#!/usr/bin/env node
var __create = Object.create;
var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key2, value) => key2 in obj ? __defProp(obj, key2, { enumerable: true, configurable: true, writable: true, value }) : obj[key2] = value;
var __spreadValues = (a2, b2) => {
  for (var prop in b2 || (b2 = {}))
    if (__hasOwnProp.call(b2, prop))
      __defNormalProp(a2, prop, b2[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b2)) {
      if (__propIsEnum.call(b2, prop))
        __defNormalProp(a2, prop, b2[prop]);
    }
  return a2;
};
var __spreadProps = (a2, b2) => __defProps(a2, __getOwnPropDescs(b2));
var __markAsModule = (target) => __defProp(target, "__esModule", { value: true });
var __objRest = (source, exclude) => {
  var target = {};
  for (var prop in source)
    if (__hasOwnProp.call(source, prop) && exclude.indexOf(prop) < 0)
      target[prop] = source[prop];
  if (source != null && __getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(source)) {
      if (exclude.indexOf(prop) < 0 && __propIsEnum.call(source, prop))
        target[prop] = source[prop];
    }
  return target;
};
var __commonJS = (cb2, mod) => function __require() {
  return mod || (0, cb2[Object.keys(cb2)[0]])((mod = { exports: {} }).exports, mod), mod.exports;
};
var __reExport = (target, module2, desc) => {
  if (module2 && typeof module2 === "object" || typeof module2 === "function") {
    for (let key2 of __getOwnPropNames(module2))
      if (!__hasOwnProp.call(target, key2) && key2 !== "default")
        __defProp(target, key2, { get: () => module2[key2], enumerable: !(desc = __getOwnPropDesc(module2, key2)) || desc.enumerable });
  }
  return target;
};
var __toModule = (module2) => {
  return __reExport(__markAsModule(__defProp(module2 != null ? __create(__getProtoOf(module2)) : {}, "default", module2 && module2.__esModule && "default" in module2 ? { get: () => module2.default, enumerable: true } : { value: module2, enumerable: true })), module2);
};

// node_modules/commander/lib/error.js
var require_error = __commonJS({
  "node_modules/commander/lib/error.js"(exports2) {
    var CommanderError = class extends Error {
      constructor(exitCode, code, message) {
        super(message);
        Error.captureStackTrace(this, this.constructor);
        this.name = this.constructor.name;
        this.code = code;
        this.exitCode = exitCode;
        this.nestedError = void 0;
      }
    };
    var InvalidArgumentError = class extends CommanderError {
      constructor(message) {
        super(1, "commander.invalidArgument", message);
        Error.captureStackTrace(this, this.constructor);
        this.name = this.constructor.name;
      }
    };
    exports2.CommanderError = CommanderError;
    exports2.InvalidArgumentError = InvalidArgumentError;
  }
});

// node_modules/commander/lib/argument.js
var require_argument = __commonJS({
  "node_modules/commander/lib/argument.js"(exports2) {
    var { InvalidArgumentError } = require_error();
    var Argument = class {
      constructor(name, description) {
        this.description = description || "";
        this.variadic = false;
        this.parseArg = void 0;
        this.defaultValue = void 0;
        this.defaultValueDescription = void 0;
        this.argChoices = void 0;
        switch (name[0]) {
          case "<":
            this.required = true;
            this._name = name.slice(1, -1);
            break;
          case "[":
            this.required = false;
            this._name = name.slice(1, -1);
            break;
          default:
            this.required = true;
            this._name = name;
            break;
        }
        if (this._name.length > 3 && this._name.slice(-3) === "...") {
          this.variadic = true;
          this._name = this._name.slice(0, -3);
        }
      }
      name() {
        return this._name;
      }
      _concatValue(value, previous) {
        if (previous === this.defaultValue || !Array.isArray(previous)) {
          return [value];
        }
        return previous.concat(value);
      }
      default(value, description) {
        this.defaultValue = value;
        this.defaultValueDescription = description;
        return this;
      }
      argParser(fn) {
        this.parseArg = fn;
        return this;
      }
      choices(values) {
        this.argChoices = values;
        this.parseArg = (arg2, previous) => {
          if (!values.includes(arg2)) {
            throw new InvalidArgumentError(`Allowed choices are ${values.join(", ")}.`);
          }
          if (this.variadic) {
            return this._concatValue(arg2, previous);
          }
          return arg2;
        };
        return this;
      }
      argRequired() {
        this.required = true;
        return this;
      }
      argOptional() {
        this.required = false;
        return this;
      }
    };
    function humanReadableArgName(arg2) {
      const nameOutput = arg2.name() + (arg2.variadic === true ? "..." : "");
      return arg2.required ? "<" + nameOutput + ">" : "[" + nameOutput + "]";
    }
    exports2.Argument = Argument;
    exports2.humanReadableArgName = humanReadableArgName;
  }
});

// node_modules/commander/lib/help.js
var require_help = __commonJS({
  "node_modules/commander/lib/help.js"(exports2) {
    var { humanReadableArgName } = require_argument();
    var Help = class {
      constructor() {
        this.helpWidth = void 0;
        this.sortSubcommands = false;
        this.sortOptions = false;
      }
      visibleCommands(cmd) {
        const visibleCommands = cmd.commands.filter((cmd2) => !cmd2._hidden);
        if (cmd._hasImplicitHelpCommand()) {
          const [, helpName, helpArgs] = cmd._helpCommandnameAndArgs.match(/([^ ]+) *(.*)/);
          const helpCommand = cmd.createCommand(helpName).helpOption(false);
          helpCommand.description(cmd._helpCommandDescription);
          if (helpArgs)
            helpCommand.arguments(helpArgs);
          visibleCommands.push(helpCommand);
        }
        if (this.sortSubcommands) {
          visibleCommands.sort((a2, b2) => {
            return a2.name().localeCompare(b2.name());
          });
        }
        return visibleCommands;
      }
      visibleOptions(cmd) {
        const visibleOptions = cmd.options.filter((option) => !option.hidden);
        const showShortHelpFlag = cmd._hasHelpOption && cmd._helpShortFlag && !cmd._findOption(cmd._helpShortFlag);
        const showLongHelpFlag = cmd._hasHelpOption && !cmd._findOption(cmd._helpLongFlag);
        if (showShortHelpFlag || showLongHelpFlag) {
          let helpOption;
          if (!showShortHelpFlag) {
            helpOption = cmd.createOption(cmd._helpLongFlag, cmd._helpDescription);
          } else if (!showLongHelpFlag) {
            helpOption = cmd.createOption(cmd._helpShortFlag, cmd._helpDescription);
          } else {
            helpOption = cmd.createOption(cmd._helpFlags, cmd._helpDescription);
          }
          visibleOptions.push(helpOption);
        }
        if (this.sortOptions) {
          const getSortKey = (option) => {
            return option.short ? option.short.replace(/^-/, "") : option.long.replace(/^--/, "");
          };
          visibleOptions.sort((a2, b2) => {
            return getSortKey(a2).localeCompare(getSortKey(b2));
          });
        }
        return visibleOptions;
      }
      visibleArguments(cmd) {
        if (cmd._argsDescription) {
          cmd._args.forEach((argument) => {
            argument.description = argument.description || cmd._argsDescription[argument.name()] || "";
          });
        }
        if (cmd._args.find((argument) => argument.description)) {
          return cmd._args;
        }
        ;
        return [];
      }
      subcommandTerm(cmd) {
        const args = cmd._args.map((arg2) => humanReadableArgName(arg2)).join(" ");
        return cmd._name + (cmd._aliases[0] ? "|" + cmd._aliases[0] : "") + (cmd.options.length ? " [options]" : "") + (args ? " " + args : "");
      }
      optionTerm(option) {
        return option.flags;
      }
      argumentTerm(argument) {
        return argument.name();
      }
      longestSubcommandTermLength(cmd, helper) {
        return helper.visibleCommands(cmd).reduce((max, command) => {
          return Math.max(max, helper.subcommandTerm(command).length);
        }, 0);
      }
      longestOptionTermLength(cmd, helper) {
        return helper.visibleOptions(cmd).reduce((max, option) => {
          return Math.max(max, helper.optionTerm(option).length);
        }, 0);
      }
      longestArgumentTermLength(cmd, helper) {
        return helper.visibleArguments(cmd).reduce((max, argument) => {
          return Math.max(max, helper.argumentTerm(argument).length);
        }, 0);
      }
      commandUsage(cmd) {
        let cmdName = cmd._name;
        if (cmd._aliases[0]) {
          cmdName = cmdName + "|" + cmd._aliases[0];
        }
        let parentCmdNames = "";
        for (let parentCmd = cmd.parent; parentCmd; parentCmd = parentCmd.parent) {
          parentCmdNames = parentCmd.name() + " " + parentCmdNames;
        }
        return parentCmdNames + cmdName + " " + cmd.usage();
      }
      commandDescription(cmd) {
        return cmd.description();
      }
      subcommandDescription(cmd) {
        return cmd.description();
      }
      optionDescription(option) {
        const extraInfo = [];
        if (option.argChoices && !option.negate) {
          extraInfo.push(`choices: ${option.argChoices.map((choice) => JSON.stringify(choice)).join(", ")}`);
        }
        if (option.defaultValue !== void 0 && !option.negate) {
          extraInfo.push(`default: ${option.defaultValueDescription || JSON.stringify(option.defaultValue)}`);
        }
        if (option.envVar !== void 0) {
          extraInfo.push(`env: ${option.envVar}`);
        }
        if (extraInfo.length > 0) {
          return `${option.description} (${extraInfo.join(", ")})`;
        }
        return option.description;
      }
      argumentDescription(argument) {
        const extraInfo = [];
        if (argument.argChoices) {
          extraInfo.push(`choices: ${argument.argChoices.map((choice) => JSON.stringify(choice)).join(", ")}`);
        }
        if (argument.defaultValue !== void 0) {
          extraInfo.push(`default: ${argument.defaultValueDescription || JSON.stringify(argument.defaultValue)}`);
        }
        if (extraInfo.length > 0) {
          const extraDescripton = `(${extraInfo.join(", ")})`;
          if (argument.description) {
            return `${argument.description} ${extraDescripton}`;
          }
          return extraDescripton;
        }
        return argument.description;
      }
      formatHelp(cmd, helper) {
        const termWidth = helper.padWidth(cmd, helper);
        const helpWidth = helper.helpWidth || 80;
        const itemIndentWidth = 2;
        const itemSeparatorWidth = 2;
        function formatItem(term, description) {
          if (description) {
            const fullText = `${term.padEnd(termWidth + itemSeparatorWidth)}${description}`;
            return helper.wrap(fullText, helpWidth - itemIndentWidth, termWidth + itemSeparatorWidth);
          }
          return term;
        }
        ;
        function formatList(textArray) {
          return textArray.join("\n").replace(/^/gm, " ".repeat(itemIndentWidth));
        }
        let output = [`Usage: ${helper.commandUsage(cmd)}`, ""];
        const commandDescription = helper.commandDescription(cmd);
        if (commandDescription.length > 0) {
          output = output.concat([commandDescription, ""]);
        }
        const argumentList = helper.visibleArguments(cmd).map((argument) => {
          return formatItem(helper.argumentTerm(argument), helper.argumentDescription(argument));
        });
        if (argumentList.length > 0) {
          output = output.concat(["Arguments:", formatList(argumentList), ""]);
        }
        const optionList = helper.visibleOptions(cmd).map((option) => {
          return formatItem(helper.optionTerm(option), helper.optionDescription(option));
        });
        if (optionList.length > 0) {
          output = output.concat(["Options:", formatList(optionList), ""]);
        }
        const commandList = helper.visibleCommands(cmd).map((cmd2) => {
          return formatItem(helper.subcommandTerm(cmd2), helper.subcommandDescription(cmd2));
        });
        if (commandList.length > 0) {
          output = output.concat(["Commands:", formatList(commandList), ""]);
        }
        return output.join("\n");
      }
      padWidth(cmd, helper) {
        return Math.max(helper.longestOptionTermLength(cmd, helper), helper.longestSubcommandTermLength(cmd, helper), helper.longestArgumentTermLength(cmd, helper));
      }
      wrap(str2, width, indent, minColumnWidth = 40) {
        if (str2.match(/[\n]\s+/))
          return str2;
        const columnWidth = width - indent;
        if (columnWidth < minColumnWidth)
          return str2;
        const leadingStr = str2.substr(0, indent);
        const columnText = str2.substr(indent);
        const indentString2 = " ".repeat(indent);
        const regex = new RegExp(".{1," + (columnWidth - 1) + "}([\\s\u200B]|$)|[^\\s\u200B]+?([\\s\u200B]|$)", "g");
        const lines = columnText.match(regex) || [];
        return leadingStr + lines.map((line, i3) => {
          if (line.slice(-1) === "\n") {
            line = line.slice(0, line.length - 1);
          }
          return (i3 > 0 ? indentString2 : "") + line.trimRight();
        }).join("\n");
      }
    };
    exports2.Help = Help;
  }
});

// node_modules/commander/lib/option.js
var require_option = __commonJS({
  "node_modules/commander/lib/option.js"(exports2) {
    var { InvalidArgumentError } = require_error();
    var Option = class {
      constructor(flags, description) {
        this.flags = flags;
        this.description = description || "";
        this.required = flags.includes("<");
        this.optional = flags.includes("[");
        this.variadic = /\w\.\.\.[>\]]$/.test(flags);
        this.mandatory = false;
        const optionFlags = splitOptionFlags(flags);
        this.short = optionFlags.shortFlag;
        this.long = optionFlags.longFlag;
        this.negate = false;
        if (this.long) {
          this.negate = this.long.startsWith("--no-");
        }
        this.defaultValue = void 0;
        this.defaultValueDescription = void 0;
        this.envVar = void 0;
        this.parseArg = void 0;
        this.hidden = false;
        this.argChoices = void 0;
      }
      default(value, description) {
        this.defaultValue = value;
        this.defaultValueDescription = description;
        return this;
      }
      env(name) {
        this.envVar = name;
        return this;
      }
      argParser(fn) {
        this.parseArg = fn;
        return this;
      }
      makeOptionMandatory(mandatory = true) {
        this.mandatory = !!mandatory;
        return this;
      }
      hideHelp(hide = true) {
        this.hidden = !!hide;
        return this;
      }
      _concatValue(value, previous) {
        if (previous === this.defaultValue || !Array.isArray(previous)) {
          return [value];
        }
        return previous.concat(value);
      }
      choices(values) {
        this.argChoices = values;
        this.parseArg = (arg2, previous) => {
          if (!values.includes(arg2)) {
            throw new InvalidArgumentError(`Allowed choices are ${values.join(", ")}.`);
          }
          if (this.variadic) {
            return this._concatValue(arg2, previous);
          }
          return arg2;
        };
        return this;
      }
      name() {
        if (this.long) {
          return this.long.replace(/^--/, "");
        }
        return this.short.replace(/^-/, "");
      }
      attributeName() {
        return camelcase(this.name().replace(/^no-/, ""));
      }
      is(arg2) {
        return this.short === arg2 || this.long === arg2;
      }
    };
    function camelcase(str2) {
      return str2.split("-").reduce((str3, word) => {
        return str3 + word[0].toUpperCase() + word.slice(1);
      });
    }
    function splitOptionFlags(flags) {
      let shortFlag;
      let longFlag;
      const flagParts = flags.split(/[ |,]+/);
      if (flagParts.length > 1 && !/^[[<]/.test(flagParts[1]))
        shortFlag = flagParts.shift();
      longFlag = flagParts.shift();
      if (!shortFlag && /^-[^-]$/.test(longFlag)) {
        shortFlag = longFlag;
        longFlag = void 0;
      }
      return { shortFlag, longFlag };
    }
    exports2.Option = Option;
    exports2.splitOptionFlags = splitOptionFlags;
  }
});

// node_modules/commander/lib/suggestSimilar.js
var require_suggestSimilar = __commonJS({
  "node_modules/commander/lib/suggestSimilar.js"(exports2) {
    var maxDistance = 3;
    function editDistance(a2, b2) {
      if (Math.abs(a2.length - b2.length) > maxDistance)
        return Math.max(a2.length, b2.length);
      const d = [];
      for (let i3 = 0; i3 <= a2.length; i3++) {
        d[i3] = [i3];
      }
      for (let j = 0; j <= b2.length; j++) {
        d[0][j] = j;
      }
      for (let j = 1; j <= b2.length; j++) {
        for (let i3 = 1; i3 <= a2.length; i3++) {
          let cost = 1;
          if (a2[i3 - 1] === b2[j - 1]) {
            cost = 0;
          } else {
            cost = 1;
          }
          d[i3][j] = Math.min(d[i3 - 1][j] + 1, d[i3][j - 1] + 1, d[i3 - 1][j - 1] + cost);
          if (i3 > 1 && j > 1 && a2[i3 - 1] === b2[j - 2] && a2[i3 - 2] === b2[j - 1]) {
            d[i3][j] = Math.min(d[i3][j], d[i3 - 2][j - 2] + 1);
          }
        }
      }
      return d[a2.length][b2.length];
    }
    function suggestSimilar(word, candidates) {
      if (!candidates || candidates.length === 0)
        return "";
      candidates = Array.from(new Set(candidates));
      const searchingOptions = word.startsWith("--");
      if (searchingOptions) {
        word = word.slice(2);
        candidates = candidates.map((candidate) => candidate.slice(2));
      }
      let similar = [];
      let bestDistance = maxDistance;
      const minSimilarity = 0.4;
      candidates.forEach((candidate) => {
        if (candidate.length <= 1)
          return;
        const distance = editDistance(word, candidate);
        const length = Math.max(word.length, candidate.length);
        const similarity = (length - distance) / length;
        if (similarity > minSimilarity) {
          if (distance < bestDistance) {
            bestDistance = distance;
            similar = [candidate];
          } else if (distance === bestDistance) {
            similar.push(candidate);
          }
        }
      });
      similar.sort((a2, b2) => a2.localeCompare(b2));
      if (searchingOptions) {
        similar = similar.map((candidate) => `--${candidate}`);
      }
      if (similar.length > 1) {
        return `
(Did you mean one of ${similar.join(", ")}?)`;
      }
      if (similar.length === 1) {
        return `
(Did you mean ${similar[0]}?)`;
      }
      return "";
    }
    exports2.suggestSimilar = suggestSimilar;
  }
});

// node_modules/commander/lib/command.js
var require_command = __commonJS({
  "node_modules/commander/lib/command.js"(exports2) {
    var EventEmitter = require("events").EventEmitter;
    var childProcess = require("child_process");
    var path2 = require("path");
    var fs5 = require("fs");
    var { Argument, humanReadableArgName } = require_argument();
    var { CommanderError } = require_error();
    var { Help } = require_help();
    var { Option, splitOptionFlags } = require_option();
    var { suggestSimilar } = require_suggestSimilar();
    var Command2 = class extends EventEmitter {
      constructor(name) {
        super();
        this.commands = [];
        this.options = [];
        this.parent = null;
        this._allowUnknownOption = false;
        this._allowExcessArguments = true;
        this._args = [];
        this.args = [];
        this.rawArgs = [];
        this.processedArgs = [];
        this._scriptPath = null;
        this._name = name || "";
        this._optionValues = {};
        this._optionValueSources = {};
        this._storeOptionsAsProperties = false;
        this._actionHandler = null;
        this._executableHandler = false;
        this._executableFile = null;
        this._defaultCommandName = null;
        this._exitCallback = null;
        this._aliases = [];
        this._combineFlagAndOptionalValue = true;
        this._description = "";
        this._argsDescription = void 0;
        this._enablePositionalOptions = false;
        this._passThroughOptions = false;
        this._lifeCycleHooks = {};
        this._showHelpAfterError = false;
        this._showSuggestionAfterError = false;
        this._outputConfiguration = {
          writeOut: (str2) => process.stdout.write(str2),
          writeErr: (str2) => process.stderr.write(str2),
          getOutHelpWidth: () => process.stdout.isTTY ? process.stdout.columns : void 0,
          getErrHelpWidth: () => process.stderr.isTTY ? process.stderr.columns : void 0,
          outputError: (str2, write) => write(str2)
        };
        this._hidden = false;
        this._hasHelpOption = true;
        this._helpFlags = "-h, --help";
        this._helpDescription = "display help for command";
        this._helpShortFlag = "-h";
        this._helpLongFlag = "--help";
        this._addImplicitHelpCommand = void 0;
        this._helpCommandName = "help";
        this._helpCommandnameAndArgs = "help [command]";
        this._helpCommandDescription = "display help for command";
        this._helpConfiguration = {};
      }
      copyInheritedSettings(sourceCommand) {
        this._outputConfiguration = sourceCommand._outputConfiguration;
        this._hasHelpOption = sourceCommand._hasHelpOption;
        this._helpFlags = sourceCommand._helpFlags;
        this._helpDescription = sourceCommand._helpDescription;
        this._helpShortFlag = sourceCommand._helpShortFlag;
        this._helpLongFlag = sourceCommand._helpLongFlag;
        this._helpCommandName = sourceCommand._helpCommandName;
        this._helpCommandnameAndArgs = sourceCommand._helpCommandnameAndArgs;
        this._helpCommandDescription = sourceCommand._helpCommandDescription;
        this._helpConfiguration = sourceCommand._helpConfiguration;
        this._exitCallback = sourceCommand._exitCallback;
        this._storeOptionsAsProperties = sourceCommand._storeOptionsAsProperties;
        this._combineFlagAndOptionalValue = sourceCommand._combineFlagAndOptionalValue;
        this._allowExcessArguments = sourceCommand._allowExcessArguments;
        this._enablePositionalOptions = sourceCommand._enablePositionalOptions;
        this._showHelpAfterError = sourceCommand._showHelpAfterError;
        this._showSuggestionAfterError = sourceCommand._showSuggestionAfterError;
        return this;
      }
      command(nameAndArgs, actionOptsOrExecDesc, execOpts) {
        let desc = actionOptsOrExecDesc;
        let opts = execOpts;
        if (typeof desc === "object" && desc !== null) {
          opts = desc;
          desc = null;
        }
        opts = opts || {};
        const [, name, args] = nameAndArgs.match(/([^ ]+) *(.*)/);
        const cmd = this.createCommand(name);
        if (desc) {
          cmd.description(desc);
          cmd._executableHandler = true;
        }
        if (opts.isDefault)
          this._defaultCommandName = cmd._name;
        cmd._hidden = !!(opts.noHelp || opts.hidden);
        cmd._executableFile = opts.executableFile || null;
        if (args)
          cmd.arguments(args);
        this.commands.push(cmd);
        cmd.parent = this;
        cmd.copyInheritedSettings(this);
        if (desc)
          return this;
        return cmd;
      }
      createCommand(name) {
        return new Command2(name);
      }
      createHelp() {
        return Object.assign(new Help(), this.configureHelp());
      }
      configureHelp(configuration) {
        if (configuration === void 0)
          return this._helpConfiguration;
        this._helpConfiguration = configuration;
        return this;
      }
      configureOutput(configuration) {
        if (configuration === void 0)
          return this._outputConfiguration;
        Object.assign(this._outputConfiguration, configuration);
        return this;
      }
      showHelpAfterError(displayHelp = true) {
        if (typeof displayHelp !== "string")
          displayHelp = !!displayHelp;
        this._showHelpAfterError = displayHelp;
        return this;
      }
      showSuggestionAfterError(displaySuggestion = true) {
        this._showSuggestionAfterError = !!displaySuggestion;
        return this;
      }
      addCommand(cmd, opts) {
        if (!cmd._name)
          throw new Error("Command passed to .addCommand() must have a name");
        function checkExplicitNames(commandArray) {
          commandArray.forEach((cmd2) => {
            if (cmd2._executableHandler && !cmd2._executableFile) {
              throw new Error(`Must specify executableFile for deeply nested executable: ${cmd2.name()}`);
            }
            checkExplicitNames(cmd2.commands);
          });
        }
        checkExplicitNames(cmd.commands);
        opts = opts || {};
        if (opts.isDefault)
          this._defaultCommandName = cmd._name;
        if (opts.noHelp || opts.hidden)
          cmd._hidden = true;
        this.commands.push(cmd);
        cmd.parent = this;
        return this;
      }
      createArgument(name, description) {
        return new Argument(name, description);
      }
      argument(name, description, fn, defaultValue) {
        const argument = this.createArgument(name, description);
        if (typeof fn === "function") {
          argument.default(defaultValue).argParser(fn);
        } else {
          argument.default(fn);
        }
        this.addArgument(argument);
        return this;
      }
      arguments(names) {
        names.split(/ +/).forEach((detail) => {
          this.argument(detail);
        });
        return this;
      }
      addArgument(argument) {
        const previousArgument = this._args.slice(-1)[0];
        if (previousArgument && previousArgument.variadic) {
          throw new Error(`only the last argument can be variadic '${previousArgument.name()}'`);
        }
        if (argument.required && argument.defaultValue !== void 0 && argument.parseArg === void 0) {
          throw new Error(`a default value for a required argument is never used: '${argument.name()}'`);
        }
        this._args.push(argument);
        return this;
      }
      addHelpCommand(enableOrNameAndArgs, description) {
        if (enableOrNameAndArgs === false) {
          this._addImplicitHelpCommand = false;
        } else {
          this._addImplicitHelpCommand = true;
          if (typeof enableOrNameAndArgs === "string") {
            this._helpCommandName = enableOrNameAndArgs.split(" ")[0];
            this._helpCommandnameAndArgs = enableOrNameAndArgs;
          }
          this._helpCommandDescription = description || this._helpCommandDescription;
        }
        return this;
      }
      _hasImplicitHelpCommand() {
        if (this._addImplicitHelpCommand === void 0) {
          return this.commands.length && !this._actionHandler && !this._findCommand("help");
        }
        return this._addImplicitHelpCommand;
      }
      hook(event2, listener) {
        const allowedValues = ["preAction", "postAction"];
        if (!allowedValues.includes(event2)) {
          throw new Error(`Unexpected value for event passed to hook : '${event2}'.
Expecting one of '${allowedValues.join("', '")}'`);
        }
        if (this._lifeCycleHooks[event2]) {
          this._lifeCycleHooks[event2].push(listener);
        } else {
          this._lifeCycleHooks[event2] = [listener];
        }
        return this;
      }
      exitOverride(fn) {
        if (fn) {
          this._exitCallback = fn;
        } else {
          this._exitCallback = (err2) => {
            if (err2.code !== "commander.executeSubCommandAsync") {
              throw err2;
            } else {
            }
          };
        }
        return this;
      }
      _exit(exitCode, code, message) {
        if (this._exitCallback) {
          this._exitCallback(new CommanderError(exitCode, code, message));
        }
        process.exit(exitCode);
      }
      action(fn) {
        const listener = (args) => {
          const expectedArgsCount = this._args.length;
          const actionArgs = args.slice(0, expectedArgsCount);
          if (this._storeOptionsAsProperties) {
            actionArgs[expectedArgsCount] = this;
          } else {
            actionArgs[expectedArgsCount] = this.opts();
          }
          actionArgs.push(this);
          return fn.apply(this, actionArgs);
        };
        this._actionHandler = listener;
        return this;
      }
      createOption(flags, description) {
        return new Option(flags, description);
      }
      addOption(option) {
        const oname = option.name();
        const name = option.attributeName();
        let defaultValue = option.defaultValue;
        if (option.negate || option.optional || option.required || typeof defaultValue === "boolean") {
          if (option.negate) {
            const positiveLongFlag = option.long.replace(/^--no-/, "--");
            defaultValue = this._findOption(positiveLongFlag) ? this.getOptionValue(name) : true;
          }
          if (defaultValue !== void 0) {
            this._setOptionValueWithSource(name, defaultValue, "default");
          }
        }
        this.options.push(option);
        const handleOptionValue = (val, invalidValueMessage, valueSource) => {
          const oldValue = this.getOptionValue(name);
          if (val !== null && option.parseArg) {
            try {
              val = option.parseArg(val, oldValue === void 0 ? defaultValue : oldValue);
            } catch (err2) {
              if (err2.code === "commander.invalidArgument") {
                const message = `${invalidValueMessage} ${err2.message}`;
                this._displayError(err2.exitCode, err2.code, message);
              }
              throw err2;
            }
          } else if (val !== null && option.variadic) {
            val = option._concatValue(val, oldValue);
          }
          if (typeof oldValue === "boolean" || typeof oldValue === "undefined") {
            if (val == null) {
              this._setOptionValueWithSource(name, option.negate ? false : defaultValue || true, valueSource);
            } else {
              this._setOptionValueWithSource(name, val, valueSource);
            }
          } else if (val !== null) {
            this._setOptionValueWithSource(name, option.negate ? false : val, valueSource);
          }
        };
        this.on("option:" + oname, (val) => {
          const invalidValueMessage = `error: option '${option.flags}' argument '${val}' is invalid.`;
          handleOptionValue(val, invalidValueMessage, "cli");
        });
        if (option.envVar) {
          this.on("optionEnv:" + oname, (val) => {
            const invalidValueMessage = `error: option '${option.flags}' value '${val}' from env '${option.envVar}' is invalid.`;
            handleOptionValue(val, invalidValueMessage, "env");
          });
        }
        return this;
      }
      _optionEx(config, flags, description, fn, defaultValue) {
        const option = this.createOption(flags, description);
        option.makeOptionMandatory(!!config.mandatory);
        if (typeof fn === "function") {
          option.default(defaultValue).argParser(fn);
        } else if (fn instanceof RegExp) {
          const regex = fn;
          fn = (val, def) => {
            const m = regex.exec(val);
            return m ? m[0] : def;
          };
          option.default(defaultValue).argParser(fn);
        } else {
          option.default(fn);
        }
        return this.addOption(option);
      }
      option(flags, description, fn, defaultValue) {
        return this._optionEx({}, flags, description, fn, defaultValue);
      }
      requiredOption(flags, description, fn, defaultValue) {
        return this._optionEx({ mandatory: true }, flags, description, fn, defaultValue);
      }
      combineFlagAndOptionalValue(combine = true) {
        this._combineFlagAndOptionalValue = !!combine;
        return this;
      }
      allowUnknownOption(allowUnknown = true) {
        this._allowUnknownOption = !!allowUnknown;
        return this;
      }
      allowExcessArguments(allowExcess = true) {
        this._allowExcessArguments = !!allowExcess;
        return this;
      }
      enablePositionalOptions(positional = true) {
        this._enablePositionalOptions = !!positional;
        return this;
      }
      passThroughOptions(passThrough = true) {
        this._passThroughOptions = !!passThrough;
        if (!!this.parent && passThrough && !this.parent._enablePositionalOptions) {
          throw new Error("passThroughOptions can not be used without turning on enablePositionalOptions for parent command(s)");
        }
        return this;
      }
      storeOptionsAsProperties(storeAsProperties = true) {
        this._storeOptionsAsProperties = !!storeAsProperties;
        if (this.options.length) {
          throw new Error("call .storeOptionsAsProperties() before adding options");
        }
        return this;
      }
      getOptionValue(key2) {
        if (this._storeOptionsAsProperties) {
          return this[key2];
        }
        return this._optionValues[key2];
      }
      setOptionValue(key2, value) {
        if (this._storeOptionsAsProperties) {
          this[key2] = value;
        } else {
          this._optionValues[key2] = value;
        }
        return this;
      }
      _setOptionValueWithSource(key2, value, source) {
        this.setOptionValue(key2, value);
        this._optionValueSources[key2] = source;
      }
      _prepareUserArgs(argv, parseOptions) {
        if (argv !== void 0 && !Array.isArray(argv)) {
          throw new Error("first parameter to parse must be array or undefined");
        }
        parseOptions = parseOptions || {};
        if (argv === void 0) {
          argv = process.argv;
          if (process.versions && process.versions.electron) {
            parseOptions.from = "electron";
          }
        }
        this.rawArgs = argv.slice();
        let userArgs;
        switch (parseOptions.from) {
          case void 0:
          case "node":
            this._scriptPath = argv[1];
            userArgs = argv.slice(2);
            break;
          case "electron":
            if (process.defaultApp) {
              this._scriptPath = argv[1];
              userArgs = argv.slice(2);
            } else {
              userArgs = argv.slice(1);
            }
            break;
          case "user":
            userArgs = argv.slice(0);
            break;
          default:
            throw new Error(`unexpected parse option { from: '${parseOptions.from}' }`);
        }
        if (!this._scriptPath && require.main) {
          this._scriptPath = require.main.filename;
        }
        this._name = this._name || this._scriptPath && path2.basename(this._scriptPath, path2.extname(this._scriptPath));
        return userArgs;
      }
      parse(argv, parseOptions) {
        const userArgs = this._prepareUserArgs(argv, parseOptions);
        this._parseCommand([], userArgs);
        return this;
      }
      async parseAsync(argv, parseOptions) {
        const userArgs = this._prepareUserArgs(argv, parseOptions);
        await this._parseCommand([], userArgs);
        return this;
      }
      _executeSubCommand(subcommand, args) {
        args = args.slice();
        let launchWithNode = false;
        const sourceExt = [".js", ".ts", ".tsx", ".mjs", ".cjs"];
        this._checkForMissingMandatoryOptions();
        let scriptPath = this._scriptPath;
        if (!scriptPath && require.main) {
          scriptPath = require.main.filename;
        }
        let baseDir;
        try {
          const resolvedLink = fs5.realpathSync(scriptPath);
          baseDir = path2.dirname(resolvedLink);
        } catch (e2) {
          baseDir = ".";
        }
        let bin = path2.basename(scriptPath, path2.extname(scriptPath)) + "-" + subcommand._name;
        if (subcommand._executableFile) {
          bin = subcommand._executableFile;
        }
        const localBin = path2.join(baseDir, bin);
        if (fs5.existsSync(localBin)) {
          bin = localBin;
        } else {
          sourceExt.forEach((ext) => {
            if (fs5.existsSync(`${localBin}${ext}`)) {
              bin = `${localBin}${ext}`;
            }
          });
        }
        launchWithNode = sourceExt.includes(path2.extname(bin));
        let proc;
        if (process.platform !== "win32") {
          if (launchWithNode) {
            args.unshift(bin);
            args = incrementNodeInspectorPort(process.execArgv).concat(args);
            proc = childProcess.spawn(process.argv[0], args, { stdio: "inherit" });
          } else {
            proc = childProcess.spawn(bin, args, { stdio: "inherit" });
          }
        } else {
          args.unshift(bin);
          args = incrementNodeInspectorPort(process.execArgv).concat(args);
          proc = childProcess.spawn(process.execPath, args, { stdio: "inherit" });
        }
        const signals = ["SIGUSR1", "SIGUSR2", "SIGTERM", "SIGINT", "SIGHUP"];
        signals.forEach((signal) => {
          process.on(signal, () => {
            if (proc.killed === false && proc.exitCode === null) {
              proc.kill(signal);
            }
          });
        });
        const exitCallback = this._exitCallback;
        if (!exitCallback) {
          proc.on("close", process.exit.bind(process));
        } else {
          proc.on("close", () => {
            exitCallback(new CommanderError(process.exitCode || 0, "commander.executeSubCommandAsync", "(close)"));
          });
        }
        proc.on("error", (err2) => {
          if (err2.code === "ENOENT") {
            const executableMissing = `'${bin}' does not exist
 - if '${subcommand._name}' is not meant to be an executable command, remove description parameter from '.command()' and use '.description()' instead
 - if the default executable name is not suitable, use the executableFile option to supply a custom name`;
            throw new Error(executableMissing);
          } else if (err2.code === "EACCES") {
            throw new Error(`'${bin}' not executable`);
          }
          if (!exitCallback) {
            process.exit(1);
          } else {
            const wrappedError = new CommanderError(1, "commander.executeSubCommandAsync", "(error)");
            wrappedError.nestedError = err2;
            exitCallback(wrappedError);
          }
        });
        this.runningCommand = proc;
      }
      _dispatchSubcommand(commandName, operands, unknown) {
        const subCommand = this._findCommand(commandName);
        if (!subCommand)
          this.help({ error: true });
        if (subCommand._executableHandler) {
          this._executeSubCommand(subCommand, operands.concat(unknown));
        } else {
          return subCommand._parseCommand(operands, unknown);
        }
      }
      _checkNumberOfArguments() {
        this._args.forEach((arg2, i3) => {
          if (arg2.required && this.args[i3] == null) {
            this.missingArgument(arg2.name());
          }
        });
        if (this._args.length > 0 && this._args[this._args.length - 1].variadic) {
          return;
        }
        if (this.args.length > this._args.length) {
          this._excessArguments(this.args);
        }
      }
      _processArguments() {
        const myParseArg = (argument, value, previous) => {
          let parsedValue = value;
          if (value !== null && argument.parseArg) {
            try {
              parsedValue = argument.parseArg(value, previous);
            } catch (err2) {
              if (err2.code === "commander.invalidArgument") {
                const message = `error: command-argument value '${value}' is invalid for argument '${argument.name()}'. ${err2.message}`;
                this._displayError(err2.exitCode, err2.code, message);
              }
              throw err2;
            }
          }
          return parsedValue;
        };
        this._checkNumberOfArguments();
        const processedArgs = [];
        this._args.forEach((declaredArg, index) => {
          let value = declaredArg.defaultValue;
          if (declaredArg.variadic) {
            if (index < this.args.length) {
              value = this.args.slice(index);
              if (declaredArg.parseArg) {
                value = value.reduce((processed, v) => {
                  return myParseArg(declaredArg, v, processed);
                }, declaredArg.defaultValue);
              }
            } else if (value === void 0) {
              value = [];
            }
          } else if (index < this.args.length) {
            value = this.args[index];
            if (declaredArg.parseArg) {
              value = myParseArg(declaredArg, value, declaredArg.defaultValue);
            }
          }
          processedArgs[index] = value;
        });
        this.processedArgs = processedArgs;
      }
      _chainOrCall(promise, fn) {
        if (promise && promise.then && typeof promise.then === "function") {
          return promise.then(() => fn());
        }
        return fn();
      }
      _chainOrCallHooks(promise, event2) {
        let result2 = promise;
        const hooks = [];
        getCommandAndParents(this).reverse().filter((cmd) => cmd._lifeCycleHooks[event2] !== void 0).forEach((hookedCommand) => {
          hookedCommand._lifeCycleHooks[event2].forEach((callback) => {
            hooks.push({ hookedCommand, callback });
          });
        });
        if (event2 === "postAction") {
          hooks.reverse();
        }
        hooks.forEach((hookDetail) => {
          result2 = this._chainOrCall(result2, () => {
            return hookDetail.callback(hookDetail.hookedCommand, this);
          });
        });
        return result2;
      }
      _parseCommand(operands, unknown) {
        const parsed = this.parseOptions(unknown);
        this._parseOptionsEnv();
        operands = operands.concat(parsed.operands);
        unknown = parsed.unknown;
        this.args = operands.concat(unknown);
        if (operands && this._findCommand(operands[0])) {
          return this._dispatchSubcommand(operands[0], operands.slice(1), unknown);
        }
        if (this._hasImplicitHelpCommand() && operands[0] === this._helpCommandName) {
          if (operands.length === 1) {
            this.help();
          }
          return this._dispatchSubcommand(operands[1], [], [this._helpLongFlag]);
        }
        if (this._defaultCommandName) {
          outputHelpIfRequested(this, unknown);
          return this._dispatchSubcommand(this._defaultCommandName, operands, unknown);
        }
        if (this.commands.length && this.args.length === 0 && !this._actionHandler && !this._defaultCommandName) {
          this.help({ error: true });
        }
        outputHelpIfRequested(this, parsed.unknown);
        this._checkForMissingMandatoryOptions();
        const checkForUnknownOptions = () => {
          if (parsed.unknown.length > 0) {
            this.unknownOption(parsed.unknown[0]);
          }
        };
        const commandEvent = `command:${this.name()}`;
        if (this._actionHandler) {
          checkForUnknownOptions();
          this._processArguments();
          let actionResult;
          actionResult = this._chainOrCallHooks(actionResult, "preAction");
          actionResult = this._chainOrCall(actionResult, () => this._actionHandler(this.processedArgs));
          if (this.parent)
            this.parent.emit(commandEvent, operands, unknown);
          actionResult = this._chainOrCallHooks(actionResult, "postAction");
          return actionResult;
        }
        if (this.parent && this.parent.listenerCount(commandEvent)) {
          checkForUnknownOptions();
          this._processArguments();
          this.parent.emit(commandEvent, operands, unknown);
        } else if (operands.length) {
          if (this._findCommand("*")) {
            return this._dispatchSubcommand("*", operands, unknown);
          }
          if (this.listenerCount("command:*")) {
            this.emit("command:*", operands, unknown);
          } else if (this.commands.length) {
            this.unknownCommand();
          } else {
            checkForUnknownOptions();
            this._processArguments();
          }
        } else if (this.commands.length) {
          checkForUnknownOptions();
          this.help({ error: true });
        } else {
          checkForUnknownOptions();
          this._processArguments();
        }
      }
      _findCommand(name) {
        if (!name)
          return void 0;
        return this.commands.find((cmd) => cmd._name === name || cmd._aliases.includes(name));
      }
      _findOption(arg2) {
        return this.options.find((option) => option.is(arg2));
      }
      _checkForMissingMandatoryOptions() {
        for (let cmd = this; cmd; cmd = cmd.parent) {
          cmd.options.forEach((anOption) => {
            if (anOption.mandatory && cmd.getOptionValue(anOption.attributeName()) === void 0) {
              cmd.missingMandatoryOptionValue(anOption);
            }
          });
        }
      }
      parseOptions(argv) {
        const operands = [];
        const unknown = [];
        let dest = operands;
        const args = argv.slice();
        function maybeOption(arg2) {
          return arg2.length > 1 && arg2[0] === "-";
        }
        let activeVariadicOption = null;
        while (args.length) {
          const arg2 = args.shift();
          if (arg2 === "--") {
            if (dest === unknown)
              dest.push(arg2);
            dest.push(...args);
            break;
          }
          if (activeVariadicOption && !maybeOption(arg2)) {
            this.emit(`option:${activeVariadicOption.name()}`, arg2);
            continue;
          }
          activeVariadicOption = null;
          if (maybeOption(arg2)) {
            const option = this._findOption(arg2);
            if (option) {
              if (option.required) {
                const value = args.shift();
                if (value === void 0)
                  this.optionMissingArgument(option);
                this.emit(`option:${option.name()}`, value);
              } else if (option.optional) {
                let value = null;
                if (args.length > 0 && !maybeOption(args[0])) {
                  value = args.shift();
                }
                this.emit(`option:${option.name()}`, value);
              } else {
                this.emit(`option:${option.name()}`);
              }
              activeVariadicOption = option.variadic ? option : null;
              continue;
            }
          }
          if (arg2.length > 2 && arg2[0] === "-" && arg2[1] !== "-") {
            const option = this._findOption(`-${arg2[1]}`);
            if (option) {
              if (option.required || option.optional && this._combineFlagAndOptionalValue) {
                this.emit(`option:${option.name()}`, arg2.slice(2));
              } else {
                this.emit(`option:${option.name()}`);
                args.unshift(`-${arg2.slice(2)}`);
              }
              continue;
            }
          }
          if (/^--[^=]+=/.test(arg2)) {
            const index = arg2.indexOf("=");
            const option = this._findOption(arg2.slice(0, index));
            if (option && (option.required || option.optional)) {
              this.emit(`option:${option.name()}`, arg2.slice(index + 1));
              continue;
            }
          }
          if (maybeOption(arg2)) {
            dest = unknown;
          }
          if ((this._enablePositionalOptions || this._passThroughOptions) && operands.length === 0 && unknown.length === 0) {
            if (this._findCommand(arg2)) {
              operands.push(arg2);
              if (args.length > 0)
                unknown.push(...args);
              break;
            } else if (arg2 === this._helpCommandName && this._hasImplicitHelpCommand()) {
              operands.push(arg2);
              if (args.length > 0)
                operands.push(...args);
              break;
            } else if (this._defaultCommandName) {
              unknown.push(arg2);
              if (args.length > 0)
                unknown.push(...args);
              break;
            }
          }
          if (this._passThroughOptions) {
            dest.push(arg2);
            if (args.length > 0)
              dest.push(...args);
            break;
          }
          dest.push(arg2);
        }
        return { operands, unknown };
      }
      opts() {
        if (this._storeOptionsAsProperties) {
          const result2 = {};
          const len = this.options.length;
          for (let i3 = 0; i3 < len; i3++) {
            const key2 = this.options[i3].attributeName();
            result2[key2] = key2 === this._versionOptionName ? this._version : this[key2];
          }
          return result2;
        }
        return this._optionValues;
      }
      _displayError(exitCode, code, message) {
        this._outputConfiguration.outputError(`${message}
`, this._outputConfiguration.writeErr);
        if (typeof this._showHelpAfterError === "string") {
          this._outputConfiguration.writeErr(`${this._showHelpAfterError}
`);
        } else if (this._showHelpAfterError) {
          this._outputConfiguration.writeErr("\n");
          this.outputHelp({ error: true });
        }
        this._exit(exitCode, code, message);
      }
      _parseOptionsEnv() {
        this.options.forEach((option) => {
          if (option.envVar && option.envVar in process.env) {
            const optionKey = option.attributeName();
            if (this.getOptionValue(optionKey) === void 0 || this._optionValueSources[optionKey] === "default") {
              if (option.required || option.optional) {
                this.emit(`optionEnv:${option.name()}`, process.env[option.envVar]);
              } else {
                this.emit(`optionEnv:${option.name()}`);
              }
            }
          }
        });
      }
      missingArgument(name) {
        const message = `error: missing required argument '${name}'`;
        this._displayError(1, "commander.missingArgument", message);
      }
      optionMissingArgument(option) {
        const message = `error: option '${option.flags}' argument missing`;
        this._displayError(1, "commander.optionMissingArgument", message);
      }
      missingMandatoryOptionValue(option) {
        const message = `error: required option '${option.flags}' not specified`;
        this._displayError(1, "commander.missingMandatoryOptionValue", message);
      }
      unknownOption(flag) {
        if (this._allowUnknownOption)
          return;
        let suggestion = "";
        if (flag.startsWith("--") && this._showSuggestionAfterError) {
          let candidateFlags = [];
          let command = this;
          do {
            const moreFlags = command.createHelp().visibleOptions(command).filter((option) => option.long).map((option) => option.long);
            candidateFlags = candidateFlags.concat(moreFlags);
            command = command.parent;
          } while (command && !command._enablePositionalOptions);
          suggestion = suggestSimilar(flag, candidateFlags);
        }
        const message = `error: unknown option '${flag}'${suggestion}`;
        this._displayError(1, "commander.unknownOption", message);
      }
      _excessArguments(receivedArgs) {
        if (this._allowExcessArguments)
          return;
        const expected = this._args.length;
        const s2 = expected === 1 ? "" : "s";
        const forSubcommand = this.parent ? ` for '${this.name()}'` : "";
        const message = `error: too many arguments${forSubcommand}. Expected ${expected} argument${s2} but got ${receivedArgs.length}.`;
        this._displayError(1, "commander.excessArguments", message);
      }
      unknownCommand() {
        const unknownName = this.args[0];
        let suggestion = "";
        if (this._showSuggestionAfterError) {
          const candidateNames = [];
          this.createHelp().visibleCommands(this).forEach((command) => {
            candidateNames.push(command.name());
            if (command.alias())
              candidateNames.push(command.alias());
          });
          suggestion = suggestSimilar(unknownName, candidateNames);
        }
        const message = `error: unknown command '${unknownName}'${suggestion}`;
        this._displayError(1, "commander.unknownCommand", message);
      }
      version(str2, flags, description) {
        if (str2 === void 0)
          return this._version;
        this._version = str2;
        flags = flags || "-V, --version";
        description = description || "output the version number";
        const versionOption = this.createOption(flags, description);
        this._versionOptionName = versionOption.attributeName();
        this.options.push(versionOption);
        this.on("option:" + versionOption.name(), () => {
          this._outputConfiguration.writeOut(`${str2}
`);
          this._exit(0, "commander.version", str2);
        });
        return this;
      }
      description(str2, argsDescription) {
        if (str2 === void 0 && argsDescription === void 0)
          return this._description;
        this._description = str2;
        if (argsDescription) {
          this._argsDescription = argsDescription;
        }
        return this;
      }
      alias(alias) {
        if (alias === void 0)
          return this._aliases[0];
        let command = this;
        if (this.commands.length !== 0 && this.commands[this.commands.length - 1]._executableHandler) {
          command = this.commands[this.commands.length - 1];
        }
        if (alias === command._name)
          throw new Error("Command alias can't be the same as its name");
        command._aliases.push(alias);
        return this;
      }
      aliases(aliases) {
        if (aliases === void 0)
          return this._aliases;
        aliases.forEach((alias) => this.alias(alias));
        return this;
      }
      usage(str2) {
        if (str2 === void 0) {
          if (this._usage)
            return this._usage;
          const args = this._args.map((arg2) => {
            return humanReadableArgName(arg2);
          });
          return [].concat(this.options.length || this._hasHelpOption ? "[options]" : [], this.commands.length ? "[command]" : [], this._args.length ? args : []).join(" ");
        }
        this._usage = str2;
        return this;
      }
      name(str2) {
        if (str2 === void 0)
          return this._name;
        this._name = str2;
        return this;
      }
      helpInformation(contextOptions) {
        const helper = this.createHelp();
        if (helper.helpWidth === void 0) {
          helper.helpWidth = contextOptions && contextOptions.error ? this._outputConfiguration.getErrHelpWidth() : this._outputConfiguration.getOutHelpWidth();
        }
        return helper.formatHelp(this, helper);
      }
      _getHelpContext(contextOptions) {
        contextOptions = contextOptions || {};
        const context = { error: !!contextOptions.error };
        let write;
        if (context.error) {
          write = (arg2) => this._outputConfiguration.writeErr(arg2);
        } else {
          write = (arg2) => this._outputConfiguration.writeOut(arg2);
        }
        context.write = contextOptions.write || write;
        context.command = this;
        return context;
      }
      outputHelp(contextOptions) {
        let deprecatedCallback;
        if (typeof contextOptions === "function") {
          deprecatedCallback = contextOptions;
          contextOptions = void 0;
        }
        const context = this._getHelpContext(contextOptions);
        getCommandAndParents(this).reverse().forEach((command) => command.emit("beforeAllHelp", context));
        this.emit("beforeHelp", context);
        let helpInformation = this.helpInformation(context);
        if (deprecatedCallback) {
          helpInformation = deprecatedCallback(helpInformation);
          if (typeof helpInformation !== "string" && !Buffer.isBuffer(helpInformation)) {
            throw new Error("outputHelp callback must return a string or a Buffer");
          }
        }
        context.write(helpInformation);
        this.emit(this._helpLongFlag);
        this.emit("afterHelp", context);
        getCommandAndParents(this).forEach((command) => command.emit("afterAllHelp", context));
      }
      helpOption(flags, description) {
        if (typeof flags === "boolean") {
          this._hasHelpOption = flags;
          return this;
        }
        this._helpFlags = flags || this._helpFlags;
        this._helpDescription = description || this._helpDescription;
        const helpFlags = splitOptionFlags(this._helpFlags);
        this._helpShortFlag = helpFlags.shortFlag;
        this._helpLongFlag = helpFlags.longFlag;
        return this;
      }
      help(contextOptions) {
        this.outputHelp(contextOptions);
        let exitCode = process.exitCode || 0;
        if (exitCode === 0 && contextOptions && typeof contextOptions !== "function" && contextOptions.error) {
          exitCode = 1;
        }
        this._exit(exitCode, "commander.help", "(outputHelp)");
      }
      addHelpText(position, text) {
        const allowedValues = ["beforeAll", "before", "after", "afterAll"];
        if (!allowedValues.includes(position)) {
          throw new Error(`Unexpected value for position to addHelpText.
Expecting one of '${allowedValues.join("', '")}'`);
        }
        const helpEvent = `${position}Help`;
        this.on(helpEvent, (context) => {
          let helpStr;
          if (typeof text === "function") {
            helpStr = text({ error: context.error, command: context.command });
          } else {
            helpStr = text;
          }
          if (helpStr) {
            context.write(`${helpStr}
`);
          }
        });
        return this;
      }
    };
    function outputHelpIfRequested(cmd, args) {
      const helpOption = cmd._hasHelpOption && args.find((arg2) => arg2 === cmd._helpLongFlag || arg2 === cmd._helpShortFlag);
      if (helpOption) {
        cmd.outputHelp();
        cmd._exit(0, "commander.helpDisplayed", "(outputHelp)");
      }
    }
    function incrementNodeInspectorPort(args) {
      return args.map((arg2) => {
        if (!arg2.startsWith("--inspect")) {
          return arg2;
        }
        let debugOption;
        let debugHost = "127.0.0.1";
        let debugPort = "9229";
        let match;
        if ((match = arg2.match(/^(--inspect(-brk)?)$/)) !== null) {
          debugOption = match[1];
        } else if ((match = arg2.match(/^(--inspect(-brk|-port)?)=([^:]+)$/)) !== null) {
          debugOption = match[1];
          if (/^\d+$/.test(match[3])) {
            debugPort = match[3];
          } else {
            debugHost = match[3];
          }
        } else if ((match = arg2.match(/^(--inspect(-brk|-port)?)=([^:]+):(\d+)$/)) !== null) {
          debugOption = match[1];
          debugHost = match[3];
          debugPort = match[4];
        }
        if (debugOption && debugPort !== "0") {
          return `${debugOption}=${debugHost}:${parseInt(debugPort) + 1}`;
        }
        return arg2;
      });
    }
    function getCommandAndParents(startCommand) {
      const result2 = [];
      for (let command = startCommand; command; command = command.parent) {
        result2.push(command);
      }
      return result2;
    }
    exports2.Command = Command2;
  }
});

// node_modules/commander/index.js
var require_commander = __commonJS({
  "node_modules/commander/index.js"(exports2, module2) {
    var { Argument } = require_argument();
    var { Command: Command2 } = require_command();
    var { CommanderError, InvalidArgumentError } = require_error();
    var { Help } = require_help();
    var { Option } = require_option();
    exports2 = module2.exports = new Command2();
    exports2.program = exports2;
    exports2.Argument = Argument;
    exports2.Command = Command2;
    exports2.CommanderError = CommanderError;
    exports2.Help = Help;
    exports2.InvalidArgumentError = InvalidArgumentError;
    exports2.InvalidOptionArgumentError = InvalidArgumentError;
    exports2.Option = Option;
  }
});

// node_modules/object-assign/index.js
var require_object_assign = __commonJS({
  "node_modules/object-assign/index.js"(exports2, module2) {
    "use strict";
    var getOwnPropertySymbols = Object.getOwnPropertySymbols;
    var hasOwnProperty2 = Object.prototype.hasOwnProperty;
    var propIsEnumerable = Object.prototype.propertyIsEnumerable;
    function toObject(val) {
      if (val === null || val === void 0) {
        throw new TypeError("Object.assign cannot be called with null or undefined");
      }
      return Object(val);
    }
    function shouldUseNative() {
      try {
        if (!Object.assign) {
          return false;
        }
        var test1 = new String("abc");
        test1[5] = "de";
        if (Object.getOwnPropertyNames(test1)[0] === "5") {
          return false;
        }
        var test2 = {};
        for (var i3 = 0; i3 < 10; i3++) {
          test2["_" + String.fromCharCode(i3)] = i3;
        }
        var order2 = Object.getOwnPropertyNames(test2).map(function(n2) {
          return test2[n2];
        });
        if (order2.join("") !== "0123456789") {
          return false;
        }
        var test3 = {};
        "abcdefghijklmnopqrst".split("").forEach(function(letter) {
          test3[letter] = letter;
        });
        if (Object.keys(Object.assign({}, test3)).join("") !== "abcdefghijklmnopqrst") {
          return false;
        }
        return true;
      } catch (err2) {
        return false;
      }
    }
    module2.exports = shouldUseNative() ? Object.assign : function(target, source) {
      var from;
      var to = toObject(target);
      var symbols;
      for (var s2 = 1; s2 < arguments.length; s2++) {
        from = Object(arguments[s2]);
        for (var key2 in from) {
          if (hasOwnProperty2.call(from, key2)) {
            to[key2] = from[key2];
          }
        }
        if (getOwnPropertySymbols) {
          symbols = getOwnPropertySymbols(from);
          for (var i3 = 0; i3 < symbols.length; i3++) {
            if (propIsEnumerable.call(from, symbols[i3])) {
              to[symbols[i3]] = from[symbols[i3]];
            }
          }
        }
      }
      return to;
    };
  }
});

// node_modules/react/cjs/react.production.min.js
var require_react_production_min = __commonJS({
  "node_modules/react/cjs/react.production.min.js"(exports2) {
    "use strict";
    var l2 = require_object_assign();
    var n2 = typeof Symbol === "function" && Symbol.for;
    var p = n2 ? Symbol.for("react.element") : 60103;
    var q = n2 ? Symbol.for("react.portal") : 60106;
    var r2 = n2 ? Symbol.for("react.fragment") : 60107;
    var t2 = n2 ? Symbol.for("react.strict_mode") : 60108;
    var u2 = n2 ? Symbol.for("react.profiler") : 60114;
    var v = n2 ? Symbol.for("react.provider") : 60109;
    var w = n2 ? Symbol.for("react.context") : 60110;
    var x = n2 ? Symbol.for("react.forward_ref") : 60112;
    var y2 = n2 ? Symbol.for("react.suspense") : 60113;
    var z = n2 ? Symbol.for("react.memo") : 60115;
    var A = n2 ? Symbol.for("react.lazy") : 60116;
    var B = typeof Symbol === "function" && Symbol.iterator;
    function C(a2) {
      for (var b2 = "https://reactjs.org/docs/error-decoder.html?invariant=" + a2, c2 = 1; c2 < arguments.length; c2++)
        b2 += "&args[]=" + encodeURIComponent(arguments[c2]);
      return "Minified React error #" + a2 + "; visit " + b2 + " for the full message or use the non-minified dev environment for full errors and additional helpful warnings.";
    }
    var D = { isMounted: function() {
      return false;
    }, enqueueForceUpdate: function() {
    }, enqueueReplaceState: function() {
    }, enqueueSetState: function() {
    } };
    var E = {};
    function F(a2, b2, c2) {
      this.props = a2;
      this.context = b2;
      this.refs = E;
      this.updater = c2 || D;
    }
    F.prototype.isReactComponent = {};
    F.prototype.setState = function(a2, b2) {
      if (typeof a2 !== "object" && typeof a2 !== "function" && a2 != null)
        throw Error(C(85));
      this.updater.enqueueSetState(this, a2, b2, "setState");
    };
    F.prototype.forceUpdate = function(a2) {
      this.updater.enqueueForceUpdate(this, a2, "forceUpdate");
    };
    function G() {
    }
    G.prototype = F.prototype;
    function H(a2, b2, c2) {
      this.props = a2;
      this.context = b2;
      this.refs = E;
      this.updater = c2 || D;
    }
    var I = H.prototype = new G();
    I.constructor = H;
    l2(I, F.prototype);
    I.isPureReactComponent = true;
    var J = { current: null };
    var K = Object.prototype.hasOwnProperty;
    var L = { key: true, ref: true, __self: true, __source: true };
    function M(a2, b2, c2) {
      var e2, d = {}, g2 = null, k = null;
      if (b2 != null)
        for (e2 in b2.ref !== void 0 && (k = b2.ref), b2.key !== void 0 && (g2 = "" + b2.key), b2)
          K.call(b2, e2) && !L.hasOwnProperty(e2) && (d[e2] = b2[e2]);
      var f = arguments.length - 2;
      if (f === 1)
        d.children = c2;
      else if (1 < f) {
        for (var h = Array(f), m = 0; m < f; m++)
          h[m] = arguments[m + 2];
        d.children = h;
      }
      if (a2 && a2.defaultProps)
        for (e2 in f = a2.defaultProps, f)
          d[e2] === void 0 && (d[e2] = f[e2]);
      return { $$typeof: p, type: a2, key: g2, ref: k, props: d, _owner: J.current };
    }
    function N(a2, b2) {
      return { $$typeof: p, type: a2.type, key: b2, ref: a2.ref, props: a2.props, _owner: a2._owner };
    }
    function O(a2) {
      return typeof a2 === "object" && a2 !== null && a2.$$typeof === p;
    }
    function escape(a2) {
      var b2 = { "=": "=0", ":": "=2" };
      return "$" + ("" + a2).replace(/[=:]/g, function(a3) {
        return b2[a3];
      });
    }
    var P = /\/+/g;
    var Q = [];
    function R(a2, b2, c2, e2) {
      if (Q.length) {
        var d = Q.pop();
        d.result = a2;
        d.keyPrefix = b2;
        d.func = c2;
        d.context = e2;
        d.count = 0;
        return d;
      }
      return { result: a2, keyPrefix: b2, func: c2, context: e2, count: 0 };
    }
    function S(a2) {
      a2.result = null;
      a2.keyPrefix = null;
      a2.func = null;
      a2.context = null;
      a2.count = 0;
      10 > Q.length && Q.push(a2);
    }
    function T(a2, b2, c2, e2) {
      var d = typeof a2;
      if (d === "undefined" || d === "boolean")
        a2 = null;
      var g2 = false;
      if (a2 === null)
        g2 = true;
      else
        switch (d) {
          case "string":
          case "number":
            g2 = true;
            break;
          case "object":
            switch (a2.$$typeof) {
              case p:
              case q:
                g2 = true;
            }
        }
      if (g2)
        return c2(e2, a2, b2 === "" ? "." + U(a2, 0) : b2), 1;
      g2 = 0;
      b2 = b2 === "" ? "." : b2 + ":";
      if (Array.isArray(a2))
        for (var k = 0; k < a2.length; k++) {
          d = a2[k];
          var f = b2 + U(d, k);
          g2 += T(d, f, c2, e2);
        }
      else if (a2 === null || typeof a2 !== "object" ? f = null : (f = B && a2[B] || a2["@@iterator"], f = typeof f === "function" ? f : null), typeof f === "function")
        for (a2 = f.call(a2), k = 0; !(d = a2.next()).done; )
          d = d.value, f = b2 + U(d, k++), g2 += T(d, f, c2, e2);
      else if (d === "object")
        throw c2 = "" + a2, Error(C(31, c2 === "[object Object]" ? "object with keys {" + Object.keys(a2).join(", ") + "}" : c2, ""));
      return g2;
    }
    function V(a2, b2, c2) {
      return a2 == null ? 0 : T(a2, "", b2, c2);
    }
    function U(a2, b2) {
      return typeof a2 === "object" && a2 !== null && a2.key != null ? escape(a2.key) : b2.toString(36);
    }
    function W(a2, b2) {
      a2.func.call(a2.context, b2, a2.count++);
    }
    function aa(a2, b2, c2) {
      var e2 = a2.result, d = a2.keyPrefix;
      a2 = a2.func.call(a2.context, b2, a2.count++);
      Array.isArray(a2) ? X(a2, e2, c2, function(a3) {
        return a3;
      }) : a2 != null && (O(a2) && (a2 = N(a2, d + (!a2.key || b2 && b2.key === a2.key ? "" : ("" + a2.key).replace(P, "$&/") + "/") + c2)), e2.push(a2));
    }
    function X(a2, b2, c2, e2, d) {
      var g2 = "";
      c2 != null && (g2 = ("" + c2).replace(P, "$&/") + "/");
      b2 = R(b2, g2, e2, d);
      V(a2, aa, b2);
      S(b2);
    }
    var Y = { current: null };
    function Z() {
      var a2 = Y.current;
      if (a2 === null)
        throw Error(C(321));
      return a2;
    }
    var ba = { ReactCurrentDispatcher: Y, ReactCurrentBatchConfig: { suspense: null }, ReactCurrentOwner: J, IsSomeRendererActing: { current: false }, assign: l2 };
    exports2.Children = { map: function(a2, b2, c2) {
      if (a2 == null)
        return a2;
      var e2 = [];
      X(a2, e2, null, b2, c2);
      return e2;
    }, forEach: function(a2, b2, c2) {
      if (a2 == null)
        return a2;
      b2 = R(null, null, b2, c2);
      V(a2, W, b2);
      S(b2);
    }, count: function(a2) {
      return V(a2, function() {
        return null;
      }, null);
    }, toArray: function(a2) {
      var b2 = [];
      X(a2, b2, null, function(a3) {
        return a3;
      });
      return b2;
    }, only: function(a2) {
      if (!O(a2))
        throw Error(C(143));
      return a2;
    } };
    exports2.Component = F;
    exports2.Fragment = r2;
    exports2.Profiler = u2;
    exports2.PureComponent = H;
    exports2.StrictMode = t2;
    exports2.Suspense = y2;
    exports2.__SECRET_INTERNALS_DO_NOT_USE_OR_YOU_WILL_BE_FIRED = ba;
    exports2.cloneElement = function(a2, b2, c2) {
      if (a2 === null || a2 === void 0)
        throw Error(C(267, a2));
      var e2 = l2({}, a2.props), d = a2.key, g2 = a2.ref, k = a2._owner;
      if (b2 != null) {
        b2.ref !== void 0 && (g2 = b2.ref, k = J.current);
        b2.key !== void 0 && (d = "" + b2.key);
        if (a2.type && a2.type.defaultProps)
          var f = a2.type.defaultProps;
        for (h in b2)
          K.call(b2, h) && !L.hasOwnProperty(h) && (e2[h] = b2[h] === void 0 && f !== void 0 ? f[h] : b2[h]);
      }
      var h = arguments.length - 2;
      if (h === 1)
        e2.children = c2;
      else if (1 < h) {
        f = Array(h);
        for (var m = 0; m < h; m++)
          f[m] = arguments[m + 2];
        e2.children = f;
      }
      return {
        $$typeof: p,
        type: a2.type,
        key: d,
        ref: g2,
        props: e2,
        _owner: k
      };
    };
    exports2.createContext = function(a2, b2) {
      b2 === void 0 && (b2 = null);
      a2 = { $$typeof: w, _calculateChangedBits: b2, _currentValue: a2, _currentValue2: a2, _threadCount: 0, Provider: null, Consumer: null };
      a2.Provider = { $$typeof: v, _context: a2 };
      return a2.Consumer = a2;
    };
    exports2.createElement = M;
    exports2.createFactory = function(a2) {
      var b2 = M.bind(null, a2);
      b2.type = a2;
      return b2;
    };
    exports2.createRef = function() {
      return { current: null };
    };
    exports2.forwardRef = function(a2) {
      return { $$typeof: x, render: a2 };
    };
    exports2.isValidElement = O;
    exports2.lazy = function(a2) {
      return { $$typeof: A, _ctor: a2, _status: -1, _result: null };
    };
    exports2.memo = function(a2, b2) {
      return { $$typeof: z, type: a2, compare: b2 === void 0 ? null : b2 };
    };
    exports2.useCallback = function(a2, b2) {
      return Z().useCallback(a2, b2);
    };
    exports2.useContext = function(a2, b2) {
      return Z().useContext(a2, b2);
    };
    exports2.useDebugValue = function() {
    };
    exports2.useEffect = function(a2, b2) {
      return Z().useEffect(a2, b2);
    };
    exports2.useImperativeHandle = function(a2, b2, c2) {
      return Z().useImperativeHandle(a2, b2, c2);
    };
    exports2.useLayoutEffect = function(a2, b2) {
      return Z().useLayoutEffect(a2, b2);
    };
    exports2.useMemo = function(a2, b2) {
      return Z().useMemo(a2, b2);
    };
    exports2.useReducer = function(a2, b2, c2) {
      return Z().useReducer(a2, b2, c2);
    };
    exports2.useRef = function(a2) {
      return Z().useRef(a2);
    };
    exports2.useState = function(a2) {
      return Z().useState(a2);
    };
    exports2.version = "16.14.0";
  }
});

// node_modules/prop-types/lib/ReactPropTypesSecret.js
var require_ReactPropTypesSecret = __commonJS({
  "node_modules/prop-types/lib/ReactPropTypesSecret.js"(exports2, module2) {
    "use strict";
    var ReactPropTypesSecret = "SECRET_DO_NOT_PASS_THIS_OR_YOU_WILL_BE_FIRED";
    module2.exports = ReactPropTypesSecret;
  }
});

// node_modules/prop-types/checkPropTypes.js
var require_checkPropTypes = __commonJS({
  "node_modules/prop-types/checkPropTypes.js"(exports2, module2) {
    "use strict";
    var printWarning = function() {
    };
    if (process.env.NODE_ENV !== "production") {
      ReactPropTypesSecret = require_ReactPropTypesSecret();
      loggedTypeFailures = {};
      has = Function.call.bind(Object.prototype.hasOwnProperty);
      printWarning = function(text) {
        var message = "Warning: " + text;
        if (typeof console !== "undefined") {
          console.error(message);
        }
        try {
          throw new Error(message);
        } catch (x) {
        }
      };
    }
    var ReactPropTypesSecret;
    var loggedTypeFailures;
    var has;
    function checkPropTypes(typeSpecs, values, location, componentName, getStack) {
      if (process.env.NODE_ENV !== "production") {
        for (var typeSpecName in typeSpecs) {
          if (has(typeSpecs, typeSpecName)) {
            var error;
            try {
              if (typeof typeSpecs[typeSpecName] !== "function") {
                var err2 = Error((componentName || "React class") + ": " + location + " type `" + typeSpecName + "` is invalid; it must be a function, usually from the `prop-types` package, but received `" + typeof typeSpecs[typeSpecName] + "`.");
                err2.name = "Invariant Violation";
                throw err2;
              }
              error = typeSpecs[typeSpecName](values, typeSpecName, componentName, location, null, ReactPropTypesSecret);
            } catch (ex) {
              error = ex;
            }
            if (error && !(error instanceof Error)) {
              printWarning((componentName || "React class") + ": type specification of " + location + " `" + typeSpecName + "` is invalid; the type checker function must return `null` or an `Error` but returned a " + typeof error + ". You may have forgotten to pass an argument to the type checker creator (arrayOf, instanceOf, objectOf, oneOf, oneOfType, and shape all require an argument).");
            }
            if (error instanceof Error && !(error.message in loggedTypeFailures)) {
              loggedTypeFailures[error.message] = true;
              var stack = getStack ? getStack() : "";
              printWarning("Failed " + location + " type: " + error.message + (stack != null ? stack : ""));
            }
          }
        }
      }
    }
    checkPropTypes.resetWarningCache = function() {
      if (process.env.NODE_ENV !== "production") {
        loggedTypeFailures = {};
      }
    };
    module2.exports = checkPropTypes;
  }
});

// node_modules/react/cjs/react.development.js
var require_react_development = __commonJS({
  "node_modules/react/cjs/react.development.js"(exports2) {
    "use strict";
    if (process.env.NODE_ENV !== "production") {
      (function() {
        "use strict";
        var _assign = require_object_assign();
        var checkPropTypes = require_checkPropTypes();
        var ReactVersion = "16.14.0";
        var hasSymbol = typeof Symbol === "function" && Symbol.for;
        var REACT_ELEMENT_TYPE = hasSymbol ? Symbol.for("react.element") : 60103;
        var REACT_PORTAL_TYPE = hasSymbol ? Symbol.for("react.portal") : 60106;
        var REACT_FRAGMENT_TYPE = hasSymbol ? Symbol.for("react.fragment") : 60107;
        var REACT_STRICT_MODE_TYPE = hasSymbol ? Symbol.for("react.strict_mode") : 60108;
        var REACT_PROFILER_TYPE = hasSymbol ? Symbol.for("react.profiler") : 60114;
        var REACT_PROVIDER_TYPE = hasSymbol ? Symbol.for("react.provider") : 60109;
        var REACT_CONTEXT_TYPE = hasSymbol ? Symbol.for("react.context") : 60110;
        var REACT_CONCURRENT_MODE_TYPE = hasSymbol ? Symbol.for("react.concurrent_mode") : 60111;
        var REACT_FORWARD_REF_TYPE = hasSymbol ? Symbol.for("react.forward_ref") : 60112;
        var REACT_SUSPENSE_TYPE = hasSymbol ? Symbol.for("react.suspense") : 60113;
        var REACT_SUSPENSE_LIST_TYPE = hasSymbol ? Symbol.for("react.suspense_list") : 60120;
        var REACT_MEMO_TYPE = hasSymbol ? Symbol.for("react.memo") : 60115;
        var REACT_LAZY_TYPE = hasSymbol ? Symbol.for("react.lazy") : 60116;
        var REACT_BLOCK_TYPE = hasSymbol ? Symbol.for("react.block") : 60121;
        var REACT_FUNDAMENTAL_TYPE = hasSymbol ? Symbol.for("react.fundamental") : 60117;
        var REACT_RESPONDER_TYPE = hasSymbol ? Symbol.for("react.responder") : 60118;
        var REACT_SCOPE_TYPE = hasSymbol ? Symbol.for("react.scope") : 60119;
        var MAYBE_ITERATOR_SYMBOL = typeof Symbol === "function" && Symbol.iterator;
        var FAUX_ITERATOR_SYMBOL = "@@iterator";
        function getIteratorFn(maybeIterable) {
          if (maybeIterable === null || typeof maybeIterable !== "object") {
            return null;
          }
          var maybeIterator = MAYBE_ITERATOR_SYMBOL && maybeIterable[MAYBE_ITERATOR_SYMBOL] || maybeIterable[FAUX_ITERATOR_SYMBOL];
          if (typeof maybeIterator === "function") {
            return maybeIterator;
          }
          return null;
        }
        var ReactCurrentDispatcher = {
          current: null
        };
        var ReactCurrentBatchConfig = {
          suspense: null
        };
        var ReactCurrentOwner = {
          current: null
        };
        var BEFORE_SLASH_RE = /^(.*)[\\\/]/;
        function describeComponentFrame(name, source, ownerName) {
          var sourceInfo = "";
          if (source) {
            var path2 = source.fileName;
            var fileName = path2.replace(BEFORE_SLASH_RE, "");
            {
              if (/^index\./.test(fileName)) {
                var match = path2.match(BEFORE_SLASH_RE);
                if (match) {
                  var pathBeforeSlash = match[1];
                  if (pathBeforeSlash) {
                    var folderName = pathBeforeSlash.replace(BEFORE_SLASH_RE, "");
                    fileName = folderName + "/" + fileName;
                  }
                }
              }
            }
            sourceInfo = " (at " + fileName + ":" + source.lineNumber + ")";
          } else if (ownerName) {
            sourceInfo = " (created by " + ownerName + ")";
          }
          return "\n    in " + (name || "Unknown") + sourceInfo;
        }
        var Resolved = 1;
        function refineResolvedLazyComponent(lazyComponent) {
          return lazyComponent._status === Resolved ? lazyComponent._result : null;
        }
        function getWrappedName(outerType, innerType, wrapperName) {
          var functionName = innerType.displayName || innerType.name || "";
          return outerType.displayName || (functionName !== "" ? wrapperName + "(" + functionName + ")" : wrapperName);
        }
        function getComponentName(type3) {
          if (type3 == null) {
            return null;
          }
          {
            if (typeof type3.tag === "number") {
              error("Received an unexpected object in getComponentName(). This is likely a bug in React. Please file an issue.");
            }
          }
          if (typeof type3 === "function") {
            return type3.displayName || type3.name || null;
          }
          if (typeof type3 === "string") {
            return type3;
          }
          switch (type3) {
            case REACT_FRAGMENT_TYPE:
              return "Fragment";
            case REACT_PORTAL_TYPE:
              return "Portal";
            case REACT_PROFILER_TYPE:
              return "Profiler";
            case REACT_STRICT_MODE_TYPE:
              return "StrictMode";
            case REACT_SUSPENSE_TYPE:
              return "Suspense";
            case REACT_SUSPENSE_LIST_TYPE:
              return "SuspenseList";
          }
          if (typeof type3 === "object") {
            switch (type3.$$typeof) {
              case REACT_CONTEXT_TYPE:
                return "Context.Consumer";
              case REACT_PROVIDER_TYPE:
                return "Context.Provider";
              case REACT_FORWARD_REF_TYPE:
                return getWrappedName(type3, type3.render, "ForwardRef");
              case REACT_MEMO_TYPE:
                return getComponentName(type3.type);
              case REACT_BLOCK_TYPE:
                return getComponentName(type3.render);
              case REACT_LAZY_TYPE: {
                var thenable = type3;
                var resolvedThenable = refineResolvedLazyComponent(thenable);
                if (resolvedThenable) {
                  return getComponentName(resolvedThenable);
                }
                break;
              }
            }
          }
          return null;
        }
        var ReactDebugCurrentFrame = {};
        var currentlyValidatingElement = null;
        function setCurrentlyValidatingElement(element) {
          {
            currentlyValidatingElement = element;
          }
        }
        {
          ReactDebugCurrentFrame.getCurrentStack = null;
          ReactDebugCurrentFrame.getStackAddendum = function() {
            var stack = "";
            if (currentlyValidatingElement) {
              var name = getComponentName(currentlyValidatingElement.type);
              var owner = currentlyValidatingElement._owner;
              stack += describeComponentFrame(name, currentlyValidatingElement._source, owner && getComponentName(owner.type));
            }
            var impl = ReactDebugCurrentFrame.getCurrentStack;
            if (impl) {
              stack += impl() || "";
            }
            return stack;
          };
        }
        var IsSomeRendererActing = {
          current: false
        };
        var ReactSharedInternals = {
          ReactCurrentDispatcher,
          ReactCurrentBatchConfig,
          ReactCurrentOwner,
          IsSomeRendererActing,
          assign: _assign
        };
        {
          _assign(ReactSharedInternals, {
            ReactDebugCurrentFrame,
            ReactComponentTreeHook: {}
          });
        }
        function warn(format) {
          {
            for (var _len = arguments.length, args = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
              args[_key - 1] = arguments[_key];
            }
            printWarning("warn", format, args);
          }
        }
        function error(format) {
          {
            for (var _len2 = arguments.length, args = new Array(_len2 > 1 ? _len2 - 1 : 0), _key2 = 1; _key2 < _len2; _key2++) {
              args[_key2 - 1] = arguments[_key2];
            }
            printWarning("error", format, args);
          }
        }
        function printWarning(level, format, args) {
          {
            var hasExistingStack = args.length > 0 && typeof args[args.length - 1] === "string" && args[args.length - 1].indexOf("\n    in") === 0;
            if (!hasExistingStack) {
              var ReactDebugCurrentFrame2 = ReactSharedInternals.ReactDebugCurrentFrame;
              var stack = ReactDebugCurrentFrame2.getStackAddendum();
              if (stack !== "") {
                format += "%s";
                args = args.concat([stack]);
              }
            }
            var argsWithFormat = args.map(function(item) {
              return "" + item;
            });
            argsWithFormat.unshift("Warning: " + format);
            Function.prototype.apply.call(console[level], console, argsWithFormat);
            try {
              var argIndex = 0;
              var message = "Warning: " + format.replace(/%s/g, function() {
                return args[argIndex++];
              });
              throw new Error(message);
            } catch (x) {
            }
          }
        }
        var didWarnStateUpdateForUnmountedComponent = {};
        function warnNoop(publicInstance, callerName) {
          {
            var _constructor = publicInstance.constructor;
            var componentName = _constructor && (_constructor.displayName || _constructor.name) || "ReactClass";
            var warningKey = componentName + "." + callerName;
            if (didWarnStateUpdateForUnmountedComponent[warningKey]) {
              return;
            }
            error("Can't call %s on a component that is not yet mounted. This is a no-op, but it might indicate a bug in your application. Instead, assign to `this.state` directly or define a `state = {};` class property with the desired state in the %s component.", callerName, componentName);
            didWarnStateUpdateForUnmountedComponent[warningKey] = true;
          }
        }
        var ReactNoopUpdateQueue = {
          isMounted: function(publicInstance) {
            return false;
          },
          enqueueForceUpdate: function(publicInstance, callback, callerName) {
            warnNoop(publicInstance, "forceUpdate");
          },
          enqueueReplaceState: function(publicInstance, completeState, callback, callerName) {
            warnNoop(publicInstance, "replaceState");
          },
          enqueueSetState: function(publicInstance, partialState, callback, callerName) {
            warnNoop(publicInstance, "setState");
          }
        };
        var emptyObject = {};
        {
          Object.freeze(emptyObject);
        }
        function Component(props, context, updater) {
          this.props = props;
          this.context = context;
          this.refs = emptyObject;
          this.updater = updater || ReactNoopUpdateQueue;
        }
        Component.prototype.isReactComponent = {};
        Component.prototype.setState = function(partialState, callback) {
          if (!(typeof partialState === "object" || typeof partialState === "function" || partialState == null)) {
            {
              throw Error("setState(...): takes an object of state variables to update or a function which returns an object of state variables.");
            }
          }
          this.updater.enqueueSetState(this, partialState, callback, "setState");
        };
        Component.prototype.forceUpdate = function(callback) {
          this.updater.enqueueForceUpdate(this, callback, "forceUpdate");
        };
        {
          var deprecatedAPIs = {
            isMounted: ["isMounted", "Instead, make sure to clean up subscriptions and pending requests in componentWillUnmount to prevent memory leaks."],
            replaceState: ["replaceState", "Refactor your code to use setState instead (see https://github.com/facebook/react/issues/3236)."]
          };
          var defineDeprecationWarning = function(methodName, info) {
            Object.defineProperty(Component.prototype, methodName, {
              get: function() {
                warn("%s(...) is deprecated in plain JavaScript React classes. %s", info[0], info[1]);
                return void 0;
              }
            });
          };
          for (var fnName in deprecatedAPIs) {
            if (deprecatedAPIs.hasOwnProperty(fnName)) {
              defineDeprecationWarning(fnName, deprecatedAPIs[fnName]);
            }
          }
        }
        function ComponentDummy() {
        }
        ComponentDummy.prototype = Component.prototype;
        function PureComponent(props, context, updater) {
          this.props = props;
          this.context = context;
          this.refs = emptyObject;
          this.updater = updater || ReactNoopUpdateQueue;
        }
        var pureComponentPrototype = PureComponent.prototype = new ComponentDummy();
        pureComponentPrototype.constructor = PureComponent;
        _assign(pureComponentPrototype, Component.prototype);
        pureComponentPrototype.isPureReactComponent = true;
        function createRef() {
          var refObject = {
            current: null
          };
          {
            Object.seal(refObject);
          }
          return refObject;
        }
        var hasOwnProperty2 = Object.prototype.hasOwnProperty;
        var RESERVED_PROPS = {
          key: true,
          ref: true,
          __self: true,
          __source: true
        };
        var specialPropKeyWarningShown, specialPropRefWarningShown, didWarnAboutStringRefs;
        {
          didWarnAboutStringRefs = {};
        }
        function hasValidRef(config) {
          {
            if (hasOwnProperty2.call(config, "ref")) {
              var getter = Object.getOwnPropertyDescriptor(config, "ref").get;
              if (getter && getter.isReactWarning) {
                return false;
              }
            }
          }
          return config.ref !== void 0;
        }
        function hasValidKey(config) {
          {
            if (hasOwnProperty2.call(config, "key")) {
              var getter = Object.getOwnPropertyDescriptor(config, "key").get;
              if (getter && getter.isReactWarning) {
                return false;
              }
            }
          }
          return config.key !== void 0;
        }
        function defineKeyPropWarningGetter(props, displayName) {
          var warnAboutAccessingKey = function() {
            {
              if (!specialPropKeyWarningShown) {
                specialPropKeyWarningShown = true;
                error("%s: `key` is not a prop. Trying to access it will result in `undefined` being returned. If you need to access the same value within the child component, you should pass it as a different prop. (https://fb.me/react-special-props)", displayName);
              }
            }
          };
          warnAboutAccessingKey.isReactWarning = true;
          Object.defineProperty(props, "key", {
            get: warnAboutAccessingKey,
            configurable: true
          });
        }
        function defineRefPropWarningGetter(props, displayName) {
          var warnAboutAccessingRef = function() {
            {
              if (!specialPropRefWarningShown) {
                specialPropRefWarningShown = true;
                error("%s: `ref` is not a prop. Trying to access it will result in `undefined` being returned. If you need to access the same value within the child component, you should pass it as a different prop. (https://fb.me/react-special-props)", displayName);
              }
            }
          };
          warnAboutAccessingRef.isReactWarning = true;
          Object.defineProperty(props, "ref", {
            get: warnAboutAccessingRef,
            configurable: true
          });
        }
        function warnIfStringRefCannotBeAutoConverted(config) {
          {
            if (typeof config.ref === "string" && ReactCurrentOwner.current && config.__self && ReactCurrentOwner.current.stateNode !== config.__self) {
              var componentName = getComponentName(ReactCurrentOwner.current.type);
              if (!didWarnAboutStringRefs[componentName]) {
                error('Component "%s" contains the string ref "%s". Support for string refs will be removed in a future major release. This case cannot be automatically converted to an arrow function. We ask you to manually fix this case by using useRef() or createRef() instead. Learn more about using refs safely here: https://fb.me/react-strict-mode-string-ref', getComponentName(ReactCurrentOwner.current.type), config.ref);
                didWarnAboutStringRefs[componentName] = true;
              }
            }
          }
        }
        var ReactElement = function(type3, key2, ref2, self2, source, owner, props) {
          var element = {
            $$typeof: REACT_ELEMENT_TYPE,
            type: type3,
            key: key2,
            ref: ref2,
            props,
            _owner: owner
          };
          {
            element._store = {};
            Object.defineProperty(element._store, "validated", {
              configurable: false,
              enumerable: false,
              writable: true,
              value: false
            });
            Object.defineProperty(element, "_self", {
              configurable: false,
              enumerable: false,
              writable: false,
              value: self2
            });
            Object.defineProperty(element, "_source", {
              configurable: false,
              enumerable: false,
              writable: false,
              value: source
            });
            if (Object.freeze) {
              Object.freeze(element.props);
              Object.freeze(element);
            }
          }
          return element;
        };
        function createElement(type3, config, children) {
          var propName;
          var props = {};
          var key2 = null;
          var ref2 = null;
          var self2 = null;
          var source = null;
          if (config != null) {
            if (hasValidRef(config)) {
              ref2 = config.ref;
              {
                warnIfStringRefCannotBeAutoConverted(config);
              }
            }
            if (hasValidKey(config)) {
              key2 = "" + config.key;
            }
            self2 = config.__self === void 0 ? null : config.__self;
            source = config.__source === void 0 ? null : config.__source;
            for (propName in config) {
              if (hasOwnProperty2.call(config, propName) && !RESERVED_PROPS.hasOwnProperty(propName)) {
                props[propName] = config[propName];
              }
            }
          }
          var childrenLength = arguments.length - 2;
          if (childrenLength === 1) {
            props.children = children;
          } else if (childrenLength > 1) {
            var childArray = Array(childrenLength);
            for (var i3 = 0; i3 < childrenLength; i3++) {
              childArray[i3] = arguments[i3 + 2];
            }
            {
              if (Object.freeze) {
                Object.freeze(childArray);
              }
            }
            props.children = childArray;
          }
          if (type3 && type3.defaultProps) {
            var defaultProps = type3.defaultProps;
            for (propName in defaultProps) {
              if (props[propName] === void 0) {
                props[propName] = defaultProps[propName];
              }
            }
          }
          {
            if (key2 || ref2) {
              var displayName = typeof type3 === "function" ? type3.displayName || type3.name || "Unknown" : type3;
              if (key2) {
                defineKeyPropWarningGetter(props, displayName);
              }
              if (ref2) {
                defineRefPropWarningGetter(props, displayName);
              }
            }
          }
          return ReactElement(type3, key2, ref2, self2, source, ReactCurrentOwner.current, props);
        }
        function cloneAndReplaceKey(oldElement, newKey) {
          var newElement = ReactElement(oldElement.type, newKey, oldElement.ref, oldElement._self, oldElement._source, oldElement._owner, oldElement.props);
          return newElement;
        }
        function cloneElement(element, config, children) {
          if (!!(element === null || element === void 0)) {
            {
              throw Error("React.cloneElement(...): The argument must be a React element, but you passed " + element + ".");
            }
          }
          var propName;
          var props = _assign({}, element.props);
          var key2 = element.key;
          var ref2 = element.ref;
          var self2 = element._self;
          var source = element._source;
          var owner = element._owner;
          if (config != null) {
            if (hasValidRef(config)) {
              ref2 = config.ref;
              owner = ReactCurrentOwner.current;
            }
            if (hasValidKey(config)) {
              key2 = "" + config.key;
            }
            var defaultProps;
            if (element.type && element.type.defaultProps) {
              defaultProps = element.type.defaultProps;
            }
            for (propName in config) {
              if (hasOwnProperty2.call(config, propName) && !RESERVED_PROPS.hasOwnProperty(propName)) {
                if (config[propName] === void 0 && defaultProps !== void 0) {
                  props[propName] = defaultProps[propName];
                } else {
                  props[propName] = config[propName];
                }
              }
            }
          }
          var childrenLength = arguments.length - 2;
          if (childrenLength === 1) {
            props.children = children;
          } else if (childrenLength > 1) {
            var childArray = Array(childrenLength);
            for (var i3 = 0; i3 < childrenLength; i3++) {
              childArray[i3] = arguments[i3 + 2];
            }
            props.children = childArray;
          }
          return ReactElement(element.type, key2, ref2, self2, source, owner, props);
        }
        function isValidElement(object) {
          return typeof object === "object" && object !== null && object.$$typeof === REACT_ELEMENT_TYPE;
        }
        var SEPARATOR = ".";
        var SUBSEPARATOR = ":";
        function escape(key2) {
          var escapeRegex = /[=:]/g;
          var escaperLookup = {
            "=": "=0",
            ":": "=2"
          };
          var escapedString = ("" + key2).replace(escapeRegex, function(match) {
            return escaperLookup[match];
          });
          return "$" + escapedString;
        }
        var didWarnAboutMaps = false;
        var userProvidedKeyEscapeRegex = /\/+/g;
        function escapeUserProvidedKey(text) {
          return ("" + text).replace(userProvidedKeyEscapeRegex, "$&/");
        }
        var POOL_SIZE = 10;
        var traverseContextPool = [];
        function getPooledTraverseContext(mapResult, keyPrefix, mapFunction, mapContext) {
          if (traverseContextPool.length) {
            var traverseContext = traverseContextPool.pop();
            traverseContext.result = mapResult;
            traverseContext.keyPrefix = keyPrefix;
            traverseContext.func = mapFunction;
            traverseContext.context = mapContext;
            traverseContext.count = 0;
            return traverseContext;
          } else {
            return {
              result: mapResult,
              keyPrefix,
              func: mapFunction,
              context: mapContext,
              count: 0
            };
          }
        }
        function releaseTraverseContext(traverseContext) {
          traverseContext.result = null;
          traverseContext.keyPrefix = null;
          traverseContext.func = null;
          traverseContext.context = null;
          traverseContext.count = 0;
          if (traverseContextPool.length < POOL_SIZE) {
            traverseContextPool.push(traverseContext);
          }
        }
        function traverseAllChildrenImpl(children, nameSoFar, callback, traverseContext) {
          var type3 = typeof children;
          if (type3 === "undefined" || type3 === "boolean") {
            children = null;
          }
          var invokeCallback = false;
          if (children === null) {
            invokeCallback = true;
          } else {
            switch (type3) {
              case "string":
              case "number":
                invokeCallback = true;
                break;
              case "object":
                switch (children.$$typeof) {
                  case REACT_ELEMENT_TYPE:
                  case REACT_PORTAL_TYPE:
                    invokeCallback = true;
                }
            }
          }
          if (invokeCallback) {
            callback(traverseContext, children, nameSoFar === "" ? SEPARATOR + getComponentKey(children, 0) : nameSoFar);
            return 1;
          }
          var child;
          var nextName;
          var subtreeCount = 0;
          var nextNamePrefix = nameSoFar === "" ? SEPARATOR : nameSoFar + SUBSEPARATOR;
          if (Array.isArray(children)) {
            for (var i3 = 0; i3 < children.length; i3++) {
              child = children[i3];
              nextName = nextNamePrefix + getComponentKey(child, i3);
              subtreeCount += traverseAllChildrenImpl(child, nextName, callback, traverseContext);
            }
          } else {
            var iteratorFn = getIteratorFn(children);
            if (typeof iteratorFn === "function") {
              {
                if (iteratorFn === children.entries) {
                  if (!didWarnAboutMaps) {
                    warn("Using Maps as children is deprecated and will be removed in a future major release. Consider converting children to an array of keyed ReactElements instead.");
                  }
                  didWarnAboutMaps = true;
                }
              }
              var iterator = iteratorFn.call(children);
              var step;
              var ii = 0;
              while (!(step = iterator.next()).done) {
                child = step.value;
                nextName = nextNamePrefix + getComponentKey(child, ii++);
                subtreeCount += traverseAllChildrenImpl(child, nextName, callback, traverseContext);
              }
            } else if (type3 === "object") {
              var addendum = "";
              {
                addendum = " If you meant to render a collection of children, use an array instead." + ReactDebugCurrentFrame.getStackAddendum();
              }
              var childrenString = "" + children;
              {
                {
                  throw Error("Objects are not valid as a React child (found: " + (childrenString === "[object Object]" ? "object with keys {" + Object.keys(children).join(", ") + "}" : childrenString) + ")." + addendum);
                }
              }
            }
          }
          return subtreeCount;
        }
        function traverseAllChildren(children, callback, traverseContext) {
          if (children == null) {
            return 0;
          }
          return traverseAllChildrenImpl(children, "", callback, traverseContext);
        }
        function getComponentKey(component, index) {
          if (typeof component === "object" && component !== null && component.key != null) {
            return escape(component.key);
          }
          return index.toString(36);
        }
        function forEachSingleChild(bookKeeping, child, name) {
          var func2 = bookKeeping.func, context = bookKeeping.context;
          func2.call(context, child, bookKeeping.count++);
        }
        function forEachChildren(children, forEachFunc, forEachContext) {
          if (children == null) {
            return children;
          }
          var traverseContext = getPooledTraverseContext(null, null, forEachFunc, forEachContext);
          traverseAllChildren(children, forEachSingleChild, traverseContext);
          releaseTraverseContext(traverseContext);
        }
        function mapSingleChildIntoContext(bookKeeping, child, childKey) {
          var result2 = bookKeeping.result, keyPrefix = bookKeeping.keyPrefix, func2 = bookKeeping.func, context = bookKeeping.context;
          var mappedChild = func2.call(context, child, bookKeeping.count++);
          if (Array.isArray(mappedChild)) {
            mapIntoWithKeyPrefixInternal(mappedChild, result2, childKey, function(c2) {
              return c2;
            });
          } else if (mappedChild != null) {
            if (isValidElement(mappedChild)) {
              mappedChild = cloneAndReplaceKey(mappedChild, keyPrefix + (mappedChild.key && (!child || child.key !== mappedChild.key) ? escapeUserProvidedKey(mappedChild.key) + "/" : "") + childKey);
            }
            result2.push(mappedChild);
          }
        }
        function mapIntoWithKeyPrefixInternal(children, array, prefix2, func2, context) {
          var escapedPrefix = "";
          if (prefix2 != null) {
            escapedPrefix = escapeUserProvidedKey(prefix2) + "/";
          }
          var traverseContext = getPooledTraverseContext(array, escapedPrefix, func2, context);
          traverseAllChildren(children, mapSingleChildIntoContext, traverseContext);
          releaseTraverseContext(traverseContext);
        }
        function mapChildren(children, func2, context) {
          if (children == null) {
            return children;
          }
          var result2 = [];
          mapIntoWithKeyPrefixInternal(children, result2, null, func2, context);
          return result2;
        }
        function countChildren(children) {
          return traverseAllChildren(children, function() {
            return null;
          }, null);
        }
        function toArray2(children) {
          var result2 = [];
          mapIntoWithKeyPrefixInternal(children, result2, null, function(child) {
            return child;
          });
          return result2;
        }
        function onlyChild(children) {
          if (!isValidElement(children)) {
            {
              throw Error("React.Children.only expected to receive a single React element child.");
            }
          }
          return children;
        }
        function createContext(defaultValue, calculateChangedBits) {
          if (calculateChangedBits === void 0) {
            calculateChangedBits = null;
          } else {
            {
              if (calculateChangedBits !== null && typeof calculateChangedBits !== "function") {
                error("createContext: Expected the optional second argument to be a function. Instead received: %s", calculateChangedBits);
              }
            }
          }
          var context = {
            $$typeof: REACT_CONTEXT_TYPE,
            _calculateChangedBits: calculateChangedBits,
            _currentValue: defaultValue,
            _currentValue2: defaultValue,
            _threadCount: 0,
            Provider: null,
            Consumer: null
          };
          context.Provider = {
            $$typeof: REACT_PROVIDER_TYPE,
            _context: context
          };
          var hasWarnedAboutUsingNestedContextConsumers = false;
          var hasWarnedAboutUsingConsumerProvider = false;
          {
            var Consumer = {
              $$typeof: REACT_CONTEXT_TYPE,
              _context: context,
              _calculateChangedBits: context._calculateChangedBits
            };
            Object.defineProperties(Consumer, {
              Provider: {
                get: function() {
                  if (!hasWarnedAboutUsingConsumerProvider) {
                    hasWarnedAboutUsingConsumerProvider = true;
                    error("Rendering <Context.Consumer.Provider> is not supported and will be removed in a future major release. Did you mean to render <Context.Provider> instead?");
                  }
                  return context.Provider;
                },
                set: function(_Provider) {
                  context.Provider = _Provider;
                }
              },
              _currentValue: {
                get: function() {
                  return context._currentValue;
                },
                set: function(_currentValue) {
                  context._currentValue = _currentValue;
                }
              },
              _currentValue2: {
                get: function() {
                  return context._currentValue2;
                },
                set: function(_currentValue2) {
                  context._currentValue2 = _currentValue2;
                }
              },
              _threadCount: {
                get: function() {
                  return context._threadCount;
                },
                set: function(_threadCount) {
                  context._threadCount = _threadCount;
                }
              },
              Consumer: {
                get: function() {
                  if (!hasWarnedAboutUsingNestedContextConsumers) {
                    hasWarnedAboutUsingNestedContextConsumers = true;
                    error("Rendering <Context.Consumer.Consumer> is not supported and will be removed in a future major release. Did you mean to render <Context.Consumer> instead?");
                  }
                  return context.Consumer;
                }
              }
            });
            context.Consumer = Consumer;
          }
          {
            context._currentRenderer = null;
            context._currentRenderer2 = null;
          }
          return context;
        }
        function lazy(ctor) {
          var lazyType = {
            $$typeof: REACT_LAZY_TYPE,
            _ctor: ctor,
            _status: -1,
            _result: null
          };
          {
            var defaultProps;
            var propTypes;
            Object.defineProperties(lazyType, {
              defaultProps: {
                configurable: true,
                get: function() {
                  return defaultProps;
                },
                set: function(newDefaultProps) {
                  error("React.lazy(...): It is not supported to assign `defaultProps` to a lazy component import. Either specify them where the component is defined, or create a wrapping component around it.");
                  defaultProps = newDefaultProps;
                  Object.defineProperty(lazyType, "defaultProps", {
                    enumerable: true
                  });
                }
              },
              propTypes: {
                configurable: true,
                get: function() {
                  return propTypes;
                },
                set: function(newPropTypes) {
                  error("React.lazy(...): It is not supported to assign `propTypes` to a lazy component import. Either specify them where the component is defined, or create a wrapping component around it.");
                  propTypes = newPropTypes;
                  Object.defineProperty(lazyType, "propTypes", {
                    enumerable: true
                  });
                }
              }
            });
          }
          return lazyType;
        }
        function forwardRef(render2) {
          {
            if (render2 != null && render2.$$typeof === REACT_MEMO_TYPE) {
              error("forwardRef requires a render function but received a `memo` component. Instead of forwardRef(memo(...)), use memo(forwardRef(...)).");
            } else if (typeof render2 !== "function") {
              error("forwardRef requires a render function but was given %s.", render2 === null ? "null" : typeof render2);
            } else {
              if (render2.length !== 0 && render2.length !== 2) {
                error("forwardRef render functions accept exactly two parameters: props and ref. %s", render2.length === 1 ? "Did you forget to use the ref parameter?" : "Any additional parameter will be undefined.");
              }
            }
            if (render2 != null) {
              if (render2.defaultProps != null || render2.propTypes != null) {
                error("forwardRef render functions do not support propTypes or defaultProps. Did you accidentally pass a React component?");
              }
            }
          }
          return {
            $$typeof: REACT_FORWARD_REF_TYPE,
            render: render2
          };
        }
        function isValidElementType(type3) {
          return typeof type3 === "string" || typeof type3 === "function" || type3 === REACT_FRAGMENT_TYPE || type3 === REACT_CONCURRENT_MODE_TYPE || type3 === REACT_PROFILER_TYPE || type3 === REACT_STRICT_MODE_TYPE || type3 === REACT_SUSPENSE_TYPE || type3 === REACT_SUSPENSE_LIST_TYPE || typeof type3 === "object" && type3 !== null && (type3.$$typeof === REACT_LAZY_TYPE || type3.$$typeof === REACT_MEMO_TYPE || type3.$$typeof === REACT_PROVIDER_TYPE || type3.$$typeof === REACT_CONTEXT_TYPE || type3.$$typeof === REACT_FORWARD_REF_TYPE || type3.$$typeof === REACT_FUNDAMENTAL_TYPE || type3.$$typeof === REACT_RESPONDER_TYPE || type3.$$typeof === REACT_SCOPE_TYPE || type3.$$typeof === REACT_BLOCK_TYPE);
        }
        function memo(type3, compare) {
          {
            if (!isValidElementType(type3)) {
              error("memo: The first argument must be a component. Instead received: %s", type3 === null ? "null" : typeof type3);
            }
          }
          return {
            $$typeof: REACT_MEMO_TYPE,
            type: type3,
            compare: compare === void 0 ? null : compare
          };
        }
        function resolveDispatcher() {
          var dispatcher = ReactCurrentDispatcher.current;
          if (!(dispatcher !== null)) {
            {
              throw Error("Invalid hook call. Hooks can only be called inside of the body of a function component. This could happen for one of the following reasons:\n1. You might have mismatching versions of React and the renderer (such as React DOM)\n2. You might be breaking the Rules of Hooks\n3. You might have more than one copy of React in the same app\nSee https://fb.me/react-invalid-hook-call for tips about how to debug and fix this problem.");
            }
          }
          return dispatcher;
        }
        function useContext(Context, unstable_observedBits) {
          var dispatcher = resolveDispatcher();
          {
            if (unstable_observedBits !== void 0) {
              error("useContext() second argument is reserved for future use in React. Passing it is not supported. You passed: %s.%s", unstable_observedBits, typeof unstable_observedBits === "number" && Array.isArray(arguments[2]) ? "\n\nDid you call array.map(useContext)? Calling Hooks inside a loop is not supported. Learn more at https://fb.me/rules-of-hooks" : "");
            }
            if (Context._context !== void 0) {
              var realContext = Context._context;
              if (realContext.Consumer === Context) {
                error("Calling useContext(Context.Consumer) is not supported, may cause bugs, and will be removed in a future major release. Did you mean to call useContext(Context) instead?");
              } else if (realContext.Provider === Context) {
                error("Calling useContext(Context.Provider) is not supported. Did you mean to call useContext(Context) instead?");
              }
            }
          }
          return dispatcher.useContext(Context, unstable_observedBits);
        }
        function useState3(initialState) {
          var dispatcher = resolveDispatcher();
          return dispatcher.useState(initialState);
        }
        function useReducer2(reducer, initialArg, init) {
          var dispatcher = resolveDispatcher();
          return dispatcher.useReducer(reducer, initialArg, init);
        }
        function useRef2(initialValue) {
          var dispatcher = resolveDispatcher();
          return dispatcher.useRef(initialValue);
        }
        function useEffect3(create, deps) {
          var dispatcher = resolveDispatcher();
          return dispatcher.useEffect(create, deps);
        }
        function useLayoutEffect2(create, deps) {
          var dispatcher = resolveDispatcher();
          return dispatcher.useLayoutEffect(create, deps);
        }
        function useCallback2(callback, deps) {
          var dispatcher = resolveDispatcher();
          return dispatcher.useCallback(callback, deps);
        }
        function useMemo2(create, deps) {
          var dispatcher = resolveDispatcher();
          return dispatcher.useMemo(create, deps);
        }
        function useImperativeHandle(ref2, create, deps) {
          var dispatcher = resolveDispatcher();
          return dispatcher.useImperativeHandle(ref2, create, deps);
        }
        function useDebugValue2(value, formatterFn) {
          {
            var dispatcher = resolveDispatcher();
            return dispatcher.useDebugValue(value, formatterFn);
          }
        }
        var propTypesMisspellWarningShown;
        {
          propTypesMisspellWarningShown = false;
        }
        function getDeclarationErrorAddendum() {
          if (ReactCurrentOwner.current) {
            var name = getComponentName(ReactCurrentOwner.current.type);
            if (name) {
              return "\n\nCheck the render method of `" + name + "`.";
            }
          }
          return "";
        }
        function getSourceInfoErrorAddendum(source) {
          if (source !== void 0) {
            var fileName = source.fileName.replace(/^.*[\\\/]/, "");
            var lineNumber = source.lineNumber;
            return "\n\nCheck your code at " + fileName + ":" + lineNumber + ".";
          }
          return "";
        }
        function getSourceInfoErrorAddendumForProps(elementProps) {
          if (elementProps !== null && elementProps !== void 0) {
            return getSourceInfoErrorAddendum(elementProps.__source);
          }
          return "";
        }
        var ownerHasKeyUseWarning = {};
        function getCurrentComponentErrorInfo(parentType) {
          var info = getDeclarationErrorAddendum();
          if (!info) {
            var parentName = typeof parentType === "string" ? parentType : parentType.displayName || parentType.name;
            if (parentName) {
              info = "\n\nCheck the top-level render call using <" + parentName + ">.";
            }
          }
          return info;
        }
        function validateExplicitKey(element, parentType) {
          if (!element._store || element._store.validated || element.key != null) {
            return;
          }
          element._store.validated = true;
          var currentComponentErrorInfo = getCurrentComponentErrorInfo(parentType);
          if (ownerHasKeyUseWarning[currentComponentErrorInfo]) {
            return;
          }
          ownerHasKeyUseWarning[currentComponentErrorInfo] = true;
          var childOwner = "";
          if (element && element._owner && element._owner !== ReactCurrentOwner.current) {
            childOwner = " It was passed a child from " + getComponentName(element._owner.type) + ".";
          }
          setCurrentlyValidatingElement(element);
          {
            error('Each child in a list should have a unique "key" prop.%s%s See https://fb.me/react-warning-keys for more information.', currentComponentErrorInfo, childOwner);
          }
          setCurrentlyValidatingElement(null);
        }
        function validateChildKeys(node, parentType) {
          if (typeof node !== "object") {
            return;
          }
          if (Array.isArray(node)) {
            for (var i3 = 0; i3 < node.length; i3++) {
              var child = node[i3];
              if (isValidElement(child)) {
                validateExplicitKey(child, parentType);
              }
            }
          } else if (isValidElement(node)) {
            if (node._store) {
              node._store.validated = true;
            }
          } else if (node) {
            var iteratorFn = getIteratorFn(node);
            if (typeof iteratorFn === "function") {
              if (iteratorFn !== node.entries) {
                var iterator = iteratorFn.call(node);
                var step;
                while (!(step = iterator.next()).done) {
                  if (isValidElement(step.value)) {
                    validateExplicitKey(step.value, parentType);
                  }
                }
              }
            }
          }
        }
        function validatePropTypes(element) {
          {
            var type3 = element.type;
            if (type3 === null || type3 === void 0 || typeof type3 === "string") {
              return;
            }
            var name = getComponentName(type3);
            var propTypes;
            if (typeof type3 === "function") {
              propTypes = type3.propTypes;
            } else if (typeof type3 === "object" && (type3.$$typeof === REACT_FORWARD_REF_TYPE || type3.$$typeof === REACT_MEMO_TYPE)) {
              propTypes = type3.propTypes;
            } else {
              return;
            }
            if (propTypes) {
              setCurrentlyValidatingElement(element);
              checkPropTypes(propTypes, element.props, "prop", name, ReactDebugCurrentFrame.getStackAddendum);
              setCurrentlyValidatingElement(null);
            } else if (type3.PropTypes !== void 0 && !propTypesMisspellWarningShown) {
              propTypesMisspellWarningShown = true;
              error("Component %s declared `PropTypes` instead of `propTypes`. Did you misspell the property assignment?", name || "Unknown");
            }
            if (typeof type3.getDefaultProps === "function" && !type3.getDefaultProps.isReactClassApproved) {
              error("getDefaultProps is only used on classic React.createClass definitions. Use a static property named `defaultProps` instead.");
            }
          }
        }
        function validateFragmentProps(fragment) {
          {
            setCurrentlyValidatingElement(fragment);
            var keys = Object.keys(fragment.props);
            for (var i3 = 0; i3 < keys.length; i3++) {
              var key2 = keys[i3];
              if (key2 !== "children" && key2 !== "key") {
                error("Invalid prop `%s` supplied to `React.Fragment`. React.Fragment can only have `key` and `children` props.", key2);
                break;
              }
            }
            if (fragment.ref !== null) {
              error("Invalid attribute `ref` supplied to `React.Fragment`.");
            }
            setCurrentlyValidatingElement(null);
          }
        }
        function createElementWithValidation(type3, props, children) {
          var validType = isValidElementType(type3);
          if (!validType) {
            var info = "";
            if (type3 === void 0 || typeof type3 === "object" && type3 !== null && Object.keys(type3).length === 0) {
              info += " You likely forgot to export your component from the file it's defined in, or you might have mixed up default and named imports.";
            }
            var sourceInfo = getSourceInfoErrorAddendumForProps(props);
            if (sourceInfo) {
              info += sourceInfo;
            } else {
              info += getDeclarationErrorAddendum();
            }
            var typeString;
            if (type3 === null) {
              typeString = "null";
            } else if (Array.isArray(type3)) {
              typeString = "array";
            } else if (type3 !== void 0 && type3.$$typeof === REACT_ELEMENT_TYPE) {
              typeString = "<" + (getComponentName(type3.type) || "Unknown") + " />";
              info = " Did you accidentally export a JSX literal instead of a component?";
            } else {
              typeString = typeof type3;
            }
            {
              error("React.createElement: type is invalid -- expected a string (for built-in components) or a class/function (for composite components) but got: %s.%s", typeString, info);
            }
          }
          var element = createElement.apply(this, arguments);
          if (element == null) {
            return element;
          }
          if (validType) {
            for (var i3 = 2; i3 < arguments.length; i3++) {
              validateChildKeys(arguments[i3], type3);
            }
          }
          if (type3 === REACT_FRAGMENT_TYPE) {
            validateFragmentProps(element);
          } else {
            validatePropTypes(element);
          }
          return element;
        }
        var didWarnAboutDeprecatedCreateFactory = false;
        function createFactoryWithValidation(type3) {
          var validatedFactory = createElementWithValidation.bind(null, type3);
          validatedFactory.type = type3;
          {
            if (!didWarnAboutDeprecatedCreateFactory) {
              didWarnAboutDeprecatedCreateFactory = true;
              warn("React.createFactory() is deprecated and will be removed in a future major release. Consider using JSX or use React.createElement() directly instead.");
            }
            Object.defineProperty(validatedFactory, "type", {
              enumerable: false,
              get: function() {
                warn("Factory.type is deprecated. Access the class directly before passing it to createFactory.");
                Object.defineProperty(this, "type", {
                  value: type3
                });
                return type3;
              }
            });
          }
          return validatedFactory;
        }
        function cloneElementWithValidation(element, props, children) {
          var newElement = cloneElement.apply(this, arguments);
          for (var i3 = 2; i3 < arguments.length; i3++) {
            validateChildKeys(arguments[i3], newElement.type);
          }
          validatePropTypes(newElement);
          return newElement;
        }
        {
          try {
            var frozenObject = Object.freeze({});
            var testMap = /* @__PURE__ */ new Map([[frozenObject, null]]);
            var testSet = /* @__PURE__ */ new Set([frozenObject]);
            testMap.set(0, 0);
            testSet.add(0);
          } catch (e2) {
          }
        }
        var createElement$1 = createElementWithValidation;
        var cloneElement$1 = cloneElementWithValidation;
        var createFactory = createFactoryWithValidation;
        var Children = {
          map: mapChildren,
          forEach: forEachChildren,
          count: countChildren,
          toArray: toArray2,
          only: onlyChild
        };
        exports2.Children = Children;
        exports2.Component = Component;
        exports2.Fragment = REACT_FRAGMENT_TYPE;
        exports2.Profiler = REACT_PROFILER_TYPE;
        exports2.PureComponent = PureComponent;
        exports2.StrictMode = REACT_STRICT_MODE_TYPE;
        exports2.Suspense = REACT_SUSPENSE_TYPE;
        exports2.__SECRET_INTERNALS_DO_NOT_USE_OR_YOU_WILL_BE_FIRED = ReactSharedInternals;
        exports2.cloneElement = cloneElement$1;
        exports2.createContext = createContext;
        exports2.createElement = createElement$1;
        exports2.createFactory = createFactory;
        exports2.createRef = createRef;
        exports2.forwardRef = forwardRef;
        exports2.isValidElement = isValidElement;
        exports2.lazy = lazy;
        exports2.memo = memo;
        exports2.useCallback = useCallback2;
        exports2.useContext = useContext;
        exports2.useDebugValue = useDebugValue2;
        exports2.useEffect = useEffect3;
        exports2.useImperativeHandle = useImperativeHandle;
        exports2.useLayoutEffect = useLayoutEffect2;
        exports2.useMemo = useMemo2;
        exports2.useReducer = useReducer2;
        exports2.useRef = useRef2;
        exports2.useState = useState3;
        exports2.version = ReactVersion;
      })();
    }
  }
});

// node_modules/react/index.js
var require_react = __commonJS({
  "node_modules/react/index.js"(exports2, module2) {
    "use strict";
    if (process.env.NODE_ENV === "production") {
      module2.exports = require_react_production_min();
    } else {
      module2.exports = require_react_development();
    }
  }
});

// node_modules/lodash/lodash.js
var require_lodash = __commonJS({
  "node_modules/lodash/lodash.js"(exports2, module2) {
    (function() {
      var undefined2;
      var VERSION2 = "4.17.21";
      var LARGE_ARRAY_SIZE = 200;
      var CORE_ERROR_TEXT = "Unsupported core-js use. Try https://npms.io/search?q=ponyfill.", FUNC_ERROR_TEXT = "Expected a function", INVALID_TEMPL_VAR_ERROR_TEXT = "Invalid `variable` option passed into `_.template`";
      var HASH_UNDEFINED = "__lodash_hash_undefined__";
      var MAX_MEMOIZE_SIZE = 500;
      var PLACEHOLDER = "__lodash_placeholder__";
      var CLONE_DEEP_FLAG = 1, CLONE_FLAT_FLAG = 2, CLONE_SYMBOLS_FLAG = 4;
      var COMPARE_PARTIAL_FLAG = 1, COMPARE_UNORDERED_FLAG = 2;
      var WRAP_BIND_FLAG = 1, WRAP_BIND_KEY_FLAG = 2, WRAP_CURRY_BOUND_FLAG = 4, WRAP_CURRY_FLAG = 8, WRAP_CURRY_RIGHT_FLAG = 16, WRAP_PARTIAL_FLAG = 32, WRAP_PARTIAL_RIGHT_FLAG = 64, WRAP_ARY_FLAG = 128, WRAP_REARG_FLAG = 256, WRAP_FLIP_FLAG = 512;
      var DEFAULT_TRUNC_LENGTH = 30, DEFAULT_TRUNC_OMISSION = "...";
      var HOT_COUNT = 800, HOT_SPAN = 16;
      var LAZY_FILTER_FLAG = 1, LAZY_MAP_FLAG = 2, LAZY_WHILE_FLAG = 3;
      var INFINITY = 1 / 0, MAX_SAFE_INTEGER = 9007199254740991, MAX_INTEGER = 17976931348623157e292, NAN = 0 / 0;
      var MAX_ARRAY_LENGTH = 4294967295, MAX_ARRAY_INDEX = MAX_ARRAY_LENGTH - 1, HALF_MAX_ARRAY_LENGTH = MAX_ARRAY_LENGTH >>> 1;
      var wrapFlags = [
        ["ary", WRAP_ARY_FLAG],
        ["bind", WRAP_BIND_FLAG],
        ["bindKey", WRAP_BIND_KEY_FLAG],
        ["curry", WRAP_CURRY_FLAG],
        ["curryRight", WRAP_CURRY_RIGHT_FLAG],
        ["flip", WRAP_FLIP_FLAG],
        ["partial", WRAP_PARTIAL_FLAG],
        ["partialRight", WRAP_PARTIAL_RIGHT_FLAG],
        ["rearg", WRAP_REARG_FLAG]
      ];
      var argsTag = "[object Arguments]", arrayTag = "[object Array]", asyncTag = "[object AsyncFunction]", boolTag = "[object Boolean]", dateTag = "[object Date]", domExcTag = "[object DOMException]", errorTag = "[object Error]", funcTag = "[object Function]", genTag = "[object GeneratorFunction]", mapTag = "[object Map]", numberTag = "[object Number]", nullTag = "[object Null]", objectTag = "[object Object]", promiseTag = "[object Promise]", proxyTag = "[object Proxy]", regexpTag = "[object RegExp]", setTag = "[object Set]", stringTag = "[object String]", symbolTag = "[object Symbol]", undefinedTag = "[object Undefined]", weakMapTag = "[object WeakMap]", weakSetTag = "[object WeakSet]";
      var arrayBufferTag = "[object ArrayBuffer]", dataViewTag = "[object DataView]", float32Tag = "[object Float32Array]", float64Tag = "[object Float64Array]", int8Tag = "[object Int8Array]", int16Tag = "[object Int16Array]", int32Tag = "[object Int32Array]", uint8Tag = "[object Uint8Array]", uint8ClampedTag = "[object Uint8ClampedArray]", uint16Tag = "[object Uint16Array]", uint32Tag = "[object Uint32Array]";
      var reEmptyStringLeading = /\b__p \+= '';/g, reEmptyStringMiddle = /\b(__p \+=) '' \+/g, reEmptyStringTrailing = /(__e\(.*?\)|\b__t\)) \+\n'';/g;
      var reEscapedHtml = /&(?:amp|lt|gt|quot|#39);/g, reUnescapedHtml = /[&<>"']/g, reHasEscapedHtml = RegExp(reEscapedHtml.source), reHasUnescapedHtml = RegExp(reUnescapedHtml.source);
      var reEscape = /<%-([\s\S]+?)%>/g, reEvaluate = /<%([\s\S]+?)%>/g, reInterpolate = /<%=([\s\S]+?)%>/g;
      var reIsDeepProp = /\.|\[(?:[^[\]]*|(["'])(?:(?!\1)[^\\]|\\.)*?\1)\]/, reIsPlainProp = /^\w*$/, rePropName = /[^.[\]]+|\[(?:(-?\d+(?:\.\d+)?)|(["'])((?:(?!\2)[^\\]|\\.)*?)\2)\]|(?=(?:\.|\[\])(?:\.|\[\]|$))/g;
      var reRegExpChar = /[\\^$.*+?()[\]{}|]/g, reHasRegExpChar = RegExp(reRegExpChar.source);
      var reTrimStart = /^\s+/;
      var reWhitespace = /\s/;
      var reWrapComment = /\{(?:\n\/\* \[wrapped with .+\] \*\/)?\n?/, reWrapDetails = /\{\n\/\* \[wrapped with (.+)\] \*/, reSplitDetails = /,? & /;
      var reAsciiWord = /[^\x00-\x2f\x3a-\x40\x5b-\x60\x7b-\x7f]+/g;
      var reForbiddenIdentifierChars = /[()=,{}\[\]\/\s]/;
      var reEscapeChar = /\\(\\)?/g;
      var reEsTemplate = /\$\{([^\\}]*(?:\\.[^\\}]*)*)\}/g;
      var reFlags = /\w*$/;
      var reIsBadHex = /^[-+]0x[0-9a-f]+$/i;
      var reIsBinary = /^0b[01]+$/i;
      var reIsHostCtor = /^\[object .+?Constructor\]$/;
      var reIsOctal = /^0o[0-7]+$/i;
      var reIsUint = /^(?:0|[1-9]\d*)$/;
      var reLatin = /[\xc0-\xd6\xd8-\xf6\xf8-\xff\u0100-\u017f]/g;
      var reNoMatch = /($^)/;
      var reUnescapedString = /['\n\r\u2028\u2029\\]/g;
      var rsAstralRange = "\\ud800-\\udfff", rsComboMarksRange = "\\u0300-\\u036f", reComboHalfMarksRange = "\\ufe20-\\ufe2f", rsComboSymbolsRange = "\\u20d0-\\u20ff", rsComboRange = rsComboMarksRange + reComboHalfMarksRange + rsComboSymbolsRange, rsDingbatRange = "\\u2700-\\u27bf", rsLowerRange = "a-z\\xdf-\\xf6\\xf8-\\xff", rsMathOpRange = "\\xac\\xb1\\xd7\\xf7", rsNonCharRange = "\\x00-\\x2f\\x3a-\\x40\\x5b-\\x60\\x7b-\\xbf", rsPunctuationRange = "\\u2000-\\u206f", rsSpaceRange = " \\t\\x0b\\f\\xa0\\ufeff\\n\\r\\u2028\\u2029\\u1680\\u180e\\u2000\\u2001\\u2002\\u2003\\u2004\\u2005\\u2006\\u2007\\u2008\\u2009\\u200a\\u202f\\u205f\\u3000", rsUpperRange = "A-Z\\xc0-\\xd6\\xd8-\\xde", rsVarRange = "\\ufe0e\\ufe0f", rsBreakRange = rsMathOpRange + rsNonCharRange + rsPunctuationRange + rsSpaceRange;
      var rsApos = "['\u2019]", rsAstral = "[" + rsAstralRange + "]", rsBreak = "[" + rsBreakRange + "]", rsCombo = "[" + rsComboRange + "]", rsDigits = "\\d+", rsDingbat = "[" + rsDingbatRange + "]", rsLower = "[" + rsLowerRange + "]", rsMisc = "[^" + rsAstralRange + rsBreakRange + rsDigits + rsDingbatRange + rsLowerRange + rsUpperRange + "]", rsFitz = "\\ud83c[\\udffb-\\udfff]", rsModifier = "(?:" + rsCombo + "|" + rsFitz + ")", rsNonAstral = "[^" + rsAstralRange + "]", rsRegional = "(?:\\ud83c[\\udde6-\\uddff]){2}", rsSurrPair = "[\\ud800-\\udbff][\\udc00-\\udfff]", rsUpper = "[" + rsUpperRange + "]", rsZWJ = "\\u200d";
      var rsMiscLower = "(?:" + rsLower + "|" + rsMisc + ")", rsMiscUpper = "(?:" + rsUpper + "|" + rsMisc + ")", rsOptContrLower = "(?:" + rsApos + "(?:d|ll|m|re|s|t|ve))?", rsOptContrUpper = "(?:" + rsApos + "(?:D|LL|M|RE|S|T|VE))?", reOptMod = rsModifier + "?", rsOptVar = "[" + rsVarRange + "]?", rsOptJoin = "(?:" + rsZWJ + "(?:" + [rsNonAstral, rsRegional, rsSurrPair].join("|") + ")" + rsOptVar + reOptMod + ")*", rsOrdLower = "\\d*(?:1st|2nd|3rd|(?![123])\\dth)(?=\\b|[A-Z_])", rsOrdUpper = "\\d*(?:1ST|2ND|3RD|(?![123])\\dTH)(?=\\b|[a-z_])", rsSeq = rsOptVar + reOptMod + rsOptJoin, rsEmoji = "(?:" + [rsDingbat, rsRegional, rsSurrPair].join("|") + ")" + rsSeq, rsSymbol = "(?:" + [rsNonAstral + rsCombo + "?", rsCombo, rsRegional, rsSurrPair, rsAstral].join("|") + ")";
      var reApos = RegExp(rsApos, "g");
      var reComboMark = RegExp(rsCombo, "g");
      var reUnicode = RegExp(rsFitz + "(?=" + rsFitz + ")|" + rsSymbol + rsSeq, "g");
      var reUnicodeWord = RegExp([
        rsUpper + "?" + rsLower + "+" + rsOptContrLower + "(?=" + [rsBreak, rsUpper, "$"].join("|") + ")",
        rsMiscUpper + "+" + rsOptContrUpper + "(?=" + [rsBreak, rsUpper + rsMiscLower, "$"].join("|") + ")",
        rsUpper + "?" + rsMiscLower + "+" + rsOptContrLower,
        rsUpper + "+" + rsOptContrUpper,
        rsOrdUpper,
        rsOrdLower,
        rsDigits,
        rsEmoji
      ].join("|"), "g");
      var reHasUnicode = RegExp("[" + rsZWJ + rsAstralRange + rsComboRange + rsVarRange + "]");
      var reHasUnicodeWord = /[a-z][A-Z]|[A-Z]{2}[a-z]|[0-9][a-zA-Z]|[a-zA-Z][0-9]|[^a-zA-Z0-9 ]/;
      var contextProps = [
        "Array",
        "Buffer",
        "DataView",
        "Date",
        "Error",
        "Float32Array",
        "Float64Array",
        "Function",
        "Int8Array",
        "Int16Array",
        "Int32Array",
        "Map",
        "Math",
        "Object",
        "Promise",
        "RegExp",
        "Set",
        "String",
        "Symbol",
        "TypeError",
        "Uint8Array",
        "Uint8ClampedArray",
        "Uint16Array",
        "Uint32Array",
        "WeakMap",
        "_",
        "clearTimeout",
        "isFinite",
        "parseInt",
        "setTimeout"
      ];
      var templateCounter = -1;
      var typedArrayTags = {};
      typedArrayTags[float32Tag] = typedArrayTags[float64Tag] = typedArrayTags[int8Tag] = typedArrayTags[int16Tag] = typedArrayTags[int32Tag] = typedArrayTags[uint8Tag] = typedArrayTags[uint8ClampedTag] = typedArrayTags[uint16Tag] = typedArrayTags[uint32Tag] = true;
      typedArrayTags[argsTag] = typedArrayTags[arrayTag] = typedArrayTags[arrayBufferTag] = typedArrayTags[boolTag] = typedArrayTags[dataViewTag] = typedArrayTags[dateTag] = typedArrayTags[errorTag] = typedArrayTags[funcTag] = typedArrayTags[mapTag] = typedArrayTags[numberTag] = typedArrayTags[objectTag] = typedArrayTags[regexpTag] = typedArrayTags[setTag] = typedArrayTags[stringTag] = typedArrayTags[weakMapTag] = false;
      var cloneableTags = {};
      cloneableTags[argsTag] = cloneableTags[arrayTag] = cloneableTags[arrayBufferTag] = cloneableTags[dataViewTag] = cloneableTags[boolTag] = cloneableTags[dateTag] = cloneableTags[float32Tag] = cloneableTags[float64Tag] = cloneableTags[int8Tag] = cloneableTags[int16Tag] = cloneableTags[int32Tag] = cloneableTags[mapTag] = cloneableTags[numberTag] = cloneableTags[objectTag] = cloneableTags[regexpTag] = cloneableTags[setTag] = cloneableTags[stringTag] = cloneableTags[symbolTag] = cloneableTags[uint8Tag] = cloneableTags[uint8ClampedTag] = cloneableTags[uint16Tag] = cloneableTags[uint32Tag] = true;
      cloneableTags[errorTag] = cloneableTags[funcTag] = cloneableTags[weakMapTag] = false;
      var deburredLetters = {
        "\xC0": "A",
        "\xC1": "A",
        "\xC2": "A",
        "\xC3": "A",
        "\xC4": "A",
        "\xC5": "A",
        "\xE0": "a",
        "\xE1": "a",
        "\xE2": "a",
        "\xE3": "a",
        "\xE4": "a",
        "\xE5": "a",
        "\xC7": "C",
        "\xE7": "c",
        "\xD0": "D",
        "\xF0": "d",
        "\xC8": "E",
        "\xC9": "E",
        "\xCA": "E",
        "\xCB": "E",
        "\xE8": "e",
        "\xE9": "e",
        "\xEA": "e",
        "\xEB": "e",
        "\xCC": "I",
        "\xCD": "I",
        "\xCE": "I",
        "\xCF": "I",
        "\xEC": "i",
        "\xED": "i",
        "\xEE": "i",
        "\xEF": "i",
        "\xD1": "N",
        "\xF1": "n",
        "\xD2": "O",
        "\xD3": "O",
        "\xD4": "O",
        "\xD5": "O",
        "\xD6": "O",
        "\xD8": "O",
        "\xF2": "o",
        "\xF3": "o",
        "\xF4": "o",
        "\xF5": "o",
        "\xF6": "o",
        "\xF8": "o",
        "\xD9": "U",
        "\xDA": "U",
        "\xDB": "U",
        "\xDC": "U",
        "\xF9": "u",
        "\xFA": "u",
        "\xFB": "u",
        "\xFC": "u",
        "\xDD": "Y",
        "\xFD": "y",
        "\xFF": "y",
        "\xC6": "Ae",
        "\xE6": "ae",
        "\xDE": "Th",
        "\xFE": "th",
        "\xDF": "ss",
        "\u0100": "A",
        "\u0102": "A",
        "\u0104": "A",
        "\u0101": "a",
        "\u0103": "a",
        "\u0105": "a",
        "\u0106": "C",
        "\u0108": "C",
        "\u010A": "C",
        "\u010C": "C",
        "\u0107": "c",
        "\u0109": "c",
        "\u010B": "c",
        "\u010D": "c",
        "\u010E": "D",
        "\u0110": "D",
        "\u010F": "d",
        "\u0111": "d",
        "\u0112": "E",
        "\u0114": "E",
        "\u0116": "E",
        "\u0118": "E",
        "\u011A": "E",
        "\u0113": "e",
        "\u0115": "e",
        "\u0117": "e",
        "\u0119": "e",
        "\u011B": "e",
        "\u011C": "G",
        "\u011E": "G",
        "\u0120": "G",
        "\u0122": "G",
        "\u011D": "g",
        "\u011F": "g",
        "\u0121": "g",
        "\u0123": "g",
        "\u0124": "H",
        "\u0126": "H",
        "\u0125": "h",
        "\u0127": "h",
        "\u0128": "I",
        "\u012A": "I",
        "\u012C": "I",
        "\u012E": "I",
        "\u0130": "I",
        "\u0129": "i",
        "\u012B": "i",
        "\u012D": "i",
        "\u012F": "i",
        "\u0131": "i",
        "\u0134": "J",
        "\u0135": "j",
        "\u0136": "K",
        "\u0137": "k",
        "\u0138": "k",
        "\u0139": "L",
        "\u013B": "L",
        "\u013D": "L",
        "\u013F": "L",
        "\u0141": "L",
        "\u013A": "l",
        "\u013C": "l",
        "\u013E": "l",
        "\u0140": "l",
        "\u0142": "l",
        "\u0143": "N",
        "\u0145": "N",
        "\u0147": "N",
        "\u014A": "N",
        "\u0144": "n",
        "\u0146": "n",
        "\u0148": "n",
        "\u014B": "n",
        "\u014C": "O",
        "\u014E": "O",
        "\u0150": "O",
        "\u014D": "o",
        "\u014F": "o",
        "\u0151": "o",
        "\u0154": "R",
        "\u0156": "R",
        "\u0158": "R",
        "\u0155": "r",
        "\u0157": "r",
        "\u0159": "r",
        "\u015A": "S",
        "\u015C": "S",
        "\u015E": "S",
        "\u0160": "S",
        "\u015B": "s",
        "\u015D": "s",
        "\u015F": "s",
        "\u0161": "s",
        "\u0162": "T",
        "\u0164": "T",
        "\u0166": "T",
        "\u0163": "t",
        "\u0165": "t",
        "\u0167": "t",
        "\u0168": "U",
        "\u016A": "U",
        "\u016C": "U",
        "\u016E": "U",
        "\u0170": "U",
        "\u0172": "U",
        "\u0169": "u",
        "\u016B": "u",
        "\u016D": "u",
        "\u016F": "u",
        "\u0171": "u",
        "\u0173": "u",
        "\u0174": "W",
        "\u0175": "w",
        "\u0176": "Y",
        "\u0177": "y",
        "\u0178": "Y",
        "\u0179": "Z",
        "\u017B": "Z",
        "\u017D": "Z",
        "\u017A": "z",
        "\u017C": "z",
        "\u017E": "z",
        "\u0132": "IJ",
        "\u0133": "ij",
        "\u0152": "Oe",
        "\u0153": "oe",
        "\u0149": "'n",
        "\u017F": "s"
      };
      var htmlEscapes = {
        "&": "&amp;",
        "<": "&lt;",
        ">": "&gt;",
        '"': "&quot;",
        "'": "&#39;"
      };
      var htmlUnescapes = {
        "&amp;": "&",
        "&lt;": "<",
        "&gt;": ">",
        "&quot;": '"',
        "&#39;": "'"
      };
      var stringEscapes = {
        "\\": "\\",
        "'": "'",
        "\n": "n",
        "\r": "r",
        "\u2028": "u2028",
        "\u2029": "u2029"
      };
      var freeParseFloat = parseFloat, freeParseInt = parseInt;
      var freeGlobal = typeof global == "object" && global && global.Object === Object && global;
      var freeSelf = typeof self == "object" && self && self.Object === Object && self;
      var root = freeGlobal || freeSelf || Function("return this")();
      var freeExports = typeof exports2 == "object" && exports2 && !exports2.nodeType && exports2;
      var freeModule = freeExports && typeof module2 == "object" && module2 && !module2.nodeType && module2;
      var moduleExports = freeModule && freeModule.exports === freeExports;
      var freeProcess = moduleExports && freeGlobal.process;
      var nodeUtil = function() {
        try {
          var types2 = freeModule && freeModule.require && freeModule.require("util").types;
          if (types2) {
            return types2;
          }
          return freeProcess && freeProcess.binding && freeProcess.binding("util");
        } catch (e2) {
        }
      }();
      var nodeIsArrayBuffer = nodeUtil && nodeUtil.isArrayBuffer, nodeIsDate = nodeUtil && nodeUtil.isDate, nodeIsMap = nodeUtil && nodeUtil.isMap, nodeIsRegExp = nodeUtil && nodeUtil.isRegExp, nodeIsSet = nodeUtil && nodeUtil.isSet, nodeIsTypedArray = nodeUtil && nodeUtil.isTypedArray;
      function apply(func2, thisArg, args) {
        switch (args.length) {
          case 0:
            return func2.call(thisArg);
          case 1:
            return func2.call(thisArg, args[0]);
          case 2:
            return func2.call(thisArg, args[0], args[1]);
          case 3:
            return func2.call(thisArg, args[0], args[1], args[2]);
        }
        return func2.apply(thisArg, args);
      }
      function arrayAggregator(array, setter, iteratee, accumulator) {
        var index = -1, length = array == null ? 0 : array.length;
        while (++index < length) {
          var value = array[index];
          setter(accumulator, value, iteratee(value), array);
        }
        return accumulator;
      }
      function arrayEach(array, iteratee) {
        var index = -1, length = array == null ? 0 : array.length;
        while (++index < length) {
          if (iteratee(array[index], index, array) === false) {
            break;
          }
        }
        return array;
      }
      function arrayEachRight(array, iteratee) {
        var length = array == null ? 0 : array.length;
        while (length--) {
          if (iteratee(array[length], length, array) === false) {
            break;
          }
        }
        return array;
      }
      function arrayEvery(array, predicate) {
        var index = -1, length = array == null ? 0 : array.length;
        while (++index < length) {
          if (!predicate(array[index], index, array)) {
            return false;
          }
        }
        return true;
      }
      function arrayFilter(array, predicate) {
        var index = -1, length = array == null ? 0 : array.length, resIndex = 0, result2 = [];
        while (++index < length) {
          var value = array[index];
          if (predicate(value, index, array)) {
            result2[resIndex++] = value;
          }
        }
        return result2;
      }
      function arrayIncludes(array, value) {
        var length = array == null ? 0 : array.length;
        return !!length && baseIndexOf(array, value, 0) > -1;
      }
      function arrayIncludesWith(array, value, comparator) {
        var index = -1, length = array == null ? 0 : array.length;
        while (++index < length) {
          if (comparator(value, array[index])) {
            return true;
          }
        }
        return false;
      }
      function arrayMap(array, iteratee) {
        var index = -1, length = array == null ? 0 : array.length, result2 = Array(length);
        while (++index < length) {
          result2[index] = iteratee(array[index], index, array);
        }
        return result2;
      }
      function arrayPush(array, values) {
        var index = -1, length = values.length, offset = array.length;
        while (++index < length) {
          array[offset + index] = values[index];
        }
        return array;
      }
      function arrayReduce(array, iteratee, accumulator, initAccum) {
        var index = -1, length = array == null ? 0 : array.length;
        if (initAccum && length) {
          accumulator = array[++index];
        }
        while (++index < length) {
          accumulator = iteratee(accumulator, array[index], index, array);
        }
        return accumulator;
      }
      function arrayReduceRight(array, iteratee, accumulator, initAccum) {
        var length = array == null ? 0 : array.length;
        if (initAccum && length) {
          accumulator = array[--length];
        }
        while (length--) {
          accumulator = iteratee(accumulator, array[length], length, array);
        }
        return accumulator;
      }
      function arraySome(array, predicate) {
        var index = -1, length = array == null ? 0 : array.length;
        while (++index < length) {
          if (predicate(array[index], index, array)) {
            return true;
          }
        }
        return false;
      }
      var asciiSize = baseProperty("length");
      function asciiToArray(string) {
        return string.split("");
      }
      function asciiWords(string) {
        return string.match(reAsciiWord) || [];
      }
      function baseFindKey(collection, predicate, eachFunc) {
        var result2;
        eachFunc(collection, function(value, key2, collection2) {
          if (predicate(value, key2, collection2)) {
            result2 = key2;
            return false;
          }
        });
        return result2;
      }
      function baseFindIndex(array, predicate, fromIndex, fromRight) {
        var length = array.length, index = fromIndex + (fromRight ? 1 : -1);
        while (fromRight ? index-- : ++index < length) {
          if (predicate(array[index], index, array)) {
            return index;
          }
        }
        return -1;
      }
      function baseIndexOf(array, value, fromIndex) {
        return value === value ? strictIndexOf(array, value, fromIndex) : baseFindIndex(array, baseIsNaN, fromIndex);
      }
      function baseIndexOfWith(array, value, fromIndex, comparator) {
        var index = fromIndex - 1, length = array.length;
        while (++index < length) {
          if (comparator(array[index], value)) {
            return index;
          }
        }
        return -1;
      }
      function baseIsNaN(value) {
        return value !== value;
      }
      function baseMean(array, iteratee) {
        var length = array == null ? 0 : array.length;
        return length ? baseSum(array, iteratee) / length : NAN;
      }
      function baseProperty(key2) {
        return function(object) {
          return object == null ? undefined2 : object[key2];
        };
      }
      function basePropertyOf(object) {
        return function(key2) {
          return object == null ? undefined2 : object[key2];
        };
      }
      function baseReduce(collection, iteratee, accumulator, initAccum, eachFunc) {
        eachFunc(collection, function(value, index, collection2) {
          accumulator = initAccum ? (initAccum = false, value) : iteratee(accumulator, value, index, collection2);
        });
        return accumulator;
      }
      function baseSortBy(array, comparer) {
        var length = array.length;
        array.sort(comparer);
        while (length--) {
          array[length] = array[length].value;
        }
        return array;
      }
      function baseSum(array, iteratee) {
        var result2, index = -1, length = array.length;
        while (++index < length) {
          var current = iteratee(array[index]);
          if (current !== undefined2) {
            result2 = result2 === undefined2 ? current : result2 + current;
          }
        }
        return result2;
      }
      function baseTimes(n2, iteratee) {
        var index = -1, result2 = Array(n2);
        while (++index < n2) {
          result2[index] = iteratee(index);
        }
        return result2;
      }
      function baseToPairs(object, props) {
        return arrayMap(props, function(key2) {
          return [key2, object[key2]];
        });
      }
      function baseTrim(string) {
        return string ? string.slice(0, trimmedEndIndex(string) + 1).replace(reTrimStart, "") : string;
      }
      function baseUnary(func2) {
        return function(value) {
          return func2(value);
        };
      }
      function baseValues(object, props) {
        return arrayMap(props, function(key2) {
          return object[key2];
        });
      }
      function cacheHas(cache, key2) {
        return cache.has(key2);
      }
      function charsStartIndex(strSymbols, chrSymbols) {
        var index = -1, length = strSymbols.length;
        while (++index < length && baseIndexOf(chrSymbols, strSymbols[index], 0) > -1) {
        }
        return index;
      }
      function charsEndIndex(strSymbols, chrSymbols) {
        var index = strSymbols.length;
        while (index-- && baseIndexOf(chrSymbols, strSymbols[index], 0) > -1) {
        }
        return index;
      }
      function countHolders(array, placeholder) {
        var length = array.length, result2 = 0;
        while (length--) {
          if (array[length] === placeholder) {
            ++result2;
          }
        }
        return result2;
      }
      var deburrLetter = basePropertyOf(deburredLetters);
      var escapeHtmlChar = basePropertyOf(htmlEscapes);
      function escapeStringChar(chr) {
        return "\\" + stringEscapes[chr];
      }
      function getValue2(object, key2) {
        return object == null ? undefined2 : object[key2];
      }
      function hasUnicode(string) {
        return reHasUnicode.test(string);
      }
      function hasUnicodeWord(string) {
        return reHasUnicodeWord.test(string);
      }
      function iteratorToArray(iterator) {
        var data, result2 = [];
        while (!(data = iterator.next()).done) {
          result2.push(data.value);
        }
        return result2;
      }
      function mapToArray(map2) {
        var index = -1, result2 = Array(map2.size);
        map2.forEach(function(value, key2) {
          result2[++index] = [key2, value];
        });
        return result2;
      }
      function overArg(func2, transform) {
        return function(arg2) {
          return func2(transform(arg2));
        };
      }
      function replaceHolders(array, placeholder) {
        var index = -1, length = array.length, resIndex = 0, result2 = [];
        while (++index < length) {
          var value = array[index];
          if (value === placeholder || value === PLACEHOLDER) {
            array[index] = PLACEHOLDER;
            result2[resIndex++] = index;
          }
        }
        return result2;
      }
      function setToArray(set2) {
        var index = -1, result2 = Array(set2.size);
        set2.forEach(function(value) {
          result2[++index] = value;
        });
        return result2;
      }
      function setToPairs(set2) {
        var index = -1, result2 = Array(set2.size);
        set2.forEach(function(value) {
          result2[++index] = [value, value];
        });
        return result2;
      }
      function strictIndexOf(array, value, fromIndex) {
        var index = fromIndex - 1, length = array.length;
        while (++index < length) {
          if (array[index] === value) {
            return index;
          }
        }
        return -1;
      }
      function strictLastIndexOf(array, value, fromIndex) {
        var index = fromIndex + 1;
        while (index--) {
          if (array[index] === value) {
            return index;
          }
        }
        return index;
      }
      function stringSize(string) {
        return hasUnicode(string) ? unicodeSize(string) : asciiSize(string);
      }
      function stringToArray(string) {
        return hasUnicode(string) ? unicodeToArray(string) : asciiToArray(string);
      }
      function trimmedEndIndex(string) {
        var index = string.length;
        while (index-- && reWhitespace.test(string.charAt(index))) {
        }
        return index;
      }
      var unescapeHtmlChar = basePropertyOf(htmlUnescapes);
      function unicodeSize(string) {
        var result2 = reUnicode.lastIndex = 0;
        while (reUnicode.test(string)) {
          ++result2;
        }
        return result2;
      }
      function unicodeToArray(string) {
        return string.match(reUnicode) || [];
      }
      function unicodeWords(string) {
        return string.match(reUnicodeWord) || [];
      }
      var runInContext = function runInContext2(context) {
        context = context == null ? root : _.defaults(root.Object(), context, _.pick(root, contextProps));
        var Array2 = context.Array, Date2 = context.Date, Error2 = context.Error, Function2 = context.Function, Math2 = context.Math, Object2 = context.Object, RegExp2 = context.RegExp, String2 = context.String, TypeError2 = context.TypeError;
        var arrayProto = Array2.prototype, funcProto = Function2.prototype, objectProto = Object2.prototype;
        var coreJsData = context["__core-js_shared__"];
        var funcToString = funcProto.toString;
        var hasOwnProperty2 = objectProto.hasOwnProperty;
        var idCounter = 0;
        var maskSrcKey = function() {
          var uid = /[^.]+$/.exec(coreJsData && coreJsData.keys && coreJsData.keys.IE_PROTO || "");
          return uid ? "Symbol(src)_1." + uid : "";
        }();
        var nativeObjectToString = objectProto.toString;
        var objectCtorString = funcToString.call(Object2);
        var oldDash = root._;
        var reIsNative = RegExp2("^" + funcToString.call(hasOwnProperty2).replace(reRegExpChar, "\\$&").replace(/hasOwnProperty|(function).*?(?=\\\()| for .+?(?=\\\])/g, "$1.*?") + "$");
        var Buffer2 = moduleExports ? context.Buffer : undefined2, Symbol2 = context.Symbol, Uint8Array2 = context.Uint8Array, allocUnsafe = Buffer2 ? Buffer2.allocUnsafe : undefined2, getPrototype = overArg(Object2.getPrototypeOf, Object2), objectCreate = Object2.create, propertyIsEnumerable = objectProto.propertyIsEnumerable, splice = arrayProto.splice, spreadableSymbol = Symbol2 ? Symbol2.isConcatSpreadable : undefined2, symIterator = Symbol2 ? Symbol2.iterator : undefined2, symToStringTag = Symbol2 ? Symbol2.toStringTag : undefined2;
        var defineProperty = function() {
          try {
            var func2 = getNative(Object2, "defineProperty");
            func2({}, "", {});
            return func2;
          } catch (e2) {
          }
        }();
        var ctxClearTimeout = context.clearTimeout !== root.clearTimeout && context.clearTimeout, ctxNow = Date2 && Date2.now !== root.Date.now && Date2.now, ctxSetTimeout = context.setTimeout !== root.setTimeout && context.setTimeout;
        var nativeCeil = Math2.ceil, nativeFloor = Math2.floor, nativeGetSymbols = Object2.getOwnPropertySymbols, nativeIsBuffer = Buffer2 ? Buffer2.isBuffer : undefined2, nativeIsFinite = context.isFinite, nativeJoin = arrayProto.join, nativeKeys = overArg(Object2.keys, Object2), nativeMax = Math2.max, nativeMin = Math2.min, nativeNow = Date2.now, nativeParseInt = context.parseInt, nativeRandom = Math2.random, nativeReverse = arrayProto.reverse;
        var DataView2 = getNative(context, "DataView"), Map2 = getNative(context, "Map"), Promise2 = getNative(context, "Promise"), Set2 = getNative(context, "Set"), WeakMap2 = getNative(context, "WeakMap"), nativeCreate = getNative(Object2, "create");
        var metaMap = WeakMap2 && new WeakMap2();
        var realNames = {};
        var dataViewCtorString = toSource(DataView2), mapCtorString = toSource(Map2), promiseCtorString = toSource(Promise2), setCtorString = toSource(Set2), weakMapCtorString = toSource(WeakMap2);
        var symbolProto = Symbol2 ? Symbol2.prototype : undefined2, symbolValueOf = symbolProto ? symbolProto.valueOf : undefined2, symbolToString = symbolProto ? symbolProto.toString : undefined2;
        function lodash(value) {
          if (isObjectLike(value) && !isArray(value) && !(value instanceof LazyWrapper)) {
            if (value instanceof LodashWrapper) {
              return value;
            }
            if (hasOwnProperty2.call(value, "__wrapped__")) {
              return wrapperClone(value);
            }
          }
          return new LodashWrapper(value);
        }
        var baseCreate = function() {
          function object() {
          }
          return function(proto) {
            if (!isObject2(proto)) {
              return {};
            }
            if (objectCreate) {
              return objectCreate(proto);
            }
            object.prototype = proto;
            var result3 = new object();
            object.prototype = undefined2;
            return result3;
          };
        }();
        function baseLodash() {
        }
        function LodashWrapper(value, chainAll) {
          this.__wrapped__ = value;
          this.__actions__ = [];
          this.__chain__ = !!chainAll;
          this.__index__ = 0;
          this.__values__ = undefined2;
        }
        lodash.templateSettings = {
          "escape": reEscape,
          "evaluate": reEvaluate,
          "interpolate": reInterpolate,
          "variable": "",
          "imports": {
            "_": lodash
          }
        };
        lodash.prototype = baseLodash.prototype;
        lodash.prototype.constructor = lodash;
        LodashWrapper.prototype = baseCreate(baseLodash.prototype);
        LodashWrapper.prototype.constructor = LodashWrapper;
        function LazyWrapper(value) {
          this.__wrapped__ = value;
          this.__actions__ = [];
          this.__dir__ = 1;
          this.__filtered__ = false;
          this.__iteratees__ = [];
          this.__takeCount__ = MAX_ARRAY_LENGTH;
          this.__views__ = [];
        }
        function lazyClone() {
          var result3 = new LazyWrapper(this.__wrapped__);
          result3.__actions__ = copyArray(this.__actions__);
          result3.__dir__ = this.__dir__;
          result3.__filtered__ = this.__filtered__;
          result3.__iteratees__ = copyArray(this.__iteratees__);
          result3.__takeCount__ = this.__takeCount__;
          result3.__views__ = copyArray(this.__views__);
          return result3;
        }
        function lazyReverse() {
          if (this.__filtered__) {
            var result3 = new LazyWrapper(this);
            result3.__dir__ = -1;
            result3.__filtered__ = true;
          } else {
            result3 = this.clone();
            result3.__dir__ *= -1;
          }
          return result3;
        }
        function lazyValue() {
          var array = this.__wrapped__.value(), dir = this.__dir__, isArr = isArray(array), isRight = dir < 0, arrLength = isArr ? array.length : 0, view = getView(0, arrLength, this.__views__), start = view.start, end = view.end, length = end - start, index = isRight ? end : start - 1, iteratees = this.__iteratees__, iterLength = iteratees.length, resIndex = 0, takeCount = nativeMin(length, this.__takeCount__);
          if (!isArr || !isRight && arrLength == length && takeCount == length) {
            return baseWrapperValue(array, this.__actions__);
          }
          var result3 = [];
          outer:
            while (length-- && resIndex < takeCount) {
              index += dir;
              var iterIndex = -1, value = array[index];
              while (++iterIndex < iterLength) {
                var data = iteratees[iterIndex], iteratee2 = data.iteratee, type3 = data.type, computed = iteratee2(value);
                if (type3 == LAZY_MAP_FLAG) {
                  value = computed;
                } else if (!computed) {
                  if (type3 == LAZY_FILTER_FLAG) {
                    continue outer;
                  } else {
                    break outer;
                  }
                }
              }
              result3[resIndex++] = value;
            }
          return result3;
        }
        LazyWrapper.prototype = baseCreate(baseLodash.prototype);
        LazyWrapper.prototype.constructor = LazyWrapper;
        function Hash(entries) {
          var index = -1, length = entries == null ? 0 : entries.length;
          this.clear();
          while (++index < length) {
            var entry = entries[index];
            this.set(entry[0], entry[1]);
          }
        }
        function hashClear() {
          this.__data__ = nativeCreate ? nativeCreate(null) : {};
          this.size = 0;
        }
        function hashDelete(key2) {
          var result3 = this.has(key2) && delete this.__data__[key2];
          this.size -= result3 ? 1 : 0;
          return result3;
        }
        function hashGet(key2) {
          var data = this.__data__;
          if (nativeCreate) {
            var result3 = data[key2];
            return result3 === HASH_UNDEFINED ? undefined2 : result3;
          }
          return hasOwnProperty2.call(data, key2) ? data[key2] : undefined2;
        }
        function hashHas(key2) {
          var data = this.__data__;
          return nativeCreate ? data[key2] !== undefined2 : hasOwnProperty2.call(data, key2);
        }
        function hashSet(key2, value) {
          var data = this.__data__;
          this.size += this.has(key2) ? 0 : 1;
          data[key2] = nativeCreate && value === undefined2 ? HASH_UNDEFINED : value;
          return this;
        }
        Hash.prototype.clear = hashClear;
        Hash.prototype["delete"] = hashDelete;
        Hash.prototype.get = hashGet;
        Hash.prototype.has = hashHas;
        Hash.prototype.set = hashSet;
        function ListCache(entries) {
          var index = -1, length = entries == null ? 0 : entries.length;
          this.clear();
          while (++index < length) {
            var entry = entries[index];
            this.set(entry[0], entry[1]);
          }
        }
        function listCacheClear() {
          this.__data__ = [];
          this.size = 0;
        }
        function listCacheDelete(key2) {
          var data = this.__data__, index = assocIndexOf(data, key2);
          if (index < 0) {
            return false;
          }
          var lastIndex = data.length - 1;
          if (index == lastIndex) {
            data.pop();
          } else {
            splice.call(data, index, 1);
          }
          --this.size;
          return true;
        }
        function listCacheGet(key2) {
          var data = this.__data__, index = assocIndexOf(data, key2);
          return index < 0 ? undefined2 : data[index][1];
        }
        function listCacheHas(key2) {
          return assocIndexOf(this.__data__, key2) > -1;
        }
        function listCacheSet(key2, value) {
          var data = this.__data__, index = assocIndexOf(data, key2);
          if (index < 0) {
            ++this.size;
            data.push([key2, value]);
          } else {
            data[index][1] = value;
          }
          return this;
        }
        ListCache.prototype.clear = listCacheClear;
        ListCache.prototype["delete"] = listCacheDelete;
        ListCache.prototype.get = listCacheGet;
        ListCache.prototype.has = listCacheHas;
        ListCache.prototype.set = listCacheSet;
        function MapCache(entries) {
          var index = -1, length = entries == null ? 0 : entries.length;
          this.clear();
          while (++index < length) {
            var entry = entries[index];
            this.set(entry[0], entry[1]);
          }
        }
        function mapCacheClear() {
          this.size = 0;
          this.__data__ = {
            "hash": new Hash(),
            "map": new (Map2 || ListCache)(),
            "string": new Hash()
          };
        }
        function mapCacheDelete(key2) {
          var result3 = getMapData(this, key2)["delete"](key2);
          this.size -= result3 ? 1 : 0;
          return result3;
        }
        function mapCacheGet(key2) {
          return getMapData(this, key2).get(key2);
        }
        function mapCacheHas(key2) {
          return getMapData(this, key2).has(key2);
        }
        function mapCacheSet(key2, value) {
          var data = getMapData(this, key2), size2 = data.size;
          data.set(key2, value);
          this.size += data.size == size2 ? 0 : 1;
          return this;
        }
        MapCache.prototype.clear = mapCacheClear;
        MapCache.prototype["delete"] = mapCacheDelete;
        MapCache.prototype.get = mapCacheGet;
        MapCache.prototype.has = mapCacheHas;
        MapCache.prototype.set = mapCacheSet;
        function SetCache(values2) {
          var index = -1, length = values2 == null ? 0 : values2.length;
          this.__data__ = new MapCache();
          while (++index < length) {
            this.add(values2[index]);
          }
        }
        function setCacheAdd(value) {
          this.__data__.set(value, HASH_UNDEFINED);
          return this;
        }
        function setCacheHas(value) {
          return this.__data__.has(value);
        }
        SetCache.prototype.add = SetCache.prototype.push = setCacheAdd;
        SetCache.prototype.has = setCacheHas;
        function Stack(entries) {
          var data = this.__data__ = new ListCache(entries);
          this.size = data.size;
        }
        function stackClear() {
          this.__data__ = new ListCache();
          this.size = 0;
        }
        function stackDelete(key2) {
          var data = this.__data__, result3 = data["delete"](key2);
          this.size = data.size;
          return result3;
        }
        function stackGet(key2) {
          return this.__data__.get(key2);
        }
        function stackHas(key2) {
          return this.__data__.has(key2);
        }
        function stackSet(key2, value) {
          var data = this.__data__;
          if (data instanceof ListCache) {
            var pairs2 = data.__data__;
            if (!Map2 || pairs2.length < LARGE_ARRAY_SIZE - 1) {
              pairs2.push([key2, value]);
              this.size = ++data.size;
              return this;
            }
            data = this.__data__ = new MapCache(pairs2);
          }
          data.set(key2, value);
          this.size = data.size;
          return this;
        }
        Stack.prototype.clear = stackClear;
        Stack.prototype["delete"] = stackDelete;
        Stack.prototype.get = stackGet;
        Stack.prototype.has = stackHas;
        Stack.prototype.set = stackSet;
        function arrayLikeKeys(value, inherited) {
          var isArr = isArray(value), isArg = !isArr && isArguments(value), isBuff = !isArr && !isArg && isBuffer(value), isType = !isArr && !isArg && !isBuff && isTypedArray(value), skipIndexes = isArr || isArg || isBuff || isType, result3 = skipIndexes ? baseTimes(value.length, String2) : [], length = result3.length;
          for (var key2 in value) {
            if ((inherited || hasOwnProperty2.call(value, key2)) && !(skipIndexes && (key2 == "length" || isBuff && (key2 == "offset" || key2 == "parent") || isType && (key2 == "buffer" || key2 == "byteLength" || key2 == "byteOffset") || isIndex(key2, length)))) {
              result3.push(key2);
            }
          }
          return result3;
        }
        function arraySample(array) {
          var length = array.length;
          return length ? array[baseRandom(0, length - 1)] : undefined2;
        }
        function arraySampleSize(array, n2) {
          return shuffleSelf(copyArray(array), baseClamp(n2, 0, array.length));
        }
        function arrayShuffle(array) {
          return shuffleSelf(copyArray(array));
        }
        function assignMergeValue(object, key2, value) {
          if (value !== undefined2 && !eq(object[key2], value) || value === undefined2 && !(key2 in object)) {
            baseAssignValue(object, key2, value);
          }
        }
        function assignValue(object, key2, value) {
          var objValue = object[key2];
          if (!(hasOwnProperty2.call(object, key2) && eq(objValue, value)) || value === undefined2 && !(key2 in object)) {
            baseAssignValue(object, key2, value);
          }
        }
        function assocIndexOf(array, key2) {
          var length = array.length;
          while (length--) {
            if (eq(array[length][0], key2)) {
              return length;
            }
          }
          return -1;
        }
        function baseAggregator(collection, setter, iteratee2, accumulator) {
          baseEach(collection, function(value, key2, collection2) {
            setter(accumulator, value, iteratee2(value), collection2);
          });
          return accumulator;
        }
        function baseAssign(object, source) {
          return object && copyObject(source, keys(source), object);
        }
        function baseAssignIn(object, source) {
          return object && copyObject(source, keysIn(source), object);
        }
        function baseAssignValue(object, key2, value) {
          if (key2 == "__proto__" && defineProperty) {
            defineProperty(object, key2, {
              "configurable": true,
              "enumerable": true,
              "value": value,
              "writable": true
            });
          } else {
            object[key2] = value;
          }
        }
        function baseAt(object, paths) {
          var index = -1, length = paths.length, result3 = Array2(length), skip = object == null;
          while (++index < length) {
            result3[index] = skip ? undefined2 : get(object, paths[index]);
          }
          return result3;
        }
        function baseClamp(number, lower, upper) {
          if (number === number) {
            if (upper !== undefined2) {
              number = number <= upper ? number : upper;
            }
            if (lower !== undefined2) {
              number = number >= lower ? number : lower;
            }
          }
          return number;
        }
        function baseClone(value, bitmask, customizer, key2, object, stack) {
          var result3, isDeep = bitmask & CLONE_DEEP_FLAG, isFlat = bitmask & CLONE_FLAT_FLAG, isFull = bitmask & CLONE_SYMBOLS_FLAG;
          if (customizer) {
            result3 = object ? customizer(value, key2, object, stack) : customizer(value);
          }
          if (result3 !== undefined2) {
            return result3;
          }
          if (!isObject2(value)) {
            return value;
          }
          var isArr = isArray(value);
          if (isArr) {
            result3 = initCloneArray(value);
            if (!isDeep) {
              return copyArray(value, result3);
            }
          } else {
            var tag = getTag(value), isFunc = tag == funcTag || tag == genTag;
            if (isBuffer(value)) {
              return cloneBuffer(value, isDeep);
            }
            if (tag == objectTag || tag == argsTag || isFunc && !object) {
              result3 = isFlat || isFunc ? {} : initCloneObject(value);
              if (!isDeep) {
                return isFlat ? copySymbolsIn(value, baseAssignIn(result3, value)) : copySymbols(value, baseAssign(result3, value));
              }
            } else {
              if (!cloneableTags[tag]) {
                return object ? value : {};
              }
              result3 = initCloneByTag(value, tag, isDeep);
            }
          }
          stack || (stack = new Stack());
          var stacked = stack.get(value);
          if (stacked) {
            return stacked;
          }
          stack.set(value, result3);
          if (isSet(value)) {
            value.forEach(function(subValue) {
              result3.add(baseClone(subValue, bitmask, customizer, subValue, value, stack));
            });
          } else if (isMap(value)) {
            value.forEach(function(subValue, key3) {
              result3.set(key3, baseClone(subValue, bitmask, customizer, key3, value, stack));
            });
          }
          var keysFunc = isFull ? isFlat ? getAllKeysIn : getAllKeys : isFlat ? keysIn : keys;
          var props = isArr ? undefined2 : keysFunc(value);
          arrayEach(props || value, function(subValue, key3) {
            if (props) {
              key3 = subValue;
              subValue = value[key3];
            }
            assignValue(result3, key3, baseClone(subValue, bitmask, customizer, key3, value, stack));
          });
          return result3;
        }
        function baseConforms(source) {
          var props = keys(source);
          return function(object) {
            return baseConformsTo(object, source, props);
          };
        }
        function baseConformsTo(object, source, props) {
          var length = props.length;
          if (object == null) {
            return !length;
          }
          object = Object2(object);
          while (length--) {
            var key2 = props[length], predicate = source[key2], value = object[key2];
            if (value === undefined2 && !(key2 in object) || !predicate(value)) {
              return false;
            }
          }
          return true;
        }
        function baseDelay(func2, wait, args) {
          if (typeof func2 != "function") {
            throw new TypeError2(FUNC_ERROR_TEXT);
          }
          return setTimeout2(function() {
            func2.apply(undefined2, args);
          }, wait);
        }
        function baseDifference(array, values2, iteratee2, comparator) {
          var index = -1, includes2 = arrayIncludes, isCommon = true, length = array.length, result3 = [], valuesLength = values2.length;
          if (!length) {
            return result3;
          }
          if (iteratee2) {
            values2 = arrayMap(values2, baseUnary(iteratee2));
          }
          if (comparator) {
            includes2 = arrayIncludesWith;
            isCommon = false;
          } else if (values2.length >= LARGE_ARRAY_SIZE) {
            includes2 = cacheHas;
            isCommon = false;
            values2 = new SetCache(values2);
          }
          outer:
            while (++index < length) {
              var value = array[index], computed = iteratee2 == null ? value : iteratee2(value);
              value = comparator || value !== 0 ? value : 0;
              if (isCommon && computed === computed) {
                var valuesIndex = valuesLength;
                while (valuesIndex--) {
                  if (values2[valuesIndex] === computed) {
                    continue outer;
                  }
                }
                result3.push(value);
              } else if (!includes2(values2, computed, comparator)) {
                result3.push(value);
              }
            }
          return result3;
        }
        var baseEach = createBaseEach(baseForOwn);
        var baseEachRight = createBaseEach(baseForOwnRight, true);
        function baseEvery(collection, predicate) {
          var result3 = true;
          baseEach(collection, function(value, index, collection2) {
            result3 = !!predicate(value, index, collection2);
            return result3;
          });
          return result3;
        }
        function baseExtremum(array, iteratee2, comparator) {
          var index = -1, length = array.length;
          while (++index < length) {
            var value = array[index], current = iteratee2(value);
            if (current != null && (computed === undefined2 ? current === current && !isSymbol(current) : comparator(current, computed))) {
              var computed = current, result3 = value;
            }
          }
          return result3;
        }
        function baseFill(array, value, start, end) {
          var length = array.length;
          start = toInteger(start);
          if (start < 0) {
            start = -start > length ? 0 : length + start;
          }
          end = end === undefined2 || end > length ? length : toInteger(end);
          if (end < 0) {
            end += length;
          }
          end = start > end ? 0 : toLength(end);
          while (start < end) {
            array[start++] = value;
          }
          return array;
        }
        function baseFilter(collection, predicate) {
          var result3 = [];
          baseEach(collection, function(value, index, collection2) {
            if (predicate(value, index, collection2)) {
              result3.push(value);
            }
          });
          return result3;
        }
        function baseFlatten(array, depth, predicate, isStrict, result3) {
          var index = -1, length = array.length;
          predicate || (predicate = isFlattenable);
          result3 || (result3 = []);
          while (++index < length) {
            var value = array[index];
            if (depth > 0 && predicate(value)) {
              if (depth > 1) {
                baseFlatten(value, depth - 1, predicate, isStrict, result3);
              } else {
                arrayPush(result3, value);
              }
            } else if (!isStrict) {
              result3[result3.length] = value;
            }
          }
          return result3;
        }
        var baseFor = createBaseFor();
        var baseForRight = createBaseFor(true);
        function baseForOwn(object, iteratee2) {
          return object && baseFor(object, iteratee2, keys);
        }
        function baseForOwnRight(object, iteratee2) {
          return object && baseForRight(object, iteratee2, keys);
        }
        function baseFunctions(object, props) {
          return arrayFilter(props, function(key2) {
            return isFunction(object[key2]);
          });
        }
        function baseGet(object, path2) {
          path2 = castPath(path2, object);
          var index = 0, length = path2.length;
          while (object != null && index < length) {
            object = object[toKey(path2[index++])];
          }
          return index && index == length ? object : undefined2;
        }
        function baseGetAllKeys(object, keysFunc, symbolsFunc) {
          var result3 = keysFunc(object);
          return isArray(object) ? result3 : arrayPush(result3, symbolsFunc(object));
        }
        function baseGetTag(value) {
          if (value == null) {
            return value === undefined2 ? undefinedTag : nullTag;
          }
          return symToStringTag && symToStringTag in Object2(value) ? getRawTag(value) : objectToString(value);
        }
        function baseGt(value, other) {
          return value > other;
        }
        function baseHas(object, key2) {
          return object != null && hasOwnProperty2.call(object, key2);
        }
        function baseHasIn(object, key2) {
          return object != null && key2 in Object2(object);
        }
        function baseInRange(number, start, end) {
          return number >= nativeMin(start, end) && number < nativeMax(start, end);
        }
        function baseIntersection(arrays, iteratee2, comparator) {
          var includes2 = comparator ? arrayIncludesWith : arrayIncludes, length = arrays[0].length, othLength = arrays.length, othIndex = othLength, caches = Array2(othLength), maxLength = Infinity, result3 = [];
          while (othIndex--) {
            var array = arrays[othIndex];
            if (othIndex && iteratee2) {
              array = arrayMap(array, baseUnary(iteratee2));
            }
            maxLength = nativeMin(array.length, maxLength);
            caches[othIndex] = !comparator && (iteratee2 || length >= 120 && array.length >= 120) ? new SetCache(othIndex && array) : undefined2;
          }
          array = arrays[0];
          var index = -1, seen = caches[0];
          outer:
            while (++index < length && result3.length < maxLength) {
              var value = array[index], computed = iteratee2 ? iteratee2(value) : value;
              value = comparator || value !== 0 ? value : 0;
              if (!(seen ? cacheHas(seen, computed) : includes2(result3, computed, comparator))) {
                othIndex = othLength;
                while (--othIndex) {
                  var cache = caches[othIndex];
                  if (!(cache ? cacheHas(cache, computed) : includes2(arrays[othIndex], computed, comparator))) {
                    continue outer;
                  }
                }
                if (seen) {
                  seen.push(computed);
                }
                result3.push(value);
              }
            }
          return result3;
        }
        function baseInverter(object, setter, iteratee2, accumulator) {
          baseForOwn(object, function(value, key2, object2) {
            setter(accumulator, iteratee2(value), key2, object2);
          });
          return accumulator;
        }
        function baseInvoke(object, path2, args) {
          path2 = castPath(path2, object);
          object = parent(object, path2);
          var func2 = object == null ? object : object[toKey(last(path2))];
          return func2 == null ? undefined2 : apply(func2, object, args);
        }
        function baseIsArguments(value) {
          return isObjectLike(value) && baseGetTag(value) == argsTag;
        }
        function baseIsArrayBuffer(value) {
          return isObjectLike(value) && baseGetTag(value) == arrayBufferTag;
        }
        function baseIsDate(value) {
          return isObjectLike(value) && baseGetTag(value) == dateTag;
        }
        function baseIsEqual(value, other, bitmask, customizer, stack) {
          if (value === other) {
            return true;
          }
          if (value == null || other == null || !isObjectLike(value) && !isObjectLike(other)) {
            return value !== value && other !== other;
          }
          return baseIsEqualDeep(value, other, bitmask, customizer, baseIsEqual, stack);
        }
        function baseIsEqualDeep(object, other, bitmask, customizer, equalFunc, stack) {
          var objIsArr = isArray(object), othIsArr = isArray(other), objTag = objIsArr ? arrayTag : getTag(object), othTag = othIsArr ? arrayTag : getTag(other);
          objTag = objTag == argsTag ? objectTag : objTag;
          othTag = othTag == argsTag ? objectTag : othTag;
          var objIsObj = objTag == objectTag, othIsObj = othTag == objectTag, isSameTag = objTag == othTag;
          if (isSameTag && isBuffer(object)) {
            if (!isBuffer(other)) {
              return false;
            }
            objIsArr = true;
            objIsObj = false;
          }
          if (isSameTag && !objIsObj) {
            stack || (stack = new Stack());
            return objIsArr || isTypedArray(object) ? equalArrays(object, other, bitmask, customizer, equalFunc, stack) : equalByTag(object, other, objTag, bitmask, customizer, equalFunc, stack);
          }
          if (!(bitmask & COMPARE_PARTIAL_FLAG)) {
            var objIsWrapped = objIsObj && hasOwnProperty2.call(object, "__wrapped__"), othIsWrapped = othIsObj && hasOwnProperty2.call(other, "__wrapped__");
            if (objIsWrapped || othIsWrapped) {
              var objUnwrapped = objIsWrapped ? object.value() : object, othUnwrapped = othIsWrapped ? other.value() : other;
              stack || (stack = new Stack());
              return equalFunc(objUnwrapped, othUnwrapped, bitmask, customizer, stack);
            }
          }
          if (!isSameTag) {
            return false;
          }
          stack || (stack = new Stack());
          return equalObjects(object, other, bitmask, customizer, equalFunc, stack);
        }
        function baseIsMap(value) {
          return isObjectLike(value) && getTag(value) == mapTag;
        }
        function baseIsMatch(object, source, matchData, customizer) {
          var index = matchData.length, length = index, noCustomizer = !customizer;
          if (object == null) {
            return !length;
          }
          object = Object2(object);
          while (index--) {
            var data = matchData[index];
            if (noCustomizer && data[2] ? data[1] !== object[data[0]] : !(data[0] in object)) {
              return false;
            }
          }
          while (++index < length) {
            data = matchData[index];
            var key2 = data[0], objValue = object[key2], srcValue = data[1];
            if (noCustomizer && data[2]) {
              if (objValue === undefined2 && !(key2 in object)) {
                return false;
              }
            } else {
              var stack = new Stack();
              if (customizer) {
                var result3 = customizer(objValue, srcValue, key2, object, source, stack);
              }
              if (!(result3 === undefined2 ? baseIsEqual(srcValue, objValue, COMPARE_PARTIAL_FLAG | COMPARE_UNORDERED_FLAG, customizer, stack) : result3)) {
                return false;
              }
            }
          }
          return true;
        }
        function baseIsNative(value) {
          if (!isObject2(value) || isMasked(value)) {
            return false;
          }
          var pattern = isFunction(value) ? reIsNative : reIsHostCtor;
          return pattern.test(toSource(value));
        }
        function baseIsRegExp(value) {
          return isObjectLike(value) && baseGetTag(value) == regexpTag;
        }
        function baseIsSet(value) {
          return isObjectLike(value) && getTag(value) == setTag;
        }
        function baseIsTypedArray(value) {
          return isObjectLike(value) && isLength(value.length) && !!typedArrayTags[baseGetTag(value)];
        }
        function baseIteratee(value) {
          if (typeof value == "function") {
            return value;
          }
          if (value == null) {
            return identity;
          }
          if (typeof value == "object") {
            return isArray(value) ? baseMatchesProperty(value[0], value[1]) : baseMatches(value);
          }
          return property(value);
        }
        function baseKeys(object) {
          if (!isPrototype(object)) {
            return nativeKeys(object);
          }
          var result3 = [];
          for (var key2 in Object2(object)) {
            if (hasOwnProperty2.call(object, key2) && key2 != "constructor") {
              result3.push(key2);
            }
          }
          return result3;
        }
        function baseKeysIn(object) {
          if (!isObject2(object)) {
            return nativeKeysIn(object);
          }
          var isProto = isPrototype(object), result3 = [];
          for (var key2 in object) {
            if (!(key2 == "constructor" && (isProto || !hasOwnProperty2.call(object, key2)))) {
              result3.push(key2);
            }
          }
          return result3;
        }
        function baseLt(value, other) {
          return value < other;
        }
        function baseMap(collection, iteratee2) {
          var index = -1, result3 = isArrayLike(collection) ? Array2(collection.length) : [];
          baseEach(collection, function(value, key2, collection2) {
            result3[++index] = iteratee2(value, key2, collection2);
          });
          return result3;
        }
        function baseMatches(source) {
          var matchData = getMatchData(source);
          if (matchData.length == 1 && matchData[0][2]) {
            return matchesStrictComparable(matchData[0][0], matchData[0][1]);
          }
          return function(object) {
            return object === source || baseIsMatch(object, source, matchData);
          };
        }
        function baseMatchesProperty(path2, srcValue) {
          if (isKey(path2) && isStrictComparable(srcValue)) {
            return matchesStrictComparable(toKey(path2), srcValue);
          }
          return function(object) {
            var objValue = get(object, path2);
            return objValue === undefined2 && objValue === srcValue ? hasIn(object, path2) : baseIsEqual(srcValue, objValue, COMPARE_PARTIAL_FLAG | COMPARE_UNORDERED_FLAG);
          };
        }
        function baseMerge(object, source, srcIndex, customizer, stack) {
          if (object === source) {
            return;
          }
          baseFor(source, function(srcValue, key2) {
            stack || (stack = new Stack());
            if (isObject2(srcValue)) {
              baseMergeDeep(object, source, key2, srcIndex, baseMerge, customizer, stack);
            } else {
              var newValue = customizer ? customizer(safeGet(object, key2), srcValue, key2 + "", object, source, stack) : undefined2;
              if (newValue === undefined2) {
                newValue = srcValue;
              }
              assignMergeValue(object, key2, newValue);
            }
          }, keysIn);
        }
        function baseMergeDeep(object, source, key2, srcIndex, mergeFunc, customizer, stack) {
          var objValue = safeGet(object, key2), srcValue = safeGet(source, key2), stacked = stack.get(srcValue);
          if (stacked) {
            assignMergeValue(object, key2, stacked);
            return;
          }
          var newValue = customizer ? customizer(objValue, srcValue, key2 + "", object, source, stack) : undefined2;
          var isCommon = newValue === undefined2;
          if (isCommon) {
            var isArr = isArray(srcValue), isBuff = !isArr && isBuffer(srcValue), isTyped = !isArr && !isBuff && isTypedArray(srcValue);
            newValue = srcValue;
            if (isArr || isBuff || isTyped) {
              if (isArray(objValue)) {
                newValue = objValue;
              } else if (isArrayLikeObject(objValue)) {
                newValue = copyArray(objValue);
              } else if (isBuff) {
                isCommon = false;
                newValue = cloneBuffer(srcValue, true);
              } else if (isTyped) {
                isCommon = false;
                newValue = cloneTypedArray(srcValue, true);
              } else {
                newValue = [];
              }
            } else if (isPlainObject(srcValue) || isArguments(srcValue)) {
              newValue = objValue;
              if (isArguments(objValue)) {
                newValue = toPlainObject(objValue);
              } else if (!isObject2(objValue) || isFunction(objValue)) {
                newValue = initCloneObject(srcValue);
              }
            } else {
              isCommon = false;
            }
          }
          if (isCommon) {
            stack.set(srcValue, newValue);
            mergeFunc(newValue, srcValue, srcIndex, customizer, stack);
            stack["delete"](srcValue);
          }
          assignMergeValue(object, key2, newValue);
        }
        function baseNth(array, n2) {
          var length = array.length;
          if (!length) {
            return;
          }
          n2 += n2 < 0 ? length : 0;
          return isIndex(n2, length) ? array[n2] : undefined2;
        }
        function baseOrderBy(collection, iteratees, orders) {
          if (iteratees.length) {
            iteratees = arrayMap(iteratees, function(iteratee2) {
              if (isArray(iteratee2)) {
                return function(value) {
                  return baseGet(value, iteratee2.length === 1 ? iteratee2[0] : iteratee2);
                };
              }
              return iteratee2;
            });
          } else {
            iteratees = [identity];
          }
          var index = -1;
          iteratees = arrayMap(iteratees, baseUnary(getIteratee()));
          var result3 = baseMap(collection, function(value, key2, collection2) {
            var criteria = arrayMap(iteratees, function(iteratee2) {
              return iteratee2(value);
            });
            return { "criteria": criteria, "index": ++index, "value": value };
          });
          return baseSortBy(result3, function(object, other) {
            return compareMultiple(object, other, orders);
          });
        }
        function basePick(object, paths) {
          return basePickBy(object, paths, function(value, path2) {
            return hasIn(object, path2);
          });
        }
        function basePickBy(object, paths, predicate) {
          var index = -1, length = paths.length, result3 = {};
          while (++index < length) {
            var path2 = paths[index], value = baseGet(object, path2);
            if (predicate(value, path2)) {
              baseSet(result3, castPath(path2, object), value);
            }
          }
          return result3;
        }
        function basePropertyDeep(path2) {
          return function(object) {
            return baseGet(object, path2);
          };
        }
        function basePullAll(array, values2, iteratee2, comparator) {
          var indexOf2 = comparator ? baseIndexOfWith : baseIndexOf, index = -1, length = values2.length, seen = array;
          if (array === values2) {
            values2 = copyArray(values2);
          }
          if (iteratee2) {
            seen = arrayMap(array, baseUnary(iteratee2));
          }
          while (++index < length) {
            var fromIndex = 0, value = values2[index], computed = iteratee2 ? iteratee2(value) : value;
            while ((fromIndex = indexOf2(seen, computed, fromIndex, comparator)) > -1) {
              if (seen !== array) {
                splice.call(seen, fromIndex, 1);
              }
              splice.call(array, fromIndex, 1);
            }
          }
          return array;
        }
        function basePullAt(array, indexes) {
          var length = array ? indexes.length : 0, lastIndex = length - 1;
          while (length--) {
            var index = indexes[length];
            if (length == lastIndex || index !== previous) {
              var previous = index;
              if (isIndex(index)) {
                splice.call(array, index, 1);
              } else {
                baseUnset(array, index);
              }
            }
          }
          return array;
        }
        function baseRandom(lower, upper) {
          return lower + nativeFloor(nativeRandom() * (upper - lower + 1));
        }
        function baseRange(start, end, step, fromRight) {
          var index = -1, length = nativeMax(nativeCeil((end - start) / (step || 1)), 0), result3 = Array2(length);
          while (length--) {
            result3[fromRight ? length : ++index] = start;
            start += step;
          }
          return result3;
        }
        function baseRepeat(string, n2) {
          var result3 = "";
          if (!string || n2 < 1 || n2 > MAX_SAFE_INTEGER) {
            return result3;
          }
          do {
            if (n2 % 2) {
              result3 += string;
            }
            n2 = nativeFloor(n2 / 2);
            if (n2) {
              string += string;
            }
          } while (n2);
          return result3;
        }
        function baseRest(func2, start) {
          return setToString(overRest(func2, start, identity), func2 + "");
        }
        function baseSample(collection) {
          return arraySample(values(collection));
        }
        function baseSampleSize(collection, n2) {
          var array = values(collection);
          return shuffleSelf(array, baseClamp(n2, 0, array.length));
        }
        function baseSet(object, path2, value, customizer) {
          if (!isObject2(object)) {
            return object;
          }
          path2 = castPath(path2, object);
          var index = -1, length = path2.length, lastIndex = length - 1, nested = object;
          while (nested != null && ++index < length) {
            var key2 = toKey(path2[index]), newValue = value;
            if (key2 === "__proto__" || key2 === "constructor" || key2 === "prototype") {
              return object;
            }
            if (index != lastIndex) {
              var objValue = nested[key2];
              newValue = customizer ? customizer(objValue, key2, nested) : undefined2;
              if (newValue === undefined2) {
                newValue = isObject2(objValue) ? objValue : isIndex(path2[index + 1]) ? [] : {};
              }
            }
            assignValue(nested, key2, newValue);
            nested = nested[key2];
          }
          return object;
        }
        var baseSetData = !metaMap ? identity : function(func2, data) {
          metaMap.set(func2, data);
          return func2;
        };
        var baseSetToString = !defineProperty ? identity : function(func2, string) {
          return defineProperty(func2, "toString", {
            "configurable": true,
            "enumerable": false,
            "value": constant(string),
            "writable": true
          });
        };
        function baseShuffle(collection) {
          return shuffleSelf(values(collection));
        }
        function baseSlice(array, start, end) {
          var index = -1, length = array.length;
          if (start < 0) {
            start = -start > length ? 0 : length + start;
          }
          end = end > length ? length : end;
          if (end < 0) {
            end += length;
          }
          length = start > end ? 0 : end - start >>> 0;
          start >>>= 0;
          var result3 = Array2(length);
          while (++index < length) {
            result3[index] = array[index + start];
          }
          return result3;
        }
        function baseSome(collection, predicate) {
          var result3;
          baseEach(collection, function(value, index, collection2) {
            result3 = predicate(value, index, collection2);
            return !result3;
          });
          return !!result3;
        }
        function baseSortedIndex(array, value, retHighest) {
          var low = 0, high = array == null ? low : array.length;
          if (typeof value == "number" && value === value && high <= HALF_MAX_ARRAY_LENGTH) {
            while (low < high) {
              var mid = low + high >>> 1, computed = array[mid];
              if (computed !== null && !isSymbol(computed) && (retHighest ? computed <= value : computed < value)) {
                low = mid + 1;
              } else {
                high = mid;
              }
            }
            return high;
          }
          return baseSortedIndexBy(array, value, identity, retHighest);
        }
        function baseSortedIndexBy(array, value, iteratee2, retHighest) {
          var low = 0, high = array == null ? 0 : array.length;
          if (high === 0) {
            return 0;
          }
          value = iteratee2(value);
          var valIsNaN = value !== value, valIsNull = value === null, valIsSymbol = isSymbol(value), valIsUndefined = value === undefined2;
          while (low < high) {
            var mid = nativeFloor((low + high) / 2), computed = iteratee2(array[mid]), othIsDefined = computed !== undefined2, othIsNull = computed === null, othIsReflexive = computed === computed, othIsSymbol = isSymbol(computed);
            if (valIsNaN) {
              var setLow = retHighest || othIsReflexive;
            } else if (valIsUndefined) {
              setLow = othIsReflexive && (retHighest || othIsDefined);
            } else if (valIsNull) {
              setLow = othIsReflexive && othIsDefined && (retHighest || !othIsNull);
            } else if (valIsSymbol) {
              setLow = othIsReflexive && othIsDefined && !othIsNull && (retHighest || !othIsSymbol);
            } else if (othIsNull || othIsSymbol) {
              setLow = false;
            } else {
              setLow = retHighest ? computed <= value : computed < value;
            }
            if (setLow) {
              low = mid + 1;
            } else {
              high = mid;
            }
          }
          return nativeMin(high, MAX_ARRAY_INDEX);
        }
        function baseSortedUniq(array, iteratee2) {
          var index = -1, length = array.length, resIndex = 0, result3 = [];
          while (++index < length) {
            var value = array[index], computed = iteratee2 ? iteratee2(value) : value;
            if (!index || !eq(computed, seen)) {
              var seen = computed;
              result3[resIndex++] = value === 0 ? 0 : value;
            }
          }
          return result3;
        }
        function baseToNumber(value) {
          if (typeof value == "number") {
            return value;
          }
          if (isSymbol(value)) {
            return NAN;
          }
          return +value;
        }
        function baseToString(value) {
          if (typeof value == "string") {
            return value;
          }
          if (isArray(value)) {
            return arrayMap(value, baseToString) + "";
          }
          if (isSymbol(value)) {
            return symbolToString ? symbolToString.call(value) : "";
          }
          var result3 = value + "";
          return result3 == "0" && 1 / value == -INFINITY ? "-0" : result3;
        }
        function baseUniq(array, iteratee2, comparator) {
          var index = -1, includes2 = arrayIncludes, length = array.length, isCommon = true, result3 = [], seen = result3;
          if (comparator) {
            isCommon = false;
            includes2 = arrayIncludesWith;
          } else if (length >= LARGE_ARRAY_SIZE) {
            var set3 = iteratee2 ? null : createSet(array);
            if (set3) {
              return setToArray(set3);
            }
            isCommon = false;
            includes2 = cacheHas;
            seen = new SetCache();
          } else {
            seen = iteratee2 ? [] : result3;
          }
          outer:
            while (++index < length) {
              var value = array[index], computed = iteratee2 ? iteratee2(value) : value;
              value = comparator || value !== 0 ? value : 0;
              if (isCommon && computed === computed) {
                var seenIndex = seen.length;
                while (seenIndex--) {
                  if (seen[seenIndex] === computed) {
                    continue outer;
                  }
                }
                if (iteratee2) {
                  seen.push(computed);
                }
                result3.push(value);
              } else if (!includes2(seen, computed, comparator)) {
                if (seen !== result3) {
                  seen.push(computed);
                }
                result3.push(value);
              }
            }
          return result3;
        }
        function baseUnset(object, path2) {
          path2 = castPath(path2, object);
          object = parent(object, path2);
          return object == null || delete object[toKey(last(path2))];
        }
        function baseUpdate(object, path2, updater, customizer) {
          return baseSet(object, path2, updater(baseGet(object, path2)), customizer);
        }
        function baseWhile(array, predicate, isDrop, fromRight) {
          var length = array.length, index = fromRight ? length : -1;
          while ((fromRight ? index-- : ++index < length) && predicate(array[index], index, array)) {
          }
          return isDrop ? baseSlice(array, fromRight ? 0 : index, fromRight ? index + 1 : length) : baseSlice(array, fromRight ? index + 1 : 0, fromRight ? length : index);
        }
        function baseWrapperValue(value, actions2) {
          var result3 = value;
          if (result3 instanceof LazyWrapper) {
            result3 = result3.value();
          }
          return arrayReduce(actions2, function(result4, action) {
            return action.func.apply(action.thisArg, arrayPush([result4], action.args));
          }, result3);
        }
        function baseXor(arrays, iteratee2, comparator) {
          var length = arrays.length;
          if (length < 2) {
            return length ? baseUniq(arrays[0]) : [];
          }
          var index = -1, result3 = Array2(length);
          while (++index < length) {
            var array = arrays[index], othIndex = -1;
            while (++othIndex < length) {
              if (othIndex != index) {
                result3[index] = baseDifference(result3[index] || array, arrays[othIndex], iteratee2, comparator);
              }
            }
          }
          return baseUniq(baseFlatten(result3, 1), iteratee2, comparator);
        }
        function baseZipObject(props, values2, assignFunc) {
          var index = -1, length = props.length, valsLength = values2.length, result3 = {};
          while (++index < length) {
            var value = index < valsLength ? values2[index] : undefined2;
            assignFunc(result3, props[index], value);
          }
          return result3;
        }
        function castArrayLikeObject(value) {
          return isArrayLikeObject(value) ? value : [];
        }
        function castFunction(value) {
          return typeof value == "function" ? value : identity;
        }
        function castPath(value, object) {
          if (isArray(value)) {
            return value;
          }
          return isKey(value, object) ? [value] : stringToPath(toString2(value));
        }
        var castRest = baseRest;
        function castSlice(array, start, end) {
          var length = array.length;
          end = end === undefined2 ? length : end;
          return !start && end >= length ? array : baseSlice(array, start, end);
        }
        var clearTimeout2 = ctxClearTimeout || function(id) {
          return root.clearTimeout(id);
        };
        function cloneBuffer(buffer2, isDeep) {
          if (isDeep) {
            return buffer2.slice();
          }
          var length = buffer2.length, result3 = allocUnsafe ? allocUnsafe(length) : new buffer2.constructor(length);
          buffer2.copy(result3);
          return result3;
        }
        function cloneArrayBuffer(arrayBuffer) {
          var result3 = new arrayBuffer.constructor(arrayBuffer.byteLength);
          new Uint8Array2(result3).set(new Uint8Array2(arrayBuffer));
          return result3;
        }
        function cloneDataView(dataView, isDeep) {
          var buffer2 = isDeep ? cloneArrayBuffer(dataView.buffer) : dataView.buffer;
          return new dataView.constructor(buffer2, dataView.byteOffset, dataView.byteLength);
        }
        function cloneRegExp(regexp) {
          var result3 = new regexp.constructor(regexp.source, reFlags.exec(regexp));
          result3.lastIndex = regexp.lastIndex;
          return result3;
        }
        function cloneSymbol(symbol) {
          return symbolValueOf ? Object2(symbolValueOf.call(symbol)) : {};
        }
        function cloneTypedArray(typedArray, isDeep) {
          var buffer2 = isDeep ? cloneArrayBuffer(typedArray.buffer) : typedArray.buffer;
          return new typedArray.constructor(buffer2, typedArray.byteOffset, typedArray.length);
        }
        function compareAscending(value, other) {
          if (value !== other) {
            var valIsDefined = value !== undefined2, valIsNull = value === null, valIsReflexive = value === value, valIsSymbol = isSymbol(value);
            var othIsDefined = other !== undefined2, othIsNull = other === null, othIsReflexive = other === other, othIsSymbol = isSymbol(other);
            if (!othIsNull && !othIsSymbol && !valIsSymbol && value > other || valIsSymbol && othIsDefined && othIsReflexive && !othIsNull && !othIsSymbol || valIsNull && othIsDefined && othIsReflexive || !valIsDefined && othIsReflexive || !valIsReflexive) {
              return 1;
            }
            if (!valIsNull && !valIsSymbol && !othIsSymbol && value < other || othIsSymbol && valIsDefined && valIsReflexive && !valIsNull && !valIsSymbol || othIsNull && valIsDefined && valIsReflexive || !othIsDefined && valIsReflexive || !othIsReflexive) {
              return -1;
            }
          }
          return 0;
        }
        function compareMultiple(object, other, orders) {
          var index = -1, objCriteria = object.criteria, othCriteria = other.criteria, length = objCriteria.length, ordersLength = orders.length;
          while (++index < length) {
            var result3 = compareAscending(objCriteria[index], othCriteria[index]);
            if (result3) {
              if (index >= ordersLength) {
                return result3;
              }
              var order = orders[index];
              return result3 * (order == "desc" ? -1 : 1);
            }
          }
          return object.index - other.index;
        }
        function composeArgs(args, partials, holders, isCurried) {
          var argsIndex = -1, argsLength = args.length, holdersLength = holders.length, leftIndex = -1, leftLength = partials.length, rangeLength = nativeMax(argsLength - holdersLength, 0), result3 = Array2(leftLength + rangeLength), isUncurried = !isCurried;
          while (++leftIndex < leftLength) {
            result3[leftIndex] = partials[leftIndex];
          }
          while (++argsIndex < holdersLength) {
            if (isUncurried || argsIndex < argsLength) {
              result3[holders[argsIndex]] = args[argsIndex];
            }
          }
          while (rangeLength--) {
            result3[leftIndex++] = args[argsIndex++];
          }
          return result3;
        }
        function composeArgsRight(args, partials, holders, isCurried) {
          var argsIndex = -1, argsLength = args.length, holdersIndex = -1, holdersLength = holders.length, rightIndex = -1, rightLength = partials.length, rangeLength = nativeMax(argsLength - holdersLength, 0), result3 = Array2(rangeLength + rightLength), isUncurried = !isCurried;
          while (++argsIndex < rangeLength) {
            result3[argsIndex] = args[argsIndex];
          }
          var offset = argsIndex;
          while (++rightIndex < rightLength) {
            result3[offset + rightIndex] = partials[rightIndex];
          }
          while (++holdersIndex < holdersLength) {
            if (isUncurried || argsIndex < argsLength) {
              result3[offset + holders[holdersIndex]] = args[argsIndex++];
            }
          }
          return result3;
        }
        function copyArray(source, array) {
          var index = -1, length = source.length;
          array || (array = Array2(length));
          while (++index < length) {
            array[index] = source[index];
          }
          return array;
        }
        function copyObject(source, props, object, customizer) {
          var isNew = !object;
          object || (object = {});
          var index = -1, length = props.length;
          while (++index < length) {
            var key2 = props[index];
            var newValue = customizer ? customizer(object[key2], source[key2], key2, object, source) : undefined2;
            if (newValue === undefined2) {
              newValue = source[key2];
            }
            if (isNew) {
              baseAssignValue(object, key2, newValue);
            } else {
              assignValue(object, key2, newValue);
            }
          }
          return object;
        }
        function copySymbols(source, object) {
          return copyObject(source, getSymbols(source), object);
        }
        function copySymbolsIn(source, object) {
          return copyObject(source, getSymbolsIn(source), object);
        }
        function createAggregator(setter, initializer) {
          return function(collection, iteratee2) {
            var func2 = isArray(collection) ? arrayAggregator : baseAggregator, accumulator = initializer ? initializer() : {};
            return func2(collection, setter, getIteratee(iteratee2, 2), accumulator);
          };
        }
        function createAssigner(assigner) {
          return baseRest(function(object, sources) {
            var index = -1, length = sources.length, customizer = length > 1 ? sources[length - 1] : undefined2, guard = length > 2 ? sources[2] : undefined2;
            customizer = assigner.length > 3 && typeof customizer == "function" ? (length--, customizer) : undefined2;
            if (guard && isIterateeCall(sources[0], sources[1], guard)) {
              customizer = length < 3 ? undefined2 : customizer;
              length = 1;
            }
            object = Object2(object);
            while (++index < length) {
              var source = sources[index];
              if (source) {
                assigner(object, source, index, customizer);
              }
            }
            return object;
          });
        }
        function createBaseEach(eachFunc, fromRight) {
          return function(collection, iteratee2) {
            if (collection == null) {
              return collection;
            }
            if (!isArrayLike(collection)) {
              return eachFunc(collection, iteratee2);
            }
            var length = collection.length, index = fromRight ? length : -1, iterable = Object2(collection);
            while (fromRight ? index-- : ++index < length) {
              if (iteratee2(iterable[index], index, iterable) === false) {
                break;
              }
            }
            return collection;
          };
        }
        function createBaseFor(fromRight) {
          return function(object, iteratee2, keysFunc) {
            var index = -1, iterable = Object2(object), props = keysFunc(object), length = props.length;
            while (length--) {
              var key2 = props[fromRight ? length : ++index];
              if (iteratee2(iterable[key2], key2, iterable) === false) {
                break;
              }
            }
            return object;
          };
        }
        function createBind(func2, bitmask, thisArg) {
          var isBind = bitmask & WRAP_BIND_FLAG, Ctor = createCtor(func2);
          function wrapper() {
            var fn = this && this !== root && this instanceof wrapper ? Ctor : func2;
            return fn.apply(isBind ? thisArg : this, arguments);
          }
          return wrapper;
        }
        function createCaseFirst(methodName) {
          return function(string) {
            string = toString2(string);
            var strSymbols = hasUnicode(string) ? stringToArray(string) : undefined2;
            var chr = strSymbols ? strSymbols[0] : string.charAt(0);
            var trailing = strSymbols ? castSlice(strSymbols, 1).join("") : string.slice(1);
            return chr[methodName]() + trailing;
          };
        }
        function createCompounder(callback) {
          return function(string) {
            return arrayReduce(words(deburr(string).replace(reApos, "")), callback, "");
          };
        }
        function createCtor(Ctor) {
          return function() {
            var args = arguments;
            switch (args.length) {
              case 0:
                return new Ctor();
              case 1:
                return new Ctor(args[0]);
              case 2:
                return new Ctor(args[0], args[1]);
              case 3:
                return new Ctor(args[0], args[1], args[2]);
              case 4:
                return new Ctor(args[0], args[1], args[2], args[3]);
              case 5:
                return new Ctor(args[0], args[1], args[2], args[3], args[4]);
              case 6:
                return new Ctor(args[0], args[1], args[2], args[3], args[4], args[5]);
              case 7:
                return new Ctor(args[0], args[1], args[2], args[3], args[4], args[5], args[6]);
            }
            var thisBinding = baseCreate(Ctor.prototype), result3 = Ctor.apply(thisBinding, args);
            return isObject2(result3) ? result3 : thisBinding;
          };
        }
        function createCurry(func2, bitmask, arity) {
          var Ctor = createCtor(func2);
          function wrapper() {
            var length = arguments.length, args = Array2(length), index = length, placeholder = getHolder(wrapper);
            while (index--) {
              args[index] = arguments[index];
            }
            var holders = length < 3 && args[0] !== placeholder && args[length - 1] !== placeholder ? [] : replaceHolders(args, placeholder);
            length -= holders.length;
            if (length < arity) {
              return createRecurry(func2, bitmask, createHybrid, wrapper.placeholder, undefined2, args, holders, undefined2, undefined2, arity - length);
            }
            var fn = this && this !== root && this instanceof wrapper ? Ctor : func2;
            return apply(fn, this, args);
          }
          return wrapper;
        }
        function createFind(findIndexFunc) {
          return function(collection, predicate, fromIndex) {
            var iterable = Object2(collection);
            if (!isArrayLike(collection)) {
              var iteratee2 = getIteratee(predicate, 3);
              collection = keys(collection);
              predicate = function(key2) {
                return iteratee2(iterable[key2], key2, iterable);
              };
            }
            var index = findIndexFunc(collection, predicate, fromIndex);
            return index > -1 ? iterable[iteratee2 ? collection[index] : index] : undefined2;
          };
        }
        function createFlow(fromRight) {
          return flatRest(function(funcs) {
            var length = funcs.length, index = length, prereq = LodashWrapper.prototype.thru;
            if (fromRight) {
              funcs.reverse();
            }
            while (index--) {
              var func2 = funcs[index];
              if (typeof func2 != "function") {
                throw new TypeError2(FUNC_ERROR_TEXT);
              }
              if (prereq && !wrapper && getFuncName(func2) == "wrapper") {
                var wrapper = new LodashWrapper([], true);
              }
            }
            index = wrapper ? index : length;
            while (++index < length) {
              func2 = funcs[index];
              var funcName = getFuncName(func2), data = funcName == "wrapper" ? getData(func2) : undefined2;
              if (data && isLaziable(data[0]) && data[1] == (WRAP_ARY_FLAG | WRAP_CURRY_FLAG | WRAP_PARTIAL_FLAG | WRAP_REARG_FLAG) && !data[4].length && data[9] == 1) {
                wrapper = wrapper[getFuncName(data[0])].apply(wrapper, data[3]);
              } else {
                wrapper = func2.length == 1 && isLaziable(func2) ? wrapper[funcName]() : wrapper.thru(func2);
              }
            }
            return function() {
              var args = arguments, value = args[0];
              if (wrapper && args.length == 1 && isArray(value)) {
                return wrapper.plant(value).value();
              }
              var index2 = 0, result3 = length ? funcs[index2].apply(this, args) : value;
              while (++index2 < length) {
                result3 = funcs[index2].call(this, result3);
              }
              return result3;
            };
          });
        }
        function createHybrid(func2, bitmask, thisArg, partials, holders, partialsRight, holdersRight, argPos, ary2, arity) {
          var isAry = bitmask & WRAP_ARY_FLAG, isBind = bitmask & WRAP_BIND_FLAG, isBindKey = bitmask & WRAP_BIND_KEY_FLAG, isCurried = bitmask & (WRAP_CURRY_FLAG | WRAP_CURRY_RIGHT_FLAG), isFlip = bitmask & WRAP_FLIP_FLAG, Ctor = isBindKey ? undefined2 : createCtor(func2);
          function wrapper() {
            var length = arguments.length, args = Array2(length), index = length;
            while (index--) {
              args[index] = arguments[index];
            }
            if (isCurried) {
              var placeholder = getHolder(wrapper), holdersCount = countHolders(args, placeholder);
            }
            if (partials) {
              args = composeArgs(args, partials, holders, isCurried);
            }
            if (partialsRight) {
              args = composeArgsRight(args, partialsRight, holdersRight, isCurried);
            }
            length -= holdersCount;
            if (isCurried && length < arity) {
              var newHolders = replaceHolders(args, placeholder);
              return createRecurry(func2, bitmask, createHybrid, wrapper.placeholder, thisArg, args, newHolders, argPos, ary2, arity - length);
            }
            var thisBinding = isBind ? thisArg : this, fn = isBindKey ? thisBinding[func2] : func2;
            length = args.length;
            if (argPos) {
              args = reorder(args, argPos);
            } else if (isFlip && length > 1) {
              args.reverse();
            }
            if (isAry && ary2 < length) {
              args.length = ary2;
            }
            if (this && this !== root && this instanceof wrapper) {
              fn = Ctor || createCtor(fn);
            }
            return fn.apply(thisBinding, args);
          }
          return wrapper;
        }
        function createInverter(setter, toIteratee) {
          return function(object, iteratee2) {
            return baseInverter(object, setter, toIteratee(iteratee2), {});
          };
        }
        function createMathOperation(operator, defaultValue) {
          return function(value, other) {
            var result3;
            if (value === undefined2 && other === undefined2) {
              return defaultValue;
            }
            if (value !== undefined2) {
              result3 = value;
            }
            if (other !== undefined2) {
              if (result3 === undefined2) {
                return other;
              }
              if (typeof value == "string" || typeof other == "string") {
                value = baseToString(value);
                other = baseToString(other);
              } else {
                value = baseToNumber(value);
                other = baseToNumber(other);
              }
              result3 = operator(value, other);
            }
            return result3;
          };
        }
        function createOver(arrayFunc) {
          return flatRest(function(iteratees) {
            iteratees = arrayMap(iteratees, baseUnary(getIteratee()));
            return baseRest(function(args) {
              var thisArg = this;
              return arrayFunc(iteratees, function(iteratee2) {
                return apply(iteratee2, thisArg, args);
              });
            });
          });
        }
        function createPadding(length, chars) {
          chars = chars === undefined2 ? " " : baseToString(chars);
          var charsLength = chars.length;
          if (charsLength < 2) {
            return charsLength ? baseRepeat(chars, length) : chars;
          }
          var result3 = baseRepeat(chars, nativeCeil(length / stringSize(chars)));
          return hasUnicode(chars) ? castSlice(stringToArray(result3), 0, length).join("") : result3.slice(0, length);
        }
        function createPartial(func2, bitmask, thisArg, partials) {
          var isBind = bitmask & WRAP_BIND_FLAG, Ctor = createCtor(func2);
          function wrapper() {
            var argsIndex = -1, argsLength = arguments.length, leftIndex = -1, leftLength = partials.length, args = Array2(leftLength + argsLength), fn = this && this !== root && this instanceof wrapper ? Ctor : func2;
            while (++leftIndex < leftLength) {
              args[leftIndex] = partials[leftIndex];
            }
            while (argsLength--) {
              args[leftIndex++] = arguments[++argsIndex];
            }
            return apply(fn, isBind ? thisArg : this, args);
          }
          return wrapper;
        }
        function createRange(fromRight) {
          return function(start, end, step) {
            if (step && typeof step != "number" && isIterateeCall(start, end, step)) {
              end = step = undefined2;
            }
            start = toFinite(start);
            if (end === undefined2) {
              end = start;
              start = 0;
            } else {
              end = toFinite(end);
            }
            step = step === undefined2 ? start < end ? 1 : -1 : toFinite(step);
            return baseRange(start, end, step, fromRight);
          };
        }
        function createRelationalOperation(operator) {
          return function(value, other) {
            if (!(typeof value == "string" && typeof other == "string")) {
              value = toNumber(value);
              other = toNumber(other);
            }
            return operator(value, other);
          };
        }
        function createRecurry(func2, bitmask, wrapFunc, placeholder, thisArg, partials, holders, argPos, ary2, arity) {
          var isCurry = bitmask & WRAP_CURRY_FLAG, newHolders = isCurry ? holders : undefined2, newHoldersRight = isCurry ? undefined2 : holders, newPartials = isCurry ? partials : undefined2, newPartialsRight = isCurry ? undefined2 : partials;
          bitmask |= isCurry ? WRAP_PARTIAL_FLAG : WRAP_PARTIAL_RIGHT_FLAG;
          bitmask &= ~(isCurry ? WRAP_PARTIAL_RIGHT_FLAG : WRAP_PARTIAL_FLAG);
          if (!(bitmask & WRAP_CURRY_BOUND_FLAG)) {
            bitmask &= ~(WRAP_BIND_FLAG | WRAP_BIND_KEY_FLAG);
          }
          var newData = [
            func2,
            bitmask,
            thisArg,
            newPartials,
            newHolders,
            newPartialsRight,
            newHoldersRight,
            argPos,
            ary2,
            arity
          ];
          var result3 = wrapFunc.apply(undefined2, newData);
          if (isLaziable(func2)) {
            setData(result3, newData);
          }
          result3.placeholder = placeholder;
          return setWrapToString(result3, func2, bitmask);
        }
        function createRound(methodName) {
          var func2 = Math2[methodName];
          return function(number, precision) {
            number = toNumber(number);
            precision = precision == null ? 0 : nativeMin(toInteger(precision), 292);
            if (precision && nativeIsFinite(number)) {
              var pair = (toString2(number) + "e").split("e"), value = func2(pair[0] + "e" + (+pair[1] + precision));
              pair = (toString2(value) + "e").split("e");
              return +(pair[0] + "e" + (+pair[1] - precision));
            }
            return func2(number);
          };
        }
        var createSet = !(Set2 && 1 / setToArray(new Set2([, -0]))[1] == INFINITY) ? noop : function(values2) {
          return new Set2(values2);
        };
        function createToPairs(keysFunc) {
          return function(object) {
            var tag = getTag(object);
            if (tag == mapTag) {
              return mapToArray(object);
            }
            if (tag == setTag) {
              return setToPairs(object);
            }
            return baseToPairs(object, keysFunc(object));
          };
        }
        function createWrap(func2, bitmask, thisArg, partials, holders, argPos, ary2, arity) {
          var isBindKey = bitmask & WRAP_BIND_KEY_FLAG;
          if (!isBindKey && typeof func2 != "function") {
            throw new TypeError2(FUNC_ERROR_TEXT);
          }
          var length = partials ? partials.length : 0;
          if (!length) {
            bitmask &= ~(WRAP_PARTIAL_FLAG | WRAP_PARTIAL_RIGHT_FLAG);
            partials = holders = undefined2;
          }
          ary2 = ary2 === undefined2 ? ary2 : nativeMax(toInteger(ary2), 0);
          arity = arity === undefined2 ? arity : toInteger(arity);
          length -= holders ? holders.length : 0;
          if (bitmask & WRAP_PARTIAL_RIGHT_FLAG) {
            var partialsRight = partials, holdersRight = holders;
            partials = holders = undefined2;
          }
          var data = isBindKey ? undefined2 : getData(func2);
          var newData = [
            func2,
            bitmask,
            thisArg,
            partials,
            holders,
            partialsRight,
            holdersRight,
            argPos,
            ary2,
            arity
          ];
          if (data) {
            mergeData(newData, data);
          }
          func2 = newData[0];
          bitmask = newData[1];
          thisArg = newData[2];
          partials = newData[3];
          holders = newData[4];
          arity = newData[9] = newData[9] === undefined2 ? isBindKey ? 0 : func2.length : nativeMax(newData[9] - length, 0);
          if (!arity && bitmask & (WRAP_CURRY_FLAG | WRAP_CURRY_RIGHT_FLAG)) {
            bitmask &= ~(WRAP_CURRY_FLAG | WRAP_CURRY_RIGHT_FLAG);
          }
          if (!bitmask || bitmask == WRAP_BIND_FLAG) {
            var result3 = createBind(func2, bitmask, thisArg);
          } else if (bitmask == WRAP_CURRY_FLAG || bitmask == WRAP_CURRY_RIGHT_FLAG) {
            result3 = createCurry(func2, bitmask, arity);
          } else if ((bitmask == WRAP_PARTIAL_FLAG || bitmask == (WRAP_BIND_FLAG | WRAP_PARTIAL_FLAG)) && !holders.length) {
            result3 = createPartial(func2, bitmask, thisArg, partials);
          } else {
            result3 = createHybrid.apply(undefined2, newData);
          }
          var setter = data ? baseSetData : setData;
          return setWrapToString(setter(result3, newData), func2, bitmask);
        }
        function customDefaultsAssignIn(objValue, srcValue, key2, object) {
          if (objValue === undefined2 || eq(objValue, objectProto[key2]) && !hasOwnProperty2.call(object, key2)) {
            return srcValue;
          }
          return objValue;
        }
        function customDefaultsMerge(objValue, srcValue, key2, object, source, stack) {
          if (isObject2(objValue) && isObject2(srcValue)) {
            stack.set(srcValue, objValue);
            baseMerge(objValue, srcValue, undefined2, customDefaultsMerge, stack);
            stack["delete"](srcValue);
          }
          return objValue;
        }
        function customOmitClone(value) {
          return isPlainObject(value) ? undefined2 : value;
        }
        function equalArrays(array, other, bitmask, customizer, equalFunc, stack) {
          var isPartial = bitmask & COMPARE_PARTIAL_FLAG, arrLength = array.length, othLength = other.length;
          if (arrLength != othLength && !(isPartial && othLength > arrLength)) {
            return false;
          }
          var arrStacked = stack.get(array);
          var othStacked = stack.get(other);
          if (arrStacked && othStacked) {
            return arrStacked == other && othStacked == array;
          }
          var index = -1, result3 = true, seen = bitmask & COMPARE_UNORDERED_FLAG ? new SetCache() : undefined2;
          stack.set(array, other);
          stack.set(other, array);
          while (++index < arrLength) {
            var arrValue = array[index], othValue = other[index];
            if (customizer) {
              var compared = isPartial ? customizer(othValue, arrValue, index, other, array, stack) : customizer(arrValue, othValue, index, array, other, stack);
            }
            if (compared !== undefined2) {
              if (compared) {
                continue;
              }
              result3 = false;
              break;
            }
            if (seen) {
              if (!arraySome(other, function(othValue2, othIndex) {
                if (!cacheHas(seen, othIndex) && (arrValue === othValue2 || equalFunc(arrValue, othValue2, bitmask, customizer, stack))) {
                  return seen.push(othIndex);
                }
              })) {
                result3 = false;
                break;
              }
            } else if (!(arrValue === othValue || equalFunc(arrValue, othValue, bitmask, customizer, stack))) {
              result3 = false;
              break;
            }
          }
          stack["delete"](array);
          stack["delete"](other);
          return result3;
        }
        function equalByTag(object, other, tag, bitmask, customizer, equalFunc, stack) {
          switch (tag) {
            case dataViewTag:
              if (object.byteLength != other.byteLength || object.byteOffset != other.byteOffset) {
                return false;
              }
              object = object.buffer;
              other = other.buffer;
            case arrayBufferTag:
              if (object.byteLength != other.byteLength || !equalFunc(new Uint8Array2(object), new Uint8Array2(other))) {
                return false;
              }
              return true;
            case boolTag:
            case dateTag:
            case numberTag:
              return eq(+object, +other);
            case errorTag:
              return object.name == other.name && object.message == other.message;
            case regexpTag:
            case stringTag:
              return object == other + "";
            case mapTag:
              var convert = mapToArray;
            case setTag:
              var isPartial = bitmask & COMPARE_PARTIAL_FLAG;
              convert || (convert = setToArray);
              if (object.size != other.size && !isPartial) {
                return false;
              }
              var stacked = stack.get(object);
              if (stacked) {
                return stacked == other;
              }
              bitmask |= COMPARE_UNORDERED_FLAG;
              stack.set(object, other);
              var result3 = equalArrays(convert(object), convert(other), bitmask, customizer, equalFunc, stack);
              stack["delete"](object);
              return result3;
            case symbolTag:
              if (symbolValueOf) {
                return symbolValueOf.call(object) == symbolValueOf.call(other);
              }
          }
          return false;
        }
        function equalObjects(object, other, bitmask, customizer, equalFunc, stack) {
          var isPartial = bitmask & COMPARE_PARTIAL_FLAG, objProps = getAllKeys(object), objLength = objProps.length, othProps = getAllKeys(other), othLength = othProps.length;
          if (objLength != othLength && !isPartial) {
            return false;
          }
          var index = objLength;
          while (index--) {
            var key2 = objProps[index];
            if (!(isPartial ? key2 in other : hasOwnProperty2.call(other, key2))) {
              return false;
            }
          }
          var objStacked = stack.get(object);
          var othStacked = stack.get(other);
          if (objStacked && othStacked) {
            return objStacked == other && othStacked == object;
          }
          var result3 = true;
          stack.set(object, other);
          stack.set(other, object);
          var skipCtor = isPartial;
          while (++index < objLength) {
            key2 = objProps[index];
            var objValue = object[key2], othValue = other[key2];
            if (customizer) {
              var compared = isPartial ? customizer(othValue, objValue, key2, other, object, stack) : customizer(objValue, othValue, key2, object, other, stack);
            }
            if (!(compared === undefined2 ? objValue === othValue || equalFunc(objValue, othValue, bitmask, customizer, stack) : compared)) {
              result3 = false;
              break;
            }
            skipCtor || (skipCtor = key2 == "constructor");
          }
          if (result3 && !skipCtor) {
            var objCtor = object.constructor, othCtor = other.constructor;
            if (objCtor != othCtor && ("constructor" in object && "constructor" in other) && !(typeof objCtor == "function" && objCtor instanceof objCtor && typeof othCtor == "function" && othCtor instanceof othCtor)) {
              result3 = false;
            }
          }
          stack["delete"](object);
          stack["delete"](other);
          return result3;
        }
        function flatRest(func2) {
          return setToString(overRest(func2, undefined2, flatten), func2 + "");
        }
        function getAllKeys(object) {
          return baseGetAllKeys(object, keys, getSymbols);
        }
        function getAllKeysIn(object) {
          return baseGetAllKeys(object, keysIn, getSymbolsIn);
        }
        var getData = !metaMap ? noop : function(func2) {
          return metaMap.get(func2);
        };
        function getFuncName(func2) {
          var result3 = func2.name + "", array = realNames[result3], length = hasOwnProperty2.call(realNames, result3) ? array.length : 0;
          while (length--) {
            var data = array[length], otherFunc = data.func;
            if (otherFunc == null || otherFunc == func2) {
              return data.name;
            }
          }
          return result3;
        }
        function getHolder(func2) {
          var object = hasOwnProperty2.call(lodash, "placeholder") ? lodash : func2;
          return object.placeholder;
        }
        function getIteratee() {
          var result3 = lodash.iteratee || iteratee;
          result3 = result3 === iteratee ? baseIteratee : result3;
          return arguments.length ? result3(arguments[0], arguments[1]) : result3;
        }
        function getMapData(map3, key2) {
          var data = map3.__data__;
          return isKeyable(key2) ? data[typeof key2 == "string" ? "string" : "hash"] : data.map;
        }
        function getMatchData(object) {
          var result3 = keys(object), length = result3.length;
          while (length--) {
            var key2 = result3[length], value = object[key2];
            result3[length] = [key2, value, isStrictComparable(value)];
          }
          return result3;
        }
        function getNative(object, key2) {
          var value = getValue2(object, key2);
          return baseIsNative(value) ? value : undefined2;
        }
        function getRawTag(value) {
          var isOwn = hasOwnProperty2.call(value, symToStringTag), tag = value[symToStringTag];
          try {
            value[symToStringTag] = undefined2;
            var unmasked = true;
          } catch (e2) {
          }
          var result3 = nativeObjectToString.call(value);
          if (unmasked) {
            if (isOwn) {
              value[symToStringTag] = tag;
            } else {
              delete value[symToStringTag];
            }
          }
          return result3;
        }
        var getSymbols = !nativeGetSymbols ? stubArray : function(object) {
          if (object == null) {
            return [];
          }
          object = Object2(object);
          return arrayFilter(nativeGetSymbols(object), function(symbol) {
            return propertyIsEnumerable.call(object, symbol);
          });
        };
        var getSymbolsIn = !nativeGetSymbols ? stubArray : function(object) {
          var result3 = [];
          while (object) {
            arrayPush(result3, getSymbols(object));
            object = getPrototype(object);
          }
          return result3;
        };
        var getTag = baseGetTag;
        if (DataView2 && getTag(new DataView2(new ArrayBuffer(1))) != dataViewTag || Map2 && getTag(new Map2()) != mapTag || Promise2 && getTag(Promise2.resolve()) != promiseTag || Set2 && getTag(new Set2()) != setTag || WeakMap2 && getTag(new WeakMap2()) != weakMapTag) {
          getTag = function(value) {
            var result3 = baseGetTag(value), Ctor = result3 == objectTag ? value.constructor : undefined2, ctorString = Ctor ? toSource(Ctor) : "";
            if (ctorString) {
              switch (ctorString) {
                case dataViewCtorString:
                  return dataViewTag;
                case mapCtorString:
                  return mapTag;
                case promiseCtorString:
                  return promiseTag;
                case setCtorString:
                  return setTag;
                case weakMapCtorString:
                  return weakMapTag;
              }
            }
            return result3;
          };
        }
        function getView(start, end, transforms) {
          var index = -1, length = transforms.length;
          while (++index < length) {
            var data = transforms[index], size2 = data.size;
            switch (data.type) {
              case "drop":
                start += size2;
                break;
              case "dropRight":
                end -= size2;
                break;
              case "take":
                end = nativeMin(end, start + size2);
                break;
              case "takeRight":
                start = nativeMax(start, end - size2);
                break;
            }
          }
          return { "start": start, "end": end };
        }
        function getWrapDetails(source) {
          var match = source.match(reWrapDetails);
          return match ? match[1].split(reSplitDetails) : [];
        }
        function hasPath(object, path2, hasFunc) {
          path2 = castPath(path2, object);
          var index = -1, length = path2.length, result3 = false;
          while (++index < length) {
            var key2 = toKey(path2[index]);
            if (!(result3 = object != null && hasFunc(object, key2))) {
              break;
            }
            object = object[key2];
          }
          if (result3 || ++index != length) {
            return result3;
          }
          length = object == null ? 0 : object.length;
          return !!length && isLength(length) && isIndex(key2, length) && (isArray(object) || isArguments(object));
        }
        function initCloneArray(array) {
          var length = array.length, result3 = new array.constructor(length);
          if (length && typeof array[0] == "string" && hasOwnProperty2.call(array, "index")) {
            result3.index = array.index;
            result3.input = array.input;
          }
          return result3;
        }
        function initCloneObject(object) {
          return typeof object.constructor == "function" && !isPrototype(object) ? baseCreate(getPrototype(object)) : {};
        }
        function initCloneByTag(object, tag, isDeep) {
          var Ctor = object.constructor;
          switch (tag) {
            case arrayBufferTag:
              return cloneArrayBuffer(object);
            case boolTag:
            case dateTag:
              return new Ctor(+object);
            case dataViewTag:
              return cloneDataView(object, isDeep);
            case float32Tag:
            case float64Tag:
            case int8Tag:
            case int16Tag:
            case int32Tag:
            case uint8Tag:
            case uint8ClampedTag:
            case uint16Tag:
            case uint32Tag:
              return cloneTypedArray(object, isDeep);
            case mapTag:
              return new Ctor();
            case numberTag:
            case stringTag:
              return new Ctor(object);
            case regexpTag:
              return cloneRegExp(object);
            case setTag:
              return new Ctor();
            case symbolTag:
              return cloneSymbol(object);
          }
        }
        function insertWrapDetails(source, details) {
          var length = details.length;
          if (!length) {
            return source;
          }
          var lastIndex = length - 1;
          details[lastIndex] = (length > 1 ? "& " : "") + details[lastIndex];
          details = details.join(length > 2 ? ", " : " ");
          return source.replace(reWrapComment, "{\n/* [wrapped with " + details + "] */\n");
        }
        function isFlattenable(value) {
          return isArray(value) || isArguments(value) || !!(spreadableSymbol && value && value[spreadableSymbol]);
        }
        function isIndex(value, length) {
          var type3 = typeof value;
          length = length == null ? MAX_SAFE_INTEGER : length;
          return !!length && (type3 == "number" || type3 != "symbol" && reIsUint.test(value)) && (value > -1 && value % 1 == 0 && value < length);
        }
        function isIterateeCall(value, index, object) {
          if (!isObject2(object)) {
            return false;
          }
          var type3 = typeof index;
          if (type3 == "number" ? isArrayLike(object) && isIndex(index, object.length) : type3 == "string" && index in object) {
            return eq(object[index], value);
          }
          return false;
        }
        function isKey(value, object) {
          if (isArray(value)) {
            return false;
          }
          var type3 = typeof value;
          if (type3 == "number" || type3 == "symbol" || type3 == "boolean" || value == null || isSymbol(value)) {
            return true;
          }
          return reIsPlainProp.test(value) || !reIsDeepProp.test(value) || object != null && value in Object2(object);
        }
        function isKeyable(value) {
          var type3 = typeof value;
          return type3 == "string" || type3 == "number" || type3 == "symbol" || type3 == "boolean" ? value !== "__proto__" : value === null;
        }
        function isLaziable(func2) {
          var funcName = getFuncName(func2), other = lodash[funcName];
          if (typeof other != "function" || !(funcName in LazyWrapper.prototype)) {
            return false;
          }
          if (func2 === other) {
            return true;
          }
          var data = getData(other);
          return !!data && func2 === data[0];
        }
        function isMasked(func2) {
          return !!maskSrcKey && maskSrcKey in func2;
        }
        var isMaskable = coreJsData ? isFunction : stubFalse;
        function isPrototype(value) {
          var Ctor = value && value.constructor, proto = typeof Ctor == "function" && Ctor.prototype || objectProto;
          return value === proto;
        }
        function isStrictComparable(value) {
          return value === value && !isObject2(value);
        }
        function matchesStrictComparable(key2, srcValue) {
          return function(object) {
            if (object == null) {
              return false;
            }
            return object[key2] === srcValue && (srcValue !== undefined2 || key2 in Object2(object));
          };
        }
        function memoizeCapped(func2) {
          var result3 = memoize(func2, function(key2) {
            if (cache.size === MAX_MEMOIZE_SIZE) {
              cache.clear();
            }
            return key2;
          });
          var cache = result3.cache;
          return result3;
        }
        function mergeData(data, source) {
          var bitmask = data[1], srcBitmask = source[1], newBitmask = bitmask | srcBitmask, isCommon = newBitmask < (WRAP_BIND_FLAG | WRAP_BIND_KEY_FLAG | WRAP_ARY_FLAG);
          var isCombo = srcBitmask == WRAP_ARY_FLAG && bitmask == WRAP_CURRY_FLAG || srcBitmask == WRAP_ARY_FLAG && bitmask == WRAP_REARG_FLAG && data[7].length <= source[8] || srcBitmask == (WRAP_ARY_FLAG | WRAP_REARG_FLAG) && source[7].length <= source[8] && bitmask == WRAP_CURRY_FLAG;
          if (!(isCommon || isCombo)) {
            return data;
          }
          if (srcBitmask & WRAP_BIND_FLAG) {
            data[2] = source[2];
            newBitmask |= bitmask & WRAP_BIND_FLAG ? 0 : WRAP_CURRY_BOUND_FLAG;
          }
          var value = source[3];
          if (value) {
            var partials = data[3];
            data[3] = partials ? composeArgs(partials, value, source[4]) : value;
            data[4] = partials ? replaceHolders(data[3], PLACEHOLDER) : source[4];
          }
          value = source[5];
          if (value) {
            partials = data[5];
            data[5] = partials ? composeArgsRight(partials, value, source[6]) : value;
            data[6] = partials ? replaceHolders(data[5], PLACEHOLDER) : source[6];
          }
          value = source[7];
          if (value) {
            data[7] = value;
          }
          if (srcBitmask & WRAP_ARY_FLAG) {
            data[8] = data[8] == null ? source[8] : nativeMin(data[8], source[8]);
          }
          if (data[9] == null) {
            data[9] = source[9];
          }
          data[0] = source[0];
          data[1] = newBitmask;
          return data;
        }
        function nativeKeysIn(object) {
          var result3 = [];
          if (object != null) {
            for (var key2 in Object2(object)) {
              result3.push(key2);
            }
          }
          return result3;
        }
        function objectToString(value) {
          return nativeObjectToString.call(value);
        }
        function overRest(func2, start, transform2) {
          start = nativeMax(start === undefined2 ? func2.length - 1 : start, 0);
          return function() {
            var args = arguments, index = -1, length = nativeMax(args.length - start, 0), array = Array2(length);
            while (++index < length) {
              array[index] = args[start + index];
            }
            index = -1;
            var otherArgs = Array2(start + 1);
            while (++index < start) {
              otherArgs[index] = args[index];
            }
            otherArgs[start] = transform2(array);
            return apply(func2, this, otherArgs);
          };
        }
        function parent(object, path2) {
          return path2.length < 2 ? object : baseGet(object, baseSlice(path2, 0, -1));
        }
        function reorder(array, indexes) {
          var arrLength = array.length, length = nativeMin(indexes.length, arrLength), oldArray = copyArray(array);
          while (length--) {
            var index = indexes[length];
            array[length] = isIndex(index, arrLength) ? oldArray[index] : undefined2;
          }
          return array;
        }
        function safeGet(object, key2) {
          if (key2 === "constructor" && typeof object[key2] === "function") {
            return;
          }
          if (key2 == "__proto__") {
            return;
          }
          return object[key2];
        }
        var setData = shortOut(baseSetData);
        var setTimeout2 = ctxSetTimeout || function(func2, wait) {
          return root.setTimeout(func2, wait);
        };
        var setToString = shortOut(baseSetToString);
        function setWrapToString(wrapper, reference, bitmask) {
          var source = reference + "";
          return setToString(wrapper, insertWrapDetails(source, updateWrapDetails(getWrapDetails(source), bitmask)));
        }
        function shortOut(func2) {
          var count = 0, lastCalled = 0;
          return function() {
            var stamp = nativeNow(), remaining = HOT_SPAN - (stamp - lastCalled);
            lastCalled = stamp;
            if (remaining > 0) {
              if (++count >= HOT_COUNT) {
                return arguments[0];
              }
            } else {
              count = 0;
            }
            return func2.apply(undefined2, arguments);
          };
        }
        function shuffleSelf(array, size2) {
          var index = -1, length = array.length, lastIndex = length - 1;
          size2 = size2 === undefined2 ? length : size2;
          while (++index < size2) {
            var rand = baseRandom(index, lastIndex), value = array[rand];
            array[rand] = array[index];
            array[index] = value;
          }
          array.length = size2;
          return array;
        }
        var stringToPath = memoizeCapped(function(string) {
          var result3 = [];
          if (string.charCodeAt(0) === 46) {
            result3.push("");
          }
          string.replace(rePropName, function(match, number, quote, subString) {
            result3.push(quote ? subString.replace(reEscapeChar, "$1") : number || match);
          });
          return result3;
        });
        function toKey(value) {
          if (typeof value == "string" || isSymbol(value)) {
            return value;
          }
          var result3 = value + "";
          return result3 == "0" && 1 / value == -INFINITY ? "-0" : result3;
        }
        function toSource(func2) {
          if (func2 != null) {
            try {
              return funcToString.call(func2);
            } catch (e2) {
            }
            try {
              return func2 + "";
            } catch (e2) {
            }
          }
          return "";
        }
        function updateWrapDetails(details, bitmask) {
          arrayEach(wrapFlags, function(pair) {
            var value = "_." + pair[0];
            if (bitmask & pair[1] && !arrayIncludes(details, value)) {
              details.push(value);
            }
          });
          return details.sort();
        }
        function wrapperClone(wrapper) {
          if (wrapper instanceof LazyWrapper) {
            return wrapper.clone();
          }
          var result3 = new LodashWrapper(wrapper.__wrapped__, wrapper.__chain__);
          result3.__actions__ = copyArray(wrapper.__actions__);
          result3.__index__ = wrapper.__index__;
          result3.__values__ = wrapper.__values__;
          return result3;
        }
        function chunk(array, size2, guard) {
          if (guard ? isIterateeCall(array, size2, guard) : size2 === undefined2) {
            size2 = 1;
          } else {
            size2 = nativeMax(toInteger(size2), 0);
          }
          var length = array == null ? 0 : array.length;
          if (!length || size2 < 1) {
            return [];
          }
          var index = 0, resIndex = 0, result3 = Array2(nativeCeil(length / size2));
          while (index < length) {
            result3[resIndex++] = baseSlice(array, index, index += size2);
          }
          return result3;
        }
        function compact(array) {
          var index = -1, length = array == null ? 0 : array.length, resIndex = 0, result3 = [];
          while (++index < length) {
            var value = array[index];
            if (value) {
              result3[resIndex++] = value;
            }
          }
          return result3;
        }
        function concat() {
          var length = arguments.length;
          if (!length) {
            return [];
          }
          var args = Array2(length - 1), array = arguments[0], index = length;
          while (index--) {
            args[index - 1] = arguments[index];
          }
          return arrayPush(isArray(array) ? copyArray(array) : [array], baseFlatten(args, 1));
        }
        var difference = baseRest(function(array, values2) {
          return isArrayLikeObject(array) ? baseDifference(array, baseFlatten(values2, 1, isArrayLikeObject, true)) : [];
        });
        var differenceBy = baseRest(function(array, values2) {
          var iteratee2 = last(values2);
          if (isArrayLikeObject(iteratee2)) {
            iteratee2 = undefined2;
          }
          return isArrayLikeObject(array) ? baseDifference(array, baseFlatten(values2, 1, isArrayLikeObject, true), getIteratee(iteratee2, 2)) : [];
        });
        var differenceWith = baseRest(function(array, values2) {
          var comparator = last(values2);
          if (isArrayLikeObject(comparator)) {
            comparator = undefined2;
          }
          return isArrayLikeObject(array) ? baseDifference(array, baseFlatten(values2, 1, isArrayLikeObject, true), undefined2, comparator) : [];
        });
        function drop(array, n2, guard) {
          var length = array == null ? 0 : array.length;
          if (!length) {
            return [];
          }
          n2 = guard || n2 === undefined2 ? 1 : toInteger(n2);
          return baseSlice(array, n2 < 0 ? 0 : n2, length);
        }
        function dropRight(array, n2, guard) {
          var length = array == null ? 0 : array.length;
          if (!length) {
            return [];
          }
          n2 = guard || n2 === undefined2 ? 1 : toInteger(n2);
          n2 = length - n2;
          return baseSlice(array, 0, n2 < 0 ? 0 : n2);
        }
        function dropRightWhile(array, predicate) {
          return array && array.length ? baseWhile(array, getIteratee(predicate, 3), true, true) : [];
        }
        function dropWhile(array, predicate) {
          return array && array.length ? baseWhile(array, getIteratee(predicate, 3), true) : [];
        }
        function fill(array, value, start, end) {
          var length = array == null ? 0 : array.length;
          if (!length) {
            return [];
          }
          if (start && typeof start != "number" && isIterateeCall(array, value, start)) {
            start = 0;
            end = length;
          }
          return baseFill(array, value, start, end);
        }
        function findIndex(array, predicate, fromIndex) {
          var length = array == null ? 0 : array.length;
          if (!length) {
            return -1;
          }
          var index = fromIndex == null ? 0 : toInteger(fromIndex);
          if (index < 0) {
            index = nativeMax(length + index, 0);
          }
          return baseFindIndex(array, getIteratee(predicate, 3), index);
        }
        function findLastIndex(array, predicate, fromIndex) {
          var length = array == null ? 0 : array.length;
          if (!length) {
            return -1;
          }
          var index = length - 1;
          if (fromIndex !== undefined2) {
            index = toInteger(fromIndex);
            index = fromIndex < 0 ? nativeMax(length + index, 0) : nativeMin(index, length - 1);
          }
          return baseFindIndex(array, getIteratee(predicate, 3), index, true);
        }
        function flatten(array) {
          var length = array == null ? 0 : array.length;
          return length ? baseFlatten(array, 1) : [];
        }
        function flattenDeep(array) {
          var length = array == null ? 0 : array.length;
          return length ? baseFlatten(array, INFINITY) : [];
        }
        function flattenDepth(array, depth) {
          var length = array == null ? 0 : array.length;
          if (!length) {
            return [];
          }
          depth = depth === undefined2 ? 1 : toInteger(depth);
          return baseFlatten(array, depth);
        }
        function fromPairs(pairs2) {
          var index = -1, length = pairs2 == null ? 0 : pairs2.length, result3 = {};
          while (++index < length) {
            var pair = pairs2[index];
            result3[pair[0]] = pair[1];
          }
          return result3;
        }
        function head(array) {
          return array && array.length ? array[0] : undefined2;
        }
        function indexOf(array, value, fromIndex) {
          var length = array == null ? 0 : array.length;
          if (!length) {
            return -1;
          }
          var index = fromIndex == null ? 0 : toInteger(fromIndex);
          if (index < 0) {
            index = nativeMax(length + index, 0);
          }
          return baseIndexOf(array, value, index);
        }
        function initial(array) {
          var length = array == null ? 0 : array.length;
          return length ? baseSlice(array, 0, -1) : [];
        }
        var intersection = baseRest(function(arrays) {
          var mapped = arrayMap(arrays, castArrayLikeObject);
          return mapped.length && mapped[0] === arrays[0] ? baseIntersection(mapped) : [];
        });
        var intersectionBy = baseRest(function(arrays) {
          var iteratee2 = last(arrays), mapped = arrayMap(arrays, castArrayLikeObject);
          if (iteratee2 === last(mapped)) {
            iteratee2 = undefined2;
          } else {
            mapped.pop();
          }
          return mapped.length && mapped[0] === arrays[0] ? baseIntersection(mapped, getIteratee(iteratee2, 2)) : [];
        });
        var intersectionWith = baseRest(function(arrays) {
          var comparator = last(arrays), mapped = arrayMap(arrays, castArrayLikeObject);
          comparator = typeof comparator == "function" ? comparator : undefined2;
          if (comparator) {
            mapped.pop();
          }
          return mapped.length && mapped[0] === arrays[0] ? baseIntersection(mapped, undefined2, comparator) : [];
        });
        function join(array, separator) {
          return array == null ? "" : nativeJoin.call(array, separator);
        }
        function last(array) {
          var length = array == null ? 0 : array.length;
          return length ? array[length - 1] : undefined2;
        }
        function lastIndexOf(array, value, fromIndex) {
          var length = array == null ? 0 : array.length;
          if (!length) {
            return -1;
          }
          var index = length;
          if (fromIndex !== undefined2) {
            index = toInteger(fromIndex);
            index = index < 0 ? nativeMax(length + index, 0) : nativeMin(index, length - 1);
          }
          return value === value ? strictLastIndexOf(array, value, index) : baseFindIndex(array, baseIsNaN, index, true);
        }
        function nth(array, n2) {
          return array && array.length ? baseNth(array, toInteger(n2)) : undefined2;
        }
        var pull = baseRest(pullAll);
        function pullAll(array, values2) {
          return array && array.length && values2 && values2.length ? basePullAll(array, values2) : array;
        }
        function pullAllBy(array, values2, iteratee2) {
          return array && array.length && values2 && values2.length ? basePullAll(array, values2, getIteratee(iteratee2, 2)) : array;
        }
        function pullAllWith(array, values2, comparator) {
          return array && array.length && values2 && values2.length ? basePullAll(array, values2, undefined2, comparator) : array;
        }
        var pullAt = flatRest(function(array, indexes) {
          var length = array == null ? 0 : array.length, result3 = baseAt(array, indexes);
          basePullAt(array, arrayMap(indexes, function(index) {
            return isIndex(index, length) ? +index : index;
          }).sort(compareAscending));
          return result3;
        });
        function remove(array, predicate) {
          var result3 = [];
          if (!(array && array.length)) {
            return result3;
          }
          var index = -1, indexes = [], length = array.length;
          predicate = getIteratee(predicate, 3);
          while (++index < length) {
            var value = array[index];
            if (predicate(value, index, array)) {
              result3.push(value);
              indexes.push(index);
            }
          }
          basePullAt(array, indexes);
          return result3;
        }
        function reverse(array) {
          return array == null ? array : nativeReverse.call(array);
        }
        function slice(array, start, end) {
          var length = array == null ? 0 : array.length;
          if (!length) {
            return [];
          }
          if (end && typeof end != "number" && isIterateeCall(array, start, end)) {
            start = 0;
            end = length;
          } else {
            start = start == null ? 0 : toInteger(start);
            end = end === undefined2 ? length : toInteger(end);
          }
          return baseSlice(array, start, end);
        }
        function sortedIndex(array, value) {
          return baseSortedIndex(array, value);
        }
        function sortedIndexBy(array, value, iteratee2) {
          return baseSortedIndexBy(array, value, getIteratee(iteratee2, 2));
        }
        function sortedIndexOf(array, value) {
          var length = array == null ? 0 : array.length;
          if (length) {
            var index = baseSortedIndex(array, value);
            if (index < length && eq(array[index], value)) {
              return index;
            }
          }
          return -1;
        }
        function sortedLastIndex(array, value) {
          return baseSortedIndex(array, value, true);
        }
        function sortedLastIndexBy(array, value, iteratee2) {
          return baseSortedIndexBy(array, value, getIteratee(iteratee2, 2), true);
        }
        function sortedLastIndexOf(array, value) {
          var length = array == null ? 0 : array.length;
          if (length) {
            var index = baseSortedIndex(array, value, true) - 1;
            if (eq(array[index], value)) {
              return index;
            }
          }
          return -1;
        }
        function sortedUniq(array) {
          return array && array.length ? baseSortedUniq(array) : [];
        }
        function sortedUniqBy(array, iteratee2) {
          return array && array.length ? baseSortedUniq(array, getIteratee(iteratee2, 2)) : [];
        }
        function tail(array) {
          var length = array == null ? 0 : array.length;
          return length ? baseSlice(array, 1, length) : [];
        }
        function take(array, n2, guard) {
          if (!(array && array.length)) {
            return [];
          }
          n2 = guard || n2 === undefined2 ? 1 : toInteger(n2);
          return baseSlice(array, 0, n2 < 0 ? 0 : n2);
        }
        function takeRight(array, n2, guard) {
          var length = array == null ? 0 : array.length;
          if (!length) {
            return [];
          }
          n2 = guard || n2 === undefined2 ? 1 : toInteger(n2);
          n2 = length - n2;
          return baseSlice(array, n2 < 0 ? 0 : n2, length);
        }
        function takeRightWhile(array, predicate) {
          return array && array.length ? baseWhile(array, getIteratee(predicate, 3), false, true) : [];
        }
        function takeWhile(array, predicate) {
          return array && array.length ? baseWhile(array, getIteratee(predicate, 3)) : [];
        }
        var union = baseRest(function(arrays) {
          return baseUniq(baseFlatten(arrays, 1, isArrayLikeObject, true));
        });
        var unionBy = baseRest(function(arrays) {
          var iteratee2 = last(arrays);
          if (isArrayLikeObject(iteratee2)) {
            iteratee2 = undefined2;
          }
          return baseUniq(baseFlatten(arrays, 1, isArrayLikeObject, true), getIteratee(iteratee2, 2));
        });
        var unionWith = baseRest(function(arrays) {
          var comparator = last(arrays);
          comparator = typeof comparator == "function" ? comparator : undefined2;
          return baseUniq(baseFlatten(arrays, 1, isArrayLikeObject, true), undefined2, comparator);
        });
        function uniq(array) {
          return array && array.length ? baseUniq(array) : [];
        }
        function uniqBy(array, iteratee2) {
          return array && array.length ? baseUniq(array, getIteratee(iteratee2, 2)) : [];
        }
        function uniqWith(array, comparator) {
          comparator = typeof comparator == "function" ? comparator : undefined2;
          return array && array.length ? baseUniq(array, undefined2, comparator) : [];
        }
        function unzip(array) {
          if (!(array && array.length)) {
            return [];
          }
          var length = 0;
          array = arrayFilter(array, function(group) {
            if (isArrayLikeObject(group)) {
              length = nativeMax(group.length, length);
              return true;
            }
          });
          return baseTimes(length, function(index) {
            return arrayMap(array, baseProperty(index));
          });
        }
        function unzipWith(array, iteratee2) {
          if (!(array && array.length)) {
            return [];
          }
          var result3 = unzip(array);
          if (iteratee2 == null) {
            return result3;
          }
          return arrayMap(result3, function(group) {
            return apply(iteratee2, undefined2, group);
          });
        }
        var without = baseRest(function(array, values2) {
          return isArrayLikeObject(array) ? baseDifference(array, values2) : [];
        });
        var xor = baseRest(function(arrays) {
          return baseXor(arrayFilter(arrays, isArrayLikeObject));
        });
        var xorBy = baseRest(function(arrays) {
          var iteratee2 = last(arrays);
          if (isArrayLikeObject(iteratee2)) {
            iteratee2 = undefined2;
          }
          return baseXor(arrayFilter(arrays, isArrayLikeObject), getIteratee(iteratee2, 2));
        });
        var xorWith = baseRest(function(arrays) {
          var comparator = last(arrays);
          comparator = typeof comparator == "function" ? comparator : undefined2;
          return baseXor(arrayFilter(arrays, isArrayLikeObject), undefined2, comparator);
        });
        var zip = baseRest(unzip);
        function zipObject(props, values2) {
          return baseZipObject(props || [], values2 || [], assignValue);
        }
        function zipObjectDeep(props, values2) {
          return baseZipObject(props || [], values2 || [], baseSet);
        }
        var zipWith = baseRest(function(arrays) {
          var length = arrays.length, iteratee2 = length > 1 ? arrays[length - 1] : undefined2;
          iteratee2 = typeof iteratee2 == "function" ? (arrays.pop(), iteratee2) : undefined2;
          return unzipWith(arrays, iteratee2);
        });
        function chain(value) {
          var result3 = lodash(value);
          result3.__chain__ = true;
          return result3;
        }
        function tap(value, interceptor) {
          interceptor(value);
          return value;
        }
        function thru(value, interceptor) {
          return interceptor(value);
        }
        var wrapperAt = flatRest(function(paths) {
          var length = paths.length, start = length ? paths[0] : 0, value = this.__wrapped__, interceptor = function(object) {
            return baseAt(object, paths);
          };
          if (length > 1 || this.__actions__.length || !(value instanceof LazyWrapper) || !isIndex(start)) {
            return this.thru(interceptor);
          }
          value = value.slice(start, +start + (length ? 1 : 0));
          value.__actions__.push({
            "func": thru,
            "args": [interceptor],
            "thisArg": undefined2
          });
          return new LodashWrapper(value, this.__chain__).thru(function(array) {
            if (length && !array.length) {
              array.push(undefined2);
            }
            return array;
          });
        });
        function wrapperChain() {
          return chain(this);
        }
        function wrapperCommit() {
          return new LodashWrapper(this.value(), this.__chain__);
        }
        function wrapperNext() {
          if (this.__values__ === undefined2) {
            this.__values__ = toArray2(this.value());
          }
          var done = this.__index__ >= this.__values__.length, value = done ? undefined2 : this.__values__[this.__index__++];
          return { "done": done, "value": value };
        }
        function wrapperToIterator() {
          return this;
        }
        function wrapperPlant(value) {
          var result3, parent2 = this;
          while (parent2 instanceof baseLodash) {
            var clone2 = wrapperClone(parent2);
            clone2.__index__ = 0;
            clone2.__values__ = undefined2;
            if (result3) {
              previous.__wrapped__ = clone2;
            } else {
              result3 = clone2;
            }
            var previous = clone2;
            parent2 = parent2.__wrapped__;
          }
          previous.__wrapped__ = value;
          return result3;
        }
        function wrapperReverse() {
          var value = this.__wrapped__;
          if (value instanceof LazyWrapper) {
            var wrapped = value;
            if (this.__actions__.length) {
              wrapped = new LazyWrapper(this);
            }
            wrapped = wrapped.reverse();
            wrapped.__actions__.push({
              "func": thru,
              "args": [reverse],
              "thisArg": undefined2
            });
            return new LodashWrapper(wrapped, this.__chain__);
          }
          return this.thru(reverse);
        }
        function wrapperValue() {
          return baseWrapperValue(this.__wrapped__, this.__actions__);
        }
        var countBy = createAggregator(function(result3, value, key2) {
          if (hasOwnProperty2.call(result3, key2)) {
            ++result3[key2];
          } else {
            baseAssignValue(result3, key2, 1);
          }
        });
        function every(collection, predicate, guard) {
          var func2 = isArray(collection) ? arrayEvery : baseEvery;
          if (guard && isIterateeCall(collection, predicate, guard)) {
            predicate = undefined2;
          }
          return func2(collection, getIteratee(predicate, 3));
        }
        function filter(collection, predicate) {
          var func2 = isArray(collection) ? arrayFilter : baseFilter;
          return func2(collection, getIteratee(predicate, 3));
        }
        var find = createFind(findIndex);
        var findLast = createFind(findLastIndex);
        function flatMap(collection, iteratee2) {
          return baseFlatten(map2(collection, iteratee2), 1);
        }
        function flatMapDeep(collection, iteratee2) {
          return baseFlatten(map2(collection, iteratee2), INFINITY);
        }
        function flatMapDepth(collection, iteratee2, depth) {
          depth = depth === undefined2 ? 1 : toInteger(depth);
          return baseFlatten(map2(collection, iteratee2), depth);
        }
        function forEach(collection, iteratee2) {
          var func2 = isArray(collection) ? arrayEach : baseEach;
          return func2(collection, getIteratee(iteratee2, 3));
        }
        function forEachRight(collection, iteratee2) {
          var func2 = isArray(collection) ? arrayEachRight : baseEachRight;
          return func2(collection, getIteratee(iteratee2, 3));
        }
        var groupBy = createAggregator(function(result3, value, key2) {
          if (hasOwnProperty2.call(result3, key2)) {
            result3[key2].push(value);
          } else {
            baseAssignValue(result3, key2, [value]);
          }
        });
        function includes(collection, value, fromIndex, guard) {
          collection = isArrayLike(collection) ? collection : values(collection);
          fromIndex = fromIndex && !guard ? toInteger(fromIndex) : 0;
          var length = collection.length;
          if (fromIndex < 0) {
            fromIndex = nativeMax(length + fromIndex, 0);
          }
          return isString(collection) ? fromIndex <= length && collection.indexOf(value, fromIndex) > -1 : !!length && baseIndexOf(collection, value, fromIndex) > -1;
        }
        var invokeMap = baseRest(function(collection, path2, args) {
          var index = -1, isFunc = typeof path2 == "function", result3 = isArrayLike(collection) ? Array2(collection.length) : [];
          baseEach(collection, function(value) {
            result3[++index] = isFunc ? apply(path2, value, args) : baseInvoke(value, path2, args);
          });
          return result3;
        });
        var keyBy = createAggregator(function(result3, value, key2) {
          baseAssignValue(result3, key2, value);
        });
        function map2(collection, iteratee2) {
          var func2 = isArray(collection) ? arrayMap : baseMap;
          return func2(collection, getIteratee(iteratee2, 3));
        }
        function orderBy(collection, iteratees, orders, guard) {
          if (collection == null) {
            return [];
          }
          if (!isArray(iteratees)) {
            iteratees = iteratees == null ? [] : [iteratees];
          }
          orders = guard ? undefined2 : orders;
          if (!isArray(orders)) {
            orders = orders == null ? [] : [orders];
          }
          return baseOrderBy(collection, iteratees, orders);
        }
        var partition = createAggregator(function(result3, value, key2) {
          result3[key2 ? 0 : 1].push(value);
        }, function() {
          return [[], []];
        });
        function reduce(collection, iteratee2, accumulator) {
          var func2 = isArray(collection) ? arrayReduce : baseReduce, initAccum = arguments.length < 3;
          return func2(collection, getIteratee(iteratee2, 4), accumulator, initAccum, baseEach);
        }
        function reduceRight(collection, iteratee2, accumulator) {
          var func2 = isArray(collection) ? arrayReduceRight : baseReduce, initAccum = arguments.length < 3;
          return func2(collection, getIteratee(iteratee2, 4), accumulator, initAccum, baseEachRight);
        }
        function reject(collection, predicate) {
          var func2 = isArray(collection) ? arrayFilter : baseFilter;
          return func2(collection, negate(getIteratee(predicate, 3)));
        }
        function sample(collection) {
          var func2 = isArray(collection) ? arraySample : baseSample;
          return func2(collection);
        }
        function sampleSize(collection, n2, guard) {
          if (guard ? isIterateeCall(collection, n2, guard) : n2 === undefined2) {
            n2 = 1;
          } else {
            n2 = toInteger(n2);
          }
          var func2 = isArray(collection) ? arraySampleSize : baseSampleSize;
          return func2(collection, n2);
        }
        function shuffle(collection) {
          var func2 = isArray(collection) ? arrayShuffle : baseShuffle;
          return func2(collection);
        }
        function size(collection) {
          if (collection == null) {
            return 0;
          }
          if (isArrayLike(collection)) {
            return isString(collection) ? stringSize(collection) : collection.length;
          }
          var tag = getTag(collection);
          if (tag == mapTag || tag == setTag) {
            return collection.size;
          }
          return baseKeys(collection).length;
        }
        function some(collection, predicate, guard) {
          var func2 = isArray(collection) ? arraySome : baseSome;
          if (guard && isIterateeCall(collection, predicate, guard)) {
            predicate = undefined2;
          }
          return func2(collection, getIteratee(predicate, 3));
        }
        var sortBy = baseRest(function(collection, iteratees) {
          if (collection == null) {
            return [];
          }
          var length = iteratees.length;
          if (length > 1 && isIterateeCall(collection, iteratees[0], iteratees[1])) {
            iteratees = [];
          } else if (length > 2 && isIterateeCall(iteratees[0], iteratees[1], iteratees[2])) {
            iteratees = [iteratees[0]];
          }
          return baseOrderBy(collection, baseFlatten(iteratees, 1), []);
        });
        var now = ctxNow || function() {
          return root.Date.now();
        };
        function after(n2, func2) {
          if (typeof func2 != "function") {
            throw new TypeError2(FUNC_ERROR_TEXT);
          }
          n2 = toInteger(n2);
          return function() {
            if (--n2 < 1) {
              return func2.apply(this, arguments);
            }
          };
        }
        function ary(func2, n2, guard) {
          n2 = guard ? undefined2 : n2;
          n2 = func2 && n2 == null ? func2.length : n2;
          return createWrap(func2, WRAP_ARY_FLAG, undefined2, undefined2, undefined2, undefined2, n2);
        }
        function before(n2, func2) {
          var result3;
          if (typeof func2 != "function") {
            throw new TypeError2(FUNC_ERROR_TEXT);
          }
          n2 = toInteger(n2);
          return function() {
            if (--n2 > 0) {
              result3 = func2.apply(this, arguments);
            }
            if (n2 <= 1) {
              func2 = undefined2;
            }
            return result3;
          };
        }
        var bind = baseRest(function(func2, thisArg, partials) {
          var bitmask = WRAP_BIND_FLAG;
          if (partials.length) {
            var holders = replaceHolders(partials, getHolder(bind));
            bitmask |= WRAP_PARTIAL_FLAG;
          }
          return createWrap(func2, bitmask, thisArg, partials, holders);
        });
        var bindKey = baseRest(function(object, key2, partials) {
          var bitmask = WRAP_BIND_FLAG | WRAP_BIND_KEY_FLAG;
          if (partials.length) {
            var holders = replaceHolders(partials, getHolder(bindKey));
            bitmask |= WRAP_PARTIAL_FLAG;
          }
          return createWrap(key2, bitmask, object, partials, holders);
        });
        function curry(func2, arity, guard) {
          arity = guard ? undefined2 : arity;
          var result3 = createWrap(func2, WRAP_CURRY_FLAG, undefined2, undefined2, undefined2, undefined2, undefined2, arity);
          result3.placeholder = curry.placeholder;
          return result3;
        }
        function curryRight(func2, arity, guard) {
          arity = guard ? undefined2 : arity;
          var result3 = createWrap(func2, WRAP_CURRY_RIGHT_FLAG, undefined2, undefined2, undefined2, undefined2, undefined2, arity);
          result3.placeholder = curryRight.placeholder;
          return result3;
        }
        function debounce(func2, wait, options) {
          var lastArgs, lastThis, maxWait, result3, timerId, lastCallTime, lastInvokeTime = 0, leading = false, maxing = false, trailing = true;
          if (typeof func2 != "function") {
            throw new TypeError2(FUNC_ERROR_TEXT);
          }
          wait = toNumber(wait) || 0;
          if (isObject2(options)) {
            leading = !!options.leading;
            maxing = "maxWait" in options;
            maxWait = maxing ? nativeMax(toNumber(options.maxWait) || 0, wait) : maxWait;
            trailing = "trailing" in options ? !!options.trailing : trailing;
          }
          function invokeFunc(time) {
            var args = lastArgs, thisArg = lastThis;
            lastArgs = lastThis = undefined2;
            lastInvokeTime = time;
            result3 = func2.apply(thisArg, args);
            return result3;
          }
          function leadingEdge(time) {
            lastInvokeTime = time;
            timerId = setTimeout2(timerExpired, wait);
            return leading ? invokeFunc(time) : result3;
          }
          function remainingWait(time) {
            var timeSinceLastCall = time - lastCallTime, timeSinceLastInvoke = time - lastInvokeTime, timeWaiting = wait - timeSinceLastCall;
            return maxing ? nativeMin(timeWaiting, maxWait - timeSinceLastInvoke) : timeWaiting;
          }
          function shouldInvoke(time) {
            var timeSinceLastCall = time - lastCallTime, timeSinceLastInvoke = time - lastInvokeTime;
            return lastCallTime === undefined2 || timeSinceLastCall >= wait || timeSinceLastCall < 0 || maxing && timeSinceLastInvoke >= maxWait;
          }
          function timerExpired() {
            var time = now();
            if (shouldInvoke(time)) {
              return trailingEdge(time);
            }
            timerId = setTimeout2(timerExpired, remainingWait(time));
          }
          function trailingEdge(time) {
            timerId = undefined2;
            if (trailing && lastArgs) {
              return invokeFunc(time);
            }
            lastArgs = lastThis = undefined2;
            return result3;
          }
          function cancel() {
            if (timerId !== undefined2) {
              clearTimeout2(timerId);
            }
            lastInvokeTime = 0;
            lastArgs = lastCallTime = lastThis = timerId = undefined2;
          }
          function flush() {
            return timerId === undefined2 ? result3 : trailingEdge(now());
          }
          function debounced() {
            var time = now(), isInvoking = shouldInvoke(time);
            lastArgs = arguments;
            lastThis = this;
            lastCallTime = time;
            if (isInvoking) {
              if (timerId === undefined2) {
                return leadingEdge(lastCallTime);
              }
              if (maxing) {
                clearTimeout2(timerId);
                timerId = setTimeout2(timerExpired, wait);
                return invokeFunc(lastCallTime);
              }
            }
            if (timerId === undefined2) {
              timerId = setTimeout2(timerExpired, wait);
            }
            return result3;
          }
          debounced.cancel = cancel;
          debounced.flush = flush;
          return debounced;
        }
        var defer = baseRest(function(func2, args) {
          return baseDelay(func2, 1, args);
        });
        var delay = baseRest(function(func2, wait, args) {
          return baseDelay(func2, toNumber(wait) || 0, args);
        });
        function flip(func2) {
          return createWrap(func2, WRAP_FLIP_FLAG);
        }
        function memoize(func2, resolver) {
          if (typeof func2 != "function" || resolver != null && typeof resolver != "function") {
            throw new TypeError2(FUNC_ERROR_TEXT);
          }
          var memoized = function() {
            var args = arguments, key2 = resolver ? resolver.apply(this, args) : args[0], cache = memoized.cache;
            if (cache.has(key2)) {
              return cache.get(key2);
            }
            var result3 = func2.apply(this, args);
            memoized.cache = cache.set(key2, result3) || cache;
            return result3;
          };
          memoized.cache = new (memoize.Cache || MapCache)();
          return memoized;
        }
        memoize.Cache = MapCache;
        function negate(predicate) {
          if (typeof predicate != "function") {
            throw new TypeError2(FUNC_ERROR_TEXT);
          }
          return function() {
            var args = arguments;
            switch (args.length) {
              case 0:
                return !predicate.call(this);
              case 1:
                return !predicate.call(this, args[0]);
              case 2:
                return !predicate.call(this, args[0], args[1]);
              case 3:
                return !predicate.call(this, args[0], args[1], args[2]);
            }
            return !predicate.apply(this, args);
          };
        }
        function once(func2) {
          return before(2, func2);
        }
        var overArgs = castRest(function(func2, transforms) {
          transforms = transforms.length == 1 && isArray(transforms[0]) ? arrayMap(transforms[0], baseUnary(getIteratee())) : arrayMap(baseFlatten(transforms, 1), baseUnary(getIteratee()));
          var funcsLength = transforms.length;
          return baseRest(function(args) {
            var index = -1, length = nativeMin(args.length, funcsLength);
            while (++index < length) {
              args[index] = transforms[index].call(this, args[index]);
            }
            return apply(func2, this, args);
          });
        });
        var partial = baseRest(function(func2, partials) {
          var holders = replaceHolders(partials, getHolder(partial));
          return createWrap(func2, WRAP_PARTIAL_FLAG, undefined2, partials, holders);
        });
        var partialRight = baseRest(function(func2, partials) {
          var holders = replaceHolders(partials, getHolder(partialRight));
          return createWrap(func2, WRAP_PARTIAL_RIGHT_FLAG, undefined2, partials, holders);
        });
        var rearg = flatRest(function(func2, indexes) {
          return createWrap(func2, WRAP_REARG_FLAG, undefined2, undefined2, undefined2, indexes);
        });
        function rest(func2, start) {
          if (typeof func2 != "function") {
            throw new TypeError2(FUNC_ERROR_TEXT);
          }
          start = start === undefined2 ? start : toInteger(start);
          return baseRest(func2, start);
        }
        function spread(func2, start) {
          if (typeof func2 != "function") {
            throw new TypeError2(FUNC_ERROR_TEXT);
          }
          start = start == null ? 0 : nativeMax(toInteger(start), 0);
          return baseRest(function(args) {
            var array = args[start], otherArgs = castSlice(args, 0, start);
            if (array) {
              arrayPush(otherArgs, array);
            }
            return apply(func2, this, otherArgs);
          });
        }
        function throttle(func2, wait, options) {
          var leading = true, trailing = true;
          if (typeof func2 != "function") {
            throw new TypeError2(FUNC_ERROR_TEXT);
          }
          if (isObject2(options)) {
            leading = "leading" in options ? !!options.leading : leading;
            trailing = "trailing" in options ? !!options.trailing : trailing;
          }
          return debounce(func2, wait, {
            "leading": leading,
            "maxWait": wait,
            "trailing": trailing
          });
        }
        function unary(func2) {
          return ary(func2, 1);
        }
        function wrap(value, wrapper) {
          return partial(castFunction(wrapper), value);
        }
        function castArray() {
          if (!arguments.length) {
            return [];
          }
          var value = arguments[0];
          return isArray(value) ? value : [value];
        }
        function clone(value) {
          return baseClone(value, CLONE_SYMBOLS_FLAG);
        }
        function cloneWith(value, customizer) {
          customizer = typeof customizer == "function" ? customizer : undefined2;
          return baseClone(value, CLONE_SYMBOLS_FLAG, customizer);
        }
        function cloneDeep(value) {
          return baseClone(value, CLONE_DEEP_FLAG | CLONE_SYMBOLS_FLAG);
        }
        function cloneDeepWith(value, customizer) {
          customizer = typeof customizer == "function" ? customizer : undefined2;
          return baseClone(value, CLONE_DEEP_FLAG | CLONE_SYMBOLS_FLAG, customizer);
        }
        function conformsTo(object, source) {
          return source == null || baseConformsTo(object, source, keys(source));
        }
        function eq(value, other) {
          return value === other || value !== value && other !== other;
        }
        var gt = createRelationalOperation(baseGt);
        var gte = createRelationalOperation(function(value, other) {
          return value >= other;
        });
        var isArguments = baseIsArguments(function() {
          return arguments;
        }()) ? baseIsArguments : function(value) {
          return isObjectLike(value) && hasOwnProperty2.call(value, "callee") && !propertyIsEnumerable.call(value, "callee");
        };
        var isArray = Array2.isArray;
        var isArrayBuffer = nodeIsArrayBuffer ? baseUnary(nodeIsArrayBuffer) : baseIsArrayBuffer;
        function isArrayLike(value) {
          return value != null && isLength(value.length) && !isFunction(value);
        }
        function isArrayLikeObject(value) {
          return isObjectLike(value) && isArrayLike(value);
        }
        function isBoolean2(value) {
          return value === true || value === false || isObjectLike(value) && baseGetTag(value) == boolTag;
        }
        var isBuffer = nativeIsBuffer || stubFalse;
        var isDate = nodeIsDate ? baseUnary(nodeIsDate) : baseIsDate;
        function isElement(value) {
          return isObjectLike(value) && value.nodeType === 1 && !isPlainObject(value);
        }
        function isEmpty(value) {
          if (value == null) {
            return true;
          }
          if (isArrayLike(value) && (isArray(value) || typeof value == "string" || typeof value.splice == "function" || isBuffer(value) || isTypedArray(value) || isArguments(value))) {
            return !value.length;
          }
          var tag = getTag(value);
          if (tag == mapTag || tag == setTag) {
            return !value.size;
          }
          if (isPrototype(value)) {
            return !baseKeys(value).length;
          }
          for (var key2 in value) {
            if (hasOwnProperty2.call(value, key2)) {
              return false;
            }
          }
          return true;
        }
        function isEqual(value, other) {
          return baseIsEqual(value, other);
        }
        function isEqualWith(value, other, customizer) {
          customizer = typeof customizer == "function" ? customizer : undefined2;
          var result3 = customizer ? customizer(value, other) : undefined2;
          return result3 === undefined2 ? baseIsEqual(value, other, undefined2, customizer) : !!result3;
        }
        function isError(value) {
          if (!isObjectLike(value)) {
            return false;
          }
          var tag = baseGetTag(value);
          return tag == errorTag || tag == domExcTag || typeof value.message == "string" && typeof value.name == "string" && !isPlainObject(value);
        }
        function isFinite2(value) {
          return typeof value == "number" && nativeIsFinite(value);
        }
        function isFunction(value) {
          if (!isObject2(value)) {
            return false;
          }
          var tag = baseGetTag(value);
          return tag == funcTag || tag == genTag || tag == asyncTag || tag == proxyTag;
        }
        function isInteger2(value) {
          return typeof value == "number" && value == toInteger(value);
        }
        function isLength(value) {
          return typeof value == "number" && value > -1 && value % 1 == 0 && value <= MAX_SAFE_INTEGER;
        }
        function isObject2(value) {
          var type3 = typeof value;
          return value != null && (type3 == "object" || type3 == "function");
        }
        function isObjectLike(value) {
          return value != null && typeof value == "object";
        }
        var isMap = nodeIsMap ? baseUnary(nodeIsMap) : baseIsMap;
        function isMatch(object, source) {
          return object === source || baseIsMatch(object, source, getMatchData(source));
        }
        function isMatchWith(object, source, customizer) {
          customizer = typeof customizer == "function" ? customizer : undefined2;
          return baseIsMatch(object, source, getMatchData(source), customizer);
        }
        function isNaN2(value) {
          return isNumber(value) && value != +value;
        }
        function isNative(value) {
          if (isMaskable(value)) {
            throw new Error2(CORE_ERROR_TEXT);
          }
          return baseIsNative(value);
        }
        function isNull2(value) {
          return value === null;
        }
        function isNil(value) {
          return value == null;
        }
        function isNumber(value) {
          return typeof value == "number" || isObjectLike(value) && baseGetTag(value) == numberTag;
        }
        function isPlainObject(value) {
          if (!isObjectLike(value) || baseGetTag(value) != objectTag) {
            return false;
          }
          var proto = getPrototype(value);
          if (proto === null) {
            return true;
          }
          var Ctor = hasOwnProperty2.call(proto, "constructor") && proto.constructor;
          return typeof Ctor == "function" && Ctor instanceof Ctor && funcToString.call(Ctor) == objectCtorString;
        }
        var isRegExp = nodeIsRegExp ? baseUnary(nodeIsRegExp) : baseIsRegExp;
        function isSafeInteger(value) {
          return isInteger2(value) && value >= -MAX_SAFE_INTEGER && value <= MAX_SAFE_INTEGER;
        }
        var isSet = nodeIsSet ? baseUnary(nodeIsSet) : baseIsSet;
        function isString(value) {
          return typeof value == "string" || !isArray(value) && isObjectLike(value) && baseGetTag(value) == stringTag;
        }
        function isSymbol(value) {
          return typeof value == "symbol" || isObjectLike(value) && baseGetTag(value) == symbolTag;
        }
        var isTypedArray = nodeIsTypedArray ? baseUnary(nodeIsTypedArray) : baseIsTypedArray;
        function isUndefined(value) {
          return value === undefined2;
        }
        function isWeakMap(value) {
          return isObjectLike(value) && getTag(value) == weakMapTag;
        }
        function isWeakSet(value) {
          return isObjectLike(value) && baseGetTag(value) == weakSetTag;
        }
        var lt = createRelationalOperation(baseLt);
        var lte = createRelationalOperation(function(value, other) {
          return value <= other;
        });
        function toArray2(value) {
          if (!value) {
            return [];
          }
          if (isArrayLike(value)) {
            return isString(value) ? stringToArray(value) : copyArray(value);
          }
          if (symIterator && value[symIterator]) {
            return iteratorToArray(value[symIterator]());
          }
          var tag = getTag(value), func2 = tag == mapTag ? mapToArray : tag == setTag ? setToArray : values;
          return func2(value);
        }
        function toFinite(value) {
          if (!value) {
            return value === 0 ? value : 0;
          }
          value = toNumber(value);
          if (value === INFINITY || value === -INFINITY) {
            var sign = value < 0 ? -1 : 1;
            return sign * MAX_INTEGER;
          }
          return value === value ? value : 0;
        }
        function toInteger(value) {
          var result3 = toFinite(value), remainder = result3 % 1;
          return result3 === result3 ? remainder ? result3 - remainder : result3 : 0;
        }
        function toLength(value) {
          return value ? baseClamp(toInteger(value), 0, MAX_ARRAY_LENGTH) : 0;
        }
        function toNumber(value) {
          if (typeof value == "number") {
            return value;
          }
          if (isSymbol(value)) {
            return NAN;
          }
          if (isObject2(value)) {
            var other = typeof value.valueOf == "function" ? value.valueOf() : value;
            value = isObject2(other) ? other + "" : other;
          }
          if (typeof value != "string") {
            return value === 0 ? value : +value;
          }
          value = baseTrim(value);
          var isBinary2 = reIsBinary.test(value);
          return isBinary2 || reIsOctal.test(value) ? freeParseInt(value.slice(2), isBinary2 ? 2 : 8) : reIsBadHex.test(value) ? NAN : +value;
        }
        function toPlainObject(value) {
          return copyObject(value, keysIn(value));
        }
        function toSafeInteger(value) {
          return value ? baseClamp(toInteger(value), -MAX_SAFE_INTEGER, MAX_SAFE_INTEGER) : value === 0 ? value : 0;
        }
        function toString2(value) {
          return value == null ? "" : baseToString(value);
        }
        var assign3 = createAssigner(function(object, source) {
          if (isPrototype(source) || isArrayLike(source)) {
            copyObject(source, keys(source), object);
            return;
          }
          for (var key2 in source) {
            if (hasOwnProperty2.call(source, key2)) {
              assignValue(object, key2, source[key2]);
            }
          }
        });
        var assignIn = createAssigner(function(object, source) {
          copyObject(source, keysIn(source), object);
        });
        var assignInWith = createAssigner(function(object, source, srcIndex, customizer) {
          copyObject(source, keysIn(source), object, customizer);
        });
        var assignWith = createAssigner(function(object, source, srcIndex, customizer) {
          copyObject(source, keys(source), object, customizer);
        });
        var at = flatRest(baseAt);
        function create(prototype, properties) {
          var result3 = baseCreate(prototype);
          return properties == null ? result3 : baseAssign(result3, properties);
        }
        var defaults = baseRest(function(object, sources) {
          object = Object2(object);
          var index = -1;
          var length = sources.length;
          var guard = length > 2 ? sources[2] : undefined2;
          if (guard && isIterateeCall(sources[0], sources[1], guard)) {
            length = 1;
          }
          while (++index < length) {
            var source = sources[index];
            var props = keysIn(source);
            var propsIndex = -1;
            var propsLength = props.length;
            while (++propsIndex < propsLength) {
              var key2 = props[propsIndex];
              var value = object[key2];
              if (value === undefined2 || eq(value, objectProto[key2]) && !hasOwnProperty2.call(object, key2)) {
                object[key2] = source[key2];
              }
            }
          }
          return object;
        });
        var defaultsDeep = baseRest(function(args) {
          args.push(undefined2, customDefaultsMerge);
          return apply(mergeWith, undefined2, args);
        });
        function findKey(object, predicate) {
          return baseFindKey(object, getIteratee(predicate, 3), baseForOwn);
        }
        function findLastKey(object, predicate) {
          return baseFindKey(object, getIteratee(predicate, 3), baseForOwnRight);
        }
        function forIn(object, iteratee2) {
          return object == null ? object : baseFor(object, getIteratee(iteratee2, 3), keysIn);
        }
        function forInRight(object, iteratee2) {
          return object == null ? object : baseForRight(object, getIteratee(iteratee2, 3), keysIn);
        }
        function forOwn(object, iteratee2) {
          return object && baseForOwn(object, getIteratee(iteratee2, 3));
        }
        function forOwnRight(object, iteratee2) {
          return object && baseForOwnRight(object, getIteratee(iteratee2, 3));
        }
        function functions(object) {
          return object == null ? [] : baseFunctions(object, keys(object));
        }
        function functionsIn(object) {
          return object == null ? [] : baseFunctions(object, keysIn(object));
        }
        function get(object, path2, defaultValue) {
          var result3 = object == null ? undefined2 : baseGet(object, path2);
          return result3 === undefined2 ? defaultValue : result3;
        }
        function has(object, path2) {
          return object != null && hasPath(object, path2, baseHas);
        }
        function hasIn(object, path2) {
          return object != null && hasPath(object, path2, baseHasIn);
        }
        var invert = createInverter(function(result3, value, key2) {
          if (value != null && typeof value.toString != "function") {
            value = nativeObjectToString.call(value);
          }
          result3[value] = key2;
        }, constant(identity));
        var invertBy = createInverter(function(result3, value, key2) {
          if (value != null && typeof value.toString != "function") {
            value = nativeObjectToString.call(value);
          }
          if (hasOwnProperty2.call(result3, value)) {
            result3[value].push(key2);
          } else {
            result3[value] = [key2];
          }
        }, getIteratee);
        var invoke = baseRest(baseInvoke);
        function keys(object) {
          return isArrayLike(object) ? arrayLikeKeys(object) : baseKeys(object);
        }
        function keysIn(object) {
          return isArrayLike(object) ? arrayLikeKeys(object, true) : baseKeysIn(object);
        }
        function mapKeys(object, iteratee2) {
          var result3 = {};
          iteratee2 = getIteratee(iteratee2, 3);
          baseForOwn(object, function(value, key2, object2) {
            baseAssignValue(result3, iteratee2(value, key2, object2), value);
          });
          return result3;
        }
        function mapValues(object, iteratee2) {
          var result3 = {};
          iteratee2 = getIteratee(iteratee2, 3);
          baseForOwn(object, function(value, key2, object2) {
            baseAssignValue(result3, key2, iteratee2(value, key2, object2));
          });
          return result3;
        }
        var merge2 = createAssigner(function(object, source, srcIndex) {
          baseMerge(object, source, srcIndex);
        });
        var mergeWith = createAssigner(function(object, source, srcIndex, customizer) {
          baseMerge(object, source, srcIndex, customizer);
        });
        var omit = flatRest(function(object, paths) {
          var result3 = {};
          if (object == null) {
            return result3;
          }
          var isDeep = false;
          paths = arrayMap(paths, function(path2) {
            path2 = castPath(path2, object);
            isDeep || (isDeep = path2.length > 1);
            return path2;
          });
          copyObject(object, getAllKeysIn(object), result3);
          if (isDeep) {
            result3 = baseClone(result3, CLONE_DEEP_FLAG | CLONE_FLAT_FLAG | CLONE_SYMBOLS_FLAG, customOmitClone);
          }
          var length = paths.length;
          while (length--) {
            baseUnset(result3, paths[length]);
          }
          return result3;
        });
        function omitBy(object, predicate) {
          return pickBy(object, negate(getIteratee(predicate)));
        }
        var pick = flatRest(function(object, paths) {
          return object == null ? {} : basePick(object, paths);
        });
        function pickBy(object, predicate) {
          if (object == null) {
            return {};
          }
          var props = arrayMap(getAllKeysIn(object), function(prop) {
            return [prop];
          });
          predicate = getIteratee(predicate);
          return basePickBy(object, props, function(value, path2) {
            return predicate(value, path2[0]);
          });
        }
        function result2(object, path2, defaultValue) {
          path2 = castPath(path2, object);
          var index = -1, length = path2.length;
          if (!length) {
            length = 1;
            object = undefined2;
          }
          while (++index < length) {
            var value = object == null ? undefined2 : object[toKey(path2[index])];
            if (value === undefined2) {
              index = length;
              value = defaultValue;
            }
            object = isFunction(value) ? value.call(object) : value;
          }
          return object;
        }
        function set2(object, path2, value) {
          return object == null ? object : baseSet(object, path2, value);
        }
        function setWith(object, path2, value, customizer) {
          customizer = typeof customizer == "function" ? customizer : undefined2;
          return object == null ? object : baseSet(object, path2, value, customizer);
        }
        var toPairs = createToPairs(keys);
        var toPairsIn = createToPairs(keysIn);
        function transform(object, iteratee2, accumulator) {
          var isArr = isArray(object), isArrLike = isArr || isBuffer(object) || isTypedArray(object);
          iteratee2 = getIteratee(iteratee2, 4);
          if (accumulator == null) {
            var Ctor = object && object.constructor;
            if (isArrLike) {
              accumulator = isArr ? new Ctor() : [];
            } else if (isObject2(object)) {
              accumulator = isFunction(Ctor) ? baseCreate(getPrototype(object)) : {};
            } else {
              accumulator = {};
            }
          }
          (isArrLike ? arrayEach : baseForOwn)(object, function(value, index, object2) {
            return iteratee2(accumulator, value, index, object2);
          });
          return accumulator;
        }
        function unset(object, path2) {
          return object == null ? true : baseUnset(object, path2);
        }
        function update(object, path2, updater) {
          return object == null ? object : baseUpdate(object, path2, castFunction(updater));
        }
        function updateWith(object, path2, updater, customizer) {
          customizer = typeof customizer == "function" ? customizer : undefined2;
          return object == null ? object : baseUpdate(object, path2, castFunction(updater), customizer);
        }
        function values(object) {
          return object == null ? [] : baseValues(object, keys(object));
        }
        function valuesIn(object) {
          return object == null ? [] : baseValues(object, keysIn(object));
        }
        function clamp(number, lower, upper) {
          if (upper === undefined2) {
            upper = lower;
            lower = undefined2;
          }
          if (upper !== undefined2) {
            upper = toNumber(upper);
            upper = upper === upper ? upper : 0;
          }
          if (lower !== undefined2) {
            lower = toNumber(lower);
            lower = lower === lower ? lower : 0;
          }
          return baseClamp(toNumber(number), lower, upper);
        }
        function inRange(number, start, end) {
          start = toFinite(start);
          if (end === undefined2) {
            end = start;
            start = 0;
          } else {
            end = toFinite(end);
          }
          number = toNumber(number);
          return baseInRange(number, start, end);
        }
        function random(lower, upper, floating) {
          if (floating && typeof floating != "boolean" && isIterateeCall(lower, upper, floating)) {
            upper = floating = undefined2;
          }
          if (floating === undefined2) {
            if (typeof upper == "boolean") {
              floating = upper;
              upper = undefined2;
            } else if (typeof lower == "boolean") {
              floating = lower;
              lower = undefined2;
            }
          }
          if (lower === undefined2 && upper === undefined2) {
            lower = 0;
            upper = 1;
          } else {
            lower = toFinite(lower);
            if (upper === undefined2) {
              upper = lower;
              lower = 0;
            } else {
              upper = toFinite(upper);
            }
          }
          if (lower > upper) {
            var temp = lower;
            lower = upper;
            upper = temp;
          }
          if (floating || lower % 1 || upper % 1) {
            var rand = nativeRandom();
            return nativeMin(lower + rand * (upper - lower + freeParseFloat("1e-" + ((rand + "").length - 1))), upper);
          }
          return baseRandom(lower, upper);
        }
        var camelCase = createCompounder(function(result3, word, index) {
          word = word.toLowerCase();
          return result3 + (index ? capitalize(word) : word);
        });
        function capitalize(string) {
          return upperFirst(toString2(string).toLowerCase());
        }
        function deburr(string) {
          string = toString2(string);
          return string && string.replace(reLatin, deburrLetter).replace(reComboMark, "");
        }
        function endsWith(string, target, position) {
          string = toString2(string);
          target = baseToString(target);
          var length = string.length;
          position = position === undefined2 ? length : baseClamp(toInteger(position), 0, length);
          var end = position;
          position -= target.length;
          return position >= 0 && string.slice(position, end) == target;
        }
        function escape(string) {
          string = toString2(string);
          return string && reHasUnescapedHtml.test(string) ? string.replace(reUnescapedHtml, escapeHtmlChar) : string;
        }
        function escapeRegExp(string) {
          string = toString2(string);
          return string && reHasRegExpChar.test(string) ? string.replace(reRegExpChar, "\\$&") : string;
        }
        var kebabCase = createCompounder(function(result3, word, index) {
          return result3 + (index ? "-" : "") + word.toLowerCase();
        });
        var lowerCase = createCompounder(function(result3, word, index) {
          return result3 + (index ? " " : "") + word.toLowerCase();
        });
        var lowerFirst = createCaseFirst("toLowerCase");
        function pad(string, length, chars) {
          string = toString2(string);
          length = toInteger(length);
          var strLength = length ? stringSize(string) : 0;
          if (!length || strLength >= length) {
            return string;
          }
          var mid = (length - strLength) / 2;
          return createPadding(nativeFloor(mid), chars) + string + createPadding(nativeCeil(mid), chars);
        }
        function padEnd(string, length, chars) {
          string = toString2(string);
          length = toInteger(length);
          var strLength = length ? stringSize(string) : 0;
          return length && strLength < length ? string + createPadding(length - strLength, chars) : string;
        }
        function padStart2(string, length, chars) {
          string = toString2(string);
          length = toInteger(length);
          var strLength = length ? stringSize(string) : 0;
          return length && strLength < length ? createPadding(length - strLength, chars) + string : string;
        }
        function parseInt2(string, radix, guard) {
          if (guard || radix == null) {
            radix = 0;
          } else if (radix) {
            radix = +radix;
          }
          return nativeParseInt(toString2(string).replace(reTrimStart, ""), radix || 0);
        }
        function repeat2(string, n2, guard) {
          if (guard ? isIterateeCall(string, n2, guard) : n2 === undefined2) {
            n2 = 1;
          } else {
            n2 = toInteger(n2);
          }
          return baseRepeat(toString2(string), n2);
        }
        function replace() {
          var args = arguments, string = toString2(args[0]);
          return args.length < 3 ? string : string.replace(args[1], args[2]);
        }
        var snakeCase = createCompounder(function(result3, word, index) {
          return result3 + (index ? "_" : "") + word.toLowerCase();
        });
        function split(string, separator, limit) {
          if (limit && typeof limit != "number" && isIterateeCall(string, separator, limit)) {
            separator = limit = undefined2;
          }
          limit = limit === undefined2 ? MAX_ARRAY_LENGTH : limit >>> 0;
          if (!limit) {
            return [];
          }
          string = toString2(string);
          if (string && (typeof separator == "string" || separator != null && !isRegExp(separator))) {
            separator = baseToString(separator);
            if (!separator && hasUnicode(string)) {
              return castSlice(stringToArray(string), 0, limit);
            }
          }
          return string.split(separator, limit);
        }
        var startCase = createCompounder(function(result3, word, index) {
          return result3 + (index ? " " : "") + upperFirst(word);
        });
        function startsWith(string, target, position) {
          string = toString2(string);
          position = position == null ? 0 : baseClamp(toInteger(position), 0, string.length);
          target = baseToString(target);
          return string.slice(position, position + target.length) == target;
        }
        function template(string, options, guard) {
          var settings = lodash.templateSettings;
          if (guard && isIterateeCall(string, options, guard)) {
            options = undefined2;
          }
          string = toString2(string);
          options = assignInWith({}, options, settings, customDefaultsAssignIn);
          var imports = assignInWith({}, options.imports, settings.imports, customDefaultsAssignIn), importsKeys = keys(imports), importsValues = baseValues(imports, importsKeys);
          var isEscaping, isEvaluating, index = 0, interpolate = options.interpolate || reNoMatch, source = "__p += '";
          var reDelimiters = RegExp2((options.escape || reNoMatch).source + "|" + interpolate.source + "|" + (interpolate === reInterpolate ? reEsTemplate : reNoMatch).source + "|" + (options.evaluate || reNoMatch).source + "|$", "g");
          var sourceURL = "//# sourceURL=" + (hasOwnProperty2.call(options, "sourceURL") ? (options.sourceURL + "").replace(/\s/g, " ") : "lodash.templateSources[" + ++templateCounter + "]") + "\n";
          string.replace(reDelimiters, function(match, escapeValue, interpolateValue, esTemplateValue, evaluateValue, offset) {
            interpolateValue || (interpolateValue = esTemplateValue);
            source += string.slice(index, offset).replace(reUnescapedString, escapeStringChar);
            if (escapeValue) {
              isEscaping = true;
              source += "' +\n__e(" + escapeValue + ") +\n'";
            }
            if (evaluateValue) {
              isEvaluating = true;
              source += "';\n" + evaluateValue + ";\n__p += '";
            }
            if (interpolateValue) {
              source += "' +\n((__t = (" + interpolateValue + ")) == null ? '' : __t) +\n'";
            }
            index = offset + match.length;
            return match;
          });
          source += "';\n";
          var variable = hasOwnProperty2.call(options, "variable") && options.variable;
          if (!variable) {
            source = "with (obj) {\n" + source + "\n}\n";
          } else if (reForbiddenIdentifierChars.test(variable)) {
            throw new Error2(INVALID_TEMPL_VAR_ERROR_TEXT);
          }
          source = (isEvaluating ? source.replace(reEmptyStringLeading, "") : source).replace(reEmptyStringMiddle, "$1").replace(reEmptyStringTrailing, "$1;");
          source = "function(" + (variable || "obj") + ") {\n" + (variable ? "" : "obj || (obj = {});\n") + "var __t, __p = ''" + (isEscaping ? ", __e = _.escape" : "") + (isEvaluating ? ", __j = Array.prototype.join;\nfunction print() { __p += __j.call(arguments, '') }\n" : ";\n") + source + "return __p\n}";
          var result3 = attempt(function() {
            return Function2(importsKeys, sourceURL + "return " + source).apply(undefined2, importsValues);
          });
          result3.source = source;
          if (isError(result3)) {
            throw result3;
          }
          return result3;
        }
        function toLower(value) {
          return toString2(value).toLowerCase();
        }
        function toUpper(value) {
          return toString2(value).toUpperCase();
        }
        function trim(string, chars, guard) {
          string = toString2(string);
          if (string && (guard || chars === undefined2)) {
            return baseTrim(string);
          }
          if (!string || !(chars = baseToString(chars))) {
            return string;
          }
          var strSymbols = stringToArray(string), chrSymbols = stringToArray(chars), start = charsStartIndex(strSymbols, chrSymbols), end = charsEndIndex(strSymbols, chrSymbols) + 1;
          return castSlice(strSymbols, start, end).join("");
        }
        function trimEnd(string, chars, guard) {
          string = toString2(string);
          if (string && (guard || chars === undefined2)) {
            return string.slice(0, trimmedEndIndex(string) + 1);
          }
          if (!string || !(chars = baseToString(chars))) {
            return string;
          }
          var strSymbols = stringToArray(string), end = charsEndIndex(strSymbols, stringToArray(chars)) + 1;
          return castSlice(strSymbols, 0, end).join("");
        }
        function trimStart(string, chars, guard) {
          string = toString2(string);
          if (string && (guard || chars === undefined2)) {
            return string.replace(reTrimStart, "");
          }
          if (!string || !(chars = baseToString(chars))) {
            return string;
          }
          var strSymbols = stringToArray(string), start = charsStartIndex(strSymbols, stringToArray(chars));
          return castSlice(strSymbols, start).join("");
        }
        function truncate(string, options) {
          var length = DEFAULT_TRUNC_LENGTH, omission = DEFAULT_TRUNC_OMISSION;
          if (isObject2(options)) {
            var separator = "separator" in options ? options.separator : separator;
            length = "length" in options ? toInteger(options.length) : length;
            omission = "omission" in options ? baseToString(options.omission) : omission;
          }
          string = toString2(string);
          var strLength = string.length;
          if (hasUnicode(string)) {
            var strSymbols = stringToArray(string);
            strLength = strSymbols.length;
          }
          if (length >= strLength) {
            return string;
          }
          var end = length - stringSize(omission);
          if (end < 1) {
            return omission;
          }
          var result3 = strSymbols ? castSlice(strSymbols, 0, end).join("") : string.slice(0, end);
          if (separator === undefined2) {
            return result3 + omission;
          }
          if (strSymbols) {
            end += result3.length - end;
          }
          if (isRegExp(separator)) {
            if (string.slice(end).search(separator)) {
              var match, substring = result3;
              if (!separator.global) {
                separator = RegExp2(separator.source, toString2(reFlags.exec(separator)) + "g");
              }
              separator.lastIndex = 0;
              while (match = separator.exec(substring)) {
                var newEnd = match.index;
              }
              result3 = result3.slice(0, newEnd === undefined2 ? end : newEnd);
            }
          } else if (string.indexOf(baseToString(separator), end) != end) {
            var index = result3.lastIndexOf(separator);
            if (index > -1) {
              result3 = result3.slice(0, index);
            }
          }
          return result3 + omission;
        }
        function unescape(string) {
          string = toString2(string);
          return string && reHasEscapedHtml.test(string) ? string.replace(reEscapedHtml, unescapeHtmlChar) : string;
        }
        var upperCase = createCompounder(function(result3, word, index) {
          return result3 + (index ? " " : "") + word.toUpperCase();
        });
        var upperFirst = createCaseFirst("toUpperCase");
        function words(string, pattern, guard) {
          string = toString2(string);
          pattern = guard ? undefined2 : pattern;
          if (pattern === undefined2) {
            return hasUnicodeWord(string) ? unicodeWords(string) : asciiWords(string);
          }
          return string.match(pattern) || [];
        }
        var attempt = baseRest(function(func2, args) {
          try {
            return apply(func2, undefined2, args);
          } catch (e2) {
            return isError(e2) ? e2 : new Error2(e2);
          }
        });
        var bindAll = flatRest(function(object, methodNames) {
          arrayEach(methodNames, function(key2) {
            key2 = toKey(key2);
            baseAssignValue(object, key2, bind(object[key2], object));
          });
          return object;
        });
        function cond(pairs2) {
          var length = pairs2 == null ? 0 : pairs2.length, toIteratee = getIteratee();
          pairs2 = !length ? [] : arrayMap(pairs2, function(pair) {
            if (typeof pair[1] != "function") {
              throw new TypeError2(FUNC_ERROR_TEXT);
            }
            return [toIteratee(pair[0]), pair[1]];
          });
          return baseRest(function(args) {
            var index = -1;
            while (++index < length) {
              var pair = pairs2[index];
              if (apply(pair[0], this, args)) {
                return apply(pair[1], this, args);
              }
            }
          });
        }
        function conforms(source) {
          return baseConforms(baseClone(source, CLONE_DEEP_FLAG));
        }
        function constant(value) {
          return function() {
            return value;
          };
        }
        function defaultTo(value, defaultValue) {
          return value == null || value !== value ? defaultValue : value;
        }
        var flow = createFlow();
        var flowRight = createFlow(true);
        function identity(value) {
          return value;
        }
        function iteratee(func2) {
          return baseIteratee(typeof func2 == "function" ? func2 : baseClone(func2, CLONE_DEEP_FLAG));
        }
        function matches(source) {
          return baseMatches(baseClone(source, CLONE_DEEP_FLAG));
        }
        function matchesProperty(path2, srcValue) {
          return baseMatchesProperty(path2, baseClone(srcValue, CLONE_DEEP_FLAG));
        }
        var method = baseRest(function(path2, args) {
          return function(object) {
            return baseInvoke(object, path2, args);
          };
        });
        var methodOf = baseRest(function(object, args) {
          return function(path2) {
            return baseInvoke(object, path2, args);
          };
        });
        function mixin(object, source, options) {
          var props = keys(source), methodNames = baseFunctions(source, props);
          if (options == null && !(isObject2(source) && (methodNames.length || !props.length))) {
            options = source;
            source = object;
            object = this;
            methodNames = baseFunctions(source, keys(source));
          }
          var chain2 = !(isObject2(options) && "chain" in options) || !!options.chain, isFunc = isFunction(object);
          arrayEach(methodNames, function(methodName) {
            var func2 = source[methodName];
            object[methodName] = func2;
            if (isFunc) {
              object.prototype[methodName] = function() {
                var chainAll = this.__chain__;
                if (chain2 || chainAll) {
                  var result3 = object(this.__wrapped__), actions2 = result3.__actions__ = copyArray(this.__actions__);
                  actions2.push({ "func": func2, "args": arguments, "thisArg": object });
                  result3.__chain__ = chainAll;
                  return result3;
                }
                return func2.apply(object, arrayPush([this.value()], arguments));
              };
            }
          });
          return object;
        }
        function noConflict() {
          if (root._ === this) {
            root._ = oldDash;
          }
          return this;
        }
        function noop() {
        }
        function nthArg(n2) {
          n2 = toInteger(n2);
          return baseRest(function(args) {
            return baseNth(args, n2);
          });
        }
        var over = createOver(arrayMap);
        var overEvery = createOver(arrayEvery);
        var overSome = createOver(arraySome);
        function property(path2) {
          return isKey(path2) ? baseProperty(toKey(path2)) : basePropertyDeep(path2);
        }
        function propertyOf(object) {
          return function(path2) {
            return object == null ? undefined2 : baseGet(object, path2);
          };
        }
        var range = createRange();
        var rangeRight = createRange(true);
        function stubArray() {
          return [];
        }
        function stubFalse() {
          return false;
        }
        function stubObject() {
          return {};
        }
        function stubString() {
          return "";
        }
        function stubTrue() {
          return true;
        }
        function times(n2, iteratee2) {
          n2 = toInteger(n2);
          if (n2 < 1 || n2 > MAX_SAFE_INTEGER) {
            return [];
          }
          var index = MAX_ARRAY_LENGTH, length = nativeMin(n2, MAX_ARRAY_LENGTH);
          iteratee2 = getIteratee(iteratee2);
          n2 -= MAX_ARRAY_LENGTH;
          var result3 = baseTimes(length, iteratee2);
          while (++index < n2) {
            iteratee2(index);
          }
          return result3;
        }
        function toPath(value) {
          if (isArray(value)) {
            return arrayMap(value, toKey);
          }
          return isSymbol(value) ? [value] : copyArray(stringToPath(toString2(value)));
        }
        function uniqueId(prefix2) {
          var id = ++idCounter;
          return toString2(prefix2) + id;
        }
        var add = createMathOperation(function(augend, addend) {
          return augend + addend;
        }, 0);
        var ceil = createRound("ceil");
        var divide = createMathOperation(function(dividend, divisor) {
          return dividend / divisor;
        }, 1);
        var floor = createRound("floor");
        function max(array) {
          return array && array.length ? baseExtremum(array, identity, baseGt) : undefined2;
        }
        function maxBy(array, iteratee2) {
          return array && array.length ? baseExtremum(array, getIteratee(iteratee2, 2), baseGt) : undefined2;
        }
        function mean(array) {
          return baseMean(array, identity);
        }
        function meanBy(array, iteratee2) {
          return baseMean(array, getIteratee(iteratee2, 2));
        }
        function min(array) {
          return array && array.length ? baseExtremum(array, identity, baseLt) : undefined2;
        }
        function minBy(array, iteratee2) {
          return array && array.length ? baseExtremum(array, getIteratee(iteratee2, 2), baseLt) : undefined2;
        }
        var multiply = createMathOperation(function(multiplier, multiplicand) {
          return multiplier * multiplicand;
        }, 1);
        var round = createRound("round");
        var subtract = createMathOperation(function(minuend, subtrahend) {
          return minuend - subtrahend;
        }, 0);
        function sum(array) {
          return array && array.length ? baseSum(array, identity) : 0;
        }
        function sumBy(array, iteratee2) {
          return array && array.length ? baseSum(array, getIteratee(iteratee2, 2)) : 0;
        }
        lodash.after = after;
        lodash.ary = ary;
        lodash.assign = assign3;
        lodash.assignIn = assignIn;
        lodash.assignInWith = assignInWith;
        lodash.assignWith = assignWith;
        lodash.at = at;
        lodash.before = before;
        lodash.bind = bind;
        lodash.bindAll = bindAll;
        lodash.bindKey = bindKey;
        lodash.castArray = castArray;
        lodash.chain = chain;
        lodash.chunk = chunk;
        lodash.compact = compact;
        lodash.concat = concat;
        lodash.cond = cond;
        lodash.conforms = conforms;
        lodash.constant = constant;
        lodash.countBy = countBy;
        lodash.create = create;
        lodash.curry = curry;
        lodash.curryRight = curryRight;
        lodash.debounce = debounce;
        lodash.defaults = defaults;
        lodash.defaultsDeep = defaultsDeep;
        lodash.defer = defer;
        lodash.delay = delay;
        lodash.difference = difference;
        lodash.differenceBy = differenceBy;
        lodash.differenceWith = differenceWith;
        lodash.drop = drop;
        lodash.dropRight = dropRight;
        lodash.dropRightWhile = dropRightWhile;
        lodash.dropWhile = dropWhile;
        lodash.fill = fill;
        lodash.filter = filter;
        lodash.flatMap = flatMap;
        lodash.flatMapDeep = flatMapDeep;
        lodash.flatMapDepth = flatMapDepth;
        lodash.flatten = flatten;
        lodash.flattenDeep = flattenDeep;
        lodash.flattenDepth = flattenDepth;
        lodash.flip = flip;
        lodash.flow = flow;
        lodash.flowRight = flowRight;
        lodash.fromPairs = fromPairs;
        lodash.functions = functions;
        lodash.functionsIn = functionsIn;
        lodash.groupBy = groupBy;
        lodash.initial = initial;
        lodash.intersection = intersection;
        lodash.intersectionBy = intersectionBy;
        lodash.intersectionWith = intersectionWith;
        lodash.invert = invert;
        lodash.invertBy = invertBy;
        lodash.invokeMap = invokeMap;
        lodash.iteratee = iteratee;
        lodash.keyBy = keyBy;
        lodash.keys = keys;
        lodash.keysIn = keysIn;
        lodash.map = map2;
        lodash.mapKeys = mapKeys;
        lodash.mapValues = mapValues;
        lodash.matches = matches;
        lodash.matchesProperty = matchesProperty;
        lodash.memoize = memoize;
        lodash.merge = merge2;
        lodash.mergeWith = mergeWith;
        lodash.method = method;
        lodash.methodOf = methodOf;
        lodash.mixin = mixin;
        lodash.negate = negate;
        lodash.nthArg = nthArg;
        lodash.omit = omit;
        lodash.omitBy = omitBy;
        lodash.once = once;
        lodash.orderBy = orderBy;
        lodash.over = over;
        lodash.overArgs = overArgs;
        lodash.overEvery = overEvery;
        lodash.overSome = overSome;
        lodash.partial = partial;
        lodash.partialRight = partialRight;
        lodash.partition = partition;
        lodash.pick = pick;
        lodash.pickBy = pickBy;
        lodash.property = property;
        lodash.propertyOf = propertyOf;
        lodash.pull = pull;
        lodash.pullAll = pullAll;
        lodash.pullAllBy = pullAllBy;
        lodash.pullAllWith = pullAllWith;
        lodash.pullAt = pullAt;
        lodash.range = range;
        lodash.rangeRight = rangeRight;
        lodash.rearg = rearg;
        lodash.reject = reject;
        lodash.remove = remove;
        lodash.rest = rest;
        lodash.reverse = reverse;
        lodash.sampleSize = sampleSize;
        lodash.set = set2;
        lodash.setWith = setWith;
        lodash.shuffle = shuffle;
        lodash.slice = slice;
        lodash.sortBy = sortBy;
        lodash.sortedUniq = sortedUniq;
        lodash.sortedUniqBy = sortedUniqBy;
        lodash.split = split;
        lodash.spread = spread;
        lodash.tail = tail;
        lodash.take = take;
        lodash.takeRight = takeRight;
        lodash.takeRightWhile = takeRightWhile;
        lodash.takeWhile = takeWhile;
        lodash.tap = tap;
        lodash.throttle = throttle;
        lodash.thru = thru;
        lodash.toArray = toArray2;
        lodash.toPairs = toPairs;
        lodash.toPairsIn = toPairsIn;
        lodash.toPath = toPath;
        lodash.toPlainObject = toPlainObject;
        lodash.transform = transform;
        lodash.unary = unary;
        lodash.union = union;
        lodash.unionBy = unionBy;
        lodash.unionWith = unionWith;
        lodash.uniq = uniq;
        lodash.uniqBy = uniqBy;
        lodash.uniqWith = uniqWith;
        lodash.unset = unset;
        lodash.unzip = unzip;
        lodash.unzipWith = unzipWith;
        lodash.update = update;
        lodash.updateWith = updateWith;
        lodash.values = values;
        lodash.valuesIn = valuesIn;
        lodash.without = without;
        lodash.words = words;
        lodash.wrap = wrap;
        lodash.xor = xor;
        lodash.xorBy = xorBy;
        lodash.xorWith = xorWith;
        lodash.zip = zip;
        lodash.zipObject = zipObject;
        lodash.zipObjectDeep = zipObjectDeep;
        lodash.zipWith = zipWith;
        lodash.entries = toPairs;
        lodash.entriesIn = toPairsIn;
        lodash.extend = assignIn;
        lodash.extendWith = assignInWith;
        mixin(lodash, lodash);
        lodash.add = add;
        lodash.attempt = attempt;
        lodash.camelCase = camelCase;
        lodash.capitalize = capitalize;
        lodash.ceil = ceil;
        lodash.clamp = clamp;
        lodash.clone = clone;
        lodash.cloneDeep = cloneDeep;
        lodash.cloneDeepWith = cloneDeepWith;
        lodash.cloneWith = cloneWith;
        lodash.conformsTo = conformsTo;
        lodash.deburr = deburr;
        lodash.defaultTo = defaultTo;
        lodash.divide = divide;
        lodash.endsWith = endsWith;
        lodash.eq = eq;
        lodash.escape = escape;
        lodash.escapeRegExp = escapeRegExp;
        lodash.every = every;
        lodash.find = find;
        lodash.findIndex = findIndex;
        lodash.findKey = findKey;
        lodash.findLast = findLast;
        lodash.findLastIndex = findLastIndex;
        lodash.findLastKey = findLastKey;
        lodash.floor = floor;
        lodash.forEach = forEach;
        lodash.forEachRight = forEachRight;
        lodash.forIn = forIn;
        lodash.forInRight = forInRight;
        lodash.forOwn = forOwn;
        lodash.forOwnRight = forOwnRight;
        lodash.get = get;
        lodash.gt = gt;
        lodash.gte = gte;
        lodash.has = has;
        lodash.hasIn = hasIn;
        lodash.head = head;
        lodash.identity = identity;
        lodash.includes = includes;
        lodash.indexOf = indexOf;
        lodash.inRange = inRange;
        lodash.invoke = invoke;
        lodash.isArguments = isArguments;
        lodash.isArray = isArray;
        lodash.isArrayBuffer = isArrayBuffer;
        lodash.isArrayLike = isArrayLike;
        lodash.isArrayLikeObject = isArrayLikeObject;
        lodash.isBoolean = isBoolean2;
        lodash.isBuffer = isBuffer;
        lodash.isDate = isDate;
        lodash.isElement = isElement;
        lodash.isEmpty = isEmpty;
        lodash.isEqual = isEqual;
        lodash.isEqualWith = isEqualWith;
        lodash.isError = isError;
        lodash.isFinite = isFinite2;
        lodash.isFunction = isFunction;
        lodash.isInteger = isInteger2;
        lodash.isLength = isLength;
        lodash.isMap = isMap;
        lodash.isMatch = isMatch;
        lodash.isMatchWith = isMatchWith;
        lodash.isNaN = isNaN2;
        lodash.isNative = isNative;
        lodash.isNil = isNil;
        lodash.isNull = isNull2;
        lodash.isNumber = isNumber;
        lodash.isObject = isObject2;
        lodash.isObjectLike = isObjectLike;
        lodash.isPlainObject = isPlainObject;
        lodash.isRegExp = isRegExp;
        lodash.isSafeInteger = isSafeInteger;
        lodash.isSet = isSet;
        lodash.isString = isString;
        lodash.isSymbol = isSymbol;
        lodash.isTypedArray = isTypedArray;
        lodash.isUndefined = isUndefined;
        lodash.isWeakMap = isWeakMap;
        lodash.isWeakSet = isWeakSet;
        lodash.join = join;
        lodash.kebabCase = kebabCase;
        lodash.last = last;
        lodash.lastIndexOf = lastIndexOf;
        lodash.lowerCase = lowerCase;
        lodash.lowerFirst = lowerFirst;
        lodash.lt = lt;
        lodash.lte = lte;
        lodash.max = max;
        lodash.maxBy = maxBy;
        lodash.mean = mean;
        lodash.meanBy = meanBy;
        lodash.min = min;
        lodash.minBy = minBy;
        lodash.stubArray = stubArray;
        lodash.stubFalse = stubFalse;
        lodash.stubObject = stubObject;
        lodash.stubString = stubString;
        lodash.stubTrue = stubTrue;
        lodash.multiply = multiply;
        lodash.nth = nth;
        lodash.noConflict = noConflict;
        lodash.noop = noop;
        lodash.now = now;
        lodash.pad = pad;
        lodash.padEnd = padEnd;
        lodash.padStart = padStart2;
        lodash.parseInt = parseInt2;
        lodash.random = random;
        lodash.reduce = reduce;
        lodash.reduceRight = reduceRight;
        lodash.repeat = repeat2;
        lodash.replace = replace;
        lodash.result = result2;
        lodash.round = round;
        lodash.runInContext = runInContext2;
        lodash.sample = sample;
        lodash.size = size;
        lodash.snakeCase = snakeCase;
        lodash.some = some;
        lodash.sortedIndex = sortedIndex;
        lodash.sortedIndexBy = sortedIndexBy;
        lodash.sortedIndexOf = sortedIndexOf;
        lodash.sortedLastIndex = sortedLastIndex;
        lodash.sortedLastIndexBy = sortedLastIndexBy;
        lodash.sortedLastIndexOf = sortedLastIndexOf;
        lodash.startCase = startCase;
        lodash.startsWith = startsWith;
        lodash.subtract = subtract;
        lodash.sum = sum;
        lodash.sumBy = sumBy;
        lodash.template = template;
        lodash.times = times;
        lodash.toFinite = toFinite;
        lodash.toInteger = toInteger;
        lodash.toLength = toLength;
        lodash.toLower = toLower;
        lodash.toNumber = toNumber;
        lodash.toSafeInteger = toSafeInteger;
        lodash.toString = toString2;
        lodash.toUpper = toUpper;
        lodash.trim = trim;
        lodash.trimEnd = trimEnd;
        lodash.trimStart = trimStart;
        lodash.truncate = truncate;
        lodash.unescape = unescape;
        lodash.uniqueId = uniqueId;
        lodash.upperCase = upperCase;
        lodash.upperFirst = upperFirst;
        lodash.each = forEach;
        lodash.eachRight = forEachRight;
        lodash.first = head;
        mixin(lodash, function() {
          var source = {};
          baseForOwn(lodash, function(func2, methodName) {
            if (!hasOwnProperty2.call(lodash.prototype, methodName)) {
              source[methodName] = func2;
            }
          });
          return source;
        }(), { "chain": false });
        lodash.VERSION = VERSION2;
        arrayEach(["bind", "bindKey", "curry", "curryRight", "partial", "partialRight"], function(methodName) {
          lodash[methodName].placeholder = lodash;
        });
        arrayEach(["drop", "take"], function(methodName, index) {
          LazyWrapper.prototype[methodName] = function(n2) {
            n2 = n2 === undefined2 ? 1 : nativeMax(toInteger(n2), 0);
            var result3 = this.__filtered__ && !index ? new LazyWrapper(this) : this.clone();
            if (result3.__filtered__) {
              result3.__takeCount__ = nativeMin(n2, result3.__takeCount__);
            } else {
              result3.__views__.push({
                "size": nativeMin(n2, MAX_ARRAY_LENGTH),
                "type": methodName + (result3.__dir__ < 0 ? "Right" : "")
              });
            }
            return result3;
          };
          LazyWrapper.prototype[methodName + "Right"] = function(n2) {
            return this.reverse()[methodName](n2).reverse();
          };
        });
        arrayEach(["filter", "map", "takeWhile"], function(methodName, index) {
          var type3 = index + 1, isFilter = type3 == LAZY_FILTER_FLAG || type3 == LAZY_WHILE_FLAG;
          LazyWrapper.prototype[methodName] = function(iteratee2) {
            var result3 = this.clone();
            result3.__iteratees__.push({
              "iteratee": getIteratee(iteratee2, 3),
              "type": type3
            });
            result3.__filtered__ = result3.__filtered__ || isFilter;
            return result3;
          };
        });
        arrayEach(["head", "last"], function(methodName, index) {
          var takeName = "take" + (index ? "Right" : "");
          LazyWrapper.prototype[methodName] = function() {
            return this[takeName](1).value()[0];
          };
        });
        arrayEach(["initial", "tail"], function(methodName, index) {
          var dropName = "drop" + (index ? "" : "Right");
          LazyWrapper.prototype[methodName] = function() {
            return this.__filtered__ ? new LazyWrapper(this) : this[dropName](1);
          };
        });
        LazyWrapper.prototype.compact = function() {
          return this.filter(identity);
        };
        LazyWrapper.prototype.find = function(predicate) {
          return this.filter(predicate).head();
        };
        LazyWrapper.prototype.findLast = function(predicate) {
          return this.reverse().find(predicate);
        };
        LazyWrapper.prototype.invokeMap = baseRest(function(path2, args) {
          if (typeof path2 == "function") {
            return new LazyWrapper(this);
          }
          return this.map(function(value) {
            return baseInvoke(value, path2, args);
          });
        });
        LazyWrapper.prototype.reject = function(predicate) {
          return this.filter(negate(getIteratee(predicate)));
        };
        LazyWrapper.prototype.slice = function(start, end) {
          start = toInteger(start);
          var result3 = this;
          if (result3.__filtered__ && (start > 0 || end < 0)) {
            return new LazyWrapper(result3);
          }
          if (start < 0) {
            result3 = result3.takeRight(-start);
          } else if (start) {
            result3 = result3.drop(start);
          }
          if (end !== undefined2) {
            end = toInteger(end);
            result3 = end < 0 ? result3.dropRight(-end) : result3.take(end - start);
          }
          return result3;
        };
        LazyWrapper.prototype.takeRightWhile = function(predicate) {
          return this.reverse().takeWhile(predicate).reverse();
        };
        LazyWrapper.prototype.toArray = function() {
          return this.take(MAX_ARRAY_LENGTH);
        };
        baseForOwn(LazyWrapper.prototype, function(func2, methodName) {
          var checkIteratee = /^(?:filter|find|map|reject)|While$/.test(methodName), isTaker = /^(?:head|last)$/.test(methodName), lodashFunc = lodash[isTaker ? "take" + (methodName == "last" ? "Right" : "") : methodName], retUnwrapped = isTaker || /^find/.test(methodName);
          if (!lodashFunc) {
            return;
          }
          lodash.prototype[methodName] = function() {
            var value = this.__wrapped__, args = isTaker ? [1] : arguments, isLazy = value instanceof LazyWrapper, iteratee2 = args[0], useLazy = isLazy || isArray(value);
            var interceptor = function(value2) {
              var result4 = lodashFunc.apply(lodash, arrayPush([value2], args));
              return isTaker && chainAll ? result4[0] : result4;
            };
            if (useLazy && checkIteratee && typeof iteratee2 == "function" && iteratee2.length != 1) {
              isLazy = useLazy = false;
            }
            var chainAll = this.__chain__, isHybrid = !!this.__actions__.length, isUnwrapped = retUnwrapped && !chainAll, onlyLazy = isLazy && !isHybrid;
            if (!retUnwrapped && useLazy) {
              value = onlyLazy ? value : new LazyWrapper(this);
              var result3 = func2.apply(value, args);
              result3.__actions__.push({ "func": thru, "args": [interceptor], "thisArg": undefined2 });
              return new LodashWrapper(result3, chainAll);
            }
            if (isUnwrapped && onlyLazy) {
              return func2.apply(this, args);
            }
            result3 = this.thru(interceptor);
            return isUnwrapped ? isTaker ? result3.value()[0] : result3.value() : result3;
          };
        });
        arrayEach(["pop", "push", "shift", "sort", "splice", "unshift"], function(methodName) {
          var func2 = arrayProto[methodName], chainName = /^(?:push|sort|unshift)$/.test(methodName) ? "tap" : "thru", retUnwrapped = /^(?:pop|shift)$/.test(methodName);
          lodash.prototype[methodName] = function() {
            var args = arguments;
            if (retUnwrapped && !this.__chain__) {
              var value = this.value();
              return func2.apply(isArray(value) ? value : [], args);
            }
            return this[chainName](function(value2) {
              return func2.apply(isArray(value2) ? value2 : [], args);
            });
          };
        });
        baseForOwn(LazyWrapper.prototype, function(func2, methodName) {
          var lodashFunc = lodash[methodName];
          if (lodashFunc) {
            var key2 = lodashFunc.name + "";
            if (!hasOwnProperty2.call(realNames, key2)) {
              realNames[key2] = [];
            }
            realNames[key2].push({ "name": methodName, "func": lodashFunc });
          }
        });
        realNames[createHybrid(undefined2, WRAP_BIND_KEY_FLAG).name] = [{
          "name": "wrapper",
          "func": undefined2
        }];
        LazyWrapper.prototype.clone = lazyClone;
        LazyWrapper.prototype.reverse = lazyReverse;
        LazyWrapper.prototype.value = lazyValue;
        lodash.prototype.at = wrapperAt;
        lodash.prototype.chain = wrapperChain;
        lodash.prototype.commit = wrapperCommit;
        lodash.prototype.next = wrapperNext;
        lodash.prototype.plant = wrapperPlant;
        lodash.prototype.reverse = wrapperReverse;
        lodash.prototype.toJSON = lodash.prototype.valueOf = lodash.prototype.value = wrapperValue;
        lodash.prototype.first = lodash.prototype.head;
        if (symIterator) {
          lodash.prototype[symIterator] = wrapperToIterator;
        }
        return lodash;
      };
      var _ = runInContext();
      if (typeof define == "function" && typeof define.amd == "object" && define.amd) {
        root._ = _;
        define(function() {
          return _;
        });
      } else if (freeModule) {
        (freeModule.exports = _)._ = _;
        freeExports._ = _;
      } else {
        root._ = _;
      }
    }).call(exports2);
  }
});

// node_modules/ansi-escapes/index.js
var require_ansi_escapes = __commonJS({
  "node_modules/ansi-escapes/index.js"(exports2, module2) {
    "use strict";
    var ansiEscapes = module2.exports;
    module2.exports.default = ansiEscapes;
    var ESC = "[";
    var OSC = "]";
    var BEL = "\x07";
    var SEP = ";";
    var isTerminalApp = process.env.TERM_PROGRAM === "Apple_Terminal";
    ansiEscapes.cursorTo = (x, y2) => {
      if (typeof x !== "number") {
        throw new TypeError("The `x` argument is required");
      }
      if (typeof y2 !== "number") {
        return ESC + (x + 1) + "G";
      }
      return ESC + (y2 + 1) + ";" + (x + 1) + "H";
    };
    ansiEscapes.cursorMove = (x, y2) => {
      if (typeof x !== "number") {
        throw new TypeError("The `x` argument is required");
      }
      let ret = "";
      if (x < 0) {
        ret += ESC + -x + "D";
      } else if (x > 0) {
        ret += ESC + x + "C";
      }
      if (y2 < 0) {
        ret += ESC + -y2 + "A";
      } else if (y2 > 0) {
        ret += ESC + y2 + "B";
      }
      return ret;
    };
    ansiEscapes.cursorUp = (count = 1) => ESC + count + "A";
    ansiEscapes.cursorDown = (count = 1) => ESC + count + "B";
    ansiEscapes.cursorForward = (count = 1) => ESC + count + "C";
    ansiEscapes.cursorBackward = (count = 1) => ESC + count + "D";
    ansiEscapes.cursorLeft = ESC + "G";
    ansiEscapes.cursorSavePosition = isTerminalApp ? "7" : ESC + "s";
    ansiEscapes.cursorRestorePosition = isTerminalApp ? "8" : ESC + "u";
    ansiEscapes.cursorGetPosition = ESC + "6n";
    ansiEscapes.cursorNextLine = ESC + "E";
    ansiEscapes.cursorPrevLine = ESC + "F";
    ansiEscapes.cursorHide = ESC + "?25l";
    ansiEscapes.cursorShow = ESC + "?25h";
    ansiEscapes.eraseLines = (count) => {
      let clear = "";
      for (let i3 = 0; i3 < count; i3++) {
        clear += ansiEscapes.eraseLine + (i3 < count - 1 ? ansiEscapes.cursorUp() : "");
      }
      if (count) {
        clear += ansiEscapes.cursorLeft;
      }
      return clear;
    };
    ansiEscapes.eraseEndLine = ESC + "K";
    ansiEscapes.eraseStartLine = ESC + "1K";
    ansiEscapes.eraseLine = ESC + "2K";
    ansiEscapes.eraseDown = ESC + "J";
    ansiEscapes.eraseUp = ESC + "1J";
    ansiEscapes.eraseScreen = ESC + "2J";
    ansiEscapes.scrollUp = ESC + "S";
    ansiEscapes.scrollDown = ESC + "T";
    ansiEscapes.clearScreen = "c";
    ansiEscapes.clearTerminal = process.platform === "win32" ? `${ansiEscapes.eraseScreen}${ESC}0f` : `${ansiEscapes.eraseScreen}${ESC}3J${ESC}H`;
    ansiEscapes.beep = BEL;
    ansiEscapes.link = (text, url) => {
      return [
        OSC,
        "8",
        SEP,
        SEP,
        url,
        BEL,
        text,
        OSC,
        "8",
        SEP,
        SEP,
        BEL
      ].join("");
    };
    ansiEscapes.image = (buffer2, options = {}) => {
      let ret = `${OSC}1337;File=inline=1`;
      if (options.width) {
        ret += `;width=${options.width}`;
      }
      if (options.height) {
        ret += `;height=${options.height}`;
      }
      if (options.preserveAspectRatio === false) {
        ret += ";preserveAspectRatio=0";
      }
      return ret + ":" + buffer2.toString("base64") + BEL;
    };
    ansiEscapes.iTerm = {
      setCwd: (cwd = process.cwd()) => `${OSC}50;CurrentDir=${cwd}${BEL}`,
      annotation: (message, options = {}) => {
        let ret = `${OSC}1337;`;
        const hasX = typeof options.x !== "undefined";
        const hasY = typeof options.y !== "undefined";
        if ((hasX || hasY) && !(hasX && hasY && typeof options.length !== "undefined")) {
          throw new Error("`x`, `y` and `length` must be defined when `x` or `y` is defined");
        }
        message = message.replace(/\|/g, "");
        ret += options.isHidden ? "AddHiddenAnnotation=" : "AddAnnotation=";
        if (options.length > 0) {
          ret += (hasX ? [message, options.length, options.x, options.y] : [options.length, message]).join("|");
        } else {
          ret += message;
        }
        return ret + BEL;
      }
    };
  }
});

// node_modules/mimic-fn/index.js
var require_mimic_fn = __commonJS({
  "node_modules/mimic-fn/index.js"(exports2, module2) {
    "use strict";
    var mimicFn = (to, from) => {
      for (const prop of Reflect.ownKeys(from)) {
        Object.defineProperty(to, prop, Object.getOwnPropertyDescriptor(from, prop));
      }
      return to;
    };
    module2.exports = mimicFn;
    module2.exports.default = mimicFn;
  }
});

// node_modules/onetime/index.js
var require_onetime = __commonJS({
  "node_modules/onetime/index.js"(exports2, module2) {
    "use strict";
    var mimicFn = require_mimic_fn();
    var calledFunctions = new WeakMap();
    var onetime = (function_, options = {}) => {
      if (typeof function_ !== "function") {
        throw new TypeError("Expected a function");
      }
      let returnValue;
      let callCount = 0;
      const functionName = function_.displayName || function_.name || "<anonymous>";
      const onetime2 = function(...arguments_) {
        calledFunctions.set(onetime2, ++callCount);
        if (callCount === 1) {
          returnValue = function_.apply(this, arguments_);
          function_ = null;
        } else if (options.throw === true) {
          throw new Error(`Function \`${functionName}\` can only be called once`);
        }
        return returnValue;
      };
      mimicFn(onetime2, function_);
      calledFunctions.set(onetime2, callCount);
      return onetime2;
    };
    module2.exports = onetime;
    module2.exports.default = onetime;
    module2.exports.callCount = (function_) => {
      if (!calledFunctions.has(function_)) {
        throw new Error(`The given function \`${function_.name}\` is not wrapped by the \`onetime\` package`);
      }
      return calledFunctions.get(function_);
    };
  }
});

// node_modules/signal-exit/signals.js
var require_signals = __commonJS({
  "node_modules/signal-exit/signals.js"(exports2, module2) {
    module2.exports = [
      "SIGABRT",
      "SIGALRM",
      "SIGHUP",
      "SIGINT",
      "SIGTERM"
    ];
    if (process.platform !== "win32") {
      module2.exports.push("SIGVTALRM", "SIGXCPU", "SIGXFSZ", "SIGUSR2", "SIGTRAP", "SIGSYS", "SIGQUIT", "SIGIOT");
    }
    if (process.platform === "linux") {
      module2.exports.push("SIGIO", "SIGPOLL", "SIGPWR", "SIGSTKFLT", "SIGUNUSED");
    }
  }
});

// node_modules/signal-exit/index.js
var require_signal_exit = __commonJS({
  "node_modules/signal-exit/index.js"(exports2, module2) {
    var process2 = global.process;
    if (typeof process2 !== "object" || !process2) {
      module2.exports = () => {
      };
    } else {
      assert2 = require("assert");
      signals = require_signals();
      isWin = /^win/i.test(process2.platform);
      EE = require("events");
      if (typeof EE !== "function") {
        EE = EE.EventEmitter;
      }
      if (process2.__signal_exit_emitter__) {
        emitter = process2.__signal_exit_emitter__;
      } else {
        emitter = process2.__signal_exit_emitter__ = new EE();
        emitter.count = 0;
        emitter.emitted = {};
      }
      if (!emitter.infinite) {
        emitter.setMaxListeners(Infinity);
        emitter.infinite = true;
      }
      module2.exports = function(cb2, opts) {
        if (global.process !== process2) {
          return;
        }
        assert2.equal(typeof cb2, "function", "a callback must be provided for exit handler");
        if (loaded === false) {
          load2();
        }
        var ev = "exit";
        if (opts && opts.alwaysLast) {
          ev = "afterexit";
        }
        var remove = function() {
          emitter.removeListener(ev, cb2);
          if (emitter.listeners("exit").length === 0 && emitter.listeners("afterexit").length === 0) {
            unload();
          }
        };
        emitter.on(ev, cb2);
        return remove;
      };
      unload = function unload2() {
        if (!loaded || global.process !== process2) {
          return;
        }
        loaded = false;
        signals.forEach(function(sig) {
          try {
            process2.removeListener(sig, sigListeners[sig]);
          } catch (er) {
          }
        });
        process2.emit = originalProcessEmit;
        process2.reallyExit = originalProcessReallyExit;
        emitter.count -= 1;
      };
      module2.exports.unload = unload;
      emit = function emit2(event2, code, signal) {
        if (emitter.emitted[event2]) {
          return;
        }
        emitter.emitted[event2] = true;
        emitter.emit(event2, code, signal);
      };
      sigListeners = {};
      signals.forEach(function(sig) {
        sigListeners[sig] = function listener() {
          if (process2 !== global.process) {
            return;
          }
          var listeners = process2.listeners(sig);
          if (listeners.length === emitter.count) {
            unload();
            emit("exit", null, sig);
            emit("afterexit", null, sig);
            if (isWin && sig === "SIGHUP") {
              sig = "SIGINT";
            }
            process2.kill(process2.pid, sig);
          }
        };
      });
      module2.exports.signals = function() {
        return signals;
      };
      loaded = false;
      load2 = function load3() {
        if (loaded || process2 !== global.process) {
          return;
        }
        loaded = true;
        emitter.count += 1;
        signals = signals.filter(function(sig) {
          try {
            process2.on(sig, sigListeners[sig]);
            return true;
          } catch (er) {
            return false;
          }
        });
        process2.emit = processEmit;
        process2.reallyExit = processReallyExit;
      };
      module2.exports.load = load2;
      originalProcessReallyExit = process2.reallyExit;
      processReallyExit = function processReallyExit2(code) {
        if (process2 !== global.process) {
          return;
        }
        process2.exitCode = code || 0;
        emit("exit", process2.exitCode, null);
        emit("afterexit", process2.exitCode, null);
        originalProcessReallyExit.call(process2, process2.exitCode);
      };
      originalProcessEmit = process2.emit;
      processEmit = function processEmit2(ev, arg2) {
        if (ev === "exit" && process2 === global.process) {
          if (arg2 !== void 0) {
            process2.exitCode = arg2;
          }
          var ret = originalProcessEmit.apply(this, arguments);
          emit("exit", process2.exitCode, null);
          emit("afterexit", process2.exitCode, null);
          return ret;
        } else {
          return originalProcessEmit.apply(this, arguments);
        }
      };
    }
    var assert2;
    var signals;
    var isWin;
    var EE;
    var emitter;
    var unload;
    var emit;
    var sigListeners;
    var loaded;
    var load2;
    var originalProcessReallyExit;
    var processReallyExit;
    var originalProcessEmit;
    var processEmit;
  }
});

// node_modules/restore-cursor/index.js
var require_restore_cursor = __commonJS({
  "node_modules/restore-cursor/index.js"(exports2, module2) {
    "use strict";
    var onetime = require_onetime();
    var signalExit = require_signal_exit();
    module2.exports = onetime(() => {
      signalExit(() => {
        process.stderr.write("[?25h");
      }, { alwaysLast: true });
    });
  }
});

// node_modules/cli-cursor/index.js
var require_cli_cursor = __commonJS({
  "node_modules/cli-cursor/index.js"(exports2) {
    "use strict";
    var restoreCursor = require_restore_cursor();
    var isHidden = false;
    exports2.show = (writableStream = process.stderr) => {
      if (!writableStream.isTTY) {
        return;
      }
      isHidden = false;
      writableStream.write("[?25h");
    };
    exports2.hide = (writableStream = process.stderr) => {
      if (!writableStream.isTTY) {
        return;
      }
      restoreCursor();
      isHidden = true;
      writableStream.write("[?25l");
    };
    exports2.toggle = (force, writableStream) => {
      if (force !== void 0) {
        isHidden = force;
      }
      if (isHidden) {
        exports2.show(writableStream);
      } else {
        exports2.hide(writableStream);
      }
    };
  }
});

// node_modules/ink/build/log-update.js
var require_log_update = __commonJS({
  "node_modules/ink/build/log-update.js"(exports2) {
    "use strict";
    var __importDefault = exports2 && exports2.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { "default": mod };
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    var ansi_escapes_1 = __importDefault(require_ansi_escapes());
    var cli_cursor_1 = __importDefault(require_cli_cursor());
    var create = (stream, { showCursor = false } = {}) => {
      let previousLineCount = 0;
      let previousOutput = "";
      let hasHiddenCursor = false;
      const render2 = (str2) => {
        if (!showCursor && !hasHiddenCursor) {
          cli_cursor_1.default.hide();
          hasHiddenCursor = true;
        }
        const output = str2 + "\n";
        if (output === previousOutput) {
          return;
        }
        previousOutput = output;
        stream.write(ansi_escapes_1.default.eraseLines(previousLineCount) + output);
        previousLineCount = output.split("\n").length;
      };
      render2.clear = () => {
        stream.write(ansi_escapes_1.default.eraseLines(previousLineCount));
        previousOutput = "";
        previousLineCount = 0;
      };
      render2.done = () => {
        previousOutput = "";
        previousLineCount = 0;
        if (!showCursor) {
          cli_cursor_1.default.show();
          hasHiddenCursor = false;
        }
      };
      return render2;
    };
    exports2.default = { create };
  }
});

// node_modules/ci-info/vendors.json
var require_vendors = __commonJS({
  "node_modules/ci-info/vendors.json"(exports2, module2) {
    module2.exports = [
      {
        name: "AppVeyor",
        constant: "APPVEYOR",
        env: "APPVEYOR",
        pr: "APPVEYOR_PULL_REQUEST_NUMBER"
      },
      {
        name: "Azure Pipelines",
        constant: "AZURE_PIPELINES",
        env: "SYSTEM_TEAMFOUNDATIONCOLLECTIONURI",
        pr: "SYSTEM_PULLREQUEST_PULLREQUESTID"
      },
      {
        name: "Bamboo",
        constant: "BAMBOO",
        env: "bamboo_planKey"
      },
      {
        name: "Bitbucket Pipelines",
        constant: "BITBUCKET",
        env: "BITBUCKET_COMMIT",
        pr: "BITBUCKET_PR_ID"
      },
      {
        name: "Bitrise",
        constant: "BITRISE",
        env: "BITRISE_IO",
        pr: "BITRISE_PULL_REQUEST"
      },
      {
        name: "Buddy",
        constant: "BUDDY",
        env: "BUDDY_WORKSPACE_ID",
        pr: "BUDDY_EXECUTION_PULL_REQUEST_ID"
      },
      {
        name: "Buildkite",
        constant: "BUILDKITE",
        env: "BUILDKITE",
        pr: { env: "BUILDKITE_PULL_REQUEST", ne: "false" }
      },
      {
        name: "CircleCI",
        constant: "CIRCLE",
        env: "CIRCLECI",
        pr: "CIRCLE_PULL_REQUEST"
      },
      {
        name: "Cirrus CI",
        constant: "CIRRUS",
        env: "CIRRUS_CI",
        pr: "CIRRUS_PR"
      },
      {
        name: "AWS CodeBuild",
        constant: "CODEBUILD",
        env: "CODEBUILD_BUILD_ARN"
      },
      {
        name: "Codeship",
        constant: "CODESHIP",
        env: { CI_NAME: "codeship" }
      },
      {
        name: "Drone",
        constant: "DRONE",
        env: "DRONE",
        pr: { DRONE_BUILD_EVENT: "pull_request" }
      },
      {
        name: "dsari",
        constant: "DSARI",
        env: "DSARI"
      },
      {
        name: "GitLab CI",
        constant: "GITLAB",
        env: "GITLAB_CI"
      },
      {
        name: "GoCD",
        constant: "GOCD",
        env: "GO_PIPELINE_LABEL"
      },
      {
        name: "Hudson",
        constant: "HUDSON",
        env: "HUDSON_URL"
      },
      {
        name: "Jenkins",
        constant: "JENKINS",
        env: ["JENKINS_URL", "BUILD_ID"],
        pr: { any: ["ghprbPullId", "CHANGE_ID"] }
      },
      {
        name: "Magnum CI",
        constant: "MAGNUM",
        env: "MAGNUM"
      },
      {
        name: "Netlify CI",
        constant: "NETLIFY",
        env: "NETLIFY_BUILD_BASE",
        pr: { env: "PULL_REQUEST", ne: "false" }
      },
      {
        name: "Sail CI",
        constant: "SAIL",
        env: "SAILCI",
        pr: "SAIL_PULL_REQUEST_NUMBER"
      },
      {
        name: "Semaphore",
        constant: "SEMAPHORE",
        env: "SEMAPHORE",
        pr: "PULL_REQUEST_NUMBER"
      },
      {
        name: "Shippable",
        constant: "SHIPPABLE",
        env: "SHIPPABLE",
        pr: { IS_PULL_REQUEST: "true" }
      },
      {
        name: "Solano CI",
        constant: "SOLANO",
        env: "TDDIUM",
        pr: "TDDIUM_PR_ID"
      },
      {
        name: "Strider CD",
        constant: "STRIDER",
        env: "STRIDER"
      },
      {
        name: "TaskCluster",
        constant: "TASKCLUSTER",
        env: ["TASK_ID", "RUN_ID"]
      },
      {
        name: "TeamCity",
        constant: "TEAMCITY",
        env: "TEAMCITY_VERSION"
      },
      {
        name: "Travis CI",
        constant: "TRAVIS",
        env: "TRAVIS",
        pr: { env: "TRAVIS_PULL_REQUEST", ne: "false" }
      }
    ];
  }
});

// node_modules/ci-info/index.js
var require_ci_info = __commonJS({
  "node_modules/ci-info/index.js"(exports2) {
    "use strict";
    var vendors = require_vendors();
    var env = process.env;
    Object.defineProperty(exports2, "_vendors", {
      value: vendors.map(function(v) {
        return v.constant;
      })
    });
    exports2.name = null;
    exports2.isPR = null;
    vendors.forEach(function(vendor) {
      var envs = Array.isArray(vendor.env) ? vendor.env : [vendor.env];
      var isCI = envs.every(function(obj) {
        return checkEnv(obj);
      });
      exports2[vendor.constant] = isCI;
      if (isCI) {
        exports2.name = vendor.name;
        switch (typeof vendor.pr) {
          case "string":
            exports2.isPR = !!env[vendor.pr];
            break;
          case "object":
            if ("env" in vendor.pr) {
              exports2.isPR = vendor.pr.env in env && env[vendor.pr.env] !== vendor.pr.ne;
            } else if ("any" in vendor.pr) {
              exports2.isPR = vendor.pr.any.some(function(key2) {
                return !!env[key2];
              });
            } else {
              exports2.isPR = checkEnv(vendor.pr);
            }
            break;
          default:
            exports2.isPR = null;
        }
      }
    });
    exports2.isCI = !!(env.CI || env.CONTINUOUS_INTEGRATION || env.BUILD_NUMBER || env.RUN_ID || exports2.name || false);
    function checkEnv(obj) {
      if (typeof obj === "string")
        return !!env[obj];
      return Object.keys(obj).every(function(k) {
        return env[k] === obj[k];
      });
    }
  }
});

// node_modules/is-ci/index.js
var require_is_ci = __commonJS({
  "node_modules/is-ci/index.js"(exports2, module2) {
    "use strict";
    module2.exports = require_ci_info().isCI;
  }
});

// node_modules/auto-bind/index.js
var require_auto_bind = __commonJS({
  "node_modules/auto-bind/index.js"(exports2, module2) {
    "use strict";
    var getAllProperties = (object) => {
      const properties = /* @__PURE__ */ new Set();
      do {
        for (const key2 of Reflect.ownKeys(object)) {
          properties.add([object, key2]);
        }
      } while ((object = Reflect.getPrototypeOf(object)) && object !== Object.prototype);
      return properties;
    };
    module2.exports = (self2, { include, exclude } = {}) => {
      const filter = (key2) => {
        const match = (pattern) => typeof pattern === "string" ? key2 === pattern : pattern.test(key2);
        if (include) {
          return include.some(match);
        }
        if (exclude) {
          return !exclude.some(match);
        }
        return true;
      };
      for (const [object, key2] of getAllProperties(self2.constructor.prototype)) {
        if (key2 === "constructor" || !filter(key2)) {
          continue;
        }
        const descriptor = Reflect.getOwnPropertyDescriptor(object, key2);
        if (descriptor && typeof descriptor.value === "function") {
          self2[key2] = self2[key2].bind(self2);
        }
      }
      return self2;
    };
  }
});

// node_modules/scheduler/cjs/scheduler.production.min.js
var require_scheduler_production_min = __commonJS({
  "node_modules/scheduler/cjs/scheduler.production.min.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var f;
    var g2;
    var h;
    var k;
    var l2;
    if (typeof window === "undefined" || typeof MessageChannel !== "function") {
      p = null, q = null, t2 = function() {
        if (p !== null)
          try {
            var a2 = exports2.unstable_now();
            p(true, a2);
            p = null;
          } catch (b2) {
            throw setTimeout(t2, 0), b2;
          }
      }, u2 = Date.now();
      exports2.unstable_now = function() {
        return Date.now() - u2;
      };
      f = function(a2) {
        p !== null ? setTimeout(f, 0, a2) : (p = a2, setTimeout(t2, 0));
      };
      g2 = function(a2, b2) {
        q = setTimeout(a2, b2);
      };
      h = function() {
        clearTimeout(q);
      };
      k = function() {
        return false;
      };
      l2 = exports2.unstable_forceFrameRate = function() {
      };
    } else {
      w = window.performance, x = window.Date, y2 = window.setTimeout, z = window.clearTimeout;
      if (typeof console !== "undefined") {
        A = window.cancelAnimationFrame;
        typeof window.requestAnimationFrame !== "function" && console.error("This browser doesn't support requestAnimationFrame. Make sure that you load a polyfill in older browsers. https://fb.me/react-polyfills");
        typeof A !== "function" && console.error("This browser doesn't support cancelAnimationFrame. Make sure that you load a polyfill in older browsers. https://fb.me/react-polyfills");
      }
      if (typeof w === "object" && typeof w.now === "function")
        exports2.unstable_now = function() {
          return w.now();
        };
      else {
        B = x.now();
        exports2.unstable_now = function() {
          return x.now() - B;
        };
      }
      C = false, D = null, E = -1, F = 5, G = 0;
      k = function() {
        return exports2.unstable_now() >= G;
      };
      l2 = function() {
      };
      exports2.unstable_forceFrameRate = function(a2) {
        0 > a2 || 125 < a2 ? console.error("forceFrameRate takes a positive int between 0 and 125, forcing framerates higher than 125 fps is not unsupported") : F = 0 < a2 ? Math.floor(1e3 / a2) : 5;
      };
      H = new MessageChannel(), I = H.port2;
      H.port1.onmessage = function() {
        if (D !== null) {
          var a2 = exports2.unstable_now();
          G = a2 + F;
          try {
            D(true, a2) ? I.postMessage(null) : (C = false, D = null);
          } catch (b2) {
            throw I.postMessage(null), b2;
          }
        } else
          C = false;
      };
      f = function(a2) {
        D = a2;
        C || (C = true, I.postMessage(null));
      };
      g2 = function(a2, b2) {
        E = y2(function() {
          a2(exports2.unstable_now());
        }, b2);
      };
      h = function() {
        z(E);
        E = -1;
      };
    }
    var p;
    var q;
    var t2;
    var u2;
    var w;
    var x;
    var y2;
    var z;
    var A;
    var B;
    var C;
    var D;
    var E;
    var F;
    var G;
    var H;
    var I;
    function J(a2, b2) {
      var c2 = a2.length;
      a2.push(b2);
      a:
        for (; ; ) {
          var d = Math.floor((c2 - 1) / 2), e2 = a2[d];
          if (e2 !== void 0 && 0 < K(e2, b2))
            a2[d] = b2, a2[c2] = e2, c2 = d;
          else
            break a;
        }
    }
    function L(a2) {
      a2 = a2[0];
      return a2 === void 0 ? null : a2;
    }
    function M(a2) {
      var b2 = a2[0];
      if (b2 !== void 0) {
        var c2 = a2.pop();
        if (c2 !== b2) {
          a2[0] = c2;
          a:
            for (var d = 0, e2 = a2.length; d < e2; ) {
              var m = 2 * (d + 1) - 1, n2 = a2[m], v = m + 1, r2 = a2[v];
              if (n2 !== void 0 && 0 > K(n2, c2))
                r2 !== void 0 && 0 > K(r2, n2) ? (a2[d] = r2, a2[v] = c2, d = v) : (a2[d] = n2, a2[m] = c2, d = m);
              else if (r2 !== void 0 && 0 > K(r2, c2))
                a2[d] = r2, a2[v] = c2, d = v;
              else
                break a;
            }
        }
        return b2;
      }
      return null;
    }
    function K(a2, b2) {
      var c2 = a2.sortIndex - b2.sortIndex;
      return c2 !== 0 ? c2 : a2.id - b2.id;
    }
    var N = [];
    var O = [];
    var P = 1;
    var Q = null;
    var R = 3;
    var S = false;
    var T = false;
    var U = false;
    function V(a2) {
      for (var b2 = L(O); b2 !== null; ) {
        if (b2.callback === null)
          M(O);
        else if (b2.startTime <= a2)
          M(O), b2.sortIndex = b2.expirationTime, J(N, b2);
        else
          break;
        b2 = L(O);
      }
    }
    function W(a2) {
      U = false;
      V(a2);
      if (!T)
        if (L(N) !== null)
          T = true, f(X);
        else {
          var b2 = L(O);
          b2 !== null && g2(W, b2.startTime - a2);
        }
    }
    function X(a2, b2) {
      T = false;
      U && (U = false, h());
      S = true;
      var c2 = R;
      try {
        V(b2);
        for (Q = L(N); Q !== null && (!(Q.expirationTime > b2) || a2 && !k()); ) {
          var d = Q.callback;
          if (d !== null) {
            Q.callback = null;
            R = Q.priorityLevel;
            var e2 = d(Q.expirationTime <= b2);
            b2 = exports2.unstable_now();
            typeof e2 === "function" ? Q.callback = e2 : Q === L(N) && M(N);
            V(b2);
          } else
            M(N);
          Q = L(N);
        }
        if (Q !== null)
          var m = true;
        else {
          var n2 = L(O);
          n2 !== null && g2(W, n2.startTime - b2);
          m = false;
        }
        return m;
      } finally {
        Q = null, R = c2, S = false;
      }
    }
    function Y(a2) {
      switch (a2) {
        case 1:
          return -1;
        case 2:
          return 250;
        case 5:
          return 1073741823;
        case 4:
          return 1e4;
        default:
          return 5e3;
      }
    }
    var Z = l2;
    exports2.unstable_ImmediatePriority = 1;
    exports2.unstable_UserBlockingPriority = 2;
    exports2.unstable_NormalPriority = 3;
    exports2.unstable_IdlePriority = 5;
    exports2.unstable_LowPriority = 4;
    exports2.unstable_runWithPriority = function(a2, b2) {
      switch (a2) {
        case 1:
        case 2:
        case 3:
        case 4:
        case 5:
          break;
        default:
          a2 = 3;
      }
      var c2 = R;
      R = a2;
      try {
        return b2();
      } finally {
        R = c2;
      }
    };
    exports2.unstable_next = function(a2) {
      switch (R) {
        case 1:
        case 2:
        case 3:
          var b2 = 3;
          break;
        default:
          b2 = R;
      }
      var c2 = R;
      R = b2;
      try {
        return a2();
      } finally {
        R = c2;
      }
    };
    exports2.unstable_scheduleCallback = function(a2, b2, c2) {
      var d = exports2.unstable_now();
      if (typeof c2 === "object" && c2 !== null) {
        var e2 = c2.delay;
        e2 = typeof e2 === "number" && 0 < e2 ? d + e2 : d;
        c2 = typeof c2.timeout === "number" ? c2.timeout : Y(a2);
      } else
        c2 = Y(a2), e2 = d;
      c2 = e2 + c2;
      a2 = { id: P++, callback: b2, priorityLevel: a2, startTime: e2, expirationTime: c2, sortIndex: -1 };
      e2 > d ? (a2.sortIndex = e2, J(O, a2), L(N) === null && a2 === L(O) && (U ? h() : U = true, g2(W, e2 - d))) : (a2.sortIndex = c2, J(N, a2), T || S || (T = true, f(X)));
      return a2;
    };
    exports2.unstable_cancelCallback = function(a2) {
      a2.callback = null;
    };
    exports2.unstable_wrapCallback = function(a2) {
      var b2 = R;
      return function() {
        var c2 = R;
        R = b2;
        try {
          return a2.apply(this, arguments);
        } finally {
          R = c2;
        }
      };
    };
    exports2.unstable_getCurrentPriorityLevel = function() {
      return R;
    };
    exports2.unstable_shouldYield = function() {
      var a2 = exports2.unstable_now();
      V(a2);
      var b2 = L(N);
      return b2 !== Q && Q !== null && b2 !== null && b2.callback !== null && b2.startTime <= a2 && b2.expirationTime < Q.expirationTime || k();
    };
    exports2.unstable_requestPaint = Z;
    exports2.unstable_continueExecution = function() {
      T || S || (T = true, f(X));
    };
    exports2.unstable_pauseExecution = function() {
    };
    exports2.unstable_getFirstCallbackNode = function() {
      return L(N);
    };
    exports2.unstable_Profiling = null;
  }
});

// node_modules/scheduler/cjs/scheduler.development.js
var require_scheduler_development = __commonJS({
  "node_modules/scheduler/cjs/scheduler.development.js"(exports2) {
    "use strict";
    if (process.env.NODE_ENV !== "production") {
      (function() {
        "use strict";
        Object.defineProperty(exports2, "__esModule", { value: true });
        var enableSchedulerDebugging = false;
        var enableIsInputPending = false;
        var enableProfiling = true;
        var requestHostCallback;
        var requestHostTimeout;
        var cancelHostTimeout;
        var shouldYieldToHost;
        var requestPaint;
        if (typeof window === "undefined" || typeof MessageChannel !== "function") {
          var _callback = null;
          var _timeoutID = null;
          var _flushCallback = function() {
            if (_callback !== null) {
              try {
                var currentTime = exports2.unstable_now();
                var hasRemainingTime = true;
                _callback(hasRemainingTime, currentTime);
                _callback = null;
              } catch (e2) {
                setTimeout(_flushCallback, 0);
                throw e2;
              }
            }
          };
          var initialTime = Date.now();
          exports2.unstable_now = function() {
            return Date.now() - initialTime;
          };
          requestHostCallback = function(cb2) {
            if (_callback !== null) {
              setTimeout(requestHostCallback, 0, cb2);
            } else {
              _callback = cb2;
              setTimeout(_flushCallback, 0);
            }
          };
          requestHostTimeout = function(cb2, ms) {
            _timeoutID = setTimeout(cb2, ms);
          };
          cancelHostTimeout = function() {
            clearTimeout(_timeoutID);
          };
          shouldYieldToHost = function() {
            return false;
          };
          requestPaint = exports2.unstable_forceFrameRate = function() {
          };
        } else {
          var performance2 = window.performance;
          var _Date = window.Date;
          var _setTimeout = window.setTimeout;
          var _clearTimeout = window.clearTimeout;
          if (typeof console !== "undefined") {
            var requestAnimationFrame2 = window.requestAnimationFrame;
            var cancelAnimationFrame2 = window.cancelAnimationFrame;
            if (typeof requestAnimationFrame2 !== "function") {
              console.error("This browser doesn't support requestAnimationFrame. Make sure that you load a polyfill in older browsers. https://fb.me/react-polyfills");
            }
            if (typeof cancelAnimationFrame2 !== "function") {
              console.error("This browser doesn't support cancelAnimationFrame. Make sure that you load a polyfill in older browsers. https://fb.me/react-polyfills");
            }
          }
          if (typeof performance2 === "object" && typeof performance2.now === "function") {
            exports2.unstable_now = function() {
              return performance2.now();
            };
          } else {
            var _initialTime = _Date.now();
            exports2.unstable_now = function() {
              return _Date.now() - _initialTime;
            };
          }
          var isMessageLoopRunning = false;
          var scheduledHostCallback = null;
          var taskTimeoutID = -1;
          var yieldInterval = 5;
          var deadline = 0;
          var maxYieldInterval = 300;
          var needsPaint = false;
          if (enableIsInputPending && navigator !== void 0 && navigator.scheduling !== void 0 && navigator.scheduling.isInputPending !== void 0) {
            var scheduling = navigator.scheduling;
            shouldYieldToHost = function() {
              var currentTime = exports2.unstable_now();
              if (currentTime >= deadline) {
                if (needsPaint || scheduling.isInputPending()) {
                  return true;
                }
                return currentTime >= maxYieldInterval;
              } else {
                return false;
              }
            };
            requestPaint = function() {
              needsPaint = true;
            };
          } else {
            shouldYieldToHost = function() {
              return exports2.unstable_now() >= deadline;
            };
            requestPaint = function() {
            };
          }
          exports2.unstable_forceFrameRate = function(fps) {
            if (fps < 0 || fps > 125) {
              console.error("forceFrameRate takes a positive int between 0 and 125, forcing framerates higher than 125 fps is not unsupported");
              return;
            }
            if (fps > 0) {
              yieldInterval = Math.floor(1e3 / fps);
            } else {
              yieldInterval = 5;
            }
          };
          var performWorkUntilDeadline = function() {
            if (scheduledHostCallback !== null) {
              var currentTime = exports2.unstable_now();
              deadline = currentTime + yieldInterval;
              var hasTimeRemaining = true;
              try {
                var hasMoreWork = scheduledHostCallback(hasTimeRemaining, currentTime);
                if (!hasMoreWork) {
                  isMessageLoopRunning = false;
                  scheduledHostCallback = null;
                } else {
                  port.postMessage(null);
                }
              } catch (error) {
                port.postMessage(null);
                throw error;
              }
            } else {
              isMessageLoopRunning = false;
            }
            needsPaint = false;
          };
          var channel = new MessageChannel();
          var port = channel.port2;
          channel.port1.onmessage = performWorkUntilDeadline;
          requestHostCallback = function(callback) {
            scheduledHostCallback = callback;
            if (!isMessageLoopRunning) {
              isMessageLoopRunning = true;
              port.postMessage(null);
            }
          };
          requestHostTimeout = function(callback, ms) {
            taskTimeoutID = _setTimeout(function() {
              callback(exports2.unstable_now());
            }, ms);
          };
          cancelHostTimeout = function() {
            _clearTimeout(taskTimeoutID);
            taskTimeoutID = -1;
          };
        }
        function push(heap, node) {
          var index = heap.length;
          heap.push(node);
          siftUp(heap, node, index);
        }
        function peek(heap) {
          var first = heap[0];
          return first === void 0 ? null : first;
        }
        function pop(heap) {
          var first = heap[0];
          if (first !== void 0) {
            var last = heap.pop();
            if (last !== first) {
              heap[0] = last;
              siftDown(heap, last, 0);
            }
            return first;
          } else {
            return null;
          }
        }
        function siftUp(heap, node, i3) {
          var index = i3;
          while (true) {
            var parentIndex = Math.floor((index - 1) / 2);
            var parent = heap[parentIndex];
            if (parent !== void 0 && compare(parent, node) > 0) {
              heap[parentIndex] = node;
              heap[index] = parent;
              index = parentIndex;
            } else {
              return;
            }
          }
        }
        function siftDown(heap, node, i3) {
          var index = i3;
          var length = heap.length;
          while (index < length) {
            var leftIndex = (index + 1) * 2 - 1;
            var left = heap[leftIndex];
            var rightIndex = leftIndex + 1;
            var right = heap[rightIndex];
            if (left !== void 0 && compare(left, node) < 0) {
              if (right !== void 0 && compare(right, left) < 0) {
                heap[index] = right;
                heap[rightIndex] = node;
                index = rightIndex;
              } else {
                heap[index] = left;
                heap[leftIndex] = node;
                index = leftIndex;
              }
            } else if (right !== void 0 && compare(right, node) < 0) {
              heap[index] = right;
              heap[rightIndex] = node;
              index = rightIndex;
            } else {
              return;
            }
          }
        }
        function compare(a2, b2) {
          var diff2 = a2.sortIndex - b2.sortIndex;
          return diff2 !== 0 ? diff2 : a2.id - b2.id;
        }
        var NoPriority = 0;
        var ImmediatePriority = 1;
        var UserBlockingPriority = 2;
        var NormalPriority = 3;
        var LowPriority = 4;
        var IdlePriority = 5;
        var runIdCounter = 0;
        var mainThreadIdCounter = 0;
        var profilingStateSize = 4;
        var sharedProfilingBuffer = enableProfiling ? typeof SharedArrayBuffer === "function" ? new SharedArrayBuffer(profilingStateSize * Int32Array.BYTES_PER_ELEMENT) : typeof ArrayBuffer === "function" ? new ArrayBuffer(profilingStateSize * Int32Array.BYTES_PER_ELEMENT) : null : null;
        var profilingState = enableProfiling && sharedProfilingBuffer !== null ? new Int32Array(sharedProfilingBuffer) : [];
        var PRIORITY = 0;
        var CURRENT_TASK_ID = 1;
        var CURRENT_RUN_ID = 2;
        var QUEUE_SIZE = 3;
        if (enableProfiling) {
          profilingState[PRIORITY] = NoPriority;
          profilingState[QUEUE_SIZE] = 0;
          profilingState[CURRENT_TASK_ID] = 0;
        }
        var INITIAL_EVENT_LOG_SIZE = 131072;
        var MAX_EVENT_LOG_SIZE = 524288;
        var eventLogSize = 0;
        var eventLogBuffer = null;
        var eventLog = null;
        var eventLogIndex = 0;
        var TaskStartEvent = 1;
        var TaskCompleteEvent = 2;
        var TaskErrorEvent = 3;
        var TaskCancelEvent = 4;
        var TaskRunEvent = 5;
        var TaskYieldEvent = 6;
        var SchedulerSuspendEvent = 7;
        var SchedulerResumeEvent = 8;
        function logEvent(entries) {
          if (eventLog !== null) {
            var offset = eventLogIndex;
            eventLogIndex += entries.length;
            if (eventLogIndex + 1 > eventLogSize) {
              eventLogSize *= 2;
              if (eventLogSize > MAX_EVENT_LOG_SIZE) {
                console.error("Scheduler Profiling: Event log exceeded maximum size. Don't forget to call `stopLoggingProfilingEvents()`.");
                stopLoggingProfilingEvents();
                return;
              }
              var newEventLog = new Int32Array(eventLogSize * 4);
              newEventLog.set(eventLog);
              eventLogBuffer = newEventLog.buffer;
              eventLog = newEventLog;
            }
            eventLog.set(entries, offset);
          }
        }
        function startLoggingProfilingEvents() {
          eventLogSize = INITIAL_EVENT_LOG_SIZE;
          eventLogBuffer = new ArrayBuffer(eventLogSize * 4);
          eventLog = new Int32Array(eventLogBuffer);
          eventLogIndex = 0;
        }
        function stopLoggingProfilingEvents() {
          var buffer2 = eventLogBuffer;
          eventLogSize = 0;
          eventLogBuffer = null;
          eventLog = null;
          eventLogIndex = 0;
          return buffer2;
        }
        function markTaskStart(task2, ms) {
          if (enableProfiling) {
            profilingState[QUEUE_SIZE]++;
            if (eventLog !== null) {
              logEvent([TaskStartEvent, ms * 1e3, task2.id, task2.priorityLevel]);
            }
          }
        }
        function markTaskCompleted(task2, ms) {
          if (enableProfiling) {
            profilingState[PRIORITY] = NoPriority;
            profilingState[CURRENT_TASK_ID] = 0;
            profilingState[QUEUE_SIZE]--;
            if (eventLog !== null) {
              logEvent([TaskCompleteEvent, ms * 1e3, task2.id]);
            }
          }
        }
        function markTaskCanceled(task2, ms) {
          if (enableProfiling) {
            profilingState[QUEUE_SIZE]--;
            if (eventLog !== null) {
              logEvent([TaskCancelEvent, ms * 1e3, task2.id]);
            }
          }
        }
        function markTaskErrored(task2, ms) {
          if (enableProfiling) {
            profilingState[PRIORITY] = NoPriority;
            profilingState[CURRENT_TASK_ID] = 0;
            profilingState[QUEUE_SIZE]--;
            if (eventLog !== null) {
              logEvent([TaskErrorEvent, ms * 1e3, task2.id]);
            }
          }
        }
        function markTaskRun(task2, ms) {
          if (enableProfiling) {
            runIdCounter++;
            profilingState[PRIORITY] = task2.priorityLevel;
            profilingState[CURRENT_TASK_ID] = task2.id;
            profilingState[CURRENT_RUN_ID] = runIdCounter;
            if (eventLog !== null) {
              logEvent([TaskRunEvent, ms * 1e3, task2.id, runIdCounter]);
            }
          }
        }
        function markTaskYield(task2, ms) {
          if (enableProfiling) {
            profilingState[PRIORITY] = NoPriority;
            profilingState[CURRENT_TASK_ID] = 0;
            profilingState[CURRENT_RUN_ID] = 0;
            if (eventLog !== null) {
              logEvent([TaskYieldEvent, ms * 1e3, task2.id, runIdCounter]);
            }
          }
        }
        function markSchedulerSuspended(ms) {
          if (enableProfiling) {
            mainThreadIdCounter++;
            if (eventLog !== null) {
              logEvent([SchedulerSuspendEvent, ms * 1e3, mainThreadIdCounter]);
            }
          }
        }
        function markSchedulerUnsuspended(ms) {
          if (enableProfiling) {
            if (eventLog !== null) {
              logEvent([SchedulerResumeEvent, ms * 1e3, mainThreadIdCounter]);
            }
          }
        }
        var maxSigned31BitInt = 1073741823;
        var IMMEDIATE_PRIORITY_TIMEOUT = -1;
        var USER_BLOCKING_PRIORITY = 250;
        var NORMAL_PRIORITY_TIMEOUT = 5e3;
        var LOW_PRIORITY_TIMEOUT = 1e4;
        var IDLE_PRIORITY = maxSigned31BitInt;
        var taskQueue = [];
        var timerQueue = [];
        var taskIdCounter = 1;
        var isSchedulerPaused = false;
        var currentTask = null;
        var currentPriorityLevel = NormalPriority;
        var isPerformingWork = false;
        var isHostCallbackScheduled = false;
        var isHostTimeoutScheduled = false;
        function advanceTimers(currentTime) {
          var timer = peek(timerQueue);
          while (timer !== null) {
            if (timer.callback === null) {
              pop(timerQueue);
            } else if (timer.startTime <= currentTime) {
              pop(timerQueue);
              timer.sortIndex = timer.expirationTime;
              push(taskQueue, timer);
              if (enableProfiling) {
                markTaskStart(timer, currentTime);
                timer.isQueued = true;
              }
            } else {
              return;
            }
            timer = peek(timerQueue);
          }
        }
        function handleTimeout(currentTime) {
          isHostTimeoutScheduled = false;
          advanceTimers(currentTime);
          if (!isHostCallbackScheduled) {
            if (peek(taskQueue) !== null) {
              isHostCallbackScheduled = true;
              requestHostCallback(flushWork);
            } else {
              var firstTimer = peek(timerQueue);
              if (firstTimer !== null) {
                requestHostTimeout(handleTimeout, firstTimer.startTime - currentTime);
              }
            }
          }
        }
        function flushWork(hasTimeRemaining, initialTime2) {
          if (enableProfiling) {
            markSchedulerUnsuspended(initialTime2);
          }
          isHostCallbackScheduled = false;
          if (isHostTimeoutScheduled) {
            isHostTimeoutScheduled = false;
            cancelHostTimeout();
          }
          isPerformingWork = true;
          var previousPriorityLevel = currentPriorityLevel;
          try {
            if (enableProfiling) {
              try {
                return workLoop(hasTimeRemaining, initialTime2);
              } catch (error) {
                if (currentTask !== null) {
                  var currentTime = exports2.unstable_now();
                  markTaskErrored(currentTask, currentTime);
                  currentTask.isQueued = false;
                }
                throw error;
              }
            } else {
              return workLoop(hasTimeRemaining, initialTime2);
            }
          } finally {
            currentTask = null;
            currentPriorityLevel = previousPriorityLevel;
            isPerformingWork = false;
            if (enableProfiling) {
              var _currentTime = exports2.unstable_now();
              markSchedulerSuspended(_currentTime);
            }
          }
        }
        function workLoop(hasTimeRemaining, initialTime2) {
          var currentTime = initialTime2;
          advanceTimers(currentTime);
          currentTask = peek(taskQueue);
          while (currentTask !== null && !(enableSchedulerDebugging && isSchedulerPaused)) {
            if (currentTask.expirationTime > currentTime && (!hasTimeRemaining || shouldYieldToHost())) {
              break;
            }
            var callback = currentTask.callback;
            if (callback !== null) {
              currentTask.callback = null;
              currentPriorityLevel = currentTask.priorityLevel;
              var didUserCallbackTimeout = currentTask.expirationTime <= currentTime;
              markTaskRun(currentTask, currentTime);
              var continuationCallback = callback(didUserCallbackTimeout);
              currentTime = exports2.unstable_now();
              if (typeof continuationCallback === "function") {
                currentTask.callback = continuationCallback;
                markTaskYield(currentTask, currentTime);
              } else {
                if (enableProfiling) {
                  markTaskCompleted(currentTask, currentTime);
                  currentTask.isQueued = false;
                }
                if (currentTask === peek(taskQueue)) {
                  pop(taskQueue);
                }
              }
              advanceTimers(currentTime);
            } else {
              pop(taskQueue);
            }
            currentTask = peek(taskQueue);
          }
          if (currentTask !== null) {
            return true;
          } else {
            var firstTimer = peek(timerQueue);
            if (firstTimer !== null) {
              requestHostTimeout(handleTimeout, firstTimer.startTime - currentTime);
            }
            return false;
          }
        }
        function unstable_runWithPriority(priorityLevel, eventHandler) {
          switch (priorityLevel) {
            case ImmediatePriority:
            case UserBlockingPriority:
            case NormalPriority:
            case LowPriority:
            case IdlePriority:
              break;
            default:
              priorityLevel = NormalPriority;
          }
          var previousPriorityLevel = currentPriorityLevel;
          currentPriorityLevel = priorityLevel;
          try {
            return eventHandler();
          } finally {
            currentPriorityLevel = previousPriorityLevel;
          }
        }
        function unstable_next(eventHandler) {
          var priorityLevel;
          switch (currentPriorityLevel) {
            case ImmediatePriority:
            case UserBlockingPriority:
            case NormalPriority:
              priorityLevel = NormalPriority;
              break;
            default:
              priorityLevel = currentPriorityLevel;
              break;
          }
          var previousPriorityLevel = currentPriorityLevel;
          currentPriorityLevel = priorityLevel;
          try {
            return eventHandler();
          } finally {
            currentPriorityLevel = previousPriorityLevel;
          }
        }
        function unstable_wrapCallback(callback) {
          var parentPriorityLevel = currentPriorityLevel;
          return function() {
            var previousPriorityLevel = currentPriorityLevel;
            currentPriorityLevel = parentPriorityLevel;
            try {
              return callback.apply(this, arguments);
            } finally {
              currentPriorityLevel = previousPriorityLevel;
            }
          };
        }
        function timeoutForPriorityLevel(priorityLevel) {
          switch (priorityLevel) {
            case ImmediatePriority:
              return IMMEDIATE_PRIORITY_TIMEOUT;
            case UserBlockingPriority:
              return USER_BLOCKING_PRIORITY;
            case IdlePriority:
              return IDLE_PRIORITY;
            case LowPriority:
              return LOW_PRIORITY_TIMEOUT;
            case NormalPriority:
            default:
              return NORMAL_PRIORITY_TIMEOUT;
          }
        }
        function unstable_scheduleCallback(priorityLevel, callback, options) {
          var currentTime = exports2.unstable_now();
          var startTime;
          var timeout;
          if (typeof options === "object" && options !== null) {
            var delay = options.delay;
            if (typeof delay === "number" && delay > 0) {
              startTime = currentTime + delay;
            } else {
              startTime = currentTime;
            }
            timeout = typeof options.timeout === "number" ? options.timeout : timeoutForPriorityLevel(priorityLevel);
          } else {
            timeout = timeoutForPriorityLevel(priorityLevel);
            startTime = currentTime;
          }
          var expirationTime = startTime + timeout;
          var newTask = {
            id: taskIdCounter++,
            callback,
            priorityLevel,
            startTime,
            expirationTime,
            sortIndex: -1
          };
          if (enableProfiling) {
            newTask.isQueued = false;
          }
          if (startTime > currentTime) {
            newTask.sortIndex = startTime;
            push(timerQueue, newTask);
            if (peek(taskQueue) === null && newTask === peek(timerQueue)) {
              if (isHostTimeoutScheduled) {
                cancelHostTimeout();
              } else {
                isHostTimeoutScheduled = true;
              }
              requestHostTimeout(handleTimeout, startTime - currentTime);
            }
          } else {
            newTask.sortIndex = expirationTime;
            push(taskQueue, newTask);
            if (enableProfiling) {
              markTaskStart(newTask, currentTime);
              newTask.isQueued = true;
            }
            if (!isHostCallbackScheduled && !isPerformingWork) {
              isHostCallbackScheduled = true;
              requestHostCallback(flushWork);
            }
          }
          return newTask;
        }
        function unstable_pauseExecution() {
          isSchedulerPaused = true;
        }
        function unstable_continueExecution() {
          isSchedulerPaused = false;
          if (!isHostCallbackScheduled && !isPerformingWork) {
            isHostCallbackScheduled = true;
            requestHostCallback(flushWork);
          }
        }
        function unstable_getFirstCallbackNode() {
          return peek(taskQueue);
        }
        function unstable_cancelCallback(task2) {
          if (enableProfiling) {
            if (task2.isQueued) {
              var currentTime = exports2.unstable_now();
              markTaskCanceled(task2, currentTime);
              task2.isQueued = false;
            }
          }
          task2.callback = null;
        }
        function unstable_getCurrentPriorityLevel() {
          return currentPriorityLevel;
        }
        function unstable_shouldYield() {
          var currentTime = exports2.unstable_now();
          advanceTimers(currentTime);
          var firstTask = peek(taskQueue);
          return firstTask !== currentTask && currentTask !== null && firstTask !== null && firstTask.callback !== null && firstTask.startTime <= currentTime && firstTask.expirationTime < currentTask.expirationTime || shouldYieldToHost();
        }
        var unstable_requestPaint = requestPaint;
        var unstable_Profiling = enableProfiling ? {
          startLoggingProfilingEvents,
          stopLoggingProfilingEvents,
          sharedProfilingBuffer
        } : null;
        exports2.unstable_ImmediatePriority = ImmediatePriority;
        exports2.unstable_UserBlockingPriority = UserBlockingPriority;
        exports2.unstable_NormalPriority = NormalPriority;
        exports2.unstable_IdlePriority = IdlePriority;
        exports2.unstable_LowPriority = LowPriority;
        exports2.unstable_runWithPriority = unstable_runWithPriority;
        exports2.unstable_next = unstable_next;
        exports2.unstable_scheduleCallback = unstable_scheduleCallback;
        exports2.unstable_cancelCallback = unstable_cancelCallback;
        exports2.unstable_wrapCallback = unstable_wrapCallback;
        exports2.unstable_getCurrentPriorityLevel = unstable_getCurrentPriorityLevel;
        exports2.unstable_shouldYield = unstable_shouldYield;
        exports2.unstable_requestPaint = unstable_requestPaint;
        exports2.unstable_continueExecution = unstable_continueExecution;
        exports2.unstable_pauseExecution = unstable_pauseExecution;
        exports2.unstable_getFirstCallbackNode = unstable_getFirstCallbackNode;
        exports2.unstable_Profiling = unstable_Profiling;
      })();
    }
  }
});

// node_modules/scheduler/index.js
var require_scheduler = __commonJS({
  "node_modules/scheduler/index.js"(exports2, module2) {
    "use strict";
    if (process.env.NODE_ENV === "production") {
      module2.exports = require_scheduler_production_min();
    } else {
      module2.exports = require_scheduler_development();
    }
  }
});

// node_modules/ink/node_modules/react-reconciler/cjs/react-reconciler.production.min.js
var require_react_reconciler_production_min = __commonJS({
  "node_modules/ink/node_modules/react-reconciler/cjs/react-reconciler.production.min.js"(exports2, module2) {
    module2.exports = function $$$reconciler($$$hostConfig) {
      "use strict";
      var aa = require_object_assign(), ba = require_react(), m = require_scheduler();
      function n2(a2) {
        for (var b2 = "https://reactjs.org/docs/error-decoder.html?invariant=" + a2, c2 = 1; c2 < arguments.length; c2++)
          b2 += "&args[]=" + encodeURIComponent(arguments[c2]);
        return "Minified React error #" + a2 + "; visit " + b2 + " for the full message or use the non-minified dev environment for full errors and additional helpful warnings.";
      }
      var q = ba.__SECRET_INTERNALS_DO_NOT_USE_OR_YOU_WILL_BE_FIRED;
      q.hasOwnProperty("ReactCurrentDispatcher") || (q.ReactCurrentDispatcher = { current: null });
      q.hasOwnProperty("ReactCurrentBatchConfig") || (q.ReactCurrentBatchConfig = { suspense: null });
      var u2 = typeof Symbol === "function" && Symbol.for, ca = u2 ? Symbol.for("react.element") : 60103, da = u2 ? Symbol.for("react.portal") : 60106, ea = u2 ? Symbol.for("react.fragment") : 60107, fa = u2 ? Symbol.for("react.strict_mode") : 60108, ha = u2 ? Symbol.for("react.profiler") : 60114, ia = u2 ? Symbol.for("react.provider") : 60109, ja = u2 ? Symbol.for("react.context") : 60110, ka = u2 ? Symbol.for("react.concurrent_mode") : 60111, la = u2 ? Symbol.for("react.forward_ref") : 60112, ma = u2 ? Symbol.for("react.suspense") : 60113, na = u2 ? Symbol.for("react.suspense_list") : 60120, oa = u2 ? Symbol.for("react.memo") : 60115, pa = u2 ? Symbol.for("react.lazy") : 60116;
      u2 && Symbol.for("react.fundamental");
      u2 && Symbol.for("react.responder");
      u2 && Symbol.for("react.scope");
      var qa = typeof Symbol === "function" && Symbol.iterator;
      function ra(a2) {
        if (a2 === null || typeof a2 !== "object")
          return null;
        a2 = qa && a2[qa] || a2["@@iterator"];
        return typeof a2 === "function" ? a2 : null;
      }
      function sa(a2) {
        if (a2._status === -1) {
          a2._status = 0;
          var b2 = a2._ctor;
          b2 = b2();
          a2._result = b2;
          b2.then(function(b3) {
            a2._status === 0 && (b3 = b3.default, a2._status = 1, a2._result = b3);
          }, function(b3) {
            a2._status === 0 && (a2._status = 2, a2._result = b3);
          });
        }
      }
      function ta(a2) {
        if (a2 == null)
          return null;
        if (typeof a2 === "function")
          return a2.displayName || a2.name || null;
        if (typeof a2 === "string")
          return a2;
        switch (a2) {
          case ea:
            return "Fragment";
          case da:
            return "Portal";
          case ha:
            return "Profiler";
          case fa:
            return "StrictMode";
          case ma:
            return "Suspense";
          case na:
            return "SuspenseList";
        }
        if (typeof a2 === "object")
          switch (a2.$$typeof) {
            case ja:
              return "Context.Consumer";
            case ia:
              return "Context.Provider";
            case la:
              var b2 = a2.render;
              b2 = b2.displayName || b2.name || "";
              return a2.displayName || (b2 !== "" ? "ForwardRef(" + b2 + ")" : "ForwardRef");
            case oa:
              return ta(a2.type);
            case pa:
              if (a2 = a2._status === 1 ? a2._result : null)
                return ta(a2);
          }
        return null;
      }
      function ua(a2) {
        var b2 = a2, c2 = a2;
        if (a2.alternate)
          for (; b2.return; )
            b2 = b2.return;
        else {
          a2 = b2;
          do
            b2 = a2, (b2.effectTag & 1026) !== 0 && (c2 = b2.return), a2 = b2.return;
          while (a2);
        }
        return b2.tag === 3 ? c2 : null;
      }
      function va(a2) {
        if (ua(a2) !== a2)
          throw Error(n2(188));
      }
      function wa(a2) {
        var b2 = a2.alternate;
        if (!b2) {
          b2 = ua(a2);
          if (b2 === null)
            throw Error(n2(188));
          return b2 !== a2 ? null : a2;
        }
        for (var c2 = a2, d = b2; ; ) {
          var e2 = c2.return;
          if (e2 === null)
            break;
          var f = e2.alternate;
          if (f === null) {
            d = e2.return;
            if (d !== null) {
              c2 = d;
              continue;
            }
            break;
          }
          if (e2.child === f.child) {
            for (f = e2.child; f; ) {
              if (f === c2)
                return va(e2), a2;
              if (f === d)
                return va(e2), b2;
              f = f.sibling;
            }
            throw Error(n2(188));
          }
          if (c2.return !== d.return)
            c2 = e2, d = f;
          else {
            for (var g2 = false, l2 = e2.child; l2; ) {
              if (l2 === c2) {
                g2 = true;
                c2 = e2;
                d = f;
                break;
              }
              if (l2 === d) {
                g2 = true;
                d = e2;
                c2 = f;
                break;
              }
              l2 = l2.sibling;
            }
            if (!g2) {
              for (l2 = f.child; l2; ) {
                if (l2 === c2) {
                  g2 = true;
                  c2 = f;
                  d = e2;
                  break;
                }
                if (l2 === d) {
                  g2 = true;
                  d = f;
                  c2 = e2;
                  break;
                }
                l2 = l2.sibling;
              }
              if (!g2)
                throw Error(n2(189));
            }
          }
          if (c2.alternate !== d)
            throw Error(n2(190));
        }
        if (c2.tag !== 3)
          throw Error(n2(188));
        return c2.stateNode.current === c2 ? a2 : b2;
      }
      function xa(a2) {
        a2 = wa(a2);
        if (!a2)
          return null;
        for (var b2 = a2; ; ) {
          if (b2.tag === 5 || b2.tag === 6)
            return b2;
          if (b2.child)
            b2.child.return = b2, b2 = b2.child;
          else {
            if (b2 === a2)
              break;
            for (; !b2.sibling; ) {
              if (!b2.return || b2.return === a2)
                return null;
              b2 = b2.return;
            }
            b2.sibling.return = b2.return;
            b2 = b2.sibling;
          }
        }
        return null;
      }
      function ya(a2) {
        a2 = wa(a2);
        if (!a2)
          return null;
        for (var b2 = a2; ; ) {
          if (b2.tag === 5 || b2.tag === 6)
            return b2;
          if (b2.child && b2.tag !== 4)
            b2.child.return = b2, b2 = b2.child;
          else {
            if (b2 === a2)
              break;
            for (; !b2.sibling; ) {
              if (!b2.return || b2.return === a2)
                return null;
              b2 = b2.return;
            }
            b2.sibling.return = b2.return;
            b2 = b2.sibling;
          }
        }
        return null;
      }
      var za = $$$hostConfig.getPublicInstance, Aa = $$$hostConfig.getRootHostContext, Ba = $$$hostConfig.getChildHostContext, Ca = $$$hostConfig.prepareForCommit, Da = $$$hostConfig.resetAfterCommit, Ea = $$$hostConfig.createInstance, Fa = $$$hostConfig.appendInitialChild, Ga = $$$hostConfig.finalizeInitialChildren, Ia = $$$hostConfig.prepareUpdate, Ja = $$$hostConfig.shouldSetTextContent, Ka = $$$hostConfig.shouldDeprioritizeSubtree, La = $$$hostConfig.createTextInstance, Ma = $$$hostConfig.setTimeout, Na = $$$hostConfig.clearTimeout, Oa = $$$hostConfig.noTimeout, Pa = $$$hostConfig.isPrimaryRenderer, Qa = $$$hostConfig.supportsMutation, Ra = $$$hostConfig.supportsPersistence, Sa = $$$hostConfig.supportsHydration, Ta = $$$hostConfig.appendChild, Ua = $$$hostConfig.appendChildToContainer, Va = $$$hostConfig.commitTextUpdate, Wa = $$$hostConfig.commitMount, Xa = $$$hostConfig.commitUpdate, Ya = $$$hostConfig.insertBefore, Za = $$$hostConfig.insertInContainerBefore, $a = $$$hostConfig.removeChild, ab = $$$hostConfig.removeChildFromContainer, bb = $$$hostConfig.resetTextContent, cb2 = $$$hostConfig.hideInstance, db = $$$hostConfig.hideTextInstance, eb = $$$hostConfig.unhideInstance, fb = $$$hostConfig.unhideTextInstance, gb = $$$hostConfig.cloneInstance, hb = $$$hostConfig.createContainerChildSet, ib = $$$hostConfig.appendChildToContainerChildSet, kb = $$$hostConfig.finalizeContainerChildren, lb = $$$hostConfig.replaceContainerChildren, mb = $$$hostConfig.cloneHiddenInstance, nb = $$$hostConfig.cloneHiddenTextInstance, ob = $$$hostConfig.canHydrateInstance, pb = $$$hostConfig.canHydrateTextInstance, qb = $$$hostConfig.isSuspenseInstancePending, rb = $$$hostConfig.isSuspenseInstanceFallback, sb = $$$hostConfig.getNextHydratableSibling, tb = $$$hostConfig.getFirstHydratableChild, ub = $$$hostConfig.hydrateInstance, vb = $$$hostConfig.hydrateTextInstance, wb = $$$hostConfig.getNextHydratableInstanceAfterSuspenseInstance, xb = $$$hostConfig.commitHydratedContainer, yb = $$$hostConfig.commitHydratedSuspenseInstance, zb = /^(.*)[\\\/]/;
      function Ab(a2) {
        var b2 = "";
        do {
          a:
            switch (a2.tag) {
              case 3:
              case 4:
              case 6:
              case 7:
              case 10:
              case 9:
                var c2 = "";
                break a;
              default:
                var d = a2._debugOwner, e2 = a2._debugSource, f = ta(a2.type);
                c2 = null;
                d && (c2 = ta(d.type));
                d = f;
                f = "";
                e2 ? f = " (at " + e2.fileName.replace(zb, "") + ":" + e2.lineNumber + ")" : c2 && (f = " (created by " + c2 + ")");
                c2 = "\n    in " + (d || "Unknown") + f;
            }
          b2 += c2;
          a2 = a2.return;
        } while (a2);
        return b2;
      }
      /* @__PURE__ */ new Set();
      var Bb = [], Cb = -1;
      function y2(a2) {
        0 > Cb || (a2.current = Bb[Cb], Bb[Cb] = null, Cb--);
      }
      function z(a2, b2) {
        Cb++;
        Bb[Cb] = a2.current;
        a2.current = b2;
      }
      var Db = {}, A = { current: Db }, B = { current: false }, Eb = Db;
      function Fb(a2, b2) {
        var c2 = a2.type.contextTypes;
        if (!c2)
          return Db;
        var d = a2.stateNode;
        if (d && d.__reactInternalMemoizedUnmaskedChildContext === b2)
          return d.__reactInternalMemoizedMaskedChildContext;
        var e2 = {}, f;
        for (f in c2)
          e2[f] = b2[f];
        d && (a2 = a2.stateNode, a2.__reactInternalMemoizedUnmaskedChildContext = b2, a2.__reactInternalMemoizedMaskedChildContext = e2);
        return e2;
      }
      function C(a2) {
        a2 = a2.childContextTypes;
        return a2 !== null && a2 !== void 0;
      }
      function Gb(a2) {
        y2(B, a2);
        y2(A, a2);
      }
      function Hb(a2) {
        y2(B, a2);
        y2(A, a2);
      }
      function Ib(a2, b2, c2) {
        if (A.current !== Db)
          throw Error(n2(168));
        z(A, b2, a2);
        z(B, c2, a2);
      }
      function Jb(a2, b2, c2) {
        var d = a2.stateNode;
        a2 = b2.childContextTypes;
        if (typeof d.getChildContext !== "function")
          return c2;
        d = d.getChildContext();
        for (var e2 in d)
          if (!(e2 in a2))
            throw Error(n2(108, ta(b2) || "Unknown", e2));
        return aa({}, c2, {}, d);
      }
      function Kb(a2) {
        var b2 = a2.stateNode;
        b2 = b2 && b2.__reactInternalMemoizedMergedChildContext || Db;
        Eb = A.current;
        z(A, b2, a2);
        z(B, B.current, a2);
        return true;
      }
      function Lb(a2, b2, c2) {
        var d = a2.stateNode;
        if (!d)
          throw Error(n2(169));
        c2 ? (b2 = Jb(a2, b2, Eb), d.__reactInternalMemoizedMergedChildContext = b2, y2(B, a2), y2(A, a2), z(A, b2, a2)) : y2(B, a2);
        z(B, c2, a2);
      }
      var Mb = m.unstable_runWithPriority, Nb = m.unstable_scheduleCallback, Ob = m.unstable_cancelCallback, Pb = m.unstable_shouldYield, Qb = m.unstable_requestPaint, Rb = m.unstable_now, Ub = m.unstable_getCurrentPriorityLevel, Vb = m.unstable_ImmediatePriority, Wb = m.unstable_UserBlockingPriority, Xb = m.unstable_NormalPriority, Yb = m.unstable_LowPriority, Zb = m.unstable_IdlePriority, $b = {}, ac = Qb !== void 0 ? Qb : function() {
      }, bc = null, cc = null, dc = false, ec = Rb(), E = 1e4 > ec ? Rb : function() {
        return Rb() - ec;
      };
      function fc() {
        switch (Ub()) {
          case Vb:
            return 99;
          case Wb:
            return 98;
          case Xb:
            return 97;
          case Yb:
            return 96;
          case Zb:
            return 95;
          default:
            throw Error(n2(332));
        }
      }
      function gc(a2) {
        switch (a2) {
          case 99:
            return Vb;
          case 98:
            return Wb;
          case 97:
            return Xb;
          case 96:
            return Yb;
          case 95:
            return Zb;
          default:
            throw Error(n2(332));
        }
      }
      function hc(a2, b2) {
        a2 = gc(a2);
        return Mb(a2, b2);
      }
      function ic(a2, b2, c2) {
        a2 = gc(a2);
        return Nb(a2, b2, c2);
      }
      function jc(a2) {
        bc === null ? (bc = [a2], cc = Nb(Vb, kc)) : bc.push(a2);
        return $b;
      }
      function F() {
        if (cc !== null) {
          var a2 = cc;
          cc = null;
          Ob(a2);
        }
        kc();
      }
      function kc() {
        if (!dc && bc !== null) {
          dc = true;
          var a2 = 0;
          try {
            var b2 = bc;
            hc(99, function() {
              for (; a2 < b2.length; a2++) {
                var c2 = b2[a2];
                do
                  c2 = c2(true);
                while (c2 !== null);
              }
            });
            bc = null;
          } catch (c2) {
            throw bc !== null && (bc = bc.slice(a2 + 1)), Nb(Vb, F), c2;
          } finally {
            dc = false;
          }
        }
      }
      var lc = 3;
      function mc(a2, b2, c2) {
        c2 /= 10;
        return 1073741821 - (((1073741821 - a2 + b2 / 10) / c2 | 0) + 1) * c2;
      }
      function nc(a2, b2) {
        return a2 === b2 && (a2 !== 0 || 1 / a2 === 1 / b2) || a2 !== a2 && b2 !== b2;
      }
      var oc = typeof Object.is === "function" ? Object.is : nc, pc = Object.prototype.hasOwnProperty;
      function qc(a2, b2) {
        if (oc(a2, b2))
          return true;
        if (typeof a2 !== "object" || a2 === null || typeof b2 !== "object" || b2 === null)
          return false;
        var c2 = Object.keys(a2), d = Object.keys(b2);
        if (c2.length !== d.length)
          return false;
        for (d = 0; d < c2.length; d++)
          if (!pc.call(b2, c2[d]) || !oc(a2[c2[d]], b2[c2[d]]))
            return false;
        return true;
      }
      function rc(a2, b2) {
        if (a2 && a2.defaultProps) {
          b2 = aa({}, b2);
          a2 = a2.defaultProps;
          for (var c2 in a2)
            b2[c2] === void 0 && (b2[c2] = a2[c2]);
        }
        return b2;
      }
      var sc = { current: null }, tc = null, uc = null, vc = null;
      function wc() {
        vc = uc = tc = null;
      }
      function xc(a2, b2) {
        var c2 = a2.type._context;
        Pa ? (z(sc, c2._currentValue, a2), c2._currentValue = b2) : (z(sc, c2._currentValue2, a2), c2._currentValue2 = b2);
      }
      function yc(a2) {
        var b2 = sc.current;
        y2(sc, a2);
        a2 = a2.type._context;
        Pa ? a2._currentValue = b2 : a2._currentValue2 = b2;
      }
      function zc(a2, b2) {
        for (; a2 !== null; ) {
          var c2 = a2.alternate;
          if (a2.childExpirationTime < b2)
            a2.childExpirationTime = b2, c2 !== null && c2.childExpirationTime < b2 && (c2.childExpirationTime = b2);
          else if (c2 !== null && c2.childExpirationTime < b2)
            c2.childExpirationTime = b2;
          else
            break;
          a2 = a2.return;
        }
      }
      function Ac(a2, b2) {
        tc = a2;
        vc = uc = null;
        a2 = a2.dependencies;
        a2 !== null && a2.firstContext !== null && (a2.expirationTime >= b2 && (Bc = true), a2.firstContext = null);
      }
      function Cc(a2, b2) {
        if (vc !== a2 && b2 !== false && b2 !== 0) {
          if (typeof b2 !== "number" || b2 === 1073741823)
            vc = a2, b2 = 1073741823;
          b2 = { context: a2, observedBits: b2, next: null };
          if (uc === null) {
            if (tc === null)
              throw Error(n2(308));
            uc = b2;
            tc.dependencies = { expirationTime: 0, firstContext: b2, responders: null };
          } else
            uc = uc.next = b2;
        }
        return Pa ? a2._currentValue : a2._currentValue2;
      }
      var Dc = false;
      function Ec(a2) {
        return { baseState: a2, firstUpdate: null, lastUpdate: null, firstCapturedUpdate: null, lastCapturedUpdate: null, firstEffect: null, lastEffect: null, firstCapturedEffect: null, lastCapturedEffect: null };
      }
      function Fc(a2) {
        return { baseState: a2.baseState, firstUpdate: a2.firstUpdate, lastUpdate: a2.lastUpdate, firstCapturedUpdate: null, lastCapturedUpdate: null, firstEffect: null, lastEffect: null, firstCapturedEffect: null, lastCapturedEffect: null };
      }
      function Gc(a2, b2) {
        return { expirationTime: a2, suspenseConfig: b2, tag: 0, payload: null, callback: null, next: null, nextEffect: null };
      }
      function Hc(a2, b2) {
        a2.lastUpdate === null ? a2.firstUpdate = a2.lastUpdate = b2 : (a2.lastUpdate.next = b2, a2.lastUpdate = b2);
      }
      function Ic(a2, b2) {
        var c2 = a2.alternate;
        if (c2 === null) {
          var d = a2.updateQueue;
          var e2 = null;
          d === null && (d = a2.updateQueue = Ec(a2.memoizedState));
        } else
          d = a2.updateQueue, e2 = c2.updateQueue, d === null ? e2 === null ? (d = a2.updateQueue = Ec(a2.memoizedState), e2 = c2.updateQueue = Ec(c2.memoizedState)) : d = a2.updateQueue = Fc(e2) : e2 === null && (e2 = c2.updateQueue = Fc(d));
        e2 === null || d === e2 ? Hc(d, b2) : d.lastUpdate === null || e2.lastUpdate === null ? (Hc(d, b2), Hc(e2, b2)) : (Hc(d, b2), e2.lastUpdate = b2);
      }
      function Jc(a2, b2) {
        var c2 = a2.updateQueue;
        c2 = c2 === null ? a2.updateQueue = Ec(a2.memoizedState) : Kc(a2, c2);
        c2.lastCapturedUpdate === null ? c2.firstCapturedUpdate = c2.lastCapturedUpdate = b2 : (c2.lastCapturedUpdate.next = b2, c2.lastCapturedUpdate = b2);
      }
      function Kc(a2, b2) {
        var c2 = a2.alternate;
        c2 !== null && b2 === c2.updateQueue && (b2 = a2.updateQueue = Fc(b2));
        return b2;
      }
      function Lc(a2, b2, c2, d, e2, f) {
        switch (c2.tag) {
          case 1:
            return a2 = c2.payload, typeof a2 === "function" ? a2.call(f, d, e2) : a2;
          case 3:
            a2.effectTag = a2.effectTag & -4097 | 64;
          case 0:
            a2 = c2.payload;
            e2 = typeof a2 === "function" ? a2.call(f, d, e2) : a2;
            if (e2 === null || e2 === void 0)
              break;
            return aa({}, d, e2);
          case 2:
            Dc = true;
        }
        return d;
      }
      function Nc(a2, b2, c2, d, e2) {
        Dc = false;
        b2 = Kc(a2, b2);
        for (var f = b2.baseState, g2 = null, l2 = 0, h = b2.firstUpdate, k = f; h !== null; ) {
          var p = h.expirationTime;
          p < e2 ? (g2 === null && (g2 = h, f = k), l2 < p && (l2 = p)) : (Oc(p, h.suspenseConfig), k = Lc(a2, b2, h, k, c2, d), h.callback !== null && (a2.effectTag |= 32, h.nextEffect = null, b2.lastEffect === null ? b2.firstEffect = b2.lastEffect = h : (b2.lastEffect.nextEffect = h, b2.lastEffect = h)));
          h = h.next;
        }
        p = null;
        for (h = b2.firstCapturedUpdate; h !== null; ) {
          var D = h.expirationTime;
          D < e2 ? (p === null && (p = h, g2 === null && (f = k)), l2 < D && (l2 = D)) : (k = Lc(a2, b2, h, k, c2, d), h.callback !== null && (a2.effectTag |= 32, h.nextEffect = null, b2.lastCapturedEffect === null ? b2.firstCapturedEffect = b2.lastCapturedEffect = h : (b2.lastCapturedEffect.nextEffect = h, b2.lastCapturedEffect = h)));
          h = h.next;
        }
        g2 === null && (b2.lastUpdate = null);
        p === null ? b2.lastCapturedUpdate = null : a2.effectTag |= 32;
        g2 === null && p === null && (f = k);
        b2.baseState = f;
        b2.firstUpdate = g2;
        b2.firstCapturedUpdate = p;
        Pc(l2);
        a2.expirationTime = l2;
        a2.memoizedState = k;
      }
      function Qc(a2, b2, c2) {
        b2.firstCapturedUpdate !== null && (b2.lastUpdate !== null && (b2.lastUpdate.next = b2.firstCapturedUpdate, b2.lastUpdate = b2.lastCapturedUpdate), b2.firstCapturedUpdate = b2.lastCapturedUpdate = null);
        Rc(b2.firstEffect, c2);
        b2.firstEffect = b2.lastEffect = null;
        Rc(b2.firstCapturedEffect, c2);
        b2.firstCapturedEffect = b2.lastCapturedEffect = null;
      }
      function Rc(a2, b2) {
        for (; a2 !== null; ) {
          var c2 = a2.callback;
          if (c2 !== null) {
            a2.callback = null;
            var d = b2;
            if (typeof c2 !== "function")
              throw Error(n2(191, c2));
            c2.call(d);
          }
          a2 = a2.nextEffect;
        }
      }
      var Sc = q.ReactCurrentBatchConfig, Tc = new ba.Component().refs;
      function Uc(a2, b2, c2, d) {
        b2 = a2.memoizedState;
        c2 = c2(d, b2);
        c2 = c2 === null || c2 === void 0 ? b2 : aa({}, b2, c2);
        a2.memoizedState = c2;
        d = a2.updateQueue;
        d !== null && a2.expirationTime === 0 && (d.baseState = c2);
      }
      var Xc = { isMounted: function(a2) {
        return (a2 = a2._reactInternalFiber) ? ua(a2) === a2 : false;
      }, enqueueSetState: function(a2, b2, c2) {
        a2 = a2._reactInternalFiber;
        var d = G(), e2 = Sc.suspense;
        d = Vc(d, a2, e2);
        e2 = Gc(d, e2);
        e2.payload = b2;
        c2 !== void 0 && c2 !== null && (e2.callback = c2);
        Ic(a2, e2);
        Wc(a2, d);
      }, enqueueReplaceState: function(a2, b2, c2) {
        a2 = a2._reactInternalFiber;
        var d = G(), e2 = Sc.suspense;
        d = Vc(d, a2, e2);
        e2 = Gc(d, e2);
        e2.tag = 1;
        e2.payload = b2;
        c2 !== void 0 && c2 !== null && (e2.callback = c2);
        Ic(a2, e2);
        Wc(a2, d);
      }, enqueueForceUpdate: function(a2, b2) {
        a2 = a2._reactInternalFiber;
        var c2 = G(), d = Sc.suspense;
        c2 = Vc(c2, a2, d);
        d = Gc(c2, d);
        d.tag = 2;
        b2 !== void 0 && b2 !== null && (d.callback = b2);
        Ic(a2, d);
        Wc(a2, c2);
      } };
      function Yc(a2, b2, c2, d, e2, f, g2) {
        a2 = a2.stateNode;
        return typeof a2.shouldComponentUpdate === "function" ? a2.shouldComponentUpdate(d, f, g2) : b2.prototype && b2.prototype.isPureReactComponent ? !qc(c2, d) || !qc(e2, f) : true;
      }
      function Zc(a2, b2, c2) {
        var d = false, e2 = Db;
        var f = b2.contextType;
        typeof f === "object" && f !== null ? f = Cc(f) : (e2 = C(b2) ? Eb : A.current, d = b2.contextTypes, f = (d = d !== null && d !== void 0) ? Fb(a2, e2) : Db);
        b2 = new b2(c2, f);
        a2.memoizedState = b2.state !== null && b2.state !== void 0 ? b2.state : null;
        b2.updater = Xc;
        a2.stateNode = b2;
        b2._reactInternalFiber = a2;
        d && (a2 = a2.stateNode, a2.__reactInternalMemoizedUnmaskedChildContext = e2, a2.__reactInternalMemoizedMaskedChildContext = f);
        return b2;
      }
      function $c(a2, b2, c2, d) {
        a2 = b2.state;
        typeof b2.componentWillReceiveProps === "function" && b2.componentWillReceiveProps(c2, d);
        typeof b2.UNSAFE_componentWillReceiveProps === "function" && b2.UNSAFE_componentWillReceiveProps(c2, d);
        b2.state !== a2 && Xc.enqueueReplaceState(b2, b2.state, null);
      }
      function ad(a2, b2, c2, d) {
        var e2 = a2.stateNode;
        e2.props = c2;
        e2.state = a2.memoizedState;
        e2.refs = Tc;
        var f = b2.contextType;
        typeof f === "object" && f !== null ? e2.context = Cc(f) : (f = C(b2) ? Eb : A.current, e2.context = Fb(a2, f));
        f = a2.updateQueue;
        f !== null && (Nc(a2, f, c2, e2, d), e2.state = a2.memoizedState);
        f = b2.getDerivedStateFromProps;
        typeof f === "function" && (Uc(a2, b2, f, c2), e2.state = a2.memoizedState);
        typeof b2.getDerivedStateFromProps === "function" || typeof e2.getSnapshotBeforeUpdate === "function" || typeof e2.UNSAFE_componentWillMount !== "function" && typeof e2.componentWillMount !== "function" || (b2 = e2.state, typeof e2.componentWillMount === "function" && e2.componentWillMount(), typeof e2.UNSAFE_componentWillMount === "function" && e2.UNSAFE_componentWillMount(), b2 !== e2.state && Xc.enqueueReplaceState(e2, e2.state, null), f = a2.updateQueue, f !== null && (Nc(a2, f, c2, e2, d), e2.state = a2.memoizedState));
        typeof e2.componentDidMount === "function" && (a2.effectTag |= 4);
      }
      var bd = Array.isArray;
      function cd(a2, b2, c2) {
        a2 = c2.ref;
        if (a2 !== null && typeof a2 !== "function" && typeof a2 !== "object") {
          if (c2._owner) {
            c2 = c2._owner;
            if (c2) {
              if (c2.tag !== 1)
                throw Error(n2(309));
              var d = c2.stateNode;
            }
            if (!d)
              throw Error(n2(147, a2));
            var e2 = "" + a2;
            if (b2 !== null && b2.ref !== null && typeof b2.ref === "function" && b2.ref._stringRef === e2)
              return b2.ref;
            b2 = function(b3) {
              var a3 = d.refs;
              a3 === Tc && (a3 = d.refs = {});
              b3 === null ? delete a3[e2] : a3[e2] = b3;
            };
            b2._stringRef = e2;
            return b2;
          }
          if (typeof a2 !== "string")
            throw Error(n2(284));
          if (!c2._owner)
            throw Error(n2(290, a2));
        }
        return a2;
      }
      function dd(a2, b2) {
        if (a2.type !== "textarea")
          throw Error(n2(31, Object.prototype.toString.call(b2) === "[object Object]" ? "object with keys {" + Object.keys(b2).join(", ") + "}" : b2, ""));
      }
      function ed(a2) {
        function b2(b3, c3) {
          if (a2) {
            var d2 = b3.lastEffect;
            d2 !== null ? (d2.nextEffect = c3, b3.lastEffect = c3) : b3.firstEffect = b3.lastEffect = c3;
            c3.nextEffect = null;
            c3.effectTag = 8;
          }
        }
        function c2(c3, d2) {
          if (!a2)
            return null;
          for (; d2 !== null; )
            b2(c3, d2), d2 = d2.sibling;
          return null;
        }
        function d(b3, a3) {
          for (b3 = /* @__PURE__ */ new Map(); a3 !== null; )
            a3.key !== null ? b3.set(a3.key, a3) : b3.set(a3.index, a3), a3 = a3.sibling;
          return b3;
        }
        function e2(b3, a3, c3) {
          b3 = fd(b3, a3, c3);
          b3.index = 0;
          b3.sibling = null;
          return b3;
        }
        function f(b3, c3, d2) {
          b3.index = d2;
          if (!a2)
            return c3;
          d2 = b3.alternate;
          if (d2 !== null)
            return d2 = d2.index, d2 < c3 ? (b3.effectTag = 2, c3) : d2;
          b3.effectTag = 2;
          return c3;
        }
        function g2(b3) {
          a2 && b3.alternate === null && (b3.effectTag = 2);
          return b3;
        }
        function l2(b3, a3, c3, d2) {
          if (a3 === null || a3.tag !== 6)
            return a3 = gd(c3, b3.mode, d2), a3.return = b3, a3;
          a3 = e2(a3, c3, d2);
          a3.return = b3;
          return a3;
        }
        function h(b3, a3, c3, d2) {
          if (a3 !== null && a3.elementType === c3.type)
            return d2 = e2(a3, c3.props, d2), d2.ref = cd(b3, a3, c3), d2.return = b3, d2;
          d2 = hd(c3.type, c3.key, c3.props, null, b3.mode, d2);
          d2.ref = cd(b3, a3, c3);
          d2.return = b3;
          return d2;
        }
        function k(b3, a3, c3, d2) {
          if (a3 === null || a3.tag !== 4 || a3.stateNode.containerInfo !== c3.containerInfo || a3.stateNode.implementation !== c3.implementation)
            return a3 = id(c3, b3.mode, d2), a3.return = b3, a3;
          a3 = e2(a3, c3.children || [], d2);
          a3.return = b3;
          return a3;
        }
        function p(b3, a3, c3, d2, f2) {
          if (a3 === null || a3.tag !== 7)
            return a3 = jd(c3, b3.mode, d2, f2), a3.return = b3, a3;
          a3 = e2(a3, c3, d2);
          a3.return = b3;
          return a3;
        }
        function D(b3, a3, c3) {
          if (typeof a3 === "string" || typeof a3 === "number")
            return a3 = gd("" + a3, b3.mode, c3), a3.return = b3, a3;
          if (typeof a3 === "object" && a3 !== null) {
            switch (a3.$$typeof) {
              case ca:
                return c3 = hd(a3.type, a3.key, a3.props, null, b3.mode, c3), c3.ref = cd(b3, null, a3), c3.return = b3, c3;
              case da:
                return a3 = id(a3, b3.mode, c3), a3.return = b3, a3;
            }
            if (bd(a3) || ra(a3))
              return a3 = jd(a3, b3.mode, c3, null), a3.return = b3, a3;
            dd(b3, a3);
          }
          return null;
        }
        function x(b3, a3, c3, d2) {
          var e3 = a3 !== null ? a3.key : null;
          if (typeof c3 === "string" || typeof c3 === "number")
            return e3 !== null ? null : l2(b3, a3, "" + c3, d2);
          if (typeof c3 === "object" && c3 !== null) {
            switch (c3.$$typeof) {
              case ca:
                return c3.key === e3 ? c3.type === ea ? p(b3, a3, c3.props.children, d2, e3) : h(b3, a3, c3, d2) : null;
              case da:
                return c3.key === e3 ? k(b3, a3, c3, d2) : null;
            }
            if (bd(c3) || ra(c3))
              return e3 !== null ? null : p(b3, a3, c3, d2, null);
            dd(b3, c3);
          }
          return null;
        }
        function K(b3, a3, c3, d2, e3) {
          if (typeof d2 === "string" || typeof d2 === "number")
            return b3 = b3.get(c3) || null, l2(a3, b3, "" + d2, e3);
          if (typeof d2 === "object" && d2 !== null) {
            switch (d2.$$typeof) {
              case ca:
                return b3 = b3.get(d2.key === null ? c3 : d2.key) || null, d2.type === ea ? p(a3, b3, d2.props.children, e3, d2.key) : h(a3, b3, d2, e3);
              case da:
                return b3 = b3.get(d2.key === null ? c3 : d2.key) || null, k(a3, b3, d2, e3);
            }
            if (bd(d2) || ra(d2))
              return b3 = b3.get(c3) || null, p(a3, b3, d2, e3, null);
            dd(a3, d2);
          }
          return null;
        }
        function Ha(e3, g3, h2, l3) {
          for (var k2 = null, w = null, t2 = g3, r2 = g3 = 0, p2 = null; t2 !== null && r2 < h2.length; r2++) {
            t2.index > r2 ? (p2 = t2, t2 = null) : p2 = t2.sibling;
            var v = x(e3, t2, h2[r2], l3);
            if (v === null) {
              t2 === null && (t2 = p2);
              break;
            }
            a2 && t2 && v.alternate === null && b2(e3, t2);
            g3 = f(v, g3, r2);
            w === null ? k2 = v : w.sibling = v;
            w = v;
            t2 = p2;
          }
          if (r2 === h2.length)
            return c2(e3, t2), k2;
          if (t2 === null) {
            for (; r2 < h2.length; r2++)
              t2 = D(e3, h2[r2], l3), t2 !== null && (g3 = f(t2, g3, r2), w === null ? k2 = t2 : w.sibling = t2, w = t2);
            return k2;
          }
          for (t2 = d(e3, t2); r2 < h2.length; r2++)
            p2 = K(t2, e3, r2, h2[r2], l3), p2 !== null && (a2 && p2.alternate !== null && t2.delete(p2.key === null ? r2 : p2.key), g3 = f(p2, g3, r2), w === null ? k2 = p2 : w.sibling = p2, w = p2);
          a2 && t2.forEach(function(a3) {
            return b2(e3, a3);
          });
          return k2;
        }
        function O(e3, g3, h2, l3) {
          var k2 = ra(h2);
          if (typeof k2 !== "function")
            throw Error(n2(150));
          h2 = k2.call(h2);
          if (h2 == null)
            throw Error(n2(151));
          for (var t2 = k2 = null, r2 = g3, w = g3 = 0, p2 = null, v = h2.next(); r2 !== null && !v.done; w++, v = h2.next()) {
            r2.index > w ? (p2 = r2, r2 = null) : p2 = r2.sibling;
            var N = x(e3, r2, v.value, l3);
            if (N === null) {
              r2 === null && (r2 = p2);
              break;
            }
            a2 && r2 && N.alternate === null && b2(e3, r2);
            g3 = f(N, g3, w);
            t2 === null ? k2 = N : t2.sibling = N;
            t2 = N;
            r2 = p2;
          }
          if (v.done)
            return c2(e3, r2), k2;
          if (r2 === null) {
            for (; !v.done; w++, v = h2.next())
              v = D(e3, v.value, l3), v !== null && (g3 = f(v, g3, w), t2 === null ? k2 = v : t2.sibling = v, t2 = v);
            return k2;
          }
          for (r2 = d(e3, r2); !v.done; w++, v = h2.next())
            v = K(r2, e3, w, v.value, l3), v !== null && (a2 && v.alternate !== null && r2.delete(v.key === null ? w : v.key), g3 = f(v, g3, w), t2 === null ? k2 = v : t2.sibling = v, t2 = v);
          a2 && r2.forEach(function(a3) {
            return b2(e3, a3);
          });
          return k2;
        }
        return function(a3, d2, f2, h2) {
          var k2 = typeof f2 === "object" && f2 !== null && f2.type === ea && f2.key === null;
          k2 && (f2 = f2.props.children);
          var l3 = typeof f2 === "object" && f2 !== null;
          if (l3)
            switch (f2.$$typeof) {
              case ca:
                a: {
                  l3 = f2.key;
                  for (k2 = d2; k2 !== null; ) {
                    if (k2.key === l3)
                      if (k2.tag === 7 ? f2.type === ea : k2.elementType === f2.type) {
                        c2(a3, k2.sibling);
                        d2 = e2(k2, f2.type === ea ? f2.props.children : f2.props, h2);
                        d2.ref = cd(a3, k2, f2);
                        d2.return = a3;
                        a3 = d2;
                        break a;
                      } else {
                        c2(a3, k2);
                        break;
                      }
                    else
                      b2(a3, k2);
                    k2 = k2.sibling;
                  }
                  f2.type === ea ? (d2 = jd(f2.props.children, a3.mode, h2, f2.key), d2.return = a3, a3 = d2) : (h2 = hd(f2.type, f2.key, f2.props, null, a3.mode, h2), h2.ref = cd(a3, d2, f2), h2.return = a3, a3 = h2);
                }
                return g2(a3);
              case da:
                a: {
                  for (k2 = f2.key; d2 !== null; ) {
                    if (d2.key === k2)
                      if (d2.tag === 4 && d2.stateNode.containerInfo === f2.containerInfo && d2.stateNode.implementation === f2.implementation) {
                        c2(a3, d2.sibling);
                        d2 = e2(d2, f2.children || [], h2);
                        d2.return = a3;
                        a3 = d2;
                        break a;
                      } else {
                        c2(a3, d2);
                        break;
                      }
                    else
                      b2(a3, d2);
                    d2 = d2.sibling;
                  }
                  d2 = id(f2, a3.mode, h2);
                  d2.return = a3;
                  a3 = d2;
                }
                return g2(a3);
            }
          if (typeof f2 === "string" || typeof f2 === "number")
            return f2 = "" + f2, d2 !== null && d2.tag === 6 ? (c2(a3, d2.sibling), d2 = e2(d2, f2, h2), d2.return = a3, a3 = d2) : (c2(a3, d2), d2 = gd(f2, a3.mode, h2), d2.return = a3, a3 = d2), g2(a3);
          if (bd(f2))
            return Ha(a3, d2, f2, h2);
          if (ra(f2))
            return O(a3, d2, f2, h2);
          l3 && dd(a3, f2);
          if (typeof f2 === "undefined" && !k2)
            switch (a3.tag) {
              case 1:
              case 0:
                throw a3 = a3.type, Error(n2(152, a3.displayName || a3.name || "Component"));
            }
          return c2(a3, d2);
        };
      }
      var kd = ed(true), ld = ed(false), md = {}, H = { current: md }, nd = { current: md }, od = { current: md };
      function pd(a2) {
        if (a2 === md)
          throw Error(n2(174));
        return a2;
      }
      function qd(a2, b2) {
        z(od, b2, a2);
        z(nd, a2, a2);
        z(H, md, a2);
        b2 = Aa(b2);
        y2(H, a2);
        z(H, b2, a2);
      }
      function rd(a2) {
        y2(H, a2);
        y2(nd, a2);
        y2(od, a2);
      }
      function sd(a2) {
        var b2 = pd(od.current), c2 = pd(H.current);
        b2 = Ba(c2, a2.type, b2);
        c2 !== b2 && (z(nd, a2, a2), z(H, b2, a2));
      }
      function td(a2) {
        nd.current === a2 && (y2(H, a2), y2(nd, a2));
      }
      var I = { current: 0 };
      function ud(a2) {
        for (var b2 = a2; b2 !== null; ) {
          if (b2.tag === 13) {
            var c2 = b2.memoizedState;
            if (c2 !== null && (c2 = c2.dehydrated, c2 === null || qb(c2) || rb(c2)))
              return b2;
          } else if (b2.tag === 19 && b2.memoizedProps.revealOrder !== void 0) {
            if ((b2.effectTag & 64) !== 0)
              return b2;
          } else if (b2.child !== null) {
            b2.child.return = b2;
            b2 = b2.child;
            continue;
          }
          if (b2 === a2)
            break;
          for (; b2.sibling === null; ) {
            if (b2.return === null || b2.return === a2)
              return null;
            b2 = b2.return;
          }
          b2.sibling.return = b2.return;
          b2 = b2.sibling;
        }
        return null;
      }
      function vd(a2, b2) {
        return { responder: a2, props: b2 };
      }
      var wd = q.ReactCurrentDispatcher, J = q.ReactCurrentBatchConfig, xd = 0, yd = null, L = null, zd = null, Ad = null, M = null, Bd = null, Cd = 0, Dd = null, Ed = 0, Fd = false, Gd = null, Hd = 0;
      function P() {
        throw Error(n2(321));
      }
      function Id(a2, b2) {
        if (b2 === null)
          return false;
        for (var c2 = 0; c2 < b2.length && c2 < a2.length; c2++)
          if (!oc(a2[c2], b2[c2]))
            return false;
        return true;
      }
      function Jd(a2, b2, c2, d, e2, f) {
        xd = f;
        yd = b2;
        zd = a2 !== null ? a2.memoizedState : null;
        wd.current = zd === null ? Kd : Ld;
        b2 = c2(d, e2);
        if (Fd) {
          do
            Fd = false, Hd += 1, zd = a2 !== null ? a2.memoizedState : null, Bd = Ad, Dd = M = L = null, wd.current = Ld, b2 = c2(d, e2);
          while (Fd);
          Gd = null;
          Hd = 0;
        }
        wd.current = Md;
        a2 = yd;
        a2.memoizedState = Ad;
        a2.expirationTime = Cd;
        a2.updateQueue = Dd;
        a2.effectTag |= Ed;
        a2 = L !== null && L.next !== null;
        xd = 0;
        Bd = M = Ad = zd = L = yd = null;
        Cd = 0;
        Dd = null;
        Ed = 0;
        if (a2)
          throw Error(n2(300));
        return b2;
      }
      function Nd() {
        wd.current = Md;
        xd = 0;
        Bd = M = Ad = zd = L = yd = null;
        Cd = 0;
        Dd = null;
        Ed = 0;
        Fd = false;
        Gd = null;
        Hd = 0;
      }
      function Od() {
        var a2 = { memoizedState: null, baseState: null, queue: null, baseUpdate: null, next: null };
        M === null ? Ad = M = a2 : M = M.next = a2;
        return M;
      }
      function Pd() {
        if (Bd !== null)
          M = Bd, Bd = M.next, L = zd, zd = L !== null ? L.next : null;
        else {
          if (zd === null)
            throw Error(n2(310));
          L = zd;
          var a2 = { memoizedState: L.memoizedState, baseState: L.baseState, queue: L.queue, baseUpdate: L.baseUpdate, next: null };
          M = M === null ? Ad = a2 : M.next = a2;
          zd = L.next;
        }
        return M;
      }
      function Qd(a2, b2) {
        return typeof b2 === "function" ? b2(a2) : b2;
      }
      function Rd(a2) {
        var b2 = Pd(), c2 = b2.queue;
        if (c2 === null)
          throw Error(n2(311));
        c2.lastRenderedReducer = a2;
        if (0 < Hd) {
          var d = c2.dispatch;
          if (Gd !== null) {
            var e2 = Gd.get(c2);
            if (e2 !== void 0) {
              Gd.delete(c2);
              var f = b2.memoizedState;
              do
                f = a2(f, e2.action), e2 = e2.next;
              while (e2 !== null);
              oc(f, b2.memoizedState) || (Bc = true);
              b2.memoizedState = f;
              b2.baseUpdate === c2.last && (b2.baseState = f);
              c2.lastRenderedState = f;
              return [f, d];
            }
          }
          return [b2.memoizedState, d];
        }
        d = c2.last;
        var g2 = b2.baseUpdate;
        f = b2.baseState;
        g2 !== null ? (d !== null && (d.next = null), d = g2.next) : d = d !== null ? d.next : null;
        if (d !== null) {
          var l2 = e2 = null, h = d, k = false;
          do {
            var p = h.expirationTime;
            p < xd ? (k || (k = true, l2 = g2, e2 = f), p > Cd && (Cd = p, Pc(Cd))) : (Oc(p, h.suspenseConfig), f = h.eagerReducer === a2 ? h.eagerState : a2(f, h.action));
            g2 = h;
            h = h.next;
          } while (h !== null && h !== d);
          k || (l2 = g2, e2 = f);
          oc(f, b2.memoizedState) || (Bc = true);
          b2.memoizedState = f;
          b2.baseUpdate = l2;
          b2.baseState = e2;
          c2.lastRenderedState = f;
        }
        return [b2.memoizedState, c2.dispatch];
      }
      function Sd(a2) {
        var b2 = Od();
        typeof a2 === "function" && (a2 = a2());
        b2.memoizedState = b2.baseState = a2;
        a2 = b2.queue = { last: null, dispatch: null, lastRenderedReducer: Qd, lastRenderedState: a2 };
        a2 = a2.dispatch = Td.bind(null, yd, a2);
        return [b2.memoizedState, a2];
      }
      function Ud(a2) {
        return Rd(Qd, a2);
      }
      function Vd(a2, b2, c2, d) {
        a2 = { tag: a2, create: b2, destroy: c2, deps: d, next: null };
        Dd === null ? (Dd = { lastEffect: null }, Dd.lastEffect = a2.next = a2) : (b2 = Dd.lastEffect, b2 === null ? Dd.lastEffect = a2.next = a2 : (c2 = b2.next, b2.next = a2, a2.next = c2, Dd.lastEffect = a2));
        return a2;
      }
      function Wd(a2, b2, c2, d) {
        var e2 = Od();
        Ed |= a2;
        e2.memoizedState = Vd(b2, c2, void 0, d === void 0 ? null : d);
      }
      function Xd(a2, b2, c2, d) {
        var e2 = Pd();
        d = d === void 0 ? null : d;
        var f = void 0;
        if (L !== null) {
          var g2 = L.memoizedState;
          f = g2.destroy;
          if (d !== null && Id(d, g2.deps)) {
            Vd(0, c2, f, d);
            return;
          }
        }
        Ed |= a2;
        e2.memoizedState = Vd(b2, c2, f, d);
      }
      function Yd(a2, b2) {
        return Wd(516, 192, a2, b2);
      }
      function Zd(a2, b2) {
        return Xd(516, 192, a2, b2);
      }
      function $d(a2, b2) {
        if (typeof b2 === "function")
          return a2 = a2(), b2(a2), function() {
            b2(null);
          };
        if (b2 !== null && b2 !== void 0)
          return a2 = a2(), b2.current = a2, function() {
            b2.current = null;
          };
      }
      function ae() {
      }
      function be(a2, b2) {
        Od().memoizedState = [a2, b2 === void 0 ? null : b2];
        return a2;
      }
      function ce(a2, b2) {
        var c2 = Pd();
        b2 = b2 === void 0 ? null : b2;
        var d = c2.memoizedState;
        if (d !== null && b2 !== null && Id(b2, d[1]))
          return d[0];
        c2.memoizedState = [a2, b2];
        return a2;
      }
      function Td(a2, b2, c2) {
        if (!(25 > Hd))
          throw Error(n2(301));
        var d = a2.alternate;
        if (a2 === yd || d !== null && d === yd)
          if (Fd = true, a2 = { expirationTime: xd, suspenseConfig: null, action: c2, eagerReducer: null, eagerState: null, next: null }, Gd === null && (Gd = /* @__PURE__ */ new Map()), c2 = Gd.get(b2), c2 === void 0)
            Gd.set(b2, a2);
          else {
            for (b2 = c2; b2.next !== null; )
              b2 = b2.next;
            b2.next = a2;
          }
        else {
          var e2 = G(), f = Sc.suspense;
          e2 = Vc(e2, a2, f);
          f = { expirationTime: e2, suspenseConfig: f, action: c2, eagerReducer: null, eagerState: null, next: null };
          var g2 = b2.last;
          if (g2 === null)
            f.next = f;
          else {
            var l2 = g2.next;
            l2 !== null && (f.next = l2);
            g2.next = f;
          }
          b2.last = f;
          if (a2.expirationTime === 0 && (d === null || d.expirationTime === 0) && (d = b2.lastRenderedReducer, d !== null))
            try {
              var h = b2.lastRenderedState, k = d(h, c2);
              f.eagerReducer = d;
              f.eagerState = k;
              if (oc(k, h))
                return;
            } catch (p) {
            } finally {
            }
          Wc(a2, e2);
        }
      }
      var Md = { readContext: Cc, useCallback: P, useContext: P, useEffect: P, useImperativeHandle: P, useLayoutEffect: P, useMemo: P, useReducer: P, useRef: P, useState: P, useDebugValue: P, useResponder: P, useDeferredValue: P, useTransition: P }, Kd = { readContext: Cc, useCallback: be, useContext: Cc, useEffect: Yd, useImperativeHandle: function(a2, b2, c2) {
        c2 = c2 !== null && c2 !== void 0 ? c2.concat([a2]) : null;
        return Wd(4, 36, $d.bind(null, b2, a2), c2);
      }, useLayoutEffect: function(a2, b2) {
        return Wd(4, 36, a2, b2);
      }, useMemo: function(a2, b2) {
        var c2 = Od();
        b2 = b2 === void 0 ? null : b2;
        a2 = a2();
        c2.memoizedState = [a2, b2];
        return a2;
      }, useReducer: function(a2, b2, c2) {
        var d = Od();
        b2 = c2 !== void 0 ? c2(b2) : b2;
        d.memoizedState = d.baseState = b2;
        a2 = d.queue = { last: null, dispatch: null, lastRenderedReducer: a2, lastRenderedState: b2 };
        a2 = a2.dispatch = Td.bind(null, yd, a2);
        return [d.memoizedState, a2];
      }, useRef: function(a2) {
        var b2 = Od();
        a2 = { current: a2 };
        return b2.memoizedState = a2;
      }, useState: Sd, useDebugValue: ae, useResponder: vd, useDeferredValue: function(a2, b2) {
        var c2 = Sd(a2), d = c2[0], e2 = c2[1];
        Yd(function() {
          m.unstable_next(function() {
            var c3 = J.suspense;
            J.suspense = b2 === void 0 ? null : b2;
            try {
              e2(a2);
            } finally {
              J.suspense = c3;
            }
          });
        }, [a2, b2]);
        return d;
      }, useTransition: function(a2) {
        var b2 = Sd(false), c2 = b2[0], d = b2[1];
        return [be(function(b3) {
          d(true);
          m.unstable_next(function() {
            var c3 = J.suspense;
            J.suspense = a2 === void 0 ? null : a2;
            try {
              d(false), b3();
            } finally {
              J.suspense = c3;
            }
          });
        }, [a2, c2]), c2];
      } }, Ld = { readContext: Cc, useCallback: ce, useContext: Cc, useEffect: Zd, useImperativeHandle: function(a2, b2, c2) {
        c2 = c2 !== null && c2 !== void 0 ? c2.concat([a2]) : null;
        return Xd(4, 36, $d.bind(null, b2, a2), c2);
      }, useLayoutEffect: function(a2, b2) {
        return Xd(4, 36, a2, b2);
      }, useMemo: function(a2, b2) {
        var c2 = Pd();
        b2 = b2 === void 0 ? null : b2;
        var d = c2.memoizedState;
        if (d !== null && b2 !== null && Id(b2, d[1]))
          return d[0];
        a2 = a2();
        c2.memoizedState = [a2, b2];
        return a2;
      }, useReducer: Rd, useRef: function() {
        return Pd().memoizedState;
      }, useState: Ud, useDebugValue: ae, useResponder: vd, useDeferredValue: function(a2, b2) {
        var c2 = Ud(a2), d = c2[0], e2 = c2[1];
        Zd(function() {
          m.unstable_next(function() {
            var c3 = J.suspense;
            J.suspense = b2 === void 0 ? null : b2;
            try {
              e2(a2);
            } finally {
              J.suspense = c3;
            }
          });
        }, [a2, b2]);
        return d;
      }, useTransition: function(a2) {
        var b2 = Ud(false), c2 = b2[0], d = b2[1];
        return [ce(function(b3) {
          d(true);
          m.unstable_next(function() {
            var c3 = J.suspense;
            J.suspense = a2 === void 0 ? null : a2;
            try {
              d(false), b3();
            } finally {
              J.suspense = c3;
            }
          });
        }, [a2, c2]), c2];
      } }, de = null, ee = null, fe = false;
      function ge(a2, b2) {
        var c2 = he(5, null, null, 0);
        c2.elementType = "DELETED";
        c2.type = "DELETED";
        c2.stateNode = b2;
        c2.return = a2;
        c2.effectTag = 8;
        a2.lastEffect !== null ? (a2.lastEffect.nextEffect = c2, a2.lastEffect = c2) : a2.firstEffect = a2.lastEffect = c2;
      }
      function ie(a2, b2) {
        switch (a2.tag) {
          case 5:
            return b2 = ob(b2, a2.type, a2.pendingProps), b2 !== null ? (a2.stateNode = b2, true) : false;
          case 6:
            return b2 = pb(b2, a2.pendingProps), b2 !== null ? (a2.stateNode = b2, true) : false;
          case 13:
            return false;
          default:
            return false;
        }
      }
      function je(a2) {
        if (fe) {
          var b2 = ee;
          if (b2) {
            var c2 = b2;
            if (!ie(a2, b2)) {
              b2 = sb(c2);
              if (!b2 || !ie(a2, b2)) {
                a2.effectTag = a2.effectTag & -1025 | 2;
                fe = false;
                de = a2;
                return;
              }
              ge(de, c2);
            }
            de = a2;
            ee = tb(b2);
          } else
            a2.effectTag = a2.effectTag & -1025 | 2, fe = false, de = a2;
        }
      }
      function ke(a2) {
        for (a2 = a2.return; a2 !== null && a2.tag !== 5 && a2.tag !== 3 && a2.tag !== 13; )
          a2 = a2.return;
        de = a2;
      }
      function ne(a2) {
        if (!Sa || a2 !== de)
          return false;
        if (!fe)
          return ke(a2), fe = true, false;
        var b2 = a2.type;
        if (a2.tag !== 5 || b2 !== "head" && b2 !== "body" && !Ja(b2, a2.memoizedProps))
          for (b2 = ee; b2; )
            ge(a2, b2), b2 = sb(b2);
        ke(a2);
        if (a2.tag === 13) {
          if (!Sa)
            throw Error(n2(316));
          a2 = a2.memoizedState;
          a2 = a2 !== null ? a2.dehydrated : null;
          if (!a2)
            throw Error(n2(317));
          ee = wb(a2);
        } else
          ee = de ? sb(a2.stateNode) : null;
        return true;
      }
      function oe() {
        Sa && (ee = de = null, fe = false);
      }
      var pe = q.ReactCurrentOwner, Bc = false;
      function Q(a2, b2, c2, d) {
        b2.child = a2 === null ? ld(b2, null, c2, d) : kd(b2, a2.child, c2, d);
      }
      function qe(a2, b2, c2, d, e2) {
        c2 = c2.render;
        var f = b2.ref;
        Ac(b2, e2);
        d = Jd(a2, b2, c2, d, f, e2);
        if (a2 !== null && !Bc)
          return b2.updateQueue = a2.updateQueue, b2.effectTag &= -517, a2.expirationTime <= e2 && (a2.expirationTime = 0), re(a2, b2, e2);
        b2.effectTag |= 1;
        Q(a2, b2, d, e2);
        return b2.child;
      }
      function se(a2, b2, c2, d, e2, f) {
        if (a2 === null) {
          var g2 = c2.type;
          if (typeof g2 === "function" && !te(g2) && g2.defaultProps === void 0 && c2.compare === null && c2.defaultProps === void 0)
            return b2.tag = 15, b2.type = g2, ue(a2, b2, g2, d, e2, f);
          a2 = hd(c2.type, null, d, null, b2.mode, f);
          a2.ref = b2.ref;
          a2.return = b2;
          return b2.child = a2;
        }
        g2 = a2.child;
        if (e2 < f && (e2 = g2.memoizedProps, c2 = c2.compare, c2 = c2 !== null ? c2 : qc, c2(e2, d) && a2.ref === b2.ref))
          return re(a2, b2, f);
        b2.effectTag |= 1;
        a2 = fd(g2, d, f);
        a2.ref = b2.ref;
        a2.return = b2;
        return b2.child = a2;
      }
      function ue(a2, b2, c2, d, e2, f) {
        return a2 !== null && qc(a2.memoizedProps, d) && a2.ref === b2.ref && (Bc = false, e2 < f) ? re(a2, b2, f) : ve(a2, b2, c2, d, f);
      }
      function we(a2, b2) {
        var c2 = b2.ref;
        if (a2 === null && c2 !== null || a2 !== null && a2.ref !== c2)
          b2.effectTag |= 128;
      }
      function ve(a2, b2, c2, d, e2) {
        var f = C(c2) ? Eb : A.current;
        f = Fb(b2, f);
        Ac(b2, e2);
        c2 = Jd(a2, b2, c2, d, f, e2);
        if (a2 !== null && !Bc)
          return b2.updateQueue = a2.updateQueue, b2.effectTag &= -517, a2.expirationTime <= e2 && (a2.expirationTime = 0), re(a2, b2, e2);
        b2.effectTag |= 1;
        Q(a2, b2, c2, e2);
        return b2.child;
      }
      function xe(a2, b2, c2, d, e2) {
        if (C(c2)) {
          var f = true;
          Kb(b2);
        } else
          f = false;
        Ac(b2, e2);
        if (b2.stateNode === null)
          a2 !== null && (a2.alternate = null, b2.alternate = null, b2.effectTag |= 2), Zc(b2, c2, d, e2), ad(b2, c2, d, e2), d = true;
        else if (a2 === null) {
          var g2 = b2.stateNode, l2 = b2.memoizedProps;
          g2.props = l2;
          var h = g2.context, k = c2.contextType;
          typeof k === "object" && k !== null ? k = Cc(k) : (k = C(c2) ? Eb : A.current, k = Fb(b2, k));
          var p = c2.getDerivedStateFromProps, D = typeof p === "function" || typeof g2.getSnapshotBeforeUpdate === "function";
          D || typeof g2.UNSAFE_componentWillReceiveProps !== "function" && typeof g2.componentWillReceiveProps !== "function" || (l2 !== d || h !== k) && $c(b2, g2, d, k);
          Dc = false;
          var x = b2.memoizedState;
          h = g2.state = x;
          var K = b2.updateQueue;
          K !== null && (Nc(b2, K, d, g2, e2), h = b2.memoizedState);
          l2 !== d || x !== h || B.current || Dc ? (typeof p === "function" && (Uc(b2, c2, p, d), h = b2.memoizedState), (l2 = Dc || Yc(b2, c2, l2, d, x, h, k)) ? (D || typeof g2.UNSAFE_componentWillMount !== "function" && typeof g2.componentWillMount !== "function" || (typeof g2.componentWillMount === "function" && g2.componentWillMount(), typeof g2.UNSAFE_componentWillMount === "function" && g2.UNSAFE_componentWillMount()), typeof g2.componentDidMount === "function" && (b2.effectTag |= 4)) : (typeof g2.componentDidMount === "function" && (b2.effectTag |= 4), b2.memoizedProps = d, b2.memoizedState = h), g2.props = d, g2.state = h, g2.context = k, d = l2) : (typeof g2.componentDidMount === "function" && (b2.effectTag |= 4), d = false);
        } else
          g2 = b2.stateNode, l2 = b2.memoizedProps, g2.props = b2.type === b2.elementType ? l2 : rc(b2.type, l2), h = g2.context, k = c2.contextType, typeof k === "object" && k !== null ? k = Cc(k) : (k = C(c2) ? Eb : A.current, k = Fb(b2, k)), p = c2.getDerivedStateFromProps, (D = typeof p === "function" || typeof g2.getSnapshotBeforeUpdate === "function") || typeof g2.UNSAFE_componentWillReceiveProps !== "function" && typeof g2.componentWillReceiveProps !== "function" || (l2 !== d || h !== k) && $c(b2, g2, d, k), Dc = false, h = b2.memoizedState, x = g2.state = h, K = b2.updateQueue, K !== null && (Nc(b2, K, d, g2, e2), x = b2.memoizedState), l2 !== d || h !== x || B.current || Dc ? (typeof p === "function" && (Uc(b2, c2, p, d), x = b2.memoizedState), (p = Dc || Yc(b2, c2, l2, d, h, x, k)) ? (D || typeof g2.UNSAFE_componentWillUpdate !== "function" && typeof g2.componentWillUpdate !== "function" || (typeof g2.componentWillUpdate === "function" && g2.componentWillUpdate(d, x, k), typeof g2.UNSAFE_componentWillUpdate === "function" && g2.UNSAFE_componentWillUpdate(d, x, k)), typeof g2.componentDidUpdate === "function" && (b2.effectTag |= 4), typeof g2.getSnapshotBeforeUpdate === "function" && (b2.effectTag |= 256)) : (typeof g2.componentDidUpdate !== "function" || l2 === a2.memoizedProps && h === a2.memoizedState || (b2.effectTag |= 4), typeof g2.getSnapshotBeforeUpdate !== "function" || l2 === a2.memoizedProps && h === a2.memoizedState || (b2.effectTag |= 256), b2.memoizedProps = d, b2.memoizedState = x), g2.props = d, g2.state = x, g2.context = k, d = p) : (typeof g2.componentDidUpdate !== "function" || l2 === a2.memoizedProps && h === a2.memoizedState || (b2.effectTag |= 4), typeof g2.getSnapshotBeforeUpdate !== "function" || l2 === a2.memoizedProps && h === a2.memoizedState || (b2.effectTag |= 256), d = false);
        return ye(a2, b2, c2, d, f, e2);
      }
      function ye(a2, b2, c2, d, e2, f) {
        we(a2, b2);
        var g2 = (b2.effectTag & 64) !== 0;
        if (!d && !g2)
          return e2 && Lb(b2, c2, false), re(a2, b2, f);
        d = b2.stateNode;
        pe.current = b2;
        var l2 = g2 && typeof c2.getDerivedStateFromError !== "function" ? null : d.render();
        b2.effectTag |= 1;
        a2 !== null && g2 ? (b2.child = kd(b2, a2.child, null, f), b2.child = kd(b2, null, l2, f)) : Q(a2, b2, l2, f);
        b2.memoizedState = d.state;
        e2 && Lb(b2, c2, true);
        return b2.child;
      }
      function ze(a2) {
        var b2 = a2.stateNode;
        b2.pendingContext ? Ib(a2, b2.pendingContext, b2.pendingContext !== b2.context) : b2.context && Ib(a2, b2.context, false);
        qd(a2, b2.containerInfo);
      }
      var Ae = { dehydrated: null, retryTime: 0 };
      function Be(a2, b2, c2) {
        var d = b2.mode, e2 = b2.pendingProps, f = I.current, g2 = false, l2;
        (l2 = (b2.effectTag & 64) !== 0) || (l2 = (f & 2) !== 0 && (a2 === null || a2.memoizedState !== null));
        l2 ? (g2 = true, b2.effectTag &= -65) : a2 !== null && a2.memoizedState === null || e2.fallback === void 0 || e2.unstable_avoidThisFallback === true || (f |= 1);
        z(I, f & 1, b2);
        if (a2 === null) {
          e2.fallback !== void 0 && je(b2);
          if (g2) {
            g2 = e2.fallback;
            e2 = jd(null, d, 0, null);
            e2.return = b2;
            if ((b2.mode & 2) === 0)
              for (a2 = b2.memoizedState !== null ? b2.child.child : b2.child, e2.child = a2; a2 !== null; )
                a2.return = e2, a2 = a2.sibling;
            c2 = jd(g2, d, c2, null);
            c2.return = b2;
            e2.sibling = c2;
            b2.memoizedState = Ae;
            b2.child = e2;
            return c2;
          }
          d = e2.children;
          b2.memoizedState = null;
          return b2.child = ld(b2, null, d, c2);
        }
        if (a2.memoizedState !== null) {
          a2 = a2.child;
          d = a2.sibling;
          if (g2) {
            e2 = e2.fallback;
            c2 = fd(a2, a2.pendingProps, 0);
            c2.return = b2;
            if ((b2.mode & 2) === 0 && (g2 = b2.memoizedState !== null ? b2.child.child : b2.child, g2 !== a2.child))
              for (c2.child = g2; g2 !== null; )
                g2.return = c2, g2 = g2.sibling;
            d = fd(d, e2, d.expirationTime);
            d.return = b2;
            c2.sibling = d;
            c2.childExpirationTime = 0;
            b2.memoizedState = Ae;
            b2.child = c2;
            return d;
          }
          c2 = kd(b2, a2.child, e2.children, c2);
          b2.memoizedState = null;
          return b2.child = c2;
        }
        a2 = a2.child;
        if (g2) {
          g2 = e2.fallback;
          e2 = jd(null, d, 0, null);
          e2.return = b2;
          e2.child = a2;
          a2 !== null && (a2.return = e2);
          if ((b2.mode & 2) === 0)
            for (a2 = b2.memoizedState !== null ? b2.child.child : b2.child, e2.child = a2; a2 !== null; )
              a2.return = e2, a2 = a2.sibling;
          c2 = jd(g2, d, c2, null);
          c2.return = b2;
          e2.sibling = c2;
          c2.effectTag |= 2;
          e2.childExpirationTime = 0;
          b2.memoizedState = Ae;
          b2.child = e2;
          return c2;
        }
        b2.memoizedState = null;
        return b2.child = kd(b2, a2, e2.children, c2);
      }
      function Ce(a2, b2) {
        a2.expirationTime < b2 && (a2.expirationTime = b2);
        var c2 = a2.alternate;
        c2 !== null && c2.expirationTime < b2 && (c2.expirationTime = b2);
        zc(a2.return, b2);
      }
      function De(a2, b2, c2, d, e2, f) {
        var g2 = a2.memoizedState;
        g2 === null ? a2.memoizedState = { isBackwards: b2, rendering: null, last: d, tail: c2, tailExpiration: 0, tailMode: e2, lastEffect: f } : (g2.isBackwards = b2, g2.rendering = null, g2.last = d, g2.tail = c2, g2.tailExpiration = 0, g2.tailMode = e2, g2.lastEffect = f);
      }
      function Ee(a2, b2, c2) {
        var d = b2.pendingProps, e2 = d.revealOrder, f = d.tail;
        Q(a2, b2, d.children, c2);
        d = I.current;
        if ((d & 2) !== 0)
          d = d & 1 | 2, b2.effectTag |= 64;
        else {
          if (a2 !== null && (a2.effectTag & 64) !== 0)
            a:
              for (a2 = b2.child; a2 !== null; ) {
                if (a2.tag === 13)
                  a2.memoizedState !== null && Ce(a2, c2);
                else if (a2.tag === 19)
                  Ce(a2, c2);
                else if (a2.child !== null) {
                  a2.child.return = a2;
                  a2 = a2.child;
                  continue;
                }
                if (a2 === b2)
                  break a;
                for (; a2.sibling === null; ) {
                  if (a2.return === null || a2.return === b2)
                    break a;
                  a2 = a2.return;
                }
                a2.sibling.return = a2.return;
                a2 = a2.sibling;
              }
          d &= 1;
        }
        z(I, d, b2);
        if ((b2.mode & 2) === 0)
          b2.memoizedState = null;
        else
          switch (e2) {
            case "forwards":
              c2 = b2.child;
              for (e2 = null; c2 !== null; )
                a2 = c2.alternate, a2 !== null && ud(a2) === null && (e2 = c2), c2 = c2.sibling;
              c2 = e2;
              c2 === null ? (e2 = b2.child, b2.child = null) : (e2 = c2.sibling, c2.sibling = null);
              De(b2, false, e2, c2, f, b2.lastEffect);
              break;
            case "backwards":
              c2 = null;
              e2 = b2.child;
              for (b2.child = null; e2 !== null; ) {
                a2 = e2.alternate;
                if (a2 !== null && ud(a2) === null) {
                  b2.child = e2;
                  break;
                }
                a2 = e2.sibling;
                e2.sibling = c2;
                c2 = e2;
                e2 = a2;
              }
              De(b2, true, c2, null, f, b2.lastEffect);
              break;
            case "together":
              De(b2, false, null, null, void 0, b2.lastEffect);
              break;
            default:
              b2.memoizedState = null;
          }
        return b2.child;
      }
      function re(a2, b2, c2) {
        a2 !== null && (b2.dependencies = a2.dependencies);
        var d = b2.expirationTime;
        d !== 0 && Pc(d);
        if (b2.childExpirationTime < c2)
          return null;
        if (a2 !== null && b2.child !== a2.child)
          throw Error(n2(153));
        if (b2.child !== null) {
          a2 = b2.child;
          c2 = fd(a2, a2.pendingProps, a2.expirationTime);
          b2.child = c2;
          for (c2.return = b2; a2.sibling !== null; )
            a2 = a2.sibling, c2 = c2.sibling = fd(a2, a2.pendingProps, a2.expirationTime), c2.return = b2;
          c2.sibling = null;
        }
        return b2.child;
      }
      function Fe(a2) {
        a2.effectTag |= 4;
      }
      var Ge, He, Ie, Je;
      if (Qa)
        Ge = function(a2, b2) {
          for (var c2 = b2.child; c2 !== null; ) {
            if (c2.tag === 5 || c2.tag === 6)
              Fa(a2, c2.stateNode);
            else if (c2.tag !== 4 && c2.child !== null) {
              c2.child.return = c2;
              c2 = c2.child;
              continue;
            }
            if (c2 === b2)
              break;
            for (; c2.sibling === null; ) {
              if (c2.return === null || c2.return === b2)
                return;
              c2 = c2.return;
            }
            c2.sibling.return = c2.return;
            c2 = c2.sibling;
          }
        }, He = function() {
        }, Ie = function(a2, b2, c2, d, e2) {
          a2 = a2.memoizedProps;
          if (a2 !== d) {
            var f = b2.stateNode, g2 = pd(H.current);
            c2 = Ia(f, c2, a2, d, e2, g2);
            (b2.updateQueue = c2) && Fe(b2);
          }
        }, Je = function(a2, b2, c2, d) {
          c2 !== d && Fe(b2);
        };
      else if (Ra) {
        Ge = function(a2, b2, c2, d) {
          for (var e2 = b2.child; e2 !== null; ) {
            if (e2.tag === 5) {
              var f = e2.stateNode;
              c2 && d && (f = mb(f, e2.type, e2.memoizedProps, e2));
              Fa(a2, f);
            } else if (e2.tag === 6)
              f = e2.stateNode, c2 && d && (f = nb(f, e2.memoizedProps, e2)), Fa(a2, f);
            else if (e2.tag !== 4) {
              if (e2.tag === 13 && (e2.effectTag & 4) !== 0 && (f = e2.memoizedState !== null)) {
                var g2 = e2.child;
                if (g2 !== null && (g2.child !== null && (g2.child.return = g2, Ge(a2, g2, true, f)), f = g2.sibling, f !== null)) {
                  f.return = e2;
                  e2 = f;
                  continue;
                }
              }
              if (e2.child !== null) {
                e2.child.return = e2;
                e2 = e2.child;
                continue;
              }
            }
            if (e2 === b2)
              break;
            for (; e2.sibling === null; ) {
              if (e2.return === null || e2.return === b2)
                return;
              e2 = e2.return;
            }
            e2.sibling.return = e2.return;
            e2 = e2.sibling;
          }
        };
        var Ke = function(a2, b2, c2, d) {
          for (var e2 = b2.child; e2 !== null; ) {
            if (e2.tag === 5) {
              var f = e2.stateNode;
              c2 && d && (f = mb(f, e2.type, e2.memoizedProps, e2));
              ib(a2, f);
            } else if (e2.tag === 6)
              f = e2.stateNode, c2 && d && (f = nb(f, e2.memoizedProps, e2)), ib(a2, f);
            else if (e2.tag !== 4) {
              if (e2.tag === 13 && (e2.effectTag & 4) !== 0 && (f = e2.memoizedState !== null)) {
                var g2 = e2.child;
                if (g2 !== null && (g2.child !== null && (g2.child.return = g2, Ke(a2, g2, true, f)), f = g2.sibling, f !== null)) {
                  f.return = e2;
                  e2 = f;
                  continue;
                }
              }
              if (e2.child !== null) {
                e2.child.return = e2;
                e2 = e2.child;
                continue;
              }
            }
            if (e2 === b2)
              break;
            for (; e2.sibling === null; ) {
              if (e2.return === null || e2.return === b2)
                return;
              e2 = e2.return;
            }
            e2.sibling.return = e2.return;
            e2 = e2.sibling;
          }
        };
        He = function(a2) {
          var b2 = a2.stateNode;
          if (a2.firstEffect !== null) {
            var c2 = b2.containerInfo, d = hb(c2);
            Ke(d, a2, false, false);
            b2.pendingChildren = d;
            Fe(a2);
            kb(c2, d);
          }
        };
        Ie = function(a2, b2, c2, d, e2) {
          var f = a2.stateNode, g2 = a2.memoizedProps;
          if ((a2 = b2.firstEffect === null) && g2 === d)
            b2.stateNode = f;
          else {
            var l2 = b2.stateNode, h = pd(H.current), k = null;
            g2 !== d && (k = Ia(l2, c2, g2, d, e2, h));
            a2 && k === null ? b2.stateNode = f : (f = gb(f, k, c2, g2, d, b2, a2, l2), Ga(f, c2, d, e2, h) && Fe(b2), b2.stateNode = f, a2 ? Fe(b2) : Ge(f, b2, false, false));
          }
        };
        Je = function(a2, b2, c2, d) {
          c2 !== d && (a2 = pd(od.current), c2 = pd(H.current), b2.stateNode = La(d, a2, c2, b2), Fe(b2));
        };
      } else
        He = function() {
        }, Ie = function() {
        }, Je = function() {
        };
      function Le(a2, b2) {
        switch (a2.tailMode) {
          case "hidden":
            b2 = a2.tail;
            for (var c2 = null; b2 !== null; )
              b2.alternate !== null && (c2 = b2), b2 = b2.sibling;
            c2 === null ? a2.tail = null : c2.sibling = null;
            break;
          case "collapsed":
            c2 = a2.tail;
            for (var d = null; c2 !== null; )
              c2.alternate !== null && (d = c2), c2 = c2.sibling;
            d === null ? b2 || a2.tail === null ? a2.tail = null : a2.tail.sibling = null : d.sibling = null;
        }
      }
      function Me(a2) {
        switch (a2.tag) {
          case 1:
            C(a2.type) && Gb(a2);
            var b2 = a2.effectTag;
            return b2 & 4096 ? (a2.effectTag = b2 & -4097 | 64, a2) : null;
          case 3:
            rd(a2);
            Hb(a2);
            b2 = a2.effectTag;
            if ((b2 & 64) !== 0)
              throw Error(n2(285));
            a2.effectTag = b2 & -4097 | 64;
            return a2;
          case 5:
            return td(a2), null;
          case 13:
            return y2(I, a2), b2 = a2.effectTag, b2 & 4096 ? (a2.effectTag = b2 & -4097 | 64, a2) : null;
          case 19:
            return y2(I, a2), null;
          case 4:
            return rd(a2), null;
          case 10:
            return yc(a2), null;
          default:
            return null;
        }
      }
      function Ne(a2, b2) {
        return { value: a2, source: b2, stack: Ab(b2) };
      }
      var Oe = typeof WeakSet === "function" ? WeakSet : Set;
      function Pe(a2, b2) {
        var c2 = b2.source, d = b2.stack;
        d === null && c2 !== null && (d = Ab(c2));
        c2 !== null && ta(c2.type);
        b2 = b2.value;
        a2 !== null && a2.tag === 1 && ta(a2.type);
        try {
          console.error(b2);
        } catch (e2) {
          setTimeout(function() {
            throw e2;
          });
        }
      }
      function Qe(a2, b2) {
        try {
          b2.props = a2.memoizedProps, b2.state = a2.memoizedState, b2.componentWillUnmount();
        } catch (c2) {
          Re(a2, c2);
        }
      }
      function Se(a2) {
        var b2 = a2.ref;
        if (b2 !== null)
          if (typeof b2 === "function")
            try {
              b2(null);
            } catch (c2) {
              Re(a2, c2);
            }
          else
            b2.current = null;
      }
      function Te(a2, b2) {
        switch (b2.tag) {
          case 0:
          case 11:
          case 15:
            Ue(2, 0, b2);
            break;
          case 1:
            if (b2.effectTag & 256 && a2 !== null) {
              var c2 = a2.memoizedProps, d = a2.memoizedState;
              a2 = b2.stateNode;
              b2 = a2.getSnapshotBeforeUpdate(b2.elementType === b2.type ? c2 : rc(b2.type, c2), d);
              a2.__reactInternalSnapshotBeforeUpdate = b2;
            }
            break;
          case 3:
          case 5:
          case 6:
          case 4:
          case 17:
            break;
          default:
            throw Error(n2(163));
        }
      }
      function Ue(a2, b2, c2) {
        c2 = c2.updateQueue;
        c2 = c2 !== null ? c2.lastEffect : null;
        if (c2 !== null) {
          var d = c2 = c2.next;
          do {
            if ((d.tag & a2) !== 0) {
              var e2 = d.destroy;
              d.destroy = void 0;
              e2 !== void 0 && e2();
            }
            (d.tag & b2) !== 0 && (e2 = d.create, d.destroy = e2());
            d = d.next;
          } while (d !== c2);
        }
      }
      function Ve(a2, b2, c2) {
        typeof We === "function" && We(b2);
        switch (b2.tag) {
          case 0:
          case 11:
          case 14:
          case 15:
            a2 = b2.updateQueue;
            if (a2 !== null && (a2 = a2.lastEffect, a2 !== null)) {
              var d = a2.next;
              hc(97 < c2 ? 97 : c2, function() {
                var a3 = d;
                do {
                  var c3 = a3.destroy;
                  if (c3 !== void 0) {
                    var g2 = b2;
                    try {
                      c3();
                    } catch (l2) {
                      Re(g2, l2);
                    }
                  }
                  a3 = a3.next;
                } while (a3 !== d);
              });
            }
            break;
          case 1:
            Se(b2);
            c2 = b2.stateNode;
            typeof c2.componentWillUnmount === "function" && Qe(b2, c2);
            break;
          case 5:
            Se(b2);
            break;
          case 4:
            Qa ? Xe(a2, b2, c2) : Ra && Ye(b2);
        }
      }
      function Ze(a2, b2, c2) {
        for (var d = b2; ; )
          if (Ve(a2, d, c2), d.child === null || Qa && d.tag === 4) {
            if (d === b2)
              break;
            for (; d.sibling === null; ) {
              if (d.return === null || d.return === b2)
                return;
              d = d.return;
            }
            d.sibling.return = d.return;
            d = d.sibling;
          } else
            d.child.return = d, d = d.child;
      }
      function $e(a2) {
        var b2 = a2.alternate;
        a2.return = null;
        a2.child = null;
        a2.memoizedState = null;
        a2.updateQueue = null;
        a2.dependencies = null;
        a2.alternate = null;
        a2.firstEffect = null;
        a2.lastEffect = null;
        a2.pendingProps = null;
        a2.memoizedProps = null;
        b2 !== null && $e(b2);
      }
      function Ye(a2) {
        if (Ra) {
          a2 = a2.stateNode.containerInfo;
          var b2 = hb(a2);
          lb(a2, b2);
        }
      }
      function af(a2) {
        return a2.tag === 5 || a2.tag === 3 || a2.tag === 4;
      }
      function bf(a2) {
        if (Qa) {
          a: {
            for (var b2 = a2.return; b2 !== null; ) {
              if (af(b2)) {
                var c2 = b2;
                break a;
              }
              b2 = b2.return;
            }
            throw Error(n2(160));
          }
          b2 = c2.stateNode;
          switch (c2.tag) {
            case 5:
              var d = false;
              break;
            case 3:
              b2 = b2.containerInfo;
              d = true;
              break;
            case 4:
              b2 = b2.containerInfo;
              d = true;
              break;
            default:
              throw Error(n2(161));
          }
          c2.effectTag & 16 && (bb(b2), c2.effectTag &= -17);
          a:
            b:
              for (c2 = a2; ; ) {
                for (; c2.sibling === null; ) {
                  if (c2.return === null || af(c2.return)) {
                    c2 = null;
                    break a;
                  }
                  c2 = c2.return;
                }
                c2.sibling.return = c2.return;
                for (c2 = c2.sibling; c2.tag !== 5 && c2.tag !== 6 && c2.tag !== 18; ) {
                  if (c2.effectTag & 2)
                    continue b;
                  if (c2.child === null || c2.tag === 4)
                    continue b;
                  else
                    c2.child.return = c2, c2 = c2.child;
                }
                if (!(c2.effectTag & 2)) {
                  c2 = c2.stateNode;
                  break a;
                }
              }
          for (var e2 = a2; ; ) {
            var f = e2.tag === 5 || e2.tag === 6;
            if (f)
              f = f ? e2.stateNode : e2.stateNode.instance, c2 ? d ? Za(b2, f, c2) : Ya(b2, f, c2) : d ? Ua(b2, f) : Ta(b2, f);
            else if (e2.tag !== 4 && e2.child !== null) {
              e2.child.return = e2;
              e2 = e2.child;
              continue;
            }
            if (e2 === a2)
              break;
            for (; e2.sibling === null; ) {
              if (e2.return === null || e2.return === a2)
                return;
              e2 = e2.return;
            }
            e2.sibling.return = e2.return;
            e2 = e2.sibling;
          }
        }
      }
      function Xe(a2, b2, c2) {
        for (var d = b2, e2 = false, f, g2; ; ) {
          if (!e2) {
            e2 = d.return;
            a:
              for (; ; ) {
                if (e2 === null)
                  throw Error(n2(160));
                f = e2.stateNode;
                switch (e2.tag) {
                  case 5:
                    g2 = false;
                    break a;
                  case 3:
                    f = f.containerInfo;
                    g2 = true;
                    break a;
                  case 4:
                    f = f.containerInfo;
                    g2 = true;
                    break a;
                }
                e2 = e2.return;
              }
            e2 = true;
          }
          if (d.tag === 5 || d.tag === 6)
            Ze(a2, d, c2), g2 ? ab(f, d.stateNode) : $a(f, d.stateNode);
          else if (d.tag === 4) {
            if (d.child !== null) {
              f = d.stateNode.containerInfo;
              g2 = true;
              d.child.return = d;
              d = d.child;
              continue;
            }
          } else if (Ve(a2, d, c2), d.child !== null) {
            d.child.return = d;
            d = d.child;
            continue;
          }
          if (d === b2)
            break;
          for (; d.sibling === null; ) {
            if (d.return === null || d.return === b2)
              return;
            d = d.return;
            d.tag === 4 && (e2 = false);
          }
          d.sibling.return = d.return;
          d = d.sibling;
        }
      }
      function cf(a2, b2) {
        if (Qa)
          switch (b2.tag) {
            case 0:
            case 11:
            case 14:
            case 15:
              Ue(4, 8, b2);
              break;
            case 1:
              break;
            case 5:
              var c2 = b2.stateNode;
              if (c2 != null) {
                var d = b2.memoizedProps;
                a2 = a2 !== null ? a2.memoizedProps : d;
                var e2 = b2.type, f = b2.updateQueue;
                b2.updateQueue = null;
                f !== null && Xa(c2, f, e2, a2, d, b2);
              }
              break;
            case 6:
              if (b2.stateNode === null)
                throw Error(n2(162));
              c2 = b2.memoizedProps;
              Va(b2.stateNode, a2 !== null ? a2.memoizedProps : c2, c2);
              break;
            case 3:
              Sa && (b2 = b2.stateNode, b2.hydrate && (b2.hydrate = false, xb(b2.containerInfo)));
              break;
            case 12:
              break;
            case 13:
              df(b2);
              ef(b2);
              break;
            case 19:
              ef(b2);
              break;
            case 17:
              break;
            case 20:
              break;
            case 21:
              break;
            default:
              throw Error(n2(163));
          }
        else {
          switch (b2.tag) {
            case 0:
            case 11:
            case 14:
            case 15:
              Ue(4, 8, b2);
              return;
            case 12:
              return;
            case 13:
              df(b2);
              ef(b2);
              return;
            case 19:
              ef(b2);
              return;
            case 3:
              Sa && (c2 = b2.stateNode, c2.hydrate && (c2.hydrate = false, xb(c2.containerInfo)));
          }
          a:
            if (Ra)
              switch (b2.tag) {
                case 1:
                case 5:
                case 6:
                case 20:
                  break a;
                case 3:
                case 4:
                  b2 = b2.stateNode;
                  lb(b2.containerInfo, b2.pendingChildren);
                  break a;
                default:
                  throw Error(n2(163));
              }
        }
      }
      function df(a2) {
        var b2 = a2;
        if (a2.memoizedState === null)
          var c2 = false;
        else
          c2 = true, b2 = a2.child, ff = E();
        if (Qa && b2 !== null)
          a:
            if (a2 = b2, Qa)
              for (b2 = a2; ; ) {
                if (b2.tag === 5) {
                  var d = b2.stateNode;
                  c2 ? cb2(d) : eb(b2.stateNode, b2.memoizedProps);
                } else if (b2.tag === 6)
                  d = b2.stateNode, c2 ? db(d) : fb(d, b2.memoizedProps);
                else if (b2.tag === 13 && b2.memoizedState !== null && b2.memoizedState.dehydrated === null) {
                  d = b2.child.sibling;
                  d.return = b2;
                  b2 = d;
                  continue;
                } else if (b2.child !== null) {
                  b2.child.return = b2;
                  b2 = b2.child;
                  continue;
                }
                if (b2 === a2)
                  break a;
                for (; b2.sibling === null; ) {
                  if (b2.return === null || b2.return === a2)
                    break a;
                  b2 = b2.return;
                }
                b2.sibling.return = b2.return;
                b2 = b2.sibling;
              }
      }
      function ef(a2) {
        var b2 = a2.updateQueue;
        if (b2 !== null) {
          a2.updateQueue = null;
          var c2 = a2.stateNode;
          c2 === null && (c2 = a2.stateNode = new Oe());
          b2.forEach(function(b3) {
            var d = gf.bind(null, a2, b3);
            c2.has(b3) || (c2.add(b3), b3.then(d, d));
          });
        }
      }
      var hf = typeof WeakMap === "function" ? WeakMap : Map;
      function jf(a2, b2, c2) {
        c2 = Gc(c2, null);
        c2.tag = 3;
        c2.payload = { element: null };
        var d = b2.value;
        c2.callback = function() {
          kf || (kf = true, lf = d);
          Pe(a2, b2);
        };
        return c2;
      }
      function mf(a2, b2, c2) {
        c2 = Gc(c2, null);
        c2.tag = 3;
        var d = a2.type.getDerivedStateFromError;
        if (typeof d === "function") {
          var e2 = b2.value;
          c2.payload = function() {
            Pe(a2, b2);
            return d(e2);
          };
        }
        var f = a2.stateNode;
        f !== null && typeof f.componentDidCatch === "function" && (c2.callback = function() {
          typeof d !== "function" && (nf === null ? nf = /* @__PURE__ */ new Set([this]) : nf.add(this), Pe(a2, b2));
          var c3 = b2.stack;
          this.componentDidCatch(b2.value, { componentStack: c3 !== null ? c3 : "" });
        });
        return c2;
      }
      var of = Math.ceil, pf = q.ReactCurrentDispatcher, qf = q.ReactCurrentOwner, R = 0, rf = 8, S = 16, sf = 32, tf = 0, uf = 1, vf = 2, wf = 3, xf = 4, yf = 5, T = R, U = null, V = null, W = 0, X = tf, zf = null, Af = 1073741823, Bf = 1073741823, Cf = null, Df = 0, Ef = false, ff = 0, Ff = 500, Y = null, kf = false, lf = null, nf = null, Gf = false, Hf = null, If = 90, Jf = null, Kf = 0, Lf = null, Mf = 0;
      function G() {
        return (T & (S | sf)) !== R ? 1073741821 - (E() / 10 | 0) : Mf !== 0 ? Mf : Mf = 1073741821 - (E() / 10 | 0);
      }
      function Vc(a2, b2, c2) {
        b2 = b2.mode;
        if ((b2 & 2) === 0)
          return 1073741823;
        var d = fc();
        if ((b2 & 4) === 0)
          return d === 99 ? 1073741823 : 1073741822;
        if ((T & S) !== R)
          return W;
        if (c2 !== null)
          a2 = mc(a2, c2.timeoutMs | 0 || 5e3, 250);
        else
          switch (d) {
            case 99:
              a2 = 1073741823;
              break;
            case 98:
              a2 = mc(a2, 150, 100);
              break;
            case 97:
            case 96:
              a2 = mc(a2, 5e3, 250);
              break;
            case 95:
              a2 = 2;
              break;
            default:
              throw Error(n2(326));
          }
        U !== null && a2 === W && --a2;
        return a2;
      }
      function Wc(a2, b2) {
        if (50 < Kf)
          throw Kf = 0, Lf = null, Error(n2(185));
        a2 = Nf(a2, b2);
        if (a2 !== null) {
          var c2 = fc();
          b2 === 1073741823 ? (T & rf) !== R && (T & (S | sf)) === R ? Of(a2) : (Z(a2), T === R && F()) : Z(a2);
          (T & 4) === R || c2 !== 98 && c2 !== 99 || (Jf === null ? Jf = /* @__PURE__ */ new Map([[a2, b2]]) : (c2 = Jf.get(a2), (c2 === void 0 || c2 > b2) && Jf.set(a2, b2)));
        }
      }
      function Nf(a2, b2) {
        a2.expirationTime < b2 && (a2.expirationTime = b2);
        var c2 = a2.alternate;
        c2 !== null && c2.expirationTime < b2 && (c2.expirationTime = b2);
        var d = a2.return, e2 = null;
        if (d === null && a2.tag === 3)
          e2 = a2.stateNode;
        else
          for (; d !== null; ) {
            c2 = d.alternate;
            d.childExpirationTime < b2 && (d.childExpirationTime = b2);
            c2 !== null && c2.childExpirationTime < b2 && (c2.childExpirationTime = b2);
            if (d.return === null && d.tag === 3) {
              e2 = d.stateNode;
              break;
            }
            d = d.return;
          }
        e2 !== null && (U === e2 && (Pc(b2), X === xf && Pf(e2, W)), Qf(e2, b2));
        return e2;
      }
      function Rf(a2) {
        var b2 = a2.lastExpiredTime;
        if (b2 !== 0)
          return b2;
        b2 = a2.firstPendingTime;
        if (!Sf(a2, b2))
          return b2;
        b2 = a2.lastPingedTime;
        a2 = a2.nextKnownPendingLevel;
        return b2 > a2 ? b2 : a2;
      }
      function Z(a2) {
        if (a2.lastExpiredTime !== 0)
          a2.callbackExpirationTime = 1073741823, a2.callbackPriority = 99, a2.callbackNode = jc(Of.bind(null, a2));
        else {
          var b2 = Rf(a2), c2 = a2.callbackNode;
          if (b2 === 0)
            c2 !== null && (a2.callbackNode = null, a2.callbackExpirationTime = 0, a2.callbackPriority = 90);
          else {
            var d = G();
            b2 === 1073741823 ? d = 99 : b2 === 1 || b2 === 2 ? d = 95 : (d = 10 * (1073741821 - b2) - 10 * (1073741821 - d), d = 0 >= d ? 99 : 250 >= d ? 98 : 5250 >= d ? 97 : 95);
            if (c2 !== null) {
              var e2 = a2.callbackPriority;
              if (a2.callbackExpirationTime === b2 && e2 >= d)
                return;
              c2 !== $b && Ob(c2);
            }
            a2.callbackExpirationTime = b2;
            a2.callbackPriority = d;
            b2 = b2 === 1073741823 ? jc(Of.bind(null, a2)) : ic(d, Tf.bind(null, a2), { timeout: 10 * (1073741821 - b2) - E() });
            a2.callbackNode = b2;
          }
        }
      }
      function Tf(a2, b2) {
        Mf = 0;
        if (b2)
          return b2 = G(), Uf(a2, b2), Z(a2), null;
        var c2 = Rf(a2);
        if (c2 !== 0) {
          b2 = a2.callbackNode;
          if ((T & (S | sf)) !== R)
            throw Error(n2(327));
          Vf();
          a2 === U && c2 === W || Wf(a2, c2);
          if (V !== null) {
            var d = T;
            T |= S;
            var e2 = Xf(a2);
            do
              try {
                Yf();
                break;
              } catch (l2) {
                Zf(a2, l2);
              }
            while (1);
            wc();
            T = d;
            pf.current = e2;
            if (X === uf)
              throw b2 = zf, Wf(a2, c2), Pf(a2, c2), Z(a2), b2;
            if (V === null)
              switch (e2 = a2.finishedWork = a2.current.alternate, a2.finishedExpirationTime = c2, d = X, U = null, d) {
                case tf:
                case uf:
                  throw Error(n2(345));
                case vf:
                  Uf(a2, 2 < c2 ? 2 : c2);
                  break;
                case wf:
                  Pf(a2, c2);
                  d = a2.lastSuspendedTime;
                  c2 === d && (a2.nextKnownPendingLevel = $f(e2));
                  if (Af === 1073741823 && (e2 = ff + Ff - E(), 10 < e2)) {
                    if (Ef) {
                      var f = a2.lastPingedTime;
                      if (f === 0 || f >= c2) {
                        a2.lastPingedTime = c2;
                        Wf(a2, c2);
                        break;
                      }
                    }
                    f = Rf(a2);
                    if (f !== 0 && f !== c2)
                      break;
                    if (d !== 0 && d !== c2) {
                      a2.lastPingedTime = d;
                      break;
                    }
                    a2.timeoutHandle = Ma(ag.bind(null, a2), e2);
                    break;
                  }
                  ag(a2);
                  break;
                case xf:
                  Pf(a2, c2);
                  d = a2.lastSuspendedTime;
                  c2 === d && (a2.nextKnownPendingLevel = $f(e2));
                  if (Ef && (e2 = a2.lastPingedTime, e2 === 0 || e2 >= c2)) {
                    a2.lastPingedTime = c2;
                    Wf(a2, c2);
                    break;
                  }
                  e2 = Rf(a2);
                  if (e2 !== 0 && e2 !== c2)
                    break;
                  if (d !== 0 && d !== c2) {
                    a2.lastPingedTime = d;
                    break;
                  }
                  Bf !== 1073741823 ? d = 10 * (1073741821 - Bf) - E() : Af === 1073741823 ? d = 0 : (d = 10 * (1073741821 - Af) - 5e3, e2 = E(), c2 = 10 * (1073741821 - c2) - e2, d = e2 - d, 0 > d && (d = 0), d = (120 > d ? 120 : 480 > d ? 480 : 1080 > d ? 1080 : 1920 > d ? 1920 : 3e3 > d ? 3e3 : 4320 > d ? 4320 : 1960 * of(d / 1960)) - d, c2 < d && (d = c2));
                  if (10 < d) {
                    a2.timeoutHandle = Ma(ag.bind(null, a2), d);
                    break;
                  }
                  ag(a2);
                  break;
                case yf:
                  if (Af !== 1073741823 && Cf !== null) {
                    f = Af;
                    var g2 = Cf;
                    d = g2.busyMinDurationMs | 0;
                    0 >= d ? d = 0 : (e2 = g2.busyDelayMs | 0, f = E() - (10 * (1073741821 - f) - (g2.timeoutMs | 0 || 5e3)), d = f <= e2 ? 0 : e2 + d - f);
                    if (10 < d) {
                      Pf(a2, c2);
                      a2.timeoutHandle = Ma(ag.bind(null, a2), d);
                      break;
                    }
                  }
                  ag(a2);
                  break;
                default:
                  throw Error(n2(329));
              }
            Z(a2);
            if (a2.callbackNode === b2)
              return Tf.bind(null, a2);
          }
        }
        return null;
      }
      function Of(a2) {
        var b2 = a2.lastExpiredTime;
        b2 = b2 !== 0 ? b2 : 1073741823;
        if (a2.finishedExpirationTime === b2)
          ag(a2);
        else {
          if ((T & (S | sf)) !== R)
            throw Error(n2(327));
          Vf();
          a2 === U && b2 === W || Wf(a2, b2);
          if (V !== null) {
            var c2 = T;
            T |= S;
            var d = Xf(a2);
            do
              try {
                bg();
                break;
              } catch (e2) {
                Zf(a2, e2);
              }
            while (1);
            wc();
            T = c2;
            pf.current = d;
            if (X === uf)
              throw c2 = zf, Wf(a2, b2), Pf(a2, b2), Z(a2), c2;
            if (V !== null)
              throw Error(n2(261));
            a2.finishedWork = a2.current.alternate;
            a2.finishedExpirationTime = b2;
            U = null;
            ag(a2);
            Z(a2);
          }
        }
        return null;
      }
      function cg(a2, b2) {
        Uf(a2, b2);
        Z(a2);
        (T & (S | sf)) === R && F();
      }
      function dg() {
        if (Jf !== null) {
          var a2 = Jf;
          Jf = null;
          a2.forEach(function(a3, c2) {
            Uf(c2, a3);
            Z(c2);
          });
          F();
        }
      }
      function eg(a2, b2) {
        if ((T & (S | sf)) !== R)
          throw Error(n2(187));
        var c2 = T;
        T |= 1;
        try {
          return hc(99, a2.bind(null, b2));
        } finally {
          T = c2, F();
        }
      }
      function Wf(a2, b2) {
        a2.finishedWork = null;
        a2.finishedExpirationTime = 0;
        var c2 = a2.timeoutHandle;
        c2 !== Oa && (a2.timeoutHandle = Oa, Na(c2));
        if (V !== null)
          for (c2 = V.return; c2 !== null; ) {
            var d = c2;
            switch (d.tag) {
              case 1:
                var e2 = d.type.childContextTypes;
                e2 !== null && e2 !== void 0 && Gb(d);
                break;
              case 3:
                rd(d);
                Hb(d);
                break;
              case 5:
                td(d);
                break;
              case 4:
                rd(d);
                break;
              case 13:
                y2(I, d);
                break;
              case 19:
                y2(I, d);
                break;
              case 10:
                yc(d);
            }
            c2 = c2.return;
          }
        U = a2;
        V = fd(a2.current, null, b2);
        W = b2;
        X = tf;
        zf = null;
        Bf = Af = 1073741823;
        Cf = null;
        Df = 0;
        Ef = false;
      }
      function Zf(a2, b2) {
        do {
          try {
            wc();
            Nd();
            if (V === null || V.return === null)
              return X = uf, zf = b2, null;
            a: {
              var c2 = a2, d = V.return, e2 = V, f = b2;
              b2 = W;
              e2.effectTag |= 2048;
              e2.firstEffect = e2.lastEffect = null;
              if (f !== null && typeof f === "object" && typeof f.then === "function") {
                var g2 = f, l2 = (I.current & 1) !== 0, h = d;
                do {
                  var k;
                  if (k = h.tag === 13) {
                    var p = h.memoizedState;
                    if (p !== null)
                      k = p.dehydrated !== null ? true : false;
                    else {
                      var D = h.memoizedProps;
                      k = D.fallback === void 0 ? false : D.unstable_avoidThisFallback !== true ? true : l2 ? false : true;
                    }
                  }
                  if (k) {
                    var x = h.updateQueue;
                    if (x === null) {
                      var K = /* @__PURE__ */ new Set();
                      K.add(g2);
                      h.updateQueue = K;
                    } else
                      x.add(g2);
                    if ((h.mode & 2) === 0) {
                      h.effectTag |= 64;
                      e2.effectTag &= -2981;
                      if (e2.tag === 1)
                        if (e2.alternate === null)
                          e2.tag = 17;
                        else {
                          var Ha = Gc(1073741823, null);
                          Ha.tag = 2;
                          Ic(e2, Ha);
                        }
                      e2.expirationTime = 1073741823;
                      break a;
                    }
                    f = void 0;
                    e2 = b2;
                    var O = c2.pingCache;
                    O === null ? (O = c2.pingCache = new hf(), f = /* @__PURE__ */ new Set(), O.set(g2, f)) : (f = O.get(g2), f === void 0 && (f = /* @__PURE__ */ new Set(), O.set(g2, f)));
                    if (!f.has(e2)) {
                      f.add(e2);
                      var w = fg.bind(null, c2, g2, e2);
                      g2.then(w, w);
                    }
                    h.effectTag |= 4096;
                    h.expirationTime = b2;
                    break a;
                  }
                  h = h.return;
                } while (h !== null);
                f = Error((ta(e2.type) || "A React component") + " suspended while rendering, but no fallback UI was specified.\n\nAdd a <Suspense fallback=...> component higher in the tree to provide a loading indicator or placeholder to display." + Ab(e2));
              }
              X !== yf && (X = vf);
              f = Ne(f, e2);
              h = d;
              do {
                switch (h.tag) {
                  case 3:
                    g2 = f;
                    h.effectTag |= 4096;
                    h.expirationTime = b2;
                    var r2 = jf(h, g2, b2);
                    Jc(h, r2);
                    break a;
                  case 1:
                    g2 = f;
                    var t2 = h.type, N = h.stateNode;
                    if ((h.effectTag & 64) === 0 && (typeof t2.getDerivedStateFromError === "function" || N !== null && typeof N.componentDidCatch === "function" && (nf === null || !nf.has(N)))) {
                      h.effectTag |= 4096;
                      h.expirationTime = b2;
                      var Mc = mf(h, g2, b2);
                      Jc(h, Mc);
                      break a;
                    }
                }
                h = h.return;
              } while (h !== null);
            }
            V = gg(V);
          } catch (Sb) {
            b2 = Sb;
            continue;
          }
          break;
        } while (1);
      }
      function Xf() {
        var a2 = pf.current;
        pf.current = Md;
        return a2 === null ? Md : a2;
      }
      function Oc(a2, b2) {
        a2 < Af && 2 < a2 && (Af = a2);
        b2 !== null && a2 < Bf && 2 < a2 && (Bf = a2, Cf = b2);
      }
      function Pc(a2) {
        a2 > Df && (Df = a2);
      }
      function bg() {
        for (; V !== null; )
          V = hg(V);
      }
      function Yf() {
        for (; V !== null && !Pb(); )
          V = hg(V);
      }
      function hg(a2) {
        var b2 = ig(a2.alternate, a2, W);
        a2.memoizedProps = a2.pendingProps;
        b2 === null && (b2 = gg(a2));
        qf.current = null;
        return b2;
      }
      function gg(a2) {
        V = a2;
        do {
          var b2 = V.alternate;
          a2 = V.return;
          if ((V.effectTag & 2048) === 0) {
            a: {
              var c2 = b2;
              b2 = V;
              var d = W, e2 = b2.pendingProps;
              switch (b2.tag) {
                case 2:
                  break;
                case 16:
                  break;
                case 15:
                case 0:
                  break;
                case 1:
                  C(b2.type) && Gb(b2);
                  break;
                case 3:
                  rd(b2);
                  Hb(b2);
                  e2 = b2.stateNode;
                  e2.pendingContext && (e2.context = e2.pendingContext, e2.pendingContext = null);
                  (c2 === null || c2.child === null) && ne(b2) && Fe(b2);
                  He(b2);
                  break;
                case 5:
                  td(b2);
                  var f = pd(od.current);
                  d = b2.type;
                  if (c2 !== null && b2.stateNode != null)
                    Ie(c2, b2, d, e2, f), c2.ref !== b2.ref && (b2.effectTag |= 128);
                  else if (e2) {
                    c2 = pd(H.current);
                    if (ne(b2)) {
                      e2 = b2;
                      if (!Sa)
                        throw Error(n2(175));
                      c2 = ub(e2.stateNode, e2.type, e2.memoizedProps, f, c2, e2);
                      e2.updateQueue = c2;
                      c2 = c2 !== null ? true : false;
                      c2 && Fe(b2);
                    } else {
                      var g2 = Ea(d, e2, f, c2, b2);
                      Ge(g2, b2, false, false);
                      b2.stateNode = g2;
                      Ga(g2, d, e2, f, c2) && Fe(b2);
                    }
                    b2.ref !== null && (b2.effectTag |= 128);
                  } else if (b2.stateNode === null)
                    throw Error(n2(166));
                  break;
                case 6:
                  if (c2 && b2.stateNode != null)
                    Je(c2, b2, c2.memoizedProps, e2);
                  else {
                    if (typeof e2 !== "string" && b2.stateNode === null)
                      throw Error(n2(166));
                    c2 = pd(od.current);
                    f = pd(H.current);
                    if (ne(b2)) {
                      c2 = b2;
                      if (!Sa)
                        throw Error(n2(176));
                      (c2 = vb(c2.stateNode, c2.memoizedProps, c2)) && Fe(b2);
                    } else
                      b2.stateNode = La(e2, c2, f, b2);
                  }
                  break;
                case 11:
                  break;
                case 13:
                  y2(I, b2);
                  e2 = b2.memoizedState;
                  if ((b2.effectTag & 64) !== 0) {
                    b2.expirationTime = d;
                    break a;
                  }
                  e2 = e2 !== null;
                  f = false;
                  c2 === null ? b2.memoizedProps.fallback !== void 0 && ne(b2) : (d = c2.memoizedState, f = d !== null, e2 || d === null || (d = c2.child.sibling, d !== null && (g2 = b2.firstEffect, g2 !== null ? (b2.firstEffect = d, d.nextEffect = g2) : (b2.firstEffect = b2.lastEffect = d, d.nextEffect = null), d.effectTag = 8)));
                  if (e2 && !f && (b2.mode & 2) !== 0)
                    if (c2 === null && b2.memoizedProps.unstable_avoidThisFallback !== true || (I.current & 1) !== 0)
                      X === tf && (X = wf);
                    else {
                      if (X === tf || X === wf)
                        X = xf;
                      Df !== 0 && U !== null && (Pf(U, W), Qf(U, Df));
                    }
                  Ra && e2 && (b2.effectTag |= 4);
                  Qa && (e2 || f) && (b2.effectTag |= 4);
                  break;
                case 7:
                  break;
                case 8:
                  break;
                case 12:
                  break;
                case 4:
                  rd(b2);
                  He(b2);
                  break;
                case 10:
                  yc(b2);
                  break;
                case 9:
                  break;
                case 14:
                  break;
                case 17:
                  C(b2.type) && Gb(b2);
                  break;
                case 19:
                  y2(I, b2);
                  e2 = b2.memoizedState;
                  if (e2 === null)
                    break;
                  f = (b2.effectTag & 64) !== 0;
                  g2 = e2.rendering;
                  if (g2 === null)
                    if (f)
                      Le(e2, false);
                    else {
                      if (X !== tf || c2 !== null && (c2.effectTag & 64) !== 0)
                        for (c2 = b2.child; c2 !== null; ) {
                          g2 = ud(c2);
                          if (g2 !== null) {
                            b2.effectTag |= 64;
                            Le(e2, false);
                            c2 = g2.updateQueue;
                            c2 !== null && (b2.updateQueue = c2, b2.effectTag |= 4);
                            e2.lastEffect === null && (b2.firstEffect = null);
                            b2.lastEffect = e2.lastEffect;
                            c2 = d;
                            for (e2 = b2.child; e2 !== null; )
                              f = e2, d = c2, f.effectTag &= 2, f.nextEffect = null, f.firstEffect = null, f.lastEffect = null, g2 = f.alternate, g2 === null ? (f.childExpirationTime = 0, f.expirationTime = d, f.child = null, f.memoizedProps = null, f.memoizedState = null, f.updateQueue = null, f.dependencies = null) : (f.childExpirationTime = g2.childExpirationTime, f.expirationTime = g2.expirationTime, f.child = g2.child, f.memoizedProps = g2.memoizedProps, f.memoizedState = g2.memoizedState, f.updateQueue = g2.updateQueue, d = g2.dependencies, f.dependencies = d === null ? null : { expirationTime: d.expirationTime, firstContext: d.firstContext, responders: d.responders }), e2 = e2.sibling;
                            z(I, I.current & 1 | 2, b2);
                            b2 = b2.child;
                            break a;
                          }
                          c2 = c2.sibling;
                        }
                    }
                  else {
                    if (!f)
                      if (c2 = ud(g2), c2 !== null) {
                        if (b2.effectTag |= 64, f = true, c2 = c2.updateQueue, c2 !== null && (b2.updateQueue = c2, b2.effectTag |= 4), Le(e2, true), e2.tail === null && e2.tailMode === "hidden" && !g2.alternate) {
                          b2 = b2.lastEffect = e2.lastEffect;
                          b2 !== null && (b2.nextEffect = null);
                          break;
                        }
                      } else
                        E() > e2.tailExpiration && 1 < d && (b2.effectTag |= 64, f = true, Le(e2, false), b2.expirationTime = b2.childExpirationTime = d - 1);
                    e2.isBackwards ? (g2.sibling = b2.child, b2.child = g2) : (c2 = e2.last, c2 !== null ? c2.sibling = g2 : b2.child = g2, e2.last = g2);
                  }
                  if (e2.tail !== null) {
                    e2.tailExpiration === 0 && (e2.tailExpiration = E() + 500);
                    c2 = e2.tail;
                    e2.rendering = c2;
                    e2.tail = c2.sibling;
                    e2.lastEffect = b2.lastEffect;
                    c2.sibling = null;
                    e2 = I.current;
                    e2 = f ? e2 & 1 | 2 : e2 & 1;
                    z(I, e2, b2);
                    b2 = c2;
                    break a;
                  }
                  break;
                case 20:
                  break;
                case 21:
                  break;
                default:
                  throw Error(n2(156, b2.tag));
              }
              b2 = null;
            }
            c2 = V;
            if (W === 1 || c2.childExpirationTime !== 1) {
              e2 = 0;
              for (f = c2.child; f !== null; )
                d = f.expirationTime, g2 = f.childExpirationTime, d > e2 && (e2 = d), g2 > e2 && (e2 = g2), f = f.sibling;
              c2.childExpirationTime = e2;
            }
            if (b2 !== null)
              return b2;
            a2 !== null && (a2.effectTag & 2048) === 0 && (a2.firstEffect === null && (a2.firstEffect = V.firstEffect), V.lastEffect !== null && (a2.lastEffect !== null && (a2.lastEffect.nextEffect = V.firstEffect), a2.lastEffect = V.lastEffect), 1 < V.effectTag && (a2.lastEffect !== null ? a2.lastEffect.nextEffect = V : a2.firstEffect = V, a2.lastEffect = V));
          } else {
            b2 = Me(V, W);
            if (b2 !== null)
              return b2.effectTag &= 2047, b2;
            a2 !== null && (a2.firstEffect = a2.lastEffect = null, a2.effectTag |= 2048);
          }
          b2 = V.sibling;
          if (b2 !== null)
            return b2;
          V = a2;
        } while (V !== null);
        X === tf && (X = yf);
        return null;
      }
      function $f(a2) {
        var b2 = a2.expirationTime;
        a2 = a2.childExpirationTime;
        return b2 > a2 ? b2 : a2;
      }
      function ag(a2) {
        var b2 = fc();
        hc(99, jg.bind(null, a2, b2));
        return null;
      }
      function jg(a2, b2) {
        do
          Vf();
        while (Hf !== null);
        if ((T & (S | sf)) !== R)
          throw Error(n2(327));
        var c2 = a2.finishedWork, d = a2.finishedExpirationTime;
        if (c2 === null)
          return null;
        a2.finishedWork = null;
        a2.finishedExpirationTime = 0;
        if (c2 === a2.current)
          throw Error(n2(177));
        a2.callbackNode = null;
        a2.callbackExpirationTime = 0;
        a2.callbackPriority = 90;
        a2.nextKnownPendingLevel = 0;
        var e2 = $f(c2);
        a2.firstPendingTime = e2;
        d <= a2.lastSuspendedTime ? a2.firstSuspendedTime = a2.lastSuspendedTime = a2.nextKnownPendingLevel = 0 : d <= a2.firstSuspendedTime && (a2.firstSuspendedTime = d - 1);
        d <= a2.lastPingedTime && (a2.lastPingedTime = 0);
        d <= a2.lastExpiredTime && (a2.lastExpiredTime = 0);
        a2 === U && (V = U = null, W = 0);
        1 < c2.effectTag ? c2.lastEffect !== null ? (c2.lastEffect.nextEffect = c2, e2 = c2.firstEffect) : e2 = c2 : e2 = c2.firstEffect;
        if (e2 !== null) {
          var f = T;
          T |= sf;
          qf.current = null;
          Ca(a2.containerInfo);
          Y = e2;
          do
            try {
              kg();
            } catch (jb) {
              if (Y === null)
                throw Error(n2(330));
              Re(Y, jb);
              Y = Y.nextEffect;
            }
          while (Y !== null);
          Y = e2;
          do
            try {
              for (var g2 = a2, l2 = b2; Y !== null; ) {
                var h = Y.effectTag;
                h & 16 && Qa && bb(Y.stateNode);
                if (h & 128) {
                  var k = Y.alternate;
                  if (k !== null) {
                    var p = k.ref;
                    p !== null && (typeof p === "function" ? p(null) : p.current = null);
                  }
                }
                switch (h & 1038) {
                  case 2:
                    bf(Y);
                    Y.effectTag &= -3;
                    break;
                  case 6:
                    bf(Y);
                    Y.effectTag &= -3;
                    cf(Y.alternate, Y);
                    break;
                  case 1024:
                    Y.effectTag &= -1025;
                    break;
                  case 1028:
                    Y.effectTag &= -1025;
                    cf(Y.alternate, Y);
                    break;
                  case 4:
                    cf(Y.alternate, Y);
                    break;
                  case 8:
                    var D = g2, x = Y, K = l2;
                    Qa ? Xe(D, x, K) : Ze(D, x, K);
                    $e(x);
                }
                Y = Y.nextEffect;
              }
            } catch (jb) {
              if (Y === null)
                throw Error(n2(330));
              Re(Y, jb);
              Y = Y.nextEffect;
            }
          while (Y !== null);
          Da(a2.containerInfo);
          a2.current = c2;
          Y = e2;
          do
            try {
              for (h = d; Y !== null; ) {
                var Ha = Y.effectTag;
                if (Ha & 36) {
                  var O = Y.alternate;
                  k = Y;
                  p = h;
                  switch (k.tag) {
                    case 0:
                    case 11:
                    case 15:
                      Ue(16, 32, k);
                      break;
                    case 1:
                      var w = k.stateNode;
                      if (k.effectTag & 4)
                        if (O === null)
                          w.componentDidMount();
                        else {
                          var r2 = k.elementType === k.type ? O.memoizedProps : rc(k.type, O.memoizedProps);
                          w.componentDidUpdate(r2, O.memoizedState, w.__reactInternalSnapshotBeforeUpdate);
                        }
                      var t2 = k.updateQueue;
                      t2 !== null && Qc(k, t2, w, p);
                      break;
                    case 3:
                      var N = k.updateQueue;
                      if (N !== null) {
                        g2 = null;
                        if (k.child !== null)
                          switch (k.child.tag) {
                            case 5:
                              g2 = za(k.child.stateNode);
                              break;
                            case 1:
                              g2 = k.child.stateNode;
                          }
                        Qc(k, N, g2, p);
                      }
                      break;
                    case 5:
                      var Mc = k.stateNode;
                      O === null && k.effectTag & 4 && Wa(Mc, k.type, k.memoizedProps, k);
                      break;
                    case 6:
                      break;
                    case 4:
                      break;
                    case 12:
                      break;
                    case 13:
                      if (Sa && k.memoizedState === null) {
                        var Sb = k.alternate;
                        if (Sb !== null) {
                          var le = Sb.memoizedState;
                          if (le !== null) {
                            var me = le.dehydrated;
                            me !== null && yb(me);
                          }
                        }
                      }
                      break;
                    case 19:
                    case 17:
                    case 20:
                    case 21:
                      break;
                    default:
                      throw Error(n2(163));
                  }
                }
                if (Ha & 128) {
                  k = void 0;
                  var Tb = Y.ref;
                  if (Tb !== null) {
                    var v = Y.stateNode;
                    switch (Y.tag) {
                      case 5:
                        k = za(v);
                        break;
                      default:
                        k = v;
                    }
                    typeof Tb === "function" ? Tb(k) : Tb.current = k;
                  }
                }
                Y = Y.nextEffect;
              }
            } catch (jb) {
              if (Y === null)
                throw Error(n2(330));
              Re(Y, jb);
              Y = Y.nextEffect;
            }
          while (Y !== null);
          Y = null;
          ac();
          T = f;
        } else
          a2.current = c2;
        if (Gf)
          Gf = false, Hf = a2, If = b2;
        else
          for (Y = e2; Y !== null; )
            b2 = Y.nextEffect, Y.nextEffect = null, Y = b2;
        b2 = a2.firstPendingTime;
        b2 === 0 && (nf = null);
        b2 === 1073741823 ? a2 === Lf ? Kf++ : (Kf = 0, Lf = a2) : Kf = 0;
        typeof lg === "function" && lg(c2.stateNode, d);
        Z(a2);
        if (kf)
          throw kf = false, a2 = lf, lf = null, a2;
        if ((T & rf) !== R)
          return null;
        F();
        return null;
      }
      function kg() {
        for (; Y !== null; ) {
          var a2 = Y.effectTag;
          (a2 & 256) !== 0 && Te(Y.alternate, Y);
          (a2 & 512) === 0 || Gf || (Gf = true, ic(97, function() {
            Vf();
            return null;
          }));
          Y = Y.nextEffect;
        }
      }
      function Vf() {
        if (If !== 90) {
          var a2 = 97 < If ? 97 : If;
          If = 90;
          return hc(a2, mg);
        }
      }
      function mg() {
        if (Hf === null)
          return false;
        var a2 = Hf;
        Hf = null;
        if ((T & (S | sf)) !== R)
          throw Error(n2(331));
        var b2 = T;
        T |= sf;
        for (a2 = a2.current.firstEffect; a2 !== null; ) {
          try {
            var c2 = a2;
            if ((c2.effectTag & 512) !== 0)
              switch (c2.tag) {
                case 0:
                case 11:
                case 15:
                  Ue(128, 0, c2), Ue(0, 64, c2);
              }
          } catch (d) {
            if (a2 === null)
              throw Error(n2(330));
            Re(a2, d);
          }
          c2 = a2.nextEffect;
          a2.nextEffect = null;
          a2 = c2;
        }
        T = b2;
        F();
        return true;
      }
      function ng(a2, b2, c2) {
        b2 = Ne(c2, b2);
        b2 = jf(a2, b2, 1073741823);
        Ic(a2, b2);
        a2 = Nf(a2, 1073741823);
        a2 !== null && Z(a2);
      }
      function Re(a2, b2) {
        if (a2.tag === 3)
          ng(a2, a2, b2);
        else
          for (var c2 = a2.return; c2 !== null; ) {
            if (c2.tag === 3) {
              ng(c2, a2, b2);
              break;
            } else if (c2.tag === 1) {
              var d = c2.stateNode;
              if (typeof c2.type.getDerivedStateFromError === "function" || typeof d.componentDidCatch === "function" && (nf === null || !nf.has(d))) {
                a2 = Ne(b2, a2);
                a2 = mf(c2, a2, 1073741823);
                Ic(c2, a2);
                c2 = Nf(c2, 1073741823);
                c2 !== null && Z(c2);
                break;
              }
            }
            c2 = c2.return;
          }
      }
      function fg(a2, b2, c2) {
        var d = a2.pingCache;
        d !== null && d.delete(b2);
        U === a2 && W === c2 ? X === xf || X === wf && Af === 1073741823 && E() - ff < Ff ? Wf(a2, W) : Ef = true : Sf(a2, c2) && (b2 = a2.lastPingedTime, b2 !== 0 && b2 < c2 || (a2.lastPingedTime = c2, a2.finishedExpirationTime === c2 && (a2.finishedExpirationTime = 0, a2.finishedWork = null), Z(a2)));
      }
      function gf(a2, b2) {
        var c2 = a2.stateNode;
        c2 !== null && c2.delete(b2);
        b2 = 0;
        b2 === 0 && (b2 = G(), b2 = Vc(b2, a2, null));
        a2 = Nf(a2, b2);
        a2 !== null && Z(a2);
      }
      var ig;
      ig = function(a2, b2, c2) {
        var d = b2.expirationTime;
        if (a2 !== null) {
          var e2 = b2.pendingProps;
          if (a2.memoizedProps !== e2 || B.current)
            Bc = true;
          else {
            if (d < c2) {
              Bc = false;
              switch (b2.tag) {
                case 3:
                  ze(b2);
                  oe();
                  break;
                case 5:
                  sd(b2);
                  if (b2.mode & 4 && c2 !== 1 && Ka(b2.type, e2))
                    return b2.expirationTime = b2.childExpirationTime = 1, null;
                  break;
                case 1:
                  C(b2.type) && Kb(b2);
                  break;
                case 4:
                  qd(b2, b2.stateNode.containerInfo);
                  break;
                case 10:
                  xc(b2, b2.memoizedProps.value);
                  break;
                case 13:
                  if (b2.memoizedState !== null) {
                    d = b2.child.childExpirationTime;
                    if (d !== 0 && d >= c2)
                      return Be(a2, b2, c2);
                    z(I, I.current & 1, b2);
                    b2 = re(a2, b2, c2);
                    return b2 !== null ? b2.sibling : null;
                  }
                  z(I, I.current & 1, b2);
                  break;
                case 19:
                  d = b2.childExpirationTime >= c2;
                  if ((a2.effectTag & 64) !== 0) {
                    if (d)
                      return Ee(a2, b2, c2);
                    b2.effectTag |= 64;
                  }
                  e2 = b2.memoizedState;
                  e2 !== null && (e2.rendering = null, e2.tail = null);
                  z(I, I.current, b2);
                  if (!d)
                    return null;
              }
              return re(a2, b2, c2);
            }
            Bc = false;
          }
        } else
          Bc = false;
        b2.expirationTime = 0;
        switch (b2.tag) {
          case 2:
            d = b2.type;
            a2 !== null && (a2.alternate = null, b2.alternate = null, b2.effectTag |= 2);
            a2 = b2.pendingProps;
            e2 = Fb(b2, A.current);
            Ac(b2, c2);
            e2 = Jd(null, b2, d, a2, e2, c2);
            b2.effectTag |= 1;
            if (typeof e2 === "object" && e2 !== null && typeof e2.render === "function" && e2.$$typeof === void 0) {
              b2.tag = 1;
              Nd();
              if (C(d)) {
                var f = true;
                Kb(b2);
              } else
                f = false;
              b2.memoizedState = e2.state !== null && e2.state !== void 0 ? e2.state : null;
              var g2 = d.getDerivedStateFromProps;
              typeof g2 === "function" && Uc(b2, d, g2, a2);
              e2.updater = Xc;
              b2.stateNode = e2;
              e2._reactInternalFiber = b2;
              ad(b2, d, a2, c2);
              b2 = ye(null, b2, d, true, f, c2);
            } else
              b2.tag = 0, Q(null, b2, e2, c2), b2 = b2.child;
            return b2;
          case 16:
            e2 = b2.elementType;
            a2 !== null && (a2.alternate = null, b2.alternate = null, b2.effectTag |= 2);
            a2 = b2.pendingProps;
            sa(e2);
            if (e2._status !== 1)
              throw e2._result;
            e2 = e2._result;
            b2.type = e2;
            f = b2.tag = og(e2);
            a2 = rc(e2, a2);
            switch (f) {
              case 0:
                b2 = ve(null, b2, e2, a2, c2);
                break;
              case 1:
                b2 = xe(null, b2, e2, a2, c2);
                break;
              case 11:
                b2 = qe(null, b2, e2, a2, c2);
                break;
              case 14:
                b2 = se(null, b2, e2, rc(e2.type, a2), d, c2);
                break;
              default:
                throw Error(n2(306, e2, ""));
            }
            return b2;
          case 0:
            return d = b2.type, e2 = b2.pendingProps, e2 = b2.elementType === d ? e2 : rc(d, e2), ve(a2, b2, d, e2, c2);
          case 1:
            return d = b2.type, e2 = b2.pendingProps, e2 = b2.elementType === d ? e2 : rc(d, e2), xe(a2, b2, d, e2, c2);
          case 3:
            ze(b2);
            d = b2.updateQueue;
            if (d === null)
              throw Error(n2(282));
            e2 = b2.memoizedState;
            e2 = e2 !== null ? e2.element : null;
            Nc(b2, d, b2.pendingProps, null, c2);
            d = b2.memoizedState.element;
            if (d === e2)
              oe(), b2 = re(a2, b2, c2);
            else {
              if (e2 = b2.stateNode.hydrate)
                Sa ? (ee = tb(b2.stateNode.containerInfo), de = b2, e2 = fe = true) : e2 = false;
              if (e2)
                for (c2 = ld(b2, null, d, c2), b2.child = c2; c2; )
                  c2.effectTag = c2.effectTag & -3 | 1024, c2 = c2.sibling;
              else
                Q(a2, b2, d, c2), oe();
              b2 = b2.child;
            }
            return b2;
          case 5:
            return sd(b2), a2 === null && je(b2), d = b2.type, e2 = b2.pendingProps, f = a2 !== null ? a2.memoizedProps : null, g2 = e2.children, Ja(d, e2) ? g2 = null : f !== null && Ja(d, f) && (b2.effectTag |= 16), we(a2, b2), b2.mode & 4 && c2 !== 1 && Ka(d, e2) ? (b2.expirationTime = b2.childExpirationTime = 1, b2 = null) : (Q(a2, b2, g2, c2), b2 = b2.child), b2;
          case 6:
            return a2 === null && je(b2), null;
          case 13:
            return Be(a2, b2, c2);
          case 4:
            return qd(b2, b2.stateNode.containerInfo), d = b2.pendingProps, a2 === null ? b2.child = kd(b2, null, d, c2) : Q(a2, b2, d, c2), b2.child;
          case 11:
            return d = b2.type, e2 = b2.pendingProps, e2 = b2.elementType === d ? e2 : rc(d, e2), qe(a2, b2, d, e2, c2);
          case 7:
            return Q(a2, b2, b2.pendingProps, c2), b2.child;
          case 8:
            return Q(a2, b2, b2.pendingProps.children, c2), b2.child;
          case 12:
            return Q(a2, b2, b2.pendingProps.children, c2), b2.child;
          case 10:
            a: {
              d = b2.type._context;
              e2 = b2.pendingProps;
              g2 = b2.memoizedProps;
              f = e2.value;
              xc(b2, f);
              if (g2 !== null) {
                var l2 = g2.value;
                f = oc(l2, f) ? 0 : (typeof d._calculateChangedBits === "function" ? d._calculateChangedBits(l2, f) : 1073741823) | 0;
                if (f === 0) {
                  if (g2.children === e2.children && !B.current) {
                    b2 = re(a2, b2, c2);
                    break a;
                  }
                } else
                  for (l2 = b2.child, l2 !== null && (l2.return = b2); l2 !== null; ) {
                    var h = l2.dependencies;
                    if (h !== null) {
                      g2 = l2.child;
                      for (var k = h.firstContext; k !== null; ) {
                        if (k.context === d && (k.observedBits & f) !== 0) {
                          l2.tag === 1 && (k = Gc(c2, null), k.tag = 2, Ic(l2, k));
                          l2.expirationTime < c2 && (l2.expirationTime = c2);
                          k = l2.alternate;
                          k !== null && k.expirationTime < c2 && (k.expirationTime = c2);
                          zc(l2.return, c2);
                          h.expirationTime < c2 && (h.expirationTime = c2);
                          break;
                        }
                        k = k.next;
                      }
                    } else
                      g2 = l2.tag === 10 ? l2.type === b2.type ? null : l2.child : l2.child;
                    if (g2 !== null)
                      g2.return = l2;
                    else
                      for (g2 = l2; g2 !== null; ) {
                        if (g2 === b2) {
                          g2 = null;
                          break;
                        }
                        l2 = g2.sibling;
                        if (l2 !== null) {
                          l2.return = g2.return;
                          g2 = l2;
                          break;
                        }
                        g2 = g2.return;
                      }
                    l2 = g2;
                  }
              }
              Q(a2, b2, e2.children, c2);
              b2 = b2.child;
            }
            return b2;
          case 9:
            return e2 = b2.type, f = b2.pendingProps, d = f.children, Ac(b2, c2), e2 = Cc(e2, f.unstable_observedBits), d = d(e2), b2.effectTag |= 1, Q(a2, b2, d, c2), b2.child;
          case 14:
            return e2 = b2.type, f = rc(e2, b2.pendingProps), f = rc(e2.type, f), se(a2, b2, e2, f, d, c2);
          case 15:
            return ue(a2, b2, b2.type, b2.pendingProps, d, c2);
          case 17:
            return d = b2.type, e2 = b2.pendingProps, e2 = b2.elementType === d ? e2 : rc(d, e2), a2 !== null && (a2.alternate = null, b2.alternate = null, b2.effectTag |= 2), b2.tag = 1, C(d) ? (a2 = true, Kb(b2)) : a2 = false, Ac(b2, c2), Zc(b2, d, e2, c2), ad(b2, d, e2, c2), ye(null, b2, d, true, a2, c2);
          case 19:
            return Ee(a2, b2, c2);
        }
        throw Error(n2(156, b2.tag));
      };
      var lg = null, We = null;
      function pg(a2) {
        if (typeof __REACT_DEVTOOLS_GLOBAL_HOOK__ === "undefined")
          return false;
        var b2 = __REACT_DEVTOOLS_GLOBAL_HOOK__;
        if (b2.isDisabled || !b2.supportsFiber)
          return true;
        try {
          var c2 = b2.inject(a2);
          lg = function(a3) {
            try {
              b2.onCommitFiberRoot(c2, a3, void 0, (a3.current.effectTag & 64) === 64);
            } catch (e2) {
            }
          };
          We = function(a3) {
            try {
              b2.onCommitFiberUnmount(c2, a3);
            } catch (e2) {
            }
          };
        } catch (d) {
        }
        return true;
      }
      function qg(a2, b2, c2, d) {
        this.tag = a2;
        this.key = c2;
        this.sibling = this.child = this.return = this.stateNode = this.type = this.elementType = null;
        this.index = 0;
        this.ref = null;
        this.pendingProps = b2;
        this.dependencies = this.memoizedState = this.updateQueue = this.memoizedProps = null;
        this.mode = d;
        this.effectTag = 0;
        this.lastEffect = this.firstEffect = this.nextEffect = null;
        this.childExpirationTime = this.expirationTime = 0;
        this.alternate = null;
      }
      function he(a2, b2, c2, d) {
        return new qg(a2, b2, c2, d);
      }
      function te(a2) {
        a2 = a2.prototype;
        return !(!a2 || !a2.isReactComponent);
      }
      function og(a2) {
        if (typeof a2 === "function")
          return te(a2) ? 1 : 0;
        if (a2 !== void 0 && a2 !== null) {
          a2 = a2.$$typeof;
          if (a2 === la)
            return 11;
          if (a2 === oa)
            return 14;
        }
        return 2;
      }
      function fd(a2, b2) {
        var c2 = a2.alternate;
        c2 === null ? (c2 = he(a2.tag, b2, a2.key, a2.mode), c2.elementType = a2.elementType, c2.type = a2.type, c2.stateNode = a2.stateNode, c2.alternate = a2, a2.alternate = c2) : (c2.pendingProps = b2, c2.effectTag = 0, c2.nextEffect = null, c2.firstEffect = null, c2.lastEffect = null);
        c2.childExpirationTime = a2.childExpirationTime;
        c2.expirationTime = a2.expirationTime;
        c2.child = a2.child;
        c2.memoizedProps = a2.memoizedProps;
        c2.memoizedState = a2.memoizedState;
        c2.updateQueue = a2.updateQueue;
        b2 = a2.dependencies;
        c2.dependencies = b2 === null ? null : {
          expirationTime: b2.expirationTime,
          firstContext: b2.firstContext,
          responders: b2.responders
        };
        c2.sibling = a2.sibling;
        c2.index = a2.index;
        c2.ref = a2.ref;
        return c2;
      }
      function hd(a2, b2, c2, d, e2, f) {
        var g2 = 2;
        d = a2;
        if (typeof a2 === "function")
          te(a2) && (g2 = 1);
        else if (typeof a2 === "string")
          g2 = 5;
        else
          a:
            switch (a2) {
              case ea:
                return jd(c2.children, e2, f, b2);
              case ka:
                g2 = 8;
                e2 |= 7;
                break;
              case fa:
                g2 = 8;
                e2 |= 1;
                break;
              case ha:
                return a2 = he(12, c2, b2, e2 | 8), a2.elementType = ha, a2.type = ha, a2.expirationTime = f, a2;
              case ma:
                return a2 = he(13, c2, b2, e2), a2.type = ma, a2.elementType = ma, a2.expirationTime = f, a2;
              case na:
                return a2 = he(19, c2, b2, e2), a2.elementType = na, a2.expirationTime = f, a2;
              default:
                if (typeof a2 === "object" && a2 !== null)
                  switch (a2.$$typeof) {
                    case ia:
                      g2 = 10;
                      break a;
                    case ja:
                      g2 = 9;
                      break a;
                    case la:
                      g2 = 11;
                      break a;
                    case oa:
                      g2 = 14;
                      break a;
                    case pa:
                      g2 = 16;
                      d = null;
                      break a;
                  }
                throw Error(n2(130, a2 == null ? a2 : typeof a2, ""));
            }
        b2 = he(g2, c2, b2, e2);
        b2.elementType = a2;
        b2.type = d;
        b2.expirationTime = f;
        return b2;
      }
      function jd(a2, b2, c2, d) {
        a2 = he(7, a2, d, b2);
        a2.expirationTime = c2;
        return a2;
      }
      function gd(a2, b2, c2) {
        a2 = he(6, a2, null, b2);
        a2.expirationTime = c2;
        return a2;
      }
      function id(a2, b2, c2) {
        b2 = he(4, a2.children !== null ? a2.children : [], a2.key, b2);
        b2.expirationTime = c2;
        b2.stateNode = { containerInfo: a2.containerInfo, pendingChildren: null, implementation: a2.implementation };
        return b2;
      }
      function rg(a2, b2, c2) {
        this.tag = b2;
        this.current = null;
        this.containerInfo = a2;
        this.pingCache = this.pendingChildren = null;
        this.finishedExpirationTime = 0;
        this.finishedWork = null;
        this.timeoutHandle = Oa;
        this.pendingContext = this.context = null;
        this.hydrate = c2;
        this.callbackNode = null;
        this.callbackPriority = 90;
        this.lastExpiredTime = this.lastPingedTime = this.nextKnownPendingLevel = this.lastSuspendedTime = this.firstSuspendedTime = this.firstPendingTime = 0;
      }
      function Sf(a2, b2) {
        var c2 = a2.firstSuspendedTime;
        a2 = a2.lastSuspendedTime;
        return c2 !== 0 && c2 >= b2 && a2 <= b2;
      }
      function Pf(a2, b2) {
        var c2 = a2.firstSuspendedTime, d = a2.lastSuspendedTime;
        c2 < b2 && (a2.firstSuspendedTime = b2);
        if (d > b2 || c2 === 0)
          a2.lastSuspendedTime = b2;
        b2 <= a2.lastPingedTime && (a2.lastPingedTime = 0);
        b2 <= a2.lastExpiredTime && (a2.lastExpiredTime = 0);
      }
      function Qf(a2, b2) {
        b2 > a2.firstPendingTime && (a2.firstPendingTime = b2);
        var c2 = a2.firstSuspendedTime;
        c2 !== 0 && (b2 >= c2 ? a2.firstSuspendedTime = a2.lastSuspendedTime = a2.nextKnownPendingLevel = 0 : b2 >= a2.lastSuspendedTime && (a2.lastSuspendedTime = b2 + 1), b2 > a2.nextKnownPendingLevel && (a2.nextKnownPendingLevel = b2));
      }
      function Uf(a2, b2) {
        var c2 = a2.lastExpiredTime;
        if (c2 === 0 || c2 > b2)
          a2.lastExpiredTime = b2;
      }
      function sg(a2) {
        var b2 = a2._reactInternalFiber;
        if (b2 === void 0) {
          if (typeof a2.render === "function")
            throw Error(n2(188));
          throw Error(n2(268, Object.keys(a2)));
        }
        a2 = xa(b2);
        return a2 === null ? null : a2.stateNode;
      }
      function tg(a2, b2) {
        a2 = a2.memoizedState;
        a2 !== null && a2.dehydrated !== null && a2.retryTime < b2 && (a2.retryTime = b2);
      }
      function ug(a2, b2) {
        tg(a2, b2);
        (a2 = a2.alternate) && tg(a2, b2);
      }
      var vg = { createContainer: function(a2, b2, c2) {
        a2 = new rg(a2, b2, c2);
        b2 = he(3, null, null, b2 === 2 ? 7 : b2 === 1 ? 3 : 0);
        a2.current = b2;
        return b2.stateNode = a2;
      }, updateContainer: function(a2, b2, c2, d) {
        var e2 = b2.current, f = G(), g2 = Sc.suspense;
        f = Vc(f, e2, g2);
        a:
          if (c2) {
            c2 = c2._reactInternalFiber;
            b: {
              if (ua(c2) !== c2 || c2.tag !== 1)
                throw Error(n2(170));
              var l2 = c2;
              do {
                switch (l2.tag) {
                  case 3:
                    l2 = l2.stateNode.context;
                    break b;
                  case 1:
                    if (C(l2.type)) {
                      l2 = l2.stateNode.__reactInternalMemoizedMergedChildContext;
                      break b;
                    }
                }
                l2 = l2.return;
              } while (l2 !== null);
              throw Error(n2(171));
            }
            if (c2.tag === 1) {
              var h = c2.type;
              if (C(h)) {
                c2 = Jb(c2, h, l2);
                break a;
              }
            }
            c2 = l2;
          } else
            c2 = Db;
        b2.context === null ? b2.context = c2 : b2.pendingContext = c2;
        b2 = Gc(f, g2);
        b2.payload = { element: a2 };
        d = d === void 0 ? null : d;
        d !== null && (b2.callback = d);
        Ic(e2, b2);
        Wc(e2, f);
        return f;
      }, batchedEventUpdates: function(a2, b2) {
        var c2 = T;
        T |= 2;
        try {
          return a2(b2);
        } finally {
          T = c2, T === R && F();
        }
      }, batchedUpdates: function(a2, b2) {
        var c2 = T;
        T |= 1;
        try {
          return a2(b2);
        } finally {
          T = c2, T === R && F();
        }
      }, unbatchedUpdates: function(a2, b2) {
        var c2 = T;
        T &= -2;
        T |= rf;
        try {
          return a2(b2);
        } finally {
          T = c2, T === R && F();
        }
      }, deferredUpdates: function(a2) {
        return hc(97, a2);
      }, syncUpdates: function(a2, b2, c2, d) {
        return hc(99, a2.bind(null, b2, c2, d));
      }, discreteUpdates: function(a2, b2, c2, d) {
        var e2 = T;
        T |= 4;
        try {
          return hc(98, a2.bind(null, b2, c2, d));
        } finally {
          T = e2, T === R && F();
        }
      }, flushDiscreteUpdates: function() {
        (T & (1 | S | sf)) === R && (dg(), Vf());
      }, flushControlled: function(a2) {
        var b2 = T;
        T |= 1;
        try {
          hc(99, a2);
        } finally {
          T = b2, T === R && F();
        }
      }, flushSync: eg, flushPassiveEffects: Vf, IsThisRendererActing: { current: false }, getPublicRootInstance: function(a2) {
        a2 = a2.current;
        if (!a2.child)
          return null;
        switch (a2.child.tag) {
          case 5:
            return za(a2.child.stateNode);
          default:
            return a2.child.stateNode;
        }
      }, attemptSynchronousHydration: function(a2) {
        switch (a2.tag) {
          case 3:
            var b2 = a2.stateNode;
            b2.hydrate && cg(b2, b2.firstPendingTime);
            break;
          case 13:
            eg(function() {
              return Wc(a2, 1073741823);
            }), b2 = mc(G(), 150, 100), ug(a2, b2);
        }
      }, attemptUserBlockingHydration: function(a2) {
        if (a2.tag === 13) {
          var b2 = mc(G(), 150, 100);
          Wc(a2, b2);
          ug(a2, b2);
        }
      }, attemptContinuousHydration: function(a2) {
        if (a2.tag === 13) {
          G();
          var b2 = lc++;
          Wc(a2, b2);
          ug(a2, b2);
        }
      }, attemptHydrationAtCurrentPriority: function(a2) {
        if (a2.tag === 13) {
          var b2 = G();
          b2 = Vc(b2, a2, null);
          Wc(a2, b2);
          ug(a2, b2);
        }
      }, findHostInstance: sg, findHostInstanceWithWarning: function(a2) {
        return sg(a2);
      }, findHostInstanceWithNoPortals: function(a2) {
        a2 = ya(a2);
        return a2 === null ? null : a2.tag === 20 ? a2.stateNode.instance : a2.stateNode;
      }, shouldSuspend: function() {
        return false;
      }, injectIntoDevTools: function(a2) {
        var b2 = a2.findFiberByHostInstance;
        return pg(aa({}, a2, { overrideHookState: null, overrideProps: null, setSuspenseHandler: null, scheduleUpdate: null, currentDispatcherRef: q.ReactCurrentDispatcher, findHostInstanceByFiber: function(a3) {
          a3 = xa(a3);
          return a3 === null ? null : a3.stateNode;
        }, findFiberByHostInstance: function(a3) {
          return b2 ? b2(a3) : null;
        }, findHostInstancesForRefresh: null, scheduleRefresh: null, scheduleRoot: null, setRefreshHandler: null, getCurrentFiber: null }));
      } };
      module2.exports = vg.default || vg;
      var $$$renderer = module2.exports;
      module2.exports = $$$reconciler;
      return $$$renderer;
    };
  }
});

// node_modules/scheduler/cjs/scheduler-tracing.production.min.js
var require_scheduler_tracing_production_min = __commonJS({
  "node_modules/scheduler/cjs/scheduler-tracing.production.min.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var b2 = 0;
    exports2.__interactionsRef = null;
    exports2.__subscriberRef = null;
    exports2.unstable_clear = function(a2) {
      return a2();
    };
    exports2.unstable_getCurrent = function() {
      return null;
    };
    exports2.unstable_getThreadID = function() {
      return ++b2;
    };
    exports2.unstable_trace = function(a2, d, c2) {
      return c2();
    };
    exports2.unstable_wrap = function(a2) {
      return a2;
    };
    exports2.unstable_subscribe = function() {
    };
    exports2.unstable_unsubscribe = function() {
    };
  }
});

// node_modules/scheduler/cjs/scheduler-tracing.development.js
var require_scheduler_tracing_development = __commonJS({
  "node_modules/scheduler/cjs/scheduler-tracing.development.js"(exports2) {
    "use strict";
    if (process.env.NODE_ENV !== "production") {
      (function() {
        "use strict";
        Object.defineProperty(exports2, "__esModule", { value: true });
        var enableSchedulerTracing = true;
        var DEFAULT_THREAD_ID = 0;
        var interactionIDCounter = 0;
        var threadIDCounter = 0;
        exports2.__interactionsRef = null;
        exports2.__subscriberRef = null;
        if (enableSchedulerTracing) {
          exports2.__interactionsRef = {
            current: /* @__PURE__ */ new Set()
          };
          exports2.__subscriberRef = {
            current: null
          };
        }
        function unstable_clear(callback) {
          if (!enableSchedulerTracing) {
            return callback();
          }
          var prevInteractions = exports2.__interactionsRef.current;
          exports2.__interactionsRef.current = /* @__PURE__ */ new Set();
          try {
            return callback();
          } finally {
            exports2.__interactionsRef.current = prevInteractions;
          }
        }
        function unstable_getCurrent() {
          if (!enableSchedulerTracing) {
            return null;
          } else {
            return exports2.__interactionsRef.current;
          }
        }
        function unstable_getThreadID() {
          return ++threadIDCounter;
        }
        function unstable_trace(name, timestamp2, callback) {
          var threadID = arguments.length > 3 && arguments[3] !== void 0 ? arguments[3] : DEFAULT_THREAD_ID;
          if (!enableSchedulerTracing) {
            return callback();
          }
          var interaction = {
            __count: 1,
            id: interactionIDCounter++,
            name,
            timestamp: timestamp2
          };
          var prevInteractions = exports2.__interactionsRef.current;
          var interactions = new Set(prevInteractions);
          interactions.add(interaction);
          exports2.__interactionsRef.current = interactions;
          var subscriber = exports2.__subscriberRef.current;
          var returnValue;
          try {
            if (subscriber !== null) {
              subscriber.onInteractionTraced(interaction);
            }
          } finally {
            try {
              if (subscriber !== null) {
                subscriber.onWorkStarted(interactions, threadID);
              }
            } finally {
              try {
                returnValue = callback();
              } finally {
                exports2.__interactionsRef.current = prevInteractions;
                try {
                  if (subscriber !== null) {
                    subscriber.onWorkStopped(interactions, threadID);
                  }
                } finally {
                  interaction.__count--;
                  if (subscriber !== null && interaction.__count === 0) {
                    subscriber.onInteractionScheduledWorkCompleted(interaction);
                  }
                }
              }
            }
          }
          return returnValue;
        }
        function unstable_wrap(callback) {
          var threadID = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : DEFAULT_THREAD_ID;
          if (!enableSchedulerTracing) {
            return callback;
          }
          var wrappedInteractions = exports2.__interactionsRef.current;
          var subscriber = exports2.__subscriberRef.current;
          if (subscriber !== null) {
            subscriber.onWorkScheduled(wrappedInteractions, threadID);
          }
          wrappedInteractions.forEach(function(interaction) {
            interaction.__count++;
          });
          var hasRun = false;
          function wrapped() {
            var prevInteractions = exports2.__interactionsRef.current;
            exports2.__interactionsRef.current = wrappedInteractions;
            subscriber = exports2.__subscriberRef.current;
            try {
              var returnValue;
              try {
                if (subscriber !== null) {
                  subscriber.onWorkStarted(wrappedInteractions, threadID);
                }
              } finally {
                try {
                  returnValue = callback.apply(void 0, arguments);
                } finally {
                  exports2.__interactionsRef.current = prevInteractions;
                  if (subscriber !== null) {
                    subscriber.onWorkStopped(wrappedInteractions, threadID);
                  }
                }
              }
              return returnValue;
            } finally {
              if (!hasRun) {
                hasRun = true;
                wrappedInteractions.forEach(function(interaction) {
                  interaction.__count--;
                  if (subscriber !== null && interaction.__count === 0) {
                    subscriber.onInteractionScheduledWorkCompleted(interaction);
                  }
                });
              }
            }
          }
          wrapped.cancel = function cancel() {
            subscriber = exports2.__subscriberRef.current;
            try {
              if (subscriber !== null) {
                subscriber.onWorkCanceled(wrappedInteractions, threadID);
              }
            } finally {
              wrappedInteractions.forEach(function(interaction) {
                interaction.__count--;
                if (subscriber && interaction.__count === 0) {
                  subscriber.onInteractionScheduledWorkCompleted(interaction);
                }
              });
            }
          };
          return wrapped;
        }
        var subscribers = null;
        if (enableSchedulerTracing) {
          subscribers = /* @__PURE__ */ new Set();
        }
        function unstable_subscribe(subscriber) {
          if (enableSchedulerTracing) {
            subscribers.add(subscriber);
            if (subscribers.size === 1) {
              exports2.__subscriberRef.current = {
                onInteractionScheduledWorkCompleted,
                onInteractionTraced,
                onWorkCanceled,
                onWorkScheduled,
                onWorkStarted,
                onWorkStopped
              };
            }
          }
        }
        function unstable_unsubscribe(subscriber) {
          if (enableSchedulerTracing) {
            subscribers.delete(subscriber);
            if (subscribers.size === 0) {
              exports2.__subscriberRef.current = null;
            }
          }
        }
        function onInteractionTraced(interaction) {
          var didCatchError = false;
          var caughtError = null;
          subscribers.forEach(function(subscriber) {
            try {
              subscriber.onInteractionTraced(interaction);
            } catch (error) {
              if (!didCatchError) {
                didCatchError = true;
                caughtError = error;
              }
            }
          });
          if (didCatchError) {
            throw caughtError;
          }
        }
        function onInteractionScheduledWorkCompleted(interaction) {
          var didCatchError = false;
          var caughtError = null;
          subscribers.forEach(function(subscriber) {
            try {
              subscriber.onInteractionScheduledWorkCompleted(interaction);
            } catch (error) {
              if (!didCatchError) {
                didCatchError = true;
                caughtError = error;
              }
            }
          });
          if (didCatchError) {
            throw caughtError;
          }
        }
        function onWorkScheduled(interactions, threadID) {
          var didCatchError = false;
          var caughtError = null;
          subscribers.forEach(function(subscriber) {
            try {
              subscriber.onWorkScheduled(interactions, threadID);
            } catch (error) {
              if (!didCatchError) {
                didCatchError = true;
                caughtError = error;
              }
            }
          });
          if (didCatchError) {
            throw caughtError;
          }
        }
        function onWorkStarted(interactions, threadID) {
          var didCatchError = false;
          var caughtError = null;
          subscribers.forEach(function(subscriber) {
            try {
              subscriber.onWorkStarted(interactions, threadID);
            } catch (error) {
              if (!didCatchError) {
                didCatchError = true;
                caughtError = error;
              }
            }
          });
          if (didCatchError) {
            throw caughtError;
          }
        }
        function onWorkStopped(interactions, threadID) {
          var didCatchError = false;
          var caughtError = null;
          subscribers.forEach(function(subscriber) {
            try {
              subscriber.onWorkStopped(interactions, threadID);
            } catch (error) {
              if (!didCatchError) {
                didCatchError = true;
                caughtError = error;
              }
            }
          });
          if (didCatchError) {
            throw caughtError;
          }
        }
        function onWorkCanceled(interactions, threadID) {
          var didCatchError = false;
          var caughtError = null;
          subscribers.forEach(function(subscriber) {
            try {
              subscriber.onWorkCanceled(interactions, threadID);
            } catch (error) {
              if (!didCatchError) {
                didCatchError = true;
                caughtError = error;
              }
            }
          });
          if (didCatchError) {
            throw caughtError;
          }
        }
        exports2.unstable_clear = unstable_clear;
        exports2.unstable_getCurrent = unstable_getCurrent;
        exports2.unstable_getThreadID = unstable_getThreadID;
        exports2.unstable_trace = unstable_trace;
        exports2.unstable_wrap = unstable_wrap;
        exports2.unstable_subscribe = unstable_subscribe;
        exports2.unstable_unsubscribe = unstable_unsubscribe;
      })();
    }
  }
});

// node_modules/scheduler/tracing.js
var require_tracing = __commonJS({
  "node_modules/scheduler/tracing.js"(exports2, module2) {
    "use strict";
    if (process.env.NODE_ENV === "production") {
      module2.exports = require_scheduler_tracing_production_min();
    } else {
      module2.exports = require_scheduler_tracing_development();
    }
  }
});

// node_modules/ink/node_modules/react-reconciler/cjs/react-reconciler.development.js
var require_react_reconciler_development = __commonJS({
  "node_modules/ink/node_modules/react-reconciler/cjs/react-reconciler.development.js"(exports2, module2) {
    "use strict";
    if (process.env.NODE_ENV !== "production") {
      module2.exports = function $$$reconciler($$$hostConfig) {
        "use strict";
        var _assign = require_object_assign();
        var React7 = require_react();
        var checkPropTypes = require_checkPropTypes();
        var Scheduler = require_scheduler();
        var tracing = require_tracing();
        var FunctionComponent = 0;
        var ClassComponent = 1;
        var IndeterminateComponent = 2;
        var HostRoot = 3;
        var HostPortal = 4;
        var HostComponent = 5;
        var HostText = 6;
        var Fragment = 7;
        var Mode = 8;
        var ContextConsumer = 9;
        var ContextProvider = 10;
        var ForwardRef = 11;
        var Profiler = 12;
        var SuspenseComponent = 13;
        var MemoComponent = 14;
        var SimpleMemoComponent = 15;
        var LazyComponent = 16;
        var IncompleteClassComponent = 17;
        var DehydratedFragment = 18;
        var SuspenseListComponent = 19;
        var FundamentalComponent = 20;
        var ScopeComponent = 21;
        var warningWithoutStack = function() {
        };
        {
          warningWithoutStack = function(condition, format) {
            for (var _len = arguments.length, args = new Array(_len > 2 ? _len - 2 : 0), _key = 2; _key < _len; _key++) {
              args[_key - 2] = arguments[_key];
            }
            if (format === void 0) {
              throw new Error("`warningWithoutStack(condition, format, ...args)` requires a warning message argument");
            }
            if (args.length > 8) {
              throw new Error("warningWithoutStack() currently supports at most 8 arguments.");
            }
            if (condition) {
              return;
            }
            if (typeof console !== "undefined") {
              var argsWithFormat = args.map(function(item) {
                return "" + item;
              });
              argsWithFormat.unshift("Warning: " + format);
              Function.prototype.apply.call(console.error, console, argsWithFormat);
            }
            try {
              var argIndex = 0;
              var message = "Warning: " + format.replace(/%s/g, function() {
                return args[argIndex++];
              });
              throw new Error(message);
            } catch (x) {
            }
          };
        }
        var warningWithoutStack$1 = warningWithoutStack;
        function get(key2) {
          return key2._reactInternalFiber;
        }
        function set2(key2, value) {
          key2._reactInternalFiber = value;
        }
        var ReactSharedInternals = React7.__SECRET_INTERNALS_DO_NOT_USE_OR_YOU_WILL_BE_FIRED;
        if (!ReactSharedInternals.hasOwnProperty("ReactCurrentDispatcher")) {
          ReactSharedInternals.ReactCurrentDispatcher = {
            current: null
          };
        }
        if (!ReactSharedInternals.hasOwnProperty("ReactCurrentBatchConfig")) {
          ReactSharedInternals.ReactCurrentBatchConfig = {
            suspense: null
          };
        }
        var hasSymbol = typeof Symbol === "function" && Symbol.for;
        var REACT_ELEMENT_TYPE = hasSymbol ? Symbol.for("react.element") : 60103;
        var REACT_PORTAL_TYPE = hasSymbol ? Symbol.for("react.portal") : 60106;
        var REACT_FRAGMENT_TYPE = hasSymbol ? Symbol.for("react.fragment") : 60107;
        var REACT_STRICT_MODE_TYPE = hasSymbol ? Symbol.for("react.strict_mode") : 60108;
        var REACT_PROFILER_TYPE = hasSymbol ? Symbol.for("react.profiler") : 60114;
        var REACT_PROVIDER_TYPE = hasSymbol ? Symbol.for("react.provider") : 60109;
        var REACT_CONTEXT_TYPE = hasSymbol ? Symbol.for("react.context") : 60110;
        var REACT_CONCURRENT_MODE_TYPE = hasSymbol ? Symbol.for("react.concurrent_mode") : 60111;
        var REACT_FORWARD_REF_TYPE = hasSymbol ? Symbol.for("react.forward_ref") : 60112;
        var REACT_SUSPENSE_TYPE = hasSymbol ? Symbol.for("react.suspense") : 60113;
        var REACT_SUSPENSE_LIST_TYPE = hasSymbol ? Symbol.for("react.suspense_list") : 60120;
        var REACT_MEMO_TYPE = hasSymbol ? Symbol.for("react.memo") : 60115;
        var REACT_LAZY_TYPE = hasSymbol ? Symbol.for("react.lazy") : 60116;
        var REACT_FUNDAMENTAL_TYPE = hasSymbol ? Symbol.for("react.fundamental") : 60117;
        var REACT_RESPONDER_TYPE = hasSymbol ? Symbol.for("react.responder") : 60118;
        var REACT_SCOPE_TYPE = hasSymbol ? Symbol.for("react.scope") : 60119;
        var MAYBE_ITERATOR_SYMBOL = typeof Symbol === "function" && Symbol.iterator;
        var FAUX_ITERATOR_SYMBOL = "@@iterator";
        function getIteratorFn(maybeIterable) {
          if (maybeIterable === null || typeof maybeIterable !== "object") {
            return null;
          }
          var maybeIterator = MAYBE_ITERATOR_SYMBOL && maybeIterable[MAYBE_ITERATOR_SYMBOL] || maybeIterable[FAUX_ITERATOR_SYMBOL];
          if (typeof maybeIterator === "function") {
            return maybeIterator;
          }
          return null;
        }
        var warning = warningWithoutStack$1;
        {
          warning = function(condition, format) {
            if (condition) {
              return;
            }
            var ReactDebugCurrentFrame2 = ReactSharedInternals.ReactDebugCurrentFrame;
            var stack = ReactDebugCurrentFrame2.getStackAddendum();
            for (var _len = arguments.length, args = new Array(_len > 2 ? _len - 2 : 0), _key = 2; _key < _len; _key++) {
              args[_key - 2] = arguments[_key];
            }
            warningWithoutStack$1.apply(void 0, [false, format + "%s"].concat(args, [stack]));
          };
        }
        var warning$1 = warning;
        var Uninitialized = -1;
        var Pending = 0;
        var Resolved = 1;
        var Rejected = 2;
        function refineResolvedLazyComponent(lazyComponent) {
          return lazyComponent._status === Resolved ? lazyComponent._result : null;
        }
        function initializeLazyComponentType(lazyComponent) {
          if (lazyComponent._status === Uninitialized) {
            lazyComponent._status = Pending;
            var ctor = lazyComponent._ctor;
            var thenable = ctor();
            lazyComponent._result = thenable;
            thenable.then(function(moduleObject) {
              if (lazyComponent._status === Pending) {
                var defaultExport = moduleObject.default;
                {
                  if (defaultExport === void 0) {
                    warning$1(false, "lazy: Expected the result of a dynamic import() call. Instead received: %s\n\nYour code should look like: \n  const MyComponent = lazy(() => import('./MyComponent'))", moduleObject);
                  }
                }
                lazyComponent._status = Resolved;
                lazyComponent._result = defaultExport;
              }
            }, function(error) {
              if (lazyComponent._status === Pending) {
                lazyComponent._status = Rejected;
                lazyComponent._result = error;
              }
            });
          }
        }
        function getWrappedName(outerType, innerType, wrapperName) {
          var functionName = innerType.displayName || innerType.name || "";
          return outerType.displayName || (functionName !== "" ? wrapperName + "(" + functionName + ")" : wrapperName);
        }
        function getComponentName(type3) {
          if (type3 == null) {
            return null;
          }
          {
            if (typeof type3.tag === "number") {
              warningWithoutStack$1(false, "Received an unexpected object in getComponentName(). This is likely a bug in React. Please file an issue.");
            }
          }
          if (typeof type3 === "function") {
            return type3.displayName || type3.name || null;
          }
          if (typeof type3 === "string") {
            return type3;
          }
          switch (type3) {
            case REACT_FRAGMENT_TYPE:
              return "Fragment";
            case REACT_PORTAL_TYPE:
              return "Portal";
            case REACT_PROFILER_TYPE:
              return "Profiler";
            case REACT_STRICT_MODE_TYPE:
              return "StrictMode";
            case REACT_SUSPENSE_TYPE:
              return "Suspense";
            case REACT_SUSPENSE_LIST_TYPE:
              return "SuspenseList";
          }
          if (typeof type3 === "object") {
            switch (type3.$$typeof) {
              case REACT_CONTEXT_TYPE:
                return "Context.Consumer";
              case REACT_PROVIDER_TYPE:
                return "Context.Provider";
              case REACT_FORWARD_REF_TYPE:
                return getWrappedName(type3, type3.render, "ForwardRef");
              case REACT_MEMO_TYPE:
                return getComponentName(type3.type);
              case REACT_LAZY_TYPE: {
                var thenable = type3;
                var resolvedThenable = refineResolvedLazyComponent(thenable);
                if (resolvedThenable) {
                  return getComponentName(resolvedThenable);
                }
                break;
              }
            }
          }
          return null;
        }
        var NoEffect = 0;
        var PerformedWork = 1;
        var Placement = 2;
        var Update = 4;
        var PlacementAndUpdate = 6;
        var Deletion = 8;
        var ContentReset = 16;
        var Callback = 32;
        var DidCapture = 64;
        var Ref = 128;
        var Snapshot = 256;
        var Passive = 512;
        var Hydrating = 1024;
        var HydratingAndUpdate = 1028;
        var LifecycleEffectMask = 932;
        var HostEffectMask = 2047;
        var Incomplete = 2048;
        var ShouldCapture = 4096;
        var enableUserTimingAPI = true;
        var debugRenderPhaseSideEffectsForStrictMode = true;
        var replayFailedUnitOfWorkWithInvokeGuardedCallback = true;
        var warnAboutDeprecatedLifecycles = true;
        var enableProfilerTimer = true;
        var enableSchedulerTracing = true;
        var enableSuspenseServerRenderer = false;
        var enableFlareAPI = false;
        var enableFundamentalAPI = false;
        var enableScopeAPI = false;
        var warnAboutUnmockedScheduler = false;
        var flushSuspenseFallbacksInTests = true;
        var enableSuspenseCallback = false;
        var warnAboutDefaultPropsOnFunctionComponents = false;
        var warnAboutStringRefs = false;
        var disableLegacyContext = false;
        var disableSchedulerTimeoutBasedOnReactExpirationTime = false;
        var ReactCurrentOwner = ReactSharedInternals.ReactCurrentOwner;
        function getNearestMountedFiber(fiber) {
          var node = fiber;
          var nearestMounted = fiber;
          if (!fiber.alternate) {
            var nextNode = node;
            do {
              node = nextNode;
              if ((node.effectTag & (Placement | Hydrating)) !== NoEffect) {
                nearestMounted = node.return;
              }
              nextNode = node.return;
            } while (nextNode);
          } else {
            while (node.return) {
              node = node.return;
            }
          }
          if (node.tag === HostRoot) {
            return nearestMounted;
          }
          return null;
        }
        function isFiberMounted(fiber) {
          return getNearestMountedFiber(fiber) === fiber;
        }
        function isMounted(component) {
          {
            var owner = ReactCurrentOwner.current;
            if (owner !== null && owner.tag === ClassComponent) {
              var ownerFiber = owner;
              var instance = ownerFiber.stateNode;
              !instance._warnedAboutRefsInRender ? warningWithoutStack$1(false, "%s is accessing isMounted inside its render() function. render() should be a pure function of props and state. It should never access something that requires stale data from the previous render, such as refs. Move this logic to componentDidMount and componentDidUpdate instead.", getComponentName(ownerFiber.type) || "A component") : void 0;
              instance._warnedAboutRefsInRender = true;
            }
          }
          var fiber = get(component);
          if (!fiber) {
            return false;
          }
          return getNearestMountedFiber(fiber) === fiber;
        }
        function assertIsMounted(fiber) {
          if (!(getNearestMountedFiber(fiber) === fiber)) {
            {
              throw Error("Unable to find node on an unmounted component.");
            }
          }
        }
        function findCurrentFiberUsingSlowPath(fiber) {
          var alternate = fiber.alternate;
          if (!alternate) {
            var nearestMounted = getNearestMountedFiber(fiber);
            if (!(nearestMounted !== null)) {
              {
                throw Error("Unable to find node on an unmounted component.");
              }
            }
            if (nearestMounted !== fiber) {
              return null;
            }
            return fiber;
          }
          var a2 = fiber;
          var b2 = alternate;
          while (true) {
            var parentA = a2.return;
            if (parentA === null) {
              break;
            }
            var parentB = parentA.alternate;
            if (parentB === null) {
              var nextParent = parentA.return;
              if (nextParent !== null) {
                a2 = b2 = nextParent;
                continue;
              }
              break;
            }
            if (parentA.child === parentB.child) {
              var child = parentA.child;
              while (child) {
                if (child === a2) {
                  assertIsMounted(parentA);
                  return fiber;
                }
                if (child === b2) {
                  assertIsMounted(parentA);
                  return alternate;
                }
                child = child.sibling;
              }
              {
                {
                  throw Error("Unable to find node on an unmounted component.");
                }
              }
            }
            if (a2.return !== b2.return) {
              a2 = parentA;
              b2 = parentB;
            } else {
              var didFindChild = false;
              var _child = parentA.child;
              while (_child) {
                if (_child === a2) {
                  didFindChild = true;
                  a2 = parentA;
                  b2 = parentB;
                  break;
                }
                if (_child === b2) {
                  didFindChild = true;
                  b2 = parentA;
                  a2 = parentB;
                  break;
                }
                _child = _child.sibling;
              }
              if (!didFindChild) {
                _child = parentB.child;
                while (_child) {
                  if (_child === a2) {
                    didFindChild = true;
                    a2 = parentB;
                    b2 = parentA;
                    break;
                  }
                  if (_child === b2) {
                    didFindChild = true;
                    b2 = parentB;
                    a2 = parentA;
                    break;
                  }
                  _child = _child.sibling;
                }
                if (!didFindChild) {
                  {
                    throw Error("Child was not found in either parent set. This indicates a bug in React related to the return pointer. Please file an issue.");
                  }
                }
              }
            }
            if (!(a2.alternate === b2)) {
              {
                throw Error("Return fibers should always be each others' alternates. This error is likely caused by a bug in React. Please file an issue.");
              }
            }
          }
          if (!(a2.tag === HostRoot)) {
            {
              throw Error("Unable to find node on an unmounted component.");
            }
          }
          if (a2.stateNode.current === a2) {
            return fiber;
          }
          return alternate;
        }
        function findCurrentHostFiber(parent) {
          var currentParent = findCurrentFiberUsingSlowPath(parent);
          if (!currentParent) {
            return null;
          }
          var node = currentParent;
          while (true) {
            if (node.tag === HostComponent || node.tag === HostText) {
              return node;
            } else if (node.child) {
              node.child.return = node;
              node = node.child;
              continue;
            }
            if (node === currentParent) {
              return null;
            }
            while (!node.sibling) {
              if (!node.return || node.return === currentParent) {
                return null;
              }
              node = node.return;
            }
            node.sibling.return = node.return;
            node = node.sibling;
          }
          return null;
        }
        function findCurrentHostFiberWithNoPortals(parent) {
          var currentParent = findCurrentFiberUsingSlowPath(parent);
          if (!currentParent) {
            return null;
          }
          var node = currentParent;
          while (true) {
            if (node.tag === HostComponent || node.tag === HostText || enableFundamentalAPI && node.tag === FundamentalComponent) {
              return node;
            } else if (node.child && node.tag !== HostPortal) {
              node.child.return = node;
              node = node.child;
              continue;
            }
            if (node === currentParent) {
              return null;
            }
            while (!node.sibling) {
              if (!node.return || node.return === currentParent) {
                return null;
              }
              node = node.return;
            }
            node.sibling.return = node.return;
            node = node.sibling;
          }
          return null;
        }
        var getPublicInstance = $$$hostConfig.getPublicInstance;
        var getRootHostContext = $$$hostConfig.getRootHostContext;
        var getChildHostContext = $$$hostConfig.getChildHostContext;
        var prepareForCommit = $$$hostConfig.prepareForCommit;
        var resetAfterCommit = $$$hostConfig.resetAfterCommit;
        var createInstance = $$$hostConfig.createInstance;
        var appendInitialChild = $$$hostConfig.appendInitialChild;
        var finalizeInitialChildren = $$$hostConfig.finalizeInitialChildren;
        var prepareUpdate = $$$hostConfig.prepareUpdate;
        var shouldSetTextContent = $$$hostConfig.shouldSetTextContent;
        var shouldDeprioritizeSubtree = $$$hostConfig.shouldDeprioritizeSubtree;
        var createTextInstance = $$$hostConfig.createTextInstance;
        var scheduleTimeout = $$$hostConfig.setTimeout;
        var cancelTimeout = $$$hostConfig.clearTimeout;
        var noTimeout = $$$hostConfig.noTimeout;
        var now = $$$hostConfig.now;
        var isPrimaryRenderer = $$$hostConfig.isPrimaryRenderer;
        var warnsIfNotActing = $$$hostConfig.warnsIfNotActing;
        var supportsMutation = $$$hostConfig.supportsMutation;
        var supportsPersistence = $$$hostConfig.supportsPersistence;
        var supportsHydration = $$$hostConfig.supportsHydration;
        var mountResponderInstance = $$$hostConfig.mountResponderInstance;
        var unmountResponderInstance = $$$hostConfig.unmountResponderInstance;
        var getFundamentalComponentInstance = $$$hostConfig.getFundamentalComponentInstance;
        var mountFundamentalComponent = $$$hostConfig.mountFundamentalComponent;
        var shouldUpdateFundamentalComponent = $$$hostConfig.shouldUpdateFundamentalComponent;
        var getInstanceFromNode = $$$hostConfig.getInstanceFromNode;
        var appendChild = $$$hostConfig.appendChild;
        var appendChildToContainer = $$$hostConfig.appendChildToContainer;
        var commitTextUpdate = $$$hostConfig.commitTextUpdate;
        var commitMount = $$$hostConfig.commitMount;
        var commitUpdate = $$$hostConfig.commitUpdate;
        var insertBefore = $$$hostConfig.insertBefore;
        var insertInContainerBefore = $$$hostConfig.insertInContainerBefore;
        var removeChild = $$$hostConfig.removeChild;
        var removeChildFromContainer = $$$hostConfig.removeChildFromContainer;
        var resetTextContent = $$$hostConfig.resetTextContent;
        var hideInstance = $$$hostConfig.hideInstance;
        var hideTextInstance = $$$hostConfig.hideTextInstance;
        var unhideInstance = $$$hostConfig.unhideInstance;
        var unhideTextInstance = $$$hostConfig.unhideTextInstance;
        var updateFundamentalComponent = $$$hostConfig.updateFundamentalComponent;
        var unmountFundamentalComponent = $$$hostConfig.unmountFundamentalComponent;
        var cloneInstance = $$$hostConfig.cloneInstance;
        var createContainerChildSet = $$$hostConfig.createContainerChildSet;
        var appendChildToContainerChildSet = $$$hostConfig.appendChildToContainerChildSet;
        var finalizeContainerChildren = $$$hostConfig.finalizeContainerChildren;
        var replaceContainerChildren = $$$hostConfig.replaceContainerChildren;
        var cloneHiddenInstance = $$$hostConfig.cloneHiddenInstance;
        var cloneHiddenTextInstance = $$$hostConfig.cloneHiddenTextInstance;
        var cloneFundamentalInstance = $$$hostConfig.cloneInstance;
        var canHydrateInstance = $$$hostConfig.canHydrateInstance;
        var canHydrateTextInstance = $$$hostConfig.canHydrateTextInstance;
        var canHydrateSuspenseInstance = $$$hostConfig.canHydrateSuspenseInstance;
        var isSuspenseInstancePending = $$$hostConfig.isSuspenseInstancePending;
        var isSuspenseInstanceFallback = $$$hostConfig.isSuspenseInstanceFallback;
        var registerSuspenseInstanceRetry = $$$hostConfig.registerSuspenseInstanceRetry;
        var getNextHydratableSibling = $$$hostConfig.getNextHydratableSibling;
        var getFirstHydratableChild = $$$hostConfig.getFirstHydratableChild;
        var hydrateInstance = $$$hostConfig.hydrateInstance;
        var hydrateTextInstance = $$$hostConfig.hydrateTextInstance;
        var hydrateSuspenseInstance = $$$hostConfig.hydrateSuspenseInstance;
        var getNextHydratableInstanceAfterSuspenseInstance = $$$hostConfig.getNextHydratableInstanceAfterSuspenseInstance;
        var commitHydratedContainer = $$$hostConfig.commitHydratedContainer;
        var commitHydratedSuspenseInstance = $$$hostConfig.commitHydratedSuspenseInstance;
        var clearSuspenseBoundary = $$$hostConfig.clearSuspenseBoundary;
        var clearSuspenseBoundaryFromContainer = $$$hostConfig.clearSuspenseBoundaryFromContainer;
        var didNotMatchHydratedContainerTextInstance = $$$hostConfig.didNotMatchHydratedContainerTextInstance;
        var didNotMatchHydratedTextInstance = $$$hostConfig.didNotMatchHydratedTextInstance;
        var didNotHydrateContainerInstance = $$$hostConfig.didNotHydrateContainerInstance;
        var didNotHydrateInstance = $$$hostConfig.didNotHydrateInstance;
        var didNotFindHydratableContainerInstance = $$$hostConfig.didNotFindHydratableContainerInstance;
        var didNotFindHydratableContainerTextInstance = $$$hostConfig.didNotFindHydratableContainerTextInstance;
        var didNotFindHydratableContainerSuspenseInstance = $$$hostConfig.didNotFindHydratableContainerSuspenseInstance;
        var didNotFindHydratableInstance = $$$hostConfig.didNotFindHydratableInstance;
        var didNotFindHydratableTextInstance = $$$hostConfig.didNotFindHydratableTextInstance;
        var didNotFindHydratableSuspenseInstance = $$$hostConfig.didNotFindHydratableSuspenseInstance;
        var BEFORE_SLASH_RE = /^(.*)[\\\/]/;
        var describeComponentFrame = function(name, source, ownerName) {
          var sourceInfo = "";
          if (source) {
            var path2 = source.fileName;
            var fileName = path2.replace(BEFORE_SLASH_RE, "");
            {
              if (/^index\./.test(fileName)) {
                var match = path2.match(BEFORE_SLASH_RE);
                if (match) {
                  var pathBeforeSlash = match[1];
                  if (pathBeforeSlash) {
                    var folderName = pathBeforeSlash.replace(BEFORE_SLASH_RE, "");
                    fileName = folderName + "/" + fileName;
                  }
                }
              }
            }
            sourceInfo = " (at " + fileName + ":" + source.lineNumber + ")";
          } else if (ownerName) {
            sourceInfo = " (created by " + ownerName + ")";
          }
          return "\n    in " + (name || "Unknown") + sourceInfo;
        };
        var ReactDebugCurrentFrame = ReactSharedInternals.ReactDebugCurrentFrame;
        function describeFiber(fiber) {
          switch (fiber.tag) {
            case HostRoot:
            case HostPortal:
            case HostText:
            case Fragment:
            case ContextProvider:
            case ContextConsumer:
              return "";
            default:
              var owner = fiber._debugOwner;
              var source = fiber._debugSource;
              var name = getComponentName(fiber.type);
              var ownerName = null;
              if (owner) {
                ownerName = getComponentName(owner.type);
              }
              return describeComponentFrame(name, source, ownerName);
          }
        }
        function getStackByFiberInDevAndProd(workInProgress2) {
          var info = "";
          var node = workInProgress2;
          do {
            info += describeFiber(node);
            node = node.return;
          } while (node);
          return info;
        }
        var current = null;
        var phase = null;
        function getCurrentFiberOwnerNameInDevOrNull() {
          {
            if (current === null) {
              return null;
            }
            var owner = current._debugOwner;
            if (owner !== null && typeof owner !== "undefined") {
              return getComponentName(owner.type);
            }
          }
          return null;
        }
        function getCurrentFiberStackInDev() {
          {
            if (current === null) {
              return "";
            }
            return getStackByFiberInDevAndProd(current);
          }
          return "";
        }
        function resetCurrentFiber() {
          {
            ReactDebugCurrentFrame.getCurrentStack = null;
            current = null;
            phase = null;
          }
        }
        function setCurrentFiber(fiber) {
          {
            ReactDebugCurrentFrame.getCurrentStack = getCurrentFiberStackInDev;
            current = fiber;
            phase = null;
          }
        }
        function setCurrentPhase(lifeCyclePhase) {
          {
            phase = lifeCyclePhase;
          }
        }
        var reactEmoji = "\u269B";
        var warningEmoji = "\u26D4";
        var supportsUserTiming = typeof performance !== "undefined" && typeof performance.mark === "function" && typeof performance.clearMarks === "function" && typeof performance.measure === "function" && typeof performance.clearMeasures === "function";
        var currentFiber = null;
        var currentPhase = null;
        var currentPhaseFiber = null;
        var isCommitting = false;
        var hasScheduledUpdateInCurrentCommit = false;
        var hasScheduledUpdateInCurrentPhase = false;
        var commitCountInCurrentWorkLoop = 0;
        var effectCountInCurrentCommit = 0;
        var labelsInCurrentCommit = /* @__PURE__ */ new Set();
        var formatMarkName = function(markName) {
          return reactEmoji + " " + markName;
        };
        var formatLabel = function(label, warning2) {
          var prefix2 = warning2 ? warningEmoji + " " : reactEmoji + " ";
          var suffix = warning2 ? " Warning: " + warning2 : "";
          return "" + prefix2 + label + suffix;
        };
        var beginMark = function(markName) {
          performance.mark(formatMarkName(markName));
        };
        var clearMark = function(markName) {
          performance.clearMarks(formatMarkName(markName));
        };
        var endMark = function(label, markName, warning2) {
          var formattedMarkName = formatMarkName(markName);
          var formattedLabel = formatLabel(label, warning2);
          try {
            performance.measure(formattedLabel, formattedMarkName);
          } catch (err2) {
          }
          performance.clearMarks(formattedMarkName);
          performance.clearMeasures(formattedLabel);
        };
        var getFiberMarkName = function(label, debugID) {
          return label + " (#" + debugID + ")";
        };
        var getFiberLabel = function(componentName, isMounted2, phase2) {
          if (phase2 === null) {
            return componentName + " [" + (isMounted2 ? "update" : "mount") + "]";
          } else {
            return componentName + "." + phase2;
          }
        };
        var beginFiberMark = function(fiber, phase2) {
          var componentName = getComponentName(fiber.type) || "Unknown";
          var debugID = fiber._debugID;
          var isMounted2 = fiber.alternate !== null;
          var label = getFiberLabel(componentName, isMounted2, phase2);
          if (isCommitting && labelsInCurrentCommit.has(label)) {
            return false;
          }
          labelsInCurrentCommit.add(label);
          var markName = getFiberMarkName(label, debugID);
          beginMark(markName);
          return true;
        };
        var clearFiberMark = function(fiber, phase2) {
          var componentName = getComponentName(fiber.type) || "Unknown";
          var debugID = fiber._debugID;
          var isMounted2 = fiber.alternate !== null;
          var label = getFiberLabel(componentName, isMounted2, phase2);
          var markName = getFiberMarkName(label, debugID);
          clearMark(markName);
        };
        var endFiberMark = function(fiber, phase2, warning2) {
          var componentName = getComponentName(fiber.type) || "Unknown";
          var debugID = fiber._debugID;
          var isMounted2 = fiber.alternate !== null;
          var label = getFiberLabel(componentName, isMounted2, phase2);
          var markName = getFiberMarkName(label, debugID);
          endMark(label, markName, warning2);
        };
        var shouldIgnoreFiber = function(fiber) {
          switch (fiber.tag) {
            case HostRoot:
            case HostComponent:
            case HostText:
            case HostPortal:
            case Fragment:
            case ContextProvider:
            case ContextConsumer:
            case Mode:
              return true;
            default:
              return false;
          }
        };
        var clearPendingPhaseMeasurement = function() {
          if (currentPhase !== null && currentPhaseFiber !== null) {
            clearFiberMark(currentPhaseFiber, currentPhase);
          }
          currentPhaseFiber = null;
          currentPhase = null;
          hasScheduledUpdateInCurrentPhase = false;
        };
        var pauseTimers = function() {
          var fiber = currentFiber;
          while (fiber) {
            if (fiber._debugIsCurrentlyTiming) {
              endFiberMark(fiber, null, null);
            }
            fiber = fiber.return;
          }
        };
        var resumeTimersRecursively = function(fiber) {
          if (fiber.return !== null) {
            resumeTimersRecursively(fiber.return);
          }
          if (fiber._debugIsCurrentlyTiming) {
            beginFiberMark(fiber, null);
          }
        };
        var resumeTimers = function() {
          if (currentFiber !== null) {
            resumeTimersRecursively(currentFiber);
          }
        };
        function recordEffect() {
          if (enableUserTimingAPI) {
            effectCountInCurrentCommit++;
          }
        }
        function recordScheduleUpdate() {
          if (enableUserTimingAPI) {
            if (isCommitting) {
              hasScheduledUpdateInCurrentCommit = true;
            }
            if (currentPhase !== null && currentPhase !== "componentWillMount" && currentPhase !== "componentWillReceiveProps") {
              hasScheduledUpdateInCurrentPhase = true;
            }
          }
        }
        function startWorkTimer(fiber) {
          if (enableUserTimingAPI) {
            if (!supportsUserTiming || shouldIgnoreFiber(fiber)) {
              return;
            }
            currentFiber = fiber;
            if (!beginFiberMark(fiber, null)) {
              return;
            }
            fiber._debugIsCurrentlyTiming = true;
          }
        }
        function cancelWorkTimer(fiber) {
          if (enableUserTimingAPI) {
            if (!supportsUserTiming || shouldIgnoreFiber(fiber)) {
              return;
            }
            fiber._debugIsCurrentlyTiming = false;
            clearFiberMark(fiber, null);
          }
        }
        function stopWorkTimer(fiber) {
          if (enableUserTimingAPI) {
            if (!supportsUserTiming || shouldIgnoreFiber(fiber)) {
              return;
            }
            currentFiber = fiber.return;
            if (!fiber._debugIsCurrentlyTiming) {
              return;
            }
            fiber._debugIsCurrentlyTiming = false;
            endFiberMark(fiber, null, null);
          }
        }
        function stopFailedWorkTimer(fiber) {
          if (enableUserTimingAPI) {
            if (!supportsUserTiming || shouldIgnoreFiber(fiber)) {
              return;
            }
            currentFiber = fiber.return;
            if (!fiber._debugIsCurrentlyTiming) {
              return;
            }
            fiber._debugIsCurrentlyTiming = false;
            var warning2 = fiber.tag === SuspenseComponent ? "Rendering was suspended" : "An error was thrown inside this error boundary";
            endFiberMark(fiber, null, warning2);
          }
        }
        function startPhaseTimer(fiber, phase2) {
          if (enableUserTimingAPI) {
            if (!supportsUserTiming) {
              return;
            }
            clearPendingPhaseMeasurement();
            if (!beginFiberMark(fiber, phase2)) {
              return;
            }
            currentPhaseFiber = fiber;
            currentPhase = phase2;
          }
        }
        function stopPhaseTimer() {
          if (enableUserTimingAPI) {
            if (!supportsUserTiming) {
              return;
            }
            if (currentPhase !== null && currentPhaseFiber !== null) {
              var warning2 = hasScheduledUpdateInCurrentPhase ? "Scheduled a cascading update" : null;
              endFiberMark(currentPhaseFiber, currentPhase, warning2);
            }
            currentPhase = null;
            currentPhaseFiber = null;
          }
        }
        function startWorkLoopTimer(nextUnitOfWork) {
          if (enableUserTimingAPI) {
            currentFiber = nextUnitOfWork;
            if (!supportsUserTiming) {
              return;
            }
            commitCountInCurrentWorkLoop = 0;
            beginMark("(React Tree Reconciliation)");
            resumeTimers();
          }
        }
        function stopWorkLoopTimer(interruptedBy2, didCompleteRoot) {
          if (enableUserTimingAPI) {
            if (!supportsUserTiming) {
              return;
            }
            var warning2 = null;
            if (interruptedBy2 !== null) {
              if (interruptedBy2.tag === HostRoot) {
                warning2 = "A top-level update interrupted the previous render";
              } else {
                var componentName = getComponentName(interruptedBy2.type) || "Unknown";
                warning2 = "An update to " + componentName + " interrupted the previous render";
              }
            } else if (commitCountInCurrentWorkLoop > 1) {
              warning2 = "There were cascading updates";
            }
            commitCountInCurrentWorkLoop = 0;
            var label = didCompleteRoot ? "(React Tree Reconciliation: Completed Root)" : "(React Tree Reconciliation: Yielded)";
            pauseTimers();
            endMark(label, "(React Tree Reconciliation)", warning2);
          }
        }
        function startCommitTimer() {
          if (enableUserTimingAPI) {
            if (!supportsUserTiming) {
              return;
            }
            isCommitting = true;
            hasScheduledUpdateInCurrentCommit = false;
            labelsInCurrentCommit.clear();
            beginMark("(Committing Changes)");
          }
        }
        function stopCommitTimer() {
          if (enableUserTimingAPI) {
            if (!supportsUserTiming) {
              return;
            }
            var warning2 = null;
            if (hasScheduledUpdateInCurrentCommit) {
              warning2 = "Lifecycle hook scheduled a cascading update";
            } else if (commitCountInCurrentWorkLoop > 0) {
              warning2 = "Caused by a cascading update in earlier commit";
            }
            hasScheduledUpdateInCurrentCommit = false;
            commitCountInCurrentWorkLoop++;
            isCommitting = false;
            labelsInCurrentCommit.clear();
            endMark("(Committing Changes)", "(Committing Changes)", warning2);
          }
        }
        function startCommitSnapshotEffectsTimer() {
          if (enableUserTimingAPI) {
            if (!supportsUserTiming) {
              return;
            }
            effectCountInCurrentCommit = 0;
            beginMark("(Committing Snapshot Effects)");
          }
        }
        function stopCommitSnapshotEffectsTimer() {
          if (enableUserTimingAPI) {
            if (!supportsUserTiming) {
              return;
            }
            var count = effectCountInCurrentCommit;
            effectCountInCurrentCommit = 0;
            endMark("(Committing Snapshot Effects: " + count + " Total)", "(Committing Snapshot Effects)", null);
          }
        }
        function startCommitHostEffectsTimer() {
          if (enableUserTimingAPI) {
            if (!supportsUserTiming) {
              return;
            }
            effectCountInCurrentCommit = 0;
            beginMark("(Committing Host Effects)");
          }
        }
        function stopCommitHostEffectsTimer() {
          if (enableUserTimingAPI) {
            if (!supportsUserTiming) {
              return;
            }
            var count = effectCountInCurrentCommit;
            effectCountInCurrentCommit = 0;
            endMark("(Committing Host Effects: " + count + " Total)", "(Committing Host Effects)", null);
          }
        }
        function startCommitLifeCyclesTimer() {
          if (enableUserTimingAPI) {
            if (!supportsUserTiming) {
              return;
            }
            effectCountInCurrentCommit = 0;
            beginMark("(Calling Lifecycle Methods)");
          }
        }
        function stopCommitLifeCyclesTimer() {
          if (enableUserTimingAPI) {
            if (!supportsUserTiming) {
              return;
            }
            var count = effectCountInCurrentCommit;
            effectCountInCurrentCommit = 0;
            endMark("(Calling Lifecycle Methods: " + count + " Total)", "(Calling Lifecycle Methods)", null);
          }
        }
        var valueStack = [];
        var fiberStack;
        {
          fiberStack = [];
        }
        var index = -1;
        function createCursor(defaultValue) {
          return {
            current: defaultValue
          };
        }
        function pop(cursor, fiber) {
          if (index < 0) {
            {
              warningWithoutStack$1(false, "Unexpected pop.");
            }
            return;
          }
          {
            if (fiber !== fiberStack[index]) {
              warningWithoutStack$1(false, "Unexpected Fiber popped.");
            }
          }
          cursor.current = valueStack[index];
          valueStack[index] = null;
          {
            fiberStack[index] = null;
          }
          index--;
        }
        function push(cursor, value, fiber) {
          index++;
          valueStack[index] = cursor.current;
          {
            fiberStack[index] = fiber;
          }
          cursor.current = value;
        }
        var warnedAboutMissingGetChildContext;
        {
          warnedAboutMissingGetChildContext = {};
        }
        var emptyContextObject = {};
        {
          Object.freeze(emptyContextObject);
        }
        var contextStackCursor = createCursor(emptyContextObject);
        var didPerformWorkStackCursor = createCursor(false);
        var previousContext = emptyContextObject;
        function getUnmaskedContext(workInProgress2, Component, didPushOwnContextIfProvider) {
          if (disableLegacyContext) {
            return emptyContextObject;
          } else {
            if (didPushOwnContextIfProvider && isContextProvider(Component)) {
              return previousContext;
            }
            return contextStackCursor.current;
          }
        }
        function cacheContext(workInProgress2, unmaskedContext, maskedContext) {
          if (disableLegacyContext) {
            return;
          } else {
            var instance = workInProgress2.stateNode;
            instance.__reactInternalMemoizedUnmaskedChildContext = unmaskedContext;
            instance.__reactInternalMemoizedMaskedChildContext = maskedContext;
          }
        }
        function getMaskedContext(workInProgress2, unmaskedContext) {
          if (disableLegacyContext) {
            return emptyContextObject;
          } else {
            var type3 = workInProgress2.type;
            var contextTypes = type3.contextTypes;
            if (!contextTypes) {
              return emptyContextObject;
            }
            var instance = workInProgress2.stateNode;
            if (instance && instance.__reactInternalMemoizedUnmaskedChildContext === unmaskedContext) {
              return instance.__reactInternalMemoizedMaskedChildContext;
            }
            var context = {};
            for (var key2 in contextTypes) {
              context[key2] = unmaskedContext[key2];
            }
            {
              var name = getComponentName(type3) || "Unknown";
              checkPropTypes(contextTypes, context, "context", name, getCurrentFiberStackInDev);
            }
            if (instance) {
              cacheContext(workInProgress2, unmaskedContext, context);
            }
            return context;
          }
        }
        function hasContextChanged() {
          if (disableLegacyContext) {
            return false;
          } else {
            return didPerformWorkStackCursor.current;
          }
        }
        function isContextProvider(type3) {
          if (disableLegacyContext) {
            return false;
          } else {
            var childContextTypes = type3.childContextTypes;
            return childContextTypes !== null && childContextTypes !== void 0;
          }
        }
        function popContext(fiber) {
          if (disableLegacyContext) {
            return;
          } else {
            pop(didPerformWorkStackCursor, fiber);
            pop(contextStackCursor, fiber);
          }
        }
        function popTopLevelContextObject(fiber) {
          if (disableLegacyContext) {
            return;
          } else {
            pop(didPerformWorkStackCursor, fiber);
            pop(contextStackCursor, fiber);
          }
        }
        function pushTopLevelContextObject(fiber, context, didChange) {
          if (disableLegacyContext) {
            return;
          } else {
            if (!(contextStackCursor.current === emptyContextObject)) {
              {
                throw Error("Unexpected context found on stack. This error is likely caused by a bug in React. Please file an issue.");
              }
            }
            push(contextStackCursor, context, fiber);
            push(didPerformWorkStackCursor, didChange, fiber);
          }
        }
        function processChildContext(fiber, type3, parentContext) {
          if (disableLegacyContext) {
            return parentContext;
          } else {
            var instance = fiber.stateNode;
            var childContextTypes = type3.childContextTypes;
            if (typeof instance.getChildContext !== "function") {
              {
                var componentName = getComponentName(type3) || "Unknown";
                if (!warnedAboutMissingGetChildContext[componentName]) {
                  warnedAboutMissingGetChildContext[componentName] = true;
                  warningWithoutStack$1(false, "%s.childContextTypes is specified but there is no getChildContext() method on the instance. You can either define getChildContext() on %s or remove childContextTypes from it.", componentName, componentName);
                }
              }
              return parentContext;
            }
            var childContext;
            {
              setCurrentPhase("getChildContext");
            }
            startPhaseTimer(fiber, "getChildContext");
            childContext = instance.getChildContext();
            stopPhaseTimer();
            {
              setCurrentPhase(null);
            }
            for (var contextKey in childContext) {
              if (!(contextKey in childContextTypes)) {
                {
                  throw Error((getComponentName(type3) || "Unknown") + '.getChildContext(): key "' + contextKey + '" is not defined in childContextTypes.');
                }
              }
            }
            {
              var name = getComponentName(type3) || "Unknown";
              checkPropTypes(childContextTypes, childContext, "child context", name, getCurrentFiberStackInDev);
            }
            return _assign({}, parentContext, {}, childContext);
          }
        }
        function pushContextProvider(workInProgress2) {
          if (disableLegacyContext) {
            return false;
          } else {
            var instance = workInProgress2.stateNode;
            var memoizedMergedChildContext = instance && instance.__reactInternalMemoizedMergedChildContext || emptyContextObject;
            previousContext = contextStackCursor.current;
            push(contextStackCursor, memoizedMergedChildContext, workInProgress2);
            push(didPerformWorkStackCursor, didPerformWorkStackCursor.current, workInProgress2);
            return true;
          }
        }
        function invalidateContextProvider(workInProgress2, type3, didChange) {
          if (disableLegacyContext) {
            return;
          } else {
            var instance = workInProgress2.stateNode;
            if (!instance) {
              {
                throw Error("Expected to have an instance by this point. This error is likely caused by a bug in React. Please file an issue.");
              }
            }
            if (didChange) {
              var mergedContext = processChildContext(workInProgress2, type3, previousContext);
              instance.__reactInternalMemoizedMergedChildContext = mergedContext;
              pop(didPerformWorkStackCursor, workInProgress2);
              pop(contextStackCursor, workInProgress2);
              push(contextStackCursor, mergedContext, workInProgress2);
              push(didPerformWorkStackCursor, didChange, workInProgress2);
            } else {
              pop(didPerformWorkStackCursor, workInProgress2);
              push(didPerformWorkStackCursor, didChange, workInProgress2);
            }
          }
        }
        function findCurrentUnmaskedContext(fiber) {
          if (disableLegacyContext) {
            return emptyContextObject;
          } else {
            if (!(isFiberMounted(fiber) && fiber.tag === ClassComponent)) {
              {
                throw Error("Expected subtree parent to be a mounted class component. This error is likely caused by a bug in React. Please file an issue.");
              }
            }
            var node = fiber;
            do {
              switch (node.tag) {
                case HostRoot:
                  return node.stateNode.context;
                case ClassComponent: {
                  var Component = node.type;
                  if (isContextProvider(Component)) {
                    return node.stateNode.__reactInternalMemoizedMergedChildContext;
                  }
                  break;
                }
              }
              node = node.return;
            } while (node !== null);
            {
              {
                throw Error("Found unexpected detached subtree parent. This error is likely caused by a bug in React. Please file an issue.");
              }
            }
          }
        }
        var BlockingRoot = 1;
        var ConcurrentRoot = 2;
        var Scheduler_runWithPriority = Scheduler.unstable_runWithPriority;
        var Scheduler_scheduleCallback = Scheduler.unstable_scheduleCallback;
        var Scheduler_cancelCallback = Scheduler.unstable_cancelCallback;
        var Scheduler_shouldYield = Scheduler.unstable_shouldYield;
        var Scheduler_requestPaint = Scheduler.unstable_requestPaint;
        var Scheduler_now = Scheduler.unstable_now;
        var Scheduler_getCurrentPriorityLevel = Scheduler.unstable_getCurrentPriorityLevel;
        var Scheduler_ImmediatePriority = Scheduler.unstable_ImmediatePriority;
        var Scheduler_UserBlockingPriority = Scheduler.unstable_UserBlockingPriority;
        var Scheduler_NormalPriority = Scheduler.unstable_NormalPriority;
        var Scheduler_LowPriority = Scheduler.unstable_LowPriority;
        var Scheduler_IdlePriority = Scheduler.unstable_IdlePriority;
        if (enableSchedulerTracing) {
          if (!(tracing.__interactionsRef != null && tracing.__interactionsRef.current != null)) {
            {
              throw Error("It is not supported to run the profiling version of a renderer (for example, `react-dom/profiling`) without also replacing the `scheduler/tracing` module with `scheduler/tracing-profiling`. Your bundler might have a setting for aliasing both modules. Learn more at http://fb.me/react-profiling");
            }
          }
        }
        var fakeCallbackNode = {};
        var ImmediatePriority = 99;
        var UserBlockingPriority = 98;
        var NormalPriority = 97;
        var LowPriority = 96;
        var IdlePriority = 95;
        var NoPriority = 90;
        var shouldYield = Scheduler_shouldYield;
        var requestPaint = Scheduler_requestPaint !== void 0 ? Scheduler_requestPaint : function() {
        };
        var syncQueue = null;
        var immediateQueueCallbackNode = null;
        var isFlushingSyncQueue = false;
        var initialTimeMs = Scheduler_now();
        var now$1 = initialTimeMs < 1e4 ? Scheduler_now : function() {
          return Scheduler_now() - initialTimeMs;
        };
        function getCurrentPriorityLevel() {
          switch (Scheduler_getCurrentPriorityLevel()) {
            case Scheduler_ImmediatePriority:
              return ImmediatePriority;
            case Scheduler_UserBlockingPriority:
              return UserBlockingPriority;
            case Scheduler_NormalPriority:
              return NormalPriority;
            case Scheduler_LowPriority:
              return LowPriority;
            case Scheduler_IdlePriority:
              return IdlePriority;
            default: {
              {
                throw Error("Unknown priority level.");
              }
            }
          }
        }
        function reactPriorityToSchedulerPriority(reactPriorityLevel) {
          switch (reactPriorityLevel) {
            case ImmediatePriority:
              return Scheduler_ImmediatePriority;
            case UserBlockingPriority:
              return Scheduler_UserBlockingPriority;
            case NormalPriority:
              return Scheduler_NormalPriority;
            case LowPriority:
              return Scheduler_LowPriority;
            case IdlePriority:
              return Scheduler_IdlePriority;
            default: {
              {
                throw Error("Unknown priority level.");
              }
            }
          }
        }
        function runWithPriority(reactPriorityLevel, fn) {
          var priorityLevel = reactPriorityToSchedulerPriority(reactPriorityLevel);
          return Scheduler_runWithPriority(priorityLevel, fn);
        }
        function scheduleCallback(reactPriorityLevel, callback, options) {
          var priorityLevel = reactPriorityToSchedulerPriority(reactPriorityLevel);
          return Scheduler_scheduleCallback(priorityLevel, callback, options);
        }
        function scheduleSyncCallback(callback) {
          if (syncQueue === null) {
            syncQueue = [callback];
            immediateQueueCallbackNode = Scheduler_scheduleCallback(Scheduler_ImmediatePriority, flushSyncCallbackQueueImpl);
          } else {
            syncQueue.push(callback);
          }
          return fakeCallbackNode;
        }
        function cancelCallback(callbackNode) {
          if (callbackNode !== fakeCallbackNode) {
            Scheduler_cancelCallback(callbackNode);
          }
        }
        function flushSyncCallbackQueue() {
          if (immediateQueueCallbackNode !== null) {
            var node = immediateQueueCallbackNode;
            immediateQueueCallbackNode = null;
            Scheduler_cancelCallback(node);
          }
          flushSyncCallbackQueueImpl();
        }
        function flushSyncCallbackQueueImpl() {
          if (!isFlushingSyncQueue && syncQueue !== null) {
            isFlushingSyncQueue = true;
            var i3 = 0;
            try {
              var _isSync = true;
              var queue = syncQueue;
              runWithPriority(ImmediatePriority, function() {
                for (; i3 < queue.length; i3++) {
                  var callback = queue[i3];
                  do {
                    callback = callback(_isSync);
                  } while (callback !== null);
                }
              });
              syncQueue = null;
            } catch (error) {
              if (syncQueue !== null) {
                syncQueue = syncQueue.slice(i3 + 1);
              }
              Scheduler_scheduleCallback(Scheduler_ImmediatePriority, flushSyncCallbackQueue);
              throw error;
            } finally {
              isFlushingSyncQueue = false;
            }
          }
        }
        var NoMode = 0;
        var StrictMode = 1;
        var BlockingMode = 2;
        var ConcurrentMode = 4;
        var ProfileMode = 8;
        var MAX_SIGNED_31_BIT_INT = 1073741823;
        var NoWork = 0;
        var Never = 1;
        var Idle = 2;
        var ContinuousHydration = 3;
        var Sync = MAX_SIGNED_31_BIT_INT;
        var Batched = Sync - 1;
        var UNIT_SIZE = 10;
        var MAGIC_NUMBER_OFFSET = Batched - 1;
        function msToExpirationTime(ms) {
          return MAGIC_NUMBER_OFFSET - (ms / UNIT_SIZE | 0);
        }
        function expirationTimeToMs(expirationTime) {
          return (MAGIC_NUMBER_OFFSET - expirationTime) * UNIT_SIZE;
        }
        function ceiling(num2, precision) {
          return ((num2 / precision | 0) + 1) * precision;
        }
        function computeExpirationBucket(currentTime, expirationInMs, bucketSizeMs) {
          return MAGIC_NUMBER_OFFSET - ceiling(MAGIC_NUMBER_OFFSET - currentTime + expirationInMs / UNIT_SIZE, bucketSizeMs / UNIT_SIZE);
        }
        var LOW_PRIORITY_EXPIRATION = 5e3;
        var LOW_PRIORITY_BATCH_SIZE = 250;
        function computeAsyncExpiration(currentTime) {
          return computeExpirationBucket(currentTime, LOW_PRIORITY_EXPIRATION, LOW_PRIORITY_BATCH_SIZE);
        }
        function computeSuspenseExpiration(currentTime, timeoutMs) {
          return computeExpirationBucket(currentTime, timeoutMs, LOW_PRIORITY_BATCH_SIZE);
        }
        var HIGH_PRIORITY_EXPIRATION = 500;
        var HIGH_PRIORITY_BATCH_SIZE = 100;
        function computeInteractiveExpiration(currentTime) {
          return computeExpirationBucket(currentTime, HIGH_PRIORITY_EXPIRATION, HIGH_PRIORITY_BATCH_SIZE);
        }
        function computeContinuousHydrationExpiration(currentTime) {
          return ContinuousHydration++;
        }
        function inferPriorityFromExpirationTime(currentTime, expirationTime) {
          if (expirationTime === Sync) {
            return ImmediatePriority;
          }
          if (expirationTime === Never || expirationTime === Idle) {
            return IdlePriority;
          }
          var msUntil = expirationTimeToMs(expirationTime) - expirationTimeToMs(currentTime);
          if (msUntil <= 0) {
            return ImmediatePriority;
          }
          if (msUntil <= HIGH_PRIORITY_EXPIRATION + HIGH_PRIORITY_BATCH_SIZE) {
            return UserBlockingPriority;
          }
          if (msUntil <= LOW_PRIORITY_EXPIRATION + LOW_PRIORITY_BATCH_SIZE) {
            return NormalPriority;
          }
          return IdlePriority;
        }
        function is(x, y2) {
          return x === y2 && (x !== 0 || 1 / x === 1 / y2) || x !== x && y2 !== y2;
        }
        var is$1 = typeof Object.is === "function" ? Object.is : is;
        var hasOwnProperty2 = Object.prototype.hasOwnProperty;
        function shallowEqual(objA, objB) {
          if (is$1(objA, objB)) {
            return true;
          }
          if (typeof objA !== "object" || objA === null || typeof objB !== "object" || objB === null) {
            return false;
          }
          var keysA = Object.keys(objA);
          var keysB = Object.keys(objB);
          if (keysA.length !== keysB.length) {
            return false;
          }
          for (var i3 = 0; i3 < keysA.length; i3++) {
            if (!hasOwnProperty2.call(objB, keysA[i3]) || !is$1(objA[keysA[i3]], objB[keysA[i3]])) {
              return false;
            }
          }
          return true;
        }
        var lowPriorityWarningWithoutStack = function() {
        };
        {
          var printWarning = function(format) {
            for (var _len = arguments.length, args = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
              args[_key - 1] = arguments[_key];
            }
            var argIndex = 0;
            var message = "Warning: " + format.replace(/%s/g, function() {
              return args[argIndex++];
            });
            if (typeof console !== "undefined") {
              console.warn(message);
            }
            try {
              throw new Error(message);
            } catch (x) {
            }
          };
          lowPriorityWarningWithoutStack = function(condition, format) {
            if (format === void 0) {
              throw new Error("`lowPriorityWarningWithoutStack(condition, format, ...args)` requires a warning message argument");
            }
            if (!condition) {
              for (var _len2 = arguments.length, args = new Array(_len2 > 2 ? _len2 - 2 : 0), _key2 = 2; _key2 < _len2; _key2++) {
                args[_key2 - 2] = arguments[_key2];
              }
              printWarning.apply(void 0, [format].concat(args));
            }
          };
        }
        var lowPriorityWarningWithoutStack$1 = lowPriorityWarningWithoutStack;
        var ReactStrictModeWarnings = {
          recordUnsafeLifecycleWarnings: function(fiber, instance) {
          },
          flushPendingUnsafeLifecycleWarnings: function() {
          },
          recordLegacyContextWarning: function(fiber, instance) {
          },
          flushLegacyContextWarning: function() {
          },
          discardPendingWarnings: function() {
          }
        };
        {
          var findStrictRoot = function(fiber) {
            var maybeStrictRoot = null;
            var node = fiber;
            while (node !== null) {
              if (node.mode & StrictMode) {
                maybeStrictRoot = node;
              }
              node = node.return;
            }
            return maybeStrictRoot;
          };
          var setToSortedString = function(set3) {
            var array = [];
            set3.forEach(function(value) {
              array.push(value);
            });
            return array.sort().join(", ");
          };
          var pendingComponentWillMountWarnings = [];
          var pendingUNSAFE_ComponentWillMountWarnings = [];
          var pendingComponentWillReceivePropsWarnings = [];
          var pendingUNSAFE_ComponentWillReceivePropsWarnings = [];
          var pendingComponentWillUpdateWarnings = [];
          var pendingUNSAFE_ComponentWillUpdateWarnings = [];
          var didWarnAboutUnsafeLifecycles = /* @__PURE__ */ new Set();
          ReactStrictModeWarnings.recordUnsafeLifecycleWarnings = function(fiber, instance) {
            if (didWarnAboutUnsafeLifecycles.has(fiber.type)) {
              return;
            }
            if (typeof instance.componentWillMount === "function" && instance.componentWillMount.__suppressDeprecationWarning !== true) {
              pendingComponentWillMountWarnings.push(fiber);
            }
            if (fiber.mode & StrictMode && typeof instance.UNSAFE_componentWillMount === "function") {
              pendingUNSAFE_ComponentWillMountWarnings.push(fiber);
            }
            if (typeof instance.componentWillReceiveProps === "function" && instance.componentWillReceiveProps.__suppressDeprecationWarning !== true) {
              pendingComponentWillReceivePropsWarnings.push(fiber);
            }
            if (fiber.mode & StrictMode && typeof instance.UNSAFE_componentWillReceiveProps === "function") {
              pendingUNSAFE_ComponentWillReceivePropsWarnings.push(fiber);
            }
            if (typeof instance.componentWillUpdate === "function" && instance.componentWillUpdate.__suppressDeprecationWarning !== true) {
              pendingComponentWillUpdateWarnings.push(fiber);
            }
            if (fiber.mode & StrictMode && typeof instance.UNSAFE_componentWillUpdate === "function") {
              pendingUNSAFE_ComponentWillUpdateWarnings.push(fiber);
            }
          };
          ReactStrictModeWarnings.flushPendingUnsafeLifecycleWarnings = function() {
            var componentWillMountUniqueNames = /* @__PURE__ */ new Set();
            if (pendingComponentWillMountWarnings.length > 0) {
              pendingComponentWillMountWarnings.forEach(function(fiber) {
                componentWillMountUniqueNames.add(getComponentName(fiber.type) || "Component");
                didWarnAboutUnsafeLifecycles.add(fiber.type);
              });
              pendingComponentWillMountWarnings = [];
            }
            var UNSAFE_componentWillMountUniqueNames = /* @__PURE__ */ new Set();
            if (pendingUNSAFE_ComponentWillMountWarnings.length > 0) {
              pendingUNSAFE_ComponentWillMountWarnings.forEach(function(fiber) {
                UNSAFE_componentWillMountUniqueNames.add(getComponentName(fiber.type) || "Component");
                didWarnAboutUnsafeLifecycles.add(fiber.type);
              });
              pendingUNSAFE_ComponentWillMountWarnings = [];
            }
            var componentWillReceivePropsUniqueNames = /* @__PURE__ */ new Set();
            if (pendingComponentWillReceivePropsWarnings.length > 0) {
              pendingComponentWillReceivePropsWarnings.forEach(function(fiber) {
                componentWillReceivePropsUniqueNames.add(getComponentName(fiber.type) || "Component");
                didWarnAboutUnsafeLifecycles.add(fiber.type);
              });
              pendingComponentWillReceivePropsWarnings = [];
            }
            var UNSAFE_componentWillReceivePropsUniqueNames = /* @__PURE__ */ new Set();
            if (pendingUNSAFE_ComponentWillReceivePropsWarnings.length > 0) {
              pendingUNSAFE_ComponentWillReceivePropsWarnings.forEach(function(fiber) {
                UNSAFE_componentWillReceivePropsUniqueNames.add(getComponentName(fiber.type) || "Component");
                didWarnAboutUnsafeLifecycles.add(fiber.type);
              });
              pendingUNSAFE_ComponentWillReceivePropsWarnings = [];
            }
            var componentWillUpdateUniqueNames = /* @__PURE__ */ new Set();
            if (pendingComponentWillUpdateWarnings.length > 0) {
              pendingComponentWillUpdateWarnings.forEach(function(fiber) {
                componentWillUpdateUniqueNames.add(getComponentName(fiber.type) || "Component");
                didWarnAboutUnsafeLifecycles.add(fiber.type);
              });
              pendingComponentWillUpdateWarnings = [];
            }
            var UNSAFE_componentWillUpdateUniqueNames = /* @__PURE__ */ new Set();
            if (pendingUNSAFE_ComponentWillUpdateWarnings.length > 0) {
              pendingUNSAFE_ComponentWillUpdateWarnings.forEach(function(fiber) {
                UNSAFE_componentWillUpdateUniqueNames.add(getComponentName(fiber.type) || "Component");
                didWarnAboutUnsafeLifecycles.add(fiber.type);
              });
              pendingUNSAFE_ComponentWillUpdateWarnings = [];
            }
            if (UNSAFE_componentWillMountUniqueNames.size > 0) {
              var sortedNames = setToSortedString(UNSAFE_componentWillMountUniqueNames);
              warningWithoutStack$1(false, "Using UNSAFE_componentWillMount in strict mode is not recommended and may indicate bugs in your code. See https://fb.me/react-unsafe-component-lifecycles for details.\n\n* Move code with side effects to componentDidMount, and set initial state in the constructor.\n\nPlease update the following components: %s", sortedNames);
            }
            if (UNSAFE_componentWillReceivePropsUniqueNames.size > 0) {
              var _sortedNames = setToSortedString(UNSAFE_componentWillReceivePropsUniqueNames);
              warningWithoutStack$1(false, "Using UNSAFE_componentWillReceiveProps in strict mode is not recommended and may indicate bugs in your code. See https://fb.me/react-unsafe-component-lifecycles for details.\n\n* Move data fetching code or side effects to componentDidUpdate.\n* If you're updating state whenever props change, refactor your code to use memoization techniques or move it to static getDerivedStateFromProps. Learn more at: https://fb.me/react-derived-state\n\nPlease update the following components: %s", _sortedNames);
            }
            if (UNSAFE_componentWillUpdateUniqueNames.size > 0) {
              var _sortedNames2 = setToSortedString(UNSAFE_componentWillUpdateUniqueNames);
              warningWithoutStack$1(false, "Using UNSAFE_componentWillUpdate in strict mode is not recommended and may indicate bugs in your code. See https://fb.me/react-unsafe-component-lifecycles for details.\n\n* Move data fetching code or side effects to componentDidUpdate.\n\nPlease update the following components: %s", _sortedNames2);
            }
            if (componentWillMountUniqueNames.size > 0) {
              var _sortedNames3 = setToSortedString(componentWillMountUniqueNames);
              lowPriorityWarningWithoutStack$1(false, "componentWillMount has been renamed, and is not recommended for use. See https://fb.me/react-unsafe-component-lifecycles for details.\n\n* Move code with side effects to componentDidMount, and set initial state in the constructor.\n* Rename componentWillMount to UNSAFE_componentWillMount to suppress this warning in non-strict mode. In React 17.x, only the UNSAFE_ name will work. To rename all deprecated lifecycles to their new names, you can run `npx react-codemod rename-unsafe-lifecycles` in your project source folder.\n\nPlease update the following components: %s", _sortedNames3);
            }
            if (componentWillReceivePropsUniqueNames.size > 0) {
              var _sortedNames4 = setToSortedString(componentWillReceivePropsUniqueNames);
              lowPriorityWarningWithoutStack$1(false, "componentWillReceiveProps has been renamed, and is not recommended for use. See https://fb.me/react-unsafe-component-lifecycles for details.\n\n* Move data fetching code or side effects to componentDidUpdate.\n* If you're updating state whenever props change, refactor your code to use memoization techniques or move it to static getDerivedStateFromProps. Learn more at: https://fb.me/react-derived-state\n* Rename componentWillReceiveProps to UNSAFE_componentWillReceiveProps to suppress this warning in non-strict mode. In React 17.x, only the UNSAFE_ name will work. To rename all deprecated lifecycles to their new names, you can run `npx react-codemod rename-unsafe-lifecycles` in your project source folder.\n\nPlease update the following components: %s", _sortedNames4);
            }
            if (componentWillUpdateUniqueNames.size > 0) {
              var _sortedNames5 = setToSortedString(componentWillUpdateUniqueNames);
              lowPriorityWarningWithoutStack$1(false, "componentWillUpdate has been renamed, and is not recommended for use. See https://fb.me/react-unsafe-component-lifecycles for details.\n\n* Move data fetching code or side effects to componentDidUpdate.\n* Rename componentWillUpdate to UNSAFE_componentWillUpdate to suppress this warning in non-strict mode. In React 17.x, only the UNSAFE_ name will work. To rename all deprecated lifecycles to their new names, you can run `npx react-codemod rename-unsafe-lifecycles` in your project source folder.\n\nPlease update the following components: %s", _sortedNames5);
            }
          };
          var pendingLegacyContextWarning = /* @__PURE__ */ new Map();
          var didWarnAboutLegacyContext = /* @__PURE__ */ new Set();
          ReactStrictModeWarnings.recordLegacyContextWarning = function(fiber, instance) {
            var strictRoot = findStrictRoot(fiber);
            if (strictRoot === null) {
              warningWithoutStack$1(false, "Expected to find a StrictMode component in a strict mode tree. This error is likely caused by a bug in React. Please file an issue.");
              return;
            }
            if (didWarnAboutLegacyContext.has(fiber.type)) {
              return;
            }
            var warningsForRoot = pendingLegacyContextWarning.get(strictRoot);
            if (fiber.type.contextTypes != null || fiber.type.childContextTypes != null || instance !== null && typeof instance.getChildContext === "function") {
              if (warningsForRoot === void 0) {
                warningsForRoot = [];
                pendingLegacyContextWarning.set(strictRoot, warningsForRoot);
              }
              warningsForRoot.push(fiber);
            }
          };
          ReactStrictModeWarnings.flushLegacyContextWarning = function() {
            pendingLegacyContextWarning.forEach(function(fiberArray, strictRoot) {
              var uniqueNames = /* @__PURE__ */ new Set();
              fiberArray.forEach(function(fiber) {
                uniqueNames.add(getComponentName(fiber.type) || "Component");
                didWarnAboutLegacyContext.add(fiber.type);
              });
              var sortedNames = setToSortedString(uniqueNames);
              var strictRootComponentStack = getStackByFiberInDevAndProd(strictRoot);
              warningWithoutStack$1(false, "Legacy context API has been detected within a strict-mode tree.\n\nThe old API will be supported in all 16.x releases, but applications using it should migrate to the new version.\n\nPlease update the following components: %s\n\nLearn more about this warning here: https://fb.me/react-legacy-context%s", sortedNames, strictRootComponentStack);
            });
          };
          ReactStrictModeWarnings.discardPendingWarnings = function() {
            pendingComponentWillMountWarnings = [];
            pendingUNSAFE_ComponentWillMountWarnings = [];
            pendingComponentWillReceivePropsWarnings = [];
            pendingUNSAFE_ComponentWillReceivePropsWarnings = [];
            pendingComponentWillUpdateWarnings = [];
            pendingUNSAFE_ComponentWillUpdateWarnings = [];
            pendingLegacyContextWarning = /* @__PURE__ */ new Map();
          };
        }
        var resolveFamily = null;
        var failedBoundaries = null;
        var setRefreshHandler = function(handler) {
          {
            resolveFamily = handler;
          }
        };
        function resolveFunctionForHotReloading(type3) {
          {
            if (resolveFamily === null) {
              return type3;
            }
            var family = resolveFamily(type3);
            if (family === void 0) {
              return type3;
            }
            return family.current;
          }
        }
        function resolveClassForHotReloading(type3) {
          return resolveFunctionForHotReloading(type3);
        }
        function resolveForwardRefForHotReloading(type3) {
          {
            if (resolveFamily === null) {
              return type3;
            }
            var family = resolveFamily(type3);
            if (family === void 0) {
              if (type3 !== null && type3 !== void 0 && typeof type3.render === "function") {
                var currentRender = resolveFunctionForHotReloading(type3.render);
                if (type3.render !== currentRender) {
                  var syntheticType = {
                    $$typeof: REACT_FORWARD_REF_TYPE,
                    render: currentRender
                  };
                  if (type3.displayName !== void 0) {
                    syntheticType.displayName = type3.displayName;
                  }
                  return syntheticType;
                }
              }
              return type3;
            }
            return family.current;
          }
        }
        function isCompatibleFamilyForHotReloading(fiber, element) {
          {
            if (resolveFamily === null) {
              return false;
            }
            var prevType = fiber.elementType;
            var nextType = element.type;
            var needsCompareFamilies = false;
            var $$typeofNextType = typeof nextType === "object" && nextType !== null ? nextType.$$typeof : null;
            switch (fiber.tag) {
              case ClassComponent: {
                if (typeof nextType === "function") {
                  needsCompareFamilies = true;
                }
                break;
              }
              case FunctionComponent: {
                if (typeof nextType === "function") {
                  needsCompareFamilies = true;
                } else if ($$typeofNextType === REACT_LAZY_TYPE) {
                  needsCompareFamilies = true;
                }
                break;
              }
              case ForwardRef: {
                if ($$typeofNextType === REACT_FORWARD_REF_TYPE) {
                  needsCompareFamilies = true;
                } else if ($$typeofNextType === REACT_LAZY_TYPE) {
                  needsCompareFamilies = true;
                }
                break;
              }
              case MemoComponent:
              case SimpleMemoComponent: {
                if ($$typeofNextType === REACT_MEMO_TYPE) {
                  needsCompareFamilies = true;
                } else if ($$typeofNextType === REACT_LAZY_TYPE) {
                  needsCompareFamilies = true;
                }
                break;
              }
              default:
                return false;
            }
            if (needsCompareFamilies) {
              var prevFamily = resolveFamily(prevType);
              if (prevFamily !== void 0 && prevFamily === resolveFamily(nextType)) {
                return true;
              }
            }
            return false;
          }
        }
        function markFailedErrorBoundaryForHotReloading(fiber) {
          {
            if (resolveFamily === null) {
              return;
            }
            if (typeof WeakSet !== "function") {
              return;
            }
            if (failedBoundaries === null) {
              failedBoundaries = new WeakSet();
            }
            failedBoundaries.add(fiber);
          }
        }
        var scheduleRefresh = function(root, update) {
          {
            if (resolveFamily === null) {
              return;
            }
            var staleFamilies = update.staleFamilies, updatedFamilies = update.updatedFamilies;
            flushPassiveEffects();
            flushSync(function() {
              scheduleFibersWithFamiliesRecursively(root.current, updatedFamilies, staleFamilies);
            });
          }
        };
        var scheduleRoot = function(root, element) {
          {
            if (root.context !== emptyContextObject) {
              return;
            }
            flushPassiveEffects();
            syncUpdates(function() {
              updateContainer(element, root, null, null);
            });
          }
        };
        function scheduleFibersWithFamiliesRecursively(fiber, updatedFamilies, staleFamilies) {
          {
            var alternate = fiber.alternate, child = fiber.child, sibling = fiber.sibling, tag = fiber.tag, type3 = fiber.type;
            var candidateType = null;
            switch (tag) {
              case FunctionComponent:
              case SimpleMemoComponent:
              case ClassComponent:
                candidateType = type3;
                break;
              case ForwardRef:
                candidateType = type3.render;
                break;
              default:
                break;
            }
            if (resolveFamily === null) {
              throw new Error("Expected resolveFamily to be set during hot reload.");
            }
            var needsRender = false;
            var needsRemount = false;
            if (candidateType !== null) {
              var family = resolveFamily(candidateType);
              if (family !== void 0) {
                if (staleFamilies.has(family)) {
                  needsRemount = true;
                } else if (updatedFamilies.has(family)) {
                  if (tag === ClassComponent) {
                    needsRemount = true;
                  } else {
                    needsRender = true;
                  }
                }
              }
            }
            if (failedBoundaries !== null) {
              if (failedBoundaries.has(fiber) || alternate !== null && failedBoundaries.has(alternate)) {
                needsRemount = true;
              }
            }
            if (needsRemount) {
              fiber._debugNeedsRemount = true;
            }
            if (needsRemount || needsRender) {
              scheduleWork(fiber, Sync);
            }
            if (child !== null && !needsRemount) {
              scheduleFibersWithFamiliesRecursively(child, updatedFamilies, staleFamilies);
            }
            if (sibling !== null) {
              scheduleFibersWithFamiliesRecursively(sibling, updatedFamilies, staleFamilies);
            }
          }
        }
        var findHostInstancesForRefresh = function(root, families) {
          {
            var hostInstances = /* @__PURE__ */ new Set();
            var types2 = new Set(families.map(function(family) {
              return family.current;
            }));
            findHostInstancesForMatchingFibersRecursively(root.current, types2, hostInstances);
            return hostInstances;
          }
        };
        function findHostInstancesForMatchingFibersRecursively(fiber, types2, hostInstances) {
          {
            var child = fiber.child, sibling = fiber.sibling, tag = fiber.tag, type3 = fiber.type;
            var candidateType = null;
            switch (tag) {
              case FunctionComponent:
              case SimpleMemoComponent:
              case ClassComponent:
                candidateType = type3;
                break;
              case ForwardRef:
                candidateType = type3.render;
                break;
              default:
                break;
            }
            var didMatch = false;
            if (candidateType !== null) {
              if (types2.has(candidateType)) {
                didMatch = true;
              }
            }
            if (didMatch) {
              findHostInstancesForFiberShallowly(fiber, hostInstances);
            } else {
              if (child !== null) {
                findHostInstancesForMatchingFibersRecursively(child, types2, hostInstances);
              }
            }
            if (sibling !== null) {
              findHostInstancesForMatchingFibersRecursively(sibling, types2, hostInstances);
            }
          }
        }
        function findHostInstancesForFiberShallowly(fiber, hostInstances) {
          {
            var foundHostInstances = findChildHostInstancesForFiberShallowly(fiber, hostInstances);
            if (foundHostInstances) {
              return;
            }
            var node = fiber;
            while (true) {
              switch (node.tag) {
                case HostComponent:
                  hostInstances.add(node.stateNode);
                  return;
                case HostPortal:
                  hostInstances.add(node.stateNode.containerInfo);
                  return;
                case HostRoot:
                  hostInstances.add(node.stateNode.containerInfo);
                  return;
              }
              if (node.return === null) {
                throw new Error("Expected to reach root first.");
              }
              node = node.return;
            }
          }
        }
        function findChildHostInstancesForFiberShallowly(fiber, hostInstances) {
          {
            var node = fiber;
            var foundHostInstances = false;
            while (true) {
              if (node.tag === HostComponent) {
                foundHostInstances = true;
                hostInstances.add(node.stateNode);
              } else if (node.child !== null) {
                node.child.return = node;
                node = node.child;
                continue;
              }
              if (node === fiber) {
                return foundHostInstances;
              }
              while (node.sibling === null) {
                if (node.return === null || node.return === fiber) {
                  return foundHostInstances;
                }
                node = node.return;
              }
              node.sibling.return = node.return;
              node = node.sibling;
            }
          }
          return false;
        }
        function resolveDefaultProps(Component, baseProps) {
          if (Component && Component.defaultProps) {
            var props = _assign({}, baseProps);
            var defaultProps = Component.defaultProps;
            for (var propName in defaultProps) {
              if (props[propName] === void 0) {
                props[propName] = defaultProps[propName];
              }
            }
            return props;
          }
          return baseProps;
        }
        function readLazyComponentType(lazyComponent) {
          initializeLazyComponentType(lazyComponent);
          if (lazyComponent._status !== Resolved) {
            throw lazyComponent._result;
          }
          return lazyComponent._result;
        }
        var valueCursor = createCursor(null);
        var rendererSigil;
        {
          rendererSigil = {};
        }
        var currentlyRenderingFiber = null;
        var lastContextDependency = null;
        var lastContextWithAllBitsObserved = null;
        var isDisallowedContextReadInDEV = false;
        function resetContextDependencies() {
          currentlyRenderingFiber = null;
          lastContextDependency = null;
          lastContextWithAllBitsObserved = null;
          {
            isDisallowedContextReadInDEV = false;
          }
        }
        function enterDisallowedContextReadInDEV() {
          {
            isDisallowedContextReadInDEV = true;
          }
        }
        function exitDisallowedContextReadInDEV() {
          {
            isDisallowedContextReadInDEV = false;
          }
        }
        function pushProvider(providerFiber, nextValue) {
          var context = providerFiber.type._context;
          if (isPrimaryRenderer) {
            push(valueCursor, context._currentValue, providerFiber);
            context._currentValue = nextValue;
            {
              !(context._currentRenderer === void 0 || context._currentRenderer === null || context._currentRenderer === rendererSigil) ? warningWithoutStack$1(false, "Detected multiple renderers concurrently rendering the same context provider. This is currently unsupported.") : void 0;
              context._currentRenderer = rendererSigil;
            }
          } else {
            push(valueCursor, context._currentValue2, providerFiber);
            context._currentValue2 = nextValue;
            {
              !(context._currentRenderer2 === void 0 || context._currentRenderer2 === null || context._currentRenderer2 === rendererSigil) ? warningWithoutStack$1(false, "Detected multiple renderers concurrently rendering the same context provider. This is currently unsupported.") : void 0;
              context._currentRenderer2 = rendererSigil;
            }
          }
        }
        function popProvider(providerFiber) {
          var currentValue = valueCursor.current;
          pop(valueCursor, providerFiber);
          var context = providerFiber.type._context;
          if (isPrimaryRenderer) {
            context._currentValue = currentValue;
          } else {
            context._currentValue2 = currentValue;
          }
        }
        function calculateChangedBits(context, newValue, oldValue) {
          if (is$1(oldValue, newValue)) {
            return 0;
          } else {
            var changedBits = typeof context._calculateChangedBits === "function" ? context._calculateChangedBits(oldValue, newValue) : MAX_SIGNED_31_BIT_INT;
            {
              !((changedBits & MAX_SIGNED_31_BIT_INT) === changedBits) ? warning$1(false, "calculateChangedBits: Expected the return value to be a 31-bit integer. Instead received: %s", changedBits) : void 0;
            }
            return changedBits | 0;
          }
        }
        function scheduleWorkOnParentPath(parent, renderExpirationTime2) {
          var node = parent;
          while (node !== null) {
            var alternate = node.alternate;
            if (node.childExpirationTime < renderExpirationTime2) {
              node.childExpirationTime = renderExpirationTime2;
              if (alternate !== null && alternate.childExpirationTime < renderExpirationTime2) {
                alternate.childExpirationTime = renderExpirationTime2;
              }
            } else if (alternate !== null && alternate.childExpirationTime < renderExpirationTime2) {
              alternate.childExpirationTime = renderExpirationTime2;
            } else {
              break;
            }
            node = node.return;
          }
        }
        function propagateContextChange(workInProgress2, context, changedBits, renderExpirationTime2) {
          var fiber = workInProgress2.child;
          if (fiber !== null) {
            fiber.return = workInProgress2;
          }
          while (fiber !== null) {
            var nextFiber = void 0;
            var list = fiber.dependencies;
            if (list !== null) {
              nextFiber = fiber.child;
              var dependency = list.firstContext;
              while (dependency !== null) {
                if (dependency.context === context && (dependency.observedBits & changedBits) !== 0) {
                  if (fiber.tag === ClassComponent) {
                    var update = createUpdate(renderExpirationTime2, null);
                    update.tag = ForceUpdate;
                    enqueueUpdate(fiber, update);
                  }
                  if (fiber.expirationTime < renderExpirationTime2) {
                    fiber.expirationTime = renderExpirationTime2;
                  }
                  var alternate = fiber.alternate;
                  if (alternate !== null && alternate.expirationTime < renderExpirationTime2) {
                    alternate.expirationTime = renderExpirationTime2;
                  }
                  scheduleWorkOnParentPath(fiber.return, renderExpirationTime2);
                  if (list.expirationTime < renderExpirationTime2) {
                    list.expirationTime = renderExpirationTime2;
                  }
                  break;
                }
                dependency = dependency.next;
              }
            } else if (fiber.tag === ContextProvider) {
              nextFiber = fiber.type === workInProgress2.type ? null : fiber.child;
            } else if (enableSuspenseServerRenderer && fiber.tag === DehydratedFragment) {
              var parentSuspense = fiber.return;
              if (!(parentSuspense !== null)) {
                {
                  throw Error("We just came from a parent so we must have had a parent. This is a bug in React.");
                }
              }
              if (parentSuspense.expirationTime < renderExpirationTime2) {
                parentSuspense.expirationTime = renderExpirationTime2;
              }
              var _alternate = parentSuspense.alternate;
              if (_alternate !== null && _alternate.expirationTime < renderExpirationTime2) {
                _alternate.expirationTime = renderExpirationTime2;
              }
              scheduleWorkOnParentPath(parentSuspense, renderExpirationTime2);
              nextFiber = fiber.sibling;
            } else {
              nextFiber = fiber.child;
            }
            if (nextFiber !== null) {
              nextFiber.return = fiber;
            } else {
              nextFiber = fiber;
              while (nextFiber !== null) {
                if (nextFiber === workInProgress2) {
                  nextFiber = null;
                  break;
                }
                var sibling = nextFiber.sibling;
                if (sibling !== null) {
                  sibling.return = nextFiber.return;
                  nextFiber = sibling;
                  break;
                }
                nextFiber = nextFiber.return;
              }
            }
            fiber = nextFiber;
          }
        }
        function prepareToReadContext(workInProgress2, renderExpirationTime2) {
          currentlyRenderingFiber = workInProgress2;
          lastContextDependency = null;
          lastContextWithAllBitsObserved = null;
          var dependencies = workInProgress2.dependencies;
          if (dependencies !== null) {
            var firstContext = dependencies.firstContext;
            if (firstContext !== null) {
              if (dependencies.expirationTime >= renderExpirationTime2) {
                markWorkInProgressReceivedUpdate();
              }
              dependencies.firstContext = null;
            }
          }
        }
        function readContext(context, observedBits) {
          {
            !!isDisallowedContextReadInDEV ? warning$1(false, "Context can only be read while React is rendering. In classes, you can read it in the render method or getDerivedStateFromProps. In function components, you can read it directly in the function body, but not inside Hooks like useReducer() or useMemo().") : void 0;
          }
          if (lastContextWithAllBitsObserved === context) {
          } else if (observedBits === false || observedBits === 0) {
          } else {
            var resolvedObservedBits;
            if (typeof observedBits !== "number" || observedBits === MAX_SIGNED_31_BIT_INT) {
              lastContextWithAllBitsObserved = context;
              resolvedObservedBits = MAX_SIGNED_31_BIT_INT;
            } else {
              resolvedObservedBits = observedBits;
            }
            var contextItem = {
              context,
              observedBits: resolvedObservedBits,
              next: null
            };
            if (lastContextDependency === null) {
              if (!(currentlyRenderingFiber !== null)) {
                {
                  throw Error("Context can only be read while React is rendering. In classes, you can read it in the render method or getDerivedStateFromProps. In function components, you can read it directly in the function body, but not inside Hooks like useReducer() or useMemo().");
                }
              }
              lastContextDependency = contextItem;
              currentlyRenderingFiber.dependencies = {
                expirationTime: NoWork,
                firstContext: contextItem,
                responders: null
              };
            } else {
              lastContextDependency = lastContextDependency.next = contextItem;
            }
          }
          return isPrimaryRenderer ? context._currentValue : context._currentValue2;
        }
        var UpdateState = 0;
        var ReplaceState = 1;
        var ForceUpdate = 2;
        var CaptureUpdate = 3;
        var hasForceUpdate = false;
        var didWarnUpdateInsideUpdate;
        var currentlyProcessingQueue;
        {
          didWarnUpdateInsideUpdate = false;
          currentlyProcessingQueue = null;
        }
        function createUpdateQueue(baseState) {
          var queue = {
            baseState,
            firstUpdate: null,
            lastUpdate: null,
            firstCapturedUpdate: null,
            lastCapturedUpdate: null,
            firstEffect: null,
            lastEffect: null,
            firstCapturedEffect: null,
            lastCapturedEffect: null
          };
          return queue;
        }
        function cloneUpdateQueue(currentQueue) {
          var queue = {
            baseState: currentQueue.baseState,
            firstUpdate: currentQueue.firstUpdate,
            lastUpdate: currentQueue.lastUpdate,
            firstCapturedUpdate: null,
            lastCapturedUpdate: null,
            firstEffect: null,
            lastEffect: null,
            firstCapturedEffect: null,
            lastCapturedEffect: null
          };
          return queue;
        }
        function createUpdate(expirationTime, suspenseConfig) {
          var update = {
            expirationTime,
            suspenseConfig,
            tag: UpdateState,
            payload: null,
            callback: null,
            next: null,
            nextEffect: null
          };
          {
            update.priority = getCurrentPriorityLevel();
          }
          return update;
        }
        function appendUpdateToQueue(queue, update) {
          if (queue.lastUpdate === null) {
            queue.firstUpdate = queue.lastUpdate = update;
          } else {
            queue.lastUpdate.next = update;
            queue.lastUpdate = update;
          }
        }
        function enqueueUpdate(fiber, update) {
          var alternate = fiber.alternate;
          var queue1;
          var queue2;
          if (alternate === null) {
            queue1 = fiber.updateQueue;
            queue2 = null;
            if (queue1 === null) {
              queue1 = fiber.updateQueue = createUpdateQueue(fiber.memoizedState);
            }
          } else {
            queue1 = fiber.updateQueue;
            queue2 = alternate.updateQueue;
            if (queue1 === null) {
              if (queue2 === null) {
                queue1 = fiber.updateQueue = createUpdateQueue(fiber.memoizedState);
                queue2 = alternate.updateQueue = createUpdateQueue(alternate.memoizedState);
              } else {
                queue1 = fiber.updateQueue = cloneUpdateQueue(queue2);
              }
            } else {
              if (queue2 === null) {
                queue2 = alternate.updateQueue = cloneUpdateQueue(queue1);
              } else {
              }
            }
          }
          if (queue2 === null || queue1 === queue2) {
            appendUpdateToQueue(queue1, update);
          } else {
            if (queue1.lastUpdate === null || queue2.lastUpdate === null) {
              appendUpdateToQueue(queue1, update);
              appendUpdateToQueue(queue2, update);
            } else {
              appendUpdateToQueue(queue1, update);
              queue2.lastUpdate = update;
            }
          }
          {
            if (fiber.tag === ClassComponent && (currentlyProcessingQueue === queue1 || queue2 !== null && currentlyProcessingQueue === queue2) && !didWarnUpdateInsideUpdate) {
              warningWithoutStack$1(false, "An update (setState, replaceState, or forceUpdate) was scheduled from inside an update function. Update functions should be pure, with zero side-effects. Consider using componentDidUpdate or a callback.");
              didWarnUpdateInsideUpdate = true;
            }
          }
        }
        function enqueueCapturedUpdate(workInProgress2, update) {
          var workInProgressQueue = workInProgress2.updateQueue;
          if (workInProgressQueue === null) {
            workInProgressQueue = workInProgress2.updateQueue = createUpdateQueue(workInProgress2.memoizedState);
          } else {
            workInProgressQueue = ensureWorkInProgressQueueIsAClone(workInProgress2, workInProgressQueue);
          }
          if (workInProgressQueue.lastCapturedUpdate === null) {
            workInProgressQueue.firstCapturedUpdate = workInProgressQueue.lastCapturedUpdate = update;
          } else {
            workInProgressQueue.lastCapturedUpdate.next = update;
            workInProgressQueue.lastCapturedUpdate = update;
          }
        }
        function ensureWorkInProgressQueueIsAClone(workInProgress2, queue) {
          var current2 = workInProgress2.alternate;
          if (current2 !== null) {
            if (queue === current2.updateQueue) {
              queue = workInProgress2.updateQueue = cloneUpdateQueue(queue);
            }
          }
          return queue;
        }
        function getStateFromUpdate(workInProgress2, queue, update, prevState, nextProps, instance) {
          switch (update.tag) {
            case ReplaceState: {
              var payload = update.payload;
              if (typeof payload === "function") {
                {
                  enterDisallowedContextReadInDEV();
                  if (debugRenderPhaseSideEffectsForStrictMode && workInProgress2.mode & StrictMode) {
                    payload.call(instance, prevState, nextProps);
                  }
                }
                var nextState = payload.call(instance, prevState, nextProps);
                {
                  exitDisallowedContextReadInDEV();
                }
                return nextState;
              }
              return payload;
            }
            case CaptureUpdate: {
              workInProgress2.effectTag = workInProgress2.effectTag & ~ShouldCapture | DidCapture;
            }
            case UpdateState: {
              var _payload = update.payload;
              var partialState;
              if (typeof _payload === "function") {
                {
                  enterDisallowedContextReadInDEV();
                  if (debugRenderPhaseSideEffectsForStrictMode && workInProgress2.mode & StrictMode) {
                    _payload.call(instance, prevState, nextProps);
                  }
                }
                partialState = _payload.call(instance, prevState, nextProps);
                {
                  exitDisallowedContextReadInDEV();
                }
              } else {
                partialState = _payload;
              }
              if (partialState === null || partialState === void 0) {
                return prevState;
              }
              return _assign({}, prevState, partialState);
            }
            case ForceUpdate: {
              hasForceUpdate = true;
              return prevState;
            }
          }
          return prevState;
        }
        function processUpdateQueue(workInProgress2, queue, props, instance, renderExpirationTime2) {
          hasForceUpdate = false;
          queue = ensureWorkInProgressQueueIsAClone(workInProgress2, queue);
          {
            currentlyProcessingQueue = queue;
          }
          var newBaseState = queue.baseState;
          var newFirstUpdate = null;
          var newExpirationTime = NoWork;
          var update = queue.firstUpdate;
          var resultState = newBaseState;
          while (update !== null) {
            var updateExpirationTime = update.expirationTime;
            if (updateExpirationTime < renderExpirationTime2) {
              if (newFirstUpdate === null) {
                newFirstUpdate = update;
                newBaseState = resultState;
              }
              if (newExpirationTime < updateExpirationTime) {
                newExpirationTime = updateExpirationTime;
              }
            } else {
              markRenderEventTimeAndConfig(updateExpirationTime, update.suspenseConfig);
              resultState = getStateFromUpdate(workInProgress2, queue, update, resultState, props, instance);
              var callback = update.callback;
              if (callback !== null) {
                workInProgress2.effectTag |= Callback;
                update.nextEffect = null;
                if (queue.lastEffect === null) {
                  queue.firstEffect = queue.lastEffect = update;
                } else {
                  queue.lastEffect.nextEffect = update;
                  queue.lastEffect = update;
                }
              }
            }
            update = update.next;
          }
          var newFirstCapturedUpdate = null;
          update = queue.firstCapturedUpdate;
          while (update !== null) {
            var _updateExpirationTime = update.expirationTime;
            if (_updateExpirationTime < renderExpirationTime2) {
              if (newFirstCapturedUpdate === null) {
                newFirstCapturedUpdate = update;
                if (newFirstUpdate === null) {
                  newBaseState = resultState;
                }
              }
              if (newExpirationTime < _updateExpirationTime) {
                newExpirationTime = _updateExpirationTime;
              }
            } else {
              resultState = getStateFromUpdate(workInProgress2, queue, update, resultState, props, instance);
              var _callback = update.callback;
              if (_callback !== null) {
                workInProgress2.effectTag |= Callback;
                update.nextEffect = null;
                if (queue.lastCapturedEffect === null) {
                  queue.firstCapturedEffect = queue.lastCapturedEffect = update;
                } else {
                  queue.lastCapturedEffect.nextEffect = update;
                  queue.lastCapturedEffect = update;
                }
              }
            }
            update = update.next;
          }
          if (newFirstUpdate === null) {
            queue.lastUpdate = null;
          }
          if (newFirstCapturedUpdate === null) {
            queue.lastCapturedUpdate = null;
          } else {
            workInProgress2.effectTag |= Callback;
          }
          if (newFirstUpdate === null && newFirstCapturedUpdate === null) {
            newBaseState = resultState;
          }
          queue.baseState = newBaseState;
          queue.firstUpdate = newFirstUpdate;
          queue.firstCapturedUpdate = newFirstCapturedUpdate;
          markUnprocessedUpdateTime(newExpirationTime);
          workInProgress2.expirationTime = newExpirationTime;
          workInProgress2.memoizedState = resultState;
          {
            currentlyProcessingQueue = null;
          }
        }
        function callCallback(callback, context) {
          if (!(typeof callback === "function")) {
            {
              throw Error("Invalid argument passed as callback. Expected a function. Instead received: " + callback);
            }
          }
          callback.call(context);
        }
        function resetHasForceUpdateBeforeProcessing() {
          hasForceUpdate = false;
        }
        function checkHasForceUpdateAfterProcessing() {
          return hasForceUpdate;
        }
        function commitUpdateQueue(finishedWork, finishedQueue, instance, renderExpirationTime2) {
          if (finishedQueue.firstCapturedUpdate !== null) {
            if (finishedQueue.lastUpdate !== null) {
              finishedQueue.lastUpdate.next = finishedQueue.firstCapturedUpdate;
              finishedQueue.lastUpdate = finishedQueue.lastCapturedUpdate;
            }
            finishedQueue.firstCapturedUpdate = finishedQueue.lastCapturedUpdate = null;
          }
          commitUpdateEffects(finishedQueue.firstEffect, instance);
          finishedQueue.firstEffect = finishedQueue.lastEffect = null;
          commitUpdateEffects(finishedQueue.firstCapturedEffect, instance);
          finishedQueue.firstCapturedEffect = finishedQueue.lastCapturedEffect = null;
        }
        function commitUpdateEffects(effect, instance) {
          while (effect !== null) {
            var callback = effect.callback;
            if (callback !== null) {
              effect.callback = null;
              callCallback(callback, instance);
            }
            effect = effect.nextEffect;
          }
        }
        var ReactCurrentBatchConfig = ReactSharedInternals.ReactCurrentBatchConfig;
        function requestCurrentSuspenseConfig() {
          return ReactCurrentBatchConfig.suspense;
        }
        var fakeInternalInstance = {};
        var isArray$1 = Array.isArray;
        var emptyRefsObject = new React7.Component().refs;
        var didWarnAboutStateAssignmentForComponent;
        var didWarnAboutUninitializedState;
        var didWarnAboutGetSnapshotBeforeUpdateWithoutDidUpdate;
        var didWarnAboutLegacyLifecyclesAndDerivedState;
        var didWarnAboutUndefinedDerivedState;
        var warnOnUndefinedDerivedState;
        var warnOnInvalidCallback;
        var didWarnAboutDirectlyAssigningPropsToState;
        var didWarnAboutContextTypeAndContextTypes;
        var didWarnAboutInvalidateContextType;
        {
          didWarnAboutStateAssignmentForComponent = /* @__PURE__ */ new Set();
          didWarnAboutUninitializedState = /* @__PURE__ */ new Set();
          didWarnAboutGetSnapshotBeforeUpdateWithoutDidUpdate = /* @__PURE__ */ new Set();
          didWarnAboutLegacyLifecyclesAndDerivedState = /* @__PURE__ */ new Set();
          didWarnAboutDirectlyAssigningPropsToState = /* @__PURE__ */ new Set();
          didWarnAboutUndefinedDerivedState = /* @__PURE__ */ new Set();
          didWarnAboutContextTypeAndContextTypes = /* @__PURE__ */ new Set();
          didWarnAboutInvalidateContextType = /* @__PURE__ */ new Set();
          var didWarnOnInvalidCallback = /* @__PURE__ */ new Set();
          warnOnInvalidCallback = function(callback, callerName) {
            if (callback === null || typeof callback === "function") {
              return;
            }
            var key2 = callerName + "_" + callback;
            if (!didWarnOnInvalidCallback.has(key2)) {
              didWarnOnInvalidCallback.add(key2);
              warningWithoutStack$1(false, "%s(...): Expected the last optional `callback` argument to be a function. Instead received: %s.", callerName, callback);
            }
          };
          warnOnUndefinedDerivedState = function(type3, partialState) {
            if (partialState === void 0) {
              var componentName = getComponentName(type3) || "Component";
              if (!didWarnAboutUndefinedDerivedState.has(componentName)) {
                didWarnAboutUndefinedDerivedState.add(componentName);
                warningWithoutStack$1(false, "%s.getDerivedStateFromProps(): A valid state object (or null) must be returned. You have returned undefined.", componentName);
              }
            }
          };
          Object.defineProperty(fakeInternalInstance, "_processChildContext", {
            enumerable: false,
            value: function() {
              {
                {
                  throw Error("_processChildContext is not available in React 16+. This likely means you have multiple copies of React and are attempting to nest a React 15 tree inside a React 16 tree using unstable_renderSubtreeIntoContainer, which isn't supported. Try to make sure you have only one copy of React (and ideally, switch to ReactDOM.createPortal).");
                }
              }
            }
          });
          Object.freeze(fakeInternalInstance);
        }
        function applyDerivedStateFromProps(workInProgress2, ctor, getDerivedStateFromProps, nextProps) {
          var prevState = workInProgress2.memoizedState;
          {
            if (debugRenderPhaseSideEffectsForStrictMode && workInProgress2.mode & StrictMode) {
              getDerivedStateFromProps(nextProps, prevState);
            }
          }
          var partialState = getDerivedStateFromProps(nextProps, prevState);
          {
            warnOnUndefinedDerivedState(ctor, partialState);
          }
          var memoizedState = partialState === null || partialState === void 0 ? prevState : _assign({}, prevState, partialState);
          workInProgress2.memoizedState = memoizedState;
          var updateQueue = workInProgress2.updateQueue;
          if (updateQueue !== null && workInProgress2.expirationTime === NoWork) {
            updateQueue.baseState = memoizedState;
          }
        }
        var classComponentUpdater = {
          isMounted,
          enqueueSetState: function(inst, payload, callback) {
            var fiber = get(inst);
            var currentTime = requestCurrentTimeForUpdate();
            var suspenseConfig = requestCurrentSuspenseConfig();
            var expirationTime = computeExpirationForFiber(currentTime, fiber, suspenseConfig);
            var update = createUpdate(expirationTime, suspenseConfig);
            update.payload = payload;
            if (callback !== void 0 && callback !== null) {
              {
                warnOnInvalidCallback(callback, "setState");
              }
              update.callback = callback;
            }
            enqueueUpdate(fiber, update);
            scheduleWork(fiber, expirationTime);
          },
          enqueueReplaceState: function(inst, payload, callback) {
            var fiber = get(inst);
            var currentTime = requestCurrentTimeForUpdate();
            var suspenseConfig = requestCurrentSuspenseConfig();
            var expirationTime = computeExpirationForFiber(currentTime, fiber, suspenseConfig);
            var update = createUpdate(expirationTime, suspenseConfig);
            update.tag = ReplaceState;
            update.payload = payload;
            if (callback !== void 0 && callback !== null) {
              {
                warnOnInvalidCallback(callback, "replaceState");
              }
              update.callback = callback;
            }
            enqueueUpdate(fiber, update);
            scheduleWork(fiber, expirationTime);
          },
          enqueueForceUpdate: function(inst, callback) {
            var fiber = get(inst);
            var currentTime = requestCurrentTimeForUpdate();
            var suspenseConfig = requestCurrentSuspenseConfig();
            var expirationTime = computeExpirationForFiber(currentTime, fiber, suspenseConfig);
            var update = createUpdate(expirationTime, suspenseConfig);
            update.tag = ForceUpdate;
            if (callback !== void 0 && callback !== null) {
              {
                warnOnInvalidCallback(callback, "forceUpdate");
              }
              update.callback = callback;
            }
            enqueueUpdate(fiber, update);
            scheduleWork(fiber, expirationTime);
          }
        };
        function checkShouldComponentUpdate(workInProgress2, ctor, oldProps, newProps, oldState, newState, nextContext) {
          var instance = workInProgress2.stateNode;
          if (typeof instance.shouldComponentUpdate === "function") {
            startPhaseTimer(workInProgress2, "shouldComponentUpdate");
            var shouldUpdate = instance.shouldComponentUpdate(newProps, newState, nextContext);
            stopPhaseTimer();
            {
              !(shouldUpdate !== void 0) ? warningWithoutStack$1(false, "%s.shouldComponentUpdate(): Returned undefined instead of a boolean value. Make sure to return true or false.", getComponentName(ctor) || "Component") : void 0;
            }
            return shouldUpdate;
          }
          if (ctor.prototype && ctor.prototype.isPureReactComponent) {
            return !shallowEqual(oldProps, newProps) || !shallowEqual(oldState, newState);
          }
          return true;
        }
        function checkClassInstance(workInProgress2, ctor, newProps) {
          var instance = workInProgress2.stateNode;
          {
            var name = getComponentName(ctor) || "Component";
            var renderPresent = instance.render;
            if (!renderPresent) {
              if (ctor.prototype && typeof ctor.prototype.render === "function") {
                warningWithoutStack$1(false, "%s(...): No `render` method found on the returned component instance: did you accidentally return an object from the constructor?", name);
              } else {
                warningWithoutStack$1(false, "%s(...): No `render` method found on the returned component instance: you may have forgotten to define `render`.", name);
              }
            }
            var noGetInitialStateOnES6 = !instance.getInitialState || instance.getInitialState.isReactClassApproved || instance.state;
            !noGetInitialStateOnES6 ? warningWithoutStack$1(false, "getInitialState was defined on %s, a plain JavaScript class. This is only supported for classes created using React.createClass. Did you mean to define a state property instead?", name) : void 0;
            var noGetDefaultPropsOnES6 = !instance.getDefaultProps || instance.getDefaultProps.isReactClassApproved;
            !noGetDefaultPropsOnES6 ? warningWithoutStack$1(false, "getDefaultProps was defined on %s, a plain JavaScript class. This is only supported for classes created using React.createClass. Use a static property to define defaultProps instead.", name) : void 0;
            var noInstancePropTypes = !instance.propTypes;
            !noInstancePropTypes ? warningWithoutStack$1(false, "propTypes was defined as an instance property on %s. Use a static property to define propTypes instead.", name) : void 0;
            var noInstanceContextType = !instance.contextType;
            !noInstanceContextType ? warningWithoutStack$1(false, "contextType was defined as an instance property on %s. Use a static property to define contextType instead.", name) : void 0;
            if (disableLegacyContext) {
              if (ctor.childContextTypes) {
                warningWithoutStack$1(false, "%s uses the legacy childContextTypes API which is no longer supported. Use React.createContext() instead.", name);
              }
              if (ctor.contextTypes) {
                warningWithoutStack$1(false, "%s uses the legacy contextTypes API which is no longer supported. Use React.createContext() with static contextType instead.", name);
              }
            } else {
              var noInstanceContextTypes = !instance.contextTypes;
              !noInstanceContextTypes ? warningWithoutStack$1(false, "contextTypes was defined as an instance property on %s. Use a static property to define contextTypes instead.", name) : void 0;
              if (ctor.contextType && ctor.contextTypes && !didWarnAboutContextTypeAndContextTypes.has(ctor)) {
                didWarnAboutContextTypeAndContextTypes.add(ctor);
                warningWithoutStack$1(false, "%s declares both contextTypes and contextType static properties. The legacy contextTypes property will be ignored.", name);
              }
            }
            var noComponentShouldUpdate = typeof instance.componentShouldUpdate !== "function";
            !noComponentShouldUpdate ? warningWithoutStack$1(false, "%s has a method called componentShouldUpdate(). Did you mean shouldComponentUpdate()? The name is phrased as a question because the function is expected to return a value.", name) : void 0;
            if (ctor.prototype && ctor.prototype.isPureReactComponent && typeof instance.shouldComponentUpdate !== "undefined") {
              warningWithoutStack$1(false, "%s has a method called shouldComponentUpdate(). shouldComponentUpdate should not be used when extending React.PureComponent. Please extend React.Component if shouldComponentUpdate is used.", getComponentName(ctor) || "A pure component");
            }
            var noComponentDidUnmount = typeof instance.componentDidUnmount !== "function";
            !noComponentDidUnmount ? warningWithoutStack$1(false, "%s has a method called componentDidUnmount(). But there is no such lifecycle method. Did you mean componentWillUnmount()?", name) : void 0;
            var noComponentDidReceiveProps = typeof instance.componentDidReceiveProps !== "function";
            !noComponentDidReceiveProps ? warningWithoutStack$1(false, "%s has a method called componentDidReceiveProps(). But there is no such lifecycle method. If you meant to update the state in response to changing props, use componentWillReceiveProps(). If you meant to fetch data or run side-effects or mutations after React has updated the UI, use componentDidUpdate().", name) : void 0;
            var noComponentWillRecieveProps = typeof instance.componentWillRecieveProps !== "function";
            !noComponentWillRecieveProps ? warningWithoutStack$1(false, "%s has a method called componentWillRecieveProps(). Did you mean componentWillReceiveProps()?", name) : void 0;
            var noUnsafeComponentWillRecieveProps = typeof instance.UNSAFE_componentWillRecieveProps !== "function";
            !noUnsafeComponentWillRecieveProps ? warningWithoutStack$1(false, "%s has a method called UNSAFE_componentWillRecieveProps(). Did you mean UNSAFE_componentWillReceiveProps()?", name) : void 0;
            var hasMutatedProps = instance.props !== newProps;
            !(instance.props === void 0 || !hasMutatedProps) ? warningWithoutStack$1(false, "%s(...): When calling super() in `%s`, make sure to pass up the same props that your component's constructor was passed.", name, name) : void 0;
            var noInstanceDefaultProps = !instance.defaultProps;
            !noInstanceDefaultProps ? warningWithoutStack$1(false, "Setting defaultProps as an instance property on %s is not supported and will be ignored. Instead, define defaultProps as a static property on %s.", name, name) : void 0;
            if (typeof instance.getSnapshotBeforeUpdate === "function" && typeof instance.componentDidUpdate !== "function" && !didWarnAboutGetSnapshotBeforeUpdateWithoutDidUpdate.has(ctor)) {
              didWarnAboutGetSnapshotBeforeUpdateWithoutDidUpdate.add(ctor);
              warningWithoutStack$1(false, "%s: getSnapshotBeforeUpdate() should be used with componentDidUpdate(). This component defines getSnapshotBeforeUpdate() only.", getComponentName(ctor));
            }
            var noInstanceGetDerivedStateFromProps = typeof instance.getDerivedStateFromProps !== "function";
            !noInstanceGetDerivedStateFromProps ? warningWithoutStack$1(false, "%s: getDerivedStateFromProps() is defined as an instance method and will be ignored. Instead, declare it as a static method.", name) : void 0;
            var noInstanceGetDerivedStateFromCatch = typeof instance.getDerivedStateFromError !== "function";
            !noInstanceGetDerivedStateFromCatch ? warningWithoutStack$1(false, "%s: getDerivedStateFromError() is defined as an instance method and will be ignored. Instead, declare it as a static method.", name) : void 0;
            var noStaticGetSnapshotBeforeUpdate = typeof ctor.getSnapshotBeforeUpdate !== "function";
            !noStaticGetSnapshotBeforeUpdate ? warningWithoutStack$1(false, "%s: getSnapshotBeforeUpdate() is defined as a static method and will be ignored. Instead, declare it as an instance method.", name) : void 0;
            var _state = instance.state;
            if (_state && (typeof _state !== "object" || isArray$1(_state))) {
              warningWithoutStack$1(false, "%s.state: must be set to an object or null", name);
            }
            if (typeof instance.getChildContext === "function") {
              !(typeof ctor.childContextTypes === "object") ? warningWithoutStack$1(false, "%s.getChildContext(): childContextTypes must be defined in order to use getChildContext().", name) : void 0;
            }
          }
        }
        function adoptClassInstance(workInProgress2, instance) {
          instance.updater = classComponentUpdater;
          workInProgress2.stateNode = instance;
          set2(instance, workInProgress2);
          {
            instance._reactInternalInstance = fakeInternalInstance;
          }
        }
        function constructClassInstance(workInProgress2, ctor, props, renderExpirationTime2) {
          var isLegacyContextConsumer = false;
          var unmaskedContext = emptyContextObject;
          var context = emptyContextObject;
          var contextType = ctor.contextType;
          {
            if ("contextType" in ctor) {
              var isValid = contextType === null || contextType !== void 0 && contextType.$$typeof === REACT_CONTEXT_TYPE && contextType._context === void 0;
              if (!isValid && !didWarnAboutInvalidateContextType.has(ctor)) {
                didWarnAboutInvalidateContextType.add(ctor);
                var addendum = "";
                if (contextType === void 0) {
                  addendum = " However, it is set to undefined. This can be caused by a typo or by mixing up named and default imports. This can also happen due to a circular dependency, so try moving the createContext() call to a separate file.";
                } else if (typeof contextType !== "object") {
                  addendum = " However, it is set to a " + typeof contextType + ".";
                } else if (contextType.$$typeof === REACT_PROVIDER_TYPE) {
                  addendum = " Did you accidentally pass the Context.Provider instead?";
                } else if (contextType._context !== void 0) {
                  addendum = " Did you accidentally pass the Context.Consumer instead?";
                } else {
                  addendum = " However, it is set to an object with keys {" + Object.keys(contextType).join(", ") + "}.";
                }
                warningWithoutStack$1(false, "%s defines an invalid contextType. contextType should point to the Context object returned by React.createContext().%s", getComponentName(ctor) || "Component", addendum);
              }
            }
          }
          if (typeof contextType === "object" && contextType !== null) {
            context = readContext(contextType);
          } else if (!disableLegacyContext) {
            unmaskedContext = getUnmaskedContext(workInProgress2, ctor, true);
            var contextTypes = ctor.contextTypes;
            isLegacyContextConsumer = contextTypes !== null && contextTypes !== void 0;
            context = isLegacyContextConsumer ? getMaskedContext(workInProgress2, unmaskedContext) : emptyContextObject;
          }
          {
            if (debugRenderPhaseSideEffectsForStrictMode && workInProgress2.mode & StrictMode) {
              new ctor(props, context);
            }
          }
          var instance = new ctor(props, context);
          var state = workInProgress2.memoizedState = instance.state !== null && instance.state !== void 0 ? instance.state : null;
          adoptClassInstance(workInProgress2, instance);
          {
            if (typeof ctor.getDerivedStateFromProps === "function" && state === null) {
              var componentName = getComponentName(ctor) || "Component";
              if (!didWarnAboutUninitializedState.has(componentName)) {
                didWarnAboutUninitializedState.add(componentName);
                warningWithoutStack$1(false, "`%s` uses `getDerivedStateFromProps` but its initial state is %s. This is not recommended. Instead, define the initial state by assigning an object to `this.state` in the constructor of `%s`. This ensures that `getDerivedStateFromProps` arguments have a consistent shape.", componentName, instance.state === null ? "null" : "undefined", componentName);
              }
            }
            if (typeof ctor.getDerivedStateFromProps === "function" || typeof instance.getSnapshotBeforeUpdate === "function") {
              var foundWillMountName = null;
              var foundWillReceivePropsName = null;
              var foundWillUpdateName = null;
              if (typeof instance.componentWillMount === "function" && instance.componentWillMount.__suppressDeprecationWarning !== true) {
                foundWillMountName = "componentWillMount";
              } else if (typeof instance.UNSAFE_componentWillMount === "function") {
                foundWillMountName = "UNSAFE_componentWillMount";
              }
              if (typeof instance.componentWillReceiveProps === "function" && instance.componentWillReceiveProps.__suppressDeprecationWarning !== true) {
                foundWillReceivePropsName = "componentWillReceiveProps";
              } else if (typeof instance.UNSAFE_componentWillReceiveProps === "function") {
                foundWillReceivePropsName = "UNSAFE_componentWillReceiveProps";
              }
              if (typeof instance.componentWillUpdate === "function" && instance.componentWillUpdate.__suppressDeprecationWarning !== true) {
                foundWillUpdateName = "componentWillUpdate";
              } else if (typeof instance.UNSAFE_componentWillUpdate === "function") {
                foundWillUpdateName = "UNSAFE_componentWillUpdate";
              }
              if (foundWillMountName !== null || foundWillReceivePropsName !== null || foundWillUpdateName !== null) {
                var _componentName = getComponentName(ctor) || "Component";
                var newApiName = typeof ctor.getDerivedStateFromProps === "function" ? "getDerivedStateFromProps()" : "getSnapshotBeforeUpdate()";
                if (!didWarnAboutLegacyLifecyclesAndDerivedState.has(_componentName)) {
                  didWarnAboutLegacyLifecyclesAndDerivedState.add(_componentName);
                  warningWithoutStack$1(false, "Unsafe legacy lifecycles will not be called for components using new component APIs.\n\n%s uses %s but also contains the following legacy lifecycles:%s%s%s\n\nThe above lifecycles should be removed. Learn more about this warning here:\nhttps://fb.me/react-unsafe-component-lifecycles", _componentName, newApiName, foundWillMountName !== null ? "\n  " + foundWillMountName : "", foundWillReceivePropsName !== null ? "\n  " + foundWillReceivePropsName : "", foundWillUpdateName !== null ? "\n  " + foundWillUpdateName : "");
                }
              }
            }
          }
          if (isLegacyContextConsumer) {
            cacheContext(workInProgress2, unmaskedContext, context);
          }
          return instance;
        }
        function callComponentWillMount(workInProgress2, instance) {
          startPhaseTimer(workInProgress2, "componentWillMount");
          var oldState = instance.state;
          if (typeof instance.componentWillMount === "function") {
            instance.componentWillMount();
          }
          if (typeof instance.UNSAFE_componentWillMount === "function") {
            instance.UNSAFE_componentWillMount();
          }
          stopPhaseTimer();
          if (oldState !== instance.state) {
            {
              warningWithoutStack$1(false, "%s.componentWillMount(): Assigning directly to this.state is deprecated (except inside a component's constructor). Use setState instead.", getComponentName(workInProgress2.type) || "Component");
            }
            classComponentUpdater.enqueueReplaceState(instance, instance.state, null);
          }
        }
        function callComponentWillReceiveProps(workInProgress2, instance, newProps, nextContext) {
          var oldState = instance.state;
          startPhaseTimer(workInProgress2, "componentWillReceiveProps");
          if (typeof instance.componentWillReceiveProps === "function") {
            instance.componentWillReceiveProps(newProps, nextContext);
          }
          if (typeof instance.UNSAFE_componentWillReceiveProps === "function") {
            instance.UNSAFE_componentWillReceiveProps(newProps, nextContext);
          }
          stopPhaseTimer();
          if (instance.state !== oldState) {
            {
              var componentName = getComponentName(workInProgress2.type) || "Component";
              if (!didWarnAboutStateAssignmentForComponent.has(componentName)) {
                didWarnAboutStateAssignmentForComponent.add(componentName);
                warningWithoutStack$1(false, "%s.componentWillReceiveProps(): Assigning directly to this.state is deprecated (except inside a component's constructor). Use setState instead.", componentName);
              }
            }
            classComponentUpdater.enqueueReplaceState(instance, instance.state, null);
          }
        }
        function mountClassInstance(workInProgress2, ctor, newProps, renderExpirationTime2) {
          {
            checkClassInstance(workInProgress2, ctor, newProps);
          }
          var instance = workInProgress2.stateNode;
          instance.props = newProps;
          instance.state = workInProgress2.memoizedState;
          instance.refs = emptyRefsObject;
          var contextType = ctor.contextType;
          if (typeof contextType === "object" && contextType !== null) {
            instance.context = readContext(contextType);
          } else if (disableLegacyContext) {
            instance.context = emptyContextObject;
          } else {
            var unmaskedContext = getUnmaskedContext(workInProgress2, ctor, true);
            instance.context = getMaskedContext(workInProgress2, unmaskedContext);
          }
          {
            if (instance.state === newProps) {
              var componentName = getComponentName(ctor) || "Component";
              if (!didWarnAboutDirectlyAssigningPropsToState.has(componentName)) {
                didWarnAboutDirectlyAssigningPropsToState.add(componentName);
                warningWithoutStack$1(false, "%s: It is not recommended to assign props directly to state because updates to props won't be reflected in state. In most cases, it is better to use props directly.", componentName);
              }
            }
            if (workInProgress2.mode & StrictMode) {
              ReactStrictModeWarnings.recordLegacyContextWarning(workInProgress2, instance);
            }
            if (warnAboutDeprecatedLifecycles) {
              ReactStrictModeWarnings.recordUnsafeLifecycleWarnings(workInProgress2, instance);
            }
          }
          var updateQueue = workInProgress2.updateQueue;
          if (updateQueue !== null) {
            processUpdateQueue(workInProgress2, updateQueue, newProps, instance, renderExpirationTime2);
            instance.state = workInProgress2.memoizedState;
          }
          var getDerivedStateFromProps = ctor.getDerivedStateFromProps;
          if (typeof getDerivedStateFromProps === "function") {
            applyDerivedStateFromProps(workInProgress2, ctor, getDerivedStateFromProps, newProps);
            instance.state = workInProgress2.memoizedState;
          }
          if (typeof ctor.getDerivedStateFromProps !== "function" && typeof instance.getSnapshotBeforeUpdate !== "function" && (typeof instance.UNSAFE_componentWillMount === "function" || typeof instance.componentWillMount === "function")) {
            callComponentWillMount(workInProgress2, instance);
            updateQueue = workInProgress2.updateQueue;
            if (updateQueue !== null) {
              processUpdateQueue(workInProgress2, updateQueue, newProps, instance, renderExpirationTime2);
              instance.state = workInProgress2.memoizedState;
            }
          }
          if (typeof instance.componentDidMount === "function") {
            workInProgress2.effectTag |= Update;
          }
        }
        function resumeMountClassInstance(workInProgress2, ctor, newProps, renderExpirationTime2) {
          var instance = workInProgress2.stateNode;
          var oldProps = workInProgress2.memoizedProps;
          instance.props = oldProps;
          var oldContext = instance.context;
          var contextType = ctor.contextType;
          var nextContext = emptyContextObject;
          if (typeof contextType === "object" && contextType !== null) {
            nextContext = readContext(contextType);
          } else if (!disableLegacyContext) {
            var nextLegacyUnmaskedContext = getUnmaskedContext(workInProgress2, ctor, true);
            nextContext = getMaskedContext(workInProgress2, nextLegacyUnmaskedContext);
          }
          var getDerivedStateFromProps = ctor.getDerivedStateFromProps;
          var hasNewLifecycles = typeof getDerivedStateFromProps === "function" || typeof instance.getSnapshotBeforeUpdate === "function";
          if (!hasNewLifecycles && (typeof instance.UNSAFE_componentWillReceiveProps === "function" || typeof instance.componentWillReceiveProps === "function")) {
            if (oldProps !== newProps || oldContext !== nextContext) {
              callComponentWillReceiveProps(workInProgress2, instance, newProps, nextContext);
            }
          }
          resetHasForceUpdateBeforeProcessing();
          var oldState = workInProgress2.memoizedState;
          var newState = instance.state = oldState;
          var updateQueue = workInProgress2.updateQueue;
          if (updateQueue !== null) {
            processUpdateQueue(workInProgress2, updateQueue, newProps, instance, renderExpirationTime2);
            newState = workInProgress2.memoizedState;
          }
          if (oldProps === newProps && oldState === newState && !hasContextChanged() && !checkHasForceUpdateAfterProcessing()) {
            if (typeof instance.componentDidMount === "function") {
              workInProgress2.effectTag |= Update;
            }
            return false;
          }
          if (typeof getDerivedStateFromProps === "function") {
            applyDerivedStateFromProps(workInProgress2, ctor, getDerivedStateFromProps, newProps);
            newState = workInProgress2.memoizedState;
          }
          var shouldUpdate = checkHasForceUpdateAfterProcessing() || checkShouldComponentUpdate(workInProgress2, ctor, oldProps, newProps, oldState, newState, nextContext);
          if (shouldUpdate) {
            if (!hasNewLifecycles && (typeof instance.UNSAFE_componentWillMount === "function" || typeof instance.componentWillMount === "function")) {
              startPhaseTimer(workInProgress2, "componentWillMount");
              if (typeof instance.componentWillMount === "function") {
                instance.componentWillMount();
              }
              if (typeof instance.UNSAFE_componentWillMount === "function") {
                instance.UNSAFE_componentWillMount();
              }
              stopPhaseTimer();
            }
            if (typeof instance.componentDidMount === "function") {
              workInProgress2.effectTag |= Update;
            }
          } else {
            if (typeof instance.componentDidMount === "function") {
              workInProgress2.effectTag |= Update;
            }
            workInProgress2.memoizedProps = newProps;
            workInProgress2.memoizedState = newState;
          }
          instance.props = newProps;
          instance.state = newState;
          instance.context = nextContext;
          return shouldUpdate;
        }
        function updateClassInstance(current2, workInProgress2, ctor, newProps, renderExpirationTime2) {
          var instance = workInProgress2.stateNode;
          var oldProps = workInProgress2.memoizedProps;
          instance.props = workInProgress2.type === workInProgress2.elementType ? oldProps : resolveDefaultProps(workInProgress2.type, oldProps);
          var oldContext = instance.context;
          var contextType = ctor.contextType;
          var nextContext = emptyContextObject;
          if (typeof contextType === "object" && contextType !== null) {
            nextContext = readContext(contextType);
          } else if (!disableLegacyContext) {
            var nextUnmaskedContext = getUnmaskedContext(workInProgress2, ctor, true);
            nextContext = getMaskedContext(workInProgress2, nextUnmaskedContext);
          }
          var getDerivedStateFromProps = ctor.getDerivedStateFromProps;
          var hasNewLifecycles = typeof getDerivedStateFromProps === "function" || typeof instance.getSnapshotBeforeUpdate === "function";
          if (!hasNewLifecycles && (typeof instance.UNSAFE_componentWillReceiveProps === "function" || typeof instance.componentWillReceiveProps === "function")) {
            if (oldProps !== newProps || oldContext !== nextContext) {
              callComponentWillReceiveProps(workInProgress2, instance, newProps, nextContext);
            }
          }
          resetHasForceUpdateBeforeProcessing();
          var oldState = workInProgress2.memoizedState;
          var newState = instance.state = oldState;
          var updateQueue = workInProgress2.updateQueue;
          if (updateQueue !== null) {
            processUpdateQueue(workInProgress2, updateQueue, newProps, instance, renderExpirationTime2);
            newState = workInProgress2.memoizedState;
          }
          if (oldProps === newProps && oldState === newState && !hasContextChanged() && !checkHasForceUpdateAfterProcessing()) {
            if (typeof instance.componentDidUpdate === "function") {
              if (oldProps !== current2.memoizedProps || oldState !== current2.memoizedState) {
                workInProgress2.effectTag |= Update;
              }
            }
            if (typeof instance.getSnapshotBeforeUpdate === "function") {
              if (oldProps !== current2.memoizedProps || oldState !== current2.memoizedState) {
                workInProgress2.effectTag |= Snapshot;
              }
            }
            return false;
          }
          if (typeof getDerivedStateFromProps === "function") {
            applyDerivedStateFromProps(workInProgress2, ctor, getDerivedStateFromProps, newProps);
            newState = workInProgress2.memoizedState;
          }
          var shouldUpdate = checkHasForceUpdateAfterProcessing() || checkShouldComponentUpdate(workInProgress2, ctor, oldProps, newProps, oldState, newState, nextContext);
          if (shouldUpdate) {
            if (!hasNewLifecycles && (typeof instance.UNSAFE_componentWillUpdate === "function" || typeof instance.componentWillUpdate === "function")) {
              startPhaseTimer(workInProgress2, "componentWillUpdate");
              if (typeof instance.componentWillUpdate === "function") {
                instance.componentWillUpdate(newProps, newState, nextContext);
              }
              if (typeof instance.UNSAFE_componentWillUpdate === "function") {
                instance.UNSAFE_componentWillUpdate(newProps, newState, nextContext);
              }
              stopPhaseTimer();
            }
            if (typeof instance.componentDidUpdate === "function") {
              workInProgress2.effectTag |= Update;
            }
            if (typeof instance.getSnapshotBeforeUpdate === "function") {
              workInProgress2.effectTag |= Snapshot;
            }
          } else {
            if (typeof instance.componentDidUpdate === "function") {
              if (oldProps !== current2.memoizedProps || oldState !== current2.memoizedState) {
                workInProgress2.effectTag |= Update;
              }
            }
            if (typeof instance.getSnapshotBeforeUpdate === "function") {
              if (oldProps !== current2.memoizedProps || oldState !== current2.memoizedState) {
                workInProgress2.effectTag |= Snapshot;
              }
            }
            workInProgress2.memoizedProps = newProps;
            workInProgress2.memoizedState = newState;
          }
          instance.props = newProps;
          instance.state = newState;
          instance.context = nextContext;
          return shouldUpdate;
        }
        var didWarnAboutMaps;
        var didWarnAboutGenerators;
        var didWarnAboutStringRefs;
        var ownerHasKeyUseWarning;
        var ownerHasFunctionTypeWarning;
        var warnForMissingKey = function(child) {
        };
        {
          didWarnAboutMaps = false;
          didWarnAboutGenerators = false;
          didWarnAboutStringRefs = {};
          ownerHasKeyUseWarning = {};
          ownerHasFunctionTypeWarning = {};
          warnForMissingKey = function(child) {
            if (child === null || typeof child !== "object") {
              return;
            }
            if (!child._store || child._store.validated || child.key != null) {
              return;
            }
            if (!(typeof child._store === "object")) {
              {
                throw Error("React Component in warnForMissingKey should have a _store. This error is likely caused by a bug in React. Please file an issue.");
              }
            }
            child._store.validated = true;
            var currentComponentErrorInfo = 'Each child in a list should have a unique "key" prop. See https://fb.me/react-warning-keys for more information.' + getCurrentFiberStackInDev();
            if (ownerHasKeyUseWarning[currentComponentErrorInfo]) {
              return;
            }
            ownerHasKeyUseWarning[currentComponentErrorInfo] = true;
            warning$1(false, 'Each child in a list should have a unique "key" prop. See https://fb.me/react-warning-keys for more information.');
          };
        }
        var isArray = Array.isArray;
        function coerceRef(returnFiber, current$$1, element) {
          var mixedRef = element.ref;
          if (mixedRef !== null && typeof mixedRef !== "function" && typeof mixedRef !== "object") {
            {
              if (returnFiber.mode & StrictMode || warnAboutStringRefs) {
                var componentName = getComponentName(returnFiber.type) || "Component";
                if (!didWarnAboutStringRefs[componentName]) {
                  if (warnAboutStringRefs) {
                    warningWithoutStack$1(false, 'Component "%s" contains the string ref "%s". Support for string refs will be removed in a future major release. We recommend using useRef() or createRef() instead. Learn more about using refs safely here: https://fb.me/react-strict-mode-string-ref%s', componentName, mixedRef, getStackByFiberInDevAndProd(returnFiber));
                  } else {
                    warningWithoutStack$1(false, 'A string ref, "%s", has been found within a strict mode tree. String refs are a source of potential bugs and should be avoided. We recommend using useRef() or createRef() instead. Learn more about using refs safely here: https://fb.me/react-strict-mode-string-ref%s', mixedRef, getStackByFiberInDevAndProd(returnFiber));
                  }
                  didWarnAboutStringRefs[componentName] = true;
                }
              }
            }
            if (element._owner) {
              var owner = element._owner;
              var inst;
              if (owner) {
                var ownerFiber = owner;
                if (!(ownerFiber.tag === ClassComponent)) {
                  {
                    throw Error("Function components cannot have refs. Did you mean to use React.forwardRef()?");
                  }
                }
                inst = ownerFiber.stateNode;
              }
              if (!inst) {
                {
                  throw Error("Missing owner for string ref " + mixedRef + ". This error is likely caused by a bug in React. Please file an issue.");
                }
              }
              var stringRef = "" + mixedRef;
              if (current$$1 !== null && current$$1.ref !== null && typeof current$$1.ref === "function" && current$$1.ref._stringRef === stringRef) {
                return current$$1.ref;
              }
              var ref2 = function(value) {
                var refs = inst.refs;
                if (refs === emptyRefsObject) {
                  refs = inst.refs = {};
                }
                if (value === null) {
                  delete refs[stringRef];
                } else {
                  refs[stringRef] = value;
                }
              };
              ref2._stringRef = stringRef;
              return ref2;
            } else {
              if (!(typeof mixedRef === "string")) {
                {
                  throw Error("Expected ref to be a function, a string, an object returned by React.createRef(), or null.");
                }
              }
              if (!element._owner) {
                {
                  throw Error("Element ref was specified as a string (" + mixedRef + ") but no owner was set. This could happen for one of the following reasons:\n1. You may be adding a ref to a function component\n2. You may be adding a ref to a component that was not created inside a component's render method\n3. You have multiple copies of React loaded\nSee https://fb.me/react-refs-must-have-owner for more information.");
                }
              }
            }
          }
          return mixedRef;
        }
        function throwOnInvalidObjectType(returnFiber, newChild) {
          if (returnFiber.type !== "textarea") {
            var addendum = "";
            {
              addendum = " If you meant to render a collection of children, use an array instead." + getCurrentFiberStackInDev();
            }
            {
              {
                throw Error("Objects are not valid as a React child (found: " + (Object.prototype.toString.call(newChild) === "[object Object]" ? "object with keys {" + Object.keys(newChild).join(", ") + "}" : newChild) + ")." + addendum);
              }
            }
          }
        }
        function warnOnFunctionType() {
          var currentComponentErrorInfo = "Functions are not valid as a React child. This may happen if you return a Component instead of <Component /> from render. Or maybe you meant to call this function rather than return it." + getCurrentFiberStackInDev();
          if (ownerHasFunctionTypeWarning[currentComponentErrorInfo]) {
            return;
          }
          ownerHasFunctionTypeWarning[currentComponentErrorInfo] = true;
          warning$1(false, "Functions are not valid as a React child. This may happen if you return a Component instead of <Component /> from render. Or maybe you meant to call this function rather than return it.");
        }
        function ChildReconciler(shouldTrackSideEffects) {
          function deleteChild(returnFiber, childToDelete) {
            if (!shouldTrackSideEffects) {
              return;
            }
            var last = returnFiber.lastEffect;
            if (last !== null) {
              last.nextEffect = childToDelete;
              returnFiber.lastEffect = childToDelete;
            } else {
              returnFiber.firstEffect = returnFiber.lastEffect = childToDelete;
            }
            childToDelete.nextEffect = null;
            childToDelete.effectTag = Deletion;
          }
          function deleteRemainingChildren(returnFiber, currentFirstChild) {
            if (!shouldTrackSideEffects) {
              return null;
            }
            var childToDelete = currentFirstChild;
            while (childToDelete !== null) {
              deleteChild(returnFiber, childToDelete);
              childToDelete = childToDelete.sibling;
            }
            return null;
          }
          function mapRemainingChildren(returnFiber, currentFirstChild) {
            var existingChildren = /* @__PURE__ */ new Map();
            var existingChild = currentFirstChild;
            while (existingChild !== null) {
              if (existingChild.key !== null) {
                existingChildren.set(existingChild.key, existingChild);
              } else {
                existingChildren.set(existingChild.index, existingChild);
              }
              existingChild = existingChild.sibling;
            }
            return existingChildren;
          }
          function useFiber(fiber, pendingProps, expirationTime) {
            var clone = createWorkInProgress(fiber, pendingProps, expirationTime);
            clone.index = 0;
            clone.sibling = null;
            return clone;
          }
          function placeChild(newFiber, lastPlacedIndex, newIndex) {
            newFiber.index = newIndex;
            if (!shouldTrackSideEffects) {
              return lastPlacedIndex;
            }
            var current$$1 = newFiber.alternate;
            if (current$$1 !== null) {
              var oldIndex = current$$1.index;
              if (oldIndex < lastPlacedIndex) {
                newFiber.effectTag = Placement;
                return lastPlacedIndex;
              } else {
                return oldIndex;
              }
            } else {
              newFiber.effectTag = Placement;
              return lastPlacedIndex;
            }
          }
          function placeSingleChild(newFiber) {
            if (shouldTrackSideEffects && newFiber.alternate === null) {
              newFiber.effectTag = Placement;
            }
            return newFiber;
          }
          function updateTextNode(returnFiber, current$$1, textContent, expirationTime) {
            if (current$$1 === null || current$$1.tag !== HostText) {
              var created = createFiberFromText(textContent, returnFiber.mode, expirationTime);
              created.return = returnFiber;
              return created;
            } else {
              var existing = useFiber(current$$1, textContent, expirationTime);
              existing.return = returnFiber;
              return existing;
            }
          }
          function updateElement(returnFiber, current$$1, element, expirationTime) {
            if (current$$1 !== null && (current$$1.elementType === element.type || isCompatibleFamilyForHotReloading(current$$1, element))) {
              var existing = useFiber(current$$1, element.props, expirationTime);
              existing.ref = coerceRef(returnFiber, current$$1, element);
              existing.return = returnFiber;
              {
                existing._debugSource = element._source;
                existing._debugOwner = element._owner;
              }
              return existing;
            } else {
              var created = createFiberFromElement(element, returnFiber.mode, expirationTime);
              created.ref = coerceRef(returnFiber, current$$1, element);
              created.return = returnFiber;
              return created;
            }
          }
          function updatePortal(returnFiber, current$$1, portal, expirationTime) {
            if (current$$1 === null || current$$1.tag !== HostPortal || current$$1.stateNode.containerInfo !== portal.containerInfo || current$$1.stateNode.implementation !== portal.implementation) {
              var created = createFiberFromPortal(portal, returnFiber.mode, expirationTime);
              created.return = returnFiber;
              return created;
            } else {
              var existing = useFiber(current$$1, portal.children || [], expirationTime);
              existing.return = returnFiber;
              return existing;
            }
          }
          function updateFragment2(returnFiber, current$$1, fragment, expirationTime, key2) {
            if (current$$1 === null || current$$1.tag !== Fragment) {
              var created = createFiberFromFragment(fragment, returnFiber.mode, expirationTime, key2);
              created.return = returnFiber;
              return created;
            } else {
              var existing = useFiber(current$$1, fragment, expirationTime);
              existing.return = returnFiber;
              return existing;
            }
          }
          function createChild(returnFiber, newChild, expirationTime) {
            if (typeof newChild === "string" || typeof newChild === "number") {
              var created = createFiberFromText("" + newChild, returnFiber.mode, expirationTime);
              created.return = returnFiber;
              return created;
            }
            if (typeof newChild === "object" && newChild !== null) {
              switch (newChild.$$typeof) {
                case REACT_ELEMENT_TYPE: {
                  var _created = createFiberFromElement(newChild, returnFiber.mode, expirationTime);
                  _created.ref = coerceRef(returnFiber, null, newChild);
                  _created.return = returnFiber;
                  return _created;
                }
                case REACT_PORTAL_TYPE: {
                  var _created2 = createFiberFromPortal(newChild, returnFiber.mode, expirationTime);
                  _created2.return = returnFiber;
                  return _created2;
                }
              }
              if (isArray(newChild) || getIteratorFn(newChild)) {
                var _created3 = createFiberFromFragment(newChild, returnFiber.mode, expirationTime, null);
                _created3.return = returnFiber;
                return _created3;
              }
              throwOnInvalidObjectType(returnFiber, newChild);
            }
            {
              if (typeof newChild === "function") {
                warnOnFunctionType();
              }
            }
            return null;
          }
          function updateSlot(returnFiber, oldFiber, newChild, expirationTime) {
            var key2 = oldFiber !== null ? oldFiber.key : null;
            if (typeof newChild === "string" || typeof newChild === "number") {
              if (key2 !== null) {
                return null;
              }
              return updateTextNode(returnFiber, oldFiber, "" + newChild, expirationTime);
            }
            if (typeof newChild === "object" && newChild !== null) {
              switch (newChild.$$typeof) {
                case REACT_ELEMENT_TYPE: {
                  if (newChild.key === key2) {
                    if (newChild.type === REACT_FRAGMENT_TYPE) {
                      return updateFragment2(returnFiber, oldFiber, newChild.props.children, expirationTime, key2);
                    }
                    return updateElement(returnFiber, oldFiber, newChild, expirationTime);
                  } else {
                    return null;
                  }
                }
                case REACT_PORTAL_TYPE: {
                  if (newChild.key === key2) {
                    return updatePortal(returnFiber, oldFiber, newChild, expirationTime);
                  } else {
                    return null;
                  }
                }
              }
              if (isArray(newChild) || getIteratorFn(newChild)) {
                if (key2 !== null) {
                  return null;
                }
                return updateFragment2(returnFiber, oldFiber, newChild, expirationTime, null);
              }
              throwOnInvalidObjectType(returnFiber, newChild);
            }
            {
              if (typeof newChild === "function") {
                warnOnFunctionType();
              }
            }
            return null;
          }
          function updateFromMap(existingChildren, returnFiber, newIdx, newChild, expirationTime) {
            if (typeof newChild === "string" || typeof newChild === "number") {
              var matchedFiber = existingChildren.get(newIdx) || null;
              return updateTextNode(returnFiber, matchedFiber, "" + newChild, expirationTime);
            }
            if (typeof newChild === "object" && newChild !== null) {
              switch (newChild.$$typeof) {
                case REACT_ELEMENT_TYPE: {
                  var _matchedFiber = existingChildren.get(newChild.key === null ? newIdx : newChild.key) || null;
                  if (newChild.type === REACT_FRAGMENT_TYPE) {
                    return updateFragment2(returnFiber, _matchedFiber, newChild.props.children, expirationTime, newChild.key);
                  }
                  return updateElement(returnFiber, _matchedFiber, newChild, expirationTime);
                }
                case REACT_PORTAL_TYPE: {
                  var _matchedFiber2 = existingChildren.get(newChild.key === null ? newIdx : newChild.key) || null;
                  return updatePortal(returnFiber, _matchedFiber2, newChild, expirationTime);
                }
              }
              if (isArray(newChild) || getIteratorFn(newChild)) {
                var _matchedFiber3 = existingChildren.get(newIdx) || null;
                return updateFragment2(returnFiber, _matchedFiber3, newChild, expirationTime, null);
              }
              throwOnInvalidObjectType(returnFiber, newChild);
            }
            {
              if (typeof newChild === "function") {
                warnOnFunctionType();
              }
            }
            return null;
          }
          function warnOnInvalidKey(child, knownKeys) {
            {
              if (typeof child !== "object" || child === null) {
                return knownKeys;
              }
              switch (child.$$typeof) {
                case REACT_ELEMENT_TYPE:
                case REACT_PORTAL_TYPE:
                  warnForMissingKey(child);
                  var key2 = child.key;
                  if (typeof key2 !== "string") {
                    break;
                  }
                  if (knownKeys === null) {
                    knownKeys = /* @__PURE__ */ new Set();
                    knownKeys.add(key2);
                    break;
                  }
                  if (!knownKeys.has(key2)) {
                    knownKeys.add(key2);
                    break;
                  }
                  warning$1(false, "Encountered two children with the same key, `%s`. Keys should be unique so that components maintain their identity across updates. Non-unique keys may cause children to be duplicated and/or omitted \u2014 the behavior is unsupported and could change in a future version.", key2);
                  break;
                default:
                  break;
              }
            }
            return knownKeys;
          }
          function reconcileChildrenArray(returnFiber, currentFirstChild, newChildren, expirationTime) {
            {
              var knownKeys = null;
              for (var i3 = 0; i3 < newChildren.length; i3++) {
                var child = newChildren[i3];
                knownKeys = warnOnInvalidKey(child, knownKeys);
              }
            }
            var resultingFirstChild = null;
            var previousNewFiber = null;
            var oldFiber = currentFirstChild;
            var lastPlacedIndex = 0;
            var newIdx = 0;
            var nextOldFiber = null;
            for (; oldFiber !== null && newIdx < newChildren.length; newIdx++) {
              if (oldFiber.index > newIdx) {
                nextOldFiber = oldFiber;
                oldFiber = null;
              } else {
                nextOldFiber = oldFiber.sibling;
              }
              var newFiber = updateSlot(returnFiber, oldFiber, newChildren[newIdx], expirationTime);
              if (newFiber === null) {
                if (oldFiber === null) {
                  oldFiber = nextOldFiber;
                }
                break;
              }
              if (shouldTrackSideEffects) {
                if (oldFiber && newFiber.alternate === null) {
                  deleteChild(returnFiber, oldFiber);
                }
              }
              lastPlacedIndex = placeChild(newFiber, lastPlacedIndex, newIdx);
              if (previousNewFiber === null) {
                resultingFirstChild = newFiber;
              } else {
                previousNewFiber.sibling = newFiber;
              }
              previousNewFiber = newFiber;
              oldFiber = nextOldFiber;
            }
            if (newIdx === newChildren.length) {
              deleteRemainingChildren(returnFiber, oldFiber);
              return resultingFirstChild;
            }
            if (oldFiber === null) {
              for (; newIdx < newChildren.length; newIdx++) {
                var _newFiber = createChild(returnFiber, newChildren[newIdx], expirationTime);
                if (_newFiber === null) {
                  continue;
                }
                lastPlacedIndex = placeChild(_newFiber, lastPlacedIndex, newIdx);
                if (previousNewFiber === null) {
                  resultingFirstChild = _newFiber;
                } else {
                  previousNewFiber.sibling = _newFiber;
                }
                previousNewFiber = _newFiber;
              }
              return resultingFirstChild;
            }
            var existingChildren = mapRemainingChildren(returnFiber, oldFiber);
            for (; newIdx < newChildren.length; newIdx++) {
              var _newFiber2 = updateFromMap(existingChildren, returnFiber, newIdx, newChildren[newIdx], expirationTime);
              if (_newFiber2 !== null) {
                if (shouldTrackSideEffects) {
                  if (_newFiber2.alternate !== null) {
                    existingChildren.delete(_newFiber2.key === null ? newIdx : _newFiber2.key);
                  }
                }
                lastPlacedIndex = placeChild(_newFiber2, lastPlacedIndex, newIdx);
                if (previousNewFiber === null) {
                  resultingFirstChild = _newFiber2;
                } else {
                  previousNewFiber.sibling = _newFiber2;
                }
                previousNewFiber = _newFiber2;
              }
            }
            if (shouldTrackSideEffects) {
              existingChildren.forEach(function(child2) {
                return deleteChild(returnFiber, child2);
              });
            }
            return resultingFirstChild;
          }
          function reconcileChildrenIterator(returnFiber, currentFirstChild, newChildrenIterable, expirationTime) {
            var iteratorFn = getIteratorFn(newChildrenIterable);
            if (!(typeof iteratorFn === "function")) {
              {
                throw Error("An object is not an iterable. This error is likely caused by a bug in React. Please file an issue.");
              }
            }
            {
              if (typeof Symbol === "function" && newChildrenIterable[Symbol.toStringTag] === "Generator") {
                !didWarnAboutGenerators ? warning$1(false, "Using Generators as children is unsupported and will likely yield unexpected results because enumerating a generator mutates it. You may convert it to an array with `Array.from()` or the `[...spread]` operator before rendering. Keep in mind you might need to polyfill these features for older browsers.") : void 0;
                didWarnAboutGenerators = true;
              }
              if (newChildrenIterable.entries === iteratorFn) {
                !didWarnAboutMaps ? warning$1(false, "Using Maps as children is unsupported and will likely yield unexpected results. Convert it to a sequence/iterable of keyed ReactElements instead.") : void 0;
                didWarnAboutMaps = true;
              }
              var _newChildren = iteratorFn.call(newChildrenIterable);
              if (_newChildren) {
                var knownKeys = null;
                var _step = _newChildren.next();
                for (; !_step.done; _step = _newChildren.next()) {
                  var child = _step.value;
                  knownKeys = warnOnInvalidKey(child, knownKeys);
                }
              }
            }
            var newChildren = iteratorFn.call(newChildrenIterable);
            if (!(newChildren != null)) {
              {
                throw Error("An iterable object provided no iterator.");
              }
            }
            var resultingFirstChild = null;
            var previousNewFiber = null;
            var oldFiber = currentFirstChild;
            var lastPlacedIndex = 0;
            var newIdx = 0;
            var nextOldFiber = null;
            var step = newChildren.next();
            for (; oldFiber !== null && !step.done; newIdx++, step = newChildren.next()) {
              if (oldFiber.index > newIdx) {
                nextOldFiber = oldFiber;
                oldFiber = null;
              } else {
                nextOldFiber = oldFiber.sibling;
              }
              var newFiber = updateSlot(returnFiber, oldFiber, step.value, expirationTime);
              if (newFiber === null) {
                if (oldFiber === null) {
                  oldFiber = nextOldFiber;
                }
                break;
              }
              if (shouldTrackSideEffects) {
                if (oldFiber && newFiber.alternate === null) {
                  deleteChild(returnFiber, oldFiber);
                }
              }
              lastPlacedIndex = placeChild(newFiber, lastPlacedIndex, newIdx);
              if (previousNewFiber === null) {
                resultingFirstChild = newFiber;
              } else {
                previousNewFiber.sibling = newFiber;
              }
              previousNewFiber = newFiber;
              oldFiber = nextOldFiber;
            }
            if (step.done) {
              deleteRemainingChildren(returnFiber, oldFiber);
              return resultingFirstChild;
            }
            if (oldFiber === null) {
              for (; !step.done; newIdx++, step = newChildren.next()) {
                var _newFiber3 = createChild(returnFiber, step.value, expirationTime);
                if (_newFiber3 === null) {
                  continue;
                }
                lastPlacedIndex = placeChild(_newFiber3, lastPlacedIndex, newIdx);
                if (previousNewFiber === null) {
                  resultingFirstChild = _newFiber3;
                } else {
                  previousNewFiber.sibling = _newFiber3;
                }
                previousNewFiber = _newFiber3;
              }
              return resultingFirstChild;
            }
            var existingChildren = mapRemainingChildren(returnFiber, oldFiber);
            for (; !step.done; newIdx++, step = newChildren.next()) {
              var _newFiber4 = updateFromMap(existingChildren, returnFiber, newIdx, step.value, expirationTime);
              if (_newFiber4 !== null) {
                if (shouldTrackSideEffects) {
                  if (_newFiber4.alternate !== null) {
                    existingChildren.delete(_newFiber4.key === null ? newIdx : _newFiber4.key);
                  }
                }
                lastPlacedIndex = placeChild(_newFiber4, lastPlacedIndex, newIdx);
                if (previousNewFiber === null) {
                  resultingFirstChild = _newFiber4;
                } else {
                  previousNewFiber.sibling = _newFiber4;
                }
                previousNewFiber = _newFiber4;
              }
            }
            if (shouldTrackSideEffects) {
              existingChildren.forEach(function(child2) {
                return deleteChild(returnFiber, child2);
              });
            }
            return resultingFirstChild;
          }
          function reconcileSingleTextNode(returnFiber, currentFirstChild, textContent, expirationTime) {
            if (currentFirstChild !== null && currentFirstChild.tag === HostText) {
              deleteRemainingChildren(returnFiber, currentFirstChild.sibling);
              var existing = useFiber(currentFirstChild, textContent, expirationTime);
              existing.return = returnFiber;
              return existing;
            }
            deleteRemainingChildren(returnFiber, currentFirstChild);
            var created = createFiberFromText(textContent, returnFiber.mode, expirationTime);
            created.return = returnFiber;
            return created;
          }
          function reconcileSingleElement(returnFiber, currentFirstChild, element, expirationTime) {
            var key2 = element.key;
            var child = currentFirstChild;
            while (child !== null) {
              if (child.key === key2) {
                if (child.tag === Fragment ? element.type === REACT_FRAGMENT_TYPE : child.elementType === element.type || isCompatibleFamilyForHotReloading(child, element)) {
                  deleteRemainingChildren(returnFiber, child.sibling);
                  var existing = useFiber(child, element.type === REACT_FRAGMENT_TYPE ? element.props.children : element.props, expirationTime);
                  existing.ref = coerceRef(returnFiber, child, element);
                  existing.return = returnFiber;
                  {
                    existing._debugSource = element._source;
                    existing._debugOwner = element._owner;
                  }
                  return existing;
                } else {
                  deleteRemainingChildren(returnFiber, child);
                  break;
                }
              } else {
                deleteChild(returnFiber, child);
              }
              child = child.sibling;
            }
            if (element.type === REACT_FRAGMENT_TYPE) {
              var created = createFiberFromFragment(element.props.children, returnFiber.mode, expirationTime, element.key);
              created.return = returnFiber;
              return created;
            } else {
              var _created4 = createFiberFromElement(element, returnFiber.mode, expirationTime);
              _created4.ref = coerceRef(returnFiber, currentFirstChild, element);
              _created4.return = returnFiber;
              return _created4;
            }
          }
          function reconcileSinglePortal(returnFiber, currentFirstChild, portal, expirationTime) {
            var key2 = portal.key;
            var child = currentFirstChild;
            while (child !== null) {
              if (child.key === key2) {
                if (child.tag === HostPortal && child.stateNode.containerInfo === portal.containerInfo && child.stateNode.implementation === portal.implementation) {
                  deleteRemainingChildren(returnFiber, child.sibling);
                  var existing = useFiber(child, portal.children || [], expirationTime);
                  existing.return = returnFiber;
                  return existing;
                } else {
                  deleteRemainingChildren(returnFiber, child);
                  break;
                }
              } else {
                deleteChild(returnFiber, child);
              }
              child = child.sibling;
            }
            var created = createFiberFromPortal(portal, returnFiber.mode, expirationTime);
            created.return = returnFiber;
            return created;
          }
          function reconcileChildFibers2(returnFiber, currentFirstChild, newChild, expirationTime) {
            var isUnkeyedTopLevelFragment = typeof newChild === "object" && newChild !== null && newChild.type === REACT_FRAGMENT_TYPE && newChild.key === null;
            if (isUnkeyedTopLevelFragment) {
              newChild = newChild.props.children;
            }
            var isObject2 = typeof newChild === "object" && newChild !== null;
            if (isObject2) {
              switch (newChild.$$typeof) {
                case REACT_ELEMENT_TYPE:
                  return placeSingleChild(reconcileSingleElement(returnFiber, currentFirstChild, newChild, expirationTime));
                case REACT_PORTAL_TYPE:
                  return placeSingleChild(reconcileSinglePortal(returnFiber, currentFirstChild, newChild, expirationTime));
              }
            }
            if (typeof newChild === "string" || typeof newChild === "number") {
              return placeSingleChild(reconcileSingleTextNode(returnFiber, currentFirstChild, "" + newChild, expirationTime));
            }
            if (isArray(newChild)) {
              return reconcileChildrenArray(returnFiber, currentFirstChild, newChild, expirationTime);
            }
            if (getIteratorFn(newChild)) {
              return reconcileChildrenIterator(returnFiber, currentFirstChild, newChild, expirationTime);
            }
            if (isObject2) {
              throwOnInvalidObjectType(returnFiber, newChild);
            }
            {
              if (typeof newChild === "function") {
                warnOnFunctionType();
              }
            }
            if (typeof newChild === "undefined" && !isUnkeyedTopLevelFragment) {
              switch (returnFiber.tag) {
                case ClassComponent: {
                  {
                    var instance = returnFiber.stateNode;
                    if (instance.render._isMockFunction) {
                      break;
                    }
                  }
                }
                case FunctionComponent: {
                  var Component = returnFiber.type;
                  {
                    {
                      throw Error((Component.displayName || Component.name || "Component") + "(...): Nothing was returned from render. This usually means a return statement is missing. Or, to render nothing, return null.");
                    }
                  }
                }
              }
            }
            return deleteRemainingChildren(returnFiber, currentFirstChild);
          }
          return reconcileChildFibers2;
        }
        var reconcileChildFibers = ChildReconciler(true);
        var mountChildFibers = ChildReconciler(false);
        function cloneChildFibers(current$$1, workInProgress2) {
          if (!(current$$1 === null || workInProgress2.child === current$$1.child)) {
            {
              throw Error("Resuming work not yet implemented.");
            }
          }
          if (workInProgress2.child === null) {
            return;
          }
          var currentChild = workInProgress2.child;
          var newChild = createWorkInProgress(currentChild, currentChild.pendingProps, currentChild.expirationTime);
          workInProgress2.child = newChild;
          newChild.return = workInProgress2;
          while (currentChild.sibling !== null) {
            currentChild = currentChild.sibling;
            newChild = newChild.sibling = createWorkInProgress(currentChild, currentChild.pendingProps, currentChild.expirationTime);
            newChild.return = workInProgress2;
          }
          newChild.sibling = null;
        }
        function resetChildFibers(workInProgress2, renderExpirationTime2) {
          var child = workInProgress2.child;
          while (child !== null) {
            resetWorkInProgress(child, renderExpirationTime2);
            child = child.sibling;
          }
        }
        var NO_CONTEXT = {};
        var contextStackCursor$1 = createCursor(NO_CONTEXT);
        var contextFiberStackCursor = createCursor(NO_CONTEXT);
        var rootInstanceStackCursor = createCursor(NO_CONTEXT);
        function requiredContext(c2) {
          if (!(c2 !== NO_CONTEXT)) {
            {
              throw Error("Expected host context to exist. This error is likely caused by a bug in React. Please file an issue.");
            }
          }
          return c2;
        }
        function getRootHostContainer() {
          var rootInstance = requiredContext(rootInstanceStackCursor.current);
          return rootInstance;
        }
        function pushHostContainer(fiber, nextRootInstance) {
          push(rootInstanceStackCursor, nextRootInstance, fiber);
          push(contextFiberStackCursor, fiber, fiber);
          push(contextStackCursor$1, NO_CONTEXT, fiber);
          var nextRootContext = getRootHostContext(nextRootInstance);
          pop(contextStackCursor$1, fiber);
          push(contextStackCursor$1, nextRootContext, fiber);
        }
        function popHostContainer(fiber) {
          pop(contextStackCursor$1, fiber);
          pop(contextFiberStackCursor, fiber);
          pop(rootInstanceStackCursor, fiber);
        }
        function getHostContext() {
          var context = requiredContext(contextStackCursor$1.current);
          return context;
        }
        function pushHostContext(fiber) {
          var rootInstance = requiredContext(rootInstanceStackCursor.current);
          var context = requiredContext(contextStackCursor$1.current);
          var nextContext = getChildHostContext(context, fiber.type, rootInstance);
          if (context === nextContext) {
            return;
          }
          push(contextFiberStackCursor, fiber, fiber);
          push(contextStackCursor$1, nextContext, fiber);
        }
        function popHostContext(fiber) {
          if (contextFiberStackCursor.current !== fiber) {
            return;
          }
          pop(contextStackCursor$1, fiber);
          pop(contextFiberStackCursor, fiber);
        }
        var DefaultSuspenseContext = 0;
        var SubtreeSuspenseContextMask = 1;
        var InvisibleParentSuspenseContext = 1;
        var ForceSuspenseFallback = 2;
        var suspenseStackCursor = createCursor(DefaultSuspenseContext);
        function hasSuspenseContext(parentContext, flag) {
          return (parentContext & flag) !== 0;
        }
        function setDefaultShallowSuspenseContext(parentContext) {
          return parentContext & SubtreeSuspenseContextMask;
        }
        function setShallowSuspenseContext(parentContext, shallowContext) {
          return parentContext & SubtreeSuspenseContextMask | shallowContext;
        }
        function addSubtreeSuspenseContext(parentContext, subtreeContext) {
          return parentContext | subtreeContext;
        }
        function pushSuspenseContext(fiber, newContext) {
          push(suspenseStackCursor, newContext, fiber);
        }
        function popSuspenseContext(fiber) {
          pop(suspenseStackCursor, fiber);
        }
        function shouldCaptureSuspense(workInProgress2, hasInvisibleParent) {
          var nextState = workInProgress2.memoizedState;
          if (nextState !== null) {
            if (nextState.dehydrated !== null) {
              return true;
            }
            return false;
          }
          var props = workInProgress2.memoizedProps;
          if (props.fallback === void 0) {
            return false;
          }
          if (props.unstable_avoidThisFallback !== true) {
            return true;
          }
          if (hasInvisibleParent) {
            return false;
          }
          return true;
        }
        function findFirstSuspended(row) {
          var node = row;
          while (node !== null) {
            if (node.tag === SuspenseComponent) {
              var state = node.memoizedState;
              if (state !== null) {
                var dehydrated = state.dehydrated;
                if (dehydrated === null || isSuspenseInstancePending(dehydrated) || isSuspenseInstanceFallback(dehydrated)) {
                  return node;
                }
              }
            } else if (node.tag === SuspenseListComponent && node.memoizedProps.revealOrder !== void 0) {
              var didSuspend = (node.effectTag & DidCapture) !== NoEffect;
              if (didSuspend) {
                return node;
              }
            } else if (node.child !== null) {
              node.child.return = node;
              node = node.child;
              continue;
            }
            if (node === row) {
              return null;
            }
            while (node.sibling === null) {
              if (node.return === null || node.return === row) {
                return null;
              }
              node = node.return;
            }
            node.sibling.return = node.return;
            node = node.sibling;
          }
          return null;
        }
        var emptyObject = {};
        var isArray$2 = Array.isArray;
        function createResponderInstance(responder, responderProps, responderState, fiber) {
          return {
            fiber,
            props: responderProps,
            responder,
            rootEventTypes: null,
            state: responderState
          };
        }
        function mountEventResponder(responder, responderProps, fiber, respondersMap, rootContainerInstance) {
          var responderState = emptyObject;
          var getInitialState = responder.getInitialState;
          if (getInitialState !== null) {
            responderState = getInitialState(responderProps);
          }
          var responderInstance = createResponderInstance(responder, responderProps, responderState, fiber);
          if (!rootContainerInstance) {
            var node = fiber;
            while (node !== null) {
              var tag = node.tag;
              if (tag === HostComponent) {
                rootContainerInstance = node.stateNode;
                break;
              } else if (tag === HostRoot) {
                rootContainerInstance = node.stateNode.containerInfo;
                break;
              }
              node = node.return;
            }
          }
          mountResponderInstance(responder, responderInstance, responderProps, responderState, rootContainerInstance);
          respondersMap.set(responder, responderInstance);
        }
        function updateEventListener(listener, fiber, visistedResponders, respondersMap, rootContainerInstance) {
          var responder;
          var props;
          if (listener) {
            responder = listener.responder;
            props = listener.props;
          }
          if (!(responder && responder.$$typeof === REACT_RESPONDER_TYPE)) {
            {
              throw Error("An invalid value was used as an event listener. Expect one or many event listeners created via React.unstable_useResponder().");
            }
          }
          var listenerProps = props;
          if (visistedResponders.has(responder)) {
            {
              warning$1(false, 'Duplicate event responder "%s" found in event listeners. Event listeners passed to elements cannot use the same event responder more than once.', responder.displayName);
            }
            return;
          }
          visistedResponders.add(responder);
          var responderInstance = respondersMap.get(responder);
          if (responderInstance === void 0) {
            mountEventResponder(responder, listenerProps, fiber, respondersMap, rootContainerInstance);
          } else {
            responderInstance.props = listenerProps;
            responderInstance.fiber = fiber;
          }
        }
        function updateEventListeners(listeners, fiber, rootContainerInstance) {
          var visistedResponders = /* @__PURE__ */ new Set();
          var dependencies = fiber.dependencies;
          if (listeners != null) {
            if (dependencies === null) {
              dependencies = fiber.dependencies = {
                expirationTime: NoWork,
                firstContext: null,
                responders: /* @__PURE__ */ new Map()
              };
            }
            var respondersMap = dependencies.responders;
            if (respondersMap === null) {
              respondersMap = /* @__PURE__ */ new Map();
            }
            if (isArray$2(listeners)) {
              for (var i3 = 0, length = listeners.length; i3 < length; i3++) {
                var listener = listeners[i3];
                updateEventListener(listener, fiber, visistedResponders, respondersMap, rootContainerInstance);
              }
            } else {
              updateEventListener(listeners, fiber, visistedResponders, respondersMap, rootContainerInstance);
            }
          }
          if (dependencies !== null) {
            var _respondersMap = dependencies.responders;
            if (_respondersMap !== null) {
              var mountedResponders = Array.from(_respondersMap.keys());
              for (var _i = 0, _length = mountedResponders.length; _i < _length; _i++) {
                var mountedResponder = mountedResponders[_i];
                if (!visistedResponders.has(mountedResponder)) {
                  var responderInstance = _respondersMap.get(mountedResponder);
                  unmountResponderInstance(responderInstance);
                  _respondersMap.delete(mountedResponder);
                }
              }
            }
          }
        }
        function createResponderListener(responder, props) {
          var eventResponderListener = {
            responder,
            props
          };
          {
            Object.freeze(eventResponderListener);
          }
          return eventResponderListener;
        }
        var NoEffect$1 = 0;
        var UnmountSnapshot = 2;
        var UnmountMutation = 4;
        var MountMutation = 8;
        var UnmountLayout = 16;
        var MountLayout = 32;
        var MountPassive = 64;
        var UnmountPassive = 128;
        var ReactCurrentDispatcher$1 = ReactSharedInternals.ReactCurrentDispatcher;
        var ReactCurrentBatchConfig$1 = ReactSharedInternals.ReactCurrentBatchConfig;
        var didWarnAboutMismatchedHooksForComponent;
        {
          didWarnAboutMismatchedHooksForComponent = /* @__PURE__ */ new Set();
        }
        var renderExpirationTime$1 = NoWork;
        var currentlyRenderingFiber$1 = null;
        var currentHook = null;
        var nextCurrentHook = null;
        var firstWorkInProgressHook = null;
        var workInProgressHook = null;
        var nextWorkInProgressHook = null;
        var remainingExpirationTime = NoWork;
        var componentUpdateQueue = null;
        var sideEffectTag = 0;
        var didScheduleRenderPhaseUpdate = false;
        var renderPhaseUpdates = null;
        var numberOfReRenders = 0;
        var RE_RENDER_LIMIT = 25;
        var currentHookNameInDev = null;
        var hookTypesDev = null;
        var hookTypesUpdateIndexDev = -1;
        var ignorePreviousDependencies = false;
        function mountHookTypesDev() {
          {
            var hookName = currentHookNameInDev;
            if (hookTypesDev === null) {
              hookTypesDev = [hookName];
            } else {
              hookTypesDev.push(hookName);
            }
          }
        }
        function updateHookTypesDev() {
          {
            var hookName = currentHookNameInDev;
            if (hookTypesDev !== null) {
              hookTypesUpdateIndexDev++;
              if (hookTypesDev[hookTypesUpdateIndexDev] !== hookName) {
                warnOnHookMismatchInDev(hookName);
              }
            }
          }
        }
        function checkDepsAreArrayDev(deps) {
          {
            if (deps !== void 0 && deps !== null && !Array.isArray(deps)) {
              warning$1(false, "%s received a final argument that is not an array (instead, received `%s`). When specified, the final argument must be an array.", currentHookNameInDev, typeof deps);
            }
          }
        }
        function warnOnHookMismatchInDev(currentHookName) {
          {
            var componentName = getComponentName(currentlyRenderingFiber$1.type);
            if (!didWarnAboutMismatchedHooksForComponent.has(componentName)) {
              didWarnAboutMismatchedHooksForComponent.add(componentName);
              if (hookTypesDev !== null) {
                var table = "";
                var secondColumnStart = 30;
                for (var i3 = 0; i3 <= hookTypesUpdateIndexDev; i3++) {
                  var oldHookName = hookTypesDev[i3];
                  var newHookName = i3 === hookTypesUpdateIndexDev ? currentHookName : oldHookName;
                  var row = i3 + 1 + ". " + oldHookName;
                  while (row.length < secondColumnStart) {
                    row += " ";
                  }
                  row += newHookName + "\n";
                  table += row;
                }
                warning$1(false, "React has detected a change in the order of Hooks called by %s. This will lead to bugs and errors if not fixed. For more information, read the Rules of Hooks: https://fb.me/rules-of-hooks\n\n   Previous render            Next render\n   ------------------------------------------------------\n%s   ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^\n", componentName, table);
              }
            }
          }
        }
        function throwInvalidHookError() {
          {
            {
              throw Error("Invalid hook call. Hooks can only be called inside of the body of a function component. This could happen for one of the following reasons:\n1. You might have mismatching versions of React and the renderer (such as React DOM)\n2. You might be breaking the Rules of Hooks\n3. You might have more than one copy of React in the same app\nSee https://fb.me/react-invalid-hook-call for tips about how to debug and fix this problem.");
            }
          }
        }
        function areHookInputsEqual(nextDeps, prevDeps) {
          {
            if (ignorePreviousDependencies) {
              return false;
            }
          }
          if (prevDeps === null) {
            {
              warning$1(false, "%s received a final argument during this render, but not during the previous render. Even though the final argument is optional, its type cannot change between renders.", currentHookNameInDev);
            }
            return false;
          }
          {
            if (nextDeps.length !== prevDeps.length) {
              warning$1(false, "The final argument passed to %s changed size between renders. The order and size of this array must remain constant.\n\nPrevious: %s\nIncoming: %s", currentHookNameInDev, "[" + prevDeps.join(", ") + "]", "[" + nextDeps.join(", ") + "]");
            }
          }
          for (var i3 = 0; i3 < prevDeps.length && i3 < nextDeps.length; i3++) {
            if (is$1(nextDeps[i3], prevDeps[i3])) {
              continue;
            }
            return false;
          }
          return true;
        }
        function renderWithHooks(current2, workInProgress2, Component, props, refOrContext, nextRenderExpirationTime) {
          renderExpirationTime$1 = nextRenderExpirationTime;
          currentlyRenderingFiber$1 = workInProgress2;
          nextCurrentHook = current2 !== null ? current2.memoizedState : null;
          {
            hookTypesDev = current2 !== null ? current2._debugHookTypes : null;
            hookTypesUpdateIndexDev = -1;
            ignorePreviousDependencies = current2 !== null && current2.type !== workInProgress2.type;
          }
          {
            if (nextCurrentHook !== null) {
              ReactCurrentDispatcher$1.current = HooksDispatcherOnUpdateInDEV;
            } else if (hookTypesDev !== null) {
              ReactCurrentDispatcher$1.current = HooksDispatcherOnMountWithHookTypesInDEV;
            } else {
              ReactCurrentDispatcher$1.current = HooksDispatcherOnMountInDEV;
            }
          }
          var children = Component(props, refOrContext);
          if (didScheduleRenderPhaseUpdate) {
            do {
              didScheduleRenderPhaseUpdate = false;
              numberOfReRenders += 1;
              {
                ignorePreviousDependencies = false;
              }
              nextCurrentHook = current2 !== null ? current2.memoizedState : null;
              nextWorkInProgressHook = firstWorkInProgressHook;
              currentHook = null;
              workInProgressHook = null;
              componentUpdateQueue = null;
              {
                hookTypesUpdateIndexDev = -1;
              }
              ReactCurrentDispatcher$1.current = HooksDispatcherOnUpdateInDEV;
              children = Component(props, refOrContext);
            } while (didScheduleRenderPhaseUpdate);
            renderPhaseUpdates = null;
            numberOfReRenders = 0;
          }
          ReactCurrentDispatcher$1.current = ContextOnlyDispatcher;
          var renderedWork = currentlyRenderingFiber$1;
          renderedWork.memoizedState = firstWorkInProgressHook;
          renderedWork.expirationTime = remainingExpirationTime;
          renderedWork.updateQueue = componentUpdateQueue;
          renderedWork.effectTag |= sideEffectTag;
          {
            renderedWork._debugHookTypes = hookTypesDev;
          }
          var didRenderTooFewHooks = currentHook !== null && currentHook.next !== null;
          renderExpirationTime$1 = NoWork;
          currentlyRenderingFiber$1 = null;
          currentHook = null;
          nextCurrentHook = null;
          firstWorkInProgressHook = null;
          workInProgressHook = null;
          nextWorkInProgressHook = null;
          {
            currentHookNameInDev = null;
            hookTypesDev = null;
            hookTypesUpdateIndexDev = -1;
          }
          remainingExpirationTime = NoWork;
          componentUpdateQueue = null;
          sideEffectTag = 0;
          if (!!didRenderTooFewHooks) {
            {
              throw Error("Rendered fewer hooks than expected. This may be caused by an accidental early return statement.");
            }
          }
          return children;
        }
        function bailoutHooks(current2, workInProgress2, expirationTime) {
          workInProgress2.updateQueue = current2.updateQueue;
          workInProgress2.effectTag &= ~(Passive | Update);
          if (current2.expirationTime <= expirationTime) {
            current2.expirationTime = NoWork;
          }
        }
        function resetHooks() {
          ReactCurrentDispatcher$1.current = ContextOnlyDispatcher;
          renderExpirationTime$1 = NoWork;
          currentlyRenderingFiber$1 = null;
          currentHook = null;
          nextCurrentHook = null;
          firstWorkInProgressHook = null;
          workInProgressHook = null;
          nextWorkInProgressHook = null;
          {
            hookTypesDev = null;
            hookTypesUpdateIndexDev = -1;
            currentHookNameInDev = null;
          }
          remainingExpirationTime = NoWork;
          componentUpdateQueue = null;
          sideEffectTag = 0;
          didScheduleRenderPhaseUpdate = false;
          renderPhaseUpdates = null;
          numberOfReRenders = 0;
        }
        function mountWorkInProgressHook() {
          var hook = {
            memoizedState: null,
            baseState: null,
            queue: null,
            baseUpdate: null,
            next: null
          };
          if (workInProgressHook === null) {
            firstWorkInProgressHook = workInProgressHook = hook;
          } else {
            workInProgressHook = workInProgressHook.next = hook;
          }
          return workInProgressHook;
        }
        function updateWorkInProgressHook() {
          if (nextWorkInProgressHook !== null) {
            workInProgressHook = nextWorkInProgressHook;
            nextWorkInProgressHook = workInProgressHook.next;
            currentHook = nextCurrentHook;
            nextCurrentHook = currentHook !== null ? currentHook.next : null;
          } else {
            if (!(nextCurrentHook !== null)) {
              {
                throw Error("Rendered more hooks than during the previous render.");
              }
            }
            currentHook = nextCurrentHook;
            var newHook = {
              memoizedState: currentHook.memoizedState,
              baseState: currentHook.baseState,
              queue: currentHook.queue,
              baseUpdate: currentHook.baseUpdate,
              next: null
            };
            if (workInProgressHook === null) {
              workInProgressHook = firstWorkInProgressHook = newHook;
            } else {
              workInProgressHook = workInProgressHook.next = newHook;
            }
            nextCurrentHook = currentHook.next;
          }
          return workInProgressHook;
        }
        function createFunctionComponentUpdateQueue() {
          return {
            lastEffect: null
          };
        }
        function basicStateReducer(state, action) {
          return typeof action === "function" ? action(state) : action;
        }
        function mountReducer(reducer, initialArg, init) {
          var hook = mountWorkInProgressHook();
          var initialState;
          if (init !== void 0) {
            initialState = init(initialArg);
          } else {
            initialState = initialArg;
          }
          hook.memoizedState = hook.baseState = initialState;
          var queue = hook.queue = {
            last: null,
            dispatch: null,
            lastRenderedReducer: reducer,
            lastRenderedState: initialState
          };
          var dispatch = queue.dispatch = dispatchAction.bind(null, currentlyRenderingFiber$1, queue);
          return [hook.memoizedState, dispatch];
        }
        function updateReducer(reducer, initialArg, init) {
          var hook = updateWorkInProgressHook();
          var queue = hook.queue;
          if (!(queue !== null)) {
            {
              throw Error("Should have a queue. This is likely a bug in React. Please file an issue.");
            }
          }
          queue.lastRenderedReducer = reducer;
          if (numberOfReRenders > 0) {
            var _dispatch = queue.dispatch;
            if (renderPhaseUpdates !== null) {
              var firstRenderPhaseUpdate = renderPhaseUpdates.get(queue);
              if (firstRenderPhaseUpdate !== void 0) {
                renderPhaseUpdates.delete(queue);
                var newState = hook.memoizedState;
                var update = firstRenderPhaseUpdate;
                do {
                  var action = update.action;
                  newState = reducer(newState, action);
                  update = update.next;
                } while (update !== null);
                if (!is$1(newState, hook.memoizedState)) {
                  markWorkInProgressReceivedUpdate();
                }
                hook.memoizedState = newState;
                if (hook.baseUpdate === queue.last) {
                  hook.baseState = newState;
                }
                queue.lastRenderedState = newState;
                return [newState, _dispatch];
              }
            }
            return [hook.memoizedState, _dispatch];
          }
          var last = queue.last;
          var baseUpdate = hook.baseUpdate;
          var baseState = hook.baseState;
          var first;
          if (baseUpdate !== null) {
            if (last !== null) {
              last.next = null;
            }
            first = baseUpdate.next;
          } else {
            first = last !== null ? last.next : null;
          }
          if (first !== null) {
            var _newState = baseState;
            var newBaseState = null;
            var newBaseUpdate = null;
            var prevUpdate = baseUpdate;
            var _update = first;
            var didSkip = false;
            do {
              var updateExpirationTime = _update.expirationTime;
              if (updateExpirationTime < renderExpirationTime$1) {
                if (!didSkip) {
                  didSkip = true;
                  newBaseUpdate = prevUpdate;
                  newBaseState = _newState;
                }
                if (updateExpirationTime > remainingExpirationTime) {
                  remainingExpirationTime = updateExpirationTime;
                  markUnprocessedUpdateTime(remainingExpirationTime);
                }
              } else {
                markRenderEventTimeAndConfig(updateExpirationTime, _update.suspenseConfig);
                if (_update.eagerReducer === reducer) {
                  _newState = _update.eagerState;
                } else {
                  var _action = _update.action;
                  _newState = reducer(_newState, _action);
                }
              }
              prevUpdate = _update;
              _update = _update.next;
            } while (_update !== null && _update !== first);
            if (!didSkip) {
              newBaseUpdate = prevUpdate;
              newBaseState = _newState;
            }
            if (!is$1(_newState, hook.memoizedState)) {
              markWorkInProgressReceivedUpdate();
            }
            hook.memoizedState = _newState;
            hook.baseUpdate = newBaseUpdate;
            hook.baseState = newBaseState;
            queue.lastRenderedState = _newState;
          }
          var dispatch = queue.dispatch;
          return [hook.memoizedState, dispatch];
        }
        function mountState(initialState) {
          var hook = mountWorkInProgressHook();
          if (typeof initialState === "function") {
            initialState = initialState();
          }
          hook.memoizedState = hook.baseState = initialState;
          var queue = hook.queue = {
            last: null,
            dispatch: null,
            lastRenderedReducer: basicStateReducer,
            lastRenderedState: initialState
          };
          var dispatch = queue.dispatch = dispatchAction.bind(null, currentlyRenderingFiber$1, queue);
          return [hook.memoizedState, dispatch];
        }
        function updateState(initialState) {
          return updateReducer(basicStateReducer, initialState);
        }
        function pushEffect(tag, create, destroy, deps) {
          var effect = {
            tag,
            create,
            destroy,
            deps,
            next: null
          };
          if (componentUpdateQueue === null) {
            componentUpdateQueue = createFunctionComponentUpdateQueue();
            componentUpdateQueue.lastEffect = effect.next = effect;
          } else {
            var lastEffect = componentUpdateQueue.lastEffect;
            if (lastEffect === null) {
              componentUpdateQueue.lastEffect = effect.next = effect;
            } else {
              var firstEffect = lastEffect.next;
              lastEffect.next = effect;
              effect.next = firstEffect;
              componentUpdateQueue.lastEffect = effect;
            }
          }
          return effect;
        }
        function mountRef(initialValue) {
          var hook = mountWorkInProgressHook();
          var ref2 = {
            current: initialValue
          };
          {
            Object.seal(ref2);
          }
          hook.memoizedState = ref2;
          return ref2;
        }
        function updateRef(initialValue) {
          var hook = updateWorkInProgressHook();
          return hook.memoizedState;
        }
        function mountEffectImpl(fiberEffectTag, hookEffectTag, create, deps) {
          var hook = mountWorkInProgressHook();
          var nextDeps = deps === void 0 ? null : deps;
          sideEffectTag |= fiberEffectTag;
          hook.memoizedState = pushEffect(hookEffectTag, create, void 0, nextDeps);
        }
        function updateEffectImpl(fiberEffectTag, hookEffectTag, create, deps) {
          var hook = updateWorkInProgressHook();
          var nextDeps = deps === void 0 ? null : deps;
          var destroy = void 0;
          if (currentHook !== null) {
            var prevEffect = currentHook.memoizedState;
            destroy = prevEffect.destroy;
            if (nextDeps !== null) {
              var prevDeps = prevEffect.deps;
              if (areHookInputsEqual(nextDeps, prevDeps)) {
                pushEffect(NoEffect$1, create, destroy, nextDeps);
                return;
              }
            }
          }
          sideEffectTag |= fiberEffectTag;
          hook.memoizedState = pushEffect(hookEffectTag, create, destroy, nextDeps);
        }
        function mountEffect(create, deps) {
          {
            if (typeof jest !== "undefined") {
              warnIfNotCurrentlyActingEffectsInDEV(currentlyRenderingFiber$1);
            }
          }
          return mountEffectImpl(Update | Passive, UnmountPassive | MountPassive, create, deps);
        }
        function updateEffect(create, deps) {
          {
            if (typeof jest !== "undefined") {
              warnIfNotCurrentlyActingEffectsInDEV(currentlyRenderingFiber$1);
            }
          }
          return updateEffectImpl(Update | Passive, UnmountPassive | MountPassive, create, deps);
        }
        function mountLayoutEffect(create, deps) {
          return mountEffectImpl(Update, UnmountMutation | MountLayout, create, deps);
        }
        function updateLayoutEffect(create, deps) {
          return updateEffectImpl(Update, UnmountMutation | MountLayout, create, deps);
        }
        function imperativeHandleEffect(create, ref2) {
          if (typeof ref2 === "function") {
            var refCallback = ref2;
            var _inst = create();
            refCallback(_inst);
            return function() {
              refCallback(null);
            };
          } else if (ref2 !== null && ref2 !== void 0) {
            var refObject = ref2;
            {
              !refObject.hasOwnProperty("current") ? warning$1(false, "Expected useImperativeHandle() first argument to either be a ref callback or React.createRef() object. Instead received: %s.", "an object with keys {" + Object.keys(refObject).join(", ") + "}") : void 0;
            }
            var _inst2 = create();
            refObject.current = _inst2;
            return function() {
              refObject.current = null;
            };
          }
        }
        function mountImperativeHandle(ref2, create, deps) {
          {
            !(typeof create === "function") ? warning$1(false, "Expected useImperativeHandle() second argument to be a function that creates a handle. Instead received: %s.", create !== null ? typeof create : "null") : void 0;
          }
          var effectDeps = deps !== null && deps !== void 0 ? deps.concat([ref2]) : null;
          return mountEffectImpl(Update, UnmountMutation | MountLayout, imperativeHandleEffect.bind(null, create, ref2), effectDeps);
        }
        function updateImperativeHandle(ref2, create, deps) {
          {
            !(typeof create === "function") ? warning$1(false, "Expected useImperativeHandle() second argument to be a function that creates a handle. Instead received: %s.", create !== null ? typeof create : "null") : void 0;
          }
          var effectDeps = deps !== null && deps !== void 0 ? deps.concat([ref2]) : null;
          return updateEffectImpl(Update, UnmountMutation | MountLayout, imperativeHandleEffect.bind(null, create, ref2), effectDeps);
        }
        function mountDebugValue(value, formatterFn) {
        }
        var updateDebugValue = mountDebugValue;
        function mountCallback(callback, deps) {
          var hook = mountWorkInProgressHook();
          var nextDeps = deps === void 0 ? null : deps;
          hook.memoizedState = [callback, nextDeps];
          return callback;
        }
        function updateCallback(callback, deps) {
          var hook = updateWorkInProgressHook();
          var nextDeps = deps === void 0 ? null : deps;
          var prevState = hook.memoizedState;
          if (prevState !== null) {
            if (nextDeps !== null) {
              var prevDeps = prevState[1];
              if (areHookInputsEqual(nextDeps, prevDeps)) {
                return prevState[0];
              }
            }
          }
          hook.memoizedState = [callback, nextDeps];
          return callback;
        }
        function mountMemo(nextCreate, deps) {
          var hook = mountWorkInProgressHook();
          var nextDeps = deps === void 0 ? null : deps;
          var nextValue = nextCreate();
          hook.memoizedState = [nextValue, nextDeps];
          return nextValue;
        }
        function updateMemo(nextCreate, deps) {
          var hook = updateWorkInProgressHook();
          var nextDeps = deps === void 0 ? null : deps;
          var prevState = hook.memoizedState;
          if (prevState !== null) {
            if (nextDeps !== null) {
              var prevDeps = prevState[1];
              if (areHookInputsEqual(nextDeps, prevDeps)) {
                return prevState[0];
              }
            }
          }
          var nextValue = nextCreate();
          hook.memoizedState = [nextValue, nextDeps];
          return nextValue;
        }
        function mountDeferredValue(value, config) {
          var _mountState = mountState(value), prevValue = _mountState[0], setValue2 = _mountState[1];
          mountEffect(function() {
            Scheduler.unstable_next(function() {
              var previousConfig = ReactCurrentBatchConfig$1.suspense;
              ReactCurrentBatchConfig$1.suspense = config === void 0 ? null : config;
              try {
                setValue2(value);
              } finally {
                ReactCurrentBatchConfig$1.suspense = previousConfig;
              }
            });
          }, [value, config]);
          return prevValue;
        }
        function updateDeferredValue(value, config) {
          var _updateState = updateState(value), prevValue = _updateState[0], setValue2 = _updateState[1];
          updateEffect(function() {
            Scheduler.unstable_next(function() {
              var previousConfig = ReactCurrentBatchConfig$1.suspense;
              ReactCurrentBatchConfig$1.suspense = config === void 0 ? null : config;
              try {
                setValue2(value);
              } finally {
                ReactCurrentBatchConfig$1.suspense = previousConfig;
              }
            });
          }, [value, config]);
          return prevValue;
        }
        function mountTransition(config) {
          var _mountState2 = mountState(false), isPending = _mountState2[0], setPending = _mountState2[1];
          var startTransition = mountCallback(function(callback) {
            setPending(true);
            Scheduler.unstable_next(function() {
              var previousConfig = ReactCurrentBatchConfig$1.suspense;
              ReactCurrentBatchConfig$1.suspense = config === void 0 ? null : config;
              try {
                setPending(false);
                callback();
              } finally {
                ReactCurrentBatchConfig$1.suspense = previousConfig;
              }
            });
          }, [config, isPending]);
          return [startTransition, isPending];
        }
        function updateTransition(config) {
          var _updateState2 = updateState(false), isPending = _updateState2[0], setPending = _updateState2[1];
          var startTransition = updateCallback(function(callback) {
            setPending(true);
            Scheduler.unstable_next(function() {
              var previousConfig = ReactCurrentBatchConfig$1.suspense;
              ReactCurrentBatchConfig$1.suspense = config === void 0 ? null : config;
              try {
                setPending(false);
                callback();
              } finally {
                ReactCurrentBatchConfig$1.suspense = previousConfig;
              }
            });
          }, [config, isPending]);
          return [startTransition, isPending];
        }
        function dispatchAction(fiber, queue, action) {
          if (!(numberOfReRenders < RE_RENDER_LIMIT)) {
            {
              throw Error("Too many re-renders. React limits the number of renders to prevent an infinite loop.");
            }
          }
          {
            !(typeof arguments[3] !== "function") ? warning$1(false, "State updates from the useState() and useReducer() Hooks don't support the second callback argument. To execute a side effect after rendering, declare it in the component body with useEffect().") : void 0;
          }
          var alternate = fiber.alternate;
          if (fiber === currentlyRenderingFiber$1 || alternate !== null && alternate === currentlyRenderingFiber$1) {
            didScheduleRenderPhaseUpdate = true;
            var update = {
              expirationTime: renderExpirationTime$1,
              suspenseConfig: null,
              action,
              eagerReducer: null,
              eagerState: null,
              next: null
            };
            {
              update.priority = getCurrentPriorityLevel();
            }
            if (renderPhaseUpdates === null) {
              renderPhaseUpdates = /* @__PURE__ */ new Map();
            }
            var firstRenderPhaseUpdate = renderPhaseUpdates.get(queue);
            if (firstRenderPhaseUpdate === void 0) {
              renderPhaseUpdates.set(queue, update);
            } else {
              var lastRenderPhaseUpdate = firstRenderPhaseUpdate;
              while (lastRenderPhaseUpdate.next !== null) {
                lastRenderPhaseUpdate = lastRenderPhaseUpdate.next;
              }
              lastRenderPhaseUpdate.next = update;
            }
          } else {
            var currentTime = requestCurrentTimeForUpdate();
            var suspenseConfig = requestCurrentSuspenseConfig();
            var expirationTime = computeExpirationForFiber(currentTime, fiber, suspenseConfig);
            var _update2 = {
              expirationTime,
              suspenseConfig,
              action,
              eagerReducer: null,
              eagerState: null,
              next: null
            };
            {
              _update2.priority = getCurrentPriorityLevel();
            }
            var last = queue.last;
            if (last === null) {
              _update2.next = _update2;
            } else {
              var first = last.next;
              if (first !== null) {
                _update2.next = first;
              }
              last.next = _update2;
            }
            queue.last = _update2;
            if (fiber.expirationTime === NoWork && (alternate === null || alternate.expirationTime === NoWork)) {
              var lastRenderedReducer = queue.lastRenderedReducer;
              if (lastRenderedReducer !== null) {
                var prevDispatcher;
                {
                  prevDispatcher = ReactCurrentDispatcher$1.current;
                  ReactCurrentDispatcher$1.current = InvalidNestedHooksDispatcherOnUpdateInDEV;
                }
                try {
                  var currentState = queue.lastRenderedState;
                  var eagerState = lastRenderedReducer(currentState, action);
                  _update2.eagerReducer = lastRenderedReducer;
                  _update2.eagerState = eagerState;
                  if (is$1(eagerState, currentState)) {
                    return;
                  }
                } catch (error) {
                } finally {
                  {
                    ReactCurrentDispatcher$1.current = prevDispatcher;
                  }
                }
              }
            }
            {
              if (typeof jest !== "undefined") {
                warnIfNotScopedWithMatchingAct(fiber);
                warnIfNotCurrentlyActingUpdatesInDev(fiber);
              }
            }
            scheduleWork(fiber, expirationTime);
          }
        }
        var ContextOnlyDispatcher = {
          readContext,
          useCallback: throwInvalidHookError,
          useContext: throwInvalidHookError,
          useEffect: throwInvalidHookError,
          useImperativeHandle: throwInvalidHookError,
          useLayoutEffect: throwInvalidHookError,
          useMemo: throwInvalidHookError,
          useReducer: throwInvalidHookError,
          useRef: throwInvalidHookError,
          useState: throwInvalidHookError,
          useDebugValue: throwInvalidHookError,
          useResponder: throwInvalidHookError,
          useDeferredValue: throwInvalidHookError,
          useTransition: throwInvalidHookError
        };
        var HooksDispatcherOnMountInDEV = null;
        var HooksDispatcherOnMountWithHookTypesInDEV = null;
        var HooksDispatcherOnUpdateInDEV = null;
        var InvalidNestedHooksDispatcherOnMountInDEV = null;
        var InvalidNestedHooksDispatcherOnUpdateInDEV = null;
        {
          var warnInvalidContextAccess = function() {
            warning$1(false, "Context can only be read while React is rendering. In classes, you can read it in the render method or getDerivedStateFromProps. In function components, you can read it directly in the function body, but not inside Hooks like useReducer() or useMemo().");
          };
          var warnInvalidHookAccess = function() {
            warning$1(false, "Do not call Hooks inside useEffect(...), useMemo(...), or other built-in Hooks. You can only call Hooks at the top level of your React function. For more information, see https://fb.me/rules-of-hooks");
          };
          HooksDispatcherOnMountInDEV = {
            readContext: function(context, observedBits) {
              return readContext(context, observedBits);
            },
            useCallback: function(callback, deps) {
              currentHookNameInDev = "useCallback";
              mountHookTypesDev();
              checkDepsAreArrayDev(deps);
              return mountCallback(callback, deps);
            },
            useContext: function(context, observedBits) {
              currentHookNameInDev = "useContext";
              mountHookTypesDev();
              return readContext(context, observedBits);
            },
            useEffect: function(create, deps) {
              currentHookNameInDev = "useEffect";
              mountHookTypesDev();
              checkDepsAreArrayDev(deps);
              return mountEffect(create, deps);
            },
            useImperativeHandle: function(ref2, create, deps) {
              currentHookNameInDev = "useImperativeHandle";
              mountHookTypesDev();
              checkDepsAreArrayDev(deps);
              return mountImperativeHandle(ref2, create, deps);
            },
            useLayoutEffect: function(create, deps) {
              currentHookNameInDev = "useLayoutEffect";
              mountHookTypesDev();
              checkDepsAreArrayDev(deps);
              return mountLayoutEffect(create, deps);
            },
            useMemo: function(create, deps) {
              currentHookNameInDev = "useMemo";
              mountHookTypesDev();
              checkDepsAreArrayDev(deps);
              var prevDispatcher = ReactCurrentDispatcher$1.current;
              ReactCurrentDispatcher$1.current = InvalidNestedHooksDispatcherOnMountInDEV;
              try {
                return mountMemo(create, deps);
              } finally {
                ReactCurrentDispatcher$1.current = prevDispatcher;
              }
            },
            useReducer: function(reducer, initialArg, init) {
              currentHookNameInDev = "useReducer";
              mountHookTypesDev();
              var prevDispatcher = ReactCurrentDispatcher$1.current;
              ReactCurrentDispatcher$1.current = InvalidNestedHooksDispatcherOnMountInDEV;
              try {
                return mountReducer(reducer, initialArg, init);
              } finally {
                ReactCurrentDispatcher$1.current = prevDispatcher;
              }
            },
            useRef: function(initialValue) {
              currentHookNameInDev = "useRef";
              mountHookTypesDev();
              return mountRef(initialValue);
            },
            useState: function(initialState) {
              currentHookNameInDev = "useState";
              mountHookTypesDev();
              var prevDispatcher = ReactCurrentDispatcher$1.current;
              ReactCurrentDispatcher$1.current = InvalidNestedHooksDispatcherOnMountInDEV;
              try {
                return mountState(initialState);
              } finally {
                ReactCurrentDispatcher$1.current = prevDispatcher;
              }
            },
            useDebugValue: function(value, formatterFn) {
              currentHookNameInDev = "useDebugValue";
              mountHookTypesDev();
              return mountDebugValue(value, formatterFn);
            },
            useResponder: function(responder, props) {
              currentHookNameInDev = "useResponder";
              mountHookTypesDev();
              return createResponderListener(responder, props);
            },
            useDeferredValue: function(value, config) {
              currentHookNameInDev = "useDeferredValue";
              mountHookTypesDev();
              return mountDeferredValue(value, config);
            },
            useTransition: function(config) {
              currentHookNameInDev = "useTransition";
              mountHookTypesDev();
              return mountTransition(config);
            }
          };
          HooksDispatcherOnMountWithHookTypesInDEV = {
            readContext: function(context, observedBits) {
              return readContext(context, observedBits);
            },
            useCallback: function(callback, deps) {
              currentHookNameInDev = "useCallback";
              updateHookTypesDev();
              return mountCallback(callback, deps);
            },
            useContext: function(context, observedBits) {
              currentHookNameInDev = "useContext";
              updateHookTypesDev();
              return readContext(context, observedBits);
            },
            useEffect: function(create, deps) {
              currentHookNameInDev = "useEffect";
              updateHookTypesDev();
              return mountEffect(create, deps);
            },
            useImperativeHandle: function(ref2, create, deps) {
              currentHookNameInDev = "useImperativeHandle";
              updateHookTypesDev();
              return mountImperativeHandle(ref2, create, deps);
            },
            useLayoutEffect: function(create, deps) {
              currentHookNameInDev = "useLayoutEffect";
              updateHookTypesDev();
              return mountLayoutEffect(create, deps);
            },
            useMemo: function(create, deps) {
              currentHookNameInDev = "useMemo";
              updateHookTypesDev();
              var prevDispatcher = ReactCurrentDispatcher$1.current;
              ReactCurrentDispatcher$1.current = InvalidNestedHooksDispatcherOnMountInDEV;
              try {
                return mountMemo(create, deps);
              } finally {
                ReactCurrentDispatcher$1.current = prevDispatcher;
              }
            },
            useReducer: function(reducer, initialArg, init) {
              currentHookNameInDev = "useReducer";
              updateHookTypesDev();
              var prevDispatcher = ReactCurrentDispatcher$1.current;
              ReactCurrentDispatcher$1.current = InvalidNestedHooksDispatcherOnMountInDEV;
              try {
                return mountReducer(reducer, initialArg, init);
              } finally {
                ReactCurrentDispatcher$1.current = prevDispatcher;
              }
            },
            useRef: function(initialValue) {
              currentHookNameInDev = "useRef";
              updateHookTypesDev();
              return mountRef(initialValue);
            },
            useState: function(initialState) {
              currentHookNameInDev = "useState";
              updateHookTypesDev();
              var prevDispatcher = ReactCurrentDispatcher$1.current;
              ReactCurrentDispatcher$1.current = InvalidNestedHooksDispatcherOnMountInDEV;
              try {
                return mountState(initialState);
              } finally {
                ReactCurrentDispatcher$1.current = prevDispatcher;
              }
            },
            useDebugValue: function(value, formatterFn) {
              currentHookNameInDev = "useDebugValue";
              updateHookTypesDev();
              return mountDebugValue(value, formatterFn);
            },
            useResponder: function(responder, props) {
              currentHookNameInDev = "useResponder";
              updateHookTypesDev();
              return createResponderListener(responder, props);
            },
            useDeferredValue: function(value, config) {
              currentHookNameInDev = "useDeferredValue";
              updateHookTypesDev();
              return mountDeferredValue(value, config);
            },
            useTransition: function(config) {
              currentHookNameInDev = "useTransition";
              updateHookTypesDev();
              return mountTransition(config);
            }
          };
          HooksDispatcherOnUpdateInDEV = {
            readContext: function(context, observedBits) {
              return readContext(context, observedBits);
            },
            useCallback: function(callback, deps) {
              currentHookNameInDev = "useCallback";
              updateHookTypesDev();
              return updateCallback(callback, deps);
            },
            useContext: function(context, observedBits) {
              currentHookNameInDev = "useContext";
              updateHookTypesDev();
              return readContext(context, observedBits);
            },
            useEffect: function(create, deps) {
              currentHookNameInDev = "useEffect";
              updateHookTypesDev();
              return updateEffect(create, deps);
            },
            useImperativeHandle: function(ref2, create, deps) {
              currentHookNameInDev = "useImperativeHandle";
              updateHookTypesDev();
              return updateImperativeHandle(ref2, create, deps);
            },
            useLayoutEffect: function(create, deps) {
              currentHookNameInDev = "useLayoutEffect";
              updateHookTypesDev();
              return updateLayoutEffect(create, deps);
            },
            useMemo: function(create, deps) {
              currentHookNameInDev = "useMemo";
              updateHookTypesDev();
              var prevDispatcher = ReactCurrentDispatcher$1.current;
              ReactCurrentDispatcher$1.current = InvalidNestedHooksDispatcherOnUpdateInDEV;
              try {
                return updateMemo(create, deps);
              } finally {
                ReactCurrentDispatcher$1.current = prevDispatcher;
              }
            },
            useReducer: function(reducer, initialArg, init) {
              currentHookNameInDev = "useReducer";
              updateHookTypesDev();
              var prevDispatcher = ReactCurrentDispatcher$1.current;
              ReactCurrentDispatcher$1.current = InvalidNestedHooksDispatcherOnUpdateInDEV;
              try {
                return updateReducer(reducer, initialArg, init);
              } finally {
                ReactCurrentDispatcher$1.current = prevDispatcher;
              }
            },
            useRef: function(initialValue) {
              currentHookNameInDev = "useRef";
              updateHookTypesDev();
              return updateRef(initialValue);
            },
            useState: function(initialState) {
              currentHookNameInDev = "useState";
              updateHookTypesDev();
              var prevDispatcher = ReactCurrentDispatcher$1.current;
              ReactCurrentDispatcher$1.current = InvalidNestedHooksDispatcherOnUpdateInDEV;
              try {
                return updateState(initialState);
              } finally {
                ReactCurrentDispatcher$1.current = prevDispatcher;
              }
            },
            useDebugValue: function(value, formatterFn) {
              currentHookNameInDev = "useDebugValue";
              updateHookTypesDev();
              return updateDebugValue(value, formatterFn);
            },
            useResponder: function(responder, props) {
              currentHookNameInDev = "useResponder";
              updateHookTypesDev();
              return createResponderListener(responder, props);
            },
            useDeferredValue: function(value, config) {
              currentHookNameInDev = "useDeferredValue";
              updateHookTypesDev();
              return updateDeferredValue(value, config);
            },
            useTransition: function(config) {
              currentHookNameInDev = "useTransition";
              updateHookTypesDev();
              return updateTransition(config);
            }
          };
          InvalidNestedHooksDispatcherOnMountInDEV = {
            readContext: function(context, observedBits) {
              warnInvalidContextAccess();
              return readContext(context, observedBits);
            },
            useCallback: function(callback, deps) {
              currentHookNameInDev = "useCallback";
              warnInvalidHookAccess();
              mountHookTypesDev();
              return mountCallback(callback, deps);
            },
            useContext: function(context, observedBits) {
              currentHookNameInDev = "useContext";
              warnInvalidHookAccess();
              mountHookTypesDev();
              return readContext(context, observedBits);
            },
            useEffect: function(create, deps) {
              currentHookNameInDev = "useEffect";
              warnInvalidHookAccess();
              mountHookTypesDev();
              return mountEffect(create, deps);
            },
            useImperativeHandle: function(ref2, create, deps) {
              currentHookNameInDev = "useImperativeHandle";
              warnInvalidHookAccess();
              mountHookTypesDev();
              return mountImperativeHandle(ref2, create, deps);
            },
            useLayoutEffect: function(create, deps) {
              currentHookNameInDev = "useLayoutEffect";
              warnInvalidHookAccess();
              mountHookTypesDev();
              return mountLayoutEffect(create, deps);
            },
            useMemo: function(create, deps) {
              currentHookNameInDev = "useMemo";
              warnInvalidHookAccess();
              mountHookTypesDev();
              var prevDispatcher = ReactCurrentDispatcher$1.current;
              ReactCurrentDispatcher$1.current = InvalidNestedHooksDispatcherOnMountInDEV;
              try {
                return mountMemo(create, deps);
              } finally {
                ReactCurrentDispatcher$1.current = prevDispatcher;
              }
            },
            useReducer: function(reducer, initialArg, init) {
              currentHookNameInDev = "useReducer";
              warnInvalidHookAccess();
              mountHookTypesDev();
              var prevDispatcher = ReactCurrentDispatcher$1.current;
              ReactCurrentDispatcher$1.current = InvalidNestedHooksDispatcherOnMountInDEV;
              try {
                return mountReducer(reducer, initialArg, init);
              } finally {
                ReactCurrentDispatcher$1.current = prevDispatcher;
              }
            },
            useRef: function(initialValue) {
              currentHookNameInDev = "useRef";
              warnInvalidHookAccess();
              mountHookTypesDev();
              return mountRef(initialValue);
            },
            useState: function(initialState) {
              currentHookNameInDev = "useState";
              warnInvalidHookAccess();
              mountHookTypesDev();
              var prevDispatcher = ReactCurrentDispatcher$1.current;
              ReactCurrentDispatcher$1.current = InvalidNestedHooksDispatcherOnMountInDEV;
              try {
                return mountState(initialState);
              } finally {
                ReactCurrentDispatcher$1.current = prevDispatcher;
              }
            },
            useDebugValue: function(value, formatterFn) {
              currentHookNameInDev = "useDebugValue";
              warnInvalidHookAccess();
              mountHookTypesDev();
              return mountDebugValue(value, formatterFn);
            },
            useResponder: function(responder, props) {
              currentHookNameInDev = "useResponder";
              warnInvalidHookAccess();
              mountHookTypesDev();
              return createResponderListener(responder, props);
            },
            useDeferredValue: function(value, config) {
              currentHookNameInDev = "useDeferredValue";
              warnInvalidHookAccess();
              mountHookTypesDev();
              return mountDeferredValue(value, config);
            },
            useTransition: function(config) {
              currentHookNameInDev = "useTransition";
              warnInvalidHookAccess();
              mountHookTypesDev();
              return mountTransition(config);
            }
          };
          InvalidNestedHooksDispatcherOnUpdateInDEV = {
            readContext: function(context, observedBits) {
              warnInvalidContextAccess();
              return readContext(context, observedBits);
            },
            useCallback: function(callback, deps) {
              currentHookNameInDev = "useCallback";
              warnInvalidHookAccess();
              updateHookTypesDev();
              return updateCallback(callback, deps);
            },
            useContext: function(context, observedBits) {
              currentHookNameInDev = "useContext";
              warnInvalidHookAccess();
              updateHookTypesDev();
              return readContext(context, observedBits);
            },
            useEffect: function(create, deps) {
              currentHookNameInDev = "useEffect";
              warnInvalidHookAccess();
              updateHookTypesDev();
              return updateEffect(create, deps);
            },
            useImperativeHandle: function(ref2, create, deps) {
              currentHookNameInDev = "useImperativeHandle";
              warnInvalidHookAccess();
              updateHookTypesDev();
              return updateImperativeHandle(ref2, create, deps);
            },
            useLayoutEffect: function(create, deps) {
              currentHookNameInDev = "useLayoutEffect";
              warnInvalidHookAccess();
              updateHookTypesDev();
              return updateLayoutEffect(create, deps);
            },
            useMemo: function(create, deps) {
              currentHookNameInDev = "useMemo";
              warnInvalidHookAccess();
              updateHookTypesDev();
              var prevDispatcher = ReactCurrentDispatcher$1.current;
              ReactCurrentDispatcher$1.current = InvalidNestedHooksDispatcherOnUpdateInDEV;
              try {
                return updateMemo(create, deps);
              } finally {
                ReactCurrentDispatcher$1.current = prevDispatcher;
              }
            },
            useReducer: function(reducer, initialArg, init) {
              currentHookNameInDev = "useReducer";
              warnInvalidHookAccess();
              updateHookTypesDev();
              var prevDispatcher = ReactCurrentDispatcher$1.current;
              ReactCurrentDispatcher$1.current = InvalidNestedHooksDispatcherOnUpdateInDEV;
              try {
                return updateReducer(reducer, initialArg, init);
              } finally {
                ReactCurrentDispatcher$1.current = prevDispatcher;
              }
            },
            useRef: function(initialValue) {
              currentHookNameInDev = "useRef";
              warnInvalidHookAccess();
              updateHookTypesDev();
              return updateRef(initialValue);
            },
            useState: function(initialState) {
              currentHookNameInDev = "useState";
              warnInvalidHookAccess();
              updateHookTypesDev();
              var prevDispatcher = ReactCurrentDispatcher$1.current;
              ReactCurrentDispatcher$1.current = InvalidNestedHooksDispatcherOnUpdateInDEV;
              try {
                return updateState(initialState);
              } finally {
                ReactCurrentDispatcher$1.current = prevDispatcher;
              }
            },
            useDebugValue: function(value, formatterFn) {
              currentHookNameInDev = "useDebugValue";
              warnInvalidHookAccess();
              updateHookTypesDev();
              return updateDebugValue(value, formatterFn);
            },
            useResponder: function(responder, props) {
              currentHookNameInDev = "useResponder";
              warnInvalidHookAccess();
              updateHookTypesDev();
              return createResponderListener(responder, props);
            },
            useDeferredValue: function(value, config) {
              currentHookNameInDev = "useDeferredValue";
              warnInvalidHookAccess();
              updateHookTypesDev();
              return updateDeferredValue(value, config);
            },
            useTransition: function(config) {
              currentHookNameInDev = "useTransition";
              warnInvalidHookAccess();
              updateHookTypesDev();
              return updateTransition(config);
            }
          };
        }
        var now$2 = Scheduler.unstable_now;
        var commitTime = 0;
        var profilerStartTime = -1;
        function getCommitTime() {
          return commitTime;
        }
        function recordCommitTime() {
          if (!enableProfilerTimer) {
            return;
          }
          commitTime = now$2();
        }
        function startProfilerTimer(fiber) {
          if (!enableProfilerTimer) {
            return;
          }
          profilerStartTime = now$2();
          if (fiber.actualStartTime < 0) {
            fiber.actualStartTime = now$2();
          }
        }
        function stopProfilerTimerIfRunning(fiber) {
          if (!enableProfilerTimer) {
            return;
          }
          profilerStartTime = -1;
        }
        function stopProfilerTimerIfRunningAndRecordDelta(fiber, overrideBaseTime) {
          if (!enableProfilerTimer) {
            return;
          }
          if (profilerStartTime >= 0) {
            var elapsedTime = now$2() - profilerStartTime;
            fiber.actualDuration += elapsedTime;
            if (overrideBaseTime) {
              fiber.selfBaseDuration = elapsedTime;
            }
            profilerStartTime = -1;
          }
        }
        var hydrationParentFiber = null;
        var nextHydratableInstance = null;
        var isHydrating = false;
        function warnIfHydrating() {
          {
            !!isHydrating ? warning$1(false, "We should not be hydrating here. This is a bug in React. Please file a bug.") : void 0;
          }
        }
        function enterHydrationState(fiber) {
          if (!supportsHydration) {
            return false;
          }
          var parentInstance = fiber.stateNode.containerInfo;
          nextHydratableInstance = getFirstHydratableChild(parentInstance);
          hydrationParentFiber = fiber;
          isHydrating = true;
          return true;
        }
        function reenterHydrationStateFromDehydratedSuspenseInstance(fiber, suspenseInstance) {
          if (!supportsHydration) {
            return false;
          }
          nextHydratableInstance = getNextHydratableSibling(suspenseInstance);
          popToNextHostParent(fiber);
          isHydrating = true;
          return true;
        }
        function deleteHydratableInstance(returnFiber, instance) {
          {
            switch (returnFiber.tag) {
              case HostRoot:
                didNotHydrateContainerInstance(returnFiber.stateNode.containerInfo, instance);
                break;
              case HostComponent:
                didNotHydrateInstance(returnFiber.type, returnFiber.memoizedProps, returnFiber.stateNode, instance);
                break;
            }
          }
          var childToDelete = createFiberFromHostInstanceForDeletion();
          childToDelete.stateNode = instance;
          childToDelete.return = returnFiber;
          childToDelete.effectTag = Deletion;
          if (returnFiber.lastEffect !== null) {
            returnFiber.lastEffect.nextEffect = childToDelete;
            returnFiber.lastEffect = childToDelete;
          } else {
            returnFiber.firstEffect = returnFiber.lastEffect = childToDelete;
          }
        }
        function insertNonHydratedInstance(returnFiber, fiber) {
          fiber.effectTag = fiber.effectTag & ~Hydrating | Placement;
          {
            switch (returnFiber.tag) {
              case HostRoot: {
                var parentContainer = returnFiber.stateNode.containerInfo;
                switch (fiber.tag) {
                  case HostComponent:
                    var type3 = fiber.type;
                    var props = fiber.pendingProps;
                    didNotFindHydratableContainerInstance(parentContainer, type3, props);
                    break;
                  case HostText:
                    var text = fiber.pendingProps;
                    didNotFindHydratableContainerTextInstance(parentContainer, text);
                    break;
                  case SuspenseComponent:
                    didNotFindHydratableContainerSuspenseInstance(parentContainer);
                    break;
                }
                break;
              }
              case HostComponent: {
                var parentType = returnFiber.type;
                var parentProps = returnFiber.memoizedProps;
                var parentInstance = returnFiber.stateNode;
                switch (fiber.tag) {
                  case HostComponent:
                    var _type = fiber.type;
                    var _props = fiber.pendingProps;
                    didNotFindHydratableInstance(parentType, parentProps, parentInstance, _type, _props);
                    break;
                  case HostText:
                    var _text = fiber.pendingProps;
                    didNotFindHydratableTextInstance(parentType, parentProps, parentInstance, _text);
                    break;
                  case SuspenseComponent:
                    didNotFindHydratableSuspenseInstance(parentType, parentProps, parentInstance);
                    break;
                }
                break;
              }
              default:
                return;
            }
          }
        }
        function tryHydrate(fiber, nextInstance) {
          switch (fiber.tag) {
            case HostComponent: {
              var type3 = fiber.type;
              var props = fiber.pendingProps;
              var instance = canHydrateInstance(nextInstance, type3, props);
              if (instance !== null) {
                fiber.stateNode = instance;
                return true;
              }
              return false;
            }
            case HostText: {
              var text = fiber.pendingProps;
              var textInstance = canHydrateTextInstance(nextInstance, text);
              if (textInstance !== null) {
                fiber.stateNode = textInstance;
                return true;
              }
              return false;
            }
            case SuspenseComponent: {
              if (enableSuspenseServerRenderer) {
                var suspenseInstance = canHydrateSuspenseInstance(nextInstance);
                if (suspenseInstance !== null) {
                  var suspenseState = {
                    dehydrated: suspenseInstance,
                    retryTime: Never
                  };
                  fiber.memoizedState = suspenseState;
                  var dehydratedFragment = createFiberFromDehydratedFragment(suspenseInstance);
                  dehydratedFragment.return = fiber;
                  fiber.child = dehydratedFragment;
                  return true;
                }
              }
              return false;
            }
            default:
              return false;
          }
        }
        function tryToClaimNextHydratableInstance(fiber) {
          if (!isHydrating) {
            return;
          }
          var nextInstance = nextHydratableInstance;
          if (!nextInstance) {
            insertNonHydratedInstance(hydrationParentFiber, fiber);
            isHydrating = false;
            hydrationParentFiber = fiber;
            return;
          }
          var firstAttemptedInstance = nextInstance;
          if (!tryHydrate(fiber, nextInstance)) {
            nextInstance = getNextHydratableSibling(firstAttemptedInstance);
            if (!nextInstance || !tryHydrate(fiber, nextInstance)) {
              insertNonHydratedInstance(hydrationParentFiber, fiber);
              isHydrating = false;
              hydrationParentFiber = fiber;
              return;
            }
            deleteHydratableInstance(hydrationParentFiber, firstAttemptedInstance);
          }
          hydrationParentFiber = fiber;
          nextHydratableInstance = getFirstHydratableChild(nextInstance);
        }
        function prepareToHydrateHostInstance(fiber, rootContainerInstance, hostContext) {
          if (!supportsHydration) {
            {
              {
                throw Error("Expected prepareToHydrateHostInstance() to never be called. This error is likely caused by a bug in React. Please file an issue.");
              }
            }
          }
          var instance = fiber.stateNode;
          var updatePayload = hydrateInstance(instance, fiber.type, fiber.memoizedProps, rootContainerInstance, hostContext, fiber);
          fiber.updateQueue = updatePayload;
          if (updatePayload !== null) {
            return true;
          }
          return false;
        }
        function prepareToHydrateHostTextInstance(fiber) {
          if (!supportsHydration) {
            {
              {
                throw Error("Expected prepareToHydrateHostTextInstance() to never be called. This error is likely caused by a bug in React. Please file an issue.");
              }
            }
          }
          var textInstance = fiber.stateNode;
          var textContent = fiber.memoizedProps;
          var shouldUpdate = hydrateTextInstance(textInstance, textContent, fiber);
          {
            if (shouldUpdate) {
              var returnFiber = hydrationParentFiber;
              if (returnFiber !== null) {
                switch (returnFiber.tag) {
                  case HostRoot: {
                    var parentContainer = returnFiber.stateNode.containerInfo;
                    didNotMatchHydratedContainerTextInstance(parentContainer, textInstance, textContent);
                    break;
                  }
                  case HostComponent: {
                    var parentType = returnFiber.type;
                    var parentProps = returnFiber.memoizedProps;
                    var parentInstance = returnFiber.stateNode;
                    didNotMatchHydratedTextInstance(parentType, parentProps, parentInstance, textInstance, textContent);
                    break;
                  }
                }
              }
            }
          }
          return shouldUpdate;
        }
        function prepareToHydrateHostSuspenseInstance(fiber) {
          if (!supportsHydration) {
            {
              {
                throw Error("Expected prepareToHydrateHostSuspenseInstance() to never be called. This error is likely caused by a bug in React. Please file an issue.");
              }
            }
          }
          var suspenseState = fiber.memoizedState;
          var suspenseInstance = suspenseState !== null ? suspenseState.dehydrated : null;
          if (!suspenseInstance) {
            {
              throw Error("Expected to have a hydrated suspense instance. This error is likely caused by a bug in React. Please file an issue.");
            }
          }
          hydrateSuspenseInstance(suspenseInstance, fiber);
        }
        function skipPastDehydratedSuspenseInstance(fiber) {
          if (!supportsHydration) {
            {
              {
                throw Error("Expected skipPastDehydratedSuspenseInstance() to never be called. This error is likely caused by a bug in React. Please file an issue.");
              }
            }
          }
          var suspenseState = fiber.memoizedState;
          var suspenseInstance = suspenseState !== null ? suspenseState.dehydrated : null;
          if (!suspenseInstance) {
            {
              throw Error("Expected to have a hydrated suspense instance. This error is likely caused by a bug in React. Please file an issue.");
            }
          }
          return getNextHydratableInstanceAfterSuspenseInstance(suspenseInstance);
        }
        function popToNextHostParent(fiber) {
          var parent = fiber.return;
          while (parent !== null && parent.tag !== HostComponent && parent.tag !== HostRoot && parent.tag !== SuspenseComponent) {
            parent = parent.return;
          }
          hydrationParentFiber = parent;
        }
        function popHydrationState(fiber) {
          if (!supportsHydration) {
            return false;
          }
          if (fiber !== hydrationParentFiber) {
            return false;
          }
          if (!isHydrating) {
            popToNextHostParent(fiber);
            isHydrating = true;
            return false;
          }
          var type3 = fiber.type;
          if (fiber.tag !== HostComponent || type3 !== "head" && type3 !== "body" && !shouldSetTextContent(type3, fiber.memoizedProps)) {
            var nextInstance = nextHydratableInstance;
            while (nextInstance) {
              deleteHydratableInstance(fiber, nextInstance);
              nextInstance = getNextHydratableSibling(nextInstance);
            }
          }
          popToNextHostParent(fiber);
          if (fiber.tag === SuspenseComponent) {
            nextHydratableInstance = skipPastDehydratedSuspenseInstance(fiber);
          } else {
            nextHydratableInstance = hydrationParentFiber ? getNextHydratableSibling(fiber.stateNode) : null;
          }
          return true;
        }
        function resetHydrationState() {
          if (!supportsHydration) {
            return;
          }
          hydrationParentFiber = null;
          nextHydratableInstance = null;
          isHydrating = false;
        }
        var ReactCurrentOwner$2 = ReactSharedInternals.ReactCurrentOwner;
        var didReceiveUpdate = false;
        var didWarnAboutBadClass;
        var didWarnAboutModulePatternComponent;
        var didWarnAboutContextTypeOnFunctionComponent;
        var didWarnAboutGetDerivedStateOnFunctionComponent;
        var didWarnAboutFunctionRefs;
        var didWarnAboutReassigningProps;
        var didWarnAboutMaxDuration;
        var didWarnAboutRevealOrder;
        var didWarnAboutTailOptions;
        var didWarnAboutDefaultPropsOnFunctionComponent;
        {
          didWarnAboutBadClass = {};
          didWarnAboutModulePatternComponent = {};
          didWarnAboutContextTypeOnFunctionComponent = {};
          didWarnAboutGetDerivedStateOnFunctionComponent = {};
          didWarnAboutFunctionRefs = {};
          didWarnAboutReassigningProps = false;
          didWarnAboutMaxDuration = false;
          didWarnAboutRevealOrder = {};
          didWarnAboutTailOptions = {};
          didWarnAboutDefaultPropsOnFunctionComponent = {};
        }
        function reconcileChildren(current$$1, workInProgress2, nextChildren, renderExpirationTime2) {
          if (current$$1 === null) {
            workInProgress2.child = mountChildFibers(workInProgress2, null, nextChildren, renderExpirationTime2);
          } else {
            workInProgress2.child = reconcileChildFibers(workInProgress2, current$$1.child, nextChildren, renderExpirationTime2);
          }
        }
        function forceUnmountCurrentAndReconcile(current$$1, workInProgress2, nextChildren, renderExpirationTime2) {
          workInProgress2.child = reconcileChildFibers(workInProgress2, current$$1.child, null, renderExpirationTime2);
          workInProgress2.child = reconcileChildFibers(workInProgress2, null, nextChildren, renderExpirationTime2);
        }
        function updateForwardRef(current$$1, workInProgress2, Component, nextProps, renderExpirationTime2) {
          {
            if (workInProgress2.type !== workInProgress2.elementType) {
              var innerPropTypes = Component.propTypes;
              if (innerPropTypes) {
                checkPropTypes(innerPropTypes, nextProps, "prop", getComponentName(Component), getCurrentFiberStackInDev);
              }
            }
          }
          var render2 = Component.render;
          var ref2 = workInProgress2.ref;
          var nextChildren;
          prepareToReadContext(workInProgress2, renderExpirationTime2);
          {
            ReactCurrentOwner$2.current = workInProgress2;
            setCurrentPhase("render");
            nextChildren = renderWithHooks(current$$1, workInProgress2, render2, nextProps, ref2, renderExpirationTime2);
            if (debugRenderPhaseSideEffectsForStrictMode && workInProgress2.mode & StrictMode) {
              if (workInProgress2.memoizedState !== null) {
                nextChildren = renderWithHooks(current$$1, workInProgress2, render2, nextProps, ref2, renderExpirationTime2);
              }
            }
            setCurrentPhase(null);
          }
          if (current$$1 !== null && !didReceiveUpdate) {
            bailoutHooks(current$$1, workInProgress2, renderExpirationTime2);
            return bailoutOnAlreadyFinishedWork(current$$1, workInProgress2, renderExpirationTime2);
          }
          workInProgress2.effectTag |= PerformedWork;
          reconcileChildren(current$$1, workInProgress2, nextChildren, renderExpirationTime2);
          return workInProgress2.child;
        }
        function updateMemoComponent(current$$1, workInProgress2, Component, nextProps, updateExpirationTime, renderExpirationTime2) {
          if (current$$1 === null) {
            var type3 = Component.type;
            if (isSimpleFunctionComponent(type3) && Component.compare === null && Component.defaultProps === void 0) {
              var resolvedType = type3;
              {
                resolvedType = resolveFunctionForHotReloading(type3);
              }
              workInProgress2.tag = SimpleMemoComponent;
              workInProgress2.type = resolvedType;
              {
                validateFunctionComponentInDev(workInProgress2, type3);
              }
              return updateSimpleMemoComponent(current$$1, workInProgress2, resolvedType, nextProps, updateExpirationTime, renderExpirationTime2);
            }
            {
              var innerPropTypes = type3.propTypes;
              if (innerPropTypes) {
                checkPropTypes(innerPropTypes, nextProps, "prop", getComponentName(type3), getCurrentFiberStackInDev);
              }
            }
            var child = createFiberFromTypeAndProps(Component.type, null, nextProps, null, workInProgress2.mode, renderExpirationTime2);
            child.ref = workInProgress2.ref;
            child.return = workInProgress2;
            workInProgress2.child = child;
            return child;
          }
          {
            var _type = Component.type;
            var _innerPropTypes = _type.propTypes;
            if (_innerPropTypes) {
              checkPropTypes(_innerPropTypes, nextProps, "prop", getComponentName(_type), getCurrentFiberStackInDev);
            }
          }
          var currentChild = current$$1.child;
          if (updateExpirationTime < renderExpirationTime2) {
            var prevProps = currentChild.memoizedProps;
            var compare = Component.compare;
            compare = compare !== null ? compare : shallowEqual;
            if (compare(prevProps, nextProps) && current$$1.ref === workInProgress2.ref) {
              return bailoutOnAlreadyFinishedWork(current$$1, workInProgress2, renderExpirationTime2);
            }
          }
          workInProgress2.effectTag |= PerformedWork;
          var newChild = createWorkInProgress(currentChild, nextProps, renderExpirationTime2);
          newChild.ref = workInProgress2.ref;
          newChild.return = workInProgress2;
          workInProgress2.child = newChild;
          return newChild;
        }
        function updateSimpleMemoComponent(current$$1, workInProgress2, Component, nextProps, updateExpirationTime, renderExpirationTime2) {
          {
            if (workInProgress2.type !== workInProgress2.elementType) {
              var outerMemoType = workInProgress2.elementType;
              if (outerMemoType.$$typeof === REACT_LAZY_TYPE) {
                outerMemoType = refineResolvedLazyComponent(outerMemoType);
              }
              var outerPropTypes = outerMemoType && outerMemoType.propTypes;
              if (outerPropTypes) {
                checkPropTypes(outerPropTypes, nextProps, "prop", getComponentName(outerMemoType), getCurrentFiberStackInDev);
              }
            }
          }
          if (current$$1 !== null) {
            var prevProps = current$$1.memoizedProps;
            if (shallowEqual(prevProps, nextProps) && current$$1.ref === workInProgress2.ref && workInProgress2.type === current$$1.type) {
              didReceiveUpdate = false;
              if (updateExpirationTime < renderExpirationTime2) {
                return bailoutOnAlreadyFinishedWork(current$$1, workInProgress2, renderExpirationTime2);
              }
            }
          }
          return updateFunctionComponent(current$$1, workInProgress2, Component, nextProps, renderExpirationTime2);
        }
        function updateFragment(current$$1, workInProgress2, renderExpirationTime2) {
          var nextChildren = workInProgress2.pendingProps;
          reconcileChildren(current$$1, workInProgress2, nextChildren, renderExpirationTime2);
          return workInProgress2.child;
        }
        function updateMode(current$$1, workInProgress2, renderExpirationTime2) {
          var nextChildren = workInProgress2.pendingProps.children;
          reconcileChildren(current$$1, workInProgress2, nextChildren, renderExpirationTime2);
          return workInProgress2.child;
        }
        function updateProfiler(current$$1, workInProgress2, renderExpirationTime2) {
          if (enableProfilerTimer) {
            workInProgress2.effectTag |= Update;
          }
          var nextProps = workInProgress2.pendingProps;
          var nextChildren = nextProps.children;
          reconcileChildren(current$$1, workInProgress2, nextChildren, renderExpirationTime2);
          return workInProgress2.child;
        }
        function markRef(current$$1, workInProgress2) {
          var ref2 = workInProgress2.ref;
          if (current$$1 === null && ref2 !== null || current$$1 !== null && current$$1.ref !== ref2) {
            workInProgress2.effectTag |= Ref;
          }
        }
        function updateFunctionComponent(current$$1, workInProgress2, Component, nextProps, renderExpirationTime2) {
          {
            if (workInProgress2.type !== workInProgress2.elementType) {
              var innerPropTypes = Component.propTypes;
              if (innerPropTypes) {
                checkPropTypes(innerPropTypes, nextProps, "prop", getComponentName(Component), getCurrentFiberStackInDev);
              }
            }
          }
          var context;
          if (!disableLegacyContext) {
            var unmaskedContext = getUnmaskedContext(workInProgress2, Component, true);
            context = getMaskedContext(workInProgress2, unmaskedContext);
          }
          var nextChildren;
          prepareToReadContext(workInProgress2, renderExpirationTime2);
          {
            ReactCurrentOwner$2.current = workInProgress2;
            setCurrentPhase("render");
            nextChildren = renderWithHooks(current$$1, workInProgress2, Component, nextProps, context, renderExpirationTime2);
            if (debugRenderPhaseSideEffectsForStrictMode && workInProgress2.mode & StrictMode) {
              if (workInProgress2.memoizedState !== null) {
                nextChildren = renderWithHooks(current$$1, workInProgress2, Component, nextProps, context, renderExpirationTime2);
              }
            }
            setCurrentPhase(null);
          }
          if (current$$1 !== null && !didReceiveUpdate) {
            bailoutHooks(current$$1, workInProgress2, renderExpirationTime2);
            return bailoutOnAlreadyFinishedWork(current$$1, workInProgress2, renderExpirationTime2);
          }
          workInProgress2.effectTag |= PerformedWork;
          reconcileChildren(current$$1, workInProgress2, nextChildren, renderExpirationTime2);
          return workInProgress2.child;
        }
        function updateClassComponent(current$$1, workInProgress2, Component, nextProps, renderExpirationTime2) {
          {
            if (workInProgress2.type !== workInProgress2.elementType) {
              var innerPropTypes = Component.propTypes;
              if (innerPropTypes) {
                checkPropTypes(innerPropTypes, nextProps, "prop", getComponentName(Component), getCurrentFiberStackInDev);
              }
            }
          }
          var hasContext;
          if (isContextProvider(Component)) {
            hasContext = true;
            pushContextProvider(workInProgress2);
          } else {
            hasContext = false;
          }
          prepareToReadContext(workInProgress2, renderExpirationTime2);
          var instance = workInProgress2.stateNode;
          var shouldUpdate;
          if (instance === null) {
            if (current$$1 !== null) {
              current$$1.alternate = null;
              workInProgress2.alternate = null;
              workInProgress2.effectTag |= Placement;
            }
            constructClassInstance(workInProgress2, Component, nextProps, renderExpirationTime2);
            mountClassInstance(workInProgress2, Component, nextProps, renderExpirationTime2);
            shouldUpdate = true;
          } else if (current$$1 === null) {
            shouldUpdate = resumeMountClassInstance(workInProgress2, Component, nextProps, renderExpirationTime2);
          } else {
            shouldUpdate = updateClassInstance(current$$1, workInProgress2, Component, nextProps, renderExpirationTime2);
          }
          var nextUnitOfWork = finishClassComponent(current$$1, workInProgress2, Component, shouldUpdate, hasContext, renderExpirationTime2);
          {
            var inst = workInProgress2.stateNode;
            if (inst.props !== nextProps) {
              !didWarnAboutReassigningProps ? warning$1(false, "It looks like %s is reassigning its own `this.props` while rendering. This is not supported and can lead to confusing bugs.", getComponentName(workInProgress2.type) || "a component") : void 0;
              didWarnAboutReassigningProps = true;
            }
          }
          return nextUnitOfWork;
        }
        function finishClassComponent(current$$1, workInProgress2, Component, shouldUpdate, hasContext, renderExpirationTime2) {
          markRef(current$$1, workInProgress2);
          var didCaptureError = (workInProgress2.effectTag & DidCapture) !== NoEffect;
          if (!shouldUpdate && !didCaptureError) {
            if (hasContext) {
              invalidateContextProvider(workInProgress2, Component, false);
            }
            return bailoutOnAlreadyFinishedWork(current$$1, workInProgress2, renderExpirationTime2);
          }
          var instance = workInProgress2.stateNode;
          ReactCurrentOwner$2.current = workInProgress2;
          var nextChildren;
          if (didCaptureError && typeof Component.getDerivedStateFromError !== "function") {
            nextChildren = null;
            if (enableProfilerTimer) {
              stopProfilerTimerIfRunning(workInProgress2);
            }
          } else {
            {
              setCurrentPhase("render");
              nextChildren = instance.render();
              if (debugRenderPhaseSideEffectsForStrictMode && workInProgress2.mode & StrictMode) {
                instance.render();
              }
              setCurrentPhase(null);
            }
          }
          workInProgress2.effectTag |= PerformedWork;
          if (current$$1 !== null && didCaptureError) {
            forceUnmountCurrentAndReconcile(current$$1, workInProgress2, nextChildren, renderExpirationTime2);
          } else {
            reconcileChildren(current$$1, workInProgress2, nextChildren, renderExpirationTime2);
          }
          workInProgress2.memoizedState = instance.state;
          if (hasContext) {
            invalidateContextProvider(workInProgress2, Component, true);
          }
          return workInProgress2.child;
        }
        function pushHostRootContext(workInProgress2) {
          var root = workInProgress2.stateNode;
          if (root.pendingContext) {
            pushTopLevelContextObject(workInProgress2, root.pendingContext, root.pendingContext !== root.context);
          } else if (root.context) {
            pushTopLevelContextObject(workInProgress2, root.context, false);
          }
          pushHostContainer(workInProgress2, root.containerInfo);
        }
        function updateHostRoot(current$$1, workInProgress2, renderExpirationTime2) {
          pushHostRootContext(workInProgress2);
          var updateQueue = workInProgress2.updateQueue;
          if (!(updateQueue !== null)) {
            {
              throw Error("If the root does not have an updateQueue, we should have already bailed out. This error is likely caused by a bug in React. Please file an issue.");
            }
          }
          var nextProps = workInProgress2.pendingProps;
          var prevState = workInProgress2.memoizedState;
          var prevChildren = prevState !== null ? prevState.element : null;
          processUpdateQueue(workInProgress2, updateQueue, nextProps, null, renderExpirationTime2);
          var nextState = workInProgress2.memoizedState;
          var nextChildren = nextState.element;
          if (nextChildren === prevChildren) {
            resetHydrationState();
            return bailoutOnAlreadyFinishedWork(current$$1, workInProgress2, renderExpirationTime2);
          }
          var root = workInProgress2.stateNode;
          if (root.hydrate && enterHydrationState(workInProgress2)) {
            var child = mountChildFibers(workInProgress2, null, nextChildren, renderExpirationTime2);
            workInProgress2.child = child;
            var node = child;
            while (node) {
              node.effectTag = node.effectTag & ~Placement | Hydrating;
              node = node.sibling;
            }
          } else {
            reconcileChildren(current$$1, workInProgress2, nextChildren, renderExpirationTime2);
            resetHydrationState();
          }
          return workInProgress2.child;
        }
        function updateHostComponent(current$$1, workInProgress2, renderExpirationTime2) {
          pushHostContext(workInProgress2);
          if (current$$1 === null) {
            tryToClaimNextHydratableInstance(workInProgress2);
          }
          var type3 = workInProgress2.type;
          var nextProps = workInProgress2.pendingProps;
          var prevProps = current$$1 !== null ? current$$1.memoizedProps : null;
          var nextChildren = nextProps.children;
          var isDirectTextChild = shouldSetTextContent(type3, nextProps);
          if (isDirectTextChild) {
            nextChildren = null;
          } else if (prevProps !== null && shouldSetTextContent(type3, prevProps)) {
            workInProgress2.effectTag |= ContentReset;
          }
          markRef(current$$1, workInProgress2);
          if (workInProgress2.mode & ConcurrentMode && renderExpirationTime2 !== Never && shouldDeprioritizeSubtree(type3, nextProps)) {
            if (enableSchedulerTracing) {
              markSpawnedWork(Never);
            }
            workInProgress2.expirationTime = workInProgress2.childExpirationTime = Never;
            return null;
          }
          reconcileChildren(current$$1, workInProgress2, nextChildren, renderExpirationTime2);
          return workInProgress2.child;
        }
        function updateHostText(current$$1, workInProgress2) {
          if (current$$1 === null) {
            tryToClaimNextHydratableInstance(workInProgress2);
          }
          return null;
        }
        function mountLazyComponent(_current, workInProgress2, elementType, updateExpirationTime, renderExpirationTime2) {
          if (_current !== null) {
            _current.alternate = null;
            workInProgress2.alternate = null;
            workInProgress2.effectTag |= Placement;
          }
          var props = workInProgress2.pendingProps;
          cancelWorkTimer(workInProgress2);
          var Component = readLazyComponentType(elementType);
          workInProgress2.type = Component;
          var resolvedTag = workInProgress2.tag = resolveLazyComponentTag(Component);
          startWorkTimer(workInProgress2);
          var resolvedProps = resolveDefaultProps(Component, props);
          var child;
          switch (resolvedTag) {
            case FunctionComponent: {
              {
                validateFunctionComponentInDev(workInProgress2, Component);
                workInProgress2.type = Component = resolveFunctionForHotReloading(Component);
              }
              child = updateFunctionComponent(null, workInProgress2, Component, resolvedProps, renderExpirationTime2);
              break;
            }
            case ClassComponent: {
              {
                workInProgress2.type = Component = resolveClassForHotReloading(Component);
              }
              child = updateClassComponent(null, workInProgress2, Component, resolvedProps, renderExpirationTime2);
              break;
            }
            case ForwardRef: {
              {
                workInProgress2.type = Component = resolveForwardRefForHotReloading(Component);
              }
              child = updateForwardRef(null, workInProgress2, Component, resolvedProps, renderExpirationTime2);
              break;
            }
            case MemoComponent: {
              {
                if (workInProgress2.type !== workInProgress2.elementType) {
                  var outerPropTypes = Component.propTypes;
                  if (outerPropTypes) {
                    checkPropTypes(outerPropTypes, resolvedProps, "prop", getComponentName(Component), getCurrentFiberStackInDev);
                  }
                }
              }
              child = updateMemoComponent(null, workInProgress2, Component, resolveDefaultProps(Component.type, resolvedProps), updateExpirationTime, renderExpirationTime2);
              break;
            }
            default: {
              var hint = "";
              {
                if (Component !== null && typeof Component === "object" && Component.$$typeof === REACT_LAZY_TYPE) {
                  hint = " Did you wrap a component in React.lazy() more than once?";
                }
              }
              {
                {
                  throw Error("Element type is invalid. Received a promise that resolves to: " + Component + ". Lazy element type must resolve to a class or function." + hint);
                }
              }
            }
          }
          return child;
        }
        function mountIncompleteClassComponent(_current, workInProgress2, Component, nextProps, renderExpirationTime2) {
          if (_current !== null) {
            _current.alternate = null;
            workInProgress2.alternate = null;
            workInProgress2.effectTag |= Placement;
          }
          workInProgress2.tag = ClassComponent;
          var hasContext;
          if (isContextProvider(Component)) {
            hasContext = true;
            pushContextProvider(workInProgress2);
          } else {
            hasContext = false;
          }
          prepareToReadContext(workInProgress2, renderExpirationTime2);
          constructClassInstance(workInProgress2, Component, nextProps, renderExpirationTime2);
          mountClassInstance(workInProgress2, Component, nextProps, renderExpirationTime2);
          return finishClassComponent(null, workInProgress2, Component, true, hasContext, renderExpirationTime2);
        }
        function mountIndeterminateComponent(_current, workInProgress2, Component, renderExpirationTime2) {
          if (_current !== null) {
            _current.alternate = null;
            workInProgress2.alternate = null;
            workInProgress2.effectTag |= Placement;
          }
          var props = workInProgress2.pendingProps;
          var context;
          if (!disableLegacyContext) {
            var unmaskedContext = getUnmaskedContext(workInProgress2, Component, false);
            context = getMaskedContext(workInProgress2, unmaskedContext);
          }
          prepareToReadContext(workInProgress2, renderExpirationTime2);
          var value;
          {
            if (Component.prototype && typeof Component.prototype.render === "function") {
              var componentName = getComponentName(Component) || "Unknown";
              if (!didWarnAboutBadClass[componentName]) {
                warningWithoutStack$1(false, "The <%s /> component appears to have a render method, but doesn't extend React.Component. This is likely to cause errors. Change %s to extend React.Component instead.", componentName, componentName);
                didWarnAboutBadClass[componentName] = true;
              }
            }
            if (workInProgress2.mode & StrictMode) {
              ReactStrictModeWarnings.recordLegacyContextWarning(workInProgress2, null);
            }
            ReactCurrentOwner$2.current = workInProgress2;
            value = renderWithHooks(null, workInProgress2, Component, props, context, renderExpirationTime2);
          }
          workInProgress2.effectTag |= PerformedWork;
          if (typeof value === "object" && value !== null && typeof value.render === "function" && value.$$typeof === void 0) {
            {
              var _componentName = getComponentName(Component) || "Unknown";
              if (!didWarnAboutModulePatternComponent[_componentName]) {
                warningWithoutStack$1(false, "The <%s /> component appears to be a function component that returns a class instance. Change %s to a class that extends React.Component instead. If you can't use a class try assigning the prototype on the function as a workaround. `%s.prototype = React.Component.prototype`. Don't use an arrow function since it cannot be called with `new` by React.", _componentName, _componentName, _componentName);
                didWarnAboutModulePatternComponent[_componentName] = true;
              }
            }
            workInProgress2.tag = ClassComponent;
            resetHooks();
            var hasContext = false;
            if (isContextProvider(Component)) {
              hasContext = true;
              pushContextProvider(workInProgress2);
            } else {
              hasContext = false;
            }
            workInProgress2.memoizedState = value.state !== null && value.state !== void 0 ? value.state : null;
            var getDerivedStateFromProps = Component.getDerivedStateFromProps;
            if (typeof getDerivedStateFromProps === "function") {
              applyDerivedStateFromProps(workInProgress2, Component, getDerivedStateFromProps, props);
            }
            adoptClassInstance(workInProgress2, value);
            mountClassInstance(workInProgress2, Component, props, renderExpirationTime2);
            return finishClassComponent(null, workInProgress2, Component, true, hasContext, renderExpirationTime2);
          } else {
            workInProgress2.tag = FunctionComponent;
            {
              if (disableLegacyContext && Component.contextTypes) {
                warningWithoutStack$1(false, "%s uses the legacy contextTypes API which is no longer supported. Use React.createContext() with React.useContext() instead.", getComponentName(Component) || "Unknown");
              }
              if (debugRenderPhaseSideEffectsForStrictMode && workInProgress2.mode & StrictMode) {
                if (workInProgress2.memoizedState !== null) {
                  value = renderWithHooks(null, workInProgress2, Component, props, context, renderExpirationTime2);
                }
              }
            }
            reconcileChildren(null, workInProgress2, value, renderExpirationTime2);
            {
              validateFunctionComponentInDev(workInProgress2, Component);
            }
            return workInProgress2.child;
          }
        }
        function validateFunctionComponentInDev(workInProgress2, Component) {
          if (Component) {
            !!Component.childContextTypes ? warningWithoutStack$1(false, "%s(...): childContextTypes cannot be defined on a function component.", Component.displayName || Component.name || "Component") : void 0;
          }
          if (workInProgress2.ref !== null) {
            var info = "";
            var ownerName = getCurrentFiberOwnerNameInDevOrNull();
            if (ownerName) {
              info += "\n\nCheck the render method of `" + ownerName + "`.";
            }
            var warningKey = ownerName || workInProgress2._debugID || "";
            var debugSource = workInProgress2._debugSource;
            if (debugSource) {
              warningKey = debugSource.fileName + ":" + debugSource.lineNumber;
            }
            if (!didWarnAboutFunctionRefs[warningKey]) {
              didWarnAboutFunctionRefs[warningKey] = true;
              warning$1(false, "Function components cannot be given refs. Attempts to access this ref will fail. Did you mean to use React.forwardRef()?%s", info);
            }
          }
          if (warnAboutDefaultPropsOnFunctionComponents && Component.defaultProps !== void 0) {
            var componentName = getComponentName(Component) || "Unknown";
            if (!didWarnAboutDefaultPropsOnFunctionComponent[componentName]) {
              warningWithoutStack$1(false, "%s: Support for defaultProps will be removed from function components in a future major release. Use JavaScript default parameters instead.", componentName);
              didWarnAboutDefaultPropsOnFunctionComponent[componentName] = true;
            }
          }
          if (typeof Component.getDerivedStateFromProps === "function") {
            var _componentName2 = getComponentName(Component) || "Unknown";
            if (!didWarnAboutGetDerivedStateOnFunctionComponent[_componentName2]) {
              warningWithoutStack$1(false, "%s: Function components do not support getDerivedStateFromProps.", _componentName2);
              didWarnAboutGetDerivedStateOnFunctionComponent[_componentName2] = true;
            }
          }
          if (typeof Component.contextType === "object" && Component.contextType !== null) {
            var _componentName3 = getComponentName(Component) || "Unknown";
            if (!didWarnAboutContextTypeOnFunctionComponent[_componentName3]) {
              warningWithoutStack$1(false, "%s: Function components do not support contextType.", _componentName3);
              didWarnAboutContextTypeOnFunctionComponent[_componentName3] = true;
            }
          }
        }
        var SUSPENDED_MARKER = {
          dehydrated: null,
          retryTime: NoWork
        };
        function shouldRemainOnFallback(suspenseContext, current$$1, workInProgress2) {
          return hasSuspenseContext(suspenseContext, ForceSuspenseFallback) && (current$$1 === null || current$$1.memoizedState !== null);
        }
        function updateSuspenseComponent(current$$1, workInProgress2, renderExpirationTime2) {
          var mode = workInProgress2.mode;
          var nextProps = workInProgress2.pendingProps;
          {
            if (shouldSuspend(workInProgress2)) {
              workInProgress2.effectTag |= DidCapture;
            }
          }
          var suspenseContext = suspenseStackCursor.current;
          var nextDidTimeout = false;
          var didSuspend = (workInProgress2.effectTag & DidCapture) !== NoEffect;
          if (didSuspend || shouldRemainOnFallback(suspenseContext, current$$1, workInProgress2)) {
            nextDidTimeout = true;
            workInProgress2.effectTag &= ~DidCapture;
          } else {
            if (current$$1 === null || current$$1.memoizedState !== null) {
              if (nextProps.fallback !== void 0 && nextProps.unstable_avoidThisFallback !== true) {
                suspenseContext = addSubtreeSuspenseContext(suspenseContext, InvisibleParentSuspenseContext);
              }
            }
          }
          suspenseContext = setDefaultShallowSuspenseContext(suspenseContext);
          pushSuspenseContext(workInProgress2, suspenseContext);
          {
            if ("maxDuration" in nextProps) {
              if (!didWarnAboutMaxDuration) {
                didWarnAboutMaxDuration = true;
                warning$1(false, "maxDuration has been removed from React. Remove the maxDuration prop.");
              }
            }
          }
          if (current$$1 === null) {
            if (nextProps.fallback !== void 0) {
              tryToClaimNextHydratableInstance(workInProgress2);
              if (enableSuspenseServerRenderer) {
                var suspenseState = workInProgress2.memoizedState;
                if (suspenseState !== null) {
                  var dehydrated = suspenseState.dehydrated;
                  if (dehydrated !== null) {
                    return mountDehydratedSuspenseComponent(workInProgress2, dehydrated, renderExpirationTime2);
                  }
                }
              }
            }
            if (nextDidTimeout) {
              var nextFallbackChildren = nextProps.fallback;
              var primaryChildFragment = createFiberFromFragment(null, mode, NoWork, null);
              primaryChildFragment.return = workInProgress2;
              if ((workInProgress2.mode & BlockingMode) === NoMode) {
                var progressedState = workInProgress2.memoizedState;
                var progressedPrimaryChild = progressedState !== null ? workInProgress2.child.child : workInProgress2.child;
                primaryChildFragment.child = progressedPrimaryChild;
                var progressedChild = progressedPrimaryChild;
                while (progressedChild !== null) {
                  progressedChild.return = primaryChildFragment;
                  progressedChild = progressedChild.sibling;
                }
              }
              var fallbackChildFragment = createFiberFromFragment(nextFallbackChildren, mode, renderExpirationTime2, null);
              fallbackChildFragment.return = workInProgress2;
              primaryChildFragment.sibling = fallbackChildFragment;
              workInProgress2.memoizedState = SUSPENDED_MARKER;
              workInProgress2.child = primaryChildFragment;
              return fallbackChildFragment;
            } else {
              var nextPrimaryChildren = nextProps.children;
              workInProgress2.memoizedState = null;
              return workInProgress2.child = mountChildFibers(workInProgress2, null, nextPrimaryChildren, renderExpirationTime2);
            }
          } else {
            var prevState = current$$1.memoizedState;
            if (prevState !== null) {
              if (enableSuspenseServerRenderer) {
                var _dehydrated = prevState.dehydrated;
                if (_dehydrated !== null) {
                  if (!didSuspend) {
                    return updateDehydratedSuspenseComponent(current$$1, workInProgress2, _dehydrated, prevState, renderExpirationTime2);
                  } else if (workInProgress2.memoizedState !== null) {
                    workInProgress2.child = current$$1.child;
                    workInProgress2.effectTag |= DidCapture;
                    return null;
                  } else {
                    var _nextFallbackChildren = nextProps.fallback;
                    var _primaryChildFragment = createFiberFromFragment(null, mode, NoWork, null);
                    _primaryChildFragment.return = workInProgress2;
                    _primaryChildFragment.child = null;
                    if ((workInProgress2.mode & BlockingMode) === NoMode) {
                      var _progressedChild = _primaryChildFragment.child = workInProgress2.child;
                      while (_progressedChild !== null) {
                        _progressedChild.return = _primaryChildFragment;
                        _progressedChild = _progressedChild.sibling;
                      }
                    } else {
                      reconcileChildFibers(workInProgress2, current$$1.child, null, renderExpirationTime2);
                    }
                    if (enableProfilerTimer && workInProgress2.mode & ProfileMode) {
                      var treeBaseDuration = 0;
                      var hiddenChild = _primaryChildFragment.child;
                      while (hiddenChild !== null) {
                        treeBaseDuration += hiddenChild.treeBaseDuration;
                        hiddenChild = hiddenChild.sibling;
                      }
                      _primaryChildFragment.treeBaseDuration = treeBaseDuration;
                    }
                    var _fallbackChildFragment = createFiberFromFragment(_nextFallbackChildren, mode, renderExpirationTime2, null);
                    _fallbackChildFragment.return = workInProgress2;
                    _primaryChildFragment.sibling = _fallbackChildFragment;
                    _fallbackChildFragment.effectTag |= Placement;
                    _primaryChildFragment.childExpirationTime = NoWork;
                    workInProgress2.memoizedState = SUSPENDED_MARKER;
                    workInProgress2.child = _primaryChildFragment;
                    return _fallbackChildFragment;
                  }
                }
              }
              var currentPrimaryChildFragment = current$$1.child;
              var currentFallbackChildFragment = currentPrimaryChildFragment.sibling;
              if (nextDidTimeout) {
                var _nextFallbackChildren2 = nextProps.fallback;
                var _primaryChildFragment2 = createWorkInProgress(currentPrimaryChildFragment, currentPrimaryChildFragment.pendingProps, NoWork);
                _primaryChildFragment2.return = workInProgress2;
                if ((workInProgress2.mode & BlockingMode) === NoMode) {
                  var _progressedState = workInProgress2.memoizedState;
                  var _progressedPrimaryChild = _progressedState !== null ? workInProgress2.child.child : workInProgress2.child;
                  if (_progressedPrimaryChild !== currentPrimaryChildFragment.child) {
                    _primaryChildFragment2.child = _progressedPrimaryChild;
                    var _progressedChild2 = _progressedPrimaryChild;
                    while (_progressedChild2 !== null) {
                      _progressedChild2.return = _primaryChildFragment2;
                      _progressedChild2 = _progressedChild2.sibling;
                    }
                  }
                }
                if (enableProfilerTimer && workInProgress2.mode & ProfileMode) {
                  var _treeBaseDuration = 0;
                  var _hiddenChild = _primaryChildFragment2.child;
                  while (_hiddenChild !== null) {
                    _treeBaseDuration += _hiddenChild.treeBaseDuration;
                    _hiddenChild = _hiddenChild.sibling;
                  }
                  _primaryChildFragment2.treeBaseDuration = _treeBaseDuration;
                }
                var _fallbackChildFragment2 = createWorkInProgress(currentFallbackChildFragment, _nextFallbackChildren2, currentFallbackChildFragment.expirationTime);
                _fallbackChildFragment2.return = workInProgress2;
                _primaryChildFragment2.sibling = _fallbackChildFragment2;
                _primaryChildFragment2.childExpirationTime = NoWork;
                workInProgress2.memoizedState = SUSPENDED_MARKER;
                workInProgress2.child = _primaryChildFragment2;
                return _fallbackChildFragment2;
              } else {
                var _nextPrimaryChildren = nextProps.children;
                var currentPrimaryChild = currentPrimaryChildFragment.child;
                var primaryChild = reconcileChildFibers(workInProgress2, currentPrimaryChild, _nextPrimaryChildren, renderExpirationTime2);
                workInProgress2.memoizedState = null;
                return workInProgress2.child = primaryChild;
              }
            } else {
              var _currentPrimaryChild = current$$1.child;
              if (nextDidTimeout) {
                var _nextFallbackChildren3 = nextProps.fallback;
                var _primaryChildFragment3 = createFiberFromFragment(null, mode, NoWork, null);
                _primaryChildFragment3.return = workInProgress2;
                _primaryChildFragment3.child = _currentPrimaryChild;
                if (_currentPrimaryChild !== null) {
                  _currentPrimaryChild.return = _primaryChildFragment3;
                }
                if ((workInProgress2.mode & BlockingMode) === NoMode) {
                  var _progressedState2 = workInProgress2.memoizedState;
                  var _progressedPrimaryChild2 = _progressedState2 !== null ? workInProgress2.child.child : workInProgress2.child;
                  _primaryChildFragment3.child = _progressedPrimaryChild2;
                  var _progressedChild3 = _progressedPrimaryChild2;
                  while (_progressedChild3 !== null) {
                    _progressedChild3.return = _primaryChildFragment3;
                    _progressedChild3 = _progressedChild3.sibling;
                  }
                }
                if (enableProfilerTimer && workInProgress2.mode & ProfileMode) {
                  var _treeBaseDuration2 = 0;
                  var _hiddenChild2 = _primaryChildFragment3.child;
                  while (_hiddenChild2 !== null) {
                    _treeBaseDuration2 += _hiddenChild2.treeBaseDuration;
                    _hiddenChild2 = _hiddenChild2.sibling;
                  }
                  _primaryChildFragment3.treeBaseDuration = _treeBaseDuration2;
                }
                var _fallbackChildFragment3 = createFiberFromFragment(_nextFallbackChildren3, mode, renderExpirationTime2, null);
                _fallbackChildFragment3.return = workInProgress2;
                _primaryChildFragment3.sibling = _fallbackChildFragment3;
                _fallbackChildFragment3.effectTag |= Placement;
                _primaryChildFragment3.childExpirationTime = NoWork;
                workInProgress2.memoizedState = SUSPENDED_MARKER;
                workInProgress2.child = _primaryChildFragment3;
                return _fallbackChildFragment3;
              } else {
                workInProgress2.memoizedState = null;
                var _nextPrimaryChildren2 = nextProps.children;
                return workInProgress2.child = reconcileChildFibers(workInProgress2, _currentPrimaryChild, _nextPrimaryChildren2, renderExpirationTime2);
              }
            }
          }
        }
        function retrySuspenseComponentWithoutHydrating(current$$1, workInProgress2, renderExpirationTime2) {
          workInProgress2.memoizedState = null;
          var nextProps = workInProgress2.pendingProps;
          var nextChildren = nextProps.children;
          reconcileChildren(current$$1, workInProgress2, nextChildren, renderExpirationTime2);
          return workInProgress2.child;
        }
        function mountDehydratedSuspenseComponent(workInProgress2, suspenseInstance, renderExpirationTime2) {
          if ((workInProgress2.mode & BlockingMode) === NoMode) {
            {
              warning$1(false, "Cannot hydrate Suspense in legacy mode. Switch from ReactDOM.hydrate(element, container) to ReactDOM.createBlockingRoot(container, { hydrate: true }).render(element) or remove the Suspense components from the server rendered components.");
            }
            workInProgress2.expirationTime = Sync;
          } else if (isSuspenseInstanceFallback(suspenseInstance)) {
            var serverDisplayTime = requestCurrentTimeForUpdate();
            var newExpirationTime = computeAsyncExpiration(serverDisplayTime);
            if (enableSchedulerTracing) {
              markSpawnedWork(newExpirationTime);
            }
            workInProgress2.expirationTime = newExpirationTime;
          } else {
            workInProgress2.expirationTime = Never;
            if (enableSchedulerTracing) {
              markSpawnedWork(Never);
            }
          }
          return null;
        }
        function updateDehydratedSuspenseComponent(current$$1, workInProgress2, suspenseInstance, suspenseState, renderExpirationTime2) {
          warnIfHydrating();
          if ((workInProgress2.mode & BlockingMode) === NoMode) {
            return retrySuspenseComponentWithoutHydrating(current$$1, workInProgress2, renderExpirationTime2);
          }
          if (isSuspenseInstanceFallback(suspenseInstance)) {
            return retrySuspenseComponentWithoutHydrating(current$$1, workInProgress2, renderExpirationTime2);
          }
          var hasContextChanged$$1 = current$$1.childExpirationTime >= renderExpirationTime2;
          if (didReceiveUpdate || hasContextChanged$$1) {
            if (renderExpirationTime2 < Sync) {
              if (suspenseState.retryTime <= renderExpirationTime2) {
                var attemptHydrationAtExpirationTime = renderExpirationTime2 + 1;
                suspenseState.retryTime = attemptHydrationAtExpirationTime;
                scheduleWork(current$$1, attemptHydrationAtExpirationTime);
              } else {
              }
            }
            renderDidSuspendDelayIfPossible();
            return retrySuspenseComponentWithoutHydrating(current$$1, workInProgress2, renderExpirationTime2);
          } else if (isSuspenseInstancePending(suspenseInstance)) {
            workInProgress2.effectTag |= DidCapture;
            workInProgress2.child = current$$1.child;
            registerSuspenseInstanceRetry(suspenseInstance, retryDehydratedSuspenseBoundary.bind(null, current$$1));
            return null;
          } else {
            reenterHydrationStateFromDehydratedSuspenseInstance(workInProgress2, suspenseInstance);
            var nextProps = workInProgress2.pendingProps;
            var nextChildren = nextProps.children;
            var child = mountChildFibers(workInProgress2, null, nextChildren, renderExpirationTime2);
            var node = child;
            while (node) {
              node.effectTag |= Hydrating;
              node = node.sibling;
            }
            workInProgress2.child = child;
            return workInProgress2.child;
          }
        }
        function scheduleWorkOnFiber(fiber, renderExpirationTime2) {
          if (fiber.expirationTime < renderExpirationTime2) {
            fiber.expirationTime = renderExpirationTime2;
          }
          var alternate = fiber.alternate;
          if (alternate !== null && alternate.expirationTime < renderExpirationTime2) {
            alternate.expirationTime = renderExpirationTime2;
          }
          scheduleWorkOnParentPath(fiber.return, renderExpirationTime2);
        }
        function propagateSuspenseContextChange(workInProgress2, firstChild, renderExpirationTime2) {
          var node = firstChild;
          while (node !== null) {
            if (node.tag === SuspenseComponent) {
              var state = node.memoizedState;
              if (state !== null) {
                scheduleWorkOnFiber(node, renderExpirationTime2);
              }
            } else if (node.tag === SuspenseListComponent) {
              scheduleWorkOnFiber(node, renderExpirationTime2);
            } else if (node.child !== null) {
              node.child.return = node;
              node = node.child;
              continue;
            }
            if (node === workInProgress2) {
              return;
            }
            while (node.sibling === null) {
              if (node.return === null || node.return === workInProgress2) {
                return;
              }
              node = node.return;
            }
            node.sibling.return = node.return;
            node = node.sibling;
          }
        }
        function findLastContentRow(firstChild) {
          var row = firstChild;
          var lastContentRow = null;
          while (row !== null) {
            var currentRow = row.alternate;
            if (currentRow !== null && findFirstSuspended(currentRow) === null) {
              lastContentRow = row;
            }
            row = row.sibling;
          }
          return lastContentRow;
        }
        function validateRevealOrder(revealOrder) {
          {
            if (revealOrder !== void 0 && revealOrder !== "forwards" && revealOrder !== "backwards" && revealOrder !== "together" && !didWarnAboutRevealOrder[revealOrder]) {
              didWarnAboutRevealOrder[revealOrder] = true;
              if (typeof revealOrder === "string") {
                switch (revealOrder.toLowerCase()) {
                  case "together":
                  case "forwards":
                  case "backwards": {
                    warning$1(false, '"%s" is not a valid value for revealOrder on <SuspenseList />. Use lowercase "%s" instead.', revealOrder, revealOrder.toLowerCase());
                    break;
                  }
                  case "forward":
                  case "backward": {
                    warning$1(false, '"%s" is not a valid value for revealOrder on <SuspenseList />. React uses the -s suffix in the spelling. Use "%ss" instead.', revealOrder, revealOrder.toLowerCase());
                    break;
                  }
                  default:
                    warning$1(false, '"%s" is not a supported revealOrder on <SuspenseList />. Did you mean "together", "forwards" or "backwards"?', revealOrder);
                    break;
                }
              } else {
                warning$1(false, '%s is not a supported value for revealOrder on <SuspenseList />. Did you mean "together", "forwards" or "backwards"?', revealOrder);
              }
            }
          }
        }
        function validateTailOptions(tailMode, revealOrder) {
          {
            if (tailMode !== void 0 && !didWarnAboutTailOptions[tailMode]) {
              if (tailMode !== "collapsed" && tailMode !== "hidden") {
                didWarnAboutTailOptions[tailMode] = true;
                warning$1(false, '"%s" is not a supported value for tail on <SuspenseList />. Did you mean "collapsed" or "hidden"?', tailMode);
              } else if (revealOrder !== "forwards" && revealOrder !== "backwards") {
                didWarnAboutTailOptions[tailMode] = true;
                warning$1(false, '<SuspenseList tail="%s" /> is only valid if revealOrder is "forwards" or "backwards". Did you mean to specify revealOrder="forwards"?', tailMode);
              }
            }
          }
        }
        function validateSuspenseListNestedChild(childSlot, index2) {
          {
            var isArray2 = Array.isArray(childSlot);
            var isIterable = !isArray2 && typeof getIteratorFn(childSlot) === "function";
            if (isArray2 || isIterable) {
              var type3 = isArray2 ? "array" : "iterable";
              warning$1(false, "A nested %s was passed to row #%s in <SuspenseList />. Wrap it in an additional SuspenseList to configure its revealOrder: <SuspenseList revealOrder=...> ... <SuspenseList revealOrder=...>{%s}</SuspenseList> ... </SuspenseList>", type3, index2, type3);
              return false;
            }
          }
          return true;
        }
        function validateSuspenseListChildren(children, revealOrder) {
          {
            if ((revealOrder === "forwards" || revealOrder === "backwards") && children !== void 0 && children !== null && children !== false) {
              if (Array.isArray(children)) {
                for (var i3 = 0; i3 < children.length; i3++) {
                  if (!validateSuspenseListNestedChild(children[i3], i3)) {
                    return;
                  }
                }
              } else {
                var iteratorFn = getIteratorFn(children);
                if (typeof iteratorFn === "function") {
                  var childrenIterator = iteratorFn.call(children);
                  if (childrenIterator) {
                    var step = childrenIterator.next();
                    var _i = 0;
                    for (; !step.done; step = childrenIterator.next()) {
                      if (!validateSuspenseListNestedChild(step.value, _i)) {
                        return;
                      }
                      _i++;
                    }
                  }
                } else {
                  warning$1(false, 'A single row was passed to a <SuspenseList revealOrder="%s" />. This is not useful since it needs multiple rows. Did you mean to pass multiple children or an array?', revealOrder);
                }
              }
            }
          }
        }
        function initSuspenseListRenderState(workInProgress2, isBackwards, tail, lastContentRow, tailMode, lastEffectBeforeRendering) {
          var renderState = workInProgress2.memoizedState;
          if (renderState === null) {
            workInProgress2.memoizedState = {
              isBackwards,
              rendering: null,
              last: lastContentRow,
              tail,
              tailExpiration: 0,
              tailMode,
              lastEffect: lastEffectBeforeRendering
            };
          } else {
            renderState.isBackwards = isBackwards;
            renderState.rendering = null;
            renderState.last = lastContentRow;
            renderState.tail = tail;
            renderState.tailExpiration = 0;
            renderState.tailMode = tailMode;
            renderState.lastEffect = lastEffectBeforeRendering;
          }
        }
        function updateSuspenseListComponent(current$$1, workInProgress2, renderExpirationTime2) {
          var nextProps = workInProgress2.pendingProps;
          var revealOrder = nextProps.revealOrder;
          var tailMode = nextProps.tail;
          var newChildren = nextProps.children;
          validateRevealOrder(revealOrder);
          validateTailOptions(tailMode, revealOrder);
          validateSuspenseListChildren(newChildren, revealOrder);
          reconcileChildren(current$$1, workInProgress2, newChildren, renderExpirationTime2);
          var suspenseContext = suspenseStackCursor.current;
          var shouldForceFallback = hasSuspenseContext(suspenseContext, ForceSuspenseFallback);
          if (shouldForceFallback) {
            suspenseContext = setShallowSuspenseContext(suspenseContext, ForceSuspenseFallback);
            workInProgress2.effectTag |= DidCapture;
          } else {
            var didSuspendBefore = current$$1 !== null && (current$$1.effectTag & DidCapture) !== NoEffect;
            if (didSuspendBefore) {
              propagateSuspenseContextChange(workInProgress2, workInProgress2.child, renderExpirationTime2);
            }
            suspenseContext = setDefaultShallowSuspenseContext(suspenseContext);
          }
          pushSuspenseContext(workInProgress2, suspenseContext);
          if ((workInProgress2.mode & BlockingMode) === NoMode) {
            workInProgress2.memoizedState = null;
          } else {
            switch (revealOrder) {
              case "forwards": {
                var lastContentRow = findLastContentRow(workInProgress2.child);
                var tail;
                if (lastContentRow === null) {
                  tail = workInProgress2.child;
                  workInProgress2.child = null;
                } else {
                  tail = lastContentRow.sibling;
                  lastContentRow.sibling = null;
                }
                initSuspenseListRenderState(workInProgress2, false, tail, lastContentRow, tailMode, workInProgress2.lastEffect);
                break;
              }
              case "backwards": {
                var _tail = null;
                var row = workInProgress2.child;
                workInProgress2.child = null;
                while (row !== null) {
                  var currentRow = row.alternate;
                  if (currentRow !== null && findFirstSuspended(currentRow) === null) {
                    workInProgress2.child = row;
                    break;
                  }
                  var nextRow = row.sibling;
                  row.sibling = _tail;
                  _tail = row;
                  row = nextRow;
                }
                initSuspenseListRenderState(workInProgress2, true, _tail, null, tailMode, workInProgress2.lastEffect);
                break;
              }
              case "together": {
                initSuspenseListRenderState(workInProgress2, false, null, null, void 0, workInProgress2.lastEffect);
                break;
              }
              default: {
                workInProgress2.memoizedState = null;
              }
            }
          }
          return workInProgress2.child;
        }
        function updatePortalComponent(current$$1, workInProgress2, renderExpirationTime2) {
          pushHostContainer(workInProgress2, workInProgress2.stateNode.containerInfo);
          var nextChildren = workInProgress2.pendingProps;
          if (current$$1 === null) {
            workInProgress2.child = reconcileChildFibers(workInProgress2, null, nextChildren, renderExpirationTime2);
          } else {
            reconcileChildren(current$$1, workInProgress2, nextChildren, renderExpirationTime2);
          }
          return workInProgress2.child;
        }
        function updateContextProvider(current$$1, workInProgress2, renderExpirationTime2) {
          var providerType = workInProgress2.type;
          var context = providerType._context;
          var newProps = workInProgress2.pendingProps;
          var oldProps = workInProgress2.memoizedProps;
          var newValue = newProps.value;
          {
            var providerPropTypes = workInProgress2.type.propTypes;
            if (providerPropTypes) {
              checkPropTypes(providerPropTypes, newProps, "prop", "Context.Provider", getCurrentFiberStackInDev);
            }
          }
          pushProvider(workInProgress2, newValue);
          if (oldProps !== null) {
            var oldValue = oldProps.value;
            var changedBits = calculateChangedBits(context, newValue, oldValue);
            if (changedBits === 0) {
              if (oldProps.children === newProps.children && !hasContextChanged()) {
                return bailoutOnAlreadyFinishedWork(current$$1, workInProgress2, renderExpirationTime2);
              }
            } else {
              propagateContextChange(workInProgress2, context, changedBits, renderExpirationTime2);
            }
          }
          var newChildren = newProps.children;
          reconcileChildren(current$$1, workInProgress2, newChildren, renderExpirationTime2);
          return workInProgress2.child;
        }
        var hasWarnedAboutUsingContextAsConsumer = false;
        function updateContextConsumer(current$$1, workInProgress2, renderExpirationTime2) {
          var context = workInProgress2.type;
          {
            if (context._context === void 0) {
              if (context !== context.Consumer) {
                if (!hasWarnedAboutUsingContextAsConsumer) {
                  hasWarnedAboutUsingContextAsConsumer = true;
                  warning$1(false, "Rendering <Context> directly is not supported and will be removed in a future major release. Did you mean to render <Context.Consumer> instead?");
                }
              }
            } else {
              context = context._context;
            }
          }
          var newProps = workInProgress2.pendingProps;
          var render2 = newProps.children;
          {
            !(typeof render2 === "function") ? warningWithoutStack$1(false, "A context consumer was rendered with multiple children, or a child that isn't a function. A context consumer expects a single child that is a function. If you did pass a function, make sure there is no trailing or leading whitespace around it.") : void 0;
          }
          prepareToReadContext(workInProgress2, renderExpirationTime2);
          var newValue = readContext(context, newProps.unstable_observedBits);
          var newChildren;
          {
            ReactCurrentOwner$2.current = workInProgress2;
            setCurrentPhase("render");
            newChildren = render2(newValue);
            setCurrentPhase(null);
          }
          workInProgress2.effectTag |= PerformedWork;
          reconcileChildren(current$$1, workInProgress2, newChildren, renderExpirationTime2);
          return workInProgress2.child;
        }
        function updateFundamentalComponent$1(current$$1, workInProgress2, renderExpirationTime2) {
          var fundamentalImpl = workInProgress2.type.impl;
          if (fundamentalImpl.reconcileChildren === false) {
            return null;
          }
          var nextProps = workInProgress2.pendingProps;
          var nextChildren = nextProps.children;
          reconcileChildren(current$$1, workInProgress2, nextChildren, renderExpirationTime2);
          return workInProgress2.child;
        }
        function updateScopeComponent(current$$1, workInProgress2, renderExpirationTime2) {
          var nextProps = workInProgress2.pendingProps;
          var nextChildren = nextProps.children;
          reconcileChildren(current$$1, workInProgress2, nextChildren, renderExpirationTime2);
          return workInProgress2.child;
        }
        function markWorkInProgressReceivedUpdate() {
          didReceiveUpdate = true;
        }
        function bailoutOnAlreadyFinishedWork(current$$1, workInProgress2, renderExpirationTime2) {
          cancelWorkTimer(workInProgress2);
          if (current$$1 !== null) {
            workInProgress2.dependencies = current$$1.dependencies;
          }
          if (enableProfilerTimer) {
            stopProfilerTimerIfRunning(workInProgress2);
          }
          var updateExpirationTime = workInProgress2.expirationTime;
          if (updateExpirationTime !== NoWork) {
            markUnprocessedUpdateTime(updateExpirationTime);
          }
          var childExpirationTime = workInProgress2.childExpirationTime;
          if (childExpirationTime < renderExpirationTime2) {
            return null;
          } else {
            cloneChildFibers(current$$1, workInProgress2);
            return workInProgress2.child;
          }
        }
        function remountFiber(current$$1, oldWorkInProgress, newWorkInProgress) {
          {
            var returnFiber = oldWorkInProgress.return;
            if (returnFiber === null) {
              throw new Error("Cannot swap the root fiber.");
            }
            current$$1.alternate = null;
            oldWorkInProgress.alternate = null;
            newWorkInProgress.index = oldWorkInProgress.index;
            newWorkInProgress.sibling = oldWorkInProgress.sibling;
            newWorkInProgress.return = oldWorkInProgress.return;
            newWorkInProgress.ref = oldWorkInProgress.ref;
            if (oldWorkInProgress === returnFiber.child) {
              returnFiber.child = newWorkInProgress;
            } else {
              var prevSibling = returnFiber.child;
              if (prevSibling === null) {
                throw new Error("Expected parent to have a child.");
              }
              while (prevSibling.sibling !== oldWorkInProgress) {
                prevSibling = prevSibling.sibling;
                if (prevSibling === null) {
                  throw new Error("Expected to find the previous sibling.");
                }
              }
              prevSibling.sibling = newWorkInProgress;
            }
            var last = returnFiber.lastEffect;
            if (last !== null) {
              last.nextEffect = current$$1;
              returnFiber.lastEffect = current$$1;
            } else {
              returnFiber.firstEffect = returnFiber.lastEffect = current$$1;
            }
            current$$1.nextEffect = null;
            current$$1.effectTag = Deletion;
            newWorkInProgress.effectTag |= Placement;
            return newWorkInProgress;
          }
        }
        function beginWork$1(current$$1, workInProgress2, renderExpirationTime2) {
          var updateExpirationTime = workInProgress2.expirationTime;
          {
            if (workInProgress2._debugNeedsRemount && current$$1 !== null) {
              return remountFiber(current$$1, workInProgress2, createFiberFromTypeAndProps(workInProgress2.type, workInProgress2.key, workInProgress2.pendingProps, workInProgress2._debugOwner || null, workInProgress2.mode, workInProgress2.expirationTime));
            }
          }
          if (current$$1 !== null) {
            var oldProps = current$$1.memoizedProps;
            var newProps = workInProgress2.pendingProps;
            if (oldProps !== newProps || hasContextChanged() || workInProgress2.type !== current$$1.type) {
              didReceiveUpdate = true;
            } else if (updateExpirationTime < renderExpirationTime2) {
              didReceiveUpdate = false;
              switch (workInProgress2.tag) {
                case HostRoot:
                  pushHostRootContext(workInProgress2);
                  resetHydrationState();
                  break;
                case HostComponent:
                  pushHostContext(workInProgress2);
                  if (workInProgress2.mode & ConcurrentMode && renderExpirationTime2 !== Never && shouldDeprioritizeSubtree(workInProgress2.type, newProps)) {
                    if (enableSchedulerTracing) {
                      markSpawnedWork(Never);
                    }
                    workInProgress2.expirationTime = workInProgress2.childExpirationTime = Never;
                    return null;
                  }
                  break;
                case ClassComponent: {
                  var Component = workInProgress2.type;
                  if (isContextProvider(Component)) {
                    pushContextProvider(workInProgress2);
                  }
                  break;
                }
                case HostPortal:
                  pushHostContainer(workInProgress2, workInProgress2.stateNode.containerInfo);
                  break;
                case ContextProvider: {
                  var newValue = workInProgress2.memoizedProps.value;
                  pushProvider(workInProgress2, newValue);
                  break;
                }
                case Profiler:
                  if (enableProfilerTimer) {
                    var hasChildWork = workInProgress2.childExpirationTime >= renderExpirationTime2;
                    if (hasChildWork) {
                      workInProgress2.effectTag |= Update;
                    }
                  }
                  break;
                case SuspenseComponent: {
                  var state = workInProgress2.memoizedState;
                  if (state !== null) {
                    if (enableSuspenseServerRenderer) {
                      if (state.dehydrated !== null) {
                        pushSuspenseContext(workInProgress2, setDefaultShallowSuspenseContext(suspenseStackCursor.current));
                        workInProgress2.effectTag |= DidCapture;
                        break;
                      }
                    }
                    var primaryChildFragment = workInProgress2.child;
                    var primaryChildExpirationTime = primaryChildFragment.childExpirationTime;
                    if (primaryChildExpirationTime !== NoWork && primaryChildExpirationTime >= renderExpirationTime2) {
                      return updateSuspenseComponent(current$$1, workInProgress2, renderExpirationTime2);
                    } else {
                      pushSuspenseContext(workInProgress2, setDefaultShallowSuspenseContext(suspenseStackCursor.current));
                      var child = bailoutOnAlreadyFinishedWork(current$$1, workInProgress2, renderExpirationTime2);
                      if (child !== null) {
                        return child.sibling;
                      } else {
                        return null;
                      }
                    }
                  } else {
                    pushSuspenseContext(workInProgress2, setDefaultShallowSuspenseContext(suspenseStackCursor.current));
                  }
                  break;
                }
                case SuspenseListComponent: {
                  var didSuspendBefore = (current$$1.effectTag & DidCapture) !== NoEffect;
                  var _hasChildWork = workInProgress2.childExpirationTime >= renderExpirationTime2;
                  if (didSuspendBefore) {
                    if (_hasChildWork) {
                      return updateSuspenseListComponent(current$$1, workInProgress2, renderExpirationTime2);
                    }
                    workInProgress2.effectTag |= DidCapture;
                  }
                  var renderState = workInProgress2.memoizedState;
                  if (renderState !== null) {
                    renderState.rendering = null;
                    renderState.tail = null;
                  }
                  pushSuspenseContext(workInProgress2, suspenseStackCursor.current);
                  if (_hasChildWork) {
                    break;
                  } else {
                    return null;
                  }
                }
              }
              return bailoutOnAlreadyFinishedWork(current$$1, workInProgress2, renderExpirationTime2);
            } else {
              didReceiveUpdate = false;
            }
          } else {
            didReceiveUpdate = false;
          }
          workInProgress2.expirationTime = NoWork;
          switch (workInProgress2.tag) {
            case IndeterminateComponent: {
              return mountIndeterminateComponent(current$$1, workInProgress2, workInProgress2.type, renderExpirationTime2);
            }
            case LazyComponent: {
              var elementType = workInProgress2.elementType;
              return mountLazyComponent(current$$1, workInProgress2, elementType, updateExpirationTime, renderExpirationTime2);
            }
            case FunctionComponent: {
              var _Component = workInProgress2.type;
              var unresolvedProps = workInProgress2.pendingProps;
              var resolvedProps = workInProgress2.elementType === _Component ? unresolvedProps : resolveDefaultProps(_Component, unresolvedProps);
              return updateFunctionComponent(current$$1, workInProgress2, _Component, resolvedProps, renderExpirationTime2);
            }
            case ClassComponent: {
              var _Component2 = workInProgress2.type;
              var _unresolvedProps = workInProgress2.pendingProps;
              var _resolvedProps = workInProgress2.elementType === _Component2 ? _unresolvedProps : resolveDefaultProps(_Component2, _unresolvedProps);
              return updateClassComponent(current$$1, workInProgress2, _Component2, _resolvedProps, renderExpirationTime2);
            }
            case HostRoot:
              return updateHostRoot(current$$1, workInProgress2, renderExpirationTime2);
            case HostComponent:
              return updateHostComponent(current$$1, workInProgress2, renderExpirationTime2);
            case HostText:
              return updateHostText(current$$1, workInProgress2);
            case SuspenseComponent:
              return updateSuspenseComponent(current$$1, workInProgress2, renderExpirationTime2);
            case HostPortal:
              return updatePortalComponent(current$$1, workInProgress2, renderExpirationTime2);
            case ForwardRef: {
              var type3 = workInProgress2.type;
              var _unresolvedProps2 = workInProgress2.pendingProps;
              var _resolvedProps2 = workInProgress2.elementType === type3 ? _unresolvedProps2 : resolveDefaultProps(type3, _unresolvedProps2);
              return updateForwardRef(current$$1, workInProgress2, type3, _resolvedProps2, renderExpirationTime2);
            }
            case Fragment:
              return updateFragment(current$$1, workInProgress2, renderExpirationTime2);
            case Mode:
              return updateMode(current$$1, workInProgress2, renderExpirationTime2);
            case Profiler:
              return updateProfiler(current$$1, workInProgress2, renderExpirationTime2);
            case ContextProvider:
              return updateContextProvider(current$$1, workInProgress2, renderExpirationTime2);
            case ContextConsumer:
              return updateContextConsumer(current$$1, workInProgress2, renderExpirationTime2);
            case MemoComponent: {
              var _type2 = workInProgress2.type;
              var _unresolvedProps3 = workInProgress2.pendingProps;
              var _resolvedProps3 = resolveDefaultProps(_type2, _unresolvedProps3);
              {
                if (workInProgress2.type !== workInProgress2.elementType) {
                  var outerPropTypes = _type2.propTypes;
                  if (outerPropTypes) {
                    checkPropTypes(outerPropTypes, _resolvedProps3, "prop", getComponentName(_type2), getCurrentFiberStackInDev);
                  }
                }
              }
              _resolvedProps3 = resolveDefaultProps(_type2.type, _resolvedProps3);
              return updateMemoComponent(current$$1, workInProgress2, _type2, _resolvedProps3, updateExpirationTime, renderExpirationTime2);
            }
            case SimpleMemoComponent: {
              return updateSimpleMemoComponent(current$$1, workInProgress2, workInProgress2.type, workInProgress2.pendingProps, updateExpirationTime, renderExpirationTime2);
            }
            case IncompleteClassComponent: {
              var _Component3 = workInProgress2.type;
              var _unresolvedProps4 = workInProgress2.pendingProps;
              var _resolvedProps4 = workInProgress2.elementType === _Component3 ? _unresolvedProps4 : resolveDefaultProps(_Component3, _unresolvedProps4);
              return mountIncompleteClassComponent(current$$1, workInProgress2, _Component3, _resolvedProps4, renderExpirationTime2);
            }
            case SuspenseListComponent: {
              return updateSuspenseListComponent(current$$1, workInProgress2, renderExpirationTime2);
            }
            case FundamentalComponent: {
              if (enableFundamentalAPI) {
                return updateFundamentalComponent$1(current$$1, workInProgress2, renderExpirationTime2);
              }
              break;
            }
            case ScopeComponent: {
              if (enableScopeAPI) {
                return updateScopeComponent(current$$1, workInProgress2, renderExpirationTime2);
              }
              break;
            }
          }
          {
            {
              throw Error("Unknown unit of work tag (" + workInProgress2.tag + "). This error is likely caused by a bug in React. Please file an issue.");
            }
          }
        }
        function createFundamentalStateInstance(currentFiber2, props, impl, state) {
          return {
            currentFiber: currentFiber2,
            impl,
            instance: null,
            prevProps: null,
            props,
            state
          };
        }
        function isFiberSuspenseAndTimedOut(fiber) {
          return fiber.tag === SuspenseComponent && fiber.memoizedState !== null;
        }
        function getSuspenseFallbackChild(fiber) {
          return fiber.child.sibling.child;
        }
        var emptyObject$1 = {};
        function collectScopedNodes(node, fn, scopedNodes) {
          if (enableScopeAPI) {
            if (node.tag === HostComponent) {
              var _type = node.type, memoizedProps = node.memoizedProps, stateNode = node.stateNode;
              var _instance = getPublicInstance(stateNode);
              if (_instance !== null && fn(_type, memoizedProps || emptyObject$1, _instance) === true) {
                scopedNodes.push(_instance);
              }
            }
            var child = node.child;
            if (isFiberSuspenseAndTimedOut(node)) {
              child = getSuspenseFallbackChild(node);
            }
            if (child !== null) {
              collectScopedNodesFromChildren(child, fn, scopedNodes);
            }
          }
        }
        function collectFirstScopedNode(node, fn) {
          if (enableScopeAPI) {
            if (node.tag === HostComponent) {
              var _type2 = node.type, memoizedProps = node.memoizedProps, stateNode = node.stateNode;
              var _instance2 = getPublicInstance(stateNode);
              if (_instance2 !== null && fn(_type2, memoizedProps, _instance2) === true) {
                return _instance2;
              }
            }
            var child = node.child;
            if (isFiberSuspenseAndTimedOut(node)) {
              child = getSuspenseFallbackChild(node);
            }
            if (child !== null) {
              return collectFirstScopedNodeFromChildren(child, fn);
            }
          }
          return null;
        }
        function collectScopedNodesFromChildren(startingChild, fn, scopedNodes) {
          var child = startingChild;
          while (child !== null) {
            collectScopedNodes(child, fn, scopedNodes);
            child = child.sibling;
          }
        }
        function collectFirstScopedNodeFromChildren(startingChild, fn) {
          var child = startingChild;
          while (child !== null) {
            var scopedNode = collectFirstScopedNode(child, fn);
            if (scopedNode !== null) {
              return scopedNode;
            }
            child = child.sibling;
          }
          return null;
        }
        function collectNearestScopeMethods(node, scope, childrenScopes) {
          if (isValidScopeNode(node, scope)) {
            childrenScopes.push(node.stateNode.methods);
          } else {
            var child = node.child;
            if (isFiberSuspenseAndTimedOut(node)) {
              child = getSuspenseFallbackChild(node);
            }
            if (child !== null) {
              collectNearestChildScopeMethods(child, scope, childrenScopes);
            }
          }
        }
        function collectNearestChildScopeMethods(startingChild, scope, childrenScopes) {
          var child = startingChild;
          while (child !== null) {
            collectNearestScopeMethods(child, scope, childrenScopes);
            child = child.sibling;
          }
        }
        function isValidScopeNode(node, scope) {
          return node.tag === ScopeComponent && node.type === scope && node.stateNode !== null;
        }
        function createScopeMethods(scope, instance) {
          return {
            getChildren: function() {
              var currentFiber2 = instance.fiber;
              var child = currentFiber2.child;
              var childrenScopes = [];
              if (child !== null) {
                collectNearestChildScopeMethods(child, scope, childrenScopes);
              }
              return childrenScopes.length === 0 ? null : childrenScopes;
            },
            getChildrenFromRoot: function() {
              var currentFiber2 = instance.fiber;
              var node = currentFiber2;
              while (node !== null) {
                var parent = node.return;
                if (parent === null) {
                  break;
                }
                node = parent;
                if (node.tag === ScopeComponent && node.type === scope) {
                  break;
                }
              }
              var childrenScopes = [];
              collectNearestChildScopeMethods(node.child, scope, childrenScopes);
              return childrenScopes.length === 0 ? null : childrenScopes;
            },
            getParent: function() {
              var node = instance.fiber.return;
              while (node !== null) {
                if (node.tag === ScopeComponent && node.type === scope) {
                  return node.stateNode.methods;
                }
                node = node.return;
              }
              return null;
            },
            getProps: function() {
              var currentFiber2 = instance.fiber;
              return currentFiber2.memoizedProps;
            },
            queryAllNodes: function(fn) {
              var currentFiber2 = instance.fiber;
              var child = currentFiber2.child;
              var scopedNodes = [];
              if (child !== null) {
                collectScopedNodesFromChildren(child, fn, scopedNodes);
              }
              return scopedNodes.length === 0 ? null : scopedNodes;
            },
            queryFirstNode: function(fn) {
              var currentFiber2 = instance.fiber;
              var child = currentFiber2.child;
              if (child !== null) {
                return collectFirstScopedNodeFromChildren(child, fn);
              }
              return null;
            },
            containsNode: function(node) {
              var fiber = getInstanceFromNode(node);
              while (fiber !== null) {
                if (fiber.tag === ScopeComponent && fiber.type === scope && fiber.stateNode === instance) {
                  return true;
                }
                fiber = fiber.return;
              }
              return false;
            }
          };
        }
        function markUpdate(workInProgress2) {
          workInProgress2.effectTag |= Update;
        }
        function markRef$1(workInProgress2) {
          workInProgress2.effectTag |= Ref;
        }
        var appendAllChildren;
        var updateHostContainer;
        var updateHostComponent$1;
        var updateHostText$1;
        if (supportsMutation) {
          appendAllChildren = function(parent, workInProgress2, needsVisibilityToggle, isHidden) {
            var node = workInProgress2.child;
            while (node !== null) {
              if (node.tag === HostComponent || node.tag === HostText) {
                appendInitialChild(parent, node.stateNode);
              } else if (enableFundamentalAPI && node.tag === FundamentalComponent) {
                appendInitialChild(parent, node.stateNode.instance);
              } else if (node.tag === HostPortal) {
              } else if (node.child !== null) {
                node.child.return = node;
                node = node.child;
                continue;
              }
              if (node === workInProgress2) {
                return;
              }
              while (node.sibling === null) {
                if (node.return === null || node.return === workInProgress2) {
                  return;
                }
                node = node.return;
              }
              node.sibling.return = node.return;
              node = node.sibling;
            }
          };
          updateHostContainer = function(workInProgress2) {
          };
          updateHostComponent$1 = function(current2, workInProgress2, type3, newProps, rootContainerInstance) {
            var oldProps = current2.memoizedProps;
            if (oldProps === newProps) {
              return;
            }
            var instance = workInProgress2.stateNode;
            var currentHostContext = getHostContext();
            var updatePayload = prepareUpdate(instance, type3, oldProps, newProps, rootContainerInstance, currentHostContext);
            workInProgress2.updateQueue = updatePayload;
            if (updatePayload) {
              markUpdate(workInProgress2);
            }
          };
          updateHostText$1 = function(current2, workInProgress2, oldText, newText) {
            if (oldText !== newText) {
              markUpdate(workInProgress2);
            }
          };
        } else if (supportsPersistence) {
          appendAllChildren = function(parent, workInProgress2, needsVisibilityToggle, isHidden) {
            var node = workInProgress2.child;
            while (node !== null) {
              branches:
                if (node.tag === HostComponent) {
                  var instance = node.stateNode;
                  if (needsVisibilityToggle && isHidden) {
                    var props = node.memoizedProps;
                    var type3 = node.type;
                    instance = cloneHiddenInstance(instance, type3, props, node);
                  }
                  appendInitialChild(parent, instance);
                } else if (node.tag === HostText) {
                  var _instance = node.stateNode;
                  if (needsVisibilityToggle && isHidden) {
                    var text = node.memoizedProps;
                    _instance = cloneHiddenTextInstance(_instance, text, node);
                  }
                  appendInitialChild(parent, _instance);
                } else if (enableFundamentalAPI && node.tag === FundamentalComponent) {
                  var _instance2 = node.stateNode.instance;
                  if (needsVisibilityToggle && isHidden) {
                    var _props = node.memoizedProps;
                    var _type = node.type;
                    _instance2 = cloneHiddenInstance(_instance2, _type, _props, node);
                  }
                  appendInitialChild(parent, _instance2);
                } else if (node.tag === HostPortal) {
                } else if (node.tag === SuspenseComponent) {
                  if ((node.effectTag & Update) !== NoEffect) {
                    var newIsHidden = node.memoizedState !== null;
                    if (newIsHidden) {
                      var primaryChildParent = node.child;
                      if (primaryChildParent !== null) {
                        if (primaryChildParent.child !== null) {
                          primaryChildParent.child.return = primaryChildParent;
                          appendAllChildren(parent, primaryChildParent, true, newIsHidden);
                        }
                        var fallbackChildParent = primaryChildParent.sibling;
                        if (fallbackChildParent !== null) {
                          fallbackChildParent.return = node;
                          node = fallbackChildParent;
                          continue;
                        }
                      }
                    }
                  }
                  if (node.child !== null) {
                    node.child.return = node;
                    node = node.child;
                    continue;
                  }
                } else if (node.child !== null) {
                  node.child.return = node;
                  node = node.child;
                  continue;
                }
              node = node;
              if (node === workInProgress2) {
                return;
              }
              while (node.sibling === null) {
                if (node.return === null || node.return === workInProgress2) {
                  return;
                }
                node = node.return;
              }
              node.sibling.return = node.return;
              node = node.sibling;
            }
          };
          var appendAllChildrenToContainer = function(containerChildSet, workInProgress2, needsVisibilityToggle, isHidden) {
            var node = workInProgress2.child;
            while (node !== null) {
              branches:
                if (node.tag === HostComponent) {
                  var instance = node.stateNode;
                  if (needsVisibilityToggle && isHidden) {
                    var props = node.memoizedProps;
                    var type3 = node.type;
                    instance = cloneHiddenInstance(instance, type3, props, node);
                  }
                  appendChildToContainerChildSet(containerChildSet, instance);
                } else if (node.tag === HostText) {
                  var _instance3 = node.stateNode;
                  if (needsVisibilityToggle && isHidden) {
                    var text = node.memoizedProps;
                    _instance3 = cloneHiddenTextInstance(_instance3, text, node);
                  }
                  appendChildToContainerChildSet(containerChildSet, _instance3);
                } else if (enableFundamentalAPI && node.tag === FundamentalComponent) {
                  var _instance4 = node.stateNode.instance;
                  if (needsVisibilityToggle && isHidden) {
                    var _props2 = node.memoizedProps;
                    var _type2 = node.type;
                    _instance4 = cloneHiddenInstance(_instance4, _type2, _props2, node);
                  }
                  appendChildToContainerChildSet(containerChildSet, _instance4);
                } else if (node.tag === HostPortal) {
                } else if (node.tag === SuspenseComponent) {
                  if ((node.effectTag & Update) !== NoEffect) {
                    var newIsHidden = node.memoizedState !== null;
                    if (newIsHidden) {
                      var primaryChildParent = node.child;
                      if (primaryChildParent !== null) {
                        if (primaryChildParent.child !== null) {
                          primaryChildParent.child.return = primaryChildParent;
                          appendAllChildrenToContainer(containerChildSet, primaryChildParent, true, newIsHidden);
                        }
                        var fallbackChildParent = primaryChildParent.sibling;
                        if (fallbackChildParent !== null) {
                          fallbackChildParent.return = node;
                          node = fallbackChildParent;
                          continue;
                        }
                      }
                    }
                  }
                  if (node.child !== null) {
                    node.child.return = node;
                    node = node.child;
                    continue;
                  }
                } else if (node.child !== null) {
                  node.child.return = node;
                  node = node.child;
                  continue;
                }
              node = node;
              if (node === workInProgress2) {
                return;
              }
              while (node.sibling === null) {
                if (node.return === null || node.return === workInProgress2) {
                  return;
                }
                node = node.return;
              }
              node.sibling.return = node.return;
              node = node.sibling;
            }
          };
          updateHostContainer = function(workInProgress2) {
            var portalOrRoot = workInProgress2.stateNode;
            var childrenUnchanged = workInProgress2.firstEffect === null;
            if (childrenUnchanged) {
            } else {
              var container = portalOrRoot.containerInfo;
              var newChildSet = createContainerChildSet(container);
              appendAllChildrenToContainer(newChildSet, workInProgress2, false, false);
              portalOrRoot.pendingChildren = newChildSet;
              markUpdate(workInProgress2);
              finalizeContainerChildren(container, newChildSet);
            }
          };
          updateHostComponent$1 = function(current2, workInProgress2, type3, newProps, rootContainerInstance) {
            var currentInstance = current2.stateNode;
            var oldProps = current2.memoizedProps;
            var childrenUnchanged = workInProgress2.firstEffect === null;
            if (childrenUnchanged && oldProps === newProps) {
              workInProgress2.stateNode = currentInstance;
              return;
            }
            var recyclableInstance = workInProgress2.stateNode;
            var currentHostContext = getHostContext();
            var updatePayload = null;
            if (oldProps !== newProps) {
              updatePayload = prepareUpdate(recyclableInstance, type3, oldProps, newProps, rootContainerInstance, currentHostContext);
            }
            if (childrenUnchanged && updatePayload === null) {
              workInProgress2.stateNode = currentInstance;
              return;
            }
            var newInstance = cloneInstance(currentInstance, updatePayload, type3, oldProps, newProps, workInProgress2, childrenUnchanged, recyclableInstance);
            if (finalizeInitialChildren(newInstance, type3, newProps, rootContainerInstance, currentHostContext)) {
              markUpdate(workInProgress2);
            }
            workInProgress2.stateNode = newInstance;
            if (childrenUnchanged) {
              markUpdate(workInProgress2);
            } else {
              appendAllChildren(newInstance, workInProgress2, false, false);
            }
          };
          updateHostText$1 = function(current2, workInProgress2, oldText, newText) {
            if (oldText !== newText) {
              var rootContainerInstance = getRootHostContainer();
              var currentHostContext = getHostContext();
              workInProgress2.stateNode = createTextInstance(newText, rootContainerInstance, currentHostContext, workInProgress2);
              markUpdate(workInProgress2);
            }
          };
        } else {
          updateHostContainer = function(workInProgress2) {
          };
          updateHostComponent$1 = function(current2, workInProgress2, type3, newProps, rootContainerInstance) {
          };
          updateHostText$1 = function(current2, workInProgress2, oldText, newText) {
          };
        }
        function cutOffTailIfNeeded(renderState, hasRenderedATailFallback) {
          switch (renderState.tailMode) {
            case "hidden": {
              var tailNode = renderState.tail;
              var lastTailNode = null;
              while (tailNode !== null) {
                if (tailNode.alternate !== null) {
                  lastTailNode = tailNode;
                }
                tailNode = tailNode.sibling;
              }
              if (lastTailNode === null) {
                renderState.tail = null;
              } else {
                lastTailNode.sibling = null;
              }
              break;
            }
            case "collapsed": {
              var _tailNode = renderState.tail;
              var _lastTailNode = null;
              while (_tailNode !== null) {
                if (_tailNode.alternate !== null) {
                  _lastTailNode = _tailNode;
                }
                _tailNode = _tailNode.sibling;
              }
              if (_lastTailNode === null) {
                if (!hasRenderedATailFallback && renderState.tail !== null) {
                  renderState.tail.sibling = null;
                } else {
                  renderState.tail = null;
                }
              } else {
                _lastTailNode.sibling = null;
              }
              break;
            }
          }
        }
        function completeWork(current2, workInProgress2, renderExpirationTime2) {
          var newProps = workInProgress2.pendingProps;
          switch (workInProgress2.tag) {
            case IndeterminateComponent:
              break;
            case LazyComponent:
              break;
            case SimpleMemoComponent:
            case FunctionComponent:
              break;
            case ClassComponent: {
              var Component = workInProgress2.type;
              if (isContextProvider(Component)) {
                popContext(workInProgress2);
              }
              break;
            }
            case HostRoot: {
              popHostContainer(workInProgress2);
              popTopLevelContextObject(workInProgress2);
              var fiberRoot = workInProgress2.stateNode;
              if (fiberRoot.pendingContext) {
                fiberRoot.context = fiberRoot.pendingContext;
                fiberRoot.pendingContext = null;
              }
              if (current2 === null || current2.child === null) {
                var wasHydrated = popHydrationState(workInProgress2);
                if (wasHydrated) {
                  markUpdate(workInProgress2);
                }
              }
              updateHostContainer(workInProgress2);
              break;
            }
            case HostComponent: {
              popHostContext(workInProgress2);
              var rootContainerInstance = getRootHostContainer();
              var type3 = workInProgress2.type;
              if (current2 !== null && workInProgress2.stateNode != null) {
                updateHostComponent$1(current2, workInProgress2, type3, newProps, rootContainerInstance);
                if (enableFlareAPI) {
                  var prevListeners = current2.memoizedProps.listeners;
                  var nextListeners = newProps.listeners;
                  if (prevListeners !== nextListeners) {
                    markUpdate(workInProgress2);
                  }
                }
                if (current2.ref !== workInProgress2.ref) {
                  markRef$1(workInProgress2);
                }
              } else {
                if (!newProps) {
                  if (!(workInProgress2.stateNode !== null)) {
                    {
                      throw Error("We must have new props for new mounts. This error is likely caused by a bug in React. Please file an issue.");
                    }
                  }
                  break;
                }
                var currentHostContext = getHostContext();
                var _wasHydrated = popHydrationState(workInProgress2);
                if (_wasHydrated) {
                  if (prepareToHydrateHostInstance(workInProgress2, rootContainerInstance, currentHostContext)) {
                    markUpdate(workInProgress2);
                  }
                  if (enableFlareAPI) {
                    var listeners = newProps.listeners;
                    if (listeners != null) {
                      updateEventListeners(listeners, workInProgress2, rootContainerInstance);
                    }
                  }
                } else {
                  var instance = createInstance(type3, newProps, rootContainerInstance, currentHostContext, workInProgress2);
                  appendAllChildren(instance, workInProgress2, false, false);
                  workInProgress2.stateNode = instance;
                  if (enableFlareAPI) {
                    var _listeners = newProps.listeners;
                    if (_listeners != null) {
                      updateEventListeners(_listeners, workInProgress2, rootContainerInstance);
                    }
                  }
                  if (finalizeInitialChildren(instance, type3, newProps, rootContainerInstance, currentHostContext)) {
                    markUpdate(workInProgress2);
                  }
                }
                if (workInProgress2.ref !== null) {
                  markRef$1(workInProgress2);
                }
              }
              break;
            }
            case HostText: {
              var newText = newProps;
              if (current2 && workInProgress2.stateNode != null) {
                var oldText = current2.memoizedProps;
                updateHostText$1(current2, workInProgress2, oldText, newText);
              } else {
                if (typeof newText !== "string") {
                  if (!(workInProgress2.stateNode !== null)) {
                    {
                      throw Error("We must have new props for new mounts. This error is likely caused by a bug in React. Please file an issue.");
                    }
                  }
                }
                var _rootContainerInstance = getRootHostContainer();
                var _currentHostContext = getHostContext();
                var _wasHydrated2 = popHydrationState(workInProgress2);
                if (_wasHydrated2) {
                  if (prepareToHydrateHostTextInstance(workInProgress2)) {
                    markUpdate(workInProgress2);
                  }
                } else {
                  workInProgress2.stateNode = createTextInstance(newText, _rootContainerInstance, _currentHostContext, workInProgress2);
                }
              }
              break;
            }
            case ForwardRef:
              break;
            case SuspenseComponent: {
              popSuspenseContext(workInProgress2);
              var nextState = workInProgress2.memoizedState;
              if (enableSuspenseServerRenderer) {
                if (nextState !== null && nextState.dehydrated !== null) {
                  if (current2 === null) {
                    var _wasHydrated3 = popHydrationState(workInProgress2);
                    if (!_wasHydrated3) {
                      {
                        throw Error("A dehydrated suspense component was completed without a hydrated node. This is probably a bug in React.");
                      }
                    }
                    prepareToHydrateHostSuspenseInstance(workInProgress2);
                    if (enableSchedulerTracing) {
                      markSpawnedWork(Never);
                    }
                    return null;
                  } else {
                    resetHydrationState();
                    if ((workInProgress2.effectTag & DidCapture) === NoEffect) {
                      workInProgress2.memoizedState = null;
                    }
                    workInProgress2.effectTag |= Update;
                    return null;
                  }
                }
              }
              if ((workInProgress2.effectTag & DidCapture) !== NoEffect) {
                workInProgress2.expirationTime = renderExpirationTime2;
                return workInProgress2;
              }
              var nextDidTimeout = nextState !== null;
              var prevDidTimeout = false;
              if (current2 === null) {
                if (workInProgress2.memoizedProps.fallback !== void 0) {
                  popHydrationState(workInProgress2);
                }
              } else {
                var prevState = current2.memoizedState;
                prevDidTimeout = prevState !== null;
                if (!nextDidTimeout && prevState !== null) {
                  var currentFallbackChild = current2.child.sibling;
                  if (currentFallbackChild !== null) {
                    var first = workInProgress2.firstEffect;
                    if (first !== null) {
                      workInProgress2.firstEffect = currentFallbackChild;
                      currentFallbackChild.nextEffect = first;
                    } else {
                      workInProgress2.firstEffect = workInProgress2.lastEffect = currentFallbackChild;
                      currentFallbackChild.nextEffect = null;
                    }
                    currentFallbackChild.effectTag = Deletion;
                  }
                }
              }
              if (nextDidTimeout && !prevDidTimeout) {
                if ((workInProgress2.mode & BlockingMode) !== NoMode) {
                  var hasInvisibleChildContext = current2 === null && workInProgress2.memoizedProps.unstable_avoidThisFallback !== true;
                  if (hasInvisibleChildContext || hasSuspenseContext(suspenseStackCursor.current, InvisibleParentSuspenseContext)) {
                    renderDidSuspend();
                  } else {
                    renderDidSuspendDelayIfPossible();
                  }
                }
              }
              if (supportsPersistence) {
                if (nextDidTimeout) {
                  workInProgress2.effectTag |= Update;
                }
              }
              if (supportsMutation) {
                if (nextDidTimeout || prevDidTimeout) {
                  workInProgress2.effectTag |= Update;
                }
              }
              if (enableSuspenseCallback && workInProgress2.updateQueue !== null && workInProgress2.memoizedProps.suspenseCallback != null) {
                workInProgress2.effectTag |= Update;
              }
              break;
            }
            case Fragment:
              break;
            case Mode:
              break;
            case Profiler:
              break;
            case HostPortal:
              popHostContainer(workInProgress2);
              updateHostContainer(workInProgress2);
              break;
            case ContextProvider:
              popProvider(workInProgress2);
              break;
            case ContextConsumer:
              break;
            case MemoComponent:
              break;
            case IncompleteClassComponent: {
              var _Component = workInProgress2.type;
              if (isContextProvider(_Component)) {
                popContext(workInProgress2);
              }
              break;
            }
            case SuspenseListComponent: {
              popSuspenseContext(workInProgress2);
              var renderState = workInProgress2.memoizedState;
              if (renderState === null) {
                break;
              }
              var didSuspendAlready = (workInProgress2.effectTag & DidCapture) !== NoEffect;
              var renderedTail = renderState.rendering;
              if (renderedTail === null) {
                if (!didSuspendAlready) {
                  var cannotBeSuspended = renderHasNotSuspendedYet() && (current2 === null || (current2.effectTag & DidCapture) === NoEffect);
                  if (!cannotBeSuspended) {
                    var row = workInProgress2.child;
                    while (row !== null) {
                      var suspended = findFirstSuspended(row);
                      if (suspended !== null) {
                        didSuspendAlready = true;
                        workInProgress2.effectTag |= DidCapture;
                        cutOffTailIfNeeded(renderState, false);
                        var newThennables = suspended.updateQueue;
                        if (newThennables !== null) {
                          workInProgress2.updateQueue = newThennables;
                          workInProgress2.effectTag |= Update;
                        }
                        if (renderState.lastEffect === null) {
                          workInProgress2.firstEffect = null;
                        }
                        workInProgress2.lastEffect = renderState.lastEffect;
                        resetChildFibers(workInProgress2, renderExpirationTime2);
                        pushSuspenseContext(workInProgress2, setShallowSuspenseContext(suspenseStackCursor.current, ForceSuspenseFallback));
                        return workInProgress2.child;
                      }
                      row = row.sibling;
                    }
                  }
                } else {
                  cutOffTailIfNeeded(renderState, false);
                }
              } else {
                if (!didSuspendAlready) {
                  var _suspended = findFirstSuspended(renderedTail);
                  if (_suspended !== null) {
                    workInProgress2.effectTag |= DidCapture;
                    didSuspendAlready = true;
                    var _newThennables = _suspended.updateQueue;
                    if (_newThennables !== null) {
                      workInProgress2.updateQueue = _newThennables;
                      workInProgress2.effectTag |= Update;
                    }
                    cutOffTailIfNeeded(renderState, true);
                    if (renderState.tail === null && renderState.tailMode === "hidden" && !renderedTail.alternate) {
                      var lastEffect = workInProgress2.lastEffect = renderState.lastEffect;
                      if (lastEffect !== null) {
                        lastEffect.nextEffect = null;
                      }
                      return null;
                    }
                  } else if (now$1() > renderState.tailExpiration && renderExpirationTime2 > Never) {
                    workInProgress2.effectTag |= DidCapture;
                    didSuspendAlready = true;
                    cutOffTailIfNeeded(renderState, false);
                    var nextPriority = renderExpirationTime2 - 1;
                    workInProgress2.expirationTime = workInProgress2.childExpirationTime = nextPriority;
                    if (enableSchedulerTracing) {
                      markSpawnedWork(nextPriority);
                    }
                  }
                }
                if (renderState.isBackwards) {
                  renderedTail.sibling = workInProgress2.child;
                  workInProgress2.child = renderedTail;
                } else {
                  var previousSibling = renderState.last;
                  if (previousSibling !== null) {
                    previousSibling.sibling = renderedTail;
                  } else {
                    workInProgress2.child = renderedTail;
                  }
                  renderState.last = renderedTail;
                }
              }
              if (renderState.tail !== null) {
                if (renderState.tailExpiration === 0) {
                  var TAIL_EXPIRATION_TIMEOUT_MS = 500;
                  renderState.tailExpiration = now$1() + TAIL_EXPIRATION_TIMEOUT_MS;
                }
                var next = renderState.tail;
                renderState.rendering = next;
                renderState.tail = next.sibling;
                renderState.lastEffect = workInProgress2.lastEffect;
                next.sibling = null;
                var suspenseContext = suspenseStackCursor.current;
                if (didSuspendAlready) {
                  suspenseContext = setShallowSuspenseContext(suspenseContext, ForceSuspenseFallback);
                } else {
                  suspenseContext = setDefaultShallowSuspenseContext(suspenseContext);
                }
                pushSuspenseContext(workInProgress2, suspenseContext);
                return next;
              }
              break;
            }
            case FundamentalComponent: {
              if (enableFundamentalAPI) {
                var fundamentalImpl = workInProgress2.type.impl;
                var fundamentalInstance = workInProgress2.stateNode;
                if (fundamentalInstance === null) {
                  var getInitialState = fundamentalImpl.getInitialState;
                  var fundamentalState;
                  if (getInitialState !== void 0) {
                    fundamentalState = getInitialState(newProps);
                  }
                  fundamentalInstance = workInProgress2.stateNode = createFundamentalStateInstance(workInProgress2, newProps, fundamentalImpl, fundamentalState || {});
                  var _instance5 = getFundamentalComponentInstance(fundamentalInstance);
                  fundamentalInstance.instance = _instance5;
                  if (fundamentalImpl.reconcileChildren === false) {
                    return null;
                  }
                  appendAllChildren(_instance5, workInProgress2, false, false);
                  mountFundamentalComponent(fundamentalInstance);
                } else {
                  var prevProps = fundamentalInstance.props;
                  fundamentalInstance.prevProps = prevProps;
                  fundamentalInstance.props = newProps;
                  fundamentalInstance.currentFiber = workInProgress2;
                  if (supportsPersistence) {
                    var _instance6 = cloneFundamentalInstance(fundamentalInstance);
                    fundamentalInstance.instance = _instance6;
                    appendAllChildren(_instance6, workInProgress2, false, false);
                  }
                  var shouldUpdate = shouldUpdateFundamentalComponent(fundamentalInstance);
                  if (shouldUpdate) {
                    markUpdate(workInProgress2);
                  }
                }
              }
              break;
            }
            case ScopeComponent: {
              if (enableScopeAPI) {
                if (current2 === null) {
                  var _type3 = workInProgress2.type;
                  var scopeInstance = {
                    fiber: workInProgress2,
                    methods: null
                  };
                  workInProgress2.stateNode = scopeInstance;
                  scopeInstance.methods = createScopeMethods(_type3, scopeInstance);
                  if (enableFlareAPI) {
                    var _listeners2 = newProps.listeners;
                    if (_listeners2 != null) {
                      var _rootContainerInstance2 = getRootHostContainer();
                      updateEventListeners(_listeners2, workInProgress2, _rootContainerInstance2);
                    }
                  }
                  if (workInProgress2.ref !== null) {
                    markRef$1(workInProgress2);
                    markUpdate(workInProgress2);
                  }
                } else {
                  if (enableFlareAPI) {
                    var _prevListeners = current2.memoizedProps.listeners;
                    var _nextListeners = newProps.listeners;
                    if (_prevListeners !== _nextListeners || workInProgress2.ref !== null) {
                      markUpdate(workInProgress2);
                    }
                  } else {
                    if (workInProgress2.ref !== null) {
                      markUpdate(workInProgress2);
                    }
                  }
                  if (current2.ref !== workInProgress2.ref) {
                    markRef$1(workInProgress2);
                  }
                }
              }
              break;
            }
            default: {
              {
                throw Error("Unknown unit of work tag (" + workInProgress2.tag + "). This error is likely caused by a bug in React. Please file an issue.");
              }
            }
          }
          return null;
        }
        function unwindWork(workInProgress2, renderExpirationTime2) {
          switch (workInProgress2.tag) {
            case ClassComponent: {
              var Component = workInProgress2.type;
              if (isContextProvider(Component)) {
                popContext(workInProgress2);
              }
              var effectTag = workInProgress2.effectTag;
              if (effectTag & ShouldCapture) {
                workInProgress2.effectTag = effectTag & ~ShouldCapture | DidCapture;
                return workInProgress2;
              }
              return null;
            }
            case HostRoot: {
              popHostContainer(workInProgress2);
              popTopLevelContextObject(workInProgress2);
              var _effectTag = workInProgress2.effectTag;
              if (!((_effectTag & DidCapture) === NoEffect)) {
                {
                  throw Error("The root failed to unmount after an error. This is likely a bug in React. Please file an issue.");
                }
              }
              workInProgress2.effectTag = _effectTag & ~ShouldCapture | DidCapture;
              return workInProgress2;
            }
            case HostComponent: {
              popHostContext(workInProgress2);
              return null;
            }
            case SuspenseComponent: {
              popSuspenseContext(workInProgress2);
              if (enableSuspenseServerRenderer) {
                var suspenseState = workInProgress2.memoizedState;
                if (suspenseState !== null && suspenseState.dehydrated !== null) {
                  if (!(workInProgress2.alternate !== null)) {
                    {
                      throw Error("Threw in newly mounted dehydrated component. This is likely a bug in React. Please file an issue.");
                    }
                  }
                  resetHydrationState();
                }
              }
              var _effectTag2 = workInProgress2.effectTag;
              if (_effectTag2 & ShouldCapture) {
                workInProgress2.effectTag = _effectTag2 & ~ShouldCapture | DidCapture;
                return workInProgress2;
              }
              return null;
            }
            case SuspenseListComponent: {
              popSuspenseContext(workInProgress2);
              return null;
            }
            case HostPortal:
              popHostContainer(workInProgress2);
              return null;
            case ContextProvider:
              popProvider(workInProgress2);
              return null;
            default:
              return null;
          }
        }
        function unwindInterruptedWork(interruptedWork) {
          switch (interruptedWork.tag) {
            case ClassComponent: {
              var childContextTypes = interruptedWork.type.childContextTypes;
              if (childContextTypes !== null && childContextTypes !== void 0) {
                popContext(interruptedWork);
              }
              break;
            }
            case HostRoot: {
              popHostContainer(interruptedWork);
              popTopLevelContextObject(interruptedWork);
              break;
            }
            case HostComponent: {
              popHostContext(interruptedWork);
              break;
            }
            case HostPortal:
              popHostContainer(interruptedWork);
              break;
            case SuspenseComponent:
              popSuspenseContext(interruptedWork);
              break;
            case SuspenseListComponent:
              popSuspenseContext(interruptedWork);
              break;
            case ContextProvider:
              popProvider(interruptedWork);
              break;
            default:
              break;
          }
        }
        function createCapturedValue(value, source) {
          return {
            value,
            source,
            stack: getStackByFiberInDevAndProd(source)
          };
        }
        var invokeGuardedCallbackImpl = function(name, func2, context, a2, b2, c2, d, e2, f) {
          var funcArgs = Array.prototype.slice.call(arguments, 3);
          try {
            func2.apply(context, funcArgs);
          } catch (error) {
            this.onError(error);
          }
        };
        {
          if (typeof window !== "undefined" && typeof window.dispatchEvent === "function" && typeof document !== "undefined" && typeof document.createEvent === "function") {
            var fakeNode = document.createElement("react");
            var invokeGuardedCallbackDev = function(name, func2, context, a2, b2, c2, d, e2, f) {
              if (!(typeof document !== "undefined")) {
                {
                  throw Error("The `document` global was defined when React was initialized, but is not defined anymore. This can happen in a test environment if a component schedules an update from an asynchronous callback, but the test has already finished running. To solve this, you can either unmount the component at the end of your test (and ensure that any asynchronous operations get canceled in `componentWillUnmount`), or you can change the test itself to be asynchronous.");
                }
              }
              var evt = document.createEvent("Event");
              var didError = true;
              var windowEvent = window.event;
              var windowEventDescriptor = Object.getOwnPropertyDescriptor(window, "event");
              var funcArgs = Array.prototype.slice.call(arguments, 3);
              function callCallback2() {
                fakeNode.removeEventListener(evtType, callCallback2, false);
                if (typeof window.event !== "undefined" && window.hasOwnProperty("event")) {
                  window.event = windowEvent;
                }
                func2.apply(context, funcArgs);
                didError = false;
              }
              var error;
              var didSetError = false;
              var isCrossOriginError = false;
              function handleWindowError(event2) {
                error = event2.error;
                didSetError = true;
                if (error === null && event2.colno === 0 && event2.lineno === 0) {
                  isCrossOriginError = true;
                }
                if (event2.defaultPrevented) {
                  if (error != null && typeof error === "object") {
                    try {
                      error._suppressLogging = true;
                    } catch (inner) {
                    }
                  }
                }
              }
              var evtType = "react-" + (name ? name : "invokeguardedcallback");
              window.addEventListener("error", handleWindowError);
              fakeNode.addEventListener(evtType, callCallback2, false);
              evt.initEvent(evtType, false, false);
              fakeNode.dispatchEvent(evt);
              if (windowEventDescriptor) {
                Object.defineProperty(window, "event", windowEventDescriptor);
              }
              if (didError) {
                if (!didSetError) {
                  error = new Error(`An error was thrown inside one of your components, but React doesn't know what it was. This is likely due to browser flakiness. React does its best to preserve the "Pause on exceptions" behavior of the DevTools, which requires some DEV-mode only tricks. It's possible that these don't work in your browser. Try triggering the error in production mode, or switching to a modern browser. If you suspect that this is actually an issue with React, please file an issue.`);
                } else if (isCrossOriginError) {
                  error = new Error("A cross-origin error was thrown. React doesn't have access to the actual error object in development. See https://fb.me/react-crossorigin-error for more information.");
                }
                this.onError(error);
              }
              window.removeEventListener("error", handleWindowError);
            };
            invokeGuardedCallbackImpl = invokeGuardedCallbackDev;
          }
        }
        var invokeGuardedCallbackImpl$1 = invokeGuardedCallbackImpl;
        var hasError = false;
        var caughtError = null;
        var reporter = {
          onError: function(error) {
            hasError = true;
            caughtError = error;
          }
        };
        function invokeGuardedCallback(name, func2, context, a2, b2, c2, d, e2, f) {
          hasError = false;
          caughtError = null;
          invokeGuardedCallbackImpl$1.apply(reporter, arguments);
        }
        function hasCaughtError() {
          return hasError;
        }
        function clearCaughtError() {
          if (hasError) {
            var error = caughtError;
            hasError = false;
            caughtError = null;
            return error;
          } else {
            {
              {
                throw Error("clearCaughtError was called but no error was captured. This error is likely caused by a bug in React. Please file an issue.");
              }
            }
          }
        }
        function showErrorDialog(capturedError) {
          return true;
        }
        function logCapturedError(capturedError) {
          var logError2 = showErrorDialog(capturedError);
          if (logError2 === false) {
            return;
          }
          var error = capturedError.error;
          {
            var componentName = capturedError.componentName, componentStack = capturedError.componentStack, errorBoundaryName = capturedError.errorBoundaryName, errorBoundaryFound = capturedError.errorBoundaryFound, willRetry = capturedError.willRetry;
            if (error != null && error._suppressLogging) {
              if (errorBoundaryFound && willRetry) {
                return;
              }
              console.error(error);
            }
            var componentNameMessage = componentName ? "The above error occurred in the <" + componentName + "> component:" : "The above error occurred in one of your React components:";
            var errorBoundaryMessage;
            if (errorBoundaryFound && errorBoundaryName) {
              if (willRetry) {
                errorBoundaryMessage = "React will try to recreate this component tree from scratch " + ("using the error boundary you provided, " + errorBoundaryName + ".");
              } else {
                errorBoundaryMessage = "This error was initially handled by the error boundary " + errorBoundaryName + ".\nRecreating the tree from scratch failed so React will unmount the tree.";
              }
            } else {
              errorBoundaryMessage = "Consider adding an error boundary to your tree to customize error handling behavior.\nVisit https://fb.me/react-error-boundaries to learn more about error boundaries.";
            }
            var combinedMessage = "" + componentNameMessage + componentStack + "\n\n" + ("" + errorBoundaryMessage);
            console.error(combinedMessage);
          }
        }
        var didWarnAboutUndefinedSnapshotBeforeUpdate = null;
        {
          didWarnAboutUndefinedSnapshotBeforeUpdate = /* @__PURE__ */ new Set();
        }
        var PossiblyWeakSet = typeof WeakSet === "function" ? WeakSet : Set;
        function logError(boundary, errorInfo) {
          var source = errorInfo.source;
          var stack = errorInfo.stack;
          if (stack === null && source !== null) {
            stack = getStackByFiberInDevAndProd(source);
          }
          var capturedError = {
            componentName: source !== null ? getComponentName(source.type) : null,
            componentStack: stack !== null ? stack : "",
            error: errorInfo.value,
            errorBoundary: null,
            errorBoundaryName: null,
            errorBoundaryFound: false,
            willRetry: false
          };
          if (boundary !== null && boundary.tag === ClassComponent) {
            capturedError.errorBoundary = boundary.stateNode;
            capturedError.errorBoundaryName = getComponentName(boundary.type);
            capturedError.errorBoundaryFound = true;
            capturedError.willRetry = true;
          }
          try {
            logCapturedError(capturedError);
          } catch (e2) {
            setTimeout(function() {
              throw e2;
            });
          }
        }
        var callComponentWillUnmountWithTimer = function(current$$1, instance) {
          startPhaseTimer(current$$1, "componentWillUnmount");
          instance.props = current$$1.memoizedProps;
          instance.state = current$$1.memoizedState;
          instance.componentWillUnmount();
          stopPhaseTimer();
        };
        function safelyCallComponentWillUnmount(current$$1, instance) {
          {
            invokeGuardedCallback(null, callComponentWillUnmountWithTimer, null, current$$1, instance);
            if (hasCaughtError()) {
              var unmountError = clearCaughtError();
              captureCommitPhaseError(current$$1, unmountError);
            }
          }
        }
        function safelyDetachRef(current$$1) {
          var ref2 = current$$1.ref;
          if (ref2 !== null) {
            if (typeof ref2 === "function") {
              {
                invokeGuardedCallback(null, ref2, null, null);
                if (hasCaughtError()) {
                  var refError = clearCaughtError();
                  captureCommitPhaseError(current$$1, refError);
                }
              }
            } else {
              ref2.current = null;
            }
          }
        }
        function safelyCallDestroy(current$$1, destroy) {
          {
            invokeGuardedCallback(null, destroy, null);
            if (hasCaughtError()) {
              var error = clearCaughtError();
              captureCommitPhaseError(current$$1, error);
            }
          }
        }
        function commitBeforeMutationLifeCycles(current$$1, finishedWork) {
          switch (finishedWork.tag) {
            case FunctionComponent:
            case ForwardRef:
            case SimpleMemoComponent: {
              commitHookEffectList(UnmountSnapshot, NoEffect$1, finishedWork);
              return;
            }
            case ClassComponent: {
              if (finishedWork.effectTag & Snapshot) {
                if (current$$1 !== null) {
                  var prevProps = current$$1.memoizedProps;
                  var prevState = current$$1.memoizedState;
                  startPhaseTimer(finishedWork, "getSnapshotBeforeUpdate");
                  var instance = finishedWork.stateNode;
                  {
                    if (finishedWork.type === finishedWork.elementType && !didWarnAboutReassigningProps) {
                      !(instance.props === finishedWork.memoizedProps) ? warning$1(false, "Expected %s props to match memoized props before getSnapshotBeforeUpdate. This might either be because of a bug in React, or because a component reassigns its own `this.props`. Please file an issue.", getComponentName(finishedWork.type) || "instance") : void 0;
                      !(instance.state === finishedWork.memoizedState) ? warning$1(false, "Expected %s state to match memoized state before getSnapshotBeforeUpdate. This might either be because of a bug in React, or because a component reassigns its own `this.props`. Please file an issue.", getComponentName(finishedWork.type) || "instance") : void 0;
                    }
                  }
                  var snapshot2 = instance.getSnapshotBeforeUpdate(finishedWork.elementType === finishedWork.type ? prevProps : resolveDefaultProps(finishedWork.type, prevProps), prevState);
                  {
                    var didWarnSet = didWarnAboutUndefinedSnapshotBeforeUpdate;
                    if (snapshot2 === void 0 && !didWarnSet.has(finishedWork.type)) {
                      didWarnSet.add(finishedWork.type);
                      warningWithoutStack$1(false, "%s.getSnapshotBeforeUpdate(): A snapshot value (or null) must be returned. You have returned undefined.", getComponentName(finishedWork.type));
                    }
                  }
                  instance.__reactInternalSnapshotBeforeUpdate = snapshot2;
                  stopPhaseTimer();
                }
              }
              return;
            }
            case HostRoot:
            case HostComponent:
            case HostText:
            case HostPortal:
            case IncompleteClassComponent:
              return;
            default: {
              {
                {
                  throw Error("This unit of work tag should not have side-effects. This error is likely caused by a bug in React. Please file an issue.");
                }
              }
            }
          }
        }
        function commitHookEffectList(unmountTag, mountTag, finishedWork) {
          var updateQueue = finishedWork.updateQueue;
          var lastEffect = updateQueue !== null ? updateQueue.lastEffect : null;
          if (lastEffect !== null) {
            var firstEffect = lastEffect.next;
            var effect = firstEffect;
            do {
              if ((effect.tag & unmountTag) !== NoEffect$1) {
                var destroy = effect.destroy;
                effect.destroy = void 0;
                if (destroy !== void 0) {
                  destroy();
                }
              }
              if ((effect.tag & mountTag) !== NoEffect$1) {
                var create = effect.create;
                effect.destroy = create();
                {
                  var _destroy = effect.destroy;
                  if (_destroy !== void 0 && typeof _destroy !== "function") {
                    var addendum = void 0;
                    if (_destroy === null) {
                      addendum = " You returned null. If your effect does not require clean up, return undefined (or nothing).";
                    } else if (typeof _destroy.then === "function") {
                      addendum = "\n\nIt looks like you wrote useEffect(async () => ...) or returned a Promise. Instead, write the async function inside your effect and call it immediately:\n\nuseEffect(() => {\n  async function fetchData() {\n    // You can await here\n    const response = await MyAPI.getData(someId);\n    // ...\n  }\n  fetchData();\n}, [someId]); // Or [] if effect doesn't need props or state\n\nLearn more about data fetching with Hooks: https://fb.me/react-hooks-data-fetching";
                    } else {
                      addendum = " You returned: " + _destroy;
                    }
                    warningWithoutStack$1(false, "An effect function must not return anything besides a function, which is used for clean-up.%s%s", addendum, getStackByFiberInDevAndProd(finishedWork));
                  }
                }
              }
              effect = effect.next;
            } while (effect !== firstEffect);
          }
        }
        function commitPassiveHookEffects(finishedWork) {
          if ((finishedWork.effectTag & Passive) !== NoEffect) {
            switch (finishedWork.tag) {
              case FunctionComponent:
              case ForwardRef:
              case SimpleMemoComponent: {
                commitHookEffectList(UnmountPassive, NoEffect$1, finishedWork);
                commitHookEffectList(NoEffect$1, MountPassive, finishedWork);
                break;
              }
              default:
                break;
            }
          }
        }
        function commitLifeCycles(finishedRoot, current$$1, finishedWork, committedExpirationTime) {
          switch (finishedWork.tag) {
            case FunctionComponent:
            case ForwardRef:
            case SimpleMemoComponent: {
              commitHookEffectList(UnmountLayout, MountLayout, finishedWork);
              break;
            }
            case ClassComponent: {
              var instance = finishedWork.stateNode;
              if (finishedWork.effectTag & Update) {
                if (current$$1 === null) {
                  startPhaseTimer(finishedWork, "componentDidMount");
                  {
                    if (finishedWork.type === finishedWork.elementType && !didWarnAboutReassigningProps) {
                      !(instance.props === finishedWork.memoizedProps) ? warning$1(false, "Expected %s props to match memoized props before componentDidMount. This might either be because of a bug in React, or because a component reassigns its own `this.props`. Please file an issue.", getComponentName(finishedWork.type) || "instance") : void 0;
                      !(instance.state === finishedWork.memoizedState) ? warning$1(false, "Expected %s state to match memoized state before componentDidMount. This might either be because of a bug in React, or because a component reassigns its own `this.props`. Please file an issue.", getComponentName(finishedWork.type) || "instance") : void 0;
                    }
                  }
                  instance.componentDidMount();
                  stopPhaseTimer();
                } else {
                  var prevProps = finishedWork.elementType === finishedWork.type ? current$$1.memoizedProps : resolveDefaultProps(finishedWork.type, current$$1.memoizedProps);
                  var prevState = current$$1.memoizedState;
                  startPhaseTimer(finishedWork, "componentDidUpdate");
                  {
                    if (finishedWork.type === finishedWork.elementType && !didWarnAboutReassigningProps) {
                      !(instance.props === finishedWork.memoizedProps) ? warning$1(false, "Expected %s props to match memoized props before componentDidUpdate. This might either be because of a bug in React, or because a component reassigns its own `this.props`. Please file an issue.", getComponentName(finishedWork.type) || "instance") : void 0;
                      !(instance.state === finishedWork.memoizedState) ? warning$1(false, "Expected %s state to match memoized state before componentDidUpdate. This might either be because of a bug in React, or because a component reassigns its own `this.props`. Please file an issue.", getComponentName(finishedWork.type) || "instance") : void 0;
                    }
                  }
                  instance.componentDidUpdate(prevProps, prevState, instance.__reactInternalSnapshotBeforeUpdate);
                  stopPhaseTimer();
                }
              }
              var updateQueue = finishedWork.updateQueue;
              if (updateQueue !== null) {
                {
                  if (finishedWork.type === finishedWork.elementType && !didWarnAboutReassigningProps) {
                    !(instance.props === finishedWork.memoizedProps) ? warning$1(false, "Expected %s props to match memoized props before processing the update queue. This might either be because of a bug in React, or because a component reassigns its own `this.props`. Please file an issue.", getComponentName(finishedWork.type) || "instance") : void 0;
                    !(instance.state === finishedWork.memoizedState) ? warning$1(false, "Expected %s state to match memoized state before processing the update queue. This might either be because of a bug in React, or because a component reassigns its own `this.props`. Please file an issue.", getComponentName(finishedWork.type) || "instance") : void 0;
                  }
                }
                commitUpdateQueue(finishedWork, updateQueue, instance, committedExpirationTime);
              }
              return;
            }
            case HostRoot: {
              var _updateQueue = finishedWork.updateQueue;
              if (_updateQueue !== null) {
                var _instance = null;
                if (finishedWork.child !== null) {
                  switch (finishedWork.child.tag) {
                    case HostComponent:
                      _instance = getPublicInstance(finishedWork.child.stateNode);
                      break;
                    case ClassComponent:
                      _instance = finishedWork.child.stateNode;
                      break;
                  }
                }
                commitUpdateQueue(finishedWork, _updateQueue, _instance, committedExpirationTime);
              }
              return;
            }
            case HostComponent: {
              var _instance2 = finishedWork.stateNode;
              if (current$$1 === null && finishedWork.effectTag & Update) {
                var type3 = finishedWork.type;
                var props = finishedWork.memoizedProps;
                commitMount(_instance2, type3, props, finishedWork);
              }
              return;
            }
            case HostText: {
              return;
            }
            case HostPortal: {
              return;
            }
            case Profiler: {
              if (enableProfilerTimer) {
                var onRender = finishedWork.memoizedProps.onRender;
                if (typeof onRender === "function") {
                  if (enableSchedulerTracing) {
                    onRender(finishedWork.memoizedProps.id, current$$1 === null ? "mount" : "update", finishedWork.actualDuration, finishedWork.treeBaseDuration, finishedWork.actualStartTime, getCommitTime(), finishedRoot.memoizedInteractions);
                  } else {
                    onRender(finishedWork.memoizedProps.id, current$$1 === null ? "mount" : "update", finishedWork.actualDuration, finishedWork.treeBaseDuration, finishedWork.actualStartTime, getCommitTime());
                  }
                }
              }
              return;
            }
            case SuspenseComponent: {
              commitSuspenseHydrationCallbacks(finishedRoot, finishedWork);
              return;
            }
            case SuspenseListComponent:
            case IncompleteClassComponent:
            case FundamentalComponent:
            case ScopeComponent:
              return;
            default: {
              {
                {
                  throw Error("This unit of work tag should not have side-effects. This error is likely caused by a bug in React. Please file an issue.");
                }
              }
            }
          }
        }
        function hideOrUnhideAllChildren(finishedWork, isHidden) {
          if (supportsMutation) {
            var node = finishedWork;
            while (true) {
              if (node.tag === HostComponent) {
                var instance = node.stateNode;
                if (isHidden) {
                  hideInstance(instance);
                } else {
                  unhideInstance(node.stateNode, node.memoizedProps);
                }
              } else if (node.tag === HostText) {
                var _instance3 = node.stateNode;
                if (isHidden) {
                  hideTextInstance(_instance3);
                } else {
                  unhideTextInstance(_instance3, node.memoizedProps);
                }
              } else if (node.tag === SuspenseComponent && node.memoizedState !== null && node.memoizedState.dehydrated === null) {
                var fallbackChildFragment = node.child.sibling;
                fallbackChildFragment.return = node;
                node = fallbackChildFragment;
                continue;
              } else if (node.child !== null) {
                node.child.return = node;
                node = node.child;
                continue;
              }
              if (node === finishedWork) {
                return;
              }
              while (node.sibling === null) {
                if (node.return === null || node.return === finishedWork) {
                  return;
                }
                node = node.return;
              }
              node.sibling.return = node.return;
              node = node.sibling;
            }
          }
        }
        function commitAttachRef(finishedWork) {
          var ref2 = finishedWork.ref;
          if (ref2 !== null) {
            var instance = finishedWork.stateNode;
            var instanceToUse;
            switch (finishedWork.tag) {
              case HostComponent:
                instanceToUse = getPublicInstance(instance);
                break;
              default:
                instanceToUse = instance;
            }
            if (enableScopeAPI && finishedWork.tag === ScopeComponent) {
              instanceToUse = instance.methods;
            }
            if (typeof ref2 === "function") {
              ref2(instanceToUse);
            } else {
              {
                if (!ref2.hasOwnProperty("current")) {
                  warningWithoutStack$1(false, "Unexpected ref object provided for %s. Use either a ref-setter function or React.createRef().%s", getComponentName(finishedWork.type), getStackByFiberInDevAndProd(finishedWork));
                }
              }
              ref2.current = instanceToUse;
            }
          }
        }
        function commitDetachRef(current$$1) {
          var currentRef = current$$1.ref;
          if (currentRef !== null) {
            if (typeof currentRef === "function") {
              currentRef(null);
            } else {
              currentRef.current = null;
            }
          }
        }
        function commitUnmount(finishedRoot, current$$1, renderPriorityLevel) {
          onCommitUnmount(current$$1);
          switch (current$$1.tag) {
            case FunctionComponent:
            case ForwardRef:
            case MemoComponent:
            case SimpleMemoComponent: {
              var updateQueue = current$$1.updateQueue;
              if (updateQueue !== null) {
                var lastEffect = updateQueue.lastEffect;
                if (lastEffect !== null) {
                  var firstEffect = lastEffect.next;
                  var priorityLevel = renderPriorityLevel > NormalPriority ? NormalPriority : renderPriorityLevel;
                  runWithPriority(priorityLevel, function() {
                    var effect = firstEffect;
                    do {
                      var destroy = effect.destroy;
                      if (destroy !== void 0) {
                        safelyCallDestroy(current$$1, destroy);
                      }
                      effect = effect.next;
                    } while (effect !== firstEffect);
                  });
                }
              }
              break;
            }
            case ClassComponent: {
              safelyDetachRef(current$$1);
              var instance = current$$1.stateNode;
              if (typeof instance.componentWillUnmount === "function") {
                safelyCallComponentWillUnmount(current$$1, instance);
              }
              return;
            }
            case HostComponent: {
              if (enableFlareAPI) {
                var dependencies = current$$1.dependencies;
                if (dependencies !== null) {
                  var respondersMap = dependencies.responders;
                  if (respondersMap !== null) {
                    var responderInstances = Array.from(respondersMap.values());
                    for (var i3 = 0, length = responderInstances.length; i3 < length; i3++) {
                      var responderInstance = responderInstances[i3];
                      unmountResponderInstance(responderInstance);
                    }
                    dependencies.responders = null;
                  }
                }
              }
              safelyDetachRef(current$$1);
              return;
            }
            case HostPortal: {
              if (supportsMutation) {
                unmountHostComponents(finishedRoot, current$$1, renderPriorityLevel);
              } else if (supportsPersistence) {
                emptyPortalContainer(current$$1);
              }
              return;
            }
            case FundamentalComponent: {
              if (enableFundamentalAPI) {
                var fundamentalInstance = current$$1.stateNode;
                if (fundamentalInstance !== null) {
                  unmountFundamentalComponent(fundamentalInstance);
                  current$$1.stateNode = null;
                }
              }
              return;
            }
            case DehydratedFragment: {
              if (enableSuspenseCallback) {
                var hydrationCallbacks = finishedRoot.hydrationCallbacks;
                if (hydrationCallbacks !== null) {
                  var onDeleted = hydrationCallbacks.onDeleted;
                  if (onDeleted) {
                    onDeleted(current$$1.stateNode);
                  }
                }
              }
              return;
            }
            case ScopeComponent: {
              if (enableScopeAPI) {
                safelyDetachRef(current$$1);
              }
            }
          }
        }
        function commitNestedUnmounts(finishedRoot, root, renderPriorityLevel) {
          var node = root;
          while (true) {
            commitUnmount(finishedRoot, node, renderPriorityLevel);
            if (node.child !== null && (!supportsMutation || node.tag !== HostPortal)) {
              node.child.return = node;
              node = node.child;
              continue;
            }
            if (node === root) {
              return;
            }
            while (node.sibling === null) {
              if (node.return === null || node.return === root) {
                return;
              }
              node = node.return;
            }
            node.sibling.return = node.return;
            node = node.sibling;
          }
        }
        function detachFiber(current$$1) {
          var alternate = current$$1.alternate;
          current$$1.return = null;
          current$$1.child = null;
          current$$1.memoizedState = null;
          current$$1.updateQueue = null;
          current$$1.dependencies = null;
          current$$1.alternate = null;
          current$$1.firstEffect = null;
          current$$1.lastEffect = null;
          current$$1.pendingProps = null;
          current$$1.memoizedProps = null;
          if (alternate !== null) {
            detachFiber(alternate);
          }
        }
        function emptyPortalContainer(current$$1) {
          if (!supportsPersistence) {
            return;
          }
          var portal = current$$1.stateNode;
          var containerInfo = portal.containerInfo;
          var emptyChildSet = createContainerChildSet(containerInfo);
          replaceContainerChildren(containerInfo, emptyChildSet);
        }
        function commitContainer(finishedWork) {
          if (!supportsPersistence) {
            return;
          }
          switch (finishedWork.tag) {
            case ClassComponent:
            case HostComponent:
            case HostText:
            case FundamentalComponent: {
              return;
            }
            case HostRoot:
            case HostPortal: {
              var portalOrRoot = finishedWork.stateNode;
              var containerInfo = portalOrRoot.containerInfo, pendingChildren = portalOrRoot.pendingChildren;
              replaceContainerChildren(containerInfo, pendingChildren);
              return;
            }
            default: {
              {
                {
                  throw Error("This unit of work tag should not have side-effects. This error is likely caused by a bug in React. Please file an issue.");
                }
              }
            }
          }
        }
        function getHostParentFiber(fiber) {
          var parent = fiber.return;
          while (parent !== null) {
            if (isHostParent(parent)) {
              return parent;
            }
            parent = parent.return;
          }
          {
            {
              throw Error("Expected to find a host parent. This error is likely caused by a bug in React. Please file an issue.");
            }
          }
        }
        function isHostParent(fiber) {
          return fiber.tag === HostComponent || fiber.tag === HostRoot || fiber.tag === HostPortal;
        }
        function getHostSibling(fiber) {
          var node = fiber;
          siblings:
            while (true) {
              while (node.sibling === null) {
                if (node.return === null || isHostParent(node.return)) {
                  return null;
                }
                node = node.return;
              }
              node.sibling.return = node.return;
              node = node.sibling;
              while (node.tag !== HostComponent && node.tag !== HostText && node.tag !== DehydratedFragment) {
                if (node.effectTag & Placement) {
                  continue siblings;
                }
                if (node.child === null || node.tag === HostPortal) {
                  continue siblings;
                } else {
                  node.child.return = node;
                  node = node.child;
                }
              }
              if (!(node.effectTag & Placement)) {
                return node.stateNode;
              }
            }
        }
        function commitPlacement(finishedWork) {
          if (!supportsMutation) {
            return;
          }
          var parentFiber = getHostParentFiber(finishedWork);
          var parent;
          var isContainer;
          var parentStateNode = parentFiber.stateNode;
          switch (parentFiber.tag) {
            case HostComponent:
              parent = parentStateNode;
              isContainer = false;
              break;
            case HostRoot:
              parent = parentStateNode.containerInfo;
              isContainer = true;
              break;
            case HostPortal:
              parent = parentStateNode.containerInfo;
              isContainer = true;
              break;
            case FundamentalComponent:
              if (enableFundamentalAPI) {
                parent = parentStateNode.instance;
                isContainer = false;
              }
            default: {
              {
                throw Error("Invalid host parent fiber. This error is likely caused by a bug in React. Please file an issue.");
              }
            }
          }
          if (parentFiber.effectTag & ContentReset) {
            resetTextContent(parent);
            parentFiber.effectTag &= ~ContentReset;
          }
          var before = getHostSibling(finishedWork);
          var node = finishedWork;
          while (true) {
            var isHost = node.tag === HostComponent || node.tag === HostText;
            if (isHost || enableFundamentalAPI && node.tag === FundamentalComponent) {
              var stateNode = isHost ? node.stateNode : node.stateNode.instance;
              if (before) {
                if (isContainer) {
                  insertInContainerBefore(parent, stateNode, before);
                } else {
                  insertBefore(parent, stateNode, before);
                }
              } else {
                if (isContainer) {
                  appendChildToContainer(parent, stateNode);
                } else {
                  appendChild(parent, stateNode);
                }
              }
            } else if (node.tag === HostPortal) {
            } else if (node.child !== null) {
              node.child.return = node;
              node = node.child;
              continue;
            }
            if (node === finishedWork) {
              return;
            }
            while (node.sibling === null) {
              if (node.return === null || node.return === finishedWork) {
                return;
              }
              node = node.return;
            }
            node.sibling.return = node.return;
            node = node.sibling;
          }
        }
        function unmountHostComponents(finishedRoot, current$$1, renderPriorityLevel) {
          var node = current$$1;
          var currentParentIsValid = false;
          var currentParent;
          var currentParentIsContainer;
          while (true) {
            if (!currentParentIsValid) {
              var parent = node.return;
              findParent:
                while (true) {
                  if (!(parent !== null)) {
                    {
                      throw Error("Expected to find a host parent. This error is likely caused by a bug in React. Please file an issue.");
                    }
                  }
                  var parentStateNode = parent.stateNode;
                  switch (parent.tag) {
                    case HostComponent:
                      currentParent = parentStateNode;
                      currentParentIsContainer = false;
                      break findParent;
                    case HostRoot:
                      currentParent = parentStateNode.containerInfo;
                      currentParentIsContainer = true;
                      break findParent;
                    case HostPortal:
                      currentParent = parentStateNode.containerInfo;
                      currentParentIsContainer = true;
                      break findParent;
                    case FundamentalComponent:
                      if (enableFundamentalAPI) {
                        currentParent = parentStateNode.instance;
                        currentParentIsContainer = false;
                      }
                  }
                  parent = parent.return;
                }
              currentParentIsValid = true;
            }
            if (node.tag === HostComponent || node.tag === HostText) {
              commitNestedUnmounts(finishedRoot, node, renderPriorityLevel);
              if (currentParentIsContainer) {
                removeChildFromContainer(currentParent, node.stateNode);
              } else {
                removeChild(currentParent, node.stateNode);
              }
            } else if (enableFundamentalAPI && node.tag === FundamentalComponent) {
              var fundamentalNode = node.stateNode.instance;
              commitNestedUnmounts(finishedRoot, node, renderPriorityLevel);
              if (currentParentIsContainer) {
                removeChildFromContainer(currentParent, fundamentalNode);
              } else {
                removeChild(currentParent, fundamentalNode);
              }
            } else if (enableSuspenseServerRenderer && node.tag === DehydratedFragment) {
              if (enableSuspenseCallback) {
                var hydrationCallbacks = finishedRoot.hydrationCallbacks;
                if (hydrationCallbacks !== null) {
                  var onDeleted = hydrationCallbacks.onDeleted;
                  if (onDeleted) {
                    onDeleted(node.stateNode);
                  }
                }
              }
              if (currentParentIsContainer) {
                clearSuspenseBoundaryFromContainer(currentParent, node.stateNode);
              } else {
                clearSuspenseBoundary(currentParent, node.stateNode);
              }
            } else if (node.tag === HostPortal) {
              if (node.child !== null) {
                currentParent = node.stateNode.containerInfo;
                currentParentIsContainer = true;
                node.child.return = node;
                node = node.child;
                continue;
              }
            } else {
              commitUnmount(finishedRoot, node, renderPriorityLevel);
              if (node.child !== null) {
                node.child.return = node;
                node = node.child;
                continue;
              }
            }
            if (node === current$$1) {
              return;
            }
            while (node.sibling === null) {
              if (node.return === null || node.return === current$$1) {
                return;
              }
              node = node.return;
              if (node.tag === HostPortal) {
                currentParentIsValid = false;
              }
            }
            node.sibling.return = node.return;
            node = node.sibling;
          }
        }
        function commitDeletion(finishedRoot, current$$1, renderPriorityLevel) {
          if (supportsMutation) {
            unmountHostComponents(finishedRoot, current$$1, renderPriorityLevel);
          } else {
            commitNestedUnmounts(finishedRoot, current$$1, renderPriorityLevel);
          }
          detachFiber(current$$1);
        }
        function commitWork(current$$1, finishedWork) {
          if (!supportsMutation) {
            switch (finishedWork.tag) {
              case FunctionComponent:
              case ForwardRef:
              case MemoComponent:
              case SimpleMemoComponent: {
                commitHookEffectList(UnmountMutation, MountMutation, finishedWork);
                return;
              }
              case Profiler: {
                return;
              }
              case SuspenseComponent: {
                commitSuspenseComponent(finishedWork);
                attachSuspenseRetryListeners(finishedWork);
                return;
              }
              case SuspenseListComponent: {
                attachSuspenseRetryListeners(finishedWork);
                return;
              }
              case HostRoot: {
                if (supportsHydration) {
                  var root = finishedWork.stateNode;
                  if (root.hydrate) {
                    root.hydrate = false;
                    commitHydratedContainer(root.containerInfo);
                  }
                }
                break;
              }
            }
            commitContainer(finishedWork);
            return;
          }
          switch (finishedWork.tag) {
            case FunctionComponent:
            case ForwardRef:
            case MemoComponent:
            case SimpleMemoComponent: {
              commitHookEffectList(UnmountMutation, MountMutation, finishedWork);
              return;
            }
            case ClassComponent: {
              return;
            }
            case HostComponent: {
              var instance = finishedWork.stateNode;
              if (instance != null) {
                var newProps = finishedWork.memoizedProps;
                var oldProps = current$$1 !== null ? current$$1.memoizedProps : newProps;
                var type3 = finishedWork.type;
                var updatePayload = finishedWork.updateQueue;
                finishedWork.updateQueue = null;
                if (updatePayload !== null) {
                  commitUpdate(instance, updatePayload, type3, oldProps, newProps, finishedWork);
                }
                if (enableFlareAPI) {
                  var prevListeners = oldProps.listeners;
                  var nextListeners = newProps.listeners;
                  if (prevListeners !== nextListeners) {
                    updateEventListeners(nextListeners, finishedWork, null);
                  }
                }
              }
              return;
            }
            case HostText: {
              if (!(finishedWork.stateNode !== null)) {
                {
                  throw Error("This should have a text node initialized. This error is likely caused by a bug in React. Please file an issue.");
                }
              }
              var textInstance = finishedWork.stateNode;
              var newText = finishedWork.memoizedProps;
              var oldText = current$$1 !== null ? current$$1.memoizedProps : newText;
              commitTextUpdate(textInstance, oldText, newText);
              return;
            }
            case HostRoot: {
              if (supportsHydration) {
                var _root = finishedWork.stateNode;
                if (_root.hydrate) {
                  _root.hydrate = false;
                  commitHydratedContainer(_root.containerInfo);
                }
              }
              return;
            }
            case Profiler: {
              return;
            }
            case SuspenseComponent: {
              commitSuspenseComponent(finishedWork);
              attachSuspenseRetryListeners(finishedWork);
              return;
            }
            case SuspenseListComponent: {
              attachSuspenseRetryListeners(finishedWork);
              return;
            }
            case IncompleteClassComponent: {
              return;
            }
            case FundamentalComponent: {
              if (enableFundamentalAPI) {
                var fundamentalInstance = finishedWork.stateNode;
                updateFundamentalComponent(fundamentalInstance);
              }
              return;
            }
            case ScopeComponent: {
              if (enableScopeAPI) {
                var scopeInstance = finishedWork.stateNode;
                scopeInstance.fiber = finishedWork;
                if (enableFlareAPI) {
                  var _newProps = finishedWork.memoizedProps;
                  var _oldProps = current$$1 !== null ? current$$1.memoizedProps : _newProps;
                  var _prevListeners = _oldProps.listeners;
                  var _nextListeners = _newProps.listeners;
                  if (_prevListeners !== _nextListeners) {
                    updateEventListeners(_nextListeners, finishedWork, null);
                  }
                }
              }
              return;
            }
            default: {
              {
                {
                  throw Error("This unit of work tag should not have side-effects. This error is likely caused by a bug in React. Please file an issue.");
                }
              }
            }
          }
        }
        function commitSuspenseComponent(finishedWork) {
          var newState = finishedWork.memoizedState;
          var newDidTimeout;
          var primaryChildParent = finishedWork;
          if (newState === null) {
            newDidTimeout = false;
          } else {
            newDidTimeout = true;
            primaryChildParent = finishedWork.child;
            markCommitTimeOfFallback();
          }
          if (supportsMutation && primaryChildParent !== null) {
            hideOrUnhideAllChildren(primaryChildParent, newDidTimeout);
          }
          if (enableSuspenseCallback && newState !== null) {
            var suspenseCallback = finishedWork.memoizedProps.suspenseCallback;
            if (typeof suspenseCallback === "function") {
              var thenables = finishedWork.updateQueue;
              if (thenables !== null) {
                suspenseCallback(new Set(thenables));
              }
            } else {
              if (suspenseCallback !== void 0) {
                warning$1(false, "Unexpected type for suspenseCallback.");
              }
            }
          }
        }
        function commitSuspenseHydrationCallbacks(finishedRoot, finishedWork) {
          if (!supportsHydration) {
            return;
          }
          var newState = finishedWork.memoizedState;
          if (newState === null) {
            var current$$1 = finishedWork.alternate;
            if (current$$1 !== null) {
              var prevState = current$$1.memoizedState;
              if (prevState !== null) {
                var suspenseInstance = prevState.dehydrated;
                if (suspenseInstance !== null) {
                  commitHydratedSuspenseInstance(suspenseInstance);
                  if (enableSuspenseCallback) {
                    var hydrationCallbacks = finishedRoot.hydrationCallbacks;
                    if (hydrationCallbacks !== null) {
                      var onHydrated = hydrationCallbacks.onHydrated;
                      if (onHydrated) {
                        onHydrated(suspenseInstance);
                      }
                    }
                  }
                }
              }
            }
          }
        }
        function attachSuspenseRetryListeners(finishedWork) {
          var thenables = finishedWork.updateQueue;
          if (thenables !== null) {
            finishedWork.updateQueue = null;
            var retryCache = finishedWork.stateNode;
            if (retryCache === null) {
              retryCache = finishedWork.stateNode = new PossiblyWeakSet();
            }
            thenables.forEach(function(thenable) {
              var retry = resolveRetryThenable.bind(null, finishedWork, thenable);
              if (!retryCache.has(thenable)) {
                if (enableSchedulerTracing) {
                  if (thenable.__reactDoNotTraceInteractions !== true) {
                    retry = tracing.unstable_wrap(retry);
                  }
                }
                retryCache.add(thenable);
                thenable.then(retry, retry);
              }
            });
          }
        }
        function commitResetTextContent(current$$1) {
          if (!supportsMutation) {
            return;
          }
          resetTextContent(current$$1.stateNode);
        }
        var PossiblyWeakMap = typeof WeakMap === "function" ? WeakMap : Map;
        function createRootErrorUpdate(fiber, errorInfo, expirationTime) {
          var update = createUpdate(expirationTime, null);
          update.tag = CaptureUpdate;
          update.payload = {
            element: null
          };
          var error = errorInfo.value;
          update.callback = function() {
            onUncaughtError(error);
            logError(fiber, errorInfo);
          };
          return update;
        }
        function createClassErrorUpdate(fiber, errorInfo, expirationTime) {
          var update = createUpdate(expirationTime, null);
          update.tag = CaptureUpdate;
          var getDerivedStateFromError = fiber.type.getDerivedStateFromError;
          if (typeof getDerivedStateFromError === "function") {
            var error = errorInfo.value;
            update.payload = function() {
              logError(fiber, errorInfo);
              return getDerivedStateFromError(error);
            };
          }
          var inst = fiber.stateNode;
          if (inst !== null && typeof inst.componentDidCatch === "function") {
            update.callback = function callback() {
              {
                markFailedErrorBoundaryForHotReloading(fiber);
              }
              if (typeof getDerivedStateFromError !== "function") {
                markLegacyErrorBoundaryAsFailed(this);
                logError(fiber, errorInfo);
              }
              var error2 = errorInfo.value;
              var stack = errorInfo.stack;
              this.componentDidCatch(error2, {
                componentStack: stack !== null ? stack : ""
              });
              {
                if (typeof getDerivedStateFromError !== "function") {
                  !(fiber.expirationTime === Sync) ? warningWithoutStack$1(false, "%s: Error boundaries should implement getDerivedStateFromError(). In that method, return a state update to display an error message or fallback UI.", getComponentName(fiber.type) || "Unknown") : void 0;
                }
              }
            };
          } else {
            update.callback = function() {
              markFailedErrorBoundaryForHotReloading(fiber);
            };
          }
          return update;
        }
        function attachPingListener(root, renderExpirationTime2, thenable) {
          var pingCache = root.pingCache;
          var threadIDs;
          if (pingCache === null) {
            pingCache = root.pingCache = new PossiblyWeakMap();
            threadIDs = /* @__PURE__ */ new Set();
            pingCache.set(thenable, threadIDs);
          } else {
            threadIDs = pingCache.get(thenable);
            if (threadIDs === void 0) {
              threadIDs = /* @__PURE__ */ new Set();
              pingCache.set(thenable, threadIDs);
            }
          }
          if (!threadIDs.has(renderExpirationTime2)) {
            threadIDs.add(renderExpirationTime2);
            var ping = pingSuspendedRoot.bind(null, root, thenable, renderExpirationTime2);
            thenable.then(ping, ping);
          }
        }
        function throwException(root, returnFiber, sourceFiber, value, renderExpirationTime2) {
          sourceFiber.effectTag |= Incomplete;
          sourceFiber.firstEffect = sourceFiber.lastEffect = null;
          if (value !== null && typeof value === "object" && typeof value.then === "function") {
            var thenable = value;
            checkForWrongSuspensePriorityInDEV(sourceFiber);
            var hasInvisibleParentBoundary = hasSuspenseContext(suspenseStackCursor.current, InvisibleParentSuspenseContext);
            var _workInProgress = returnFiber;
            do {
              if (_workInProgress.tag === SuspenseComponent && shouldCaptureSuspense(_workInProgress, hasInvisibleParentBoundary)) {
                var thenables = _workInProgress.updateQueue;
                if (thenables === null) {
                  var updateQueue = /* @__PURE__ */ new Set();
                  updateQueue.add(thenable);
                  _workInProgress.updateQueue = updateQueue;
                } else {
                  thenables.add(thenable);
                }
                if ((_workInProgress.mode & BlockingMode) === NoMode) {
                  _workInProgress.effectTag |= DidCapture;
                  sourceFiber.effectTag &= ~(LifecycleEffectMask | Incomplete);
                  if (sourceFiber.tag === ClassComponent) {
                    var currentSourceFiber = sourceFiber.alternate;
                    if (currentSourceFiber === null) {
                      sourceFiber.tag = IncompleteClassComponent;
                    } else {
                      var update = createUpdate(Sync, null);
                      update.tag = ForceUpdate;
                      enqueueUpdate(sourceFiber, update);
                    }
                  }
                  sourceFiber.expirationTime = Sync;
                  return;
                }
                attachPingListener(root, renderExpirationTime2, thenable);
                _workInProgress.effectTag |= ShouldCapture;
                _workInProgress.expirationTime = renderExpirationTime2;
                return;
              }
              _workInProgress = _workInProgress.return;
            } while (_workInProgress !== null);
            value = new Error((getComponentName(sourceFiber.type) || "A React component") + " suspended while rendering, but no fallback UI was specified.\n\nAdd a <Suspense fallback=...> component higher in the tree to provide a loading indicator or placeholder to display." + getStackByFiberInDevAndProd(sourceFiber));
          }
          renderDidError();
          value = createCapturedValue(value, sourceFiber);
          var workInProgress2 = returnFiber;
          do {
            switch (workInProgress2.tag) {
              case HostRoot: {
                var _errorInfo = value;
                workInProgress2.effectTag |= ShouldCapture;
                workInProgress2.expirationTime = renderExpirationTime2;
                var _update = createRootErrorUpdate(workInProgress2, _errorInfo, renderExpirationTime2);
                enqueueCapturedUpdate(workInProgress2, _update);
                return;
              }
              case ClassComponent:
                var errorInfo = value;
                var ctor = workInProgress2.type;
                var instance = workInProgress2.stateNode;
                if ((workInProgress2.effectTag & DidCapture) === NoEffect && (typeof ctor.getDerivedStateFromError === "function" || instance !== null && typeof instance.componentDidCatch === "function" && !isAlreadyFailedLegacyErrorBoundary(instance))) {
                  workInProgress2.effectTag |= ShouldCapture;
                  workInProgress2.expirationTime = renderExpirationTime2;
                  var _update2 = createClassErrorUpdate(workInProgress2, errorInfo, renderExpirationTime2);
                  enqueueCapturedUpdate(workInProgress2, _update2);
                  return;
                }
                break;
              default:
                break;
            }
            workInProgress2 = workInProgress2.return;
          } while (workInProgress2 !== null);
        }
        var ceil = Math.ceil;
        var ReactCurrentDispatcher = ReactSharedInternals.ReactCurrentDispatcher;
        var ReactCurrentOwner$1 = ReactSharedInternals.ReactCurrentOwner;
        var IsSomeRendererActing = ReactSharedInternals.IsSomeRendererActing;
        var NoContext = 0;
        var BatchedContext = 1;
        var EventContext = 2;
        var DiscreteEventContext = 4;
        var LegacyUnbatchedContext = 8;
        var RenderContext = 16;
        var CommitContext = 32;
        var RootIncomplete = 0;
        var RootFatalErrored = 1;
        var RootErrored = 2;
        var RootSuspended = 3;
        var RootSuspendedWithDelay = 4;
        var RootCompleted = 5;
        var executionContext = NoContext;
        var workInProgressRoot = null;
        var workInProgress = null;
        var renderExpirationTime = NoWork;
        var workInProgressRootExitStatus = RootIncomplete;
        var workInProgressRootFatalError = null;
        var workInProgressRootLatestProcessedExpirationTime = Sync;
        var workInProgressRootLatestSuspenseTimeout = Sync;
        var workInProgressRootCanSuspendUsingConfig = null;
        var workInProgressRootNextUnprocessedUpdateTime = NoWork;
        var workInProgressRootHasPendingPing = false;
        var globalMostRecentFallbackTime = 0;
        var FALLBACK_THROTTLE_MS = 500;
        var nextEffect = null;
        var hasUncaughtError = false;
        var firstUncaughtError = null;
        var legacyErrorBoundariesThatAlreadyFailed = null;
        var rootDoesHavePassiveEffects = false;
        var rootWithPendingPassiveEffects = null;
        var pendingPassiveEffectsRenderPriority = NoPriority;
        var pendingPassiveEffectsExpirationTime = NoWork;
        var rootsWithPendingDiscreteUpdates = null;
        var NESTED_UPDATE_LIMIT = 50;
        var nestedUpdateCount = 0;
        var rootWithNestedUpdates = null;
        var NESTED_PASSIVE_UPDATE_LIMIT = 50;
        var nestedPassiveUpdateCount = 0;
        var interruptedBy = null;
        var spawnedWorkDuringRender = null;
        var currentEventTime = NoWork;
        function requestCurrentTimeForUpdate() {
          if ((executionContext & (RenderContext | CommitContext)) !== NoContext) {
            return msToExpirationTime(now$1());
          }
          if (currentEventTime !== NoWork) {
            return currentEventTime;
          }
          currentEventTime = msToExpirationTime(now$1());
          return currentEventTime;
        }
        function getCurrentTime() {
          return msToExpirationTime(now$1());
        }
        function computeExpirationForFiber(currentTime, fiber, suspenseConfig) {
          var mode = fiber.mode;
          if ((mode & BlockingMode) === NoMode) {
            return Sync;
          }
          var priorityLevel = getCurrentPriorityLevel();
          if ((mode & ConcurrentMode) === NoMode) {
            return priorityLevel === ImmediatePriority ? Sync : Batched;
          }
          if ((executionContext & RenderContext) !== NoContext) {
            return renderExpirationTime;
          }
          var expirationTime;
          if (suspenseConfig !== null) {
            expirationTime = computeSuspenseExpiration(currentTime, suspenseConfig.timeoutMs | 0 || LOW_PRIORITY_EXPIRATION);
          } else {
            switch (priorityLevel) {
              case ImmediatePriority:
                expirationTime = Sync;
                break;
              case UserBlockingPriority:
                expirationTime = computeInteractiveExpiration(currentTime);
                break;
              case NormalPriority:
              case LowPriority:
                expirationTime = computeAsyncExpiration(currentTime);
                break;
              case IdlePriority:
                expirationTime = Idle;
                break;
              default: {
                {
                  throw Error("Expected a valid priority level");
                }
              }
            }
          }
          if (workInProgressRoot !== null && expirationTime === renderExpirationTime) {
            expirationTime -= 1;
          }
          return expirationTime;
        }
        function scheduleUpdateOnFiber(fiber, expirationTime) {
          checkForNestedUpdates();
          warnAboutInvalidUpdatesOnClassComponentsInDEV(fiber);
          var root = markUpdateTimeFromFiberToRoot(fiber, expirationTime);
          if (root === null) {
            warnAboutUpdateOnUnmountedFiberInDEV(fiber);
            return;
          }
          checkForInterruption(fiber, expirationTime);
          recordScheduleUpdate();
          var priorityLevel = getCurrentPriorityLevel();
          if (expirationTime === Sync) {
            if ((executionContext & LegacyUnbatchedContext) !== NoContext && (executionContext & (RenderContext | CommitContext)) === NoContext) {
              schedulePendingInteractions(root, expirationTime);
              performSyncWorkOnRoot(root);
            } else {
              ensureRootIsScheduled(root);
              schedulePendingInteractions(root, expirationTime);
              if (executionContext === NoContext) {
                flushSyncCallbackQueue();
              }
            }
          } else {
            ensureRootIsScheduled(root);
            schedulePendingInteractions(root, expirationTime);
          }
          if ((executionContext & DiscreteEventContext) !== NoContext && (priorityLevel === UserBlockingPriority || priorityLevel === ImmediatePriority)) {
            if (rootsWithPendingDiscreteUpdates === null) {
              rootsWithPendingDiscreteUpdates = /* @__PURE__ */ new Map([[root, expirationTime]]);
            } else {
              var lastDiscreteTime = rootsWithPendingDiscreteUpdates.get(root);
              if (lastDiscreteTime === void 0 || lastDiscreteTime > expirationTime) {
                rootsWithPendingDiscreteUpdates.set(root, expirationTime);
              }
            }
          }
        }
        var scheduleWork = scheduleUpdateOnFiber;
        function markUpdateTimeFromFiberToRoot(fiber, expirationTime) {
          if (fiber.expirationTime < expirationTime) {
            fiber.expirationTime = expirationTime;
          }
          var alternate = fiber.alternate;
          if (alternate !== null && alternate.expirationTime < expirationTime) {
            alternate.expirationTime = expirationTime;
          }
          var node = fiber.return;
          var root = null;
          if (node === null && fiber.tag === HostRoot) {
            root = fiber.stateNode;
          } else {
            while (node !== null) {
              alternate = node.alternate;
              if (node.childExpirationTime < expirationTime) {
                node.childExpirationTime = expirationTime;
                if (alternate !== null && alternate.childExpirationTime < expirationTime) {
                  alternate.childExpirationTime = expirationTime;
                }
              } else if (alternate !== null && alternate.childExpirationTime < expirationTime) {
                alternate.childExpirationTime = expirationTime;
              }
              if (node.return === null && node.tag === HostRoot) {
                root = node.stateNode;
                break;
              }
              node = node.return;
            }
          }
          if (root !== null) {
            if (workInProgressRoot === root) {
              markUnprocessedUpdateTime(expirationTime);
              if (workInProgressRootExitStatus === RootSuspendedWithDelay) {
                markRootSuspendedAtTime(root, renderExpirationTime);
              }
            }
            markRootUpdatedAtTime(root, expirationTime);
          }
          return root;
        }
        function getNextRootExpirationTimeToWorkOn(root) {
          var lastExpiredTime = root.lastExpiredTime;
          if (lastExpiredTime !== NoWork) {
            return lastExpiredTime;
          }
          var firstPendingTime = root.firstPendingTime;
          if (!isRootSuspendedAtTime(root, firstPendingTime)) {
            return firstPendingTime;
          }
          var lastPingedTime = root.lastPingedTime;
          var nextKnownPendingLevel = root.nextKnownPendingLevel;
          return lastPingedTime > nextKnownPendingLevel ? lastPingedTime : nextKnownPendingLevel;
        }
        function ensureRootIsScheduled(root) {
          var lastExpiredTime = root.lastExpiredTime;
          if (lastExpiredTime !== NoWork) {
            root.callbackExpirationTime = Sync;
            root.callbackPriority = ImmediatePriority;
            root.callbackNode = scheduleSyncCallback(performSyncWorkOnRoot.bind(null, root));
            return;
          }
          var expirationTime = getNextRootExpirationTimeToWorkOn(root);
          var existingCallbackNode = root.callbackNode;
          if (expirationTime === NoWork) {
            if (existingCallbackNode !== null) {
              root.callbackNode = null;
              root.callbackExpirationTime = NoWork;
              root.callbackPriority = NoPriority;
            }
            return;
          }
          var currentTime = requestCurrentTimeForUpdate();
          var priorityLevel = inferPriorityFromExpirationTime(currentTime, expirationTime);
          if (existingCallbackNode !== null) {
            var existingCallbackPriority = root.callbackPriority;
            var existingCallbackExpirationTime = root.callbackExpirationTime;
            if (existingCallbackExpirationTime === expirationTime && existingCallbackPriority >= priorityLevel) {
              return;
            }
            cancelCallback(existingCallbackNode);
          }
          root.callbackExpirationTime = expirationTime;
          root.callbackPriority = priorityLevel;
          var callbackNode;
          if (expirationTime === Sync) {
            callbackNode = scheduleSyncCallback(performSyncWorkOnRoot.bind(null, root));
          } else if (disableSchedulerTimeoutBasedOnReactExpirationTime) {
            callbackNode = scheduleCallback(priorityLevel, performConcurrentWorkOnRoot.bind(null, root));
          } else {
            callbackNode = scheduleCallback(priorityLevel, performConcurrentWorkOnRoot.bind(null, root), {
              timeout: expirationTimeToMs(expirationTime) - now$1()
            });
          }
          root.callbackNode = callbackNode;
        }
        function performConcurrentWorkOnRoot(root, didTimeout) {
          currentEventTime = NoWork;
          if (didTimeout) {
            var currentTime = requestCurrentTimeForUpdate();
            markRootExpiredAtTime(root, currentTime);
            ensureRootIsScheduled(root);
            return null;
          }
          var expirationTime = getNextRootExpirationTimeToWorkOn(root);
          if (expirationTime !== NoWork) {
            var originalCallbackNode = root.callbackNode;
            if (!((executionContext & (RenderContext | CommitContext)) === NoContext)) {
              {
                throw Error("Should not already be working.");
              }
            }
            flushPassiveEffects();
            if (root !== workInProgressRoot || expirationTime !== renderExpirationTime) {
              prepareFreshStack(root, expirationTime);
              startWorkOnPendingInteractions(root, expirationTime);
            }
            if (workInProgress !== null) {
              var prevExecutionContext = executionContext;
              executionContext |= RenderContext;
              var prevDispatcher = pushDispatcher(root);
              var prevInteractions = pushInteractions(root);
              startWorkLoopTimer(workInProgress);
              do {
                try {
                  workLoopConcurrent();
                  break;
                } catch (thrownValue) {
                  handleError(root, thrownValue);
                }
              } while (true);
              resetContextDependencies();
              executionContext = prevExecutionContext;
              popDispatcher(prevDispatcher);
              if (enableSchedulerTracing) {
                popInteractions(prevInteractions);
              }
              if (workInProgressRootExitStatus === RootFatalErrored) {
                var fatalError = workInProgressRootFatalError;
                stopInterruptedWorkLoopTimer();
                prepareFreshStack(root, expirationTime);
                markRootSuspendedAtTime(root, expirationTime);
                ensureRootIsScheduled(root);
                throw fatalError;
              }
              if (workInProgress !== null) {
                stopInterruptedWorkLoopTimer();
              } else {
                stopFinishedWorkLoopTimer();
                var finishedWork = root.finishedWork = root.current.alternate;
                root.finishedExpirationTime = expirationTime;
                finishConcurrentRender(root, finishedWork, workInProgressRootExitStatus, expirationTime);
              }
              ensureRootIsScheduled(root);
              if (root.callbackNode === originalCallbackNode) {
                return performConcurrentWorkOnRoot.bind(null, root);
              }
            }
          }
          return null;
        }
        function finishConcurrentRender(root, finishedWork, exitStatus, expirationTime) {
          workInProgressRoot = null;
          switch (exitStatus) {
            case RootIncomplete:
            case RootFatalErrored: {
              {
                {
                  throw Error("Root did not complete. This is a bug in React.");
                }
              }
            }
            case RootErrored: {
              markRootExpiredAtTime(root, expirationTime > Idle ? Idle : expirationTime);
              break;
            }
            case RootSuspended: {
              markRootSuspendedAtTime(root, expirationTime);
              var lastSuspendedTime = root.lastSuspendedTime;
              if (expirationTime === lastSuspendedTime) {
                root.nextKnownPendingLevel = getRemainingExpirationTime(finishedWork);
              }
              flushSuspensePriorityWarningInDEV();
              var hasNotProcessedNewUpdates = workInProgressRootLatestProcessedExpirationTime === Sync;
              if (hasNotProcessedNewUpdates && !(flushSuspenseFallbacksInTests && IsThisRendererActing.current)) {
                var msUntilTimeout = globalMostRecentFallbackTime + FALLBACK_THROTTLE_MS - now$1();
                if (msUntilTimeout > 10) {
                  if (workInProgressRootHasPendingPing) {
                    var lastPingedTime = root.lastPingedTime;
                    if (lastPingedTime === NoWork || lastPingedTime >= expirationTime) {
                      root.lastPingedTime = expirationTime;
                      prepareFreshStack(root, expirationTime);
                      break;
                    }
                  }
                  var nextTime = getNextRootExpirationTimeToWorkOn(root);
                  if (nextTime !== NoWork && nextTime !== expirationTime) {
                    break;
                  }
                  if (lastSuspendedTime !== NoWork && lastSuspendedTime !== expirationTime) {
                    root.lastPingedTime = lastSuspendedTime;
                    break;
                  }
                  root.timeoutHandle = scheduleTimeout(commitRoot.bind(null, root), msUntilTimeout);
                  break;
                }
              }
              commitRoot(root);
              break;
            }
            case RootSuspendedWithDelay: {
              markRootSuspendedAtTime(root, expirationTime);
              var _lastSuspendedTime = root.lastSuspendedTime;
              if (expirationTime === _lastSuspendedTime) {
                root.nextKnownPendingLevel = getRemainingExpirationTime(finishedWork);
              }
              flushSuspensePriorityWarningInDEV();
              if (!(flushSuspenseFallbacksInTests && IsThisRendererActing.current)) {
                if (workInProgressRootHasPendingPing) {
                  var _lastPingedTime = root.lastPingedTime;
                  if (_lastPingedTime === NoWork || _lastPingedTime >= expirationTime) {
                    root.lastPingedTime = expirationTime;
                    prepareFreshStack(root, expirationTime);
                    break;
                  }
                }
                var _nextTime = getNextRootExpirationTimeToWorkOn(root);
                if (_nextTime !== NoWork && _nextTime !== expirationTime) {
                  break;
                }
                if (_lastSuspendedTime !== NoWork && _lastSuspendedTime !== expirationTime) {
                  root.lastPingedTime = _lastSuspendedTime;
                  break;
                }
                var _msUntilTimeout;
                if (workInProgressRootLatestSuspenseTimeout !== Sync) {
                  _msUntilTimeout = expirationTimeToMs(workInProgressRootLatestSuspenseTimeout) - now$1();
                } else if (workInProgressRootLatestProcessedExpirationTime === Sync) {
                  _msUntilTimeout = 0;
                } else {
                  var eventTimeMs = inferTimeFromExpirationTime(workInProgressRootLatestProcessedExpirationTime);
                  var currentTimeMs = now$1();
                  var timeUntilExpirationMs = expirationTimeToMs(expirationTime) - currentTimeMs;
                  var timeElapsed = currentTimeMs - eventTimeMs;
                  if (timeElapsed < 0) {
                    timeElapsed = 0;
                  }
                  _msUntilTimeout = jnd(timeElapsed) - timeElapsed;
                  if (timeUntilExpirationMs < _msUntilTimeout) {
                    _msUntilTimeout = timeUntilExpirationMs;
                  }
                }
                if (_msUntilTimeout > 10) {
                  root.timeoutHandle = scheduleTimeout(commitRoot.bind(null, root), _msUntilTimeout);
                  break;
                }
              }
              commitRoot(root);
              break;
            }
            case RootCompleted: {
              if (!(flushSuspenseFallbacksInTests && IsThisRendererActing.current) && workInProgressRootLatestProcessedExpirationTime !== Sync && workInProgressRootCanSuspendUsingConfig !== null) {
                var _msUntilTimeout2 = computeMsUntilSuspenseLoadingDelay(workInProgressRootLatestProcessedExpirationTime, expirationTime, workInProgressRootCanSuspendUsingConfig);
                if (_msUntilTimeout2 > 10) {
                  markRootSuspendedAtTime(root, expirationTime);
                  root.timeoutHandle = scheduleTimeout(commitRoot.bind(null, root), _msUntilTimeout2);
                  break;
                }
              }
              commitRoot(root);
              break;
            }
            default: {
              {
                {
                  throw Error("Unknown root exit status.");
                }
              }
            }
          }
        }
        function performSyncWorkOnRoot(root) {
          var lastExpiredTime = root.lastExpiredTime;
          var expirationTime = lastExpiredTime !== NoWork ? lastExpiredTime : Sync;
          if (root.finishedExpirationTime === expirationTime) {
            commitRoot(root);
          } else {
            if (!((executionContext & (RenderContext | CommitContext)) === NoContext)) {
              {
                throw Error("Should not already be working.");
              }
            }
            flushPassiveEffects();
            if (root !== workInProgressRoot || expirationTime !== renderExpirationTime) {
              prepareFreshStack(root, expirationTime);
              startWorkOnPendingInteractions(root, expirationTime);
            }
            if (workInProgress !== null) {
              var prevExecutionContext = executionContext;
              executionContext |= RenderContext;
              var prevDispatcher = pushDispatcher(root);
              var prevInteractions = pushInteractions(root);
              startWorkLoopTimer(workInProgress);
              do {
                try {
                  workLoopSync();
                  break;
                } catch (thrownValue) {
                  handleError(root, thrownValue);
                }
              } while (true);
              resetContextDependencies();
              executionContext = prevExecutionContext;
              popDispatcher(prevDispatcher);
              if (enableSchedulerTracing) {
                popInteractions(prevInteractions);
              }
              if (workInProgressRootExitStatus === RootFatalErrored) {
                var fatalError = workInProgressRootFatalError;
                stopInterruptedWorkLoopTimer();
                prepareFreshStack(root, expirationTime);
                markRootSuspendedAtTime(root, expirationTime);
                ensureRootIsScheduled(root);
                throw fatalError;
              }
              if (workInProgress !== null) {
                {
                  {
                    throw Error("Cannot commit an incomplete root. This error is likely caused by a bug in React. Please file an issue.");
                  }
                }
              } else {
                stopFinishedWorkLoopTimer();
                root.finishedWork = root.current.alternate;
                root.finishedExpirationTime = expirationTime;
                finishSyncRender(root, workInProgressRootExitStatus, expirationTime);
              }
              ensureRootIsScheduled(root);
            }
          }
          return null;
        }
        function finishSyncRender(root, exitStatus, expirationTime) {
          workInProgressRoot = null;
          {
            if (exitStatus === RootSuspended || exitStatus === RootSuspendedWithDelay) {
              flushSuspensePriorityWarningInDEV();
            }
          }
          commitRoot(root);
        }
        function flushRoot(root, expirationTime) {
          markRootExpiredAtTime(root, expirationTime);
          ensureRootIsScheduled(root);
          if ((executionContext & (RenderContext | CommitContext)) === NoContext) {
            flushSyncCallbackQueue();
          }
        }
        function flushDiscreteUpdates() {
          if ((executionContext & (BatchedContext | RenderContext | CommitContext)) !== NoContext) {
            if ((executionContext & RenderContext) !== NoContext) {
              warning$1(false, "unstable_flushDiscreteUpdates: Cannot flush updates when React is already rendering.");
            }
            return;
          }
          flushPendingDiscreteUpdates();
          flushPassiveEffects();
        }
        function deferredUpdates(fn) {
          return runWithPriority(NormalPriority, fn);
        }
        function syncUpdates(fn, a2, b2, c2) {
          return runWithPriority(ImmediatePriority, fn.bind(null, a2, b2, c2));
        }
        function flushPendingDiscreteUpdates() {
          if (rootsWithPendingDiscreteUpdates !== null) {
            var roots = rootsWithPendingDiscreteUpdates;
            rootsWithPendingDiscreteUpdates = null;
            roots.forEach(function(expirationTime, root) {
              markRootExpiredAtTime(root, expirationTime);
              ensureRootIsScheduled(root);
            });
            flushSyncCallbackQueue();
          }
        }
        function batchedUpdates(fn, a2) {
          var prevExecutionContext = executionContext;
          executionContext |= BatchedContext;
          try {
            return fn(a2);
          } finally {
            executionContext = prevExecutionContext;
            if (executionContext === NoContext) {
              flushSyncCallbackQueue();
            }
          }
        }
        function batchedEventUpdates(fn, a2) {
          var prevExecutionContext = executionContext;
          executionContext |= EventContext;
          try {
            return fn(a2);
          } finally {
            executionContext = prevExecutionContext;
            if (executionContext === NoContext) {
              flushSyncCallbackQueue();
            }
          }
        }
        function discreteUpdates(fn, a2, b2, c2) {
          var prevExecutionContext = executionContext;
          executionContext |= DiscreteEventContext;
          try {
            return runWithPriority(UserBlockingPriority, fn.bind(null, a2, b2, c2));
          } finally {
            executionContext = prevExecutionContext;
            if (executionContext === NoContext) {
              flushSyncCallbackQueue();
            }
          }
        }
        function unbatchedUpdates(fn, a2) {
          var prevExecutionContext = executionContext;
          executionContext &= ~BatchedContext;
          executionContext |= LegacyUnbatchedContext;
          try {
            return fn(a2);
          } finally {
            executionContext = prevExecutionContext;
            if (executionContext === NoContext) {
              flushSyncCallbackQueue();
            }
          }
        }
        function flushSync(fn, a2) {
          if ((executionContext & (RenderContext | CommitContext)) !== NoContext) {
            {
              {
                throw Error("flushSync was called from inside a lifecycle method. It cannot be called when React is already rendering.");
              }
            }
          }
          var prevExecutionContext = executionContext;
          executionContext |= BatchedContext;
          try {
            return runWithPriority(ImmediatePriority, fn.bind(null, a2));
          } finally {
            executionContext = prevExecutionContext;
            flushSyncCallbackQueue();
          }
        }
        function flushControlled(fn) {
          var prevExecutionContext = executionContext;
          executionContext |= BatchedContext;
          try {
            runWithPriority(ImmediatePriority, fn);
          } finally {
            executionContext = prevExecutionContext;
            if (executionContext === NoContext) {
              flushSyncCallbackQueue();
            }
          }
        }
        function prepareFreshStack(root, expirationTime) {
          root.finishedWork = null;
          root.finishedExpirationTime = NoWork;
          var timeoutHandle = root.timeoutHandle;
          if (timeoutHandle !== noTimeout) {
            root.timeoutHandle = noTimeout;
            cancelTimeout(timeoutHandle);
          }
          if (workInProgress !== null) {
            var interruptedWork = workInProgress.return;
            while (interruptedWork !== null) {
              unwindInterruptedWork(interruptedWork);
              interruptedWork = interruptedWork.return;
            }
          }
          workInProgressRoot = root;
          workInProgress = createWorkInProgress(root.current, null, expirationTime);
          renderExpirationTime = expirationTime;
          workInProgressRootExitStatus = RootIncomplete;
          workInProgressRootFatalError = null;
          workInProgressRootLatestProcessedExpirationTime = Sync;
          workInProgressRootLatestSuspenseTimeout = Sync;
          workInProgressRootCanSuspendUsingConfig = null;
          workInProgressRootNextUnprocessedUpdateTime = NoWork;
          workInProgressRootHasPendingPing = false;
          if (enableSchedulerTracing) {
            spawnedWorkDuringRender = null;
          }
          {
            ReactStrictModeWarnings.discardPendingWarnings();
            componentsThatTriggeredHighPriSuspend = null;
          }
        }
        function handleError(root, thrownValue) {
          do {
            try {
              resetContextDependencies();
              resetHooks();
              resetCurrentFiber();
              if (workInProgress === null || workInProgress.return === null) {
                workInProgressRootExitStatus = RootFatalErrored;
                workInProgressRootFatalError = thrownValue;
                return null;
              }
              if (enableProfilerTimer && workInProgress.mode & ProfileMode) {
                stopProfilerTimerIfRunningAndRecordDelta(workInProgress, true);
              }
              throwException(root, workInProgress.return, workInProgress, thrownValue, renderExpirationTime);
              workInProgress = completeUnitOfWork(workInProgress);
            } catch (yetAnotherThrownValue) {
              thrownValue = yetAnotherThrownValue;
              continue;
            }
            return;
          } while (true);
        }
        function pushDispatcher(root) {
          var prevDispatcher = ReactCurrentDispatcher.current;
          ReactCurrentDispatcher.current = ContextOnlyDispatcher;
          if (prevDispatcher === null) {
            return ContextOnlyDispatcher;
          } else {
            return prevDispatcher;
          }
        }
        function popDispatcher(prevDispatcher) {
          ReactCurrentDispatcher.current = prevDispatcher;
        }
        function pushInteractions(root) {
          if (enableSchedulerTracing) {
            var prevInteractions = tracing.__interactionsRef.current;
            tracing.__interactionsRef.current = root.memoizedInteractions;
            return prevInteractions;
          }
          return null;
        }
        function popInteractions(prevInteractions) {
          if (enableSchedulerTracing) {
            tracing.__interactionsRef.current = prevInteractions;
          }
        }
        function markCommitTimeOfFallback() {
          globalMostRecentFallbackTime = now$1();
        }
        function markRenderEventTimeAndConfig(expirationTime, suspenseConfig) {
          if (expirationTime < workInProgressRootLatestProcessedExpirationTime && expirationTime > Idle) {
            workInProgressRootLatestProcessedExpirationTime = expirationTime;
          }
          if (suspenseConfig !== null) {
            if (expirationTime < workInProgressRootLatestSuspenseTimeout && expirationTime > Idle) {
              workInProgressRootLatestSuspenseTimeout = expirationTime;
              workInProgressRootCanSuspendUsingConfig = suspenseConfig;
            }
          }
        }
        function markUnprocessedUpdateTime(expirationTime) {
          if (expirationTime > workInProgressRootNextUnprocessedUpdateTime) {
            workInProgressRootNextUnprocessedUpdateTime = expirationTime;
          }
        }
        function renderDidSuspend() {
          if (workInProgressRootExitStatus === RootIncomplete) {
            workInProgressRootExitStatus = RootSuspended;
          }
        }
        function renderDidSuspendDelayIfPossible() {
          if (workInProgressRootExitStatus === RootIncomplete || workInProgressRootExitStatus === RootSuspended) {
            workInProgressRootExitStatus = RootSuspendedWithDelay;
          }
          if (workInProgressRootNextUnprocessedUpdateTime !== NoWork && workInProgressRoot !== null) {
            markRootSuspendedAtTime(workInProgressRoot, renderExpirationTime);
            markRootUpdatedAtTime(workInProgressRoot, workInProgressRootNextUnprocessedUpdateTime);
          }
        }
        function renderDidError() {
          if (workInProgressRootExitStatus !== RootCompleted) {
            workInProgressRootExitStatus = RootErrored;
          }
        }
        function renderHasNotSuspendedYet() {
          return workInProgressRootExitStatus === RootIncomplete;
        }
        function inferTimeFromExpirationTime(expirationTime) {
          var earliestExpirationTimeMs = expirationTimeToMs(expirationTime);
          return earliestExpirationTimeMs - LOW_PRIORITY_EXPIRATION;
        }
        function inferTimeFromExpirationTimeWithSuspenseConfig(expirationTime, suspenseConfig) {
          var earliestExpirationTimeMs = expirationTimeToMs(expirationTime);
          return earliestExpirationTimeMs - (suspenseConfig.timeoutMs | 0 || LOW_PRIORITY_EXPIRATION);
        }
        function workLoopSync() {
          while (workInProgress !== null) {
            workInProgress = performUnitOfWork(workInProgress);
          }
        }
        function workLoopConcurrent() {
          while (workInProgress !== null && !shouldYield()) {
            workInProgress = performUnitOfWork(workInProgress);
          }
        }
        function performUnitOfWork(unitOfWork) {
          var current$$1 = unitOfWork.alternate;
          startWorkTimer(unitOfWork);
          setCurrentFiber(unitOfWork);
          var next;
          if (enableProfilerTimer && (unitOfWork.mode & ProfileMode) !== NoMode) {
            startProfilerTimer(unitOfWork);
            next = beginWork$$1(current$$1, unitOfWork, renderExpirationTime);
            stopProfilerTimerIfRunningAndRecordDelta(unitOfWork, true);
          } else {
            next = beginWork$$1(current$$1, unitOfWork, renderExpirationTime);
          }
          resetCurrentFiber();
          unitOfWork.memoizedProps = unitOfWork.pendingProps;
          if (next === null) {
            next = completeUnitOfWork(unitOfWork);
          }
          ReactCurrentOwner$1.current = null;
          return next;
        }
        function completeUnitOfWork(unitOfWork) {
          workInProgress = unitOfWork;
          do {
            var current$$1 = workInProgress.alternate;
            var returnFiber = workInProgress.return;
            if ((workInProgress.effectTag & Incomplete) === NoEffect) {
              setCurrentFiber(workInProgress);
              var next = void 0;
              if (!enableProfilerTimer || (workInProgress.mode & ProfileMode) === NoMode) {
                next = completeWork(current$$1, workInProgress, renderExpirationTime);
              } else {
                startProfilerTimer(workInProgress);
                next = completeWork(current$$1, workInProgress, renderExpirationTime);
                stopProfilerTimerIfRunningAndRecordDelta(workInProgress, false);
              }
              stopWorkTimer(workInProgress);
              resetCurrentFiber();
              resetChildExpirationTime(workInProgress);
              if (next !== null) {
                return next;
              }
              if (returnFiber !== null && (returnFiber.effectTag & Incomplete) === NoEffect) {
                if (returnFiber.firstEffect === null) {
                  returnFiber.firstEffect = workInProgress.firstEffect;
                }
                if (workInProgress.lastEffect !== null) {
                  if (returnFiber.lastEffect !== null) {
                    returnFiber.lastEffect.nextEffect = workInProgress.firstEffect;
                  }
                  returnFiber.lastEffect = workInProgress.lastEffect;
                }
                var effectTag = workInProgress.effectTag;
                if (effectTag > PerformedWork) {
                  if (returnFiber.lastEffect !== null) {
                    returnFiber.lastEffect.nextEffect = workInProgress;
                  } else {
                    returnFiber.firstEffect = workInProgress;
                  }
                  returnFiber.lastEffect = workInProgress;
                }
              }
            } else {
              var _next = unwindWork(workInProgress, renderExpirationTime);
              if (enableProfilerTimer && (workInProgress.mode & ProfileMode) !== NoMode) {
                stopProfilerTimerIfRunningAndRecordDelta(workInProgress, false);
                var actualDuration = workInProgress.actualDuration;
                var child = workInProgress.child;
                while (child !== null) {
                  actualDuration += child.actualDuration;
                  child = child.sibling;
                }
                workInProgress.actualDuration = actualDuration;
              }
              if (_next !== null) {
                stopFailedWorkTimer(workInProgress);
                _next.effectTag &= HostEffectMask;
                return _next;
              }
              stopWorkTimer(workInProgress);
              if (returnFiber !== null) {
                returnFiber.firstEffect = returnFiber.lastEffect = null;
                returnFiber.effectTag |= Incomplete;
              }
            }
            var siblingFiber = workInProgress.sibling;
            if (siblingFiber !== null) {
              return siblingFiber;
            }
            workInProgress = returnFiber;
          } while (workInProgress !== null);
          if (workInProgressRootExitStatus === RootIncomplete) {
            workInProgressRootExitStatus = RootCompleted;
          }
          return null;
        }
        function getRemainingExpirationTime(fiber) {
          var updateExpirationTime = fiber.expirationTime;
          var childExpirationTime = fiber.childExpirationTime;
          return updateExpirationTime > childExpirationTime ? updateExpirationTime : childExpirationTime;
        }
        function resetChildExpirationTime(completedWork) {
          if (renderExpirationTime !== Never && completedWork.childExpirationTime === Never) {
            return;
          }
          var newChildExpirationTime = NoWork;
          if (enableProfilerTimer && (completedWork.mode & ProfileMode) !== NoMode) {
            var actualDuration = completedWork.actualDuration;
            var treeBaseDuration = completedWork.selfBaseDuration;
            var shouldBubbleActualDurations = completedWork.alternate === null || completedWork.child !== completedWork.alternate.child;
            var child = completedWork.child;
            while (child !== null) {
              var childUpdateExpirationTime = child.expirationTime;
              var childChildExpirationTime = child.childExpirationTime;
              if (childUpdateExpirationTime > newChildExpirationTime) {
                newChildExpirationTime = childUpdateExpirationTime;
              }
              if (childChildExpirationTime > newChildExpirationTime) {
                newChildExpirationTime = childChildExpirationTime;
              }
              if (shouldBubbleActualDurations) {
                actualDuration += child.actualDuration;
              }
              treeBaseDuration += child.treeBaseDuration;
              child = child.sibling;
            }
            completedWork.actualDuration = actualDuration;
            completedWork.treeBaseDuration = treeBaseDuration;
          } else {
            var _child = completedWork.child;
            while (_child !== null) {
              var _childUpdateExpirationTime = _child.expirationTime;
              var _childChildExpirationTime = _child.childExpirationTime;
              if (_childUpdateExpirationTime > newChildExpirationTime) {
                newChildExpirationTime = _childUpdateExpirationTime;
              }
              if (_childChildExpirationTime > newChildExpirationTime) {
                newChildExpirationTime = _childChildExpirationTime;
              }
              _child = _child.sibling;
            }
          }
          completedWork.childExpirationTime = newChildExpirationTime;
        }
        function commitRoot(root) {
          var renderPriorityLevel = getCurrentPriorityLevel();
          runWithPriority(ImmediatePriority, commitRootImpl.bind(null, root, renderPriorityLevel));
          return null;
        }
        function commitRootImpl(root, renderPriorityLevel) {
          do {
            flushPassiveEffects();
          } while (rootWithPendingPassiveEffects !== null);
          flushRenderPhaseStrictModeWarningsInDEV();
          if (!((executionContext & (RenderContext | CommitContext)) === NoContext)) {
            {
              throw Error("Should not already be working.");
            }
          }
          var finishedWork = root.finishedWork;
          var expirationTime = root.finishedExpirationTime;
          if (finishedWork === null) {
            return null;
          }
          root.finishedWork = null;
          root.finishedExpirationTime = NoWork;
          if (!(finishedWork !== root.current)) {
            {
              throw Error("Cannot commit the same tree as before. This error is likely caused by a bug in React. Please file an issue.");
            }
          }
          root.callbackNode = null;
          root.callbackExpirationTime = NoWork;
          root.callbackPriority = NoPriority;
          root.nextKnownPendingLevel = NoWork;
          startCommitTimer();
          var remainingExpirationTimeBeforeCommit = getRemainingExpirationTime(finishedWork);
          markRootFinishedAtTime(root, expirationTime, remainingExpirationTimeBeforeCommit);
          if (root === workInProgressRoot) {
            workInProgressRoot = null;
            workInProgress = null;
            renderExpirationTime = NoWork;
          } else {
          }
          var firstEffect;
          if (finishedWork.effectTag > PerformedWork) {
            if (finishedWork.lastEffect !== null) {
              finishedWork.lastEffect.nextEffect = finishedWork;
              firstEffect = finishedWork.firstEffect;
            } else {
              firstEffect = finishedWork;
            }
          } else {
            firstEffect = finishedWork.firstEffect;
          }
          if (firstEffect !== null) {
            var prevExecutionContext = executionContext;
            executionContext |= CommitContext;
            var prevInteractions = pushInteractions(root);
            ReactCurrentOwner$1.current = null;
            startCommitSnapshotEffectsTimer();
            prepareForCommit(root.containerInfo);
            nextEffect = firstEffect;
            do {
              {
                invokeGuardedCallback(null, commitBeforeMutationEffects, null);
                if (hasCaughtError()) {
                  if (!(nextEffect !== null)) {
                    {
                      throw Error("Should be working on an effect.");
                    }
                  }
                  var error = clearCaughtError();
                  captureCommitPhaseError(nextEffect, error);
                  nextEffect = nextEffect.nextEffect;
                }
              }
            } while (nextEffect !== null);
            stopCommitSnapshotEffectsTimer();
            if (enableProfilerTimer) {
              recordCommitTime();
            }
            startCommitHostEffectsTimer();
            nextEffect = firstEffect;
            do {
              {
                invokeGuardedCallback(null, commitMutationEffects, null, root, renderPriorityLevel);
                if (hasCaughtError()) {
                  if (!(nextEffect !== null)) {
                    {
                      throw Error("Should be working on an effect.");
                    }
                  }
                  var _error = clearCaughtError();
                  captureCommitPhaseError(nextEffect, _error);
                  nextEffect = nextEffect.nextEffect;
                }
              }
            } while (nextEffect !== null);
            stopCommitHostEffectsTimer();
            resetAfterCommit(root.containerInfo);
            root.current = finishedWork;
            startCommitLifeCyclesTimer();
            nextEffect = firstEffect;
            do {
              {
                invokeGuardedCallback(null, commitLayoutEffects, null, root, expirationTime);
                if (hasCaughtError()) {
                  if (!(nextEffect !== null)) {
                    {
                      throw Error("Should be working on an effect.");
                    }
                  }
                  var _error2 = clearCaughtError();
                  captureCommitPhaseError(nextEffect, _error2);
                  nextEffect = nextEffect.nextEffect;
                }
              }
            } while (nextEffect !== null);
            stopCommitLifeCyclesTimer();
            nextEffect = null;
            requestPaint();
            if (enableSchedulerTracing) {
              popInteractions(prevInteractions);
            }
            executionContext = prevExecutionContext;
          } else {
            root.current = finishedWork;
            startCommitSnapshotEffectsTimer();
            stopCommitSnapshotEffectsTimer();
            if (enableProfilerTimer) {
              recordCommitTime();
            }
            startCommitHostEffectsTimer();
            stopCommitHostEffectsTimer();
            startCommitLifeCyclesTimer();
            stopCommitLifeCyclesTimer();
          }
          stopCommitTimer();
          var rootDidHavePassiveEffects = rootDoesHavePassiveEffects;
          if (rootDoesHavePassiveEffects) {
            rootDoesHavePassiveEffects = false;
            rootWithPendingPassiveEffects = root;
            pendingPassiveEffectsExpirationTime = expirationTime;
            pendingPassiveEffectsRenderPriority = renderPriorityLevel;
          } else {
            nextEffect = firstEffect;
            while (nextEffect !== null) {
              var nextNextEffect = nextEffect.nextEffect;
              nextEffect.nextEffect = null;
              nextEffect = nextNextEffect;
            }
          }
          var remainingExpirationTime2 = root.firstPendingTime;
          if (remainingExpirationTime2 !== NoWork) {
            if (enableSchedulerTracing) {
              if (spawnedWorkDuringRender !== null) {
                var expirationTimes = spawnedWorkDuringRender;
                spawnedWorkDuringRender = null;
                for (var i3 = 0; i3 < expirationTimes.length; i3++) {
                  scheduleInteractions(root, expirationTimes[i3], root.memoizedInteractions);
                }
              }
              schedulePendingInteractions(root, remainingExpirationTime2);
            }
          } else {
            legacyErrorBoundariesThatAlreadyFailed = null;
          }
          if (enableSchedulerTracing) {
            if (!rootDidHavePassiveEffects) {
              finishPendingInteractions(root, expirationTime);
            }
          }
          if (remainingExpirationTime2 === Sync) {
            if (root === rootWithNestedUpdates) {
              nestedUpdateCount++;
            } else {
              nestedUpdateCount = 0;
              rootWithNestedUpdates = root;
            }
          } else {
            nestedUpdateCount = 0;
          }
          onCommitRoot(finishedWork.stateNode, expirationTime);
          ensureRootIsScheduled(root);
          if (hasUncaughtError) {
            hasUncaughtError = false;
            var _error3 = firstUncaughtError;
            firstUncaughtError = null;
            throw _error3;
          }
          if ((executionContext & LegacyUnbatchedContext) !== NoContext) {
            return null;
          }
          flushSyncCallbackQueue();
          return null;
        }
        function commitBeforeMutationEffects() {
          while (nextEffect !== null) {
            var effectTag = nextEffect.effectTag;
            if ((effectTag & Snapshot) !== NoEffect) {
              setCurrentFiber(nextEffect);
              recordEffect();
              var current$$1 = nextEffect.alternate;
              commitBeforeMutationLifeCycles(current$$1, nextEffect);
              resetCurrentFiber();
            }
            if ((effectTag & Passive) !== NoEffect) {
              if (!rootDoesHavePassiveEffects) {
                rootDoesHavePassiveEffects = true;
                scheduleCallback(NormalPriority, function() {
                  flushPassiveEffects();
                  return null;
                });
              }
            }
            nextEffect = nextEffect.nextEffect;
          }
        }
        function commitMutationEffects(root, renderPriorityLevel) {
          while (nextEffect !== null) {
            setCurrentFiber(nextEffect);
            var effectTag = nextEffect.effectTag;
            if (effectTag & ContentReset) {
              commitResetTextContent(nextEffect);
            }
            if (effectTag & Ref) {
              var current$$1 = nextEffect.alternate;
              if (current$$1 !== null) {
                commitDetachRef(current$$1);
              }
            }
            var primaryEffectTag = effectTag & (Placement | Update | Deletion | Hydrating);
            switch (primaryEffectTag) {
              case Placement: {
                commitPlacement(nextEffect);
                nextEffect.effectTag &= ~Placement;
                break;
              }
              case PlacementAndUpdate: {
                commitPlacement(nextEffect);
                nextEffect.effectTag &= ~Placement;
                var _current = nextEffect.alternate;
                commitWork(_current, nextEffect);
                break;
              }
              case Hydrating: {
                nextEffect.effectTag &= ~Hydrating;
                break;
              }
              case HydratingAndUpdate: {
                nextEffect.effectTag &= ~Hydrating;
                var _current2 = nextEffect.alternate;
                commitWork(_current2, nextEffect);
                break;
              }
              case Update: {
                var _current3 = nextEffect.alternate;
                commitWork(_current3, nextEffect);
                break;
              }
              case Deletion: {
                commitDeletion(root, nextEffect, renderPriorityLevel);
                break;
              }
            }
            recordEffect();
            resetCurrentFiber();
            nextEffect = nextEffect.nextEffect;
          }
        }
        function commitLayoutEffects(root, committedExpirationTime) {
          while (nextEffect !== null) {
            setCurrentFiber(nextEffect);
            var effectTag = nextEffect.effectTag;
            if (effectTag & (Update | Callback)) {
              recordEffect();
              var current$$1 = nextEffect.alternate;
              commitLifeCycles(root, current$$1, nextEffect, committedExpirationTime);
            }
            if (effectTag & Ref) {
              recordEffect();
              commitAttachRef(nextEffect);
            }
            resetCurrentFiber();
            nextEffect = nextEffect.nextEffect;
          }
        }
        function flushPassiveEffects() {
          if (pendingPassiveEffectsRenderPriority !== NoPriority) {
            var priorityLevel = pendingPassiveEffectsRenderPriority > NormalPriority ? NormalPriority : pendingPassiveEffectsRenderPriority;
            pendingPassiveEffectsRenderPriority = NoPriority;
            return runWithPriority(priorityLevel, flushPassiveEffectsImpl);
          }
        }
        function flushPassiveEffectsImpl() {
          if (rootWithPendingPassiveEffects === null) {
            return false;
          }
          var root = rootWithPendingPassiveEffects;
          var expirationTime = pendingPassiveEffectsExpirationTime;
          rootWithPendingPassiveEffects = null;
          pendingPassiveEffectsExpirationTime = NoWork;
          if (!((executionContext & (RenderContext | CommitContext)) === NoContext)) {
            {
              throw Error("Cannot flush passive effects while already rendering.");
            }
          }
          var prevExecutionContext = executionContext;
          executionContext |= CommitContext;
          var prevInteractions = pushInteractions(root);
          var effect = root.current.firstEffect;
          while (effect !== null) {
            {
              setCurrentFiber(effect);
              invokeGuardedCallback(null, commitPassiveHookEffects, null, effect);
              if (hasCaughtError()) {
                if (!(effect !== null)) {
                  {
                    throw Error("Should be working on an effect.");
                  }
                }
                var error = clearCaughtError();
                captureCommitPhaseError(effect, error);
              }
              resetCurrentFiber();
            }
            var nextNextEffect = effect.nextEffect;
            effect.nextEffect = null;
            effect = nextNextEffect;
          }
          if (enableSchedulerTracing) {
            popInteractions(prevInteractions);
            finishPendingInteractions(root, expirationTime);
          }
          executionContext = prevExecutionContext;
          flushSyncCallbackQueue();
          nestedPassiveUpdateCount = rootWithPendingPassiveEffects === null ? 0 : nestedPassiveUpdateCount + 1;
          return true;
        }
        function isAlreadyFailedLegacyErrorBoundary(instance) {
          return legacyErrorBoundariesThatAlreadyFailed !== null && legacyErrorBoundariesThatAlreadyFailed.has(instance);
        }
        function markLegacyErrorBoundaryAsFailed(instance) {
          if (legacyErrorBoundariesThatAlreadyFailed === null) {
            legacyErrorBoundariesThatAlreadyFailed = /* @__PURE__ */ new Set([instance]);
          } else {
            legacyErrorBoundariesThatAlreadyFailed.add(instance);
          }
        }
        function prepareToThrowUncaughtError(error) {
          if (!hasUncaughtError) {
            hasUncaughtError = true;
            firstUncaughtError = error;
          }
        }
        var onUncaughtError = prepareToThrowUncaughtError;
        function captureCommitPhaseErrorOnRoot(rootFiber, sourceFiber, error) {
          var errorInfo = createCapturedValue(error, sourceFiber);
          var update = createRootErrorUpdate(rootFiber, errorInfo, Sync);
          enqueueUpdate(rootFiber, update);
          var root = markUpdateTimeFromFiberToRoot(rootFiber, Sync);
          if (root !== null) {
            ensureRootIsScheduled(root);
            schedulePendingInteractions(root, Sync);
          }
        }
        function captureCommitPhaseError(sourceFiber, error) {
          if (sourceFiber.tag === HostRoot) {
            captureCommitPhaseErrorOnRoot(sourceFiber, sourceFiber, error);
            return;
          }
          var fiber = sourceFiber.return;
          while (fiber !== null) {
            if (fiber.tag === HostRoot) {
              captureCommitPhaseErrorOnRoot(fiber, sourceFiber, error);
              return;
            } else if (fiber.tag === ClassComponent) {
              var ctor = fiber.type;
              var instance = fiber.stateNode;
              if (typeof ctor.getDerivedStateFromError === "function" || typeof instance.componentDidCatch === "function" && !isAlreadyFailedLegacyErrorBoundary(instance)) {
                var errorInfo = createCapturedValue(error, sourceFiber);
                var update = createClassErrorUpdate(fiber, errorInfo, Sync);
                enqueueUpdate(fiber, update);
                var root = markUpdateTimeFromFiberToRoot(fiber, Sync);
                if (root !== null) {
                  ensureRootIsScheduled(root);
                  schedulePendingInteractions(root, Sync);
                }
                return;
              }
            }
            fiber = fiber.return;
          }
        }
        function pingSuspendedRoot(root, thenable, suspendedTime) {
          var pingCache = root.pingCache;
          if (pingCache !== null) {
            pingCache.delete(thenable);
          }
          if (workInProgressRoot === root && renderExpirationTime === suspendedTime) {
            if (workInProgressRootExitStatus === RootSuspendedWithDelay || workInProgressRootExitStatus === RootSuspended && workInProgressRootLatestProcessedExpirationTime === Sync && now$1() - globalMostRecentFallbackTime < FALLBACK_THROTTLE_MS) {
              prepareFreshStack(root, renderExpirationTime);
            } else {
              workInProgressRootHasPendingPing = true;
            }
            return;
          }
          if (!isRootSuspendedAtTime(root, suspendedTime)) {
            return;
          }
          var lastPingedTime = root.lastPingedTime;
          if (lastPingedTime !== NoWork && lastPingedTime < suspendedTime) {
            return;
          }
          root.lastPingedTime = suspendedTime;
          if (root.finishedExpirationTime === suspendedTime) {
            root.finishedExpirationTime = NoWork;
            root.finishedWork = null;
          }
          ensureRootIsScheduled(root);
          schedulePendingInteractions(root, suspendedTime);
        }
        function retryTimedOutBoundary(boundaryFiber, retryTime) {
          if (retryTime === NoWork) {
            var suspenseConfig = null;
            var currentTime = requestCurrentTimeForUpdate();
            retryTime = computeExpirationForFiber(currentTime, boundaryFiber, suspenseConfig);
          }
          var root = markUpdateTimeFromFiberToRoot(boundaryFiber, retryTime);
          if (root !== null) {
            ensureRootIsScheduled(root);
            schedulePendingInteractions(root, retryTime);
          }
        }
        function retryDehydratedSuspenseBoundary(boundaryFiber) {
          var suspenseState = boundaryFiber.memoizedState;
          var retryTime = NoWork;
          if (suspenseState !== null) {
            retryTime = suspenseState.retryTime;
          }
          retryTimedOutBoundary(boundaryFiber, retryTime);
        }
        function resolveRetryThenable(boundaryFiber, thenable) {
          var retryTime = NoWork;
          var retryCache;
          if (enableSuspenseServerRenderer) {
            switch (boundaryFiber.tag) {
              case SuspenseComponent:
                retryCache = boundaryFiber.stateNode;
                var suspenseState = boundaryFiber.memoizedState;
                if (suspenseState !== null) {
                  retryTime = suspenseState.retryTime;
                }
                break;
              case SuspenseListComponent:
                retryCache = boundaryFiber.stateNode;
                break;
              default: {
                {
                  throw Error("Pinged unknown suspense boundary type. This is probably a bug in React.");
                }
              }
            }
          } else {
            retryCache = boundaryFiber.stateNode;
          }
          if (retryCache !== null) {
            retryCache.delete(thenable);
          }
          retryTimedOutBoundary(boundaryFiber, retryTime);
        }
        function jnd(timeElapsed) {
          return timeElapsed < 120 ? 120 : timeElapsed < 480 ? 480 : timeElapsed < 1080 ? 1080 : timeElapsed < 1920 ? 1920 : timeElapsed < 3e3 ? 3e3 : timeElapsed < 4320 ? 4320 : ceil(timeElapsed / 1960) * 1960;
        }
        function computeMsUntilSuspenseLoadingDelay(mostRecentEventTime, committedExpirationTime, suspenseConfig) {
          var busyMinDurationMs = suspenseConfig.busyMinDurationMs | 0;
          if (busyMinDurationMs <= 0) {
            return 0;
          }
          var busyDelayMs = suspenseConfig.busyDelayMs | 0;
          var currentTimeMs = now$1();
          var eventTimeMs = inferTimeFromExpirationTimeWithSuspenseConfig(mostRecentEventTime, suspenseConfig);
          var timeElapsed = currentTimeMs - eventTimeMs;
          if (timeElapsed <= busyDelayMs) {
            return 0;
          }
          var msUntilTimeout = busyDelayMs + busyMinDurationMs - timeElapsed;
          return msUntilTimeout;
        }
        function checkForNestedUpdates() {
          if (nestedUpdateCount > NESTED_UPDATE_LIMIT) {
            nestedUpdateCount = 0;
            rootWithNestedUpdates = null;
            {
              {
                throw Error("Maximum update depth exceeded. This can happen when a component repeatedly calls setState inside componentWillUpdate or componentDidUpdate. React limits the number of nested updates to prevent infinite loops.");
              }
            }
          }
          {
            if (nestedPassiveUpdateCount > NESTED_PASSIVE_UPDATE_LIMIT) {
              nestedPassiveUpdateCount = 0;
              warning$1(false, "Maximum update depth exceeded. This can happen when a component calls setState inside useEffect, but useEffect either doesn't have a dependency array, or one of the dependencies changes on every render.");
            }
          }
        }
        function flushRenderPhaseStrictModeWarningsInDEV() {
          {
            ReactStrictModeWarnings.flushLegacyContextWarning();
            if (warnAboutDeprecatedLifecycles) {
              ReactStrictModeWarnings.flushPendingUnsafeLifecycleWarnings();
            }
          }
        }
        function stopFinishedWorkLoopTimer() {
          var didCompleteRoot = true;
          stopWorkLoopTimer(interruptedBy, didCompleteRoot);
          interruptedBy = null;
        }
        function stopInterruptedWorkLoopTimer() {
          var didCompleteRoot = false;
          stopWorkLoopTimer(interruptedBy, didCompleteRoot);
          interruptedBy = null;
        }
        function checkForInterruption(fiberThatReceivedUpdate, updateExpirationTime) {
          if (enableUserTimingAPI && workInProgressRoot !== null && updateExpirationTime > renderExpirationTime) {
            interruptedBy = fiberThatReceivedUpdate;
          }
        }
        var didWarnStateUpdateForUnmountedComponent = null;
        function warnAboutUpdateOnUnmountedFiberInDEV(fiber) {
          {
            var tag = fiber.tag;
            if (tag !== HostRoot && tag !== ClassComponent && tag !== FunctionComponent && tag !== ForwardRef && tag !== MemoComponent && tag !== SimpleMemoComponent) {
              return;
            }
            var componentName = getComponentName(fiber.type) || "ReactComponent";
            if (didWarnStateUpdateForUnmountedComponent !== null) {
              if (didWarnStateUpdateForUnmountedComponent.has(componentName)) {
                return;
              }
              didWarnStateUpdateForUnmountedComponent.add(componentName);
            } else {
              didWarnStateUpdateForUnmountedComponent = /* @__PURE__ */ new Set([componentName]);
            }
            warningWithoutStack$1(false, "Can't perform a React state update on an unmounted component. This is a no-op, but it indicates a memory leak in your application. To fix, cancel all subscriptions and asynchronous tasks in %s.%s", tag === ClassComponent ? "the componentWillUnmount method" : "a useEffect cleanup function", getStackByFiberInDevAndProd(fiber));
          }
        }
        var beginWork$$1;
        if (replayFailedUnitOfWorkWithInvokeGuardedCallback) {
          var dummyFiber = null;
          beginWork$$1 = function(current$$1, unitOfWork, expirationTime) {
            var originalWorkInProgressCopy = assignFiberPropertiesInDEV(dummyFiber, unitOfWork);
            try {
              return beginWork$1(current$$1, unitOfWork, expirationTime);
            } catch (originalError) {
              if (originalError !== null && typeof originalError === "object" && typeof originalError.then === "function") {
                throw originalError;
              }
              resetContextDependencies();
              resetHooks();
              unwindInterruptedWork(unitOfWork);
              assignFiberPropertiesInDEV(unitOfWork, originalWorkInProgressCopy);
              if (enableProfilerTimer && unitOfWork.mode & ProfileMode) {
                startProfilerTimer(unitOfWork);
              }
              invokeGuardedCallback(null, beginWork$1, null, current$$1, unitOfWork, expirationTime);
              if (hasCaughtError()) {
                var replayError = clearCaughtError();
                throw replayError;
              } else {
                throw originalError;
              }
            }
          };
        } else {
          beginWork$$1 = beginWork$1;
        }
        var didWarnAboutUpdateInRender = false;
        var didWarnAboutUpdateInGetChildContext = false;
        function warnAboutInvalidUpdatesOnClassComponentsInDEV(fiber) {
          {
            if (fiber.tag === ClassComponent) {
              switch (phase) {
                case "getChildContext":
                  if (didWarnAboutUpdateInGetChildContext) {
                    return;
                  }
                  warningWithoutStack$1(false, "setState(...): Cannot call setState() inside getChildContext()");
                  didWarnAboutUpdateInGetChildContext = true;
                  break;
                case "render":
                  if (didWarnAboutUpdateInRender) {
                    return;
                  }
                  warningWithoutStack$1(false, "Cannot update during an existing state transition (such as within `render`). Render methods should be a pure function of props and state.");
                  didWarnAboutUpdateInRender = true;
                  break;
              }
            }
          }
        }
        var IsThisRendererActing = {
          current: false
        };
        function warnIfNotScopedWithMatchingAct(fiber) {
          {
            if (warnsIfNotActing === true && IsSomeRendererActing.current === true && IsThisRendererActing.current !== true) {
              warningWithoutStack$1(false, "It looks like you're using the wrong act() around your test interactions.\nBe sure to use the matching version of act() corresponding to your renderer:\n\n// for react-dom:\nimport {act} from 'react-dom/test-utils';\n// ...\nact(() => ...);\n\n// for react-test-renderer:\nimport TestRenderer from 'react-test-renderer';\nconst {act} = TestRenderer;\n// ...\nact(() => ...);%s", getStackByFiberInDevAndProd(fiber));
            }
          }
        }
        function warnIfNotCurrentlyActingEffectsInDEV(fiber) {
          {
            if (warnsIfNotActing === true && (fiber.mode & StrictMode) !== NoMode && IsSomeRendererActing.current === false && IsThisRendererActing.current === false) {
              warningWithoutStack$1(false, "An update to %s ran an effect, but was not wrapped in act(...).\n\nWhen testing, code that causes React state updates should be wrapped into act(...):\n\nact(() => {\n  /* fire events that update state */\n});\n/* assert on the output */\n\nThis ensures that you're testing the behavior the user would see in the browser. Learn more at https://fb.me/react-wrap-tests-with-act%s", getComponentName(fiber.type), getStackByFiberInDevAndProd(fiber));
            }
          }
        }
        function warnIfNotCurrentlyActingUpdatesInDEV(fiber) {
          {
            if (warnsIfNotActing === true && executionContext === NoContext && IsSomeRendererActing.current === false && IsThisRendererActing.current === false) {
              warningWithoutStack$1(false, "An update to %s inside a test was not wrapped in act(...).\n\nWhen testing, code that causes React state updates should be wrapped into act(...):\n\nact(() => {\n  /* fire events that update state */\n});\n/* assert on the output */\n\nThis ensures that you're testing the behavior the user would see in the browser. Learn more at https://fb.me/react-wrap-tests-with-act%s", getComponentName(fiber.type), getStackByFiberInDevAndProd(fiber));
            }
          }
        }
        var warnIfNotCurrentlyActingUpdatesInDev = warnIfNotCurrentlyActingUpdatesInDEV;
        var didWarnAboutUnmockedScheduler = false;
        function warnIfUnmockedScheduler(fiber) {
          {
            if (didWarnAboutUnmockedScheduler === false && Scheduler.unstable_flushAllWithoutAsserting === void 0) {
              if (fiber.mode & BlockingMode || fiber.mode & ConcurrentMode) {
                didWarnAboutUnmockedScheduler = true;
                warningWithoutStack$1(false, `In Concurrent or Sync modes, the "scheduler" module needs to be mocked to guarantee consistent behaviour across tests and browsers. For example, with jest: 
jest.mock('scheduler', () => require('scheduler/unstable_mock'));

For more info, visit https://fb.me/react-mock-scheduler`);
              } else if (warnAboutUnmockedScheduler === true) {
                didWarnAboutUnmockedScheduler = true;
                warningWithoutStack$1(false, `Starting from React v17, the "scheduler" module will need to be mocked to guarantee consistent behaviour across tests and browsers. For example, with jest: 
jest.mock('scheduler', () => require('scheduler/unstable_mock'));

For more info, visit https://fb.me/react-mock-scheduler`);
              }
            }
          }
        }
        var componentsThatTriggeredHighPriSuspend = null;
        function checkForWrongSuspensePriorityInDEV(sourceFiber) {
          {
            var currentPriorityLevel = getCurrentPriorityLevel();
            if ((sourceFiber.mode & ConcurrentMode) !== NoEffect && (currentPriorityLevel === UserBlockingPriority || currentPriorityLevel === ImmediatePriority)) {
              var workInProgressNode = sourceFiber;
              while (workInProgressNode !== null) {
                var current$$1 = workInProgressNode.alternate;
                if (current$$1 !== null) {
                  switch (workInProgressNode.tag) {
                    case ClassComponent:
                      var updateQueue = current$$1.updateQueue;
                      if (updateQueue !== null) {
                        var update = updateQueue.firstUpdate;
                        while (update !== null) {
                          var priorityLevel = update.priority;
                          if (priorityLevel === UserBlockingPriority || priorityLevel === ImmediatePriority) {
                            if (componentsThatTriggeredHighPriSuspend === null) {
                              componentsThatTriggeredHighPriSuspend = /* @__PURE__ */ new Set([getComponentName(workInProgressNode.type)]);
                            } else {
                              componentsThatTriggeredHighPriSuspend.add(getComponentName(workInProgressNode.type));
                            }
                            break;
                          }
                          update = update.next;
                        }
                      }
                      break;
                    case FunctionComponent:
                    case ForwardRef:
                    case SimpleMemoComponent:
                      if (workInProgressNode.memoizedState !== null && workInProgressNode.memoizedState.baseUpdate !== null) {
                        var _update = workInProgressNode.memoizedState.baseUpdate;
                        while (_update !== null) {
                          var priority = _update.priority;
                          if (priority === UserBlockingPriority || priority === ImmediatePriority) {
                            if (componentsThatTriggeredHighPriSuspend === null) {
                              componentsThatTriggeredHighPriSuspend = /* @__PURE__ */ new Set([getComponentName(workInProgressNode.type)]);
                            } else {
                              componentsThatTriggeredHighPriSuspend.add(getComponentName(workInProgressNode.type));
                            }
                            break;
                          }
                          if (_update.next === workInProgressNode.memoizedState.baseUpdate) {
                            break;
                          }
                          _update = _update.next;
                        }
                      }
                      break;
                    default:
                      break;
                  }
                }
                workInProgressNode = workInProgressNode.return;
              }
            }
          }
        }
        function flushSuspensePriorityWarningInDEV() {
          {
            if (componentsThatTriggeredHighPriSuspend !== null) {
              var componentNames = [];
              componentsThatTriggeredHighPriSuspend.forEach(function(name) {
                return componentNames.push(name);
              });
              componentsThatTriggeredHighPriSuspend = null;
              if (componentNames.length > 0) {
                warningWithoutStack$1(false, "%s triggered a user-blocking update that suspended.\n\nThe fix is to split the update into multiple parts: a user-blocking update to provide immediate feedback, and another update that triggers the bulk of the changes.\n\nRefer to the documentation for useTransition to learn how to implement this pattern.", componentNames.sort().join(", "));
              }
            }
          }
        }
        function computeThreadID(root, expirationTime) {
          return expirationTime * 1e3 + root.interactionThreadID;
        }
        function markSpawnedWork(expirationTime) {
          if (!enableSchedulerTracing) {
            return;
          }
          if (spawnedWorkDuringRender === null) {
            spawnedWorkDuringRender = [expirationTime];
          } else {
            spawnedWorkDuringRender.push(expirationTime);
          }
        }
        function scheduleInteractions(root, expirationTime, interactions) {
          if (!enableSchedulerTracing) {
            return;
          }
          if (interactions.size > 0) {
            var pendingInteractionMap = root.pendingInteractionMap;
            var pendingInteractions = pendingInteractionMap.get(expirationTime);
            if (pendingInteractions != null) {
              interactions.forEach(function(interaction) {
                if (!pendingInteractions.has(interaction)) {
                  interaction.__count++;
                }
                pendingInteractions.add(interaction);
              });
            } else {
              pendingInteractionMap.set(expirationTime, new Set(interactions));
              interactions.forEach(function(interaction) {
                interaction.__count++;
              });
            }
            var subscriber = tracing.__subscriberRef.current;
            if (subscriber !== null) {
              var threadID = computeThreadID(root, expirationTime);
              subscriber.onWorkScheduled(interactions, threadID);
            }
          }
        }
        function schedulePendingInteractions(root, expirationTime) {
          if (!enableSchedulerTracing) {
            return;
          }
          scheduleInteractions(root, expirationTime, tracing.__interactionsRef.current);
        }
        function startWorkOnPendingInteractions(root, expirationTime) {
          if (!enableSchedulerTracing) {
            return;
          }
          var interactions = /* @__PURE__ */ new Set();
          root.pendingInteractionMap.forEach(function(scheduledInteractions, scheduledExpirationTime) {
            if (scheduledExpirationTime >= expirationTime) {
              scheduledInteractions.forEach(function(interaction) {
                return interactions.add(interaction);
              });
            }
          });
          root.memoizedInteractions = interactions;
          if (interactions.size > 0) {
            var subscriber = tracing.__subscriberRef.current;
            if (subscriber !== null) {
              var threadID = computeThreadID(root, expirationTime);
              try {
                subscriber.onWorkStarted(interactions, threadID);
              } catch (error) {
                scheduleCallback(ImmediatePriority, function() {
                  throw error;
                });
              }
            }
          }
        }
        function finishPendingInteractions(root, committedExpirationTime) {
          if (!enableSchedulerTracing) {
            return;
          }
          var earliestRemainingTimeAfterCommit = root.firstPendingTime;
          var subscriber;
          try {
            subscriber = tracing.__subscriberRef.current;
            if (subscriber !== null && root.memoizedInteractions.size > 0) {
              var threadID = computeThreadID(root, committedExpirationTime);
              subscriber.onWorkStopped(root.memoizedInteractions, threadID);
            }
          } catch (error) {
            scheduleCallback(ImmediatePriority, function() {
              throw error;
            });
          } finally {
            var pendingInteractionMap = root.pendingInteractionMap;
            pendingInteractionMap.forEach(function(scheduledInteractions, scheduledExpirationTime) {
              if (scheduledExpirationTime > earliestRemainingTimeAfterCommit) {
                pendingInteractionMap.delete(scheduledExpirationTime);
                scheduledInteractions.forEach(function(interaction) {
                  interaction.__count--;
                  if (subscriber !== null && interaction.__count === 0) {
                    try {
                      subscriber.onInteractionScheduledWorkCompleted(interaction);
                    } catch (error) {
                      scheduleCallback(ImmediatePriority, function() {
                        throw error;
                      });
                    }
                  }
                });
              }
            });
          }
        }
        var onCommitFiberRoot = null;
        var onCommitFiberUnmount = null;
        var hasLoggedError = false;
        var isDevToolsPresent = typeof __REACT_DEVTOOLS_GLOBAL_HOOK__ !== "undefined";
        function injectInternals(internals) {
          if (typeof __REACT_DEVTOOLS_GLOBAL_HOOK__ === "undefined") {
            return false;
          }
          var hook = __REACT_DEVTOOLS_GLOBAL_HOOK__;
          if (hook.isDisabled) {
            return true;
          }
          if (!hook.supportsFiber) {
            {
              warningWithoutStack$1(false, "The installed version of React DevTools is too old and will not work with the current version of React. Please update React DevTools. https://fb.me/react-devtools");
            }
            return true;
          }
          try {
            var rendererID = hook.inject(internals);
            onCommitFiberRoot = function(root, expirationTime) {
              try {
                var didError = (root.current.effectTag & DidCapture) === DidCapture;
                if (enableProfilerTimer) {
                  var currentTime = getCurrentTime();
                  var priorityLevel = inferPriorityFromExpirationTime(currentTime, expirationTime);
                  hook.onCommitFiberRoot(rendererID, root, priorityLevel, didError);
                } else {
                  hook.onCommitFiberRoot(rendererID, root, void 0, didError);
                }
              } catch (err2) {
                if (!hasLoggedError) {
                  hasLoggedError = true;
                  warningWithoutStack$1(false, "React DevTools encountered an error: %s", err2);
                }
              }
            };
            onCommitFiberUnmount = function(fiber) {
              try {
                hook.onCommitFiberUnmount(rendererID, fiber);
              } catch (err2) {
                if (!hasLoggedError) {
                  hasLoggedError = true;
                  warningWithoutStack$1(false, "React DevTools encountered an error: %s", err2);
                }
              }
            };
          } catch (err2) {
            {
              warningWithoutStack$1(false, "React DevTools encountered an error: %s.", err2);
            }
          }
          return true;
        }
        function onCommitRoot(root, expirationTime) {
          if (typeof onCommitFiberRoot === "function") {
            onCommitFiberRoot(root, expirationTime);
          }
        }
        function onCommitUnmount(fiber) {
          if (typeof onCommitFiberUnmount === "function") {
            onCommitFiberUnmount(fiber);
          }
        }
        var hasBadMapPolyfill;
        {
          hasBadMapPolyfill = false;
          try {
            var nonExtensibleObject = Object.preventExtensions({});
            var testMap = /* @__PURE__ */ new Map([[nonExtensibleObject, null]]);
            var testSet = /* @__PURE__ */ new Set([nonExtensibleObject]);
            testMap.set(0, 0);
            testSet.add(0);
          } catch (e2) {
            hasBadMapPolyfill = true;
          }
        }
        var debugCounter = 1;
        function FiberNode(tag, pendingProps, key2, mode) {
          this.tag = tag;
          this.key = key2;
          this.elementType = null;
          this.type = null;
          this.stateNode = null;
          this.return = null;
          this.child = null;
          this.sibling = null;
          this.index = 0;
          this.ref = null;
          this.pendingProps = pendingProps;
          this.memoizedProps = null;
          this.updateQueue = null;
          this.memoizedState = null;
          this.dependencies = null;
          this.mode = mode;
          this.effectTag = NoEffect;
          this.nextEffect = null;
          this.firstEffect = null;
          this.lastEffect = null;
          this.expirationTime = NoWork;
          this.childExpirationTime = NoWork;
          this.alternate = null;
          if (enableProfilerTimer) {
            this.actualDuration = Number.NaN;
            this.actualStartTime = Number.NaN;
            this.selfBaseDuration = Number.NaN;
            this.treeBaseDuration = Number.NaN;
            this.actualDuration = 0;
            this.actualStartTime = -1;
            this.selfBaseDuration = 0;
            this.treeBaseDuration = 0;
          }
          if (enableUserTimingAPI) {
            this._debugID = debugCounter++;
            this._debugIsCurrentlyTiming = false;
          }
          {
            this._debugSource = null;
            this._debugOwner = null;
            this._debugNeedsRemount = false;
            this._debugHookTypes = null;
            if (!hasBadMapPolyfill && typeof Object.preventExtensions === "function") {
              Object.preventExtensions(this);
            }
          }
        }
        var createFiber = function(tag, pendingProps, key2, mode) {
          return new FiberNode(tag, pendingProps, key2, mode);
        };
        function shouldConstruct(Component) {
          var prototype = Component.prototype;
          return !!(prototype && prototype.isReactComponent);
        }
        function isSimpleFunctionComponent(type3) {
          return typeof type3 === "function" && !shouldConstruct(type3) && type3.defaultProps === void 0;
        }
        function resolveLazyComponentTag(Component) {
          if (typeof Component === "function") {
            return shouldConstruct(Component) ? ClassComponent : FunctionComponent;
          } else if (Component !== void 0 && Component !== null) {
            var $$typeof = Component.$$typeof;
            if ($$typeof === REACT_FORWARD_REF_TYPE) {
              return ForwardRef;
            }
            if ($$typeof === REACT_MEMO_TYPE) {
              return MemoComponent;
            }
          }
          return IndeterminateComponent;
        }
        function createWorkInProgress(current2, pendingProps, expirationTime) {
          var workInProgress2 = current2.alternate;
          if (workInProgress2 === null) {
            workInProgress2 = createFiber(current2.tag, pendingProps, current2.key, current2.mode);
            workInProgress2.elementType = current2.elementType;
            workInProgress2.type = current2.type;
            workInProgress2.stateNode = current2.stateNode;
            {
              workInProgress2._debugID = current2._debugID;
              workInProgress2._debugSource = current2._debugSource;
              workInProgress2._debugOwner = current2._debugOwner;
              workInProgress2._debugHookTypes = current2._debugHookTypes;
            }
            workInProgress2.alternate = current2;
            current2.alternate = workInProgress2;
          } else {
            workInProgress2.pendingProps = pendingProps;
            workInProgress2.effectTag = NoEffect;
            workInProgress2.nextEffect = null;
            workInProgress2.firstEffect = null;
            workInProgress2.lastEffect = null;
            if (enableProfilerTimer) {
              workInProgress2.actualDuration = 0;
              workInProgress2.actualStartTime = -1;
            }
          }
          workInProgress2.childExpirationTime = current2.childExpirationTime;
          workInProgress2.expirationTime = current2.expirationTime;
          workInProgress2.child = current2.child;
          workInProgress2.memoizedProps = current2.memoizedProps;
          workInProgress2.memoizedState = current2.memoizedState;
          workInProgress2.updateQueue = current2.updateQueue;
          var currentDependencies = current2.dependencies;
          workInProgress2.dependencies = currentDependencies === null ? null : {
            expirationTime: currentDependencies.expirationTime,
            firstContext: currentDependencies.firstContext,
            responders: currentDependencies.responders
          };
          workInProgress2.sibling = current2.sibling;
          workInProgress2.index = current2.index;
          workInProgress2.ref = current2.ref;
          if (enableProfilerTimer) {
            workInProgress2.selfBaseDuration = current2.selfBaseDuration;
            workInProgress2.treeBaseDuration = current2.treeBaseDuration;
          }
          {
            workInProgress2._debugNeedsRemount = current2._debugNeedsRemount;
            switch (workInProgress2.tag) {
              case IndeterminateComponent:
              case FunctionComponent:
              case SimpleMemoComponent:
                workInProgress2.type = resolveFunctionForHotReloading(current2.type);
                break;
              case ClassComponent:
                workInProgress2.type = resolveClassForHotReloading(current2.type);
                break;
              case ForwardRef:
                workInProgress2.type = resolveForwardRefForHotReloading(current2.type);
                break;
              default:
                break;
            }
          }
          return workInProgress2;
        }
        function resetWorkInProgress(workInProgress2, renderExpirationTime2) {
          workInProgress2.effectTag &= Placement;
          workInProgress2.nextEffect = null;
          workInProgress2.firstEffect = null;
          workInProgress2.lastEffect = null;
          var current2 = workInProgress2.alternate;
          if (current2 === null) {
            workInProgress2.childExpirationTime = NoWork;
            workInProgress2.expirationTime = renderExpirationTime2;
            workInProgress2.child = null;
            workInProgress2.memoizedProps = null;
            workInProgress2.memoizedState = null;
            workInProgress2.updateQueue = null;
            workInProgress2.dependencies = null;
            if (enableProfilerTimer) {
              workInProgress2.selfBaseDuration = 0;
              workInProgress2.treeBaseDuration = 0;
            }
          } else {
            workInProgress2.childExpirationTime = current2.childExpirationTime;
            workInProgress2.expirationTime = current2.expirationTime;
            workInProgress2.child = current2.child;
            workInProgress2.memoizedProps = current2.memoizedProps;
            workInProgress2.memoizedState = current2.memoizedState;
            workInProgress2.updateQueue = current2.updateQueue;
            var currentDependencies = current2.dependencies;
            workInProgress2.dependencies = currentDependencies === null ? null : {
              expirationTime: currentDependencies.expirationTime,
              firstContext: currentDependencies.firstContext,
              responders: currentDependencies.responders
            };
            if (enableProfilerTimer) {
              workInProgress2.selfBaseDuration = current2.selfBaseDuration;
              workInProgress2.treeBaseDuration = current2.treeBaseDuration;
            }
          }
          return workInProgress2;
        }
        function createHostRootFiber(tag) {
          var mode;
          if (tag === ConcurrentRoot) {
            mode = ConcurrentMode | BlockingMode | StrictMode;
          } else if (tag === BlockingRoot) {
            mode = BlockingMode | StrictMode;
          } else {
            mode = NoMode;
          }
          if (enableProfilerTimer && isDevToolsPresent) {
            mode |= ProfileMode;
          }
          return createFiber(HostRoot, null, null, mode);
        }
        function createFiberFromTypeAndProps(type3, key2, pendingProps, owner, mode, expirationTime) {
          var fiber;
          var fiberTag = IndeterminateComponent;
          var resolvedType = type3;
          if (typeof type3 === "function") {
            if (shouldConstruct(type3)) {
              fiberTag = ClassComponent;
              {
                resolvedType = resolveClassForHotReloading(resolvedType);
              }
            } else {
              {
                resolvedType = resolveFunctionForHotReloading(resolvedType);
              }
            }
          } else if (typeof type3 === "string") {
            fiberTag = HostComponent;
          } else {
            getTag:
              switch (type3) {
                case REACT_FRAGMENT_TYPE:
                  return createFiberFromFragment(pendingProps.children, mode, expirationTime, key2);
                case REACT_CONCURRENT_MODE_TYPE:
                  fiberTag = Mode;
                  mode |= ConcurrentMode | BlockingMode | StrictMode;
                  break;
                case REACT_STRICT_MODE_TYPE:
                  fiberTag = Mode;
                  mode |= StrictMode;
                  break;
                case REACT_PROFILER_TYPE:
                  return createFiberFromProfiler(pendingProps, mode, expirationTime, key2);
                case REACT_SUSPENSE_TYPE:
                  return createFiberFromSuspense(pendingProps, mode, expirationTime, key2);
                case REACT_SUSPENSE_LIST_TYPE:
                  return createFiberFromSuspenseList(pendingProps, mode, expirationTime, key2);
                default: {
                  if (typeof type3 === "object" && type3 !== null) {
                    switch (type3.$$typeof) {
                      case REACT_PROVIDER_TYPE:
                        fiberTag = ContextProvider;
                        break getTag;
                      case REACT_CONTEXT_TYPE:
                        fiberTag = ContextConsumer;
                        break getTag;
                      case REACT_FORWARD_REF_TYPE:
                        fiberTag = ForwardRef;
                        {
                          resolvedType = resolveForwardRefForHotReloading(resolvedType);
                        }
                        break getTag;
                      case REACT_MEMO_TYPE:
                        fiberTag = MemoComponent;
                        break getTag;
                      case REACT_LAZY_TYPE:
                        fiberTag = LazyComponent;
                        resolvedType = null;
                        break getTag;
                      case REACT_FUNDAMENTAL_TYPE:
                        if (enableFundamentalAPI) {
                          return createFiberFromFundamental(type3, pendingProps, mode, expirationTime, key2);
                        }
                        break;
                      case REACT_SCOPE_TYPE:
                        if (enableScopeAPI) {
                          return createFiberFromScope(type3, pendingProps, mode, expirationTime, key2);
                        }
                    }
                  }
                  var info = "";
                  {
                    if (type3 === void 0 || typeof type3 === "object" && type3 !== null && Object.keys(type3).length === 0) {
                      info += " You likely forgot to export your component from the file it's defined in, or you might have mixed up default and named imports.";
                    }
                    var ownerName = owner ? getComponentName(owner.type) : null;
                    if (ownerName) {
                      info += "\n\nCheck the render method of `" + ownerName + "`.";
                    }
                  }
                  {
                    {
                      throw Error("Element type is invalid: expected a string (for built-in components) or a class/function (for composite components) but got: " + (type3 == null ? type3 : typeof type3) + "." + info);
                    }
                  }
                }
              }
          }
          fiber = createFiber(fiberTag, pendingProps, key2, mode);
          fiber.elementType = type3;
          fiber.type = resolvedType;
          fiber.expirationTime = expirationTime;
          return fiber;
        }
        function createFiberFromElement(element, mode, expirationTime) {
          var owner = null;
          {
            owner = element._owner;
          }
          var type3 = element.type;
          var key2 = element.key;
          var pendingProps = element.props;
          var fiber = createFiberFromTypeAndProps(type3, key2, pendingProps, owner, mode, expirationTime);
          {
            fiber._debugSource = element._source;
            fiber._debugOwner = element._owner;
          }
          return fiber;
        }
        function createFiberFromFragment(elements, mode, expirationTime, key2) {
          var fiber = createFiber(Fragment, elements, key2, mode);
          fiber.expirationTime = expirationTime;
          return fiber;
        }
        function createFiberFromFundamental(fundamentalComponent, pendingProps, mode, expirationTime, key2) {
          var fiber = createFiber(FundamentalComponent, pendingProps, key2, mode);
          fiber.elementType = fundamentalComponent;
          fiber.type = fundamentalComponent;
          fiber.expirationTime = expirationTime;
          return fiber;
        }
        function createFiberFromScope(scope, pendingProps, mode, expirationTime, key2) {
          var fiber = createFiber(ScopeComponent, pendingProps, key2, mode);
          fiber.type = scope;
          fiber.elementType = scope;
          fiber.expirationTime = expirationTime;
          return fiber;
        }
        function createFiberFromProfiler(pendingProps, mode, expirationTime, key2) {
          {
            if (typeof pendingProps.id !== "string" || typeof pendingProps.onRender !== "function") {
              warningWithoutStack$1(false, 'Profiler must specify an "id" string and "onRender" function as props');
            }
          }
          var fiber = createFiber(Profiler, pendingProps, key2, mode | ProfileMode);
          fiber.elementType = REACT_PROFILER_TYPE;
          fiber.type = REACT_PROFILER_TYPE;
          fiber.expirationTime = expirationTime;
          return fiber;
        }
        function createFiberFromSuspense(pendingProps, mode, expirationTime, key2) {
          var fiber = createFiber(SuspenseComponent, pendingProps, key2, mode);
          fiber.type = REACT_SUSPENSE_TYPE;
          fiber.elementType = REACT_SUSPENSE_TYPE;
          fiber.expirationTime = expirationTime;
          return fiber;
        }
        function createFiberFromSuspenseList(pendingProps, mode, expirationTime, key2) {
          var fiber = createFiber(SuspenseListComponent, pendingProps, key2, mode);
          {
            fiber.type = REACT_SUSPENSE_LIST_TYPE;
          }
          fiber.elementType = REACT_SUSPENSE_LIST_TYPE;
          fiber.expirationTime = expirationTime;
          return fiber;
        }
        function createFiberFromText(content, mode, expirationTime) {
          var fiber = createFiber(HostText, content, null, mode);
          fiber.expirationTime = expirationTime;
          return fiber;
        }
        function createFiberFromHostInstanceForDeletion() {
          var fiber = createFiber(HostComponent, null, null, NoMode);
          fiber.elementType = "DELETED";
          fiber.type = "DELETED";
          return fiber;
        }
        function createFiberFromDehydratedFragment(dehydratedNode) {
          var fiber = createFiber(DehydratedFragment, null, null, NoMode);
          fiber.stateNode = dehydratedNode;
          return fiber;
        }
        function createFiberFromPortal(portal, mode, expirationTime) {
          var pendingProps = portal.children !== null ? portal.children : [];
          var fiber = createFiber(HostPortal, pendingProps, portal.key, mode);
          fiber.expirationTime = expirationTime;
          fiber.stateNode = {
            containerInfo: portal.containerInfo,
            pendingChildren: null,
            implementation: portal.implementation
          };
          return fiber;
        }
        function assignFiberPropertiesInDEV(target, source) {
          if (target === null) {
            target = createFiber(IndeterminateComponent, null, null, NoMode);
          }
          target.tag = source.tag;
          target.key = source.key;
          target.elementType = source.elementType;
          target.type = source.type;
          target.stateNode = source.stateNode;
          target.return = source.return;
          target.child = source.child;
          target.sibling = source.sibling;
          target.index = source.index;
          target.ref = source.ref;
          target.pendingProps = source.pendingProps;
          target.memoizedProps = source.memoizedProps;
          target.updateQueue = source.updateQueue;
          target.memoizedState = source.memoizedState;
          target.dependencies = source.dependencies;
          target.mode = source.mode;
          target.effectTag = source.effectTag;
          target.nextEffect = source.nextEffect;
          target.firstEffect = source.firstEffect;
          target.lastEffect = source.lastEffect;
          target.expirationTime = source.expirationTime;
          target.childExpirationTime = source.childExpirationTime;
          target.alternate = source.alternate;
          if (enableProfilerTimer) {
            target.actualDuration = source.actualDuration;
            target.actualStartTime = source.actualStartTime;
            target.selfBaseDuration = source.selfBaseDuration;
            target.treeBaseDuration = source.treeBaseDuration;
          }
          target._debugID = source._debugID;
          target._debugSource = source._debugSource;
          target._debugOwner = source._debugOwner;
          target._debugIsCurrentlyTiming = source._debugIsCurrentlyTiming;
          target._debugNeedsRemount = source._debugNeedsRemount;
          target._debugHookTypes = source._debugHookTypes;
          return target;
        }
        function FiberRootNode(containerInfo, tag, hydrate) {
          this.tag = tag;
          this.current = null;
          this.containerInfo = containerInfo;
          this.pendingChildren = null;
          this.pingCache = null;
          this.finishedExpirationTime = NoWork;
          this.finishedWork = null;
          this.timeoutHandle = noTimeout;
          this.context = null;
          this.pendingContext = null;
          this.hydrate = hydrate;
          this.callbackNode = null;
          this.callbackPriority = NoPriority;
          this.firstPendingTime = NoWork;
          this.firstSuspendedTime = NoWork;
          this.lastSuspendedTime = NoWork;
          this.nextKnownPendingLevel = NoWork;
          this.lastPingedTime = NoWork;
          this.lastExpiredTime = NoWork;
          if (enableSchedulerTracing) {
            this.interactionThreadID = tracing.unstable_getThreadID();
            this.memoizedInteractions = /* @__PURE__ */ new Set();
            this.pendingInteractionMap = /* @__PURE__ */ new Map();
          }
          if (enableSuspenseCallback) {
            this.hydrationCallbacks = null;
          }
        }
        function createFiberRoot(containerInfo, tag, hydrate, hydrationCallbacks) {
          var root = new FiberRootNode(containerInfo, tag, hydrate);
          if (enableSuspenseCallback) {
            root.hydrationCallbacks = hydrationCallbacks;
          }
          var uninitializedFiber = createHostRootFiber(tag);
          root.current = uninitializedFiber;
          uninitializedFiber.stateNode = root;
          return root;
        }
        function isRootSuspendedAtTime(root, expirationTime) {
          var firstSuspendedTime = root.firstSuspendedTime;
          var lastSuspendedTime = root.lastSuspendedTime;
          return firstSuspendedTime !== NoWork && firstSuspendedTime >= expirationTime && lastSuspendedTime <= expirationTime;
        }
        function markRootSuspendedAtTime(root, expirationTime) {
          var firstSuspendedTime = root.firstSuspendedTime;
          var lastSuspendedTime = root.lastSuspendedTime;
          if (firstSuspendedTime < expirationTime) {
            root.firstSuspendedTime = expirationTime;
          }
          if (lastSuspendedTime > expirationTime || firstSuspendedTime === NoWork) {
            root.lastSuspendedTime = expirationTime;
          }
          if (expirationTime <= root.lastPingedTime) {
            root.lastPingedTime = NoWork;
          }
          if (expirationTime <= root.lastExpiredTime) {
            root.lastExpiredTime = NoWork;
          }
        }
        function markRootUpdatedAtTime(root, expirationTime) {
          var firstPendingTime = root.firstPendingTime;
          if (expirationTime > firstPendingTime) {
            root.firstPendingTime = expirationTime;
          }
          var firstSuspendedTime = root.firstSuspendedTime;
          if (firstSuspendedTime !== NoWork) {
            if (expirationTime >= firstSuspendedTime) {
              root.firstSuspendedTime = root.lastSuspendedTime = root.nextKnownPendingLevel = NoWork;
            } else if (expirationTime >= root.lastSuspendedTime) {
              root.lastSuspendedTime = expirationTime + 1;
            }
            if (expirationTime > root.nextKnownPendingLevel) {
              root.nextKnownPendingLevel = expirationTime;
            }
          }
        }
        function markRootFinishedAtTime(root, finishedExpirationTime, remainingExpirationTime2) {
          root.firstPendingTime = remainingExpirationTime2;
          if (finishedExpirationTime <= root.lastSuspendedTime) {
            root.firstSuspendedTime = root.lastSuspendedTime = root.nextKnownPendingLevel = NoWork;
          } else if (finishedExpirationTime <= root.firstSuspendedTime) {
            root.firstSuspendedTime = finishedExpirationTime - 1;
          }
          if (finishedExpirationTime <= root.lastPingedTime) {
            root.lastPingedTime = NoWork;
          }
          if (finishedExpirationTime <= root.lastExpiredTime) {
            root.lastExpiredTime = NoWork;
          }
        }
        function markRootExpiredAtTime(root, expirationTime) {
          var lastExpiredTime = root.lastExpiredTime;
          if (lastExpiredTime === NoWork || lastExpiredTime > expirationTime) {
            root.lastExpiredTime = expirationTime;
          }
        }
        var ReactFiberInstrumentation = {
          debugTool: null
        };
        var ReactFiberInstrumentation_1 = ReactFiberInstrumentation;
        var didWarnAboutNestedUpdates;
        var didWarnAboutFindNodeInStrictMode;
        {
          didWarnAboutNestedUpdates = false;
          didWarnAboutFindNodeInStrictMode = {};
        }
        function getContextForSubtree(parentComponent) {
          if (!parentComponent) {
            return emptyContextObject;
          }
          var fiber = get(parentComponent);
          var parentContext = findCurrentUnmaskedContext(fiber);
          if (fiber.tag === ClassComponent) {
            var Component = fiber.type;
            if (isContextProvider(Component)) {
              return processChildContext(fiber, Component, parentContext);
            }
          }
          return parentContext;
        }
        function findHostInstance(component) {
          var fiber = get(component);
          if (fiber === void 0) {
            if (typeof component.render === "function") {
              {
                {
                  throw Error("Unable to find node on an unmounted component.");
                }
              }
            } else {
              {
                {
                  throw Error("Argument appears to not be a ReactComponent. Keys: " + Object.keys(component));
                }
              }
            }
          }
          var hostFiber = findCurrentHostFiber(fiber);
          if (hostFiber === null) {
            return null;
          }
          return hostFiber.stateNode;
        }
        function findHostInstanceWithWarning(component, methodName) {
          {
            var fiber = get(component);
            if (fiber === void 0) {
              if (typeof component.render === "function") {
                {
                  {
                    throw Error("Unable to find node on an unmounted component.");
                  }
                }
              } else {
                {
                  {
                    throw Error("Argument appears to not be a ReactComponent. Keys: " + Object.keys(component));
                  }
                }
              }
            }
            var hostFiber = findCurrentHostFiber(fiber);
            if (hostFiber === null) {
              return null;
            }
            if (hostFiber.mode & StrictMode) {
              var componentName = getComponentName(fiber.type) || "Component";
              if (!didWarnAboutFindNodeInStrictMode[componentName]) {
                didWarnAboutFindNodeInStrictMode[componentName] = true;
                if (fiber.mode & StrictMode) {
                  warningWithoutStack$1(false, "%s is deprecated in StrictMode. %s was passed an instance of %s which is inside StrictMode. Instead, add a ref directly to the element you want to reference. Learn more about using refs safely here: https://fb.me/react-strict-mode-find-node%s", methodName, methodName, componentName, getStackByFiberInDevAndProd(hostFiber));
                } else {
                  warningWithoutStack$1(false, "%s is deprecated in StrictMode. %s was passed an instance of %s which renders StrictMode children. Instead, add a ref directly to the element you want to reference. Learn more about using refs safely here: https://fb.me/react-strict-mode-find-node%s", methodName, methodName, componentName, getStackByFiberInDevAndProd(hostFiber));
                }
              }
            }
            return hostFiber.stateNode;
          }
          return findHostInstance(component);
        }
        function createContainer(containerInfo, tag, hydrate, hydrationCallbacks) {
          return createFiberRoot(containerInfo, tag, hydrate, hydrationCallbacks);
        }
        function updateContainer(element, container, parentComponent, callback) {
          var current$$1 = container.current;
          var currentTime = requestCurrentTimeForUpdate();
          {
            if (typeof jest !== "undefined") {
              warnIfUnmockedScheduler(current$$1);
              warnIfNotScopedWithMatchingAct(current$$1);
            }
          }
          var suspenseConfig = requestCurrentSuspenseConfig();
          var expirationTime = computeExpirationForFiber(currentTime, current$$1, suspenseConfig);
          {
            if (ReactFiberInstrumentation_1.debugTool) {
              if (current$$1.alternate === null) {
                ReactFiberInstrumentation_1.debugTool.onMountContainer(container);
              } else if (element === null) {
                ReactFiberInstrumentation_1.debugTool.onUnmountContainer(container);
              } else {
                ReactFiberInstrumentation_1.debugTool.onUpdateContainer(container);
              }
            }
          }
          var context = getContextForSubtree(parentComponent);
          if (container.context === null) {
            container.context = context;
          } else {
            container.pendingContext = context;
          }
          {
            if (phase === "render" && current !== null && !didWarnAboutNestedUpdates) {
              didWarnAboutNestedUpdates = true;
              warningWithoutStack$1(false, "Render methods should be a pure function of props and state; triggering nested component updates from render is not allowed. If necessary, trigger nested updates in componentDidUpdate.\n\nCheck the render method of %s.", getComponentName(current.type) || "Unknown");
            }
          }
          var update = createUpdate(expirationTime, suspenseConfig);
          update.payload = {
            element
          };
          callback = callback === void 0 ? null : callback;
          if (callback !== null) {
            !(typeof callback === "function") ? warningWithoutStack$1(false, "render(...): Expected the last optional `callback` argument to be a function. Instead received: %s.", callback) : void 0;
            update.callback = callback;
          }
          enqueueUpdate(current$$1, update);
          scheduleWork(current$$1, expirationTime);
          return expirationTime;
        }
        function getPublicRootInstance(container) {
          var containerFiber = container.current;
          if (!containerFiber.child) {
            return null;
          }
          switch (containerFiber.child.tag) {
            case HostComponent:
              return getPublicInstance(containerFiber.child.stateNode);
            default:
              return containerFiber.child.stateNode;
          }
        }
        function attemptSynchronousHydration(fiber) {
          switch (fiber.tag) {
            case HostRoot:
              var root = fiber.stateNode;
              if (root.hydrate) {
                flushRoot(root, root.firstPendingTime);
              }
              break;
            case SuspenseComponent:
              flushSync(function() {
                return scheduleWork(fiber, Sync);
              });
              var retryExpTime = computeInteractiveExpiration(requestCurrentTimeForUpdate());
              markRetryTimeIfNotHydrated(fiber, retryExpTime);
              break;
          }
        }
        function markRetryTimeImpl(fiber, retryTime) {
          var suspenseState = fiber.memoizedState;
          if (suspenseState !== null && suspenseState.dehydrated !== null) {
            if (suspenseState.retryTime < retryTime) {
              suspenseState.retryTime = retryTime;
            }
          }
        }
        function markRetryTimeIfNotHydrated(fiber, retryTime) {
          markRetryTimeImpl(fiber, retryTime);
          var alternate = fiber.alternate;
          if (alternate) {
            markRetryTimeImpl(alternate, retryTime);
          }
        }
        function attemptUserBlockingHydration(fiber) {
          if (fiber.tag !== SuspenseComponent) {
            return;
          }
          var expTime = computeInteractiveExpiration(requestCurrentTimeForUpdate());
          scheduleWork(fiber, expTime);
          markRetryTimeIfNotHydrated(fiber, expTime);
        }
        function attemptContinuousHydration(fiber) {
          if (fiber.tag !== SuspenseComponent) {
            return;
          }
          var expTime = computeContinuousHydrationExpiration(requestCurrentTimeForUpdate());
          scheduleWork(fiber, expTime);
          markRetryTimeIfNotHydrated(fiber, expTime);
        }
        function attemptHydrationAtCurrentPriority(fiber) {
          if (fiber.tag !== SuspenseComponent) {
            return;
          }
          var currentTime = requestCurrentTimeForUpdate();
          var expTime = computeExpirationForFiber(currentTime, fiber, null);
          scheduleWork(fiber, expTime);
          markRetryTimeIfNotHydrated(fiber, expTime);
        }
        function findHostInstanceWithNoPortals(fiber) {
          var hostFiber = findCurrentHostFiberWithNoPortals(fiber);
          if (hostFiber === null) {
            return null;
          }
          if (hostFiber.tag === FundamentalComponent) {
            return hostFiber.stateNode.instance;
          }
          return hostFiber.stateNode;
        }
        var shouldSuspendImpl = function(fiber) {
          return false;
        };
        function shouldSuspend(fiber) {
          return shouldSuspendImpl(fiber);
        }
        var overrideHookState = null;
        var overrideProps = null;
        var scheduleUpdate = null;
        var setSuspenseHandler = null;
        {
          var copyWithSetImpl = function(obj, path2, idx, value) {
            if (idx >= path2.length) {
              return value;
            }
            var key2 = path2[idx];
            var updated = Array.isArray(obj) ? obj.slice() : _assign({}, obj);
            updated[key2] = copyWithSetImpl(obj[key2], path2, idx + 1, value);
            return updated;
          };
          var copyWithSet = function(obj, path2, value) {
            return copyWithSetImpl(obj, path2, 0, value);
          };
          overrideHookState = function(fiber, id, path2, value) {
            var currentHook2 = fiber.memoizedState;
            while (currentHook2 !== null && id > 0) {
              currentHook2 = currentHook2.next;
              id--;
            }
            if (currentHook2 !== null) {
              var newState = copyWithSet(currentHook2.memoizedState, path2, value);
              currentHook2.memoizedState = newState;
              currentHook2.baseState = newState;
              fiber.memoizedProps = _assign({}, fiber.memoizedProps);
              scheduleWork(fiber, Sync);
            }
          };
          overrideProps = function(fiber, path2, value) {
            fiber.pendingProps = copyWithSet(fiber.memoizedProps, path2, value);
            if (fiber.alternate) {
              fiber.alternate.pendingProps = fiber.pendingProps;
            }
            scheduleWork(fiber, Sync);
          };
          scheduleUpdate = function(fiber) {
            scheduleWork(fiber, Sync);
          };
          setSuspenseHandler = function(newShouldSuspendImpl) {
            shouldSuspendImpl = newShouldSuspendImpl;
          };
        }
        function injectIntoDevTools(devToolsConfig) {
          var findFiberByHostInstance = devToolsConfig.findFiberByHostInstance;
          var ReactCurrentDispatcher2 = ReactSharedInternals.ReactCurrentDispatcher;
          return injectInternals(_assign({}, devToolsConfig, {
            overrideHookState,
            overrideProps,
            setSuspenseHandler,
            scheduleUpdate,
            currentDispatcherRef: ReactCurrentDispatcher2,
            findHostInstanceByFiber: function(fiber) {
              var hostFiber = findCurrentHostFiber(fiber);
              if (hostFiber === null) {
                return null;
              }
              return hostFiber.stateNode;
            },
            findFiberByHostInstance: function(instance) {
              if (!findFiberByHostInstance) {
                return null;
              }
              return findFiberByHostInstance(instance);
            },
            findHostInstancesForRefresh,
            scheduleRefresh,
            scheduleRoot,
            setRefreshHandler,
            getCurrentFiber: function() {
              return current;
            }
          }));
        }
        var ReactFiberReconciler = Object.freeze({
          createContainer,
          updateContainer,
          batchedEventUpdates,
          batchedUpdates,
          unbatchedUpdates,
          deferredUpdates,
          syncUpdates,
          discreteUpdates,
          flushDiscreteUpdates,
          flushControlled,
          flushSync,
          flushPassiveEffects,
          IsThisRendererActing,
          getPublicRootInstance,
          attemptSynchronousHydration,
          attemptUserBlockingHydration,
          attemptContinuousHydration,
          attemptHydrationAtCurrentPriority,
          findHostInstance,
          findHostInstanceWithWarning,
          findHostInstanceWithNoPortals,
          shouldSuspend,
          injectIntoDevTools
        });
        var reactReconciler = ReactFiberReconciler.default || ReactFiberReconciler;
        module2.exports = reactReconciler;
        var $$$renderer = module2.exports;
        module2.exports = $$$reconciler;
        return $$$renderer;
      };
    }
  }
});

// node_modules/ink/node_modules/react-reconciler/index.js
var require_react_reconciler = __commonJS({
  "node_modules/ink/node_modules/react-reconciler/index.js"(exports2, module2) {
    "use strict";
    if (process.env.NODE_ENV === "production") {
      module2.exports = require_react_reconciler_production_min();
    } else {
      module2.exports = require_react_reconciler_development();
    }
  }
});

// node_modules/yoga-layout-prebuilt/yoga-layout/dist/YGEnums.js
var require_YGEnums = __commonJS({
  "node_modules/yoga-layout-prebuilt/yoga-layout/dist/YGEnums.js"(exports2, module2) {
    "use strict";
    var CONSTANTS = {
      ALIGN_COUNT: 8,
      ALIGN_AUTO: 0,
      ALIGN_FLEX_START: 1,
      ALIGN_CENTER: 2,
      ALIGN_FLEX_END: 3,
      ALIGN_STRETCH: 4,
      ALIGN_BASELINE: 5,
      ALIGN_SPACE_BETWEEN: 6,
      ALIGN_SPACE_AROUND: 7,
      DIMENSION_COUNT: 2,
      DIMENSION_WIDTH: 0,
      DIMENSION_HEIGHT: 1,
      DIRECTION_COUNT: 3,
      DIRECTION_INHERIT: 0,
      DIRECTION_LTR: 1,
      DIRECTION_RTL: 2,
      DISPLAY_COUNT: 2,
      DISPLAY_FLEX: 0,
      DISPLAY_NONE: 1,
      EDGE_COUNT: 9,
      EDGE_LEFT: 0,
      EDGE_TOP: 1,
      EDGE_RIGHT: 2,
      EDGE_BOTTOM: 3,
      EDGE_START: 4,
      EDGE_END: 5,
      EDGE_HORIZONTAL: 6,
      EDGE_VERTICAL: 7,
      EDGE_ALL: 8,
      EXPERIMENTAL_FEATURE_COUNT: 1,
      EXPERIMENTAL_FEATURE_WEB_FLEX_BASIS: 0,
      FLEX_DIRECTION_COUNT: 4,
      FLEX_DIRECTION_COLUMN: 0,
      FLEX_DIRECTION_COLUMN_REVERSE: 1,
      FLEX_DIRECTION_ROW: 2,
      FLEX_DIRECTION_ROW_REVERSE: 3,
      JUSTIFY_COUNT: 6,
      JUSTIFY_FLEX_START: 0,
      JUSTIFY_CENTER: 1,
      JUSTIFY_FLEX_END: 2,
      JUSTIFY_SPACE_BETWEEN: 3,
      JUSTIFY_SPACE_AROUND: 4,
      JUSTIFY_SPACE_EVENLY: 5,
      LOG_LEVEL_COUNT: 6,
      LOG_LEVEL_ERROR: 0,
      LOG_LEVEL_WARN: 1,
      LOG_LEVEL_INFO: 2,
      LOG_LEVEL_DEBUG: 3,
      LOG_LEVEL_VERBOSE: 4,
      LOG_LEVEL_FATAL: 5,
      MEASURE_MODE_COUNT: 3,
      MEASURE_MODE_UNDEFINED: 0,
      MEASURE_MODE_EXACTLY: 1,
      MEASURE_MODE_AT_MOST: 2,
      NODE_TYPE_COUNT: 2,
      NODE_TYPE_DEFAULT: 0,
      NODE_TYPE_TEXT: 1,
      OVERFLOW_COUNT: 3,
      OVERFLOW_VISIBLE: 0,
      OVERFLOW_HIDDEN: 1,
      OVERFLOW_SCROLL: 2,
      POSITION_TYPE_COUNT: 2,
      POSITION_TYPE_RELATIVE: 0,
      POSITION_TYPE_ABSOLUTE: 1,
      PRINT_OPTIONS_COUNT: 3,
      PRINT_OPTIONS_LAYOUT: 1,
      PRINT_OPTIONS_STYLE: 2,
      PRINT_OPTIONS_CHILDREN: 4,
      UNIT_COUNT: 4,
      UNIT_UNDEFINED: 0,
      UNIT_POINT: 1,
      UNIT_PERCENT: 2,
      UNIT_AUTO: 3,
      WRAP_COUNT: 3,
      WRAP_NO_WRAP: 0,
      WRAP_WRAP: 1,
      WRAP_WRAP_REVERSE: 2
    };
    module2.exports = CONSTANTS;
  }
});

// node_modules/yoga-layout-prebuilt/yoga-layout/dist/entry-common.js
var require_entry_common = __commonJS({
  "node_modules/yoga-layout-prebuilt/yoga-layout/dist/entry-common.js"(exports2, module2) {
    "use strict";
    var _extends = Object.assign || function(target) {
      for (var i3 = 1; i3 < arguments.length; i3++) {
        var source = arguments[i3];
        for (var key2 in source) {
          if (Object.prototype.hasOwnProperty.call(source, key2)) {
            target[key2] = source[key2];
          }
        }
      }
      return target;
    };
    var _createClass = function() {
      function defineProperties(target, props) {
        for (var i3 = 0; i3 < props.length; i3++) {
          var descriptor = props[i3];
          descriptor.enumerable = descriptor.enumerable || false;
          descriptor.configurable = true;
          if ("value" in descriptor)
            descriptor.writable = true;
          Object.defineProperty(target, descriptor.key, descriptor);
        }
      }
      return function(Constructor, protoProps, staticProps) {
        if (protoProps)
          defineProperties(Constructor.prototype, protoProps);
        if (staticProps)
          defineProperties(Constructor, staticProps);
        return Constructor;
      };
    }();
    function _defineProperty(obj, key2, value) {
      if (key2 in obj) {
        Object.defineProperty(obj, key2, { value, enumerable: true, configurable: true, writable: true });
      } else {
        obj[key2] = value;
      }
      return obj;
    }
    function _classCallCheck(instance, Constructor) {
      if (!(instance instanceof Constructor)) {
        throw new TypeError("Cannot call a class as a function");
      }
    }
    var CONSTANTS = require_YGEnums();
    var Layout = function() {
      function Layout2(left, right, top, bottom, width, height) {
        _classCallCheck(this, Layout2);
        this.left = left;
        this.right = right;
        this.top = top;
        this.bottom = bottom;
        this.width = width;
        this.height = height;
      }
      _createClass(Layout2, [{
        key: "fromJS",
        value: function fromJS(expose) {
          expose(this.left, this.right, this.top, this.bottom, this.width, this.height);
        }
      }, {
        key: "toString",
        value: function toString2() {
          return "<Layout#" + this.left + ":" + this.right + ";" + this.top + ":" + this.bottom + ";" + this.width + ":" + this.height + ">";
        }
      }]);
      return Layout2;
    }();
    var Size = function() {
      _createClass(Size2, null, [{
        key: "fromJS",
        value: function fromJS(_ref) {
          var width = _ref.width, height = _ref.height;
          return new Size2(width, height);
        }
      }]);
      function Size2(width, height) {
        _classCallCheck(this, Size2);
        this.width = width;
        this.height = height;
      }
      _createClass(Size2, [{
        key: "fromJS",
        value: function fromJS(expose) {
          expose(this.width, this.height);
        }
      }, {
        key: "toString",
        value: function toString2() {
          return "<Size#" + this.width + "x" + this.height + ">";
        }
      }]);
      return Size2;
    }();
    var Value = function() {
      function Value2(unit, value) {
        _classCallCheck(this, Value2);
        this.unit = unit;
        this.value = value;
      }
      _createClass(Value2, [{
        key: "fromJS",
        value: function fromJS(expose) {
          expose(this.unit, this.value);
        }
      }, {
        key: "toString",
        value: function toString2() {
          switch (this.unit) {
            case CONSTANTS.UNIT_POINT:
              return String(this.value);
            case CONSTANTS.UNIT_PERCENT:
              return this.value + "%";
            case CONSTANTS.UNIT_AUTO:
              return "auto";
            default: {
              return this.value + "?";
            }
          }
        }
      }, {
        key: "valueOf",
        value: function valueOf() {
          return this.value;
        }
      }]);
      return Value2;
    }();
    module2.exports = function(bind, lib) {
      function patch(prototype, name, fn) {
        var original = prototype[name];
        prototype[name] = function() {
          for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
            args[_key] = arguments[_key];
          }
          return fn.call.apply(fn, [this, original].concat(args));
        };
      }
      var _arr = ["setPosition", "setMargin", "setFlexBasis", "setWidth", "setHeight", "setMinWidth", "setMinHeight", "setMaxWidth", "setMaxHeight", "setPadding"];
      var _loop = function _loop2() {
        var _methods;
        var fnName = _arr[_i];
        var methods = (_methods = {}, _defineProperty(_methods, CONSTANTS.UNIT_POINT, lib.Node.prototype[fnName]), _defineProperty(_methods, CONSTANTS.UNIT_PERCENT, lib.Node.prototype[fnName + "Percent"]), _defineProperty(_methods, CONSTANTS.UNIT_AUTO, lib.Node.prototype[fnName + "Auto"]), _methods);
        patch(lib.Node.prototype, fnName, function(original) {
          for (var _len2 = arguments.length, args = Array(_len2 > 1 ? _len2 - 1 : 0), _key2 = 1; _key2 < _len2; _key2++) {
            args[_key2 - 1] = arguments[_key2];
          }
          var value = args.pop();
          var unit = void 0, asNumber = void 0;
          if (value === "auto") {
            unit = CONSTANTS.UNIT_AUTO;
            asNumber = void 0;
          } else if (value instanceof Value) {
            unit = value.unit;
            asNumber = value.valueOf();
          } else {
            unit = typeof value === "string" && value.endsWith("%") ? CONSTANTS.UNIT_PERCENT : CONSTANTS.UNIT_POINT;
            asNumber = parseFloat(value);
            if (!Number.isNaN(value) && Number.isNaN(asNumber)) {
              throw new Error("Invalid value " + value + " for " + fnName);
            }
          }
          if (!methods[unit])
            throw new Error('Failed to execute "' + fnName + `": Unsupported unit '` + value + "'");
          if (asNumber !== void 0) {
            var _methods$unit;
            return (_methods$unit = methods[unit]).call.apply(_methods$unit, [this].concat(args, [asNumber]));
          } else {
            var _methods$unit2;
            return (_methods$unit2 = methods[unit]).call.apply(_methods$unit2, [this].concat(args));
          }
        });
      };
      for (var _i = 0; _i < _arr.length; _i++) {
        _loop();
      }
      patch(lib.Config.prototype, "free", function() {
        lib.Config.destroy(this);
      });
      patch(lib.Node, "create", function(_, config) {
        return config ? lib.Node.createWithConfig(config) : lib.Node.createDefault();
      });
      patch(lib.Node.prototype, "free", function() {
        lib.Node.destroy(this);
      });
      patch(lib.Node.prototype, "freeRecursive", function() {
        for (var t2 = 0, T = this.getChildCount(); t2 < T; ++t2) {
          this.getChild(0).freeRecursive();
        }
        this.free();
      });
      patch(lib.Node.prototype, "setMeasureFunc", function(original, measureFunc) {
        if (measureFunc) {
          return original.call(this, function() {
            return Size.fromJS(measureFunc.apply(void 0, arguments));
          });
        } else {
          return this.unsetMeasureFunc();
        }
      });
      patch(lib.Node.prototype, "calculateLayout", function(original) {
        var width = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : NaN;
        var height = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : NaN;
        var direction = arguments.length > 3 && arguments[3] !== void 0 ? arguments[3] : CONSTANTS.DIRECTION_LTR;
        return original.call(this, width, height, direction);
      });
      return _extends({
        Config: lib.Config,
        Node: lib.Node,
        Layout: bind("Layout", Layout),
        Size: bind("Size", Size),
        Value: bind("Value", Value),
        getInstanceCount: function getInstanceCount() {
          return lib.getInstanceCount.apply(lib, arguments);
        }
      }, CONSTANTS);
    };
  }
});

// node_modules/yoga-layout-prebuilt/yoga-layout/build/Release/nbind.js
var require_nbind = __commonJS({
  "node_modules/yoga-layout-prebuilt/yoga-layout/build/Release/nbind.js"(exports, module) {
    (function(root, wrapper) {
      if (typeof define == "function" && define.amd)
        define([], function() {
          return wrapper;
        });
      else if (typeof module == "object" && module.exports)
        module.exports = wrapper;
      else
        (root.nbind = root.nbind || {}).init = wrapper;
    })(exports, function(Module, cb) {
      if (typeof Module == "function") {
        cb = Module;
        Module = {};
      }
      Module.onRuntimeInitialized = function(init, cb2) {
        return function() {
          if (init)
            init.apply(this, arguments);
          try {
            Module.ccall("nbind_init");
          } catch (err2) {
            cb2(err2);
            return;
          }
          cb2(null, { bind: Module._nbind_value, reflect: Module.NBind.reflect, queryType: Module.NBind.queryType, toggleLightGC: Module.toggleLightGC, lib: Module });
        };
      }(Module.onRuntimeInitialized, cb);
      var Module;
      if (!Module)
        Module = (typeof Module !== "undefined" ? Module : null) || {};
      var moduleOverrides = {};
      for (var key in Module) {
        if (Module.hasOwnProperty(key)) {
          moduleOverrides[key] = Module[key];
        }
      }
      var ENVIRONMENT_IS_WEB = false;
      var ENVIRONMENT_IS_WORKER = false;
      var ENVIRONMENT_IS_NODE = false;
      var ENVIRONMENT_IS_SHELL = false;
      if (Module["ENVIRONMENT"]) {
        if (Module["ENVIRONMENT"] === "WEB") {
          ENVIRONMENT_IS_WEB = true;
        } else if (Module["ENVIRONMENT"] === "WORKER") {
          ENVIRONMENT_IS_WORKER = true;
        } else if (Module["ENVIRONMENT"] === "NODE") {
          ENVIRONMENT_IS_NODE = true;
        } else if (Module["ENVIRONMENT"] === "SHELL") {
          ENVIRONMENT_IS_SHELL = true;
        } else {
          throw new Error("The provided Module['ENVIRONMENT'] value is not valid. It must be one of: WEB|WORKER|NODE|SHELL.");
        }
      } else {
        ENVIRONMENT_IS_WEB = typeof window === "object";
        ENVIRONMENT_IS_WORKER = typeof importScripts === "function";
        ENVIRONMENT_IS_NODE = typeof process === "object" && typeof require === "function" && !ENVIRONMENT_IS_WEB && !ENVIRONMENT_IS_WORKER;
        ENVIRONMENT_IS_SHELL = !ENVIRONMENT_IS_WEB && !ENVIRONMENT_IS_NODE && !ENVIRONMENT_IS_WORKER;
      }
      if (ENVIRONMENT_IS_NODE) {
        if (!Module["print"])
          Module["print"] = console.log;
        if (!Module["printErr"])
          Module["printErr"] = console.warn;
        var nodeFS;
        var nodePath;
        Module["read"] = function shell_read(filename, binary2) {
          if (!nodeFS)
            nodeFS = {}("");
          if (!nodePath)
            nodePath = {}("");
          filename = nodePath["normalize"](filename);
          var ret = nodeFS["readFileSync"](filename);
          return binary2 ? ret : ret.toString();
        };
        Module["readBinary"] = function readBinary(filename) {
          var ret = Module["read"](filename, true);
          if (!ret.buffer) {
            ret = new Uint8Array(ret);
          }
          assert(ret.buffer);
          return ret;
        };
        Module["load"] = function load2(f) {
          globalEval(read(f));
        };
        if (!Module["thisProgram"]) {
          if (process["argv"].length > 1) {
            Module["thisProgram"] = process["argv"][1].replace(/\\/g, "/");
          } else {
            Module["thisProgram"] = "unknown-program";
          }
        }
        Module["arguments"] = process["argv"].slice(2);
        if (typeof module !== "undefined") {
          module["exports"] = Module;
        }
        process["on"]("uncaughtException", function(ex) {
          if (!(ex instanceof ExitStatus)) {
            throw ex;
          }
        });
        Module["inspect"] = function() {
          return "[Emscripten Module object]";
        };
      } else if (ENVIRONMENT_IS_SHELL) {
        if (!Module["print"])
          Module["print"] = print;
        if (typeof printErr != "undefined")
          Module["printErr"] = printErr;
        if (typeof read != "undefined") {
          Module["read"] = read;
        } else {
          Module["read"] = function shell_read() {
            throw "no read() available";
          };
        }
        Module["readBinary"] = function readBinary(f) {
          if (typeof readbuffer === "function") {
            return new Uint8Array(readbuffer(f));
          }
          var data = read(f, "binary");
          assert(typeof data === "object");
          return data;
        };
        if (typeof scriptArgs != "undefined") {
          Module["arguments"] = scriptArgs;
        } else if (typeof arguments != "undefined") {
          Module["arguments"] = arguments;
        }
        if (typeof quit === "function") {
          Module["quit"] = function(status, toThrow) {
            quit(status);
          };
        }
      } else if (ENVIRONMENT_IS_WEB || ENVIRONMENT_IS_WORKER) {
        Module["read"] = function shell_read(url) {
          var xhr = new XMLHttpRequest();
          xhr.open("GET", url, false);
          xhr.send(null);
          return xhr.responseText;
        };
        if (ENVIRONMENT_IS_WORKER) {
          Module["readBinary"] = function readBinary(url) {
            var xhr = new XMLHttpRequest();
            xhr.open("GET", url, false);
            xhr.responseType = "arraybuffer";
            xhr.send(null);
            return new Uint8Array(xhr.response);
          };
        }
        Module["readAsync"] = function readAsync(url, onload, onerror) {
          var xhr = new XMLHttpRequest();
          xhr.open("GET", url, true);
          xhr.responseType = "arraybuffer";
          xhr.onload = function xhr_onload() {
            if (xhr.status == 200 || xhr.status == 0 && xhr.response) {
              onload(xhr.response);
            } else {
              onerror();
            }
          };
          xhr.onerror = onerror;
          xhr.send(null);
        };
        if (typeof arguments != "undefined") {
          Module["arguments"] = arguments;
        }
        if (typeof console !== "undefined") {
          if (!Module["print"])
            Module["print"] = function shell_print(x) {
              console.log(x);
            };
          if (!Module["printErr"])
            Module["printErr"] = function shell_printErr(x) {
              console.warn(x);
            };
        } else {
          var TRY_USE_DUMP = false;
          if (!Module["print"])
            Module["print"] = TRY_USE_DUMP && typeof dump !== "undefined" ? function(x) {
              dump(x);
            } : function(x) {
            };
        }
        if (ENVIRONMENT_IS_WORKER) {
          Module["load"] = importScripts;
        }
        if (typeof Module["setWindowTitle"] === "undefined") {
          Module["setWindowTitle"] = function(title) {
            document.title = title;
          };
        }
      } else {
        throw "Unknown runtime environment. Where are we?";
      }
      function globalEval(x) {
        eval.call(null, x);
      }
      if (!Module["load"] && Module["read"]) {
        Module["load"] = function load2(f) {
          globalEval(Module["read"](f));
        };
      }
      if (!Module["print"]) {
        Module["print"] = function() {
        };
      }
      if (!Module["printErr"]) {
        Module["printErr"] = Module["print"];
      }
      if (!Module["arguments"]) {
        Module["arguments"] = [];
      }
      if (!Module["thisProgram"]) {
        Module["thisProgram"] = "./this.program";
      }
      if (!Module["quit"]) {
        Module["quit"] = function(status, toThrow) {
          throw toThrow;
        };
      }
      Module.print = Module["print"];
      Module.printErr = Module["printErr"];
      Module["preRun"] = [];
      Module["postRun"] = [];
      for (var key in moduleOverrides) {
        if (moduleOverrides.hasOwnProperty(key)) {
          Module[key] = moduleOverrides[key];
        }
      }
      moduleOverrides = void 0;
      var Runtime = { setTempRet0: function(value) {
        tempRet0 = value;
        return value;
      }, getTempRet0: function() {
        return tempRet0;
      }, stackSave: function() {
        return STACKTOP;
      }, stackRestore: function(stackTop) {
        STACKTOP = stackTop;
      }, getNativeTypeSize: function(type3) {
        switch (type3) {
          case "i1":
          case "i8":
            return 1;
          case "i16":
            return 2;
          case "i32":
            return 4;
          case "i64":
            return 8;
          case "float":
            return 4;
          case "double":
            return 8;
          default: {
            if (type3[type3.length - 1] === "*") {
              return Runtime.QUANTUM_SIZE;
            } else if (type3[0] === "i") {
              var bits = parseInt(type3.substr(1));
              assert(bits % 8 === 0);
              return bits / 8;
            } else {
              return 0;
            }
          }
        }
      }, getNativeFieldSize: function(type3) {
        return Math.max(Runtime.getNativeTypeSize(type3), Runtime.QUANTUM_SIZE);
      }, STACK_ALIGN: 16, prepVararg: function(ptr2, type3) {
        if (type3 === "double" || type3 === "i64") {
          if (ptr2 & 7) {
            assert((ptr2 & 7) === 4);
            ptr2 += 4;
          }
        } else {
          assert((ptr2 & 3) === 0);
        }
        return ptr2;
      }, getAlignSize: function(type3, size, vararg) {
        if (!vararg && (type3 == "i64" || type3 == "double"))
          return 8;
        if (!type3)
          return Math.min(size, 8);
        return Math.min(size || (type3 ? Runtime.getNativeFieldSize(type3) : 0), Runtime.QUANTUM_SIZE);
      }, dynCall: function(sig, ptr2, args) {
        if (args && args.length) {
          return Module["dynCall_" + sig].apply(null, [ptr2].concat(args));
        } else {
          return Module["dynCall_" + sig].call(null, ptr2);
        }
      }, functionPointers: [], addFunction: function(func2) {
        for (var i3 = 0; i3 < Runtime.functionPointers.length; i3++) {
          if (!Runtime.functionPointers[i3]) {
            Runtime.functionPointers[i3] = func2;
            return 2 * (1 + i3);
          }
        }
        throw "Finished up all reserved function pointers. Use a higher value for RESERVED_FUNCTION_POINTERS.";
      }, removeFunction: function(index) {
        Runtime.functionPointers[(index - 2) / 2] = null;
      }, warnOnce: function(text) {
        if (!Runtime.warnOnce.shown)
          Runtime.warnOnce.shown = {};
        if (!Runtime.warnOnce.shown[text]) {
          Runtime.warnOnce.shown[text] = 1;
          Module.printErr(text);
        }
      }, funcWrappers: {}, getFuncWrapper: function(func2, sig) {
        if (!func2)
          return;
        assert(sig);
        if (!Runtime.funcWrappers[sig]) {
          Runtime.funcWrappers[sig] = {};
        }
        var sigCache = Runtime.funcWrappers[sig];
        if (!sigCache[func2]) {
          if (sig.length === 1) {
            sigCache[func2] = function dynCall_wrapper() {
              return Runtime.dynCall(sig, func2);
            };
          } else if (sig.length === 2) {
            sigCache[func2] = function dynCall_wrapper(arg2) {
              return Runtime.dynCall(sig, func2, [arg2]);
            };
          } else {
            sigCache[func2] = function dynCall_wrapper() {
              return Runtime.dynCall(sig, func2, Array.prototype.slice.call(arguments));
            };
          }
        }
        return sigCache[func2];
      }, getCompilerSetting: function(name) {
        throw "You must build with -s RETAIN_COMPILER_SETTINGS=1 for Runtime.getCompilerSetting or emscripten_get_compiler_setting to work";
      }, stackAlloc: function(size) {
        var ret = STACKTOP;
        STACKTOP = STACKTOP + size | 0;
        STACKTOP = STACKTOP + 15 & -16;
        return ret;
      }, staticAlloc: function(size) {
        var ret = STATICTOP;
        STATICTOP = STATICTOP + size | 0;
        STATICTOP = STATICTOP + 15 & -16;
        return ret;
      }, dynamicAlloc: function(size) {
        var ret = HEAP32[DYNAMICTOP_PTR >> 2];
        var end = (ret + size + 15 | 0) & -16;
        HEAP32[DYNAMICTOP_PTR >> 2] = end;
        if (end >= TOTAL_MEMORY) {
          var success = enlargeMemory();
          if (!success) {
            HEAP32[DYNAMICTOP_PTR >> 2] = ret;
            return 0;
          }
        }
        return ret;
      }, alignMemory: function(size, quantum) {
        var ret = size = Math.ceil(size / (quantum ? quantum : 16)) * (quantum ? quantum : 16);
        return ret;
      }, makeBigInt: function(low, high, unsigned) {
        var ret = unsigned ? +(low >>> 0) + +(high >>> 0) * 4294967296 : +(low >>> 0) + +(high | 0) * 4294967296;
        return ret;
      }, GLOBAL_BASE: 8, QUANTUM_SIZE: 4, __dummy__: 0 };
      Module["Runtime"] = Runtime;
      var ABORT = 0;
      var EXITSTATUS = 0;
      function assert(condition, text) {
        if (!condition) {
          abort("Assertion failed: " + text);
        }
      }
      function getCFunc(ident) {
        var func = Module["_" + ident];
        if (!func) {
          try {
            func = eval("_" + ident);
          } catch (e2) {
          }
        }
        assert(func, "Cannot call unknown function " + ident + " (perhaps LLVM optimizations or closure removed it?)");
        return func;
      }
      var cwrap, ccall;
      (function() {
        var JSfuncs = { "stackSave": function() {
          Runtime.stackSave();
        }, "stackRestore": function() {
          Runtime.stackRestore();
        }, "arrayToC": function(arr) {
          var ret = Runtime.stackAlloc(arr.length);
          writeArrayToMemory(arr, ret);
          return ret;
        }, "stringToC": function(str2) {
          var ret = 0;
          if (str2 !== null && str2 !== void 0 && str2 !== 0) {
            var len = (str2.length << 2) + 1;
            ret = Runtime.stackAlloc(len);
            stringToUTF8(str2, ret, len);
          }
          return ret;
        } };
        var toC = { "string": JSfuncs["stringToC"], "array": JSfuncs["arrayToC"] };
        ccall = function ccallFunc(ident2, returnType2, argTypes2, args, opts) {
          var func2 = getCFunc(ident2);
          var cArgs = [];
          var stack = 0;
          if (args) {
            for (var i3 = 0; i3 < args.length; i3++) {
              var converter = toC[argTypes2[i3]];
              if (converter) {
                if (stack === 0)
                  stack = Runtime.stackSave();
                cArgs[i3] = converter(args[i3]);
              } else {
                cArgs[i3] = args[i3];
              }
            }
          }
          var ret = func2.apply(null, cArgs);
          if (returnType2 === "string")
            ret = Pointer_stringify(ret);
          if (stack !== 0) {
            if (opts && opts.async) {
              EmterpreterAsync.asyncFinalizers.push(function() {
                Runtime.stackRestore(stack);
              });
              return;
            }
            Runtime.stackRestore(stack);
          }
          return ret;
        };
        var sourceRegex = /^function\s*[a-zA-Z$_0-9]*\s*\(([^)]*)\)\s*{\s*([^*]*?)[\s;]*(?:return\s*(.*?)[;\s]*)?}$/;
        function parseJSFunc(jsfunc) {
          var parsed = jsfunc.toString().match(sourceRegex).slice(1);
          return { arguments: parsed[0], body: parsed[1], returnValue: parsed[2] };
        }
        var JSsource = null;
        function ensureJSsource() {
          if (!JSsource) {
            JSsource = {};
            for (var fun in JSfuncs) {
              if (JSfuncs.hasOwnProperty(fun)) {
                JSsource[fun] = parseJSFunc(JSfuncs[fun]);
              }
            }
          }
        }
        cwrap = function cwrap(ident, returnType, argTypes) {
          argTypes = argTypes || [];
          var cfunc = getCFunc(ident);
          var numericArgs = argTypes.every(function(type3) {
            return type3 === "number";
          });
          var numericRet = returnType !== "string";
          if (numericRet && numericArgs) {
            return cfunc;
          }
          var argNames = argTypes.map(function(x, i3) {
            return "$" + i3;
          });
          var funcstr = "(function(" + argNames.join(",") + ") {";
          var nargs = argTypes.length;
          if (!numericArgs) {
            ensureJSsource();
            funcstr += "var stack = " + JSsource["stackSave"].body + ";";
            for (var i = 0; i < nargs; i++) {
              var arg = argNames[i], type = argTypes[i];
              if (type === "number")
                continue;
              var convertCode = JSsource[type + "ToC"];
              funcstr += "var " + convertCode.arguments + " = " + arg + ";";
              funcstr += convertCode.body + ";";
              funcstr += arg + "=(" + convertCode.returnValue + ");";
            }
          }
          var cfuncname = parseJSFunc(function() {
            return cfunc;
          }).returnValue;
          funcstr += "var ret = " + cfuncname + "(" + argNames.join(",") + ");";
          if (!numericRet) {
            var strgfy = parseJSFunc(function() {
              return Pointer_stringify;
            }).returnValue;
            funcstr += "ret = " + strgfy + "(ret);";
          }
          if (!numericArgs) {
            ensureJSsource();
            funcstr += JSsource["stackRestore"].body.replace("()", "(stack)") + ";";
          }
          funcstr += "return ret})";
          return eval(funcstr);
        };
      })();
      Module["ccall"] = ccall;
      Module["cwrap"] = cwrap;
      function setValue(ptr2, value, type3, noSafe) {
        type3 = type3 || "i8";
        if (type3.charAt(type3.length - 1) === "*")
          type3 = "i32";
        switch (type3) {
          case "i1":
            HEAP8[ptr2 >> 0] = value;
            break;
          case "i8":
            HEAP8[ptr2 >> 0] = value;
            break;
          case "i16":
            HEAP16[ptr2 >> 1] = value;
            break;
          case "i32":
            HEAP32[ptr2 >> 2] = value;
            break;
          case "i64":
            tempI64 = [value >>> 0, (tempDouble = value, +Math_abs(tempDouble) >= 1 ? tempDouble > 0 ? (Math_min(+Math_floor(tempDouble / 4294967296), 4294967295) | 0) >>> 0 : ~~+Math_ceil((tempDouble - +(~~tempDouble >>> 0)) / 4294967296) >>> 0 : 0)], HEAP32[ptr2 >> 2] = tempI64[0], HEAP32[ptr2 + 4 >> 2] = tempI64[1];
            break;
          case "float":
            HEAPF32[ptr2 >> 2] = value;
            break;
          case "double":
            HEAPF64[ptr2 >> 3] = value;
            break;
          default:
            abort("invalid type for setValue: " + type3);
        }
      }
      Module["setValue"] = setValue;
      function getValue(ptr2, type3, noSafe) {
        type3 = type3 || "i8";
        if (type3.charAt(type3.length - 1) === "*")
          type3 = "i32";
        switch (type3) {
          case "i1":
            return HEAP8[ptr2 >> 0];
          case "i8":
            return HEAP8[ptr2 >> 0];
          case "i16":
            return HEAP16[ptr2 >> 1];
          case "i32":
            return HEAP32[ptr2 >> 2];
          case "i64":
            return HEAP32[ptr2 >> 2];
          case "float":
            return HEAPF32[ptr2 >> 2];
          case "double":
            return HEAPF64[ptr2 >> 3];
          default:
            abort("invalid type for setValue: " + type3);
        }
        return null;
      }
      Module["getValue"] = getValue;
      var ALLOC_NORMAL = 0;
      var ALLOC_STACK = 1;
      var ALLOC_STATIC = 2;
      var ALLOC_DYNAMIC = 3;
      var ALLOC_NONE = 4;
      Module["ALLOC_NORMAL"] = ALLOC_NORMAL;
      Module["ALLOC_STACK"] = ALLOC_STACK;
      Module["ALLOC_STATIC"] = ALLOC_STATIC;
      Module["ALLOC_DYNAMIC"] = ALLOC_DYNAMIC;
      Module["ALLOC_NONE"] = ALLOC_NONE;
      function allocate(slab, types2, allocator, ptr2) {
        var zeroinit, size;
        if (typeof slab === "number") {
          zeroinit = true;
          size = slab;
        } else {
          zeroinit = false;
          size = slab.length;
        }
        var singleType = typeof types2 === "string" ? types2 : null;
        var ret;
        if (allocator == ALLOC_NONE) {
          ret = ptr2;
        } else {
          ret = [typeof _malloc === "function" ? _malloc : Runtime.staticAlloc, Runtime.stackAlloc, Runtime.staticAlloc, Runtime.dynamicAlloc][allocator === void 0 ? ALLOC_STATIC : allocator](Math.max(size, singleType ? 1 : types2.length));
        }
        if (zeroinit) {
          var ptr2 = ret, stop;
          assert((ret & 3) == 0);
          stop = ret + (size & ~3);
          for (; ptr2 < stop; ptr2 += 4) {
            HEAP32[ptr2 >> 2] = 0;
          }
          stop = ret + size;
          while (ptr2 < stop) {
            HEAP8[ptr2++ >> 0] = 0;
          }
          return ret;
        }
        if (singleType === "i8") {
          if (slab.subarray || slab.slice) {
            HEAPU8.set(slab, ret);
          } else {
            HEAPU8.set(new Uint8Array(slab), ret);
          }
          return ret;
        }
        var i3 = 0, type3, typeSize, previousType;
        while (i3 < size) {
          var curr = slab[i3];
          if (typeof curr === "function") {
            curr = Runtime.getFunctionIndex(curr);
          }
          type3 = singleType || types2[i3];
          if (type3 === 0) {
            i3++;
            continue;
          }
          if (type3 == "i64")
            type3 = "i32";
          setValue(ret + i3, curr, type3);
          if (previousType !== type3) {
            typeSize = Runtime.getNativeTypeSize(type3);
            previousType = type3;
          }
          i3 += typeSize;
        }
        return ret;
      }
      Module["allocate"] = allocate;
      function getMemory(size) {
        if (!staticSealed)
          return Runtime.staticAlloc(size);
        if (!runtimeInitialized)
          return Runtime.dynamicAlloc(size);
        return _malloc(size);
      }
      Module["getMemory"] = getMemory;
      function Pointer_stringify(ptr2, length) {
        if (length === 0 || !ptr2)
          return "";
        var hasUtf = 0;
        var t2;
        var i3 = 0;
        while (1) {
          t2 = HEAPU8[ptr2 + i3 >> 0];
          hasUtf |= t2;
          if (t2 == 0 && !length)
            break;
          i3++;
          if (length && i3 == length)
            break;
        }
        if (!length)
          length = i3;
        var ret = "";
        if (hasUtf < 128) {
          var MAX_CHUNK = 1024;
          var curr;
          while (length > 0) {
            curr = String.fromCharCode.apply(String, HEAPU8.subarray(ptr2, ptr2 + Math.min(length, MAX_CHUNK)));
            ret = ret ? ret + curr : curr;
            ptr2 += MAX_CHUNK;
            length -= MAX_CHUNK;
          }
          return ret;
        }
        return Module["UTF8ToString"](ptr2);
      }
      Module["Pointer_stringify"] = Pointer_stringify;
      function AsciiToString(ptr2) {
        var str2 = "";
        while (1) {
          var ch = HEAP8[ptr2++ >> 0];
          if (!ch)
            return str2;
          str2 += String.fromCharCode(ch);
        }
      }
      Module["AsciiToString"] = AsciiToString;
      function stringToAscii(str2, outPtr) {
        return writeAsciiToMemory(str2, outPtr, false);
      }
      Module["stringToAscii"] = stringToAscii;
      var UTF8Decoder = typeof TextDecoder !== "undefined" ? new TextDecoder("utf8") : void 0;
      function UTF8ArrayToString(u8Array, idx) {
        var endPtr = idx;
        while (u8Array[endPtr])
          ++endPtr;
        if (endPtr - idx > 16 && u8Array.subarray && UTF8Decoder) {
          return UTF8Decoder.decode(u8Array.subarray(idx, endPtr));
        } else {
          var u0, u1, u2, u3, u4, u5;
          var str2 = "";
          while (1) {
            u0 = u8Array[idx++];
            if (!u0)
              return str2;
            if (!(u0 & 128)) {
              str2 += String.fromCharCode(u0);
              continue;
            }
            u1 = u8Array[idx++] & 63;
            if ((u0 & 224) == 192) {
              str2 += String.fromCharCode((u0 & 31) << 6 | u1);
              continue;
            }
            u2 = u8Array[idx++] & 63;
            if ((u0 & 240) == 224) {
              u0 = (u0 & 15) << 12 | u1 << 6 | u2;
            } else {
              u3 = u8Array[idx++] & 63;
              if ((u0 & 248) == 240) {
                u0 = (u0 & 7) << 18 | u1 << 12 | u2 << 6 | u3;
              } else {
                u4 = u8Array[idx++] & 63;
                if ((u0 & 252) == 248) {
                  u0 = (u0 & 3) << 24 | u1 << 18 | u2 << 12 | u3 << 6 | u4;
                } else {
                  u5 = u8Array[idx++] & 63;
                  u0 = (u0 & 1) << 30 | u1 << 24 | u2 << 18 | u3 << 12 | u4 << 6 | u5;
                }
              }
            }
            if (u0 < 65536) {
              str2 += String.fromCharCode(u0);
            } else {
              var ch = u0 - 65536;
              str2 += String.fromCharCode(55296 | ch >> 10, 56320 | ch & 1023);
            }
          }
        }
      }
      Module["UTF8ArrayToString"] = UTF8ArrayToString;
      function UTF8ToString(ptr2) {
        return UTF8ArrayToString(HEAPU8, ptr2);
      }
      Module["UTF8ToString"] = UTF8ToString;
      function stringToUTF8Array(str2, outU8Array, outIdx, maxBytesToWrite) {
        if (!(maxBytesToWrite > 0))
          return 0;
        var startIdx = outIdx;
        var endIdx = outIdx + maxBytesToWrite - 1;
        for (var i3 = 0; i3 < str2.length; ++i3) {
          var u2 = str2.charCodeAt(i3);
          if (u2 >= 55296 && u2 <= 57343)
            u2 = 65536 + ((u2 & 1023) << 10) | str2.charCodeAt(++i3) & 1023;
          if (u2 <= 127) {
            if (outIdx >= endIdx)
              break;
            outU8Array[outIdx++] = u2;
          } else if (u2 <= 2047) {
            if (outIdx + 1 >= endIdx)
              break;
            outU8Array[outIdx++] = 192 | u2 >> 6;
            outU8Array[outIdx++] = 128 | u2 & 63;
          } else if (u2 <= 65535) {
            if (outIdx + 2 >= endIdx)
              break;
            outU8Array[outIdx++] = 224 | u2 >> 12;
            outU8Array[outIdx++] = 128 | u2 >> 6 & 63;
            outU8Array[outIdx++] = 128 | u2 & 63;
          } else if (u2 <= 2097151) {
            if (outIdx + 3 >= endIdx)
              break;
            outU8Array[outIdx++] = 240 | u2 >> 18;
            outU8Array[outIdx++] = 128 | u2 >> 12 & 63;
            outU8Array[outIdx++] = 128 | u2 >> 6 & 63;
            outU8Array[outIdx++] = 128 | u2 & 63;
          } else if (u2 <= 67108863) {
            if (outIdx + 4 >= endIdx)
              break;
            outU8Array[outIdx++] = 248 | u2 >> 24;
            outU8Array[outIdx++] = 128 | u2 >> 18 & 63;
            outU8Array[outIdx++] = 128 | u2 >> 12 & 63;
            outU8Array[outIdx++] = 128 | u2 >> 6 & 63;
            outU8Array[outIdx++] = 128 | u2 & 63;
          } else {
            if (outIdx + 5 >= endIdx)
              break;
            outU8Array[outIdx++] = 252 | u2 >> 30;
            outU8Array[outIdx++] = 128 | u2 >> 24 & 63;
            outU8Array[outIdx++] = 128 | u2 >> 18 & 63;
            outU8Array[outIdx++] = 128 | u2 >> 12 & 63;
            outU8Array[outIdx++] = 128 | u2 >> 6 & 63;
            outU8Array[outIdx++] = 128 | u2 & 63;
          }
        }
        outU8Array[outIdx] = 0;
        return outIdx - startIdx;
      }
      Module["stringToUTF8Array"] = stringToUTF8Array;
      function stringToUTF8(str2, outPtr, maxBytesToWrite) {
        return stringToUTF8Array(str2, HEAPU8, outPtr, maxBytesToWrite);
      }
      Module["stringToUTF8"] = stringToUTF8;
      function lengthBytesUTF8(str2) {
        var len = 0;
        for (var i3 = 0; i3 < str2.length; ++i3) {
          var u2 = str2.charCodeAt(i3);
          if (u2 >= 55296 && u2 <= 57343)
            u2 = 65536 + ((u2 & 1023) << 10) | str2.charCodeAt(++i3) & 1023;
          if (u2 <= 127) {
            ++len;
          } else if (u2 <= 2047) {
            len += 2;
          } else if (u2 <= 65535) {
            len += 3;
          } else if (u2 <= 2097151) {
            len += 4;
          } else if (u2 <= 67108863) {
            len += 5;
          } else {
            len += 6;
          }
        }
        return len;
      }
      Module["lengthBytesUTF8"] = lengthBytesUTF8;
      var UTF16Decoder = typeof TextDecoder !== "undefined" ? new TextDecoder("utf-16le") : void 0;
      function demangle(func2) {
        var __cxa_demangle_func = Module["___cxa_demangle"] || Module["__cxa_demangle"];
        if (__cxa_demangle_func) {
          try {
            var s2 = func2.substr(1);
            var len = lengthBytesUTF8(s2) + 1;
            var buf = _malloc(len);
            stringToUTF8(s2, buf, len);
            var status = _malloc(4);
            var ret = __cxa_demangle_func(buf, 0, 0, status);
            if (getValue(status, "i32") === 0 && ret) {
              return Pointer_stringify(ret);
            }
          } catch (e2) {
          } finally {
            if (buf)
              _free(buf);
            if (status)
              _free(status);
            if (ret)
              _free(ret);
          }
          return func2;
        }
        Runtime.warnOnce("warning: build with  -s DEMANGLE_SUPPORT=1  to link in libcxxabi demangling");
        return func2;
      }
      function demangleAll(text) {
        var regex = /__Z[\w\d_]+/g;
        return text.replace(regex, function(x) {
          var y2 = demangle(x);
          return x === y2 ? x : x + " [" + y2 + "]";
        });
      }
      function jsStackTrace() {
        var err2 = new Error();
        if (!err2.stack) {
          try {
            throw new Error(0);
          } catch (e2) {
            err2 = e2;
          }
          if (!err2.stack) {
            return "(no stack trace available)";
          }
        }
        return err2.stack.toString();
      }
      function stackTrace() {
        var js = jsStackTrace();
        if (Module["extraStackTrace"])
          js += "\n" + Module["extraStackTrace"]();
        return demangleAll(js);
      }
      Module["stackTrace"] = stackTrace;
      var HEAP, buffer, HEAP8, HEAPU8, HEAP16, HEAPU16, HEAP32, HEAPU32, HEAPF32, HEAPF64;
      function updateGlobalBufferViews() {
        Module["HEAP8"] = HEAP8 = new Int8Array(buffer);
        Module["HEAP16"] = HEAP16 = new Int16Array(buffer);
        Module["HEAP32"] = HEAP32 = new Int32Array(buffer);
        Module["HEAPU8"] = HEAPU8 = new Uint8Array(buffer);
        Module["HEAPU16"] = HEAPU16 = new Uint16Array(buffer);
        Module["HEAPU32"] = HEAPU32 = new Uint32Array(buffer);
        Module["HEAPF32"] = HEAPF32 = new Float32Array(buffer);
        Module["HEAPF64"] = HEAPF64 = new Float64Array(buffer);
      }
      var STATIC_BASE, STATICTOP, staticSealed;
      var STACK_BASE, STACKTOP, STACK_MAX;
      var DYNAMIC_BASE, DYNAMICTOP_PTR;
      STATIC_BASE = STATICTOP = STACK_BASE = STACKTOP = STACK_MAX = DYNAMIC_BASE = DYNAMICTOP_PTR = 0;
      staticSealed = false;
      function abortOnCannotGrowMemory() {
        abort("Cannot enlarge memory arrays. Either (1) compile with  -s TOTAL_MEMORY=X  with X higher than the current value " + TOTAL_MEMORY + ", (2) compile with  -s ALLOW_MEMORY_GROWTH=1  which allows increasing the size at runtime but prevents some optimizations, (3) set Module.TOTAL_MEMORY to a higher value before the program runs, or (4) if you want malloc to return NULL (0) instead of this abort, compile with  -s ABORTING_MALLOC=0 ");
      }
      function enlargeMemory() {
        abortOnCannotGrowMemory();
      }
      var TOTAL_STACK = Module["TOTAL_STACK"] || 5242880;
      var TOTAL_MEMORY = Module["TOTAL_MEMORY"] || 134217728;
      if (TOTAL_MEMORY < TOTAL_STACK)
        Module.printErr("TOTAL_MEMORY should be larger than TOTAL_STACK, was " + TOTAL_MEMORY + "! (TOTAL_STACK=" + TOTAL_STACK + ")");
      if (Module["buffer"]) {
        buffer = Module["buffer"];
      } else {
        {
          buffer = new ArrayBuffer(TOTAL_MEMORY);
        }
      }
      updateGlobalBufferViews();
      function getTotalMemory() {
        return TOTAL_MEMORY;
      }
      HEAP32[0] = 1668509029;
      HEAP16[1] = 25459;
      if (HEAPU8[2] !== 115 || HEAPU8[3] !== 99)
        throw "Runtime error: expected the system to be little-endian!";
      Module["HEAP"] = HEAP;
      Module["buffer"] = buffer;
      Module["HEAP8"] = HEAP8;
      Module["HEAP16"] = HEAP16;
      Module["HEAP32"] = HEAP32;
      Module["HEAPU8"] = HEAPU8;
      Module["HEAPU16"] = HEAPU16;
      Module["HEAPU32"] = HEAPU32;
      Module["HEAPF32"] = HEAPF32;
      Module["HEAPF64"] = HEAPF64;
      function callRuntimeCallbacks(callbacks) {
        while (callbacks.length > 0) {
          var callback = callbacks.shift();
          if (typeof callback == "function") {
            callback();
            continue;
          }
          var func2 = callback.func;
          if (typeof func2 === "number") {
            if (callback.arg === void 0) {
              Module["dynCall_v"](func2);
            } else {
              Module["dynCall_vi"](func2, callback.arg);
            }
          } else {
            func2(callback.arg === void 0 ? null : callback.arg);
          }
        }
      }
      var __ATPRERUN__ = [];
      var __ATINIT__ = [];
      var __ATMAIN__ = [];
      var __ATEXIT__ = [];
      var __ATPOSTRUN__ = [];
      var runtimeInitialized = false;
      var runtimeExited = false;
      function preRun() {
        if (Module["preRun"]) {
          if (typeof Module["preRun"] == "function")
            Module["preRun"] = [Module["preRun"]];
          while (Module["preRun"].length) {
            addOnPreRun(Module["preRun"].shift());
          }
        }
        callRuntimeCallbacks(__ATPRERUN__);
      }
      function ensureInitRuntime() {
        if (runtimeInitialized)
          return;
        runtimeInitialized = true;
        callRuntimeCallbacks(__ATINIT__);
      }
      function preMain() {
        callRuntimeCallbacks(__ATMAIN__);
      }
      function exitRuntime() {
        callRuntimeCallbacks(__ATEXIT__);
        runtimeExited = true;
      }
      function postRun() {
        if (Module["postRun"]) {
          if (typeof Module["postRun"] == "function")
            Module["postRun"] = [Module["postRun"]];
          while (Module["postRun"].length) {
            addOnPostRun(Module["postRun"].shift());
          }
        }
        callRuntimeCallbacks(__ATPOSTRUN__);
      }
      function addOnPreRun(cb2) {
        __ATPRERUN__.unshift(cb2);
      }
      Module["addOnPreRun"] = addOnPreRun;
      function addOnInit(cb2) {
        __ATINIT__.unshift(cb2);
      }
      Module["addOnInit"] = addOnInit;
      function addOnPreMain(cb2) {
        __ATMAIN__.unshift(cb2);
      }
      Module["addOnPreMain"] = addOnPreMain;
      function addOnExit(cb2) {
        __ATEXIT__.unshift(cb2);
      }
      Module["addOnExit"] = addOnExit;
      function addOnPostRun(cb2) {
        __ATPOSTRUN__.unshift(cb2);
      }
      Module["addOnPostRun"] = addOnPostRun;
      function intArrayFromString(stringy, dontAddNull, length) {
        var len = length > 0 ? length : lengthBytesUTF8(stringy) + 1;
        var u8array = new Array(len);
        var numBytesWritten = stringToUTF8Array(stringy, u8array, 0, u8array.length);
        if (dontAddNull)
          u8array.length = numBytesWritten;
        return u8array;
      }
      Module["intArrayFromString"] = intArrayFromString;
      function intArrayToString(array) {
        var ret = [];
        for (var i3 = 0; i3 < array.length; i3++) {
          var chr = array[i3];
          if (chr > 255) {
            chr &= 255;
          }
          ret.push(String.fromCharCode(chr));
        }
        return ret.join("");
      }
      Module["intArrayToString"] = intArrayToString;
      function writeStringToMemory(string, buffer2, dontAddNull) {
        Runtime.warnOnce("writeStringToMemory is deprecated and should not be called! Use stringToUTF8() instead!");
        var lastChar, end;
        if (dontAddNull) {
          end = buffer2 + lengthBytesUTF8(string);
          lastChar = HEAP8[end];
        }
        stringToUTF8(string, buffer2, Infinity);
        if (dontAddNull)
          HEAP8[end] = lastChar;
      }
      Module["writeStringToMemory"] = writeStringToMemory;
      function writeArrayToMemory(array, buffer2) {
        HEAP8.set(array, buffer2);
      }
      Module["writeArrayToMemory"] = writeArrayToMemory;
      function writeAsciiToMemory(str2, buffer2, dontAddNull) {
        for (var i3 = 0; i3 < str2.length; ++i3) {
          HEAP8[buffer2++ >> 0] = str2.charCodeAt(i3);
        }
        if (!dontAddNull)
          HEAP8[buffer2 >> 0] = 0;
      }
      Module["writeAsciiToMemory"] = writeAsciiToMemory;
      if (!Math["imul"] || Math["imul"](4294967295, 5) !== -5)
        Math["imul"] = function imul(a2, b2) {
          var ah = a2 >>> 16;
          var al = a2 & 65535;
          var bh = b2 >>> 16;
          var bl = b2 & 65535;
          return al * bl + (ah * bl + al * bh << 16) | 0;
        };
      Math.imul = Math["imul"];
      if (!Math["fround"]) {
        var froundBuffer = new Float32Array(1);
        Math["fround"] = function(x) {
          froundBuffer[0] = x;
          return froundBuffer[0];
        };
      }
      Math.fround = Math["fround"];
      if (!Math["clz32"])
        Math["clz32"] = function(x) {
          x = x >>> 0;
          for (var i3 = 0; i3 < 32; i3++) {
            if (x & 1 << 31 - i3)
              return i3;
          }
          return 32;
        };
      Math.clz32 = Math["clz32"];
      if (!Math["trunc"])
        Math["trunc"] = function(x) {
          return x < 0 ? Math.ceil(x) : Math.floor(x);
        };
      Math.trunc = Math["trunc"];
      var Math_abs = Math.abs;
      var Math_cos = Math.cos;
      var Math_sin = Math.sin;
      var Math_tan = Math.tan;
      var Math_acos = Math.acos;
      var Math_asin = Math.asin;
      var Math_atan = Math.atan;
      var Math_atan2 = Math.atan2;
      var Math_exp = Math.exp;
      var Math_log = Math.log;
      var Math_sqrt = Math.sqrt;
      var Math_ceil = Math.ceil;
      var Math_floor = Math.floor;
      var Math_pow = Math.pow;
      var Math_imul = Math.imul;
      var Math_fround = Math.fround;
      var Math_round = Math.round;
      var Math_min = Math.min;
      var Math_clz32 = Math.clz32;
      var Math_trunc = Math.trunc;
      var runDependencies = 0;
      var runDependencyWatcher = null;
      var dependenciesFulfilled = null;
      function getUniqueRunDependency(id) {
        return id;
      }
      function addRunDependency(id) {
        runDependencies++;
        if (Module["monitorRunDependencies"]) {
          Module["monitorRunDependencies"](runDependencies);
        }
      }
      Module["addRunDependency"] = addRunDependency;
      function removeRunDependency(id) {
        runDependencies--;
        if (Module["monitorRunDependencies"]) {
          Module["monitorRunDependencies"](runDependencies);
        }
        if (runDependencies == 0) {
          if (runDependencyWatcher !== null) {
            clearInterval(runDependencyWatcher);
            runDependencyWatcher = null;
          }
          if (dependenciesFulfilled) {
            var callback = dependenciesFulfilled;
            dependenciesFulfilled = null;
            callback();
          }
        }
      }
      Module["removeRunDependency"] = removeRunDependency;
      Module["preloadedImages"] = {};
      Module["preloadedAudios"] = {};
      var ASM_CONSTS = [function($0, $1, $2, $3, $4, $5, $6, $7) {
        return _nbind.callbackSignatureList[$0].apply(this, arguments);
      }];
      function _emscripten_asm_const_iiiiiiii(code, a0, a1, a2, a3, a4, a5, a6) {
        return ASM_CONSTS[code](a0, a1, a2, a3, a4, a5, a6);
      }
      function _emscripten_asm_const_iiiii(code, a0, a1, a2, a3) {
        return ASM_CONSTS[code](a0, a1, a2, a3);
      }
      function _emscripten_asm_const_iiidddddd(code, a0, a1, a2, a3, a4, a5, a6, a7) {
        return ASM_CONSTS[code](a0, a1, a2, a3, a4, a5, a6, a7);
      }
      function _emscripten_asm_const_iiididi(code, a0, a1, a2, a3, a4, a5) {
        return ASM_CONSTS[code](a0, a1, a2, a3, a4, a5);
      }
      function _emscripten_asm_const_iiii(code, a0, a1, a2) {
        return ASM_CONSTS[code](a0, a1, a2);
      }
      function _emscripten_asm_const_iiiid(code, a0, a1, a2, a3) {
        return ASM_CONSTS[code](a0, a1, a2, a3);
      }
      function _emscripten_asm_const_iiiiii(code, a0, a1, a2, a3, a4) {
        return ASM_CONSTS[code](a0, a1, a2, a3, a4);
      }
      STATIC_BASE = Runtime.GLOBAL_BASE;
      STATICTOP = STATIC_BASE + 12800;
      __ATINIT__.push({ func: function() {
        __GLOBAL__sub_I_Yoga_cpp();
      } }, { func: function() {
        __GLOBAL__sub_I_nbind_cc();
      } }, { func: function() {
        __GLOBAL__sub_I_common_cc();
      } }, { func: function() {
        __GLOBAL__sub_I_Binding_cc();
      } });
      allocate([0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 192, 127, 0, 0, 192, 127, 0, 0, 192, 127, 0, 0, 192, 127, 3, 0, 0, 0, 0, 0, 192, 127, 0, 0, 0, 0, 0, 0, 192, 127, 0, 0, 0, 0, 0, 0, 192, 127, 0, 0, 0, 0, 0, 0, 192, 127, 0, 0, 0, 0, 0, 0, 192, 127, 0, 0, 0, 0, 0, 0, 192, 127, 0, 0, 0, 0, 0, 0, 192, 127, 0, 0, 0, 0, 0, 0, 192, 127, 0, 0, 0, 0, 0, 0, 192, 127, 0, 0, 0, 0, 0, 0, 192, 127, 0, 0, 0, 0, 0, 0, 192, 127, 0, 0, 0, 0, 0, 0, 192, 127, 0, 0, 0, 0, 0, 0, 192, 127, 0, 0, 0, 0, 0, 0, 192, 127, 0, 0, 0, 0, 0, 0, 192, 127, 0, 0, 0, 0, 0, 0, 192, 127, 0, 0, 0, 0, 0, 0, 192, 127, 0, 0, 0, 0, 0, 0, 192, 127, 0, 0, 0, 0, 0, 0, 192, 127, 0, 0, 0, 0, 0, 0, 192, 127, 0, 0, 0, 0, 0, 0, 192, 127, 0, 0, 0, 0, 0, 0, 192, 127, 0, 0, 0, 0, 0, 0, 192, 127, 0, 0, 0, 0, 0, 0, 192, 127, 0, 0, 0, 0, 0, 0, 192, 127, 0, 0, 0, 0, 0, 0, 192, 127, 0, 0, 0, 0, 0, 0, 192, 127, 0, 0, 0, 0, 0, 0, 192, 127, 0, 0, 0, 0, 0, 0, 192, 127, 0, 0, 0, 0, 0, 0, 192, 127, 0, 0, 0, 0, 0, 0, 192, 127, 0, 0, 0, 0, 0, 0, 192, 127, 0, 0, 0, 0, 0, 0, 192, 127, 0, 0, 0, 0, 0, 0, 192, 127, 0, 0, 0, 0, 0, 0, 192, 127, 0, 0, 0, 0, 0, 0, 192, 127, 0, 0, 0, 0, 0, 0, 192, 127, 3, 0, 0, 0, 0, 0, 192, 127, 3, 0, 0, 0, 0, 0, 192, 127, 0, 0, 0, 0, 0, 0, 192, 127, 0, 0, 0, 0, 0, 0, 192, 127, 0, 0, 0, 0, 0, 0, 192, 127, 0, 0, 0, 0, 0, 0, 192, 127, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 192, 127, 0, 0, 192, 127, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 192, 127, 0, 0, 0, 0, 0, 0, 0, 0, 255, 255, 255, 255, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 192, 127, 0, 0, 192, 127, 0, 0, 0, 0, 0, 0, 0, 0, 255, 255, 255, 255, 255, 255, 255, 255, 0, 0, 128, 191, 0, 0, 128, 191, 0, 0, 192, 127, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 128, 63, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 3, 0, 0, 0, 1, 0, 0, 0, 2, 0, 0, 0, 0, 0, 0, 0, 190, 12, 0, 0, 200, 12, 0, 0, 208, 12, 0, 0, 216, 12, 0, 0, 230, 12, 0, 0, 242, 12, 0, 0, 1, 0, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 192, 127, 3, 0, 0, 0, 180, 45, 0, 0, 181, 45, 0, 0, 182, 45, 0, 0, 181, 45, 0, 0, 182, 45, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 2, 0, 0, 0, 3, 0, 0, 0, 1, 0, 0, 0, 4, 0, 0, 0, 183, 45, 0, 0, 181, 45, 0, 0, 181, 45, 0, 0, 181, 45, 0, 0, 181, 45, 0, 0, 181, 45, 0, 0, 181, 45, 0, 0, 184, 45, 0, 0, 185, 45, 0, 0, 181, 45, 0, 0, 181, 45, 0, 0, 182, 45, 0, 0, 186, 45, 0, 0, 185, 45, 0, 0, 148, 4, 0, 0, 3, 0, 0, 0, 187, 45, 0, 0, 164, 4, 0, 0, 188, 45, 0, 0, 2, 0, 0, 0, 189, 45, 0, 0, 164, 4, 0, 0, 188, 45, 0, 0, 185, 45, 0, 0, 164, 4, 0, 0, 185, 45, 0, 0, 164, 4, 0, 0, 188, 45, 0, 0, 181, 45, 0, 0, 182, 45, 0, 0, 181, 45, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 5, 0, 0, 0, 6, 0, 0, 0, 1, 0, 0, 0, 7, 0, 0, 0, 183, 45, 0, 0, 182, 45, 0, 0, 181, 45, 0, 0, 190, 45, 0, 0, 190, 45, 0, 0, 182, 45, 0, 0, 182, 45, 0, 0, 185, 45, 0, 0, 181, 45, 0, 0, 185, 45, 0, 0, 182, 45, 0, 0, 181, 45, 0, 0, 185, 45, 0, 0, 182, 45, 0, 0, 185, 45, 0, 0, 48, 5, 0, 0, 3, 0, 0, 0, 56, 5, 0, 0, 1, 0, 0, 0, 189, 45, 0, 0, 185, 45, 0, 0, 164, 4, 0, 0, 76, 5, 0, 0, 2, 0, 0, 0, 191, 45, 0, 0, 186, 45, 0, 0, 182, 45, 0, 0, 185, 45, 0, 0, 192, 45, 0, 0, 185, 45, 0, 0, 182, 45, 0, 0, 186, 45, 0, 0, 185, 45, 0, 0, 76, 5, 0, 0, 76, 5, 0, 0, 136, 5, 0, 0, 182, 45, 0, 0, 181, 45, 0, 0, 2, 0, 0, 0, 190, 45, 0, 0, 136, 5, 0, 0, 56, 19, 0, 0, 156, 5, 0, 0, 2, 0, 0, 0, 184, 45, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 8, 0, 0, 0, 9, 0, 0, 0, 1, 0, 0, 0, 10, 0, 0, 0, 204, 5, 0, 0, 181, 45, 0, 0, 181, 45, 0, 0, 2, 0, 0, 0, 180, 45, 0, 0, 204, 5, 0, 0, 2, 0, 0, 0, 195, 45, 0, 0, 236, 5, 0, 0, 97, 19, 0, 0, 198, 45, 0, 0, 211, 45, 0, 0, 212, 45, 0, 0, 213, 45, 0, 0, 214, 45, 0, 0, 215, 45, 0, 0, 188, 45, 0, 0, 182, 45, 0, 0, 216, 45, 0, 0, 217, 45, 0, 0, 218, 45, 0, 0, 219, 45, 0, 0, 192, 45, 0, 0, 181, 45, 0, 0, 0, 0, 0, 0, 185, 45, 0, 0, 110, 19, 0, 0, 186, 45, 0, 0, 115, 19, 0, 0, 221, 45, 0, 0, 120, 19, 0, 0, 148, 4, 0, 0, 132, 19, 0, 0, 96, 6, 0, 0, 145, 19, 0, 0, 222, 45, 0, 0, 164, 19, 0, 0, 223, 45, 0, 0, 173, 19, 0, 0, 0, 0, 0, 0, 3, 0, 0, 0, 104, 6, 0, 0, 1, 0, 0, 0, 187, 45, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 11, 0, 0, 0, 12, 0, 0, 0, 1, 0, 0, 0, 13, 0, 0, 0, 185, 45, 0, 0, 224, 45, 0, 0, 164, 6, 0, 0, 188, 45, 0, 0, 172, 6, 0, 0, 180, 6, 0, 0, 2, 0, 0, 0, 188, 6, 0, 0, 7, 0, 0, 0, 224, 45, 0, 0, 7, 0, 0, 0, 164, 6, 0, 0, 1, 0, 0, 0, 213, 45, 0, 0, 185, 45, 0, 0, 224, 45, 0, 0, 172, 6, 0, 0, 185, 45, 0, 0, 224, 45, 0, 0, 164, 6, 0, 0, 185, 45, 0, 0, 224, 45, 0, 0, 211, 45, 0, 0, 211, 45, 0, 0, 222, 45, 0, 0, 211, 45, 0, 0, 224, 45, 0, 0, 222, 45, 0, 0, 211, 45, 0, 0, 224, 45, 0, 0, 172, 6, 0, 0, 222, 45, 0, 0, 211, 45, 0, 0, 224, 45, 0, 0, 188, 45, 0, 0, 222, 45, 0, 0, 211, 45, 0, 0, 40, 7, 0, 0, 188, 45, 0, 0, 2, 0, 0, 0, 224, 45, 0, 0, 185, 45, 0, 0, 188, 45, 0, 0, 188, 45, 0, 0, 188, 45, 0, 0, 188, 45, 0, 0, 222, 45, 0, 0, 224, 45, 0, 0, 148, 4, 0, 0, 185, 45, 0, 0, 148, 4, 0, 0, 148, 4, 0, 0, 148, 4, 0, 0, 148, 4, 0, 0, 148, 4, 0, 0, 185, 45, 0, 0, 164, 6, 0, 0, 148, 4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 14, 0, 0, 0, 15, 0, 0, 0, 1, 0, 0, 0, 16, 0, 0, 0, 148, 7, 0, 0, 2, 0, 0, 0, 225, 45, 0, 0, 183, 45, 0, 0, 188, 45, 0, 0, 168, 7, 0, 0, 5, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 2, 0, 0, 0, 234, 45, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 255, 255, 255, 255, 255, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 148, 45, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 28, 9, 0, 0, 5, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3, 0, 0, 0, 2, 0, 0, 0, 242, 45, 0, 0, 0, 4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 10, 255, 255, 255, 255, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 67, 111, 117, 108, 100, 32, 110, 111, 116, 32, 97, 108, 108, 111, 99, 97, 116, 101, 32, 109, 101, 109, 111, 114, 121, 32, 102, 111, 114, 32, 110, 111, 100, 101, 0, 67, 97, 110, 110, 111, 116, 32, 114, 101, 115, 101, 116, 32, 97, 32, 110, 111, 100, 101, 32, 119, 104, 105, 99, 104, 32, 115, 116, 105, 108, 108, 32, 104, 97, 115, 32, 99, 104, 105, 108, 100, 114, 101, 110, 32, 97, 116, 116, 97, 99, 104, 101, 100, 0, 67, 97, 110, 110, 111, 116, 32, 114, 101, 115, 101, 116, 32, 97, 32, 110, 111, 100, 101, 32, 115, 116, 105, 108, 108, 32, 97, 116, 116, 97, 99, 104, 101, 100, 32, 116, 111, 32, 97, 32, 112, 97, 114, 101, 110, 116, 0, 67, 111, 117, 108, 100, 32, 110, 111, 116, 32, 97, 108, 108, 111, 99, 97, 116, 101, 32, 109, 101, 109, 111, 114, 121, 32, 102, 111, 114, 32, 99, 111, 110, 102, 105, 103, 0, 67, 97, 110, 110, 111, 116, 32, 115, 101, 116, 32, 109, 101, 97, 115, 117, 114, 101, 32, 102, 117, 110, 99, 116, 105, 111, 110, 58, 32, 78, 111, 100, 101, 115, 32, 119, 105, 116, 104, 32, 109, 101, 97, 115, 117, 114, 101, 32, 102, 117, 110, 99, 116, 105, 111, 110, 115, 32, 99, 97, 110, 110, 111, 116, 32, 104, 97, 118, 101, 32, 99, 104, 105, 108, 100, 114, 101, 110, 46, 0, 67, 104, 105, 108, 100, 32, 97, 108, 114, 101, 97, 100, 121, 32, 104, 97, 115, 32, 97, 32, 112, 97, 114, 101, 110, 116, 44, 32, 105, 116, 32, 109, 117, 115, 116, 32, 98, 101, 32, 114, 101, 109, 111, 118, 101, 100, 32, 102, 105, 114, 115, 116, 46, 0, 67, 97, 110, 110, 111, 116, 32, 97, 100, 100, 32, 99, 104, 105, 108, 100, 58, 32, 78, 111, 100, 101, 115, 32, 119, 105, 116, 104, 32, 109, 101, 97, 115, 117, 114, 101, 32, 102, 117, 110, 99, 116, 105, 111, 110, 115, 32, 99, 97, 110, 110, 111, 116, 32, 104, 97, 118, 101, 32, 99, 104, 105, 108, 100, 114, 101, 110, 46, 0, 79, 110, 108, 121, 32, 108, 101, 97, 102, 32, 110, 111, 100, 101, 115, 32, 119, 105, 116, 104, 32, 99, 117, 115, 116, 111, 109, 32, 109, 101, 97, 115, 117, 114, 101, 32, 102, 117, 110, 99, 116, 105, 111, 110, 115, 115, 104, 111, 117, 108, 100, 32, 109, 97, 110, 117, 97, 108, 108, 121, 32, 109, 97, 114, 107, 32, 116, 104, 101, 109, 115, 101, 108, 118, 101, 115, 32, 97, 115, 32, 100, 105, 114, 116, 121, 0, 67, 97, 110, 110, 111, 116, 32, 103, 101, 116, 32, 108, 97, 121, 111, 117, 116, 32, 112, 114, 111, 112, 101, 114, 116, 105, 101, 115, 32, 111, 102, 32, 109, 117, 108, 116, 105, 45, 101, 100, 103, 101, 32, 115, 104, 111, 114, 116, 104, 97, 110, 100, 115, 0, 37, 115, 37, 100, 46, 123, 91, 115, 107, 105, 112, 112, 101, 100, 93, 32, 0, 119, 109, 58, 32, 37, 115, 44, 32, 104, 109, 58, 32, 37, 115, 44, 32, 97, 119, 58, 32, 37, 102, 32, 97, 104, 58, 32, 37, 102, 32, 61, 62, 32, 100, 58, 32, 40, 37, 102, 44, 32, 37, 102, 41, 32, 37, 115, 10, 0, 37, 115, 37, 100, 46, 123, 37, 115, 0, 42, 0, 119, 109, 58, 32, 37, 115, 44, 32, 104, 109, 58, 32, 37, 115, 44, 32, 97, 119, 58, 32, 37, 102, 32, 97, 104, 58, 32, 37, 102, 32, 37, 115, 10, 0, 37, 115, 37, 100, 46, 125, 37, 115, 0, 119, 109, 58, 32, 37, 115, 44, 32, 104, 109, 58, 32, 37, 115, 44, 32, 100, 58, 32, 40, 37, 102, 44, 32, 37, 102, 41, 32, 37, 115, 10, 0, 79, 117, 116, 32, 111, 102, 32, 99, 97, 99, 104, 101, 32, 101, 110, 116, 114, 105, 101, 115, 33, 10, 0, 83, 99, 97, 108, 101, 32, 102, 97, 99, 116, 111, 114, 32, 115, 104, 111, 117, 108, 100, 32, 110, 111, 116, 32, 98, 101, 32, 108, 101, 115, 115, 32, 116, 104, 97, 110, 32, 122, 101, 114, 111, 0, 105, 110, 105, 116, 105, 97, 108, 0, 37, 115, 10, 0, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 0, 85, 78, 68, 69, 70, 73, 78, 69, 68, 0, 69, 88, 65, 67, 84, 76, 89, 0, 65, 84, 95, 77, 79, 83, 84, 0, 76, 65, 89, 95, 85, 78, 68, 69, 70, 73, 78, 69, 68, 0, 76, 65, 89, 95, 69, 88, 65, 67, 84, 76, 89, 0, 76, 65, 89, 95, 65, 84, 95, 77, 79, 83, 84, 0, 97, 118, 97, 105, 108, 97, 98, 108, 101, 87, 105, 100, 116, 104, 32, 105, 115, 32, 105, 110, 100, 101, 102, 105, 110, 105, 116, 101, 32, 115, 111, 32, 119, 105, 100, 116, 104, 77, 101, 97, 115, 117, 114, 101, 77, 111, 100, 101, 32, 109, 117, 115, 116, 32, 98, 101, 32, 89, 71, 77, 101, 97, 115, 117, 114, 101, 77, 111, 100, 101, 85, 110, 100, 101, 102, 105, 110, 101, 100, 0, 97, 118, 97, 105, 108, 97, 98, 108, 101, 72, 101, 105, 103, 104, 116, 32, 105, 115, 32, 105, 110, 100, 101, 102, 105, 110, 105, 116, 101, 32, 115, 111, 32, 104, 101, 105, 103, 104, 116, 77, 101, 97, 115, 117, 114, 101, 77, 111, 100, 101, 32, 109, 117, 115, 116, 32, 98, 101, 32, 89, 71, 77, 101, 97, 115, 117, 114, 101, 77, 111, 100, 101, 85, 110, 100, 101, 102, 105, 110, 101, 100, 0, 102, 108, 101, 120, 0, 115, 116, 114, 101, 116, 99, 104, 0, 109, 117, 108, 116, 105, 108, 105, 110, 101, 45, 115, 116, 114, 101, 116, 99, 104, 0, 69, 120, 112, 101, 99, 116, 101, 100, 32, 110, 111, 100, 101, 32, 116, 111, 32, 104, 97, 118, 101, 32, 99, 117, 115, 116, 111, 109, 32, 109, 101, 97, 115, 117, 114, 101, 32, 102, 117, 110, 99, 116, 105, 111, 110, 0, 109, 101, 97, 115, 117, 114, 101, 0, 69, 120, 112, 101, 99, 116, 32, 99, 117, 115, 116, 111, 109, 32, 98, 97, 115, 101, 108, 105, 110, 101, 32, 102, 117, 110, 99, 116, 105, 111, 110, 32, 116, 111, 32, 110, 111, 116, 32, 114, 101, 116, 117, 114, 110, 32, 78, 97, 78, 0, 97, 98, 115, 45, 109, 101, 97, 115, 117, 114, 101, 0, 97, 98, 115, 45, 108, 97, 121, 111, 117, 116, 0, 78, 111, 100, 101, 0, 99, 114, 101, 97, 116, 101, 68, 101, 102, 97, 117, 108, 116, 0, 99, 114, 101, 97, 116, 101, 87, 105, 116, 104, 67, 111, 110, 102, 105, 103, 0, 100, 101, 115, 116, 114, 111, 121, 0, 114, 101, 115, 101, 116, 0, 99, 111, 112, 121, 83, 116, 121, 108, 101, 0, 115, 101, 116, 80, 111, 115, 105, 116, 105, 111, 110, 84, 121, 112, 101, 0, 115, 101, 116, 80, 111, 115, 105, 116, 105, 111, 110, 0, 115, 101, 116, 80, 111, 115, 105, 116, 105, 111, 110, 80, 101, 114, 99, 101, 110, 116, 0, 115, 101, 116, 65, 108, 105, 103, 110, 67, 111, 110, 116, 101, 110, 116, 0, 115, 101, 116, 65, 108, 105, 103, 110, 73, 116, 101, 109, 115, 0, 115, 101, 116, 65, 108, 105, 103, 110, 83, 101, 108, 102, 0, 115, 101, 116, 70, 108, 101, 120, 68, 105, 114, 101, 99, 116, 105, 111, 110, 0, 115, 101, 116, 70, 108, 101, 120, 87, 114, 97, 112, 0, 115, 101, 116, 74, 117, 115, 116, 105, 102, 121, 67, 111, 110, 116, 101, 110, 116, 0, 115, 101, 116, 77, 97, 114, 103, 105, 110, 0, 115, 101, 116, 77, 97, 114, 103, 105, 110, 80, 101, 114, 99, 101, 110, 116, 0, 115, 101, 116, 77, 97, 114, 103, 105, 110, 65, 117, 116, 111, 0, 115, 101, 116, 79, 118, 101, 114, 102, 108, 111, 119, 0, 115, 101, 116, 68, 105, 115, 112, 108, 97, 121, 0, 115, 101, 116, 70, 108, 101, 120, 0, 115, 101, 116, 70, 108, 101, 120, 66, 97, 115, 105, 115, 0, 115, 101, 116, 70, 108, 101, 120, 66, 97, 115, 105, 115, 80, 101, 114, 99, 101, 110, 116, 0, 115, 101, 116, 70, 108, 101, 120, 71, 114, 111, 119, 0, 115, 101, 116, 70, 108, 101, 120, 83, 104, 114, 105, 110, 107, 0, 115, 101, 116, 87, 105, 100, 116, 104, 0, 115, 101, 116, 87, 105, 100, 116, 104, 80, 101, 114, 99, 101, 110, 116, 0, 115, 101, 116, 87, 105, 100, 116, 104, 65, 117, 116, 111, 0, 115, 101, 116, 72, 101, 105, 103, 104, 116, 0, 115, 101, 116, 72, 101, 105, 103, 104, 116, 80, 101, 114, 99, 101, 110, 116, 0, 115, 101, 116, 72, 101, 105, 103, 104, 116, 65, 117, 116, 111, 0, 115, 101, 116, 77, 105, 110, 87, 105, 100, 116, 104, 0, 115, 101, 116, 77, 105, 110, 87, 105, 100, 116, 104, 80, 101, 114, 99, 101, 110, 116, 0, 115, 101, 116, 77, 105, 110, 72, 101, 105, 103, 104, 116, 0, 115, 101, 116, 77, 105, 110, 72, 101, 105, 103, 104, 116, 80, 101, 114, 99, 101, 110, 116, 0, 115, 101, 116, 77, 97, 120, 87, 105, 100, 116, 104, 0, 115, 101, 116, 77, 97, 120, 87, 105, 100, 116, 104, 80, 101, 114, 99, 101, 110, 116, 0, 115, 101, 116, 77, 97, 120, 72, 101, 105, 103, 104, 116, 0, 115, 101, 116, 77, 97, 120, 72, 101, 105, 103, 104, 116, 80, 101, 114, 99, 101, 110, 116, 0, 115, 101, 116, 65, 115, 112, 101, 99, 116, 82, 97, 116, 105, 111, 0, 115, 101, 116, 66, 111, 114, 100, 101, 114, 0, 115, 101, 116, 80, 97, 100, 100, 105, 110, 103, 0, 115, 101, 116, 80, 97, 100, 100, 105, 110, 103, 80, 101, 114, 99, 101, 110, 116, 0, 103, 101, 116, 80, 111, 115, 105, 116, 105, 111, 110, 84, 121, 112, 101, 0, 103, 101, 116, 80, 111, 115, 105, 116, 105, 111, 110, 0, 103, 101, 116, 65, 108, 105, 103, 110, 67, 111, 110, 116, 101, 110, 116, 0, 103, 101, 116, 65, 108, 105, 103, 110, 73, 116, 101, 109, 115, 0, 103, 101, 116, 65, 108, 105, 103, 110, 83, 101, 108, 102, 0, 103, 101, 116, 70, 108, 101, 120, 68, 105, 114, 101, 99, 116, 105, 111, 110, 0, 103, 101, 116, 70, 108, 101, 120, 87, 114, 97, 112, 0, 103, 101, 116, 74, 117, 115, 116, 105, 102, 121, 67, 111, 110, 116, 101, 110, 116, 0, 103, 101, 116, 77, 97, 114, 103, 105, 110, 0, 103, 101, 116, 70, 108, 101, 120, 66, 97, 115, 105, 115, 0, 103, 101, 116, 70, 108, 101, 120, 71, 114, 111, 119, 0, 103, 101, 116, 70, 108, 101, 120, 83, 104, 114, 105, 110, 107, 0, 103, 101, 116, 87, 105, 100, 116, 104, 0, 103, 101, 116, 72, 101, 105, 103, 104, 116, 0, 103, 101, 116, 77, 105, 110, 87, 105, 100, 116, 104, 0, 103, 101, 116, 77, 105, 110, 72, 101, 105, 103, 104, 116, 0, 103, 101, 116, 77, 97, 120, 87, 105, 100, 116, 104, 0, 103, 101, 116, 77, 97, 120, 72, 101, 105, 103, 104, 116, 0, 103, 101, 116, 65, 115, 112, 101, 99, 116, 82, 97, 116, 105, 111, 0, 103, 101, 116, 66, 111, 114, 100, 101, 114, 0, 103, 101, 116, 79, 118, 101, 114, 102, 108, 111, 119, 0, 103, 101, 116, 68, 105, 115, 112, 108, 97, 121, 0, 103, 101, 116, 80, 97, 100, 100, 105, 110, 103, 0, 105, 110, 115, 101, 114, 116, 67, 104, 105, 108, 100, 0, 114, 101, 109, 111, 118, 101, 67, 104, 105, 108, 100, 0, 103, 101, 116, 67, 104, 105, 108, 100, 67, 111, 117, 110, 116, 0, 103, 101, 116, 80, 97, 114, 101, 110, 116, 0, 103, 101, 116, 67, 104, 105, 108, 100, 0, 115, 101, 116, 77, 101, 97, 115, 117, 114, 101, 70, 117, 110, 99, 0, 117, 110, 115, 101, 116, 77, 101, 97, 115, 117, 114, 101, 70, 117, 110, 99, 0, 109, 97, 114, 107, 68, 105, 114, 116, 121, 0, 105, 115, 68, 105, 114, 116, 121, 0, 99, 97, 108, 99, 117, 108, 97, 116, 101, 76, 97, 121, 111, 117, 116, 0, 103, 101, 116, 67, 111, 109, 112, 117, 116, 101, 100, 76, 101, 102, 116, 0, 103, 101, 116, 67, 111, 109, 112, 117, 116, 101, 100, 82, 105, 103, 104, 116, 0, 103, 101, 116, 67, 111, 109, 112, 117, 116, 101, 100, 84, 111, 112, 0, 103, 101, 116, 67, 111, 109, 112, 117, 116, 101, 100, 66, 111, 116, 116, 111, 109, 0, 103, 101, 116, 67, 111, 109, 112, 117, 116, 101, 100, 87, 105, 100, 116, 104, 0, 103, 101, 116, 67, 111, 109, 112, 117, 116, 101, 100, 72, 101, 105, 103, 104, 116, 0, 103, 101, 116, 67, 111, 109, 112, 117, 116, 101, 100, 76, 97, 121, 111, 117, 116, 0, 103, 101, 116, 67, 111, 109, 112, 117, 116, 101, 100, 77, 97, 114, 103, 105, 110, 0, 103, 101, 116, 67, 111, 109, 112, 117, 116, 101, 100, 66, 111, 114, 100, 101, 114, 0, 103, 101, 116, 67, 111, 109, 112, 117, 116, 101, 100, 80, 97, 100, 100, 105, 110, 103, 0, 67, 111, 110, 102, 105, 103, 0, 99, 114, 101, 97, 116, 101, 0, 115, 101, 116, 69, 120, 112, 101, 114, 105, 109, 101, 110, 116, 97, 108, 70, 101, 97, 116, 117, 114, 101, 69, 110, 97, 98, 108, 101, 100, 0, 115, 101, 116, 80, 111, 105, 110, 116, 83, 99, 97, 108, 101, 70, 97, 99, 116, 111, 114, 0, 105, 115, 69, 120, 112, 101, 114, 105, 109, 101, 110, 116, 97, 108, 70, 101, 97, 116, 117, 114, 101, 69, 110, 97, 98, 108, 101, 100, 0, 86, 97, 108, 117, 101, 0, 76, 97, 121, 111, 117, 116, 0, 83, 105, 122, 101, 0, 103, 101, 116, 73, 110, 115, 116, 97, 110, 99, 101, 67, 111, 117, 110, 116, 0, 73, 110, 116, 54, 52, 0, 1, 1, 1, 2, 2, 4, 4, 4, 4, 8, 8, 4, 8, 118, 111, 105, 100, 0, 98, 111, 111, 108, 0, 115, 116, 100, 58, 58, 115, 116, 114, 105, 110, 103, 0, 99, 98, 70, 117, 110, 99, 116, 105, 111, 110, 32, 38, 0, 99, 111, 110, 115, 116, 32, 99, 98, 70, 117, 110, 99, 116, 105, 111, 110, 32, 38, 0, 69, 120, 116, 101, 114, 110, 97, 108, 0, 66, 117, 102, 102, 101, 114, 0, 78, 66, 105, 110, 100, 73, 68, 0, 78, 66, 105, 110, 100, 0, 98, 105, 110, 100, 95, 118, 97, 108, 117, 101, 0, 114, 101, 102, 108, 101, 99, 116, 0, 113, 117, 101, 114, 121, 84, 121, 112, 101, 0, 108, 97, 108, 108, 111, 99, 0, 108, 114, 101, 115, 101, 116, 0, 123, 114, 101, 116, 117, 114, 110, 40, 95, 110, 98, 105, 110, 100, 46, 99, 97, 108, 108, 98, 97, 99, 107, 83, 105, 103, 110, 97, 116, 117, 114, 101, 76, 105, 115, 116, 91, 36, 48, 93, 46, 97, 112, 112, 108, 121, 40, 116, 104, 105, 115, 44, 97, 114, 103, 117, 109, 101, 110, 116, 115, 41, 41, 59, 125, 0, 95, 110, 98, 105, 110, 100, 95, 110, 101, 119, 0, 17, 0, 10, 0, 17, 17, 17, 0, 0, 0, 0, 5, 0, 0, 0, 0, 0, 0, 9, 0, 0, 0, 0, 11, 0, 0, 0, 0, 0, 0, 0, 0, 17, 0, 15, 10, 17, 17, 17, 3, 10, 7, 0, 1, 19, 9, 11, 11, 0, 0, 9, 6, 11, 0, 0, 11, 0, 6, 17, 0, 0, 0, 17, 17, 17, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 11, 0, 0, 0, 0, 0, 0, 0, 0, 17, 0, 10, 10, 17, 17, 17, 0, 10, 0, 0, 2, 0, 9, 11, 0, 0, 0, 9, 0, 11, 0, 0, 11, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 12, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 12, 0, 0, 0, 0, 12, 0, 0, 0, 0, 9, 12, 0, 0, 0, 0, 0, 12, 0, 0, 12, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 14, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 0, 4, 13, 0, 0, 0, 0, 9, 14, 0, 0, 0, 0, 0, 14, 0, 0, 14, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 16, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 15, 0, 0, 0, 0, 15, 0, 0, 0, 0, 9, 16, 0, 0, 0, 0, 0, 16, 0, 0, 16, 0, 0, 18, 0, 0, 0, 18, 18, 18, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 18, 0, 0, 0, 18, 18, 18, 0, 0, 0, 0, 0, 0, 9, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 11, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 10, 0, 0, 0, 0, 10, 0, 0, 0, 0, 9, 11, 0, 0, 0, 0, 0, 11, 0, 0, 11, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 12, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 12, 0, 0, 0, 0, 12, 0, 0, 0, 0, 9, 12, 0, 0, 0, 0, 0, 12, 0, 0, 12, 0, 0, 45, 43, 32, 32, 32, 48, 88, 48, 120, 0, 40, 110, 117, 108, 108, 41, 0, 45, 48, 88, 43, 48, 88, 32, 48, 88, 45, 48, 120, 43, 48, 120, 32, 48, 120, 0, 105, 110, 102, 0, 73, 78, 70, 0, 110, 97, 110, 0, 78, 65, 78, 0, 48, 49, 50, 51, 52, 53, 54, 55, 56, 57, 65, 66, 67, 68, 69, 70, 46, 0, 84, 33, 34, 25, 13, 1, 2, 3, 17, 75, 28, 12, 16, 4, 11, 29, 18, 30, 39, 104, 110, 111, 112, 113, 98, 32, 5, 6, 15, 19, 20, 21, 26, 8, 22, 7, 40, 36, 23, 24, 9, 10, 14, 27, 31, 37, 35, 131, 130, 125, 38, 42, 43, 60, 61, 62, 63, 67, 71, 74, 77, 88, 89, 90, 91, 92, 93, 94, 95, 96, 97, 99, 100, 101, 102, 103, 105, 106, 107, 108, 114, 115, 116, 121, 122, 123, 124, 0, 73, 108, 108, 101, 103, 97, 108, 32, 98, 121, 116, 101, 32, 115, 101, 113, 117, 101, 110, 99, 101, 0, 68, 111, 109, 97, 105, 110, 32, 101, 114, 114, 111, 114, 0, 82, 101, 115, 117, 108, 116, 32, 110, 111, 116, 32, 114, 101, 112, 114, 101, 115, 101, 110, 116, 97, 98, 108, 101, 0, 78, 111, 116, 32, 97, 32, 116, 116, 121, 0, 80, 101, 114, 109, 105, 115, 115, 105, 111, 110, 32, 100, 101, 110, 105, 101, 100, 0, 79, 112, 101, 114, 97, 116, 105, 111, 110, 32, 110, 111, 116, 32, 112, 101, 114, 109, 105, 116, 116, 101, 100, 0, 78, 111, 32, 115, 117, 99, 104, 32, 102, 105, 108, 101, 32, 111, 114, 32, 100, 105, 114, 101, 99, 116, 111, 114, 121, 0, 78, 111, 32, 115, 117, 99, 104, 32, 112, 114, 111, 99, 101, 115, 115, 0, 70, 105, 108, 101, 32, 101, 120, 105, 115, 116, 115, 0, 86, 97, 108, 117, 101, 32, 116, 111, 111, 32, 108, 97, 114, 103, 101, 32, 102, 111, 114, 32, 100, 97, 116, 97, 32, 116, 121, 112, 101, 0, 78, 111, 32, 115, 112, 97, 99, 101, 32, 108, 101, 102, 116, 32, 111, 110, 32, 100, 101, 118, 105, 99, 101, 0, 79, 117, 116, 32, 111, 102, 32, 109, 101, 109, 111, 114, 121, 0, 82, 101, 115, 111, 117, 114, 99, 101, 32, 98, 117, 115, 121, 0, 73, 110, 116, 101, 114, 114, 117, 112, 116, 101, 100, 32, 115, 121, 115, 116, 101, 109, 32, 99, 97, 108, 108, 0, 82, 101, 115, 111, 117, 114, 99, 101, 32, 116, 101, 109, 112, 111, 114, 97, 114, 105, 108, 121, 32, 117, 110, 97, 118, 97, 105, 108, 97, 98, 108, 101, 0, 73, 110, 118, 97, 108, 105, 100, 32, 115, 101, 101, 107, 0, 67, 114, 111, 115, 115, 45, 100, 101, 118, 105, 99, 101, 32, 108, 105, 110, 107, 0, 82, 101, 97, 100, 45, 111, 110, 108, 121, 32, 102, 105, 108, 101, 32, 115, 121, 115, 116, 101, 109, 0, 68, 105, 114, 101, 99, 116, 111, 114, 121, 32, 110, 111, 116, 32, 101, 109, 112, 116, 121, 0, 67, 111, 110, 110, 101, 99, 116, 105, 111, 110, 32, 114, 101, 115, 101, 116, 32, 98, 121, 32, 112, 101, 101, 114, 0, 79, 112, 101, 114, 97, 116, 105, 111, 110, 32, 116, 105, 109, 101, 100, 32, 111, 117, 116, 0, 67, 111, 110, 110, 101, 99, 116, 105, 111, 110, 32, 114, 101, 102, 117, 115, 101, 100, 0, 72, 111, 115, 116, 32, 105, 115, 32, 100, 111, 119, 110, 0, 72, 111, 115, 116, 32, 105, 115, 32, 117, 110, 114, 101, 97, 99, 104, 97, 98, 108, 101, 0, 65, 100, 100, 114, 101, 115, 115, 32, 105, 110, 32, 117, 115, 101, 0, 66, 114, 111, 107, 101, 110, 32, 112, 105, 112, 101, 0, 73, 47, 79, 32, 101, 114, 114, 111, 114, 0, 78, 111, 32, 115, 117, 99, 104, 32, 100, 101, 118, 105, 99, 101, 32, 111, 114, 32, 97, 100, 100, 114, 101, 115, 115, 0, 66, 108, 111, 99, 107, 32, 100, 101, 118, 105, 99, 101, 32, 114, 101, 113, 117, 105, 114, 101, 100, 0, 78, 111, 32, 115, 117, 99, 104, 32, 100, 101, 118, 105, 99, 101, 0, 78, 111, 116, 32, 97, 32, 100, 105, 114, 101, 99, 116, 111, 114, 121, 0, 73, 115, 32, 97, 32, 100, 105, 114, 101, 99, 116, 111, 114, 121, 0, 84, 101, 120, 116, 32, 102, 105, 108, 101, 32, 98, 117, 115, 121, 0, 69, 120, 101, 99, 32, 102, 111, 114, 109, 97, 116, 32, 101, 114, 114, 111, 114, 0, 73, 110, 118, 97, 108, 105, 100, 32, 97, 114, 103, 117, 109, 101, 110, 116, 0, 65, 114, 103, 117, 109, 101, 110, 116, 32, 108, 105, 115, 116, 32, 116, 111, 111, 32, 108, 111, 110, 103, 0, 83, 121, 109, 98, 111, 108, 105, 99, 32, 108, 105, 110, 107, 32, 108, 111, 111, 112, 0, 70, 105, 108, 101, 110, 97, 109, 101, 32, 116, 111, 111, 32, 108, 111, 110, 103, 0, 84, 111, 111, 32, 109, 97, 110, 121, 32, 111, 112, 101, 110, 32, 102, 105, 108, 101, 115, 32, 105, 110, 32, 115, 121, 115, 116, 101, 109, 0, 78, 111, 32, 102, 105, 108, 101, 32, 100, 101, 115, 99, 114, 105, 112, 116, 111, 114, 115, 32, 97, 118, 97, 105, 108, 97, 98, 108, 101, 0, 66, 97, 100, 32, 102, 105, 108, 101, 32, 100, 101, 115, 99, 114, 105, 112, 116, 111, 114, 0, 78, 111, 32, 99, 104, 105, 108, 100, 32, 112, 114, 111, 99, 101, 115, 115, 0, 66, 97, 100, 32, 97, 100, 100, 114, 101, 115, 115, 0, 70, 105, 108, 101, 32, 116, 111, 111, 32, 108, 97, 114, 103, 101, 0, 84, 111, 111, 32, 109, 97, 110, 121, 32, 108, 105, 110, 107, 115, 0, 78, 111, 32, 108, 111, 99, 107, 115, 32, 97, 118, 97, 105, 108, 97, 98, 108, 101, 0, 82, 101, 115, 111, 117, 114, 99, 101, 32, 100, 101, 97, 100, 108, 111, 99, 107, 32, 119, 111, 117, 108, 100, 32, 111, 99, 99, 117, 114, 0, 83, 116, 97, 116, 101, 32, 110, 111, 116, 32, 114, 101, 99, 111, 118, 101, 114, 97, 98, 108, 101, 0, 80, 114, 101, 118, 105, 111, 117, 115, 32, 111, 119, 110, 101, 114, 32, 100, 105, 101, 100, 0, 79, 112, 101, 114, 97, 116, 105, 111, 110, 32, 99, 97, 110, 99, 101, 108, 101, 100, 0, 70, 117, 110, 99, 116, 105, 111, 110, 32, 110, 111, 116, 32, 105, 109, 112, 108, 101, 109, 101, 110, 116, 101, 100, 0, 78, 111, 32, 109, 101, 115, 115, 97, 103, 101, 32, 111, 102, 32, 100, 101, 115, 105, 114, 101, 100, 32, 116, 121, 112, 101, 0, 73, 100, 101, 110, 116, 105, 102, 105, 101, 114, 32, 114, 101, 109, 111, 118, 101, 100, 0, 68, 101, 118, 105, 99, 101, 32, 110, 111, 116, 32, 97, 32, 115, 116, 114, 101, 97, 109, 0, 78, 111, 32, 100, 97, 116, 97, 32, 97, 118, 97, 105, 108, 97, 98, 108, 101, 0, 68, 101, 118, 105, 99, 101, 32, 116, 105, 109, 101, 111, 117, 116, 0, 79, 117, 116, 32, 111, 102, 32, 115, 116, 114, 101, 97, 109, 115, 32, 114, 101, 115, 111, 117, 114, 99, 101, 115, 0, 76, 105, 110, 107, 32, 104, 97, 115, 32, 98, 101, 101, 110, 32, 115, 101, 118, 101, 114, 101, 100, 0, 80, 114, 111, 116, 111, 99, 111, 108, 32, 101, 114, 114, 111, 114, 0, 66, 97, 100, 32, 109, 101, 115, 115, 97, 103, 101, 0, 70, 105, 108, 101, 32, 100, 101, 115, 99, 114, 105, 112, 116, 111, 114, 32, 105, 110, 32, 98, 97, 100, 32, 115, 116, 97, 116, 101, 0, 78, 111, 116, 32, 97, 32, 115, 111, 99, 107, 101, 116, 0, 68, 101, 115, 116, 105, 110, 97, 116, 105, 111, 110, 32, 97, 100, 100, 114, 101, 115, 115, 32, 114, 101, 113, 117, 105, 114, 101, 100, 0, 77, 101, 115, 115, 97, 103, 101, 32, 116, 111, 111, 32, 108, 97, 114, 103, 101, 0, 80, 114, 111, 116, 111, 99, 111, 108, 32, 119, 114, 111, 110, 103, 32, 116, 121, 112, 101, 32, 102, 111, 114, 32, 115, 111, 99, 107, 101, 116, 0, 80, 114, 111, 116, 111, 99, 111, 108, 32, 110, 111, 116, 32, 97, 118, 97, 105, 108, 97, 98, 108, 101, 0, 80, 114, 111, 116, 111, 99, 111, 108, 32, 110, 111, 116, 32, 115, 117, 112, 112, 111, 114, 116, 101, 100, 0, 83, 111, 99, 107, 101, 116, 32, 116, 121, 112, 101, 32, 110, 111, 116, 32, 115, 117, 112, 112, 111, 114, 116, 101, 100, 0, 78, 111, 116, 32, 115, 117, 112, 112, 111, 114, 116, 101, 100, 0, 80, 114, 111, 116, 111, 99, 111, 108, 32, 102, 97, 109, 105, 108, 121, 32, 110, 111, 116, 32, 115, 117, 112, 112, 111, 114, 116, 101, 100, 0, 65, 100, 100, 114, 101, 115, 115, 32, 102, 97, 109, 105, 108, 121, 32, 110, 111, 116, 32, 115, 117, 112, 112, 111, 114, 116, 101, 100, 32, 98, 121, 32, 112, 114, 111, 116, 111, 99, 111, 108, 0, 65, 100, 100, 114, 101, 115, 115, 32, 110, 111, 116, 32, 97, 118, 97, 105, 108, 97, 98, 108, 101, 0, 78, 101, 116, 119, 111, 114, 107, 32, 105, 115, 32, 100, 111, 119, 110, 0, 78, 101, 116, 119, 111, 114, 107, 32, 117, 110, 114, 101, 97, 99, 104, 97, 98, 108, 101, 0, 67, 111, 110, 110, 101, 99, 116, 105, 111, 110, 32, 114, 101, 115, 101, 116, 32, 98, 121, 32, 110, 101, 116, 119, 111, 114, 107, 0, 67, 111, 110, 110, 101, 99, 116, 105, 111, 110, 32, 97, 98, 111, 114, 116, 101, 100, 0, 78, 111, 32, 98, 117, 102, 102, 101, 114, 32, 115, 112, 97, 99, 101, 32, 97, 118, 97, 105, 108, 97, 98, 108, 101, 0, 83, 111, 99, 107, 101, 116, 32, 105, 115, 32, 99, 111, 110, 110, 101, 99, 116, 101, 100, 0, 83, 111, 99, 107, 101, 116, 32, 110, 111, 116, 32, 99, 111, 110, 110, 101, 99, 116, 101, 100, 0, 67, 97, 110, 110, 111, 116, 32, 115, 101, 110, 100, 32, 97, 102, 116, 101, 114, 32, 115, 111, 99, 107, 101, 116, 32, 115, 104, 117, 116, 100, 111, 119, 110, 0, 79, 112, 101, 114, 97, 116, 105, 111, 110, 32, 97, 108, 114, 101, 97, 100, 121, 32, 105, 110, 32, 112, 114, 111, 103, 114, 101, 115, 115, 0, 79, 112, 101, 114, 97, 116, 105, 111, 110, 32, 105, 110, 32, 112, 114, 111, 103, 114, 101, 115, 115, 0, 83, 116, 97, 108, 101, 32, 102, 105, 108, 101, 32, 104, 97, 110, 100, 108, 101, 0, 82, 101, 109, 111, 116, 101, 32, 73, 47, 79, 32, 101, 114, 114, 111, 114, 0, 81, 117, 111, 116, 97, 32, 101, 120, 99, 101, 101, 100, 101, 100, 0, 78, 111, 32, 109, 101, 100, 105, 117, 109, 32, 102, 111, 117, 110, 100, 0, 87, 114, 111, 110, 103, 32, 109, 101, 100, 105, 117, 109, 32, 116, 121, 112, 101, 0, 78, 111, 32, 101, 114, 114, 111, 114, 32, 105, 110, 102, 111, 114, 109, 97, 116, 105, 111, 110, 0, 0], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE);
      var tempDoublePtr = STATICTOP;
      STATICTOP += 16;
      function _atexit(func2, arg2) {
        __ATEXIT__.unshift({ func: func2, arg: arg2 });
      }
      function ___cxa_atexit() {
        return _atexit.apply(null, arguments);
      }
      function _abort() {
        Module["abort"]();
      }
      function __ZN8facebook4yoga14YGNodeToStringEPNSt3__212basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEEP6YGNode14YGPrintOptionsj() {
        Module["printErr"]("missing function: _ZN8facebook4yoga14YGNodeToStringEPNSt3__212basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEEP6YGNode14YGPrintOptionsj");
        abort(-1);
      }
      function __decorate(decorators, target, key2, desc) {
        var c2 = arguments.length, r2 = c2 < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key2) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
          r2 = Reflect.decorate(decorators, target, key2, desc);
        else
          for (var i3 = decorators.length - 1; i3 >= 0; i3--)
            if (d = decorators[i3])
              r2 = (c2 < 3 ? d(r2) : c2 > 3 ? d(target, key2, r2) : d(target, key2)) || r2;
        return c2 > 3 && r2 && Object.defineProperty(target, key2, r2), r2;
      }
      function _defineHidden(value) {
        return function(target, key2) {
          Object.defineProperty(target, key2, { configurable: false, enumerable: false, value, writable: true });
        };
      }
      var _nbind = {};
      function __nbind_free_external(num2) {
        _nbind.externalList[num2].dereference(num2);
      }
      function __nbind_reference_external(num2) {
        _nbind.externalList[num2].reference();
      }
      function _llvm_stackrestore(p) {
        var self2 = _llvm_stacksave;
        var ret = self2.LLVM_SAVEDSTACKS[p];
        self2.LLVM_SAVEDSTACKS.splice(p, 1);
        Runtime.stackRestore(ret);
      }
      function __nbind_register_pool(pageSize, usedPtr, rootPtr, pagePtr) {
        _nbind.Pool.pageSize = pageSize;
        _nbind.Pool.usedPtr = usedPtr / 4;
        _nbind.Pool.rootPtr = rootPtr;
        _nbind.Pool.pagePtr = pagePtr / 4;
        HEAP32[usedPtr / 4] = 16909060;
        if (HEAP8[usedPtr] == 1)
          _nbind.bigEndian = true;
        HEAP32[usedPtr / 4] = 0;
        _nbind.makeTypeKindTbl = (_a2 = {}, _a2[1024] = _nbind.PrimitiveType, _a2[64] = _nbind.Int64Type, _a2[2048] = _nbind.BindClass, _a2[3072] = _nbind.BindClassPtr, _a2[4096] = _nbind.SharedClassPtr, _a2[5120] = _nbind.ArrayType, _a2[6144] = _nbind.ArrayType, _a2[7168] = _nbind.CStringType, _a2[9216] = _nbind.CallbackType, _a2[10240] = _nbind.BindType, _a2);
        _nbind.makeTypeNameTbl = { "Buffer": _nbind.BufferType, "External": _nbind.ExternalType, "Int64": _nbind.Int64Type, "_nbind_new": _nbind.CreateValueType, "bool": _nbind.BooleanType, "cbFunction &": _nbind.CallbackType, "const cbFunction &": _nbind.CallbackType, "const std::string &": _nbind.StringType, "std::string": _nbind.StringType };
        Module["toggleLightGC"] = _nbind.toggleLightGC;
        _nbind.callUpcast = Module["dynCall_ii"];
        var globalScope = _nbind.makeType(_nbind.constructType, { flags: 2048, id: 0, name: "" });
        globalScope.proto = Module;
        _nbind.BindClass.list.push(globalScope);
        var _a2;
      }
      function _emscripten_set_main_loop_timing(mode, value) {
        Browser.mainLoop.timingMode = mode;
        Browser.mainLoop.timingValue = value;
        if (!Browser.mainLoop.func) {
          return 1;
        }
        if (mode == 0) {
          Browser.mainLoop.scheduler = function Browser_mainLoop_scheduler_setTimeout() {
            var timeUntilNextTick = Math.max(0, Browser.mainLoop.tickStartTime + value - _emscripten_get_now()) | 0;
            setTimeout(Browser.mainLoop.runner, timeUntilNextTick);
          };
          Browser.mainLoop.method = "timeout";
        } else if (mode == 1) {
          Browser.mainLoop.scheduler = function Browser_mainLoop_scheduler_rAF() {
            Browser.requestAnimationFrame(Browser.mainLoop.runner);
          };
          Browser.mainLoop.method = "rAF";
        } else if (mode == 2) {
          if (!window["setImmediate"]) {
            let Browser_setImmediate_messageHandler2 = function(event2) {
              if (event2.source === window && event2.data === emscriptenMainLoopMessageId) {
                event2.stopPropagation();
                setImmediates.shift()();
              }
            };
            var Browser_setImmediate_messageHandler = Browser_setImmediate_messageHandler2;
            var setImmediates = [];
            var emscriptenMainLoopMessageId = "setimmediate";
            window.addEventListener("message", Browser_setImmediate_messageHandler2, true);
            window["setImmediate"] = function Browser_emulated_setImmediate(func2) {
              setImmediates.push(func2);
              if (ENVIRONMENT_IS_WORKER) {
                if (Module["setImmediates"] === void 0)
                  Module["setImmediates"] = [];
                Module["setImmediates"].push(func2);
                window.postMessage({ target: emscriptenMainLoopMessageId });
              } else
                window.postMessage(emscriptenMainLoopMessageId, "*");
            };
          }
          Browser.mainLoop.scheduler = function Browser_mainLoop_scheduler_setImmediate() {
            window["setImmediate"](Browser.mainLoop.runner);
          };
          Browser.mainLoop.method = "immediate";
        }
        return 0;
      }
      function _emscripten_get_now() {
        abort();
      }
      function _emscripten_set_main_loop(func2, fps, simulateInfiniteLoop, arg2, noSetTiming) {
        Module["noExitRuntime"] = true;
        assert(!Browser.mainLoop.func, "emscripten_set_main_loop: there can only be one main loop function at once: call emscripten_cancel_main_loop to cancel the previous one before setting a new one with different parameters.");
        Browser.mainLoop.func = func2;
        Browser.mainLoop.arg = arg2;
        var browserIterationFunc;
        if (typeof arg2 !== "undefined") {
          browserIterationFunc = function() {
            Module["dynCall_vi"](func2, arg2);
          };
        } else {
          browserIterationFunc = function() {
            Module["dynCall_v"](func2);
          };
        }
        var thisMainLoopId = Browser.mainLoop.currentlyRunningMainloop;
        Browser.mainLoop.runner = function Browser_mainLoop_runner() {
          if (ABORT)
            return;
          if (Browser.mainLoop.queue.length > 0) {
            var start = Date.now();
            var blocker = Browser.mainLoop.queue.shift();
            blocker.func(blocker.arg);
            if (Browser.mainLoop.remainingBlockers) {
              var remaining = Browser.mainLoop.remainingBlockers;
              var next = remaining % 1 == 0 ? remaining - 1 : Math.floor(remaining);
              if (blocker.counted) {
                Browser.mainLoop.remainingBlockers = next;
              } else {
                next = next + 0.5;
                Browser.mainLoop.remainingBlockers = (8 * remaining + next) / 9;
              }
            }
            console.log('main loop blocker "' + blocker.name + '" took ' + (Date.now() - start) + " ms");
            Browser.mainLoop.updateStatus();
            if (thisMainLoopId < Browser.mainLoop.currentlyRunningMainloop)
              return;
            setTimeout(Browser.mainLoop.runner, 0);
            return;
          }
          if (thisMainLoopId < Browser.mainLoop.currentlyRunningMainloop)
            return;
          Browser.mainLoop.currentFrameNumber = Browser.mainLoop.currentFrameNumber + 1 | 0;
          if (Browser.mainLoop.timingMode == 1 && Browser.mainLoop.timingValue > 1 && Browser.mainLoop.currentFrameNumber % Browser.mainLoop.timingValue != 0) {
            Browser.mainLoop.scheduler();
            return;
          } else if (Browser.mainLoop.timingMode == 0) {
            Browser.mainLoop.tickStartTime = _emscripten_get_now();
          }
          if (Browser.mainLoop.method === "timeout" && Module.ctx) {
            Module.printErr("Looks like you are rendering without using requestAnimationFrame for the main loop. You should use 0 for the frame rate in emscripten_set_main_loop in order to use requestAnimationFrame, as that can greatly improve your frame rates!");
            Browser.mainLoop.method = "";
          }
          Browser.mainLoop.runIter(browserIterationFunc);
          if (thisMainLoopId < Browser.mainLoop.currentlyRunningMainloop)
            return;
          if (typeof SDL === "object" && SDL.audio && SDL.audio.queueNewAudioData)
            SDL.audio.queueNewAudioData();
          Browser.mainLoop.scheduler();
        };
        if (!noSetTiming) {
          if (fps && fps > 0)
            _emscripten_set_main_loop_timing(0, 1e3 / fps);
          else
            _emscripten_set_main_loop_timing(1, 1);
          Browser.mainLoop.scheduler();
        }
        if (simulateInfiniteLoop) {
          throw "SimulateInfiniteLoop";
        }
      }
      var Browser = { mainLoop: { scheduler: null, method: "", currentlyRunningMainloop: 0, func: null, arg: 0, timingMode: 0, timingValue: 0, currentFrameNumber: 0, queue: [], pause: function() {
        Browser.mainLoop.scheduler = null;
        Browser.mainLoop.currentlyRunningMainloop++;
      }, resume: function() {
        Browser.mainLoop.currentlyRunningMainloop++;
        var timingMode = Browser.mainLoop.timingMode;
        var timingValue = Browser.mainLoop.timingValue;
        var func2 = Browser.mainLoop.func;
        Browser.mainLoop.func = null;
        _emscripten_set_main_loop(func2, 0, false, Browser.mainLoop.arg, true);
        _emscripten_set_main_loop_timing(timingMode, timingValue);
        Browser.mainLoop.scheduler();
      }, updateStatus: function() {
        if (Module["setStatus"]) {
          var message = Module["statusMessage"] || "Please wait...";
          var remaining = Browser.mainLoop.remainingBlockers;
          var expected = Browser.mainLoop.expectedBlockers;
          if (remaining) {
            if (remaining < expected) {
              Module["setStatus"](message + " (" + (expected - remaining) + "/" + expected + ")");
            } else {
              Module["setStatus"](message);
            }
          } else {
            Module["setStatus"]("");
          }
        }
      }, runIter: function(func2) {
        if (ABORT)
          return;
        if (Module["preMainLoop"]) {
          var preRet = Module["preMainLoop"]();
          if (preRet === false) {
            return;
          }
        }
        try {
          func2();
        } catch (e2) {
          if (e2 instanceof ExitStatus) {
            return;
          } else {
            if (e2 && typeof e2 === "object" && e2.stack)
              Module.printErr("exception thrown: " + [e2, e2.stack]);
            throw e2;
          }
        }
        if (Module["postMainLoop"])
          Module["postMainLoop"]();
      } }, isFullscreen: false, pointerLock: false, moduleContextCreatedCallbacks: [], workers: [], init: function() {
        if (!Module["preloadPlugins"])
          Module["preloadPlugins"] = [];
        if (Browser.initted)
          return;
        Browser.initted = true;
        try {
          new Blob();
          Browser.hasBlobConstructor = true;
        } catch (e2) {
          Browser.hasBlobConstructor = false;
          console.log("warning: no blob constructor, cannot create blobs with mimetypes");
        }
        Browser.BlobBuilder = typeof MozBlobBuilder != "undefined" ? MozBlobBuilder : typeof WebKitBlobBuilder != "undefined" ? WebKitBlobBuilder : !Browser.hasBlobConstructor ? console.log("warning: no BlobBuilder") : null;
        Browser.URLObject = typeof window != "undefined" ? window.URL ? window.URL : window.webkitURL : void 0;
        if (!Module.noImageDecoding && typeof Browser.URLObject === "undefined") {
          console.log("warning: Browser does not support creating object URLs. Built-in browser image decoding will not be available.");
          Module.noImageDecoding = true;
        }
        var imagePlugin = {};
        imagePlugin["canHandle"] = function imagePlugin_canHandle(name) {
          return !Module.noImageDecoding && /\.(jpg|jpeg|png|bmp)$/i.test(name);
        };
        imagePlugin["handle"] = function imagePlugin_handle(byteArray, name, onload, onerror) {
          var b2 = null;
          if (Browser.hasBlobConstructor) {
            try {
              b2 = new Blob([byteArray], { type: Browser.getMimetype(name) });
              if (b2.size !== byteArray.length) {
                b2 = new Blob([new Uint8Array(byteArray).buffer], { type: Browser.getMimetype(name) });
              }
            } catch (e2) {
              Runtime.warnOnce("Blob constructor present but fails: " + e2 + "; falling back to blob builder");
            }
          }
          if (!b2) {
            var bb = new Browser.BlobBuilder();
            bb.append(new Uint8Array(byteArray).buffer);
            b2 = bb.getBlob();
          }
          var url = Browser.URLObject.createObjectURL(b2);
          var img = new Image();
          img.onload = function img_onload() {
            assert(img.complete, "Image " + name + " could not be decoded");
            var canvas2 = document.createElement("canvas");
            canvas2.width = img.width;
            canvas2.height = img.height;
            var ctx = canvas2.getContext("2d");
            ctx.drawImage(img, 0, 0);
            Module["preloadedImages"][name] = canvas2;
            Browser.URLObject.revokeObjectURL(url);
            if (onload)
              onload(byteArray);
          };
          img.onerror = function img_onerror(event2) {
            console.log("Image " + url + " could not be decoded");
            if (onerror)
              onerror();
          };
          img.src = url;
        };
        Module["preloadPlugins"].push(imagePlugin);
        var audioPlugin = {};
        audioPlugin["canHandle"] = function audioPlugin_canHandle(name) {
          return !Module.noAudioDecoding && name.substr(-4) in { ".ogg": 1, ".wav": 1, ".mp3": 1 };
        };
        audioPlugin["handle"] = function audioPlugin_handle(byteArray, name, onload, onerror) {
          var done = false;
          function finish(audio2) {
            if (done)
              return;
            done = true;
            Module["preloadedAudios"][name] = audio2;
            if (onload)
              onload(byteArray);
          }
          function fail() {
            if (done)
              return;
            done = true;
            Module["preloadedAudios"][name] = new Audio();
            if (onerror)
              onerror();
          }
          if (Browser.hasBlobConstructor) {
            try {
              var b2 = new Blob([byteArray], { type: Browser.getMimetype(name) });
            } catch (e2) {
              return fail();
            }
            var url = Browser.URLObject.createObjectURL(b2);
            var audio = new Audio();
            audio.addEventListener("canplaythrough", function() {
              finish(audio);
            }, false);
            audio.onerror = function audio_onerror(event2) {
              if (done)
                return;
              console.log("warning: browser could not fully decode audio " + name + ", trying slower base64 approach");
              function encode64(data) {
                var BASE = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";
                var PAD = "=";
                var ret = "";
                var leftchar = 0;
                var leftbits = 0;
                for (var i3 = 0; i3 < data.length; i3++) {
                  leftchar = leftchar << 8 | data[i3];
                  leftbits += 8;
                  while (leftbits >= 6) {
                    var curr = leftchar >> leftbits - 6 & 63;
                    leftbits -= 6;
                    ret += BASE[curr];
                  }
                }
                if (leftbits == 2) {
                  ret += BASE[(leftchar & 3) << 4];
                  ret += PAD + PAD;
                } else if (leftbits == 4) {
                  ret += BASE[(leftchar & 15) << 2];
                  ret += PAD;
                }
                return ret;
              }
              audio.src = "data:audio/x-" + name.substr(-3) + ";base64," + encode64(byteArray);
              finish(audio);
            };
            audio.src = url;
            Browser.safeSetTimeout(function() {
              finish(audio);
            }, 1e4);
          } else {
            return fail();
          }
        };
        Module["preloadPlugins"].push(audioPlugin);
        function pointerLockChange() {
          Browser.pointerLock = document["pointerLockElement"] === Module["canvas"] || document["mozPointerLockElement"] === Module["canvas"] || document["webkitPointerLockElement"] === Module["canvas"] || document["msPointerLockElement"] === Module["canvas"];
        }
        var canvas = Module["canvas"];
        if (canvas) {
          canvas.requestPointerLock = canvas["requestPointerLock"] || canvas["mozRequestPointerLock"] || canvas["webkitRequestPointerLock"] || canvas["msRequestPointerLock"] || function() {
          };
          canvas.exitPointerLock = document["exitPointerLock"] || document["mozExitPointerLock"] || document["webkitExitPointerLock"] || document["msExitPointerLock"] || function() {
          };
          canvas.exitPointerLock = canvas.exitPointerLock.bind(document);
          document.addEventListener("pointerlockchange", pointerLockChange, false);
          document.addEventListener("mozpointerlockchange", pointerLockChange, false);
          document.addEventListener("webkitpointerlockchange", pointerLockChange, false);
          document.addEventListener("mspointerlockchange", pointerLockChange, false);
          if (Module["elementPointerLock"]) {
            canvas.addEventListener("click", function(ev) {
              if (!Browser.pointerLock && Module["canvas"].requestPointerLock) {
                Module["canvas"].requestPointerLock();
                ev.preventDefault();
              }
            }, false);
          }
        }
      }, createContext: function(canvas, useWebGL, setInModule, webGLContextAttributes) {
        if (useWebGL && Module.ctx && canvas == Module.canvas)
          return Module.ctx;
        var ctx;
        var contextHandle;
        if (useWebGL) {
          var contextAttributes = { antialias: false, alpha: false };
          if (webGLContextAttributes) {
            for (var attribute in webGLContextAttributes) {
              contextAttributes[attribute] = webGLContextAttributes[attribute];
            }
          }
          contextHandle = GL.createContext(canvas, contextAttributes);
          if (contextHandle) {
            ctx = GL.getContext(contextHandle).GLctx;
          }
        } else {
          ctx = canvas.getContext("2d");
        }
        if (!ctx)
          return null;
        if (setInModule) {
          if (!useWebGL)
            assert(typeof GLctx === "undefined", "cannot set in module if GLctx is used, but we are a non-GL context that would replace it");
          Module.ctx = ctx;
          if (useWebGL)
            GL.makeContextCurrent(contextHandle);
          Module.useWebGL = useWebGL;
          Browser.moduleContextCreatedCallbacks.forEach(function(callback) {
            callback();
          });
          Browser.init();
        }
        return ctx;
      }, destroyContext: function(canvas, useWebGL, setInModule) {
      }, fullscreenHandlersInstalled: false, lockPointer: void 0, resizeCanvas: void 0, requestFullscreen: function(lockPointer, resizeCanvas, vrDevice) {
        Browser.lockPointer = lockPointer;
        Browser.resizeCanvas = resizeCanvas;
        Browser.vrDevice = vrDevice;
        if (typeof Browser.lockPointer === "undefined")
          Browser.lockPointer = true;
        if (typeof Browser.resizeCanvas === "undefined")
          Browser.resizeCanvas = false;
        if (typeof Browser.vrDevice === "undefined")
          Browser.vrDevice = null;
        var canvas = Module["canvas"];
        function fullscreenChange() {
          Browser.isFullscreen = false;
          var canvasContainer2 = canvas.parentNode;
          if ((document["fullscreenElement"] || document["mozFullScreenElement"] || document["msFullscreenElement"] || document["webkitFullscreenElement"] || document["webkitCurrentFullScreenElement"]) === canvasContainer2) {
            canvas.exitFullscreen = document["exitFullscreen"] || document["cancelFullScreen"] || document["mozCancelFullScreen"] || document["msExitFullscreen"] || document["webkitCancelFullScreen"] || function() {
            };
            canvas.exitFullscreen = canvas.exitFullscreen.bind(document);
            if (Browser.lockPointer)
              canvas.requestPointerLock();
            Browser.isFullscreen = true;
            if (Browser.resizeCanvas)
              Browser.setFullscreenCanvasSize();
          } else {
            canvasContainer2.parentNode.insertBefore(canvas, canvasContainer2);
            canvasContainer2.parentNode.removeChild(canvasContainer2);
            if (Browser.resizeCanvas)
              Browser.setWindowedCanvasSize();
          }
          if (Module["onFullScreen"])
            Module["onFullScreen"](Browser.isFullscreen);
          if (Module["onFullscreen"])
            Module["onFullscreen"](Browser.isFullscreen);
          Browser.updateCanvasDimensions(canvas);
        }
        if (!Browser.fullscreenHandlersInstalled) {
          Browser.fullscreenHandlersInstalled = true;
          document.addEventListener("fullscreenchange", fullscreenChange, false);
          document.addEventListener("mozfullscreenchange", fullscreenChange, false);
          document.addEventListener("webkitfullscreenchange", fullscreenChange, false);
          document.addEventListener("MSFullscreenChange", fullscreenChange, false);
        }
        var canvasContainer = document.createElement("div");
        canvas.parentNode.insertBefore(canvasContainer, canvas);
        canvasContainer.appendChild(canvas);
        canvasContainer.requestFullscreen = canvasContainer["requestFullscreen"] || canvasContainer["mozRequestFullScreen"] || canvasContainer["msRequestFullscreen"] || (canvasContainer["webkitRequestFullscreen"] ? function() {
          canvasContainer["webkitRequestFullscreen"](Element["ALLOW_KEYBOARD_INPUT"]);
        } : null) || (canvasContainer["webkitRequestFullScreen"] ? function() {
          canvasContainer["webkitRequestFullScreen"](Element["ALLOW_KEYBOARD_INPUT"]);
        } : null);
        if (vrDevice) {
          canvasContainer.requestFullscreen({ vrDisplay: vrDevice });
        } else {
          canvasContainer.requestFullscreen();
        }
      }, requestFullScreen: function(lockPointer, resizeCanvas, vrDevice) {
        Module.printErr("Browser.requestFullScreen() is deprecated. Please call Browser.requestFullscreen instead.");
        Browser.requestFullScreen = function(lockPointer2, resizeCanvas2, vrDevice2) {
          return Browser.requestFullscreen(lockPointer2, resizeCanvas2, vrDevice2);
        };
        return Browser.requestFullscreen(lockPointer, resizeCanvas, vrDevice);
      }, nextRAF: 0, fakeRequestAnimationFrame: function(func2) {
        var now = Date.now();
        if (Browser.nextRAF === 0) {
          Browser.nextRAF = now + 1e3 / 60;
        } else {
          while (now + 2 >= Browser.nextRAF) {
            Browser.nextRAF += 1e3 / 60;
          }
        }
        var delay = Math.max(Browser.nextRAF - now, 0);
        setTimeout(func2, delay);
      }, requestAnimationFrame: function requestAnimationFrame2(func2) {
        if (typeof window === "undefined") {
          Browser.fakeRequestAnimationFrame(func2);
        } else {
          if (!window.requestAnimationFrame) {
            window.requestAnimationFrame = window["requestAnimationFrame"] || window["mozRequestAnimationFrame"] || window["webkitRequestAnimationFrame"] || window["msRequestAnimationFrame"] || window["oRequestAnimationFrame"] || Browser.fakeRequestAnimationFrame;
          }
          window.requestAnimationFrame(func2);
        }
      }, safeCallback: function(func2) {
        return function() {
          if (!ABORT)
            return func2.apply(null, arguments);
        };
      }, allowAsyncCallbacks: true, queuedAsyncCallbacks: [], pauseAsyncCallbacks: function() {
        Browser.allowAsyncCallbacks = false;
      }, resumeAsyncCallbacks: function() {
        Browser.allowAsyncCallbacks = true;
        if (Browser.queuedAsyncCallbacks.length > 0) {
          var callbacks = Browser.queuedAsyncCallbacks;
          Browser.queuedAsyncCallbacks = [];
          callbacks.forEach(function(func2) {
            func2();
          });
        }
      }, safeRequestAnimationFrame: function(func2) {
        return Browser.requestAnimationFrame(function() {
          if (ABORT)
            return;
          if (Browser.allowAsyncCallbacks) {
            func2();
          } else {
            Browser.queuedAsyncCallbacks.push(func2);
          }
        });
      }, safeSetTimeout: function(func2, timeout) {
        Module["noExitRuntime"] = true;
        return setTimeout(function() {
          if (ABORT)
            return;
          if (Browser.allowAsyncCallbacks) {
            func2();
          } else {
            Browser.queuedAsyncCallbacks.push(func2);
          }
        }, timeout);
      }, safeSetInterval: function(func2, timeout) {
        Module["noExitRuntime"] = true;
        return setInterval(function() {
          if (ABORT)
            return;
          if (Browser.allowAsyncCallbacks) {
            func2();
          }
        }, timeout);
      }, getMimetype: function(name) {
        return { "jpg": "image/jpeg", "jpeg": "image/jpeg", "png": "image/png", "bmp": "image/bmp", "ogg": "audio/ogg", "wav": "audio/wav", "mp3": "audio/mpeg" }[name.substr(name.lastIndexOf(".") + 1)];
      }, getUserMedia: function(func2) {
        if (!window.getUserMedia) {
          window.getUserMedia = navigator["getUserMedia"] || navigator["mozGetUserMedia"];
        }
        window.getUserMedia(func2);
      }, getMovementX: function(event2) {
        return event2["movementX"] || event2["mozMovementX"] || event2["webkitMovementX"] || 0;
      }, getMovementY: function(event2) {
        return event2["movementY"] || event2["mozMovementY"] || event2["webkitMovementY"] || 0;
      }, getMouseWheelDelta: function(event2) {
        var delta = 0;
        switch (event2.type) {
          case "DOMMouseScroll":
            delta = event2.detail;
            break;
          case "mousewheel":
            delta = event2.wheelDelta;
            break;
          case "wheel":
            delta = event2["deltaY"];
            break;
          default:
            throw "unrecognized mouse wheel event: " + event2.type;
        }
        return delta;
      }, mouseX: 0, mouseY: 0, mouseMovementX: 0, mouseMovementY: 0, touches: {}, lastTouches: {}, calculateMouseEvent: function(event2) {
        if (Browser.pointerLock) {
          if (event2.type != "mousemove" && "mozMovementX" in event2) {
            Browser.mouseMovementX = Browser.mouseMovementY = 0;
          } else {
            Browser.mouseMovementX = Browser.getMovementX(event2);
            Browser.mouseMovementY = Browser.getMovementY(event2);
          }
          if (typeof SDL != "undefined") {
            Browser.mouseX = SDL.mouseX + Browser.mouseMovementX;
            Browser.mouseY = SDL.mouseY + Browser.mouseMovementY;
          } else {
            Browser.mouseX += Browser.mouseMovementX;
            Browser.mouseY += Browser.mouseMovementY;
          }
        } else {
          var rect = Module["canvas"].getBoundingClientRect();
          var cw = Module["canvas"].width;
          var ch = Module["canvas"].height;
          var scrollX = typeof window.scrollX !== "undefined" ? window.scrollX : window.pageXOffset;
          var scrollY = typeof window.scrollY !== "undefined" ? window.scrollY : window.pageYOffset;
          if (event2.type === "touchstart" || event2.type === "touchend" || event2.type === "touchmove") {
            var touch = event2.touch;
            if (touch === void 0) {
              return;
            }
            var adjustedX = touch.pageX - (scrollX + rect.left);
            var adjustedY = touch.pageY - (scrollY + rect.top);
            adjustedX = adjustedX * (cw / rect.width);
            adjustedY = adjustedY * (ch / rect.height);
            var coords = { x: adjustedX, y: adjustedY };
            if (event2.type === "touchstart") {
              Browser.lastTouches[touch.identifier] = coords;
              Browser.touches[touch.identifier] = coords;
            } else if (event2.type === "touchend" || event2.type === "touchmove") {
              var last = Browser.touches[touch.identifier];
              if (!last)
                last = coords;
              Browser.lastTouches[touch.identifier] = last;
              Browser.touches[touch.identifier] = coords;
            }
            return;
          }
          var x = event2.pageX - (scrollX + rect.left);
          var y2 = event2.pageY - (scrollY + rect.top);
          x = x * (cw / rect.width);
          y2 = y2 * (ch / rect.height);
          Browser.mouseMovementX = x - Browser.mouseX;
          Browser.mouseMovementY = y2 - Browser.mouseY;
          Browser.mouseX = x;
          Browser.mouseY = y2;
        }
      }, asyncLoad: function(url, onload, onerror, noRunDep) {
        var dep = !noRunDep ? getUniqueRunDependency("al " + url) : "";
        Module["readAsync"](url, function(arrayBuffer) {
          assert(arrayBuffer, 'Loading data file "' + url + '" failed (no arrayBuffer).');
          onload(new Uint8Array(arrayBuffer));
          if (dep)
            removeRunDependency(dep);
        }, function(event2) {
          if (onerror) {
            onerror();
          } else {
            throw 'Loading data file "' + url + '" failed.';
          }
        });
        if (dep)
          addRunDependency(dep);
      }, resizeListeners: [], updateResizeListeners: function() {
        var canvas = Module["canvas"];
        Browser.resizeListeners.forEach(function(listener) {
          listener(canvas.width, canvas.height);
        });
      }, setCanvasSize: function(width, height, noUpdates) {
        var canvas = Module["canvas"];
        Browser.updateCanvasDimensions(canvas, width, height);
        if (!noUpdates)
          Browser.updateResizeListeners();
      }, windowedWidth: 0, windowedHeight: 0, setFullscreenCanvasSize: function() {
        if (typeof SDL != "undefined") {
          var flags = HEAPU32[SDL.screen + Runtime.QUANTUM_SIZE * 0 >> 2];
          flags = flags | 8388608;
          HEAP32[SDL.screen + Runtime.QUANTUM_SIZE * 0 >> 2] = flags;
        }
        Browser.updateResizeListeners();
      }, setWindowedCanvasSize: function() {
        if (typeof SDL != "undefined") {
          var flags = HEAPU32[SDL.screen + Runtime.QUANTUM_SIZE * 0 >> 2];
          flags = flags & ~8388608;
          HEAP32[SDL.screen + Runtime.QUANTUM_SIZE * 0 >> 2] = flags;
        }
        Browser.updateResizeListeners();
      }, updateCanvasDimensions: function(canvas, wNative, hNative) {
        if (wNative && hNative) {
          canvas.widthNative = wNative;
          canvas.heightNative = hNative;
        } else {
          wNative = canvas.widthNative;
          hNative = canvas.heightNative;
        }
        var w = wNative;
        var h = hNative;
        if (Module["forcedAspectRatio"] && Module["forcedAspectRatio"] > 0) {
          if (w / h < Module["forcedAspectRatio"]) {
            w = Math.round(h * Module["forcedAspectRatio"]);
          } else {
            h = Math.round(w / Module["forcedAspectRatio"]);
          }
        }
        if ((document["fullscreenElement"] || document["mozFullScreenElement"] || document["msFullscreenElement"] || document["webkitFullscreenElement"] || document["webkitCurrentFullScreenElement"]) === canvas.parentNode && typeof screen != "undefined") {
          var factor = Math.min(screen.width / w, screen.height / h);
          w = Math.round(w * factor);
          h = Math.round(h * factor);
        }
        if (Browser.resizeCanvas) {
          if (canvas.width != w)
            canvas.width = w;
          if (canvas.height != h)
            canvas.height = h;
          if (typeof canvas.style != "undefined") {
            canvas.style.removeProperty("width");
            canvas.style.removeProperty("height");
          }
        } else {
          if (canvas.width != wNative)
            canvas.width = wNative;
          if (canvas.height != hNative)
            canvas.height = hNative;
          if (typeof canvas.style != "undefined") {
            if (w != wNative || h != hNative) {
              canvas.style.setProperty("width", w + "px", "important");
              canvas.style.setProperty("height", h + "px", "important");
            } else {
              canvas.style.removeProperty("width");
              canvas.style.removeProperty("height");
            }
          }
        }
      }, wgetRequests: {}, nextWgetRequestHandle: 0, getNextWgetRequestHandle: function() {
        var handle = Browser.nextWgetRequestHandle;
        Browser.nextWgetRequestHandle++;
        return handle;
      } };
      var SYSCALLS = { varargs: 0, get: function(varargs) {
        SYSCALLS.varargs += 4;
        var ret = HEAP32[SYSCALLS.varargs - 4 >> 2];
        return ret;
      }, getStr: function() {
        var ret = Pointer_stringify(SYSCALLS.get());
        return ret;
      }, get64: function() {
        var low = SYSCALLS.get(), high = SYSCALLS.get();
        if (low >= 0)
          assert(high === 0);
        else
          assert(high === -1);
        return low;
      }, getZero: function() {
        assert(SYSCALLS.get() === 0);
      } };
      function ___syscall6(which, varargs) {
        SYSCALLS.varargs = varargs;
        try {
          var stream = SYSCALLS.getStreamFromFD();
          FS.close(stream);
          return 0;
        } catch (e2) {
          if (typeof FS === "undefined" || !(e2 instanceof FS.ErrnoError))
            abort(e2);
          return -e2.errno;
        }
      }
      function ___syscall54(which, varargs) {
        SYSCALLS.varargs = varargs;
        try {
          return 0;
        } catch (e2) {
          if (typeof FS === "undefined" || !(e2 instanceof FS.ErrnoError))
            abort(e2);
          return -e2.errno;
        }
      }
      function _typeModule(self2) {
        var structureList = [[0, 1, "X"], [1, 1, "const X"], [128, 1, "X *"], [256, 1, "X &"], [384, 1, "X &&"], [512, 1, "std::shared_ptr<X>"], [640, 1, "std::unique_ptr<X>"], [5120, 1, "std::vector<X>"], [6144, 2, "std::array<X, Y>"], [9216, -1, "std::function<X (Y)>"]];
        function applyStructure(outerName, outerFlags, innerName, innerFlags, param, flip) {
          if (outerFlags == 1) {
            var ref2 = innerFlags & 896;
            if (ref2 == 128 || ref2 == 256 || ref2 == 384)
              outerName = "X const";
          }
          var name;
          if (flip) {
            name = innerName.replace("X", outerName).replace("Y", param);
          } else {
            name = outerName.replace("X", innerName).replace("Y", param);
          }
          return name.replace(/([*&]) (?=[*&])/g, "$1");
        }
        function reportProblem(problem, id, kind, structureType, place) {
          throw new Error(problem + " type " + kind.replace("X", id + "?") + (structureType ? " with flag " + structureType : "") + " in " + place);
        }
        function getComplexType(id, constructType2, getType2, queryType2, place, kind, prevStructure, depth) {
          if (kind === void 0) {
            kind = "X";
          }
          if (depth === void 0) {
            depth = 1;
          }
          var result2 = getType2(id);
          if (result2)
            return result2;
          var query = queryType2(id);
          var structureType = query.placeholderFlag;
          var structure = structureList[structureType];
          if (prevStructure && structure) {
            kind = applyStructure(prevStructure[2], prevStructure[0], kind, structure[0], "?", true);
          }
          var problem;
          if (structureType == 0)
            problem = "Unbound";
          if (structureType >= 10)
            problem = "Corrupt";
          if (depth > 20)
            problem = "Deeply nested";
          if (problem)
            reportProblem(problem, id, kind, structureType, place || "?");
          var subId = query.paramList[0];
          var subType = getComplexType(subId, constructType2, getType2, queryType2, place, kind, structure, depth + 1);
          var srcSpec;
          var spec = { flags: structure[0], id, name: "", paramList: [subType] };
          var argList2 = [];
          var structureParam = "?";
          switch (query.placeholderFlag) {
            case 1:
              srcSpec = subType.spec;
              break;
            case 2:
              if ((subType.flags & 15360) == 1024 && subType.spec.ptrSize == 1) {
                spec.flags = 7168;
                break;
              }
              ;
            case 3:
            case 6:
            case 5:
              srcSpec = subType.spec;
              if ((subType.flags & 15360) != 2048) {
              }
              break;
            case 8:
              structureParam = "" + query.paramList[1];
              spec.paramList.push(query.paramList[1]);
              break;
            case 9:
              for (var _i = 0, _a2 = query.paramList[1]; _i < _a2.length; _i++) {
                var paramId = _a2[_i];
                var paramType = getComplexType(paramId, constructType2, getType2, queryType2, place, kind, structure, depth + 1);
                argList2.push(paramType.name);
                spec.paramList.push(paramType);
              }
              structureParam = argList2.join(", ");
              break;
            default:
              break;
          }
          spec.name = applyStructure(structure[2], structure[0], subType.name, subType.flags, structureParam);
          if (srcSpec) {
            for (var _b = 0, _c = Object.keys(srcSpec); _b < _c.length; _b++) {
              var key2 = _c[_b];
              spec[key2] = spec[key2] || srcSpec[key2];
            }
            spec.flags |= srcSpec.flags;
          }
          return makeType(constructType2, spec);
        }
        function makeType(constructType2, spec) {
          var flags = spec.flags;
          var refKind = flags & 896;
          var kind = flags & 15360;
          if (!spec.name && kind == 1024) {
            if (spec.ptrSize == 1) {
              spec.name = (flags & 16 ? "" : (flags & 8 ? "un" : "") + "signed ") + "char";
            } else {
              spec.name = (flags & 8 ? "u" : "") + (flags & 32 ? "float" : "int") + (spec.ptrSize * 8 + "_t");
            }
          }
          if (spec.ptrSize == 8 && !(flags & 32))
            kind = 64;
          if (kind == 2048) {
            if (refKind == 512 || refKind == 640) {
              kind = 4096;
            } else if (refKind)
              kind = 3072;
          }
          return constructType2(kind, spec);
        }
        var Type2 = function() {
          function Type3(spec) {
            this.id = spec.id;
            this.name = spec.name;
            this.flags = spec.flags;
            this.spec = spec;
          }
          Type3.prototype.toString = function() {
            return this.name;
          };
          return Type3;
        }();
        var output = { Type: Type2, getComplexType, makeType, structureList };
        self2.output = output;
        return self2.output || output;
      }
      function __nbind_register_type(id, namePtr) {
        var name = _nbind.readAsciiString(namePtr);
        var spec = { flags: 10240, id, name };
        _nbind.makeType(_nbind.constructType, spec);
      }
      function __nbind_register_callback_signature(typeListPtr, typeCount) {
        var typeList = _nbind.readTypeIdList(typeListPtr, typeCount);
        var num2 = _nbind.callbackSignatureList.length;
        _nbind.callbackSignatureList[num2] = _nbind.makeJSCaller(typeList);
        return num2;
      }
      function __extends(Class, Parent) {
        for (var key2 in Parent)
          if (Parent.hasOwnProperty(key2))
            Class[key2] = Parent[key2];
        function Base() {
          this.constructor = Class;
        }
        Base.prototype = Parent.prototype;
        Class.prototype = new Base();
      }
      function __nbind_register_class(idListPtr, policyListPtr, superListPtr, upcastListPtr, superCount, destructorPtr, namePtr) {
        var name = _nbind.readAsciiString(namePtr);
        var policyTbl2 = _nbind.readPolicyList(policyListPtr);
        var idList = HEAPU32.subarray(idListPtr / 4, idListPtr / 4 + 2);
        var spec = { flags: 2048 | (policyTbl2["Value"] ? 2 : 0), id: idList[0], name };
        var bindClass = _nbind.makeType(_nbind.constructType, spec);
        bindClass.ptrType = _nbind.getComplexType(idList[1], _nbind.constructType, _nbind.getType, _nbind.queryType);
        bindClass.destroy = _nbind.makeMethodCaller(bindClass.ptrType, { boundID: spec.id, flags: 0, name: "destroy", num: 0, ptr: destructorPtr, title: bindClass.name + ".free", typeList: ["void", "uint32_t", "uint32_t"] });
        if (superCount) {
          bindClass.superIdList = Array.prototype.slice.call(HEAPU32.subarray(superListPtr / 4, superListPtr / 4 + superCount));
          bindClass.upcastList = Array.prototype.slice.call(HEAPU32.subarray(upcastListPtr / 4, upcastListPtr / 4 + superCount));
        }
        Module[bindClass.name] = bindClass.makeBound(policyTbl2);
        _nbind.BindClass.list.push(bindClass);
      }
      function _removeAccessorPrefix(name) {
        var prefixMatcher = /^[Gg]et_?([A-Z]?([A-Z]?))/;
        return name.replace(prefixMatcher, function(match, initial, second) {
          return second ? initial : initial.toLowerCase();
        });
      }
      function __nbind_register_function(boundID, policyListPtr, typeListPtr, typeCount, ptr2, direct, signatureType, namePtr, num2, flags) {
        var bindClass = _nbind.getType(boundID);
        var policyTbl2 = _nbind.readPolicyList(policyListPtr);
        var typeList = _nbind.readTypeIdList(typeListPtr, typeCount);
        var specList;
        if (signatureType == 5) {
          specList = [{ direct: ptr2, name: "__nbindConstructor", ptr: 0, title: bindClass.name + " constructor", typeList: ["uint32_t"].concat(typeList.slice(1)) }, { direct, name: "__nbindValueConstructor", ptr: 0, title: bindClass.name + " value constructor", typeList: ["void", "uint32_t"].concat(typeList.slice(1)) }];
        } else {
          var name_1 = _nbind.readAsciiString(namePtr);
          var title = (bindClass.name && bindClass.name + ".") + name_1;
          if (signatureType == 3 || signatureType == 4) {
            name_1 = _removeAccessorPrefix(name_1);
          }
          specList = [{ boundID, direct, name: name_1, ptr: ptr2, title, typeList }];
        }
        for (var _i = 0, specList_1 = specList; _i < specList_1.length; _i++) {
          var spec = specList_1[_i];
          spec.signatureType = signatureType;
          spec.policyTbl = policyTbl2;
          spec.num = num2;
          spec.flags = flags;
          bindClass.addMethod(spec);
        }
      }
      function _nbind_value(name, proto) {
        if (!_nbind.typeNameTbl[name])
          _nbind.throwError("Unknown value type " + name);
        Module["NBind"].bind_value(name, proto);
        _defineHidden(_nbind.typeNameTbl[name].proto.prototype.__nbindValueConstructor)(proto.prototype, "__nbindValueConstructor");
      }
      Module["_nbind_value"] = _nbind_value;
      function __nbind_get_value_object(num2, ptr2) {
        var obj = _nbind.popValue(num2);
        if (!obj.fromJS) {
          throw new Error("Object " + obj + " has no fromJS function");
        }
        obj.fromJS(function() {
          obj.__nbindValueConstructor.apply(this, Array.prototype.concat.apply([ptr2], arguments));
        });
      }
      function _emscripten_memcpy_big(dest, src, num2) {
        HEAPU8.set(HEAPU8.subarray(src, src + num2), dest);
        return dest;
      }
      function __nbind_register_primitive(id, size, flags) {
        var spec = { flags: 1024 | flags, id, ptrSize: size };
        _nbind.makeType(_nbind.constructType, spec);
      }
      var cttz_i8 = allocate([8, 0, 1, 0, 2, 0, 1, 0, 3, 0, 1, 0, 2, 0, 1, 0, 4, 0, 1, 0, 2, 0, 1, 0, 3, 0, 1, 0, 2, 0, 1, 0, 5, 0, 1, 0, 2, 0, 1, 0, 3, 0, 1, 0, 2, 0, 1, 0, 4, 0, 1, 0, 2, 0, 1, 0, 3, 0, 1, 0, 2, 0, 1, 0, 6, 0, 1, 0, 2, 0, 1, 0, 3, 0, 1, 0, 2, 0, 1, 0, 4, 0, 1, 0, 2, 0, 1, 0, 3, 0, 1, 0, 2, 0, 1, 0, 5, 0, 1, 0, 2, 0, 1, 0, 3, 0, 1, 0, 2, 0, 1, 0, 4, 0, 1, 0, 2, 0, 1, 0, 3, 0, 1, 0, 2, 0, 1, 0, 7, 0, 1, 0, 2, 0, 1, 0, 3, 0, 1, 0, 2, 0, 1, 0, 4, 0, 1, 0, 2, 0, 1, 0, 3, 0, 1, 0, 2, 0, 1, 0, 5, 0, 1, 0, 2, 0, 1, 0, 3, 0, 1, 0, 2, 0, 1, 0, 4, 0, 1, 0, 2, 0, 1, 0, 3, 0, 1, 0, 2, 0, 1, 0, 6, 0, 1, 0, 2, 0, 1, 0, 3, 0, 1, 0, 2, 0, 1, 0, 4, 0, 1, 0, 2, 0, 1, 0, 3, 0, 1, 0, 2, 0, 1, 0, 5, 0, 1, 0, 2, 0, 1, 0, 3, 0, 1, 0, 2, 0, 1, 0, 4, 0, 1, 0, 2, 0, 1, 0, 3, 0, 1, 0, 2, 0, 1, 0], "i8", ALLOC_STATIC);
      function ___setErrNo(value) {
        if (Module["___errno_location"])
          HEAP32[Module["___errno_location"]() >> 2] = value;
        return value;
      }
      function _llvm_stacksave() {
        var self2 = _llvm_stacksave;
        if (!self2.LLVM_SAVEDSTACKS) {
          self2.LLVM_SAVEDSTACKS = [];
        }
        self2.LLVM_SAVEDSTACKS.push(Runtime.stackSave());
        return self2.LLVM_SAVEDSTACKS.length - 1;
      }
      function ___syscall140(which, varargs) {
        SYSCALLS.varargs = varargs;
        try {
          var stream = SYSCALLS.getStreamFromFD(), offset_high = SYSCALLS.get(), offset_low = SYSCALLS.get(), result2 = SYSCALLS.get(), whence = SYSCALLS.get();
          var offset = offset_low;
          FS.llseek(stream, offset, whence);
          HEAP32[result2 >> 2] = stream.position;
          if (stream.getdents && offset === 0 && whence === 0)
            stream.getdents = null;
          return 0;
        } catch (e2) {
          if (typeof FS === "undefined" || !(e2 instanceof FS.ErrnoError))
            abort(e2);
          return -e2.errno;
        }
      }
      function ___syscall146(which, varargs) {
        SYSCALLS.varargs = varargs;
        try {
          var stream = SYSCALLS.get(), iov = SYSCALLS.get(), iovcnt = SYSCALLS.get();
          var ret = 0;
          if (!___syscall146.buffer) {
            ___syscall146.buffers = [null, [], []];
            ___syscall146.printChar = function(stream2, curr) {
              var buffer2 = ___syscall146.buffers[stream2];
              assert(buffer2);
              if (curr === 0 || curr === 10) {
                (stream2 === 1 ? Module["print"] : Module["printErr"])(UTF8ArrayToString(buffer2, 0));
                buffer2.length = 0;
              } else {
                buffer2.push(curr);
              }
            };
          }
          for (var i3 = 0; i3 < iovcnt; i3++) {
            var ptr2 = HEAP32[iov + i3 * 8 >> 2];
            var len = HEAP32[iov + (i3 * 8 + 4) >> 2];
            for (var j = 0; j < len; j++) {
              ___syscall146.printChar(stream, HEAPU8[ptr2 + j]);
            }
            ret += len;
          }
          return ret;
        } catch (e2) {
          if (typeof FS === "undefined" || !(e2 instanceof FS.ErrnoError))
            abort(e2);
          return -e2.errno;
        }
      }
      function __nbind_finish() {
        for (var _i = 0, _a2 = _nbind.BindClass.list; _i < _a2.length; _i++) {
          var bindClass = _a2[_i];
          bindClass.finish();
        }
      }
      var ___dso_handle = STATICTOP;
      STATICTOP += 16;
      (function(_nbind) {
        var typeIdTbl = {};
        _nbind.typeNameTbl = {};
        var Pool = function() {
          function Pool2() {
          }
          Pool2.lalloc = function(size) {
            size = size + 7 & ~7;
            var used = HEAPU32[Pool2.usedPtr];
            if (size > Pool2.pageSize / 2 || size > Pool2.pageSize - used) {
              var NBind = _nbind.typeNameTbl["NBind"].proto;
              return NBind.lalloc(size);
            } else {
              HEAPU32[Pool2.usedPtr] = used + size;
              return Pool2.rootPtr + used;
            }
          };
          Pool2.lreset = function(used, page) {
            var topPage = HEAPU32[Pool2.pagePtr];
            if (topPage) {
              var NBind = _nbind.typeNameTbl["NBind"].proto;
              NBind.lreset(used, page);
            } else {
              HEAPU32[Pool2.usedPtr] = used;
            }
          };
          return Pool2;
        }();
        _nbind.Pool = Pool;
        function constructType(kind, spec) {
          var construct = kind == 10240 ? _nbind.makeTypeNameTbl[spec.name] || _nbind.BindType : _nbind.makeTypeKindTbl[kind];
          var bindType = new construct(spec);
          typeIdTbl[spec.id] = bindType;
          _nbind.typeNameTbl[spec.name] = bindType;
          return bindType;
        }
        _nbind.constructType = constructType;
        function getType(id) {
          return typeIdTbl[id];
        }
        _nbind.getType = getType;
        function queryType(id) {
          var placeholderFlag = HEAPU8[id];
          var paramCount = _nbind.structureList[placeholderFlag][1];
          id /= 4;
          if (paramCount < 0) {
            ++id;
            paramCount = HEAPU32[id] + 1;
          }
          var paramList = Array.prototype.slice.call(HEAPU32.subarray(id + 1, id + 1 + paramCount));
          if (placeholderFlag == 9) {
            paramList = [paramList[0], paramList.slice(1)];
          }
          return { paramList, placeholderFlag };
        }
        _nbind.queryType = queryType;
        function getTypes(idList, place) {
          return idList.map(function(id) {
            return typeof id == "number" ? _nbind.getComplexType(id, constructType, getType, queryType, place) : _nbind.typeNameTbl[id];
          });
        }
        _nbind.getTypes = getTypes;
        function readTypeIdList(typeListPtr, typeCount) {
          return Array.prototype.slice.call(HEAPU32, typeListPtr / 4, typeListPtr / 4 + typeCount);
        }
        _nbind.readTypeIdList = readTypeIdList;
        function readAsciiString(ptr2) {
          var endPtr = ptr2;
          while (HEAPU8[endPtr++])
            ;
          return String.fromCharCode.apply("", HEAPU8.subarray(ptr2, endPtr - 1));
        }
        _nbind.readAsciiString = readAsciiString;
        function readPolicyList(policyListPtr) {
          var policyTbl2 = {};
          if (policyListPtr) {
            while (1) {
              var namePtr = HEAPU32[policyListPtr / 4];
              if (!namePtr)
                break;
              policyTbl2[readAsciiString(namePtr)] = true;
              policyListPtr += 4;
            }
          }
          return policyTbl2;
        }
        _nbind.readPolicyList = readPolicyList;
        function getDynCall(typeList, name) {
          var mangleMap = { float32_t: "d", float64_t: "d", int64_t: "d", uint64_t: "d", "void": "v" };
          var signature = typeList.map(function(type3) {
            return mangleMap[type3.name] || "i";
          }).join("");
          var dynCall2 = Module["dynCall_" + signature];
          if (!dynCall2) {
            throw new Error("dynCall_" + signature + " not found for " + name + "(" + typeList.map(function(type3) {
              return type3.name;
            }).join(", ") + ")");
          }
          return dynCall2;
        }
        _nbind.getDynCall = getDynCall;
        function addMethod(obj, name, func2, arity) {
          var overload = obj[name];
          if (obj.hasOwnProperty(name) && overload) {
            if (overload.arity || overload.arity === 0) {
              overload = _nbind.makeOverloader(overload, overload.arity);
              obj[name] = overload;
            }
            overload.addMethod(func2, arity);
          } else {
            func2.arity = arity;
            obj[name] = func2;
          }
        }
        _nbind.addMethod = addMethod;
        function throwError(message) {
          throw new Error(message);
        }
        _nbind.throwError = throwError;
        _nbind.bigEndian = false;
        _a = _typeModule(_typeModule), _nbind.Type = _a.Type, _nbind.makeType = _a.makeType, _nbind.getComplexType = _a.getComplexType, _nbind.structureList = _a.structureList;
        var BindType = function(_super) {
          __extends(BindType2, _super);
          function BindType2() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.heap = HEAPU32;
            _this.ptrSize = 4;
            return _this;
          }
          BindType2.prototype.needsWireRead = function(policyTbl2) {
            return !!this.wireRead || !!this.makeWireRead;
          };
          BindType2.prototype.needsWireWrite = function(policyTbl2) {
            return !!this.wireWrite || !!this.makeWireWrite;
          };
          return BindType2;
        }(_nbind.Type);
        _nbind.BindType = BindType;
        var PrimitiveType = function(_super) {
          __extends(PrimitiveType2, _super);
          function PrimitiveType2(spec) {
            var _this = _super.call(this, spec) || this;
            var heapTbl = spec.flags & 32 ? { 32: HEAPF32, 64: HEAPF64 } : spec.flags & 8 ? { 8: HEAPU8, 16: HEAPU16, 32: HEAPU32 } : { 8: HEAP8, 16: HEAP16, 32: HEAP32 };
            _this.heap = heapTbl[spec.ptrSize * 8];
            _this.ptrSize = spec.ptrSize;
            return _this;
          }
          PrimitiveType2.prototype.needsWireWrite = function(policyTbl2) {
            return !!policyTbl2 && !!policyTbl2["Strict"];
          };
          PrimitiveType2.prototype.makeWireWrite = function(expr, policyTbl2) {
            return policyTbl2 && policyTbl2["Strict"] && function(arg2) {
              if (typeof arg2 == "number")
                return arg2;
              throw new Error("Type mismatch");
            };
          };
          return PrimitiveType2;
        }(BindType);
        _nbind.PrimitiveType = PrimitiveType;
        function pushCString(str2, policyTbl2) {
          if (str2 === null || str2 === void 0) {
            if (policyTbl2 && policyTbl2["Nullable"]) {
              return 0;
            } else
              throw new Error("Type mismatch");
          }
          if (policyTbl2 && policyTbl2["Strict"]) {
            if (typeof str2 != "string")
              throw new Error("Type mismatch");
          } else
            str2 = str2.toString();
          var length = Module.lengthBytesUTF8(str2) + 1;
          var result2 = _nbind.Pool.lalloc(length);
          Module.stringToUTF8Array(str2, HEAPU8, result2, length);
          return result2;
        }
        _nbind.pushCString = pushCString;
        function popCString(ptr2) {
          if (ptr2 === 0)
            return null;
          return Module.Pointer_stringify(ptr2);
        }
        _nbind.popCString = popCString;
        var CStringType = function(_super) {
          __extends(CStringType2, _super);
          function CStringType2() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.wireRead = popCString;
            _this.wireWrite = pushCString;
            _this.readResources = [_nbind.resources.pool];
            _this.writeResources = [_nbind.resources.pool];
            return _this;
          }
          CStringType2.prototype.makeWireWrite = function(expr, policyTbl2) {
            return function(arg2) {
              return pushCString(arg2, policyTbl2);
            };
          };
          return CStringType2;
        }(BindType);
        _nbind.CStringType = CStringType;
        var BooleanType = function(_super) {
          __extends(BooleanType2, _super);
          function BooleanType2() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.wireRead = function(arg2) {
              return !!arg2;
            };
            return _this;
          }
          BooleanType2.prototype.needsWireWrite = function(policyTbl2) {
            return !!policyTbl2 && !!policyTbl2["Strict"];
          };
          BooleanType2.prototype.makeWireRead = function(expr) {
            return "!!(" + expr + ")";
          };
          BooleanType2.prototype.makeWireWrite = function(expr, policyTbl2) {
            return policyTbl2 && policyTbl2["Strict"] && function(arg2) {
              if (typeof arg2 == "boolean")
                return arg2;
              throw new Error("Type mismatch");
            } || expr;
          };
          return BooleanType2;
        }(BindType);
        _nbind.BooleanType = BooleanType;
        var Wrapper = function() {
          function Wrapper2() {
          }
          Wrapper2.prototype.persist = function() {
            this.__nbindState |= 1;
          };
          return Wrapper2;
        }();
        _nbind.Wrapper = Wrapper;
        function makeBound(policyTbl2, bindClass) {
          var Bound = function(_super) {
            __extends(Bound2, _super);
            function Bound2(marker, flags, ptr2, shared) {
              var _this = _super.call(this) || this;
              if (!(_this instanceof Bound2)) {
                return new (Function.prototype.bind.apply(Bound2, Array.prototype.concat.apply([null], arguments)))();
              }
              var nbindFlags = flags;
              var nbindPtr = ptr2;
              var nbindShared = shared;
              if (marker !== _nbind.ptrMarker) {
                var wirePtr = _this.__nbindConstructor.apply(_this, arguments);
                nbindFlags = 4096 | 512;
                nbindShared = HEAPU32[wirePtr / 4];
                nbindPtr = HEAPU32[wirePtr / 4 + 1];
              }
              var spec = { configurable: true, enumerable: false, value: null, writable: false };
              var propTbl = { "__nbindFlags": nbindFlags, "__nbindPtr": nbindPtr };
              if (nbindShared) {
                propTbl["__nbindShared"] = nbindShared;
                _nbind.mark(_this);
              }
              for (var _i = 0, _a2 = Object.keys(propTbl); _i < _a2.length; _i++) {
                var key2 = _a2[_i];
                spec.value = propTbl[key2];
                Object.defineProperty(_this, key2, spec);
              }
              _defineHidden(0)(_this, "__nbindState");
              return _this;
            }
            Bound2.prototype.free = function() {
              bindClass.destroy.call(this, this.__nbindShared, this.__nbindFlags);
              this.__nbindState |= 2;
              disableMember(this, "__nbindShared");
              disableMember(this, "__nbindPtr");
            };
            return Bound2;
          }(Wrapper);
          __decorate([_defineHidden()], Bound.prototype, "__nbindConstructor", void 0);
          __decorate([_defineHidden()], Bound.prototype, "__nbindValueConstructor", void 0);
          __decorate([_defineHidden(policyTbl2)], Bound.prototype, "__nbindPolicies", void 0);
          return Bound;
        }
        _nbind.makeBound = makeBound;
        function disableMember(obj, name) {
          function die() {
            throw new Error("Accessing deleted object");
          }
          Object.defineProperty(obj, name, { configurable: false, enumerable: false, get: die, set: die });
        }
        _nbind.ptrMarker = {};
        var BindClass = function(_super) {
          __extends(BindClass2, _super);
          function BindClass2(spec) {
            var _this = _super.call(this, spec) || this;
            _this.wireRead = function(arg2) {
              return _nbind.popValue(arg2, _this.ptrType);
            };
            _this.wireWrite = function(arg2) {
              return pushPointer(arg2, _this.ptrType, true);
            };
            _this.pendingSuperCount = 0;
            _this.ready = false;
            _this.methodTbl = {};
            if (spec.paramList) {
              _this.classType = spec.paramList[0].classType;
              _this.proto = _this.classType.proto;
            } else
              _this.classType = _this;
            return _this;
          }
          BindClass2.prototype.makeBound = function(policyTbl2) {
            var Bound = _nbind.makeBound(policyTbl2, this);
            this.proto = Bound;
            this.ptrType.proto = Bound;
            return Bound;
          };
          BindClass2.prototype.addMethod = function(spec) {
            var overloadList = this.methodTbl[spec.name] || [];
            overloadList.push(spec);
            this.methodTbl[spec.name] = overloadList;
          };
          BindClass2.prototype.registerMethods = function(src, staticOnly) {
            var setter;
            for (var _i = 0, _a2 = Object.keys(src.methodTbl); _i < _a2.length; _i++) {
              var name_1 = _a2[_i];
              var overloadList = src.methodTbl[name_1];
              for (var _b = 0, overloadList_1 = overloadList; _b < overloadList_1.length; _b++) {
                var spec = overloadList_1[_b];
                var target = void 0;
                var caller = void 0;
                target = this.proto.prototype;
                if (staticOnly && spec.signatureType != 1)
                  continue;
                switch (spec.signatureType) {
                  case 1:
                    target = this.proto;
                  case 5:
                    caller = _nbind.makeCaller(spec);
                    _nbind.addMethod(target, spec.name, caller, spec.typeList.length - 1);
                    break;
                  case 4:
                    setter = _nbind.makeMethodCaller(src.ptrType, spec);
                    break;
                  case 3:
                    Object.defineProperty(target, spec.name, { configurable: true, enumerable: false, get: _nbind.makeMethodCaller(src.ptrType, spec), set: setter });
                    break;
                  case 2:
                    caller = _nbind.makeMethodCaller(src.ptrType, spec);
                    _nbind.addMethod(target, spec.name, caller, spec.typeList.length - 1);
                    break;
                  default:
                    break;
                }
              }
            }
          };
          BindClass2.prototype.registerSuperMethods = function(src, firstSuper, visitTbl) {
            if (visitTbl[src.name])
              return;
            visitTbl[src.name] = true;
            var superNum = 0;
            var nextFirst;
            for (var _i = 0, _a2 = src.superIdList || []; _i < _a2.length; _i++) {
              var superId = _a2[_i];
              var superClass = _nbind.getType(superId);
              if (superNum++ < firstSuper || firstSuper < 0) {
                nextFirst = -1;
              } else {
                nextFirst = 0;
              }
              this.registerSuperMethods(superClass, nextFirst, visitTbl);
            }
            this.registerMethods(src, firstSuper < 0);
          };
          BindClass2.prototype.finish = function() {
            if (this.ready)
              return this;
            this.ready = true;
            this.superList = (this.superIdList || []).map(function(superId) {
              return _nbind.getType(superId).finish();
            });
            var Bound = this.proto;
            if (this.superList.length) {
              var Proto = function() {
                this.constructor = Bound;
              };
              Proto.prototype = this.superList[0].proto.prototype;
              Bound.prototype = new Proto();
            }
            if (Bound != Module)
              Bound.prototype.__nbindType = this;
            this.registerSuperMethods(this, 1, {});
            return this;
          };
          BindClass2.prototype.upcastStep = function(dst, ptr2) {
            if (dst == this)
              return ptr2;
            for (var i3 = 0; i3 < this.superList.length; ++i3) {
              var superPtr = this.superList[i3].upcastStep(dst, _nbind.callUpcast(this.upcastList[i3], ptr2));
              if (superPtr)
                return superPtr;
            }
            return 0;
          };
          return BindClass2;
        }(_nbind.BindType);
        BindClass.list = [];
        _nbind.BindClass = BindClass;
        function popPointer(ptr2, type3) {
          return ptr2 ? new type3.proto(_nbind.ptrMarker, type3.flags, ptr2) : null;
        }
        _nbind.popPointer = popPointer;
        function pushPointer(obj, type3, tryValue) {
          if (!(obj instanceof _nbind.Wrapper)) {
            if (tryValue) {
              return _nbind.pushValue(obj);
            } else
              throw new Error("Type mismatch");
          }
          var ptr2 = obj.__nbindPtr;
          var objType = obj.__nbindType.classType;
          var classType = type3.classType;
          if (obj instanceof type3.proto) {
            while (objType != classType) {
              ptr2 = _nbind.callUpcast(objType.upcastList[0], ptr2);
              objType = objType.superList[0];
            }
          } else {
            ptr2 = objType.upcastStep(classType, ptr2);
            if (!ptr2)
              throw new Error("Type mismatch");
          }
          return ptr2;
        }
        _nbind.pushPointer = pushPointer;
        function pushMutablePointer(obj, type3) {
          var ptr2 = pushPointer(obj, type3);
          if (obj.__nbindFlags & 1) {
            throw new Error("Passing a const value as a non-const argument");
          }
          return ptr2;
        }
        var BindClassPtr = function(_super) {
          __extends(BindClassPtr2, _super);
          function BindClassPtr2(spec) {
            var _this = _super.call(this, spec) || this;
            _this.classType = spec.paramList[0].classType;
            _this.proto = _this.classType.proto;
            var isConst = spec.flags & 1;
            var isValue = (_this.flags & 896) == 256 && spec.flags & 2;
            var push = isConst ? pushPointer : pushMutablePointer;
            var pop = isValue ? _nbind.popValue : popPointer;
            _this.makeWireWrite = function(expr, policyTbl2) {
              return policyTbl2["Nullable"] ? function(arg2) {
                return arg2 ? push(arg2, _this) : 0;
              } : function(arg2) {
                return push(arg2, _this);
              };
            };
            _this.wireRead = function(arg2) {
              return pop(arg2, _this);
            };
            _this.wireWrite = function(arg2) {
              return push(arg2, _this);
            };
            return _this;
          }
          return BindClassPtr2;
        }(_nbind.BindType);
        _nbind.BindClassPtr = BindClassPtr;
        function popShared(ptr2, type3) {
          var shared = HEAPU32[ptr2 / 4];
          var unsafe = HEAPU32[ptr2 / 4 + 1];
          return unsafe ? new type3.proto(_nbind.ptrMarker, type3.flags, unsafe, shared) : null;
        }
        _nbind.popShared = popShared;
        function pushShared(obj, type3) {
          if (!(obj instanceof type3.proto))
            throw new Error("Type mismatch");
          return obj.__nbindShared;
        }
        function pushMutableShared(obj, type3) {
          if (!(obj instanceof type3.proto))
            throw new Error("Type mismatch");
          if (obj.__nbindFlags & 1) {
            throw new Error("Passing a const value as a non-const argument");
          }
          return obj.__nbindShared;
        }
        var SharedClassPtr = function(_super) {
          __extends(SharedClassPtr2, _super);
          function SharedClassPtr2(spec) {
            var _this = _super.call(this, spec) || this;
            _this.readResources = [_nbind.resources.pool];
            _this.classType = spec.paramList[0].classType;
            _this.proto = _this.classType.proto;
            var isConst = spec.flags & 1;
            var push = isConst ? pushShared : pushMutableShared;
            _this.wireRead = function(arg2) {
              return popShared(arg2, _this);
            };
            _this.wireWrite = function(arg2) {
              return push(arg2, _this);
            };
            return _this;
          }
          return SharedClassPtr2;
        }(_nbind.BindType);
        _nbind.SharedClassPtr = SharedClassPtr;
        _nbind.externalList = [0];
        var firstFreeExternal = 0;
        var External = function() {
          function External2(data) {
            this.refCount = 1;
            this.data = data;
          }
          External2.prototype.register = function() {
            var num2 = firstFreeExternal;
            if (num2) {
              firstFreeExternal = _nbind.externalList[num2];
            } else
              num2 = _nbind.externalList.length;
            _nbind.externalList[num2] = this;
            return num2;
          };
          External2.prototype.reference = function() {
            ++this.refCount;
          };
          External2.prototype.dereference = function(num2) {
            if (--this.refCount == 0) {
              if (this.free)
                this.free();
              _nbind.externalList[num2] = firstFreeExternal;
              firstFreeExternal = num2;
            }
          };
          return External2;
        }();
        _nbind.External = External;
        function popExternal(num2) {
          var obj = _nbind.externalList[num2];
          obj.dereference(num2);
          return obj.data;
        }
        function pushExternal(obj) {
          var external = new External(obj);
          external.reference();
          return external.register();
        }
        var ExternalType = function(_super) {
          __extends(ExternalType2, _super);
          function ExternalType2() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.wireRead = popExternal;
            _this.wireWrite = pushExternal;
            return _this;
          }
          return ExternalType2;
        }(_nbind.BindType);
        _nbind.ExternalType = ExternalType;
        _nbind.callbackSignatureList = [];
        var CallbackType = function(_super) {
          __extends(CallbackType2, _super);
          function CallbackType2() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.wireWrite = function(func2) {
              if (typeof func2 != "function")
                _nbind.throwError("Type mismatch");
              return new _nbind.External(func2).register();
            };
            return _this;
          }
          return CallbackType2;
        }(_nbind.BindType);
        _nbind.CallbackType = CallbackType;
        _nbind.valueList = [0];
        var firstFreeValue = 0;
        function pushValue(value) {
          var num2 = firstFreeValue;
          if (num2) {
            firstFreeValue = _nbind.valueList[num2];
          } else
            num2 = _nbind.valueList.length;
          _nbind.valueList[num2] = value;
          return num2 * 2 + 1;
        }
        _nbind.pushValue = pushValue;
        function popValue(num2, type3) {
          if (!num2)
            _nbind.throwError("Value type JavaScript class is missing or not registered");
          if (num2 & 1) {
            num2 >>= 1;
            var obj = _nbind.valueList[num2];
            _nbind.valueList[num2] = firstFreeValue;
            firstFreeValue = num2;
            return obj;
          } else if (type3) {
            return _nbind.popShared(num2, type3);
          } else
            throw new Error("Invalid value slot " + num2);
        }
        _nbind.popValue = popValue;
        var valueBase = 18446744073709552e3;
        function push64(num2) {
          if (typeof num2 == "number")
            return num2;
          return pushValue(num2) * 4096 + valueBase;
        }
        function pop64(num2) {
          if (num2 < valueBase)
            return num2;
          return popValue((num2 - valueBase) / 4096);
        }
        var CreateValueType = function(_super) {
          __extends(CreateValueType2, _super);
          function CreateValueType2() {
            return _super !== null && _super.apply(this, arguments) || this;
          }
          CreateValueType2.prototype.makeWireWrite = function(expr) {
            return "(_nbind.pushValue(new " + expr + "))";
          };
          return CreateValueType2;
        }(_nbind.BindType);
        _nbind.CreateValueType = CreateValueType;
        var Int64Type = function(_super) {
          __extends(Int64Type2, _super);
          function Int64Type2() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.wireWrite = push64;
            _this.wireRead = pop64;
            return _this;
          }
          return Int64Type2;
        }(_nbind.BindType);
        _nbind.Int64Type = Int64Type;
        function pushArray(arr, type3) {
          if (!arr)
            return 0;
          var length = arr.length;
          if ((type3.size || type3.size === 0) && length < type3.size) {
            throw new Error("Type mismatch");
          }
          var ptrSize = type3.memberType.ptrSize;
          var result2 = _nbind.Pool.lalloc(4 + length * ptrSize);
          HEAPU32[result2 / 4] = length;
          var heap = type3.memberType.heap;
          var ptr2 = (result2 + 4) / ptrSize;
          var wireWrite = type3.memberType.wireWrite;
          var num2 = 0;
          if (wireWrite) {
            while (num2 < length) {
              heap[ptr2++] = wireWrite(arr[num2++]);
            }
          } else {
            while (num2 < length) {
              heap[ptr2++] = arr[num2++];
            }
          }
          return result2;
        }
        _nbind.pushArray = pushArray;
        function popArray(ptr2, type3) {
          if (ptr2 === 0)
            return null;
          var length = HEAPU32[ptr2 / 4];
          var arr = new Array(length);
          var heap = type3.memberType.heap;
          ptr2 = (ptr2 + 4) / type3.memberType.ptrSize;
          var wireRead = type3.memberType.wireRead;
          var num2 = 0;
          if (wireRead) {
            while (num2 < length) {
              arr[num2++] = wireRead(heap[ptr2++]);
            }
          } else {
            while (num2 < length) {
              arr[num2++] = heap[ptr2++];
            }
          }
          return arr;
        }
        _nbind.popArray = popArray;
        var ArrayType = function(_super) {
          __extends(ArrayType2, _super);
          function ArrayType2(spec) {
            var _this = _super.call(this, spec) || this;
            _this.wireRead = function(arg2) {
              return popArray(arg2, _this);
            };
            _this.wireWrite = function(arg2) {
              return pushArray(arg2, _this);
            };
            _this.readResources = [_nbind.resources.pool];
            _this.writeResources = [_nbind.resources.pool];
            _this.memberType = spec.paramList[0];
            if (spec.paramList[1])
              _this.size = spec.paramList[1];
            return _this;
          }
          return ArrayType2;
        }(_nbind.BindType);
        _nbind.ArrayType = ArrayType;
        function pushString(str2, policyTbl2) {
          if (str2 === null || str2 === void 0) {
            if (policyTbl2 && policyTbl2["Nullable"]) {
              str2 = "";
            } else
              throw new Error("Type mismatch");
          }
          if (policyTbl2 && policyTbl2["Strict"]) {
            if (typeof str2 != "string")
              throw new Error("Type mismatch");
          } else
            str2 = str2.toString();
          var length = Module.lengthBytesUTF8(str2);
          var result2 = _nbind.Pool.lalloc(4 + length + 1);
          HEAPU32[result2 / 4] = length;
          Module.stringToUTF8Array(str2, HEAPU8, result2 + 4, length + 1);
          return result2;
        }
        _nbind.pushString = pushString;
        function popString(ptr2) {
          if (ptr2 === 0)
            return null;
          var length = HEAPU32[ptr2 / 4];
          return Module.Pointer_stringify(ptr2 + 4, length);
        }
        _nbind.popString = popString;
        var StringType = function(_super) {
          __extends(StringType2, _super);
          function StringType2() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.wireRead = popString;
            _this.wireWrite = pushString;
            _this.readResources = [_nbind.resources.pool];
            _this.writeResources = [_nbind.resources.pool];
            return _this;
          }
          StringType2.prototype.makeWireWrite = function(expr, policyTbl2) {
            return function(arg2) {
              return pushString(arg2, policyTbl2);
            };
          };
          return StringType2;
        }(_nbind.BindType);
        _nbind.StringType = StringType;
        function makeArgList(argCount) {
          return Array.apply(null, Array(argCount)).map(function(dummy, num2) {
            return "a" + (num2 + 1);
          });
        }
        function anyNeedsWireWrite(typeList, policyTbl2) {
          return typeList.reduce(function(result2, type3) {
            return result2 || type3.needsWireWrite(policyTbl2);
          }, false);
        }
        function anyNeedsWireRead(typeList, policyTbl2) {
          return typeList.reduce(function(result2, type3) {
            return result2 || !!type3.needsWireRead(policyTbl2);
          }, false);
        }
        function makeWireRead(convertParamList2, policyTbl2, type3, expr) {
          var paramNum = convertParamList2.length;
          if (type3.makeWireRead) {
            return type3.makeWireRead(expr, convertParamList2, paramNum);
          } else if (type3.wireRead) {
            convertParamList2[paramNum] = type3.wireRead;
            return "(convertParamList[" + paramNum + "](" + expr + "))";
          } else
            return expr;
        }
        function makeWireWrite(convertParamList2, policyTbl2, type3, expr) {
          var wireWrite;
          var paramNum = convertParamList2.length;
          if (type3.makeWireWrite) {
            wireWrite = type3.makeWireWrite(expr, policyTbl2, convertParamList2, paramNum);
          } else
            wireWrite = type3.wireWrite;
          if (wireWrite) {
            if (typeof wireWrite == "string") {
              return wireWrite;
            } else {
              convertParamList2[paramNum] = wireWrite;
              return "(convertParamList[" + paramNum + "](" + expr + "))";
            }
          } else
            return expr;
        }
        function buildCallerFunction(dynCall, ptrType, ptr, num, policyTbl, needsWireWrite, prefix, returnType, argTypeList, mask, err) {
          var argList = makeArgList(argTypeList.length);
          var convertParamList = [];
          var callExpression = makeWireRead(convertParamList, policyTbl, returnType, "dynCall(" + [prefix].concat(argList.map(function(name, index) {
            return makeWireWrite(convertParamList, policyTbl, argTypeList[index], name);
          })).join(",") + ")");
          var resourceSet = _nbind.listResources([returnType], argTypeList);
          var sourceCode = "function(" + argList.join(",") + "){" + (mask ? "this.__nbindFlags&mask&&err();" : "") + resourceSet.makeOpen() + "var r=" + callExpression + ";" + resourceSet.makeClose() + "return r;}";
          return eval("(" + sourceCode + ")");
        }
        function buildJSCallerFunction(returnType, argTypeList) {
          var argList = makeArgList(argTypeList.length);
          var convertParamList = [];
          var callExpression = makeWireWrite(convertParamList, null, returnType, "_nbind.externalList[num].data(" + argList.map(function(name, index) {
            return makeWireRead(convertParamList, null, argTypeList[index], name);
          }).join(",") + ")");
          var resourceSet = _nbind.listResources(argTypeList, [returnType]);
          resourceSet.remove(_nbind.resources.pool);
          var sourceCode = "function(" + ["dummy", "num"].concat(argList).join(",") + "){" + resourceSet.makeOpen() + "var r=" + callExpression + ";" + resourceSet.makeClose() + "return r;}";
          return eval("(" + sourceCode + ")");
        }
        _nbind.buildJSCallerFunction = buildJSCallerFunction;
        function makeJSCaller(idList) {
          var argCount = idList.length - 1;
          var typeList = _nbind.getTypes(idList, "callback");
          var returnType2 = typeList[0];
          var argTypeList2 = typeList.slice(1);
          var needsWireRead = anyNeedsWireRead(argTypeList2, null);
          var needsWireWrite2 = returnType2.needsWireWrite(null);
          if (!needsWireWrite2 && !needsWireRead) {
            switch (argCount) {
              case 0:
                return function(dummy, num2) {
                  return _nbind.externalList[num2].data();
                };
              case 1:
                return function(dummy, num2, a1) {
                  return _nbind.externalList[num2].data(a1);
                };
              case 2:
                return function(dummy, num2, a1, a2) {
                  return _nbind.externalList[num2].data(a1, a2);
                };
              case 3:
                return function(dummy, num2, a1, a2, a3) {
                  return _nbind.externalList[num2].data(a1, a2, a3);
                };
              default:
                break;
            }
          }
          return buildJSCallerFunction(returnType2, argTypeList2);
        }
        _nbind.makeJSCaller = makeJSCaller;
        function makeMethodCaller(ptrType2, spec) {
          var argCount = spec.typeList.length - 1;
          var typeIdList = spec.typeList.slice(0);
          typeIdList.splice(1, 0, "uint32_t", spec.boundID);
          var typeList = _nbind.getTypes(typeIdList, spec.title);
          var returnType2 = typeList[0];
          var argTypeList2 = typeList.slice(3);
          var needsWireRead = returnType2.needsWireRead(spec.policyTbl);
          var needsWireWrite2 = anyNeedsWireWrite(argTypeList2, spec.policyTbl);
          var ptr2 = spec.ptr;
          var num2 = spec.num;
          var dynCall2 = _nbind.getDynCall(typeList, spec.title);
          var mask2 = ~spec.flags & 1;
          function err2() {
            throw new Error("Calling a non-const method on a const object");
          }
          if (!needsWireRead && !needsWireWrite2) {
            switch (argCount) {
              case 0:
                return function() {
                  return this.__nbindFlags & mask2 ? err2() : dynCall2(ptr2, num2, _nbind.pushPointer(this, ptrType2));
                };
              case 1:
                return function(a1) {
                  return this.__nbindFlags & mask2 ? err2() : dynCall2(ptr2, num2, _nbind.pushPointer(this, ptrType2), a1);
                };
              case 2:
                return function(a1, a2) {
                  return this.__nbindFlags & mask2 ? err2() : dynCall2(ptr2, num2, _nbind.pushPointer(this, ptrType2), a1, a2);
                };
              case 3:
                return function(a1, a2, a3) {
                  return this.__nbindFlags & mask2 ? err2() : dynCall2(ptr2, num2, _nbind.pushPointer(this, ptrType2), a1, a2, a3);
                };
              default:
                break;
            }
          }
          return buildCallerFunction(dynCall2, ptrType2, ptr2, num2, spec.policyTbl, needsWireWrite2, "ptr,num,pushPointer(this,ptrType)", returnType2, argTypeList2, mask2, err2);
        }
        _nbind.makeMethodCaller = makeMethodCaller;
        function makeCaller(spec) {
          var argCount = spec.typeList.length - 1;
          var typeList = _nbind.getTypes(spec.typeList, spec.title);
          var returnType2 = typeList[0];
          var argTypeList2 = typeList.slice(1);
          var needsWireRead = returnType2.needsWireRead(spec.policyTbl);
          var needsWireWrite2 = anyNeedsWireWrite(argTypeList2, spec.policyTbl);
          var direct = spec.direct;
          var ptr2 = spec.ptr;
          if (spec.direct && !needsWireRead && !needsWireWrite2) {
            var dynCall_1 = _nbind.getDynCall(typeList, spec.title);
            switch (argCount) {
              case 0:
                return function() {
                  return dynCall_1(direct);
                };
              case 1:
                return function(a1) {
                  return dynCall_1(direct, a1);
                };
              case 2:
                return function(a1, a2) {
                  return dynCall_1(direct, a1, a2);
                };
              case 3:
                return function(a1, a2, a3) {
                  return dynCall_1(direct, a1, a2, a3);
                };
              default:
                break;
            }
            ptr2 = 0;
          }
          var prefix2;
          if (ptr2) {
            var typeIdList = spec.typeList.slice(0);
            typeIdList.splice(1, 0, "uint32_t");
            typeList = _nbind.getTypes(typeIdList, spec.title);
            prefix2 = "ptr,num";
          } else {
            ptr2 = direct;
            prefix2 = "ptr";
          }
          var dynCall2 = _nbind.getDynCall(typeList, spec.title);
          return buildCallerFunction(dynCall2, null, ptr2, spec.num, spec.policyTbl, needsWireWrite2, prefix2, returnType2, argTypeList2);
        }
        _nbind.makeCaller = makeCaller;
        function makeOverloader(func2, arity) {
          var callerList = [];
          function call() {
            return callerList[arguments.length].apply(this, arguments);
          }
          call.addMethod = function(_func, _arity) {
            callerList[_arity] = _func;
          };
          call.addMethod(func2, arity);
          return call;
        }
        _nbind.makeOverloader = makeOverloader;
        var Resource = function() {
          function Resource2(open, close) {
            var _this = this;
            this.makeOpen = function() {
              return Object.keys(_this.openTbl).join("");
            };
            this.makeClose = function() {
              return Object.keys(_this.closeTbl).join("");
            };
            this.openTbl = {};
            this.closeTbl = {};
            if (open)
              this.openTbl[open] = true;
            if (close)
              this.closeTbl[close] = true;
          }
          Resource2.prototype.add = function(other) {
            for (var _i = 0, _a2 = Object.keys(other.openTbl); _i < _a2.length; _i++) {
              var key2 = _a2[_i];
              this.openTbl[key2] = true;
            }
            for (var _b = 0, _c = Object.keys(other.closeTbl); _b < _c.length; _b++) {
              var key2 = _c[_b];
              this.closeTbl[key2] = true;
            }
          };
          Resource2.prototype.remove = function(other) {
            for (var _i = 0, _a2 = Object.keys(other.openTbl); _i < _a2.length; _i++) {
              var key2 = _a2[_i];
              delete this.openTbl[key2];
            }
            for (var _b = 0, _c = Object.keys(other.closeTbl); _b < _c.length; _b++) {
              var key2 = _c[_b];
              delete this.closeTbl[key2];
            }
          };
          return Resource2;
        }();
        _nbind.Resource = Resource;
        function listResources(readList, writeList) {
          var result2 = new Resource();
          for (var _i = 0, readList_1 = readList; _i < readList_1.length; _i++) {
            var bindType = readList_1[_i];
            for (var _a2 = 0, _b = bindType.readResources || []; _a2 < _b.length; _a2++) {
              var resource = _b[_a2];
              result2.add(resource);
            }
          }
          for (var _c = 0, writeList_1 = writeList; _c < writeList_1.length; _c++) {
            var bindType = writeList_1[_c];
            for (var _d = 0, _e = bindType.writeResources || []; _d < _e.length; _d++) {
              var resource = _e[_d];
              result2.add(resource);
            }
          }
          return result2;
        }
        _nbind.listResources = listResources;
        _nbind.resources = { pool: new Resource("var used=HEAPU32[_nbind.Pool.usedPtr],page=HEAPU32[_nbind.Pool.pagePtr];", "_nbind.Pool.lreset(used,page);") };
        var ExternalBuffer = function(_super) {
          __extends(ExternalBuffer2, _super);
          function ExternalBuffer2(buf, ptr2) {
            var _this = _super.call(this, buf) || this;
            _this.ptr = ptr2;
            return _this;
          }
          ExternalBuffer2.prototype.free = function() {
            _free(this.ptr);
          };
          return ExternalBuffer2;
        }(_nbind.External);
        function getBuffer(buf) {
          if (buf instanceof ArrayBuffer) {
            return new Uint8Array(buf);
          } else if (buf instanceof DataView) {
            return new Uint8Array(buf.buffer, buf.byteOffset, buf.byteLength);
          } else
            return buf;
        }
        function pushBuffer(buf, policyTbl2) {
          if (buf === null || buf === void 0) {
            if (policyTbl2 && policyTbl2["Nullable"])
              buf = [];
          }
          if (typeof buf != "object")
            throw new Error("Type mismatch");
          var b2 = buf;
          var length = b2.byteLength || b2.length;
          if (!length && length !== 0 && b2.byteLength !== 0)
            throw new Error("Type mismatch");
          var result2 = _nbind.Pool.lalloc(8);
          var data = _malloc(length);
          var ptr2 = result2 / 4;
          HEAPU32[ptr2++] = length;
          HEAPU32[ptr2++] = data;
          HEAPU32[ptr2++] = new ExternalBuffer(buf, data).register();
          HEAPU8.set(getBuffer(buf), data);
          return result2;
        }
        var BufferType = function(_super) {
          __extends(BufferType2, _super);
          function BufferType2() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.wireWrite = pushBuffer;
            _this.readResources = [_nbind.resources.pool];
            _this.writeResources = [_nbind.resources.pool];
            return _this;
          }
          BufferType2.prototype.makeWireWrite = function(expr, policyTbl2) {
            return function(arg2) {
              return pushBuffer(arg2, policyTbl2);
            };
          };
          return BufferType2;
        }(_nbind.BindType);
        _nbind.BufferType = BufferType;
        function commitBuffer(num2, data, length) {
          var buf = _nbind.externalList[num2].data;
          var NodeBuffer = Buffer;
          if (typeof Buffer != "function")
            NodeBuffer = function() {
            };
          if (buf instanceof Array) {
          } else {
            var src = HEAPU8.subarray(data, data + length);
            if (buf instanceof NodeBuffer) {
              var srcBuf = void 0;
              if (typeof Buffer.from == "function" && Buffer.from.length >= 3) {
                srcBuf = Buffer.from(src);
              } else
                srcBuf = new Buffer(src);
              srcBuf.copy(buf);
            } else
              getBuffer(buf).set(src);
          }
        }
        _nbind.commitBuffer = commitBuffer;
        var dirtyList = [];
        var gcTimer = 0;
        function sweep() {
          for (var _i = 0, dirtyList_1 = dirtyList; _i < dirtyList_1.length; _i++) {
            var obj = dirtyList_1[_i];
            if (!(obj.__nbindState & (1 | 2))) {
              obj.free();
            }
          }
          dirtyList = [];
          gcTimer = 0;
        }
        _nbind.mark = function(obj) {
        };
        function toggleLightGC(enable) {
          if (enable) {
            _nbind.mark = function(obj) {
              dirtyList.push(obj);
              if (!gcTimer)
                gcTimer = setTimeout(sweep, 0);
            };
          } else {
            _nbind.mark = function(obj) {
            };
          }
        }
        _nbind.toggleLightGC = toggleLightGC;
      })(_nbind);
      Module["requestFullScreen"] = function Module_requestFullScreen(lockPointer, resizeCanvas, vrDevice) {
        Module.printErr("Module.requestFullScreen is deprecated. Please call Module.requestFullscreen instead.");
        Module["requestFullScreen"] = Module["requestFullscreen"];
        Browser.requestFullScreen(lockPointer, resizeCanvas, vrDevice);
      };
      Module["requestFullscreen"] = function Module_requestFullscreen(lockPointer, resizeCanvas, vrDevice) {
        Browser.requestFullscreen(lockPointer, resizeCanvas, vrDevice);
      };
      Module["requestAnimationFrame"] = function Module_requestAnimationFrame(func2) {
        Browser.requestAnimationFrame(func2);
      };
      Module["setCanvasSize"] = function Module_setCanvasSize(width, height, noUpdates) {
        Browser.setCanvasSize(width, height, noUpdates);
      };
      Module["pauseMainLoop"] = function Module_pauseMainLoop() {
        Browser.mainLoop.pause();
      };
      Module["resumeMainLoop"] = function Module_resumeMainLoop() {
        Browser.mainLoop.resume();
      };
      Module["getUserMedia"] = function Module_getUserMedia() {
        Browser.getUserMedia();
      };
      Module["createContext"] = function Module_createContext(canvas, useWebGL, setInModule, webGLContextAttributes) {
        return Browser.createContext(canvas, useWebGL, setInModule, webGLContextAttributes);
      };
      if (ENVIRONMENT_IS_NODE) {
        _emscripten_get_now = function _emscripten_get_now_actual() {
          var t2 = process["hrtime"]();
          return t2[0] * 1e3 + t2[1] / 1e6;
        };
      } else if (typeof dateNow !== "undefined") {
        _emscripten_get_now = dateNow;
      } else if (typeof self === "object" && self["performance"] && typeof self["performance"]["now"] === "function") {
        _emscripten_get_now = function() {
          return self["performance"]["now"]();
        };
      } else if (typeof performance === "object" && typeof performance["now"] === "function") {
        _emscripten_get_now = function() {
          return performance["now"]();
        };
      } else {
        _emscripten_get_now = Date.now;
      }
      __ATEXIT__.push(function() {
        var fflush = Module["_fflush"];
        if (fflush)
          fflush(0);
        var printChar = ___syscall146.printChar;
        if (!printChar)
          return;
        var buffers = ___syscall146.buffers;
        if (buffers[1].length)
          printChar(1, 10);
        if (buffers[2].length)
          printChar(2, 10);
      });
      DYNAMICTOP_PTR = allocate(1, "i32", ALLOC_STATIC);
      STACK_BASE = STACKTOP = Runtime.alignMemory(STATICTOP);
      STACK_MAX = STACK_BASE + TOTAL_STACK;
      DYNAMIC_BASE = Runtime.alignMemory(STACK_MAX);
      HEAP32[DYNAMICTOP_PTR >> 2] = DYNAMIC_BASE;
      staticSealed = true;
      function invoke_viiiii(index, a1, a2, a3, a4, a5) {
        try {
          Module["dynCall_viiiii"](index, a1, a2, a3, a4, a5);
        } catch (e2) {
          if (typeof e2 !== "number" && e2 !== "longjmp")
            throw e2;
          Module["setThrew"](1, 0);
        }
      }
      function invoke_vif(index, a1, a2) {
        try {
          Module["dynCall_vif"](index, a1, a2);
        } catch (e2) {
          if (typeof e2 !== "number" && e2 !== "longjmp")
            throw e2;
          Module["setThrew"](1, 0);
        }
      }
      function invoke_vid(index, a1, a2) {
        try {
          Module["dynCall_vid"](index, a1, a2);
        } catch (e2) {
          if (typeof e2 !== "number" && e2 !== "longjmp")
            throw e2;
          Module["setThrew"](1, 0);
        }
      }
      function invoke_fiff(index, a1, a2, a3) {
        try {
          return Module["dynCall_fiff"](index, a1, a2, a3);
        } catch (e2) {
          if (typeof e2 !== "number" && e2 !== "longjmp")
            throw e2;
          Module["setThrew"](1, 0);
        }
      }
      function invoke_vi(index, a1) {
        try {
          Module["dynCall_vi"](index, a1);
        } catch (e2) {
          if (typeof e2 !== "number" && e2 !== "longjmp")
            throw e2;
          Module["setThrew"](1, 0);
        }
      }
      function invoke_vii(index, a1, a2) {
        try {
          Module["dynCall_vii"](index, a1, a2);
        } catch (e2) {
          if (typeof e2 !== "number" && e2 !== "longjmp")
            throw e2;
          Module["setThrew"](1, 0);
        }
      }
      function invoke_ii(index, a1) {
        try {
          return Module["dynCall_ii"](index, a1);
        } catch (e2) {
          if (typeof e2 !== "number" && e2 !== "longjmp")
            throw e2;
          Module["setThrew"](1, 0);
        }
      }
      function invoke_viddi(index, a1, a2, a3, a4) {
        try {
          Module["dynCall_viddi"](index, a1, a2, a3, a4);
        } catch (e2) {
          if (typeof e2 !== "number" && e2 !== "longjmp")
            throw e2;
          Module["setThrew"](1, 0);
        }
      }
      function invoke_vidd(index, a1, a2, a3) {
        try {
          Module["dynCall_vidd"](index, a1, a2, a3);
        } catch (e2) {
          if (typeof e2 !== "number" && e2 !== "longjmp")
            throw e2;
          Module["setThrew"](1, 0);
        }
      }
      function invoke_iiii(index, a1, a2, a3) {
        try {
          return Module["dynCall_iiii"](index, a1, a2, a3);
        } catch (e2) {
          if (typeof e2 !== "number" && e2 !== "longjmp")
            throw e2;
          Module["setThrew"](1, 0);
        }
      }
      function invoke_diii(index, a1, a2, a3) {
        try {
          return Module["dynCall_diii"](index, a1, a2, a3);
        } catch (e2) {
          if (typeof e2 !== "number" && e2 !== "longjmp")
            throw e2;
          Module["setThrew"](1, 0);
        }
      }
      function invoke_di(index, a1) {
        try {
          return Module["dynCall_di"](index, a1);
        } catch (e2) {
          if (typeof e2 !== "number" && e2 !== "longjmp")
            throw e2;
          Module["setThrew"](1, 0);
        }
      }
      function invoke_iid(index, a1, a2) {
        try {
          return Module["dynCall_iid"](index, a1, a2);
        } catch (e2) {
          if (typeof e2 !== "number" && e2 !== "longjmp")
            throw e2;
          Module["setThrew"](1, 0);
        }
      }
      function invoke_iii(index, a1, a2) {
        try {
          return Module["dynCall_iii"](index, a1, a2);
        } catch (e2) {
          if (typeof e2 !== "number" && e2 !== "longjmp")
            throw e2;
          Module["setThrew"](1, 0);
        }
      }
      function invoke_viiddi(index, a1, a2, a3, a4, a5) {
        try {
          Module["dynCall_viiddi"](index, a1, a2, a3, a4, a5);
        } catch (e2) {
          if (typeof e2 !== "number" && e2 !== "longjmp")
            throw e2;
          Module["setThrew"](1, 0);
        }
      }
      function invoke_viiiiii(index, a1, a2, a3, a4, a5, a6) {
        try {
          Module["dynCall_viiiiii"](index, a1, a2, a3, a4, a5, a6);
        } catch (e2) {
          if (typeof e2 !== "number" && e2 !== "longjmp")
            throw e2;
          Module["setThrew"](1, 0);
        }
      }
      function invoke_dii(index, a1, a2) {
        try {
          return Module["dynCall_dii"](index, a1, a2);
        } catch (e2) {
          if (typeof e2 !== "number" && e2 !== "longjmp")
            throw e2;
          Module["setThrew"](1, 0);
        }
      }
      function invoke_i(index) {
        try {
          return Module["dynCall_i"](index);
        } catch (e2) {
          if (typeof e2 !== "number" && e2 !== "longjmp")
            throw e2;
          Module["setThrew"](1, 0);
        }
      }
      function invoke_iiiiii(index, a1, a2, a3, a4, a5) {
        try {
          return Module["dynCall_iiiiii"](index, a1, a2, a3, a4, a5);
        } catch (e2) {
          if (typeof e2 !== "number" && e2 !== "longjmp")
            throw e2;
          Module["setThrew"](1, 0);
        }
      }
      function invoke_viiid(index, a1, a2, a3, a4) {
        try {
          Module["dynCall_viiid"](index, a1, a2, a3, a4);
        } catch (e2) {
          if (typeof e2 !== "number" && e2 !== "longjmp")
            throw e2;
          Module["setThrew"](1, 0);
        }
      }
      function invoke_viififi(index, a1, a2, a3, a4, a5, a6) {
        try {
          Module["dynCall_viififi"](index, a1, a2, a3, a4, a5, a6);
        } catch (e2) {
          if (typeof e2 !== "number" && e2 !== "longjmp")
            throw e2;
          Module["setThrew"](1, 0);
        }
      }
      function invoke_viii(index, a1, a2, a3) {
        try {
          Module["dynCall_viii"](index, a1, a2, a3);
        } catch (e2) {
          if (typeof e2 !== "number" && e2 !== "longjmp")
            throw e2;
          Module["setThrew"](1, 0);
        }
      }
      function invoke_v(index) {
        try {
          Module["dynCall_v"](index);
        } catch (e2) {
          if (typeof e2 !== "number" && e2 !== "longjmp")
            throw e2;
          Module["setThrew"](1, 0);
        }
      }
      function invoke_viid(index, a1, a2, a3) {
        try {
          Module["dynCall_viid"](index, a1, a2, a3);
        } catch (e2) {
          if (typeof e2 !== "number" && e2 !== "longjmp")
            throw e2;
          Module["setThrew"](1, 0);
        }
      }
      function invoke_idd(index, a1, a2) {
        try {
          return Module["dynCall_idd"](index, a1, a2);
        } catch (e2) {
          if (typeof e2 !== "number" && e2 !== "longjmp")
            throw e2;
          Module["setThrew"](1, 0);
        }
      }
      function invoke_viiii(index, a1, a2, a3, a4) {
        try {
          Module["dynCall_viiii"](index, a1, a2, a3, a4);
        } catch (e2) {
          if (typeof e2 !== "number" && e2 !== "longjmp")
            throw e2;
          Module["setThrew"](1, 0);
        }
      }
      Module.asmGlobalArg = { "Math": Math, "Int8Array": Int8Array, "Int16Array": Int16Array, "Int32Array": Int32Array, "Uint8Array": Uint8Array, "Uint16Array": Uint16Array, "Uint32Array": Uint32Array, "Float32Array": Float32Array, "Float64Array": Float64Array, "NaN": NaN, "Infinity": Infinity };
      Module.asmLibraryArg = { "abort": abort, "assert": assert, "enlargeMemory": enlargeMemory, "getTotalMemory": getTotalMemory, "abortOnCannotGrowMemory": abortOnCannotGrowMemory, "invoke_viiiii": invoke_viiiii, "invoke_vif": invoke_vif, "invoke_vid": invoke_vid, "invoke_fiff": invoke_fiff, "invoke_vi": invoke_vi, "invoke_vii": invoke_vii, "invoke_ii": invoke_ii, "invoke_viddi": invoke_viddi, "invoke_vidd": invoke_vidd, "invoke_iiii": invoke_iiii, "invoke_diii": invoke_diii, "invoke_di": invoke_di, "invoke_iid": invoke_iid, "invoke_iii": invoke_iii, "invoke_viiddi": invoke_viiddi, "invoke_viiiiii": invoke_viiiiii, "invoke_dii": invoke_dii, "invoke_i": invoke_i, "invoke_iiiiii": invoke_iiiiii, "invoke_viiid": invoke_viiid, "invoke_viififi": invoke_viififi, "invoke_viii": invoke_viii, "invoke_v": invoke_v, "invoke_viid": invoke_viid, "invoke_idd": invoke_idd, "invoke_viiii": invoke_viiii, "_emscripten_asm_const_iiiii": _emscripten_asm_const_iiiii, "_emscripten_asm_const_iiidddddd": _emscripten_asm_const_iiidddddd, "_emscripten_asm_const_iiiid": _emscripten_asm_const_iiiid, "__nbind_reference_external": __nbind_reference_external, "_emscripten_asm_const_iiiiiiii": _emscripten_asm_const_iiiiiiii, "_removeAccessorPrefix": _removeAccessorPrefix, "_typeModule": _typeModule, "__nbind_register_pool": __nbind_register_pool, "__decorate": __decorate, "_llvm_stackrestore": _llvm_stackrestore, "___cxa_atexit": ___cxa_atexit, "__extends": __extends, "__nbind_get_value_object": __nbind_get_value_object, "__ZN8facebook4yoga14YGNodeToStringEPNSt3__212basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEEP6YGNode14YGPrintOptionsj": __ZN8facebook4yoga14YGNodeToStringEPNSt3__212basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEEP6YGNode14YGPrintOptionsj, "_emscripten_set_main_loop_timing": _emscripten_set_main_loop_timing, "__nbind_register_primitive": __nbind_register_primitive, "__nbind_register_type": __nbind_register_type, "_emscripten_memcpy_big": _emscripten_memcpy_big, "__nbind_register_function": __nbind_register_function, "___setErrNo": ___setErrNo, "__nbind_register_class": __nbind_register_class, "__nbind_finish": __nbind_finish, "_abort": _abort, "_nbind_value": _nbind_value, "_llvm_stacksave": _llvm_stacksave, "___syscall54": ___syscall54, "_defineHidden": _defineHidden, "_emscripten_set_main_loop": _emscripten_set_main_loop, "_emscripten_get_now": _emscripten_get_now, "__nbind_register_callback_signature": __nbind_register_callback_signature, "_emscripten_asm_const_iiiiii": _emscripten_asm_const_iiiiii, "__nbind_free_external": __nbind_free_external, "_emscripten_asm_const_iiii": _emscripten_asm_const_iiii, "_emscripten_asm_const_iiididi": _emscripten_asm_const_iiididi, "___syscall6": ___syscall6, "_atexit": _atexit, "___syscall140": ___syscall140, "___syscall146": ___syscall146, "DYNAMICTOP_PTR": DYNAMICTOP_PTR, "tempDoublePtr": tempDoublePtr, "ABORT": ABORT, "STACKTOP": STACKTOP, "STACK_MAX": STACK_MAX, "cttz_i8": cttz_i8, "___dso_handle": ___dso_handle };
      var asm = function(global2, env, buffer2) {
        ;
        var a2 = new global2.Int8Array(buffer2);
        var b2 = new global2.Int16Array(buffer2);
        var c2 = new global2.Int32Array(buffer2);
        var d = new global2.Uint8Array(buffer2);
        var e2 = new global2.Uint16Array(buffer2);
        var f = new global2.Uint32Array(buffer2);
        var g2 = new global2.Float32Array(buffer2);
        var h = new global2.Float64Array(buffer2);
        var i3 = env.DYNAMICTOP_PTR | 0;
        var j = env.tempDoublePtr | 0;
        var k = env.ABORT | 0;
        var l2 = env.STACKTOP | 0;
        var m = env.STACK_MAX | 0;
        var n2 = env.cttz_i8 | 0;
        var o2 = env.___dso_handle | 0;
        var p = 0;
        var q = 0;
        var r2 = 0;
        var s2 = 0;
        var t2 = global2.NaN, u2 = global2.Infinity;
        var v = 0, w = 0, x = 0, y2 = 0, z = 0;
        var A = 0;
        var B = global2.Math.floor;
        var C = global2.Math.abs;
        var D = global2.Math.sqrt;
        var E = global2.Math.pow;
        var F = global2.Math.cos;
        var G = global2.Math.sin;
        var H = global2.Math.tan;
        var I = global2.Math.acos;
        var J = global2.Math.asin;
        var K = global2.Math.atan;
        var L = global2.Math.atan2;
        var M = global2.Math.exp;
        var N = global2.Math.log;
        var O = global2.Math.ceil;
        var P = global2.Math.imul;
        var Q = global2.Math.min;
        var R = global2.Math.max;
        var S = global2.Math.clz32;
        var T = global2.Math.fround;
        var U = env.abort;
        var V = env.assert;
        var W = env.enlargeMemory;
        var X = env.getTotalMemory;
        var Y = env.abortOnCannotGrowMemory;
        var Z = env.invoke_viiiii;
        var _ = env.invoke_vif;
        var $ = env.invoke_vid;
        var aa = env.invoke_fiff;
        var ba = env.invoke_vi;
        var ca = env.invoke_vii;
        var da = env.invoke_ii;
        var ea = env.invoke_viddi;
        var fa = env.invoke_vidd;
        var ga = env.invoke_iiii;
        var ha = env.invoke_diii;
        var ia = env.invoke_di;
        var ja = env.invoke_iid;
        var ka = env.invoke_iii;
        var la = env.invoke_viiddi;
        var ma = env.invoke_viiiiii;
        var na = env.invoke_dii;
        var oa = env.invoke_i;
        var pa = env.invoke_iiiiii;
        var qa = env.invoke_viiid;
        var ra = env.invoke_viififi;
        var sa = env.invoke_viii;
        var ta = env.invoke_v;
        var ua = env.invoke_viid;
        var va = env.invoke_idd;
        var wa = env.invoke_viiii;
        var xa = env._emscripten_asm_const_iiiii;
        var ya = env._emscripten_asm_const_iiidddddd;
        var za = env._emscripten_asm_const_iiiid;
        var Aa = env.__nbind_reference_external;
        var Ba = env._emscripten_asm_const_iiiiiiii;
        var Ca = env._removeAccessorPrefix;
        var Da = env._typeModule;
        var Ea = env.__nbind_register_pool;
        var Fa = env.__decorate;
        var Ga = env._llvm_stackrestore;
        var Ha = env.___cxa_atexit;
        var Ia = env.__extends;
        var Ja = env.__nbind_get_value_object;
        var Ka = env.__ZN8facebook4yoga14YGNodeToStringEPNSt3__212basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEEP6YGNode14YGPrintOptionsj;
        var La = env._emscripten_set_main_loop_timing;
        var Ma = env.__nbind_register_primitive;
        var Na = env.__nbind_register_type;
        var Oa = env._emscripten_memcpy_big;
        var Pa = env.__nbind_register_function;
        var Qa = env.___setErrNo;
        var Ra = env.__nbind_register_class;
        var Sa = env.__nbind_finish;
        var Ta = env._abort;
        var Ua = env._nbind_value;
        var Va = env._llvm_stacksave;
        var Wa = env.___syscall54;
        var Xa = env._defineHidden;
        var Ya = env._emscripten_set_main_loop;
        var Za = env._emscripten_get_now;
        var _a2 = env.__nbind_register_callback_signature;
        var $a = env._emscripten_asm_const_iiiiii;
        var ab = env.__nbind_free_external;
        var bb = env._emscripten_asm_const_iiii;
        var cb2 = env._emscripten_asm_const_iiididi;
        var db = env.___syscall6;
        var eb = env._atexit;
        var fb = env.___syscall140;
        var gb = env.___syscall146;
        var hb = T(0);
        const ib = T(0);
        function Jb(a3) {
          a3 = a3 | 0;
          var b3 = 0;
          b3 = l2;
          l2 = l2 + a3 | 0;
          l2 = l2 + 15 & -16;
          return b3 | 0;
        }
        function Kb() {
          return l2 | 0;
        }
        function Lb(a3) {
          a3 = a3 | 0;
          l2 = a3;
        }
        function Mb(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          l2 = a3;
          m = b3;
        }
        function Nb(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          if (!p) {
            p = a3;
            q = b3;
          }
        }
        function Ob(a3) {
          a3 = a3 | 0;
          A = a3;
        }
        function Pb() {
          return A | 0;
        }
        function Qb() {
          var b3 = 0, d2 = 0;
          BC(8104, 8, 400) | 0;
          BC(8504, 408, 540) | 0;
          b3 = 9044;
          d2 = b3 + 44 | 0;
          do {
            c2[b3 >> 2] = 0;
            b3 = b3 + 4 | 0;
          } while ((b3 | 0) < (d2 | 0));
          a2[9088] = 0;
          a2[9089] = 1;
          c2[2273] = 0;
          c2[2274] = 948;
          c2[2275] = 948;
          Ha(17, 8104, o2 | 0) | 0;
          return;
        }
        function Rb(a3) {
          a3 = a3 | 0;
          oc(a3 + 948 | 0);
          return;
        }
        function Sb(a3) {
          a3 = T(a3);
          return ((af(a3) | 0) & 2147483647) >>> 0 > 2139095040 | 0;
        }
        function Tb(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          a:
            do
              if (!(c2[a3 + (b3 << 3) + 4 >> 2] | 0)) {
                if ((b3 | 2 | 0) == 3 ? c2[a3 + 60 >> 2] | 0 : 0) {
                  a3 = a3 + 56 | 0;
                  break;
                }
                switch (b3 | 0) {
                  case 0:
                  case 2:
                  case 4:
                  case 5: {
                    if (c2[a3 + 52 >> 2] | 0) {
                      a3 = a3 + 48 | 0;
                      break a;
                    }
                    break;
                  }
                  default: {
                  }
                }
                if (!(c2[a3 + 68 >> 2] | 0)) {
                  a3 = (b3 | 1 | 0) == 5 ? 948 : d2;
                  break;
                } else {
                  a3 = a3 + 64 | 0;
                  break;
                }
              } else
                a3 = a3 + (b3 << 3) | 0;
            while (0);
          return a3 | 0;
        }
        function Ub(b3) {
          b3 = b3 | 0;
          var d2 = 0;
          d2 = oB(1e3) | 0;
          Vb(b3, (d2 | 0) != 0, 2456);
          c2[2276] = (c2[2276] | 0) + 1;
          BC(d2 | 0, 8104, 1e3) | 0;
          if (a2[b3 + 2 >> 0] | 0) {
            c2[d2 + 4 >> 2] = 2;
            c2[d2 + 12 >> 2] = 4;
          }
          c2[d2 + 976 >> 2] = b3;
          return d2 | 0;
        }
        function Vb(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          var e3 = 0, f2 = 0;
          f2 = l2;
          l2 = l2 + 16 | 0;
          e3 = f2;
          if (!b3) {
            c2[e3 >> 2] = d2;
            fe(a3, 5, 3197, e3);
          }
          l2 = f2;
          return;
        }
        function Wb() {
          return Ub(956) | 0;
        }
        function Xb(a3) {
          a3 = a3 | 0;
          var b3 = 0;
          b3 = qC(1e3) | 0;
          Yb(b3, a3);
          Vb(c2[a3 + 976 >> 2] | 0, 1, 2456);
          c2[2276] = (c2[2276] | 0) + 1;
          c2[b3 + 944 >> 2] = 0;
          return b3 | 0;
        }
        function Yb(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          var d2 = 0;
          BC(a3 | 0, b3 | 0, 948) | 0;
          ie(a3 + 948 | 0, b3 + 948 | 0);
          d2 = a3 + 960 | 0;
          a3 = b3 + 960 | 0;
          b3 = d2 + 40 | 0;
          do {
            c2[d2 >> 2] = c2[a3 >> 2];
            d2 = d2 + 4 | 0;
            a3 = a3 + 4 | 0;
          } while ((d2 | 0) < (b3 | 0));
          return;
        }
        function Zb(a3) {
          a3 = a3 | 0;
          var b3 = 0, d2 = 0, e3 = 0, f2 = 0;
          b3 = a3 + 944 | 0;
          d2 = c2[b3 >> 2] | 0;
          if (d2 | 0) {
            _b(d2 + 948 | 0, a3) | 0;
            c2[b3 >> 2] = 0;
          }
          d2 = $b(a3) | 0;
          if (d2 | 0) {
            b3 = 0;
            do {
              c2[(ac(a3, b3) | 0) + 944 >> 2] = 0;
              b3 = b3 + 1 | 0;
            } while ((b3 | 0) != (d2 | 0));
          }
          d2 = a3 + 948 | 0;
          e3 = c2[d2 >> 2] | 0;
          f2 = a3 + 952 | 0;
          b3 = c2[f2 >> 2] | 0;
          if ((b3 | 0) != (e3 | 0))
            c2[f2 >> 2] = b3 + (~((b3 + -4 - e3 | 0) >>> 2) << 2);
          bc(d2);
          pB(a3);
          c2[2276] = (c2[2276] | 0) + -1;
          return;
        }
        function _b(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          var d2 = 0, e3 = 0, f2 = 0, g3 = 0, h2 = 0, i4 = 0;
          e3 = c2[a3 >> 2] | 0;
          i4 = a3 + 4 | 0;
          d2 = c2[i4 >> 2] | 0;
          g3 = d2;
          a:
            do
              if ((e3 | 0) == (d2 | 0)) {
                f2 = e3;
                h2 = 4;
              } else {
                a3 = e3;
                while (1) {
                  if ((c2[a3 >> 2] | 0) == (b3 | 0)) {
                    f2 = a3;
                    h2 = 4;
                    break a;
                  }
                  a3 = a3 + 4 | 0;
                  if ((a3 | 0) == (d2 | 0)) {
                    a3 = 0;
                    break;
                  }
                }
              }
            while (0);
          if ((h2 | 0) == 4)
            if ((f2 | 0) != (d2 | 0)) {
              e3 = f2 + 4 | 0;
              a3 = g3 - e3 | 0;
              b3 = a3 >> 2;
              if (b3) {
                GC(f2 | 0, e3 | 0, a3 | 0) | 0;
                d2 = c2[i4 >> 2] | 0;
              }
              a3 = f2 + (b3 << 2) | 0;
              if ((d2 | 0) == (a3 | 0))
                a3 = 1;
              else {
                c2[i4 >> 2] = d2 + (~((d2 + -4 - a3 | 0) >>> 2) << 2);
                a3 = 1;
              }
            } else
              a3 = 0;
          return a3 | 0;
        }
        function $b(a3) {
          a3 = a3 | 0;
          return (c2[a3 + 952 >> 2] | 0) - (c2[a3 + 948 >> 2] | 0) >> 2 | 0;
        }
        function ac(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          var d2 = 0;
          d2 = c2[a3 + 948 >> 2] | 0;
          if ((c2[a3 + 952 >> 2] | 0) - d2 >> 2 >>> 0 > b3 >>> 0)
            a3 = c2[d2 + (b3 << 2) >> 2] | 0;
          else
            a3 = 0;
          return a3 | 0;
        }
        function bc(a3) {
          a3 = a3 | 0;
          var b3 = 0, d2 = 0, e3 = 0, f2 = 0;
          e3 = l2;
          l2 = l2 + 32 | 0;
          b3 = e3;
          f2 = c2[a3 >> 2] | 0;
          d2 = (c2[a3 + 4 >> 2] | 0) - f2 | 0;
          if (((c2[a3 + 8 >> 2] | 0) - f2 | 0) >>> 0 > d2 >>> 0) {
            f2 = d2 >> 2;
            bf(b3, f2, f2, a3 + 8 | 0);
            cf(a3, b3);
            df(b3);
          }
          l2 = e3;
          return;
        }
        function cc(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          var d2 = 0, e3 = 0, f2 = 0, g3 = 0, h2 = 0, i4 = 0, j2 = 0, k2 = 0;
          k2 = $b(a3) | 0;
          do
            if (k2 | 0) {
              if ((c2[(ac(a3, 0) | 0) + 944 >> 2] | 0) == (a3 | 0)) {
                if (!(_b(a3 + 948 | 0, b3) | 0))
                  break;
                BC(b3 + 400 | 0, 8504, 540) | 0;
                c2[b3 + 944 >> 2] = 0;
                nc(a3);
                break;
              }
              h2 = c2[(c2[a3 + 976 >> 2] | 0) + 12 >> 2] | 0;
              i4 = a3 + 948 | 0;
              j2 = (h2 | 0) == 0;
              d2 = 0;
              g3 = 0;
              do {
                e3 = c2[(c2[i4 >> 2] | 0) + (g3 << 2) >> 2] | 0;
                if ((e3 | 0) == (b3 | 0))
                  nc(a3);
                else {
                  f2 = Xb(e3) | 0;
                  c2[(c2[i4 >> 2] | 0) + (d2 << 2) >> 2] = f2;
                  c2[f2 + 944 >> 2] = a3;
                  if (!j2)
                    Ib[h2 & 15](e3, f2, a3, d2);
                  d2 = d2 + 1 | 0;
                }
                g3 = g3 + 1 | 0;
              } while ((g3 | 0) != (k2 | 0));
              if (d2 >>> 0 < k2 >>> 0) {
                j2 = a3 + 948 | 0;
                i4 = a3 + 952 | 0;
                h2 = d2;
                d2 = c2[i4 >> 2] | 0;
                do {
                  g3 = (c2[j2 >> 2] | 0) + (h2 << 2) | 0;
                  e3 = g3 + 4 | 0;
                  f2 = d2 - e3 | 0;
                  b3 = f2 >> 2;
                  if (!b3)
                    f2 = d2;
                  else {
                    GC(g3 | 0, e3 | 0, f2 | 0) | 0;
                    d2 = c2[i4 >> 2] | 0;
                    f2 = d2;
                  }
                  e3 = g3 + (b3 << 2) | 0;
                  if ((f2 | 0) != (e3 | 0)) {
                    d2 = f2 + (~((f2 + -4 - e3 | 0) >>> 2) << 2) | 0;
                    c2[i4 >> 2] = d2;
                  }
                  h2 = h2 + 1 | 0;
                } while ((h2 | 0) != (k2 | 0));
              }
            }
          while (0);
          return;
        }
        function dc(b3) {
          b3 = b3 | 0;
          var d2 = 0, e3 = 0, f2 = 0, g3 = 0;
          ec(b3, ($b(b3) | 0) == 0, 2491);
          ec(b3, (c2[b3 + 944 >> 2] | 0) == 0, 2545);
          d2 = b3 + 948 | 0;
          e3 = c2[d2 >> 2] | 0;
          f2 = b3 + 952 | 0;
          g3 = c2[f2 >> 2] | 0;
          if ((g3 | 0) != (e3 | 0))
            c2[f2 >> 2] = g3 + (~((g3 + -4 - e3 | 0) >>> 2) << 2);
          bc(d2);
          d2 = b3 + 976 | 0;
          e3 = c2[d2 >> 2] | 0;
          BC(b3 | 0, 8104, 1e3) | 0;
          if (a2[e3 + 2 >> 0] | 0) {
            c2[b3 + 4 >> 2] = 2;
            c2[b3 + 12 >> 2] = 4;
          }
          c2[d2 >> 2] = e3;
          return;
        }
        function ec(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          var e3 = 0, f2 = 0;
          f2 = l2;
          l2 = l2 + 16 | 0;
          e3 = f2;
          if (!b3) {
            c2[e3 >> 2] = d2;
            Vd(a3, 5, 3197, e3);
          }
          l2 = f2;
          return;
        }
        function fc() {
          return c2[2276] | 0;
        }
        function gc() {
          var a3 = 0;
          a3 = oB(20) | 0;
          hc((a3 | 0) != 0, 2592);
          c2[2277] = (c2[2277] | 0) + 1;
          c2[a3 >> 2] = c2[239];
          c2[a3 + 4 >> 2] = c2[240];
          c2[a3 + 8 >> 2] = c2[241];
          c2[a3 + 12 >> 2] = c2[242];
          c2[a3 + 16 >> 2] = c2[243];
          return a3 | 0;
        }
        function hc(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          var d2 = 0, e3 = 0;
          e3 = l2;
          l2 = l2 + 16 | 0;
          d2 = e3;
          if (!a3) {
            c2[d2 >> 2] = b3;
            Vd(0, 5, 3197, d2);
          }
          l2 = e3;
          return;
        }
        function ic(a3) {
          a3 = a3 | 0;
          pB(a3);
          c2[2277] = (c2[2277] | 0) + -1;
          return;
        }
        function jc(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          var d2 = 0;
          if (!b3) {
            d2 = 0;
            b3 = 0;
          } else {
            ec(a3, ($b(a3) | 0) == 0, 2629);
            d2 = 1;
          }
          c2[a3 + 964 >> 2] = b3;
          c2[a3 + 988 >> 2] = d2;
          return;
        }
        function kc(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          var e3 = 0, f2 = 0, g3 = 0, h2 = 0;
          e3 = l2;
          l2 = l2 + 16 | 0;
          g3 = e3 + 8 | 0;
          f2 = e3 + 4 | 0;
          h2 = e3;
          c2[f2 >> 2] = b3;
          ec(a3, (c2[b3 + 944 >> 2] | 0) == 0, 2709);
          ec(a3, (c2[a3 + 964 >> 2] | 0) == 0, 2763);
          lc(a3);
          b3 = a3 + 948 | 0;
          c2[h2 >> 2] = (c2[b3 >> 2] | 0) + (d2 << 2);
          c2[g3 >> 2] = c2[h2 >> 2];
          mc(b3, g3, f2) | 0;
          c2[(c2[f2 >> 2] | 0) + 944 >> 2] = a3;
          nc(a3);
          l2 = e3;
          return;
        }
        function lc(a3) {
          a3 = a3 | 0;
          var b3 = 0, d2 = 0, e3 = 0, f2 = 0, g3 = 0, h2 = 0, i4 = 0;
          d2 = $b(a3) | 0;
          if (d2 | 0 ? (c2[(ac(a3, 0) | 0) + 944 >> 2] | 0) != (a3 | 0) : 0) {
            e3 = c2[(c2[a3 + 976 >> 2] | 0) + 12 >> 2] | 0;
            f2 = a3 + 948 | 0;
            g3 = (e3 | 0) == 0;
            b3 = 0;
            do {
              h2 = c2[(c2[f2 >> 2] | 0) + (b3 << 2) >> 2] | 0;
              i4 = Xb(h2) | 0;
              c2[(c2[f2 >> 2] | 0) + (b3 << 2) >> 2] = i4;
              c2[i4 + 944 >> 2] = a3;
              if (!g3)
                Ib[e3 & 15](h2, i4, a3, b3);
              b3 = b3 + 1 | 0;
            } while ((b3 | 0) != (d2 | 0));
          }
          return;
        }
        function mc(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          var e3 = 0, f2 = 0, g3 = 0, h2 = 0, i4 = 0, j2 = 0, k2 = 0, m2 = 0, n3 = 0, o3 = 0, p2 = 0, q2 = 0, r3 = 0, s3 = 0, t3 = 0;
          s3 = l2;
          l2 = l2 + 64 | 0;
          n3 = s3 + 52 | 0;
          i4 = s3 + 48 | 0;
          o3 = s3 + 28 | 0;
          p2 = s3 + 24 | 0;
          q2 = s3 + 20 | 0;
          r3 = s3;
          e3 = c2[a3 >> 2] | 0;
          g3 = e3;
          b3 = e3 + ((c2[b3 >> 2] | 0) - g3 >> 2 << 2) | 0;
          e3 = a3 + 4 | 0;
          f2 = c2[e3 >> 2] | 0;
          h2 = a3 + 8 | 0;
          do
            if (f2 >>> 0 < (c2[h2 >> 2] | 0) >>> 0) {
              if ((b3 | 0) == (f2 | 0)) {
                c2[b3 >> 2] = c2[d2 >> 2];
                c2[e3 >> 2] = (c2[e3 >> 2] | 0) + 4;
                break;
              }
              ef(a3, b3, f2, b3 + 4 | 0);
              if (b3 >>> 0 <= d2 >>> 0)
                d2 = (c2[e3 >> 2] | 0) >>> 0 > d2 >>> 0 ? d2 + 4 | 0 : d2;
              c2[b3 >> 2] = c2[d2 >> 2];
            } else {
              e3 = (f2 - g3 >> 2) + 1 | 0;
              f2 = le(a3) | 0;
              if (f2 >>> 0 < e3 >>> 0)
                jC(a3);
              m2 = c2[a3 >> 2] | 0;
              k2 = (c2[h2 >> 2] | 0) - m2 | 0;
              g3 = k2 >> 1;
              bf(r3, k2 >> 2 >>> 0 < f2 >>> 1 >>> 0 ? g3 >>> 0 < e3 >>> 0 ? e3 : g3 : f2, b3 - m2 >> 2, a3 + 8 | 0);
              m2 = r3 + 8 | 0;
              e3 = c2[m2 >> 2] | 0;
              g3 = r3 + 12 | 0;
              k2 = c2[g3 >> 2] | 0;
              h2 = k2;
              j2 = e3;
              do
                if ((e3 | 0) == (k2 | 0)) {
                  k2 = r3 + 4 | 0;
                  e3 = c2[k2 >> 2] | 0;
                  t3 = c2[r3 >> 2] | 0;
                  f2 = t3;
                  if (e3 >>> 0 <= t3 >>> 0) {
                    e3 = h2 - f2 >> 1;
                    e3 = (e3 | 0) == 0 ? 1 : e3;
                    bf(o3, e3, e3 >>> 2, c2[r3 + 16 >> 2] | 0);
                    c2[p2 >> 2] = c2[k2 >> 2];
                    c2[q2 >> 2] = c2[m2 >> 2];
                    c2[i4 >> 2] = c2[p2 >> 2];
                    c2[n3 >> 2] = c2[q2 >> 2];
                    gf(o3, i4, n3);
                    e3 = c2[r3 >> 2] | 0;
                    c2[r3 >> 2] = c2[o3 >> 2];
                    c2[o3 >> 2] = e3;
                    e3 = o3 + 4 | 0;
                    t3 = c2[k2 >> 2] | 0;
                    c2[k2 >> 2] = c2[e3 >> 2];
                    c2[e3 >> 2] = t3;
                    e3 = o3 + 8 | 0;
                    t3 = c2[m2 >> 2] | 0;
                    c2[m2 >> 2] = c2[e3 >> 2];
                    c2[e3 >> 2] = t3;
                    e3 = o3 + 12 | 0;
                    t3 = c2[g3 >> 2] | 0;
                    c2[g3 >> 2] = c2[e3 >> 2];
                    c2[e3 >> 2] = t3;
                    df(o3);
                    e3 = c2[m2 >> 2] | 0;
                    break;
                  }
                  g3 = e3;
                  h2 = ((g3 - f2 >> 2) + 1 | 0) / -2 | 0;
                  i4 = e3 + (h2 << 2) | 0;
                  f2 = j2 - g3 | 0;
                  g3 = f2 >> 2;
                  if (g3) {
                    GC(i4 | 0, e3 | 0, f2 | 0) | 0;
                    e3 = c2[k2 >> 2] | 0;
                  }
                  t3 = i4 + (g3 << 2) | 0;
                  c2[m2 >> 2] = t3;
                  c2[k2 >> 2] = e3 + (h2 << 2);
                  e3 = t3;
                }
              while (0);
              c2[e3 >> 2] = c2[d2 >> 2];
              c2[m2 >> 2] = (c2[m2 >> 2] | 0) + 4;
              b3 = ff(a3, r3, b3) | 0;
              df(r3);
            }
          while (0);
          l2 = s3;
          return b3 | 0;
        }
        function nc(b3) {
          b3 = b3 | 0;
          var d2 = 0;
          do {
            d2 = b3 + 984 | 0;
            if (a2[d2 >> 0] | 0)
              break;
            a2[d2 >> 0] = 1;
            g2[b3 + 504 >> 2] = T(t2);
            b3 = c2[b3 + 944 >> 2] | 0;
          } while ((b3 | 0) != 0);
          return;
        }
        function oc(a3) {
          a3 = a3 | 0;
          var b3 = 0, d2 = 0, e3 = 0;
          d2 = c2[a3 >> 2] | 0;
          e3 = d2;
          if (d2 | 0) {
            a3 = a3 + 4 | 0;
            b3 = c2[a3 >> 2] | 0;
            if ((b3 | 0) != (d2 | 0))
              c2[a3 >> 2] = b3 + (~((b3 + -4 - e3 | 0) >>> 2) << 2);
            sC(d2);
          }
          return;
        }
        function pc(a3) {
          a3 = a3 | 0;
          return c2[a3 + 944 >> 2] | 0;
        }
        function qc(a3) {
          a3 = a3 | 0;
          ec(a3, (c2[a3 + 964 >> 2] | 0) != 0, 2832);
          nc(a3);
          return;
        }
        function rc(b3) {
          b3 = b3 | 0;
          return (a2[b3 + 984 >> 0] | 0) != 0 | 0;
        }
        function sc(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          if (BB(a3, b3, 400) | 0) {
            BC(a3 | 0, b3 | 0, 400) | 0;
            nc(a3);
          }
          return;
        }
        function tc(a3) {
          a3 = a3 | 0;
          var b3 = ib;
          b3 = T(g2[a3 + 44 >> 2]);
          a3 = Sb(b3) | 0;
          return T(a3 ? T(0) : b3);
        }
        function uc(b3) {
          b3 = b3 | 0;
          var d2 = ib;
          d2 = T(g2[b3 + 48 >> 2]);
          if (Sb(d2) | 0)
            d2 = a2[(c2[b3 + 976 >> 2] | 0) + 2 >> 0] | 0 ? T(1) : T(0);
          return T(d2);
        }
        function vc(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          c2[a3 + 980 >> 2] = b3;
          return;
        }
        function wc(a3) {
          a3 = a3 | 0;
          return c2[a3 + 980 >> 2] | 0;
        }
        function xc(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          var d2 = 0;
          d2 = a3 + 4 | 0;
          if ((c2[d2 >> 2] | 0) != (b3 | 0)) {
            c2[d2 >> 2] = b3;
            nc(a3);
          }
          return;
        }
        function yc(a3) {
          a3 = a3 | 0;
          return c2[a3 + 4 >> 2] | 0;
        }
        function zc(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          var d2 = 0;
          d2 = a3 + 8 | 0;
          if ((c2[d2 >> 2] | 0) != (b3 | 0)) {
            c2[d2 >> 2] = b3;
            nc(a3);
          }
          return;
        }
        function Ac(a3) {
          a3 = a3 | 0;
          return c2[a3 + 8 >> 2] | 0;
        }
        function Bc(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          var d2 = 0;
          d2 = a3 + 12 | 0;
          if ((c2[d2 >> 2] | 0) != (b3 | 0)) {
            c2[d2 >> 2] = b3;
            nc(a3);
          }
          return;
        }
        function Cc(a3) {
          a3 = a3 | 0;
          return c2[a3 + 12 >> 2] | 0;
        }
        function Dc(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          var d2 = 0;
          d2 = a3 + 16 | 0;
          if ((c2[d2 >> 2] | 0) != (b3 | 0)) {
            c2[d2 >> 2] = b3;
            nc(a3);
          }
          return;
        }
        function Ec(a3) {
          a3 = a3 | 0;
          return c2[a3 + 16 >> 2] | 0;
        }
        function Fc(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          var d2 = 0;
          d2 = a3 + 20 | 0;
          if ((c2[d2 >> 2] | 0) != (b3 | 0)) {
            c2[d2 >> 2] = b3;
            nc(a3);
          }
          return;
        }
        function Gc(a3) {
          a3 = a3 | 0;
          return c2[a3 + 20 >> 2] | 0;
        }
        function Hc(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          var d2 = 0;
          d2 = a3 + 24 | 0;
          if ((c2[d2 >> 2] | 0) != (b3 | 0)) {
            c2[d2 >> 2] = b3;
            nc(a3);
          }
          return;
        }
        function Ic(a3) {
          a3 = a3 | 0;
          return c2[a3 + 24 >> 2] | 0;
        }
        function Jc(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          var d2 = 0;
          d2 = a3 + 28 | 0;
          if ((c2[d2 >> 2] | 0) != (b3 | 0)) {
            c2[d2 >> 2] = b3;
            nc(a3);
          }
          return;
        }
        function Kc(a3) {
          a3 = a3 | 0;
          return c2[a3 + 28 >> 2] | 0;
        }
        function Lc(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          var d2 = 0;
          d2 = a3 + 32 | 0;
          if ((c2[d2 >> 2] | 0) != (b3 | 0)) {
            c2[d2 >> 2] = b3;
            nc(a3);
          }
          return;
        }
        function Mc(a3) {
          a3 = a3 | 0;
          return c2[a3 + 32 >> 2] | 0;
        }
        function Nc(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          var d2 = 0;
          d2 = a3 + 36 | 0;
          if ((c2[d2 >> 2] | 0) != (b3 | 0)) {
            c2[d2 >> 2] = b3;
            nc(a3);
          }
          return;
        }
        function Oc(a3) {
          a3 = a3 | 0;
          return c2[a3 + 36 >> 2] | 0;
        }
        function Pc(a3, b3) {
          a3 = a3 | 0;
          b3 = T(b3);
          var c3 = 0;
          c3 = a3 + 40 | 0;
          if (T(g2[c3 >> 2]) != b3) {
            g2[c3 >> 2] = b3;
            nc(a3);
          }
          return;
        }
        function Qc(a3, b3) {
          a3 = a3 | 0;
          b3 = T(b3);
          var c3 = 0;
          c3 = a3 + 44 | 0;
          if (T(g2[c3 >> 2]) != b3) {
            g2[c3 >> 2] = b3;
            nc(a3);
          }
          return;
        }
        function Rc(a3, b3) {
          a3 = a3 | 0;
          b3 = T(b3);
          var c3 = 0;
          c3 = a3 + 48 | 0;
          if (T(g2[c3 >> 2]) != b3) {
            g2[c3 >> 2] = b3;
            nc(a3);
          }
          return;
        }
        function Sc(a3, b3) {
          a3 = a3 | 0;
          b3 = T(b3);
          var d2 = 0, e3 = 0, f2 = 0, h2 = 0;
          h2 = Sb(b3) | 0;
          d2 = (h2 ^ 1) & 1;
          e3 = a3 + 52 | 0;
          f2 = a3 + 56 | 0;
          if (!(h2 | T(g2[e3 >> 2]) == b3 ? (c2[f2 >> 2] | 0) == (d2 | 0) : 0)) {
            g2[e3 >> 2] = b3;
            c2[f2 >> 2] = d2;
            nc(a3);
          }
          return;
        }
        function Tc(a3, b3) {
          a3 = a3 | 0;
          b3 = T(b3);
          var d2 = 0, e3 = 0;
          e3 = a3 + 52 | 0;
          d2 = a3 + 56 | 0;
          if (!(!(T(g2[e3 >> 2]) != b3) ? (c2[d2 >> 2] | 0) == 2 : 0)) {
            g2[e3 >> 2] = b3;
            e3 = Sb(b3) | 0;
            c2[d2 >> 2] = e3 ? 3 : 2;
            nc(a3);
          }
          return;
        }
        function Uc(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          var d2 = 0, e3 = 0;
          e3 = b3 + 52 | 0;
          d2 = c2[e3 + 4 >> 2] | 0;
          b3 = a3;
          c2[b3 >> 2] = c2[e3 >> 2];
          c2[b3 + 4 >> 2] = d2;
          return;
        }
        function Vc(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = T(d2);
          var e3 = 0, f2 = 0, h2 = 0;
          h2 = Sb(d2) | 0;
          e3 = (h2 ^ 1) & 1;
          f2 = a3 + 132 + (b3 << 3) | 0;
          b3 = a3 + 132 + (b3 << 3) + 4 | 0;
          if (!(h2 | T(g2[f2 >> 2]) == d2 ? (c2[b3 >> 2] | 0) == (e3 | 0) : 0)) {
            g2[f2 >> 2] = d2;
            c2[b3 >> 2] = e3;
            nc(a3);
          }
          return;
        }
        function Wc(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = T(d2);
          var e3 = 0, f2 = 0, h2 = 0;
          h2 = Sb(d2) | 0;
          e3 = h2 ? 0 : 2;
          f2 = a3 + 132 + (b3 << 3) | 0;
          b3 = a3 + 132 + (b3 << 3) + 4 | 0;
          if (!(h2 | T(g2[f2 >> 2]) == d2 ? (c2[b3 >> 2] | 0) == (e3 | 0) : 0)) {
            g2[f2 >> 2] = d2;
            c2[b3 >> 2] = e3;
            nc(a3);
          }
          return;
        }
        function Xc(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          var e3 = 0;
          e3 = b3 + 132 + (d2 << 3) | 0;
          b3 = c2[e3 + 4 >> 2] | 0;
          d2 = a3;
          c2[d2 >> 2] = c2[e3 >> 2];
          c2[d2 + 4 >> 2] = b3;
          return;
        }
        function Yc(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = T(d2);
          var e3 = 0, f2 = 0, h2 = 0;
          h2 = Sb(d2) | 0;
          e3 = (h2 ^ 1) & 1;
          f2 = a3 + 60 + (b3 << 3) | 0;
          b3 = a3 + 60 + (b3 << 3) + 4 | 0;
          if (!(h2 | T(g2[f2 >> 2]) == d2 ? (c2[b3 >> 2] | 0) == (e3 | 0) : 0)) {
            g2[f2 >> 2] = d2;
            c2[b3 >> 2] = e3;
            nc(a3);
          }
          return;
        }
        function Zc(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = T(d2);
          var e3 = 0, f2 = 0, h2 = 0;
          h2 = Sb(d2) | 0;
          e3 = h2 ? 0 : 2;
          f2 = a3 + 60 + (b3 << 3) | 0;
          b3 = a3 + 60 + (b3 << 3) + 4 | 0;
          if (!(h2 | T(g2[f2 >> 2]) == d2 ? (c2[b3 >> 2] | 0) == (e3 | 0) : 0)) {
            g2[f2 >> 2] = d2;
            c2[b3 >> 2] = e3;
            nc(a3);
          }
          return;
        }
        function _c(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          var e3 = 0;
          e3 = b3 + 60 + (d2 << 3) | 0;
          b3 = c2[e3 + 4 >> 2] | 0;
          d2 = a3;
          c2[d2 >> 2] = c2[e3 >> 2];
          c2[d2 + 4 >> 2] = b3;
          return;
        }
        function $c(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          var d2 = 0;
          d2 = a3 + 60 + (b3 << 3) + 4 | 0;
          if ((c2[d2 >> 2] | 0) != 3) {
            g2[a3 + 60 + (b3 << 3) >> 2] = T(t2);
            c2[d2 >> 2] = 3;
            nc(a3);
          }
          return;
        }
        function ad(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = T(d2);
          var e3 = 0, f2 = 0, h2 = 0;
          h2 = Sb(d2) | 0;
          e3 = (h2 ^ 1) & 1;
          f2 = a3 + 204 + (b3 << 3) | 0;
          b3 = a3 + 204 + (b3 << 3) + 4 | 0;
          if (!(h2 | T(g2[f2 >> 2]) == d2 ? (c2[b3 >> 2] | 0) == (e3 | 0) : 0)) {
            g2[f2 >> 2] = d2;
            c2[b3 >> 2] = e3;
            nc(a3);
          }
          return;
        }
        function bd(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = T(d2);
          var e3 = 0, f2 = 0, h2 = 0;
          h2 = Sb(d2) | 0;
          e3 = h2 ? 0 : 2;
          f2 = a3 + 204 + (b3 << 3) | 0;
          b3 = a3 + 204 + (b3 << 3) + 4 | 0;
          if (!(h2 | T(g2[f2 >> 2]) == d2 ? (c2[b3 >> 2] | 0) == (e3 | 0) : 0)) {
            g2[f2 >> 2] = d2;
            c2[b3 >> 2] = e3;
            nc(a3);
          }
          return;
        }
        function cd(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          var e3 = 0;
          e3 = b3 + 204 + (d2 << 3) | 0;
          b3 = c2[e3 + 4 >> 2] | 0;
          d2 = a3;
          c2[d2 >> 2] = c2[e3 >> 2];
          c2[d2 + 4 >> 2] = b3;
          return;
        }
        function dd(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = T(d2);
          var e3 = 0, f2 = 0, h2 = 0;
          h2 = Sb(d2) | 0;
          e3 = (h2 ^ 1) & 1;
          f2 = a3 + 276 + (b3 << 3) | 0;
          b3 = a3 + 276 + (b3 << 3) + 4 | 0;
          if (!(h2 | T(g2[f2 >> 2]) == d2 ? (c2[b3 >> 2] | 0) == (e3 | 0) : 0)) {
            g2[f2 >> 2] = d2;
            c2[b3 >> 2] = e3;
            nc(a3);
          }
          return;
        }
        function ed(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          return T(g2[a3 + 276 + (b3 << 3) >> 2]);
        }
        function fd(a3, b3) {
          a3 = a3 | 0;
          b3 = T(b3);
          var d2 = 0, e3 = 0, f2 = 0, h2 = 0;
          h2 = Sb(b3) | 0;
          d2 = (h2 ^ 1) & 1;
          e3 = a3 + 348 | 0;
          f2 = a3 + 352 | 0;
          if (!(h2 | T(g2[e3 >> 2]) == b3 ? (c2[f2 >> 2] | 0) == (d2 | 0) : 0)) {
            g2[e3 >> 2] = b3;
            c2[f2 >> 2] = d2;
            nc(a3);
          }
          return;
        }
        function gd(a3, b3) {
          a3 = a3 | 0;
          b3 = T(b3);
          var d2 = 0, e3 = 0;
          e3 = a3 + 348 | 0;
          d2 = a3 + 352 | 0;
          if (!(!(T(g2[e3 >> 2]) != b3) ? (c2[d2 >> 2] | 0) == 2 : 0)) {
            g2[e3 >> 2] = b3;
            e3 = Sb(b3) | 0;
            c2[d2 >> 2] = e3 ? 3 : 2;
            nc(a3);
          }
          return;
        }
        function hd(a3) {
          a3 = a3 | 0;
          var b3 = 0;
          b3 = a3 + 352 | 0;
          if ((c2[b3 >> 2] | 0) != 3) {
            g2[a3 + 348 >> 2] = T(t2);
            c2[b3 >> 2] = 3;
            nc(a3);
          }
          return;
        }
        function id(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          var d2 = 0, e3 = 0;
          e3 = b3 + 348 | 0;
          d2 = c2[e3 + 4 >> 2] | 0;
          b3 = a3;
          c2[b3 >> 2] = c2[e3 >> 2];
          c2[b3 + 4 >> 2] = d2;
          return;
        }
        function jd(a3, b3) {
          a3 = a3 | 0;
          b3 = T(b3);
          var d2 = 0, e3 = 0, f2 = 0, h2 = 0;
          h2 = Sb(b3) | 0;
          d2 = (h2 ^ 1) & 1;
          e3 = a3 + 356 | 0;
          f2 = a3 + 360 | 0;
          if (!(h2 | T(g2[e3 >> 2]) == b3 ? (c2[f2 >> 2] | 0) == (d2 | 0) : 0)) {
            g2[e3 >> 2] = b3;
            c2[f2 >> 2] = d2;
            nc(a3);
          }
          return;
        }
        function kd(a3, b3) {
          a3 = a3 | 0;
          b3 = T(b3);
          var d2 = 0, e3 = 0;
          e3 = a3 + 356 | 0;
          d2 = a3 + 360 | 0;
          if (!(!(T(g2[e3 >> 2]) != b3) ? (c2[d2 >> 2] | 0) == 2 : 0)) {
            g2[e3 >> 2] = b3;
            e3 = Sb(b3) | 0;
            c2[d2 >> 2] = e3 ? 3 : 2;
            nc(a3);
          }
          return;
        }
        function ld(a3) {
          a3 = a3 | 0;
          var b3 = 0;
          b3 = a3 + 360 | 0;
          if ((c2[b3 >> 2] | 0) != 3) {
            g2[a3 + 356 >> 2] = T(t2);
            c2[b3 >> 2] = 3;
            nc(a3);
          }
          return;
        }
        function md(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          var d2 = 0, e3 = 0;
          e3 = b3 + 356 | 0;
          d2 = c2[e3 + 4 >> 2] | 0;
          b3 = a3;
          c2[b3 >> 2] = c2[e3 >> 2];
          c2[b3 + 4 >> 2] = d2;
          return;
        }
        function nd(a3, b3) {
          a3 = a3 | 0;
          b3 = T(b3);
          var d2 = 0, e3 = 0, f2 = 0, h2 = 0;
          h2 = Sb(b3) | 0;
          d2 = (h2 ^ 1) & 1;
          e3 = a3 + 364 | 0;
          f2 = a3 + 368 | 0;
          if (!(h2 | T(g2[e3 >> 2]) == b3 ? (c2[f2 >> 2] | 0) == (d2 | 0) : 0)) {
            g2[e3 >> 2] = b3;
            c2[f2 >> 2] = d2;
            nc(a3);
          }
          return;
        }
        function od(a3, b3) {
          a3 = a3 | 0;
          b3 = T(b3);
          var d2 = 0, e3 = 0, f2 = 0, h2 = 0;
          h2 = Sb(b3) | 0;
          d2 = h2 ? 0 : 2;
          e3 = a3 + 364 | 0;
          f2 = a3 + 368 | 0;
          if (!(h2 | T(g2[e3 >> 2]) == b3 ? (c2[f2 >> 2] | 0) == (d2 | 0) : 0)) {
            g2[e3 >> 2] = b3;
            c2[f2 >> 2] = d2;
            nc(a3);
          }
          return;
        }
        function pd(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          var d2 = 0, e3 = 0;
          e3 = b3 + 364 | 0;
          d2 = c2[e3 + 4 >> 2] | 0;
          b3 = a3;
          c2[b3 >> 2] = c2[e3 >> 2];
          c2[b3 + 4 >> 2] = d2;
          return;
        }
        function qd(a3, b3) {
          a3 = a3 | 0;
          b3 = T(b3);
          var d2 = 0, e3 = 0, f2 = 0, h2 = 0;
          h2 = Sb(b3) | 0;
          d2 = (h2 ^ 1) & 1;
          e3 = a3 + 372 | 0;
          f2 = a3 + 376 | 0;
          if (!(h2 | T(g2[e3 >> 2]) == b3 ? (c2[f2 >> 2] | 0) == (d2 | 0) : 0)) {
            g2[e3 >> 2] = b3;
            c2[f2 >> 2] = d2;
            nc(a3);
          }
          return;
        }
        function rd(a3, b3) {
          a3 = a3 | 0;
          b3 = T(b3);
          var d2 = 0, e3 = 0, f2 = 0, h2 = 0;
          h2 = Sb(b3) | 0;
          d2 = h2 ? 0 : 2;
          e3 = a3 + 372 | 0;
          f2 = a3 + 376 | 0;
          if (!(h2 | T(g2[e3 >> 2]) == b3 ? (c2[f2 >> 2] | 0) == (d2 | 0) : 0)) {
            g2[e3 >> 2] = b3;
            c2[f2 >> 2] = d2;
            nc(a3);
          }
          return;
        }
        function sd(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          var d2 = 0, e3 = 0;
          e3 = b3 + 372 | 0;
          d2 = c2[e3 + 4 >> 2] | 0;
          b3 = a3;
          c2[b3 >> 2] = c2[e3 >> 2];
          c2[b3 + 4 >> 2] = d2;
          return;
        }
        function td(a3, b3) {
          a3 = a3 | 0;
          b3 = T(b3);
          var d2 = 0, e3 = 0, f2 = 0, h2 = 0;
          h2 = Sb(b3) | 0;
          d2 = (h2 ^ 1) & 1;
          e3 = a3 + 380 | 0;
          f2 = a3 + 384 | 0;
          if (!(h2 | T(g2[e3 >> 2]) == b3 ? (c2[f2 >> 2] | 0) == (d2 | 0) : 0)) {
            g2[e3 >> 2] = b3;
            c2[f2 >> 2] = d2;
            nc(a3);
          }
          return;
        }
        function ud(a3, b3) {
          a3 = a3 | 0;
          b3 = T(b3);
          var d2 = 0, e3 = 0, f2 = 0, h2 = 0;
          h2 = Sb(b3) | 0;
          d2 = h2 ? 0 : 2;
          e3 = a3 + 380 | 0;
          f2 = a3 + 384 | 0;
          if (!(h2 | T(g2[e3 >> 2]) == b3 ? (c2[f2 >> 2] | 0) == (d2 | 0) : 0)) {
            g2[e3 >> 2] = b3;
            c2[f2 >> 2] = d2;
            nc(a3);
          }
          return;
        }
        function vd(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          var d2 = 0, e3 = 0;
          e3 = b3 + 380 | 0;
          d2 = c2[e3 + 4 >> 2] | 0;
          b3 = a3;
          c2[b3 >> 2] = c2[e3 >> 2];
          c2[b3 + 4 >> 2] = d2;
          return;
        }
        function wd(a3, b3) {
          a3 = a3 | 0;
          b3 = T(b3);
          var d2 = 0, e3 = 0, f2 = 0, h2 = 0;
          h2 = Sb(b3) | 0;
          d2 = (h2 ^ 1) & 1;
          e3 = a3 + 388 | 0;
          f2 = a3 + 392 | 0;
          if (!(h2 | T(g2[e3 >> 2]) == b3 ? (c2[f2 >> 2] | 0) == (d2 | 0) : 0)) {
            g2[e3 >> 2] = b3;
            c2[f2 >> 2] = d2;
            nc(a3);
          }
          return;
        }
        function xd(a3, b3) {
          a3 = a3 | 0;
          b3 = T(b3);
          var d2 = 0, e3 = 0, f2 = 0, h2 = 0;
          h2 = Sb(b3) | 0;
          d2 = h2 ? 0 : 2;
          e3 = a3 + 388 | 0;
          f2 = a3 + 392 | 0;
          if (!(h2 | T(g2[e3 >> 2]) == b3 ? (c2[f2 >> 2] | 0) == (d2 | 0) : 0)) {
            g2[e3 >> 2] = b3;
            c2[f2 >> 2] = d2;
            nc(a3);
          }
          return;
        }
        function yd(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          var d2 = 0, e3 = 0;
          e3 = b3 + 388 | 0;
          d2 = c2[e3 + 4 >> 2] | 0;
          b3 = a3;
          c2[b3 >> 2] = c2[e3 >> 2];
          c2[b3 + 4 >> 2] = d2;
          return;
        }
        function zd(a3, b3) {
          a3 = a3 | 0;
          b3 = T(b3);
          var c3 = 0;
          c3 = a3 + 396 | 0;
          if (T(g2[c3 >> 2]) != b3) {
            g2[c3 >> 2] = b3;
            nc(a3);
          }
          return;
        }
        function Ad(a3) {
          a3 = a3 | 0;
          return T(g2[a3 + 396 >> 2]);
        }
        function Bd(a3) {
          a3 = a3 | 0;
          return T(g2[a3 + 400 >> 2]);
        }
        function Cd(a3) {
          a3 = a3 | 0;
          return T(g2[a3 + 404 >> 2]);
        }
        function Dd(a3) {
          a3 = a3 | 0;
          return T(g2[a3 + 408 >> 2]);
        }
        function Ed(a3) {
          a3 = a3 | 0;
          return T(g2[a3 + 412 >> 2]);
        }
        function Fd(a3) {
          a3 = a3 | 0;
          return T(g2[a3 + 416 >> 2]);
        }
        function Gd(a3) {
          a3 = a3 | 0;
          return T(g2[a3 + 420 >> 2]);
        }
        function Hd(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          ec(a3, (b3 | 0) < 6, 2918);
          switch (b3 | 0) {
            case 0: {
              b3 = (c2[a3 + 496 >> 2] | 0) == 2 ? 5 : 4;
              break;
            }
            case 2: {
              b3 = (c2[a3 + 496 >> 2] | 0) == 2 ? 4 : 5;
              break;
            }
            default: {
            }
          }
          return T(g2[a3 + 424 + (b3 << 2) >> 2]);
        }
        function Id(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          ec(a3, (b3 | 0) < 6, 2918);
          switch (b3 | 0) {
            case 0: {
              b3 = (c2[a3 + 496 >> 2] | 0) == 2 ? 5 : 4;
              break;
            }
            case 2: {
              b3 = (c2[a3 + 496 >> 2] | 0) == 2 ? 4 : 5;
              break;
            }
            default: {
            }
          }
          return T(g2[a3 + 448 + (b3 << 2) >> 2]);
        }
        function Jd(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          ec(a3, (b3 | 0) < 6, 2918);
          switch (b3 | 0) {
            case 0: {
              b3 = (c2[a3 + 496 >> 2] | 0) == 2 ? 5 : 4;
              break;
            }
            case 2: {
              b3 = (c2[a3 + 496 >> 2] | 0) == 2 ? 4 : 5;
              break;
            }
            default: {
            }
          }
          return T(g2[a3 + 472 + (b3 << 2) >> 2]);
        }
        function Kd(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          var d2 = 0, e3 = ib;
          d2 = c2[a3 + 4 >> 2] | 0;
          if ((d2 | 0) == (c2[b3 + 4 >> 2] | 0)) {
            if (!d2)
              a3 = 1;
            else {
              e3 = T(g2[a3 >> 2]);
              a3 = T(C(T(e3 - T(g2[b3 >> 2])))) < T(999999974e-13);
            }
          } else
            a3 = 0;
          return a3 | 0;
        }
        function Ld(a3, b3) {
          a3 = T(a3);
          b3 = T(b3);
          var c3 = 0;
          if (Sb(a3) | 0)
            c3 = Sb(b3) | 0;
          else
            c3 = T(C(T(a3 - b3))) < T(999999974e-13);
          return c3 | 0;
        }
        function Md(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          Nd(a3, b3);
          return;
        }
        function Nd(b3, d2) {
          b3 = b3 | 0;
          d2 = d2 | 0;
          var e3 = 0, f2 = 0;
          e3 = l2;
          l2 = l2 + 16 | 0;
          f2 = e3 + 4 | 0;
          c2[f2 >> 2] = 0;
          c2[f2 + 4 >> 2] = 0;
          c2[f2 + 8 >> 2] = 0;
          Ka(f2 | 0, b3 | 0, d2 | 0, 0);
          Vd(b3, 3, (a2[f2 + 11 >> 0] | 0) < 0 ? c2[f2 >> 2] | 0 : f2, e3);
          tC(f2);
          l2 = e3;
          return;
        }
        function Od(a3, b3, c3, d2) {
          a3 = T(a3);
          b3 = T(b3);
          c3 = c3 | 0;
          d2 = d2 | 0;
          var e3 = ib;
          a3 = T(a3 * b3);
          e3 = T(gC(a3, T(1)));
          do
            if (!(Ld(e3, T(0)) | 0)) {
              a3 = T(a3 - e3);
              if (Ld(e3, T(1)) | 0) {
                a3 = T(a3 + T(1));
                break;
              }
              if (c3) {
                a3 = T(a3 + T(1));
                break;
              }
              if (!d2) {
                if (e3 > T(0.5))
                  e3 = T(1);
                else {
                  d2 = Ld(e3, T(0.5)) | 0;
                  e3 = d2 ? T(1) : T(0);
                }
                a3 = T(a3 + e3);
              }
            } else
              a3 = T(a3 - e3);
          while (0);
          return T(a3 / b3);
        }
        function Pd(a3, b3, c3, d2, e3, f2, h2, i4, j2, k2, l3, m2, n3) {
          a3 = a3 | 0;
          b3 = T(b3);
          c3 = c3 | 0;
          d2 = T(d2);
          e3 = e3 | 0;
          f2 = T(f2);
          h2 = h2 | 0;
          i4 = T(i4);
          j2 = T(j2);
          k2 = T(k2);
          l3 = T(l3);
          m2 = T(m2);
          n3 = n3 | 0;
          var o3 = 0, p2 = ib, q2 = ib, r3 = ib, s3 = ib, t3 = ib, u3 = ib;
          if (j2 < T(0) | k2 < T(0))
            n3 = 0;
          else {
            if ((n3 | 0) != 0 ? (p2 = T(g2[n3 + 4 >> 2]), p2 != T(0)) : 0) {
              r3 = T(Od(b3, p2, 0, 0));
              s3 = T(Od(d2, p2, 0, 0));
              q2 = T(Od(f2, p2, 0, 0));
              p2 = T(Od(i4, p2, 0, 0));
            } else {
              q2 = f2;
              r3 = b3;
              p2 = i4;
              s3 = d2;
            }
            if ((e3 | 0) == (a3 | 0))
              o3 = Ld(q2, r3) | 0;
            else
              o3 = 0;
            if ((h2 | 0) == (c3 | 0))
              n3 = Ld(p2, s3) | 0;
            else
              n3 = 0;
            if ((!o3 ? (t3 = T(b3 - l3), !(Qd(a3, t3, j2) | 0)) : 0) ? !(Rd(a3, t3, e3, j2) | 0) : 0)
              o3 = Sd(a3, t3, e3, f2, j2) | 0;
            else
              o3 = 1;
            if ((!n3 ? (u3 = T(d2 - m2), !(Qd(c3, u3, k2) | 0)) : 0) ? !(Rd(c3, u3, h2, k2) | 0) : 0)
              n3 = Sd(c3, u3, h2, i4, k2) | 0;
            else
              n3 = 1;
            n3 = o3 & n3;
          }
          return n3 | 0;
        }
        function Qd(a3, b3, c3) {
          a3 = a3 | 0;
          b3 = T(b3);
          c3 = T(c3);
          if ((a3 | 0) == 1)
            a3 = Ld(b3, c3) | 0;
          else
            a3 = 0;
          return a3 | 0;
        }
        function Rd(a3, b3, c3, d2) {
          a3 = a3 | 0;
          b3 = T(b3);
          c3 = c3 | 0;
          d2 = T(d2);
          if ((a3 | 0) == 2 & (c3 | 0) == 0) {
            if (!(b3 >= d2))
              a3 = Ld(b3, d2) | 0;
            else
              a3 = 1;
          } else
            a3 = 0;
          return a3 | 0;
        }
        function Sd(a3, b3, c3, d2, e3) {
          a3 = a3 | 0;
          b3 = T(b3);
          c3 = c3 | 0;
          d2 = T(d2);
          e3 = T(e3);
          if ((a3 | 0) == 2 & (c3 | 0) == 2 & d2 > b3) {
            if (!(e3 <= b3))
              a3 = Ld(b3, e3) | 0;
            else
              a3 = 1;
          } else
            a3 = 0;
          return a3 | 0;
        }
        function Td(b3, d2, e3, f2, i4, j2, k2, m2, n3, o3, p2) {
          b3 = b3 | 0;
          d2 = T(d2);
          e3 = T(e3);
          f2 = f2 | 0;
          i4 = i4 | 0;
          j2 = j2 | 0;
          k2 = T(k2);
          m2 = T(m2);
          n3 = n3 | 0;
          o3 = o3 | 0;
          p2 = p2 | 0;
          var q2 = 0, r3 = 0, s3 = 0, t3 = 0, u3 = ib, v2 = ib, w2 = 0, x2 = 0, y3 = 0, z2 = 0, A2 = 0, B2 = 0, C2 = 0, D2 = 0, E2 = 0, F2 = 0, G2 = 0, H2 = ib, I2 = ib, J2 = ib, K2 = 0, L2 = 0;
          G2 = l2;
          l2 = l2 + 160 | 0;
          D2 = G2 + 152 | 0;
          C2 = G2 + 120 | 0;
          B2 = G2 + 104 | 0;
          y3 = G2 + 72 | 0;
          t3 = G2 + 56 | 0;
          A2 = G2 + 8 | 0;
          x2 = G2;
          z2 = (c2[2279] | 0) + 1 | 0;
          c2[2279] = z2;
          E2 = b3 + 984 | 0;
          if ((a2[E2 >> 0] | 0) != 0 ? (c2[b3 + 512 >> 2] | 0) != (c2[2278] | 0) : 0)
            w2 = 4;
          else if ((c2[b3 + 516 >> 2] | 0) == (f2 | 0))
            F2 = 0;
          else
            w2 = 4;
          if ((w2 | 0) == 4) {
            c2[b3 + 520 >> 2] = 0;
            c2[b3 + 924 >> 2] = -1;
            c2[b3 + 928 >> 2] = -1;
            g2[b3 + 932 >> 2] = T(-1);
            g2[b3 + 936 >> 2] = T(-1);
            F2 = 1;
          }
          a:
            do
              if (!(c2[b3 + 964 >> 2] | 0)) {
                if (n3) {
                  q2 = b3 + 916 | 0;
                  if (!(Ld(T(g2[q2 >> 2]), d2) | 0)) {
                    w2 = 21;
                    break;
                  }
                  if (!(Ld(T(g2[b3 + 920 >> 2]), e3) | 0)) {
                    w2 = 21;
                    break;
                  }
                  if ((c2[b3 + 924 >> 2] | 0) != (i4 | 0)) {
                    w2 = 21;
                    break;
                  }
                  q2 = (c2[b3 + 928 >> 2] | 0) == (j2 | 0) ? q2 : 0;
                  w2 = 22;
                  break;
                }
                s3 = c2[b3 + 520 >> 2] | 0;
                if (!s3)
                  w2 = 21;
                else {
                  r3 = 0;
                  while (1) {
                    q2 = b3 + 524 + (r3 * 24 | 0) | 0;
                    if (((Ld(T(g2[q2 >> 2]), d2) | 0 ? Ld(T(g2[b3 + 524 + (r3 * 24 | 0) + 4 >> 2]), e3) | 0 : 0) ? (c2[b3 + 524 + (r3 * 24 | 0) + 8 >> 2] | 0) == (i4 | 0) : 0) ? (c2[b3 + 524 + (r3 * 24 | 0) + 12 >> 2] | 0) == (j2 | 0) : 0) {
                      w2 = 22;
                      break a;
                    }
                    r3 = r3 + 1 | 0;
                    if (r3 >>> 0 >= s3 >>> 0) {
                      w2 = 21;
                      break;
                    }
                  }
                }
              } else {
                u3 = T(Ud(b3, 2, k2));
                v2 = T(Ud(b3, 0, k2));
                q2 = b3 + 916 | 0;
                J2 = T(g2[q2 >> 2]);
                I2 = T(g2[b3 + 920 >> 2]);
                H2 = T(g2[b3 + 932 >> 2]);
                if (!(Pd(i4, d2, j2, e3, c2[b3 + 924 >> 2] | 0, J2, c2[b3 + 928 >> 2] | 0, I2, H2, T(g2[b3 + 936 >> 2]), u3, v2, p2) | 0)) {
                  s3 = c2[b3 + 520 >> 2] | 0;
                  if (!s3)
                    w2 = 21;
                  else {
                    r3 = 0;
                    while (1) {
                      q2 = b3 + 524 + (r3 * 24 | 0) | 0;
                      H2 = T(g2[q2 >> 2]);
                      I2 = T(g2[b3 + 524 + (r3 * 24 | 0) + 4 >> 2]);
                      J2 = T(g2[b3 + 524 + (r3 * 24 | 0) + 16 >> 2]);
                      if (Pd(i4, d2, j2, e3, c2[b3 + 524 + (r3 * 24 | 0) + 8 >> 2] | 0, H2, c2[b3 + 524 + (r3 * 24 | 0) + 12 >> 2] | 0, I2, J2, T(g2[b3 + 524 + (r3 * 24 | 0) + 20 >> 2]), u3, v2, p2) | 0) {
                        w2 = 22;
                        break a;
                      }
                      r3 = r3 + 1 | 0;
                      if (r3 >>> 0 >= s3 >>> 0) {
                        w2 = 21;
                        break;
                      }
                    }
                  }
                } else
                  w2 = 22;
              }
            while (0);
          do
            if ((w2 | 0) == 21) {
              if (!(a2[11697] | 0)) {
                q2 = 0;
                w2 = 31;
              } else {
                q2 = 0;
                w2 = 28;
              }
            } else if ((w2 | 0) == 22) {
              r3 = (a2[11697] | 0) != 0;
              if (!((q2 | 0) != 0 & (F2 ^ 1)))
                if (r3) {
                  w2 = 28;
                  break;
                } else {
                  w2 = 31;
                  break;
                }
              t3 = q2 + 16 | 0;
              c2[b3 + 908 >> 2] = c2[t3 >> 2];
              s3 = q2 + 20 | 0;
              c2[b3 + 912 >> 2] = c2[s3 >> 2];
              if (!((a2[11698] | 0) == 0 | r3 ^ 1)) {
                c2[x2 >> 2] = Wd(z2) | 0;
                c2[x2 + 4 >> 2] = z2;
                Vd(b3, 4, 2972, x2);
                r3 = c2[b3 + 972 >> 2] | 0;
                if (r3 | 0)
                  nb[r3 & 127](b3);
                i4 = Xd(i4, n3) | 0;
                j2 = Xd(j2, n3) | 0;
                L2 = +T(g2[t3 >> 2]);
                K2 = +T(g2[s3 >> 2]);
                c2[A2 >> 2] = i4;
                c2[A2 + 4 >> 2] = j2;
                h[A2 + 8 >> 3] = +d2;
                h[A2 + 16 >> 3] = +e3;
                h[A2 + 24 >> 3] = L2;
                h[A2 + 32 >> 3] = K2;
                c2[A2 + 40 >> 2] = o3;
                Vd(b3, 4, 2989, A2);
              }
            }
          while (0);
          if ((w2 | 0) == 28) {
            r3 = Wd(z2) | 0;
            c2[t3 >> 2] = r3;
            c2[t3 + 4 >> 2] = z2;
            c2[t3 + 8 >> 2] = F2 ? 3047 : 11699;
            Vd(b3, 4, 3038, t3);
            r3 = c2[b3 + 972 >> 2] | 0;
            if (r3 | 0)
              nb[r3 & 127](b3);
            A2 = Xd(i4, n3) | 0;
            w2 = Xd(j2, n3) | 0;
            c2[y3 >> 2] = A2;
            c2[y3 + 4 >> 2] = w2;
            h[y3 + 8 >> 3] = +d2;
            h[y3 + 16 >> 3] = +e3;
            c2[y3 + 24 >> 2] = o3;
            Vd(b3, 4, 3049, y3);
            w2 = 31;
          }
          if ((w2 | 0) == 31) {
            Yd(b3, d2, e3, f2, i4, j2, k2, m2, n3, p2);
            if (a2[11697] | 0) {
              r3 = c2[2279] | 0;
              A2 = Wd(r3) | 0;
              c2[B2 >> 2] = A2;
              c2[B2 + 4 >> 2] = r3;
              c2[B2 + 8 >> 2] = F2 ? 3047 : 11699;
              Vd(b3, 4, 3083, B2);
              r3 = c2[b3 + 972 >> 2] | 0;
              if (r3 | 0)
                nb[r3 & 127](b3);
              A2 = Xd(i4, n3) | 0;
              B2 = Xd(j2, n3) | 0;
              K2 = +T(g2[b3 + 908 >> 2]);
              L2 = +T(g2[b3 + 912 >> 2]);
              c2[C2 >> 2] = A2;
              c2[C2 + 4 >> 2] = B2;
              h[C2 + 8 >> 3] = K2;
              h[C2 + 16 >> 3] = L2;
              c2[C2 + 24 >> 2] = o3;
              Vd(b3, 4, 3092, C2);
            }
            c2[b3 + 516 >> 2] = f2;
            if (!q2) {
              r3 = b3 + 520 | 0;
              q2 = c2[r3 >> 2] | 0;
              if ((q2 | 0) == 16) {
                if (a2[11697] | 0)
                  Vd(b3, 4, 3124, D2);
                c2[r3 >> 2] = 0;
                q2 = 0;
              }
              if (n3)
                q2 = b3 + 916 | 0;
              else {
                c2[r3 >> 2] = q2 + 1;
                q2 = b3 + 524 + (q2 * 24 | 0) | 0;
              }
              g2[q2 >> 2] = d2;
              g2[q2 + 4 >> 2] = e3;
              c2[q2 + 8 >> 2] = i4;
              c2[q2 + 12 >> 2] = j2;
              c2[q2 + 16 >> 2] = c2[b3 + 908 >> 2];
              c2[q2 + 20 >> 2] = c2[b3 + 912 >> 2];
              q2 = 0;
            }
          }
          if (n3) {
            c2[b3 + 416 >> 2] = c2[b3 + 908 >> 2];
            c2[b3 + 420 >> 2] = c2[b3 + 912 >> 2];
            a2[b3 + 985 >> 0] = 1;
            a2[E2 >> 0] = 0;
          }
          c2[2279] = (c2[2279] | 0) + -1;
          c2[b3 + 512 >> 2] = c2[2278];
          l2 = G2;
          return F2 | (q2 | 0) == 0 | 0;
        }
        function Ud(a3, b3, c3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          c3 = T(c3);
          var d2 = ib;
          d2 = T(me(a3, b3, c3));
          return T(d2 + T(ne(a3, b3, c3)));
        }
        function Vd(a3, b3, d2, e3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          e3 = e3 | 0;
          var f2 = 0, g3 = 0;
          g3 = l2;
          l2 = l2 + 16 | 0;
          f2 = g3;
          c2[f2 >> 2] = e3;
          if (!a3)
            e3 = 0;
          else
            e3 = c2[a3 + 976 >> 2] | 0;
          ge(e3, a3, b3, d2, f2);
          l2 = g3;
          return;
        }
        function Wd(a3) {
          a3 = a3 | 0;
          return (a3 >>> 0 > 60 ? 3201 : 3201 + (60 - a3) | 0) | 0;
        }
        function Xd(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          var d2 = 0, e3 = 0, f2 = 0;
          f2 = l2;
          l2 = l2 + 32 | 0;
          d2 = f2 + 12 | 0;
          e3 = f2;
          c2[d2 >> 2] = c2[254];
          c2[d2 + 4 >> 2] = c2[255];
          c2[d2 + 8 >> 2] = c2[256];
          c2[e3 >> 2] = c2[257];
          c2[e3 + 4 >> 2] = c2[258];
          c2[e3 + 8 >> 2] = c2[259];
          if ((a3 | 0) > 2)
            a3 = 11699;
          else
            a3 = c2[(b3 ? e3 : d2) + (a3 << 2) >> 2] | 0;
          l2 = f2;
          return a3 | 0;
        }
        function Yd(b3, e3, f2, h2, i4, k2, m2, n3, o3, p2) {
          b3 = b3 | 0;
          e3 = T(e3);
          f2 = T(f2);
          h2 = h2 | 0;
          i4 = i4 | 0;
          k2 = k2 | 0;
          m2 = T(m2);
          n3 = T(n3);
          o3 = o3 | 0;
          p2 = p2 | 0;
          var q2 = 0, r3 = 0, s3 = 0, t3 = 0, u3 = ib, v2 = ib, w2 = ib, x2 = ib, y3 = ib, z2 = ib, A2 = ib, B2 = 0, C2 = 0, D2 = 0, E2 = ib, F2 = ib, G2 = 0, H2 = ib, I2 = 0, J2 = 0, K2 = 0, L2 = 0, M2 = 0, N2 = 0, O2 = 0, P2 = 0, Q2 = 0, R2 = 0, S2 = 0, U2 = 0, V2 = 0, W2 = 0, X2 = 0, Y2 = 0, Z2 = 0, _2 = 0, $2 = ib, aa2 = ib, ba2 = ib, ca2 = ib, da2 = ib, ea2 = 0, fa2 = 0, ga2 = 0, ha2 = 0, ia2 = 0, ja2 = ib, ka2 = ib, la2 = ib, ma2 = ib, na2 = ib, oa2 = ib, pa2 = 0, qa2 = ib, ra2 = ib, sa2 = ib, ta2 = ib, ua2 = ib, va2 = ib, wa2 = 0, xa2 = 0, ya2 = ib, za2 = ib, Aa2 = 0, Ba2 = 0, Ca2 = 0, Da2 = 0, Ea2 = ib, Fa2 = 0, Ga2 = 0, Ha2 = 0, Ia2 = 0, Ja2 = 0, Ka2 = 0, La2 = 0, Ma2 = ib, Na2 = 0, Oa2 = 0;
          La2 = l2;
          l2 = l2 + 16 | 0;
          ea2 = La2 + 12 | 0;
          fa2 = La2 + 8 | 0;
          ga2 = La2 + 4 | 0;
          ha2 = La2;
          ec(b3, (i4 | 0) == 0 | (Sb(e3) | 0) ^ 1, 3326);
          ec(b3, (k2 | 0) == 0 | (Sb(f2) | 0) ^ 1, 3406);
          Ga2 = qe(b3, h2) | 0;
          c2[b3 + 496 >> 2] = Ga2;
          Ja2 = re(2, Ga2) | 0;
          Ka2 = re(0, Ga2) | 0;
          g2[b3 + 440 >> 2] = T(me(b3, Ja2, m2));
          g2[b3 + 444 >> 2] = T(ne(b3, Ja2, m2));
          g2[b3 + 428 >> 2] = T(me(b3, Ka2, m2));
          g2[b3 + 436 >> 2] = T(ne(b3, Ka2, m2));
          g2[b3 + 464 >> 2] = T(se(b3, Ja2));
          g2[b3 + 468 >> 2] = T(te(b3, Ja2));
          g2[b3 + 452 >> 2] = T(se(b3, Ka2));
          g2[b3 + 460 >> 2] = T(te(b3, Ka2));
          g2[b3 + 488 >> 2] = T(ue(b3, Ja2, m2));
          g2[b3 + 492 >> 2] = T(ve(b3, Ja2, m2));
          g2[b3 + 476 >> 2] = T(ue(b3, Ka2, m2));
          g2[b3 + 484 >> 2] = T(ve(b3, Ka2, m2));
          do
            if (!(c2[b3 + 964 >> 2] | 0)) {
              Ha2 = b3 + 948 | 0;
              Ia2 = (c2[b3 + 952 >> 2] | 0) - (c2[Ha2 >> 2] | 0) >> 2;
              if (!Ia2) {
                xe(b3, e3, f2, i4, k2, m2, n3);
                break;
              }
              if (!o3 ? ye(b3, e3, f2, i4, k2, m2, n3) | 0 : 0)
                break;
              lc(b3);
              Y2 = b3 + 508 | 0;
              a2[Y2 >> 0] = 0;
              Ja2 = re(c2[b3 + 4 >> 2] | 0, Ga2) | 0;
              Ka2 = ze(Ja2, Ga2) | 0;
              Fa2 = oe(Ja2) | 0;
              Z2 = c2[b3 + 8 >> 2] | 0;
              Ba2 = b3 + 28 | 0;
              _2 = (c2[Ba2 >> 2] | 0) != 0;
              ua2 = Fa2 ? m2 : n3;
              ya2 = Fa2 ? n3 : m2;
              $2 = T(Ae(b3, Ja2, m2));
              aa2 = T(Be(b3, Ja2, m2));
              u3 = T(Ae(b3, Ka2, m2));
              va2 = T(Ce(b3, Ja2, m2));
              za2 = T(Ce(b3, Ka2, m2));
              D2 = Fa2 ? i4 : k2;
              Aa2 = Fa2 ? k2 : i4;
              Ea2 = Fa2 ? va2 : za2;
              y3 = Fa2 ? za2 : va2;
              ta2 = T(Ud(b3, 2, m2));
              x2 = T(Ud(b3, 0, m2));
              v2 = T(T(be(b3 + 364 | 0, m2)) - Ea2);
              w2 = T(T(be(b3 + 380 | 0, m2)) - Ea2);
              z2 = T(T(be(b3 + 372 | 0, n3)) - y3);
              A2 = T(T(be(b3 + 388 | 0, n3)) - y3);
              ba2 = Fa2 ? v2 : z2;
              ca2 = Fa2 ? w2 : A2;
              ta2 = T(e3 - ta2);
              e3 = T(ta2 - Ea2);
              if (Sb(e3) | 0)
                Ea2 = e3;
              else
                Ea2 = T(cC(T(eC(e3, w2)), v2));
              ra2 = T(f2 - x2);
              e3 = T(ra2 - y3);
              if (Sb(e3) | 0)
                sa2 = e3;
              else
                sa2 = T(cC(T(eC(e3, A2)), z2));
              v2 = Fa2 ? Ea2 : sa2;
              qa2 = Fa2 ? sa2 : Ea2;
              a:
                do
                  if ((D2 | 0) == 1) {
                    h2 = 0;
                    r3 = 0;
                    while (1) {
                      q2 = ac(b3, r3) | 0;
                      if (!h2) {
                        if (T(Ee(q2)) > T(0) ? T(Fe(q2)) > T(0) : 0)
                          h2 = q2;
                        else
                          h2 = 0;
                      } else if (De(q2) | 0) {
                        t3 = 0;
                        break a;
                      }
                      r3 = r3 + 1 | 0;
                      if (r3 >>> 0 >= Ia2 >>> 0) {
                        t3 = h2;
                        break;
                      }
                    }
                  } else
                    t3 = 0;
                while (0);
              B2 = t3 + 500 | 0;
              C2 = t3 + 504 | 0;
              h2 = 0;
              q2 = 0;
              e3 = T(0);
              s3 = 0;
              do {
                r3 = c2[(c2[Ha2 >> 2] | 0) + (s3 << 2) >> 2] | 0;
                if ((c2[r3 + 36 >> 2] | 0) == 1) {
                  Ge(r3);
                  a2[r3 + 985 >> 0] = 1;
                  a2[r3 + 984 >> 0] = 0;
                } else {
                  $d(r3);
                  if (o3)
                    ce(r3, qe(r3, Ga2) | 0, v2, qa2, Ea2);
                  do
                    if ((c2[r3 + 24 >> 2] | 0) != 1) {
                      if ((r3 | 0) == (t3 | 0)) {
                        c2[B2 >> 2] = c2[2278];
                        g2[C2 >> 2] = T(0);
                        break;
                      } else {
                        He(b3, r3, Ea2, i4, sa2, Ea2, sa2, k2, Ga2, p2);
                        break;
                      }
                    } else {
                      if (q2 | 0)
                        c2[q2 + 960 >> 2] = r3;
                      c2[r3 + 960 >> 2] = 0;
                      q2 = r3;
                      h2 = (h2 | 0) == 0 ? r3 : h2;
                    }
                  while (0);
                  oa2 = T(g2[r3 + 504 >> 2]);
                  e3 = T(e3 + T(oa2 + T(Ud(r3, Ja2, Ea2))));
                }
                s3 = s3 + 1 | 0;
              } while ((s3 | 0) != (Ia2 | 0));
              K2 = e3 > v2;
              pa2 = _2 & ((D2 | 0) == 2 & K2) ? 1 : D2;
              I2 = (Aa2 | 0) == 1;
              M2 = I2 & (o3 ^ 1);
              N2 = (pa2 | 0) == 1;
              O2 = (pa2 | 0) == 2;
              P2 = 976 + (Ja2 << 2) | 0;
              Q2 = (Aa2 | 2 | 0) == 2;
              W2 = I2 & (_2 ^ 1);
              R2 = 1040 + (Ka2 << 2) | 0;
              S2 = 1040 + (Ja2 << 2) | 0;
              U2 = 976 + (Ka2 << 2) | 0;
              V2 = (Aa2 | 0) != 1;
              K2 = _2 & ((D2 | 0) != 0 & K2);
              J2 = b3 + 976 | 0;
              I2 = I2 ^ 1;
              e3 = v2;
              G2 = 0;
              L2 = 0;
              oa2 = T(0);
              da2 = T(0);
              while (1) {
                b:
                  do
                    if (G2 >>> 0 < Ia2 >>> 0) {
                      C2 = c2[Ha2 >> 2] | 0;
                      s3 = 0;
                      A2 = T(0);
                      z2 = T(0);
                      w2 = T(0);
                      v2 = T(0);
                      r3 = 0;
                      q2 = 0;
                      t3 = G2;
                      while (1) {
                        B2 = c2[C2 + (t3 << 2) >> 2] | 0;
                        if ((c2[B2 + 36 >> 2] | 0) != 1 ? (c2[B2 + 940 >> 2] = L2, (c2[B2 + 24 >> 2] | 0) != 1) : 0) {
                          x2 = T(Ud(B2, Ja2, Ea2));
                          X2 = c2[P2 >> 2] | 0;
                          f2 = T(be(B2 + 380 + (X2 << 3) | 0, ua2));
                          y3 = T(g2[B2 + 504 >> 2]);
                          f2 = T(eC(f2, y3));
                          f2 = T(cC(T(be(B2 + 364 + (X2 << 3) | 0, ua2)), f2));
                          if (_2 & (s3 | 0) != 0 & T(x2 + T(z2 + f2)) > e3) {
                            k2 = s3;
                            x2 = A2;
                            D2 = t3;
                            break b;
                          }
                          x2 = T(x2 + f2);
                          f2 = T(z2 + x2);
                          x2 = T(A2 + x2);
                          if (De(B2) | 0) {
                            w2 = T(w2 + T(Ee(B2)));
                            v2 = T(v2 - T(y3 * T(Fe(B2))));
                          }
                          if (q2 | 0)
                            c2[q2 + 960 >> 2] = B2;
                          c2[B2 + 960 >> 2] = 0;
                          s3 = s3 + 1 | 0;
                          q2 = B2;
                          r3 = (r3 | 0) == 0 ? B2 : r3;
                        } else {
                          x2 = A2;
                          f2 = z2;
                        }
                        t3 = t3 + 1 | 0;
                        if (t3 >>> 0 < Ia2 >>> 0) {
                          A2 = x2;
                          z2 = f2;
                        } else {
                          k2 = s3;
                          D2 = t3;
                          break;
                        }
                      }
                    } else {
                      k2 = 0;
                      x2 = T(0);
                      w2 = T(0);
                      v2 = T(0);
                      r3 = 0;
                      D2 = G2;
                    }
                  while (0);
                X2 = w2 > T(0) & w2 < T(1);
                E2 = X2 ? T(1) : w2;
                X2 = v2 > T(0) & v2 < T(1);
                A2 = X2 ? T(1) : v2;
                do
                  if (!N2) {
                    if (!(x2 < ba2 & ((Sb(ba2) | 0) ^ 1))) {
                      if (!(x2 > ca2 & ((Sb(ca2) | 0) ^ 1))) {
                        if (!(a2[(c2[J2 >> 2] | 0) + 3 >> 0] | 0)) {
                          if (!(E2 == T(0)) ? !(T(Ee(b3)) == T(0)) : 0) {
                            X2 = 53;
                            break;
                          }
                          e3 = x2;
                          X2 = 53;
                        } else
                          X2 = 51;
                      } else {
                        e3 = ca2;
                        X2 = 51;
                      }
                    } else {
                      e3 = ba2;
                      X2 = 51;
                    }
                  } else
                    X2 = 51;
                while (0);
                if ((X2 | 0) == 51) {
                  X2 = 0;
                  if (Sb(e3) | 0)
                    X2 = 53;
                  else {
                    F2 = T(e3 - x2);
                    H2 = e3;
                  }
                }
                if ((X2 | 0) == 53) {
                  X2 = 0;
                  if (x2 < T(0)) {
                    F2 = T(-x2);
                    H2 = e3;
                  } else {
                    F2 = T(0);
                    H2 = e3;
                  }
                }
                if (!M2 ? (ia2 = (r3 | 0) == 0, !ia2) : 0) {
                  s3 = c2[P2 >> 2] | 0;
                  t3 = F2 < T(0);
                  y3 = T(F2 / A2);
                  B2 = F2 > T(0);
                  z2 = T(F2 / E2);
                  w2 = T(0);
                  x2 = T(0);
                  e3 = T(0);
                  q2 = r3;
                  do {
                    f2 = T(be(q2 + 380 + (s3 << 3) | 0, ua2));
                    v2 = T(be(q2 + 364 + (s3 << 3) | 0, ua2));
                    v2 = T(eC(f2, T(cC(v2, T(g2[q2 + 504 >> 2])))));
                    if (t3) {
                      f2 = T(v2 * T(Fe(q2)));
                      if (f2 != T(-0) ? (Ma2 = T(v2 - T(y3 * f2)), ja2 = T(Ie(q2, Ja2, Ma2, H2, Ea2)), Ma2 != ja2) : 0) {
                        w2 = T(w2 - T(ja2 - v2));
                        e3 = T(e3 + f2);
                      }
                    } else if ((B2 ? (ka2 = T(Ee(q2)), ka2 != T(0)) : 0) ? (Ma2 = T(v2 + T(z2 * ka2)), la2 = T(Ie(q2, Ja2, Ma2, H2, Ea2)), Ma2 != la2) : 0) {
                      w2 = T(w2 - T(la2 - v2));
                      x2 = T(x2 - ka2);
                    }
                    q2 = c2[q2 + 960 >> 2] | 0;
                  } while ((q2 | 0) != 0);
                  e3 = T(A2 + e3);
                  v2 = T(F2 + w2);
                  if (!ia2) {
                    y3 = T(E2 + x2);
                    t3 = c2[P2 >> 2] | 0;
                    B2 = v2 < T(0);
                    C2 = e3 == T(0);
                    z2 = T(v2 / e3);
                    s3 = v2 > T(0);
                    y3 = T(v2 / y3);
                    e3 = T(0);
                    do {
                      Ma2 = T(be(r3 + 380 + (t3 << 3) | 0, ua2));
                      w2 = T(be(r3 + 364 + (t3 << 3) | 0, ua2));
                      w2 = T(eC(Ma2, T(cC(w2, T(g2[r3 + 504 >> 2])))));
                      if (B2) {
                        Ma2 = T(w2 * T(Fe(r3)));
                        v2 = T(-Ma2);
                        if (Ma2 != T(-0)) {
                          Ma2 = T(z2 * v2);
                          v2 = T(Ie(r3, Ja2, T(w2 + (C2 ? v2 : Ma2)), H2, Ea2));
                        } else
                          v2 = w2;
                      } else if (s3 ? (ma2 = T(Ee(r3)), ma2 != T(0)) : 0)
                        v2 = T(Ie(r3, Ja2, T(w2 + T(y3 * ma2)), H2, Ea2));
                      else
                        v2 = w2;
                      e3 = T(e3 - T(v2 - w2));
                      x2 = T(Ud(r3, Ja2, Ea2));
                      f2 = T(Ud(r3, Ka2, Ea2));
                      v2 = T(v2 + x2);
                      g2[fa2 >> 2] = v2;
                      c2[ha2 >> 2] = 1;
                      w2 = T(g2[r3 + 396 >> 2]);
                      c:
                        do
                          if (Sb(w2) | 0) {
                            q2 = Sb(qa2) | 0;
                            do
                              if (!q2) {
                                if (K2 | (ae(r3, Ka2, qa2) | 0 | I2))
                                  break;
                                if ((Je(b3, r3) | 0) != 4)
                                  break;
                                if ((c2[(Ke(r3, Ka2) | 0) + 4 >> 2] | 0) == 3)
                                  break;
                                if ((c2[(Le(r3, Ka2) | 0) + 4 >> 2] | 0) == 3)
                                  break;
                                g2[ea2 >> 2] = qa2;
                                c2[ga2 >> 2] = 1;
                                break c;
                              }
                            while (0);
                            if (ae(r3, Ka2, qa2) | 0) {
                              q2 = c2[r3 + 992 + (c2[U2 >> 2] << 2) >> 2] | 0;
                              Ma2 = T(f2 + T(be(q2, qa2)));
                              g2[ea2 >> 2] = Ma2;
                              q2 = V2 & (c2[q2 + 4 >> 2] | 0) == 2;
                              c2[ga2 >> 2] = ((Sb(Ma2) | 0 | q2) ^ 1) & 1;
                              break;
                            } else {
                              g2[ea2 >> 2] = qa2;
                              c2[ga2 >> 2] = q2 ? 0 : 2;
                              break;
                            }
                          } else {
                            Ma2 = T(v2 - x2);
                            E2 = T(Ma2 / w2);
                            Ma2 = T(w2 * Ma2);
                            c2[ga2 >> 2] = 1;
                            g2[ea2 >> 2] = T(f2 + (Fa2 ? E2 : Ma2));
                          }
                        while (0);
                      Me(r3, Ja2, H2, Ea2, ha2, fa2);
                      Me(r3, Ka2, qa2, Ea2, ga2, ea2);
                      do
                        if (!(ae(r3, Ka2, qa2) | 0) ? (Je(b3, r3) | 0) == 4 : 0) {
                          if ((c2[(Ke(r3, Ka2) | 0) + 4 >> 2] | 0) == 3) {
                            q2 = 0;
                            break;
                          }
                          q2 = (c2[(Le(r3, Ka2) | 0) + 4 >> 2] | 0) != 3;
                        } else
                          q2 = 0;
                      while (0);
                      Ma2 = T(g2[fa2 >> 2]);
                      E2 = T(g2[ea2 >> 2]);
                      Na2 = c2[ha2 >> 2] | 0;
                      Oa2 = c2[ga2 >> 2] | 0;
                      Td(r3, Fa2 ? Ma2 : E2, Fa2 ? E2 : Ma2, Ga2, Fa2 ? Na2 : Oa2, Fa2 ? Oa2 : Na2, Ea2, sa2, o3 & (q2 ^ 1), 3488, p2) | 0;
                      a2[Y2 >> 0] = a2[Y2 >> 0] | a2[r3 + 508 >> 0];
                      r3 = c2[r3 + 960 >> 2] | 0;
                    } while ((r3 | 0) != 0);
                  } else
                    e3 = T(0);
                } else
                  e3 = T(0);
                e3 = T(F2 + e3);
                Oa2 = e3 < T(0) & 1;
                a2[Y2 >> 0] = Oa2 | d[Y2 >> 0];
                if (O2 & e3 > T(0)) {
                  q2 = c2[P2 >> 2] | 0;
                  if ((c2[b3 + 364 + (q2 << 3) + 4 >> 2] | 0) != 0 ? (na2 = T(be(b3 + 364 + (q2 << 3) | 0, ua2)), na2 >= T(0)) : 0)
                    v2 = T(cC(T(0), T(na2 - T(H2 - e3))));
                  else
                    v2 = T(0);
                } else
                  v2 = e3;
                B2 = G2 >>> 0 < D2 >>> 0;
                if (B2) {
                  t3 = c2[Ha2 >> 2] | 0;
                  s3 = G2;
                  q2 = 0;
                  do {
                    r3 = c2[t3 + (s3 << 2) >> 2] | 0;
                    if (!(c2[r3 + 24 >> 2] | 0)) {
                      q2 = ((c2[(Ke(r3, Ja2) | 0) + 4 >> 2] | 0) == 3 & 1) + q2 | 0;
                      q2 = q2 + ((c2[(Le(r3, Ja2) | 0) + 4 >> 2] | 0) == 3 & 1) | 0;
                    }
                    s3 = s3 + 1 | 0;
                  } while ((s3 | 0) != (D2 | 0));
                  if (q2) {
                    x2 = T(0);
                    f2 = T(0);
                  } else
                    X2 = 101;
                } else
                  X2 = 101;
                d:
                  do
                    if ((X2 | 0) == 101) {
                      X2 = 0;
                      switch (Z2 | 0) {
                        case 1: {
                          q2 = 0;
                          x2 = T(v2 * T(0.5));
                          f2 = T(0);
                          break d;
                        }
                        case 2: {
                          q2 = 0;
                          x2 = v2;
                          f2 = T(0);
                          break d;
                        }
                        case 3: {
                          if (k2 >>> 0 <= 1) {
                            q2 = 0;
                            x2 = T(0);
                            f2 = T(0);
                            break d;
                          }
                          f2 = T((k2 + -1 | 0) >>> 0);
                          q2 = 0;
                          x2 = T(0);
                          f2 = T(T(cC(v2, T(0))) / f2);
                          break d;
                        }
                        case 5: {
                          f2 = T(v2 / T((k2 + 1 | 0) >>> 0));
                          q2 = 0;
                          x2 = f2;
                          break d;
                        }
                        case 4: {
                          f2 = T(v2 / T(k2 >>> 0));
                          q2 = 0;
                          x2 = T(f2 * T(0.5));
                          break d;
                        }
                        default: {
                          q2 = 0;
                          x2 = T(0);
                          f2 = T(0);
                          break d;
                        }
                      }
                    }
                  while (0);
                e3 = T($2 + x2);
                if (B2) {
                  w2 = T(v2 / T(q2 | 0));
                  s3 = c2[Ha2 >> 2] | 0;
                  r3 = G2;
                  v2 = T(0);
                  do {
                    q2 = c2[s3 + (r3 << 2) >> 2] | 0;
                    e:
                      do
                        if ((c2[q2 + 36 >> 2] | 0) != 1) {
                          switch (c2[q2 + 24 >> 2] | 0) {
                            case 1: {
                              if (Ne(q2, Ja2) | 0) {
                                if (!o3)
                                  break e;
                                Ma2 = T(Oe(q2, Ja2, H2));
                                Ma2 = T(Ma2 + T(se(b3, Ja2)));
                                Ma2 = T(Ma2 + T(me(q2, Ja2, Ea2)));
                                g2[q2 + 400 + (c2[S2 >> 2] << 2) >> 2] = Ma2;
                                break e;
                              }
                              break;
                            }
                            case 0: {
                              Oa2 = (c2[(Ke(q2, Ja2) | 0) + 4 >> 2] | 0) == 3;
                              Ma2 = T(w2 + e3);
                              e3 = Oa2 ? Ma2 : e3;
                              if (o3) {
                                Oa2 = q2 + 400 + (c2[S2 >> 2] << 2) | 0;
                                g2[Oa2 >> 2] = T(e3 + T(g2[Oa2 >> 2]));
                              }
                              Oa2 = (c2[(Le(q2, Ja2) | 0) + 4 >> 2] | 0) == 3;
                              Ma2 = T(w2 + e3);
                              e3 = Oa2 ? Ma2 : e3;
                              if (M2) {
                                Ma2 = T(f2 + T(Ud(q2, Ja2, Ea2)));
                                v2 = qa2;
                                e3 = T(e3 + T(Ma2 + T(g2[q2 + 504 >> 2])));
                                break e;
                              } else {
                                e3 = T(e3 + T(f2 + T(Pe(q2, Ja2, Ea2))));
                                v2 = T(cC(v2, T(Pe(q2, Ka2, Ea2))));
                                break e;
                              }
                            }
                            default: {
                            }
                          }
                          if (o3) {
                            Ma2 = T(x2 + T(se(b3, Ja2)));
                            Oa2 = q2 + 400 + (c2[S2 >> 2] << 2) | 0;
                            g2[Oa2 >> 2] = T(Ma2 + T(g2[Oa2 >> 2]));
                          }
                        }
                      while (0);
                    r3 = r3 + 1 | 0;
                  } while ((r3 | 0) != (D2 | 0));
                } else
                  v2 = T(0);
                f2 = T(aa2 + e3);
                if (Q2)
                  x2 = T(T(Ie(b3, Ka2, T(za2 + v2), ya2, m2)) - za2);
                else
                  x2 = qa2;
                w2 = T(T(Ie(b3, Ka2, T(za2 + (W2 ? qa2 : v2)), ya2, m2)) - za2);
                if (B2 & o3) {
                  r3 = G2;
                  do {
                    s3 = c2[(c2[Ha2 >> 2] | 0) + (r3 << 2) >> 2] | 0;
                    do
                      if ((c2[s3 + 36 >> 2] | 0) != 1) {
                        if ((c2[s3 + 24 >> 2] | 0) == 1) {
                          if (Ne(s3, Ka2) | 0) {
                            Ma2 = T(Oe(s3, Ka2, qa2));
                            Ma2 = T(Ma2 + T(se(b3, Ka2)));
                            Ma2 = T(Ma2 + T(me(s3, Ka2, Ea2)));
                            q2 = c2[R2 >> 2] | 0;
                            g2[s3 + 400 + (q2 << 2) >> 2] = Ma2;
                            if (!(Sb(Ma2) | 0))
                              break;
                          } else
                            q2 = c2[R2 >> 2] | 0;
                          Ma2 = T(se(b3, Ka2));
                          g2[s3 + 400 + (q2 << 2) >> 2] = T(Ma2 + T(me(s3, Ka2, Ea2)));
                          break;
                        }
                        q2 = Je(b3, s3) | 0;
                        do
                          if ((q2 | 0) == 4) {
                            if ((c2[(Ke(s3, Ka2) | 0) + 4 >> 2] | 0) == 3) {
                              X2 = 139;
                              break;
                            }
                            if ((c2[(Le(s3, Ka2) | 0) + 4 >> 2] | 0) == 3) {
                              X2 = 139;
                              break;
                            }
                            if (ae(s3, Ka2, qa2) | 0) {
                              e3 = u3;
                              break;
                            }
                            Na2 = c2[s3 + 908 + (c2[P2 >> 2] << 2) >> 2] | 0;
                            c2[ea2 >> 2] = Na2;
                            e3 = T(g2[s3 + 396 >> 2]);
                            Oa2 = Sb(e3) | 0;
                            v2 = (c2[j >> 2] = Na2, T(g2[j >> 2]));
                            if (Oa2)
                              e3 = w2;
                            else {
                              F2 = T(Ud(s3, Ka2, Ea2));
                              Ma2 = T(v2 / e3);
                              e3 = T(e3 * v2);
                              e3 = T(F2 + (Fa2 ? Ma2 : e3));
                            }
                            g2[fa2 >> 2] = e3;
                            g2[ea2 >> 2] = T(T(Ud(s3, Ja2, Ea2)) + v2);
                            c2[ga2 >> 2] = 1;
                            c2[ha2 >> 2] = 1;
                            Me(s3, Ja2, H2, Ea2, ga2, ea2);
                            Me(s3, Ka2, qa2, Ea2, ha2, fa2);
                            e3 = T(g2[ea2 >> 2]);
                            F2 = T(g2[fa2 >> 2]);
                            Ma2 = Fa2 ? e3 : F2;
                            e3 = Fa2 ? F2 : e3;
                            Oa2 = ((Sb(Ma2) | 0) ^ 1) & 1;
                            Td(s3, Ma2, e3, Ga2, Oa2, ((Sb(e3) | 0) ^ 1) & 1, Ea2, sa2, 1, 3493, p2) | 0;
                            e3 = u3;
                          } else
                            X2 = 139;
                        while (0);
                        f:
                          do
                            if ((X2 | 0) == 139) {
                              X2 = 0;
                              e3 = T(x2 - T(Pe(s3, Ka2, Ea2)));
                              do
                                if ((c2[(Ke(s3, Ka2) | 0) + 4 >> 2] | 0) == 3) {
                                  if ((c2[(Le(s3, Ka2) | 0) + 4 >> 2] | 0) != 3)
                                    break;
                                  e3 = T(u3 + T(cC(T(0), T(e3 * T(0.5)))));
                                  break f;
                                }
                              while (0);
                              if ((c2[(Le(s3, Ka2) | 0) + 4 >> 2] | 0) == 3) {
                                e3 = u3;
                                break;
                              }
                              if ((c2[(Ke(s3, Ka2) | 0) + 4 >> 2] | 0) == 3) {
                                e3 = T(u3 + T(cC(T(0), e3)));
                                break;
                              }
                              switch (q2 | 0) {
                                case 1: {
                                  e3 = u3;
                                  break f;
                                }
                                case 2: {
                                  e3 = T(u3 + T(e3 * T(0.5)));
                                  break f;
                                }
                                default: {
                                  e3 = T(u3 + e3);
                                  break f;
                                }
                              }
                            }
                          while (0);
                        Ma2 = T(oa2 + e3);
                        Oa2 = s3 + 400 + (c2[R2 >> 2] << 2) | 0;
                        g2[Oa2 >> 2] = T(Ma2 + T(g2[Oa2 >> 2]));
                      }
                    while (0);
                    r3 = r3 + 1 | 0;
                  } while ((r3 | 0) != (D2 | 0));
                }
                oa2 = T(oa2 + w2);
                da2 = T(cC(da2, f2));
                k2 = L2 + 1 | 0;
                if (D2 >>> 0 >= Ia2 >>> 0)
                  break;
                else {
                  e3 = H2;
                  G2 = D2;
                  L2 = k2;
                }
              }
              do
                if (o3) {
                  q2 = k2 >>> 0 > 1;
                  if (!q2 ? !(Qe(b3) | 0) : 0)
                    break;
                  if (!(Sb(qa2) | 0)) {
                    e3 = T(qa2 - oa2);
                    g:
                      do
                        switch (c2[b3 + 12 >> 2] | 0) {
                          case 3: {
                            u3 = T(u3 + e3);
                            z2 = T(0);
                            break;
                          }
                          case 2: {
                            u3 = T(u3 + T(e3 * T(0.5)));
                            z2 = T(0);
                            break;
                          }
                          case 4: {
                            if (qa2 > oa2)
                              z2 = T(e3 / T(k2 >>> 0));
                            else
                              z2 = T(0);
                            break;
                          }
                          case 7:
                            if (qa2 > oa2) {
                              u3 = T(u3 + T(e3 / T(k2 << 1 >>> 0)));
                              z2 = T(e3 / T(k2 >>> 0));
                              z2 = q2 ? z2 : T(0);
                              break g;
                            } else {
                              u3 = T(u3 + T(e3 * T(0.5)));
                              z2 = T(0);
                              break g;
                            }
                          case 6: {
                            z2 = T(e3 / T(L2 >>> 0));
                            z2 = qa2 > oa2 & q2 ? z2 : T(0);
                            break;
                          }
                          default:
                            z2 = T(0);
                        }
                      while (0);
                    if (k2 | 0) {
                      B2 = 1040 + (Ka2 << 2) | 0;
                      C2 = 976 + (Ka2 << 2) | 0;
                      t3 = 0;
                      r3 = 0;
                      while (1) {
                        h:
                          do
                            if (r3 >>> 0 < Ia2 >>> 0) {
                              v2 = T(0);
                              w2 = T(0);
                              e3 = T(0);
                              s3 = r3;
                              while (1) {
                                q2 = c2[(c2[Ha2 >> 2] | 0) + (s3 << 2) >> 2] | 0;
                                do
                                  if ((c2[q2 + 36 >> 2] | 0) != 1 ? (c2[q2 + 24 >> 2] | 0) == 0 : 0) {
                                    if ((c2[q2 + 940 >> 2] | 0) != (t3 | 0))
                                      break h;
                                    if (Re(q2, Ka2) | 0) {
                                      Ma2 = T(g2[q2 + 908 + (c2[C2 >> 2] << 2) >> 2]);
                                      e3 = T(cC(e3, T(Ma2 + T(Ud(q2, Ka2, Ea2)))));
                                    }
                                    if ((Je(b3, q2) | 0) != 5)
                                      break;
                                    na2 = T(Se(q2));
                                    na2 = T(na2 + T(me(q2, 0, Ea2)));
                                    Ma2 = T(g2[q2 + 912 >> 2]);
                                    Ma2 = T(T(Ma2 + T(Ud(q2, 0, Ea2))) - na2);
                                    na2 = T(cC(w2, na2));
                                    Ma2 = T(cC(v2, Ma2));
                                    v2 = Ma2;
                                    w2 = na2;
                                    e3 = T(cC(e3, T(na2 + Ma2)));
                                  }
                                while (0);
                                q2 = s3 + 1 | 0;
                                if (q2 >>> 0 < Ia2 >>> 0)
                                  s3 = q2;
                                else {
                                  s3 = q2;
                                  break;
                                }
                              }
                            } else {
                              w2 = T(0);
                              e3 = T(0);
                              s3 = r3;
                            }
                          while (0);
                        y3 = T(z2 + e3);
                        f2 = u3;
                        u3 = T(u3 + y3);
                        if (r3 >>> 0 < s3 >>> 0) {
                          x2 = T(f2 + w2);
                          q2 = r3;
                          do {
                            r3 = c2[(c2[Ha2 >> 2] | 0) + (q2 << 2) >> 2] | 0;
                            i:
                              do
                                if ((c2[r3 + 36 >> 2] | 0) != 1 ? (c2[r3 + 24 >> 2] | 0) == 0 : 0)
                                  switch (Je(b3, r3) | 0) {
                                    case 1: {
                                      Ma2 = T(f2 + T(me(r3, Ka2, Ea2)));
                                      g2[r3 + 400 + (c2[B2 >> 2] << 2) >> 2] = Ma2;
                                      break i;
                                    }
                                    case 3: {
                                      Ma2 = T(T(u3 - T(ne(r3, Ka2, Ea2))) - T(g2[r3 + 908 + (c2[C2 >> 2] << 2) >> 2]));
                                      g2[r3 + 400 + (c2[B2 >> 2] << 2) >> 2] = Ma2;
                                      break i;
                                    }
                                    case 2: {
                                      Ma2 = T(f2 + T(T(y3 - T(g2[r3 + 908 + (c2[C2 >> 2] << 2) >> 2])) * T(0.5)));
                                      g2[r3 + 400 + (c2[B2 >> 2] << 2) >> 2] = Ma2;
                                      break i;
                                    }
                                    case 4: {
                                      Ma2 = T(f2 + T(me(r3, Ka2, Ea2)));
                                      g2[r3 + 400 + (c2[B2 >> 2] << 2) >> 2] = Ma2;
                                      if (ae(r3, Ka2, qa2) | 0)
                                        break i;
                                      if (Fa2) {
                                        v2 = T(g2[r3 + 908 >> 2]);
                                        e3 = T(v2 + T(Ud(r3, Ja2, Ea2)));
                                        w2 = y3;
                                      } else {
                                        w2 = T(g2[r3 + 912 >> 2]);
                                        w2 = T(w2 + T(Ud(r3, Ka2, Ea2)));
                                        e3 = y3;
                                        v2 = T(g2[r3 + 908 >> 2]);
                                      }
                                      if (Ld(e3, v2) | 0 ? Ld(w2, T(g2[r3 + 912 >> 2])) | 0 : 0)
                                        break i;
                                      Td(r3, e3, w2, Ga2, 1, 1, Ea2, sa2, 1, 3501, p2) | 0;
                                      break i;
                                    }
                                    case 5: {
                                      g2[r3 + 404 >> 2] = T(T(x2 - T(Se(r3))) + T(Oe(r3, 0, qa2)));
                                      break i;
                                    }
                                    default:
                                      break i;
                                  }
                              while (0);
                            q2 = q2 + 1 | 0;
                          } while ((q2 | 0) != (s3 | 0));
                        }
                        t3 = t3 + 1 | 0;
                        if ((t3 | 0) == (k2 | 0))
                          break;
                        else
                          r3 = s3;
                      }
                    }
                  }
                }
              while (0);
              g2[b3 + 908 >> 2] = T(Ie(b3, 2, ta2, m2, m2));
              g2[b3 + 912 >> 2] = T(Ie(b3, 0, ra2, n3, m2));
              if ((pa2 | 0) != 0 ? (wa2 = c2[b3 + 32 >> 2] | 0, xa2 = (pa2 | 0) == 2, !(xa2 & (wa2 | 0) != 2)) : 0) {
                if (xa2 & (wa2 | 0) == 2) {
                  e3 = T(va2 + H2);
                  e3 = T(cC(T(eC(e3, T(Te(b3, Ja2, da2, ua2)))), va2));
                  X2 = 198;
                }
              } else {
                e3 = T(Ie(b3, Ja2, da2, ua2, m2));
                X2 = 198;
              }
              if ((X2 | 0) == 198)
                g2[b3 + 908 + (c2[976 + (Ja2 << 2) >> 2] << 2) >> 2] = e3;
              if ((Aa2 | 0) != 0 ? (Ca2 = c2[b3 + 32 >> 2] | 0, Da2 = (Aa2 | 0) == 2, !(Da2 & (Ca2 | 0) != 2)) : 0) {
                if (Da2 & (Ca2 | 0) == 2) {
                  e3 = T(za2 + qa2);
                  e3 = T(cC(T(eC(e3, T(Te(b3, Ka2, T(za2 + oa2), ya2)))), za2));
                  X2 = 204;
                }
              } else {
                e3 = T(Ie(b3, Ka2, T(za2 + oa2), ya2, m2));
                X2 = 204;
              }
              if ((X2 | 0) == 204)
                g2[b3 + 908 + (c2[976 + (Ka2 << 2) >> 2] << 2) >> 2] = e3;
              if (o3) {
                if ((c2[Ba2 >> 2] | 0) == 2) {
                  r3 = 976 + (Ka2 << 2) | 0;
                  s3 = 1040 + (Ka2 << 2) | 0;
                  q2 = 0;
                  do {
                    t3 = ac(b3, q2) | 0;
                    if (!(c2[t3 + 24 >> 2] | 0)) {
                      Na2 = c2[r3 >> 2] | 0;
                      Ma2 = T(g2[b3 + 908 + (Na2 << 2) >> 2]);
                      Oa2 = t3 + 400 + (c2[s3 >> 2] << 2) | 0;
                      Ma2 = T(Ma2 - T(g2[Oa2 >> 2]));
                      g2[Oa2 >> 2] = T(Ma2 - T(g2[t3 + 908 + (Na2 << 2) >> 2]));
                    }
                    q2 = q2 + 1 | 0;
                  } while ((q2 | 0) != (Ia2 | 0));
                }
                if (h2 | 0) {
                  q2 = Fa2 ? pa2 : i4;
                  do {
                    Ue(b3, h2, Ea2, q2, sa2, Ga2, p2);
                    h2 = c2[h2 + 960 >> 2] | 0;
                  } while ((h2 | 0) != 0);
                }
                q2 = (Ja2 | 2 | 0) == 3;
                r3 = (Ka2 | 2 | 0) == 3;
                if (q2 | r3) {
                  h2 = 0;
                  do {
                    s3 = c2[(c2[Ha2 >> 2] | 0) + (h2 << 2) >> 2] | 0;
                    if ((c2[s3 + 36 >> 2] | 0) != 1) {
                      if (q2)
                        Ve(b3, s3, Ja2);
                      if (r3)
                        Ve(b3, s3, Ka2);
                    }
                    h2 = h2 + 1 | 0;
                  } while ((h2 | 0) != (Ia2 | 0));
                }
              }
            } else
              we(b3, e3, f2, i4, k2, m2, n3);
          while (0);
          l2 = La2;
          return;
        }
        function Zd(a3, b3) {
          a3 = a3 | 0;
          b3 = T(b3);
          var c3 = 0;
          Vb(a3, b3 >= T(0), 3147);
          c3 = b3 == T(0);
          g2[a3 + 4 >> 2] = c3 ? T(0) : b3;
          return;
        }
        function _d(b3, d2, e3, f2) {
          b3 = b3 | 0;
          d2 = T(d2);
          e3 = T(e3);
          f2 = f2 | 0;
          var h2 = ib, i4 = ib, j2 = 0, k2 = 0, l3 = 0;
          c2[2278] = (c2[2278] | 0) + 1;
          $d(b3);
          if (!(ae(b3, 2, d2) | 0)) {
            h2 = T(be(b3 + 380 | 0, d2));
            if (!(h2 >= T(0))) {
              l3 = ((Sb(d2) | 0) ^ 1) & 1;
              h2 = d2;
            } else
              l3 = 2;
          } else {
            h2 = T(be(c2[b3 + 992 >> 2] | 0, d2));
            l3 = 1;
            h2 = T(h2 + T(Ud(b3, 2, d2)));
          }
          if (!(ae(b3, 0, e3) | 0)) {
            i4 = T(be(b3 + 388 | 0, e3));
            if (!(i4 >= T(0))) {
              k2 = ((Sb(e3) | 0) ^ 1) & 1;
              i4 = e3;
            } else
              k2 = 2;
          } else {
            i4 = T(be(c2[b3 + 996 >> 2] | 0, e3));
            k2 = 1;
            i4 = T(i4 + T(Ud(b3, 0, d2)));
          }
          j2 = b3 + 976 | 0;
          if (Td(b3, h2, i4, f2, l3, k2, d2, e3, 1, 3189, c2[j2 >> 2] | 0) | 0 ? (ce(b3, c2[b3 + 496 >> 2] | 0, d2, e3, d2), de(b3, T(g2[(c2[j2 >> 2] | 0) + 4 >> 2]), T(0), T(0)), a2[11696] | 0) : 0)
            Md(b3, 7);
          return;
        }
        function $d(a3) {
          a3 = a3 | 0;
          var b3 = 0, d2 = 0, e3 = 0, f2 = 0, g3 = 0, h2 = 0, i4 = 0, j2 = 0, k2 = 0, m2 = 0;
          i4 = l2;
          l2 = l2 + 32 | 0;
          h2 = i4 + 24 | 0;
          g3 = i4 + 16 | 0;
          e3 = i4 + 8 | 0;
          f2 = i4;
          d2 = 0;
          do {
            b3 = a3 + 380 + (d2 << 3) | 0;
            if (!((c2[a3 + 380 + (d2 << 3) + 4 >> 2] | 0) != 0 ? (j2 = b3, k2 = c2[j2 + 4 >> 2] | 0, m2 = e3, c2[m2 >> 2] = c2[j2 >> 2], c2[m2 + 4 >> 2] = k2, m2 = a3 + 364 + (d2 << 3) | 0, k2 = c2[m2 + 4 >> 2] | 0, j2 = f2, c2[j2 >> 2] = c2[m2 >> 2], c2[j2 + 4 >> 2] = k2, c2[g3 >> 2] = c2[e3 >> 2], c2[g3 + 4 >> 2] = c2[e3 + 4 >> 2], c2[h2 >> 2] = c2[f2 >> 2], c2[h2 + 4 >> 2] = c2[f2 + 4 >> 2], Kd(g3, h2) | 0) : 0))
              b3 = a3 + 348 + (d2 << 3) | 0;
            c2[a3 + 992 + (d2 << 2) >> 2] = b3;
            d2 = d2 + 1 | 0;
          } while ((d2 | 0) != 2);
          l2 = i4;
          return;
        }
        function ae(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = T(d2);
          var e3 = 0;
          a3 = c2[a3 + 992 + (c2[976 + (b3 << 2) >> 2] << 2) >> 2] | 0;
          switch (c2[a3 + 4 >> 2] | 0) {
            case 0:
            case 3: {
              a3 = 0;
              break;
            }
            case 1: {
              if (T(g2[a3 >> 2]) < T(0))
                a3 = 0;
              else
                e3 = 5;
              break;
            }
            case 2: {
              if (T(g2[a3 >> 2]) < T(0))
                a3 = 0;
              else
                a3 = (Sb(d2) | 0) ^ 1;
              break;
            }
            default:
              e3 = 5;
          }
          if ((e3 | 0) == 5)
            a3 = 1;
          return a3 | 0;
        }
        function be(a3, b3) {
          a3 = a3 | 0;
          b3 = T(b3);
          switch (c2[a3 + 4 >> 2] | 0) {
            case 2: {
              b3 = T(T(T(g2[a3 >> 2]) * b3) / T(100));
              break;
            }
            case 1: {
              b3 = T(g2[a3 >> 2]);
              break;
            }
            default:
              b3 = T(t2);
          }
          return T(b3);
        }
        function ce(a3, b3, d2, e3, f2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = T(d2);
          e3 = T(e3);
          f2 = T(f2);
          var h2 = 0, i4 = ib;
          b3 = c2[a3 + 944 >> 2] | 0 ? b3 : 1;
          h2 = re(c2[a3 + 4 >> 2] | 0, b3) | 0;
          b3 = ze(h2, b3) | 0;
          d2 = T($e(a3, h2, d2));
          e3 = T($e(a3, b3, e3));
          i4 = T(d2 + T(me(a3, h2, f2)));
          g2[a3 + 400 + (c2[1040 + (h2 << 2) >> 2] << 2) >> 2] = i4;
          d2 = T(d2 + T(ne(a3, h2, f2)));
          g2[a3 + 400 + (c2[1e3 + (h2 << 2) >> 2] << 2) >> 2] = d2;
          d2 = T(e3 + T(me(a3, b3, f2)));
          g2[a3 + 400 + (c2[1040 + (b3 << 2) >> 2] << 2) >> 2] = d2;
          f2 = T(e3 + T(ne(a3, b3, f2)));
          g2[a3 + 400 + (c2[1e3 + (b3 << 2) >> 2] << 2) >> 2] = f2;
          return;
        }
        function de(a3, b3, d2, e3) {
          a3 = a3 | 0;
          b3 = T(b3);
          d2 = T(d2);
          e3 = T(e3);
          var f2 = 0, h2 = 0, i4 = ib, j2 = ib, k2 = 0, l3 = 0, m2 = ib, n3 = 0, o3 = ib, p2 = ib, q2 = ib, r3 = ib;
          if (!(b3 == T(0))) {
            f2 = a3 + 400 | 0;
            r3 = T(g2[f2 >> 2]);
            h2 = a3 + 404 | 0;
            q2 = T(g2[h2 >> 2]);
            n3 = a3 + 416 | 0;
            p2 = T(g2[n3 >> 2]);
            l3 = a3 + 420 | 0;
            i4 = T(g2[l3 >> 2]);
            o3 = T(r3 + d2);
            m2 = T(q2 + e3);
            e3 = T(o3 + p2);
            j2 = T(m2 + i4);
            k2 = (c2[a3 + 988 >> 2] | 0) == 1;
            g2[f2 >> 2] = T(Od(r3, b3, 0, k2));
            g2[h2 >> 2] = T(Od(q2, b3, 0, k2));
            d2 = T(gC(T(p2 * b3), T(1)));
            if (Ld(d2, T(0)) | 0)
              h2 = 0;
            else
              h2 = (Ld(d2, T(1)) | 0) ^ 1;
            d2 = T(gC(T(i4 * b3), T(1)));
            if (Ld(d2, T(0)) | 0)
              f2 = 0;
            else
              f2 = (Ld(d2, T(1)) | 0) ^ 1;
            r3 = T(Od(e3, b3, k2 & h2, k2 & (h2 ^ 1)));
            g2[n3 >> 2] = T(r3 - T(Od(o3, b3, 0, k2)));
            r3 = T(Od(j2, b3, k2 & f2, k2 & (f2 ^ 1)));
            g2[l3 >> 2] = T(r3 - T(Od(m2, b3, 0, k2)));
            h2 = (c2[a3 + 952 >> 2] | 0) - (c2[a3 + 948 >> 2] | 0) >> 2;
            if (h2 | 0) {
              f2 = 0;
              do {
                de(ac(a3, f2) | 0, b3, o3, m2);
                f2 = f2 + 1 | 0;
              } while ((f2 | 0) != (h2 | 0));
            }
          }
          return;
        }
        function ee(a3, b3, d2, e3, f2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          e3 = e3 | 0;
          f2 = f2 | 0;
          switch (d2 | 0) {
            case 5:
            case 0: {
              a3 = CB(c2[489] | 0, e3, f2) | 0;
              break;
            }
            default:
              a3 = iC(e3, f2) | 0;
          }
          return a3 | 0;
        }
        function fe(a3, b3, d2, e3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          e3 = e3 | 0;
          var f2 = 0, g3 = 0;
          f2 = l2;
          l2 = l2 + 16 | 0;
          g3 = f2;
          c2[g3 >> 2] = e3;
          ge(a3, 0, b3, d2, g3);
          l2 = f2;
          return;
        }
        function ge(a3, b3, d2, e3, f2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          e3 = e3 | 0;
          f2 = f2 | 0;
          a3 = a3 | 0 ? a3 : 956;
          Bb[c2[a3 + 8 >> 2] & 1](a3, b3, d2, e3, f2) | 0;
          if ((d2 | 0) == 5)
            Ta();
          else
            return;
        }
        function he(b3, c3, d2) {
          b3 = b3 | 0;
          c3 = c3 | 0;
          d2 = d2 | 0;
          a2[b3 + c3 >> 0] = d2 & 1;
          return;
        }
        function ie(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          var d2 = 0, e3 = 0;
          c2[a3 >> 2] = 0;
          c2[a3 + 4 >> 2] = 0;
          c2[a3 + 8 >> 2] = 0;
          d2 = b3 + 4 | 0;
          e3 = (c2[d2 >> 2] | 0) - (c2[b3 >> 2] | 0) >> 2;
          if (e3 | 0) {
            je(a3, e3);
            ke(a3, c2[b3 >> 2] | 0, c2[d2 >> 2] | 0, e3);
          }
          return;
        }
        function je(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          var d2 = 0;
          if ((le(a3) | 0) >>> 0 < b3 >>> 0)
            jC(a3);
          if (b3 >>> 0 > 1073741823)
            Ta();
          else {
            d2 = qC(b3 << 2) | 0;
            c2[a3 + 4 >> 2] = d2;
            c2[a3 >> 2] = d2;
            c2[a3 + 8 >> 2] = d2 + (b3 << 2);
            return;
          }
        }
        function ke(a3, b3, d2, e3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          e3 = e3 | 0;
          e3 = a3 + 4 | 0;
          a3 = d2 - b3 | 0;
          if ((a3 | 0) > 0) {
            BC(c2[e3 >> 2] | 0, b3 | 0, a3 | 0) | 0;
            c2[e3 >> 2] = (c2[e3 >> 2] | 0) + (a3 >>> 2 << 2);
          }
          return;
        }
        function le(a3) {
          a3 = a3 | 0;
          return 1073741823;
        }
        function me(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = T(d2);
          if (oe(b3) | 0 ? (c2[a3 + 96 >> 2] | 0) != 0 : 0)
            a3 = a3 + 92 | 0;
          else
            a3 = Tb(a3 + 60 | 0, c2[1040 + (b3 << 2) >> 2] | 0, 992) | 0;
          return T(pe(a3, d2));
        }
        function ne(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = T(d2);
          if (oe(b3) | 0 ? (c2[a3 + 104 >> 2] | 0) != 0 : 0)
            a3 = a3 + 100 | 0;
          else
            a3 = Tb(a3 + 60 | 0, c2[1e3 + (b3 << 2) >> 2] | 0, 992) | 0;
          return T(pe(a3, d2));
        }
        function oe(a3) {
          a3 = a3 | 0;
          return (a3 | 1 | 0) == 3 | 0;
        }
        function pe(a3, b3) {
          a3 = a3 | 0;
          b3 = T(b3);
          if ((c2[a3 + 4 >> 2] | 0) == 3)
            b3 = T(0);
          else
            b3 = T(be(a3, b3));
          return T(b3);
        }
        function qe(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          a3 = c2[a3 >> 2] | 0;
          return ((a3 | 0) == 0 ? (b3 | 0) > 1 ? b3 : 1 : a3) | 0;
        }
        function re(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          var c3 = 0;
          a:
            do
              if ((b3 | 0) == 2) {
                switch (a3 | 0) {
                  case 2: {
                    a3 = 3;
                    break a;
                  }
                  case 3:
                    break;
                  default: {
                    c3 = 4;
                    break a;
                  }
                }
                a3 = 2;
              } else
                c3 = 4;
            while (0);
          return a3 | 0;
        }
        function se(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          var d2 = ib;
          if (!((oe(b3) | 0 ? (c2[a3 + 312 >> 2] | 0) != 0 : 0) ? (d2 = T(g2[a3 + 308 >> 2]), d2 >= T(0)) : 0))
            d2 = T(cC(T(g2[(Tb(a3 + 276 | 0, c2[1040 + (b3 << 2) >> 2] | 0, 992) | 0) >> 2]), T(0)));
          return T(d2);
        }
        function te(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          var d2 = ib;
          if (!((oe(b3) | 0 ? (c2[a3 + 320 >> 2] | 0) != 0 : 0) ? (d2 = T(g2[a3 + 316 >> 2]), d2 >= T(0)) : 0))
            d2 = T(cC(T(g2[(Tb(a3 + 276 | 0, c2[1e3 + (b3 << 2) >> 2] | 0, 992) | 0) >> 2]), T(0)));
          return T(d2);
        }
        function ue(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = T(d2);
          var e3 = ib;
          if (!((oe(b3) | 0 ? (c2[a3 + 240 >> 2] | 0) != 0 : 0) ? (e3 = T(be(a3 + 236 | 0, d2)), e3 >= T(0)) : 0))
            e3 = T(cC(T(be(Tb(a3 + 204 | 0, c2[1040 + (b3 << 2) >> 2] | 0, 992) | 0, d2)), T(0)));
          return T(e3);
        }
        function ve(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = T(d2);
          var e3 = ib;
          if (!((oe(b3) | 0 ? (c2[a3 + 248 >> 2] | 0) != 0 : 0) ? (e3 = T(be(a3 + 244 | 0, d2)), e3 >= T(0)) : 0))
            e3 = T(cC(T(be(Tb(a3 + 204 | 0, c2[1e3 + (b3 << 2) >> 2] | 0, 992) | 0, d2)), T(0)));
          return T(e3);
        }
        function we(a3, b3, d2, e3, f2, h2, i4) {
          a3 = a3 | 0;
          b3 = T(b3);
          d2 = T(d2);
          e3 = e3 | 0;
          f2 = f2 | 0;
          h2 = T(h2);
          i4 = T(i4);
          var j2 = ib, k2 = ib, m2 = ib, n3 = ib, o3 = ib, p2 = ib, q2 = 0, r3 = 0, s3 = 0;
          s3 = l2;
          l2 = l2 + 16 | 0;
          q2 = s3;
          r3 = a3 + 964 | 0;
          ec(a3, (c2[r3 >> 2] | 0) != 0, 3519);
          j2 = T(Ce(a3, 2, b3));
          k2 = T(Ce(a3, 0, b3));
          m2 = T(Ud(a3, 2, b3));
          n3 = T(Ud(a3, 0, b3));
          if (Sb(b3) | 0)
            o3 = b3;
          else
            o3 = T(cC(T(0), T(T(b3 - m2) - j2)));
          if (Sb(d2) | 0)
            p2 = d2;
          else
            p2 = T(cC(T(0), T(T(d2 - n3) - k2)));
          if ((e3 | 0) == 1 & (f2 | 0) == 1) {
            g2[a3 + 908 >> 2] = T(Ie(a3, 2, T(b3 - m2), h2, h2));
            b3 = T(Ie(a3, 0, T(d2 - n3), i4, h2));
          } else {
            Db[c2[r3 >> 2] & 1](q2, a3, o3, e3, p2, f2);
            o3 = T(j2 + T(g2[q2 >> 2]));
            p2 = T(b3 - m2);
            g2[a3 + 908 >> 2] = T(Ie(a3, 2, (e3 | 2 | 0) == 2 ? o3 : p2, h2, h2));
            p2 = T(k2 + T(g2[q2 + 4 >> 2]));
            b3 = T(d2 - n3);
            b3 = T(Ie(a3, 0, (f2 | 2 | 0) == 2 ? p2 : b3, i4, h2));
          }
          g2[a3 + 912 >> 2] = b3;
          l2 = s3;
          return;
        }
        function xe(a3, b3, c3, d2, e3, f2, h2) {
          a3 = a3 | 0;
          b3 = T(b3);
          c3 = T(c3);
          d2 = d2 | 0;
          e3 = e3 | 0;
          f2 = T(f2);
          h2 = T(h2);
          var i4 = ib, j2 = ib, k2 = ib, l3 = ib;
          k2 = T(Ce(a3, 2, f2));
          i4 = T(Ce(a3, 0, f2));
          l3 = T(Ud(a3, 2, f2));
          j2 = T(Ud(a3, 0, f2));
          b3 = T(b3 - l3);
          g2[a3 + 908 >> 2] = T(Ie(a3, 2, (d2 | 2 | 0) == 2 ? k2 : b3, f2, f2));
          c3 = T(c3 - j2);
          g2[a3 + 912 >> 2] = T(Ie(a3, 0, (e3 | 2 | 0) == 2 ? i4 : c3, h2, f2));
          return;
        }
        function ye(a3, b3, c3, d2, e3, f2, h2) {
          a3 = a3 | 0;
          b3 = T(b3);
          c3 = T(c3);
          d2 = d2 | 0;
          e3 = e3 | 0;
          f2 = T(f2);
          h2 = T(h2);
          var i4 = 0, j2 = ib, k2 = ib;
          i4 = (d2 | 0) == 2;
          if ((!(b3 <= T(0) & i4) ? !(c3 <= T(0) & (e3 | 0) == 2) : 0) ? !((d2 | 0) == 1 & (e3 | 0) == 1) : 0)
            a3 = 0;
          else {
            j2 = T(Ud(a3, 0, f2));
            k2 = T(Ud(a3, 2, f2));
            i4 = b3 < T(0) & i4 | (Sb(b3) | 0);
            b3 = T(b3 - k2);
            g2[a3 + 908 >> 2] = T(Ie(a3, 2, i4 ? T(0) : b3, f2, f2));
            b3 = T(c3 - j2);
            i4 = c3 < T(0) & (e3 | 0) == 2 | (Sb(c3) | 0);
            g2[a3 + 912 >> 2] = T(Ie(a3, 0, i4 ? T(0) : b3, h2, f2));
            a3 = 1;
          }
          return a3 | 0;
        }
        function ze(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          if (We(a3) | 0)
            a3 = re(2, b3) | 0;
          else
            a3 = 0;
          return a3 | 0;
        }
        function Ae(a3, b3, c3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          c3 = T(c3);
          c3 = T(ue(a3, b3, c3));
          return T(c3 + T(se(a3, b3)));
        }
        function Be(a3, b3, c3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          c3 = T(c3);
          c3 = T(ve(a3, b3, c3));
          return T(c3 + T(te(a3, b3)));
        }
        function Ce(a3, b3, c3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          c3 = T(c3);
          var d2 = ib;
          d2 = T(Ae(a3, b3, c3));
          return T(d2 + T(Be(a3, b3, c3)));
        }
        function De(a3) {
          a3 = a3 | 0;
          if (!(c2[a3 + 24 >> 2] | 0)) {
            if (T(Ee(a3)) != T(0))
              a3 = 1;
            else
              a3 = T(Fe(a3)) != T(0);
          } else
            a3 = 0;
          return a3 | 0;
        }
        function Ee(a3) {
          a3 = a3 | 0;
          var b3 = ib;
          if (c2[a3 + 944 >> 2] | 0) {
            b3 = T(g2[a3 + 44 >> 2]);
            if (Sb(b3) | 0) {
              b3 = T(g2[a3 + 40 >> 2]);
              a3 = b3 > T(0) & ((Sb(b3) | 0) ^ 1);
              return T(a3 ? b3 : T(0));
            }
          } else
            b3 = T(0);
          return T(b3);
        }
        function Fe(b3) {
          b3 = b3 | 0;
          var d2 = ib, e3 = 0, f2 = ib;
          do
            if (c2[b3 + 944 >> 2] | 0) {
              d2 = T(g2[b3 + 48 >> 2]);
              if (Sb(d2) | 0) {
                e3 = a2[(c2[b3 + 976 >> 2] | 0) + 2 >> 0] | 0;
                if (e3 << 24 >> 24 == 0 ? (f2 = T(g2[b3 + 40 >> 2]), f2 < T(0) & ((Sb(f2) | 0) ^ 1)) : 0) {
                  d2 = T(-f2);
                  break;
                }
                d2 = e3 << 24 >> 24 ? T(1) : T(0);
              }
            } else
              d2 = T(0);
          while (0);
          return T(d2);
        }
        function Ge(b3) {
          b3 = b3 | 0;
          var d2 = 0, e3 = 0;
          yC(b3 + 400 | 0, 0, 540) | 0;
          a2[b3 + 985 >> 0] = 1;
          lc(b3);
          e3 = $b(b3) | 0;
          if (e3 | 0) {
            d2 = b3 + 948 | 0;
            b3 = 0;
            do {
              Ge(c2[(c2[d2 >> 2] | 0) + (b3 << 2) >> 2] | 0);
              b3 = b3 + 1 | 0;
            } while ((b3 | 0) != (e3 | 0));
          }
          return;
        }
        function He(a3, b3, d2, e3, f2, h2, i4, j2, k2, m2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = T(d2);
          e3 = e3 | 0;
          f2 = T(f2);
          h2 = T(h2);
          i4 = T(i4);
          j2 = j2 | 0;
          k2 = k2 | 0;
          m2 = m2 | 0;
          var n3 = 0, o3 = ib, p2 = 0, q2 = 0, r3 = ib, s3 = ib, u3 = 0, v2 = ib, w2 = 0, x2 = ib, y3 = 0, z2 = 0, A2 = 0, B2 = 0, C2 = 0, D2 = 0, E2 = 0, F2 = 0, G2 = 0, H2 = 0;
          G2 = l2;
          l2 = l2 + 16 | 0;
          A2 = G2 + 12 | 0;
          B2 = G2 + 8 | 0;
          C2 = G2 + 4 | 0;
          D2 = G2;
          F2 = re(c2[a3 + 4 >> 2] | 0, k2) | 0;
          y3 = oe(F2) | 0;
          o3 = T(be(Xe(b3) | 0, y3 ? h2 : i4));
          z2 = ae(b3, 2, h2) | 0;
          E2 = ae(b3, 0, i4) | 0;
          do
            if (!(Sb(o3) | 0) ? !(Sb(y3 ? d2 : f2) | 0) : 0) {
              n3 = b3 + 504 | 0;
              if (!(Sb(T(g2[n3 >> 2])) | 0)) {
                if (!(Ye(c2[b3 + 976 >> 2] | 0, 0) | 0))
                  break;
                if ((c2[b3 + 500 >> 2] | 0) == (c2[2278] | 0))
                  break;
              }
              g2[n3 >> 2] = T(cC(o3, T(Ce(b3, F2, h2))));
            } else
              p2 = 7;
          while (0);
          do
            if ((p2 | 0) == 7) {
              w2 = y3 ^ 1;
              if (!(w2 | z2 ^ 1)) {
                i4 = T(be(c2[b3 + 992 >> 2] | 0, h2));
                g2[b3 + 504 >> 2] = T(cC(i4, T(Ce(b3, 2, h2))));
                break;
              }
              if (!(y3 | E2 ^ 1)) {
                i4 = T(be(c2[b3 + 996 >> 2] | 0, i4));
                g2[b3 + 504 >> 2] = T(cC(i4, T(Ce(b3, 0, h2))));
                break;
              }
              g2[A2 >> 2] = T(t2);
              g2[B2 >> 2] = T(t2);
              c2[C2 >> 2] = 0;
              c2[D2 >> 2] = 0;
              v2 = T(Ud(b3, 2, h2));
              x2 = T(Ud(b3, 0, h2));
              if (z2) {
                r3 = T(v2 + T(be(c2[b3 + 992 >> 2] | 0, h2)));
                g2[A2 >> 2] = r3;
                c2[C2 >> 2] = 1;
                q2 = 1;
              } else {
                q2 = 0;
                r3 = T(t2);
              }
              if (E2) {
                o3 = T(x2 + T(be(c2[b3 + 996 >> 2] | 0, i4)));
                g2[B2 >> 2] = o3;
                c2[D2 >> 2] = 1;
                n3 = 1;
              } else {
                n3 = 0;
                o3 = T(t2);
              }
              p2 = c2[a3 + 32 >> 2] | 0;
              if (!(y3 & (p2 | 0) == 2)) {
                if (Sb(r3) | 0 ? !(Sb(d2) | 0) : 0) {
                  g2[A2 >> 2] = d2;
                  c2[C2 >> 2] = 2;
                  q2 = 2;
                  r3 = d2;
                }
              } else
                p2 = 2;
              if ((!((p2 | 0) == 2 & w2) ? Sb(o3) | 0 : 0) ? !(Sb(f2) | 0) : 0) {
                g2[B2 >> 2] = f2;
                c2[D2 >> 2] = 2;
                n3 = 2;
                o3 = f2;
              }
              s3 = T(g2[b3 + 396 >> 2]);
              u3 = Sb(s3) | 0;
              do
                if (!u3) {
                  if ((q2 | 0) == 1 & w2) {
                    g2[B2 >> 2] = T(T(r3 - v2) / s3);
                    c2[D2 >> 2] = 1;
                    n3 = 1;
                    p2 = 1;
                    break;
                  }
                  if (y3 & (n3 | 0) == 1) {
                    g2[A2 >> 2] = T(s3 * T(o3 - x2));
                    c2[C2 >> 2] = 1;
                    n3 = 1;
                    p2 = 1;
                  } else
                    p2 = q2;
                } else
                  p2 = q2;
              while (0);
              H2 = Sb(d2) | 0;
              q2 = (Je(a3, b3) | 0) != 4;
              if (!(y3 | z2 | ((e3 | 0) != 1 | H2) | (q2 | (p2 | 0) == 1)) ? (g2[A2 >> 2] = d2, c2[C2 >> 2] = 1, !u3) : 0) {
                g2[B2 >> 2] = T(T(d2 - v2) / s3);
                c2[D2 >> 2] = 1;
                n3 = 1;
              }
              if (!(E2 | w2 | ((j2 | 0) != 1 | (Sb(f2) | 0)) | (q2 | (n3 | 0) == 1)) ? (g2[B2 >> 2] = f2, c2[D2 >> 2] = 1, !u3) : 0) {
                g2[A2 >> 2] = T(s3 * T(f2 - x2));
                c2[C2 >> 2] = 1;
              }
              Me(b3, 2, h2, h2, C2, A2);
              Me(b3, 0, i4, h2, D2, B2);
              d2 = T(g2[A2 >> 2]);
              f2 = T(g2[B2 >> 2]);
              Td(b3, d2, f2, k2, c2[C2 >> 2] | 0, c2[D2 >> 2] | 0, h2, i4, 0, 3565, m2) | 0;
              i4 = T(g2[b3 + 908 + (c2[976 + (F2 << 2) >> 2] << 2) >> 2]);
              g2[b3 + 504 >> 2] = T(cC(i4, T(Ce(b3, F2, h2))));
            }
          while (0);
          c2[b3 + 500 >> 2] = c2[2278];
          l2 = G2;
          return;
        }
        function Ie(a3, b3, c3, d2, e3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          c3 = T(c3);
          d2 = T(d2);
          e3 = T(e3);
          d2 = T(Te(a3, b3, c3, d2));
          return T(cC(d2, T(Ce(a3, b3, e3))));
        }
        function Je(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          b3 = b3 + 20 | 0;
          b3 = c2[((c2[b3 >> 2] | 0) == 0 ? a3 + 16 | 0 : b3) >> 2] | 0;
          if ((b3 | 0) == 5 ? We(c2[a3 + 4 >> 2] | 0) | 0 : 0)
            b3 = 1;
          return b3 | 0;
        }
        function Ke(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          if (oe(b3) | 0 ? (c2[a3 + 96 >> 2] | 0) != 0 : 0)
            b3 = 4;
          else
            b3 = c2[1040 + (b3 << 2) >> 2] | 0;
          return a3 + 60 + (b3 << 3) | 0;
        }
        function Le(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          if (oe(b3) | 0 ? (c2[a3 + 104 >> 2] | 0) != 0 : 0)
            b3 = 5;
          else
            b3 = c2[1e3 + (b3 << 2) >> 2] | 0;
          return a3 + 60 + (b3 << 3) | 0;
        }
        function Me(a3, b3, d2, e3, f2, h2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = T(d2);
          e3 = T(e3);
          f2 = f2 | 0;
          h2 = h2 | 0;
          d2 = T(be(a3 + 380 + (c2[976 + (b3 << 2) >> 2] << 3) | 0, d2));
          d2 = T(d2 + T(Ud(a3, b3, e3)));
          switch (c2[f2 >> 2] | 0) {
            case 2:
            case 1: {
              f2 = Sb(d2) | 0;
              e3 = T(g2[h2 >> 2]);
              g2[h2 >> 2] = f2 | e3 < d2 ? e3 : d2;
              break;
            }
            case 0: {
              if (!(Sb(d2) | 0)) {
                c2[f2 >> 2] = 2;
                g2[h2 >> 2] = d2;
              }
              break;
            }
            default: {
            }
          }
          return;
        }
        function Ne(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          a3 = a3 + 132 | 0;
          if (oe(b3) | 0 ? (c2[(Tb(a3, 4, 948) | 0) + 4 >> 2] | 0) != 0 : 0)
            a3 = 1;
          else
            a3 = (c2[(Tb(a3, c2[1040 + (b3 << 2) >> 2] | 0, 948) | 0) + 4 >> 2] | 0) != 0;
          return a3 | 0;
        }
        function Oe(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = T(d2);
          var e3 = 0, f2 = 0;
          a3 = a3 + 132 | 0;
          if (oe(b3) | 0 ? (e3 = Tb(a3, 4, 948) | 0, (c2[e3 + 4 >> 2] | 0) != 0) : 0)
            f2 = 4;
          else {
            e3 = Tb(a3, c2[1040 + (b3 << 2) >> 2] | 0, 948) | 0;
            if (!(c2[e3 + 4 >> 2] | 0))
              d2 = T(0);
            else
              f2 = 4;
          }
          if ((f2 | 0) == 4)
            d2 = T(be(e3, d2));
          return T(d2);
        }
        function Pe(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = T(d2);
          var e3 = ib;
          e3 = T(g2[a3 + 908 + (c2[976 + (b3 << 2) >> 2] << 2) >> 2]);
          e3 = T(e3 + T(me(a3, b3, d2)));
          return T(e3 + T(ne(a3, b3, d2)));
        }
        function Qe(a3) {
          a3 = a3 | 0;
          var b3 = 0, d2 = 0, e3 = 0;
          a:
            do
              if (!(We(c2[a3 + 4 >> 2] | 0) | 0)) {
                if ((c2[a3 + 16 >> 2] | 0) != 5) {
                  d2 = $b(a3) | 0;
                  if (!d2)
                    b3 = 0;
                  else {
                    b3 = 0;
                    while (1) {
                      e3 = ac(a3, b3) | 0;
                      if ((c2[e3 + 24 >> 2] | 0) == 0 ? (c2[e3 + 20 >> 2] | 0) == 5 : 0) {
                        b3 = 1;
                        break a;
                      }
                      b3 = b3 + 1 | 0;
                      if (b3 >>> 0 >= d2 >>> 0) {
                        b3 = 0;
                        break;
                      }
                    }
                  }
                } else
                  b3 = 1;
              } else
                b3 = 0;
            while (0);
          return b3 | 0;
        }
        function Re(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          var d2 = ib;
          d2 = T(g2[a3 + 908 + (c2[976 + (b3 << 2) >> 2] << 2) >> 2]);
          return d2 >= T(0) & ((Sb(d2) | 0) ^ 1) | 0;
        }
        function Se(a3) {
          a3 = a3 | 0;
          var b3 = ib, d2 = 0, e3 = 0, f2 = 0, h2 = 0, i4 = 0, j2 = 0, k2 = ib;
          d2 = c2[a3 + 968 >> 2] | 0;
          if (!d2) {
            h2 = $b(a3) | 0;
            do
              if (h2 | 0) {
                d2 = 0;
                f2 = 0;
                while (1) {
                  e3 = ac(a3, f2) | 0;
                  if (c2[e3 + 940 >> 2] | 0) {
                    i4 = 8;
                    break;
                  }
                  if ((c2[e3 + 24 >> 2] | 0) != 1) {
                    j2 = (Je(a3, e3) | 0) == 5;
                    if (j2) {
                      d2 = e3;
                      break;
                    } else
                      d2 = (d2 | 0) == 0 ? e3 : d2;
                  }
                  f2 = f2 + 1 | 0;
                  if (f2 >>> 0 >= h2 >>> 0) {
                    i4 = 8;
                    break;
                  }
                }
                if ((i4 | 0) == 8) {
                  if (!d2)
                    break;
                }
                b3 = T(Se(d2));
                return T(b3 + T(g2[d2 + 404 >> 2]));
              }
            while (0);
            b3 = T(g2[a3 + 912 >> 2]);
          } else {
            k2 = T(g2[a3 + 908 >> 2]);
            b3 = T(g2[a3 + 912 >> 2]);
            b3 = T(mb[d2 & 0](a3, k2, b3));
            ec(a3, (Sb(b3) | 0) ^ 1, 3573);
          }
          return T(b3);
        }
        function Te(a3, b3, c3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          c3 = T(c3);
          d2 = T(d2);
          var e3 = ib, f2 = 0;
          if (!(We(b3) | 0)) {
            if (oe(b3) | 0) {
              b3 = 0;
              f2 = 3;
            } else {
              d2 = T(t2);
              e3 = T(t2);
            }
          } else {
            b3 = 1;
            f2 = 3;
          }
          if ((f2 | 0) == 3) {
            e3 = T(be(a3 + 364 + (b3 << 3) | 0, d2));
            d2 = T(be(a3 + 380 + (b3 << 3) | 0, d2));
          }
          f2 = d2 < c3 & (d2 >= T(0) & ((Sb(d2) | 0) ^ 1));
          c3 = f2 ? d2 : c3;
          f2 = e3 >= T(0) & ((Sb(e3) | 0) ^ 1) & c3 < e3;
          return T(f2 ? e3 : c3);
        }
        function Ue(a3, b3, d2, e3, f2, h2, i4) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = T(d2);
          e3 = e3 | 0;
          f2 = T(f2);
          h2 = h2 | 0;
          i4 = i4 | 0;
          var j2 = ib, k2 = ib, l3 = 0, m2 = 0, n3 = ib, o3 = ib, p2 = ib, q2 = 0, r3 = 0, s3 = 0, u3 = 0, v2 = ib, w2 = 0;
          s3 = re(c2[a3 + 4 >> 2] | 0, h2) | 0;
          q2 = ze(s3, h2) | 0;
          r3 = oe(s3) | 0;
          n3 = T(Ud(b3, 2, d2));
          o3 = T(Ud(b3, 0, d2));
          if (!(ae(b3, 2, d2) | 0)) {
            if (Ne(b3, 2) | 0 ? Ze(b3, 2) | 0 : 0) {
              j2 = T(g2[a3 + 908 >> 2]);
              k2 = T(se(a3, 2));
              k2 = T(j2 - T(k2 + T(te(a3, 2))));
              j2 = T(Oe(b3, 2, d2));
              j2 = T(Ie(b3, 2, T(k2 - T(j2 + T(_e(b3, 2, d2)))), d2, d2));
            } else
              j2 = T(t2);
          } else
            j2 = T(n3 + T(be(c2[b3 + 992 >> 2] | 0, d2)));
          if (!(ae(b3, 0, f2) | 0)) {
            if (Ne(b3, 0) | 0 ? Ze(b3, 0) | 0 : 0) {
              k2 = T(g2[a3 + 912 >> 2]);
              v2 = T(se(a3, 0));
              v2 = T(k2 - T(v2 + T(te(a3, 0))));
              k2 = T(Oe(b3, 0, f2));
              k2 = T(Ie(b3, 0, T(v2 - T(k2 + T(_e(b3, 0, f2)))), f2, d2));
            } else
              k2 = T(t2);
          } else
            k2 = T(o3 + T(be(c2[b3 + 996 >> 2] | 0, f2)));
          l3 = Sb(j2) | 0;
          m2 = Sb(k2) | 0;
          do
            if (l3 ^ m2 ? (p2 = T(g2[b3 + 396 >> 2]), !(Sb(p2) | 0)) : 0)
              if (l3) {
                j2 = T(n3 + T(T(k2 - o3) * p2));
                break;
              } else {
                v2 = T(o3 + T(T(j2 - n3) / p2));
                k2 = m2 ? v2 : k2;
                break;
              }
          while (0);
          m2 = Sb(j2) | 0;
          l3 = Sb(k2) | 0;
          if (m2 | l3) {
            w2 = (m2 ^ 1) & 1;
            e3 = d2 > T(0) & ((e3 | 0) != 0 & m2);
            j2 = r3 ? j2 : e3 ? d2 : j2;
            Td(b3, j2, k2, h2, r3 ? w2 : e3 ? 2 : w2, m2 & (l3 ^ 1) & 1, j2, k2, 0, 3623, i4) | 0;
            j2 = T(g2[b3 + 908 >> 2]);
            j2 = T(j2 + T(Ud(b3, 2, d2)));
            k2 = T(g2[b3 + 912 >> 2]);
            k2 = T(k2 + T(Ud(b3, 0, d2)));
          }
          Td(b3, j2, k2, h2, 1, 1, j2, k2, 1, 3635, i4) | 0;
          if (Ze(b3, s3) | 0 ? !(Ne(b3, s3) | 0) : 0) {
            w2 = c2[976 + (s3 << 2) >> 2] | 0;
            v2 = T(g2[a3 + 908 + (w2 << 2) >> 2]);
            v2 = T(v2 - T(g2[b3 + 908 + (w2 << 2) >> 2]));
            v2 = T(v2 - T(te(a3, s3)));
            v2 = T(v2 - T(ne(b3, s3, d2)));
            v2 = T(v2 - T(_e(b3, s3, r3 ? d2 : f2)));
            g2[b3 + 400 + (c2[1040 + (s3 << 2) >> 2] << 2) >> 2] = v2;
          } else
            u3 = 21;
          do
            if ((u3 | 0) == 21) {
              if (!(Ne(b3, s3) | 0) ? (c2[a3 + 8 >> 2] | 0) == 1 : 0) {
                w2 = c2[976 + (s3 << 2) >> 2] | 0;
                v2 = T(g2[a3 + 908 + (w2 << 2) >> 2]);
                v2 = T(T(v2 - T(g2[b3 + 908 + (w2 << 2) >> 2])) * T(0.5));
                g2[b3 + 400 + (c2[1040 + (s3 << 2) >> 2] << 2) >> 2] = v2;
                break;
              }
              if (!(Ne(b3, s3) | 0) ? (c2[a3 + 8 >> 2] | 0) == 2 : 0) {
                w2 = c2[976 + (s3 << 2) >> 2] | 0;
                v2 = T(g2[a3 + 908 + (w2 << 2) >> 2]);
                v2 = T(v2 - T(g2[b3 + 908 + (w2 << 2) >> 2]));
                g2[b3 + 400 + (c2[1040 + (s3 << 2) >> 2] << 2) >> 2] = v2;
              }
            }
          while (0);
          if (Ze(b3, q2) | 0 ? !(Ne(b3, q2) | 0) : 0) {
            w2 = c2[976 + (q2 << 2) >> 2] | 0;
            v2 = T(g2[a3 + 908 + (w2 << 2) >> 2]);
            v2 = T(v2 - T(g2[b3 + 908 + (w2 << 2) >> 2]));
            v2 = T(v2 - T(te(a3, q2)));
            v2 = T(v2 - T(ne(b3, q2, d2)));
            v2 = T(v2 - T(_e(b3, q2, r3 ? f2 : d2)));
            g2[b3 + 400 + (c2[1040 + (q2 << 2) >> 2] << 2) >> 2] = v2;
          } else
            u3 = 30;
          do
            if ((u3 | 0) == 30 ? !(Ne(b3, q2) | 0) : 0) {
              if ((Je(a3, b3) | 0) == 2) {
                w2 = c2[976 + (q2 << 2) >> 2] | 0;
                v2 = T(g2[a3 + 908 + (w2 << 2) >> 2]);
                v2 = T(T(v2 - T(g2[b3 + 908 + (w2 << 2) >> 2])) * T(0.5));
                g2[b3 + 400 + (c2[1040 + (q2 << 2) >> 2] << 2) >> 2] = v2;
                break;
              }
              w2 = (Je(a3, b3) | 0) == 3;
              if (w2 ^ (c2[a3 + 28 >> 2] | 0) == 2) {
                w2 = c2[976 + (q2 << 2) >> 2] | 0;
                v2 = T(g2[a3 + 908 + (w2 << 2) >> 2]);
                v2 = T(v2 - T(g2[b3 + 908 + (w2 << 2) >> 2]));
                g2[b3 + 400 + (c2[1040 + (q2 << 2) >> 2] << 2) >> 2] = v2;
              }
            }
          while (0);
          return;
        }
        function Ve(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          var e3 = ib, f2 = 0;
          f2 = c2[976 + (d2 << 2) >> 2] | 0;
          e3 = T(g2[b3 + 908 + (f2 << 2) >> 2]);
          e3 = T(T(g2[a3 + 908 + (f2 << 2) >> 2]) - e3);
          e3 = T(e3 - T(g2[b3 + 400 + (c2[1040 + (d2 << 2) >> 2] << 2) >> 2]));
          g2[b3 + 400 + (c2[1e3 + (d2 << 2) >> 2] << 2) >> 2] = e3;
          return;
        }
        function We(a3) {
          a3 = a3 | 0;
          return (a3 | 1 | 0) == 1 | 0;
        }
        function Xe(b3) {
          b3 = b3 | 0;
          var d2 = ib;
          switch (c2[b3 + 56 >> 2] | 0) {
            case 0:
            case 3: {
              d2 = T(g2[b3 + 40 >> 2]);
              if (d2 > T(0) & ((Sb(d2) | 0) ^ 1))
                b3 = a2[(c2[b3 + 976 >> 2] | 0) + 2 >> 0] | 0 ? 1056 : 992;
              else
                b3 = 1056;
              break;
            }
            default:
              b3 = b3 + 52 | 0;
          }
          return b3 | 0;
        }
        function Ye(b3, c3) {
          b3 = b3 | 0;
          c3 = c3 | 0;
          return (a2[b3 + c3 >> 0] | 0) != 0 | 0;
        }
        function Ze(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          a3 = a3 + 132 | 0;
          if (oe(b3) | 0 ? (c2[(Tb(a3, 5, 948) | 0) + 4 >> 2] | 0) != 0 : 0)
            a3 = 1;
          else
            a3 = (c2[(Tb(a3, c2[1e3 + (b3 << 2) >> 2] | 0, 948) | 0) + 4 >> 2] | 0) != 0;
          return a3 | 0;
        }
        function _e(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = T(d2);
          var e3 = 0, f2 = 0;
          a3 = a3 + 132 | 0;
          if (oe(b3) | 0 ? (e3 = Tb(a3, 5, 948) | 0, (c2[e3 + 4 >> 2] | 0) != 0) : 0)
            f2 = 4;
          else {
            e3 = Tb(a3, c2[1e3 + (b3 << 2) >> 2] | 0, 948) | 0;
            if (!(c2[e3 + 4 >> 2] | 0))
              d2 = T(0);
            else
              f2 = 4;
          }
          if ((f2 | 0) == 4)
            d2 = T(be(e3, d2));
          return T(d2);
        }
        function $e(a3, b3, c3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          c3 = T(c3);
          if (Ne(a3, b3) | 0)
            c3 = T(Oe(a3, b3, c3));
          else
            c3 = T(-T(_e(a3, b3, c3)));
          return T(c3);
        }
        function af(a3) {
          a3 = T(a3);
          return (g2[j >> 2] = a3, c2[j >> 2] | 0) | 0;
        }
        function bf(a3, b3, d2, e3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          e3 = e3 | 0;
          var f2 = 0;
          c2[a3 + 12 >> 2] = 0;
          c2[a3 + 16 >> 2] = e3;
          do
            if (b3) {
              if (b3 >>> 0 > 1073741823)
                Ta();
              else {
                f2 = qC(b3 << 2) | 0;
                break;
              }
            } else
              f2 = 0;
          while (0);
          c2[a3 >> 2] = f2;
          e3 = f2 + (d2 << 2) | 0;
          c2[a3 + 8 >> 2] = e3;
          c2[a3 + 4 >> 2] = e3;
          c2[a3 + 12 >> 2] = f2 + (b3 << 2);
          return;
        }
        function cf(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          var d2 = 0, e3 = 0, f2 = 0, g3 = 0, h2 = 0;
          e3 = c2[a3 >> 2] | 0;
          h2 = a3 + 4 | 0;
          g3 = b3 + 4 | 0;
          f2 = (c2[h2 >> 2] | 0) - e3 | 0;
          d2 = (c2[g3 >> 2] | 0) + (0 - (f2 >> 2) << 2) | 0;
          c2[g3 >> 2] = d2;
          if ((f2 | 0) > 0) {
            BC(d2 | 0, e3 | 0, f2 | 0) | 0;
            e3 = g3;
            d2 = c2[g3 >> 2] | 0;
          } else
            e3 = g3;
          g3 = c2[a3 >> 2] | 0;
          c2[a3 >> 2] = d2;
          c2[e3 >> 2] = g3;
          g3 = b3 + 8 | 0;
          f2 = c2[h2 >> 2] | 0;
          c2[h2 >> 2] = c2[g3 >> 2];
          c2[g3 >> 2] = f2;
          g3 = a3 + 8 | 0;
          h2 = b3 + 12 | 0;
          a3 = c2[g3 >> 2] | 0;
          c2[g3 >> 2] = c2[h2 >> 2];
          c2[h2 >> 2] = a3;
          c2[b3 >> 2] = c2[e3 >> 2];
          return;
        }
        function df(a3) {
          a3 = a3 | 0;
          var b3 = 0, d2 = 0, e3 = 0;
          b3 = c2[a3 + 4 >> 2] | 0;
          d2 = a3 + 8 | 0;
          e3 = c2[d2 >> 2] | 0;
          if ((e3 | 0) != (b3 | 0))
            c2[d2 >> 2] = e3 + (~((e3 + -4 - b3 | 0) >>> 2) << 2);
          a3 = c2[a3 >> 2] | 0;
          if (a3 | 0)
            sC(a3);
          return;
        }
        function ef(a3, b3, d2, e3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          e3 = e3 | 0;
          var f2 = 0, g3 = 0, h2 = 0, i4 = 0;
          h2 = a3 + 4 | 0;
          i4 = c2[h2 >> 2] | 0;
          f2 = i4 - e3 | 0;
          g3 = f2 >> 2;
          a3 = b3 + (g3 << 2) | 0;
          if (a3 >>> 0 < d2 >>> 0) {
            e3 = i4;
            do {
              c2[e3 >> 2] = c2[a3 >> 2];
              a3 = a3 + 4 | 0;
              e3 = (c2[h2 >> 2] | 0) + 4 | 0;
              c2[h2 >> 2] = e3;
            } while (a3 >>> 0 < d2 >>> 0);
          }
          if (g3 | 0)
            GC(i4 + (0 - g3 << 2) | 0, b3 | 0, f2 | 0) | 0;
          return;
        }
        function ff(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          var e3 = 0, f2 = 0, g3 = 0, h2 = 0, i4 = 0, j2 = 0;
          i4 = b3 + 4 | 0;
          j2 = c2[i4 >> 2] | 0;
          f2 = c2[a3 >> 2] | 0;
          h2 = d2;
          g3 = h2 - f2 | 0;
          e3 = j2 + (0 - (g3 >> 2) << 2) | 0;
          c2[i4 >> 2] = e3;
          if ((g3 | 0) > 0)
            BC(e3 | 0, f2 | 0, g3 | 0) | 0;
          f2 = a3 + 4 | 0;
          g3 = b3 + 8 | 0;
          e3 = (c2[f2 >> 2] | 0) - h2 | 0;
          if ((e3 | 0) > 0) {
            BC(c2[g3 >> 2] | 0, d2 | 0, e3 | 0) | 0;
            c2[g3 >> 2] = (c2[g3 >> 2] | 0) + (e3 >>> 2 << 2);
          }
          h2 = c2[a3 >> 2] | 0;
          c2[a3 >> 2] = c2[i4 >> 2];
          c2[i4 >> 2] = h2;
          h2 = c2[f2 >> 2] | 0;
          c2[f2 >> 2] = c2[g3 >> 2];
          c2[g3 >> 2] = h2;
          h2 = a3 + 8 | 0;
          d2 = b3 + 12 | 0;
          a3 = c2[h2 >> 2] | 0;
          c2[h2 >> 2] = c2[d2 >> 2];
          c2[d2 >> 2] = a3;
          c2[b3 >> 2] = c2[i4 >> 2];
          return j2 | 0;
        }
        function gf(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          var e3 = 0, f2 = 0, g3 = 0, h2 = 0;
          h2 = c2[b3 >> 2] | 0;
          g3 = c2[d2 >> 2] | 0;
          if ((h2 | 0) != (g3 | 0)) {
            f2 = a3 + 8 | 0;
            d2 = ((g3 + -4 - h2 | 0) >>> 2) + 1 | 0;
            a3 = h2;
            e3 = c2[f2 >> 2] | 0;
            do {
              c2[e3 >> 2] = c2[a3 >> 2];
              e3 = (c2[f2 >> 2] | 0) + 4 | 0;
              c2[f2 >> 2] = e3;
              a3 = a3 + 4 | 0;
            } while ((a3 | 0) != (g3 | 0));
            c2[b3 >> 2] = h2 + (d2 << 2);
          }
          return;
        }
        function hf() {
          Qb();
          return;
        }
        function jf() {
          var a3 = 0;
          a3 = qC(4) | 0;
          kf(a3);
          return a3 | 0;
        }
        function kf(a3) {
          a3 = a3 | 0;
          c2[a3 >> 2] = gc() | 0;
          return;
        }
        function lf(a3) {
          a3 = a3 | 0;
          if (a3 | 0) {
            mf(a3);
            sC(a3);
          }
          return;
        }
        function mf(a3) {
          a3 = a3 | 0;
          ic(c2[a3 >> 2] | 0);
          return;
        }
        function nf(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          he(c2[a3 >> 2] | 0, b3, d2);
          return;
        }
        function of(a3, b3) {
          a3 = a3 | 0;
          b3 = T(b3);
          Zd(c2[a3 >> 2] | 0, b3);
          return;
        }
        function pf(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          return Ye(c2[a3 >> 2] | 0, b3) | 0;
        }
        function qf() {
          var a3 = 0;
          a3 = qC(8) | 0;
          rf(a3, 0);
          return a3 | 0;
        }
        function rf(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          if (!b3)
            b3 = Wb() | 0;
          else
            b3 = Ub(c2[b3 >> 2] | 0) | 0;
          c2[a3 >> 2] = b3;
          c2[a3 + 4 >> 2] = 0;
          vc(b3, a3);
          return;
        }
        function sf(a3) {
          a3 = a3 | 0;
          var b3 = 0;
          b3 = qC(8) | 0;
          rf(b3, a3);
          return b3 | 0;
        }
        function tf(a3) {
          a3 = a3 | 0;
          if (a3 | 0) {
            uf(a3);
            sC(a3);
          }
          return;
        }
        function uf(a3) {
          a3 = a3 | 0;
          var b3 = 0;
          Zb(c2[a3 >> 2] | 0);
          b3 = a3 + 4 | 0;
          a3 = c2[b3 >> 2] | 0;
          c2[b3 >> 2] = 0;
          if (a3 | 0) {
            vf(a3);
            sC(a3);
          }
          return;
        }
        function vf(a3) {
          a3 = a3 | 0;
          wf(a3);
          return;
        }
        function wf(a3) {
          a3 = a3 | 0;
          a3 = c2[a3 >> 2] | 0;
          if (a3 | 0)
            ab(a3 | 0);
          return;
        }
        function xf(a3) {
          a3 = a3 | 0;
          return wc(a3) | 0;
        }
        function yf(a3) {
          a3 = a3 | 0;
          var b3 = 0, d2 = 0;
          d2 = a3 + 4 | 0;
          b3 = c2[d2 >> 2] | 0;
          c2[d2 >> 2] = 0;
          if (b3 | 0) {
            vf(b3);
            sC(b3);
          }
          dc(c2[a3 >> 2] | 0);
          return;
        }
        function zf(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          sc(c2[a3 >> 2] | 0, c2[b3 >> 2] | 0);
          return;
        }
        function Af(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          Hc(c2[a3 >> 2] | 0, b3);
          return;
        }
        function Bf(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = +d2;
          Vc(c2[a3 >> 2] | 0, b3, T(d2));
          return;
        }
        function Cf(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = +d2;
          Wc(c2[a3 >> 2] | 0, b3, T(d2));
          return;
        }
        function Df(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          Bc(c2[a3 >> 2] | 0, b3);
          return;
        }
        function Ef(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          Dc(c2[a3 >> 2] | 0, b3);
          return;
        }
        function Ff(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          Fc(c2[a3 >> 2] | 0, b3);
          return;
        }
        function Gf(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          xc(c2[a3 >> 2] | 0, b3);
          return;
        }
        function Hf(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          Jc(c2[a3 >> 2] | 0, b3);
          return;
        }
        function If(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          zc(c2[a3 >> 2] | 0, b3);
          return;
        }
        function Jf(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = +d2;
          Yc(c2[a3 >> 2] | 0, b3, T(d2));
          return;
        }
        function Kf(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = +d2;
          Zc(c2[a3 >> 2] | 0, b3, T(d2));
          return;
        }
        function Lf(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          $c(c2[a3 >> 2] | 0, b3);
          return;
        }
        function Mf(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          Lc(c2[a3 >> 2] | 0, b3);
          return;
        }
        function Nf(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          Nc(c2[a3 >> 2] | 0, b3);
          return;
        }
        function Of(a3, b3) {
          a3 = a3 | 0;
          b3 = +b3;
          Pc(c2[a3 >> 2] | 0, T(b3));
          return;
        }
        function Pf(a3, b3) {
          a3 = a3 | 0;
          b3 = +b3;
          Sc(c2[a3 >> 2] | 0, T(b3));
          return;
        }
        function Qf(a3, b3) {
          a3 = a3 | 0;
          b3 = +b3;
          Tc(c2[a3 >> 2] | 0, T(b3));
          return;
        }
        function Rf(a3, b3) {
          a3 = a3 | 0;
          b3 = +b3;
          Qc(c2[a3 >> 2] | 0, T(b3));
          return;
        }
        function Sf(a3, b3) {
          a3 = a3 | 0;
          b3 = +b3;
          Rc(c2[a3 >> 2] | 0, T(b3));
          return;
        }
        function Tf(a3, b3) {
          a3 = a3 | 0;
          b3 = +b3;
          fd(c2[a3 >> 2] | 0, T(b3));
          return;
        }
        function Uf(a3, b3) {
          a3 = a3 | 0;
          b3 = +b3;
          gd(c2[a3 >> 2] | 0, T(b3));
          return;
        }
        function Vf(a3) {
          a3 = a3 | 0;
          hd(c2[a3 >> 2] | 0);
          return;
        }
        function Wf(a3, b3) {
          a3 = a3 | 0;
          b3 = +b3;
          jd(c2[a3 >> 2] | 0, T(b3));
          return;
        }
        function Xf(a3, b3) {
          a3 = a3 | 0;
          b3 = +b3;
          kd(c2[a3 >> 2] | 0, T(b3));
          return;
        }
        function Yf(a3) {
          a3 = a3 | 0;
          ld(c2[a3 >> 2] | 0);
          return;
        }
        function Zf(a3, b3) {
          a3 = a3 | 0;
          b3 = +b3;
          nd(c2[a3 >> 2] | 0, T(b3));
          return;
        }
        function _f(a3, b3) {
          a3 = a3 | 0;
          b3 = +b3;
          od(c2[a3 >> 2] | 0, T(b3));
          return;
        }
        function $f(a3, b3) {
          a3 = a3 | 0;
          b3 = +b3;
          qd(c2[a3 >> 2] | 0, T(b3));
          return;
        }
        function ag(a3, b3) {
          a3 = a3 | 0;
          b3 = +b3;
          rd(c2[a3 >> 2] | 0, T(b3));
          return;
        }
        function bg(a3, b3) {
          a3 = a3 | 0;
          b3 = +b3;
          td(c2[a3 >> 2] | 0, T(b3));
          return;
        }
        function cg(a3, b3) {
          a3 = a3 | 0;
          b3 = +b3;
          ud(c2[a3 >> 2] | 0, T(b3));
          return;
        }
        function dg(a3, b3) {
          a3 = a3 | 0;
          b3 = +b3;
          wd(c2[a3 >> 2] | 0, T(b3));
          return;
        }
        function eg(a3, b3) {
          a3 = a3 | 0;
          b3 = +b3;
          xd(c2[a3 >> 2] | 0, T(b3));
          return;
        }
        function fg(a3, b3) {
          a3 = a3 | 0;
          b3 = +b3;
          zd(c2[a3 >> 2] | 0, T(b3));
          return;
        }
        function gg(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = +d2;
          dd(c2[a3 >> 2] | 0, b3, T(d2));
          return;
        }
        function hg(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = +d2;
          ad(c2[a3 >> 2] | 0, b3, T(d2));
          return;
        }
        function ig(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = +d2;
          bd(c2[a3 >> 2] | 0, b3, T(d2));
          return;
        }
        function jg(a3) {
          a3 = a3 | 0;
          return Ic(c2[a3 >> 2] | 0) | 0;
        }
        function kg(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          var e3 = 0, f2 = 0;
          e3 = l2;
          l2 = l2 + 16 | 0;
          f2 = e3;
          Xc(f2, c2[b3 >> 2] | 0, d2);
          lg(a3, f2);
          l2 = e3;
          return;
        }
        function lg(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          mg(a3, c2[b3 + 4 >> 2] | 0, +T(g2[b3 >> 2]));
          return;
        }
        function mg(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = +d2;
          c2[a3 >> 2] = b3;
          h[a3 + 8 >> 3] = d2;
          return;
        }
        function ng(a3) {
          a3 = a3 | 0;
          return Cc(c2[a3 >> 2] | 0) | 0;
        }
        function og(a3) {
          a3 = a3 | 0;
          return Ec(c2[a3 >> 2] | 0) | 0;
        }
        function pg(a3) {
          a3 = a3 | 0;
          return Gc(c2[a3 >> 2] | 0) | 0;
        }
        function qg(a3) {
          a3 = a3 | 0;
          return yc(c2[a3 >> 2] | 0) | 0;
        }
        function rg(a3) {
          a3 = a3 | 0;
          return Kc(c2[a3 >> 2] | 0) | 0;
        }
        function sg(a3) {
          a3 = a3 | 0;
          return Ac(c2[a3 >> 2] | 0) | 0;
        }
        function tg(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          var e3 = 0, f2 = 0;
          e3 = l2;
          l2 = l2 + 16 | 0;
          f2 = e3;
          _c(f2, c2[b3 >> 2] | 0, d2);
          lg(a3, f2);
          l2 = e3;
          return;
        }
        function ug(a3) {
          a3 = a3 | 0;
          return Mc(c2[a3 >> 2] | 0) | 0;
        }
        function vg(a3) {
          a3 = a3 | 0;
          return Oc(c2[a3 >> 2] | 0) | 0;
        }
        function wg(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          var d2 = 0, e3 = 0;
          d2 = l2;
          l2 = l2 + 16 | 0;
          e3 = d2;
          Uc(e3, c2[b3 >> 2] | 0);
          lg(a3, e3);
          l2 = d2;
          return;
        }
        function xg(a3) {
          a3 = a3 | 0;
          return + +T(tc(c2[a3 >> 2] | 0));
        }
        function yg(a3) {
          a3 = a3 | 0;
          return + +T(uc(c2[a3 >> 2] | 0));
        }
        function zg(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          var d2 = 0, e3 = 0;
          d2 = l2;
          l2 = l2 + 16 | 0;
          e3 = d2;
          id(e3, c2[b3 >> 2] | 0);
          lg(a3, e3);
          l2 = d2;
          return;
        }
        function Ag(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          var d2 = 0, e3 = 0;
          d2 = l2;
          l2 = l2 + 16 | 0;
          e3 = d2;
          md(e3, c2[b3 >> 2] | 0);
          lg(a3, e3);
          l2 = d2;
          return;
        }
        function Bg(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          var d2 = 0, e3 = 0;
          d2 = l2;
          l2 = l2 + 16 | 0;
          e3 = d2;
          pd(e3, c2[b3 >> 2] | 0);
          lg(a3, e3);
          l2 = d2;
          return;
        }
        function Cg(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          var d2 = 0, e3 = 0;
          d2 = l2;
          l2 = l2 + 16 | 0;
          e3 = d2;
          sd(e3, c2[b3 >> 2] | 0);
          lg(a3, e3);
          l2 = d2;
          return;
        }
        function Dg(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          var d2 = 0, e3 = 0;
          d2 = l2;
          l2 = l2 + 16 | 0;
          e3 = d2;
          vd(e3, c2[b3 >> 2] | 0);
          lg(a3, e3);
          l2 = d2;
          return;
        }
        function Eg(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          var d2 = 0, e3 = 0;
          d2 = l2;
          l2 = l2 + 16 | 0;
          e3 = d2;
          yd(e3, c2[b3 >> 2] | 0);
          lg(a3, e3);
          l2 = d2;
          return;
        }
        function Fg(a3) {
          a3 = a3 | 0;
          return + +T(Ad(c2[a3 >> 2] | 0));
        }
        function Gg(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          return + +T(ed(c2[a3 >> 2] | 0, b3));
        }
        function Hg(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          var e3 = 0, f2 = 0;
          e3 = l2;
          l2 = l2 + 16 | 0;
          f2 = e3;
          cd(f2, c2[b3 >> 2] | 0, d2);
          lg(a3, f2);
          l2 = e3;
          return;
        }
        function Ig(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          kc(c2[a3 >> 2] | 0, c2[b3 >> 2] | 0, d2);
          return;
        }
        function Jg(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          cc(c2[a3 >> 2] | 0, c2[b3 >> 2] | 0);
          return;
        }
        function Kg(a3) {
          a3 = a3 | 0;
          return $b(c2[a3 >> 2] | 0) | 0;
        }
        function Lg(a3) {
          a3 = a3 | 0;
          a3 = pc(c2[a3 >> 2] | 0) | 0;
          if (!a3)
            a3 = 0;
          else
            a3 = xf(a3) | 0;
          return a3 | 0;
        }
        function Mg(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          a3 = ac(c2[a3 >> 2] | 0, b3) | 0;
          if (!a3)
            a3 = 0;
          else
            a3 = xf(a3) | 0;
          return a3 | 0;
        }
        function Ng(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          var d2 = 0, e3 = 0;
          e3 = qC(4) | 0;
          Og(e3, b3);
          d2 = a3 + 4 | 0;
          b3 = c2[d2 >> 2] | 0;
          c2[d2 >> 2] = e3;
          if (b3 | 0) {
            vf(b3);
            sC(b3);
          }
          jc(c2[a3 >> 2] | 0, 1);
          return;
        }
        function Og(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          gh(a3, b3);
          return;
        }
        function Pg(a3, b3, c3, d2, e3, f2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          c3 = T(c3);
          d2 = d2 | 0;
          e3 = T(e3);
          f2 = f2 | 0;
          var i4 = 0, j2 = 0;
          i4 = l2;
          l2 = l2 + 16 | 0;
          j2 = i4;
          Qg(j2, wc(b3) | 0, +c3, d2, +e3, f2);
          g2[a3 >> 2] = T(+h[j2 >> 3]);
          g2[a3 + 4 >> 2] = T(+h[j2 + 8 >> 3]);
          l2 = i4;
          return;
        }
        function Qg(a3, b3, d2, e3, f2, g3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = +d2;
          e3 = e3 | 0;
          f2 = +f2;
          g3 = g3 | 0;
          var i4 = 0, j2 = 0, k2 = 0, m2 = 0, n3 = 0;
          i4 = l2;
          l2 = l2 + 32 | 0;
          n3 = i4 + 8 | 0;
          m2 = i4 + 20 | 0;
          k2 = i4;
          j2 = i4 + 16 | 0;
          h[n3 >> 3] = d2;
          c2[m2 >> 2] = e3;
          h[k2 >> 3] = f2;
          c2[j2 >> 2] = g3;
          Rg(a3, c2[b3 + 4 >> 2] | 0, n3, m2, k2, j2);
          l2 = i4;
          return;
        }
        function Rg(a3, b3, d2, e3, f2, g3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          e3 = e3 | 0;
          f2 = f2 | 0;
          g3 = g3 | 0;
          var i4 = 0, j2 = 0;
          i4 = l2;
          l2 = l2 + 16 | 0;
          j2 = i4;
          UA(j2);
          b3 = Sg(b3) | 0;
          Tg(a3, b3, +h[d2 >> 3], c2[e3 >> 2] | 0, +h[f2 >> 3], c2[g3 >> 2] | 0);
          WA(j2);
          l2 = i4;
          return;
        }
        function Sg(a3) {
          a3 = a3 | 0;
          return c2[a3 >> 2] | 0;
        }
        function Tg(a3, b3, c3, d2, e3, f2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          c3 = +c3;
          d2 = d2 | 0;
          e3 = +e3;
          f2 = f2 | 0;
          var g3 = 0;
          g3 = Vg(Ug() | 0) | 0;
          c3 = +Wg(c3);
          d2 = Xg(d2) | 0;
          e3 = +Wg(e3);
          Yg(a3, cb2(0, g3 | 0, b3 | 0, +c3, d2 | 0, +e3, Xg(f2) | 0) | 0);
          return;
        }
        function Ug() {
          var b3 = 0;
          if (!(a2[7608] | 0)) {
            dh(9120);
            b3 = 7608;
            c2[b3 >> 2] = 1;
            c2[b3 + 4 >> 2] = 0;
          }
          return 9120;
        }
        function Vg(a3) {
          a3 = a3 | 0;
          return c2[a3 + 8 >> 2] | 0;
        }
        function Wg(a3) {
          a3 = +a3;
          return + +ch(a3);
        }
        function Xg(a3) {
          a3 = a3 | 0;
          return bh(a3) | 0;
        }
        function Yg(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          var d2 = 0, e3 = 0, f2 = 0;
          f2 = l2;
          l2 = l2 + 32 | 0;
          d2 = f2;
          e3 = b3;
          if (!(e3 & 1)) {
            c2[a3 >> 2] = c2[b3 >> 2];
            c2[a3 + 4 >> 2] = c2[b3 + 4 >> 2];
            c2[a3 + 8 >> 2] = c2[b3 + 8 >> 2];
            c2[a3 + 12 >> 2] = c2[b3 + 12 >> 2];
          } else {
            Zg(d2, 0);
            Ja(e3 | 0, d2 | 0) | 0;
            _g(a3, d2);
            $g(d2);
          }
          l2 = f2;
          return;
        }
        function Zg(b3, d2) {
          b3 = b3 | 0;
          d2 = d2 | 0;
          ah(b3, d2);
          c2[b3 + 8 >> 2] = 0;
          a2[b3 + 24 >> 0] = 0;
          return;
        }
        function _g(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          b3 = b3 + 8 | 0;
          c2[a3 >> 2] = c2[b3 >> 2];
          c2[a3 + 4 >> 2] = c2[b3 + 4 >> 2];
          c2[a3 + 8 >> 2] = c2[b3 + 8 >> 2];
          c2[a3 + 12 >> 2] = c2[b3 + 12 >> 2];
          return;
        }
        function $g(b3) {
          b3 = b3 | 0;
          a2[b3 + 24 >> 0] = 0;
          return;
        }
        function ah(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          c2[a3 >> 2] = b3;
          return;
        }
        function bh(a3) {
          a3 = a3 | 0;
          return a3 | 0;
        }
        function ch(a3) {
          a3 = +a3;
          return +a3;
        }
        function dh(a3) {
          a3 = a3 | 0;
          fh(a3, eh() | 0, 4);
          return;
        }
        function eh() {
          return 1064;
        }
        function fh(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          c2[a3 >> 2] = b3;
          c2[a3 + 4 >> 2] = d2;
          c2[a3 + 8 >> 2] = _a2(b3 | 0, d2 + 1 | 0) | 0;
          return;
        }
        function gh(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          b3 = c2[b3 >> 2] | 0;
          c2[a3 >> 2] = b3;
          Aa(b3 | 0);
          return;
        }
        function hh(a3) {
          a3 = a3 | 0;
          var b3 = 0, d2 = 0;
          d2 = a3 + 4 | 0;
          b3 = c2[d2 >> 2] | 0;
          c2[d2 >> 2] = 0;
          if (b3 | 0) {
            vf(b3);
            sC(b3);
          }
          jc(c2[a3 >> 2] | 0, 0);
          return;
        }
        function ih(a3) {
          a3 = a3 | 0;
          qc(c2[a3 >> 2] | 0);
          return;
        }
        function jh(a3) {
          a3 = a3 | 0;
          return rc(c2[a3 >> 2] | 0) | 0;
        }
        function kh(a3, b3, d2, e3) {
          a3 = a3 | 0;
          b3 = +b3;
          d2 = +d2;
          e3 = e3 | 0;
          _d(c2[a3 >> 2] | 0, T(b3), T(d2), e3);
          return;
        }
        function lh(a3) {
          a3 = a3 | 0;
          return + +T(Bd(c2[a3 >> 2] | 0));
        }
        function mh(a3) {
          a3 = a3 | 0;
          return + +T(Dd(c2[a3 >> 2] | 0));
        }
        function nh(a3) {
          a3 = a3 | 0;
          return + +T(Cd(c2[a3 >> 2] | 0));
        }
        function oh(a3) {
          a3 = a3 | 0;
          return + +T(Ed(c2[a3 >> 2] | 0));
        }
        function ph(a3) {
          a3 = a3 | 0;
          return + +T(Fd(c2[a3 >> 2] | 0));
        }
        function qh(a3) {
          a3 = a3 | 0;
          return + +T(Gd(c2[a3 >> 2] | 0));
        }
        function rh(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          h[a3 >> 3] = +T(Bd(c2[b3 >> 2] | 0));
          h[a3 + 8 >> 3] = +T(Dd(c2[b3 >> 2] | 0));
          h[a3 + 16 >> 3] = +T(Cd(c2[b3 >> 2] | 0));
          h[a3 + 24 >> 3] = +T(Ed(c2[b3 >> 2] | 0));
          h[a3 + 32 >> 3] = +T(Fd(c2[b3 >> 2] | 0));
          h[a3 + 40 >> 3] = +T(Gd(c2[b3 >> 2] | 0));
          return;
        }
        function sh(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          return + +T(Hd(c2[a3 >> 2] | 0, b3));
        }
        function th(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          return + +T(Id(c2[a3 >> 2] | 0, b3));
        }
        function uh(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          return + +T(Jd(c2[a3 >> 2] | 0, b3));
        }
        function vh() {
          return fc() | 0;
        }
        function wh() {
          xh();
          yh();
          zh();
          Ah();
          Bh();
          Ch();
          return;
        }
        function xh() {
          kv(11713, 4938, 1);
          return;
        }
        function yh() {
          yu(10448);
          return;
        }
        function zh() {
          eu(10408);
          return;
        }
        function Ah() {
          vt(10324);
          return;
        }
        function Bh() {
          or(10096);
          return;
        }
        function Ch() {
          Dh(9132);
          return;
        }
        function Dh(a3) {
          a3 = a3 | 0;
          var b3 = 0, d2 = 0, e3 = 0, f2 = 0, g3 = 0, h2 = 0, i4 = 0, j2 = 0, k2 = 0, m2 = 0, n3 = 0, o3 = 0, p2 = 0, q2 = 0, r3 = 0, s3 = 0, t3 = 0, u3 = 0, v2 = 0, w2 = 0, x2 = 0, y3 = 0, z2 = 0, A2 = 0, B2 = 0, C2 = 0, D2 = 0, E2 = 0, F2 = 0, G2 = 0, H2 = 0, I2 = 0, J2 = 0, K2 = 0, L2 = 0, M2 = 0, N2 = 0, O2 = 0, P2 = 0, Q2 = 0, R2 = 0, S2 = 0, T2 = 0, U2 = 0, V2 = 0, W2 = 0, X2 = 0, Y2 = 0, Z2 = 0, _2 = 0, $2 = 0, aa2 = 0, ba2 = 0, ca2 = 0, da2 = 0, ea2 = 0, fa2 = 0, ga2 = 0, ha2 = 0, ia2 = 0, ja2 = 0, ka2 = 0, la2 = 0, ma2 = 0, na2 = 0, oa2 = 0, pa2 = 0, qa2 = 0, ra2 = 0, sa2 = 0, ta2 = 0, ua2 = 0, va2 = 0, wa2 = 0, xa2 = 0, ya2 = 0, za2 = 0, Aa2 = 0, Ba2 = 0, Ca2 = 0, Da2 = 0, Ea2 = 0, Fa2 = 0, Ga2 = 0;
          b3 = l2;
          l2 = l2 + 672 | 0;
          d2 = b3 + 656 | 0;
          Ga2 = b3 + 648 | 0;
          Fa2 = b3 + 640 | 0;
          Ea2 = b3 + 632 | 0;
          Da2 = b3 + 624 | 0;
          Ca2 = b3 + 616 | 0;
          Ba2 = b3 + 608 | 0;
          Aa2 = b3 + 600 | 0;
          za2 = b3 + 592 | 0;
          ya2 = b3 + 584 | 0;
          xa2 = b3 + 576 | 0;
          wa2 = b3 + 568 | 0;
          va2 = b3 + 560 | 0;
          ua2 = b3 + 552 | 0;
          ta2 = b3 + 544 | 0;
          sa2 = b3 + 536 | 0;
          ra2 = b3 + 528 | 0;
          qa2 = b3 + 520 | 0;
          pa2 = b3 + 512 | 0;
          oa2 = b3 + 504 | 0;
          na2 = b3 + 496 | 0;
          ma2 = b3 + 488 | 0;
          la2 = b3 + 480 | 0;
          ka2 = b3 + 472 | 0;
          ja2 = b3 + 464 | 0;
          ia2 = b3 + 456 | 0;
          ha2 = b3 + 448 | 0;
          ga2 = b3 + 440 | 0;
          fa2 = b3 + 432 | 0;
          ea2 = b3 + 424 | 0;
          da2 = b3 + 416 | 0;
          ca2 = b3 + 408 | 0;
          ba2 = b3 + 400 | 0;
          aa2 = b3 + 392 | 0;
          $2 = b3 + 384 | 0;
          _2 = b3 + 376 | 0;
          Z2 = b3 + 368 | 0;
          Y2 = b3 + 360 | 0;
          X2 = b3 + 352 | 0;
          W2 = b3 + 344 | 0;
          V2 = b3 + 336 | 0;
          U2 = b3 + 328 | 0;
          T2 = b3 + 320 | 0;
          S2 = b3 + 312 | 0;
          R2 = b3 + 304 | 0;
          Q2 = b3 + 296 | 0;
          P2 = b3 + 288 | 0;
          O2 = b3 + 280 | 0;
          N2 = b3 + 272 | 0;
          M2 = b3 + 264 | 0;
          L2 = b3 + 256 | 0;
          K2 = b3 + 248 | 0;
          J2 = b3 + 240 | 0;
          I2 = b3 + 232 | 0;
          H2 = b3 + 224 | 0;
          G2 = b3 + 216 | 0;
          F2 = b3 + 208 | 0;
          E2 = b3 + 200 | 0;
          D2 = b3 + 192 | 0;
          C2 = b3 + 184 | 0;
          B2 = b3 + 176 | 0;
          A2 = b3 + 168 | 0;
          z2 = b3 + 160 | 0;
          y3 = b3 + 152 | 0;
          x2 = b3 + 144 | 0;
          w2 = b3 + 136 | 0;
          v2 = b3 + 128 | 0;
          u3 = b3 + 120 | 0;
          t3 = b3 + 112 | 0;
          s3 = b3 + 104 | 0;
          r3 = b3 + 96 | 0;
          q2 = b3 + 88 | 0;
          p2 = b3 + 80 | 0;
          o3 = b3 + 72 | 0;
          n3 = b3 + 64 | 0;
          m2 = b3 + 56 | 0;
          k2 = b3 + 48 | 0;
          j2 = b3 + 40 | 0;
          i4 = b3 + 32 | 0;
          h2 = b3 + 24 | 0;
          g3 = b3 + 16 | 0;
          f2 = b3 + 8 | 0;
          e3 = b3;
          Eh(a3, 3646);
          Fh(a3, 3651, 2) | 0;
          Gh(a3, 3665, 2) | 0;
          Hh(a3, 3682, 18) | 0;
          c2[Ga2 >> 2] = 19;
          c2[Ga2 + 4 >> 2] = 0;
          c2[d2 >> 2] = c2[Ga2 >> 2];
          c2[d2 + 4 >> 2] = c2[Ga2 + 4 >> 2];
          Ih(a3, 3690, d2) | 0;
          c2[Fa2 >> 2] = 1;
          c2[Fa2 + 4 >> 2] = 0;
          c2[d2 >> 2] = c2[Fa2 >> 2];
          c2[d2 + 4 >> 2] = c2[Fa2 + 4 >> 2];
          Jh(a3, 3696, d2) | 0;
          c2[Ea2 >> 2] = 2;
          c2[Ea2 + 4 >> 2] = 0;
          c2[d2 >> 2] = c2[Ea2 >> 2];
          c2[d2 + 4 >> 2] = c2[Ea2 + 4 >> 2];
          Kh(a3, 3706, d2) | 0;
          c2[Da2 >> 2] = 1;
          c2[Da2 + 4 >> 2] = 0;
          c2[d2 >> 2] = c2[Da2 >> 2];
          c2[d2 + 4 >> 2] = c2[Da2 + 4 >> 2];
          Lh(a3, 3722, d2) | 0;
          c2[Ca2 >> 2] = 2;
          c2[Ca2 + 4 >> 2] = 0;
          c2[d2 >> 2] = c2[Ca2 >> 2];
          c2[d2 + 4 >> 2] = c2[Ca2 + 4 >> 2];
          Lh(a3, 3734, d2) | 0;
          c2[Ba2 >> 2] = 3;
          c2[Ba2 + 4 >> 2] = 0;
          c2[d2 >> 2] = c2[Ba2 >> 2];
          c2[d2 + 4 >> 2] = c2[Ba2 + 4 >> 2];
          Kh(a3, 3753, d2) | 0;
          c2[Aa2 >> 2] = 4;
          c2[Aa2 + 4 >> 2] = 0;
          c2[d2 >> 2] = c2[Aa2 >> 2];
          c2[d2 + 4 >> 2] = c2[Aa2 + 4 >> 2];
          Kh(a3, 3769, d2) | 0;
          c2[za2 >> 2] = 5;
          c2[za2 + 4 >> 2] = 0;
          c2[d2 >> 2] = c2[za2 >> 2];
          c2[d2 + 4 >> 2] = c2[za2 + 4 >> 2];
          Kh(a3, 3783, d2) | 0;
          c2[ya2 >> 2] = 6;
          c2[ya2 + 4 >> 2] = 0;
          c2[d2 >> 2] = c2[ya2 >> 2];
          c2[d2 + 4 >> 2] = c2[ya2 + 4 >> 2];
          Kh(a3, 3796, d2) | 0;
          c2[xa2 >> 2] = 7;
          c2[xa2 + 4 >> 2] = 0;
          c2[d2 >> 2] = c2[xa2 >> 2];
          c2[d2 + 4 >> 2] = c2[xa2 + 4 >> 2];
          Kh(a3, 3813, d2) | 0;
          c2[wa2 >> 2] = 8;
          c2[wa2 + 4 >> 2] = 0;
          c2[d2 >> 2] = c2[wa2 >> 2];
          c2[d2 + 4 >> 2] = c2[wa2 + 4 >> 2];
          Kh(a3, 3825, d2) | 0;
          c2[va2 >> 2] = 3;
          c2[va2 + 4 >> 2] = 0;
          c2[d2 >> 2] = c2[va2 >> 2];
          c2[d2 + 4 >> 2] = c2[va2 + 4 >> 2];
          Lh(a3, 3843, d2) | 0;
          c2[ua2 >> 2] = 4;
          c2[ua2 + 4 >> 2] = 0;
          c2[d2 >> 2] = c2[ua2 >> 2];
          c2[d2 + 4 >> 2] = c2[ua2 + 4 >> 2];
          Lh(a3, 3853, d2) | 0;
          c2[ta2 >> 2] = 9;
          c2[ta2 + 4 >> 2] = 0;
          c2[d2 >> 2] = c2[ta2 >> 2];
          c2[d2 + 4 >> 2] = c2[ta2 + 4 >> 2];
          Kh(a3, 3870, d2) | 0;
          c2[sa2 >> 2] = 10;
          c2[sa2 + 4 >> 2] = 0;
          c2[d2 >> 2] = c2[sa2 >> 2];
          c2[d2 + 4 >> 2] = c2[sa2 + 4 >> 2];
          Kh(a3, 3884, d2) | 0;
          c2[ra2 >> 2] = 11;
          c2[ra2 + 4 >> 2] = 0;
          c2[d2 >> 2] = c2[ra2 >> 2];
          c2[d2 + 4 >> 2] = c2[ra2 + 4 >> 2];
          Kh(a3, 3896, d2) | 0;
          c2[qa2 >> 2] = 1;
          c2[qa2 + 4 >> 2] = 0;
          c2[d2 >> 2] = c2[qa2 >> 2];
          c2[d2 + 4 >> 2] = c2[qa2 + 4 >> 2];
          Mh(a3, 3907, d2) | 0;
          c2[pa2 >> 2] = 2;
          c2[pa2 + 4 >> 2] = 0;
          c2[d2 >> 2] = c2[pa2 >> 2];
          c2[d2 + 4 >> 2] = c2[pa2 + 4 >> 2];
          Mh(a3, 3915, d2) | 0;
          c2[oa2 >> 2] = 3;
          c2[oa2 + 4 >> 2] = 0;
          c2[d2 >> 2] = c2[oa2 >> 2];
          c2[d2 + 4 >> 2] = c2[oa2 + 4 >> 2];
          Mh(a3, 3928, d2) | 0;
          c2[na2 >> 2] = 4;
          c2[na2 + 4 >> 2] = 0;
          c2[d2 >> 2] = c2[na2 >> 2];
          c2[d2 + 4 >> 2] = c2[na2 + 4 >> 2];
          Mh(a3, 3948, d2) | 0;
          c2[ma2 >> 2] = 5;
          c2[ma2 + 4 >> 2] = 0;
          c2[d2 >> 2] = c2[ma2 >> 2];
          c2[d2 + 4 >> 2] = c2[ma2 + 4 >> 2];
          Mh(a3, 3960, d2) | 0;
          c2[la2 >> 2] = 6;
          c2[la2 + 4 >> 2] = 0;
          c2[d2 >> 2] = c2[la2 >> 2];
          c2[d2 + 4 >> 2] = c2[la2 + 4 >> 2];
          Mh(a3, 3974, d2) | 0;
          c2[ka2 >> 2] = 7;
          c2[ka2 + 4 >> 2] = 0;
          c2[d2 >> 2] = c2[ka2 >> 2];
          c2[d2 + 4 >> 2] = c2[ka2 + 4 >> 2];
          Mh(a3, 3983, d2) | 0;
          c2[ja2 >> 2] = 20;
          c2[ja2 + 4 >> 2] = 0;
          c2[d2 >> 2] = c2[ja2 >> 2];
          c2[d2 + 4 >> 2] = c2[ja2 + 4 >> 2];
          Ih(a3, 3999, d2) | 0;
          c2[ia2 >> 2] = 8;
          c2[ia2 + 4 >> 2] = 0;
          c2[d2 >> 2] = c2[ia2 >> 2];
          c2[d2 + 4 >> 2] = c2[ia2 + 4 >> 2];
          Mh(a3, 4012, d2) | 0;
          c2[ha2 >> 2] = 9;
          c2[ha2 + 4 >> 2] = 0;
          c2[d2 >> 2] = c2[ha2 >> 2];
          c2[d2 + 4 >> 2] = c2[ha2 + 4 >> 2];
          Mh(a3, 4022, d2) | 0;
          c2[ga2 >> 2] = 21;
          c2[ga2 + 4 >> 2] = 0;
          c2[d2 >> 2] = c2[ga2 >> 2];
          c2[d2 + 4 >> 2] = c2[ga2 + 4 >> 2];
          Ih(a3, 4039, d2) | 0;
          c2[fa2 >> 2] = 10;
          c2[fa2 + 4 >> 2] = 0;
          c2[d2 >> 2] = c2[fa2 >> 2];
          c2[d2 + 4 >> 2] = c2[fa2 + 4 >> 2];
          Mh(a3, 4053, d2) | 0;
          c2[ea2 >> 2] = 11;
          c2[ea2 + 4 >> 2] = 0;
          c2[d2 >> 2] = c2[ea2 >> 2];
          c2[d2 + 4 >> 2] = c2[ea2 + 4 >> 2];
          Mh(a3, 4065, d2) | 0;
          c2[da2 >> 2] = 12;
          c2[da2 + 4 >> 2] = 0;
          c2[d2 >> 2] = c2[da2 >> 2];
          c2[d2 + 4 >> 2] = c2[da2 + 4 >> 2];
          Mh(a3, 4084, d2) | 0;
          c2[ca2 >> 2] = 13;
          c2[ca2 + 4 >> 2] = 0;
          c2[d2 >> 2] = c2[ca2 >> 2];
          c2[d2 + 4 >> 2] = c2[ca2 + 4 >> 2];
          Mh(a3, 4097, d2) | 0;
          c2[ba2 >> 2] = 14;
          c2[ba2 + 4 >> 2] = 0;
          c2[d2 >> 2] = c2[ba2 >> 2];
          c2[d2 + 4 >> 2] = c2[ba2 + 4 >> 2];
          Mh(a3, 4117, d2) | 0;
          c2[aa2 >> 2] = 15;
          c2[aa2 + 4 >> 2] = 0;
          c2[d2 >> 2] = c2[aa2 >> 2];
          c2[d2 + 4 >> 2] = c2[aa2 + 4 >> 2];
          Mh(a3, 4129, d2) | 0;
          c2[$2 >> 2] = 16;
          c2[$2 + 4 >> 2] = 0;
          c2[d2 >> 2] = c2[$2 >> 2];
          c2[d2 + 4 >> 2] = c2[$2 + 4 >> 2];
          Mh(a3, 4148, d2) | 0;
          c2[_2 >> 2] = 17;
          c2[_2 + 4 >> 2] = 0;
          c2[d2 >> 2] = c2[_2 >> 2];
          c2[d2 + 4 >> 2] = c2[_2 + 4 >> 2];
          Mh(a3, 4161, d2) | 0;
          c2[Z2 >> 2] = 18;
          c2[Z2 + 4 >> 2] = 0;
          c2[d2 >> 2] = c2[Z2 >> 2];
          c2[d2 + 4 >> 2] = c2[Z2 + 4 >> 2];
          Mh(a3, 4181, d2) | 0;
          c2[Y2 >> 2] = 5;
          c2[Y2 + 4 >> 2] = 0;
          c2[d2 >> 2] = c2[Y2 >> 2];
          c2[d2 + 4 >> 2] = c2[Y2 + 4 >> 2];
          Lh(a3, 4196, d2) | 0;
          c2[X2 >> 2] = 6;
          c2[X2 + 4 >> 2] = 0;
          c2[d2 >> 2] = c2[X2 >> 2];
          c2[d2 + 4 >> 2] = c2[X2 + 4 >> 2];
          Lh(a3, 4206, d2) | 0;
          c2[W2 >> 2] = 7;
          c2[W2 + 4 >> 2] = 0;
          c2[d2 >> 2] = c2[W2 >> 2];
          c2[d2 + 4 >> 2] = c2[W2 + 4 >> 2];
          Lh(a3, 4217, d2) | 0;
          c2[V2 >> 2] = 3;
          c2[V2 + 4 >> 2] = 0;
          c2[d2 >> 2] = c2[V2 >> 2];
          c2[d2 + 4 >> 2] = c2[V2 + 4 >> 2];
          Nh(a3, 4235, d2) | 0;
          c2[U2 >> 2] = 1;
          c2[U2 + 4 >> 2] = 0;
          c2[d2 >> 2] = c2[U2 >> 2];
          c2[d2 + 4 >> 2] = c2[U2 + 4 >> 2];
          Oh(a3, 4251, d2) | 0;
          c2[T2 >> 2] = 4;
          c2[T2 + 4 >> 2] = 0;
          c2[d2 >> 2] = c2[T2 >> 2];
          c2[d2 + 4 >> 2] = c2[T2 + 4 >> 2];
          Nh(a3, 4263, d2) | 0;
          c2[S2 >> 2] = 5;
          c2[S2 + 4 >> 2] = 0;
          c2[d2 >> 2] = c2[S2 >> 2];
          c2[d2 + 4 >> 2] = c2[S2 + 4 >> 2];
          Nh(a3, 4279, d2) | 0;
          c2[R2 >> 2] = 6;
          c2[R2 + 4 >> 2] = 0;
          c2[d2 >> 2] = c2[R2 >> 2];
          c2[d2 + 4 >> 2] = c2[R2 + 4 >> 2];
          Nh(a3, 4293, d2) | 0;
          c2[Q2 >> 2] = 7;
          c2[Q2 + 4 >> 2] = 0;
          c2[d2 >> 2] = c2[Q2 >> 2];
          c2[d2 + 4 >> 2] = c2[Q2 + 4 >> 2];
          Nh(a3, 4306, d2) | 0;
          c2[P2 >> 2] = 8;
          c2[P2 + 4 >> 2] = 0;
          c2[d2 >> 2] = c2[P2 >> 2];
          c2[d2 + 4 >> 2] = c2[P2 + 4 >> 2];
          Nh(a3, 4323, d2) | 0;
          c2[O2 >> 2] = 9;
          c2[O2 + 4 >> 2] = 0;
          c2[d2 >> 2] = c2[O2 >> 2];
          c2[d2 + 4 >> 2] = c2[O2 + 4 >> 2];
          Nh(a3, 4335, d2) | 0;
          c2[N2 >> 2] = 2;
          c2[N2 + 4 >> 2] = 0;
          c2[d2 >> 2] = c2[N2 >> 2];
          c2[d2 + 4 >> 2] = c2[N2 + 4 >> 2];
          Oh(a3, 4353, d2) | 0;
          c2[M2 >> 2] = 12;
          c2[M2 + 4 >> 2] = 0;
          c2[d2 >> 2] = c2[M2 >> 2];
          c2[d2 + 4 >> 2] = c2[M2 + 4 >> 2];
          Ph(a3, 4363, d2) | 0;
          c2[L2 >> 2] = 1;
          c2[L2 + 4 >> 2] = 0;
          c2[d2 >> 2] = c2[L2 >> 2];
          c2[d2 + 4 >> 2] = c2[L2 + 4 >> 2];
          Qh(a3, 4376, d2) | 0;
          c2[K2 >> 2] = 2;
          c2[K2 + 4 >> 2] = 0;
          c2[d2 >> 2] = c2[K2 >> 2];
          c2[d2 + 4 >> 2] = c2[K2 + 4 >> 2];
          Qh(a3, 4388, d2) | 0;
          c2[J2 >> 2] = 13;
          c2[J2 + 4 >> 2] = 0;
          c2[d2 >> 2] = c2[J2 >> 2];
          c2[d2 + 4 >> 2] = c2[J2 + 4 >> 2];
          Ph(a3, 4402, d2) | 0;
          c2[I2 >> 2] = 14;
          c2[I2 + 4 >> 2] = 0;
          c2[d2 >> 2] = c2[I2 >> 2];
          c2[d2 + 4 >> 2] = c2[I2 + 4 >> 2];
          Ph(a3, 4411, d2) | 0;
          c2[H2 >> 2] = 15;
          c2[H2 + 4 >> 2] = 0;
          c2[d2 >> 2] = c2[H2 >> 2];
          c2[d2 + 4 >> 2] = c2[H2 + 4 >> 2];
          Ph(a3, 4421, d2) | 0;
          c2[G2 >> 2] = 16;
          c2[G2 + 4 >> 2] = 0;
          c2[d2 >> 2] = c2[G2 >> 2];
          c2[d2 + 4 >> 2] = c2[G2 + 4 >> 2];
          Ph(a3, 4433, d2) | 0;
          c2[F2 >> 2] = 17;
          c2[F2 + 4 >> 2] = 0;
          c2[d2 >> 2] = c2[F2 >> 2];
          c2[d2 + 4 >> 2] = c2[F2 + 4 >> 2];
          Ph(a3, 4446, d2) | 0;
          c2[E2 >> 2] = 18;
          c2[E2 + 4 >> 2] = 0;
          c2[d2 >> 2] = c2[E2 >> 2];
          c2[d2 + 4 >> 2] = c2[E2 + 4 >> 2];
          Ph(a3, 4458, d2) | 0;
          c2[D2 >> 2] = 3;
          c2[D2 + 4 >> 2] = 0;
          c2[d2 >> 2] = c2[D2 >> 2];
          c2[d2 + 4 >> 2] = c2[D2 + 4 >> 2];
          Qh(a3, 4471, d2) | 0;
          c2[C2 >> 2] = 1;
          c2[C2 + 4 >> 2] = 0;
          c2[d2 >> 2] = c2[C2 >> 2];
          c2[d2 + 4 >> 2] = c2[C2 + 4 >> 2];
          Rh(a3, 4486, d2) | 0;
          c2[B2 >> 2] = 10;
          c2[B2 + 4 >> 2] = 0;
          c2[d2 >> 2] = c2[B2 >> 2];
          c2[d2 + 4 >> 2] = c2[B2 + 4 >> 2];
          Nh(a3, 4496, d2) | 0;
          c2[A2 >> 2] = 11;
          c2[A2 + 4 >> 2] = 0;
          c2[d2 >> 2] = c2[A2 >> 2];
          c2[d2 + 4 >> 2] = c2[A2 + 4 >> 2];
          Nh(a3, 4508, d2) | 0;
          c2[z2 >> 2] = 3;
          c2[z2 + 4 >> 2] = 0;
          c2[d2 >> 2] = c2[z2 >> 2];
          c2[d2 + 4 >> 2] = c2[z2 + 4 >> 2];
          Oh(a3, 4519, d2) | 0;
          c2[y3 >> 2] = 4;
          c2[y3 + 4 >> 2] = 0;
          c2[d2 >> 2] = c2[y3 >> 2];
          c2[d2 + 4 >> 2] = c2[y3 + 4 >> 2];
          Sh(a3, 4530, d2) | 0;
          c2[x2 >> 2] = 19;
          c2[x2 + 4 >> 2] = 0;
          c2[d2 >> 2] = c2[x2 >> 2];
          c2[d2 + 4 >> 2] = c2[x2 + 4 >> 2];
          Th(a3, 4542, d2) | 0;
          c2[w2 >> 2] = 12;
          c2[w2 + 4 >> 2] = 0;
          c2[d2 >> 2] = c2[w2 >> 2];
          c2[d2 + 4 >> 2] = c2[w2 + 4 >> 2];
          Uh(a3, 4554, d2) | 0;
          c2[v2 >> 2] = 13;
          c2[v2 + 4 >> 2] = 0;
          c2[d2 >> 2] = c2[v2 >> 2];
          c2[d2 + 4 >> 2] = c2[v2 + 4 >> 2];
          Vh(a3, 4568, d2) | 0;
          c2[u3 >> 2] = 2;
          c2[u3 + 4 >> 2] = 0;
          c2[d2 >> 2] = c2[u3 >> 2];
          c2[d2 + 4 >> 2] = c2[u3 + 4 >> 2];
          Wh(a3, 4578, d2) | 0;
          c2[t3 >> 2] = 20;
          c2[t3 + 4 >> 2] = 0;
          c2[d2 >> 2] = c2[t3 >> 2];
          c2[d2 + 4 >> 2] = c2[t3 + 4 >> 2];
          Xh(a3, 4587, d2) | 0;
          c2[s3 >> 2] = 22;
          c2[s3 + 4 >> 2] = 0;
          c2[d2 >> 2] = c2[s3 >> 2];
          c2[d2 + 4 >> 2] = c2[s3 + 4 >> 2];
          Ih(a3, 4602, d2) | 0;
          c2[r3 >> 2] = 23;
          c2[r3 + 4 >> 2] = 0;
          c2[d2 >> 2] = c2[r3 >> 2];
          c2[d2 + 4 >> 2] = c2[r3 + 4 >> 2];
          Ih(a3, 4619, d2) | 0;
          c2[q2 >> 2] = 14;
          c2[q2 + 4 >> 2] = 0;
          c2[d2 >> 2] = c2[q2 >> 2];
          c2[d2 + 4 >> 2] = c2[q2 + 4 >> 2];
          Yh(a3, 4629, d2) | 0;
          c2[p2 >> 2] = 1;
          c2[p2 + 4 >> 2] = 0;
          c2[d2 >> 2] = c2[p2 >> 2];
          c2[d2 + 4 >> 2] = c2[p2 + 4 >> 2];
          Zh(a3, 4637, d2) | 0;
          c2[o3 >> 2] = 4;
          c2[o3 + 4 >> 2] = 0;
          c2[d2 >> 2] = c2[o3 >> 2];
          c2[d2 + 4 >> 2] = c2[o3 + 4 >> 2];
          Qh(a3, 4653, d2) | 0;
          c2[n3 >> 2] = 5;
          c2[n3 + 4 >> 2] = 0;
          c2[d2 >> 2] = c2[n3 >> 2];
          c2[d2 + 4 >> 2] = c2[n3 + 4 >> 2];
          Qh(a3, 4669, d2) | 0;
          c2[m2 >> 2] = 6;
          c2[m2 + 4 >> 2] = 0;
          c2[d2 >> 2] = c2[m2 >> 2];
          c2[d2 + 4 >> 2] = c2[m2 + 4 >> 2];
          Qh(a3, 4686, d2) | 0;
          c2[k2 >> 2] = 7;
          c2[k2 + 4 >> 2] = 0;
          c2[d2 >> 2] = c2[k2 >> 2];
          c2[d2 + 4 >> 2] = c2[k2 + 4 >> 2];
          Qh(a3, 4701, d2) | 0;
          c2[j2 >> 2] = 8;
          c2[j2 + 4 >> 2] = 0;
          c2[d2 >> 2] = c2[j2 >> 2];
          c2[d2 + 4 >> 2] = c2[j2 + 4 >> 2];
          Qh(a3, 4719, d2) | 0;
          c2[i4 >> 2] = 9;
          c2[i4 + 4 >> 2] = 0;
          c2[d2 >> 2] = c2[i4 >> 2];
          c2[d2 + 4 >> 2] = c2[i4 + 4 >> 2];
          Qh(a3, 4736, d2) | 0;
          c2[h2 >> 2] = 21;
          c2[h2 + 4 >> 2] = 0;
          c2[d2 >> 2] = c2[h2 >> 2];
          c2[d2 + 4 >> 2] = c2[h2 + 4 >> 2];
          _h(a3, 4754, d2) | 0;
          c2[g3 >> 2] = 2;
          c2[g3 + 4 >> 2] = 0;
          c2[d2 >> 2] = c2[g3 >> 2];
          c2[d2 + 4 >> 2] = c2[g3 + 4 >> 2];
          Rh(a3, 4772, d2) | 0;
          c2[f2 >> 2] = 3;
          c2[f2 + 4 >> 2] = 0;
          c2[d2 >> 2] = c2[f2 >> 2];
          c2[d2 + 4 >> 2] = c2[f2 + 4 >> 2];
          Rh(a3, 4790, d2) | 0;
          c2[e3 >> 2] = 4;
          c2[e3 + 4 >> 2] = 0;
          c2[d2 >> 2] = c2[e3 >> 2];
          c2[d2 + 4 >> 2] = c2[e3 + 4 >> 2];
          Rh(a3, 4808, d2) | 0;
          l2 = b3;
          return;
        }
        function Eh(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          var d2 = 0;
          d2 = dr() | 0;
          c2[a3 >> 2] = d2;
          er(d2, b3);
          Hv(c2[a3 >> 2] | 0);
          return;
        }
        function Fh(a3, b3, c3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          c3 = c3 | 0;
          Oq(a3, ai(b3) | 0, c3, 0);
          return a3 | 0;
        }
        function Gh(a3, b3, c3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          c3 = c3 | 0;
          tq(a3, ai(b3) | 0, c3, 0);
          return a3 | 0;
        }
        function Hh(a3, b3, c3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          c3 = c3 | 0;
          cq(a3, ai(b3) | 0, c3, 0);
          return a3 | 0;
        }
        function Ih(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          var e3 = 0, f2 = 0, g3 = 0, h2 = 0;
          e3 = l2;
          l2 = l2 + 16 | 0;
          f2 = e3 + 8 | 0;
          g3 = e3;
          h2 = c2[d2 + 4 >> 2] | 0;
          c2[g3 >> 2] = c2[d2 >> 2];
          c2[g3 + 4 >> 2] = h2;
          c2[f2 >> 2] = c2[g3 >> 2];
          c2[f2 + 4 >> 2] = c2[g3 + 4 >> 2];
          Lp(a3, b3, f2);
          l2 = e3;
          return a3 | 0;
        }
        function Jh(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          var e3 = 0, f2 = 0, g3 = 0, h2 = 0;
          e3 = l2;
          l2 = l2 + 16 | 0;
          f2 = e3 + 8 | 0;
          g3 = e3;
          h2 = c2[d2 + 4 >> 2] | 0;
          c2[g3 >> 2] = c2[d2 >> 2];
          c2[g3 + 4 >> 2] = h2;
          c2[f2 >> 2] = c2[g3 >> 2];
          c2[f2 + 4 >> 2] = c2[g3 + 4 >> 2];
          pp(a3, b3, f2);
          l2 = e3;
          return a3 | 0;
        }
        function Kh(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          var e3 = 0, f2 = 0, g3 = 0, h2 = 0;
          e3 = l2;
          l2 = l2 + 16 | 0;
          f2 = e3 + 8 | 0;
          g3 = e3;
          h2 = c2[d2 + 4 >> 2] | 0;
          c2[g3 >> 2] = c2[d2 >> 2];
          c2[g3 + 4 >> 2] = h2;
          c2[f2 >> 2] = c2[g3 >> 2];
          c2[f2 + 4 >> 2] = c2[g3 + 4 >> 2];
          Yo(a3, b3, f2);
          l2 = e3;
          return a3 | 0;
        }
        function Lh(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          var e3 = 0, f2 = 0, g3 = 0, h2 = 0;
          e3 = l2;
          l2 = l2 + 16 | 0;
          f2 = e3 + 8 | 0;
          g3 = e3;
          h2 = c2[d2 + 4 >> 2] | 0;
          c2[g3 >> 2] = c2[d2 >> 2];
          c2[g3 + 4 >> 2] = h2;
          c2[f2 >> 2] = c2[g3 >> 2];
          c2[f2 + 4 >> 2] = c2[g3 + 4 >> 2];
          Fo(a3, b3, f2);
          l2 = e3;
          return a3 | 0;
        }
        function Mh(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          var e3 = 0, f2 = 0, g3 = 0, h2 = 0;
          e3 = l2;
          l2 = l2 + 16 | 0;
          f2 = e3 + 8 | 0;
          g3 = e3;
          h2 = c2[d2 + 4 >> 2] | 0;
          c2[g3 >> 2] = c2[d2 >> 2];
          c2[g3 + 4 >> 2] = h2;
          c2[f2 >> 2] = c2[g3 >> 2];
          c2[f2 + 4 >> 2] = c2[g3 + 4 >> 2];
          mo(a3, b3, f2);
          l2 = e3;
          return a3 | 0;
        }
        function Nh(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          var e3 = 0, f2 = 0, g3 = 0, h2 = 0;
          e3 = l2;
          l2 = l2 + 16 | 0;
          f2 = e3 + 8 | 0;
          g3 = e3;
          h2 = c2[d2 + 4 >> 2] | 0;
          c2[g3 >> 2] = c2[d2 >> 2];
          c2[g3 + 4 >> 2] = h2;
          c2[f2 >> 2] = c2[g3 >> 2];
          c2[f2 + 4 >> 2] = c2[g3 + 4 >> 2];
          Un(a3, b3, f2);
          l2 = e3;
          return a3 | 0;
        }
        function Oh(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          var e3 = 0, f2 = 0, g3 = 0, h2 = 0;
          e3 = l2;
          l2 = l2 + 16 | 0;
          f2 = e3 + 8 | 0;
          g3 = e3;
          h2 = c2[d2 + 4 >> 2] | 0;
          c2[g3 >> 2] = c2[d2 >> 2];
          c2[g3 + 4 >> 2] = h2;
          c2[f2 >> 2] = c2[g3 >> 2];
          c2[f2 + 4 >> 2] = c2[g3 + 4 >> 2];
          Bn(a3, b3, f2);
          l2 = e3;
          return a3 | 0;
        }
        function Ph(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          var e3 = 0, f2 = 0, g3 = 0, h2 = 0;
          e3 = l2;
          l2 = l2 + 16 | 0;
          f2 = e3 + 8 | 0;
          g3 = e3;
          h2 = c2[d2 + 4 >> 2] | 0;
          c2[g3 >> 2] = c2[d2 >> 2];
          c2[g3 + 4 >> 2] = h2;
          c2[f2 >> 2] = c2[g3 >> 2];
          c2[f2 + 4 >> 2] = c2[g3 + 4 >> 2];
          Um(a3, b3, f2);
          l2 = e3;
          return a3 | 0;
        }
        function Qh(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          var e3 = 0, f2 = 0, g3 = 0, h2 = 0;
          e3 = l2;
          l2 = l2 + 16 | 0;
          f2 = e3 + 8 | 0;
          g3 = e3;
          h2 = c2[d2 + 4 >> 2] | 0;
          c2[g3 >> 2] = c2[d2 >> 2];
          c2[g3 + 4 >> 2] = h2;
          c2[f2 >> 2] = c2[g3 >> 2];
          c2[f2 + 4 >> 2] = c2[g3 + 4 >> 2];
          Bm(a3, b3, f2);
          l2 = e3;
          return a3 | 0;
        }
        function Rh(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          var e3 = 0, f2 = 0, g3 = 0, h2 = 0;
          e3 = l2;
          l2 = l2 + 16 | 0;
          f2 = e3 + 8 | 0;
          g3 = e3;
          h2 = c2[d2 + 4 >> 2] | 0;
          c2[g3 >> 2] = c2[d2 >> 2];
          c2[g3 + 4 >> 2] = h2;
          c2[f2 >> 2] = c2[g3 >> 2];
          c2[f2 + 4 >> 2] = c2[g3 + 4 >> 2];
          im(a3, b3, f2);
          l2 = e3;
          return a3 | 0;
        }
        function Sh(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          var e3 = 0, f2 = 0, g3 = 0, h2 = 0;
          e3 = l2;
          l2 = l2 + 16 | 0;
          f2 = e3 + 8 | 0;
          g3 = e3;
          h2 = c2[d2 + 4 >> 2] | 0;
          c2[g3 >> 2] = c2[d2 >> 2];
          c2[g3 + 4 >> 2] = h2;
          c2[f2 >> 2] = c2[g3 >> 2];
          c2[f2 + 4 >> 2] = c2[g3 + 4 >> 2];
          Rl(a3, b3, f2);
          l2 = e3;
          return a3 | 0;
        }
        function Th(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          var e3 = 0, f2 = 0, g3 = 0, h2 = 0;
          e3 = l2;
          l2 = l2 + 16 | 0;
          f2 = e3 + 8 | 0;
          g3 = e3;
          h2 = c2[d2 + 4 >> 2] | 0;
          c2[g3 >> 2] = c2[d2 >> 2];
          c2[g3 + 4 >> 2] = h2;
          c2[f2 >> 2] = c2[g3 >> 2];
          c2[f2 + 4 >> 2] = c2[g3 + 4 >> 2];
          vl(a3, b3, f2);
          l2 = e3;
          return a3 | 0;
        }
        function Uh(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          var e3 = 0, f2 = 0, g3 = 0, h2 = 0;
          e3 = l2;
          l2 = l2 + 16 | 0;
          f2 = e3 + 8 | 0;
          g3 = e3;
          h2 = c2[d2 + 4 >> 2] | 0;
          c2[g3 >> 2] = c2[d2 >> 2];
          c2[g3 + 4 >> 2] = h2;
          c2[f2 >> 2] = c2[g3 >> 2];
          c2[f2 + 4 >> 2] = c2[g3 + 4 >> 2];
          bl(a3, b3, f2);
          l2 = e3;
          return a3 | 0;
        }
        function Vh(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          var e3 = 0, f2 = 0, g3 = 0, h2 = 0;
          e3 = l2;
          l2 = l2 + 16 | 0;
          f2 = e3 + 8 | 0;
          g3 = e3;
          h2 = c2[d2 + 4 >> 2] | 0;
          c2[g3 >> 2] = c2[d2 >> 2];
          c2[g3 + 4 >> 2] = h2;
          c2[f2 >> 2] = c2[g3 >> 2];
          c2[f2 + 4 >> 2] = c2[g3 + 4 >> 2];
          Kk(a3, b3, f2);
          l2 = e3;
          return a3 | 0;
        }
        function Wh(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          var e3 = 0, f2 = 0, g3 = 0, h2 = 0;
          e3 = l2;
          l2 = l2 + 16 | 0;
          f2 = e3 + 8 | 0;
          g3 = e3;
          h2 = c2[d2 + 4 >> 2] | 0;
          c2[g3 >> 2] = c2[d2 >> 2];
          c2[g3 + 4 >> 2] = h2;
          c2[f2 >> 2] = c2[g3 >> 2];
          c2[f2 + 4 >> 2] = c2[g3 + 4 >> 2];
          nk(a3, b3, f2);
          l2 = e3;
          return a3 | 0;
        }
        function Xh(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          var e3 = 0, f2 = 0, g3 = 0, h2 = 0;
          e3 = l2;
          l2 = l2 + 16 | 0;
          f2 = e3 + 8 | 0;
          g3 = e3;
          h2 = c2[d2 + 4 >> 2] | 0;
          c2[g3 >> 2] = c2[d2 >> 2];
          c2[g3 + 4 >> 2] = h2;
          c2[f2 >> 2] = c2[g3 >> 2];
          c2[f2 + 4 >> 2] = c2[g3 + 4 >> 2];
          Rj(a3, b3, f2);
          l2 = e3;
          return a3 | 0;
        }
        function Yh(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          var e3 = 0, f2 = 0, g3 = 0, h2 = 0;
          e3 = l2;
          l2 = l2 + 16 | 0;
          f2 = e3 + 8 | 0;
          g3 = e3;
          h2 = c2[d2 + 4 >> 2] | 0;
          c2[g3 >> 2] = c2[d2 >> 2];
          c2[g3 + 4 >> 2] = h2;
          c2[f2 >> 2] = c2[g3 >> 2];
          c2[f2 + 4 >> 2] = c2[g3 + 4 >> 2];
          xj(a3, b3, f2);
          l2 = e3;
          return a3 | 0;
        }
        function Zh(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          var e3 = 0, f2 = 0, g3 = 0, h2 = 0;
          e3 = l2;
          l2 = l2 + 16 | 0;
          f2 = e3 + 8 | 0;
          g3 = e3;
          h2 = c2[d2 + 4 >> 2] | 0;
          c2[g3 >> 2] = c2[d2 >> 2];
          c2[g3 + 4 >> 2] = h2;
          c2[f2 >> 2] = c2[g3 >> 2];
          c2[f2 + 4 >> 2] = c2[g3 + 4 >> 2];
          _i(a3, b3, f2);
          l2 = e3;
          return a3 | 0;
        }
        function _h(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          var e3 = 0, f2 = 0, g3 = 0, h2 = 0;
          e3 = l2;
          l2 = l2 + 16 | 0;
          f2 = e3 + 8 | 0;
          g3 = e3;
          h2 = c2[d2 + 4 >> 2] | 0;
          c2[g3 >> 2] = c2[d2 >> 2];
          c2[g3 + 4 >> 2] = h2;
          c2[f2 >> 2] = c2[g3 >> 2];
          c2[f2 + 4 >> 2] = c2[g3 + 4 >> 2];
          $h(a3, b3, f2);
          l2 = e3;
          return a3 | 0;
        }
        function $h(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          var e3 = 0, f2 = 0, g3 = 0, h2 = 0, i4 = 0;
          e3 = l2;
          l2 = l2 + 16 | 0;
          f2 = e3 + 8 | 0;
          g3 = e3;
          i4 = c2[d2 >> 2] | 0;
          h2 = c2[d2 + 4 >> 2] | 0;
          d2 = ai(b3) | 0;
          c2[g3 >> 2] = i4;
          c2[g3 + 4 >> 2] = h2;
          c2[f2 >> 2] = c2[g3 >> 2];
          c2[f2 + 4 >> 2] = c2[g3 + 4 >> 2];
          bi(a3, d2, f2, 1);
          l2 = e3;
          return;
        }
        function ai(a3) {
          a3 = a3 | 0;
          return a3 | 0;
        }
        function bi(a3, b3, d2, e3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          e3 = e3 | 0;
          var f2 = 0, g3 = 0, h2 = 0, i4 = 0, j2 = 0, k2 = 0, m2 = 0;
          f2 = l2;
          l2 = l2 + 32 | 0;
          g3 = f2 + 16 | 0;
          m2 = f2 + 8 | 0;
          i4 = f2;
          k2 = c2[d2 >> 2] | 0;
          j2 = c2[d2 + 4 >> 2] | 0;
          h2 = c2[a3 >> 2] | 0;
          a3 = ci() | 0;
          c2[m2 >> 2] = k2;
          c2[m2 + 4 >> 2] = j2;
          c2[g3 >> 2] = c2[m2 >> 2];
          c2[g3 + 4 >> 2] = c2[m2 + 4 >> 2];
          d2 = di(g3) | 0;
          c2[i4 >> 2] = k2;
          c2[i4 + 4 >> 2] = j2;
          c2[g3 >> 2] = c2[i4 >> 2];
          c2[g3 + 4 >> 2] = c2[i4 + 4 >> 2];
          fi(h2, b3, a3, d2, ei(g3, e3) | 0, e3);
          l2 = f2;
          return;
        }
        function ci() {
          var b3 = 0, d2 = 0;
          if (!(a2[7616] | 0)) {
            qi(9136);
            Ha(24, 9136, o2 | 0) | 0;
            d2 = 7616;
            c2[d2 >> 2] = 1;
            c2[d2 + 4 >> 2] = 0;
          }
          if (!(si(9136) | 0)) {
            b3 = 9136;
            d2 = b3 + 36 | 0;
            do {
              c2[b3 >> 2] = 0;
              b3 = b3 + 4 | 0;
            } while ((b3 | 0) < (d2 | 0));
            qi(9136);
          }
          return 9136;
        }
        function di(a3) {
          a3 = a3 | 0;
          return 0;
        }
        function ei(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          var d2 = 0, e3 = 0, f2 = 0, g3 = 0, h2 = 0, i4 = 0, j2 = 0, k2 = 0, m2 = 0, n3 = 0;
          m2 = l2;
          l2 = l2 + 32 | 0;
          f2 = m2 + 24 | 0;
          h2 = m2 + 16 | 0;
          i4 = m2;
          j2 = m2 + 8 | 0;
          g3 = c2[a3 >> 2] | 0;
          e3 = c2[a3 + 4 >> 2] | 0;
          c2[i4 >> 2] = g3;
          c2[i4 + 4 >> 2] = e3;
          n3 = ci() | 0;
          k2 = n3 + 24 | 0;
          a3 = ji(b3, 4) | 0;
          c2[j2 >> 2] = a3;
          b3 = n3 + 28 | 0;
          d2 = c2[b3 >> 2] | 0;
          if (d2 >>> 0 < (c2[n3 + 32 >> 2] | 0) >>> 0) {
            c2[h2 >> 2] = g3;
            c2[h2 + 4 >> 2] = e3;
            c2[f2 >> 2] = c2[h2 >> 2];
            c2[f2 + 4 >> 2] = c2[h2 + 4 >> 2];
            ki(d2, f2, a3);
            a3 = (c2[b3 >> 2] | 0) + 12 | 0;
            c2[b3 >> 2] = a3;
          } else {
            li(k2, i4, j2);
            a3 = c2[b3 >> 2] | 0;
          }
          l2 = m2;
          return ((a3 - (c2[k2 >> 2] | 0) | 0) / 12 | 0) + -1 | 0;
        }
        function fi(a3, b3, d2, e3, f2, g3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          e3 = e3 | 0;
          f2 = f2 | 0;
          g3 = g3 | 0;
          var h2 = 0, i4 = 0, j2 = 0, k2 = 0, m2 = 0, n3 = 0, o3 = 0, p2 = 0;
          h2 = l2;
          l2 = l2 + 32 | 0;
          o3 = h2 + 24 | 0;
          n3 = h2 + 20 | 0;
          j2 = h2 + 16 | 0;
          m2 = h2 + 12 | 0;
          k2 = h2 + 8 | 0;
          i4 = h2 + 4 | 0;
          p2 = h2;
          c2[n3 >> 2] = b3;
          c2[j2 >> 2] = d2;
          c2[m2 >> 2] = e3;
          c2[k2 >> 2] = f2;
          c2[i4 >> 2] = g3;
          g3 = a3 + 28 | 0;
          c2[p2 >> 2] = c2[g3 >> 2];
          c2[o3 >> 2] = c2[p2 >> 2];
          gi(a3 + 24 | 0, o3, n3, m2, k2, j2, i4) | 0;
          c2[g3 >> 2] = c2[c2[g3 >> 2] >> 2];
          l2 = h2;
          return;
        }
        function gi(a3, b3, d2, e3, f2, g3, h2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          e3 = e3 | 0;
          f2 = f2 | 0;
          g3 = g3 | 0;
          h2 = h2 | 0;
          a3 = hi(b3) | 0;
          b3 = qC(24) | 0;
          ii(b3 + 4 | 0, c2[d2 >> 2] | 0, c2[e3 >> 2] | 0, c2[f2 >> 2] | 0, c2[g3 >> 2] | 0, c2[h2 >> 2] | 0);
          c2[b3 >> 2] = c2[a3 >> 2];
          c2[a3 >> 2] = b3;
          return b3 | 0;
        }
        function hi(a3) {
          a3 = a3 | 0;
          return c2[a3 >> 2] | 0;
        }
        function ii(a3, b3, d2, e3, f2, g3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          e3 = e3 | 0;
          f2 = f2 | 0;
          g3 = g3 | 0;
          c2[a3 >> 2] = b3;
          c2[a3 + 4 >> 2] = d2;
          c2[a3 + 8 >> 2] = e3;
          c2[a3 + 12 >> 2] = f2;
          c2[a3 + 16 >> 2] = g3;
          return;
        }
        function ji(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          return b3 | a3 | 0;
        }
        function ki(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          var e3 = 0;
          e3 = c2[b3 + 4 >> 2] | 0;
          c2[a3 >> 2] = c2[b3 >> 2];
          c2[a3 + 4 >> 2] = e3;
          c2[a3 + 8 >> 2] = d2;
          return;
        }
        function li(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          var e3 = 0, f2 = 0, g3 = 0, h2 = 0, i4 = 0, j2 = 0, k2 = 0, m2 = 0, n3 = 0, o3 = 0;
          k2 = l2;
          l2 = l2 + 48 | 0;
          e3 = k2 + 32 | 0;
          h2 = k2 + 24 | 0;
          i4 = k2;
          j2 = a3 + 4 | 0;
          f2 = (((c2[j2 >> 2] | 0) - (c2[a3 >> 2] | 0) | 0) / 12 | 0) + 1 | 0;
          g3 = mi(a3) | 0;
          if (g3 >>> 0 < f2 >>> 0)
            jC(a3);
          else {
            m2 = c2[a3 >> 2] | 0;
            o3 = ((c2[a3 + 8 >> 2] | 0) - m2 | 0) / 12 | 0;
            n3 = o3 << 1;
            ni(i4, o3 >>> 0 < g3 >>> 1 >>> 0 ? n3 >>> 0 < f2 >>> 0 ? f2 : n3 : g3, ((c2[j2 >> 2] | 0) - m2 | 0) / 12 | 0, a3 + 8 | 0);
            j2 = i4 + 8 | 0;
            g3 = c2[j2 >> 2] | 0;
            f2 = c2[b3 + 4 >> 2] | 0;
            d2 = c2[d2 >> 2] | 0;
            c2[h2 >> 2] = c2[b3 >> 2];
            c2[h2 + 4 >> 2] = f2;
            c2[e3 >> 2] = c2[h2 >> 2];
            c2[e3 + 4 >> 2] = c2[h2 + 4 >> 2];
            ki(g3, e3, d2);
            c2[j2 >> 2] = (c2[j2 >> 2] | 0) + 12;
            oi(a3, i4);
            pi(i4);
            l2 = k2;
            return;
          }
        }
        function mi(a3) {
          a3 = a3 | 0;
          return 357913941;
        }
        function ni(a3, b3, d2, e3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          e3 = e3 | 0;
          var f2 = 0;
          c2[a3 + 12 >> 2] = 0;
          c2[a3 + 16 >> 2] = e3;
          do
            if (b3) {
              if (b3 >>> 0 > 357913941)
                Ta();
              else {
                f2 = qC(b3 * 12 | 0) | 0;
                break;
              }
            } else
              f2 = 0;
          while (0);
          c2[a3 >> 2] = f2;
          e3 = f2 + (d2 * 12 | 0) | 0;
          c2[a3 + 8 >> 2] = e3;
          c2[a3 + 4 >> 2] = e3;
          c2[a3 + 12 >> 2] = f2 + (b3 * 12 | 0);
          return;
        }
        function oi(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          var d2 = 0, e3 = 0, f2 = 0, g3 = 0, h2 = 0;
          e3 = c2[a3 >> 2] | 0;
          h2 = a3 + 4 | 0;
          g3 = b3 + 4 | 0;
          f2 = (c2[h2 >> 2] | 0) - e3 | 0;
          d2 = (c2[g3 >> 2] | 0) + (((f2 | 0) / -12 | 0) * 12 | 0) | 0;
          c2[g3 >> 2] = d2;
          if ((f2 | 0) > 0) {
            BC(d2 | 0, e3 | 0, f2 | 0) | 0;
            e3 = g3;
            d2 = c2[g3 >> 2] | 0;
          } else
            e3 = g3;
          g3 = c2[a3 >> 2] | 0;
          c2[a3 >> 2] = d2;
          c2[e3 >> 2] = g3;
          g3 = b3 + 8 | 0;
          f2 = c2[h2 >> 2] | 0;
          c2[h2 >> 2] = c2[g3 >> 2];
          c2[g3 >> 2] = f2;
          g3 = a3 + 8 | 0;
          h2 = b3 + 12 | 0;
          a3 = c2[g3 >> 2] | 0;
          c2[g3 >> 2] = c2[h2 >> 2];
          c2[h2 >> 2] = a3;
          c2[b3 >> 2] = c2[e3 >> 2];
          return;
        }
        function pi(a3) {
          a3 = a3 | 0;
          var b3 = 0, d2 = 0, e3 = 0;
          b3 = c2[a3 + 4 >> 2] | 0;
          d2 = a3 + 8 | 0;
          e3 = c2[d2 >> 2] | 0;
          if ((e3 | 0) != (b3 | 0))
            c2[d2 >> 2] = e3 + (~(((e3 + -12 - b3 | 0) >>> 0) / 12 | 0) * 12 | 0);
          a3 = c2[a3 >> 2] | 0;
          if (a3 | 0)
            sC(a3);
          return;
        }
        function qi(a3) {
          a3 = a3 | 0;
          ui(a3);
          return;
        }
        function ri(a3) {
          a3 = a3 | 0;
          ti(a3 + 24 | 0);
          return;
        }
        function si(a3) {
          a3 = a3 | 0;
          return c2[a3 >> 2] | 0;
        }
        function ti(a3) {
          a3 = a3 | 0;
          var b3 = 0, d2 = 0, e3 = 0;
          d2 = c2[a3 >> 2] | 0;
          e3 = d2;
          if (d2 | 0) {
            a3 = a3 + 4 | 0;
            b3 = c2[a3 >> 2] | 0;
            if ((b3 | 0) != (d2 | 0))
              c2[a3 >> 2] = b3 + (~(((b3 + -12 - e3 | 0) >>> 0) / 12 | 0) * 12 | 0);
            sC(d2);
          }
          return;
        }
        function ui(a3) {
          a3 = a3 | 0;
          var b3 = 0;
          b3 = vi() | 0;
          yi(a3, 2, 3, b3, wi() | 0, 0);
          c2[a3 + 24 >> 2] = 0;
          c2[a3 + 28 >> 2] = 0;
          c2[a3 + 32 >> 2] = 0;
          return;
        }
        function vi() {
          return 9228;
        }
        function wi() {
          return 1140;
        }
        function xi(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          var d2 = 0, e3 = 0, f2 = 0, g3 = 0;
          d2 = l2;
          l2 = l2 + 16 | 0;
          e3 = d2 + 8 | 0;
          f2 = d2;
          g3 = zi(a3) | 0;
          a3 = c2[g3 + 4 >> 2] | 0;
          c2[f2 >> 2] = c2[g3 >> 2];
          c2[f2 + 4 >> 2] = a3;
          c2[e3 >> 2] = c2[f2 >> 2];
          c2[e3 + 4 >> 2] = c2[f2 + 4 >> 2];
          b3 = Ai(b3, e3) | 0;
          l2 = d2;
          return b3 | 0;
        }
        function yi(a3, b3, d2, e3, f2, g3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          e3 = e3 | 0;
          f2 = f2 | 0;
          g3 = g3 | 0;
          c2[a3 >> 2] = b3;
          c2[a3 + 4 >> 2] = d2;
          c2[a3 + 8 >> 2] = e3;
          c2[a3 + 12 >> 2] = f2;
          c2[a3 + 16 >> 2] = g3;
          return;
        }
        function zi(a3) {
          a3 = a3 | 0;
          return (c2[(ci() | 0) + 24 >> 2] | 0) + (a3 * 12 | 0) | 0;
        }
        function Ai(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          var d2 = 0, e3 = 0, f2 = 0;
          f2 = l2;
          l2 = l2 + 48 | 0;
          e3 = f2;
          d2 = c2[b3 >> 2] | 0;
          b3 = c2[b3 + 4 >> 2] | 0;
          a3 = a3 + (b3 >> 1) | 0;
          if (b3 & 1)
            d2 = c2[(c2[a3 >> 2] | 0) + d2 >> 2] | 0;
          ob[d2 & 31](e3, a3);
          e3 = Bi(e3) | 0;
          l2 = f2;
          return e3 | 0;
        }
        function Bi(a3) {
          a3 = a3 | 0;
          var b3 = 0, c3 = 0, d2 = 0, e3 = 0;
          e3 = l2;
          l2 = l2 + 32 | 0;
          b3 = e3 + 12 | 0;
          c3 = e3;
          d2 = Di(Ci() | 0) | 0;
          if (!d2)
            a3 = Ii(a3) | 0;
          else {
            Ei(b3, d2);
            Fi(c3, b3);
            Gi(a3, c3);
            a3 = Hi(b3) | 0;
          }
          l2 = e3;
          return a3 | 0;
        }
        function Ci() {
          var b3 = 0;
          if (!(a2[7632] | 0)) {
            Ti(9184);
            Ha(25, 9184, o2 | 0) | 0;
            b3 = 7632;
            c2[b3 >> 2] = 1;
            c2[b3 + 4 >> 2] = 0;
          }
          return 9184;
        }
        function Di(a3) {
          a3 = a3 | 0;
          return c2[a3 + 36 >> 2] | 0;
        }
        function Ei(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          c2[a3 >> 2] = b3;
          c2[a3 + 4 >> 2] = a3;
          c2[a3 + 8 >> 2] = 0;
          return;
        }
        function Fi(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          c2[a3 >> 2] = c2[b3 >> 2];
          c2[a3 + 4 >> 2] = c2[b3 + 4 >> 2];
          c2[a3 + 8 >> 2] = 0;
          return;
        }
        function Gi(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          Ni(b3, a3, a3 + 8 | 0, a3 + 16 | 0, a3 + 24 | 0, a3 + 32 | 0, a3 + 40 | 0) | 0;
          return;
        }
        function Hi(a3) {
          a3 = a3 | 0;
          return c2[(c2[a3 + 4 >> 2] | 0) + 8 >> 2] | 0;
        }
        function Ii(a3) {
          a3 = a3 | 0;
          var b3 = 0, d2 = 0, e3 = 0, f2 = 0, g3 = 0, h2 = 0, i4 = 0, j2 = 0;
          j2 = l2;
          l2 = l2 + 16 | 0;
          d2 = j2 + 4 | 0;
          e3 = j2;
          f2 = jy(8) | 0;
          g3 = f2;
          h2 = qC(48) | 0;
          i4 = h2;
          b3 = i4 + 48 | 0;
          do {
            c2[i4 >> 2] = c2[a3 >> 2];
            i4 = i4 + 4 | 0;
            a3 = a3 + 4 | 0;
          } while ((i4 | 0) < (b3 | 0));
          b3 = g3 + 4 | 0;
          c2[b3 >> 2] = h2;
          i4 = qC(8) | 0;
          h2 = c2[b3 >> 2] | 0;
          c2[e3 >> 2] = 0;
          c2[d2 >> 2] = c2[e3 >> 2];
          Ji(i4, h2, d2);
          c2[f2 >> 2] = i4;
          l2 = j2;
          return g3 | 0;
        }
        function Ji(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          c2[a3 >> 2] = b3;
          d2 = qC(16) | 0;
          c2[d2 + 4 >> 2] = 0;
          c2[d2 + 8 >> 2] = 0;
          c2[d2 >> 2] = 1092;
          c2[d2 + 12 >> 2] = b3;
          c2[a3 + 4 >> 2] = d2;
          return;
        }
        function Ki(a3) {
          a3 = a3 | 0;
          kC(a3);
          sC(a3);
          return;
        }
        function Li(a3) {
          a3 = a3 | 0;
          a3 = c2[a3 + 12 >> 2] | 0;
          if (a3 | 0)
            sC(a3);
          return;
        }
        function Mi(a3) {
          a3 = a3 | 0;
          sC(a3);
          return;
        }
        function Ni(a3, b3, d2, e3, f2, g3, h2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          e3 = e3 | 0;
          f2 = f2 | 0;
          g3 = g3 | 0;
          h2 = h2 | 0;
          g3 = Oi(c2[a3 >> 2] | 0, b3, d2, e3, f2, g3, h2) | 0;
          h2 = a3 + 4 | 0;
          c2[(c2[h2 >> 2] | 0) + 8 >> 2] = g3;
          return c2[(c2[h2 >> 2] | 0) + 8 >> 2] | 0;
        }
        function Oi(a3, b3, c3, d2, e3, f2, g3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          c3 = c3 | 0;
          d2 = d2 | 0;
          e3 = e3 | 0;
          f2 = f2 | 0;
          g3 = g3 | 0;
          var i4 = 0, j2 = 0;
          i4 = l2;
          l2 = l2 + 16 | 0;
          j2 = i4;
          UA(j2);
          a3 = Sg(a3) | 0;
          g3 = Pi(a3, +h[b3 >> 3], +h[c3 >> 3], +h[d2 >> 3], +h[e3 >> 3], +h[f2 >> 3], +h[g3 >> 3]) | 0;
          WA(j2);
          l2 = i4;
          return g3 | 0;
        }
        function Pi(a3, b3, c3, d2, e3, f2, g3) {
          a3 = a3 | 0;
          b3 = +b3;
          c3 = +c3;
          d2 = +d2;
          e3 = +e3;
          f2 = +f2;
          g3 = +g3;
          var h2 = 0;
          h2 = Vg(Qi() | 0) | 0;
          b3 = +Wg(b3);
          c3 = +Wg(c3);
          d2 = +Wg(d2);
          e3 = +Wg(e3);
          f2 = +Wg(f2);
          return ya(0, h2 | 0, a3 | 0, +b3, +c3, +d2, +e3, +f2, + +Wg(g3)) | 0;
        }
        function Qi() {
          var b3 = 0;
          if (!(a2[7624] | 0)) {
            Ri(9172);
            b3 = 7624;
            c2[b3 >> 2] = 1;
            c2[b3 + 4 >> 2] = 0;
          }
          return 9172;
        }
        function Ri(a3) {
          a3 = a3 | 0;
          fh(a3, Si() | 0, 6);
          return;
        }
        function Si() {
          return 1112;
        }
        function Ti(a3) {
          a3 = a3 | 0;
          Zi(a3);
          return;
        }
        function Ui(a3) {
          a3 = a3 | 0;
          Vi(a3 + 24 | 0);
          Wi(a3 + 16 | 0);
          return;
        }
        function Vi(a3) {
          a3 = a3 | 0;
          Yi(a3);
          return;
        }
        function Wi(a3) {
          a3 = a3 | 0;
          Xi(a3);
          return;
        }
        function Xi(a3) {
          a3 = a3 | 0;
          var b3 = 0, d2 = 0;
          b3 = c2[a3 >> 2] | 0;
          if (b3 | 0)
            do {
              d2 = b3;
              b3 = c2[b3 >> 2] | 0;
              sC(d2);
            } while ((b3 | 0) != 0);
          c2[a3 >> 2] = 0;
          return;
        }
        function Yi(a3) {
          a3 = a3 | 0;
          var b3 = 0, d2 = 0;
          b3 = c2[a3 >> 2] | 0;
          if (b3 | 0)
            do {
              d2 = b3;
              b3 = c2[b3 >> 2] | 0;
              sC(d2);
            } while ((b3 | 0) != 0);
          c2[a3 >> 2] = 0;
          return;
        }
        function Zi(b3) {
          b3 = b3 | 0;
          var d2 = 0;
          c2[b3 + 16 >> 2] = 0;
          c2[b3 + 20 >> 2] = 0;
          d2 = b3 + 24 | 0;
          c2[d2 >> 2] = 0;
          c2[b3 + 28 >> 2] = d2;
          c2[b3 + 36 >> 2] = 0;
          a2[b3 + 40 >> 0] = 0;
          a2[b3 + 41 >> 0] = 0;
          return;
        }
        function _i(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          var e3 = 0, f2 = 0, g3 = 0, h2 = 0, i4 = 0;
          e3 = l2;
          l2 = l2 + 16 | 0;
          f2 = e3 + 8 | 0;
          g3 = e3;
          i4 = c2[d2 >> 2] | 0;
          h2 = c2[d2 + 4 >> 2] | 0;
          d2 = ai(b3) | 0;
          c2[g3 >> 2] = i4;
          c2[g3 + 4 >> 2] = h2;
          c2[f2 >> 2] = c2[g3 >> 2];
          c2[f2 + 4 >> 2] = c2[g3 + 4 >> 2];
          $i(a3, d2, f2, 0);
          l2 = e3;
          return;
        }
        function $i(a3, b3, d2, e3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          e3 = e3 | 0;
          var f2 = 0, g3 = 0, h2 = 0, i4 = 0, j2 = 0, k2 = 0, m2 = 0;
          f2 = l2;
          l2 = l2 + 32 | 0;
          g3 = f2 + 16 | 0;
          m2 = f2 + 8 | 0;
          i4 = f2;
          k2 = c2[d2 >> 2] | 0;
          j2 = c2[d2 + 4 >> 2] | 0;
          h2 = c2[a3 >> 2] | 0;
          a3 = aj() | 0;
          c2[m2 >> 2] = k2;
          c2[m2 + 4 >> 2] = j2;
          c2[g3 >> 2] = c2[m2 >> 2];
          c2[g3 + 4 >> 2] = c2[m2 + 4 >> 2];
          d2 = bj(g3) | 0;
          c2[i4 >> 2] = k2;
          c2[i4 + 4 >> 2] = j2;
          c2[g3 >> 2] = c2[i4 >> 2];
          c2[g3 + 4 >> 2] = c2[i4 + 4 >> 2];
          fi(h2, b3, a3, d2, cj(g3, e3) | 0, e3);
          l2 = f2;
          return;
        }
        function aj() {
          var b3 = 0, d2 = 0;
          if (!(a2[7640] | 0)) {
            jj(9232);
            Ha(26, 9232, o2 | 0) | 0;
            d2 = 7640;
            c2[d2 >> 2] = 1;
            c2[d2 + 4 >> 2] = 0;
          }
          if (!(si(9232) | 0)) {
            b3 = 9232;
            d2 = b3 + 36 | 0;
            do {
              c2[b3 >> 2] = 0;
              b3 = b3 + 4 | 0;
            } while ((b3 | 0) < (d2 | 0));
            jj(9232);
          }
          return 9232;
        }
        function bj(a3) {
          a3 = a3 | 0;
          return 0;
        }
        function cj(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          var d2 = 0, e3 = 0, f2 = 0, g3 = 0, h2 = 0, i4 = 0, j2 = 0, k2 = 0, m2 = 0, n3 = 0;
          m2 = l2;
          l2 = l2 + 32 | 0;
          f2 = m2 + 24 | 0;
          h2 = m2 + 16 | 0;
          i4 = m2;
          j2 = m2 + 8 | 0;
          g3 = c2[a3 >> 2] | 0;
          e3 = c2[a3 + 4 >> 2] | 0;
          c2[i4 >> 2] = g3;
          c2[i4 + 4 >> 2] = e3;
          n3 = aj() | 0;
          k2 = n3 + 24 | 0;
          a3 = ji(b3, 4) | 0;
          c2[j2 >> 2] = a3;
          b3 = n3 + 28 | 0;
          d2 = c2[b3 >> 2] | 0;
          if (d2 >>> 0 < (c2[n3 + 32 >> 2] | 0) >>> 0) {
            c2[h2 >> 2] = g3;
            c2[h2 + 4 >> 2] = e3;
            c2[f2 >> 2] = c2[h2 >> 2];
            c2[f2 + 4 >> 2] = c2[h2 + 4 >> 2];
            dj(d2, f2, a3);
            a3 = (c2[b3 >> 2] | 0) + 12 | 0;
            c2[b3 >> 2] = a3;
          } else {
            ej(k2, i4, j2);
            a3 = c2[b3 >> 2] | 0;
          }
          l2 = m2;
          return ((a3 - (c2[k2 >> 2] | 0) | 0) / 12 | 0) + -1 | 0;
        }
        function dj(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          var e3 = 0;
          e3 = c2[b3 + 4 >> 2] | 0;
          c2[a3 >> 2] = c2[b3 >> 2];
          c2[a3 + 4 >> 2] = e3;
          c2[a3 + 8 >> 2] = d2;
          return;
        }
        function ej(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          var e3 = 0, f2 = 0, g3 = 0, h2 = 0, i4 = 0, j2 = 0, k2 = 0, m2 = 0, n3 = 0, o3 = 0;
          k2 = l2;
          l2 = l2 + 48 | 0;
          e3 = k2 + 32 | 0;
          h2 = k2 + 24 | 0;
          i4 = k2;
          j2 = a3 + 4 | 0;
          f2 = (((c2[j2 >> 2] | 0) - (c2[a3 >> 2] | 0) | 0) / 12 | 0) + 1 | 0;
          g3 = fj(a3) | 0;
          if (g3 >>> 0 < f2 >>> 0)
            jC(a3);
          else {
            m2 = c2[a3 >> 2] | 0;
            o3 = ((c2[a3 + 8 >> 2] | 0) - m2 | 0) / 12 | 0;
            n3 = o3 << 1;
            gj(i4, o3 >>> 0 < g3 >>> 1 >>> 0 ? n3 >>> 0 < f2 >>> 0 ? f2 : n3 : g3, ((c2[j2 >> 2] | 0) - m2 | 0) / 12 | 0, a3 + 8 | 0);
            j2 = i4 + 8 | 0;
            g3 = c2[j2 >> 2] | 0;
            f2 = c2[b3 + 4 >> 2] | 0;
            d2 = c2[d2 >> 2] | 0;
            c2[h2 >> 2] = c2[b3 >> 2];
            c2[h2 + 4 >> 2] = f2;
            c2[e3 >> 2] = c2[h2 >> 2];
            c2[e3 + 4 >> 2] = c2[h2 + 4 >> 2];
            dj(g3, e3, d2);
            c2[j2 >> 2] = (c2[j2 >> 2] | 0) + 12;
            hj(a3, i4);
            ij(i4);
            l2 = k2;
            return;
          }
        }
        function fj(a3) {
          a3 = a3 | 0;
          return 357913941;
        }
        function gj(a3, b3, d2, e3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          e3 = e3 | 0;
          var f2 = 0;
          c2[a3 + 12 >> 2] = 0;
          c2[a3 + 16 >> 2] = e3;
          do
            if (b3) {
              if (b3 >>> 0 > 357913941)
                Ta();
              else {
                f2 = qC(b3 * 12 | 0) | 0;
                break;
              }
            } else
              f2 = 0;
          while (0);
          c2[a3 >> 2] = f2;
          e3 = f2 + (d2 * 12 | 0) | 0;
          c2[a3 + 8 >> 2] = e3;
          c2[a3 + 4 >> 2] = e3;
          c2[a3 + 12 >> 2] = f2 + (b3 * 12 | 0);
          return;
        }
        function hj(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          var d2 = 0, e3 = 0, f2 = 0, g3 = 0, h2 = 0;
          e3 = c2[a3 >> 2] | 0;
          h2 = a3 + 4 | 0;
          g3 = b3 + 4 | 0;
          f2 = (c2[h2 >> 2] | 0) - e3 | 0;
          d2 = (c2[g3 >> 2] | 0) + (((f2 | 0) / -12 | 0) * 12 | 0) | 0;
          c2[g3 >> 2] = d2;
          if ((f2 | 0) > 0) {
            BC(d2 | 0, e3 | 0, f2 | 0) | 0;
            e3 = g3;
            d2 = c2[g3 >> 2] | 0;
          } else
            e3 = g3;
          g3 = c2[a3 >> 2] | 0;
          c2[a3 >> 2] = d2;
          c2[e3 >> 2] = g3;
          g3 = b3 + 8 | 0;
          f2 = c2[h2 >> 2] | 0;
          c2[h2 >> 2] = c2[g3 >> 2];
          c2[g3 >> 2] = f2;
          g3 = a3 + 8 | 0;
          h2 = b3 + 12 | 0;
          a3 = c2[g3 >> 2] | 0;
          c2[g3 >> 2] = c2[h2 >> 2];
          c2[h2 >> 2] = a3;
          c2[b3 >> 2] = c2[e3 >> 2];
          return;
        }
        function ij(a3) {
          a3 = a3 | 0;
          var b3 = 0, d2 = 0, e3 = 0;
          b3 = c2[a3 + 4 >> 2] | 0;
          d2 = a3 + 8 | 0;
          e3 = c2[d2 >> 2] | 0;
          if ((e3 | 0) != (b3 | 0))
            c2[d2 >> 2] = e3 + (~(((e3 + -12 - b3 | 0) >>> 0) / 12 | 0) * 12 | 0);
          a3 = c2[a3 >> 2] | 0;
          if (a3 | 0)
            sC(a3);
          return;
        }
        function jj(a3) {
          a3 = a3 | 0;
          mj(a3);
          return;
        }
        function kj(a3) {
          a3 = a3 | 0;
          lj(a3 + 24 | 0);
          return;
        }
        function lj(a3) {
          a3 = a3 | 0;
          var b3 = 0, d2 = 0, e3 = 0;
          d2 = c2[a3 >> 2] | 0;
          e3 = d2;
          if (d2 | 0) {
            a3 = a3 + 4 | 0;
            b3 = c2[a3 >> 2] | 0;
            if ((b3 | 0) != (d2 | 0))
              c2[a3 >> 2] = b3 + (~(((b3 + -12 - e3 | 0) >>> 0) / 12 | 0) * 12 | 0);
            sC(d2);
          }
          return;
        }
        function mj(a3) {
          a3 = a3 | 0;
          var b3 = 0;
          b3 = vi() | 0;
          yi(a3, 2, 1, b3, nj() | 0, 3);
          c2[a3 + 24 >> 2] = 0;
          c2[a3 + 28 >> 2] = 0;
          c2[a3 + 32 >> 2] = 0;
          return;
        }
        function nj() {
          return 1144;
        }
        function oj(a3, b3, d2, e3, f2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = +d2;
          e3 = +e3;
          f2 = f2 | 0;
          var g3 = 0, h2 = 0, i4 = 0, j2 = 0;
          g3 = l2;
          l2 = l2 + 16 | 0;
          h2 = g3 + 8 | 0;
          i4 = g3;
          j2 = pj(a3) | 0;
          a3 = c2[j2 + 4 >> 2] | 0;
          c2[i4 >> 2] = c2[j2 >> 2];
          c2[i4 + 4 >> 2] = a3;
          c2[h2 >> 2] = c2[i4 >> 2];
          c2[h2 + 4 >> 2] = c2[i4 + 4 >> 2];
          qj(b3, h2, d2, e3, f2);
          l2 = g3;
          return;
        }
        function pj(a3) {
          a3 = a3 | 0;
          return (c2[(aj() | 0) + 24 >> 2] | 0) + (a3 * 12 | 0) | 0;
        }
        function qj(a3, b3, d2, e3, f2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = +d2;
          e3 = +e3;
          f2 = f2 | 0;
          var g3 = 0, h2 = 0, i4 = 0, j2 = 0, k2 = 0;
          k2 = l2;
          l2 = l2 + 16 | 0;
          h2 = k2 + 2 | 0;
          i4 = k2 + 1 | 0;
          j2 = k2;
          g3 = c2[b3 >> 2] | 0;
          b3 = c2[b3 + 4 >> 2] | 0;
          a3 = a3 + (b3 >> 1) | 0;
          if (b3 & 1)
            g3 = c2[(c2[a3 >> 2] | 0) + g3 >> 2] | 0;
          rj(h2, d2);
          d2 = +sj(h2, d2);
          rj(i4, e3);
          e3 = +sj(i4, e3);
          tj(j2, f2);
          j2 = uj(j2, f2) | 0;
          qb[g3 & 1](a3, d2, e3, j2);
          l2 = k2;
          return;
        }
        function rj(a3, b3) {
          a3 = a3 | 0;
          b3 = +b3;
          return;
        }
        function sj(a3, b3) {
          a3 = a3 | 0;
          b3 = +b3;
          return + +wj(b3);
        }
        function tj(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          return;
        }
        function uj(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          return vj(b3) | 0;
        }
        function vj(a3) {
          a3 = a3 | 0;
          return a3 | 0;
        }
        function wj(a3) {
          a3 = +a3;
          return +a3;
        }
        function xj(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          var e3 = 0, f2 = 0, g3 = 0, h2 = 0, i4 = 0;
          e3 = l2;
          l2 = l2 + 16 | 0;
          f2 = e3 + 8 | 0;
          g3 = e3;
          i4 = c2[d2 >> 2] | 0;
          h2 = c2[d2 + 4 >> 2] | 0;
          d2 = ai(b3) | 0;
          c2[g3 >> 2] = i4;
          c2[g3 + 4 >> 2] = h2;
          c2[f2 >> 2] = c2[g3 >> 2];
          c2[f2 + 4 >> 2] = c2[g3 + 4 >> 2];
          yj(a3, d2, f2, 1);
          l2 = e3;
          return;
        }
        function yj(a3, b3, d2, e3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          e3 = e3 | 0;
          var f2 = 0, g3 = 0, h2 = 0, i4 = 0, j2 = 0, k2 = 0, m2 = 0;
          f2 = l2;
          l2 = l2 + 32 | 0;
          g3 = f2 + 16 | 0;
          m2 = f2 + 8 | 0;
          i4 = f2;
          k2 = c2[d2 >> 2] | 0;
          j2 = c2[d2 + 4 >> 2] | 0;
          h2 = c2[a3 >> 2] | 0;
          a3 = zj() | 0;
          c2[m2 >> 2] = k2;
          c2[m2 + 4 >> 2] = j2;
          c2[g3 >> 2] = c2[m2 >> 2];
          c2[g3 + 4 >> 2] = c2[m2 + 4 >> 2];
          d2 = Aj(g3) | 0;
          c2[i4 >> 2] = k2;
          c2[i4 + 4 >> 2] = j2;
          c2[g3 >> 2] = c2[i4 >> 2];
          c2[g3 + 4 >> 2] = c2[i4 + 4 >> 2];
          fi(h2, b3, a3, d2, Bj(g3, e3) | 0, e3);
          l2 = f2;
          return;
        }
        function zj() {
          var b3 = 0, d2 = 0;
          if (!(a2[7648] | 0)) {
            Ij(9268);
            Ha(27, 9268, o2 | 0) | 0;
            d2 = 7648;
            c2[d2 >> 2] = 1;
            c2[d2 + 4 >> 2] = 0;
          }
          if (!(si(9268) | 0)) {
            b3 = 9268;
            d2 = b3 + 36 | 0;
            do {
              c2[b3 >> 2] = 0;
              b3 = b3 + 4 | 0;
            } while ((b3 | 0) < (d2 | 0));
            Ij(9268);
          }
          return 9268;
        }
        function Aj(a3) {
          a3 = a3 | 0;
          return 0;
        }
        function Bj(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          var d2 = 0, e3 = 0, f2 = 0, g3 = 0, h2 = 0, i4 = 0, j2 = 0, k2 = 0, m2 = 0, n3 = 0;
          m2 = l2;
          l2 = l2 + 32 | 0;
          f2 = m2 + 24 | 0;
          h2 = m2 + 16 | 0;
          i4 = m2;
          j2 = m2 + 8 | 0;
          g3 = c2[a3 >> 2] | 0;
          e3 = c2[a3 + 4 >> 2] | 0;
          c2[i4 >> 2] = g3;
          c2[i4 + 4 >> 2] = e3;
          n3 = zj() | 0;
          k2 = n3 + 24 | 0;
          a3 = ji(b3, 4) | 0;
          c2[j2 >> 2] = a3;
          b3 = n3 + 28 | 0;
          d2 = c2[b3 >> 2] | 0;
          if (d2 >>> 0 < (c2[n3 + 32 >> 2] | 0) >>> 0) {
            c2[h2 >> 2] = g3;
            c2[h2 + 4 >> 2] = e3;
            c2[f2 >> 2] = c2[h2 >> 2];
            c2[f2 + 4 >> 2] = c2[h2 + 4 >> 2];
            Cj(d2, f2, a3);
            a3 = (c2[b3 >> 2] | 0) + 12 | 0;
            c2[b3 >> 2] = a3;
          } else {
            Dj(k2, i4, j2);
            a3 = c2[b3 >> 2] | 0;
          }
          l2 = m2;
          return ((a3 - (c2[k2 >> 2] | 0) | 0) / 12 | 0) + -1 | 0;
        }
        function Cj(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          var e3 = 0;
          e3 = c2[b3 + 4 >> 2] | 0;
          c2[a3 >> 2] = c2[b3 >> 2];
          c2[a3 + 4 >> 2] = e3;
          c2[a3 + 8 >> 2] = d2;
          return;
        }
        function Dj(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          var e3 = 0, f2 = 0, g3 = 0, h2 = 0, i4 = 0, j2 = 0, k2 = 0, m2 = 0, n3 = 0, o3 = 0;
          k2 = l2;
          l2 = l2 + 48 | 0;
          e3 = k2 + 32 | 0;
          h2 = k2 + 24 | 0;
          i4 = k2;
          j2 = a3 + 4 | 0;
          f2 = (((c2[j2 >> 2] | 0) - (c2[a3 >> 2] | 0) | 0) / 12 | 0) + 1 | 0;
          g3 = Ej(a3) | 0;
          if (g3 >>> 0 < f2 >>> 0)
            jC(a3);
          else {
            m2 = c2[a3 >> 2] | 0;
            o3 = ((c2[a3 + 8 >> 2] | 0) - m2 | 0) / 12 | 0;
            n3 = o3 << 1;
            Fj(i4, o3 >>> 0 < g3 >>> 1 >>> 0 ? n3 >>> 0 < f2 >>> 0 ? f2 : n3 : g3, ((c2[j2 >> 2] | 0) - m2 | 0) / 12 | 0, a3 + 8 | 0);
            j2 = i4 + 8 | 0;
            g3 = c2[j2 >> 2] | 0;
            f2 = c2[b3 + 4 >> 2] | 0;
            d2 = c2[d2 >> 2] | 0;
            c2[h2 >> 2] = c2[b3 >> 2];
            c2[h2 + 4 >> 2] = f2;
            c2[e3 >> 2] = c2[h2 >> 2];
            c2[e3 + 4 >> 2] = c2[h2 + 4 >> 2];
            Cj(g3, e3, d2);
            c2[j2 >> 2] = (c2[j2 >> 2] | 0) + 12;
            Gj(a3, i4);
            Hj(i4);
            l2 = k2;
            return;
          }
        }
        function Ej(a3) {
          a3 = a3 | 0;
          return 357913941;
        }
        function Fj(a3, b3, d2, e3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          e3 = e3 | 0;
          var f2 = 0;
          c2[a3 + 12 >> 2] = 0;
          c2[a3 + 16 >> 2] = e3;
          do
            if (b3) {
              if (b3 >>> 0 > 357913941)
                Ta();
              else {
                f2 = qC(b3 * 12 | 0) | 0;
                break;
              }
            } else
              f2 = 0;
          while (0);
          c2[a3 >> 2] = f2;
          e3 = f2 + (d2 * 12 | 0) | 0;
          c2[a3 + 8 >> 2] = e3;
          c2[a3 + 4 >> 2] = e3;
          c2[a3 + 12 >> 2] = f2 + (b3 * 12 | 0);
          return;
        }
        function Gj(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          var d2 = 0, e3 = 0, f2 = 0, g3 = 0, h2 = 0;
          e3 = c2[a3 >> 2] | 0;
          h2 = a3 + 4 | 0;
          g3 = b3 + 4 | 0;
          f2 = (c2[h2 >> 2] | 0) - e3 | 0;
          d2 = (c2[g3 >> 2] | 0) + (((f2 | 0) / -12 | 0) * 12 | 0) | 0;
          c2[g3 >> 2] = d2;
          if ((f2 | 0) > 0) {
            BC(d2 | 0, e3 | 0, f2 | 0) | 0;
            e3 = g3;
            d2 = c2[g3 >> 2] | 0;
          } else
            e3 = g3;
          g3 = c2[a3 >> 2] | 0;
          c2[a3 >> 2] = d2;
          c2[e3 >> 2] = g3;
          g3 = b3 + 8 | 0;
          f2 = c2[h2 >> 2] | 0;
          c2[h2 >> 2] = c2[g3 >> 2];
          c2[g3 >> 2] = f2;
          g3 = a3 + 8 | 0;
          h2 = b3 + 12 | 0;
          a3 = c2[g3 >> 2] | 0;
          c2[g3 >> 2] = c2[h2 >> 2];
          c2[h2 >> 2] = a3;
          c2[b3 >> 2] = c2[e3 >> 2];
          return;
        }
        function Hj(a3) {
          a3 = a3 | 0;
          var b3 = 0, d2 = 0, e3 = 0;
          b3 = c2[a3 + 4 >> 2] | 0;
          d2 = a3 + 8 | 0;
          e3 = c2[d2 >> 2] | 0;
          if ((e3 | 0) != (b3 | 0))
            c2[d2 >> 2] = e3 + (~(((e3 + -12 - b3 | 0) >>> 0) / 12 | 0) * 12 | 0);
          a3 = c2[a3 >> 2] | 0;
          if (a3 | 0)
            sC(a3);
          return;
        }
        function Ij(a3) {
          a3 = a3 | 0;
          Lj(a3);
          return;
        }
        function Jj(a3) {
          a3 = a3 | 0;
          Kj(a3 + 24 | 0);
          return;
        }
        function Kj(a3) {
          a3 = a3 | 0;
          var b3 = 0, d2 = 0, e3 = 0;
          d2 = c2[a3 >> 2] | 0;
          e3 = d2;
          if (d2 | 0) {
            a3 = a3 + 4 | 0;
            b3 = c2[a3 >> 2] | 0;
            if ((b3 | 0) != (d2 | 0))
              c2[a3 >> 2] = b3 + (~(((b3 + -12 - e3 | 0) >>> 0) / 12 | 0) * 12 | 0);
            sC(d2);
          }
          return;
        }
        function Lj(a3) {
          a3 = a3 | 0;
          var b3 = 0;
          b3 = vi() | 0;
          yi(a3, 2, 4, b3, Mj() | 0, 0);
          c2[a3 + 24 >> 2] = 0;
          c2[a3 + 28 >> 2] = 0;
          c2[a3 + 32 >> 2] = 0;
          return;
        }
        function Mj() {
          return 1160;
        }
        function Nj(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          var d2 = 0, e3 = 0, f2 = 0, g3 = 0;
          d2 = l2;
          l2 = l2 + 16 | 0;
          e3 = d2 + 8 | 0;
          f2 = d2;
          g3 = Oj(a3) | 0;
          a3 = c2[g3 + 4 >> 2] | 0;
          c2[f2 >> 2] = c2[g3 >> 2];
          c2[f2 + 4 >> 2] = a3;
          c2[e3 >> 2] = c2[f2 >> 2];
          c2[e3 + 4 >> 2] = c2[f2 + 4 >> 2];
          b3 = Pj(b3, e3) | 0;
          l2 = d2;
          return b3 | 0;
        }
        function Oj(a3) {
          a3 = a3 | 0;
          return (c2[(zj() | 0) + 24 >> 2] | 0) + (a3 * 12 | 0) | 0;
        }
        function Pj(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          var d2 = 0;
          d2 = c2[b3 >> 2] | 0;
          b3 = c2[b3 + 4 >> 2] | 0;
          a3 = a3 + (b3 >> 1) | 0;
          if (b3 & 1)
            d2 = c2[(c2[a3 >> 2] | 0) + d2 >> 2] | 0;
          return Qj(pb[d2 & 31](a3) | 0) | 0;
        }
        function Qj(a3) {
          a3 = a3 | 0;
          return a3 & 1 | 0;
        }
        function Rj(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          var e3 = 0, f2 = 0, g3 = 0, h2 = 0, i4 = 0;
          e3 = l2;
          l2 = l2 + 16 | 0;
          f2 = e3 + 8 | 0;
          g3 = e3;
          i4 = c2[d2 >> 2] | 0;
          h2 = c2[d2 + 4 >> 2] | 0;
          d2 = ai(b3) | 0;
          c2[g3 >> 2] = i4;
          c2[g3 + 4 >> 2] = h2;
          c2[f2 >> 2] = c2[g3 >> 2];
          c2[f2 + 4 >> 2] = c2[g3 + 4 >> 2];
          Sj(a3, d2, f2, 0);
          l2 = e3;
          return;
        }
        function Sj(a3, b3, d2, e3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          e3 = e3 | 0;
          var f2 = 0, g3 = 0, h2 = 0, i4 = 0, j2 = 0, k2 = 0, m2 = 0;
          f2 = l2;
          l2 = l2 + 32 | 0;
          g3 = f2 + 16 | 0;
          m2 = f2 + 8 | 0;
          i4 = f2;
          k2 = c2[d2 >> 2] | 0;
          j2 = c2[d2 + 4 >> 2] | 0;
          h2 = c2[a3 >> 2] | 0;
          a3 = Tj() | 0;
          c2[m2 >> 2] = k2;
          c2[m2 + 4 >> 2] = j2;
          c2[g3 >> 2] = c2[m2 >> 2];
          c2[g3 + 4 >> 2] = c2[m2 + 4 >> 2];
          d2 = Uj(g3) | 0;
          c2[i4 >> 2] = k2;
          c2[i4 + 4 >> 2] = j2;
          c2[g3 >> 2] = c2[i4 >> 2];
          c2[g3 + 4 >> 2] = c2[i4 + 4 >> 2];
          fi(h2, b3, a3, d2, Vj(g3, e3) | 0, e3);
          l2 = f2;
          return;
        }
        function Tj() {
          var b3 = 0, d2 = 0;
          if (!(a2[7656] | 0)) {
            ak(9304);
            Ha(28, 9304, o2 | 0) | 0;
            d2 = 7656;
            c2[d2 >> 2] = 1;
            c2[d2 + 4 >> 2] = 0;
          }
          if (!(si(9304) | 0)) {
            b3 = 9304;
            d2 = b3 + 36 | 0;
            do {
              c2[b3 >> 2] = 0;
              b3 = b3 + 4 | 0;
            } while ((b3 | 0) < (d2 | 0));
            ak(9304);
          }
          return 9304;
        }
        function Uj(a3) {
          a3 = a3 | 0;
          return 0;
        }
        function Vj(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          var d2 = 0, e3 = 0, f2 = 0, g3 = 0, h2 = 0, i4 = 0, j2 = 0, k2 = 0, m2 = 0, n3 = 0;
          m2 = l2;
          l2 = l2 + 32 | 0;
          f2 = m2 + 24 | 0;
          h2 = m2 + 16 | 0;
          i4 = m2;
          j2 = m2 + 8 | 0;
          g3 = c2[a3 >> 2] | 0;
          e3 = c2[a3 + 4 >> 2] | 0;
          c2[i4 >> 2] = g3;
          c2[i4 + 4 >> 2] = e3;
          n3 = Tj() | 0;
          k2 = n3 + 24 | 0;
          a3 = ji(b3, 4) | 0;
          c2[j2 >> 2] = a3;
          b3 = n3 + 28 | 0;
          d2 = c2[b3 >> 2] | 0;
          if (d2 >>> 0 < (c2[n3 + 32 >> 2] | 0) >>> 0) {
            c2[h2 >> 2] = g3;
            c2[h2 + 4 >> 2] = e3;
            c2[f2 >> 2] = c2[h2 >> 2];
            c2[f2 + 4 >> 2] = c2[h2 + 4 >> 2];
            Wj(d2, f2, a3);
            a3 = (c2[b3 >> 2] | 0) + 12 | 0;
            c2[b3 >> 2] = a3;
          } else {
            Xj(k2, i4, j2);
            a3 = c2[b3 >> 2] | 0;
          }
          l2 = m2;
          return ((a3 - (c2[k2 >> 2] | 0) | 0) / 12 | 0) + -1 | 0;
        }
        function Wj(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          var e3 = 0;
          e3 = c2[b3 + 4 >> 2] | 0;
          c2[a3 >> 2] = c2[b3 >> 2];
          c2[a3 + 4 >> 2] = e3;
          c2[a3 + 8 >> 2] = d2;
          return;
        }
        function Xj(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          var e3 = 0, f2 = 0, g3 = 0, h2 = 0, i4 = 0, j2 = 0, k2 = 0, m2 = 0, n3 = 0, o3 = 0;
          k2 = l2;
          l2 = l2 + 48 | 0;
          e3 = k2 + 32 | 0;
          h2 = k2 + 24 | 0;
          i4 = k2;
          j2 = a3 + 4 | 0;
          f2 = (((c2[j2 >> 2] | 0) - (c2[a3 >> 2] | 0) | 0) / 12 | 0) + 1 | 0;
          g3 = Yj(a3) | 0;
          if (g3 >>> 0 < f2 >>> 0)
            jC(a3);
          else {
            m2 = c2[a3 >> 2] | 0;
            o3 = ((c2[a3 + 8 >> 2] | 0) - m2 | 0) / 12 | 0;
            n3 = o3 << 1;
            Zj(i4, o3 >>> 0 < g3 >>> 1 >>> 0 ? n3 >>> 0 < f2 >>> 0 ? f2 : n3 : g3, ((c2[j2 >> 2] | 0) - m2 | 0) / 12 | 0, a3 + 8 | 0);
            j2 = i4 + 8 | 0;
            g3 = c2[j2 >> 2] | 0;
            f2 = c2[b3 + 4 >> 2] | 0;
            d2 = c2[d2 >> 2] | 0;
            c2[h2 >> 2] = c2[b3 >> 2];
            c2[h2 + 4 >> 2] = f2;
            c2[e3 >> 2] = c2[h2 >> 2];
            c2[e3 + 4 >> 2] = c2[h2 + 4 >> 2];
            Wj(g3, e3, d2);
            c2[j2 >> 2] = (c2[j2 >> 2] | 0) + 12;
            _j(a3, i4);
            $j(i4);
            l2 = k2;
            return;
          }
        }
        function Yj(a3) {
          a3 = a3 | 0;
          return 357913941;
        }
        function Zj(a3, b3, d2, e3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          e3 = e3 | 0;
          var f2 = 0;
          c2[a3 + 12 >> 2] = 0;
          c2[a3 + 16 >> 2] = e3;
          do
            if (b3) {
              if (b3 >>> 0 > 357913941)
                Ta();
              else {
                f2 = qC(b3 * 12 | 0) | 0;
                break;
              }
            } else
              f2 = 0;
          while (0);
          c2[a3 >> 2] = f2;
          e3 = f2 + (d2 * 12 | 0) | 0;
          c2[a3 + 8 >> 2] = e3;
          c2[a3 + 4 >> 2] = e3;
          c2[a3 + 12 >> 2] = f2 + (b3 * 12 | 0);
          return;
        }
        function _j(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          var d2 = 0, e3 = 0, f2 = 0, g3 = 0, h2 = 0;
          e3 = c2[a3 >> 2] | 0;
          h2 = a3 + 4 | 0;
          g3 = b3 + 4 | 0;
          f2 = (c2[h2 >> 2] | 0) - e3 | 0;
          d2 = (c2[g3 >> 2] | 0) + (((f2 | 0) / -12 | 0) * 12 | 0) | 0;
          c2[g3 >> 2] = d2;
          if ((f2 | 0) > 0) {
            BC(d2 | 0, e3 | 0, f2 | 0) | 0;
            e3 = g3;
            d2 = c2[g3 >> 2] | 0;
          } else
            e3 = g3;
          g3 = c2[a3 >> 2] | 0;
          c2[a3 >> 2] = d2;
          c2[e3 >> 2] = g3;
          g3 = b3 + 8 | 0;
          f2 = c2[h2 >> 2] | 0;
          c2[h2 >> 2] = c2[g3 >> 2];
          c2[g3 >> 2] = f2;
          g3 = a3 + 8 | 0;
          h2 = b3 + 12 | 0;
          a3 = c2[g3 >> 2] | 0;
          c2[g3 >> 2] = c2[h2 >> 2];
          c2[h2 >> 2] = a3;
          c2[b3 >> 2] = c2[e3 >> 2];
          return;
        }
        function $j(a3) {
          a3 = a3 | 0;
          var b3 = 0, d2 = 0, e3 = 0;
          b3 = c2[a3 + 4 >> 2] | 0;
          d2 = a3 + 8 | 0;
          e3 = c2[d2 >> 2] | 0;
          if ((e3 | 0) != (b3 | 0))
            c2[d2 >> 2] = e3 + (~(((e3 + -12 - b3 | 0) >>> 0) / 12 | 0) * 12 | 0);
          a3 = c2[a3 >> 2] | 0;
          if (a3 | 0)
            sC(a3);
          return;
        }
        function ak(a3) {
          a3 = a3 | 0;
          dk(a3);
          return;
        }
        function bk(a3) {
          a3 = a3 | 0;
          ck(a3 + 24 | 0);
          return;
        }
        function ck(a3) {
          a3 = a3 | 0;
          var b3 = 0, d2 = 0, e3 = 0;
          d2 = c2[a3 >> 2] | 0;
          e3 = d2;
          if (d2 | 0) {
            a3 = a3 + 4 | 0;
            b3 = c2[a3 >> 2] | 0;
            if ((b3 | 0) != (d2 | 0))
              c2[a3 >> 2] = b3 + (~(((b3 + -12 - e3 | 0) >>> 0) / 12 | 0) * 12 | 0);
            sC(d2);
          }
          return;
        }
        function dk(a3) {
          a3 = a3 | 0;
          var b3 = 0;
          b3 = vi() | 0;
          yi(a3, 2, 5, b3, ek() | 0, 1);
          c2[a3 + 24 >> 2] = 0;
          c2[a3 + 28 >> 2] = 0;
          c2[a3 + 32 >> 2] = 0;
          return;
        }
        function ek() {
          return 1164;
        }
        function fk(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          var e3 = 0, f2 = 0, g3 = 0, h2 = 0;
          e3 = l2;
          l2 = l2 + 16 | 0;
          f2 = e3 + 8 | 0;
          g3 = e3;
          h2 = gk(a3) | 0;
          a3 = c2[h2 + 4 >> 2] | 0;
          c2[g3 >> 2] = c2[h2 >> 2];
          c2[g3 + 4 >> 2] = a3;
          c2[f2 >> 2] = c2[g3 >> 2];
          c2[f2 + 4 >> 2] = c2[g3 + 4 >> 2];
          hk(b3, f2, d2);
          l2 = e3;
          return;
        }
        function gk(a3) {
          a3 = a3 | 0;
          return (c2[(Tj() | 0) + 24 >> 2] | 0) + (a3 * 12 | 0) | 0;
        }
        function hk(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          var e3 = 0, f2 = 0, g3 = 0;
          g3 = l2;
          l2 = l2 + 16 | 0;
          f2 = g3;
          e3 = c2[b3 >> 2] | 0;
          b3 = c2[b3 + 4 >> 2] | 0;
          a3 = a3 + (b3 >> 1) | 0;
          if (b3 & 1)
            e3 = c2[(c2[a3 >> 2] | 0) + e3 >> 2] | 0;
          ik(f2, d2);
          d2 = jk(f2, d2) | 0;
          ob[e3 & 31](a3, d2);
          kk(f2);
          l2 = g3;
          return;
        }
        function ik(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          lk(a3, b3);
          return;
        }
        function jk(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          return a3 | 0;
        }
        function kk(a3) {
          a3 = a3 | 0;
          vf(a3);
          return;
        }
        function lk(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          mk(a3, b3);
          return;
        }
        function mk(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          c2[a3 >> 2] = b3;
          return;
        }
        function nk(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          var e3 = 0, f2 = 0, g3 = 0, h2 = 0, i4 = 0;
          e3 = l2;
          l2 = l2 + 16 | 0;
          f2 = e3 + 8 | 0;
          g3 = e3;
          i4 = c2[d2 >> 2] | 0;
          h2 = c2[d2 + 4 >> 2] | 0;
          d2 = ai(b3) | 0;
          c2[g3 >> 2] = i4;
          c2[g3 + 4 >> 2] = h2;
          c2[f2 >> 2] = c2[g3 >> 2];
          c2[f2 + 4 >> 2] = c2[g3 + 4 >> 2];
          ok(a3, d2, f2, 0);
          l2 = e3;
          return;
        }
        function ok(a3, b3, d2, e3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          e3 = e3 | 0;
          var f2 = 0, g3 = 0, h2 = 0, i4 = 0, j2 = 0, k2 = 0, m2 = 0;
          f2 = l2;
          l2 = l2 + 32 | 0;
          g3 = f2 + 16 | 0;
          m2 = f2 + 8 | 0;
          i4 = f2;
          k2 = c2[d2 >> 2] | 0;
          j2 = c2[d2 + 4 >> 2] | 0;
          h2 = c2[a3 >> 2] | 0;
          a3 = pk() | 0;
          c2[m2 >> 2] = k2;
          c2[m2 + 4 >> 2] = j2;
          c2[g3 >> 2] = c2[m2 >> 2];
          c2[g3 + 4 >> 2] = c2[m2 + 4 >> 2];
          d2 = qk(g3) | 0;
          c2[i4 >> 2] = k2;
          c2[i4 + 4 >> 2] = j2;
          c2[g3 >> 2] = c2[i4 >> 2];
          c2[g3 + 4 >> 2] = c2[i4 + 4 >> 2];
          fi(h2, b3, a3, d2, rk(g3, e3) | 0, e3);
          l2 = f2;
          return;
        }
        function pk() {
          var b3 = 0, d2 = 0;
          if (!(a2[7664] | 0)) {
            yk(9340);
            Ha(29, 9340, o2 | 0) | 0;
            d2 = 7664;
            c2[d2 >> 2] = 1;
            c2[d2 + 4 >> 2] = 0;
          }
          if (!(si(9340) | 0)) {
            b3 = 9340;
            d2 = b3 + 36 | 0;
            do {
              c2[b3 >> 2] = 0;
              b3 = b3 + 4 | 0;
            } while ((b3 | 0) < (d2 | 0));
            yk(9340);
          }
          return 9340;
        }
        function qk(a3) {
          a3 = a3 | 0;
          return 0;
        }
        function rk(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          var d2 = 0, e3 = 0, f2 = 0, g3 = 0, h2 = 0, i4 = 0, j2 = 0, k2 = 0, m2 = 0, n3 = 0;
          m2 = l2;
          l2 = l2 + 32 | 0;
          f2 = m2 + 24 | 0;
          h2 = m2 + 16 | 0;
          i4 = m2;
          j2 = m2 + 8 | 0;
          g3 = c2[a3 >> 2] | 0;
          e3 = c2[a3 + 4 >> 2] | 0;
          c2[i4 >> 2] = g3;
          c2[i4 + 4 >> 2] = e3;
          n3 = pk() | 0;
          k2 = n3 + 24 | 0;
          a3 = ji(b3, 4) | 0;
          c2[j2 >> 2] = a3;
          b3 = n3 + 28 | 0;
          d2 = c2[b3 >> 2] | 0;
          if (d2 >>> 0 < (c2[n3 + 32 >> 2] | 0) >>> 0) {
            c2[h2 >> 2] = g3;
            c2[h2 + 4 >> 2] = e3;
            c2[f2 >> 2] = c2[h2 >> 2];
            c2[f2 + 4 >> 2] = c2[h2 + 4 >> 2];
            sk(d2, f2, a3);
            a3 = (c2[b3 >> 2] | 0) + 12 | 0;
            c2[b3 >> 2] = a3;
          } else {
            tk(k2, i4, j2);
            a3 = c2[b3 >> 2] | 0;
          }
          l2 = m2;
          return ((a3 - (c2[k2 >> 2] | 0) | 0) / 12 | 0) + -1 | 0;
        }
        function sk(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          var e3 = 0;
          e3 = c2[b3 + 4 >> 2] | 0;
          c2[a3 >> 2] = c2[b3 >> 2];
          c2[a3 + 4 >> 2] = e3;
          c2[a3 + 8 >> 2] = d2;
          return;
        }
        function tk(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          var e3 = 0, f2 = 0, g3 = 0, h2 = 0, i4 = 0, j2 = 0, k2 = 0, m2 = 0, n3 = 0, o3 = 0;
          k2 = l2;
          l2 = l2 + 48 | 0;
          e3 = k2 + 32 | 0;
          h2 = k2 + 24 | 0;
          i4 = k2;
          j2 = a3 + 4 | 0;
          f2 = (((c2[j2 >> 2] | 0) - (c2[a3 >> 2] | 0) | 0) / 12 | 0) + 1 | 0;
          g3 = uk(a3) | 0;
          if (g3 >>> 0 < f2 >>> 0)
            jC(a3);
          else {
            m2 = c2[a3 >> 2] | 0;
            o3 = ((c2[a3 + 8 >> 2] | 0) - m2 | 0) / 12 | 0;
            n3 = o3 << 1;
            vk(i4, o3 >>> 0 < g3 >>> 1 >>> 0 ? n3 >>> 0 < f2 >>> 0 ? f2 : n3 : g3, ((c2[j2 >> 2] | 0) - m2 | 0) / 12 | 0, a3 + 8 | 0);
            j2 = i4 + 8 | 0;
            g3 = c2[j2 >> 2] | 0;
            f2 = c2[b3 + 4 >> 2] | 0;
            d2 = c2[d2 >> 2] | 0;
            c2[h2 >> 2] = c2[b3 >> 2];
            c2[h2 + 4 >> 2] = f2;
            c2[e3 >> 2] = c2[h2 >> 2];
            c2[e3 + 4 >> 2] = c2[h2 + 4 >> 2];
            sk(g3, e3, d2);
            c2[j2 >> 2] = (c2[j2 >> 2] | 0) + 12;
            wk(a3, i4);
            xk(i4);
            l2 = k2;
            return;
          }
        }
        function uk(a3) {
          a3 = a3 | 0;
          return 357913941;
        }
        function vk(a3, b3, d2, e3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          e3 = e3 | 0;
          var f2 = 0;
          c2[a3 + 12 >> 2] = 0;
          c2[a3 + 16 >> 2] = e3;
          do
            if (b3) {
              if (b3 >>> 0 > 357913941)
                Ta();
              else {
                f2 = qC(b3 * 12 | 0) | 0;
                break;
              }
            } else
              f2 = 0;
          while (0);
          c2[a3 >> 2] = f2;
          e3 = f2 + (d2 * 12 | 0) | 0;
          c2[a3 + 8 >> 2] = e3;
          c2[a3 + 4 >> 2] = e3;
          c2[a3 + 12 >> 2] = f2 + (b3 * 12 | 0);
          return;
        }
        function wk(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          var d2 = 0, e3 = 0, f2 = 0, g3 = 0, h2 = 0;
          e3 = c2[a3 >> 2] | 0;
          h2 = a3 + 4 | 0;
          g3 = b3 + 4 | 0;
          f2 = (c2[h2 >> 2] | 0) - e3 | 0;
          d2 = (c2[g3 >> 2] | 0) + (((f2 | 0) / -12 | 0) * 12 | 0) | 0;
          c2[g3 >> 2] = d2;
          if ((f2 | 0) > 0) {
            BC(d2 | 0, e3 | 0, f2 | 0) | 0;
            e3 = g3;
            d2 = c2[g3 >> 2] | 0;
          } else
            e3 = g3;
          g3 = c2[a3 >> 2] | 0;
          c2[a3 >> 2] = d2;
          c2[e3 >> 2] = g3;
          g3 = b3 + 8 | 0;
          f2 = c2[h2 >> 2] | 0;
          c2[h2 >> 2] = c2[g3 >> 2];
          c2[g3 >> 2] = f2;
          g3 = a3 + 8 | 0;
          h2 = b3 + 12 | 0;
          a3 = c2[g3 >> 2] | 0;
          c2[g3 >> 2] = c2[h2 >> 2];
          c2[h2 >> 2] = a3;
          c2[b3 >> 2] = c2[e3 >> 2];
          return;
        }
        function xk(a3) {
          a3 = a3 | 0;
          var b3 = 0, d2 = 0, e3 = 0;
          b3 = c2[a3 + 4 >> 2] | 0;
          d2 = a3 + 8 | 0;
          e3 = c2[d2 >> 2] | 0;
          if ((e3 | 0) != (b3 | 0))
            c2[d2 >> 2] = e3 + (~(((e3 + -12 - b3 | 0) >>> 0) / 12 | 0) * 12 | 0);
          a3 = c2[a3 >> 2] | 0;
          if (a3 | 0)
            sC(a3);
          return;
        }
        function yk(a3) {
          a3 = a3 | 0;
          Bk(a3);
          return;
        }
        function zk(a3) {
          a3 = a3 | 0;
          Ak(a3 + 24 | 0);
          return;
        }
        function Ak(a3) {
          a3 = a3 | 0;
          var b3 = 0, d2 = 0, e3 = 0;
          d2 = c2[a3 >> 2] | 0;
          e3 = d2;
          if (d2 | 0) {
            a3 = a3 + 4 | 0;
            b3 = c2[a3 >> 2] | 0;
            if ((b3 | 0) != (d2 | 0))
              c2[a3 >> 2] = b3 + (~(((b3 + -12 - e3 | 0) >>> 0) / 12 | 0) * 12 | 0);
            sC(d2);
          }
          return;
        }
        function Bk(a3) {
          a3 = a3 | 0;
          var b3 = 0;
          b3 = vi() | 0;
          yi(a3, 2, 4, b3, Ck() | 0, 1);
          c2[a3 + 24 >> 2] = 0;
          c2[a3 + 28 >> 2] = 0;
          c2[a3 + 32 >> 2] = 0;
          return;
        }
        function Ck() {
          return 1180;
        }
        function Dk(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          var e3 = 0, f2 = 0, g3 = 0, h2 = 0;
          e3 = l2;
          l2 = l2 + 16 | 0;
          f2 = e3 + 8 | 0;
          g3 = e3;
          h2 = Ek(a3) | 0;
          a3 = c2[h2 + 4 >> 2] | 0;
          c2[g3 >> 2] = c2[h2 >> 2];
          c2[g3 + 4 >> 2] = a3;
          c2[f2 >> 2] = c2[g3 >> 2];
          c2[f2 + 4 >> 2] = c2[g3 + 4 >> 2];
          d2 = Fk(b3, f2, d2) | 0;
          l2 = e3;
          return d2 | 0;
        }
        function Ek(a3) {
          a3 = a3 | 0;
          return (c2[(pk() | 0) + 24 >> 2] | 0) + (a3 * 12 | 0) | 0;
        }
        function Fk(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          var e3 = 0, f2 = 0, g3 = 0;
          g3 = l2;
          l2 = l2 + 16 | 0;
          f2 = g3;
          e3 = c2[b3 >> 2] | 0;
          b3 = c2[b3 + 4 >> 2] | 0;
          a3 = a3 + (b3 >> 1) | 0;
          if (b3 & 1)
            e3 = c2[(c2[a3 >> 2] | 0) + e3 >> 2] | 0;
          Gk(f2, d2);
          f2 = Hk(f2, d2) | 0;
          f2 = Ik(wb[e3 & 15](a3, f2) | 0) | 0;
          l2 = g3;
          return f2 | 0;
        }
        function Gk(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          return;
        }
        function Hk(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          return Jk(b3) | 0;
        }
        function Ik(a3) {
          a3 = a3 | 0;
          return a3 | 0;
        }
        function Jk(a3) {
          a3 = a3 | 0;
          return a3 | 0;
        }
        function Kk(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          var e3 = 0, f2 = 0, g3 = 0, h2 = 0, i4 = 0;
          e3 = l2;
          l2 = l2 + 16 | 0;
          f2 = e3 + 8 | 0;
          g3 = e3;
          i4 = c2[d2 >> 2] | 0;
          h2 = c2[d2 + 4 >> 2] | 0;
          d2 = ai(b3) | 0;
          c2[g3 >> 2] = i4;
          c2[g3 + 4 >> 2] = h2;
          c2[f2 >> 2] = c2[g3 >> 2];
          c2[f2 + 4 >> 2] = c2[g3 + 4 >> 2];
          Lk(a3, d2, f2, 0);
          l2 = e3;
          return;
        }
        function Lk(a3, b3, d2, e3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          e3 = e3 | 0;
          var f2 = 0, g3 = 0, h2 = 0, i4 = 0, j2 = 0, k2 = 0, m2 = 0;
          f2 = l2;
          l2 = l2 + 32 | 0;
          g3 = f2 + 16 | 0;
          m2 = f2 + 8 | 0;
          i4 = f2;
          k2 = c2[d2 >> 2] | 0;
          j2 = c2[d2 + 4 >> 2] | 0;
          h2 = c2[a3 >> 2] | 0;
          a3 = Mk() | 0;
          c2[m2 >> 2] = k2;
          c2[m2 + 4 >> 2] = j2;
          c2[g3 >> 2] = c2[m2 >> 2];
          c2[g3 + 4 >> 2] = c2[m2 + 4 >> 2];
          d2 = Nk(g3) | 0;
          c2[i4 >> 2] = k2;
          c2[i4 + 4 >> 2] = j2;
          c2[g3 >> 2] = c2[i4 >> 2];
          c2[g3 + 4 >> 2] = c2[i4 + 4 >> 2];
          fi(h2, b3, a3, d2, Ok(g3, e3) | 0, e3);
          l2 = f2;
          return;
        }
        function Mk() {
          var b3 = 0, d2 = 0;
          if (!(a2[7672] | 0)) {
            Vk(9376);
            Ha(30, 9376, o2 | 0) | 0;
            d2 = 7672;
            c2[d2 >> 2] = 1;
            c2[d2 + 4 >> 2] = 0;
          }
          if (!(si(9376) | 0)) {
            b3 = 9376;
            d2 = b3 + 36 | 0;
            do {
              c2[b3 >> 2] = 0;
              b3 = b3 + 4 | 0;
            } while ((b3 | 0) < (d2 | 0));
            Vk(9376);
          }
          return 9376;
        }
        function Nk(a3) {
          a3 = a3 | 0;
          return 0;
        }
        function Ok(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          var d2 = 0, e3 = 0, f2 = 0, g3 = 0, h2 = 0, i4 = 0, j2 = 0, k2 = 0, m2 = 0, n3 = 0;
          m2 = l2;
          l2 = l2 + 32 | 0;
          f2 = m2 + 24 | 0;
          h2 = m2 + 16 | 0;
          i4 = m2;
          j2 = m2 + 8 | 0;
          g3 = c2[a3 >> 2] | 0;
          e3 = c2[a3 + 4 >> 2] | 0;
          c2[i4 >> 2] = g3;
          c2[i4 + 4 >> 2] = e3;
          n3 = Mk() | 0;
          k2 = n3 + 24 | 0;
          a3 = ji(b3, 4) | 0;
          c2[j2 >> 2] = a3;
          b3 = n3 + 28 | 0;
          d2 = c2[b3 >> 2] | 0;
          if (d2 >>> 0 < (c2[n3 + 32 >> 2] | 0) >>> 0) {
            c2[h2 >> 2] = g3;
            c2[h2 + 4 >> 2] = e3;
            c2[f2 >> 2] = c2[h2 >> 2];
            c2[f2 + 4 >> 2] = c2[h2 + 4 >> 2];
            Pk(d2, f2, a3);
            a3 = (c2[b3 >> 2] | 0) + 12 | 0;
            c2[b3 >> 2] = a3;
          } else {
            Qk(k2, i4, j2);
            a3 = c2[b3 >> 2] | 0;
          }
          l2 = m2;
          return ((a3 - (c2[k2 >> 2] | 0) | 0) / 12 | 0) + -1 | 0;
        }
        function Pk(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          var e3 = 0;
          e3 = c2[b3 + 4 >> 2] | 0;
          c2[a3 >> 2] = c2[b3 >> 2];
          c2[a3 + 4 >> 2] = e3;
          c2[a3 + 8 >> 2] = d2;
          return;
        }
        function Qk(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          var e3 = 0, f2 = 0, g3 = 0, h2 = 0, i4 = 0, j2 = 0, k2 = 0, m2 = 0, n3 = 0, o3 = 0;
          k2 = l2;
          l2 = l2 + 48 | 0;
          e3 = k2 + 32 | 0;
          h2 = k2 + 24 | 0;
          i4 = k2;
          j2 = a3 + 4 | 0;
          f2 = (((c2[j2 >> 2] | 0) - (c2[a3 >> 2] | 0) | 0) / 12 | 0) + 1 | 0;
          g3 = Rk(a3) | 0;
          if (g3 >>> 0 < f2 >>> 0)
            jC(a3);
          else {
            m2 = c2[a3 >> 2] | 0;
            o3 = ((c2[a3 + 8 >> 2] | 0) - m2 | 0) / 12 | 0;
            n3 = o3 << 1;
            Sk(i4, o3 >>> 0 < g3 >>> 1 >>> 0 ? n3 >>> 0 < f2 >>> 0 ? f2 : n3 : g3, ((c2[j2 >> 2] | 0) - m2 | 0) / 12 | 0, a3 + 8 | 0);
            j2 = i4 + 8 | 0;
            g3 = c2[j2 >> 2] | 0;
            f2 = c2[b3 + 4 >> 2] | 0;
            d2 = c2[d2 >> 2] | 0;
            c2[h2 >> 2] = c2[b3 >> 2];
            c2[h2 + 4 >> 2] = f2;
            c2[e3 >> 2] = c2[h2 >> 2];
            c2[e3 + 4 >> 2] = c2[h2 + 4 >> 2];
            Pk(g3, e3, d2);
            c2[j2 >> 2] = (c2[j2 >> 2] | 0) + 12;
            Tk(a3, i4);
            Uk(i4);
            l2 = k2;
            return;
          }
        }
        function Rk(a3) {
          a3 = a3 | 0;
          return 357913941;
        }
        function Sk(a3, b3, d2, e3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          e3 = e3 | 0;
          var f2 = 0;
          c2[a3 + 12 >> 2] = 0;
          c2[a3 + 16 >> 2] = e3;
          do
            if (b3) {
              if (b3 >>> 0 > 357913941)
                Ta();
              else {
                f2 = qC(b3 * 12 | 0) | 0;
                break;
              }
            } else
              f2 = 0;
          while (0);
          c2[a3 >> 2] = f2;
          e3 = f2 + (d2 * 12 | 0) | 0;
          c2[a3 + 8 >> 2] = e3;
          c2[a3 + 4 >> 2] = e3;
          c2[a3 + 12 >> 2] = f2 + (b3 * 12 | 0);
          return;
        }
        function Tk(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          var d2 = 0, e3 = 0, f2 = 0, g3 = 0, h2 = 0;
          e3 = c2[a3 >> 2] | 0;
          h2 = a3 + 4 | 0;
          g3 = b3 + 4 | 0;
          f2 = (c2[h2 >> 2] | 0) - e3 | 0;
          d2 = (c2[g3 >> 2] | 0) + (((f2 | 0) / -12 | 0) * 12 | 0) | 0;
          c2[g3 >> 2] = d2;
          if ((f2 | 0) > 0) {
            BC(d2 | 0, e3 | 0, f2 | 0) | 0;
            e3 = g3;
            d2 = c2[g3 >> 2] | 0;
          } else
            e3 = g3;
          g3 = c2[a3 >> 2] | 0;
          c2[a3 >> 2] = d2;
          c2[e3 >> 2] = g3;
          g3 = b3 + 8 | 0;
          f2 = c2[h2 >> 2] | 0;
          c2[h2 >> 2] = c2[g3 >> 2];
          c2[g3 >> 2] = f2;
          g3 = a3 + 8 | 0;
          h2 = b3 + 12 | 0;
          a3 = c2[g3 >> 2] | 0;
          c2[g3 >> 2] = c2[h2 >> 2];
          c2[h2 >> 2] = a3;
          c2[b3 >> 2] = c2[e3 >> 2];
          return;
        }
        function Uk(a3) {
          a3 = a3 | 0;
          var b3 = 0, d2 = 0, e3 = 0;
          b3 = c2[a3 + 4 >> 2] | 0;
          d2 = a3 + 8 | 0;
          e3 = c2[d2 >> 2] | 0;
          if ((e3 | 0) != (b3 | 0))
            c2[d2 >> 2] = e3 + (~(((e3 + -12 - b3 | 0) >>> 0) / 12 | 0) * 12 | 0);
          a3 = c2[a3 >> 2] | 0;
          if (a3 | 0)
            sC(a3);
          return;
        }
        function Vk(a3) {
          a3 = a3 | 0;
          Yk(a3);
          return;
        }
        function Wk(a3) {
          a3 = a3 | 0;
          Xk(a3 + 24 | 0);
          return;
        }
        function Xk(a3) {
          a3 = a3 | 0;
          var b3 = 0, d2 = 0, e3 = 0;
          d2 = c2[a3 >> 2] | 0;
          e3 = d2;
          if (d2 | 0) {
            a3 = a3 + 4 | 0;
            b3 = c2[a3 >> 2] | 0;
            if ((b3 | 0) != (d2 | 0))
              c2[a3 >> 2] = b3 + (~(((b3 + -12 - e3 | 0) >>> 0) / 12 | 0) * 12 | 0);
            sC(d2);
          }
          return;
        }
        function Yk(a3) {
          a3 = a3 | 0;
          var b3 = 0;
          b3 = vi() | 0;
          yi(a3, 2, 5, b3, Zk() | 0, 0);
          c2[a3 + 24 >> 2] = 0;
          c2[a3 + 28 >> 2] = 0;
          c2[a3 + 32 >> 2] = 0;
          return;
        }
        function Zk() {
          return 1196;
        }
        function _k(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          var d2 = 0, e3 = 0, f2 = 0, g3 = 0;
          d2 = l2;
          l2 = l2 + 16 | 0;
          e3 = d2 + 8 | 0;
          f2 = d2;
          g3 = $k(a3) | 0;
          a3 = c2[g3 + 4 >> 2] | 0;
          c2[f2 >> 2] = c2[g3 >> 2];
          c2[f2 + 4 >> 2] = a3;
          c2[e3 >> 2] = c2[f2 >> 2];
          c2[e3 + 4 >> 2] = c2[f2 + 4 >> 2];
          b3 = al(b3, e3) | 0;
          l2 = d2;
          return b3 | 0;
        }
        function $k(a3) {
          a3 = a3 | 0;
          return (c2[(Mk() | 0) + 24 >> 2] | 0) + (a3 * 12 | 0) | 0;
        }
        function al(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          var d2 = 0;
          d2 = c2[b3 >> 2] | 0;
          b3 = c2[b3 + 4 >> 2] | 0;
          a3 = a3 + (b3 >> 1) | 0;
          if (b3 & 1)
            d2 = c2[(c2[a3 >> 2] | 0) + d2 >> 2] | 0;
          return Ik(pb[d2 & 31](a3) | 0) | 0;
        }
        function bl(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          var e3 = 0, f2 = 0, g3 = 0, h2 = 0, i4 = 0;
          e3 = l2;
          l2 = l2 + 16 | 0;
          f2 = e3 + 8 | 0;
          g3 = e3;
          i4 = c2[d2 >> 2] | 0;
          h2 = c2[d2 + 4 >> 2] | 0;
          d2 = ai(b3) | 0;
          c2[g3 >> 2] = i4;
          c2[g3 + 4 >> 2] = h2;
          c2[f2 >> 2] = c2[g3 >> 2];
          c2[f2 + 4 >> 2] = c2[g3 + 4 >> 2];
          cl(a3, d2, f2, 1);
          l2 = e3;
          return;
        }
        function cl(a3, b3, d2, e3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          e3 = e3 | 0;
          var f2 = 0, g3 = 0, h2 = 0, i4 = 0, j2 = 0, k2 = 0, m2 = 0;
          f2 = l2;
          l2 = l2 + 32 | 0;
          g3 = f2 + 16 | 0;
          m2 = f2 + 8 | 0;
          i4 = f2;
          k2 = c2[d2 >> 2] | 0;
          j2 = c2[d2 + 4 >> 2] | 0;
          h2 = c2[a3 >> 2] | 0;
          a3 = dl() | 0;
          c2[m2 >> 2] = k2;
          c2[m2 + 4 >> 2] = j2;
          c2[g3 >> 2] = c2[m2 >> 2];
          c2[g3 + 4 >> 2] = c2[m2 + 4 >> 2];
          d2 = el(g3) | 0;
          c2[i4 >> 2] = k2;
          c2[i4 + 4 >> 2] = j2;
          c2[g3 >> 2] = c2[i4 >> 2];
          c2[g3 + 4 >> 2] = c2[i4 + 4 >> 2];
          fi(h2, b3, a3, d2, fl(g3, e3) | 0, e3);
          l2 = f2;
          return;
        }
        function dl() {
          var b3 = 0, d2 = 0;
          if (!(a2[7680] | 0)) {
            ml(9412);
            Ha(31, 9412, o2 | 0) | 0;
            d2 = 7680;
            c2[d2 >> 2] = 1;
            c2[d2 + 4 >> 2] = 0;
          }
          if (!(si(9412) | 0)) {
            b3 = 9412;
            d2 = b3 + 36 | 0;
            do {
              c2[b3 >> 2] = 0;
              b3 = b3 + 4 | 0;
            } while ((b3 | 0) < (d2 | 0));
            ml(9412);
          }
          return 9412;
        }
        function el(a3) {
          a3 = a3 | 0;
          return 0;
        }
        function fl(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          var d2 = 0, e3 = 0, f2 = 0, g3 = 0, h2 = 0, i4 = 0, j2 = 0, k2 = 0, m2 = 0, n3 = 0;
          m2 = l2;
          l2 = l2 + 32 | 0;
          f2 = m2 + 24 | 0;
          h2 = m2 + 16 | 0;
          i4 = m2;
          j2 = m2 + 8 | 0;
          g3 = c2[a3 >> 2] | 0;
          e3 = c2[a3 + 4 >> 2] | 0;
          c2[i4 >> 2] = g3;
          c2[i4 + 4 >> 2] = e3;
          n3 = dl() | 0;
          k2 = n3 + 24 | 0;
          a3 = ji(b3, 4) | 0;
          c2[j2 >> 2] = a3;
          b3 = n3 + 28 | 0;
          d2 = c2[b3 >> 2] | 0;
          if (d2 >>> 0 < (c2[n3 + 32 >> 2] | 0) >>> 0) {
            c2[h2 >> 2] = g3;
            c2[h2 + 4 >> 2] = e3;
            c2[f2 >> 2] = c2[h2 >> 2];
            c2[f2 + 4 >> 2] = c2[h2 + 4 >> 2];
            gl(d2, f2, a3);
            a3 = (c2[b3 >> 2] | 0) + 12 | 0;
            c2[b3 >> 2] = a3;
          } else {
            hl(k2, i4, j2);
            a3 = c2[b3 >> 2] | 0;
          }
          l2 = m2;
          return ((a3 - (c2[k2 >> 2] | 0) | 0) / 12 | 0) + -1 | 0;
        }
        function gl(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          var e3 = 0;
          e3 = c2[b3 + 4 >> 2] | 0;
          c2[a3 >> 2] = c2[b3 >> 2];
          c2[a3 + 4 >> 2] = e3;
          c2[a3 + 8 >> 2] = d2;
          return;
        }
        function hl(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          var e3 = 0, f2 = 0, g3 = 0, h2 = 0, i4 = 0, j2 = 0, k2 = 0, m2 = 0, n3 = 0, o3 = 0;
          k2 = l2;
          l2 = l2 + 48 | 0;
          e3 = k2 + 32 | 0;
          h2 = k2 + 24 | 0;
          i4 = k2;
          j2 = a3 + 4 | 0;
          f2 = (((c2[j2 >> 2] | 0) - (c2[a3 >> 2] | 0) | 0) / 12 | 0) + 1 | 0;
          g3 = il(a3) | 0;
          if (g3 >>> 0 < f2 >>> 0)
            jC(a3);
          else {
            m2 = c2[a3 >> 2] | 0;
            o3 = ((c2[a3 + 8 >> 2] | 0) - m2 | 0) / 12 | 0;
            n3 = o3 << 1;
            jl(i4, o3 >>> 0 < g3 >>> 1 >>> 0 ? n3 >>> 0 < f2 >>> 0 ? f2 : n3 : g3, ((c2[j2 >> 2] | 0) - m2 | 0) / 12 | 0, a3 + 8 | 0);
            j2 = i4 + 8 | 0;
            g3 = c2[j2 >> 2] | 0;
            f2 = c2[b3 + 4 >> 2] | 0;
            d2 = c2[d2 >> 2] | 0;
            c2[h2 >> 2] = c2[b3 >> 2];
            c2[h2 + 4 >> 2] = f2;
            c2[e3 >> 2] = c2[h2 >> 2];
            c2[e3 + 4 >> 2] = c2[h2 + 4 >> 2];
            gl(g3, e3, d2);
            c2[j2 >> 2] = (c2[j2 >> 2] | 0) + 12;
            kl(a3, i4);
            ll(i4);
            l2 = k2;
            return;
          }
        }
        function il(a3) {
          a3 = a3 | 0;
          return 357913941;
        }
        function jl(a3, b3, d2, e3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          e3 = e3 | 0;
          var f2 = 0;
          c2[a3 + 12 >> 2] = 0;
          c2[a3 + 16 >> 2] = e3;
          do
            if (b3) {
              if (b3 >>> 0 > 357913941)
                Ta();
              else {
                f2 = qC(b3 * 12 | 0) | 0;
                break;
              }
            } else
              f2 = 0;
          while (0);
          c2[a3 >> 2] = f2;
          e3 = f2 + (d2 * 12 | 0) | 0;
          c2[a3 + 8 >> 2] = e3;
          c2[a3 + 4 >> 2] = e3;
          c2[a3 + 12 >> 2] = f2 + (b3 * 12 | 0);
          return;
        }
        function kl(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          var d2 = 0, e3 = 0, f2 = 0, g3 = 0, h2 = 0;
          e3 = c2[a3 >> 2] | 0;
          h2 = a3 + 4 | 0;
          g3 = b3 + 4 | 0;
          f2 = (c2[h2 >> 2] | 0) - e3 | 0;
          d2 = (c2[g3 >> 2] | 0) + (((f2 | 0) / -12 | 0) * 12 | 0) | 0;
          c2[g3 >> 2] = d2;
          if ((f2 | 0) > 0) {
            BC(d2 | 0, e3 | 0, f2 | 0) | 0;
            e3 = g3;
            d2 = c2[g3 >> 2] | 0;
          } else
            e3 = g3;
          g3 = c2[a3 >> 2] | 0;
          c2[a3 >> 2] = d2;
          c2[e3 >> 2] = g3;
          g3 = b3 + 8 | 0;
          f2 = c2[h2 >> 2] | 0;
          c2[h2 >> 2] = c2[g3 >> 2];
          c2[g3 >> 2] = f2;
          g3 = a3 + 8 | 0;
          h2 = b3 + 12 | 0;
          a3 = c2[g3 >> 2] | 0;
          c2[g3 >> 2] = c2[h2 >> 2];
          c2[h2 >> 2] = a3;
          c2[b3 >> 2] = c2[e3 >> 2];
          return;
        }
        function ll(a3) {
          a3 = a3 | 0;
          var b3 = 0, d2 = 0, e3 = 0;
          b3 = c2[a3 + 4 >> 2] | 0;
          d2 = a3 + 8 | 0;
          e3 = c2[d2 >> 2] | 0;
          if ((e3 | 0) != (b3 | 0))
            c2[d2 >> 2] = e3 + (~(((e3 + -12 - b3 | 0) >>> 0) / 12 | 0) * 12 | 0);
          a3 = c2[a3 >> 2] | 0;
          if (a3 | 0)
            sC(a3);
          return;
        }
        function ml(a3) {
          a3 = a3 | 0;
          pl(a3);
          return;
        }
        function nl(a3) {
          a3 = a3 | 0;
          ol(a3 + 24 | 0);
          return;
        }
        function ol(a3) {
          a3 = a3 | 0;
          var b3 = 0, d2 = 0, e3 = 0;
          d2 = c2[a3 >> 2] | 0;
          e3 = d2;
          if (d2 | 0) {
            a3 = a3 + 4 | 0;
            b3 = c2[a3 >> 2] | 0;
            if ((b3 | 0) != (d2 | 0))
              c2[a3 >> 2] = b3 + (~(((b3 + -12 - e3 | 0) >>> 0) / 12 | 0) * 12 | 0);
            sC(d2);
          }
          return;
        }
        function pl(a3) {
          a3 = a3 | 0;
          var b3 = 0;
          b3 = vi() | 0;
          yi(a3, 2, 6, b3, ql() | 0, 0);
          c2[a3 + 24 >> 2] = 0;
          c2[a3 + 28 >> 2] = 0;
          c2[a3 + 32 >> 2] = 0;
          return;
        }
        function ql() {
          return 1200;
        }
        function rl(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          var d2 = 0, e3 = 0, f2 = 0, g3 = 0;
          d2 = l2;
          l2 = l2 + 16 | 0;
          e3 = d2 + 8 | 0;
          f2 = d2;
          g3 = sl(a3) | 0;
          a3 = c2[g3 + 4 >> 2] | 0;
          c2[f2 >> 2] = c2[g3 >> 2];
          c2[f2 + 4 >> 2] = a3;
          c2[e3 >> 2] = c2[f2 >> 2];
          c2[e3 + 4 >> 2] = c2[f2 + 4 >> 2];
          b3 = tl(b3, e3) | 0;
          l2 = d2;
          return b3 | 0;
        }
        function sl(a3) {
          a3 = a3 | 0;
          return (c2[(dl() | 0) + 24 >> 2] | 0) + (a3 * 12 | 0) | 0;
        }
        function tl(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          var d2 = 0;
          d2 = c2[b3 >> 2] | 0;
          b3 = c2[b3 + 4 >> 2] | 0;
          a3 = a3 + (b3 >> 1) | 0;
          if (b3 & 1)
            d2 = c2[(c2[a3 >> 2] | 0) + d2 >> 2] | 0;
          return ul(pb[d2 & 31](a3) | 0) | 0;
        }
        function ul(a3) {
          a3 = a3 | 0;
          return a3 | 0;
        }
        function vl(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          var e3 = 0, f2 = 0, g3 = 0, h2 = 0, i4 = 0;
          e3 = l2;
          l2 = l2 + 16 | 0;
          f2 = e3 + 8 | 0;
          g3 = e3;
          i4 = c2[d2 >> 2] | 0;
          h2 = c2[d2 + 4 >> 2] | 0;
          d2 = ai(b3) | 0;
          c2[g3 >> 2] = i4;
          c2[g3 + 4 >> 2] = h2;
          c2[f2 >> 2] = c2[g3 >> 2];
          c2[f2 + 4 >> 2] = c2[g3 + 4 >> 2];
          wl(a3, d2, f2, 0);
          l2 = e3;
          return;
        }
        function wl(a3, b3, d2, e3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          e3 = e3 | 0;
          var f2 = 0, g3 = 0, h2 = 0, i4 = 0, j2 = 0, k2 = 0, m2 = 0;
          f2 = l2;
          l2 = l2 + 32 | 0;
          g3 = f2 + 16 | 0;
          m2 = f2 + 8 | 0;
          i4 = f2;
          k2 = c2[d2 >> 2] | 0;
          j2 = c2[d2 + 4 >> 2] | 0;
          h2 = c2[a3 >> 2] | 0;
          a3 = xl() | 0;
          c2[m2 >> 2] = k2;
          c2[m2 + 4 >> 2] = j2;
          c2[g3 >> 2] = c2[m2 >> 2];
          c2[g3 + 4 >> 2] = c2[m2 + 4 >> 2];
          d2 = yl(g3) | 0;
          c2[i4 >> 2] = k2;
          c2[i4 + 4 >> 2] = j2;
          c2[g3 >> 2] = c2[i4 >> 2];
          c2[g3 + 4 >> 2] = c2[i4 + 4 >> 2];
          fi(h2, b3, a3, d2, zl(g3, e3) | 0, e3);
          l2 = f2;
          return;
        }
        function xl() {
          var b3 = 0, d2 = 0;
          if (!(a2[7688] | 0)) {
            Gl(9448);
            Ha(32, 9448, o2 | 0) | 0;
            d2 = 7688;
            c2[d2 >> 2] = 1;
            c2[d2 + 4 >> 2] = 0;
          }
          if (!(si(9448) | 0)) {
            b3 = 9448;
            d2 = b3 + 36 | 0;
            do {
              c2[b3 >> 2] = 0;
              b3 = b3 + 4 | 0;
            } while ((b3 | 0) < (d2 | 0));
            Gl(9448);
          }
          return 9448;
        }
        function yl(a3) {
          a3 = a3 | 0;
          return 0;
        }
        function zl(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          var d2 = 0, e3 = 0, f2 = 0, g3 = 0, h2 = 0, i4 = 0, j2 = 0, k2 = 0, m2 = 0, n3 = 0;
          m2 = l2;
          l2 = l2 + 32 | 0;
          f2 = m2 + 24 | 0;
          h2 = m2 + 16 | 0;
          i4 = m2;
          j2 = m2 + 8 | 0;
          g3 = c2[a3 >> 2] | 0;
          e3 = c2[a3 + 4 >> 2] | 0;
          c2[i4 >> 2] = g3;
          c2[i4 + 4 >> 2] = e3;
          n3 = xl() | 0;
          k2 = n3 + 24 | 0;
          a3 = ji(b3, 4) | 0;
          c2[j2 >> 2] = a3;
          b3 = n3 + 28 | 0;
          d2 = c2[b3 >> 2] | 0;
          if (d2 >>> 0 < (c2[n3 + 32 >> 2] | 0) >>> 0) {
            c2[h2 >> 2] = g3;
            c2[h2 + 4 >> 2] = e3;
            c2[f2 >> 2] = c2[h2 >> 2];
            c2[f2 + 4 >> 2] = c2[h2 + 4 >> 2];
            Al(d2, f2, a3);
            a3 = (c2[b3 >> 2] | 0) + 12 | 0;
            c2[b3 >> 2] = a3;
          } else {
            Bl(k2, i4, j2);
            a3 = c2[b3 >> 2] | 0;
          }
          l2 = m2;
          return ((a3 - (c2[k2 >> 2] | 0) | 0) / 12 | 0) + -1 | 0;
        }
        function Al(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          var e3 = 0;
          e3 = c2[b3 + 4 >> 2] | 0;
          c2[a3 >> 2] = c2[b3 >> 2];
          c2[a3 + 4 >> 2] = e3;
          c2[a3 + 8 >> 2] = d2;
          return;
        }
        function Bl(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          var e3 = 0, f2 = 0, g3 = 0, h2 = 0, i4 = 0, j2 = 0, k2 = 0, m2 = 0, n3 = 0, o3 = 0;
          k2 = l2;
          l2 = l2 + 48 | 0;
          e3 = k2 + 32 | 0;
          h2 = k2 + 24 | 0;
          i4 = k2;
          j2 = a3 + 4 | 0;
          f2 = (((c2[j2 >> 2] | 0) - (c2[a3 >> 2] | 0) | 0) / 12 | 0) + 1 | 0;
          g3 = Cl(a3) | 0;
          if (g3 >>> 0 < f2 >>> 0)
            jC(a3);
          else {
            m2 = c2[a3 >> 2] | 0;
            o3 = ((c2[a3 + 8 >> 2] | 0) - m2 | 0) / 12 | 0;
            n3 = o3 << 1;
            Dl(i4, o3 >>> 0 < g3 >>> 1 >>> 0 ? n3 >>> 0 < f2 >>> 0 ? f2 : n3 : g3, ((c2[j2 >> 2] | 0) - m2 | 0) / 12 | 0, a3 + 8 | 0);
            j2 = i4 + 8 | 0;
            g3 = c2[j2 >> 2] | 0;
            f2 = c2[b3 + 4 >> 2] | 0;
            d2 = c2[d2 >> 2] | 0;
            c2[h2 >> 2] = c2[b3 >> 2];
            c2[h2 + 4 >> 2] = f2;
            c2[e3 >> 2] = c2[h2 >> 2];
            c2[e3 + 4 >> 2] = c2[h2 + 4 >> 2];
            Al(g3, e3, d2);
            c2[j2 >> 2] = (c2[j2 >> 2] | 0) + 12;
            El(a3, i4);
            Fl(i4);
            l2 = k2;
            return;
          }
        }
        function Cl(a3) {
          a3 = a3 | 0;
          return 357913941;
        }
        function Dl(a3, b3, d2, e3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          e3 = e3 | 0;
          var f2 = 0;
          c2[a3 + 12 >> 2] = 0;
          c2[a3 + 16 >> 2] = e3;
          do
            if (b3) {
              if (b3 >>> 0 > 357913941)
                Ta();
              else {
                f2 = qC(b3 * 12 | 0) | 0;
                break;
              }
            } else
              f2 = 0;
          while (0);
          c2[a3 >> 2] = f2;
          e3 = f2 + (d2 * 12 | 0) | 0;
          c2[a3 + 8 >> 2] = e3;
          c2[a3 + 4 >> 2] = e3;
          c2[a3 + 12 >> 2] = f2 + (b3 * 12 | 0);
          return;
        }
        function El(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          var d2 = 0, e3 = 0, f2 = 0, g3 = 0, h2 = 0;
          e3 = c2[a3 >> 2] | 0;
          h2 = a3 + 4 | 0;
          g3 = b3 + 4 | 0;
          f2 = (c2[h2 >> 2] | 0) - e3 | 0;
          d2 = (c2[g3 >> 2] | 0) + (((f2 | 0) / -12 | 0) * 12 | 0) | 0;
          c2[g3 >> 2] = d2;
          if ((f2 | 0) > 0) {
            BC(d2 | 0, e3 | 0, f2 | 0) | 0;
            e3 = g3;
            d2 = c2[g3 >> 2] | 0;
          } else
            e3 = g3;
          g3 = c2[a3 >> 2] | 0;
          c2[a3 >> 2] = d2;
          c2[e3 >> 2] = g3;
          g3 = b3 + 8 | 0;
          f2 = c2[h2 >> 2] | 0;
          c2[h2 >> 2] = c2[g3 >> 2];
          c2[g3 >> 2] = f2;
          g3 = a3 + 8 | 0;
          h2 = b3 + 12 | 0;
          a3 = c2[g3 >> 2] | 0;
          c2[g3 >> 2] = c2[h2 >> 2];
          c2[h2 >> 2] = a3;
          c2[b3 >> 2] = c2[e3 >> 2];
          return;
        }
        function Fl(a3) {
          a3 = a3 | 0;
          var b3 = 0, d2 = 0, e3 = 0;
          b3 = c2[a3 + 4 >> 2] | 0;
          d2 = a3 + 8 | 0;
          e3 = c2[d2 >> 2] | 0;
          if ((e3 | 0) != (b3 | 0))
            c2[d2 >> 2] = e3 + (~(((e3 + -12 - b3 | 0) >>> 0) / 12 | 0) * 12 | 0);
          a3 = c2[a3 >> 2] | 0;
          if (a3 | 0)
            sC(a3);
          return;
        }
        function Gl(a3) {
          a3 = a3 | 0;
          Jl(a3);
          return;
        }
        function Hl(a3) {
          a3 = a3 | 0;
          Il(a3 + 24 | 0);
          return;
        }
        function Il(a3) {
          a3 = a3 | 0;
          var b3 = 0, d2 = 0, e3 = 0;
          d2 = c2[a3 >> 2] | 0;
          e3 = d2;
          if (d2 | 0) {
            a3 = a3 + 4 | 0;
            b3 = c2[a3 >> 2] | 0;
            if ((b3 | 0) != (d2 | 0))
              c2[a3 >> 2] = b3 + (~(((b3 + -12 - e3 | 0) >>> 0) / 12 | 0) * 12 | 0);
            sC(d2);
          }
          return;
        }
        function Jl(a3) {
          a3 = a3 | 0;
          var b3 = 0;
          b3 = vi() | 0;
          yi(a3, 2, 6, b3, Kl() | 0, 1);
          c2[a3 + 24 >> 2] = 0;
          c2[a3 + 28 >> 2] = 0;
          c2[a3 + 32 >> 2] = 0;
          return;
        }
        function Kl() {
          return 1204;
        }
        function Ll(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          var e3 = 0, f2 = 0, g3 = 0, h2 = 0;
          e3 = l2;
          l2 = l2 + 16 | 0;
          f2 = e3 + 8 | 0;
          g3 = e3;
          h2 = Ml(a3) | 0;
          a3 = c2[h2 + 4 >> 2] | 0;
          c2[g3 >> 2] = c2[h2 >> 2];
          c2[g3 + 4 >> 2] = a3;
          c2[f2 >> 2] = c2[g3 >> 2];
          c2[f2 + 4 >> 2] = c2[g3 + 4 >> 2];
          Nl(b3, f2, d2);
          l2 = e3;
          return;
        }
        function Ml(a3) {
          a3 = a3 | 0;
          return (c2[(xl() | 0) + 24 >> 2] | 0) + (a3 * 12 | 0) | 0;
        }
        function Nl(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          var e3 = 0, f2 = 0, g3 = 0;
          g3 = l2;
          l2 = l2 + 16 | 0;
          f2 = g3;
          e3 = c2[b3 >> 2] | 0;
          b3 = c2[b3 + 4 >> 2] | 0;
          a3 = a3 + (b3 >> 1) | 0;
          if (b3 & 1)
            e3 = c2[(c2[a3 >> 2] | 0) + e3 >> 2] | 0;
          Ol(f2, d2);
          f2 = Pl(f2, d2) | 0;
          ob[e3 & 31](a3, f2);
          l2 = g3;
          return;
        }
        function Ol(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          return;
        }
        function Pl(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          return Ql(b3) | 0;
        }
        function Ql(a3) {
          a3 = a3 | 0;
          return a3 | 0;
        }
        function Rl(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          var e3 = 0, f2 = 0, g3 = 0, h2 = 0, i4 = 0;
          e3 = l2;
          l2 = l2 + 16 | 0;
          f2 = e3 + 8 | 0;
          g3 = e3;
          i4 = c2[d2 >> 2] | 0;
          h2 = c2[d2 + 4 >> 2] | 0;
          d2 = ai(b3) | 0;
          c2[g3 >> 2] = i4;
          c2[g3 + 4 >> 2] = h2;
          c2[f2 >> 2] = c2[g3 >> 2];
          c2[f2 + 4 >> 2] = c2[g3 + 4 >> 2];
          Sl(a3, d2, f2, 0);
          l2 = e3;
          return;
        }
        function Sl(a3, b3, d2, e3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          e3 = e3 | 0;
          var f2 = 0, g3 = 0, h2 = 0, i4 = 0, j2 = 0, k2 = 0, m2 = 0;
          f2 = l2;
          l2 = l2 + 32 | 0;
          g3 = f2 + 16 | 0;
          m2 = f2 + 8 | 0;
          i4 = f2;
          k2 = c2[d2 >> 2] | 0;
          j2 = c2[d2 + 4 >> 2] | 0;
          h2 = c2[a3 >> 2] | 0;
          a3 = Tl() | 0;
          c2[m2 >> 2] = k2;
          c2[m2 + 4 >> 2] = j2;
          c2[g3 >> 2] = c2[m2 >> 2];
          c2[g3 + 4 >> 2] = c2[m2 + 4 >> 2];
          d2 = Ul(g3) | 0;
          c2[i4 >> 2] = k2;
          c2[i4 + 4 >> 2] = j2;
          c2[g3 >> 2] = c2[i4 >> 2];
          c2[g3 + 4 >> 2] = c2[i4 + 4 >> 2];
          fi(h2, b3, a3, d2, Vl(g3, e3) | 0, e3);
          l2 = f2;
          return;
        }
        function Tl() {
          var b3 = 0, d2 = 0;
          if (!(a2[7696] | 0)) {
            am(9484);
            Ha(33, 9484, o2 | 0) | 0;
            d2 = 7696;
            c2[d2 >> 2] = 1;
            c2[d2 + 4 >> 2] = 0;
          }
          if (!(si(9484) | 0)) {
            b3 = 9484;
            d2 = b3 + 36 | 0;
            do {
              c2[b3 >> 2] = 0;
              b3 = b3 + 4 | 0;
            } while ((b3 | 0) < (d2 | 0));
            am(9484);
          }
          return 9484;
        }
        function Ul(a3) {
          a3 = a3 | 0;
          return 0;
        }
        function Vl(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          var d2 = 0, e3 = 0, f2 = 0, g3 = 0, h2 = 0, i4 = 0, j2 = 0, k2 = 0, m2 = 0, n3 = 0;
          m2 = l2;
          l2 = l2 + 32 | 0;
          f2 = m2 + 24 | 0;
          h2 = m2 + 16 | 0;
          i4 = m2;
          j2 = m2 + 8 | 0;
          g3 = c2[a3 >> 2] | 0;
          e3 = c2[a3 + 4 >> 2] | 0;
          c2[i4 >> 2] = g3;
          c2[i4 + 4 >> 2] = e3;
          n3 = Tl() | 0;
          k2 = n3 + 24 | 0;
          a3 = ji(b3, 4) | 0;
          c2[j2 >> 2] = a3;
          b3 = n3 + 28 | 0;
          d2 = c2[b3 >> 2] | 0;
          if (d2 >>> 0 < (c2[n3 + 32 >> 2] | 0) >>> 0) {
            c2[h2 >> 2] = g3;
            c2[h2 + 4 >> 2] = e3;
            c2[f2 >> 2] = c2[h2 >> 2];
            c2[f2 + 4 >> 2] = c2[h2 + 4 >> 2];
            Wl(d2, f2, a3);
            a3 = (c2[b3 >> 2] | 0) + 12 | 0;
            c2[b3 >> 2] = a3;
          } else {
            Xl(k2, i4, j2);
            a3 = c2[b3 >> 2] | 0;
          }
          l2 = m2;
          return ((a3 - (c2[k2 >> 2] | 0) | 0) / 12 | 0) + -1 | 0;
        }
        function Wl(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          var e3 = 0;
          e3 = c2[b3 + 4 >> 2] | 0;
          c2[a3 >> 2] = c2[b3 >> 2];
          c2[a3 + 4 >> 2] = e3;
          c2[a3 + 8 >> 2] = d2;
          return;
        }
        function Xl(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          var e3 = 0, f2 = 0, g3 = 0, h2 = 0, i4 = 0, j2 = 0, k2 = 0, m2 = 0, n3 = 0, o3 = 0;
          k2 = l2;
          l2 = l2 + 48 | 0;
          e3 = k2 + 32 | 0;
          h2 = k2 + 24 | 0;
          i4 = k2;
          j2 = a3 + 4 | 0;
          f2 = (((c2[j2 >> 2] | 0) - (c2[a3 >> 2] | 0) | 0) / 12 | 0) + 1 | 0;
          g3 = Yl(a3) | 0;
          if (g3 >>> 0 < f2 >>> 0)
            jC(a3);
          else {
            m2 = c2[a3 >> 2] | 0;
            o3 = ((c2[a3 + 8 >> 2] | 0) - m2 | 0) / 12 | 0;
            n3 = o3 << 1;
            Zl(i4, o3 >>> 0 < g3 >>> 1 >>> 0 ? n3 >>> 0 < f2 >>> 0 ? f2 : n3 : g3, ((c2[j2 >> 2] | 0) - m2 | 0) / 12 | 0, a3 + 8 | 0);
            j2 = i4 + 8 | 0;
            g3 = c2[j2 >> 2] | 0;
            f2 = c2[b3 + 4 >> 2] | 0;
            d2 = c2[d2 >> 2] | 0;
            c2[h2 >> 2] = c2[b3 >> 2];
            c2[h2 + 4 >> 2] = f2;
            c2[e3 >> 2] = c2[h2 >> 2];
            c2[e3 + 4 >> 2] = c2[h2 + 4 >> 2];
            Wl(g3, e3, d2);
            c2[j2 >> 2] = (c2[j2 >> 2] | 0) + 12;
            _l(a3, i4);
            $l(i4);
            l2 = k2;
            return;
          }
        }
        function Yl(a3) {
          a3 = a3 | 0;
          return 357913941;
        }
        function Zl(a3, b3, d2, e3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          e3 = e3 | 0;
          var f2 = 0;
          c2[a3 + 12 >> 2] = 0;
          c2[a3 + 16 >> 2] = e3;
          do
            if (b3) {
              if (b3 >>> 0 > 357913941)
                Ta();
              else {
                f2 = qC(b3 * 12 | 0) | 0;
                break;
              }
            } else
              f2 = 0;
          while (0);
          c2[a3 >> 2] = f2;
          e3 = f2 + (d2 * 12 | 0) | 0;
          c2[a3 + 8 >> 2] = e3;
          c2[a3 + 4 >> 2] = e3;
          c2[a3 + 12 >> 2] = f2 + (b3 * 12 | 0);
          return;
        }
        function _l(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          var d2 = 0, e3 = 0, f2 = 0, g3 = 0, h2 = 0;
          e3 = c2[a3 >> 2] | 0;
          h2 = a3 + 4 | 0;
          g3 = b3 + 4 | 0;
          f2 = (c2[h2 >> 2] | 0) - e3 | 0;
          d2 = (c2[g3 >> 2] | 0) + (((f2 | 0) / -12 | 0) * 12 | 0) | 0;
          c2[g3 >> 2] = d2;
          if ((f2 | 0) > 0) {
            BC(d2 | 0, e3 | 0, f2 | 0) | 0;
            e3 = g3;
            d2 = c2[g3 >> 2] | 0;
          } else
            e3 = g3;
          g3 = c2[a3 >> 2] | 0;
          c2[a3 >> 2] = d2;
          c2[e3 >> 2] = g3;
          g3 = b3 + 8 | 0;
          f2 = c2[h2 >> 2] | 0;
          c2[h2 >> 2] = c2[g3 >> 2];
          c2[g3 >> 2] = f2;
          g3 = a3 + 8 | 0;
          h2 = b3 + 12 | 0;
          a3 = c2[g3 >> 2] | 0;
          c2[g3 >> 2] = c2[h2 >> 2];
          c2[h2 >> 2] = a3;
          c2[b3 >> 2] = c2[e3 >> 2];
          return;
        }
        function $l(a3) {
          a3 = a3 | 0;
          var b3 = 0, d2 = 0, e3 = 0;
          b3 = c2[a3 + 4 >> 2] | 0;
          d2 = a3 + 8 | 0;
          e3 = c2[d2 >> 2] | 0;
          if ((e3 | 0) != (b3 | 0))
            c2[d2 >> 2] = e3 + (~(((e3 + -12 - b3 | 0) >>> 0) / 12 | 0) * 12 | 0);
          a3 = c2[a3 >> 2] | 0;
          if (a3 | 0)
            sC(a3);
          return;
        }
        function am(a3) {
          a3 = a3 | 0;
          dm(a3);
          return;
        }
        function bm(a3) {
          a3 = a3 | 0;
          cm(a3 + 24 | 0);
          return;
        }
        function cm(a3) {
          a3 = a3 | 0;
          var b3 = 0, d2 = 0, e3 = 0;
          d2 = c2[a3 >> 2] | 0;
          e3 = d2;
          if (d2 | 0) {
            a3 = a3 + 4 | 0;
            b3 = c2[a3 >> 2] | 0;
            if ((b3 | 0) != (d2 | 0))
              c2[a3 >> 2] = b3 + (~(((b3 + -12 - e3 | 0) >>> 0) / 12 | 0) * 12 | 0);
            sC(d2);
          }
          return;
        }
        function dm(a3) {
          a3 = a3 | 0;
          var b3 = 0;
          b3 = vi() | 0;
          yi(a3, 2, 1, b3, em() | 0, 2);
          c2[a3 + 24 >> 2] = 0;
          c2[a3 + 28 >> 2] = 0;
          c2[a3 + 32 >> 2] = 0;
          return;
        }
        function em() {
          return 1212;
        }
        function fm(a3, b3, d2, e3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          e3 = e3 | 0;
          var f2 = 0, g3 = 0, h2 = 0, i4 = 0;
          f2 = l2;
          l2 = l2 + 16 | 0;
          g3 = f2 + 8 | 0;
          h2 = f2;
          i4 = gm(a3) | 0;
          a3 = c2[i4 + 4 >> 2] | 0;
          c2[h2 >> 2] = c2[i4 >> 2];
          c2[h2 + 4 >> 2] = a3;
          c2[g3 >> 2] = c2[h2 >> 2];
          c2[g3 + 4 >> 2] = c2[h2 + 4 >> 2];
          hm(b3, g3, d2, e3);
          l2 = f2;
          return;
        }
        function gm(a3) {
          a3 = a3 | 0;
          return (c2[(Tl() | 0) + 24 >> 2] | 0) + (a3 * 12 | 0) | 0;
        }
        function hm(a3, b3, d2, e3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          e3 = e3 | 0;
          var f2 = 0, g3 = 0, h2 = 0, i4 = 0;
          i4 = l2;
          l2 = l2 + 16 | 0;
          g3 = i4 + 1 | 0;
          h2 = i4;
          f2 = c2[b3 >> 2] | 0;
          b3 = c2[b3 + 4 >> 2] | 0;
          a3 = a3 + (b3 >> 1) | 0;
          if (b3 & 1)
            f2 = c2[(c2[a3 >> 2] | 0) + f2 >> 2] | 0;
          Ol(g3, d2);
          g3 = Pl(g3, d2) | 0;
          Gk(h2, e3);
          h2 = Hk(h2, e3) | 0;
          Eb[f2 & 15](a3, g3, h2);
          l2 = i4;
          return;
        }
        function im(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          var e3 = 0, f2 = 0, g3 = 0, h2 = 0, i4 = 0;
          e3 = l2;
          l2 = l2 + 16 | 0;
          f2 = e3 + 8 | 0;
          g3 = e3;
          i4 = c2[d2 >> 2] | 0;
          h2 = c2[d2 + 4 >> 2] | 0;
          d2 = ai(b3) | 0;
          c2[g3 >> 2] = i4;
          c2[g3 + 4 >> 2] = h2;
          c2[f2 >> 2] = c2[g3 >> 2];
          c2[f2 + 4 >> 2] = c2[g3 + 4 >> 2];
          jm(a3, d2, f2, 1);
          l2 = e3;
          return;
        }
        function jm(a3, b3, d2, e3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          e3 = e3 | 0;
          var f2 = 0, g3 = 0, h2 = 0, i4 = 0, j2 = 0, k2 = 0, m2 = 0;
          f2 = l2;
          l2 = l2 + 32 | 0;
          g3 = f2 + 16 | 0;
          m2 = f2 + 8 | 0;
          i4 = f2;
          k2 = c2[d2 >> 2] | 0;
          j2 = c2[d2 + 4 >> 2] | 0;
          h2 = c2[a3 >> 2] | 0;
          a3 = km() | 0;
          c2[m2 >> 2] = k2;
          c2[m2 + 4 >> 2] = j2;
          c2[g3 >> 2] = c2[m2 >> 2];
          c2[g3 + 4 >> 2] = c2[m2 + 4 >> 2];
          d2 = lm(g3) | 0;
          c2[i4 >> 2] = k2;
          c2[i4 + 4 >> 2] = j2;
          c2[g3 >> 2] = c2[i4 >> 2];
          c2[g3 + 4 >> 2] = c2[i4 + 4 >> 2];
          fi(h2, b3, a3, d2, mm(g3, e3) | 0, e3);
          l2 = f2;
          return;
        }
        function km() {
          var b3 = 0, d2 = 0;
          if (!(a2[7704] | 0)) {
            tm(9520);
            Ha(34, 9520, o2 | 0) | 0;
            d2 = 7704;
            c2[d2 >> 2] = 1;
            c2[d2 + 4 >> 2] = 0;
          }
          if (!(si(9520) | 0)) {
            b3 = 9520;
            d2 = b3 + 36 | 0;
            do {
              c2[b3 >> 2] = 0;
              b3 = b3 + 4 | 0;
            } while ((b3 | 0) < (d2 | 0));
            tm(9520);
          }
          return 9520;
        }
        function lm(a3) {
          a3 = a3 | 0;
          return 0;
        }
        function mm(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          var d2 = 0, e3 = 0, f2 = 0, g3 = 0, h2 = 0, i4 = 0, j2 = 0, k2 = 0, m2 = 0, n3 = 0;
          m2 = l2;
          l2 = l2 + 32 | 0;
          f2 = m2 + 24 | 0;
          h2 = m2 + 16 | 0;
          i4 = m2;
          j2 = m2 + 8 | 0;
          g3 = c2[a3 >> 2] | 0;
          e3 = c2[a3 + 4 >> 2] | 0;
          c2[i4 >> 2] = g3;
          c2[i4 + 4 >> 2] = e3;
          n3 = km() | 0;
          k2 = n3 + 24 | 0;
          a3 = ji(b3, 4) | 0;
          c2[j2 >> 2] = a3;
          b3 = n3 + 28 | 0;
          d2 = c2[b3 >> 2] | 0;
          if (d2 >>> 0 < (c2[n3 + 32 >> 2] | 0) >>> 0) {
            c2[h2 >> 2] = g3;
            c2[h2 + 4 >> 2] = e3;
            c2[f2 >> 2] = c2[h2 >> 2];
            c2[f2 + 4 >> 2] = c2[h2 + 4 >> 2];
            nm(d2, f2, a3);
            a3 = (c2[b3 >> 2] | 0) + 12 | 0;
            c2[b3 >> 2] = a3;
          } else {
            om(k2, i4, j2);
            a3 = c2[b3 >> 2] | 0;
          }
          l2 = m2;
          return ((a3 - (c2[k2 >> 2] | 0) | 0) / 12 | 0) + -1 | 0;
        }
        function nm(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          var e3 = 0;
          e3 = c2[b3 + 4 >> 2] | 0;
          c2[a3 >> 2] = c2[b3 >> 2];
          c2[a3 + 4 >> 2] = e3;
          c2[a3 + 8 >> 2] = d2;
          return;
        }
        function om(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          var e3 = 0, f2 = 0, g3 = 0, h2 = 0, i4 = 0, j2 = 0, k2 = 0, m2 = 0, n3 = 0, o3 = 0;
          k2 = l2;
          l2 = l2 + 48 | 0;
          e3 = k2 + 32 | 0;
          h2 = k2 + 24 | 0;
          i4 = k2;
          j2 = a3 + 4 | 0;
          f2 = (((c2[j2 >> 2] | 0) - (c2[a3 >> 2] | 0) | 0) / 12 | 0) + 1 | 0;
          g3 = pm(a3) | 0;
          if (g3 >>> 0 < f2 >>> 0)
            jC(a3);
          else {
            m2 = c2[a3 >> 2] | 0;
            o3 = ((c2[a3 + 8 >> 2] | 0) - m2 | 0) / 12 | 0;
            n3 = o3 << 1;
            qm(i4, o3 >>> 0 < g3 >>> 1 >>> 0 ? n3 >>> 0 < f2 >>> 0 ? f2 : n3 : g3, ((c2[j2 >> 2] | 0) - m2 | 0) / 12 | 0, a3 + 8 | 0);
            j2 = i4 + 8 | 0;
            g3 = c2[j2 >> 2] | 0;
            f2 = c2[b3 + 4 >> 2] | 0;
            d2 = c2[d2 >> 2] | 0;
            c2[h2 >> 2] = c2[b3 >> 2];
            c2[h2 + 4 >> 2] = f2;
            c2[e3 >> 2] = c2[h2 >> 2];
            c2[e3 + 4 >> 2] = c2[h2 + 4 >> 2];
            nm(g3, e3, d2);
            c2[j2 >> 2] = (c2[j2 >> 2] | 0) + 12;
            rm(a3, i4);
            sm(i4);
            l2 = k2;
            return;
          }
        }
        function pm(a3) {
          a3 = a3 | 0;
          return 357913941;
        }
        function qm(a3, b3, d2, e3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          e3 = e3 | 0;
          var f2 = 0;
          c2[a3 + 12 >> 2] = 0;
          c2[a3 + 16 >> 2] = e3;
          do
            if (b3) {
              if (b3 >>> 0 > 357913941)
                Ta();
              else {
                f2 = qC(b3 * 12 | 0) | 0;
                break;
              }
            } else
              f2 = 0;
          while (0);
          c2[a3 >> 2] = f2;
          e3 = f2 + (d2 * 12 | 0) | 0;
          c2[a3 + 8 >> 2] = e3;
          c2[a3 + 4 >> 2] = e3;
          c2[a3 + 12 >> 2] = f2 + (b3 * 12 | 0);
          return;
        }
        function rm(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          var d2 = 0, e3 = 0, f2 = 0, g3 = 0, h2 = 0;
          e3 = c2[a3 >> 2] | 0;
          h2 = a3 + 4 | 0;
          g3 = b3 + 4 | 0;
          f2 = (c2[h2 >> 2] | 0) - e3 | 0;
          d2 = (c2[g3 >> 2] | 0) + (((f2 | 0) / -12 | 0) * 12 | 0) | 0;
          c2[g3 >> 2] = d2;
          if ((f2 | 0) > 0) {
            BC(d2 | 0, e3 | 0, f2 | 0) | 0;
            e3 = g3;
            d2 = c2[g3 >> 2] | 0;
          } else
            e3 = g3;
          g3 = c2[a3 >> 2] | 0;
          c2[a3 >> 2] = d2;
          c2[e3 >> 2] = g3;
          g3 = b3 + 8 | 0;
          f2 = c2[h2 >> 2] | 0;
          c2[h2 >> 2] = c2[g3 >> 2];
          c2[g3 >> 2] = f2;
          g3 = a3 + 8 | 0;
          h2 = b3 + 12 | 0;
          a3 = c2[g3 >> 2] | 0;
          c2[g3 >> 2] = c2[h2 >> 2];
          c2[h2 >> 2] = a3;
          c2[b3 >> 2] = c2[e3 >> 2];
          return;
        }
        function sm(a3) {
          a3 = a3 | 0;
          var b3 = 0, d2 = 0, e3 = 0;
          b3 = c2[a3 + 4 >> 2] | 0;
          d2 = a3 + 8 | 0;
          e3 = c2[d2 >> 2] | 0;
          if ((e3 | 0) != (b3 | 0))
            c2[d2 >> 2] = e3 + (~(((e3 + -12 - b3 | 0) >>> 0) / 12 | 0) * 12 | 0);
          a3 = c2[a3 >> 2] | 0;
          if (a3 | 0)
            sC(a3);
          return;
        }
        function tm(a3) {
          a3 = a3 | 0;
          wm(a3);
          return;
        }
        function um(a3) {
          a3 = a3 | 0;
          vm(a3 + 24 | 0);
          return;
        }
        function vm(a3) {
          a3 = a3 | 0;
          var b3 = 0, d2 = 0, e3 = 0;
          d2 = c2[a3 >> 2] | 0;
          e3 = d2;
          if (d2 | 0) {
            a3 = a3 + 4 | 0;
            b3 = c2[a3 >> 2] | 0;
            if ((b3 | 0) != (d2 | 0))
              c2[a3 >> 2] = b3 + (~(((b3 + -12 - e3 | 0) >>> 0) / 12 | 0) * 12 | 0);
            sC(d2);
          }
          return;
        }
        function wm(a3) {
          a3 = a3 | 0;
          var b3 = 0;
          b3 = vi() | 0;
          yi(a3, 2, 1, b3, xm() | 0, 1);
          c2[a3 + 24 >> 2] = 0;
          c2[a3 + 28 >> 2] = 0;
          c2[a3 + 32 >> 2] = 0;
          return;
        }
        function xm() {
          return 1224;
        }
        function ym(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          var e3 = 0, f2 = 0, g3 = 0, h2 = 0, i4 = 0;
          f2 = l2;
          l2 = l2 + 16 | 0;
          g3 = f2 + 8 | 0;
          h2 = f2;
          i4 = zm(a3) | 0;
          a3 = c2[i4 + 4 >> 2] | 0;
          c2[h2 >> 2] = c2[i4 >> 2];
          c2[h2 + 4 >> 2] = a3;
          c2[g3 >> 2] = c2[h2 >> 2];
          c2[g3 + 4 >> 2] = c2[h2 + 4 >> 2];
          e3 = +Am(b3, g3, d2);
          l2 = f2;
          return +e3;
        }
        function zm(a3) {
          a3 = a3 | 0;
          return (c2[(km() | 0) + 24 >> 2] | 0) + (a3 * 12 | 0) | 0;
        }
        function Am(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          var e3 = 0, f2 = 0, g3 = 0, h2 = 0;
          g3 = l2;
          l2 = l2 + 16 | 0;
          f2 = g3;
          e3 = c2[b3 >> 2] | 0;
          b3 = c2[b3 + 4 >> 2] | 0;
          a3 = a3 + (b3 >> 1) | 0;
          if (b3 & 1)
            e3 = c2[(c2[a3 >> 2] | 0) + e3 >> 2] | 0;
          tj(f2, d2);
          f2 = uj(f2, d2) | 0;
          h2 = +ch(+zb[e3 & 7](a3, f2));
          l2 = g3;
          return +h2;
        }
        function Bm(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          var e3 = 0, f2 = 0, g3 = 0, h2 = 0, i4 = 0;
          e3 = l2;
          l2 = l2 + 16 | 0;
          f2 = e3 + 8 | 0;
          g3 = e3;
          i4 = c2[d2 >> 2] | 0;
          h2 = c2[d2 + 4 >> 2] | 0;
          d2 = ai(b3) | 0;
          c2[g3 >> 2] = i4;
          c2[g3 + 4 >> 2] = h2;
          c2[f2 >> 2] = c2[g3 >> 2];
          c2[f2 + 4 >> 2] = c2[g3 + 4 >> 2];
          Cm(a3, d2, f2, 1);
          l2 = e3;
          return;
        }
        function Cm(a3, b3, d2, e3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          e3 = e3 | 0;
          var f2 = 0, g3 = 0, h2 = 0, i4 = 0, j2 = 0, k2 = 0, m2 = 0;
          f2 = l2;
          l2 = l2 + 32 | 0;
          g3 = f2 + 16 | 0;
          m2 = f2 + 8 | 0;
          i4 = f2;
          k2 = c2[d2 >> 2] | 0;
          j2 = c2[d2 + 4 >> 2] | 0;
          h2 = c2[a3 >> 2] | 0;
          a3 = Dm() | 0;
          c2[m2 >> 2] = k2;
          c2[m2 + 4 >> 2] = j2;
          c2[g3 >> 2] = c2[m2 >> 2];
          c2[g3 + 4 >> 2] = c2[m2 + 4 >> 2];
          d2 = Em(g3) | 0;
          c2[i4 >> 2] = k2;
          c2[i4 + 4 >> 2] = j2;
          c2[g3 >> 2] = c2[i4 >> 2];
          c2[g3 + 4 >> 2] = c2[i4 + 4 >> 2];
          fi(h2, b3, a3, d2, Fm(g3, e3) | 0, e3);
          l2 = f2;
          return;
        }
        function Dm() {
          var b3 = 0, d2 = 0;
          if (!(a2[7712] | 0)) {
            Mm(9556);
            Ha(35, 9556, o2 | 0) | 0;
            d2 = 7712;
            c2[d2 >> 2] = 1;
            c2[d2 + 4 >> 2] = 0;
          }
          if (!(si(9556) | 0)) {
            b3 = 9556;
            d2 = b3 + 36 | 0;
            do {
              c2[b3 >> 2] = 0;
              b3 = b3 + 4 | 0;
            } while ((b3 | 0) < (d2 | 0));
            Mm(9556);
          }
          return 9556;
        }
        function Em(a3) {
          a3 = a3 | 0;
          return 0;
        }
        function Fm(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          var d2 = 0, e3 = 0, f2 = 0, g3 = 0, h2 = 0, i4 = 0, j2 = 0, k2 = 0, m2 = 0, n3 = 0;
          m2 = l2;
          l2 = l2 + 32 | 0;
          f2 = m2 + 24 | 0;
          h2 = m2 + 16 | 0;
          i4 = m2;
          j2 = m2 + 8 | 0;
          g3 = c2[a3 >> 2] | 0;
          e3 = c2[a3 + 4 >> 2] | 0;
          c2[i4 >> 2] = g3;
          c2[i4 + 4 >> 2] = e3;
          n3 = Dm() | 0;
          k2 = n3 + 24 | 0;
          a3 = ji(b3, 4) | 0;
          c2[j2 >> 2] = a3;
          b3 = n3 + 28 | 0;
          d2 = c2[b3 >> 2] | 0;
          if (d2 >>> 0 < (c2[n3 + 32 >> 2] | 0) >>> 0) {
            c2[h2 >> 2] = g3;
            c2[h2 + 4 >> 2] = e3;
            c2[f2 >> 2] = c2[h2 >> 2];
            c2[f2 + 4 >> 2] = c2[h2 + 4 >> 2];
            Gm(d2, f2, a3);
            a3 = (c2[b3 >> 2] | 0) + 12 | 0;
            c2[b3 >> 2] = a3;
          } else {
            Hm(k2, i4, j2);
            a3 = c2[b3 >> 2] | 0;
          }
          l2 = m2;
          return ((a3 - (c2[k2 >> 2] | 0) | 0) / 12 | 0) + -1 | 0;
        }
        function Gm(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          var e3 = 0;
          e3 = c2[b3 + 4 >> 2] | 0;
          c2[a3 >> 2] = c2[b3 >> 2];
          c2[a3 + 4 >> 2] = e3;
          c2[a3 + 8 >> 2] = d2;
          return;
        }
        function Hm(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          var e3 = 0, f2 = 0, g3 = 0, h2 = 0, i4 = 0, j2 = 0, k2 = 0, m2 = 0, n3 = 0, o3 = 0;
          k2 = l2;
          l2 = l2 + 48 | 0;
          e3 = k2 + 32 | 0;
          h2 = k2 + 24 | 0;
          i4 = k2;
          j2 = a3 + 4 | 0;
          f2 = (((c2[j2 >> 2] | 0) - (c2[a3 >> 2] | 0) | 0) / 12 | 0) + 1 | 0;
          g3 = Im(a3) | 0;
          if (g3 >>> 0 < f2 >>> 0)
            jC(a3);
          else {
            m2 = c2[a3 >> 2] | 0;
            o3 = ((c2[a3 + 8 >> 2] | 0) - m2 | 0) / 12 | 0;
            n3 = o3 << 1;
            Jm(i4, o3 >>> 0 < g3 >>> 1 >>> 0 ? n3 >>> 0 < f2 >>> 0 ? f2 : n3 : g3, ((c2[j2 >> 2] | 0) - m2 | 0) / 12 | 0, a3 + 8 | 0);
            j2 = i4 + 8 | 0;
            g3 = c2[j2 >> 2] | 0;
            f2 = c2[b3 + 4 >> 2] | 0;
            d2 = c2[d2 >> 2] | 0;
            c2[h2 >> 2] = c2[b3 >> 2];
            c2[h2 + 4 >> 2] = f2;
            c2[e3 >> 2] = c2[h2 >> 2];
            c2[e3 + 4 >> 2] = c2[h2 + 4 >> 2];
            Gm(g3, e3, d2);
            c2[j2 >> 2] = (c2[j2 >> 2] | 0) + 12;
            Km(a3, i4);
            Lm(i4);
            l2 = k2;
            return;
          }
        }
        function Im(a3) {
          a3 = a3 | 0;
          return 357913941;
        }
        function Jm(a3, b3, d2, e3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          e3 = e3 | 0;
          var f2 = 0;
          c2[a3 + 12 >> 2] = 0;
          c2[a3 + 16 >> 2] = e3;
          do
            if (b3) {
              if (b3 >>> 0 > 357913941)
                Ta();
              else {
                f2 = qC(b3 * 12 | 0) | 0;
                break;
              }
            } else
              f2 = 0;
          while (0);
          c2[a3 >> 2] = f2;
          e3 = f2 + (d2 * 12 | 0) | 0;
          c2[a3 + 8 >> 2] = e3;
          c2[a3 + 4 >> 2] = e3;
          c2[a3 + 12 >> 2] = f2 + (b3 * 12 | 0);
          return;
        }
        function Km(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          var d2 = 0, e3 = 0, f2 = 0, g3 = 0, h2 = 0;
          e3 = c2[a3 >> 2] | 0;
          h2 = a3 + 4 | 0;
          g3 = b3 + 4 | 0;
          f2 = (c2[h2 >> 2] | 0) - e3 | 0;
          d2 = (c2[g3 >> 2] | 0) + (((f2 | 0) / -12 | 0) * 12 | 0) | 0;
          c2[g3 >> 2] = d2;
          if ((f2 | 0) > 0) {
            BC(d2 | 0, e3 | 0, f2 | 0) | 0;
            e3 = g3;
            d2 = c2[g3 >> 2] | 0;
          } else
            e3 = g3;
          g3 = c2[a3 >> 2] | 0;
          c2[a3 >> 2] = d2;
          c2[e3 >> 2] = g3;
          g3 = b3 + 8 | 0;
          f2 = c2[h2 >> 2] | 0;
          c2[h2 >> 2] = c2[g3 >> 2];
          c2[g3 >> 2] = f2;
          g3 = a3 + 8 | 0;
          h2 = b3 + 12 | 0;
          a3 = c2[g3 >> 2] | 0;
          c2[g3 >> 2] = c2[h2 >> 2];
          c2[h2 >> 2] = a3;
          c2[b3 >> 2] = c2[e3 >> 2];
          return;
        }
        function Lm(a3) {
          a3 = a3 | 0;
          var b3 = 0, d2 = 0, e3 = 0;
          b3 = c2[a3 + 4 >> 2] | 0;
          d2 = a3 + 8 | 0;
          e3 = c2[d2 >> 2] | 0;
          if ((e3 | 0) != (b3 | 0))
            c2[d2 >> 2] = e3 + (~(((e3 + -12 - b3 | 0) >>> 0) / 12 | 0) * 12 | 0);
          a3 = c2[a3 >> 2] | 0;
          if (a3 | 0)
            sC(a3);
          return;
        }
        function Mm(a3) {
          a3 = a3 | 0;
          Pm(a3);
          return;
        }
        function Nm(a3) {
          a3 = a3 | 0;
          Om(a3 + 24 | 0);
          return;
        }
        function Om(a3) {
          a3 = a3 | 0;
          var b3 = 0, d2 = 0, e3 = 0;
          d2 = c2[a3 >> 2] | 0;
          e3 = d2;
          if (d2 | 0) {
            a3 = a3 + 4 | 0;
            b3 = c2[a3 >> 2] | 0;
            if ((b3 | 0) != (d2 | 0))
              c2[a3 >> 2] = b3 + (~(((b3 + -12 - e3 | 0) >>> 0) / 12 | 0) * 12 | 0);
            sC(d2);
          }
          return;
        }
        function Pm(a3) {
          a3 = a3 | 0;
          var b3 = 0;
          b3 = vi() | 0;
          yi(a3, 2, 5, b3, Qm() | 0, 0);
          c2[a3 + 24 >> 2] = 0;
          c2[a3 + 28 >> 2] = 0;
          c2[a3 + 32 >> 2] = 0;
          return;
        }
        function Qm() {
          return 1232;
        }
        function Rm(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          var d2 = 0, e3 = 0, f2 = 0, g3 = 0, h2 = 0;
          e3 = l2;
          l2 = l2 + 16 | 0;
          f2 = e3 + 8 | 0;
          g3 = e3;
          h2 = Sm(a3) | 0;
          a3 = c2[h2 + 4 >> 2] | 0;
          c2[g3 >> 2] = c2[h2 >> 2];
          c2[g3 + 4 >> 2] = a3;
          c2[f2 >> 2] = c2[g3 >> 2];
          c2[f2 + 4 >> 2] = c2[g3 + 4 >> 2];
          d2 = +Tm(b3, f2);
          l2 = e3;
          return +d2;
        }
        function Sm(a3) {
          a3 = a3 | 0;
          return (c2[(Dm() | 0) + 24 >> 2] | 0) + (a3 * 12 | 0) | 0;
        }
        function Tm(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          var d2 = 0;
          d2 = c2[b3 >> 2] | 0;
          b3 = c2[b3 + 4 >> 2] | 0;
          a3 = a3 + (b3 >> 1) | 0;
          if (b3 & 1)
            d2 = c2[(c2[a3 >> 2] | 0) + d2 >> 2] | 0;
          return + +ch(+ub[d2 & 15](a3));
        }
        function Um(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          var e3 = 0, f2 = 0, g3 = 0, h2 = 0, i4 = 0;
          e3 = l2;
          l2 = l2 + 16 | 0;
          f2 = e3 + 8 | 0;
          g3 = e3;
          i4 = c2[d2 >> 2] | 0;
          h2 = c2[d2 + 4 >> 2] | 0;
          d2 = ai(b3) | 0;
          c2[g3 >> 2] = i4;
          c2[g3 + 4 >> 2] = h2;
          c2[f2 >> 2] = c2[g3 >> 2];
          c2[f2 + 4 >> 2] = c2[g3 + 4 >> 2];
          Vm(a3, d2, f2, 1);
          l2 = e3;
          return;
        }
        function Vm(a3, b3, d2, e3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          e3 = e3 | 0;
          var f2 = 0, g3 = 0, h2 = 0, i4 = 0, j2 = 0, k2 = 0, m2 = 0;
          f2 = l2;
          l2 = l2 + 32 | 0;
          g3 = f2 + 16 | 0;
          m2 = f2 + 8 | 0;
          i4 = f2;
          k2 = c2[d2 >> 2] | 0;
          j2 = c2[d2 + 4 >> 2] | 0;
          h2 = c2[a3 >> 2] | 0;
          a3 = Wm() | 0;
          c2[m2 >> 2] = k2;
          c2[m2 + 4 >> 2] = j2;
          c2[g3 >> 2] = c2[m2 >> 2];
          c2[g3 + 4 >> 2] = c2[m2 + 4 >> 2];
          d2 = Xm(g3) | 0;
          c2[i4 >> 2] = k2;
          c2[i4 + 4 >> 2] = j2;
          c2[g3 >> 2] = c2[i4 >> 2];
          c2[g3 + 4 >> 2] = c2[i4 + 4 >> 2];
          fi(h2, b3, a3, d2, Ym(g3, e3) | 0, e3);
          l2 = f2;
          return;
        }
        function Wm() {
          var b3 = 0, d2 = 0;
          if (!(a2[7720] | 0)) {
            dn(9592);
            Ha(36, 9592, o2 | 0) | 0;
            d2 = 7720;
            c2[d2 >> 2] = 1;
            c2[d2 + 4 >> 2] = 0;
          }
          if (!(si(9592) | 0)) {
            b3 = 9592;
            d2 = b3 + 36 | 0;
            do {
              c2[b3 >> 2] = 0;
              b3 = b3 + 4 | 0;
            } while ((b3 | 0) < (d2 | 0));
            dn(9592);
          }
          return 9592;
        }
        function Xm(a3) {
          a3 = a3 | 0;
          return 0;
        }
        function Ym(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          var d2 = 0, e3 = 0, f2 = 0, g3 = 0, h2 = 0, i4 = 0, j2 = 0, k2 = 0, m2 = 0, n3 = 0;
          m2 = l2;
          l2 = l2 + 32 | 0;
          f2 = m2 + 24 | 0;
          h2 = m2 + 16 | 0;
          i4 = m2;
          j2 = m2 + 8 | 0;
          g3 = c2[a3 >> 2] | 0;
          e3 = c2[a3 + 4 >> 2] | 0;
          c2[i4 >> 2] = g3;
          c2[i4 + 4 >> 2] = e3;
          n3 = Wm() | 0;
          k2 = n3 + 24 | 0;
          a3 = ji(b3, 4) | 0;
          c2[j2 >> 2] = a3;
          b3 = n3 + 28 | 0;
          d2 = c2[b3 >> 2] | 0;
          if (d2 >>> 0 < (c2[n3 + 32 >> 2] | 0) >>> 0) {
            c2[h2 >> 2] = g3;
            c2[h2 + 4 >> 2] = e3;
            c2[f2 >> 2] = c2[h2 >> 2];
            c2[f2 + 4 >> 2] = c2[h2 + 4 >> 2];
            Zm(d2, f2, a3);
            a3 = (c2[b3 >> 2] | 0) + 12 | 0;
            c2[b3 >> 2] = a3;
          } else {
            _m(k2, i4, j2);
            a3 = c2[b3 >> 2] | 0;
          }
          l2 = m2;
          return ((a3 - (c2[k2 >> 2] | 0) | 0) / 12 | 0) + -1 | 0;
        }
        function Zm(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          var e3 = 0;
          e3 = c2[b3 + 4 >> 2] | 0;
          c2[a3 >> 2] = c2[b3 >> 2];
          c2[a3 + 4 >> 2] = e3;
          c2[a3 + 8 >> 2] = d2;
          return;
        }
        function _m(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          var e3 = 0, f2 = 0, g3 = 0, h2 = 0, i4 = 0, j2 = 0, k2 = 0, m2 = 0, n3 = 0, o3 = 0;
          k2 = l2;
          l2 = l2 + 48 | 0;
          e3 = k2 + 32 | 0;
          h2 = k2 + 24 | 0;
          i4 = k2;
          j2 = a3 + 4 | 0;
          f2 = (((c2[j2 >> 2] | 0) - (c2[a3 >> 2] | 0) | 0) / 12 | 0) + 1 | 0;
          g3 = $m(a3) | 0;
          if (g3 >>> 0 < f2 >>> 0)
            jC(a3);
          else {
            m2 = c2[a3 >> 2] | 0;
            o3 = ((c2[a3 + 8 >> 2] | 0) - m2 | 0) / 12 | 0;
            n3 = o3 << 1;
            an(i4, o3 >>> 0 < g3 >>> 1 >>> 0 ? n3 >>> 0 < f2 >>> 0 ? f2 : n3 : g3, ((c2[j2 >> 2] | 0) - m2 | 0) / 12 | 0, a3 + 8 | 0);
            j2 = i4 + 8 | 0;
            g3 = c2[j2 >> 2] | 0;
            f2 = c2[b3 + 4 >> 2] | 0;
            d2 = c2[d2 >> 2] | 0;
            c2[h2 >> 2] = c2[b3 >> 2];
            c2[h2 + 4 >> 2] = f2;
            c2[e3 >> 2] = c2[h2 >> 2];
            c2[e3 + 4 >> 2] = c2[h2 + 4 >> 2];
            Zm(g3, e3, d2);
            c2[j2 >> 2] = (c2[j2 >> 2] | 0) + 12;
            bn(a3, i4);
            cn(i4);
            l2 = k2;
            return;
          }
        }
        function $m(a3) {
          a3 = a3 | 0;
          return 357913941;
        }
        function an(a3, b3, d2, e3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          e3 = e3 | 0;
          var f2 = 0;
          c2[a3 + 12 >> 2] = 0;
          c2[a3 + 16 >> 2] = e3;
          do
            if (b3) {
              if (b3 >>> 0 > 357913941)
                Ta();
              else {
                f2 = qC(b3 * 12 | 0) | 0;
                break;
              }
            } else
              f2 = 0;
          while (0);
          c2[a3 >> 2] = f2;
          e3 = f2 + (d2 * 12 | 0) | 0;
          c2[a3 + 8 >> 2] = e3;
          c2[a3 + 4 >> 2] = e3;
          c2[a3 + 12 >> 2] = f2 + (b3 * 12 | 0);
          return;
        }
        function bn(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          var d2 = 0, e3 = 0, f2 = 0, g3 = 0, h2 = 0;
          e3 = c2[a3 >> 2] | 0;
          h2 = a3 + 4 | 0;
          g3 = b3 + 4 | 0;
          f2 = (c2[h2 >> 2] | 0) - e3 | 0;
          d2 = (c2[g3 >> 2] | 0) + (((f2 | 0) / -12 | 0) * 12 | 0) | 0;
          c2[g3 >> 2] = d2;
          if ((f2 | 0) > 0) {
            BC(d2 | 0, e3 | 0, f2 | 0) | 0;
            e3 = g3;
            d2 = c2[g3 >> 2] | 0;
          } else
            e3 = g3;
          g3 = c2[a3 >> 2] | 0;
          c2[a3 >> 2] = d2;
          c2[e3 >> 2] = g3;
          g3 = b3 + 8 | 0;
          f2 = c2[h2 >> 2] | 0;
          c2[h2 >> 2] = c2[g3 >> 2];
          c2[g3 >> 2] = f2;
          g3 = a3 + 8 | 0;
          h2 = b3 + 12 | 0;
          a3 = c2[g3 >> 2] | 0;
          c2[g3 >> 2] = c2[h2 >> 2];
          c2[h2 >> 2] = a3;
          c2[b3 >> 2] = c2[e3 >> 2];
          return;
        }
        function cn(a3) {
          a3 = a3 | 0;
          var b3 = 0, d2 = 0, e3 = 0;
          b3 = c2[a3 + 4 >> 2] | 0;
          d2 = a3 + 8 | 0;
          e3 = c2[d2 >> 2] | 0;
          if ((e3 | 0) != (b3 | 0))
            c2[d2 >> 2] = e3 + (~(((e3 + -12 - b3 | 0) >>> 0) / 12 | 0) * 12 | 0);
          a3 = c2[a3 >> 2] | 0;
          if (a3 | 0)
            sC(a3);
          return;
        }
        function dn(a3) {
          a3 = a3 | 0;
          gn(a3);
          return;
        }
        function en(a3) {
          a3 = a3 | 0;
          fn(a3 + 24 | 0);
          return;
        }
        function fn(a3) {
          a3 = a3 | 0;
          var b3 = 0, d2 = 0, e3 = 0;
          d2 = c2[a3 >> 2] | 0;
          e3 = d2;
          if (d2 | 0) {
            a3 = a3 + 4 | 0;
            b3 = c2[a3 >> 2] | 0;
            if ((b3 | 0) != (d2 | 0))
              c2[a3 >> 2] = b3 + (~(((b3 + -12 - e3 | 0) >>> 0) / 12 | 0) * 12 | 0);
            sC(d2);
          }
          return;
        }
        function gn(a3) {
          a3 = a3 | 0;
          var b3 = 0;
          b3 = vi() | 0;
          yi(a3, 2, 7, b3, hn() | 0, 0);
          c2[a3 + 24 >> 2] = 0;
          c2[a3 + 28 >> 2] = 0;
          c2[a3 + 32 >> 2] = 0;
          return;
        }
        function hn() {
          return 1276;
        }
        function jn(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          var d2 = 0, e3 = 0, f2 = 0, g3 = 0;
          d2 = l2;
          l2 = l2 + 16 | 0;
          e3 = d2 + 8 | 0;
          f2 = d2;
          g3 = kn(a3) | 0;
          a3 = c2[g3 + 4 >> 2] | 0;
          c2[f2 >> 2] = c2[g3 >> 2];
          c2[f2 + 4 >> 2] = a3;
          c2[e3 >> 2] = c2[f2 >> 2];
          c2[e3 + 4 >> 2] = c2[f2 + 4 >> 2];
          b3 = ln(b3, e3) | 0;
          l2 = d2;
          return b3 | 0;
        }
        function kn(a3) {
          a3 = a3 | 0;
          return (c2[(Wm() | 0) + 24 >> 2] | 0) + (a3 * 12 | 0) | 0;
        }
        function ln(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          var d2 = 0, e3 = 0, f2 = 0;
          f2 = l2;
          l2 = l2 + 16 | 0;
          e3 = f2;
          d2 = c2[b3 >> 2] | 0;
          b3 = c2[b3 + 4 >> 2] | 0;
          a3 = a3 + (b3 >> 1) | 0;
          if (b3 & 1)
            d2 = c2[(c2[a3 >> 2] | 0) + d2 >> 2] | 0;
          ob[d2 & 31](e3, a3);
          e3 = mn(e3) | 0;
          l2 = f2;
          return e3 | 0;
        }
        function mn(a3) {
          a3 = a3 | 0;
          var b3 = 0, c3 = 0, d2 = 0, e3 = 0;
          e3 = l2;
          l2 = l2 + 32 | 0;
          b3 = e3 + 12 | 0;
          c3 = e3;
          d2 = Di(nn() | 0) | 0;
          if (!d2)
            a3 = pn(a3) | 0;
          else {
            Ei(b3, d2);
            Fi(c3, b3);
            on(a3, c3);
            a3 = Hi(b3) | 0;
          }
          l2 = e3;
          return a3 | 0;
        }
        function nn() {
          var b3 = 0;
          if (!(a2[7736] | 0)) {
            An(9640);
            Ha(25, 9640, o2 | 0) | 0;
            b3 = 7736;
            c2[b3 >> 2] = 1;
            c2[b3 + 4 >> 2] = 0;
          }
          return 9640;
        }
        function on(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          un(b3, a3, a3 + 8 | 0) | 0;
          return;
        }
        function pn(a3) {
          a3 = a3 | 0;
          var b3 = 0, d2 = 0, e3 = 0, f2 = 0, g3 = 0, h2 = 0, i4 = 0;
          d2 = l2;
          l2 = l2 + 16 | 0;
          f2 = d2 + 4 | 0;
          h2 = d2;
          e3 = jy(8) | 0;
          b3 = e3;
          i4 = qC(16) | 0;
          c2[i4 >> 2] = c2[a3 >> 2];
          c2[i4 + 4 >> 2] = c2[a3 + 4 >> 2];
          c2[i4 + 8 >> 2] = c2[a3 + 8 >> 2];
          c2[i4 + 12 >> 2] = c2[a3 + 12 >> 2];
          g3 = b3 + 4 | 0;
          c2[g3 >> 2] = i4;
          a3 = qC(8) | 0;
          g3 = c2[g3 >> 2] | 0;
          c2[h2 >> 2] = 0;
          c2[f2 >> 2] = c2[h2 >> 2];
          qn(a3, g3, f2);
          c2[e3 >> 2] = a3;
          l2 = d2;
          return b3 | 0;
        }
        function qn(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          c2[a3 >> 2] = b3;
          d2 = qC(16) | 0;
          c2[d2 + 4 >> 2] = 0;
          c2[d2 + 8 >> 2] = 0;
          c2[d2 >> 2] = 1244;
          c2[d2 + 12 >> 2] = b3;
          c2[a3 + 4 >> 2] = d2;
          return;
        }
        function rn(a3) {
          a3 = a3 | 0;
          kC(a3);
          sC(a3);
          return;
        }
        function sn(a3) {
          a3 = a3 | 0;
          a3 = c2[a3 + 12 >> 2] | 0;
          if (a3 | 0)
            sC(a3);
          return;
        }
        function tn(a3) {
          a3 = a3 | 0;
          sC(a3);
          return;
        }
        function un(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          b3 = vn(c2[a3 >> 2] | 0, b3, d2) | 0;
          d2 = a3 + 4 | 0;
          c2[(c2[d2 >> 2] | 0) + 8 >> 2] = b3;
          return c2[(c2[d2 >> 2] | 0) + 8 >> 2] | 0;
        }
        function vn(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          var e3 = 0, f2 = 0;
          e3 = l2;
          l2 = l2 + 16 | 0;
          f2 = e3;
          UA(f2);
          a3 = Sg(a3) | 0;
          d2 = wn(a3, c2[b3 >> 2] | 0, +h[d2 >> 3]) | 0;
          WA(f2);
          l2 = e3;
          return d2 | 0;
        }
        function wn(a3, b3, c3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          c3 = +c3;
          var d2 = 0;
          d2 = Vg(xn() | 0) | 0;
          b3 = Xg(b3) | 0;
          return za(0, d2 | 0, a3 | 0, b3 | 0, + +Wg(c3)) | 0;
        }
        function xn() {
          var b3 = 0;
          if (!(a2[7728] | 0)) {
            yn(9628);
            b3 = 7728;
            c2[b3 >> 2] = 1;
            c2[b3 + 4 >> 2] = 0;
          }
          return 9628;
        }
        function yn(a3) {
          a3 = a3 | 0;
          fh(a3, zn() | 0, 2);
          return;
        }
        function zn() {
          return 1264;
        }
        function An(a3) {
          a3 = a3 | 0;
          Zi(a3);
          return;
        }
        function Bn(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          var e3 = 0, f2 = 0, g3 = 0, h2 = 0, i4 = 0;
          e3 = l2;
          l2 = l2 + 16 | 0;
          f2 = e3 + 8 | 0;
          g3 = e3;
          i4 = c2[d2 >> 2] | 0;
          h2 = c2[d2 + 4 >> 2] | 0;
          d2 = ai(b3) | 0;
          c2[g3 >> 2] = i4;
          c2[g3 + 4 >> 2] = h2;
          c2[f2 >> 2] = c2[g3 >> 2];
          c2[f2 + 4 >> 2] = c2[g3 + 4 >> 2];
          Cn(a3, d2, f2, 1);
          l2 = e3;
          return;
        }
        function Cn(a3, b3, d2, e3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          e3 = e3 | 0;
          var f2 = 0, g3 = 0, h2 = 0, i4 = 0, j2 = 0, k2 = 0, m2 = 0;
          f2 = l2;
          l2 = l2 + 32 | 0;
          g3 = f2 + 16 | 0;
          m2 = f2 + 8 | 0;
          i4 = f2;
          k2 = c2[d2 >> 2] | 0;
          j2 = c2[d2 + 4 >> 2] | 0;
          h2 = c2[a3 >> 2] | 0;
          a3 = Dn() | 0;
          c2[m2 >> 2] = k2;
          c2[m2 + 4 >> 2] = j2;
          c2[g3 >> 2] = c2[m2 >> 2];
          c2[g3 + 4 >> 2] = c2[m2 + 4 >> 2];
          d2 = En(g3) | 0;
          c2[i4 >> 2] = k2;
          c2[i4 + 4 >> 2] = j2;
          c2[g3 >> 2] = c2[i4 >> 2];
          c2[g3 + 4 >> 2] = c2[i4 + 4 >> 2];
          fi(h2, b3, a3, d2, Fn(g3, e3) | 0, e3);
          l2 = f2;
          return;
        }
        function Dn() {
          var b3 = 0, d2 = 0;
          if (!(a2[7744] | 0)) {
            Mn(9684);
            Ha(37, 9684, o2 | 0) | 0;
            d2 = 7744;
            c2[d2 >> 2] = 1;
            c2[d2 + 4 >> 2] = 0;
          }
          if (!(si(9684) | 0)) {
            b3 = 9684;
            d2 = b3 + 36 | 0;
            do {
              c2[b3 >> 2] = 0;
              b3 = b3 + 4 | 0;
            } while ((b3 | 0) < (d2 | 0));
            Mn(9684);
          }
          return 9684;
        }
        function En(a3) {
          a3 = a3 | 0;
          return 0;
        }
        function Fn(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          var d2 = 0, e3 = 0, f2 = 0, g3 = 0, h2 = 0, i4 = 0, j2 = 0, k2 = 0, m2 = 0, n3 = 0;
          m2 = l2;
          l2 = l2 + 32 | 0;
          f2 = m2 + 24 | 0;
          h2 = m2 + 16 | 0;
          i4 = m2;
          j2 = m2 + 8 | 0;
          g3 = c2[a3 >> 2] | 0;
          e3 = c2[a3 + 4 >> 2] | 0;
          c2[i4 >> 2] = g3;
          c2[i4 + 4 >> 2] = e3;
          n3 = Dn() | 0;
          k2 = n3 + 24 | 0;
          a3 = ji(b3, 4) | 0;
          c2[j2 >> 2] = a3;
          b3 = n3 + 28 | 0;
          d2 = c2[b3 >> 2] | 0;
          if (d2 >>> 0 < (c2[n3 + 32 >> 2] | 0) >>> 0) {
            c2[h2 >> 2] = g3;
            c2[h2 + 4 >> 2] = e3;
            c2[f2 >> 2] = c2[h2 >> 2];
            c2[f2 + 4 >> 2] = c2[h2 + 4 >> 2];
            Gn(d2, f2, a3);
            a3 = (c2[b3 >> 2] | 0) + 12 | 0;
            c2[b3 >> 2] = a3;
          } else {
            Hn(k2, i4, j2);
            a3 = c2[b3 >> 2] | 0;
          }
          l2 = m2;
          return ((a3 - (c2[k2 >> 2] | 0) | 0) / 12 | 0) + -1 | 0;
        }
        function Gn(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          var e3 = 0;
          e3 = c2[b3 + 4 >> 2] | 0;
          c2[a3 >> 2] = c2[b3 >> 2];
          c2[a3 + 4 >> 2] = e3;
          c2[a3 + 8 >> 2] = d2;
          return;
        }
        function Hn(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          var e3 = 0, f2 = 0, g3 = 0, h2 = 0, i4 = 0, j2 = 0, k2 = 0, m2 = 0, n3 = 0, o3 = 0;
          k2 = l2;
          l2 = l2 + 48 | 0;
          e3 = k2 + 32 | 0;
          h2 = k2 + 24 | 0;
          i4 = k2;
          j2 = a3 + 4 | 0;
          f2 = (((c2[j2 >> 2] | 0) - (c2[a3 >> 2] | 0) | 0) / 12 | 0) + 1 | 0;
          g3 = In(a3) | 0;
          if (g3 >>> 0 < f2 >>> 0)
            jC(a3);
          else {
            m2 = c2[a3 >> 2] | 0;
            o3 = ((c2[a3 + 8 >> 2] | 0) - m2 | 0) / 12 | 0;
            n3 = o3 << 1;
            Jn(i4, o3 >>> 0 < g3 >>> 1 >>> 0 ? n3 >>> 0 < f2 >>> 0 ? f2 : n3 : g3, ((c2[j2 >> 2] | 0) - m2 | 0) / 12 | 0, a3 + 8 | 0);
            j2 = i4 + 8 | 0;
            g3 = c2[j2 >> 2] | 0;
            f2 = c2[b3 + 4 >> 2] | 0;
            d2 = c2[d2 >> 2] | 0;
            c2[h2 >> 2] = c2[b3 >> 2];
            c2[h2 + 4 >> 2] = f2;
            c2[e3 >> 2] = c2[h2 >> 2];
            c2[e3 + 4 >> 2] = c2[h2 + 4 >> 2];
            Gn(g3, e3, d2);
            c2[j2 >> 2] = (c2[j2 >> 2] | 0) + 12;
            Kn(a3, i4);
            Ln(i4);
            l2 = k2;
            return;
          }
        }
        function In(a3) {
          a3 = a3 | 0;
          return 357913941;
        }
        function Jn(a3, b3, d2, e3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          e3 = e3 | 0;
          var f2 = 0;
          c2[a3 + 12 >> 2] = 0;
          c2[a3 + 16 >> 2] = e3;
          do
            if (b3) {
              if (b3 >>> 0 > 357913941)
                Ta();
              else {
                f2 = qC(b3 * 12 | 0) | 0;
                break;
              }
            } else
              f2 = 0;
          while (0);
          c2[a3 >> 2] = f2;
          e3 = f2 + (d2 * 12 | 0) | 0;
          c2[a3 + 8 >> 2] = e3;
          c2[a3 + 4 >> 2] = e3;
          c2[a3 + 12 >> 2] = f2 + (b3 * 12 | 0);
          return;
        }
        function Kn(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          var d2 = 0, e3 = 0, f2 = 0, g3 = 0, h2 = 0;
          e3 = c2[a3 >> 2] | 0;
          h2 = a3 + 4 | 0;
          g3 = b3 + 4 | 0;
          f2 = (c2[h2 >> 2] | 0) - e3 | 0;
          d2 = (c2[g3 >> 2] | 0) + (((f2 | 0) / -12 | 0) * 12 | 0) | 0;
          c2[g3 >> 2] = d2;
          if ((f2 | 0) > 0) {
            BC(d2 | 0, e3 | 0, f2 | 0) | 0;
            e3 = g3;
            d2 = c2[g3 >> 2] | 0;
          } else
            e3 = g3;
          g3 = c2[a3 >> 2] | 0;
          c2[a3 >> 2] = d2;
          c2[e3 >> 2] = g3;
          g3 = b3 + 8 | 0;
          f2 = c2[h2 >> 2] | 0;
          c2[h2 >> 2] = c2[g3 >> 2];
          c2[g3 >> 2] = f2;
          g3 = a3 + 8 | 0;
          h2 = b3 + 12 | 0;
          a3 = c2[g3 >> 2] | 0;
          c2[g3 >> 2] = c2[h2 >> 2];
          c2[h2 >> 2] = a3;
          c2[b3 >> 2] = c2[e3 >> 2];
          return;
        }
        function Ln(a3) {
          a3 = a3 | 0;
          var b3 = 0, d2 = 0, e3 = 0;
          b3 = c2[a3 + 4 >> 2] | 0;
          d2 = a3 + 8 | 0;
          e3 = c2[d2 >> 2] | 0;
          if ((e3 | 0) != (b3 | 0))
            c2[d2 >> 2] = e3 + (~(((e3 + -12 - b3 | 0) >>> 0) / 12 | 0) * 12 | 0);
          a3 = c2[a3 >> 2] | 0;
          if (a3 | 0)
            sC(a3);
          return;
        }
        function Mn(a3) {
          a3 = a3 | 0;
          Pn(a3);
          return;
        }
        function Nn(a3) {
          a3 = a3 | 0;
          On(a3 + 24 | 0);
          return;
        }
        function On(a3) {
          a3 = a3 | 0;
          var b3 = 0, d2 = 0, e3 = 0;
          d2 = c2[a3 >> 2] | 0;
          e3 = d2;
          if (d2 | 0) {
            a3 = a3 + 4 | 0;
            b3 = c2[a3 >> 2] | 0;
            if ((b3 | 0) != (d2 | 0))
              c2[a3 >> 2] = b3 + (~(((b3 + -12 - e3 | 0) >>> 0) / 12 | 0) * 12 | 0);
            sC(d2);
          }
          return;
        }
        function Pn(a3) {
          a3 = a3 | 0;
          var b3 = 0;
          b3 = vi() | 0;
          yi(a3, 2, 5, b3, Qn() | 0, 1);
          c2[a3 + 24 >> 2] = 0;
          c2[a3 + 28 >> 2] = 0;
          c2[a3 + 32 >> 2] = 0;
          return;
        }
        function Qn() {
          return 1280;
        }
        function Rn(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          var e3 = 0, f2 = 0, g3 = 0, h2 = 0;
          e3 = l2;
          l2 = l2 + 16 | 0;
          f2 = e3 + 8 | 0;
          g3 = e3;
          h2 = Sn(a3) | 0;
          a3 = c2[h2 + 4 >> 2] | 0;
          c2[g3 >> 2] = c2[h2 >> 2];
          c2[g3 + 4 >> 2] = a3;
          c2[f2 >> 2] = c2[g3 >> 2];
          c2[f2 + 4 >> 2] = c2[g3 + 4 >> 2];
          d2 = Tn(b3, f2, d2) | 0;
          l2 = e3;
          return d2 | 0;
        }
        function Sn(a3) {
          a3 = a3 | 0;
          return (c2[(Dn() | 0) + 24 >> 2] | 0) + (a3 * 12 | 0) | 0;
        }
        function Tn(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          var e3 = 0, f2 = 0, g3 = 0, h2 = 0;
          h2 = l2;
          l2 = l2 + 32 | 0;
          f2 = h2;
          g3 = h2 + 16 | 0;
          e3 = c2[b3 >> 2] | 0;
          b3 = c2[b3 + 4 >> 2] | 0;
          a3 = a3 + (b3 >> 1) | 0;
          if (b3 & 1)
            e3 = c2[(c2[a3 >> 2] | 0) + e3 >> 2] | 0;
          tj(g3, d2);
          g3 = uj(g3, d2) | 0;
          Eb[e3 & 15](f2, a3, g3);
          g3 = mn(f2) | 0;
          l2 = h2;
          return g3 | 0;
        }
        function Un(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          var e3 = 0, f2 = 0, g3 = 0, h2 = 0, i4 = 0;
          e3 = l2;
          l2 = l2 + 16 | 0;
          f2 = e3 + 8 | 0;
          g3 = e3;
          i4 = c2[d2 >> 2] | 0;
          h2 = c2[d2 + 4 >> 2] | 0;
          d2 = ai(b3) | 0;
          c2[g3 >> 2] = i4;
          c2[g3 + 4 >> 2] = h2;
          c2[f2 >> 2] = c2[g3 >> 2];
          c2[f2 + 4 >> 2] = c2[g3 + 4 >> 2];
          Vn(a3, d2, f2, 1);
          l2 = e3;
          return;
        }
        function Vn(a3, b3, d2, e3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          e3 = e3 | 0;
          var f2 = 0, g3 = 0, h2 = 0, i4 = 0, j2 = 0, k2 = 0, m2 = 0;
          f2 = l2;
          l2 = l2 + 32 | 0;
          g3 = f2 + 16 | 0;
          m2 = f2 + 8 | 0;
          i4 = f2;
          k2 = c2[d2 >> 2] | 0;
          j2 = c2[d2 + 4 >> 2] | 0;
          h2 = c2[a3 >> 2] | 0;
          a3 = Wn() | 0;
          c2[m2 >> 2] = k2;
          c2[m2 + 4 >> 2] = j2;
          c2[g3 >> 2] = c2[m2 >> 2];
          c2[g3 + 4 >> 2] = c2[m2 + 4 >> 2];
          d2 = Xn(g3) | 0;
          c2[i4 >> 2] = k2;
          c2[i4 + 4 >> 2] = j2;
          c2[g3 >> 2] = c2[i4 >> 2];
          c2[g3 + 4 >> 2] = c2[i4 + 4 >> 2];
          fi(h2, b3, a3, d2, Yn(g3, e3) | 0, e3);
          l2 = f2;
          return;
        }
        function Wn() {
          var b3 = 0, d2 = 0;
          if (!(a2[7752] | 0)) {
            eo(9720);
            Ha(38, 9720, o2 | 0) | 0;
            d2 = 7752;
            c2[d2 >> 2] = 1;
            c2[d2 + 4 >> 2] = 0;
          }
          if (!(si(9720) | 0)) {
            b3 = 9720;
            d2 = b3 + 36 | 0;
            do {
              c2[b3 >> 2] = 0;
              b3 = b3 + 4 | 0;
            } while ((b3 | 0) < (d2 | 0));
            eo(9720);
          }
          return 9720;
        }
        function Xn(a3) {
          a3 = a3 | 0;
          return 0;
        }
        function Yn(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          var d2 = 0, e3 = 0, f2 = 0, g3 = 0, h2 = 0, i4 = 0, j2 = 0, k2 = 0, m2 = 0, n3 = 0;
          m2 = l2;
          l2 = l2 + 32 | 0;
          f2 = m2 + 24 | 0;
          h2 = m2 + 16 | 0;
          i4 = m2;
          j2 = m2 + 8 | 0;
          g3 = c2[a3 >> 2] | 0;
          e3 = c2[a3 + 4 >> 2] | 0;
          c2[i4 >> 2] = g3;
          c2[i4 + 4 >> 2] = e3;
          n3 = Wn() | 0;
          k2 = n3 + 24 | 0;
          a3 = ji(b3, 4) | 0;
          c2[j2 >> 2] = a3;
          b3 = n3 + 28 | 0;
          d2 = c2[b3 >> 2] | 0;
          if (d2 >>> 0 < (c2[n3 + 32 >> 2] | 0) >>> 0) {
            c2[h2 >> 2] = g3;
            c2[h2 + 4 >> 2] = e3;
            c2[f2 >> 2] = c2[h2 >> 2];
            c2[f2 + 4 >> 2] = c2[h2 + 4 >> 2];
            Zn(d2, f2, a3);
            a3 = (c2[b3 >> 2] | 0) + 12 | 0;
            c2[b3 >> 2] = a3;
          } else {
            _n(k2, i4, j2);
            a3 = c2[b3 >> 2] | 0;
          }
          l2 = m2;
          return ((a3 - (c2[k2 >> 2] | 0) | 0) / 12 | 0) + -1 | 0;
        }
        function Zn(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          var e3 = 0;
          e3 = c2[b3 + 4 >> 2] | 0;
          c2[a3 >> 2] = c2[b3 >> 2];
          c2[a3 + 4 >> 2] = e3;
          c2[a3 + 8 >> 2] = d2;
          return;
        }
        function _n(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          var e3 = 0, f2 = 0, g3 = 0, h2 = 0, i4 = 0, j2 = 0, k2 = 0, m2 = 0, n3 = 0, o3 = 0;
          k2 = l2;
          l2 = l2 + 48 | 0;
          e3 = k2 + 32 | 0;
          h2 = k2 + 24 | 0;
          i4 = k2;
          j2 = a3 + 4 | 0;
          f2 = (((c2[j2 >> 2] | 0) - (c2[a3 >> 2] | 0) | 0) / 12 | 0) + 1 | 0;
          g3 = $n(a3) | 0;
          if (g3 >>> 0 < f2 >>> 0)
            jC(a3);
          else {
            m2 = c2[a3 >> 2] | 0;
            o3 = ((c2[a3 + 8 >> 2] | 0) - m2 | 0) / 12 | 0;
            n3 = o3 << 1;
            ao(i4, o3 >>> 0 < g3 >>> 1 >>> 0 ? n3 >>> 0 < f2 >>> 0 ? f2 : n3 : g3, ((c2[j2 >> 2] | 0) - m2 | 0) / 12 | 0, a3 + 8 | 0);
            j2 = i4 + 8 | 0;
            g3 = c2[j2 >> 2] | 0;
            f2 = c2[b3 + 4 >> 2] | 0;
            d2 = c2[d2 >> 2] | 0;
            c2[h2 >> 2] = c2[b3 >> 2];
            c2[h2 + 4 >> 2] = f2;
            c2[e3 >> 2] = c2[h2 >> 2];
            c2[e3 + 4 >> 2] = c2[h2 + 4 >> 2];
            Zn(g3, e3, d2);
            c2[j2 >> 2] = (c2[j2 >> 2] | 0) + 12;
            bo(a3, i4);
            co(i4);
            l2 = k2;
            return;
          }
        }
        function $n(a3) {
          a3 = a3 | 0;
          return 357913941;
        }
        function ao(a3, b3, d2, e3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          e3 = e3 | 0;
          var f2 = 0;
          c2[a3 + 12 >> 2] = 0;
          c2[a3 + 16 >> 2] = e3;
          do
            if (b3) {
              if (b3 >>> 0 > 357913941)
                Ta();
              else {
                f2 = qC(b3 * 12 | 0) | 0;
                break;
              }
            } else
              f2 = 0;
          while (0);
          c2[a3 >> 2] = f2;
          e3 = f2 + (d2 * 12 | 0) | 0;
          c2[a3 + 8 >> 2] = e3;
          c2[a3 + 4 >> 2] = e3;
          c2[a3 + 12 >> 2] = f2 + (b3 * 12 | 0);
          return;
        }
        function bo(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          var d2 = 0, e3 = 0, f2 = 0, g3 = 0, h2 = 0;
          e3 = c2[a3 >> 2] | 0;
          h2 = a3 + 4 | 0;
          g3 = b3 + 4 | 0;
          f2 = (c2[h2 >> 2] | 0) - e3 | 0;
          d2 = (c2[g3 >> 2] | 0) + (((f2 | 0) / -12 | 0) * 12 | 0) | 0;
          c2[g3 >> 2] = d2;
          if ((f2 | 0) > 0) {
            BC(d2 | 0, e3 | 0, f2 | 0) | 0;
            e3 = g3;
            d2 = c2[g3 >> 2] | 0;
          } else
            e3 = g3;
          g3 = c2[a3 >> 2] | 0;
          c2[a3 >> 2] = d2;
          c2[e3 >> 2] = g3;
          g3 = b3 + 8 | 0;
          f2 = c2[h2 >> 2] | 0;
          c2[h2 >> 2] = c2[g3 >> 2];
          c2[g3 >> 2] = f2;
          g3 = a3 + 8 | 0;
          h2 = b3 + 12 | 0;
          a3 = c2[g3 >> 2] | 0;
          c2[g3 >> 2] = c2[h2 >> 2];
          c2[h2 >> 2] = a3;
          c2[b3 >> 2] = c2[e3 >> 2];
          return;
        }
        function co(a3) {
          a3 = a3 | 0;
          var b3 = 0, d2 = 0, e3 = 0;
          b3 = c2[a3 + 4 >> 2] | 0;
          d2 = a3 + 8 | 0;
          e3 = c2[d2 >> 2] | 0;
          if ((e3 | 0) != (b3 | 0))
            c2[d2 >> 2] = e3 + (~(((e3 + -12 - b3 | 0) >>> 0) / 12 | 0) * 12 | 0);
          a3 = c2[a3 >> 2] | 0;
          if (a3 | 0)
            sC(a3);
          return;
        }
        function eo(a3) {
          a3 = a3 | 0;
          ho(a3);
          return;
        }
        function fo(a3) {
          a3 = a3 | 0;
          go(a3 + 24 | 0);
          return;
        }
        function go(a3) {
          a3 = a3 | 0;
          var b3 = 0, d2 = 0, e3 = 0;
          d2 = c2[a3 >> 2] | 0;
          e3 = d2;
          if (d2 | 0) {
            a3 = a3 + 4 | 0;
            b3 = c2[a3 >> 2] | 0;
            if ((b3 | 0) != (d2 | 0))
              c2[a3 >> 2] = b3 + (~(((b3 + -12 - e3 | 0) >>> 0) / 12 | 0) * 12 | 0);
            sC(d2);
          }
          return;
        }
        function ho(a3) {
          a3 = a3 | 0;
          var b3 = 0;
          b3 = vi() | 0;
          yi(a3, 2, 8, b3, io() | 0, 0);
          c2[a3 + 24 >> 2] = 0;
          c2[a3 + 28 >> 2] = 0;
          c2[a3 + 32 >> 2] = 0;
          return;
        }
        function io() {
          return 1288;
        }
        function jo(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          var d2 = 0, e3 = 0, f2 = 0, g3 = 0;
          d2 = l2;
          l2 = l2 + 16 | 0;
          e3 = d2 + 8 | 0;
          f2 = d2;
          g3 = ko(a3) | 0;
          a3 = c2[g3 + 4 >> 2] | 0;
          c2[f2 >> 2] = c2[g3 >> 2];
          c2[f2 + 4 >> 2] = a3;
          c2[e3 >> 2] = c2[f2 >> 2];
          c2[e3 + 4 >> 2] = c2[f2 + 4 >> 2];
          b3 = lo(b3, e3) | 0;
          l2 = d2;
          return b3 | 0;
        }
        function ko(a3) {
          a3 = a3 | 0;
          return (c2[(Wn() | 0) + 24 >> 2] | 0) + (a3 * 12 | 0) | 0;
        }
        function lo(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          var d2 = 0;
          d2 = c2[b3 >> 2] | 0;
          b3 = c2[b3 + 4 >> 2] | 0;
          a3 = a3 + (b3 >> 1) | 0;
          if (b3 & 1)
            d2 = c2[(c2[a3 >> 2] | 0) + d2 >> 2] | 0;
          return bh(pb[d2 & 31](a3) | 0) | 0;
        }
        function mo(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          var e3 = 0, f2 = 0, g3 = 0, h2 = 0, i4 = 0;
          e3 = l2;
          l2 = l2 + 16 | 0;
          f2 = e3 + 8 | 0;
          g3 = e3;
          i4 = c2[d2 >> 2] | 0;
          h2 = c2[d2 + 4 >> 2] | 0;
          d2 = ai(b3) | 0;
          c2[g3 >> 2] = i4;
          c2[g3 + 4 >> 2] = h2;
          c2[f2 >> 2] = c2[g3 >> 2];
          c2[f2 + 4 >> 2] = c2[g3 + 4 >> 2];
          no(a3, d2, f2, 0);
          l2 = e3;
          return;
        }
        function no(a3, b3, d2, e3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          e3 = e3 | 0;
          var f2 = 0, g3 = 0, h2 = 0, i4 = 0, j2 = 0, k2 = 0, m2 = 0;
          f2 = l2;
          l2 = l2 + 32 | 0;
          g3 = f2 + 16 | 0;
          m2 = f2 + 8 | 0;
          i4 = f2;
          k2 = c2[d2 >> 2] | 0;
          j2 = c2[d2 + 4 >> 2] | 0;
          h2 = c2[a3 >> 2] | 0;
          a3 = oo() | 0;
          c2[m2 >> 2] = k2;
          c2[m2 + 4 >> 2] = j2;
          c2[g3 >> 2] = c2[m2 >> 2];
          c2[g3 + 4 >> 2] = c2[m2 + 4 >> 2];
          d2 = po(g3) | 0;
          c2[i4 >> 2] = k2;
          c2[i4 + 4 >> 2] = j2;
          c2[g3 >> 2] = c2[i4 >> 2];
          c2[g3 + 4 >> 2] = c2[i4 + 4 >> 2];
          fi(h2, b3, a3, d2, qo(g3, e3) | 0, e3);
          l2 = f2;
          return;
        }
        function oo() {
          var b3 = 0, d2 = 0;
          if (!(a2[7760] | 0)) {
            xo(9756);
            Ha(39, 9756, o2 | 0) | 0;
            d2 = 7760;
            c2[d2 >> 2] = 1;
            c2[d2 + 4 >> 2] = 0;
          }
          if (!(si(9756) | 0)) {
            b3 = 9756;
            d2 = b3 + 36 | 0;
            do {
              c2[b3 >> 2] = 0;
              b3 = b3 + 4 | 0;
            } while ((b3 | 0) < (d2 | 0));
            xo(9756);
          }
          return 9756;
        }
        function po(a3) {
          a3 = a3 | 0;
          return 0;
        }
        function qo(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          var d2 = 0, e3 = 0, f2 = 0, g3 = 0, h2 = 0, i4 = 0, j2 = 0, k2 = 0, m2 = 0, n3 = 0;
          m2 = l2;
          l2 = l2 + 32 | 0;
          f2 = m2 + 24 | 0;
          h2 = m2 + 16 | 0;
          i4 = m2;
          j2 = m2 + 8 | 0;
          g3 = c2[a3 >> 2] | 0;
          e3 = c2[a3 + 4 >> 2] | 0;
          c2[i4 >> 2] = g3;
          c2[i4 + 4 >> 2] = e3;
          n3 = oo() | 0;
          k2 = n3 + 24 | 0;
          a3 = ji(b3, 4) | 0;
          c2[j2 >> 2] = a3;
          b3 = n3 + 28 | 0;
          d2 = c2[b3 >> 2] | 0;
          if (d2 >>> 0 < (c2[n3 + 32 >> 2] | 0) >>> 0) {
            c2[h2 >> 2] = g3;
            c2[h2 + 4 >> 2] = e3;
            c2[f2 >> 2] = c2[h2 >> 2];
            c2[f2 + 4 >> 2] = c2[h2 + 4 >> 2];
            ro(d2, f2, a3);
            a3 = (c2[b3 >> 2] | 0) + 12 | 0;
            c2[b3 >> 2] = a3;
          } else {
            so(k2, i4, j2);
            a3 = c2[b3 >> 2] | 0;
          }
          l2 = m2;
          return ((a3 - (c2[k2 >> 2] | 0) | 0) / 12 | 0) + -1 | 0;
        }
        function ro(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          var e3 = 0;
          e3 = c2[b3 + 4 >> 2] | 0;
          c2[a3 >> 2] = c2[b3 >> 2];
          c2[a3 + 4 >> 2] = e3;
          c2[a3 + 8 >> 2] = d2;
          return;
        }
        function so(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          var e3 = 0, f2 = 0, g3 = 0, h2 = 0, i4 = 0, j2 = 0, k2 = 0, m2 = 0, n3 = 0, o3 = 0;
          k2 = l2;
          l2 = l2 + 48 | 0;
          e3 = k2 + 32 | 0;
          h2 = k2 + 24 | 0;
          i4 = k2;
          j2 = a3 + 4 | 0;
          f2 = (((c2[j2 >> 2] | 0) - (c2[a3 >> 2] | 0) | 0) / 12 | 0) + 1 | 0;
          g3 = to(a3) | 0;
          if (g3 >>> 0 < f2 >>> 0)
            jC(a3);
          else {
            m2 = c2[a3 >> 2] | 0;
            o3 = ((c2[a3 + 8 >> 2] | 0) - m2 | 0) / 12 | 0;
            n3 = o3 << 1;
            uo(i4, o3 >>> 0 < g3 >>> 1 >>> 0 ? n3 >>> 0 < f2 >>> 0 ? f2 : n3 : g3, ((c2[j2 >> 2] | 0) - m2 | 0) / 12 | 0, a3 + 8 | 0);
            j2 = i4 + 8 | 0;
            g3 = c2[j2 >> 2] | 0;
            f2 = c2[b3 + 4 >> 2] | 0;
            d2 = c2[d2 >> 2] | 0;
            c2[h2 >> 2] = c2[b3 >> 2];
            c2[h2 + 4 >> 2] = f2;
            c2[e3 >> 2] = c2[h2 >> 2];
            c2[e3 + 4 >> 2] = c2[h2 + 4 >> 2];
            ro(g3, e3, d2);
            c2[j2 >> 2] = (c2[j2 >> 2] | 0) + 12;
            vo(a3, i4);
            wo(i4);
            l2 = k2;
            return;
          }
        }
        function to(a3) {
          a3 = a3 | 0;
          return 357913941;
        }
        function uo(a3, b3, d2, e3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          e3 = e3 | 0;
          var f2 = 0;
          c2[a3 + 12 >> 2] = 0;
          c2[a3 + 16 >> 2] = e3;
          do
            if (b3) {
              if (b3 >>> 0 > 357913941)
                Ta();
              else {
                f2 = qC(b3 * 12 | 0) | 0;
                break;
              }
            } else
              f2 = 0;
          while (0);
          c2[a3 >> 2] = f2;
          e3 = f2 + (d2 * 12 | 0) | 0;
          c2[a3 + 8 >> 2] = e3;
          c2[a3 + 4 >> 2] = e3;
          c2[a3 + 12 >> 2] = f2 + (b3 * 12 | 0);
          return;
        }
        function vo(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          var d2 = 0, e3 = 0, f2 = 0, g3 = 0, h2 = 0;
          e3 = c2[a3 >> 2] | 0;
          h2 = a3 + 4 | 0;
          g3 = b3 + 4 | 0;
          f2 = (c2[h2 >> 2] | 0) - e3 | 0;
          d2 = (c2[g3 >> 2] | 0) + (((f2 | 0) / -12 | 0) * 12 | 0) | 0;
          c2[g3 >> 2] = d2;
          if ((f2 | 0) > 0) {
            BC(d2 | 0, e3 | 0, f2 | 0) | 0;
            e3 = g3;
            d2 = c2[g3 >> 2] | 0;
          } else
            e3 = g3;
          g3 = c2[a3 >> 2] | 0;
          c2[a3 >> 2] = d2;
          c2[e3 >> 2] = g3;
          g3 = b3 + 8 | 0;
          f2 = c2[h2 >> 2] | 0;
          c2[h2 >> 2] = c2[g3 >> 2];
          c2[g3 >> 2] = f2;
          g3 = a3 + 8 | 0;
          h2 = b3 + 12 | 0;
          a3 = c2[g3 >> 2] | 0;
          c2[g3 >> 2] = c2[h2 >> 2];
          c2[h2 >> 2] = a3;
          c2[b3 >> 2] = c2[e3 >> 2];
          return;
        }
        function wo(a3) {
          a3 = a3 | 0;
          var b3 = 0, d2 = 0, e3 = 0;
          b3 = c2[a3 + 4 >> 2] | 0;
          d2 = a3 + 8 | 0;
          e3 = c2[d2 >> 2] | 0;
          if ((e3 | 0) != (b3 | 0))
            c2[d2 >> 2] = e3 + (~(((e3 + -12 - b3 | 0) >>> 0) / 12 | 0) * 12 | 0);
          a3 = c2[a3 >> 2] | 0;
          if (a3 | 0)
            sC(a3);
          return;
        }
        function xo(a3) {
          a3 = a3 | 0;
          Ao(a3);
          return;
        }
        function yo(a3) {
          a3 = a3 | 0;
          zo(a3 + 24 | 0);
          return;
        }
        function zo(a3) {
          a3 = a3 | 0;
          var b3 = 0, d2 = 0, e3 = 0;
          d2 = c2[a3 >> 2] | 0;
          e3 = d2;
          if (d2 | 0) {
            a3 = a3 + 4 | 0;
            b3 = c2[a3 >> 2] | 0;
            if ((b3 | 0) != (d2 | 0))
              c2[a3 >> 2] = b3 + (~(((b3 + -12 - e3 | 0) >>> 0) / 12 | 0) * 12 | 0);
            sC(d2);
          }
          return;
        }
        function Ao(a3) {
          a3 = a3 | 0;
          var b3 = 0;
          b3 = vi() | 0;
          yi(a3, 2, 8, b3, Bo() | 0, 1);
          c2[a3 + 24 >> 2] = 0;
          c2[a3 + 28 >> 2] = 0;
          c2[a3 + 32 >> 2] = 0;
          return;
        }
        function Bo() {
          return 1292;
        }
        function Co(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = +d2;
          var e3 = 0, f2 = 0, g3 = 0, h2 = 0;
          e3 = l2;
          l2 = l2 + 16 | 0;
          f2 = e3 + 8 | 0;
          g3 = e3;
          h2 = Do(a3) | 0;
          a3 = c2[h2 + 4 >> 2] | 0;
          c2[g3 >> 2] = c2[h2 >> 2];
          c2[g3 + 4 >> 2] = a3;
          c2[f2 >> 2] = c2[g3 >> 2];
          c2[f2 + 4 >> 2] = c2[g3 + 4 >> 2];
          Eo(b3, f2, d2);
          l2 = e3;
          return;
        }
        function Do(a3) {
          a3 = a3 | 0;
          return (c2[(oo() | 0) + 24 >> 2] | 0) + (a3 * 12 | 0) | 0;
        }
        function Eo(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = +d2;
          var e3 = 0, f2 = 0, g3 = 0;
          g3 = l2;
          l2 = l2 + 16 | 0;
          f2 = g3;
          e3 = c2[b3 >> 2] | 0;
          b3 = c2[b3 + 4 >> 2] | 0;
          a3 = a3 + (b3 >> 1) | 0;
          if (b3 & 1)
            e3 = c2[(c2[a3 >> 2] | 0) + e3 >> 2] | 0;
          rj(f2, d2);
          d2 = +sj(f2, d2);
          lb[e3 & 31](a3, d2);
          l2 = g3;
          return;
        }
        function Fo(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          var e3 = 0, f2 = 0, g3 = 0, h2 = 0, i4 = 0;
          e3 = l2;
          l2 = l2 + 16 | 0;
          f2 = e3 + 8 | 0;
          g3 = e3;
          i4 = c2[d2 >> 2] | 0;
          h2 = c2[d2 + 4 >> 2] | 0;
          d2 = ai(b3) | 0;
          c2[g3 >> 2] = i4;
          c2[g3 + 4 >> 2] = h2;
          c2[f2 >> 2] = c2[g3 >> 2];
          c2[f2 + 4 >> 2] = c2[g3 + 4 >> 2];
          Go(a3, d2, f2, 0);
          l2 = e3;
          return;
        }
        function Go(a3, b3, d2, e3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          e3 = e3 | 0;
          var f2 = 0, g3 = 0, h2 = 0, i4 = 0, j2 = 0, k2 = 0, m2 = 0;
          f2 = l2;
          l2 = l2 + 32 | 0;
          g3 = f2 + 16 | 0;
          m2 = f2 + 8 | 0;
          i4 = f2;
          k2 = c2[d2 >> 2] | 0;
          j2 = c2[d2 + 4 >> 2] | 0;
          h2 = c2[a3 >> 2] | 0;
          a3 = Ho() | 0;
          c2[m2 >> 2] = k2;
          c2[m2 + 4 >> 2] = j2;
          c2[g3 >> 2] = c2[m2 >> 2];
          c2[g3 + 4 >> 2] = c2[m2 + 4 >> 2];
          d2 = Io(g3) | 0;
          c2[i4 >> 2] = k2;
          c2[i4 + 4 >> 2] = j2;
          c2[g3 >> 2] = c2[i4 >> 2];
          c2[g3 + 4 >> 2] = c2[i4 + 4 >> 2];
          fi(h2, b3, a3, d2, Jo(g3, e3) | 0, e3);
          l2 = f2;
          return;
        }
        function Ho() {
          var b3 = 0, d2 = 0;
          if (!(a2[7768] | 0)) {
            Qo(9792);
            Ha(40, 9792, o2 | 0) | 0;
            d2 = 7768;
            c2[d2 >> 2] = 1;
            c2[d2 + 4 >> 2] = 0;
          }
          if (!(si(9792) | 0)) {
            b3 = 9792;
            d2 = b3 + 36 | 0;
            do {
              c2[b3 >> 2] = 0;
              b3 = b3 + 4 | 0;
            } while ((b3 | 0) < (d2 | 0));
            Qo(9792);
          }
          return 9792;
        }
        function Io(a3) {
          a3 = a3 | 0;
          return 0;
        }
        function Jo(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          var d2 = 0, e3 = 0, f2 = 0, g3 = 0, h2 = 0, i4 = 0, j2 = 0, k2 = 0, m2 = 0, n3 = 0;
          m2 = l2;
          l2 = l2 + 32 | 0;
          f2 = m2 + 24 | 0;
          h2 = m2 + 16 | 0;
          i4 = m2;
          j2 = m2 + 8 | 0;
          g3 = c2[a3 >> 2] | 0;
          e3 = c2[a3 + 4 >> 2] | 0;
          c2[i4 >> 2] = g3;
          c2[i4 + 4 >> 2] = e3;
          n3 = Ho() | 0;
          k2 = n3 + 24 | 0;
          a3 = ji(b3, 4) | 0;
          c2[j2 >> 2] = a3;
          b3 = n3 + 28 | 0;
          d2 = c2[b3 >> 2] | 0;
          if (d2 >>> 0 < (c2[n3 + 32 >> 2] | 0) >>> 0) {
            c2[h2 >> 2] = g3;
            c2[h2 + 4 >> 2] = e3;
            c2[f2 >> 2] = c2[h2 >> 2];
            c2[f2 + 4 >> 2] = c2[h2 + 4 >> 2];
            Ko(d2, f2, a3);
            a3 = (c2[b3 >> 2] | 0) + 12 | 0;
            c2[b3 >> 2] = a3;
          } else {
            Lo(k2, i4, j2);
            a3 = c2[b3 >> 2] | 0;
          }
          l2 = m2;
          return ((a3 - (c2[k2 >> 2] | 0) | 0) / 12 | 0) + -1 | 0;
        }
        function Ko(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          var e3 = 0;
          e3 = c2[b3 + 4 >> 2] | 0;
          c2[a3 >> 2] = c2[b3 >> 2];
          c2[a3 + 4 >> 2] = e3;
          c2[a3 + 8 >> 2] = d2;
          return;
        }
        function Lo(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          var e3 = 0, f2 = 0, g3 = 0, h2 = 0, i4 = 0, j2 = 0, k2 = 0, m2 = 0, n3 = 0, o3 = 0;
          k2 = l2;
          l2 = l2 + 48 | 0;
          e3 = k2 + 32 | 0;
          h2 = k2 + 24 | 0;
          i4 = k2;
          j2 = a3 + 4 | 0;
          f2 = (((c2[j2 >> 2] | 0) - (c2[a3 >> 2] | 0) | 0) / 12 | 0) + 1 | 0;
          g3 = Mo(a3) | 0;
          if (g3 >>> 0 < f2 >>> 0)
            jC(a3);
          else {
            m2 = c2[a3 >> 2] | 0;
            o3 = ((c2[a3 + 8 >> 2] | 0) - m2 | 0) / 12 | 0;
            n3 = o3 << 1;
            No(i4, o3 >>> 0 < g3 >>> 1 >>> 0 ? n3 >>> 0 < f2 >>> 0 ? f2 : n3 : g3, ((c2[j2 >> 2] | 0) - m2 | 0) / 12 | 0, a3 + 8 | 0);
            j2 = i4 + 8 | 0;
            g3 = c2[j2 >> 2] | 0;
            f2 = c2[b3 + 4 >> 2] | 0;
            d2 = c2[d2 >> 2] | 0;
            c2[h2 >> 2] = c2[b3 >> 2];
            c2[h2 + 4 >> 2] = f2;
            c2[e3 >> 2] = c2[h2 >> 2];
            c2[e3 + 4 >> 2] = c2[h2 + 4 >> 2];
            Ko(g3, e3, d2);
            c2[j2 >> 2] = (c2[j2 >> 2] | 0) + 12;
            Oo(a3, i4);
            Po(i4);
            l2 = k2;
            return;
          }
        }
        function Mo(a3) {
          a3 = a3 | 0;
          return 357913941;
        }
        function No(a3, b3, d2, e3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          e3 = e3 | 0;
          var f2 = 0;
          c2[a3 + 12 >> 2] = 0;
          c2[a3 + 16 >> 2] = e3;
          do
            if (b3) {
              if (b3 >>> 0 > 357913941)
                Ta();
              else {
                f2 = qC(b3 * 12 | 0) | 0;
                break;
              }
            } else
              f2 = 0;
          while (0);
          c2[a3 >> 2] = f2;
          e3 = f2 + (d2 * 12 | 0) | 0;
          c2[a3 + 8 >> 2] = e3;
          c2[a3 + 4 >> 2] = e3;
          c2[a3 + 12 >> 2] = f2 + (b3 * 12 | 0);
          return;
        }
        function Oo(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          var d2 = 0, e3 = 0, f2 = 0, g3 = 0, h2 = 0;
          e3 = c2[a3 >> 2] | 0;
          h2 = a3 + 4 | 0;
          g3 = b3 + 4 | 0;
          f2 = (c2[h2 >> 2] | 0) - e3 | 0;
          d2 = (c2[g3 >> 2] | 0) + (((f2 | 0) / -12 | 0) * 12 | 0) | 0;
          c2[g3 >> 2] = d2;
          if ((f2 | 0) > 0) {
            BC(d2 | 0, e3 | 0, f2 | 0) | 0;
            e3 = g3;
            d2 = c2[g3 >> 2] | 0;
          } else
            e3 = g3;
          g3 = c2[a3 >> 2] | 0;
          c2[a3 >> 2] = d2;
          c2[e3 >> 2] = g3;
          g3 = b3 + 8 | 0;
          f2 = c2[h2 >> 2] | 0;
          c2[h2 >> 2] = c2[g3 >> 2];
          c2[g3 >> 2] = f2;
          g3 = a3 + 8 | 0;
          h2 = b3 + 12 | 0;
          a3 = c2[g3 >> 2] | 0;
          c2[g3 >> 2] = c2[h2 >> 2];
          c2[h2 >> 2] = a3;
          c2[b3 >> 2] = c2[e3 >> 2];
          return;
        }
        function Po(a3) {
          a3 = a3 | 0;
          var b3 = 0, d2 = 0, e3 = 0;
          b3 = c2[a3 + 4 >> 2] | 0;
          d2 = a3 + 8 | 0;
          e3 = c2[d2 >> 2] | 0;
          if ((e3 | 0) != (b3 | 0))
            c2[d2 >> 2] = e3 + (~(((e3 + -12 - b3 | 0) >>> 0) / 12 | 0) * 12 | 0);
          a3 = c2[a3 >> 2] | 0;
          if (a3 | 0)
            sC(a3);
          return;
        }
        function Qo(a3) {
          a3 = a3 | 0;
          To(a3);
          return;
        }
        function Ro(a3) {
          a3 = a3 | 0;
          So(a3 + 24 | 0);
          return;
        }
        function So(a3) {
          a3 = a3 | 0;
          var b3 = 0, d2 = 0, e3 = 0;
          d2 = c2[a3 >> 2] | 0;
          e3 = d2;
          if (d2 | 0) {
            a3 = a3 + 4 | 0;
            b3 = c2[a3 >> 2] | 0;
            if ((b3 | 0) != (d2 | 0))
              c2[a3 >> 2] = b3 + (~(((b3 + -12 - e3 | 0) >>> 0) / 12 | 0) * 12 | 0);
            sC(d2);
          }
          return;
        }
        function To(a3) {
          a3 = a3 | 0;
          var b3 = 0;
          b3 = vi() | 0;
          yi(a3, 2, 1, b3, Uo() | 0, 2);
          c2[a3 + 24 >> 2] = 0;
          c2[a3 + 28 >> 2] = 0;
          c2[a3 + 32 >> 2] = 0;
          return;
        }
        function Uo() {
          return 1300;
        }
        function Vo(a3, b3, d2, e3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          e3 = +e3;
          var f2 = 0, g3 = 0, h2 = 0, i4 = 0;
          f2 = l2;
          l2 = l2 + 16 | 0;
          g3 = f2 + 8 | 0;
          h2 = f2;
          i4 = Wo(a3) | 0;
          a3 = c2[i4 + 4 >> 2] | 0;
          c2[h2 >> 2] = c2[i4 >> 2];
          c2[h2 + 4 >> 2] = a3;
          c2[g3 >> 2] = c2[h2 >> 2];
          c2[g3 + 4 >> 2] = c2[h2 + 4 >> 2];
          Xo(b3, g3, d2, e3);
          l2 = f2;
          return;
        }
        function Wo(a3) {
          a3 = a3 | 0;
          return (c2[(Ho() | 0) + 24 >> 2] | 0) + (a3 * 12 | 0) | 0;
        }
        function Xo(a3, b3, d2, e3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          e3 = +e3;
          var f2 = 0, g3 = 0, h2 = 0, i4 = 0;
          i4 = l2;
          l2 = l2 + 16 | 0;
          g3 = i4 + 1 | 0;
          h2 = i4;
          f2 = c2[b3 >> 2] | 0;
          b3 = c2[b3 + 4 >> 2] | 0;
          a3 = a3 + (b3 >> 1) | 0;
          if (b3 & 1)
            f2 = c2[(c2[a3 >> 2] | 0) + f2 >> 2] | 0;
          tj(g3, d2);
          g3 = uj(g3, d2) | 0;
          rj(h2, e3);
          e3 = +sj(h2, e3);
          Gb[f2 & 15](a3, g3, e3);
          l2 = i4;
          return;
        }
        function Yo(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          var e3 = 0, f2 = 0, g3 = 0, h2 = 0, i4 = 0;
          e3 = l2;
          l2 = l2 + 16 | 0;
          f2 = e3 + 8 | 0;
          g3 = e3;
          i4 = c2[d2 >> 2] | 0;
          h2 = c2[d2 + 4 >> 2] | 0;
          d2 = ai(b3) | 0;
          c2[g3 >> 2] = i4;
          c2[g3 + 4 >> 2] = h2;
          c2[f2 >> 2] = c2[g3 >> 2];
          c2[f2 + 4 >> 2] = c2[g3 + 4 >> 2];
          Zo(a3, d2, f2, 0);
          l2 = e3;
          return;
        }
        function Zo(a3, b3, d2, e3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          e3 = e3 | 0;
          var f2 = 0, g3 = 0, h2 = 0, i4 = 0, j2 = 0, k2 = 0, m2 = 0;
          f2 = l2;
          l2 = l2 + 32 | 0;
          g3 = f2 + 16 | 0;
          m2 = f2 + 8 | 0;
          i4 = f2;
          k2 = c2[d2 >> 2] | 0;
          j2 = c2[d2 + 4 >> 2] | 0;
          h2 = c2[a3 >> 2] | 0;
          a3 = _o() | 0;
          c2[m2 >> 2] = k2;
          c2[m2 + 4 >> 2] = j2;
          c2[g3 >> 2] = c2[m2 >> 2];
          c2[g3 + 4 >> 2] = c2[m2 + 4 >> 2];
          d2 = $o(g3) | 0;
          c2[i4 >> 2] = k2;
          c2[i4 + 4 >> 2] = j2;
          c2[g3 >> 2] = c2[i4 >> 2];
          c2[g3 + 4 >> 2] = c2[i4 + 4 >> 2];
          fi(h2, b3, a3, d2, ap(g3, e3) | 0, e3);
          l2 = f2;
          return;
        }
        function _o() {
          var b3 = 0, d2 = 0;
          if (!(a2[7776] | 0)) {
            hp(9828);
            Ha(41, 9828, o2 | 0) | 0;
            d2 = 7776;
            c2[d2 >> 2] = 1;
            c2[d2 + 4 >> 2] = 0;
          }
          if (!(si(9828) | 0)) {
            b3 = 9828;
            d2 = b3 + 36 | 0;
            do {
              c2[b3 >> 2] = 0;
              b3 = b3 + 4 | 0;
            } while ((b3 | 0) < (d2 | 0));
            hp(9828);
          }
          return 9828;
        }
        function $o(a3) {
          a3 = a3 | 0;
          return 0;
        }
        function ap(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          var d2 = 0, e3 = 0, f2 = 0, g3 = 0, h2 = 0, i4 = 0, j2 = 0, k2 = 0, m2 = 0, n3 = 0;
          m2 = l2;
          l2 = l2 + 32 | 0;
          f2 = m2 + 24 | 0;
          h2 = m2 + 16 | 0;
          i4 = m2;
          j2 = m2 + 8 | 0;
          g3 = c2[a3 >> 2] | 0;
          e3 = c2[a3 + 4 >> 2] | 0;
          c2[i4 >> 2] = g3;
          c2[i4 + 4 >> 2] = e3;
          n3 = _o() | 0;
          k2 = n3 + 24 | 0;
          a3 = ji(b3, 4) | 0;
          c2[j2 >> 2] = a3;
          b3 = n3 + 28 | 0;
          d2 = c2[b3 >> 2] | 0;
          if (d2 >>> 0 < (c2[n3 + 32 >> 2] | 0) >>> 0) {
            c2[h2 >> 2] = g3;
            c2[h2 + 4 >> 2] = e3;
            c2[f2 >> 2] = c2[h2 >> 2];
            c2[f2 + 4 >> 2] = c2[h2 + 4 >> 2];
            bp(d2, f2, a3);
            a3 = (c2[b3 >> 2] | 0) + 12 | 0;
            c2[b3 >> 2] = a3;
          } else {
            cp(k2, i4, j2);
            a3 = c2[b3 >> 2] | 0;
          }
          l2 = m2;
          return ((a3 - (c2[k2 >> 2] | 0) | 0) / 12 | 0) + -1 | 0;
        }
        function bp(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          var e3 = 0;
          e3 = c2[b3 + 4 >> 2] | 0;
          c2[a3 >> 2] = c2[b3 >> 2];
          c2[a3 + 4 >> 2] = e3;
          c2[a3 + 8 >> 2] = d2;
          return;
        }
        function cp(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          var e3 = 0, f2 = 0, g3 = 0, h2 = 0, i4 = 0, j2 = 0, k2 = 0, m2 = 0, n3 = 0, o3 = 0;
          k2 = l2;
          l2 = l2 + 48 | 0;
          e3 = k2 + 32 | 0;
          h2 = k2 + 24 | 0;
          i4 = k2;
          j2 = a3 + 4 | 0;
          f2 = (((c2[j2 >> 2] | 0) - (c2[a3 >> 2] | 0) | 0) / 12 | 0) + 1 | 0;
          g3 = dp(a3) | 0;
          if (g3 >>> 0 < f2 >>> 0)
            jC(a3);
          else {
            m2 = c2[a3 >> 2] | 0;
            o3 = ((c2[a3 + 8 >> 2] | 0) - m2 | 0) / 12 | 0;
            n3 = o3 << 1;
            ep(i4, o3 >>> 0 < g3 >>> 1 >>> 0 ? n3 >>> 0 < f2 >>> 0 ? f2 : n3 : g3, ((c2[j2 >> 2] | 0) - m2 | 0) / 12 | 0, a3 + 8 | 0);
            j2 = i4 + 8 | 0;
            g3 = c2[j2 >> 2] | 0;
            f2 = c2[b3 + 4 >> 2] | 0;
            d2 = c2[d2 >> 2] | 0;
            c2[h2 >> 2] = c2[b3 >> 2];
            c2[h2 + 4 >> 2] = f2;
            c2[e3 >> 2] = c2[h2 >> 2];
            c2[e3 + 4 >> 2] = c2[h2 + 4 >> 2];
            bp(g3, e3, d2);
            c2[j2 >> 2] = (c2[j2 >> 2] | 0) + 12;
            fp(a3, i4);
            gp(i4);
            l2 = k2;
            return;
          }
        }
        function dp(a3) {
          a3 = a3 | 0;
          return 357913941;
        }
        function ep(a3, b3, d2, e3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          e3 = e3 | 0;
          var f2 = 0;
          c2[a3 + 12 >> 2] = 0;
          c2[a3 + 16 >> 2] = e3;
          do
            if (b3) {
              if (b3 >>> 0 > 357913941)
                Ta();
              else {
                f2 = qC(b3 * 12 | 0) | 0;
                break;
              }
            } else
              f2 = 0;
          while (0);
          c2[a3 >> 2] = f2;
          e3 = f2 + (d2 * 12 | 0) | 0;
          c2[a3 + 8 >> 2] = e3;
          c2[a3 + 4 >> 2] = e3;
          c2[a3 + 12 >> 2] = f2 + (b3 * 12 | 0);
          return;
        }
        function fp(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          var d2 = 0, e3 = 0, f2 = 0, g3 = 0, h2 = 0;
          e3 = c2[a3 >> 2] | 0;
          h2 = a3 + 4 | 0;
          g3 = b3 + 4 | 0;
          f2 = (c2[h2 >> 2] | 0) - e3 | 0;
          d2 = (c2[g3 >> 2] | 0) + (((f2 | 0) / -12 | 0) * 12 | 0) | 0;
          c2[g3 >> 2] = d2;
          if ((f2 | 0) > 0) {
            BC(d2 | 0, e3 | 0, f2 | 0) | 0;
            e3 = g3;
            d2 = c2[g3 >> 2] | 0;
          } else
            e3 = g3;
          g3 = c2[a3 >> 2] | 0;
          c2[a3 >> 2] = d2;
          c2[e3 >> 2] = g3;
          g3 = b3 + 8 | 0;
          f2 = c2[h2 >> 2] | 0;
          c2[h2 >> 2] = c2[g3 >> 2];
          c2[g3 >> 2] = f2;
          g3 = a3 + 8 | 0;
          h2 = b3 + 12 | 0;
          a3 = c2[g3 >> 2] | 0;
          c2[g3 >> 2] = c2[h2 >> 2];
          c2[h2 >> 2] = a3;
          c2[b3 >> 2] = c2[e3 >> 2];
          return;
        }
        function gp(a3) {
          a3 = a3 | 0;
          var b3 = 0, d2 = 0, e3 = 0;
          b3 = c2[a3 + 4 >> 2] | 0;
          d2 = a3 + 8 | 0;
          e3 = c2[d2 >> 2] | 0;
          if ((e3 | 0) != (b3 | 0))
            c2[d2 >> 2] = e3 + (~(((e3 + -12 - b3 | 0) >>> 0) / 12 | 0) * 12 | 0);
          a3 = c2[a3 >> 2] | 0;
          if (a3 | 0)
            sC(a3);
          return;
        }
        function hp(a3) {
          a3 = a3 | 0;
          kp(a3);
          return;
        }
        function ip(a3) {
          a3 = a3 | 0;
          jp(a3 + 24 | 0);
          return;
        }
        function jp(a3) {
          a3 = a3 | 0;
          var b3 = 0, d2 = 0, e3 = 0;
          d2 = c2[a3 >> 2] | 0;
          e3 = d2;
          if (d2 | 0) {
            a3 = a3 + 4 | 0;
            b3 = c2[a3 >> 2] | 0;
            if ((b3 | 0) != (d2 | 0))
              c2[a3 >> 2] = b3 + (~(((b3 + -12 - e3 | 0) >>> 0) / 12 | 0) * 12 | 0);
            sC(d2);
          }
          return;
        }
        function kp(a3) {
          a3 = a3 | 0;
          var b3 = 0;
          b3 = vi() | 0;
          yi(a3, 2, 7, b3, lp() | 0, 1);
          c2[a3 + 24 >> 2] = 0;
          c2[a3 + 28 >> 2] = 0;
          c2[a3 + 32 >> 2] = 0;
          return;
        }
        function lp() {
          return 1312;
        }
        function mp(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          var e3 = 0, f2 = 0, g3 = 0, h2 = 0;
          e3 = l2;
          l2 = l2 + 16 | 0;
          f2 = e3 + 8 | 0;
          g3 = e3;
          h2 = np(a3) | 0;
          a3 = c2[h2 + 4 >> 2] | 0;
          c2[g3 >> 2] = c2[h2 >> 2];
          c2[g3 + 4 >> 2] = a3;
          c2[f2 >> 2] = c2[g3 >> 2];
          c2[f2 + 4 >> 2] = c2[g3 + 4 >> 2];
          op(b3, f2, d2);
          l2 = e3;
          return;
        }
        function np(a3) {
          a3 = a3 | 0;
          return (c2[(_o() | 0) + 24 >> 2] | 0) + (a3 * 12 | 0) | 0;
        }
        function op(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          var e3 = 0, f2 = 0, g3 = 0;
          g3 = l2;
          l2 = l2 + 16 | 0;
          f2 = g3;
          e3 = c2[b3 >> 2] | 0;
          b3 = c2[b3 + 4 >> 2] | 0;
          a3 = a3 + (b3 >> 1) | 0;
          if (b3 & 1)
            e3 = c2[(c2[a3 >> 2] | 0) + e3 >> 2] | 0;
          tj(f2, d2);
          f2 = uj(f2, d2) | 0;
          ob[e3 & 31](a3, f2);
          l2 = g3;
          return;
        }
        function pp(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          var e3 = 0, f2 = 0, g3 = 0, h2 = 0, i4 = 0;
          e3 = l2;
          l2 = l2 + 16 | 0;
          f2 = e3 + 8 | 0;
          g3 = e3;
          i4 = c2[d2 >> 2] | 0;
          h2 = c2[d2 + 4 >> 2] | 0;
          d2 = ai(b3) | 0;
          c2[g3 >> 2] = i4;
          c2[g3 + 4 >> 2] = h2;
          c2[f2 >> 2] = c2[g3 >> 2];
          c2[f2 + 4 >> 2] = c2[g3 + 4 >> 2];
          qp(a3, d2, f2, 0);
          l2 = e3;
          return;
        }
        function qp(a3, b3, d2, e3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          e3 = e3 | 0;
          var f2 = 0, g3 = 0, h2 = 0, i4 = 0, j2 = 0, k2 = 0, m2 = 0;
          f2 = l2;
          l2 = l2 + 32 | 0;
          g3 = f2 + 16 | 0;
          m2 = f2 + 8 | 0;
          i4 = f2;
          k2 = c2[d2 >> 2] | 0;
          j2 = c2[d2 + 4 >> 2] | 0;
          h2 = c2[a3 >> 2] | 0;
          a3 = rp() | 0;
          c2[m2 >> 2] = k2;
          c2[m2 + 4 >> 2] = j2;
          c2[g3 >> 2] = c2[m2 >> 2];
          c2[g3 + 4 >> 2] = c2[m2 + 4 >> 2];
          d2 = sp(g3) | 0;
          c2[i4 >> 2] = k2;
          c2[i4 + 4 >> 2] = j2;
          c2[g3 >> 2] = c2[i4 >> 2];
          c2[g3 + 4 >> 2] = c2[i4 + 4 >> 2];
          fi(h2, b3, a3, d2, tp(g3, e3) | 0, e3);
          l2 = f2;
          return;
        }
        function rp() {
          var b3 = 0, d2 = 0;
          if (!(a2[7784] | 0)) {
            Ap(9864);
            Ha(42, 9864, o2 | 0) | 0;
            d2 = 7784;
            c2[d2 >> 2] = 1;
            c2[d2 + 4 >> 2] = 0;
          }
          if (!(si(9864) | 0)) {
            b3 = 9864;
            d2 = b3 + 36 | 0;
            do {
              c2[b3 >> 2] = 0;
              b3 = b3 + 4 | 0;
            } while ((b3 | 0) < (d2 | 0));
            Ap(9864);
          }
          return 9864;
        }
        function sp(a3) {
          a3 = a3 | 0;
          return 0;
        }
        function tp(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          var d2 = 0, e3 = 0, f2 = 0, g3 = 0, h2 = 0, i4 = 0, j2 = 0, k2 = 0, m2 = 0, n3 = 0;
          m2 = l2;
          l2 = l2 + 32 | 0;
          f2 = m2 + 24 | 0;
          h2 = m2 + 16 | 0;
          i4 = m2;
          j2 = m2 + 8 | 0;
          g3 = c2[a3 >> 2] | 0;
          e3 = c2[a3 + 4 >> 2] | 0;
          c2[i4 >> 2] = g3;
          c2[i4 + 4 >> 2] = e3;
          n3 = rp() | 0;
          k2 = n3 + 24 | 0;
          a3 = ji(b3, 4) | 0;
          c2[j2 >> 2] = a3;
          b3 = n3 + 28 | 0;
          d2 = c2[b3 >> 2] | 0;
          if (d2 >>> 0 < (c2[n3 + 32 >> 2] | 0) >>> 0) {
            c2[h2 >> 2] = g3;
            c2[h2 + 4 >> 2] = e3;
            c2[f2 >> 2] = c2[h2 >> 2];
            c2[f2 + 4 >> 2] = c2[h2 + 4 >> 2];
            up(d2, f2, a3);
            a3 = (c2[b3 >> 2] | 0) + 12 | 0;
            c2[b3 >> 2] = a3;
          } else {
            vp(k2, i4, j2);
            a3 = c2[b3 >> 2] | 0;
          }
          l2 = m2;
          return ((a3 - (c2[k2 >> 2] | 0) | 0) / 12 | 0) + -1 | 0;
        }
        function up(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          var e3 = 0;
          e3 = c2[b3 + 4 >> 2] | 0;
          c2[a3 >> 2] = c2[b3 >> 2];
          c2[a3 + 4 >> 2] = e3;
          c2[a3 + 8 >> 2] = d2;
          return;
        }
        function vp(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          var e3 = 0, f2 = 0, g3 = 0, h2 = 0, i4 = 0, j2 = 0, k2 = 0, m2 = 0, n3 = 0, o3 = 0;
          k2 = l2;
          l2 = l2 + 48 | 0;
          e3 = k2 + 32 | 0;
          h2 = k2 + 24 | 0;
          i4 = k2;
          j2 = a3 + 4 | 0;
          f2 = (((c2[j2 >> 2] | 0) - (c2[a3 >> 2] | 0) | 0) / 12 | 0) + 1 | 0;
          g3 = wp(a3) | 0;
          if (g3 >>> 0 < f2 >>> 0)
            jC(a3);
          else {
            m2 = c2[a3 >> 2] | 0;
            o3 = ((c2[a3 + 8 >> 2] | 0) - m2 | 0) / 12 | 0;
            n3 = o3 << 1;
            xp(i4, o3 >>> 0 < g3 >>> 1 >>> 0 ? n3 >>> 0 < f2 >>> 0 ? f2 : n3 : g3, ((c2[j2 >> 2] | 0) - m2 | 0) / 12 | 0, a3 + 8 | 0);
            j2 = i4 + 8 | 0;
            g3 = c2[j2 >> 2] | 0;
            f2 = c2[b3 + 4 >> 2] | 0;
            d2 = c2[d2 >> 2] | 0;
            c2[h2 >> 2] = c2[b3 >> 2];
            c2[h2 + 4 >> 2] = f2;
            c2[e3 >> 2] = c2[h2 >> 2];
            c2[e3 + 4 >> 2] = c2[h2 + 4 >> 2];
            up(g3, e3, d2);
            c2[j2 >> 2] = (c2[j2 >> 2] | 0) + 12;
            yp(a3, i4);
            zp(i4);
            l2 = k2;
            return;
          }
        }
        function wp(a3) {
          a3 = a3 | 0;
          return 357913941;
        }
        function xp(a3, b3, d2, e3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          e3 = e3 | 0;
          var f2 = 0;
          c2[a3 + 12 >> 2] = 0;
          c2[a3 + 16 >> 2] = e3;
          do
            if (b3) {
              if (b3 >>> 0 > 357913941)
                Ta();
              else {
                f2 = qC(b3 * 12 | 0) | 0;
                break;
              }
            } else
              f2 = 0;
          while (0);
          c2[a3 >> 2] = f2;
          e3 = f2 + (d2 * 12 | 0) | 0;
          c2[a3 + 8 >> 2] = e3;
          c2[a3 + 4 >> 2] = e3;
          c2[a3 + 12 >> 2] = f2 + (b3 * 12 | 0);
          return;
        }
        function yp(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          var d2 = 0, e3 = 0, f2 = 0, g3 = 0, h2 = 0;
          e3 = c2[a3 >> 2] | 0;
          h2 = a3 + 4 | 0;
          g3 = b3 + 4 | 0;
          f2 = (c2[h2 >> 2] | 0) - e3 | 0;
          d2 = (c2[g3 >> 2] | 0) + (((f2 | 0) / -12 | 0) * 12 | 0) | 0;
          c2[g3 >> 2] = d2;
          if ((f2 | 0) > 0) {
            BC(d2 | 0, e3 | 0, f2 | 0) | 0;
            e3 = g3;
            d2 = c2[g3 >> 2] | 0;
          } else
            e3 = g3;
          g3 = c2[a3 >> 2] | 0;
          c2[a3 >> 2] = d2;
          c2[e3 >> 2] = g3;
          g3 = b3 + 8 | 0;
          f2 = c2[h2 >> 2] | 0;
          c2[h2 >> 2] = c2[g3 >> 2];
          c2[g3 >> 2] = f2;
          g3 = a3 + 8 | 0;
          h2 = b3 + 12 | 0;
          a3 = c2[g3 >> 2] | 0;
          c2[g3 >> 2] = c2[h2 >> 2];
          c2[h2 >> 2] = a3;
          c2[b3 >> 2] = c2[e3 >> 2];
          return;
        }
        function zp(a3) {
          a3 = a3 | 0;
          var b3 = 0, d2 = 0, e3 = 0;
          b3 = c2[a3 + 4 >> 2] | 0;
          d2 = a3 + 8 | 0;
          e3 = c2[d2 >> 2] | 0;
          if ((e3 | 0) != (b3 | 0))
            c2[d2 >> 2] = e3 + (~(((e3 + -12 - b3 | 0) >>> 0) / 12 | 0) * 12 | 0);
          a3 = c2[a3 >> 2] | 0;
          if (a3 | 0)
            sC(a3);
          return;
        }
        function Ap(a3) {
          a3 = a3 | 0;
          Dp(a3);
          return;
        }
        function Bp(a3) {
          a3 = a3 | 0;
          Cp(a3 + 24 | 0);
          return;
        }
        function Cp(a3) {
          a3 = a3 | 0;
          var b3 = 0, d2 = 0, e3 = 0;
          d2 = c2[a3 >> 2] | 0;
          e3 = d2;
          if (d2 | 0) {
            a3 = a3 + 4 | 0;
            b3 = c2[a3 >> 2] | 0;
            if ((b3 | 0) != (d2 | 0))
              c2[a3 >> 2] = b3 + (~(((b3 + -12 - e3 | 0) >>> 0) / 12 | 0) * 12 | 0);
            sC(d2);
          }
          return;
        }
        function Dp(a3) {
          a3 = a3 | 0;
          var b3 = 0;
          b3 = vi() | 0;
          yi(a3, 2, 8, b3, Ep() | 0, 1);
          c2[a3 + 24 >> 2] = 0;
          c2[a3 + 28 >> 2] = 0;
          c2[a3 + 32 >> 2] = 0;
          return;
        }
        function Ep() {
          return 1320;
        }
        function Fp(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          var e3 = 0, f2 = 0, g3 = 0, h2 = 0;
          e3 = l2;
          l2 = l2 + 16 | 0;
          f2 = e3 + 8 | 0;
          g3 = e3;
          h2 = Gp(a3) | 0;
          a3 = c2[h2 + 4 >> 2] | 0;
          c2[g3 >> 2] = c2[h2 >> 2];
          c2[g3 + 4 >> 2] = a3;
          c2[f2 >> 2] = c2[g3 >> 2];
          c2[f2 + 4 >> 2] = c2[g3 + 4 >> 2];
          Hp(b3, f2, d2);
          l2 = e3;
          return;
        }
        function Gp(a3) {
          a3 = a3 | 0;
          return (c2[(rp() | 0) + 24 >> 2] | 0) + (a3 * 12 | 0) | 0;
        }
        function Hp(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          var e3 = 0, f2 = 0, g3 = 0;
          g3 = l2;
          l2 = l2 + 16 | 0;
          f2 = g3;
          e3 = c2[b3 >> 2] | 0;
          b3 = c2[b3 + 4 >> 2] | 0;
          a3 = a3 + (b3 >> 1) | 0;
          if (b3 & 1)
            e3 = c2[(c2[a3 >> 2] | 0) + e3 >> 2] | 0;
          Ip(f2, d2);
          f2 = Jp(f2, d2) | 0;
          ob[e3 & 31](a3, f2);
          l2 = g3;
          return;
        }
        function Ip(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          return;
        }
        function Jp(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          return Kp(b3) | 0;
        }
        function Kp(a3) {
          a3 = a3 | 0;
          return a3 | 0;
        }
        function Lp(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          var e3 = 0, f2 = 0, g3 = 0, h2 = 0, i4 = 0;
          e3 = l2;
          l2 = l2 + 16 | 0;
          f2 = e3 + 8 | 0;
          g3 = e3;
          i4 = c2[d2 >> 2] | 0;
          h2 = c2[d2 + 4 >> 2] | 0;
          d2 = ai(b3) | 0;
          c2[g3 >> 2] = i4;
          c2[g3 + 4 >> 2] = h2;
          c2[f2 >> 2] = c2[g3 >> 2];
          c2[f2 + 4 >> 2] = c2[g3 + 4 >> 2];
          Mp(a3, d2, f2, 0);
          l2 = e3;
          return;
        }
        function Mp(a3, b3, d2, e3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          e3 = e3 | 0;
          var f2 = 0, g3 = 0, h2 = 0, i4 = 0, j2 = 0, k2 = 0, m2 = 0;
          f2 = l2;
          l2 = l2 + 32 | 0;
          g3 = f2 + 16 | 0;
          m2 = f2 + 8 | 0;
          i4 = f2;
          k2 = c2[d2 >> 2] | 0;
          j2 = c2[d2 + 4 >> 2] | 0;
          h2 = c2[a3 >> 2] | 0;
          a3 = Np() | 0;
          c2[m2 >> 2] = k2;
          c2[m2 + 4 >> 2] = j2;
          c2[g3 >> 2] = c2[m2 >> 2];
          c2[g3 + 4 >> 2] = c2[m2 + 4 >> 2];
          d2 = Op(g3) | 0;
          c2[i4 >> 2] = k2;
          c2[i4 + 4 >> 2] = j2;
          c2[g3 >> 2] = c2[i4 >> 2];
          c2[g3 + 4 >> 2] = c2[i4 + 4 >> 2];
          fi(h2, b3, a3, d2, Pp(g3, e3) | 0, e3);
          l2 = f2;
          return;
        }
        function Np() {
          var b3 = 0, d2 = 0;
          if (!(a2[7792] | 0)) {
            Wp(9900);
            Ha(43, 9900, o2 | 0) | 0;
            d2 = 7792;
            c2[d2 >> 2] = 1;
            c2[d2 + 4 >> 2] = 0;
          }
          if (!(si(9900) | 0)) {
            b3 = 9900;
            d2 = b3 + 36 | 0;
            do {
              c2[b3 >> 2] = 0;
              b3 = b3 + 4 | 0;
            } while ((b3 | 0) < (d2 | 0));
            Wp(9900);
          }
          return 9900;
        }
        function Op(a3) {
          a3 = a3 | 0;
          return 0;
        }
        function Pp(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          var d2 = 0, e3 = 0, f2 = 0, g3 = 0, h2 = 0, i4 = 0, j2 = 0, k2 = 0, m2 = 0, n3 = 0;
          m2 = l2;
          l2 = l2 + 32 | 0;
          f2 = m2 + 24 | 0;
          h2 = m2 + 16 | 0;
          i4 = m2;
          j2 = m2 + 8 | 0;
          g3 = c2[a3 >> 2] | 0;
          e3 = c2[a3 + 4 >> 2] | 0;
          c2[i4 >> 2] = g3;
          c2[i4 + 4 >> 2] = e3;
          n3 = Np() | 0;
          k2 = n3 + 24 | 0;
          a3 = ji(b3, 4) | 0;
          c2[j2 >> 2] = a3;
          b3 = n3 + 28 | 0;
          d2 = c2[b3 >> 2] | 0;
          if (d2 >>> 0 < (c2[n3 + 32 >> 2] | 0) >>> 0) {
            c2[h2 >> 2] = g3;
            c2[h2 + 4 >> 2] = e3;
            c2[f2 >> 2] = c2[h2 >> 2];
            c2[f2 + 4 >> 2] = c2[h2 + 4 >> 2];
            Qp(d2, f2, a3);
            a3 = (c2[b3 >> 2] | 0) + 12 | 0;
            c2[b3 >> 2] = a3;
          } else {
            Rp(k2, i4, j2);
            a3 = c2[b3 >> 2] | 0;
          }
          l2 = m2;
          return ((a3 - (c2[k2 >> 2] | 0) | 0) / 12 | 0) + -1 | 0;
        }
        function Qp(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          var e3 = 0;
          e3 = c2[b3 + 4 >> 2] | 0;
          c2[a3 >> 2] = c2[b3 >> 2];
          c2[a3 + 4 >> 2] = e3;
          c2[a3 + 8 >> 2] = d2;
          return;
        }
        function Rp(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          var e3 = 0, f2 = 0, g3 = 0, h2 = 0, i4 = 0, j2 = 0, k2 = 0, m2 = 0, n3 = 0, o3 = 0;
          k2 = l2;
          l2 = l2 + 48 | 0;
          e3 = k2 + 32 | 0;
          h2 = k2 + 24 | 0;
          i4 = k2;
          j2 = a3 + 4 | 0;
          f2 = (((c2[j2 >> 2] | 0) - (c2[a3 >> 2] | 0) | 0) / 12 | 0) + 1 | 0;
          g3 = Sp(a3) | 0;
          if (g3 >>> 0 < f2 >>> 0)
            jC(a3);
          else {
            m2 = c2[a3 >> 2] | 0;
            o3 = ((c2[a3 + 8 >> 2] | 0) - m2 | 0) / 12 | 0;
            n3 = o3 << 1;
            Tp(i4, o3 >>> 0 < g3 >>> 1 >>> 0 ? n3 >>> 0 < f2 >>> 0 ? f2 : n3 : g3, ((c2[j2 >> 2] | 0) - m2 | 0) / 12 | 0, a3 + 8 | 0);
            j2 = i4 + 8 | 0;
            g3 = c2[j2 >> 2] | 0;
            f2 = c2[b3 + 4 >> 2] | 0;
            d2 = c2[d2 >> 2] | 0;
            c2[h2 >> 2] = c2[b3 >> 2];
            c2[h2 + 4 >> 2] = f2;
            c2[e3 >> 2] = c2[h2 >> 2];
            c2[e3 + 4 >> 2] = c2[h2 + 4 >> 2];
            Qp(g3, e3, d2);
            c2[j2 >> 2] = (c2[j2 >> 2] | 0) + 12;
            Up(a3, i4);
            Vp(i4);
            l2 = k2;
            return;
          }
        }
        function Sp(a3) {
          a3 = a3 | 0;
          return 357913941;
        }
        function Tp(a3, b3, d2, e3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          e3 = e3 | 0;
          var f2 = 0;
          c2[a3 + 12 >> 2] = 0;
          c2[a3 + 16 >> 2] = e3;
          do
            if (b3) {
              if (b3 >>> 0 > 357913941)
                Ta();
              else {
                f2 = qC(b3 * 12 | 0) | 0;
                break;
              }
            } else
              f2 = 0;
          while (0);
          c2[a3 >> 2] = f2;
          e3 = f2 + (d2 * 12 | 0) | 0;
          c2[a3 + 8 >> 2] = e3;
          c2[a3 + 4 >> 2] = e3;
          c2[a3 + 12 >> 2] = f2 + (b3 * 12 | 0);
          return;
        }
        function Up(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          var d2 = 0, e3 = 0, f2 = 0, g3 = 0, h2 = 0;
          e3 = c2[a3 >> 2] | 0;
          h2 = a3 + 4 | 0;
          g3 = b3 + 4 | 0;
          f2 = (c2[h2 >> 2] | 0) - e3 | 0;
          d2 = (c2[g3 >> 2] | 0) + (((f2 | 0) / -12 | 0) * 12 | 0) | 0;
          c2[g3 >> 2] = d2;
          if ((f2 | 0) > 0) {
            BC(d2 | 0, e3 | 0, f2 | 0) | 0;
            e3 = g3;
            d2 = c2[g3 >> 2] | 0;
          } else
            e3 = g3;
          g3 = c2[a3 >> 2] | 0;
          c2[a3 >> 2] = d2;
          c2[e3 >> 2] = g3;
          g3 = b3 + 8 | 0;
          f2 = c2[h2 >> 2] | 0;
          c2[h2 >> 2] = c2[g3 >> 2];
          c2[g3 >> 2] = f2;
          g3 = a3 + 8 | 0;
          h2 = b3 + 12 | 0;
          a3 = c2[g3 >> 2] | 0;
          c2[g3 >> 2] = c2[h2 >> 2];
          c2[h2 >> 2] = a3;
          c2[b3 >> 2] = c2[e3 >> 2];
          return;
        }
        function Vp(a3) {
          a3 = a3 | 0;
          var b3 = 0, d2 = 0, e3 = 0;
          b3 = c2[a3 + 4 >> 2] | 0;
          d2 = a3 + 8 | 0;
          e3 = c2[d2 >> 2] | 0;
          if ((e3 | 0) != (b3 | 0))
            c2[d2 >> 2] = e3 + (~(((e3 + -12 - b3 | 0) >>> 0) / 12 | 0) * 12 | 0);
          a3 = c2[a3 >> 2] | 0;
          if (a3 | 0)
            sC(a3);
          return;
        }
        function Wp(a3) {
          a3 = a3 | 0;
          Zp(a3);
          return;
        }
        function Xp(a3) {
          a3 = a3 | 0;
          Yp(a3 + 24 | 0);
          return;
        }
        function Yp(a3) {
          a3 = a3 | 0;
          var b3 = 0, d2 = 0, e3 = 0;
          d2 = c2[a3 >> 2] | 0;
          e3 = d2;
          if (d2 | 0) {
            a3 = a3 + 4 | 0;
            b3 = c2[a3 >> 2] | 0;
            if ((b3 | 0) != (d2 | 0))
              c2[a3 >> 2] = b3 + (~(((b3 + -12 - e3 | 0) >>> 0) / 12 | 0) * 12 | 0);
            sC(d2);
          }
          return;
        }
        function Zp(a3) {
          a3 = a3 | 0;
          var b3 = 0;
          b3 = vi() | 0;
          yi(a3, 2, 22, b3, _p() | 0, 0);
          c2[a3 + 24 >> 2] = 0;
          c2[a3 + 28 >> 2] = 0;
          c2[a3 + 32 >> 2] = 0;
          return;
        }
        function _p() {
          return 1344;
        }
        function $p(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          var d2 = 0, e3 = 0, f2 = 0, g3 = 0;
          d2 = l2;
          l2 = l2 + 16 | 0;
          e3 = d2 + 8 | 0;
          f2 = d2;
          g3 = aq(a3) | 0;
          a3 = c2[g3 + 4 >> 2] | 0;
          c2[f2 >> 2] = c2[g3 >> 2];
          c2[f2 + 4 >> 2] = a3;
          c2[e3 >> 2] = c2[f2 >> 2];
          c2[e3 + 4 >> 2] = c2[f2 + 4 >> 2];
          bq(b3, e3);
          l2 = d2;
          return;
        }
        function aq(a3) {
          a3 = a3 | 0;
          return (c2[(Np() | 0) + 24 >> 2] | 0) + (a3 * 12 | 0) | 0;
        }
        function bq(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          var d2 = 0;
          d2 = c2[b3 >> 2] | 0;
          b3 = c2[b3 + 4 >> 2] | 0;
          a3 = a3 + (b3 >> 1) | 0;
          if (b3 & 1)
            d2 = c2[(c2[a3 >> 2] | 0) + d2 >> 2] | 0;
          nb[d2 & 127](a3);
          return;
        }
        function cq(a3, b3, d2, e3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          e3 = e3 | 0;
          var f2 = 0, g3 = 0;
          g3 = c2[a3 >> 2] | 0;
          f2 = dq() | 0;
          a3 = eq(d2) | 0;
          fi(g3, b3, f2, a3, fq(d2, e3) | 0, e3);
          return;
        }
        function dq() {
          var b3 = 0, d2 = 0;
          if (!(a2[7800] | 0)) {
            mq(9936);
            Ha(44, 9936, o2 | 0) | 0;
            d2 = 7800;
            c2[d2 >> 2] = 1;
            c2[d2 + 4 >> 2] = 0;
          }
          if (!(si(9936) | 0)) {
            b3 = 9936;
            d2 = b3 + 36 | 0;
            do {
              c2[b3 >> 2] = 0;
              b3 = b3 + 4 | 0;
            } while ((b3 | 0) < (d2 | 0));
            mq(9936);
          }
          return 9936;
        }
        function eq(a3) {
          a3 = a3 | 0;
          return a3 | 0;
        }
        function fq(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          var d2 = 0, e3 = 0, f2 = 0, g3 = 0, h2 = 0, i4 = 0, j2 = 0;
          i4 = l2;
          l2 = l2 + 16 | 0;
          f2 = i4;
          g3 = i4 + 4 | 0;
          c2[f2 >> 2] = a3;
          j2 = dq() | 0;
          h2 = j2 + 24 | 0;
          b3 = ji(b3, 4) | 0;
          c2[g3 >> 2] = b3;
          d2 = j2 + 28 | 0;
          e3 = c2[d2 >> 2] | 0;
          if (e3 >>> 0 < (c2[j2 + 32 >> 2] | 0) >>> 0) {
            gq(e3, a3, b3);
            b3 = (c2[d2 >> 2] | 0) + 8 | 0;
            c2[d2 >> 2] = b3;
          } else {
            hq(h2, f2, g3);
            b3 = c2[d2 >> 2] | 0;
          }
          l2 = i4;
          return (b3 - (c2[h2 >> 2] | 0) >> 3) + -1 | 0;
        }
        function gq(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          c2[a3 >> 2] = b3;
          c2[a3 + 4 >> 2] = d2;
          return;
        }
        function hq(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          var e3 = 0, f2 = 0, g3 = 0, h2 = 0, i4 = 0, j2 = 0, k2 = 0, m2 = 0;
          i4 = l2;
          l2 = l2 + 32 | 0;
          f2 = i4;
          g3 = a3 + 4 | 0;
          h2 = ((c2[g3 >> 2] | 0) - (c2[a3 >> 2] | 0) >> 3) + 1 | 0;
          e3 = iq(a3) | 0;
          if (e3 >>> 0 < h2 >>> 0)
            jC(a3);
          else {
            j2 = c2[a3 >> 2] | 0;
            m2 = (c2[a3 + 8 >> 2] | 0) - j2 | 0;
            k2 = m2 >> 2;
            jq(f2, m2 >> 3 >>> 0 < e3 >>> 1 >>> 0 ? k2 >>> 0 < h2 >>> 0 ? h2 : k2 : e3, (c2[g3 >> 2] | 0) - j2 >> 3, a3 + 8 | 0);
            h2 = f2 + 8 | 0;
            gq(c2[h2 >> 2] | 0, c2[b3 >> 2] | 0, c2[d2 >> 2] | 0);
            c2[h2 >> 2] = (c2[h2 >> 2] | 0) + 8;
            kq(a3, f2);
            lq(f2);
            l2 = i4;
            return;
          }
        }
        function iq(a3) {
          a3 = a3 | 0;
          return 536870911;
        }
        function jq(a3, b3, d2, e3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          e3 = e3 | 0;
          var f2 = 0;
          c2[a3 + 12 >> 2] = 0;
          c2[a3 + 16 >> 2] = e3;
          do
            if (b3) {
              if (b3 >>> 0 > 536870911)
                Ta();
              else {
                f2 = qC(b3 << 3) | 0;
                break;
              }
            } else
              f2 = 0;
          while (0);
          c2[a3 >> 2] = f2;
          e3 = f2 + (d2 << 3) | 0;
          c2[a3 + 8 >> 2] = e3;
          c2[a3 + 4 >> 2] = e3;
          c2[a3 + 12 >> 2] = f2 + (b3 << 3);
          return;
        }
        function kq(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          var d2 = 0, e3 = 0, f2 = 0, g3 = 0, h2 = 0;
          e3 = c2[a3 >> 2] | 0;
          h2 = a3 + 4 | 0;
          g3 = b3 + 4 | 0;
          f2 = (c2[h2 >> 2] | 0) - e3 | 0;
          d2 = (c2[g3 >> 2] | 0) + (0 - (f2 >> 3) << 3) | 0;
          c2[g3 >> 2] = d2;
          if ((f2 | 0) > 0) {
            BC(d2 | 0, e3 | 0, f2 | 0) | 0;
            e3 = g3;
            d2 = c2[g3 >> 2] | 0;
          } else
            e3 = g3;
          g3 = c2[a3 >> 2] | 0;
          c2[a3 >> 2] = d2;
          c2[e3 >> 2] = g3;
          g3 = b3 + 8 | 0;
          f2 = c2[h2 >> 2] | 0;
          c2[h2 >> 2] = c2[g3 >> 2];
          c2[g3 >> 2] = f2;
          g3 = a3 + 8 | 0;
          h2 = b3 + 12 | 0;
          a3 = c2[g3 >> 2] | 0;
          c2[g3 >> 2] = c2[h2 >> 2];
          c2[h2 >> 2] = a3;
          c2[b3 >> 2] = c2[e3 >> 2];
          return;
        }
        function lq(a3) {
          a3 = a3 | 0;
          var b3 = 0, d2 = 0, e3 = 0;
          b3 = c2[a3 + 4 >> 2] | 0;
          d2 = a3 + 8 | 0;
          e3 = c2[d2 >> 2] | 0;
          if ((e3 | 0) != (b3 | 0))
            c2[d2 >> 2] = e3 + (~((e3 + -8 - b3 | 0) >>> 3) << 3);
          a3 = c2[a3 >> 2] | 0;
          if (a3 | 0)
            sC(a3);
          return;
        }
        function mq(a3) {
          a3 = a3 | 0;
          pq(a3);
          return;
        }
        function nq(a3) {
          a3 = a3 | 0;
          oq(a3 + 24 | 0);
          return;
        }
        function oq(a3) {
          a3 = a3 | 0;
          var b3 = 0, d2 = 0, e3 = 0;
          d2 = c2[a3 >> 2] | 0;
          e3 = d2;
          if (d2 | 0) {
            a3 = a3 + 4 | 0;
            b3 = c2[a3 >> 2] | 0;
            if ((b3 | 0) != (d2 | 0))
              c2[a3 >> 2] = b3 + (~((b3 + -8 - e3 | 0) >>> 3) << 3);
            sC(d2);
          }
          return;
        }
        function pq(a3) {
          a3 = a3 | 0;
          var b3 = 0;
          b3 = vi() | 0;
          yi(a3, 1, 23, b3, Kl() | 0, 1);
          c2[a3 + 24 >> 2] = 0;
          c2[a3 + 28 >> 2] = 0;
          c2[a3 + 32 >> 2] = 0;
          return;
        }
        function qq(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          sq(c2[(rq(a3) | 0) >> 2] | 0, b3);
          return;
        }
        function rq(a3) {
          a3 = a3 | 0;
          return (c2[(dq() | 0) + 24 >> 2] | 0) + (a3 << 3) | 0;
        }
        function sq(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          var c3 = 0, d2 = 0;
          c3 = l2;
          l2 = l2 + 16 | 0;
          d2 = c3;
          Ol(d2, b3);
          b3 = Pl(d2, b3) | 0;
          nb[a3 & 127](b3);
          l2 = c3;
          return;
        }
        function tq(a3, b3, d2, e3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          e3 = e3 | 0;
          var f2 = 0, g3 = 0;
          g3 = c2[a3 >> 2] | 0;
          f2 = uq() | 0;
          a3 = vq(d2) | 0;
          fi(g3, b3, f2, a3, wq(d2, e3) | 0, e3);
          return;
        }
        function uq() {
          var b3 = 0, d2 = 0;
          if (!(a2[7808] | 0)) {
            Dq(9972);
            Ha(45, 9972, o2 | 0) | 0;
            d2 = 7808;
            c2[d2 >> 2] = 1;
            c2[d2 + 4 >> 2] = 0;
          }
          if (!(si(9972) | 0)) {
            b3 = 9972;
            d2 = b3 + 36 | 0;
            do {
              c2[b3 >> 2] = 0;
              b3 = b3 + 4 | 0;
            } while ((b3 | 0) < (d2 | 0));
            Dq(9972);
          }
          return 9972;
        }
        function vq(a3) {
          a3 = a3 | 0;
          return a3 | 0;
        }
        function wq(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          var d2 = 0, e3 = 0, f2 = 0, g3 = 0, h2 = 0, i4 = 0, j2 = 0;
          i4 = l2;
          l2 = l2 + 16 | 0;
          f2 = i4;
          g3 = i4 + 4 | 0;
          c2[f2 >> 2] = a3;
          j2 = uq() | 0;
          h2 = j2 + 24 | 0;
          b3 = ji(b3, 4) | 0;
          c2[g3 >> 2] = b3;
          d2 = j2 + 28 | 0;
          e3 = c2[d2 >> 2] | 0;
          if (e3 >>> 0 < (c2[j2 + 32 >> 2] | 0) >>> 0) {
            xq(e3, a3, b3);
            b3 = (c2[d2 >> 2] | 0) + 8 | 0;
            c2[d2 >> 2] = b3;
          } else {
            yq(h2, f2, g3);
            b3 = c2[d2 >> 2] | 0;
          }
          l2 = i4;
          return (b3 - (c2[h2 >> 2] | 0) >> 3) + -1 | 0;
        }
        function xq(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          c2[a3 >> 2] = b3;
          c2[a3 + 4 >> 2] = d2;
          return;
        }
        function yq(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          var e3 = 0, f2 = 0, g3 = 0, h2 = 0, i4 = 0, j2 = 0, k2 = 0, m2 = 0;
          i4 = l2;
          l2 = l2 + 32 | 0;
          f2 = i4;
          g3 = a3 + 4 | 0;
          h2 = ((c2[g3 >> 2] | 0) - (c2[a3 >> 2] | 0) >> 3) + 1 | 0;
          e3 = zq(a3) | 0;
          if (e3 >>> 0 < h2 >>> 0)
            jC(a3);
          else {
            j2 = c2[a3 >> 2] | 0;
            m2 = (c2[a3 + 8 >> 2] | 0) - j2 | 0;
            k2 = m2 >> 2;
            Aq(f2, m2 >> 3 >>> 0 < e3 >>> 1 >>> 0 ? k2 >>> 0 < h2 >>> 0 ? h2 : k2 : e3, (c2[g3 >> 2] | 0) - j2 >> 3, a3 + 8 | 0);
            h2 = f2 + 8 | 0;
            xq(c2[h2 >> 2] | 0, c2[b3 >> 2] | 0, c2[d2 >> 2] | 0);
            c2[h2 >> 2] = (c2[h2 >> 2] | 0) + 8;
            Bq(a3, f2);
            Cq(f2);
            l2 = i4;
            return;
          }
        }
        function zq(a3) {
          a3 = a3 | 0;
          return 536870911;
        }
        function Aq(a3, b3, d2, e3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          e3 = e3 | 0;
          var f2 = 0;
          c2[a3 + 12 >> 2] = 0;
          c2[a3 + 16 >> 2] = e3;
          do
            if (b3) {
              if (b3 >>> 0 > 536870911)
                Ta();
              else {
                f2 = qC(b3 << 3) | 0;
                break;
              }
            } else
              f2 = 0;
          while (0);
          c2[a3 >> 2] = f2;
          e3 = f2 + (d2 << 3) | 0;
          c2[a3 + 8 >> 2] = e3;
          c2[a3 + 4 >> 2] = e3;
          c2[a3 + 12 >> 2] = f2 + (b3 << 3);
          return;
        }
        function Bq(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          var d2 = 0, e3 = 0, f2 = 0, g3 = 0, h2 = 0;
          e3 = c2[a3 >> 2] | 0;
          h2 = a3 + 4 | 0;
          g3 = b3 + 4 | 0;
          f2 = (c2[h2 >> 2] | 0) - e3 | 0;
          d2 = (c2[g3 >> 2] | 0) + (0 - (f2 >> 3) << 3) | 0;
          c2[g3 >> 2] = d2;
          if ((f2 | 0) > 0) {
            BC(d2 | 0, e3 | 0, f2 | 0) | 0;
            e3 = g3;
            d2 = c2[g3 >> 2] | 0;
          } else
            e3 = g3;
          g3 = c2[a3 >> 2] | 0;
          c2[a3 >> 2] = d2;
          c2[e3 >> 2] = g3;
          g3 = b3 + 8 | 0;
          f2 = c2[h2 >> 2] | 0;
          c2[h2 >> 2] = c2[g3 >> 2];
          c2[g3 >> 2] = f2;
          g3 = a3 + 8 | 0;
          h2 = b3 + 12 | 0;
          a3 = c2[g3 >> 2] | 0;
          c2[g3 >> 2] = c2[h2 >> 2];
          c2[h2 >> 2] = a3;
          c2[b3 >> 2] = c2[e3 >> 2];
          return;
        }
        function Cq(a3) {
          a3 = a3 | 0;
          var b3 = 0, d2 = 0, e3 = 0;
          b3 = c2[a3 + 4 >> 2] | 0;
          d2 = a3 + 8 | 0;
          e3 = c2[d2 >> 2] | 0;
          if ((e3 | 0) != (b3 | 0))
            c2[d2 >> 2] = e3 + (~((e3 + -8 - b3 | 0) >>> 3) << 3);
          a3 = c2[a3 >> 2] | 0;
          if (a3 | 0)
            sC(a3);
          return;
        }
        function Dq(a3) {
          a3 = a3 | 0;
          Gq(a3);
          return;
        }
        function Eq(a3) {
          a3 = a3 | 0;
          Fq(a3 + 24 | 0);
          return;
        }
        function Fq(a3) {
          a3 = a3 | 0;
          var b3 = 0, d2 = 0, e3 = 0;
          d2 = c2[a3 >> 2] | 0;
          e3 = d2;
          if (d2 | 0) {
            a3 = a3 + 4 | 0;
            b3 = c2[a3 >> 2] | 0;
            if ((b3 | 0) != (d2 | 0))
              c2[a3 >> 2] = b3 + (~((b3 + -8 - e3 | 0) >>> 3) << 3);
            sC(d2);
          }
          return;
        }
        function Gq(a3) {
          a3 = a3 | 0;
          var b3 = 0;
          b3 = vi() | 0;
          yi(a3, 1, 9, b3, Hq() | 0, 1);
          c2[a3 + 24 >> 2] = 0;
          c2[a3 + 28 >> 2] = 0;
          c2[a3 + 32 >> 2] = 0;
          return;
        }
        function Hq() {
          return 1348;
        }
        function Iq(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          return Kq(c2[(Jq(a3) | 0) >> 2] | 0, b3) | 0;
        }
        function Jq(a3) {
          a3 = a3 | 0;
          return (c2[(uq() | 0) + 24 >> 2] | 0) + (a3 << 3) | 0;
        }
        function Kq(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          var c3 = 0, d2 = 0;
          c3 = l2;
          l2 = l2 + 16 | 0;
          d2 = c3;
          Lq(d2, b3);
          b3 = Mq(d2, b3) | 0;
          b3 = Ik(pb[a3 & 31](b3) | 0) | 0;
          l2 = c3;
          return b3 | 0;
        }
        function Lq(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          return;
        }
        function Mq(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          return Nq(b3) | 0;
        }
        function Nq(a3) {
          a3 = a3 | 0;
          return a3 | 0;
        }
        function Oq(a3, b3, d2, e3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          e3 = e3 | 0;
          var f2 = 0, g3 = 0;
          g3 = c2[a3 >> 2] | 0;
          f2 = Pq() | 0;
          a3 = Qq(d2) | 0;
          fi(g3, b3, f2, a3, Rq(d2, e3) | 0, e3);
          return;
        }
        function Pq() {
          var b3 = 0, d2 = 0;
          if (!(a2[7816] | 0)) {
            Yq(10008);
            Ha(46, 10008, o2 | 0) | 0;
            d2 = 7816;
            c2[d2 >> 2] = 1;
            c2[d2 + 4 >> 2] = 0;
          }
          if (!(si(10008) | 0)) {
            b3 = 10008;
            d2 = b3 + 36 | 0;
            do {
              c2[b3 >> 2] = 0;
              b3 = b3 + 4 | 0;
            } while ((b3 | 0) < (d2 | 0));
            Yq(10008);
          }
          return 10008;
        }
        function Qq(a3) {
          a3 = a3 | 0;
          return a3 | 0;
        }
        function Rq(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          var d2 = 0, e3 = 0, f2 = 0, g3 = 0, h2 = 0, i4 = 0, j2 = 0;
          i4 = l2;
          l2 = l2 + 16 | 0;
          f2 = i4;
          g3 = i4 + 4 | 0;
          c2[f2 >> 2] = a3;
          j2 = Pq() | 0;
          h2 = j2 + 24 | 0;
          b3 = ji(b3, 4) | 0;
          c2[g3 >> 2] = b3;
          d2 = j2 + 28 | 0;
          e3 = c2[d2 >> 2] | 0;
          if (e3 >>> 0 < (c2[j2 + 32 >> 2] | 0) >>> 0) {
            Sq(e3, a3, b3);
            b3 = (c2[d2 >> 2] | 0) + 8 | 0;
            c2[d2 >> 2] = b3;
          } else {
            Tq(h2, f2, g3);
            b3 = c2[d2 >> 2] | 0;
          }
          l2 = i4;
          return (b3 - (c2[h2 >> 2] | 0) >> 3) + -1 | 0;
        }
        function Sq(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          c2[a3 >> 2] = b3;
          c2[a3 + 4 >> 2] = d2;
          return;
        }
        function Tq(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          var e3 = 0, f2 = 0, g3 = 0, h2 = 0, i4 = 0, j2 = 0, k2 = 0, m2 = 0;
          i4 = l2;
          l2 = l2 + 32 | 0;
          f2 = i4;
          g3 = a3 + 4 | 0;
          h2 = ((c2[g3 >> 2] | 0) - (c2[a3 >> 2] | 0) >> 3) + 1 | 0;
          e3 = Uq(a3) | 0;
          if (e3 >>> 0 < h2 >>> 0)
            jC(a3);
          else {
            j2 = c2[a3 >> 2] | 0;
            m2 = (c2[a3 + 8 >> 2] | 0) - j2 | 0;
            k2 = m2 >> 2;
            Vq(f2, m2 >> 3 >>> 0 < e3 >>> 1 >>> 0 ? k2 >>> 0 < h2 >>> 0 ? h2 : k2 : e3, (c2[g3 >> 2] | 0) - j2 >> 3, a3 + 8 | 0);
            h2 = f2 + 8 | 0;
            Sq(c2[h2 >> 2] | 0, c2[b3 >> 2] | 0, c2[d2 >> 2] | 0);
            c2[h2 >> 2] = (c2[h2 >> 2] | 0) + 8;
            Wq(a3, f2);
            Xq(f2);
            l2 = i4;
            return;
          }
        }
        function Uq(a3) {
          a3 = a3 | 0;
          return 536870911;
        }
        function Vq(a3, b3, d2, e3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          e3 = e3 | 0;
          var f2 = 0;
          c2[a3 + 12 >> 2] = 0;
          c2[a3 + 16 >> 2] = e3;
          do
            if (b3) {
              if (b3 >>> 0 > 536870911)
                Ta();
              else {
                f2 = qC(b3 << 3) | 0;
                break;
              }
            } else
              f2 = 0;
          while (0);
          c2[a3 >> 2] = f2;
          e3 = f2 + (d2 << 3) | 0;
          c2[a3 + 8 >> 2] = e3;
          c2[a3 + 4 >> 2] = e3;
          c2[a3 + 12 >> 2] = f2 + (b3 << 3);
          return;
        }
        function Wq(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          var d2 = 0, e3 = 0, f2 = 0, g3 = 0, h2 = 0;
          e3 = c2[a3 >> 2] | 0;
          h2 = a3 + 4 | 0;
          g3 = b3 + 4 | 0;
          f2 = (c2[h2 >> 2] | 0) - e3 | 0;
          d2 = (c2[g3 >> 2] | 0) + (0 - (f2 >> 3) << 3) | 0;
          c2[g3 >> 2] = d2;
          if ((f2 | 0) > 0) {
            BC(d2 | 0, e3 | 0, f2 | 0) | 0;
            e3 = g3;
            d2 = c2[g3 >> 2] | 0;
          } else
            e3 = g3;
          g3 = c2[a3 >> 2] | 0;
          c2[a3 >> 2] = d2;
          c2[e3 >> 2] = g3;
          g3 = b3 + 8 | 0;
          f2 = c2[h2 >> 2] | 0;
          c2[h2 >> 2] = c2[g3 >> 2];
          c2[g3 >> 2] = f2;
          g3 = a3 + 8 | 0;
          h2 = b3 + 12 | 0;
          a3 = c2[g3 >> 2] | 0;
          c2[g3 >> 2] = c2[h2 >> 2];
          c2[h2 >> 2] = a3;
          c2[b3 >> 2] = c2[e3 >> 2];
          return;
        }
        function Xq(a3) {
          a3 = a3 | 0;
          var b3 = 0, d2 = 0, e3 = 0;
          b3 = c2[a3 + 4 >> 2] | 0;
          d2 = a3 + 8 | 0;
          e3 = c2[d2 >> 2] | 0;
          if ((e3 | 0) != (b3 | 0))
            c2[d2 >> 2] = e3 + (~((e3 + -8 - b3 | 0) >>> 3) << 3);
          a3 = c2[a3 >> 2] | 0;
          if (a3 | 0)
            sC(a3);
          return;
        }
        function Yq(a3) {
          a3 = a3 | 0;
          $q(a3);
          return;
        }
        function Zq(a3) {
          a3 = a3 | 0;
          _q(a3 + 24 | 0);
          return;
        }
        function _q(a3) {
          a3 = a3 | 0;
          var b3 = 0, d2 = 0, e3 = 0;
          d2 = c2[a3 >> 2] | 0;
          e3 = d2;
          if (d2 | 0) {
            a3 = a3 + 4 | 0;
            b3 = c2[a3 >> 2] | 0;
            if ((b3 | 0) != (d2 | 0))
              c2[a3 >> 2] = b3 + (~((b3 + -8 - e3 | 0) >>> 3) << 3);
            sC(d2);
          }
          return;
        }
        function $q(a3) {
          a3 = a3 | 0;
          var b3 = 0;
          b3 = vi() | 0;
          yi(a3, 1, 15, b3, Zk() | 0, 0);
          c2[a3 + 24 >> 2] = 0;
          c2[a3 + 28 >> 2] = 0;
          c2[a3 + 32 >> 2] = 0;
          return;
        }
        function ar(a3) {
          a3 = a3 | 0;
          return cr(c2[(br(a3) | 0) >> 2] | 0) | 0;
        }
        function br(a3) {
          a3 = a3 | 0;
          return (c2[(Pq() | 0) + 24 >> 2] | 0) + (a3 << 3) | 0;
        }
        function cr(a3) {
          a3 = a3 | 0;
          return Ik(Ab[a3 & 7]() | 0) | 0;
        }
        function dr() {
          var b3 = 0;
          if (!(a2[7832] | 0)) {
            nr(10052);
            Ha(25, 10052, o2 | 0) | 0;
            b3 = 7832;
            c2[b3 >> 2] = 1;
            c2[b3 + 4 >> 2] = 0;
          }
          return 10052;
        }
        function er(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          c2[a3 >> 2] = fr() | 0;
          c2[a3 + 4 >> 2] = gr() | 0;
          c2[a3 + 12 >> 2] = b3;
          c2[a3 + 8 >> 2] = hr() | 0;
          c2[a3 + 32 >> 2] = 2;
          return;
        }
        function fr() {
          return 11709;
        }
        function gr() {
          return 1188;
        }
        function hr() {
          return lr() | 0;
        }
        function ir(a3, b3, c3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          c3 = c3 | 0;
          d2 = d2 | 0;
          if ((jr(d2, 896) | 0) == 512) {
            if (c3 | 0) {
              kr(c3);
              sC(c3);
            }
          } else if (b3 | 0) {
            uf(b3);
            sC(b3);
          }
          return;
        }
        function jr(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          return b3 & a3 | 0;
        }
        function kr(a3) {
          a3 = a3 | 0;
          a3 = c2[a3 + 4 >> 2] | 0;
          if (a3 | 0)
            oC(a3);
          return;
        }
        function lr() {
          var b3 = 0;
          if (!(a2[7824] | 0)) {
            c2[2511] = mr() | 0;
            c2[2512] = 0;
            b3 = 7824;
            c2[b3 >> 2] = 1;
            c2[b3 + 4 >> 2] = 0;
          }
          return 10044;
        }
        function mr() {
          return 0;
        }
        function nr(a3) {
          a3 = a3 | 0;
          Zi(a3);
          return;
        }
        function or(a3) {
          a3 = a3 | 0;
          var b3 = 0, d2 = 0, e3 = 0, f2 = 0, g3 = 0;
          b3 = l2;
          l2 = l2 + 32 | 0;
          d2 = b3 + 24 | 0;
          g3 = b3 + 16 | 0;
          f2 = b3 + 8 | 0;
          e3 = b3;
          pr(a3, 4827);
          qr(a3, 4834, 3) | 0;
          rr(a3, 3682, 47) | 0;
          c2[g3 >> 2] = 9;
          c2[g3 + 4 >> 2] = 0;
          c2[d2 >> 2] = c2[g3 >> 2];
          c2[d2 + 4 >> 2] = c2[g3 + 4 >> 2];
          sr(a3, 4841, d2) | 0;
          c2[f2 >> 2] = 1;
          c2[f2 + 4 >> 2] = 0;
          c2[d2 >> 2] = c2[f2 >> 2];
          c2[d2 + 4 >> 2] = c2[f2 + 4 >> 2];
          tr(a3, 4871, d2) | 0;
          c2[e3 >> 2] = 10;
          c2[e3 + 4 >> 2] = 0;
          c2[d2 >> 2] = c2[e3 >> 2];
          c2[d2 + 4 >> 2] = c2[e3 + 4 >> 2];
          ur(a3, 4891, d2) | 0;
          l2 = b3;
          return;
        }
        function pr(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          var d2 = 0;
          d2 = nt() | 0;
          c2[a3 >> 2] = d2;
          ot(d2, b3);
          Hv(c2[a3 >> 2] | 0);
          return;
        }
        function qr(a3, b3, c3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          c3 = c3 | 0;
          Ws(a3, ai(b3) | 0, c3, 0);
          return a3 | 0;
        }
        function rr(a3, b3, c3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          c3 = c3 | 0;
          Es(a3, ai(b3) | 0, c3, 0);
          return a3 | 0;
        }
        function sr(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          var e3 = 0, f2 = 0, g3 = 0, h2 = 0;
          e3 = l2;
          l2 = l2 + 16 | 0;
          f2 = e3 + 8 | 0;
          g3 = e3;
          h2 = c2[d2 + 4 >> 2] | 0;
          c2[g3 >> 2] = c2[d2 >> 2];
          c2[g3 + 4 >> 2] = h2;
          c2[f2 >> 2] = c2[g3 >> 2];
          c2[f2 + 4 >> 2] = c2[g3 + 4 >> 2];
          is(a3, b3, f2);
          l2 = e3;
          return a3 | 0;
        }
        function tr(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          var e3 = 0, f2 = 0, g3 = 0, h2 = 0;
          e3 = l2;
          l2 = l2 + 16 | 0;
          f2 = e3 + 8 | 0;
          g3 = e3;
          h2 = c2[d2 + 4 >> 2] | 0;
          c2[g3 >> 2] = c2[d2 >> 2];
          c2[g3 + 4 >> 2] = h2;
          c2[f2 >> 2] = c2[g3 >> 2];
          c2[f2 + 4 >> 2] = c2[g3 + 4 >> 2];
          Or(a3, b3, f2);
          l2 = e3;
          return a3 | 0;
        }
        function ur(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          var e3 = 0, f2 = 0, g3 = 0, h2 = 0;
          e3 = l2;
          l2 = l2 + 16 | 0;
          f2 = e3 + 8 | 0;
          g3 = e3;
          h2 = c2[d2 + 4 >> 2] | 0;
          c2[g3 >> 2] = c2[d2 >> 2];
          c2[g3 + 4 >> 2] = h2;
          c2[f2 >> 2] = c2[g3 >> 2];
          c2[f2 + 4 >> 2] = c2[g3 + 4 >> 2];
          vr(a3, b3, f2);
          l2 = e3;
          return a3 | 0;
        }
        function vr(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          var e3 = 0, f2 = 0, g3 = 0, h2 = 0, i4 = 0;
          e3 = l2;
          l2 = l2 + 16 | 0;
          f2 = e3 + 8 | 0;
          g3 = e3;
          i4 = c2[d2 >> 2] | 0;
          h2 = c2[d2 + 4 >> 2] | 0;
          d2 = ai(b3) | 0;
          c2[g3 >> 2] = i4;
          c2[g3 + 4 >> 2] = h2;
          c2[f2 >> 2] = c2[g3 >> 2];
          c2[f2 + 4 >> 2] = c2[g3 + 4 >> 2];
          wr(a3, d2, f2, 1);
          l2 = e3;
          return;
        }
        function wr(a3, b3, d2, e3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          e3 = e3 | 0;
          var f2 = 0, g3 = 0, h2 = 0, i4 = 0, j2 = 0, k2 = 0, m2 = 0;
          f2 = l2;
          l2 = l2 + 32 | 0;
          g3 = f2 + 16 | 0;
          m2 = f2 + 8 | 0;
          i4 = f2;
          k2 = c2[d2 >> 2] | 0;
          j2 = c2[d2 + 4 >> 2] | 0;
          h2 = c2[a3 >> 2] | 0;
          a3 = xr() | 0;
          c2[m2 >> 2] = k2;
          c2[m2 + 4 >> 2] = j2;
          c2[g3 >> 2] = c2[m2 >> 2];
          c2[g3 + 4 >> 2] = c2[m2 + 4 >> 2];
          d2 = yr(g3) | 0;
          c2[i4 >> 2] = k2;
          c2[i4 + 4 >> 2] = j2;
          c2[g3 >> 2] = c2[i4 >> 2];
          c2[g3 + 4 >> 2] = c2[i4 + 4 >> 2];
          fi(h2, b3, a3, d2, zr(g3, e3) | 0, e3);
          l2 = f2;
          return;
        }
        function xr() {
          var b3 = 0, d2 = 0;
          if (!(a2[7840] | 0)) {
            Gr(10100);
            Ha(48, 10100, o2 | 0) | 0;
            d2 = 7840;
            c2[d2 >> 2] = 1;
            c2[d2 + 4 >> 2] = 0;
          }
          if (!(si(10100) | 0)) {
            b3 = 10100;
            d2 = b3 + 36 | 0;
            do {
              c2[b3 >> 2] = 0;
              b3 = b3 + 4 | 0;
            } while ((b3 | 0) < (d2 | 0));
            Gr(10100);
          }
          return 10100;
        }
        function yr(a3) {
          a3 = a3 | 0;
          return 0;
        }
        function zr(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          var d2 = 0, e3 = 0, f2 = 0, g3 = 0, h2 = 0, i4 = 0, j2 = 0, k2 = 0, m2 = 0, n3 = 0;
          m2 = l2;
          l2 = l2 + 32 | 0;
          f2 = m2 + 24 | 0;
          h2 = m2 + 16 | 0;
          i4 = m2;
          j2 = m2 + 8 | 0;
          g3 = c2[a3 >> 2] | 0;
          e3 = c2[a3 + 4 >> 2] | 0;
          c2[i4 >> 2] = g3;
          c2[i4 + 4 >> 2] = e3;
          n3 = xr() | 0;
          k2 = n3 + 24 | 0;
          a3 = ji(b3, 4) | 0;
          c2[j2 >> 2] = a3;
          b3 = n3 + 28 | 0;
          d2 = c2[b3 >> 2] | 0;
          if (d2 >>> 0 < (c2[n3 + 32 >> 2] | 0) >>> 0) {
            c2[h2 >> 2] = g3;
            c2[h2 + 4 >> 2] = e3;
            c2[f2 >> 2] = c2[h2 >> 2];
            c2[f2 + 4 >> 2] = c2[h2 + 4 >> 2];
            Ar(d2, f2, a3);
            a3 = (c2[b3 >> 2] | 0) + 12 | 0;
            c2[b3 >> 2] = a3;
          } else {
            Br(k2, i4, j2);
            a3 = c2[b3 >> 2] | 0;
          }
          l2 = m2;
          return ((a3 - (c2[k2 >> 2] | 0) | 0) / 12 | 0) + -1 | 0;
        }
        function Ar(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          var e3 = 0;
          e3 = c2[b3 + 4 >> 2] | 0;
          c2[a3 >> 2] = c2[b3 >> 2];
          c2[a3 + 4 >> 2] = e3;
          c2[a3 + 8 >> 2] = d2;
          return;
        }
        function Br(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          var e3 = 0, f2 = 0, g3 = 0, h2 = 0, i4 = 0, j2 = 0, k2 = 0, m2 = 0, n3 = 0, o3 = 0;
          k2 = l2;
          l2 = l2 + 48 | 0;
          e3 = k2 + 32 | 0;
          h2 = k2 + 24 | 0;
          i4 = k2;
          j2 = a3 + 4 | 0;
          f2 = (((c2[j2 >> 2] | 0) - (c2[a3 >> 2] | 0) | 0) / 12 | 0) + 1 | 0;
          g3 = Cr(a3) | 0;
          if (g3 >>> 0 < f2 >>> 0)
            jC(a3);
          else {
            m2 = c2[a3 >> 2] | 0;
            o3 = ((c2[a3 + 8 >> 2] | 0) - m2 | 0) / 12 | 0;
            n3 = o3 << 1;
            Dr(i4, o3 >>> 0 < g3 >>> 1 >>> 0 ? n3 >>> 0 < f2 >>> 0 ? f2 : n3 : g3, ((c2[j2 >> 2] | 0) - m2 | 0) / 12 | 0, a3 + 8 | 0);
            j2 = i4 + 8 | 0;
            g3 = c2[j2 >> 2] | 0;
            f2 = c2[b3 + 4 >> 2] | 0;
            d2 = c2[d2 >> 2] | 0;
            c2[h2 >> 2] = c2[b3 >> 2];
            c2[h2 + 4 >> 2] = f2;
            c2[e3 >> 2] = c2[h2 >> 2];
            c2[e3 + 4 >> 2] = c2[h2 + 4 >> 2];
            Ar(g3, e3, d2);
            c2[j2 >> 2] = (c2[j2 >> 2] | 0) + 12;
            Er(a3, i4);
            Fr(i4);
            l2 = k2;
            return;
          }
        }
        function Cr(a3) {
          a3 = a3 | 0;
          return 357913941;
        }
        function Dr(a3, b3, d2, e3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          e3 = e3 | 0;
          var f2 = 0;
          c2[a3 + 12 >> 2] = 0;
          c2[a3 + 16 >> 2] = e3;
          do
            if (b3) {
              if (b3 >>> 0 > 357913941)
                Ta();
              else {
                f2 = qC(b3 * 12 | 0) | 0;
                break;
              }
            } else
              f2 = 0;
          while (0);
          c2[a3 >> 2] = f2;
          e3 = f2 + (d2 * 12 | 0) | 0;
          c2[a3 + 8 >> 2] = e3;
          c2[a3 + 4 >> 2] = e3;
          c2[a3 + 12 >> 2] = f2 + (b3 * 12 | 0);
          return;
        }
        function Er(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          var d2 = 0, e3 = 0, f2 = 0, g3 = 0, h2 = 0;
          e3 = c2[a3 >> 2] | 0;
          h2 = a3 + 4 | 0;
          g3 = b3 + 4 | 0;
          f2 = (c2[h2 >> 2] | 0) - e3 | 0;
          d2 = (c2[g3 >> 2] | 0) + (((f2 | 0) / -12 | 0) * 12 | 0) | 0;
          c2[g3 >> 2] = d2;
          if ((f2 | 0) > 0) {
            BC(d2 | 0, e3 | 0, f2 | 0) | 0;
            e3 = g3;
            d2 = c2[g3 >> 2] | 0;
          } else
            e3 = g3;
          g3 = c2[a3 >> 2] | 0;
          c2[a3 >> 2] = d2;
          c2[e3 >> 2] = g3;
          g3 = b3 + 8 | 0;
          f2 = c2[h2 >> 2] | 0;
          c2[h2 >> 2] = c2[g3 >> 2];
          c2[g3 >> 2] = f2;
          g3 = a3 + 8 | 0;
          h2 = b3 + 12 | 0;
          a3 = c2[g3 >> 2] | 0;
          c2[g3 >> 2] = c2[h2 >> 2];
          c2[h2 >> 2] = a3;
          c2[b3 >> 2] = c2[e3 >> 2];
          return;
        }
        function Fr(a3) {
          a3 = a3 | 0;
          var b3 = 0, d2 = 0, e3 = 0;
          b3 = c2[a3 + 4 >> 2] | 0;
          d2 = a3 + 8 | 0;
          e3 = c2[d2 >> 2] | 0;
          if ((e3 | 0) != (b3 | 0))
            c2[d2 >> 2] = e3 + (~(((e3 + -12 - b3 | 0) >>> 0) / 12 | 0) * 12 | 0);
          a3 = c2[a3 >> 2] | 0;
          if (a3 | 0)
            sC(a3);
          return;
        }
        function Gr(a3) {
          a3 = a3 | 0;
          Jr(a3);
          return;
        }
        function Hr(a3) {
          a3 = a3 | 0;
          Ir(a3 + 24 | 0);
          return;
        }
        function Ir(a3) {
          a3 = a3 | 0;
          var b3 = 0, d2 = 0, e3 = 0;
          d2 = c2[a3 >> 2] | 0;
          e3 = d2;
          if (d2 | 0) {
            a3 = a3 + 4 | 0;
            b3 = c2[a3 >> 2] | 0;
            if ((b3 | 0) != (d2 | 0))
              c2[a3 >> 2] = b3 + (~(((b3 + -12 - e3 | 0) >>> 0) / 12 | 0) * 12 | 0);
            sC(d2);
          }
          return;
        }
        function Jr(a3) {
          a3 = a3 | 0;
          var b3 = 0;
          b3 = vi() | 0;
          yi(a3, 2, 6, b3, Kr() | 0, 1);
          c2[a3 + 24 >> 2] = 0;
          c2[a3 + 28 >> 2] = 0;
          c2[a3 + 32 >> 2] = 0;
          return;
        }
        function Kr() {
          return 1364;
        }
        function Lr(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          var e3 = 0, f2 = 0, g3 = 0, h2 = 0;
          e3 = l2;
          l2 = l2 + 16 | 0;
          f2 = e3 + 8 | 0;
          g3 = e3;
          h2 = Mr(a3) | 0;
          a3 = c2[h2 + 4 >> 2] | 0;
          c2[g3 >> 2] = c2[h2 >> 2];
          c2[g3 + 4 >> 2] = a3;
          c2[f2 >> 2] = c2[g3 >> 2];
          c2[f2 + 4 >> 2] = c2[g3 + 4 >> 2];
          d2 = Nr(b3, f2, d2) | 0;
          l2 = e3;
          return d2 | 0;
        }
        function Mr(a3) {
          a3 = a3 | 0;
          return (c2[(xr() | 0) + 24 >> 2] | 0) + (a3 * 12 | 0) | 0;
        }
        function Nr(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          var e3 = 0, f2 = 0, g3 = 0;
          g3 = l2;
          l2 = l2 + 16 | 0;
          f2 = g3;
          e3 = c2[b3 >> 2] | 0;
          b3 = c2[b3 + 4 >> 2] | 0;
          a3 = a3 + (b3 >> 1) | 0;
          if (b3 & 1)
            e3 = c2[(c2[a3 >> 2] | 0) + e3 >> 2] | 0;
          tj(f2, d2);
          f2 = uj(f2, d2) | 0;
          f2 = Qj(wb[e3 & 15](a3, f2) | 0) | 0;
          l2 = g3;
          return f2 | 0;
        }
        function Or(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          var e3 = 0, f2 = 0, g3 = 0, h2 = 0, i4 = 0;
          e3 = l2;
          l2 = l2 + 16 | 0;
          f2 = e3 + 8 | 0;
          g3 = e3;
          i4 = c2[d2 >> 2] | 0;
          h2 = c2[d2 + 4 >> 2] | 0;
          d2 = ai(b3) | 0;
          c2[g3 >> 2] = i4;
          c2[g3 + 4 >> 2] = h2;
          c2[f2 >> 2] = c2[g3 >> 2];
          c2[f2 + 4 >> 2] = c2[g3 + 4 >> 2];
          Pr(a3, d2, f2, 0);
          l2 = e3;
          return;
        }
        function Pr(a3, b3, d2, e3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          e3 = e3 | 0;
          var f2 = 0, g3 = 0, h2 = 0, i4 = 0, j2 = 0, k2 = 0, m2 = 0;
          f2 = l2;
          l2 = l2 + 32 | 0;
          g3 = f2 + 16 | 0;
          m2 = f2 + 8 | 0;
          i4 = f2;
          k2 = c2[d2 >> 2] | 0;
          j2 = c2[d2 + 4 >> 2] | 0;
          h2 = c2[a3 >> 2] | 0;
          a3 = Qr() | 0;
          c2[m2 >> 2] = k2;
          c2[m2 + 4 >> 2] = j2;
          c2[g3 >> 2] = c2[m2 >> 2];
          c2[g3 + 4 >> 2] = c2[m2 + 4 >> 2];
          d2 = Rr(g3) | 0;
          c2[i4 >> 2] = k2;
          c2[i4 + 4 >> 2] = j2;
          c2[g3 >> 2] = c2[i4 >> 2];
          c2[g3 + 4 >> 2] = c2[i4 + 4 >> 2];
          fi(h2, b3, a3, d2, Sr(g3, e3) | 0, e3);
          l2 = f2;
          return;
        }
        function Qr() {
          var b3 = 0, d2 = 0;
          if (!(a2[7848] | 0)) {
            Zr(10136);
            Ha(49, 10136, o2 | 0) | 0;
            d2 = 7848;
            c2[d2 >> 2] = 1;
            c2[d2 + 4 >> 2] = 0;
          }
          if (!(si(10136) | 0)) {
            b3 = 10136;
            d2 = b3 + 36 | 0;
            do {
              c2[b3 >> 2] = 0;
              b3 = b3 + 4 | 0;
            } while ((b3 | 0) < (d2 | 0));
            Zr(10136);
          }
          return 10136;
        }
        function Rr(a3) {
          a3 = a3 | 0;
          return 0;
        }
        function Sr(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          var d2 = 0, e3 = 0, f2 = 0, g3 = 0, h2 = 0, i4 = 0, j2 = 0, k2 = 0, m2 = 0, n3 = 0;
          m2 = l2;
          l2 = l2 + 32 | 0;
          f2 = m2 + 24 | 0;
          h2 = m2 + 16 | 0;
          i4 = m2;
          j2 = m2 + 8 | 0;
          g3 = c2[a3 >> 2] | 0;
          e3 = c2[a3 + 4 >> 2] | 0;
          c2[i4 >> 2] = g3;
          c2[i4 + 4 >> 2] = e3;
          n3 = Qr() | 0;
          k2 = n3 + 24 | 0;
          a3 = ji(b3, 4) | 0;
          c2[j2 >> 2] = a3;
          b3 = n3 + 28 | 0;
          d2 = c2[b3 >> 2] | 0;
          if (d2 >>> 0 < (c2[n3 + 32 >> 2] | 0) >>> 0) {
            c2[h2 >> 2] = g3;
            c2[h2 + 4 >> 2] = e3;
            c2[f2 >> 2] = c2[h2 >> 2];
            c2[f2 + 4 >> 2] = c2[h2 + 4 >> 2];
            Tr(d2, f2, a3);
            a3 = (c2[b3 >> 2] | 0) + 12 | 0;
            c2[b3 >> 2] = a3;
          } else {
            Ur(k2, i4, j2);
            a3 = c2[b3 >> 2] | 0;
          }
          l2 = m2;
          return ((a3 - (c2[k2 >> 2] | 0) | 0) / 12 | 0) + -1 | 0;
        }
        function Tr(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          var e3 = 0;
          e3 = c2[b3 + 4 >> 2] | 0;
          c2[a3 >> 2] = c2[b3 >> 2];
          c2[a3 + 4 >> 2] = e3;
          c2[a3 + 8 >> 2] = d2;
          return;
        }
        function Ur(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          var e3 = 0, f2 = 0, g3 = 0, h2 = 0, i4 = 0, j2 = 0, k2 = 0, m2 = 0, n3 = 0, o3 = 0;
          k2 = l2;
          l2 = l2 + 48 | 0;
          e3 = k2 + 32 | 0;
          h2 = k2 + 24 | 0;
          i4 = k2;
          j2 = a3 + 4 | 0;
          f2 = (((c2[j2 >> 2] | 0) - (c2[a3 >> 2] | 0) | 0) / 12 | 0) + 1 | 0;
          g3 = Vr(a3) | 0;
          if (g3 >>> 0 < f2 >>> 0)
            jC(a3);
          else {
            m2 = c2[a3 >> 2] | 0;
            o3 = ((c2[a3 + 8 >> 2] | 0) - m2 | 0) / 12 | 0;
            n3 = o3 << 1;
            Wr(i4, o3 >>> 0 < g3 >>> 1 >>> 0 ? n3 >>> 0 < f2 >>> 0 ? f2 : n3 : g3, ((c2[j2 >> 2] | 0) - m2 | 0) / 12 | 0, a3 + 8 | 0);
            j2 = i4 + 8 | 0;
            g3 = c2[j2 >> 2] | 0;
            f2 = c2[b3 + 4 >> 2] | 0;
            d2 = c2[d2 >> 2] | 0;
            c2[h2 >> 2] = c2[b3 >> 2];
            c2[h2 + 4 >> 2] = f2;
            c2[e3 >> 2] = c2[h2 >> 2];
            c2[e3 + 4 >> 2] = c2[h2 + 4 >> 2];
            Tr(g3, e3, d2);
            c2[j2 >> 2] = (c2[j2 >> 2] | 0) + 12;
            Xr(a3, i4);
            Yr(i4);
            l2 = k2;
            return;
          }
        }
        function Vr(a3) {
          a3 = a3 | 0;
          return 357913941;
        }
        function Wr(a3, b3, d2, e3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          e3 = e3 | 0;
          var f2 = 0;
          c2[a3 + 12 >> 2] = 0;
          c2[a3 + 16 >> 2] = e3;
          do
            if (b3) {
              if (b3 >>> 0 > 357913941)
                Ta();
              else {
                f2 = qC(b3 * 12 | 0) | 0;
                break;
              }
            } else
              f2 = 0;
          while (0);
          c2[a3 >> 2] = f2;
          e3 = f2 + (d2 * 12 | 0) | 0;
          c2[a3 + 8 >> 2] = e3;
          c2[a3 + 4 >> 2] = e3;
          c2[a3 + 12 >> 2] = f2 + (b3 * 12 | 0);
          return;
        }
        function Xr(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          var d2 = 0, e3 = 0, f2 = 0, g3 = 0, h2 = 0;
          e3 = c2[a3 >> 2] | 0;
          h2 = a3 + 4 | 0;
          g3 = b3 + 4 | 0;
          f2 = (c2[h2 >> 2] | 0) - e3 | 0;
          d2 = (c2[g3 >> 2] | 0) + (((f2 | 0) / -12 | 0) * 12 | 0) | 0;
          c2[g3 >> 2] = d2;
          if ((f2 | 0) > 0) {
            BC(d2 | 0, e3 | 0, f2 | 0) | 0;
            e3 = g3;
            d2 = c2[g3 >> 2] | 0;
          } else
            e3 = g3;
          g3 = c2[a3 >> 2] | 0;
          c2[a3 >> 2] = d2;
          c2[e3 >> 2] = g3;
          g3 = b3 + 8 | 0;
          f2 = c2[h2 >> 2] | 0;
          c2[h2 >> 2] = c2[g3 >> 2];
          c2[g3 >> 2] = f2;
          g3 = a3 + 8 | 0;
          h2 = b3 + 12 | 0;
          a3 = c2[g3 >> 2] | 0;
          c2[g3 >> 2] = c2[h2 >> 2];
          c2[h2 >> 2] = a3;
          c2[b3 >> 2] = c2[e3 >> 2];
          return;
        }
        function Yr(a3) {
          a3 = a3 | 0;
          var b3 = 0, d2 = 0, e3 = 0;
          b3 = c2[a3 + 4 >> 2] | 0;
          d2 = a3 + 8 | 0;
          e3 = c2[d2 >> 2] | 0;
          if ((e3 | 0) != (b3 | 0))
            c2[d2 >> 2] = e3 + (~(((e3 + -12 - b3 | 0) >>> 0) / 12 | 0) * 12 | 0);
          a3 = c2[a3 >> 2] | 0;
          if (a3 | 0)
            sC(a3);
          return;
        }
        function Zr(a3) {
          a3 = a3 | 0;
          as(a3);
          return;
        }
        function _r(a3) {
          a3 = a3 | 0;
          $r(a3 + 24 | 0);
          return;
        }
        function $r(a3) {
          a3 = a3 | 0;
          var b3 = 0, d2 = 0, e3 = 0;
          d2 = c2[a3 >> 2] | 0;
          e3 = d2;
          if (d2 | 0) {
            a3 = a3 + 4 | 0;
            b3 = c2[a3 >> 2] | 0;
            if ((b3 | 0) != (d2 | 0))
              c2[a3 >> 2] = b3 + (~(((b3 + -12 - e3 | 0) >>> 0) / 12 | 0) * 12 | 0);
            sC(d2);
          }
          return;
        }
        function as(a3) {
          a3 = a3 | 0;
          var b3 = 0;
          b3 = vi() | 0;
          yi(a3, 2, 9, b3, bs() | 0, 1);
          c2[a3 + 24 >> 2] = 0;
          c2[a3 + 28 >> 2] = 0;
          c2[a3 + 32 >> 2] = 0;
          return;
        }
        function bs() {
          return 1372;
        }
        function cs(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = +d2;
          var e3 = 0, f2 = 0, g3 = 0, h2 = 0;
          e3 = l2;
          l2 = l2 + 16 | 0;
          f2 = e3 + 8 | 0;
          g3 = e3;
          h2 = ds(a3) | 0;
          a3 = c2[h2 + 4 >> 2] | 0;
          c2[g3 >> 2] = c2[h2 >> 2];
          c2[g3 + 4 >> 2] = a3;
          c2[f2 >> 2] = c2[g3 >> 2];
          c2[f2 + 4 >> 2] = c2[g3 + 4 >> 2];
          es(b3, f2, d2);
          l2 = e3;
          return;
        }
        function ds(a3) {
          a3 = a3 | 0;
          return (c2[(Qr() | 0) + 24 >> 2] | 0) + (a3 * 12 | 0) | 0;
        }
        function es(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = +d2;
          var e3 = 0, f2 = 0, g3 = 0, h2 = ib;
          g3 = l2;
          l2 = l2 + 16 | 0;
          f2 = g3;
          e3 = c2[b3 >> 2] | 0;
          b3 = c2[b3 + 4 >> 2] | 0;
          a3 = a3 + (b3 >> 1) | 0;
          if (b3 & 1)
            e3 = c2[(c2[a3 >> 2] | 0) + e3 >> 2] | 0;
          fs5(f2, d2);
          h2 = T(gs(f2, d2));
          kb[e3 & 1](a3, h2);
          l2 = g3;
          return;
        }
        function fs5(a3, b3) {
          a3 = a3 | 0;
          b3 = +b3;
          return;
        }
        function gs(a3, b3) {
          a3 = a3 | 0;
          b3 = +b3;
          return T(hs(b3));
        }
        function hs(a3) {
          a3 = +a3;
          return T(a3);
        }
        function is(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          var e3 = 0, f2 = 0, g3 = 0, h2 = 0, i4 = 0;
          e3 = l2;
          l2 = l2 + 16 | 0;
          f2 = e3 + 8 | 0;
          g3 = e3;
          i4 = c2[d2 >> 2] | 0;
          h2 = c2[d2 + 4 >> 2] | 0;
          d2 = ai(b3) | 0;
          c2[g3 >> 2] = i4;
          c2[g3 + 4 >> 2] = h2;
          c2[f2 >> 2] = c2[g3 >> 2];
          c2[f2 + 4 >> 2] = c2[g3 + 4 >> 2];
          js(a3, d2, f2, 0);
          l2 = e3;
          return;
        }
        function js(a3, b3, d2, e3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          e3 = e3 | 0;
          var f2 = 0, g3 = 0, h2 = 0, i4 = 0, j2 = 0, k2 = 0, m2 = 0;
          f2 = l2;
          l2 = l2 + 32 | 0;
          g3 = f2 + 16 | 0;
          m2 = f2 + 8 | 0;
          i4 = f2;
          k2 = c2[d2 >> 2] | 0;
          j2 = c2[d2 + 4 >> 2] | 0;
          h2 = c2[a3 >> 2] | 0;
          a3 = ks() | 0;
          c2[m2 >> 2] = k2;
          c2[m2 + 4 >> 2] = j2;
          c2[g3 >> 2] = c2[m2 >> 2];
          c2[g3 + 4 >> 2] = c2[m2 + 4 >> 2];
          d2 = ls(g3) | 0;
          c2[i4 >> 2] = k2;
          c2[i4 + 4 >> 2] = j2;
          c2[g3 >> 2] = c2[i4 >> 2];
          c2[g3 + 4 >> 2] = c2[i4 + 4 >> 2];
          fi(h2, b3, a3, d2, ms(g3, e3) | 0, e3);
          l2 = f2;
          return;
        }
        function ks() {
          var b3 = 0, d2 = 0;
          if (!(a2[7856] | 0)) {
            ts2(10172);
            Ha(50, 10172, o2 | 0) | 0;
            d2 = 7856;
            c2[d2 >> 2] = 1;
            c2[d2 + 4 >> 2] = 0;
          }
          if (!(si(10172) | 0)) {
            b3 = 10172;
            d2 = b3 + 36 | 0;
            do {
              c2[b3 >> 2] = 0;
              b3 = b3 + 4 | 0;
            } while ((b3 | 0) < (d2 | 0));
            ts2(10172);
          }
          return 10172;
        }
        function ls(a3) {
          a3 = a3 | 0;
          return 0;
        }
        function ms(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          var d2 = 0, e3 = 0, f2 = 0, g3 = 0, h2 = 0, i4 = 0, j2 = 0, k2 = 0, m2 = 0, n3 = 0;
          m2 = l2;
          l2 = l2 + 32 | 0;
          f2 = m2 + 24 | 0;
          h2 = m2 + 16 | 0;
          i4 = m2;
          j2 = m2 + 8 | 0;
          g3 = c2[a3 >> 2] | 0;
          e3 = c2[a3 + 4 >> 2] | 0;
          c2[i4 >> 2] = g3;
          c2[i4 + 4 >> 2] = e3;
          n3 = ks() | 0;
          k2 = n3 + 24 | 0;
          a3 = ji(b3, 4) | 0;
          c2[j2 >> 2] = a3;
          b3 = n3 + 28 | 0;
          d2 = c2[b3 >> 2] | 0;
          if (d2 >>> 0 < (c2[n3 + 32 >> 2] | 0) >>> 0) {
            c2[h2 >> 2] = g3;
            c2[h2 + 4 >> 2] = e3;
            c2[f2 >> 2] = c2[h2 >> 2];
            c2[f2 + 4 >> 2] = c2[h2 + 4 >> 2];
            ns(d2, f2, a3);
            a3 = (c2[b3 >> 2] | 0) + 12 | 0;
            c2[b3 >> 2] = a3;
          } else {
            os(k2, i4, j2);
            a3 = c2[b3 >> 2] | 0;
          }
          l2 = m2;
          return ((a3 - (c2[k2 >> 2] | 0) | 0) / 12 | 0) + -1 | 0;
        }
        function ns(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          var e3 = 0;
          e3 = c2[b3 + 4 >> 2] | 0;
          c2[a3 >> 2] = c2[b3 >> 2];
          c2[a3 + 4 >> 2] = e3;
          c2[a3 + 8 >> 2] = d2;
          return;
        }
        function os(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          var e3 = 0, f2 = 0, g3 = 0, h2 = 0, i4 = 0, j2 = 0, k2 = 0, m2 = 0, n3 = 0, o3 = 0;
          k2 = l2;
          l2 = l2 + 48 | 0;
          e3 = k2 + 32 | 0;
          h2 = k2 + 24 | 0;
          i4 = k2;
          j2 = a3 + 4 | 0;
          f2 = (((c2[j2 >> 2] | 0) - (c2[a3 >> 2] | 0) | 0) / 12 | 0) + 1 | 0;
          g3 = ps(a3) | 0;
          if (g3 >>> 0 < f2 >>> 0)
            jC(a3);
          else {
            m2 = c2[a3 >> 2] | 0;
            o3 = ((c2[a3 + 8 >> 2] | 0) - m2 | 0) / 12 | 0;
            n3 = o3 << 1;
            qs(i4, o3 >>> 0 < g3 >>> 1 >>> 0 ? n3 >>> 0 < f2 >>> 0 ? f2 : n3 : g3, ((c2[j2 >> 2] | 0) - m2 | 0) / 12 | 0, a3 + 8 | 0);
            j2 = i4 + 8 | 0;
            g3 = c2[j2 >> 2] | 0;
            f2 = c2[b3 + 4 >> 2] | 0;
            d2 = c2[d2 >> 2] | 0;
            c2[h2 >> 2] = c2[b3 >> 2];
            c2[h2 + 4 >> 2] = f2;
            c2[e3 >> 2] = c2[h2 >> 2];
            c2[e3 + 4 >> 2] = c2[h2 + 4 >> 2];
            ns(g3, e3, d2);
            c2[j2 >> 2] = (c2[j2 >> 2] | 0) + 12;
            rs(a3, i4);
            ss(i4);
            l2 = k2;
            return;
          }
        }
        function ps(a3) {
          a3 = a3 | 0;
          return 357913941;
        }
        function qs(a3, b3, d2, e3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          e3 = e3 | 0;
          var f2 = 0;
          c2[a3 + 12 >> 2] = 0;
          c2[a3 + 16 >> 2] = e3;
          do
            if (b3) {
              if (b3 >>> 0 > 357913941)
                Ta();
              else {
                f2 = qC(b3 * 12 | 0) | 0;
                break;
              }
            } else
              f2 = 0;
          while (0);
          c2[a3 >> 2] = f2;
          e3 = f2 + (d2 * 12 | 0) | 0;
          c2[a3 + 8 >> 2] = e3;
          c2[a3 + 4 >> 2] = e3;
          c2[a3 + 12 >> 2] = f2 + (b3 * 12 | 0);
          return;
        }
        function rs(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          var d2 = 0, e3 = 0, f2 = 0, g3 = 0, h2 = 0;
          e3 = c2[a3 >> 2] | 0;
          h2 = a3 + 4 | 0;
          g3 = b3 + 4 | 0;
          f2 = (c2[h2 >> 2] | 0) - e3 | 0;
          d2 = (c2[g3 >> 2] | 0) + (((f2 | 0) / -12 | 0) * 12 | 0) | 0;
          c2[g3 >> 2] = d2;
          if ((f2 | 0) > 0) {
            BC(d2 | 0, e3 | 0, f2 | 0) | 0;
            e3 = g3;
            d2 = c2[g3 >> 2] | 0;
          } else
            e3 = g3;
          g3 = c2[a3 >> 2] | 0;
          c2[a3 >> 2] = d2;
          c2[e3 >> 2] = g3;
          g3 = b3 + 8 | 0;
          f2 = c2[h2 >> 2] | 0;
          c2[h2 >> 2] = c2[g3 >> 2];
          c2[g3 >> 2] = f2;
          g3 = a3 + 8 | 0;
          h2 = b3 + 12 | 0;
          a3 = c2[g3 >> 2] | 0;
          c2[g3 >> 2] = c2[h2 >> 2];
          c2[h2 >> 2] = a3;
          c2[b3 >> 2] = c2[e3 >> 2];
          return;
        }
        function ss(a3) {
          a3 = a3 | 0;
          var b3 = 0, d2 = 0, e3 = 0;
          b3 = c2[a3 + 4 >> 2] | 0;
          d2 = a3 + 8 | 0;
          e3 = c2[d2 >> 2] | 0;
          if ((e3 | 0) != (b3 | 0))
            c2[d2 >> 2] = e3 + (~(((e3 + -12 - b3 | 0) >>> 0) / 12 | 0) * 12 | 0);
          a3 = c2[a3 >> 2] | 0;
          if (a3 | 0)
            sC(a3);
          return;
        }
        function ts2(a3) {
          a3 = a3 | 0;
          ws(a3);
          return;
        }
        function us(a3) {
          a3 = a3 | 0;
          vs(a3 + 24 | 0);
          return;
        }
        function vs(a3) {
          a3 = a3 | 0;
          var b3 = 0, d2 = 0, e3 = 0;
          d2 = c2[a3 >> 2] | 0;
          e3 = d2;
          if (d2 | 0) {
            a3 = a3 + 4 | 0;
            b3 = c2[a3 >> 2] | 0;
            if ((b3 | 0) != (d2 | 0))
              c2[a3 >> 2] = b3 + (~(((b3 + -12 - e3 | 0) >>> 0) / 12 | 0) * 12 | 0);
            sC(d2);
          }
          return;
        }
        function ws(a3) {
          a3 = a3 | 0;
          var b3 = 0;
          b3 = vi() | 0;
          yi(a3, 2, 3, b3, xs() | 0, 2);
          c2[a3 + 24 >> 2] = 0;
          c2[a3 + 28 >> 2] = 0;
          c2[a3 + 32 >> 2] = 0;
          return;
        }
        function xs() {
          return 1380;
        }
        function ys(a3, b3, d2, e3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          e3 = e3 | 0;
          var f2 = 0, g3 = 0, h2 = 0, i4 = 0;
          f2 = l2;
          l2 = l2 + 16 | 0;
          g3 = f2 + 8 | 0;
          h2 = f2;
          i4 = zs(a3) | 0;
          a3 = c2[i4 + 4 >> 2] | 0;
          c2[h2 >> 2] = c2[i4 >> 2];
          c2[h2 + 4 >> 2] = a3;
          c2[g3 >> 2] = c2[h2 >> 2];
          c2[g3 + 4 >> 2] = c2[h2 + 4 >> 2];
          As(b3, g3, d2, e3);
          l2 = f2;
          return;
        }
        function zs(a3) {
          a3 = a3 | 0;
          return (c2[(ks() | 0) + 24 >> 2] | 0) + (a3 * 12 | 0) | 0;
        }
        function As(a3, b3, d2, e3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          e3 = e3 | 0;
          var f2 = 0, g3 = 0, h2 = 0, i4 = 0;
          i4 = l2;
          l2 = l2 + 16 | 0;
          g3 = i4 + 1 | 0;
          h2 = i4;
          f2 = c2[b3 >> 2] | 0;
          b3 = c2[b3 + 4 >> 2] | 0;
          a3 = a3 + (b3 >> 1) | 0;
          if (b3 & 1)
            f2 = c2[(c2[a3 >> 2] | 0) + f2 >> 2] | 0;
          tj(g3, d2);
          g3 = uj(g3, d2) | 0;
          Bs(h2, e3);
          h2 = Cs(h2, e3) | 0;
          Eb[f2 & 15](a3, g3, h2);
          l2 = i4;
          return;
        }
        function Bs(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          return;
        }
        function Cs(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          return Ds(b3) | 0;
        }
        function Ds(a3) {
          a3 = a3 | 0;
          return (a3 | 0) != 0 | 0;
        }
        function Es(a3, b3, d2, e3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          e3 = e3 | 0;
          var f2 = 0, g3 = 0;
          g3 = c2[a3 >> 2] | 0;
          f2 = Fs() | 0;
          a3 = Gs(d2) | 0;
          fi(g3, b3, f2, a3, Hs(d2, e3) | 0, e3);
          return;
        }
        function Fs() {
          var b3 = 0, d2 = 0;
          if (!(a2[7864] | 0)) {
            Os(10208);
            Ha(51, 10208, o2 | 0) | 0;
            d2 = 7864;
            c2[d2 >> 2] = 1;
            c2[d2 + 4 >> 2] = 0;
          }
          if (!(si(10208) | 0)) {
            b3 = 10208;
            d2 = b3 + 36 | 0;
            do {
              c2[b3 >> 2] = 0;
              b3 = b3 + 4 | 0;
            } while ((b3 | 0) < (d2 | 0));
            Os(10208);
          }
          return 10208;
        }
        function Gs(a3) {
          a3 = a3 | 0;
          return a3 | 0;
        }
        function Hs(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          var d2 = 0, e3 = 0, f2 = 0, g3 = 0, h2 = 0, i4 = 0, j2 = 0;
          i4 = l2;
          l2 = l2 + 16 | 0;
          f2 = i4;
          g3 = i4 + 4 | 0;
          c2[f2 >> 2] = a3;
          j2 = Fs() | 0;
          h2 = j2 + 24 | 0;
          b3 = ji(b3, 4) | 0;
          c2[g3 >> 2] = b3;
          d2 = j2 + 28 | 0;
          e3 = c2[d2 >> 2] | 0;
          if (e3 >>> 0 < (c2[j2 + 32 >> 2] | 0) >>> 0) {
            Is(e3, a3, b3);
            b3 = (c2[d2 >> 2] | 0) + 8 | 0;
            c2[d2 >> 2] = b3;
          } else {
            Js(h2, f2, g3);
            b3 = c2[d2 >> 2] | 0;
          }
          l2 = i4;
          return (b3 - (c2[h2 >> 2] | 0) >> 3) + -1 | 0;
        }
        function Is(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          c2[a3 >> 2] = b3;
          c2[a3 + 4 >> 2] = d2;
          return;
        }
        function Js(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          var e3 = 0, f2 = 0, g3 = 0, h2 = 0, i4 = 0, j2 = 0, k2 = 0, m2 = 0;
          i4 = l2;
          l2 = l2 + 32 | 0;
          f2 = i4;
          g3 = a3 + 4 | 0;
          h2 = ((c2[g3 >> 2] | 0) - (c2[a3 >> 2] | 0) >> 3) + 1 | 0;
          e3 = Ks(a3) | 0;
          if (e3 >>> 0 < h2 >>> 0)
            jC(a3);
          else {
            j2 = c2[a3 >> 2] | 0;
            m2 = (c2[a3 + 8 >> 2] | 0) - j2 | 0;
            k2 = m2 >> 2;
            Ls(f2, m2 >> 3 >>> 0 < e3 >>> 1 >>> 0 ? k2 >>> 0 < h2 >>> 0 ? h2 : k2 : e3, (c2[g3 >> 2] | 0) - j2 >> 3, a3 + 8 | 0);
            h2 = f2 + 8 | 0;
            Is(c2[h2 >> 2] | 0, c2[b3 >> 2] | 0, c2[d2 >> 2] | 0);
            c2[h2 >> 2] = (c2[h2 >> 2] | 0) + 8;
            Ms(a3, f2);
            Ns(f2);
            l2 = i4;
            return;
          }
        }
        function Ks(a3) {
          a3 = a3 | 0;
          return 536870911;
        }
        function Ls(a3, b3, d2, e3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          e3 = e3 | 0;
          var f2 = 0;
          c2[a3 + 12 >> 2] = 0;
          c2[a3 + 16 >> 2] = e3;
          do
            if (b3) {
              if (b3 >>> 0 > 536870911)
                Ta();
              else {
                f2 = qC(b3 << 3) | 0;
                break;
              }
            } else
              f2 = 0;
          while (0);
          c2[a3 >> 2] = f2;
          e3 = f2 + (d2 << 3) | 0;
          c2[a3 + 8 >> 2] = e3;
          c2[a3 + 4 >> 2] = e3;
          c2[a3 + 12 >> 2] = f2 + (b3 << 3);
          return;
        }
        function Ms(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          var d2 = 0, e3 = 0, f2 = 0, g3 = 0, h2 = 0;
          e3 = c2[a3 >> 2] | 0;
          h2 = a3 + 4 | 0;
          g3 = b3 + 4 | 0;
          f2 = (c2[h2 >> 2] | 0) - e3 | 0;
          d2 = (c2[g3 >> 2] | 0) + (0 - (f2 >> 3) << 3) | 0;
          c2[g3 >> 2] = d2;
          if ((f2 | 0) > 0) {
            BC(d2 | 0, e3 | 0, f2 | 0) | 0;
            e3 = g3;
            d2 = c2[g3 >> 2] | 0;
          } else
            e3 = g3;
          g3 = c2[a3 >> 2] | 0;
          c2[a3 >> 2] = d2;
          c2[e3 >> 2] = g3;
          g3 = b3 + 8 | 0;
          f2 = c2[h2 >> 2] | 0;
          c2[h2 >> 2] = c2[g3 >> 2];
          c2[g3 >> 2] = f2;
          g3 = a3 + 8 | 0;
          h2 = b3 + 12 | 0;
          a3 = c2[g3 >> 2] | 0;
          c2[g3 >> 2] = c2[h2 >> 2];
          c2[h2 >> 2] = a3;
          c2[b3 >> 2] = c2[e3 >> 2];
          return;
        }
        function Ns(a3) {
          a3 = a3 | 0;
          var b3 = 0, d2 = 0, e3 = 0;
          b3 = c2[a3 + 4 >> 2] | 0;
          d2 = a3 + 8 | 0;
          e3 = c2[d2 >> 2] | 0;
          if ((e3 | 0) != (b3 | 0))
            c2[d2 >> 2] = e3 + (~((e3 + -8 - b3 | 0) >>> 3) << 3);
          a3 = c2[a3 >> 2] | 0;
          if (a3 | 0)
            sC(a3);
          return;
        }
        function Os(a3) {
          a3 = a3 | 0;
          Rs(a3);
          return;
        }
        function Ps(a3) {
          a3 = a3 | 0;
          Qs(a3 + 24 | 0);
          return;
        }
        function Qs(a3) {
          a3 = a3 | 0;
          var b3 = 0, d2 = 0, e3 = 0;
          d2 = c2[a3 >> 2] | 0;
          e3 = d2;
          if (d2 | 0) {
            a3 = a3 + 4 | 0;
            b3 = c2[a3 >> 2] | 0;
            if ((b3 | 0) != (d2 | 0))
              c2[a3 >> 2] = b3 + (~((b3 + -8 - e3 | 0) >>> 3) << 3);
            sC(d2);
          }
          return;
        }
        function Rs(a3) {
          a3 = a3 | 0;
          var b3 = 0;
          b3 = vi() | 0;
          yi(a3, 1, 24, b3, Ss() | 0, 1);
          c2[a3 + 24 >> 2] = 0;
          c2[a3 + 28 >> 2] = 0;
          c2[a3 + 32 >> 2] = 0;
          return;
        }
        function Ss() {
          return 1392;
        }
        function Ts(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          Vs(c2[(Us(a3) | 0) >> 2] | 0, b3);
          return;
        }
        function Us(a3) {
          a3 = a3 | 0;
          return (c2[(Fs() | 0) + 24 >> 2] | 0) + (a3 << 3) | 0;
        }
        function Vs(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          var c3 = 0, d2 = 0;
          c3 = l2;
          l2 = l2 + 16 | 0;
          d2 = c3;
          Lq(d2, b3);
          b3 = Mq(d2, b3) | 0;
          nb[a3 & 127](b3);
          l2 = c3;
          return;
        }
        function Ws(a3, b3, d2, e3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          e3 = e3 | 0;
          var f2 = 0, g3 = 0;
          g3 = c2[a3 >> 2] | 0;
          f2 = Xs() | 0;
          a3 = Ys(d2) | 0;
          fi(g3, b3, f2, a3, Zs(d2, e3) | 0, e3);
          return;
        }
        function Xs() {
          var b3 = 0, d2 = 0;
          if (!(a2[7872] | 0)) {
            et(10244);
            Ha(52, 10244, o2 | 0) | 0;
            d2 = 7872;
            c2[d2 >> 2] = 1;
            c2[d2 + 4 >> 2] = 0;
          }
          if (!(si(10244) | 0)) {
            b3 = 10244;
            d2 = b3 + 36 | 0;
            do {
              c2[b3 >> 2] = 0;
              b3 = b3 + 4 | 0;
            } while ((b3 | 0) < (d2 | 0));
            et(10244);
          }
          return 10244;
        }
        function Ys(a3) {
          a3 = a3 | 0;
          return a3 | 0;
        }
        function Zs(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          var d2 = 0, e3 = 0, f2 = 0, g3 = 0, h2 = 0, i4 = 0, j2 = 0;
          i4 = l2;
          l2 = l2 + 16 | 0;
          f2 = i4;
          g3 = i4 + 4 | 0;
          c2[f2 >> 2] = a3;
          j2 = Xs() | 0;
          h2 = j2 + 24 | 0;
          b3 = ji(b3, 4) | 0;
          c2[g3 >> 2] = b3;
          d2 = j2 + 28 | 0;
          e3 = c2[d2 >> 2] | 0;
          if (e3 >>> 0 < (c2[j2 + 32 >> 2] | 0) >>> 0) {
            _s(e3, a3, b3);
            b3 = (c2[d2 >> 2] | 0) + 8 | 0;
            c2[d2 >> 2] = b3;
          } else {
            $s(h2, f2, g3);
            b3 = c2[d2 >> 2] | 0;
          }
          l2 = i4;
          return (b3 - (c2[h2 >> 2] | 0) >> 3) + -1 | 0;
        }
        function _s(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          c2[a3 >> 2] = b3;
          c2[a3 + 4 >> 2] = d2;
          return;
        }
        function $s(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          var e3 = 0, f2 = 0, g3 = 0, h2 = 0, i4 = 0, j2 = 0, k2 = 0, m2 = 0;
          i4 = l2;
          l2 = l2 + 32 | 0;
          f2 = i4;
          g3 = a3 + 4 | 0;
          h2 = ((c2[g3 >> 2] | 0) - (c2[a3 >> 2] | 0) >> 3) + 1 | 0;
          e3 = at(a3) | 0;
          if (e3 >>> 0 < h2 >>> 0)
            jC(a3);
          else {
            j2 = c2[a3 >> 2] | 0;
            m2 = (c2[a3 + 8 >> 2] | 0) - j2 | 0;
            k2 = m2 >> 2;
            bt(f2, m2 >> 3 >>> 0 < e3 >>> 1 >>> 0 ? k2 >>> 0 < h2 >>> 0 ? h2 : k2 : e3, (c2[g3 >> 2] | 0) - j2 >> 3, a3 + 8 | 0);
            h2 = f2 + 8 | 0;
            _s(c2[h2 >> 2] | 0, c2[b3 >> 2] | 0, c2[d2 >> 2] | 0);
            c2[h2 >> 2] = (c2[h2 >> 2] | 0) + 8;
            ct(a3, f2);
            dt(f2);
            l2 = i4;
            return;
          }
        }
        function at(a3) {
          a3 = a3 | 0;
          return 536870911;
        }
        function bt(a3, b3, d2, e3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          e3 = e3 | 0;
          var f2 = 0;
          c2[a3 + 12 >> 2] = 0;
          c2[a3 + 16 >> 2] = e3;
          do
            if (b3) {
              if (b3 >>> 0 > 536870911)
                Ta();
              else {
                f2 = qC(b3 << 3) | 0;
                break;
              }
            } else
              f2 = 0;
          while (0);
          c2[a3 >> 2] = f2;
          e3 = f2 + (d2 << 3) | 0;
          c2[a3 + 8 >> 2] = e3;
          c2[a3 + 4 >> 2] = e3;
          c2[a3 + 12 >> 2] = f2 + (b3 << 3);
          return;
        }
        function ct(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          var d2 = 0, e3 = 0, f2 = 0, g3 = 0, h2 = 0;
          e3 = c2[a3 >> 2] | 0;
          h2 = a3 + 4 | 0;
          g3 = b3 + 4 | 0;
          f2 = (c2[h2 >> 2] | 0) - e3 | 0;
          d2 = (c2[g3 >> 2] | 0) + (0 - (f2 >> 3) << 3) | 0;
          c2[g3 >> 2] = d2;
          if ((f2 | 0) > 0) {
            BC(d2 | 0, e3 | 0, f2 | 0) | 0;
            e3 = g3;
            d2 = c2[g3 >> 2] | 0;
          } else
            e3 = g3;
          g3 = c2[a3 >> 2] | 0;
          c2[a3 >> 2] = d2;
          c2[e3 >> 2] = g3;
          g3 = b3 + 8 | 0;
          f2 = c2[h2 >> 2] | 0;
          c2[h2 >> 2] = c2[g3 >> 2];
          c2[g3 >> 2] = f2;
          g3 = a3 + 8 | 0;
          h2 = b3 + 12 | 0;
          a3 = c2[g3 >> 2] | 0;
          c2[g3 >> 2] = c2[h2 >> 2];
          c2[h2 >> 2] = a3;
          c2[b3 >> 2] = c2[e3 >> 2];
          return;
        }
        function dt(a3) {
          a3 = a3 | 0;
          var b3 = 0, d2 = 0, e3 = 0;
          b3 = c2[a3 + 4 >> 2] | 0;
          d2 = a3 + 8 | 0;
          e3 = c2[d2 >> 2] | 0;
          if ((e3 | 0) != (b3 | 0))
            c2[d2 >> 2] = e3 + (~((e3 + -8 - b3 | 0) >>> 3) << 3);
          a3 = c2[a3 >> 2] | 0;
          if (a3 | 0)
            sC(a3);
          return;
        }
        function et(a3) {
          a3 = a3 | 0;
          ht(a3);
          return;
        }
        function ft(a3) {
          a3 = a3 | 0;
          gt(a3 + 24 | 0);
          return;
        }
        function gt(a3) {
          a3 = a3 | 0;
          var b3 = 0, d2 = 0, e3 = 0;
          d2 = c2[a3 >> 2] | 0;
          e3 = d2;
          if (d2 | 0) {
            a3 = a3 + 4 | 0;
            b3 = c2[a3 >> 2] | 0;
            if ((b3 | 0) != (d2 | 0))
              c2[a3 >> 2] = b3 + (~((b3 + -8 - e3 | 0) >>> 3) << 3);
            sC(d2);
          }
          return;
        }
        function ht(a3) {
          a3 = a3 | 0;
          var b3 = 0;
          b3 = vi() | 0;
          yi(a3, 1, 16, b3, it() | 0, 0);
          c2[a3 + 24 >> 2] = 0;
          c2[a3 + 28 >> 2] = 0;
          c2[a3 + 32 >> 2] = 0;
          return;
        }
        function it() {
          return 1400;
        }
        function jt(a3) {
          a3 = a3 | 0;
          return lt(c2[(kt(a3) | 0) >> 2] | 0) | 0;
        }
        function kt(a3) {
          a3 = a3 | 0;
          return (c2[(Xs() | 0) + 24 >> 2] | 0) + (a3 << 3) | 0;
        }
        function lt(a3) {
          a3 = a3 | 0;
          return mt(Ab[a3 & 7]() | 0) | 0;
        }
        function mt(a3) {
          a3 = a3 | 0;
          return a3 | 0;
        }
        function nt() {
          var b3 = 0;
          if (!(a2[7880] | 0)) {
            ut(10280);
            Ha(25, 10280, o2 | 0) | 0;
            b3 = 7880;
            c2[b3 >> 2] = 1;
            c2[b3 + 4 >> 2] = 0;
          }
          return 10280;
        }
        function ot(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          c2[a3 >> 2] = pt() | 0;
          c2[a3 + 4 >> 2] = qt() | 0;
          c2[a3 + 12 >> 2] = b3;
          c2[a3 + 8 >> 2] = rt() | 0;
          c2[a3 + 32 >> 2] = 4;
          return;
        }
        function pt() {
          return 11711;
        }
        function qt() {
          return 1356;
        }
        function rt() {
          return lr() | 0;
        }
        function st(a3, b3, c3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          c3 = c3 | 0;
          d2 = d2 | 0;
          if ((jr(d2, 896) | 0) == 512) {
            if (c3 | 0) {
              tt(c3);
              sC(c3);
            }
          } else if (b3 | 0) {
            mf(b3);
            sC(b3);
          }
          return;
        }
        function tt(a3) {
          a3 = a3 | 0;
          a3 = c2[a3 + 4 >> 2] | 0;
          if (a3 | 0)
            oC(a3);
          return;
        }
        function ut(a3) {
          a3 = a3 | 0;
          Zi(a3);
          return;
        }
        function vt(a3) {
          a3 = a3 | 0;
          wt(a3, 4920);
          xt(a3) | 0;
          yt(a3) | 0;
          return;
        }
        function wt(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          var d2 = 0;
          d2 = nn() | 0;
          c2[a3 >> 2] = d2;
          Yt(d2, b3);
          Hv(c2[a3 >> 2] | 0);
          return;
        }
        function xt(a3) {
          a3 = a3 | 0;
          var b3 = 0;
          b3 = c2[a3 >> 2] | 0;
          At(b3, Mt() | 0);
          return a3 | 0;
        }
        function yt(a3) {
          a3 = a3 | 0;
          var b3 = 0;
          b3 = c2[a3 >> 2] | 0;
          At(b3, zt() | 0);
          return a3 | 0;
        }
        function zt() {
          var b3 = 0;
          if (!(a2[7888] | 0)) {
            Bt(10328);
            Ha(53, 10328, o2 | 0) | 0;
            b3 = 7888;
            c2[b3 >> 2] = 1;
            c2[b3 + 4 >> 2] = 0;
          }
          if (!(si(10328) | 0))
            Bt(10328);
          return 10328;
        }
        function At(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          fi(a3, 0, b3, 0, 0, 0);
          return;
        }
        function Bt(a3) {
          a3 = a3 | 0;
          Et(a3);
          Gt(a3, 10);
          return;
        }
        function Ct(a3) {
          a3 = a3 | 0;
          Dt(a3 + 24 | 0);
          return;
        }
        function Dt(a3) {
          a3 = a3 | 0;
          var b3 = 0, d2 = 0, e3 = 0;
          d2 = c2[a3 >> 2] | 0;
          e3 = d2;
          if (d2 | 0) {
            a3 = a3 + 4 | 0;
            b3 = c2[a3 >> 2] | 0;
            if ((b3 | 0) != (d2 | 0))
              c2[a3 >> 2] = b3 + (~((b3 + -8 - e3 | 0) >>> 3) << 3);
            sC(d2);
          }
          return;
        }
        function Et(a3) {
          a3 = a3 | 0;
          var b3 = 0;
          b3 = vi() | 0;
          yi(a3, 5, 1, b3, Jt() | 0, 2);
          c2[a3 + 24 >> 2] = 0;
          c2[a3 + 28 >> 2] = 0;
          c2[a3 + 32 >> 2] = 0;
          return;
        }
        function Ft(a3, b3, c3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          c3 = +c3;
          Ht(a3, b3, c3);
          return;
        }
        function Gt(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          c2[a3 + 20 >> 2] = b3;
          return;
        }
        function Ht(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = +d2;
          var e3 = 0, f2 = 0, g3 = 0, i4 = 0, j2 = 0;
          e3 = l2;
          l2 = l2 + 16 | 0;
          g3 = e3 + 8 | 0;
          j2 = e3 + 13 | 0;
          f2 = e3;
          i4 = e3 + 12 | 0;
          tj(j2, b3);
          c2[g3 >> 2] = uj(j2, b3) | 0;
          rj(i4, d2);
          h[f2 >> 3] = +sj(i4, d2);
          It(a3, g3, f2);
          l2 = e3;
          return;
        }
        function It(b3, d2, e3) {
          b3 = b3 | 0;
          d2 = d2 | 0;
          e3 = e3 | 0;
          mg(b3 + 8 | 0, c2[d2 >> 2] | 0, +h[e3 >> 3]);
          a2[b3 + 24 >> 0] = 1;
          return;
        }
        function Jt() {
          return 1404;
        }
        function Kt(a3, b3) {
          a3 = a3 | 0;
          b3 = +b3;
          return Lt(a3, b3) | 0;
        }
        function Lt(a3, b3) {
          a3 = a3 | 0;
          b3 = +b3;
          var d2 = 0, e3 = 0, f2 = 0, g3 = 0, h2 = 0, i4 = 0, j2 = 0;
          e3 = l2;
          l2 = l2 + 16 | 0;
          g3 = e3 + 4 | 0;
          h2 = e3 + 8 | 0;
          i4 = e3;
          f2 = jy(8) | 0;
          d2 = f2;
          j2 = qC(16) | 0;
          tj(g3, a3);
          a3 = uj(g3, a3) | 0;
          rj(h2, b3);
          mg(j2, a3, +sj(h2, b3));
          h2 = d2 + 4 | 0;
          c2[h2 >> 2] = j2;
          a3 = qC(8) | 0;
          h2 = c2[h2 >> 2] | 0;
          c2[i4 >> 2] = 0;
          c2[g3 >> 2] = c2[i4 >> 2];
          qn(a3, h2, g3);
          c2[f2 >> 2] = a3;
          l2 = e3;
          return d2 | 0;
        }
        function Mt() {
          var b3 = 0;
          if (!(a2[7896] | 0)) {
            Nt(10364);
            Ha(54, 10364, o2 | 0) | 0;
            b3 = 7896;
            c2[b3 >> 2] = 1;
            c2[b3 + 4 >> 2] = 0;
          }
          if (!(si(10364) | 0))
            Nt(10364);
          return 10364;
        }
        function Nt(a3) {
          a3 = a3 | 0;
          Qt(a3);
          Gt(a3, 55);
          return;
        }
        function Ot(a3) {
          a3 = a3 | 0;
          Pt(a3 + 24 | 0);
          return;
        }
        function Pt(a3) {
          a3 = a3 | 0;
          var b3 = 0, d2 = 0, e3 = 0;
          d2 = c2[a3 >> 2] | 0;
          e3 = d2;
          if (d2 | 0) {
            a3 = a3 + 4 | 0;
            b3 = c2[a3 >> 2] | 0;
            if ((b3 | 0) != (d2 | 0))
              c2[a3 >> 2] = b3 + (~((b3 + -8 - e3 | 0) >>> 3) << 3);
            sC(d2);
          }
          return;
        }
        function Qt(a3) {
          a3 = a3 | 0;
          var b3 = 0;
          b3 = vi() | 0;
          yi(a3, 5, 4, b3, Vt() | 0, 0);
          c2[a3 + 24 >> 2] = 0;
          c2[a3 + 28 >> 2] = 0;
          c2[a3 + 32 >> 2] = 0;
          return;
        }
        function Rt(a3) {
          a3 = a3 | 0;
          St(a3);
          return;
        }
        function St(a3) {
          a3 = a3 | 0;
          Tt(a3);
          return;
        }
        function Tt(b3) {
          b3 = b3 | 0;
          Ut(b3 + 8 | 0);
          a2[b3 + 24 >> 0] = 1;
          return;
        }
        function Ut(a3) {
          a3 = a3 | 0;
          c2[a3 >> 2] = 0;
          h[a3 + 8 >> 3] = 0;
          return;
        }
        function Vt() {
          return 1424;
        }
        function Wt() {
          return Xt() | 0;
        }
        function Xt() {
          var a3 = 0, b3 = 0, d2 = 0, e3 = 0, f2 = 0, g3 = 0, h2 = 0;
          b3 = l2;
          l2 = l2 + 16 | 0;
          f2 = b3 + 4 | 0;
          h2 = b3;
          d2 = jy(8) | 0;
          a3 = d2;
          e3 = qC(16) | 0;
          Ut(e3);
          g3 = a3 + 4 | 0;
          c2[g3 >> 2] = e3;
          e3 = qC(8) | 0;
          g3 = c2[g3 >> 2] | 0;
          c2[h2 >> 2] = 0;
          c2[f2 >> 2] = c2[h2 >> 2];
          qn(e3, g3, f2);
          c2[d2 >> 2] = e3;
          l2 = b3;
          return a3 | 0;
        }
        function Yt(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          c2[a3 >> 2] = Zt() | 0;
          c2[a3 + 4 >> 2] = _t() | 0;
          c2[a3 + 12 >> 2] = b3;
          c2[a3 + 8 >> 2] = $t() | 0;
          c2[a3 + 32 >> 2] = 5;
          return;
        }
        function Zt() {
          return 11710;
        }
        function _t() {
          return 1416;
        }
        function $t() {
          return cu() | 0;
        }
        function au(a3, b3, c3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          c3 = c3 | 0;
          d2 = d2 | 0;
          if ((jr(d2, 896) | 0) == 512) {
            if (c3 | 0) {
              bu(c3);
              sC(c3);
            }
          } else if (b3 | 0)
            sC(b3);
          return;
        }
        function bu(a3) {
          a3 = a3 | 0;
          a3 = c2[a3 + 4 >> 2] | 0;
          if (a3 | 0)
            oC(a3);
          return;
        }
        function cu() {
          var b3 = 0;
          if (!(a2[7904] | 0)) {
            c2[2600] = du() | 0;
            c2[2601] = 0;
            b3 = 7904;
            c2[b3 >> 2] = 1;
            c2[b3 + 4 >> 2] = 0;
          }
          return 10400;
        }
        function du() {
          return c2[357] | 0;
        }
        function eu(a3) {
          a3 = a3 | 0;
          fu(a3, 4926);
          gu(a3) | 0;
          return;
        }
        function fu(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          var d2 = 0;
          d2 = Ci() | 0;
          c2[a3 >> 2] = d2;
          su(d2, b3);
          Hv(c2[a3 >> 2] | 0);
          return;
        }
        function gu(a3) {
          a3 = a3 | 0;
          var b3 = 0;
          b3 = c2[a3 >> 2] | 0;
          At(b3, hu() | 0);
          return a3 | 0;
        }
        function hu() {
          var b3 = 0;
          if (!(a2[7912] | 0)) {
            iu(10412);
            Ha(56, 10412, o2 | 0) | 0;
            b3 = 7912;
            c2[b3 >> 2] = 1;
            c2[b3 + 4 >> 2] = 0;
          }
          if (!(si(10412) | 0))
            iu(10412);
          return 10412;
        }
        function iu(a3) {
          a3 = a3 | 0;
          lu(a3);
          Gt(a3, 57);
          return;
        }
        function ju(a3) {
          a3 = a3 | 0;
          ku(a3 + 24 | 0);
          return;
        }
        function ku(a3) {
          a3 = a3 | 0;
          var b3 = 0, d2 = 0, e3 = 0;
          d2 = c2[a3 >> 2] | 0;
          e3 = d2;
          if (d2 | 0) {
            a3 = a3 + 4 | 0;
            b3 = c2[a3 >> 2] | 0;
            if ((b3 | 0) != (d2 | 0))
              c2[a3 >> 2] = b3 + (~((b3 + -8 - e3 | 0) >>> 3) << 3);
            sC(d2);
          }
          return;
        }
        function lu(a3) {
          a3 = a3 | 0;
          var b3 = 0;
          b3 = vi() | 0;
          yi(a3, 5, 5, b3, pu() | 0, 0);
          c2[a3 + 24 >> 2] = 0;
          c2[a3 + 28 >> 2] = 0;
          c2[a3 + 32 >> 2] = 0;
          return;
        }
        function mu(a3) {
          a3 = a3 | 0;
          nu(a3);
          return;
        }
        function nu(a3) {
          a3 = a3 | 0;
          ou(a3);
          return;
        }
        function ou(b3) {
          b3 = b3 | 0;
          var d2 = 0, e3 = 0;
          d2 = b3 + 8 | 0;
          e3 = d2 + 48 | 0;
          do {
            c2[d2 >> 2] = 0;
            d2 = d2 + 4 | 0;
          } while ((d2 | 0) < (e3 | 0));
          a2[b3 + 56 >> 0] = 1;
          return;
        }
        function pu() {
          return 1432;
        }
        function qu() {
          return ru() | 0;
        }
        function ru() {
          var a3 = 0, b3 = 0, d2 = 0, e3 = 0, f2 = 0, g3 = 0, h2 = 0, i4 = 0;
          h2 = l2;
          l2 = l2 + 16 | 0;
          a3 = h2 + 4 | 0;
          b3 = h2;
          d2 = jy(8) | 0;
          e3 = d2;
          f2 = qC(48) | 0;
          g3 = f2;
          i4 = g3 + 48 | 0;
          do {
            c2[g3 >> 2] = 0;
            g3 = g3 + 4 | 0;
          } while ((g3 | 0) < (i4 | 0));
          g3 = e3 + 4 | 0;
          c2[g3 >> 2] = f2;
          i4 = qC(8) | 0;
          g3 = c2[g3 >> 2] | 0;
          c2[b3 >> 2] = 0;
          c2[a3 >> 2] = c2[b3 >> 2];
          Ji(i4, g3, a3);
          c2[d2 >> 2] = i4;
          l2 = h2;
          return e3 | 0;
        }
        function su(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          c2[a3 >> 2] = tu() | 0;
          c2[a3 + 4 >> 2] = uu() | 0;
          c2[a3 + 12 >> 2] = b3;
          c2[a3 + 8 >> 2] = vu() | 0;
          c2[a3 + 32 >> 2] = 6;
          return;
        }
        function tu() {
          return 11704;
        }
        function uu() {
          return 1436;
        }
        function vu() {
          return cu() | 0;
        }
        function wu(a3, b3, c3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          c3 = c3 | 0;
          d2 = d2 | 0;
          if ((jr(d2, 896) | 0) == 512) {
            if (c3 | 0) {
              xu(c3);
              sC(c3);
            }
          } else if (b3 | 0)
            sC(b3);
          return;
        }
        function xu(a3) {
          a3 = a3 | 0;
          a3 = c2[a3 + 4 >> 2] | 0;
          if (a3 | 0)
            oC(a3);
          return;
        }
        function yu(a3) {
          a3 = a3 | 0;
          zu(a3, 4933);
          Au(a3) | 0;
          Bu(a3) | 0;
          return;
        }
        function zu(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          var d2 = 0;
          d2 = cv() | 0;
          c2[a3 >> 2] = d2;
          dv(d2, b3);
          Hv(c2[a3 >> 2] | 0);
          return;
        }
        function Au(a3) {
          a3 = a3 | 0;
          var b3 = 0;
          b3 = c2[a3 >> 2] | 0;
          At(b3, Su() | 0);
          return a3 | 0;
        }
        function Bu(a3) {
          a3 = a3 | 0;
          var b3 = 0;
          b3 = c2[a3 >> 2] | 0;
          At(b3, Cu() | 0);
          return a3 | 0;
        }
        function Cu() {
          var b3 = 0;
          if (!(a2[7920] | 0)) {
            Du(10452);
            Ha(58, 10452, o2 | 0) | 0;
            b3 = 7920;
            c2[b3 >> 2] = 1;
            c2[b3 + 4 >> 2] = 0;
          }
          if (!(si(10452) | 0))
            Du(10452);
          return 10452;
        }
        function Du(a3) {
          a3 = a3 | 0;
          Gu(a3);
          Gt(a3, 1);
          return;
        }
        function Eu(a3) {
          a3 = a3 | 0;
          Fu(a3 + 24 | 0);
          return;
        }
        function Fu(a3) {
          a3 = a3 | 0;
          var b3 = 0, d2 = 0, e3 = 0;
          d2 = c2[a3 >> 2] | 0;
          e3 = d2;
          if (d2 | 0) {
            a3 = a3 + 4 | 0;
            b3 = c2[a3 >> 2] | 0;
            if ((b3 | 0) != (d2 | 0))
              c2[a3 >> 2] = b3 + (~((b3 + -8 - e3 | 0) >>> 3) << 3);
            sC(d2);
          }
          return;
        }
        function Gu(a3) {
          a3 = a3 | 0;
          var b3 = 0;
          b3 = vi() | 0;
          yi(a3, 5, 1, b3, Lu() | 0, 2);
          c2[a3 + 24 >> 2] = 0;
          c2[a3 + 28 >> 2] = 0;
          c2[a3 + 32 >> 2] = 0;
          return;
        }
        function Hu(a3, b3, c3) {
          a3 = a3 | 0;
          b3 = +b3;
          c3 = +c3;
          Iu(a3, b3, c3);
          return;
        }
        function Iu(a3, b3, c3) {
          a3 = a3 | 0;
          b3 = +b3;
          c3 = +c3;
          var d2 = 0, e3 = 0, f2 = 0, g3 = 0, i4 = 0;
          d2 = l2;
          l2 = l2 + 32 | 0;
          f2 = d2 + 8 | 0;
          i4 = d2 + 17 | 0;
          e3 = d2;
          g3 = d2 + 16 | 0;
          rj(i4, b3);
          h[f2 >> 3] = +sj(i4, b3);
          rj(g3, c3);
          h[e3 >> 3] = +sj(g3, c3);
          Ju(a3, f2, e3);
          l2 = d2;
          return;
        }
        function Ju(b3, c3, d2) {
          b3 = b3 | 0;
          c3 = c3 | 0;
          d2 = d2 | 0;
          Ku(b3 + 8 | 0, +h[c3 >> 3], +h[d2 >> 3]);
          a2[b3 + 24 >> 0] = 1;
          return;
        }
        function Ku(a3, b3, c3) {
          a3 = a3 | 0;
          b3 = +b3;
          c3 = +c3;
          h[a3 >> 3] = b3;
          h[a3 + 8 >> 3] = c3;
          return;
        }
        function Lu() {
          return 1472;
        }
        function Mu(a3, b3) {
          a3 = +a3;
          b3 = +b3;
          return Nu(a3, b3) | 0;
        }
        function Nu(a3, b3) {
          a3 = +a3;
          b3 = +b3;
          var d2 = 0, e3 = 0, f2 = 0, g3 = 0, h2 = 0, i4 = 0, j2 = 0;
          e3 = l2;
          l2 = l2 + 16 | 0;
          h2 = e3 + 4 | 0;
          i4 = e3 + 8 | 0;
          j2 = e3;
          f2 = jy(8) | 0;
          d2 = f2;
          g3 = qC(16) | 0;
          rj(h2, a3);
          a3 = +sj(h2, a3);
          rj(i4, b3);
          Ku(g3, a3, +sj(i4, b3));
          i4 = d2 + 4 | 0;
          c2[i4 >> 2] = g3;
          g3 = qC(8) | 0;
          i4 = c2[i4 >> 2] | 0;
          c2[j2 >> 2] = 0;
          c2[h2 >> 2] = c2[j2 >> 2];
          Ou(g3, i4, h2);
          c2[f2 >> 2] = g3;
          l2 = e3;
          return d2 | 0;
        }
        function Ou(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          c2[a3 >> 2] = b3;
          d2 = qC(16) | 0;
          c2[d2 + 4 >> 2] = 0;
          c2[d2 + 8 >> 2] = 0;
          c2[d2 >> 2] = 1452;
          c2[d2 + 12 >> 2] = b3;
          c2[a3 + 4 >> 2] = d2;
          return;
        }
        function Pu(a3) {
          a3 = a3 | 0;
          kC(a3);
          sC(a3);
          return;
        }
        function Qu(a3) {
          a3 = a3 | 0;
          a3 = c2[a3 + 12 >> 2] | 0;
          if (a3 | 0)
            sC(a3);
          return;
        }
        function Ru(a3) {
          a3 = a3 | 0;
          sC(a3);
          return;
        }
        function Su() {
          var b3 = 0;
          if (!(a2[7928] | 0)) {
            Tu(10488);
            Ha(59, 10488, o2 | 0) | 0;
            b3 = 7928;
            c2[b3 >> 2] = 1;
            c2[b3 + 4 >> 2] = 0;
          }
          if (!(si(10488) | 0))
            Tu(10488);
          return 10488;
        }
        function Tu(a3) {
          a3 = a3 | 0;
          Wu(a3);
          Gt(a3, 60);
          return;
        }
        function Uu(a3) {
          a3 = a3 | 0;
          Vu(a3 + 24 | 0);
          return;
        }
        function Vu(a3) {
          a3 = a3 | 0;
          var b3 = 0, d2 = 0, e3 = 0;
          d2 = c2[a3 >> 2] | 0;
          e3 = d2;
          if (d2 | 0) {
            a3 = a3 + 4 | 0;
            b3 = c2[a3 >> 2] | 0;
            if ((b3 | 0) != (d2 | 0))
              c2[a3 >> 2] = b3 + (~((b3 + -8 - e3 | 0) >>> 3) << 3);
            sC(d2);
          }
          return;
        }
        function Wu(a3) {
          a3 = a3 | 0;
          var b3 = 0;
          b3 = vi() | 0;
          yi(a3, 5, 6, b3, $u() | 0, 0);
          c2[a3 + 24 >> 2] = 0;
          c2[a3 + 28 >> 2] = 0;
          c2[a3 + 32 >> 2] = 0;
          return;
        }
        function Xu(a3) {
          a3 = a3 | 0;
          Yu(a3);
          return;
        }
        function Yu(a3) {
          a3 = a3 | 0;
          Zu(a3);
          return;
        }
        function Zu(b3) {
          b3 = b3 | 0;
          _u(b3 + 8 | 0);
          a2[b3 + 24 >> 0] = 1;
          return;
        }
        function _u(a3) {
          a3 = a3 | 0;
          c2[a3 >> 2] = 0;
          c2[a3 + 4 >> 2] = 0;
          c2[a3 + 8 >> 2] = 0;
          c2[a3 + 12 >> 2] = 0;
          return;
        }
        function $u() {
          return 1492;
        }
        function av() {
          return bv() | 0;
        }
        function bv() {
          var a3 = 0, b3 = 0, d2 = 0, e3 = 0, f2 = 0, g3 = 0, h2 = 0;
          b3 = l2;
          l2 = l2 + 16 | 0;
          f2 = b3 + 4 | 0;
          h2 = b3;
          d2 = jy(8) | 0;
          a3 = d2;
          e3 = qC(16) | 0;
          _u(e3);
          g3 = a3 + 4 | 0;
          c2[g3 >> 2] = e3;
          e3 = qC(8) | 0;
          g3 = c2[g3 >> 2] | 0;
          c2[h2 >> 2] = 0;
          c2[f2 >> 2] = c2[h2 >> 2];
          Ou(e3, g3, f2);
          c2[d2 >> 2] = e3;
          l2 = b3;
          return a3 | 0;
        }
        function cv() {
          var b3 = 0;
          if (!(a2[7936] | 0)) {
            jv(10524);
            Ha(25, 10524, o2 | 0) | 0;
            b3 = 7936;
            c2[b3 >> 2] = 1;
            c2[b3 + 4 >> 2] = 0;
          }
          return 10524;
        }
        function dv(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          c2[a3 >> 2] = ev() | 0;
          c2[a3 + 4 >> 2] = fv() | 0;
          c2[a3 + 12 >> 2] = b3;
          c2[a3 + 8 >> 2] = gv() | 0;
          c2[a3 + 32 >> 2] = 7;
          return;
        }
        function ev() {
          return 11700;
        }
        function fv() {
          return 1484;
        }
        function gv() {
          return cu() | 0;
        }
        function hv(a3, b3, c3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          c3 = c3 | 0;
          d2 = d2 | 0;
          if ((jr(d2, 896) | 0) == 512) {
            if (c3 | 0) {
              iv(c3);
              sC(c3);
            }
          } else if (b3 | 0)
            sC(b3);
          return;
        }
        function iv(a3) {
          a3 = a3 | 0;
          a3 = c2[a3 + 4 >> 2] | 0;
          if (a3 | 0)
            oC(a3);
          return;
        }
        function jv(a3) {
          a3 = a3 | 0;
          Zi(a3);
          return;
        }
        function kv(a3, b3, c3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          c3 = c3 | 0;
          a3 = ai(b3) | 0;
          b3 = lv(c3) | 0;
          c3 = mv(c3, 0) | 0;
          Zv(a3, b3, c3, nv() | 0, 0);
          return;
        }
        function lv(a3) {
          a3 = a3 | 0;
          return a3 | 0;
        }
        function mv(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          var d2 = 0, e3 = 0, f2 = 0, g3 = 0, h2 = 0, i4 = 0, j2 = 0;
          i4 = l2;
          l2 = l2 + 16 | 0;
          f2 = i4;
          g3 = i4 + 4 | 0;
          c2[f2 >> 2] = a3;
          j2 = nv() | 0;
          h2 = j2 + 24 | 0;
          b3 = ji(b3, 4) | 0;
          c2[g3 >> 2] = b3;
          d2 = j2 + 28 | 0;
          e3 = c2[d2 >> 2] | 0;
          if (e3 >>> 0 < (c2[j2 + 32 >> 2] | 0) >>> 0) {
            vv(e3, a3, b3);
            b3 = (c2[d2 >> 2] | 0) + 8 | 0;
            c2[d2 >> 2] = b3;
          } else {
            wv(h2, f2, g3);
            b3 = c2[d2 >> 2] | 0;
          }
          l2 = i4;
          return (b3 - (c2[h2 >> 2] | 0) >> 3) + -1 | 0;
        }
        function nv() {
          var b3 = 0, d2 = 0;
          if (!(a2[7944] | 0)) {
            ov(10568);
            Ha(61, 10568, o2 | 0) | 0;
            d2 = 7944;
            c2[d2 >> 2] = 1;
            c2[d2 + 4 >> 2] = 0;
          }
          if (!(si(10568) | 0)) {
            b3 = 10568;
            d2 = b3 + 36 | 0;
            do {
              c2[b3 >> 2] = 0;
              b3 = b3 + 4 | 0;
            } while ((b3 | 0) < (d2 | 0));
            ov(10568);
          }
          return 10568;
        }
        function ov(a3) {
          a3 = a3 | 0;
          rv(a3);
          return;
        }
        function pv(a3) {
          a3 = a3 | 0;
          qv(a3 + 24 | 0);
          return;
        }
        function qv(a3) {
          a3 = a3 | 0;
          var b3 = 0, d2 = 0, e3 = 0;
          d2 = c2[a3 >> 2] | 0;
          e3 = d2;
          if (d2 | 0) {
            a3 = a3 + 4 | 0;
            b3 = c2[a3 >> 2] | 0;
            if ((b3 | 0) != (d2 | 0))
              c2[a3 >> 2] = b3 + (~((b3 + -8 - e3 | 0) >>> 3) << 3);
            sC(d2);
          }
          return;
        }
        function rv(a3) {
          a3 = a3 | 0;
          var b3 = 0;
          b3 = vi() | 0;
          yi(a3, 1, 17, b3, ql() | 0, 0);
          c2[a3 + 24 >> 2] = 0;
          c2[a3 + 28 >> 2] = 0;
          c2[a3 + 32 >> 2] = 0;
          return;
        }
        function sv(a3) {
          a3 = a3 | 0;
          return uv(c2[(tv(a3) | 0) >> 2] | 0) | 0;
        }
        function tv(a3) {
          a3 = a3 | 0;
          return (c2[(nv() | 0) + 24 >> 2] | 0) + (a3 << 3) | 0;
        }
        function uv(a3) {
          a3 = a3 | 0;
          return ul(Ab[a3 & 7]() | 0) | 0;
        }
        function vv(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          c2[a3 >> 2] = b3;
          c2[a3 + 4 >> 2] = d2;
          return;
        }
        function wv(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          var e3 = 0, f2 = 0, g3 = 0, h2 = 0, i4 = 0, j2 = 0, k2 = 0, m2 = 0;
          i4 = l2;
          l2 = l2 + 32 | 0;
          f2 = i4;
          g3 = a3 + 4 | 0;
          h2 = ((c2[g3 >> 2] | 0) - (c2[a3 >> 2] | 0) >> 3) + 1 | 0;
          e3 = xv(a3) | 0;
          if (e3 >>> 0 < h2 >>> 0)
            jC(a3);
          else {
            j2 = c2[a3 >> 2] | 0;
            m2 = (c2[a3 + 8 >> 2] | 0) - j2 | 0;
            k2 = m2 >> 2;
            yv(f2, m2 >> 3 >>> 0 < e3 >>> 1 >>> 0 ? k2 >>> 0 < h2 >>> 0 ? h2 : k2 : e3, (c2[g3 >> 2] | 0) - j2 >> 3, a3 + 8 | 0);
            h2 = f2 + 8 | 0;
            vv(c2[h2 >> 2] | 0, c2[b3 >> 2] | 0, c2[d2 >> 2] | 0);
            c2[h2 >> 2] = (c2[h2 >> 2] | 0) + 8;
            zv(a3, f2);
            Av(f2);
            l2 = i4;
            return;
          }
        }
        function xv(a3) {
          a3 = a3 | 0;
          return 536870911;
        }
        function yv(a3, b3, d2, e3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          e3 = e3 | 0;
          var f2 = 0;
          c2[a3 + 12 >> 2] = 0;
          c2[a3 + 16 >> 2] = e3;
          do
            if (b3) {
              if (b3 >>> 0 > 536870911)
                Ta();
              else {
                f2 = qC(b3 << 3) | 0;
                break;
              }
            } else
              f2 = 0;
          while (0);
          c2[a3 >> 2] = f2;
          e3 = f2 + (d2 << 3) | 0;
          c2[a3 + 8 >> 2] = e3;
          c2[a3 + 4 >> 2] = e3;
          c2[a3 + 12 >> 2] = f2 + (b3 << 3);
          return;
        }
        function zv(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          var d2 = 0, e3 = 0, f2 = 0, g3 = 0, h2 = 0;
          e3 = c2[a3 >> 2] | 0;
          h2 = a3 + 4 | 0;
          g3 = b3 + 4 | 0;
          f2 = (c2[h2 >> 2] | 0) - e3 | 0;
          d2 = (c2[g3 >> 2] | 0) + (0 - (f2 >> 3) << 3) | 0;
          c2[g3 >> 2] = d2;
          if ((f2 | 0) > 0) {
            BC(d2 | 0, e3 | 0, f2 | 0) | 0;
            e3 = g3;
            d2 = c2[g3 >> 2] | 0;
          } else
            e3 = g3;
          g3 = c2[a3 >> 2] | 0;
          c2[a3 >> 2] = d2;
          c2[e3 >> 2] = g3;
          g3 = b3 + 8 | 0;
          f2 = c2[h2 >> 2] | 0;
          c2[h2 >> 2] = c2[g3 >> 2];
          c2[g3 >> 2] = f2;
          g3 = a3 + 8 | 0;
          h2 = b3 + 12 | 0;
          a3 = c2[g3 >> 2] | 0;
          c2[g3 >> 2] = c2[h2 >> 2];
          c2[h2 >> 2] = a3;
          c2[b3 >> 2] = c2[e3 >> 2];
          return;
        }
        function Av(a3) {
          a3 = a3 | 0;
          var b3 = 0, d2 = 0, e3 = 0;
          b3 = c2[a3 + 4 >> 2] | 0;
          d2 = a3 + 8 | 0;
          e3 = c2[d2 >> 2] | 0;
          if ((e3 | 0) != (b3 | 0))
            c2[d2 >> 2] = e3 + (~((e3 + -8 - b3 | 0) >>> 3) << 3);
          a3 = c2[a3 >> 2] | 0;
          if (a3 | 0)
            sC(a3);
          return;
        }
        function Bv() {
          Cv();
          return;
        }
        function Cv() {
          Dv(10604);
          return;
        }
        function Dv(a3) {
          a3 = a3 | 0;
          Ev(a3, 4955);
          return;
        }
        function Ev(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          var d2 = 0;
          d2 = Fv() | 0;
          c2[a3 >> 2] = d2;
          Gv(d2, b3);
          Hv(c2[a3 >> 2] | 0);
          return;
        }
        function Fv() {
          var b3 = 0;
          if (!(a2[7952] | 0)) {
            Rv(10612);
            Ha(25, 10612, o2 | 0) | 0;
            b3 = 7952;
            c2[b3 >> 2] = 1;
            c2[b3 + 4 >> 2] = 0;
          }
          return 10612;
        }
        function Gv(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          c2[a3 >> 2] = Mv() | 0;
          c2[a3 + 4 >> 2] = Nv() | 0;
          c2[a3 + 12 >> 2] = b3;
          c2[a3 + 8 >> 2] = Ov() | 0;
          c2[a3 + 32 >> 2] = 8;
          return;
        }
        function Hv(a3) {
          a3 = a3 | 0;
          var b3 = 0, d2 = 0;
          b3 = l2;
          l2 = l2 + 16 | 0;
          d2 = b3;
          Iv() | 0;
          c2[d2 >> 2] = a3;
          Jv(10608, d2);
          l2 = b3;
          return;
        }
        function Iv() {
          if (!(a2[11714] | 0)) {
            c2[2652] = 0;
            Ha(62, 10608, o2 | 0) | 0;
            a2[11714] = 1;
          }
          return 10608;
        }
        function Jv(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          var d2 = 0;
          d2 = qC(8) | 0;
          c2[d2 + 4 >> 2] = c2[b3 >> 2];
          c2[d2 >> 2] = c2[a3 >> 2];
          c2[a3 >> 2] = d2;
          return;
        }
        function Kv(a3) {
          a3 = a3 | 0;
          Lv(a3);
          return;
        }
        function Lv(a3) {
          a3 = a3 | 0;
          var b3 = 0, d2 = 0;
          b3 = c2[a3 >> 2] | 0;
          if (b3 | 0)
            do {
              d2 = b3;
              b3 = c2[b3 >> 2] | 0;
              sC(d2);
            } while ((b3 | 0) != 0);
          c2[a3 >> 2] = 0;
          return;
        }
        function Mv() {
          return 11715;
        }
        function Nv() {
          return 1496;
        }
        function Ov() {
          return lr() | 0;
        }
        function Pv(a3, b3, c3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          c3 = c3 | 0;
          d2 = d2 | 0;
          if ((jr(d2, 896) | 0) == 512) {
            if (c3 | 0) {
              Qv(c3);
              sC(c3);
            }
          } else if (b3 | 0)
            sC(b3);
          return;
        }
        function Qv(a3) {
          a3 = a3 | 0;
          a3 = c2[a3 + 4 >> 2] | 0;
          if (a3 | 0)
            oC(a3);
          return;
        }
        function Rv(a3) {
          a3 = a3 | 0;
          Zi(a3);
          return;
        }
        function Sv(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          var d2 = 0, e3 = 0;
          Iv() | 0;
          d2 = c2[2652] | 0;
          a:
            do
              if (d2 | 0) {
                while (1) {
                  e3 = c2[d2 + 4 >> 2] | 0;
                  if (e3 | 0 ? (AB(Tv(e3) | 0, a3) | 0) == 0 : 0)
                    break;
                  d2 = c2[d2 >> 2] | 0;
                  if (!d2)
                    break a;
                }
                Uv(e3, b3);
              }
            while (0);
          return;
        }
        function Tv(a3) {
          a3 = a3 | 0;
          return c2[a3 + 12 >> 2] | 0;
        }
        function Uv(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          var d2 = 0;
          a3 = a3 + 36 | 0;
          d2 = c2[a3 >> 2] | 0;
          if (d2 | 0) {
            vf(d2);
            sC(d2);
          }
          d2 = qC(4) | 0;
          Og(d2, b3);
          c2[a3 >> 2] = d2;
          return;
        }
        function Vv() {
          if (!(a2[11716] | 0)) {
            c2[2664] = 0;
            Ha(63, 10656, o2 | 0) | 0;
            a2[11716] = 1;
          }
          return 10656;
        }
        function Wv() {
          var b3 = 0;
          if (!(a2[11717] | 0)) {
            Xv();
            c2[2665] = 1504;
            a2[11717] = 1;
            b3 = 1504;
          } else
            b3 = c2[2665] | 0;
          return b3 | 0;
        }
        function Xv() {
          if (!(a2[11740] | 0)) {
            a2[11718] = ji(ji(8, 0) | 0, 0) | 0;
            a2[11719] = ji(ji(0, 0) | 0, 0) | 0;
            a2[11720] = ji(ji(0, 16) | 0, 0) | 0;
            a2[11721] = ji(ji(8, 0) | 0, 0) | 0;
            a2[11722] = ji(ji(0, 0) | 0, 0) | 0;
            a2[11723] = ji(ji(8, 0) | 0, 0) | 0;
            a2[11724] = ji(ji(0, 0) | 0, 0) | 0;
            a2[11725] = ji(ji(8, 0) | 0, 0) | 0;
            a2[11726] = ji(ji(0, 0) | 0, 0) | 0;
            a2[11727] = ji(ji(8, 0) | 0, 0) | 0;
            a2[11728] = ji(ji(0, 0) | 0, 0) | 0;
            a2[11729] = ji(ji(0, 0) | 0, 32) | 0;
            a2[11730] = ji(ji(0, 0) | 0, 32) | 0;
            a2[11740] = 1;
          }
          return;
        }
        function Yv() {
          return 1572;
        }
        function Zv(a3, b3, d2, e3, f2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          e3 = e3 | 0;
          f2 = f2 | 0;
          var g3 = 0, h2 = 0, i4 = 0, j2 = 0, k2 = 0, m2 = 0;
          g3 = l2;
          l2 = l2 + 32 | 0;
          m2 = g3 + 16 | 0;
          k2 = g3 + 12 | 0;
          j2 = g3 + 8 | 0;
          i4 = g3 + 4 | 0;
          h2 = g3;
          c2[m2 >> 2] = a3;
          c2[k2 >> 2] = b3;
          c2[j2 >> 2] = d2;
          c2[i4 >> 2] = e3;
          c2[h2 >> 2] = f2;
          Vv() | 0;
          _v(10656, m2, k2, j2, i4, h2);
          l2 = g3;
          return;
        }
        function _v(a3, b3, d2, e3, f2, g3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          e3 = e3 | 0;
          f2 = f2 | 0;
          g3 = g3 | 0;
          var h2 = 0;
          h2 = qC(24) | 0;
          ii(h2 + 4 | 0, c2[b3 >> 2] | 0, c2[d2 >> 2] | 0, c2[e3 >> 2] | 0, c2[f2 >> 2] | 0, c2[g3 >> 2] | 0);
          c2[h2 >> 2] = c2[a3 >> 2];
          c2[a3 >> 2] = h2;
          return;
        }
        function $v(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          var e3 = 0, f2 = 0, g3 = 0, h2 = 0, i4 = 0, j2 = 0, k2 = 0, m2 = 0, n3 = 0, o3 = 0, p2 = 0, q2 = 0, r3 = 0, s3 = 0, t3 = 0, u3 = 0;
          u3 = l2;
          l2 = l2 + 32 | 0;
          q2 = u3 + 20 | 0;
          r3 = u3 + 8 | 0;
          s3 = u3 + 4 | 0;
          t3 = u3;
          b3 = c2[b3 >> 2] | 0;
          if (b3 | 0) {
            p2 = q2 + 4 | 0;
            j2 = q2 + 8 | 0;
            k2 = r3 + 4 | 0;
            m2 = r3 + 8 | 0;
            n3 = r3 + 8 | 0;
            o3 = q2 + 8 | 0;
            do {
              h2 = b3 + 4 | 0;
              i4 = aw(h2) | 0;
              if (i4 | 0) {
                f2 = bw(i4) | 0;
                c2[q2 >> 2] = 0;
                c2[p2 >> 2] = 0;
                c2[j2 >> 2] = 0;
                e3 = (cw(i4) | 0) + 1 | 0;
                dw(q2, e3);
                if (e3 | 0)
                  while (1) {
                    e3 = e3 + -1 | 0;
                    OA(r3, c2[f2 >> 2] | 0);
                    g3 = c2[p2 >> 2] | 0;
                    if (g3 >>> 0 < (c2[o3 >> 2] | 0) >>> 0) {
                      c2[g3 >> 2] = c2[r3 >> 2];
                      c2[p2 >> 2] = (c2[p2 >> 2] | 0) + 4;
                    } else
                      ew(q2, r3);
                    if (!e3)
                      break;
                    else
                      f2 = f2 + 4 | 0;
                  }
                e3 = fw(i4) | 0;
                c2[r3 >> 2] = 0;
                c2[k2 >> 2] = 0;
                c2[m2 >> 2] = 0;
                a:
                  do
                    if (c2[e3 >> 2] | 0) {
                      f2 = 0;
                      g3 = 0;
                      while (1) {
                        if ((f2 | 0) == (g3 | 0))
                          gw(r3, e3);
                        else {
                          c2[f2 >> 2] = c2[e3 >> 2];
                          c2[k2 >> 2] = (c2[k2 >> 2] | 0) + 4;
                        }
                        e3 = e3 + 4 | 0;
                        if (!(c2[e3 >> 2] | 0))
                          break a;
                        f2 = c2[k2 >> 2] | 0;
                        g3 = c2[n3 >> 2] | 0;
                      }
                    }
                  while (0);
                c2[s3 >> 2] = hw(h2) | 0;
                c2[t3 >> 2] = si(i4) | 0;
                iw(d2, a3, s3, t3, q2, r3);
                jw(r3);
                kw(q2);
              }
              b3 = c2[b3 >> 2] | 0;
            } while ((b3 | 0) != 0);
          }
          l2 = u3;
          return;
        }
        function aw(a3) {
          a3 = a3 | 0;
          return c2[a3 + 12 >> 2] | 0;
        }
        function bw(a3) {
          a3 = a3 | 0;
          return c2[a3 + 12 >> 2] | 0;
        }
        function cw(a3) {
          a3 = a3 | 0;
          return c2[a3 + 16 >> 2] | 0;
        }
        function dw(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          var d2 = 0, e3 = 0, f2 = 0;
          f2 = l2;
          l2 = l2 + 32 | 0;
          d2 = f2;
          e3 = c2[a3 >> 2] | 0;
          if ((c2[a3 + 8 >> 2] | 0) - e3 >> 2 >>> 0 < b3 >>> 0) {
            Rw(d2, b3, (c2[a3 + 4 >> 2] | 0) - e3 >> 2, a3 + 8 | 0);
            Sw(a3, d2);
            Tw(d2);
          }
          l2 = f2;
          return;
        }
        function ew(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          var d2 = 0, e3 = 0, f2 = 0, g3 = 0, h2 = 0, i4 = 0, j2 = 0, k2 = 0;
          h2 = l2;
          l2 = l2 + 32 | 0;
          d2 = h2;
          e3 = a3 + 4 | 0;
          f2 = ((c2[e3 >> 2] | 0) - (c2[a3 >> 2] | 0) >> 2) + 1 | 0;
          g3 = Nw(a3) | 0;
          if (g3 >>> 0 < f2 >>> 0)
            jC(a3);
          else {
            i4 = c2[a3 >> 2] | 0;
            k2 = (c2[a3 + 8 >> 2] | 0) - i4 | 0;
            j2 = k2 >> 1;
            Rw(d2, k2 >> 2 >>> 0 < g3 >>> 1 >>> 0 ? j2 >>> 0 < f2 >>> 0 ? f2 : j2 : g3, (c2[e3 >> 2] | 0) - i4 >> 2, a3 + 8 | 0);
            g3 = d2 + 8 | 0;
            c2[c2[g3 >> 2] >> 2] = c2[b3 >> 2];
            c2[g3 >> 2] = (c2[g3 >> 2] | 0) + 4;
            Sw(a3, d2);
            Tw(d2);
            l2 = h2;
            return;
          }
        }
        function fw(a3) {
          a3 = a3 | 0;
          return c2[a3 + 8 >> 2] | 0;
        }
        function gw(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          var d2 = 0, e3 = 0, f2 = 0, g3 = 0, h2 = 0, i4 = 0, j2 = 0, k2 = 0;
          h2 = l2;
          l2 = l2 + 32 | 0;
          d2 = h2;
          e3 = a3 + 4 | 0;
          f2 = ((c2[e3 >> 2] | 0) - (c2[a3 >> 2] | 0) >> 2) + 1 | 0;
          g3 = Kw(a3) | 0;
          if (g3 >>> 0 < f2 >>> 0)
            jC(a3);
          else {
            i4 = c2[a3 >> 2] | 0;
            k2 = (c2[a3 + 8 >> 2] | 0) - i4 | 0;
            j2 = k2 >> 1;
            Ow(d2, k2 >> 2 >>> 0 < g3 >>> 1 >>> 0 ? j2 >>> 0 < f2 >>> 0 ? f2 : j2 : g3, (c2[e3 >> 2] | 0) - i4 >> 2, a3 + 8 | 0);
            g3 = d2 + 8 | 0;
            c2[c2[g3 >> 2] >> 2] = c2[b3 >> 2];
            c2[g3 >> 2] = (c2[g3 >> 2] | 0) + 4;
            Pw(a3, d2);
            Qw(d2);
            l2 = h2;
            return;
          }
        }
        function hw(a3) {
          a3 = a3 | 0;
          return c2[a3 >> 2] | 0;
        }
        function iw(a3, b3, c3, d2, e3, f2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          c3 = c3 | 0;
          d2 = d2 | 0;
          e3 = e3 | 0;
          f2 = f2 | 0;
          lw(a3, b3, c3, d2, e3, f2);
          return;
        }
        function jw(a3) {
          a3 = a3 | 0;
          var b3 = 0, d2 = 0, e3 = 0;
          d2 = c2[a3 >> 2] | 0;
          e3 = d2;
          if (d2 | 0) {
            a3 = a3 + 4 | 0;
            b3 = c2[a3 >> 2] | 0;
            if ((b3 | 0) != (d2 | 0))
              c2[a3 >> 2] = b3 + (~((b3 + -4 - e3 | 0) >>> 2) << 2);
            sC(d2);
          }
          return;
        }
        function kw(a3) {
          a3 = a3 | 0;
          var b3 = 0, d2 = 0, e3 = 0;
          d2 = c2[a3 >> 2] | 0;
          e3 = d2;
          if (d2 | 0) {
            a3 = a3 + 4 | 0;
            b3 = c2[a3 >> 2] | 0;
            if ((b3 | 0) != (d2 | 0))
              c2[a3 >> 2] = b3 + (~((b3 + -4 - e3 | 0) >>> 2) << 2);
            sC(d2);
          }
          return;
        }
        function lw(a3, b3, d2, e3, f2, g3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          e3 = e3 | 0;
          f2 = f2 | 0;
          g3 = g3 | 0;
          var h2 = 0, i4 = 0, j2 = 0, k2 = 0, m2 = 0, n3 = 0;
          h2 = l2;
          l2 = l2 + 48 | 0;
          m2 = h2 + 40 | 0;
          i4 = h2 + 32 | 0;
          n3 = h2 + 24 | 0;
          j2 = h2 + 12 | 0;
          k2 = h2;
          UA(i4);
          a3 = Sg(a3) | 0;
          c2[n3 >> 2] = c2[b3 >> 2];
          d2 = c2[d2 >> 2] | 0;
          e3 = c2[e3 >> 2] | 0;
          mw(j2, f2);
          nw(k2, g3);
          c2[m2 >> 2] = c2[n3 >> 2];
          ow(a3, m2, d2, e3, j2, k2);
          jw(k2);
          kw(j2);
          WA(i4);
          l2 = h2;
          return;
        }
        function mw(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          var d2 = 0, e3 = 0;
          c2[a3 >> 2] = 0;
          c2[a3 + 4 >> 2] = 0;
          c2[a3 + 8 >> 2] = 0;
          d2 = b3 + 4 | 0;
          e3 = (c2[d2 >> 2] | 0) - (c2[b3 >> 2] | 0) >> 2;
          if (e3 | 0) {
            Lw(a3, e3);
            Mw(a3, c2[b3 >> 2] | 0, c2[d2 >> 2] | 0, e3);
          }
          return;
        }
        function nw(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          var d2 = 0, e3 = 0;
          c2[a3 >> 2] = 0;
          c2[a3 + 4 >> 2] = 0;
          c2[a3 + 8 >> 2] = 0;
          d2 = b3 + 4 | 0;
          e3 = (c2[d2 >> 2] | 0) - (c2[b3 >> 2] | 0) >> 2;
          if (e3 | 0) {
            Iw(a3, e3);
            Jw(a3, c2[b3 >> 2] | 0, c2[d2 >> 2] | 0, e3);
          }
          return;
        }
        function ow(a3, b3, d2, e3, f2, g3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          e3 = e3 | 0;
          f2 = f2 | 0;
          g3 = g3 | 0;
          var h2 = 0, i4 = 0, j2 = 0, k2 = 0, m2 = 0, n3 = 0;
          h2 = l2;
          l2 = l2 + 32 | 0;
          m2 = h2 + 28 | 0;
          n3 = h2 + 24 | 0;
          i4 = h2 + 12 | 0;
          j2 = h2;
          k2 = Vg(pw() | 0) | 0;
          c2[n3 >> 2] = c2[b3 >> 2];
          c2[m2 >> 2] = c2[n3 >> 2];
          b3 = qw(m2) | 0;
          d2 = rw(d2) | 0;
          e3 = sw(e3) | 0;
          c2[i4 >> 2] = c2[f2 >> 2];
          m2 = f2 + 4 | 0;
          c2[i4 + 4 >> 2] = c2[m2 >> 2];
          n3 = f2 + 8 | 0;
          c2[i4 + 8 >> 2] = c2[n3 >> 2];
          c2[n3 >> 2] = 0;
          c2[m2 >> 2] = 0;
          c2[f2 >> 2] = 0;
          f2 = tw(i4) | 0;
          c2[j2 >> 2] = c2[g3 >> 2];
          m2 = g3 + 4 | 0;
          c2[j2 + 4 >> 2] = c2[m2 >> 2];
          n3 = g3 + 8 | 0;
          c2[j2 + 8 >> 2] = c2[n3 >> 2];
          c2[n3 >> 2] = 0;
          c2[m2 >> 2] = 0;
          c2[g3 >> 2] = 0;
          Ba(0, k2 | 0, a3 | 0, b3 | 0, d2 | 0, e3 | 0, f2 | 0, uw(j2) | 0) | 0;
          jw(j2);
          kw(i4);
          l2 = h2;
          return;
        }
        function pw() {
          var b3 = 0;
          if (!(a2[7968] | 0)) {
            Gw(10708);
            b3 = 7968;
            c2[b3 >> 2] = 1;
            c2[b3 + 4 >> 2] = 0;
          }
          return 10708;
        }
        function qw(a3) {
          a3 = a3 | 0;
          return yw(a3) | 0;
        }
        function rw(a3) {
          a3 = a3 | 0;
          return ww(a3) | 0;
        }
        function sw(a3) {
          a3 = a3 | 0;
          return ul(a3) | 0;
        }
        function tw(a3) {
          a3 = a3 | 0;
          return xw(a3) | 0;
        }
        function uw(a3) {
          a3 = a3 | 0;
          return vw(a3) | 0;
        }
        function vw(a3) {
          a3 = a3 | 0;
          var b3 = 0, d2 = 0, e3 = 0;
          e3 = (c2[a3 + 4 >> 2] | 0) - (c2[a3 >> 2] | 0) | 0;
          d2 = e3 >> 2;
          e3 = jy(e3 + 4 | 0) | 0;
          c2[e3 >> 2] = d2;
          if (d2 | 0) {
            b3 = 0;
            do {
              c2[e3 + 4 + (b3 << 2) >> 2] = ww(c2[(c2[a3 >> 2] | 0) + (b3 << 2) >> 2] | 0) | 0;
              b3 = b3 + 1 | 0;
            } while ((b3 | 0) != (d2 | 0));
          }
          return e3 | 0;
        }
        function ww(a3) {
          a3 = a3 | 0;
          return a3 | 0;
        }
        function xw(a3) {
          a3 = a3 | 0;
          var b3 = 0, d2 = 0, e3 = 0;
          e3 = (c2[a3 + 4 >> 2] | 0) - (c2[a3 >> 2] | 0) | 0;
          d2 = e3 >> 2;
          e3 = jy(e3 + 4 | 0) | 0;
          c2[e3 >> 2] = d2;
          if (d2 | 0) {
            b3 = 0;
            do {
              c2[e3 + 4 + (b3 << 2) >> 2] = yw((c2[a3 >> 2] | 0) + (b3 << 2) | 0) | 0;
              b3 = b3 + 1 | 0;
            } while ((b3 | 0) != (d2 | 0));
          }
          return e3 | 0;
        }
        function yw(a3) {
          a3 = a3 | 0;
          var b3 = 0, c3 = 0, d2 = 0, e3 = 0;
          e3 = l2;
          l2 = l2 + 32 | 0;
          b3 = e3 + 12 | 0;
          c3 = e3;
          d2 = Di(zw() | 0) | 0;
          if (!d2)
            a3 = Aw(a3) | 0;
          else {
            Ei(b3, d2);
            Fi(c3, b3);
            RA(a3, c3);
            a3 = Hi(b3) | 0;
          }
          l2 = e3;
          return a3 | 0;
        }
        function zw() {
          var b3 = 0;
          if (!(a2[7960] | 0)) {
            Fw(10664);
            Ha(25, 10664, o2 | 0) | 0;
            b3 = 7960;
            c2[b3 >> 2] = 1;
            c2[b3 + 4 >> 2] = 0;
          }
          return 10664;
        }
        function Aw(a3) {
          a3 = a3 | 0;
          var b3 = 0, d2 = 0, e3 = 0, f2 = 0, g3 = 0, h2 = 0, i4 = 0;
          d2 = l2;
          l2 = l2 + 16 | 0;
          f2 = d2 + 4 | 0;
          h2 = d2;
          e3 = jy(8) | 0;
          b3 = e3;
          i4 = qC(4) | 0;
          c2[i4 >> 2] = c2[a3 >> 2];
          g3 = b3 + 4 | 0;
          c2[g3 >> 2] = i4;
          a3 = qC(8) | 0;
          g3 = c2[g3 >> 2] | 0;
          c2[h2 >> 2] = 0;
          c2[f2 >> 2] = c2[h2 >> 2];
          Bw(a3, g3, f2);
          c2[e3 >> 2] = a3;
          l2 = d2;
          return b3 | 0;
        }
        function Bw(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          c2[a3 >> 2] = b3;
          d2 = qC(16) | 0;
          c2[d2 + 4 >> 2] = 0;
          c2[d2 + 8 >> 2] = 0;
          c2[d2 >> 2] = 1656;
          c2[d2 + 12 >> 2] = b3;
          c2[a3 + 4 >> 2] = d2;
          return;
        }
        function Cw(a3) {
          a3 = a3 | 0;
          kC(a3);
          sC(a3);
          return;
        }
        function Dw(a3) {
          a3 = a3 | 0;
          a3 = c2[a3 + 12 >> 2] | 0;
          if (a3 | 0)
            sC(a3);
          return;
        }
        function Ew(a3) {
          a3 = a3 | 0;
          sC(a3);
          return;
        }
        function Fw(a3) {
          a3 = a3 | 0;
          Zi(a3);
          return;
        }
        function Gw(a3) {
          a3 = a3 | 0;
          fh(a3, Hw() | 0, 5);
          return;
        }
        function Hw() {
          return 1676;
        }
        function Iw(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          var d2 = 0;
          if ((Kw(a3) | 0) >>> 0 < b3 >>> 0)
            jC(a3);
          if (b3 >>> 0 > 1073741823)
            Ta();
          else {
            d2 = qC(b3 << 2) | 0;
            c2[a3 + 4 >> 2] = d2;
            c2[a3 >> 2] = d2;
            c2[a3 + 8 >> 2] = d2 + (b3 << 2);
            return;
          }
        }
        function Jw(a3, b3, d2, e3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          e3 = e3 | 0;
          e3 = a3 + 4 | 0;
          a3 = d2 - b3 | 0;
          if ((a3 | 0) > 0) {
            BC(c2[e3 >> 2] | 0, b3 | 0, a3 | 0) | 0;
            c2[e3 >> 2] = (c2[e3 >> 2] | 0) + (a3 >>> 2 << 2);
          }
          return;
        }
        function Kw(a3) {
          a3 = a3 | 0;
          return 1073741823;
        }
        function Lw(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          var d2 = 0;
          if ((Nw(a3) | 0) >>> 0 < b3 >>> 0)
            jC(a3);
          if (b3 >>> 0 > 1073741823)
            Ta();
          else {
            d2 = qC(b3 << 2) | 0;
            c2[a3 + 4 >> 2] = d2;
            c2[a3 >> 2] = d2;
            c2[a3 + 8 >> 2] = d2 + (b3 << 2);
            return;
          }
        }
        function Mw(a3, b3, d2, e3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          e3 = e3 | 0;
          e3 = a3 + 4 | 0;
          a3 = d2 - b3 | 0;
          if ((a3 | 0) > 0) {
            BC(c2[e3 >> 2] | 0, b3 | 0, a3 | 0) | 0;
            c2[e3 >> 2] = (c2[e3 >> 2] | 0) + (a3 >>> 2 << 2);
          }
          return;
        }
        function Nw(a3) {
          a3 = a3 | 0;
          return 1073741823;
        }
        function Ow(a3, b3, d2, e3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          e3 = e3 | 0;
          var f2 = 0;
          c2[a3 + 12 >> 2] = 0;
          c2[a3 + 16 >> 2] = e3;
          do
            if (b3) {
              if (b3 >>> 0 > 1073741823)
                Ta();
              else {
                f2 = qC(b3 << 2) | 0;
                break;
              }
            } else
              f2 = 0;
          while (0);
          c2[a3 >> 2] = f2;
          e3 = f2 + (d2 << 2) | 0;
          c2[a3 + 8 >> 2] = e3;
          c2[a3 + 4 >> 2] = e3;
          c2[a3 + 12 >> 2] = f2 + (b3 << 2);
          return;
        }
        function Pw(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          var d2 = 0, e3 = 0, f2 = 0, g3 = 0, h2 = 0;
          e3 = c2[a3 >> 2] | 0;
          h2 = a3 + 4 | 0;
          g3 = b3 + 4 | 0;
          f2 = (c2[h2 >> 2] | 0) - e3 | 0;
          d2 = (c2[g3 >> 2] | 0) + (0 - (f2 >> 2) << 2) | 0;
          c2[g3 >> 2] = d2;
          if ((f2 | 0) > 0) {
            BC(d2 | 0, e3 | 0, f2 | 0) | 0;
            e3 = g3;
            d2 = c2[g3 >> 2] | 0;
          } else
            e3 = g3;
          g3 = c2[a3 >> 2] | 0;
          c2[a3 >> 2] = d2;
          c2[e3 >> 2] = g3;
          g3 = b3 + 8 | 0;
          f2 = c2[h2 >> 2] | 0;
          c2[h2 >> 2] = c2[g3 >> 2];
          c2[g3 >> 2] = f2;
          g3 = a3 + 8 | 0;
          h2 = b3 + 12 | 0;
          a3 = c2[g3 >> 2] | 0;
          c2[g3 >> 2] = c2[h2 >> 2];
          c2[h2 >> 2] = a3;
          c2[b3 >> 2] = c2[e3 >> 2];
          return;
        }
        function Qw(a3) {
          a3 = a3 | 0;
          var b3 = 0, d2 = 0, e3 = 0;
          b3 = c2[a3 + 4 >> 2] | 0;
          d2 = a3 + 8 | 0;
          e3 = c2[d2 >> 2] | 0;
          if ((e3 | 0) != (b3 | 0))
            c2[d2 >> 2] = e3 + (~((e3 + -4 - b3 | 0) >>> 2) << 2);
          a3 = c2[a3 >> 2] | 0;
          if (a3 | 0)
            sC(a3);
          return;
        }
        function Rw(a3, b3, d2, e3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          e3 = e3 | 0;
          var f2 = 0;
          c2[a3 + 12 >> 2] = 0;
          c2[a3 + 16 >> 2] = e3;
          do
            if (b3) {
              if (b3 >>> 0 > 1073741823)
                Ta();
              else {
                f2 = qC(b3 << 2) | 0;
                break;
              }
            } else
              f2 = 0;
          while (0);
          c2[a3 >> 2] = f2;
          e3 = f2 + (d2 << 2) | 0;
          c2[a3 + 8 >> 2] = e3;
          c2[a3 + 4 >> 2] = e3;
          c2[a3 + 12 >> 2] = f2 + (b3 << 2);
          return;
        }
        function Sw(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          var d2 = 0, e3 = 0, f2 = 0, g3 = 0, h2 = 0;
          e3 = c2[a3 >> 2] | 0;
          h2 = a3 + 4 | 0;
          g3 = b3 + 4 | 0;
          f2 = (c2[h2 >> 2] | 0) - e3 | 0;
          d2 = (c2[g3 >> 2] | 0) + (0 - (f2 >> 2) << 2) | 0;
          c2[g3 >> 2] = d2;
          if ((f2 | 0) > 0) {
            BC(d2 | 0, e3 | 0, f2 | 0) | 0;
            e3 = g3;
            d2 = c2[g3 >> 2] | 0;
          } else
            e3 = g3;
          g3 = c2[a3 >> 2] | 0;
          c2[a3 >> 2] = d2;
          c2[e3 >> 2] = g3;
          g3 = b3 + 8 | 0;
          f2 = c2[h2 >> 2] | 0;
          c2[h2 >> 2] = c2[g3 >> 2];
          c2[g3 >> 2] = f2;
          g3 = a3 + 8 | 0;
          h2 = b3 + 12 | 0;
          a3 = c2[g3 >> 2] | 0;
          c2[g3 >> 2] = c2[h2 >> 2];
          c2[h2 >> 2] = a3;
          c2[b3 >> 2] = c2[e3 >> 2];
          return;
        }
        function Tw(a3) {
          a3 = a3 | 0;
          var b3 = 0, d2 = 0, e3 = 0;
          b3 = c2[a3 + 4 >> 2] | 0;
          d2 = a3 + 8 | 0;
          e3 = c2[d2 >> 2] | 0;
          if ((e3 | 0) != (b3 | 0))
            c2[d2 >> 2] = e3 + (~((e3 + -4 - b3 | 0) >>> 2) << 2);
          a3 = c2[a3 >> 2] | 0;
          if (a3 | 0)
            sC(a3);
          return;
        }
        function Uw(a3, b3, d2, e3, f2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          e3 = e3 | 0;
          f2 = f2 | 0;
          var g3 = 0, h2 = 0, i4 = 0, j2 = 0, k2 = 0, m2 = 0, n3 = 0, o3 = 0, p2 = 0, q2 = 0, r3 = 0;
          r3 = l2;
          l2 = l2 + 32 | 0;
          m2 = r3 + 20 | 0;
          n3 = r3 + 12 | 0;
          k2 = r3 + 16 | 0;
          o3 = r3 + 4 | 0;
          p2 = r3;
          q2 = r3 + 8 | 0;
          i4 = Wv() | 0;
          g3 = c2[i4 >> 2] | 0;
          h2 = c2[g3 >> 2] | 0;
          if (h2 | 0) {
            j2 = c2[i4 + 8 >> 2] | 0;
            i4 = c2[i4 + 4 >> 2] | 0;
            while (1) {
              OA(m2, h2);
              Vw(a3, m2, i4, j2);
              g3 = g3 + 4 | 0;
              h2 = c2[g3 >> 2] | 0;
              if (!h2)
                break;
              else {
                j2 = j2 + 1 | 0;
                i4 = i4 + 1 | 0;
              }
            }
          }
          g3 = Yv() | 0;
          h2 = c2[g3 >> 2] | 0;
          if (h2 | 0)
            do {
              OA(m2, h2);
              c2[n3 >> 2] = c2[g3 + 4 >> 2];
              Ww(b3, m2, n3);
              g3 = g3 + 8 | 0;
              h2 = c2[g3 >> 2] | 0;
            } while ((h2 | 0) != 0);
          g3 = c2[(Iv() | 0) >> 2] | 0;
          if (g3 | 0)
            do {
              b3 = c2[g3 + 4 >> 2] | 0;
              OA(m2, c2[(Xw(b3) | 0) >> 2] | 0);
              c2[n3 >> 2] = Tv(b3) | 0;
              Yw(d2, m2, n3);
              g3 = c2[g3 >> 2] | 0;
            } while ((g3 | 0) != 0);
          OA(k2, 0);
          g3 = Vv() | 0;
          c2[m2 >> 2] = c2[k2 >> 2];
          $v(m2, g3, f2);
          g3 = c2[(Iv() | 0) >> 2] | 0;
          if (g3 | 0) {
            a3 = m2 + 4 | 0;
            b3 = m2 + 8 | 0;
            d2 = m2 + 8 | 0;
            do {
              j2 = c2[g3 + 4 >> 2] | 0;
              OA(n3, c2[(Xw(j2) | 0) >> 2] | 0);
              _w(o3, Zw(j2) | 0);
              h2 = c2[o3 >> 2] | 0;
              if (h2 | 0) {
                c2[m2 >> 2] = 0;
                c2[a3 >> 2] = 0;
                c2[b3 >> 2] = 0;
                do {
                  OA(p2, c2[(Xw(c2[h2 + 4 >> 2] | 0) | 0) >> 2] | 0);
                  i4 = c2[a3 >> 2] | 0;
                  if (i4 >>> 0 < (c2[d2 >> 2] | 0) >>> 0) {
                    c2[i4 >> 2] = c2[p2 >> 2];
                    c2[a3 >> 2] = (c2[a3 >> 2] | 0) + 4;
                  } else
                    ew(m2, p2);
                  h2 = c2[h2 >> 2] | 0;
                } while ((h2 | 0) != 0);
                $w(e3, n3, m2);
                kw(m2);
              }
              c2[q2 >> 2] = c2[n3 >> 2];
              k2 = ax(j2) | 0;
              c2[m2 >> 2] = c2[q2 >> 2];
              $v(m2, k2, f2);
              Wi(o3);
              g3 = c2[g3 >> 2] | 0;
            } while ((g3 | 0) != 0);
          }
          l2 = r3;
          return;
        }
        function Vw(a3, b3, c3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          c3 = c3 | 0;
          d2 = d2 | 0;
          ox(a3, b3, c3, d2);
          return;
        }
        function Ww(a3, b3, c3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          c3 = c3 | 0;
          nx(a3, b3, c3);
          return;
        }
        function Xw(a3) {
          a3 = a3 | 0;
          return a3 | 0;
        }
        function Yw(a3, b3, c3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          c3 = c3 | 0;
          ix(a3, b3, c3);
          return;
        }
        function Zw(a3) {
          a3 = a3 | 0;
          return a3 + 16 | 0;
        }
        function _w(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          var d2 = 0, e3 = 0, f2 = 0, g3 = 0, h2 = 0, i4 = 0, j2 = 0;
          g3 = l2;
          l2 = l2 + 16 | 0;
          f2 = g3 + 8 | 0;
          d2 = g3;
          c2[a3 >> 2] = 0;
          e3 = c2[b3 >> 2] | 0;
          c2[f2 >> 2] = e3;
          c2[d2 >> 2] = a3;
          d2 = gx(d2) | 0;
          if (e3 | 0) {
            e3 = qC(12) | 0;
            h2 = (hx(f2) | 0) + 4 | 0;
            a3 = c2[h2 + 4 >> 2] | 0;
            b3 = e3 + 4 | 0;
            c2[b3 >> 2] = c2[h2 >> 2];
            c2[b3 + 4 >> 2] = a3;
            b3 = c2[c2[f2 >> 2] >> 2] | 0;
            c2[f2 >> 2] = b3;
            if (!b3)
              a3 = e3;
            else {
              b3 = e3;
              while (1) {
                a3 = qC(12) | 0;
                j2 = (hx(f2) | 0) + 4 | 0;
                i4 = c2[j2 + 4 >> 2] | 0;
                h2 = a3 + 4 | 0;
                c2[h2 >> 2] = c2[j2 >> 2];
                c2[h2 + 4 >> 2] = i4;
                c2[b3 >> 2] = a3;
                h2 = c2[c2[f2 >> 2] >> 2] | 0;
                c2[f2 >> 2] = h2;
                if (!h2)
                  break;
                else
                  b3 = a3;
              }
            }
            c2[a3 >> 2] = c2[d2 >> 2];
            c2[d2 >> 2] = e3;
          }
          l2 = g3;
          return;
        }
        function $w(a3, b3, c3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          c3 = c3 | 0;
          bx(a3, b3, c3);
          return;
        }
        function ax(a3) {
          a3 = a3 | 0;
          return a3 + 24 | 0;
        }
        function bx(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          var e3 = 0, f2 = 0, g3 = 0, h2 = 0, i4 = 0;
          e3 = l2;
          l2 = l2 + 32 | 0;
          h2 = e3 + 24 | 0;
          f2 = e3 + 16 | 0;
          i4 = e3 + 12 | 0;
          g3 = e3;
          UA(f2);
          a3 = Sg(a3) | 0;
          c2[i4 >> 2] = c2[b3 >> 2];
          mw(g3, d2);
          c2[h2 >> 2] = c2[i4 >> 2];
          cx(a3, h2, g3);
          kw(g3);
          WA(f2);
          l2 = e3;
          return;
        }
        function cx(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          var e3 = 0, f2 = 0, g3 = 0, h2 = 0, i4 = 0;
          e3 = l2;
          l2 = l2 + 32 | 0;
          h2 = e3 + 16 | 0;
          i4 = e3 + 12 | 0;
          f2 = e3;
          g3 = Vg(dx() | 0) | 0;
          c2[i4 >> 2] = c2[b3 >> 2];
          c2[h2 >> 2] = c2[i4 >> 2];
          b3 = qw(h2) | 0;
          c2[f2 >> 2] = c2[d2 >> 2];
          h2 = d2 + 4 | 0;
          c2[f2 + 4 >> 2] = c2[h2 >> 2];
          i4 = d2 + 8 | 0;
          c2[f2 + 8 >> 2] = c2[i4 >> 2];
          c2[i4 >> 2] = 0;
          c2[h2 >> 2] = 0;
          c2[d2 >> 2] = 0;
          xa(0, g3 | 0, a3 | 0, b3 | 0, tw(f2) | 0) | 0;
          kw(f2);
          l2 = e3;
          return;
        }
        function dx() {
          var b3 = 0;
          if (!(a2[7976] | 0)) {
            ex(10720);
            b3 = 7976;
            c2[b3 >> 2] = 1;
            c2[b3 + 4 >> 2] = 0;
          }
          return 10720;
        }
        function ex(a3) {
          a3 = a3 | 0;
          fh(a3, fx() | 0, 2);
          return;
        }
        function fx() {
          return 1732;
        }
        function gx(a3) {
          a3 = a3 | 0;
          return c2[a3 >> 2] | 0;
        }
        function hx(a3) {
          a3 = a3 | 0;
          return c2[a3 >> 2] | 0;
        }
        function ix(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          var e3 = 0, f2 = 0, g3 = 0, h2 = 0;
          e3 = l2;
          l2 = l2 + 32 | 0;
          g3 = e3 + 16 | 0;
          f2 = e3 + 8 | 0;
          h2 = e3;
          UA(f2);
          a3 = Sg(a3) | 0;
          c2[h2 >> 2] = c2[b3 >> 2];
          d2 = c2[d2 >> 2] | 0;
          c2[g3 >> 2] = c2[h2 >> 2];
          jx(a3, g3, d2);
          WA(f2);
          l2 = e3;
          return;
        }
        function jx(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          var e3 = 0, f2 = 0, g3 = 0, h2 = 0;
          e3 = l2;
          l2 = l2 + 16 | 0;
          g3 = e3 + 4 | 0;
          h2 = e3;
          f2 = Vg(kx() | 0) | 0;
          c2[h2 >> 2] = c2[b3 >> 2];
          c2[g3 >> 2] = c2[h2 >> 2];
          b3 = qw(g3) | 0;
          xa(0, f2 | 0, a3 | 0, b3 | 0, rw(d2) | 0) | 0;
          l2 = e3;
          return;
        }
        function kx() {
          var b3 = 0;
          if (!(a2[7984] | 0)) {
            lx(10732);
            b3 = 7984;
            c2[b3 >> 2] = 1;
            c2[b3 + 4 >> 2] = 0;
          }
          return 10732;
        }
        function lx(a3) {
          a3 = a3 | 0;
          fh(a3, mx() | 0, 2);
          return;
        }
        function mx() {
          return 1744;
        }
        function nx(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          var e3 = 0, f2 = 0, g3 = 0, h2 = 0;
          e3 = l2;
          l2 = l2 + 32 | 0;
          g3 = e3 + 16 | 0;
          f2 = e3 + 8 | 0;
          h2 = e3;
          UA(f2);
          a3 = Sg(a3) | 0;
          c2[h2 >> 2] = c2[b3 >> 2];
          d2 = c2[d2 >> 2] | 0;
          c2[g3 >> 2] = c2[h2 >> 2];
          jx(a3, g3, d2);
          WA(f2);
          l2 = e3;
          return;
        }
        function ox(b3, d2, e3, f2) {
          b3 = b3 | 0;
          d2 = d2 | 0;
          e3 = e3 | 0;
          f2 = f2 | 0;
          var g3 = 0, h2 = 0, i4 = 0, j2 = 0;
          g3 = l2;
          l2 = l2 + 32 | 0;
          i4 = g3 + 16 | 0;
          h2 = g3 + 8 | 0;
          j2 = g3;
          UA(h2);
          b3 = Sg(b3) | 0;
          c2[j2 >> 2] = c2[d2 >> 2];
          e3 = a2[e3 >> 0] | 0;
          f2 = a2[f2 >> 0] | 0;
          c2[i4 >> 2] = c2[j2 >> 2];
          px(b3, i4, e3, f2);
          WA(h2);
          l2 = g3;
          return;
        }
        function px(a3, b3, d2, e3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          e3 = e3 | 0;
          var f2 = 0, g3 = 0, h2 = 0, i4 = 0;
          f2 = l2;
          l2 = l2 + 16 | 0;
          h2 = f2 + 4 | 0;
          i4 = f2;
          g3 = Vg(qx() | 0) | 0;
          c2[i4 >> 2] = c2[b3 >> 2];
          c2[h2 >> 2] = c2[i4 >> 2];
          b3 = qw(h2) | 0;
          d2 = rx(d2) | 0;
          $a(0, g3 | 0, a3 | 0, b3 | 0, d2 | 0, rx(e3) | 0) | 0;
          l2 = f2;
          return;
        }
        function qx() {
          var b3 = 0;
          if (!(a2[7992] | 0)) {
            tx(10744);
            b3 = 7992;
            c2[b3 >> 2] = 1;
            c2[b3 + 4 >> 2] = 0;
          }
          return 10744;
        }
        function rx(a3) {
          a3 = a3 | 0;
          return sx(a3) | 0;
        }
        function sx(a3) {
          a3 = a3 | 0;
          return a3 & 255 | 0;
        }
        function tx(a3) {
          a3 = a3 | 0;
          fh(a3, ux() | 0, 3);
          return;
        }
        function ux() {
          return 1756;
        }
        function vx(b3, d2, e3) {
          b3 = b3 | 0;
          d2 = d2 | 0;
          e3 = e3 | 0;
          var f2 = 0, g3 = 0, h2 = 0, i4 = 0, j2 = 0, k2 = 0, m2 = 0, n3 = 0, o3 = 0, p2 = 0;
          p2 = l2;
          l2 = l2 + 32 | 0;
          j2 = p2 + 8 | 0;
          k2 = p2 + 4 | 0;
          m2 = p2 + 20 | 0;
          n3 = p2;
          mk(b3, 0);
          f2 = QA(d2) | 0;
          c2[j2 >> 2] = 0;
          o3 = j2 + 4 | 0;
          c2[o3 >> 2] = 0;
          c2[j2 + 8 >> 2] = 0;
          switch (f2 << 24 >> 24) {
            case 0: {
              a2[m2 >> 0] = 0;
              wx(k2, e3, m2);
              xx(b3, k2) | 0;
              wf(k2);
              break;
            }
            case 8: {
              o3 = PA(d2) | 0;
              a2[m2 >> 0] = 8;
              OA(n3, c2[o3 + 4 >> 2] | 0);
              yx(k2, e3, m2, n3, o3 + 8 | 0);
              xx(b3, k2) | 0;
              wf(k2);
              break;
            }
            case 9: {
              h2 = PA(d2) | 0;
              d2 = c2[h2 + 4 >> 2] | 0;
              if (d2 | 0) {
                i4 = j2 + 8 | 0;
                g3 = h2 + 12 | 0;
                while (1) {
                  d2 = d2 + -1 | 0;
                  OA(k2, c2[g3 >> 2] | 0);
                  f2 = c2[o3 >> 2] | 0;
                  if (f2 >>> 0 < (c2[i4 >> 2] | 0) >>> 0) {
                    c2[f2 >> 2] = c2[k2 >> 2];
                    c2[o3 >> 2] = (c2[o3 >> 2] | 0) + 4;
                  } else
                    ew(j2, k2);
                  if (!d2)
                    break;
                  else
                    g3 = g3 + 4 | 0;
                }
              }
              a2[m2 >> 0] = 9;
              OA(n3, c2[h2 + 8 >> 2] | 0);
              zx(k2, e3, m2, n3, j2);
              xx(b3, k2) | 0;
              wf(k2);
              break;
            }
            default: {
              o3 = PA(d2) | 0;
              a2[m2 >> 0] = f2;
              OA(n3, c2[o3 + 4 >> 2] | 0);
              Ax(k2, e3, m2, n3);
              xx(b3, k2) | 0;
              wf(k2);
            }
          }
          kw(j2);
          l2 = p2;
          return;
        }
        function wx(b3, c3, d2) {
          b3 = b3 | 0;
          c3 = c3 | 0;
          d2 = d2 | 0;
          var e3 = 0, f2 = 0;
          e3 = l2;
          l2 = l2 + 16 | 0;
          f2 = e3;
          UA(f2);
          c3 = Sg(c3) | 0;
          Ox(b3, c3, a2[d2 >> 0] | 0);
          WA(f2);
          l2 = e3;
          return;
        }
        function xx(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          var d2 = 0;
          d2 = c2[a3 >> 2] | 0;
          if (d2 | 0)
            ab(d2 | 0);
          c2[a3 >> 2] = c2[b3 >> 2];
          c2[b3 >> 2] = 0;
          return a3 | 0;
        }
        function yx(b3, d2, e3, f2, g3) {
          b3 = b3 | 0;
          d2 = d2 | 0;
          e3 = e3 | 0;
          f2 = f2 | 0;
          g3 = g3 | 0;
          var h2 = 0, i4 = 0, j2 = 0, k2 = 0;
          h2 = l2;
          l2 = l2 + 32 | 0;
          j2 = h2 + 16 | 0;
          i4 = h2 + 8 | 0;
          k2 = h2;
          UA(i4);
          d2 = Sg(d2) | 0;
          e3 = a2[e3 >> 0] | 0;
          c2[k2 >> 2] = c2[f2 >> 2];
          g3 = c2[g3 >> 2] | 0;
          c2[j2 >> 2] = c2[k2 >> 2];
          Kx(b3, d2, e3, j2, g3);
          WA(i4);
          l2 = h2;
          return;
        }
        function zx(b3, d2, e3, f2, g3) {
          b3 = b3 | 0;
          d2 = d2 | 0;
          e3 = e3 | 0;
          f2 = f2 | 0;
          g3 = g3 | 0;
          var h2 = 0, i4 = 0, j2 = 0, k2 = 0, m2 = 0;
          h2 = l2;
          l2 = l2 + 32 | 0;
          k2 = h2 + 24 | 0;
          i4 = h2 + 16 | 0;
          m2 = h2 + 12 | 0;
          j2 = h2;
          UA(i4);
          d2 = Sg(d2) | 0;
          e3 = a2[e3 >> 0] | 0;
          c2[m2 >> 2] = c2[f2 >> 2];
          mw(j2, g3);
          c2[k2 >> 2] = c2[m2 >> 2];
          Gx(b3, d2, e3, k2, j2);
          kw(j2);
          WA(i4);
          l2 = h2;
          return;
        }
        function Ax(b3, d2, e3, f2) {
          b3 = b3 | 0;
          d2 = d2 | 0;
          e3 = e3 | 0;
          f2 = f2 | 0;
          var g3 = 0, h2 = 0, i4 = 0, j2 = 0;
          g3 = l2;
          l2 = l2 + 32 | 0;
          i4 = g3 + 16 | 0;
          h2 = g3 + 8 | 0;
          j2 = g3;
          UA(h2);
          d2 = Sg(d2) | 0;
          e3 = a2[e3 >> 0] | 0;
          c2[j2 >> 2] = c2[f2 >> 2];
          c2[i4 >> 2] = c2[j2 >> 2];
          Bx(b3, d2, e3, i4);
          WA(h2);
          l2 = g3;
          return;
        }
        function Bx(a3, b3, d2, e3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          e3 = e3 | 0;
          var f2 = 0, g3 = 0, h2 = 0, i4 = 0;
          f2 = l2;
          l2 = l2 + 16 | 0;
          g3 = f2 + 4 | 0;
          i4 = f2;
          h2 = Vg(Cx() | 0) | 0;
          d2 = rx(d2) | 0;
          c2[i4 >> 2] = c2[e3 >> 2];
          c2[g3 >> 2] = c2[i4 >> 2];
          Dx(a3, xa(0, h2 | 0, b3 | 0, d2 | 0, qw(g3) | 0) | 0);
          l2 = f2;
          return;
        }
        function Cx() {
          var b3 = 0;
          if (!(a2[8e3] | 0)) {
            Ex(10756);
            b3 = 8e3;
            c2[b3 >> 2] = 1;
            c2[b3 + 4 >> 2] = 0;
          }
          return 10756;
        }
        function Dx(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          mk(a3, b3);
          return;
        }
        function Ex(a3) {
          a3 = a3 | 0;
          fh(a3, Fx() | 0, 2);
          return;
        }
        function Fx() {
          return 1772;
        }
        function Gx(a3, b3, d2, e3, f2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          e3 = e3 | 0;
          f2 = f2 | 0;
          var g3 = 0, h2 = 0, i4 = 0, j2 = 0, k2 = 0;
          g3 = l2;
          l2 = l2 + 32 | 0;
          j2 = g3 + 16 | 0;
          k2 = g3 + 12 | 0;
          h2 = g3;
          i4 = Vg(Hx() | 0) | 0;
          d2 = rx(d2) | 0;
          c2[k2 >> 2] = c2[e3 >> 2];
          c2[j2 >> 2] = c2[k2 >> 2];
          e3 = qw(j2) | 0;
          c2[h2 >> 2] = c2[f2 >> 2];
          j2 = f2 + 4 | 0;
          c2[h2 + 4 >> 2] = c2[j2 >> 2];
          k2 = f2 + 8 | 0;
          c2[h2 + 8 >> 2] = c2[k2 >> 2];
          c2[k2 >> 2] = 0;
          c2[j2 >> 2] = 0;
          c2[f2 >> 2] = 0;
          Dx(a3, $a(0, i4 | 0, b3 | 0, d2 | 0, e3 | 0, tw(h2) | 0) | 0);
          kw(h2);
          l2 = g3;
          return;
        }
        function Hx() {
          var b3 = 0;
          if (!(a2[8008] | 0)) {
            Ix(10768);
            b3 = 8008;
            c2[b3 >> 2] = 1;
            c2[b3 + 4 >> 2] = 0;
          }
          return 10768;
        }
        function Ix(a3) {
          a3 = a3 | 0;
          fh(a3, Jx() | 0, 3);
          return;
        }
        function Jx() {
          return 1784;
        }
        function Kx(a3, b3, d2, e3, f2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          e3 = e3 | 0;
          f2 = f2 | 0;
          var g3 = 0, h2 = 0, i4 = 0, j2 = 0;
          g3 = l2;
          l2 = l2 + 16 | 0;
          i4 = g3 + 4 | 0;
          j2 = g3;
          h2 = Vg(Lx() | 0) | 0;
          d2 = rx(d2) | 0;
          c2[j2 >> 2] = c2[e3 >> 2];
          c2[i4 >> 2] = c2[j2 >> 2];
          e3 = qw(i4) | 0;
          Dx(a3, $a(0, h2 | 0, b3 | 0, d2 | 0, e3 | 0, sw(f2) | 0) | 0);
          l2 = g3;
          return;
        }
        function Lx() {
          var b3 = 0;
          if (!(a2[8016] | 0)) {
            Mx(10780);
            b3 = 8016;
            c2[b3 >> 2] = 1;
            c2[b3 + 4 >> 2] = 0;
          }
          return 10780;
        }
        function Mx(a3) {
          a3 = a3 | 0;
          fh(a3, Nx() | 0, 3);
          return;
        }
        function Nx() {
          return 1800;
        }
        function Ox(a3, b3, c3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          c3 = c3 | 0;
          var d2 = 0;
          d2 = Vg(Px() | 0) | 0;
          Dx(a3, bb(0, d2 | 0, b3 | 0, rx(c3) | 0) | 0);
          return;
        }
        function Px() {
          var b3 = 0;
          if (!(a2[8024] | 0)) {
            Qx(10792);
            b3 = 8024;
            c2[b3 >> 2] = 1;
            c2[b3 + 4 >> 2] = 0;
          }
          return 10792;
        }
        function Qx(a3) {
          a3 = a3 | 0;
          fh(a3, Rx() | 0, 1);
          return;
        }
        function Rx() {
          return 1816;
        }
        function Sx() {
          Tx();
          Ux();
          Vx();
          return;
        }
        function Tx() {
          c2[2702] = rC(65536) | 0;
          return;
        }
        function Ux() {
          qy(10856);
          return;
        }
        function Vx() {
          Wx(10816);
          return;
        }
        function Wx(a3) {
          a3 = a3 | 0;
          Xx(a3, 5044);
          Yx(a3) | 0;
          return;
        }
        function Xx(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          var d2 = 0;
          d2 = zw() | 0;
          c2[a3 >> 2] = d2;
          ky(d2, b3);
          Hv(c2[a3 >> 2] | 0);
          return;
        }
        function Yx(a3) {
          a3 = a3 | 0;
          var b3 = 0;
          b3 = c2[a3 >> 2] | 0;
          At(b3, Zx() | 0);
          return a3 | 0;
        }
        function Zx() {
          var b3 = 0;
          if (!(a2[8032] | 0)) {
            _x(10820);
            Ha(64, 10820, o2 | 0) | 0;
            b3 = 8032;
            c2[b3 >> 2] = 1;
            c2[b3 + 4 >> 2] = 0;
          }
          if (!(si(10820) | 0))
            _x(10820);
          return 10820;
        }
        function _x(a3) {
          a3 = a3 | 0;
          by(a3);
          Gt(a3, 25);
          return;
        }
        function $x(a3) {
          a3 = a3 | 0;
          ay(a3 + 24 | 0);
          return;
        }
        function ay(a3) {
          a3 = a3 | 0;
          var b3 = 0, d2 = 0, e3 = 0;
          d2 = c2[a3 >> 2] | 0;
          e3 = d2;
          if (d2 | 0) {
            a3 = a3 + 4 | 0;
            b3 = c2[a3 >> 2] | 0;
            if ((b3 | 0) != (d2 | 0))
              c2[a3 >> 2] = b3 + (~((b3 + -8 - e3 | 0) >>> 3) << 3);
            sC(d2);
          }
          return;
        }
        function by(a3) {
          a3 = a3 | 0;
          var b3 = 0;
          b3 = vi() | 0;
          yi(a3, 5, 18, b3, gy() | 0, 1);
          c2[a3 + 24 >> 2] = 0;
          c2[a3 + 28 >> 2] = 0;
          c2[a3 + 32 >> 2] = 0;
          return;
        }
        function cy(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          dy(a3, b3);
          return;
        }
        function dy(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          var d2 = 0, e3 = 0, f2 = 0;
          d2 = l2;
          l2 = l2 + 16 | 0;
          e3 = d2;
          f2 = d2 + 4 | 0;
          Gk(f2, b3);
          c2[e3 >> 2] = Hk(f2, b3) | 0;
          ey(a3, e3);
          l2 = d2;
          return;
        }
        function ey(b3, d2) {
          b3 = b3 | 0;
          d2 = d2 | 0;
          fy(b3 + 4 | 0, c2[d2 >> 2] | 0);
          a2[b3 + 8 >> 0] = 1;
          return;
        }
        function fy(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          c2[a3 >> 2] = b3;
          return;
        }
        function gy() {
          return 1824;
        }
        function hy(a3) {
          a3 = a3 | 0;
          return iy(a3) | 0;
        }
        function iy(a3) {
          a3 = a3 | 0;
          var b3 = 0, d2 = 0, e3 = 0, f2 = 0, g3 = 0, h2 = 0, i4 = 0;
          d2 = l2;
          l2 = l2 + 16 | 0;
          f2 = d2 + 4 | 0;
          h2 = d2;
          e3 = jy(8) | 0;
          b3 = e3;
          i4 = qC(4) | 0;
          Gk(f2, a3);
          fy(i4, Hk(f2, a3) | 0);
          g3 = b3 + 4 | 0;
          c2[g3 >> 2] = i4;
          a3 = qC(8) | 0;
          g3 = c2[g3 >> 2] | 0;
          c2[h2 >> 2] = 0;
          c2[f2 >> 2] = c2[h2 >> 2];
          Bw(a3, g3, f2);
          c2[e3 >> 2] = a3;
          l2 = d2;
          return b3 | 0;
        }
        function jy(a3) {
          a3 = a3 | 0;
          var b3 = 0, d2 = 0;
          a3 = a3 + 7 & -8;
          if (a3 >>> 0 <= 32768 ? (b3 = c2[2701] | 0, a3 >>> 0 <= (65536 - b3 | 0) >>> 0) : 0) {
            d2 = (c2[2702] | 0) + b3 | 0;
            c2[2701] = b3 + a3;
            a3 = d2;
          } else {
            a3 = rC(a3 + 8 | 0) | 0;
            c2[a3 >> 2] = c2[2703];
            c2[2703] = a3;
            a3 = a3 + 8 | 0;
          }
          return a3 | 0;
        }
        function ky(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          c2[a3 >> 2] = ly() | 0;
          c2[a3 + 4 >> 2] = my() | 0;
          c2[a3 + 12 >> 2] = b3;
          c2[a3 + 8 >> 2] = ny() | 0;
          c2[a3 + 32 >> 2] = 9;
          return;
        }
        function ly() {
          return 11744;
        }
        function my() {
          return 1832;
        }
        function ny() {
          return cu() | 0;
        }
        function oy(a3, b3, c3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          c3 = c3 | 0;
          d2 = d2 | 0;
          if ((jr(d2, 896) | 0) == 512) {
            if (c3 | 0) {
              py(c3);
              sC(c3);
            }
          } else if (b3 | 0)
            sC(b3);
          return;
        }
        function py(a3) {
          a3 = a3 | 0;
          a3 = c2[a3 + 4 >> 2] | 0;
          if (a3 | 0)
            oC(a3);
          return;
        }
        function qy(a3) {
          a3 = a3 | 0;
          ry(a3, 5052);
          sy(a3) | 0;
          ty(a3, 5058, 26) | 0;
          uy(a3, 5069, 1) | 0;
          vy(a3, 5077, 10) | 0;
          wy(a3, 5087, 19) | 0;
          yy(a3, 5094, 27) | 0;
          return;
        }
        function ry(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          var d2 = 0;
          d2 = GA() | 0;
          c2[a3 >> 2] = d2;
          HA(d2, b3);
          Hv(c2[a3 >> 2] | 0);
          return;
        }
        function sy(a3) {
          a3 = a3 | 0;
          var b3 = 0;
          b3 = c2[a3 >> 2] | 0;
          At(b3, rA() | 0);
          return a3 | 0;
        }
        function ty(a3, b3, c3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          c3 = c3 | 0;
          Yz(a3, ai(b3) | 0, c3, 0);
          return a3 | 0;
        }
        function uy(a3, b3, c3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          c3 = c3 | 0;
          Gz(a3, ai(b3) | 0, c3, 0);
          return a3 | 0;
        }
        function vy(a3, b3, c3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          c3 = c3 | 0;
          hz(a3, ai(b3) | 0, c3, 0);
          return a3 | 0;
        }
        function wy(a3, b3, c3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          c3 = c3 | 0;
          Ry(a3, ai(b3) | 0, c3, 0);
          return a3 | 0;
        }
        function xy(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          var d2 = 0, e3 = 0;
          a:
            while (1) {
              d2 = c2[2703] | 0;
              while (1) {
                if ((d2 | 0) == (b3 | 0))
                  break a;
                e3 = c2[d2 >> 2] | 0;
                c2[2703] = e3;
                if (!d2)
                  d2 = e3;
                else
                  break;
              }
              sC(d2);
            }
          c2[2701] = a3;
          return;
        }
        function yy(a3, b3, c3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          c3 = c3 | 0;
          zy(a3, ai(b3) | 0, c3, 0);
          return a3 | 0;
        }
        function zy(a3, b3, d2, e3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          e3 = e3 | 0;
          var f2 = 0, g3 = 0;
          g3 = c2[a3 >> 2] | 0;
          f2 = Ay() | 0;
          a3 = By(d2) | 0;
          fi(g3, b3, f2, a3, Cy(d2, e3) | 0, e3);
          return;
        }
        function Ay() {
          var b3 = 0, d2 = 0;
          if (!(a2[8040] | 0)) {
            Jy(10860);
            Ha(65, 10860, o2 | 0) | 0;
            d2 = 8040;
            c2[d2 >> 2] = 1;
            c2[d2 + 4 >> 2] = 0;
          }
          if (!(si(10860) | 0)) {
            b3 = 10860;
            d2 = b3 + 36 | 0;
            do {
              c2[b3 >> 2] = 0;
              b3 = b3 + 4 | 0;
            } while ((b3 | 0) < (d2 | 0));
            Jy(10860);
          }
          return 10860;
        }
        function By(a3) {
          a3 = a3 | 0;
          return a3 | 0;
        }
        function Cy(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          var d2 = 0, e3 = 0, f2 = 0, g3 = 0, h2 = 0, i4 = 0, j2 = 0;
          i4 = l2;
          l2 = l2 + 16 | 0;
          f2 = i4;
          g3 = i4 + 4 | 0;
          c2[f2 >> 2] = a3;
          j2 = Ay() | 0;
          h2 = j2 + 24 | 0;
          b3 = ji(b3, 4) | 0;
          c2[g3 >> 2] = b3;
          d2 = j2 + 28 | 0;
          e3 = c2[d2 >> 2] | 0;
          if (e3 >>> 0 < (c2[j2 + 32 >> 2] | 0) >>> 0) {
            Dy(e3, a3, b3);
            b3 = (c2[d2 >> 2] | 0) + 8 | 0;
            c2[d2 >> 2] = b3;
          } else {
            Ey(h2, f2, g3);
            b3 = c2[d2 >> 2] | 0;
          }
          l2 = i4;
          return (b3 - (c2[h2 >> 2] | 0) >> 3) + -1 | 0;
        }
        function Dy(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          c2[a3 >> 2] = b3;
          c2[a3 + 4 >> 2] = d2;
          return;
        }
        function Ey(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          var e3 = 0, f2 = 0, g3 = 0, h2 = 0, i4 = 0, j2 = 0, k2 = 0, m2 = 0;
          i4 = l2;
          l2 = l2 + 32 | 0;
          f2 = i4;
          g3 = a3 + 4 | 0;
          h2 = ((c2[g3 >> 2] | 0) - (c2[a3 >> 2] | 0) >> 3) + 1 | 0;
          e3 = Fy(a3) | 0;
          if (e3 >>> 0 < h2 >>> 0)
            jC(a3);
          else {
            j2 = c2[a3 >> 2] | 0;
            m2 = (c2[a3 + 8 >> 2] | 0) - j2 | 0;
            k2 = m2 >> 2;
            Gy(f2, m2 >> 3 >>> 0 < e3 >>> 1 >>> 0 ? k2 >>> 0 < h2 >>> 0 ? h2 : k2 : e3, (c2[g3 >> 2] | 0) - j2 >> 3, a3 + 8 | 0);
            h2 = f2 + 8 | 0;
            Dy(c2[h2 >> 2] | 0, c2[b3 >> 2] | 0, c2[d2 >> 2] | 0);
            c2[h2 >> 2] = (c2[h2 >> 2] | 0) + 8;
            Hy(a3, f2);
            Iy(f2);
            l2 = i4;
            return;
          }
        }
        function Fy(a3) {
          a3 = a3 | 0;
          return 536870911;
        }
        function Gy(a3, b3, d2, e3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          e3 = e3 | 0;
          var f2 = 0;
          c2[a3 + 12 >> 2] = 0;
          c2[a3 + 16 >> 2] = e3;
          do
            if (b3) {
              if (b3 >>> 0 > 536870911)
                Ta();
              else {
                f2 = qC(b3 << 3) | 0;
                break;
              }
            } else
              f2 = 0;
          while (0);
          c2[a3 >> 2] = f2;
          e3 = f2 + (d2 << 3) | 0;
          c2[a3 + 8 >> 2] = e3;
          c2[a3 + 4 >> 2] = e3;
          c2[a3 + 12 >> 2] = f2 + (b3 << 3);
          return;
        }
        function Hy(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          var d2 = 0, e3 = 0, f2 = 0, g3 = 0, h2 = 0;
          e3 = c2[a3 >> 2] | 0;
          h2 = a3 + 4 | 0;
          g3 = b3 + 4 | 0;
          f2 = (c2[h2 >> 2] | 0) - e3 | 0;
          d2 = (c2[g3 >> 2] | 0) + (0 - (f2 >> 3) << 3) | 0;
          c2[g3 >> 2] = d2;
          if ((f2 | 0) > 0) {
            BC(d2 | 0, e3 | 0, f2 | 0) | 0;
            e3 = g3;
            d2 = c2[g3 >> 2] | 0;
          } else
            e3 = g3;
          g3 = c2[a3 >> 2] | 0;
          c2[a3 >> 2] = d2;
          c2[e3 >> 2] = g3;
          g3 = b3 + 8 | 0;
          f2 = c2[h2 >> 2] | 0;
          c2[h2 >> 2] = c2[g3 >> 2];
          c2[g3 >> 2] = f2;
          g3 = a3 + 8 | 0;
          h2 = b3 + 12 | 0;
          a3 = c2[g3 >> 2] | 0;
          c2[g3 >> 2] = c2[h2 >> 2];
          c2[h2 >> 2] = a3;
          c2[b3 >> 2] = c2[e3 >> 2];
          return;
        }
        function Iy(a3) {
          a3 = a3 | 0;
          var b3 = 0, d2 = 0, e3 = 0;
          b3 = c2[a3 + 4 >> 2] | 0;
          d2 = a3 + 8 | 0;
          e3 = c2[d2 >> 2] | 0;
          if ((e3 | 0) != (b3 | 0))
            c2[d2 >> 2] = e3 + (~((e3 + -8 - b3 | 0) >>> 3) << 3);
          a3 = c2[a3 >> 2] | 0;
          if (a3 | 0)
            sC(a3);
          return;
        }
        function Jy(a3) {
          a3 = a3 | 0;
          My(a3);
          return;
        }
        function Ky(a3) {
          a3 = a3 | 0;
          Ly(a3 + 24 | 0);
          return;
        }
        function Ly(a3) {
          a3 = a3 | 0;
          var b3 = 0, d2 = 0, e3 = 0;
          d2 = c2[a3 >> 2] | 0;
          e3 = d2;
          if (d2 | 0) {
            a3 = a3 + 4 | 0;
            b3 = c2[a3 >> 2] | 0;
            if ((b3 | 0) != (d2 | 0))
              c2[a3 >> 2] = b3 + (~((b3 + -8 - e3 | 0) >>> 3) << 3);
            sC(d2);
          }
          return;
        }
        function My(a3) {
          a3 = a3 | 0;
          var b3 = 0;
          b3 = vi() | 0;
          yi(a3, 1, 11, b3, Ny() | 0, 2);
          c2[a3 + 24 >> 2] = 0;
          c2[a3 + 28 >> 2] = 0;
          c2[a3 + 32 >> 2] = 0;
          return;
        }
        function Ny() {
          return 1840;
        }
        function Oy(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          Qy(c2[(Py(a3) | 0) >> 2] | 0, b3, d2);
          return;
        }
        function Py(a3) {
          a3 = a3 | 0;
          return (c2[(Ay() | 0) + 24 >> 2] | 0) + (a3 << 3) | 0;
        }
        function Qy(a3, b3, c3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          c3 = c3 | 0;
          var d2 = 0, e3 = 0, f2 = 0;
          d2 = l2;
          l2 = l2 + 16 | 0;
          f2 = d2 + 1 | 0;
          e3 = d2;
          Gk(f2, b3);
          b3 = Hk(f2, b3) | 0;
          Gk(e3, c3);
          c3 = Hk(e3, c3) | 0;
          ob[a3 & 31](b3, c3);
          l2 = d2;
          return;
        }
        function Ry(a3, b3, d2, e3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          e3 = e3 | 0;
          var f2 = 0, g3 = 0;
          g3 = c2[a3 >> 2] | 0;
          f2 = Sy() | 0;
          a3 = Ty(d2) | 0;
          fi(g3, b3, f2, a3, Uy(d2, e3) | 0, e3);
          return;
        }
        function Sy() {
          var b3 = 0, d2 = 0;
          if (!(a2[8048] | 0)) {
            $y(10896);
            Ha(66, 10896, o2 | 0) | 0;
            d2 = 8048;
            c2[d2 >> 2] = 1;
            c2[d2 + 4 >> 2] = 0;
          }
          if (!(si(10896) | 0)) {
            b3 = 10896;
            d2 = b3 + 36 | 0;
            do {
              c2[b3 >> 2] = 0;
              b3 = b3 + 4 | 0;
            } while ((b3 | 0) < (d2 | 0));
            $y(10896);
          }
          return 10896;
        }
        function Ty(a3) {
          a3 = a3 | 0;
          return a3 | 0;
        }
        function Uy(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          var d2 = 0, e3 = 0, f2 = 0, g3 = 0, h2 = 0, i4 = 0, j2 = 0;
          i4 = l2;
          l2 = l2 + 16 | 0;
          f2 = i4;
          g3 = i4 + 4 | 0;
          c2[f2 >> 2] = a3;
          j2 = Sy() | 0;
          h2 = j2 + 24 | 0;
          b3 = ji(b3, 4) | 0;
          c2[g3 >> 2] = b3;
          d2 = j2 + 28 | 0;
          e3 = c2[d2 >> 2] | 0;
          if (e3 >>> 0 < (c2[j2 + 32 >> 2] | 0) >>> 0) {
            Vy(e3, a3, b3);
            b3 = (c2[d2 >> 2] | 0) + 8 | 0;
            c2[d2 >> 2] = b3;
          } else {
            Wy(h2, f2, g3);
            b3 = c2[d2 >> 2] | 0;
          }
          l2 = i4;
          return (b3 - (c2[h2 >> 2] | 0) >> 3) + -1 | 0;
        }
        function Vy(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          c2[a3 >> 2] = b3;
          c2[a3 + 4 >> 2] = d2;
          return;
        }
        function Wy(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          var e3 = 0, f2 = 0, g3 = 0, h2 = 0, i4 = 0, j2 = 0, k2 = 0, m2 = 0;
          i4 = l2;
          l2 = l2 + 32 | 0;
          f2 = i4;
          g3 = a3 + 4 | 0;
          h2 = ((c2[g3 >> 2] | 0) - (c2[a3 >> 2] | 0) >> 3) + 1 | 0;
          e3 = Xy(a3) | 0;
          if (e3 >>> 0 < h2 >>> 0)
            jC(a3);
          else {
            j2 = c2[a3 >> 2] | 0;
            m2 = (c2[a3 + 8 >> 2] | 0) - j2 | 0;
            k2 = m2 >> 2;
            Yy(f2, m2 >> 3 >>> 0 < e3 >>> 1 >>> 0 ? k2 >>> 0 < h2 >>> 0 ? h2 : k2 : e3, (c2[g3 >> 2] | 0) - j2 >> 3, a3 + 8 | 0);
            h2 = f2 + 8 | 0;
            Vy(c2[h2 >> 2] | 0, c2[b3 >> 2] | 0, c2[d2 >> 2] | 0);
            c2[h2 >> 2] = (c2[h2 >> 2] | 0) + 8;
            Zy(a3, f2);
            _y(f2);
            l2 = i4;
            return;
          }
        }
        function Xy(a3) {
          a3 = a3 | 0;
          return 536870911;
        }
        function Yy(a3, b3, d2, e3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          e3 = e3 | 0;
          var f2 = 0;
          c2[a3 + 12 >> 2] = 0;
          c2[a3 + 16 >> 2] = e3;
          do
            if (b3) {
              if (b3 >>> 0 > 536870911)
                Ta();
              else {
                f2 = qC(b3 << 3) | 0;
                break;
              }
            } else
              f2 = 0;
          while (0);
          c2[a3 >> 2] = f2;
          e3 = f2 + (d2 << 3) | 0;
          c2[a3 + 8 >> 2] = e3;
          c2[a3 + 4 >> 2] = e3;
          c2[a3 + 12 >> 2] = f2 + (b3 << 3);
          return;
        }
        function Zy(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          var d2 = 0, e3 = 0, f2 = 0, g3 = 0, h2 = 0;
          e3 = c2[a3 >> 2] | 0;
          h2 = a3 + 4 | 0;
          g3 = b3 + 4 | 0;
          f2 = (c2[h2 >> 2] | 0) - e3 | 0;
          d2 = (c2[g3 >> 2] | 0) + (0 - (f2 >> 3) << 3) | 0;
          c2[g3 >> 2] = d2;
          if ((f2 | 0) > 0) {
            BC(d2 | 0, e3 | 0, f2 | 0) | 0;
            e3 = g3;
            d2 = c2[g3 >> 2] | 0;
          } else
            e3 = g3;
          g3 = c2[a3 >> 2] | 0;
          c2[a3 >> 2] = d2;
          c2[e3 >> 2] = g3;
          g3 = b3 + 8 | 0;
          f2 = c2[h2 >> 2] | 0;
          c2[h2 >> 2] = c2[g3 >> 2];
          c2[g3 >> 2] = f2;
          g3 = a3 + 8 | 0;
          h2 = b3 + 12 | 0;
          a3 = c2[g3 >> 2] | 0;
          c2[g3 >> 2] = c2[h2 >> 2];
          c2[h2 >> 2] = a3;
          c2[b3 >> 2] = c2[e3 >> 2];
          return;
        }
        function _y(a3) {
          a3 = a3 | 0;
          var b3 = 0, d2 = 0, e3 = 0;
          b3 = c2[a3 + 4 >> 2] | 0;
          d2 = a3 + 8 | 0;
          e3 = c2[d2 >> 2] | 0;
          if ((e3 | 0) != (b3 | 0))
            c2[d2 >> 2] = e3 + (~((e3 + -8 - b3 | 0) >>> 3) << 3);
          a3 = c2[a3 >> 2] | 0;
          if (a3 | 0)
            sC(a3);
          return;
        }
        function $y(a3) {
          a3 = a3 | 0;
          cz(a3);
          return;
        }
        function az(a3) {
          a3 = a3 | 0;
          bz(a3 + 24 | 0);
          return;
        }
        function bz(a3) {
          a3 = a3 | 0;
          var b3 = 0, d2 = 0, e3 = 0;
          d2 = c2[a3 >> 2] | 0;
          e3 = d2;
          if (d2 | 0) {
            a3 = a3 + 4 | 0;
            b3 = c2[a3 >> 2] | 0;
            if ((b3 | 0) != (d2 | 0))
              c2[a3 >> 2] = b3 + (~((b3 + -8 - e3 | 0) >>> 3) << 3);
            sC(d2);
          }
          return;
        }
        function cz(a3) {
          a3 = a3 | 0;
          var b3 = 0;
          b3 = vi() | 0;
          yi(a3, 1, 11, b3, dz() | 0, 1);
          c2[a3 + 24 >> 2] = 0;
          c2[a3 + 28 >> 2] = 0;
          c2[a3 + 32 >> 2] = 0;
          return;
        }
        function dz() {
          return 1852;
        }
        function ez(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          return gz(c2[(fz(a3) | 0) >> 2] | 0, b3) | 0;
        }
        function fz(a3) {
          a3 = a3 | 0;
          return (c2[(Sy() | 0) + 24 >> 2] | 0) + (a3 << 3) | 0;
        }
        function gz(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          var c3 = 0, d2 = 0;
          c3 = l2;
          l2 = l2 + 16 | 0;
          d2 = c3;
          Gk(d2, b3);
          b3 = Hk(d2, b3) | 0;
          b3 = ul(pb[a3 & 31](b3) | 0) | 0;
          l2 = c3;
          return b3 | 0;
        }
        function hz(a3, b3, d2, e3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          e3 = e3 | 0;
          var f2 = 0, g3 = 0;
          g3 = c2[a3 >> 2] | 0;
          f2 = iz() | 0;
          a3 = jz(d2) | 0;
          fi(g3, b3, f2, a3, kz(d2, e3) | 0, e3);
          return;
        }
        function iz() {
          var b3 = 0, d2 = 0;
          if (!(a2[8056] | 0)) {
            rz(10932);
            Ha(67, 10932, o2 | 0) | 0;
            d2 = 8056;
            c2[d2 >> 2] = 1;
            c2[d2 + 4 >> 2] = 0;
          }
          if (!(si(10932) | 0)) {
            b3 = 10932;
            d2 = b3 + 36 | 0;
            do {
              c2[b3 >> 2] = 0;
              b3 = b3 + 4 | 0;
            } while ((b3 | 0) < (d2 | 0));
            rz(10932);
          }
          return 10932;
        }
        function jz(a3) {
          a3 = a3 | 0;
          return a3 | 0;
        }
        function kz(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          var d2 = 0, e3 = 0, f2 = 0, g3 = 0, h2 = 0, i4 = 0, j2 = 0;
          i4 = l2;
          l2 = l2 + 16 | 0;
          f2 = i4;
          g3 = i4 + 4 | 0;
          c2[f2 >> 2] = a3;
          j2 = iz() | 0;
          h2 = j2 + 24 | 0;
          b3 = ji(b3, 4) | 0;
          c2[g3 >> 2] = b3;
          d2 = j2 + 28 | 0;
          e3 = c2[d2 >> 2] | 0;
          if (e3 >>> 0 < (c2[j2 + 32 >> 2] | 0) >>> 0) {
            lz(e3, a3, b3);
            b3 = (c2[d2 >> 2] | 0) + 8 | 0;
            c2[d2 >> 2] = b3;
          } else {
            mz(h2, f2, g3);
            b3 = c2[d2 >> 2] | 0;
          }
          l2 = i4;
          return (b3 - (c2[h2 >> 2] | 0) >> 3) + -1 | 0;
        }
        function lz(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          c2[a3 >> 2] = b3;
          c2[a3 + 4 >> 2] = d2;
          return;
        }
        function mz(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          var e3 = 0, f2 = 0, g3 = 0, h2 = 0, i4 = 0, j2 = 0, k2 = 0, m2 = 0;
          i4 = l2;
          l2 = l2 + 32 | 0;
          f2 = i4;
          g3 = a3 + 4 | 0;
          h2 = ((c2[g3 >> 2] | 0) - (c2[a3 >> 2] | 0) >> 3) + 1 | 0;
          e3 = nz(a3) | 0;
          if (e3 >>> 0 < h2 >>> 0)
            jC(a3);
          else {
            j2 = c2[a3 >> 2] | 0;
            m2 = (c2[a3 + 8 >> 2] | 0) - j2 | 0;
            k2 = m2 >> 2;
            oz(f2, m2 >> 3 >>> 0 < e3 >>> 1 >>> 0 ? k2 >>> 0 < h2 >>> 0 ? h2 : k2 : e3, (c2[g3 >> 2] | 0) - j2 >> 3, a3 + 8 | 0);
            h2 = f2 + 8 | 0;
            lz(c2[h2 >> 2] | 0, c2[b3 >> 2] | 0, c2[d2 >> 2] | 0);
            c2[h2 >> 2] = (c2[h2 >> 2] | 0) + 8;
            pz(a3, f2);
            qz(f2);
            l2 = i4;
            return;
          }
        }
        function nz(a3) {
          a3 = a3 | 0;
          return 536870911;
        }
        function oz(a3, b3, d2, e3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          e3 = e3 | 0;
          var f2 = 0;
          c2[a3 + 12 >> 2] = 0;
          c2[a3 + 16 >> 2] = e3;
          do
            if (b3) {
              if (b3 >>> 0 > 536870911)
                Ta();
              else {
                f2 = qC(b3 << 3) | 0;
                break;
              }
            } else
              f2 = 0;
          while (0);
          c2[a3 >> 2] = f2;
          e3 = f2 + (d2 << 3) | 0;
          c2[a3 + 8 >> 2] = e3;
          c2[a3 + 4 >> 2] = e3;
          c2[a3 + 12 >> 2] = f2 + (b3 << 3);
          return;
        }
        function pz(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          var d2 = 0, e3 = 0, f2 = 0, g3 = 0, h2 = 0;
          e3 = c2[a3 >> 2] | 0;
          h2 = a3 + 4 | 0;
          g3 = b3 + 4 | 0;
          f2 = (c2[h2 >> 2] | 0) - e3 | 0;
          d2 = (c2[g3 >> 2] | 0) + (0 - (f2 >> 3) << 3) | 0;
          c2[g3 >> 2] = d2;
          if ((f2 | 0) > 0) {
            BC(d2 | 0, e3 | 0, f2 | 0) | 0;
            e3 = g3;
            d2 = c2[g3 >> 2] | 0;
          } else
            e3 = g3;
          g3 = c2[a3 >> 2] | 0;
          c2[a3 >> 2] = d2;
          c2[e3 >> 2] = g3;
          g3 = b3 + 8 | 0;
          f2 = c2[h2 >> 2] | 0;
          c2[h2 >> 2] = c2[g3 >> 2];
          c2[g3 >> 2] = f2;
          g3 = a3 + 8 | 0;
          h2 = b3 + 12 | 0;
          a3 = c2[g3 >> 2] | 0;
          c2[g3 >> 2] = c2[h2 >> 2];
          c2[h2 >> 2] = a3;
          c2[b3 >> 2] = c2[e3 >> 2];
          return;
        }
        function qz(a3) {
          a3 = a3 | 0;
          var b3 = 0, d2 = 0, e3 = 0;
          b3 = c2[a3 + 4 >> 2] | 0;
          d2 = a3 + 8 | 0;
          e3 = c2[d2 >> 2] | 0;
          if ((e3 | 0) != (b3 | 0))
            c2[d2 >> 2] = e3 + (~((e3 + -8 - b3 | 0) >>> 3) << 3);
          a3 = c2[a3 >> 2] | 0;
          if (a3 | 0)
            sC(a3);
          return;
        }
        function rz(a3) {
          a3 = a3 | 0;
          uz(a3);
          return;
        }
        function sz(a3) {
          a3 = a3 | 0;
          tz(a3 + 24 | 0);
          return;
        }
        function tz(a3) {
          a3 = a3 | 0;
          var b3 = 0, d2 = 0, e3 = 0;
          d2 = c2[a3 >> 2] | 0;
          e3 = d2;
          if (d2 | 0) {
            a3 = a3 + 4 | 0;
            b3 = c2[a3 >> 2] | 0;
            if ((b3 | 0) != (d2 | 0))
              c2[a3 >> 2] = b3 + (~((b3 + -8 - e3 | 0) >>> 3) << 3);
            sC(d2);
          }
          return;
        }
        function uz(a3) {
          a3 = a3 | 0;
          var b3 = 0;
          b3 = vi() | 0;
          yi(a3, 1, 7, b3, vz() | 0, 2);
          c2[a3 + 24 >> 2] = 0;
          c2[a3 + 28 >> 2] = 0;
          c2[a3 + 32 >> 2] = 0;
          return;
        }
        function vz() {
          return 1860;
        }
        function wz(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          return yz(c2[(xz(a3) | 0) >> 2] | 0, b3, d2) | 0;
        }
        function xz(a3) {
          a3 = a3 | 0;
          return (c2[(iz() | 0) + 24 >> 2] | 0) + (a3 << 3) | 0;
        }
        function yz(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          var e3 = 0, f2 = 0, g3 = 0, h2 = 0, i4 = 0, j2 = 0;
          e3 = l2;
          l2 = l2 + 32 | 0;
          h2 = e3 + 12 | 0;
          g3 = e3 + 8 | 0;
          i4 = e3;
          j2 = e3 + 16 | 0;
          f2 = e3 + 4 | 0;
          zz(j2, b3);
          Az(i4, j2, b3);
          ik(f2, d2);
          d2 = jk(f2, d2) | 0;
          c2[h2 >> 2] = c2[i4 >> 2];
          Eb[a3 & 15](g3, h2, d2);
          d2 = Bz(g3) | 0;
          wf(g3);
          kk(f2);
          l2 = e3;
          return d2 | 0;
        }
        function zz(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          return;
        }
        function Az(a3, b3, c3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          c3 = c3 | 0;
          Cz(a3, c3);
          return;
        }
        function Bz(a3) {
          a3 = a3 | 0;
          return Sg(a3) | 0;
        }
        function Cz(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          var d2 = 0, e3 = 0, f2 = 0;
          f2 = l2;
          l2 = l2 + 16 | 0;
          d2 = f2;
          e3 = b3;
          if (!(e3 & 1))
            c2[a3 >> 2] = c2[b3 >> 2];
          else {
            Dz(d2, 0);
            Ja(e3 | 0, d2 | 0) | 0;
            Ez(a3, d2);
            Fz(d2);
          }
          l2 = f2;
          return;
        }
        function Dz(b3, d2) {
          b3 = b3 | 0;
          d2 = d2 | 0;
          ah(b3, d2);
          c2[b3 + 4 >> 2] = 0;
          a2[b3 + 8 >> 0] = 0;
          return;
        }
        function Ez(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          c2[a3 >> 2] = c2[b3 + 4 >> 2];
          return;
        }
        function Fz(b3) {
          b3 = b3 | 0;
          a2[b3 + 8 >> 0] = 0;
          return;
        }
        function Gz(a3, b3, d2, e3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          e3 = e3 | 0;
          var f2 = 0, g3 = 0;
          g3 = c2[a3 >> 2] | 0;
          f2 = Hz() | 0;
          a3 = Iz(d2) | 0;
          fi(g3, b3, f2, a3, Jz(d2, e3) | 0, e3);
          return;
        }
        function Hz() {
          var b3 = 0, d2 = 0;
          if (!(a2[8064] | 0)) {
            Qz(10968);
            Ha(68, 10968, o2 | 0) | 0;
            d2 = 8064;
            c2[d2 >> 2] = 1;
            c2[d2 + 4 >> 2] = 0;
          }
          if (!(si(10968) | 0)) {
            b3 = 10968;
            d2 = b3 + 36 | 0;
            do {
              c2[b3 >> 2] = 0;
              b3 = b3 + 4 | 0;
            } while ((b3 | 0) < (d2 | 0));
            Qz(10968);
          }
          return 10968;
        }
        function Iz(a3) {
          a3 = a3 | 0;
          return a3 | 0;
        }
        function Jz(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          var d2 = 0, e3 = 0, f2 = 0, g3 = 0, h2 = 0, i4 = 0, j2 = 0;
          i4 = l2;
          l2 = l2 + 16 | 0;
          f2 = i4;
          g3 = i4 + 4 | 0;
          c2[f2 >> 2] = a3;
          j2 = Hz() | 0;
          h2 = j2 + 24 | 0;
          b3 = ji(b3, 4) | 0;
          c2[g3 >> 2] = b3;
          d2 = j2 + 28 | 0;
          e3 = c2[d2 >> 2] | 0;
          if (e3 >>> 0 < (c2[j2 + 32 >> 2] | 0) >>> 0) {
            Kz(e3, a3, b3);
            b3 = (c2[d2 >> 2] | 0) + 8 | 0;
            c2[d2 >> 2] = b3;
          } else {
            Lz(h2, f2, g3);
            b3 = c2[d2 >> 2] | 0;
          }
          l2 = i4;
          return (b3 - (c2[h2 >> 2] | 0) >> 3) + -1 | 0;
        }
        function Kz(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          c2[a3 >> 2] = b3;
          c2[a3 + 4 >> 2] = d2;
          return;
        }
        function Lz(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          var e3 = 0, f2 = 0, g3 = 0, h2 = 0, i4 = 0, j2 = 0, k2 = 0, m2 = 0;
          i4 = l2;
          l2 = l2 + 32 | 0;
          f2 = i4;
          g3 = a3 + 4 | 0;
          h2 = ((c2[g3 >> 2] | 0) - (c2[a3 >> 2] | 0) >> 3) + 1 | 0;
          e3 = Mz(a3) | 0;
          if (e3 >>> 0 < h2 >>> 0)
            jC(a3);
          else {
            j2 = c2[a3 >> 2] | 0;
            m2 = (c2[a3 + 8 >> 2] | 0) - j2 | 0;
            k2 = m2 >> 2;
            Nz(f2, m2 >> 3 >>> 0 < e3 >>> 1 >>> 0 ? k2 >>> 0 < h2 >>> 0 ? h2 : k2 : e3, (c2[g3 >> 2] | 0) - j2 >> 3, a3 + 8 | 0);
            h2 = f2 + 8 | 0;
            Kz(c2[h2 >> 2] | 0, c2[b3 >> 2] | 0, c2[d2 >> 2] | 0);
            c2[h2 >> 2] = (c2[h2 >> 2] | 0) + 8;
            Oz(a3, f2);
            Pz(f2);
            l2 = i4;
            return;
          }
        }
        function Mz(a3) {
          a3 = a3 | 0;
          return 536870911;
        }
        function Nz(a3, b3, d2, e3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          e3 = e3 | 0;
          var f2 = 0;
          c2[a3 + 12 >> 2] = 0;
          c2[a3 + 16 >> 2] = e3;
          do
            if (b3) {
              if (b3 >>> 0 > 536870911)
                Ta();
              else {
                f2 = qC(b3 << 3) | 0;
                break;
              }
            } else
              f2 = 0;
          while (0);
          c2[a3 >> 2] = f2;
          e3 = f2 + (d2 << 3) | 0;
          c2[a3 + 8 >> 2] = e3;
          c2[a3 + 4 >> 2] = e3;
          c2[a3 + 12 >> 2] = f2 + (b3 << 3);
          return;
        }
        function Oz(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          var d2 = 0, e3 = 0, f2 = 0, g3 = 0, h2 = 0;
          e3 = c2[a3 >> 2] | 0;
          h2 = a3 + 4 | 0;
          g3 = b3 + 4 | 0;
          f2 = (c2[h2 >> 2] | 0) - e3 | 0;
          d2 = (c2[g3 >> 2] | 0) + (0 - (f2 >> 3) << 3) | 0;
          c2[g3 >> 2] = d2;
          if ((f2 | 0) > 0) {
            BC(d2 | 0, e3 | 0, f2 | 0) | 0;
            e3 = g3;
            d2 = c2[g3 >> 2] | 0;
          } else
            e3 = g3;
          g3 = c2[a3 >> 2] | 0;
          c2[a3 >> 2] = d2;
          c2[e3 >> 2] = g3;
          g3 = b3 + 8 | 0;
          f2 = c2[h2 >> 2] | 0;
          c2[h2 >> 2] = c2[g3 >> 2];
          c2[g3 >> 2] = f2;
          g3 = a3 + 8 | 0;
          h2 = b3 + 12 | 0;
          a3 = c2[g3 >> 2] | 0;
          c2[g3 >> 2] = c2[h2 >> 2];
          c2[h2 >> 2] = a3;
          c2[b3 >> 2] = c2[e3 >> 2];
          return;
        }
        function Pz(a3) {
          a3 = a3 | 0;
          var b3 = 0, d2 = 0, e3 = 0;
          b3 = c2[a3 + 4 >> 2] | 0;
          d2 = a3 + 8 | 0;
          e3 = c2[d2 >> 2] | 0;
          if ((e3 | 0) != (b3 | 0))
            c2[d2 >> 2] = e3 + (~((e3 + -8 - b3 | 0) >>> 3) << 3);
          a3 = c2[a3 >> 2] | 0;
          if (a3 | 0)
            sC(a3);
          return;
        }
        function Qz(a3) {
          a3 = a3 | 0;
          Tz(a3);
          return;
        }
        function Rz(a3) {
          a3 = a3 | 0;
          Sz(a3 + 24 | 0);
          return;
        }
        function Sz(a3) {
          a3 = a3 | 0;
          var b3 = 0, d2 = 0, e3 = 0;
          d2 = c2[a3 >> 2] | 0;
          e3 = d2;
          if (d2 | 0) {
            a3 = a3 + 4 | 0;
            b3 = c2[a3 >> 2] | 0;
            if ((b3 | 0) != (d2 | 0))
              c2[a3 >> 2] = b3 + (~((b3 + -8 - e3 | 0) >>> 3) << 3);
            sC(d2);
          }
          return;
        }
        function Tz(a3) {
          a3 = a3 | 0;
          var b3 = 0;
          b3 = vi() | 0;
          yi(a3, 1, 1, b3, Uz() | 0, 5);
          c2[a3 + 24 >> 2] = 0;
          c2[a3 + 28 >> 2] = 0;
          c2[a3 + 32 >> 2] = 0;
          return;
        }
        function Uz() {
          return 1872;
        }
        function Vz(a3, b3, d2, e3, f2, g3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          e3 = e3 | 0;
          f2 = f2 | 0;
          g3 = g3 | 0;
          Xz(c2[(Wz(a3) | 0) >> 2] | 0, b3, d2, e3, f2, g3);
          return;
        }
        function Wz(a3) {
          a3 = a3 | 0;
          return (c2[(Hz() | 0) + 24 >> 2] | 0) + (a3 << 3) | 0;
        }
        function Xz(a3, b3, c3, d2, e3, f2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          c3 = c3 | 0;
          d2 = d2 | 0;
          e3 = e3 | 0;
          f2 = f2 | 0;
          var g3 = 0, h2 = 0, i4 = 0, j2 = 0, k2 = 0, m2 = 0;
          g3 = l2;
          l2 = l2 + 32 | 0;
          h2 = g3 + 16 | 0;
          i4 = g3 + 12 | 0;
          j2 = g3 + 8 | 0;
          k2 = g3 + 4 | 0;
          m2 = g3;
          ik(h2, b3);
          b3 = jk(h2, b3) | 0;
          ik(i4, c3);
          c3 = jk(i4, c3) | 0;
          ik(j2, d2);
          d2 = jk(j2, d2) | 0;
          ik(k2, e3);
          e3 = jk(k2, e3) | 0;
          ik(m2, f2);
          f2 = jk(m2, f2) | 0;
          jb[a3 & 1](b3, c3, d2, e3, f2);
          kk(m2);
          kk(k2);
          kk(j2);
          kk(i4);
          kk(h2);
          l2 = g3;
          return;
        }
        function Yz(a3, b3, d2, e3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          e3 = e3 | 0;
          var f2 = 0, g3 = 0;
          g3 = c2[a3 >> 2] | 0;
          f2 = Zz() | 0;
          a3 = _z(d2) | 0;
          fi(g3, b3, f2, a3, $z(d2, e3) | 0, e3);
          return;
        }
        function Zz() {
          var b3 = 0, d2 = 0;
          if (!(a2[8072] | 0)) {
            gA(11004);
            Ha(69, 11004, o2 | 0) | 0;
            d2 = 8072;
            c2[d2 >> 2] = 1;
            c2[d2 + 4 >> 2] = 0;
          }
          if (!(si(11004) | 0)) {
            b3 = 11004;
            d2 = b3 + 36 | 0;
            do {
              c2[b3 >> 2] = 0;
              b3 = b3 + 4 | 0;
            } while ((b3 | 0) < (d2 | 0));
            gA(11004);
          }
          return 11004;
        }
        function _z(a3) {
          a3 = a3 | 0;
          return a3 | 0;
        }
        function $z(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          var d2 = 0, e3 = 0, f2 = 0, g3 = 0, h2 = 0, i4 = 0, j2 = 0;
          i4 = l2;
          l2 = l2 + 16 | 0;
          f2 = i4;
          g3 = i4 + 4 | 0;
          c2[f2 >> 2] = a3;
          j2 = Zz() | 0;
          h2 = j2 + 24 | 0;
          b3 = ji(b3, 4) | 0;
          c2[g3 >> 2] = b3;
          d2 = j2 + 28 | 0;
          e3 = c2[d2 >> 2] | 0;
          if (e3 >>> 0 < (c2[j2 + 32 >> 2] | 0) >>> 0) {
            aA(e3, a3, b3);
            b3 = (c2[d2 >> 2] | 0) + 8 | 0;
            c2[d2 >> 2] = b3;
          } else {
            bA(h2, f2, g3);
            b3 = c2[d2 >> 2] | 0;
          }
          l2 = i4;
          return (b3 - (c2[h2 >> 2] | 0) >> 3) + -1 | 0;
        }
        function aA(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          c2[a3 >> 2] = b3;
          c2[a3 + 4 >> 2] = d2;
          return;
        }
        function bA(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          var e3 = 0, f2 = 0, g3 = 0, h2 = 0, i4 = 0, j2 = 0, k2 = 0, m2 = 0;
          i4 = l2;
          l2 = l2 + 32 | 0;
          f2 = i4;
          g3 = a3 + 4 | 0;
          h2 = ((c2[g3 >> 2] | 0) - (c2[a3 >> 2] | 0) >> 3) + 1 | 0;
          e3 = cA(a3) | 0;
          if (e3 >>> 0 < h2 >>> 0)
            jC(a3);
          else {
            j2 = c2[a3 >> 2] | 0;
            m2 = (c2[a3 + 8 >> 2] | 0) - j2 | 0;
            k2 = m2 >> 2;
            dA(f2, m2 >> 3 >>> 0 < e3 >>> 1 >>> 0 ? k2 >>> 0 < h2 >>> 0 ? h2 : k2 : e3, (c2[g3 >> 2] | 0) - j2 >> 3, a3 + 8 | 0);
            h2 = f2 + 8 | 0;
            aA(c2[h2 >> 2] | 0, c2[b3 >> 2] | 0, c2[d2 >> 2] | 0);
            c2[h2 >> 2] = (c2[h2 >> 2] | 0) + 8;
            eA(a3, f2);
            fA(f2);
            l2 = i4;
            return;
          }
        }
        function cA(a3) {
          a3 = a3 | 0;
          return 536870911;
        }
        function dA(a3, b3, d2, e3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          e3 = e3 | 0;
          var f2 = 0;
          c2[a3 + 12 >> 2] = 0;
          c2[a3 + 16 >> 2] = e3;
          do
            if (b3) {
              if (b3 >>> 0 > 536870911)
                Ta();
              else {
                f2 = qC(b3 << 3) | 0;
                break;
              }
            } else
              f2 = 0;
          while (0);
          c2[a3 >> 2] = f2;
          e3 = f2 + (d2 << 3) | 0;
          c2[a3 + 8 >> 2] = e3;
          c2[a3 + 4 >> 2] = e3;
          c2[a3 + 12 >> 2] = f2 + (b3 << 3);
          return;
        }
        function eA(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          var d2 = 0, e3 = 0, f2 = 0, g3 = 0, h2 = 0;
          e3 = c2[a3 >> 2] | 0;
          h2 = a3 + 4 | 0;
          g3 = b3 + 4 | 0;
          f2 = (c2[h2 >> 2] | 0) - e3 | 0;
          d2 = (c2[g3 >> 2] | 0) + (0 - (f2 >> 3) << 3) | 0;
          c2[g3 >> 2] = d2;
          if ((f2 | 0) > 0) {
            BC(d2 | 0, e3 | 0, f2 | 0) | 0;
            e3 = g3;
            d2 = c2[g3 >> 2] | 0;
          } else
            e3 = g3;
          g3 = c2[a3 >> 2] | 0;
          c2[a3 >> 2] = d2;
          c2[e3 >> 2] = g3;
          g3 = b3 + 8 | 0;
          f2 = c2[h2 >> 2] | 0;
          c2[h2 >> 2] = c2[g3 >> 2];
          c2[g3 >> 2] = f2;
          g3 = a3 + 8 | 0;
          h2 = b3 + 12 | 0;
          a3 = c2[g3 >> 2] | 0;
          c2[g3 >> 2] = c2[h2 >> 2];
          c2[h2 >> 2] = a3;
          c2[b3 >> 2] = c2[e3 >> 2];
          return;
        }
        function fA(a3) {
          a3 = a3 | 0;
          var b3 = 0, d2 = 0, e3 = 0;
          b3 = c2[a3 + 4 >> 2] | 0;
          d2 = a3 + 8 | 0;
          e3 = c2[d2 >> 2] | 0;
          if ((e3 | 0) != (b3 | 0))
            c2[d2 >> 2] = e3 + (~((e3 + -8 - b3 | 0) >>> 3) << 3);
          a3 = c2[a3 >> 2] | 0;
          if (a3 | 0)
            sC(a3);
          return;
        }
        function gA(a3) {
          a3 = a3 | 0;
          jA(a3);
          return;
        }
        function hA(a3) {
          a3 = a3 | 0;
          iA(a3 + 24 | 0);
          return;
        }
        function iA(a3) {
          a3 = a3 | 0;
          var b3 = 0, d2 = 0, e3 = 0;
          d2 = c2[a3 >> 2] | 0;
          e3 = d2;
          if (d2 | 0) {
            a3 = a3 + 4 | 0;
            b3 = c2[a3 >> 2] | 0;
            if ((b3 | 0) != (d2 | 0))
              c2[a3 >> 2] = b3 + (~((b3 + -8 - e3 | 0) >>> 3) << 3);
            sC(d2);
          }
          return;
        }
        function jA(a3) {
          a3 = a3 | 0;
          var b3 = 0;
          b3 = vi() | 0;
          yi(a3, 1, 12, b3, kA() | 0, 2);
          c2[a3 + 24 >> 2] = 0;
          c2[a3 + 28 >> 2] = 0;
          c2[a3 + 32 >> 2] = 0;
          return;
        }
        function kA() {
          return 1896;
        }
        function lA(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          nA(c2[(mA(a3) | 0) >> 2] | 0, b3, d2);
          return;
        }
        function mA(a3) {
          a3 = a3 | 0;
          return (c2[(Zz() | 0) + 24 >> 2] | 0) + (a3 << 3) | 0;
        }
        function nA(a3, b3, c3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          c3 = c3 | 0;
          var d2 = 0, e3 = 0, f2 = 0;
          d2 = l2;
          l2 = l2 + 16 | 0;
          f2 = d2 + 4 | 0;
          e3 = d2;
          oA(f2, b3);
          b3 = pA(f2, b3) | 0;
          ik(e3, c3);
          c3 = jk(e3, c3) | 0;
          ob[a3 & 31](b3, c3);
          kk(e3);
          l2 = d2;
          return;
        }
        function oA(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          return;
        }
        function pA(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          return qA(b3) | 0;
        }
        function qA(a3) {
          a3 = a3 | 0;
          return a3 | 0;
        }
        function rA() {
          var b3 = 0;
          if (!(a2[8080] | 0)) {
            sA(11040);
            Ha(70, 11040, o2 | 0) | 0;
            b3 = 8080;
            c2[b3 >> 2] = 1;
            c2[b3 + 4 >> 2] = 0;
          }
          if (!(si(11040) | 0))
            sA(11040);
          return 11040;
        }
        function sA(a3) {
          a3 = a3 | 0;
          vA(a3);
          Gt(a3, 71);
          return;
        }
        function tA(a3) {
          a3 = a3 | 0;
          uA(a3 + 24 | 0);
          return;
        }
        function uA(a3) {
          a3 = a3 | 0;
          var b3 = 0, d2 = 0, e3 = 0;
          d2 = c2[a3 >> 2] | 0;
          e3 = d2;
          if (d2 | 0) {
            a3 = a3 + 4 | 0;
            b3 = c2[a3 >> 2] | 0;
            if ((b3 | 0) != (d2 | 0))
              c2[a3 >> 2] = b3 + (~((b3 + -8 - e3 | 0) >>> 3) << 3);
            sC(d2);
          }
          return;
        }
        function vA(a3) {
          a3 = a3 | 0;
          var b3 = 0;
          b3 = vi() | 0;
          yi(a3, 5, 7, b3, zA() | 0, 0);
          c2[a3 + 24 >> 2] = 0;
          c2[a3 + 28 >> 2] = 0;
          c2[a3 + 32 >> 2] = 0;
          return;
        }
        function wA(a3) {
          a3 = a3 | 0;
          xA(a3);
          return;
        }
        function xA(a3) {
          a3 = a3 | 0;
          yA(a3);
          return;
        }
        function yA(b3) {
          b3 = b3 | 0;
          a2[b3 + 8 >> 0] = 1;
          return;
        }
        function zA() {
          return 1936;
        }
        function AA() {
          return BA() | 0;
        }
        function BA() {
          var a3 = 0, b3 = 0, d2 = 0, e3 = 0, f2 = 0, g3 = 0, h2 = 0;
          b3 = l2;
          l2 = l2 + 16 | 0;
          f2 = b3 + 4 | 0;
          h2 = b3;
          d2 = jy(8) | 0;
          a3 = d2;
          g3 = a3 + 4 | 0;
          c2[g3 >> 2] = qC(1) | 0;
          e3 = qC(8) | 0;
          g3 = c2[g3 >> 2] | 0;
          c2[h2 >> 2] = 0;
          c2[f2 >> 2] = c2[h2 >> 2];
          CA(e3, g3, f2);
          c2[d2 >> 2] = e3;
          l2 = b3;
          return a3 | 0;
        }
        function CA(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          c2[a3 >> 2] = b3;
          d2 = qC(16) | 0;
          c2[d2 + 4 >> 2] = 0;
          c2[d2 + 8 >> 2] = 0;
          c2[d2 >> 2] = 1916;
          c2[d2 + 12 >> 2] = b3;
          c2[a3 + 4 >> 2] = d2;
          return;
        }
        function DA(a3) {
          a3 = a3 | 0;
          kC(a3);
          sC(a3);
          return;
        }
        function EA(a3) {
          a3 = a3 | 0;
          a3 = c2[a3 + 12 >> 2] | 0;
          if (a3 | 0)
            sC(a3);
          return;
        }
        function FA(a3) {
          a3 = a3 | 0;
          sC(a3);
          return;
        }
        function GA() {
          var b3 = 0;
          if (!(a2[8088] | 0)) {
            NA(11076);
            Ha(25, 11076, o2 | 0) | 0;
            b3 = 8088;
            c2[b3 >> 2] = 1;
            c2[b3 + 4 >> 2] = 0;
          }
          return 11076;
        }
        function HA(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          c2[a3 >> 2] = IA() | 0;
          c2[a3 + 4 >> 2] = JA() | 0;
          c2[a3 + 12 >> 2] = b3;
          c2[a3 + 8 >> 2] = KA() | 0;
          c2[a3 + 32 >> 2] = 10;
          return;
        }
        function IA() {
          return 11745;
        }
        function JA() {
          return 1940;
        }
        function KA() {
          return lr() | 0;
        }
        function LA(a3, b3, c3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          c3 = c3 | 0;
          d2 = d2 | 0;
          if ((jr(d2, 896) | 0) == 512) {
            if (c3 | 0) {
              MA(c3);
              sC(c3);
            }
          } else if (b3 | 0)
            sC(b3);
          return;
        }
        function MA(a3) {
          a3 = a3 | 0;
          a3 = c2[a3 + 4 >> 2] | 0;
          if (a3 | 0)
            oC(a3);
          return;
        }
        function NA(a3) {
          a3 = a3 | 0;
          Zi(a3);
          return;
        }
        function OA(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          c2[a3 >> 2] = b3;
          return;
        }
        function PA(a3) {
          a3 = a3 | 0;
          return c2[a3 >> 2] | 0;
        }
        function QA(b3) {
          b3 = b3 | 0;
          return a2[c2[b3 >> 2] >> 0] | 0;
        }
        function RA(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          var d2 = 0, e3 = 0;
          d2 = l2;
          l2 = l2 + 16 | 0;
          e3 = d2;
          c2[e3 >> 2] = c2[a3 >> 2];
          SA(b3, e3) | 0;
          l2 = d2;
          return;
        }
        function SA(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          var d2 = 0;
          d2 = TA(c2[a3 >> 2] | 0, b3) | 0;
          b3 = a3 + 4 | 0;
          c2[(c2[b3 >> 2] | 0) + 8 >> 2] = d2;
          return c2[(c2[b3 >> 2] | 0) + 8 >> 2] | 0;
        }
        function TA(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          var d2 = 0, e3 = 0;
          d2 = l2;
          l2 = l2 + 16 | 0;
          e3 = d2;
          UA(e3);
          a3 = Sg(a3) | 0;
          b3 = VA(a3, c2[b3 >> 2] | 0) | 0;
          WA(e3);
          l2 = d2;
          return b3 | 0;
        }
        function UA(a3) {
          a3 = a3 | 0;
          c2[a3 >> 2] = c2[2701];
          c2[a3 + 4 >> 2] = c2[2703];
          return;
        }
        function VA(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          var c3 = 0;
          c3 = Vg(XA() | 0) | 0;
          return bb(0, c3 | 0, a3 | 0, sw(b3) | 0) | 0;
        }
        function WA(a3) {
          a3 = a3 | 0;
          xy(c2[a3 >> 2] | 0, c2[a3 + 4 >> 2] | 0);
          return;
        }
        function XA() {
          var b3 = 0;
          if (!(a2[8096] | 0)) {
            YA(11120);
            b3 = 8096;
            c2[b3 >> 2] = 1;
            c2[b3 + 4 >> 2] = 0;
          }
          return 11120;
        }
        function YA(a3) {
          a3 = a3 | 0;
          fh(a3, ZA() | 0, 1);
          return;
        }
        function ZA() {
          return 1948;
        }
        function _A() {
          $A();
          return;
        }
        function $A() {
          var b3 = 0, e3 = 0, f2 = 0, g3 = 0, h2 = 0, i4 = 0, j2 = 0, k2 = 0, m2 = 0, n3 = 0, o3 = 0, p2 = 0, q2 = 0, r3 = 0, s3 = 0, t3 = 0;
          s3 = l2;
          l2 = l2 + 16 | 0;
          o3 = s3 + 4 | 0;
          p2 = s3;
          Ea(65536, 10804, c2[2702] | 0, 10812);
          f2 = Wv() | 0;
          e3 = c2[f2 >> 2] | 0;
          b3 = c2[e3 >> 2] | 0;
          if (b3 | 0) {
            g3 = c2[f2 + 8 >> 2] | 0;
            f2 = c2[f2 + 4 >> 2] | 0;
            while (1) {
              Ma(b3 | 0, d[f2 >> 0] | 0 | 0, a2[g3 >> 0] | 0);
              e3 = e3 + 4 | 0;
              b3 = c2[e3 >> 2] | 0;
              if (!b3)
                break;
              else {
                g3 = g3 + 1 | 0;
                f2 = f2 + 1 | 0;
              }
            }
          }
          b3 = Yv() | 0;
          e3 = c2[b3 >> 2] | 0;
          if (e3 | 0)
            do {
              Na(e3 | 0, c2[b3 + 4 >> 2] | 0);
              b3 = b3 + 8 | 0;
              e3 = c2[b3 >> 2] | 0;
            } while ((e3 | 0) != 0);
          Na(aB() | 0, 5167);
          n3 = Iv() | 0;
          b3 = c2[n3 >> 2] | 0;
          a:
            do
              if (b3 | 0) {
                do {
                  bB(c2[b3 + 4 >> 2] | 0);
                  b3 = c2[b3 >> 2] | 0;
                } while ((b3 | 0) != 0);
                b3 = c2[n3 >> 2] | 0;
                if (b3 | 0) {
                  m2 = n3;
                  do {
                    while (1) {
                      h2 = b3;
                      b3 = c2[b3 >> 2] | 0;
                      h2 = c2[h2 + 4 >> 2] | 0;
                      if (!(cB(h2) | 0))
                        break;
                      c2[p2 >> 2] = m2;
                      c2[o3 >> 2] = c2[p2 >> 2];
                      dB(n3, o3) | 0;
                      if (!b3)
                        break a;
                    }
                    eB(h2);
                    m2 = c2[m2 >> 2] | 0;
                    e3 = fB(h2) | 0;
                    i4 = Va() | 0;
                    j2 = l2;
                    l2 = l2 + ((1 * (e3 << 2) | 0) + 15 & -16) | 0;
                    k2 = l2;
                    l2 = l2 + ((1 * (e3 << 2) | 0) + 15 & -16) | 0;
                    e3 = c2[(Zw(h2) | 0) >> 2] | 0;
                    if (e3 | 0) {
                      f2 = j2;
                      g3 = k2;
                      while (1) {
                        c2[f2 >> 2] = c2[(Xw(c2[e3 + 4 >> 2] | 0) | 0) >> 2];
                        c2[g3 >> 2] = c2[e3 + 8 >> 2];
                        e3 = c2[e3 >> 2] | 0;
                        if (!e3)
                          break;
                        else {
                          f2 = f2 + 4 | 0;
                          g3 = g3 + 4 | 0;
                        }
                      }
                    }
                    t3 = Xw(h2) | 0;
                    e3 = gB(h2) | 0;
                    f2 = fB(h2) | 0;
                    g3 = hB(h2) | 0;
                    Ra(t3 | 0, e3 | 0, j2 | 0, k2 | 0, f2 | 0, g3 | 0, Tv(h2) | 0);
                    Ga(i4 | 0);
                  } while ((b3 | 0) != 0);
                }
              }
            while (0);
          b3 = c2[(Vv() | 0) >> 2] | 0;
          if (b3 | 0)
            do {
              t3 = b3 + 4 | 0;
              n3 = aw(t3) | 0;
              h2 = fw(n3) | 0;
              i4 = bw(n3) | 0;
              j2 = (cw(n3) | 0) + 1 | 0;
              k2 = iB(n3) | 0;
              m2 = jB(t3) | 0;
              n3 = si(n3) | 0;
              o3 = hw(t3) | 0;
              p2 = kB(t3) | 0;
              Pa(0, h2 | 0, i4 | 0, j2 | 0, k2 | 0, m2 | 0, n3 | 0, o3 | 0, p2 | 0, lB(t3) | 0);
              b3 = c2[b3 >> 2] | 0;
            } while ((b3 | 0) != 0);
          b3 = c2[(Iv() | 0) >> 2] | 0;
          b:
            do
              if (b3 | 0) {
                c:
                  while (1) {
                    e3 = c2[b3 + 4 >> 2] | 0;
                    if (e3 | 0 ? (q2 = c2[(Xw(e3) | 0) >> 2] | 0, r3 = c2[(ax(e3) | 0) >> 2] | 0, r3 | 0) : 0) {
                      f2 = r3;
                      do {
                        e3 = f2 + 4 | 0;
                        g3 = aw(e3) | 0;
                        d:
                          do
                            if (g3 | 0)
                              switch (si(g3) | 0) {
                                case 0:
                                  break c;
                                case 4:
                                case 3:
                                case 2: {
                                  k2 = fw(g3) | 0;
                                  m2 = bw(g3) | 0;
                                  n3 = (cw(g3) | 0) + 1 | 0;
                                  o3 = iB(g3) | 0;
                                  p2 = si(g3) | 0;
                                  t3 = hw(e3) | 0;
                                  Pa(q2 | 0, k2 | 0, m2 | 0, n3 | 0, o3 | 0, 0, p2 | 0, t3 | 0, kB(e3) | 0, lB(e3) | 0);
                                  break d;
                                }
                                case 1: {
                                  j2 = fw(g3) | 0;
                                  k2 = bw(g3) | 0;
                                  m2 = (cw(g3) | 0) + 1 | 0;
                                  n3 = iB(g3) | 0;
                                  o3 = jB(e3) | 0;
                                  p2 = si(g3) | 0;
                                  t3 = hw(e3) | 0;
                                  Pa(q2 | 0, j2 | 0, k2 | 0, m2 | 0, n3 | 0, o3 | 0, p2 | 0, t3 | 0, kB(e3) | 0, lB(e3) | 0);
                                  break d;
                                }
                                case 5: {
                                  n3 = fw(g3) | 0;
                                  o3 = bw(g3) | 0;
                                  p2 = (cw(g3) | 0) + 1 | 0;
                                  t3 = iB(g3) | 0;
                                  Pa(q2 | 0, n3 | 0, o3 | 0, p2 | 0, t3 | 0, mB(g3) | 0, si(g3) | 0, 0, 0, 0);
                                  break d;
                                }
                                default:
                                  break d;
                              }
                          while (0);
                        f2 = c2[f2 >> 2] | 0;
                      } while ((f2 | 0) != 0);
                    }
                    b3 = c2[b3 >> 2] | 0;
                    if (!b3)
                      break b;
                  }
                Ta();
              }
            while (0);
          Sa();
          l2 = s3;
          return;
        }
        function aB() {
          return 11703;
        }
        function bB(b3) {
          b3 = b3 | 0;
          a2[b3 + 40 >> 0] = 0;
          return;
        }
        function cB(b3) {
          b3 = b3 | 0;
          return (a2[b3 + 40 >> 0] | 0) != 0 | 0;
        }
        function dB(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          b3 = nB(b3) | 0;
          a3 = c2[b3 >> 2] | 0;
          c2[b3 >> 2] = c2[a3 >> 2];
          sC(a3);
          return c2[b3 >> 2] | 0;
        }
        function eB(b3) {
          b3 = b3 | 0;
          a2[b3 + 40 >> 0] = 1;
          return;
        }
        function fB(a3) {
          a3 = a3 | 0;
          return c2[a3 + 20 >> 2] | 0;
        }
        function gB(a3) {
          a3 = a3 | 0;
          return c2[a3 + 8 >> 2] | 0;
        }
        function hB(a3) {
          a3 = a3 | 0;
          return c2[a3 + 32 >> 2] | 0;
        }
        function iB(a3) {
          a3 = a3 | 0;
          return c2[a3 + 4 >> 2] | 0;
        }
        function jB(a3) {
          a3 = a3 | 0;
          return c2[a3 + 4 >> 2] | 0;
        }
        function kB(a3) {
          a3 = a3 | 0;
          return c2[a3 + 8 >> 2] | 0;
        }
        function lB(a3) {
          a3 = a3 | 0;
          return c2[a3 + 16 >> 2] | 0;
        }
        function mB(a3) {
          a3 = a3 | 0;
          return c2[a3 + 20 >> 2] | 0;
        }
        function nB(a3) {
          a3 = a3 | 0;
          return c2[a3 >> 2] | 0;
        }
        function oB(a3) {
          a3 = a3 | 0;
          var b3 = 0, d2 = 0, e3 = 0, f2 = 0, g3 = 0, h2 = 0, i4 = 0, j2 = 0, k2 = 0, m2 = 0, n3 = 0, o3 = 0, p2 = 0, q2 = 0, r3 = 0, s3 = 0, t3 = 0, u3 = 0, v2 = 0, w2 = 0, x2 = 0;
          x2 = l2;
          l2 = l2 + 16 | 0;
          o3 = x2;
          do
            if (a3 >>> 0 < 245) {
              k2 = a3 >>> 0 < 11 ? 16 : a3 + 11 & -8;
              a3 = k2 >>> 3;
              n3 = c2[2783] | 0;
              d2 = n3 >>> a3;
              if (d2 & 3 | 0) {
                b3 = (d2 & 1 ^ 1) + a3 | 0;
                a3 = 11172 + (b3 << 1 << 2) | 0;
                d2 = a3 + 8 | 0;
                e3 = c2[d2 >> 2] | 0;
                f2 = e3 + 8 | 0;
                g3 = c2[f2 >> 2] | 0;
                if ((a3 | 0) == (g3 | 0))
                  c2[2783] = n3 & ~(1 << b3);
                else {
                  c2[g3 + 12 >> 2] = a3;
                  c2[d2 >> 2] = g3;
                }
                w2 = b3 << 3;
                c2[e3 + 4 >> 2] = w2 | 3;
                w2 = e3 + w2 + 4 | 0;
                c2[w2 >> 2] = c2[w2 >> 2] | 1;
                w2 = f2;
                l2 = x2;
                return w2 | 0;
              }
              m2 = c2[2785] | 0;
              if (k2 >>> 0 > m2 >>> 0) {
                if (d2 | 0) {
                  b3 = 2 << a3;
                  b3 = d2 << a3 & (b3 | 0 - b3);
                  b3 = (b3 & 0 - b3) + -1 | 0;
                  h2 = b3 >>> 12 & 16;
                  b3 = b3 >>> h2;
                  d2 = b3 >>> 5 & 8;
                  b3 = b3 >>> d2;
                  f2 = b3 >>> 2 & 4;
                  b3 = b3 >>> f2;
                  a3 = b3 >>> 1 & 2;
                  b3 = b3 >>> a3;
                  e3 = b3 >>> 1 & 1;
                  e3 = (d2 | h2 | f2 | a3 | e3) + (b3 >>> e3) | 0;
                  b3 = 11172 + (e3 << 1 << 2) | 0;
                  a3 = b3 + 8 | 0;
                  f2 = c2[a3 >> 2] | 0;
                  h2 = f2 + 8 | 0;
                  d2 = c2[h2 >> 2] | 0;
                  if ((b3 | 0) == (d2 | 0)) {
                    a3 = n3 & ~(1 << e3);
                    c2[2783] = a3;
                  } else {
                    c2[d2 + 12 >> 2] = b3;
                    c2[a3 >> 2] = d2;
                    a3 = n3;
                  }
                  g3 = (e3 << 3) - k2 | 0;
                  c2[f2 + 4 >> 2] = k2 | 3;
                  e3 = f2 + k2 | 0;
                  c2[e3 + 4 >> 2] = g3 | 1;
                  c2[e3 + g3 >> 2] = g3;
                  if (m2 | 0) {
                    f2 = c2[2788] | 0;
                    b3 = m2 >>> 3;
                    d2 = 11172 + (b3 << 1 << 2) | 0;
                    b3 = 1 << b3;
                    if (!(a3 & b3)) {
                      c2[2783] = a3 | b3;
                      b3 = d2;
                      a3 = d2 + 8 | 0;
                    } else {
                      a3 = d2 + 8 | 0;
                      b3 = c2[a3 >> 2] | 0;
                    }
                    c2[a3 >> 2] = f2;
                    c2[b3 + 12 >> 2] = f2;
                    c2[f2 + 8 >> 2] = b3;
                    c2[f2 + 12 >> 2] = d2;
                  }
                  c2[2785] = g3;
                  c2[2788] = e3;
                  w2 = h2;
                  l2 = x2;
                  return w2 | 0;
                }
                i4 = c2[2784] | 0;
                if (i4) {
                  d2 = (i4 & 0 - i4) + -1 | 0;
                  h2 = d2 >>> 12 & 16;
                  d2 = d2 >>> h2;
                  g3 = d2 >>> 5 & 8;
                  d2 = d2 >>> g3;
                  j2 = d2 >>> 2 & 4;
                  d2 = d2 >>> j2;
                  e3 = d2 >>> 1 & 2;
                  d2 = d2 >>> e3;
                  a3 = d2 >>> 1 & 1;
                  a3 = c2[11436 + ((g3 | h2 | j2 | e3 | a3) + (d2 >>> a3) << 2) >> 2] | 0;
                  d2 = (c2[a3 + 4 >> 2] & -8) - k2 | 0;
                  e3 = c2[a3 + 16 + (((c2[a3 + 16 >> 2] | 0) == 0 & 1) << 2) >> 2] | 0;
                  if (!e3) {
                    j2 = a3;
                    g3 = d2;
                  } else {
                    do {
                      h2 = (c2[e3 + 4 >> 2] & -8) - k2 | 0;
                      j2 = h2 >>> 0 < d2 >>> 0;
                      d2 = j2 ? h2 : d2;
                      a3 = j2 ? e3 : a3;
                      e3 = c2[e3 + 16 + (((c2[e3 + 16 >> 2] | 0) == 0 & 1) << 2) >> 2] | 0;
                    } while ((e3 | 0) != 0);
                    j2 = a3;
                    g3 = d2;
                  }
                  h2 = j2 + k2 | 0;
                  if (j2 >>> 0 < h2 >>> 0) {
                    f2 = c2[j2 + 24 >> 2] | 0;
                    b3 = c2[j2 + 12 >> 2] | 0;
                    do
                      if ((b3 | 0) == (j2 | 0)) {
                        a3 = j2 + 20 | 0;
                        b3 = c2[a3 >> 2] | 0;
                        if (!b3) {
                          a3 = j2 + 16 | 0;
                          b3 = c2[a3 >> 2] | 0;
                          if (!b3) {
                            d2 = 0;
                            break;
                          }
                        }
                        while (1) {
                          d2 = b3 + 20 | 0;
                          e3 = c2[d2 >> 2] | 0;
                          if (e3 | 0) {
                            b3 = e3;
                            a3 = d2;
                            continue;
                          }
                          d2 = b3 + 16 | 0;
                          e3 = c2[d2 >> 2] | 0;
                          if (!e3)
                            break;
                          else {
                            b3 = e3;
                            a3 = d2;
                          }
                        }
                        c2[a3 >> 2] = 0;
                        d2 = b3;
                      } else {
                        d2 = c2[j2 + 8 >> 2] | 0;
                        c2[d2 + 12 >> 2] = b3;
                        c2[b3 + 8 >> 2] = d2;
                        d2 = b3;
                      }
                    while (0);
                    do
                      if (f2 | 0) {
                        b3 = c2[j2 + 28 >> 2] | 0;
                        a3 = 11436 + (b3 << 2) | 0;
                        if ((j2 | 0) == (c2[a3 >> 2] | 0)) {
                          c2[a3 >> 2] = d2;
                          if (!d2) {
                            c2[2784] = i4 & ~(1 << b3);
                            break;
                          }
                        } else {
                          c2[f2 + 16 + (((c2[f2 + 16 >> 2] | 0) != (j2 | 0) & 1) << 2) >> 2] = d2;
                          if (!d2)
                            break;
                        }
                        c2[d2 + 24 >> 2] = f2;
                        b3 = c2[j2 + 16 >> 2] | 0;
                        if (b3 | 0) {
                          c2[d2 + 16 >> 2] = b3;
                          c2[b3 + 24 >> 2] = d2;
                        }
                        b3 = c2[j2 + 20 >> 2] | 0;
                        if (b3 | 0) {
                          c2[d2 + 20 >> 2] = b3;
                          c2[b3 + 24 >> 2] = d2;
                        }
                      }
                    while (0);
                    if (g3 >>> 0 < 16) {
                      w2 = g3 + k2 | 0;
                      c2[j2 + 4 >> 2] = w2 | 3;
                      w2 = j2 + w2 + 4 | 0;
                      c2[w2 >> 2] = c2[w2 >> 2] | 1;
                    } else {
                      c2[j2 + 4 >> 2] = k2 | 3;
                      c2[h2 + 4 >> 2] = g3 | 1;
                      c2[h2 + g3 >> 2] = g3;
                      if (m2 | 0) {
                        e3 = c2[2788] | 0;
                        b3 = m2 >>> 3;
                        d2 = 11172 + (b3 << 1 << 2) | 0;
                        b3 = 1 << b3;
                        if (!(n3 & b3)) {
                          c2[2783] = n3 | b3;
                          b3 = d2;
                          a3 = d2 + 8 | 0;
                        } else {
                          a3 = d2 + 8 | 0;
                          b3 = c2[a3 >> 2] | 0;
                        }
                        c2[a3 >> 2] = e3;
                        c2[b3 + 12 >> 2] = e3;
                        c2[e3 + 8 >> 2] = b3;
                        c2[e3 + 12 >> 2] = d2;
                      }
                      c2[2785] = g3;
                      c2[2788] = h2;
                    }
                    w2 = j2 + 8 | 0;
                    l2 = x2;
                    return w2 | 0;
                  } else
                    n3 = k2;
                } else
                  n3 = k2;
              } else
                n3 = k2;
            } else if (a3 >>> 0 <= 4294967231) {
              a3 = a3 + 11 | 0;
              k2 = a3 & -8;
              j2 = c2[2784] | 0;
              if (j2) {
                e3 = 0 - k2 | 0;
                a3 = a3 >>> 8;
                if (a3) {
                  if (k2 >>> 0 > 16777215)
                    i4 = 31;
                  else {
                    n3 = (a3 + 1048320 | 0) >>> 16 & 8;
                    v2 = a3 << n3;
                    m2 = (v2 + 520192 | 0) >>> 16 & 4;
                    v2 = v2 << m2;
                    i4 = (v2 + 245760 | 0) >>> 16 & 2;
                    i4 = 14 - (m2 | n3 | i4) + (v2 << i4 >>> 15) | 0;
                    i4 = k2 >>> (i4 + 7 | 0) & 1 | i4 << 1;
                  }
                } else
                  i4 = 0;
                d2 = c2[11436 + (i4 << 2) >> 2] | 0;
                a:
                  do
                    if (!d2) {
                      d2 = 0;
                      a3 = 0;
                      v2 = 57;
                    } else {
                      a3 = 0;
                      h2 = k2 << ((i4 | 0) == 31 ? 0 : 25 - (i4 >>> 1) | 0);
                      g3 = 0;
                      while (1) {
                        f2 = (c2[d2 + 4 >> 2] & -8) - k2 | 0;
                        if (f2 >>> 0 < e3 >>> 0)
                          if (!f2) {
                            a3 = d2;
                            e3 = 0;
                            f2 = d2;
                            v2 = 61;
                            break a;
                          } else {
                            a3 = d2;
                            e3 = f2;
                          }
                        f2 = c2[d2 + 20 >> 2] | 0;
                        d2 = c2[d2 + 16 + (h2 >>> 31 << 2) >> 2] | 0;
                        g3 = (f2 | 0) == 0 | (f2 | 0) == (d2 | 0) ? g3 : f2;
                        f2 = (d2 | 0) == 0;
                        if (f2) {
                          d2 = g3;
                          v2 = 57;
                          break;
                        } else
                          h2 = h2 << ((f2 ^ 1) & 1);
                      }
                    }
                  while (0);
                if ((v2 | 0) == 57) {
                  if ((d2 | 0) == 0 & (a3 | 0) == 0) {
                    a3 = 2 << i4;
                    a3 = j2 & (a3 | 0 - a3);
                    if (!a3) {
                      n3 = k2;
                      break;
                    }
                    n3 = (a3 & 0 - a3) + -1 | 0;
                    h2 = n3 >>> 12 & 16;
                    n3 = n3 >>> h2;
                    g3 = n3 >>> 5 & 8;
                    n3 = n3 >>> g3;
                    i4 = n3 >>> 2 & 4;
                    n3 = n3 >>> i4;
                    m2 = n3 >>> 1 & 2;
                    n3 = n3 >>> m2;
                    d2 = n3 >>> 1 & 1;
                    a3 = 0;
                    d2 = c2[11436 + ((g3 | h2 | i4 | m2 | d2) + (n3 >>> d2) << 2) >> 2] | 0;
                  }
                  if (!d2) {
                    i4 = a3;
                    h2 = e3;
                  } else {
                    f2 = d2;
                    v2 = 61;
                  }
                }
                if ((v2 | 0) == 61)
                  while (1) {
                    v2 = 0;
                    d2 = (c2[f2 + 4 >> 2] & -8) - k2 | 0;
                    n3 = d2 >>> 0 < e3 >>> 0;
                    d2 = n3 ? d2 : e3;
                    a3 = n3 ? f2 : a3;
                    f2 = c2[f2 + 16 + (((c2[f2 + 16 >> 2] | 0) == 0 & 1) << 2) >> 2] | 0;
                    if (!f2) {
                      i4 = a3;
                      h2 = d2;
                      break;
                    } else {
                      e3 = d2;
                      v2 = 61;
                    }
                  }
                if ((i4 | 0) != 0 ? h2 >>> 0 < ((c2[2785] | 0) - k2 | 0) >>> 0 : 0) {
                  g3 = i4 + k2 | 0;
                  if (i4 >>> 0 >= g3 >>> 0) {
                    w2 = 0;
                    l2 = x2;
                    return w2 | 0;
                  }
                  f2 = c2[i4 + 24 >> 2] | 0;
                  b3 = c2[i4 + 12 >> 2] | 0;
                  do
                    if ((b3 | 0) == (i4 | 0)) {
                      a3 = i4 + 20 | 0;
                      b3 = c2[a3 >> 2] | 0;
                      if (!b3) {
                        a3 = i4 + 16 | 0;
                        b3 = c2[a3 >> 2] | 0;
                        if (!b3) {
                          b3 = 0;
                          break;
                        }
                      }
                      while (1) {
                        d2 = b3 + 20 | 0;
                        e3 = c2[d2 >> 2] | 0;
                        if (e3 | 0) {
                          b3 = e3;
                          a3 = d2;
                          continue;
                        }
                        d2 = b3 + 16 | 0;
                        e3 = c2[d2 >> 2] | 0;
                        if (!e3)
                          break;
                        else {
                          b3 = e3;
                          a3 = d2;
                        }
                      }
                      c2[a3 >> 2] = 0;
                    } else {
                      w2 = c2[i4 + 8 >> 2] | 0;
                      c2[w2 + 12 >> 2] = b3;
                      c2[b3 + 8 >> 2] = w2;
                    }
                  while (0);
                  do
                    if (f2) {
                      a3 = c2[i4 + 28 >> 2] | 0;
                      d2 = 11436 + (a3 << 2) | 0;
                      if ((i4 | 0) == (c2[d2 >> 2] | 0)) {
                        c2[d2 >> 2] = b3;
                        if (!b3) {
                          e3 = j2 & ~(1 << a3);
                          c2[2784] = e3;
                          break;
                        }
                      } else {
                        c2[f2 + 16 + (((c2[f2 + 16 >> 2] | 0) != (i4 | 0) & 1) << 2) >> 2] = b3;
                        if (!b3) {
                          e3 = j2;
                          break;
                        }
                      }
                      c2[b3 + 24 >> 2] = f2;
                      a3 = c2[i4 + 16 >> 2] | 0;
                      if (a3 | 0) {
                        c2[b3 + 16 >> 2] = a3;
                        c2[a3 + 24 >> 2] = b3;
                      }
                      a3 = c2[i4 + 20 >> 2] | 0;
                      if (a3) {
                        c2[b3 + 20 >> 2] = a3;
                        c2[a3 + 24 >> 2] = b3;
                        e3 = j2;
                      } else
                        e3 = j2;
                    } else
                      e3 = j2;
                  while (0);
                  do
                    if (h2 >>> 0 >= 16) {
                      c2[i4 + 4 >> 2] = k2 | 3;
                      c2[g3 + 4 >> 2] = h2 | 1;
                      c2[g3 + h2 >> 2] = h2;
                      b3 = h2 >>> 3;
                      if (h2 >>> 0 < 256) {
                        d2 = 11172 + (b3 << 1 << 2) | 0;
                        a3 = c2[2783] | 0;
                        b3 = 1 << b3;
                        if (!(a3 & b3)) {
                          c2[2783] = a3 | b3;
                          b3 = d2;
                          a3 = d2 + 8 | 0;
                        } else {
                          a3 = d2 + 8 | 0;
                          b3 = c2[a3 >> 2] | 0;
                        }
                        c2[a3 >> 2] = g3;
                        c2[b3 + 12 >> 2] = g3;
                        c2[g3 + 8 >> 2] = b3;
                        c2[g3 + 12 >> 2] = d2;
                        break;
                      }
                      b3 = h2 >>> 8;
                      if (b3) {
                        if (h2 >>> 0 > 16777215)
                          b3 = 31;
                        else {
                          v2 = (b3 + 1048320 | 0) >>> 16 & 8;
                          w2 = b3 << v2;
                          u3 = (w2 + 520192 | 0) >>> 16 & 4;
                          w2 = w2 << u3;
                          b3 = (w2 + 245760 | 0) >>> 16 & 2;
                          b3 = 14 - (u3 | v2 | b3) + (w2 << b3 >>> 15) | 0;
                          b3 = h2 >>> (b3 + 7 | 0) & 1 | b3 << 1;
                        }
                      } else
                        b3 = 0;
                      d2 = 11436 + (b3 << 2) | 0;
                      c2[g3 + 28 >> 2] = b3;
                      a3 = g3 + 16 | 0;
                      c2[a3 + 4 >> 2] = 0;
                      c2[a3 >> 2] = 0;
                      a3 = 1 << b3;
                      if (!(e3 & a3)) {
                        c2[2784] = e3 | a3;
                        c2[d2 >> 2] = g3;
                        c2[g3 + 24 >> 2] = d2;
                        c2[g3 + 12 >> 2] = g3;
                        c2[g3 + 8 >> 2] = g3;
                        break;
                      }
                      a3 = h2 << ((b3 | 0) == 31 ? 0 : 25 - (b3 >>> 1) | 0);
                      d2 = c2[d2 >> 2] | 0;
                      while (1) {
                        if ((c2[d2 + 4 >> 2] & -8 | 0) == (h2 | 0)) {
                          v2 = 97;
                          break;
                        }
                        e3 = d2 + 16 + (a3 >>> 31 << 2) | 0;
                        b3 = c2[e3 >> 2] | 0;
                        if (!b3) {
                          v2 = 96;
                          break;
                        } else {
                          a3 = a3 << 1;
                          d2 = b3;
                        }
                      }
                      if ((v2 | 0) == 96) {
                        c2[e3 >> 2] = g3;
                        c2[g3 + 24 >> 2] = d2;
                        c2[g3 + 12 >> 2] = g3;
                        c2[g3 + 8 >> 2] = g3;
                        break;
                      } else if ((v2 | 0) == 97) {
                        v2 = d2 + 8 | 0;
                        w2 = c2[v2 >> 2] | 0;
                        c2[w2 + 12 >> 2] = g3;
                        c2[v2 >> 2] = g3;
                        c2[g3 + 8 >> 2] = w2;
                        c2[g3 + 12 >> 2] = d2;
                        c2[g3 + 24 >> 2] = 0;
                        break;
                      }
                    } else {
                      w2 = h2 + k2 | 0;
                      c2[i4 + 4 >> 2] = w2 | 3;
                      w2 = i4 + w2 + 4 | 0;
                      c2[w2 >> 2] = c2[w2 >> 2] | 1;
                    }
                  while (0);
                  w2 = i4 + 8 | 0;
                  l2 = x2;
                  return w2 | 0;
                } else
                  n3 = k2;
              } else
                n3 = k2;
            } else
              n3 = -1;
          while (0);
          d2 = c2[2785] | 0;
          if (d2 >>> 0 >= n3 >>> 0) {
            b3 = d2 - n3 | 0;
            a3 = c2[2788] | 0;
            if (b3 >>> 0 > 15) {
              w2 = a3 + n3 | 0;
              c2[2788] = w2;
              c2[2785] = b3;
              c2[w2 + 4 >> 2] = b3 | 1;
              c2[w2 + b3 >> 2] = b3;
              c2[a3 + 4 >> 2] = n3 | 3;
            } else {
              c2[2785] = 0;
              c2[2788] = 0;
              c2[a3 + 4 >> 2] = d2 | 3;
              w2 = a3 + d2 + 4 | 0;
              c2[w2 >> 2] = c2[w2 >> 2] | 1;
            }
            w2 = a3 + 8 | 0;
            l2 = x2;
            return w2 | 0;
          }
          h2 = c2[2786] | 0;
          if (h2 >>> 0 > n3 >>> 0) {
            u3 = h2 - n3 | 0;
            c2[2786] = u3;
            w2 = c2[2789] | 0;
            v2 = w2 + n3 | 0;
            c2[2789] = v2;
            c2[v2 + 4 >> 2] = u3 | 1;
            c2[w2 + 4 >> 2] = n3 | 3;
            w2 = w2 + 8 | 0;
            l2 = x2;
            return w2 | 0;
          }
          if (!(c2[2901] | 0)) {
            c2[2903] = 4096;
            c2[2902] = 4096;
            c2[2904] = -1;
            c2[2905] = -1;
            c2[2906] = 0;
            c2[2894] = 0;
            a3 = o3 & -16 ^ 1431655768;
            c2[o3 >> 2] = a3;
            c2[2901] = a3;
            a3 = 4096;
          } else
            a3 = c2[2903] | 0;
          i4 = n3 + 48 | 0;
          j2 = n3 + 47 | 0;
          g3 = a3 + j2 | 0;
          f2 = 0 - a3 | 0;
          k2 = g3 & f2;
          if (k2 >>> 0 <= n3 >>> 0) {
            w2 = 0;
            l2 = x2;
            return w2 | 0;
          }
          a3 = c2[2893] | 0;
          if (a3 | 0 ? (m2 = c2[2891] | 0, o3 = m2 + k2 | 0, o3 >>> 0 <= m2 >>> 0 | o3 >>> 0 > a3 >>> 0) : 0) {
            w2 = 0;
            l2 = x2;
            return w2 | 0;
          }
          b:
            do
              if (!(c2[2894] & 4)) {
                d2 = c2[2789] | 0;
                c:
                  do
                    if (d2) {
                      e3 = 11580;
                      while (1) {
                        a3 = c2[e3 >> 2] | 0;
                        if (a3 >>> 0 <= d2 >>> 0 ? (r3 = e3 + 4 | 0, (a3 + (c2[r3 >> 2] | 0) | 0) >>> 0 > d2 >>> 0) : 0)
                          break;
                        a3 = c2[e3 + 8 >> 2] | 0;
                        if (!a3) {
                          v2 = 118;
                          break c;
                        } else
                          e3 = a3;
                      }
                      b3 = g3 - h2 & f2;
                      if (b3 >>> 0 < 2147483647) {
                        a3 = FC(b3 | 0) | 0;
                        if ((a3 | 0) == ((c2[e3 >> 2] | 0) + (c2[r3 >> 2] | 0) | 0)) {
                          if ((a3 | 0) != (-1 | 0)) {
                            h2 = b3;
                            g3 = a3;
                            v2 = 135;
                            break b;
                          }
                        } else {
                          e3 = a3;
                          v2 = 126;
                        }
                      } else
                        b3 = 0;
                    } else
                      v2 = 118;
                  while (0);
                do
                  if ((v2 | 0) == 118) {
                    d2 = FC(0) | 0;
                    if ((d2 | 0) != (-1 | 0) ? (b3 = d2, p2 = c2[2902] | 0, q2 = p2 + -1 | 0, b3 = ((q2 & b3 | 0) == 0 ? 0 : (q2 + b3 & 0 - p2) - b3 | 0) + k2 | 0, p2 = c2[2891] | 0, q2 = b3 + p2 | 0, b3 >>> 0 > n3 >>> 0 & b3 >>> 0 < 2147483647) : 0) {
                      r3 = c2[2893] | 0;
                      if (r3 | 0 ? q2 >>> 0 <= p2 >>> 0 | q2 >>> 0 > r3 >>> 0 : 0) {
                        b3 = 0;
                        break;
                      }
                      a3 = FC(b3 | 0) | 0;
                      if ((a3 | 0) == (d2 | 0)) {
                        h2 = b3;
                        g3 = d2;
                        v2 = 135;
                        break b;
                      } else {
                        e3 = a3;
                        v2 = 126;
                      }
                    } else
                      b3 = 0;
                  }
                while (0);
                do
                  if ((v2 | 0) == 126) {
                    d2 = 0 - b3 | 0;
                    if (!(i4 >>> 0 > b3 >>> 0 & (b3 >>> 0 < 2147483647 & (e3 | 0) != (-1 | 0))))
                      if ((e3 | 0) == (-1 | 0)) {
                        b3 = 0;
                        break;
                      } else {
                        h2 = b3;
                        g3 = e3;
                        v2 = 135;
                        break b;
                      }
                    a3 = c2[2903] | 0;
                    a3 = j2 - b3 + a3 & 0 - a3;
                    if (a3 >>> 0 >= 2147483647) {
                      h2 = b3;
                      g3 = e3;
                      v2 = 135;
                      break b;
                    }
                    if ((FC(a3 | 0) | 0) == (-1 | 0)) {
                      FC(d2 | 0) | 0;
                      b3 = 0;
                      break;
                    } else {
                      h2 = a3 + b3 | 0;
                      g3 = e3;
                      v2 = 135;
                      break b;
                    }
                  }
                while (0);
                c2[2894] = c2[2894] | 4;
                v2 = 133;
              } else {
                b3 = 0;
                v2 = 133;
              }
            while (0);
          if (((v2 | 0) == 133 ? k2 >>> 0 < 2147483647 : 0) ? (u3 = FC(k2 | 0) | 0, r3 = FC(0) | 0, s3 = r3 - u3 | 0, t3 = s3 >>> 0 > (n3 + 40 | 0) >>> 0, !((u3 | 0) == (-1 | 0) | t3 ^ 1 | u3 >>> 0 < r3 >>> 0 & ((u3 | 0) != (-1 | 0) & (r3 | 0) != (-1 | 0)) ^ 1)) : 0) {
            h2 = t3 ? s3 : b3;
            g3 = u3;
            v2 = 135;
          }
          if ((v2 | 0) == 135) {
            b3 = (c2[2891] | 0) + h2 | 0;
            c2[2891] = b3;
            if (b3 >>> 0 > (c2[2892] | 0) >>> 0)
              c2[2892] = b3;
            j2 = c2[2789] | 0;
            do
              if (j2) {
                b3 = 11580;
                while (1) {
                  a3 = c2[b3 >> 2] | 0;
                  d2 = b3 + 4 | 0;
                  e3 = c2[d2 >> 2] | 0;
                  if ((g3 | 0) == (a3 + e3 | 0)) {
                    v2 = 145;
                    break;
                  }
                  f2 = c2[b3 + 8 >> 2] | 0;
                  if (!f2)
                    break;
                  else
                    b3 = f2;
                }
                if (((v2 | 0) == 145 ? (c2[b3 + 12 >> 2] & 8 | 0) == 0 : 0) ? j2 >>> 0 < g3 >>> 0 & j2 >>> 0 >= a3 >>> 0 : 0) {
                  c2[d2 >> 2] = e3 + h2;
                  w2 = j2 + 8 | 0;
                  w2 = (w2 & 7 | 0) == 0 ? 0 : 0 - w2 & 7;
                  v2 = j2 + w2 | 0;
                  w2 = (c2[2786] | 0) + (h2 - w2) | 0;
                  c2[2789] = v2;
                  c2[2786] = w2;
                  c2[v2 + 4 >> 2] = w2 | 1;
                  c2[v2 + w2 + 4 >> 2] = 40;
                  c2[2790] = c2[2905];
                  break;
                }
                if (g3 >>> 0 < (c2[2787] | 0) >>> 0)
                  c2[2787] = g3;
                d2 = g3 + h2 | 0;
                b3 = 11580;
                while (1) {
                  if ((c2[b3 >> 2] | 0) == (d2 | 0)) {
                    v2 = 153;
                    break;
                  }
                  a3 = c2[b3 + 8 >> 2] | 0;
                  if (!a3)
                    break;
                  else
                    b3 = a3;
                }
                if ((v2 | 0) == 153 ? (c2[b3 + 12 >> 2] & 8 | 0) == 0 : 0) {
                  c2[b3 >> 2] = g3;
                  m2 = b3 + 4 | 0;
                  c2[m2 >> 2] = (c2[m2 >> 2] | 0) + h2;
                  m2 = g3 + 8 | 0;
                  m2 = g3 + ((m2 & 7 | 0) == 0 ? 0 : 0 - m2 & 7) | 0;
                  b3 = d2 + 8 | 0;
                  b3 = d2 + ((b3 & 7 | 0) == 0 ? 0 : 0 - b3 & 7) | 0;
                  k2 = m2 + n3 | 0;
                  i4 = b3 - m2 - n3 | 0;
                  c2[m2 + 4 >> 2] = n3 | 3;
                  do
                    if ((b3 | 0) != (j2 | 0)) {
                      if ((b3 | 0) == (c2[2788] | 0)) {
                        w2 = (c2[2785] | 0) + i4 | 0;
                        c2[2785] = w2;
                        c2[2788] = k2;
                        c2[k2 + 4 >> 2] = w2 | 1;
                        c2[k2 + w2 >> 2] = w2;
                        break;
                      }
                      a3 = c2[b3 + 4 >> 2] | 0;
                      if ((a3 & 3 | 0) == 1) {
                        h2 = a3 & -8;
                        e3 = a3 >>> 3;
                        d:
                          do
                            if (a3 >>> 0 < 256) {
                              a3 = c2[b3 + 8 >> 2] | 0;
                              d2 = c2[b3 + 12 >> 2] | 0;
                              if ((d2 | 0) == (a3 | 0)) {
                                c2[2783] = c2[2783] & ~(1 << e3);
                                break;
                              } else {
                                c2[a3 + 12 >> 2] = d2;
                                c2[d2 + 8 >> 2] = a3;
                                break;
                              }
                            } else {
                              g3 = c2[b3 + 24 >> 2] | 0;
                              a3 = c2[b3 + 12 >> 2] | 0;
                              do
                                if ((a3 | 0) == (b3 | 0)) {
                                  e3 = b3 + 16 | 0;
                                  d2 = e3 + 4 | 0;
                                  a3 = c2[d2 >> 2] | 0;
                                  if (!a3) {
                                    a3 = c2[e3 >> 2] | 0;
                                    if (!a3) {
                                      a3 = 0;
                                      break;
                                    } else
                                      d2 = e3;
                                  }
                                  while (1) {
                                    e3 = a3 + 20 | 0;
                                    f2 = c2[e3 >> 2] | 0;
                                    if (f2 | 0) {
                                      a3 = f2;
                                      d2 = e3;
                                      continue;
                                    }
                                    e3 = a3 + 16 | 0;
                                    f2 = c2[e3 >> 2] | 0;
                                    if (!f2)
                                      break;
                                    else {
                                      a3 = f2;
                                      d2 = e3;
                                    }
                                  }
                                  c2[d2 >> 2] = 0;
                                } else {
                                  w2 = c2[b3 + 8 >> 2] | 0;
                                  c2[w2 + 12 >> 2] = a3;
                                  c2[a3 + 8 >> 2] = w2;
                                }
                              while (0);
                              if (!g3)
                                break;
                              d2 = c2[b3 + 28 >> 2] | 0;
                              e3 = 11436 + (d2 << 2) | 0;
                              do
                                if ((b3 | 0) != (c2[e3 >> 2] | 0)) {
                                  c2[g3 + 16 + (((c2[g3 + 16 >> 2] | 0) != (b3 | 0) & 1) << 2) >> 2] = a3;
                                  if (!a3)
                                    break d;
                                } else {
                                  c2[e3 >> 2] = a3;
                                  if (a3 | 0)
                                    break;
                                  c2[2784] = c2[2784] & ~(1 << d2);
                                  break d;
                                }
                              while (0);
                              c2[a3 + 24 >> 2] = g3;
                              d2 = b3 + 16 | 0;
                              e3 = c2[d2 >> 2] | 0;
                              if (e3 | 0) {
                                c2[a3 + 16 >> 2] = e3;
                                c2[e3 + 24 >> 2] = a3;
                              }
                              d2 = c2[d2 + 4 >> 2] | 0;
                              if (!d2)
                                break;
                              c2[a3 + 20 >> 2] = d2;
                              c2[d2 + 24 >> 2] = a3;
                            }
                          while (0);
                        b3 = b3 + h2 | 0;
                        f2 = h2 + i4 | 0;
                      } else
                        f2 = i4;
                      b3 = b3 + 4 | 0;
                      c2[b3 >> 2] = c2[b3 >> 2] & -2;
                      c2[k2 + 4 >> 2] = f2 | 1;
                      c2[k2 + f2 >> 2] = f2;
                      b3 = f2 >>> 3;
                      if (f2 >>> 0 < 256) {
                        d2 = 11172 + (b3 << 1 << 2) | 0;
                        a3 = c2[2783] | 0;
                        b3 = 1 << b3;
                        if (!(a3 & b3)) {
                          c2[2783] = a3 | b3;
                          b3 = d2;
                          a3 = d2 + 8 | 0;
                        } else {
                          a3 = d2 + 8 | 0;
                          b3 = c2[a3 >> 2] | 0;
                        }
                        c2[a3 >> 2] = k2;
                        c2[b3 + 12 >> 2] = k2;
                        c2[k2 + 8 >> 2] = b3;
                        c2[k2 + 12 >> 2] = d2;
                        break;
                      }
                      b3 = f2 >>> 8;
                      do
                        if (!b3)
                          b3 = 0;
                        else {
                          if (f2 >>> 0 > 16777215) {
                            b3 = 31;
                            break;
                          }
                          v2 = (b3 + 1048320 | 0) >>> 16 & 8;
                          w2 = b3 << v2;
                          u3 = (w2 + 520192 | 0) >>> 16 & 4;
                          w2 = w2 << u3;
                          b3 = (w2 + 245760 | 0) >>> 16 & 2;
                          b3 = 14 - (u3 | v2 | b3) + (w2 << b3 >>> 15) | 0;
                          b3 = f2 >>> (b3 + 7 | 0) & 1 | b3 << 1;
                        }
                      while (0);
                      e3 = 11436 + (b3 << 2) | 0;
                      c2[k2 + 28 >> 2] = b3;
                      a3 = k2 + 16 | 0;
                      c2[a3 + 4 >> 2] = 0;
                      c2[a3 >> 2] = 0;
                      a3 = c2[2784] | 0;
                      d2 = 1 << b3;
                      if (!(a3 & d2)) {
                        c2[2784] = a3 | d2;
                        c2[e3 >> 2] = k2;
                        c2[k2 + 24 >> 2] = e3;
                        c2[k2 + 12 >> 2] = k2;
                        c2[k2 + 8 >> 2] = k2;
                        break;
                      }
                      a3 = f2 << ((b3 | 0) == 31 ? 0 : 25 - (b3 >>> 1) | 0);
                      d2 = c2[e3 >> 2] | 0;
                      while (1) {
                        if ((c2[d2 + 4 >> 2] & -8 | 0) == (f2 | 0)) {
                          v2 = 194;
                          break;
                        }
                        e3 = d2 + 16 + (a3 >>> 31 << 2) | 0;
                        b3 = c2[e3 >> 2] | 0;
                        if (!b3) {
                          v2 = 193;
                          break;
                        } else {
                          a3 = a3 << 1;
                          d2 = b3;
                        }
                      }
                      if ((v2 | 0) == 193) {
                        c2[e3 >> 2] = k2;
                        c2[k2 + 24 >> 2] = d2;
                        c2[k2 + 12 >> 2] = k2;
                        c2[k2 + 8 >> 2] = k2;
                        break;
                      } else if ((v2 | 0) == 194) {
                        v2 = d2 + 8 | 0;
                        w2 = c2[v2 >> 2] | 0;
                        c2[w2 + 12 >> 2] = k2;
                        c2[v2 >> 2] = k2;
                        c2[k2 + 8 >> 2] = w2;
                        c2[k2 + 12 >> 2] = d2;
                        c2[k2 + 24 >> 2] = 0;
                        break;
                      }
                    } else {
                      w2 = (c2[2786] | 0) + i4 | 0;
                      c2[2786] = w2;
                      c2[2789] = k2;
                      c2[k2 + 4 >> 2] = w2 | 1;
                    }
                  while (0);
                  w2 = m2 + 8 | 0;
                  l2 = x2;
                  return w2 | 0;
                }
                b3 = 11580;
                while (1) {
                  a3 = c2[b3 >> 2] | 0;
                  if (a3 >>> 0 <= j2 >>> 0 ? (w2 = a3 + (c2[b3 + 4 >> 2] | 0) | 0, w2 >>> 0 > j2 >>> 0) : 0)
                    break;
                  b3 = c2[b3 + 8 >> 2] | 0;
                }
                f2 = w2 + -47 | 0;
                a3 = f2 + 8 | 0;
                a3 = f2 + ((a3 & 7 | 0) == 0 ? 0 : 0 - a3 & 7) | 0;
                f2 = j2 + 16 | 0;
                a3 = a3 >>> 0 < f2 >>> 0 ? j2 : a3;
                b3 = a3 + 8 | 0;
                d2 = g3 + 8 | 0;
                d2 = (d2 & 7 | 0) == 0 ? 0 : 0 - d2 & 7;
                v2 = g3 + d2 | 0;
                d2 = h2 + -40 - d2 | 0;
                c2[2789] = v2;
                c2[2786] = d2;
                c2[v2 + 4 >> 2] = d2 | 1;
                c2[v2 + d2 + 4 >> 2] = 40;
                c2[2790] = c2[2905];
                d2 = a3 + 4 | 0;
                c2[d2 >> 2] = 27;
                c2[b3 >> 2] = c2[2895];
                c2[b3 + 4 >> 2] = c2[2896];
                c2[b3 + 8 >> 2] = c2[2897];
                c2[b3 + 12 >> 2] = c2[2898];
                c2[2895] = g3;
                c2[2896] = h2;
                c2[2898] = 0;
                c2[2897] = b3;
                b3 = a3 + 24 | 0;
                do {
                  v2 = b3;
                  b3 = b3 + 4 | 0;
                  c2[b3 >> 2] = 7;
                } while ((v2 + 8 | 0) >>> 0 < w2 >>> 0);
                if ((a3 | 0) != (j2 | 0)) {
                  g3 = a3 - j2 | 0;
                  c2[d2 >> 2] = c2[d2 >> 2] & -2;
                  c2[j2 + 4 >> 2] = g3 | 1;
                  c2[a3 >> 2] = g3;
                  b3 = g3 >>> 3;
                  if (g3 >>> 0 < 256) {
                    d2 = 11172 + (b3 << 1 << 2) | 0;
                    a3 = c2[2783] | 0;
                    b3 = 1 << b3;
                    if (!(a3 & b3)) {
                      c2[2783] = a3 | b3;
                      b3 = d2;
                      a3 = d2 + 8 | 0;
                    } else {
                      a3 = d2 + 8 | 0;
                      b3 = c2[a3 >> 2] | 0;
                    }
                    c2[a3 >> 2] = j2;
                    c2[b3 + 12 >> 2] = j2;
                    c2[j2 + 8 >> 2] = b3;
                    c2[j2 + 12 >> 2] = d2;
                    break;
                  }
                  b3 = g3 >>> 8;
                  if (b3) {
                    if (g3 >>> 0 > 16777215)
                      d2 = 31;
                    else {
                      v2 = (b3 + 1048320 | 0) >>> 16 & 8;
                      w2 = b3 << v2;
                      u3 = (w2 + 520192 | 0) >>> 16 & 4;
                      w2 = w2 << u3;
                      d2 = (w2 + 245760 | 0) >>> 16 & 2;
                      d2 = 14 - (u3 | v2 | d2) + (w2 << d2 >>> 15) | 0;
                      d2 = g3 >>> (d2 + 7 | 0) & 1 | d2 << 1;
                    }
                  } else
                    d2 = 0;
                  e3 = 11436 + (d2 << 2) | 0;
                  c2[j2 + 28 >> 2] = d2;
                  c2[j2 + 20 >> 2] = 0;
                  c2[f2 >> 2] = 0;
                  b3 = c2[2784] | 0;
                  a3 = 1 << d2;
                  if (!(b3 & a3)) {
                    c2[2784] = b3 | a3;
                    c2[e3 >> 2] = j2;
                    c2[j2 + 24 >> 2] = e3;
                    c2[j2 + 12 >> 2] = j2;
                    c2[j2 + 8 >> 2] = j2;
                    break;
                  }
                  a3 = g3 << ((d2 | 0) == 31 ? 0 : 25 - (d2 >>> 1) | 0);
                  d2 = c2[e3 >> 2] | 0;
                  while (1) {
                    if ((c2[d2 + 4 >> 2] & -8 | 0) == (g3 | 0)) {
                      v2 = 216;
                      break;
                    }
                    e3 = d2 + 16 + (a3 >>> 31 << 2) | 0;
                    b3 = c2[e3 >> 2] | 0;
                    if (!b3) {
                      v2 = 215;
                      break;
                    } else {
                      a3 = a3 << 1;
                      d2 = b3;
                    }
                  }
                  if ((v2 | 0) == 215) {
                    c2[e3 >> 2] = j2;
                    c2[j2 + 24 >> 2] = d2;
                    c2[j2 + 12 >> 2] = j2;
                    c2[j2 + 8 >> 2] = j2;
                    break;
                  } else if ((v2 | 0) == 216) {
                    v2 = d2 + 8 | 0;
                    w2 = c2[v2 >> 2] | 0;
                    c2[w2 + 12 >> 2] = j2;
                    c2[v2 >> 2] = j2;
                    c2[j2 + 8 >> 2] = w2;
                    c2[j2 + 12 >> 2] = d2;
                    c2[j2 + 24 >> 2] = 0;
                    break;
                  }
                }
              } else {
                w2 = c2[2787] | 0;
                if ((w2 | 0) == 0 | g3 >>> 0 < w2 >>> 0)
                  c2[2787] = g3;
                c2[2895] = g3;
                c2[2896] = h2;
                c2[2898] = 0;
                c2[2792] = c2[2901];
                c2[2791] = -1;
                b3 = 0;
                do {
                  w2 = 11172 + (b3 << 1 << 2) | 0;
                  c2[w2 + 12 >> 2] = w2;
                  c2[w2 + 8 >> 2] = w2;
                  b3 = b3 + 1 | 0;
                } while ((b3 | 0) != 32);
                w2 = g3 + 8 | 0;
                w2 = (w2 & 7 | 0) == 0 ? 0 : 0 - w2 & 7;
                v2 = g3 + w2 | 0;
                w2 = h2 + -40 - w2 | 0;
                c2[2789] = v2;
                c2[2786] = w2;
                c2[v2 + 4 >> 2] = w2 | 1;
                c2[v2 + w2 + 4 >> 2] = 40;
                c2[2790] = c2[2905];
              }
            while (0);
            b3 = c2[2786] | 0;
            if (b3 >>> 0 > n3 >>> 0) {
              u3 = b3 - n3 | 0;
              c2[2786] = u3;
              w2 = c2[2789] | 0;
              v2 = w2 + n3 | 0;
              c2[2789] = v2;
              c2[v2 + 4 >> 2] = u3 | 1;
              c2[w2 + 4 >> 2] = n3 | 3;
              w2 = w2 + 8 | 0;
              l2 = x2;
              return w2 | 0;
            }
          }
          c2[(vB() | 0) >> 2] = 12;
          w2 = 0;
          l2 = x2;
          return w2 | 0;
        }
        function pB(a3) {
          a3 = a3 | 0;
          var b3 = 0, d2 = 0, e3 = 0, f2 = 0, g3 = 0, h2 = 0, i4 = 0, j2 = 0;
          if (!a3)
            return;
          d2 = a3 + -8 | 0;
          f2 = c2[2787] | 0;
          a3 = c2[a3 + -4 >> 2] | 0;
          b3 = a3 & -8;
          j2 = d2 + b3 | 0;
          do
            if (!(a3 & 1)) {
              e3 = c2[d2 >> 2] | 0;
              if (!(a3 & 3))
                return;
              h2 = d2 + (0 - e3) | 0;
              g3 = e3 + b3 | 0;
              if (h2 >>> 0 < f2 >>> 0)
                return;
              if ((h2 | 0) == (c2[2788] | 0)) {
                a3 = j2 + 4 | 0;
                b3 = c2[a3 >> 2] | 0;
                if ((b3 & 3 | 0) != 3) {
                  i4 = h2;
                  b3 = g3;
                  break;
                }
                c2[2785] = g3;
                c2[a3 >> 2] = b3 & -2;
                c2[h2 + 4 >> 2] = g3 | 1;
                c2[h2 + g3 >> 2] = g3;
                return;
              }
              d2 = e3 >>> 3;
              if (e3 >>> 0 < 256) {
                a3 = c2[h2 + 8 >> 2] | 0;
                b3 = c2[h2 + 12 >> 2] | 0;
                if ((b3 | 0) == (a3 | 0)) {
                  c2[2783] = c2[2783] & ~(1 << d2);
                  i4 = h2;
                  b3 = g3;
                  break;
                } else {
                  c2[a3 + 12 >> 2] = b3;
                  c2[b3 + 8 >> 2] = a3;
                  i4 = h2;
                  b3 = g3;
                  break;
                }
              }
              f2 = c2[h2 + 24 >> 2] | 0;
              a3 = c2[h2 + 12 >> 2] | 0;
              do
                if ((a3 | 0) == (h2 | 0)) {
                  d2 = h2 + 16 | 0;
                  b3 = d2 + 4 | 0;
                  a3 = c2[b3 >> 2] | 0;
                  if (!a3) {
                    a3 = c2[d2 >> 2] | 0;
                    if (!a3) {
                      a3 = 0;
                      break;
                    } else
                      b3 = d2;
                  }
                  while (1) {
                    d2 = a3 + 20 | 0;
                    e3 = c2[d2 >> 2] | 0;
                    if (e3 | 0) {
                      a3 = e3;
                      b3 = d2;
                      continue;
                    }
                    d2 = a3 + 16 | 0;
                    e3 = c2[d2 >> 2] | 0;
                    if (!e3)
                      break;
                    else {
                      a3 = e3;
                      b3 = d2;
                    }
                  }
                  c2[b3 >> 2] = 0;
                } else {
                  i4 = c2[h2 + 8 >> 2] | 0;
                  c2[i4 + 12 >> 2] = a3;
                  c2[a3 + 8 >> 2] = i4;
                }
              while (0);
              if (f2) {
                b3 = c2[h2 + 28 >> 2] | 0;
                d2 = 11436 + (b3 << 2) | 0;
                if ((h2 | 0) == (c2[d2 >> 2] | 0)) {
                  c2[d2 >> 2] = a3;
                  if (!a3) {
                    c2[2784] = c2[2784] & ~(1 << b3);
                    i4 = h2;
                    b3 = g3;
                    break;
                  }
                } else {
                  c2[f2 + 16 + (((c2[f2 + 16 >> 2] | 0) != (h2 | 0) & 1) << 2) >> 2] = a3;
                  if (!a3) {
                    i4 = h2;
                    b3 = g3;
                    break;
                  }
                }
                c2[a3 + 24 >> 2] = f2;
                b3 = h2 + 16 | 0;
                d2 = c2[b3 >> 2] | 0;
                if (d2 | 0) {
                  c2[a3 + 16 >> 2] = d2;
                  c2[d2 + 24 >> 2] = a3;
                }
                b3 = c2[b3 + 4 >> 2] | 0;
                if (b3) {
                  c2[a3 + 20 >> 2] = b3;
                  c2[b3 + 24 >> 2] = a3;
                  i4 = h2;
                  b3 = g3;
                } else {
                  i4 = h2;
                  b3 = g3;
                }
              } else {
                i4 = h2;
                b3 = g3;
              }
            } else {
              i4 = d2;
              h2 = d2;
            }
          while (0);
          if (h2 >>> 0 >= j2 >>> 0)
            return;
          a3 = j2 + 4 | 0;
          e3 = c2[a3 >> 2] | 0;
          if (!(e3 & 1))
            return;
          if (!(e3 & 2)) {
            a3 = c2[2788] | 0;
            if ((j2 | 0) == (c2[2789] | 0)) {
              j2 = (c2[2786] | 0) + b3 | 0;
              c2[2786] = j2;
              c2[2789] = i4;
              c2[i4 + 4 >> 2] = j2 | 1;
              if ((i4 | 0) != (a3 | 0))
                return;
              c2[2788] = 0;
              c2[2785] = 0;
              return;
            }
            if ((j2 | 0) == (a3 | 0)) {
              j2 = (c2[2785] | 0) + b3 | 0;
              c2[2785] = j2;
              c2[2788] = h2;
              c2[i4 + 4 >> 2] = j2 | 1;
              c2[h2 + j2 >> 2] = j2;
              return;
            }
            f2 = (e3 & -8) + b3 | 0;
            d2 = e3 >>> 3;
            do
              if (e3 >>> 0 < 256) {
                b3 = c2[j2 + 8 >> 2] | 0;
                a3 = c2[j2 + 12 >> 2] | 0;
                if ((a3 | 0) == (b3 | 0)) {
                  c2[2783] = c2[2783] & ~(1 << d2);
                  break;
                } else {
                  c2[b3 + 12 >> 2] = a3;
                  c2[a3 + 8 >> 2] = b3;
                  break;
                }
              } else {
                g3 = c2[j2 + 24 >> 2] | 0;
                a3 = c2[j2 + 12 >> 2] | 0;
                do
                  if ((a3 | 0) == (j2 | 0)) {
                    d2 = j2 + 16 | 0;
                    b3 = d2 + 4 | 0;
                    a3 = c2[b3 >> 2] | 0;
                    if (!a3) {
                      a3 = c2[d2 >> 2] | 0;
                      if (!a3) {
                        d2 = 0;
                        break;
                      } else
                        b3 = d2;
                    }
                    while (1) {
                      d2 = a3 + 20 | 0;
                      e3 = c2[d2 >> 2] | 0;
                      if (e3 | 0) {
                        a3 = e3;
                        b3 = d2;
                        continue;
                      }
                      d2 = a3 + 16 | 0;
                      e3 = c2[d2 >> 2] | 0;
                      if (!e3)
                        break;
                      else {
                        a3 = e3;
                        b3 = d2;
                      }
                    }
                    c2[b3 >> 2] = 0;
                    d2 = a3;
                  } else {
                    d2 = c2[j2 + 8 >> 2] | 0;
                    c2[d2 + 12 >> 2] = a3;
                    c2[a3 + 8 >> 2] = d2;
                    d2 = a3;
                  }
                while (0);
                if (g3 | 0) {
                  a3 = c2[j2 + 28 >> 2] | 0;
                  b3 = 11436 + (a3 << 2) | 0;
                  if ((j2 | 0) == (c2[b3 >> 2] | 0)) {
                    c2[b3 >> 2] = d2;
                    if (!d2) {
                      c2[2784] = c2[2784] & ~(1 << a3);
                      break;
                    }
                  } else {
                    c2[g3 + 16 + (((c2[g3 + 16 >> 2] | 0) != (j2 | 0) & 1) << 2) >> 2] = d2;
                    if (!d2)
                      break;
                  }
                  c2[d2 + 24 >> 2] = g3;
                  a3 = j2 + 16 | 0;
                  b3 = c2[a3 >> 2] | 0;
                  if (b3 | 0) {
                    c2[d2 + 16 >> 2] = b3;
                    c2[b3 + 24 >> 2] = d2;
                  }
                  a3 = c2[a3 + 4 >> 2] | 0;
                  if (a3 | 0) {
                    c2[d2 + 20 >> 2] = a3;
                    c2[a3 + 24 >> 2] = d2;
                  }
                }
              }
            while (0);
            c2[i4 + 4 >> 2] = f2 | 1;
            c2[h2 + f2 >> 2] = f2;
            if ((i4 | 0) == (c2[2788] | 0)) {
              c2[2785] = f2;
              return;
            }
          } else {
            c2[a3 >> 2] = e3 & -2;
            c2[i4 + 4 >> 2] = b3 | 1;
            c2[h2 + b3 >> 2] = b3;
            f2 = b3;
          }
          a3 = f2 >>> 3;
          if (f2 >>> 0 < 256) {
            d2 = 11172 + (a3 << 1 << 2) | 0;
            b3 = c2[2783] | 0;
            a3 = 1 << a3;
            if (!(b3 & a3)) {
              c2[2783] = b3 | a3;
              a3 = d2;
              b3 = d2 + 8 | 0;
            } else {
              b3 = d2 + 8 | 0;
              a3 = c2[b3 >> 2] | 0;
            }
            c2[b3 >> 2] = i4;
            c2[a3 + 12 >> 2] = i4;
            c2[i4 + 8 >> 2] = a3;
            c2[i4 + 12 >> 2] = d2;
            return;
          }
          a3 = f2 >>> 8;
          if (a3) {
            if (f2 >>> 0 > 16777215)
              a3 = 31;
            else {
              h2 = (a3 + 1048320 | 0) >>> 16 & 8;
              j2 = a3 << h2;
              g3 = (j2 + 520192 | 0) >>> 16 & 4;
              j2 = j2 << g3;
              a3 = (j2 + 245760 | 0) >>> 16 & 2;
              a3 = 14 - (g3 | h2 | a3) + (j2 << a3 >>> 15) | 0;
              a3 = f2 >>> (a3 + 7 | 0) & 1 | a3 << 1;
            }
          } else
            a3 = 0;
          e3 = 11436 + (a3 << 2) | 0;
          c2[i4 + 28 >> 2] = a3;
          c2[i4 + 20 >> 2] = 0;
          c2[i4 + 16 >> 2] = 0;
          b3 = c2[2784] | 0;
          d2 = 1 << a3;
          do
            if (b3 & d2) {
              b3 = f2 << ((a3 | 0) == 31 ? 0 : 25 - (a3 >>> 1) | 0);
              d2 = c2[e3 >> 2] | 0;
              while (1) {
                if ((c2[d2 + 4 >> 2] & -8 | 0) == (f2 | 0)) {
                  a3 = 73;
                  break;
                }
                e3 = d2 + 16 + (b3 >>> 31 << 2) | 0;
                a3 = c2[e3 >> 2] | 0;
                if (!a3) {
                  a3 = 72;
                  break;
                } else {
                  b3 = b3 << 1;
                  d2 = a3;
                }
              }
              if ((a3 | 0) == 72) {
                c2[e3 >> 2] = i4;
                c2[i4 + 24 >> 2] = d2;
                c2[i4 + 12 >> 2] = i4;
                c2[i4 + 8 >> 2] = i4;
                break;
              } else if ((a3 | 0) == 73) {
                h2 = d2 + 8 | 0;
                j2 = c2[h2 >> 2] | 0;
                c2[j2 + 12 >> 2] = i4;
                c2[h2 >> 2] = i4;
                c2[i4 + 8 >> 2] = j2;
                c2[i4 + 12 >> 2] = d2;
                c2[i4 + 24 >> 2] = 0;
                break;
              }
            } else {
              c2[2784] = b3 | d2;
              c2[e3 >> 2] = i4;
              c2[i4 + 24 >> 2] = e3;
              c2[i4 + 12 >> 2] = i4;
              c2[i4 + 8 >> 2] = i4;
            }
          while (0);
          j2 = (c2[2791] | 0) + -1 | 0;
          c2[2791] = j2;
          if (!j2)
            a3 = 11588;
          else
            return;
          while (1) {
            a3 = c2[a3 >> 2] | 0;
            if (!a3)
              break;
            else
              a3 = a3 + 8 | 0;
          }
          c2[2791] = -1;
          return;
        }
        function qB() {
          return 11628;
        }
        function rB(a3) {
          a3 = a3 | 0;
          var b3 = 0, d2 = 0;
          b3 = l2;
          l2 = l2 + 16 | 0;
          d2 = b3;
          c2[d2 >> 2] = yB(c2[a3 + 60 >> 2] | 0) | 0;
          a3 = uB(db(6, d2 | 0) | 0) | 0;
          l2 = b3;
          return a3 | 0;
        }
        function sB(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          var e3 = 0, f2 = 0, g3 = 0, h2 = 0, i4 = 0, j2 = 0, k2 = 0, m2 = 0, n3 = 0, o3 = 0, p2 = 0;
          n3 = l2;
          l2 = l2 + 48 | 0;
          k2 = n3 + 16 | 0;
          g3 = n3;
          f2 = n3 + 32 | 0;
          i4 = a3 + 28 | 0;
          e3 = c2[i4 >> 2] | 0;
          c2[f2 >> 2] = e3;
          j2 = a3 + 20 | 0;
          e3 = (c2[j2 >> 2] | 0) - e3 | 0;
          c2[f2 + 4 >> 2] = e3;
          c2[f2 + 8 >> 2] = b3;
          c2[f2 + 12 >> 2] = d2;
          e3 = e3 + d2 | 0;
          h2 = a3 + 60 | 0;
          c2[g3 >> 2] = c2[h2 >> 2];
          c2[g3 + 4 >> 2] = f2;
          c2[g3 + 8 >> 2] = 2;
          g3 = uB(gb(146, g3 | 0) | 0) | 0;
          a:
            do
              if ((e3 | 0) != (g3 | 0)) {
                b3 = 2;
                while (1) {
                  if ((g3 | 0) < 0)
                    break;
                  e3 = e3 - g3 | 0;
                  p2 = c2[f2 + 4 >> 2] | 0;
                  o3 = g3 >>> 0 > p2 >>> 0;
                  f2 = o3 ? f2 + 8 | 0 : f2;
                  b3 = (o3 << 31 >> 31) + b3 | 0;
                  p2 = g3 - (o3 ? p2 : 0) | 0;
                  c2[f2 >> 2] = (c2[f2 >> 2] | 0) + p2;
                  o3 = f2 + 4 | 0;
                  c2[o3 >> 2] = (c2[o3 >> 2] | 0) - p2;
                  c2[k2 >> 2] = c2[h2 >> 2];
                  c2[k2 + 4 >> 2] = f2;
                  c2[k2 + 8 >> 2] = b3;
                  g3 = uB(gb(146, k2 | 0) | 0) | 0;
                  if ((e3 | 0) == (g3 | 0)) {
                    m2 = 3;
                    break a;
                  }
                }
                c2[a3 + 16 >> 2] = 0;
                c2[i4 >> 2] = 0;
                c2[j2 >> 2] = 0;
                c2[a3 >> 2] = c2[a3 >> 2] | 32;
                if ((b3 | 0) == 2)
                  d2 = 0;
                else
                  d2 = d2 - (c2[f2 + 4 >> 2] | 0) | 0;
              } else
                m2 = 3;
            while (0);
          if ((m2 | 0) == 3) {
            p2 = c2[a3 + 44 >> 2] | 0;
            c2[a3 + 16 >> 2] = p2 + (c2[a3 + 48 >> 2] | 0);
            c2[i4 >> 2] = p2;
            c2[j2 >> 2] = p2;
          }
          l2 = n3;
          return d2 | 0;
        }
        function tB(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          var e3 = 0, f2 = 0, g3 = 0;
          f2 = l2;
          l2 = l2 + 32 | 0;
          g3 = f2;
          e3 = f2 + 20 | 0;
          c2[g3 >> 2] = c2[a3 + 60 >> 2];
          c2[g3 + 4 >> 2] = 0;
          c2[g3 + 8 >> 2] = b3;
          c2[g3 + 12 >> 2] = e3;
          c2[g3 + 16 >> 2] = d2;
          if ((uB(fb(140, g3 | 0) | 0) | 0) < 0) {
            c2[e3 >> 2] = -1;
            a3 = -1;
          } else
            a3 = c2[e3 >> 2] | 0;
          l2 = f2;
          return a3 | 0;
        }
        function uB(a3) {
          a3 = a3 | 0;
          if (a3 >>> 0 > 4294963200) {
            c2[(vB() | 0) >> 2] = 0 - a3;
            a3 = -1;
          }
          return a3 | 0;
        }
        function vB() {
          return (wB() | 0) + 64 | 0;
        }
        function wB() {
          return xB() | 0;
        }
        function xB() {
          return 2084;
        }
        function yB(a3) {
          a3 = a3 | 0;
          return a3 | 0;
        }
        function zB(b3, d2, e3) {
          b3 = b3 | 0;
          d2 = d2 | 0;
          e3 = e3 | 0;
          var f2 = 0, g3 = 0;
          g3 = l2;
          l2 = l2 + 32 | 0;
          f2 = g3;
          c2[b3 + 36 >> 2] = 1;
          if ((c2[b3 >> 2] & 64 | 0) == 0 ? (c2[f2 >> 2] = c2[b3 + 60 >> 2], c2[f2 + 4 >> 2] = 21523, c2[f2 + 8 >> 2] = g3 + 16, Wa(54, f2 | 0) | 0) : 0)
            a2[b3 + 75 >> 0] = -1;
          f2 = sB(b3, d2, e3) | 0;
          l2 = g3;
          return f2 | 0;
        }
        function AB(b3, c3) {
          b3 = b3 | 0;
          c3 = c3 | 0;
          var d2 = 0, e3 = 0;
          d2 = a2[b3 >> 0] | 0;
          e3 = a2[c3 >> 0] | 0;
          if (d2 << 24 >> 24 == 0 ? 1 : d2 << 24 >> 24 != e3 << 24 >> 24)
            b3 = e3;
          else {
            do {
              b3 = b3 + 1 | 0;
              c3 = c3 + 1 | 0;
              d2 = a2[b3 >> 0] | 0;
              e3 = a2[c3 >> 0] | 0;
            } while (!(d2 << 24 >> 24 == 0 ? 1 : d2 << 24 >> 24 != e3 << 24 >> 24));
            b3 = e3;
          }
          return (d2 & 255) - (b3 & 255) | 0;
        }
        function BB(b3, c3, d2) {
          b3 = b3 | 0;
          c3 = c3 | 0;
          d2 = d2 | 0;
          var e3 = 0, f2 = 0;
          a:
            do
              if (!d2)
                b3 = 0;
              else {
                while (1) {
                  e3 = a2[b3 >> 0] | 0;
                  f2 = a2[c3 >> 0] | 0;
                  if (e3 << 24 >> 24 != f2 << 24 >> 24)
                    break;
                  d2 = d2 + -1 | 0;
                  if (!d2) {
                    b3 = 0;
                    break a;
                  } else {
                    b3 = b3 + 1 | 0;
                    c3 = c3 + 1 | 0;
                  }
                }
                b3 = (e3 & 255) - (f2 & 255) | 0;
              }
            while (0);
          return b3 | 0;
        }
        function CB(b3, d2, e3) {
          b3 = b3 | 0;
          d2 = d2 | 0;
          e3 = e3 | 0;
          var f2 = 0, g3 = 0, h2 = 0, i4 = 0, j2 = 0, k2 = 0, m2 = 0, n3 = 0, o3 = 0, p2 = 0, q2 = 0, r3 = 0, s3 = 0;
          s3 = l2;
          l2 = l2 + 224 | 0;
          n3 = s3 + 120 | 0;
          o3 = s3 + 80 | 0;
          q2 = s3;
          r3 = s3 + 136 | 0;
          f2 = o3;
          g3 = f2 + 40 | 0;
          do {
            c2[f2 >> 2] = 0;
            f2 = f2 + 4 | 0;
          } while ((f2 | 0) < (g3 | 0));
          c2[n3 >> 2] = c2[e3 >> 2];
          if ((DB(0, d2, n3, q2, o3) | 0) < 0)
            e3 = -1;
          else {
            if ((c2[b3 + 76 >> 2] | 0) > -1)
              p2 = EB(b3) | 0;
            else
              p2 = 0;
            e3 = c2[b3 >> 2] | 0;
            m2 = e3 & 32;
            if ((a2[b3 + 74 >> 0] | 0) < 1)
              c2[b3 >> 2] = e3 & -33;
            f2 = b3 + 48 | 0;
            if (!(c2[f2 >> 2] | 0)) {
              g3 = b3 + 44 | 0;
              h2 = c2[g3 >> 2] | 0;
              c2[g3 >> 2] = r3;
              i4 = b3 + 28 | 0;
              c2[i4 >> 2] = r3;
              j2 = b3 + 20 | 0;
              c2[j2 >> 2] = r3;
              c2[f2 >> 2] = 80;
              k2 = b3 + 16 | 0;
              c2[k2 >> 2] = r3 + 80;
              e3 = DB(b3, d2, n3, q2, o3) | 0;
              if (h2) {
                sb[c2[b3 + 36 >> 2] & 7](b3, 0, 0) | 0;
                e3 = (c2[j2 >> 2] | 0) == 0 ? -1 : e3;
                c2[g3 >> 2] = h2;
                c2[f2 >> 2] = 0;
                c2[k2 >> 2] = 0;
                c2[i4 >> 2] = 0;
                c2[j2 >> 2] = 0;
              }
            } else
              e3 = DB(b3, d2, n3, q2, o3) | 0;
            f2 = c2[b3 >> 2] | 0;
            c2[b3 >> 2] = f2 | m2;
            if (p2 | 0)
              FB(b3);
            e3 = (f2 & 32 | 0) == 0 ? e3 : -1;
          }
          l2 = s3;
          return e3 | 0;
        }
        function DB(d2, e3, f2, g3, i4) {
          d2 = d2 | 0;
          e3 = e3 | 0;
          f2 = f2 | 0;
          g3 = g3 | 0;
          i4 = i4 | 0;
          var j2 = 0, k2 = 0, m2 = 0, n3 = 0, o3 = 0, p2 = 0, q2 = 0, r3 = 0, s3 = 0, t3 = 0, u3 = 0, v2 = 0, w2 = 0, x2 = 0, y3 = 0, z2 = 0, B2 = 0, C2 = 0, D2 = 0, E2 = 0, F2 = 0, G2 = 0, H2 = 0;
          H2 = l2;
          l2 = l2 + 64 | 0;
          D2 = H2 + 16 | 0;
          E2 = H2;
          B2 = H2 + 24 | 0;
          F2 = H2 + 8 | 0;
          G2 = H2 + 20 | 0;
          c2[D2 >> 2] = e3;
          x2 = (d2 | 0) != 0;
          y3 = B2 + 40 | 0;
          z2 = y3;
          B2 = B2 + 39 | 0;
          C2 = F2 + 4 | 0;
          k2 = 0;
          j2 = 0;
          p2 = 0;
          a:
            while (1) {
              do
                if ((j2 | 0) > -1)
                  if ((k2 | 0) > (2147483647 - j2 | 0)) {
                    c2[(vB() | 0) >> 2] = 75;
                    j2 = -1;
                    break;
                  } else {
                    j2 = k2 + j2 | 0;
                    break;
                  }
              while (0);
              k2 = a2[e3 >> 0] | 0;
              if (!(k2 << 24 >> 24)) {
                w2 = 87;
                break;
              } else
                m2 = e3;
              b:
                while (1) {
                  switch (k2 << 24 >> 24) {
                    case 37: {
                      k2 = m2;
                      w2 = 9;
                      break b;
                    }
                    case 0: {
                      k2 = m2;
                      break b;
                    }
                    default: {
                    }
                  }
                  v2 = m2 + 1 | 0;
                  c2[D2 >> 2] = v2;
                  k2 = a2[v2 >> 0] | 0;
                  m2 = v2;
                }
              c:
                do
                  if ((w2 | 0) == 9)
                    while (1) {
                      w2 = 0;
                      if ((a2[m2 + 1 >> 0] | 0) != 37)
                        break c;
                      k2 = k2 + 1 | 0;
                      m2 = m2 + 2 | 0;
                      c2[D2 >> 2] = m2;
                      if ((a2[m2 >> 0] | 0) == 37)
                        w2 = 9;
                      else
                        break;
                    }
                while (0);
              k2 = k2 - e3 | 0;
              if (x2)
                GB(d2, e3, k2);
              if (k2 | 0) {
                e3 = m2;
                continue;
              }
              n3 = m2 + 1 | 0;
              k2 = (a2[n3 >> 0] | 0) + -48 | 0;
              if (k2 >>> 0 < 10) {
                v2 = (a2[m2 + 2 >> 0] | 0) == 36;
                u3 = v2 ? k2 : -1;
                p2 = v2 ? 1 : p2;
                n3 = v2 ? m2 + 3 | 0 : n3;
              } else
                u3 = -1;
              c2[D2 >> 2] = n3;
              k2 = a2[n3 >> 0] | 0;
              m2 = (k2 << 24 >> 24) + -32 | 0;
              d:
                do
                  if (m2 >>> 0 < 32) {
                    o3 = 0;
                    q2 = k2;
                    while (1) {
                      k2 = 1 << m2;
                      if (!(k2 & 75913)) {
                        k2 = q2;
                        break d;
                      }
                      o3 = k2 | o3;
                      n3 = n3 + 1 | 0;
                      c2[D2 >> 2] = n3;
                      k2 = a2[n3 >> 0] | 0;
                      m2 = (k2 << 24 >> 24) + -32 | 0;
                      if (m2 >>> 0 >= 32)
                        break;
                      else
                        q2 = k2;
                    }
                  } else
                    o3 = 0;
                while (0);
              if (k2 << 24 >> 24 == 42) {
                m2 = n3 + 1 | 0;
                k2 = (a2[m2 >> 0] | 0) + -48 | 0;
                if (k2 >>> 0 < 10 ? (a2[n3 + 2 >> 0] | 0) == 36 : 0) {
                  c2[i4 + (k2 << 2) >> 2] = 10;
                  k2 = c2[g3 + ((a2[m2 >> 0] | 0) + -48 << 3) >> 2] | 0;
                  p2 = 1;
                  n3 = n3 + 3 | 0;
                } else {
                  if (p2 | 0) {
                    j2 = -1;
                    break;
                  }
                  if (x2) {
                    p2 = (c2[f2 >> 2] | 0) + (4 - 1) & ~(4 - 1);
                    k2 = c2[p2 >> 2] | 0;
                    c2[f2 >> 2] = p2 + 4;
                    p2 = 0;
                    n3 = m2;
                  } else {
                    k2 = 0;
                    p2 = 0;
                    n3 = m2;
                  }
                }
                c2[D2 >> 2] = n3;
                v2 = (k2 | 0) < 0;
                k2 = v2 ? 0 - k2 | 0 : k2;
                o3 = v2 ? o3 | 8192 : o3;
              } else {
                k2 = HB(D2) | 0;
                if ((k2 | 0) < 0) {
                  j2 = -1;
                  break;
                }
                n3 = c2[D2 >> 2] | 0;
              }
              do
                if ((a2[n3 >> 0] | 0) == 46) {
                  if ((a2[n3 + 1 >> 0] | 0) != 42) {
                    c2[D2 >> 2] = n3 + 1;
                    m2 = HB(D2) | 0;
                    n3 = c2[D2 >> 2] | 0;
                    break;
                  }
                  q2 = n3 + 2 | 0;
                  m2 = (a2[q2 >> 0] | 0) + -48 | 0;
                  if (m2 >>> 0 < 10 ? (a2[n3 + 3 >> 0] | 0) == 36 : 0) {
                    c2[i4 + (m2 << 2) >> 2] = 10;
                    m2 = c2[g3 + ((a2[q2 >> 0] | 0) + -48 << 3) >> 2] | 0;
                    n3 = n3 + 4 | 0;
                    c2[D2 >> 2] = n3;
                    break;
                  }
                  if (p2 | 0) {
                    j2 = -1;
                    break a;
                  }
                  if (x2) {
                    v2 = (c2[f2 >> 2] | 0) + (4 - 1) & ~(4 - 1);
                    m2 = c2[v2 >> 2] | 0;
                    c2[f2 >> 2] = v2 + 4;
                  } else
                    m2 = 0;
                  c2[D2 >> 2] = q2;
                  n3 = q2;
                } else
                  m2 = -1;
              while (0);
              t3 = 0;
              while (1) {
                if (((a2[n3 >> 0] | 0) + -65 | 0) >>> 0 > 57) {
                  j2 = -1;
                  break a;
                }
                v2 = n3 + 1 | 0;
                c2[D2 >> 2] = v2;
                q2 = a2[(a2[n3 >> 0] | 0) + -65 + (5178 + (t3 * 58 | 0)) >> 0] | 0;
                r3 = q2 & 255;
                if ((r3 + -1 | 0) >>> 0 < 8) {
                  t3 = r3;
                  n3 = v2;
                } else
                  break;
              }
              if (!(q2 << 24 >> 24)) {
                j2 = -1;
                break;
              }
              s3 = (u3 | 0) > -1;
              do
                if (q2 << 24 >> 24 == 19) {
                  if (s3) {
                    j2 = -1;
                    break a;
                  } else
                    w2 = 49;
                } else {
                  if (s3) {
                    c2[i4 + (u3 << 2) >> 2] = r3;
                    s3 = g3 + (u3 << 3) | 0;
                    u3 = c2[s3 + 4 >> 2] | 0;
                    w2 = E2;
                    c2[w2 >> 2] = c2[s3 >> 2];
                    c2[w2 + 4 >> 2] = u3;
                    w2 = 49;
                    break;
                  }
                  if (!x2) {
                    j2 = 0;
                    break a;
                  }
                  IB(E2, r3, f2);
                }
              while (0);
              if ((w2 | 0) == 49 ? (w2 = 0, !x2) : 0) {
                k2 = 0;
                e3 = v2;
                continue;
              }
              n3 = a2[n3 >> 0] | 0;
              n3 = (t3 | 0) != 0 & (n3 & 15 | 0) == 3 ? n3 & -33 : n3;
              s3 = o3 & -65537;
              u3 = (o3 & 8192 | 0) == 0 ? o3 : s3;
              e:
                do
                  switch (n3 | 0) {
                    case 110:
                      switch ((t3 & 255) << 24 >> 24) {
                        case 0: {
                          c2[c2[E2 >> 2] >> 2] = j2;
                          k2 = 0;
                          e3 = v2;
                          continue a;
                        }
                        case 1: {
                          c2[c2[E2 >> 2] >> 2] = j2;
                          k2 = 0;
                          e3 = v2;
                          continue a;
                        }
                        case 2: {
                          k2 = c2[E2 >> 2] | 0;
                          c2[k2 >> 2] = j2;
                          c2[k2 + 4 >> 2] = ((j2 | 0) < 0) << 31 >> 31;
                          k2 = 0;
                          e3 = v2;
                          continue a;
                        }
                        case 3: {
                          b2[c2[E2 >> 2] >> 1] = j2;
                          k2 = 0;
                          e3 = v2;
                          continue a;
                        }
                        case 4: {
                          a2[c2[E2 >> 2] >> 0] = j2;
                          k2 = 0;
                          e3 = v2;
                          continue a;
                        }
                        case 6: {
                          c2[c2[E2 >> 2] >> 2] = j2;
                          k2 = 0;
                          e3 = v2;
                          continue a;
                        }
                        case 7: {
                          k2 = c2[E2 >> 2] | 0;
                          c2[k2 >> 2] = j2;
                          c2[k2 + 4 >> 2] = ((j2 | 0) < 0) << 31 >> 31;
                          k2 = 0;
                          e3 = v2;
                          continue a;
                        }
                        default: {
                          k2 = 0;
                          e3 = v2;
                          continue a;
                        }
                      }
                    case 112: {
                      n3 = 120;
                      m2 = m2 >>> 0 > 8 ? m2 : 8;
                      e3 = u3 | 8;
                      w2 = 61;
                      break;
                    }
                    case 88:
                    case 120: {
                      e3 = u3;
                      w2 = 61;
                      break;
                    }
                    case 111: {
                      n3 = E2;
                      e3 = c2[n3 >> 2] | 0;
                      n3 = c2[n3 + 4 >> 2] | 0;
                      r3 = KB(e3, n3, y3) | 0;
                      s3 = z2 - r3 | 0;
                      o3 = 0;
                      q2 = 5642;
                      m2 = (u3 & 8 | 0) == 0 | (m2 | 0) > (s3 | 0) ? m2 : s3 + 1 | 0;
                      s3 = u3;
                      w2 = 67;
                      break;
                    }
                    case 105:
                    case 100: {
                      n3 = E2;
                      e3 = c2[n3 >> 2] | 0;
                      n3 = c2[n3 + 4 >> 2] | 0;
                      if ((n3 | 0) < 0) {
                        e3 = wC(0, 0, e3 | 0, n3 | 0) | 0;
                        n3 = A;
                        o3 = E2;
                        c2[o3 >> 2] = e3;
                        c2[o3 + 4 >> 2] = n3;
                        o3 = 1;
                        q2 = 5642;
                        w2 = 66;
                        break e;
                      } else {
                        o3 = (u3 & 2049 | 0) != 0 & 1;
                        q2 = (u3 & 2048 | 0) == 0 ? (u3 & 1 | 0) == 0 ? 5642 : 5644 : 5643;
                        w2 = 66;
                        break e;
                      }
                    }
                    case 117: {
                      n3 = E2;
                      o3 = 0;
                      q2 = 5642;
                      e3 = c2[n3 >> 2] | 0;
                      n3 = c2[n3 + 4 >> 2] | 0;
                      w2 = 66;
                      break;
                    }
                    case 99: {
                      a2[B2 >> 0] = c2[E2 >> 2];
                      e3 = B2;
                      o3 = 0;
                      q2 = 5642;
                      r3 = y3;
                      n3 = 1;
                      m2 = s3;
                      break;
                    }
                    case 109: {
                      n3 = MB(c2[(vB() | 0) >> 2] | 0) | 0;
                      w2 = 71;
                      break;
                    }
                    case 115: {
                      n3 = c2[E2 >> 2] | 0;
                      n3 = n3 | 0 ? n3 : 5652;
                      w2 = 71;
                      break;
                    }
                    case 67: {
                      c2[F2 >> 2] = c2[E2 >> 2];
                      c2[C2 >> 2] = 0;
                      c2[E2 >> 2] = F2;
                      r3 = -1;
                      n3 = F2;
                      w2 = 75;
                      break;
                    }
                    case 83: {
                      e3 = c2[E2 >> 2] | 0;
                      if (!m2) {
                        OB(d2, 32, k2, 0, u3);
                        e3 = 0;
                        w2 = 84;
                      } else {
                        r3 = m2;
                        n3 = e3;
                        w2 = 75;
                      }
                      break;
                    }
                    case 65:
                    case 71:
                    case 70:
                    case 69:
                    case 97:
                    case 103:
                    case 102:
                    case 101: {
                      k2 = QB(d2, +h[E2 >> 3], k2, m2, u3, n3) | 0;
                      e3 = v2;
                      continue a;
                    }
                    default: {
                      o3 = 0;
                      q2 = 5642;
                      r3 = y3;
                      n3 = m2;
                      m2 = u3;
                    }
                  }
                while (0);
              f:
                do
                  if ((w2 | 0) == 61) {
                    u3 = E2;
                    t3 = c2[u3 >> 2] | 0;
                    u3 = c2[u3 + 4 >> 2] | 0;
                    r3 = JB(t3, u3, y3, n3 & 32) | 0;
                    q2 = (e3 & 8 | 0) == 0 | (t3 | 0) == 0 & (u3 | 0) == 0;
                    o3 = q2 ? 0 : 2;
                    q2 = q2 ? 5642 : 5642 + (n3 >> 4) | 0;
                    s3 = e3;
                    e3 = t3;
                    n3 = u3;
                    w2 = 67;
                  } else if ((w2 | 0) == 66) {
                    r3 = LB(e3, n3, y3) | 0;
                    s3 = u3;
                    w2 = 67;
                  } else if ((w2 | 0) == 71) {
                    w2 = 0;
                    u3 = NB(n3, 0, m2) | 0;
                    t3 = (u3 | 0) == 0;
                    e3 = n3;
                    o3 = 0;
                    q2 = 5642;
                    r3 = t3 ? n3 + m2 | 0 : u3;
                    n3 = t3 ? m2 : u3 - n3 | 0;
                    m2 = s3;
                  } else if ((w2 | 0) == 75) {
                    w2 = 0;
                    q2 = n3;
                    e3 = 0;
                    m2 = 0;
                    while (1) {
                      o3 = c2[q2 >> 2] | 0;
                      if (!o3)
                        break;
                      m2 = PB(G2, o3) | 0;
                      if ((m2 | 0) < 0 | m2 >>> 0 > (r3 - e3 | 0) >>> 0)
                        break;
                      e3 = m2 + e3 | 0;
                      if (r3 >>> 0 > e3 >>> 0)
                        q2 = q2 + 4 | 0;
                      else
                        break;
                    }
                    if ((m2 | 0) < 0) {
                      j2 = -1;
                      break a;
                    }
                    OB(d2, 32, k2, e3, u3);
                    if (!e3) {
                      e3 = 0;
                      w2 = 84;
                    } else {
                      o3 = 0;
                      while (1) {
                        m2 = c2[n3 >> 2] | 0;
                        if (!m2) {
                          w2 = 84;
                          break f;
                        }
                        m2 = PB(G2, m2) | 0;
                        o3 = m2 + o3 | 0;
                        if ((o3 | 0) > (e3 | 0)) {
                          w2 = 84;
                          break f;
                        }
                        GB(d2, G2, m2);
                        if (o3 >>> 0 >= e3 >>> 0) {
                          w2 = 84;
                          break;
                        } else
                          n3 = n3 + 4 | 0;
                      }
                    }
                  }
                while (0);
              if ((w2 | 0) == 67) {
                w2 = 0;
                n3 = (e3 | 0) != 0 | (n3 | 0) != 0;
                u3 = (m2 | 0) != 0 | n3;
                n3 = ((n3 ^ 1) & 1) + (z2 - r3) | 0;
                e3 = u3 ? r3 : y3;
                r3 = y3;
                n3 = u3 ? (m2 | 0) > (n3 | 0) ? m2 : n3 : m2;
                m2 = (m2 | 0) > -1 ? s3 & -65537 : s3;
              } else if ((w2 | 0) == 84) {
                w2 = 0;
                OB(d2, 32, k2, e3, u3 ^ 8192);
                k2 = (k2 | 0) > (e3 | 0) ? k2 : e3;
                e3 = v2;
                continue;
              }
              t3 = r3 - e3 | 0;
              s3 = (n3 | 0) < (t3 | 0) ? t3 : n3;
              u3 = s3 + o3 | 0;
              k2 = (k2 | 0) < (u3 | 0) ? u3 : k2;
              OB(d2, 32, k2, u3, m2);
              GB(d2, q2, o3);
              OB(d2, 48, k2, u3, m2 ^ 65536);
              OB(d2, 48, s3, t3, 0);
              GB(d2, e3, t3);
              OB(d2, 32, k2, u3, m2 ^ 8192);
              e3 = v2;
            }
          g:
            do
              if ((w2 | 0) == 87) {
                if (!d2)
                  if (!p2)
                    j2 = 0;
                  else {
                    j2 = 1;
                    while (1) {
                      e3 = c2[i4 + (j2 << 2) >> 2] | 0;
                      if (!e3)
                        break;
                      IB(g3 + (j2 << 3) | 0, e3, f2);
                      j2 = j2 + 1 | 0;
                      if ((j2 | 0) >= 10) {
                        j2 = 1;
                        break g;
                      }
                    }
                    while (1) {
                      if (c2[i4 + (j2 << 2) >> 2] | 0) {
                        j2 = -1;
                        break g;
                      }
                      j2 = j2 + 1 | 0;
                      if ((j2 | 0) >= 10) {
                        j2 = 1;
                        break;
                      }
                    }
                  }
              }
            while (0);
          l2 = H2;
          return j2 | 0;
        }
        function EB(a3) {
          a3 = a3 | 0;
          return 0;
        }
        function FB(a3) {
          a3 = a3 | 0;
          return;
        }
        function GB(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          if (!(c2[a3 >> 2] & 32))
            aC(b3, d2, a3) | 0;
          return;
        }
        function HB(b3) {
          b3 = b3 | 0;
          var d2 = 0, e3 = 0, f2 = 0;
          e3 = c2[b3 >> 2] | 0;
          f2 = (a2[e3 >> 0] | 0) + -48 | 0;
          if (f2 >>> 0 < 10) {
            d2 = 0;
            do {
              d2 = f2 + (d2 * 10 | 0) | 0;
              e3 = e3 + 1 | 0;
              c2[b3 >> 2] = e3;
              f2 = (a2[e3 >> 0] | 0) + -48 | 0;
            } while (f2 >>> 0 < 10);
          } else
            d2 = 0;
          return d2 | 0;
        }
        function IB(a3, b3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          var e3 = 0, f2 = 0, g3 = 0;
          a:
            do
              if (b3 >>> 0 <= 20)
                do
                  switch (b3 | 0) {
                    case 9: {
                      e3 = (c2[d2 >> 2] | 0) + (4 - 1) & ~(4 - 1);
                      b3 = c2[e3 >> 2] | 0;
                      c2[d2 >> 2] = e3 + 4;
                      c2[a3 >> 2] = b3;
                      break a;
                    }
                    case 10: {
                      e3 = (c2[d2 >> 2] | 0) + (4 - 1) & ~(4 - 1);
                      b3 = c2[e3 >> 2] | 0;
                      c2[d2 >> 2] = e3 + 4;
                      e3 = a3;
                      c2[e3 >> 2] = b3;
                      c2[e3 + 4 >> 2] = ((b3 | 0) < 0) << 31 >> 31;
                      break a;
                    }
                    case 11: {
                      e3 = (c2[d2 >> 2] | 0) + (4 - 1) & ~(4 - 1);
                      b3 = c2[e3 >> 2] | 0;
                      c2[d2 >> 2] = e3 + 4;
                      e3 = a3;
                      c2[e3 >> 2] = b3;
                      c2[e3 + 4 >> 2] = 0;
                      break a;
                    }
                    case 12: {
                      e3 = (c2[d2 >> 2] | 0) + (8 - 1) & ~(8 - 1);
                      b3 = e3;
                      f2 = c2[b3 >> 2] | 0;
                      b3 = c2[b3 + 4 >> 2] | 0;
                      c2[d2 >> 2] = e3 + 8;
                      e3 = a3;
                      c2[e3 >> 2] = f2;
                      c2[e3 + 4 >> 2] = b3;
                      break a;
                    }
                    case 13: {
                      f2 = (c2[d2 >> 2] | 0) + (4 - 1) & ~(4 - 1);
                      e3 = c2[f2 >> 2] | 0;
                      c2[d2 >> 2] = f2 + 4;
                      e3 = (e3 & 65535) << 16 >> 16;
                      f2 = a3;
                      c2[f2 >> 2] = e3;
                      c2[f2 + 4 >> 2] = ((e3 | 0) < 0) << 31 >> 31;
                      break a;
                    }
                    case 14: {
                      f2 = (c2[d2 >> 2] | 0) + (4 - 1) & ~(4 - 1);
                      e3 = c2[f2 >> 2] | 0;
                      c2[d2 >> 2] = f2 + 4;
                      f2 = a3;
                      c2[f2 >> 2] = e3 & 65535;
                      c2[f2 + 4 >> 2] = 0;
                      break a;
                    }
                    case 15: {
                      f2 = (c2[d2 >> 2] | 0) + (4 - 1) & ~(4 - 1);
                      e3 = c2[f2 >> 2] | 0;
                      c2[d2 >> 2] = f2 + 4;
                      e3 = (e3 & 255) << 24 >> 24;
                      f2 = a3;
                      c2[f2 >> 2] = e3;
                      c2[f2 + 4 >> 2] = ((e3 | 0) < 0) << 31 >> 31;
                      break a;
                    }
                    case 16: {
                      f2 = (c2[d2 >> 2] | 0) + (4 - 1) & ~(4 - 1);
                      e3 = c2[f2 >> 2] | 0;
                      c2[d2 >> 2] = f2 + 4;
                      f2 = a3;
                      c2[f2 >> 2] = e3 & 255;
                      c2[f2 + 4 >> 2] = 0;
                      break a;
                    }
                    case 17: {
                      f2 = (c2[d2 >> 2] | 0) + (8 - 1) & ~(8 - 1);
                      g3 = +h[f2 >> 3];
                      c2[d2 >> 2] = f2 + 8;
                      h[a3 >> 3] = g3;
                      break a;
                    }
                    case 18: {
                      f2 = (c2[d2 >> 2] | 0) + (8 - 1) & ~(8 - 1);
                      g3 = +h[f2 >> 3];
                      c2[d2 >> 2] = f2 + 8;
                      h[a3 >> 3] = g3;
                      break a;
                    }
                    default:
                      break a;
                  }
                while (0);
            while (0);
          return;
        }
        function JB(b3, c3, e3, f2) {
          b3 = b3 | 0;
          c3 = c3 | 0;
          e3 = e3 | 0;
          f2 = f2 | 0;
          if (!((b3 | 0) == 0 & (c3 | 0) == 0))
            do {
              e3 = e3 + -1 | 0;
              a2[e3 >> 0] = d[5694 + (b3 & 15) >> 0] | 0 | f2;
              b3 = AC(b3 | 0, c3 | 0, 4) | 0;
              c3 = A;
            } while (!((b3 | 0) == 0 & (c3 | 0) == 0));
          return e3 | 0;
        }
        function KB(b3, c3, d2) {
          b3 = b3 | 0;
          c3 = c3 | 0;
          d2 = d2 | 0;
          if (!((b3 | 0) == 0 & (c3 | 0) == 0))
            do {
              d2 = d2 + -1 | 0;
              a2[d2 >> 0] = b3 & 7 | 48;
              b3 = AC(b3 | 0, c3 | 0, 3) | 0;
              c3 = A;
            } while (!((b3 | 0) == 0 & (c3 | 0) == 0));
          return d2 | 0;
        }
        function LB(b3, c3, d2) {
          b3 = b3 | 0;
          c3 = c3 | 0;
          d2 = d2 | 0;
          var e3 = 0;
          if (c3 >>> 0 > 0 | (c3 | 0) == 0 & b3 >>> 0 > 4294967295) {
            while (1) {
              e3 = HC(b3 | 0, c3 | 0, 10, 0) | 0;
              d2 = d2 + -1 | 0;
              a2[d2 >> 0] = e3 & 255 | 48;
              e3 = b3;
              b3 = EC(b3 | 0, c3 | 0, 10, 0) | 0;
              if (!(c3 >>> 0 > 9 | (c3 | 0) == 9 & e3 >>> 0 > 4294967295))
                break;
              else
                c3 = A;
            }
            c3 = b3;
          } else
            c3 = b3;
          if (c3)
            while (1) {
              d2 = d2 + -1 | 0;
              a2[d2 >> 0] = (c3 >>> 0) % 10 | 0 | 48;
              if (c3 >>> 0 < 10)
                break;
              else
                c3 = (c3 >>> 0) / 10 | 0;
            }
          return d2 | 0;
        }
        function MB(a3) {
          a3 = a3 | 0;
          return XB(a3, c2[(WB() | 0) + 188 >> 2] | 0) | 0;
        }
        function NB(b3, d2, e3) {
          b3 = b3 | 0;
          d2 = d2 | 0;
          e3 = e3 | 0;
          var f2 = 0, g3 = 0, h2 = 0, i4 = 0;
          h2 = d2 & 255;
          f2 = (e3 | 0) != 0;
          a:
            do
              if (f2 & (b3 & 3 | 0) != 0) {
                g3 = d2 & 255;
                while (1) {
                  if ((a2[b3 >> 0] | 0) == g3 << 24 >> 24) {
                    i4 = 6;
                    break a;
                  }
                  b3 = b3 + 1 | 0;
                  e3 = e3 + -1 | 0;
                  f2 = (e3 | 0) != 0;
                  if (!(f2 & (b3 & 3 | 0) != 0)) {
                    i4 = 5;
                    break;
                  }
                }
              } else
                i4 = 5;
            while (0);
          if ((i4 | 0) == 5)
            if (f2)
              i4 = 6;
            else
              e3 = 0;
          b:
            do
              if ((i4 | 0) == 6) {
                g3 = d2 & 255;
                if ((a2[b3 >> 0] | 0) != g3 << 24 >> 24) {
                  f2 = P(h2, 16843009) | 0;
                  c:
                    do
                      if (e3 >>> 0 > 3)
                        while (1) {
                          h2 = c2[b3 >> 2] ^ f2;
                          if ((h2 & -2139062144 ^ -2139062144) & h2 + -16843009 | 0)
                            break;
                          b3 = b3 + 4 | 0;
                          e3 = e3 + -4 | 0;
                          if (e3 >>> 0 <= 3) {
                            i4 = 11;
                            break c;
                          }
                        }
                      else
                        i4 = 11;
                    while (0);
                  if ((i4 | 0) == 11) {
                    if (!e3) {
                      e3 = 0;
                      break;
                    }
                  }
                  while (1) {
                    if ((a2[b3 >> 0] | 0) == g3 << 24 >> 24)
                      break b;
                    b3 = b3 + 1 | 0;
                    e3 = e3 + -1 | 0;
                    if (!e3) {
                      e3 = 0;
                      break;
                    }
                  }
                }
              }
            while (0);
          return (e3 | 0 ? b3 : 0) | 0;
        }
        function OB(a3, b3, c3, d2, e3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          c3 = c3 | 0;
          d2 = d2 | 0;
          e3 = e3 | 0;
          var f2 = 0, g3 = 0;
          g3 = l2;
          l2 = l2 + 256 | 0;
          f2 = g3;
          if ((c3 | 0) > (d2 | 0) & (e3 & 73728 | 0) == 0) {
            e3 = c3 - d2 | 0;
            yC(f2 | 0, b3 | 0, (e3 >>> 0 < 256 ? e3 : 256) | 0) | 0;
            if (e3 >>> 0 > 255) {
              b3 = c3 - d2 | 0;
              do {
                GB(a3, f2, 256);
                e3 = e3 + -256 | 0;
              } while (e3 >>> 0 > 255);
              e3 = b3 & 255;
            }
            GB(a3, f2, e3);
          }
          l2 = g3;
          return;
        }
        function PB(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          if (!a3)
            a3 = 0;
          else
            a3 = UB(a3, b3, 0) | 0;
          return a3 | 0;
        }
        function QB(b3, e3, f2, g3, h2, i4) {
          b3 = b3 | 0;
          e3 = +e3;
          f2 = f2 | 0;
          g3 = g3 | 0;
          h2 = h2 | 0;
          i4 = i4 | 0;
          var j2 = 0, k2 = 0, m2 = 0, n3 = 0, o3 = 0, p2 = 0, q2 = 0, r3 = 0, s3 = 0, t3 = 0, u3 = 0, v2 = 0, w2 = 0, x2 = 0, y3 = 0, z2 = 0, B2 = 0, C2 = 0, D2 = 0, E2 = 0, F2 = 0, G2 = 0, H2 = 0;
          H2 = l2;
          l2 = l2 + 560 | 0;
          m2 = H2 + 8 | 0;
          u3 = H2;
          G2 = H2 + 524 | 0;
          F2 = G2;
          n3 = H2 + 512 | 0;
          c2[u3 >> 2] = 0;
          E2 = n3 + 12 | 0;
          RB(e3) | 0;
          if ((A | 0) < 0) {
            e3 = -e3;
            C2 = 1;
            B2 = 5659;
          } else {
            C2 = (h2 & 2049 | 0) != 0 & 1;
            B2 = (h2 & 2048 | 0) == 0 ? (h2 & 1 | 0) == 0 ? 5660 : 5665 : 5662;
          }
          RB(e3) | 0;
          D2 = A & 2146435072;
          do
            if (D2 >>> 0 < 2146435072 | (D2 | 0) == 2146435072 & 0 < 0) {
              r3 = +SB(e3, u3) * 2;
              j2 = r3 != 0;
              if (j2)
                c2[u3 >> 2] = (c2[u3 >> 2] | 0) + -1;
              w2 = i4 | 32;
              if ((w2 | 0) == 97) {
                s3 = i4 & 32;
                q2 = (s3 | 0) == 0 ? B2 : B2 + 9 | 0;
                p2 = C2 | 2;
                j2 = 12 - g3 | 0;
                do
                  if (!(g3 >>> 0 > 11 | (j2 | 0) == 0)) {
                    e3 = 8;
                    do {
                      j2 = j2 + -1 | 0;
                      e3 = e3 * 16;
                    } while ((j2 | 0) != 0);
                    if ((a2[q2 >> 0] | 0) == 45) {
                      e3 = -(e3 + (-r3 - e3));
                      break;
                    } else {
                      e3 = r3 + e3 - e3;
                      break;
                    }
                  } else
                    e3 = r3;
                while (0);
                k2 = c2[u3 >> 2] | 0;
                j2 = (k2 | 0) < 0 ? 0 - k2 | 0 : k2;
                j2 = LB(j2, ((j2 | 0) < 0) << 31 >> 31, E2) | 0;
                if ((j2 | 0) == (E2 | 0)) {
                  j2 = n3 + 11 | 0;
                  a2[j2 >> 0] = 48;
                }
                a2[j2 + -1 >> 0] = (k2 >> 31 & 2) + 43;
                o3 = j2 + -2 | 0;
                a2[o3 >> 0] = i4 + 15;
                n3 = (g3 | 0) < 1;
                m2 = (h2 & 8 | 0) == 0;
                j2 = G2;
                do {
                  D2 = ~~e3;
                  k2 = j2 + 1 | 0;
                  a2[j2 >> 0] = d[5694 + D2 >> 0] | s3;
                  e3 = (e3 - +(D2 | 0)) * 16;
                  if ((k2 - F2 | 0) == 1 ? !(m2 & (n3 & e3 == 0)) : 0) {
                    a2[k2 >> 0] = 46;
                    j2 = j2 + 2 | 0;
                  } else
                    j2 = k2;
                } while (e3 != 0);
                D2 = j2 - F2 | 0;
                F2 = E2 - o3 | 0;
                E2 = (g3 | 0) != 0 & (D2 + -2 | 0) < (g3 | 0) ? g3 + 2 | 0 : D2;
                j2 = F2 + p2 + E2 | 0;
                OB(b3, 32, f2, j2, h2);
                GB(b3, q2, p2);
                OB(b3, 48, f2, j2, h2 ^ 65536);
                GB(b3, G2, D2);
                OB(b3, 48, E2 - D2 | 0, 0, 0);
                GB(b3, o3, F2);
                OB(b3, 32, f2, j2, h2 ^ 8192);
                break;
              }
              k2 = (g3 | 0) < 0 ? 6 : g3;
              if (j2) {
                j2 = (c2[u3 >> 2] | 0) + -28 | 0;
                c2[u3 >> 2] = j2;
                e3 = r3 * 268435456;
              } else {
                e3 = r3;
                j2 = c2[u3 >> 2] | 0;
              }
              D2 = (j2 | 0) < 0 ? m2 : m2 + 288 | 0;
              m2 = D2;
              do {
                y3 = ~~e3 >>> 0;
                c2[m2 >> 2] = y3;
                m2 = m2 + 4 | 0;
                e3 = (e3 - +(y3 >>> 0)) * 1e9;
              } while (e3 != 0);
              if ((j2 | 0) > 0) {
                n3 = D2;
                p2 = m2;
                while (1) {
                  o3 = (j2 | 0) < 29 ? j2 : 29;
                  j2 = p2 + -4 | 0;
                  if (j2 >>> 0 >= n3 >>> 0) {
                    m2 = 0;
                    do {
                      x2 = zC(c2[j2 >> 2] | 0, 0, o3 | 0) | 0;
                      x2 = xC(x2 | 0, A | 0, m2 | 0, 0) | 0;
                      y3 = A;
                      v2 = HC(x2 | 0, y3 | 0, 1e9, 0) | 0;
                      c2[j2 >> 2] = v2;
                      m2 = EC(x2 | 0, y3 | 0, 1e9, 0) | 0;
                      j2 = j2 + -4 | 0;
                    } while (j2 >>> 0 >= n3 >>> 0);
                    if (m2) {
                      n3 = n3 + -4 | 0;
                      c2[n3 >> 2] = m2;
                    }
                  }
                  m2 = p2;
                  while (1) {
                    if (m2 >>> 0 <= n3 >>> 0)
                      break;
                    j2 = m2 + -4 | 0;
                    if (!(c2[j2 >> 2] | 0))
                      m2 = j2;
                    else
                      break;
                  }
                  j2 = (c2[u3 >> 2] | 0) - o3 | 0;
                  c2[u3 >> 2] = j2;
                  if ((j2 | 0) > 0)
                    p2 = m2;
                  else
                    break;
                }
              } else
                n3 = D2;
              if ((j2 | 0) < 0) {
                g3 = ((k2 + 25 | 0) / 9 | 0) + 1 | 0;
                t3 = (w2 | 0) == 102;
                do {
                  s3 = 0 - j2 | 0;
                  s3 = (s3 | 0) < 9 ? s3 : 9;
                  if (n3 >>> 0 < m2 >>> 0) {
                    o3 = (1 << s3) + -1 | 0;
                    p2 = 1e9 >>> s3;
                    q2 = 0;
                    j2 = n3;
                    do {
                      y3 = c2[j2 >> 2] | 0;
                      c2[j2 >> 2] = (y3 >>> s3) + q2;
                      q2 = P(y3 & o3, p2) | 0;
                      j2 = j2 + 4 | 0;
                    } while (j2 >>> 0 < m2 >>> 0);
                    j2 = (c2[n3 >> 2] | 0) == 0 ? n3 + 4 | 0 : n3;
                    if (!q2) {
                      n3 = j2;
                      j2 = m2;
                    } else {
                      c2[m2 >> 2] = q2;
                      n3 = j2;
                      j2 = m2 + 4 | 0;
                    }
                  } else {
                    n3 = (c2[n3 >> 2] | 0) == 0 ? n3 + 4 | 0 : n3;
                    j2 = m2;
                  }
                  m2 = t3 ? D2 : n3;
                  m2 = (j2 - m2 >> 2 | 0) > (g3 | 0) ? m2 + (g3 << 2) | 0 : j2;
                  j2 = (c2[u3 >> 2] | 0) + s3 | 0;
                  c2[u3 >> 2] = j2;
                } while ((j2 | 0) < 0);
                j2 = n3;
                g3 = m2;
              } else {
                j2 = n3;
                g3 = m2;
              }
              y3 = D2;
              if (j2 >>> 0 < g3 >>> 0) {
                m2 = (y3 - j2 >> 2) * 9 | 0;
                o3 = c2[j2 >> 2] | 0;
                if (o3 >>> 0 >= 10) {
                  n3 = 10;
                  do {
                    n3 = n3 * 10 | 0;
                    m2 = m2 + 1 | 0;
                  } while (o3 >>> 0 >= n3 >>> 0);
                }
              } else
                m2 = 0;
              t3 = (w2 | 0) == 103;
              v2 = (k2 | 0) != 0;
              n3 = k2 - ((w2 | 0) != 102 ? m2 : 0) + ((v2 & t3) << 31 >> 31) | 0;
              if ((n3 | 0) < (((g3 - y3 >> 2) * 9 | 0) + -9 | 0)) {
                n3 = n3 + 9216 | 0;
                s3 = D2 + 4 + (((n3 | 0) / 9 | 0) + -1024 << 2) | 0;
                n3 = ((n3 | 0) % 9 | 0) + 1 | 0;
                if ((n3 | 0) < 9) {
                  o3 = 10;
                  do {
                    o3 = o3 * 10 | 0;
                    n3 = n3 + 1 | 0;
                  } while ((n3 | 0) != 9);
                } else
                  o3 = 10;
                p2 = c2[s3 >> 2] | 0;
                q2 = (p2 >>> 0) % (o3 >>> 0) | 0;
                n3 = (s3 + 4 | 0) == (g3 | 0);
                if (!(n3 & (q2 | 0) == 0)) {
                  r3 = (((p2 >>> 0) / (o3 >>> 0) | 0) & 1 | 0) == 0 ? 9007199254740992 : 9007199254740994;
                  x2 = (o3 | 0) / 2 | 0;
                  e3 = q2 >>> 0 < x2 >>> 0 ? 0.5 : n3 & (q2 | 0) == (x2 | 0) ? 1 : 1.5;
                  if (C2) {
                    x2 = (a2[B2 >> 0] | 0) == 45;
                    e3 = x2 ? -e3 : e3;
                    r3 = x2 ? -r3 : r3;
                  }
                  n3 = p2 - q2 | 0;
                  c2[s3 >> 2] = n3;
                  if (r3 + e3 != r3) {
                    x2 = n3 + o3 | 0;
                    c2[s3 >> 2] = x2;
                    if (x2 >>> 0 > 999999999) {
                      m2 = s3;
                      while (1) {
                        n3 = m2 + -4 | 0;
                        c2[m2 >> 2] = 0;
                        if (n3 >>> 0 < j2 >>> 0) {
                          j2 = j2 + -4 | 0;
                          c2[j2 >> 2] = 0;
                        }
                        x2 = (c2[n3 >> 2] | 0) + 1 | 0;
                        c2[n3 >> 2] = x2;
                        if (x2 >>> 0 > 999999999)
                          m2 = n3;
                        else
                          break;
                      }
                    } else
                      n3 = s3;
                    m2 = (y3 - j2 >> 2) * 9 | 0;
                    p2 = c2[j2 >> 2] | 0;
                    if (p2 >>> 0 >= 10) {
                      o3 = 10;
                      do {
                        o3 = o3 * 10 | 0;
                        m2 = m2 + 1 | 0;
                      } while (p2 >>> 0 >= o3 >>> 0);
                    }
                  } else
                    n3 = s3;
                } else
                  n3 = s3;
                n3 = n3 + 4 | 0;
                n3 = g3 >>> 0 > n3 >>> 0 ? n3 : g3;
                x2 = j2;
              } else {
                n3 = g3;
                x2 = j2;
              }
              w2 = n3;
              while (1) {
                if (w2 >>> 0 <= x2 >>> 0) {
                  u3 = 0;
                  break;
                }
                j2 = w2 + -4 | 0;
                if (!(c2[j2 >> 2] | 0))
                  w2 = j2;
                else {
                  u3 = 1;
                  break;
                }
              }
              g3 = 0 - m2 | 0;
              do
                if (t3) {
                  j2 = ((v2 ^ 1) & 1) + k2 | 0;
                  if ((j2 | 0) > (m2 | 0) & (m2 | 0) > -5) {
                    o3 = i4 + -1 | 0;
                    k2 = j2 + -1 - m2 | 0;
                  } else {
                    o3 = i4 + -2 | 0;
                    k2 = j2 + -1 | 0;
                  }
                  j2 = h2 & 8;
                  if (!j2) {
                    if (u3 ? (z2 = c2[w2 + -4 >> 2] | 0, (z2 | 0) != 0) : 0) {
                      if (!((z2 >>> 0) % 10 | 0)) {
                        n3 = 0;
                        j2 = 10;
                        do {
                          j2 = j2 * 10 | 0;
                          n3 = n3 + 1 | 0;
                        } while (!((z2 >>> 0) % (j2 >>> 0) | 0 | 0));
                      } else
                        n3 = 0;
                    } else
                      n3 = 9;
                    j2 = ((w2 - y3 >> 2) * 9 | 0) + -9 | 0;
                    if ((o3 | 32 | 0) == 102) {
                      s3 = j2 - n3 | 0;
                      s3 = (s3 | 0) > 0 ? s3 : 0;
                      k2 = (k2 | 0) < (s3 | 0) ? k2 : s3;
                      s3 = 0;
                      break;
                    } else {
                      s3 = j2 + m2 - n3 | 0;
                      s3 = (s3 | 0) > 0 ? s3 : 0;
                      k2 = (k2 | 0) < (s3 | 0) ? k2 : s3;
                      s3 = 0;
                      break;
                    }
                  } else
                    s3 = j2;
                } else {
                  o3 = i4;
                  s3 = h2 & 8;
                }
              while (0);
              t3 = k2 | s3;
              p2 = (t3 | 0) != 0 & 1;
              q2 = (o3 | 32 | 0) == 102;
              if (q2) {
                v2 = 0;
                j2 = (m2 | 0) > 0 ? m2 : 0;
              } else {
                j2 = (m2 | 0) < 0 ? g3 : m2;
                j2 = LB(j2, ((j2 | 0) < 0) << 31 >> 31, E2) | 0;
                n3 = E2;
                if ((n3 - j2 | 0) < 2)
                  do {
                    j2 = j2 + -1 | 0;
                    a2[j2 >> 0] = 48;
                  } while ((n3 - j2 | 0) < 2);
                a2[j2 + -1 >> 0] = (m2 >> 31 & 2) + 43;
                j2 = j2 + -2 | 0;
                a2[j2 >> 0] = o3;
                v2 = j2;
                j2 = n3 - j2 | 0;
              }
              j2 = C2 + 1 + k2 + p2 + j2 | 0;
              OB(b3, 32, f2, j2, h2);
              GB(b3, B2, C2);
              OB(b3, 48, f2, j2, h2 ^ 65536);
              if (q2) {
                o3 = x2 >>> 0 > D2 >>> 0 ? D2 : x2;
                s3 = G2 + 9 | 0;
                p2 = s3;
                q2 = G2 + 8 | 0;
                n3 = o3;
                do {
                  m2 = LB(c2[n3 >> 2] | 0, 0, s3) | 0;
                  if ((n3 | 0) == (o3 | 0)) {
                    if ((m2 | 0) == (s3 | 0)) {
                      a2[q2 >> 0] = 48;
                      m2 = q2;
                    }
                  } else if (m2 >>> 0 > G2 >>> 0) {
                    yC(G2 | 0, 48, m2 - F2 | 0) | 0;
                    do
                      m2 = m2 + -1 | 0;
                    while (m2 >>> 0 > G2 >>> 0);
                  }
                  GB(b3, m2, p2 - m2 | 0);
                  n3 = n3 + 4 | 0;
                } while (n3 >>> 0 <= D2 >>> 0);
                if (t3 | 0)
                  GB(b3, 5710, 1);
                if (n3 >>> 0 < w2 >>> 0 & (k2 | 0) > 0)
                  while (1) {
                    m2 = LB(c2[n3 >> 2] | 0, 0, s3) | 0;
                    if (m2 >>> 0 > G2 >>> 0) {
                      yC(G2 | 0, 48, m2 - F2 | 0) | 0;
                      do
                        m2 = m2 + -1 | 0;
                      while (m2 >>> 0 > G2 >>> 0);
                    }
                    GB(b3, m2, (k2 | 0) < 9 ? k2 : 9);
                    n3 = n3 + 4 | 0;
                    m2 = k2 + -9 | 0;
                    if (!(n3 >>> 0 < w2 >>> 0 & (k2 | 0) > 9)) {
                      k2 = m2;
                      break;
                    } else
                      k2 = m2;
                  }
                OB(b3, 48, k2 + 9 | 0, 9, 0);
              } else {
                t3 = u3 ? w2 : x2 + 4 | 0;
                if ((k2 | 0) > -1) {
                  u3 = G2 + 9 | 0;
                  s3 = (s3 | 0) == 0;
                  g3 = u3;
                  p2 = 0 - F2 | 0;
                  q2 = G2 + 8 | 0;
                  o3 = x2;
                  do {
                    m2 = LB(c2[o3 >> 2] | 0, 0, u3) | 0;
                    if ((m2 | 0) == (u3 | 0)) {
                      a2[q2 >> 0] = 48;
                      m2 = q2;
                    }
                    do
                      if ((o3 | 0) == (x2 | 0)) {
                        n3 = m2 + 1 | 0;
                        GB(b3, m2, 1);
                        if (s3 & (k2 | 0) < 1) {
                          m2 = n3;
                          break;
                        }
                        GB(b3, 5710, 1);
                        m2 = n3;
                      } else {
                        if (m2 >>> 0 <= G2 >>> 0)
                          break;
                        yC(G2 | 0, 48, m2 + p2 | 0) | 0;
                        do
                          m2 = m2 + -1 | 0;
                        while (m2 >>> 0 > G2 >>> 0);
                      }
                    while (0);
                    F2 = g3 - m2 | 0;
                    GB(b3, m2, (k2 | 0) > (F2 | 0) ? F2 : k2);
                    k2 = k2 - F2 | 0;
                    o3 = o3 + 4 | 0;
                  } while (o3 >>> 0 < t3 >>> 0 & (k2 | 0) > -1);
                }
                OB(b3, 48, k2 + 18 | 0, 18, 0);
                GB(b3, v2, E2 - v2 | 0);
              }
              OB(b3, 32, f2, j2, h2 ^ 8192);
            } else {
              G2 = (i4 & 32 | 0) != 0;
              j2 = C2 + 3 | 0;
              OB(b3, 32, f2, j2, h2 & -65537);
              GB(b3, B2, C2);
              GB(b3, e3 != e3 | false ? G2 ? 5686 : 5690 : G2 ? 5678 : 5682, 3);
              OB(b3, 32, f2, j2, h2 ^ 8192);
            }
          while (0);
          l2 = H2;
          return ((j2 | 0) < (f2 | 0) ? f2 : j2) | 0;
        }
        function RB(a3) {
          a3 = +a3;
          var b3 = 0;
          h[j >> 3] = a3;
          b3 = c2[j >> 2] | 0;
          A = c2[j + 4 >> 2] | 0;
          return b3 | 0;
        }
        function SB(a3, b3) {
          a3 = +a3;
          b3 = b3 | 0;
          return + +TB(a3, b3);
        }
        function TB(a3, b3) {
          a3 = +a3;
          b3 = b3 | 0;
          var d2 = 0, e3 = 0, f2 = 0;
          h[j >> 3] = a3;
          d2 = c2[j >> 2] | 0;
          e3 = c2[j + 4 >> 2] | 0;
          f2 = AC(d2 | 0, e3 | 0, 52) | 0;
          switch (f2 & 2047) {
            case 0: {
              if (a3 != 0) {
                a3 = +TB(a3 * 18446744073709552e3, b3);
                d2 = (c2[b3 >> 2] | 0) + -64 | 0;
              } else
                d2 = 0;
              c2[b3 >> 2] = d2;
              break;
            }
            case 2047:
              break;
            default: {
              c2[b3 >> 2] = (f2 & 2047) + -1022;
              c2[j >> 2] = d2;
              c2[j + 4 >> 2] = e3 & -2146435073 | 1071644672;
              a3 = +h[j >> 3];
            }
          }
          return +a3;
        }
        function UB(b3, d2, e3) {
          b3 = b3 | 0;
          d2 = d2 | 0;
          e3 = e3 | 0;
          do
            if (b3) {
              if (d2 >>> 0 < 128) {
                a2[b3 >> 0] = d2;
                b3 = 1;
                break;
              }
              if (!(c2[c2[(VB() | 0) + 188 >> 2] >> 2] | 0))
                if ((d2 & -128 | 0) == 57216) {
                  a2[b3 >> 0] = d2;
                  b3 = 1;
                  break;
                } else {
                  c2[(vB() | 0) >> 2] = 84;
                  b3 = -1;
                  break;
                }
              if (d2 >>> 0 < 2048) {
                a2[b3 >> 0] = d2 >>> 6 | 192;
                a2[b3 + 1 >> 0] = d2 & 63 | 128;
                b3 = 2;
                break;
              }
              if (d2 >>> 0 < 55296 | (d2 & -8192 | 0) == 57344) {
                a2[b3 >> 0] = d2 >>> 12 | 224;
                a2[b3 + 1 >> 0] = d2 >>> 6 & 63 | 128;
                a2[b3 + 2 >> 0] = d2 & 63 | 128;
                b3 = 3;
                break;
              }
              if ((d2 + -65536 | 0) >>> 0 < 1048576) {
                a2[b3 >> 0] = d2 >>> 18 | 240;
                a2[b3 + 1 >> 0] = d2 >>> 12 & 63 | 128;
                a2[b3 + 2 >> 0] = d2 >>> 6 & 63 | 128;
                a2[b3 + 3 >> 0] = d2 & 63 | 128;
                b3 = 4;
                break;
              } else {
                c2[(vB() | 0) >> 2] = 84;
                b3 = -1;
                break;
              }
            } else
              b3 = 1;
          while (0);
          return b3 | 0;
        }
        function VB() {
          return xB() | 0;
        }
        function WB() {
          return xB() | 0;
        }
        function XB(b3, e3) {
          b3 = b3 | 0;
          e3 = e3 | 0;
          var f2 = 0, g3 = 0;
          g3 = 0;
          while (1) {
            if ((d[5712 + g3 >> 0] | 0) == (b3 | 0)) {
              b3 = 2;
              break;
            }
            f2 = g3 + 1 | 0;
            if ((f2 | 0) == 87) {
              f2 = 5800;
              g3 = 87;
              b3 = 5;
              break;
            } else
              g3 = f2;
          }
          if ((b3 | 0) == 2)
            if (!g3)
              f2 = 5800;
            else {
              f2 = 5800;
              b3 = 5;
            }
          if ((b3 | 0) == 5)
            while (1) {
              do {
                b3 = f2;
                f2 = f2 + 1 | 0;
              } while ((a2[b3 >> 0] | 0) != 0);
              g3 = g3 + -1 | 0;
              if (!g3)
                break;
              else
                b3 = 5;
            }
          return YB(f2, c2[e3 + 20 >> 2] | 0) | 0;
        }
        function YB(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          return ZB(a3, b3) | 0;
        }
        function ZB(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          if (!b3)
            b3 = 0;
          else
            b3 = _B(c2[b3 >> 2] | 0, c2[b3 + 4 >> 2] | 0, a3) | 0;
          return (b3 | 0 ? b3 : a3) | 0;
        }
        function _B(b3, d2, e3) {
          b3 = b3 | 0;
          d2 = d2 | 0;
          e3 = e3 | 0;
          var f2 = 0, g3 = 0, h2 = 0, i4 = 0, j2 = 0, k2 = 0, l3 = 0, m2 = 0, n3 = 0, o3 = 0;
          o3 = (c2[b3 >> 2] | 0) + 1794895138 | 0;
          h2 = $B(c2[b3 + 8 >> 2] | 0, o3) | 0;
          f2 = $B(c2[b3 + 12 >> 2] | 0, o3) | 0;
          g3 = $B(c2[b3 + 16 >> 2] | 0, o3) | 0;
          a:
            do
              if ((h2 >>> 0 < d2 >>> 2 >>> 0 ? (n3 = d2 - (h2 << 2) | 0, f2 >>> 0 < n3 >>> 0 & g3 >>> 0 < n3 >>> 0) : 0) ? ((g3 | f2) & 3 | 0) == 0 : 0) {
                n3 = f2 >>> 2;
                m2 = g3 >>> 2;
                l3 = 0;
                while (1) {
                  j2 = h2 >>> 1;
                  k2 = l3 + j2 | 0;
                  i4 = k2 << 1;
                  g3 = i4 + n3 | 0;
                  f2 = $B(c2[b3 + (g3 << 2) >> 2] | 0, o3) | 0;
                  g3 = $B(c2[b3 + (g3 + 1 << 2) >> 2] | 0, o3) | 0;
                  if (!(g3 >>> 0 < d2 >>> 0 & f2 >>> 0 < (d2 - g3 | 0) >>> 0)) {
                    f2 = 0;
                    break a;
                  }
                  if (a2[b3 + (g3 + f2) >> 0] | 0) {
                    f2 = 0;
                    break a;
                  }
                  f2 = AB(e3, b3 + g3 | 0) | 0;
                  if (!f2)
                    break;
                  f2 = (f2 | 0) < 0;
                  if ((h2 | 0) == 1) {
                    f2 = 0;
                    break a;
                  } else {
                    l3 = f2 ? l3 : k2;
                    h2 = f2 ? j2 : h2 - j2 | 0;
                  }
                }
                f2 = i4 + m2 | 0;
                g3 = $B(c2[b3 + (f2 << 2) >> 2] | 0, o3) | 0;
                f2 = $B(c2[b3 + (f2 + 1 << 2) >> 2] | 0, o3) | 0;
                if (f2 >>> 0 < d2 >>> 0 & g3 >>> 0 < (d2 - f2 | 0) >>> 0)
                  f2 = (a2[b3 + (f2 + g3) >> 0] | 0) == 0 ? b3 + f2 | 0 : 0;
                else
                  f2 = 0;
              } else
                f2 = 0;
            while (0);
          return f2 | 0;
        }
        function $B(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          var c3 = 0;
          c3 = IC(a3 | 0) | 0;
          return ((b3 | 0) == 0 ? a3 : c3) | 0;
        }
        function aC(b3, d2, e3) {
          b3 = b3 | 0;
          d2 = d2 | 0;
          e3 = e3 | 0;
          var f2 = 0, g3 = 0, h2 = 0, i4 = 0, j2 = 0;
          f2 = e3 + 16 | 0;
          g3 = c2[f2 >> 2] | 0;
          if (!g3) {
            if (!(bC(e3) | 0)) {
              g3 = c2[f2 >> 2] | 0;
              h2 = 5;
            } else
              f2 = 0;
          } else
            h2 = 5;
          a:
            do
              if ((h2 | 0) == 5) {
                j2 = e3 + 20 | 0;
                i4 = c2[j2 >> 2] | 0;
                f2 = i4;
                if ((g3 - i4 | 0) >>> 0 < d2 >>> 0) {
                  f2 = sb[c2[e3 + 36 >> 2] & 7](e3, b3, d2) | 0;
                  break;
                }
                b:
                  do
                    if ((a2[e3 + 75 >> 0] | 0) > -1) {
                      i4 = d2;
                      while (1) {
                        if (!i4) {
                          h2 = 0;
                          g3 = b3;
                          break b;
                        }
                        g3 = i4 + -1 | 0;
                        if ((a2[b3 + g3 >> 0] | 0) == 10)
                          break;
                        else
                          i4 = g3;
                      }
                      f2 = sb[c2[e3 + 36 >> 2] & 7](e3, b3, i4) | 0;
                      if (f2 >>> 0 < i4 >>> 0)
                        break a;
                      h2 = i4;
                      g3 = b3 + i4 | 0;
                      d2 = d2 - i4 | 0;
                      f2 = c2[j2 >> 2] | 0;
                    } else {
                      h2 = 0;
                      g3 = b3;
                    }
                  while (0);
                BC(f2 | 0, g3 | 0, d2 | 0) | 0;
                c2[j2 >> 2] = (c2[j2 >> 2] | 0) + d2;
                f2 = h2 + d2 | 0;
              }
            while (0);
          return f2 | 0;
        }
        function bC(b3) {
          b3 = b3 | 0;
          var d2 = 0, e3 = 0;
          d2 = b3 + 74 | 0;
          e3 = a2[d2 >> 0] | 0;
          a2[d2 >> 0] = e3 + 255 | e3;
          d2 = c2[b3 >> 2] | 0;
          if (!(d2 & 8)) {
            c2[b3 + 8 >> 2] = 0;
            c2[b3 + 4 >> 2] = 0;
            e3 = c2[b3 + 44 >> 2] | 0;
            c2[b3 + 28 >> 2] = e3;
            c2[b3 + 20 >> 2] = e3;
            c2[b3 + 16 >> 2] = e3 + (c2[b3 + 48 >> 2] | 0);
            b3 = 0;
          } else {
            c2[b3 >> 2] = d2 | 32;
            b3 = -1;
          }
          return b3 | 0;
        }
        function cC(a3, b3) {
          a3 = T(a3);
          b3 = T(b3);
          var c3 = 0, d2 = 0;
          c3 = dC(a3) | 0;
          do
            if ((c3 & 2147483647) >>> 0 <= 2139095040) {
              d2 = dC(b3) | 0;
              if ((d2 & 2147483647) >>> 0 <= 2139095040)
                if ((d2 ^ c3 | 0) < 0) {
                  a3 = (c3 | 0) < 0 ? b3 : a3;
                  break;
                } else {
                  a3 = a3 < b3 ? b3 : a3;
                  break;
                }
            } else
              a3 = b3;
          while (0);
          return T(a3);
        }
        function dC(a3) {
          a3 = T(a3);
          return (g2[j >> 2] = a3, c2[j >> 2] | 0) | 0;
        }
        function eC(a3, b3) {
          a3 = T(a3);
          b3 = T(b3);
          var c3 = 0, d2 = 0;
          c3 = fC(a3) | 0;
          do
            if ((c3 & 2147483647) >>> 0 <= 2139095040) {
              d2 = fC(b3) | 0;
              if ((d2 & 2147483647) >>> 0 <= 2139095040)
                if ((d2 ^ c3 | 0) < 0) {
                  a3 = (c3 | 0) < 0 ? a3 : b3;
                  break;
                } else {
                  a3 = a3 < b3 ? a3 : b3;
                  break;
                }
            } else
              a3 = b3;
          while (0);
          return T(a3);
        }
        function fC(a3) {
          a3 = T(a3);
          return (g2[j >> 2] = a3, c2[j >> 2] | 0) | 0;
        }
        function gC(a3, b3) {
          a3 = T(a3);
          b3 = T(b3);
          var d2 = 0, e3 = 0, f2 = 0, h2 = 0, i4 = 0, k2 = 0, l3 = 0, m2 = 0;
          h2 = (g2[j >> 2] = a3, c2[j >> 2] | 0);
          k2 = (g2[j >> 2] = b3, c2[j >> 2] | 0);
          d2 = h2 >>> 23 & 255;
          i4 = k2 >>> 23 & 255;
          l3 = h2 & -2147483648;
          f2 = k2 << 1;
          a:
            do
              if ((f2 | 0) != 0 ? !((d2 | 0) == 255 | ((hC(b3) | 0) & 2147483647) >>> 0 > 2139095040) : 0) {
                e3 = h2 << 1;
                if (e3 >>> 0 <= f2 >>> 0) {
                  b3 = T(a3 * T(0));
                  return T((e3 | 0) == (f2 | 0) ? b3 : a3);
                }
                if (!d2) {
                  d2 = h2 << 9;
                  if ((d2 | 0) > -1) {
                    e3 = d2;
                    d2 = 0;
                    do {
                      d2 = d2 + -1 | 0;
                      e3 = e3 << 1;
                    } while ((e3 | 0) > -1);
                  } else
                    d2 = 0;
                  e3 = h2 << 1 - d2;
                } else
                  e3 = h2 & 8388607 | 8388608;
                if (!i4) {
                  h2 = k2 << 9;
                  if ((h2 | 0) > -1) {
                    f2 = 0;
                    do {
                      f2 = f2 + -1 | 0;
                      h2 = h2 << 1;
                    } while ((h2 | 0) > -1);
                  } else
                    f2 = 0;
                  i4 = f2;
                  k2 = k2 << 1 - f2;
                } else
                  k2 = k2 & 8388607 | 8388608;
                f2 = e3 - k2 | 0;
                h2 = (f2 | 0) > -1;
                b:
                  do
                    if ((d2 | 0) > (i4 | 0)) {
                      while (1) {
                        if (h2)
                          if (!f2)
                            break;
                          else
                            e3 = f2;
                        e3 = e3 << 1;
                        d2 = d2 + -1 | 0;
                        f2 = e3 - k2 | 0;
                        h2 = (f2 | 0) > -1;
                        if ((d2 | 0) <= (i4 | 0))
                          break b;
                      }
                      b3 = T(a3 * T(0));
                      break a;
                    }
                  while (0);
                if (h2)
                  if (!f2) {
                    b3 = T(a3 * T(0));
                    break;
                  } else
                    e3 = f2;
                if (e3 >>> 0 < 8388608)
                  do {
                    e3 = e3 << 1;
                    d2 = d2 + -1 | 0;
                  } while (e3 >>> 0 < 8388608);
                if ((d2 | 0) > 0)
                  d2 = e3 + -8388608 | d2 << 23;
                else
                  d2 = e3 >>> (1 - d2 | 0);
                b3 = (c2[j >> 2] = d2 | l3, T(g2[j >> 2]));
              } else
                m2 = 3;
            while (0);
          if ((m2 | 0) == 3) {
            b3 = T(a3 * b3);
            b3 = T(b3 / b3);
          }
          return T(b3);
        }
        function hC(a3) {
          a3 = T(a3);
          return (g2[j >> 2] = a3, c2[j >> 2] | 0) | 0;
        }
        function iC(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          return CB(c2[582] | 0, a3, b3) | 0;
        }
        function jC(a3) {
          a3 = a3 | 0;
          Ta();
        }
        function kC(a3) {
          a3 = a3 | 0;
          return;
        }
        function lC(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          return 0;
        }
        function mC(a3) {
          a3 = a3 | 0;
          if ((nC(a3 + 4 | 0) | 0) == -1) {
            nb[c2[(c2[a3 >> 2] | 0) + 8 >> 2] & 127](a3);
            a3 = 1;
          } else
            a3 = 0;
          return a3 | 0;
        }
        function nC(a3) {
          a3 = a3 | 0;
          var b3 = 0;
          b3 = c2[a3 >> 2] | 0;
          c2[a3 >> 2] = b3 + -1;
          return b3 + -1 | 0;
        }
        function oC(a3) {
          a3 = a3 | 0;
          if (mC(a3) | 0)
            pC(a3);
          return;
        }
        function pC(a3) {
          a3 = a3 | 0;
          var b3 = 0;
          b3 = a3 + 8 | 0;
          if (!((c2[b3 >> 2] | 0) != 0 ? (nC(b3) | 0) != -1 : 0))
            nb[c2[(c2[a3 >> 2] | 0) + 16 >> 2] & 127](a3);
          return;
        }
        function qC(a3) {
          a3 = a3 | 0;
          var b3 = 0;
          b3 = (a3 | 0) == 0 ? 1 : a3;
          while (1) {
            a3 = oB(b3) | 0;
            if (a3 | 0)
              break;
            a3 = uC() | 0;
            if (!a3) {
              a3 = 0;
              break;
            }
            Fb[a3 & 0]();
          }
          return a3 | 0;
        }
        function rC(a3) {
          a3 = a3 | 0;
          return qC(a3) | 0;
        }
        function sC(a3) {
          a3 = a3 | 0;
          pB(a3);
          return;
        }
        function tC(b3) {
          b3 = b3 | 0;
          if ((a2[b3 + 11 >> 0] | 0) < 0)
            sC(c2[b3 >> 2] | 0);
          return;
        }
        function uC() {
          var a3 = 0;
          a3 = c2[2923] | 0;
          c2[2923] = a3 + 0;
          return a3 | 0;
        }
        function vC() {
        }
        function wC(a3, b3, c3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          c3 = c3 | 0;
          d2 = d2 | 0;
          d2 = b3 - d2 - (c3 >>> 0 > a3 >>> 0 | 0) >>> 0;
          return (A = d2, a3 - c3 >>> 0 | 0) | 0;
        }
        function xC(a3, b3, c3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          c3 = c3 | 0;
          d2 = d2 | 0;
          c3 = a3 + c3 >>> 0;
          return (A = b3 + d2 + (c3 >>> 0 < a3 >>> 0 | 0) >>> 0, c3 | 0) | 0;
        }
        function yC(b3, d2, e3) {
          b3 = b3 | 0;
          d2 = d2 | 0;
          e3 = e3 | 0;
          var f2 = 0, g3 = 0, h2 = 0, i4 = 0;
          h2 = b3 + e3 | 0;
          d2 = d2 & 255;
          if ((e3 | 0) >= 67) {
            while (b3 & 3) {
              a2[b3 >> 0] = d2;
              b3 = b3 + 1 | 0;
            }
            f2 = h2 & -4 | 0;
            g3 = f2 - 64 | 0;
            i4 = d2 | d2 << 8 | d2 << 16 | d2 << 24;
            while ((b3 | 0) <= (g3 | 0)) {
              c2[b3 >> 2] = i4;
              c2[b3 + 4 >> 2] = i4;
              c2[b3 + 8 >> 2] = i4;
              c2[b3 + 12 >> 2] = i4;
              c2[b3 + 16 >> 2] = i4;
              c2[b3 + 20 >> 2] = i4;
              c2[b3 + 24 >> 2] = i4;
              c2[b3 + 28 >> 2] = i4;
              c2[b3 + 32 >> 2] = i4;
              c2[b3 + 36 >> 2] = i4;
              c2[b3 + 40 >> 2] = i4;
              c2[b3 + 44 >> 2] = i4;
              c2[b3 + 48 >> 2] = i4;
              c2[b3 + 52 >> 2] = i4;
              c2[b3 + 56 >> 2] = i4;
              c2[b3 + 60 >> 2] = i4;
              b3 = b3 + 64 | 0;
            }
            while ((b3 | 0) < (f2 | 0)) {
              c2[b3 >> 2] = i4;
              b3 = b3 + 4 | 0;
            }
          }
          while ((b3 | 0) < (h2 | 0)) {
            a2[b3 >> 0] = d2;
            b3 = b3 + 1 | 0;
          }
          return h2 - e3 | 0;
        }
        function zC(a3, b3, c3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          c3 = c3 | 0;
          if ((c3 | 0) < 32) {
            A = b3 << c3 | (a3 & (1 << c3) - 1 << 32 - c3) >>> 32 - c3;
            return a3 << c3;
          }
          A = a3 << c3 - 32;
          return 0;
        }
        function AC(a3, b3, c3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          c3 = c3 | 0;
          if ((c3 | 0) < 32) {
            A = b3 >>> c3;
            return a3 >>> c3 | (b3 & (1 << c3) - 1) << 32 - c3;
          }
          A = 0;
          return b3 >>> c3 - 32 | 0;
        }
        function BC(b3, d2, e3) {
          b3 = b3 | 0;
          d2 = d2 | 0;
          e3 = e3 | 0;
          var f2 = 0, g3 = 0, h2 = 0;
          if ((e3 | 0) >= 8192)
            return Oa(b3 | 0, d2 | 0, e3 | 0) | 0;
          h2 = b3 | 0;
          g3 = b3 + e3 | 0;
          if ((b3 & 3) == (d2 & 3)) {
            while (b3 & 3) {
              if (!e3)
                return h2 | 0;
              a2[b3 >> 0] = a2[d2 >> 0] | 0;
              b3 = b3 + 1 | 0;
              d2 = d2 + 1 | 0;
              e3 = e3 - 1 | 0;
            }
            e3 = g3 & -4 | 0;
            f2 = e3 - 64 | 0;
            while ((b3 | 0) <= (f2 | 0)) {
              c2[b3 >> 2] = c2[d2 >> 2];
              c2[b3 + 4 >> 2] = c2[d2 + 4 >> 2];
              c2[b3 + 8 >> 2] = c2[d2 + 8 >> 2];
              c2[b3 + 12 >> 2] = c2[d2 + 12 >> 2];
              c2[b3 + 16 >> 2] = c2[d2 + 16 >> 2];
              c2[b3 + 20 >> 2] = c2[d2 + 20 >> 2];
              c2[b3 + 24 >> 2] = c2[d2 + 24 >> 2];
              c2[b3 + 28 >> 2] = c2[d2 + 28 >> 2];
              c2[b3 + 32 >> 2] = c2[d2 + 32 >> 2];
              c2[b3 + 36 >> 2] = c2[d2 + 36 >> 2];
              c2[b3 + 40 >> 2] = c2[d2 + 40 >> 2];
              c2[b3 + 44 >> 2] = c2[d2 + 44 >> 2];
              c2[b3 + 48 >> 2] = c2[d2 + 48 >> 2];
              c2[b3 + 52 >> 2] = c2[d2 + 52 >> 2];
              c2[b3 + 56 >> 2] = c2[d2 + 56 >> 2];
              c2[b3 + 60 >> 2] = c2[d2 + 60 >> 2];
              b3 = b3 + 64 | 0;
              d2 = d2 + 64 | 0;
            }
            while ((b3 | 0) < (e3 | 0)) {
              c2[b3 >> 2] = c2[d2 >> 2];
              b3 = b3 + 4 | 0;
              d2 = d2 + 4 | 0;
            }
          } else {
            e3 = g3 - 4 | 0;
            while ((b3 | 0) < (e3 | 0)) {
              a2[b3 >> 0] = a2[d2 >> 0] | 0;
              a2[b3 + 1 >> 0] = a2[d2 + 1 >> 0] | 0;
              a2[b3 + 2 >> 0] = a2[d2 + 2 >> 0] | 0;
              a2[b3 + 3 >> 0] = a2[d2 + 3 >> 0] | 0;
              b3 = b3 + 4 | 0;
              d2 = d2 + 4 | 0;
            }
          }
          while ((b3 | 0) < (g3 | 0)) {
            a2[b3 >> 0] = a2[d2 >> 0] | 0;
            b3 = b3 + 1 | 0;
            d2 = d2 + 1 | 0;
          }
          return h2 | 0;
        }
        function CC(b3) {
          b3 = b3 | 0;
          var c3 = 0;
          c3 = a2[n2 + (b3 & 255) >> 0] | 0;
          if ((c3 | 0) < 8)
            return c3 | 0;
          c3 = a2[n2 + (b3 >> 8 & 255) >> 0] | 0;
          if ((c3 | 0) < 8)
            return c3 + 8 | 0;
          c3 = a2[n2 + (b3 >> 16 & 255) >> 0] | 0;
          if ((c3 | 0) < 8)
            return c3 + 16 | 0;
          return (a2[n2 + (b3 >>> 24) >> 0] | 0) + 24 | 0;
        }
        function DC(a3, b3, d2, e3, f2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          e3 = e3 | 0;
          f2 = f2 | 0;
          var g3 = 0, h2 = 0, i4 = 0, j2 = 0, k2 = 0, l3 = 0, m2 = 0, n3 = 0, o3 = 0, p2 = 0;
          l3 = a3;
          j2 = b3;
          k2 = j2;
          h2 = d2;
          n3 = e3;
          i4 = n3;
          if (!k2) {
            g3 = (f2 | 0) != 0;
            if (!i4) {
              if (g3) {
                c2[f2 >> 2] = (l3 >>> 0) % (h2 >>> 0);
                c2[f2 + 4 >> 2] = 0;
              }
              n3 = 0;
              f2 = (l3 >>> 0) / (h2 >>> 0) >>> 0;
              return (A = n3, f2) | 0;
            } else {
              if (!g3) {
                n3 = 0;
                f2 = 0;
                return (A = n3, f2) | 0;
              }
              c2[f2 >> 2] = a3 | 0;
              c2[f2 + 4 >> 2] = b3 & 0;
              n3 = 0;
              f2 = 0;
              return (A = n3, f2) | 0;
            }
          }
          g3 = (i4 | 0) == 0;
          do
            if (h2) {
              if (!g3) {
                g3 = (S(i4 | 0) | 0) - (S(k2 | 0) | 0) | 0;
                if (g3 >>> 0 <= 31) {
                  m2 = g3 + 1 | 0;
                  i4 = 31 - g3 | 0;
                  b3 = g3 - 31 >> 31;
                  h2 = m2;
                  a3 = l3 >>> (m2 >>> 0) & b3 | k2 << i4;
                  b3 = k2 >>> (m2 >>> 0) & b3;
                  g3 = 0;
                  i4 = l3 << i4;
                  break;
                }
                if (!f2) {
                  n3 = 0;
                  f2 = 0;
                  return (A = n3, f2) | 0;
                }
                c2[f2 >> 2] = a3 | 0;
                c2[f2 + 4 >> 2] = j2 | b3 & 0;
                n3 = 0;
                f2 = 0;
                return (A = n3, f2) | 0;
              }
              g3 = h2 - 1 | 0;
              if (g3 & h2 | 0) {
                i4 = (S(h2 | 0) | 0) + 33 - (S(k2 | 0) | 0) | 0;
                p2 = 64 - i4 | 0;
                m2 = 32 - i4 | 0;
                j2 = m2 >> 31;
                o3 = i4 - 32 | 0;
                b3 = o3 >> 31;
                h2 = i4;
                a3 = m2 - 1 >> 31 & k2 >>> (o3 >>> 0) | (k2 << m2 | l3 >>> (i4 >>> 0)) & b3;
                b3 = b3 & k2 >>> (i4 >>> 0);
                g3 = l3 << p2 & j2;
                i4 = (k2 << p2 | l3 >>> (o3 >>> 0)) & j2 | l3 << m2 & i4 - 33 >> 31;
                break;
              }
              if (f2 | 0) {
                c2[f2 >> 2] = g3 & l3;
                c2[f2 + 4 >> 2] = 0;
              }
              if ((h2 | 0) == 1) {
                o3 = j2 | b3 & 0;
                p2 = a3 | 0 | 0;
                return (A = o3, p2) | 0;
              } else {
                p2 = CC(h2 | 0) | 0;
                o3 = k2 >>> (p2 >>> 0) | 0;
                p2 = k2 << 32 - p2 | l3 >>> (p2 >>> 0) | 0;
                return (A = o3, p2) | 0;
              }
            } else {
              if (g3) {
                if (f2 | 0) {
                  c2[f2 >> 2] = (k2 >>> 0) % (h2 >>> 0);
                  c2[f2 + 4 >> 2] = 0;
                }
                o3 = 0;
                p2 = (k2 >>> 0) / (h2 >>> 0) >>> 0;
                return (A = o3, p2) | 0;
              }
              if (!l3) {
                if (f2 | 0) {
                  c2[f2 >> 2] = 0;
                  c2[f2 + 4 >> 2] = (k2 >>> 0) % (i4 >>> 0);
                }
                o3 = 0;
                p2 = (k2 >>> 0) / (i4 >>> 0) >>> 0;
                return (A = o3, p2) | 0;
              }
              g3 = i4 - 1 | 0;
              if (!(g3 & i4)) {
                if (f2 | 0) {
                  c2[f2 >> 2] = a3 | 0;
                  c2[f2 + 4 >> 2] = g3 & k2 | b3 & 0;
                }
                o3 = 0;
                p2 = k2 >>> ((CC(i4 | 0) | 0) >>> 0);
                return (A = o3, p2) | 0;
              }
              g3 = (S(i4 | 0) | 0) - (S(k2 | 0) | 0) | 0;
              if (g3 >>> 0 <= 30) {
                b3 = g3 + 1 | 0;
                i4 = 31 - g3 | 0;
                h2 = b3;
                a3 = k2 << i4 | l3 >>> (b3 >>> 0);
                b3 = k2 >>> (b3 >>> 0);
                g3 = 0;
                i4 = l3 << i4;
                break;
              }
              if (!f2) {
                o3 = 0;
                p2 = 0;
                return (A = o3, p2) | 0;
              }
              c2[f2 >> 2] = a3 | 0;
              c2[f2 + 4 >> 2] = j2 | b3 & 0;
              o3 = 0;
              p2 = 0;
              return (A = o3, p2) | 0;
            }
          while (0);
          if (!h2) {
            k2 = i4;
            j2 = 0;
            i4 = 0;
          } else {
            m2 = d2 | 0 | 0;
            l3 = n3 | e3 & 0;
            k2 = xC(m2 | 0, l3 | 0, -1, -1) | 0;
            d2 = A;
            j2 = i4;
            i4 = 0;
            do {
              e3 = j2;
              j2 = g3 >>> 31 | j2 << 1;
              g3 = i4 | g3 << 1;
              e3 = a3 << 1 | e3 >>> 31 | 0;
              n3 = a3 >>> 31 | b3 << 1 | 0;
              wC(k2 | 0, d2 | 0, e3 | 0, n3 | 0) | 0;
              p2 = A;
              o3 = p2 >> 31 | ((p2 | 0) < 0 ? -1 : 0) << 1;
              i4 = o3 & 1;
              a3 = wC(e3 | 0, n3 | 0, o3 & m2 | 0, (((p2 | 0) < 0 ? -1 : 0) >> 31 | ((p2 | 0) < 0 ? -1 : 0) << 1) & l3 | 0) | 0;
              b3 = A;
              h2 = h2 - 1 | 0;
            } while ((h2 | 0) != 0);
            k2 = j2;
            j2 = 0;
          }
          h2 = 0;
          if (f2 | 0) {
            c2[f2 >> 2] = a3;
            c2[f2 + 4 >> 2] = b3;
          }
          o3 = (g3 | 0) >>> 31 | (k2 | h2) << 1 | (h2 << 1 | g3 >>> 31) & 0 | j2;
          p2 = (g3 << 1 | 0 >>> 31) & -2 | i4;
          return (A = o3, p2) | 0;
        }
        function EC(a3, b3, c3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          c3 = c3 | 0;
          d2 = d2 | 0;
          return DC(a3, b3, c3, d2, 0) | 0;
        }
        function FC(a3) {
          a3 = a3 | 0;
          var b3 = 0, d2 = 0;
          d2 = a3 + 15 & -16 | 0;
          b3 = c2[i3 >> 2] | 0;
          a3 = b3 + d2 | 0;
          if ((d2 | 0) > 0 & (a3 | 0) < (b3 | 0) | (a3 | 0) < 0) {
            Y() | 0;
            Qa(12);
            return -1;
          }
          c2[i3 >> 2] = a3;
          if ((a3 | 0) > (X() | 0) ? (W() | 0) == 0 : 0) {
            c2[i3 >> 2] = b3;
            Qa(12);
            return -1;
          }
          return b3 | 0;
        }
        function GC(b3, c3, d2) {
          b3 = b3 | 0;
          c3 = c3 | 0;
          d2 = d2 | 0;
          var e3 = 0;
          if ((c3 | 0) < (b3 | 0) & (b3 | 0) < (c3 + d2 | 0)) {
            e3 = b3;
            c3 = c3 + d2 | 0;
            b3 = b3 + d2 | 0;
            while ((d2 | 0) > 0) {
              b3 = b3 - 1 | 0;
              c3 = c3 - 1 | 0;
              d2 = d2 - 1 | 0;
              a2[b3 >> 0] = a2[c3 >> 0] | 0;
            }
            b3 = e3;
          } else
            BC(b3, c3, d2) | 0;
          return b3 | 0;
        }
        function HC(a3, b3, d2, e3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          d2 = d2 | 0;
          e3 = e3 | 0;
          var f2 = 0, g3 = 0;
          g3 = l2;
          l2 = l2 + 16 | 0;
          f2 = g3 | 0;
          DC(a3, b3, d2, e3, f2) | 0;
          l2 = g3;
          return (A = c2[f2 + 4 >> 2] | 0, c2[f2 >> 2] | 0) | 0;
        }
        function IC(a3) {
          a3 = a3 | 0;
          return (a3 & 255) << 24 | (a3 >> 8 & 255) << 16 | (a3 >> 16 & 255) << 8 | a3 >>> 24 | 0;
        }
        function JC(a3, b3, c3, d2, e3, f2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          c3 = c3 | 0;
          d2 = d2 | 0;
          e3 = e3 | 0;
          f2 = f2 | 0;
          jb[a3 & 1](b3 | 0, c3 | 0, d2 | 0, e3 | 0, f2 | 0);
        }
        function KC(a3, b3, c3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          c3 = T(c3);
          kb[a3 & 1](b3 | 0, T(c3));
        }
        function LC(a3, b3, c3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          c3 = +c3;
          lb[a3 & 31](b3 | 0, +c3);
        }
        function MC(a3, b3, c3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          c3 = T(c3);
          d2 = T(d2);
          return T(mb[a3 & 0](b3 | 0, T(c3), T(d2)));
        }
        function NC(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          nb[a3 & 127](b3 | 0);
        }
        function OC(a3, b3, c3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          c3 = c3 | 0;
          ob[a3 & 31](b3 | 0, c3 | 0);
        }
        function PC(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          return pb[a3 & 31](b3 | 0) | 0;
        }
        function QC(a3, b3, c3, d2, e3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          c3 = +c3;
          d2 = +d2;
          e3 = e3 | 0;
          qb[a3 & 1](b3 | 0, +c3, +d2, e3 | 0);
        }
        function RC(a3, b3, c3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          c3 = +c3;
          d2 = +d2;
          rb[a3 & 1](b3 | 0, +c3, +d2);
        }
        function SC(a3, b3, c3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          c3 = c3 | 0;
          d2 = d2 | 0;
          return sb[a3 & 7](b3 | 0, c3 | 0, d2 | 0) | 0;
        }
        function TC(a3, b3, c3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          c3 = c3 | 0;
          d2 = d2 | 0;
          return +tb[a3 & 1](b3 | 0, c3 | 0, d2 | 0);
        }
        function UC(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          return +ub[a3 & 15](b3 | 0);
        }
        function VC(a3, b3, c3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          c3 = +c3;
          return vb[a3 & 1](b3 | 0, +c3) | 0;
        }
        function WC(a3, b3, c3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          c3 = c3 | 0;
          return wb[a3 & 15](b3 | 0, c3 | 0) | 0;
        }
        function XC(a3, b3, c3, d2, e3, f2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          c3 = c3 | 0;
          d2 = +d2;
          e3 = +e3;
          f2 = f2 | 0;
          xb[a3 & 1](b3 | 0, c3 | 0, +d2, +e3, f2 | 0);
        }
        function YC(a3, b3, c3, d2, e3, f2, g3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          c3 = c3 | 0;
          d2 = d2 | 0;
          e3 = e3 | 0;
          f2 = f2 | 0;
          g3 = g3 | 0;
          yb[a3 & 1](b3 | 0, c3 | 0, d2 | 0, e3 | 0, f2 | 0, g3 | 0);
        }
        function ZC(a3, b3, c3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          c3 = c3 | 0;
          return +zb[a3 & 7](b3 | 0, c3 | 0);
        }
        function _C(a3) {
          a3 = a3 | 0;
          return Ab[a3 & 7]() | 0;
        }
        function $C(a3, b3, c3, d2, e3, f2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          c3 = c3 | 0;
          d2 = d2 | 0;
          e3 = e3 | 0;
          f2 = f2 | 0;
          return Bb[a3 & 1](b3 | 0, c3 | 0, d2 | 0, e3 | 0, f2 | 0) | 0;
        }
        function aD(a3, b3, c3, d2, e3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          c3 = c3 | 0;
          d2 = d2 | 0;
          e3 = +e3;
          Cb[a3 & 1](b3 | 0, c3 | 0, d2 | 0, +e3);
        }
        function bD(a3, b3, c3, d2, e3, f2, g3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          c3 = c3 | 0;
          d2 = T(d2);
          e3 = e3 | 0;
          f2 = T(f2);
          g3 = g3 | 0;
          Db[a3 & 1](b3 | 0, c3 | 0, T(d2), e3 | 0, T(f2), g3 | 0);
        }
        function cD(a3, b3, c3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          c3 = c3 | 0;
          d2 = d2 | 0;
          Eb[a3 & 15](b3 | 0, c3 | 0, d2 | 0);
        }
        function dD(a3) {
          a3 = a3 | 0;
          Fb[a3 & 0]();
        }
        function eD(a3, b3, c3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          c3 = c3 | 0;
          d2 = +d2;
          Gb[a3 & 15](b3 | 0, c3 | 0, +d2);
        }
        function fD(a3, b3, c3) {
          a3 = a3 | 0;
          b3 = +b3;
          c3 = +c3;
          return Hb[a3 & 1](+b3, +c3) | 0;
        }
        function gD(a3, b3, c3, d2, e3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          c3 = c3 | 0;
          d2 = d2 | 0;
          e3 = e3 | 0;
          Ib[a3 & 15](b3 | 0, c3 | 0, d2 | 0, e3 | 0);
        }
        function hD(a3, b3, c3, d2, e3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          c3 = c3 | 0;
          d2 = d2 | 0;
          e3 = e3 | 0;
          U(0);
        }
        function iD(a3, b3) {
          a3 = a3 | 0;
          b3 = T(b3);
          U(1);
        }
        function jD(a3, b3) {
          a3 = a3 | 0;
          b3 = +b3;
          U(2);
        }
        function kD(a3, b3, c3) {
          a3 = a3 | 0;
          b3 = T(b3);
          c3 = T(c3);
          U(3);
          return ib;
        }
        function lD(a3) {
          a3 = a3 | 0;
          U(4);
        }
        function mD(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          U(5);
        }
        function nD(a3) {
          a3 = a3 | 0;
          U(6);
          return 0;
        }
        function oD(a3, b3, c3, d2) {
          a3 = a3 | 0;
          b3 = +b3;
          c3 = +c3;
          d2 = d2 | 0;
          U(7);
        }
        function pD(a3, b3, c3) {
          a3 = a3 | 0;
          b3 = +b3;
          c3 = +c3;
          U(8);
        }
        function qD(a3, b3, c3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          c3 = c3 | 0;
          U(9);
          return 0;
        }
        function rD(a3, b3, c3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          c3 = c3 | 0;
          U(10);
          return 0;
        }
        function sD(a3) {
          a3 = a3 | 0;
          U(11);
          return 0;
        }
        function tD(a3, b3) {
          a3 = a3 | 0;
          b3 = +b3;
          U(12);
          return 0;
        }
        function uD(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          U(13);
          return 0;
        }
        function vD(a3, b3, c3, d2, e3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          c3 = +c3;
          d2 = +d2;
          e3 = e3 | 0;
          U(14);
        }
        function wD(a3, b3, c3, d2, e3, f2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          c3 = c3 | 0;
          d2 = d2 | 0;
          e3 = e3 | 0;
          f2 = f2 | 0;
          U(15);
        }
        function xD(a3, b3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          U(16);
          return 0;
        }
        function yD() {
          U(17);
          return 0;
        }
        function zD(a3, b3, c3, d2, e3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          c3 = c3 | 0;
          d2 = d2 | 0;
          e3 = e3 | 0;
          U(18);
          return 0;
        }
        function AD(a3, b3, c3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          c3 = c3 | 0;
          d2 = +d2;
          U(19);
        }
        function BD(a3, b3, c3, d2, e3, f2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          c3 = T(c3);
          d2 = d2 | 0;
          e3 = T(e3);
          f2 = f2 | 0;
          U(20);
        }
        function CD(a3, b3, c3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          c3 = c3 | 0;
          U(21);
        }
        function DD() {
          U(22);
        }
        function ED(a3, b3, c3) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          c3 = +c3;
          U(23);
        }
        function FD(a3, b3) {
          a3 = +a3;
          b3 = +b3;
          U(24);
          return 0;
        }
        function GD(a3, b3, c3, d2) {
          a3 = a3 | 0;
          b3 = b3 | 0;
          c3 = c3 | 0;
          d2 = d2 | 0;
          U(25);
        }
        var jb = [hD, Uw];
        var kb = [iD, of];
        var lb = [jD, Of, Pf, Qf, Rf, Sf, Tf, Uf, Wf, Xf, Zf, _f, $f, ag, bg, cg, dg, eg, fg, jD, jD, jD, jD, jD, jD, jD, jD, jD, jD, jD, jD, jD];
        var mb = [kD];
        var nb = [lD, kC, Ki, Li, Mi, rn, sn, tn, Pu, Qu, Ru, Cw, Dw, Ew, DA, EA, FA, Rb, tf, yf, Vf, Yf, hh, ih, ri, Ui, kj, Jj, bk, zk, Wk, nl, Hl, bm, um, Nm, en, Nn, fo, yo, Ro, ip, Bp, Xp, nq, Eq, Zq, lf, Hr, _r, us, Ps, ft, Ct, Ot, Rt, ju, mu, Eu, Uu, Xu, pv, Kv, Vi, $x, Ky, az, sz, Rz, hA, tA, wA, lD, lD, lD, lD, lD, lD, lD, lD, lD, lD, lD, lD, lD, lD, lD, lD, lD, lD, lD, lD, lD, lD, lD, lD, lD, lD, lD, lD, lD, lD, lD, lD, lD, lD, lD, lD, lD, lD, lD, lD, lD, lD, lD, lD, lD, lD, lD, lD, lD, lD, lD, lD, lD, lD, lD, lD];
        var ob = [mD, zf, Af, Df, Ef, Ff, Gf, Hf, If, Lf, Mf, Nf, wg, zg, Ag, Bg, Cg, Dg, Eg, Jg, Ng, rh, $p, qq, Ts, cy, Sv, xy, mD, mD, mD, mD];
        var pb = [nD, rB, sf, jg, ng, og, pg, qg, rg, sg, ug, vg, Kg, Lg, jh, ar, jt, sv, hy, jy, nD, nD, nD, nD, nD, nD, nD, nD, nD, nD, nD, nD];
        var qb = [oD, kh];
        var rb = [pD, Hu];
        var sb = [qD, sB, tB, zB, Dk, Rn, Lr, wz];
        var tb = [rD, ym];
        var ub = [sD, xg, yg, Fg, lh, mh, nh, oh, ph, qh, sD, sD, sD, sD, sD, sD];
        var vb = [tD, Kt];
        var wb = [uD, lC, Mg, xi, Nj, _k, rl, jn, jo, Iq, pf, ez, uD, uD, uD, uD];
        var xb = [vD, oj];
        var yb = [wD, Vz];
        var zb = [xD, Gg, sh, th, uh, Rm, xD, xD];
        var Ab = [yD, vh, qf, jf, Wt, qu, av, AA];
        var Bb = [zD, ee];
        var Cb = [AD, Vo];
        var Db = [BD, Pg];
        var Eb = [CD, kg, tg, Hg, Ig, fk, Ll, mp, Fp, nf, vx, Oy, lA, CD, CD, CD];
        var Fb = [DD];
        var Gb = [ED, Bf, Cf, Jf, Kf, gg, hg, ig, Co, cs, Ft, ED, ED, ED, ED, ED];
        var Hb = [FD, Mu];
        var Ib = [GD, fm, ir, ys, st, au, wu, hv, Pv, oy, LA, GD, GD, GD, GD, GD];
        return { _llvm_bswap_i32: IC, dynCall_idd: fD, dynCall_i: _C, _i64Subtract: wC, ___udivdi3: EC, dynCall_vif: KC, setThrew: Nb, dynCall_viii: cD, _bitshift64Lshr: AC, _bitshift64Shl: zC, dynCall_vi: NC, dynCall_viiddi: XC, dynCall_diii: TC, dynCall_iii: WC, _memset: yC, _sbrk: FC, _memcpy: BC, __GLOBAL__sub_I_Yoga_cpp: hf, dynCall_vii: OC, ___uremdi3: HC, dynCall_vid: LC, stackAlloc: Jb, _nbind_init: _A, getTempRet0: Pb, dynCall_di: UC, dynCall_iid: VC, setTempRet0: Ob, _i64Add: xC, dynCall_fiff: MC, dynCall_iiii: SC, _emscripten_get_global_libc: qB, dynCall_viid: eD, dynCall_viiid: aD, dynCall_viififi: bD, dynCall_ii: PC, __GLOBAL__sub_I_Binding_cc: Sx, dynCall_viiii: gD, dynCall_iiiiii: $C, stackSave: Kb, dynCall_viiiii: JC, __GLOBAL__sub_I_nbind_cc: wh, dynCall_vidd: RC, _free: pB, runPostSets: vC, dynCall_viiiiii: YC, establishStackSpace: Mb, _memmove: GC, stackRestore: Lb, _malloc: oB, __GLOBAL__sub_I_common_cc: Bv, dynCall_viddi: QC, dynCall_dii: ZC, dynCall_v: dD };
      }(Module.asmGlobalArg, Module.asmLibraryArg, buffer);
      var _llvm_bswap_i32 = Module["_llvm_bswap_i32"] = asm["_llvm_bswap_i32"];
      var getTempRet0 = Module["getTempRet0"] = asm["getTempRet0"];
      var ___udivdi3 = Module["___udivdi3"] = asm["___udivdi3"];
      var setThrew = Module["setThrew"] = asm["setThrew"];
      var _bitshift64Lshr = Module["_bitshift64Lshr"] = asm["_bitshift64Lshr"];
      var _bitshift64Shl = Module["_bitshift64Shl"] = asm["_bitshift64Shl"];
      var _memset = Module["_memset"] = asm["_memset"];
      var _sbrk = Module["_sbrk"] = asm["_sbrk"];
      var _memcpy = Module["_memcpy"] = asm["_memcpy"];
      var stackAlloc = Module["stackAlloc"] = asm["stackAlloc"];
      var ___uremdi3 = Module["___uremdi3"] = asm["___uremdi3"];
      var _nbind_init = Module["_nbind_init"] = asm["_nbind_init"];
      var _i64Subtract = Module["_i64Subtract"] = asm["_i64Subtract"];
      var setTempRet0 = Module["setTempRet0"] = asm["setTempRet0"];
      var _i64Add = Module["_i64Add"] = asm["_i64Add"];
      var _emscripten_get_global_libc = Module["_emscripten_get_global_libc"] = asm["_emscripten_get_global_libc"];
      var __GLOBAL__sub_I_Yoga_cpp = Module["__GLOBAL__sub_I_Yoga_cpp"] = asm["__GLOBAL__sub_I_Yoga_cpp"];
      var __GLOBAL__sub_I_Binding_cc = Module["__GLOBAL__sub_I_Binding_cc"] = asm["__GLOBAL__sub_I_Binding_cc"];
      var stackSave = Module["stackSave"] = asm["stackSave"];
      var __GLOBAL__sub_I_nbind_cc = Module["__GLOBAL__sub_I_nbind_cc"] = asm["__GLOBAL__sub_I_nbind_cc"];
      var _free = Module["_free"] = asm["_free"];
      var runPostSets = Module["runPostSets"] = asm["runPostSets"];
      var establishStackSpace = Module["establishStackSpace"] = asm["establishStackSpace"];
      var _memmove = Module["_memmove"] = asm["_memmove"];
      var stackRestore = Module["stackRestore"] = asm["stackRestore"];
      var _malloc = Module["_malloc"] = asm["_malloc"];
      var __GLOBAL__sub_I_common_cc = Module["__GLOBAL__sub_I_common_cc"] = asm["__GLOBAL__sub_I_common_cc"];
      var dynCall_viiiii = Module["dynCall_viiiii"] = asm["dynCall_viiiii"];
      var dynCall_vif = Module["dynCall_vif"] = asm["dynCall_vif"];
      var dynCall_vid = Module["dynCall_vid"] = asm["dynCall_vid"];
      var dynCall_fiff = Module["dynCall_fiff"] = asm["dynCall_fiff"];
      var dynCall_vi = Module["dynCall_vi"] = asm["dynCall_vi"];
      var dynCall_vii = Module["dynCall_vii"] = asm["dynCall_vii"];
      var dynCall_ii = Module["dynCall_ii"] = asm["dynCall_ii"];
      var dynCall_viddi = Module["dynCall_viddi"] = asm["dynCall_viddi"];
      var dynCall_vidd = Module["dynCall_vidd"] = asm["dynCall_vidd"];
      var dynCall_iiii = Module["dynCall_iiii"] = asm["dynCall_iiii"];
      var dynCall_diii = Module["dynCall_diii"] = asm["dynCall_diii"];
      var dynCall_di = Module["dynCall_di"] = asm["dynCall_di"];
      var dynCall_iid = Module["dynCall_iid"] = asm["dynCall_iid"];
      var dynCall_iii = Module["dynCall_iii"] = asm["dynCall_iii"];
      var dynCall_viiddi = Module["dynCall_viiddi"] = asm["dynCall_viiddi"];
      var dynCall_viiiiii = Module["dynCall_viiiiii"] = asm["dynCall_viiiiii"];
      var dynCall_dii = Module["dynCall_dii"] = asm["dynCall_dii"];
      var dynCall_i = Module["dynCall_i"] = asm["dynCall_i"];
      var dynCall_iiiiii = Module["dynCall_iiiiii"] = asm["dynCall_iiiiii"];
      var dynCall_viiid = Module["dynCall_viiid"] = asm["dynCall_viiid"];
      var dynCall_viififi = Module["dynCall_viififi"] = asm["dynCall_viififi"];
      var dynCall_viii = Module["dynCall_viii"] = asm["dynCall_viii"];
      var dynCall_v = Module["dynCall_v"] = asm["dynCall_v"];
      var dynCall_viid = Module["dynCall_viid"] = asm["dynCall_viid"];
      var dynCall_idd = Module["dynCall_idd"] = asm["dynCall_idd"];
      var dynCall_viiii = Module["dynCall_viiii"] = asm["dynCall_viiii"];
      Runtime.stackAlloc = Module["stackAlloc"];
      Runtime.stackSave = Module["stackSave"];
      Runtime.stackRestore = Module["stackRestore"];
      Runtime.establishStackSpace = Module["establishStackSpace"];
      Runtime.setTempRet0 = Module["setTempRet0"];
      Runtime.getTempRet0 = Module["getTempRet0"];
      Module["asm"] = asm;
      function ExitStatus(status) {
        this.name = "ExitStatus";
        this.message = "Program terminated with exit(" + status + ")";
        this.status = status;
      }
      ExitStatus.prototype = new Error();
      ExitStatus.prototype.constructor = ExitStatus;
      var initialStackTop;
      var preloadStartTime = null;
      var calledMain = false;
      dependenciesFulfilled = function runCaller() {
        if (!Module["calledRun"])
          run();
        if (!Module["calledRun"])
          dependenciesFulfilled = runCaller;
      };
      Module["callMain"] = Module.callMain = function callMain(args) {
        args = args || [];
        ensureInitRuntime();
        var argc = args.length + 1;
        function pad() {
          for (var i4 = 0; i4 < 4 - 1; i4++) {
            argv.push(0);
          }
        }
        var argv = [allocate(intArrayFromString(Module["thisProgram"]), "i8", ALLOC_NORMAL)];
        pad();
        for (var i3 = 0; i3 < argc - 1; i3 = i3 + 1) {
          argv.push(allocate(intArrayFromString(args[i3]), "i8", ALLOC_NORMAL));
          pad();
        }
        argv.push(0);
        argv = allocate(argv, "i32", ALLOC_NORMAL);
        try {
          var ret = Module["_main"](argc, argv, 0);
          exit(ret, true);
        } catch (e2) {
          if (e2 instanceof ExitStatus) {
            return;
          } else if (e2 == "SimulateInfiniteLoop") {
            Module["noExitRuntime"] = true;
            return;
          } else {
            var toLog = e2;
            if (e2 && typeof e2 === "object" && e2.stack) {
              toLog = [e2, e2.stack];
            }
            Module.printErr("exception thrown: " + toLog);
            Module["quit"](1, e2);
          }
        } finally {
          calledMain = true;
        }
      };
      function run(args) {
        args = args || Module["arguments"];
        if (preloadStartTime === null)
          preloadStartTime = Date.now();
        if (runDependencies > 0) {
          return;
        }
        preRun();
        if (runDependencies > 0)
          return;
        if (Module["calledRun"])
          return;
        function doRun() {
          if (Module["calledRun"])
            return;
          Module["calledRun"] = true;
          if (ABORT)
            return;
          ensureInitRuntime();
          preMain();
          if (Module["onRuntimeInitialized"])
            Module["onRuntimeInitialized"]();
          if (Module["_main"] && shouldRunNow)
            Module["callMain"](args);
          postRun();
        }
        if (Module["setStatus"]) {
          Module["setStatus"]("Running...");
          setTimeout(function() {
            setTimeout(function() {
              Module["setStatus"]("");
            }, 1);
            doRun();
          }, 1);
        } else {
          doRun();
        }
      }
      Module["run"] = Module.run = run;
      function exit(status, implicit) {
        if (implicit && Module["noExitRuntime"]) {
          return;
        }
        if (Module["noExitRuntime"]) {
        } else {
          ABORT = true;
          EXITSTATUS = status;
          STACKTOP = initialStackTop;
          exitRuntime();
          if (Module["onExit"])
            Module["onExit"](status);
        }
        if (ENVIRONMENT_IS_NODE) {
          process["exit"](status);
        }
        Module["quit"](status, new ExitStatus(status));
      }
      Module["exit"] = Module.exit = exit;
      var abortDecorators = [];
      function abort(what) {
        if (Module["onAbort"]) {
          Module["onAbort"](what);
        }
        if (what !== void 0) {
          Module.print(what);
          Module.printErr(what);
          what = JSON.stringify(what);
        } else {
          what = "";
        }
        ABORT = true;
        EXITSTATUS = 1;
        var extra = "\nIf this abort() is unexpected, build with -s ASSERTIONS=1 which can give more information.";
        var output = "abort(" + what + ") at " + stackTrace() + extra;
        if (abortDecorators) {
          abortDecorators.forEach(function(decorator) {
            output = decorator(output, what);
          });
        }
        throw output;
      }
      Module["abort"] = Module.abort = abort;
      if (Module["preInit"]) {
        if (typeof Module["preInit"] == "function")
          Module["preInit"] = [Module["preInit"]];
        while (Module["preInit"].length > 0) {
          Module["preInit"].pop()();
        }
      }
      var shouldRunNow = true;
      if (Module["noInitialRun"]) {
        shouldRunNow = false;
      }
      run();
    });
  }
});

// node_modules/yoga-layout-prebuilt/yoga-layout/dist/entry-browser.js
var require_entry_browser = __commonJS({
  "node_modules/yoga-layout-prebuilt/yoga-layout/dist/entry-browser.js"(exports2, module2) {
    "use strict";
    var Yoga = require_entry_common();
    var nbind = require_nbind();
    var ran = false;
    var ret = null;
    nbind({}, function(err2, result2) {
      if (ran) {
        return;
      }
      ran = true;
      if (err2) {
        throw err2;
      }
      ret = result2;
    });
    if (!ran) {
      throw new Error("Failed to load the yoga module - it needed to be loaded synchronously, but didn't");
    }
    module2.exports = Yoga(ret.bind, ret.lib);
  }
});

// node_modules/ansi-regex/index.js
var require_ansi_regex = __commonJS({
  "node_modules/ansi-regex/index.js"(exports2, module2) {
    "use strict";
    module2.exports = ({ onlyFirst = false } = {}) => {
      const pattern = [
        "[\\u001B\\u009B][[\\]()#;?]*(?:(?:(?:(?:;[-a-zA-Z\\d\\/#&.:=?%@~_]+)*|[a-zA-Z\\d]+(?:;[-a-zA-Z\\d\\/#&.:=?%@~_]*)*)?\\u0007)",
        "(?:(?:\\d{1,4}(?:;\\d{0,4})*)?[\\dA-PR-TZcf-ntqry=><~]))"
      ].join("|");
      return new RegExp(pattern, onlyFirst ? void 0 : "g");
    };
  }
});

// node_modules/strip-ansi/index.js
var require_strip_ansi = __commonJS({
  "node_modules/strip-ansi/index.js"(exports2, module2) {
    "use strict";
    var ansiRegex = require_ansi_regex();
    module2.exports = (string) => typeof string === "string" ? string.replace(ansiRegex(), "") : string;
  }
});

// node_modules/is-fullwidth-code-point/index.js
var require_is_fullwidth_code_point = __commonJS({
  "node_modules/is-fullwidth-code-point/index.js"(exports2, module2) {
    "use strict";
    var isFullwidthCodePoint = (codePoint) => {
      if (Number.isNaN(codePoint)) {
        return false;
      }
      if (codePoint >= 4352 && (codePoint <= 4447 || codePoint === 9001 || codePoint === 9002 || 11904 <= codePoint && codePoint <= 12871 && codePoint !== 12351 || 12880 <= codePoint && codePoint <= 19903 || 19968 <= codePoint && codePoint <= 42182 || 43360 <= codePoint && codePoint <= 43388 || 44032 <= codePoint && codePoint <= 55203 || 63744 <= codePoint && codePoint <= 64255 || 65040 <= codePoint && codePoint <= 65049 || 65072 <= codePoint && codePoint <= 65131 || 65281 <= codePoint && codePoint <= 65376 || 65504 <= codePoint && codePoint <= 65510 || 110592 <= codePoint && codePoint <= 110593 || 127488 <= codePoint && codePoint <= 127569 || 131072 <= codePoint && codePoint <= 262141)) {
        return true;
      }
      return false;
    };
    module2.exports = isFullwidthCodePoint;
    module2.exports.default = isFullwidthCodePoint;
  }
});

// node_modules/string-width/node_modules/emoji-regex/index.js
var require_emoji_regex = __commonJS({
  "node_modules/string-width/node_modules/emoji-regex/index.js"(exports2, module2) {
    "use strict";
    module2.exports = function() {
      return /\uD83C\uDFF4\uDB40\uDC67\uDB40\uDC62(?:\uDB40\uDC65\uDB40\uDC6E\uDB40\uDC67|\uDB40\uDC73\uDB40\uDC63\uDB40\uDC74|\uDB40\uDC77\uDB40\uDC6C\uDB40\uDC73)\uDB40\uDC7F|\uD83D\uDC68(?:\uD83C\uDFFC\u200D(?:\uD83E\uDD1D\u200D\uD83D\uDC68\uD83C\uDFFB|\uD83C[\uDF3E\uDF73\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFF\u200D(?:\uD83E\uDD1D\u200D\uD83D\uDC68(?:\uD83C[\uDFFB-\uDFFE])|\uD83C[\uDF3E\uDF73\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFE\u200D(?:\uD83E\uDD1D\u200D\uD83D\uDC68(?:\uD83C[\uDFFB-\uDFFD])|\uD83C[\uDF3E\uDF73\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFD\u200D(?:\uD83E\uDD1D\u200D\uD83D\uDC68(?:\uD83C[\uDFFB\uDFFC])|\uD83C[\uDF3E\uDF73\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\u200D(?:\u2764\uFE0F\u200D(?:\uD83D\uDC8B\u200D)?\uD83D\uDC68|(?:\uD83D[\uDC68\uDC69])\u200D(?:\uD83D\uDC66\u200D\uD83D\uDC66|\uD83D\uDC67\u200D(?:\uD83D[\uDC66\uDC67]))|\uD83D\uDC66\u200D\uD83D\uDC66|\uD83D\uDC67\u200D(?:\uD83D[\uDC66\uDC67])|(?:\uD83D[\uDC68\uDC69])\u200D(?:\uD83D[\uDC66\uDC67])|[\u2695\u2696\u2708]\uFE0F|\uD83D[\uDC66\uDC67]|\uD83C[\uDF3E\uDF73\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|(?:\uD83C\uDFFB\u200D[\u2695\u2696\u2708]|\uD83C\uDFFF\u200D[\u2695\u2696\u2708]|\uD83C\uDFFE\u200D[\u2695\u2696\u2708]|\uD83C\uDFFD\u200D[\u2695\u2696\u2708]|\uD83C\uDFFC\u200D[\u2695\u2696\u2708])\uFE0F|\uD83C\uDFFB\u200D(?:\uD83C[\uDF3E\uDF73\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C[\uDFFB-\uDFFF])|(?:\uD83E\uDDD1\uD83C\uDFFB\u200D\uD83E\uDD1D\u200D\uD83E\uDDD1|\uD83D\uDC69\uD83C\uDFFC\u200D\uD83E\uDD1D\u200D\uD83D\uDC69)\uD83C\uDFFB|\uD83E\uDDD1(?:\uD83C\uDFFF\u200D\uD83E\uDD1D\u200D\uD83E\uDDD1(?:\uD83C[\uDFFB-\uDFFF])|\u200D\uD83E\uDD1D\u200D\uD83E\uDDD1)|(?:\uD83E\uDDD1\uD83C\uDFFE\u200D\uD83E\uDD1D\u200D\uD83E\uDDD1|\uD83D\uDC69\uD83C\uDFFF\u200D\uD83E\uDD1D\u200D(?:\uD83D[\uDC68\uDC69]))(?:\uD83C[\uDFFB-\uDFFE])|(?:\uD83E\uDDD1\uD83C\uDFFC\u200D\uD83E\uDD1D\u200D\uD83E\uDDD1|\uD83D\uDC69\uD83C\uDFFD\u200D\uD83E\uDD1D\u200D\uD83D\uDC69)(?:\uD83C[\uDFFB\uDFFC])|\uD83D\uDC69(?:\uD83C\uDFFE\u200D(?:\uD83E\uDD1D\u200D\uD83D\uDC68(?:\uD83C[\uDFFB-\uDFFD\uDFFF])|\uD83C[\uDF3E\uDF73\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFC\u200D(?:\uD83E\uDD1D\u200D\uD83D\uDC68(?:\uD83C[\uDFFB\uDFFD-\uDFFF])|\uD83C[\uDF3E\uDF73\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFB\u200D(?:\uD83E\uDD1D\u200D\uD83D\uDC68(?:\uD83C[\uDFFC-\uDFFF])|\uD83C[\uDF3E\uDF73\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFD\u200D(?:\uD83E\uDD1D\u200D\uD83D\uDC68(?:\uD83C[\uDFFB\uDFFC\uDFFE\uDFFF])|\uD83C[\uDF3E\uDF73\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\u200D(?:\u2764\uFE0F\u200D(?:\uD83D\uDC8B\u200D(?:\uD83D[\uDC68\uDC69])|\uD83D[\uDC68\uDC69])|\uD83C[\uDF3E\uDF73\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFF\u200D(?:\uD83C[\uDF3E\uDF73\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD]))|\uD83D\uDC69\u200D\uD83D\uDC69\u200D(?:\uD83D\uDC66\u200D\uD83D\uDC66|\uD83D\uDC67\u200D(?:\uD83D[\uDC66\uDC67]))|(?:\uD83E\uDDD1\uD83C\uDFFD\u200D\uD83E\uDD1D\u200D\uD83E\uDDD1|\uD83D\uDC69\uD83C\uDFFE\u200D\uD83E\uDD1D\u200D\uD83D\uDC69)(?:\uD83C[\uDFFB-\uDFFD])|\uD83D\uDC69\u200D\uD83D\uDC66\u200D\uD83D\uDC66|\uD83D\uDC69\u200D\uD83D\uDC69\u200D(?:\uD83D[\uDC66\uDC67])|(?:\uD83D\uDC41\uFE0F\u200D\uD83D\uDDE8|\uD83D\uDC69(?:\uD83C\uDFFF\u200D[\u2695\u2696\u2708]|\uD83C\uDFFE\u200D[\u2695\u2696\u2708]|\uD83C\uDFFC\u200D[\u2695\u2696\u2708]|\uD83C\uDFFB\u200D[\u2695\u2696\u2708]|\uD83C\uDFFD\u200D[\u2695\u2696\u2708]|\u200D[\u2695\u2696\u2708])|(?:(?:\u26F9|\uD83C[\uDFCB\uDFCC]|\uD83D\uDD75)\uFE0F|\uD83D\uDC6F|\uD83E[\uDD3C\uDDDE\uDDDF])\u200D[\u2640\u2642]|(?:\u26F9|\uD83C[\uDFCB\uDFCC]|\uD83D\uDD75)(?:\uD83C[\uDFFB-\uDFFF])\u200D[\u2640\u2642]|(?:\uD83C[\uDFC3\uDFC4\uDFCA]|\uD83D[\uDC6E\uDC71\uDC73\uDC77\uDC81\uDC82\uDC86\uDC87\uDE45-\uDE47\uDE4B\uDE4D\uDE4E\uDEA3\uDEB4-\uDEB6]|\uD83E[\uDD26\uDD37-\uDD39\uDD3D\uDD3E\uDDB8\uDDB9\uDDCD-\uDDCF\uDDD6-\uDDDD])(?:(?:\uD83C[\uDFFB-\uDFFF])\u200D[\u2640\u2642]|\u200D[\u2640\u2642])|\uD83C\uDFF4\u200D\u2620)\uFE0F|\uD83D\uDC69\u200D\uD83D\uDC67\u200D(?:\uD83D[\uDC66\uDC67])|\uD83C\uDFF3\uFE0F\u200D\uD83C\uDF08|\uD83D\uDC15\u200D\uD83E\uDDBA|\uD83D\uDC69\u200D\uD83D\uDC66|\uD83D\uDC69\u200D\uD83D\uDC67|\uD83C\uDDFD\uD83C\uDDF0|\uD83C\uDDF4\uD83C\uDDF2|\uD83C\uDDF6\uD83C\uDDE6|[#\*0-9]\uFE0F\u20E3|\uD83C\uDDE7(?:\uD83C[\uDDE6\uDDE7\uDDE9-\uDDEF\uDDF1-\uDDF4\uDDF6-\uDDF9\uDDFB\uDDFC\uDDFE\uDDFF])|\uD83C\uDDF9(?:\uD83C[\uDDE6\uDDE8\uDDE9\uDDEB-\uDDED\uDDEF-\uDDF4\uDDF7\uDDF9\uDDFB\uDDFC\uDDFF])|\uD83C\uDDEA(?:\uD83C[\uDDE6\uDDE8\uDDEA\uDDEC\uDDED\uDDF7-\uDDFA])|\uD83E\uDDD1(?:\uD83C[\uDFFB-\uDFFF])|\uD83C\uDDF7(?:\uD83C[\uDDEA\uDDF4\uDDF8\uDDFA\uDDFC])|\uD83D\uDC69(?:\uD83C[\uDFFB-\uDFFF])|\uD83C\uDDF2(?:\uD83C[\uDDE6\uDDE8-\uDDED\uDDF0-\uDDFF])|\uD83C\uDDE6(?:\uD83C[\uDDE8-\uDDEC\uDDEE\uDDF1\uDDF2\uDDF4\uDDF6-\uDDFA\uDDFC\uDDFD\uDDFF])|\uD83C\uDDF0(?:\uD83C[\uDDEA\uDDEC-\uDDEE\uDDF2\uDDF3\uDDF5\uDDF7\uDDFC\uDDFE\uDDFF])|\uD83C\uDDED(?:\uD83C[\uDDF0\uDDF2\uDDF3\uDDF7\uDDF9\uDDFA])|\uD83C\uDDE9(?:\uD83C[\uDDEA\uDDEC\uDDEF\uDDF0\uDDF2\uDDF4\uDDFF])|\uD83C\uDDFE(?:\uD83C[\uDDEA\uDDF9])|\uD83C\uDDEC(?:\uD83C[\uDDE6\uDDE7\uDDE9-\uDDEE\uDDF1-\uDDF3\uDDF5-\uDDFA\uDDFC\uDDFE])|\uD83C\uDDF8(?:\uD83C[\uDDE6-\uDDEA\uDDEC-\uDDF4\uDDF7-\uDDF9\uDDFB\uDDFD-\uDDFF])|\uD83C\uDDEB(?:\uD83C[\uDDEE-\uDDF0\uDDF2\uDDF4\uDDF7])|\uD83C\uDDF5(?:\uD83C[\uDDE6\uDDEA-\uDDED\uDDF0-\uDDF3\uDDF7-\uDDF9\uDDFC\uDDFE])|\uD83C\uDDFB(?:\uD83C[\uDDE6\uDDE8\uDDEA\uDDEC\uDDEE\uDDF3\uDDFA])|\uD83C\uDDF3(?:\uD83C[\uDDE6\uDDE8\uDDEA-\uDDEC\uDDEE\uDDF1\uDDF4\uDDF5\uDDF7\uDDFA\uDDFF])|\uD83C\uDDE8(?:\uD83C[\uDDE6\uDDE8\uDDE9\uDDEB-\uDDEE\uDDF0-\uDDF5\uDDF7\uDDFA-\uDDFF])|\uD83C\uDDF1(?:\uD83C[\uDDE6-\uDDE8\uDDEE\uDDF0\uDDF7-\uDDFB\uDDFE])|\uD83C\uDDFF(?:\uD83C[\uDDE6\uDDF2\uDDFC])|\uD83C\uDDFC(?:\uD83C[\uDDEB\uDDF8])|\uD83C\uDDFA(?:\uD83C[\uDDE6\uDDEC\uDDF2\uDDF3\uDDF8\uDDFE\uDDFF])|\uD83C\uDDEE(?:\uD83C[\uDDE8-\uDDEA\uDDF1-\uDDF4\uDDF6-\uDDF9])|\uD83C\uDDEF(?:\uD83C[\uDDEA\uDDF2\uDDF4\uDDF5])|(?:\uD83C[\uDFC3\uDFC4\uDFCA]|\uD83D[\uDC6E\uDC71\uDC73\uDC77\uDC81\uDC82\uDC86\uDC87\uDE45-\uDE47\uDE4B\uDE4D\uDE4E\uDEA3\uDEB4-\uDEB6]|\uD83E[\uDD26\uDD37-\uDD39\uDD3D\uDD3E\uDDB8\uDDB9\uDDCD-\uDDCF\uDDD6-\uDDDD])(?:\uD83C[\uDFFB-\uDFFF])|(?:\u26F9|\uD83C[\uDFCB\uDFCC]|\uD83D\uDD75)(?:\uD83C[\uDFFB-\uDFFF])|(?:[\u261D\u270A-\u270D]|\uD83C[\uDF85\uDFC2\uDFC7]|\uD83D[\uDC42\uDC43\uDC46-\uDC50\uDC66\uDC67\uDC6B-\uDC6D\uDC70\uDC72\uDC74-\uDC76\uDC78\uDC7C\uDC83\uDC85\uDCAA\uDD74\uDD7A\uDD90\uDD95\uDD96\uDE4C\uDE4F\uDEC0\uDECC]|\uD83E[\uDD0F\uDD18-\uDD1C\uDD1E\uDD1F\uDD30-\uDD36\uDDB5\uDDB6\uDDBB\uDDD2-\uDDD5])(?:\uD83C[\uDFFB-\uDFFF])|(?:[\u231A\u231B\u23E9-\u23EC\u23F0\u23F3\u25FD\u25FE\u2614\u2615\u2648-\u2653\u267F\u2693\u26A1\u26AA\u26AB\u26BD\u26BE\u26C4\u26C5\u26CE\u26D4\u26EA\u26F2\u26F3\u26F5\u26FA\u26FD\u2705\u270A\u270B\u2728\u274C\u274E\u2753-\u2755\u2757\u2795-\u2797\u27B0\u27BF\u2B1B\u2B1C\u2B50\u2B55]|\uD83C[\uDC04\uDCCF\uDD8E\uDD91-\uDD9A\uDDE6-\uDDFF\uDE01\uDE1A\uDE2F\uDE32-\uDE36\uDE38-\uDE3A\uDE50\uDE51\uDF00-\uDF20\uDF2D-\uDF35\uDF37-\uDF7C\uDF7E-\uDF93\uDFA0-\uDFCA\uDFCF-\uDFD3\uDFE0-\uDFF0\uDFF4\uDFF8-\uDFFF]|\uD83D[\uDC00-\uDC3E\uDC40\uDC42-\uDCFC\uDCFF-\uDD3D\uDD4B-\uDD4E\uDD50-\uDD67\uDD7A\uDD95\uDD96\uDDA4\uDDFB-\uDE4F\uDE80-\uDEC5\uDECC\uDED0-\uDED2\uDED5\uDEEB\uDEEC\uDEF4-\uDEFA\uDFE0-\uDFEB]|\uD83E[\uDD0D-\uDD3A\uDD3C-\uDD45\uDD47-\uDD71\uDD73-\uDD76\uDD7A-\uDDA2\uDDA5-\uDDAA\uDDAE-\uDDCA\uDDCD-\uDDFF\uDE70-\uDE73\uDE78-\uDE7A\uDE80-\uDE82\uDE90-\uDE95])|(?:[#\*0-9\xA9\xAE\u203C\u2049\u2122\u2139\u2194-\u2199\u21A9\u21AA\u231A\u231B\u2328\u23CF\u23E9-\u23F3\u23F8-\u23FA\u24C2\u25AA\u25AB\u25B6\u25C0\u25FB-\u25FE\u2600-\u2604\u260E\u2611\u2614\u2615\u2618\u261D\u2620\u2622\u2623\u2626\u262A\u262E\u262F\u2638-\u263A\u2640\u2642\u2648-\u2653\u265F\u2660\u2663\u2665\u2666\u2668\u267B\u267E\u267F\u2692-\u2697\u2699\u269B\u269C\u26A0\u26A1\u26AA\u26AB\u26B0\u26B1\u26BD\u26BE\u26C4\u26C5\u26C8\u26CE\u26CF\u26D1\u26D3\u26D4\u26E9\u26EA\u26F0-\u26F5\u26F7-\u26FA\u26FD\u2702\u2705\u2708-\u270D\u270F\u2712\u2714\u2716\u271D\u2721\u2728\u2733\u2734\u2744\u2747\u274C\u274E\u2753-\u2755\u2757\u2763\u2764\u2795-\u2797\u27A1\u27B0\u27BF\u2934\u2935\u2B05-\u2B07\u2B1B\u2B1C\u2B50\u2B55\u3030\u303D\u3297\u3299]|\uD83C[\uDC04\uDCCF\uDD70\uDD71\uDD7E\uDD7F\uDD8E\uDD91-\uDD9A\uDDE6-\uDDFF\uDE01\uDE02\uDE1A\uDE2F\uDE32-\uDE3A\uDE50\uDE51\uDF00-\uDF21\uDF24-\uDF93\uDF96\uDF97\uDF99-\uDF9B\uDF9E-\uDFF0\uDFF3-\uDFF5\uDFF7-\uDFFF]|\uD83D[\uDC00-\uDCFD\uDCFF-\uDD3D\uDD49-\uDD4E\uDD50-\uDD67\uDD6F\uDD70\uDD73-\uDD7A\uDD87\uDD8A-\uDD8D\uDD90\uDD95\uDD96\uDDA4\uDDA5\uDDA8\uDDB1\uDDB2\uDDBC\uDDC2-\uDDC4\uDDD1-\uDDD3\uDDDC-\uDDDE\uDDE1\uDDE3\uDDE8\uDDEF\uDDF3\uDDFA-\uDE4F\uDE80-\uDEC5\uDECB-\uDED2\uDED5\uDEE0-\uDEE5\uDEE9\uDEEB\uDEEC\uDEF0\uDEF3-\uDEFA\uDFE0-\uDFEB]|\uD83E[\uDD0D-\uDD3A\uDD3C-\uDD45\uDD47-\uDD71\uDD73-\uDD76\uDD7A-\uDDA2\uDDA5-\uDDAA\uDDAE-\uDDCA\uDDCD-\uDDFF\uDE70-\uDE73\uDE78-\uDE7A\uDE80-\uDE82\uDE90-\uDE95])\uFE0F|(?:[\u261D\u26F9\u270A-\u270D]|\uD83C[\uDF85\uDFC2-\uDFC4\uDFC7\uDFCA-\uDFCC]|\uD83D[\uDC42\uDC43\uDC46-\uDC50\uDC66-\uDC78\uDC7C\uDC81-\uDC83\uDC85-\uDC87\uDC8F\uDC91\uDCAA\uDD74\uDD75\uDD7A\uDD90\uDD95\uDD96\uDE45-\uDE47\uDE4B-\uDE4F\uDEA3\uDEB4-\uDEB6\uDEC0\uDECC]|\uD83E[\uDD0F\uDD18-\uDD1F\uDD26\uDD30-\uDD39\uDD3C-\uDD3E\uDDB5\uDDB6\uDDB8\uDDB9\uDDBB\uDDCD-\uDDCF\uDDD1-\uDDDD])/g;
    };
  }
});

// node_modules/string-width/index.js
var require_string_width = __commonJS({
  "node_modules/string-width/index.js"(exports2, module2) {
    "use strict";
    var stripAnsi = require_strip_ansi();
    var isFullwidthCodePoint = require_is_fullwidth_code_point();
    var emojiRegex = require_emoji_regex();
    var stringWidth = (string) => {
      if (typeof string !== "string" || string.length === 0) {
        return 0;
      }
      string = stripAnsi(string);
      if (string.length === 0) {
        return 0;
      }
      string = string.replace(emojiRegex(), "  ");
      let width = 0;
      for (let i3 = 0; i3 < string.length; i3++) {
        const code = string.codePointAt(i3);
        if (code <= 31 || code >= 127 && code <= 159) {
          continue;
        }
        if (code >= 768 && code <= 879) {
          continue;
        }
        if (code > 65535) {
          i3++;
        }
        width += isFullwidthCodePoint(code) ? 2 : 1;
      }
      return width;
    };
    module2.exports = stringWidth;
    module2.exports.default = stringWidth;
  }
});

// node_modules/widest-line/index.js
var require_widest_line = __commonJS({
  "node_modules/widest-line/index.js"(exports2, module2) {
    "use strict";
    var stringWidth = require_string_width();
    var widestLine = (input) => {
      let max = 0;
      for (const line of input.split("\n")) {
        max = Math.max(max, stringWidth(line));
      }
      return max;
    };
    module2.exports = widestLine;
    module2.exports.default = widestLine;
  }
});

// node_modules/ink/build/measure-text.js
var require_measure_text = __commonJS({
  "node_modules/ink/build/measure-text.js"(exports2) {
    "use strict";
    var __importDefault = exports2 && exports2.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { "default": mod };
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    var widest_line_1 = __importDefault(require_widest_line());
    var cache = {};
    exports2.default = (text) => {
      if (text.length === 0) {
        return {
          width: 0,
          height: 0
        };
      }
      if (cache[text]) {
        return cache[text];
      }
      const width = widest_line_1.default(text);
      const height = text.split("\n").length;
      cache[text] = { width, height };
      return { width, height };
    };
  }
});

// node_modules/ink/build/styles.js
var require_styles = __commonJS({
  "node_modules/ink/build/styles.js"(exports2) {
    "use strict";
    var __importDefault = exports2 && exports2.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { "default": mod };
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    var yoga_layout_prebuilt_1 = __importDefault(require_entry_browser());
    var applyPositionStyles = (node, style) => {
      if ("position" in style) {
        node.setPositionType(style.position === "absolute" ? yoga_layout_prebuilt_1.default.POSITION_TYPE_ABSOLUTE : yoga_layout_prebuilt_1.default.POSITION_TYPE_RELATIVE);
      }
    };
    var applyMarginStyles = (node, style) => {
      if ("marginLeft" in style) {
        node.setMargin(yoga_layout_prebuilt_1.default.EDGE_START, style.marginLeft || 0);
      }
      if ("marginRight" in style) {
        node.setMargin(yoga_layout_prebuilt_1.default.EDGE_END, style.marginRight || 0);
      }
      if ("marginTop" in style) {
        node.setMargin(yoga_layout_prebuilt_1.default.EDGE_TOP, style.marginTop || 0);
      }
      if ("marginBottom" in style) {
        node.setMargin(yoga_layout_prebuilt_1.default.EDGE_BOTTOM, style.marginBottom || 0);
      }
    };
    var applyPaddingStyles = (node, style) => {
      if ("paddingLeft" in style) {
        node.setPadding(yoga_layout_prebuilt_1.default.EDGE_LEFT, style.paddingLeft || 0);
      }
      if ("paddingRight" in style) {
        node.setPadding(yoga_layout_prebuilt_1.default.EDGE_RIGHT, style.paddingRight || 0);
      }
      if ("paddingTop" in style) {
        node.setPadding(yoga_layout_prebuilt_1.default.EDGE_TOP, style.paddingTop || 0);
      }
      if ("paddingBottom" in style) {
        node.setPadding(yoga_layout_prebuilt_1.default.EDGE_BOTTOM, style.paddingBottom || 0);
      }
    };
    var applyFlexStyles = (node, style) => {
      var _a2;
      if ("flexGrow" in style) {
        node.setFlexGrow((_a2 = style.flexGrow) !== null && _a2 !== void 0 ? _a2 : 0);
      }
      if ("flexShrink" in style) {
        node.setFlexShrink(typeof style.flexShrink === "number" ? style.flexShrink : 1);
      }
      if ("flexDirection" in style) {
        if (style.flexDirection === "row") {
          node.setFlexDirection(yoga_layout_prebuilt_1.default.FLEX_DIRECTION_ROW);
        }
        if (style.flexDirection === "row-reverse") {
          node.setFlexDirection(yoga_layout_prebuilt_1.default.FLEX_DIRECTION_ROW_REVERSE);
        }
        if (style.flexDirection === "column") {
          node.setFlexDirection(yoga_layout_prebuilt_1.default.FLEX_DIRECTION_COLUMN);
        }
        if (style.flexDirection === "column-reverse") {
          node.setFlexDirection(yoga_layout_prebuilt_1.default.FLEX_DIRECTION_COLUMN_REVERSE);
        }
      }
      if ("flexBasis" in style) {
        if (typeof style.flexBasis === "number") {
          node.setFlexBasis(style.flexBasis);
        } else if (typeof style.flexBasis === "string") {
          node.setFlexBasisPercent(Number.parseInt(style.flexBasis, 10));
        } else {
          node.setFlexBasis(NaN);
        }
      }
      if ("alignItems" in style) {
        if (style.alignItems === "stretch" || !style.alignItems) {
          node.setAlignItems(yoga_layout_prebuilt_1.default.ALIGN_STRETCH);
        }
        if (style.alignItems === "flex-start") {
          node.setAlignItems(yoga_layout_prebuilt_1.default.ALIGN_FLEX_START);
        }
        if (style.alignItems === "center") {
          node.setAlignItems(yoga_layout_prebuilt_1.default.ALIGN_CENTER);
        }
        if (style.alignItems === "flex-end") {
          node.setAlignItems(yoga_layout_prebuilt_1.default.ALIGN_FLEX_END);
        }
      }
      if ("alignSelf" in style) {
        if (style.alignSelf === "auto" || !style.alignSelf) {
          node.setAlignSelf(yoga_layout_prebuilt_1.default.ALIGN_AUTO);
        }
        if (style.alignSelf === "flex-start") {
          node.setAlignSelf(yoga_layout_prebuilt_1.default.ALIGN_FLEX_START);
        }
        if (style.alignSelf === "center") {
          node.setAlignSelf(yoga_layout_prebuilt_1.default.ALIGN_CENTER);
        }
        if (style.alignSelf === "flex-end") {
          node.setAlignSelf(yoga_layout_prebuilt_1.default.ALIGN_FLEX_END);
        }
      }
      if ("justifyContent" in style) {
        if (style.justifyContent === "flex-start" || !style.justifyContent) {
          node.setJustifyContent(yoga_layout_prebuilt_1.default.JUSTIFY_FLEX_START);
        }
        if (style.justifyContent === "center") {
          node.setJustifyContent(yoga_layout_prebuilt_1.default.JUSTIFY_CENTER);
        }
        if (style.justifyContent === "flex-end") {
          node.setJustifyContent(yoga_layout_prebuilt_1.default.JUSTIFY_FLEX_END);
        }
        if (style.justifyContent === "space-between") {
          node.setJustifyContent(yoga_layout_prebuilt_1.default.JUSTIFY_SPACE_BETWEEN);
        }
        if (style.justifyContent === "space-around") {
          node.setJustifyContent(yoga_layout_prebuilt_1.default.JUSTIFY_SPACE_AROUND);
        }
      }
    };
    var applyDimensionStyles = (node, style) => {
      var _a2, _b;
      if ("width" in style) {
        if (typeof style.width === "number") {
          node.setWidth(style.width);
        } else if (typeof style.width === "string") {
          node.setWidthPercent(Number.parseInt(style.width, 10));
        } else {
          node.setWidthAuto();
        }
      }
      if ("height" in style) {
        if (typeof style.height === "number") {
          node.setHeight(style.height);
        } else if (typeof style.height === "string") {
          node.setHeightPercent(Number.parseInt(style.height, 10));
        } else {
          node.setHeightAuto();
        }
      }
      if ("minWidth" in style) {
        if (typeof style.minWidth === "string") {
          node.setMinWidthPercent(Number.parseInt(style.minWidth, 10));
        } else {
          node.setMinWidth((_a2 = style.minWidth) !== null && _a2 !== void 0 ? _a2 : 0);
        }
      }
      if ("minHeight" in style) {
        if (typeof style.minHeight === "string") {
          node.setMinHeightPercent(Number.parseInt(style.minHeight, 10));
        } else {
          node.setMinHeight((_b = style.minHeight) !== null && _b !== void 0 ? _b : 0);
        }
      }
    };
    var applyDisplayStyles = (node, style) => {
      if ("display" in style) {
        node.setDisplay(style.display === "flex" ? yoga_layout_prebuilt_1.default.DISPLAY_FLEX : yoga_layout_prebuilt_1.default.DISPLAY_NONE);
      }
    };
    var applyBorderStyles = (node, style) => {
      if ("borderStyle" in style) {
        const borderWidth = typeof style.borderStyle === "string" ? 1 : 0;
        node.setBorder(yoga_layout_prebuilt_1.default.EDGE_TOP, borderWidth);
        node.setBorder(yoga_layout_prebuilt_1.default.EDGE_BOTTOM, borderWidth);
        node.setBorder(yoga_layout_prebuilt_1.default.EDGE_LEFT, borderWidth);
        node.setBorder(yoga_layout_prebuilt_1.default.EDGE_RIGHT, borderWidth);
      }
    };
    exports2.default = (node, style = {}) => {
      applyPositionStyles(node, style);
      applyMarginStyles(node, style);
      applyPaddingStyles(node, style);
      applyFlexStyles(node, style);
      applyDimensionStyles(node, style);
      applyDisplayStyles(node, style);
      applyBorderStyles(node, style);
    };
  }
});

// node_modules/color-name/index.js
var require_color_name = __commonJS({
  "node_modules/color-name/index.js"(exports2, module2) {
    "use strict";
    module2.exports = {
      "aliceblue": [240, 248, 255],
      "antiquewhite": [250, 235, 215],
      "aqua": [0, 255, 255],
      "aquamarine": [127, 255, 212],
      "azure": [240, 255, 255],
      "beige": [245, 245, 220],
      "bisque": [255, 228, 196],
      "black": [0, 0, 0],
      "blanchedalmond": [255, 235, 205],
      "blue": [0, 0, 255],
      "blueviolet": [138, 43, 226],
      "brown": [165, 42, 42],
      "burlywood": [222, 184, 135],
      "cadetblue": [95, 158, 160],
      "chartreuse": [127, 255, 0],
      "chocolate": [210, 105, 30],
      "coral": [255, 127, 80],
      "cornflowerblue": [100, 149, 237],
      "cornsilk": [255, 248, 220],
      "crimson": [220, 20, 60],
      "cyan": [0, 255, 255],
      "darkblue": [0, 0, 139],
      "darkcyan": [0, 139, 139],
      "darkgoldenrod": [184, 134, 11],
      "darkgray": [169, 169, 169],
      "darkgreen": [0, 100, 0],
      "darkgrey": [169, 169, 169],
      "darkkhaki": [189, 183, 107],
      "darkmagenta": [139, 0, 139],
      "darkolivegreen": [85, 107, 47],
      "darkorange": [255, 140, 0],
      "darkorchid": [153, 50, 204],
      "darkred": [139, 0, 0],
      "darksalmon": [233, 150, 122],
      "darkseagreen": [143, 188, 143],
      "darkslateblue": [72, 61, 139],
      "darkslategray": [47, 79, 79],
      "darkslategrey": [47, 79, 79],
      "darkturquoise": [0, 206, 209],
      "darkviolet": [148, 0, 211],
      "deeppink": [255, 20, 147],
      "deepskyblue": [0, 191, 255],
      "dimgray": [105, 105, 105],
      "dimgrey": [105, 105, 105],
      "dodgerblue": [30, 144, 255],
      "firebrick": [178, 34, 34],
      "floralwhite": [255, 250, 240],
      "forestgreen": [34, 139, 34],
      "fuchsia": [255, 0, 255],
      "gainsboro": [220, 220, 220],
      "ghostwhite": [248, 248, 255],
      "gold": [255, 215, 0],
      "goldenrod": [218, 165, 32],
      "gray": [128, 128, 128],
      "green": [0, 128, 0],
      "greenyellow": [173, 255, 47],
      "grey": [128, 128, 128],
      "honeydew": [240, 255, 240],
      "hotpink": [255, 105, 180],
      "indianred": [205, 92, 92],
      "indigo": [75, 0, 130],
      "ivory": [255, 255, 240],
      "khaki": [240, 230, 140],
      "lavender": [230, 230, 250],
      "lavenderblush": [255, 240, 245],
      "lawngreen": [124, 252, 0],
      "lemonchiffon": [255, 250, 205],
      "lightblue": [173, 216, 230],
      "lightcoral": [240, 128, 128],
      "lightcyan": [224, 255, 255],
      "lightgoldenrodyellow": [250, 250, 210],
      "lightgray": [211, 211, 211],
      "lightgreen": [144, 238, 144],
      "lightgrey": [211, 211, 211],
      "lightpink": [255, 182, 193],
      "lightsalmon": [255, 160, 122],
      "lightseagreen": [32, 178, 170],
      "lightskyblue": [135, 206, 250],
      "lightslategray": [119, 136, 153],
      "lightslategrey": [119, 136, 153],
      "lightsteelblue": [176, 196, 222],
      "lightyellow": [255, 255, 224],
      "lime": [0, 255, 0],
      "limegreen": [50, 205, 50],
      "linen": [250, 240, 230],
      "magenta": [255, 0, 255],
      "maroon": [128, 0, 0],
      "mediumaquamarine": [102, 205, 170],
      "mediumblue": [0, 0, 205],
      "mediumorchid": [186, 85, 211],
      "mediumpurple": [147, 112, 219],
      "mediumseagreen": [60, 179, 113],
      "mediumslateblue": [123, 104, 238],
      "mediumspringgreen": [0, 250, 154],
      "mediumturquoise": [72, 209, 204],
      "mediumvioletred": [199, 21, 133],
      "midnightblue": [25, 25, 112],
      "mintcream": [245, 255, 250],
      "mistyrose": [255, 228, 225],
      "moccasin": [255, 228, 181],
      "navajowhite": [255, 222, 173],
      "navy": [0, 0, 128],
      "oldlace": [253, 245, 230],
      "olive": [128, 128, 0],
      "olivedrab": [107, 142, 35],
      "orange": [255, 165, 0],
      "orangered": [255, 69, 0],
      "orchid": [218, 112, 214],
      "palegoldenrod": [238, 232, 170],
      "palegreen": [152, 251, 152],
      "paleturquoise": [175, 238, 238],
      "palevioletred": [219, 112, 147],
      "papayawhip": [255, 239, 213],
      "peachpuff": [255, 218, 185],
      "peru": [205, 133, 63],
      "pink": [255, 192, 203],
      "plum": [221, 160, 221],
      "powderblue": [176, 224, 230],
      "purple": [128, 0, 128],
      "rebeccapurple": [102, 51, 153],
      "red": [255, 0, 0],
      "rosybrown": [188, 143, 143],
      "royalblue": [65, 105, 225],
      "saddlebrown": [139, 69, 19],
      "salmon": [250, 128, 114],
      "sandybrown": [244, 164, 96],
      "seagreen": [46, 139, 87],
      "seashell": [255, 245, 238],
      "sienna": [160, 82, 45],
      "silver": [192, 192, 192],
      "skyblue": [135, 206, 235],
      "slateblue": [106, 90, 205],
      "slategray": [112, 128, 144],
      "slategrey": [112, 128, 144],
      "snow": [255, 250, 250],
      "springgreen": [0, 255, 127],
      "steelblue": [70, 130, 180],
      "tan": [210, 180, 140],
      "teal": [0, 128, 128],
      "thistle": [216, 191, 216],
      "tomato": [255, 99, 71],
      "turquoise": [64, 224, 208],
      "violet": [238, 130, 238],
      "wheat": [245, 222, 179],
      "white": [255, 255, 255],
      "whitesmoke": [245, 245, 245],
      "yellow": [255, 255, 0],
      "yellowgreen": [154, 205, 50]
    };
  }
});

// node_modules/color-convert/conversions.js
var require_conversions = __commonJS({
  "node_modules/color-convert/conversions.js"(exports2, module2) {
    var cssKeywords = require_color_name();
    var reverseKeywords = {};
    for (const key2 of Object.keys(cssKeywords)) {
      reverseKeywords[cssKeywords[key2]] = key2;
    }
    var convert = {
      rgb: { channels: 3, labels: "rgb" },
      hsl: { channels: 3, labels: "hsl" },
      hsv: { channels: 3, labels: "hsv" },
      hwb: { channels: 3, labels: "hwb" },
      cmyk: { channels: 4, labels: "cmyk" },
      xyz: { channels: 3, labels: "xyz" },
      lab: { channels: 3, labels: "lab" },
      lch: { channels: 3, labels: "lch" },
      hex: { channels: 1, labels: ["hex"] },
      keyword: { channels: 1, labels: ["keyword"] },
      ansi16: { channels: 1, labels: ["ansi16"] },
      ansi256: { channels: 1, labels: ["ansi256"] },
      hcg: { channels: 3, labels: ["h", "c", "g"] },
      apple: { channels: 3, labels: ["r16", "g16", "b16"] },
      gray: { channels: 1, labels: ["gray"] }
    };
    module2.exports = convert;
    for (const model of Object.keys(convert)) {
      if (!("channels" in convert[model])) {
        throw new Error("missing channels property: " + model);
      }
      if (!("labels" in convert[model])) {
        throw new Error("missing channel labels property: " + model);
      }
      if (convert[model].labels.length !== convert[model].channels) {
        throw new Error("channel and label counts mismatch: " + model);
      }
      const { channels, labels } = convert[model];
      delete convert[model].channels;
      delete convert[model].labels;
      Object.defineProperty(convert[model], "channels", { value: channels });
      Object.defineProperty(convert[model], "labels", { value: labels });
    }
    convert.rgb.hsl = function(rgb) {
      const r2 = rgb[0] / 255;
      const g2 = rgb[1] / 255;
      const b2 = rgb[2] / 255;
      const min = Math.min(r2, g2, b2);
      const max = Math.max(r2, g2, b2);
      const delta = max - min;
      let h;
      let s2;
      if (max === min) {
        h = 0;
      } else if (r2 === max) {
        h = (g2 - b2) / delta;
      } else if (g2 === max) {
        h = 2 + (b2 - r2) / delta;
      } else if (b2 === max) {
        h = 4 + (r2 - g2) / delta;
      }
      h = Math.min(h * 60, 360);
      if (h < 0) {
        h += 360;
      }
      const l2 = (min + max) / 2;
      if (max === min) {
        s2 = 0;
      } else if (l2 <= 0.5) {
        s2 = delta / (max + min);
      } else {
        s2 = delta / (2 - max - min);
      }
      return [h, s2 * 100, l2 * 100];
    };
    convert.rgb.hsv = function(rgb) {
      let rdif;
      let gdif;
      let bdif;
      let h;
      let s2;
      const r2 = rgb[0] / 255;
      const g2 = rgb[1] / 255;
      const b2 = rgb[2] / 255;
      const v = Math.max(r2, g2, b2);
      const diff2 = v - Math.min(r2, g2, b2);
      const diffc = function(c2) {
        return (v - c2) / 6 / diff2 + 1 / 2;
      };
      if (diff2 === 0) {
        h = 0;
        s2 = 0;
      } else {
        s2 = diff2 / v;
        rdif = diffc(r2);
        gdif = diffc(g2);
        bdif = diffc(b2);
        if (r2 === v) {
          h = bdif - gdif;
        } else if (g2 === v) {
          h = 1 / 3 + rdif - bdif;
        } else if (b2 === v) {
          h = 2 / 3 + gdif - rdif;
        }
        if (h < 0) {
          h += 1;
        } else if (h > 1) {
          h -= 1;
        }
      }
      return [
        h * 360,
        s2 * 100,
        v * 100
      ];
    };
    convert.rgb.hwb = function(rgb) {
      const r2 = rgb[0];
      const g2 = rgb[1];
      let b2 = rgb[2];
      const h = convert.rgb.hsl(rgb)[0];
      const w = 1 / 255 * Math.min(r2, Math.min(g2, b2));
      b2 = 1 - 1 / 255 * Math.max(r2, Math.max(g2, b2));
      return [h, w * 100, b2 * 100];
    };
    convert.rgb.cmyk = function(rgb) {
      const r2 = rgb[0] / 255;
      const g2 = rgb[1] / 255;
      const b2 = rgb[2] / 255;
      const k = Math.min(1 - r2, 1 - g2, 1 - b2);
      const c2 = (1 - r2 - k) / (1 - k) || 0;
      const m = (1 - g2 - k) / (1 - k) || 0;
      const y2 = (1 - b2 - k) / (1 - k) || 0;
      return [c2 * 100, m * 100, y2 * 100, k * 100];
    };
    function comparativeDistance(x, y2) {
      return (x[0] - y2[0]) ** 2 + (x[1] - y2[1]) ** 2 + (x[2] - y2[2]) ** 2;
    }
    convert.rgb.keyword = function(rgb) {
      const reversed = reverseKeywords[rgb];
      if (reversed) {
        return reversed;
      }
      let currentClosestDistance = Infinity;
      let currentClosestKeyword;
      for (const keyword of Object.keys(cssKeywords)) {
        const value = cssKeywords[keyword];
        const distance = comparativeDistance(rgb, value);
        if (distance < currentClosestDistance) {
          currentClosestDistance = distance;
          currentClosestKeyword = keyword;
        }
      }
      return currentClosestKeyword;
    };
    convert.keyword.rgb = function(keyword) {
      return cssKeywords[keyword];
    };
    convert.rgb.xyz = function(rgb) {
      let r2 = rgb[0] / 255;
      let g2 = rgb[1] / 255;
      let b2 = rgb[2] / 255;
      r2 = r2 > 0.04045 ? ((r2 + 0.055) / 1.055) ** 2.4 : r2 / 12.92;
      g2 = g2 > 0.04045 ? ((g2 + 0.055) / 1.055) ** 2.4 : g2 / 12.92;
      b2 = b2 > 0.04045 ? ((b2 + 0.055) / 1.055) ** 2.4 : b2 / 12.92;
      const x = r2 * 0.4124 + g2 * 0.3576 + b2 * 0.1805;
      const y2 = r2 * 0.2126 + g2 * 0.7152 + b2 * 0.0722;
      const z = r2 * 0.0193 + g2 * 0.1192 + b2 * 0.9505;
      return [x * 100, y2 * 100, z * 100];
    };
    convert.rgb.lab = function(rgb) {
      const xyz = convert.rgb.xyz(rgb);
      let x = xyz[0];
      let y2 = xyz[1];
      let z = xyz[2];
      x /= 95.047;
      y2 /= 100;
      z /= 108.883;
      x = x > 8856e-6 ? x ** (1 / 3) : 7.787 * x + 16 / 116;
      y2 = y2 > 8856e-6 ? y2 ** (1 / 3) : 7.787 * y2 + 16 / 116;
      z = z > 8856e-6 ? z ** (1 / 3) : 7.787 * z + 16 / 116;
      const l2 = 116 * y2 - 16;
      const a2 = 500 * (x - y2);
      const b2 = 200 * (y2 - z);
      return [l2, a2, b2];
    };
    convert.hsl.rgb = function(hsl) {
      const h = hsl[0] / 360;
      const s2 = hsl[1] / 100;
      const l2 = hsl[2] / 100;
      let t2;
      let t3;
      let val;
      if (s2 === 0) {
        val = l2 * 255;
        return [val, val, val];
      }
      if (l2 < 0.5) {
        t2 = l2 * (1 + s2);
      } else {
        t2 = l2 + s2 - l2 * s2;
      }
      const t1 = 2 * l2 - t2;
      const rgb = [0, 0, 0];
      for (let i3 = 0; i3 < 3; i3++) {
        t3 = h + 1 / 3 * -(i3 - 1);
        if (t3 < 0) {
          t3++;
        }
        if (t3 > 1) {
          t3--;
        }
        if (6 * t3 < 1) {
          val = t1 + (t2 - t1) * 6 * t3;
        } else if (2 * t3 < 1) {
          val = t2;
        } else if (3 * t3 < 2) {
          val = t1 + (t2 - t1) * (2 / 3 - t3) * 6;
        } else {
          val = t1;
        }
        rgb[i3] = val * 255;
      }
      return rgb;
    };
    convert.hsl.hsv = function(hsl) {
      const h = hsl[0];
      let s2 = hsl[1] / 100;
      let l2 = hsl[2] / 100;
      let smin = s2;
      const lmin = Math.max(l2, 0.01);
      l2 *= 2;
      s2 *= l2 <= 1 ? l2 : 2 - l2;
      smin *= lmin <= 1 ? lmin : 2 - lmin;
      const v = (l2 + s2) / 2;
      const sv = l2 === 0 ? 2 * smin / (lmin + smin) : 2 * s2 / (l2 + s2);
      return [h, sv * 100, v * 100];
    };
    convert.hsv.rgb = function(hsv) {
      const h = hsv[0] / 60;
      const s2 = hsv[1] / 100;
      let v = hsv[2] / 100;
      const hi = Math.floor(h) % 6;
      const f = h - Math.floor(h);
      const p = 255 * v * (1 - s2);
      const q = 255 * v * (1 - s2 * f);
      const t2 = 255 * v * (1 - s2 * (1 - f));
      v *= 255;
      switch (hi) {
        case 0:
          return [v, t2, p];
        case 1:
          return [q, v, p];
        case 2:
          return [p, v, t2];
        case 3:
          return [p, q, v];
        case 4:
          return [t2, p, v];
        case 5:
          return [v, p, q];
      }
    };
    convert.hsv.hsl = function(hsv) {
      const h = hsv[0];
      const s2 = hsv[1] / 100;
      const v = hsv[2] / 100;
      const vmin = Math.max(v, 0.01);
      let sl;
      let l2;
      l2 = (2 - s2) * v;
      const lmin = (2 - s2) * vmin;
      sl = s2 * vmin;
      sl /= lmin <= 1 ? lmin : 2 - lmin;
      sl = sl || 0;
      l2 /= 2;
      return [h, sl * 100, l2 * 100];
    };
    convert.hwb.rgb = function(hwb) {
      const h = hwb[0] / 360;
      let wh = hwb[1] / 100;
      let bl = hwb[2] / 100;
      const ratio = wh + bl;
      let f;
      if (ratio > 1) {
        wh /= ratio;
        bl /= ratio;
      }
      const i3 = Math.floor(6 * h);
      const v = 1 - bl;
      f = 6 * h - i3;
      if ((i3 & 1) !== 0) {
        f = 1 - f;
      }
      const n2 = wh + f * (v - wh);
      let r2;
      let g2;
      let b2;
      switch (i3) {
        default:
        case 6:
        case 0:
          r2 = v;
          g2 = n2;
          b2 = wh;
          break;
        case 1:
          r2 = n2;
          g2 = v;
          b2 = wh;
          break;
        case 2:
          r2 = wh;
          g2 = v;
          b2 = n2;
          break;
        case 3:
          r2 = wh;
          g2 = n2;
          b2 = v;
          break;
        case 4:
          r2 = n2;
          g2 = wh;
          b2 = v;
          break;
        case 5:
          r2 = v;
          g2 = wh;
          b2 = n2;
          break;
      }
      return [r2 * 255, g2 * 255, b2 * 255];
    };
    convert.cmyk.rgb = function(cmyk) {
      const c2 = cmyk[0] / 100;
      const m = cmyk[1] / 100;
      const y2 = cmyk[2] / 100;
      const k = cmyk[3] / 100;
      const r2 = 1 - Math.min(1, c2 * (1 - k) + k);
      const g2 = 1 - Math.min(1, m * (1 - k) + k);
      const b2 = 1 - Math.min(1, y2 * (1 - k) + k);
      return [r2 * 255, g2 * 255, b2 * 255];
    };
    convert.xyz.rgb = function(xyz) {
      const x = xyz[0] / 100;
      const y2 = xyz[1] / 100;
      const z = xyz[2] / 100;
      let r2;
      let g2;
      let b2;
      r2 = x * 3.2406 + y2 * -1.5372 + z * -0.4986;
      g2 = x * -0.9689 + y2 * 1.8758 + z * 0.0415;
      b2 = x * 0.0557 + y2 * -0.204 + z * 1.057;
      r2 = r2 > 31308e-7 ? 1.055 * r2 ** (1 / 2.4) - 0.055 : r2 * 12.92;
      g2 = g2 > 31308e-7 ? 1.055 * g2 ** (1 / 2.4) - 0.055 : g2 * 12.92;
      b2 = b2 > 31308e-7 ? 1.055 * b2 ** (1 / 2.4) - 0.055 : b2 * 12.92;
      r2 = Math.min(Math.max(0, r2), 1);
      g2 = Math.min(Math.max(0, g2), 1);
      b2 = Math.min(Math.max(0, b2), 1);
      return [r2 * 255, g2 * 255, b2 * 255];
    };
    convert.xyz.lab = function(xyz) {
      let x = xyz[0];
      let y2 = xyz[1];
      let z = xyz[2];
      x /= 95.047;
      y2 /= 100;
      z /= 108.883;
      x = x > 8856e-6 ? x ** (1 / 3) : 7.787 * x + 16 / 116;
      y2 = y2 > 8856e-6 ? y2 ** (1 / 3) : 7.787 * y2 + 16 / 116;
      z = z > 8856e-6 ? z ** (1 / 3) : 7.787 * z + 16 / 116;
      const l2 = 116 * y2 - 16;
      const a2 = 500 * (x - y2);
      const b2 = 200 * (y2 - z);
      return [l2, a2, b2];
    };
    convert.lab.xyz = function(lab) {
      const l2 = lab[0];
      const a2 = lab[1];
      const b2 = lab[2];
      let x;
      let y2;
      let z;
      y2 = (l2 + 16) / 116;
      x = a2 / 500 + y2;
      z = y2 - b2 / 200;
      const y22 = y2 ** 3;
      const x2 = x ** 3;
      const z2 = z ** 3;
      y2 = y22 > 8856e-6 ? y22 : (y2 - 16 / 116) / 7.787;
      x = x2 > 8856e-6 ? x2 : (x - 16 / 116) / 7.787;
      z = z2 > 8856e-6 ? z2 : (z - 16 / 116) / 7.787;
      x *= 95.047;
      y2 *= 100;
      z *= 108.883;
      return [x, y2, z];
    };
    convert.lab.lch = function(lab) {
      const l2 = lab[0];
      const a2 = lab[1];
      const b2 = lab[2];
      let h;
      const hr = Math.atan2(b2, a2);
      h = hr * 360 / 2 / Math.PI;
      if (h < 0) {
        h += 360;
      }
      const c2 = Math.sqrt(a2 * a2 + b2 * b2);
      return [l2, c2, h];
    };
    convert.lch.lab = function(lch) {
      const l2 = lch[0];
      const c2 = lch[1];
      const h = lch[2];
      const hr = h / 360 * 2 * Math.PI;
      const a2 = c2 * Math.cos(hr);
      const b2 = c2 * Math.sin(hr);
      return [l2, a2, b2];
    };
    convert.rgb.ansi16 = function(args, saturation = null) {
      const [r2, g2, b2] = args;
      let value = saturation === null ? convert.rgb.hsv(args)[2] : saturation;
      value = Math.round(value / 50);
      if (value === 0) {
        return 30;
      }
      let ansi = 30 + (Math.round(b2 / 255) << 2 | Math.round(g2 / 255) << 1 | Math.round(r2 / 255));
      if (value === 2) {
        ansi += 60;
      }
      return ansi;
    };
    convert.hsv.ansi16 = function(args) {
      return convert.rgb.ansi16(convert.hsv.rgb(args), args[2]);
    };
    convert.rgb.ansi256 = function(args) {
      const r2 = args[0];
      const g2 = args[1];
      const b2 = args[2];
      if (r2 === g2 && g2 === b2) {
        if (r2 < 8) {
          return 16;
        }
        if (r2 > 248) {
          return 231;
        }
        return Math.round((r2 - 8) / 247 * 24) + 232;
      }
      const ansi = 16 + 36 * Math.round(r2 / 255 * 5) + 6 * Math.round(g2 / 255 * 5) + Math.round(b2 / 255 * 5);
      return ansi;
    };
    convert.ansi16.rgb = function(args) {
      let color = args % 10;
      if (color === 0 || color === 7) {
        if (args > 50) {
          color += 3.5;
        }
        color = color / 10.5 * 255;
        return [color, color, color];
      }
      const mult = (~~(args > 50) + 1) * 0.5;
      const r2 = (color & 1) * mult * 255;
      const g2 = (color >> 1 & 1) * mult * 255;
      const b2 = (color >> 2 & 1) * mult * 255;
      return [r2, g2, b2];
    };
    convert.ansi256.rgb = function(args) {
      if (args >= 232) {
        const c2 = (args - 232) * 10 + 8;
        return [c2, c2, c2];
      }
      args -= 16;
      let rem;
      const r2 = Math.floor(args / 36) / 5 * 255;
      const g2 = Math.floor((rem = args % 36) / 6) / 5 * 255;
      const b2 = rem % 6 / 5 * 255;
      return [r2, g2, b2];
    };
    convert.rgb.hex = function(args) {
      const integer = ((Math.round(args[0]) & 255) << 16) + ((Math.round(args[1]) & 255) << 8) + (Math.round(args[2]) & 255);
      const string = integer.toString(16).toUpperCase();
      return "000000".substring(string.length) + string;
    };
    convert.hex.rgb = function(args) {
      const match = args.toString(16).match(/[a-f0-9]{6}|[a-f0-9]{3}/i);
      if (!match) {
        return [0, 0, 0];
      }
      let colorString = match[0];
      if (match[0].length === 3) {
        colorString = colorString.split("").map((char) => {
          return char + char;
        }).join("");
      }
      const integer = parseInt(colorString, 16);
      const r2 = integer >> 16 & 255;
      const g2 = integer >> 8 & 255;
      const b2 = integer & 255;
      return [r2, g2, b2];
    };
    convert.rgb.hcg = function(rgb) {
      const r2 = rgb[0] / 255;
      const g2 = rgb[1] / 255;
      const b2 = rgb[2] / 255;
      const max = Math.max(Math.max(r2, g2), b2);
      const min = Math.min(Math.min(r2, g2), b2);
      const chroma = max - min;
      let grayscale;
      let hue;
      if (chroma < 1) {
        grayscale = min / (1 - chroma);
      } else {
        grayscale = 0;
      }
      if (chroma <= 0) {
        hue = 0;
      } else if (max === r2) {
        hue = (g2 - b2) / chroma % 6;
      } else if (max === g2) {
        hue = 2 + (b2 - r2) / chroma;
      } else {
        hue = 4 + (r2 - g2) / chroma;
      }
      hue /= 6;
      hue %= 1;
      return [hue * 360, chroma * 100, grayscale * 100];
    };
    convert.hsl.hcg = function(hsl) {
      const s2 = hsl[1] / 100;
      const l2 = hsl[2] / 100;
      const c2 = l2 < 0.5 ? 2 * s2 * l2 : 2 * s2 * (1 - l2);
      let f = 0;
      if (c2 < 1) {
        f = (l2 - 0.5 * c2) / (1 - c2);
      }
      return [hsl[0], c2 * 100, f * 100];
    };
    convert.hsv.hcg = function(hsv) {
      const s2 = hsv[1] / 100;
      const v = hsv[2] / 100;
      const c2 = s2 * v;
      let f = 0;
      if (c2 < 1) {
        f = (v - c2) / (1 - c2);
      }
      return [hsv[0], c2 * 100, f * 100];
    };
    convert.hcg.rgb = function(hcg) {
      const h = hcg[0] / 360;
      const c2 = hcg[1] / 100;
      const g2 = hcg[2] / 100;
      if (c2 === 0) {
        return [g2 * 255, g2 * 255, g2 * 255];
      }
      const pure = [0, 0, 0];
      const hi = h % 1 * 6;
      const v = hi % 1;
      const w = 1 - v;
      let mg = 0;
      switch (Math.floor(hi)) {
        case 0:
          pure[0] = 1;
          pure[1] = v;
          pure[2] = 0;
          break;
        case 1:
          pure[0] = w;
          pure[1] = 1;
          pure[2] = 0;
          break;
        case 2:
          pure[0] = 0;
          pure[1] = 1;
          pure[2] = v;
          break;
        case 3:
          pure[0] = 0;
          pure[1] = w;
          pure[2] = 1;
          break;
        case 4:
          pure[0] = v;
          pure[1] = 0;
          pure[2] = 1;
          break;
        default:
          pure[0] = 1;
          pure[1] = 0;
          pure[2] = w;
      }
      mg = (1 - c2) * g2;
      return [
        (c2 * pure[0] + mg) * 255,
        (c2 * pure[1] + mg) * 255,
        (c2 * pure[2] + mg) * 255
      ];
    };
    convert.hcg.hsv = function(hcg) {
      const c2 = hcg[1] / 100;
      const g2 = hcg[2] / 100;
      const v = c2 + g2 * (1 - c2);
      let f = 0;
      if (v > 0) {
        f = c2 / v;
      }
      return [hcg[0], f * 100, v * 100];
    };
    convert.hcg.hsl = function(hcg) {
      const c2 = hcg[1] / 100;
      const g2 = hcg[2] / 100;
      const l2 = g2 * (1 - c2) + 0.5 * c2;
      let s2 = 0;
      if (l2 > 0 && l2 < 0.5) {
        s2 = c2 / (2 * l2);
      } else if (l2 >= 0.5 && l2 < 1) {
        s2 = c2 / (2 * (1 - l2));
      }
      return [hcg[0], s2 * 100, l2 * 100];
    };
    convert.hcg.hwb = function(hcg) {
      const c2 = hcg[1] / 100;
      const g2 = hcg[2] / 100;
      const v = c2 + g2 * (1 - c2);
      return [hcg[0], (v - c2) * 100, (1 - v) * 100];
    };
    convert.hwb.hcg = function(hwb) {
      const w = hwb[1] / 100;
      const b2 = hwb[2] / 100;
      const v = 1 - b2;
      const c2 = v - w;
      let g2 = 0;
      if (c2 < 1) {
        g2 = (v - c2) / (1 - c2);
      }
      return [hwb[0], c2 * 100, g2 * 100];
    };
    convert.apple.rgb = function(apple) {
      return [apple[0] / 65535 * 255, apple[1] / 65535 * 255, apple[2] / 65535 * 255];
    };
    convert.rgb.apple = function(rgb) {
      return [rgb[0] / 255 * 65535, rgb[1] / 255 * 65535, rgb[2] / 255 * 65535];
    };
    convert.gray.rgb = function(args) {
      return [args[0] / 100 * 255, args[0] / 100 * 255, args[0] / 100 * 255];
    };
    convert.gray.hsl = function(args) {
      return [0, 0, args[0]];
    };
    convert.gray.hsv = convert.gray.hsl;
    convert.gray.hwb = function(gray) {
      return [0, 100, gray[0]];
    };
    convert.gray.cmyk = function(gray) {
      return [0, 0, 0, gray[0]];
    };
    convert.gray.lab = function(gray) {
      return [gray[0], 0, 0];
    };
    convert.gray.hex = function(gray) {
      const val = Math.round(gray[0] / 100 * 255) & 255;
      const integer = (val << 16) + (val << 8) + val;
      const string = integer.toString(16).toUpperCase();
      return "000000".substring(string.length) + string;
    };
    convert.rgb.gray = function(rgb) {
      const val = (rgb[0] + rgb[1] + rgb[2]) / 3;
      return [val / 255 * 100];
    };
  }
});

// node_modules/color-convert/route.js
var require_route = __commonJS({
  "node_modules/color-convert/route.js"(exports2, module2) {
    var conversions = require_conversions();
    function buildGraph() {
      const graph = {};
      const models = Object.keys(conversions);
      for (let len = models.length, i3 = 0; i3 < len; i3++) {
        graph[models[i3]] = {
          distance: -1,
          parent: null
        };
      }
      return graph;
    }
    function deriveBFS(fromModel) {
      const graph = buildGraph();
      const queue = [fromModel];
      graph[fromModel].distance = 0;
      while (queue.length) {
        const current = queue.pop();
        const adjacents = Object.keys(conversions[current]);
        for (let len = adjacents.length, i3 = 0; i3 < len; i3++) {
          const adjacent = adjacents[i3];
          const node = graph[adjacent];
          if (node.distance === -1) {
            node.distance = graph[current].distance + 1;
            node.parent = current;
            queue.unshift(adjacent);
          }
        }
      }
      return graph;
    }
    function link(from, to) {
      return function(args) {
        return to(from(args));
      };
    }
    function wrapConversion(toModel, graph) {
      const path2 = [graph[toModel].parent, toModel];
      let fn = conversions[graph[toModel].parent][toModel];
      let cur = graph[toModel].parent;
      while (graph[cur].parent) {
        path2.unshift(graph[cur].parent);
        fn = link(conversions[graph[cur].parent][cur], fn);
        cur = graph[cur].parent;
      }
      fn.conversion = path2;
      return fn;
    }
    module2.exports = function(fromModel) {
      const graph = deriveBFS(fromModel);
      const conversion = {};
      const models = Object.keys(graph);
      for (let len = models.length, i3 = 0; i3 < len; i3++) {
        const toModel = models[i3];
        const node = graph[toModel];
        if (node.parent === null) {
          continue;
        }
        conversion[toModel] = wrapConversion(toModel, graph);
      }
      return conversion;
    };
  }
});

// node_modules/color-convert/index.js
var require_color_convert = __commonJS({
  "node_modules/color-convert/index.js"(exports2, module2) {
    var conversions = require_conversions();
    var route = require_route();
    var convert = {};
    var models = Object.keys(conversions);
    function wrapRaw(fn) {
      const wrappedFn = function(...args) {
        const arg0 = args[0];
        if (arg0 === void 0 || arg0 === null) {
          return arg0;
        }
        if (arg0.length > 1) {
          args = arg0;
        }
        return fn(args);
      };
      if ("conversion" in fn) {
        wrappedFn.conversion = fn.conversion;
      }
      return wrappedFn;
    }
    function wrapRounded(fn) {
      const wrappedFn = function(...args) {
        const arg0 = args[0];
        if (arg0 === void 0 || arg0 === null) {
          return arg0;
        }
        if (arg0.length > 1) {
          args = arg0;
        }
        const result2 = fn(args);
        if (typeof result2 === "object") {
          for (let len = result2.length, i3 = 0; i3 < len; i3++) {
            result2[i3] = Math.round(result2[i3]);
          }
        }
        return result2;
      };
      if ("conversion" in fn) {
        wrappedFn.conversion = fn.conversion;
      }
      return wrappedFn;
    }
    models.forEach((fromModel) => {
      convert[fromModel] = {};
      Object.defineProperty(convert[fromModel], "channels", { value: conversions[fromModel].channels });
      Object.defineProperty(convert[fromModel], "labels", { value: conversions[fromModel].labels });
      const routes = route(fromModel);
      const routeModels = Object.keys(routes);
      routeModels.forEach((toModel) => {
        const fn = routes[toModel];
        convert[fromModel][toModel] = wrapRounded(fn);
        convert[fromModel][toModel].raw = wrapRaw(fn);
      });
    });
    module2.exports = convert;
  }
});

// node_modules/ansi-styles/index.js
var require_ansi_styles = __commonJS({
  "node_modules/ansi-styles/index.js"(exports2, module2) {
    "use strict";
    var wrapAnsi16 = (fn, offset) => (...args) => {
      const code = fn(...args);
      return `[${code + offset}m`;
    };
    var wrapAnsi256 = (fn, offset) => (...args) => {
      const code = fn(...args);
      return `[${38 + offset};5;${code}m`;
    };
    var wrapAnsi16m = (fn, offset) => (...args) => {
      const rgb = fn(...args);
      return `[${38 + offset};2;${rgb[0]};${rgb[1]};${rgb[2]}m`;
    };
    var ansi2ansi = (n2) => n2;
    var rgb2rgb = (r2, g2, b2) => [r2, g2, b2];
    var setLazyProperty = (object, property, get) => {
      Object.defineProperty(object, property, {
        get: () => {
          const value = get();
          Object.defineProperty(object, property, {
            value,
            enumerable: true,
            configurable: true
          });
          return value;
        },
        enumerable: true,
        configurable: true
      });
    };
    var colorConvert;
    var makeDynamicStyles = (wrap, targetSpace, identity, isBackground) => {
      if (colorConvert === void 0) {
        colorConvert = require_color_convert();
      }
      const offset = isBackground ? 10 : 0;
      const styles = {};
      for (const [sourceSpace, suite] of Object.entries(colorConvert)) {
        const name = sourceSpace === "ansi16" ? "ansi" : sourceSpace;
        if (sourceSpace === targetSpace) {
          styles[name] = wrap(identity, offset);
        } else if (typeof suite === "object") {
          styles[name] = wrap(suite[targetSpace], offset);
        }
      }
      return styles;
    };
    function assembleStyles() {
      const codes = /* @__PURE__ */ new Map();
      const styles = {
        modifier: {
          reset: [0, 0],
          bold: [1, 22],
          dim: [2, 22],
          italic: [3, 23],
          underline: [4, 24],
          inverse: [7, 27],
          hidden: [8, 28],
          strikethrough: [9, 29]
        },
        color: {
          black: [30, 39],
          red: [31, 39],
          green: [32, 39],
          yellow: [33, 39],
          blue: [34, 39],
          magenta: [35, 39],
          cyan: [36, 39],
          white: [37, 39],
          blackBright: [90, 39],
          redBright: [91, 39],
          greenBright: [92, 39],
          yellowBright: [93, 39],
          blueBright: [94, 39],
          magentaBright: [95, 39],
          cyanBright: [96, 39],
          whiteBright: [97, 39]
        },
        bgColor: {
          bgBlack: [40, 49],
          bgRed: [41, 49],
          bgGreen: [42, 49],
          bgYellow: [43, 49],
          bgBlue: [44, 49],
          bgMagenta: [45, 49],
          bgCyan: [46, 49],
          bgWhite: [47, 49],
          bgBlackBright: [100, 49],
          bgRedBright: [101, 49],
          bgGreenBright: [102, 49],
          bgYellowBright: [103, 49],
          bgBlueBright: [104, 49],
          bgMagentaBright: [105, 49],
          bgCyanBright: [106, 49],
          bgWhiteBright: [107, 49]
        }
      };
      styles.color.gray = styles.color.blackBright;
      styles.bgColor.bgGray = styles.bgColor.bgBlackBright;
      styles.color.grey = styles.color.blackBright;
      styles.bgColor.bgGrey = styles.bgColor.bgBlackBright;
      for (const [groupName, group] of Object.entries(styles)) {
        for (const [styleName, style] of Object.entries(group)) {
          styles[styleName] = {
            open: `[${style[0]}m`,
            close: `[${style[1]}m`
          };
          group[styleName] = styles[styleName];
          codes.set(style[0], style[1]);
        }
        Object.defineProperty(styles, groupName, {
          value: group,
          enumerable: false
        });
      }
      Object.defineProperty(styles, "codes", {
        value: codes,
        enumerable: false
      });
      styles.color.close = "[39m";
      styles.bgColor.close = "[49m";
      setLazyProperty(styles.color, "ansi", () => makeDynamicStyles(wrapAnsi16, "ansi16", ansi2ansi, false));
      setLazyProperty(styles.color, "ansi256", () => makeDynamicStyles(wrapAnsi256, "ansi256", ansi2ansi, false));
      setLazyProperty(styles.color, "ansi16m", () => makeDynamicStyles(wrapAnsi16m, "rgb", rgb2rgb, false));
      setLazyProperty(styles.bgColor, "ansi", () => makeDynamicStyles(wrapAnsi16, "ansi16", ansi2ansi, true));
      setLazyProperty(styles.bgColor, "ansi256", () => makeDynamicStyles(wrapAnsi256, "ansi256", ansi2ansi, true));
      setLazyProperty(styles.bgColor, "ansi16m", () => makeDynamicStyles(wrapAnsi16m, "rgb", rgb2rgb, true));
      return styles;
    }
    Object.defineProperty(module2, "exports", {
      enumerable: true,
      get: assembleStyles
    });
  }
});

// node_modules/wrap-ansi/index.js
var require_wrap_ansi = __commonJS({
  "node_modules/wrap-ansi/index.js"(exports2, module2) {
    "use strict";
    var stringWidth = require_string_width();
    var stripAnsi = require_strip_ansi();
    var ansiStyles = require_ansi_styles();
    var ESCAPES = /* @__PURE__ */ new Set([
      "",
      "\x9B"
    ]);
    var END_CODE = 39;
    var wrapAnsi = (code) => `${ESCAPES.values().next().value}[${code}m`;
    var wordLengths = (string) => string.split(" ").map((character) => stringWidth(character));
    var wrapWord = (rows, word, columns) => {
      const characters = [...word];
      let isInsideEscape = false;
      let visible = stringWidth(stripAnsi(rows[rows.length - 1]));
      for (const [index, character] of characters.entries()) {
        const characterLength = stringWidth(character);
        if (visible + characterLength <= columns) {
          rows[rows.length - 1] += character;
        } else {
          rows.push(character);
          visible = 0;
        }
        if (ESCAPES.has(character)) {
          isInsideEscape = true;
        } else if (isInsideEscape && character === "m") {
          isInsideEscape = false;
          continue;
        }
        if (isInsideEscape) {
          continue;
        }
        visible += characterLength;
        if (visible === columns && index < characters.length - 1) {
          rows.push("");
          visible = 0;
        }
      }
      if (!visible && rows[rows.length - 1].length > 0 && rows.length > 1) {
        rows[rows.length - 2] += rows.pop();
      }
    };
    var stringVisibleTrimSpacesRight = (str2) => {
      const words = str2.split(" ");
      let last = words.length;
      while (last > 0) {
        if (stringWidth(words[last - 1]) > 0) {
          break;
        }
        last--;
      }
      if (last === words.length) {
        return str2;
      }
      return words.slice(0, last).join(" ") + words.slice(last).join("");
    };
    var exec = (string, columns, options = {}) => {
      if (options.trim !== false && string.trim() === "") {
        return "";
      }
      let pre = "";
      let ret = "";
      let escapeCode;
      const lengths = wordLengths(string);
      let rows = [""];
      for (const [index, word] of string.split(" ").entries()) {
        if (options.trim !== false) {
          rows[rows.length - 1] = rows[rows.length - 1].trimLeft();
        }
        let rowLength = stringWidth(rows[rows.length - 1]);
        if (index !== 0) {
          if (rowLength >= columns && (options.wordWrap === false || options.trim === false)) {
            rows.push("");
            rowLength = 0;
          }
          if (rowLength > 0 || options.trim === false) {
            rows[rows.length - 1] += " ";
            rowLength++;
          }
        }
        if (options.hard && lengths[index] > columns) {
          const remainingColumns = columns - rowLength;
          const breaksStartingThisLine = 1 + Math.floor((lengths[index] - remainingColumns - 1) / columns);
          const breaksStartingNextLine = Math.floor((lengths[index] - 1) / columns);
          if (breaksStartingNextLine < breaksStartingThisLine) {
            rows.push("");
          }
          wrapWord(rows, word, columns);
          continue;
        }
        if (rowLength + lengths[index] > columns && rowLength > 0 && lengths[index] > 0) {
          if (options.wordWrap === false && rowLength < columns) {
            wrapWord(rows, word, columns);
            continue;
          }
          rows.push("");
        }
        if (rowLength + lengths[index] > columns && options.wordWrap === false) {
          wrapWord(rows, word, columns);
          continue;
        }
        rows[rows.length - 1] += word;
      }
      if (options.trim !== false) {
        rows = rows.map(stringVisibleTrimSpacesRight);
      }
      pre = rows.join("\n");
      for (const [index, character] of [...pre].entries()) {
        ret += character;
        if (ESCAPES.has(character)) {
          const code2 = parseFloat(/\d[^m]*/.exec(pre.slice(index, index + 4)));
          escapeCode = code2 === END_CODE ? null : code2;
        }
        const code = ansiStyles.codes.get(Number(escapeCode));
        if (escapeCode && code) {
          if (pre[index + 1] === "\n") {
            ret += wrapAnsi(code);
          } else if (character === "\n") {
            ret += wrapAnsi(escapeCode);
          }
        }
      }
      return ret;
    };
    module2.exports = (string, columns, options) => {
      return String(string).normalize().replace(/\r\n/g, "\n").split("\n").map((line) => exec(line, columns, options)).join("\n");
    };
  }
});

// node_modules/astral-regex/index.js
var require_astral_regex = __commonJS({
  "node_modules/astral-regex/index.js"(exports2, module2) {
    "use strict";
    var regex = "[\uD800-\uDBFF][\uDC00-\uDFFF]";
    var astralRegex = (options) => options && options.exact ? new RegExp(`^${regex}$`) : new RegExp(regex, "g");
    module2.exports = astralRegex;
  }
});

// node_modules/slice-ansi/index.js
var require_slice_ansi = __commonJS({
  "node_modules/slice-ansi/index.js"(exports2, module2) {
    "use strict";
    var isFullwidthCodePoint = require_is_fullwidth_code_point();
    var astralRegex = require_astral_regex();
    var ansiStyles = require_ansi_styles();
    var ESCAPES = [
      "",
      "\x9B"
    ];
    var wrapAnsi = (code) => `${ESCAPES[0]}[${code}m`;
    var checkAnsi = (ansiCodes, isEscapes, endAnsiCode) => {
      let output = [];
      ansiCodes = [...ansiCodes];
      for (let ansiCode of ansiCodes) {
        const ansiCodeOrigin = ansiCode;
        if (ansiCode.match(";")) {
          ansiCode = ansiCode.split(";")[0][0] + "0";
        }
        const item = ansiStyles.codes.get(parseInt(ansiCode, 10));
        if (item) {
          const indexEscape = ansiCodes.indexOf(item.toString());
          if (indexEscape >= 0) {
            ansiCodes.splice(indexEscape, 1);
          } else {
            output.push(wrapAnsi(isEscapes ? item : ansiCodeOrigin));
          }
        } else if (isEscapes) {
          output.push(wrapAnsi(0));
          break;
        } else {
          output.push(wrapAnsi(ansiCodeOrigin));
        }
      }
      if (isEscapes) {
        output = output.filter((element, index) => output.indexOf(element) === index);
        if (endAnsiCode !== void 0) {
          const fistEscapeCode = wrapAnsi(ansiStyles.codes.get(parseInt(endAnsiCode, 10)));
          output = output.reduce((current, next) => next === fistEscapeCode ? [next, ...current] : [...current, next], []);
        }
      }
      return output.join("");
    };
    module2.exports = (string, begin, end) => {
      const characters = [...string.normalize()];
      const ansiCodes = [];
      end = typeof end === "number" ? end : characters.length;
      let isInsideEscape = false;
      let ansiCode;
      let visible = 0;
      let output = "";
      for (const [index, character] of characters.entries()) {
        let leftEscape = false;
        if (ESCAPES.includes(character)) {
          const code = /\d[^m]*/.exec(string.slice(index, index + 18));
          ansiCode = code && code.length > 0 ? code[0] : void 0;
          if (visible < end) {
            isInsideEscape = true;
            if (ansiCode !== void 0) {
              ansiCodes.push(ansiCode);
            }
          }
        } else if (isInsideEscape && character === "m") {
          isInsideEscape = false;
          leftEscape = true;
        }
        if (!isInsideEscape && !leftEscape) {
          ++visible;
        }
        if (!astralRegex({ exact: true }).test(character) && isFullwidthCodePoint(character.codePointAt())) {
          ++visible;
        }
        if (visible > begin && visible <= end) {
          output += character;
        } else if (visible === begin && !isInsideEscape && ansiCode !== void 0) {
          output = checkAnsi(ansiCodes);
        } else if (visible >= end) {
          output += checkAnsi(ansiCodes, true, ansiCode);
          break;
        }
      }
      return output;
    };
  }
});

// node_modules/cli-truncate/index.js
var require_cli_truncate = __commonJS({
  "node_modules/cli-truncate/index.js"(exports2, module2) {
    "use strict";
    var sliceAnsi = require_slice_ansi();
    var stringWidth = require_string_width();
    function getIndexOfNearestSpace(string, index, shouldSearchRight) {
      if (string.charAt(index) === " ") {
        return index;
      }
      for (let i3 = 1; i3 <= 3; i3++) {
        if (shouldSearchRight) {
          if (string.charAt(index + i3) === " ") {
            return index + i3;
          }
        } else if (string.charAt(index - i3) === " ") {
          return index - i3;
        }
      }
      return index;
    }
    module2.exports = (text, columns, options) => {
      options = __spreadValues({
        position: "end",
        preferTruncationOnSpace: false
      }, options);
      const { position, space, preferTruncationOnSpace } = options;
      let ellipsis = "\u2026";
      let ellipsisWidth = 1;
      if (typeof text !== "string") {
        throw new TypeError(`Expected \`input\` to be a string, got ${typeof text}`);
      }
      if (typeof columns !== "number") {
        throw new TypeError(`Expected \`columns\` to be a number, got ${typeof columns}`);
      }
      if (columns < 1) {
        return "";
      }
      if (columns === 1) {
        return ellipsis;
      }
      const length = stringWidth(text);
      if (length <= columns) {
        return text;
      }
      if (position === "start") {
        if (preferTruncationOnSpace) {
          const nearestSpace = getIndexOfNearestSpace(text, length - columns + 1, true);
          return ellipsis + sliceAnsi(text, nearestSpace, length).trim();
        }
        if (space === true) {
          ellipsis += " ";
          ellipsisWidth = 2;
        }
        return ellipsis + sliceAnsi(text, length - columns + ellipsisWidth, length);
      }
      if (position === "middle") {
        if (space === true) {
          ellipsis = " " + ellipsis + " ";
          ellipsisWidth = 3;
        }
        const half = Math.floor(columns / 2);
        if (preferTruncationOnSpace) {
          const spaceNearFirstBreakPoint = getIndexOfNearestSpace(text, half);
          const spaceNearSecondBreakPoint = getIndexOfNearestSpace(text, length - (columns - half) + 1, true);
          return sliceAnsi(text, 0, spaceNearFirstBreakPoint) + ellipsis + sliceAnsi(text, spaceNearSecondBreakPoint, length).trim();
        }
        return sliceAnsi(text, 0, half) + ellipsis + sliceAnsi(text, length - (columns - half) + ellipsisWidth, length);
      }
      if (position === "end") {
        if (preferTruncationOnSpace) {
          const nearestSpace = getIndexOfNearestSpace(text, columns - 1);
          return sliceAnsi(text, 0, nearestSpace) + ellipsis;
        }
        if (space === true) {
          ellipsis = " " + ellipsis;
          ellipsisWidth = 2;
        }
        return sliceAnsi(text, 0, columns - ellipsisWidth) + ellipsis;
      }
      throw new Error(`Expected \`options.position\` to be either \`start\`, \`middle\` or \`end\`, got ${position}`);
    };
  }
});

// node_modules/ink/build/wrap-text.js
var require_wrap_text = __commonJS({
  "node_modules/ink/build/wrap-text.js"(exports2) {
    "use strict";
    var __importDefault = exports2 && exports2.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { "default": mod };
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    var wrap_ansi_1 = __importDefault(require_wrap_ansi());
    var cli_truncate_1 = __importDefault(require_cli_truncate());
    var cache = {};
    exports2.default = (text, maxWidth, wrapType) => {
      const cacheKey = text + String(maxWidth) + String(wrapType);
      if (cache[cacheKey]) {
        return cache[cacheKey];
      }
      let wrappedText = text;
      if (wrapType === "wrap") {
        wrappedText = wrap_ansi_1.default(text, maxWidth, {
          trim: false,
          hard: true
        });
      }
      if (wrapType.startsWith("truncate")) {
        let position = "end";
        if (wrapType === "truncate-middle") {
          position = "middle";
        }
        if (wrapType === "truncate-start") {
          position = "start";
        }
        wrappedText = cli_truncate_1.default(text, maxWidth, { position });
      }
      cache[cacheKey] = wrappedText;
      return wrappedText;
    };
  }
});

// node_modules/ink/build/squash-text-nodes.js
var require_squash_text_nodes = __commonJS({
  "node_modules/ink/build/squash-text-nodes.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var squashTextNodes = (node) => {
      let text = "";
      if (node.childNodes.length > 0) {
        for (const childNode of node.childNodes) {
          let nodeText = "";
          if (childNode.nodeName === "#text") {
            nodeText = childNode.nodeValue;
          } else {
            if (childNode.nodeName === "ink-text" || childNode.nodeName === "ink-virtual-text") {
              nodeText = squashTextNodes(childNode);
            }
            if (nodeText.length > 0 && typeof childNode.internal_transform === "function") {
              nodeText = childNode.internal_transform(nodeText);
            }
          }
          text += nodeText;
        }
      }
      return text;
    };
    exports2.default = squashTextNodes;
  }
});

// node_modules/ink/build/dom.js
var require_dom = __commonJS({
  "node_modules/ink/build/dom.js"(exports2) {
    "use strict";
    var __importDefault = exports2 && exports2.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { "default": mod };
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.setTextNodeValue = exports2.createTextNode = exports2.setStyle = exports2.setAttribute = exports2.removeChildNode = exports2.insertBeforeNode = exports2.appendChildNode = exports2.createNode = exports2.TEXT_NAME = void 0;
    var yoga_layout_prebuilt_1 = __importDefault(require_entry_browser());
    var measure_text_1 = __importDefault(require_measure_text());
    var styles_1 = __importDefault(require_styles());
    var wrap_text_1 = __importDefault(require_wrap_text());
    var squash_text_nodes_1 = __importDefault(require_squash_text_nodes());
    exports2.TEXT_NAME = "#text";
    exports2.createNode = (nodeName) => {
      var _a2;
      const node = {
        nodeName,
        style: {},
        attributes: {},
        childNodes: [],
        parentNode: null,
        yogaNode: nodeName === "ink-virtual-text" ? void 0 : yoga_layout_prebuilt_1.default.Node.create()
      };
      if (nodeName === "ink-text") {
        (_a2 = node.yogaNode) === null || _a2 === void 0 ? void 0 : _a2.setMeasureFunc(measureTextNode.bind(null, node));
      }
      return node;
    };
    exports2.appendChildNode = (node, childNode) => {
      var _a2;
      if (childNode.parentNode) {
        exports2.removeChildNode(childNode.parentNode, childNode);
      }
      childNode.parentNode = node;
      node.childNodes.push(childNode);
      if (childNode.yogaNode) {
        (_a2 = node.yogaNode) === null || _a2 === void 0 ? void 0 : _a2.insertChild(childNode.yogaNode, node.yogaNode.getChildCount());
      }
      if (node.nodeName === "ink-text" || node.nodeName === "ink-virtual-text") {
        markNodeAsDirty(node);
      }
    };
    exports2.insertBeforeNode = (node, newChildNode, beforeChildNode) => {
      var _a2, _b;
      if (newChildNode.parentNode) {
        exports2.removeChildNode(newChildNode.parentNode, newChildNode);
      }
      newChildNode.parentNode = node;
      const index = node.childNodes.indexOf(beforeChildNode);
      if (index >= 0) {
        node.childNodes.splice(index, 0, newChildNode);
        if (newChildNode.yogaNode) {
          (_a2 = node.yogaNode) === null || _a2 === void 0 ? void 0 : _a2.insertChild(newChildNode.yogaNode, index);
        }
        return;
      }
      node.childNodes.push(newChildNode);
      if (newChildNode.yogaNode) {
        (_b = node.yogaNode) === null || _b === void 0 ? void 0 : _b.insertChild(newChildNode.yogaNode, node.yogaNode.getChildCount());
      }
      if (node.nodeName === "ink-text" || node.nodeName === "ink-virtual-text") {
        markNodeAsDirty(node);
      }
    };
    exports2.removeChildNode = (node, removeNode) => {
      var _a2, _b;
      if (removeNode.yogaNode) {
        (_b = (_a2 = removeNode.parentNode) === null || _a2 === void 0 ? void 0 : _a2.yogaNode) === null || _b === void 0 ? void 0 : _b.removeChild(removeNode.yogaNode);
      }
      removeNode.parentNode = null;
      const index = node.childNodes.indexOf(removeNode);
      if (index >= 0) {
        node.childNodes.splice(index, 1);
      }
      if (node.nodeName === "ink-text" || node.nodeName === "ink-virtual-text") {
        markNodeAsDirty(node);
      }
    };
    exports2.setAttribute = (node, key2, value) => {
      node.attributes[key2] = value;
    };
    exports2.setStyle = (node, style) => {
      node.style = style;
      if (node.yogaNode) {
        styles_1.default(node.yogaNode, style);
      }
    };
    exports2.createTextNode = (text) => {
      const node = {
        nodeName: "#text",
        nodeValue: text,
        yogaNode: void 0,
        parentNode: null,
        style: {}
      };
      exports2.setTextNodeValue(node, text);
      return node;
    };
    var measureTextNode = function(node, width) {
      var _a2, _b;
      const text = node.nodeName === "#text" ? node.nodeValue : squash_text_nodes_1.default(node);
      const dimensions = measure_text_1.default(text);
      if (dimensions.width <= width) {
        return dimensions;
      }
      if (dimensions.width >= 1 && width > 0 && width < 1) {
        return dimensions;
      }
      const textWrap = (_b = (_a2 = node.style) === null || _a2 === void 0 ? void 0 : _a2.textWrap) !== null && _b !== void 0 ? _b : "wrap";
      const wrappedText = wrap_text_1.default(text, width, textWrap);
      return measure_text_1.default(wrappedText);
    };
    var findClosestYogaNode = (node) => {
      var _a2;
      if (!node || !node.parentNode) {
        return void 0;
      }
      return (_a2 = node.yogaNode) !== null && _a2 !== void 0 ? _a2 : findClosestYogaNode(node.parentNode);
    };
    var markNodeAsDirty = (node) => {
      const yogaNode = findClosestYogaNode(node);
      yogaNode === null || yogaNode === void 0 ? void 0 : yogaNode.markDirty();
    };
    exports2.setTextNodeValue = (node, text) => {
      if (typeof text !== "string") {
        text = String(text);
      }
      node.nodeValue = text;
      markNodeAsDirty(node);
    };
  }
});

// node_modules/ws/lib/constants.js
var require_constants = __commonJS({
  "node_modules/ws/lib/constants.js"(exports2, module2) {
    "use strict";
    module2.exports = {
      BINARY_TYPES: ["nodebuffer", "arraybuffer", "fragments"],
      GUID: "258EAFA5-E914-47DA-95CA-C5AB0DC85B11",
      kStatusCode: Symbol("status-code"),
      kWebSocket: Symbol("websocket"),
      EMPTY_BUFFER: Buffer.alloc(0),
      NOOP: () => {
      }
    };
  }
});

// node_modules/ws/lib/buffer-util.js
var require_buffer_util = __commonJS({
  "node_modules/ws/lib/buffer-util.js"(exports2, module2) {
    "use strict";
    var { EMPTY_BUFFER } = require_constants();
    function concat(list, totalLength) {
      if (list.length === 0)
        return EMPTY_BUFFER;
      if (list.length === 1)
        return list[0];
      const target = Buffer.allocUnsafe(totalLength);
      let offset = 0;
      for (let i3 = 0; i3 < list.length; i3++) {
        const buf = list[i3];
        target.set(buf, offset);
        offset += buf.length;
      }
      if (offset < totalLength)
        return target.slice(0, offset);
      return target;
    }
    function _mask(source, mask2, output, offset, length) {
      for (let i3 = 0; i3 < length; i3++) {
        output[offset + i3] = source[i3] ^ mask2[i3 & 3];
      }
    }
    function _unmask(buffer2, mask2) {
      const length = buffer2.length;
      for (let i3 = 0; i3 < length; i3++) {
        buffer2[i3] ^= mask2[i3 & 3];
      }
    }
    function toArrayBuffer(buf) {
      if (buf.byteLength === buf.buffer.byteLength) {
        return buf.buffer;
      }
      return buf.buffer.slice(buf.byteOffset, buf.byteOffset + buf.byteLength);
    }
    function toBuffer(data) {
      toBuffer.readOnly = true;
      if (Buffer.isBuffer(data))
        return data;
      let buf;
      if (data instanceof ArrayBuffer) {
        buf = Buffer.from(data);
      } else if (ArrayBuffer.isView(data)) {
        buf = Buffer.from(data.buffer, data.byteOffset, data.byteLength);
      } else {
        buf = Buffer.from(data);
        toBuffer.readOnly = false;
      }
      return buf;
    }
    try {
      const bufferUtil = require("bufferutil");
      const bu = bufferUtil.BufferUtil || bufferUtil;
      module2.exports = {
        concat,
        mask(source, mask2, output, offset, length) {
          if (length < 48)
            _mask(source, mask2, output, offset, length);
          else
            bu.mask(source, mask2, output, offset, length);
        },
        toArrayBuffer,
        toBuffer,
        unmask(buffer2, mask2) {
          if (buffer2.length < 32)
            _unmask(buffer2, mask2);
          else
            bu.unmask(buffer2, mask2);
        }
      };
    } catch (e2) {
      module2.exports = {
        concat,
        mask: _mask,
        toArrayBuffer,
        toBuffer,
        unmask: _unmask
      };
    }
  }
});

// node_modules/ws/lib/limiter.js
var require_limiter = __commonJS({
  "node_modules/ws/lib/limiter.js"(exports2, module2) {
    "use strict";
    var kDone = Symbol("kDone");
    var kRun = Symbol("kRun");
    var Limiter = class {
      constructor(concurrency) {
        this[kDone] = () => {
          this.pending--;
          this[kRun]();
        };
        this.concurrency = concurrency || Infinity;
        this.jobs = [];
        this.pending = 0;
      }
      add(job) {
        this.jobs.push(job);
        this[kRun]();
      }
      [kRun]() {
        if (this.pending === this.concurrency)
          return;
        if (this.jobs.length) {
          const job = this.jobs.shift();
          this.pending++;
          job(this[kDone]);
        }
      }
    };
    module2.exports = Limiter;
  }
});

// node_modules/ws/lib/permessage-deflate.js
var require_permessage_deflate = __commonJS({
  "node_modules/ws/lib/permessage-deflate.js"(exports2, module2) {
    "use strict";
    var zlib = require("zlib");
    var bufferUtil = require_buffer_util();
    var Limiter = require_limiter();
    var { kStatusCode, NOOP } = require_constants();
    var TRAILER = Buffer.from([0, 0, 255, 255]);
    var kPerMessageDeflate = Symbol("permessage-deflate");
    var kTotalLength = Symbol("total-length");
    var kCallback = Symbol("callback");
    var kBuffers = Symbol("buffers");
    var kError = Symbol("error");
    var zlibLimiter;
    var PerMessageDeflate = class {
      constructor(options, isServer, maxPayload) {
        this._maxPayload = maxPayload | 0;
        this._options = options || {};
        this._threshold = this._options.threshold !== void 0 ? this._options.threshold : 1024;
        this._isServer = !!isServer;
        this._deflate = null;
        this._inflate = null;
        this.params = null;
        if (!zlibLimiter) {
          const concurrency = this._options.concurrencyLimit !== void 0 ? this._options.concurrencyLimit : 10;
          zlibLimiter = new Limiter(concurrency);
        }
      }
      static get extensionName() {
        return "permessage-deflate";
      }
      offer() {
        const params = {};
        if (this._options.serverNoContextTakeover) {
          params.server_no_context_takeover = true;
        }
        if (this._options.clientNoContextTakeover) {
          params.client_no_context_takeover = true;
        }
        if (this._options.serverMaxWindowBits) {
          params.server_max_window_bits = this._options.serverMaxWindowBits;
        }
        if (this._options.clientMaxWindowBits) {
          params.client_max_window_bits = this._options.clientMaxWindowBits;
        } else if (this._options.clientMaxWindowBits == null) {
          params.client_max_window_bits = true;
        }
        return params;
      }
      accept(configurations) {
        configurations = this.normalizeParams(configurations);
        this.params = this._isServer ? this.acceptAsServer(configurations) : this.acceptAsClient(configurations);
        return this.params;
      }
      cleanup() {
        if (this._inflate) {
          this._inflate.close();
          this._inflate = null;
        }
        if (this._deflate) {
          const callback = this._deflate[kCallback];
          this._deflate.close();
          this._deflate = null;
          if (callback) {
            callback(new Error("The deflate stream was closed while data was being processed"));
          }
        }
      }
      acceptAsServer(offers) {
        const opts = this._options;
        const accepted = offers.find((params) => {
          if (opts.serverNoContextTakeover === false && params.server_no_context_takeover || params.server_max_window_bits && (opts.serverMaxWindowBits === false || typeof opts.serverMaxWindowBits === "number" && opts.serverMaxWindowBits > params.server_max_window_bits) || typeof opts.clientMaxWindowBits === "number" && !params.client_max_window_bits) {
            return false;
          }
          return true;
        });
        if (!accepted) {
          throw new Error("None of the extension offers can be accepted");
        }
        if (opts.serverNoContextTakeover) {
          accepted.server_no_context_takeover = true;
        }
        if (opts.clientNoContextTakeover) {
          accepted.client_no_context_takeover = true;
        }
        if (typeof opts.serverMaxWindowBits === "number") {
          accepted.server_max_window_bits = opts.serverMaxWindowBits;
        }
        if (typeof opts.clientMaxWindowBits === "number") {
          accepted.client_max_window_bits = opts.clientMaxWindowBits;
        } else if (accepted.client_max_window_bits === true || opts.clientMaxWindowBits === false) {
          delete accepted.client_max_window_bits;
        }
        return accepted;
      }
      acceptAsClient(response) {
        const params = response[0];
        if (this._options.clientNoContextTakeover === false && params.client_no_context_takeover) {
          throw new Error('Unexpected parameter "client_no_context_takeover"');
        }
        if (!params.client_max_window_bits) {
          if (typeof this._options.clientMaxWindowBits === "number") {
            params.client_max_window_bits = this._options.clientMaxWindowBits;
          }
        } else if (this._options.clientMaxWindowBits === false || typeof this._options.clientMaxWindowBits === "number" && params.client_max_window_bits > this._options.clientMaxWindowBits) {
          throw new Error('Unexpected or invalid parameter "client_max_window_bits"');
        }
        return params;
      }
      normalizeParams(configurations) {
        configurations.forEach((params) => {
          Object.keys(params).forEach((key2) => {
            let value = params[key2];
            if (value.length > 1) {
              throw new Error(`Parameter "${key2}" must have only a single value`);
            }
            value = value[0];
            if (key2 === "client_max_window_bits") {
              if (value !== true) {
                const num2 = +value;
                if (!Number.isInteger(num2) || num2 < 8 || num2 > 15) {
                  throw new TypeError(`Invalid value for parameter "${key2}": ${value}`);
                }
                value = num2;
              } else if (!this._isServer) {
                throw new TypeError(`Invalid value for parameter "${key2}": ${value}`);
              }
            } else if (key2 === "server_max_window_bits") {
              const num2 = +value;
              if (!Number.isInteger(num2) || num2 < 8 || num2 > 15) {
                throw new TypeError(`Invalid value for parameter "${key2}": ${value}`);
              }
              value = num2;
            } else if (key2 === "client_no_context_takeover" || key2 === "server_no_context_takeover") {
              if (value !== true) {
                throw new TypeError(`Invalid value for parameter "${key2}": ${value}`);
              }
            } else {
              throw new Error(`Unknown parameter "${key2}"`);
            }
            params[key2] = value;
          });
        });
        return configurations;
      }
      decompress(data, fin, callback) {
        zlibLimiter.add((done) => {
          this._decompress(data, fin, (err2, result2) => {
            done();
            callback(err2, result2);
          });
        });
      }
      compress(data, fin, callback) {
        zlibLimiter.add((done) => {
          this._compress(data, fin, (err2, result2) => {
            done();
            callback(err2, result2);
          });
        });
      }
      _decompress(data, fin, callback) {
        const endpoint = this._isServer ? "client" : "server";
        if (!this._inflate) {
          const key2 = `${endpoint}_max_window_bits`;
          const windowBits = typeof this.params[key2] !== "number" ? zlib.Z_DEFAULT_WINDOWBITS : this.params[key2];
          this._inflate = zlib.createInflateRaw(__spreadProps(__spreadValues({}, this._options.zlibInflateOptions), {
            windowBits
          }));
          this._inflate[kPerMessageDeflate] = this;
          this._inflate[kTotalLength] = 0;
          this._inflate[kBuffers] = [];
          this._inflate.on("error", inflateOnError);
          this._inflate.on("data", inflateOnData);
        }
        this._inflate[kCallback] = callback;
        this._inflate.write(data);
        if (fin)
          this._inflate.write(TRAILER);
        this._inflate.flush(() => {
          const err2 = this._inflate[kError];
          if (err2) {
            this._inflate.close();
            this._inflate = null;
            callback(err2);
            return;
          }
          const data2 = bufferUtil.concat(this._inflate[kBuffers], this._inflate[kTotalLength]);
          if (this._inflate._readableState.endEmitted) {
            this._inflate.close();
            this._inflate = null;
          } else {
            this._inflate[kTotalLength] = 0;
            this._inflate[kBuffers] = [];
            if (fin && this.params[`${endpoint}_no_context_takeover`]) {
              this._inflate.reset();
            }
          }
          callback(null, data2);
        });
      }
      _compress(data, fin, callback) {
        const endpoint = this._isServer ? "server" : "client";
        if (!this._deflate) {
          const key2 = `${endpoint}_max_window_bits`;
          const windowBits = typeof this.params[key2] !== "number" ? zlib.Z_DEFAULT_WINDOWBITS : this.params[key2];
          this._deflate = zlib.createDeflateRaw(__spreadProps(__spreadValues({}, this._options.zlibDeflateOptions), {
            windowBits
          }));
          this._deflate[kTotalLength] = 0;
          this._deflate[kBuffers] = [];
          this._deflate.on("error", NOOP);
          this._deflate.on("data", deflateOnData);
        }
        this._deflate[kCallback] = callback;
        this._deflate.write(data);
        this._deflate.flush(zlib.Z_SYNC_FLUSH, () => {
          if (!this._deflate) {
            return;
          }
          let data2 = bufferUtil.concat(this._deflate[kBuffers], this._deflate[kTotalLength]);
          if (fin)
            data2 = data2.slice(0, data2.length - 4);
          this._deflate[kCallback] = null;
          this._deflate[kTotalLength] = 0;
          this._deflate[kBuffers] = [];
          if (fin && this.params[`${endpoint}_no_context_takeover`]) {
            this._deflate.reset();
          }
          callback(null, data2);
        });
      }
    };
    module2.exports = PerMessageDeflate;
    function deflateOnData(chunk) {
      this[kBuffers].push(chunk);
      this[kTotalLength] += chunk.length;
    }
    function inflateOnData(chunk) {
      this[kTotalLength] += chunk.length;
      if (this[kPerMessageDeflate]._maxPayload < 1 || this[kTotalLength] <= this[kPerMessageDeflate]._maxPayload) {
        this[kBuffers].push(chunk);
        return;
      }
      this[kError] = new RangeError("Max payload size exceeded");
      this[kError].code = "WS_ERR_UNSUPPORTED_MESSAGE_LENGTH";
      this[kError][kStatusCode] = 1009;
      this.removeListener("data", inflateOnData);
      this.reset();
    }
    function inflateOnError(err2) {
      this[kPerMessageDeflate]._inflate = null;
      err2[kStatusCode] = 1007;
      this[kCallback](err2);
    }
  }
});

// node_modules/ws/lib/validation.js
var require_validation = __commonJS({
  "node_modules/ws/lib/validation.js"(exports2, module2) {
    "use strict";
    function isValidStatusCode(code) {
      return code >= 1e3 && code <= 1014 && code !== 1004 && code !== 1005 && code !== 1006 || code >= 3e3 && code <= 4999;
    }
    function _isValidUTF8(buf) {
      const len = buf.length;
      let i3 = 0;
      while (i3 < len) {
        if ((buf[i3] & 128) === 0) {
          i3++;
        } else if ((buf[i3] & 224) === 192) {
          if (i3 + 1 === len || (buf[i3 + 1] & 192) !== 128 || (buf[i3] & 254) === 192) {
            return false;
          }
          i3 += 2;
        } else if ((buf[i3] & 240) === 224) {
          if (i3 + 2 >= len || (buf[i3 + 1] & 192) !== 128 || (buf[i3 + 2] & 192) !== 128 || buf[i3] === 224 && (buf[i3 + 1] & 224) === 128 || buf[i3] === 237 && (buf[i3 + 1] & 224) === 160) {
            return false;
          }
          i3 += 3;
        } else if ((buf[i3] & 248) === 240) {
          if (i3 + 3 >= len || (buf[i3 + 1] & 192) !== 128 || (buf[i3 + 2] & 192) !== 128 || (buf[i3 + 3] & 192) !== 128 || buf[i3] === 240 && (buf[i3 + 1] & 240) === 128 || buf[i3] === 244 && buf[i3 + 1] > 143 || buf[i3] > 244) {
            return false;
          }
          i3 += 4;
        } else {
          return false;
        }
      }
      return true;
    }
    try {
      let isValidUTF8 = require("utf-8-validate");
      if (typeof isValidUTF8 === "object") {
        isValidUTF8 = isValidUTF8.Validation.isValidUTF8;
      }
      module2.exports = {
        isValidStatusCode,
        isValidUTF8(buf) {
          return buf.length < 150 ? _isValidUTF8(buf) : isValidUTF8(buf);
        }
      };
    } catch (e2) {
      module2.exports = {
        isValidStatusCode,
        isValidUTF8: _isValidUTF8
      };
    }
  }
});

// node_modules/ws/lib/receiver.js
var require_receiver = __commonJS({
  "node_modules/ws/lib/receiver.js"(exports2, module2) {
    "use strict";
    var { Writable } = require("stream");
    var PerMessageDeflate = require_permessage_deflate();
    var {
      BINARY_TYPES,
      EMPTY_BUFFER,
      kStatusCode,
      kWebSocket
    } = require_constants();
    var { concat, toArrayBuffer, unmask } = require_buffer_util();
    var { isValidStatusCode, isValidUTF8 } = require_validation();
    var GET_INFO = 0;
    var GET_PAYLOAD_LENGTH_16 = 1;
    var GET_PAYLOAD_LENGTH_64 = 2;
    var GET_MASK = 3;
    var GET_DATA = 4;
    var INFLATING = 5;
    var Receiver = class extends Writable {
      constructor(binaryType, extensions, isServer, maxPayload) {
        super();
        this._binaryType = binaryType || BINARY_TYPES[0];
        this[kWebSocket] = void 0;
        this._extensions = extensions || {};
        this._isServer = !!isServer;
        this._maxPayload = maxPayload | 0;
        this._bufferedBytes = 0;
        this._buffers = [];
        this._compressed = false;
        this._payloadLength = 0;
        this._mask = void 0;
        this._fragmented = 0;
        this._masked = false;
        this._fin = false;
        this._opcode = 0;
        this._totalPayloadLength = 0;
        this._messageLength = 0;
        this._fragments = [];
        this._state = GET_INFO;
        this._loop = false;
      }
      _write(chunk, encoding, cb2) {
        if (this._opcode === 8 && this._state == GET_INFO)
          return cb2();
        this._bufferedBytes += chunk.length;
        this._buffers.push(chunk);
        this.startLoop(cb2);
      }
      consume(n2) {
        this._bufferedBytes -= n2;
        if (n2 === this._buffers[0].length)
          return this._buffers.shift();
        if (n2 < this._buffers[0].length) {
          const buf = this._buffers[0];
          this._buffers[0] = buf.slice(n2);
          return buf.slice(0, n2);
        }
        const dst = Buffer.allocUnsafe(n2);
        do {
          const buf = this._buffers[0];
          const offset = dst.length - n2;
          if (n2 >= buf.length) {
            dst.set(this._buffers.shift(), offset);
          } else {
            dst.set(new Uint8Array(buf.buffer, buf.byteOffset, n2), offset);
            this._buffers[0] = buf.slice(n2);
          }
          n2 -= buf.length;
        } while (n2 > 0);
        return dst;
      }
      startLoop(cb2) {
        let err2;
        this._loop = true;
        do {
          switch (this._state) {
            case GET_INFO:
              err2 = this.getInfo();
              break;
            case GET_PAYLOAD_LENGTH_16:
              err2 = this.getPayloadLength16();
              break;
            case GET_PAYLOAD_LENGTH_64:
              err2 = this.getPayloadLength64();
              break;
            case GET_MASK:
              this.getMask();
              break;
            case GET_DATA:
              err2 = this.getData(cb2);
              break;
            default:
              this._loop = false;
              return;
          }
        } while (this._loop);
        cb2(err2);
      }
      getInfo() {
        if (this._bufferedBytes < 2) {
          this._loop = false;
          return;
        }
        const buf = this.consume(2);
        if ((buf[0] & 48) !== 0) {
          this._loop = false;
          return error(RangeError, "RSV2 and RSV3 must be clear", true, 1002, "WS_ERR_UNEXPECTED_RSV_2_3");
        }
        const compressed = (buf[0] & 64) === 64;
        if (compressed && !this._extensions[PerMessageDeflate.extensionName]) {
          this._loop = false;
          return error(RangeError, "RSV1 must be clear", true, 1002, "WS_ERR_UNEXPECTED_RSV_1");
        }
        this._fin = (buf[0] & 128) === 128;
        this._opcode = buf[0] & 15;
        this._payloadLength = buf[1] & 127;
        if (this._opcode === 0) {
          if (compressed) {
            this._loop = false;
            return error(RangeError, "RSV1 must be clear", true, 1002, "WS_ERR_UNEXPECTED_RSV_1");
          }
          if (!this._fragmented) {
            this._loop = false;
            return error(RangeError, "invalid opcode 0", true, 1002, "WS_ERR_INVALID_OPCODE");
          }
          this._opcode = this._fragmented;
        } else if (this._opcode === 1 || this._opcode === 2) {
          if (this._fragmented) {
            this._loop = false;
            return error(RangeError, `invalid opcode ${this._opcode}`, true, 1002, "WS_ERR_INVALID_OPCODE");
          }
          this._compressed = compressed;
        } else if (this._opcode > 7 && this._opcode < 11) {
          if (!this._fin) {
            this._loop = false;
            return error(RangeError, "FIN must be set", true, 1002, "WS_ERR_EXPECTED_FIN");
          }
          if (compressed) {
            this._loop = false;
            return error(RangeError, "RSV1 must be clear", true, 1002, "WS_ERR_UNEXPECTED_RSV_1");
          }
          if (this._payloadLength > 125) {
            this._loop = false;
            return error(RangeError, `invalid payload length ${this._payloadLength}`, true, 1002, "WS_ERR_INVALID_CONTROL_PAYLOAD_LENGTH");
          }
        } else {
          this._loop = false;
          return error(RangeError, `invalid opcode ${this._opcode}`, true, 1002, "WS_ERR_INVALID_OPCODE");
        }
        if (!this._fin && !this._fragmented)
          this._fragmented = this._opcode;
        this._masked = (buf[1] & 128) === 128;
        if (this._isServer) {
          if (!this._masked) {
            this._loop = false;
            return error(RangeError, "MASK must be set", true, 1002, "WS_ERR_EXPECTED_MASK");
          }
        } else if (this._masked) {
          this._loop = false;
          return error(RangeError, "MASK must be clear", true, 1002, "WS_ERR_UNEXPECTED_MASK");
        }
        if (this._payloadLength === 126)
          this._state = GET_PAYLOAD_LENGTH_16;
        else if (this._payloadLength === 127)
          this._state = GET_PAYLOAD_LENGTH_64;
        else
          return this.haveLength();
      }
      getPayloadLength16() {
        if (this._bufferedBytes < 2) {
          this._loop = false;
          return;
        }
        this._payloadLength = this.consume(2).readUInt16BE(0);
        return this.haveLength();
      }
      getPayloadLength64() {
        if (this._bufferedBytes < 8) {
          this._loop = false;
          return;
        }
        const buf = this.consume(8);
        const num2 = buf.readUInt32BE(0);
        if (num2 > Math.pow(2, 53 - 32) - 1) {
          this._loop = false;
          return error(RangeError, "Unsupported WebSocket frame: payload length > 2^53 - 1", false, 1009, "WS_ERR_UNSUPPORTED_DATA_PAYLOAD_LENGTH");
        }
        this._payloadLength = num2 * Math.pow(2, 32) + buf.readUInt32BE(4);
        return this.haveLength();
      }
      haveLength() {
        if (this._payloadLength && this._opcode < 8) {
          this._totalPayloadLength += this._payloadLength;
          if (this._totalPayloadLength > this._maxPayload && this._maxPayload > 0) {
            this._loop = false;
            return error(RangeError, "Max payload size exceeded", false, 1009, "WS_ERR_UNSUPPORTED_MESSAGE_LENGTH");
          }
        }
        if (this._masked)
          this._state = GET_MASK;
        else
          this._state = GET_DATA;
      }
      getMask() {
        if (this._bufferedBytes < 4) {
          this._loop = false;
          return;
        }
        this._mask = this.consume(4);
        this._state = GET_DATA;
      }
      getData(cb2) {
        let data = EMPTY_BUFFER;
        if (this._payloadLength) {
          if (this._bufferedBytes < this._payloadLength) {
            this._loop = false;
            return;
          }
          data = this.consume(this._payloadLength);
          if (this._masked)
            unmask(data, this._mask);
        }
        if (this._opcode > 7)
          return this.controlMessage(data);
        if (this._compressed) {
          this._state = INFLATING;
          this.decompress(data, cb2);
          return;
        }
        if (data.length) {
          this._messageLength = this._totalPayloadLength;
          this._fragments.push(data);
        }
        return this.dataMessage();
      }
      decompress(data, cb2) {
        const perMessageDeflate = this._extensions[PerMessageDeflate.extensionName];
        perMessageDeflate.decompress(data, this._fin, (err2, buf) => {
          if (err2)
            return cb2(err2);
          if (buf.length) {
            this._messageLength += buf.length;
            if (this._messageLength > this._maxPayload && this._maxPayload > 0) {
              return cb2(error(RangeError, "Max payload size exceeded", false, 1009, "WS_ERR_UNSUPPORTED_MESSAGE_LENGTH"));
            }
            this._fragments.push(buf);
          }
          const er = this.dataMessage();
          if (er)
            return cb2(er);
          this.startLoop(cb2);
        });
      }
      dataMessage() {
        if (this._fin) {
          const messageLength = this._messageLength;
          const fragments = this._fragments;
          this._totalPayloadLength = 0;
          this._messageLength = 0;
          this._fragmented = 0;
          this._fragments = [];
          if (this._opcode === 2) {
            let data;
            if (this._binaryType === "nodebuffer") {
              data = concat(fragments, messageLength);
            } else if (this._binaryType === "arraybuffer") {
              data = toArrayBuffer(concat(fragments, messageLength));
            } else {
              data = fragments;
            }
            this.emit("message", data);
          } else {
            const buf = concat(fragments, messageLength);
            if (!isValidUTF8(buf)) {
              this._loop = false;
              return error(Error, "invalid UTF-8 sequence", true, 1007, "WS_ERR_INVALID_UTF8");
            }
            this.emit("message", buf.toString());
          }
        }
        this._state = GET_INFO;
      }
      controlMessage(data) {
        if (this._opcode === 8) {
          this._loop = false;
          if (data.length === 0) {
            this.emit("conclude", 1005, "");
            this.end();
          } else if (data.length === 1) {
            return error(RangeError, "invalid payload length 1", true, 1002, "WS_ERR_INVALID_CONTROL_PAYLOAD_LENGTH");
          } else {
            const code = data.readUInt16BE(0);
            if (!isValidStatusCode(code)) {
              return error(RangeError, `invalid status code ${code}`, true, 1002, "WS_ERR_INVALID_CLOSE_CODE");
            }
            const buf = data.slice(2);
            if (!isValidUTF8(buf)) {
              return error(Error, "invalid UTF-8 sequence", true, 1007, "WS_ERR_INVALID_UTF8");
            }
            this.emit("conclude", code, buf.toString());
            this.end();
          }
        } else if (this._opcode === 9) {
          this.emit("ping", data);
        } else {
          this.emit("pong", data);
        }
        this._state = GET_INFO;
      }
    };
    module2.exports = Receiver;
    function error(ErrorCtor, message, prefix2, statusCode, errorCode) {
      const err2 = new ErrorCtor(prefix2 ? `Invalid WebSocket frame: ${message}` : message);
      Error.captureStackTrace(err2, error);
      err2.code = errorCode;
      err2[kStatusCode] = statusCode;
      return err2;
    }
  }
});

// node_modules/ws/lib/sender.js
var require_sender = __commonJS({
  "node_modules/ws/lib/sender.js"(exports2, module2) {
    "use strict";
    var net = require("net");
    var tls = require("tls");
    var { randomFillSync } = require("crypto");
    var PerMessageDeflate = require_permessage_deflate();
    var { EMPTY_BUFFER } = require_constants();
    var { isValidStatusCode } = require_validation();
    var { mask: applyMask, toBuffer } = require_buffer_util();
    var mask2 = Buffer.alloc(4);
    var Sender = class {
      constructor(socket, extensions) {
        this._extensions = extensions || {};
        this._socket = socket;
        this._firstFragment = true;
        this._compress = false;
        this._bufferedBytes = 0;
        this._deflating = false;
        this._queue = [];
      }
      static frame(data, options) {
        const merge2 = options.mask && options.readOnly;
        let offset = options.mask ? 6 : 2;
        let payloadLength = data.length;
        if (data.length >= 65536) {
          offset += 8;
          payloadLength = 127;
        } else if (data.length > 125) {
          offset += 2;
          payloadLength = 126;
        }
        const target = Buffer.allocUnsafe(merge2 ? data.length + offset : offset);
        target[0] = options.fin ? options.opcode | 128 : options.opcode;
        if (options.rsv1)
          target[0] |= 64;
        target[1] = payloadLength;
        if (payloadLength === 126) {
          target.writeUInt16BE(data.length, 2);
        } else if (payloadLength === 127) {
          target.writeUInt32BE(0, 2);
          target.writeUInt32BE(data.length, 6);
        }
        if (!options.mask)
          return [target, data];
        randomFillSync(mask2, 0, 4);
        target[1] |= 128;
        target[offset - 4] = mask2[0];
        target[offset - 3] = mask2[1];
        target[offset - 2] = mask2[2];
        target[offset - 1] = mask2[3];
        if (merge2) {
          applyMask(data, mask2, target, offset, data.length);
          return [target];
        }
        applyMask(data, mask2, data, 0, data.length);
        return [target, data];
      }
      close(code, data, mask3, cb2) {
        let buf;
        if (code === void 0) {
          buf = EMPTY_BUFFER;
        } else if (typeof code !== "number" || !isValidStatusCode(code)) {
          throw new TypeError("First argument must be a valid error code number");
        } else if (data === void 0 || data === "") {
          buf = Buffer.allocUnsafe(2);
          buf.writeUInt16BE(code, 0);
        } else {
          const length = Buffer.byteLength(data);
          if (length > 123) {
            throw new RangeError("The message must not be greater than 123 bytes");
          }
          buf = Buffer.allocUnsafe(2 + length);
          buf.writeUInt16BE(code, 0);
          buf.write(data, 2);
        }
        if (this._deflating) {
          this.enqueue([this.doClose, buf, mask3, cb2]);
        } else {
          this.doClose(buf, mask3, cb2);
        }
      }
      doClose(data, mask3, cb2) {
        this.sendFrame(Sender.frame(data, {
          fin: true,
          rsv1: false,
          opcode: 8,
          mask: mask3,
          readOnly: false
        }), cb2);
      }
      ping(data, mask3, cb2) {
        const buf = toBuffer(data);
        if (buf.length > 125) {
          throw new RangeError("The data size must not be greater than 125 bytes");
        }
        if (this._deflating) {
          this.enqueue([this.doPing, buf, mask3, toBuffer.readOnly, cb2]);
        } else {
          this.doPing(buf, mask3, toBuffer.readOnly, cb2);
        }
      }
      doPing(data, mask3, readOnly, cb2) {
        this.sendFrame(Sender.frame(data, {
          fin: true,
          rsv1: false,
          opcode: 9,
          mask: mask3,
          readOnly
        }), cb2);
      }
      pong(data, mask3, cb2) {
        const buf = toBuffer(data);
        if (buf.length > 125) {
          throw new RangeError("The data size must not be greater than 125 bytes");
        }
        if (this._deflating) {
          this.enqueue([this.doPong, buf, mask3, toBuffer.readOnly, cb2]);
        } else {
          this.doPong(buf, mask3, toBuffer.readOnly, cb2);
        }
      }
      doPong(data, mask3, readOnly, cb2) {
        this.sendFrame(Sender.frame(data, {
          fin: true,
          rsv1: false,
          opcode: 10,
          mask: mask3,
          readOnly
        }), cb2);
      }
      send(data, options, cb2) {
        const buf = toBuffer(data);
        const perMessageDeflate = this._extensions[PerMessageDeflate.extensionName];
        let opcode = options.binary ? 2 : 1;
        let rsv1 = options.compress;
        if (this._firstFragment) {
          this._firstFragment = false;
          if (rsv1 && perMessageDeflate) {
            rsv1 = buf.length >= perMessageDeflate._threshold;
          }
          this._compress = rsv1;
        } else {
          rsv1 = false;
          opcode = 0;
        }
        if (options.fin)
          this._firstFragment = true;
        if (perMessageDeflate) {
          const opts = {
            fin: options.fin,
            rsv1,
            opcode,
            mask: options.mask,
            readOnly: toBuffer.readOnly
          };
          if (this._deflating) {
            this.enqueue([this.dispatch, buf, this._compress, opts, cb2]);
          } else {
            this.dispatch(buf, this._compress, opts, cb2);
          }
        } else {
          this.sendFrame(Sender.frame(buf, {
            fin: options.fin,
            rsv1: false,
            opcode,
            mask: options.mask,
            readOnly: toBuffer.readOnly
          }), cb2);
        }
      }
      dispatch(data, compress, options, cb2) {
        if (!compress) {
          this.sendFrame(Sender.frame(data, options), cb2);
          return;
        }
        const perMessageDeflate = this._extensions[PerMessageDeflate.extensionName];
        this._bufferedBytes += data.length;
        this._deflating = true;
        perMessageDeflate.compress(data, options.fin, (_, buf) => {
          if (this._socket.destroyed) {
            const err2 = new Error("The socket was closed while data was being compressed");
            if (typeof cb2 === "function")
              cb2(err2);
            for (let i3 = 0; i3 < this._queue.length; i3++) {
              const callback = this._queue[i3][4];
              if (typeof callback === "function")
                callback(err2);
            }
            return;
          }
          this._bufferedBytes -= data.length;
          this._deflating = false;
          options.readOnly = false;
          this.sendFrame(Sender.frame(buf, options), cb2);
          this.dequeue();
        });
      }
      dequeue() {
        while (!this._deflating && this._queue.length) {
          const params = this._queue.shift();
          this._bufferedBytes -= params[1].length;
          Reflect.apply(params[0], this, params.slice(1));
        }
      }
      enqueue(params) {
        this._bufferedBytes += params[1].length;
        this._queue.push(params);
      }
      sendFrame(list, cb2) {
        if (list.length === 2) {
          this._socket.cork();
          this._socket.write(list[0]);
          this._socket.write(list[1], cb2);
          this._socket.uncork();
        } else {
          this._socket.write(list[0], cb2);
        }
      }
    };
    module2.exports = Sender;
  }
});

// node_modules/ws/lib/event-target.js
var require_event_target = __commonJS({
  "node_modules/ws/lib/event-target.js"(exports2, module2) {
    "use strict";
    var Event = class {
      constructor(type3, target) {
        this.target = target;
        this.type = type3;
      }
    };
    var MessageEvent = class extends Event {
      constructor(data, target) {
        super("message", target);
        this.data = data;
      }
    };
    var CloseEvent = class extends Event {
      constructor(code, reason, target) {
        super("close", target);
        this.wasClean = target._closeFrameReceived && target._closeFrameSent;
        this.reason = reason;
        this.code = code;
      }
    };
    var OpenEvent = class extends Event {
      constructor(target) {
        super("open", target);
      }
    };
    var ErrorEvent = class extends Event {
      constructor(error, target) {
        super("error", target);
        this.message = error.message;
        this.error = error;
      }
    };
    var EventTarget = {
      addEventListener(type3, listener, options) {
        if (typeof listener !== "function")
          return;
        function onMessage(data) {
          listener.call(this, new MessageEvent(data, this));
        }
        function onClose(code, message) {
          listener.call(this, new CloseEvent(code, message, this));
        }
        function onError(error) {
          listener.call(this, new ErrorEvent(error, this));
        }
        function onOpen() {
          listener.call(this, new OpenEvent(this));
        }
        const method = options && options.once ? "once" : "on";
        if (type3 === "message") {
          onMessage._listener = listener;
          this[method](type3, onMessage);
        } else if (type3 === "close") {
          onClose._listener = listener;
          this[method](type3, onClose);
        } else if (type3 === "error") {
          onError._listener = listener;
          this[method](type3, onError);
        } else if (type3 === "open") {
          onOpen._listener = listener;
          this[method](type3, onOpen);
        } else {
          this[method](type3, listener);
        }
      },
      removeEventListener(type3, listener) {
        const listeners = this.listeners(type3);
        for (let i3 = 0; i3 < listeners.length; i3++) {
          if (listeners[i3] === listener || listeners[i3]._listener === listener) {
            this.removeListener(type3, listeners[i3]);
          }
        }
      }
    };
    module2.exports = EventTarget;
  }
});

// node_modules/ws/lib/extension.js
var require_extension = __commonJS({
  "node_modules/ws/lib/extension.js"(exports2, module2) {
    "use strict";
    var tokenChars = [
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      1,
      0,
      1,
      1,
      1,
      1,
      1,
      0,
      0,
      1,
      1,
      0,
      1,
      1,
      0,
      1,
      1,
      1,
      1,
      1,
      1,
      1,
      1,
      1,
      1,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      1,
      1,
      1,
      1,
      1,
      1,
      1,
      1,
      1,
      1,
      1,
      1,
      1,
      1,
      1,
      1,
      1,
      1,
      1,
      1,
      1,
      1,
      1,
      1,
      1,
      1,
      0,
      0,
      0,
      1,
      1,
      1,
      1,
      1,
      1,
      1,
      1,
      1,
      1,
      1,
      1,
      1,
      1,
      1,
      1,
      1,
      1,
      1,
      1,
      1,
      1,
      1,
      1,
      1,
      1,
      1,
      1,
      1,
      0,
      1,
      0,
      1,
      0
    ];
    function push(dest, name, elem) {
      if (dest[name] === void 0)
        dest[name] = [elem];
      else
        dest[name].push(elem);
    }
    function parse(header) {
      const offers = Object.create(null);
      if (header === void 0 || header === "")
        return offers;
      let params = Object.create(null);
      let mustUnescape = false;
      let isEscaping = false;
      let inQuotes = false;
      let extensionName;
      let paramName;
      let start = -1;
      let end = -1;
      let i3 = 0;
      for (; i3 < header.length; i3++) {
        const code = header.charCodeAt(i3);
        if (extensionName === void 0) {
          if (end === -1 && tokenChars[code] === 1) {
            if (start === -1)
              start = i3;
          } else if (code === 32 || code === 9) {
            if (end === -1 && start !== -1)
              end = i3;
          } else if (code === 59 || code === 44) {
            if (start === -1) {
              throw new SyntaxError(`Unexpected character at index ${i3}`);
            }
            if (end === -1)
              end = i3;
            const name = header.slice(start, end);
            if (code === 44) {
              push(offers, name, params);
              params = Object.create(null);
            } else {
              extensionName = name;
            }
            start = end = -1;
          } else {
            throw new SyntaxError(`Unexpected character at index ${i3}`);
          }
        } else if (paramName === void 0) {
          if (end === -1 && tokenChars[code] === 1) {
            if (start === -1)
              start = i3;
          } else if (code === 32 || code === 9) {
            if (end === -1 && start !== -1)
              end = i3;
          } else if (code === 59 || code === 44) {
            if (start === -1) {
              throw new SyntaxError(`Unexpected character at index ${i3}`);
            }
            if (end === -1)
              end = i3;
            push(params, header.slice(start, end), true);
            if (code === 44) {
              push(offers, extensionName, params);
              params = Object.create(null);
              extensionName = void 0;
            }
            start = end = -1;
          } else if (code === 61 && start !== -1 && end === -1) {
            paramName = header.slice(start, i3);
            start = end = -1;
          } else {
            throw new SyntaxError(`Unexpected character at index ${i3}`);
          }
        } else {
          if (isEscaping) {
            if (tokenChars[code] !== 1) {
              throw new SyntaxError(`Unexpected character at index ${i3}`);
            }
            if (start === -1)
              start = i3;
            else if (!mustUnescape)
              mustUnescape = true;
            isEscaping = false;
          } else if (inQuotes) {
            if (tokenChars[code] === 1) {
              if (start === -1)
                start = i3;
            } else if (code === 34 && start !== -1) {
              inQuotes = false;
              end = i3;
            } else if (code === 92) {
              isEscaping = true;
            } else {
              throw new SyntaxError(`Unexpected character at index ${i3}`);
            }
          } else if (code === 34 && header.charCodeAt(i3 - 1) === 61) {
            inQuotes = true;
          } else if (end === -1 && tokenChars[code] === 1) {
            if (start === -1)
              start = i3;
          } else if (start !== -1 && (code === 32 || code === 9)) {
            if (end === -1)
              end = i3;
          } else if (code === 59 || code === 44) {
            if (start === -1) {
              throw new SyntaxError(`Unexpected character at index ${i3}`);
            }
            if (end === -1)
              end = i3;
            let value = header.slice(start, end);
            if (mustUnescape) {
              value = value.replace(/\\/g, "");
              mustUnescape = false;
            }
            push(params, paramName, value);
            if (code === 44) {
              push(offers, extensionName, params);
              params = Object.create(null);
              extensionName = void 0;
            }
            paramName = void 0;
            start = end = -1;
          } else {
            throw new SyntaxError(`Unexpected character at index ${i3}`);
          }
        }
      }
      if (start === -1 || inQuotes) {
        throw new SyntaxError("Unexpected end of input");
      }
      if (end === -1)
        end = i3;
      const token = header.slice(start, end);
      if (extensionName === void 0) {
        push(offers, token, params);
      } else {
        if (paramName === void 0) {
          push(params, token, true);
        } else if (mustUnescape) {
          push(params, paramName, token.replace(/\\/g, ""));
        } else {
          push(params, paramName, token);
        }
        push(offers, extensionName, params);
      }
      return offers;
    }
    function format(extensions) {
      return Object.keys(extensions).map((extension) => {
        let configurations = extensions[extension];
        if (!Array.isArray(configurations))
          configurations = [configurations];
        return configurations.map((params) => {
          return [extension].concat(Object.keys(params).map((k) => {
            let values = params[k];
            if (!Array.isArray(values))
              values = [values];
            return values.map((v) => v === true ? k : `${k}=${v}`).join("; ");
          })).join("; ");
        }).join(", ");
      }).join(", ");
    }
    module2.exports = { format, parse };
  }
});

// node_modules/ws/lib/websocket.js
var require_websocket = __commonJS({
  "node_modules/ws/lib/websocket.js"(exports2, module2) {
    "use strict";
    var EventEmitter = require("events");
    var https = require("https");
    var http = require("http");
    var net = require("net");
    var tls = require("tls");
    var { randomBytes, createHash } = require("crypto");
    var { Readable } = require("stream");
    var { URL } = require("url");
    var PerMessageDeflate = require_permessage_deflate();
    var Receiver = require_receiver();
    var Sender = require_sender();
    var {
      BINARY_TYPES,
      EMPTY_BUFFER,
      GUID,
      kStatusCode,
      kWebSocket,
      NOOP
    } = require_constants();
    var { addEventListener, removeEventListener } = require_event_target();
    var { format, parse } = require_extension();
    var { toBuffer } = require_buffer_util();
    var readyStates = ["CONNECTING", "OPEN", "CLOSING", "CLOSED"];
    var protocolVersions = [8, 13];
    var closeTimeout = 30 * 1e3;
    var WebSocket = class extends EventEmitter {
      constructor(address, protocols, options) {
        super();
        this._binaryType = BINARY_TYPES[0];
        this._closeCode = 1006;
        this._closeFrameReceived = false;
        this._closeFrameSent = false;
        this._closeMessage = "";
        this._closeTimer = null;
        this._extensions = {};
        this._protocol = "";
        this._readyState = WebSocket.CONNECTING;
        this._receiver = null;
        this._sender = null;
        this._socket = null;
        if (address !== null) {
          this._bufferedAmount = 0;
          this._isServer = false;
          this._redirects = 0;
          if (Array.isArray(protocols)) {
            protocols = protocols.join(", ");
          } else if (typeof protocols === "object" && protocols !== null) {
            options = protocols;
            protocols = void 0;
          }
          initAsClient(this, address, protocols, options);
        } else {
          this._isServer = true;
        }
      }
      get binaryType() {
        return this._binaryType;
      }
      set binaryType(type3) {
        if (!BINARY_TYPES.includes(type3))
          return;
        this._binaryType = type3;
        if (this._receiver)
          this._receiver._binaryType = type3;
      }
      get bufferedAmount() {
        if (!this._socket)
          return this._bufferedAmount;
        return this._socket._writableState.length + this._sender._bufferedBytes;
      }
      get extensions() {
        return Object.keys(this._extensions).join();
      }
      get onclose() {
        return void 0;
      }
      set onclose(listener) {
      }
      get onerror() {
        return void 0;
      }
      set onerror(listener) {
      }
      get onopen() {
        return void 0;
      }
      set onopen(listener) {
      }
      get onmessage() {
        return void 0;
      }
      set onmessage(listener) {
      }
      get protocol() {
        return this._protocol;
      }
      get readyState() {
        return this._readyState;
      }
      get url() {
        return this._url;
      }
      setSocket(socket, head, maxPayload) {
        const receiver = new Receiver(this.binaryType, this._extensions, this._isServer, maxPayload);
        this._sender = new Sender(socket, this._extensions);
        this._receiver = receiver;
        this._socket = socket;
        receiver[kWebSocket] = this;
        socket[kWebSocket] = this;
        receiver.on("conclude", receiverOnConclude);
        receiver.on("drain", receiverOnDrain);
        receiver.on("error", receiverOnError);
        receiver.on("message", receiverOnMessage);
        receiver.on("ping", receiverOnPing);
        receiver.on("pong", receiverOnPong);
        socket.setTimeout(0);
        socket.setNoDelay();
        if (head.length > 0)
          socket.unshift(head);
        socket.on("close", socketOnClose);
        socket.on("data", socketOnData);
        socket.on("end", socketOnEnd);
        socket.on("error", socketOnError);
        this._readyState = WebSocket.OPEN;
        this.emit("open");
      }
      emitClose() {
        if (!this._socket) {
          this._readyState = WebSocket.CLOSED;
          this.emit("close", this._closeCode, this._closeMessage);
          return;
        }
        if (this._extensions[PerMessageDeflate.extensionName]) {
          this._extensions[PerMessageDeflate.extensionName].cleanup();
        }
        this._receiver.removeAllListeners();
        this._readyState = WebSocket.CLOSED;
        this.emit("close", this._closeCode, this._closeMessage);
      }
      close(code, data) {
        if (this.readyState === WebSocket.CLOSED)
          return;
        if (this.readyState === WebSocket.CONNECTING) {
          const msg = "WebSocket was closed before the connection was established";
          return abortHandshake(this, this._req, msg);
        }
        if (this.readyState === WebSocket.CLOSING) {
          if (this._closeFrameSent && (this._closeFrameReceived || this._receiver._writableState.errorEmitted)) {
            this._socket.end();
          }
          return;
        }
        this._readyState = WebSocket.CLOSING;
        this._sender.close(code, data, !this._isServer, (err2) => {
          if (err2)
            return;
          this._closeFrameSent = true;
          if (this._closeFrameReceived || this._receiver._writableState.errorEmitted) {
            this._socket.end();
          }
        });
        this._closeTimer = setTimeout(this._socket.destroy.bind(this._socket), closeTimeout);
      }
      ping(data, mask2, cb2) {
        if (this.readyState === WebSocket.CONNECTING) {
          throw new Error("WebSocket is not open: readyState 0 (CONNECTING)");
        }
        if (typeof data === "function") {
          cb2 = data;
          data = mask2 = void 0;
        } else if (typeof mask2 === "function") {
          cb2 = mask2;
          mask2 = void 0;
        }
        if (typeof data === "number")
          data = data.toString();
        if (this.readyState !== WebSocket.OPEN) {
          sendAfterClose(this, data, cb2);
          return;
        }
        if (mask2 === void 0)
          mask2 = !this._isServer;
        this._sender.ping(data || EMPTY_BUFFER, mask2, cb2);
      }
      pong(data, mask2, cb2) {
        if (this.readyState === WebSocket.CONNECTING) {
          throw new Error("WebSocket is not open: readyState 0 (CONNECTING)");
        }
        if (typeof data === "function") {
          cb2 = data;
          data = mask2 = void 0;
        } else if (typeof mask2 === "function") {
          cb2 = mask2;
          mask2 = void 0;
        }
        if (typeof data === "number")
          data = data.toString();
        if (this.readyState !== WebSocket.OPEN) {
          sendAfterClose(this, data, cb2);
          return;
        }
        if (mask2 === void 0)
          mask2 = !this._isServer;
        this._sender.pong(data || EMPTY_BUFFER, mask2, cb2);
      }
      send(data, options, cb2) {
        if (this.readyState === WebSocket.CONNECTING) {
          throw new Error("WebSocket is not open: readyState 0 (CONNECTING)");
        }
        if (typeof options === "function") {
          cb2 = options;
          options = {};
        }
        if (typeof data === "number")
          data = data.toString();
        if (this.readyState !== WebSocket.OPEN) {
          sendAfterClose(this, data, cb2);
          return;
        }
        const opts = __spreadValues({
          binary: typeof data !== "string",
          mask: !this._isServer,
          compress: true,
          fin: true
        }, options);
        if (!this._extensions[PerMessageDeflate.extensionName]) {
          opts.compress = false;
        }
        this._sender.send(data || EMPTY_BUFFER, opts, cb2);
      }
      terminate() {
        if (this.readyState === WebSocket.CLOSED)
          return;
        if (this.readyState === WebSocket.CONNECTING) {
          const msg = "WebSocket was closed before the connection was established";
          return abortHandshake(this, this._req, msg);
        }
        if (this._socket) {
          this._readyState = WebSocket.CLOSING;
          this._socket.destroy();
        }
      }
    };
    Object.defineProperty(WebSocket, "CONNECTING", {
      enumerable: true,
      value: readyStates.indexOf("CONNECTING")
    });
    Object.defineProperty(WebSocket.prototype, "CONNECTING", {
      enumerable: true,
      value: readyStates.indexOf("CONNECTING")
    });
    Object.defineProperty(WebSocket, "OPEN", {
      enumerable: true,
      value: readyStates.indexOf("OPEN")
    });
    Object.defineProperty(WebSocket.prototype, "OPEN", {
      enumerable: true,
      value: readyStates.indexOf("OPEN")
    });
    Object.defineProperty(WebSocket, "CLOSING", {
      enumerable: true,
      value: readyStates.indexOf("CLOSING")
    });
    Object.defineProperty(WebSocket.prototype, "CLOSING", {
      enumerable: true,
      value: readyStates.indexOf("CLOSING")
    });
    Object.defineProperty(WebSocket, "CLOSED", {
      enumerable: true,
      value: readyStates.indexOf("CLOSED")
    });
    Object.defineProperty(WebSocket.prototype, "CLOSED", {
      enumerable: true,
      value: readyStates.indexOf("CLOSED")
    });
    [
      "binaryType",
      "bufferedAmount",
      "extensions",
      "protocol",
      "readyState",
      "url"
    ].forEach((property) => {
      Object.defineProperty(WebSocket.prototype, property, { enumerable: true });
    });
    ["open", "error", "close", "message"].forEach((method) => {
      Object.defineProperty(WebSocket.prototype, `on${method}`, {
        enumerable: true,
        get() {
          const listeners = this.listeners(method);
          for (let i3 = 0; i3 < listeners.length; i3++) {
            if (listeners[i3]._listener)
              return listeners[i3]._listener;
          }
          return void 0;
        },
        set(listener) {
          const listeners = this.listeners(method);
          for (let i3 = 0; i3 < listeners.length; i3++) {
            if (listeners[i3]._listener)
              this.removeListener(method, listeners[i3]);
          }
          this.addEventListener(method, listener);
        }
      });
    });
    WebSocket.prototype.addEventListener = addEventListener;
    WebSocket.prototype.removeEventListener = removeEventListener;
    module2.exports = WebSocket;
    function initAsClient(websocket, address, protocols, options) {
      const opts = __spreadProps(__spreadValues({
        protocolVersion: protocolVersions[1],
        maxPayload: 100 * 1024 * 1024,
        perMessageDeflate: true,
        followRedirects: false,
        maxRedirects: 10
      }, options), {
        createConnection: void 0,
        socketPath: void 0,
        hostname: void 0,
        protocol: void 0,
        timeout: void 0,
        method: void 0,
        host: void 0,
        path: void 0,
        port: void 0
      });
      if (!protocolVersions.includes(opts.protocolVersion)) {
        throw new RangeError(`Unsupported protocol version: ${opts.protocolVersion} (supported versions: ${protocolVersions.join(", ")})`);
      }
      let parsedUrl;
      if (address instanceof URL) {
        parsedUrl = address;
        websocket._url = address.href;
      } else {
        parsedUrl = new URL(address);
        websocket._url = address;
      }
      const isUnixSocket = parsedUrl.protocol === "ws+unix:";
      if (!parsedUrl.host && (!isUnixSocket || !parsedUrl.pathname)) {
        throw new Error(`Invalid URL: ${websocket.url}`);
      }
      const isSecure = parsedUrl.protocol === "wss:" || parsedUrl.protocol === "https:";
      const defaultPort = isSecure ? 443 : 80;
      const key2 = randomBytes(16).toString("base64");
      const get = isSecure ? https.get : http.get;
      let perMessageDeflate;
      opts.createConnection = isSecure ? tlsConnect : netConnect;
      opts.defaultPort = opts.defaultPort || defaultPort;
      opts.port = parsedUrl.port || defaultPort;
      opts.host = parsedUrl.hostname.startsWith("[") ? parsedUrl.hostname.slice(1, -1) : parsedUrl.hostname;
      opts.headers = __spreadValues({
        "Sec-WebSocket-Version": opts.protocolVersion,
        "Sec-WebSocket-Key": key2,
        Connection: "Upgrade",
        Upgrade: "websocket"
      }, opts.headers);
      opts.path = parsedUrl.pathname + parsedUrl.search;
      opts.timeout = opts.handshakeTimeout;
      if (opts.perMessageDeflate) {
        perMessageDeflate = new PerMessageDeflate(opts.perMessageDeflate !== true ? opts.perMessageDeflate : {}, false, opts.maxPayload);
        opts.headers["Sec-WebSocket-Extensions"] = format({
          [PerMessageDeflate.extensionName]: perMessageDeflate.offer()
        });
      }
      if (protocols) {
        opts.headers["Sec-WebSocket-Protocol"] = protocols;
      }
      if (opts.origin) {
        if (opts.protocolVersion < 13) {
          opts.headers["Sec-WebSocket-Origin"] = opts.origin;
        } else {
          opts.headers.Origin = opts.origin;
        }
      }
      if (parsedUrl.username || parsedUrl.password) {
        opts.auth = `${parsedUrl.username}:${parsedUrl.password}`;
      }
      if (isUnixSocket) {
        const parts = opts.path.split(":");
        opts.socketPath = parts[0];
        opts.path = parts[1];
      }
      let req = websocket._req = get(opts);
      if (opts.timeout) {
        req.on("timeout", () => {
          abortHandshake(websocket, req, "Opening handshake has timed out");
        });
      }
      req.on("error", (err2) => {
        if (req === null || req.aborted)
          return;
        req = websocket._req = null;
        websocket._readyState = WebSocket.CLOSING;
        websocket.emit("error", err2);
        websocket.emitClose();
      });
      req.on("response", (res) => {
        const location = res.headers.location;
        const statusCode = res.statusCode;
        if (location && opts.followRedirects && statusCode >= 300 && statusCode < 400) {
          if (++websocket._redirects > opts.maxRedirects) {
            abortHandshake(websocket, req, "Maximum redirects exceeded");
            return;
          }
          req.abort();
          const addr = new URL(location, address);
          initAsClient(websocket, addr, protocols, options);
        } else if (!websocket.emit("unexpected-response", req, res)) {
          abortHandshake(websocket, req, `Unexpected server response: ${res.statusCode}`);
        }
      });
      req.on("upgrade", (res, socket, head) => {
        websocket.emit("upgrade", res);
        if (websocket.readyState !== WebSocket.CONNECTING)
          return;
        req = websocket._req = null;
        const digest = createHash("sha1").update(key2 + GUID).digest("base64");
        if (res.headers["sec-websocket-accept"] !== digest) {
          abortHandshake(websocket, socket, "Invalid Sec-WebSocket-Accept header");
          return;
        }
        const serverProt = res.headers["sec-websocket-protocol"];
        const protList = (protocols || "").split(/, */);
        let protError;
        if (!protocols && serverProt) {
          protError = "Server sent a subprotocol but none was requested";
        } else if (protocols && !serverProt) {
          protError = "Server sent no subprotocol";
        } else if (serverProt && !protList.includes(serverProt)) {
          protError = "Server sent an invalid subprotocol";
        }
        if (protError) {
          abortHandshake(websocket, socket, protError);
          return;
        }
        if (serverProt)
          websocket._protocol = serverProt;
        const secWebSocketExtensions = res.headers["sec-websocket-extensions"];
        if (secWebSocketExtensions !== void 0) {
          if (!perMessageDeflate) {
            const message = "Server sent a Sec-WebSocket-Extensions header but no extension was requested";
            abortHandshake(websocket, socket, message);
            return;
          }
          let extensions;
          try {
            extensions = parse(secWebSocketExtensions);
          } catch (err2) {
            const message = "Invalid Sec-WebSocket-Extensions header";
            abortHandshake(websocket, socket, message);
            return;
          }
          const extensionNames = Object.keys(extensions);
          if (extensionNames.length) {
            if (extensionNames.length !== 1 || extensionNames[0] !== PerMessageDeflate.extensionName) {
              const message = "Server indicated an extension that was not requested";
              abortHandshake(websocket, socket, message);
              return;
            }
            try {
              perMessageDeflate.accept(extensions[PerMessageDeflate.extensionName]);
            } catch (err2) {
              const message = "Invalid Sec-WebSocket-Extensions header";
              abortHandshake(websocket, socket, message);
              return;
            }
            websocket._extensions[PerMessageDeflate.extensionName] = perMessageDeflate;
          }
        }
        websocket.setSocket(socket, head, opts.maxPayload);
      });
    }
    function netConnect(options) {
      options.path = options.socketPath;
      return net.connect(options);
    }
    function tlsConnect(options) {
      options.path = void 0;
      if (!options.servername && options.servername !== "") {
        options.servername = net.isIP(options.host) ? "" : options.host;
      }
      return tls.connect(options);
    }
    function abortHandshake(websocket, stream, message) {
      websocket._readyState = WebSocket.CLOSING;
      const err2 = new Error(message);
      Error.captureStackTrace(err2, abortHandshake);
      if (stream.setHeader) {
        stream.abort();
        if (stream.socket && !stream.socket.destroyed) {
          stream.socket.destroy();
        }
        stream.once("abort", websocket.emitClose.bind(websocket));
        websocket.emit("error", err2);
      } else {
        stream.destroy(err2);
        stream.once("error", websocket.emit.bind(websocket, "error"));
        stream.once("close", websocket.emitClose.bind(websocket));
      }
    }
    function sendAfterClose(websocket, data, cb2) {
      if (data) {
        const length = toBuffer(data).length;
        if (websocket._socket)
          websocket._sender._bufferedBytes += length;
        else
          websocket._bufferedAmount += length;
      }
      if (cb2) {
        const err2 = new Error(`WebSocket is not open: readyState ${websocket.readyState} (${readyStates[websocket.readyState]})`);
        cb2(err2);
      }
    }
    function receiverOnConclude(code, reason) {
      const websocket = this[kWebSocket];
      websocket._closeFrameReceived = true;
      websocket._closeMessage = reason;
      websocket._closeCode = code;
      if (websocket._socket[kWebSocket] === void 0)
        return;
      websocket._socket.removeListener("data", socketOnData);
      process.nextTick(resume, websocket._socket);
      if (code === 1005)
        websocket.close();
      else
        websocket.close(code, reason);
    }
    function receiverOnDrain() {
      this[kWebSocket]._socket.resume();
    }
    function receiverOnError(err2) {
      const websocket = this[kWebSocket];
      if (websocket._socket[kWebSocket] !== void 0) {
        websocket._socket.removeListener("data", socketOnData);
        process.nextTick(resume, websocket._socket);
        websocket.close(err2[kStatusCode]);
      }
      websocket.emit("error", err2);
    }
    function receiverOnFinish() {
      this[kWebSocket].emitClose();
    }
    function receiverOnMessage(data) {
      this[kWebSocket].emit("message", data);
    }
    function receiverOnPing(data) {
      const websocket = this[kWebSocket];
      websocket.pong(data, !websocket._isServer, NOOP);
      websocket.emit("ping", data);
    }
    function receiverOnPong(data) {
      this[kWebSocket].emit("pong", data);
    }
    function resume(stream) {
      stream.resume();
    }
    function socketOnClose() {
      const websocket = this[kWebSocket];
      this.removeListener("close", socketOnClose);
      this.removeListener("data", socketOnData);
      this.removeListener("end", socketOnEnd);
      websocket._readyState = WebSocket.CLOSING;
      let chunk;
      if (!this._readableState.endEmitted && !websocket._closeFrameReceived && !websocket._receiver._writableState.errorEmitted && (chunk = websocket._socket.read()) !== null) {
        websocket._receiver.write(chunk);
      }
      websocket._receiver.end();
      this[kWebSocket] = void 0;
      clearTimeout(websocket._closeTimer);
      if (websocket._receiver._writableState.finished || websocket._receiver._writableState.errorEmitted) {
        websocket.emitClose();
      } else {
        websocket._receiver.on("error", receiverOnFinish);
        websocket._receiver.on("finish", receiverOnFinish);
      }
    }
    function socketOnData(chunk) {
      if (!this[kWebSocket]._receiver.write(chunk)) {
        this.pause();
      }
    }
    function socketOnEnd() {
      const websocket = this[kWebSocket];
      websocket._readyState = WebSocket.CLOSING;
      websocket._receiver.end();
      this.end();
    }
    function socketOnError() {
      const websocket = this[kWebSocket];
      this.removeListener("error", socketOnError);
      this.on("error", NOOP);
      if (websocket) {
        websocket._readyState = WebSocket.CLOSING;
        this.destroy();
      }
    }
  }
});

// node_modules/ws/lib/stream.js
var require_stream = __commonJS({
  "node_modules/ws/lib/stream.js"(exports2, module2) {
    "use strict";
    var { Duplex } = require("stream");
    function emitClose(stream) {
      stream.emit("close");
    }
    function duplexOnEnd() {
      if (!this.destroyed && this._writableState.finished) {
        this.destroy();
      }
    }
    function duplexOnError(err2) {
      this.removeListener("error", duplexOnError);
      this.destroy();
      if (this.listenerCount("error") === 0) {
        this.emit("error", err2);
      }
    }
    function createWebSocketStream(ws, options) {
      let resumeOnReceiverDrain = true;
      let terminateOnDestroy = true;
      function receiverOnDrain() {
        if (resumeOnReceiverDrain)
          ws._socket.resume();
      }
      if (ws.readyState === ws.CONNECTING) {
        ws.once("open", function open() {
          ws._receiver.removeAllListeners("drain");
          ws._receiver.on("drain", receiverOnDrain);
        });
      } else {
        ws._receiver.removeAllListeners("drain");
        ws._receiver.on("drain", receiverOnDrain);
      }
      const duplex = new Duplex(__spreadProps(__spreadValues({}, options), {
        autoDestroy: false,
        emitClose: false,
        objectMode: false,
        writableObjectMode: false
      }));
      ws.on("message", function message(msg) {
        if (!duplex.push(msg)) {
          resumeOnReceiverDrain = false;
          ws._socket.pause();
        }
      });
      ws.once("error", function error(err2) {
        if (duplex.destroyed)
          return;
        terminateOnDestroy = false;
        duplex.destroy(err2);
      });
      ws.once("close", function close() {
        if (duplex.destroyed)
          return;
        duplex.push(null);
      });
      duplex._destroy = function(err2, callback) {
        if (ws.readyState === ws.CLOSED) {
          callback(err2);
          process.nextTick(emitClose, duplex);
          return;
        }
        let called = false;
        ws.once("error", function error(err3) {
          called = true;
          callback(err3);
        });
        ws.once("close", function close() {
          if (!called)
            callback(err2);
          process.nextTick(emitClose, duplex);
        });
        if (terminateOnDestroy)
          ws.terminate();
      };
      duplex._final = function(callback) {
        if (ws.readyState === ws.CONNECTING) {
          ws.once("open", function open() {
            duplex._final(callback);
          });
          return;
        }
        if (ws._socket === null)
          return;
        if (ws._socket._writableState.finished) {
          callback();
          if (duplex._readableState.endEmitted)
            duplex.destroy();
        } else {
          ws._socket.once("finish", function finish() {
            callback();
          });
          ws.close();
        }
      };
      duplex._read = function() {
        if (ws.readyState === ws.OPEN && !resumeOnReceiverDrain) {
          resumeOnReceiverDrain = true;
          if (!ws._receiver._writableState.needDrain)
            ws._socket.resume();
        }
      };
      duplex._write = function(chunk, encoding, callback) {
        if (ws.readyState === ws.CONNECTING) {
          ws.once("open", function open() {
            duplex._write(chunk, encoding, callback);
          });
          return;
        }
        ws.send(chunk, callback);
      };
      duplex.on("end", duplexOnEnd);
      duplex.on("error", duplexOnError);
      return duplex;
    }
    module2.exports = createWebSocketStream;
  }
});

// node_modules/ws/lib/websocket-server.js
var require_websocket_server = __commonJS({
  "node_modules/ws/lib/websocket-server.js"(exports2, module2) {
    "use strict";
    var EventEmitter = require("events");
    var http = require("http");
    var https = require("https");
    var net = require("net");
    var tls = require("tls");
    var { createHash } = require("crypto");
    var PerMessageDeflate = require_permessage_deflate();
    var WebSocket = require_websocket();
    var { format, parse } = require_extension();
    var { GUID, kWebSocket } = require_constants();
    var keyRegex = /^[+/0-9A-Za-z]{22}==$/;
    var RUNNING = 0;
    var CLOSING = 1;
    var CLOSED = 2;
    var WebSocketServer = class extends EventEmitter {
      constructor(options, callback) {
        super();
        options = __spreadValues({
          maxPayload: 100 * 1024 * 1024,
          perMessageDeflate: false,
          handleProtocols: null,
          clientTracking: true,
          verifyClient: null,
          noServer: false,
          backlog: null,
          server: null,
          host: null,
          path: null,
          port: null
        }, options);
        if (options.port == null && !options.server && !options.noServer || options.port != null && (options.server || options.noServer) || options.server && options.noServer) {
          throw new TypeError('One and only one of the "port", "server", or "noServer" options must be specified');
        }
        if (options.port != null) {
          this._server = http.createServer((req, res) => {
            const body = http.STATUS_CODES[426];
            res.writeHead(426, {
              "Content-Length": body.length,
              "Content-Type": "text/plain"
            });
            res.end(body);
          });
          this._server.listen(options.port, options.host, options.backlog, callback);
        } else if (options.server) {
          this._server = options.server;
        }
        if (this._server) {
          const emitConnection = this.emit.bind(this, "connection");
          this._removeListeners = addListeners(this._server, {
            listening: this.emit.bind(this, "listening"),
            error: this.emit.bind(this, "error"),
            upgrade: (req, socket, head) => {
              this.handleUpgrade(req, socket, head, emitConnection);
            }
          });
        }
        if (options.perMessageDeflate === true)
          options.perMessageDeflate = {};
        if (options.clientTracking)
          this.clients = /* @__PURE__ */ new Set();
        this.options = options;
        this._state = RUNNING;
      }
      address() {
        if (this.options.noServer) {
          throw new Error('The server is operating in "noServer" mode');
        }
        if (!this._server)
          return null;
        return this._server.address();
      }
      close(cb2) {
        if (cb2)
          this.once("close", cb2);
        if (this._state === CLOSED) {
          process.nextTick(emitClose, this);
          return;
        }
        if (this._state === CLOSING)
          return;
        this._state = CLOSING;
        if (this.clients) {
          for (const client of this.clients)
            client.terminate();
        }
        const server = this._server;
        if (server) {
          this._removeListeners();
          this._removeListeners = this._server = null;
          if (this.options.port != null) {
            server.close(emitClose.bind(void 0, this));
            return;
          }
        }
        process.nextTick(emitClose, this);
      }
      shouldHandle(req) {
        if (this.options.path) {
          const index = req.url.indexOf("?");
          const pathname = index !== -1 ? req.url.slice(0, index) : req.url;
          if (pathname !== this.options.path)
            return false;
        }
        return true;
      }
      handleUpgrade(req, socket, head, cb2) {
        socket.on("error", socketOnError);
        const key2 = req.headers["sec-websocket-key"] !== void 0 ? req.headers["sec-websocket-key"].trim() : false;
        const version = +req.headers["sec-websocket-version"];
        const extensions = {};
        if (req.method !== "GET" || req.headers.upgrade.toLowerCase() !== "websocket" || !key2 || !keyRegex.test(key2) || version !== 8 && version !== 13 || !this.shouldHandle(req)) {
          return abortHandshake(socket, 400);
        }
        if (this.options.perMessageDeflate) {
          const perMessageDeflate = new PerMessageDeflate(this.options.perMessageDeflate, true, this.options.maxPayload);
          try {
            const offers = parse(req.headers["sec-websocket-extensions"]);
            if (offers[PerMessageDeflate.extensionName]) {
              perMessageDeflate.accept(offers[PerMessageDeflate.extensionName]);
              extensions[PerMessageDeflate.extensionName] = perMessageDeflate;
            }
          } catch (err2) {
            return abortHandshake(socket, 400);
          }
        }
        if (this.options.verifyClient) {
          const info = {
            origin: req.headers[`${version === 8 ? "sec-websocket-origin" : "origin"}`],
            secure: !!(req.socket.authorized || req.socket.encrypted),
            req
          };
          if (this.options.verifyClient.length === 2) {
            this.options.verifyClient(info, (verified, code, message, headers) => {
              if (!verified) {
                return abortHandshake(socket, code || 401, message, headers);
              }
              this.completeUpgrade(key2, extensions, req, socket, head, cb2);
            });
            return;
          }
          if (!this.options.verifyClient(info))
            return abortHandshake(socket, 401);
        }
        this.completeUpgrade(key2, extensions, req, socket, head, cb2);
      }
      completeUpgrade(key2, extensions, req, socket, head, cb2) {
        if (!socket.readable || !socket.writable)
          return socket.destroy();
        if (socket[kWebSocket]) {
          throw new Error("server.handleUpgrade() was called more than once with the same socket, possibly due to a misconfiguration");
        }
        if (this._state > RUNNING)
          return abortHandshake(socket, 503);
        const digest = createHash("sha1").update(key2 + GUID).digest("base64");
        const headers = [
          "HTTP/1.1 101 Switching Protocols",
          "Upgrade: websocket",
          "Connection: Upgrade",
          `Sec-WebSocket-Accept: ${digest}`
        ];
        const ws = new WebSocket(null);
        let protocol = req.headers["sec-websocket-protocol"];
        if (protocol) {
          protocol = protocol.split(",").map(trim);
          if (this.options.handleProtocols) {
            protocol = this.options.handleProtocols(protocol, req);
          } else {
            protocol = protocol[0];
          }
          if (protocol) {
            headers.push(`Sec-WebSocket-Protocol: ${protocol}`);
            ws._protocol = protocol;
          }
        }
        if (extensions[PerMessageDeflate.extensionName]) {
          const params = extensions[PerMessageDeflate.extensionName].params;
          const value = format({
            [PerMessageDeflate.extensionName]: [params]
          });
          headers.push(`Sec-WebSocket-Extensions: ${value}`);
          ws._extensions = extensions;
        }
        this.emit("headers", headers, req);
        socket.write(headers.concat("\r\n").join("\r\n"));
        socket.removeListener("error", socketOnError);
        ws.setSocket(socket, head, this.options.maxPayload);
        if (this.clients) {
          this.clients.add(ws);
          ws.on("close", () => this.clients.delete(ws));
        }
        cb2(ws, req);
      }
    };
    module2.exports = WebSocketServer;
    function addListeners(server, map2) {
      for (const event2 of Object.keys(map2))
        server.on(event2, map2[event2]);
      return function removeListeners() {
        for (const event2 of Object.keys(map2)) {
          server.removeListener(event2, map2[event2]);
        }
      };
    }
    function emitClose(server) {
      server._state = CLOSED;
      server.emit("close");
    }
    function socketOnError() {
      this.destroy();
    }
    function abortHandshake(socket, code, message, headers) {
      if (socket.writable) {
        message = message || http.STATUS_CODES[code];
        headers = __spreadValues({
          Connection: "close",
          "Content-Type": "text/html",
          "Content-Length": Buffer.byteLength(message)
        }, headers);
        socket.write(`HTTP/1.1 ${code} ${http.STATUS_CODES[code]}\r
` + Object.keys(headers).map((h) => `${h}: ${headers[h]}`).join("\r\n") + "\r\n\r\n" + message);
      }
      socket.removeListener("error", socketOnError);
      socket.destroy();
    }
    function trim(str2) {
      return str2.trim();
    }
  }
});

// node_modules/ws/index.js
var require_ws = __commonJS({
  "node_modules/ws/index.js"(exports2, module2) {
    "use strict";
    var WebSocket = require_websocket();
    WebSocket.createWebSocketStream = require_stream();
    WebSocket.Server = require_websocket_server();
    WebSocket.Receiver = require_receiver();
    WebSocket.Sender = require_sender();
    module2.exports = WebSocket;
  }
});

// node_modules/ink/build/devtools-window-polyfill.js
var require_devtools_window_polyfill = __commonJS({
  "node_modules/ink/build/devtools-window-polyfill.js"(exports2) {
    "use strict";
    var __importDefault = exports2 && exports2.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { "default": mod };
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    var ws_1 = __importDefault(require_ws());
    var customGlobal = global;
    if (!customGlobal.WebSocket) {
      customGlobal.WebSocket = ws_1.default;
    }
    if (!customGlobal.window) {
      customGlobal.window = global;
    }
    customGlobal.window.__REACT_DEVTOOLS_COMPONENT_FILTERS__ = [
      {
        type: 1,
        value: 7,
        isEnabled: true
      },
      {
        type: 2,
        value: "InternalApp",
        isEnabled: true,
        isValid: true
      },
      {
        type: 2,
        value: "InternalAppContext",
        isEnabled: true,
        isValid: true
      },
      {
        type: 2,
        value: "InternalStdoutContext",
        isEnabled: true,
        isValid: true
      },
      {
        type: 2,
        value: "InternalStderrContext",
        isEnabled: true,
        isValid: true
      },
      {
        type: 2,
        value: "InternalStdinContext",
        isEnabled: true,
        isValid: true
      },
      {
        type: 2,
        value: "InternalFocusContext",
        isEnabled: true,
        isValid: true
      }
    ];
  }
});

// node_modules/react-devtools-core/dist/backend.js
var require_backend = __commonJS({
  "node_modules/react-devtools-core/dist/backend.js"(exports2, module2) {
    (function webpackUniversalModuleDefinition(root, factory) {
      if (typeof exports2 === "object" && typeof module2 === "object")
        module2.exports = factory();
      else if (typeof define === "function" && define.amd)
        define([], factory);
      else if (typeof exports2 === "object")
        exports2["ReactDevToolsBackend"] = factory();
      else
        root["ReactDevToolsBackend"] = factory();
    })(window, function() {
      return function(modules) {
        var installedModules = {};
        function __webpack_require__(moduleId) {
          if (installedModules[moduleId]) {
            return installedModules[moduleId].exports;
          }
          var module3 = installedModules[moduleId] = {
            i: moduleId,
            l: false,
            exports: {}
          };
          modules[moduleId].call(module3.exports, module3, module3.exports, __webpack_require__);
          module3.l = true;
          return module3.exports;
        }
        __webpack_require__.m = modules;
        __webpack_require__.c = installedModules;
        __webpack_require__.d = function(exports3, name, getter) {
          if (!__webpack_require__.o(exports3, name)) {
            Object.defineProperty(exports3, name, { enumerable: true, get: getter });
          }
        };
        __webpack_require__.r = function(exports3) {
          if (typeof Symbol !== "undefined" && Symbol.toStringTag) {
            Object.defineProperty(exports3, Symbol.toStringTag, { value: "Module" });
          }
          Object.defineProperty(exports3, "__esModule", { value: true });
        };
        __webpack_require__.t = function(value, mode) {
          if (mode & 1)
            value = __webpack_require__(value);
          if (mode & 8)
            return value;
          if (mode & 4 && typeof value === "object" && value && value.__esModule)
            return value;
          var ns = Object.create(null);
          __webpack_require__.r(ns);
          Object.defineProperty(ns, "default", { enumerable: true, value });
          if (mode & 2 && typeof value != "string")
            for (var key2 in value)
              __webpack_require__.d(ns, key2, function(key3) {
                return value[key3];
              }.bind(null, key2));
          return ns;
        };
        __webpack_require__.n = function(module3) {
          var getter = module3 && module3.__esModule ? function getDefault() {
            return module3["default"];
          } : function getModuleExports() {
            return module3;
          };
          __webpack_require__.d(getter, "a", getter);
          return getter;
        };
        __webpack_require__.o = function(object, property) {
          return Object.prototype.hasOwnProperty.call(object, property);
        };
        __webpack_require__.p = "";
        return __webpack_require__(__webpack_require__.s = 31);
      }([
        function(module3, __webpack_exports__, __webpack_require__) {
          "use strict";
          __webpack_require__.d(__webpack_exports__, "o", function() {
            return __DEBUG__;
          });
          __webpack_require__.d(__webpack_exports__, "i", function() {
            return TREE_OPERATION_ADD;
          });
          __webpack_require__.d(__webpack_exports__, "j", function() {
            return TREE_OPERATION_REMOVE;
          });
          __webpack_require__.d(__webpack_exports__, "l", function() {
            return TREE_OPERATION_REORDER_CHILDREN;
          });
          __webpack_require__.d(__webpack_exports__, "n", function() {
            return TREE_OPERATION_UPDATE_TREE_BASE_DURATION;
          });
          __webpack_require__.d(__webpack_exports__, "m", function() {
            return TREE_OPERATION_UPDATE_ERRORS_OR_WARNINGS;
          });
          __webpack_require__.d(__webpack_exports__, "k", function() {
            return TREE_OPERATION_REMOVE_ROOT;
          });
          __webpack_require__.d(__webpack_exports__, "a", function() {
            return LOCAL_STORAGE_FILTER_PREFERENCES_KEY;
          });
          __webpack_require__.d(__webpack_exports__, "f", function() {
            return SESSION_STORAGE_LAST_SELECTION_KEY;
          });
          __webpack_require__.d(__webpack_exports__, "g", function() {
            return SESSION_STORAGE_RECORD_CHANGE_DESCRIPTIONS_KEY;
          });
          __webpack_require__.d(__webpack_exports__, "h", function() {
            return SESSION_STORAGE_RELOAD_AND_PROFILE_KEY;
          });
          __webpack_require__.d(__webpack_exports__, "c", function() {
            return LOCAL_STORAGE_SHOULD_BREAK_ON_CONSOLE_ERRORS;
          });
          __webpack_require__.d(__webpack_exports__, "d", function() {
            return LOCAL_STORAGE_SHOULD_PATCH_CONSOLE_KEY;
          });
          __webpack_require__.d(__webpack_exports__, "e", function() {
            return LOCAL_STORAGE_SHOW_INLINE_WARNINGS_AND_ERRORS_KEY;
          });
          __webpack_require__.d(__webpack_exports__, "b", function() {
            return LOCAL_STORAGE_HIDE_CONSOLE_LOGS_IN_STRICT_MODE;
          });
          var __DEBUG__ = false;
          var __PERFORMANCE_PROFILE__ = false;
          var TREE_OPERATION_ADD = 1;
          var TREE_OPERATION_REMOVE = 2;
          var TREE_OPERATION_REORDER_CHILDREN = 3;
          var TREE_OPERATION_UPDATE_TREE_BASE_DURATION = 4;
          var TREE_OPERATION_UPDATE_ERRORS_OR_WARNINGS = 5;
          var TREE_OPERATION_REMOVE_ROOT = 6;
          var LOCAL_STORAGE_FILTER_PREFERENCES_KEY = "React::DevTools::componentFilters";
          var SESSION_STORAGE_LAST_SELECTION_KEY = "React::DevTools::lastSelection";
          var LOCAL_STORAGE_PARSE_HOOK_NAMES_KEY = "React::DevTools::parseHookNames";
          var SESSION_STORAGE_RECORD_CHANGE_DESCRIPTIONS_KEY = "React::DevTools::recordChangeDescriptions";
          var SESSION_STORAGE_RELOAD_AND_PROFILE_KEY = "React::DevTools::reloadAndProfile";
          var LOCAL_STORAGE_SHOULD_BREAK_ON_CONSOLE_ERRORS = "React::DevTools::breakOnConsoleErrors";
          var LOCAL_STORAGE_SHOULD_PATCH_CONSOLE_KEY = "React::DevTools::appendComponentStack";
          var LOCAL_STORAGE_SHOW_INLINE_WARNINGS_AND_ERRORS_KEY = "React::DevTools::showInlineWarningsAndErrors";
          var LOCAL_STORAGE_TRACE_UPDATES_ENABLED_KEY = "React::DevTools::traceUpdatesEnabled";
          var LOCAL_STORAGE_HIDE_CONSOLE_LOGS_IN_STRICT_MODE = "React::DevTools::hideConsoleLogsInStrictMode";
          var PROFILER_EXPORT_VERSION = 5;
          var CHANGE_LOG_URL = "https://github.com/facebook/react/blob/main/packages/react-devtools/CHANGELOG.md";
          var UNSUPPORTED_VERSION_URL = "https://reactjs.org/blog/2019/08/15/new-react-devtools.html#how-do-i-get-the-old-version-back";
          var REACT_DEVTOOLS_WORKPLACE_URL = "https://fburl.com/react-devtools-workplace-group";
          var THEME_STYLES = {
            light: {
              "--color-attribute-name": "#ef6632",
              "--color-attribute-name-not-editable": "#23272f",
              "--color-attribute-name-inverted": "rgba(255, 255, 255, 0.7)",
              "--color-attribute-value": "#1a1aa6",
              "--color-attribute-value-inverted": "#ffffff",
              "--color-attribute-editable-value": "#1a1aa6",
              "--color-background": "#ffffff",
              "--color-background-hover": "rgba(0, 136, 250, 0.1)",
              "--color-background-inactive": "#e5e5e5",
              "--color-background-invalid": "#fff0f0",
              "--color-background-selected": "#0088fa",
              "--color-button-background": "#ffffff",
              "--color-button-background-focus": "#ededed",
              "--color-button": "#5f6673",
              "--color-button-disabled": "#cfd1d5",
              "--color-button-active": "#0088fa",
              "--color-button-focus": "#23272f",
              "--color-button-hover": "#23272f",
              "--color-border": "#eeeeee",
              "--color-commit-did-not-render-fill": "#cfd1d5",
              "--color-commit-did-not-render-fill-text": "#000000",
              "--color-commit-did-not-render-pattern": "#cfd1d5",
              "--color-commit-did-not-render-pattern-text": "#333333",
              "--color-commit-gradient-0": "#37afa9",
              "--color-commit-gradient-1": "#63b19e",
              "--color-commit-gradient-2": "#80b393",
              "--color-commit-gradient-3": "#97b488",
              "--color-commit-gradient-4": "#abb67d",
              "--color-commit-gradient-5": "#beb771",
              "--color-commit-gradient-6": "#cfb965",
              "--color-commit-gradient-7": "#dfba57",
              "--color-commit-gradient-8": "#efbb49",
              "--color-commit-gradient-9": "#febc38",
              "--color-commit-gradient-text": "#000000",
              "--color-component-name": "#6a51b2",
              "--color-component-name-inverted": "#ffffff",
              "--color-component-badge-background": "rgba(0, 0, 0, 0.1)",
              "--color-component-badge-background-inverted": "rgba(255, 255, 255, 0.25)",
              "--color-component-badge-count": "#777d88",
              "--color-component-badge-count-inverted": "rgba(255, 255, 255, 0.7)",
              "--color-console-error-badge-text": "#ffffff",
              "--color-console-error-background": "#fff0f0",
              "--color-console-error-border": "#ffd6d6",
              "--color-console-error-icon": "#eb3941",
              "--color-console-error-text": "#fe2e31",
              "--color-console-warning-badge-text": "#000000",
              "--color-console-warning-background": "#fffbe5",
              "--color-console-warning-border": "#fff5c1",
              "--color-console-warning-icon": "#f4bd00",
              "--color-console-warning-text": "#64460c",
              "--color-context-background": "rgba(0,0,0,.9)",
              "--color-context-background-hover": "rgba(255, 255, 255, 0.1)",
              "--color-context-background-selected": "#178fb9",
              "--color-context-border": "#3d424a",
              "--color-context-text": "#ffffff",
              "--color-context-text-selected": "#ffffff",
              "--color-dim": "#777d88",
              "--color-dimmer": "#cfd1d5",
              "--color-dimmest": "#eff0f1",
              "--color-error-background": "hsl(0, 100%, 97%)",
              "--color-error-border": "hsl(0, 100%, 92%)",
              "--color-error-text": "#ff0000",
              "--color-expand-collapse-toggle": "#777d88",
              "--color-link": "#0000ff",
              "--color-modal-background": "rgba(255, 255, 255, 0.75)",
              "--color-bridge-version-npm-background": "#eff0f1",
              "--color-bridge-version-npm-text": "#000000",
              "--color-bridge-version-number": "#0088fa",
              "--color-primitive-hook-badge-background": "#e5e5e5",
              "--color-primitive-hook-badge-text": "#5f6673",
              "--color-record-active": "#fc3a4b",
              "--color-record-hover": "#3578e5",
              "--color-record-inactive": "#0088fa",
              "--color-resize-bar": "#eeeeee",
              "--color-resize-bar-active": "#dcdcdc",
              "--color-resize-bar-border": "#d1d1d1",
              "--color-resize-bar-dot": "#333333",
              "--color-scheduling-profiler-native-event": "#ccc",
              "--color-scheduling-profiler-native-event-hover": "#aaa",
              "--color-scheduling-profiler-network-primary": "#fcf3dc",
              "--color-scheduling-profiler-network-primary-hover": "#f0e7d1",
              "--color-scheduling-profiler-network-secondary": "#efc457",
              "--color-scheduling-profiler-network-secondary-hover": "#e3ba52",
              "--color-scheduling-profiler-priority-background": "#f6f6f6",
              "--color-scheduling-profiler-priority-border": "#eeeeee",
              "--color-scheduling-profiler-user-timing": "#c9cacd",
              "--color-scheduling-profiler-user-timing-hover": "#93959a",
              "--color-scheduling-profiler-react-idle": "#d3e5f6",
              "--color-scheduling-profiler-react-idle-hover": "#c3d9ef",
              "--color-scheduling-profiler-react-render": "#9fc3f3",
              "--color-scheduling-profiler-react-render-hover": "#83afe9",
              "--color-scheduling-profiler-react-render-text": "#11365e",
              "--color-scheduling-profiler-react-commit": "#c88ff0",
              "--color-scheduling-profiler-react-commit-hover": "#b281d6",
              "--color-scheduling-profiler-react-commit-text": "#3e2c4a",
              "--color-scheduling-profiler-react-layout-effects": "#b281d6",
              "--color-scheduling-profiler-react-layout-effects-hover": "#9d71bd",
              "--color-scheduling-profiler-react-layout-effects-text": "#3e2c4a",
              "--color-scheduling-profiler-react-passive-effects": "#b281d6",
              "--color-scheduling-profiler-react-passive-effects-hover": "#9d71bd",
              "--color-scheduling-profiler-react-passive-effects-text": "#3e2c4a",
              "--color-scheduling-profiler-react-schedule": "#9fc3f3",
              "--color-scheduling-profiler-react-schedule-hover": "#2683E2",
              "--color-scheduling-profiler-react-suspense-rejected": "#f1cc14",
              "--color-scheduling-profiler-react-suspense-rejected-hover": "#ffdf37",
              "--color-scheduling-profiler-react-suspense-resolved": "#a6e59f",
              "--color-scheduling-profiler-react-suspense-resolved-hover": "#89d281",
              "--color-scheduling-profiler-react-suspense-unresolved": "#c9cacd",
              "--color-scheduling-profiler-react-suspense-unresolved-hover": "#93959a",
              "--color-scheduling-profiler-text-color": "#000000",
              "--color-scheduling-profiler-text-dim-color": "#ccc",
              "--color-scheduling-profiler-react-work-border": "#ffffff",
              "--color-search-match": "yellow",
              "--color-search-match-current": "#f7923b",
              "--color-selected-tree-highlight-active": "rgba(0, 136, 250, 0.1)",
              "--color-selected-tree-highlight-inactive": "rgba(0, 0, 0, 0.05)",
              "--color-scroll-caret": "rgba(150, 150, 150, 0.5)",
              "--color-tab-selected-border": "#0088fa",
              "--color-text": "#000000",
              "--color-text-invalid": "#ff0000",
              "--color-text-selected": "#ffffff",
              "--color-toggle-background-invalid": "#fc3a4b",
              "--color-toggle-background-on": "#0088fa",
              "--color-toggle-background-off": "#cfd1d5",
              "--color-toggle-text": "#ffffff",
              "--color-warning-background": "#fb3655",
              "--color-warning-background-hover": "#f82042",
              "--color-warning-text-color": "#ffffff",
              "--color-warning-text-color-inverted": "#fd4d69",
              "--color-scroll-thumb": "#c2c2c2",
              "--color-scroll-track": "#fafafa",
              "--color-tooltip-background": "rgba(0, 0, 0, 0.9)",
              "--color-tooltip-text": "#ffffff"
            },
            dark: {
              "--color-attribute-name": "#9d87d2",
              "--color-attribute-name-not-editable": "#ededed",
              "--color-attribute-name-inverted": "#282828",
              "--color-attribute-value": "#cedae0",
              "--color-attribute-value-inverted": "#ffffff",
              "--color-attribute-editable-value": "yellow",
              "--color-background": "#282c34",
              "--color-background-hover": "rgba(255, 255, 255, 0.1)",
              "--color-background-inactive": "#3d424a",
              "--color-background-invalid": "#5c0000",
              "--color-background-selected": "#178fb9",
              "--color-button-background": "#282c34",
              "--color-button-background-focus": "#3d424a",
              "--color-button": "#afb3b9",
              "--color-button-active": "#61dafb",
              "--color-button-disabled": "#4f5766",
              "--color-button-focus": "#a2e9fc",
              "--color-button-hover": "#ededed",
              "--color-border": "#3d424a",
              "--color-commit-did-not-render-fill": "#777d88",
              "--color-commit-did-not-render-fill-text": "#000000",
              "--color-commit-did-not-render-pattern": "#666c77",
              "--color-commit-did-not-render-pattern-text": "#ffffff",
              "--color-commit-gradient-0": "#37afa9",
              "--color-commit-gradient-1": "#63b19e",
              "--color-commit-gradient-2": "#80b393",
              "--color-commit-gradient-3": "#97b488",
              "--color-commit-gradient-4": "#abb67d",
              "--color-commit-gradient-5": "#beb771",
              "--color-commit-gradient-6": "#cfb965",
              "--color-commit-gradient-7": "#dfba57",
              "--color-commit-gradient-8": "#efbb49",
              "--color-commit-gradient-9": "#febc38",
              "--color-commit-gradient-text": "#000000",
              "--color-component-name": "#61dafb",
              "--color-component-name-inverted": "#282828",
              "--color-component-badge-background": "rgba(255, 255, 255, 0.25)",
              "--color-component-badge-background-inverted": "rgba(0, 0, 0, 0.25)",
              "--color-component-badge-count": "#8f949d",
              "--color-component-badge-count-inverted": "rgba(255, 255, 255, 0.7)",
              "--color-console-error-badge-text": "#000000",
              "--color-console-error-background": "#290000",
              "--color-console-error-border": "#5c0000",
              "--color-console-error-icon": "#eb3941",
              "--color-console-error-text": "#fc7f7f",
              "--color-console-warning-badge-text": "#000000",
              "--color-console-warning-background": "#332b00",
              "--color-console-warning-border": "#665500",
              "--color-console-warning-icon": "#f4bd00",
              "--color-console-warning-text": "#f5f2ed",
              "--color-context-background": "rgba(255,255,255,.95)",
              "--color-context-background-hover": "rgba(0, 136, 250, 0.1)",
              "--color-context-background-selected": "#0088fa",
              "--color-context-border": "#eeeeee",
              "--color-context-text": "#000000",
              "--color-context-text-selected": "#ffffff",
              "--color-dim": "#8f949d",
              "--color-dimmer": "#777d88",
              "--color-dimmest": "#4f5766",
              "--color-error-background": "#200",
              "--color-error-border": "#900",
              "--color-error-text": "#f55",
              "--color-expand-collapse-toggle": "#8f949d",
              "--color-link": "#61dafb",
              "--color-modal-background": "rgba(0, 0, 0, 0.75)",
              "--color-bridge-version-npm-background": "rgba(0, 0, 0, 0.25)",
              "--color-bridge-version-npm-text": "#ffffff",
              "--color-bridge-version-number": "yellow",
              "--color-primitive-hook-badge-background": "rgba(0, 0, 0, 0.25)",
              "--color-primitive-hook-badge-text": "rgba(255, 255, 255, 0.7)",
              "--color-record-active": "#fc3a4b",
              "--color-record-hover": "#a2e9fc",
              "--color-record-inactive": "#61dafb",
              "--color-resize-bar": "#282c34",
              "--color-resize-bar-active": "#31363f",
              "--color-resize-bar-border": "#3d424a",
              "--color-resize-bar-dot": "#cfd1d5",
              "--color-scheduling-profiler-native-event": "#b2b2b2",
              "--color-scheduling-profiler-native-event-hover": "#949494",
              "--color-scheduling-profiler-network-primary": "#fcf3dc",
              "--color-scheduling-profiler-network-primary-hover": "#e3dbc5",
              "--color-scheduling-profiler-network-secondary": "#efc457",
              "--color-scheduling-profiler-network-secondary-hover": "#d6af4d",
              "--color-scheduling-profiler-priority-background": "#1d2129",
              "--color-scheduling-profiler-priority-border": "#282c34",
              "--color-scheduling-profiler-user-timing": "#c9cacd",
              "--color-scheduling-profiler-user-timing-hover": "#93959a",
              "--color-scheduling-profiler-react-idle": "#3d485b",
              "--color-scheduling-profiler-react-idle-hover": "#465269",
              "--color-scheduling-profiler-react-render": "#2683E2",
              "--color-scheduling-profiler-react-render-hover": "#1a76d4",
              "--color-scheduling-profiler-react-render-text": "#11365e",
              "--color-scheduling-profiler-react-commit": "#731fad",
              "--color-scheduling-profiler-react-commit-hover": "#611b94",
              "--color-scheduling-profiler-react-commit-text": "#e5c1ff",
              "--color-scheduling-profiler-react-layout-effects": "#611b94",
              "--color-scheduling-profiler-react-layout-effects-hover": "#51167a",
              "--color-scheduling-profiler-react-layout-effects-text": "#e5c1ff",
              "--color-scheduling-profiler-react-passive-effects": "#611b94",
              "--color-scheduling-profiler-react-passive-effects-hover": "#51167a",
              "--color-scheduling-profiler-react-passive-effects-text": "#e5c1ff",
              "--color-scheduling-profiler-react-schedule": "#2683E2",
              "--color-scheduling-profiler-react-schedule-hover": "#1a76d4",
              "--color-scheduling-profiler-react-suspense-rejected": "#f1cc14",
              "--color-scheduling-profiler-react-suspense-rejected-hover": "#e4c00f",
              "--color-scheduling-profiler-react-suspense-resolved": "#a6e59f",
              "--color-scheduling-profiler-react-suspense-resolved-hover": "#89d281",
              "--color-scheduling-profiler-react-suspense-unresolved": "#c9cacd",
              "--color-scheduling-profiler-react-suspense-unresolved-hover": "#93959a",
              "--color-scheduling-profiler-text-color": "#282c34",
              "--color-scheduling-profiler-text-dim-color": "#555b66",
              "--color-scheduling-profiler-react-work-border": "#ffffff",
              "--color-search-match": "yellow",
              "--color-search-match-current": "#f7923b",
              "--color-selected-tree-highlight-active": "rgba(23, 143, 185, 0.15)",
              "--color-selected-tree-highlight-inactive": "rgba(255, 255, 255, 0.05)",
              "--color-scroll-caret": "#4f5766",
              "--color-shadow": "rgba(0, 0, 0, 0.5)",
              "--color-tab-selected-border": "#178fb9",
              "--color-text": "#ffffff",
              "--color-text-invalid": "#ff8080",
              "--color-text-selected": "#ffffff",
              "--color-toggle-background-invalid": "#fc3a4b",
              "--color-toggle-background-on": "#178fb9",
              "--color-toggle-background-off": "#777d88",
              "--color-toggle-text": "#ffffff",
              "--color-warning-background": "#ee1638",
              "--color-warning-background-hover": "#da1030",
              "--color-warning-text-color": "#ffffff",
              "--color-warning-text-color-inverted": "#ee1638",
              "--color-scroll-thumb": "#afb3b9",
              "--color-scroll-track": "#313640",
              "--color-tooltip-background": "rgba(255, 255, 255, 0.95)",
              "--color-tooltip-text": "#000000"
            },
            compact: {
              "--font-size-monospace-small": "9px",
              "--font-size-monospace-normal": "11px",
              "--font-size-monospace-large": "15px",
              "--font-size-sans-small": "10px",
              "--font-size-sans-normal": "12px",
              "--font-size-sans-large": "14px",
              "--line-height-data": "18px"
            },
            comfortable: {
              "--font-size-monospace-small": "10px",
              "--font-size-monospace-normal": "13px",
              "--font-size-monospace-large": "17px",
              "--font-size-sans-small": "12px",
              "--font-size-sans-normal": "14px",
              "--font-size-sans-large": "16px",
              "--line-height-data": "22px"
            }
          };
          var COMFORTABLE_LINE_HEIGHT = parseInt(THEME_STYLES.comfortable["--line-height-data"], 10);
          var COMPACT_LINE_HEIGHT = parseInt(THEME_STYLES.compact["--line-height-data"], 10);
        },
        function(module3, __webpack_exports__, __webpack_require__) {
          "use strict";
          __webpack_require__.d(__webpack_exports__, "e", function() {
            return ElementTypeClass;
          });
          __webpack_require__.d(__webpack_exports__, "f", function() {
            return ElementTypeContext;
          });
          __webpack_require__.d(__webpack_exports__, "h", function() {
            return ElementTypeFunction;
          });
          __webpack_require__.d(__webpack_exports__, "g", function() {
            return ElementTypeForwardRef;
          });
          __webpack_require__.d(__webpack_exports__, "i", function() {
            return ElementTypeHostComponent;
          });
          __webpack_require__.d(__webpack_exports__, "j", function() {
            return ElementTypeMemo;
          });
          __webpack_require__.d(__webpack_exports__, "k", function() {
            return ElementTypeOtherOrUnknown;
          });
          __webpack_require__.d(__webpack_exports__, "l", function() {
            return ElementTypeProfiler;
          });
          __webpack_require__.d(__webpack_exports__, "m", function() {
            return ElementTypeRoot;
          });
          __webpack_require__.d(__webpack_exports__, "n", function() {
            return ElementTypeSuspense;
          });
          __webpack_require__.d(__webpack_exports__, "o", function() {
            return ElementTypeSuspenseList;
          });
          __webpack_require__.d(__webpack_exports__, "b", function() {
            return ComponentFilterElementType;
          });
          __webpack_require__.d(__webpack_exports__, "a", function() {
            return ComponentFilterDisplayName;
          });
          __webpack_require__.d(__webpack_exports__, "d", function() {
            return ComponentFilterLocation;
          });
          __webpack_require__.d(__webpack_exports__, "c", function() {
            return ComponentFilterHOC;
          });
          var ElementTypeClass = 1;
          var ElementTypeContext = 2;
          var ElementTypeFunction = 5;
          var ElementTypeForwardRef = 6;
          var ElementTypeHostComponent = 7;
          var ElementTypeMemo = 8;
          var ElementTypeOtherOrUnknown = 9;
          var ElementTypeProfiler = 10;
          var ElementTypeRoot = 11;
          var ElementTypeSuspense = 12;
          var ElementTypeSuspenseList = 13;
          var ComponentFilterElementType = 1;
          var ComponentFilterDisplayName = 2;
          var ComponentFilterLocation = 3;
          var ComponentFilterHOC = 4;
        },
        function(module3, __webpack_exports__, __webpack_require__) {
          "use strict";
          __webpack_require__.d(__webpack_exports__, "c", function() {
            return getAllEnumerableKeys;
          });
          __webpack_require__.d(__webpack_exports__, "f", function() {
            return getDisplayName;
          });
          __webpack_require__.d(__webpack_exports__, "i", function() {
            return getUID;
          });
          __webpack_require__.d(__webpack_exports__, "m", function() {
            return utfEncodeString;
          });
          __webpack_require__.d(__webpack_exports__, "j", function() {
            return printOperationsArray;
          });
          __webpack_require__.d(__webpack_exports__, "e", function() {
            return getDefaultComponentFilters;
          });
          __webpack_require__.d(__webpack_exports__, "h", function() {
            return getInObject;
          });
          __webpack_require__.d(__webpack_exports__, "a", function() {
            return deletePathInObject;
          });
          __webpack_require__.d(__webpack_exports__, "k", function() {
            return renamePathInObject;
          });
          __webpack_require__.d(__webpack_exports__, "l", function() {
            return setInObject;
          });
          __webpack_require__.d(__webpack_exports__, "d", function() {
            return getDataType;
          });
          __webpack_require__.d(__webpack_exports__, "g", function() {
            return getDisplayNameForReactElement;
          });
          __webpack_require__.d(__webpack_exports__, "b", function() {
            return formatDataForPreview;
          });
          var lru_cache = __webpack_require__(18);
          var lru_cache_default = /* @__PURE__ */ __webpack_require__.n(lru_cache);
          var react_is = __webpack_require__(6);
          function _typeof(obj) {
            "@babel/helpers - typeof";
            if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
              _typeof = function _typeof2(obj2) {
                return typeof obj2;
              };
            } else {
              _typeof = function _typeof2(obj2) {
                return obj2 && typeof Symbol === "function" && obj2.constructor === Symbol && obj2 !== Symbol.prototype ? "symbol" : typeof obj2;
              };
            }
            return _typeof(obj);
          }
          var REACT_ELEMENT_TYPE = 60103;
          var REACT_PORTAL_TYPE = 60106;
          var REACT_FRAGMENT_TYPE = 60107;
          var REACT_STRICT_MODE_TYPE = 60108;
          var REACT_PROFILER_TYPE = 60114;
          var REACT_PROVIDER_TYPE = 60109;
          var REACT_CONTEXT_TYPE = 60110;
          var REACT_FORWARD_REF_TYPE = 60112;
          var REACT_SUSPENSE_TYPE = 60113;
          var REACT_SUSPENSE_LIST_TYPE = 60120;
          var REACT_MEMO_TYPE = 60115;
          var REACT_LAZY_TYPE = 60116;
          var REACT_SCOPE_TYPE = 60119;
          var REACT_OPAQUE_ID_TYPE = 60128;
          var REACT_DEBUG_TRACING_MODE_TYPE = 60129;
          var REACT_OFFSCREEN_TYPE = 60130;
          var REACT_LEGACY_HIDDEN_TYPE = 60131;
          var REACT_CACHE_TYPE = 60132;
          if (typeof Symbol === "function" && Symbol.for) {
            var symbolFor = Symbol.for;
            REACT_ELEMENT_TYPE = symbolFor("react.element");
            REACT_PORTAL_TYPE = symbolFor("react.portal");
            REACT_FRAGMENT_TYPE = symbolFor("react.fragment");
            REACT_STRICT_MODE_TYPE = symbolFor("react.strict_mode");
            REACT_PROFILER_TYPE = symbolFor("react.profiler");
            REACT_PROVIDER_TYPE = symbolFor("react.provider");
            REACT_CONTEXT_TYPE = symbolFor("react.context");
            REACT_FORWARD_REF_TYPE = symbolFor("react.forward_ref");
            REACT_SUSPENSE_TYPE = symbolFor("react.suspense");
            REACT_SUSPENSE_LIST_TYPE = symbolFor("react.suspense_list");
            REACT_MEMO_TYPE = symbolFor("react.memo");
            REACT_LAZY_TYPE = symbolFor("react.lazy");
            REACT_SCOPE_TYPE = symbolFor("react.scope");
            REACT_OPAQUE_ID_TYPE = symbolFor("react.opaque.id");
            REACT_DEBUG_TRACING_MODE_TYPE = symbolFor("react.debug_trace_mode");
            REACT_OFFSCREEN_TYPE = symbolFor("react.offscreen");
            REACT_LEGACY_HIDDEN_TYPE = symbolFor("react.legacy_hidden");
            REACT_CACHE_TYPE = symbolFor("react.cache");
          }
          var MAYBE_ITERATOR_SYMBOL = typeof Symbol === "function" && Symbol.iterator;
          var FAUX_ITERATOR_SYMBOL = "@@iterator";
          function getIteratorFn(maybeIterable) {
            if (maybeIterable === null || _typeof(maybeIterable) !== "object") {
              return null;
            }
            var maybeIterator = MAYBE_ITERATOR_SYMBOL && maybeIterable[MAYBE_ITERATOR_SYMBOL] || maybeIterable[FAUX_ITERATOR_SYMBOL];
            if (typeof maybeIterator === "function") {
              return maybeIterator;
            }
            return null;
          }
          var constants = __webpack_require__(0);
          var types2 = __webpack_require__(1);
          var storage = __webpack_require__(5);
          var hydration = __webpack_require__(10);
          function utils_typeof(obj) {
            "@babel/helpers - typeof";
            if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
              utils_typeof = function _typeof2(obj2) {
                return typeof obj2;
              };
            } else {
              utils_typeof = function _typeof2(obj2) {
                return obj2 && typeof Symbol === "function" && obj2.constructor === Symbol && obj2 !== Symbol.prototype ? "symbol" : typeof obj2;
              };
            }
            return utils_typeof(obj);
          }
          function _toConsumableArray(arr) {
            return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread();
          }
          function _nonIterableSpread() {
            throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
          }
          function _unsupportedIterableToArray(o2, minLen) {
            if (!o2)
              return;
            if (typeof o2 === "string")
              return _arrayLikeToArray(o2, minLen);
            var n2 = Object.prototype.toString.call(o2).slice(8, -1);
            if (n2 === "Object" && o2.constructor)
              n2 = o2.constructor.name;
            if (n2 === "Map" || n2 === "Set")
              return Array.from(o2);
            if (n2 === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n2))
              return _arrayLikeToArray(o2, minLen);
          }
          function _iterableToArray(iter) {
            if (typeof Symbol !== "undefined" && Symbol.iterator in Object(iter))
              return Array.from(iter);
          }
          function _arrayWithoutHoles(arr) {
            if (Array.isArray(arr))
              return _arrayLikeToArray(arr);
          }
          function _arrayLikeToArray(arr, len) {
            if (len == null || len > arr.length)
              len = arr.length;
            for (var i3 = 0, arr2 = new Array(len); i3 < len; i3++) {
              arr2[i3] = arr[i3];
            }
            return arr2;
          }
          var cachedDisplayNames = new WeakMap();
          var encodedStringCache = new lru_cache_default.a({
            max: 1e3
          });
          function alphaSortKeys(a2, b2) {
            if (a2.toString() > b2.toString()) {
              return 1;
            } else if (b2.toString() > a2.toString()) {
              return -1;
            } else {
              return 0;
            }
          }
          function getAllEnumerableKeys(obj) {
            var keys = /* @__PURE__ */ new Set();
            var current = obj;
            var _loop = function _loop2() {
              var currentKeys = [].concat(_toConsumableArray(Object.keys(current)), _toConsumableArray(Object.getOwnPropertySymbols(current)));
              var descriptors = Object.getOwnPropertyDescriptors(current);
              currentKeys.forEach(function(key2) {
                if (descriptors[key2].enumerable) {
                  keys.add(key2);
                }
              });
              current = Object.getPrototypeOf(current);
            };
            while (current != null) {
              _loop();
            }
            return keys;
          }
          function getDisplayName(type3) {
            var fallbackName = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : "Anonymous";
            var nameFromCache = cachedDisplayNames.get(type3);
            if (nameFromCache != null) {
              return nameFromCache;
            }
            var displayName = fallbackName;
            if (typeof type3.displayName === "string") {
              displayName = type3.displayName;
            } else if (typeof type3.name === "string" && type3.name !== "") {
              displayName = type3.name;
            }
            cachedDisplayNames.set(type3, displayName);
            return displayName;
          }
          var uidCounter = 0;
          function getUID() {
            return ++uidCounter;
          }
          function utfDecodeString(array) {
            return String.fromCodePoint.apply(String, _toConsumableArray(array));
          }
          function utfEncodeString(string) {
            var cached = encodedStringCache.get(string);
            if (cached !== void 0) {
              return cached;
            }
            var encoded = new Array(string.length);
            for (var i3 = 0; i3 < string.length; i3++) {
              encoded[i3] = string.codePointAt(i3);
            }
            encodedStringCache.set(string, encoded);
            return encoded;
          }
          function printOperationsArray(operations) {
            var rendererID = operations[0];
            var rootID = operations[1];
            var logs = ["operations for renderer:".concat(rendererID, " and root:").concat(rootID)];
            var i3 = 2;
            var stringTable = [
              null
            ];
            var stringTableSize = operations[i3++];
            var stringTableEnd = i3 + stringTableSize;
            while (i3 < stringTableEnd) {
              var nextLength = operations[i3++];
              var nextString = utfDecodeString(operations.slice(i3, i3 + nextLength));
              stringTable.push(nextString);
              i3 += nextLength;
            }
            while (i3 < operations.length) {
              var operation = operations[i3];
              switch (operation) {
                case constants["i"]: {
                  var _id = operations[i3 + 1];
                  var type3 = operations[i3 + 2];
                  i3 += 3;
                  if (type3 === types2["m"]) {
                    logs.push("Add new root node ".concat(_id));
                    i3++;
                    i3++;
                  } else {
                    var parentID = operations[i3];
                    i3++;
                    i3++;
                    var displayNameStringID = operations[i3];
                    var displayName = stringTable[displayNameStringID];
                    i3++;
                    i3++;
                    logs.push("Add node ".concat(_id, " (").concat(displayName || "null", ") as child of ").concat(parentID));
                  }
                  break;
                }
                case constants["j"]: {
                  var removeLength = operations[i3 + 1];
                  i3 += 2;
                  for (var removeIndex = 0; removeIndex < removeLength; removeIndex++) {
                    var _id2 = operations[i3];
                    i3 += 1;
                    logs.push("Remove node ".concat(_id2));
                  }
                  break;
                }
                case constants["k"]: {
                  i3 += 1;
                  logs.push("Remove root ".concat(rootID));
                  break;
                }
                case constants["l"]: {
                  var _id3 = operations[i3 + 1];
                  var numChildren = operations[i3 + 2];
                  i3 += 3;
                  var children = operations.slice(i3, i3 + numChildren);
                  i3 += numChildren;
                  logs.push("Re-order node ".concat(_id3, " children ").concat(children.join(",")));
                  break;
                }
                case constants["n"]:
                  i3 += 3;
                  break;
                case constants["m"]:
                  var id = operations[i3 + 1];
                  var numErrors = operations[i3 + 2];
                  var numWarnings = operations[i3 + 3];
                  i3 += 4;
                  logs.push("Node ".concat(id, " has ").concat(numErrors, " errors and ").concat(numWarnings, " warnings"));
                  break;
                default:
                  throw Error('Unsupported Bridge operation "'.concat(operation, '"'));
              }
            }
            console.log(logs.join("\n  "));
          }
          function getDefaultComponentFilters() {
            return [{
              type: types2["b"],
              value: types2["i"],
              isEnabled: true
            }];
          }
          function getSavedComponentFilters() {
            try {
              var raw = Object(storage["a"])(constants["a"]);
              if (raw != null) {
                return JSON.parse(raw);
              }
            } catch (error) {
            }
            return getDefaultComponentFilters();
          }
          function saveComponentFilters(componentFilters) {
            Object(storage["b"])(constants["a"], JSON.stringify(componentFilters));
          }
          function getAppendComponentStack() {
            try {
              var raw = Object(storage["a"])(constants["d"]);
              if (raw != null) {
                return JSON.parse(raw);
              }
            } catch (error) {
            }
            return true;
          }
          function setAppendComponentStack(value) {
            Object(storage["b"])(constants["d"], JSON.stringify(value));
          }
          function getBreakOnConsoleErrors() {
            try {
              var raw = Object(storage["a"])(constants["c"]);
              if (raw != null) {
                return JSON.parse(raw);
              }
            } catch (error) {
            }
            return false;
          }
          function setBreakOnConsoleErrors(value) {
            Object(storage["b"])(constants["c"], JSON.stringify(value));
          }
          function getHideConsoleLogsInStrictMode() {
            try {
              var raw = Object(storage["a"])(constants["b"]);
              if (raw != null) {
                return JSON.parse(raw);
              }
            } catch (error) {
            }
            return false;
          }
          function sethideConsoleLogsInStrictMode(value) {
            Object(storage["b"])(constants["b"], JSON.stringify(value));
          }
          function getShowInlineWarningsAndErrors() {
            try {
              var raw = Object(storage["a"])(constants["e"]);
              if (raw != null) {
                return JSON.parse(raw);
              }
            } catch (error) {
            }
            return true;
          }
          function setShowInlineWarningsAndErrors(value) {
            Object(storage["b"])(constants["e"], JSON.stringify(value));
          }
          function separateDisplayNameAndHOCs(displayName, type3) {
            if (displayName === null) {
              return [null, null];
            }
            var hocDisplayNames = null;
            switch (type3) {
              case types2["e"]:
              case types2["g"]:
              case types2["h"]:
              case types2["j"]:
                if (displayName.indexOf("(") >= 0) {
                  var matches = displayName.match(/[^()]+/g);
                  if (matches != null) {
                    displayName = matches.pop();
                    hocDisplayNames = matches;
                  }
                }
                break;
              default:
                break;
            }
            if (type3 === types2["j"]) {
              if (hocDisplayNames === null) {
                hocDisplayNames = ["Memo"];
              } else {
                hocDisplayNames.unshift("Memo");
              }
            } else if (type3 === types2["g"]) {
              if (hocDisplayNames === null) {
                hocDisplayNames = ["ForwardRef"];
              } else {
                hocDisplayNames.unshift("ForwardRef");
              }
            }
            return [displayName, hocDisplayNames];
          }
          function shallowDiffers(prev, next) {
            for (var attribute in prev) {
              if (!(attribute in next)) {
                return true;
              }
            }
            for (var _attribute in next) {
              if (prev[_attribute] !== next[_attribute]) {
                return true;
              }
            }
            return false;
          }
          function getInObject(object, path2) {
            return path2.reduce(function(reduced, attr) {
              if (reduced) {
                if (hasOwnProperty.call(reduced, attr)) {
                  return reduced[attr];
                }
                if (typeof reduced[Symbol.iterator] === "function") {
                  return Array.from(reduced)[attr];
                }
              }
              return null;
            }, object);
          }
          function deletePathInObject(object, path2) {
            var length = path2.length;
            var last = path2[length - 1];
            if (object != null) {
              var parent = getInObject(object, path2.slice(0, length - 1));
              if (parent) {
                if (Array.isArray(parent)) {
                  parent.splice(last, 1);
                } else {
                  delete parent[last];
                }
              }
            }
          }
          function renamePathInObject(object, oldPath, newPath) {
            var length = oldPath.length;
            if (object != null) {
              var parent = getInObject(object, oldPath.slice(0, length - 1));
              if (parent) {
                var lastOld = oldPath[length - 1];
                var lastNew = newPath[length - 1];
                parent[lastNew] = parent[lastOld];
                if (Array.isArray(parent)) {
                  parent.splice(lastOld, 1);
                } else {
                  delete parent[lastOld];
                }
              }
            }
          }
          function setInObject(object, path2, value) {
            var length = path2.length;
            var last = path2[length - 1];
            if (object != null) {
              var parent = getInObject(object, path2.slice(0, length - 1));
              if (parent) {
                parent[last] = value;
              }
            }
          }
          function getDataType(data) {
            if (data === null) {
              return "null";
            } else if (data === void 0) {
              return "undefined";
            }
            if (Object(react_is["isElement"])(data)) {
              return "react_element";
            }
            if (typeof HTMLElement !== "undefined" && data instanceof HTMLElement) {
              return "html_element";
            }
            var type3 = utils_typeof(data);
            switch (type3) {
              case "bigint":
                return "bigint";
              case "boolean":
                return "boolean";
              case "function":
                return "function";
              case "number":
                if (Number.isNaN(data)) {
                  return "nan";
                } else if (!Number.isFinite(data)) {
                  return "infinity";
                } else {
                  return "number";
                }
              case "object":
                if (Array.isArray(data)) {
                  return "array";
                } else if (ArrayBuffer.isView(data)) {
                  return hasOwnProperty.call(data.constructor, "BYTES_PER_ELEMENT") ? "typed_array" : "data_view";
                } else if (data.constructor && data.constructor.name === "ArrayBuffer") {
                  return "array_buffer";
                } else if (typeof data[Symbol.iterator] === "function") {
                  var iterator = data[Symbol.iterator]();
                  if (!iterator) {
                  } else {
                    return iterator === data ? "opaque_iterator" : "iterator";
                  }
                } else if (data.constructor && data.constructor.name === "RegExp") {
                  return "regexp";
                } else {
                  var toStringValue = Object.prototype.toString.call(data);
                  if (toStringValue === "[object Date]") {
                    return "date";
                  } else if (toStringValue === "[object HTMLAllCollection]") {
                    return "html_all_collection";
                  }
                }
                return "object";
              case "string":
                return "string";
              case "symbol":
                return "symbol";
              case "undefined":
                if (Object.prototype.toString.call(data) === "[object HTMLAllCollection]") {
                  return "html_all_collection";
                }
                return "undefined";
              default:
                return "unknown";
            }
          }
          function getDisplayNameForReactElement(element) {
            var elementType = Object(react_is["typeOf"])(element);
            switch (elementType) {
              case react_is["ContextConsumer"]:
                return "ContextConsumer";
              case react_is["ContextProvider"]:
                return "ContextProvider";
              case react_is["ForwardRef"]:
                return "ForwardRef";
              case react_is["Fragment"]:
                return "Fragment";
              case react_is["Lazy"]:
                return "Lazy";
              case react_is["Memo"]:
                return "Memo";
              case react_is["Portal"]:
                return "Portal";
              case react_is["Profiler"]:
                return "Profiler";
              case react_is["StrictMode"]:
                return "StrictMode";
              case react_is["Suspense"]:
                return "Suspense";
              case REACT_SUSPENSE_LIST_TYPE:
                return "SuspenseList";
              default:
                var type3 = element.type;
                if (typeof type3 === "string") {
                  return type3;
                } else if (typeof type3 === "function") {
                  return getDisplayName(type3, "Anonymous");
                } else if (type3 != null) {
                  return "NotImplementedInDevtools";
                } else {
                  return "Element";
                }
            }
          }
          var MAX_PREVIEW_STRING_LENGTH = 50;
          function truncateForDisplay(string) {
            var length = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : MAX_PREVIEW_STRING_LENGTH;
            if (string.length > length) {
              return string.substr(0, length) + "\u2026";
            } else {
              return string;
            }
          }
          function formatDataForPreview(data, showFormattedValue) {
            if (data != null && hasOwnProperty.call(data, hydration["b"].type)) {
              return showFormattedValue ? data[hydration["b"].preview_long] : data[hydration["b"].preview_short];
            }
            var type3 = getDataType(data);
            switch (type3) {
              case "html_element":
                return "<".concat(truncateForDisplay(data.tagName.toLowerCase()), " />");
              case "function":
                return truncateForDisplay("\u0192 ".concat(typeof data.name === "function" ? "" : data.name, "() {}"));
              case "string":
                return '"'.concat(data, '"');
              case "bigint":
                return truncateForDisplay(data.toString() + "n");
              case "regexp":
                return truncateForDisplay(data.toString());
              case "symbol":
                return truncateForDisplay(data.toString());
              case "react_element":
                return "<".concat(truncateForDisplay(getDisplayNameForReactElement(data) || "Unknown"), " />");
              case "array_buffer":
                return "ArrayBuffer(".concat(data.byteLength, ")");
              case "data_view":
                return "DataView(".concat(data.buffer.byteLength, ")");
              case "array":
                if (showFormattedValue) {
                  var formatted = "";
                  for (var i3 = 0; i3 < data.length; i3++) {
                    if (i3 > 0) {
                      formatted += ", ";
                    }
                    formatted += formatDataForPreview(data[i3], false);
                    if (formatted.length > MAX_PREVIEW_STRING_LENGTH) {
                      break;
                    }
                  }
                  return "[".concat(truncateForDisplay(formatted), "]");
                } else {
                  var length = hasOwnProperty.call(data, hydration["b"].size) ? data[hydration["b"].size] : data.length;
                  return "Array(".concat(length, ")");
                }
              case "typed_array":
                var shortName = "".concat(data.constructor.name, "(").concat(data.length, ")");
                if (showFormattedValue) {
                  var _formatted = "";
                  for (var _i = 0; _i < data.length; _i++) {
                    if (_i > 0) {
                      _formatted += ", ";
                    }
                    _formatted += data[_i];
                    if (_formatted.length > MAX_PREVIEW_STRING_LENGTH) {
                      break;
                    }
                  }
                  return "".concat(shortName, " [").concat(truncateForDisplay(_formatted), "]");
                } else {
                  return shortName;
                }
              case "iterator":
                var name = data.constructor.name;
                if (showFormattedValue) {
                  var array = Array.from(data);
                  var _formatted2 = "";
                  for (var _i2 = 0; _i2 < array.length; _i2++) {
                    var entryOrEntries = array[_i2];
                    if (_i2 > 0) {
                      _formatted2 += ", ";
                    }
                    if (Array.isArray(entryOrEntries)) {
                      var key2 = formatDataForPreview(entryOrEntries[0], true);
                      var value = formatDataForPreview(entryOrEntries[1], false);
                      _formatted2 += "".concat(key2, " => ").concat(value);
                    } else {
                      _formatted2 += formatDataForPreview(entryOrEntries, false);
                    }
                    if (_formatted2.length > MAX_PREVIEW_STRING_LENGTH) {
                      break;
                    }
                  }
                  return "".concat(name, "(").concat(data.size, ") {").concat(truncateForDisplay(_formatted2), "}");
                } else {
                  return "".concat(name, "(").concat(data.size, ")");
                }
              case "opaque_iterator": {
                return data[Symbol.toStringTag];
              }
              case "date":
                return data.toString();
              case "object":
                if (showFormattedValue) {
                  var keys = Array.from(getAllEnumerableKeys(data)).sort(alphaSortKeys);
                  var _formatted3 = "";
                  for (var _i3 = 0; _i3 < keys.length; _i3++) {
                    var _key = keys[_i3];
                    if (_i3 > 0) {
                      _formatted3 += ", ";
                    }
                    _formatted3 += "".concat(_key.toString(), ": ").concat(formatDataForPreview(data[_key], false));
                    if (_formatted3.length > MAX_PREVIEW_STRING_LENGTH) {
                      break;
                    }
                  }
                  return "{".concat(truncateForDisplay(_formatted3), "}");
                } else {
                  return "{\u2026}";
                }
              case "boolean":
              case "number":
              case "infinity":
              case "nan":
              case "null":
              case "undefined":
                return data;
              default:
                try {
                  return truncateForDisplay("" + data);
                } catch (error) {
                  return "unserializable";
                }
            }
          }
        },
        function(module3, __webpack_exports__, __webpack_require__) {
          "use strict";
          __webpack_require__.d(__webpack_exports__, "a", function() {
            return CONCURRENT_MODE_NUMBER;
          });
          __webpack_require__.d(__webpack_exports__, "b", function() {
            return CONCURRENT_MODE_SYMBOL_STRING;
          });
          __webpack_require__.d(__webpack_exports__, "c", function() {
            return CONTEXT_NUMBER;
          });
          __webpack_require__.d(__webpack_exports__, "d", function() {
            return CONTEXT_SYMBOL_STRING;
          });
          __webpack_require__.d(__webpack_exports__, "e", function() {
            return DEPRECATED_ASYNC_MODE_SYMBOL_STRING;
          });
          __webpack_require__.d(__webpack_exports__, "f", function() {
            return FORWARD_REF_NUMBER;
          });
          __webpack_require__.d(__webpack_exports__, "g", function() {
            return FORWARD_REF_SYMBOL_STRING;
          });
          __webpack_require__.d(__webpack_exports__, "h", function() {
            return LAZY_NUMBER;
          });
          __webpack_require__.d(__webpack_exports__, "i", function() {
            return LAZY_SYMBOL_STRING;
          });
          __webpack_require__.d(__webpack_exports__, "j", function() {
            return MEMO_NUMBER;
          });
          __webpack_require__.d(__webpack_exports__, "k", function() {
            return MEMO_SYMBOL_STRING;
          });
          __webpack_require__.d(__webpack_exports__, "l", function() {
            return PROFILER_NUMBER;
          });
          __webpack_require__.d(__webpack_exports__, "m", function() {
            return PROFILER_SYMBOL_STRING;
          });
          __webpack_require__.d(__webpack_exports__, "n", function() {
            return PROVIDER_NUMBER;
          });
          __webpack_require__.d(__webpack_exports__, "o", function() {
            return PROVIDER_SYMBOL_STRING;
          });
          __webpack_require__.d(__webpack_exports__, "p", function() {
            return SCOPE_NUMBER;
          });
          __webpack_require__.d(__webpack_exports__, "q", function() {
            return SCOPE_SYMBOL_STRING;
          });
          __webpack_require__.d(__webpack_exports__, "r", function() {
            return STRICT_MODE_NUMBER;
          });
          __webpack_require__.d(__webpack_exports__, "s", function() {
            return STRICT_MODE_SYMBOL_STRING;
          });
          __webpack_require__.d(__webpack_exports__, "v", function() {
            return SUSPENSE_NUMBER;
          });
          __webpack_require__.d(__webpack_exports__, "w", function() {
            return SUSPENSE_SYMBOL_STRING;
          });
          __webpack_require__.d(__webpack_exports__, "t", function() {
            return SUSPENSE_LIST_NUMBER;
          });
          __webpack_require__.d(__webpack_exports__, "u", function() {
            return SUSPENSE_LIST_SYMBOL_STRING;
          });
          var CONCURRENT_MODE_NUMBER = 60111;
          var CONCURRENT_MODE_SYMBOL_STRING = "Symbol(react.concurrent_mode)";
          var CONTEXT_NUMBER = 60110;
          var CONTEXT_SYMBOL_STRING = "Symbol(react.context)";
          var DEPRECATED_ASYNC_MODE_SYMBOL_STRING = "Symbol(react.async_mode)";
          var ELEMENT_NUMBER = 60103;
          var ELEMENT_SYMBOL_STRING = "Symbol(react.element)";
          var DEBUG_TRACING_MODE_NUMBER = 60129;
          var DEBUG_TRACING_MODE_SYMBOL_STRING = "Symbol(react.debug_trace_mode)";
          var FORWARD_REF_NUMBER = 60112;
          var FORWARD_REF_SYMBOL_STRING = "Symbol(react.forward_ref)";
          var FRAGMENT_NUMBER = 60107;
          var FRAGMENT_SYMBOL_STRING = "Symbol(react.fragment)";
          var LAZY_NUMBER = 60116;
          var LAZY_SYMBOL_STRING = "Symbol(react.lazy)";
          var MEMO_NUMBER = 60115;
          var MEMO_SYMBOL_STRING = "Symbol(react.memo)";
          var OPAQUE_ID_NUMBER = 60128;
          var OPAQUE_ID_SYMBOL_STRING = "Symbol(react.opaque.id)";
          var PORTAL_NUMBER = 60106;
          var PORTAL_SYMBOL_STRING = "Symbol(react.portal)";
          var PROFILER_NUMBER = 60114;
          var PROFILER_SYMBOL_STRING = "Symbol(react.profiler)";
          var PROVIDER_NUMBER = 60109;
          var PROVIDER_SYMBOL_STRING = "Symbol(react.provider)";
          var SCOPE_NUMBER = 60119;
          var SCOPE_SYMBOL_STRING = "Symbol(react.scope)";
          var STRICT_MODE_NUMBER = 60108;
          var STRICT_MODE_SYMBOL_STRING = "Symbol(react.strict_mode)";
          var SUSPENSE_NUMBER = 60113;
          var SUSPENSE_SYMBOL_STRING = "Symbol(react.suspense)";
          var SUSPENSE_LIST_NUMBER = 60120;
          var SUSPENSE_LIST_SYMBOL_STRING = "Symbol(react.suspense_list)";
        },
        function(module3, __webpack_exports__, __webpack_require__) {
          "use strict";
          __webpack_require__.d(__webpack_exports__, "a", function() {
            return cleanForBridge;
          });
          __webpack_require__.d(__webpack_exports__, "b", function() {
            return copyToClipboard;
          });
          __webpack_require__.d(__webpack_exports__, "c", function() {
            return copyWithDelete;
          });
          __webpack_require__.d(__webpack_exports__, "d", function() {
            return copyWithRename;
          });
          __webpack_require__.d(__webpack_exports__, "e", function() {
            return copyWithSet;
          });
          __webpack_require__.d(__webpack_exports__, "g", function() {
            return getEffectDurations;
          });
          __webpack_require__.d(__webpack_exports__, "f", function() {
            return format;
          });
          __webpack_require__.d(__webpack_exports__, "h", function() {
            return isSynchronousXHRSupported;
          });
          var clipboard_js__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(17);
          var clipboard_js__WEBPACK_IMPORTED_MODULE_0___default = /* @__PURE__ */ __webpack_require__.n(clipboard_js__WEBPACK_IMPORTED_MODULE_0__);
          var _hydration__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(10);
          var shared_isArray__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(11);
          function _typeof(obj) {
            "@babel/helpers - typeof";
            if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
              _typeof = function _typeof2(obj2) {
                return typeof obj2;
              };
            } else {
              _typeof = function _typeof2(obj2) {
                return obj2 && typeof Symbol === "function" && obj2.constructor === Symbol && obj2 !== Symbol.prototype ? "symbol" : typeof obj2;
              };
            }
            return _typeof(obj);
          }
          function ownKeys(object, enumerableOnly) {
            var keys = Object.keys(object);
            if (Object.getOwnPropertySymbols) {
              var symbols = Object.getOwnPropertySymbols(object);
              if (enumerableOnly)
                symbols = symbols.filter(function(sym) {
                  return Object.getOwnPropertyDescriptor(object, sym).enumerable;
                });
              keys.push.apply(keys, symbols);
            }
            return keys;
          }
          function _objectSpread(target) {
            for (var i3 = 1; i3 < arguments.length; i3++) {
              var source = arguments[i3] != null ? arguments[i3] : {};
              if (i3 % 2) {
                ownKeys(Object(source), true).forEach(function(key2) {
                  _defineProperty(target, key2, source[key2]);
                });
              } else if (Object.getOwnPropertyDescriptors) {
                Object.defineProperties(target, Object.getOwnPropertyDescriptors(source));
              } else {
                ownKeys(Object(source)).forEach(function(key2) {
                  Object.defineProperty(target, key2, Object.getOwnPropertyDescriptor(source, key2));
                });
              }
            }
            return target;
          }
          function _defineProperty(obj, key2, value) {
            if (key2 in obj) {
              Object.defineProperty(obj, key2, { value, enumerable: true, configurable: true, writable: true });
            } else {
              obj[key2] = value;
            }
            return obj;
          }
          function cleanForBridge(data, isPathAllowed) {
            var path2 = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : [];
            if (data !== null) {
              var cleanedPaths = [];
              var unserializablePaths = [];
              var cleanedData = Object(_hydration__WEBPACK_IMPORTED_MODULE_1__["a"])(data, cleanedPaths, unserializablePaths, path2, isPathAllowed);
              return {
                data: cleanedData,
                cleaned: cleanedPaths,
                unserializable: unserializablePaths
              };
            } else {
              return null;
            }
          }
          function copyToClipboard(value) {
            var safeToCopy = serializeToString(value);
            var text = safeToCopy === void 0 ? "undefined" : safeToCopy;
            var clipboardCopyText = window.__REACT_DEVTOOLS_GLOBAL_HOOK__.clipboardCopyText;
            if (typeof clipboardCopyText === "function") {
              clipboardCopyText(text).catch(function(err2) {
              });
            } else {
              Object(clipboard_js__WEBPACK_IMPORTED_MODULE_0__["copy"])(text);
            }
          }
          function copyWithDelete(obj, path2) {
            var index = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : 0;
            var key2 = path2[index];
            var updated = Object(shared_isArray__WEBPACK_IMPORTED_MODULE_2__["a"])(obj) ? obj.slice() : _objectSpread({}, obj);
            if (index + 1 === path2.length) {
              if (Object(shared_isArray__WEBPACK_IMPORTED_MODULE_2__["a"])(updated)) {
                updated.splice(key2, 1);
              } else {
                delete updated[key2];
              }
            } else {
              updated[key2] = copyWithDelete(obj[key2], path2, index + 1);
            }
            return updated;
          }
          function copyWithRename(obj, oldPath, newPath) {
            var index = arguments.length > 3 && arguments[3] !== void 0 ? arguments[3] : 0;
            var oldKey = oldPath[index];
            var updated = Object(shared_isArray__WEBPACK_IMPORTED_MODULE_2__["a"])(obj) ? obj.slice() : _objectSpread({}, obj);
            if (index + 1 === oldPath.length) {
              var newKey = newPath[index];
              updated[newKey] = updated[oldKey];
              if (Object(shared_isArray__WEBPACK_IMPORTED_MODULE_2__["a"])(updated)) {
                updated.splice(oldKey, 1);
              } else {
                delete updated[oldKey];
              }
            } else {
              updated[oldKey] = copyWithRename(obj[oldKey], oldPath, newPath, index + 1);
            }
            return updated;
          }
          function copyWithSet(obj, path2, value) {
            var index = arguments.length > 3 && arguments[3] !== void 0 ? arguments[3] : 0;
            if (index >= path2.length) {
              return value;
            }
            var key2 = path2[index];
            var updated = Object(shared_isArray__WEBPACK_IMPORTED_MODULE_2__["a"])(obj) ? obj.slice() : _objectSpread({}, obj);
            updated[key2] = copyWithSet(obj[key2], path2, value, index + 1);
            return updated;
          }
          function getEffectDurations(root) {
            var effectDuration = null;
            var passiveEffectDuration = null;
            var hostRoot = root.current;
            if (hostRoot != null) {
              var stateNode = hostRoot.stateNode;
              if (stateNode != null) {
                effectDuration = stateNode.effectDuration != null ? stateNode.effectDuration : null;
                passiveEffectDuration = stateNode.passiveEffectDuration != null ? stateNode.passiveEffectDuration : null;
              }
            }
            return {
              effectDuration,
              passiveEffectDuration
            };
          }
          function serializeToString(data) {
            var cache = /* @__PURE__ */ new Set();
            return JSON.stringify(data, function(key2, value) {
              if (_typeof(value) === "object" && value !== null) {
                if (cache.has(value)) {
                  return;
                }
                cache.add(value);
              }
              if (typeof value === "bigint") {
                return value.toString() + "n";
              }
              return value;
            });
          }
          function format(maybeMessage) {
            for (var _len = arguments.length, inputArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
              inputArgs[_key - 1] = arguments[_key];
            }
            var args = inputArgs.slice();
            var formatted = _typeof(maybeMessage) === "symbol" ? maybeMessage.toString() : "" + maybeMessage;
            if (typeof maybeMessage === "string") {
              if (args.length) {
                var REGEXP = /(%?)(%([jds]))/g;
                formatted = formatted.replace(REGEXP, function(match, escaped, ptn, flag) {
                  var arg3 = args.shift();
                  switch (flag) {
                    case "s":
                      arg3 += "";
                      break;
                    case "d":
                    case "i":
                      arg3 = parseInt(arg3, 10).toString();
                      break;
                    case "f":
                      arg3 = parseFloat(arg3).toString();
                      break;
                  }
                  if (!escaped) {
                    return arg3;
                  }
                  args.unshift(arg3);
                  return match;
                });
              }
            }
            if (args.length) {
              for (var i3 = 0; i3 < args.length; i3++) {
                var arg2 = args[i3];
                formatted += " " + (_typeof(arg2) === "symbol" ? arg2.toString() : arg2);
              }
            }
            formatted = formatted.replace(/%{2,2}/g, "%");
            return "" + formatted;
          }
          function isSynchronousXHRSupported() {
            return !!(window.document && window.document.featurePolicy && window.document.featurePolicy.allowsFeature("sync-xhr"));
          }
        },
        function(module3, __webpack_exports__, __webpack_require__) {
          "use strict";
          __webpack_require__.d(__webpack_exports__, "a", function() {
            return localStorageGetItem;
          });
          __webpack_require__.d(__webpack_exports__, "b", function() {
            return localStorageSetItem;
          });
          __webpack_require__.d(__webpack_exports__, "c", function() {
            return sessionStorageGetItem;
          });
          __webpack_require__.d(__webpack_exports__, "d", function() {
            return sessionStorageRemoveItem;
          });
          __webpack_require__.d(__webpack_exports__, "e", function() {
            return sessionStorageSetItem;
          });
          function localStorageGetItem(key2) {
            try {
              return localStorage.getItem(key2);
            } catch (error) {
              return null;
            }
          }
          function localStorageRemoveItem(key2) {
            try {
              localStorage.removeItem(key2);
            } catch (error) {
            }
          }
          function localStorageSetItem(key2, value) {
            try {
              return localStorage.setItem(key2, value);
            } catch (error) {
            }
          }
          function sessionStorageGetItem(key2) {
            try {
              return sessionStorage.getItem(key2);
            } catch (error) {
              return null;
            }
          }
          function sessionStorageRemoveItem(key2) {
            try {
              sessionStorage.removeItem(key2);
            } catch (error) {
            }
          }
          function sessionStorageSetItem(key2, value) {
            try {
              return sessionStorage.setItem(key2, value);
            } catch (error) {
            }
          }
        },
        function(module3, exports3, __webpack_require__) {
          "use strict";
          if (true) {
            module3.exports = __webpack_require__(25);
          } else {
          }
        },
        function(module3, exports3, __webpack_require__) {
          "use strict";
          var getOwnPropertySymbols = Object.getOwnPropertySymbols;
          var hasOwnProperty2 = Object.prototype.hasOwnProperty;
          var propIsEnumerable = Object.prototype.propertyIsEnumerable;
          function toObject(val) {
            if (val === null || val === void 0) {
              throw new TypeError("Object.assign cannot be called with null or undefined");
            }
            return Object(val);
          }
          function shouldUseNative() {
            try {
              if (!Object.assign) {
                return false;
              }
              var test1 = new String("abc");
              test1[5] = "de";
              if (Object.getOwnPropertyNames(test1)[0] === "5") {
                return false;
              }
              var test2 = {};
              for (var i3 = 0; i3 < 10; i3++) {
                test2["_" + String.fromCharCode(i3)] = i3;
              }
              var order2 = Object.getOwnPropertyNames(test2).map(function(n2) {
                return test2[n2];
              });
              if (order2.join("") !== "0123456789") {
                return false;
              }
              var test3 = {};
              "abcdefghijklmnopqrst".split("").forEach(function(letter) {
                test3[letter] = letter;
              });
              if (Object.keys(Object.assign({}, test3)).join("") !== "abcdefghijklmnopqrst") {
                return false;
              }
              return true;
            } catch (err2) {
              return false;
            }
          }
          module3.exports = shouldUseNative() ? Object.assign : function(target, source) {
            var from;
            var to = toObject(target);
            var symbols;
            for (var s2 = 1; s2 < arguments.length; s2++) {
              from = Object(arguments[s2]);
              for (var key2 in from) {
                if (hasOwnProperty2.call(from, key2)) {
                  to[key2] = from[key2];
                }
              }
              if (getOwnPropertySymbols) {
                symbols = getOwnPropertySymbols(from);
                for (var i3 = 0; i3 < symbols.length; i3++) {
                  if (propIsEnumerable.call(from, symbols[i3])) {
                    to[symbols[i3]] = from[symbols[i3]];
                  }
                }
              }
            }
            return to;
          };
        },
        function(module3, __webpack_exports__, __webpack_require__) {
          "use strict";
          (function(global2) {
            __webpack_require__.d(__webpack_exports__, "b", function() {
              return registerRenderer;
            });
            __webpack_require__.d(__webpack_exports__, "a", function() {
              return patch;
            });
            var _utils__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(4);
            var _renderer__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(15);
            var _DevToolsFiberComponentStack__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(20);
            var react_devtools_feature_flags__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(9);
            function _createForOfIteratorHelper(o2, allowArrayLike) {
              var it;
              if (typeof Symbol === "undefined" || o2[Symbol.iterator] == null) {
                if (Array.isArray(o2) || (it = _unsupportedIterableToArray(o2)) || allowArrayLike && o2 && typeof o2.length === "number") {
                  if (it)
                    o2 = it;
                  var i3 = 0;
                  var F = function F2() {
                  };
                  return { s: F, n: function n2() {
                    if (i3 >= o2.length)
                      return { done: true };
                    return { done: false, value: o2[i3++] };
                  }, e: function e2(_e) {
                    throw _e;
                  }, f: F };
                }
                throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
              }
              var normalCompletion = true, didErr = false, err2;
              return { s: function s2() {
                it = o2[Symbol.iterator]();
              }, n: function n2() {
                var step = it.next();
                normalCompletion = step.done;
                return step;
              }, e: function e2(_e2) {
                didErr = true;
                err2 = _e2;
              }, f: function f() {
                try {
                  if (!normalCompletion && it.return != null)
                    it.return();
                } finally {
                  if (didErr)
                    throw err2;
                }
              } };
            }
            function _unsupportedIterableToArray(o2, minLen) {
              if (!o2)
                return;
              if (typeof o2 === "string")
                return _arrayLikeToArray(o2, minLen);
              var n2 = Object.prototype.toString.call(o2).slice(8, -1);
              if (n2 === "Object" && o2.constructor)
                n2 = o2.constructor.name;
              if (n2 === "Map" || n2 === "Set")
                return Array.from(o2);
              if (n2 === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n2))
                return _arrayLikeToArray(o2, minLen);
            }
            function _arrayLikeToArray(arr, len) {
              if (len == null || len > arr.length)
                len = arr.length;
              for (var i3 = 0, arr2 = new Array(len); i3 < len; i3++) {
                arr2[i3] = arr[i3];
              }
              return arr2;
            }
            var OVERRIDE_CONSOLE_METHODS = ["error", "trace", "warn", "log"];
            var DIMMED_NODE_CONSOLE_COLOR = "[2m%s[0m";
            var PREFIX_REGEX = /\s{4}(in|at)\s{1}/;
            var ROW_COLUMN_NUMBER_REGEX = /:\d+:\d+(\n|$)/;
            function isStringComponentStack(text) {
              return PREFIX_REGEX.test(text) || ROW_COLUMN_NUMBER_REGEX.test(text);
            }
            var injectedRenderers = /* @__PURE__ */ new Map();
            var targetConsole = console;
            var targetConsoleMethods = {};
            for (var method in console) {
              targetConsoleMethods[method] = console[method];
            }
            var unpatchFn = null;
            var isNode = false;
            try {
              isNode = global2 === void 0;
            } catch (error) {
            }
            function dangerous_setTargetConsoleForTesting(targetConsoleForTesting) {
              targetConsole = targetConsoleForTesting;
              targetConsoleMethods = {};
              for (var _method in targetConsole) {
                targetConsoleMethods[_method] = console[_method];
              }
            }
            function registerRenderer(renderer, onErrorOrWarning) {
              var currentDispatcherRef = renderer.currentDispatcherRef, getCurrentFiber = renderer.getCurrentFiber, getIsStrictMode = renderer.getIsStrictMode, findFiberByHostInstance = renderer.findFiberByHostInstance, version = renderer.version;
              if (typeof findFiberByHostInstance !== "function") {
                return;
              }
              if (currentDispatcherRef != null && typeof getCurrentFiber === "function") {
                var _getInternalReactCons = Object(_renderer__WEBPACK_IMPORTED_MODULE_1__["b"])(version), ReactTypeOfWork = _getInternalReactCons.ReactTypeOfWork;
                injectedRenderers.set(renderer, {
                  currentDispatcherRef,
                  getCurrentFiber,
                  getIsStrictMode,
                  workTagMap: ReactTypeOfWork,
                  onErrorOrWarning
                });
              }
            }
            var consoleSettingsRef = {
              appendComponentStack: false,
              breakOnConsoleErrors: false,
              showInlineWarningsAndErrors: false,
              hideConsoleLogsInStrictMode: false
            };
            function patch(_ref) {
              var appendComponentStack = _ref.appendComponentStack, breakOnConsoleErrors = _ref.breakOnConsoleErrors, showInlineWarningsAndErrors = _ref.showInlineWarningsAndErrors, hideConsoleLogsInStrictMode = _ref.hideConsoleLogsInStrictMode, browserTheme = _ref.browserTheme;
              consoleSettingsRef.appendComponentStack = appendComponentStack;
              consoleSettingsRef.breakOnConsoleErrors = breakOnConsoleErrors;
              consoleSettingsRef.showInlineWarningsAndErrors = showInlineWarningsAndErrors;
              consoleSettingsRef.hideConsoleLogsInStrictMode = hideConsoleLogsInStrictMode;
              if (unpatchFn !== null) {
                return;
              }
              var originalConsoleMethods = {};
              unpatchFn = function unpatchFn2() {
                for (var _method2 in originalConsoleMethods) {
                  try {
                    targetConsole[_method2] = originalConsoleMethods[_method2];
                  } catch (error) {
                  }
                }
              };
              OVERRIDE_CONSOLE_METHODS.forEach(function(method2) {
                try {
                  var originalMethod = originalConsoleMethods[method2] = targetConsole[method2].__REACT_DEVTOOLS_ORIGINAL_METHOD__ ? targetConsole[method2].__REACT_DEVTOOLS_ORIGINAL_METHOD__ : targetConsole[method2];
                  var overrideMethod = function overrideMethod2() {
                    var shouldAppendWarningStack = false;
                    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
                      args[_key] = arguments[_key];
                    }
                    if (method2 !== "log") {
                      if (consoleSettingsRef.appendComponentStack) {
                        var lastArg = args.length > 0 ? args[args.length - 1] : null;
                        var alreadyHasComponentStack = typeof lastArg === "string" && isStringComponentStack(lastArg);
                        shouldAppendWarningStack = !alreadyHasComponentStack;
                      }
                    }
                    var shouldShowInlineWarningsAndErrors = consoleSettingsRef.showInlineWarningsAndErrors && (method2 === "error" || method2 === "warn");
                    var isInStrictMode = false;
                    var _iterator = _createForOfIteratorHelper(injectedRenderers.values()), _step;
                    try {
                      for (_iterator.s(); !(_step = _iterator.n()).done; ) {
                        var _step$value = _step.value, currentDispatcherRef = _step$value.currentDispatcherRef, getCurrentFiber = _step$value.getCurrentFiber, onErrorOrWarning = _step$value.onErrorOrWarning, workTagMap = _step$value.workTagMap, getIsStrictMode = _step$value.getIsStrictMode;
                        var current = getCurrentFiber();
                        if (current != null) {
                          try {
                            if (typeof getIsStrictMode === "function" && getIsStrictMode()) {
                              isInStrictMode = true;
                            }
                            if (shouldShowInlineWarningsAndErrors) {
                              if (typeof onErrorOrWarning === "function") {
                                onErrorOrWarning(current, method2, args.slice());
                              }
                            }
                            if (shouldAppendWarningStack) {
                              var componentStack = Object(_DevToolsFiberComponentStack__WEBPACK_IMPORTED_MODULE_2__["a"])(workTagMap, current, currentDispatcherRef);
                              if (componentStack !== "") {
                                args.push(componentStack);
                              }
                            }
                          } catch (error) {
                            setTimeout(function() {
                              throw error;
                            }, 0);
                          } finally {
                            break;
                          }
                        }
                      }
                    } catch (err2) {
                      _iterator.e(err2);
                    } finally {
                      _iterator.f();
                    }
                    if (consoleSettingsRef.breakOnConsoleErrors) {
                      debugger;
                    }
                    if (react_devtools_feature_flags__WEBPACK_IMPORTED_MODULE_3__["a"] && isInStrictMode) {
                      if (!consoleSettingsRef.hideConsoleLogsInStrictMode) {
                        if (isNode) {
                          originalMethod(DIMMED_NODE_CONSOLE_COLOR, _utils__WEBPACK_IMPORTED_MODULE_0__["f"].apply(void 0, args));
                        } else {
                          var color;
                          switch (method2) {
                            case "warn":
                              color = browserTheme === "light" ? "rgba(250, 180, 50, 0.75)" : "rgba(250, 180, 50, 0.5)";
                              break;
                            case "error":
                              color = browserTheme === "light" ? "rgba(250, 123, 130, 0.75)" : "rgba(250, 123, 130, 0.5)";
                              break;
                            case "log":
                            default:
                              color = browserTheme === "light" ? "rgba(125, 125, 125, 0.75)" : "rgba(125, 125, 125, 0.5)";
                              break;
                          }
                          if (color) {
                            originalMethod("%c".concat(_utils__WEBPACK_IMPORTED_MODULE_0__["f"].apply(void 0, args)), "color: ".concat(color));
                          } else {
                            throw Error("Console color is not defined");
                          }
                        }
                      }
                    } else {
                      originalMethod.apply(void 0, args);
                    }
                  };
                  overrideMethod.__REACT_DEVTOOLS_ORIGINAL_METHOD__ = originalMethod;
                  originalMethod.__REACT_DEVTOOLS_OVERRIDE_METHOD__ = overrideMethod;
                  targetConsole[method2] = overrideMethod;
                } catch (error) {
                }
              });
            }
            function unpatch() {
              if (unpatchFn !== null) {
                unpatchFn();
                unpatchFn = null;
              }
            }
          }).call(this, __webpack_require__(13));
        },
        function(module3, __webpack_exports__, __webpack_require__) {
          "use strict";
          __webpack_require__.d(__webpack_exports__, "b", function() {
            return enableProfilerChangedHookIndices;
          });
          __webpack_require__.d(__webpack_exports__, "a", function() {
            return consoleManagedByDevToolsDuringStrictMode;
          });
          var enableProfilerChangedHookIndices = false;
          var isInternalFacebookBuild = false;
          var consoleManagedByDevToolsDuringStrictMode = false;
          null;
        },
        function(module3, __webpack_exports__, __webpack_require__) {
          "use strict";
          __webpack_require__.d(__webpack_exports__, "b", function() {
            return meta;
          });
          __webpack_require__.d(__webpack_exports__, "a", function() {
            return dehydrate;
          });
          var _utils__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(2);
          function ownKeys(object, enumerableOnly) {
            var keys = Object.keys(object);
            if (Object.getOwnPropertySymbols) {
              var symbols = Object.getOwnPropertySymbols(object);
              if (enumerableOnly)
                symbols = symbols.filter(function(sym) {
                  return Object.getOwnPropertyDescriptor(object, sym).enumerable;
                });
              keys.push.apply(keys, symbols);
            }
            return keys;
          }
          function _objectSpread(target) {
            for (var i3 = 1; i3 < arguments.length; i3++) {
              var source = arguments[i3] != null ? arguments[i3] : {};
              if (i3 % 2) {
                ownKeys(Object(source), true).forEach(function(key2) {
                  _defineProperty(target, key2, source[key2]);
                });
              } else if (Object.getOwnPropertyDescriptors) {
                Object.defineProperties(target, Object.getOwnPropertyDescriptors(source));
              } else {
                ownKeys(Object(source)).forEach(function(key2) {
                  Object.defineProperty(target, key2, Object.getOwnPropertyDescriptor(source, key2));
                });
              }
            }
            return target;
          }
          function _defineProperty(obj, key2, value) {
            if (key2 in obj) {
              Object.defineProperty(obj, key2, { value, enumerable: true, configurable: true, writable: true });
            } else {
              obj[key2] = value;
            }
            return obj;
          }
          var meta = {
            inspectable: Symbol("inspectable"),
            inspected: Symbol("inspected"),
            name: Symbol("name"),
            preview_long: Symbol("preview_long"),
            preview_short: Symbol("preview_short"),
            readonly: Symbol("readonly"),
            size: Symbol("size"),
            type: Symbol("type"),
            unserializable: Symbol("unserializable")
          };
          var LEVEL_THRESHOLD = 2;
          function createDehydrated(type3, inspectable, data, cleaned, path2) {
            cleaned.push(path2);
            var dehydrated = {
              inspectable,
              type: type3,
              preview_long: Object(_utils__WEBPACK_IMPORTED_MODULE_0__["b"])(data, true),
              preview_short: Object(_utils__WEBPACK_IMPORTED_MODULE_0__["b"])(data, false),
              name: !data.constructor || data.constructor.name === "Object" ? "" : data.constructor.name
            };
            if (type3 === "array" || type3 === "typed_array") {
              dehydrated.size = data.length;
            } else if (type3 === "object") {
              dehydrated.size = Object.keys(data).length;
            }
            if (type3 === "iterator" || type3 === "typed_array") {
              dehydrated.readonly = true;
            }
            return dehydrated;
          }
          function dehydrate(data, cleaned, unserializable, path2, isPathAllowed) {
            var level = arguments.length > 5 && arguments[5] !== void 0 ? arguments[5] : 0;
            var type3 = Object(_utils__WEBPACK_IMPORTED_MODULE_0__["d"])(data);
            var isPathAllowedCheck;
            switch (type3) {
              case "html_element":
                cleaned.push(path2);
                return {
                  inspectable: false,
                  preview_short: Object(_utils__WEBPACK_IMPORTED_MODULE_0__["b"])(data, false),
                  preview_long: Object(_utils__WEBPACK_IMPORTED_MODULE_0__["b"])(data, true),
                  name: data.tagName,
                  type: type3
                };
              case "function":
                cleaned.push(path2);
                return {
                  inspectable: false,
                  preview_short: Object(_utils__WEBPACK_IMPORTED_MODULE_0__["b"])(data, false),
                  preview_long: Object(_utils__WEBPACK_IMPORTED_MODULE_0__["b"])(data, true),
                  name: typeof data.name === "function" || !data.name ? "function" : data.name,
                  type: type3
                };
              case "string":
                isPathAllowedCheck = isPathAllowed(path2);
                if (isPathAllowedCheck) {
                  return data;
                } else {
                  return data.length <= 500 ? data : data.slice(0, 500) + "...";
                }
              case "bigint":
                cleaned.push(path2);
                return {
                  inspectable: false,
                  preview_short: Object(_utils__WEBPACK_IMPORTED_MODULE_0__["b"])(data, false),
                  preview_long: Object(_utils__WEBPACK_IMPORTED_MODULE_0__["b"])(data, true),
                  name: data.toString(),
                  type: type3
                };
              case "symbol":
                cleaned.push(path2);
                return {
                  inspectable: false,
                  preview_short: Object(_utils__WEBPACK_IMPORTED_MODULE_0__["b"])(data, false),
                  preview_long: Object(_utils__WEBPACK_IMPORTED_MODULE_0__["b"])(data, true),
                  name: data.toString(),
                  type: type3
                };
              case "react_element":
                cleaned.push(path2);
                return {
                  inspectable: false,
                  preview_short: Object(_utils__WEBPACK_IMPORTED_MODULE_0__["b"])(data, false),
                  preview_long: Object(_utils__WEBPACK_IMPORTED_MODULE_0__["b"])(data, true),
                  name: Object(_utils__WEBPACK_IMPORTED_MODULE_0__["g"])(data) || "Unknown",
                  type: type3
                };
              case "array_buffer":
              case "data_view":
                cleaned.push(path2);
                return {
                  inspectable: false,
                  preview_short: Object(_utils__WEBPACK_IMPORTED_MODULE_0__["b"])(data, false),
                  preview_long: Object(_utils__WEBPACK_IMPORTED_MODULE_0__["b"])(data, true),
                  name: type3 === "data_view" ? "DataView" : "ArrayBuffer",
                  size: data.byteLength,
                  type: type3
                };
              case "array":
                isPathAllowedCheck = isPathAllowed(path2);
                if (level >= LEVEL_THRESHOLD && !isPathAllowedCheck) {
                  return createDehydrated(type3, true, data, cleaned, path2);
                }
                return data.map(function(item, i3) {
                  return dehydrate(item, cleaned, unserializable, path2.concat([i3]), isPathAllowed, isPathAllowedCheck ? 1 : level + 1);
                });
              case "html_all_collection":
              case "typed_array":
              case "iterator":
                isPathAllowedCheck = isPathAllowed(path2);
                if (level >= LEVEL_THRESHOLD && !isPathAllowedCheck) {
                  return createDehydrated(type3, true, data, cleaned, path2);
                } else {
                  var unserializableValue = {
                    unserializable: true,
                    type: type3,
                    readonly: true,
                    size: type3 === "typed_array" ? data.length : void 0,
                    preview_short: Object(_utils__WEBPACK_IMPORTED_MODULE_0__["b"])(data, false),
                    preview_long: Object(_utils__WEBPACK_IMPORTED_MODULE_0__["b"])(data, true),
                    name: !data.constructor || data.constructor.name === "Object" ? "" : data.constructor.name
                  };
                  Array.from(data).forEach(function(item, i3) {
                    return unserializableValue[i3] = dehydrate(item, cleaned, unserializable, path2.concat([i3]), isPathAllowed, isPathAllowedCheck ? 1 : level + 1);
                  });
                  unserializable.push(path2);
                  return unserializableValue;
                }
              case "opaque_iterator":
                cleaned.push(path2);
                return {
                  inspectable: false,
                  preview_short: Object(_utils__WEBPACK_IMPORTED_MODULE_0__["b"])(data, false),
                  preview_long: Object(_utils__WEBPACK_IMPORTED_MODULE_0__["b"])(data, true),
                  name: data[Symbol.toStringTag],
                  type: type3
                };
              case "date":
                cleaned.push(path2);
                return {
                  inspectable: false,
                  preview_short: Object(_utils__WEBPACK_IMPORTED_MODULE_0__["b"])(data, false),
                  preview_long: Object(_utils__WEBPACK_IMPORTED_MODULE_0__["b"])(data, true),
                  name: data.toString(),
                  type: type3
                };
              case "regexp":
                cleaned.push(path2);
                return {
                  inspectable: false,
                  preview_short: Object(_utils__WEBPACK_IMPORTED_MODULE_0__["b"])(data, false),
                  preview_long: Object(_utils__WEBPACK_IMPORTED_MODULE_0__["b"])(data, true),
                  name: data.toString(),
                  type: type3
                };
              case "object":
                isPathAllowedCheck = isPathAllowed(path2);
                if (level >= LEVEL_THRESHOLD && !isPathAllowedCheck) {
                  return createDehydrated(type3, true, data, cleaned, path2);
                } else {
                  var object = {};
                  Object(_utils__WEBPACK_IMPORTED_MODULE_0__["c"])(data).forEach(function(key2) {
                    var name = key2.toString();
                    object[name] = dehydrate(data[key2], cleaned, unserializable, path2.concat([name]), isPathAllowed, isPathAllowedCheck ? 1 : level + 1);
                  });
                  return object;
                }
              case "infinity":
              case "nan":
              case "undefined":
                cleaned.push(path2);
                return {
                  type: type3
                };
              default:
                return data;
            }
          }
          function fillInPath(object, data, path2, value) {
            var target = Object(_utils__WEBPACK_IMPORTED_MODULE_0__["h"])(object, path2);
            if (target != null) {
              if (!target[meta.unserializable]) {
                delete target[meta.inspectable];
                delete target[meta.inspected];
                delete target[meta.name];
                delete target[meta.preview_long];
                delete target[meta.preview_short];
                delete target[meta.readonly];
                delete target[meta.size];
                delete target[meta.type];
              }
            }
            if (value !== null && data.unserializable.length > 0) {
              var unserializablePath = data.unserializable[0];
              var isMatch = unserializablePath.length === path2.length;
              for (var i3 = 0; i3 < path2.length; i3++) {
                if (path2[i3] !== unserializablePath[i3]) {
                  isMatch = false;
                  break;
                }
              }
              if (isMatch) {
                upgradeUnserializable(value, value);
              }
            }
            Object(_utils__WEBPACK_IMPORTED_MODULE_0__["l"])(object, path2, value);
          }
          function hydrate(object, cleaned, unserializable) {
            cleaned.forEach(function(path2) {
              var length = path2.length;
              var last = path2[length - 1];
              var parent = Object(_utils__WEBPACK_IMPORTED_MODULE_0__["h"])(object, path2.slice(0, length - 1));
              if (!parent || !parent.hasOwnProperty(last)) {
                return;
              }
              var value = parent[last];
              if (!value) {
                return;
              } else if (value.type === "infinity") {
                parent[last] = Infinity;
              } else if (value.type === "nan") {
                parent[last] = NaN;
              } else if (value.type === "undefined") {
                parent[last] = void 0;
              } else {
                var replaced = {};
                replaced[meta.inspectable] = !!value.inspectable;
                replaced[meta.inspected] = false;
                replaced[meta.name] = value.name;
                replaced[meta.preview_long] = value.preview_long;
                replaced[meta.preview_short] = value.preview_short;
                replaced[meta.size] = value.size;
                replaced[meta.readonly] = !!value.readonly;
                replaced[meta.type] = value.type;
                parent[last] = replaced;
              }
            });
            unserializable.forEach(function(path2) {
              var length = path2.length;
              var last = path2[length - 1];
              var parent = Object(_utils__WEBPACK_IMPORTED_MODULE_0__["h"])(object, path2.slice(0, length - 1));
              if (!parent || !parent.hasOwnProperty(last)) {
                return;
              }
              var node = parent[last];
              var replacement = _objectSpread({}, node);
              upgradeUnserializable(replacement, node);
              parent[last] = replacement;
            });
            return object;
          }
          function upgradeUnserializable(destination, source) {
            var _Object$definePropert;
            Object.defineProperties(destination, (_Object$definePropert = {}, _defineProperty(_Object$definePropert, meta.inspected, {
              configurable: true,
              enumerable: false,
              value: !!source.inspected
            }), _defineProperty(_Object$definePropert, meta.name, {
              configurable: true,
              enumerable: false,
              value: source.name
            }), _defineProperty(_Object$definePropert, meta.preview_long, {
              configurable: true,
              enumerable: false,
              value: source.preview_long
            }), _defineProperty(_Object$definePropert, meta.preview_short, {
              configurable: true,
              enumerable: false,
              value: source.preview_short
            }), _defineProperty(_Object$definePropert, meta.size, {
              configurable: true,
              enumerable: false,
              value: source.size
            }), _defineProperty(_Object$definePropert, meta.readonly, {
              configurable: true,
              enumerable: false,
              value: !!source.readonly
            }), _defineProperty(_Object$definePropert, meta.type, {
              configurable: true,
              enumerable: false,
              value: source.type
            }), _defineProperty(_Object$definePropert, meta.unserializable, {
              configurable: true,
              enumerable: false,
              value: !!source.unserializable
            }), _Object$definePropert));
            delete destination.inspected;
            delete destination.name;
            delete destination.preview_long;
            delete destination.preview_short;
            delete destination.size;
            delete destination.readonly;
            delete destination.type;
            delete destination.unserializable;
          }
        },
        function(module3, __webpack_exports__, __webpack_require__) {
          "use strict";
          var isArrayImpl = Array.isArray;
          function isArray(a2) {
            return isArrayImpl(a2);
          }
          __webpack_exports__["a"] = isArray;
        },
        function(module3, exports3, __webpack_require__) {
          (function(process2) {
            function _typeof(obj) {
              "@babel/helpers - typeof";
              if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
                _typeof = function _typeof2(obj2) {
                  return typeof obj2;
                };
              } else {
                _typeof = function _typeof2(obj2) {
                  return obj2 && typeof Symbol === "function" && obj2.constructor === Symbol && obj2 !== Symbol.prototype ? "symbol" : typeof obj2;
                };
              }
              return _typeof(obj);
            }
            exports3 = module3.exports = SemVer;
            var debug;
            if ((typeof process2 === "undefined" ? "undefined" : _typeof(process2)) === "object" && process2.env && process2.env.NODE_DEBUG && /\bsemver\b/i.test(process2.env.NODE_DEBUG)) {
              debug = function debug2() {
                var args = Array.prototype.slice.call(arguments, 0);
                args.unshift("SEMVER");
                console.log.apply(console, args);
              };
            } else {
              debug = function debug2() {
              };
            }
            exports3.SEMVER_SPEC_VERSION = "2.0.0";
            var MAX_LENGTH = 256;
            var MAX_SAFE_INTEGER = Number.MAX_SAFE_INTEGER || 9007199254740991;
            var MAX_SAFE_COMPONENT_LENGTH = 16;
            var re = exports3.re = [];
            var src = exports3.src = [];
            var t2 = exports3.tokens = {};
            var R = 0;
            function tok(n2) {
              t2[n2] = R++;
            }
            tok("NUMERICIDENTIFIER");
            src[t2.NUMERICIDENTIFIER] = "0|[1-9]\\d*";
            tok("NUMERICIDENTIFIERLOOSE");
            src[t2.NUMERICIDENTIFIERLOOSE] = "[0-9]+";
            tok("NONNUMERICIDENTIFIER");
            src[t2.NONNUMERICIDENTIFIER] = "\\d*[a-zA-Z-][a-zA-Z0-9-]*";
            tok("MAINVERSION");
            src[t2.MAINVERSION] = "(" + src[t2.NUMERICIDENTIFIER] + ")\\.(" + src[t2.NUMERICIDENTIFIER] + ")\\.(" + src[t2.NUMERICIDENTIFIER] + ")";
            tok("MAINVERSIONLOOSE");
            src[t2.MAINVERSIONLOOSE] = "(" + src[t2.NUMERICIDENTIFIERLOOSE] + ")\\.(" + src[t2.NUMERICIDENTIFIERLOOSE] + ")\\.(" + src[t2.NUMERICIDENTIFIERLOOSE] + ")";
            tok("PRERELEASEIDENTIFIER");
            src[t2.PRERELEASEIDENTIFIER] = "(?:" + src[t2.NUMERICIDENTIFIER] + "|" + src[t2.NONNUMERICIDENTIFIER] + ")";
            tok("PRERELEASEIDENTIFIERLOOSE");
            src[t2.PRERELEASEIDENTIFIERLOOSE] = "(?:" + src[t2.NUMERICIDENTIFIERLOOSE] + "|" + src[t2.NONNUMERICIDENTIFIER] + ")";
            tok("PRERELEASE");
            src[t2.PRERELEASE] = "(?:-(" + src[t2.PRERELEASEIDENTIFIER] + "(?:\\." + src[t2.PRERELEASEIDENTIFIER] + ")*))";
            tok("PRERELEASELOOSE");
            src[t2.PRERELEASELOOSE] = "(?:-?(" + src[t2.PRERELEASEIDENTIFIERLOOSE] + "(?:\\." + src[t2.PRERELEASEIDENTIFIERLOOSE] + ")*))";
            tok("BUILDIDENTIFIER");
            src[t2.BUILDIDENTIFIER] = "[0-9A-Za-z-]+";
            tok("BUILD");
            src[t2.BUILD] = "(?:\\+(" + src[t2.BUILDIDENTIFIER] + "(?:\\." + src[t2.BUILDIDENTIFIER] + ")*))";
            tok("FULL");
            tok("FULLPLAIN");
            src[t2.FULLPLAIN] = "v?" + src[t2.MAINVERSION] + src[t2.PRERELEASE] + "?" + src[t2.BUILD] + "?";
            src[t2.FULL] = "^" + src[t2.FULLPLAIN] + "$";
            tok("LOOSEPLAIN");
            src[t2.LOOSEPLAIN] = "[v=\\s]*" + src[t2.MAINVERSIONLOOSE] + src[t2.PRERELEASELOOSE] + "?" + src[t2.BUILD] + "?";
            tok("LOOSE");
            src[t2.LOOSE] = "^" + src[t2.LOOSEPLAIN] + "$";
            tok("GTLT");
            src[t2.GTLT] = "((?:<|>)?=?)";
            tok("XRANGEIDENTIFIERLOOSE");
            src[t2.XRANGEIDENTIFIERLOOSE] = src[t2.NUMERICIDENTIFIERLOOSE] + "|x|X|\\*";
            tok("XRANGEIDENTIFIER");
            src[t2.XRANGEIDENTIFIER] = src[t2.NUMERICIDENTIFIER] + "|x|X|\\*";
            tok("XRANGEPLAIN");
            src[t2.XRANGEPLAIN] = "[v=\\s]*(" + src[t2.XRANGEIDENTIFIER] + ")(?:\\.(" + src[t2.XRANGEIDENTIFIER] + ")(?:\\.(" + src[t2.XRANGEIDENTIFIER] + ")(?:" + src[t2.PRERELEASE] + ")?" + src[t2.BUILD] + "?)?)?";
            tok("XRANGEPLAINLOOSE");
            src[t2.XRANGEPLAINLOOSE] = "[v=\\s]*(" + src[t2.XRANGEIDENTIFIERLOOSE] + ")(?:\\.(" + src[t2.XRANGEIDENTIFIERLOOSE] + ")(?:\\.(" + src[t2.XRANGEIDENTIFIERLOOSE] + ")(?:" + src[t2.PRERELEASELOOSE] + ")?" + src[t2.BUILD] + "?)?)?";
            tok("XRANGE");
            src[t2.XRANGE] = "^" + src[t2.GTLT] + "\\s*" + src[t2.XRANGEPLAIN] + "$";
            tok("XRANGELOOSE");
            src[t2.XRANGELOOSE] = "^" + src[t2.GTLT] + "\\s*" + src[t2.XRANGEPLAINLOOSE] + "$";
            tok("COERCE");
            src[t2.COERCE] = "(^|[^\\d])(\\d{1," + MAX_SAFE_COMPONENT_LENGTH + "})(?:\\.(\\d{1," + MAX_SAFE_COMPONENT_LENGTH + "}))?(?:\\.(\\d{1," + MAX_SAFE_COMPONENT_LENGTH + "}))?(?:$|[^\\d])";
            tok("COERCERTL");
            re[t2.COERCERTL] = new RegExp(src[t2.COERCE], "g");
            tok("LONETILDE");
            src[t2.LONETILDE] = "(?:~>?)";
            tok("TILDETRIM");
            src[t2.TILDETRIM] = "(\\s*)" + src[t2.LONETILDE] + "\\s+";
            re[t2.TILDETRIM] = new RegExp(src[t2.TILDETRIM], "g");
            var tildeTrimReplace = "$1~";
            tok("TILDE");
            src[t2.TILDE] = "^" + src[t2.LONETILDE] + src[t2.XRANGEPLAIN] + "$";
            tok("TILDELOOSE");
            src[t2.TILDELOOSE] = "^" + src[t2.LONETILDE] + src[t2.XRANGEPLAINLOOSE] + "$";
            tok("LONECARET");
            src[t2.LONECARET] = "(?:\\^)";
            tok("CARETTRIM");
            src[t2.CARETTRIM] = "(\\s*)" + src[t2.LONECARET] + "\\s+";
            re[t2.CARETTRIM] = new RegExp(src[t2.CARETTRIM], "g");
            var caretTrimReplace = "$1^";
            tok("CARET");
            src[t2.CARET] = "^" + src[t2.LONECARET] + src[t2.XRANGEPLAIN] + "$";
            tok("CARETLOOSE");
            src[t2.CARETLOOSE] = "^" + src[t2.LONECARET] + src[t2.XRANGEPLAINLOOSE] + "$";
            tok("COMPARATORLOOSE");
            src[t2.COMPARATORLOOSE] = "^" + src[t2.GTLT] + "\\s*(" + src[t2.LOOSEPLAIN] + ")$|^$";
            tok("COMPARATOR");
            src[t2.COMPARATOR] = "^" + src[t2.GTLT] + "\\s*(" + src[t2.FULLPLAIN] + ")$|^$";
            tok("COMPARATORTRIM");
            src[t2.COMPARATORTRIM] = "(\\s*)" + src[t2.GTLT] + "\\s*(" + src[t2.LOOSEPLAIN] + "|" + src[t2.XRANGEPLAIN] + ")";
            re[t2.COMPARATORTRIM] = new RegExp(src[t2.COMPARATORTRIM], "g");
            var comparatorTrimReplace = "$1$2$3";
            tok("HYPHENRANGE");
            src[t2.HYPHENRANGE] = "^\\s*(" + src[t2.XRANGEPLAIN] + ")\\s+-\\s+(" + src[t2.XRANGEPLAIN] + ")\\s*$";
            tok("HYPHENRANGELOOSE");
            src[t2.HYPHENRANGELOOSE] = "^\\s*(" + src[t2.XRANGEPLAINLOOSE] + ")\\s+-\\s+(" + src[t2.XRANGEPLAINLOOSE] + ")\\s*$";
            tok("STAR");
            src[t2.STAR] = "(<|>)?=?\\s*\\*";
            for (var i3 = 0; i3 < R; i3++) {
              debug(i3, src[i3]);
              if (!re[i3]) {
                re[i3] = new RegExp(src[i3]);
              }
            }
            exports3.parse = parse;
            function parse(version, options) {
              if (!options || _typeof(options) !== "object") {
                options = {
                  loose: !!options,
                  includePrerelease: false
                };
              }
              if (version instanceof SemVer) {
                return version;
              }
              if (typeof version !== "string") {
                return null;
              }
              if (version.length > MAX_LENGTH) {
                return null;
              }
              var r2 = options.loose ? re[t2.LOOSE] : re[t2.FULL];
              if (!r2.test(version)) {
                return null;
              }
              try {
                return new SemVer(version, options);
              } catch (er) {
                return null;
              }
            }
            exports3.valid = valid;
            function valid(version, options) {
              var v = parse(version, options);
              return v ? v.version : null;
            }
            exports3.clean = clean;
            function clean(version, options) {
              var s2 = parse(version.trim().replace(/^[=v]+/, ""), options);
              return s2 ? s2.version : null;
            }
            exports3.SemVer = SemVer;
            function SemVer(version, options) {
              if (!options || _typeof(options) !== "object") {
                options = {
                  loose: !!options,
                  includePrerelease: false
                };
              }
              if (version instanceof SemVer) {
                if (version.loose === options.loose) {
                  return version;
                } else {
                  version = version.version;
                }
              } else if (typeof version !== "string") {
                throw new TypeError("Invalid Version: " + version);
              }
              if (version.length > MAX_LENGTH) {
                throw new TypeError("version is longer than " + MAX_LENGTH + " characters");
              }
              if (!(this instanceof SemVer)) {
                return new SemVer(version, options);
              }
              debug("SemVer", version, options);
              this.options = options;
              this.loose = !!options.loose;
              var m = version.trim().match(options.loose ? re[t2.LOOSE] : re[t2.FULL]);
              if (!m) {
                throw new TypeError("Invalid Version: " + version);
              }
              this.raw = version;
              this.major = +m[1];
              this.minor = +m[2];
              this.patch = +m[3];
              if (this.major > MAX_SAFE_INTEGER || this.major < 0) {
                throw new TypeError("Invalid major version");
              }
              if (this.minor > MAX_SAFE_INTEGER || this.minor < 0) {
                throw new TypeError("Invalid minor version");
              }
              if (this.patch > MAX_SAFE_INTEGER || this.patch < 0) {
                throw new TypeError("Invalid patch version");
              }
              if (!m[4]) {
                this.prerelease = [];
              } else {
                this.prerelease = m[4].split(".").map(function(id) {
                  if (/^[0-9]+$/.test(id)) {
                    var num2 = +id;
                    if (num2 >= 0 && num2 < MAX_SAFE_INTEGER) {
                      return num2;
                    }
                  }
                  return id;
                });
              }
              this.build = m[5] ? m[5].split(".") : [];
              this.format();
            }
            SemVer.prototype.format = function() {
              this.version = this.major + "." + this.minor + "." + this.patch;
              if (this.prerelease.length) {
                this.version += "-" + this.prerelease.join(".");
              }
              return this.version;
            };
            SemVer.prototype.toString = function() {
              return this.version;
            };
            SemVer.prototype.compare = function(other) {
              debug("SemVer.compare", this.version, this.options, other);
              if (!(other instanceof SemVer)) {
                other = new SemVer(other, this.options);
              }
              return this.compareMain(other) || this.comparePre(other);
            };
            SemVer.prototype.compareMain = function(other) {
              if (!(other instanceof SemVer)) {
                other = new SemVer(other, this.options);
              }
              return compareIdentifiers(this.major, other.major) || compareIdentifiers(this.minor, other.minor) || compareIdentifiers(this.patch, other.patch);
            };
            SemVer.prototype.comparePre = function(other) {
              if (!(other instanceof SemVer)) {
                other = new SemVer(other, this.options);
              }
              if (this.prerelease.length && !other.prerelease.length) {
                return -1;
              } else if (!this.prerelease.length && other.prerelease.length) {
                return 1;
              } else if (!this.prerelease.length && !other.prerelease.length) {
                return 0;
              }
              var i4 = 0;
              do {
                var a2 = this.prerelease[i4];
                var b2 = other.prerelease[i4];
                debug("prerelease compare", i4, a2, b2);
                if (a2 === void 0 && b2 === void 0) {
                  return 0;
                } else if (b2 === void 0) {
                  return 1;
                } else if (a2 === void 0) {
                  return -1;
                } else if (a2 === b2) {
                  continue;
                } else {
                  return compareIdentifiers(a2, b2);
                }
              } while (++i4);
            };
            SemVer.prototype.compareBuild = function(other) {
              if (!(other instanceof SemVer)) {
                other = new SemVer(other, this.options);
              }
              var i4 = 0;
              do {
                var a2 = this.build[i4];
                var b2 = other.build[i4];
                debug("prerelease compare", i4, a2, b2);
                if (a2 === void 0 && b2 === void 0) {
                  return 0;
                } else if (b2 === void 0) {
                  return 1;
                } else if (a2 === void 0) {
                  return -1;
                } else if (a2 === b2) {
                  continue;
                } else {
                  return compareIdentifiers(a2, b2);
                }
              } while (++i4);
            };
            SemVer.prototype.inc = function(release, identifier) {
              switch (release) {
                case "premajor":
                  this.prerelease.length = 0;
                  this.patch = 0;
                  this.minor = 0;
                  this.major++;
                  this.inc("pre", identifier);
                  break;
                case "preminor":
                  this.prerelease.length = 0;
                  this.patch = 0;
                  this.minor++;
                  this.inc("pre", identifier);
                  break;
                case "prepatch":
                  this.prerelease.length = 0;
                  this.inc("patch", identifier);
                  this.inc("pre", identifier);
                  break;
                case "prerelease":
                  if (this.prerelease.length === 0) {
                    this.inc("patch", identifier);
                  }
                  this.inc("pre", identifier);
                  break;
                case "major":
                  if (this.minor !== 0 || this.patch !== 0 || this.prerelease.length === 0) {
                    this.major++;
                  }
                  this.minor = 0;
                  this.patch = 0;
                  this.prerelease = [];
                  break;
                case "minor":
                  if (this.patch !== 0 || this.prerelease.length === 0) {
                    this.minor++;
                  }
                  this.patch = 0;
                  this.prerelease = [];
                  break;
                case "patch":
                  if (this.prerelease.length === 0) {
                    this.patch++;
                  }
                  this.prerelease = [];
                  break;
                case "pre":
                  if (this.prerelease.length === 0) {
                    this.prerelease = [0];
                  } else {
                    var i4 = this.prerelease.length;
                    while (--i4 >= 0) {
                      if (typeof this.prerelease[i4] === "number") {
                        this.prerelease[i4]++;
                        i4 = -2;
                      }
                    }
                    if (i4 === -1) {
                      this.prerelease.push(0);
                    }
                  }
                  if (identifier) {
                    if (this.prerelease[0] === identifier) {
                      if (isNaN(this.prerelease[1])) {
                        this.prerelease = [identifier, 0];
                      }
                    } else {
                      this.prerelease = [identifier, 0];
                    }
                  }
                  break;
                default:
                  throw new Error("invalid increment argument: " + release);
              }
              this.format();
              this.raw = this.version;
              return this;
            };
            exports3.inc = inc;
            function inc(version, release, loose, identifier) {
              if (typeof loose === "string") {
                identifier = loose;
                loose = void 0;
              }
              try {
                return new SemVer(version, loose).inc(release, identifier).version;
              } catch (er) {
                return null;
              }
            }
            exports3.diff = diff2;
            function diff2(version1, version2) {
              if (eq(version1, version2)) {
                return null;
              } else {
                var v1 = parse(version1);
                var v2 = parse(version2);
                var prefix2 = "";
                if (v1.prerelease.length || v2.prerelease.length) {
                  prefix2 = "pre";
                  var defaultResult = "prerelease";
                }
                for (var key2 in v1) {
                  if (key2 === "major" || key2 === "minor" || key2 === "patch") {
                    if (v1[key2] !== v2[key2]) {
                      return prefix2 + key2;
                    }
                  }
                }
                return defaultResult;
              }
            }
            exports3.compareIdentifiers = compareIdentifiers;
            var numeric = /^[0-9]+$/;
            function compareIdentifiers(a2, b2) {
              var anum = numeric.test(a2);
              var bnum = numeric.test(b2);
              if (anum && bnum) {
                a2 = +a2;
                b2 = +b2;
              }
              return a2 === b2 ? 0 : anum && !bnum ? -1 : bnum && !anum ? 1 : a2 < b2 ? -1 : 1;
            }
            exports3.rcompareIdentifiers = rcompareIdentifiers;
            function rcompareIdentifiers(a2, b2) {
              return compareIdentifiers(b2, a2);
            }
            exports3.major = major;
            function major(a2, loose) {
              return new SemVer(a2, loose).major;
            }
            exports3.minor = minor;
            function minor(a2, loose) {
              return new SemVer(a2, loose).minor;
            }
            exports3.patch = patch;
            function patch(a2, loose) {
              return new SemVer(a2, loose).patch;
            }
            exports3.compare = compare;
            function compare(a2, b2, loose) {
              return new SemVer(a2, loose).compare(new SemVer(b2, loose));
            }
            exports3.compareLoose = compareLoose;
            function compareLoose(a2, b2) {
              return compare(a2, b2, true);
            }
            exports3.compareBuild = compareBuild;
            function compareBuild(a2, b2, loose) {
              var versionA = new SemVer(a2, loose);
              var versionB = new SemVer(b2, loose);
              return versionA.compare(versionB) || versionA.compareBuild(versionB);
            }
            exports3.rcompare = rcompare;
            function rcompare(a2, b2, loose) {
              return compare(b2, a2, loose);
            }
            exports3.sort = sort;
            function sort(list, loose) {
              return list.sort(function(a2, b2) {
                return exports3.compareBuild(a2, b2, loose);
              });
            }
            exports3.rsort = rsort;
            function rsort(list, loose) {
              return list.sort(function(a2, b2) {
                return exports3.compareBuild(b2, a2, loose);
              });
            }
            exports3.gt = gt;
            function gt(a2, b2, loose) {
              return compare(a2, b2, loose) > 0;
            }
            exports3.lt = lt;
            function lt(a2, b2, loose) {
              return compare(a2, b2, loose) < 0;
            }
            exports3.eq = eq;
            function eq(a2, b2, loose) {
              return compare(a2, b2, loose) === 0;
            }
            exports3.neq = neq;
            function neq(a2, b2, loose) {
              return compare(a2, b2, loose) !== 0;
            }
            exports3.gte = gte;
            function gte(a2, b2, loose) {
              return compare(a2, b2, loose) >= 0;
            }
            exports3.lte = lte;
            function lte(a2, b2, loose) {
              return compare(a2, b2, loose) <= 0;
            }
            exports3.cmp = cmp;
            function cmp(a2, op, b2, loose) {
              switch (op) {
                case "===":
                  if (_typeof(a2) === "object")
                    a2 = a2.version;
                  if (_typeof(b2) === "object")
                    b2 = b2.version;
                  return a2 === b2;
                case "!==":
                  if (_typeof(a2) === "object")
                    a2 = a2.version;
                  if (_typeof(b2) === "object")
                    b2 = b2.version;
                  return a2 !== b2;
                case "":
                case "=":
                case "==":
                  return eq(a2, b2, loose);
                case "!=":
                  return neq(a2, b2, loose);
                case ">":
                  return gt(a2, b2, loose);
                case ">=":
                  return gte(a2, b2, loose);
                case "<":
                  return lt(a2, b2, loose);
                case "<=":
                  return lte(a2, b2, loose);
                default:
                  throw new TypeError("Invalid operator: " + op);
              }
            }
            exports3.Comparator = Comparator;
            function Comparator(comp, options) {
              if (!options || _typeof(options) !== "object") {
                options = {
                  loose: !!options,
                  includePrerelease: false
                };
              }
              if (comp instanceof Comparator) {
                if (comp.loose === !!options.loose) {
                  return comp;
                } else {
                  comp = comp.value;
                }
              }
              if (!(this instanceof Comparator)) {
                return new Comparator(comp, options);
              }
              debug("comparator", comp, options);
              this.options = options;
              this.loose = !!options.loose;
              this.parse(comp);
              if (this.semver === ANY) {
                this.value = "";
              } else {
                this.value = this.operator + this.semver.version;
              }
              debug("comp", this);
            }
            var ANY = {};
            Comparator.prototype.parse = function(comp) {
              var r2 = this.options.loose ? re[t2.COMPARATORLOOSE] : re[t2.COMPARATOR];
              var m = comp.match(r2);
              if (!m) {
                throw new TypeError("Invalid comparator: " + comp);
              }
              this.operator = m[1] !== void 0 ? m[1] : "";
              if (this.operator === "=") {
                this.operator = "";
              }
              if (!m[2]) {
                this.semver = ANY;
              } else {
                this.semver = new SemVer(m[2], this.options.loose);
              }
            };
            Comparator.prototype.toString = function() {
              return this.value;
            };
            Comparator.prototype.test = function(version) {
              debug("Comparator.test", version, this.options.loose);
              if (this.semver === ANY || version === ANY) {
                return true;
              }
              if (typeof version === "string") {
                try {
                  version = new SemVer(version, this.options);
                } catch (er) {
                  return false;
                }
              }
              return cmp(version, this.operator, this.semver, this.options);
            };
            Comparator.prototype.intersects = function(comp, options) {
              if (!(comp instanceof Comparator)) {
                throw new TypeError("a Comparator is required");
              }
              if (!options || _typeof(options) !== "object") {
                options = {
                  loose: !!options,
                  includePrerelease: false
                };
              }
              var rangeTmp;
              if (this.operator === "") {
                if (this.value === "") {
                  return true;
                }
                rangeTmp = new Range(comp.value, options);
                return satisfies(this.value, rangeTmp, options);
              } else if (comp.operator === "") {
                if (comp.value === "") {
                  return true;
                }
                rangeTmp = new Range(this.value, options);
                return satisfies(comp.semver, rangeTmp, options);
              }
              var sameDirectionIncreasing = (this.operator === ">=" || this.operator === ">") && (comp.operator === ">=" || comp.operator === ">");
              var sameDirectionDecreasing = (this.operator === "<=" || this.operator === "<") && (comp.operator === "<=" || comp.operator === "<");
              var sameSemVer = this.semver.version === comp.semver.version;
              var differentDirectionsInclusive = (this.operator === ">=" || this.operator === "<=") && (comp.operator === ">=" || comp.operator === "<=");
              var oppositeDirectionsLessThan = cmp(this.semver, "<", comp.semver, options) && (this.operator === ">=" || this.operator === ">") && (comp.operator === "<=" || comp.operator === "<");
              var oppositeDirectionsGreaterThan = cmp(this.semver, ">", comp.semver, options) && (this.operator === "<=" || this.operator === "<") && (comp.operator === ">=" || comp.operator === ">");
              return sameDirectionIncreasing || sameDirectionDecreasing || sameSemVer && differentDirectionsInclusive || oppositeDirectionsLessThan || oppositeDirectionsGreaterThan;
            };
            exports3.Range = Range;
            function Range(range, options) {
              if (!options || _typeof(options) !== "object") {
                options = {
                  loose: !!options,
                  includePrerelease: false
                };
              }
              if (range instanceof Range) {
                if (range.loose === !!options.loose && range.includePrerelease === !!options.includePrerelease) {
                  return range;
                } else {
                  return new Range(range.raw, options);
                }
              }
              if (range instanceof Comparator) {
                return new Range(range.value, options);
              }
              if (!(this instanceof Range)) {
                return new Range(range, options);
              }
              this.options = options;
              this.loose = !!options.loose;
              this.includePrerelease = !!options.includePrerelease;
              this.raw = range;
              this.set = range.split(/\s*\|\|\s*/).map(function(range2) {
                return this.parseRange(range2.trim());
              }, this).filter(function(c2) {
                return c2.length;
              });
              if (!this.set.length) {
                throw new TypeError("Invalid SemVer Range: " + range);
              }
              this.format();
            }
            Range.prototype.format = function() {
              this.range = this.set.map(function(comps) {
                return comps.join(" ").trim();
              }).join("||").trim();
              return this.range;
            };
            Range.prototype.toString = function() {
              return this.range;
            };
            Range.prototype.parseRange = function(range) {
              var loose = this.options.loose;
              range = range.trim();
              var hr = loose ? re[t2.HYPHENRANGELOOSE] : re[t2.HYPHENRANGE];
              range = range.replace(hr, hyphenReplace);
              debug("hyphen replace", range);
              range = range.replace(re[t2.COMPARATORTRIM], comparatorTrimReplace);
              debug("comparator trim", range, re[t2.COMPARATORTRIM]);
              range = range.replace(re[t2.TILDETRIM], tildeTrimReplace);
              range = range.replace(re[t2.CARETTRIM], caretTrimReplace);
              range = range.split(/\s+/).join(" ");
              var compRe = loose ? re[t2.COMPARATORLOOSE] : re[t2.COMPARATOR];
              var set2 = range.split(" ").map(function(comp) {
                return parseComparator(comp, this.options);
              }, this).join(" ").split(/\s+/);
              if (this.options.loose) {
                set2 = set2.filter(function(comp) {
                  return !!comp.match(compRe);
                });
              }
              set2 = set2.map(function(comp) {
                return new Comparator(comp, this.options);
              }, this);
              return set2;
            };
            Range.prototype.intersects = function(range, options) {
              if (!(range instanceof Range)) {
                throw new TypeError("a Range is required");
              }
              return this.set.some(function(thisComparators) {
                return isSatisfiable(thisComparators, options) && range.set.some(function(rangeComparators) {
                  return isSatisfiable(rangeComparators, options) && thisComparators.every(function(thisComparator) {
                    return rangeComparators.every(function(rangeComparator) {
                      return thisComparator.intersects(rangeComparator, options);
                    });
                  });
                });
              });
            };
            function isSatisfiable(comparators, options) {
              var result2 = true;
              var remainingComparators = comparators.slice();
              var testComparator = remainingComparators.pop();
              while (result2 && remainingComparators.length) {
                result2 = remainingComparators.every(function(otherComparator) {
                  return testComparator.intersects(otherComparator, options);
                });
                testComparator = remainingComparators.pop();
              }
              return result2;
            }
            exports3.toComparators = toComparators;
            function toComparators(range, options) {
              return new Range(range, options).set.map(function(comp) {
                return comp.map(function(c2) {
                  return c2.value;
                }).join(" ").trim().split(" ");
              });
            }
            function parseComparator(comp, options) {
              debug("comp", comp, options);
              comp = replaceCarets(comp, options);
              debug("caret", comp);
              comp = replaceTildes(comp, options);
              debug("tildes", comp);
              comp = replaceXRanges(comp, options);
              debug("xrange", comp);
              comp = replaceStars(comp, options);
              debug("stars", comp);
              return comp;
            }
            function isX(id) {
              return !id || id.toLowerCase() === "x" || id === "*";
            }
            function replaceTildes(comp, options) {
              return comp.trim().split(/\s+/).map(function(comp2) {
                return replaceTilde(comp2, options);
              }).join(" ");
            }
            function replaceTilde(comp, options) {
              var r2 = options.loose ? re[t2.TILDELOOSE] : re[t2.TILDE];
              return comp.replace(r2, function(_, M, m, p, pr) {
                debug("tilde", comp, _, M, m, p, pr);
                var ret;
                if (isX(M)) {
                  ret = "";
                } else if (isX(m)) {
                  ret = ">=" + M + ".0.0 <" + (+M + 1) + ".0.0";
                } else if (isX(p)) {
                  ret = ">=" + M + "." + m + ".0 <" + M + "." + (+m + 1) + ".0";
                } else if (pr) {
                  debug("replaceTilde pr", pr);
                  ret = ">=" + M + "." + m + "." + p + "-" + pr + " <" + M + "." + (+m + 1) + ".0";
                } else {
                  ret = ">=" + M + "." + m + "." + p + " <" + M + "." + (+m + 1) + ".0";
                }
                debug("tilde return", ret);
                return ret;
              });
            }
            function replaceCarets(comp, options) {
              return comp.trim().split(/\s+/).map(function(comp2) {
                return replaceCaret(comp2, options);
              }).join(" ");
            }
            function replaceCaret(comp, options) {
              debug("caret", comp, options);
              var r2 = options.loose ? re[t2.CARETLOOSE] : re[t2.CARET];
              return comp.replace(r2, function(_, M, m, p, pr) {
                debug("caret", comp, _, M, m, p, pr);
                var ret;
                if (isX(M)) {
                  ret = "";
                } else if (isX(m)) {
                  ret = ">=" + M + ".0.0 <" + (+M + 1) + ".0.0";
                } else if (isX(p)) {
                  if (M === "0") {
                    ret = ">=" + M + "." + m + ".0 <" + M + "." + (+m + 1) + ".0";
                  } else {
                    ret = ">=" + M + "." + m + ".0 <" + (+M + 1) + ".0.0";
                  }
                } else if (pr) {
                  debug("replaceCaret pr", pr);
                  if (M === "0") {
                    if (m === "0") {
                      ret = ">=" + M + "." + m + "." + p + "-" + pr + " <" + M + "." + m + "." + (+p + 1);
                    } else {
                      ret = ">=" + M + "." + m + "." + p + "-" + pr + " <" + M + "." + (+m + 1) + ".0";
                    }
                  } else {
                    ret = ">=" + M + "." + m + "." + p + "-" + pr + " <" + (+M + 1) + ".0.0";
                  }
                } else {
                  debug("no pr");
                  if (M === "0") {
                    if (m === "0") {
                      ret = ">=" + M + "." + m + "." + p + " <" + M + "." + m + "." + (+p + 1);
                    } else {
                      ret = ">=" + M + "." + m + "." + p + " <" + M + "." + (+m + 1) + ".0";
                    }
                  } else {
                    ret = ">=" + M + "." + m + "." + p + " <" + (+M + 1) + ".0.0";
                  }
                }
                debug("caret return", ret);
                return ret;
              });
            }
            function replaceXRanges(comp, options) {
              debug("replaceXRanges", comp, options);
              return comp.split(/\s+/).map(function(comp2) {
                return replaceXRange(comp2, options);
              }).join(" ");
            }
            function replaceXRange(comp, options) {
              comp = comp.trim();
              var r2 = options.loose ? re[t2.XRANGELOOSE] : re[t2.XRANGE];
              return comp.replace(r2, function(ret, gtlt, M, m, p, pr) {
                debug("xRange", comp, ret, gtlt, M, m, p, pr);
                var xM = isX(M);
                var xm = xM || isX(m);
                var xp = xm || isX(p);
                var anyX = xp;
                if (gtlt === "=" && anyX) {
                  gtlt = "";
                }
                pr = options.includePrerelease ? "-0" : "";
                if (xM) {
                  if (gtlt === ">" || gtlt === "<") {
                    ret = "<0.0.0-0";
                  } else {
                    ret = "*";
                  }
                } else if (gtlt && anyX) {
                  if (xm) {
                    m = 0;
                  }
                  p = 0;
                  if (gtlt === ">") {
                    gtlt = ">=";
                    if (xm) {
                      M = +M + 1;
                      m = 0;
                      p = 0;
                    } else {
                      m = +m + 1;
                      p = 0;
                    }
                  } else if (gtlt === "<=") {
                    gtlt = "<";
                    if (xm) {
                      M = +M + 1;
                    } else {
                      m = +m + 1;
                    }
                  }
                  ret = gtlt + M + "." + m + "." + p + pr;
                } else if (xm) {
                  ret = ">=" + M + ".0.0" + pr + " <" + (+M + 1) + ".0.0" + pr;
                } else if (xp) {
                  ret = ">=" + M + "." + m + ".0" + pr + " <" + M + "." + (+m + 1) + ".0" + pr;
                }
                debug("xRange return", ret);
                return ret;
              });
            }
            function replaceStars(comp, options) {
              debug("replaceStars", comp, options);
              return comp.trim().replace(re[t2.STAR], "");
            }
            function hyphenReplace($0, from, fM, fm, fp, fpr, fb, to, tM, tm, tp, tpr, tb) {
              if (isX(fM)) {
                from = "";
              } else if (isX(fm)) {
                from = ">=" + fM + ".0.0";
              } else if (isX(fp)) {
                from = ">=" + fM + "." + fm + ".0";
              } else {
                from = ">=" + from;
              }
              if (isX(tM)) {
                to = "";
              } else if (isX(tm)) {
                to = "<" + (+tM + 1) + ".0.0";
              } else if (isX(tp)) {
                to = "<" + tM + "." + (+tm + 1) + ".0";
              } else if (tpr) {
                to = "<=" + tM + "." + tm + "." + tp + "-" + tpr;
              } else {
                to = "<=" + to;
              }
              return (from + " " + to).trim();
            }
            Range.prototype.test = function(version) {
              if (!version) {
                return false;
              }
              if (typeof version === "string") {
                try {
                  version = new SemVer(version, this.options);
                } catch (er) {
                  return false;
                }
              }
              for (var i4 = 0; i4 < this.set.length; i4++) {
                if (testSet(this.set[i4], version, this.options)) {
                  return true;
                }
              }
              return false;
            };
            function testSet(set2, version, options) {
              for (var i4 = 0; i4 < set2.length; i4++) {
                if (!set2[i4].test(version)) {
                  return false;
                }
              }
              if (version.prerelease.length && !options.includePrerelease) {
                for (i4 = 0; i4 < set2.length; i4++) {
                  debug(set2[i4].semver);
                  if (set2[i4].semver === ANY) {
                    continue;
                  }
                  if (set2[i4].semver.prerelease.length > 0) {
                    var allowed = set2[i4].semver;
                    if (allowed.major === version.major && allowed.minor === version.minor && allowed.patch === version.patch) {
                      return true;
                    }
                  }
                }
                return false;
              }
              return true;
            }
            exports3.satisfies = satisfies;
            function satisfies(version, range, options) {
              try {
                range = new Range(range, options);
              } catch (er) {
                return false;
              }
              return range.test(version);
            }
            exports3.maxSatisfying = maxSatisfying;
            function maxSatisfying(versions, range, options) {
              var max = null;
              var maxSV = null;
              try {
                var rangeObj = new Range(range, options);
              } catch (er) {
                return null;
              }
              versions.forEach(function(v) {
                if (rangeObj.test(v)) {
                  if (!max || maxSV.compare(v) === -1) {
                    max = v;
                    maxSV = new SemVer(max, options);
                  }
                }
              });
              return max;
            }
            exports3.minSatisfying = minSatisfying;
            function minSatisfying(versions, range, options) {
              var min = null;
              var minSV = null;
              try {
                var rangeObj = new Range(range, options);
              } catch (er) {
                return null;
              }
              versions.forEach(function(v) {
                if (rangeObj.test(v)) {
                  if (!min || minSV.compare(v) === 1) {
                    min = v;
                    minSV = new SemVer(min, options);
                  }
                }
              });
              return min;
            }
            exports3.minVersion = minVersion;
            function minVersion(range, loose) {
              range = new Range(range, loose);
              var minver = new SemVer("0.0.0");
              if (range.test(minver)) {
                return minver;
              }
              minver = new SemVer("0.0.0-0");
              if (range.test(minver)) {
                return minver;
              }
              minver = null;
              for (var i4 = 0; i4 < range.set.length; ++i4) {
                var comparators = range.set[i4];
                comparators.forEach(function(comparator) {
                  var compver = new SemVer(comparator.semver.version);
                  switch (comparator.operator) {
                    case ">":
                      if (compver.prerelease.length === 0) {
                        compver.patch++;
                      } else {
                        compver.prerelease.push(0);
                      }
                      compver.raw = compver.format();
                    case "":
                    case ">=":
                      if (!minver || gt(minver, compver)) {
                        minver = compver;
                      }
                      break;
                    case "<":
                    case "<=":
                      break;
                    default:
                      throw new Error("Unexpected operation: " + comparator.operator);
                  }
                });
              }
              if (minver && range.test(minver)) {
                return minver;
              }
              return null;
            }
            exports3.validRange = validRange;
            function validRange(range, options) {
              try {
                return new Range(range, options).range || "*";
              } catch (er) {
                return null;
              }
            }
            exports3.ltr = ltr;
            function ltr(version, range, options) {
              return outside(version, range, "<", options);
            }
            exports3.gtr = gtr;
            function gtr(version, range, options) {
              return outside(version, range, ">", options);
            }
            exports3.outside = outside;
            function outside(version, range, hilo, options) {
              version = new SemVer(version, options);
              range = new Range(range, options);
              var gtfn, ltefn, ltfn, comp, ecomp;
              switch (hilo) {
                case ">":
                  gtfn = gt;
                  ltefn = lte;
                  ltfn = lt;
                  comp = ">";
                  ecomp = ">=";
                  break;
                case "<":
                  gtfn = lt;
                  ltefn = gte;
                  ltfn = gt;
                  comp = "<";
                  ecomp = "<=";
                  break;
                default:
                  throw new TypeError('Must provide a hilo val of "<" or ">"');
              }
              if (satisfies(version, range, options)) {
                return false;
              }
              for (var i4 = 0; i4 < range.set.length; ++i4) {
                var comparators = range.set[i4];
                var high = null;
                var low = null;
                comparators.forEach(function(comparator) {
                  if (comparator.semver === ANY) {
                    comparator = new Comparator(">=0.0.0");
                  }
                  high = high || comparator;
                  low = low || comparator;
                  if (gtfn(comparator.semver, high.semver, options)) {
                    high = comparator;
                  } else if (ltfn(comparator.semver, low.semver, options)) {
                    low = comparator;
                  }
                });
                if (high.operator === comp || high.operator === ecomp) {
                  return false;
                }
                if ((!low.operator || low.operator === comp) && ltefn(version, low.semver)) {
                  return false;
                } else if (low.operator === ecomp && ltfn(version, low.semver)) {
                  return false;
                }
              }
              return true;
            }
            exports3.prerelease = prerelease;
            function prerelease(version, options) {
              var parsed = parse(version, options);
              return parsed && parsed.prerelease.length ? parsed.prerelease : null;
            }
            exports3.intersects = intersects;
            function intersects(r1, r2, options) {
              r1 = new Range(r1, options);
              r2 = new Range(r2, options);
              return r1.intersects(r2);
            }
            exports3.coerce = coerce;
            function coerce(version, options) {
              if (version instanceof SemVer) {
                return version;
              }
              if (typeof version === "number") {
                version = String(version);
              }
              if (typeof version !== "string") {
                return null;
              }
              options = options || {};
              var match = null;
              if (!options.rtl) {
                match = version.match(re[t2.COERCE]);
              } else {
                var next;
                while ((next = re[t2.COERCERTL].exec(version)) && (!match || match.index + match[0].length !== version.length)) {
                  if (!match || next.index + next[0].length !== match.index + match[0].length) {
                    match = next;
                  }
                  re[t2.COERCERTL].lastIndex = next.index + next[1].length + next[2].length;
                }
                re[t2.COERCERTL].lastIndex = -1;
              }
              if (match === null) {
                return null;
              }
              return parse(match[2] + "." + (match[3] || "0") + "." + (match[4] || "0"), options);
            }
          }).call(this, __webpack_require__(16));
        },
        function(module3, exports3) {
          function _typeof(obj) {
            "@babel/helpers - typeof";
            if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
              _typeof = function _typeof2(obj2) {
                return typeof obj2;
              };
            } else {
              _typeof = function _typeof2(obj2) {
                return obj2 && typeof Symbol === "function" && obj2.constructor === Symbol && obj2 !== Symbol.prototype ? "symbol" : typeof obj2;
              };
            }
            return _typeof(obj);
          }
          var g2;
          g2 = function() {
            return this;
          }();
          try {
            g2 = g2 || new Function("return this")();
          } catch (e2) {
            if ((typeof window === "undefined" ? "undefined" : _typeof(window)) === "object")
              g2 = window;
          }
          module3.exports = g2;
        },
        function(module3, exports3, __webpack_require__) {
          (function(global2) {
            function _typeof(obj) {
              "@babel/helpers - typeof";
              if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
                _typeof = function _typeof2(obj2) {
                  return typeof obj2;
                };
              } else {
                _typeof = function _typeof2(obj2) {
                  return obj2 && typeof Symbol === "function" && obj2.constructor === Symbol && obj2 !== Symbol.prototype ? "symbol" : typeof obj2;
                };
              }
              return _typeof(obj);
            }
            var FUNC_ERROR_TEXT = "Expected a function";
            var NAN = 0 / 0;
            var symbolTag = "[object Symbol]";
            var reTrim = /^\s+|\s+$/g;
            var reIsBadHex = /^[-+]0x[0-9a-f]+$/i;
            var reIsBinary = /^0b[01]+$/i;
            var reIsOctal = /^0o[0-7]+$/i;
            var freeParseInt = parseInt;
            var freeGlobal = (typeof global2 === "undefined" ? "undefined" : _typeof(global2)) == "object" && global2 && global2.Object === Object && global2;
            var freeSelf = (typeof self === "undefined" ? "undefined" : _typeof(self)) == "object" && self && self.Object === Object && self;
            var root = freeGlobal || freeSelf || Function("return this")();
            var objectProto = Object.prototype;
            var objectToString = objectProto.toString;
            var nativeMax = Math.max, nativeMin = Math.min;
            var now = function now2() {
              return root.Date.now();
            };
            function debounce(func2, wait, options) {
              var lastArgs, lastThis, maxWait, result2, timerId, lastCallTime, lastInvokeTime = 0, leading = false, maxing = false, trailing = true;
              if (typeof func2 != "function") {
                throw new TypeError(FUNC_ERROR_TEXT);
              }
              wait = toNumber(wait) || 0;
              if (isObject2(options)) {
                leading = !!options.leading;
                maxing = "maxWait" in options;
                maxWait = maxing ? nativeMax(toNumber(options.maxWait) || 0, wait) : maxWait;
                trailing = "trailing" in options ? !!options.trailing : trailing;
              }
              function invokeFunc(time) {
                var args = lastArgs, thisArg = lastThis;
                lastArgs = lastThis = void 0;
                lastInvokeTime = time;
                result2 = func2.apply(thisArg, args);
                return result2;
              }
              function leadingEdge(time) {
                lastInvokeTime = time;
                timerId = setTimeout(timerExpired, wait);
                return leading ? invokeFunc(time) : result2;
              }
              function remainingWait(time) {
                var timeSinceLastCall = time - lastCallTime, timeSinceLastInvoke = time - lastInvokeTime, result3 = wait - timeSinceLastCall;
                return maxing ? nativeMin(result3, maxWait - timeSinceLastInvoke) : result3;
              }
              function shouldInvoke(time) {
                var timeSinceLastCall = time - lastCallTime, timeSinceLastInvoke = time - lastInvokeTime;
                return lastCallTime === void 0 || timeSinceLastCall >= wait || timeSinceLastCall < 0 || maxing && timeSinceLastInvoke >= maxWait;
              }
              function timerExpired() {
                var time = now();
                if (shouldInvoke(time)) {
                  return trailingEdge(time);
                }
                timerId = setTimeout(timerExpired, remainingWait(time));
              }
              function trailingEdge(time) {
                timerId = void 0;
                if (trailing && lastArgs) {
                  return invokeFunc(time);
                }
                lastArgs = lastThis = void 0;
                return result2;
              }
              function cancel() {
                if (timerId !== void 0) {
                  clearTimeout(timerId);
                }
                lastInvokeTime = 0;
                lastArgs = lastCallTime = lastThis = timerId = void 0;
              }
              function flush() {
                return timerId === void 0 ? result2 : trailingEdge(now());
              }
              function debounced() {
                var time = now(), isInvoking = shouldInvoke(time);
                lastArgs = arguments;
                lastThis = this;
                lastCallTime = time;
                if (isInvoking) {
                  if (timerId === void 0) {
                    return leadingEdge(lastCallTime);
                  }
                  if (maxing) {
                    timerId = setTimeout(timerExpired, wait);
                    return invokeFunc(lastCallTime);
                  }
                }
                if (timerId === void 0) {
                  timerId = setTimeout(timerExpired, wait);
                }
                return result2;
              }
              debounced.cancel = cancel;
              debounced.flush = flush;
              return debounced;
            }
            function throttle(func2, wait, options) {
              var leading = true, trailing = true;
              if (typeof func2 != "function") {
                throw new TypeError(FUNC_ERROR_TEXT);
              }
              if (isObject2(options)) {
                leading = "leading" in options ? !!options.leading : leading;
                trailing = "trailing" in options ? !!options.trailing : trailing;
              }
              return debounce(func2, wait, {
                "leading": leading,
                "maxWait": wait,
                "trailing": trailing
              });
            }
            function isObject2(value) {
              var type3 = _typeof(value);
              return !!value && (type3 == "object" || type3 == "function");
            }
            function isObjectLike(value) {
              return !!value && _typeof(value) == "object";
            }
            function isSymbol(value) {
              return _typeof(value) == "symbol" || isObjectLike(value) && objectToString.call(value) == symbolTag;
            }
            function toNumber(value) {
              if (typeof value == "number") {
                return value;
              }
              if (isSymbol(value)) {
                return NAN;
              }
              if (isObject2(value)) {
                var other = typeof value.valueOf == "function" ? value.valueOf() : value;
                value = isObject2(other) ? other + "" : other;
              }
              if (typeof value != "string") {
                return value === 0 ? value : +value;
              }
              value = value.replace(reTrim, "");
              var isBinary2 = reIsBinary.test(value);
              return isBinary2 || reIsOctal.test(value) ? freeParseInt(value.slice(2), isBinary2 ? 2 : 8) : reIsBadHex.test(value) ? NAN : +value;
            }
            module3.exports = throttle;
          }).call(this, __webpack_require__(13));
        },
        function(module3, __webpack_exports__, __webpack_require__) {
          "use strict";
          __webpack_require__.d(__webpack_exports__, "b", function() {
            return getInternalReactConstants;
          });
          __webpack_require__.d(__webpack_exports__, "a", function() {
            return attach;
          });
          var semver = __webpack_require__(12);
          var types2 = __webpack_require__(1);
          var utils = __webpack_require__(2);
          var storage = __webpack_require__(5);
          var backend_utils = __webpack_require__(4);
          var constants = __webpack_require__(0);
          var react_debug_tools = __webpack_require__(19);
          var backend_console = __webpack_require__(8);
          var ReactSymbols = __webpack_require__(3);
          var DevToolsFeatureFlags_core_oss = __webpack_require__(9);
          function is(x, y2) {
            return x === y2 && (x !== 0 || 1 / x === 1 / y2) || x !== x && y2 !== y2;
          }
          var objectIs = typeof Object.is === "function" ? Object.is : is;
          var shared_objectIs = objectIs;
          var isArray = __webpack_require__(11);
          function ownKeys(object, enumerableOnly) {
            var keys = Object.keys(object);
            if (Object.getOwnPropertySymbols) {
              var symbols = Object.getOwnPropertySymbols(object);
              if (enumerableOnly)
                symbols = symbols.filter(function(sym) {
                  return Object.getOwnPropertyDescriptor(object, sym).enumerable;
                });
              keys.push.apply(keys, symbols);
            }
            return keys;
          }
          function _objectSpread(target) {
            for (var i3 = 1; i3 < arguments.length; i3++) {
              var source = arguments[i3] != null ? arguments[i3] : {};
              if (i3 % 2) {
                ownKeys(Object(source), true).forEach(function(key2) {
                  _defineProperty(target, key2, source[key2]);
                });
              } else if (Object.getOwnPropertyDescriptors) {
                Object.defineProperties(target, Object.getOwnPropertyDescriptors(source));
              } else {
                ownKeys(Object(source)).forEach(function(key2) {
                  Object.defineProperty(target, key2, Object.getOwnPropertyDescriptor(source, key2));
                });
              }
            }
            return target;
          }
          function _defineProperty(obj, key2, value) {
            if (key2 in obj) {
              Object.defineProperty(obj, key2, { value, enumerable: true, configurable: true, writable: true });
            } else {
              obj[key2] = value;
            }
            return obj;
          }
          function _slicedToArray(arr, i3) {
            return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i3) || _unsupportedIterableToArray(arr, i3) || _nonIterableRest();
          }
          function _nonIterableRest() {
            throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
          }
          function _iterableToArrayLimit(arr, i3) {
            if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr)))
              return;
            var _arr = [];
            var _n = true;
            var _d = false;
            var _e = void 0;
            try {
              for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) {
                _arr.push(_s.value);
                if (i3 && _arr.length === i3)
                  break;
              }
            } catch (err2) {
              _d = true;
              _e = err2;
            } finally {
              try {
                if (!_n && _i["return"] != null)
                  _i["return"]();
              } finally {
                if (_d)
                  throw _e;
              }
            }
            return _arr;
          }
          function _arrayWithHoles(arr) {
            if (Array.isArray(arr))
              return arr;
          }
          function _toConsumableArray(arr) {
            return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread();
          }
          function _nonIterableSpread() {
            throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
          }
          function _iterableToArray(iter) {
            if (typeof Symbol !== "undefined" && Symbol.iterator in Object(iter))
              return Array.from(iter);
          }
          function _arrayWithoutHoles(arr) {
            if (Array.isArray(arr))
              return _arrayLikeToArray(arr);
          }
          function _createForOfIteratorHelper(o2, allowArrayLike) {
            var it;
            if (typeof Symbol === "undefined" || o2[Symbol.iterator] == null) {
              if (Array.isArray(o2) || (it = _unsupportedIterableToArray(o2)) || allowArrayLike && o2 && typeof o2.length === "number") {
                if (it)
                  o2 = it;
                var i3 = 0;
                var F = function F2() {
                };
                return { s: F, n: function n2() {
                  if (i3 >= o2.length)
                    return { done: true };
                  return { done: false, value: o2[i3++] };
                }, e: function e2(_e2) {
                  throw _e2;
                }, f: F };
              }
              throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
            }
            var normalCompletion = true, didErr = false, err2;
            return { s: function s2() {
              it = o2[Symbol.iterator]();
            }, n: function n2() {
              var step = it.next();
              normalCompletion = step.done;
              return step;
            }, e: function e2(_e3) {
              didErr = true;
              err2 = _e3;
            }, f: function f() {
              try {
                if (!normalCompletion && it.return != null)
                  it.return();
              } finally {
                if (didErr)
                  throw err2;
              }
            } };
          }
          function _unsupportedIterableToArray(o2, minLen) {
            if (!o2)
              return;
            if (typeof o2 === "string")
              return _arrayLikeToArray(o2, minLen);
            var n2 = Object.prototype.toString.call(o2).slice(8, -1);
            if (n2 === "Object" && o2.constructor)
              n2 = o2.constructor.name;
            if (n2 === "Map" || n2 === "Set")
              return Array.from(o2);
            if (n2 === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n2))
              return _arrayLikeToArray(o2, minLen);
          }
          function _arrayLikeToArray(arr, len) {
            if (len == null || len > arr.length)
              len = arr.length;
            for (var i3 = 0, arr2 = new Array(len); i3 < len; i3++) {
              arr2[i3] = arr[i3];
            }
            return arr2;
          }
          function _typeof(obj) {
            "@babel/helpers - typeof";
            if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
              _typeof = function _typeof2(obj2) {
                return typeof obj2;
              };
            } else {
              _typeof = function _typeof2(obj2) {
                return obj2 && typeof Symbol === "function" && obj2.constructor === Symbol && obj2 !== Symbol.prototype ? "symbol" : typeof obj2;
              };
            }
            return _typeof(obj);
          }
          function getFiberFlags(fiber) {
            return fiber.flags !== void 0 ? fiber.flags : fiber.effectTag;
          }
          var getCurrentTime = (typeof performance === "undefined" ? "undefined" : _typeof(performance)) === "object" && typeof performance.now === "function" ? function() {
            return performance.now();
          } : function() {
            return Date.now();
          };
          function getInternalReactConstants(version) {
            var ReactTypeOfSideEffect = {
              DidCapture: 128,
              NoFlags: 0,
              PerformedWork: 1,
              Placement: 2,
              Incomplete: 8192
            };
            var ReactPriorityLevels = {
              ImmediatePriority: 99,
              UserBlockingPriority: 98,
              NormalPriority: 97,
              LowPriority: 96,
              IdlePriority: 95,
              NoPriority: 90
            };
            if (Object(semver["gt"])(version, "17.0.2")) {
              ReactPriorityLevels = {
                ImmediatePriority: 1,
                UserBlockingPriority: 2,
                NormalPriority: 3,
                LowPriority: 4,
                IdlePriority: 5,
                NoPriority: 0
              };
            }
            var ReactTypeOfWork = null;
            if (Object(semver["gt"])(version, "17.0.1")) {
              ReactTypeOfWork = {
                CacheComponent: 24,
                ClassComponent: 1,
                ContextConsumer: 9,
                ContextProvider: 10,
                CoroutineComponent: -1,
                CoroutineHandlerPhase: -1,
                DehydratedSuspenseComponent: 18,
                ForwardRef: 11,
                Fragment: 7,
                FunctionComponent: 0,
                HostComponent: 5,
                HostPortal: 4,
                HostRoot: 3,
                HostText: 6,
                IncompleteClassComponent: 17,
                IndeterminateComponent: 2,
                LazyComponent: 16,
                LegacyHiddenComponent: 23,
                MemoComponent: 14,
                Mode: 8,
                OffscreenComponent: 22,
                Profiler: 12,
                ScopeComponent: 21,
                SimpleMemoComponent: 15,
                SuspenseComponent: 13,
                SuspenseListComponent: 19,
                YieldComponent: -1
              };
            } else if (Object(semver["gte"])(version, "17.0.0-alpha")) {
              ReactTypeOfWork = {
                CacheComponent: -1,
                ClassComponent: 1,
                ContextConsumer: 9,
                ContextProvider: 10,
                CoroutineComponent: -1,
                CoroutineHandlerPhase: -1,
                DehydratedSuspenseComponent: 18,
                ForwardRef: 11,
                Fragment: 7,
                FunctionComponent: 0,
                HostComponent: 5,
                HostPortal: 4,
                HostRoot: 3,
                HostText: 6,
                IncompleteClassComponent: 17,
                IndeterminateComponent: 2,
                LazyComponent: 16,
                LegacyHiddenComponent: 24,
                MemoComponent: 14,
                Mode: 8,
                OffscreenComponent: 23,
                Profiler: 12,
                ScopeComponent: 21,
                SimpleMemoComponent: 15,
                SuspenseComponent: 13,
                SuspenseListComponent: 19,
                YieldComponent: -1
              };
            } else if (Object(semver["gte"])(version, "16.6.0-beta.0")) {
              ReactTypeOfWork = {
                CacheComponent: -1,
                ClassComponent: 1,
                ContextConsumer: 9,
                ContextProvider: 10,
                CoroutineComponent: -1,
                CoroutineHandlerPhase: -1,
                DehydratedSuspenseComponent: 18,
                ForwardRef: 11,
                Fragment: 7,
                FunctionComponent: 0,
                HostComponent: 5,
                HostPortal: 4,
                HostRoot: 3,
                HostText: 6,
                IncompleteClassComponent: 17,
                IndeterminateComponent: 2,
                LazyComponent: 16,
                LegacyHiddenComponent: -1,
                MemoComponent: 14,
                Mode: 8,
                OffscreenComponent: -1,
                Profiler: 12,
                ScopeComponent: -1,
                SimpleMemoComponent: 15,
                SuspenseComponent: 13,
                SuspenseListComponent: 19,
                YieldComponent: -1
              };
            } else if (Object(semver["gte"])(version, "16.4.3-alpha")) {
              ReactTypeOfWork = {
                CacheComponent: -1,
                ClassComponent: 2,
                ContextConsumer: 11,
                ContextProvider: 12,
                CoroutineComponent: -1,
                CoroutineHandlerPhase: -1,
                DehydratedSuspenseComponent: -1,
                ForwardRef: 13,
                Fragment: 9,
                FunctionComponent: 0,
                HostComponent: 7,
                HostPortal: 6,
                HostRoot: 5,
                HostText: 8,
                IncompleteClassComponent: -1,
                IndeterminateComponent: 4,
                LazyComponent: -1,
                LegacyHiddenComponent: -1,
                MemoComponent: -1,
                Mode: 10,
                OffscreenComponent: -1,
                Profiler: 15,
                ScopeComponent: -1,
                SimpleMemoComponent: -1,
                SuspenseComponent: 16,
                SuspenseListComponent: -1,
                YieldComponent: -1
              };
            } else {
              ReactTypeOfWork = {
                CacheComponent: -1,
                ClassComponent: 2,
                ContextConsumer: 12,
                ContextProvider: 13,
                CoroutineComponent: 7,
                CoroutineHandlerPhase: 8,
                DehydratedSuspenseComponent: -1,
                ForwardRef: 14,
                Fragment: 10,
                FunctionComponent: 1,
                HostComponent: 5,
                HostPortal: 4,
                HostRoot: 3,
                HostText: 6,
                IncompleteClassComponent: -1,
                IndeterminateComponent: 0,
                LazyComponent: -1,
                LegacyHiddenComponent: -1,
                MemoComponent: -1,
                Mode: 11,
                OffscreenComponent: -1,
                Profiler: 15,
                ScopeComponent: -1,
                SimpleMemoComponent: -1,
                SuspenseComponent: 16,
                SuspenseListComponent: -1,
                YieldComponent: 9
              };
            }
            function getTypeSymbol(type3) {
              var symbolOrNumber = _typeof(type3) === "object" && type3 !== null ? type3.$$typeof : type3;
              return _typeof(symbolOrNumber) === "symbol" ? symbolOrNumber.toString() : symbolOrNumber;
            }
            var _ReactTypeOfWork = ReactTypeOfWork, CacheComponent = _ReactTypeOfWork.CacheComponent, ClassComponent = _ReactTypeOfWork.ClassComponent, IncompleteClassComponent = _ReactTypeOfWork.IncompleteClassComponent, FunctionComponent = _ReactTypeOfWork.FunctionComponent, IndeterminateComponent = _ReactTypeOfWork.IndeterminateComponent, ForwardRef = _ReactTypeOfWork.ForwardRef, HostRoot = _ReactTypeOfWork.HostRoot, HostComponent = _ReactTypeOfWork.HostComponent, HostPortal = _ReactTypeOfWork.HostPortal, HostText = _ReactTypeOfWork.HostText, Fragment = _ReactTypeOfWork.Fragment, LazyComponent = _ReactTypeOfWork.LazyComponent, LegacyHiddenComponent = _ReactTypeOfWork.LegacyHiddenComponent, MemoComponent = _ReactTypeOfWork.MemoComponent, OffscreenComponent = _ReactTypeOfWork.OffscreenComponent, Profiler = _ReactTypeOfWork.Profiler, ScopeComponent = _ReactTypeOfWork.ScopeComponent, SimpleMemoComponent = _ReactTypeOfWork.SimpleMemoComponent, SuspenseComponent = _ReactTypeOfWork.SuspenseComponent, SuspenseListComponent = _ReactTypeOfWork.SuspenseListComponent;
            function resolveFiberType(type3) {
              var typeSymbol = getTypeSymbol(type3);
              switch (typeSymbol) {
                case ReactSymbols["j"]:
                case ReactSymbols["k"]:
                  return resolveFiberType(type3.type);
                case ReactSymbols["f"]:
                case ReactSymbols["g"]:
                  return type3.render;
                default:
                  return type3;
              }
            }
            function getDisplayNameForFiber(fiber) {
              var elementType = fiber.elementType, type3 = fiber.type, tag = fiber.tag;
              var resolvedType = type3;
              if (_typeof(type3) === "object" && type3 !== null) {
                resolvedType = resolveFiberType(type3);
              }
              var resolvedContext = null;
              switch (tag) {
                case CacheComponent:
                  return "Cache";
                case ClassComponent:
                case IncompleteClassComponent:
                  return Object(utils["f"])(resolvedType);
                case FunctionComponent:
                case IndeterminateComponent:
                  return Object(utils["f"])(resolvedType);
                case ForwardRef:
                  return type3 && type3.displayName || Object(utils["f"])(resolvedType, "Anonymous");
                case HostRoot:
                  return null;
                case HostComponent:
                  return type3;
                case HostPortal:
                case HostText:
                case Fragment:
                  return null;
                case LazyComponent:
                  return "Lazy";
                case MemoComponent:
                case SimpleMemoComponent:
                  return elementType && elementType.displayName || type3 && type3.displayName || Object(utils["f"])(resolvedType, "Anonymous");
                case SuspenseComponent:
                  return "Suspense";
                case LegacyHiddenComponent:
                  return "LegacyHidden";
                case OffscreenComponent:
                  return "Offscreen";
                case ScopeComponent:
                  return "Scope";
                case SuspenseListComponent:
                  return "SuspenseList";
                case Profiler:
                  return "Profiler";
                default:
                  var typeSymbol = getTypeSymbol(type3);
                  switch (typeSymbol) {
                    case ReactSymbols["a"]:
                    case ReactSymbols["b"]:
                    case ReactSymbols["e"]:
                      return null;
                    case ReactSymbols["n"]:
                    case ReactSymbols["o"]:
                      resolvedContext = fiber.type._context || fiber.type.context;
                      return "".concat(resolvedContext.displayName || "Context", ".Provider");
                    case ReactSymbols["c"]:
                    case ReactSymbols["d"]:
                      resolvedContext = fiber.type._context || fiber.type;
                      return "".concat(resolvedContext.displayName || "Context", ".Consumer");
                    case ReactSymbols["r"]:
                    case ReactSymbols["s"]:
                      return null;
                    case ReactSymbols["l"]:
                    case ReactSymbols["m"]:
                      return "Profiler(".concat(fiber.memoizedProps.id, ")");
                    case ReactSymbols["p"]:
                    case ReactSymbols["q"]:
                      return "Scope";
                    default:
                      return null;
                  }
              }
            }
            return {
              getDisplayNameForFiber,
              getTypeSymbol,
              ReactPriorityLevels,
              ReactTypeOfWork,
              ReactTypeOfSideEffect
            };
          }
          function attach(hook, rendererID, renderer, global2) {
            var version = renderer.reconcilerVersion || renderer.version;
            var _getInternalReactCons = getInternalReactConstants(version), getDisplayNameForFiber = _getInternalReactCons.getDisplayNameForFiber, getTypeSymbol = _getInternalReactCons.getTypeSymbol, ReactPriorityLevels = _getInternalReactCons.ReactPriorityLevels, ReactTypeOfWork = _getInternalReactCons.ReactTypeOfWork, ReactTypeOfSideEffect = _getInternalReactCons.ReactTypeOfSideEffect;
            var DidCapture = ReactTypeOfSideEffect.DidCapture, Incomplete = ReactTypeOfSideEffect.Incomplete, NoFlags = ReactTypeOfSideEffect.NoFlags, PerformedWork = ReactTypeOfSideEffect.PerformedWork, Placement = ReactTypeOfSideEffect.Placement;
            var CacheComponent = ReactTypeOfWork.CacheComponent, ClassComponent = ReactTypeOfWork.ClassComponent, ContextConsumer = ReactTypeOfWork.ContextConsumer, DehydratedSuspenseComponent = ReactTypeOfWork.DehydratedSuspenseComponent, ForwardRef = ReactTypeOfWork.ForwardRef, Fragment = ReactTypeOfWork.Fragment, FunctionComponent = ReactTypeOfWork.FunctionComponent, HostRoot = ReactTypeOfWork.HostRoot, HostPortal = ReactTypeOfWork.HostPortal, HostComponent = ReactTypeOfWork.HostComponent, HostText = ReactTypeOfWork.HostText, IncompleteClassComponent = ReactTypeOfWork.IncompleteClassComponent, IndeterminateComponent = ReactTypeOfWork.IndeterminateComponent, LegacyHiddenComponent = ReactTypeOfWork.LegacyHiddenComponent, MemoComponent = ReactTypeOfWork.MemoComponent, OffscreenComponent = ReactTypeOfWork.OffscreenComponent, SimpleMemoComponent = ReactTypeOfWork.SimpleMemoComponent, SuspenseComponent = ReactTypeOfWork.SuspenseComponent, SuspenseListComponent = ReactTypeOfWork.SuspenseListComponent;
            var ImmediatePriority = ReactPriorityLevels.ImmediatePriority, UserBlockingPriority = ReactPriorityLevels.UserBlockingPriority, NormalPriority = ReactPriorityLevels.NormalPriority, LowPriority = ReactPriorityLevels.LowPriority, IdlePriority = ReactPriorityLevels.IdlePriority, NoPriority = ReactPriorityLevels.NoPriority;
            var overrideHookState = renderer.overrideHookState, overrideHookStateDeletePath = renderer.overrideHookStateDeletePath, overrideHookStateRenamePath = renderer.overrideHookStateRenamePath, overrideProps = renderer.overrideProps, overridePropsDeletePath = renderer.overridePropsDeletePath, overridePropsRenamePath = renderer.overridePropsRenamePath, scheduleRefresh = renderer.scheduleRefresh, setErrorHandler = renderer.setErrorHandler, setSuspenseHandler = renderer.setSuspenseHandler, scheduleUpdate = renderer.scheduleUpdate;
            var supportsTogglingError = typeof setErrorHandler === "function" && typeof scheduleUpdate === "function";
            var supportsTogglingSuspense = typeof setSuspenseHandler === "function" && typeof scheduleUpdate === "function";
            if (typeof scheduleRefresh === "function") {
              renderer.scheduleRefresh = function() {
                try {
                  hook.emit("fastRefreshScheduled");
                } finally {
                  return scheduleRefresh.apply(void 0, arguments);
                }
              };
            }
            var fibersWithChangedErrorOrWarningCounts = /* @__PURE__ */ new Set();
            var pendingFiberToErrorsMap = /* @__PURE__ */ new Map();
            var pendingFiberToWarningsMap = /* @__PURE__ */ new Map();
            var fiberIDToErrorsMap = /* @__PURE__ */ new Map();
            var fiberIDToWarningsMap = /* @__PURE__ */ new Map();
            function clearErrorsAndWarnings() {
              var _iterator = _createForOfIteratorHelper(fiberIDToErrorsMap.keys()), _step;
              try {
                for (_iterator.s(); !(_step = _iterator.n()).done; ) {
                  var id = _step.value;
                  var _fiber = idToArbitraryFiberMap.get(id);
                  if (_fiber != null) {
                    fibersWithChangedErrorOrWarningCounts.add(_fiber);
                    updateMostRecentlyInspectedElementIfNecessary(id);
                  }
                }
              } catch (err2) {
                _iterator.e(err2);
              } finally {
                _iterator.f();
              }
              var _iterator2 = _createForOfIteratorHelper(fiberIDToWarningsMap.keys()), _step2;
              try {
                for (_iterator2.s(); !(_step2 = _iterator2.n()).done; ) {
                  var _id = _step2.value;
                  var _fiber2 = idToArbitraryFiberMap.get(_id);
                  if (_fiber2 != null) {
                    fibersWithChangedErrorOrWarningCounts.add(_fiber2);
                    updateMostRecentlyInspectedElementIfNecessary(_id);
                  }
                }
              } catch (err2) {
                _iterator2.e(err2);
              } finally {
                _iterator2.f();
              }
              fiberIDToErrorsMap.clear();
              fiberIDToWarningsMap.clear();
              flushPendingEvents();
            }
            function clearMessageCountHelper(fiberID, pendingFiberToMessageCountMap, fiberIDToMessageCountMap) {
              var fiber = idToArbitraryFiberMap.get(fiberID);
              if (fiber != null) {
                pendingFiberToErrorsMap.delete(fiber);
                if (fiberIDToMessageCountMap.has(fiberID)) {
                  fiberIDToMessageCountMap.delete(fiberID);
                  fibersWithChangedErrorOrWarningCounts.add(fiber);
                  flushPendingEvents();
                  updateMostRecentlyInspectedElementIfNecessary(fiberID);
                } else {
                  fibersWithChangedErrorOrWarningCounts.delete(fiber);
                }
              }
            }
            function clearErrorsForFiberID(fiberID) {
              clearMessageCountHelper(fiberID, pendingFiberToErrorsMap, fiberIDToErrorsMap);
            }
            function clearWarningsForFiberID(fiberID) {
              clearMessageCountHelper(fiberID, pendingFiberToWarningsMap, fiberIDToWarningsMap);
            }
            function updateMostRecentlyInspectedElementIfNecessary(fiberID) {
              if (mostRecentlyInspectedElement !== null && mostRecentlyInspectedElement.id === fiberID) {
                hasElementUpdatedSinceLastInspected = true;
              }
            }
            function onErrorOrWarning(fiber, type3, args) {
              if (type3 === "error") {
                var maybeID = getFiberIDUnsafe(fiber);
                if (maybeID != null && forceErrorForFiberIDs.get(maybeID) === true) {
                  return;
                }
              }
              var message = backend_utils["f"].apply(void 0, _toConsumableArray(args));
              if (constants["o"]) {
                debug("onErrorOrWarning", fiber, null, "".concat(type3, ': "').concat(message, '"'));
              }
              fibersWithChangedErrorOrWarningCounts.add(fiber);
              var fiberMap = type3 === "error" ? pendingFiberToErrorsMap : pendingFiberToWarningsMap;
              var messageMap = fiberMap.get(fiber);
              if (messageMap != null) {
                var count = messageMap.get(message) || 0;
                messageMap.set(message, count + 1);
              } else {
                fiberMap.set(fiber, /* @__PURE__ */ new Map([[message, 1]]));
              }
              flushPendingErrorsAndWarningsAfterDelay();
            }
            if (true) {
              Object(backend_console["b"])(renderer, onErrorOrWarning);
              var appendComponentStack = window.__REACT_DEVTOOLS_APPEND_COMPONENT_STACK__ !== false;
              var breakOnConsoleErrors = window.__REACT_DEVTOOLS_BREAK_ON_CONSOLE_ERRORS__ === true;
              var showInlineWarningsAndErrors = window.__REACT_DEVTOOLS_SHOW_INLINE_WARNINGS_AND_ERRORS__ !== false;
              var hideConsoleLogsInStrictMode = window.__REACT_DEVTOOLS_HIDE_CONSOLE_LOGS_IN_STRICT_MODE__ === true;
              var browserTheme = window.__REACT_DEVTOOLS_BROWSER_THEME__;
              Object(backend_console["a"])({
                appendComponentStack,
                breakOnConsoleErrors,
                showInlineWarningsAndErrors,
                hideConsoleLogsInStrictMode,
                browserTheme
              });
            }
            var debug = function debug2(name, fiber, parentFiber) {
              var extraString = arguments.length > 3 && arguments[3] !== void 0 ? arguments[3] : "";
              if (constants["o"]) {
                var displayName = fiber.tag + ":" + (getDisplayNameForFiber(fiber) || "null");
                var maybeID = getFiberIDUnsafe(fiber) || "<no id>";
                var parentDisplayName = parentFiber ? parentFiber.tag + ":" + (getDisplayNameForFiber(parentFiber) || "null") : "";
                var maybeParentID = parentFiber ? getFiberIDUnsafe(parentFiber) || "<no-id>" : "";
                console.groupCollapsed("[renderer] %c".concat(name, " %c").concat(displayName, " (").concat(maybeID, ") %c").concat(parentFiber ? "".concat(parentDisplayName, " (").concat(maybeParentID, ")") : "", " %c").concat(extraString), "color: red; font-weight: bold;", "color: blue;", "color: purple;", "color: black;");
                console.log(new Error().stack.split("\n").slice(1).join("\n"));
                console.groupEnd();
              }
            };
            var hideElementsWithDisplayNames = /* @__PURE__ */ new Set();
            var hideElementsWithPaths = /* @__PURE__ */ new Set();
            var hideElementsWithTypes = /* @__PURE__ */ new Set();
            var traceUpdatesEnabled = false;
            var traceUpdatesForNodes = /* @__PURE__ */ new Set();
            function applyComponentFilters(componentFilters) {
              hideElementsWithTypes.clear();
              hideElementsWithDisplayNames.clear();
              hideElementsWithPaths.clear();
              componentFilters.forEach(function(componentFilter) {
                if (!componentFilter.isEnabled) {
                  return;
                }
                switch (componentFilter.type) {
                  case types2["a"]:
                    if (componentFilter.isValid && componentFilter.value !== "") {
                      hideElementsWithDisplayNames.add(new RegExp(componentFilter.value, "i"));
                    }
                    break;
                  case types2["b"]:
                    hideElementsWithTypes.add(componentFilter.value);
                    break;
                  case types2["d"]:
                    if (componentFilter.isValid && componentFilter.value !== "") {
                      hideElementsWithPaths.add(new RegExp(componentFilter.value, "i"));
                    }
                    break;
                  case types2["c"]:
                    hideElementsWithDisplayNames.add(new RegExp("\\("));
                    break;
                  default:
                    console.warn('Invalid component filter type "'.concat(componentFilter.type, '"'));
                    break;
                }
              });
            }
            if (window.__REACT_DEVTOOLS_COMPONENT_FILTERS__ != null) {
              applyComponentFilters(window.__REACT_DEVTOOLS_COMPONENT_FILTERS__);
            } else {
              applyComponentFilters(Object(utils["e"])());
            }
            function updateComponentFilters(componentFilters) {
              if (isProfiling) {
                throw Error("Cannot modify filter preferences while profiling");
              }
              hook.getFiberRoots(rendererID).forEach(function(root) {
                currentRootID = getOrGenerateFiberID(root.current);
                pushOperation(constants["k"]);
                flushPendingEvents(root);
                currentRootID = -1;
              });
              applyComponentFilters(componentFilters);
              rootDisplayNameCounter.clear();
              hook.getFiberRoots(rendererID).forEach(function(root) {
                currentRootID = getOrGenerateFiberID(root.current);
                setRootPseudoKey(currentRootID, root.current);
                mountFiberRecursively(root.current, null, false, false);
                flushPendingEvents(root);
                currentRootID = -1;
              });
              reevaluateErrorsAndWarnings();
              flushPendingEvents();
            }
            function shouldFilterFiber(fiber) {
              var _debugSource = fiber._debugSource, tag = fiber.tag, type3 = fiber.type;
              switch (tag) {
                case DehydratedSuspenseComponent:
                  return true;
                case HostPortal:
                case HostText:
                case Fragment:
                case LegacyHiddenComponent:
                case OffscreenComponent:
                  return true;
                case HostRoot:
                  return false;
                default:
                  var typeSymbol = getTypeSymbol(type3);
                  switch (typeSymbol) {
                    case ReactSymbols["a"]:
                    case ReactSymbols["b"]:
                    case ReactSymbols["e"]:
                    case ReactSymbols["r"]:
                    case ReactSymbols["s"]:
                      return true;
                    default:
                      break;
                  }
              }
              var elementType = getElementTypeForFiber(fiber);
              if (hideElementsWithTypes.has(elementType)) {
                return true;
              }
              if (hideElementsWithDisplayNames.size > 0) {
                var displayName = getDisplayNameForFiber(fiber);
                if (displayName != null) {
                  var _iterator3 = _createForOfIteratorHelper(hideElementsWithDisplayNames), _step3;
                  try {
                    for (_iterator3.s(); !(_step3 = _iterator3.n()).done; ) {
                      var displayNameRegExp = _step3.value;
                      if (displayNameRegExp.test(displayName)) {
                        return true;
                      }
                    }
                  } catch (err2) {
                    _iterator3.e(err2);
                  } finally {
                    _iterator3.f();
                  }
                }
              }
              if (_debugSource != null && hideElementsWithPaths.size > 0) {
                var fileName = _debugSource.fileName;
                var _iterator4 = _createForOfIteratorHelper(hideElementsWithPaths), _step4;
                try {
                  for (_iterator4.s(); !(_step4 = _iterator4.n()).done; ) {
                    var pathRegExp = _step4.value;
                    if (pathRegExp.test(fileName)) {
                      return true;
                    }
                  }
                } catch (err2) {
                  _iterator4.e(err2);
                } finally {
                  _iterator4.f();
                }
              }
              return false;
            }
            function getElementTypeForFiber(fiber) {
              var type3 = fiber.type, tag = fiber.tag;
              switch (tag) {
                case ClassComponent:
                case IncompleteClassComponent:
                  return types2["e"];
                case FunctionComponent:
                case IndeterminateComponent:
                  return types2["h"];
                case ForwardRef:
                  return types2["g"];
                case HostRoot:
                  return types2["m"];
                case HostComponent:
                  return types2["i"];
                case HostPortal:
                case HostText:
                case Fragment:
                  return types2["k"];
                case MemoComponent:
                case SimpleMemoComponent:
                  return types2["j"];
                case SuspenseComponent:
                  return types2["n"];
                case SuspenseListComponent:
                  return types2["o"];
                default:
                  var typeSymbol = getTypeSymbol(type3);
                  switch (typeSymbol) {
                    case ReactSymbols["a"]:
                    case ReactSymbols["b"]:
                    case ReactSymbols["e"]:
                      return types2["k"];
                    case ReactSymbols["n"]:
                    case ReactSymbols["o"]:
                      return types2["f"];
                    case ReactSymbols["c"]:
                    case ReactSymbols["d"]:
                      return types2["f"];
                    case ReactSymbols["r"]:
                    case ReactSymbols["s"]:
                      return types2["k"];
                    case ReactSymbols["l"]:
                    case ReactSymbols["m"]:
                      return types2["l"];
                    default:
                      return types2["k"];
                  }
              }
            }
            var fiberToIDMap = /* @__PURE__ */ new Map();
            var idToArbitraryFiberMap = /* @__PURE__ */ new Map();
            var idToTreeBaseDurationMap = /* @__PURE__ */ new Map();
            var idToRootMap = /* @__PURE__ */ new Map();
            var currentRootID = -1;
            function getOrGenerateFiberID(fiber) {
              var id = null;
              if (fiberToIDMap.has(fiber)) {
                id = fiberToIDMap.get(fiber);
              } else {
                var _alternate = fiber.alternate;
                if (_alternate !== null && fiberToIDMap.has(_alternate)) {
                  id = fiberToIDMap.get(_alternate);
                }
              }
              var didGenerateID = false;
              if (id === null) {
                didGenerateID = true;
                id = Object(utils["i"])();
              }
              var refinedID = id;
              if (!fiberToIDMap.has(fiber)) {
                fiberToIDMap.set(fiber, refinedID);
                idToArbitraryFiberMap.set(refinedID, fiber);
              }
              var alternate = fiber.alternate;
              if (alternate !== null) {
                if (!fiberToIDMap.has(alternate)) {
                  fiberToIDMap.set(alternate, refinedID);
                }
              }
              if (constants["o"]) {
                if (didGenerateID) {
                  debug("getOrGenerateFiberID()", fiber, fiber.return, "Generated a new UID");
                }
              }
              return refinedID;
            }
            function getFiberIDThrows(fiber) {
              var maybeID = getFiberIDUnsafe(fiber);
              if (maybeID !== null) {
                return maybeID;
              }
              throw Error('Could not find ID for Fiber "'.concat(getDisplayNameForFiber(fiber) || "", '"'));
            }
            function getFiberIDUnsafe(fiber) {
              if (fiberToIDMap.has(fiber)) {
                return fiberToIDMap.get(fiber);
              } else {
                var alternate = fiber.alternate;
                if (alternate !== null && fiberToIDMap.has(alternate)) {
                  return fiberToIDMap.get(alternate);
                }
              }
              return null;
            }
            function untrackFiberID(fiber) {
              if (constants["o"]) {
                debug("untrackFiberID()", fiber, fiber.return, "schedule after delay");
              }
              untrackFibersSet.add(fiber);
              if (untrackFibersTimeoutID === null) {
                untrackFibersTimeoutID = setTimeout(untrackFibers, 1e3);
              }
            }
            var untrackFibersSet = /* @__PURE__ */ new Set();
            var untrackFibersTimeoutID = null;
            function untrackFibers() {
              if (untrackFibersTimeoutID !== null) {
                clearTimeout(untrackFibersTimeoutID);
                untrackFibersTimeoutID = null;
              }
              untrackFibersSet.forEach(function(fiber) {
                var fiberID = getFiberIDUnsafe(fiber);
                if (fiberID !== null) {
                  idToArbitraryFiberMap.delete(fiberID);
                  clearErrorsForFiberID(fiberID);
                  clearWarningsForFiberID(fiberID);
                }
                fiberToIDMap.delete(fiber);
                var alternate = fiber.alternate;
                if (alternate !== null) {
                  fiberToIDMap.delete(alternate);
                }
                if (forceErrorForFiberIDs.has(fiberID)) {
                  forceErrorForFiberIDs.delete(fiberID);
                  if (forceErrorForFiberIDs.size === 0 && setErrorHandler != null) {
                    setErrorHandler(shouldErrorFiberAlwaysNull);
                  }
                }
              });
              untrackFibersSet.clear();
            }
            function getChangeDescription(prevFiber, nextFiber) {
              switch (getElementTypeForFiber(nextFiber)) {
                case types2["e"]:
                case types2["h"]:
                case types2["j"]:
                case types2["g"]:
                  if (prevFiber === null) {
                    return {
                      context: null,
                      didHooksChange: false,
                      isFirstMount: true,
                      props: null,
                      state: null
                    };
                  } else {
                    var data = {
                      context: getContextChangedKeys(nextFiber),
                      didHooksChange: false,
                      isFirstMount: false,
                      props: getChangedKeys(prevFiber.memoizedProps, nextFiber.memoizedProps),
                      state: getChangedKeys(prevFiber.memoizedState, nextFiber.memoizedState)
                    };
                    if (DevToolsFeatureFlags_core_oss["b"]) {
                      var indices = getChangedHooksIndices(prevFiber.memoizedState, nextFiber.memoizedState);
                      data.hooks = indices;
                      data.didHooksChange = indices !== null && indices.length > 0;
                    } else {
                      data.didHooksChange = didHooksChange(prevFiber.memoizedState, nextFiber.memoizedState);
                    }
                    return data;
                  }
                default:
                  return null;
              }
            }
            function updateContextsForFiber(fiber) {
              switch (getElementTypeForFiber(fiber)) {
                case types2["h"]:
                case types2["e"]:
                  if (idToContextsMap !== null) {
                    var id = getFiberIDThrows(fiber);
                    var contexts = getContextsForFiber(fiber);
                    if (contexts !== null) {
                      idToContextsMap.set(id, contexts);
                    }
                  }
                  break;
                default:
                  break;
              }
            }
            var NO_CONTEXT = {};
            function getContextsForFiber(fiber) {
              var legacyContext = NO_CONTEXT;
              var modernContext = NO_CONTEXT;
              switch (getElementTypeForFiber(fiber)) {
                case types2["e"]:
                  var instance = fiber.stateNode;
                  if (instance != null) {
                    if (instance.constructor && instance.constructor.contextType != null) {
                      modernContext = instance.context;
                    } else {
                      legacyContext = instance.context;
                      if (legacyContext && Object.keys(legacyContext).length === 0) {
                        legacyContext = NO_CONTEXT;
                      }
                    }
                  }
                  return [legacyContext, modernContext];
                case types2["h"]:
                  var dependencies = fiber.dependencies;
                  if (dependencies && dependencies.firstContext) {
                    modernContext = dependencies.firstContext;
                  }
                  return [legacyContext, modernContext];
                default:
                  return null;
              }
            }
            function crawlToInitializeContextsMap(fiber) {
              updateContextsForFiber(fiber);
              var current = fiber.child;
              while (current !== null) {
                crawlToInitializeContextsMap(current);
                current = current.sibling;
              }
            }
            function getContextChangedKeys(fiber) {
              if (idToContextsMap !== null) {
                var id = getFiberIDThrows(fiber);
                var prevContexts = idToContextsMap.has(id) ? idToContextsMap.get(id) : null;
                var nextContexts = getContextsForFiber(fiber);
                if (prevContexts == null || nextContexts == null) {
                  return null;
                }
                var _prevContexts = _slicedToArray(prevContexts, 2), prevLegacyContext = _prevContexts[0], prevModernContext = _prevContexts[1];
                var _nextContexts = _slicedToArray(nextContexts, 2), nextLegacyContext = _nextContexts[0], nextModernContext = _nextContexts[1];
                switch (getElementTypeForFiber(fiber)) {
                  case types2["e"]:
                    if (prevContexts && nextContexts) {
                      if (nextLegacyContext !== NO_CONTEXT) {
                        return getChangedKeys(prevLegacyContext, nextLegacyContext);
                      } else if (nextModernContext !== NO_CONTEXT) {
                        return prevModernContext !== nextModernContext;
                      }
                    }
                    break;
                  case types2["h"]:
                    if (nextModernContext !== NO_CONTEXT) {
                      var prevContext = prevModernContext;
                      var nextContext = nextModernContext;
                      while (prevContext && nextContext) {
                        if (!shared_objectIs(prevContext.memoizedValue, nextContext.memoizedValue)) {
                          return true;
                        }
                        prevContext = prevContext.next;
                        nextContext = nextContext.next;
                      }
                      return false;
                    }
                    break;
                  default:
                    break;
                }
              }
              return null;
            }
            function areHookInputsEqual(nextDeps, prevDeps) {
              if (prevDeps === null) {
                return false;
              }
              for (var i3 = 0; i3 < prevDeps.length && i3 < nextDeps.length; i3++) {
                if (shared_objectIs(nextDeps[i3], prevDeps[i3])) {
                  continue;
                }
                return false;
              }
              return true;
            }
            function isEffect(memoizedState) {
              if (memoizedState === null || _typeof(memoizedState) !== "object") {
                return false;
              }
              var deps = memoizedState.deps;
              var hasOwnProperty2 = Object.prototype.hasOwnProperty.bind(memoizedState);
              return hasOwnProperty2("create") && hasOwnProperty2("destroy") && hasOwnProperty2("deps") && hasOwnProperty2("next") && hasOwnProperty2("tag") && (deps === null || Object(isArray["a"])(deps));
            }
            function didHookChange(prev, next) {
              var prevMemoizedState = prev.memoizedState;
              var nextMemoizedState = next.memoizedState;
              if (isEffect(prevMemoizedState) && isEffect(nextMemoizedState)) {
                return prevMemoizedState !== nextMemoizedState && !areHookInputsEqual(nextMemoizedState.deps, prevMemoizedState.deps);
              }
              return nextMemoizedState !== prevMemoizedState;
            }
            function didHooksChange(prev, next) {
              if (prev == null || next == null) {
                return false;
              }
              if (next.hasOwnProperty("baseState") && next.hasOwnProperty("memoizedState") && next.hasOwnProperty("next") && next.hasOwnProperty("queue")) {
                while (next !== null) {
                  if (didHookChange(prev, next)) {
                    return true;
                  } else {
                    next = next.next;
                    prev = prev.next;
                  }
                }
              }
              return false;
            }
            function getChangedHooksIndices(prev, next) {
              if (DevToolsFeatureFlags_core_oss["b"]) {
                if (prev == null || next == null) {
                  return null;
                }
                var indices = [];
                var index = 0;
                if (next.hasOwnProperty("baseState") && next.hasOwnProperty("memoizedState") && next.hasOwnProperty("next") && next.hasOwnProperty("queue")) {
                  while (next !== null) {
                    if (didHookChange(prev, next)) {
                      indices.push(index);
                    }
                    next = next.next;
                    prev = prev.next;
                    index++;
                  }
                }
                return indices;
              }
              return null;
            }
            function getChangedKeys(prev, next) {
              if (prev == null || next == null) {
                return null;
              }
              if (next.hasOwnProperty("baseState") && next.hasOwnProperty("memoizedState") && next.hasOwnProperty("next") && next.hasOwnProperty("queue")) {
                return null;
              }
              var keys = new Set([].concat(_toConsumableArray(Object.keys(prev)), _toConsumableArray(Object.keys(next))));
              var changedKeys = [];
              var _iterator5 = _createForOfIteratorHelper(keys), _step5;
              try {
                for (_iterator5.s(); !(_step5 = _iterator5.n()).done; ) {
                  var key2 = _step5.value;
                  if (prev[key2] !== next[key2]) {
                    changedKeys.push(key2);
                  }
                }
              } catch (err2) {
                _iterator5.e(err2);
              } finally {
                _iterator5.f();
              }
              return changedKeys;
            }
            function didFiberRender(prevFiber, nextFiber) {
              switch (nextFiber.tag) {
                case ClassComponent:
                case FunctionComponent:
                case ContextConsumer:
                case MemoComponent:
                case SimpleMemoComponent:
                  return (getFiberFlags(nextFiber) & PerformedWork) === PerformedWork;
                default:
                  return prevFiber.memoizedProps !== nextFiber.memoizedProps || prevFiber.memoizedState !== nextFiber.memoizedState || prevFiber.ref !== nextFiber.ref;
              }
            }
            var pendingOperations = [];
            var pendingRealUnmountedIDs = [];
            var pendingSimulatedUnmountedIDs = [];
            var pendingOperationsQueue = [];
            var pendingStringTable = /* @__PURE__ */ new Map();
            var pendingStringTableLength = 0;
            var pendingUnmountedRootID = null;
            function pushOperation(op) {
              if (false) {
              }
              pendingOperations.push(op);
            }
            function flushOrQueueOperations(operations) {
              if (pendingOperationsQueue !== null) {
                pendingOperationsQueue.push(operations);
              } else {
                hook.emit("operations", operations);
              }
            }
            var flushPendingErrorsAndWarningsAfterDelayTimeoutID = null;
            function clearPendingErrorsAndWarningsAfterDelay() {
              if (flushPendingErrorsAndWarningsAfterDelayTimeoutID !== null) {
                clearTimeout(flushPendingErrorsAndWarningsAfterDelayTimeoutID);
                flushPendingErrorsAndWarningsAfterDelayTimeoutID = null;
              }
            }
            function flushPendingErrorsAndWarningsAfterDelay() {
              clearPendingErrorsAndWarningsAfterDelay();
              flushPendingErrorsAndWarningsAfterDelayTimeoutID = setTimeout(function() {
                flushPendingErrorsAndWarningsAfterDelayTimeoutID = null;
                if (pendingOperations.length > 0) {
                  return;
                }
                recordPendingErrorsAndWarnings();
                if (pendingOperations.length === 0) {
                  return;
                }
                var operations = new Array(3 + pendingOperations.length);
                operations[0] = rendererID;
                operations[1] = currentRootID;
                operations[2] = 0;
                for (var j = 0; j < pendingOperations.length; j++) {
                  operations[3 + j] = pendingOperations[j];
                }
                flushOrQueueOperations(operations);
                pendingOperations.length = 0;
              }, 1e3);
            }
            function reevaluateErrorsAndWarnings() {
              fibersWithChangedErrorOrWarningCounts.clear();
              fiberIDToErrorsMap.forEach(function(countMap, fiberID) {
                var fiber = idToArbitraryFiberMap.get(fiberID);
                if (fiber != null) {
                  fibersWithChangedErrorOrWarningCounts.add(fiber);
                }
              });
              fiberIDToWarningsMap.forEach(function(countMap, fiberID) {
                var fiber = idToArbitraryFiberMap.get(fiberID);
                if (fiber != null) {
                  fibersWithChangedErrorOrWarningCounts.add(fiber);
                }
              });
              recordPendingErrorsAndWarnings();
            }
            function mergeMapsAndGetCountHelper(fiber, fiberID, pendingFiberToMessageCountMap, fiberIDToMessageCountMap) {
              var newCount = 0;
              var messageCountMap = fiberIDToMessageCountMap.get(fiberID);
              var pendingMessageCountMap = pendingFiberToMessageCountMap.get(fiber);
              if (pendingMessageCountMap != null) {
                if (messageCountMap == null) {
                  messageCountMap = pendingMessageCountMap;
                  fiberIDToMessageCountMap.set(fiberID, pendingMessageCountMap);
                } else {
                  var refinedMessageCountMap = messageCountMap;
                  pendingMessageCountMap.forEach(function(pendingCount, message) {
                    var previousCount = refinedMessageCountMap.get(message) || 0;
                    refinedMessageCountMap.set(message, previousCount + pendingCount);
                  });
                }
              }
              if (!shouldFilterFiber(fiber)) {
                if (messageCountMap != null) {
                  messageCountMap.forEach(function(count) {
                    newCount += count;
                  });
                }
              }
              pendingFiberToMessageCountMap.delete(fiber);
              return newCount;
            }
            function recordPendingErrorsAndWarnings() {
              clearPendingErrorsAndWarningsAfterDelay();
              fibersWithChangedErrorOrWarningCounts.forEach(function(fiber) {
                var fiberID = getFiberIDUnsafe(fiber);
                if (fiberID === null) {
                } else {
                  var errorCount = mergeMapsAndGetCountHelper(fiber, fiberID, pendingFiberToErrorsMap, fiberIDToErrorsMap);
                  var warningCount = mergeMapsAndGetCountHelper(fiber, fiberID, pendingFiberToWarningsMap, fiberIDToWarningsMap);
                  pushOperation(constants["m"]);
                  pushOperation(fiberID);
                  pushOperation(errorCount);
                  pushOperation(warningCount);
                }
                pendingFiberToErrorsMap.delete(fiber);
                pendingFiberToWarningsMap.delete(fiber);
              });
              fibersWithChangedErrorOrWarningCounts.clear();
            }
            function flushPendingEvents(root) {
              recordPendingErrorsAndWarnings();
              if (pendingOperations.length === 0 && pendingRealUnmountedIDs.length === 0 && pendingSimulatedUnmountedIDs.length === 0 && pendingUnmountedRootID === null) {
                if (!isProfiling) {
                  return;
                }
              }
              var numUnmountIDs = pendingRealUnmountedIDs.length + pendingSimulatedUnmountedIDs.length + (pendingUnmountedRootID === null ? 0 : 1);
              var operations = new Array(2 + 1 + pendingStringTableLength + (numUnmountIDs > 0 ? 2 + numUnmountIDs : 0) + pendingOperations.length);
              var i3 = 0;
              operations[i3++] = rendererID;
              operations[i3++] = currentRootID;
              operations[i3++] = pendingStringTableLength;
              pendingStringTable.forEach(function(value, key2) {
                operations[i3++] = key2.length;
                var encodedKey = Object(utils["m"])(key2);
                for (var j2 = 0; j2 < encodedKey.length; j2++) {
                  operations[i3 + j2] = encodedKey[j2];
                }
                i3 += key2.length;
              });
              if (numUnmountIDs > 0) {
                operations[i3++] = constants["j"];
                operations[i3++] = numUnmountIDs;
                for (var j = pendingRealUnmountedIDs.length - 1; j >= 0; j--) {
                  operations[i3++] = pendingRealUnmountedIDs[j];
                }
                for (var _j = 0; _j < pendingSimulatedUnmountedIDs.length; _j++) {
                  operations[i3 + _j] = pendingSimulatedUnmountedIDs[_j];
                }
                i3 += pendingSimulatedUnmountedIDs.length;
                if (pendingUnmountedRootID !== null) {
                  operations[i3] = pendingUnmountedRootID;
                  i3++;
                }
              }
              for (var _j2 = 0; _j2 < pendingOperations.length; _j2++) {
                operations[i3 + _j2] = pendingOperations[_j2];
              }
              i3 += pendingOperations.length;
              flushOrQueueOperations(operations);
              pendingOperations.length = 0;
              pendingRealUnmountedIDs.length = 0;
              pendingSimulatedUnmountedIDs.length = 0;
              pendingUnmountedRootID = null;
              pendingStringTable.clear();
              pendingStringTableLength = 0;
            }
            function getStringID(str2) {
              if (str2 === null) {
                return 0;
              }
              var existingID = pendingStringTable.get(str2);
              if (existingID !== void 0) {
                return existingID;
              }
              var stringID = pendingStringTable.size + 1;
              pendingStringTable.set(str2, stringID);
              pendingStringTableLength += str2.length + 1;
              return stringID;
            }
            function recordMount(fiber, parentFiber) {
              var isRoot = fiber.tag === HostRoot;
              var id = getOrGenerateFiberID(fiber);
              if (constants["o"]) {
                debug("recordMount()", fiber, parentFiber);
              }
              var hasOwnerMetadata = fiber.hasOwnProperty("_debugOwner");
              var isProfilingSupported = fiber.hasOwnProperty("treeBaseDuration");
              if (isRoot) {
                pushOperation(constants["i"]);
                pushOperation(id);
                pushOperation(types2["m"]);
                pushOperation(isProfilingSupported ? 1 : 0);
                pushOperation(hasOwnerMetadata ? 1 : 0);
                if (isProfiling) {
                  if (displayNamesByRootID !== null) {
                    displayNamesByRootID.set(id, getDisplayNameForRoot(fiber));
                  }
                }
              } else {
                var key2 = fiber.key;
                var displayName = getDisplayNameForFiber(fiber);
                var elementType = getElementTypeForFiber(fiber);
                var _debugOwner = fiber._debugOwner;
                var ownerID = _debugOwner != null ? getOrGenerateFiberID(_debugOwner) : 0;
                var parentID = parentFiber ? getFiberIDThrows(parentFiber) : 0;
                var displayNameStringID = getStringID(displayName);
                var keyString = key2 === null ? null : "" + key2;
                var keyStringID = getStringID(keyString);
                pushOperation(constants["i"]);
                pushOperation(id);
                pushOperation(elementType);
                pushOperation(parentID);
                pushOperation(ownerID);
                pushOperation(displayNameStringID);
                pushOperation(keyStringID);
              }
              if (isProfilingSupported) {
                idToRootMap.set(id, currentRootID);
                recordProfilingDurations(fiber);
              }
            }
            function recordUnmount(fiber, isSimulated) {
              if (constants["o"]) {
                debug("recordUnmount()", fiber, null, isSimulated ? "unmount is simulated" : "");
              }
              if (trackedPathMatchFiber !== null) {
                if (fiber === trackedPathMatchFiber || fiber === trackedPathMatchFiber.alternate) {
                  setTrackedPath(null);
                }
              }
              var unsafeID = getFiberIDUnsafe(fiber);
              if (unsafeID === null) {
                return;
              }
              var id = unsafeID;
              var isRoot = fiber.tag === HostRoot;
              if (isRoot) {
                pendingUnmountedRootID = id;
              } else if (!shouldFilterFiber(fiber)) {
                if (isSimulated) {
                  pendingSimulatedUnmountedIDs.push(id);
                } else {
                  pendingRealUnmountedIDs.push(id);
                }
              }
              if (!fiber._debugNeedsRemount) {
                untrackFiberID(fiber);
                var isProfilingSupported = fiber.hasOwnProperty("treeBaseDuration");
                if (isProfilingSupported) {
                  idToRootMap.delete(id);
                  idToTreeBaseDurationMap.delete(id);
                }
              }
            }
            function mountFiberRecursively(firstChild, parentFiber, traverseSiblings, traceNearestHostComponentUpdate) {
              var fiber = firstChild;
              while (fiber !== null) {
                getOrGenerateFiberID(fiber);
                if (constants["o"]) {
                  debug("mountFiberRecursively()", fiber, parentFiber);
                }
                var mightSiblingsBeOnTrackedPath = updateTrackedPathStateBeforeMount(fiber);
                var shouldIncludeInTree = !shouldFilterFiber(fiber);
                if (shouldIncludeInTree) {
                  recordMount(fiber, parentFiber);
                }
                if (traceUpdatesEnabled) {
                  if (traceNearestHostComponentUpdate) {
                    var elementType = getElementTypeForFiber(fiber);
                    if (elementType === types2["i"]) {
                      traceUpdatesForNodes.add(fiber.stateNode);
                      traceNearestHostComponentUpdate = false;
                    }
                  }
                }
                var isSuspense = fiber.tag === ReactTypeOfWork.SuspenseComponent;
                if (isSuspense) {
                  var isTimedOut = fiber.memoizedState !== null;
                  if (isTimedOut) {
                    var primaryChildFragment = fiber.child;
                    var fallbackChildFragment = primaryChildFragment ? primaryChildFragment.sibling : null;
                    var fallbackChild = fallbackChildFragment ? fallbackChildFragment.child : null;
                    if (fallbackChild !== null) {
                      mountFiberRecursively(fallbackChild, shouldIncludeInTree ? fiber : parentFiber, true, traceNearestHostComponentUpdate);
                    }
                  } else {
                    var primaryChild = null;
                    var areSuspenseChildrenConditionallyWrapped = OffscreenComponent === -1;
                    if (areSuspenseChildrenConditionallyWrapped) {
                      primaryChild = fiber.child;
                    } else if (fiber.child !== null) {
                      primaryChild = fiber.child.child;
                    }
                    if (primaryChild !== null) {
                      mountFiberRecursively(primaryChild, shouldIncludeInTree ? fiber : parentFiber, true, traceNearestHostComponentUpdate);
                    }
                  }
                } else {
                  if (fiber.child !== null) {
                    mountFiberRecursively(fiber.child, shouldIncludeInTree ? fiber : parentFiber, true, traceNearestHostComponentUpdate);
                  }
                }
                updateTrackedPathStateAfterMount(mightSiblingsBeOnTrackedPath);
                fiber = traverseSiblings ? fiber.sibling : null;
              }
            }
            function unmountFiberChildrenRecursively(fiber) {
              if (constants["o"]) {
                debug("unmountFiberChildrenRecursively()", fiber);
              }
              var isTimedOutSuspense = fiber.tag === ReactTypeOfWork.SuspenseComponent && fiber.memoizedState !== null;
              var child = fiber.child;
              if (isTimedOutSuspense) {
                var primaryChildFragment = fiber.child;
                var fallbackChildFragment = primaryChildFragment ? primaryChildFragment.sibling : null;
                child = fallbackChildFragment ? fallbackChildFragment.child : null;
              }
              while (child !== null) {
                if (child.return !== null) {
                  unmountFiberChildrenRecursively(child);
                  recordUnmount(child, true);
                }
                child = child.sibling;
              }
            }
            function recordProfilingDurations(fiber) {
              var id = getFiberIDThrows(fiber);
              var actualDuration = fiber.actualDuration, treeBaseDuration = fiber.treeBaseDuration;
              idToTreeBaseDurationMap.set(id, treeBaseDuration || 0);
              if (isProfiling) {
                var alternate = fiber.alternate;
                if (alternate == null || treeBaseDuration !== alternate.treeBaseDuration) {
                  var convertedTreeBaseDuration = Math.floor((treeBaseDuration || 0) * 1e3);
                  pushOperation(constants["n"]);
                  pushOperation(id);
                  pushOperation(convertedTreeBaseDuration);
                }
                if (alternate == null || didFiberRender(alternate, fiber)) {
                  if (actualDuration != null) {
                    var selfDuration = actualDuration;
                    var child = fiber.child;
                    while (child !== null) {
                      selfDuration -= child.actualDuration || 0;
                      child = child.sibling;
                    }
                    var metadata = currentCommitProfilingMetadata;
                    metadata.durations.push(id, actualDuration, selfDuration);
                    metadata.maxActualDuration = Math.max(metadata.maxActualDuration, actualDuration);
                    if (recordChangeDescriptions) {
                      var changeDescription = getChangeDescription(alternate, fiber);
                      if (changeDescription !== null) {
                        if (metadata.changeDescriptions !== null) {
                          metadata.changeDescriptions.set(id, changeDescription);
                        }
                      }
                      updateContextsForFiber(fiber);
                    }
                  }
                }
              }
            }
            function recordResetChildren(fiber, childSet) {
              if (constants["o"]) {
                debug("recordResetChildren()", childSet, fiber);
              }
              var nextChildren = [];
              var child = childSet;
              while (child !== null) {
                findReorderedChildrenRecursively(child, nextChildren);
                child = child.sibling;
              }
              var numChildren = nextChildren.length;
              if (numChildren < 2) {
                return;
              }
              pushOperation(constants["l"]);
              pushOperation(getFiberIDThrows(fiber));
              pushOperation(numChildren);
              for (var i3 = 0; i3 < nextChildren.length; i3++) {
                pushOperation(nextChildren[i3]);
              }
            }
            function findReorderedChildrenRecursively(fiber, nextChildren) {
              if (!shouldFilterFiber(fiber)) {
                nextChildren.push(getFiberIDThrows(fiber));
              } else {
                var child = fiber.child;
                var isTimedOutSuspense = fiber.tag === SuspenseComponent && fiber.memoizedState !== null;
                if (isTimedOutSuspense) {
                  var primaryChildFragment = fiber.child;
                  var fallbackChildFragment = primaryChildFragment ? primaryChildFragment.sibling : null;
                  var fallbackChild = fallbackChildFragment ? fallbackChildFragment.child : null;
                  if (fallbackChild !== null) {
                    child = fallbackChild;
                  }
                }
                while (child !== null) {
                  findReorderedChildrenRecursively(child, nextChildren);
                  child = child.sibling;
                }
              }
            }
            function updateFiberRecursively(nextFiber, prevFiber, parentFiber, traceNearestHostComponentUpdate) {
              var id = getOrGenerateFiberID(nextFiber);
              if (constants["o"]) {
                debug("updateFiberRecursively()", nextFiber, parentFiber);
              }
              if (traceUpdatesEnabled) {
                var elementType = getElementTypeForFiber(nextFiber);
                if (traceNearestHostComponentUpdate) {
                  if (elementType === types2["i"]) {
                    traceUpdatesForNodes.add(nextFiber.stateNode);
                    traceNearestHostComponentUpdate = false;
                  }
                } else {
                  if (elementType === types2["h"] || elementType === types2["e"] || elementType === types2["f"] || elementType === types2["j"] || elementType === types2["g"]) {
                    traceNearestHostComponentUpdate = didFiberRender(prevFiber, nextFiber);
                  }
                }
              }
              if (mostRecentlyInspectedElement !== null && mostRecentlyInspectedElement.id === id && didFiberRender(prevFiber, nextFiber)) {
                hasElementUpdatedSinceLastInspected = true;
              }
              var shouldIncludeInTree = !shouldFilterFiber(nextFiber);
              var isSuspense = nextFiber.tag === SuspenseComponent;
              var shouldResetChildren = false;
              var prevDidTimeout = isSuspense && prevFiber.memoizedState !== null;
              var nextDidTimeOut = isSuspense && nextFiber.memoizedState !== null;
              if (prevDidTimeout && nextDidTimeOut) {
                var nextFiberChild = nextFiber.child;
                var nextFallbackChildSet = nextFiberChild ? nextFiberChild.sibling : null;
                var prevFiberChild = prevFiber.child;
                var prevFallbackChildSet = prevFiberChild ? prevFiberChild.sibling : null;
                if (nextFallbackChildSet != null && prevFallbackChildSet != null && updateFiberRecursively(nextFallbackChildSet, prevFallbackChildSet, nextFiber, traceNearestHostComponentUpdate)) {
                  shouldResetChildren = true;
                }
              } else if (prevDidTimeout && !nextDidTimeOut) {
                var nextPrimaryChildSet = nextFiber.child;
                if (nextPrimaryChildSet !== null) {
                  mountFiberRecursively(nextPrimaryChildSet, shouldIncludeInTree ? nextFiber : parentFiber, true, traceNearestHostComponentUpdate);
                }
                shouldResetChildren = true;
              } else if (!prevDidTimeout && nextDidTimeOut) {
                unmountFiberChildrenRecursively(prevFiber);
                var _nextFiberChild = nextFiber.child;
                var _nextFallbackChildSet = _nextFiberChild ? _nextFiberChild.sibling : null;
                if (_nextFallbackChildSet != null) {
                  mountFiberRecursively(_nextFallbackChildSet, shouldIncludeInTree ? nextFiber : parentFiber, true, traceNearestHostComponentUpdate);
                  shouldResetChildren = true;
                }
              } else {
                if (nextFiber.child !== prevFiber.child) {
                  var nextChild = nextFiber.child;
                  var prevChildAtSameIndex = prevFiber.child;
                  while (nextChild) {
                    if (nextChild.alternate) {
                      var prevChild = nextChild.alternate;
                      if (updateFiberRecursively(nextChild, prevChild, shouldIncludeInTree ? nextFiber : parentFiber, traceNearestHostComponentUpdate)) {
                        shouldResetChildren = true;
                      }
                      if (prevChild !== prevChildAtSameIndex) {
                        shouldResetChildren = true;
                      }
                    } else {
                      mountFiberRecursively(nextChild, shouldIncludeInTree ? nextFiber : parentFiber, false, traceNearestHostComponentUpdate);
                      shouldResetChildren = true;
                    }
                    nextChild = nextChild.sibling;
                    if (!shouldResetChildren && prevChildAtSameIndex !== null) {
                      prevChildAtSameIndex = prevChildAtSameIndex.sibling;
                    }
                  }
                  if (prevChildAtSameIndex !== null) {
                    shouldResetChildren = true;
                  }
                } else {
                  if (traceUpdatesEnabled) {
                    if (traceNearestHostComponentUpdate) {
                      var hostFibers = findAllCurrentHostFibers(getFiberIDThrows(nextFiber));
                      hostFibers.forEach(function(hostFiber) {
                        traceUpdatesForNodes.add(hostFiber.stateNode);
                      });
                    }
                  }
                }
              }
              if (shouldIncludeInTree) {
                var isProfilingSupported = nextFiber.hasOwnProperty("treeBaseDuration");
                if (isProfilingSupported) {
                  recordProfilingDurations(nextFiber);
                }
              }
              if (shouldResetChildren) {
                if (shouldIncludeInTree) {
                  var nextChildSet = nextFiber.child;
                  if (nextDidTimeOut) {
                    var _nextFiberChild2 = nextFiber.child;
                    nextChildSet = _nextFiberChild2 ? _nextFiberChild2.sibling : null;
                  }
                  if (nextChildSet != null) {
                    recordResetChildren(nextFiber, nextChildSet);
                  }
                  return false;
                } else {
                  return true;
                }
              } else {
                return false;
              }
            }
            function cleanup() {
            }
            function rootSupportsProfiling(root) {
              if (root.memoizedInteractions != null) {
                return true;
              } else if (root.current != null && root.current.hasOwnProperty("treeBaseDuration")) {
                return true;
              } else {
                return false;
              }
            }
            function flushInitialOperations() {
              var localPendingOperationsQueue = pendingOperationsQueue;
              pendingOperationsQueue = null;
              if (localPendingOperationsQueue !== null && localPendingOperationsQueue.length > 0) {
                localPendingOperationsQueue.forEach(function(operations) {
                  hook.emit("operations", operations);
                });
              } else {
                if (trackedPath !== null) {
                  mightBeOnTrackedPath = true;
                }
                hook.getFiberRoots(rendererID).forEach(function(root) {
                  currentRootID = getOrGenerateFiberID(root.current);
                  setRootPseudoKey(currentRootID, root.current);
                  if (isProfiling && rootSupportsProfiling(root)) {
                    currentCommitProfilingMetadata = {
                      changeDescriptions: recordChangeDescriptions ? /* @__PURE__ */ new Map() : null,
                      durations: [],
                      commitTime: getCurrentTime() - profilingStartTime,
                      maxActualDuration: 0,
                      priorityLevel: null,
                      updaters: getUpdatersList(root),
                      effectDuration: null,
                      passiveEffectDuration: null
                    };
                  }
                  mountFiberRecursively(root.current, null, false, false);
                  flushPendingEvents(root);
                  currentRootID = -1;
                });
              }
            }
            function getUpdatersList(root) {
              return root.memoizedUpdaters != null ? Array.from(root.memoizedUpdaters).map(fiberToSerializedElement) : null;
            }
            function handleCommitFiberUnmount(fiber) {
              recordUnmount(fiber, false);
            }
            function handlePostCommitFiberRoot(root) {
              if (isProfiling && rootSupportsProfiling(root)) {
                if (currentCommitProfilingMetadata !== null) {
                  var _getEffectDurations = Object(backend_utils["g"])(root), effectDuration = _getEffectDurations.effectDuration, passiveEffectDuration = _getEffectDurations.passiveEffectDuration;
                  currentCommitProfilingMetadata.effectDuration = effectDuration;
                  currentCommitProfilingMetadata.passiveEffectDuration = passiveEffectDuration;
                }
              }
            }
            function handleCommitFiberRoot(root, priorityLevel) {
              var current = root.current;
              var alternate = current.alternate;
              untrackFibers();
              currentRootID = getOrGenerateFiberID(current);
              if (trackedPath !== null) {
                mightBeOnTrackedPath = true;
              }
              if (traceUpdatesEnabled) {
                traceUpdatesForNodes.clear();
              }
              var isProfilingSupported = rootSupportsProfiling(root);
              if (isProfiling && isProfilingSupported) {
                currentCommitProfilingMetadata = {
                  changeDescriptions: recordChangeDescriptions ? /* @__PURE__ */ new Map() : null,
                  durations: [],
                  commitTime: getCurrentTime() - profilingStartTime,
                  maxActualDuration: 0,
                  priorityLevel: priorityLevel == null ? null : formatPriorityLevel(priorityLevel),
                  updaters: getUpdatersList(root),
                  effectDuration: null,
                  passiveEffectDuration: null
                };
              }
              if (alternate) {
                var wasMounted = alternate.memoizedState != null && alternate.memoizedState.element != null;
                var isMounted = current.memoizedState != null && current.memoizedState.element != null;
                if (!wasMounted && isMounted) {
                  setRootPseudoKey(currentRootID, current);
                  mountFiberRecursively(current, null, false, false);
                } else if (wasMounted && isMounted) {
                  updateFiberRecursively(current, alternate, null, false);
                } else if (wasMounted && !isMounted) {
                  removeRootPseudoKey(currentRootID);
                  recordUnmount(current, false);
                }
              } else {
                setRootPseudoKey(currentRootID, current);
                mountFiberRecursively(current, null, false, false);
              }
              if (isProfiling && isProfilingSupported) {
                var commitProfilingMetadata = rootToCommitProfilingMetadataMap.get(currentRootID);
                if (commitProfilingMetadata != null) {
                  commitProfilingMetadata.push(currentCommitProfilingMetadata);
                } else {
                  rootToCommitProfilingMetadataMap.set(currentRootID, [currentCommitProfilingMetadata]);
                }
              }
              flushPendingEvents(root);
              if (traceUpdatesEnabled) {
                hook.emit("traceUpdates", traceUpdatesForNodes);
              }
              currentRootID = -1;
            }
            function findAllCurrentHostFibers(id) {
              var fibers = [];
              var fiber = findCurrentFiberUsingSlowPathById(id);
              if (!fiber) {
                return fibers;
              }
              var node = fiber;
              while (true) {
                if (node.tag === HostComponent || node.tag === HostText) {
                  fibers.push(node);
                } else if (node.child) {
                  node.child.return = node;
                  node = node.child;
                  continue;
                }
                if (node === fiber) {
                  return fibers;
                }
                while (!node.sibling) {
                  if (!node.return || node.return === fiber) {
                    return fibers;
                  }
                  node = node.return;
                }
                node.sibling.return = node.return;
                node = node.sibling;
              }
              return fibers;
            }
            function findNativeNodesForFiberID(id) {
              try {
                var _fiber3 = findCurrentFiberUsingSlowPathById(id);
                if (_fiber3 === null) {
                  return null;
                }
                var isTimedOutSuspense = _fiber3.tag === SuspenseComponent && _fiber3.memoizedState !== null;
                if (isTimedOutSuspense) {
                  var maybeFallbackFiber = _fiber3.child && _fiber3.child.sibling;
                  if (maybeFallbackFiber != null) {
                    _fiber3 = maybeFallbackFiber;
                  }
                }
                var hostFibers = findAllCurrentHostFibers(id);
                return hostFibers.map(function(hostFiber) {
                  return hostFiber.stateNode;
                }).filter(Boolean);
              } catch (err2) {
                return null;
              }
            }
            function getDisplayNameForFiberID(id) {
              var fiber = idToArbitraryFiberMap.get(id);
              return fiber != null ? getDisplayNameForFiber(fiber) : null;
            }
            function getFiberIDForNative(hostInstance) {
              var findNearestUnfilteredAncestor = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : false;
              var fiber = renderer.findFiberByHostInstance(hostInstance);
              if (fiber != null) {
                if (findNearestUnfilteredAncestor) {
                  while (fiber !== null && shouldFilterFiber(fiber)) {
                    fiber = fiber.return;
                  }
                }
                return getFiberIDThrows(fiber);
              }
              return null;
            }
            var MOUNTING = 1;
            var MOUNTED = 2;
            var UNMOUNTED = 3;
            function isFiberMountedImpl(fiber) {
              var node = fiber;
              var prevNode = null;
              if (!fiber.alternate) {
                if ((getFiberFlags(node) & Placement) !== NoFlags) {
                  return MOUNTING;
                }
                if ((getFiberFlags(node) & Incomplete) !== NoFlags) {
                  return UNMOUNTED;
                }
                while (node.return) {
                  prevNode = node;
                  node = node.return;
                  if ((getFiberFlags(node) & Placement) !== NoFlags) {
                    return MOUNTING;
                  }
                  if ((getFiberFlags(node) & Incomplete) !== NoFlags) {
                    return UNMOUNTED;
                  }
                  var isTimedOutSuspense = node.tag === SuspenseComponent && node.memoizedState !== null;
                  if (isTimedOutSuspense) {
                    var primaryChildFragment = node.child;
                    var fallbackChildFragment = primaryChildFragment ? primaryChildFragment.sibling : null;
                    if (prevNode !== fallbackChildFragment) {
                      return UNMOUNTED;
                    }
                  }
                }
              } else {
                while (node.return) {
                  node = node.return;
                }
              }
              if (node.tag === HostRoot) {
                return MOUNTED;
              }
              return UNMOUNTED;
            }
            function findCurrentFiberUsingSlowPathById(id) {
              var fiber = idToArbitraryFiberMap.get(id);
              if (fiber == null) {
                console.warn('Could not find Fiber with id "'.concat(id, '"'));
                return null;
              }
              var alternate = fiber.alternate;
              if (!alternate) {
                var state = isFiberMountedImpl(fiber);
                if (state === UNMOUNTED) {
                  throw Error("Unable to find node on an unmounted component.");
                }
                if (state === MOUNTING) {
                  return null;
                }
                return fiber;
              }
              var a2 = fiber;
              var b2 = alternate;
              while (true) {
                var parentA = a2.return;
                if (parentA === null) {
                  break;
                }
                var parentB = parentA.alternate;
                if (parentB === null) {
                  var nextParent = parentA.return;
                  if (nextParent !== null) {
                    a2 = b2 = nextParent;
                    continue;
                  }
                  break;
                }
                if (parentA.child === parentB.child) {
                  var child = parentA.child;
                  while (child) {
                    if (child === a2) {
                      if (isFiberMountedImpl(parentA) !== MOUNTED) {
                        throw Error("Unable to find node on an unmounted component.");
                      }
                      return fiber;
                    }
                    if (child === b2) {
                      if (isFiberMountedImpl(parentA) !== MOUNTED) {
                        throw Error("Unable to find node on an unmounted component.");
                      }
                      return alternate;
                    }
                    child = child.sibling;
                  }
                  throw Error("Unable to find node on an unmounted component.");
                }
                if (a2.return !== b2.return) {
                  a2 = parentA;
                  b2 = parentB;
                } else {
                  var didFindChild = false;
                  var _child = parentA.child;
                  while (_child) {
                    if (_child === a2) {
                      didFindChild = true;
                      a2 = parentA;
                      b2 = parentB;
                      break;
                    }
                    if (_child === b2) {
                      didFindChild = true;
                      b2 = parentA;
                      a2 = parentB;
                      break;
                    }
                    _child = _child.sibling;
                  }
                  if (!didFindChild) {
                    _child = parentB.child;
                    while (_child) {
                      if (_child === a2) {
                        didFindChild = true;
                        a2 = parentB;
                        b2 = parentA;
                        break;
                      }
                      if (_child === b2) {
                        didFindChild = true;
                        b2 = parentB;
                        a2 = parentA;
                        break;
                      }
                      _child = _child.sibling;
                    }
                    if (!didFindChild) {
                      throw Error("Child was not found in either parent set. This indicates a bug in React related to the return pointer. Please file an issue.");
                    }
                  }
                }
                if (a2.alternate !== b2) {
                  throw Error("Return fibers should always be each others' alternates. This error is likely caused by a bug in React. Please file an issue.");
                }
              }
              if (a2.tag !== HostRoot) {
                throw Error("Unable to find node on an unmounted component.");
              }
              if (a2.stateNode.current === a2) {
                return fiber;
              }
              return alternate;
            }
            function prepareViewAttributeSource(id, path2) {
              if (isMostRecentlyInspectedElement(id)) {
                window.$attribute = Object(utils["h"])(mostRecentlyInspectedElement, path2);
              }
            }
            function prepareViewElementSource(id) {
              var fiber = idToArbitraryFiberMap.get(id);
              if (fiber == null) {
                console.warn('Could not find Fiber with id "'.concat(id, '"'));
                return;
              }
              var elementType = fiber.elementType, tag = fiber.tag, type3 = fiber.type;
              switch (tag) {
                case ClassComponent:
                case IncompleteClassComponent:
                case IndeterminateComponent:
                case FunctionComponent:
                  global2.$type = type3;
                  break;
                case ForwardRef:
                  global2.$type = type3.render;
                  break;
                case MemoComponent:
                case SimpleMemoComponent:
                  global2.$type = elementType != null && elementType.type != null ? elementType.type : type3;
                  break;
                default:
                  global2.$type = null;
                  break;
              }
            }
            function fiberToSerializedElement(fiber) {
              return {
                displayName: getDisplayNameForFiber(fiber) || "Anonymous",
                id: getFiberIDThrows(fiber),
                key: fiber.key,
                type: getElementTypeForFiber(fiber)
              };
            }
            function getOwnersList(id) {
              var fiber = findCurrentFiberUsingSlowPathById(id);
              if (fiber == null) {
                return null;
              }
              var _debugOwner = fiber._debugOwner;
              var owners = [fiberToSerializedElement(fiber)];
              if (_debugOwner) {
                var owner = _debugOwner;
                while (owner !== null) {
                  owners.unshift(fiberToSerializedElement(owner));
                  owner = owner._debugOwner || null;
                }
              }
              return owners;
            }
            function getInstanceAndStyle(id) {
              var instance = null;
              var style = null;
              var fiber = findCurrentFiberUsingSlowPathById(id);
              if (fiber !== null) {
                instance = fiber.stateNode;
                if (fiber.memoizedProps !== null) {
                  style = fiber.memoizedProps.style;
                }
              }
              return {
                instance,
                style
              };
            }
            function isErrorBoundary(fiber) {
              var tag = fiber.tag, type3 = fiber.type;
              switch (tag) {
                case ClassComponent:
                case IncompleteClassComponent:
                  var instance = fiber.stateNode;
                  return typeof type3.getDerivedStateFromError === "function" || instance !== null && typeof instance.componentDidCatch === "function";
                default:
                  return false;
              }
            }
            function getNearestErrorBoundaryID(fiber) {
              var parent = fiber.return;
              while (parent !== null) {
                if (isErrorBoundary(parent)) {
                  return getFiberIDUnsafe(parent);
                }
                parent = parent.return;
              }
              return null;
            }
            function inspectElementRaw(id) {
              var fiber = findCurrentFiberUsingSlowPathById(id);
              if (fiber == null) {
                return null;
              }
              var _debugOwner = fiber._debugOwner, _debugSource = fiber._debugSource, stateNode = fiber.stateNode, key2 = fiber.key, memoizedProps = fiber.memoizedProps, memoizedState = fiber.memoizedState, dependencies = fiber.dependencies, tag = fiber.tag, type3 = fiber.type;
              var elementType = getElementTypeForFiber(fiber);
              var usesHooks = (tag === FunctionComponent || tag === SimpleMemoComponent || tag === ForwardRef) && (!!memoizedState || !!dependencies);
              var showState = !usesHooks && tag !== CacheComponent;
              var typeSymbol = getTypeSymbol(type3);
              var canViewSource = false;
              var context = null;
              if (tag === ClassComponent || tag === FunctionComponent || tag === IncompleteClassComponent || tag === IndeterminateComponent || tag === MemoComponent || tag === ForwardRef || tag === SimpleMemoComponent) {
                canViewSource = true;
                if (stateNode && stateNode.context != null) {
                  var shouldHideContext = elementType === types2["e"] && !(type3.contextTypes || type3.contextType);
                  if (!shouldHideContext) {
                    context = stateNode.context;
                  }
                }
              } else if (typeSymbol === ReactSymbols["c"] || typeSymbol === ReactSymbols["d"]) {
                var consumerResolvedContext = type3._context || type3;
                context = consumerResolvedContext._currentValue || null;
                var _current = fiber.return;
                while (_current !== null) {
                  var currentType = _current.type;
                  var currentTypeSymbol = getTypeSymbol(currentType);
                  if (currentTypeSymbol === ReactSymbols["n"] || currentTypeSymbol === ReactSymbols["o"]) {
                    var providerResolvedContext = currentType._context || currentType.context;
                    if (providerResolvedContext === consumerResolvedContext) {
                      context = _current.memoizedProps.value;
                      break;
                    }
                  }
                  _current = _current.return;
                }
              }
              var hasLegacyContext = false;
              if (context !== null) {
                hasLegacyContext = !!type3.contextTypes;
                context = {
                  value: context
                };
              }
              var owners = null;
              if (_debugOwner) {
                owners = [];
                var owner = _debugOwner;
                while (owner !== null) {
                  owners.push(fiberToSerializedElement(owner));
                  owner = owner._debugOwner || null;
                }
              }
              var isTimedOutSuspense = tag === SuspenseComponent && memoizedState !== null;
              var hooks = null;
              if (usesHooks) {
                var originalConsoleMethods = {};
                for (var method in console) {
                  try {
                    originalConsoleMethods[method] = console[method];
                    console[method] = function() {
                    };
                  } catch (error) {
                  }
                }
                try {
                  hooks = Object(react_debug_tools["inspectHooksOfFiber"])(fiber, renderer.currentDispatcherRef, true);
                } finally {
                  for (var _method in originalConsoleMethods) {
                    try {
                      console[_method] = originalConsoleMethods[_method];
                    } catch (error) {
                    }
                  }
                }
              }
              var rootType = null;
              var current = fiber;
              while (current.return !== null) {
                current = current.return;
              }
              var fiberRoot = current.stateNode;
              if (fiberRoot != null && fiberRoot._debugRootType !== null) {
                rootType = fiberRoot._debugRootType;
              }
              var errors = fiberIDToErrorsMap.get(id) || /* @__PURE__ */ new Map();
              var warnings = fiberIDToWarningsMap.get(id) || /* @__PURE__ */ new Map();
              var isErrored = (fiber.flags & DidCapture) !== NoFlags || forceErrorForFiberIDs.get(id) === true;
              var targetErrorBoundaryID;
              if (isErrorBoundary(fiber)) {
                targetErrorBoundaryID = isErrored ? id : getNearestErrorBoundaryID(fiber);
              } else {
                targetErrorBoundaryID = getNearestErrorBoundaryID(fiber);
              }
              return {
                id,
                canEditHooks: typeof overrideHookState === "function",
                canEditFunctionProps: typeof overrideProps === "function",
                canEditHooksAndDeletePaths: typeof overrideHookStateDeletePath === "function",
                canEditHooksAndRenamePaths: typeof overrideHookStateRenamePath === "function",
                canEditFunctionPropsDeletePaths: typeof overridePropsDeletePath === "function",
                canEditFunctionPropsRenamePaths: typeof overridePropsRenamePath === "function",
                canToggleError: supportsTogglingError && targetErrorBoundaryID != null,
                isErrored,
                targetErrorBoundaryID,
                canToggleSuspense: supportsTogglingSuspense && (!isTimedOutSuspense || forceFallbackForSuspenseIDs.has(id)),
                canViewSource,
                hasLegacyContext,
                key: key2 != null ? key2 : null,
                displayName: getDisplayNameForFiber(fiber),
                type: elementType,
                context,
                hooks,
                props: memoizedProps,
                state: showState ? memoizedState : null,
                errors: Array.from(errors.entries()),
                warnings: Array.from(warnings.entries()),
                owners,
                source: _debugSource || null,
                rootType,
                rendererPackageName: renderer.rendererPackageName,
                rendererVersion: renderer.version
              };
            }
            var mostRecentlyInspectedElement = null;
            var hasElementUpdatedSinceLastInspected = false;
            var currentlyInspectedPaths = {};
            function isMostRecentlyInspectedElement(id) {
              return mostRecentlyInspectedElement !== null && mostRecentlyInspectedElement.id === id;
            }
            function isMostRecentlyInspectedElementCurrent(id) {
              return isMostRecentlyInspectedElement(id) && !hasElementUpdatedSinceLastInspected;
            }
            function mergeInspectedPaths(path2) {
              var current = currentlyInspectedPaths;
              path2.forEach(function(key2) {
                if (!current[key2]) {
                  current[key2] = {};
                }
                current = current[key2];
              });
            }
            function createIsPathAllowed(key2, secondaryCategory) {
              return function isPathAllowed(path2) {
                switch (secondaryCategory) {
                  case "hooks":
                    if (path2.length === 1) {
                      return true;
                    }
                    if (path2[path2.length - 2] === "hookSource" && path2[path2.length - 1] === "fileName") {
                      return true;
                    }
                    if (path2[path2.length - 1] === "subHooks" || path2[path2.length - 2] === "subHooks") {
                      return true;
                    }
                    break;
                  default:
                    break;
                }
                var current = key2 === null ? currentlyInspectedPaths : currentlyInspectedPaths[key2];
                if (!current) {
                  return false;
                }
                for (var i3 = 0; i3 < path2.length; i3++) {
                  current = current[path2[i3]];
                  if (!current) {
                    return false;
                  }
                }
                return true;
              };
            }
            function updateSelectedElement(inspectedElement) {
              var hooks = inspectedElement.hooks, id = inspectedElement.id, props = inspectedElement.props;
              var fiber = idToArbitraryFiberMap.get(id);
              if (fiber == null) {
                console.warn('Could not find Fiber with id "'.concat(id, '"'));
                return;
              }
              var elementType = fiber.elementType, stateNode = fiber.stateNode, tag = fiber.tag, type3 = fiber.type;
              switch (tag) {
                case ClassComponent:
                case IncompleteClassComponent:
                case IndeterminateComponent:
                  global2.$r = stateNode;
                  break;
                case FunctionComponent:
                  global2.$r = {
                    hooks,
                    props,
                    type: type3
                  };
                  break;
                case ForwardRef:
                  global2.$r = {
                    hooks,
                    props,
                    type: type3.render
                  };
                  break;
                case MemoComponent:
                case SimpleMemoComponent:
                  global2.$r = {
                    hooks,
                    props,
                    type: elementType != null && elementType.type != null ? elementType.type : type3
                  };
                  break;
                default:
                  global2.$r = null;
                  break;
              }
            }
            function storeAsGlobal(id, path2, count) {
              if (isMostRecentlyInspectedElement(id)) {
                var value = Object(utils["h"])(mostRecentlyInspectedElement, path2);
                var key2 = "$reactTemp".concat(count);
                window[key2] = value;
                console.log(key2);
                console.log(value);
              }
            }
            function copyElementPath(id, path2) {
              if (isMostRecentlyInspectedElement(id)) {
                Object(backend_utils["b"])(Object(utils["h"])(mostRecentlyInspectedElement, path2));
              }
            }
            function inspectElement(requestID, id, path2) {
              if (path2 !== null) {
                mergeInspectedPaths(path2);
              }
              if (isMostRecentlyInspectedElement(id)) {
                if (!hasElementUpdatedSinceLastInspected) {
                  if (path2 !== null) {
                    var secondaryCategory = null;
                    if (path2[0] === "hooks") {
                      secondaryCategory = "hooks";
                    }
                    return {
                      id,
                      responseID: requestID,
                      type: "hydrated-path",
                      path: path2,
                      value: Object(backend_utils["a"])(Object(utils["h"])(mostRecentlyInspectedElement, path2), createIsPathAllowed(null, secondaryCategory), path2)
                    };
                  } else {
                    return {
                      id,
                      responseID: requestID,
                      type: "no-change"
                    };
                  }
                }
              } else {
                currentlyInspectedPaths = {};
              }
              hasElementUpdatedSinceLastInspected = false;
              mostRecentlyInspectedElement = inspectElementRaw(id);
              if (mostRecentlyInspectedElement === null) {
                return {
                  id,
                  responseID: requestID,
                  type: "not-found"
                };
              }
              updateSelectedElement(mostRecentlyInspectedElement);
              var cleanedInspectedElement = _objectSpread({}, mostRecentlyInspectedElement);
              cleanedInspectedElement.context = Object(backend_utils["a"])(cleanedInspectedElement.context, createIsPathAllowed("context", null));
              cleanedInspectedElement.hooks = Object(backend_utils["a"])(cleanedInspectedElement.hooks, createIsPathAllowed("hooks", "hooks"));
              cleanedInspectedElement.props = Object(backend_utils["a"])(cleanedInspectedElement.props, createIsPathAllowed("props", null));
              cleanedInspectedElement.state = Object(backend_utils["a"])(cleanedInspectedElement.state, createIsPathAllowed("state", null));
              return {
                id,
                responseID: requestID,
                type: "full-data",
                value: cleanedInspectedElement
              };
            }
            function logElementToConsole(id) {
              var result2 = isMostRecentlyInspectedElementCurrent(id) ? mostRecentlyInspectedElement : inspectElementRaw(id);
              if (result2 === null) {
                console.warn('Could not find Fiber with id "'.concat(id, '"'));
                return;
              }
              var supportsGroup = typeof console.groupCollapsed === "function";
              if (supportsGroup) {
                console.groupCollapsed("[Click to expand] %c<".concat(result2.displayName || "Component", " />"), "color: var(--dom-tag-name-color); font-weight: normal;");
              }
              if (result2.props !== null) {
                console.log("Props:", result2.props);
              }
              if (result2.state !== null) {
                console.log("State:", result2.state);
              }
              if (result2.hooks !== null) {
                console.log("Hooks:", result2.hooks);
              }
              var nativeNodes = findNativeNodesForFiberID(id);
              if (nativeNodes !== null) {
                console.log("Nodes:", nativeNodes);
              }
              if (result2.source !== null) {
                console.log("Location:", result2.source);
              }
              if (window.chrome || /firefox/i.test(navigator.userAgent)) {
                console.log("Right-click any value to save it as a global variable for further inspection.");
              }
              if (supportsGroup) {
                console.groupEnd();
              }
            }
            function deletePath(type3, id, hookID, path2) {
              var fiber = findCurrentFiberUsingSlowPathById(id);
              if (fiber !== null) {
                var instance = fiber.stateNode;
                switch (type3) {
                  case "context":
                    path2 = path2.slice(1);
                    switch (fiber.tag) {
                      case ClassComponent:
                        if (path2.length === 0) {
                        } else {
                          Object(utils["a"])(instance.context, path2);
                        }
                        instance.forceUpdate();
                        break;
                      case FunctionComponent:
                        break;
                    }
                    break;
                  case "hooks":
                    if (typeof overrideHookStateDeletePath === "function") {
                      overrideHookStateDeletePath(fiber, hookID, path2);
                    }
                    break;
                  case "props":
                    if (instance === null) {
                      if (typeof overridePropsDeletePath === "function") {
                        overridePropsDeletePath(fiber, path2);
                      }
                    } else {
                      fiber.pendingProps = Object(backend_utils["c"])(instance.props, path2);
                      instance.forceUpdate();
                    }
                    break;
                  case "state":
                    Object(utils["a"])(instance.state, path2);
                    instance.forceUpdate();
                    break;
                }
              }
            }
            function renamePath(type3, id, hookID, oldPath, newPath) {
              var fiber = findCurrentFiberUsingSlowPathById(id);
              if (fiber !== null) {
                var instance = fiber.stateNode;
                switch (type3) {
                  case "context":
                    oldPath = oldPath.slice(1);
                    newPath = newPath.slice(1);
                    switch (fiber.tag) {
                      case ClassComponent:
                        if (oldPath.length === 0) {
                        } else {
                          Object(utils["k"])(instance.context, oldPath, newPath);
                        }
                        instance.forceUpdate();
                        break;
                      case FunctionComponent:
                        break;
                    }
                    break;
                  case "hooks":
                    if (typeof overrideHookStateRenamePath === "function") {
                      overrideHookStateRenamePath(fiber, hookID, oldPath, newPath);
                    }
                    break;
                  case "props":
                    if (instance === null) {
                      if (typeof overridePropsRenamePath === "function") {
                        overridePropsRenamePath(fiber, oldPath, newPath);
                      }
                    } else {
                      fiber.pendingProps = Object(backend_utils["d"])(instance.props, oldPath, newPath);
                      instance.forceUpdate();
                    }
                    break;
                  case "state":
                    Object(utils["k"])(instance.state, oldPath, newPath);
                    instance.forceUpdate();
                    break;
                }
              }
            }
            function overrideValueAtPath(type3, id, hookID, path2, value) {
              var fiber = findCurrentFiberUsingSlowPathById(id);
              if (fiber !== null) {
                var instance = fiber.stateNode;
                switch (type3) {
                  case "context":
                    path2 = path2.slice(1);
                    switch (fiber.tag) {
                      case ClassComponent:
                        if (path2.length === 0) {
                          instance.context = value;
                        } else {
                          Object(utils["l"])(instance.context, path2, value);
                        }
                        instance.forceUpdate();
                        break;
                      case FunctionComponent:
                        break;
                    }
                    break;
                  case "hooks":
                    if (typeof overrideHookState === "function") {
                      overrideHookState(fiber, hookID, path2, value);
                    }
                    break;
                  case "props":
                    switch (fiber.tag) {
                      case ClassComponent:
                        fiber.pendingProps = Object(backend_utils["e"])(instance.props, path2, value);
                        instance.forceUpdate();
                        break;
                      default:
                        if (typeof overrideProps === "function") {
                          overrideProps(fiber, path2, value);
                        }
                        break;
                    }
                    break;
                  case "state":
                    switch (fiber.tag) {
                      case ClassComponent:
                        Object(utils["l"])(instance.state, path2, value);
                        instance.forceUpdate();
                        break;
                    }
                    break;
                }
              }
            }
            var currentCommitProfilingMetadata = null;
            var displayNamesByRootID = null;
            var idToContextsMap = null;
            var initialTreeBaseDurationsMap = null;
            var initialIDToRootMap = null;
            var isProfiling = false;
            var profilingStartTime = 0;
            var recordChangeDescriptions = false;
            var rootToCommitProfilingMetadataMap = null;
            function getProfilingData() {
              var dataForRoots = [];
              if (rootToCommitProfilingMetadataMap === null) {
                throw Error("getProfilingData() called before any profiling data was recorded");
              }
              rootToCommitProfilingMetadataMap.forEach(function(commitProfilingMetadata, rootID) {
                var commitData = [];
                var initialTreeBaseDurations = [];
                var displayName = displayNamesByRootID !== null && displayNamesByRootID.get(rootID) || "Unknown";
                if (initialTreeBaseDurationsMap != null) {
                  initialTreeBaseDurationsMap.forEach(function(treeBaseDuration, id) {
                    if (initialIDToRootMap != null && initialIDToRootMap.get(id) === rootID) {
                      initialTreeBaseDurations.push([id, treeBaseDuration]);
                    }
                  });
                }
                commitProfilingMetadata.forEach(function(commitProfilingData, commitIndex) {
                  var changeDescriptions = commitProfilingData.changeDescriptions, durations = commitProfilingData.durations, effectDuration = commitProfilingData.effectDuration, maxActualDuration = commitProfilingData.maxActualDuration, passiveEffectDuration = commitProfilingData.passiveEffectDuration, priorityLevel = commitProfilingData.priorityLevel, commitTime = commitProfilingData.commitTime, updaters = commitProfilingData.updaters;
                  var fiberActualDurations = [];
                  var fiberSelfDurations = [];
                  for (var i3 = 0; i3 < durations.length; i3 += 3) {
                    var fiberID = durations[i3];
                    fiberActualDurations.push([fiberID, durations[i3 + 1]]);
                    fiberSelfDurations.push([fiberID, durations[i3 + 2]]);
                  }
                  commitData.push({
                    changeDescriptions: changeDescriptions !== null ? Array.from(changeDescriptions.entries()) : null,
                    duration: maxActualDuration,
                    effectDuration,
                    fiberActualDurations,
                    fiberSelfDurations,
                    passiveEffectDuration,
                    priorityLevel,
                    timestamp: commitTime,
                    updaters
                  });
                });
                dataForRoots.push({
                  commitData,
                  displayName,
                  initialTreeBaseDurations,
                  rootID
                });
              });
              return {
                dataForRoots,
                rendererID
              };
            }
            function startProfiling(shouldRecordChangeDescriptions) {
              if (isProfiling) {
                return;
              }
              recordChangeDescriptions = shouldRecordChangeDescriptions;
              displayNamesByRootID = /* @__PURE__ */ new Map();
              initialTreeBaseDurationsMap = new Map(idToTreeBaseDurationMap);
              initialIDToRootMap = new Map(idToRootMap);
              idToContextsMap = /* @__PURE__ */ new Map();
              hook.getFiberRoots(rendererID).forEach(function(root) {
                var rootID = getFiberIDThrows(root.current);
                displayNamesByRootID.set(rootID, getDisplayNameForRoot(root.current));
                if (shouldRecordChangeDescriptions) {
                  crawlToInitializeContextsMap(root.current);
                }
              });
              isProfiling = true;
              profilingStartTime = getCurrentTime();
              rootToCommitProfilingMetadataMap = /* @__PURE__ */ new Map();
            }
            function stopProfiling() {
              isProfiling = false;
              recordChangeDescriptions = false;
            }
            if (Object(storage["c"])(constants["h"]) === "true") {
              startProfiling(Object(storage["c"])(constants["g"]) === "true");
            }
            function shouldErrorFiberAlwaysNull() {
              return null;
            }
            var forceErrorForFiberIDs = /* @__PURE__ */ new Map();
            function shouldErrorFiberAccordingToMap(fiber) {
              if (typeof setErrorHandler !== "function") {
                throw new Error("Expected overrideError() to not get called for earlier React versions.");
              }
              var id = getFiberIDUnsafe(fiber);
              if (id === null) {
                return null;
              }
              var status = null;
              if (forceErrorForFiberIDs.has(id)) {
                status = forceErrorForFiberIDs.get(id);
                if (status === false) {
                  forceErrorForFiberIDs.delete(id);
                  if (forceErrorForFiberIDs.size === 0) {
                    setErrorHandler(shouldErrorFiberAlwaysNull);
                  }
                }
              }
              return status;
            }
            function overrideError(id, forceError) {
              if (typeof setErrorHandler !== "function" || typeof scheduleUpdate !== "function") {
                throw new Error("Expected overrideError() to not get called for earlier React versions.");
              }
              forceErrorForFiberIDs.set(id, forceError);
              if (forceErrorForFiberIDs.size === 1) {
                setErrorHandler(shouldErrorFiberAccordingToMap);
              }
              var fiber = idToArbitraryFiberMap.get(id);
              if (fiber != null) {
                scheduleUpdate(fiber);
              }
            }
            function shouldSuspendFiberAlwaysFalse() {
              return false;
            }
            var forceFallbackForSuspenseIDs = /* @__PURE__ */ new Set();
            function shouldSuspendFiberAccordingToSet(fiber) {
              var maybeID = getFiberIDUnsafe(fiber);
              return maybeID !== null && forceFallbackForSuspenseIDs.has(maybeID);
            }
            function overrideSuspense(id, forceFallback) {
              if (typeof setSuspenseHandler !== "function" || typeof scheduleUpdate !== "function") {
                throw new Error("Expected overrideSuspense() to not get called for earlier React versions.");
              }
              if (forceFallback) {
                forceFallbackForSuspenseIDs.add(id);
                if (forceFallbackForSuspenseIDs.size === 1) {
                  setSuspenseHandler(shouldSuspendFiberAccordingToSet);
                }
              } else {
                forceFallbackForSuspenseIDs.delete(id);
                if (forceFallbackForSuspenseIDs.size === 0) {
                  setSuspenseHandler(shouldSuspendFiberAlwaysFalse);
                }
              }
              var fiber = idToArbitraryFiberMap.get(id);
              if (fiber != null) {
                scheduleUpdate(fiber);
              }
            }
            var trackedPath = null;
            var trackedPathMatchFiber = null;
            var trackedPathMatchDepth = -1;
            var mightBeOnTrackedPath = false;
            function setTrackedPath(path2) {
              if (path2 === null) {
                trackedPathMatchFiber = null;
                trackedPathMatchDepth = -1;
                mightBeOnTrackedPath = false;
              }
              trackedPath = path2;
            }
            function updateTrackedPathStateBeforeMount(fiber) {
              if (trackedPath === null || !mightBeOnTrackedPath) {
                return false;
              }
              var returnFiber = fiber.return;
              var returnAlternate = returnFiber !== null ? returnFiber.alternate : null;
              if (trackedPathMatchFiber === returnFiber || trackedPathMatchFiber === returnAlternate && returnAlternate !== null) {
                var actualFrame = getPathFrame(fiber);
                var expectedFrame = trackedPath[trackedPathMatchDepth + 1];
                if (expectedFrame === void 0) {
                  throw new Error("Expected to see a frame at the next depth.");
                }
                if (actualFrame.index === expectedFrame.index && actualFrame.key === expectedFrame.key && actualFrame.displayName === expectedFrame.displayName) {
                  trackedPathMatchFiber = fiber;
                  trackedPathMatchDepth++;
                  if (trackedPathMatchDepth === trackedPath.length - 1) {
                    mightBeOnTrackedPath = false;
                  } else {
                    mightBeOnTrackedPath = true;
                  }
                  return false;
                }
              }
              mightBeOnTrackedPath = false;
              return true;
            }
            function updateTrackedPathStateAfterMount(mightSiblingsBeOnTrackedPath) {
              mightBeOnTrackedPath = mightSiblingsBeOnTrackedPath;
            }
            var rootPseudoKeys = /* @__PURE__ */ new Map();
            var rootDisplayNameCounter = /* @__PURE__ */ new Map();
            function setRootPseudoKey(id, fiber) {
              var name = getDisplayNameForRoot(fiber);
              var counter = rootDisplayNameCounter.get(name) || 0;
              rootDisplayNameCounter.set(name, counter + 1);
              var pseudoKey = "".concat(name, ":").concat(counter);
              rootPseudoKeys.set(id, pseudoKey);
            }
            function removeRootPseudoKey(id) {
              var pseudoKey = rootPseudoKeys.get(id);
              if (pseudoKey === void 0) {
                throw new Error("Expected root pseudo key to be known.");
              }
              var name = pseudoKey.substring(0, pseudoKey.lastIndexOf(":"));
              var counter = rootDisplayNameCounter.get(name);
              if (counter === void 0) {
                throw new Error("Expected counter to be known.");
              }
              if (counter > 1) {
                rootDisplayNameCounter.set(name, counter - 1);
              } else {
                rootDisplayNameCounter.delete(name);
              }
              rootPseudoKeys.delete(id);
            }
            function getDisplayNameForRoot(fiber) {
              var preferredDisplayName = null;
              var fallbackDisplayName = null;
              var child = fiber.child;
              for (var i3 = 0; i3 < 3; i3++) {
                if (child === null) {
                  break;
                }
                var displayName = getDisplayNameForFiber(child);
                if (displayName !== null) {
                  if (typeof child.type === "function") {
                    preferredDisplayName = displayName;
                  } else if (fallbackDisplayName === null) {
                    fallbackDisplayName = displayName;
                  }
                }
                if (preferredDisplayName !== null) {
                  break;
                }
                child = child.child;
              }
              return preferredDisplayName || fallbackDisplayName || "Anonymous";
            }
            function getPathFrame(fiber) {
              var key2 = fiber.key;
              var displayName = getDisplayNameForFiber(fiber);
              var index = fiber.index;
              switch (fiber.tag) {
                case HostRoot:
                  var id = getFiberIDThrows(fiber);
                  var pseudoKey = rootPseudoKeys.get(id);
                  if (pseudoKey === void 0) {
                    throw new Error("Expected mounted root to have known pseudo key.");
                  }
                  displayName = pseudoKey;
                  break;
                case HostComponent:
                  displayName = fiber.type;
                  break;
                default:
                  break;
              }
              return {
                displayName,
                key: key2,
                index
              };
            }
            function getPathForElement(id) {
              var fiber = idToArbitraryFiberMap.get(id);
              if (fiber == null) {
                return null;
              }
              var keyPath = [];
              while (fiber !== null) {
                keyPath.push(getPathFrame(fiber));
                fiber = fiber.return;
              }
              keyPath.reverse();
              return keyPath;
            }
            function getBestMatchForTrackedPath() {
              if (trackedPath === null) {
                return null;
              }
              if (trackedPathMatchFiber === null) {
                return null;
              }
              var fiber = trackedPathMatchFiber;
              while (fiber !== null && shouldFilterFiber(fiber)) {
                fiber = fiber.return;
              }
              if (fiber === null) {
                return null;
              }
              return {
                id: getFiberIDThrows(fiber),
                isFullMatch: trackedPathMatchDepth === trackedPath.length - 1
              };
            }
            var formatPriorityLevel = function formatPriorityLevel2(priorityLevel) {
              if (priorityLevel == null) {
                return "Unknown";
              }
              switch (priorityLevel) {
                case ImmediatePriority:
                  return "Immediate";
                case UserBlockingPriority:
                  return "User-Blocking";
                case NormalPriority:
                  return "Normal";
                case LowPriority:
                  return "Low";
                case IdlePriority:
                  return "Idle";
                case NoPriority:
                default:
                  return "Unknown";
              }
            };
            function setTraceUpdatesEnabled(isEnabled) {
              traceUpdatesEnabled = isEnabled;
            }
            return {
              cleanup,
              clearErrorsAndWarnings,
              clearErrorsForFiberID,
              clearWarningsForFiberID,
              copyElementPath,
              deletePath,
              findNativeNodesForFiberID,
              flushInitialOperations,
              getBestMatchForTrackedPath,
              getDisplayNameForFiberID,
              getFiberIDForNative,
              getInstanceAndStyle,
              getOwnersList,
              getPathForElement,
              getProfilingData,
              handleCommitFiberRoot,
              handleCommitFiberUnmount,
              handlePostCommitFiberRoot,
              inspectElement,
              logElementToConsole,
              prepareViewAttributeSource,
              prepareViewElementSource,
              overrideError,
              overrideSuspense,
              overrideValueAtPath,
              renamePath,
              renderer,
              setTraceUpdatesEnabled,
              setTrackedPath,
              startProfiling,
              stopProfiling,
              storeAsGlobal,
              updateComponentFilters
            };
          }
        },
        function(module3, exports3) {
          var process2 = module3.exports = {};
          var cachedSetTimeout;
          var cachedClearTimeout;
          function defaultSetTimout() {
            throw new Error("setTimeout has not been defined");
          }
          function defaultClearTimeout() {
            throw new Error("clearTimeout has not been defined");
          }
          (function() {
            try {
              if (typeof setTimeout === "function") {
                cachedSetTimeout = setTimeout;
              } else {
                cachedSetTimeout = defaultSetTimout;
              }
            } catch (e2) {
              cachedSetTimeout = defaultSetTimout;
            }
            try {
              if (typeof clearTimeout === "function") {
                cachedClearTimeout = clearTimeout;
              } else {
                cachedClearTimeout = defaultClearTimeout;
              }
            } catch (e2) {
              cachedClearTimeout = defaultClearTimeout;
            }
          })();
          function runTimeout(fun) {
            if (cachedSetTimeout === setTimeout) {
              return setTimeout(fun, 0);
            }
            if ((cachedSetTimeout === defaultSetTimout || !cachedSetTimeout) && setTimeout) {
              cachedSetTimeout = setTimeout;
              return setTimeout(fun, 0);
            }
            try {
              return cachedSetTimeout(fun, 0);
            } catch (e2) {
              try {
                return cachedSetTimeout.call(null, fun, 0);
              } catch (e3) {
                return cachedSetTimeout.call(this, fun, 0);
              }
            }
          }
          function runClearTimeout(marker) {
            if (cachedClearTimeout === clearTimeout) {
              return clearTimeout(marker);
            }
            if ((cachedClearTimeout === defaultClearTimeout || !cachedClearTimeout) && clearTimeout) {
              cachedClearTimeout = clearTimeout;
              return clearTimeout(marker);
            }
            try {
              return cachedClearTimeout(marker);
            } catch (e2) {
              try {
                return cachedClearTimeout.call(null, marker);
              } catch (e3) {
                return cachedClearTimeout.call(this, marker);
              }
            }
          }
          var queue = [];
          var draining = false;
          var currentQueue;
          var queueIndex = -1;
          function cleanUpNextTick() {
            if (!draining || !currentQueue) {
              return;
            }
            draining = false;
            if (currentQueue.length) {
              queue = currentQueue.concat(queue);
            } else {
              queueIndex = -1;
            }
            if (queue.length) {
              drainQueue();
            }
          }
          function drainQueue() {
            if (draining) {
              return;
            }
            var timeout = runTimeout(cleanUpNextTick);
            draining = true;
            var len = queue.length;
            while (len) {
              currentQueue = queue;
              queue = [];
              while (++queueIndex < len) {
                if (currentQueue) {
                  currentQueue[queueIndex].run();
                }
              }
              queueIndex = -1;
              len = queue.length;
            }
            currentQueue = null;
            draining = false;
            runClearTimeout(timeout);
          }
          process2.nextTick = function(fun) {
            var args = new Array(arguments.length - 1);
            if (arguments.length > 1) {
              for (var i3 = 1; i3 < arguments.length; i3++) {
                args[i3 - 1] = arguments[i3];
              }
            }
            queue.push(new Item(fun, args));
            if (queue.length === 1 && !draining) {
              runTimeout(drainQueue);
            }
          };
          function Item(fun, array) {
            this.fun = fun;
            this.array = array;
          }
          Item.prototype.run = function() {
            this.fun.apply(null, this.array);
          };
          process2.title = "browser";
          process2.browser = true;
          process2.env = {};
          process2.argv = [];
          process2.version = "";
          process2.versions = {};
          function noop() {
          }
          process2.on = noop;
          process2.addListener = noop;
          process2.once = noop;
          process2.off = noop;
          process2.removeListener = noop;
          process2.removeAllListeners = noop;
          process2.emit = noop;
          process2.prependListener = noop;
          process2.prependOnceListener = noop;
          process2.listeners = function(name) {
            return [];
          };
          process2.binding = function(name) {
            throw new Error("process.binding is not supported");
          };
          process2.cwd = function() {
            return "/";
          };
          process2.chdir = function(dir) {
            throw new Error("process.chdir is not supported");
          };
          process2.umask = function() {
            return 0;
          };
        },
        function(module3, exports3, __webpack_require__) {
          (function(setImmediate) {
            function _typeof(obj) {
              "@babel/helpers - typeof";
              if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
                _typeof = function _typeof2(obj2) {
                  return typeof obj2;
                };
              } else {
                _typeof = function _typeof2(obj2) {
                  return obj2 && typeof Symbol === "function" && obj2.constructor === Symbol && obj2 !== Symbol.prototype ? "symbol" : typeof obj2;
                };
              }
              return _typeof(obj);
            }
            (function(name, definition) {
              if (true) {
                module3.exports = definition();
              } else {
              }
            })("clipboard", function() {
              if (typeof document === "undefined" || !document.addEventListener) {
                return null;
              }
              var clipboard = {};
              clipboard.copy = function() {
                var _intercept = false;
                var _data = null;
                var _bogusSelection = false;
                function cleanup() {
                  _intercept = false;
                  _data = null;
                  if (_bogusSelection) {
                    window.getSelection().removeAllRanges();
                  }
                  _bogusSelection = false;
                }
                document.addEventListener("copy", function(e2) {
                  if (_intercept) {
                    for (var key2 in _data) {
                      e2.clipboardData.setData(key2, _data[key2]);
                    }
                    e2.preventDefault();
                  }
                });
                function bogusSelect() {
                  var sel = document.getSelection();
                  if (!document.queryCommandEnabled("copy") && sel.isCollapsed) {
                    var range = document.createRange();
                    range.selectNodeContents(document.body);
                    sel.removeAllRanges();
                    sel.addRange(range);
                    _bogusSelection = true;
                  }
                }
                ;
                return function(data) {
                  return new Promise(function(resolve, reject) {
                    _intercept = true;
                    if (typeof data === "string") {
                      _data = {
                        "text/plain": data
                      };
                    } else if (data instanceof Node) {
                      _data = {
                        "text/html": new XMLSerializer().serializeToString(data)
                      };
                    } else if (data instanceof Object) {
                      _data = data;
                    } else {
                      reject("Invalid data type. Must be string, DOM node, or an object mapping MIME types to strings.");
                    }
                    function triggerCopy(tryBogusSelect) {
                      try {
                        if (document.execCommand("copy")) {
                          cleanup();
                          resolve();
                        } else {
                          if (!tryBogusSelect) {
                            bogusSelect();
                            triggerCopy(true);
                          } else {
                            cleanup();
                            throw new Error("Unable to copy. Perhaps it's not available in your browser?");
                          }
                        }
                      } catch (e2) {
                        cleanup();
                        reject(e2);
                      }
                    }
                    triggerCopy(false);
                  });
                };
              }();
              clipboard.paste = function() {
                var _intercept = false;
                var _resolve;
                var _dataType;
                document.addEventListener("paste", function(e2) {
                  if (_intercept) {
                    _intercept = false;
                    e2.preventDefault();
                    var resolve = _resolve;
                    _resolve = null;
                    resolve(e2.clipboardData.getData(_dataType));
                  }
                });
                return function(dataType) {
                  return new Promise(function(resolve, reject) {
                    _intercept = true;
                    _resolve = resolve;
                    _dataType = dataType || "text/plain";
                    try {
                      if (!document.execCommand("paste")) {
                        _intercept = false;
                        reject(new Error("Unable to paste. Pasting only works in Internet Explorer at the moment."));
                      }
                    } catch (e2) {
                      _intercept = false;
                      reject(new Error(e2));
                    }
                  });
                };
              }();
              if (typeof ClipboardEvent === "undefined" && typeof window.clipboardData !== "undefined" && typeof window.clipboardData.setData !== "undefined") {
                (function(a2) {
                  function b2(a3, b3) {
                    return function() {
                      a3.apply(b3, arguments);
                    };
                  }
                  function c2(a3) {
                    if (_typeof(this) != "object")
                      throw new TypeError("Promises must be constructed via new");
                    if (typeof a3 != "function")
                      throw new TypeError("not a function");
                    this._state = null, this._value = null, this._deferreds = [], i3(a3, b2(e2, this), b2(f, this));
                  }
                  function d(a3) {
                    var b3 = this;
                    return this._state === null ? void this._deferreds.push(a3) : void j(function() {
                      var c3 = b3._state ? a3.onFulfilled : a3.onRejected;
                      if (c3 === null)
                        return void (b3._state ? a3.resolve : a3.reject)(b3._value);
                      var d2;
                      try {
                        d2 = c3(b3._value);
                      } catch (e3) {
                        return void a3.reject(e3);
                      }
                      a3.resolve(d2);
                    });
                  }
                  function e2(a3) {
                    try {
                      if (a3 === this)
                        throw new TypeError("A promise cannot be resolved with itself.");
                      if (a3 && (_typeof(a3) == "object" || typeof a3 == "function")) {
                        var c3 = a3.then;
                        if (typeof c3 == "function")
                          return void i3(b2(c3, a3), b2(e2, this), b2(f, this));
                      }
                      this._state = true, this._value = a3, g2.call(this);
                    } catch (d2) {
                      f.call(this, d2);
                    }
                  }
                  function f(a3) {
                    this._state = false, this._value = a3, g2.call(this);
                  }
                  function g2() {
                    for (var a3 = 0, b3 = this._deferreds.length; b3 > a3; a3++) {
                      d.call(this, this._deferreds[a3]);
                    }
                    this._deferreds = null;
                  }
                  function h(a3, b3, c3, d2) {
                    this.onFulfilled = typeof a3 == "function" ? a3 : null, this.onRejected = typeof b3 == "function" ? b3 : null, this.resolve = c3, this.reject = d2;
                  }
                  function i3(a3, b3, c3) {
                    var d2 = false;
                    try {
                      a3(function(a4) {
                        d2 || (d2 = true, b3(a4));
                      }, function(a4) {
                        d2 || (d2 = true, c3(a4));
                      });
                    } catch (e3) {
                      if (d2)
                        return;
                      d2 = true, c3(e3);
                    }
                  }
                  var j = c2.immediateFn || typeof setImmediate == "function" && setImmediate || function(a3) {
                    setTimeout(a3, 1);
                  }, k = Array.isArray || function(a3) {
                    return Object.prototype.toString.call(a3) === "[object Array]";
                  };
                  c2.prototype["catch"] = function(a3) {
                    return this.then(null, a3);
                  }, c2.prototype.then = function(a3, b3) {
                    var e3 = this;
                    return new c2(function(c3, f2) {
                      d.call(e3, new h(a3, b3, c3, f2));
                    });
                  }, c2.all = function() {
                    var a3 = Array.prototype.slice.call(arguments.length === 1 && k(arguments[0]) ? arguments[0] : arguments);
                    return new c2(function(b3, c3) {
                      function d2(f3, g3) {
                        try {
                          if (g3 && (_typeof(g3) == "object" || typeof g3 == "function")) {
                            var h2 = g3.then;
                            if (typeof h2 == "function")
                              return void h2.call(g3, function(a4) {
                                d2(f3, a4);
                              }, c3);
                          }
                          a3[f3] = g3, --e3 === 0 && b3(a3);
                        } catch (i4) {
                          c3(i4);
                        }
                      }
                      if (a3.length === 0)
                        return b3([]);
                      for (var e3 = a3.length, f2 = 0; f2 < a3.length; f2++) {
                        d2(f2, a3[f2]);
                      }
                    });
                  }, c2.resolve = function(a3) {
                    return a3 && _typeof(a3) == "object" && a3.constructor === c2 ? a3 : new c2(function(b3) {
                      b3(a3);
                    });
                  }, c2.reject = function(a3) {
                    return new c2(function(b3, c3) {
                      c3(a3);
                    });
                  }, c2.race = function(a3) {
                    return new c2(function(b3, c3) {
                      for (var d2 = 0, e3 = a3.length; e3 > d2; d2++) {
                        a3[d2].then(b3, c3);
                      }
                    });
                  }, module3.exports ? module3.exports = c2 : a2.Promise || (a2.Promise = c2);
                })(this);
                clipboard.copy = function(data) {
                  return new Promise(function(resolve, reject) {
                    if (typeof data !== "string" && !("text/plain" in data)) {
                      throw new Error("You must provide a text/plain type.");
                    }
                    var strData = typeof data === "string" ? data : data["text/plain"];
                    var copySucceeded = window.clipboardData.setData("Text", strData);
                    if (copySucceeded) {
                      resolve();
                    } else {
                      reject(new Error("Copying was rejected."));
                    }
                  });
                };
                clipboard.paste = function() {
                  return new Promise(function(resolve, reject) {
                    var strData = window.clipboardData.getData("Text");
                    if (strData) {
                      resolve(strData);
                    } else {
                      reject(new Error("Pasting was rejected."));
                    }
                  });
                };
              }
              return clipboard;
            });
          }).call(this, __webpack_require__(21).setImmediate);
        },
        function(module3, exports3, __webpack_require__) {
          "use strict";
          function _classCallCheck(instance, Constructor) {
            if (!(instance instanceof Constructor)) {
              throw new TypeError("Cannot call a class as a function");
            }
          }
          function _defineProperties(target, props) {
            for (var i3 = 0; i3 < props.length; i3++) {
              var descriptor = props[i3];
              descriptor.enumerable = descriptor.enumerable || false;
              descriptor.configurable = true;
              if ("value" in descriptor)
                descriptor.writable = true;
              Object.defineProperty(target, descriptor.key, descriptor);
            }
          }
          function _createClass(Constructor, protoProps, staticProps) {
            if (protoProps)
              _defineProperties(Constructor.prototype, protoProps);
            if (staticProps)
              _defineProperties(Constructor, staticProps);
            return Constructor;
          }
          var Yallist = __webpack_require__(23);
          var MAX = Symbol("max");
          var LENGTH = Symbol("length");
          var LENGTH_CALCULATOR = Symbol("lengthCalculator");
          var ALLOW_STALE = Symbol("allowStale");
          var MAX_AGE = Symbol("maxAge");
          var DISPOSE = Symbol("dispose");
          var NO_DISPOSE_ON_SET = Symbol("noDisposeOnSet");
          var LRU_LIST = Symbol("lruList");
          var CACHE = Symbol("cache");
          var UPDATE_AGE_ON_GET = Symbol("updateAgeOnGet");
          var naiveLength = function naiveLength2() {
            return 1;
          };
          var LRUCache = /* @__PURE__ */ function() {
            function LRUCache2(options) {
              _classCallCheck(this, LRUCache2);
              if (typeof options === "number")
                options = {
                  max: options
                };
              if (!options)
                options = {};
              if (options.max && (typeof options.max !== "number" || options.max < 0))
                throw new TypeError("max must be a non-negative number");
              var max = this[MAX] = options.max || Infinity;
              var lc = options.length || naiveLength;
              this[LENGTH_CALCULATOR] = typeof lc !== "function" ? naiveLength : lc;
              this[ALLOW_STALE] = options.stale || false;
              if (options.maxAge && typeof options.maxAge !== "number")
                throw new TypeError("maxAge must be a number");
              this[MAX_AGE] = options.maxAge || 0;
              this[DISPOSE] = options.dispose;
              this[NO_DISPOSE_ON_SET] = options.noDisposeOnSet || false;
              this[UPDATE_AGE_ON_GET] = options.updateAgeOnGet || false;
              this.reset();
            }
            _createClass(LRUCache2, [{
              key: "rforEach",
              value: function rforEach(fn, thisp) {
                thisp = thisp || this;
                for (var walker = this[LRU_LIST].tail; walker !== null; ) {
                  var prev = walker.prev;
                  forEachStep(this, fn, walker, thisp);
                  walker = prev;
                }
              }
            }, {
              key: "forEach",
              value: function forEach(fn, thisp) {
                thisp = thisp || this;
                for (var walker = this[LRU_LIST].head; walker !== null; ) {
                  var next = walker.next;
                  forEachStep(this, fn, walker, thisp);
                  walker = next;
                }
              }
            }, {
              key: "keys",
              value: function keys() {
                return this[LRU_LIST].toArray().map(function(k) {
                  return k.key;
                });
              }
            }, {
              key: "values",
              value: function values() {
                return this[LRU_LIST].toArray().map(function(k) {
                  return k.value;
                });
              }
            }, {
              key: "reset",
              value: function reset() {
                var _this = this;
                if (this[DISPOSE] && this[LRU_LIST] && this[LRU_LIST].length) {
                  this[LRU_LIST].forEach(function(hit) {
                    return _this[DISPOSE](hit.key, hit.value);
                  });
                }
                this[CACHE] = /* @__PURE__ */ new Map();
                this[LRU_LIST] = new Yallist();
                this[LENGTH] = 0;
              }
            }, {
              key: "dump",
              value: function dump3() {
                var _this2 = this;
                return this[LRU_LIST].map(function(hit) {
                  return isStale(_this2, hit) ? false : {
                    k: hit.key,
                    v: hit.value,
                    e: hit.now + (hit.maxAge || 0)
                  };
                }).toArray().filter(function(h) {
                  return h;
                });
              }
            }, {
              key: "dumpLru",
              value: function dumpLru() {
                return this[LRU_LIST];
              }
            }, {
              key: "set",
              value: function set2(key2, value, maxAge) {
                maxAge = maxAge || this[MAX_AGE];
                if (maxAge && typeof maxAge !== "number")
                  throw new TypeError("maxAge must be a number");
                var now = maxAge ? Date.now() : 0;
                var len = this[LENGTH_CALCULATOR](value, key2);
                if (this[CACHE].has(key2)) {
                  if (len > this[MAX]) {
                    _del(this, this[CACHE].get(key2));
                    return false;
                  }
                  var node = this[CACHE].get(key2);
                  var item = node.value;
                  if (this[DISPOSE]) {
                    if (!this[NO_DISPOSE_ON_SET])
                      this[DISPOSE](key2, item.value);
                  }
                  item.now = now;
                  item.maxAge = maxAge;
                  item.value = value;
                  this[LENGTH] += len - item.length;
                  item.length = len;
                  this.get(key2);
                  trim(this);
                  return true;
                }
                var hit = new Entry(key2, value, len, now, maxAge);
                if (hit.length > this[MAX]) {
                  if (this[DISPOSE])
                    this[DISPOSE](key2, value);
                  return false;
                }
                this[LENGTH] += hit.length;
                this[LRU_LIST].unshift(hit);
                this[CACHE].set(key2, this[LRU_LIST].head);
                trim(this);
                return true;
              }
            }, {
              key: "has",
              value: function has(key2) {
                if (!this[CACHE].has(key2))
                  return false;
                var hit = this[CACHE].get(key2).value;
                return !isStale(this, hit);
              }
            }, {
              key: "get",
              value: function get(key2) {
                return _get(this, key2, true);
              }
            }, {
              key: "peek",
              value: function peek(key2) {
                return _get(this, key2, false);
              }
            }, {
              key: "pop",
              value: function pop() {
                var node = this[LRU_LIST].tail;
                if (!node)
                  return null;
                _del(this, node);
                return node.value;
              }
            }, {
              key: "del",
              value: function del(key2) {
                _del(this, this[CACHE].get(key2));
              }
            }, {
              key: "load",
              value: function load2(arr) {
                this.reset();
                var now = Date.now();
                for (var l2 = arr.length - 1; l2 >= 0; l2--) {
                  var hit = arr[l2];
                  var expiresAt = hit.e || 0;
                  if (expiresAt === 0)
                    this.set(hit.k, hit.v);
                  else {
                    var maxAge = expiresAt - now;
                    if (maxAge > 0) {
                      this.set(hit.k, hit.v, maxAge);
                    }
                  }
                }
              }
            }, {
              key: "prune",
              value: function prune() {
                var _this3 = this;
                this[CACHE].forEach(function(value, key2) {
                  return _get(_this3, key2, false);
                });
              }
            }, {
              key: "max",
              set: function set2(mL) {
                if (typeof mL !== "number" || mL < 0)
                  throw new TypeError("max must be a non-negative number");
                this[MAX] = mL || Infinity;
                trim(this);
              },
              get: function get() {
                return this[MAX];
              }
            }, {
              key: "allowStale",
              set: function set2(allowStale) {
                this[ALLOW_STALE] = !!allowStale;
              },
              get: function get() {
                return this[ALLOW_STALE];
              }
            }, {
              key: "maxAge",
              set: function set2(mA) {
                if (typeof mA !== "number")
                  throw new TypeError("maxAge must be a non-negative number");
                this[MAX_AGE] = mA;
                trim(this);
              },
              get: function get() {
                return this[MAX_AGE];
              }
            }, {
              key: "lengthCalculator",
              set: function set2(lC) {
                var _this4 = this;
                if (typeof lC !== "function")
                  lC = naiveLength;
                if (lC !== this[LENGTH_CALCULATOR]) {
                  this[LENGTH_CALCULATOR] = lC;
                  this[LENGTH] = 0;
                  this[LRU_LIST].forEach(function(hit) {
                    hit.length = _this4[LENGTH_CALCULATOR](hit.value, hit.key);
                    _this4[LENGTH] += hit.length;
                  });
                }
                trim(this);
              },
              get: function get() {
                return this[LENGTH_CALCULATOR];
              }
            }, {
              key: "length",
              get: function get() {
                return this[LENGTH];
              }
            }, {
              key: "itemCount",
              get: function get() {
                return this[LRU_LIST].length;
              }
            }]);
            return LRUCache2;
          }();
          var _get = function _get2(self2, key2, doUse) {
            var node = self2[CACHE].get(key2);
            if (node) {
              var hit = node.value;
              if (isStale(self2, hit)) {
                _del(self2, node);
                if (!self2[ALLOW_STALE])
                  return void 0;
              } else {
                if (doUse) {
                  if (self2[UPDATE_AGE_ON_GET])
                    node.value.now = Date.now();
                  self2[LRU_LIST].unshiftNode(node);
                }
              }
              return hit.value;
            }
          };
          var isStale = function isStale2(self2, hit) {
            if (!hit || !hit.maxAge && !self2[MAX_AGE])
              return false;
            var diff2 = Date.now() - hit.now;
            return hit.maxAge ? diff2 > hit.maxAge : self2[MAX_AGE] && diff2 > self2[MAX_AGE];
          };
          var trim = function trim2(self2) {
            if (self2[LENGTH] > self2[MAX]) {
              for (var walker = self2[LRU_LIST].tail; self2[LENGTH] > self2[MAX] && walker !== null; ) {
                var prev = walker.prev;
                _del(self2, walker);
                walker = prev;
              }
            }
          };
          var _del = function _del2(self2, node) {
            if (node) {
              var hit = node.value;
              if (self2[DISPOSE])
                self2[DISPOSE](hit.key, hit.value);
              self2[LENGTH] -= hit.length;
              self2[CACHE].delete(hit.key);
              self2[LRU_LIST].removeNode(node);
            }
          };
          var Entry = function Entry2(key2, value, length, now, maxAge) {
            _classCallCheck(this, Entry2);
            this.key = key2;
            this.value = value;
            this.length = length;
            this.now = now;
            this.maxAge = maxAge || 0;
          };
          var forEachStep = function forEachStep2(self2, fn, node, thisp) {
            var hit = node.value;
            if (isStale(self2, hit)) {
              _del(self2, node);
              if (!self2[ALLOW_STALE])
                hit = void 0;
            }
            if (hit)
              fn.call(thisp, hit.value, hit.key, self2);
          };
          module3.exports = LRUCache;
        },
        function(module3, exports3, __webpack_require__) {
          "use strict";
          if (true) {
            module3.exports = __webpack_require__(26);
          } else {
          }
        },
        function(module3, __webpack_exports__, __webpack_require__) {
          "use strict";
          __webpack_require__.d(__webpack_exports__, "a", function() {
            return getStackByFiberInDevAndProd;
          });
          var ReactSymbols = __webpack_require__(3);
          function ownKeys(object, enumerableOnly) {
            var keys = Object.keys(object);
            if (Object.getOwnPropertySymbols) {
              var symbols = Object.getOwnPropertySymbols(object);
              if (enumerableOnly)
                symbols = symbols.filter(function(sym) {
                  return Object.getOwnPropertyDescriptor(object, sym).enumerable;
                });
              keys.push.apply(keys, symbols);
            }
            return keys;
          }
          function _objectSpread(target) {
            for (var i3 = 1; i3 < arguments.length; i3++) {
              var source = arguments[i3] != null ? arguments[i3] : {};
              if (i3 % 2) {
                ownKeys(Object(source), true).forEach(function(key2) {
                  _defineProperty(target, key2, source[key2]);
                });
              } else if (Object.getOwnPropertyDescriptors) {
                Object.defineProperties(target, Object.getOwnPropertyDescriptors(source));
              } else {
                ownKeys(Object(source)).forEach(function(key2) {
                  Object.defineProperty(target, key2, Object.getOwnPropertyDescriptor(source, key2));
                });
              }
            }
            return target;
          }
          function _defineProperty(obj, key2, value) {
            if (key2 in obj) {
              Object.defineProperty(obj, key2, { value, enumerable: true, configurable: true, writable: true });
            } else {
              obj[key2] = value;
            }
            return obj;
          }
          var disabledDepth = 0;
          var prevLog;
          var prevInfo;
          var prevWarn;
          var prevError;
          var prevGroup;
          var prevGroupCollapsed;
          var prevGroupEnd;
          function disabledLog() {
          }
          disabledLog.__reactDisabledLog = true;
          function disableLogs() {
            if (disabledDepth === 0) {
              prevLog = console.log;
              prevInfo = console.info;
              prevWarn = console.warn;
              prevError = console.error;
              prevGroup = console.group;
              prevGroupCollapsed = console.groupCollapsed;
              prevGroupEnd = console.groupEnd;
              var props = {
                configurable: true,
                enumerable: true,
                value: disabledLog,
                writable: true
              };
              Object.defineProperties(console, {
                info: props,
                log: props,
                warn: props,
                error: props,
                group: props,
                groupCollapsed: props,
                groupEnd: props
              });
            }
            disabledDepth++;
          }
          function reenableLogs() {
            disabledDepth--;
            if (disabledDepth === 0) {
              var props = {
                configurable: true,
                enumerable: true,
                writable: true
              };
              Object.defineProperties(console, {
                log: _objectSpread(_objectSpread({}, props), {}, {
                  value: prevLog
                }),
                info: _objectSpread(_objectSpread({}, props), {}, {
                  value: prevInfo
                }),
                warn: _objectSpread(_objectSpread({}, props), {}, {
                  value: prevWarn
                }),
                error: _objectSpread(_objectSpread({}, props), {}, {
                  value: prevError
                }),
                group: _objectSpread(_objectSpread({}, props), {}, {
                  value: prevGroup
                }),
                groupCollapsed: _objectSpread(_objectSpread({}, props), {}, {
                  value: prevGroupCollapsed
                }),
                groupEnd: _objectSpread(_objectSpread({}, props), {}, {
                  value: prevGroupEnd
                })
              });
            }
            if (disabledDepth < 0) {
              console.error("disabledDepth fell below zero. This is a bug in React. Please file an issue.");
            }
          }
          function _typeof(obj) {
            "@babel/helpers - typeof";
            if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
              _typeof = function _typeof2(obj2) {
                return typeof obj2;
              };
            } else {
              _typeof = function _typeof2(obj2) {
                return obj2 && typeof Symbol === "function" && obj2.constructor === Symbol && obj2 !== Symbol.prototype ? "symbol" : typeof obj2;
              };
            }
            return _typeof(obj);
          }
          var prefix2;
          function describeBuiltInComponentFrame(name, source, ownerFn) {
            if (prefix2 === void 0) {
              try {
                throw Error();
              } catch (x) {
                var match = x.stack.trim().match(/\n( *(at )?)/);
                prefix2 = match && match[1] || "";
              }
            }
            return "\n" + prefix2 + name;
          }
          var reentry = false;
          var componentFrameCache;
          if (false) {
            var PossiblyWeakMap;
          }
          function describeNativeComponentFrame(fn, construct, currentDispatcherRef) {
            if (!fn || reentry) {
              return "";
            }
            if (false) {
              var frame;
            }
            var control;
            var previousPrepareStackTrace = Error.prepareStackTrace;
            Error.prepareStackTrace = void 0;
            reentry = true;
            var previousDispatcher = currentDispatcherRef.current;
            currentDispatcherRef.current = null;
            disableLogs();
            try {
              if (construct) {
                var Fake = function Fake2() {
                  throw Error();
                };
                Object.defineProperty(Fake.prototype, "props", {
                  set: function set2() {
                    throw Error();
                  }
                });
                if ((typeof Reflect === "undefined" ? "undefined" : _typeof(Reflect)) === "object" && Reflect.construct) {
                  try {
                    Reflect.construct(Fake, []);
                  } catch (x) {
                    control = x;
                  }
                  Reflect.construct(fn, [], Fake);
                } else {
                  try {
                    Fake.call();
                  } catch (x) {
                    control = x;
                  }
                  fn.call(Fake.prototype);
                }
              } else {
                try {
                  throw Error();
                } catch (x) {
                  control = x;
                }
                fn();
              }
            } catch (sample) {
              if (sample && control && typeof sample.stack === "string") {
                var sampleLines = sample.stack.split("\n");
                var controlLines = control.stack.split("\n");
                var s2 = sampleLines.length - 1;
                var c2 = controlLines.length - 1;
                while (s2 >= 1 && c2 >= 0 && sampleLines[s2] !== controlLines[c2]) {
                  c2--;
                }
                for (; s2 >= 1 && c2 >= 0; s2--, c2--) {
                  if (sampleLines[s2] !== controlLines[c2]) {
                    if (s2 !== 1 || c2 !== 1) {
                      do {
                        s2--;
                        c2--;
                        if (c2 < 0 || sampleLines[s2] !== controlLines[c2]) {
                          var _frame = "\n" + sampleLines[s2].replace(" at new ", " at ");
                          if (false) {
                          }
                          return _frame;
                        }
                      } while (s2 >= 1 && c2 >= 0);
                    }
                    break;
                  }
                }
              }
            } finally {
              reentry = false;
              Error.prepareStackTrace = previousPrepareStackTrace;
              currentDispatcherRef.current = previousDispatcher;
              reenableLogs();
            }
            var name = fn ? fn.displayName || fn.name : "";
            var syntheticFrame = name ? describeBuiltInComponentFrame(name) : "";
            if (false) {
            }
            return syntheticFrame;
          }
          function describeClassComponentFrame(ctor, source, ownerFn, currentDispatcherRef) {
            return describeNativeComponentFrame(ctor, true, currentDispatcherRef);
          }
          function describeFunctionComponentFrame(fn, source, ownerFn, currentDispatcherRef) {
            return describeNativeComponentFrame(fn, false, currentDispatcherRef);
          }
          function shouldConstruct(Component) {
            var prototype = Component.prototype;
            return !!(prototype && prototype.isReactComponent);
          }
          function describeUnknownElementTypeFrameInDEV(type3, source, ownerFn, currentDispatcherRef) {
            if (true) {
              return "";
            }
            if (type3 == null) {
              return "";
            }
            if (typeof type3 === "function") {
              return describeNativeComponentFrame(type3, shouldConstruct(type3), currentDispatcherRef);
            }
            if (typeof type3 === "string") {
              return describeBuiltInComponentFrame(type3, source, ownerFn);
            }
            switch (type3) {
              case ReactSymbols["v"]:
              case ReactSymbols["w"]:
                return describeBuiltInComponentFrame("Suspense", source, ownerFn);
              case ReactSymbols["t"]:
              case ReactSymbols["u"]:
                return describeBuiltInComponentFrame("SuspenseList", source, ownerFn);
            }
            if (_typeof(type3) === "object") {
              switch (type3.$$typeof) {
                case ReactSymbols["f"]:
                case ReactSymbols["g"]:
                  return describeFunctionComponentFrame(type3.render, source, ownerFn, currentDispatcherRef);
                case ReactSymbols["j"]:
                case ReactSymbols["k"]:
                  return describeUnknownElementTypeFrameInDEV(type3.type, source, ownerFn, currentDispatcherRef);
                case ReactSymbols["h"]:
                case ReactSymbols["i"]: {
                  var lazyComponent = type3;
                  var payload = lazyComponent._payload;
                  var init = lazyComponent._init;
                  try {
                    return describeUnknownElementTypeFrameInDEV(init(payload), source, ownerFn, currentDispatcherRef);
                  } catch (x) {
                  }
                }
              }
            }
            return "";
          }
          function describeFiber(workTagMap, workInProgress, currentDispatcherRef) {
            var HostComponent = workTagMap.HostComponent, LazyComponent = workTagMap.LazyComponent, SuspenseComponent = workTagMap.SuspenseComponent, SuspenseListComponent = workTagMap.SuspenseListComponent, FunctionComponent = workTagMap.FunctionComponent, IndeterminateComponent = workTagMap.IndeterminateComponent, SimpleMemoComponent = workTagMap.SimpleMemoComponent, ForwardRef = workTagMap.ForwardRef, ClassComponent = workTagMap.ClassComponent;
            var owner = false ? void 0 : null;
            var source = false ? void 0 : null;
            switch (workInProgress.tag) {
              case HostComponent:
                return describeBuiltInComponentFrame(workInProgress.type, source, owner);
              case LazyComponent:
                return describeBuiltInComponentFrame("Lazy", source, owner);
              case SuspenseComponent:
                return describeBuiltInComponentFrame("Suspense", source, owner);
              case SuspenseListComponent:
                return describeBuiltInComponentFrame("SuspenseList", source, owner);
              case FunctionComponent:
              case IndeterminateComponent:
              case SimpleMemoComponent:
                return describeFunctionComponentFrame(workInProgress.type, source, owner, currentDispatcherRef);
              case ForwardRef:
                return describeFunctionComponentFrame(workInProgress.type.render, source, owner, currentDispatcherRef);
              case ClassComponent:
                return describeClassComponentFrame(workInProgress.type, source, owner, currentDispatcherRef);
              default:
                return "";
            }
          }
          function getStackByFiberInDevAndProd(workTagMap, workInProgress, currentDispatcherRef) {
            try {
              var info = "";
              var node = workInProgress;
              do {
                info += describeFiber(workTagMap, node, currentDispatcherRef);
                node = node.return;
              } while (node);
              return info;
            } catch (x) {
              return "\nError generating stack: " + x.message + "\n" + x.stack;
            }
          }
        },
        function(module3, exports3, __webpack_require__) {
          (function(global2) {
            var scope = typeof global2 !== "undefined" && global2 || typeof self !== "undefined" && self || window;
            var apply = Function.prototype.apply;
            exports3.setTimeout = function() {
              return new Timeout(apply.call(setTimeout, scope, arguments), clearTimeout);
            };
            exports3.setInterval = function() {
              return new Timeout(apply.call(setInterval, scope, arguments), clearInterval);
            };
            exports3.clearTimeout = exports3.clearInterval = function(timeout) {
              if (timeout) {
                timeout.close();
              }
            };
            function Timeout(id, clearFn) {
              this._id = id;
              this._clearFn = clearFn;
            }
            Timeout.prototype.unref = Timeout.prototype.ref = function() {
            };
            Timeout.prototype.close = function() {
              this._clearFn.call(scope, this._id);
            };
            exports3.enroll = function(item, msecs) {
              clearTimeout(item._idleTimeoutId);
              item._idleTimeout = msecs;
            };
            exports3.unenroll = function(item) {
              clearTimeout(item._idleTimeoutId);
              item._idleTimeout = -1;
            };
            exports3._unrefActive = exports3.active = function(item) {
              clearTimeout(item._idleTimeoutId);
              var msecs = item._idleTimeout;
              if (msecs >= 0) {
                item._idleTimeoutId = setTimeout(function onTimeout() {
                  if (item._onTimeout)
                    item._onTimeout();
                }, msecs);
              }
            };
            __webpack_require__(22);
            exports3.setImmediate = typeof self !== "undefined" && self.setImmediate || typeof global2 !== "undefined" && global2.setImmediate || this && this.setImmediate;
            exports3.clearImmediate = typeof self !== "undefined" && self.clearImmediate || typeof global2 !== "undefined" && global2.clearImmediate || this && this.clearImmediate;
          }).call(this, __webpack_require__(13));
        },
        function(module3, exports3, __webpack_require__) {
          (function(global2, process2) {
            (function(global3, undefined2) {
              "use strict";
              if (global3.setImmediate) {
                return;
              }
              var nextHandle = 1;
              var tasksByHandle = {};
              var currentlyRunningATask = false;
              var doc = global3.document;
              var registerImmediate;
              function setImmediate(callback) {
                if (typeof callback !== "function") {
                  callback = new Function("" + callback);
                }
                var args = new Array(arguments.length - 1);
                for (var i3 = 0; i3 < args.length; i3++) {
                  args[i3] = arguments[i3 + 1];
                }
                var task2 = {
                  callback,
                  args
                };
                tasksByHandle[nextHandle] = task2;
                registerImmediate(nextHandle);
                return nextHandle++;
              }
              function clearImmediate(handle) {
                delete tasksByHandle[handle];
              }
              function run2(task2) {
                var callback = task2.callback;
                var args = task2.args;
                switch (args.length) {
                  case 0:
                    callback();
                    break;
                  case 1:
                    callback(args[0]);
                    break;
                  case 2:
                    callback(args[0], args[1]);
                    break;
                  case 3:
                    callback(args[0], args[1], args[2]);
                    break;
                  default:
                    callback.apply(undefined2, args);
                    break;
                }
              }
              function runIfPresent(handle) {
                if (currentlyRunningATask) {
                  setTimeout(runIfPresent, 0, handle);
                } else {
                  var task2 = tasksByHandle[handle];
                  if (task2) {
                    currentlyRunningATask = true;
                    try {
                      run2(task2);
                    } finally {
                      clearImmediate(handle);
                      currentlyRunningATask = false;
                    }
                  }
                }
              }
              function installNextTickImplementation() {
                registerImmediate = function registerImmediate2(handle) {
                  process2.nextTick(function() {
                    runIfPresent(handle);
                  });
                };
              }
              function canUsePostMessage() {
                if (global3.postMessage && !global3.importScripts) {
                  var postMessageIsAsynchronous = true;
                  var oldOnMessage = global3.onmessage;
                  global3.onmessage = function() {
                    postMessageIsAsynchronous = false;
                  };
                  global3.postMessage("", "*");
                  global3.onmessage = oldOnMessage;
                  return postMessageIsAsynchronous;
                }
              }
              function installPostMessageImplementation() {
                var messagePrefix = "setImmediate$" + Math.random() + "$";
                var onGlobalMessage = function onGlobalMessage2(event2) {
                  if (event2.source === global3 && typeof event2.data === "string" && event2.data.indexOf(messagePrefix) === 0) {
                    runIfPresent(+event2.data.slice(messagePrefix.length));
                  }
                };
                if (global3.addEventListener) {
                  global3.addEventListener("message", onGlobalMessage, false);
                } else {
                  global3.attachEvent("onmessage", onGlobalMessage);
                }
                registerImmediate = function registerImmediate2(handle) {
                  global3.postMessage(messagePrefix + handle, "*");
                };
              }
              function installMessageChannelImplementation() {
                var channel = new MessageChannel();
                channel.port1.onmessage = function(event2) {
                  var handle = event2.data;
                  runIfPresent(handle);
                };
                registerImmediate = function registerImmediate2(handle) {
                  channel.port2.postMessage(handle);
                };
              }
              function installReadyStateChangeImplementation() {
                var html = doc.documentElement;
                registerImmediate = function registerImmediate2(handle) {
                  var script = doc.createElement("script");
                  script.onreadystatechange = function() {
                    runIfPresent(handle);
                    script.onreadystatechange = null;
                    html.removeChild(script);
                    script = null;
                  };
                  html.appendChild(script);
                };
              }
              function installSetTimeoutImplementation() {
                registerImmediate = function registerImmediate2(handle) {
                  setTimeout(runIfPresent, 0, handle);
                };
              }
              var attachTo = Object.getPrototypeOf && Object.getPrototypeOf(global3);
              attachTo = attachTo && attachTo.setTimeout ? attachTo : global3;
              if ({}.toString.call(global3.process) === "[object process]") {
                installNextTickImplementation();
              } else if (canUsePostMessage()) {
                installPostMessageImplementation();
              } else if (global3.MessageChannel) {
                installMessageChannelImplementation();
              } else if (doc && "onreadystatechange" in doc.createElement("script")) {
                installReadyStateChangeImplementation();
              } else {
                installSetTimeoutImplementation();
              }
              attachTo.setImmediate = setImmediate;
              attachTo.clearImmediate = clearImmediate;
            })(typeof self === "undefined" ? typeof global2 === "undefined" ? this : global2 : self);
          }).call(this, __webpack_require__(13), __webpack_require__(16));
        },
        function(module3, exports3, __webpack_require__) {
          "use strict";
          module3.exports = Yallist;
          Yallist.Node = Node2;
          Yallist.create = Yallist;
          function Yallist(list) {
            var self2 = this;
            if (!(self2 instanceof Yallist)) {
              self2 = new Yallist();
            }
            self2.tail = null;
            self2.head = null;
            self2.length = 0;
            if (list && typeof list.forEach === "function") {
              list.forEach(function(item) {
                self2.push(item);
              });
            } else if (arguments.length > 0) {
              for (var i3 = 0, l2 = arguments.length; i3 < l2; i3++) {
                self2.push(arguments[i3]);
              }
            }
            return self2;
          }
          Yallist.prototype.removeNode = function(node) {
            if (node.list !== this) {
              throw new Error("removing node which does not belong to this list");
            }
            var next = node.next;
            var prev = node.prev;
            if (next) {
              next.prev = prev;
            }
            if (prev) {
              prev.next = next;
            }
            if (node === this.head) {
              this.head = next;
            }
            if (node === this.tail) {
              this.tail = prev;
            }
            node.list.length--;
            node.next = null;
            node.prev = null;
            node.list = null;
            return next;
          };
          Yallist.prototype.unshiftNode = function(node) {
            if (node === this.head) {
              return;
            }
            if (node.list) {
              node.list.removeNode(node);
            }
            var head = this.head;
            node.list = this;
            node.next = head;
            if (head) {
              head.prev = node;
            }
            this.head = node;
            if (!this.tail) {
              this.tail = node;
            }
            this.length++;
          };
          Yallist.prototype.pushNode = function(node) {
            if (node === this.tail) {
              return;
            }
            if (node.list) {
              node.list.removeNode(node);
            }
            var tail = this.tail;
            node.list = this;
            node.prev = tail;
            if (tail) {
              tail.next = node;
            }
            this.tail = node;
            if (!this.head) {
              this.head = node;
            }
            this.length++;
          };
          Yallist.prototype.push = function() {
            for (var i3 = 0, l2 = arguments.length; i3 < l2; i3++) {
              push(this, arguments[i3]);
            }
            return this.length;
          };
          Yallist.prototype.unshift = function() {
            for (var i3 = 0, l2 = arguments.length; i3 < l2; i3++) {
              unshift(this, arguments[i3]);
            }
            return this.length;
          };
          Yallist.prototype.pop = function() {
            if (!this.tail) {
              return void 0;
            }
            var res = this.tail.value;
            this.tail = this.tail.prev;
            if (this.tail) {
              this.tail.next = null;
            } else {
              this.head = null;
            }
            this.length--;
            return res;
          };
          Yallist.prototype.shift = function() {
            if (!this.head) {
              return void 0;
            }
            var res = this.head.value;
            this.head = this.head.next;
            if (this.head) {
              this.head.prev = null;
            } else {
              this.tail = null;
            }
            this.length--;
            return res;
          };
          Yallist.prototype.forEach = function(fn, thisp) {
            thisp = thisp || this;
            for (var walker = this.head, i3 = 0; walker !== null; i3++) {
              fn.call(thisp, walker.value, i3, this);
              walker = walker.next;
            }
          };
          Yallist.prototype.forEachReverse = function(fn, thisp) {
            thisp = thisp || this;
            for (var walker = this.tail, i3 = this.length - 1; walker !== null; i3--) {
              fn.call(thisp, walker.value, i3, this);
              walker = walker.prev;
            }
          };
          Yallist.prototype.get = function(n2) {
            for (var i3 = 0, walker = this.head; walker !== null && i3 < n2; i3++) {
              walker = walker.next;
            }
            if (i3 === n2 && walker !== null) {
              return walker.value;
            }
          };
          Yallist.prototype.getReverse = function(n2) {
            for (var i3 = 0, walker = this.tail; walker !== null && i3 < n2; i3++) {
              walker = walker.prev;
            }
            if (i3 === n2 && walker !== null) {
              return walker.value;
            }
          };
          Yallist.prototype.map = function(fn, thisp) {
            thisp = thisp || this;
            var res = new Yallist();
            for (var walker = this.head; walker !== null; ) {
              res.push(fn.call(thisp, walker.value, this));
              walker = walker.next;
            }
            return res;
          };
          Yallist.prototype.mapReverse = function(fn, thisp) {
            thisp = thisp || this;
            var res = new Yallist();
            for (var walker = this.tail; walker !== null; ) {
              res.push(fn.call(thisp, walker.value, this));
              walker = walker.prev;
            }
            return res;
          };
          Yallist.prototype.reduce = function(fn, initial) {
            var acc;
            var walker = this.head;
            if (arguments.length > 1) {
              acc = initial;
            } else if (this.head) {
              walker = this.head.next;
              acc = this.head.value;
            } else {
              throw new TypeError("Reduce of empty list with no initial value");
            }
            for (var i3 = 0; walker !== null; i3++) {
              acc = fn(acc, walker.value, i3);
              walker = walker.next;
            }
            return acc;
          };
          Yallist.prototype.reduceReverse = function(fn, initial) {
            var acc;
            var walker = this.tail;
            if (arguments.length > 1) {
              acc = initial;
            } else if (this.tail) {
              walker = this.tail.prev;
              acc = this.tail.value;
            } else {
              throw new TypeError("Reduce of empty list with no initial value");
            }
            for (var i3 = this.length - 1; walker !== null; i3--) {
              acc = fn(acc, walker.value, i3);
              walker = walker.prev;
            }
            return acc;
          };
          Yallist.prototype.toArray = function() {
            var arr = new Array(this.length);
            for (var i3 = 0, walker = this.head; walker !== null; i3++) {
              arr[i3] = walker.value;
              walker = walker.next;
            }
            return arr;
          };
          Yallist.prototype.toArrayReverse = function() {
            var arr = new Array(this.length);
            for (var i3 = 0, walker = this.tail; walker !== null; i3++) {
              arr[i3] = walker.value;
              walker = walker.prev;
            }
            return arr;
          };
          Yallist.prototype.slice = function(from, to) {
            to = to || this.length;
            if (to < 0) {
              to += this.length;
            }
            from = from || 0;
            if (from < 0) {
              from += this.length;
            }
            var ret = new Yallist();
            if (to < from || to < 0) {
              return ret;
            }
            if (from < 0) {
              from = 0;
            }
            if (to > this.length) {
              to = this.length;
            }
            for (var i3 = 0, walker = this.head; walker !== null && i3 < from; i3++) {
              walker = walker.next;
            }
            for (; walker !== null && i3 < to; i3++, walker = walker.next) {
              ret.push(walker.value);
            }
            return ret;
          };
          Yallist.prototype.sliceReverse = function(from, to) {
            to = to || this.length;
            if (to < 0) {
              to += this.length;
            }
            from = from || 0;
            if (from < 0) {
              from += this.length;
            }
            var ret = new Yallist();
            if (to < from || to < 0) {
              return ret;
            }
            if (from < 0) {
              from = 0;
            }
            if (to > this.length) {
              to = this.length;
            }
            for (var i3 = this.length, walker = this.tail; walker !== null && i3 > to; i3--) {
              walker = walker.prev;
            }
            for (; walker !== null && i3 > from; i3--, walker = walker.prev) {
              ret.push(walker.value);
            }
            return ret;
          };
          Yallist.prototype.splice = function(start, deleteCount) {
            if (start > this.length) {
              start = this.length - 1;
            }
            if (start < 0) {
              start = this.length + start;
            }
            for (var i3 = 0, walker = this.head; walker !== null && i3 < start; i3++) {
              walker = walker.next;
            }
            var ret = [];
            for (var i3 = 0; walker && i3 < deleteCount; i3++) {
              ret.push(walker.value);
              walker = this.removeNode(walker);
            }
            if (walker === null) {
              walker = this.tail;
            }
            if (walker !== this.head && walker !== this.tail) {
              walker = walker.prev;
            }
            for (var i3 = 2; i3 < arguments.length; i3++) {
              walker = insert(this, walker, arguments[i3]);
            }
            return ret;
          };
          Yallist.prototype.reverse = function() {
            var head = this.head;
            var tail = this.tail;
            for (var walker = head; walker !== null; walker = walker.prev) {
              var p = walker.prev;
              walker.prev = walker.next;
              walker.next = p;
            }
            this.head = tail;
            this.tail = head;
            return this;
          };
          function insert(self2, node, value) {
            var inserted = node === self2.head ? new Node2(value, null, node, self2) : new Node2(value, node, node.next, self2);
            if (inserted.next === null) {
              self2.tail = inserted;
            }
            if (inserted.prev === null) {
              self2.head = inserted;
            }
            self2.length++;
            return inserted;
          }
          function push(self2, item) {
            self2.tail = new Node2(item, self2.tail, null, self2);
            if (!self2.head) {
              self2.head = self2.tail;
            }
            self2.length++;
          }
          function unshift(self2, item) {
            self2.head = new Node2(item, null, self2.head, self2);
            if (!self2.tail) {
              self2.tail = self2.head;
            }
            self2.length++;
          }
          function Node2(value, prev, next, list) {
            if (!(this instanceof Node2)) {
              return new Node2(value, prev, next, list);
            }
            this.list = list;
            this.value = value;
            if (prev) {
              prev.next = this;
              this.prev = prev;
            } else {
              this.prev = null;
            }
            if (next) {
              next.prev = this;
              this.next = next;
            } else {
              this.next = null;
            }
          }
          try {
            __webpack_require__(24)(Yallist);
          } catch (er) {
          }
        },
        function(module3, exports3, __webpack_require__) {
          "use strict";
          module3.exports = function(Yallist) {
            Yallist.prototype[Symbol.iterator] = /* @__PURE__ */ regeneratorRuntime.mark(function _callee() {
              var walker;
              return regeneratorRuntime.wrap(function _callee$(_context) {
                while (1) {
                  switch (_context.prev = _context.next) {
                    case 0:
                      walker = this.head;
                    case 1:
                      if (!walker) {
                        _context.next = 7;
                        break;
                      }
                      _context.next = 4;
                      return walker.value;
                    case 4:
                      walker = walker.next;
                      _context.next = 1;
                      break;
                    case 7:
                    case "end":
                      return _context.stop();
                  }
                }
              }, _callee, this);
            });
          };
        },
        function(module3, exports3, __webpack_require__) {
          "use strict";
          function _typeof(obj) {
            "@babel/helpers - typeof";
            if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
              _typeof = function _typeof2(obj2) {
                return typeof obj2;
              };
            } else {
              _typeof = function _typeof2(obj2) {
                return obj2 && typeof Symbol === "function" && obj2.constructor === Symbol && obj2 !== Symbol.prototype ? "symbol" : typeof obj2;
              };
            }
            return _typeof(obj);
          }
          var b2 = 60103, c2 = 60106, d = 60107, e2 = 60108, f = 60114, g2 = 60109, h = 60110, k = 60112, l2 = 60113, m = 60120, n2 = 60115, p = 60116, q = 60129, r2 = 60130, u2 = 60131, v = 60132;
          if (typeof Symbol === "function" && Symbol.for) {
            var w = Symbol.for;
            b2 = w("react.element");
            c2 = w("react.portal");
            d = w("react.fragment");
            e2 = w("react.strict_mode");
            f = w("react.profiler");
            g2 = w("react.provider");
            h = w("react.context");
            k = w("react.forward_ref");
            l2 = w("react.suspense");
            m = w("react.suspense_list");
            n2 = w("react.memo");
            p = w("react.lazy");
            q = w("react.debug_trace_mode");
            r2 = w("react.offscreen");
            u2 = w("react.legacy_hidden");
            v = w("react.cache");
          }
          var x = 0;
          typeof Symbol === "function" && (x = Symbol.for("react.module.reference"));
          function y2(a2) {
            if (_typeof(a2) === "object" && a2 !== null) {
              var t2 = a2.$$typeof;
              switch (t2) {
                case b2:
                  switch (a2 = a2.type, a2) {
                    case d:
                    case f:
                    case e2:
                    case l2:
                    case m:
                      return a2;
                    default:
                      switch (a2 = a2 && a2.$$typeof, a2) {
                        case h:
                        case k:
                        case p:
                        case n2:
                        case g2:
                          return a2;
                        default:
                          return t2;
                      }
                  }
                case c2:
                  return t2;
              }
            }
          }
          var z = g2, A = b2, B = k, C = d, D = p, E = n2, F = c2, G = f, H = e2, I = l2, J = m;
          exports3.ContextConsumer = h;
          exports3.ContextProvider = z;
          exports3.Element = A;
          exports3.ForwardRef = B;
          exports3.Fragment = C;
          exports3.Lazy = D;
          exports3.Memo = E;
          exports3.Portal = F;
          exports3.Profiler = G;
          exports3.StrictMode = H;
          exports3.Suspense = I;
          exports3.SuspenseList = J;
          exports3.isAsyncMode = function() {
            return false;
          };
          exports3.isConcurrentMode = function() {
            return false;
          };
          exports3.isContextConsumer = function(a2) {
            return y2(a2) === h;
          };
          exports3.isContextProvider = function(a2) {
            return y2(a2) === g2;
          };
          exports3.isElement = function(a2) {
            return _typeof(a2) === "object" && a2 !== null && a2.$$typeof === b2;
          };
          exports3.isForwardRef = function(a2) {
            return y2(a2) === k;
          };
          exports3.isFragment = function(a2) {
            return y2(a2) === d;
          };
          exports3.isLazy = function(a2) {
            return y2(a2) === p;
          };
          exports3.isMemo = function(a2) {
            return y2(a2) === n2;
          };
          exports3.isPortal = function(a2) {
            return y2(a2) === c2;
          };
          exports3.isProfiler = function(a2) {
            return y2(a2) === f;
          };
          exports3.isStrictMode = function(a2) {
            return y2(a2) === e2;
          };
          exports3.isSuspense = function(a2) {
            return y2(a2) === l2;
          };
          exports3.isSuspenseList = function(a2) {
            return y2(a2) === m;
          };
          exports3.isValidElementType = function(a2) {
            return typeof a2 === "string" || typeof a2 === "function" || a2 === d || a2 === f || a2 === q || a2 === e2 || a2 === l2 || a2 === m || a2 === u2 || a2 === r2 || a2 === v || _typeof(a2) === "object" && a2 !== null && (a2.$$typeof === p || a2.$$typeof === n2 || a2.$$typeof === g2 || a2.$$typeof === h || a2.$$typeof === k || a2.$$typeof === x || a2.getModuleId !== void 0) ? true : false;
          };
          exports3.typeOf = y2;
        },
        function(module3, exports3, __webpack_require__) {
          "use strict";
          function _typeof(obj) {
            "@babel/helpers - typeof";
            if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
              _typeof = function _typeof2(obj2) {
                return typeof obj2;
              };
            } else {
              _typeof = function _typeof2(obj2) {
                return obj2 && typeof Symbol === "function" && obj2.constructor === Symbol && obj2 !== Symbol.prototype ? "symbol" : typeof obj2;
              };
            }
            return _typeof(obj);
          }
          var k = __webpack_require__(7), p = __webpack_require__(27);
          function r2(a2) {
            for (var b2 = "https://reactjs.org/docs/error-decoder.html?invariant=" + a2, e2 = 1; e2 < arguments.length; e2++) {
              b2 += "&args[]=" + encodeURIComponent(arguments[e2]);
            }
            return "Minified React error #" + a2 + "; visit " + b2 + " for the full message or use the non-minified dev environment for full errors and additional helpful warnings.";
          }
          var w = __webpack_require__(29).__SECRET_INTERNALS_DO_NOT_USE_OR_YOU_WILL_BE_FIRED, x = 60128;
          if (typeof Symbol === "function" && Symbol.for) {
            var y2 = Symbol.for;
            x = y2("react.opaque.id");
          }
          var z = [], A = null, B = null;
          function C() {
            if (A === null) {
              var a2 = /* @__PURE__ */ new Map();
              try {
                D.useContext({
                  _currentValue: null
                }), D.useState(null), D.useReducer(function(a3) {
                  return a3;
                }, null), D.useRef(null), typeof D.useCacheRefresh === "function" && D.useCacheRefresh(), D.useLayoutEffect(function() {
                }), D.useEffect(function() {
                }), D.useImperativeHandle(void 0, function() {
                  return null;
                }), D.useDebugValue(null), D.useCallback(function() {
                }), D.useMemo(function() {
                  return null;
                });
              } finally {
                var b2 = z;
                z = [];
              }
              for (var e2 = 0; e2 < b2.length; e2++) {
                var f = b2[e2];
                a2.set(f.primitive, p.parse(f.stackError));
              }
              A = a2;
            }
            return A;
          }
          var E = null;
          function F() {
            var a2 = E;
            a2 !== null && (E = a2.next);
            return a2;
          }
          var D = {
            getCacheForType: function getCacheForType() {
              throw Error(r2(248));
            },
            readContext: function readContext(a2) {
              return a2._currentValue;
            },
            useCacheRefresh: function useCacheRefresh() {
              var a2 = F();
              z.push({
                primitive: "CacheRefresh",
                stackError: Error(),
                value: a2 !== null ? a2.memoizedState : function() {
                }
              });
              return function() {
              };
            },
            useCallback: function useCallback2(a2) {
              var b2 = F();
              z.push({
                primitive: "Callback",
                stackError: Error(),
                value: b2 !== null ? b2.memoizedState[0] : a2
              });
              return a2;
            },
            useContext: function useContext(a2) {
              z.push({
                primitive: "Context",
                stackError: Error(),
                value: a2._currentValue
              });
              return a2._currentValue;
            },
            useEffect: function useEffect3(a2) {
              F();
              z.push({
                primitive: "Effect",
                stackError: Error(),
                value: a2
              });
            },
            useImperativeHandle: function useImperativeHandle(a2) {
              F();
              var b2 = void 0;
              a2 !== null && _typeof(a2) === "object" && (b2 = a2.current);
              z.push({
                primitive: "ImperativeHandle",
                stackError: Error(),
                value: b2
              });
            },
            useDebugValue: function useDebugValue2(a2, b2) {
              z.push({
                primitive: "DebugValue",
                stackError: Error(),
                value: typeof b2 === "function" ? b2(a2) : a2
              });
            },
            useLayoutEffect: function useLayoutEffect2(a2) {
              F();
              z.push({
                primitive: "LayoutEffect",
                stackError: Error(),
                value: a2
              });
            },
            useMemo: function useMemo2(a2) {
              var b2 = F();
              a2 = b2 !== null ? b2.memoizedState[0] : a2();
              z.push({
                primitive: "Memo",
                stackError: Error(),
                value: a2
              });
              return a2;
            },
            useReducer: function useReducer2(a2, b2, e2) {
              a2 = F();
              b2 = a2 !== null ? a2.memoizedState : e2 !== void 0 ? e2(b2) : b2;
              z.push({
                primitive: "Reducer",
                stackError: Error(),
                value: b2
              });
              return [b2, function() {
              }];
            },
            useRef: function useRef2(a2) {
              var b2 = F();
              a2 = b2 !== null ? b2.memoizedState : {
                current: a2
              };
              z.push({
                primitive: "Ref",
                stackError: Error(),
                value: a2.current
              });
              return a2;
            },
            useState: function useState3(a2) {
              var b2 = F();
              a2 = b2 !== null ? b2.memoizedState : typeof a2 === "function" ? a2() : a2;
              z.push({
                primitive: "State",
                stackError: Error(),
                value: a2
              });
              return [a2, function() {
              }];
            },
            useTransition: function useTransition() {
              F();
              F();
              z.push({
                primitive: "Transition",
                stackError: Error(),
                value: void 0
              });
              return [false, function() {
              }];
            },
            useMutableSource: function useMutableSource2(a2, b2) {
              F();
              F();
              F();
              F();
              a2 = b2(a2._source);
              z.push({
                primitive: "MutableSource",
                stackError: Error(),
                value: a2
              });
              return a2;
            },
            useDeferredValue: function useDeferredValue(a2) {
              F();
              F();
              z.push({
                primitive: "DeferredValue",
                stackError: Error(),
                value: a2
              });
              return a2;
            },
            useOpaqueIdentifier: function useOpaqueIdentifier() {
              var a2 = F();
              B && B.mode === 0 && F();
              (a2 = a2 === null ? void 0 : a2.memoizedState) && a2.$$typeof === x && (a2 = void 0);
              z.push({
                primitive: "OpaqueIdentifier",
                stackError: Error(),
                value: a2
              });
              return a2;
            }
          }, G = 0;
          function H(a2, b2, e2) {
            var f = b2[e2].source, c2 = 0;
            a:
              for (; c2 < a2.length; c2++) {
                if (a2[c2].source === f) {
                  for (var l2 = e2 + 1, q = c2 + 1; l2 < b2.length && q < a2.length; l2++, q++) {
                    if (a2[q].source !== b2[l2].source)
                      continue a;
                  }
                  return c2;
                }
              }
            return -1;
          }
          function I(a2, b2) {
            if (!a2)
              return false;
            b2 = "use" + b2;
            return a2.length < b2.length ? false : a2.lastIndexOf(b2) === a2.length - b2.length;
          }
          function J(a2, b2, e2) {
            for (var f = [], c2 = null, l2 = f, q = 0, t2 = [], v = 0; v < b2.length; v++) {
              var u2 = b2[v];
              var d = a2;
              var h = p.parse(u2.stackError);
              b: {
                var m = h, n2 = H(m, d, G);
                if (n2 !== -1)
                  d = n2;
                else {
                  for (var g2 = 0; g2 < d.length && 5 > g2; g2++) {
                    if (n2 = H(m, d, g2), n2 !== -1) {
                      G = g2;
                      d = n2;
                      break b;
                    }
                  }
                  d = -1;
                }
              }
              b: {
                m = h;
                n2 = C().get(u2.primitive);
                if (n2 !== void 0)
                  for (g2 = 0; g2 < n2.length && g2 < m.length; g2++) {
                    if (n2[g2].source !== m[g2].source) {
                      g2 < m.length - 1 && I(m[g2].functionName, u2.primitive) && g2++;
                      g2 < m.length - 1 && I(m[g2].functionName, u2.primitive) && g2++;
                      m = g2;
                      break b;
                    }
                  }
                m = -1;
              }
              h = d === -1 || m === -1 || 2 > d - m ? null : h.slice(m, d - 1);
              if (h !== null) {
                d = 0;
                if (c2 !== null) {
                  for (; d < h.length && d < c2.length && h[h.length - d - 1].source === c2[c2.length - d - 1].source; ) {
                    d++;
                  }
                  for (c2 = c2.length - 1; c2 > d; c2--) {
                    l2 = t2.pop();
                  }
                }
                for (c2 = h.length - d - 1; 1 <= c2; c2--) {
                  d = [], m = h[c2], (n2 = h[c2 - 1].functionName) ? (g2 = n2.lastIndexOf("."), g2 === -1 && (g2 = 0), n2.substr(g2, 3) === "use" && (g2 += 3), n2 = n2.substr(g2)) : n2 = "", n2 = {
                    id: null,
                    isStateEditable: false,
                    name: n2,
                    value: void 0,
                    subHooks: d
                  }, e2 && (n2.hookSource = {
                    lineNumber: m.lineNumber,
                    columnNumber: m.columnNumber,
                    functionName: m.functionName,
                    fileName: m.fileName
                  }), l2.push(n2), t2.push(l2), l2 = d;
                }
                c2 = h;
              }
              d = u2.primitive;
              u2 = {
                id: d === "Context" || d === "DebugValue" ? null : q++,
                isStateEditable: d === "Reducer" || d === "State",
                name: d,
                value: u2.value,
                subHooks: []
              };
              e2 && (d = {
                lineNumber: null,
                functionName: null,
                fileName: null,
                columnNumber: null
              }, h && 1 <= h.length && (h = h[0], d.lineNumber = h.lineNumber, d.functionName = h.functionName, d.fileName = h.fileName, d.columnNumber = h.columnNumber), u2.hookSource = d);
              l2.push(u2);
            }
            K(f, null);
            return f;
          }
          function K(a2, b2) {
            for (var e2 = [], f = 0; f < a2.length; f++) {
              var c2 = a2[f];
              c2.name === "DebugValue" && c2.subHooks.length === 0 ? (a2.splice(f, 1), f--, e2.push(c2)) : K(c2.subHooks, c2);
            }
            b2 !== null && (e2.length === 1 ? b2.value = e2[0].value : 1 < e2.length && (b2.value = e2.map(function(a3) {
              return a3.value;
            })));
          }
          function L(a2, b2, e2) {
            var f = 3 < arguments.length && arguments[3] !== void 0 ? arguments[3] : false;
            e2 == null && (e2 = w.ReactCurrentDispatcher);
            var c2 = e2.current;
            e2.current = D;
            try {
              var l2 = Error();
              a2(b2);
            } finally {
              var q = z;
              z = [];
              e2.current = c2;
            }
            c2 = p.parse(l2);
            return J(c2, q, f);
          }
          function M(a2) {
            a2.forEach(function(a3, e2) {
              return e2._currentValue = a3;
            });
          }
          exports3.inspectHooks = L;
          exports3.inspectHooksOfFiber = function(a2, b2) {
            var e2 = 2 < arguments.length && arguments[2] !== void 0 ? arguments[2] : false;
            b2 == null && (b2 = w.ReactCurrentDispatcher);
            B = a2;
            if (a2.tag !== 0 && a2.tag !== 15 && a2.tag !== 11)
              throw Error("Unknown Fiber. Needs to be a function component to inspect hooks.");
            C();
            var f = a2.type, c2 = a2.memoizedProps;
            if (f !== a2.elementType && f && f.defaultProps) {
              c2 = k({}, c2);
              var l2 = f.defaultProps;
              for (q in l2) {
                c2[q] === void 0 && (c2[q] = l2[q]);
              }
            }
            E = a2.memoizedState;
            var q = /* @__PURE__ */ new Map();
            try {
              for (l2 = a2; l2; ) {
                if (l2.tag === 10) {
                  var t2 = l2.type._context;
                  q.has(t2) || (q.set(t2, t2._currentValue), t2._currentValue = l2.memoizedProps.value);
                }
                l2 = l2.return;
              }
              if (a2.tag === 11) {
                var v = f.render;
                f = c2;
                var u2 = a2.ref;
                t2 = b2;
                var d = t2.current;
                t2.current = D;
                try {
                  var h = Error();
                  v(f, u2);
                } finally {
                  var m = z;
                  z = [];
                  t2.current = d;
                }
                var n2 = p.parse(h);
                return J(n2, m, e2);
              }
              return L(f, c2, b2, e2);
            } finally {
              E = null, M(q);
            }
          };
        },
        function(module3, exports3, __webpack_require__) {
          var __WEBPACK_AMD_DEFINE_FACTORY__, __WEBPACK_AMD_DEFINE_ARRAY__, __WEBPACK_AMD_DEFINE_RESULT__;
          function _typeof(obj) {
            "@babel/helpers - typeof";
            if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
              _typeof = function _typeof2(obj2) {
                return typeof obj2;
              };
            } else {
              _typeof = function _typeof2(obj2) {
                return obj2 && typeof Symbol === "function" && obj2.constructor === Symbol && obj2 !== Symbol.prototype ? "symbol" : typeof obj2;
              };
            }
            return _typeof(obj);
          }
          (function(root, factory) {
            "use strict";
            if (true) {
              !(__WEBPACK_AMD_DEFINE_ARRAY__ = [__webpack_require__(28)], __WEBPACK_AMD_DEFINE_FACTORY__ = factory, __WEBPACK_AMD_DEFINE_RESULT__ = typeof __WEBPACK_AMD_DEFINE_FACTORY__ === "function" ? __WEBPACK_AMD_DEFINE_FACTORY__.apply(exports3, __WEBPACK_AMD_DEFINE_ARRAY__) : __WEBPACK_AMD_DEFINE_FACTORY__, __WEBPACK_AMD_DEFINE_RESULT__ !== void 0 && (module3.exports = __WEBPACK_AMD_DEFINE_RESULT__));
            } else {
            }
          })(this, function ErrorStackParser(StackFrame) {
            "use strict";
            var FIREFOX_SAFARI_STACK_REGEXP = /(^|@)\S+:\d+/;
            var CHROME_IE_STACK_REGEXP = /^\s*at .*(\S+:\d+|\(native\))/m;
            var SAFARI_NATIVE_CODE_REGEXP = /^(eval@)?(\[native code])?$/;
            return {
              parse: function ErrorStackParser$$parse(error) {
                if (typeof error.stacktrace !== "undefined" || typeof error["opera#sourceloc"] !== "undefined") {
                  return this.parseOpera(error);
                } else if (error.stack && error.stack.match(CHROME_IE_STACK_REGEXP)) {
                  return this.parseV8OrIE(error);
                } else if (error.stack) {
                  return this.parseFFOrSafari(error);
                } else {
                  throw new Error("Cannot parse given Error object");
                }
              },
              extractLocation: function ErrorStackParser$$extractLocation(urlLike) {
                if (urlLike.indexOf(":") === -1) {
                  return [urlLike];
                }
                var regExp = /(.+?)(?::(\d+))?(?::(\d+))?$/;
                var parts = regExp.exec(urlLike.replace(/[()]/g, ""));
                return [parts[1], parts[2] || void 0, parts[3] || void 0];
              },
              parseV8OrIE: function ErrorStackParser$$parseV8OrIE(error) {
                var filtered = error.stack.split("\n").filter(function(line) {
                  return !!line.match(CHROME_IE_STACK_REGEXP);
                }, this);
                return filtered.map(function(line) {
                  if (line.indexOf("(eval ") > -1) {
                    line = line.replace(/eval code/g, "eval").replace(/(\(eval at [^()]*)|(\),.*$)/g, "");
                  }
                  var sanitizedLine = line.replace(/^\s+/, "").replace(/\(eval code/g, "(");
                  var location = sanitizedLine.match(/ (\((.+):(\d+):(\d+)\)$)/);
                  sanitizedLine = location ? sanitizedLine.replace(location[0], "") : sanitizedLine;
                  var tokens = sanitizedLine.split(/\s+/).slice(1);
                  var locationParts = this.extractLocation(location ? location[1] : tokens.pop());
                  var functionName = tokens.join(" ") || void 0;
                  var fileName = ["eval", "<anonymous>"].indexOf(locationParts[0]) > -1 ? void 0 : locationParts[0];
                  return new StackFrame({
                    functionName,
                    fileName,
                    lineNumber: locationParts[1],
                    columnNumber: locationParts[2],
                    source: line
                  });
                }, this);
              },
              parseFFOrSafari: function ErrorStackParser$$parseFFOrSafari(error) {
                var filtered = error.stack.split("\n").filter(function(line) {
                  return !line.match(SAFARI_NATIVE_CODE_REGEXP);
                }, this);
                return filtered.map(function(line) {
                  if (line.indexOf(" > eval") > -1) {
                    line = line.replace(/ line (\d+)(?: > eval line \d+)* > eval:\d+:\d+/g, ":$1");
                  }
                  if (line.indexOf("@") === -1 && line.indexOf(":") === -1) {
                    return new StackFrame({
                      functionName: line
                    });
                  } else {
                    var functionNameRegex = /((.*".+"[^@]*)?[^@]*)(?:@)/;
                    var matches = line.match(functionNameRegex);
                    var functionName = matches && matches[1] ? matches[1] : void 0;
                    var locationParts = this.extractLocation(line.replace(functionNameRegex, ""));
                    return new StackFrame({
                      functionName,
                      fileName: locationParts[0],
                      lineNumber: locationParts[1],
                      columnNumber: locationParts[2],
                      source: line
                    });
                  }
                }, this);
              },
              parseOpera: function ErrorStackParser$$parseOpera(e2) {
                if (!e2.stacktrace || e2.message.indexOf("\n") > -1 && e2.message.split("\n").length > e2.stacktrace.split("\n").length) {
                  return this.parseOpera9(e2);
                } else if (!e2.stack) {
                  return this.parseOpera10(e2);
                } else {
                  return this.parseOpera11(e2);
                }
              },
              parseOpera9: function ErrorStackParser$$parseOpera9(e2) {
                var lineRE = /Line (\d+).*script (?:in )?(\S+)/i;
                var lines = e2.message.split("\n");
                var result2 = [];
                for (var i3 = 2, len = lines.length; i3 < len; i3 += 2) {
                  var match = lineRE.exec(lines[i3]);
                  if (match) {
                    result2.push(new StackFrame({
                      fileName: match[2],
                      lineNumber: match[1],
                      source: lines[i3]
                    }));
                  }
                }
                return result2;
              },
              parseOpera10: function ErrorStackParser$$parseOpera10(e2) {
                var lineRE = /Line (\d+).*script (?:in )?(\S+)(?:: In function (\S+))?$/i;
                var lines = e2.stacktrace.split("\n");
                var result2 = [];
                for (var i3 = 0, len = lines.length; i3 < len; i3 += 2) {
                  var match = lineRE.exec(lines[i3]);
                  if (match) {
                    result2.push(new StackFrame({
                      functionName: match[3] || void 0,
                      fileName: match[2],
                      lineNumber: match[1],
                      source: lines[i3]
                    }));
                  }
                }
                return result2;
              },
              parseOpera11: function ErrorStackParser$$parseOpera11(error) {
                var filtered = error.stack.split("\n").filter(function(line) {
                  return !!line.match(FIREFOX_SAFARI_STACK_REGEXP) && !line.match(/^Error created at/);
                }, this);
                return filtered.map(function(line) {
                  var tokens = line.split("@");
                  var locationParts = this.extractLocation(tokens.pop());
                  var functionCall = tokens.shift() || "";
                  var functionName = functionCall.replace(/<anonymous function(: (\w+))?>/, "$2").replace(/\([^)]*\)/g, "") || void 0;
                  var argsRaw;
                  if (functionCall.match(/\(([^)]*)\)/)) {
                    argsRaw = functionCall.replace(/^[^(]+\(([^)]*)\)$/, "$1");
                  }
                  var args = argsRaw === void 0 || argsRaw === "[arguments not available]" ? void 0 : argsRaw.split(",");
                  return new StackFrame({
                    functionName,
                    args,
                    fileName: locationParts[0],
                    lineNumber: locationParts[1],
                    columnNumber: locationParts[2],
                    source: line
                  });
                }, this);
              }
            };
          });
        },
        function(module3, exports3, __webpack_require__) {
          var __WEBPACK_AMD_DEFINE_FACTORY__, __WEBPACK_AMD_DEFINE_ARRAY__, __WEBPACK_AMD_DEFINE_RESULT__;
          function _typeof(obj) {
            "@babel/helpers - typeof";
            if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
              _typeof = function _typeof2(obj2) {
                return typeof obj2;
              };
            } else {
              _typeof = function _typeof2(obj2) {
                return obj2 && typeof Symbol === "function" && obj2.constructor === Symbol && obj2 !== Symbol.prototype ? "symbol" : typeof obj2;
              };
            }
            return _typeof(obj);
          }
          (function(root, factory) {
            "use strict";
            if (true) {
              !(__WEBPACK_AMD_DEFINE_ARRAY__ = [], __WEBPACK_AMD_DEFINE_FACTORY__ = factory, __WEBPACK_AMD_DEFINE_RESULT__ = typeof __WEBPACK_AMD_DEFINE_FACTORY__ === "function" ? __WEBPACK_AMD_DEFINE_FACTORY__.apply(exports3, __WEBPACK_AMD_DEFINE_ARRAY__) : __WEBPACK_AMD_DEFINE_FACTORY__, __WEBPACK_AMD_DEFINE_RESULT__ !== void 0 && (module3.exports = __WEBPACK_AMD_DEFINE_RESULT__));
            } else {
            }
          })(this, function() {
            "use strict";
            function _isNumber(n2) {
              return !isNaN(parseFloat(n2)) && isFinite(n2);
            }
            function _capitalize(str2) {
              return str2.charAt(0).toUpperCase() + str2.substring(1);
            }
            function _getter(p) {
              return function() {
                return this[p];
              };
            }
            var booleanProps = ["isConstructor", "isEval", "isNative", "isToplevel"];
            var numericProps = ["columnNumber", "lineNumber"];
            var stringProps = ["fileName", "functionName", "source"];
            var arrayProps = ["args"];
            var props = booleanProps.concat(numericProps, stringProps, arrayProps);
            function StackFrame(obj) {
              if (!obj)
                return;
              for (var i4 = 0; i4 < props.length; i4++) {
                if (obj[props[i4]] !== void 0) {
                  this["set" + _capitalize(props[i4])](obj[props[i4]]);
                }
              }
            }
            StackFrame.prototype = {
              getArgs: function getArgs() {
                return this.args;
              },
              setArgs: function setArgs(v) {
                if (Object.prototype.toString.call(v) !== "[object Array]") {
                  throw new TypeError("Args must be an Array");
                }
                this.args = v;
              },
              getEvalOrigin: function getEvalOrigin() {
                return this.evalOrigin;
              },
              setEvalOrigin: function setEvalOrigin(v) {
                if (v instanceof StackFrame) {
                  this.evalOrigin = v;
                } else if (v instanceof Object) {
                  this.evalOrigin = new StackFrame(v);
                } else {
                  throw new TypeError("Eval Origin must be an Object or StackFrame");
                }
              },
              toString: function toString2() {
                var fileName = this.getFileName() || "";
                var lineNumber = this.getLineNumber() || "";
                var columnNumber = this.getColumnNumber() || "";
                var functionName = this.getFunctionName() || "";
                if (this.getIsEval()) {
                  if (fileName) {
                    return "[eval] (" + fileName + ":" + lineNumber + ":" + columnNumber + ")";
                  }
                  return "[eval]:" + lineNumber + ":" + columnNumber;
                }
                if (functionName) {
                  return functionName + " (" + fileName + ":" + lineNumber + ":" + columnNumber + ")";
                }
                return fileName + ":" + lineNumber + ":" + columnNumber;
              }
            };
            StackFrame.fromString = function StackFrame$$fromString(str2) {
              var argsStartIndex = str2.indexOf("(");
              var argsEndIndex = str2.lastIndexOf(")");
              var functionName = str2.substring(0, argsStartIndex);
              var args = str2.substring(argsStartIndex + 1, argsEndIndex).split(",");
              var locationString = str2.substring(argsEndIndex + 1);
              if (locationString.indexOf("@") === 0) {
                var parts = /@(.+?)(?::(\d+))?(?::(\d+))?$/.exec(locationString, "");
                var fileName = parts[1];
                var lineNumber = parts[2];
                var columnNumber = parts[3];
              }
              return new StackFrame({
                functionName,
                args: args || void 0,
                fileName,
                lineNumber: lineNumber || void 0,
                columnNumber: columnNumber || void 0
              });
            };
            for (var i3 = 0; i3 < booleanProps.length; i3++) {
              StackFrame.prototype["get" + _capitalize(booleanProps[i3])] = _getter(booleanProps[i3]);
              StackFrame.prototype["set" + _capitalize(booleanProps[i3])] = function(p) {
                return function(v) {
                  this[p] = Boolean(v);
                };
              }(booleanProps[i3]);
            }
            for (var j = 0; j < numericProps.length; j++) {
              StackFrame.prototype["get" + _capitalize(numericProps[j])] = _getter(numericProps[j]);
              StackFrame.prototype["set" + _capitalize(numericProps[j])] = function(p) {
                return function(v) {
                  if (!_isNumber(v)) {
                    throw new TypeError(p + " must be a Number");
                  }
                  this[p] = Number(v);
                };
              }(numericProps[j]);
            }
            for (var k = 0; k < stringProps.length; k++) {
              StackFrame.prototype["get" + _capitalize(stringProps[k])] = _getter(stringProps[k]);
              StackFrame.prototype["set" + _capitalize(stringProps[k])] = function(p) {
                return function(v) {
                  this[p] = String(v);
                };
              }(stringProps[k]);
            }
            return StackFrame;
          });
        },
        function(module3, exports3, __webpack_require__) {
          "use strict";
          if (true) {
            module3.exports = __webpack_require__(30);
          } else {
          }
        },
        function(module3, exports3, __webpack_require__) {
          "use strict";
          function _typeof(obj) {
            "@babel/helpers - typeof";
            if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
              _typeof = function _typeof2(obj2) {
                return typeof obj2;
              };
            } else {
              _typeof = function _typeof2(obj2) {
                return obj2 && typeof Symbol === "function" && obj2.constructor === Symbol && obj2 !== Symbol.prototype ? "symbol" : typeof obj2;
              };
            }
            return _typeof(obj);
          }
          var l2 = __webpack_require__(7), m = 60103, p = 60106;
          exports3.Fragment = 60107;
          exports3.StrictMode = 60108;
          exports3.Profiler = 60114;
          var q = 60109, r2 = 60110, t2 = 60112;
          exports3.Suspense = 60113;
          exports3.SuspenseList = 60120;
          var u2 = 60115, v = 60116;
          exports3.unstable_DebugTracingMode = 60129;
          exports3.unstable_Offscreen = 60130;
          exports3.unstable_LegacyHidden = 60131;
          exports3.unstable_Cache = 60132;
          if (typeof Symbol === "function" && Symbol.for) {
            var w = Symbol.for;
            m = w("react.element");
            p = w("react.portal");
            exports3.Fragment = w("react.fragment");
            exports3.StrictMode = w("react.strict_mode");
            exports3.Profiler = w("react.profiler");
            q = w("react.provider");
            r2 = w("react.context");
            t2 = w("react.forward_ref");
            exports3.Suspense = w("react.suspense");
            exports3.SuspenseList = w("react.suspense_list");
            u2 = w("react.memo");
            v = w("react.lazy");
            exports3.unstable_DebugTracingMode = w("react.debug_trace_mode");
            exports3.unstable_Offscreen = w("react.offscreen");
            exports3.unstable_LegacyHidden = w("react.legacy_hidden");
            exports3.unstable_Cache = w("react.cache");
          }
          var x = typeof Symbol === "function" && Symbol.iterator;
          function y2(a2) {
            if (a2 === null || _typeof(a2) !== "object")
              return null;
            a2 = x && a2[x] || a2["@@iterator"];
            return typeof a2 === "function" ? a2 : null;
          }
          function z(a2) {
            for (var b2 = "https://reactjs.org/docs/error-decoder.html?invariant=" + a2, c2 = 1; c2 < arguments.length; c2++) {
              b2 += "&args[]=" + encodeURIComponent(arguments[c2]);
            }
            return "Minified React error #" + a2 + "; visit " + b2 + " for the full message or use the non-minified dev environment for full errors and additional helpful warnings.";
          }
          var A = {
            isMounted: function isMounted() {
              return false;
            },
            enqueueForceUpdate: function enqueueForceUpdate() {
            },
            enqueueReplaceState: function enqueueReplaceState() {
            },
            enqueueSetState: function enqueueSetState() {
            }
          }, B = {};
          function C(a2, b2, c2) {
            this.props = a2;
            this.context = b2;
            this.refs = B;
            this.updater = c2 || A;
          }
          C.prototype.isReactComponent = {};
          C.prototype.setState = function(a2, b2) {
            if (_typeof(a2) !== "object" && typeof a2 !== "function" && a2 != null)
              throw Error(z(85));
            this.updater.enqueueSetState(this, a2, b2, "setState");
          };
          C.prototype.forceUpdate = function(a2) {
            this.updater.enqueueForceUpdate(this, a2, "forceUpdate");
          };
          function D() {
          }
          D.prototype = C.prototype;
          function E(a2, b2, c2) {
            this.props = a2;
            this.context = b2;
            this.refs = B;
            this.updater = c2 || A;
          }
          var F = E.prototype = new D();
          F.constructor = E;
          l2(F, C.prototype);
          F.isPureReactComponent = true;
          var G = Array.isArray, H = Object.prototype.hasOwnProperty, I = {
            current: null
          }, J = {
            key: true,
            ref: true,
            __self: true,
            __source: true
          };
          function K(a2, b2, c2) {
            var e2, d = {}, k = null, h = null;
            if (b2 != null)
              for (e2 in b2.ref !== void 0 && (h = b2.ref), b2.key !== void 0 && (k = "" + b2.key), b2) {
                H.call(b2, e2) && !J.hasOwnProperty(e2) && (d[e2] = b2[e2]);
              }
            var g2 = arguments.length - 2;
            if (g2 === 1)
              d.children = c2;
            else if (1 < g2) {
              for (var f = Array(g2), n2 = 0; n2 < g2; n2++) {
                f[n2] = arguments[n2 + 2];
              }
              d.children = f;
            }
            if (a2 && a2.defaultProps)
              for (e2 in g2 = a2.defaultProps, g2) {
                d[e2] === void 0 && (d[e2] = g2[e2]);
              }
            return {
              $$typeof: m,
              type: a2,
              key: k,
              ref: h,
              props: d,
              _owner: I.current
            };
          }
          function L(a2, b2) {
            return {
              $$typeof: m,
              type: a2.type,
              key: b2,
              ref: a2.ref,
              props: a2.props,
              _owner: a2._owner
            };
          }
          function M(a2) {
            return _typeof(a2) === "object" && a2 !== null && a2.$$typeof === m;
          }
          function escape(a2) {
            var b2 = {
              "=": "=0",
              ":": "=2"
            };
            return "$" + a2.replace(/[=:]/g, function(a3) {
              return b2[a3];
            });
          }
          var N = /\/+/g;
          function O(a2, b2) {
            return _typeof(a2) === "object" && a2 !== null && a2.key != null ? escape("" + a2.key) : b2.toString(36);
          }
          function P(a2, b2, c2, e2, d) {
            var k = _typeof(a2);
            if (k === "undefined" || k === "boolean")
              a2 = null;
            var h = false;
            if (a2 === null)
              h = true;
            else
              switch (k) {
                case "string":
                case "number":
                  h = true;
                  break;
                case "object":
                  switch (a2.$$typeof) {
                    case m:
                    case p:
                      h = true;
                  }
              }
            if (h)
              return h = a2, d = d(h), a2 = e2 === "" ? "." + O(h, 0) : e2, G(d) ? (c2 = "", a2 != null && (c2 = a2.replace(N, "$&/") + "/"), P(d, b2, c2, "", function(a3) {
                return a3;
              })) : d != null && (M(d) && (d = L(d, c2 + (!d.key || h && h.key === d.key ? "" : ("" + d.key).replace(N, "$&/") + "/") + a2)), b2.push(d)), 1;
            h = 0;
            e2 = e2 === "" ? "." : e2 + ":";
            if (G(a2))
              for (var g2 = 0; g2 < a2.length; g2++) {
                k = a2[g2];
                var f = e2 + O(k, g2);
                h += P(k, b2, c2, f, d);
              }
            else if (f = y2(a2), typeof f === "function")
              for (a2 = f.call(a2), g2 = 0; !(k = a2.next()).done; ) {
                k = k.value, f = e2 + O(k, g2++), h += P(k, b2, c2, f, d);
              }
            else if (k === "object")
              throw b2 = "" + a2, Error(z(31, b2 === "[object Object]" ? "object with keys {" + Object.keys(a2).join(", ") + "}" : b2));
            return h;
          }
          function Q(a2, b2, c2) {
            if (a2 == null)
              return a2;
            var e2 = [], d = 0;
            P(a2, e2, "", "", function(a3) {
              return b2.call(c2, a3, d++);
            });
            return e2;
          }
          function R(a2) {
            if (a2._status === -1) {
              var b2 = a2._result;
              b2 = b2();
              b2.then(function(b3) {
                if (a2._status === 0 || a2._status === -1)
                  a2._status = 1, a2._result = b3;
              }, function(b3) {
                if (a2._status === 0 || a2._status === -1)
                  a2._status = 2, a2._result = b3;
              });
              a2._status === -1 && (a2._status = 0, a2._result = b2);
            }
            if (a2._status === 1)
              return a2._result.default;
            throw a2._result;
          }
          var S = {
            current: null
          }, T = {
            transition: 0
          }, U = {
            ReactCurrentDispatcher: S,
            ReactCurrentBatchConfig: T,
            ReactCurrentOwner: I,
            assign: l2
          };
          exports3.Children = {
            map: Q,
            forEach: function forEach(a2, b2, c2) {
              Q(a2, function() {
                b2.apply(this, arguments);
              }, c2);
            },
            count: function count(a2) {
              var b2 = 0;
              Q(a2, function() {
                b2++;
              });
              return b2;
            },
            toArray: function toArray2(a2) {
              return Q(a2, function(a3) {
                return a3;
              }) || [];
            },
            only: function only(a2) {
              if (!M(a2))
                throw Error(z(143));
              return a2;
            }
          };
          exports3.Component = C;
          exports3.PureComponent = E;
          exports3.__SECRET_INTERNALS_DO_NOT_USE_OR_YOU_WILL_BE_FIRED = U;
          exports3.cloneElement = function(a2, b2, c2) {
            if (a2 === null || a2 === void 0)
              throw Error(z(267, a2));
            var e2 = l2({}, a2.props), d = a2.key, k = a2.ref, h = a2._owner;
            if (b2 != null) {
              b2.ref !== void 0 && (k = b2.ref, h = I.current);
              b2.key !== void 0 && (d = "" + b2.key);
              if (a2.type && a2.type.defaultProps)
                var g2 = a2.type.defaultProps;
              for (f in b2) {
                H.call(b2, f) && !J.hasOwnProperty(f) && (e2[f] = b2[f] === void 0 && g2 !== void 0 ? g2[f] : b2[f]);
              }
            }
            var f = arguments.length - 2;
            if (f === 1)
              e2.children = c2;
            else if (1 < f) {
              g2 = Array(f);
              for (var n2 = 0; n2 < f; n2++) {
                g2[n2] = arguments[n2 + 2];
              }
              e2.children = g2;
            }
            return {
              $$typeof: m,
              type: a2.type,
              key: d,
              ref: k,
              props: e2,
              _owner: h
            };
          };
          exports3.createContext = function(a2) {
            a2 = {
              $$typeof: r2,
              _currentValue: a2,
              _currentValue2: a2,
              _threadCount: 0,
              Provider: null,
              Consumer: null
            };
            a2.Provider = {
              $$typeof: q,
              _context: a2
            };
            return a2.Consumer = a2;
          };
          exports3.createElement = K;
          exports3.createFactory = function(a2) {
            var b2 = K.bind(null, a2);
            b2.type = a2;
            return b2;
          };
          exports3.createRef = function() {
            return {
              current: null
            };
          };
          exports3.forwardRef = function(a2) {
            return {
              $$typeof: t2,
              render: a2
            };
          };
          exports3.isValidElement = M;
          exports3.lazy = function(a2) {
            return {
              $$typeof: v,
              _payload: {
                _status: -1,
                _result: a2
              },
              _init: R
            };
          };
          exports3.memo = function(a2, b2) {
            return {
              $$typeof: u2,
              type: a2,
              compare: b2 === void 0 ? null : b2
            };
          };
          exports3.startTransition = function(a2) {
            var b2 = T.transition;
            T.transition = 1;
            try {
              a2();
            } finally {
              T.transition = b2;
            }
          };
          exports3.unstable_act = function() {
            throw Error(z(406));
          };
          exports3.unstable_createMutableSource = function(a2, b2) {
            return {
              _getVersion: b2,
              _source: a2,
              _workInProgressVersionPrimary: null,
              _workInProgressVersionSecondary: null
            };
          };
          exports3.unstable_getCacheForType = function(a2) {
            return S.current.getCacheForType(a2);
          };
          exports3.unstable_useCacheRefresh = function() {
            return S.current.useCacheRefresh();
          };
          exports3.unstable_useMutableSource = function(a2, b2, c2) {
            return S.current.useMutableSource(a2, b2, c2);
          };
          exports3.unstable_useOpaqueIdentifier = function() {
            return S.current.useOpaqueIdentifier();
          };
          exports3.useCallback = function(a2, b2) {
            return S.current.useCallback(a2, b2);
          };
          exports3.useContext = function(a2) {
            return S.current.useContext(a2);
          };
          exports3.useDebugValue = function() {
          };
          exports3.useDeferredValue = function(a2) {
            return S.current.useDeferredValue(a2);
          };
          exports3.useEffect = function(a2, b2) {
            return S.current.useEffect(a2, b2);
          };
          exports3.useImperativeHandle = function(a2, b2, c2) {
            return S.current.useImperativeHandle(a2, b2, c2);
          };
          exports3.useLayoutEffect = function(a2, b2) {
            return S.current.useLayoutEffect(a2, b2);
          };
          exports3.useMemo = function(a2, b2) {
            return S.current.useMemo(a2, b2);
          };
          exports3.useReducer = function(a2, b2, c2) {
            return S.current.useReducer(a2, b2, c2);
          };
          exports3.useRef = function(a2) {
            return S.current.useRef(a2);
          };
          exports3.useState = function(a2) {
            return S.current.useState(a2);
          };
          exports3.useTransition = function() {
            return S.current.useTransition();
          };
          exports3.version = "18.0.0-experimental-3385b377f-20210901";
        },
        function(module3, __webpack_exports__, __webpack_require__) {
          "use strict";
          __webpack_require__.r(__webpack_exports__);
          __webpack_require__.d(__webpack_exports__, "connectToDevTools", function() {
            return connectToDevTools;
          });
          function _classCallCheck(instance, Constructor) {
            if (!(instance instanceof Constructor)) {
              throw new TypeError("Cannot call a class as a function");
            }
          }
          function _defineProperties(target, props) {
            for (var i3 = 0; i3 < props.length; i3++) {
              var descriptor = props[i3];
              descriptor.enumerable = descriptor.enumerable || false;
              descriptor.configurable = true;
              if ("value" in descriptor)
                descriptor.writable = true;
              Object.defineProperty(target, descriptor.key, descriptor);
            }
          }
          function _createClass(Constructor, protoProps, staticProps) {
            if (protoProps)
              _defineProperties(Constructor.prototype, protoProps);
            if (staticProps)
              _defineProperties(Constructor, staticProps);
            return Constructor;
          }
          function _defineProperty(obj, key2, value) {
            if (key2 in obj) {
              Object.defineProperty(obj, key2, { value, enumerable: true, configurable: true, writable: true });
            } else {
              obj[key2] = value;
            }
            return obj;
          }
          var EventEmitter = /* @__PURE__ */ function() {
            function EventEmitter2() {
              _classCallCheck(this, EventEmitter2);
              _defineProperty(this, "listenersMap", /* @__PURE__ */ new Map());
            }
            _createClass(EventEmitter2, [{
              key: "addListener",
              value: function addListener(event2, listener) {
                var listeners = this.listenersMap.get(event2);
                if (listeners === void 0) {
                  this.listenersMap.set(event2, [listener]);
                } else {
                  var index = listeners.indexOf(listener);
                  if (index < 0) {
                    listeners.push(listener);
                  }
                }
              }
            }, {
              key: "emit",
              value: function emit(event2) {
                var listeners = this.listenersMap.get(event2);
                if (listeners !== void 0) {
                  for (var _len = arguments.length, args = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
                    args[_key - 1] = arguments[_key];
                  }
                  if (listeners.length === 1) {
                    var listener = listeners[0];
                    listener.apply(null, args);
                  } else {
                    var didThrow = false;
                    var caughtError = null;
                    var clonedListeners = Array.from(listeners);
                    for (var i3 = 0; i3 < clonedListeners.length; i3++) {
                      var _listener = clonedListeners[i3];
                      try {
                        _listener.apply(null, args);
                      } catch (error) {
                        if (caughtError === null) {
                          didThrow = true;
                          caughtError = error;
                        }
                      }
                    }
                    if (didThrow) {
                      throw caughtError;
                    }
                  }
                }
              }
            }, {
              key: "removeAllListeners",
              value: function removeAllListeners() {
                this.listenersMap.clear();
              }
            }, {
              key: "removeListener",
              value: function removeListener(event2, listener) {
                var listeners = this.listenersMap.get(event2);
                if (listeners !== void 0) {
                  var index = listeners.indexOf(listener);
                  if (index >= 0) {
                    listeners.splice(index, 1);
                  }
                }
              }
            }]);
            return EventEmitter2;
          }();
          var lodash_throttle = __webpack_require__(14);
          var lodash_throttle_default = /* @__PURE__ */ __webpack_require__.n(lodash_throttle);
          var constants = __webpack_require__(0);
          var storage = __webpack_require__(5);
          var simpleIsEqual = function simpleIsEqual2(a2, b2) {
            return a2 === b2;
          };
          var esm = function(resultFn) {
            var isEqual = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : simpleIsEqual;
            var lastThis = void 0;
            var lastArgs = [];
            var lastResult = void 0;
            var calledOnce = false;
            var isNewArgEqualToLast = function isNewArgEqualToLast2(newArg, index) {
              return isEqual(newArg, lastArgs[index]);
            };
            var result2 = function result3() {
              for (var _len = arguments.length, newArgs = Array(_len), _key = 0; _key < _len; _key++) {
                newArgs[_key] = arguments[_key];
              }
              if (calledOnce && lastThis === this && newArgs.length === lastArgs.length && newArgs.every(isNewArgEqualToLast)) {
                return lastResult;
              }
              calledOnce = true;
              lastThis = this;
              lastArgs = newArgs;
              lastResult = resultFn.apply(this, newArgs);
              return lastResult;
            };
            return result2;
          };
          var object_assign = __webpack_require__(7);
          var object_assign_default = /* @__PURE__ */ __webpack_require__.n(object_assign);
          function getOwnerWindow(node) {
            if (!node.ownerDocument) {
              return null;
            }
            return node.ownerDocument.defaultView;
          }
          function getOwnerIframe(node) {
            var nodeWindow = getOwnerWindow(node);
            if (nodeWindow) {
              return nodeWindow.frameElement;
            }
            return null;
          }
          function getBoundingClientRectWithBorderOffset(node) {
            var dimensions = getElementDimensions(node);
            return mergeRectOffsets([node.getBoundingClientRect(), {
              top: dimensions.borderTop,
              left: dimensions.borderLeft,
              bottom: dimensions.borderBottom,
              right: dimensions.borderRight,
              width: 0,
              height: 0
            }]);
          }
          function mergeRectOffsets(rects) {
            return rects.reduce(function(previousRect, rect) {
              if (previousRect == null) {
                return rect;
              }
              return {
                top: previousRect.top + rect.top,
                left: previousRect.left + rect.left,
                width: previousRect.width,
                height: previousRect.height,
                bottom: previousRect.bottom + rect.bottom,
                right: previousRect.right + rect.right
              };
            });
          }
          function getNestedBoundingClientRect(node, boundaryWindow) {
            var ownerIframe = getOwnerIframe(node);
            if (ownerIframe && ownerIframe !== boundaryWindow) {
              var rects = [node.getBoundingClientRect()];
              var currentIframe = ownerIframe;
              var onlyOneMore = false;
              while (currentIframe) {
                var rect = getBoundingClientRectWithBorderOffset(currentIframe);
                rects.push(rect);
                currentIframe = getOwnerIframe(currentIframe);
                if (onlyOneMore) {
                  break;
                }
                if (currentIframe && getOwnerWindow(currentIframe) === boundaryWindow) {
                  onlyOneMore = true;
                }
              }
              return mergeRectOffsets(rects);
            } else {
              return node.getBoundingClientRect();
            }
          }
          function getElementDimensions(domElement) {
            var calculatedStyle = window.getComputedStyle(domElement);
            return {
              borderLeft: parseInt(calculatedStyle.borderLeftWidth, 10),
              borderRight: parseInt(calculatedStyle.borderRightWidth, 10),
              borderTop: parseInt(calculatedStyle.borderTopWidth, 10),
              borderBottom: parseInt(calculatedStyle.borderBottomWidth, 10),
              marginLeft: parseInt(calculatedStyle.marginLeft, 10),
              marginRight: parseInt(calculatedStyle.marginRight, 10),
              marginTop: parseInt(calculatedStyle.marginTop, 10),
              marginBottom: parseInt(calculatedStyle.marginBottom, 10),
              paddingLeft: parseInt(calculatedStyle.paddingLeft, 10),
              paddingRight: parseInt(calculatedStyle.paddingRight, 10),
              paddingTop: parseInt(calculatedStyle.paddingTop, 10),
              paddingBottom: parseInt(calculatedStyle.paddingBottom, 10)
            };
          }
          function _createForOfIteratorHelper(o2, allowArrayLike) {
            var it;
            if (typeof Symbol === "undefined" || o2[Symbol.iterator] == null) {
              if (Array.isArray(o2) || (it = _unsupportedIterableToArray(o2)) || allowArrayLike && o2 && typeof o2.length === "number") {
                if (it)
                  o2 = it;
                var i3 = 0;
                var F = function F2() {
                };
                return { s: F, n: function n2() {
                  if (i3 >= o2.length)
                    return { done: true };
                  return { done: false, value: o2[i3++] };
                }, e: function e2(_e) {
                  throw _e;
                }, f: F };
              }
              throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
            }
            var normalCompletion = true, didErr = false, err2;
            return { s: function s2() {
              it = o2[Symbol.iterator]();
            }, n: function n2() {
              var step = it.next();
              normalCompletion = step.done;
              return step;
            }, e: function e2(_e2) {
              didErr = true;
              err2 = _e2;
            }, f: function f() {
              try {
                if (!normalCompletion && it.return != null)
                  it.return();
              } finally {
                if (didErr)
                  throw err2;
              }
            } };
          }
          function _unsupportedIterableToArray(o2, minLen) {
            if (!o2)
              return;
            if (typeof o2 === "string")
              return _arrayLikeToArray(o2, minLen);
            var n2 = Object.prototype.toString.call(o2).slice(8, -1);
            if (n2 === "Object" && o2.constructor)
              n2 = o2.constructor.name;
            if (n2 === "Map" || n2 === "Set")
              return Array.from(o2);
            if (n2 === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n2))
              return _arrayLikeToArray(o2, minLen);
          }
          function _arrayLikeToArray(arr, len) {
            if (len == null || len > arr.length)
              len = arr.length;
            for (var i3 = 0, arr2 = new Array(len); i3 < len; i3++) {
              arr2[i3] = arr[i3];
            }
            return arr2;
          }
          function Overlay_classCallCheck(instance, Constructor) {
            if (!(instance instanceof Constructor)) {
              throw new TypeError("Cannot call a class as a function");
            }
          }
          function Overlay_defineProperties(target, props) {
            for (var i3 = 0; i3 < props.length; i3++) {
              var descriptor = props[i3];
              descriptor.enumerable = descriptor.enumerable || false;
              descriptor.configurable = true;
              if ("value" in descriptor)
                descriptor.writable = true;
              Object.defineProperty(target, descriptor.key, descriptor);
            }
          }
          function Overlay_createClass(Constructor, protoProps, staticProps) {
            if (protoProps)
              Overlay_defineProperties(Constructor.prototype, protoProps);
            if (staticProps)
              Overlay_defineProperties(Constructor, staticProps);
            return Constructor;
          }
          var Overlay_OverlayRect = /* @__PURE__ */ function() {
            function OverlayRect(doc, container) {
              Overlay_classCallCheck(this, OverlayRect);
              this.node = doc.createElement("div");
              this.border = doc.createElement("div");
              this.padding = doc.createElement("div");
              this.content = doc.createElement("div");
              this.border.style.borderColor = overlayStyles.border;
              this.padding.style.borderColor = overlayStyles.padding;
              this.content.style.backgroundColor = overlayStyles.background;
              object_assign_default()(this.node.style, {
                borderColor: overlayStyles.margin,
                pointerEvents: "none",
                position: "fixed"
              });
              this.node.style.zIndex = "10000000";
              this.node.appendChild(this.border);
              this.border.appendChild(this.padding);
              this.padding.appendChild(this.content);
              container.appendChild(this.node);
            }
            Overlay_createClass(OverlayRect, [{
              key: "remove",
              value: function remove() {
                if (this.node.parentNode) {
                  this.node.parentNode.removeChild(this.node);
                }
              }
            }, {
              key: "update",
              value: function update(box, dims) {
                boxWrap(dims, "margin", this.node);
                boxWrap(dims, "border", this.border);
                boxWrap(dims, "padding", this.padding);
                object_assign_default()(this.content.style, {
                  height: box.height - dims.borderTop - dims.borderBottom - dims.paddingTop - dims.paddingBottom + "px",
                  width: box.width - dims.borderLeft - dims.borderRight - dims.paddingLeft - dims.paddingRight + "px"
                });
                object_assign_default()(this.node.style, {
                  top: box.top - dims.marginTop + "px",
                  left: box.left - dims.marginLeft + "px"
                });
              }
            }]);
            return OverlayRect;
          }();
          var Overlay_OverlayTip = /* @__PURE__ */ function() {
            function OverlayTip(doc, container) {
              Overlay_classCallCheck(this, OverlayTip);
              this.tip = doc.createElement("div");
              object_assign_default()(this.tip.style, {
                display: "flex",
                flexFlow: "row nowrap",
                backgroundColor: "#333740",
                borderRadius: "2px",
                fontFamily: '"SFMono-Regular", Consolas, "Liberation Mono", Menlo, Courier, monospace',
                fontWeight: "bold",
                padding: "3px 5px",
                pointerEvents: "none",
                position: "fixed",
                fontSize: "12px",
                whiteSpace: "nowrap"
              });
              this.nameSpan = doc.createElement("span");
              this.tip.appendChild(this.nameSpan);
              object_assign_default()(this.nameSpan.style, {
                color: "#ee78e6",
                borderRight: "1px solid #aaaaaa",
                paddingRight: "0.5rem",
                marginRight: "0.5rem"
              });
              this.dimSpan = doc.createElement("span");
              this.tip.appendChild(this.dimSpan);
              object_assign_default()(this.dimSpan.style, {
                color: "#d7d7d7"
              });
              this.tip.style.zIndex = "10000000";
              container.appendChild(this.tip);
            }
            Overlay_createClass(OverlayTip, [{
              key: "remove",
              value: function remove() {
                if (this.tip.parentNode) {
                  this.tip.parentNode.removeChild(this.tip);
                }
              }
            }, {
              key: "updateText",
              value: function updateText(name, width, height) {
                this.nameSpan.textContent = name;
                this.dimSpan.textContent = Math.round(width) + "px \xD7 " + Math.round(height) + "px";
              }
            }, {
              key: "updatePosition",
              value: function updatePosition(dims, bounds) {
                var tipRect = this.tip.getBoundingClientRect();
                var tipPos = findTipPos(dims, bounds, {
                  width: tipRect.width,
                  height: tipRect.height
                });
                object_assign_default()(this.tip.style, tipPos.style);
              }
            }]);
            return OverlayTip;
          }();
          var Overlay_Overlay = /* @__PURE__ */ function() {
            function Overlay() {
              Overlay_classCallCheck(this, Overlay);
              var currentWindow = window.__REACT_DEVTOOLS_TARGET_WINDOW__ || window;
              this.window = currentWindow;
              var tipBoundsWindow = window.__REACT_DEVTOOLS_TARGET_WINDOW__ || window;
              this.tipBoundsWindow = tipBoundsWindow;
              var doc = currentWindow.document;
              this.container = doc.createElement("div");
              this.container.style.zIndex = "10000000";
              this.tip = new Overlay_OverlayTip(doc, this.container);
              this.rects = [];
              doc.body.appendChild(this.container);
            }
            Overlay_createClass(Overlay, [{
              key: "remove",
              value: function remove() {
                this.tip.remove();
                this.rects.forEach(function(rect) {
                  rect.remove();
                });
                this.rects.length = 0;
                if (this.container.parentNode) {
                  this.container.parentNode.removeChild(this.container);
                }
              }
            }, {
              key: "inspect",
              value: function inspect2(nodes, name) {
                var _this = this;
                var elements = nodes.filter(function(node2) {
                  return node2.nodeType === Node.ELEMENT_NODE;
                });
                while (this.rects.length > elements.length) {
                  var rect = this.rects.pop();
                  rect.remove();
                }
                if (elements.length === 0) {
                  return;
                }
                while (this.rects.length < elements.length) {
                  this.rects.push(new Overlay_OverlayRect(this.window.document, this.container));
                }
                var outerBox = {
                  top: Number.POSITIVE_INFINITY,
                  right: Number.NEGATIVE_INFINITY,
                  bottom: Number.NEGATIVE_INFINITY,
                  left: Number.POSITIVE_INFINITY
                };
                elements.forEach(function(element, index) {
                  var box = getNestedBoundingClientRect(element, _this.window);
                  var dims = getElementDimensions(element);
                  outerBox.top = Math.min(outerBox.top, box.top - dims.marginTop);
                  outerBox.right = Math.max(outerBox.right, box.left + box.width + dims.marginRight);
                  outerBox.bottom = Math.max(outerBox.bottom, box.top + box.height + dims.marginBottom);
                  outerBox.left = Math.min(outerBox.left, box.left - dims.marginLeft);
                  var rect2 = _this.rects[index];
                  rect2.update(box, dims);
                });
                if (!name) {
                  name = elements[0].nodeName.toLowerCase();
                  var node = elements[0];
                  var hook = node.ownerDocument.defaultView.__REACT_DEVTOOLS_GLOBAL_HOOK__;
                  if (hook != null && hook.rendererInterfaces != null) {
                    var ownerName = null;
                    var _iterator = _createForOfIteratorHelper(hook.rendererInterfaces.values()), _step;
                    try {
                      for (_iterator.s(); !(_step = _iterator.n()).done; ) {
                        var rendererInterface = _step.value;
                        var id = rendererInterface.getFiberIDForNative(node, true);
                        if (id !== null) {
                          ownerName = rendererInterface.getDisplayNameForFiberID(id, true);
                          break;
                        }
                      }
                    } catch (err2) {
                      _iterator.e(err2);
                    } finally {
                      _iterator.f();
                    }
                    if (ownerName) {
                      name += " (in " + ownerName + ")";
                    }
                  }
                }
                this.tip.updateText(name, outerBox.right - outerBox.left, outerBox.bottom - outerBox.top);
                var tipBounds = getNestedBoundingClientRect(this.tipBoundsWindow.document.documentElement, this.window);
                this.tip.updatePosition({
                  top: outerBox.top,
                  left: outerBox.left,
                  height: outerBox.bottom - outerBox.top,
                  width: outerBox.right - outerBox.left
                }, {
                  top: tipBounds.top + this.tipBoundsWindow.scrollY,
                  left: tipBounds.left + this.tipBoundsWindow.scrollX,
                  height: this.tipBoundsWindow.innerHeight,
                  width: this.tipBoundsWindow.innerWidth
                });
              }
            }]);
            return Overlay;
          }();
          function findTipPos(dims, bounds, tipSize) {
            var tipHeight = Math.max(tipSize.height, 20);
            var tipWidth = Math.max(tipSize.width, 60);
            var margin = 5;
            var top;
            if (dims.top + dims.height + tipHeight <= bounds.top + bounds.height) {
              if (dims.top + dims.height < bounds.top + 0) {
                top = bounds.top + margin;
              } else {
                top = dims.top + dims.height + margin;
              }
            } else if (dims.top - tipHeight <= bounds.top + bounds.height) {
              if (dims.top - tipHeight - margin < bounds.top + margin) {
                top = bounds.top + margin;
              } else {
                top = dims.top - tipHeight - margin;
              }
            } else {
              top = bounds.top + bounds.height - tipHeight - margin;
            }
            var left = dims.left + margin;
            if (dims.left < bounds.left) {
              left = bounds.left + margin;
            }
            if (dims.left + tipWidth > bounds.left + bounds.width) {
              left = bounds.left + bounds.width - tipWidth - margin;
            }
            top += "px";
            left += "px";
            return {
              style: {
                top,
                left
              }
            };
          }
          function boxWrap(dims, what, node) {
            object_assign_default()(node.style, {
              borderTopWidth: dims[what + "Top"] + "px",
              borderLeftWidth: dims[what + "Left"] + "px",
              borderRightWidth: dims[what + "Right"] + "px",
              borderBottomWidth: dims[what + "Bottom"] + "px",
              borderStyle: "solid"
            });
          }
          var overlayStyles = {
            background: "rgba(120, 170, 210, 0.7)",
            padding: "rgba(77, 200, 0, 0.3)",
            margin: "rgba(255, 155, 0, 0.3)",
            border: "rgba(255, 200, 50, 0.3)"
          };
          var SHOW_DURATION = 2e3;
          var timeoutID = null;
          var overlay = null;
          function hideOverlay() {
            timeoutID = null;
            if (overlay !== null) {
              overlay.remove();
              overlay = null;
            }
          }
          function showOverlay(elements, componentName, hideAfterTimeout) {
            if (window.document == null) {
              return;
            }
            if (timeoutID !== null) {
              clearTimeout(timeoutID);
            }
            if (elements == null) {
              return;
            }
            if (overlay === null) {
              overlay = new Overlay_Overlay();
            }
            overlay.inspect(elements, componentName);
            if (hideAfterTimeout) {
              timeoutID = setTimeout(hideOverlay, SHOW_DURATION);
            }
          }
          var iframesListeningTo = /* @__PURE__ */ new Set();
          function setupHighlighter(bridge, agent) {
            bridge.addListener("clearNativeElementHighlight", clearNativeElementHighlight);
            bridge.addListener("highlightNativeElement", highlightNativeElement);
            bridge.addListener("shutdown", stopInspectingNative);
            bridge.addListener("startInspectingNative", startInspectingNative);
            bridge.addListener("stopInspectingNative", stopInspectingNative);
            function startInspectingNative() {
              registerListenersOnWindow(window);
            }
            function registerListenersOnWindow(window2) {
              if (window2 && typeof window2.addEventListener === "function") {
                window2.addEventListener("click", onClick, true);
                window2.addEventListener("mousedown", onMouseEvent, true);
                window2.addEventListener("mouseover", onMouseEvent, true);
                window2.addEventListener("mouseup", onMouseEvent, true);
                window2.addEventListener("pointerdown", onPointerDown, true);
                window2.addEventListener("pointerover", onPointerOver, true);
                window2.addEventListener("pointerup", onPointerUp, true);
              }
            }
            function stopInspectingNative() {
              hideOverlay();
              removeListenersOnWindow(window);
              iframesListeningTo.forEach(function(frame) {
                try {
                  removeListenersOnWindow(frame.contentWindow);
                } catch (error) {
                }
              });
              iframesListeningTo = /* @__PURE__ */ new Set();
            }
            function removeListenersOnWindow(window2) {
              if (window2 && typeof window2.removeEventListener === "function") {
                window2.removeEventListener("click", onClick, true);
                window2.removeEventListener("mousedown", onMouseEvent, true);
                window2.removeEventListener("mouseover", onMouseEvent, true);
                window2.removeEventListener("mouseup", onMouseEvent, true);
                window2.removeEventListener("pointerdown", onPointerDown, true);
                window2.removeEventListener("pointerover", onPointerOver, true);
                window2.removeEventListener("pointerup", onPointerUp, true);
              }
            }
            function clearNativeElementHighlight() {
              hideOverlay();
            }
            function highlightNativeElement(_ref) {
              var displayName = _ref.displayName, hideAfterTimeout = _ref.hideAfterTimeout, id = _ref.id, openNativeElementsPanel = _ref.openNativeElementsPanel, rendererID = _ref.rendererID, scrollIntoView = _ref.scrollIntoView;
              var renderer = agent.rendererInterfaces[rendererID];
              if (renderer == null) {
                console.warn('Invalid renderer id "'.concat(rendererID, '" for element "').concat(id, '"'));
              }
              var nodes = null;
              if (renderer != null) {
                nodes = renderer.findNativeNodesForFiberID(id);
              }
              if (nodes != null && nodes[0] != null) {
                var node = nodes[0];
                if (scrollIntoView && typeof node.scrollIntoView === "function") {
                  node.scrollIntoView({
                    block: "nearest",
                    inline: "nearest"
                  });
                }
                showOverlay(nodes, displayName, hideAfterTimeout);
                if (openNativeElementsPanel) {
                  window.__REACT_DEVTOOLS_GLOBAL_HOOK__.$0 = node;
                  bridge.send("syncSelectionToNativeElementsPanel");
                }
              } else {
                hideOverlay();
              }
            }
            function onClick(event2) {
              event2.preventDefault();
              event2.stopPropagation();
              stopInspectingNative();
              bridge.send("stopInspectingNative", true);
            }
            function onMouseEvent(event2) {
              event2.preventDefault();
              event2.stopPropagation();
            }
            function onPointerDown(event2) {
              event2.preventDefault();
              event2.stopPropagation();
              selectFiberForNode(event2.target);
            }
            function onPointerOver(event2) {
              event2.preventDefault();
              event2.stopPropagation();
              var target = event2.target;
              if (target.tagName === "IFRAME") {
                var iframe = target;
                try {
                  if (!iframesListeningTo.has(iframe)) {
                    var _window = iframe.contentWindow;
                    registerListenersOnWindow(_window);
                    iframesListeningTo.add(iframe);
                  }
                } catch (error) {
                }
              }
              showOverlay([target], null, false);
              selectFiberForNode(target);
            }
            function onPointerUp(event2) {
              event2.preventDefault();
              event2.stopPropagation();
            }
            var selectFiberForNode = lodash_throttle_default()(esm(function(node) {
              var id = agent.getIDForNode(node);
              if (id !== null) {
                bridge.send("selectFiber", id);
              }
            }), 200, {
              leading: false
            });
          }
          var OUTLINE_COLOR = "#f0f0f0";
          var COLORS = ["#37afa9", "#63b19e", "#80b393", "#97b488", "#abb67d", "#beb771", "#cfb965", "#dfba57", "#efbb49", "#febc38"];
          var canvas = null;
          function draw(nodeToData2) {
            if (canvas === null) {
              initialize();
            }
            var canvasFlow = canvas;
            canvasFlow.width = window.innerWidth;
            canvasFlow.height = window.innerHeight;
            var context = canvasFlow.getContext("2d");
            context.clearRect(0, 0, canvasFlow.width, canvasFlow.height);
            nodeToData2.forEach(function(_ref) {
              var count = _ref.count, rect = _ref.rect;
              if (rect !== null) {
                var colorIndex = Math.min(COLORS.length - 1, count - 1);
                var color = COLORS[colorIndex];
                drawBorder(context, rect, color);
              }
            });
          }
          function drawBorder(context, rect, color) {
            var height = rect.height, left = rect.left, top = rect.top, width = rect.width;
            context.lineWidth = 1;
            context.strokeStyle = OUTLINE_COLOR;
            context.strokeRect(left - 1, top - 1, width + 2, height + 2);
            context.lineWidth = 1;
            context.strokeStyle = OUTLINE_COLOR;
            context.strokeRect(left + 1, top + 1, width - 1, height - 1);
            context.strokeStyle = color;
            context.setLineDash([0]);
            context.lineWidth = 1;
            context.strokeRect(left, top, width - 1, height - 1);
            context.setLineDash([0]);
          }
          function destroy() {
            if (canvas !== null) {
              if (canvas.parentNode != null) {
                canvas.parentNode.removeChild(canvas);
              }
              canvas = null;
            }
          }
          function initialize() {
            canvas = window.document.createElement("canvas");
            canvas.style.cssText = "\n    xx-background-color: red;\n    xx-opacity: 0.5;\n    bottom: 0;\n    left: 0;\n    pointer-events: none;\n    position: fixed;\n    right: 0;\n    top: 0;\n    z-index: 1000000000;\n  ";
            var root = window.document.documentElement;
            root.insertBefore(canvas, root.firstChild);
          }
          function _typeof(obj) {
            "@babel/helpers - typeof";
            if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
              _typeof = function _typeof2(obj2) {
                return typeof obj2;
              };
            } else {
              _typeof = function _typeof2(obj2) {
                return obj2 && typeof Symbol === "function" && obj2.constructor === Symbol && obj2 !== Symbol.prototype ? "symbol" : typeof obj2;
              };
            }
            return _typeof(obj);
          }
          var DISPLAY_DURATION = 250;
          var MAX_DISPLAY_DURATION = 3e3;
          var REMEASUREMENT_AFTER_DURATION = 250;
          var getCurrentTime = (typeof performance === "undefined" ? "undefined" : _typeof(performance)) === "object" && typeof performance.now === "function" ? function() {
            return performance.now();
          } : function() {
            return Date.now();
          };
          var nodeToData = /* @__PURE__ */ new Map();
          var TraceUpdates_agent = null;
          var drawAnimationFrameID = null;
          var isEnabled = false;
          var redrawTimeoutID = null;
          function TraceUpdates_initialize(injectedAgent) {
            TraceUpdates_agent = injectedAgent;
            TraceUpdates_agent.addListener("traceUpdates", traceUpdates);
          }
          function toggleEnabled(value) {
            isEnabled = value;
            if (!isEnabled) {
              nodeToData.clear();
              if (drawAnimationFrameID !== null) {
                cancelAnimationFrame(drawAnimationFrameID);
                drawAnimationFrameID = null;
              }
              if (redrawTimeoutID !== null) {
                clearTimeout(redrawTimeoutID);
                redrawTimeoutID = null;
              }
              destroy();
            }
          }
          function traceUpdates(nodes) {
            if (!isEnabled) {
              return;
            }
            nodes.forEach(function(node) {
              var data = nodeToData.get(node);
              var now = getCurrentTime();
              var lastMeasuredAt = data != null ? data.lastMeasuredAt : 0;
              var rect = data != null ? data.rect : null;
              if (rect === null || lastMeasuredAt + REMEASUREMENT_AFTER_DURATION < now) {
                lastMeasuredAt = now;
                rect = measureNode(node);
              }
              nodeToData.set(node, {
                count: data != null ? data.count + 1 : 1,
                expirationTime: data != null ? Math.min(now + MAX_DISPLAY_DURATION, data.expirationTime + DISPLAY_DURATION) : now + DISPLAY_DURATION,
                lastMeasuredAt,
                rect
              });
            });
            if (redrawTimeoutID !== null) {
              clearTimeout(redrawTimeoutID);
              redrawTimeoutID = null;
            }
            if (drawAnimationFrameID === null) {
              drawAnimationFrameID = requestAnimationFrame(prepareToDraw);
            }
          }
          function prepareToDraw() {
            drawAnimationFrameID = null;
            redrawTimeoutID = null;
            var now = getCurrentTime();
            var earliestExpiration = Number.MAX_VALUE;
            nodeToData.forEach(function(data, node) {
              if (data.expirationTime < now) {
                nodeToData.delete(node);
              } else {
                earliestExpiration = Math.min(earliestExpiration, data.expirationTime);
              }
            });
            draw(nodeToData);
            if (earliestExpiration !== Number.MAX_VALUE) {
              redrawTimeoutID = setTimeout(prepareToDraw, earliestExpiration - now);
            }
          }
          function measureNode(node) {
            if (!node || typeof node.getBoundingClientRect !== "function") {
              return null;
            }
            var currentWindow = window.__REACT_DEVTOOLS_TARGET_WINDOW__ || window;
            return getNestedBoundingClientRect(node, currentWindow);
          }
          var backend_console = __webpack_require__(8);
          function bridge_typeof(obj) {
            "@babel/helpers - typeof";
            if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
              bridge_typeof = function _typeof2(obj2) {
                return typeof obj2;
              };
            } else {
              bridge_typeof = function _typeof2(obj2) {
                return obj2 && typeof Symbol === "function" && obj2.constructor === Symbol && obj2 !== Symbol.prototype ? "symbol" : typeof obj2;
              };
            }
            return bridge_typeof(obj);
          }
          function _toConsumableArray(arr) {
            return _arrayWithoutHoles(arr) || _iterableToArray(arr) || bridge_unsupportedIterableToArray(arr) || _nonIterableSpread();
          }
          function _nonIterableSpread() {
            throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
          }
          function bridge_unsupportedIterableToArray(o2, minLen) {
            if (!o2)
              return;
            if (typeof o2 === "string")
              return bridge_arrayLikeToArray(o2, minLen);
            var n2 = Object.prototype.toString.call(o2).slice(8, -1);
            if (n2 === "Object" && o2.constructor)
              n2 = o2.constructor.name;
            if (n2 === "Map" || n2 === "Set")
              return Array.from(o2);
            if (n2 === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n2))
              return bridge_arrayLikeToArray(o2, minLen);
          }
          function _iterableToArray(iter) {
            if (typeof Symbol !== "undefined" && Symbol.iterator in Object(iter))
              return Array.from(iter);
          }
          function _arrayWithoutHoles(arr) {
            if (Array.isArray(arr))
              return bridge_arrayLikeToArray(arr);
          }
          function bridge_arrayLikeToArray(arr, len) {
            if (len == null || len > arr.length)
              len = arr.length;
            for (var i3 = 0, arr2 = new Array(len); i3 < len; i3++) {
              arr2[i3] = arr[i3];
            }
            return arr2;
          }
          function bridge_classCallCheck(instance, Constructor) {
            if (!(instance instanceof Constructor)) {
              throw new TypeError("Cannot call a class as a function");
            }
          }
          function bridge_defineProperties(target, props) {
            for (var i3 = 0; i3 < props.length; i3++) {
              var descriptor = props[i3];
              descriptor.enumerable = descriptor.enumerable || false;
              descriptor.configurable = true;
              if ("value" in descriptor)
                descriptor.writable = true;
              Object.defineProperty(target, descriptor.key, descriptor);
            }
          }
          function bridge_createClass(Constructor, protoProps, staticProps) {
            if (protoProps)
              bridge_defineProperties(Constructor.prototype, protoProps);
            if (staticProps)
              bridge_defineProperties(Constructor, staticProps);
            return Constructor;
          }
          function _inherits(subClass, superClass) {
            if (typeof superClass !== "function" && superClass !== null) {
              throw new TypeError("Super expression must either be null or a function");
            }
            subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } });
            if (superClass)
              _setPrototypeOf(subClass, superClass);
          }
          function _setPrototypeOf(o2, p) {
            _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf2(o3, p2) {
              o3.__proto__ = p2;
              return o3;
            };
            return _setPrototypeOf(o2, p);
          }
          function _createSuper(Derived) {
            var hasNativeReflectConstruct = _isNativeReflectConstruct();
            return function _createSuperInternal() {
              var Super = _getPrototypeOf(Derived), result2;
              if (hasNativeReflectConstruct) {
                var NewTarget = _getPrototypeOf(this).constructor;
                result2 = Reflect.construct(Super, arguments, NewTarget);
              } else {
                result2 = Super.apply(this, arguments);
              }
              return _possibleConstructorReturn(this, result2);
            };
          }
          function _possibleConstructorReturn(self2, call) {
            if (call && (bridge_typeof(call) === "object" || typeof call === "function")) {
              return call;
            }
            return _assertThisInitialized(self2);
          }
          function _assertThisInitialized(self2) {
            if (self2 === void 0) {
              throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
            }
            return self2;
          }
          function _isNativeReflectConstruct() {
            if (typeof Reflect === "undefined" || !Reflect.construct)
              return false;
            if (Reflect.construct.sham)
              return false;
            if (typeof Proxy === "function")
              return true;
            try {
              Date.prototype.toString.call(Reflect.construct(Date, [], function() {
              }));
              return true;
            } catch (e2) {
              return false;
            }
          }
          function _getPrototypeOf(o2) {
            _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf2(o3) {
              return o3.__proto__ || Object.getPrototypeOf(o3);
            };
            return _getPrototypeOf(o2);
          }
          function bridge_defineProperty(obj, key2, value) {
            if (key2 in obj) {
              Object.defineProperty(obj, key2, { value, enumerable: true, configurable: true, writable: true });
            } else {
              obj[key2] = value;
            }
            return obj;
          }
          var BATCH_DURATION = 100;
          var BRIDGE_PROTOCOL = [
            {
              version: 0,
              minNpmVersion: '"<4.11.0"',
              maxNpmVersion: '"<4.11.0"'
            },
            {
              version: 1,
              minNpmVersion: "4.13.0",
              maxNpmVersion: null
            }
          ];
          var currentBridgeProtocol = BRIDGE_PROTOCOL[BRIDGE_PROTOCOL.length - 1];
          var Bridge = /* @__PURE__ */ function(_EventEmitter) {
            _inherits(Bridge2, _EventEmitter);
            var _super = _createSuper(Bridge2);
            function Bridge2(wall) {
              var _this;
              bridge_classCallCheck(this, Bridge2);
              _this = _super.call(this);
              bridge_defineProperty(_assertThisInitialized(_this), "_isShutdown", false);
              bridge_defineProperty(_assertThisInitialized(_this), "_messageQueue", []);
              bridge_defineProperty(_assertThisInitialized(_this), "_timeoutID", null);
              bridge_defineProperty(_assertThisInitialized(_this), "_wallUnlisten", null);
              bridge_defineProperty(_assertThisInitialized(_this), "_flush", function() {
                if (_this._timeoutID !== null) {
                  clearTimeout(_this._timeoutID);
                  _this._timeoutID = null;
                }
                if (_this._messageQueue.length) {
                  for (var i3 = 0; i3 < _this._messageQueue.length; i3 += 2) {
                    var _this$_wall;
                    (_this$_wall = _this._wall).send.apply(_this$_wall, [_this._messageQueue[i3]].concat(_toConsumableArray(_this._messageQueue[i3 + 1])));
                  }
                  _this._messageQueue.length = 0;
                  _this._timeoutID = setTimeout(_this._flush, BATCH_DURATION);
                }
              });
              bridge_defineProperty(_assertThisInitialized(_this), "overrideValueAtPath", function(_ref) {
                var id = _ref.id, path2 = _ref.path, rendererID = _ref.rendererID, type3 = _ref.type, value = _ref.value;
                switch (type3) {
                  case "context":
                    _this.send("overrideContext", {
                      id,
                      path: path2,
                      rendererID,
                      wasForwarded: true,
                      value
                    });
                    break;
                  case "hooks":
                    _this.send("overrideHookState", {
                      id,
                      path: path2,
                      rendererID,
                      wasForwarded: true,
                      value
                    });
                    break;
                  case "props":
                    _this.send("overrideProps", {
                      id,
                      path: path2,
                      rendererID,
                      wasForwarded: true,
                      value
                    });
                    break;
                  case "state":
                    _this.send("overrideState", {
                      id,
                      path: path2,
                      rendererID,
                      wasForwarded: true,
                      value
                    });
                    break;
                }
              });
              _this._wall = wall;
              _this._wallUnlisten = wall.listen(function(message) {
                _assertThisInitialized(_this).emit(message.event, message.payload);
              }) || null;
              _this.addListener("overrideValueAtPath", _this.overrideValueAtPath);
              return _this;
            }
            bridge_createClass(Bridge2, [{
              key: "send",
              value: function send3(event2) {
                if (this._isShutdown) {
                  console.warn('Cannot send message "'.concat(event2, '" through a Bridge that has been shutdown.'));
                  return;
                }
                for (var _len = arguments.length, payload = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
                  payload[_key - 1] = arguments[_key];
                }
                this._messageQueue.push(event2, payload);
                if (!this._timeoutID) {
                  this._timeoutID = setTimeout(this._flush, 0);
                }
              }
            }, {
              key: "shutdown",
              value: function shutdown() {
                if (this._isShutdown) {
                  console.warn("Bridge was already shutdown.");
                  return;
                }
                this.send("shutdown");
                this._isShutdown = true;
                this.addListener = function() {
                };
                this.emit = function() {
                };
                this.removeAllListeners();
                var wallUnlisten = this._wallUnlisten;
                if (wallUnlisten) {
                  wallUnlisten();
                }
                do {
                  this._flush();
                } while (this._messageQueue.length);
                if (this._timeoutID !== null) {
                  clearTimeout(this._timeoutID);
                  this._timeoutID = null;
                }
              }
            }, {
              key: "wall",
              get: function get() {
                return this._wall;
              }
            }]);
            return Bridge2;
          }(EventEmitter);
          var src_bridge = Bridge;
          var utils = __webpack_require__(4);
          function agent_typeof(obj) {
            "@babel/helpers - typeof";
            if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
              agent_typeof = function _typeof2(obj2) {
                return typeof obj2;
              };
            } else {
              agent_typeof = function _typeof2(obj2) {
                return obj2 && typeof Symbol === "function" && obj2.constructor === Symbol && obj2 !== Symbol.prototype ? "symbol" : typeof obj2;
              };
            }
            return agent_typeof(obj);
          }
          function agent_classCallCheck(instance, Constructor) {
            if (!(instance instanceof Constructor)) {
              throw new TypeError("Cannot call a class as a function");
            }
          }
          function agent_defineProperties(target, props) {
            for (var i3 = 0; i3 < props.length; i3++) {
              var descriptor = props[i3];
              descriptor.enumerable = descriptor.enumerable || false;
              descriptor.configurable = true;
              if ("value" in descriptor)
                descriptor.writable = true;
              Object.defineProperty(target, descriptor.key, descriptor);
            }
          }
          function agent_createClass(Constructor, protoProps, staticProps) {
            if (protoProps)
              agent_defineProperties(Constructor.prototype, protoProps);
            if (staticProps)
              agent_defineProperties(Constructor, staticProps);
            return Constructor;
          }
          function agent_inherits(subClass, superClass) {
            if (typeof superClass !== "function" && superClass !== null) {
              throw new TypeError("Super expression must either be null or a function");
            }
            subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } });
            if (superClass)
              agent_setPrototypeOf(subClass, superClass);
          }
          function agent_setPrototypeOf(o2, p) {
            agent_setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf2(o3, p2) {
              o3.__proto__ = p2;
              return o3;
            };
            return agent_setPrototypeOf(o2, p);
          }
          function agent_createSuper(Derived) {
            var hasNativeReflectConstruct = agent_isNativeReflectConstruct();
            return function _createSuperInternal() {
              var Super = agent_getPrototypeOf(Derived), result2;
              if (hasNativeReflectConstruct) {
                var NewTarget = agent_getPrototypeOf(this).constructor;
                result2 = Reflect.construct(Super, arguments, NewTarget);
              } else {
                result2 = Super.apply(this, arguments);
              }
              return agent_possibleConstructorReturn(this, result2);
            };
          }
          function agent_possibleConstructorReturn(self2, call) {
            if (call && (agent_typeof(call) === "object" || typeof call === "function")) {
              return call;
            }
            return agent_assertThisInitialized(self2);
          }
          function agent_assertThisInitialized(self2) {
            if (self2 === void 0) {
              throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
            }
            return self2;
          }
          function agent_isNativeReflectConstruct() {
            if (typeof Reflect === "undefined" || !Reflect.construct)
              return false;
            if (Reflect.construct.sham)
              return false;
            if (typeof Proxy === "function")
              return true;
            try {
              Date.prototype.toString.call(Reflect.construct(Date, [], function() {
              }));
              return true;
            } catch (e2) {
              return false;
            }
          }
          function agent_getPrototypeOf(o2) {
            agent_getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf2(o3) {
              return o3.__proto__ || Object.getPrototypeOf(o3);
            };
            return agent_getPrototypeOf(o2);
          }
          function agent_defineProperty(obj, key2, value) {
            if (key2 in obj) {
              Object.defineProperty(obj, key2, { value, enumerable: true, configurable: true, writable: true });
            } else {
              obj[key2] = value;
            }
            return obj;
          }
          var agent_debug = function debug(methodName) {
            if (constants["o"]) {
              var _console;
              for (var _len = arguments.length, args = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
                args[_key - 1] = arguments[_key];
              }
              (_console = console).log.apply(_console, ["%cAgent %c".concat(methodName), "color: purple; font-weight: bold;", "font-weight: bold;"].concat(args));
            }
          };
          var agent_Agent = /* @__PURE__ */ function(_EventEmitter) {
            agent_inherits(Agent, _EventEmitter);
            var _super = agent_createSuper(Agent);
            function Agent(bridge) {
              var _this;
              agent_classCallCheck(this, Agent);
              _this = _super.call(this);
              agent_defineProperty(agent_assertThisInitialized(_this), "_isProfiling", false);
              agent_defineProperty(agent_assertThisInitialized(_this), "_recordChangeDescriptions", false);
              agent_defineProperty(agent_assertThisInitialized(_this), "_rendererInterfaces", {});
              agent_defineProperty(agent_assertThisInitialized(_this), "_persistedSelection", null);
              agent_defineProperty(agent_assertThisInitialized(_this), "_persistedSelectionMatch", null);
              agent_defineProperty(agent_assertThisInitialized(_this), "_traceUpdatesEnabled", false);
              agent_defineProperty(agent_assertThisInitialized(_this), "clearErrorsAndWarnings", function(_ref) {
                var rendererID = _ref.rendererID;
                var renderer = _this._rendererInterfaces[rendererID];
                if (renderer == null) {
                  console.warn('Invalid renderer id "'.concat(rendererID, '"'));
                } else {
                  renderer.clearErrorsAndWarnings();
                }
              });
              agent_defineProperty(agent_assertThisInitialized(_this), "clearErrorsForFiberID", function(_ref2) {
                var id = _ref2.id, rendererID = _ref2.rendererID;
                var renderer = _this._rendererInterfaces[rendererID];
                if (renderer == null) {
                  console.warn('Invalid renderer id "'.concat(rendererID, '"'));
                } else {
                  renderer.clearErrorsForFiberID(id);
                }
              });
              agent_defineProperty(agent_assertThisInitialized(_this), "clearWarningsForFiberID", function(_ref3) {
                var id = _ref3.id, rendererID = _ref3.rendererID;
                var renderer = _this._rendererInterfaces[rendererID];
                if (renderer == null) {
                  console.warn('Invalid renderer id "'.concat(rendererID, '"'));
                } else {
                  renderer.clearWarningsForFiberID(id);
                }
              });
              agent_defineProperty(agent_assertThisInitialized(_this), "copyElementPath", function(_ref4) {
                var id = _ref4.id, path2 = _ref4.path, rendererID = _ref4.rendererID;
                var renderer = _this._rendererInterfaces[rendererID];
                if (renderer == null) {
                  console.warn('Invalid renderer id "'.concat(rendererID, '" for element "').concat(id, '"'));
                } else {
                  renderer.copyElementPath(id, path2);
                }
              });
              agent_defineProperty(agent_assertThisInitialized(_this), "deletePath", function(_ref5) {
                var hookID = _ref5.hookID, id = _ref5.id, path2 = _ref5.path, rendererID = _ref5.rendererID, type3 = _ref5.type;
                var renderer = _this._rendererInterfaces[rendererID];
                if (renderer == null) {
                  console.warn('Invalid renderer id "'.concat(rendererID, '" for element "').concat(id, '"'));
                } else {
                  renderer.deletePath(type3, id, hookID, path2);
                }
              });
              agent_defineProperty(agent_assertThisInitialized(_this), "getBridgeProtocol", function() {
                _this._bridge.send("bridgeProtocol", currentBridgeProtocol);
              });
              agent_defineProperty(agent_assertThisInitialized(_this), "getProfilingData", function(_ref6) {
                var rendererID = _ref6.rendererID;
                var renderer = _this._rendererInterfaces[rendererID];
                if (renderer == null) {
                  console.warn('Invalid renderer id "'.concat(rendererID, '"'));
                }
                _this._bridge.send("profilingData", renderer.getProfilingData());
              });
              agent_defineProperty(agent_assertThisInitialized(_this), "getProfilingStatus", function() {
                _this._bridge.send("profilingStatus", _this._isProfiling);
              });
              agent_defineProperty(agent_assertThisInitialized(_this), "getOwnersList", function(_ref7) {
                var id = _ref7.id, rendererID = _ref7.rendererID;
                var renderer = _this._rendererInterfaces[rendererID];
                if (renderer == null) {
                  console.warn('Invalid renderer id "'.concat(rendererID, '" for element "').concat(id, '"'));
                } else {
                  var owners = renderer.getOwnersList(id);
                  _this._bridge.send("ownersList", {
                    id,
                    owners
                  });
                }
              });
              agent_defineProperty(agent_assertThisInitialized(_this), "inspectElement", function(_ref8) {
                var id = _ref8.id, path2 = _ref8.path, rendererID = _ref8.rendererID, requestID = _ref8.requestID;
                var renderer = _this._rendererInterfaces[rendererID];
                if (renderer == null) {
                  console.warn('Invalid renderer id "'.concat(rendererID, '" for element "').concat(id, '"'));
                } else {
                  _this._bridge.send("inspectedElement", renderer.inspectElement(requestID, id, path2));
                  if (_this._persistedSelectionMatch === null || _this._persistedSelectionMatch.id !== id) {
                    _this._persistedSelection = null;
                    _this._persistedSelectionMatch = null;
                    renderer.setTrackedPath(null);
                    _this._throttledPersistSelection(rendererID, id);
                  }
                }
              });
              agent_defineProperty(agent_assertThisInitialized(_this), "logElementToConsole", function(_ref9) {
                var id = _ref9.id, rendererID = _ref9.rendererID;
                var renderer = _this._rendererInterfaces[rendererID];
                if (renderer == null) {
                  console.warn('Invalid renderer id "'.concat(rendererID, '" for element "').concat(id, '"'));
                } else {
                  renderer.logElementToConsole(id);
                }
              });
              agent_defineProperty(agent_assertThisInitialized(_this), "overrideError", function(_ref10) {
                var id = _ref10.id, rendererID = _ref10.rendererID, forceError = _ref10.forceError;
                var renderer = _this._rendererInterfaces[rendererID];
                if (renderer == null) {
                  console.warn('Invalid renderer id "'.concat(rendererID, '" for element "').concat(id, '"'));
                } else {
                  renderer.overrideError(id, forceError);
                }
              });
              agent_defineProperty(agent_assertThisInitialized(_this), "overrideSuspense", function(_ref11) {
                var id = _ref11.id, rendererID = _ref11.rendererID, forceFallback = _ref11.forceFallback;
                var renderer = _this._rendererInterfaces[rendererID];
                if (renderer == null) {
                  console.warn('Invalid renderer id "'.concat(rendererID, '" for element "').concat(id, '"'));
                } else {
                  renderer.overrideSuspense(id, forceFallback);
                }
              });
              agent_defineProperty(agent_assertThisInitialized(_this), "overrideValueAtPath", function(_ref12) {
                var hookID = _ref12.hookID, id = _ref12.id, path2 = _ref12.path, rendererID = _ref12.rendererID, type3 = _ref12.type, value = _ref12.value;
                var renderer = _this._rendererInterfaces[rendererID];
                if (renderer == null) {
                  console.warn('Invalid renderer id "'.concat(rendererID, '" for element "').concat(id, '"'));
                } else {
                  renderer.overrideValueAtPath(type3, id, hookID, path2, value);
                }
              });
              agent_defineProperty(agent_assertThisInitialized(_this), "overrideContext", function(_ref13) {
                var id = _ref13.id, path2 = _ref13.path, rendererID = _ref13.rendererID, wasForwarded = _ref13.wasForwarded, value = _ref13.value;
                if (!wasForwarded) {
                  _this.overrideValueAtPath({
                    id,
                    path: path2,
                    rendererID,
                    type: "context",
                    value
                  });
                }
              });
              agent_defineProperty(agent_assertThisInitialized(_this), "overrideHookState", function(_ref14) {
                var id = _ref14.id, hookID = _ref14.hookID, path2 = _ref14.path, rendererID = _ref14.rendererID, wasForwarded = _ref14.wasForwarded, value = _ref14.value;
                if (!wasForwarded) {
                  _this.overrideValueAtPath({
                    id,
                    path: path2,
                    rendererID,
                    type: "hooks",
                    value
                  });
                }
              });
              agent_defineProperty(agent_assertThisInitialized(_this), "overrideProps", function(_ref15) {
                var id = _ref15.id, path2 = _ref15.path, rendererID = _ref15.rendererID, wasForwarded = _ref15.wasForwarded, value = _ref15.value;
                if (!wasForwarded) {
                  _this.overrideValueAtPath({
                    id,
                    path: path2,
                    rendererID,
                    type: "props",
                    value
                  });
                }
              });
              agent_defineProperty(agent_assertThisInitialized(_this), "overrideState", function(_ref16) {
                var id = _ref16.id, path2 = _ref16.path, rendererID = _ref16.rendererID, wasForwarded = _ref16.wasForwarded, value = _ref16.value;
                if (!wasForwarded) {
                  _this.overrideValueAtPath({
                    id,
                    path: path2,
                    rendererID,
                    type: "state",
                    value
                  });
                }
              });
              agent_defineProperty(agent_assertThisInitialized(_this), "reloadAndProfile", function(recordChangeDescriptions) {
                Object(storage["e"])(constants["h"], "true");
                Object(storage["e"])(constants["g"], recordChangeDescriptions ? "true" : "false");
                _this._bridge.send("reloadAppForProfiling");
              });
              agent_defineProperty(agent_assertThisInitialized(_this), "renamePath", function(_ref17) {
                var hookID = _ref17.hookID, id = _ref17.id, newPath = _ref17.newPath, oldPath = _ref17.oldPath, rendererID = _ref17.rendererID, type3 = _ref17.type;
                var renderer = _this._rendererInterfaces[rendererID];
                if (renderer == null) {
                  console.warn('Invalid renderer id "'.concat(rendererID, '" for element "').concat(id, '"'));
                } else {
                  renderer.renamePath(type3, id, hookID, oldPath, newPath);
                }
              });
              agent_defineProperty(agent_assertThisInitialized(_this), "setTraceUpdatesEnabled", function(traceUpdatesEnabled) {
                _this._traceUpdatesEnabled = traceUpdatesEnabled;
                toggleEnabled(traceUpdatesEnabled);
                for (var rendererID in _this._rendererInterfaces) {
                  var renderer = _this._rendererInterfaces[rendererID];
                  renderer.setTraceUpdatesEnabled(traceUpdatesEnabled);
                }
              });
              agent_defineProperty(agent_assertThisInitialized(_this), "syncSelectionFromNativeElementsPanel", function() {
                var target = window.__REACT_DEVTOOLS_GLOBAL_HOOK__.$0;
                if (target == null) {
                  return;
                }
                _this.selectNode(target);
              });
              agent_defineProperty(agent_assertThisInitialized(_this), "shutdown", function() {
                _this.emit("shutdown");
              });
              agent_defineProperty(agent_assertThisInitialized(_this), "startProfiling", function(recordChangeDescriptions) {
                _this._recordChangeDescriptions = recordChangeDescriptions;
                _this._isProfiling = true;
                for (var rendererID in _this._rendererInterfaces) {
                  var renderer = _this._rendererInterfaces[rendererID];
                  renderer.startProfiling(recordChangeDescriptions);
                }
                _this._bridge.send("profilingStatus", _this._isProfiling);
              });
              agent_defineProperty(agent_assertThisInitialized(_this), "stopProfiling", function() {
                _this._isProfiling = false;
                _this._recordChangeDescriptions = false;
                for (var rendererID in _this._rendererInterfaces) {
                  var renderer = _this._rendererInterfaces[rendererID];
                  renderer.stopProfiling();
                }
                _this._bridge.send("profilingStatus", _this._isProfiling);
              });
              agent_defineProperty(agent_assertThisInitialized(_this), "storeAsGlobal", function(_ref18) {
                var count = _ref18.count, id = _ref18.id, path2 = _ref18.path, rendererID = _ref18.rendererID;
                var renderer = _this._rendererInterfaces[rendererID];
                if (renderer == null) {
                  console.warn('Invalid renderer id "'.concat(rendererID, '" for element "').concat(id, '"'));
                } else {
                  renderer.storeAsGlobal(id, path2, count);
                }
              });
              agent_defineProperty(agent_assertThisInitialized(_this), "updateConsolePatchSettings", function(_ref19) {
                var appendComponentStack = _ref19.appendComponentStack, breakOnConsoleErrors = _ref19.breakOnConsoleErrors, showInlineWarningsAndErrors = _ref19.showInlineWarningsAndErrors, hideConsoleLogsInStrictMode = _ref19.hideConsoleLogsInStrictMode, browserTheme = _ref19.browserTheme;
                Object(backend_console["a"])({
                  appendComponentStack,
                  breakOnConsoleErrors,
                  showInlineWarningsAndErrors,
                  hideConsoleLogsInStrictMode,
                  browserTheme
                });
              });
              agent_defineProperty(agent_assertThisInitialized(_this), "updateComponentFilters", function(componentFilters) {
                for (var rendererID in _this._rendererInterfaces) {
                  var renderer = _this._rendererInterfaces[rendererID];
                  renderer.updateComponentFilters(componentFilters);
                }
              });
              agent_defineProperty(agent_assertThisInitialized(_this), "viewAttributeSource", function(_ref20) {
                var id = _ref20.id, path2 = _ref20.path, rendererID = _ref20.rendererID;
                var renderer = _this._rendererInterfaces[rendererID];
                if (renderer == null) {
                  console.warn('Invalid renderer id "'.concat(rendererID, '" for element "').concat(id, '"'));
                } else {
                  renderer.prepareViewAttributeSource(id, path2);
                }
              });
              agent_defineProperty(agent_assertThisInitialized(_this), "viewElementSource", function(_ref21) {
                var id = _ref21.id, rendererID = _ref21.rendererID;
                var renderer = _this._rendererInterfaces[rendererID];
                if (renderer == null) {
                  console.warn('Invalid renderer id "'.concat(rendererID, '" for element "').concat(id, '"'));
                } else {
                  renderer.prepareViewElementSource(id);
                }
              });
              agent_defineProperty(agent_assertThisInitialized(_this), "onTraceUpdates", function(nodes) {
                _this.emit("traceUpdates", nodes);
              });
              agent_defineProperty(agent_assertThisInitialized(_this), "onFastRefreshScheduled", function() {
                if (constants["o"]) {
                  agent_debug("onFastRefreshScheduled");
                }
                _this._bridge.send("fastRefreshScheduled");
              });
              agent_defineProperty(agent_assertThisInitialized(_this), "onHookOperations", function(operations) {
                if (constants["o"]) {
                  agent_debug("onHookOperations", "(".concat(operations.length, ") [").concat(operations.join(", "), "]"));
                }
                _this._bridge.send("operations", operations);
                if (_this._persistedSelection !== null) {
                  var rendererID = operations[0];
                  if (_this._persistedSelection.rendererID === rendererID) {
                    var renderer = _this._rendererInterfaces[rendererID];
                    if (renderer == null) {
                      console.warn('Invalid renderer id "'.concat(rendererID, '"'));
                    } else {
                      var prevMatch = _this._persistedSelectionMatch;
                      var nextMatch = renderer.getBestMatchForTrackedPath();
                      _this._persistedSelectionMatch = nextMatch;
                      var prevMatchID = prevMatch !== null ? prevMatch.id : null;
                      var nextMatchID = nextMatch !== null ? nextMatch.id : null;
                      if (prevMatchID !== nextMatchID) {
                        if (nextMatchID !== null) {
                          _this._bridge.send("selectFiber", nextMatchID);
                        }
                      }
                      if (nextMatch !== null && nextMatch.isFullMatch) {
                        _this._persistedSelection = null;
                        _this._persistedSelectionMatch = null;
                        renderer.setTrackedPath(null);
                      }
                    }
                  }
                }
              });
              agent_defineProperty(agent_assertThisInitialized(_this), "_throttledPersistSelection", lodash_throttle_default()(function(rendererID, id) {
                var renderer = _this._rendererInterfaces[rendererID];
                var path2 = renderer != null ? renderer.getPathForElement(id) : null;
                if (path2 !== null) {
                  Object(storage["e"])(constants["f"], JSON.stringify({
                    rendererID,
                    path: path2
                  }));
                } else {
                  Object(storage["d"])(constants["f"]);
                }
              }, 1e3));
              if (Object(storage["c"])(constants["h"]) === "true") {
                _this._recordChangeDescriptions = Object(storage["c"])(constants["g"]) === "true";
                _this._isProfiling = true;
                Object(storage["d"])(constants["g"]);
                Object(storage["d"])(constants["h"]);
              }
              var persistedSelectionString = Object(storage["c"])(constants["f"]);
              if (persistedSelectionString != null) {
                _this._persistedSelection = JSON.parse(persistedSelectionString);
              }
              _this._bridge = bridge;
              bridge.addListener("clearErrorsAndWarnings", _this.clearErrorsAndWarnings);
              bridge.addListener("clearErrorsForFiberID", _this.clearErrorsForFiberID);
              bridge.addListener("clearWarningsForFiberID", _this.clearWarningsForFiberID);
              bridge.addListener("copyElementPath", _this.copyElementPath);
              bridge.addListener("deletePath", _this.deletePath);
              bridge.addListener("getBridgeProtocol", _this.getBridgeProtocol);
              bridge.addListener("getProfilingData", _this.getProfilingData);
              bridge.addListener("getProfilingStatus", _this.getProfilingStatus);
              bridge.addListener("getOwnersList", _this.getOwnersList);
              bridge.addListener("inspectElement", _this.inspectElement);
              bridge.addListener("logElementToConsole", _this.logElementToConsole);
              bridge.addListener("overrideError", _this.overrideError);
              bridge.addListener("overrideSuspense", _this.overrideSuspense);
              bridge.addListener("overrideValueAtPath", _this.overrideValueAtPath);
              bridge.addListener("reloadAndProfile", _this.reloadAndProfile);
              bridge.addListener("renamePath", _this.renamePath);
              bridge.addListener("setTraceUpdatesEnabled", _this.setTraceUpdatesEnabled);
              bridge.addListener("startProfiling", _this.startProfiling);
              bridge.addListener("stopProfiling", _this.stopProfiling);
              bridge.addListener("storeAsGlobal", _this.storeAsGlobal);
              bridge.addListener("syncSelectionFromNativeElementsPanel", _this.syncSelectionFromNativeElementsPanel);
              bridge.addListener("shutdown", _this.shutdown);
              bridge.addListener("updateConsolePatchSettings", _this.updateConsolePatchSettings);
              bridge.addListener("updateComponentFilters", _this.updateComponentFilters);
              bridge.addListener("viewAttributeSource", _this.viewAttributeSource);
              bridge.addListener("viewElementSource", _this.viewElementSource);
              bridge.addListener("overrideContext", _this.overrideContext);
              bridge.addListener("overrideHookState", _this.overrideHookState);
              bridge.addListener("overrideProps", _this.overrideProps);
              bridge.addListener("overrideState", _this.overrideState);
              if (_this._isProfiling) {
                bridge.send("profilingStatus", true);
              }
              var isBackendStorageAPISupported = false;
              try {
                localStorage.getItem("test");
                isBackendStorageAPISupported = true;
              } catch (error) {
              }
              bridge.send("isBackendStorageAPISupported", isBackendStorageAPISupported);
              bridge.send("isSynchronousXHRSupported", Object(utils["h"])());
              setupHighlighter(bridge, agent_assertThisInitialized(_this));
              TraceUpdates_initialize(agent_assertThisInitialized(_this));
              return _this;
            }
            agent_createClass(Agent, [{
              key: "getInstanceAndStyle",
              value: function getInstanceAndStyle(_ref22) {
                var id = _ref22.id, rendererID = _ref22.rendererID;
                var renderer = this._rendererInterfaces[rendererID];
                if (renderer == null) {
                  console.warn('Invalid renderer id "'.concat(rendererID, '"'));
                  return null;
                }
                return renderer.getInstanceAndStyle(id);
              }
            }, {
              key: "getIDForNode",
              value: function getIDForNode(node) {
                for (var rendererID in this._rendererInterfaces) {
                  var renderer = this._rendererInterfaces[rendererID];
                  try {
                    var id = renderer.getFiberIDForNative(node, true);
                    if (id !== null) {
                      return id;
                    }
                  } catch (error) {
                  }
                }
                return null;
              }
            }, {
              key: "selectNode",
              value: function selectNode(target) {
                var id = this.getIDForNode(target);
                if (id !== null) {
                  this._bridge.send("selectFiber", id);
                }
              }
            }, {
              key: "setRendererInterface",
              value: function setRendererInterface(rendererID, rendererInterface) {
                this._rendererInterfaces[rendererID] = rendererInterface;
                if (this._isProfiling) {
                  rendererInterface.startProfiling(this._recordChangeDescriptions);
                }
                rendererInterface.setTraceUpdatesEnabled(this._traceUpdatesEnabled);
                var selection = this._persistedSelection;
                if (selection !== null && selection.rendererID === rendererID) {
                  rendererInterface.setTrackedPath(selection.path);
                }
              }
            }, {
              key: "onUnsupportedRenderer",
              value: function onUnsupportedRenderer(rendererID) {
                this._bridge.send("unsupportedRendererVersion", rendererID);
              }
            }, {
              key: "rendererInterfaces",
              get: function get() {
                return this._rendererInterfaces;
              }
            }]);
            return Agent;
          }(EventEmitter);
          var DevToolsFeatureFlags_core_oss = __webpack_require__(9);
          function hook_typeof(obj) {
            "@babel/helpers - typeof";
            if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
              hook_typeof = function _typeof2(obj2) {
                return typeof obj2;
              };
            } else {
              hook_typeof = function _typeof2(obj2) {
                return obj2 && typeof Symbol === "function" && obj2.constructor === Symbol && obj2 !== Symbol.prototype ? "symbol" : typeof obj2;
              };
            }
            return hook_typeof(obj);
          }
          function installHook(target) {
            if (target.hasOwnProperty("__REACT_DEVTOOLS_GLOBAL_HOOK__")) {
              return null;
            }
            function detectReactBuildType(renderer) {
              try {
                if (typeof renderer.version === "string") {
                  if (renderer.bundleType > 0) {
                    return "development";
                  }
                  return "production";
                }
                var _toString2 = Function.prototype.toString;
                if (renderer.Mount && renderer.Mount._renderNewRootComponent) {
                  var renderRootCode = _toString2.call(renderer.Mount._renderNewRootComponent);
                  if (renderRootCode.indexOf("function") !== 0) {
                    return "production";
                  }
                  if (renderRootCode.indexOf("storedMeasure") !== -1) {
                    return "development";
                  }
                  if (renderRootCode.indexOf("should be a pure function") !== -1) {
                    if (renderRootCode.indexOf("NODE_ENV") !== -1) {
                      return "development";
                    }
                    if (renderRootCode.indexOf("development") !== -1) {
                      return "development";
                    }
                    if (renderRootCode.indexOf("true") !== -1) {
                      return "development";
                    }
                    if (renderRootCode.indexOf("nextElement") !== -1 || renderRootCode.indexOf("nextComponent") !== -1) {
                      return "unminified";
                    } else {
                      return "development";
                    }
                  }
                  if (renderRootCode.indexOf("nextElement") !== -1 || renderRootCode.indexOf("nextComponent") !== -1) {
                    return "unminified";
                  }
                  return "outdated";
                }
              } catch (err2) {
              }
              return "production";
            }
            function checkDCE(fn) {
              try {
                var _toString2 = Function.prototype.toString;
                var code = _toString2.call(fn);
                if (code.indexOf("^_^") > -1) {
                  hasDetectedBadDCE = true;
                  setTimeout(function() {
                    throw new Error("React is running in production mode, but dead code elimination has not been applied. Read how to correctly configure React for production: https://reactjs.org/link/perf-use-production-build");
                  });
                }
              } catch (err2) {
              }
            }
            function format(maybeMessage) {
              if (DevToolsFeatureFlags_core_oss["a"]) {
                for (var _len = arguments.length, inputArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
                  inputArgs[_key - 1] = arguments[_key];
                }
                var args = inputArgs.slice();
                var formatted = hook_typeof(maybeMessage) === "symbol" ? maybeMessage.toString() : "" + maybeMessage;
                if (typeof maybeMessage === "string") {
                  if (args.length) {
                    var REGEXP = /(%?)(%([jds]))/g;
                    formatted = formatted.replace(REGEXP, function(match, escaped, ptn, flag) {
                      var arg3 = args.shift();
                      switch (flag) {
                        case "s":
                          arg3 += "";
                          break;
                        case "d":
                        case "i":
                          arg3 = parseInt(arg3, 10).toString();
                          break;
                        case "f":
                          arg3 = parseFloat(arg3).toString();
                          break;
                      }
                      if (!escaped) {
                        return arg3;
                      }
                      args.unshift(arg3);
                      return match;
                    });
                  }
                }
                if (args.length) {
                  for (var i3 = 0; i3 < args.length; i3++) {
                    var arg2 = args[i3];
                    formatted += " " + (hook_typeof(arg2) === "symbol" ? arg2.toString() : arg2);
                  }
                }
                formatted = formatted.replace(/%{2,2}/g, "%");
                return "" + formatted;
              }
              return "";
            }
            function patchConsoleForInitialRenderInExtension(renderer, _ref) {
              var hideConsoleLogsInStrictMode = _ref.hideConsoleLogsInStrictMode, browserTheme = _ref.browserTheme;
              if (DevToolsFeatureFlags_core_oss["a"]) {
                var overrideConsoleMethods = ["error", "trace", "warn", "log"];
                if (false) {
                  var originalConsoleMethods, targetConsole;
                }
              }
            }
            var uidCounter = 0;
            function inject(renderer) {
              var id = ++uidCounter;
              renderers.set(id, renderer);
              var reactBuildType = hasDetectedBadDCE ? "deadcode" : detectReactBuildType(renderer);
              if (true) {
                try {
                  var appendComponentStack = window.__REACT_DEVTOOLS_APPEND_COMPONENT_STACK__ !== false;
                  var breakOnConsoleErrors = window.__REACT_DEVTOOLS_BREAK_ON_CONSOLE_ERRORS__ === true;
                  var showInlineWarningsAndErrors = window.__REACT_DEVTOOLS_SHOW_INLINE_WARNINGS_AND_ERRORS__ !== false;
                  var hideConsoleLogsInStrictMode = window.__REACT_DEVTOOLS_HIDE_CONSOLE_LOGS_IN_STRICT_MODE__ === true;
                  var browserTheme = window.__REACT_DEVTOOLS_BROWSER_THEME__;
                  if (true) {
                    Object(backend_console["b"])(renderer);
                    Object(backend_console["a"])({
                      appendComponentStack,
                      breakOnConsoleErrors,
                      showInlineWarningsAndErrors,
                      hideConsoleLogsInStrictMode,
                      browserTheme
                    });
                  } else {
                  }
                } catch (error) {
                }
              }
              var attach = target.__REACT_DEVTOOLS_ATTACH__;
              if (typeof attach === "function") {
                var rendererInterface = attach(hook, id, renderer, target);
                hook.rendererInterfaces.set(id, rendererInterface);
              }
              hook.emit("renderer", {
                id,
                renderer,
                reactBuildType
              });
              return id;
            }
            var hasDetectedBadDCE = false;
            function sub(event2, fn) {
              hook.on(event2, fn);
              return function() {
                return hook.off(event2, fn);
              };
            }
            function on(event2, fn) {
              if (!listeners[event2]) {
                listeners[event2] = [];
              }
              listeners[event2].push(fn);
            }
            function off(event2, fn) {
              if (!listeners[event2]) {
                return;
              }
              var index = listeners[event2].indexOf(fn);
              if (index !== -1) {
                listeners[event2].splice(index, 1);
              }
              if (!listeners[event2].length) {
                delete listeners[event2];
              }
            }
            function emit(event2, data) {
              if (listeners[event2]) {
                listeners[event2].map(function(fn) {
                  return fn(data);
                });
              }
            }
            function getFiberRoots(rendererID) {
              var roots = fiberRoots;
              if (!roots[rendererID]) {
                roots[rendererID] = /* @__PURE__ */ new Set();
              }
              return roots[rendererID];
            }
            function onCommitFiberUnmount(rendererID, fiber) {
              var rendererInterface = rendererInterfaces.get(rendererID);
              if (rendererInterface != null) {
                rendererInterface.handleCommitFiberUnmount(fiber);
              }
            }
            function onCommitFiberRoot(rendererID, root, priorityLevel) {
              var mountedRoots = hook.getFiberRoots(rendererID);
              var current = root.current;
              var isKnownRoot = mountedRoots.has(root);
              var isUnmounting = current.memoizedState == null || current.memoizedState.element == null;
              if (!isKnownRoot && !isUnmounting) {
                mountedRoots.add(root);
              } else if (isKnownRoot && isUnmounting) {
                mountedRoots.delete(root);
              }
              var rendererInterface = rendererInterfaces.get(rendererID);
              if (rendererInterface != null) {
                rendererInterface.handleCommitFiberRoot(root, priorityLevel);
              }
            }
            function onPostCommitFiberRoot(rendererID, root) {
              var rendererInterface = rendererInterfaces.get(rendererID);
              if (rendererInterface != null) {
                rendererInterface.handlePostCommitFiberRoot(root);
              }
            }
            var fiberRoots = {};
            var rendererInterfaces = /* @__PURE__ */ new Map();
            var listeners = {};
            var renderers = /* @__PURE__ */ new Map();
            var hook = {
              rendererInterfaces,
              listeners,
              renderers,
              emit,
              getFiberRoots,
              inject,
              on,
              off,
              sub,
              supportsFiber: true,
              checkDCE,
              onCommitFiberUnmount,
              onCommitFiberRoot,
              onPostCommitFiberRoot
            };
            Object.defineProperty(target, "__REACT_DEVTOOLS_GLOBAL_HOOK__", {
              configurable: false,
              enumerable: false,
              get: function get() {
                return hook;
              }
            });
            return hook;
          }
          var backend_renderer = __webpack_require__(15);
          var types2 = __webpack_require__(1);
          var src_utils = __webpack_require__(2);
          function decorate(object, attr, fn) {
            var old = object[attr];
            object[attr] = function(instance) {
              return fn.call(this, old, arguments);
            };
            return old;
          }
          function decorateMany(source, fns) {
            var olds = {};
            for (var name in fns) {
              olds[name] = decorate(source, name, fns[name]);
            }
            return olds;
          }
          function restoreMany(source, olds) {
            for (var name in olds) {
              source[name] = olds[name];
            }
          }
          function forceUpdate(instance) {
            if (typeof instance.forceUpdate === "function") {
              instance.forceUpdate();
            } else if (instance.updater != null && typeof instance.updater.enqueueForceUpdate === "function") {
              instance.updater.enqueueForceUpdate(this, function() {
              }, "forceUpdate");
            }
          }
          function ownKeys(object, enumerableOnly) {
            var keys = Object.keys(object);
            if (Object.getOwnPropertySymbols) {
              var symbols = Object.getOwnPropertySymbols(object);
              if (enumerableOnly)
                symbols = symbols.filter(function(sym) {
                  return Object.getOwnPropertyDescriptor(object, sym).enumerable;
                });
              keys.push.apply(keys, symbols);
            }
            return keys;
          }
          function _objectSpread(target) {
            for (var i3 = 1; i3 < arguments.length; i3++) {
              var source = arguments[i3] != null ? arguments[i3] : {};
              if (i3 % 2) {
                ownKeys(Object(source), true).forEach(function(key2) {
                  renderer_defineProperty(target, key2, source[key2]);
                });
              } else if (Object.getOwnPropertyDescriptors) {
                Object.defineProperties(target, Object.getOwnPropertyDescriptors(source));
              } else {
                ownKeys(Object(source)).forEach(function(key2) {
                  Object.defineProperty(target, key2, Object.getOwnPropertyDescriptor(source, key2));
                });
              }
            }
            return target;
          }
          function renderer_defineProperty(obj, key2, value) {
            if (key2 in obj) {
              Object.defineProperty(obj, key2, { value, enumerable: true, configurable: true, writable: true });
            } else {
              obj[key2] = value;
            }
            return obj;
          }
          function renderer_typeof(obj) {
            "@babel/helpers - typeof";
            if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
              renderer_typeof = function _typeof2(obj2) {
                return typeof obj2;
              };
            } else {
              renderer_typeof = function _typeof2(obj2) {
                return obj2 && typeof Symbol === "function" && obj2.constructor === Symbol && obj2 !== Symbol.prototype ? "symbol" : typeof obj2;
              };
            }
            return renderer_typeof(obj);
          }
          function getData(internalInstance) {
            var displayName = null;
            var key2 = null;
            if (internalInstance._currentElement != null) {
              if (internalInstance._currentElement.key) {
                key2 = "" + internalInstance._currentElement.key;
              }
              var elementType = internalInstance._currentElement.type;
              if (typeof elementType === "string") {
                displayName = elementType;
              } else if (typeof elementType === "function") {
                displayName = Object(src_utils["f"])(elementType);
              }
            }
            return {
              displayName,
              key: key2
            };
          }
          function getElementType(internalInstance) {
            if (internalInstance._currentElement != null) {
              var elementType = internalInstance._currentElement.type;
              if (typeof elementType === "function") {
                var publicInstance = internalInstance.getPublicInstance();
                if (publicInstance !== null) {
                  return types2["e"];
                } else {
                  return types2["h"];
                }
              } else if (typeof elementType === "string") {
                return types2["i"];
              }
            }
            return types2["k"];
          }
          function getChildren(internalInstance) {
            var children = [];
            if (renderer_typeof(internalInstance) !== "object") {
            } else if (internalInstance._currentElement === null || internalInstance._currentElement === false) {
            } else if (internalInstance._renderedComponent) {
              var child = internalInstance._renderedComponent;
              if (getElementType(child) !== types2["k"]) {
                children.push(child);
              }
            } else if (internalInstance._renderedChildren) {
              var renderedChildren = internalInstance._renderedChildren;
              for (var name in renderedChildren) {
                var _child = renderedChildren[name];
                if (getElementType(_child) !== types2["k"]) {
                  children.push(_child);
                }
              }
            }
            return children;
          }
          function renderer_attach(hook, rendererID, renderer, global2) {
            var idToInternalInstanceMap = /* @__PURE__ */ new Map();
            var internalInstanceToIDMap = new WeakMap();
            var internalInstanceToRootIDMap = new WeakMap();
            var getInternalIDForNative = null;
            var findNativeNodeForInternalID;
            if (renderer.ComponentTree) {
              getInternalIDForNative = function getInternalIDForNative2(node, findNearestUnfilteredAncestor) {
                var internalInstance = renderer.ComponentTree.getClosestInstanceFromNode(node);
                return internalInstanceToIDMap.get(internalInstance) || null;
              };
              findNativeNodeForInternalID = function findNativeNodeForInternalID2(id) {
                var internalInstance = idToInternalInstanceMap.get(id);
                return renderer.ComponentTree.getNodeFromInstance(internalInstance);
              };
            } else if (renderer.Mount.getID && renderer.Mount.getNode) {
              getInternalIDForNative = function getInternalIDForNative2(node, findNearestUnfilteredAncestor) {
                return null;
              };
              findNativeNodeForInternalID = function findNativeNodeForInternalID2(id) {
                return null;
              };
            }
            function getDisplayNameForFiberID(id) {
              var internalInstance = idToInternalInstanceMap.get(id);
              return internalInstance ? getData(internalInstance).displayName : null;
            }
            function getID(internalInstance) {
              if (renderer_typeof(internalInstance) !== "object" || internalInstance === null) {
                throw new Error("Invalid internal instance: " + internalInstance);
              }
              if (!internalInstanceToIDMap.has(internalInstance)) {
                var _id = Object(src_utils["i"])();
                internalInstanceToIDMap.set(internalInstance, _id);
                idToInternalInstanceMap.set(_id, internalInstance);
              }
              return internalInstanceToIDMap.get(internalInstance);
            }
            function areEqualArrays(a2, b2) {
              if (a2.length !== b2.length) {
                return false;
              }
              for (var i3 = 0; i3 < a2.length; i3++) {
                if (a2[i3] !== b2[i3]) {
                  return false;
                }
              }
              return true;
            }
            var parentIDStack = [];
            var oldReconcilerMethods = null;
            if (renderer.Reconciler) {
              oldReconcilerMethods = decorateMany(renderer.Reconciler, {
                mountComponent: function mountComponent(fn, args) {
                  var internalInstance = args[0];
                  var hostContainerInfo = args[3];
                  if (getElementType(internalInstance) === types2["k"]) {
                    return fn.apply(this, args);
                  }
                  if (hostContainerInfo._topLevelWrapper === void 0) {
                    return fn.apply(this, args);
                  }
                  var id = getID(internalInstance);
                  var parentID = parentIDStack.length > 0 ? parentIDStack[parentIDStack.length - 1] : 0;
                  recordMount(internalInstance, id, parentID);
                  parentIDStack.push(id);
                  internalInstanceToRootIDMap.set(internalInstance, getID(hostContainerInfo._topLevelWrapper));
                  try {
                    var result2 = fn.apply(this, args);
                    parentIDStack.pop();
                    return result2;
                  } catch (err2) {
                    parentIDStack = [];
                    throw err2;
                  } finally {
                    if (parentIDStack.length === 0) {
                      var rootID = internalInstanceToRootIDMap.get(internalInstance);
                      if (rootID === void 0) {
                        throw new Error("Expected to find root ID.");
                      }
                      flushPendingEvents(rootID);
                    }
                  }
                },
                performUpdateIfNecessary: function performUpdateIfNecessary(fn, args) {
                  var internalInstance = args[0];
                  if (getElementType(internalInstance) === types2["k"]) {
                    return fn.apply(this, args);
                  }
                  var id = getID(internalInstance);
                  parentIDStack.push(id);
                  var prevChildren = getChildren(internalInstance);
                  try {
                    var result2 = fn.apply(this, args);
                    var nextChildren = getChildren(internalInstance);
                    if (!areEqualArrays(prevChildren, nextChildren)) {
                      recordReorder(internalInstance, id, nextChildren);
                    }
                    parentIDStack.pop();
                    return result2;
                  } catch (err2) {
                    parentIDStack = [];
                    throw err2;
                  } finally {
                    if (parentIDStack.length === 0) {
                      var rootID = internalInstanceToRootIDMap.get(internalInstance);
                      if (rootID === void 0) {
                        throw new Error("Expected to find root ID.");
                      }
                      flushPendingEvents(rootID);
                    }
                  }
                },
                receiveComponent: function receiveComponent(fn, args) {
                  var internalInstance = args[0];
                  if (getElementType(internalInstance) === types2["k"]) {
                    return fn.apply(this, args);
                  }
                  var id = getID(internalInstance);
                  parentIDStack.push(id);
                  var prevChildren = getChildren(internalInstance);
                  try {
                    var result2 = fn.apply(this, args);
                    var nextChildren = getChildren(internalInstance);
                    if (!areEqualArrays(prevChildren, nextChildren)) {
                      recordReorder(internalInstance, id, nextChildren);
                    }
                    parentIDStack.pop();
                    return result2;
                  } catch (err2) {
                    parentIDStack = [];
                    throw err2;
                  } finally {
                    if (parentIDStack.length === 0) {
                      var rootID = internalInstanceToRootIDMap.get(internalInstance);
                      if (rootID === void 0) {
                        throw new Error("Expected to find root ID.");
                      }
                      flushPendingEvents(rootID);
                    }
                  }
                },
                unmountComponent: function unmountComponent(fn, args) {
                  var internalInstance = args[0];
                  if (getElementType(internalInstance) === types2["k"]) {
                    return fn.apply(this, args);
                  }
                  var id = getID(internalInstance);
                  parentIDStack.push(id);
                  try {
                    var result2 = fn.apply(this, args);
                    parentIDStack.pop();
                    recordUnmount(internalInstance, id);
                    return result2;
                  } catch (err2) {
                    parentIDStack = [];
                    throw err2;
                  } finally {
                    if (parentIDStack.length === 0) {
                      var rootID = internalInstanceToRootIDMap.get(internalInstance);
                      if (rootID === void 0) {
                        throw new Error("Expected to find root ID.");
                      }
                      flushPendingEvents(rootID);
                    }
                  }
                }
              });
            }
            function cleanup() {
              if (oldReconcilerMethods !== null) {
                if (renderer.Component) {
                  restoreMany(renderer.Component.Mixin, oldReconcilerMethods);
                } else {
                  restoreMany(renderer.Reconciler, oldReconcilerMethods);
                }
              }
              oldReconcilerMethods = null;
            }
            function recordMount(internalInstance, id, parentID) {
              var isRoot = parentID === 0;
              if (constants["o"]) {
                console.log("%crecordMount()", "color: green; font-weight: bold;", id, getData(internalInstance).displayName);
              }
              if (isRoot) {
                var hasOwnerMetadata = internalInstance._currentElement != null && internalInstance._currentElement._owner != null;
                pushOperation(constants["i"]);
                pushOperation(id);
                pushOperation(types2["m"]);
                pushOperation(0);
                pushOperation(hasOwnerMetadata ? 1 : 0);
              } else {
                var type3 = getElementType(internalInstance);
                var _getData = getData(internalInstance), displayName = _getData.displayName, key2 = _getData.key;
                var ownerID = internalInstance._currentElement != null && internalInstance._currentElement._owner != null ? getID(internalInstance._currentElement._owner) : 0;
                var displayNameStringID = getStringID(displayName);
                var keyStringID = getStringID(key2);
                pushOperation(constants["i"]);
                pushOperation(id);
                pushOperation(type3);
                pushOperation(parentID);
                pushOperation(ownerID);
                pushOperation(displayNameStringID);
                pushOperation(keyStringID);
              }
            }
            function recordReorder(internalInstance, id, nextChildren) {
              pushOperation(constants["l"]);
              pushOperation(id);
              var nextChildIDs = nextChildren.map(getID);
              pushOperation(nextChildIDs.length);
              for (var i3 = 0; i3 < nextChildIDs.length; i3++) {
                pushOperation(nextChildIDs[i3]);
              }
            }
            function recordUnmount(internalInstance, id) {
              pendingUnmountedIDs.push(id);
              idToInternalInstanceMap.delete(id);
            }
            function crawlAndRecordInitialMounts(id, parentID, rootID) {
              if (constants["o"]) {
                console.group("crawlAndRecordInitialMounts() id:", id);
              }
              var internalInstance = idToInternalInstanceMap.get(id);
              if (internalInstance != null) {
                internalInstanceToRootIDMap.set(internalInstance, rootID);
                recordMount(internalInstance, id, parentID);
                getChildren(internalInstance).forEach(function(child) {
                  return crawlAndRecordInitialMounts(getID(child), id, rootID);
                });
              }
              if (constants["o"]) {
                console.groupEnd();
              }
            }
            function flushInitialOperations() {
              var roots = renderer.Mount._instancesByReactRootID || renderer.Mount._instancesByContainerID;
              for (var key2 in roots) {
                var internalInstance = roots[key2];
                var _id2 = getID(internalInstance);
                crawlAndRecordInitialMounts(_id2, 0, _id2);
                flushPendingEvents(_id2);
              }
            }
            var pendingOperations = [];
            var pendingStringTable = /* @__PURE__ */ new Map();
            var pendingUnmountedIDs = [];
            var pendingStringTableLength = 0;
            var pendingUnmountedRootID = null;
            function flushPendingEvents(rootID) {
              if (pendingOperations.length === 0 && pendingUnmountedIDs.length === 0 && pendingUnmountedRootID === null) {
                return;
              }
              var numUnmountIDs = pendingUnmountedIDs.length + (pendingUnmountedRootID === null ? 0 : 1);
              var operations = new Array(2 + 1 + pendingStringTableLength + (numUnmountIDs > 0 ? 2 + numUnmountIDs : 0) + pendingOperations.length);
              var i3 = 0;
              operations[i3++] = rendererID;
              operations[i3++] = rootID;
              operations[i3++] = pendingStringTableLength;
              pendingStringTable.forEach(function(value, key2) {
                operations[i3++] = key2.length;
                var encodedKey = Object(src_utils["m"])(key2);
                for (var j2 = 0; j2 < encodedKey.length; j2++) {
                  operations[i3 + j2] = encodedKey[j2];
                }
                i3 += key2.length;
              });
              if (numUnmountIDs > 0) {
                operations[i3++] = constants["j"];
                operations[i3++] = numUnmountIDs;
                for (var j = 0; j < pendingUnmountedIDs.length; j++) {
                  operations[i3++] = pendingUnmountedIDs[j];
                }
                if (pendingUnmountedRootID !== null) {
                  operations[i3] = pendingUnmountedRootID;
                  i3++;
                }
              }
              for (var _j = 0; _j < pendingOperations.length; _j++) {
                operations[i3 + _j] = pendingOperations[_j];
              }
              i3 += pendingOperations.length;
              if (constants["o"]) {
                Object(src_utils["j"])(operations);
              }
              hook.emit("operations", operations);
              pendingOperations.length = 0;
              pendingUnmountedIDs = [];
              pendingUnmountedRootID = null;
              pendingStringTable.clear();
              pendingStringTableLength = 0;
            }
            function pushOperation(op) {
              if (false) {
              }
              pendingOperations.push(op);
            }
            function getStringID(str2) {
              if (str2 === null) {
                return 0;
              }
              var existingID = pendingStringTable.get(str2);
              if (existingID !== void 0) {
                return existingID;
              }
              var stringID = pendingStringTable.size + 1;
              pendingStringTable.set(str2, stringID);
              pendingStringTableLength += str2.length + 1;
              return stringID;
            }
            var currentlyInspectedElementID = null;
            var currentlyInspectedPaths = {};
            function mergeInspectedPaths(path2) {
              var current = currentlyInspectedPaths;
              path2.forEach(function(key2) {
                if (!current[key2]) {
                  current[key2] = {};
                }
                current = current[key2];
              });
            }
            function createIsPathAllowed(key2) {
              return function isPathAllowed(path2) {
                var current = currentlyInspectedPaths[key2];
                if (!current) {
                  return false;
                }
                for (var i3 = 0; i3 < path2.length; i3++) {
                  current = current[path2[i3]];
                  if (!current) {
                    return false;
                  }
                }
                return true;
              };
            }
            function getInstanceAndStyle(id) {
              var instance = null;
              var style = null;
              var internalInstance = idToInternalInstanceMap.get(id);
              if (internalInstance != null) {
                instance = internalInstance._instance || null;
                var element = internalInstance._currentElement;
                if (element != null && element.props != null) {
                  style = element.props.style || null;
                }
              }
              return {
                instance,
                style
              };
            }
            function updateSelectedElement(id) {
              var internalInstance = idToInternalInstanceMap.get(id);
              if (internalInstance == null) {
                console.warn('Could not find instance with id "'.concat(id, '"'));
                return;
              }
              switch (getElementType(internalInstance)) {
                case types2["e"]:
                  global2.$r = internalInstance._instance;
                  break;
                case types2["h"]:
                  var element = internalInstance._currentElement;
                  if (element == null) {
                    console.warn('Could not find element with id "'.concat(id, '"'));
                    return;
                  }
                  global2.$r = {
                    props: element.props,
                    type: element.type
                  };
                  break;
                default:
                  global2.$r = null;
                  break;
              }
            }
            function storeAsGlobal(id, path2, count) {
              var inspectedElement = inspectElementRaw(id);
              if (inspectedElement !== null) {
                var value = Object(src_utils["h"])(inspectedElement, path2);
                var key2 = "$reactTemp".concat(count);
                window[key2] = value;
                console.log(key2);
                console.log(value);
              }
            }
            function copyElementPath(id, path2) {
              var inspectedElement = inspectElementRaw(id);
              if (inspectedElement !== null) {
                Object(utils["b"])(Object(src_utils["h"])(inspectedElement, path2));
              }
            }
            function inspectElement(requestID, id, path2) {
              if (currentlyInspectedElementID !== id) {
                currentlyInspectedElementID = id;
                currentlyInspectedPaths = {};
              }
              var inspectedElement = inspectElementRaw(id);
              if (inspectedElement === null) {
                return {
                  id,
                  responseID: requestID,
                  type: "not-found"
                };
              }
              if (path2 !== null) {
                mergeInspectedPaths(path2);
              }
              updateSelectedElement(id);
              inspectedElement.context = Object(utils["a"])(inspectedElement.context, createIsPathAllowed("context"));
              inspectedElement.props = Object(utils["a"])(inspectedElement.props, createIsPathAllowed("props"));
              inspectedElement.state = Object(utils["a"])(inspectedElement.state, createIsPathAllowed("state"));
              return {
                id,
                responseID: requestID,
                type: "full-data",
                value: inspectedElement
              };
            }
            function inspectElementRaw(id) {
              var internalInstance = idToInternalInstanceMap.get(id);
              if (internalInstance == null) {
                return null;
              }
              var _getData2 = getData(internalInstance), displayName = _getData2.displayName, key2 = _getData2.key;
              var type3 = getElementType(internalInstance);
              var context = null;
              var owners = null;
              var props = null;
              var state = null;
              var source = null;
              var element = internalInstance._currentElement;
              if (element !== null) {
                props = element.props;
                source = element._source != null ? element._source : null;
                var owner = element._owner;
                if (owner) {
                  owners = [];
                  while (owner != null) {
                    owners.push({
                      displayName: getData(owner).displayName || "Unknown",
                      id: getID(owner),
                      key: element.key,
                      type: getElementType(owner)
                    });
                    if (owner._currentElement) {
                      owner = owner._currentElement._owner;
                    }
                  }
                }
              }
              var publicInstance = internalInstance._instance;
              if (publicInstance != null) {
                context = publicInstance.context || null;
                state = publicInstance.state || null;
              }
              var errors = [];
              var warnings = [];
              return {
                id,
                canEditHooks: false,
                canEditFunctionProps: false,
                canEditHooksAndDeletePaths: false,
                canEditHooksAndRenamePaths: false,
                canEditFunctionPropsDeletePaths: false,
                canEditFunctionPropsRenamePaths: false,
                canToggleError: false,
                isErrored: false,
                targetErrorBoundaryID: null,
                canToggleSuspense: false,
                canViewSource: type3 === types2["e"] || type3 === types2["h"],
                hasLegacyContext: true,
                displayName,
                type: type3,
                key: key2 != null ? key2 : null,
                context,
                hooks: null,
                props,
                state,
                errors,
                warnings,
                owners,
                source,
                rootType: null,
                rendererPackageName: null,
                rendererVersion: null
              };
            }
            function logElementToConsole(id) {
              var result2 = inspectElementRaw(id);
              if (result2 === null) {
                console.warn('Could not find element with id "'.concat(id, '"'));
                return;
              }
              var supportsGroup = typeof console.groupCollapsed === "function";
              if (supportsGroup) {
                console.groupCollapsed("[Click to expand] %c<".concat(result2.displayName || "Component", " />"), "color: var(--dom-tag-name-color); font-weight: normal;");
              }
              if (result2.props !== null) {
                console.log("Props:", result2.props);
              }
              if (result2.state !== null) {
                console.log("State:", result2.state);
              }
              if (result2.context !== null) {
                console.log("Context:", result2.context);
              }
              var nativeNode = findNativeNodeForInternalID(id);
              if (nativeNode !== null) {
                console.log("Node:", nativeNode);
              }
              if (window.chrome || /firefox/i.test(navigator.userAgent)) {
                console.log("Right-click any value to save it as a global variable for further inspection.");
              }
              if (supportsGroup) {
                console.groupEnd();
              }
            }
            function prepareViewAttributeSource(id, path2) {
              var inspectedElement = inspectElementRaw(id);
              if (inspectedElement !== null) {
                window.$attribute = Object(src_utils["h"])(inspectedElement, path2);
              }
            }
            function prepareViewElementSource(id) {
              var internalInstance = idToInternalInstanceMap.get(id);
              if (internalInstance == null) {
                console.warn('Could not find instance with id "'.concat(id, '"'));
                return;
              }
              var element = internalInstance._currentElement;
              if (element == null) {
                console.warn('Could not find element with id "'.concat(id, '"'));
                return;
              }
              global2.$type = element.type;
            }
            function deletePath(type3, id, hookID, path2) {
              var internalInstance = idToInternalInstanceMap.get(id);
              if (internalInstance != null) {
                var publicInstance = internalInstance._instance;
                if (publicInstance != null) {
                  switch (type3) {
                    case "context":
                      Object(src_utils["a"])(publicInstance.context, path2);
                      forceUpdate(publicInstance);
                      break;
                    case "hooks":
                      throw new Error("Hooks not supported by this renderer");
                    case "props":
                      var element = internalInstance._currentElement;
                      internalInstance._currentElement = _objectSpread(_objectSpread({}, element), {}, {
                        props: Object(utils["c"])(element.props, path2)
                      });
                      forceUpdate(publicInstance);
                      break;
                    case "state":
                      Object(src_utils["a"])(publicInstance.state, path2);
                      forceUpdate(publicInstance);
                      break;
                  }
                }
              }
            }
            function renamePath(type3, id, hookID, oldPath, newPath) {
              var internalInstance = idToInternalInstanceMap.get(id);
              if (internalInstance != null) {
                var publicInstance = internalInstance._instance;
                if (publicInstance != null) {
                  switch (type3) {
                    case "context":
                      Object(src_utils["k"])(publicInstance.context, oldPath, newPath);
                      forceUpdate(publicInstance);
                      break;
                    case "hooks":
                      throw new Error("Hooks not supported by this renderer");
                    case "props":
                      var element = internalInstance._currentElement;
                      internalInstance._currentElement = _objectSpread(_objectSpread({}, element), {}, {
                        props: Object(utils["d"])(element.props, oldPath, newPath)
                      });
                      forceUpdate(publicInstance);
                      break;
                    case "state":
                      Object(src_utils["k"])(publicInstance.state, oldPath, newPath);
                      forceUpdate(publicInstance);
                      break;
                  }
                }
              }
            }
            function overrideValueAtPath(type3, id, hookID, path2, value) {
              var internalInstance = idToInternalInstanceMap.get(id);
              if (internalInstance != null) {
                var publicInstance = internalInstance._instance;
                if (publicInstance != null) {
                  switch (type3) {
                    case "context":
                      Object(src_utils["l"])(publicInstance.context, path2, value);
                      forceUpdate(publicInstance);
                      break;
                    case "hooks":
                      throw new Error("Hooks not supported by this renderer");
                    case "props":
                      var element = internalInstance._currentElement;
                      internalInstance._currentElement = _objectSpread(_objectSpread({}, element), {}, {
                        props: Object(utils["e"])(element.props, path2, value)
                      });
                      forceUpdate(publicInstance);
                      break;
                    case "state":
                      Object(src_utils["l"])(publicInstance.state, path2, value);
                      forceUpdate(publicInstance);
                      break;
                  }
                }
              }
            }
            var getProfilingData = function getProfilingData2() {
              throw new Error("getProfilingData not supported by this renderer");
            };
            var handleCommitFiberRoot = function handleCommitFiberRoot2() {
              throw new Error("handleCommitFiberRoot not supported by this renderer");
            };
            var handleCommitFiberUnmount = function handleCommitFiberUnmount2() {
              throw new Error("handleCommitFiberUnmount not supported by this renderer");
            };
            var handlePostCommitFiberRoot = function handlePostCommitFiberRoot2() {
              throw new Error("handlePostCommitFiberRoot not supported by this renderer");
            };
            var overrideError = function overrideError2() {
              throw new Error("overrideError not supported by this renderer");
            };
            var overrideSuspense = function overrideSuspense2() {
              throw new Error("overrideSuspense not supported by this renderer");
            };
            var startProfiling = function startProfiling2() {
            };
            var stopProfiling = function stopProfiling2() {
            };
            function getBestMatchForTrackedPath() {
              return null;
            }
            function getPathForElement(id) {
              return null;
            }
            function updateComponentFilters(componentFilters) {
            }
            function setTraceUpdatesEnabled(enabled) {
            }
            function setTrackedPath(path2) {
            }
            function getOwnersList(id) {
              return null;
            }
            function clearErrorsAndWarnings() {
            }
            function clearErrorsForFiberID(id) {
            }
            function clearWarningsForFiberID(id) {
            }
            return {
              clearErrorsAndWarnings,
              clearErrorsForFiberID,
              clearWarningsForFiberID,
              cleanup,
              copyElementPath,
              deletePath,
              flushInitialOperations,
              getBestMatchForTrackedPath,
              getDisplayNameForFiberID,
              getFiberIDForNative: getInternalIDForNative,
              getInstanceAndStyle,
              findNativeNodesForFiberID: function findNativeNodesForFiberID(id) {
                var nativeNode = findNativeNodeForInternalID(id);
                return nativeNode == null ? null : [nativeNode];
              },
              getOwnersList,
              getPathForElement,
              getProfilingData,
              handleCommitFiberRoot,
              handleCommitFiberUnmount,
              handlePostCommitFiberRoot,
              inspectElement,
              logElementToConsole,
              overrideError,
              overrideSuspense,
              overrideValueAtPath,
              renamePath,
              prepareViewAttributeSource,
              prepareViewElementSource,
              renderer,
              setTraceUpdatesEnabled,
              setTrackedPath,
              startProfiling,
              stopProfiling,
              storeAsGlobal,
              updateComponentFilters
            };
          }
          function initBackend(hook, agent, global2) {
            if (hook == null) {
              return function() {
              };
            }
            var subs = [
              hook.sub("renderer-attached", function(_ref) {
                var id = _ref.id, renderer = _ref.renderer, rendererInterface = _ref.rendererInterface;
                agent.setRendererInterface(id, rendererInterface);
                rendererInterface.flushInitialOperations();
              }),
              hook.sub("unsupported-renderer-version", function(id) {
                agent.onUnsupportedRenderer(id);
              }),
              hook.sub("fastRefreshScheduled", agent.onFastRefreshScheduled),
              hook.sub("operations", agent.onHookOperations),
              hook.sub("traceUpdates", agent.onTraceUpdates)
            ];
            var attachRenderer = function attachRenderer2(id, renderer) {
              var rendererInterface = hook.rendererInterfaces.get(id);
              if (rendererInterface == null) {
                if (typeof renderer.findFiberByHostInstance === "function") {
                  rendererInterface = Object(backend_renderer["a"])(hook, id, renderer, global2);
                } else if (renderer.ComponentTree) {
                  rendererInterface = renderer_attach(hook, id, renderer, global2);
                } else {
                }
                if (rendererInterface != null) {
                  hook.rendererInterfaces.set(id, rendererInterface);
                }
              }
              if (rendererInterface != null) {
                hook.emit("renderer-attached", {
                  id,
                  renderer,
                  rendererInterface
                });
              } else {
                hook.emit("unsupported-renderer-version", id);
              }
            };
            hook.renderers.forEach(function(renderer, id) {
              attachRenderer(id, renderer);
            });
            subs.push(hook.sub("renderer", function(_ref2) {
              var id = _ref2.id, renderer = _ref2.renderer;
              attachRenderer(id, renderer);
            }));
            hook.emit("react-devtools", agent);
            hook.reactDevtoolsAgent = agent;
            var onAgentShutdown = function onAgentShutdown2() {
              subs.forEach(function(fn) {
                return fn();
              });
              hook.rendererInterfaces.forEach(function(rendererInterface) {
                rendererInterface.cleanup();
              });
              hook.reactDevtoolsAgent = null;
            };
            agent.addListener("shutdown", onAgentShutdown);
            subs.push(function() {
              agent.removeListener("shutdown", onAgentShutdown);
            });
            return function() {
              subs.forEach(function(fn) {
                return fn();
              });
            };
          }
          function resolveBoxStyle(prefix2, style) {
            var hasParts = false;
            var result2 = {
              bottom: 0,
              left: 0,
              right: 0,
              top: 0
            };
            var styleForAll = style[prefix2];
            if (styleForAll != null) {
              for (var _i = 0, _Object$keys = Object.keys(result2); _i < _Object$keys.length; _i++) {
                var key2 = _Object$keys[_i];
                result2[key2] = styleForAll;
              }
              hasParts = true;
            }
            var styleForHorizontal = style[prefix2 + "Horizontal"];
            if (styleForHorizontal != null) {
              result2.left = styleForHorizontal;
              result2.right = styleForHorizontal;
              hasParts = true;
            } else {
              var styleForLeft = style[prefix2 + "Left"];
              if (styleForLeft != null) {
                result2.left = styleForLeft;
                hasParts = true;
              }
              var styleForRight = style[prefix2 + "Right"];
              if (styleForRight != null) {
                result2.right = styleForRight;
                hasParts = true;
              }
              var styleForEnd = style[prefix2 + "End"];
              if (styleForEnd != null) {
                result2.right = styleForEnd;
                hasParts = true;
              }
              var styleForStart = style[prefix2 + "Start"];
              if (styleForStart != null) {
                result2.left = styleForStart;
                hasParts = true;
              }
            }
            var styleForVertical = style[prefix2 + "Vertical"];
            if (styleForVertical != null) {
              result2.bottom = styleForVertical;
              result2.top = styleForVertical;
              hasParts = true;
            } else {
              var styleForBottom = style[prefix2 + "Bottom"];
              if (styleForBottom != null) {
                result2.bottom = styleForBottom;
                hasParts = true;
              }
              var styleForTop = style[prefix2 + "Top"];
              if (styleForTop != null) {
                result2.top = styleForTop;
                hasParts = true;
              }
            }
            return hasParts ? result2 : null;
          }
          function setupNativeStyleEditor_typeof(obj) {
            "@babel/helpers - typeof";
            if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
              setupNativeStyleEditor_typeof = function _typeof2(obj2) {
                return typeof obj2;
              };
            } else {
              setupNativeStyleEditor_typeof = function _typeof2(obj2) {
                return obj2 && typeof Symbol === "function" && obj2.constructor === Symbol && obj2 !== Symbol.prototype ? "symbol" : typeof obj2;
              };
            }
            return setupNativeStyleEditor_typeof(obj);
          }
          function setupNativeStyleEditor_defineProperty(obj, key2, value) {
            if (key2 in obj) {
              Object.defineProperty(obj, key2, { value, enumerable: true, configurable: true, writable: true });
            } else {
              obj[key2] = value;
            }
            return obj;
          }
          function setupNativeStyleEditor(bridge, agent, resolveNativeStyle, validAttributes) {
            bridge.addListener("NativeStyleEditor_measure", function(_ref) {
              var id = _ref.id, rendererID = _ref.rendererID;
              measureStyle(agent, bridge, resolveNativeStyle, id, rendererID);
            });
            bridge.addListener("NativeStyleEditor_renameAttribute", function(_ref2) {
              var id = _ref2.id, rendererID = _ref2.rendererID, oldName = _ref2.oldName, newName = _ref2.newName, value = _ref2.value;
              renameStyle(agent, id, rendererID, oldName, newName, value);
              setTimeout(function() {
                return measureStyle(agent, bridge, resolveNativeStyle, id, rendererID);
              });
            });
            bridge.addListener("NativeStyleEditor_setValue", function(_ref3) {
              var id = _ref3.id, rendererID = _ref3.rendererID, name = _ref3.name, value = _ref3.value;
              setStyle(agent, id, rendererID, name, value);
              setTimeout(function() {
                return measureStyle(agent, bridge, resolveNativeStyle, id, rendererID);
              });
            });
            bridge.send("isNativeStyleEditorSupported", {
              isSupported: true,
              validAttributes
            });
          }
          var EMPTY_BOX_STYLE = {
            top: 0,
            left: 0,
            right: 0,
            bottom: 0
          };
          var componentIDToStyleOverrides = /* @__PURE__ */ new Map();
          function measureStyle(agent, bridge, resolveNativeStyle, id, rendererID) {
            var data = agent.getInstanceAndStyle({
              id,
              rendererID
            });
            if (!data || !data.style) {
              bridge.send("NativeStyleEditor_styleAndLayout", {
                id,
                layout: null,
                style: null
              });
              return;
            }
            var instance = data.instance, style = data.style;
            var resolvedStyle = resolveNativeStyle(style);
            var styleOverrides = componentIDToStyleOverrides.get(id);
            if (styleOverrides != null) {
              resolvedStyle = Object.assign({}, resolvedStyle, styleOverrides);
            }
            if (!instance || typeof instance.measure !== "function") {
              bridge.send("NativeStyleEditor_styleAndLayout", {
                id,
                layout: null,
                style: resolvedStyle || null
              });
              return;
            }
            instance.measure(function(x, y2, width, height, left, top) {
              if (typeof x !== "number") {
                bridge.send("NativeStyleEditor_styleAndLayout", {
                  id,
                  layout: null,
                  style: resolvedStyle || null
                });
                return;
              }
              var margin = resolvedStyle != null && resolveBoxStyle("margin", resolvedStyle) || EMPTY_BOX_STYLE;
              var padding = resolvedStyle != null && resolveBoxStyle("padding", resolvedStyle) || EMPTY_BOX_STYLE;
              bridge.send("NativeStyleEditor_styleAndLayout", {
                id,
                layout: {
                  x,
                  y: y2,
                  width,
                  height,
                  left,
                  top,
                  margin,
                  padding
                },
                style: resolvedStyle || null
              });
            });
          }
          function shallowClone(object) {
            var cloned = {};
            for (var n2 in object) {
              cloned[n2] = object[n2];
            }
            return cloned;
          }
          function renameStyle(agent, id, rendererID, oldName, newName, value) {
            var _ref4;
            var data = agent.getInstanceAndStyle({
              id,
              rendererID
            });
            if (!data || !data.style) {
              return;
            }
            var instance = data.instance, style = data.style;
            var newStyle = newName ? (_ref4 = {}, setupNativeStyleEditor_defineProperty(_ref4, oldName, void 0), setupNativeStyleEditor_defineProperty(_ref4, newName, value), _ref4) : setupNativeStyleEditor_defineProperty({}, oldName, void 0);
            var customStyle;
            if (instance !== null && typeof instance.setNativeProps === "function") {
              var styleOverrides = componentIDToStyleOverrides.get(id);
              if (!styleOverrides) {
                componentIDToStyleOverrides.set(id, newStyle);
              } else {
                Object.assign(styleOverrides, newStyle);
              }
              instance.setNativeProps({
                style: newStyle
              });
            } else if (Array.isArray(style)) {
              var lastIndex = style.length - 1;
              if (setupNativeStyleEditor_typeof(style[lastIndex]) === "object" && !Array.isArray(style[lastIndex])) {
                customStyle = shallowClone(style[lastIndex]);
                delete customStyle[oldName];
                if (newName) {
                  customStyle[newName] = value;
                } else {
                  customStyle[oldName] = void 0;
                }
                agent.overrideValueAtPath({
                  type: "props",
                  id,
                  rendererID,
                  path: ["style", lastIndex],
                  value: customStyle
                });
              } else {
                agent.overrideValueAtPath({
                  type: "props",
                  id,
                  rendererID,
                  path: ["style"],
                  value: style.concat([newStyle])
                });
              }
            } else if (setupNativeStyleEditor_typeof(style) === "object") {
              customStyle = shallowClone(style);
              delete customStyle[oldName];
              if (newName) {
                customStyle[newName] = value;
              } else {
                customStyle[oldName] = void 0;
              }
              agent.overrideValueAtPath({
                type: "props",
                id,
                rendererID,
                path: ["style"],
                value: customStyle
              });
            } else {
              agent.overrideValueAtPath({
                type: "props",
                id,
                rendererID,
                path: ["style"],
                value: [style, newStyle]
              });
            }
            agent.emit("hideNativeHighlight");
          }
          function setStyle(agent, id, rendererID, name, value) {
            var data = agent.getInstanceAndStyle({
              id,
              rendererID
            });
            if (!data || !data.style) {
              return;
            }
            var instance = data.instance, style = data.style;
            var newStyle = setupNativeStyleEditor_defineProperty({}, name, value);
            if (instance !== null && typeof instance.setNativeProps === "function") {
              var styleOverrides = componentIDToStyleOverrides.get(id);
              if (!styleOverrides) {
                componentIDToStyleOverrides.set(id, newStyle);
              } else {
                Object.assign(styleOverrides, newStyle);
              }
              instance.setNativeProps({
                style: newStyle
              });
            } else if (Array.isArray(style)) {
              var lastLength = style.length - 1;
              if (setupNativeStyleEditor_typeof(style[lastLength]) === "object" && !Array.isArray(style[lastLength])) {
                agent.overrideValueAtPath({
                  type: "props",
                  id,
                  rendererID,
                  path: ["style", lastLength, name],
                  value
                });
              } else {
                agent.overrideValueAtPath({
                  type: "props",
                  id,
                  rendererID,
                  path: ["style"],
                  value: style.concat([newStyle])
                });
              }
            } else {
              agent.overrideValueAtPath({
                type: "props",
                id,
                rendererID,
                path: ["style"],
                value: [style, newStyle]
              });
            }
            agent.emit("hideNativeHighlight");
          }
          installHook(window);
          var backend_hook = window.__REACT_DEVTOOLS_GLOBAL_HOOK__;
          var savedComponentFilters = Object(src_utils["e"])();
          function backend_debug(methodName) {
            if (constants["o"]) {
              var _console;
              for (var _len = arguments.length, args = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
                args[_key - 1] = arguments[_key];
              }
              (_console = console).log.apply(_console, ["%c[core/backend] %c".concat(methodName), "color: teal; font-weight: bold;", "font-weight: bold;"].concat(args));
            }
          }
          function connectToDevTools(options) {
            if (backend_hook == null) {
              return;
            }
            var _ref = options || {}, _ref$host = _ref.host, host = _ref$host === void 0 ? "localhost" : _ref$host, nativeStyleEditorValidAttributes = _ref.nativeStyleEditorValidAttributes, _ref$useHttps = _ref.useHttps, useHttps = _ref$useHttps === void 0 ? false : _ref$useHttps, _ref$port = _ref.port, port = _ref$port === void 0 ? 8097 : _ref$port, websocket = _ref.websocket, _ref$resolveRNStyle = _ref.resolveRNStyle, resolveRNStyle = _ref$resolveRNStyle === void 0 ? null : _ref$resolveRNStyle, _ref$retryConnectionD = _ref.retryConnectionDelay, retryConnectionDelay = _ref$retryConnectionD === void 0 ? 2e3 : _ref$retryConnectionD, _ref$isAppActive = _ref.isAppActive, isAppActive = _ref$isAppActive === void 0 ? function() {
              return true;
            } : _ref$isAppActive;
            var protocol = useHttps ? "wss" : "ws";
            var retryTimeoutID = null;
            function scheduleRetry() {
              if (retryTimeoutID === null) {
                retryTimeoutID = setTimeout(function() {
                  return connectToDevTools(options);
                }, retryConnectionDelay);
              }
            }
            if (!isAppActive()) {
              scheduleRetry();
              return;
            }
            var bridge = null;
            var messageListeners = [];
            var uri = protocol + "://" + host + ":" + port;
            var ws = websocket ? websocket : new window.WebSocket(uri);
            ws.onclose = handleClose;
            ws.onerror = handleFailed;
            ws.onmessage = handleMessage;
            ws.onopen = function() {
              bridge = new src_bridge({
                listen: function listen(fn) {
                  messageListeners.push(fn);
                  return function() {
                    var index = messageListeners.indexOf(fn);
                    if (index >= 0) {
                      messageListeners.splice(index, 1);
                    }
                  };
                },
                send: function send3(event2, payload, transferable) {
                  if (ws.readyState === ws.OPEN) {
                    if (constants["o"]) {
                      backend_debug("wall.send()", event2, payload);
                    }
                    ws.send(JSON.stringify({
                      event: event2,
                      payload
                    }));
                  } else {
                    if (constants["o"]) {
                      backend_debug("wall.send()", "Shutting down bridge because of closed WebSocket connection");
                    }
                    if (bridge !== null) {
                      bridge.shutdown();
                    }
                    scheduleRetry();
                  }
                }
              });
              bridge.addListener("inspectElement", function(_ref2) {
                var id = _ref2.id, rendererID = _ref2.rendererID;
                var renderer = agent.rendererInterfaces[rendererID];
                if (renderer != null) {
                  var nodes = renderer.findNativeNodesForFiberID(id);
                  if (nodes != null && nodes[0] != null) {
                    agent.emit("showNativeHighlight", nodes[0]);
                  }
                }
              });
              bridge.addListener("updateComponentFilters", function(componentFilters) {
                savedComponentFilters = componentFilters;
              });
              if (window.__REACT_DEVTOOLS_COMPONENT_FILTERS__ == null) {
                bridge.send("overrideComponentFilters", savedComponentFilters);
              }
              var agent = new agent_Agent(bridge);
              agent.addListener("shutdown", function() {
                backend_hook.emit("shutdown");
              });
              initBackend(backend_hook, agent, window);
              if (resolveRNStyle != null || backend_hook.resolveRNStyle != null) {
                setupNativeStyleEditor(bridge, agent, resolveRNStyle || backend_hook.resolveRNStyle, nativeStyleEditorValidAttributes || backend_hook.nativeStyleEditorValidAttributes || null);
              } else {
                var lazyResolveRNStyle;
                var lazyNativeStyleEditorValidAttributes;
                var initAfterTick = function initAfterTick2() {
                  if (bridge !== null) {
                    setupNativeStyleEditor(bridge, agent, lazyResolveRNStyle, lazyNativeStyleEditorValidAttributes);
                  }
                };
                if (!backend_hook.hasOwnProperty("resolveRNStyle")) {
                  Object.defineProperty(backend_hook, "resolveRNStyle", {
                    enumerable: false,
                    get: function get() {
                      return lazyResolveRNStyle;
                    },
                    set: function set2(value) {
                      lazyResolveRNStyle = value;
                      initAfterTick();
                    }
                  });
                }
                if (!backend_hook.hasOwnProperty("nativeStyleEditorValidAttributes")) {
                  Object.defineProperty(backend_hook, "nativeStyleEditorValidAttributes", {
                    enumerable: false,
                    get: function get() {
                      return lazyNativeStyleEditorValidAttributes;
                    },
                    set: function set2(value) {
                      lazyNativeStyleEditorValidAttributes = value;
                      initAfterTick();
                    }
                  });
                }
              }
            };
            function handleClose() {
              if (constants["o"]) {
                backend_debug("WebSocket.onclose");
              }
              if (bridge !== null) {
                bridge.emit("shutdown");
              }
              scheduleRetry();
            }
            function handleFailed() {
              if (constants["o"]) {
                backend_debug("WebSocket.onerror");
              }
              scheduleRetry();
            }
            function handleMessage(event2) {
              var data;
              try {
                if (typeof event2.data === "string") {
                  data = JSON.parse(event2.data);
                  if (constants["o"]) {
                    backend_debug("WebSocket.onmessage", data);
                  }
                } else {
                  throw Error();
                }
              } catch (e2) {
                console.error("[React DevTools] Failed to parse JSON: " + event2.data);
                return;
              }
              messageListeners.forEach(function(fn) {
                try {
                  fn(data);
                } catch (error) {
                  console.log("[React DevTools] Error calling listener", data);
                  console.log("error:", error);
                  throw error;
                }
              });
            }
          }
        }
      ]);
    });
  }
});

// node_modules/ink/build/devtools.js
var require_devtools = __commonJS({
  "node_modules/ink/build/devtools.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    require_devtools_window_polyfill();
    var react_devtools_core_1 = require_backend();
    react_devtools_core_1.connectToDevTools();
  }
});

// node_modules/ink/build/reconciler.js
var require_reconciler = __commonJS({
  "node_modules/ink/build/reconciler.js"(exports2) {
    "use strict";
    var __importDefault = exports2 && exports2.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { "default": mod };
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    var scheduler_1 = require_scheduler();
    var react_reconciler_1 = __importDefault(require_react_reconciler());
    var yoga_layout_prebuilt_1 = __importDefault(require_entry_browser());
    var dom_1 = require_dom();
    if (process.env.DEV === "true") {
      require_devtools();
    }
    var cleanupYogaNode = (node) => {
      node === null || node === void 0 ? void 0 : node.unsetMeasureFunc();
      node === null || node === void 0 ? void 0 : node.freeRecursive();
    };
    exports2.default = react_reconciler_1.default({
      schedulePassiveEffects: scheduler_1.unstable_scheduleCallback,
      cancelPassiveEffects: scheduler_1.unstable_cancelCallback,
      now: Date.now,
      getRootHostContext: () => ({
        isInsideText: false
      }),
      prepareForCommit: () => {
      },
      resetAfterCommit: (rootNode) => {
        if (rootNode.isStaticDirty) {
          rootNode.isStaticDirty = false;
          if (typeof rootNode.onImmediateRender === "function") {
            rootNode.onImmediateRender();
          }
          return;
        }
        if (typeof rootNode.onRender === "function") {
          rootNode.onRender();
        }
      },
      getChildHostContext: (parentHostContext, type3) => {
        const previousIsInsideText = parentHostContext.isInsideText;
        const isInsideText = type3 === "ink-text" || type3 === "ink-virtual-text";
        if (previousIsInsideText === isInsideText) {
          return parentHostContext;
        }
        return { isInsideText };
      },
      shouldSetTextContent: () => false,
      createInstance: (originalType, newProps, _root, hostContext) => {
        if (hostContext.isInsideText && originalType === "ink-box") {
          throw new Error(`<Box> can\u2019t be nested inside <Text> component`);
        }
        const type3 = originalType === "ink-text" && hostContext.isInsideText ? "ink-virtual-text" : originalType;
        const node = dom_1.createNode(type3);
        for (const [key2, value] of Object.entries(newProps)) {
          if (key2 === "children") {
            continue;
          } else if (key2 === "style") {
            dom_1.setStyle(node, value);
          } else if (key2 === "internal_transform") {
            node.internal_transform = value;
          } else if (key2 === "internal_static") {
            node.internal_static = true;
          } else {
            dom_1.setAttribute(node, key2, value);
          }
        }
        return node;
      },
      createTextInstance: (text, _root, hostContext) => {
        if (!hostContext.isInsideText) {
          throw new Error(`Text string "${text}" must be rendered inside <Text> component`);
        }
        return dom_1.createTextNode(text);
      },
      resetTextContent: () => {
      },
      hideTextInstance: (node) => {
        dom_1.setTextNodeValue(node, "");
      },
      unhideTextInstance: (node, text) => {
        dom_1.setTextNodeValue(node, text);
      },
      getPublicInstance: (instance) => instance,
      hideInstance: (node) => {
        var _a2;
        (_a2 = node.yogaNode) === null || _a2 === void 0 ? void 0 : _a2.setDisplay(yoga_layout_prebuilt_1.default.DISPLAY_NONE);
      },
      unhideInstance: (node) => {
        var _a2;
        (_a2 = node.yogaNode) === null || _a2 === void 0 ? void 0 : _a2.setDisplay(yoga_layout_prebuilt_1.default.DISPLAY_FLEX);
      },
      appendInitialChild: dom_1.appendChildNode,
      appendChild: dom_1.appendChildNode,
      insertBefore: dom_1.insertBeforeNode,
      finalizeInitialChildren: (node, _type, _props, rootNode) => {
        if (node.internal_static) {
          rootNode.isStaticDirty = true;
          rootNode.staticNode = node;
        }
        return false;
      },
      supportsMutation: true,
      appendChildToContainer: dom_1.appendChildNode,
      insertInContainerBefore: dom_1.insertBeforeNode,
      removeChildFromContainer: (node, removeNode) => {
        dom_1.removeChildNode(node, removeNode);
        cleanupYogaNode(removeNode.yogaNode);
      },
      prepareUpdate: (node, _type, oldProps, newProps, rootNode) => {
        if (node.internal_static) {
          rootNode.isStaticDirty = true;
        }
        const updatePayload = {};
        const keys = Object.keys(newProps);
        for (const key2 of keys) {
          if (newProps[key2] !== oldProps[key2]) {
            const isStyle = key2 === "style" && typeof newProps.style === "object" && typeof oldProps.style === "object";
            if (isStyle) {
              const newStyle = newProps.style;
              const oldStyle = oldProps.style;
              const styleKeys = Object.keys(newStyle);
              for (const styleKey of styleKeys) {
                if (styleKey === "borderStyle" || styleKey === "borderColor") {
                  if (typeof updatePayload.style !== "object") {
                    const style = {};
                    updatePayload.style = style;
                  }
                  updatePayload.style.borderStyle = newStyle.borderStyle;
                  updatePayload.style.borderColor = newStyle.borderColor;
                }
                if (newStyle[styleKey] !== oldStyle[styleKey]) {
                  if (typeof updatePayload.style !== "object") {
                    const style = {};
                    updatePayload.style = style;
                  }
                  updatePayload.style[styleKey] = newStyle[styleKey];
                }
              }
              continue;
            }
            updatePayload[key2] = newProps[key2];
          }
        }
        return updatePayload;
      },
      commitUpdate: (node, updatePayload) => {
        for (const [key2, value] of Object.entries(updatePayload)) {
          if (key2 === "children") {
            continue;
          } else if (key2 === "style") {
            dom_1.setStyle(node, value);
          } else if (key2 === "internal_transform") {
            node.internal_transform = value;
          } else if (key2 === "internal_static") {
            node.internal_static = true;
          } else {
            dom_1.setAttribute(node, key2, value);
          }
        }
      },
      commitTextUpdate: (node, _oldText, newText) => {
        dom_1.setTextNodeValue(node, newText);
      },
      removeChild: (node, removeNode) => {
        dom_1.removeChildNode(node, removeNode);
        cleanupYogaNode(removeNode.yogaNode);
      }
    });
  }
});

// node_modules/indent-string/index.js
var require_indent_string = __commonJS({
  "node_modules/indent-string/index.js"(exports2, module2) {
    "use strict";
    module2.exports = (string, count = 1, options) => {
      options = __spreadValues({
        indent: " ",
        includeEmptyLines: false
      }, options);
      if (typeof string !== "string") {
        throw new TypeError(`Expected \`input\` to be a \`string\`, got \`${typeof string}\``);
      }
      if (typeof count !== "number") {
        throw new TypeError(`Expected \`count\` to be a \`number\`, got \`${typeof count}\``);
      }
      if (typeof options.indent !== "string") {
        throw new TypeError(`Expected \`options.indent\` to be a \`string\`, got \`${typeof options.indent}\``);
      }
      if (count === 0) {
        return string;
      }
      const regex = options.includeEmptyLines ? /^/gm : /^(?!\s*$)/gm;
      return string.replace(regex, options.indent.repeat(count));
    };
  }
});

// node_modules/ink/build/get-max-width.js
var require_get_max_width = __commonJS({
  "node_modules/ink/build/get-max-width.js"(exports2) {
    "use strict";
    var __importDefault = exports2 && exports2.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { "default": mod };
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    var yoga_layout_prebuilt_1 = __importDefault(require_entry_browser());
    exports2.default = (yogaNode) => {
      return yogaNode.getComputedWidth() - yogaNode.getComputedPadding(yoga_layout_prebuilt_1.default.EDGE_LEFT) - yogaNode.getComputedPadding(yoga_layout_prebuilt_1.default.EDGE_RIGHT) - yogaNode.getComputedBorder(yoga_layout_prebuilt_1.default.EDGE_LEFT) - yogaNode.getComputedBorder(yoga_layout_prebuilt_1.default.EDGE_RIGHT);
    };
  }
});

// node_modules/cli-boxes/boxes.json
var require_boxes = __commonJS({
  "node_modules/cli-boxes/boxes.json"(exports2, module2) {
    module2.exports = {
      single: {
        topLeft: "\u250C",
        topRight: "\u2510",
        bottomRight: "\u2518",
        bottomLeft: "\u2514",
        vertical: "\u2502",
        horizontal: "\u2500"
      },
      double: {
        topLeft: "\u2554",
        topRight: "\u2557",
        bottomRight: "\u255D",
        bottomLeft: "\u255A",
        vertical: "\u2551",
        horizontal: "\u2550"
      },
      round: {
        topLeft: "\u256D",
        topRight: "\u256E",
        bottomRight: "\u256F",
        bottomLeft: "\u2570",
        vertical: "\u2502",
        horizontal: "\u2500"
      },
      bold: {
        topLeft: "\u250F",
        topRight: "\u2513",
        bottomRight: "\u251B",
        bottomLeft: "\u2517",
        vertical: "\u2503",
        horizontal: "\u2501"
      },
      singleDouble: {
        topLeft: "\u2553",
        topRight: "\u2556",
        bottomRight: "\u255C",
        bottomLeft: "\u2559",
        vertical: "\u2551",
        horizontal: "\u2500"
      },
      doubleSingle: {
        topLeft: "\u2552",
        topRight: "\u2555",
        bottomRight: "\u255B",
        bottomLeft: "\u2558",
        vertical: "\u2502",
        horizontal: "\u2550"
      },
      classic: {
        topLeft: "+",
        topRight: "+",
        bottomRight: "+",
        bottomLeft: "+",
        vertical: "|",
        horizontal: "-"
      }
    };
  }
});

// node_modules/cli-boxes/index.js
var require_cli_boxes = __commonJS({
  "node_modules/cli-boxes/index.js"(exports2, module2) {
    "use strict";
    var cliBoxes = require_boxes();
    module2.exports = cliBoxes;
    module2.exports.default = cliBoxes;
  }
});

// node_modules/has-flag/index.js
var require_has_flag = __commonJS({
  "node_modules/has-flag/index.js"(exports2, module2) {
    "use strict";
    module2.exports = (flag, argv = process.argv) => {
      const prefix2 = flag.startsWith("-") ? "" : flag.length === 1 ? "-" : "--";
      const position = argv.indexOf(prefix2 + flag);
      const terminatorPosition = argv.indexOf("--");
      return position !== -1 && (terminatorPosition === -1 || position < terminatorPosition);
    };
  }
});

// node_modules/supports-color/index.js
var require_supports_color = __commonJS({
  "node_modules/supports-color/index.js"(exports2, module2) {
    "use strict";
    var os = require("os");
    var tty = require("tty");
    var hasFlag = require_has_flag();
    var { env } = process;
    var forceColor;
    if (hasFlag("no-color") || hasFlag("no-colors") || hasFlag("color=false") || hasFlag("color=never")) {
      forceColor = 0;
    } else if (hasFlag("color") || hasFlag("colors") || hasFlag("color=true") || hasFlag("color=always")) {
      forceColor = 1;
    }
    if ("FORCE_COLOR" in env) {
      if (env.FORCE_COLOR === "true") {
        forceColor = 1;
      } else if (env.FORCE_COLOR === "false") {
        forceColor = 0;
      } else {
        forceColor = env.FORCE_COLOR.length === 0 ? 1 : Math.min(parseInt(env.FORCE_COLOR, 10), 3);
      }
    }
    function translateLevel(level) {
      if (level === 0) {
        return false;
      }
      return {
        level,
        hasBasic: true,
        has256: level >= 2,
        has16m: level >= 3
      };
    }
    function supportsColor(haveStream, streamIsTTY) {
      if (forceColor === 0) {
        return 0;
      }
      if (hasFlag("color=16m") || hasFlag("color=full") || hasFlag("color=truecolor")) {
        return 3;
      }
      if (hasFlag("color=256")) {
        return 2;
      }
      if (haveStream && !streamIsTTY && forceColor === void 0) {
        return 0;
      }
      const min = forceColor || 0;
      if (env.TERM === "dumb") {
        return min;
      }
      if (process.platform === "win32") {
        const osRelease = os.release().split(".");
        if (Number(osRelease[0]) >= 10 && Number(osRelease[2]) >= 10586) {
          return Number(osRelease[2]) >= 14931 ? 3 : 2;
        }
        return 1;
      }
      if ("CI" in env) {
        if (["TRAVIS", "CIRCLECI", "APPVEYOR", "GITLAB_CI", "GITHUB_ACTIONS", "BUILDKITE"].some((sign) => sign in env) || env.CI_NAME === "codeship") {
          return 1;
        }
        return min;
      }
      if ("TEAMCITY_VERSION" in env) {
        return /^(9\.(0*[1-9]\d*)\.|\d{2,}\.)/.test(env.TEAMCITY_VERSION) ? 1 : 0;
      }
      if (env.COLORTERM === "truecolor") {
        return 3;
      }
      if ("TERM_PROGRAM" in env) {
        const version = parseInt((env.TERM_PROGRAM_VERSION || "").split(".")[0], 10);
        switch (env.TERM_PROGRAM) {
          case "iTerm.app":
            return version >= 3 ? 3 : 2;
          case "Apple_Terminal":
            return 2;
        }
      }
      if (/-256(color)?$/i.test(env.TERM)) {
        return 2;
      }
      if (/^screen|^xterm|^vt100|^vt220|^rxvt|color|ansi|cygwin|linux/i.test(env.TERM)) {
        return 1;
      }
      if ("COLORTERM" in env) {
        return 1;
      }
      return min;
    }
    function getSupportLevel(stream) {
      const level = supportsColor(stream, stream && stream.isTTY);
      return translateLevel(level);
    }
    module2.exports = {
      supportsColor: getSupportLevel,
      stdout: translateLevel(supportsColor(true, tty.isatty(1))),
      stderr: translateLevel(supportsColor(true, tty.isatty(2)))
    };
  }
});

// node_modules/chalk/source/util.js
var require_util = __commonJS({
  "node_modules/chalk/source/util.js"(exports2, module2) {
    "use strict";
    var stringReplaceAll = (string, substring, replacer) => {
      let index = string.indexOf(substring);
      if (index === -1) {
        return string;
      }
      const substringLength = substring.length;
      let endIndex = 0;
      let returnValue = "";
      do {
        returnValue += string.substr(endIndex, index - endIndex) + substring + replacer;
        endIndex = index + substringLength;
        index = string.indexOf(substring, endIndex);
      } while (index !== -1);
      returnValue += string.substr(endIndex);
      return returnValue;
    };
    var stringEncaseCRLFWithFirstIndex = (string, prefix2, postfix, index) => {
      let endIndex = 0;
      let returnValue = "";
      do {
        const gotCR = string[index - 1] === "\r";
        returnValue += string.substr(endIndex, (gotCR ? index - 1 : index) - endIndex) + prefix2 + (gotCR ? "\r\n" : "\n") + postfix;
        endIndex = index + 1;
        index = string.indexOf("\n", endIndex);
      } while (index !== -1);
      returnValue += string.substr(endIndex);
      return returnValue;
    };
    module2.exports = {
      stringReplaceAll,
      stringEncaseCRLFWithFirstIndex
    };
  }
});

// node_modules/chalk/source/templates.js
var require_templates = __commonJS({
  "node_modules/chalk/source/templates.js"(exports2, module2) {
    "use strict";
    var TEMPLATE_REGEX = /(?:\\(u(?:[a-f\d]{4}|\{[a-f\d]{1,6}\})|x[a-f\d]{2}|.))|(?:\{(~)?(\w+(?:\([^)]*\))?(?:\.\w+(?:\([^)]*\))?)*)(?:[ \t]|(?=\r?\n)))|(\})|((?:.|[\r\n\f])+?)/gi;
    var STYLE_REGEX = /(?:^|\.)(\w+)(?:\(([^)]*)\))?/g;
    var STRING_REGEX = /^(['"])((?:\\.|(?!\1)[^\\])*)\1$/;
    var ESCAPE_REGEX = /\\(u(?:[a-f\d]{4}|{[a-f\d]{1,6}})|x[a-f\d]{2}|.)|([^\\])/gi;
    var ESCAPES = /* @__PURE__ */ new Map([
      ["n", "\n"],
      ["r", "\r"],
      ["t", "	"],
      ["b", "\b"],
      ["f", "\f"],
      ["v", "\v"],
      ["0", "\0"],
      ["\\", "\\"],
      ["e", ""],
      ["a", "\x07"]
    ]);
    function unescape(c2) {
      const u2 = c2[0] === "u";
      const bracket = c2[1] === "{";
      if (u2 && !bracket && c2.length === 5 || c2[0] === "x" && c2.length === 3) {
        return String.fromCharCode(parseInt(c2.slice(1), 16));
      }
      if (u2 && bracket) {
        return String.fromCodePoint(parseInt(c2.slice(2, -1), 16));
      }
      return ESCAPES.get(c2) || c2;
    }
    function parseArguments(name, arguments_) {
      const results = [];
      const chunks = arguments_.trim().split(/\s*,\s*/g);
      let matches;
      for (const chunk of chunks) {
        const number = Number(chunk);
        if (!Number.isNaN(number)) {
          results.push(number);
        } else if (matches = chunk.match(STRING_REGEX)) {
          results.push(matches[2].replace(ESCAPE_REGEX, (m, escape, character) => escape ? unescape(escape) : character));
        } else {
          throw new Error(`Invalid Chalk template style argument: ${chunk} (in style '${name}')`);
        }
      }
      return results;
    }
    function parseStyle(style) {
      STYLE_REGEX.lastIndex = 0;
      const results = [];
      let matches;
      while ((matches = STYLE_REGEX.exec(style)) !== null) {
        const name = matches[1];
        if (matches[2]) {
          const args = parseArguments(name, matches[2]);
          results.push([name].concat(args));
        } else {
          results.push([name]);
        }
      }
      return results;
    }
    function buildStyle(chalk, styles) {
      const enabled = {};
      for (const layer of styles) {
        for (const style of layer.styles) {
          enabled[style[0]] = layer.inverse ? null : style.slice(1);
        }
      }
      let current = chalk;
      for (const [styleName, styles2] of Object.entries(enabled)) {
        if (!Array.isArray(styles2)) {
          continue;
        }
        if (!(styleName in current)) {
          throw new Error(`Unknown Chalk style: ${styleName}`);
        }
        current = styles2.length > 0 ? current[styleName](...styles2) : current[styleName];
      }
      return current;
    }
    module2.exports = (chalk, temporary) => {
      const styles = [];
      const chunks = [];
      let chunk = [];
      temporary.replace(TEMPLATE_REGEX, (m, escapeCharacter, inverse, style, close, character) => {
        if (escapeCharacter) {
          chunk.push(unescape(escapeCharacter));
        } else if (style) {
          const string = chunk.join("");
          chunk = [];
          chunks.push(styles.length === 0 ? string : buildStyle(chalk, styles)(string));
          styles.push({ inverse, styles: parseStyle(style) });
        } else if (close) {
          if (styles.length === 0) {
            throw new Error("Found extraneous } in Chalk template literal");
          }
          chunks.push(buildStyle(chalk, styles)(chunk.join("")));
          chunk = [];
          styles.pop();
        } else {
          chunk.push(character);
        }
      });
      chunks.push(chunk.join(""));
      if (styles.length > 0) {
        const errMessage = `Chalk template literal is missing ${styles.length} closing bracket${styles.length === 1 ? "" : "s"} (\`}\`)`;
        throw new Error(errMessage);
      }
      return chunks.join("");
    };
  }
});

// node_modules/chalk/source/index.js
var require_source = __commonJS({
  "node_modules/chalk/source/index.js"(exports2, module2) {
    "use strict";
    var ansiStyles = require_ansi_styles();
    var { stdout: stdoutColor, stderr: stderrColor } = require_supports_color();
    var {
      stringReplaceAll,
      stringEncaseCRLFWithFirstIndex
    } = require_util();
    var { isArray } = Array;
    var levelMapping = [
      "ansi",
      "ansi",
      "ansi256",
      "ansi16m"
    ];
    var styles = Object.create(null);
    var applyOptions = (object, options = {}) => {
      if (options.level && !(Number.isInteger(options.level) && options.level >= 0 && options.level <= 3)) {
        throw new Error("The `level` option should be an integer from 0 to 3");
      }
      const colorLevel = stdoutColor ? stdoutColor.level : 0;
      object.level = options.level === void 0 ? colorLevel : options.level;
    };
    var ChalkClass = class {
      constructor(options) {
        return chalkFactory(options);
      }
    };
    var chalkFactory = (options) => {
      const chalk2 = {};
      applyOptions(chalk2, options);
      chalk2.template = (...arguments_) => chalkTag(chalk2.template, ...arguments_);
      Object.setPrototypeOf(chalk2, Chalk.prototype);
      Object.setPrototypeOf(chalk2.template, chalk2);
      chalk2.template.constructor = () => {
        throw new Error("`chalk.constructor()` is deprecated. Use `new chalk.Instance()` instead.");
      };
      chalk2.template.Instance = ChalkClass;
      return chalk2.template;
    };
    function Chalk(options) {
      return chalkFactory(options);
    }
    for (const [styleName, style] of Object.entries(ansiStyles)) {
      styles[styleName] = {
        get() {
          const builder = createBuilder(this, createStyler(style.open, style.close, this._styler), this._isEmpty);
          Object.defineProperty(this, styleName, { value: builder });
          return builder;
        }
      };
    }
    styles.visible = {
      get() {
        const builder = createBuilder(this, this._styler, true);
        Object.defineProperty(this, "visible", { value: builder });
        return builder;
      }
    };
    var usedModels = ["rgb", "hex", "keyword", "hsl", "hsv", "hwb", "ansi", "ansi256"];
    for (const model of usedModels) {
      styles[model] = {
        get() {
          const { level } = this;
          return function(...arguments_) {
            const styler = createStyler(ansiStyles.color[levelMapping[level]][model](...arguments_), ansiStyles.color.close, this._styler);
            return createBuilder(this, styler, this._isEmpty);
          };
        }
      };
    }
    for (const model of usedModels) {
      const bgModel = "bg" + model[0].toUpperCase() + model.slice(1);
      styles[bgModel] = {
        get() {
          const { level } = this;
          return function(...arguments_) {
            const styler = createStyler(ansiStyles.bgColor[levelMapping[level]][model](...arguments_), ansiStyles.bgColor.close, this._styler);
            return createBuilder(this, styler, this._isEmpty);
          };
        }
      };
    }
    var proto = Object.defineProperties(() => {
    }, __spreadProps(__spreadValues({}, styles), {
      level: {
        enumerable: true,
        get() {
          return this._generator.level;
        },
        set(level) {
          this._generator.level = level;
        }
      }
    }));
    var createStyler = (open, close, parent) => {
      let openAll;
      let closeAll;
      if (parent === void 0) {
        openAll = open;
        closeAll = close;
      } else {
        openAll = parent.openAll + open;
        closeAll = close + parent.closeAll;
      }
      return {
        open,
        close,
        openAll,
        closeAll,
        parent
      };
    };
    var createBuilder = (self2, _styler, _isEmpty) => {
      const builder = (...arguments_) => {
        if (isArray(arguments_[0]) && isArray(arguments_[0].raw)) {
          return applyStyle(builder, chalkTag(builder, ...arguments_));
        }
        return applyStyle(builder, arguments_.length === 1 ? "" + arguments_[0] : arguments_.join(" "));
      };
      Object.setPrototypeOf(builder, proto);
      builder._generator = self2;
      builder._styler = _styler;
      builder._isEmpty = _isEmpty;
      return builder;
    };
    var applyStyle = (self2, string) => {
      if (self2.level <= 0 || !string) {
        return self2._isEmpty ? "" : string;
      }
      let styler = self2._styler;
      if (styler === void 0) {
        return string;
      }
      const { openAll, closeAll } = styler;
      if (string.indexOf("") !== -1) {
        while (styler !== void 0) {
          string = stringReplaceAll(string, styler.close, styler.open);
          styler = styler.parent;
        }
      }
      const lfIndex = string.indexOf("\n");
      if (lfIndex !== -1) {
        string = stringEncaseCRLFWithFirstIndex(string, closeAll, openAll, lfIndex);
      }
      return openAll + string + closeAll;
    };
    var template;
    var chalkTag = (chalk2, ...strings) => {
      const [firstString] = strings;
      if (!isArray(firstString) || !isArray(firstString.raw)) {
        return strings.join(" ");
      }
      const arguments_ = strings.slice(1);
      const parts = [firstString.raw[0]];
      for (let i3 = 1; i3 < firstString.length; i3++) {
        parts.push(String(arguments_[i3 - 1]).replace(/[{}\\]/g, "\\$&"), String(firstString.raw[i3]));
      }
      if (template === void 0) {
        template = require_templates();
      }
      return template(chalk2, parts.join(""));
    };
    Object.defineProperties(Chalk.prototype, styles);
    var chalk = Chalk();
    chalk.supportsColor = stdoutColor;
    chalk.stderr = Chalk({ level: stderrColor ? stderrColor.level : 0 });
    chalk.stderr.supportsColor = stderrColor;
    module2.exports = chalk;
  }
});

// node_modules/ink/build/colorize.js
var require_colorize = __commonJS({
  "node_modules/ink/build/colorize.js"(exports2) {
    "use strict";
    var __importDefault = exports2 && exports2.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { "default": mod };
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    var chalk_1 = __importDefault(require_source());
    var RGB_LIKE_REGEX = /^(rgb|hsl|hsv|hwb)\(\s?(\d+),\s?(\d+),\s?(\d+)\s?\)$/;
    var ANSI_REGEX = /^(ansi|ansi256)\(\s?(\d+)\s?\)$/;
    var getMethod = (name, type3) => {
      if (type3 === "foreground") {
        return name;
      }
      return "bg" + name[0].toUpperCase() + name.slice(1);
    };
    exports2.default = (str2, color, type3) => {
      if (!color) {
        return str2;
      }
      if (color in chalk_1.default) {
        const method = getMethod(color, type3);
        return chalk_1.default[method](str2);
      }
      if (color.startsWith("#")) {
        const method = getMethod("hex", type3);
        return chalk_1.default[method](color)(str2);
      }
      if (color.startsWith("ansi")) {
        const matches = ANSI_REGEX.exec(color);
        if (!matches) {
          return str2;
        }
        const method = getMethod(matches[1], type3);
        const value = Number(matches[2]);
        return chalk_1.default[method](value)(str2);
      }
      const isRgbLike = color.startsWith("rgb") || color.startsWith("hsl") || color.startsWith("hsv") || color.startsWith("hwb");
      if (isRgbLike) {
        const matches = RGB_LIKE_REGEX.exec(color);
        if (!matches) {
          return str2;
        }
        const method = getMethod(matches[1], type3);
        const firstValue = Number(matches[2]);
        const secondValue = Number(matches[3]);
        const thirdValue = Number(matches[4]);
        return chalk_1.default[method](firstValue, secondValue, thirdValue)(str2);
      }
      return str2;
    };
  }
});

// node_modules/ink/build/render-border.js
var require_render_border = __commonJS({
  "node_modules/ink/build/render-border.js"(exports2) {
    "use strict";
    var __importDefault = exports2 && exports2.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { "default": mod };
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    var cli_boxes_1 = __importDefault(require_cli_boxes());
    var colorize_1 = __importDefault(require_colorize());
    exports2.default = (x, y2, node, output) => {
      if (typeof node.style.borderStyle === "string") {
        const width = node.yogaNode.getComputedWidth();
        const height = node.yogaNode.getComputedHeight();
        const color = node.style.borderColor;
        const box = cli_boxes_1.default[node.style.borderStyle];
        const topBorder = colorize_1.default(box.topLeft + box.horizontal.repeat(width - 2) + box.topRight, color, "foreground");
        const verticalBorder = (colorize_1.default(box.vertical, color, "foreground") + "\n").repeat(height - 2);
        const bottomBorder = colorize_1.default(box.bottomLeft + box.horizontal.repeat(width - 2) + box.bottomRight, color, "foreground");
        output.write(x, y2, topBorder, { transformers: [] });
        output.write(x, y2 + 1, verticalBorder, { transformers: [] });
        output.write(x + width - 1, y2 + 1, verticalBorder, { transformers: [] });
        output.write(x, y2 + height - 1, bottomBorder, { transformers: [] });
      }
    };
  }
});

// node_modules/ink/build/render-node-to-output.js
var require_render_node_to_output = __commonJS({
  "node_modules/ink/build/render-node-to-output.js"(exports2) {
    "use strict";
    var __importDefault = exports2 && exports2.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { "default": mod };
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    var yoga_layout_prebuilt_1 = __importDefault(require_entry_browser());
    var widest_line_1 = __importDefault(require_widest_line());
    var indent_string_1 = __importDefault(require_indent_string());
    var wrap_text_1 = __importDefault(require_wrap_text());
    var get_max_width_1 = __importDefault(require_get_max_width());
    var squash_text_nodes_1 = __importDefault(require_squash_text_nodes());
    var render_border_1 = __importDefault(require_render_border());
    var applyPaddingToText = (node, text) => {
      var _a2;
      const yogaNode = (_a2 = node.childNodes[0]) === null || _a2 === void 0 ? void 0 : _a2.yogaNode;
      if (yogaNode) {
        const offsetX = yogaNode.getComputedLeft();
        const offsetY = yogaNode.getComputedTop();
        text = "\n".repeat(offsetY) + indent_string_1.default(text, offsetX);
      }
      return text;
    };
    var renderNodeToOutput = (node, output, options) => {
      var _a2;
      const { offsetX = 0, offsetY = 0, transformers = [], skipStaticElements } = options;
      if (skipStaticElements && node.internal_static) {
        return;
      }
      const { yogaNode } = node;
      if (yogaNode) {
        if (yogaNode.getDisplay() === yoga_layout_prebuilt_1.default.DISPLAY_NONE) {
          return;
        }
        const x = offsetX + yogaNode.getComputedLeft();
        const y2 = offsetY + yogaNode.getComputedTop();
        let newTransformers = transformers;
        if (typeof node.internal_transform === "function") {
          newTransformers = [node.internal_transform, ...transformers];
        }
        if (node.nodeName === "ink-text") {
          let text = squash_text_nodes_1.default(node);
          if (text.length > 0) {
            const currentWidth = widest_line_1.default(text);
            const maxWidth = get_max_width_1.default(yogaNode);
            if (currentWidth > maxWidth) {
              const textWrap = (_a2 = node.style.textWrap) !== null && _a2 !== void 0 ? _a2 : "wrap";
              text = wrap_text_1.default(text, maxWidth, textWrap);
            }
            text = applyPaddingToText(node, text);
            output.write(x, y2, text, { transformers: newTransformers });
          }
          return;
        }
        if (node.nodeName === "ink-box") {
          render_border_1.default(x, y2, node, output);
        }
        if (node.nodeName === "ink-root" || node.nodeName === "ink-box") {
          for (const childNode of node.childNodes) {
            renderNodeToOutput(childNode, output, {
              offsetX: x,
              offsetY: y2,
              transformers: newTransformers,
              skipStaticElements
            });
          }
        }
      }
    };
    exports2.default = renderNodeToOutput;
  }
});

// node_modules/ink/build/output.js
var require_output = __commonJS({
  "node_modules/ink/build/output.js"(exports2) {
    "use strict";
    var __importDefault = exports2 && exports2.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { "default": mod };
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    var slice_ansi_1 = __importDefault(require_slice_ansi());
    var string_width_1 = __importDefault(require_string_width());
    var Output = class {
      constructor(options) {
        this.writes = [];
        const { width, height } = options;
        this.width = width;
        this.height = height;
      }
      write(x, y2, text, options) {
        const { transformers } = options;
        if (!text) {
          return;
        }
        this.writes.push({ x, y: y2, text, transformers });
      }
      get() {
        const output = [];
        for (let y2 = 0; y2 < this.height; y2++) {
          output.push(" ".repeat(this.width));
        }
        for (const write of this.writes) {
          const { x, y: y2, text, transformers } = write;
          const lines = text.split("\n");
          let offsetY = 0;
          for (let line of lines) {
            const currentLine = output[y2 + offsetY];
            if (!currentLine) {
              continue;
            }
            const width = string_width_1.default(line);
            for (const transformer of transformers) {
              line = transformer(line);
            }
            output[y2 + offsetY] = slice_ansi_1.default(currentLine, 0, x) + line + slice_ansi_1.default(currentLine, x + width);
            offsetY++;
          }
        }
        const generatedOutput = output.map((line) => line.trimRight()).join("\n");
        return {
          output: generatedOutput,
          height: output.length
        };
      }
    };
    exports2.default = Output;
  }
});

// node_modules/ink/build/renderer.js
var require_renderer = __commonJS({
  "node_modules/ink/build/renderer.js"(exports2) {
    "use strict";
    var __importDefault = exports2 && exports2.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { "default": mod };
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    var yoga_layout_prebuilt_1 = __importDefault(require_entry_browser());
    var render_node_to_output_1 = __importDefault(require_render_node_to_output());
    var output_1 = __importDefault(require_output());
    exports2.default = (node, terminalWidth) => {
      var _a2;
      node.yogaNode.setWidth(terminalWidth);
      if (node.yogaNode) {
        node.yogaNode.calculateLayout(void 0, void 0, yoga_layout_prebuilt_1.default.DIRECTION_LTR);
        const output = new output_1.default({
          width: node.yogaNode.getComputedWidth(),
          height: node.yogaNode.getComputedHeight()
        });
        render_node_to_output_1.default(node, output, { skipStaticElements: true });
        let staticOutput;
        if ((_a2 = node.staticNode) === null || _a2 === void 0 ? void 0 : _a2.yogaNode) {
          staticOutput = new output_1.default({
            width: node.staticNode.yogaNode.getComputedWidth(),
            height: node.staticNode.yogaNode.getComputedHeight()
          });
          render_node_to_output_1.default(node.staticNode, staticOutput, {
            skipStaticElements: false
          });
        }
        const { output: generatedOutput, height: outputHeight } = output.get();
        return {
          output: generatedOutput,
          outputHeight,
          staticOutput: staticOutput ? `${staticOutput.get().output}
` : ""
        };
      }
      return {
        output: "",
        outputHeight: 0,
        staticOutput: ""
      };
    };
  }
});

// node_modules/patch-console/build/index.js
var require_build = __commonJS({
  "node_modules/patch-console/build/index.js"(exports2, module2) {
    "use strict";
    var stream_1 = require("stream");
    var CONSOLE_METHODS = [
      "assert",
      "count",
      "countReset",
      "debug",
      "dir",
      "dirxml",
      "error",
      "group",
      "groupCollapsed",
      "groupEnd",
      "info",
      "log",
      "table",
      "time",
      "timeEnd",
      "timeLog",
      "trace",
      "warn"
    ];
    var originalMethods = {};
    var patchConsole = (callback) => {
      const stdout = new stream_1.PassThrough();
      const stderr = new stream_1.PassThrough();
      stdout.write = (data) => callback("stdout", data);
      stderr.write = (data) => callback("stderr", data);
      const internalConsole = new console.Console(stdout, stderr);
      for (const method of CONSOLE_METHODS) {
        originalMethods[method] = console[method];
        console[method] = internalConsole[method];
      }
      return () => {
        for (const method of CONSOLE_METHODS) {
          console[method] = originalMethods[method];
        }
        originalMethods = {};
      };
    };
    module2.exports = patchConsole;
  }
});

// node_modules/ink/build/instances.js
var require_instances = __commonJS({
  "node_modules/ink/build/instances.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.default = new WeakMap();
  }
});

// node_modules/ink/build/components/AppContext.js
var require_AppContext = __commonJS({
  "node_modules/ink/build/components/AppContext.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var react_1 = require_react();
    var AppContext = react_1.createContext({
      exit: () => {
      }
    });
    AppContext.displayName = "InternalAppContext";
    exports2.default = AppContext;
  }
});

// node_modules/ink/build/components/StdinContext.js
var require_StdinContext = __commonJS({
  "node_modules/ink/build/components/StdinContext.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var react_1 = require_react();
    var StdinContext = react_1.createContext({
      stdin: void 0,
      setRawMode: () => {
      },
      isRawModeSupported: false,
      internal_exitOnCtrlC: true
    });
    StdinContext.displayName = "InternalStdinContext";
    exports2.default = StdinContext;
  }
});

// node_modules/ink/build/components/StdoutContext.js
var require_StdoutContext = __commonJS({
  "node_modules/ink/build/components/StdoutContext.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var react_1 = require_react();
    var StdoutContext = react_1.createContext({
      stdout: void 0,
      write: () => {
      }
    });
    StdoutContext.displayName = "InternalStdoutContext";
    exports2.default = StdoutContext;
  }
});

// node_modules/ink/build/components/StderrContext.js
var require_StderrContext = __commonJS({
  "node_modules/ink/build/components/StderrContext.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var react_1 = require_react();
    var StderrContext = react_1.createContext({
      stderr: void 0,
      write: () => {
      }
    });
    StderrContext.displayName = "InternalStderrContext";
    exports2.default = StderrContext;
  }
});

// node_modules/ink/build/components/FocusContext.js
var require_FocusContext = __commonJS({
  "node_modules/ink/build/components/FocusContext.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var react_1 = require_react();
    var FocusContext = react_1.createContext({
      activeId: void 0,
      add: () => {
      },
      remove: () => {
      },
      activate: () => {
      },
      deactivate: () => {
      },
      enableFocus: () => {
      },
      disableFocus: () => {
      },
      focusNext: () => {
      },
      focusPrevious: () => {
      }
    });
    FocusContext.displayName = "InternalFocusContext";
    exports2.default = FocusContext;
  }
});

// node_modules/stack-utils/node_modules/escape-string-regexp/index.js
var require_escape_string_regexp = __commonJS({
  "node_modules/stack-utils/node_modules/escape-string-regexp/index.js"(exports2, module2) {
    "use strict";
    var matchOperatorsRegex = /[|\\{}()[\]^$+*?.-]/g;
    module2.exports = (string) => {
      if (typeof string !== "string") {
        throw new TypeError("Expected a string");
      }
      return string.replace(matchOperatorsRegex, "\\$&");
    };
  }
});

// node_modules/stack-utils/index.js
var require_stack_utils = __commonJS({
  "node_modules/stack-utils/index.js"(exports2, module2) {
    "use strict";
    var escapeStringRegexp = require_escape_string_regexp();
    var cwd = typeof process === "object" && process && typeof process.cwd === "function" ? process.cwd() : ".";
    var natives = [].concat(require("module").builtinModules, "bootstrap_node", "node").map((n2) => new RegExp(`(?:\\((?:node:)?${n2}(?:\\.js)?:\\d+:\\d+\\)$|^\\s*at (?:node:)?${n2}(?:\\.js)?:\\d+:\\d+$)`));
    natives.push(/\((?:node:)?internal\/[^:]+:\d+:\d+\)$/, /\s*at (?:node:)?internal\/[^:]+:\d+:\d+$/, /\/\.node-spawn-wrap-\w+-\w+\/node:\d+:\d+\)?$/);
    var StackUtils = class {
      constructor(opts) {
        opts = __spreadValues({
          ignoredPackages: []
        }, opts);
        if ("internals" in opts === false) {
          opts.internals = StackUtils.nodeInternals();
        }
        if ("cwd" in opts === false) {
          opts.cwd = cwd;
        }
        this._cwd = opts.cwd.replace(/\\/g, "/");
        this._internals = [].concat(opts.internals, ignoredPackagesRegExp(opts.ignoredPackages));
        this._wrapCallSite = opts.wrapCallSite || false;
      }
      static nodeInternals() {
        return [...natives];
      }
      clean(stack, indent = 0) {
        indent = " ".repeat(indent);
        if (!Array.isArray(stack)) {
          stack = stack.split("\n");
        }
        if (!/^\s*at /.test(stack[0]) && /^\s*at /.test(stack[1])) {
          stack = stack.slice(1);
        }
        let outdent = false;
        let lastNonAtLine = null;
        const result2 = [];
        stack.forEach((st) => {
          st = st.replace(/\\/g, "/");
          if (this._internals.some((internal) => internal.test(st))) {
            return;
          }
          const isAtLine = /^\s*at /.test(st);
          if (outdent) {
            st = st.trimEnd().replace(/^(\s+)at /, "$1");
          } else {
            st = st.trim();
            if (isAtLine) {
              st = st.slice(3);
            }
          }
          st = st.replace(`${this._cwd}/`, "");
          if (st) {
            if (isAtLine) {
              if (lastNonAtLine) {
                result2.push(lastNonAtLine);
                lastNonAtLine = null;
              }
              result2.push(st);
            } else {
              outdent = true;
              lastNonAtLine = st;
            }
          }
        });
        return result2.map((line) => `${indent}${line}
`).join("");
      }
      captureString(limit, fn = this.captureString) {
        if (typeof limit === "function") {
          fn = limit;
          limit = Infinity;
        }
        const { stackTraceLimit } = Error;
        if (limit) {
          Error.stackTraceLimit = limit;
        }
        const obj = {};
        Error.captureStackTrace(obj, fn);
        const { stack } = obj;
        Error.stackTraceLimit = stackTraceLimit;
        return this.clean(stack);
      }
      capture(limit, fn = this.capture) {
        if (typeof limit === "function") {
          fn = limit;
          limit = Infinity;
        }
        const { prepareStackTrace, stackTraceLimit } = Error;
        Error.prepareStackTrace = (obj2, site) => {
          if (this._wrapCallSite) {
            return site.map(this._wrapCallSite);
          }
          return site;
        };
        if (limit) {
          Error.stackTraceLimit = limit;
        }
        const obj = {};
        Error.captureStackTrace(obj, fn);
        const { stack } = obj;
        Object.assign(Error, { prepareStackTrace, stackTraceLimit });
        return stack;
      }
      at(fn = this.at) {
        const [site] = this.capture(1, fn);
        if (!site) {
          return {};
        }
        const res = {
          line: site.getLineNumber(),
          column: site.getColumnNumber()
        };
        setFile(res, site.getFileName(), this._cwd);
        if (site.isConstructor()) {
          res.constructor = true;
        }
        if (site.isEval()) {
          res.evalOrigin = site.getEvalOrigin();
        }
        if (site.isNative()) {
          res.native = true;
        }
        let typename;
        try {
          typename = site.getTypeName();
        } catch (_) {
        }
        if (typename && typename !== "Object" && typename !== "[object Object]") {
          res.type = typename;
        }
        const fname = site.getFunctionName();
        if (fname) {
          res.function = fname;
        }
        const meth = site.getMethodName();
        if (meth && fname !== meth) {
          res.method = meth;
        }
        return res;
      }
      parseLine(line) {
        const match = line && line.match(re);
        if (!match) {
          return null;
        }
        const ctor = match[1] === "new";
        let fname = match[2];
        const evalOrigin = match[3];
        const evalFile = match[4];
        const evalLine = Number(match[5]);
        const evalCol = Number(match[6]);
        let file = match[7];
        const lnum = match[8];
        const col = match[9];
        const native = match[10] === "native";
        const closeParen = match[11] === ")";
        let method;
        const res = {};
        if (lnum) {
          res.line = Number(lnum);
        }
        if (col) {
          res.column = Number(col);
        }
        if (closeParen && file) {
          let closes = 0;
          for (let i3 = file.length - 1; i3 > 0; i3--) {
            if (file.charAt(i3) === ")") {
              closes++;
            } else if (file.charAt(i3) === "(" && file.charAt(i3 - 1) === " ") {
              closes--;
              if (closes === -1 && file.charAt(i3 - 1) === " ") {
                const before = file.slice(0, i3 - 1);
                const after = file.slice(i3 + 1);
                file = after;
                fname += ` (${before}`;
                break;
              }
            }
          }
        }
        if (fname) {
          const methodMatch = fname.match(methodRe);
          if (methodMatch) {
            fname = methodMatch[1];
            method = methodMatch[2];
          }
        }
        setFile(res, file, this._cwd);
        if (ctor) {
          res.constructor = true;
        }
        if (evalOrigin) {
          res.evalOrigin = evalOrigin;
          res.evalLine = evalLine;
          res.evalColumn = evalCol;
          res.evalFile = evalFile && evalFile.replace(/\\/g, "/");
        }
        if (native) {
          res.native = true;
        }
        if (fname) {
          res.function = fname;
        }
        if (method && fname !== method) {
          res.method = method;
        }
        return res;
      }
    };
    function setFile(result2, filename, cwd2) {
      if (filename) {
        filename = filename.replace(/\\/g, "/");
        if (filename.startsWith(`${cwd2}/`)) {
          filename = filename.slice(cwd2.length + 1);
        }
        result2.file = filename;
      }
    }
    function ignoredPackagesRegExp(ignoredPackages) {
      if (ignoredPackages.length === 0) {
        return [];
      }
      const packages = ignoredPackages.map((mod) => escapeStringRegexp(mod));
      return new RegExp(`[/\\\\]node_modules[/\\\\](?:${packages.join("|")})[/\\\\][^:]+:\\d+:\\d+`);
    }
    var re = new RegExp("^(?:\\s*at )?(?:(new) )?(?:(.*?) \\()?(?:eval at ([^ ]+) \\((.+?):(\\d+):(\\d+)\\), )?(?:(.+?):(\\d+):(\\d+)|(native))(\\)?)$");
    var methodRe = /^(.*?) \[as (.*?)\]$/;
    module2.exports = StackUtils;
  }
});

// node_modules/convert-to-spaces/index.js
var require_convert_to_spaces = __commonJS({
  "node_modules/convert-to-spaces/index.js"(exports2, module2) {
    "use strict";
    module2.exports = (str2, spaces) => {
      return str2.replace(/^\t+/gm, ($1) => " ".repeat($1.length * (spaces || 2)));
    };
  }
});

// node_modules/code-excerpt/index.js
var require_code_excerpt = __commonJS({
  "node_modules/code-excerpt/index.js"(exports2, module2) {
    "use strict";
    var tabsToSpaces = require_convert_to_spaces();
    var generateLineNumbers = (line, around) => {
      const lineNumbers = [];
      const min = line - around;
      const max = line + around;
      for (let lineNumber = min; lineNumber <= max; lineNumber++) {
        lineNumbers.push(lineNumber);
      }
      return lineNumbers;
    };
    module2.exports = (source, line, options) => {
      if (typeof source !== "string") {
        throw new TypeError("Source code is missing.");
      }
      if (!line || line < 1) {
        throw new TypeError("Line number must start from `1`.");
      }
      source = tabsToSpaces(source).split(/\r?\n/);
      if (line > source.length) {
        return;
      }
      options = __spreadValues({
        around: 3
      }, options);
      return generateLineNumbers(line, options.around).filter((line2) => source[line2 - 1] !== void 0).map((line2) => ({ line: line2, value: source[line2 - 1] }));
    };
  }
});

// node_modules/ink/build/components/Box.js
var require_Box = __commonJS({
  "node_modules/ink/build/components/Box.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o2, m, k, k2) {
      if (k2 === void 0)
        k2 = k;
      Object.defineProperty(o2, k2, { enumerable: true, get: function() {
        return m[k];
      } });
    } : function(o2, m, k, k2) {
      if (k2 === void 0)
        k2 = k;
      o2[k2] = m[k];
    });
    var __setModuleDefault = exports2 && exports2.__setModuleDefault || (Object.create ? function(o2, v) {
      Object.defineProperty(o2, "default", { enumerable: true, value: v });
    } : function(o2, v) {
      o2["default"] = v;
    });
    var __importStar = exports2 && exports2.__importStar || function(mod) {
      if (mod && mod.__esModule)
        return mod;
      var result2 = {};
      if (mod != null) {
        for (var k in mod)
          if (k !== "default" && Object.hasOwnProperty.call(mod, k))
            __createBinding(result2, mod, k);
      }
      __setModuleDefault(result2, mod);
      return result2;
    };
    var __rest = exports2 && exports2.__rest || function(s2, e2) {
      var t2 = {};
      for (var p in s2)
        if (Object.prototype.hasOwnProperty.call(s2, p) && e2.indexOf(p) < 0)
          t2[p] = s2[p];
      if (s2 != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i3 = 0, p = Object.getOwnPropertySymbols(s2); i3 < p.length; i3++) {
          if (e2.indexOf(p[i3]) < 0 && Object.prototype.propertyIsEnumerable.call(s2, p[i3]))
            t2[p[i3]] = s2[p[i3]];
        }
      return t2;
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    var react_1 = __importStar(require_react());
    var Box4 = react_1.forwardRef((_a2, ref2) => {
      var { children } = _a2, style = __rest(_a2, ["children"]);
      const transformedStyle = Object.assign(Object.assign({}, style), { marginLeft: style.marginLeft || style.marginX || style.margin || 0, marginRight: style.marginRight || style.marginX || style.margin || 0, marginTop: style.marginTop || style.marginY || style.margin || 0, marginBottom: style.marginBottom || style.marginY || style.margin || 0, paddingLeft: style.paddingLeft || style.paddingX || style.padding || 0, paddingRight: style.paddingRight || style.paddingX || style.padding || 0, paddingTop: style.paddingTop || style.paddingY || style.padding || 0, paddingBottom: style.paddingBottom || style.paddingY || style.padding || 0 });
      return react_1.default.createElement("ink-box", { ref: ref2, style: transformedStyle }, children);
    });
    Box4.displayName = "Box";
    Box4.defaultProps = {
      flexDirection: "row",
      flexGrow: 0,
      flexShrink: 1
    };
    exports2.default = Box4;
  }
});

// node_modules/ink/build/components/Text.js
var require_Text = __commonJS({
  "node_modules/ink/build/components/Text.js"(exports2) {
    "use strict";
    var __importDefault = exports2 && exports2.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { "default": mod };
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    var react_1 = __importDefault(require_react());
    var chalk_1 = __importDefault(require_source());
    var colorize_1 = __importDefault(require_colorize());
    var Text4 = ({ color, backgroundColor, dimColor, bold, italic, underline, strikethrough, inverse, wrap, children }) => {
      if (children === void 0 || children === null) {
        return null;
      }
      const transform = (children2) => {
        if (dimColor) {
          children2 = chalk_1.default.dim(children2);
        }
        if (color) {
          children2 = colorize_1.default(children2, color, "foreground");
        }
        if (backgroundColor) {
          children2 = colorize_1.default(children2, backgroundColor, "background");
        }
        if (bold) {
          children2 = chalk_1.default.bold(children2);
        }
        if (italic) {
          children2 = chalk_1.default.italic(children2);
        }
        if (underline) {
          children2 = chalk_1.default.underline(children2);
        }
        if (strikethrough) {
          children2 = chalk_1.default.strikethrough(children2);
        }
        if (inverse) {
          children2 = chalk_1.default.inverse(children2);
        }
        return children2;
      };
      return react_1.default.createElement("ink-text", { style: { flexGrow: 0, flexShrink: 1, flexDirection: "row", textWrap: wrap }, internal_transform: transform }, children);
    };
    Text4.displayName = "Text";
    Text4.defaultProps = {
      dimColor: false,
      bold: false,
      italic: false,
      underline: false,
      strikethrough: false,
      wrap: "wrap"
    };
    exports2.default = Text4;
  }
});

// node_modules/ink/build/components/ErrorOverview.js
var require_ErrorOverview = __commonJS({
  "node_modules/ink/build/components/ErrorOverview.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o2, m, k, k2) {
      if (k2 === void 0)
        k2 = k;
      Object.defineProperty(o2, k2, { enumerable: true, get: function() {
        return m[k];
      } });
    } : function(o2, m, k, k2) {
      if (k2 === void 0)
        k2 = k;
      o2[k2] = m[k];
    });
    var __setModuleDefault = exports2 && exports2.__setModuleDefault || (Object.create ? function(o2, v) {
      Object.defineProperty(o2, "default", { enumerable: true, value: v });
    } : function(o2, v) {
      o2["default"] = v;
    });
    var __importStar = exports2 && exports2.__importStar || function(mod) {
      if (mod && mod.__esModule)
        return mod;
      var result2 = {};
      if (mod != null) {
        for (var k in mod)
          if (k !== "default" && Object.hasOwnProperty.call(mod, k))
            __createBinding(result2, mod, k);
      }
      __setModuleDefault(result2, mod);
      return result2;
    };
    var __importDefault = exports2 && exports2.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { "default": mod };
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    var fs5 = __importStar(require("fs"));
    var react_1 = __importDefault(require_react());
    var stack_utils_1 = __importDefault(require_stack_utils());
    var code_excerpt_1 = __importDefault(require_code_excerpt());
    var Box_1 = __importDefault(require_Box());
    var Text_1 = __importDefault(require_Text());
    var stackUtils = new stack_utils_1.default({
      cwd: process.cwd(),
      internals: stack_utils_1.default.nodeInternals()
    });
    var ErrorOverview = ({ error }) => {
      const stack = error.stack ? error.stack.split("\n").slice(1) : void 0;
      const origin = stack ? stackUtils.parseLine(stack[0]) : void 0;
      let excerpt;
      let lineWidth = 0;
      if ((origin === null || origin === void 0 ? void 0 : origin.file) && (origin === null || origin === void 0 ? void 0 : origin.line) && fs5.existsSync(origin.file)) {
        const sourceCode2 = fs5.readFileSync(origin.file, "utf8");
        excerpt = code_excerpt_1.default(sourceCode2, origin.line);
        if (excerpt) {
          for (const { line } of excerpt) {
            lineWidth = Math.max(lineWidth, String(line).length);
          }
        }
      }
      return react_1.default.createElement(Box_1.default, { flexDirection: "column", padding: 1 }, react_1.default.createElement(Box_1.default, null, react_1.default.createElement(Text_1.default, { backgroundColor: "red", color: "white" }, " ", "ERROR", " "), react_1.default.createElement(Text_1.default, null, " ", error.message)), origin && react_1.default.createElement(Box_1.default, { marginTop: 1 }, react_1.default.createElement(Text_1.default, { dimColor: true }, origin.file, ":", origin.line, ":", origin.column)), origin && excerpt && react_1.default.createElement(Box_1.default, { marginTop: 1, flexDirection: "column" }, excerpt.map(({ line, value }) => react_1.default.createElement(Box_1.default, { key: line }, react_1.default.createElement(Box_1.default, { width: lineWidth + 1 }, react_1.default.createElement(Text_1.default, { dimColor: line !== origin.line, backgroundColor: line === origin.line ? "red" : void 0, color: line === origin.line ? "white" : void 0 }, String(line).padStart(lineWidth, " "), ":")), react_1.default.createElement(Text_1.default, { key: line, backgroundColor: line === origin.line ? "red" : void 0, color: line === origin.line ? "white" : void 0 }, " " + value)))), error.stack && react_1.default.createElement(Box_1.default, { marginTop: 1, flexDirection: "column" }, error.stack.split("\n").slice(1).map((line) => {
        const parsedLine = stackUtils.parseLine(line);
        if (!parsedLine) {
          return react_1.default.createElement(Box_1.default, { key: line }, react_1.default.createElement(Text_1.default, { dimColor: true }, "- "), react_1.default.createElement(Text_1.default, { dimColor: true, bold: true }, line));
        }
        return react_1.default.createElement(Box_1.default, { key: line }, react_1.default.createElement(Text_1.default, { dimColor: true }, "- "), react_1.default.createElement(Text_1.default, { dimColor: true, bold: true }, parsedLine.function), react_1.default.createElement(Text_1.default, { dimColor: true, color: "gray" }, " ", "(", parsedLine.file, ":", parsedLine.line, ":", parsedLine.column, ")"));
      })));
    };
    exports2.default = ErrorOverview;
  }
});

// node_modules/ink/build/components/App.js
var require_App = __commonJS({
  "node_modules/ink/build/components/App.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o2, m, k, k2) {
      if (k2 === void 0)
        k2 = k;
      Object.defineProperty(o2, k2, { enumerable: true, get: function() {
        return m[k];
      } });
    } : function(o2, m, k, k2) {
      if (k2 === void 0)
        k2 = k;
      o2[k2] = m[k];
    });
    var __setModuleDefault = exports2 && exports2.__setModuleDefault || (Object.create ? function(o2, v) {
      Object.defineProperty(o2, "default", { enumerable: true, value: v });
    } : function(o2, v) {
      o2["default"] = v;
    });
    var __importStar = exports2 && exports2.__importStar || function(mod) {
      if (mod && mod.__esModule)
        return mod;
      var result2 = {};
      if (mod != null) {
        for (var k in mod)
          if (k !== "default" && Object.hasOwnProperty.call(mod, k))
            __createBinding(result2, mod, k);
      }
      __setModuleDefault(result2, mod);
      return result2;
    };
    var __importDefault = exports2 && exports2.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { "default": mod };
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    var react_1 = __importStar(require_react());
    var cli_cursor_1 = __importDefault(require_cli_cursor());
    var AppContext_1 = __importDefault(require_AppContext());
    var StdinContext_1 = __importDefault(require_StdinContext());
    var StdoutContext_1 = __importDefault(require_StdoutContext());
    var StderrContext_1 = __importDefault(require_StderrContext());
    var FocusContext_1 = __importDefault(require_FocusContext());
    var ErrorOverview_1 = __importDefault(require_ErrorOverview());
    var TAB = "	";
    var SHIFT_TAB = "[Z";
    var ESC = "";
    var App = class extends react_1.PureComponent {
      constructor() {
        super(...arguments);
        this.state = {
          isFocusEnabled: true,
          activeFocusId: void 0,
          focusables: [],
          error: void 0
        };
        this.rawModeEnabledCount = 0;
        this.handleSetRawMode = (isEnabled) => {
          const { stdin } = this.props;
          if (!this.isRawModeSupported()) {
            if (stdin === process.stdin) {
              throw new Error("Raw mode is not supported on the current process.stdin, which Ink uses as input stream by default.\nRead about how to prevent this error on https://github.com/vadimdemedes/ink/#israwmodesupported");
            } else {
              throw new Error("Raw mode is not supported on the stdin provided to Ink.\nRead about how to prevent this error on https://github.com/vadimdemedes/ink/#israwmodesupported");
            }
          }
          stdin.setEncoding("utf8");
          if (isEnabled) {
            if (this.rawModeEnabledCount === 0) {
              stdin.addListener("data", this.handleInput);
              stdin.resume();
              stdin.setRawMode(true);
            }
            this.rawModeEnabledCount++;
            return;
          }
          if (--this.rawModeEnabledCount === 0) {
            stdin.setRawMode(false);
            stdin.removeListener("data", this.handleInput);
            stdin.pause();
          }
        };
        this.handleInput = (input) => {
          if (input === "" && this.props.exitOnCtrlC) {
            this.handleExit();
          }
          if (input === ESC && this.state.activeFocusId) {
            this.setState({
              activeFocusId: void 0
            });
          }
          if (this.state.isFocusEnabled && this.state.focusables.length > 0) {
            if (input === TAB) {
              this.focusNext();
            }
            if (input === SHIFT_TAB) {
              this.focusPrevious();
            }
          }
        };
        this.handleExit = (error) => {
          if (this.isRawModeSupported()) {
            this.handleSetRawMode(false);
          }
          this.props.onExit(error);
        };
        this.enableFocus = () => {
          this.setState({
            isFocusEnabled: true
          });
        };
        this.disableFocus = () => {
          this.setState({
            isFocusEnabled: false
          });
        };
        this.focusNext = () => {
          this.setState((previousState) => {
            var _a2;
            const firstFocusableId = (_a2 = previousState.focusables[0]) === null || _a2 === void 0 ? void 0 : _a2.id;
            const nextFocusableId = this.findNextFocusable(previousState);
            return {
              activeFocusId: nextFocusableId || firstFocusableId
            };
          });
        };
        this.focusPrevious = () => {
          this.setState((previousState) => {
            var _a2;
            const lastFocusableId = (_a2 = previousState.focusables[previousState.focusables.length - 1]) === null || _a2 === void 0 ? void 0 : _a2.id;
            const previousFocusableId = this.findPreviousFocusable(previousState);
            return {
              activeFocusId: previousFocusableId || lastFocusableId
            };
          });
        };
        this.addFocusable = (id, { autoFocus }) => {
          this.setState((previousState) => {
            let nextFocusId = previousState.activeFocusId;
            if (!nextFocusId && autoFocus) {
              nextFocusId = id;
            }
            return {
              activeFocusId: nextFocusId,
              focusables: [
                ...previousState.focusables,
                {
                  id,
                  isActive: true
                }
              ]
            };
          });
        };
        this.removeFocusable = (id) => {
          this.setState((previousState) => ({
            activeFocusId: previousState.activeFocusId === id ? void 0 : previousState.activeFocusId,
            focusables: previousState.focusables.filter((focusable) => {
              return focusable.id !== id;
            })
          }));
        };
        this.activateFocusable = (id) => {
          this.setState((previousState) => ({
            focusables: previousState.focusables.map((focusable) => {
              if (focusable.id !== id) {
                return focusable;
              }
              return {
                id,
                isActive: true
              };
            })
          }));
        };
        this.deactivateFocusable = (id) => {
          this.setState((previousState) => ({
            activeFocusId: previousState.activeFocusId === id ? void 0 : previousState.activeFocusId,
            focusables: previousState.focusables.map((focusable) => {
              if (focusable.id !== id) {
                return focusable;
              }
              return {
                id,
                isActive: false
              };
            })
          }));
        };
        this.findNextFocusable = (state) => {
          var _a2;
          const activeIndex = state.focusables.findIndex((focusable) => {
            return focusable.id === state.activeFocusId;
          });
          for (let index = activeIndex + 1; index < state.focusables.length; index++) {
            if ((_a2 = state.focusables[index]) === null || _a2 === void 0 ? void 0 : _a2.isActive) {
              return state.focusables[index].id;
            }
          }
          return void 0;
        };
        this.findPreviousFocusable = (state) => {
          var _a2;
          const activeIndex = state.focusables.findIndex((focusable) => {
            return focusable.id === state.activeFocusId;
          });
          for (let index = activeIndex - 1; index >= 0; index--) {
            if ((_a2 = state.focusables[index]) === null || _a2 === void 0 ? void 0 : _a2.isActive) {
              return state.focusables[index].id;
            }
          }
          return void 0;
        };
      }
      static getDerivedStateFromError(error) {
        return { error };
      }
      isRawModeSupported() {
        return this.props.stdin.isTTY;
      }
      render() {
        return react_1.default.createElement(AppContext_1.default.Provider, { value: {
          exit: this.handleExit
        } }, react_1.default.createElement(StdinContext_1.default.Provider, { value: {
          stdin: this.props.stdin,
          setRawMode: this.handleSetRawMode,
          isRawModeSupported: this.isRawModeSupported(),
          internal_exitOnCtrlC: this.props.exitOnCtrlC
        } }, react_1.default.createElement(StdoutContext_1.default.Provider, { value: {
          stdout: this.props.stdout,
          write: this.props.writeToStdout
        } }, react_1.default.createElement(StderrContext_1.default.Provider, { value: {
          stderr: this.props.stderr,
          write: this.props.writeToStderr
        } }, react_1.default.createElement(FocusContext_1.default.Provider, { value: {
          activeId: this.state.activeFocusId,
          add: this.addFocusable,
          remove: this.removeFocusable,
          activate: this.activateFocusable,
          deactivate: this.deactivateFocusable,
          enableFocus: this.enableFocus,
          disableFocus: this.disableFocus,
          focusNext: this.focusNext,
          focusPrevious: this.focusPrevious
        } }, this.state.error ? react_1.default.createElement(ErrorOverview_1.default, { error: this.state.error }) : this.props.children)))));
      }
      componentDidMount() {
        cli_cursor_1.default.hide(this.props.stdout);
      }
      componentWillUnmount() {
        cli_cursor_1.default.show(this.props.stdout);
        if (this.isRawModeSupported()) {
          this.handleSetRawMode(false);
        }
      }
      componentDidCatch(error) {
        this.handleExit(error);
      }
    };
    exports2.default = App;
    App.displayName = "InternalApp";
  }
});

// node_modules/ink/build/ink.js
var require_ink = __commonJS({
  "node_modules/ink/build/ink.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o2, m, k, k2) {
      if (k2 === void 0)
        k2 = k;
      Object.defineProperty(o2, k2, { enumerable: true, get: function() {
        return m[k];
      } });
    } : function(o2, m, k, k2) {
      if (k2 === void 0)
        k2 = k;
      o2[k2] = m[k];
    });
    var __setModuleDefault = exports2 && exports2.__setModuleDefault || (Object.create ? function(o2, v) {
      Object.defineProperty(o2, "default", { enumerable: true, value: v });
    } : function(o2, v) {
      o2["default"] = v;
    });
    var __importStar = exports2 && exports2.__importStar || function(mod) {
      if (mod && mod.__esModule)
        return mod;
      var result2 = {};
      if (mod != null) {
        for (var k in mod)
          if (k !== "default" && Object.hasOwnProperty.call(mod, k))
            __createBinding(result2, mod, k);
      }
      __setModuleDefault(result2, mod);
      return result2;
    };
    var __importDefault = exports2 && exports2.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { "default": mod };
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    var react_1 = __importDefault(require_react());
    var lodash_1 = require_lodash();
    var log_update_1 = __importDefault(require_log_update());
    var ansi_escapes_1 = __importDefault(require_ansi_escapes());
    var is_ci_1 = __importDefault(require_is_ci());
    var auto_bind_1 = __importDefault(require_auto_bind());
    var reconciler_1 = __importDefault(require_reconciler());
    var renderer_1 = __importDefault(require_renderer());
    var signal_exit_1 = __importDefault(require_signal_exit());
    var patch_console_1 = __importDefault(require_build());
    var dom = __importStar(require_dom());
    var instances_1 = __importDefault(require_instances());
    var App_1 = __importDefault(require_App());
    var isCI = process.env.CI === "false" ? false : is_ci_1.default;
    var noop = () => {
    };
    var Ink = class {
      constructor(options) {
        this.resolveExitPromise = () => {
        };
        this.rejectExitPromise = () => {
        };
        this.unsubscribeExit = () => {
        };
        this.onRender = () => {
          if (this.isUnmounted) {
            return;
          }
          const { output, outputHeight, staticOutput } = renderer_1.default(this.rootNode, this.options.stdout.columns || 80);
          const hasStaticOutput = staticOutput && staticOutput !== "\n";
          if (this.options.debug) {
            if (hasStaticOutput) {
              this.fullStaticOutput += staticOutput;
            }
            this.options.stdout.write(this.fullStaticOutput + output);
            return;
          }
          if (isCI) {
            if (hasStaticOutput) {
              this.options.stdout.write(staticOutput);
            }
            this.lastOutput = output;
            return;
          }
          if (hasStaticOutput) {
            this.fullStaticOutput += staticOutput;
          }
          if (outputHeight >= this.options.stdout.rows) {
            this.options.stdout.write(ansi_escapes_1.default.clearTerminal + this.fullStaticOutput + output);
            this.lastOutput = output;
            return;
          }
          if (hasStaticOutput) {
            this.log.clear();
            this.options.stdout.write(staticOutput);
            this.log(output);
          }
          if (!hasStaticOutput && output !== this.lastOutput) {
            this.throttledLog(output);
          }
          this.lastOutput = output;
        };
        auto_bind_1.default(this);
        this.options = options;
        this.rootNode = dom.createNode("ink-root");
        this.rootNode.onRender = options.debug ? this.onRender : lodash_1.throttle(this.onRender, 32, {
          leading: true,
          trailing: true
        });
        this.rootNode.onImmediateRender = this.onRender;
        this.log = log_update_1.default.create(options.stdout);
        this.throttledLog = options.debug ? this.log : lodash_1.throttle(this.log, void 0, {
          leading: true,
          trailing: true
        });
        this.isUnmounted = false;
        this.lastOutput = "";
        this.fullStaticOutput = "";
        this.container = reconciler_1.default.createContainer(this.rootNode, false, false);
        this.unsubscribeExit = signal_exit_1.default(this.unmount, { alwaysLast: false });
        if (process.env.DEV === "true") {
          reconciler_1.default.injectIntoDevTools({
            bundleType: 0,
            version: "16.13.1",
            rendererPackageName: "ink"
          });
        }
        if (options.patchConsole) {
          this.patchConsole();
        }
        if (!isCI) {
          options.stdout.on("resize", this.onRender);
          this.unsubscribeResize = () => {
            options.stdout.off("resize", this.onRender);
          };
        }
      }
      render(node) {
        const tree = react_1.default.createElement(App_1.default, { stdin: this.options.stdin, stdout: this.options.stdout, stderr: this.options.stderr, writeToStdout: this.writeToStdout, writeToStderr: this.writeToStderr, exitOnCtrlC: this.options.exitOnCtrlC, onExit: this.unmount }, node);
        reconciler_1.default.updateContainer(tree, this.container, null, noop);
      }
      writeToStdout(data) {
        if (this.isUnmounted) {
          return;
        }
        if (this.options.debug) {
          this.options.stdout.write(data + this.fullStaticOutput + this.lastOutput);
          return;
        }
        if (isCI) {
          this.options.stdout.write(data);
          return;
        }
        this.log.clear();
        this.options.stdout.write(data);
        this.log(this.lastOutput);
      }
      writeToStderr(data) {
        if (this.isUnmounted) {
          return;
        }
        if (this.options.debug) {
          this.options.stderr.write(data);
          this.options.stdout.write(this.fullStaticOutput + this.lastOutput);
          return;
        }
        if (isCI) {
          this.options.stderr.write(data);
          return;
        }
        this.log.clear();
        this.options.stderr.write(data);
        this.log(this.lastOutput);
      }
      unmount(error) {
        if (this.isUnmounted) {
          return;
        }
        this.onRender();
        this.unsubscribeExit();
        if (typeof this.restoreConsole === "function") {
          this.restoreConsole();
        }
        if (typeof this.unsubscribeResize === "function") {
          this.unsubscribeResize();
        }
        if (isCI) {
          this.options.stdout.write(this.lastOutput + "\n");
        } else if (!this.options.debug) {
          this.log.done();
        }
        this.isUnmounted = true;
        reconciler_1.default.updateContainer(null, this.container, null, noop);
        instances_1.default.delete(this.options.stdout);
        if (error instanceof Error) {
          this.rejectExitPromise(error);
        } else {
          this.resolveExitPromise();
        }
      }
      waitUntilExit() {
        if (!this.exitPromise) {
          this.exitPromise = new Promise((resolve, reject) => {
            this.resolveExitPromise = resolve;
            this.rejectExitPromise = reject;
          });
        }
        return this.exitPromise;
      }
      clear() {
        if (!isCI && !this.options.debug) {
          this.log.clear();
        }
      }
      patchConsole() {
        if (this.options.debug) {
          return;
        }
        this.restoreConsole = patch_console_1.default((stream, data) => {
          if (stream === "stdout") {
            this.writeToStdout(data);
          }
          if (stream === "stderr") {
            const isReactMessage = data.startsWith("The above error occurred");
            if (!isReactMessage) {
              this.writeToStderr(data);
            }
          }
        });
      }
    };
    exports2.default = Ink;
  }
});

// node_modules/ink/build/render.js
var require_render = __commonJS({
  "node_modules/ink/build/render.js"(exports2) {
    "use strict";
    var __importDefault = exports2 && exports2.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { "default": mod };
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    var ink_1 = __importDefault(require_ink());
    var instances_1 = __importDefault(require_instances());
    var stream_1 = require("stream");
    var render2 = (node, options) => {
      const inkOptions = Object.assign({ stdout: process.stdout, stdin: process.stdin, stderr: process.stderr, debug: false, exitOnCtrlC: true, patchConsole: true }, getOptions(options));
      const instance = getInstance(inkOptions.stdout, () => new ink_1.default(inkOptions));
      instance.render(node);
      return {
        rerender: instance.render,
        unmount: () => instance.unmount(),
        waitUntilExit: instance.waitUntilExit,
        cleanup: () => instances_1.default.delete(inkOptions.stdout),
        clear: instance.clear
      };
    };
    exports2.default = render2;
    var getOptions = (stdout = {}) => {
      if (stdout instanceof stream_1.Stream) {
        return {
          stdout,
          stdin: process.stdin
        };
      }
      return stdout;
    };
    var getInstance = (stdout, createInstance) => {
      let instance;
      if (instances_1.default.has(stdout)) {
        instance = instances_1.default.get(stdout);
      } else {
        instance = createInstance();
        instances_1.default.set(stdout, instance);
      }
      return instance;
    };
  }
});

// node_modules/ink/build/components/Static.js
var require_Static = __commonJS({
  "node_modules/ink/build/components/Static.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o2, m, k, k2) {
      if (k2 === void 0)
        k2 = k;
      Object.defineProperty(o2, k2, { enumerable: true, get: function() {
        return m[k];
      } });
    } : function(o2, m, k, k2) {
      if (k2 === void 0)
        k2 = k;
      o2[k2] = m[k];
    });
    var __setModuleDefault = exports2 && exports2.__setModuleDefault || (Object.create ? function(o2, v) {
      Object.defineProperty(o2, "default", { enumerable: true, value: v });
    } : function(o2, v) {
      o2["default"] = v;
    });
    var __importStar = exports2 && exports2.__importStar || function(mod) {
      if (mod && mod.__esModule)
        return mod;
      var result2 = {};
      if (mod != null) {
        for (var k in mod)
          if (k !== "default" && Object.hasOwnProperty.call(mod, k))
            __createBinding(result2, mod, k);
      }
      __setModuleDefault(result2, mod);
      return result2;
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    var react_1 = __importStar(require_react());
    var Static = (props) => {
      const { items, children: render2, style: customStyle } = props;
      const [index, setIndex] = react_1.useState(0);
      const itemsToRender = react_1.useMemo(() => {
        return items.slice(index);
      }, [items, index]);
      react_1.useLayoutEffect(() => {
        setIndex(items.length);
      }, [items.length]);
      const children = itemsToRender.map((item, itemIndex) => {
        return render2(item, index + itemIndex);
      });
      const style = react_1.useMemo(() => Object.assign({ position: "absolute", flexDirection: "column" }, customStyle), [customStyle]);
      return react_1.default.createElement("ink-box", {
        internal_static: true,
        style
      }, children);
    };
    Static.displayName = "Static";
    exports2.default = Static;
  }
});

// node_modules/ink/build/components/Transform.js
var require_Transform = __commonJS({
  "node_modules/ink/build/components/Transform.js"(exports2) {
    "use strict";
    var __importDefault = exports2 && exports2.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { "default": mod };
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    var react_1 = __importDefault(require_react());
    var Transform = ({ children, transform }) => {
      if (children === void 0 || children === null) {
        return null;
      }
      return react_1.default.createElement("ink-text", { style: { flexGrow: 0, flexShrink: 1, flexDirection: "row" }, internal_transform: transform }, children);
    };
    Transform.displayName = "Transform";
    exports2.default = Transform;
  }
});

// node_modules/ink/build/components/Newline.js
var require_Newline = __commonJS({
  "node_modules/ink/build/components/Newline.js"(exports2) {
    "use strict";
    var __importDefault = exports2 && exports2.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { "default": mod };
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    var react_1 = __importDefault(require_react());
    var Newline2 = ({ count = 1 }) => react_1.default.createElement("ink-text", null, "\n".repeat(count));
    Newline2.displayName = "Newline";
    exports2.default = Newline2;
  }
});

// node_modules/ink/build/components/Spacer.js
var require_Spacer = __commonJS({
  "node_modules/ink/build/components/Spacer.js"(exports2) {
    "use strict";
    var __importDefault = exports2 && exports2.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { "default": mod };
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    var react_1 = __importDefault(require_react());
    var Box_1 = __importDefault(require_Box());
    var Spacer = () => react_1.default.createElement(Box_1.default, { flexGrow: 1 });
    Spacer.displayName = "Spacer";
    exports2.default = Spacer;
  }
});

// node_modules/ink/build/hooks/use-stdin.js
var require_use_stdin = __commonJS({
  "node_modules/ink/build/hooks/use-stdin.js"(exports2) {
    "use strict";
    var __importDefault = exports2 && exports2.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { "default": mod };
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    var react_1 = require_react();
    var StdinContext_1 = __importDefault(require_StdinContext());
    var useStdin = () => react_1.useContext(StdinContext_1.default);
    exports2.default = useStdin;
  }
});

// node_modules/ink/build/hooks/use-input.js
var require_use_input = __commonJS({
  "node_modules/ink/build/hooks/use-input.js"(exports2) {
    "use strict";
    var __importDefault = exports2 && exports2.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { "default": mod };
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    var react_1 = require_react();
    var use_stdin_1 = __importDefault(require_use_stdin());
    var useInput = (inputHandler, options = {}) => {
      const { stdin, setRawMode, internal_exitOnCtrlC } = use_stdin_1.default();
      react_1.useEffect(() => {
        if (options.isActive === false) {
          return;
        }
        setRawMode(true);
        return () => {
          setRawMode(false);
        };
      }, [options.isActive, setRawMode]);
      react_1.useEffect(() => {
        if (options.isActive === false) {
          return;
        }
        const handleData = (data) => {
          let input = String(data);
          const key2 = {
            upArrow: input === "[A",
            downArrow: input === "[B",
            leftArrow: input === "[D",
            rightArrow: input === "[C",
            pageDown: input === "[6~",
            pageUp: input === "[5~",
            return: input === "\r",
            escape: input === "",
            ctrl: false,
            shift: false,
            tab: input === "	" || input === "[Z",
            backspace: input === "\b",
            delete: input === "\x7F" || input === "[3~",
            meta: false
          };
          if (input <= "" && !key2.return) {
            input = String.fromCharCode(input.charCodeAt(0) + "a".charCodeAt(0) - 1);
            key2.ctrl = true;
          }
          if (input.startsWith("")) {
            input = input.slice(1);
            key2.meta = true;
          }
          const isLatinUppercase = input >= "A" && input <= "Z";
          const isCyrillicUppercase = input >= "\u0410" && input <= "\u042F";
          if (input.length === 1 && (isLatinUppercase || isCyrillicUppercase)) {
            key2.shift = true;
          }
          if (key2.tab && input === "[Z") {
            key2.shift = true;
          }
          if (key2.tab || key2.backspace || key2.delete) {
            input = "";
          }
          if (!(input === "c" && key2.ctrl) || !internal_exitOnCtrlC) {
            inputHandler(input, key2);
          }
        };
        stdin === null || stdin === void 0 ? void 0 : stdin.on("data", handleData);
        return () => {
          stdin === null || stdin === void 0 ? void 0 : stdin.off("data", handleData);
        };
      }, [options.isActive, stdin, internal_exitOnCtrlC, inputHandler]);
    };
    exports2.default = useInput;
  }
});

// node_modules/ink/build/hooks/use-app.js
var require_use_app = __commonJS({
  "node_modules/ink/build/hooks/use-app.js"(exports2) {
    "use strict";
    var __importDefault = exports2 && exports2.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { "default": mod };
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    var react_1 = require_react();
    var AppContext_1 = __importDefault(require_AppContext());
    var useApp = () => react_1.useContext(AppContext_1.default);
    exports2.default = useApp;
  }
});

// node_modules/ink/build/hooks/use-stdout.js
var require_use_stdout = __commonJS({
  "node_modules/ink/build/hooks/use-stdout.js"(exports2) {
    "use strict";
    var __importDefault = exports2 && exports2.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { "default": mod };
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    var react_1 = require_react();
    var StdoutContext_1 = __importDefault(require_StdoutContext());
    var useStdout = () => react_1.useContext(StdoutContext_1.default);
    exports2.default = useStdout;
  }
});

// node_modules/ink/build/hooks/use-stderr.js
var require_use_stderr = __commonJS({
  "node_modules/ink/build/hooks/use-stderr.js"(exports2) {
    "use strict";
    var __importDefault = exports2 && exports2.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { "default": mod };
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    var react_1 = require_react();
    var StderrContext_1 = __importDefault(require_StderrContext());
    var useStderr = () => react_1.useContext(StderrContext_1.default);
    exports2.default = useStderr;
  }
});

// node_modules/ink/build/hooks/use-focus.js
var require_use_focus = __commonJS({
  "node_modules/ink/build/hooks/use-focus.js"(exports2) {
    "use strict";
    var __importDefault = exports2 && exports2.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { "default": mod };
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    var react_1 = require_react();
    var FocusContext_1 = __importDefault(require_FocusContext());
    var use_stdin_1 = __importDefault(require_use_stdin());
    var useFocus = ({ isActive = true, autoFocus = false } = {}) => {
      const { isRawModeSupported, setRawMode } = use_stdin_1.default();
      const { activeId, add, remove, activate, deactivate } = react_1.useContext(FocusContext_1.default);
      const id = react_1.useMemo(() => Math.random().toString().slice(2, 7), []);
      react_1.useEffect(() => {
        add(id, { autoFocus });
        return () => {
          remove(id);
        };
      }, [id, autoFocus]);
      react_1.useEffect(() => {
        if (isActive) {
          activate(id);
        } else {
          deactivate(id);
        }
      }, [isActive, id]);
      react_1.useEffect(() => {
        if (!isRawModeSupported || !isActive) {
          return;
        }
        setRawMode(true);
        return () => {
          setRawMode(false);
        };
      }, [isActive]);
      return {
        isFocused: Boolean(id) && activeId === id
      };
    };
    exports2.default = useFocus;
  }
});

// node_modules/ink/build/hooks/use-focus-manager.js
var require_use_focus_manager = __commonJS({
  "node_modules/ink/build/hooks/use-focus-manager.js"(exports2) {
    "use strict";
    var __importDefault = exports2 && exports2.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { "default": mod };
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    var react_1 = require_react();
    var FocusContext_1 = __importDefault(require_FocusContext());
    var useFocusManager = () => {
      const focusContext = react_1.useContext(FocusContext_1.default);
      return {
        enableFocus: focusContext.enableFocus,
        disableFocus: focusContext.disableFocus,
        focusNext: focusContext.focusNext,
        focusPrevious: focusContext.focusPrevious
      };
    };
    exports2.default = useFocusManager;
  }
});

// node_modules/ink/build/measure-element.js
var require_measure_element = __commonJS({
  "node_modules/ink/build/measure-element.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.default = (node) => {
      var _a2, _b, _c, _d;
      return {
        width: (_b = (_a2 = node.yogaNode) === null || _a2 === void 0 ? void 0 : _a2.getComputedWidth()) !== null && _b !== void 0 ? _b : 0,
        height: (_d = (_c = node.yogaNode) === null || _c === void 0 ? void 0 : _c.getComputedHeight()) !== null && _d !== void 0 ? _d : 0
      };
    };
  }
});

// node_modules/ink/build/index.js
var require_build2 = __commonJS({
  "node_modules/ink/build/index.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var render_1 = require_render();
    Object.defineProperty(exports2, "render", { enumerable: true, get: function() {
      return render_1.default;
    } });
    var Box_1 = require_Box();
    Object.defineProperty(exports2, "Box", { enumerable: true, get: function() {
      return Box_1.default;
    } });
    var Text_1 = require_Text();
    Object.defineProperty(exports2, "Text", { enumerable: true, get: function() {
      return Text_1.default;
    } });
    var Static_1 = require_Static();
    Object.defineProperty(exports2, "Static", { enumerable: true, get: function() {
      return Static_1.default;
    } });
    var Transform_1 = require_Transform();
    Object.defineProperty(exports2, "Transform", { enumerable: true, get: function() {
      return Transform_1.default;
    } });
    var Newline_1 = require_Newline();
    Object.defineProperty(exports2, "Newline", { enumerable: true, get: function() {
      return Newline_1.default;
    } });
    var Spacer_1 = require_Spacer();
    Object.defineProperty(exports2, "Spacer", { enumerable: true, get: function() {
      return Spacer_1.default;
    } });
    var use_input_1 = require_use_input();
    Object.defineProperty(exports2, "useInput", { enumerable: true, get: function() {
      return use_input_1.default;
    } });
    var use_app_1 = require_use_app();
    Object.defineProperty(exports2, "useApp", { enumerable: true, get: function() {
      return use_app_1.default;
    } });
    var use_stdin_1 = require_use_stdin();
    Object.defineProperty(exports2, "useStdin", { enumerable: true, get: function() {
      return use_stdin_1.default;
    } });
    var use_stdout_1 = require_use_stdout();
    Object.defineProperty(exports2, "useStdout", { enumerable: true, get: function() {
      return use_stdout_1.default;
    } });
    var use_stderr_1 = require_use_stderr();
    Object.defineProperty(exports2, "useStderr", { enumerable: true, get: function() {
      return use_stderr_1.default;
    } });
    var use_focus_1 = require_use_focus();
    Object.defineProperty(exports2, "useFocus", { enumerable: true, get: function() {
      return use_focus_1.default;
    } });
    var use_focus_manager_1 = require_use_focus_manager();
    Object.defineProperty(exports2, "useFocusManager", { enumerable: true, get: function() {
      return use_focus_manager_1.default;
    } });
    var measure_element_1 = require_measure_element();
    Object.defineProperty(exports2, "measureElement", { enumerable: true, get: function() {
      return measure_element_1.default;
    } });
  }
});

// node_modules/cli-spinners/spinners.json
var require_spinners = __commonJS({
  "node_modules/cli-spinners/spinners.json"(exports2, module2) {
    module2.exports = {
      dots: {
        interval: 80,
        frames: [
          "\u280B",
          "\u2819",
          "\u2839",
          "\u2838",
          "\u283C",
          "\u2834",
          "\u2826",
          "\u2827",
          "\u2807",
          "\u280F"
        ]
      },
      dots2: {
        interval: 80,
        frames: [
          "\u28FE",
          "\u28FD",
          "\u28FB",
          "\u28BF",
          "\u287F",
          "\u28DF",
          "\u28EF",
          "\u28F7"
        ]
      },
      dots3: {
        interval: 80,
        frames: [
          "\u280B",
          "\u2819",
          "\u281A",
          "\u281E",
          "\u2816",
          "\u2826",
          "\u2834",
          "\u2832",
          "\u2833",
          "\u2813"
        ]
      },
      dots4: {
        interval: 80,
        frames: [
          "\u2804",
          "\u2806",
          "\u2807",
          "\u280B",
          "\u2819",
          "\u2838",
          "\u2830",
          "\u2820",
          "\u2830",
          "\u2838",
          "\u2819",
          "\u280B",
          "\u2807",
          "\u2806"
        ]
      },
      dots5: {
        interval: 80,
        frames: [
          "\u280B",
          "\u2819",
          "\u281A",
          "\u2812",
          "\u2802",
          "\u2802",
          "\u2812",
          "\u2832",
          "\u2834",
          "\u2826",
          "\u2816",
          "\u2812",
          "\u2810",
          "\u2810",
          "\u2812",
          "\u2813",
          "\u280B"
        ]
      },
      dots6: {
        interval: 80,
        frames: [
          "\u2801",
          "\u2809",
          "\u2819",
          "\u281A",
          "\u2812",
          "\u2802",
          "\u2802",
          "\u2812",
          "\u2832",
          "\u2834",
          "\u2824",
          "\u2804",
          "\u2804",
          "\u2824",
          "\u2834",
          "\u2832",
          "\u2812",
          "\u2802",
          "\u2802",
          "\u2812",
          "\u281A",
          "\u2819",
          "\u2809",
          "\u2801"
        ]
      },
      dots7: {
        interval: 80,
        frames: [
          "\u2808",
          "\u2809",
          "\u280B",
          "\u2813",
          "\u2812",
          "\u2810",
          "\u2810",
          "\u2812",
          "\u2816",
          "\u2826",
          "\u2824",
          "\u2820",
          "\u2820",
          "\u2824",
          "\u2826",
          "\u2816",
          "\u2812",
          "\u2810",
          "\u2810",
          "\u2812",
          "\u2813",
          "\u280B",
          "\u2809",
          "\u2808"
        ]
      },
      dots8: {
        interval: 80,
        frames: [
          "\u2801",
          "\u2801",
          "\u2809",
          "\u2819",
          "\u281A",
          "\u2812",
          "\u2802",
          "\u2802",
          "\u2812",
          "\u2832",
          "\u2834",
          "\u2824",
          "\u2804",
          "\u2804",
          "\u2824",
          "\u2820",
          "\u2820",
          "\u2824",
          "\u2826",
          "\u2816",
          "\u2812",
          "\u2810",
          "\u2810",
          "\u2812",
          "\u2813",
          "\u280B",
          "\u2809",
          "\u2808",
          "\u2808"
        ]
      },
      dots9: {
        interval: 80,
        frames: [
          "\u28B9",
          "\u28BA",
          "\u28BC",
          "\u28F8",
          "\u28C7",
          "\u2867",
          "\u2857",
          "\u284F"
        ]
      },
      dots10: {
        interval: 80,
        frames: [
          "\u2884",
          "\u2882",
          "\u2881",
          "\u2841",
          "\u2848",
          "\u2850",
          "\u2860"
        ]
      },
      dots11: {
        interval: 100,
        frames: [
          "\u2801",
          "\u2802",
          "\u2804",
          "\u2840",
          "\u2880",
          "\u2820",
          "\u2810",
          "\u2808"
        ]
      },
      dots12: {
        interval: 80,
        frames: [
          "\u2880\u2800",
          "\u2840\u2800",
          "\u2804\u2800",
          "\u2882\u2800",
          "\u2842\u2800",
          "\u2805\u2800",
          "\u2883\u2800",
          "\u2843\u2800",
          "\u280D\u2800",
          "\u288B\u2800",
          "\u284B\u2800",
          "\u280D\u2801",
          "\u288B\u2801",
          "\u284B\u2801",
          "\u280D\u2809",
          "\u280B\u2809",
          "\u280B\u2809",
          "\u2809\u2819",
          "\u2809\u2819",
          "\u2809\u2829",
          "\u2808\u2899",
          "\u2808\u2859",
          "\u2888\u2829",
          "\u2840\u2899",
          "\u2804\u2859",
          "\u2882\u2829",
          "\u2842\u2898",
          "\u2805\u2858",
          "\u2883\u2828",
          "\u2843\u2890",
          "\u280D\u2850",
          "\u288B\u2820",
          "\u284B\u2880",
          "\u280D\u2841",
          "\u288B\u2801",
          "\u284B\u2801",
          "\u280D\u2809",
          "\u280B\u2809",
          "\u280B\u2809",
          "\u2809\u2819",
          "\u2809\u2819",
          "\u2809\u2829",
          "\u2808\u2899",
          "\u2808\u2859",
          "\u2808\u2829",
          "\u2800\u2899",
          "\u2800\u2859",
          "\u2800\u2829",
          "\u2800\u2898",
          "\u2800\u2858",
          "\u2800\u2828",
          "\u2800\u2890",
          "\u2800\u2850",
          "\u2800\u2820",
          "\u2800\u2880",
          "\u2800\u2840"
        ]
      },
      dots8Bit: {
        interval: 80,
        frames: [
          "\u2800",
          "\u2801",
          "\u2802",
          "\u2803",
          "\u2804",
          "\u2805",
          "\u2806",
          "\u2807",
          "\u2840",
          "\u2841",
          "\u2842",
          "\u2843",
          "\u2844",
          "\u2845",
          "\u2846",
          "\u2847",
          "\u2808",
          "\u2809",
          "\u280A",
          "\u280B",
          "\u280C",
          "\u280D",
          "\u280E",
          "\u280F",
          "\u2848",
          "\u2849",
          "\u284A",
          "\u284B",
          "\u284C",
          "\u284D",
          "\u284E",
          "\u284F",
          "\u2810",
          "\u2811",
          "\u2812",
          "\u2813",
          "\u2814",
          "\u2815",
          "\u2816",
          "\u2817",
          "\u2850",
          "\u2851",
          "\u2852",
          "\u2853",
          "\u2854",
          "\u2855",
          "\u2856",
          "\u2857",
          "\u2818",
          "\u2819",
          "\u281A",
          "\u281B",
          "\u281C",
          "\u281D",
          "\u281E",
          "\u281F",
          "\u2858",
          "\u2859",
          "\u285A",
          "\u285B",
          "\u285C",
          "\u285D",
          "\u285E",
          "\u285F",
          "\u2820",
          "\u2821",
          "\u2822",
          "\u2823",
          "\u2824",
          "\u2825",
          "\u2826",
          "\u2827",
          "\u2860",
          "\u2861",
          "\u2862",
          "\u2863",
          "\u2864",
          "\u2865",
          "\u2866",
          "\u2867",
          "\u2828",
          "\u2829",
          "\u282A",
          "\u282B",
          "\u282C",
          "\u282D",
          "\u282E",
          "\u282F",
          "\u2868",
          "\u2869",
          "\u286A",
          "\u286B",
          "\u286C",
          "\u286D",
          "\u286E",
          "\u286F",
          "\u2830",
          "\u2831",
          "\u2832",
          "\u2833",
          "\u2834",
          "\u2835",
          "\u2836",
          "\u2837",
          "\u2870",
          "\u2871",
          "\u2872",
          "\u2873",
          "\u2874",
          "\u2875",
          "\u2876",
          "\u2877",
          "\u2838",
          "\u2839",
          "\u283A",
          "\u283B",
          "\u283C",
          "\u283D",
          "\u283E",
          "\u283F",
          "\u2878",
          "\u2879",
          "\u287A",
          "\u287B",
          "\u287C",
          "\u287D",
          "\u287E",
          "\u287F",
          "\u2880",
          "\u2881",
          "\u2882",
          "\u2883",
          "\u2884",
          "\u2885",
          "\u2886",
          "\u2887",
          "\u28C0",
          "\u28C1",
          "\u28C2",
          "\u28C3",
          "\u28C4",
          "\u28C5",
          "\u28C6",
          "\u28C7",
          "\u2888",
          "\u2889",
          "\u288A",
          "\u288B",
          "\u288C",
          "\u288D",
          "\u288E",
          "\u288F",
          "\u28C8",
          "\u28C9",
          "\u28CA",
          "\u28CB",
          "\u28CC",
          "\u28CD",
          "\u28CE",
          "\u28CF",
          "\u2890",
          "\u2891",
          "\u2892",
          "\u2893",
          "\u2894",
          "\u2895",
          "\u2896",
          "\u2897",
          "\u28D0",
          "\u28D1",
          "\u28D2",
          "\u28D3",
          "\u28D4",
          "\u28D5",
          "\u28D6",
          "\u28D7",
          "\u2898",
          "\u2899",
          "\u289A",
          "\u289B",
          "\u289C",
          "\u289D",
          "\u289E",
          "\u289F",
          "\u28D8",
          "\u28D9",
          "\u28DA",
          "\u28DB",
          "\u28DC",
          "\u28DD",
          "\u28DE",
          "\u28DF",
          "\u28A0",
          "\u28A1",
          "\u28A2",
          "\u28A3",
          "\u28A4",
          "\u28A5",
          "\u28A6",
          "\u28A7",
          "\u28E0",
          "\u28E1",
          "\u28E2",
          "\u28E3",
          "\u28E4",
          "\u28E5",
          "\u28E6",
          "\u28E7",
          "\u28A8",
          "\u28A9",
          "\u28AA",
          "\u28AB",
          "\u28AC",
          "\u28AD",
          "\u28AE",
          "\u28AF",
          "\u28E8",
          "\u28E9",
          "\u28EA",
          "\u28EB",
          "\u28EC",
          "\u28ED",
          "\u28EE",
          "\u28EF",
          "\u28B0",
          "\u28B1",
          "\u28B2",
          "\u28B3",
          "\u28B4",
          "\u28B5",
          "\u28B6",
          "\u28B7",
          "\u28F0",
          "\u28F1",
          "\u28F2",
          "\u28F3",
          "\u28F4",
          "\u28F5",
          "\u28F6",
          "\u28F7",
          "\u28B8",
          "\u28B9",
          "\u28BA",
          "\u28BB",
          "\u28BC",
          "\u28BD",
          "\u28BE",
          "\u28BF",
          "\u28F8",
          "\u28F9",
          "\u28FA",
          "\u28FB",
          "\u28FC",
          "\u28FD",
          "\u28FE",
          "\u28FF"
        ]
      },
      line: {
        interval: 130,
        frames: [
          "-",
          "\\",
          "|",
          "/"
        ]
      },
      line2: {
        interval: 100,
        frames: [
          "\u2802",
          "-",
          "\u2013",
          "\u2014",
          "\u2013",
          "-"
        ]
      },
      pipe: {
        interval: 100,
        frames: [
          "\u2524",
          "\u2518",
          "\u2534",
          "\u2514",
          "\u251C",
          "\u250C",
          "\u252C",
          "\u2510"
        ]
      },
      simpleDots: {
        interval: 400,
        frames: [
          ".  ",
          ".. ",
          "...",
          "   "
        ]
      },
      simpleDotsScrolling: {
        interval: 200,
        frames: [
          ".  ",
          ".. ",
          "...",
          " ..",
          "  .",
          "   "
        ]
      },
      star: {
        interval: 70,
        frames: [
          "\u2736",
          "\u2738",
          "\u2739",
          "\u273A",
          "\u2739",
          "\u2737"
        ]
      },
      star2: {
        interval: 80,
        frames: [
          "+",
          "x",
          "*"
        ]
      },
      flip: {
        interval: 70,
        frames: [
          "_",
          "_",
          "_",
          "-",
          "`",
          "`",
          "'",
          "\xB4",
          "-",
          "_",
          "_",
          "_"
        ]
      },
      hamburger: {
        interval: 100,
        frames: [
          "\u2631",
          "\u2632",
          "\u2634"
        ]
      },
      growVertical: {
        interval: 120,
        frames: [
          "\u2581",
          "\u2583",
          "\u2584",
          "\u2585",
          "\u2586",
          "\u2587",
          "\u2586",
          "\u2585",
          "\u2584",
          "\u2583"
        ]
      },
      growHorizontal: {
        interval: 120,
        frames: [
          "\u258F",
          "\u258E",
          "\u258D",
          "\u258C",
          "\u258B",
          "\u258A",
          "\u2589",
          "\u258A",
          "\u258B",
          "\u258C",
          "\u258D",
          "\u258E"
        ]
      },
      balloon: {
        interval: 140,
        frames: [
          " ",
          ".",
          "o",
          "O",
          "@",
          "*",
          " "
        ]
      },
      balloon2: {
        interval: 120,
        frames: [
          ".",
          "o",
          "O",
          "\xB0",
          "O",
          "o",
          "."
        ]
      },
      noise: {
        interval: 100,
        frames: [
          "\u2593",
          "\u2592",
          "\u2591"
        ]
      },
      bounce: {
        interval: 120,
        frames: [
          "\u2801",
          "\u2802",
          "\u2804",
          "\u2802"
        ]
      },
      boxBounce: {
        interval: 120,
        frames: [
          "\u2596",
          "\u2598",
          "\u259D",
          "\u2597"
        ]
      },
      boxBounce2: {
        interval: 100,
        frames: [
          "\u258C",
          "\u2580",
          "\u2590",
          "\u2584"
        ]
      },
      triangle: {
        interval: 50,
        frames: [
          "\u25E2",
          "\u25E3",
          "\u25E4",
          "\u25E5"
        ]
      },
      arc: {
        interval: 100,
        frames: [
          "\u25DC",
          "\u25E0",
          "\u25DD",
          "\u25DE",
          "\u25E1",
          "\u25DF"
        ]
      },
      circle: {
        interval: 120,
        frames: [
          "\u25E1",
          "\u2299",
          "\u25E0"
        ]
      },
      squareCorners: {
        interval: 180,
        frames: [
          "\u25F0",
          "\u25F3",
          "\u25F2",
          "\u25F1"
        ]
      },
      circleQuarters: {
        interval: 120,
        frames: [
          "\u25F4",
          "\u25F7",
          "\u25F6",
          "\u25F5"
        ]
      },
      circleHalves: {
        interval: 50,
        frames: [
          "\u25D0",
          "\u25D3",
          "\u25D1",
          "\u25D2"
        ]
      },
      squish: {
        interval: 100,
        frames: [
          "\u256B",
          "\u256A"
        ]
      },
      toggle: {
        interval: 250,
        frames: [
          "\u22B6",
          "\u22B7"
        ]
      },
      toggle2: {
        interval: 80,
        frames: [
          "\u25AB",
          "\u25AA"
        ]
      },
      toggle3: {
        interval: 120,
        frames: [
          "\u25A1",
          "\u25A0"
        ]
      },
      toggle4: {
        interval: 100,
        frames: [
          "\u25A0",
          "\u25A1",
          "\u25AA",
          "\u25AB"
        ]
      },
      toggle5: {
        interval: 100,
        frames: [
          "\u25AE",
          "\u25AF"
        ]
      },
      toggle6: {
        interval: 300,
        frames: [
          "\u101D",
          "\u1040"
        ]
      },
      toggle7: {
        interval: 80,
        frames: [
          "\u29BE",
          "\u29BF"
        ]
      },
      toggle8: {
        interval: 100,
        frames: [
          "\u25CD",
          "\u25CC"
        ]
      },
      toggle9: {
        interval: 100,
        frames: [
          "\u25C9",
          "\u25CE"
        ]
      },
      toggle10: {
        interval: 100,
        frames: [
          "\u3282",
          "\u3280",
          "\u3281"
        ]
      },
      toggle11: {
        interval: 50,
        frames: [
          "\u29C7",
          "\u29C6"
        ]
      },
      toggle12: {
        interval: 120,
        frames: [
          "\u2617",
          "\u2616"
        ]
      },
      toggle13: {
        interval: 80,
        frames: [
          "=",
          "*",
          "-"
        ]
      },
      arrow: {
        interval: 100,
        frames: [
          "\u2190",
          "\u2196",
          "\u2191",
          "\u2197",
          "\u2192",
          "\u2198",
          "\u2193",
          "\u2199"
        ]
      },
      arrow2: {
        interval: 80,
        frames: [
          "\u2B06\uFE0F ",
          "\u2197\uFE0F ",
          "\u27A1\uFE0F ",
          "\u2198\uFE0F ",
          "\u2B07\uFE0F ",
          "\u2199\uFE0F ",
          "\u2B05\uFE0F ",
          "\u2196\uFE0F "
        ]
      },
      arrow3: {
        interval: 120,
        frames: [
          "\u25B9\u25B9\u25B9\u25B9\u25B9",
          "\u25B8\u25B9\u25B9\u25B9\u25B9",
          "\u25B9\u25B8\u25B9\u25B9\u25B9",
          "\u25B9\u25B9\u25B8\u25B9\u25B9",
          "\u25B9\u25B9\u25B9\u25B8\u25B9",
          "\u25B9\u25B9\u25B9\u25B9\u25B8"
        ]
      },
      bouncingBar: {
        interval: 80,
        frames: [
          "[    ]",
          "[=   ]",
          "[==  ]",
          "[=== ]",
          "[ ===]",
          "[  ==]",
          "[   =]",
          "[    ]",
          "[   =]",
          "[  ==]",
          "[ ===]",
          "[====]",
          "[=== ]",
          "[==  ]",
          "[=   ]"
        ]
      },
      bouncingBall: {
        interval: 80,
        frames: [
          "( \u25CF    )",
          "(  \u25CF   )",
          "(   \u25CF  )",
          "(    \u25CF )",
          "(     \u25CF)",
          "(    \u25CF )",
          "(   \u25CF  )",
          "(  \u25CF   )",
          "( \u25CF    )",
          "(\u25CF     )"
        ]
      },
      smiley: {
        interval: 200,
        frames: [
          "\u{1F604} ",
          "\u{1F61D} "
        ]
      },
      monkey: {
        interval: 300,
        frames: [
          "\u{1F648} ",
          "\u{1F648} ",
          "\u{1F649} ",
          "\u{1F64A} "
        ]
      },
      hearts: {
        interval: 100,
        frames: [
          "\u{1F49B} ",
          "\u{1F499} ",
          "\u{1F49C} ",
          "\u{1F49A} ",
          "\u2764\uFE0F "
        ]
      },
      clock: {
        interval: 100,
        frames: [
          "\u{1F55B} ",
          "\u{1F550} ",
          "\u{1F551} ",
          "\u{1F552} ",
          "\u{1F553} ",
          "\u{1F554} ",
          "\u{1F555} ",
          "\u{1F556} ",
          "\u{1F557} ",
          "\u{1F558} ",
          "\u{1F559} ",
          "\u{1F55A} "
        ]
      },
      earth: {
        interval: 180,
        frames: [
          "\u{1F30D} ",
          "\u{1F30E} ",
          "\u{1F30F} "
        ]
      },
      material: {
        interval: 17,
        frames: [
          "\u2588\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581",
          "\u2588\u2588\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581",
          "\u2588\u2588\u2588\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581",
          "\u2588\u2588\u2588\u2588\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581",
          "\u2588\u2588\u2588\u2588\u2588\u2588\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581",
          "\u2588\u2588\u2588\u2588\u2588\u2588\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581",
          "\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581",
          "\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581",
          "\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581",
          "\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581",
          "\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581",
          "\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581",
          "\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2581\u2581\u2581\u2581\u2581\u2581\u2581",
          "\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2581\u2581\u2581\u2581\u2581\u2581",
          "\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2581\u2581\u2581\u2581\u2581\u2581",
          "\u2581\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2581\u2581\u2581\u2581\u2581",
          "\u2581\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2581\u2581\u2581\u2581\u2581",
          "\u2581\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2581\u2581\u2581\u2581\u2581",
          "\u2581\u2581\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2581\u2581\u2581\u2581",
          "\u2581\u2581\u2581\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2581\u2581\u2581",
          "\u2581\u2581\u2581\u2581\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2581\u2581\u2581",
          "\u2581\u2581\u2581\u2581\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2581\u2581",
          "\u2581\u2581\u2581\u2581\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2581\u2581",
          "\u2581\u2581\u2581\u2581\u2581\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2581",
          "\u2581\u2581\u2581\u2581\u2581\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2581",
          "\u2581\u2581\u2581\u2581\u2581\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2581",
          "\u2581\u2581\u2581\u2581\u2581\u2581\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588",
          "\u2581\u2581\u2581\u2581\u2581\u2581\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588",
          "\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588",
          "\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588",
          "\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588",
          "\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588",
          "\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588",
          "\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588",
          "\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588",
          "\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588",
          "\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588",
          "\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2588\u2588\u2588\u2588\u2588\u2588\u2588",
          "\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2588\u2588\u2588\u2588\u2588\u2588",
          "\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2588\u2588\u2588\u2588\u2588",
          "\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2588\u2588\u2588\u2588\u2588",
          "\u2588\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2588\u2588\u2588\u2588",
          "\u2588\u2588\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2588\u2588\u2588",
          "\u2588\u2588\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2588\u2588\u2588",
          "\u2588\u2588\u2588\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2588\u2588\u2588",
          "\u2588\u2588\u2588\u2588\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2588\u2588",
          "\u2588\u2588\u2588\u2588\u2588\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2588",
          "\u2588\u2588\u2588\u2588\u2588\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2588",
          "\u2588\u2588\u2588\u2588\u2588\u2588\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2588",
          "\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581",
          "\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581",
          "\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581",
          "\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581",
          "\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581",
          "\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581",
          "\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581",
          "\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581",
          "\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2581\u2581\u2581\u2581\u2581\u2581",
          "\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2581\u2581\u2581\u2581\u2581\u2581",
          "\u2581\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2581\u2581\u2581\u2581\u2581",
          "\u2581\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2581\u2581\u2581\u2581\u2581",
          "\u2581\u2581\u2581\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2581\u2581\u2581\u2581",
          "\u2581\u2581\u2581\u2581\u2581\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2581\u2581\u2581",
          "\u2581\u2581\u2581\u2581\u2581\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2581\u2581\u2581",
          "\u2581\u2581\u2581\u2581\u2581\u2581\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2581\u2581\u2581",
          "\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2581\u2581\u2581",
          "\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2581\u2581\u2581",
          "\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2581\u2581",
          "\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2581\u2581",
          "\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2581",
          "\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2581",
          "\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2581",
          "\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2581",
          "\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2581",
          "\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2588\u2588\u2588\u2588\u2588\u2588\u2588",
          "\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2588\u2588\u2588\u2588\u2588\u2588\u2588",
          "\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2588\u2588\u2588\u2588\u2588",
          "\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2588\u2588\u2588\u2588",
          "\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2588\u2588\u2588\u2588",
          "\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2588\u2588\u2588\u2588",
          "\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2588\u2588\u2588",
          "\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2588\u2588\u2588",
          "\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2588\u2588",
          "\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2588\u2588",
          "\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2588\u2588",
          "\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2588",
          "\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2588",
          "\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2588",
          "\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581",
          "\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581",
          "\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581",
          "\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581\u2581"
        ]
      },
      moon: {
        interval: 80,
        frames: [
          "\u{1F311} ",
          "\u{1F312} ",
          "\u{1F313} ",
          "\u{1F314} ",
          "\u{1F315} ",
          "\u{1F316} ",
          "\u{1F317} ",
          "\u{1F318} "
        ]
      },
      runner: {
        interval: 140,
        frames: [
          "\u{1F6B6} ",
          "\u{1F3C3} "
        ]
      },
      pong: {
        interval: 80,
        frames: [
          "\u2590\u2802       \u258C",
          "\u2590\u2808       \u258C",
          "\u2590 \u2802      \u258C",
          "\u2590 \u2820      \u258C",
          "\u2590  \u2840     \u258C",
          "\u2590  \u2820     \u258C",
          "\u2590   \u2802    \u258C",
          "\u2590   \u2808    \u258C",
          "\u2590    \u2802   \u258C",
          "\u2590    \u2820   \u258C",
          "\u2590     \u2840  \u258C",
          "\u2590     \u2820  \u258C",
          "\u2590      \u2802 \u258C",
          "\u2590      \u2808 \u258C",
          "\u2590       \u2802\u258C",
          "\u2590       \u2820\u258C",
          "\u2590       \u2840\u258C",
          "\u2590      \u2820 \u258C",
          "\u2590      \u2802 \u258C",
          "\u2590     \u2808  \u258C",
          "\u2590     \u2802  \u258C",
          "\u2590    \u2820   \u258C",
          "\u2590    \u2840   \u258C",
          "\u2590   \u2820    \u258C",
          "\u2590   \u2802    \u258C",
          "\u2590  \u2808     \u258C",
          "\u2590  \u2802     \u258C",
          "\u2590 \u2820      \u258C",
          "\u2590 \u2840      \u258C",
          "\u2590\u2820       \u258C"
        ]
      },
      shark: {
        interval: 120,
        frames: [
          "\u2590|\\____________\u258C",
          "\u2590_|\\___________\u258C",
          "\u2590__|\\__________\u258C",
          "\u2590___|\\_________\u258C",
          "\u2590____|\\________\u258C",
          "\u2590_____|\\_______\u258C",
          "\u2590______|\\______\u258C",
          "\u2590_______|\\_____\u258C",
          "\u2590________|\\____\u258C",
          "\u2590_________|\\___\u258C",
          "\u2590__________|\\__\u258C",
          "\u2590___________|\\_\u258C",
          "\u2590____________|\\\u258C",
          "\u2590____________/|\u258C",
          "\u2590___________/|_\u258C",
          "\u2590__________/|__\u258C",
          "\u2590_________/|___\u258C",
          "\u2590________/|____\u258C",
          "\u2590_______/|_____\u258C",
          "\u2590______/|______\u258C",
          "\u2590_____/|_______\u258C",
          "\u2590____/|________\u258C",
          "\u2590___/|_________\u258C",
          "\u2590__/|__________\u258C",
          "\u2590_/|___________\u258C",
          "\u2590/|____________\u258C"
        ]
      },
      dqpb: {
        interval: 100,
        frames: [
          "d",
          "q",
          "p",
          "b"
        ]
      },
      weather: {
        interval: 100,
        frames: [
          "\u2600\uFE0F ",
          "\u2600\uFE0F ",
          "\u2600\uFE0F ",
          "\u{1F324} ",
          "\u26C5\uFE0F ",
          "\u{1F325} ",
          "\u2601\uFE0F ",
          "\u{1F327} ",
          "\u{1F328} ",
          "\u{1F327} ",
          "\u{1F328} ",
          "\u{1F327} ",
          "\u{1F328} ",
          "\u26C8 ",
          "\u{1F328} ",
          "\u{1F327} ",
          "\u{1F328} ",
          "\u2601\uFE0F ",
          "\u{1F325} ",
          "\u26C5\uFE0F ",
          "\u{1F324} ",
          "\u2600\uFE0F ",
          "\u2600\uFE0F "
        ]
      },
      christmas: {
        interval: 400,
        frames: [
          "\u{1F332}",
          "\u{1F384}"
        ]
      },
      grenade: {
        interval: 80,
        frames: [
          "\u060C  ",
          "\u2032  ",
          " \xB4 ",
          " \u203E ",
          "  \u2E0C",
          "  \u2E0A",
          "  |",
          "  \u204E",
          "  \u2055",
          " \u0DF4 ",
          "  \u2053",
          "   ",
          "   ",
          "   "
        ]
      },
      point: {
        interval: 125,
        frames: [
          "\u2219\u2219\u2219",
          "\u25CF\u2219\u2219",
          "\u2219\u25CF\u2219",
          "\u2219\u2219\u25CF",
          "\u2219\u2219\u2219"
        ]
      },
      layer: {
        interval: 150,
        frames: [
          "-",
          "=",
          "\u2261"
        ]
      },
      betaWave: {
        interval: 80,
        frames: [
          "\u03C1\u03B2\u03B2\u03B2\u03B2\u03B2\u03B2",
          "\u03B2\u03C1\u03B2\u03B2\u03B2\u03B2\u03B2",
          "\u03B2\u03B2\u03C1\u03B2\u03B2\u03B2\u03B2",
          "\u03B2\u03B2\u03B2\u03C1\u03B2\u03B2\u03B2",
          "\u03B2\u03B2\u03B2\u03B2\u03C1\u03B2\u03B2",
          "\u03B2\u03B2\u03B2\u03B2\u03B2\u03C1\u03B2",
          "\u03B2\u03B2\u03B2\u03B2\u03B2\u03B2\u03C1"
        ]
      },
      fingerDance: {
        interval: 160,
        frames: [
          "\u{1F918} ",
          "\u{1F91F} ",
          "\u{1F596} ",
          "\u270B ",
          "\u{1F91A} ",
          "\u{1F446} "
        ]
      },
      fistBump: {
        interval: 80,
        frames: [
          "\u{1F91C}\u3000\u3000\u3000\u3000\u{1F91B} ",
          "\u{1F91C}\u3000\u3000\u3000\u3000\u{1F91B} ",
          "\u{1F91C}\u3000\u3000\u3000\u3000\u{1F91B} ",
          "\u3000\u{1F91C}\u3000\u3000\u{1F91B}\u3000 ",
          "\u3000\u3000\u{1F91C}\u{1F91B}\u3000\u3000 ",
          "\u3000\u{1F91C}\u2728\u{1F91B}\u3000\u3000 ",
          "\u{1F91C}\u3000\u2728\u3000\u{1F91B}\u3000 "
        ]
      },
      soccerHeader: {
        interval: 80,
        frames: [
          " \u{1F9D1}\u26BD\uFE0F       \u{1F9D1} ",
          "\u{1F9D1}  \u26BD\uFE0F      \u{1F9D1} ",
          "\u{1F9D1}   \u26BD\uFE0F     \u{1F9D1} ",
          "\u{1F9D1}    \u26BD\uFE0F    \u{1F9D1} ",
          "\u{1F9D1}     \u26BD\uFE0F   \u{1F9D1} ",
          "\u{1F9D1}      \u26BD\uFE0F  \u{1F9D1} ",
          "\u{1F9D1}       \u26BD\uFE0F\u{1F9D1}  ",
          "\u{1F9D1}      \u26BD\uFE0F  \u{1F9D1} ",
          "\u{1F9D1}     \u26BD\uFE0F   \u{1F9D1} ",
          "\u{1F9D1}    \u26BD\uFE0F    \u{1F9D1} ",
          "\u{1F9D1}   \u26BD\uFE0F     \u{1F9D1} ",
          "\u{1F9D1}  \u26BD\uFE0F      \u{1F9D1} "
        ]
      },
      mindblown: {
        interval: 160,
        frames: [
          "\u{1F610} ",
          "\u{1F610} ",
          "\u{1F62E} ",
          "\u{1F62E} ",
          "\u{1F626} ",
          "\u{1F626} ",
          "\u{1F627} ",
          "\u{1F627} ",
          "\u{1F92F} ",
          "\u{1F4A5} ",
          "\u2728 ",
          "\u3000 ",
          "\u3000 ",
          "\u3000 "
        ]
      },
      speaker: {
        interval: 160,
        frames: [
          "\u{1F508} ",
          "\u{1F509} ",
          "\u{1F50A} ",
          "\u{1F509} "
        ]
      },
      orangePulse: {
        interval: 100,
        frames: [
          "\u{1F538} ",
          "\u{1F536} ",
          "\u{1F7E0} ",
          "\u{1F7E0} ",
          "\u{1F536} "
        ]
      },
      bluePulse: {
        interval: 100,
        frames: [
          "\u{1F539} ",
          "\u{1F537} ",
          "\u{1F535} ",
          "\u{1F535} ",
          "\u{1F537} "
        ]
      },
      orangeBluePulse: {
        interval: 100,
        frames: [
          "\u{1F538} ",
          "\u{1F536} ",
          "\u{1F7E0} ",
          "\u{1F7E0} ",
          "\u{1F536} ",
          "\u{1F539} ",
          "\u{1F537} ",
          "\u{1F535} ",
          "\u{1F535} ",
          "\u{1F537} "
        ]
      },
      timeTravel: {
        interval: 100,
        frames: [
          "\u{1F55B} ",
          "\u{1F55A} ",
          "\u{1F559} ",
          "\u{1F558} ",
          "\u{1F557} ",
          "\u{1F556} ",
          "\u{1F555} ",
          "\u{1F554} ",
          "\u{1F553} ",
          "\u{1F552} ",
          "\u{1F551} ",
          "\u{1F550} "
        ]
      },
      aesthetic: {
        interval: 80,
        frames: [
          "\u25B0\u25B1\u25B1\u25B1\u25B1\u25B1\u25B1",
          "\u25B0\u25B0\u25B1\u25B1\u25B1\u25B1\u25B1",
          "\u25B0\u25B0\u25B0\u25B1\u25B1\u25B1\u25B1",
          "\u25B0\u25B0\u25B0\u25B0\u25B1\u25B1\u25B1",
          "\u25B0\u25B0\u25B0\u25B0\u25B0\u25B1\u25B1",
          "\u25B0\u25B0\u25B0\u25B0\u25B0\u25B0\u25B1",
          "\u25B0\u25B0\u25B0\u25B0\u25B0\u25B0\u25B0",
          "\u25B0\u25B1\u25B1\u25B1\u25B1\u25B1\u25B1"
        ]
      }
    };
  }
});

// node_modules/cli-spinners/index.js
var require_cli_spinners = __commonJS({
  "node_modules/cli-spinners/index.js"(exports2, module2) {
    "use strict";
    var spinners = Object.assign({}, require_spinners());
    var spinnersList = Object.keys(spinners);
    Object.defineProperty(spinners, "random", {
      get() {
        const randomIndex = Math.floor(Math.random() * spinnersList.length);
        const spinnerName = spinnersList[randomIndex];
        return spinners[spinnerName];
      }
    });
    module2.exports = spinners;
    module2.exports.default = spinners;
  }
});

// node_modules/ink-spinner/build/index.js
var require_build3 = __commonJS({
  "node_modules/ink-spinner/build/index.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var React7 = require_react();
    var react_1 = require_react();
    var ink_1 = require_build2();
    var spinners = require_cli_spinners();
    var Spinner2 = ({ type: type3 = "dots" }) => {
      const [frame, setFrame] = react_1.useState(0);
      const spinner = spinners[type3];
      react_1.useEffect(() => {
        const timer = setInterval(() => {
          setFrame((previousFrame) => {
            const isLastFrame = previousFrame === spinner.frames.length - 1;
            return isLastFrame ? 0 : previousFrame + 1;
          });
        }, spinner.interval);
        return () => {
          clearInterval(timer);
        };
      }, [spinner]);
      return React7.createElement(ink_1.Text, null, spinner.frames[frame]);
    };
    exports2.default = Spinner2;
  }
});

// node_modules/lodash.isequal/index.js
var require_lodash2 = __commonJS({
  "node_modules/lodash.isequal/index.js"(exports2, module2) {
    var LARGE_ARRAY_SIZE = 200;
    var HASH_UNDEFINED = "__lodash_hash_undefined__";
    var COMPARE_PARTIAL_FLAG = 1;
    var COMPARE_UNORDERED_FLAG = 2;
    var MAX_SAFE_INTEGER = 9007199254740991;
    var argsTag = "[object Arguments]";
    var arrayTag = "[object Array]";
    var asyncTag = "[object AsyncFunction]";
    var boolTag = "[object Boolean]";
    var dateTag = "[object Date]";
    var errorTag = "[object Error]";
    var funcTag = "[object Function]";
    var genTag = "[object GeneratorFunction]";
    var mapTag = "[object Map]";
    var numberTag = "[object Number]";
    var nullTag = "[object Null]";
    var objectTag = "[object Object]";
    var promiseTag = "[object Promise]";
    var proxyTag = "[object Proxy]";
    var regexpTag = "[object RegExp]";
    var setTag = "[object Set]";
    var stringTag = "[object String]";
    var symbolTag = "[object Symbol]";
    var undefinedTag = "[object Undefined]";
    var weakMapTag = "[object WeakMap]";
    var arrayBufferTag = "[object ArrayBuffer]";
    var dataViewTag = "[object DataView]";
    var float32Tag = "[object Float32Array]";
    var float64Tag = "[object Float64Array]";
    var int8Tag = "[object Int8Array]";
    var int16Tag = "[object Int16Array]";
    var int32Tag = "[object Int32Array]";
    var uint8Tag = "[object Uint8Array]";
    var uint8ClampedTag = "[object Uint8ClampedArray]";
    var uint16Tag = "[object Uint16Array]";
    var uint32Tag = "[object Uint32Array]";
    var reRegExpChar = /[\\^$.*+?()[\]{}|]/g;
    var reIsHostCtor = /^\[object .+?Constructor\]$/;
    var reIsUint = /^(?:0|[1-9]\d*)$/;
    var typedArrayTags = {};
    typedArrayTags[float32Tag] = typedArrayTags[float64Tag] = typedArrayTags[int8Tag] = typedArrayTags[int16Tag] = typedArrayTags[int32Tag] = typedArrayTags[uint8Tag] = typedArrayTags[uint8ClampedTag] = typedArrayTags[uint16Tag] = typedArrayTags[uint32Tag] = true;
    typedArrayTags[argsTag] = typedArrayTags[arrayTag] = typedArrayTags[arrayBufferTag] = typedArrayTags[boolTag] = typedArrayTags[dataViewTag] = typedArrayTags[dateTag] = typedArrayTags[errorTag] = typedArrayTags[funcTag] = typedArrayTags[mapTag] = typedArrayTags[numberTag] = typedArrayTags[objectTag] = typedArrayTags[regexpTag] = typedArrayTags[setTag] = typedArrayTags[stringTag] = typedArrayTags[weakMapTag] = false;
    var freeGlobal = typeof global == "object" && global && global.Object === Object && global;
    var freeSelf = typeof self == "object" && self && self.Object === Object && self;
    var root = freeGlobal || freeSelf || Function("return this")();
    var freeExports = typeof exports2 == "object" && exports2 && !exports2.nodeType && exports2;
    var freeModule = freeExports && typeof module2 == "object" && module2 && !module2.nodeType && module2;
    var moduleExports = freeModule && freeModule.exports === freeExports;
    var freeProcess = moduleExports && freeGlobal.process;
    var nodeUtil = function() {
      try {
        return freeProcess && freeProcess.binding && freeProcess.binding("util");
      } catch (e2) {
      }
    }();
    var nodeIsTypedArray = nodeUtil && nodeUtil.isTypedArray;
    function arrayFilter(array, predicate) {
      var index = -1, length = array == null ? 0 : array.length, resIndex = 0, result2 = [];
      while (++index < length) {
        var value = array[index];
        if (predicate(value, index, array)) {
          result2[resIndex++] = value;
        }
      }
      return result2;
    }
    function arrayPush(array, values) {
      var index = -1, length = values.length, offset = array.length;
      while (++index < length) {
        array[offset + index] = values[index];
      }
      return array;
    }
    function arraySome(array, predicate) {
      var index = -1, length = array == null ? 0 : array.length;
      while (++index < length) {
        if (predicate(array[index], index, array)) {
          return true;
        }
      }
      return false;
    }
    function baseTimes(n2, iteratee) {
      var index = -1, result2 = Array(n2);
      while (++index < n2) {
        result2[index] = iteratee(index);
      }
      return result2;
    }
    function baseUnary(func2) {
      return function(value) {
        return func2(value);
      };
    }
    function cacheHas(cache, key2) {
      return cache.has(key2);
    }
    function getValue2(object, key2) {
      return object == null ? void 0 : object[key2];
    }
    function mapToArray(map2) {
      var index = -1, result2 = Array(map2.size);
      map2.forEach(function(value, key2) {
        result2[++index] = [key2, value];
      });
      return result2;
    }
    function overArg(func2, transform) {
      return function(arg2) {
        return func2(transform(arg2));
      };
    }
    function setToArray(set2) {
      var index = -1, result2 = Array(set2.size);
      set2.forEach(function(value) {
        result2[++index] = value;
      });
      return result2;
    }
    var arrayProto = Array.prototype;
    var funcProto = Function.prototype;
    var objectProto = Object.prototype;
    var coreJsData = root["__core-js_shared__"];
    var funcToString = funcProto.toString;
    var hasOwnProperty2 = objectProto.hasOwnProperty;
    var maskSrcKey = function() {
      var uid = /[^.]+$/.exec(coreJsData && coreJsData.keys && coreJsData.keys.IE_PROTO || "");
      return uid ? "Symbol(src)_1." + uid : "";
    }();
    var nativeObjectToString = objectProto.toString;
    var reIsNative = RegExp("^" + funcToString.call(hasOwnProperty2).replace(reRegExpChar, "\\$&").replace(/hasOwnProperty|(function).*?(?=\\\()| for .+?(?=\\\])/g, "$1.*?") + "$");
    var Buffer2 = moduleExports ? root.Buffer : void 0;
    var Symbol2 = root.Symbol;
    var Uint8Array2 = root.Uint8Array;
    var propertyIsEnumerable = objectProto.propertyIsEnumerable;
    var splice = arrayProto.splice;
    var symToStringTag = Symbol2 ? Symbol2.toStringTag : void 0;
    var nativeGetSymbols = Object.getOwnPropertySymbols;
    var nativeIsBuffer = Buffer2 ? Buffer2.isBuffer : void 0;
    var nativeKeys = overArg(Object.keys, Object);
    var DataView2 = getNative(root, "DataView");
    var Map2 = getNative(root, "Map");
    var Promise2 = getNative(root, "Promise");
    var Set2 = getNative(root, "Set");
    var WeakMap2 = getNative(root, "WeakMap");
    var nativeCreate = getNative(Object, "create");
    var dataViewCtorString = toSource(DataView2);
    var mapCtorString = toSource(Map2);
    var promiseCtorString = toSource(Promise2);
    var setCtorString = toSource(Set2);
    var weakMapCtorString = toSource(WeakMap2);
    var symbolProto = Symbol2 ? Symbol2.prototype : void 0;
    var symbolValueOf = symbolProto ? symbolProto.valueOf : void 0;
    function Hash(entries) {
      var index = -1, length = entries == null ? 0 : entries.length;
      this.clear();
      while (++index < length) {
        var entry = entries[index];
        this.set(entry[0], entry[1]);
      }
    }
    function hashClear() {
      this.__data__ = nativeCreate ? nativeCreate(null) : {};
      this.size = 0;
    }
    function hashDelete(key2) {
      var result2 = this.has(key2) && delete this.__data__[key2];
      this.size -= result2 ? 1 : 0;
      return result2;
    }
    function hashGet(key2) {
      var data = this.__data__;
      if (nativeCreate) {
        var result2 = data[key2];
        return result2 === HASH_UNDEFINED ? void 0 : result2;
      }
      return hasOwnProperty2.call(data, key2) ? data[key2] : void 0;
    }
    function hashHas(key2) {
      var data = this.__data__;
      return nativeCreate ? data[key2] !== void 0 : hasOwnProperty2.call(data, key2);
    }
    function hashSet(key2, value) {
      var data = this.__data__;
      this.size += this.has(key2) ? 0 : 1;
      data[key2] = nativeCreate && value === void 0 ? HASH_UNDEFINED : value;
      return this;
    }
    Hash.prototype.clear = hashClear;
    Hash.prototype["delete"] = hashDelete;
    Hash.prototype.get = hashGet;
    Hash.prototype.has = hashHas;
    Hash.prototype.set = hashSet;
    function ListCache(entries) {
      var index = -1, length = entries == null ? 0 : entries.length;
      this.clear();
      while (++index < length) {
        var entry = entries[index];
        this.set(entry[0], entry[1]);
      }
    }
    function listCacheClear() {
      this.__data__ = [];
      this.size = 0;
    }
    function listCacheDelete(key2) {
      var data = this.__data__, index = assocIndexOf(data, key2);
      if (index < 0) {
        return false;
      }
      var lastIndex = data.length - 1;
      if (index == lastIndex) {
        data.pop();
      } else {
        splice.call(data, index, 1);
      }
      --this.size;
      return true;
    }
    function listCacheGet(key2) {
      var data = this.__data__, index = assocIndexOf(data, key2);
      return index < 0 ? void 0 : data[index][1];
    }
    function listCacheHas(key2) {
      return assocIndexOf(this.__data__, key2) > -1;
    }
    function listCacheSet(key2, value) {
      var data = this.__data__, index = assocIndexOf(data, key2);
      if (index < 0) {
        ++this.size;
        data.push([key2, value]);
      } else {
        data[index][1] = value;
      }
      return this;
    }
    ListCache.prototype.clear = listCacheClear;
    ListCache.prototype["delete"] = listCacheDelete;
    ListCache.prototype.get = listCacheGet;
    ListCache.prototype.has = listCacheHas;
    ListCache.prototype.set = listCacheSet;
    function MapCache(entries) {
      var index = -1, length = entries == null ? 0 : entries.length;
      this.clear();
      while (++index < length) {
        var entry = entries[index];
        this.set(entry[0], entry[1]);
      }
    }
    function mapCacheClear() {
      this.size = 0;
      this.__data__ = {
        "hash": new Hash(),
        "map": new (Map2 || ListCache)(),
        "string": new Hash()
      };
    }
    function mapCacheDelete(key2) {
      var result2 = getMapData(this, key2)["delete"](key2);
      this.size -= result2 ? 1 : 0;
      return result2;
    }
    function mapCacheGet(key2) {
      return getMapData(this, key2).get(key2);
    }
    function mapCacheHas(key2) {
      return getMapData(this, key2).has(key2);
    }
    function mapCacheSet(key2, value) {
      var data = getMapData(this, key2), size = data.size;
      data.set(key2, value);
      this.size += data.size == size ? 0 : 1;
      return this;
    }
    MapCache.prototype.clear = mapCacheClear;
    MapCache.prototype["delete"] = mapCacheDelete;
    MapCache.prototype.get = mapCacheGet;
    MapCache.prototype.has = mapCacheHas;
    MapCache.prototype.set = mapCacheSet;
    function SetCache(values) {
      var index = -1, length = values == null ? 0 : values.length;
      this.__data__ = new MapCache();
      while (++index < length) {
        this.add(values[index]);
      }
    }
    function setCacheAdd(value) {
      this.__data__.set(value, HASH_UNDEFINED);
      return this;
    }
    function setCacheHas(value) {
      return this.__data__.has(value);
    }
    SetCache.prototype.add = SetCache.prototype.push = setCacheAdd;
    SetCache.prototype.has = setCacheHas;
    function Stack(entries) {
      var data = this.__data__ = new ListCache(entries);
      this.size = data.size;
    }
    function stackClear() {
      this.__data__ = new ListCache();
      this.size = 0;
    }
    function stackDelete(key2) {
      var data = this.__data__, result2 = data["delete"](key2);
      this.size = data.size;
      return result2;
    }
    function stackGet(key2) {
      return this.__data__.get(key2);
    }
    function stackHas(key2) {
      return this.__data__.has(key2);
    }
    function stackSet(key2, value) {
      var data = this.__data__;
      if (data instanceof ListCache) {
        var pairs2 = data.__data__;
        if (!Map2 || pairs2.length < LARGE_ARRAY_SIZE - 1) {
          pairs2.push([key2, value]);
          this.size = ++data.size;
          return this;
        }
        data = this.__data__ = new MapCache(pairs2);
      }
      data.set(key2, value);
      this.size = data.size;
      return this;
    }
    Stack.prototype.clear = stackClear;
    Stack.prototype["delete"] = stackDelete;
    Stack.prototype.get = stackGet;
    Stack.prototype.has = stackHas;
    Stack.prototype.set = stackSet;
    function arrayLikeKeys(value, inherited) {
      var isArr = isArray(value), isArg = !isArr && isArguments(value), isBuff = !isArr && !isArg && isBuffer(value), isType = !isArr && !isArg && !isBuff && isTypedArray(value), skipIndexes = isArr || isArg || isBuff || isType, result2 = skipIndexes ? baseTimes(value.length, String) : [], length = result2.length;
      for (var key2 in value) {
        if ((inherited || hasOwnProperty2.call(value, key2)) && !(skipIndexes && (key2 == "length" || isBuff && (key2 == "offset" || key2 == "parent") || isType && (key2 == "buffer" || key2 == "byteLength" || key2 == "byteOffset") || isIndex(key2, length)))) {
          result2.push(key2);
        }
      }
      return result2;
    }
    function assocIndexOf(array, key2) {
      var length = array.length;
      while (length--) {
        if (eq(array[length][0], key2)) {
          return length;
        }
      }
      return -1;
    }
    function baseGetAllKeys(object, keysFunc, symbolsFunc) {
      var result2 = keysFunc(object);
      return isArray(object) ? result2 : arrayPush(result2, symbolsFunc(object));
    }
    function baseGetTag(value) {
      if (value == null) {
        return value === void 0 ? undefinedTag : nullTag;
      }
      return symToStringTag && symToStringTag in Object(value) ? getRawTag(value) : objectToString(value);
    }
    function baseIsArguments(value) {
      return isObjectLike(value) && baseGetTag(value) == argsTag;
    }
    function baseIsEqual(value, other, bitmask, customizer, stack) {
      if (value === other) {
        return true;
      }
      if (value == null || other == null || !isObjectLike(value) && !isObjectLike(other)) {
        return value !== value && other !== other;
      }
      return baseIsEqualDeep(value, other, bitmask, customizer, baseIsEqual, stack);
    }
    function baseIsEqualDeep(object, other, bitmask, customizer, equalFunc, stack) {
      var objIsArr = isArray(object), othIsArr = isArray(other), objTag = objIsArr ? arrayTag : getTag(object), othTag = othIsArr ? arrayTag : getTag(other);
      objTag = objTag == argsTag ? objectTag : objTag;
      othTag = othTag == argsTag ? objectTag : othTag;
      var objIsObj = objTag == objectTag, othIsObj = othTag == objectTag, isSameTag = objTag == othTag;
      if (isSameTag && isBuffer(object)) {
        if (!isBuffer(other)) {
          return false;
        }
        objIsArr = true;
        objIsObj = false;
      }
      if (isSameTag && !objIsObj) {
        stack || (stack = new Stack());
        return objIsArr || isTypedArray(object) ? equalArrays(object, other, bitmask, customizer, equalFunc, stack) : equalByTag(object, other, objTag, bitmask, customizer, equalFunc, stack);
      }
      if (!(bitmask & COMPARE_PARTIAL_FLAG)) {
        var objIsWrapped = objIsObj && hasOwnProperty2.call(object, "__wrapped__"), othIsWrapped = othIsObj && hasOwnProperty2.call(other, "__wrapped__");
        if (objIsWrapped || othIsWrapped) {
          var objUnwrapped = objIsWrapped ? object.value() : object, othUnwrapped = othIsWrapped ? other.value() : other;
          stack || (stack = new Stack());
          return equalFunc(objUnwrapped, othUnwrapped, bitmask, customizer, stack);
        }
      }
      if (!isSameTag) {
        return false;
      }
      stack || (stack = new Stack());
      return equalObjects(object, other, bitmask, customizer, equalFunc, stack);
    }
    function baseIsNative(value) {
      if (!isObject2(value) || isMasked(value)) {
        return false;
      }
      var pattern = isFunction(value) ? reIsNative : reIsHostCtor;
      return pattern.test(toSource(value));
    }
    function baseIsTypedArray(value) {
      return isObjectLike(value) && isLength(value.length) && !!typedArrayTags[baseGetTag(value)];
    }
    function baseKeys(object) {
      if (!isPrototype(object)) {
        return nativeKeys(object);
      }
      var result2 = [];
      for (var key2 in Object(object)) {
        if (hasOwnProperty2.call(object, key2) && key2 != "constructor") {
          result2.push(key2);
        }
      }
      return result2;
    }
    function equalArrays(array, other, bitmask, customizer, equalFunc, stack) {
      var isPartial = bitmask & COMPARE_PARTIAL_FLAG, arrLength = array.length, othLength = other.length;
      if (arrLength != othLength && !(isPartial && othLength > arrLength)) {
        return false;
      }
      var stacked = stack.get(array);
      if (stacked && stack.get(other)) {
        return stacked == other;
      }
      var index = -1, result2 = true, seen = bitmask & COMPARE_UNORDERED_FLAG ? new SetCache() : void 0;
      stack.set(array, other);
      stack.set(other, array);
      while (++index < arrLength) {
        var arrValue = array[index], othValue = other[index];
        if (customizer) {
          var compared = isPartial ? customizer(othValue, arrValue, index, other, array, stack) : customizer(arrValue, othValue, index, array, other, stack);
        }
        if (compared !== void 0) {
          if (compared) {
            continue;
          }
          result2 = false;
          break;
        }
        if (seen) {
          if (!arraySome(other, function(othValue2, othIndex) {
            if (!cacheHas(seen, othIndex) && (arrValue === othValue2 || equalFunc(arrValue, othValue2, bitmask, customizer, stack))) {
              return seen.push(othIndex);
            }
          })) {
            result2 = false;
            break;
          }
        } else if (!(arrValue === othValue || equalFunc(arrValue, othValue, bitmask, customizer, stack))) {
          result2 = false;
          break;
        }
      }
      stack["delete"](array);
      stack["delete"](other);
      return result2;
    }
    function equalByTag(object, other, tag, bitmask, customizer, equalFunc, stack) {
      switch (tag) {
        case dataViewTag:
          if (object.byteLength != other.byteLength || object.byteOffset != other.byteOffset) {
            return false;
          }
          object = object.buffer;
          other = other.buffer;
        case arrayBufferTag:
          if (object.byteLength != other.byteLength || !equalFunc(new Uint8Array2(object), new Uint8Array2(other))) {
            return false;
          }
          return true;
        case boolTag:
        case dateTag:
        case numberTag:
          return eq(+object, +other);
        case errorTag:
          return object.name == other.name && object.message == other.message;
        case regexpTag:
        case stringTag:
          return object == other + "";
        case mapTag:
          var convert = mapToArray;
        case setTag:
          var isPartial = bitmask & COMPARE_PARTIAL_FLAG;
          convert || (convert = setToArray);
          if (object.size != other.size && !isPartial) {
            return false;
          }
          var stacked = stack.get(object);
          if (stacked) {
            return stacked == other;
          }
          bitmask |= COMPARE_UNORDERED_FLAG;
          stack.set(object, other);
          var result2 = equalArrays(convert(object), convert(other), bitmask, customizer, equalFunc, stack);
          stack["delete"](object);
          return result2;
        case symbolTag:
          if (symbolValueOf) {
            return symbolValueOf.call(object) == symbolValueOf.call(other);
          }
      }
      return false;
    }
    function equalObjects(object, other, bitmask, customizer, equalFunc, stack) {
      var isPartial = bitmask & COMPARE_PARTIAL_FLAG, objProps = getAllKeys(object), objLength = objProps.length, othProps = getAllKeys(other), othLength = othProps.length;
      if (objLength != othLength && !isPartial) {
        return false;
      }
      var index = objLength;
      while (index--) {
        var key2 = objProps[index];
        if (!(isPartial ? key2 in other : hasOwnProperty2.call(other, key2))) {
          return false;
        }
      }
      var stacked = stack.get(object);
      if (stacked && stack.get(other)) {
        return stacked == other;
      }
      var result2 = true;
      stack.set(object, other);
      stack.set(other, object);
      var skipCtor = isPartial;
      while (++index < objLength) {
        key2 = objProps[index];
        var objValue = object[key2], othValue = other[key2];
        if (customizer) {
          var compared = isPartial ? customizer(othValue, objValue, key2, other, object, stack) : customizer(objValue, othValue, key2, object, other, stack);
        }
        if (!(compared === void 0 ? objValue === othValue || equalFunc(objValue, othValue, bitmask, customizer, stack) : compared)) {
          result2 = false;
          break;
        }
        skipCtor || (skipCtor = key2 == "constructor");
      }
      if (result2 && !skipCtor) {
        var objCtor = object.constructor, othCtor = other.constructor;
        if (objCtor != othCtor && ("constructor" in object && "constructor" in other) && !(typeof objCtor == "function" && objCtor instanceof objCtor && typeof othCtor == "function" && othCtor instanceof othCtor)) {
          result2 = false;
        }
      }
      stack["delete"](object);
      stack["delete"](other);
      return result2;
    }
    function getAllKeys(object) {
      return baseGetAllKeys(object, keys, getSymbols);
    }
    function getMapData(map2, key2) {
      var data = map2.__data__;
      return isKeyable(key2) ? data[typeof key2 == "string" ? "string" : "hash"] : data.map;
    }
    function getNative(object, key2) {
      var value = getValue2(object, key2);
      return baseIsNative(value) ? value : void 0;
    }
    function getRawTag(value) {
      var isOwn = hasOwnProperty2.call(value, symToStringTag), tag = value[symToStringTag];
      try {
        value[symToStringTag] = void 0;
        var unmasked = true;
      } catch (e2) {
      }
      var result2 = nativeObjectToString.call(value);
      if (unmasked) {
        if (isOwn) {
          value[symToStringTag] = tag;
        } else {
          delete value[symToStringTag];
        }
      }
      return result2;
    }
    var getSymbols = !nativeGetSymbols ? stubArray : function(object) {
      if (object == null) {
        return [];
      }
      object = Object(object);
      return arrayFilter(nativeGetSymbols(object), function(symbol) {
        return propertyIsEnumerable.call(object, symbol);
      });
    };
    var getTag = baseGetTag;
    if (DataView2 && getTag(new DataView2(new ArrayBuffer(1))) != dataViewTag || Map2 && getTag(new Map2()) != mapTag || Promise2 && getTag(Promise2.resolve()) != promiseTag || Set2 && getTag(new Set2()) != setTag || WeakMap2 && getTag(new WeakMap2()) != weakMapTag) {
      getTag = function(value) {
        var result2 = baseGetTag(value), Ctor = result2 == objectTag ? value.constructor : void 0, ctorString = Ctor ? toSource(Ctor) : "";
        if (ctorString) {
          switch (ctorString) {
            case dataViewCtorString:
              return dataViewTag;
            case mapCtorString:
              return mapTag;
            case promiseCtorString:
              return promiseTag;
            case setCtorString:
              return setTag;
            case weakMapCtorString:
              return weakMapTag;
          }
        }
        return result2;
      };
    }
    function isIndex(value, length) {
      length = length == null ? MAX_SAFE_INTEGER : length;
      return !!length && (typeof value == "number" || reIsUint.test(value)) && (value > -1 && value % 1 == 0 && value < length);
    }
    function isKeyable(value) {
      var type3 = typeof value;
      return type3 == "string" || type3 == "number" || type3 == "symbol" || type3 == "boolean" ? value !== "__proto__" : value === null;
    }
    function isMasked(func2) {
      return !!maskSrcKey && maskSrcKey in func2;
    }
    function isPrototype(value) {
      var Ctor = value && value.constructor, proto = typeof Ctor == "function" && Ctor.prototype || objectProto;
      return value === proto;
    }
    function objectToString(value) {
      return nativeObjectToString.call(value);
    }
    function toSource(func2) {
      if (func2 != null) {
        try {
          return funcToString.call(func2);
        } catch (e2) {
        }
        try {
          return func2 + "";
        } catch (e2) {
        }
      }
      return "";
    }
    function eq(value, other) {
      return value === other || value !== value && other !== other;
    }
    var isArguments = baseIsArguments(function() {
      return arguments;
    }()) ? baseIsArguments : function(value) {
      return isObjectLike(value) && hasOwnProperty2.call(value, "callee") && !propertyIsEnumerable.call(value, "callee");
    };
    var isArray = Array.isArray;
    function isArrayLike(value) {
      return value != null && isLength(value.length) && !isFunction(value);
    }
    var isBuffer = nativeIsBuffer || stubFalse;
    function isEqual(value, other) {
      return baseIsEqual(value, other);
    }
    function isFunction(value) {
      if (!isObject2(value)) {
        return false;
      }
      var tag = baseGetTag(value);
      return tag == funcTag || tag == genTag || tag == asyncTag || tag == proxyTag;
    }
    function isLength(value) {
      return typeof value == "number" && value > -1 && value % 1 == 0 && value <= MAX_SAFE_INTEGER;
    }
    function isObject2(value) {
      var type3 = typeof value;
      return value != null && (type3 == "object" || type3 == "function");
    }
    function isObjectLike(value) {
      return value != null && typeof value == "object";
    }
    var isTypedArray = nodeIsTypedArray ? baseUnary(nodeIsTypedArray) : baseIsTypedArray;
    function keys(object) {
      return isArrayLike(object) ? arrayLikeKeys(object) : baseKeys(object);
    }
    function stubArray() {
      return [];
    }
    function stubFalse() {
      return false;
    }
    module2.exports = isEqual;
  }
});

// node_modules/arr-rotate/index.js
var require_arr_rotate = __commonJS({
  "node_modules/arr-rotate/index.js"(exports2, module2) {
    "use strict";
    module2.exports = (input, n2) => {
      if (!Array.isArray(input)) {
        throw new TypeError(`Expected an array, got ${typeof input}`);
      }
      const x = input.slice();
      const num2 = typeof n2 === "number" ? n2 : 0;
      return x.splice(-num2 % x.length).concat(x);
    };
  }
});

// node_modules/figures/node_modules/escape-string-regexp/index.js
var require_escape_string_regexp2 = __commonJS({
  "node_modules/figures/node_modules/escape-string-regexp/index.js"(exports2, module2) {
    "use strict";
    var matchOperatorsRe = /[|\\{}()[\]^$+*?.]/g;
    module2.exports = function(str2) {
      if (typeof str2 !== "string") {
        throw new TypeError("Expected a string");
      }
      return str2.replace(matchOperatorsRe, "\\$&");
    };
  }
});

// node_modules/figures/index.js
var require_figures = __commonJS({
  "node_modules/figures/index.js"(exports2, module2) {
    "use strict";
    var escapeStringRegexp = require_escape_string_regexp2();
    var { platform } = process;
    var main = {
      tick: "\u2714",
      cross: "\u2716",
      star: "\u2605",
      square: "\u2587",
      squareSmall: "\u25FB",
      squareSmallFilled: "\u25FC",
      play: "\u25B6",
      circle: "\u25EF",
      circleFilled: "\u25C9",
      circleDotted: "\u25CC",
      circleDouble: "\u25CE",
      circleCircle: "\u24DE",
      circleCross: "\u24E7",
      circlePipe: "\u24BE",
      circleQuestionMark: "?\u20DD",
      bullet: "\u25CF",
      dot: "\u2024",
      line: "\u2500",
      ellipsis: "\u2026",
      pointer: "\u276F",
      pointerSmall: "\u203A",
      info: "\u2139",
      warning: "\u26A0",
      hamburger: "\u2630",
      smiley: "\u32E1",
      mustache: "\u0DF4",
      heart: "\u2665",
      nodejs: "\u2B22",
      arrowUp: "\u2191",
      arrowDown: "\u2193",
      arrowLeft: "\u2190",
      arrowRight: "\u2192",
      radioOn: "\u25C9",
      radioOff: "\u25EF",
      checkboxOn: "\u2612",
      checkboxOff: "\u2610",
      checkboxCircleOn: "\u24E7",
      checkboxCircleOff: "\u24BE",
      questionMarkPrefix: "?\u20DD",
      oneHalf: "\xBD",
      oneThird: "\u2153",
      oneQuarter: "\xBC",
      oneFifth: "\u2155",
      oneSixth: "\u2159",
      oneSeventh: "\u2150",
      oneEighth: "\u215B",
      oneNinth: "\u2151",
      oneTenth: "\u2152",
      twoThirds: "\u2154",
      twoFifths: "\u2156",
      threeQuarters: "\xBE",
      threeFifths: "\u2157",
      threeEighths: "\u215C",
      fourFifths: "\u2158",
      fiveSixths: "\u215A",
      fiveEighths: "\u215D",
      sevenEighths: "\u215E"
    };
    var windows = {
      tick: "\u221A",
      cross: "\xD7",
      star: "*",
      square: "\u2588",
      squareSmall: "[ ]",
      squareSmallFilled: "[\u2588]",
      play: "\u25BA",
      circle: "( )",
      circleFilled: "(*)",
      circleDotted: "( )",
      circleDouble: "( )",
      circleCircle: "(\u25CB)",
      circleCross: "(\xD7)",
      circlePipe: "(\u2502)",
      circleQuestionMark: "(?)",
      bullet: "*",
      dot: ".",
      line: "\u2500",
      ellipsis: "...",
      pointer: ">",
      pointerSmall: "\xBB",
      info: "i",
      warning: "\u203C",
      hamburger: "\u2261",
      smiley: "\u263A",
      mustache: "\u250C\u2500\u2510",
      heart: main.heart,
      nodejs: "\u2666",
      arrowUp: main.arrowUp,
      arrowDown: main.arrowDown,
      arrowLeft: main.arrowLeft,
      arrowRight: main.arrowRight,
      radioOn: "(*)",
      radioOff: "( )",
      checkboxOn: "[\xD7]",
      checkboxOff: "[ ]",
      checkboxCircleOn: "(\xD7)",
      checkboxCircleOff: "( )",
      questionMarkPrefix: "\uFF1F",
      oneHalf: "1/2",
      oneThird: "1/3",
      oneQuarter: "1/4",
      oneFifth: "1/5",
      oneSixth: "1/6",
      oneSeventh: "1/7",
      oneEighth: "1/8",
      oneNinth: "1/9",
      oneTenth: "1/10",
      twoThirds: "2/3",
      twoFifths: "2/5",
      threeQuarters: "3/4",
      threeFifths: "3/5",
      threeEighths: "3/8",
      fourFifths: "4/5",
      fiveSixths: "5/6",
      fiveEighths: "5/8",
      sevenEighths: "7/8"
    };
    if (platform === "linux") {
      main.questionMarkPrefix = "?";
    }
    var figures = platform === "win32" ? windows : main;
    var fn = (string) => {
      if (figures === main) {
        return string;
      }
      for (const [key2, value] of Object.entries(main)) {
        if (value === figures[key2]) {
          continue;
        }
        string = string.replace(new RegExp(escapeStringRegexp(value), "g"), figures[key2]);
      }
      return string;
    };
    module2.exports = Object.assign(fn, figures);
    module2.exports.main = main;
    module2.exports.windows = windows;
  }
});

// node_modules/ink-select-input/build/Indicator.js
var require_Indicator = __commonJS({
  "node_modules/ink-select-input/build/Indicator.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var React7 = require_react();
    var ink_1 = require_build2();
    var figures = require_figures();
    var Indicator = ({ isSelected = false }) => React7.createElement(ink_1.Box, { marginRight: 1 }, isSelected ? React7.createElement(ink_1.Text, { color: "blue" }, figures.pointer) : React7.createElement(ink_1.Text, null, " "));
    exports2.default = Indicator;
  }
});

// node_modules/ink-select-input/build/Item.js
var require_Item = __commonJS({
  "node_modules/ink-select-input/build/Item.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var React7 = require_react();
    var ink_1 = require_build2();
    var Item = ({ isSelected = false, label }) => React7.createElement(ink_1.Text, { color: isSelected ? "blue" : void 0 }, label);
    exports2.default = Item;
  }
});

// node_modules/ink-select-input/build/SelectInput.js
var require_SelectInput = __commonJS({
  "node_modules/ink-select-input/build/SelectInput.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var React7 = require_react();
    var react_1 = require_react();
    var isEqual = require_lodash2();
    var arrayRotate = require_arr_rotate();
    var ink_1 = require_build2();
    var Indicator_1 = require_Indicator();
    var Item_1 = require_Item();
    function SelectInput3({ items = [], isFocused = true, initialIndex = 0, indicatorComponent = Indicator_1.default, itemComponent = Item_1.default, limit: customLimit, onSelect, onHighlight }) {
      const [rotateIndex, setRotateIndex] = react_1.useState(0);
      const [selectedIndex, setSelectedIndex] = react_1.useState(initialIndex);
      const hasLimit = typeof customLimit === "number" && items.length > customLimit;
      const limit = hasLimit ? Math.min(customLimit, items.length) : items.length;
      const previousItems = react_1.useRef(items);
      react_1.useEffect(() => {
        if (!isEqual(previousItems.current.map((item) => item.value), items.map((item) => item.value))) {
          setRotateIndex(0);
          setSelectedIndex(0);
        }
        previousItems.current = items;
      }, [items]);
      ink_1.useInput(react_1.useCallback((input, key2) => {
        if (input === "k" || key2.upArrow) {
          const lastIndex = (hasLimit ? limit : items.length) - 1;
          const atFirstIndex = selectedIndex === 0;
          const nextIndex = hasLimit ? selectedIndex : lastIndex;
          const nextRotateIndex = atFirstIndex ? rotateIndex + 1 : rotateIndex;
          const nextSelectedIndex = atFirstIndex ? nextIndex : selectedIndex - 1;
          setRotateIndex(nextRotateIndex);
          setSelectedIndex(nextSelectedIndex);
          const slicedItems2 = hasLimit ? arrayRotate(items, nextRotateIndex).slice(0, limit) : items;
          if (typeof onHighlight === "function") {
            onHighlight(slicedItems2[nextSelectedIndex]);
          }
        }
        if (input === "j" || key2.downArrow) {
          const atLastIndex = selectedIndex === (hasLimit ? limit : items.length) - 1;
          const nextIndex = hasLimit ? selectedIndex : 0;
          const nextRotateIndex = atLastIndex ? rotateIndex - 1 : rotateIndex;
          const nextSelectedIndex = atLastIndex ? nextIndex : selectedIndex + 1;
          setRotateIndex(nextRotateIndex);
          setSelectedIndex(nextSelectedIndex);
          const slicedItems2 = hasLimit ? arrayRotate(items, nextRotateIndex).slice(0, limit) : items;
          if (typeof onHighlight === "function") {
            onHighlight(slicedItems2[nextSelectedIndex]);
          }
        }
        if (key2.return) {
          const slicedItems2 = hasLimit ? arrayRotate(items, rotateIndex).slice(0, limit) : items;
          if (typeof onSelect === "function") {
            onSelect(slicedItems2[selectedIndex]);
          }
        }
      }, [
        hasLimit,
        limit,
        rotateIndex,
        selectedIndex,
        items,
        onSelect,
        onHighlight
      ]), { isActive: isFocused });
      const slicedItems = hasLimit ? arrayRotate(items, rotateIndex).slice(0, limit) : items;
      return React7.createElement(ink_1.Box, { flexDirection: "column" }, slicedItems.map((item, index) => {
        var _a2;
        const isSelected = index === selectedIndex;
        return React7.createElement(ink_1.Box, { key: (_a2 = item.key) !== null && _a2 !== void 0 ? _a2 : item.value }, React7.createElement(indicatorComponent, { isSelected }), React7.createElement(itemComponent, __spreadProps(__spreadValues({}, item), { isSelected })));
      }));
    }
    exports2.default = SelectInput3;
  }
});

// node_modules/ink-select-input/build/index.js
var require_build4 = __commonJS({
  "node_modules/ink-select-input/build/index.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var SelectInput_1 = require_SelectInput();
    exports2.default = SelectInput_1.default;
    var Indicator_1 = require_Indicator();
    Object.defineProperty(exports2, "Indicator", { enumerable: true, get: function() {
      return Indicator_1.default;
    } });
    var Item_1 = require_Item();
    Object.defineProperty(exports2, "Item", { enumerable: true, get: function() {
      return Item_1.default;
    } });
  }
});

// node_modules/object-hash/index.js
var require_object_hash = __commonJS({
  "node_modules/object-hash/index.js"(exports2, module2) {
    "use strict";
    var crypto = require("crypto");
    exports2 = module2.exports = objectHash;
    function objectHash(object, options) {
      options = applyDefaults(object, options);
      return hash(object, options);
    }
    exports2.sha1 = function(object) {
      return objectHash(object);
    };
    exports2.keys = function(object) {
      return objectHash(object, { excludeValues: true, algorithm: "sha1", encoding: "hex" });
    };
    exports2.MD5 = function(object) {
      return objectHash(object, { algorithm: "md5", encoding: "hex" });
    };
    exports2.keysMD5 = function(object) {
      return objectHash(object, { algorithm: "md5", encoding: "hex", excludeValues: true });
    };
    var hashes = crypto.getHashes ? crypto.getHashes().slice() : ["sha1", "md5"];
    hashes.push("passthrough");
    var encodings = ["buffer", "hex", "binary", "base64"];
    function applyDefaults(object, sourceOptions) {
      sourceOptions = sourceOptions || {};
      var options = {};
      options.algorithm = sourceOptions.algorithm || "sha1";
      options.encoding = sourceOptions.encoding || "hex";
      options.excludeValues = sourceOptions.excludeValues ? true : false;
      options.algorithm = options.algorithm.toLowerCase();
      options.encoding = options.encoding.toLowerCase();
      options.ignoreUnknown = sourceOptions.ignoreUnknown !== true ? false : true;
      options.respectType = sourceOptions.respectType === false ? false : true;
      options.respectFunctionNames = sourceOptions.respectFunctionNames === false ? false : true;
      options.respectFunctionProperties = sourceOptions.respectFunctionProperties === false ? false : true;
      options.unorderedArrays = sourceOptions.unorderedArrays !== true ? false : true;
      options.unorderedSets = sourceOptions.unorderedSets === false ? false : true;
      options.unorderedObjects = sourceOptions.unorderedObjects === false ? false : true;
      options.replacer = sourceOptions.replacer || void 0;
      options.excludeKeys = sourceOptions.excludeKeys || void 0;
      if (typeof object === "undefined") {
        throw new Error("Object argument required.");
      }
      for (var i3 = 0; i3 < hashes.length; ++i3) {
        if (hashes[i3].toLowerCase() === options.algorithm.toLowerCase()) {
          options.algorithm = hashes[i3];
        }
      }
      if (hashes.indexOf(options.algorithm) === -1) {
        throw new Error('Algorithm "' + options.algorithm + '"  not supported. supported values: ' + hashes.join(", "));
      }
      if (encodings.indexOf(options.encoding) === -1 && options.algorithm !== "passthrough") {
        throw new Error('Encoding "' + options.encoding + '"  not supported. supported values: ' + encodings.join(", "));
      }
      return options;
    }
    function isNativeFunction(f) {
      if (typeof f !== "function") {
        return false;
      }
      var exp = /^function\s+\w*\s*\(\s*\)\s*{\s+\[native code\]\s+}$/i;
      return exp.exec(Function.prototype.toString.call(f)) != null;
    }
    function hash(object, options) {
      var hashingStream;
      if (options.algorithm !== "passthrough") {
        hashingStream = crypto.createHash(options.algorithm);
      } else {
        hashingStream = new PassThrough();
      }
      if (typeof hashingStream.write === "undefined") {
        hashingStream.write = hashingStream.update;
        hashingStream.end = hashingStream.update;
      }
      var hasher = typeHasher(options, hashingStream);
      hasher.dispatch(object);
      if (!hashingStream.update) {
        hashingStream.end("");
      }
      if (hashingStream.digest) {
        return hashingStream.digest(options.encoding === "buffer" ? void 0 : options.encoding);
      }
      var buf = hashingStream.read();
      if (options.encoding === "buffer") {
        return buf;
      }
      return buf.toString(options.encoding);
    }
    exports2.writeToStream = function(object, options, stream) {
      if (typeof stream === "undefined") {
        stream = options;
        options = {};
      }
      options = applyDefaults(object, options);
      return typeHasher(options, stream).dispatch(object);
    };
    function typeHasher(options, writeTo, context) {
      context = context || [];
      var write = function(str2) {
        if (writeTo.update) {
          return writeTo.update(str2, "utf8");
        } else {
          return writeTo.write(str2, "utf8");
        }
      };
      return {
        dispatch: function(value) {
          if (options.replacer) {
            value = options.replacer(value);
          }
          var type3 = typeof value;
          if (value === null) {
            type3 = "null";
          }
          return this["_" + type3](value);
        },
        _object: function(object) {
          var pattern = /\[object (.*)\]/i;
          var objString = Object.prototype.toString.call(object);
          var objType = pattern.exec(objString);
          if (!objType) {
            objType = "unknown:[" + objString + "]";
          } else {
            objType = objType[1];
          }
          objType = objType.toLowerCase();
          var objectNumber = null;
          if ((objectNumber = context.indexOf(object)) >= 0) {
            return this.dispatch("[CIRCULAR:" + objectNumber + "]");
          } else {
            context.push(object);
          }
          if (typeof Buffer !== "undefined" && Buffer.isBuffer && Buffer.isBuffer(object)) {
            write("buffer:");
            return write(object);
          }
          if (objType !== "object" && objType !== "function" && objType !== "asyncfunction") {
            if (this["_" + objType]) {
              this["_" + objType](object);
            } else if (options.ignoreUnknown) {
              return write("[" + objType + "]");
            } else {
              throw new Error('Unknown object type "' + objType + '"');
            }
          } else {
            var keys = Object.keys(object);
            if (options.unorderedObjects) {
              keys = keys.sort();
            }
            if (options.respectType !== false && !isNativeFunction(object)) {
              keys.splice(0, 0, "prototype", "__proto__", "constructor");
            }
            if (options.excludeKeys) {
              keys = keys.filter(function(key2) {
                return !options.excludeKeys(key2);
              });
            }
            write("object:" + keys.length + ":");
            var self2 = this;
            return keys.forEach(function(key2) {
              self2.dispatch(key2);
              write(":");
              if (!options.excludeValues) {
                self2.dispatch(object[key2]);
              }
              write(",");
            });
          }
        },
        _array: function(arr, unordered) {
          unordered = typeof unordered !== "undefined" ? unordered : options.unorderedArrays !== false;
          var self2 = this;
          write("array:" + arr.length + ":");
          if (!unordered || arr.length <= 1) {
            return arr.forEach(function(entry) {
              return self2.dispatch(entry);
            });
          }
          var contextAdditions = [];
          var entries = arr.map(function(entry) {
            var strm = new PassThrough();
            var localContext = context.slice();
            var hasher = typeHasher(options, strm, localContext);
            hasher.dispatch(entry);
            contextAdditions = contextAdditions.concat(localContext.slice(context.length));
            return strm.read().toString();
          });
          context = context.concat(contextAdditions);
          entries.sort();
          return this._array(entries, false);
        },
        _date: function(date) {
          return write("date:" + date.toJSON());
        },
        _symbol: function(sym) {
          return write("symbol:" + sym.toString());
        },
        _error: function(err2) {
          return write("error:" + err2.toString());
        },
        _boolean: function(bool2) {
          return write("bool:" + bool2.toString());
        },
        _string: function(string) {
          write("string:" + string.length + ":");
          write(string.toString());
        },
        _function: function(fn) {
          write("fn:");
          if (isNativeFunction(fn)) {
            this.dispatch("[native]");
          } else {
            this.dispatch(fn.toString());
          }
          if (options.respectFunctionNames !== false) {
            this.dispatch("function-name:" + String(fn.name));
          }
          if (options.respectFunctionProperties) {
            this._object(fn);
          }
        },
        _number: function(number) {
          return write("number:" + number.toString());
        },
        _xml: function(xml) {
          return write("xml:" + xml.toString());
        },
        _null: function() {
          return write("Null");
        },
        _undefined: function() {
          return write("Undefined");
        },
        _regexp: function(regex) {
          return write("regex:" + regex.toString());
        },
        _uint8array: function(arr) {
          write("uint8array:");
          return this.dispatch(Array.prototype.slice.call(arr));
        },
        _uint8clampedarray: function(arr) {
          write("uint8clampedarray:");
          return this.dispatch(Array.prototype.slice.call(arr));
        },
        _int8array: function(arr) {
          write("uint8array:");
          return this.dispatch(Array.prototype.slice.call(arr));
        },
        _uint16array: function(arr) {
          write("uint16array:");
          return this.dispatch(Array.prototype.slice.call(arr));
        },
        _int16array: function(arr) {
          write("uint16array:");
          return this.dispatch(Array.prototype.slice.call(arr));
        },
        _uint32array: function(arr) {
          write("uint32array:");
          return this.dispatch(Array.prototype.slice.call(arr));
        },
        _int32array: function(arr) {
          write("uint32array:");
          return this.dispatch(Array.prototype.slice.call(arr));
        },
        _float32array: function(arr) {
          write("float32array:");
          return this.dispatch(Array.prototype.slice.call(arr));
        },
        _float64array: function(arr) {
          write("float64array:");
          return this.dispatch(Array.prototype.slice.call(arr));
        },
        _arraybuffer: function(arr) {
          write("arraybuffer:");
          return this.dispatch(new Uint8Array(arr));
        },
        _url: function(url) {
          return write("url:" + url.toString(), "utf8");
        },
        _map: function(map2) {
          write("map:");
          var arr = Array.from(map2);
          return this._array(arr, options.unorderedSets !== false);
        },
        _set: function(set2) {
          write("set:");
          var arr = Array.from(set2);
          return this._array(arr, options.unorderedSets !== false);
        },
        _file: function(file) {
          write("file:");
          return this.dispatch([file.name, file.size, file.type, file.lastModfied]);
        },
        _blob: function() {
          if (options.ignoreUnknown) {
            return write("[blob]");
          }
          throw Error('Hashing Blob objects is currently not supported\n(see https://github.com/puleos/object-hash/issues/26)\nUse "options.replacer" or "options.ignoreUnknown"\n');
        },
        _domwindow: function() {
          return write("domwindow");
        },
        _bigint: function(number) {
          return write("bigint:" + number.toString());
        },
        _process: function() {
          return write("process");
        },
        _timer: function() {
          return write("timer");
        },
        _pipe: function() {
          return write("pipe");
        },
        _tcp: function() {
          return write("tcp");
        },
        _udp: function() {
          return write("udp");
        },
        _tty: function() {
          return write("tty");
        },
        _statwatcher: function() {
          return write("statwatcher");
        },
        _securecontext: function() {
          return write("securecontext");
        },
        _connection: function() {
          return write("connection");
        },
        _zlib: function() {
          return write("zlib");
        },
        _context: function() {
          return write("context");
        },
        _nodescript: function() {
          return write("nodescript");
        },
        _httpparser: function() {
          return write("httpparser");
        },
        _dataview: function() {
          return write("dataview");
        },
        _signal: function() {
          return write("signal");
        },
        _fsevent: function() {
          return write("fsevent");
        },
        _tlswrap: function() {
          return write("tlswrap");
        }
      };
    }
    function PassThrough() {
      return {
        buf: "",
        write: function(b2) {
          this.buf += b2;
        },
        end: function(b2) {
          this.buf += b2;
        },
        read: function() {
          return this.buf;
        }
      };
    }
  }
});

// node_modules/ink-table/dist/index.js
var require_dist = __commonJS({
  "node_modules/ink-table/dist/index.js"(exports2) {
    "use strict";
    var __importDefault = exports2 && exports2.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { "default": mod };
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.Skeleton = exports2.Cell = exports2.Header = void 0;
    var react_1 = __importDefault(require_react());
    var ink_1 = require_build2();
    var object_hash_1 = require_object_hash();
    var Table4 = class extends react_1.default.Component {
      constructor() {
        super(...arguments);
        this.header = row({
          cell: this.getConfig().skeleton,
          padding: this.getConfig().padding,
          skeleton: {
            component: this.getConfig().skeleton,
            line: "\u2500",
            left: "\u250C",
            right: "\u2510",
            cross: "\u252C"
          }
        });
        this.heading = row({
          cell: this.getConfig().header,
          padding: this.getConfig().padding,
          skeleton: {
            component: this.getConfig().skeleton,
            line: " ",
            left: "\u2502",
            right: "\u2502",
            cross: "\u2502"
          }
        });
        this.separator = row({
          cell: this.getConfig().skeleton,
          padding: this.getConfig().padding,
          skeleton: {
            component: this.getConfig().skeleton,
            line: "\u2500",
            left: "\u251C",
            right: "\u2524",
            cross: "\u253C"
          }
        });
        this.data = row({
          cell: this.getConfig().cell,
          padding: this.getConfig().padding,
          skeleton: {
            component: this.getConfig().skeleton,
            line: " ",
            left: "\u2502",
            right: "\u2502",
            cross: "\u2502"
          }
        });
        this.footer = row({
          cell: this.getConfig().skeleton,
          padding: this.getConfig().padding,
          skeleton: {
            component: this.getConfig().skeleton,
            line: "\u2500",
            left: "\u2514",
            right: "\u2518",
            cross: "\u2534"
          }
        });
      }
      getConfig() {
        return {
          data: this.props.data,
          columns: this.props.columns || this.getDataKeys(),
          padding: this.props.padding || 1,
          header: this.props.header || Header3,
          cell: this.props.cell || Cell,
          skeleton: this.props.skeleton || Skeleton
        };
      }
      getDataKeys() {
        let keys = /* @__PURE__ */ new Set();
        for (const data of this.props.data) {
          for (const key2 in data) {
            keys.add(key2);
          }
        }
        return Array.from(keys);
      }
      getColumns() {
        const { columns, padding } = this.getConfig();
        const widths = columns.map((key2) => {
          const header = String(key2).length;
          const data = this.props.data.map((data2) => {
            const value = data2[key2];
            if (value == void 0 || value == null)
              return 0;
            return String(value).length;
          });
          const width = Math.max(...data, header) + padding * 2;
          return {
            column: key2,
            width,
            key: String(key2)
          };
        });
        return widths;
      }
      getHeadings() {
        const { columns } = this.getConfig();
        const headings = columns.reduce((acc, column) => __spreadProps(__spreadValues({}, acc), { [column]: column }), {});
        return headings;
      }
      render() {
        const columns = this.getColumns();
        const headings = this.getHeadings();
        return react_1.default.createElement(ink_1.Box, { flexDirection: "column" }, this.header({ key: "header", columns, data: {} }), this.heading({ key: "heading", columns, data: headings }), this.props.data.map((row2, index) => {
          const key2 = `row-${object_hash_1.sha1(row2)}-${index}`;
          return react_1.default.createElement(ink_1.Box, { flexDirection: "column", key: key2 }, this.separator({ key: `separator-${key2}`, columns, data: {} }), this.data({ key: `data-${key2}`, columns, data: row2 }));
        }), this.footer({ key: "footer", columns, data: {} }));
      }
    };
    exports2.default = Table4;
    function row(config) {
      const skeleton = config.skeleton;
      return (props) => react_1.default.createElement(ink_1.Box, { flexDirection: "row" }, react_1.default.createElement(skeleton.component, null, skeleton.left), intersperse((i3) => {
        const key2 = `${props.key}-hseparator-${i3}`;
        return react_1.default.createElement(skeleton.component, { key: key2 }, skeleton.cross);
      }, props.columns.map((column) => {
        const value = props.data[column.column];
        if (value == void 0 || value == null) {
          const key2 = `${props.key}-empty-${column.key}`;
          return react_1.default.createElement(config.cell, { key: key2 }, skeleton.line.repeat(column.width));
        } else {
          const key2 = `${props.key}-cell-${column.key}`;
          const ml = config.padding;
          const mr = column.width - String(value).length - config.padding;
          return react_1.default.createElement(config.cell, { key: key2 }, `${skeleton.line.repeat(ml)}${String(value)}${skeleton.line.repeat(mr)}`);
        }
      })), react_1.default.createElement(skeleton.component, null, skeleton.right));
    }
    function Header3(props) {
      return react_1.default.createElement(ink_1.Text, { bold: true, color: "blue" }, props.children);
    }
    exports2.Header = Header3;
    function Cell(props) {
      return react_1.default.createElement(ink_1.Text, null, props.children);
    }
    exports2.Cell = Cell;
    function Skeleton(props) {
      return react_1.default.createElement(ink_1.Text, { bold: true }, props.children);
    }
    exports2.Skeleton = Skeleton;
    function intersperse(intersperser, elements) {
      let interspersed = elements.reduce((acc, element, index) => {
        if (acc.length === 0)
          return [element];
        return [...acc, intersperser(index), element];
      }, []);
      return interspersed;
    }
  }
});

// node_modules/xstate/lib/_virtual/_tslib.js
var require_tslib = __commonJS({
  "node_modules/xstate/lib/_virtual/_tslib.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.__assign = function() {
      exports2.__assign = Object.assign || function __assign(t2) {
        for (var s2, i3 = 1, n2 = arguments.length; i3 < n2; i3++) {
          s2 = arguments[i3];
          for (var p in s2)
            if (Object.prototype.hasOwnProperty.call(s2, p))
              t2[p] = s2[p];
        }
        return t2;
      };
      return exports2.__assign.apply(this, arguments);
    };
    function __rest(s2, e2) {
      var t2 = {};
      for (var p in s2)
        if (Object.prototype.hasOwnProperty.call(s2, p) && e2.indexOf(p) < 0)
          t2[p] = s2[p];
      if (s2 != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i3 = 0, p = Object.getOwnPropertySymbols(s2); i3 < p.length; i3++) {
          if (e2.indexOf(p[i3]) < 0 && Object.prototype.propertyIsEnumerable.call(s2, p[i3]))
            t2[p[i3]] = s2[p[i3]];
        }
      return t2;
    }
    function __values(o2) {
      var s2 = typeof Symbol === "function" && Symbol.iterator, m = s2 && o2[s2], i3 = 0;
      if (m)
        return m.call(o2);
      if (o2 && typeof o2.length === "number")
        return {
          next: function() {
            if (o2 && i3 >= o2.length)
              o2 = void 0;
            return { value: o2 && o2[i3++], done: !o2 };
          }
        };
      throw new TypeError(s2 ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }
    function __read(o2, n2) {
      var m = typeof Symbol === "function" && o2[Symbol.iterator];
      if (!m)
        return o2;
      var i3 = m.call(o2), r2, ar = [], e2;
      try {
        while ((n2 === void 0 || n2-- > 0) && !(r2 = i3.next()).done)
          ar.push(r2.value);
      } catch (error) {
        e2 = { error };
      } finally {
        try {
          if (r2 && !r2.done && (m = i3["return"]))
            m.call(i3);
        } finally {
          if (e2)
            throw e2.error;
        }
      }
      return ar;
    }
    function __spreadArray(to, from) {
      for (var i3 = 0, il = from.length, j = to.length; i3 < il; i3++, j++)
        to[j] = from[i3];
      return to;
    }
    exports2.__read = __read;
    exports2.__rest = __rest;
    exports2.__spreadArray = __spreadArray;
    exports2.__values = __values;
  }
});

// node_modules/xstate/lib/constants.js
var require_constants2 = __commonJS({
  "node_modules/xstate/lib/constants.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var STATE_DELIMITER = ".";
    var EMPTY_ACTIVITY_MAP = {};
    var DEFAULT_GUARD_TYPE = "xstate.guard";
    var TARGETLESS_KEY = "";
    exports2.DEFAULT_GUARD_TYPE = DEFAULT_GUARD_TYPE;
    exports2.EMPTY_ACTIVITY_MAP = EMPTY_ACTIVITY_MAP;
    exports2.STATE_DELIMITER = STATE_DELIMITER;
    exports2.TARGETLESS_KEY = TARGETLESS_KEY;
  }
});

// node_modules/xstate/lib/environment.js
var require_environment = __commonJS({
  "node_modules/xstate/lib/environment.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var IS_PRODUCTION = process.env.NODE_ENV === "production";
    exports2.IS_PRODUCTION = IS_PRODUCTION;
  }
});

// node_modules/xstate/lib/utils.js
var require_utils = __commonJS({
  "node_modules/xstate/lib/utils.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var _tslib = require_tslib();
    var constants = require_constants2();
    var environment = require_environment();
    function keys(value) {
      return Object.keys(value);
    }
    function matchesState(parentStateId, childStateId, delimiter) {
      if (delimiter === void 0) {
        delimiter = constants.STATE_DELIMITER;
      }
      var parentStateValue = toStateValue(parentStateId, delimiter);
      var childStateValue = toStateValue(childStateId, delimiter);
      if (isString(childStateValue)) {
        if (isString(parentStateValue)) {
          return childStateValue === parentStateValue;
        }
        return false;
      }
      if (isString(parentStateValue)) {
        return parentStateValue in childStateValue;
      }
      return keys(parentStateValue).every(function(key2) {
        if (!(key2 in childStateValue)) {
          return false;
        }
        return matchesState(parentStateValue[key2], childStateValue[key2]);
      });
    }
    function getEventType(event2) {
      try {
        return isString(event2) || typeof event2 === "number" ? "" + event2 : event2.type;
      } catch (e2) {
        throw new Error("Events must be strings or objects with a string event.type property.");
      }
    }
    function toStatePath(stateId, delimiter) {
      try {
        if (isArray(stateId)) {
          return stateId;
        }
        return stateId.toString().split(delimiter);
      } catch (e2) {
        throw new Error("'" + stateId + "' is not a valid state path.");
      }
    }
    function isStateLike(state) {
      return typeof state === "object" && "value" in state && "context" in state && "event" in state && "_event" in state;
    }
    function toStateValue(stateValue, delimiter) {
      if (isStateLike(stateValue)) {
        return stateValue.value;
      }
      if (isArray(stateValue)) {
        return pathToStateValue(stateValue);
      }
      if (typeof stateValue !== "string") {
        return stateValue;
      }
      var statePath = toStatePath(stateValue, delimiter);
      return pathToStateValue(statePath);
    }
    function pathToStateValue(statePath) {
      if (statePath.length === 1) {
        return statePath[0];
      }
      var value = {};
      var marker = value;
      for (var i3 = 0; i3 < statePath.length - 1; i3++) {
        if (i3 === statePath.length - 2) {
          marker[statePath[i3]] = statePath[i3 + 1];
        } else {
          marker[statePath[i3]] = {};
          marker = marker[statePath[i3]];
        }
      }
      return value;
    }
    function mapValues(collection, iteratee) {
      var result2 = {};
      var collectionKeys = keys(collection);
      for (var i3 = 0; i3 < collectionKeys.length; i3++) {
        var key2 = collectionKeys[i3];
        result2[key2] = iteratee(collection[key2], key2, collection, i3);
      }
      return result2;
    }
    function mapFilterValues(collection, iteratee, predicate) {
      var e_1, _a2;
      var result2 = {};
      try {
        for (var _b = _tslib.__values(keys(collection)), _c = _b.next(); !_c.done; _c = _b.next()) {
          var key2 = _c.value;
          var item = collection[key2];
          if (!predicate(item)) {
            continue;
          }
          result2[key2] = iteratee(item, key2, collection);
        }
      } catch (e_1_1) {
        e_1 = {
          error: e_1_1
        };
      } finally {
        try {
          if (_c && !_c.done && (_a2 = _b.return))
            _a2.call(_b);
        } finally {
          if (e_1)
            throw e_1.error;
        }
      }
      return result2;
    }
    var path2 = function(props) {
      return function(object) {
        var e_2, _a2;
        var result2 = object;
        try {
          for (var props_1 = _tslib.__values(props), props_1_1 = props_1.next(); !props_1_1.done; props_1_1 = props_1.next()) {
            var prop = props_1_1.value;
            result2 = result2[prop];
          }
        } catch (e_2_1) {
          e_2 = {
            error: e_2_1
          };
        } finally {
          try {
            if (props_1_1 && !props_1_1.done && (_a2 = props_1.return))
              _a2.call(props_1);
          } finally {
            if (e_2)
              throw e_2.error;
          }
        }
        return result2;
      };
    };
    function nestedPath(props, accessorProp) {
      return function(object) {
        var e_3, _a2;
        var result2 = object;
        try {
          for (var props_2 = _tslib.__values(props), props_2_1 = props_2.next(); !props_2_1.done; props_2_1 = props_2.next()) {
            var prop = props_2_1.value;
            result2 = result2[accessorProp][prop];
          }
        } catch (e_3_1) {
          e_3 = {
            error: e_3_1
          };
        } finally {
          try {
            if (props_2_1 && !props_2_1.done && (_a2 = props_2.return))
              _a2.call(props_2);
          } finally {
            if (e_3)
              throw e_3.error;
          }
        }
        return result2;
      };
    }
    function toStatePaths(stateValue) {
      if (!stateValue) {
        return [[]];
      }
      if (isString(stateValue)) {
        return [[stateValue]];
      }
      var result2 = flatten(keys(stateValue).map(function(key2) {
        var subStateValue = stateValue[key2];
        if (typeof subStateValue !== "string" && (!subStateValue || !Object.keys(subStateValue).length)) {
          return [[key2]];
        }
        return toStatePaths(stateValue[key2]).map(function(subPath) {
          return [key2].concat(subPath);
        });
      }));
      return result2;
    }
    function flatten(array) {
      var _a2;
      return (_a2 = []).concat.apply(_a2, _tslib.__spreadArray([], _tslib.__read(array)));
    }
    function toArrayStrict(value) {
      if (isArray(value)) {
        return value;
      }
      return [value];
    }
    function toArray2(value) {
      if (value === void 0) {
        return [];
      }
      return toArrayStrict(value);
    }
    function mapContext(mapper, context, _event) {
      var e_5, _a2;
      if (isFunction(mapper)) {
        return mapper(context, _event.data);
      }
      var result2 = {};
      try {
        for (var _b = _tslib.__values(Object.keys(mapper)), _c = _b.next(); !_c.done; _c = _b.next()) {
          var key2 = _c.value;
          var subMapper = mapper[key2];
          if (isFunction(subMapper)) {
            result2[key2] = subMapper(context, _event.data);
          } else {
            result2[key2] = subMapper;
          }
        }
      } catch (e_5_1) {
        e_5 = {
          error: e_5_1
        };
      } finally {
        try {
          if (_c && !_c.done && (_a2 = _b.return))
            _a2.call(_b);
        } finally {
          if (e_5)
            throw e_5.error;
        }
      }
      return result2;
    }
    function isBuiltInEvent(eventType) {
      return /^(done|error)\./.test(eventType);
    }
    function isPromiseLike(value) {
      if (value instanceof Promise) {
        return true;
      }
      if (value !== null && (isFunction(value) || typeof value === "object") && isFunction(value.then)) {
        return true;
      }
      return false;
    }
    function isBehavior(value) {
      return value !== null && typeof value === "object" && "transition" in value && typeof value.transition === "function";
    }
    function partition(items, predicate) {
      var e_6, _a2;
      var _b = _tslib.__read([[], []], 2), truthy = _b[0], falsy = _b[1];
      try {
        for (var items_1 = _tslib.__values(items), items_1_1 = items_1.next(); !items_1_1.done; items_1_1 = items_1.next()) {
          var item = items_1_1.value;
          if (predicate(item)) {
            truthy.push(item);
          } else {
            falsy.push(item);
          }
        }
      } catch (e_6_1) {
        e_6 = {
          error: e_6_1
        };
      } finally {
        try {
          if (items_1_1 && !items_1_1.done && (_a2 = items_1.return))
            _a2.call(items_1);
        } finally {
          if (e_6)
            throw e_6.error;
        }
      }
      return [truthy, falsy];
    }
    function updateHistoryStates(hist, stateValue) {
      return mapValues(hist.states, function(subHist, key2) {
        if (!subHist) {
          return void 0;
        }
        var subStateValue = (isString(stateValue) ? void 0 : stateValue[key2]) || (subHist ? subHist.current : void 0);
        if (!subStateValue) {
          return void 0;
        }
        return {
          current: subStateValue,
          states: updateHistoryStates(subHist, subStateValue)
        };
      });
    }
    function updateHistoryValue(hist, stateValue) {
      return {
        current: stateValue,
        states: updateHistoryStates(hist, stateValue)
      };
    }
    function updateContext(context, _event, assignActions, state) {
      if (!environment.IS_PRODUCTION) {
        exports2.warn(!!context, "Attempting to update undefined context");
      }
      var updatedContext = context ? assignActions.reduce(function(acc, assignAction) {
        var e_7, _a2;
        var assignment = assignAction.assignment;
        var meta = {
          state,
          action: assignAction,
          _event
        };
        var partialUpdate = {};
        if (isFunction(assignment)) {
          partialUpdate = assignment(acc, _event.data, meta);
        } else {
          try {
            for (var _b = _tslib.__values(keys(assignment)), _c = _b.next(); !_c.done; _c = _b.next()) {
              var key2 = _c.value;
              var propAssignment = assignment[key2];
              partialUpdate[key2] = isFunction(propAssignment) ? propAssignment(acc, _event.data, meta) : propAssignment;
            }
          } catch (e_7_1) {
            e_7 = {
              error: e_7_1
            };
          } finally {
            try {
              if (_c && !_c.done && (_a2 = _b.return))
                _a2.call(_b);
            } finally {
              if (e_7)
                throw e_7.error;
            }
          }
        }
        return Object.assign({}, acc, partialUpdate);
      }, context) : context;
      return updatedContext;
    }
    exports2.warn = function() {
    };
    if (!environment.IS_PRODUCTION) {
      exports2.warn = function(condition, message) {
        var error = condition instanceof Error ? condition : void 0;
        if (!error && condition) {
          return;
        }
        if (console !== void 0) {
          var args = ["Warning: " + message];
          if (error) {
            args.push(error);
          }
          console.warn.apply(console, args);
        }
      };
    }
    function isArray(value) {
      return Array.isArray(value);
    }
    function isFunction(value) {
      return typeof value === "function";
    }
    function isString(value) {
      return typeof value === "string";
    }
    function toGuard(condition, guardMap) {
      if (!condition) {
        return void 0;
      }
      if (isString(condition)) {
        return {
          type: constants.DEFAULT_GUARD_TYPE,
          name: condition,
          predicate: guardMap ? guardMap[condition] : void 0
        };
      }
      if (isFunction(condition)) {
        return {
          type: constants.DEFAULT_GUARD_TYPE,
          name: condition.name,
          predicate: condition
        };
      }
      return condition;
    }
    function isObservable(value) {
      try {
        return "subscribe" in value && isFunction(value.subscribe);
      } catch (e2) {
        return false;
      }
    }
    var symbolObservable = /* @__PURE__ */ function() {
      return typeof Symbol === "function" && Symbol.observable || "@@observable";
    }();
    function isMachine(value) {
      try {
        return "__xstatenode" in value;
      } catch (e2) {
        return false;
      }
    }
    function isActor(value) {
      return !!value && typeof value.send === "function";
    }
    var uniqueId = /* @__PURE__ */ function() {
      var currentId = 0;
      return function() {
        currentId++;
        return currentId.toString(16);
      };
    }();
    function toEventObject(event2, payload) {
      if (isString(event2) || typeof event2 === "number") {
        return _tslib.__assign({
          type: event2
        }, payload);
      }
      return event2;
    }
    function toSCXMLEvent(event2, scxmlEvent) {
      if (!isString(event2) && "$$type" in event2 && event2.$$type === "scxml") {
        return event2;
      }
      var eventObject = toEventObject(event2);
      return _tslib.__assign({
        name: eventObject.type,
        data: eventObject,
        $$type: "scxml",
        type: "external"
      }, scxmlEvent);
    }
    function toTransitionConfigArray(event2, configLike) {
      var transitions = toArrayStrict(configLike).map(function(transitionLike) {
        if (typeof transitionLike === "undefined" || typeof transitionLike === "string" || isMachine(transitionLike)) {
          return {
            target: transitionLike,
            event: event2
          };
        }
        return _tslib.__assign(_tslib.__assign({}, transitionLike), {
          event: event2
        });
      });
      return transitions;
    }
    function normalizeTarget(target) {
      if (target === void 0 || target === constants.TARGETLESS_KEY) {
        return void 0;
      }
      return toArray2(target);
    }
    function reportUnhandledExceptionOnInvocation(originalError, currentError, id) {
      if (!environment.IS_PRODUCTION) {
        var originalStackTrace = originalError.stack ? " Stacktrace was '" + originalError.stack + "'" : "";
        if (originalError === currentError) {
          console.error("Missing onError handler for invocation '" + id + "', error was '" + originalError + "'." + originalStackTrace);
        } else {
          var stackTrace2 = currentError.stack ? " Stacktrace was '" + currentError.stack + "'" : "";
          console.error("Missing onError handler and/or unhandled exception/promise rejection for invocation '" + id + "'. " + ("Original error: '" + originalError + "'. " + originalStackTrace + " Current error is '" + currentError + "'." + stackTrace2));
        }
      }
    }
    function evaluateGuard(machine, guard, context, _event, state) {
      var guards = machine.options.guards;
      var guardMeta = {
        state,
        cond: guard,
        _event
      };
      if (guard.type === constants.DEFAULT_GUARD_TYPE) {
        return ((guards === null || guards === void 0 ? void 0 : guards[guard.name]) || guard.predicate)(context, _event.data, guardMeta);
      }
      var condFn = guards[guard.type];
      if (!condFn) {
        throw new Error("Guard '" + guard.type + "' is not implemented on machine '" + machine.id + "'.");
      }
      return condFn(context, _event.data, guardMeta);
    }
    function toInvokeSource(src) {
      if (typeof src === "string") {
        return {
          type: src
        };
      }
      return src;
    }
    function toObserver(nextHandler, errorHandler, completionHandler) {
      if (typeof nextHandler === "object") {
        return nextHandler;
      }
      var noop = function() {
        return void 0;
      };
      return {
        next: nextHandler,
        error: errorHandler || noop,
        complete: completionHandler || noop
      };
    }
    exports2.evaluateGuard = evaluateGuard;
    exports2.flatten = flatten;
    exports2.getEventType = getEventType;
    exports2.isActor = isActor;
    exports2.isArray = isArray;
    exports2.isBehavior = isBehavior;
    exports2.isBuiltInEvent = isBuiltInEvent;
    exports2.isFunction = isFunction;
    exports2.isMachine = isMachine;
    exports2.isObservable = isObservable;
    exports2.isPromiseLike = isPromiseLike;
    exports2.isStateLike = isStateLike;
    exports2.isString = isString;
    exports2.keys = keys;
    exports2.mapContext = mapContext;
    exports2.mapFilterValues = mapFilterValues;
    exports2.mapValues = mapValues;
    exports2.matchesState = matchesState;
    exports2.nestedPath = nestedPath;
    exports2.normalizeTarget = normalizeTarget;
    exports2.partition = partition;
    exports2.path = path2;
    exports2.pathToStateValue = pathToStateValue;
    exports2.reportUnhandledExceptionOnInvocation = reportUnhandledExceptionOnInvocation;
    exports2.symbolObservable = symbolObservable;
    exports2.toArray = toArray2;
    exports2.toArrayStrict = toArrayStrict;
    exports2.toEventObject = toEventObject;
    exports2.toGuard = toGuard;
    exports2.toInvokeSource = toInvokeSource;
    exports2.toObserver = toObserver;
    exports2.toSCXMLEvent = toSCXMLEvent;
    exports2.toStatePath = toStatePath;
    exports2.toStatePaths = toStatePaths;
    exports2.toStateValue = toStateValue;
    exports2.toTransitionConfigArray = toTransitionConfigArray;
    exports2.uniqueId = uniqueId;
    exports2.updateContext = updateContext;
    exports2.updateHistoryStates = updateHistoryStates;
    exports2.updateHistoryValue = updateHistoryValue;
  }
});

// node_modules/xstate/lib/mapState.js
var require_mapState = __commonJS({
  "node_modules/xstate/lib/mapState.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var _tslib = require_tslib();
    var utils = require_utils();
    function mapState(stateMap, stateId) {
      var e_1, _a2;
      var foundStateId;
      try {
        for (var _b = _tslib.__values(utils.keys(stateMap)), _c = _b.next(); !_c.done; _c = _b.next()) {
          var mappedStateId = _c.value;
          if (utils.matchesState(mappedStateId, stateId) && (!foundStateId || stateId.length > foundStateId.length)) {
            foundStateId = mappedStateId;
          }
        }
      } catch (e_1_1) {
        e_1 = {
          error: e_1_1
        };
      } finally {
        try {
          if (_c && !_c.done && (_a2 = _b.return))
            _a2.call(_b);
        } finally {
          if (e_1)
            throw e_1.error;
        }
      }
      return stateMap[foundStateId];
    }
    exports2.mapState = mapState;
  }
});

// node_modules/xstate/lib/types.js
var require_types = __commonJS({
  "node_modules/xstate/lib/types.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    (function(ActionTypes) {
      ActionTypes["Start"] = "xstate.start";
      ActionTypes["Stop"] = "xstate.stop";
      ActionTypes["Raise"] = "xstate.raise";
      ActionTypes["Send"] = "xstate.send";
      ActionTypes["Cancel"] = "xstate.cancel";
      ActionTypes["NullEvent"] = "";
      ActionTypes["Assign"] = "xstate.assign";
      ActionTypes["After"] = "xstate.after";
      ActionTypes["DoneState"] = "done.state";
      ActionTypes["DoneInvoke"] = "done.invoke";
      ActionTypes["Log"] = "xstate.log";
      ActionTypes["Init"] = "xstate.init";
      ActionTypes["Invoke"] = "xstate.invoke";
      ActionTypes["ErrorExecution"] = "error.execution";
      ActionTypes["ErrorCommunication"] = "error.communication";
      ActionTypes["ErrorPlatform"] = "error.platform";
      ActionTypes["ErrorCustom"] = "xstate.error";
      ActionTypes["Update"] = "xstate.update";
      ActionTypes["Pure"] = "xstate.pure";
      ActionTypes["Choose"] = "xstate.choose";
    })(exports2.ActionTypes || (exports2.ActionTypes = {}));
    (function(SpecialTargets) {
      SpecialTargets["Parent"] = "#_parent";
      SpecialTargets["Internal"] = "#_internal";
    })(exports2.SpecialTargets || (exports2.SpecialTargets = {}));
  }
});

// node_modules/xstate/lib/actionTypes.js
var require_actionTypes = __commonJS({
  "node_modules/xstate/lib/actionTypes.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var types2 = require_types();
    var start = types2.ActionTypes.Start;
    var stop = types2.ActionTypes.Stop;
    var raise = types2.ActionTypes.Raise;
    var send3 = types2.ActionTypes.Send;
    var cancel = types2.ActionTypes.Cancel;
    var nullEvent = types2.ActionTypes.NullEvent;
    var assign3 = types2.ActionTypes.Assign;
    var after = types2.ActionTypes.After;
    var doneState = types2.ActionTypes.DoneState;
    var log = types2.ActionTypes.Log;
    var init = types2.ActionTypes.Init;
    var invoke = types2.ActionTypes.Invoke;
    var errorExecution = types2.ActionTypes.ErrorExecution;
    var errorPlatform = types2.ActionTypes.ErrorPlatform;
    var error = types2.ActionTypes.ErrorCustom;
    var update = types2.ActionTypes.Update;
    var choose = types2.ActionTypes.Choose;
    var pure = types2.ActionTypes.Pure;
    exports2.after = after;
    exports2.assign = assign3;
    exports2.cancel = cancel;
    exports2.choose = choose;
    exports2.doneState = doneState;
    exports2.error = error;
    exports2.errorExecution = errorExecution;
    exports2.errorPlatform = errorPlatform;
    exports2.init = init;
    exports2.invoke = invoke;
    exports2.log = log;
    exports2.nullEvent = nullEvent;
    exports2.pure = pure;
    exports2.raise = raise;
    exports2.send = send3;
    exports2.start = start;
    exports2.stop = stop;
    exports2.update = update;
  }
});

// node_modules/xstate/lib/actions.js
var require_actions = __commonJS({
  "node_modules/xstate/lib/actions.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var _tslib = require_tslib();
    var environment = require_environment();
    var utils = require_utils();
    var types2 = require_types();
    var actionTypes = require_actionTypes();
    var initEvent = /* @__PURE__ */ utils.toSCXMLEvent({
      type: actionTypes.init
    });
    function getActionFunction(actionType, actionFunctionMap) {
      return actionFunctionMap ? actionFunctionMap[actionType] || void 0 : void 0;
    }
    function toActionObject(action, actionFunctionMap) {
      var actionObject;
      if (utils.isString(action) || typeof action === "number") {
        var exec = getActionFunction(action, actionFunctionMap);
        if (utils.isFunction(exec)) {
          actionObject = {
            type: action,
            exec
          };
        } else if (exec) {
          actionObject = exec;
        } else {
          actionObject = {
            type: action,
            exec: void 0
          };
        }
      } else if (utils.isFunction(action)) {
        actionObject = {
          type: action.name || action.toString(),
          exec: action
        };
      } else {
        var exec = getActionFunction(action.type, actionFunctionMap);
        if (utils.isFunction(exec)) {
          actionObject = _tslib.__assign(_tslib.__assign({}, action), {
            exec
          });
        } else if (exec) {
          var actionType = exec.type || action.type;
          actionObject = _tslib.__assign(_tslib.__assign(_tslib.__assign({}, exec), action), {
            type: actionType
          });
        } else {
          actionObject = action;
        }
      }
      return actionObject;
    }
    var toActionObjects = function(action, actionFunctionMap) {
      if (!action) {
        return [];
      }
      var actions2 = utils.isArray(action) ? action : [action];
      return actions2.map(function(subAction) {
        return toActionObject(subAction, actionFunctionMap);
      });
    };
    function toActivityDefinition(action) {
      var actionObject = toActionObject(action);
      return _tslib.__assign(_tslib.__assign({
        id: utils.isString(action) ? action : actionObject.id
      }, actionObject), {
        type: actionObject.type
      });
    }
    function raise(event2) {
      if (!utils.isString(event2)) {
        return send3(event2, {
          to: types2.SpecialTargets.Internal
        });
      }
      return {
        type: actionTypes.raise,
        event: event2
      };
    }
    function resolveRaise(action) {
      return {
        type: actionTypes.raise,
        _event: utils.toSCXMLEvent(action.event)
      };
    }
    function send3(event2, options) {
      return {
        to: options ? options.to : void 0,
        type: actionTypes.send,
        event: utils.isFunction(event2) ? event2 : utils.toEventObject(event2),
        delay: options ? options.delay : void 0,
        id: options && options.id !== void 0 ? options.id : utils.isFunction(event2) ? event2.name : utils.getEventType(event2)
      };
    }
    function resolveSend(action, ctx, _event, delaysMap) {
      var meta = {
        _event
      };
      var resolvedEvent = utils.toSCXMLEvent(utils.isFunction(action.event) ? action.event(ctx, _event.data, meta) : action.event);
      var resolvedDelay;
      if (utils.isString(action.delay)) {
        var configDelay = delaysMap && delaysMap[action.delay];
        resolvedDelay = utils.isFunction(configDelay) ? configDelay(ctx, _event.data, meta) : configDelay;
      } else {
        resolvedDelay = utils.isFunction(action.delay) ? action.delay(ctx, _event.data, meta) : action.delay;
      }
      var resolvedTarget = utils.isFunction(action.to) ? action.to(ctx, _event.data, meta) : action.to;
      return _tslib.__assign(_tslib.__assign({}, action), {
        to: resolvedTarget,
        _event: resolvedEvent,
        event: resolvedEvent.data,
        delay: resolvedDelay
      });
    }
    function sendParent(event2, options) {
      return send3(event2, _tslib.__assign(_tslib.__assign({}, options), {
        to: types2.SpecialTargets.Parent
      }));
    }
    function sendUpdate() {
      return sendParent(actionTypes.update);
    }
    function respond(event2, options) {
      return send3(event2, _tslib.__assign(_tslib.__assign({}, options), {
        to: function(_, __, _a2) {
          var _event = _a2._event;
          return _event.origin;
        }
      }));
    }
    var defaultLogExpr = function(context, event2) {
      return {
        context,
        event: event2
      };
    };
    function log(expr, label) {
      if (expr === void 0) {
        expr = defaultLogExpr;
      }
      return {
        type: actionTypes.log,
        label,
        expr
      };
    }
    var resolveLog = function(action, ctx, _event) {
      return _tslib.__assign(_tslib.__assign({}, action), {
        value: utils.isString(action.expr) ? action.expr : action.expr(ctx, _event.data, {
          _event
        })
      });
    };
    var cancel = function(sendId) {
      return {
        type: actionTypes.cancel,
        sendId
      };
    };
    function start(activity) {
      var activityDef = toActivityDefinition(activity);
      return {
        type: types2.ActionTypes.Start,
        activity: activityDef,
        exec: void 0
      };
    }
    function stop(actorRef) {
      var activity = utils.isFunction(actorRef) ? actorRef : toActivityDefinition(actorRef);
      return {
        type: types2.ActionTypes.Stop,
        activity,
        exec: void 0
      };
    }
    function resolveStop(action, context, _event) {
      var actorRefOrString = utils.isFunction(action.activity) ? action.activity(context, _event.data) : action.activity;
      var resolvedActorRef = typeof actorRefOrString === "string" ? {
        id: actorRefOrString
      } : actorRefOrString;
      var actionObject = {
        type: types2.ActionTypes.Stop,
        activity: resolvedActorRef
      };
      return actionObject;
    }
    var assign3 = function(assignment) {
      return {
        type: actionTypes.assign,
        assignment
      };
    };
    function after(delayRef, id) {
      var idSuffix = id ? "#" + id : "";
      return types2.ActionTypes.After + "(" + delayRef + ")" + idSuffix;
    }
    function done(id, data) {
      var type3 = types2.ActionTypes.DoneState + "." + id;
      var eventObject = {
        type: type3,
        data
      };
      eventObject.toString = function() {
        return type3;
      };
      return eventObject;
    }
    function doneInvoke(id, data) {
      var type3 = types2.ActionTypes.DoneInvoke + "." + id;
      var eventObject = {
        type: type3,
        data
      };
      eventObject.toString = function() {
        return type3;
      };
      return eventObject;
    }
    function error(id, data) {
      var type3 = types2.ActionTypes.ErrorPlatform + "." + id;
      var eventObject = {
        type: type3,
        data
      };
      eventObject.toString = function() {
        return type3;
      };
      return eventObject;
    }
    function pure(getActions) {
      return {
        type: types2.ActionTypes.Pure,
        get: getActions
      };
    }
    function forwardTo(target, options) {
      return send3(function(_, event2) {
        return event2;
      }, _tslib.__assign(_tslib.__assign({}, options), {
        to: target
      }));
    }
    function escalate(errorData, options) {
      return sendParent(function(context, event2, meta) {
        return {
          type: actionTypes.error,
          data: utils.isFunction(errorData) ? errorData(context, event2, meta) : errorData
        };
      }, _tslib.__assign(_tslib.__assign({}, options), {
        to: types2.SpecialTargets.Parent
      }));
    }
    function choose(conds) {
      return {
        type: types2.ActionTypes.Choose,
        conds
      };
    }
    function resolveActions(machine, currentState, currentContext, _event, actions2, preserveActionOrder) {
      if (preserveActionOrder === void 0) {
        preserveActionOrder = false;
      }
      var _a2 = _tslib.__read(preserveActionOrder ? [[], actions2] : utils.partition(actions2, function(action) {
        return action.type === actionTypes.assign;
      }), 2), assignActions = _a2[0], otherActions = _a2[1];
      var updatedContext = assignActions.length ? utils.updateContext(currentContext, _event, assignActions, currentState) : currentContext;
      var preservedContexts = preserveActionOrder ? [currentContext] : void 0;
      var resolvedActions = utils.flatten(otherActions.map(function(actionObject) {
        var _a3;
        switch (actionObject.type) {
          case actionTypes.raise:
            return resolveRaise(actionObject);
          case actionTypes.send:
            var sendAction = resolveSend(actionObject, updatedContext, _event, machine.options.delays);
            if (!environment.IS_PRODUCTION) {
              utils.warn(!utils.isString(actionObject.delay) || typeof sendAction.delay === "number", "No delay reference for delay expression '" + actionObject.delay + "' was found on machine '" + machine.id + "'");
            }
            return sendAction;
          case actionTypes.log:
            return resolveLog(actionObject, updatedContext, _event);
          case actionTypes.choose: {
            var chooseAction = actionObject;
            var matchedActions = (_a3 = chooseAction.conds.find(function(condition) {
              var guard = utils.toGuard(condition.cond, machine.options.guards);
              return !guard || utils.evaluateGuard(machine, guard, updatedContext, _event, currentState);
            })) === null || _a3 === void 0 ? void 0 : _a3.actions;
            if (!matchedActions) {
              return [];
            }
            var _b = _tslib.__read(resolveActions(machine, currentState, updatedContext, _event, toActionObjects(utils.toArray(matchedActions), machine.options.actions), preserveActionOrder), 2), resolvedActionsFromChoose = _b[0], resolvedContextFromChoose = _b[1];
            updatedContext = resolvedContextFromChoose;
            preservedContexts === null || preservedContexts === void 0 ? void 0 : preservedContexts.push(updatedContext);
            return resolvedActionsFromChoose;
          }
          case actionTypes.pure: {
            var matchedActions = actionObject.get(updatedContext, _event.data);
            if (!matchedActions) {
              return [];
            }
            var _c = _tslib.__read(resolveActions(machine, currentState, updatedContext, _event, toActionObjects(utils.toArray(matchedActions), machine.options.actions), preserveActionOrder), 2), resolvedActionsFromPure = _c[0], resolvedContext = _c[1];
            updatedContext = resolvedContext;
            preservedContexts === null || preservedContexts === void 0 ? void 0 : preservedContexts.push(updatedContext);
            return resolvedActionsFromPure;
          }
          case actionTypes.stop: {
            return resolveStop(actionObject, updatedContext, _event);
          }
          case actionTypes.assign: {
            updatedContext = utils.updateContext(updatedContext, _event, [actionObject], currentState);
            preservedContexts === null || preservedContexts === void 0 ? void 0 : preservedContexts.push(updatedContext);
            break;
          }
          default:
            var resolvedActionObject = toActionObject(actionObject, machine.options.actions);
            var exec_1 = resolvedActionObject.exec;
            if (exec_1 && preservedContexts) {
              var contextIndex_1 = preservedContexts.length - 1;
              resolvedActionObject = _tslib.__assign(_tslib.__assign({}, resolvedActionObject), {
                exec: function(_ctx) {
                  var args = [];
                  for (var _i = 1; _i < arguments.length; _i++) {
                    args[_i - 1] = arguments[_i];
                  }
                  exec_1.apply(void 0, _tslib.__spreadArray([preservedContexts[contextIndex_1]], _tslib.__read(args)));
                }
              });
            }
            return resolvedActionObject;
        }
      }).filter(function(a2) {
        return !!a2;
      }));
      return [resolvedActions, updatedContext];
    }
    exports2.after = after;
    exports2.assign = assign3;
    exports2.cancel = cancel;
    exports2.choose = choose;
    exports2.done = done;
    exports2.doneInvoke = doneInvoke;
    exports2.error = error;
    exports2.escalate = escalate;
    exports2.forwardTo = forwardTo;
    exports2.getActionFunction = getActionFunction;
    exports2.initEvent = initEvent;
    exports2.log = log;
    exports2.pure = pure;
    exports2.raise = raise;
    exports2.resolveActions = resolveActions;
    exports2.resolveLog = resolveLog;
    exports2.resolveRaise = resolveRaise;
    exports2.resolveSend = resolveSend;
    exports2.resolveStop = resolveStop;
    exports2.respond = respond;
    exports2.send = send3;
    exports2.sendParent = sendParent;
    exports2.sendUpdate = sendUpdate;
    exports2.start = start;
    exports2.stop = stop;
    exports2.toActionObject = toActionObject;
    exports2.toActionObjects = toActionObjects;
    exports2.toActivityDefinition = toActivityDefinition;
  }
});

// node_modules/xstate/lib/stateUtils.js
var require_stateUtils = __commonJS({
  "node_modules/xstate/lib/stateUtils.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var _tslib = require_tslib();
    var utils = require_utils();
    var isLeafNode = function(stateNode) {
      return stateNode.type === "atomic" || stateNode.type === "final";
    };
    function getChildren(stateNode) {
      return utils.keys(stateNode.states).map(function(key2) {
        return stateNode.states[key2];
      });
    }
    function getAllStateNodes(stateNode) {
      var stateNodes = [stateNode];
      if (isLeafNode(stateNode)) {
        return stateNodes;
      }
      return stateNodes.concat(utils.flatten(getChildren(stateNode).map(getAllStateNodes)));
    }
    function getConfiguration(prevStateNodes, stateNodes) {
      var e_1, _a2, e_2, _b, e_3, _c, e_4, _d;
      var prevConfiguration = new Set(prevStateNodes);
      var prevAdjList = getAdjList(prevConfiguration);
      var configuration = new Set(stateNodes);
      try {
        for (var configuration_1 = _tslib.__values(configuration), configuration_1_1 = configuration_1.next(); !configuration_1_1.done; configuration_1_1 = configuration_1.next()) {
          var s2 = configuration_1_1.value;
          var m = s2.parent;
          while (m && !configuration.has(m)) {
            configuration.add(m);
            m = m.parent;
          }
        }
      } catch (e_1_1) {
        e_1 = {
          error: e_1_1
        };
      } finally {
        try {
          if (configuration_1_1 && !configuration_1_1.done && (_a2 = configuration_1.return))
            _a2.call(configuration_1);
        } finally {
          if (e_1)
            throw e_1.error;
        }
      }
      var adjList = getAdjList(configuration);
      try {
        for (var configuration_2 = _tslib.__values(configuration), configuration_2_1 = configuration_2.next(); !configuration_2_1.done; configuration_2_1 = configuration_2.next()) {
          var s2 = configuration_2_1.value;
          if (s2.type === "compound" && (!adjList.get(s2) || !adjList.get(s2).length)) {
            if (prevAdjList.get(s2)) {
              prevAdjList.get(s2).forEach(function(sn) {
                return configuration.add(sn);
              });
            } else {
              s2.initialStateNodes.forEach(function(sn) {
                return configuration.add(sn);
              });
            }
          } else {
            if (s2.type === "parallel") {
              try {
                for (var _e = (e_3 = void 0, _tslib.__values(getChildren(s2))), _f = _e.next(); !_f.done; _f = _e.next()) {
                  var child = _f.value;
                  if (child.type === "history") {
                    continue;
                  }
                  if (!configuration.has(child)) {
                    configuration.add(child);
                    if (prevAdjList.get(child)) {
                      prevAdjList.get(child).forEach(function(sn) {
                        return configuration.add(sn);
                      });
                    } else {
                      child.initialStateNodes.forEach(function(sn) {
                        return configuration.add(sn);
                      });
                    }
                  }
                }
              } catch (e_3_1) {
                e_3 = {
                  error: e_3_1
                };
              } finally {
                try {
                  if (_f && !_f.done && (_c = _e.return))
                    _c.call(_e);
                } finally {
                  if (e_3)
                    throw e_3.error;
                }
              }
            }
          }
        }
      } catch (e_2_1) {
        e_2 = {
          error: e_2_1
        };
      } finally {
        try {
          if (configuration_2_1 && !configuration_2_1.done && (_b = configuration_2.return))
            _b.call(configuration_2);
        } finally {
          if (e_2)
            throw e_2.error;
        }
      }
      try {
        for (var configuration_3 = _tslib.__values(configuration), configuration_3_1 = configuration_3.next(); !configuration_3_1.done; configuration_3_1 = configuration_3.next()) {
          var s2 = configuration_3_1.value;
          var m = s2.parent;
          while (m && !configuration.has(m)) {
            configuration.add(m);
            m = m.parent;
          }
        }
      } catch (e_4_1) {
        e_4 = {
          error: e_4_1
        };
      } finally {
        try {
          if (configuration_3_1 && !configuration_3_1.done && (_d = configuration_3.return))
            _d.call(configuration_3);
        } finally {
          if (e_4)
            throw e_4.error;
        }
      }
      return configuration;
    }
    function getValueFromAdj(baseNode, adjList) {
      var childStateNodes = adjList.get(baseNode);
      if (!childStateNodes) {
        return {};
      }
      if (baseNode.type === "compound") {
        var childStateNode = childStateNodes[0];
        if (childStateNode) {
          if (isLeafNode(childStateNode)) {
            return childStateNode.key;
          }
        } else {
          return {};
        }
      }
      var stateValue = {};
      childStateNodes.forEach(function(csn) {
        stateValue[csn.key] = getValueFromAdj(csn, adjList);
      });
      return stateValue;
    }
    function getAdjList(configuration) {
      var e_5, _a2;
      var adjList = /* @__PURE__ */ new Map();
      try {
        for (var configuration_4 = _tslib.__values(configuration), configuration_4_1 = configuration_4.next(); !configuration_4_1.done; configuration_4_1 = configuration_4.next()) {
          var s2 = configuration_4_1.value;
          if (!adjList.has(s2)) {
            adjList.set(s2, []);
          }
          if (s2.parent) {
            if (!adjList.has(s2.parent)) {
              adjList.set(s2.parent, []);
            }
            adjList.get(s2.parent).push(s2);
          }
        }
      } catch (e_5_1) {
        e_5 = {
          error: e_5_1
        };
      } finally {
        try {
          if (configuration_4_1 && !configuration_4_1.done && (_a2 = configuration_4.return))
            _a2.call(configuration_4);
        } finally {
          if (e_5)
            throw e_5.error;
        }
      }
      return adjList;
    }
    function getValue2(rootNode, configuration) {
      var config = getConfiguration([rootNode], configuration);
      return getValueFromAdj(rootNode, getAdjList(config));
    }
    function has(iterable, item) {
      if (Array.isArray(iterable)) {
        return iterable.some(function(member) {
          return member === item;
        });
      }
      if (iterable instanceof Set) {
        return iterable.has(item);
      }
      return false;
    }
    function nextEvents(configuration) {
      return _tslib.__spreadArray([], _tslib.__read(new Set(utils.flatten(_tslib.__spreadArray([], _tslib.__read(configuration.map(function(sn) {
        return sn.ownEvents;
      })))))));
    }
    function isInFinalState(configuration, stateNode) {
      if (stateNode.type === "compound") {
        return getChildren(stateNode).some(function(s2) {
          return s2.type === "final" && has(configuration, s2);
        });
      }
      if (stateNode.type === "parallel") {
        return getChildren(stateNode).every(function(sn) {
          return isInFinalState(configuration, sn);
        });
      }
      return false;
    }
    function getMeta(configuration) {
      if (configuration === void 0) {
        configuration = [];
      }
      return configuration.reduce(function(acc, stateNode) {
        if (stateNode.meta !== void 0) {
          acc[stateNode.id] = stateNode.meta;
        }
        return acc;
      }, {});
    }
    function getTagsFromConfiguration(configuration) {
      return new Set(utils.flatten(configuration.map(function(sn) {
        return sn.tags;
      })));
    }
    exports2.getAdjList = getAdjList;
    exports2.getAllStateNodes = getAllStateNodes;
    exports2.getChildren = getChildren;
    exports2.getConfiguration = getConfiguration;
    exports2.getMeta = getMeta;
    exports2.getTagsFromConfiguration = getTagsFromConfiguration;
    exports2.getValue = getValue2;
    exports2.has = has;
    exports2.isInFinalState = isInFinalState;
    exports2.isLeafNode = isLeafNode;
    exports2.nextEvents = nextEvents;
  }
});

// node_modules/xstate/lib/State.js
var require_State = __commonJS({
  "node_modules/xstate/lib/State.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var _tslib = require_tslib();
    var constants = require_constants2();
    var environment = require_environment();
    var utils = require_utils();
    var stateUtils = require_stateUtils();
    var actions2 = require_actions();
    function stateValuesEqual(a2, b2) {
      if (a2 === b2) {
        return true;
      }
      if (a2 === void 0 || b2 === void 0) {
        return false;
      }
      if (utils.isString(a2) || utils.isString(b2)) {
        return a2 === b2;
      }
      var aKeys = utils.keys(a2);
      var bKeys = utils.keys(b2);
      return aKeys.length === bKeys.length && aKeys.every(function(key2) {
        return stateValuesEqual(a2[key2], b2[key2]);
      });
    }
    function isState(state) {
      if (utils.isString(state)) {
        return false;
      }
      return "value" in state && "history" in state;
    }
    function bindActionToState(action, state) {
      var exec = action.exec;
      var boundAction = _tslib.__assign(_tslib.__assign({}, action), {
        exec: exec !== void 0 ? function() {
          return exec(state.context, state.event, {
            action,
            state,
            _event: state._event
          });
        } : void 0
      });
      return boundAction;
    }
    var State2 = /* @__PURE__ */ function() {
      function State3(config) {
        var _this = this;
        var _a2;
        this.actions = [];
        this.activities = constants.EMPTY_ACTIVITY_MAP;
        this.meta = {};
        this.events = [];
        this.value = config.value;
        this.context = config.context;
        this._event = config._event;
        this._sessionid = config._sessionid;
        this.event = this._event.data;
        this.historyValue = config.historyValue;
        this.history = config.history;
        this.actions = config.actions || [];
        this.activities = config.activities || constants.EMPTY_ACTIVITY_MAP;
        this.meta = stateUtils.getMeta(config.configuration);
        this.events = config.events || [];
        this.matches = this.matches.bind(this);
        this.toStrings = this.toStrings.bind(this);
        this.configuration = config.configuration;
        this.transitions = config.transitions;
        this.children = config.children;
        this.done = !!config.done;
        this.tags = (_a2 = Array.isArray(config.tags) ? new Set(config.tags) : config.tags) !== null && _a2 !== void 0 ? _a2 : /* @__PURE__ */ new Set();
        this.machine = config.machine;
        Object.defineProperty(this, "nextEvents", {
          get: function() {
            return stateUtils.nextEvents(_this.configuration);
          }
        });
      }
      State3.from = function(stateValue, context) {
        if (stateValue instanceof State3) {
          if (stateValue.context !== context) {
            return new State3({
              value: stateValue.value,
              context,
              _event: stateValue._event,
              _sessionid: null,
              historyValue: stateValue.historyValue,
              history: stateValue.history,
              actions: [],
              activities: stateValue.activities,
              meta: {},
              events: [],
              configuration: [],
              transitions: [],
              children: {}
            });
          }
          return stateValue;
        }
        var _event = actions2.initEvent;
        return new State3({
          value: stateValue,
          context,
          _event,
          _sessionid: null,
          historyValue: void 0,
          history: void 0,
          actions: [],
          activities: void 0,
          meta: void 0,
          events: [],
          configuration: [],
          transitions: [],
          children: {}
        });
      };
      State3.create = function(config) {
        return new State3(config);
      };
      State3.inert = function(stateValue, context) {
        if (stateValue instanceof State3) {
          if (!stateValue.actions.length) {
            return stateValue;
          }
          var _event = actions2.initEvent;
          return new State3({
            value: stateValue.value,
            context,
            _event,
            _sessionid: null,
            historyValue: stateValue.historyValue,
            history: stateValue.history,
            activities: stateValue.activities,
            configuration: stateValue.configuration,
            transitions: [],
            children: {}
          });
        }
        return State3.from(stateValue, context);
      };
      State3.prototype.toStrings = function(stateValue, delimiter) {
        var _this = this;
        if (stateValue === void 0) {
          stateValue = this.value;
        }
        if (delimiter === void 0) {
          delimiter = ".";
        }
        if (utils.isString(stateValue)) {
          return [stateValue];
        }
        var valueKeys = utils.keys(stateValue);
        return valueKeys.concat.apply(valueKeys, _tslib.__spreadArray([], _tslib.__read(valueKeys.map(function(key2) {
          return _this.toStrings(stateValue[key2], delimiter).map(function(s2) {
            return key2 + delimiter + s2;
          });
        }))));
      };
      State3.prototype.toJSON = function() {
        var _a2 = this, configuration = _a2.configuration, transitions = _a2.transitions, tags = _a2.tags, machine = _a2.machine, jsonValues = _tslib.__rest(_a2, ["configuration", "transitions", "tags", "machine"]);
        return _tslib.__assign(_tslib.__assign({}, jsonValues), {
          tags: Array.from(tags)
        });
      };
      State3.prototype.matches = function(parentStateValue) {
        return utils.matchesState(parentStateValue, this.value);
      };
      State3.prototype.hasTag = function(tag) {
        return this.tags.has(tag);
      };
      State3.prototype.can = function(event2) {
        var _a2;
        if (environment.IS_PRODUCTION) {
          utils.warn(!!this.machine, "state.can(...) used outside of a machine-created State object; this will always return false.");
        }
        return !!((_a2 = this.machine) === null || _a2 === void 0 ? void 0 : _a2.transition(this, event2).changed);
      };
      return State3;
    }();
    exports2.State = State2;
    exports2.bindActionToState = bindActionToState;
    exports2.isState = isState;
    exports2.stateValuesEqual = stateValuesEqual;
  }
});

// node_modules/xstate/lib/serviceScope.js
var require_serviceScope = __commonJS({
  "node_modules/xstate/lib/serviceScope.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var serviceStack = [];
    var provide = function(service, fn) {
      serviceStack.push(service);
      var result2 = fn(service);
      serviceStack.pop();
      return result2;
    };
    var consume = function(fn) {
      return fn(serviceStack[serviceStack.length - 1]);
    };
    exports2.consume = consume;
    exports2.provide = provide;
  }
});

// node_modules/xstate/lib/Actor.js
var require_Actor = __commonJS({
  "node_modules/xstate/lib/Actor.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var _tslib = require_tslib();
    var utils = require_utils();
    var serviceScope = require_serviceScope();
    function createNullActor(id) {
      return {
        id,
        send: function() {
          return void 0;
        },
        subscribe: function() {
          return {
            unsubscribe: function() {
              return void 0;
            }
          };
        },
        getSnapshot: function() {
          return void 0;
        },
        toJSON: function() {
          return {
            id
          };
        }
      };
    }
    function createInvocableActor(invokeDefinition, machine, context, _event) {
      var _a2;
      var invokeSrc = utils.toInvokeSource(invokeDefinition.src);
      var serviceCreator = (_a2 = machine === null || machine === void 0 ? void 0 : machine.options.services) === null || _a2 === void 0 ? void 0 : _a2[invokeSrc.type];
      var resolvedData = invokeDefinition.data ? utils.mapContext(invokeDefinition.data, context, _event) : void 0;
      var tempActor = serviceCreator ? createDeferredActor(serviceCreator, invokeDefinition.id, resolvedData) : createNullActor(invokeDefinition.id);
      tempActor.meta = invokeDefinition;
      return tempActor;
    }
    function createDeferredActor(entity, id, data) {
      var tempActor = createNullActor(id);
      tempActor.deferred = true;
      if (utils.isMachine(entity)) {
        var initialState_1 = tempActor.state = serviceScope.provide(void 0, function() {
          return (data ? entity.withContext(data) : entity).initialState;
        });
        tempActor.getSnapshot = function() {
          return initialState_1;
        };
      }
      return tempActor;
    }
    function isActor(item) {
      try {
        return typeof item.send === "function";
      } catch (e2) {
        return false;
      }
    }
    function isSpawnedActor(item) {
      return isActor(item) && "id" in item;
    }
    function toActorRef(actorRefLike) {
      return _tslib.__assign({
        subscribe: function() {
          return {
            unsubscribe: function() {
              return void 0;
            }
          };
        },
        id: "anonymous",
        getSnapshot: function() {
          return void 0;
        }
      }, actorRefLike);
    }
    exports2.createDeferredActor = createDeferredActor;
    exports2.createInvocableActor = createInvocableActor;
    exports2.createNullActor = createNullActor;
    exports2.isActor = isActor;
    exports2.isSpawnedActor = isSpawnedActor;
    exports2.toActorRef = toActorRef;
  }
});

// node_modules/xstate/lib/invokeUtils.js
var require_invokeUtils = __commonJS({
  "node_modules/xstate/lib/invokeUtils.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var _tslib = require_tslib();
    require_environment();
    require_utils();
    require_types();
    var actionTypes = require_actionTypes();
    function toInvokeSource(src) {
      if (typeof src === "string") {
        var simpleSrc = {
          type: src
        };
        simpleSrc.toString = function() {
          return src;
        };
        return simpleSrc;
      }
      return src;
    }
    function toInvokeDefinition(invokeConfig) {
      return _tslib.__assign(_tslib.__assign({
        type: actionTypes.invoke
      }, invokeConfig), {
        toJSON: function() {
          var onDone = invokeConfig.onDone, onError = invokeConfig.onError, invokeDef = _tslib.__rest(invokeConfig, ["onDone", "onError"]);
          return _tslib.__assign(_tslib.__assign({}, invokeDef), {
            type: actionTypes.invoke,
            src: toInvokeSource(invokeConfig.src)
          });
        }
      });
    }
    exports2.toInvokeDefinition = toInvokeDefinition;
    exports2.toInvokeSource = toInvokeSource;
  }
});

// node_modules/xstate/lib/StateNode.js
var require_StateNode = __commonJS({
  "node_modules/xstate/lib/StateNode.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var _tslib = require_tslib();
    var constants = require_constants2();
    var environment = require_environment();
    var utils = require_utils();
    var types2 = require_types();
    var stateUtils = require_stateUtils();
    var actionTypes = require_actionTypes();
    var actions2 = require_actions();
    var State2 = require_State();
    var Actor = require_Actor();
    var invokeUtils = require_invokeUtils();
    var NULL_EVENT = "";
    var STATE_IDENTIFIER = "#";
    var WILDCARD = "*";
    var EMPTY_OBJECT = {};
    var isStateId = function(str2) {
      return str2[0] === STATE_IDENTIFIER;
    };
    var createDefaultOptions = function() {
      return {
        actions: {},
        guards: {},
        services: {},
        activities: {},
        delays: {}
      };
    };
    var validateArrayifiedTransitions = function(stateNode, event2, transitions) {
      var hasNonLastUnguardedTarget = transitions.slice(0, -1).some(function(transition) {
        return !("cond" in transition) && !("in" in transition) && (utils.isString(transition.target) || utils.isMachine(transition.target));
      });
      var eventText = event2 === NULL_EVENT ? "the transient event" : "event '" + event2 + "'";
      utils.warn(!hasNonLastUnguardedTarget, "One or more transitions for " + eventText + " on state '" + stateNode.id + "' are unreachable. Make sure that the default transition is the last one defined.");
    };
    var StateNode = /* @__PURE__ */ function() {
      function StateNode2(config, options, _context) {
        var _this = this;
        if (_context === void 0) {
          _context = "context" in config ? config.context : void 0;
        }
        var _a2;
        this.config = config;
        this._context = _context;
        this.order = -1;
        this.__xstatenode = true;
        this.__cache = {
          events: void 0,
          relativeValue: /* @__PURE__ */ new Map(),
          initialStateValue: void 0,
          initialState: void 0,
          on: void 0,
          transitions: void 0,
          candidates: {},
          delayedTransitions: void 0
        };
        this.idMap = {};
        this.tags = [];
        this.options = Object.assign(createDefaultOptions(), options);
        this.parent = this.options._parent;
        this.key = this.config.key || this.options._key || this.config.id || "(machine)";
        this.machine = this.parent ? this.parent.machine : this;
        this.path = this.parent ? this.parent.path.concat(this.key) : [];
        this.delimiter = this.config.delimiter || (this.parent ? this.parent.delimiter : constants.STATE_DELIMITER);
        this.id = this.config.id || _tslib.__spreadArray([this.machine.key], _tslib.__read(this.path)).join(this.delimiter);
        this.version = this.parent ? this.parent.version : this.config.version;
        this.type = this.config.type || (this.config.parallel ? "parallel" : this.config.states && utils.keys(this.config.states).length ? "compound" : this.config.history ? "history" : "atomic");
        this.schema = this.parent ? this.machine.schema : (_a2 = this.config.schema) !== null && _a2 !== void 0 ? _a2 : {};
        this.description = this.config.description;
        if (!environment.IS_PRODUCTION) {
          utils.warn(!("parallel" in this.config), 'The "parallel" property is deprecated and will be removed in version 4.1. ' + (this.config.parallel ? "Replace with `type: 'parallel'`" : "Use `type: '" + this.type + "'`") + " in the config for state node '" + this.id + "' instead.");
        }
        this.initial = this.config.initial;
        this.states = this.config.states ? utils.mapValues(this.config.states, function(stateConfig, key2) {
          var _a3;
          var stateNode = new StateNode2(stateConfig, {
            _parent: _this,
            _key: key2
          });
          Object.assign(_this.idMap, _tslib.__assign((_a3 = {}, _a3[stateNode.id] = stateNode, _a3), stateNode.idMap));
          return stateNode;
        }) : EMPTY_OBJECT;
        var order = 0;
        function dfs(stateNode) {
          var e_1, _a3;
          stateNode.order = order++;
          try {
            for (var _b = _tslib.__values(stateUtils.getChildren(stateNode)), _c = _b.next(); !_c.done; _c = _b.next()) {
              var child = _c.value;
              dfs(child);
            }
          } catch (e_1_1) {
            e_1 = {
              error: e_1_1
            };
          } finally {
            try {
              if (_c && !_c.done && (_a3 = _b.return))
                _a3.call(_b);
            } finally {
              if (e_1)
                throw e_1.error;
            }
          }
        }
        dfs(this);
        this.history = this.config.history === true ? "shallow" : this.config.history || false;
        this._transient = !!this.config.always || (!this.config.on ? false : Array.isArray(this.config.on) ? this.config.on.some(function(_a3) {
          var event2 = _a3.event;
          return event2 === NULL_EVENT;
        }) : NULL_EVENT in this.config.on);
        this.strict = !!this.config.strict;
        this.onEntry = utils.toArray(this.config.entry || this.config.onEntry).map(function(action) {
          return actions2.toActionObject(action);
        });
        this.onExit = utils.toArray(this.config.exit || this.config.onExit).map(function(action) {
          return actions2.toActionObject(action);
        });
        this.meta = this.config.meta;
        this.doneData = this.type === "final" ? this.config.data : void 0;
        this.invoke = utils.toArray(this.config.invoke).map(function(invokeConfig, i3) {
          var _a3, _b;
          if (utils.isMachine(invokeConfig)) {
            _this.machine.options.services = _tslib.__assign((_a3 = {}, _a3[invokeConfig.id] = invokeConfig, _a3), _this.machine.options.services);
            return invokeUtils.toInvokeDefinition({
              src: invokeConfig.id,
              id: invokeConfig.id
            });
          } else if (utils.isString(invokeConfig.src)) {
            return invokeUtils.toInvokeDefinition(_tslib.__assign(_tslib.__assign({}, invokeConfig), {
              id: invokeConfig.id || invokeConfig.src,
              src: invokeConfig.src
            }));
          } else if (utils.isMachine(invokeConfig.src) || utils.isFunction(invokeConfig.src)) {
            var invokeSrc = _this.id + ":invocation[" + i3 + "]";
            _this.machine.options.services = _tslib.__assign((_b = {}, _b[invokeSrc] = invokeConfig.src, _b), _this.machine.options.services);
            return invokeUtils.toInvokeDefinition(_tslib.__assign(_tslib.__assign({
              id: invokeSrc
            }, invokeConfig), {
              src: invokeSrc
            }));
          } else {
            var invokeSource = invokeConfig.src;
            return invokeUtils.toInvokeDefinition(_tslib.__assign(_tslib.__assign({
              id: invokeSource.type
            }, invokeConfig), {
              src: invokeSource
            }));
          }
        });
        this.activities = utils.toArray(this.config.activities).concat(this.invoke).map(function(activity) {
          return actions2.toActivityDefinition(activity);
        });
        this.transition = this.transition.bind(this);
        this.tags = utils.toArray(this.config.tags);
      }
      StateNode2.prototype._init = function() {
        if (this.__cache.transitions) {
          return;
        }
        stateUtils.getAllStateNodes(this).forEach(function(stateNode) {
          return stateNode.on;
        });
      };
      StateNode2.prototype.withConfig = function(options, context) {
        var _a2 = this.options, actions3 = _a2.actions, activities = _a2.activities, guards = _a2.guards, services = _a2.services, delays = _a2.delays;
        return new StateNode2(this.config, {
          actions: _tslib.__assign(_tslib.__assign({}, actions3), options.actions),
          activities: _tslib.__assign(_tslib.__assign({}, activities), options.activities),
          guards: _tslib.__assign(_tslib.__assign({}, guards), options.guards),
          services: _tslib.__assign(_tslib.__assign({}, services), options.services),
          delays: _tslib.__assign(_tslib.__assign({}, delays), options.delays)
        }, context !== null && context !== void 0 ? context : this.context);
      };
      StateNode2.prototype.withContext = function(context) {
        return new StateNode2(this.config, this.options, context);
      };
      Object.defineProperty(StateNode2.prototype, "context", {
        get: function() {
          return utils.isFunction(this._context) ? this._context() : this._context;
        },
        enumerable: false,
        configurable: true
      });
      Object.defineProperty(StateNode2.prototype, "definition", {
        get: function() {
          return {
            id: this.id,
            key: this.key,
            version: this.version,
            context: this.context,
            type: this.type,
            initial: this.initial,
            history: this.history,
            states: utils.mapValues(this.states, function(state) {
              return state.definition;
            }),
            on: this.on,
            transitions: this.transitions,
            entry: this.onEntry,
            exit: this.onExit,
            activities: this.activities || [],
            meta: this.meta,
            order: this.order || -1,
            data: this.doneData,
            invoke: this.invoke,
            description: this.description,
            tags: this.tags
          };
        },
        enumerable: false,
        configurable: true
      });
      StateNode2.prototype.toJSON = function() {
        return this.definition;
      };
      Object.defineProperty(StateNode2.prototype, "on", {
        get: function() {
          if (this.__cache.on) {
            return this.__cache.on;
          }
          var transitions = this.transitions;
          return this.__cache.on = transitions.reduce(function(map2, transition) {
            map2[transition.eventType] = map2[transition.eventType] || [];
            map2[transition.eventType].push(transition);
            return map2;
          }, {});
        },
        enumerable: false,
        configurable: true
      });
      Object.defineProperty(StateNode2.prototype, "after", {
        get: function() {
          return this.__cache.delayedTransitions || (this.__cache.delayedTransitions = this.getDelayedTransitions(), this.__cache.delayedTransitions);
        },
        enumerable: false,
        configurable: true
      });
      Object.defineProperty(StateNode2.prototype, "transitions", {
        get: function() {
          return this.__cache.transitions || (this.__cache.transitions = this.formatTransitions(), this.__cache.transitions);
        },
        enumerable: false,
        configurable: true
      });
      StateNode2.prototype.getCandidates = function(eventName) {
        if (this.__cache.candidates[eventName]) {
          return this.__cache.candidates[eventName];
        }
        var transient = eventName === NULL_EVENT;
        var candidates = this.transitions.filter(function(transition) {
          var sameEventType = transition.eventType === eventName;
          return transient ? sameEventType : sameEventType || transition.eventType === WILDCARD;
        });
        this.__cache.candidates[eventName] = candidates;
        return candidates;
      };
      StateNode2.prototype.getDelayedTransitions = function() {
        var _this = this;
        var afterConfig = this.config.after;
        if (!afterConfig) {
          return [];
        }
        var mutateEntryExit = function(delay, i3) {
          var delayRef = utils.isFunction(delay) ? _this.id + ":delay[" + i3 + "]" : delay;
          var eventType = actions2.after(delayRef, _this.id);
          _this.onEntry.push(actions2.send(eventType, {
            delay
          }));
          _this.onExit.push(actions2.cancel(eventType));
          return eventType;
        };
        var delayedTransitions = utils.isArray(afterConfig) ? afterConfig.map(function(transition, i3) {
          var eventType = mutateEntryExit(transition.delay, i3);
          return _tslib.__assign(_tslib.__assign({}, transition), {
            event: eventType
          });
        }) : utils.flatten(utils.keys(afterConfig).map(function(delay, i3) {
          var configTransition = afterConfig[delay];
          var resolvedTransition = utils.isString(configTransition) ? {
            target: configTransition
          } : configTransition;
          var resolvedDelay = !isNaN(+delay) ? +delay : delay;
          var eventType = mutateEntryExit(resolvedDelay, i3);
          return utils.toArray(resolvedTransition).map(function(transition) {
            return _tslib.__assign(_tslib.__assign({}, transition), {
              event: eventType,
              delay: resolvedDelay
            });
          });
        }));
        return delayedTransitions.map(function(delayedTransition) {
          var delay = delayedTransition.delay;
          return _tslib.__assign(_tslib.__assign({}, _this.formatTransition(delayedTransition)), {
            delay
          });
        });
      };
      StateNode2.prototype.getStateNodes = function(state) {
        var _a2;
        var _this = this;
        if (!state) {
          return [];
        }
        var stateValue = state instanceof State2.State ? state.value : utils.toStateValue(state, this.delimiter);
        if (utils.isString(stateValue)) {
          var initialStateValue = this.getStateNode(stateValue).initial;
          return initialStateValue !== void 0 ? this.getStateNodes((_a2 = {}, _a2[stateValue] = initialStateValue, _a2)) : [this, this.states[stateValue]];
        }
        var subStateKeys = utils.keys(stateValue);
        var subStateNodes = subStateKeys.map(function(subStateKey) {
          return _this.getStateNode(subStateKey);
        });
        subStateNodes.push(this);
        return subStateNodes.concat(subStateKeys.reduce(function(allSubStateNodes, subStateKey) {
          var subStateNode = _this.getStateNode(subStateKey).getStateNodes(stateValue[subStateKey]);
          return allSubStateNodes.concat(subStateNode);
        }, []));
      };
      StateNode2.prototype.handles = function(event2) {
        var eventType = utils.getEventType(event2);
        return this.events.includes(eventType);
      };
      StateNode2.prototype.resolveState = function(state) {
        var configuration = Array.from(stateUtils.getConfiguration([], this.getStateNodes(state.value)));
        return new State2.State(_tslib.__assign(_tslib.__assign({}, state), {
          value: this.resolve(state.value),
          configuration,
          done: stateUtils.isInFinalState(configuration, this),
          tags: stateUtils.getTagsFromConfiguration(configuration)
        }));
      };
      StateNode2.prototype.transitionLeafNode = function(stateValue, state, _event) {
        var stateNode = this.getStateNode(stateValue);
        var next = stateNode.next(state, _event);
        if (!next || !next.transitions.length) {
          return this.next(state, _event);
        }
        return next;
      };
      StateNode2.prototype.transitionCompoundNode = function(stateValue, state, _event) {
        var subStateKeys = utils.keys(stateValue);
        var stateNode = this.getStateNode(subStateKeys[0]);
        var next = stateNode._transition(stateValue[subStateKeys[0]], state, _event);
        if (!next || !next.transitions.length) {
          return this.next(state, _event);
        }
        return next;
      };
      StateNode2.prototype.transitionParallelNode = function(stateValue, state, _event) {
        var e_2, _a2;
        var transitionMap = {};
        try {
          for (var _b = _tslib.__values(utils.keys(stateValue)), _c = _b.next(); !_c.done; _c = _b.next()) {
            var subStateKey = _c.value;
            var subStateValue = stateValue[subStateKey];
            if (!subStateValue) {
              continue;
            }
            var subStateNode = this.getStateNode(subStateKey);
            var next = subStateNode._transition(subStateValue, state, _event);
            if (next) {
              transitionMap[subStateKey] = next;
            }
          }
        } catch (e_2_1) {
          e_2 = {
            error: e_2_1
          };
        } finally {
          try {
            if (_c && !_c.done && (_a2 = _b.return))
              _a2.call(_b);
          } finally {
            if (e_2)
              throw e_2.error;
          }
        }
        var stateTransitions = utils.keys(transitionMap).map(function(key2) {
          return transitionMap[key2];
        });
        var enabledTransitions = utils.flatten(stateTransitions.map(function(st) {
          return st.transitions;
        }));
        var willTransition = stateTransitions.some(function(st) {
          return st.transitions.length > 0;
        });
        if (!willTransition) {
          return this.next(state, _event);
        }
        var entryNodes = utils.flatten(stateTransitions.map(function(t2) {
          return t2.entrySet;
        }));
        var configuration = utils.flatten(utils.keys(transitionMap).map(function(key2) {
          return transitionMap[key2].configuration;
        }));
        return {
          transitions: enabledTransitions,
          entrySet: entryNodes,
          exitSet: utils.flatten(stateTransitions.map(function(t2) {
            return t2.exitSet;
          })),
          configuration,
          source: state,
          actions: utils.flatten(utils.keys(transitionMap).map(function(key2) {
            return transitionMap[key2].actions;
          }))
        };
      };
      StateNode2.prototype._transition = function(stateValue, state, _event) {
        if (utils.isString(stateValue)) {
          return this.transitionLeafNode(stateValue, state, _event);
        }
        if (utils.keys(stateValue).length === 1) {
          return this.transitionCompoundNode(stateValue, state, _event);
        }
        return this.transitionParallelNode(stateValue, state, _event);
      };
      StateNode2.prototype.next = function(state, _event) {
        var e_3, _a2;
        var _this = this;
        var eventName = _event.name;
        var actions3 = [];
        var nextStateNodes = [];
        var selectedTransition;
        try {
          for (var _b = _tslib.__values(this.getCandidates(eventName)), _c = _b.next(); !_c.done; _c = _b.next()) {
            var candidate = _c.value;
            var cond = candidate.cond, stateIn = candidate.in;
            var resolvedContext = state.context;
            var isInState = stateIn ? utils.isString(stateIn) && isStateId(stateIn) ? state.matches(utils.toStateValue(this.getStateNodeById(stateIn).path, this.delimiter)) : utils.matchesState(utils.toStateValue(stateIn, this.delimiter), utils.path(this.path.slice(0, -2))(state.value)) : true;
            var guardPassed = false;
            try {
              guardPassed = !cond || utils.evaluateGuard(this.machine, cond, resolvedContext, _event, state);
            } catch (err2) {
              throw new Error("Unable to evaluate guard '" + (cond.name || cond.type) + "' in transition for event '" + eventName + "' in state node '" + this.id + "':\n" + err2.message);
            }
            if (guardPassed && isInState) {
              if (candidate.target !== void 0) {
                nextStateNodes = candidate.target;
              }
              actions3.push.apply(actions3, _tslib.__spreadArray([], _tslib.__read(candidate.actions)));
              selectedTransition = candidate;
              break;
            }
          }
        } catch (e_3_1) {
          e_3 = {
            error: e_3_1
          };
        } finally {
          try {
            if (_c && !_c.done && (_a2 = _b.return))
              _a2.call(_b);
          } finally {
            if (e_3)
              throw e_3.error;
          }
        }
        if (!selectedTransition) {
          return void 0;
        }
        if (!nextStateNodes.length) {
          return {
            transitions: [selectedTransition],
            entrySet: [],
            exitSet: [],
            configuration: state.value ? [this] : [],
            source: state,
            actions: actions3
          };
        }
        var allNextStateNodes = utils.flatten(nextStateNodes.map(function(stateNode) {
          return _this.getRelativeStateNodes(stateNode, state.historyValue);
        }));
        var isInternal = !!selectedTransition.internal;
        var reentryNodes = isInternal ? [] : utils.flatten(allNextStateNodes.map(function(n2) {
          return _this.nodesFromChild(n2);
        }));
        return {
          transitions: [selectedTransition],
          entrySet: reentryNodes,
          exitSet: isInternal ? [] : [this],
          configuration: allNextStateNodes,
          source: state,
          actions: actions3
        };
      };
      StateNode2.prototype.nodesFromChild = function(childStateNode) {
        if (childStateNode.escapes(this)) {
          return [];
        }
        var nodes = [];
        var marker = childStateNode;
        while (marker && marker !== this) {
          nodes.push(marker);
          marker = marker.parent;
        }
        nodes.push(this);
        return nodes;
      };
      StateNode2.prototype.escapes = function(stateNode) {
        if (this === stateNode) {
          return false;
        }
        var parent = this.parent;
        while (parent) {
          if (parent === stateNode) {
            return false;
          }
          parent = parent.parent;
        }
        return true;
      };
      StateNode2.prototype.getActions = function(transition, currentContext, _event, prevState) {
        var e_4, _a2, e_5, _b;
        var prevConfig = stateUtils.getConfiguration([], prevState ? this.getStateNodes(prevState.value) : [this]);
        var resolvedConfig = transition.configuration.length ? stateUtils.getConfiguration(prevConfig, transition.configuration) : prevConfig;
        try {
          for (var resolvedConfig_1 = _tslib.__values(resolvedConfig), resolvedConfig_1_1 = resolvedConfig_1.next(); !resolvedConfig_1_1.done; resolvedConfig_1_1 = resolvedConfig_1.next()) {
            var sn = resolvedConfig_1_1.value;
            if (!stateUtils.has(prevConfig, sn)) {
              transition.entrySet.push(sn);
            }
          }
        } catch (e_4_1) {
          e_4 = {
            error: e_4_1
          };
        } finally {
          try {
            if (resolvedConfig_1_1 && !resolvedConfig_1_1.done && (_a2 = resolvedConfig_1.return))
              _a2.call(resolvedConfig_1);
          } finally {
            if (e_4)
              throw e_4.error;
          }
        }
        try {
          for (var prevConfig_1 = _tslib.__values(prevConfig), prevConfig_1_1 = prevConfig_1.next(); !prevConfig_1_1.done; prevConfig_1_1 = prevConfig_1.next()) {
            var sn = prevConfig_1_1.value;
            if (!stateUtils.has(resolvedConfig, sn) || stateUtils.has(transition.exitSet, sn.parent)) {
              transition.exitSet.push(sn);
            }
          }
        } catch (e_5_1) {
          e_5 = {
            error: e_5_1
          };
        } finally {
          try {
            if (prevConfig_1_1 && !prevConfig_1_1.done && (_b = prevConfig_1.return))
              _b.call(prevConfig_1);
          } finally {
            if (e_5)
              throw e_5.error;
          }
        }
        if (!transition.source) {
          transition.exitSet = [];
          transition.entrySet.push(this);
        }
        var doneEvents = utils.flatten(transition.entrySet.map(function(sn2) {
          var events = [];
          if (sn2.type !== "final") {
            return events;
          }
          var parent = sn2.parent;
          if (!parent.parent) {
            return events;
          }
          events.push(actions2.done(sn2.id, sn2.doneData), actions2.done(parent.id, sn2.doneData ? utils.mapContext(sn2.doneData, currentContext, _event) : void 0));
          var grandparent = parent.parent;
          if (grandparent.type === "parallel") {
            if (stateUtils.getChildren(grandparent).every(function(parentNode) {
              return stateUtils.isInFinalState(transition.configuration, parentNode);
            })) {
              events.push(actions2.done(grandparent.id));
            }
          }
          return events;
        }));
        transition.exitSet.sort(function(a2, b2) {
          return b2.order - a2.order;
        });
        transition.entrySet.sort(function(a2, b2) {
          return a2.order - b2.order;
        });
        var entryStates = new Set(transition.entrySet);
        var exitStates = new Set(transition.exitSet);
        var _c = _tslib.__read([utils.flatten(Array.from(entryStates).map(function(stateNode) {
          return _tslib.__spreadArray(_tslib.__spreadArray([], _tslib.__read(stateNode.activities.map(function(activity) {
            return actions2.start(activity);
          }))), _tslib.__read(stateNode.onEntry));
        })).concat(doneEvents.map(actions2.raise)), utils.flatten(Array.from(exitStates).map(function(stateNode) {
          return _tslib.__spreadArray(_tslib.__spreadArray([], _tslib.__read(stateNode.onExit)), _tslib.__read(stateNode.activities.map(function(activity) {
            return actions2.stop(activity);
          })));
        }))], 2), entryActions = _c[0], exitActions = _c[1];
        var actions$1 = actions2.toActionObjects(exitActions.concat(transition.actions).concat(entryActions), this.machine.options.actions);
        return actions$1;
      };
      StateNode2.prototype.transition = function(state, event2, context) {
        if (state === void 0) {
          state = this.initialState;
        }
        var _event = utils.toSCXMLEvent(event2);
        var currentState;
        if (state instanceof State2.State) {
          currentState = context === void 0 ? state : this.resolveState(State2.State.from(state, context));
        } else {
          var resolvedStateValue = utils.isString(state) ? this.resolve(utils.pathToStateValue(this.getResolvedPath(state))) : this.resolve(state);
          var resolvedContext = context !== null && context !== void 0 ? context : this.machine.context;
          currentState = this.resolveState(State2.State.from(resolvedStateValue, resolvedContext));
        }
        if (!environment.IS_PRODUCTION && _event.name === WILDCARD) {
          throw new Error("An event cannot have the wildcard type ('" + WILDCARD + "')");
        }
        if (this.strict) {
          if (!this.events.includes(_event.name) && !utils.isBuiltInEvent(_event.name)) {
            throw new Error("Machine '" + this.id + "' does not accept event '" + _event.name + "'");
          }
        }
        var stateTransition = this._transition(currentState.value, currentState, _event) || {
          transitions: [],
          configuration: [],
          entrySet: [],
          exitSet: [],
          source: currentState,
          actions: []
        };
        var prevConfig = stateUtils.getConfiguration([], this.getStateNodes(currentState.value));
        var resolvedConfig = stateTransition.configuration.length ? stateUtils.getConfiguration(prevConfig, stateTransition.configuration) : prevConfig;
        stateTransition.configuration = _tslib.__spreadArray([], _tslib.__read(resolvedConfig));
        return this.resolveTransition(stateTransition, currentState, _event);
      };
      StateNode2.prototype.resolveRaisedTransition = function(state, _event, originalEvent) {
        var _a2;
        var currentActions = state.actions;
        state = this.transition(state, _event);
        state._event = originalEvent;
        state.event = originalEvent.data;
        (_a2 = state.actions).unshift.apply(_a2, _tslib.__spreadArray([], _tslib.__read(currentActions)));
        return state;
      };
      StateNode2.prototype.resolveTransition = function(stateTransition, currentState, _event, context) {
        var e_6, _a2;
        var _this = this;
        if (_event === void 0) {
          _event = actions2.initEvent;
        }
        if (context === void 0) {
          context = this.machine.context;
        }
        var configuration = stateTransition.configuration;
        var willTransition = !currentState || stateTransition.transitions.length > 0;
        var resolvedStateValue = willTransition ? stateUtils.getValue(this.machine, configuration) : void 0;
        var historyValue = currentState ? currentState.historyValue ? currentState.historyValue : stateTransition.source ? this.machine.historyValue(currentState.value) : void 0 : void 0;
        var currentContext = currentState ? currentState.context : context;
        var actions$1 = this.getActions(stateTransition, currentContext, _event, currentState);
        var activities = currentState ? _tslib.__assign({}, currentState.activities) : {};
        try {
          for (var actions_1 = _tslib.__values(actions$1), actions_1_1 = actions_1.next(); !actions_1_1.done; actions_1_1 = actions_1.next()) {
            var action = actions_1_1.value;
            if (action.type === actionTypes.start) {
              activities[action.activity.id || action.activity.type] = action;
            } else if (action.type === actionTypes.stop) {
              activities[action.activity.id || action.activity.type] = false;
            }
          }
        } catch (e_6_1) {
          e_6 = {
            error: e_6_1
          };
        } finally {
          try {
            if (actions_1_1 && !actions_1_1.done && (_a2 = actions_1.return))
              _a2.call(actions_1);
          } finally {
            if (e_6)
              throw e_6.error;
          }
        }
        var _b = _tslib.__read(actions2.resolveActions(this, currentState, currentContext, _event, actions$1, this.machine.config.preserveActionOrder), 2), resolvedActions = _b[0], updatedContext = _b[1];
        var _c = _tslib.__read(utils.partition(resolvedActions, function(action2) {
          return action2.type === actionTypes.raise || action2.type === actionTypes.send && action2.to === types2.SpecialTargets.Internal;
        }), 2), raisedEvents = _c[0], nonRaisedActions = _c[1];
        var invokeActions = resolvedActions.filter(function(action2) {
          var _a3;
          return action2.type === actionTypes.start && ((_a3 = action2.activity) === null || _a3 === void 0 ? void 0 : _a3.type) === actionTypes.invoke;
        });
        var children = invokeActions.reduce(function(acc, action2) {
          acc[action2.activity.id] = Actor.createInvocableActor(action2.activity, _this.machine, updatedContext, _event);
          return acc;
        }, currentState ? _tslib.__assign({}, currentState.children) : {});
        var resolvedConfiguration = resolvedStateValue ? stateTransition.configuration : currentState ? currentState.configuration : [];
        var isDone = stateUtils.isInFinalState(resolvedConfiguration, this);
        var nextState = new State2.State({
          value: resolvedStateValue || currentState.value,
          context: updatedContext,
          _event,
          _sessionid: currentState ? currentState._sessionid : null,
          historyValue: resolvedStateValue ? historyValue ? utils.updateHistoryValue(historyValue, resolvedStateValue) : void 0 : currentState ? currentState.historyValue : void 0,
          history: !resolvedStateValue || stateTransition.source ? currentState : void 0,
          actions: resolvedStateValue ? nonRaisedActions : [],
          activities: resolvedStateValue ? activities : currentState ? currentState.activities : {},
          events: [],
          configuration: resolvedConfiguration,
          transitions: stateTransition.transitions,
          children,
          done: isDone,
          tags: currentState === null || currentState === void 0 ? void 0 : currentState.tags,
          machine: this
        });
        var didUpdateContext = currentContext !== updatedContext;
        nextState.changed = _event.name === actionTypes.update || didUpdateContext;
        var history = nextState.history;
        if (history) {
          delete history.history;
        }
        var isTransient = !isDone && (this._transient || configuration.some(function(stateNode) {
          return stateNode._transient;
        }));
        if (!willTransition && (!isTransient || _event.name === NULL_EVENT)) {
          return nextState;
        }
        var maybeNextState = nextState;
        if (!isDone) {
          if (isTransient) {
            maybeNextState = this.resolveRaisedTransition(maybeNextState, {
              type: actionTypes.nullEvent
            }, _event);
          }
          while (raisedEvents.length) {
            var raisedEvent = raisedEvents.shift();
            maybeNextState = this.resolveRaisedTransition(maybeNextState, raisedEvent._event, _event);
          }
        }
        var changed = maybeNextState.changed || (history ? !!maybeNextState.actions.length || didUpdateContext || typeof history.value !== typeof maybeNextState.value || !State2.stateValuesEqual(maybeNextState.value, history.value) : void 0);
        maybeNextState.changed = changed;
        maybeNextState.history = history;
        maybeNextState.tags = stateUtils.getTagsFromConfiguration(maybeNextState.configuration);
        return maybeNextState;
      };
      StateNode2.prototype.getStateNode = function(stateKey) {
        if (isStateId(stateKey)) {
          return this.machine.getStateNodeById(stateKey);
        }
        if (!this.states) {
          throw new Error("Unable to retrieve child state '" + stateKey + "' from '" + this.id + "'; no child states exist.");
        }
        var result2 = this.states[stateKey];
        if (!result2) {
          throw new Error("Child state '" + stateKey + "' does not exist on '" + this.id + "'");
        }
        return result2;
      };
      StateNode2.prototype.getStateNodeById = function(stateId) {
        var resolvedStateId = isStateId(stateId) ? stateId.slice(STATE_IDENTIFIER.length) : stateId;
        if (resolvedStateId === this.id) {
          return this;
        }
        var stateNode = this.machine.idMap[resolvedStateId];
        if (!stateNode) {
          throw new Error("Child state node '#" + resolvedStateId + "' does not exist on machine '" + this.id + "'");
        }
        return stateNode;
      };
      StateNode2.prototype.getStateNodeByPath = function(statePath) {
        if (typeof statePath === "string" && isStateId(statePath)) {
          try {
            return this.getStateNodeById(statePath.slice(1));
          } catch (e2) {
          }
        }
        var arrayStatePath = utils.toStatePath(statePath, this.delimiter).slice();
        var currentStateNode = this;
        while (arrayStatePath.length) {
          var key2 = arrayStatePath.shift();
          if (!key2.length) {
            break;
          }
          currentStateNode = currentStateNode.getStateNode(key2);
        }
        return currentStateNode;
      };
      StateNode2.prototype.resolve = function(stateValue) {
        var _a2;
        var _this = this;
        if (!stateValue) {
          return this.initialStateValue || EMPTY_OBJECT;
        }
        switch (this.type) {
          case "parallel":
            return utils.mapValues(this.initialStateValue, function(subStateValue, subStateKey) {
              return subStateValue ? _this.getStateNode(subStateKey).resolve(stateValue[subStateKey] || subStateValue) : EMPTY_OBJECT;
            });
          case "compound":
            if (utils.isString(stateValue)) {
              var subStateNode = this.getStateNode(stateValue);
              if (subStateNode.type === "parallel" || subStateNode.type === "compound") {
                return _a2 = {}, _a2[stateValue] = subStateNode.initialStateValue, _a2;
              }
              return stateValue;
            }
            if (!utils.keys(stateValue).length) {
              return this.initialStateValue || {};
            }
            return utils.mapValues(stateValue, function(subStateValue, subStateKey) {
              return subStateValue ? _this.getStateNode(subStateKey).resolve(subStateValue) : EMPTY_OBJECT;
            });
          default:
            return stateValue || EMPTY_OBJECT;
        }
      };
      StateNode2.prototype.getResolvedPath = function(stateIdentifier) {
        if (isStateId(stateIdentifier)) {
          var stateNode = this.machine.idMap[stateIdentifier.slice(STATE_IDENTIFIER.length)];
          if (!stateNode) {
            throw new Error("Unable to find state node '" + stateIdentifier + "'");
          }
          return stateNode.path;
        }
        return utils.toStatePath(stateIdentifier, this.delimiter);
      };
      Object.defineProperty(StateNode2.prototype, "initialStateValue", {
        get: function() {
          var _a2;
          if (this.__cache.initialStateValue) {
            return this.__cache.initialStateValue;
          }
          var initialStateValue;
          if (this.type === "parallel") {
            initialStateValue = utils.mapFilterValues(this.states, function(state) {
              return state.initialStateValue || EMPTY_OBJECT;
            }, function(stateNode) {
              return !(stateNode.type === "history");
            });
          } else if (this.initial !== void 0) {
            if (!this.states[this.initial]) {
              throw new Error("Initial state '" + this.initial + "' not found on '" + this.key + "'");
            }
            initialStateValue = stateUtils.isLeafNode(this.states[this.initial]) ? this.initial : (_a2 = {}, _a2[this.initial] = this.states[this.initial].initialStateValue, _a2);
          } else {
            initialStateValue = {};
          }
          this.__cache.initialStateValue = initialStateValue;
          return this.__cache.initialStateValue;
        },
        enumerable: false,
        configurable: true
      });
      StateNode2.prototype.getInitialState = function(stateValue, context) {
        var configuration = this.getStateNodes(stateValue);
        return this.resolveTransition({
          configuration,
          entrySet: configuration,
          exitSet: [],
          transitions: [],
          source: void 0,
          actions: []
        }, void 0, void 0, context);
      };
      Object.defineProperty(StateNode2.prototype, "initialState", {
        get: function() {
          this._init();
          var initialStateValue = this.initialStateValue;
          if (!initialStateValue) {
            throw new Error("Cannot retrieve initial state from simple state '" + this.id + "'.");
          }
          return this.getInitialState(initialStateValue);
        },
        enumerable: false,
        configurable: true
      });
      Object.defineProperty(StateNode2.prototype, "target", {
        get: function() {
          var target;
          if (this.type === "history") {
            var historyConfig = this.config;
            if (utils.isString(historyConfig.target)) {
              target = isStateId(historyConfig.target) ? utils.pathToStateValue(this.machine.getStateNodeById(historyConfig.target).path.slice(this.path.length - 1)) : historyConfig.target;
            } else {
              target = historyConfig.target;
            }
          }
          return target;
        },
        enumerable: false,
        configurable: true
      });
      StateNode2.prototype.getRelativeStateNodes = function(relativeStateId, historyValue, resolve) {
        if (resolve === void 0) {
          resolve = true;
        }
        return resolve ? relativeStateId.type === "history" ? relativeStateId.resolveHistory(historyValue) : relativeStateId.initialStateNodes : [relativeStateId];
      };
      Object.defineProperty(StateNode2.prototype, "initialStateNodes", {
        get: function() {
          var _this = this;
          if (stateUtils.isLeafNode(this)) {
            return [this];
          }
          if (this.type === "compound" && !this.initial) {
            if (!environment.IS_PRODUCTION) {
              utils.warn(false, "Compound state node '" + this.id + "' has no initial state.");
            }
            return [this];
          }
          var initialStateNodePaths = utils.toStatePaths(this.initialStateValue);
          return utils.flatten(initialStateNodePaths.map(function(initialPath) {
            return _this.getFromRelativePath(initialPath);
          }));
        },
        enumerable: false,
        configurable: true
      });
      StateNode2.prototype.getFromRelativePath = function(relativePath) {
        if (!relativePath.length) {
          return [this];
        }
        var _a2 = _tslib.__read(relativePath), stateKey = _a2[0], childStatePath = _a2.slice(1);
        if (!this.states) {
          throw new Error("Cannot retrieve subPath '" + stateKey + "' from node with no states");
        }
        var childStateNode = this.getStateNode(stateKey);
        if (childStateNode.type === "history") {
          return childStateNode.resolveHistory();
        }
        if (!this.states[stateKey]) {
          throw new Error("Child state '" + stateKey + "' does not exist on '" + this.id + "'");
        }
        return this.states[stateKey].getFromRelativePath(childStatePath);
      };
      StateNode2.prototype.historyValue = function(relativeStateValue) {
        if (!utils.keys(this.states).length) {
          return void 0;
        }
        return {
          current: relativeStateValue || this.initialStateValue,
          states: utils.mapFilterValues(this.states, function(stateNode, key2) {
            if (!relativeStateValue) {
              return stateNode.historyValue();
            }
            var subStateValue = utils.isString(relativeStateValue) ? void 0 : relativeStateValue[key2];
            return stateNode.historyValue(subStateValue || stateNode.initialStateValue);
          }, function(stateNode) {
            return !stateNode.history;
          })
        };
      };
      StateNode2.prototype.resolveHistory = function(historyValue) {
        var _this = this;
        if (this.type !== "history") {
          return [this];
        }
        var parent = this.parent;
        if (!historyValue) {
          var historyTarget = this.target;
          return historyTarget ? utils.flatten(utils.toStatePaths(historyTarget).map(function(relativeChildPath) {
            return parent.getFromRelativePath(relativeChildPath);
          })) : parent.initialStateNodes;
        }
        var subHistoryValue = utils.nestedPath(parent.path, "states")(historyValue).current;
        if (utils.isString(subHistoryValue)) {
          return [parent.getStateNode(subHistoryValue)];
        }
        return utils.flatten(utils.toStatePaths(subHistoryValue).map(function(subStatePath) {
          return _this.history === "deep" ? parent.getFromRelativePath(subStatePath) : [parent.states[subStatePath[0]]];
        }));
      };
      Object.defineProperty(StateNode2.prototype, "stateIds", {
        get: function() {
          var _this = this;
          var childStateIds = utils.flatten(utils.keys(this.states).map(function(stateKey) {
            return _this.states[stateKey].stateIds;
          }));
          return [this.id].concat(childStateIds);
        },
        enumerable: false,
        configurable: true
      });
      Object.defineProperty(StateNode2.prototype, "events", {
        get: function() {
          var e_7, _a2, e_8, _b;
          if (this.__cache.events) {
            return this.__cache.events;
          }
          var states = this.states;
          var events = new Set(this.ownEvents);
          if (states) {
            try {
              for (var _c = _tslib.__values(utils.keys(states)), _d = _c.next(); !_d.done; _d = _c.next()) {
                var stateId = _d.value;
                var state = states[stateId];
                if (state.states) {
                  try {
                    for (var _e = (e_8 = void 0, _tslib.__values(state.events)), _f = _e.next(); !_f.done; _f = _e.next()) {
                      var event_1 = _f.value;
                      events.add("" + event_1);
                    }
                  } catch (e_8_1) {
                    e_8 = {
                      error: e_8_1
                    };
                  } finally {
                    try {
                      if (_f && !_f.done && (_b = _e.return))
                        _b.call(_e);
                    } finally {
                      if (e_8)
                        throw e_8.error;
                    }
                  }
                }
              }
            } catch (e_7_1) {
              e_7 = {
                error: e_7_1
              };
            } finally {
              try {
                if (_d && !_d.done && (_a2 = _c.return))
                  _a2.call(_c);
              } finally {
                if (e_7)
                  throw e_7.error;
              }
            }
          }
          return this.__cache.events = Array.from(events);
        },
        enumerable: false,
        configurable: true
      });
      Object.defineProperty(StateNode2.prototype, "ownEvents", {
        get: function() {
          var events = new Set(this.transitions.filter(function(transition) {
            return !(!transition.target && !transition.actions.length && transition.internal);
          }).map(function(transition) {
            return transition.eventType;
          }));
          return Array.from(events);
        },
        enumerable: false,
        configurable: true
      });
      StateNode2.prototype.resolveTarget = function(_target) {
        var _this = this;
        if (_target === void 0) {
          return void 0;
        }
        return _target.map(function(target) {
          if (!utils.isString(target)) {
            return target;
          }
          var isInternalTarget = target[0] === _this.delimiter;
          if (isInternalTarget && !_this.parent) {
            return _this.getStateNodeByPath(target.slice(1));
          }
          var resolvedTarget = isInternalTarget ? _this.key + target : target;
          if (_this.parent) {
            try {
              var targetStateNode = _this.parent.getStateNodeByPath(resolvedTarget);
              return targetStateNode;
            } catch (err2) {
              throw new Error("Invalid transition definition for state node '" + _this.id + "':\n" + err2.message);
            }
          } else {
            return _this.getStateNodeByPath(resolvedTarget);
          }
        });
      };
      StateNode2.prototype.formatTransition = function(transitionConfig) {
        var _this = this;
        var normalizedTarget = utils.normalizeTarget(transitionConfig.target);
        var internal = "internal" in transitionConfig ? transitionConfig.internal : normalizedTarget ? normalizedTarget.some(function(_target) {
          return utils.isString(_target) && _target[0] === _this.delimiter;
        }) : true;
        var guards = this.machine.options.guards;
        var target = this.resolveTarget(normalizedTarget);
        var transition = _tslib.__assign(_tslib.__assign({}, transitionConfig), {
          actions: actions2.toActionObjects(utils.toArray(transitionConfig.actions)),
          cond: utils.toGuard(transitionConfig.cond, guards),
          target,
          source: this,
          internal,
          eventType: transitionConfig.event,
          toJSON: function() {
            return _tslib.__assign(_tslib.__assign({}, transition), {
              target: transition.target ? transition.target.map(function(t2) {
                return "#" + t2.id;
              }) : void 0,
              source: "#" + _this.id
            });
          }
        });
        return transition;
      };
      StateNode2.prototype.formatTransitions = function() {
        var e_9, _a2;
        var _this = this;
        var onConfig;
        if (!this.config.on) {
          onConfig = [];
        } else if (Array.isArray(this.config.on)) {
          onConfig = this.config.on;
        } else {
          var _b = this.config.on, _c = WILDCARD, _d = _b[_c], wildcardConfigs = _d === void 0 ? [] : _d, strictTransitionConfigs_1 = _tslib.__rest(_b, [typeof _c === "symbol" ? _c : _c + ""]);
          onConfig = utils.flatten(utils.keys(strictTransitionConfigs_1).map(function(key2) {
            if (!environment.IS_PRODUCTION && key2 === NULL_EVENT) {
              utils.warn(false, "Empty string transition configs (e.g., `{ on: { '': ... }}`) for transient transitions are deprecated. Specify the transition in the `{ always: ... }` property instead. " + ('Please check the `on` configuration for "#' + _this.id + '".'));
            }
            var transitionConfigArray = utils.toTransitionConfigArray(key2, strictTransitionConfigs_1[key2]);
            if (!environment.IS_PRODUCTION) {
              validateArrayifiedTransitions(_this, key2, transitionConfigArray);
            }
            return transitionConfigArray;
          }).concat(utils.toTransitionConfigArray(WILDCARD, wildcardConfigs)));
        }
        var eventlessConfig = this.config.always ? utils.toTransitionConfigArray("", this.config.always) : [];
        var doneConfig = this.config.onDone ? utils.toTransitionConfigArray(String(actions2.done(this.id)), this.config.onDone) : [];
        if (!environment.IS_PRODUCTION) {
          utils.warn(!(this.config.onDone && !this.parent), 'Root nodes cannot have an ".onDone" transition. Please check the config of "' + this.id + '".');
        }
        var invokeConfig = utils.flatten(this.invoke.map(function(invokeDef) {
          var settleTransitions = [];
          if (invokeDef.onDone) {
            settleTransitions.push.apply(settleTransitions, _tslib.__spreadArray([], _tslib.__read(utils.toTransitionConfigArray(String(actions2.doneInvoke(invokeDef.id)), invokeDef.onDone))));
          }
          if (invokeDef.onError) {
            settleTransitions.push.apply(settleTransitions, _tslib.__spreadArray([], _tslib.__read(utils.toTransitionConfigArray(String(actions2.error(invokeDef.id)), invokeDef.onError))));
          }
          return settleTransitions;
        }));
        var delayedTransitions = this.after;
        var formattedTransitions = utils.flatten(_tslib.__spreadArray(_tslib.__spreadArray(_tslib.__spreadArray(_tslib.__spreadArray([], _tslib.__read(doneConfig)), _tslib.__read(invokeConfig)), _tslib.__read(onConfig)), _tslib.__read(eventlessConfig)).map(function(transitionConfig) {
          return utils.toArray(transitionConfig).map(function(transition) {
            return _this.formatTransition(transition);
          });
        }));
        try {
          for (var delayedTransitions_1 = _tslib.__values(delayedTransitions), delayedTransitions_1_1 = delayedTransitions_1.next(); !delayedTransitions_1_1.done; delayedTransitions_1_1 = delayedTransitions_1.next()) {
            var delayedTransition = delayedTransitions_1_1.value;
            formattedTransitions.push(delayedTransition);
          }
        } catch (e_9_1) {
          e_9 = {
            error: e_9_1
          };
        } finally {
          try {
            if (delayedTransitions_1_1 && !delayedTransitions_1_1.done && (_a2 = delayedTransitions_1.return))
              _a2.call(delayedTransitions_1);
          } finally {
            if (e_9)
              throw e_9.error;
          }
        }
        return formattedTransitions;
      };
      return StateNode2;
    }();
    exports2.StateNode = StateNode;
  }
});

// node_modules/xstate/lib/Machine.js
var require_Machine = __commonJS({
  "node_modules/xstate/lib/Machine.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var StateNode = require_StateNode();
    function Machine(config, options, initialContext) {
      if (initialContext === void 0) {
        initialContext = config.context;
      }
      return new StateNode.StateNode(config, options, initialContext);
    }
    function createMachine3(config, options) {
      return new StateNode.StateNode(config, options);
    }
    exports2.Machine = Machine;
    exports2.createMachine = createMachine3;
  }
});

// node_modules/xstate/lib/scheduler.js
var require_scheduler2 = __commonJS({
  "node_modules/xstate/lib/scheduler.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var _tslib = require_tslib();
    var defaultOptions = {
      deferEvents: false
    };
    var Scheduler = /* @__PURE__ */ function() {
      function Scheduler2(options) {
        this.processingEvent = false;
        this.queue = [];
        this.initialized = false;
        this.options = _tslib.__assign(_tslib.__assign({}, defaultOptions), options);
      }
      Scheduler2.prototype.initialize = function(callback) {
        this.initialized = true;
        if (callback) {
          if (!this.options.deferEvents) {
            this.schedule(callback);
            return;
          }
          this.process(callback);
        }
        this.flushEvents();
      };
      Scheduler2.prototype.schedule = function(task2) {
        if (!this.initialized || this.processingEvent) {
          this.queue.push(task2);
          return;
        }
        if (this.queue.length !== 0) {
          throw new Error("Event queue should be empty when it is not processing events");
        }
        this.process(task2);
        this.flushEvents();
      };
      Scheduler2.prototype.clear = function() {
        this.queue = [];
      };
      Scheduler2.prototype.flushEvents = function() {
        var nextCallback = this.queue.shift();
        while (nextCallback) {
          this.process(nextCallback);
          nextCallback = this.queue.shift();
        }
      };
      Scheduler2.prototype.process = function(callback) {
        this.processingEvent = true;
        try {
          callback();
        } catch (e2) {
          this.clear();
          throw e2;
        } finally {
          this.processingEvent = false;
        }
      };
      return Scheduler2;
    }();
    exports2.Scheduler = Scheduler;
  }
});

// node_modules/xstate/lib/registry.js
var require_registry = __commonJS({
  "node_modules/xstate/lib/registry.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var children = /* @__PURE__ */ new Map();
    var sessionIdIndex = 0;
    var registry = {
      bookId: function() {
        return "x:" + sessionIdIndex++;
      },
      register: function(id, actor) {
        children.set(id, actor);
        return id;
      },
      get: function(id) {
        return children.get(id);
      },
      free: function(id) {
        children.delete(id);
      }
    };
    exports2.registry = registry;
  }
});

// node_modules/xstate/lib/devTools.js
var require_devTools = __commonJS({
  "node_modules/xstate/lib/devTools.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    function getGlobal() {
      if (typeof self !== "undefined") {
        return self;
      }
      if (typeof window !== "undefined") {
        return window;
      }
      if (typeof global !== "undefined") {
        return global;
      }
      return void 0;
    }
    function getDevTools() {
      var global2 = getGlobal();
      if (global2 && "__xstate__" in global2) {
        return global2.__xstate__;
      }
      return void 0;
    }
    function registerService(service) {
      if (!getGlobal()) {
        return;
      }
      var devTools = getDevTools();
      if (devTools) {
        devTools.register(service);
      }
    }
    exports2.getGlobal = getGlobal;
    exports2.registerService = registerService;
  }
});

// node_modules/xstate/lib/behaviors.js
var require_behaviors = __commonJS({
  "node_modules/xstate/lib/behaviors.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    require_environment();
    var utils = require_utils();
    require_types();
    require_actionTypes();
    var Actor = require_Actor();
    function spawnBehavior(behavior, options) {
      if (options === void 0) {
        options = {};
      }
      var state = behavior.initialState;
      var observers = /* @__PURE__ */ new Set();
      var mailbox = [];
      var flushing = false;
      var flush = function() {
        if (flushing) {
          return;
        }
        flushing = true;
        while (mailbox.length > 0) {
          var event_1 = mailbox.shift();
          state = behavior.transition(state, event_1, actorCtx);
          observers.forEach(function(observer) {
            return observer.next(state);
          });
        }
        flushing = false;
      };
      var actor = Actor.toActorRef({
        id: options.id,
        send: function(event2) {
          mailbox.push(event2);
          flush();
        },
        getSnapshot: function() {
          return state;
        },
        subscribe: function(next, handleError, complete) {
          var observer = utils.toObserver(next, handleError, complete);
          observers.add(observer);
          observer.next(state);
          return {
            unsubscribe: function() {
              observers.delete(observer);
            }
          };
        }
      });
      var actorCtx = {
        parent: options.parent,
        self: actor,
        id: options.id || "anonymous",
        observers
      };
      state = behavior.start ? behavior.start(actorCtx) : state;
      return actor;
    }
    exports2.spawnBehavior = spawnBehavior;
  }
});

// node_modules/xstate/lib/interpreter.js
var require_interpreter = __commonJS({
  "node_modules/xstate/lib/interpreter.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var _tslib = require_tslib();
    var environment = require_environment();
    var utils = require_utils();
    var types2 = require_types();
    var stateUtils = require_stateUtils();
    var actionTypes = require_actionTypes();
    var actions2 = require_actions();
    var State2 = require_State();
    var serviceScope = require_serviceScope();
    var Actor = require_Actor();
    var scheduler = require_scheduler2();
    var registry = require_registry();
    var devTools = require_devTools();
    var behaviors = require_behaviors();
    var DEFAULT_SPAWN_OPTIONS = {
      sync: false,
      autoForward: false
    };
    (function(InterpreterStatus) {
      InterpreterStatus[InterpreterStatus["NotStarted"] = 0] = "NotStarted";
      InterpreterStatus[InterpreterStatus["Running"] = 1] = "Running";
      InterpreterStatus[InterpreterStatus["Stopped"] = 2] = "Stopped";
    })(exports2.InterpreterStatus || (exports2.InterpreterStatus = {}));
    var Interpreter = /* @__PURE__ */ function() {
      function Interpreter2(machine, options) {
        var _this = this;
        if (options === void 0) {
          options = Interpreter2.defaultOptions;
        }
        this.machine = machine;
        this.scheduler = new scheduler.Scheduler();
        this.delayedEventsMap = {};
        this.listeners = /* @__PURE__ */ new Set();
        this.contextListeners = /* @__PURE__ */ new Set();
        this.stopListeners = /* @__PURE__ */ new Set();
        this.doneListeners = /* @__PURE__ */ new Set();
        this.eventListeners = /* @__PURE__ */ new Set();
        this.sendListeners = /* @__PURE__ */ new Set();
        this.initialized = false;
        this.status = exports2.InterpreterStatus.NotStarted;
        this.children = /* @__PURE__ */ new Map();
        this.forwardTo = /* @__PURE__ */ new Set();
        this.init = this.start;
        this.send = function(event2, payload) {
          if (utils.isArray(event2)) {
            _this.batch(event2);
            return _this.state;
          }
          var _event = utils.toSCXMLEvent(utils.toEventObject(event2, payload));
          if (_this.status === exports2.InterpreterStatus.Stopped) {
            if (!environment.IS_PRODUCTION) {
              utils.warn(false, 'Event "' + _event.name + '" was sent to stopped service "' + _this.machine.id + '". This service has already reached its final state, and will not transition.\nEvent: ' + JSON.stringify(_event.data));
            }
            return _this.state;
          }
          if (_this.status !== exports2.InterpreterStatus.Running && !_this.options.deferEvents) {
            throw new Error('Event "' + _event.name + '" was sent to uninitialized service "' + _this.machine.id + '". Make sure .start() is called for this service, or set { deferEvents: true } in the service options.\nEvent: ' + JSON.stringify(_event.data));
          }
          _this.scheduler.schedule(function() {
            _this.forward(_event);
            var nextState = _this.nextState(_event);
            _this.update(nextState, _event);
          });
          return _this._state;
        };
        this.sendTo = function(event2, to) {
          var isParent = _this.parent && (to === types2.SpecialTargets.Parent || _this.parent.id === to);
          var target = isParent ? _this.parent : utils.isString(to) ? _this.children.get(to) || registry.registry.get(to) : utils.isActor(to) ? to : void 0;
          if (!target) {
            if (!isParent) {
              throw new Error("Unable to send event to child '" + to + "' from service '" + _this.id + "'.");
            }
            if (!environment.IS_PRODUCTION) {
              utils.warn(false, "Service '" + _this.id + "' has no parent: unable to send event " + event2.type);
            }
            return;
          }
          if ("machine" in target) {
            target.send(_tslib.__assign(_tslib.__assign({}, event2), {
              name: event2.name === actionTypes.error ? "" + actions2.error(_this.id) : event2.name,
              origin: _this.sessionId
            }));
          } else {
            target.send(event2.data);
          }
        };
        var resolvedOptions = _tslib.__assign(_tslib.__assign({}, Interpreter2.defaultOptions), options);
        var clock = resolvedOptions.clock, logger = resolvedOptions.logger, parent = resolvedOptions.parent, id = resolvedOptions.id;
        var resolvedId = id !== void 0 ? id : machine.id;
        this.id = resolvedId;
        this.logger = logger;
        this.clock = clock;
        this.parent = parent;
        this.options = resolvedOptions;
        this.scheduler = new scheduler.Scheduler({
          deferEvents: this.options.deferEvents
        });
        this.sessionId = registry.registry.bookId();
      }
      Object.defineProperty(Interpreter2.prototype, "initialState", {
        get: function() {
          var _this = this;
          if (this._initialState) {
            return this._initialState;
          }
          return serviceScope.provide(this, function() {
            _this._initialState = _this.machine.initialState;
            return _this._initialState;
          });
        },
        enumerable: false,
        configurable: true
      });
      Object.defineProperty(Interpreter2.prototype, "state", {
        get: function() {
          if (!environment.IS_PRODUCTION) {
            utils.warn(this.status !== exports2.InterpreterStatus.NotStarted, "Attempted to read state from uninitialized service '" + this.id + "'. Make sure the service is started first.");
          }
          return this._state;
        },
        enumerable: false,
        configurable: true
      });
      Interpreter2.prototype.execute = function(state, actionsConfig) {
        var e_1, _a2;
        try {
          for (var _b = _tslib.__values(state.actions), _c = _b.next(); !_c.done; _c = _b.next()) {
            var action = _c.value;
            this.exec(action, state, actionsConfig);
          }
        } catch (e_1_1) {
          e_1 = {
            error: e_1_1
          };
        } finally {
          try {
            if (_c && !_c.done && (_a2 = _b.return))
              _a2.call(_b);
          } finally {
            if (e_1)
              throw e_1.error;
          }
        }
      };
      Interpreter2.prototype.update = function(state, _event) {
        var e_2, _a2, e_3, _b, e_4, _c, e_5, _d;
        var _this = this;
        state._sessionid = this.sessionId;
        this._state = state;
        if (this.options.execute) {
          this.execute(this.state);
        }
        this.children.forEach(function(child) {
          _this.state.children[child.id] = child;
        });
        if (this.devTools) {
          this.devTools.send(_event.data, state);
        }
        if (state.event) {
          try {
            for (var _e = _tslib.__values(this.eventListeners), _f = _e.next(); !_f.done; _f = _e.next()) {
              var listener = _f.value;
              listener(state.event);
            }
          } catch (e_2_1) {
            e_2 = {
              error: e_2_1
            };
          } finally {
            try {
              if (_f && !_f.done && (_a2 = _e.return))
                _a2.call(_e);
            } finally {
              if (e_2)
                throw e_2.error;
            }
          }
        }
        try {
          for (var _g = _tslib.__values(this.listeners), _h = _g.next(); !_h.done; _h = _g.next()) {
            var listener = _h.value;
            listener(state, state.event);
          }
        } catch (e_3_1) {
          e_3 = {
            error: e_3_1
          };
        } finally {
          try {
            if (_h && !_h.done && (_b = _g.return))
              _b.call(_g);
          } finally {
            if (e_3)
              throw e_3.error;
          }
        }
        try {
          for (var _j = _tslib.__values(this.contextListeners), _k = _j.next(); !_k.done; _k = _j.next()) {
            var contextListener = _k.value;
            contextListener(this.state.context, this.state.history ? this.state.history.context : void 0);
          }
        } catch (e_4_1) {
          e_4 = {
            error: e_4_1
          };
        } finally {
          try {
            if (_k && !_k.done && (_c = _j.return))
              _c.call(_j);
          } finally {
            if (e_4)
              throw e_4.error;
          }
        }
        var isDone = stateUtils.isInFinalState(state.configuration || [], this.machine);
        if (this.state.configuration && isDone) {
          var finalChildStateNode = state.configuration.find(function(sn) {
            return sn.type === "final" && sn.parent === _this.machine;
          });
          var doneData = finalChildStateNode && finalChildStateNode.doneData ? utils.mapContext(finalChildStateNode.doneData, state.context, _event) : void 0;
          try {
            for (var _l = _tslib.__values(this.doneListeners), _m = _l.next(); !_m.done; _m = _l.next()) {
              var listener = _m.value;
              listener(actions2.doneInvoke(this.id, doneData));
            }
          } catch (e_5_1) {
            e_5 = {
              error: e_5_1
            };
          } finally {
            try {
              if (_m && !_m.done && (_d = _l.return))
                _d.call(_l);
            } finally {
              if (e_5)
                throw e_5.error;
            }
          }
          this.stop();
        }
      };
      Interpreter2.prototype.onTransition = function(listener) {
        this.listeners.add(listener);
        if (this.status === exports2.InterpreterStatus.Running) {
          listener(this.state, this.state.event);
        }
        return this;
      };
      Interpreter2.prototype.subscribe = function(nextListenerOrObserver, _, completeListener) {
        var _this = this;
        if (!nextListenerOrObserver) {
          return {
            unsubscribe: function() {
              return void 0;
            }
          };
        }
        var listener;
        var resolvedCompleteListener = completeListener;
        if (typeof nextListenerOrObserver === "function") {
          listener = nextListenerOrObserver;
        } else {
          listener = nextListenerOrObserver.next.bind(nextListenerOrObserver);
          resolvedCompleteListener = nextListenerOrObserver.complete.bind(nextListenerOrObserver);
        }
        this.listeners.add(listener);
        if (this.status === exports2.InterpreterStatus.Running) {
          listener(this.state);
        }
        if (resolvedCompleteListener) {
          this.onDone(resolvedCompleteListener);
        }
        return {
          unsubscribe: function() {
            listener && _this.listeners.delete(listener);
            resolvedCompleteListener && _this.doneListeners.delete(resolvedCompleteListener);
          }
        };
      };
      Interpreter2.prototype.onEvent = function(listener) {
        this.eventListeners.add(listener);
        return this;
      };
      Interpreter2.prototype.onSend = function(listener) {
        this.sendListeners.add(listener);
        return this;
      };
      Interpreter2.prototype.onChange = function(listener) {
        this.contextListeners.add(listener);
        return this;
      };
      Interpreter2.prototype.onStop = function(listener) {
        this.stopListeners.add(listener);
        return this;
      };
      Interpreter2.prototype.onDone = function(listener) {
        this.doneListeners.add(listener);
        return this;
      };
      Interpreter2.prototype.off = function(listener) {
        this.listeners.delete(listener);
        this.eventListeners.delete(listener);
        this.sendListeners.delete(listener);
        this.stopListeners.delete(listener);
        this.doneListeners.delete(listener);
        this.contextListeners.delete(listener);
        return this;
      };
      Interpreter2.prototype.start = function(initialState) {
        var _this = this;
        if (this.status === exports2.InterpreterStatus.Running) {
          return this;
        }
        registry.registry.register(this.sessionId, this);
        this.initialized = true;
        this.status = exports2.InterpreterStatus.Running;
        var resolvedState = initialState === void 0 ? this.initialState : serviceScope.provide(this, function() {
          return State2.isState(initialState) ? _this.machine.resolveState(initialState) : _this.machine.resolveState(State2.State.from(initialState, _this.machine.context));
        });
        if (this.options.devTools) {
          this.attachDev();
        }
        this.scheduler.initialize(function() {
          _this.update(resolvedState, actions2.initEvent);
        });
        return this;
      };
      Interpreter2.prototype.stop = function() {
        var e_6, _a2, e_7, _b, e_8, _c, e_9, _d, e_10, _e;
        var _this = this;
        try {
          for (var _f = _tslib.__values(this.listeners), _g = _f.next(); !_g.done; _g = _f.next()) {
            var listener = _g.value;
            this.listeners.delete(listener);
          }
        } catch (e_6_1) {
          e_6 = {
            error: e_6_1
          };
        } finally {
          try {
            if (_g && !_g.done && (_a2 = _f.return))
              _a2.call(_f);
          } finally {
            if (e_6)
              throw e_6.error;
          }
        }
        try {
          for (var _h = _tslib.__values(this.stopListeners), _j = _h.next(); !_j.done; _j = _h.next()) {
            var listener = _j.value;
            listener();
            this.stopListeners.delete(listener);
          }
        } catch (e_7_1) {
          e_7 = {
            error: e_7_1
          };
        } finally {
          try {
            if (_j && !_j.done && (_b = _h.return))
              _b.call(_h);
          } finally {
            if (e_7)
              throw e_7.error;
          }
        }
        try {
          for (var _k = _tslib.__values(this.contextListeners), _l = _k.next(); !_l.done; _l = _k.next()) {
            var listener = _l.value;
            this.contextListeners.delete(listener);
          }
        } catch (e_8_1) {
          e_8 = {
            error: e_8_1
          };
        } finally {
          try {
            if (_l && !_l.done && (_c = _k.return))
              _c.call(_k);
          } finally {
            if (e_8)
              throw e_8.error;
          }
        }
        try {
          for (var _m = _tslib.__values(this.doneListeners), _o = _m.next(); !_o.done; _o = _m.next()) {
            var listener = _o.value;
            this.doneListeners.delete(listener);
          }
        } catch (e_9_1) {
          e_9 = {
            error: e_9_1
          };
        } finally {
          try {
            if (_o && !_o.done && (_d = _m.return))
              _d.call(_m);
          } finally {
            if (e_9)
              throw e_9.error;
          }
        }
        if (!this.initialized) {
          return this;
        }
        this.state.configuration.forEach(function(stateNode) {
          var e_11, _a3;
          try {
            for (var _b2 = _tslib.__values(stateNode.definition.exit), _c2 = _b2.next(); !_c2.done; _c2 = _b2.next()) {
              var action = _c2.value;
              _this.exec(action, _this.state);
            }
          } catch (e_11_1) {
            e_11 = {
              error: e_11_1
            };
          } finally {
            try {
              if (_c2 && !_c2.done && (_a3 = _b2.return))
                _a3.call(_b2);
            } finally {
              if (e_11)
                throw e_11.error;
            }
          }
        });
        this.children.forEach(function(child) {
          if (utils.isFunction(child.stop)) {
            child.stop();
          }
        });
        try {
          for (var _p = _tslib.__values(utils.keys(this.delayedEventsMap)), _q = _p.next(); !_q.done; _q = _p.next()) {
            var key2 = _q.value;
            this.clock.clearTimeout(this.delayedEventsMap[key2]);
          }
        } catch (e_10_1) {
          e_10 = {
            error: e_10_1
          };
        } finally {
          try {
            if (_q && !_q.done && (_e = _p.return))
              _e.call(_p);
          } finally {
            if (e_10)
              throw e_10.error;
          }
        }
        this.scheduler.clear();
        this.initialized = false;
        this.status = exports2.InterpreterStatus.Stopped;
        registry.registry.free(this.sessionId);
        return this;
      };
      Interpreter2.prototype.batch = function(events) {
        var _this = this;
        if (this.status === exports2.InterpreterStatus.NotStarted && this.options.deferEvents) {
          if (!environment.IS_PRODUCTION) {
            utils.warn(false, events.length + ' event(s) were sent to uninitialized service "' + this.machine.id + '" and are deferred. Make sure .start() is called for this service.\nEvent: ' + JSON.stringify(event));
          }
        } else if (this.status !== exports2.InterpreterStatus.Running) {
          throw new Error(events.length + ' event(s) were sent to uninitialized service "' + this.machine.id + '". Make sure .start() is called for this service, or set { deferEvents: true } in the service options.');
        }
        this.scheduler.schedule(function() {
          var e_12, _a2;
          var nextState = _this.state;
          var batchChanged = false;
          var batchedActions = [];
          var _loop_1 = function(event_12) {
            var _event = utils.toSCXMLEvent(event_12);
            _this.forward(_event);
            nextState = serviceScope.provide(_this, function() {
              return _this.machine.transition(nextState, _event);
            });
            batchedActions.push.apply(batchedActions, _tslib.__spreadArray([], _tslib.__read(nextState.actions.map(function(a2) {
              return State2.bindActionToState(a2, nextState);
            }))));
            batchChanged = batchChanged || !!nextState.changed;
          };
          try {
            for (var events_1 = _tslib.__values(events), events_1_1 = events_1.next(); !events_1_1.done; events_1_1 = events_1.next()) {
              var event_1 = events_1_1.value;
              _loop_1(event_1);
            }
          } catch (e_12_1) {
            e_12 = {
              error: e_12_1
            };
          } finally {
            try {
              if (events_1_1 && !events_1_1.done && (_a2 = events_1.return))
                _a2.call(events_1);
            } finally {
              if (e_12)
                throw e_12.error;
            }
          }
          nextState.changed = batchChanged;
          nextState.actions = batchedActions;
          _this.update(nextState, utils.toSCXMLEvent(events[events.length - 1]));
        });
      };
      Interpreter2.prototype.sender = function(event2) {
        return this.send.bind(this, event2);
      };
      Interpreter2.prototype.nextState = function(event2) {
        var _this = this;
        var _event = utils.toSCXMLEvent(event2);
        if (_event.name.indexOf(actionTypes.errorPlatform) === 0 && !this.state.nextEvents.some(function(nextEvent) {
          return nextEvent.indexOf(actionTypes.errorPlatform) === 0;
        })) {
          throw _event.data.data;
        }
        var nextState = serviceScope.provide(this, function() {
          return _this.machine.transition(_this.state, _event);
        });
        return nextState;
      };
      Interpreter2.prototype.forward = function(event2) {
        var e_13, _a2;
        try {
          for (var _b = _tslib.__values(this.forwardTo), _c = _b.next(); !_c.done; _c = _b.next()) {
            var id = _c.value;
            var child = this.children.get(id);
            if (!child) {
              throw new Error("Unable to forward event '" + event2 + "' from interpreter '" + this.id + "' to nonexistant child '" + id + "'.");
            }
            child.send(event2);
          }
        } catch (e_13_1) {
          e_13 = {
            error: e_13_1
          };
        } finally {
          try {
            if (_c && !_c.done && (_a2 = _b.return))
              _a2.call(_b);
          } finally {
            if (e_13)
              throw e_13.error;
          }
        }
      };
      Interpreter2.prototype.defer = function(sendAction) {
        var _this = this;
        this.delayedEventsMap[sendAction.id] = this.clock.setTimeout(function() {
          if (sendAction.to) {
            _this.sendTo(sendAction._event, sendAction.to);
          } else {
            _this.send(sendAction._event);
          }
        }, sendAction.delay);
      };
      Interpreter2.prototype.cancel = function(sendId) {
        this.clock.clearTimeout(this.delayedEventsMap[sendId]);
        delete this.delayedEventsMap[sendId];
      };
      Interpreter2.prototype.exec = function(action, state, actionFunctionMap) {
        if (actionFunctionMap === void 0) {
          actionFunctionMap = this.machine.options.actions;
        }
        var context = state.context, _event = state._event;
        var actionOrExec = action.exec || actions2.getActionFunction(action.type, actionFunctionMap);
        var exec = utils.isFunction(actionOrExec) ? actionOrExec : actionOrExec ? actionOrExec.exec : action.exec;
        if (exec) {
          try {
            return exec(context, _event.data, {
              action,
              state: this.state,
              _event
            });
          } catch (err2) {
            if (this.parent) {
              this.parent.send({
                type: "xstate.error",
                data: err2
              });
            }
            throw err2;
          }
        }
        switch (action.type) {
          case actionTypes.send:
            var sendAction = action;
            if (typeof sendAction.delay === "number") {
              this.defer(sendAction);
              return;
            } else {
              if (sendAction.to) {
                this.sendTo(sendAction._event, sendAction.to);
              } else {
                this.send(sendAction._event);
              }
            }
            break;
          case actionTypes.cancel:
            this.cancel(action.sendId);
            break;
          case actionTypes.start: {
            var activity = action.activity;
            if (!this.state.activities[activity.id || activity.type]) {
              break;
            }
            if (activity.type === types2.ActionTypes.Invoke) {
              var invokeSource = utils.toInvokeSource(activity.src);
              var serviceCreator = this.machine.options.services ? this.machine.options.services[invokeSource.type] : void 0;
              var id = activity.id, data = activity.data;
              if (!environment.IS_PRODUCTION) {
                utils.warn(!("forward" in activity), "`forward` property is deprecated (found in invocation of '" + activity.src + "' in in machine '" + this.machine.id + "'). Please use `autoForward` instead.");
              }
              var autoForward = "autoForward" in activity ? activity.autoForward : !!activity.forward;
              if (!serviceCreator) {
                if (!environment.IS_PRODUCTION) {
                  utils.warn(false, "No service found for invocation '" + activity.src + "' in machine '" + this.machine.id + "'.");
                }
                return;
              }
              var resolvedData = data ? utils.mapContext(data, context, _event) : void 0;
              if (typeof serviceCreator === "string") {
                return;
              }
              var source = utils.isFunction(serviceCreator) ? serviceCreator(context, _event.data, {
                data: resolvedData,
                src: invokeSource,
                meta: activity.meta
              }) : serviceCreator;
              if (!source) {
                return;
              }
              var options = void 0;
              if (utils.isMachine(source)) {
                source = resolvedData ? source.withContext(resolvedData) : source;
                options = {
                  autoForward
                };
              }
              this.spawn(source, id, options);
            } else {
              this.spawnActivity(activity);
            }
            break;
          }
          case actionTypes.stop: {
            this.stopChild(action.activity.id);
            break;
          }
          case actionTypes.log:
            var label = action.label, value = action.value;
            if (label) {
              this.logger(label, value);
            } else {
              this.logger(value);
            }
            break;
          default:
            if (!environment.IS_PRODUCTION) {
              utils.warn(false, "No implementation found for action type '" + action.type + "'");
            }
            break;
        }
        return void 0;
      };
      Interpreter2.prototype.removeChild = function(childId) {
        var _a2;
        this.children.delete(childId);
        this.forwardTo.delete(childId);
        (_a2 = this.state) === null || _a2 === void 0 ? true : delete _a2.children[childId];
      };
      Interpreter2.prototype.stopChild = function(childId) {
        var child = this.children.get(childId);
        if (!child) {
          return;
        }
        this.removeChild(childId);
        if (utils.isFunction(child.stop)) {
          child.stop();
        }
      };
      Interpreter2.prototype.spawn = function(entity, name, options) {
        if (utils.isPromiseLike(entity)) {
          return this.spawnPromise(Promise.resolve(entity), name);
        } else if (utils.isFunction(entity)) {
          return this.spawnCallback(entity, name);
        } else if (Actor.isSpawnedActor(entity)) {
          return this.spawnActor(entity, name);
        } else if (utils.isObservable(entity)) {
          return this.spawnObservable(entity, name);
        } else if (utils.isMachine(entity)) {
          return this.spawnMachine(entity, _tslib.__assign(_tslib.__assign({}, options), {
            id: name
          }));
        } else if (utils.isBehavior(entity)) {
          return this.spawnBehavior(entity, name);
        } else {
          throw new Error('Unable to spawn entity "' + name + '" of type "' + typeof entity + '".');
        }
      };
      Interpreter2.prototype.spawnMachine = function(machine, options) {
        var _this = this;
        if (options === void 0) {
          options = {};
        }
        var childService = new Interpreter2(machine, _tslib.__assign(_tslib.__assign({}, this.options), {
          parent: this,
          id: options.id || machine.id
        }));
        var resolvedOptions = _tslib.__assign(_tslib.__assign({}, DEFAULT_SPAWN_OPTIONS), options);
        if (resolvedOptions.sync) {
          childService.onTransition(function(state) {
            _this.send(actionTypes.update, {
              state,
              id: childService.id
            });
          });
        }
        var actor = childService;
        this.children.set(childService.id, actor);
        if (resolvedOptions.autoForward) {
          this.forwardTo.add(childService.id);
        }
        childService.onDone(function(doneEvent) {
          _this.removeChild(childService.id);
          _this.send(utils.toSCXMLEvent(doneEvent, {
            origin: childService.id
          }));
        }).start();
        return actor;
      };
      Interpreter2.prototype.spawnBehavior = function(behavior, id) {
        var actorRef = behaviors.spawnBehavior(behavior, {
          id,
          parent: this
        });
        this.children.set(id, actorRef);
        return actorRef;
      };
      Interpreter2.prototype.spawnPromise = function(promise, id) {
        var _this = this;
        var canceled = false;
        var resolvedData;
        promise.then(function(response) {
          if (!canceled) {
            resolvedData = response;
            _this.removeChild(id);
            _this.send(utils.toSCXMLEvent(actions2.doneInvoke(id, response), {
              origin: id
            }));
          }
        }, function(errorData) {
          if (!canceled) {
            _this.removeChild(id);
            var errorEvent = actions2.error(id, errorData);
            try {
              _this.send(utils.toSCXMLEvent(errorEvent, {
                origin: id
              }));
            } catch (error) {
              utils.reportUnhandledExceptionOnInvocation(errorData, error, id);
              if (_this.devTools) {
                _this.devTools.send(errorEvent, _this.state);
              }
              if (_this.machine.strict) {
                _this.stop();
              }
            }
          }
        });
        var actor = {
          id,
          send: function() {
            return void 0;
          },
          subscribe: function(next, handleError, complete) {
            var observer = utils.toObserver(next, handleError, complete);
            var unsubscribed = false;
            promise.then(function(response) {
              if (unsubscribed) {
                return;
              }
              observer.next(response);
              if (unsubscribed) {
                return;
              }
              observer.complete();
            }, function(err2) {
              if (unsubscribed) {
                return;
              }
              observer.error(err2);
            });
            return {
              unsubscribe: function() {
                return unsubscribed = true;
              }
            };
          },
          stop: function() {
            canceled = true;
          },
          toJSON: function() {
            return {
              id
            };
          },
          getSnapshot: function() {
            return resolvedData;
          }
        };
        this.children.set(id, actor);
        return actor;
      };
      Interpreter2.prototype.spawnCallback = function(callback, id) {
        var _this = this;
        var canceled = false;
        var receivers = /* @__PURE__ */ new Set();
        var listeners = /* @__PURE__ */ new Set();
        var emitted;
        var receive = function(e2) {
          emitted = e2;
          listeners.forEach(function(listener) {
            return listener(e2);
          });
          if (canceled) {
            return;
          }
          _this.send(utils.toSCXMLEvent(e2, {
            origin: id
          }));
        };
        var callbackStop;
        try {
          callbackStop = callback(receive, function(newListener) {
            receivers.add(newListener);
          });
        } catch (err2) {
          this.send(actions2.error(id, err2));
        }
        if (utils.isPromiseLike(callbackStop)) {
          return this.spawnPromise(callbackStop, id);
        }
        var actor = {
          id,
          send: function(event2) {
            return receivers.forEach(function(receiver) {
              return receiver(event2);
            });
          },
          subscribe: function(next) {
            listeners.add(next);
            return {
              unsubscribe: function() {
                listeners.delete(next);
              }
            };
          },
          stop: function() {
            canceled = true;
            if (utils.isFunction(callbackStop)) {
              callbackStop();
            }
          },
          toJSON: function() {
            return {
              id
            };
          },
          getSnapshot: function() {
            return emitted;
          }
        };
        this.children.set(id, actor);
        return actor;
      };
      Interpreter2.prototype.spawnObservable = function(source, id) {
        var _this = this;
        var emitted;
        var subscription = source.subscribe(function(value) {
          emitted = value;
          _this.send(utils.toSCXMLEvent(value, {
            origin: id
          }));
        }, function(err2) {
          _this.removeChild(id);
          _this.send(utils.toSCXMLEvent(actions2.error(id, err2), {
            origin: id
          }));
        }, function() {
          _this.removeChild(id);
          _this.send(utils.toSCXMLEvent(actions2.doneInvoke(id), {
            origin: id
          }));
        });
        var actor = {
          id,
          send: function() {
            return void 0;
          },
          subscribe: function(next, handleError, complete) {
            return source.subscribe(next, handleError, complete);
          },
          stop: function() {
            return subscription.unsubscribe();
          },
          getSnapshot: function() {
            return emitted;
          },
          toJSON: function() {
            return {
              id
            };
          }
        };
        this.children.set(id, actor);
        return actor;
      };
      Interpreter2.prototype.spawnActor = function(actor, name) {
        this.children.set(name, actor);
        return actor;
      };
      Interpreter2.prototype.spawnActivity = function(activity) {
        var implementation = this.machine.options && this.machine.options.activities ? this.machine.options.activities[activity.type] : void 0;
        if (!implementation) {
          if (!environment.IS_PRODUCTION) {
            utils.warn(false, "No implementation found for activity '" + activity.type + "'");
          }
          return;
        }
        var dispose = implementation(this.state.context, activity);
        this.spawnEffect(activity.id, dispose);
      };
      Interpreter2.prototype.spawnEffect = function(id, dispose) {
        this.children.set(id, {
          id,
          send: function() {
            return void 0;
          },
          subscribe: function() {
            return {
              unsubscribe: function() {
                return void 0;
              }
            };
          },
          stop: dispose || void 0,
          getSnapshot: function() {
            return void 0;
          },
          toJSON: function() {
            return {
              id
            };
          }
        });
      };
      Interpreter2.prototype.attachDev = function() {
        var global2 = devTools.getGlobal();
        if (this.options.devTools && global2) {
          if (global2.__REDUX_DEVTOOLS_EXTENSION__) {
            var devToolsOptions = typeof this.options.devTools === "object" ? this.options.devTools : void 0;
            this.devTools = global2.__REDUX_DEVTOOLS_EXTENSION__.connect(_tslib.__assign(_tslib.__assign({
              name: this.id,
              autoPause: true,
              stateSanitizer: function(state) {
                return {
                  value: state.value,
                  context: state.context,
                  actions: state.actions
                };
              }
            }, devToolsOptions), {
              features: _tslib.__assign({
                jump: false,
                skip: false
              }, devToolsOptions ? devToolsOptions.features : void 0)
            }), this.machine);
            this.devTools.init(this.state);
          }
          devTools.registerService(this);
        }
      };
      Interpreter2.prototype.toJSON = function() {
        return {
          id: this.id
        };
      };
      Interpreter2.prototype[utils.symbolObservable] = function() {
        return this;
      };
      Interpreter2.prototype.getSnapshot = function() {
        if (this.status === exports2.InterpreterStatus.NotStarted) {
          return this.initialState;
        }
        return this._state;
      };
      Interpreter2.defaultOptions = /* @__PURE__ */ function(global2) {
        return {
          execute: true,
          deferEvents: true,
          clock: {
            setTimeout: function(fn, ms) {
              return setTimeout(fn, ms);
            },
            clearTimeout: function(id) {
              return clearTimeout(id);
            }
          },
          logger: global2.console.log.bind(console),
          devTools: false
        };
      }(typeof self !== "undefined" ? self : global);
      Interpreter2.interpret = interpret;
      return Interpreter2;
    }();
    var resolveSpawnOptions = function(nameOrOptions) {
      if (utils.isString(nameOrOptions)) {
        return _tslib.__assign(_tslib.__assign({}, DEFAULT_SPAWN_OPTIONS), {
          name: nameOrOptions
        });
      }
      return _tslib.__assign(_tslib.__assign(_tslib.__assign({}, DEFAULT_SPAWN_OPTIONS), {
        name: utils.uniqueId()
      }), nameOrOptions);
    };
    function spawn(entity, nameOrOptions) {
      var resolvedOptions = resolveSpawnOptions(nameOrOptions);
      return serviceScope.consume(function(service) {
        if (!environment.IS_PRODUCTION) {
          var isLazyEntity = utils.isMachine(entity) || utils.isFunction(entity);
          utils.warn(!!service || isLazyEntity, 'Attempted to spawn an Actor (ID: "' + (utils.isMachine(entity) ? entity.id : "undefined") + '") outside of a service. This will have no effect.');
        }
        if (service) {
          return service.spawn(entity, resolvedOptions.name, resolvedOptions);
        } else {
          return Actor.createDeferredActor(entity, resolvedOptions.name);
        }
      });
    }
    function interpret(machine, options) {
      var interpreter = new Interpreter(machine, options);
      return interpreter;
    }
    exports2.Interpreter = Interpreter;
    exports2.interpret = interpret;
    exports2.spawn = spawn;
  }
});

// node_modules/xstate/lib/match.js
var require_match = __commonJS({
  "node_modules/xstate/lib/match.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var _tslib = require_tslib();
    var State2 = require_State();
    function matchState(state, patterns, defaultValue) {
      var e_1, _a2;
      var resolvedState = State2.State.from(state, state instanceof State2.State ? state.context : void 0);
      try {
        for (var patterns_1 = _tslib.__values(patterns), patterns_1_1 = patterns_1.next(); !patterns_1_1.done; patterns_1_1 = patterns_1.next()) {
          var _b = _tslib.__read(patterns_1_1.value, 2), stateValue = _b[0], getValue2 = _b[1];
          if (resolvedState.matches(stateValue)) {
            return getValue2(resolvedState);
          }
        }
      } catch (e_1_1) {
        e_1 = {
          error: e_1_1
        };
      } finally {
        try {
          if (patterns_1_1 && !patterns_1_1.done && (_a2 = patterns_1.return))
            _a2.call(patterns_1);
        } finally {
          if (e_1)
            throw e_1.error;
        }
      }
      return defaultValue(resolvedState);
    }
    exports2.matchState = matchState;
  }
});

// node_modules/xstate/lib/schema.js
var require_schema = __commonJS({
  "node_modules/xstate/lib/schema.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    function createSchema(schema2) {
      return schema2;
    }
    exports2.createSchema = createSchema;
  }
});

// node_modules/xstate/lib/index.js
var require_lib = __commonJS({
  "node_modules/xstate/lib/index.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var utils = require_utils();
    var mapState = require_mapState();
    var types2 = require_types();
    var actions$1 = require_actions();
    var State2 = require_State();
    var StateNode = require_StateNode();
    var Machine = require_Machine();
    var interpreter = require_interpreter();
    var match = require_match();
    var schema2 = require_schema();
    var actions2 = {
      raise: actions$1.raise,
      send: actions$1.send,
      sendParent: actions$1.sendParent,
      sendUpdate: actions$1.sendUpdate,
      log: actions$1.log,
      cancel: actions$1.cancel,
      start: actions$1.start,
      stop: actions$1.stop,
      assign: actions$1.assign,
      after: actions$1.after,
      done: actions$1.done,
      respond: actions$1.respond,
      forwardTo: actions$1.forwardTo,
      escalate: actions$1.escalate,
      choose: actions$1.choose,
      pure: actions$1.pure
    };
    exports2.matchesState = utils.matchesState;
    exports2.mapState = mapState.mapState;
    Object.defineProperty(exports2, "ActionTypes", {
      enumerable: true,
      get: function() {
        return types2.ActionTypes;
      }
    });
    Object.defineProperty(exports2, "SpecialTargets", {
      enumerable: true,
      get: function() {
        return types2.SpecialTargets;
      }
    });
    exports2.assign = actions$1.assign;
    exports2.doneInvoke = actions$1.doneInvoke;
    exports2.forwardTo = actions$1.forwardTo;
    exports2.send = actions$1.send;
    exports2.sendParent = actions$1.sendParent;
    exports2.sendUpdate = actions$1.sendUpdate;
    exports2.State = State2.State;
    exports2.StateNode = StateNode.StateNode;
    exports2.Machine = Machine.Machine;
    exports2.createMachine = Machine.createMachine;
    exports2.Interpreter = interpreter.Interpreter;
    Object.defineProperty(exports2, "InterpreterStatus", {
      enumerable: true,
      get: function() {
        return interpreter.InterpreterStatus;
      }
    });
    exports2.interpret = interpreter.interpret;
    exports2.spawn = interpreter.spawn;
    exports2.matchState = match.matchState;
    exports2.createSchema = schema2.createSchema;
    exports2.actions = actions2;
  }
});

// node_modules/@xstate/react/lib/types.js
var require_types2 = __commonJS({
  "node_modules/@xstate/react/lib/types.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.ReactEffectType = void 0;
    var ReactEffectType;
    (function(ReactEffectType2) {
      ReactEffectType2[ReactEffectType2["Effect"] = 1] = "Effect";
      ReactEffectType2[ReactEffectType2["LayoutEffect"] = 2] = "LayoutEffect";
    })(ReactEffectType = exports2.ReactEffectType || (exports2.ReactEffectType = {}));
  }
});

// node_modules/use-isomorphic-layout-effect/dist/use-isomorphic-layout-effect.cjs.prod.js
var require_use_isomorphic_layout_effect_cjs_prod = __commonJS({
  "node_modules/use-isomorphic-layout-effect/dist/use-isomorphic-layout-effect.cjs.prod.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", {
      value: true
    });
    var react = require_react();
    var index = typeof document != "undefined" ? react.useLayoutEffect : react.useEffect;
    exports2.default = index;
  }
});

// node_modules/use-isomorphic-layout-effect/dist/use-isomorphic-layout-effect.cjs.dev.js
var require_use_isomorphic_layout_effect_cjs_dev = __commonJS({
  "node_modules/use-isomorphic-layout-effect/dist/use-isomorphic-layout-effect.cjs.dev.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var react = require_react();
    var index = typeof document !== "undefined" ? react.useLayoutEffect : react.useEffect;
    exports2.default = index;
  }
});

// node_modules/use-isomorphic-layout-effect/dist/use-isomorphic-layout-effect.cjs.js
var require_use_isomorphic_layout_effect_cjs = __commonJS({
  "node_modules/use-isomorphic-layout-effect/dist/use-isomorphic-layout-effect.cjs.js"(exports2, module2) {
    "use strict";
    if (process.env.NODE_ENV === "production") {
      module2.exports = require_use_isomorphic_layout_effect_cjs_prod();
    } else {
      module2.exports = require_use_isomorphic_layout_effect_cjs_dev();
    }
  }
});

// node_modules/@xstate/react/lib/useConstant.js
var require_useConstant = __commonJS({
  "node_modules/@xstate/react/lib/useConstant.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var React7 = require_react();
    function useConstant(fn) {
      var ref2 = React7.useRef();
      if (!ref2.current) {
        ref2.current = { v: fn() };
      }
      return ref2.current.v;
    }
    exports2.default = useConstant;
  }
});

// node_modules/@xstate/react/lib/utils.js
var require_utils2 = __commonJS({
  "node_modules/@xstate/react/lib/utils.js"(exports2) {
    "use strict";
    var __read = exports2 && exports2.__read || function(o2, n2) {
      var m = typeof Symbol === "function" && o2[Symbol.iterator];
      if (!m)
        return o2;
      var i3 = m.call(o2), r2, ar = [], e2;
      try {
        while ((n2 === void 0 || n2-- > 0) && !(r2 = i3.next()).done)
          ar.push(r2.value);
      } catch (error) {
        e2 = { error };
      } finally {
        try {
          if (r2 && !r2.done && (m = i3["return"]))
            m.call(i3);
        } finally {
          if (e2)
            throw e2.error;
        }
      }
      return ar;
    };
    var __values = exports2 && exports2.__values || function(o2) {
      var s2 = typeof Symbol === "function" && Symbol.iterator, m = s2 && o2[s2], i3 = 0;
      if (m)
        return m.call(o2);
      if (o2 && typeof o2.length === "number")
        return {
          next: function() {
            if (o2 && i3 >= o2.length)
              o2 = void 0;
            return { value: o2 && o2[i3++], done: !o2 };
          }
        };
      throw new TypeError(s2 ? "Object is not iterable." : "Symbol.iterator is not defined.");
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.partition = void 0;
    function partition(items, predicate) {
      var e_1, _a2;
      var _b = __read([[], []], 2), truthy = _b[0], falsy = _b[1];
      try {
        for (var items_1 = __values(items), items_1_1 = items_1.next(); !items_1_1.done; items_1_1 = items_1.next()) {
          var item = items_1_1.value;
          if (predicate(item)) {
            truthy.push(item);
          } else {
            falsy.push(item);
          }
        }
      } catch (e_1_1) {
        e_1 = { error: e_1_1 };
      } finally {
        try {
          if (items_1_1 && !items_1_1.done && (_a2 = items_1.return))
            _a2.call(items_1);
        } finally {
          if (e_1)
            throw e_1.error;
        }
      }
      return [truthy, falsy];
    }
    exports2.partition = partition;
  }
});

// node_modules/@xstate/react/lib/useReactEffectActions.js
var require_useReactEffectActions = __commonJS({
  "node_modules/@xstate/react/lib/useReactEffectActions.js"(exports2) {
    "use strict";
    var __read = exports2 && exports2.__read || function(o2, n2) {
      var m = typeof Symbol === "function" && o2[Symbol.iterator];
      if (!m)
        return o2;
      var i3 = m.call(o2), r2, ar = [], e2;
      try {
        while ((n2 === void 0 || n2-- > 0) && !(r2 = i3.next()).done)
          ar.push(r2.value);
      } catch (error) {
        e2 = { error };
      } finally {
        try {
          if (r2 && !r2.done && (m = i3["return"]))
            m.call(i3);
        } finally {
          if (e2)
            throw e2.error;
        }
      }
      return ar;
    };
    var __spreadArray = exports2 && exports2.__spreadArray || function(to, from) {
      for (var i3 = 0, il = from.length, j = to.length; i3 < il; i3++, j++)
        to[j] = from[i3];
      return to;
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.useReactEffectActions = void 0;
    var react_1 = require_react();
    var use_isomorphic_layout_effect_1 = require_use_isomorphic_layout_effect_cjs();
    var types_1 = require_types2();
    var utils_1 = require_utils2();
    function executeEffect(action, state) {
      var exec = action.exec;
      var originalExec = exec(state.context, state._event.data, {
        action,
        state,
        _event: state._event
      });
      originalExec();
    }
    function useReactEffectActions(service) {
      var effectActionsRef = react_1.useRef([]);
      var layoutEffectActionsRef = react_1.useRef([]);
      use_isomorphic_layout_effect_1.default(function() {
        var sub = service.subscribe(function(currentState) {
          var _a2, _b;
          if (currentState.actions.length) {
            var reactEffectActions = currentState.actions.filter(function(action) {
              return typeof action.exec === "function" && "__effect" in action.exec;
            });
            var _c = __read(utils_1.partition(reactEffectActions, function(action) {
              return action.exec.__effect === types_1.ReactEffectType.Effect;
            }), 2), effectActions = _c[0], layoutEffectActions = _c[1];
            (_a2 = effectActionsRef.current).push.apply(_a2, __spreadArray([], __read(effectActions.map(function(effectAction) {
              return [effectAction, currentState];
            }))));
            (_b = layoutEffectActionsRef.current).push.apply(_b, __spreadArray([], __read(layoutEffectActions.map(function(layoutEffectAction) {
              return [layoutEffectAction, currentState];
            }))));
          }
        });
        return function() {
          sub.unsubscribe();
        };
      }, []);
      use_isomorphic_layout_effect_1.default(function() {
        while (layoutEffectActionsRef.current.length) {
          var _a2 = __read(layoutEffectActionsRef.current.shift(), 2), layoutEffectAction = _a2[0], effectState = _a2[1];
          executeEffect(layoutEffectAction, effectState);
        }
      });
      react_1.useEffect(function() {
        while (effectActionsRef.current.length) {
          var _a2 = __read(effectActionsRef.current.shift(), 2), effectAction = _a2[0], effectState = _a2[1];
          executeEffect(effectAction, effectState);
        }
      });
    }
    exports2.useReactEffectActions = useReactEffectActions;
  }
});

// node_modules/@xstate/react/lib/useInterpret.js
var require_useInterpret = __commonJS({
  "node_modules/@xstate/react/lib/useInterpret.js"(exports2) {
    "use strict";
    var __assign = exports2 && exports2.__assign || function() {
      __assign = Object.assign || function(t2) {
        for (var s2, i3 = 1, n2 = arguments.length; i3 < n2; i3++) {
          s2 = arguments[i3];
          for (var p in s2)
            if (Object.prototype.hasOwnProperty.call(s2, p))
              t2[p] = s2[p];
        }
        return t2;
      };
      return __assign.apply(this, arguments);
    };
    var __rest = exports2 && exports2.__rest || function(s2, e2) {
      var t2 = {};
      for (var p in s2)
        if (Object.prototype.hasOwnProperty.call(s2, p) && e2.indexOf(p) < 0)
          t2[p] = s2[p];
      if (s2 != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i3 = 0, p = Object.getOwnPropertySymbols(s2); i3 < p.length; i3++) {
          if (e2.indexOf(p[i3]) < 0 && Object.prototype.propertyIsEnumerable.call(s2, p[i3]))
            t2[p[i3]] = s2[p[i3]];
        }
      return t2;
    };
    var __read = exports2 && exports2.__read || function(o2, n2) {
      var m = typeof Symbol === "function" && o2[Symbol.iterator];
      if (!m)
        return o2;
      var i3 = m.call(o2), r2, ar = [], e2;
      try {
        while ((n2 === void 0 || n2-- > 0) && !(r2 = i3.next()).done)
          ar.push(r2.value);
      } catch (error) {
        e2 = { error };
      } finally {
        try {
          if (r2 && !r2.done && (m = i3["return"]))
            m.call(i3);
        } finally {
          if (e2)
            throw e2.error;
        }
      }
      return ar;
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.useInterpret = void 0;
    var react_1 = require_react();
    var use_isomorphic_layout_effect_1 = require_use_isomorphic_layout_effect_cjs();
    var xstate_1 = require_lib();
    var useConstant_1 = require_useConstant();
    var useReactEffectActions_1 = require_useReactEffectActions();
    function toObserver(nextHandler, errorHandler, completionHandler) {
      if (typeof nextHandler === "object") {
        return nextHandler;
      }
      var noop = function() {
        return void 0;
      };
      return {
        next: nextHandler,
        error: errorHandler || noop,
        complete: completionHandler || noop
      };
    }
    function useInterpret(getMachine, options, observerOrListener) {
      if (options === void 0) {
        options = {};
      }
      var machine = useConstant_1.default(function() {
        return typeof getMachine === "function" ? getMachine() : getMachine;
      });
      if (process.env.NODE_ENV !== "production" && typeof getMachine !== "function") {
        var _a2 = __read(react_1.useState(machine), 1), initialMachine = _a2[0];
        if (getMachine !== initialMachine) {
          console.warn("Machine given to `useMachine` has changed between renders. This is not supported and might lead to unexpected results.\nPlease make sure that you pass the same Machine as argument each time.");
        }
      }
      var context = options.context, guards = options.guards, actions2 = options.actions, activities = options.activities, services = options.services, delays = options.delays, rehydratedState = options.state, interpreterOptions = __rest(options, ["context", "guards", "actions", "activities", "services", "delays", "state"]);
      var service = useConstant_1.default(function() {
        var machineConfig = {
          context,
          guards,
          actions: actions2,
          activities,
          services,
          delays
        };
        var machineWithConfig = machine.withConfig(machineConfig, function() {
          return __assign(__assign({}, machine.context), context);
        });
        return xstate_1.interpret(machineWithConfig, __assign({ deferEvents: true }, interpreterOptions));
      });
      use_isomorphic_layout_effect_1.default(function() {
        var sub;
        if (observerOrListener) {
          sub = service.subscribe(toObserver(observerOrListener));
        }
        return function() {
          sub === null || sub === void 0 ? void 0 : sub.unsubscribe();
        };
      }, [observerOrListener]);
      use_isomorphic_layout_effect_1.default(function() {
        service.start(rehydratedState ? xstate_1.State.create(rehydratedState) : void 0);
        return function() {
          service.stop();
        };
      }, []);
      use_isomorphic_layout_effect_1.default(function() {
        Object.assign(service.machine.options.actions, actions2);
        Object.assign(service.machine.options.guards, guards);
        Object.assign(service.machine.options.activities, activities);
        Object.assign(service.machine.options.services, services);
        Object.assign(service.machine.options.delays, delays);
      }, [actions2, guards, activities, services, delays]);
      useReactEffectActions_1.useReactEffectActions(service);
      return service;
    }
    exports2.useInterpret = useInterpret;
  }
});

// node_modules/@xstate/react/lib/useMachine.js
var require_useMachine = __commonJS({
  "node_modules/@xstate/react/lib/useMachine.js"(exports2) {
    "use strict";
    var __read = exports2 && exports2.__read || function(o2, n2) {
      var m = typeof Symbol === "function" && o2[Symbol.iterator];
      if (!m)
        return o2;
      var i3 = m.call(o2), r2, ar = [], e2;
      try {
        while ((n2 === void 0 || n2-- > 0) && !(r2 = i3.next()).done)
          ar.push(r2.value);
      } catch (error) {
        e2 = { error };
      } finally {
        try {
          if (r2 && !r2.done && (m = i3["return"]))
            m.call(i3);
        } finally {
          if (e2)
            throw e2.error;
        }
      }
      return ar;
    };
    var __spreadArray = exports2 && exports2.__spreadArray || function(to, from) {
      for (var i3 = 0, il = from.length, j = to.length; i3 < il; i3++, j++)
        to[j] = from[i3];
      return to;
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.useMachine = exports2.asLayoutEffect = exports2.asEffect = void 0;
    var react_1 = require_react();
    var xstate_1 = require_lib();
    var types_1 = require_types2();
    var useInterpret_1 = require_useInterpret();
    function createReactActionFunction(exec, tag) {
      var effectExec = function() {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
          args[_i] = arguments[_i];
        }
        return function() {
          return exec.apply(void 0, __spreadArray([], __read(args)));
        };
      };
      Object.defineProperties(effectExec, {
        name: { value: "effect:" + exec.name },
        __effect: { value: tag }
      });
      return effectExec;
    }
    function asEffect(exec) {
      return createReactActionFunction(exec, types_1.ReactEffectType.Effect);
    }
    exports2.asEffect = asEffect;
    function asLayoutEffect(exec) {
      return createReactActionFunction(exec, types_1.ReactEffectType.LayoutEffect);
    }
    exports2.asLayoutEffect = asLayoutEffect;
    function useMachine3(getMachine, options) {
      if (options === void 0) {
        options = {};
      }
      var listener = react_1.useCallback(function(nextState) {
        var initialStateChanged = nextState.changed === void 0 && Object.keys(nextState.children).length;
        if (nextState.changed || initialStateChanged) {
          setState(nextState);
        }
      }, []);
      var service = useInterpret_1.useInterpret(getMachine, options, listener);
      var _a2 = __read(react_1.useState(function() {
        var initialState = service.machine.initialState;
        return options.state ? xstate_1.State.create(options.state) : initialState;
      }), 2), state = _a2[0], setState = _a2[1];
      return [state, service.send, service];
    }
    exports2.useMachine = useMachine3;
  }
});

// node_modules/@xstate/react/lib/useActor.js
var require_useActor = __commonJS({
  "node_modules/@xstate/react/lib/useActor.js"(exports2) {
    "use strict";
    var __read = exports2 && exports2.__read || function(o2, n2) {
      var m = typeof Symbol === "function" && o2[Symbol.iterator];
      if (!m)
        return o2;
      var i3 = m.call(o2), r2, ar = [], e2;
      try {
        while ((n2 === void 0 || n2-- > 0) && !(r2 = i3.next()).done)
          ar.push(r2.value);
      } catch (error) {
        e2 = { error };
      } finally {
        try {
          if (r2 && !r2.done && (m = i3["return"]))
            m.call(i3);
        } finally {
          if (e2)
            throw e2.error;
        }
      }
      return ar;
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.useActor = exports2.isActorWithState = void 0;
    var react_1 = require_react();
    var use_isomorphic_layout_effect_1 = require_use_isomorphic_layout_effect_cjs();
    var useConstant_1 = require_useConstant();
    function isActorWithState(actorRef) {
      return "state" in actorRef;
    }
    exports2.isActorWithState = isActorWithState;
    function isDeferredActor(actorRef) {
      return "deferred" in actorRef;
    }
    var noop = function() {
    };
    function defaultGetSnapshot(actorRef) {
      return "getSnapshot" in actorRef ? actorRef.getSnapshot() : isActorWithState(actorRef) ? actorRef.state : void 0;
    }
    function useActor(actorRef, getSnapshot) {
      if (getSnapshot === void 0) {
        getSnapshot = defaultGetSnapshot;
      }
      var actorRefRef = react_1.useRef(actorRef);
      var deferredEventsRef = react_1.useRef([]);
      var _a2 = __read(react_1.useState(function() {
        return getSnapshot(actorRef);
      }), 2), current = _a2[0], setCurrent = _a2[1];
      var send3 = useConstant_1.default(function() {
        return function() {
          var args = [];
          for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
          }
          var event2 = args[0];
          if (process.env.NODE_ENV !== "production" && args.length > 1) {
            console.warn("Unexpected payload: " + JSON.stringify(args[1]) + ". Only a single event object can be sent to actor send() functions.");
          }
          var currentActorRef = actorRefRef.current;
          if (isDeferredActor(currentActorRef) && currentActorRef.deferred) {
            deferredEventsRef.current.push(event2);
          } else {
            currentActorRef.send(event2);
          }
        };
      });
      use_isomorphic_layout_effect_1.default(function() {
        actorRefRef.current = actorRef;
        setCurrent(getSnapshot(actorRef));
        var subscription = actorRef.subscribe({
          next: function(emitted) {
            return setCurrent(emitted);
          },
          error: noop,
          complete: noop
        });
        while (deferredEventsRef.current.length > 0) {
          var deferredEvent = deferredEventsRef.current.shift();
          actorRef.send(deferredEvent);
        }
        return function() {
          subscription.unsubscribe();
        };
      }, [actorRef]);
      return [current, send3];
    }
    exports2.useActor = useActor;
  }
});

// node_modules/@xstate/react/lib/useService.js
var require_useService = __commonJS({
  "node_modules/@xstate/react/lib/useService.js"(exports2) {
    "use strict";
    var __read = exports2 && exports2.__read || function(o2, n2) {
      var m = typeof Symbol === "function" && o2[Symbol.iterator];
      if (!m)
        return o2;
      var i3 = m.call(o2), r2, ar = [], e2;
      try {
        while ((n2 === void 0 || n2-- > 0) && !(r2 = i3.next()).done)
          ar.push(r2.value);
      } catch (error) {
        e2 = { error };
      } finally {
        try {
          if (r2 && !r2.done && (m = i3["return"]))
            m.call(i3);
        } finally {
          if (e2)
            throw e2.error;
        }
      }
      return ar;
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.useService = exports2.getServiceSnapshot = void 0;
    var useActor_1 = require_useActor();
    function getServiceSnapshot(service) {
      return ("status" in service ? service.status : service._status) !== 0 ? service.state : service.machine.initialState;
    }
    exports2.getServiceSnapshot = getServiceSnapshot;
    function useService(service) {
      if (process.env.NODE_ENV !== "production" && !("machine" in service)) {
        throw new Error("Attempted to use an actor-like object instead of a service in the useService() hook. Please use the useActor() hook instead.");
      }
      var _a2 = __read(useActor_1.useActor(service), 1), state = _a2[0];
      return [state, service.send];
    }
    exports2.useService = useService;
  }
});

// node_modules/use-subscription/cjs/use-subscription.production.min.js
var require_use_subscription_production_min = __commonJS({
  "node_modules/use-subscription/cjs/use-subscription.production.min.js"(exports2) {
    "use strict";
    var e2 = require_object_assign();
    var g2 = require_react();
    exports2.useSubscription = function(a2) {
      var c2 = a2.getCurrentValue, d = a2.subscribe, b2 = g2.useState(function() {
        return { getCurrentValue: c2, subscribe: d, value: c2() };
      });
      a2 = b2[0];
      var f = b2[1];
      b2 = a2.value;
      if (a2.getCurrentValue !== c2 || a2.subscribe !== d)
        b2 = c2(), f({ getCurrentValue: c2, subscribe: d, value: b2 });
      g2.useDebugValue(b2);
      g2.useEffect(function() {
        function b3() {
          if (!a3) {
            var b4 = c2();
            f(function(a4) {
              return a4.getCurrentValue !== c2 || a4.subscribe !== d || a4.value === b4 ? a4 : e2({}, a4, { value: b4 });
            });
          }
        }
        var a3 = false, h = d(b3);
        b3();
        return function() {
          a3 = true;
          h();
        };
      }, [c2, d]);
      return b2;
    };
  }
});

// node_modules/use-subscription/cjs/use-subscription.development.js
var require_use_subscription_development = __commonJS({
  "node_modules/use-subscription/cjs/use-subscription.development.js"(exports2) {
    "use strict";
    if (process.env.NODE_ENV !== "production") {
      (function() {
        "use strict";
        var _assign = require_object_assign();
        var react = require_react();
        function useSubscription(_ref) {
          var getCurrentValue = _ref.getCurrentValue, subscribe2 = _ref.subscribe;
          var _useState = react.useState(function() {
            return {
              getCurrentValue,
              subscribe: subscribe2,
              value: getCurrentValue()
            };
          }), state = _useState[0], setState = _useState[1];
          var valueToReturn = state.value;
          if (state.getCurrentValue !== getCurrentValue || state.subscribe !== subscribe2) {
            valueToReturn = getCurrentValue();
            setState({
              getCurrentValue,
              subscribe: subscribe2,
              value: valueToReturn
            });
          }
          react.useDebugValue(valueToReturn);
          react.useEffect(function() {
            var didUnsubscribe = false;
            var checkForUpdates = function() {
              if (didUnsubscribe) {
                return;
              }
              var value = getCurrentValue();
              setState(function(prevState) {
                if (prevState.getCurrentValue !== getCurrentValue || prevState.subscribe !== subscribe2) {
                  return prevState;
                }
                if (prevState.value === value) {
                  return prevState;
                }
                return _assign({}, prevState, {
                  value
                });
              });
            };
            var unsubscribe = subscribe2(checkForUpdates);
            checkForUpdates();
            return function() {
              didUnsubscribe = true;
              unsubscribe();
            };
          }, [getCurrentValue, subscribe2]);
          return valueToReturn;
        }
        exports2.useSubscription = useSubscription;
      })();
    }
  }
});

// node_modules/use-subscription/index.js
var require_use_subscription = __commonJS({
  "node_modules/use-subscription/index.js"(exports2, module2) {
    "use strict";
    if (process.env.NODE_ENV === "production") {
      module2.exports = require_use_subscription_production_min();
    } else {
      module2.exports = require_use_subscription_development();
    }
  }
});

// node_modules/@xstate/react/lib/useSelector.js
var require_useSelector = __commonJS({
  "node_modules/@xstate/react/lib/useSelector.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.useSelector = void 0;
    var react_1 = require_react();
    var use_subscription_1 = require_use_subscription();
    var use_isomorphic_layout_effect_1 = require_use_isomorphic_layout_effect_cjs();
    var useActor_1 = require_useActor();
    var useService_1 = require_useService();
    function isService(actor) {
      return "state" in actor && "machine" in actor;
    }
    var defaultCompare = function(a2, b2) {
      return a2 === b2;
    };
    var defaultGetSnapshot = function(a2) {
      return isService(a2) ? useService_1.getServiceSnapshot(a2) : useActor_1.isActorWithState(a2) ? a2.state : void 0;
    };
    function useSelector(actor, selector, compare, getSnapshot) {
      if (compare === void 0) {
        compare = defaultCompare;
      }
      if (getSnapshot === void 0) {
        getSnapshot = defaultGetSnapshot;
      }
      var latestSelectorRef = react_1.useRef(selector);
      var subscription = react_1.useMemo(function() {
        var snapshot2 = getSnapshot(actor);
        var current = selector(snapshot2);
        var notifySubscriber;
        return {
          getSnapshot: function() {
            return snapshot2;
          },
          getCurrentValue: function() {
            return current;
          },
          setCurrentValue: function(newCurrent) {
            current = newCurrent;
            notifySubscriber === null || notifySubscriber === void 0 ? void 0 : notifySubscriber();
          },
          subscribe: function(callback) {
            notifySubscriber = callback;
            var sub = actor.subscribe(function(emitted) {
              snapshot2 = emitted;
              var next = latestSelectorRef.current(emitted);
              if (!compare(current, next)) {
                current = next;
                callback();
              }
            });
            return function() {
              sub.unsubscribe();
            };
          }
        };
      }, [actor]);
      var currentSelected = use_subscription_1.useSubscription(subscription);
      if (latestSelectorRef.current !== selector) {
        var selected = selector(subscription.getSnapshot());
        if (!compare(currentSelected, selected)) {
          currentSelected = selected;
        }
      }
      use_isomorphic_layout_effect_1.default(function() {
        latestSelectorRef.current = selector;
        subscription.setCurrentValue(currentSelected);
      });
      return currentSelected;
    }
    exports2.useSelector = useSelector;
  }
});

// node_modules/@xstate/react/lib/useSpawn.js
var require_useSpawn = __commonJS({
  "node_modules/@xstate/react/lib/useSpawn.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.useSpawn = void 0;
    var behaviors_1 = require_behaviors();
    var useConstant_1 = require_useConstant();
    function useSpawn(behavior) {
      var actorRef = useConstant_1.default(function() {
        return behaviors_1.spawnBehavior(behavior);
      });
      return actorRef;
    }
    exports2.useSpawn = useSpawn;
  }
});

// node_modules/@xstate/react/lib/index.js
var require_lib2 = __commonJS({
  "node_modules/@xstate/react/lib/index.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.useSpawn = exports2.useSelector = exports2.useInterpret = exports2.useActor = exports2.useService = exports2.asLayoutEffect = exports2.asEffect = exports2.useMachine = void 0;
    var useMachine_1 = require_useMachine();
    Object.defineProperty(exports2, "useMachine", { enumerable: true, get: function() {
      return useMachine_1.useMachine;
    } });
    Object.defineProperty(exports2, "asEffect", { enumerable: true, get: function() {
      return useMachine_1.asEffect;
    } });
    Object.defineProperty(exports2, "asLayoutEffect", { enumerable: true, get: function() {
      return useMachine_1.asLayoutEffect;
    } });
    var useService_1 = require_useService();
    Object.defineProperty(exports2, "useService", { enumerable: true, get: function() {
      return useService_1.useService;
    } });
    var useActor_1 = require_useActor();
    Object.defineProperty(exports2, "useActor", { enumerable: true, get: function() {
      return useActor_1.useActor;
    } });
    var useInterpret_1 = require_useInterpret();
    Object.defineProperty(exports2, "useInterpret", { enumerable: true, get: function() {
      return useInterpret_1.useInterpret;
    } });
    var useSelector_1 = require_useSelector();
    Object.defineProperty(exports2, "useSelector", { enumerable: true, get: function() {
      return useSelector_1.useSelector;
    } });
    var useSpawn_1 = require_useSpawn();
    Object.defineProperty(exports2, "useSpawn", { enumerable: true, get: function() {
      return useSpawn_1.useSpawn;
    } });
  }
});

// node_modules/source-map/lib/base64.js
var require_base64 = __commonJS({
  "node_modules/source-map/lib/base64.js"(exports2) {
    var intToCharMap = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/".split("");
    exports2.encode = function(number) {
      if (0 <= number && number < intToCharMap.length) {
        return intToCharMap[number];
      }
      throw new TypeError("Must be between 0 and 63: " + number);
    };
    exports2.decode = function(charCode) {
      var bigA = 65;
      var bigZ = 90;
      var littleA = 97;
      var littleZ = 122;
      var zero = 48;
      var nine = 57;
      var plus = 43;
      var slash = 47;
      var littleOffset = 26;
      var numberOffset = 52;
      if (bigA <= charCode && charCode <= bigZ) {
        return charCode - bigA;
      }
      if (littleA <= charCode && charCode <= littleZ) {
        return charCode - littleA + littleOffset;
      }
      if (zero <= charCode && charCode <= nine) {
        return charCode - zero + numberOffset;
      }
      if (charCode == plus) {
        return 62;
      }
      if (charCode == slash) {
        return 63;
      }
      return -1;
    };
  }
});

// node_modules/source-map/lib/base64-vlq.js
var require_base64_vlq = __commonJS({
  "node_modules/source-map/lib/base64-vlq.js"(exports2) {
    var base64 = require_base64();
    var VLQ_BASE_SHIFT = 5;
    var VLQ_BASE = 1 << VLQ_BASE_SHIFT;
    var VLQ_BASE_MASK = VLQ_BASE - 1;
    var VLQ_CONTINUATION_BIT = VLQ_BASE;
    function toVLQSigned(aValue) {
      return aValue < 0 ? (-aValue << 1) + 1 : (aValue << 1) + 0;
    }
    function fromVLQSigned(aValue) {
      var isNegative = (aValue & 1) === 1;
      var shifted = aValue >> 1;
      return isNegative ? -shifted : shifted;
    }
    exports2.encode = function base64VLQ_encode(aValue) {
      var encoded = "";
      var digit;
      var vlq = toVLQSigned(aValue);
      do {
        digit = vlq & VLQ_BASE_MASK;
        vlq >>>= VLQ_BASE_SHIFT;
        if (vlq > 0) {
          digit |= VLQ_CONTINUATION_BIT;
        }
        encoded += base64.encode(digit);
      } while (vlq > 0);
      return encoded;
    };
    exports2.decode = function base64VLQ_decode(aStr, aIndex, aOutParam) {
      var strLen = aStr.length;
      var result2 = 0;
      var shift = 0;
      var continuation, digit;
      do {
        if (aIndex >= strLen) {
          throw new Error("Expected more digits in base 64 VLQ value.");
        }
        digit = base64.decode(aStr.charCodeAt(aIndex++));
        if (digit === -1) {
          throw new Error("Invalid base64 digit: " + aStr.charAt(aIndex - 1));
        }
        continuation = !!(digit & VLQ_CONTINUATION_BIT);
        digit &= VLQ_BASE_MASK;
        result2 = result2 + (digit << shift);
        shift += VLQ_BASE_SHIFT;
      } while (continuation);
      aOutParam.value = fromVLQSigned(result2);
      aOutParam.rest = aIndex;
    };
  }
});

// node_modules/source-map/lib/util.js
var require_util2 = __commonJS({
  "node_modules/source-map/lib/util.js"(exports2) {
    function getArg(aArgs, aName, aDefaultValue) {
      if (aName in aArgs) {
        return aArgs[aName];
      } else if (arguments.length === 3) {
        return aDefaultValue;
      } else {
        throw new Error('"' + aName + '" is a required argument.');
      }
    }
    exports2.getArg = getArg;
    var urlRegexp = /^(?:([\w+\-.]+):)?\/\/(?:(\w+:\w+)@)?([\w.-]*)(?::(\d+))?(.*)$/;
    var dataUrlRegexp = /^data:.+\,.+$/;
    function urlParse(aUrl) {
      var match = aUrl.match(urlRegexp);
      if (!match) {
        return null;
      }
      return {
        scheme: match[1],
        auth: match[2],
        host: match[3],
        port: match[4],
        path: match[5]
      };
    }
    exports2.urlParse = urlParse;
    function urlGenerate(aParsedUrl) {
      var url = "";
      if (aParsedUrl.scheme) {
        url += aParsedUrl.scheme + ":";
      }
      url += "//";
      if (aParsedUrl.auth) {
        url += aParsedUrl.auth + "@";
      }
      if (aParsedUrl.host) {
        url += aParsedUrl.host;
      }
      if (aParsedUrl.port) {
        url += ":" + aParsedUrl.port;
      }
      if (aParsedUrl.path) {
        url += aParsedUrl.path;
      }
      return url;
    }
    exports2.urlGenerate = urlGenerate;
    function normalize(aPath) {
      var path2 = aPath;
      var url = urlParse(aPath);
      if (url) {
        if (!url.path) {
          return aPath;
        }
        path2 = url.path;
      }
      var isAbsolute = exports2.isAbsolute(path2);
      var parts = path2.split(/\/+/);
      for (var part, up = 0, i3 = parts.length - 1; i3 >= 0; i3--) {
        part = parts[i3];
        if (part === ".") {
          parts.splice(i3, 1);
        } else if (part === "..") {
          up++;
        } else if (up > 0) {
          if (part === "") {
            parts.splice(i3 + 1, up);
            up = 0;
          } else {
            parts.splice(i3, 2);
            up--;
          }
        }
      }
      path2 = parts.join("/");
      if (path2 === "") {
        path2 = isAbsolute ? "/" : ".";
      }
      if (url) {
        url.path = path2;
        return urlGenerate(url);
      }
      return path2;
    }
    exports2.normalize = normalize;
    function join(aRoot, aPath) {
      if (aRoot === "") {
        aRoot = ".";
      }
      if (aPath === "") {
        aPath = ".";
      }
      var aPathUrl = urlParse(aPath);
      var aRootUrl = urlParse(aRoot);
      if (aRootUrl) {
        aRoot = aRootUrl.path || "/";
      }
      if (aPathUrl && !aPathUrl.scheme) {
        if (aRootUrl) {
          aPathUrl.scheme = aRootUrl.scheme;
        }
        return urlGenerate(aPathUrl);
      }
      if (aPathUrl || aPath.match(dataUrlRegexp)) {
        return aPath;
      }
      if (aRootUrl && !aRootUrl.host && !aRootUrl.path) {
        aRootUrl.host = aPath;
        return urlGenerate(aRootUrl);
      }
      var joined = aPath.charAt(0) === "/" ? aPath : normalize(aRoot.replace(/\/+$/, "") + "/" + aPath);
      if (aRootUrl) {
        aRootUrl.path = joined;
        return urlGenerate(aRootUrl);
      }
      return joined;
    }
    exports2.join = join;
    exports2.isAbsolute = function(aPath) {
      return aPath.charAt(0) === "/" || urlRegexp.test(aPath);
    };
    function relative(aRoot, aPath) {
      if (aRoot === "") {
        aRoot = ".";
      }
      aRoot = aRoot.replace(/\/$/, "");
      var level = 0;
      while (aPath.indexOf(aRoot + "/") !== 0) {
        var index = aRoot.lastIndexOf("/");
        if (index < 0) {
          return aPath;
        }
        aRoot = aRoot.slice(0, index);
        if (aRoot.match(/^([^\/]+:\/)?\/*$/)) {
          return aPath;
        }
        ++level;
      }
      return Array(level + 1).join("../") + aPath.substr(aRoot.length + 1);
    }
    exports2.relative = relative;
    var supportsNullProto = function() {
      var obj = Object.create(null);
      return !("__proto__" in obj);
    }();
    function identity(s2) {
      return s2;
    }
    function toSetString(aStr) {
      if (isProtoString(aStr)) {
        return "$" + aStr;
      }
      return aStr;
    }
    exports2.toSetString = supportsNullProto ? identity : toSetString;
    function fromSetString(aStr) {
      if (isProtoString(aStr)) {
        return aStr.slice(1);
      }
      return aStr;
    }
    exports2.fromSetString = supportsNullProto ? identity : fromSetString;
    function isProtoString(s2) {
      if (!s2) {
        return false;
      }
      var length = s2.length;
      if (length < 9) {
        return false;
      }
      if (s2.charCodeAt(length - 1) !== 95 || s2.charCodeAt(length - 2) !== 95 || s2.charCodeAt(length - 3) !== 111 || s2.charCodeAt(length - 4) !== 116 || s2.charCodeAt(length - 5) !== 111 || s2.charCodeAt(length - 6) !== 114 || s2.charCodeAt(length - 7) !== 112 || s2.charCodeAt(length - 8) !== 95 || s2.charCodeAt(length - 9) !== 95) {
        return false;
      }
      for (var i3 = length - 10; i3 >= 0; i3--) {
        if (s2.charCodeAt(i3) !== 36) {
          return false;
        }
      }
      return true;
    }
    function compareByOriginalPositions(mappingA, mappingB, onlyCompareOriginal) {
      var cmp = strcmp(mappingA.source, mappingB.source);
      if (cmp !== 0) {
        return cmp;
      }
      cmp = mappingA.originalLine - mappingB.originalLine;
      if (cmp !== 0) {
        return cmp;
      }
      cmp = mappingA.originalColumn - mappingB.originalColumn;
      if (cmp !== 0 || onlyCompareOriginal) {
        return cmp;
      }
      cmp = mappingA.generatedColumn - mappingB.generatedColumn;
      if (cmp !== 0) {
        return cmp;
      }
      cmp = mappingA.generatedLine - mappingB.generatedLine;
      if (cmp !== 0) {
        return cmp;
      }
      return strcmp(mappingA.name, mappingB.name);
    }
    exports2.compareByOriginalPositions = compareByOriginalPositions;
    function compareByGeneratedPositionsDeflated(mappingA, mappingB, onlyCompareGenerated) {
      var cmp = mappingA.generatedLine - mappingB.generatedLine;
      if (cmp !== 0) {
        return cmp;
      }
      cmp = mappingA.generatedColumn - mappingB.generatedColumn;
      if (cmp !== 0 || onlyCompareGenerated) {
        return cmp;
      }
      cmp = strcmp(mappingA.source, mappingB.source);
      if (cmp !== 0) {
        return cmp;
      }
      cmp = mappingA.originalLine - mappingB.originalLine;
      if (cmp !== 0) {
        return cmp;
      }
      cmp = mappingA.originalColumn - mappingB.originalColumn;
      if (cmp !== 0) {
        return cmp;
      }
      return strcmp(mappingA.name, mappingB.name);
    }
    exports2.compareByGeneratedPositionsDeflated = compareByGeneratedPositionsDeflated;
    function strcmp(aStr1, aStr2) {
      if (aStr1 === aStr2) {
        return 0;
      }
      if (aStr1 === null) {
        return 1;
      }
      if (aStr2 === null) {
        return -1;
      }
      if (aStr1 > aStr2) {
        return 1;
      }
      return -1;
    }
    function compareByGeneratedPositionsInflated(mappingA, mappingB) {
      var cmp = mappingA.generatedLine - mappingB.generatedLine;
      if (cmp !== 0) {
        return cmp;
      }
      cmp = mappingA.generatedColumn - mappingB.generatedColumn;
      if (cmp !== 0) {
        return cmp;
      }
      cmp = strcmp(mappingA.source, mappingB.source);
      if (cmp !== 0) {
        return cmp;
      }
      cmp = mappingA.originalLine - mappingB.originalLine;
      if (cmp !== 0) {
        return cmp;
      }
      cmp = mappingA.originalColumn - mappingB.originalColumn;
      if (cmp !== 0) {
        return cmp;
      }
      return strcmp(mappingA.name, mappingB.name);
    }
    exports2.compareByGeneratedPositionsInflated = compareByGeneratedPositionsInflated;
    function parseSourceMapInput(str2) {
      return JSON.parse(str2.replace(/^\)]}'[^\n]*\n/, ""));
    }
    exports2.parseSourceMapInput = parseSourceMapInput;
    function computeSourceURL(sourceRoot, sourceURL, sourceMapURL) {
      sourceURL = sourceURL || "";
      if (sourceRoot) {
        if (sourceRoot[sourceRoot.length - 1] !== "/" && sourceURL[0] !== "/") {
          sourceRoot += "/";
        }
        sourceURL = sourceRoot + sourceURL;
      }
      if (sourceMapURL) {
        var parsed = urlParse(sourceMapURL);
        if (!parsed) {
          throw new Error("sourceMapURL could not be parsed");
        }
        if (parsed.path) {
          var index = parsed.path.lastIndexOf("/");
          if (index >= 0) {
            parsed.path = parsed.path.substring(0, index + 1);
          }
        }
        sourceURL = join(urlGenerate(parsed), sourceURL);
      }
      return normalize(sourceURL);
    }
    exports2.computeSourceURL = computeSourceURL;
  }
});

// node_modules/source-map/lib/array-set.js
var require_array_set = __commonJS({
  "node_modules/source-map/lib/array-set.js"(exports2) {
    var util = require_util2();
    var has = Object.prototype.hasOwnProperty;
    var hasNativeMap = typeof Map !== "undefined";
    function ArraySet() {
      this._array = [];
      this._set = hasNativeMap ? /* @__PURE__ */ new Map() : Object.create(null);
    }
    ArraySet.fromArray = function ArraySet_fromArray(aArray, aAllowDuplicates) {
      var set2 = new ArraySet();
      for (var i3 = 0, len = aArray.length; i3 < len; i3++) {
        set2.add(aArray[i3], aAllowDuplicates);
      }
      return set2;
    };
    ArraySet.prototype.size = function ArraySet_size() {
      return hasNativeMap ? this._set.size : Object.getOwnPropertyNames(this._set).length;
    };
    ArraySet.prototype.add = function ArraySet_add(aStr, aAllowDuplicates) {
      var sStr = hasNativeMap ? aStr : util.toSetString(aStr);
      var isDuplicate = hasNativeMap ? this.has(aStr) : has.call(this._set, sStr);
      var idx = this._array.length;
      if (!isDuplicate || aAllowDuplicates) {
        this._array.push(aStr);
      }
      if (!isDuplicate) {
        if (hasNativeMap) {
          this._set.set(aStr, idx);
        } else {
          this._set[sStr] = idx;
        }
      }
    };
    ArraySet.prototype.has = function ArraySet_has(aStr) {
      if (hasNativeMap) {
        return this._set.has(aStr);
      } else {
        var sStr = util.toSetString(aStr);
        return has.call(this._set, sStr);
      }
    };
    ArraySet.prototype.indexOf = function ArraySet_indexOf(aStr) {
      if (hasNativeMap) {
        var idx = this._set.get(aStr);
        if (idx >= 0) {
          return idx;
        }
      } else {
        var sStr = util.toSetString(aStr);
        if (has.call(this._set, sStr)) {
          return this._set[sStr];
        }
      }
      throw new Error('"' + aStr + '" is not in the set.');
    };
    ArraySet.prototype.at = function ArraySet_at(aIdx) {
      if (aIdx >= 0 && aIdx < this._array.length) {
        return this._array[aIdx];
      }
      throw new Error("No element indexed by " + aIdx);
    };
    ArraySet.prototype.toArray = function ArraySet_toArray() {
      return this._array.slice();
    };
    exports2.ArraySet = ArraySet;
  }
});

// node_modules/source-map/lib/mapping-list.js
var require_mapping_list = __commonJS({
  "node_modules/source-map/lib/mapping-list.js"(exports2) {
    var util = require_util2();
    function generatedPositionAfter(mappingA, mappingB) {
      var lineA = mappingA.generatedLine;
      var lineB = mappingB.generatedLine;
      var columnA = mappingA.generatedColumn;
      var columnB = mappingB.generatedColumn;
      return lineB > lineA || lineB == lineA && columnB >= columnA || util.compareByGeneratedPositionsInflated(mappingA, mappingB) <= 0;
    }
    function MappingList() {
      this._array = [];
      this._sorted = true;
      this._last = { generatedLine: -1, generatedColumn: 0 };
    }
    MappingList.prototype.unsortedForEach = function MappingList_forEach(aCallback, aThisArg) {
      this._array.forEach(aCallback, aThisArg);
    };
    MappingList.prototype.add = function MappingList_add(aMapping) {
      if (generatedPositionAfter(this._last, aMapping)) {
        this._last = aMapping;
        this._array.push(aMapping);
      } else {
        this._sorted = false;
        this._array.push(aMapping);
      }
    };
    MappingList.prototype.toArray = function MappingList_toArray() {
      if (!this._sorted) {
        this._array.sort(util.compareByGeneratedPositionsInflated);
        this._sorted = true;
      }
      return this._array;
    };
    exports2.MappingList = MappingList;
  }
});

// node_modules/source-map/lib/source-map-generator.js
var require_source_map_generator = __commonJS({
  "node_modules/source-map/lib/source-map-generator.js"(exports2) {
    var base64VLQ = require_base64_vlq();
    var util = require_util2();
    var ArraySet = require_array_set().ArraySet;
    var MappingList = require_mapping_list().MappingList;
    function SourceMapGenerator(aArgs) {
      if (!aArgs) {
        aArgs = {};
      }
      this._file = util.getArg(aArgs, "file", null);
      this._sourceRoot = util.getArg(aArgs, "sourceRoot", null);
      this._skipValidation = util.getArg(aArgs, "skipValidation", false);
      this._sources = new ArraySet();
      this._names = new ArraySet();
      this._mappings = new MappingList();
      this._sourcesContents = null;
    }
    SourceMapGenerator.prototype._version = 3;
    SourceMapGenerator.fromSourceMap = function SourceMapGenerator_fromSourceMap(aSourceMapConsumer) {
      var sourceRoot = aSourceMapConsumer.sourceRoot;
      var generator = new SourceMapGenerator({
        file: aSourceMapConsumer.file,
        sourceRoot
      });
      aSourceMapConsumer.eachMapping(function(mapping) {
        var newMapping = {
          generated: {
            line: mapping.generatedLine,
            column: mapping.generatedColumn
          }
        };
        if (mapping.source != null) {
          newMapping.source = mapping.source;
          if (sourceRoot != null) {
            newMapping.source = util.relative(sourceRoot, newMapping.source);
          }
          newMapping.original = {
            line: mapping.originalLine,
            column: mapping.originalColumn
          };
          if (mapping.name != null) {
            newMapping.name = mapping.name;
          }
        }
        generator.addMapping(newMapping);
      });
      aSourceMapConsumer.sources.forEach(function(sourceFile) {
        var sourceRelative = sourceFile;
        if (sourceRoot !== null) {
          sourceRelative = util.relative(sourceRoot, sourceFile);
        }
        if (!generator._sources.has(sourceRelative)) {
          generator._sources.add(sourceRelative);
        }
        var content = aSourceMapConsumer.sourceContentFor(sourceFile);
        if (content != null) {
          generator.setSourceContent(sourceFile, content);
        }
      });
      return generator;
    };
    SourceMapGenerator.prototype.addMapping = function SourceMapGenerator_addMapping(aArgs) {
      var generated = util.getArg(aArgs, "generated");
      var original = util.getArg(aArgs, "original", null);
      var source = util.getArg(aArgs, "source", null);
      var name = util.getArg(aArgs, "name", null);
      if (!this._skipValidation) {
        this._validateMapping(generated, original, source, name);
      }
      if (source != null) {
        source = String(source);
        if (!this._sources.has(source)) {
          this._sources.add(source);
        }
      }
      if (name != null) {
        name = String(name);
        if (!this._names.has(name)) {
          this._names.add(name);
        }
      }
      this._mappings.add({
        generatedLine: generated.line,
        generatedColumn: generated.column,
        originalLine: original != null && original.line,
        originalColumn: original != null && original.column,
        source,
        name
      });
    };
    SourceMapGenerator.prototype.setSourceContent = function SourceMapGenerator_setSourceContent(aSourceFile, aSourceContent) {
      var source = aSourceFile;
      if (this._sourceRoot != null) {
        source = util.relative(this._sourceRoot, source);
      }
      if (aSourceContent != null) {
        if (!this._sourcesContents) {
          this._sourcesContents = Object.create(null);
        }
        this._sourcesContents[util.toSetString(source)] = aSourceContent;
      } else if (this._sourcesContents) {
        delete this._sourcesContents[util.toSetString(source)];
        if (Object.keys(this._sourcesContents).length === 0) {
          this._sourcesContents = null;
        }
      }
    };
    SourceMapGenerator.prototype.applySourceMap = function SourceMapGenerator_applySourceMap(aSourceMapConsumer, aSourceFile, aSourceMapPath) {
      var sourceFile = aSourceFile;
      if (aSourceFile == null) {
        if (aSourceMapConsumer.file == null) {
          throw new Error(`SourceMapGenerator.prototype.applySourceMap requires either an explicit source file, or the source map's "file" property. Both were omitted.`);
        }
        sourceFile = aSourceMapConsumer.file;
      }
      var sourceRoot = this._sourceRoot;
      if (sourceRoot != null) {
        sourceFile = util.relative(sourceRoot, sourceFile);
      }
      var newSources = new ArraySet();
      var newNames = new ArraySet();
      this._mappings.unsortedForEach(function(mapping) {
        if (mapping.source === sourceFile && mapping.originalLine != null) {
          var original = aSourceMapConsumer.originalPositionFor({
            line: mapping.originalLine,
            column: mapping.originalColumn
          });
          if (original.source != null) {
            mapping.source = original.source;
            if (aSourceMapPath != null) {
              mapping.source = util.join(aSourceMapPath, mapping.source);
            }
            if (sourceRoot != null) {
              mapping.source = util.relative(sourceRoot, mapping.source);
            }
            mapping.originalLine = original.line;
            mapping.originalColumn = original.column;
            if (original.name != null) {
              mapping.name = original.name;
            }
          }
        }
        var source = mapping.source;
        if (source != null && !newSources.has(source)) {
          newSources.add(source);
        }
        var name = mapping.name;
        if (name != null && !newNames.has(name)) {
          newNames.add(name);
        }
      }, this);
      this._sources = newSources;
      this._names = newNames;
      aSourceMapConsumer.sources.forEach(function(sourceFile2) {
        var content = aSourceMapConsumer.sourceContentFor(sourceFile2);
        if (content != null) {
          if (aSourceMapPath != null) {
            sourceFile2 = util.join(aSourceMapPath, sourceFile2);
          }
          if (sourceRoot != null) {
            sourceFile2 = util.relative(sourceRoot, sourceFile2);
          }
          this.setSourceContent(sourceFile2, content);
        }
      }, this);
    };
    SourceMapGenerator.prototype._validateMapping = function SourceMapGenerator_validateMapping(aGenerated, aOriginal, aSource, aName) {
      if (aOriginal && typeof aOriginal.line !== "number" && typeof aOriginal.column !== "number") {
        throw new Error("original.line and original.column are not numbers -- you probably meant to omit the original mapping entirely and only map the generated position. If so, pass null for the original mapping instead of an object with empty or null values.");
      }
      if (aGenerated && "line" in aGenerated && "column" in aGenerated && aGenerated.line > 0 && aGenerated.column >= 0 && !aOriginal && !aSource && !aName) {
        return;
      } else if (aGenerated && "line" in aGenerated && "column" in aGenerated && aOriginal && "line" in aOriginal && "column" in aOriginal && aGenerated.line > 0 && aGenerated.column >= 0 && aOriginal.line > 0 && aOriginal.column >= 0 && aSource) {
        return;
      } else {
        throw new Error("Invalid mapping: " + JSON.stringify({
          generated: aGenerated,
          source: aSource,
          original: aOriginal,
          name: aName
        }));
      }
    };
    SourceMapGenerator.prototype._serializeMappings = function SourceMapGenerator_serializeMappings() {
      var previousGeneratedColumn = 0;
      var previousGeneratedLine = 1;
      var previousOriginalColumn = 0;
      var previousOriginalLine = 0;
      var previousName = 0;
      var previousSource = 0;
      var result2 = "";
      var next;
      var mapping;
      var nameIdx;
      var sourceIdx;
      var mappings = this._mappings.toArray();
      for (var i3 = 0, len = mappings.length; i3 < len; i3++) {
        mapping = mappings[i3];
        next = "";
        if (mapping.generatedLine !== previousGeneratedLine) {
          previousGeneratedColumn = 0;
          while (mapping.generatedLine !== previousGeneratedLine) {
            next += ";";
            previousGeneratedLine++;
          }
        } else {
          if (i3 > 0) {
            if (!util.compareByGeneratedPositionsInflated(mapping, mappings[i3 - 1])) {
              continue;
            }
            next += ",";
          }
        }
        next += base64VLQ.encode(mapping.generatedColumn - previousGeneratedColumn);
        previousGeneratedColumn = mapping.generatedColumn;
        if (mapping.source != null) {
          sourceIdx = this._sources.indexOf(mapping.source);
          next += base64VLQ.encode(sourceIdx - previousSource);
          previousSource = sourceIdx;
          next += base64VLQ.encode(mapping.originalLine - 1 - previousOriginalLine);
          previousOriginalLine = mapping.originalLine - 1;
          next += base64VLQ.encode(mapping.originalColumn - previousOriginalColumn);
          previousOriginalColumn = mapping.originalColumn;
          if (mapping.name != null) {
            nameIdx = this._names.indexOf(mapping.name);
            next += base64VLQ.encode(nameIdx - previousName);
            previousName = nameIdx;
          }
        }
        result2 += next;
      }
      return result2;
    };
    SourceMapGenerator.prototype._generateSourcesContent = function SourceMapGenerator_generateSourcesContent(aSources, aSourceRoot) {
      return aSources.map(function(source) {
        if (!this._sourcesContents) {
          return null;
        }
        if (aSourceRoot != null) {
          source = util.relative(aSourceRoot, source);
        }
        var key2 = util.toSetString(source);
        return Object.prototype.hasOwnProperty.call(this._sourcesContents, key2) ? this._sourcesContents[key2] : null;
      }, this);
    };
    SourceMapGenerator.prototype.toJSON = function SourceMapGenerator_toJSON() {
      var map2 = {
        version: this._version,
        sources: this._sources.toArray(),
        names: this._names.toArray(),
        mappings: this._serializeMappings()
      };
      if (this._file != null) {
        map2.file = this._file;
      }
      if (this._sourceRoot != null) {
        map2.sourceRoot = this._sourceRoot;
      }
      if (this._sourcesContents) {
        map2.sourcesContent = this._generateSourcesContent(map2.sources, map2.sourceRoot);
      }
      return map2;
    };
    SourceMapGenerator.prototype.toString = function SourceMapGenerator_toString() {
      return JSON.stringify(this.toJSON());
    };
    exports2.SourceMapGenerator = SourceMapGenerator;
  }
});

// node_modules/source-map/lib/binary-search.js
var require_binary_search = __commonJS({
  "node_modules/source-map/lib/binary-search.js"(exports2) {
    exports2.GREATEST_LOWER_BOUND = 1;
    exports2.LEAST_UPPER_BOUND = 2;
    function recursiveSearch(aLow, aHigh, aNeedle, aHaystack, aCompare, aBias) {
      var mid = Math.floor((aHigh - aLow) / 2) + aLow;
      var cmp = aCompare(aNeedle, aHaystack[mid], true);
      if (cmp === 0) {
        return mid;
      } else if (cmp > 0) {
        if (aHigh - mid > 1) {
          return recursiveSearch(mid, aHigh, aNeedle, aHaystack, aCompare, aBias);
        }
        if (aBias == exports2.LEAST_UPPER_BOUND) {
          return aHigh < aHaystack.length ? aHigh : -1;
        } else {
          return mid;
        }
      } else {
        if (mid - aLow > 1) {
          return recursiveSearch(aLow, mid, aNeedle, aHaystack, aCompare, aBias);
        }
        if (aBias == exports2.LEAST_UPPER_BOUND) {
          return mid;
        } else {
          return aLow < 0 ? -1 : aLow;
        }
      }
    }
    exports2.search = function search(aNeedle, aHaystack, aCompare, aBias) {
      if (aHaystack.length === 0) {
        return -1;
      }
      var index = recursiveSearch(-1, aHaystack.length, aNeedle, aHaystack, aCompare, aBias || exports2.GREATEST_LOWER_BOUND);
      if (index < 0) {
        return -1;
      }
      while (index - 1 >= 0) {
        if (aCompare(aHaystack[index], aHaystack[index - 1], true) !== 0) {
          break;
        }
        --index;
      }
      return index;
    };
  }
});

// node_modules/source-map/lib/quick-sort.js
var require_quick_sort = __commonJS({
  "node_modules/source-map/lib/quick-sort.js"(exports2) {
    function swap(ary, x, y2) {
      var temp = ary[x];
      ary[x] = ary[y2];
      ary[y2] = temp;
    }
    function randomIntInRange(low, high) {
      return Math.round(low + Math.random() * (high - low));
    }
    function doQuickSort(ary, comparator, p, r2) {
      if (p < r2) {
        var pivotIndex = randomIntInRange(p, r2);
        var i3 = p - 1;
        swap(ary, pivotIndex, r2);
        var pivot = ary[r2];
        for (var j = p; j < r2; j++) {
          if (comparator(ary[j], pivot) <= 0) {
            i3 += 1;
            swap(ary, i3, j);
          }
        }
        swap(ary, i3 + 1, j);
        var q = i3 + 1;
        doQuickSort(ary, comparator, p, q - 1);
        doQuickSort(ary, comparator, q + 1, r2);
      }
    }
    exports2.quickSort = function(ary, comparator) {
      doQuickSort(ary, comparator, 0, ary.length - 1);
    };
  }
});

// node_modules/source-map/lib/source-map-consumer.js
var require_source_map_consumer = __commonJS({
  "node_modules/source-map/lib/source-map-consumer.js"(exports2) {
    var util = require_util2();
    var binarySearch = require_binary_search();
    var ArraySet = require_array_set().ArraySet;
    var base64VLQ = require_base64_vlq();
    var quickSort = require_quick_sort().quickSort;
    function SourceMapConsumer(aSourceMap, aSourceMapURL) {
      var sourceMap = aSourceMap;
      if (typeof aSourceMap === "string") {
        sourceMap = util.parseSourceMapInput(aSourceMap);
      }
      return sourceMap.sections != null ? new IndexedSourceMapConsumer(sourceMap, aSourceMapURL) : new BasicSourceMapConsumer(sourceMap, aSourceMapURL);
    }
    SourceMapConsumer.fromSourceMap = function(aSourceMap, aSourceMapURL) {
      return BasicSourceMapConsumer.fromSourceMap(aSourceMap, aSourceMapURL);
    };
    SourceMapConsumer.prototype._version = 3;
    SourceMapConsumer.prototype.__generatedMappings = null;
    Object.defineProperty(SourceMapConsumer.prototype, "_generatedMappings", {
      configurable: true,
      enumerable: true,
      get: function() {
        if (!this.__generatedMappings) {
          this._parseMappings(this._mappings, this.sourceRoot);
        }
        return this.__generatedMappings;
      }
    });
    SourceMapConsumer.prototype.__originalMappings = null;
    Object.defineProperty(SourceMapConsumer.prototype, "_originalMappings", {
      configurable: true,
      enumerable: true,
      get: function() {
        if (!this.__originalMappings) {
          this._parseMappings(this._mappings, this.sourceRoot);
        }
        return this.__originalMappings;
      }
    });
    SourceMapConsumer.prototype._charIsMappingSeparator = function SourceMapConsumer_charIsMappingSeparator(aStr, index) {
      var c2 = aStr.charAt(index);
      return c2 === ";" || c2 === ",";
    };
    SourceMapConsumer.prototype._parseMappings = function SourceMapConsumer_parseMappings(aStr, aSourceRoot) {
      throw new Error("Subclasses must implement _parseMappings");
    };
    SourceMapConsumer.GENERATED_ORDER = 1;
    SourceMapConsumer.ORIGINAL_ORDER = 2;
    SourceMapConsumer.GREATEST_LOWER_BOUND = 1;
    SourceMapConsumer.LEAST_UPPER_BOUND = 2;
    SourceMapConsumer.prototype.eachMapping = function SourceMapConsumer_eachMapping(aCallback, aContext, aOrder) {
      var context = aContext || null;
      var order = aOrder || SourceMapConsumer.GENERATED_ORDER;
      var mappings;
      switch (order) {
        case SourceMapConsumer.GENERATED_ORDER:
          mappings = this._generatedMappings;
          break;
        case SourceMapConsumer.ORIGINAL_ORDER:
          mappings = this._originalMappings;
          break;
        default:
          throw new Error("Unknown order of iteration.");
      }
      var sourceRoot = this.sourceRoot;
      mappings.map(function(mapping) {
        var source = mapping.source === null ? null : this._sources.at(mapping.source);
        source = util.computeSourceURL(sourceRoot, source, this._sourceMapURL);
        return {
          source,
          generatedLine: mapping.generatedLine,
          generatedColumn: mapping.generatedColumn,
          originalLine: mapping.originalLine,
          originalColumn: mapping.originalColumn,
          name: mapping.name === null ? null : this._names.at(mapping.name)
        };
      }, this).forEach(aCallback, context);
    };
    SourceMapConsumer.prototype.allGeneratedPositionsFor = function SourceMapConsumer_allGeneratedPositionsFor(aArgs) {
      var line = util.getArg(aArgs, "line");
      var needle = {
        source: util.getArg(aArgs, "source"),
        originalLine: line,
        originalColumn: util.getArg(aArgs, "column", 0)
      };
      needle.source = this._findSourceIndex(needle.source);
      if (needle.source < 0) {
        return [];
      }
      var mappings = [];
      var index = this._findMapping(needle, this._originalMappings, "originalLine", "originalColumn", util.compareByOriginalPositions, binarySearch.LEAST_UPPER_BOUND);
      if (index >= 0) {
        var mapping = this._originalMappings[index];
        if (aArgs.column === void 0) {
          var originalLine = mapping.originalLine;
          while (mapping && mapping.originalLine === originalLine) {
            mappings.push({
              line: util.getArg(mapping, "generatedLine", null),
              column: util.getArg(mapping, "generatedColumn", null),
              lastColumn: util.getArg(mapping, "lastGeneratedColumn", null)
            });
            mapping = this._originalMappings[++index];
          }
        } else {
          var originalColumn = mapping.originalColumn;
          while (mapping && mapping.originalLine === line && mapping.originalColumn == originalColumn) {
            mappings.push({
              line: util.getArg(mapping, "generatedLine", null),
              column: util.getArg(mapping, "generatedColumn", null),
              lastColumn: util.getArg(mapping, "lastGeneratedColumn", null)
            });
            mapping = this._originalMappings[++index];
          }
        }
      }
      return mappings;
    };
    exports2.SourceMapConsumer = SourceMapConsumer;
    function BasicSourceMapConsumer(aSourceMap, aSourceMapURL) {
      var sourceMap = aSourceMap;
      if (typeof aSourceMap === "string") {
        sourceMap = util.parseSourceMapInput(aSourceMap);
      }
      var version = util.getArg(sourceMap, "version");
      var sources = util.getArg(sourceMap, "sources");
      var names = util.getArg(sourceMap, "names", []);
      var sourceRoot = util.getArg(sourceMap, "sourceRoot", null);
      var sourcesContent = util.getArg(sourceMap, "sourcesContent", null);
      var mappings = util.getArg(sourceMap, "mappings");
      var file = util.getArg(sourceMap, "file", null);
      if (version != this._version) {
        throw new Error("Unsupported version: " + version);
      }
      if (sourceRoot) {
        sourceRoot = util.normalize(sourceRoot);
      }
      sources = sources.map(String).map(util.normalize).map(function(source) {
        return sourceRoot && util.isAbsolute(sourceRoot) && util.isAbsolute(source) ? util.relative(sourceRoot, source) : source;
      });
      this._names = ArraySet.fromArray(names.map(String), true);
      this._sources = ArraySet.fromArray(sources, true);
      this._absoluteSources = this._sources.toArray().map(function(s2) {
        return util.computeSourceURL(sourceRoot, s2, aSourceMapURL);
      });
      this.sourceRoot = sourceRoot;
      this.sourcesContent = sourcesContent;
      this._mappings = mappings;
      this._sourceMapURL = aSourceMapURL;
      this.file = file;
    }
    BasicSourceMapConsumer.prototype = Object.create(SourceMapConsumer.prototype);
    BasicSourceMapConsumer.prototype.consumer = SourceMapConsumer;
    BasicSourceMapConsumer.prototype._findSourceIndex = function(aSource) {
      var relativeSource = aSource;
      if (this.sourceRoot != null) {
        relativeSource = util.relative(this.sourceRoot, relativeSource);
      }
      if (this._sources.has(relativeSource)) {
        return this._sources.indexOf(relativeSource);
      }
      var i3;
      for (i3 = 0; i3 < this._absoluteSources.length; ++i3) {
        if (this._absoluteSources[i3] == aSource) {
          return i3;
        }
      }
      return -1;
    };
    BasicSourceMapConsumer.fromSourceMap = function SourceMapConsumer_fromSourceMap(aSourceMap, aSourceMapURL) {
      var smc = Object.create(BasicSourceMapConsumer.prototype);
      var names = smc._names = ArraySet.fromArray(aSourceMap._names.toArray(), true);
      var sources = smc._sources = ArraySet.fromArray(aSourceMap._sources.toArray(), true);
      smc.sourceRoot = aSourceMap._sourceRoot;
      smc.sourcesContent = aSourceMap._generateSourcesContent(smc._sources.toArray(), smc.sourceRoot);
      smc.file = aSourceMap._file;
      smc._sourceMapURL = aSourceMapURL;
      smc._absoluteSources = smc._sources.toArray().map(function(s2) {
        return util.computeSourceURL(smc.sourceRoot, s2, aSourceMapURL);
      });
      var generatedMappings = aSourceMap._mappings.toArray().slice();
      var destGeneratedMappings = smc.__generatedMappings = [];
      var destOriginalMappings = smc.__originalMappings = [];
      for (var i3 = 0, length = generatedMappings.length; i3 < length; i3++) {
        var srcMapping = generatedMappings[i3];
        var destMapping = new Mapping();
        destMapping.generatedLine = srcMapping.generatedLine;
        destMapping.generatedColumn = srcMapping.generatedColumn;
        if (srcMapping.source) {
          destMapping.source = sources.indexOf(srcMapping.source);
          destMapping.originalLine = srcMapping.originalLine;
          destMapping.originalColumn = srcMapping.originalColumn;
          if (srcMapping.name) {
            destMapping.name = names.indexOf(srcMapping.name);
          }
          destOriginalMappings.push(destMapping);
        }
        destGeneratedMappings.push(destMapping);
      }
      quickSort(smc.__originalMappings, util.compareByOriginalPositions);
      return smc;
    };
    BasicSourceMapConsumer.prototype._version = 3;
    Object.defineProperty(BasicSourceMapConsumer.prototype, "sources", {
      get: function() {
        return this._absoluteSources.slice();
      }
    });
    function Mapping() {
      this.generatedLine = 0;
      this.generatedColumn = 0;
      this.source = null;
      this.originalLine = null;
      this.originalColumn = null;
      this.name = null;
    }
    BasicSourceMapConsumer.prototype._parseMappings = function SourceMapConsumer_parseMappings(aStr, aSourceRoot) {
      var generatedLine = 1;
      var previousGeneratedColumn = 0;
      var previousOriginalLine = 0;
      var previousOriginalColumn = 0;
      var previousSource = 0;
      var previousName = 0;
      var length = aStr.length;
      var index = 0;
      var cachedSegments = {};
      var temp = {};
      var originalMappings = [];
      var generatedMappings = [];
      var mapping, str2, segment, end, value;
      while (index < length) {
        if (aStr.charAt(index) === ";") {
          generatedLine++;
          index++;
          previousGeneratedColumn = 0;
        } else if (aStr.charAt(index) === ",") {
          index++;
        } else {
          mapping = new Mapping();
          mapping.generatedLine = generatedLine;
          for (end = index; end < length; end++) {
            if (this._charIsMappingSeparator(aStr, end)) {
              break;
            }
          }
          str2 = aStr.slice(index, end);
          segment = cachedSegments[str2];
          if (segment) {
            index += str2.length;
          } else {
            segment = [];
            while (index < end) {
              base64VLQ.decode(aStr, index, temp);
              value = temp.value;
              index = temp.rest;
              segment.push(value);
            }
            if (segment.length === 2) {
              throw new Error("Found a source, but no line and column");
            }
            if (segment.length === 3) {
              throw new Error("Found a source and line, but no column");
            }
            cachedSegments[str2] = segment;
          }
          mapping.generatedColumn = previousGeneratedColumn + segment[0];
          previousGeneratedColumn = mapping.generatedColumn;
          if (segment.length > 1) {
            mapping.source = previousSource + segment[1];
            previousSource += segment[1];
            mapping.originalLine = previousOriginalLine + segment[2];
            previousOriginalLine = mapping.originalLine;
            mapping.originalLine += 1;
            mapping.originalColumn = previousOriginalColumn + segment[3];
            previousOriginalColumn = mapping.originalColumn;
            if (segment.length > 4) {
              mapping.name = previousName + segment[4];
              previousName += segment[4];
            }
          }
          generatedMappings.push(mapping);
          if (typeof mapping.originalLine === "number") {
            originalMappings.push(mapping);
          }
        }
      }
      quickSort(generatedMappings, util.compareByGeneratedPositionsDeflated);
      this.__generatedMappings = generatedMappings;
      quickSort(originalMappings, util.compareByOriginalPositions);
      this.__originalMappings = originalMappings;
    };
    BasicSourceMapConsumer.prototype._findMapping = function SourceMapConsumer_findMapping(aNeedle, aMappings, aLineName, aColumnName, aComparator, aBias) {
      if (aNeedle[aLineName] <= 0) {
        throw new TypeError("Line must be greater than or equal to 1, got " + aNeedle[aLineName]);
      }
      if (aNeedle[aColumnName] < 0) {
        throw new TypeError("Column must be greater than or equal to 0, got " + aNeedle[aColumnName]);
      }
      return binarySearch.search(aNeedle, aMappings, aComparator, aBias);
    };
    BasicSourceMapConsumer.prototype.computeColumnSpans = function SourceMapConsumer_computeColumnSpans() {
      for (var index = 0; index < this._generatedMappings.length; ++index) {
        var mapping = this._generatedMappings[index];
        if (index + 1 < this._generatedMappings.length) {
          var nextMapping = this._generatedMappings[index + 1];
          if (mapping.generatedLine === nextMapping.generatedLine) {
            mapping.lastGeneratedColumn = nextMapping.generatedColumn - 1;
            continue;
          }
        }
        mapping.lastGeneratedColumn = Infinity;
      }
    };
    BasicSourceMapConsumer.prototype.originalPositionFor = function SourceMapConsumer_originalPositionFor(aArgs) {
      var needle = {
        generatedLine: util.getArg(aArgs, "line"),
        generatedColumn: util.getArg(aArgs, "column")
      };
      var index = this._findMapping(needle, this._generatedMappings, "generatedLine", "generatedColumn", util.compareByGeneratedPositionsDeflated, util.getArg(aArgs, "bias", SourceMapConsumer.GREATEST_LOWER_BOUND));
      if (index >= 0) {
        var mapping = this._generatedMappings[index];
        if (mapping.generatedLine === needle.generatedLine) {
          var source = util.getArg(mapping, "source", null);
          if (source !== null) {
            source = this._sources.at(source);
            source = util.computeSourceURL(this.sourceRoot, source, this._sourceMapURL);
          }
          var name = util.getArg(mapping, "name", null);
          if (name !== null) {
            name = this._names.at(name);
          }
          return {
            source,
            line: util.getArg(mapping, "originalLine", null),
            column: util.getArg(mapping, "originalColumn", null),
            name
          };
        }
      }
      return {
        source: null,
        line: null,
        column: null,
        name: null
      };
    };
    BasicSourceMapConsumer.prototype.hasContentsOfAllSources = function BasicSourceMapConsumer_hasContentsOfAllSources() {
      if (!this.sourcesContent) {
        return false;
      }
      return this.sourcesContent.length >= this._sources.size() && !this.sourcesContent.some(function(sc) {
        return sc == null;
      });
    };
    BasicSourceMapConsumer.prototype.sourceContentFor = function SourceMapConsumer_sourceContentFor(aSource, nullOnMissing) {
      if (!this.sourcesContent) {
        return null;
      }
      var index = this._findSourceIndex(aSource);
      if (index >= 0) {
        return this.sourcesContent[index];
      }
      var relativeSource = aSource;
      if (this.sourceRoot != null) {
        relativeSource = util.relative(this.sourceRoot, relativeSource);
      }
      var url;
      if (this.sourceRoot != null && (url = util.urlParse(this.sourceRoot))) {
        var fileUriAbsPath = relativeSource.replace(/^file:\/\//, "");
        if (url.scheme == "file" && this._sources.has(fileUriAbsPath)) {
          return this.sourcesContent[this._sources.indexOf(fileUriAbsPath)];
        }
        if ((!url.path || url.path == "/") && this._sources.has("/" + relativeSource)) {
          return this.sourcesContent[this._sources.indexOf("/" + relativeSource)];
        }
      }
      if (nullOnMissing) {
        return null;
      } else {
        throw new Error('"' + relativeSource + '" is not in the SourceMap.');
      }
    };
    BasicSourceMapConsumer.prototype.generatedPositionFor = function SourceMapConsumer_generatedPositionFor(aArgs) {
      var source = util.getArg(aArgs, "source");
      source = this._findSourceIndex(source);
      if (source < 0) {
        return {
          line: null,
          column: null,
          lastColumn: null
        };
      }
      var needle = {
        source,
        originalLine: util.getArg(aArgs, "line"),
        originalColumn: util.getArg(aArgs, "column")
      };
      var index = this._findMapping(needle, this._originalMappings, "originalLine", "originalColumn", util.compareByOriginalPositions, util.getArg(aArgs, "bias", SourceMapConsumer.GREATEST_LOWER_BOUND));
      if (index >= 0) {
        var mapping = this._originalMappings[index];
        if (mapping.source === needle.source) {
          return {
            line: util.getArg(mapping, "generatedLine", null),
            column: util.getArg(mapping, "generatedColumn", null),
            lastColumn: util.getArg(mapping, "lastGeneratedColumn", null)
          };
        }
      }
      return {
        line: null,
        column: null,
        lastColumn: null
      };
    };
    exports2.BasicSourceMapConsumer = BasicSourceMapConsumer;
    function IndexedSourceMapConsumer(aSourceMap, aSourceMapURL) {
      var sourceMap = aSourceMap;
      if (typeof aSourceMap === "string") {
        sourceMap = util.parseSourceMapInput(aSourceMap);
      }
      var version = util.getArg(sourceMap, "version");
      var sections = util.getArg(sourceMap, "sections");
      if (version != this._version) {
        throw new Error("Unsupported version: " + version);
      }
      this._sources = new ArraySet();
      this._names = new ArraySet();
      var lastOffset = {
        line: -1,
        column: 0
      };
      this._sections = sections.map(function(s2) {
        if (s2.url) {
          throw new Error("Support for url field in sections not implemented.");
        }
        var offset = util.getArg(s2, "offset");
        var offsetLine = util.getArg(offset, "line");
        var offsetColumn = util.getArg(offset, "column");
        if (offsetLine < lastOffset.line || offsetLine === lastOffset.line && offsetColumn < lastOffset.column) {
          throw new Error("Section offsets must be ordered and non-overlapping.");
        }
        lastOffset = offset;
        return {
          generatedOffset: {
            generatedLine: offsetLine + 1,
            generatedColumn: offsetColumn + 1
          },
          consumer: new SourceMapConsumer(util.getArg(s2, "map"), aSourceMapURL)
        };
      });
    }
    IndexedSourceMapConsumer.prototype = Object.create(SourceMapConsumer.prototype);
    IndexedSourceMapConsumer.prototype.constructor = SourceMapConsumer;
    IndexedSourceMapConsumer.prototype._version = 3;
    Object.defineProperty(IndexedSourceMapConsumer.prototype, "sources", {
      get: function() {
        var sources = [];
        for (var i3 = 0; i3 < this._sections.length; i3++) {
          for (var j = 0; j < this._sections[i3].consumer.sources.length; j++) {
            sources.push(this._sections[i3].consumer.sources[j]);
          }
        }
        return sources;
      }
    });
    IndexedSourceMapConsumer.prototype.originalPositionFor = function IndexedSourceMapConsumer_originalPositionFor(aArgs) {
      var needle = {
        generatedLine: util.getArg(aArgs, "line"),
        generatedColumn: util.getArg(aArgs, "column")
      };
      var sectionIndex = binarySearch.search(needle, this._sections, function(needle2, section2) {
        var cmp = needle2.generatedLine - section2.generatedOffset.generatedLine;
        if (cmp) {
          return cmp;
        }
        return needle2.generatedColumn - section2.generatedOffset.generatedColumn;
      });
      var section = this._sections[sectionIndex];
      if (!section) {
        return {
          source: null,
          line: null,
          column: null,
          name: null
        };
      }
      return section.consumer.originalPositionFor({
        line: needle.generatedLine - (section.generatedOffset.generatedLine - 1),
        column: needle.generatedColumn - (section.generatedOffset.generatedLine === needle.generatedLine ? section.generatedOffset.generatedColumn - 1 : 0),
        bias: aArgs.bias
      });
    };
    IndexedSourceMapConsumer.prototype.hasContentsOfAllSources = function IndexedSourceMapConsumer_hasContentsOfAllSources() {
      return this._sections.every(function(s2) {
        return s2.consumer.hasContentsOfAllSources();
      });
    };
    IndexedSourceMapConsumer.prototype.sourceContentFor = function IndexedSourceMapConsumer_sourceContentFor(aSource, nullOnMissing) {
      for (var i3 = 0; i3 < this._sections.length; i3++) {
        var section = this._sections[i3];
        var content = section.consumer.sourceContentFor(aSource, true);
        if (content) {
          return content;
        }
      }
      if (nullOnMissing) {
        return null;
      } else {
        throw new Error('"' + aSource + '" is not in the SourceMap.');
      }
    };
    IndexedSourceMapConsumer.prototype.generatedPositionFor = function IndexedSourceMapConsumer_generatedPositionFor(aArgs) {
      for (var i3 = 0; i3 < this._sections.length; i3++) {
        var section = this._sections[i3];
        if (section.consumer._findSourceIndex(util.getArg(aArgs, "source")) === -1) {
          continue;
        }
        var generatedPosition = section.consumer.generatedPositionFor(aArgs);
        if (generatedPosition) {
          var ret = {
            line: generatedPosition.line + (section.generatedOffset.generatedLine - 1),
            column: generatedPosition.column + (section.generatedOffset.generatedLine === generatedPosition.line ? section.generatedOffset.generatedColumn - 1 : 0)
          };
          return ret;
        }
      }
      return {
        line: null,
        column: null
      };
    };
    IndexedSourceMapConsumer.prototype._parseMappings = function IndexedSourceMapConsumer_parseMappings(aStr, aSourceRoot) {
      this.__generatedMappings = [];
      this.__originalMappings = [];
      for (var i3 = 0; i3 < this._sections.length; i3++) {
        var section = this._sections[i3];
        var sectionMappings = section.consumer._generatedMappings;
        for (var j = 0; j < sectionMappings.length; j++) {
          var mapping = sectionMappings[j];
          var source = section.consumer._sources.at(mapping.source);
          source = util.computeSourceURL(section.consumer.sourceRoot, source, this._sourceMapURL);
          this._sources.add(source);
          source = this._sources.indexOf(source);
          var name = null;
          if (mapping.name) {
            name = section.consumer._names.at(mapping.name);
            this._names.add(name);
            name = this._names.indexOf(name);
          }
          var adjustedMapping = {
            source,
            generatedLine: mapping.generatedLine + (section.generatedOffset.generatedLine - 1),
            generatedColumn: mapping.generatedColumn + (section.generatedOffset.generatedLine === mapping.generatedLine ? section.generatedOffset.generatedColumn - 1 : 0),
            originalLine: mapping.originalLine,
            originalColumn: mapping.originalColumn,
            name
          };
          this.__generatedMappings.push(adjustedMapping);
          if (typeof adjustedMapping.originalLine === "number") {
            this.__originalMappings.push(adjustedMapping);
          }
        }
      }
      quickSort(this.__generatedMappings, util.compareByGeneratedPositionsDeflated);
      quickSort(this.__originalMappings, util.compareByOriginalPositions);
    };
    exports2.IndexedSourceMapConsumer = IndexedSourceMapConsumer;
  }
});

// node_modules/source-map/lib/source-node.js
var require_source_node = __commonJS({
  "node_modules/source-map/lib/source-node.js"(exports2) {
    var SourceMapGenerator = require_source_map_generator().SourceMapGenerator;
    var util = require_util2();
    var REGEX_NEWLINE = /(\r?\n)/;
    var NEWLINE_CODE = 10;
    var isSourceNode = "$$$isSourceNode$$$";
    function SourceNode(aLine, aColumn, aSource, aChunks, aName) {
      this.children = [];
      this.sourceContents = {};
      this.line = aLine == null ? null : aLine;
      this.column = aColumn == null ? null : aColumn;
      this.source = aSource == null ? null : aSource;
      this.name = aName == null ? null : aName;
      this[isSourceNode] = true;
      if (aChunks != null)
        this.add(aChunks);
    }
    SourceNode.fromStringWithSourceMap = function SourceNode_fromStringWithSourceMap(aGeneratedCode, aSourceMapConsumer, aRelativePath) {
      var node = new SourceNode();
      var remainingLines = aGeneratedCode.split(REGEX_NEWLINE);
      var remainingLinesIndex = 0;
      var shiftNextLine = function() {
        var lineContents = getNextLine();
        var newLine = getNextLine() || "";
        return lineContents + newLine;
        function getNextLine() {
          return remainingLinesIndex < remainingLines.length ? remainingLines[remainingLinesIndex++] : void 0;
        }
      };
      var lastGeneratedLine = 1, lastGeneratedColumn = 0;
      var lastMapping = null;
      aSourceMapConsumer.eachMapping(function(mapping) {
        if (lastMapping !== null) {
          if (lastGeneratedLine < mapping.generatedLine) {
            addMappingWithCode(lastMapping, shiftNextLine());
            lastGeneratedLine++;
            lastGeneratedColumn = 0;
          } else {
            var nextLine = remainingLines[remainingLinesIndex] || "";
            var code = nextLine.substr(0, mapping.generatedColumn - lastGeneratedColumn);
            remainingLines[remainingLinesIndex] = nextLine.substr(mapping.generatedColumn - lastGeneratedColumn);
            lastGeneratedColumn = mapping.generatedColumn;
            addMappingWithCode(lastMapping, code);
            lastMapping = mapping;
            return;
          }
        }
        while (lastGeneratedLine < mapping.generatedLine) {
          node.add(shiftNextLine());
          lastGeneratedLine++;
        }
        if (lastGeneratedColumn < mapping.generatedColumn) {
          var nextLine = remainingLines[remainingLinesIndex] || "";
          node.add(nextLine.substr(0, mapping.generatedColumn));
          remainingLines[remainingLinesIndex] = nextLine.substr(mapping.generatedColumn);
          lastGeneratedColumn = mapping.generatedColumn;
        }
        lastMapping = mapping;
      }, this);
      if (remainingLinesIndex < remainingLines.length) {
        if (lastMapping) {
          addMappingWithCode(lastMapping, shiftNextLine());
        }
        node.add(remainingLines.splice(remainingLinesIndex).join(""));
      }
      aSourceMapConsumer.sources.forEach(function(sourceFile) {
        var content = aSourceMapConsumer.sourceContentFor(sourceFile);
        if (content != null) {
          if (aRelativePath != null) {
            sourceFile = util.join(aRelativePath, sourceFile);
          }
          node.setSourceContent(sourceFile, content);
        }
      });
      return node;
      function addMappingWithCode(mapping, code) {
        if (mapping === null || mapping.source === void 0) {
          node.add(code);
        } else {
          var source = aRelativePath ? util.join(aRelativePath, mapping.source) : mapping.source;
          node.add(new SourceNode(mapping.originalLine, mapping.originalColumn, source, code, mapping.name));
        }
      }
    };
    SourceNode.prototype.add = function SourceNode_add(aChunk) {
      if (Array.isArray(aChunk)) {
        aChunk.forEach(function(chunk) {
          this.add(chunk);
        }, this);
      } else if (aChunk[isSourceNode] || typeof aChunk === "string") {
        if (aChunk) {
          this.children.push(aChunk);
        }
      } else {
        throw new TypeError("Expected a SourceNode, string, or an array of SourceNodes and strings. Got " + aChunk);
      }
      return this;
    };
    SourceNode.prototype.prepend = function SourceNode_prepend(aChunk) {
      if (Array.isArray(aChunk)) {
        for (var i3 = aChunk.length - 1; i3 >= 0; i3--) {
          this.prepend(aChunk[i3]);
        }
      } else if (aChunk[isSourceNode] || typeof aChunk === "string") {
        this.children.unshift(aChunk);
      } else {
        throw new TypeError("Expected a SourceNode, string, or an array of SourceNodes and strings. Got " + aChunk);
      }
      return this;
    };
    SourceNode.prototype.walk = function SourceNode_walk(aFn) {
      var chunk;
      for (var i3 = 0, len = this.children.length; i3 < len; i3++) {
        chunk = this.children[i3];
        if (chunk[isSourceNode]) {
          chunk.walk(aFn);
        } else {
          if (chunk !== "") {
            aFn(chunk, {
              source: this.source,
              line: this.line,
              column: this.column,
              name: this.name
            });
          }
        }
      }
    };
    SourceNode.prototype.join = function SourceNode_join(aSep) {
      var newChildren;
      var i3;
      var len = this.children.length;
      if (len > 0) {
        newChildren = [];
        for (i3 = 0; i3 < len - 1; i3++) {
          newChildren.push(this.children[i3]);
          newChildren.push(aSep);
        }
        newChildren.push(this.children[i3]);
        this.children = newChildren;
      }
      return this;
    };
    SourceNode.prototype.replaceRight = function SourceNode_replaceRight(aPattern, aReplacement) {
      var lastChild = this.children[this.children.length - 1];
      if (lastChild[isSourceNode]) {
        lastChild.replaceRight(aPattern, aReplacement);
      } else if (typeof lastChild === "string") {
        this.children[this.children.length - 1] = lastChild.replace(aPattern, aReplacement);
      } else {
        this.children.push("".replace(aPattern, aReplacement));
      }
      return this;
    };
    SourceNode.prototype.setSourceContent = function SourceNode_setSourceContent(aSourceFile, aSourceContent) {
      this.sourceContents[util.toSetString(aSourceFile)] = aSourceContent;
    };
    SourceNode.prototype.walkSourceContents = function SourceNode_walkSourceContents(aFn) {
      for (var i3 = 0, len = this.children.length; i3 < len; i3++) {
        if (this.children[i3][isSourceNode]) {
          this.children[i3].walkSourceContents(aFn);
        }
      }
      var sources = Object.keys(this.sourceContents);
      for (var i3 = 0, len = sources.length; i3 < len; i3++) {
        aFn(util.fromSetString(sources[i3]), this.sourceContents[sources[i3]]);
      }
    };
    SourceNode.prototype.toString = function SourceNode_toString() {
      var str2 = "";
      this.walk(function(chunk) {
        str2 += chunk;
      });
      return str2;
    };
    SourceNode.prototype.toStringWithSourceMap = function SourceNode_toStringWithSourceMap(aArgs) {
      var generated = {
        code: "",
        line: 1,
        column: 0
      };
      var map2 = new SourceMapGenerator(aArgs);
      var sourceMappingActive = false;
      var lastOriginalSource = null;
      var lastOriginalLine = null;
      var lastOriginalColumn = null;
      var lastOriginalName = null;
      this.walk(function(chunk, original) {
        generated.code += chunk;
        if (original.source !== null && original.line !== null && original.column !== null) {
          if (lastOriginalSource !== original.source || lastOriginalLine !== original.line || lastOriginalColumn !== original.column || lastOriginalName !== original.name) {
            map2.addMapping({
              source: original.source,
              original: {
                line: original.line,
                column: original.column
              },
              generated: {
                line: generated.line,
                column: generated.column
              },
              name: original.name
            });
          }
          lastOriginalSource = original.source;
          lastOriginalLine = original.line;
          lastOriginalColumn = original.column;
          lastOriginalName = original.name;
          sourceMappingActive = true;
        } else if (sourceMappingActive) {
          map2.addMapping({
            generated: {
              line: generated.line,
              column: generated.column
            }
          });
          lastOriginalSource = null;
          sourceMappingActive = false;
        }
        for (var idx = 0, length = chunk.length; idx < length; idx++) {
          if (chunk.charCodeAt(idx) === NEWLINE_CODE) {
            generated.line++;
            generated.column = 0;
            if (idx + 1 === length) {
              lastOriginalSource = null;
              sourceMappingActive = false;
            } else if (sourceMappingActive) {
              map2.addMapping({
                source: original.source,
                original: {
                  line: original.line,
                  column: original.column
                },
                generated: {
                  line: generated.line,
                  column: generated.column
                },
                name: original.name
              });
            }
          } else {
            generated.column++;
          }
        }
      });
      this.walkSourceContents(function(sourceFile, sourceContent) {
        map2.setSourceContent(sourceFile, sourceContent);
      });
      return { code: generated.code, map: map2 };
    };
    exports2.SourceNode = SourceNode;
  }
});

// node_modules/source-map/source-map.js
var require_source_map = __commonJS({
  "node_modules/source-map/source-map.js"(exports2) {
    exports2.SourceMapGenerator = require_source_map_generator().SourceMapGenerator;
    exports2.SourceMapConsumer = require_source_map_consumer().SourceMapConsumer;
    exports2.SourceNode = require_source_node().SourceNode;
  }
});

// node_modules/buffer-from/index.js
var require_buffer_from = __commonJS({
  "node_modules/buffer-from/index.js"(exports2, module2) {
    var toString2 = Object.prototype.toString;
    var isModern = typeof Buffer !== "undefined" && typeof Buffer.alloc === "function" && typeof Buffer.allocUnsafe === "function" && typeof Buffer.from === "function";
    function isArrayBuffer(input) {
      return toString2.call(input).slice(8, -1) === "ArrayBuffer";
    }
    function fromArrayBuffer(obj, byteOffset, length) {
      byteOffset >>>= 0;
      var maxLength = obj.byteLength - byteOffset;
      if (maxLength < 0) {
        throw new RangeError("'offset' is out of bounds");
      }
      if (length === void 0) {
        length = maxLength;
      } else {
        length >>>= 0;
        if (length > maxLength) {
          throw new RangeError("'length' is out of bounds");
        }
      }
      return isModern ? Buffer.from(obj.slice(byteOffset, byteOffset + length)) : new Buffer(new Uint8Array(obj.slice(byteOffset, byteOffset + length)));
    }
    function fromString(string, encoding) {
      if (typeof encoding !== "string" || encoding === "") {
        encoding = "utf8";
      }
      if (!Buffer.isEncoding(encoding)) {
        throw new TypeError('"encoding" must be a valid string encoding');
      }
      return isModern ? Buffer.from(string, encoding) : new Buffer(string, encoding);
    }
    function bufferFrom(value, encodingOrOffset, length) {
      if (typeof value === "number") {
        throw new TypeError('"value" argument must not be a number');
      }
      if (isArrayBuffer(value)) {
        return fromArrayBuffer(value, encodingOrOffset, length);
      }
      if (typeof value === "string") {
        return fromString(value, encodingOrOffset);
      }
      return isModern ? Buffer.from(value) : new Buffer(value);
    }
    module2.exports = bufferFrom;
  }
});

// node_modules/source-map-support/source-map-support.js
var require_source_map_support = __commonJS({
  "node_modules/source-map-support/source-map-support.js"(exports2, module2) {
    var SourceMapConsumer = require_source_map().SourceMapConsumer;
    var path2 = require("path");
    var fs5;
    try {
      fs5 = require("fs");
      if (!fs5.existsSync || !fs5.readFileSync) {
        fs5 = null;
      }
    } catch (err2) {
    }
    var bufferFrom = require_buffer_from();
    function dynamicRequire(mod, request) {
      return mod.require(request);
    }
    var errorFormatterInstalled = false;
    var uncaughtShimInstalled = false;
    var emptyCacheBetweenOperations = false;
    var environment = "auto";
    var fileContentsCache = {};
    var sourceMapCache = {};
    var reSourceMap = /^data:application\/json[^,]+base64,/;
    var retrieveFileHandlers = [];
    var retrieveMapHandlers = [];
    function isInBrowser() {
      if (environment === "browser")
        return true;
      if (environment === "node")
        return false;
      return typeof window !== "undefined" && typeof XMLHttpRequest === "function" && !(window.require && window.module && window.process && window.process.type === "renderer");
    }
    function hasGlobalProcessEventEmitter() {
      return typeof process === "object" && process !== null && typeof process.on === "function";
    }
    function globalProcessVersion() {
      if (typeof process === "object" && process !== null) {
        return process.version;
      } else {
        return "";
      }
    }
    function globalProcessStderr() {
      if (typeof process === "object" && process !== null) {
        return process.stderr;
      }
    }
    function globalProcessExit(code) {
      if (typeof process === "object" && process !== null && typeof process.exit === "function") {
        return process.exit(code);
      }
    }
    function handlerExec(list) {
      return function(arg2) {
        for (var i3 = 0; i3 < list.length; i3++) {
          var ret = list[i3](arg2);
          if (ret) {
            return ret;
          }
        }
        return null;
      };
    }
    var retrieveFile = handlerExec(retrieveFileHandlers);
    retrieveFileHandlers.push(function(path3) {
      path3 = path3.trim();
      if (/^file:/.test(path3)) {
        path3 = path3.replace(/file:\/\/\/(\w:)?/, function(protocol, drive) {
          return drive ? "" : "/";
        });
      }
      if (path3 in fileContentsCache) {
        return fileContentsCache[path3];
      }
      var contents = "";
      try {
        if (!fs5) {
          var xhr = new XMLHttpRequest();
          xhr.open("GET", path3, false);
          xhr.send(null);
          if (xhr.readyState === 4 && xhr.status === 200) {
            contents = xhr.responseText;
          }
        } else if (fs5.existsSync(path3)) {
          contents = fs5.readFileSync(path3, "utf8");
        }
      } catch (er) {
      }
      return fileContentsCache[path3] = contents;
    });
    function supportRelativeURL(file, url) {
      if (!file)
        return url;
      var dir = path2.dirname(file);
      var match = /^\w+:\/\/[^\/]*/.exec(dir);
      var protocol = match ? match[0] : "";
      var startPath = dir.slice(protocol.length);
      if (protocol && /^\/\w\:/.test(startPath)) {
        protocol += "/";
        return protocol + path2.resolve(dir.slice(protocol.length), url).replace(/\\/g, "/");
      }
      return protocol + path2.resolve(dir.slice(protocol.length), url);
    }
    function retrieveSourceMapURL(source) {
      var fileData;
      if (isInBrowser()) {
        try {
          var xhr = new XMLHttpRequest();
          xhr.open("GET", source, false);
          xhr.send(null);
          fileData = xhr.readyState === 4 ? xhr.responseText : null;
          var sourceMapHeader = xhr.getResponseHeader("SourceMap") || xhr.getResponseHeader("X-SourceMap");
          if (sourceMapHeader) {
            return sourceMapHeader;
          }
        } catch (e2) {
        }
      }
      fileData = retrieveFile(source);
      var re = /(?:\/\/[@#][\s]*sourceMappingURL=([^\s'"]+)[\s]*$)|(?:\/\*[@#][\s]*sourceMappingURL=([^\s*'"]+)[\s]*(?:\*\/)[\s]*$)/mg;
      var lastMatch, match;
      while (match = re.exec(fileData))
        lastMatch = match;
      if (!lastMatch)
        return null;
      return lastMatch[1];
    }
    var retrieveSourceMap = handlerExec(retrieveMapHandlers);
    retrieveMapHandlers.push(function(source) {
      var sourceMappingURL = retrieveSourceMapURL(source);
      if (!sourceMappingURL)
        return null;
      var sourceMapData;
      if (reSourceMap.test(sourceMappingURL)) {
        var rawData = sourceMappingURL.slice(sourceMappingURL.indexOf(",") + 1);
        sourceMapData = bufferFrom(rawData, "base64").toString();
        sourceMappingURL = source;
      } else {
        sourceMappingURL = supportRelativeURL(source, sourceMappingURL);
        sourceMapData = retrieveFile(sourceMappingURL);
      }
      if (!sourceMapData) {
        return null;
      }
      return {
        url: sourceMappingURL,
        map: sourceMapData
      };
    });
    function mapSourcePosition(position) {
      var sourceMap = sourceMapCache[position.source];
      if (!sourceMap) {
        var urlAndMap = retrieveSourceMap(position.source);
        if (urlAndMap) {
          sourceMap = sourceMapCache[position.source] = {
            url: urlAndMap.url,
            map: new SourceMapConsumer(urlAndMap.map)
          };
          if (sourceMap.map.sourcesContent) {
            sourceMap.map.sources.forEach(function(source, i3) {
              var contents = sourceMap.map.sourcesContent[i3];
              if (contents) {
                var url = supportRelativeURL(sourceMap.url, source);
                fileContentsCache[url] = contents;
              }
            });
          }
        } else {
          sourceMap = sourceMapCache[position.source] = {
            url: null,
            map: null
          };
        }
      }
      if (sourceMap && sourceMap.map && typeof sourceMap.map.originalPositionFor === "function") {
        var originalPosition = sourceMap.map.originalPositionFor(position);
        if (originalPosition.source !== null) {
          originalPosition.source = supportRelativeURL(sourceMap.url, originalPosition.source);
          return originalPosition;
        }
      }
      return position;
    }
    function mapEvalOrigin(origin) {
      var match = /^eval at ([^(]+) \((.+):(\d+):(\d+)\)$/.exec(origin);
      if (match) {
        var position = mapSourcePosition({
          source: match[2],
          line: +match[3],
          column: match[4] - 1
        });
        return "eval at " + match[1] + " (" + position.source + ":" + position.line + ":" + (position.column + 1) + ")";
      }
      match = /^eval at ([^(]+) \((.+)\)$/.exec(origin);
      if (match) {
        return "eval at " + match[1] + " (" + mapEvalOrigin(match[2]) + ")";
      }
      return origin;
    }
    function CallSiteToString() {
      var fileName;
      var fileLocation = "";
      if (this.isNative()) {
        fileLocation = "native";
      } else {
        fileName = this.getScriptNameOrSourceURL();
        if (!fileName && this.isEval()) {
          fileLocation = this.getEvalOrigin();
          fileLocation += ", ";
        }
        if (fileName) {
          fileLocation += fileName;
        } else {
          fileLocation += "<anonymous>";
        }
        var lineNumber = this.getLineNumber();
        if (lineNumber != null) {
          fileLocation += ":" + lineNumber;
          var columnNumber = this.getColumnNumber();
          if (columnNumber) {
            fileLocation += ":" + columnNumber;
          }
        }
      }
      var line = "";
      var functionName = this.getFunctionName();
      var addSuffix = true;
      var isConstructor = this.isConstructor();
      var isMethodCall = !(this.isToplevel() || isConstructor);
      if (isMethodCall) {
        var typeName = this.getTypeName();
        if (typeName === "[object Object]") {
          typeName = "null";
        }
        var methodName = this.getMethodName();
        if (functionName) {
          if (typeName && functionName.indexOf(typeName) != 0) {
            line += typeName + ".";
          }
          line += functionName;
          if (methodName && functionName.indexOf("." + methodName) != functionName.length - methodName.length - 1) {
            line += " [as " + methodName + "]";
          }
        } else {
          line += typeName + "." + (methodName || "<anonymous>");
        }
      } else if (isConstructor) {
        line += "new " + (functionName || "<anonymous>");
      } else if (functionName) {
        line += functionName;
      } else {
        line += fileLocation;
        addSuffix = false;
      }
      if (addSuffix) {
        line += " (" + fileLocation + ")";
      }
      return line;
    }
    function cloneCallSite(frame) {
      var object = {};
      Object.getOwnPropertyNames(Object.getPrototypeOf(frame)).forEach(function(name) {
        object[name] = /^(?:is|get)/.test(name) ? function() {
          return frame[name].call(frame);
        } : frame[name];
      });
      object.toString = CallSiteToString;
      return object;
    }
    function wrapCallSite(frame, state) {
      if (state === void 0) {
        state = { nextPosition: null, curPosition: null };
      }
      if (frame.isNative()) {
        state.curPosition = null;
        return frame;
      }
      var source = frame.getFileName() || frame.getScriptNameOrSourceURL();
      if (source) {
        var line = frame.getLineNumber();
        var column = frame.getColumnNumber() - 1;
        var noHeader = /^v(10\.1[6-9]|10\.[2-9][0-9]|10\.[0-9]{3,}|1[2-9]\d*|[2-9]\d|\d{3,}|11\.11)/;
        var headerLength = noHeader.test(globalProcessVersion()) ? 0 : 62;
        if (line === 1 && column > headerLength && !isInBrowser() && !frame.isEval()) {
          column -= headerLength;
        }
        var position = mapSourcePosition({
          source,
          line,
          column
        });
        state.curPosition = position;
        frame = cloneCallSite(frame);
        var originalFunctionName = frame.getFunctionName;
        frame.getFunctionName = function() {
          if (state.nextPosition == null) {
            return originalFunctionName();
          }
          return state.nextPosition.name || originalFunctionName();
        };
        frame.getFileName = function() {
          return position.source;
        };
        frame.getLineNumber = function() {
          return position.line;
        };
        frame.getColumnNumber = function() {
          return position.column + 1;
        };
        frame.getScriptNameOrSourceURL = function() {
          return position.source;
        };
        return frame;
      }
      var origin = frame.isEval() && frame.getEvalOrigin();
      if (origin) {
        origin = mapEvalOrigin(origin);
        frame = cloneCallSite(frame);
        frame.getEvalOrigin = function() {
          return origin;
        };
        return frame;
      }
      return frame;
    }
    function prepareStackTrace(error, stack) {
      if (emptyCacheBetweenOperations) {
        fileContentsCache = {};
        sourceMapCache = {};
      }
      var name = error.name || "Error";
      var message = error.message || "";
      var errorString = name + ": " + message;
      var state = { nextPosition: null, curPosition: null };
      var processedStack = [];
      for (var i3 = stack.length - 1; i3 >= 0; i3--) {
        processedStack.push("\n    at " + wrapCallSite(stack[i3], state));
        state.nextPosition = state.curPosition;
      }
      state.curPosition = state.nextPosition = null;
      return errorString + processedStack.reverse().join("");
    }
    function getErrorSource(error) {
      var match = /\n    at [^(]+ \((.*):(\d+):(\d+)\)/.exec(error.stack);
      if (match) {
        var source = match[1];
        var line = +match[2];
        var column = +match[3];
        var contents = fileContentsCache[source];
        if (!contents && fs5 && fs5.existsSync(source)) {
          try {
            contents = fs5.readFileSync(source, "utf8");
          } catch (er) {
            contents = "";
          }
        }
        if (contents) {
          var code = contents.split(/(?:\r\n|\r|\n)/)[line - 1];
          if (code) {
            return source + ":" + line + "\n" + code + "\n" + new Array(column).join(" ") + "^";
          }
        }
      }
      return null;
    }
    function printErrorAndExit(error) {
      var source = getErrorSource(error);
      var stderr = globalProcessStderr();
      if (stderr && stderr._handle && stderr._handle.setBlocking) {
        stderr._handle.setBlocking(true);
      }
      if (source) {
        console.error();
        console.error(source);
      }
      console.error(error.stack);
      globalProcessExit(1);
    }
    function shimEmitUncaughtException() {
      var origEmit = process.emit;
      process.emit = function(type3) {
        if (type3 === "uncaughtException") {
          var hasStack = arguments[1] && arguments[1].stack;
          var hasListeners = this.listeners(type3).length > 0;
          if (hasStack && !hasListeners) {
            return printErrorAndExit(arguments[1]);
          }
        }
        return origEmit.apply(this, arguments);
      };
    }
    var originalRetrieveFileHandlers = retrieveFileHandlers.slice(0);
    var originalRetrieveMapHandlers = retrieveMapHandlers.slice(0);
    exports2.wrapCallSite = wrapCallSite;
    exports2.getErrorSource = getErrorSource;
    exports2.mapSourcePosition = mapSourcePosition;
    exports2.retrieveSourceMap = retrieveSourceMap;
    exports2.install = function(options) {
      options = options || {};
      if (options.environment) {
        environment = options.environment;
        if (["node", "browser", "auto"].indexOf(environment) === -1) {
          throw new Error("environment " + environment + " was unknown. Available options are {auto, browser, node}");
        }
      }
      if (options.retrieveFile) {
        if (options.overrideRetrieveFile) {
          retrieveFileHandlers.length = 0;
        }
        retrieveFileHandlers.unshift(options.retrieveFile);
      }
      if (options.retrieveSourceMap) {
        if (options.overrideRetrieveSourceMap) {
          retrieveMapHandlers.length = 0;
        }
        retrieveMapHandlers.unshift(options.retrieveSourceMap);
      }
      if (options.hookRequire && !isInBrowser()) {
        var Module2 = dynamicRequire(module2, "module");
        var $compile = Module2.prototype._compile;
        if (!$compile.__sourceMapSupport) {
          Module2.prototype._compile = function(content, filename) {
            fileContentsCache[filename] = content;
            sourceMapCache[filename] = void 0;
            return $compile.call(this, content, filename);
          };
          Module2.prototype._compile.__sourceMapSupport = true;
        }
      }
      if (!emptyCacheBetweenOperations) {
        emptyCacheBetweenOperations = "emptyCacheBetweenOperations" in options ? options.emptyCacheBetweenOperations : false;
      }
      if (!errorFormatterInstalled) {
        errorFormatterInstalled = true;
        Error.prepareStackTrace = prepareStackTrace;
      }
      if (!uncaughtShimInstalled) {
        var installHandler = "handleUncaughtExceptions" in options ? options.handleUncaughtExceptions : true;
        try {
          var worker_threads = dynamicRequire(module2, "worker_threads");
          if (worker_threads.isMainThread === false) {
            installHandler = false;
          }
        } catch (e2) {
        }
        if (installHandler && hasGlobalProcessEventEmitter()) {
          uncaughtShimInstalled = true;
          shimEmitUncaughtException();
        }
      }
    };
    exports2.resetRetrieveHandlers = function() {
      retrieveFileHandlers.length = 0;
      retrieveMapHandlers.length = 0;
      retrieveFileHandlers = originalRetrieveFileHandlers.slice(0);
      retrieveMapHandlers = originalRetrieveMapHandlers.slice(0);
      retrieveSourceMap = handlerExec(retrieveMapHandlers);
      retrieveFile = handlerExec(retrieveFileHandlers);
    };
  }
});

// node_modules/typescript/lib/typescript.js
var require_typescript = __commonJS({
  "node_modules/typescript/lib/typescript.js"(exports2, module2) {
    "use strict";
    var __spreadArray = exports2 && exports2.__spreadArray || function(to, from) {
      for (var i3 = 0, il = from.length, j = to.length; i3 < il; i3++, j++)
        to[j] = from[i3];
      return to;
    };
    var __assign = exports2 && exports2.__assign || function() {
      __assign = Object.assign || function(t2) {
        for (var s2, i3 = 1, n2 = arguments.length; i3 < n2; i3++) {
          s2 = arguments[i3];
          for (var p in s2)
            if (Object.prototype.hasOwnProperty.call(s2, p))
              t2[p] = s2[p];
        }
        return t2;
      };
      return __assign.apply(this, arguments);
    };
    var __makeTemplateObject = exports2 && exports2.__makeTemplateObject || function(cooked, raw) {
      if (Object.defineProperty) {
        Object.defineProperty(cooked, "raw", { value: raw });
      } else {
        cooked.raw = raw;
      }
      return cooked;
    };
    var __generator = exports2 && exports2.__generator || function(thisArg, body) {
      var _ = { label: 0, sent: function() {
        if (t2[0] & 1)
          throw t2[1];
        return t2[1];
      }, trys: [], ops: [] }, f, y2, t2, g2;
      return g2 = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g2[Symbol.iterator] = function() {
        return this;
      }), g2;
      function verb(n2) {
        return function(v) {
          return step([n2, v]);
        };
      }
      function step(op) {
        if (f)
          throw new TypeError("Generator is already executing.");
        while (_)
          try {
            if (f = 1, y2 && (t2 = op[0] & 2 ? y2["return"] : op[0] ? y2["throw"] || ((t2 = y2["return"]) && t2.call(y2), 0) : y2.next) && !(t2 = t2.call(y2, op[1])).done)
              return t2;
            if (y2 = 0, t2)
              op = [op[0] & 2, t2.value];
            switch (op[0]) {
              case 0:
              case 1:
                t2 = op;
                break;
              case 4:
                _.label++;
                return { value: op[1], done: false };
              case 5:
                _.label++;
                y2 = op[1];
                op = [0];
                continue;
              case 7:
                op = _.ops.pop();
                _.trys.pop();
                continue;
              default:
                if (!(t2 = _.trys, t2 = t2.length > 0 && t2[t2.length - 1]) && (op[0] === 6 || op[0] === 2)) {
                  _ = 0;
                  continue;
                }
                if (op[0] === 3 && (!t2 || op[1] > t2[0] && op[1] < t2[3])) {
                  _.label = op[1];
                  break;
                }
                if (op[0] === 6 && _.label < t2[1]) {
                  _.label = t2[1];
                  t2 = op;
                  break;
                }
                if (t2 && _.label < t2[2]) {
                  _.label = t2[2];
                  _.ops.push(op);
                  break;
                }
                if (t2[2])
                  _.ops.pop();
                _.trys.pop();
                continue;
            }
            op = body.call(thisArg, _);
          } catch (e2) {
            op = [6, e2];
            y2 = 0;
          } finally {
            f = t2 = 0;
          }
        if (op[0] & 5)
          throw op[1];
        return { value: op[0] ? op[1] : void 0, done: true };
      }
    };
    var __rest = exports2 && exports2.__rest || function(s2, e2) {
      var t2 = {};
      for (var p in s2)
        if (Object.prototype.hasOwnProperty.call(s2, p) && e2.indexOf(p) < 0)
          t2[p] = s2[p];
      if (s2 != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i3 = 0, p = Object.getOwnPropertySymbols(s2); i3 < p.length; i3++) {
          if (e2.indexOf(p[i3]) < 0 && Object.prototype.propertyIsEnumerable.call(s2, p[i3]))
            t2[p[i3]] = s2[p[i3]];
        }
      return t2;
    };
    var __extends2 = exports2 && exports2.__extends || function() {
      var extendStatics = function(d, b2) {
        extendStatics = Object.setPrototypeOf || { __proto__: [] } instanceof Array && function(d2, b3) {
          d2.__proto__ = b3;
        } || function(d2, b3) {
          for (var p in b3)
            if (Object.prototype.hasOwnProperty.call(b3, p))
              d2[p] = b3[p];
        };
        return extendStatics(d, b2);
      };
      return function(d, b2) {
        if (typeof b2 !== "function" && b2 !== null)
          throw new TypeError("Class extends value " + String(b2) + " is not a constructor or null");
        extendStatics(d, b2);
        function __() {
          this.constructor = d;
        }
        d.prototype = b2 === null ? Object.create(b2) : (__.prototype = b2.prototype, new __());
      };
    }();
    var ts2;
    (function(ts3) {
      function createMapData() {
        var sentinel = {};
        sentinel.prev = sentinel;
        return { head: sentinel, tail: sentinel, size: 0 };
      }
      function createMapEntry(key2, value) {
        return { key: key2, value, next: void 0, prev: void 0 };
      }
      function sameValueZero(x, y2) {
        return x === y2 || x !== x && y2 !== y2;
      }
      function getPrev(entry) {
        var prev = entry.prev;
        if (!prev || prev === entry)
          throw new Error("Illegal state");
        return prev;
      }
      function getNext(entry) {
        while (entry) {
          var skipNext = !entry.prev;
          entry = entry.next;
          if (skipNext) {
            continue;
          }
          return entry;
        }
      }
      function getEntry(data, key2) {
        for (var entry = data.tail; entry !== data.head; entry = getPrev(entry)) {
          if (sameValueZero(entry.key, key2)) {
            return entry;
          }
        }
      }
      function addOrUpdateEntry(data, key2, value) {
        var existing = getEntry(data, key2);
        if (existing) {
          existing.value = value;
          return;
        }
        var entry = createMapEntry(key2, value);
        entry.prev = data.tail;
        data.tail.next = entry;
        data.tail = entry;
        data.size++;
        return entry;
      }
      function deleteEntry(data, key2) {
        for (var entry = data.tail; entry !== data.head; entry = getPrev(entry)) {
          if (entry.prev === void 0)
            throw new Error("Illegal state");
          if (sameValueZero(entry.key, key2)) {
            if (entry.next) {
              entry.next.prev = entry.prev;
            } else {
              if (data.tail !== entry)
                throw new Error("Illegal state");
              data.tail = entry.prev;
            }
            entry.prev.next = entry.next;
            entry.next = entry.prev;
            entry.prev = void 0;
            data.size--;
            return entry;
          }
        }
      }
      function clearEntries(data) {
        var node = data.tail;
        while (node !== data.head) {
          var prev = getPrev(node);
          node.next = data.head;
          node.prev = void 0;
          node = prev;
        }
        data.head.next = void 0;
        data.tail = data.head;
        data.size = 0;
      }
      function forEachEntry(data, action) {
        var entry = data.head;
        while (entry) {
          entry = getNext(entry);
          if (entry) {
            action(entry.value, entry.key);
          }
        }
      }
      function forEachIteration(iterator, action) {
        if (iterator) {
          for (var step = iterator.next(); !step.done; step = iterator.next()) {
            action(step.value);
          }
        }
      }
      function createIteratorData(data, selector) {
        return { current: data.head, selector };
      }
      function iteratorNext(data) {
        data.current = getNext(data.current);
        if (data.current) {
          return { value: data.selector(data.current.key, data.current.value), done: false };
        } else {
          return { value: void 0, done: true };
        }
      }
      var ShimCollections;
      (function(ShimCollections2) {
        function createMapShim(getIterator) {
          var MapIterator = function() {
            function MapIterator2(data, selector) {
              this._data = createIteratorData(data, selector);
            }
            MapIterator2.prototype.next = function() {
              return iteratorNext(this._data);
            };
            return MapIterator2;
          }();
          return function() {
            function Map2(iterable) {
              var _this = this;
              this._mapData = createMapData();
              forEachIteration(getIterator(iterable), function(_a2) {
                var key2 = _a2[0], value = _a2[1];
                return _this.set(key2, value);
              });
            }
            Object.defineProperty(Map2.prototype, "size", {
              get: function() {
                return this._mapData.size;
              },
              enumerable: false,
              configurable: true
            });
            Map2.prototype.get = function(key2) {
              var _a2;
              return (_a2 = getEntry(this._mapData, key2)) === null || _a2 === void 0 ? void 0 : _a2.value;
            };
            Map2.prototype.set = function(key2, value) {
              return addOrUpdateEntry(this._mapData, key2, value), this;
            };
            Map2.prototype.has = function(key2) {
              return !!getEntry(this._mapData, key2);
            };
            Map2.prototype.delete = function(key2) {
              return !!deleteEntry(this._mapData, key2);
            };
            Map2.prototype.clear = function() {
              clearEntries(this._mapData);
            };
            Map2.prototype.keys = function() {
              return new MapIterator(this._mapData, function(key2, _value) {
                return key2;
              });
            };
            Map2.prototype.values = function() {
              return new MapIterator(this._mapData, function(_key, value) {
                return value;
              });
            };
            Map2.prototype.entries = function() {
              return new MapIterator(this._mapData, function(key2, value) {
                return [key2, value];
              });
            };
            Map2.prototype.forEach = function(action) {
              forEachEntry(this._mapData, action);
            };
            return Map2;
          }();
        }
        ShimCollections2.createMapShim = createMapShim;
        function createSetShim(getIterator) {
          var SetIterator = function() {
            function SetIterator2(data, selector) {
              this._data = createIteratorData(data, selector);
            }
            SetIterator2.prototype.next = function() {
              return iteratorNext(this._data);
            };
            return SetIterator2;
          }();
          return function() {
            function Set2(iterable) {
              var _this = this;
              this._mapData = createMapData();
              forEachIteration(getIterator(iterable), function(value) {
                return _this.add(value);
              });
            }
            Object.defineProperty(Set2.prototype, "size", {
              get: function() {
                return this._mapData.size;
              },
              enumerable: false,
              configurable: true
            });
            Set2.prototype.add = function(value) {
              return addOrUpdateEntry(this._mapData, value, value), this;
            };
            Set2.prototype.has = function(value) {
              return !!getEntry(this._mapData, value);
            };
            Set2.prototype.delete = function(value) {
              return !!deleteEntry(this._mapData, value);
            };
            Set2.prototype.clear = function() {
              clearEntries(this._mapData);
            };
            Set2.prototype.keys = function() {
              return new SetIterator(this._mapData, function(key2, _value) {
                return key2;
              });
            };
            Set2.prototype.values = function() {
              return new SetIterator(this._mapData, function(_key, value) {
                return value;
              });
            };
            Set2.prototype.entries = function() {
              return new SetIterator(this._mapData, function(key2, value) {
                return [key2, value];
              });
            };
            Set2.prototype.forEach = function(action) {
              forEachEntry(this._mapData, action);
            };
            return Set2;
          }();
        }
        ShimCollections2.createSetShim = createSetShim;
      })(ShimCollections = ts3.ShimCollections || (ts3.ShimCollections = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      ts3.versionMajorMinor = "4.3";
      ts3.version = "4.3.5";
      var Comparison;
      (function(Comparison2) {
        Comparison2[Comparison2["LessThan"] = -1] = "LessThan";
        Comparison2[Comparison2["EqualTo"] = 0] = "EqualTo";
        Comparison2[Comparison2["GreaterThan"] = 1] = "GreaterThan";
      })(Comparison = ts3.Comparison || (ts3.Comparison = {}));
      var NativeCollections;
      (function(NativeCollections2) {
        function tryGetNativeMap() {
          return typeof Map !== "undefined" && "entries" in Map.prototype && (/* @__PURE__ */ new Map([[0, 0]])).size === 1 ? Map : void 0;
        }
        NativeCollections2.tryGetNativeMap = tryGetNativeMap;
        function tryGetNativeSet() {
          return typeof Set !== "undefined" && "entries" in Set.prototype && (/* @__PURE__ */ new Set([0])).size === 1 ? Set : void 0;
        }
        NativeCollections2.tryGetNativeSet = tryGetNativeSet;
      })(NativeCollections = ts3.NativeCollections || (ts3.NativeCollections = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      function getCollectionImplementation(name, nativeFactory, shimFactory) {
        var _a2;
        var constructor = (_a2 = ts3.NativeCollections[nativeFactory]()) !== null && _a2 !== void 0 ? _a2 : ts3.ShimCollections === null || ts3.ShimCollections === void 0 ? void 0 : ts3.ShimCollections[shimFactory](getIterator);
        if (constructor)
          return constructor;
        throw new Error("TypeScript requires an environment that provides a compatible native " + name + " implementation.");
      }
      ts3.Map = getCollectionImplementation("Map", "tryGetNativeMap", "createMapShim");
      ts3.Set = getCollectionImplementation("Set", "tryGetNativeSet", "createSetShim");
      function getIterator(iterable) {
        if (iterable) {
          if (isArray(iterable))
            return arrayIterator(iterable);
          if (iterable instanceof ts3.Map)
            return iterable.entries();
          if (iterable instanceof ts3.Set)
            return iterable.values();
          throw new Error("Iteration not supported.");
        }
      }
      ts3.getIterator = getIterator;
      ts3.emptyArray = [];
      ts3.emptyMap = new ts3.Map();
      ts3.emptySet = new ts3.Set();
      function createMap() {
        return new ts3.Map();
      }
      ts3.createMap = createMap;
      function createMapFromTemplate(template) {
        var map3 = new ts3.Map();
        for (var key2 in template) {
          if (hasOwnProperty2.call(template, key2)) {
            map3.set(key2, template[key2]);
          }
        }
        return map3;
      }
      ts3.createMapFromTemplate = createMapFromTemplate;
      function length(array) {
        return array ? array.length : 0;
      }
      ts3.length = length;
      function forEach(array, callback) {
        if (array) {
          for (var i3 = 0; i3 < array.length; i3++) {
            var result2 = callback(array[i3], i3);
            if (result2) {
              return result2;
            }
          }
        }
        return void 0;
      }
      ts3.forEach = forEach;
      function forEachRight(array, callback) {
        if (array) {
          for (var i3 = array.length - 1; i3 >= 0; i3--) {
            var result2 = callback(array[i3], i3);
            if (result2) {
              return result2;
            }
          }
        }
        return void 0;
      }
      ts3.forEachRight = forEachRight;
      function firstDefined(array, callback) {
        if (array === void 0) {
          return void 0;
        }
        for (var i3 = 0; i3 < array.length; i3++) {
          var result2 = callback(array[i3], i3);
          if (result2 !== void 0) {
            return result2;
          }
        }
        return void 0;
      }
      ts3.firstDefined = firstDefined;
      function firstDefinedIterator(iter, callback) {
        while (true) {
          var iterResult = iter.next();
          if (iterResult.done) {
            return void 0;
          }
          var result2 = callback(iterResult.value);
          if (result2 !== void 0) {
            return result2;
          }
        }
      }
      ts3.firstDefinedIterator = firstDefinedIterator;
      function reduceLeftIterator(iterator, f, initial) {
        var result2 = initial;
        if (iterator) {
          for (var step = iterator.next(), pos = 0; !step.done; step = iterator.next(), pos++) {
            result2 = f(result2, step.value, pos);
          }
        }
        return result2;
      }
      ts3.reduceLeftIterator = reduceLeftIterator;
      function zipWith(arrayA, arrayB, callback) {
        var result2 = [];
        ts3.Debug.assertEqual(arrayA.length, arrayB.length);
        for (var i3 = 0; i3 < arrayA.length; i3++) {
          result2.push(callback(arrayA[i3], arrayB[i3], i3));
        }
        return result2;
      }
      ts3.zipWith = zipWith;
      function zipToIterator(arrayA, arrayB) {
        ts3.Debug.assertEqual(arrayA.length, arrayB.length);
        var i3 = 0;
        return {
          next: function() {
            if (i3 === arrayA.length) {
              return { value: void 0, done: true };
            }
            i3++;
            return { value: [arrayA[i3 - 1], arrayB[i3 - 1]], done: false };
          }
        };
      }
      ts3.zipToIterator = zipToIterator;
      function zipToMap(keys, values) {
        ts3.Debug.assert(keys.length === values.length);
        var map3 = new ts3.Map();
        for (var i3 = 0; i3 < keys.length; ++i3) {
          map3.set(keys[i3], values[i3]);
        }
        return map3;
      }
      ts3.zipToMap = zipToMap;
      function intersperse(input, element) {
        if (input.length <= 1) {
          return input;
        }
        var result2 = [];
        for (var i3 = 0, n2 = input.length; i3 < n2; i3++) {
          if (i3)
            result2.push(element);
          result2.push(input[i3]);
        }
        return result2;
      }
      ts3.intersperse = intersperse;
      function every(array, callback) {
        if (array) {
          for (var i3 = 0; i3 < array.length; i3++) {
            if (!callback(array[i3], i3)) {
              return false;
            }
          }
        }
        return true;
      }
      ts3.every = every;
      function find(array, predicate) {
        for (var i3 = 0; i3 < array.length; i3++) {
          var value = array[i3];
          if (predicate(value, i3)) {
            return value;
          }
        }
        return void 0;
      }
      ts3.find = find;
      function findLast(array, predicate) {
        for (var i3 = array.length - 1; i3 >= 0; i3--) {
          var value = array[i3];
          if (predicate(value, i3)) {
            return value;
          }
        }
        return void 0;
      }
      ts3.findLast = findLast;
      function findIndex(array, predicate, startIndex) {
        for (var i3 = startIndex || 0; i3 < array.length; i3++) {
          if (predicate(array[i3], i3)) {
            return i3;
          }
        }
        return -1;
      }
      ts3.findIndex = findIndex;
      function findLastIndex(array, predicate, startIndex) {
        for (var i3 = startIndex === void 0 ? array.length - 1 : startIndex; i3 >= 0; i3--) {
          if (predicate(array[i3], i3)) {
            return i3;
          }
        }
        return -1;
      }
      ts3.findLastIndex = findLastIndex;
      function findMap(array, callback) {
        for (var i3 = 0; i3 < array.length; i3++) {
          var result2 = callback(array[i3], i3);
          if (result2) {
            return result2;
          }
        }
        return ts3.Debug.fail();
      }
      ts3.findMap = findMap;
      function contains(array, value, equalityComparer) {
        if (equalityComparer === void 0) {
          equalityComparer = equateValues;
        }
        if (array) {
          for (var _i = 0, array_1 = array; _i < array_1.length; _i++) {
            var v = array_1[_i];
            if (equalityComparer(v, value)) {
              return true;
            }
          }
        }
        return false;
      }
      ts3.contains = contains;
      function arraysEqual(a2, b2, equalityComparer) {
        if (equalityComparer === void 0) {
          equalityComparer = equateValues;
        }
        return a2.length === b2.length && a2.every(function(x, i3) {
          return equalityComparer(x, b2[i3]);
        });
      }
      ts3.arraysEqual = arraysEqual;
      function indexOfAnyCharCode(text, charCodes, start) {
        for (var i3 = start || 0; i3 < text.length; i3++) {
          if (contains(charCodes, text.charCodeAt(i3))) {
            return i3;
          }
        }
        return -1;
      }
      ts3.indexOfAnyCharCode = indexOfAnyCharCode;
      function countWhere(array, predicate) {
        var count = 0;
        if (array) {
          for (var i3 = 0; i3 < array.length; i3++) {
            var v = array[i3];
            if (predicate(v, i3)) {
              count++;
            }
          }
        }
        return count;
      }
      ts3.countWhere = countWhere;
      function filter(array, f) {
        if (array) {
          var len = array.length;
          var i3 = 0;
          while (i3 < len && f(array[i3]))
            i3++;
          if (i3 < len) {
            var result2 = array.slice(0, i3);
            i3++;
            while (i3 < len) {
              var item = array[i3];
              if (f(item)) {
                result2.push(item);
              }
              i3++;
            }
            return result2;
          }
        }
        return array;
      }
      ts3.filter = filter;
      function filterMutate(array, f) {
        var outIndex = 0;
        for (var i3 = 0; i3 < array.length; i3++) {
          if (f(array[i3], i3, array)) {
            array[outIndex] = array[i3];
            outIndex++;
          }
        }
        array.length = outIndex;
      }
      ts3.filterMutate = filterMutate;
      function clear(array) {
        array.length = 0;
      }
      ts3.clear = clear;
      function map2(array, f) {
        var result2;
        if (array) {
          result2 = [];
          for (var i3 = 0; i3 < array.length; i3++) {
            result2.push(f(array[i3], i3));
          }
        }
        return result2;
      }
      ts3.map = map2;
      function mapIterator(iter, mapFn) {
        return {
          next: function() {
            var iterRes = iter.next();
            return iterRes.done ? iterRes : { value: mapFn(iterRes.value), done: false };
          }
        };
      }
      ts3.mapIterator = mapIterator;
      function sameMap(array, f) {
        if (array) {
          for (var i3 = 0; i3 < array.length; i3++) {
            var item = array[i3];
            var mapped = f(item, i3);
            if (item !== mapped) {
              var result2 = array.slice(0, i3);
              result2.push(mapped);
              for (i3++; i3 < array.length; i3++) {
                result2.push(f(array[i3], i3));
              }
              return result2;
            }
          }
        }
        return array;
      }
      ts3.sameMap = sameMap;
      function flatten(array) {
        var result2 = [];
        for (var _i = 0, array_2 = array; _i < array_2.length; _i++) {
          var v = array_2[_i];
          if (v) {
            if (isArray(v)) {
              addRange(result2, v);
            } else {
              result2.push(v);
            }
          }
        }
        return result2;
      }
      ts3.flatten = flatten;
      function flatMap(array, mapfn) {
        var result2;
        if (array) {
          for (var i3 = 0; i3 < array.length; i3++) {
            var v = mapfn(array[i3], i3);
            if (v) {
              if (isArray(v)) {
                result2 = addRange(result2, v);
              } else {
                result2 = append(result2, v);
              }
            }
          }
        }
        return result2 || ts3.emptyArray;
      }
      ts3.flatMap = flatMap;
      function flatMapToMutable(array, mapfn) {
        var result2 = [];
        if (array) {
          for (var i3 = 0; i3 < array.length; i3++) {
            var v = mapfn(array[i3], i3);
            if (v) {
              if (isArray(v)) {
                addRange(result2, v);
              } else {
                result2.push(v);
              }
            }
          }
        }
        return result2;
      }
      ts3.flatMapToMutable = flatMapToMutable;
      function flatMapIterator(iter, mapfn) {
        var first2 = iter.next();
        if (first2.done) {
          return ts3.emptyIterator;
        }
        var currentIter = getIterator2(first2.value);
        return {
          next: function() {
            while (true) {
              var currentRes = currentIter.next();
              if (!currentRes.done) {
                return currentRes;
              }
              var iterRes = iter.next();
              if (iterRes.done) {
                return iterRes;
              }
              currentIter = getIterator2(iterRes.value);
            }
          }
        };
        function getIterator2(x) {
          var res = mapfn(x);
          return res === void 0 ? ts3.emptyIterator : isArray(res) ? arrayIterator(res) : res;
        }
      }
      ts3.flatMapIterator = flatMapIterator;
      function sameFlatMap(array, mapfn) {
        var result2;
        if (array) {
          for (var i3 = 0; i3 < array.length; i3++) {
            var item = array[i3];
            var mapped = mapfn(item, i3);
            if (result2 || item !== mapped || isArray(mapped)) {
              if (!result2) {
                result2 = array.slice(0, i3);
              }
              if (isArray(mapped)) {
                addRange(result2, mapped);
              } else {
                result2.push(mapped);
              }
            }
          }
        }
        return result2 || array;
      }
      ts3.sameFlatMap = sameFlatMap;
      function mapAllOrFail(array, mapFn) {
        var result2 = [];
        for (var i3 = 0; i3 < array.length; i3++) {
          var mapped = mapFn(array[i3], i3);
          if (mapped === void 0) {
            return void 0;
          }
          result2.push(mapped);
        }
        return result2;
      }
      ts3.mapAllOrFail = mapAllOrFail;
      function mapDefined(array, mapFn) {
        var result2 = [];
        if (array) {
          for (var i3 = 0; i3 < array.length; i3++) {
            var mapped = mapFn(array[i3], i3);
            if (mapped !== void 0) {
              result2.push(mapped);
            }
          }
        }
        return result2;
      }
      ts3.mapDefined = mapDefined;
      function mapDefinedIterator(iter, mapFn) {
        return {
          next: function() {
            while (true) {
              var res = iter.next();
              if (res.done) {
                return res;
              }
              var value = mapFn(res.value);
              if (value !== void 0) {
                return { value, done: false };
              }
            }
          }
        };
      }
      ts3.mapDefinedIterator = mapDefinedIterator;
      function mapDefinedEntries(map3, f) {
        if (!map3) {
          return void 0;
        }
        var result2 = new ts3.Map();
        map3.forEach(function(value, key2) {
          var entry = f(key2, value);
          if (entry !== void 0) {
            var newKey = entry[0], newValue = entry[1];
            if (newKey !== void 0 && newValue !== void 0) {
              result2.set(newKey, newValue);
            }
          }
        });
        return result2;
      }
      ts3.mapDefinedEntries = mapDefinedEntries;
      function mapDefinedValues(set2, f) {
        if (set2) {
          var result_1 = new ts3.Set();
          set2.forEach(function(value) {
            var newValue = f(value);
            if (newValue !== void 0) {
              result_1.add(newValue);
            }
          });
          return result_1;
        }
      }
      ts3.mapDefinedValues = mapDefinedValues;
      function getOrUpdate(map3, key2, callback) {
        if (map3.has(key2)) {
          return map3.get(key2);
        }
        var value = callback();
        map3.set(key2, value);
        return value;
      }
      ts3.getOrUpdate = getOrUpdate;
      function tryAddToSet(set2, value) {
        if (!set2.has(value)) {
          set2.add(value);
          return true;
        }
        return false;
      }
      ts3.tryAddToSet = tryAddToSet;
      ts3.emptyIterator = { next: function() {
        return { value: void 0, done: true };
      } };
      function singleIterator(value) {
        var done = false;
        return {
          next: function() {
            var wasDone = done;
            done = true;
            return wasDone ? { value: void 0, done: true } : { value, done: false };
          }
        };
      }
      ts3.singleIterator = singleIterator;
      function spanMap(array, keyfn, mapfn) {
        var result2;
        if (array) {
          result2 = [];
          var len = array.length;
          var previousKey = void 0;
          var key2 = void 0;
          var start = 0;
          var pos = 0;
          while (start < len) {
            while (pos < len) {
              var value = array[pos];
              key2 = keyfn(value, pos);
              if (pos === 0) {
                previousKey = key2;
              } else if (key2 !== previousKey) {
                break;
              }
              pos++;
            }
            if (start < pos) {
              var v = mapfn(array.slice(start, pos), previousKey, start, pos);
              if (v) {
                result2.push(v);
              }
              start = pos;
            }
            previousKey = key2;
            pos++;
          }
        }
        return result2;
      }
      ts3.spanMap = spanMap;
      function mapEntries(map3, f) {
        if (!map3) {
          return void 0;
        }
        var result2 = new ts3.Map();
        map3.forEach(function(value, key2) {
          var _a2 = f(key2, value), newKey = _a2[0], newValue = _a2[1];
          result2.set(newKey, newValue);
        });
        return result2;
      }
      ts3.mapEntries = mapEntries;
      function some(array, predicate) {
        if (array) {
          if (predicate) {
            for (var _i = 0, array_3 = array; _i < array_3.length; _i++) {
              var v = array_3[_i];
              if (predicate(v)) {
                return true;
              }
            }
          } else {
            return array.length > 0;
          }
        }
        return false;
      }
      ts3.some = some;
      function getRangesWhere(arr, pred, cb2) {
        var start;
        for (var i3 = 0; i3 < arr.length; i3++) {
          if (pred(arr[i3])) {
            start = start === void 0 ? i3 : start;
          } else {
            if (start !== void 0) {
              cb2(start, i3);
              start = void 0;
            }
          }
        }
        if (start !== void 0)
          cb2(start, arr.length);
      }
      ts3.getRangesWhere = getRangesWhere;
      function concatenate(array1, array2) {
        if (!some(array2))
          return array1;
        if (!some(array1))
          return array2;
        return __spreadArray(__spreadArray([], array1), array2);
      }
      ts3.concatenate = concatenate;
      function selectIndex(_, i3) {
        return i3;
      }
      function indicesOf(array) {
        return array.map(selectIndex);
      }
      ts3.indicesOf = indicesOf;
      function deduplicateRelational(array, equalityComparer, comparer) {
        var indices = indicesOf(array);
        stableSortIndices(array, indices, comparer);
        var last2 = array[indices[0]];
        var deduplicated = [indices[0]];
        for (var i3 = 1; i3 < indices.length; i3++) {
          var index = indices[i3];
          var item = array[index];
          if (!equalityComparer(last2, item)) {
            deduplicated.push(index);
            last2 = item;
          }
        }
        deduplicated.sort();
        return deduplicated.map(function(i4) {
          return array[i4];
        });
      }
      function deduplicateEquality(array, equalityComparer) {
        var result2 = [];
        for (var _i = 0, array_4 = array; _i < array_4.length; _i++) {
          var item = array_4[_i];
          pushIfUnique(result2, item, equalityComparer);
        }
        return result2;
      }
      function deduplicate(array, equalityComparer, comparer) {
        return array.length === 0 ? [] : array.length === 1 ? array.slice() : comparer ? deduplicateRelational(array, equalityComparer, comparer) : deduplicateEquality(array, equalityComparer);
      }
      ts3.deduplicate = deduplicate;
      function deduplicateSorted(array, comparer) {
        if (array.length === 0)
          return ts3.emptyArray;
        var last2 = array[0];
        var deduplicated = [last2];
        for (var i3 = 1; i3 < array.length; i3++) {
          var next = array[i3];
          switch (comparer(next, last2)) {
            case true:
            case 0:
              continue;
            case -1:
              return ts3.Debug.fail("Array is unsorted.");
          }
          deduplicated.push(last2 = next);
        }
        return deduplicated;
      }
      function insertSorted(array, insert, compare) {
        if (array.length === 0) {
          array.push(insert);
          return;
        }
        var insertIndex = binarySearch(array, insert, identity, compare);
        if (insertIndex < 0) {
          array.splice(~insertIndex, 0, insert);
        }
      }
      ts3.insertSorted = insertSorted;
      function sortAndDeduplicate(array, comparer, equalityComparer) {
        return deduplicateSorted(sort(array, comparer), equalityComparer || comparer || compareStringsCaseSensitive);
      }
      ts3.sortAndDeduplicate = sortAndDeduplicate;
      function arrayIsSorted(array, comparer) {
        if (array.length < 2)
          return true;
        var prevElement = array[0];
        for (var _i = 0, _a2 = array.slice(1); _i < _a2.length; _i++) {
          var element = _a2[_i];
          if (comparer(prevElement, element) === 1) {
            return false;
          }
          prevElement = element;
        }
        return true;
      }
      ts3.arrayIsSorted = arrayIsSorted;
      function arrayIsEqualTo(array1, array2, equalityComparer) {
        if (equalityComparer === void 0) {
          equalityComparer = equateValues;
        }
        if (!array1 || !array2) {
          return array1 === array2;
        }
        if (array1.length !== array2.length) {
          return false;
        }
        for (var i3 = 0; i3 < array1.length; i3++) {
          if (!equalityComparer(array1[i3], array2[i3], i3)) {
            return false;
          }
        }
        return true;
      }
      ts3.arrayIsEqualTo = arrayIsEqualTo;
      function compact(array) {
        var result2;
        if (array) {
          for (var i3 = 0; i3 < array.length; i3++) {
            var v = array[i3];
            if (result2 || !v) {
              if (!result2) {
                result2 = array.slice(0, i3);
              }
              if (v) {
                result2.push(v);
              }
            }
          }
        }
        return result2 || array;
      }
      ts3.compact = compact;
      function relativeComplement(arrayA, arrayB, comparer) {
        if (!arrayB || !arrayA || arrayB.length === 0 || arrayA.length === 0)
          return arrayB;
        var result2 = [];
        loopB:
          for (var offsetA = 0, offsetB = 0; offsetB < arrayB.length; offsetB++) {
            if (offsetB > 0) {
              ts3.Debug.assertGreaterThanOrEqual(comparer(arrayB[offsetB], arrayB[offsetB - 1]), 0);
            }
            loopA:
              for (var startA = offsetA; offsetA < arrayA.length; offsetA++) {
                if (offsetA > startA) {
                  ts3.Debug.assertGreaterThanOrEqual(comparer(arrayA[offsetA], arrayA[offsetA - 1]), 0);
                }
                switch (comparer(arrayB[offsetB], arrayA[offsetA])) {
                  case -1:
                    result2.push(arrayB[offsetB]);
                    continue loopB;
                  case 0:
                    continue loopB;
                  case 1:
                    continue loopA;
                }
              }
          }
        return result2;
      }
      ts3.relativeComplement = relativeComplement;
      function sum(array, prop) {
        var result2 = 0;
        for (var _i = 0, array_5 = array; _i < array_5.length; _i++) {
          var v = array_5[_i];
          result2 += v[prop];
        }
        return result2;
      }
      ts3.sum = sum;
      function append(to, value) {
        if (value === void 0)
          return to;
        if (to === void 0)
          return [value];
        to.push(value);
        return to;
      }
      ts3.append = append;
      function combine(xs, ys) {
        if (xs === void 0)
          return ys;
        if (ys === void 0)
          return xs;
        if (isArray(xs))
          return isArray(ys) ? concatenate(xs, ys) : append(xs, ys);
        if (isArray(ys))
          return append(ys, xs);
        return [xs, ys];
      }
      ts3.combine = combine;
      function toOffset(array, offset) {
        return offset < 0 ? array.length + offset : offset;
      }
      function addRange(to, from, start, end) {
        if (from === void 0 || from.length === 0)
          return to;
        if (to === void 0)
          return from.slice(start, end);
        start = start === void 0 ? 0 : toOffset(from, start);
        end = end === void 0 ? from.length : toOffset(from, end);
        for (var i3 = start; i3 < end && i3 < from.length; i3++) {
          if (from[i3] !== void 0) {
            to.push(from[i3]);
          }
        }
        return to;
      }
      ts3.addRange = addRange;
      function pushIfUnique(array, toAdd, equalityComparer) {
        if (contains(array, toAdd, equalityComparer)) {
          return false;
        } else {
          array.push(toAdd);
          return true;
        }
      }
      ts3.pushIfUnique = pushIfUnique;
      function appendIfUnique(array, toAdd, equalityComparer) {
        if (array) {
          pushIfUnique(array, toAdd, equalityComparer);
          return array;
        } else {
          return [toAdd];
        }
      }
      ts3.appendIfUnique = appendIfUnique;
      function stableSortIndices(array, indices, comparer) {
        indices.sort(function(x, y2) {
          return comparer(array[x], array[y2]) || compareValues(x, y2);
        });
      }
      function sort(array, comparer) {
        return array.length === 0 ? array : array.slice().sort(comparer);
      }
      ts3.sort = sort;
      function arrayIterator(array) {
        var i3 = 0;
        return { next: function() {
          if (i3 === array.length) {
            return { value: void 0, done: true };
          } else {
            i3++;
            return { value: array[i3 - 1], done: false };
          }
        } };
      }
      ts3.arrayIterator = arrayIterator;
      function arrayReverseIterator(array) {
        var i3 = array.length;
        return {
          next: function() {
            if (i3 === 0) {
              return { value: void 0, done: true };
            } else {
              i3--;
              return { value: array[i3], done: false };
            }
          }
        };
      }
      ts3.arrayReverseIterator = arrayReverseIterator;
      function stableSort(array, comparer) {
        var indices = indicesOf(array);
        stableSortIndices(array, indices, comparer);
        return indices.map(function(i3) {
          return array[i3];
        });
      }
      ts3.stableSort = stableSort;
      function rangeEquals(array1, array2, pos, end) {
        while (pos < end) {
          if (array1[pos] !== array2[pos]) {
            return false;
          }
          pos++;
        }
        return true;
      }
      ts3.rangeEquals = rangeEquals;
      function elementAt(array, offset) {
        if (array) {
          offset = toOffset(array, offset);
          if (offset < array.length) {
            return array[offset];
          }
        }
        return void 0;
      }
      ts3.elementAt = elementAt;
      function firstOrUndefined(array) {
        return array.length === 0 ? void 0 : array[0];
      }
      ts3.firstOrUndefined = firstOrUndefined;
      function first(array) {
        ts3.Debug.assert(array.length !== 0);
        return array[0];
      }
      ts3.first = first;
      function lastOrUndefined(array) {
        return array.length === 0 ? void 0 : array[array.length - 1];
      }
      ts3.lastOrUndefined = lastOrUndefined;
      function last(array) {
        ts3.Debug.assert(array.length !== 0);
        return array[array.length - 1];
      }
      ts3.last = last;
      function singleOrUndefined(array) {
        return array && array.length === 1 ? array[0] : void 0;
      }
      ts3.singleOrUndefined = singleOrUndefined;
      function singleOrMany(array) {
        return array && array.length === 1 ? array[0] : array;
      }
      ts3.singleOrMany = singleOrMany;
      function replaceElement(array, index, value) {
        var result2 = array.slice(0);
        result2[index] = value;
        return result2;
      }
      ts3.replaceElement = replaceElement;
      function binarySearch(array, value, keySelector, keyComparer, offset) {
        return binarySearchKey(array, keySelector(value), keySelector, keyComparer, offset);
      }
      ts3.binarySearch = binarySearch;
      function binarySearchKey(array, key2, keySelector, keyComparer, offset) {
        if (!some(array)) {
          return -1;
        }
        var low = offset || 0;
        var high = array.length - 1;
        while (low <= high) {
          var middle = low + (high - low >> 1);
          var midKey = keySelector(array[middle], middle);
          switch (keyComparer(midKey, key2)) {
            case -1:
              low = middle + 1;
              break;
            case 0:
              return middle;
            case 1:
              high = middle - 1;
              break;
          }
        }
        return ~low;
      }
      ts3.binarySearchKey = binarySearchKey;
      function reduceLeft(array, f, initial, start, count) {
        if (array && array.length > 0) {
          var size = array.length;
          if (size > 0) {
            var pos = start === void 0 || start < 0 ? 0 : start;
            var end = count === void 0 || pos + count > size - 1 ? size - 1 : pos + count;
            var result2 = void 0;
            if (arguments.length <= 2) {
              result2 = array[pos];
              pos++;
            } else {
              result2 = initial;
            }
            while (pos <= end) {
              result2 = f(result2, array[pos], pos);
              pos++;
            }
            return result2;
          }
        }
        return initial;
      }
      ts3.reduceLeft = reduceLeft;
      var hasOwnProperty2 = Object.prototype.hasOwnProperty;
      function hasProperty(map3, key2) {
        return hasOwnProperty2.call(map3, key2);
      }
      ts3.hasProperty = hasProperty;
      function getProperty(map3, key2) {
        return hasOwnProperty2.call(map3, key2) ? map3[key2] : void 0;
      }
      ts3.getProperty = getProperty;
      function getOwnKeys(map3) {
        var keys = [];
        for (var key2 in map3) {
          if (hasOwnProperty2.call(map3, key2)) {
            keys.push(key2);
          }
        }
        return keys;
      }
      ts3.getOwnKeys = getOwnKeys;
      function getAllKeys(obj) {
        var result2 = [];
        do {
          var names = Object.getOwnPropertyNames(obj);
          for (var _i = 0, names_1 = names; _i < names_1.length; _i++) {
            var name = names_1[_i];
            pushIfUnique(result2, name);
          }
        } while (obj = Object.getPrototypeOf(obj));
        return result2;
      }
      ts3.getAllKeys = getAllKeys;
      function getOwnValues(sparseArray) {
        var values = [];
        for (var key2 in sparseArray) {
          if (hasOwnProperty2.call(sparseArray, key2)) {
            values.push(sparseArray[key2]);
          }
        }
        return values;
      }
      ts3.getOwnValues = getOwnValues;
      var _entries = Object.entries || function(obj) {
        var keys = getOwnKeys(obj);
        var result2 = Array(keys.length);
        for (var i3 = 0; i3 < keys.length; i3++) {
          result2[i3] = [keys[i3], obj[keys[i3]]];
        }
        return result2;
      };
      function getEntries(obj) {
        return obj ? _entries(obj) : [];
      }
      ts3.getEntries = getEntries;
      function arrayOf(count, f) {
        var result2 = new Array(count);
        for (var i3 = 0; i3 < count; i3++) {
          result2[i3] = f(i3);
        }
        return result2;
      }
      ts3.arrayOf = arrayOf;
      function arrayFrom(iterator, map3) {
        var result2 = [];
        for (var iterResult = iterator.next(); !iterResult.done; iterResult = iterator.next()) {
          result2.push(map3 ? map3(iterResult.value) : iterResult.value);
        }
        return result2;
      }
      ts3.arrayFrom = arrayFrom;
      function assign3(t2) {
        var args = [];
        for (var _i = 1; _i < arguments.length; _i++) {
          args[_i - 1] = arguments[_i];
        }
        for (var _a2 = 0, args_1 = args; _a2 < args_1.length; _a2++) {
          var arg2 = args_1[_a2];
          if (arg2 === void 0)
            continue;
          for (var p in arg2) {
            if (hasProperty(arg2, p)) {
              t2[p] = arg2[p];
            }
          }
        }
        return t2;
      }
      ts3.assign = assign3;
      function equalOwnProperties(left, right, equalityComparer) {
        if (equalityComparer === void 0) {
          equalityComparer = equateValues;
        }
        if (left === right)
          return true;
        if (!left || !right)
          return false;
        for (var key2 in left) {
          if (hasOwnProperty2.call(left, key2)) {
            if (!hasOwnProperty2.call(right, key2))
              return false;
            if (!equalityComparer(left[key2], right[key2]))
              return false;
          }
        }
        for (var key2 in right) {
          if (hasOwnProperty2.call(right, key2)) {
            if (!hasOwnProperty2.call(left, key2))
              return false;
          }
        }
        return true;
      }
      ts3.equalOwnProperties = equalOwnProperties;
      function arrayToMap(array, makeKey, makeValue) {
        if (makeValue === void 0) {
          makeValue = identity;
        }
        var result2 = new ts3.Map();
        for (var _i = 0, array_6 = array; _i < array_6.length; _i++) {
          var value = array_6[_i];
          var key2 = makeKey(value);
          if (key2 !== void 0)
            result2.set(key2, makeValue(value));
        }
        return result2;
      }
      ts3.arrayToMap = arrayToMap;
      function arrayToNumericMap(array, makeKey, makeValue) {
        if (makeValue === void 0) {
          makeValue = identity;
        }
        var result2 = [];
        for (var _i = 0, array_7 = array; _i < array_7.length; _i++) {
          var value = array_7[_i];
          result2[makeKey(value)] = makeValue(value);
        }
        return result2;
      }
      ts3.arrayToNumericMap = arrayToNumericMap;
      function arrayToMultiMap(values, makeKey, makeValue) {
        if (makeValue === void 0) {
          makeValue = identity;
        }
        var result2 = createMultiMap();
        for (var _i = 0, values_1 = values; _i < values_1.length; _i++) {
          var value = values_1[_i];
          result2.add(makeKey(value), makeValue(value));
        }
        return result2;
      }
      ts3.arrayToMultiMap = arrayToMultiMap;
      function group(values, getGroupId, resultSelector) {
        if (resultSelector === void 0) {
          resultSelector = identity;
        }
        return arrayFrom(arrayToMultiMap(values, getGroupId).values(), resultSelector);
      }
      ts3.group = group;
      function clone(object) {
        var result2 = {};
        for (var id in object) {
          if (hasOwnProperty2.call(object, id)) {
            result2[id] = object[id];
          }
        }
        return result2;
      }
      ts3.clone = clone;
      function extend3(first2, second) {
        var result2 = {};
        for (var id in second) {
          if (hasOwnProperty2.call(second, id)) {
            result2[id] = second[id];
          }
        }
        for (var id in first2) {
          if (hasOwnProperty2.call(first2, id)) {
            result2[id] = first2[id];
          }
        }
        return result2;
      }
      ts3.extend = extend3;
      function copyProperties(first2, second) {
        for (var id in second) {
          if (hasOwnProperty2.call(second, id)) {
            first2[id] = second[id];
          }
        }
      }
      ts3.copyProperties = copyProperties;
      function maybeBind(obj, fn) {
        return fn ? fn.bind(obj) : void 0;
      }
      ts3.maybeBind = maybeBind;
      function createMultiMap() {
        var map3 = new ts3.Map();
        map3.add = multiMapAdd;
        map3.remove = multiMapRemove;
        return map3;
      }
      ts3.createMultiMap = createMultiMap;
      function multiMapAdd(key2, value) {
        var values = this.get(key2);
        if (values) {
          values.push(value);
        } else {
          this.set(key2, values = [value]);
        }
        return values;
      }
      function multiMapRemove(key2, value) {
        var values = this.get(key2);
        if (values) {
          unorderedRemoveItem(values, value);
          if (!values.length) {
            this.delete(key2);
          }
        }
      }
      function createUnderscoreEscapedMultiMap() {
        return createMultiMap();
      }
      ts3.createUnderscoreEscapedMultiMap = createUnderscoreEscapedMultiMap;
      function isArray(value) {
        return Array.isArray ? Array.isArray(value) : value instanceof Array;
      }
      ts3.isArray = isArray;
      function toArray2(value) {
        return isArray(value) ? value : [value];
      }
      ts3.toArray = toArray2;
      function isString(text) {
        return typeof text === "string";
      }
      ts3.isString = isString;
      function isNumber(x) {
        return typeof x === "number";
      }
      ts3.isNumber = isNumber;
      function tryCast(value, test) {
        return value !== void 0 && test(value) ? value : void 0;
      }
      ts3.tryCast = tryCast;
      function cast(value, test) {
        if (value !== void 0 && test(value))
          return value;
        return ts3.Debug.fail("Invalid cast. The supplied value " + value + " did not pass the test '" + ts3.Debug.getFunctionName(test) + "'.");
      }
      ts3.cast = cast;
      function noop(_) {
      }
      ts3.noop = noop;
      function returnFalse() {
        return false;
      }
      ts3.returnFalse = returnFalse;
      function returnTrue() {
        return true;
      }
      ts3.returnTrue = returnTrue;
      function returnUndefined() {
        return void 0;
      }
      ts3.returnUndefined = returnUndefined;
      function identity(x) {
        return x;
      }
      ts3.identity = identity;
      function toLowerCase(x) {
        return x.toLowerCase();
      }
      ts3.toLowerCase = toLowerCase;
      var fileNameLowerCaseRegExp = /[^\u0130\u0131\u00DFa-z0-9\\/:\-_\. ]+/g;
      function toFileNameLowerCase(x) {
        return fileNameLowerCaseRegExp.test(x) ? x.replace(fileNameLowerCaseRegExp, toLowerCase) : x;
      }
      ts3.toFileNameLowerCase = toFileNameLowerCase;
      function notImplemented() {
        throw new Error("Not implemented");
      }
      ts3.notImplemented = notImplemented;
      function memoize(callback) {
        var value;
        return function() {
          if (callback) {
            value = callback();
            callback = void 0;
          }
          return value;
        };
      }
      ts3.memoize = memoize;
      function memoizeOne(callback) {
        var map3 = new ts3.Map();
        return function(arg2) {
          var key2 = typeof arg2 + ":" + arg2;
          var value = map3.get(key2);
          if (value === void 0 && !map3.has(key2)) {
            value = callback(arg2);
            map3.set(key2, value);
          }
          return value;
        };
      }
      ts3.memoizeOne = memoizeOne;
      function compose(a2, b2, c2, d, e2) {
        if (!!e2) {
          var args_2 = [];
          for (var i3 = 0; i3 < arguments.length; i3++) {
            args_2[i3] = arguments[i3];
          }
          return function(t2) {
            return reduceLeft(args_2, function(u2, f) {
              return f(u2);
            }, t2);
          };
        } else if (d) {
          return function(t2) {
            return d(c2(b2(a2(t2))));
          };
        } else if (c2) {
          return function(t2) {
            return c2(b2(a2(t2)));
          };
        } else if (b2) {
          return function(t2) {
            return b2(a2(t2));
          };
        } else if (a2) {
          return function(t2) {
            return a2(t2);
          };
        } else {
          return function(t2) {
            return t2;
          };
        }
      }
      ts3.compose = compose;
      var AssertionLevel;
      (function(AssertionLevel2) {
        AssertionLevel2[AssertionLevel2["None"] = 0] = "None";
        AssertionLevel2[AssertionLevel2["Normal"] = 1] = "Normal";
        AssertionLevel2[AssertionLevel2["Aggressive"] = 2] = "Aggressive";
        AssertionLevel2[AssertionLevel2["VeryAggressive"] = 3] = "VeryAggressive";
      })(AssertionLevel = ts3.AssertionLevel || (ts3.AssertionLevel = {}));
      function equateValues(a2, b2) {
        return a2 === b2;
      }
      ts3.equateValues = equateValues;
      function equateStringsCaseInsensitive(a2, b2) {
        return a2 === b2 || a2 !== void 0 && b2 !== void 0 && a2.toUpperCase() === b2.toUpperCase();
      }
      ts3.equateStringsCaseInsensitive = equateStringsCaseInsensitive;
      function equateStringsCaseSensitive(a2, b2) {
        return equateValues(a2, b2);
      }
      ts3.equateStringsCaseSensitive = equateStringsCaseSensitive;
      function compareComparableValues(a2, b2) {
        return a2 === b2 ? 0 : a2 === void 0 ? -1 : b2 === void 0 ? 1 : a2 < b2 ? -1 : 1;
      }
      function compareValues(a2, b2) {
        return compareComparableValues(a2, b2);
      }
      ts3.compareValues = compareValues;
      function compareTextSpans(a2, b2) {
        return compareValues(a2 === null || a2 === void 0 ? void 0 : a2.start, b2 === null || b2 === void 0 ? void 0 : b2.start) || compareValues(a2 === null || a2 === void 0 ? void 0 : a2.length, b2 === null || b2 === void 0 ? void 0 : b2.length);
      }
      ts3.compareTextSpans = compareTextSpans;
      function min(a2, b2, compare) {
        return compare(a2, b2) === -1 ? a2 : b2;
      }
      ts3.min = min;
      function compareStringsCaseInsensitive(a2, b2) {
        if (a2 === b2)
          return 0;
        if (a2 === void 0)
          return -1;
        if (b2 === void 0)
          return 1;
        a2 = a2.toUpperCase();
        b2 = b2.toUpperCase();
        return a2 < b2 ? -1 : a2 > b2 ? 1 : 0;
      }
      ts3.compareStringsCaseInsensitive = compareStringsCaseInsensitive;
      function compareStringsCaseSensitive(a2, b2) {
        return compareComparableValues(a2, b2);
      }
      ts3.compareStringsCaseSensitive = compareStringsCaseSensitive;
      function getStringComparer(ignoreCase) {
        return ignoreCase ? compareStringsCaseInsensitive : compareStringsCaseSensitive;
      }
      ts3.getStringComparer = getStringComparer;
      var createUIStringComparer = function() {
        var defaultComparer;
        var enUSComparer;
        var stringComparerFactory = getStringComparerFactory();
        return createStringComparer;
        function compareWithCallback(a2, b2, comparer) {
          if (a2 === b2)
            return 0;
          if (a2 === void 0)
            return -1;
          if (b2 === void 0)
            return 1;
          var value = comparer(a2, b2);
          return value < 0 ? -1 : value > 0 ? 1 : 0;
        }
        function createIntlCollatorStringComparer(locale) {
          var comparer = new Intl.Collator(locale, { usage: "sort", sensitivity: "variant" }).compare;
          return function(a2, b2) {
            return compareWithCallback(a2, b2, comparer);
          };
        }
        function createLocaleCompareStringComparer(locale) {
          if (locale !== void 0)
            return createFallbackStringComparer();
          return function(a2, b2) {
            return compareWithCallback(a2, b2, compareStrings);
          };
          function compareStrings(a2, b2) {
            return a2.localeCompare(b2);
          }
        }
        function createFallbackStringComparer() {
          return function(a2, b2) {
            return compareWithCallback(a2, b2, compareDictionaryOrder);
          };
          function compareDictionaryOrder(a2, b2) {
            return compareStrings(a2.toUpperCase(), b2.toUpperCase()) || compareStrings(a2, b2);
          }
          function compareStrings(a2, b2) {
            return a2 < b2 ? -1 : a2 > b2 ? 1 : 0;
          }
        }
        function getStringComparerFactory() {
          if (typeof Intl === "object" && typeof Intl.Collator === "function") {
            return createIntlCollatorStringComparer;
          }
          if (typeof String.prototype.localeCompare === "function" && typeof String.prototype.toLocaleUpperCase === "function" && "a".localeCompare("B") < 0) {
            return createLocaleCompareStringComparer;
          }
          return createFallbackStringComparer;
        }
        function createStringComparer(locale) {
          if (locale === void 0) {
            return defaultComparer || (defaultComparer = stringComparerFactory(locale));
          } else if (locale === "en-US") {
            return enUSComparer || (enUSComparer = stringComparerFactory(locale));
          } else {
            return stringComparerFactory(locale);
          }
        }
      }();
      var uiComparerCaseSensitive;
      var uiLocale;
      function getUILocale() {
        return uiLocale;
      }
      ts3.getUILocale = getUILocale;
      function setUILocale(value) {
        if (uiLocale !== value) {
          uiLocale = value;
          uiComparerCaseSensitive = void 0;
        }
      }
      ts3.setUILocale = setUILocale;
      function compareStringsCaseSensitiveUI(a2, b2) {
        var comparer = uiComparerCaseSensitive || (uiComparerCaseSensitive = createUIStringComparer(uiLocale));
        return comparer(a2, b2);
      }
      ts3.compareStringsCaseSensitiveUI = compareStringsCaseSensitiveUI;
      function compareProperties(a2, b2, key2, comparer) {
        return a2 === b2 ? 0 : a2 === void 0 ? -1 : b2 === void 0 ? 1 : comparer(a2[key2], b2[key2]);
      }
      ts3.compareProperties = compareProperties;
      function compareBooleans(a2, b2) {
        return compareValues(a2 ? 1 : 0, b2 ? 1 : 0);
      }
      ts3.compareBooleans = compareBooleans;
      function getSpellingSuggestion(name, candidates, getName) {
        var maximumLengthDifference = Math.min(2, Math.floor(name.length * 0.34));
        var bestDistance = Math.floor(name.length * 0.4) + 1;
        var bestCandidate;
        for (var _i = 0, candidates_1 = candidates; _i < candidates_1.length; _i++) {
          var candidate = candidates_1[_i];
          var candidateName = getName(candidate);
          if (candidateName !== void 0 && Math.abs(candidateName.length - name.length) <= maximumLengthDifference) {
            if (candidateName === name) {
              continue;
            }
            if (candidateName.length < 3 && candidateName.toLowerCase() !== name.toLowerCase()) {
              continue;
            }
            var distance = levenshteinWithMax(name, candidateName, bestDistance - 0.1);
            if (distance === void 0) {
              continue;
            }
            ts3.Debug.assert(distance < bestDistance);
            bestDistance = distance;
            bestCandidate = candidate;
          }
        }
        return bestCandidate;
      }
      ts3.getSpellingSuggestion = getSpellingSuggestion;
      function levenshteinWithMax(s1, s2, max) {
        var previous = new Array(s2.length + 1);
        var current = new Array(s2.length + 1);
        var big = max + 0.01;
        for (var i3 = 0; i3 <= s2.length; i3++) {
          previous[i3] = i3;
        }
        for (var i3 = 1; i3 <= s1.length; i3++) {
          var c1 = s1.charCodeAt(i3 - 1);
          var minJ = Math.ceil(i3 > max ? i3 - max : 1);
          var maxJ = Math.floor(s2.length > max + i3 ? max + i3 : s2.length);
          current[0] = i3;
          var colMin = i3;
          for (var j = 1; j < minJ; j++) {
            current[j] = big;
          }
          for (var j = minJ; j <= maxJ; j++) {
            var substitutionDistance = s1[i3 - 1].toLowerCase() === s2[j - 1].toLowerCase() ? previous[j - 1] + 0.1 : previous[j - 1] + 2;
            var dist = c1 === s2.charCodeAt(j - 1) ? previous[j - 1] : Math.min(previous[j] + 1, current[j - 1] + 1, substitutionDistance);
            current[j] = dist;
            colMin = Math.min(colMin, dist);
          }
          for (var j = maxJ + 1; j <= s2.length; j++) {
            current[j] = big;
          }
          if (colMin > max) {
            return void 0;
          }
          var temp = previous;
          previous = current;
          current = temp;
        }
        var res = previous[s2.length];
        return res > max ? void 0 : res;
      }
      function endsWith(str2, suffix) {
        var expectedPos = str2.length - suffix.length;
        return expectedPos >= 0 && str2.indexOf(suffix, expectedPos) === expectedPos;
      }
      ts3.endsWith = endsWith;
      function removeSuffix(str2, suffix) {
        return endsWith(str2, suffix) ? str2.slice(0, str2.length - suffix.length) : str2;
      }
      ts3.removeSuffix = removeSuffix;
      function tryRemoveSuffix(str2, suffix) {
        return endsWith(str2, suffix) ? str2.slice(0, str2.length - suffix.length) : void 0;
      }
      ts3.tryRemoveSuffix = tryRemoveSuffix;
      function stringContains(str2, substring) {
        return str2.indexOf(substring) !== -1;
      }
      ts3.stringContains = stringContains;
      function removeMinAndVersionNumbers(fileName) {
        var trailingMinOrVersion = /[.-]((min)|(\d+(\.\d+)*))$/;
        return fileName.replace(trailingMinOrVersion, "").replace(trailingMinOrVersion, "");
      }
      ts3.removeMinAndVersionNumbers = removeMinAndVersionNumbers;
      function orderedRemoveItem(array, item) {
        for (var i3 = 0; i3 < array.length; i3++) {
          if (array[i3] === item) {
            orderedRemoveItemAt(array, i3);
            return true;
          }
        }
        return false;
      }
      ts3.orderedRemoveItem = orderedRemoveItem;
      function orderedRemoveItemAt(array, index) {
        for (var i3 = index; i3 < array.length - 1; i3++) {
          array[i3] = array[i3 + 1];
        }
        array.pop();
      }
      ts3.orderedRemoveItemAt = orderedRemoveItemAt;
      function unorderedRemoveItemAt(array, index) {
        array[index] = array[array.length - 1];
        array.pop();
      }
      ts3.unorderedRemoveItemAt = unorderedRemoveItemAt;
      function unorderedRemoveItem(array, item) {
        return unorderedRemoveFirstItemWhere(array, function(element) {
          return element === item;
        });
      }
      ts3.unorderedRemoveItem = unorderedRemoveItem;
      function unorderedRemoveFirstItemWhere(array, predicate) {
        for (var i3 = 0; i3 < array.length; i3++) {
          if (predicate(array[i3])) {
            unorderedRemoveItemAt(array, i3);
            return true;
          }
        }
        return false;
      }
      function createGetCanonicalFileName(useCaseSensitiveFileNames) {
        return useCaseSensitiveFileNames ? identity : toFileNameLowerCase;
      }
      ts3.createGetCanonicalFileName = createGetCanonicalFileName;
      function patternText(_a2) {
        var prefix2 = _a2.prefix, suffix = _a2.suffix;
        return prefix2 + "*" + suffix;
      }
      ts3.patternText = patternText;
      function matchedText(pattern, candidate) {
        ts3.Debug.assert(isPatternMatch(pattern, candidate));
        return candidate.substring(pattern.prefix.length, candidate.length - pattern.suffix.length);
      }
      ts3.matchedText = matchedText;
      function findBestPatternMatch(values, getPattern, candidate) {
        var matchedValue;
        var longestMatchPrefixLength = -1;
        for (var _i = 0, values_2 = values; _i < values_2.length; _i++) {
          var v = values_2[_i];
          var pattern = getPattern(v);
          if (isPatternMatch(pattern, candidate) && pattern.prefix.length > longestMatchPrefixLength) {
            longestMatchPrefixLength = pattern.prefix.length;
            matchedValue = v;
          }
        }
        return matchedValue;
      }
      ts3.findBestPatternMatch = findBestPatternMatch;
      function startsWith(str2, prefix2) {
        return str2.lastIndexOf(prefix2, 0) === 0;
      }
      ts3.startsWith = startsWith;
      function removePrefix(str2, prefix2) {
        return startsWith(str2, prefix2) ? str2.substr(prefix2.length) : str2;
      }
      ts3.removePrefix = removePrefix;
      function tryRemovePrefix(str2, prefix2, getCanonicalFileName) {
        if (getCanonicalFileName === void 0) {
          getCanonicalFileName = identity;
        }
        return startsWith(getCanonicalFileName(str2), getCanonicalFileName(prefix2)) ? str2.substring(prefix2.length) : void 0;
      }
      ts3.tryRemovePrefix = tryRemovePrefix;
      function isPatternMatch(_a2, candidate) {
        var prefix2 = _a2.prefix, suffix = _a2.suffix;
        return candidate.length >= prefix2.length + suffix.length && startsWith(candidate, prefix2) && endsWith(candidate, suffix);
      }
      function and(f, g2) {
        return function(arg2) {
          return f(arg2) && g2(arg2);
        };
      }
      ts3.and = and;
      function or() {
        var fs5 = [];
        for (var _i = 0; _i < arguments.length; _i++) {
          fs5[_i] = arguments[_i];
        }
        return function() {
          var args = [];
          for (var _i2 = 0; _i2 < arguments.length; _i2++) {
            args[_i2] = arguments[_i2];
          }
          for (var _a2 = 0, fs_1 = fs5; _a2 < fs_1.length; _a2++) {
            var f = fs_1[_a2];
            if (f.apply(void 0, args)) {
              return true;
            }
          }
          return false;
        };
      }
      ts3.or = or;
      function not(fn) {
        return function() {
          var args = [];
          for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
          }
          return !fn.apply(void 0, args);
        };
      }
      ts3.not = not;
      function assertType(_) {
      }
      ts3.assertType = assertType;
      function singleElementArray(t2) {
        return t2 === void 0 ? void 0 : [t2];
      }
      ts3.singleElementArray = singleElementArray;
      function enumerateInsertsAndDeletes(newItems, oldItems, comparer, inserted, deleted, unchanged) {
        unchanged = unchanged || noop;
        var newIndex = 0;
        var oldIndex = 0;
        var newLen = newItems.length;
        var oldLen = oldItems.length;
        var hasChanges = false;
        while (newIndex < newLen && oldIndex < oldLen) {
          var newItem = newItems[newIndex];
          var oldItem = oldItems[oldIndex];
          var compareResult = comparer(newItem, oldItem);
          if (compareResult === -1) {
            inserted(newItem);
            newIndex++;
            hasChanges = true;
          } else if (compareResult === 1) {
            deleted(oldItem);
            oldIndex++;
            hasChanges = true;
          } else {
            unchanged(oldItem, newItem);
            newIndex++;
            oldIndex++;
          }
        }
        while (newIndex < newLen) {
          inserted(newItems[newIndex++]);
          hasChanges = true;
        }
        while (oldIndex < oldLen) {
          deleted(oldItems[oldIndex++]);
          hasChanges = true;
        }
        return hasChanges;
      }
      ts3.enumerateInsertsAndDeletes = enumerateInsertsAndDeletes;
      function fill(length2, cb2) {
        var result2 = Array(length2);
        for (var i3 = 0; i3 < length2; i3++) {
          result2[i3] = cb2(i3);
        }
        return result2;
      }
      ts3.fill = fill;
      function cartesianProduct(arrays) {
        var result2 = [];
        cartesianProductWorker(arrays, result2, void 0, 0);
        return result2;
      }
      ts3.cartesianProduct = cartesianProduct;
      function cartesianProductWorker(arrays, result2, outer, index) {
        for (var _i = 0, _a2 = arrays[index]; _i < _a2.length; _i++) {
          var element = _a2[_i];
          var inner = void 0;
          if (outer) {
            inner = outer.slice();
            inner.push(element);
          } else {
            inner = [element];
          }
          if (index === arrays.length - 1) {
            result2.push(inner);
          } else {
            cartesianProductWorker(arrays, result2, inner, index + 1);
          }
        }
      }
      function padLeft(s2, length2, padString) {
        if (padString === void 0) {
          padString = " ";
        }
        return length2 <= s2.length ? s2 : padString.repeat(length2 - s2.length) + s2;
      }
      ts3.padLeft = padLeft;
      function padRight(s2, length2, padString) {
        if (padString === void 0) {
          padString = " ";
        }
        return length2 <= s2.length ? s2 : s2 + padString.repeat(length2 - s2.length);
      }
      ts3.padRight = padRight;
      function takeWhile(array, predicate) {
        var len = array.length;
        var index = 0;
        while (index < len && predicate(array[index])) {
          index++;
        }
        return array.slice(0, index);
      }
      ts3.takeWhile = takeWhile;
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var LogLevel;
      (function(LogLevel2) {
        LogLevel2[LogLevel2["Off"] = 0] = "Off";
        LogLevel2[LogLevel2["Error"] = 1] = "Error";
        LogLevel2[LogLevel2["Warning"] = 2] = "Warning";
        LogLevel2[LogLevel2["Info"] = 3] = "Info";
        LogLevel2[LogLevel2["Verbose"] = 4] = "Verbose";
      })(LogLevel = ts3.LogLevel || (ts3.LogLevel = {}));
      var Debug;
      (function(Debug2) {
        var typeScriptVersion;
        var currentAssertionLevel = 0;
        Debug2.currentLogLevel = LogLevel.Warning;
        Debug2.isDebugging = false;
        function getTypeScriptVersion() {
          return typeScriptVersion !== null && typeScriptVersion !== void 0 ? typeScriptVersion : typeScriptVersion = new ts3.Version(ts3.version);
        }
        Debug2.getTypeScriptVersion = getTypeScriptVersion;
        function shouldLog(level) {
          return Debug2.currentLogLevel <= level;
        }
        Debug2.shouldLog = shouldLog;
        function logMessage(level, s2) {
          if (Debug2.loggingHost && shouldLog(level)) {
            Debug2.loggingHost.log(level, s2);
          }
        }
        function log(s2) {
          logMessage(LogLevel.Info, s2);
        }
        Debug2.log = log;
        (function(log_1) {
          function error(s2) {
            logMessage(LogLevel.Error, s2);
          }
          log_1.error = error;
          function warn(s2) {
            logMessage(LogLevel.Warning, s2);
          }
          log_1.warn = warn;
          function log2(s2) {
            logMessage(LogLevel.Info, s2);
          }
          log_1.log = log2;
          function trace(s2) {
            logMessage(LogLevel.Verbose, s2);
          }
          log_1.trace = trace;
        })(log = Debug2.log || (Debug2.log = {}));
        var assertionCache = {};
        function getAssertionLevel() {
          return currentAssertionLevel;
        }
        Debug2.getAssertionLevel = getAssertionLevel;
        function setAssertionLevel(level) {
          var prevAssertionLevel = currentAssertionLevel;
          currentAssertionLevel = level;
          if (level > prevAssertionLevel) {
            for (var _i = 0, _a2 = ts3.getOwnKeys(assertionCache); _i < _a2.length; _i++) {
              var key2 = _a2[_i];
              var cachedFunc = assertionCache[key2];
              if (cachedFunc !== void 0 && Debug2[key2] !== cachedFunc.assertion && level >= cachedFunc.level) {
                Debug2[key2] = cachedFunc;
                assertionCache[key2] = void 0;
              }
            }
          }
        }
        Debug2.setAssertionLevel = setAssertionLevel;
        function shouldAssert(level) {
          return currentAssertionLevel >= level;
        }
        Debug2.shouldAssert = shouldAssert;
        function shouldAssertFunction(level, name) {
          if (!shouldAssert(level)) {
            assertionCache[name] = { level, assertion: Debug2[name] };
            Debug2[name] = ts3.noop;
            return false;
          }
          return true;
        }
        function fail(message, stackCrawlMark) {
          debugger;
          var e2 = new Error(message ? "Debug Failure. " + message : "Debug Failure.");
          if (Error.captureStackTrace) {
            Error.captureStackTrace(e2, stackCrawlMark || fail);
          }
          throw e2;
        }
        Debug2.fail = fail;
        function failBadSyntaxKind(node, message, stackCrawlMark) {
          return fail((message || "Unexpected node.") + "\r\nNode " + formatSyntaxKind(node.kind) + " was unexpected.", stackCrawlMark || failBadSyntaxKind);
        }
        Debug2.failBadSyntaxKind = failBadSyntaxKind;
        function assert2(expression, message, verboseDebugInfo, stackCrawlMark) {
          if (!expression) {
            message = message ? "False expression: " + message : "False expression.";
            if (verboseDebugInfo) {
              message += "\r\nVerbose Debug Information: " + (typeof verboseDebugInfo === "string" ? verboseDebugInfo : verboseDebugInfo());
            }
            fail(message, stackCrawlMark || assert2);
          }
        }
        Debug2.assert = assert2;
        function assertEqual(a2, b2, msg, msg2, stackCrawlMark) {
          if (a2 !== b2) {
            var message = msg ? msg2 ? msg + " " + msg2 : msg : "";
            fail("Expected " + a2 + " === " + b2 + ". " + message, stackCrawlMark || assertEqual);
          }
        }
        Debug2.assertEqual = assertEqual;
        function assertLessThan(a2, b2, msg, stackCrawlMark) {
          if (a2 >= b2) {
            fail("Expected " + a2 + " < " + b2 + ". " + (msg || ""), stackCrawlMark || assertLessThan);
          }
        }
        Debug2.assertLessThan = assertLessThan;
        function assertLessThanOrEqual(a2, b2, stackCrawlMark) {
          if (a2 > b2) {
            fail("Expected " + a2 + " <= " + b2, stackCrawlMark || assertLessThanOrEqual);
          }
        }
        Debug2.assertLessThanOrEqual = assertLessThanOrEqual;
        function assertGreaterThanOrEqual(a2, b2, stackCrawlMark) {
          if (a2 < b2) {
            fail("Expected " + a2 + " >= " + b2, stackCrawlMark || assertGreaterThanOrEqual);
          }
        }
        Debug2.assertGreaterThanOrEqual = assertGreaterThanOrEqual;
        function assertIsDefined(value, message, stackCrawlMark) {
          if (value === void 0 || value === null) {
            fail(message, stackCrawlMark || assertIsDefined);
          }
        }
        Debug2.assertIsDefined = assertIsDefined;
        function checkDefined(value, message, stackCrawlMark) {
          assertIsDefined(value, message, stackCrawlMark || checkDefined);
          return value;
        }
        Debug2.checkDefined = checkDefined;
        Debug2.assertDefined = checkDefined;
        function assertEachIsDefined(value, message, stackCrawlMark) {
          for (var _i = 0, value_1 = value; _i < value_1.length; _i++) {
            var v = value_1[_i];
            assertIsDefined(v, message, stackCrawlMark || assertEachIsDefined);
          }
        }
        Debug2.assertEachIsDefined = assertEachIsDefined;
        function checkEachDefined(value, message, stackCrawlMark) {
          assertEachIsDefined(value, message, stackCrawlMark || checkEachDefined);
          return value;
        }
        Debug2.checkEachDefined = checkEachDefined;
        Debug2.assertEachDefined = checkEachDefined;
        function assertNever(member, message, stackCrawlMark) {
          if (message === void 0) {
            message = "Illegal value:";
          }
          var detail = typeof member === "object" && ts3.hasProperty(member, "kind") && ts3.hasProperty(member, "pos") && formatSyntaxKind ? "SyntaxKind: " + formatSyntaxKind(member.kind) : JSON.stringify(member);
          return fail(message + " " + detail, stackCrawlMark || assertNever);
        }
        Debug2.assertNever = assertNever;
        function assertEachNode(nodes, test, message, stackCrawlMark) {
          if (shouldAssertFunction(1, "assertEachNode")) {
            assert2(test === void 0 || ts3.every(nodes, test), message || "Unexpected node.", function() {
              return "Node array did not pass test '" + getFunctionName(test) + "'.";
            }, stackCrawlMark || assertEachNode);
          }
        }
        Debug2.assertEachNode = assertEachNode;
        function assertNode(node, test, message, stackCrawlMark) {
          if (shouldAssertFunction(1, "assertNode")) {
            assert2(node !== void 0 && (test === void 0 || test(node)), message || "Unexpected node.", function() {
              return "Node " + formatSyntaxKind(node.kind) + " did not pass test '" + getFunctionName(test) + "'.";
            }, stackCrawlMark || assertNode);
          }
        }
        Debug2.assertNode = assertNode;
        function assertNotNode(node, test, message, stackCrawlMark) {
          if (shouldAssertFunction(1, "assertNotNode")) {
            assert2(node === void 0 || test === void 0 || !test(node), message || "Unexpected node.", function() {
              return "Node " + formatSyntaxKind(node.kind) + " should not have passed test '" + getFunctionName(test) + "'.";
            }, stackCrawlMark || assertNotNode);
          }
        }
        Debug2.assertNotNode = assertNotNode;
        function assertOptionalNode(node, test, message, stackCrawlMark) {
          if (shouldAssertFunction(1, "assertOptionalNode")) {
            assert2(test === void 0 || node === void 0 || test(node), message || "Unexpected node.", function() {
              return "Node " + formatSyntaxKind(node.kind) + " did not pass test '" + getFunctionName(test) + "'.";
            }, stackCrawlMark || assertOptionalNode);
          }
        }
        Debug2.assertOptionalNode = assertOptionalNode;
        function assertOptionalToken(node, kind, message, stackCrawlMark) {
          if (shouldAssertFunction(1, "assertOptionalToken")) {
            assert2(kind === void 0 || node === void 0 || node.kind === kind, message || "Unexpected node.", function() {
              return "Node " + formatSyntaxKind(node.kind) + " was not a '" + formatSyntaxKind(kind) + "' token.";
            }, stackCrawlMark || assertOptionalToken);
          }
        }
        Debug2.assertOptionalToken = assertOptionalToken;
        function assertMissingNode(node, message, stackCrawlMark) {
          if (shouldAssertFunction(1, "assertMissingNode")) {
            assert2(node === void 0, message || "Unexpected node.", function() {
              return "Node " + formatSyntaxKind(node.kind) + " was unexpected'.";
            }, stackCrawlMark || assertMissingNode);
          }
        }
        Debug2.assertMissingNode = assertMissingNode;
        function type3(_value) {
        }
        Debug2.type = type3;
        function getFunctionName(func2) {
          if (typeof func2 !== "function") {
            return "";
          } else if (func2.hasOwnProperty("name")) {
            return func2.name;
          } else {
            var text = Function.prototype.toString.call(func2);
            var match = /^function\s+([\w\$]+)\s*\(/.exec(text);
            return match ? match[1] : "";
          }
        }
        Debug2.getFunctionName = getFunctionName;
        function formatSymbol(symbol) {
          return "{ name: " + ts3.unescapeLeadingUnderscores(symbol.escapedName) + "; flags: " + formatSymbolFlags(symbol.flags) + "; declarations: " + ts3.map(symbol.declarations, function(node) {
            return formatSyntaxKind(node.kind);
          }) + " }";
        }
        Debug2.formatSymbol = formatSymbol;
        function formatEnum(value, enumObject, isFlags) {
          if (value === void 0) {
            value = 0;
          }
          var members = getEnumMembers(enumObject);
          if (value === 0) {
            return members.length > 0 && members[0][0] === 0 ? members[0][1] : "0";
          }
          if (isFlags) {
            var result2 = "";
            var remainingFlags = value;
            for (var _i = 0, members_1 = members; _i < members_1.length; _i++) {
              var _a2 = members_1[_i], enumValue = _a2[0], enumName = _a2[1];
              if (enumValue > value) {
                break;
              }
              if (enumValue !== 0 && enumValue & value) {
                result2 = "" + result2 + (result2 ? "|" : "") + enumName;
                remainingFlags &= ~enumValue;
              }
            }
            if (remainingFlags === 0) {
              return result2;
            }
          } else {
            for (var _b = 0, members_2 = members; _b < members_2.length; _b++) {
              var _c = members_2[_b], enumValue = _c[0], enumName = _c[1];
              if (enumValue === value) {
                return enumName;
              }
            }
          }
          return value.toString();
        }
        Debug2.formatEnum = formatEnum;
        function getEnumMembers(enumObject) {
          var result2 = [];
          for (var name in enumObject) {
            var value = enumObject[name];
            if (typeof value === "number") {
              result2.push([value, name]);
            }
          }
          return ts3.stableSort(result2, function(x, y2) {
            return ts3.compareValues(x[0], y2[0]);
          });
        }
        function formatSyntaxKind(kind) {
          return formatEnum(kind, ts3.SyntaxKind, false);
        }
        Debug2.formatSyntaxKind = formatSyntaxKind;
        function formatNodeFlags(flags) {
          return formatEnum(flags, ts3.NodeFlags, true);
        }
        Debug2.formatNodeFlags = formatNodeFlags;
        function formatModifierFlags(flags) {
          return formatEnum(flags, ts3.ModifierFlags, true);
        }
        Debug2.formatModifierFlags = formatModifierFlags;
        function formatTransformFlags(flags) {
          return formatEnum(flags, ts3.TransformFlags, true);
        }
        Debug2.formatTransformFlags = formatTransformFlags;
        function formatEmitFlags(flags) {
          return formatEnum(flags, ts3.EmitFlags, true);
        }
        Debug2.formatEmitFlags = formatEmitFlags;
        function formatSymbolFlags(flags) {
          return formatEnum(flags, ts3.SymbolFlags, true);
        }
        Debug2.formatSymbolFlags = formatSymbolFlags;
        function formatTypeFlags(flags) {
          return formatEnum(flags, ts3.TypeFlags, true);
        }
        Debug2.formatTypeFlags = formatTypeFlags;
        function formatSignatureFlags(flags) {
          return formatEnum(flags, ts3.SignatureFlags, true);
        }
        Debug2.formatSignatureFlags = formatSignatureFlags;
        function formatObjectFlags(flags) {
          return formatEnum(flags, ts3.ObjectFlags, true);
        }
        Debug2.formatObjectFlags = formatObjectFlags;
        function formatFlowFlags(flags) {
          return formatEnum(flags, ts3.FlowFlags, true);
        }
        Debug2.formatFlowFlags = formatFlowFlags;
        var isDebugInfoEnabled = false;
        var extendedDebugModule;
        function extendedDebug() {
          enableDebugInfo();
          if (!extendedDebugModule) {
            throw new Error("Debugging helpers could not be loaded.");
          }
          return extendedDebugModule;
        }
        function printControlFlowGraph(flowNode) {
          return console.log(formatControlFlowGraph(flowNode));
        }
        Debug2.printControlFlowGraph = printControlFlowGraph;
        function formatControlFlowGraph(flowNode) {
          return extendedDebug().formatControlFlowGraph(flowNode);
        }
        Debug2.formatControlFlowGraph = formatControlFlowGraph;
        var flowNodeProto;
        function attachFlowNodeDebugInfoWorker(flowNode) {
          if (!("__debugFlowFlags" in flowNode)) {
            Object.defineProperties(flowNode, {
              __tsDebuggerDisplay: {
                value: function() {
                  var flowHeader = this.flags & 2 ? "FlowStart" : this.flags & 4 ? "FlowBranchLabel" : this.flags & 8 ? "FlowLoopLabel" : this.flags & 16 ? "FlowAssignment" : this.flags & 32 ? "FlowTrueCondition" : this.flags & 64 ? "FlowFalseCondition" : this.flags & 128 ? "FlowSwitchClause" : this.flags & 256 ? "FlowArrayMutation" : this.flags & 512 ? "FlowCall" : this.flags & 1024 ? "FlowReduceLabel" : this.flags & 1 ? "FlowUnreachable" : "UnknownFlow";
                  var remainingFlags = this.flags & ~(2048 - 1);
                  return "" + flowHeader + (remainingFlags ? " (" + formatFlowFlags(remainingFlags) + ")" : "");
                }
              },
              __debugFlowFlags: { get: function() {
                return formatEnum(this.flags, ts3.FlowFlags, true);
              } },
              __debugToString: { value: function() {
                return formatControlFlowGraph(this);
              } }
            });
          }
        }
        function attachFlowNodeDebugInfo(flowNode) {
          if (isDebugInfoEnabled) {
            if (typeof Object.setPrototypeOf === "function") {
              if (!flowNodeProto) {
                flowNodeProto = Object.create(Object.prototype);
                attachFlowNodeDebugInfoWorker(flowNodeProto);
              }
              Object.setPrototypeOf(flowNode, flowNodeProto);
            } else {
              attachFlowNodeDebugInfoWorker(flowNode);
            }
          }
        }
        Debug2.attachFlowNodeDebugInfo = attachFlowNodeDebugInfo;
        var nodeArrayProto;
        function attachNodeArrayDebugInfoWorker(array) {
          if (!("__tsDebuggerDisplay" in array)) {
            Object.defineProperties(array, {
              __tsDebuggerDisplay: {
                value: function(defaultValue) {
                  defaultValue = String(defaultValue).replace(/(?:,[\s\w\d_]+:[^,]+)+\]$/, "]");
                  return "NodeArray " + defaultValue;
                }
              }
            });
          }
        }
        function attachNodeArrayDebugInfo(array) {
          if (isDebugInfoEnabled) {
            if (typeof Object.setPrototypeOf === "function") {
              if (!nodeArrayProto) {
                nodeArrayProto = Object.create(Array.prototype);
                attachNodeArrayDebugInfoWorker(nodeArrayProto);
              }
              Object.setPrototypeOf(array, nodeArrayProto);
            } else {
              attachNodeArrayDebugInfoWorker(array);
            }
          }
        }
        Debug2.attachNodeArrayDebugInfo = attachNodeArrayDebugInfo;
        function enableDebugInfo() {
          if (isDebugInfoEnabled)
            return;
          var weakTypeTextMap;
          var weakNodeTextMap;
          function getWeakTypeTextMap() {
            if (weakTypeTextMap === void 0) {
              if (typeof WeakMap === "function")
                weakTypeTextMap = new WeakMap();
            }
            return weakTypeTextMap;
          }
          function getWeakNodeTextMap() {
            if (weakNodeTextMap === void 0) {
              if (typeof WeakMap === "function")
                weakNodeTextMap = new WeakMap();
            }
            return weakNodeTextMap;
          }
          Object.defineProperties(ts3.objectAllocator.getSymbolConstructor().prototype, {
            __tsDebuggerDisplay: {
              value: function() {
                var symbolHeader = this.flags & 33554432 ? "TransientSymbol" : "Symbol";
                var remainingSymbolFlags = this.flags & ~33554432;
                return symbolHeader + " '" + ts3.symbolName(this) + "'" + (remainingSymbolFlags ? " (" + formatSymbolFlags(remainingSymbolFlags) + ")" : "");
              }
            },
            __debugFlags: { get: function() {
              return formatSymbolFlags(this.flags);
            } }
          });
          Object.defineProperties(ts3.objectAllocator.getTypeConstructor().prototype, {
            __tsDebuggerDisplay: {
              value: function() {
                var typeHeader = this.flags & 98304 ? "NullableType" : this.flags & 384 ? "LiteralType " + JSON.stringify(this.value) : this.flags & 2048 ? "LiteralType " + (this.value.negative ? "-" : "") + this.value.base10Value + "n" : this.flags & 8192 ? "UniqueESSymbolType" : this.flags & 32 ? "EnumType" : this.flags & 67359327 ? "IntrinsicType " + this.intrinsicName : this.flags & 1048576 ? "UnionType" : this.flags & 2097152 ? "IntersectionType" : this.flags & 4194304 ? "IndexType" : this.flags & 8388608 ? "IndexedAccessType" : this.flags & 16777216 ? "ConditionalType" : this.flags & 33554432 ? "SubstitutionType" : this.flags & 262144 ? "TypeParameter" : this.flags & 524288 ? this.objectFlags & 3 ? "InterfaceType" : this.objectFlags & 4 ? "TypeReference" : this.objectFlags & 8 ? "TupleType" : this.objectFlags & 16 ? "AnonymousType" : this.objectFlags & 32 ? "MappedType" : this.objectFlags & 1024 ? "ReverseMappedType" : this.objectFlags & 256 ? "EvolvingArrayType" : "ObjectType" : "Type";
                var remainingObjectFlags = this.flags & 524288 ? this.objectFlags & ~1343 : 0;
                return "" + typeHeader + (this.symbol ? " '" + ts3.symbolName(this.symbol) + "'" : "") + (remainingObjectFlags ? " (" + formatObjectFlags(remainingObjectFlags) + ")" : "");
              }
            },
            __debugFlags: { get: function() {
              return formatTypeFlags(this.flags);
            } },
            __debugObjectFlags: { get: function() {
              return this.flags & 524288 ? formatObjectFlags(this.objectFlags) : "";
            } },
            __debugTypeToString: {
              value: function() {
                var map2 = getWeakTypeTextMap();
                var text = map2 === null || map2 === void 0 ? void 0 : map2.get(this);
                if (text === void 0) {
                  text = this.checker.typeToString(this);
                  map2 === null || map2 === void 0 ? void 0 : map2.set(this, text);
                }
                return text;
              }
            }
          });
          Object.defineProperties(ts3.objectAllocator.getSignatureConstructor().prototype, {
            __debugFlags: { get: function() {
              return formatSignatureFlags(this.flags);
            } },
            __debugSignatureToString: { value: function() {
              var _a2;
              return (_a2 = this.checker) === null || _a2 === void 0 ? void 0 : _a2.signatureToString(this);
            } }
          });
          var nodeConstructors = [
            ts3.objectAllocator.getNodeConstructor(),
            ts3.objectAllocator.getIdentifierConstructor(),
            ts3.objectAllocator.getTokenConstructor(),
            ts3.objectAllocator.getSourceFileConstructor()
          ];
          for (var _i = 0, nodeConstructors_1 = nodeConstructors; _i < nodeConstructors_1.length; _i++) {
            var ctor = nodeConstructors_1[_i];
            if (!ctor.prototype.hasOwnProperty("__debugKind")) {
              Object.defineProperties(ctor.prototype, {
                __tsDebuggerDisplay: {
                  value: function() {
                    var nodeHeader = ts3.isGeneratedIdentifier(this) ? "GeneratedIdentifier" : ts3.isIdentifier(this) ? "Identifier '" + ts3.idText(this) + "'" : ts3.isPrivateIdentifier(this) ? "PrivateIdentifier '" + ts3.idText(this) + "'" : ts3.isStringLiteral(this) ? "StringLiteral " + JSON.stringify(this.text.length < 10 ? this.text : this.text.slice(10) + "...") : ts3.isNumericLiteral(this) ? "NumericLiteral " + this.text : ts3.isBigIntLiteral(this) ? "BigIntLiteral " + this.text + "n" : ts3.isTypeParameterDeclaration(this) ? "TypeParameterDeclaration" : ts3.isParameter(this) ? "ParameterDeclaration" : ts3.isConstructorDeclaration(this) ? "ConstructorDeclaration" : ts3.isGetAccessorDeclaration(this) ? "GetAccessorDeclaration" : ts3.isSetAccessorDeclaration(this) ? "SetAccessorDeclaration" : ts3.isCallSignatureDeclaration(this) ? "CallSignatureDeclaration" : ts3.isConstructSignatureDeclaration(this) ? "ConstructSignatureDeclaration" : ts3.isIndexSignatureDeclaration(this) ? "IndexSignatureDeclaration" : ts3.isTypePredicateNode(this) ? "TypePredicateNode" : ts3.isTypeReferenceNode(this) ? "TypeReferenceNode" : ts3.isFunctionTypeNode(this) ? "FunctionTypeNode" : ts3.isConstructorTypeNode(this) ? "ConstructorTypeNode" : ts3.isTypeQueryNode(this) ? "TypeQueryNode" : ts3.isTypeLiteralNode(this) ? "TypeLiteralNode" : ts3.isArrayTypeNode(this) ? "ArrayTypeNode" : ts3.isTupleTypeNode(this) ? "TupleTypeNode" : ts3.isOptionalTypeNode(this) ? "OptionalTypeNode" : ts3.isRestTypeNode(this) ? "RestTypeNode" : ts3.isUnionTypeNode(this) ? "UnionTypeNode" : ts3.isIntersectionTypeNode(this) ? "IntersectionTypeNode" : ts3.isConditionalTypeNode(this) ? "ConditionalTypeNode" : ts3.isInferTypeNode(this) ? "InferTypeNode" : ts3.isParenthesizedTypeNode(this) ? "ParenthesizedTypeNode" : ts3.isThisTypeNode(this) ? "ThisTypeNode" : ts3.isTypeOperatorNode(this) ? "TypeOperatorNode" : ts3.isIndexedAccessTypeNode(this) ? "IndexedAccessTypeNode" : ts3.isMappedTypeNode(this) ? "MappedTypeNode" : ts3.isLiteralTypeNode(this) ? "LiteralTypeNode" : ts3.isNamedTupleMember(this) ? "NamedTupleMember" : ts3.isImportTypeNode(this) ? "ImportTypeNode" : formatSyntaxKind(this.kind);
                    return "" + nodeHeader + (this.flags ? " (" + formatNodeFlags(this.flags) + ")" : "");
                  }
                },
                __debugKind: { get: function() {
                  return formatSyntaxKind(this.kind);
                } },
                __debugNodeFlags: { get: function() {
                  return formatNodeFlags(this.flags);
                } },
                __debugModifierFlags: { get: function() {
                  return formatModifierFlags(ts3.getEffectiveModifierFlagsNoCache(this));
                } },
                __debugTransformFlags: { get: function() {
                  return formatTransformFlags(this.transformFlags);
                } },
                __debugIsParseTreeNode: { get: function() {
                  return ts3.isParseTreeNode(this);
                } },
                __debugEmitFlags: { get: function() {
                  return formatEmitFlags(ts3.getEmitFlags(this));
                } },
                __debugGetText: {
                  value: function(includeTrivia) {
                    if (ts3.nodeIsSynthesized(this))
                      return "";
                    var map2 = getWeakNodeTextMap();
                    var text = map2 === null || map2 === void 0 ? void 0 : map2.get(this);
                    if (text === void 0) {
                      var parseNode = ts3.getParseTreeNode(this);
                      var sourceFile = parseNode && ts3.getSourceFileOfNode(parseNode);
                      text = sourceFile ? ts3.getSourceTextOfNodeFromSourceFile(sourceFile, parseNode, includeTrivia) : "";
                      map2 === null || map2 === void 0 ? void 0 : map2.set(this, text);
                    }
                    return text;
                  }
                }
              });
            }
          }
          try {
            if (ts3.sys && ts3.sys.require) {
              var basePath = ts3.getDirectoryPath(ts3.resolvePath(ts3.sys.getExecutingFilePath()));
              var result2 = ts3.sys.require(basePath, "./compiler-debug");
              if (!result2.error) {
                result2.module.init(ts3);
                extendedDebugModule = result2.module;
              }
            }
          } catch (_a2) {
          }
          isDebugInfoEnabled = true;
        }
        Debug2.enableDebugInfo = enableDebugInfo;
        function formatDeprecationMessage(name, error, errorAfter, since, message) {
          var deprecationMessage = error ? "DeprecationError: " : "DeprecationWarning: ";
          deprecationMessage += "'" + name + "' ";
          deprecationMessage += since ? "has been deprecated since v" + since : "is deprecated";
          deprecationMessage += error ? " and can no longer be used." : errorAfter ? " and will no longer be usable after v" + errorAfter + "." : ".";
          deprecationMessage += message ? " " + ts3.formatStringFromArgs(message, [name], 0) : "";
          return deprecationMessage;
        }
        function createErrorDeprecation(name, errorAfter, since, message) {
          var deprecationMessage = formatDeprecationMessage(name, true, errorAfter, since, message);
          return function() {
            throw new TypeError(deprecationMessage);
          };
        }
        function createWarningDeprecation(name, errorAfter, since, message) {
          var hasWrittenDeprecation = false;
          return function() {
            if (!hasWrittenDeprecation) {
              log.warn(formatDeprecationMessage(name, false, errorAfter, since, message));
              hasWrittenDeprecation = true;
            }
          };
        }
        function createDeprecation(name, options) {
          var _a2, _b;
          if (options === void 0) {
            options = {};
          }
          var version = typeof options.typeScriptVersion === "string" ? new ts3.Version(options.typeScriptVersion) : (_a2 = options.typeScriptVersion) !== null && _a2 !== void 0 ? _a2 : getTypeScriptVersion();
          var errorAfter = typeof options.errorAfter === "string" ? new ts3.Version(options.errorAfter) : options.errorAfter;
          var warnAfter = typeof options.warnAfter === "string" ? new ts3.Version(options.warnAfter) : options.warnAfter;
          var since = typeof options.since === "string" ? new ts3.Version(options.since) : (_b = options.since) !== null && _b !== void 0 ? _b : warnAfter;
          var error = options.error || errorAfter && version.compareTo(errorAfter) <= 0;
          var warn = !warnAfter || version.compareTo(warnAfter) >= 0;
          return error ? createErrorDeprecation(name, errorAfter, since, options.message) : warn ? createWarningDeprecation(name, errorAfter, since, options.message) : ts3.noop;
        }
        function wrapFunction(deprecation, func2) {
          return function() {
            deprecation();
            return func2.apply(this, arguments);
          };
        }
        function deprecate(func2, options) {
          var deprecation = createDeprecation(getFunctionName(func2), options);
          return wrapFunction(deprecation, func2);
        }
        Debug2.deprecate = deprecate;
      })(Debug = ts3.Debug || (ts3.Debug = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var versionRegExp = /^(0|[1-9]\d*)(?:\.(0|[1-9]\d*)(?:\.(0|[1-9]\d*)(?:\-([a-z0-9-.]+))?(?:\+([a-z0-9-.]+))?)?)?$/i;
      var prereleaseRegExp = /^(?:0|[1-9]\d*|[a-z-][a-z0-9-]*)(?:\.(?:0|[1-9]\d*|[a-z-][a-z0-9-]*))*$/i;
      var buildRegExp = /^[a-z0-9-]+(?:\.[a-z0-9-]+)*$/i;
      var numericIdentifierRegExp = /^(0|[1-9]\d*)$/;
      var Version = function() {
        function Version2(major, minor, patch, prerelease, build) {
          if (minor === void 0) {
            minor = 0;
          }
          if (patch === void 0) {
            patch = 0;
          }
          if (prerelease === void 0) {
            prerelease = "";
          }
          if (build === void 0) {
            build = "";
          }
          if (typeof major === "string") {
            var result2 = ts3.Debug.checkDefined(tryParseComponents(major), "Invalid version");
            major = result2.major, minor = result2.minor, patch = result2.patch, prerelease = result2.prerelease, build = result2.build;
          }
          ts3.Debug.assert(major >= 0, "Invalid argument: major");
          ts3.Debug.assert(minor >= 0, "Invalid argument: minor");
          ts3.Debug.assert(patch >= 0, "Invalid argument: patch");
          ts3.Debug.assert(!prerelease || prereleaseRegExp.test(prerelease), "Invalid argument: prerelease");
          ts3.Debug.assert(!build || buildRegExp.test(build), "Invalid argument: build");
          this.major = major;
          this.minor = minor;
          this.patch = patch;
          this.prerelease = prerelease ? prerelease.split(".") : ts3.emptyArray;
          this.build = build ? build.split(".") : ts3.emptyArray;
        }
        Version2.tryParse = function(text) {
          var result2 = tryParseComponents(text);
          if (!result2)
            return void 0;
          var major = result2.major, minor = result2.minor, patch = result2.patch, prerelease = result2.prerelease, build = result2.build;
          return new Version2(major, minor, patch, prerelease, build);
        };
        Version2.prototype.compareTo = function(other) {
          if (this === other)
            return 0;
          if (other === void 0)
            return 1;
          return ts3.compareValues(this.major, other.major) || ts3.compareValues(this.minor, other.minor) || ts3.compareValues(this.patch, other.patch) || comparePrereleaseIdentifiers(this.prerelease, other.prerelease);
        };
        Version2.prototype.increment = function(field) {
          switch (field) {
            case "major":
              return new Version2(this.major + 1, 0, 0);
            case "minor":
              return new Version2(this.major, this.minor + 1, 0);
            case "patch":
              return new Version2(this.major, this.minor, this.patch + 1);
            default:
              return ts3.Debug.assertNever(field);
          }
        };
        Version2.prototype.toString = function() {
          var result2 = this.major + "." + this.minor + "." + this.patch;
          if (ts3.some(this.prerelease))
            result2 += "-" + this.prerelease.join(".");
          if (ts3.some(this.build))
            result2 += "+" + this.build.join(".");
          return result2;
        };
        Version2.zero = new Version2(0, 0, 0);
        return Version2;
      }();
      ts3.Version = Version;
      function tryParseComponents(text) {
        var match = versionRegExp.exec(text);
        if (!match)
          return void 0;
        var major = match[1], _a2 = match[2], minor = _a2 === void 0 ? "0" : _a2, _b = match[3], patch = _b === void 0 ? "0" : _b, _c = match[4], prerelease = _c === void 0 ? "" : _c, _d = match[5], build = _d === void 0 ? "" : _d;
        if (prerelease && !prereleaseRegExp.test(prerelease))
          return void 0;
        if (build && !buildRegExp.test(build))
          return void 0;
        return {
          major: parseInt(major, 10),
          minor: parseInt(minor, 10),
          patch: parseInt(patch, 10),
          prerelease,
          build
        };
      }
      function comparePrereleaseIdentifiers(left, right) {
        if (left === right)
          return 0;
        if (left.length === 0)
          return right.length === 0 ? 0 : 1;
        if (right.length === 0)
          return -1;
        var length = Math.min(left.length, right.length);
        for (var i3 = 0; i3 < length; i3++) {
          var leftIdentifier = left[i3];
          var rightIdentifier = right[i3];
          if (leftIdentifier === rightIdentifier)
            continue;
          var leftIsNumeric = numericIdentifierRegExp.test(leftIdentifier);
          var rightIsNumeric = numericIdentifierRegExp.test(rightIdentifier);
          if (leftIsNumeric || rightIsNumeric) {
            if (leftIsNumeric !== rightIsNumeric)
              return leftIsNumeric ? -1 : 1;
            var result2 = ts3.compareValues(+leftIdentifier, +rightIdentifier);
            if (result2)
              return result2;
          } else {
            var result2 = ts3.compareStringsCaseSensitive(leftIdentifier, rightIdentifier);
            if (result2)
              return result2;
          }
        }
        return ts3.compareValues(left.length, right.length);
      }
      var VersionRange = function() {
        function VersionRange2(spec) {
          this._alternatives = spec ? ts3.Debug.checkDefined(parseRange(spec), "Invalid range spec.") : ts3.emptyArray;
        }
        VersionRange2.tryParse = function(text) {
          var sets = parseRange(text);
          if (sets) {
            var range = new VersionRange2("");
            range._alternatives = sets;
            return range;
          }
          return void 0;
        };
        VersionRange2.prototype.test = function(version) {
          if (typeof version === "string")
            version = new Version(version);
          return testDisjunction(version, this._alternatives);
        };
        VersionRange2.prototype.toString = function() {
          return formatDisjunction(this._alternatives);
        };
        return VersionRange2;
      }();
      ts3.VersionRange = VersionRange;
      var logicalOrRegExp = /\s*\|\|\s*/g;
      var whitespaceRegExp = /\s+/g;
      var partialRegExp = /^([xX*0]|[1-9]\d*)(?:\.([xX*0]|[1-9]\d*)(?:\.([xX*0]|[1-9]\d*)(?:-([a-z0-9-.]+))?(?:\+([a-z0-9-.]+))?)?)?$/i;
      var hyphenRegExp = /^\s*([a-z0-9-+.*]+)\s+-\s+([a-z0-9-+.*]+)\s*$/i;
      var rangeRegExp = /^\s*(~|\^|<|<=|>|>=|=)?\s*([a-z0-9-+.*]+)$/i;
      function parseRange(text) {
        var alternatives = [];
        for (var _i = 0, _a2 = text.trim().split(logicalOrRegExp); _i < _a2.length; _i++) {
          var range = _a2[_i];
          if (!range)
            continue;
          var comparators = [];
          var match = hyphenRegExp.exec(range);
          if (match) {
            if (!parseHyphen(match[1], match[2], comparators))
              return void 0;
          } else {
            for (var _b = 0, _c = range.split(whitespaceRegExp); _b < _c.length; _b++) {
              var simple = _c[_b];
              var match_1 = rangeRegExp.exec(simple);
              if (!match_1 || !parseComparator(match_1[1], match_1[2], comparators))
                return void 0;
            }
          }
          alternatives.push(comparators);
        }
        return alternatives;
      }
      function parsePartial(text) {
        var match = partialRegExp.exec(text);
        if (!match)
          return void 0;
        var major = match[1], _a2 = match[2], minor = _a2 === void 0 ? "*" : _a2, _b = match[3], patch = _b === void 0 ? "*" : _b, prerelease = match[4], build = match[5];
        var version = new Version(isWildcard(major) ? 0 : parseInt(major, 10), isWildcard(major) || isWildcard(minor) ? 0 : parseInt(minor, 10), isWildcard(major) || isWildcard(minor) || isWildcard(patch) ? 0 : parseInt(patch, 10), prerelease, build);
        return { version, major, minor, patch };
      }
      function parseHyphen(left, right, comparators) {
        var leftResult = parsePartial(left);
        if (!leftResult)
          return false;
        var rightResult = parsePartial(right);
        if (!rightResult)
          return false;
        if (!isWildcard(leftResult.major)) {
          comparators.push(createComparator(">=", leftResult.version));
        }
        if (!isWildcard(rightResult.major)) {
          comparators.push(isWildcard(rightResult.minor) ? createComparator("<", rightResult.version.increment("major")) : isWildcard(rightResult.patch) ? createComparator("<", rightResult.version.increment("minor")) : createComparator("<=", rightResult.version));
        }
        return true;
      }
      function parseComparator(operator, text, comparators) {
        var result2 = parsePartial(text);
        if (!result2)
          return false;
        var version = result2.version, major = result2.major, minor = result2.minor, patch = result2.patch;
        if (!isWildcard(major)) {
          switch (operator) {
            case "~":
              comparators.push(createComparator(">=", version));
              comparators.push(createComparator("<", version.increment(isWildcard(minor) ? "major" : "minor")));
              break;
            case "^":
              comparators.push(createComparator(">=", version));
              comparators.push(createComparator("<", version.increment(version.major > 0 || isWildcard(minor) ? "major" : version.minor > 0 || isWildcard(patch) ? "minor" : "patch")));
              break;
            case "<":
            case ">=":
              comparators.push(createComparator(operator, version));
              break;
            case "<=":
            case ">":
              comparators.push(isWildcard(minor) ? createComparator(operator === "<=" ? "<" : ">=", version.increment("major")) : isWildcard(patch) ? createComparator(operator === "<=" ? "<" : ">=", version.increment("minor")) : createComparator(operator, version));
              break;
            case "=":
            case void 0:
              if (isWildcard(minor) || isWildcard(patch)) {
                comparators.push(createComparator(">=", version));
                comparators.push(createComparator("<", version.increment(isWildcard(minor) ? "major" : "minor")));
              } else {
                comparators.push(createComparator("=", version));
              }
              break;
            default:
              return false;
          }
        } else if (operator === "<" || operator === ">") {
          comparators.push(createComparator("<", Version.zero));
        }
        return true;
      }
      function isWildcard(part) {
        return part === "*" || part === "x" || part === "X";
      }
      function createComparator(operator, operand) {
        return { operator, operand };
      }
      function testDisjunction(version, alternatives) {
        if (alternatives.length === 0)
          return true;
        for (var _i = 0, alternatives_1 = alternatives; _i < alternatives_1.length; _i++) {
          var alternative = alternatives_1[_i];
          if (testAlternative(version, alternative))
            return true;
        }
        return false;
      }
      function testAlternative(version, comparators) {
        for (var _i = 0, comparators_1 = comparators; _i < comparators_1.length; _i++) {
          var comparator = comparators_1[_i];
          if (!testComparator(version, comparator.operator, comparator.operand))
            return false;
        }
        return true;
      }
      function testComparator(version, operator, operand) {
        var cmp = version.compareTo(operand);
        switch (operator) {
          case "<":
            return cmp < 0;
          case "<=":
            return cmp <= 0;
          case ">":
            return cmp > 0;
          case ">=":
            return cmp >= 0;
          case "=":
            return cmp === 0;
          default:
            return ts3.Debug.assertNever(operator);
        }
      }
      function formatDisjunction(alternatives) {
        return ts3.map(alternatives, formatAlternative).join(" || ") || "*";
      }
      function formatAlternative(comparators) {
        return ts3.map(comparators, formatComparator).join(" ");
      }
      function formatComparator(comparator) {
        return "" + comparator.operator + comparator.operand;
      }
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      function hasRequiredAPI(performance2, PerformanceObserver2) {
        return typeof performance2 === "object" && typeof performance2.timeOrigin === "number" && typeof performance2.mark === "function" && typeof performance2.measure === "function" && typeof performance2.now === "function" && typeof PerformanceObserver2 === "function";
      }
      function tryGetWebPerformanceHooks() {
        if (typeof performance === "object" && typeof PerformanceObserver === "function" && hasRequiredAPI(performance, PerformanceObserver)) {
          return {
            shouldWriteNativeEvents: true,
            performance,
            PerformanceObserver
          };
        }
      }
      function tryGetNodePerformanceHooks() {
        if (typeof process !== "undefined" && process.nextTick && !process.browser && typeof module2 === "object" && typeof require === "function") {
          try {
            var performance_1;
            var _a2 = require("perf_hooks"), nodePerformance_1 = _a2.performance, PerformanceObserver_1 = _a2.PerformanceObserver;
            if (hasRequiredAPI(nodePerformance_1, PerformanceObserver_1)) {
              performance_1 = nodePerformance_1;
              var version_1 = new ts3.Version(process.versions.node);
              var range = new ts3.VersionRange("<12.16.3 || 13 <13.13");
              if (range.test(version_1)) {
                performance_1 = {
                  get timeOrigin() {
                    return nodePerformance_1.timeOrigin;
                  },
                  now: function() {
                    return nodePerformance_1.now();
                  },
                  mark: function(name) {
                    return nodePerformance_1.mark(name);
                  },
                  measure: function(name, start, end) {
                    if (start === void 0) {
                      start = "nodeStart";
                    }
                    if (end === void 0) {
                      end = "__performance.measure-fix__";
                      nodePerformance_1.mark(end);
                    }
                    nodePerformance_1.measure(name, start, end);
                    if (end === "__performance.measure-fix__") {
                      nodePerformance_1.clearMarks("__performance.measure-fix__");
                    }
                  }
                };
              }
              return {
                shouldWriteNativeEvents: false,
                performance: performance_1,
                PerformanceObserver: PerformanceObserver_1
              };
            }
          } catch (_b) {
          }
        }
      }
      var nativePerformanceHooks = tryGetWebPerformanceHooks() || tryGetNodePerformanceHooks();
      var nativePerformance = nativePerformanceHooks === null || nativePerformanceHooks === void 0 ? void 0 : nativePerformanceHooks.performance;
      function tryGetNativePerformanceHooks() {
        return nativePerformanceHooks;
      }
      ts3.tryGetNativePerformanceHooks = tryGetNativePerformanceHooks;
      ts3.timestamp = nativePerformance ? function() {
        return nativePerformance.now();
      } : Date.now ? Date.now : function() {
        return +new Date();
      };
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var performance2;
      (function(performance3) {
        var perfHooks;
        var performanceImpl;
        function createTimerIf(condition, measureName, startMarkName, endMarkName) {
          return condition ? createTimer(measureName, startMarkName, endMarkName) : performance3.nullTimer;
        }
        performance3.createTimerIf = createTimerIf;
        function createTimer(measureName, startMarkName, endMarkName) {
          var enterCount = 0;
          return {
            enter,
            exit: exit2
          };
          function enter() {
            if (++enterCount === 1) {
              mark(startMarkName);
            }
          }
          function exit2() {
            if (--enterCount === 0) {
              mark(endMarkName);
              measure(measureName, startMarkName, endMarkName);
            } else if (enterCount < 0) {
              ts3.Debug.fail("enter/exit count does not match.");
            }
          }
        }
        performance3.createTimer = createTimer;
        performance3.nullTimer = { enter: ts3.noop, exit: ts3.noop };
        var enabled = false;
        var timeorigin = ts3.timestamp();
        var marks = new ts3.Map();
        var counts = new ts3.Map();
        var durations = new ts3.Map();
        function mark(markName) {
          var _a2;
          if (enabled) {
            var count = (_a2 = counts.get(markName)) !== null && _a2 !== void 0 ? _a2 : 0;
            counts.set(markName, count + 1);
            marks.set(markName, ts3.timestamp());
            performanceImpl === null || performanceImpl === void 0 ? void 0 : performanceImpl.mark(markName);
          }
        }
        performance3.mark = mark;
        function measure(measureName, startMarkName, endMarkName) {
          var _a2, _b;
          if (enabled) {
            var end = (_a2 = endMarkName !== void 0 ? marks.get(endMarkName) : void 0) !== null && _a2 !== void 0 ? _a2 : ts3.timestamp();
            var start = (_b = startMarkName !== void 0 ? marks.get(startMarkName) : void 0) !== null && _b !== void 0 ? _b : timeorigin;
            var previousDuration = durations.get(measureName) || 0;
            durations.set(measureName, previousDuration + (end - start));
            performanceImpl === null || performanceImpl === void 0 ? void 0 : performanceImpl.measure(measureName, startMarkName, endMarkName);
          }
        }
        performance3.measure = measure;
        function getCount(markName) {
          return counts.get(markName) || 0;
        }
        performance3.getCount = getCount;
        function getDuration(measureName) {
          return durations.get(measureName) || 0;
        }
        performance3.getDuration = getDuration;
        function forEachMeasure(cb2) {
          durations.forEach(function(duration, measureName) {
            return cb2(measureName, duration);
          });
        }
        performance3.forEachMeasure = forEachMeasure;
        function isEnabled() {
          return enabled;
        }
        performance3.isEnabled = isEnabled;
        function enable(system) {
          var _a2;
          if (system === void 0) {
            system = ts3.sys;
          }
          if (!enabled) {
            enabled = true;
            perfHooks || (perfHooks = ts3.tryGetNativePerformanceHooks());
            if (perfHooks) {
              timeorigin = perfHooks.performance.timeOrigin;
              if (perfHooks.shouldWriteNativeEvents || ((_a2 = system === null || system === void 0 ? void 0 : system.cpuProfilingEnabled) === null || _a2 === void 0 ? void 0 : _a2.call(system)) || (system === null || system === void 0 ? void 0 : system.debugMode)) {
                performanceImpl = perfHooks.performance;
              }
            }
          }
          return true;
        }
        performance3.enable = enable;
        function disable() {
          if (enabled) {
            marks.clear();
            counts.clear();
            durations.clear();
            performanceImpl = void 0;
            enabled = false;
          }
        }
        performance3.disable = disable;
      })(performance2 = ts3.performance || (ts3.performance = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var _a2;
      var nullLogger = {
        logEvent: ts3.noop,
        logErrEvent: ts3.noop,
        logPerfEvent: ts3.noop,
        logInfoEvent: ts3.noop,
        logStartCommand: ts3.noop,
        logStopCommand: ts3.noop,
        logStartUpdateProgram: ts3.noop,
        logStopUpdateProgram: ts3.noop,
        logStartUpdateGraph: ts3.noop,
        logStopUpdateGraph: ts3.noop,
        logStartResolveModule: ts3.noop,
        logStopResolveModule: ts3.noop,
        logStartParseSourceFile: ts3.noop,
        logStopParseSourceFile: ts3.noop,
        logStartReadFile: ts3.noop,
        logStopReadFile: ts3.noop,
        logStartBindFile: ts3.noop,
        logStopBindFile: ts3.noop,
        logStartScheduledOperation: ts3.noop,
        logStopScheduledOperation: ts3.noop
      };
      var etwModule;
      try {
        var etwModulePath = (_a2 = process.env.TS_ETW_MODULE_PATH) !== null && _a2 !== void 0 ? _a2 : "./node_modules/@microsoft/typescript-etw";
        etwModule = require(etwModulePath);
      } catch (e2) {
        etwModule = void 0;
      }
      ts3.perfLogger = etwModule && etwModule.logEvent ? etwModule : nullLogger;
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var tracingEnabled;
      (function(tracingEnabled2) {
        var fs5;
        var traceCount = 0;
        var traceFd = 0;
        var mode;
        var typeCatalog = [];
        var legendPath;
        var legend = [];
        ;
        function startTracing(tracingMode, traceDir, configFilePath) {
          ts3.Debug.assert(!ts3.tracing, "Tracing already started");
          if (fs5 === void 0) {
            try {
              fs5 = require("fs");
            } catch (e2) {
              throw new Error("tracing requires having fs\n(original error: " + (e2.message || e2) + ")");
            }
          }
          mode = tracingMode;
          typeCatalog.length = 0;
          if (legendPath === void 0) {
            legendPath = ts3.combinePaths(traceDir, "legend.json");
          }
          if (!fs5.existsSync(traceDir)) {
            fs5.mkdirSync(traceDir, { recursive: true });
          }
          var countPart = mode === "build" ? "." + process.pid + "-" + ++traceCount : mode === "server" ? "." + process.pid : "";
          var tracePath = ts3.combinePaths(traceDir, "trace" + countPart + ".json");
          var typesPath = ts3.combinePaths(traceDir, "types" + countPart + ".json");
          legend.push({
            configFilePath,
            tracePath,
            typesPath
          });
          traceFd = fs5.openSync(tracePath, "w");
          ts3.tracing = tracingEnabled2;
          var meta = { cat: "__metadata", ph: "M", ts: 1e3 * ts3.timestamp(), pid: 1, tid: 1 };
          fs5.writeSync(traceFd, "[\n" + [__assign({ name: "process_name", args: { name: "tsc" } }, meta), __assign({ name: "thread_name", args: { name: "Main" } }, meta), __assign(__assign({ name: "TracingStartedInBrowser" }, meta), { cat: "disabled-by-default-devtools.timeline" })].map(function(v) {
            return JSON.stringify(v);
          }).join(",\n"));
        }
        tracingEnabled2.startTracing = startTracing;
        function stopTracing() {
          ts3.Debug.assert(ts3.tracing, "Tracing is not in progress");
          ts3.Debug.assert(!!typeCatalog.length === (mode !== "server"));
          fs5.writeSync(traceFd, "\n]\n");
          fs5.closeSync(traceFd);
          ts3.tracing = void 0;
          if (typeCatalog.length) {
            dumpTypes(typeCatalog);
          } else {
            legend[legend.length - 1].typesPath = void 0;
          }
        }
        tracingEnabled2.stopTracing = stopTracing;
        function recordType(type3) {
          if (mode !== "server") {
            typeCatalog.push(type3);
          }
        }
        tracingEnabled2.recordType = recordType;
        var Phase;
        (function(Phase2) {
          Phase2["Parse"] = "parse";
          Phase2["Program"] = "program";
          Phase2["Bind"] = "bind";
          Phase2["Check"] = "check";
          Phase2["CheckTypes"] = "checkTypes";
          Phase2["Emit"] = "emit";
          Phase2["Session"] = "session";
        })(Phase = tracingEnabled2.Phase || (tracingEnabled2.Phase = {}));
        function instant(phase, name, args) {
          writeEvent("I", phase, name, args, '"s":"g"');
        }
        tracingEnabled2.instant = instant;
        var eventStack = [];
        function push(phase, name, args, separateBeginAndEnd) {
          if (separateBeginAndEnd === void 0) {
            separateBeginAndEnd = false;
          }
          if (separateBeginAndEnd) {
            writeEvent("B", phase, name, args);
          }
          eventStack.push({ phase, name, args, time: 1e3 * ts3.timestamp(), separateBeginAndEnd });
        }
        tracingEnabled2.push = push;
        function pop() {
          ts3.Debug.assert(eventStack.length > 0);
          writeStackEvent(eventStack.length - 1, 1e3 * ts3.timestamp());
          eventStack.length--;
        }
        tracingEnabled2.pop = pop;
        function popAll() {
          var endTime = 1e3 * ts3.timestamp();
          for (var i3 = eventStack.length - 1; i3 >= 0; i3--) {
            writeStackEvent(i3, endTime);
          }
          eventStack.length = 0;
        }
        tracingEnabled2.popAll = popAll;
        var sampleInterval = 1e3 * 10;
        function writeStackEvent(index, endTime) {
          var _a2 = eventStack[index], phase = _a2.phase, name = _a2.name, args = _a2.args, time = _a2.time, separateBeginAndEnd = _a2.separateBeginAndEnd;
          if (separateBeginAndEnd) {
            writeEvent("E", phase, name, args, void 0, endTime);
          } else if (sampleInterval - time % sampleInterval <= endTime - time) {
            writeEvent("X", phase, name, args, '"dur":' + (endTime - time), time);
          }
        }
        function writeEvent(eventType, phase, name, args, extras, time) {
          if (time === void 0) {
            time = 1e3 * ts3.timestamp();
          }
          if (mode === "server" && phase === "checkTypes")
            return;
          ts3.performance.mark("beginTracing");
          fs5.writeSync(traceFd, ',\n{"pid":1,"tid":1,"ph":"' + eventType + '","cat":"' + phase + '","ts":' + time + ',"name":"' + name + '"');
          if (extras)
            fs5.writeSync(traceFd, "," + extras);
          if (args)
            fs5.writeSync(traceFd, ',"args":' + JSON.stringify(args));
          fs5.writeSync(traceFd, "}");
          ts3.performance.mark("endTracing");
          ts3.performance.measure("Tracing", "beginTracing", "endTracing");
        }
        function getLocation(node) {
          var file = ts3.getSourceFileOfNode(node);
          return !file ? void 0 : {
            path: file.path,
            start: indexFromOne(ts3.getLineAndCharacterOfPosition(file, node.pos)),
            end: indexFromOne(ts3.getLineAndCharacterOfPosition(file, node.end))
          };
          function indexFromOne(lc) {
            return {
              line: lc.line + 1,
              character: lc.character + 1
            };
          }
        }
        function dumpTypes(types2) {
          var _a2, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o, _p, _q, _r, _s, _t, _u, _v, _w, _x;
          ts3.performance.mark("beginDumpTypes");
          var typesPath = legend[legend.length - 1].typesPath;
          var typesFd = fs5.openSync(typesPath, "w");
          var recursionIdentityMap = new ts3.Map();
          fs5.writeSync(typesFd, "[");
          var numTypes = types2.length;
          for (var i3 = 0; i3 < numTypes; i3++) {
            var type3 = types2[i3];
            var objectFlags = type3.objectFlags;
            var symbol = (_a2 = type3.aliasSymbol) !== null && _a2 !== void 0 ? _a2 : type3.symbol;
            var display = void 0;
            if (objectFlags & 16 | type3.flags & 2944) {
              try {
                display = (_b = type3.checker) === null || _b === void 0 ? void 0 : _b.typeToString(type3);
              } catch (_y) {
                display = void 0;
              }
            }
            var indexedAccessProperties = {};
            if (type3.flags & 8388608) {
              var indexedAccessType = type3;
              indexedAccessProperties = {
                indexedAccessObjectType: (_c = indexedAccessType.objectType) === null || _c === void 0 ? void 0 : _c.id,
                indexedAccessIndexType: (_d = indexedAccessType.indexType) === null || _d === void 0 ? void 0 : _d.id
              };
            }
            var referenceProperties = {};
            if (objectFlags & 4) {
              var referenceType = type3;
              referenceProperties = {
                instantiatedType: (_e = referenceType.target) === null || _e === void 0 ? void 0 : _e.id,
                typeArguments: (_f = referenceType.resolvedTypeArguments) === null || _f === void 0 ? void 0 : _f.map(function(t2) {
                  return t2.id;
                }),
                referenceLocation: getLocation(referenceType.node)
              };
            }
            var conditionalProperties = {};
            if (type3.flags & 16777216) {
              var conditionalType = type3;
              conditionalProperties = {
                conditionalCheckType: (_g = conditionalType.checkType) === null || _g === void 0 ? void 0 : _g.id,
                conditionalExtendsType: (_h = conditionalType.extendsType) === null || _h === void 0 ? void 0 : _h.id,
                conditionalTrueType: (_k = (_j = conditionalType.resolvedTrueType) === null || _j === void 0 ? void 0 : _j.id) !== null && _k !== void 0 ? _k : -1,
                conditionalFalseType: (_m = (_l = conditionalType.resolvedFalseType) === null || _l === void 0 ? void 0 : _l.id) !== null && _m !== void 0 ? _m : -1
              };
            }
            var substitutionProperties = {};
            if (type3.flags & 33554432) {
              var substitutionType = type3;
              substitutionProperties = {
                substitutionBaseType: (_o = substitutionType.baseType) === null || _o === void 0 ? void 0 : _o.id,
                substituteType: (_p = substitutionType.substitute) === null || _p === void 0 ? void 0 : _p.id
              };
            }
            var reverseMappedProperties = {};
            if (objectFlags & 1024) {
              var reverseMappedType = type3;
              reverseMappedProperties = {
                reverseMappedSourceType: (_q = reverseMappedType.source) === null || _q === void 0 ? void 0 : _q.id,
                reverseMappedMappedType: (_r = reverseMappedType.mappedType) === null || _r === void 0 ? void 0 : _r.id,
                reverseMappedConstraintType: (_s = reverseMappedType.constraintType) === null || _s === void 0 ? void 0 : _s.id
              };
            }
            var evolvingArrayProperties = {};
            if (objectFlags & 256) {
              var evolvingArrayType = type3;
              evolvingArrayProperties = {
                evolvingArrayElementType: evolvingArrayType.elementType.id,
                evolvingArrayFinalType: (_t = evolvingArrayType.finalArrayType) === null || _t === void 0 ? void 0 : _t.id
              };
            }
            var recursionToken = void 0;
            var recursionIdentity = type3.checker.getRecursionIdentity(type3);
            if (recursionIdentity) {
              recursionToken = recursionIdentityMap.get(recursionIdentity);
              if (!recursionToken) {
                recursionToken = recursionIdentityMap.size;
                recursionIdentityMap.set(recursionIdentity, recursionToken);
              }
            }
            var descriptor = __assign(__assign(__assign(__assign(__assign(__assign(__assign({ id: type3.id, intrinsicName: type3.intrinsicName, symbolName: (symbol === null || symbol === void 0 ? void 0 : symbol.escapedName) && ts3.unescapeLeadingUnderscores(symbol.escapedName), recursionId: recursionToken, isTuple: objectFlags & 8 ? true : void 0, unionTypes: type3.flags & 1048576 ? (_u = type3.types) === null || _u === void 0 ? void 0 : _u.map(function(t2) {
              return t2.id;
            }) : void 0, intersectionTypes: type3.flags & 2097152 ? type3.types.map(function(t2) {
              return t2.id;
            }) : void 0, aliasTypeArguments: (_v = type3.aliasTypeArguments) === null || _v === void 0 ? void 0 : _v.map(function(t2) {
              return t2.id;
            }), keyofType: type3.flags & 4194304 ? (_w = type3.type) === null || _w === void 0 ? void 0 : _w.id : void 0 }, indexedAccessProperties), referenceProperties), conditionalProperties), substitutionProperties), reverseMappedProperties), evolvingArrayProperties), { destructuringPattern: getLocation(type3.pattern), firstDeclaration: getLocation((_x = symbol === null || symbol === void 0 ? void 0 : symbol.declarations) === null || _x === void 0 ? void 0 : _x[0]), flags: ts3.Debug.formatTypeFlags(type3.flags).split("|"), display });
            fs5.writeSync(typesFd, JSON.stringify(descriptor));
            if (i3 < numTypes - 1) {
              fs5.writeSync(typesFd, ",\n");
            }
          }
          fs5.writeSync(typesFd, "]\n");
          fs5.closeSync(typesFd);
          ts3.performance.mark("endDumpTypes");
          ts3.performance.measure("Dump types", "beginDumpTypes", "endDumpTypes");
        }
        function dumpLegend() {
          if (!legendPath) {
            return;
          }
          fs5.writeFileSync(legendPath, JSON.stringify(legend));
        }
        tracingEnabled2.dumpLegend = dumpLegend;
      })(tracingEnabled || (tracingEnabled = {}));
      ts3.startTracing = tracingEnabled.startTracing;
      ts3.dumpTracingLegend = tracingEnabled.dumpLegend;
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var SyntaxKind;
      (function(SyntaxKind2) {
        SyntaxKind2[SyntaxKind2["Unknown"] = 0] = "Unknown";
        SyntaxKind2[SyntaxKind2["EndOfFileToken"] = 1] = "EndOfFileToken";
        SyntaxKind2[SyntaxKind2["SingleLineCommentTrivia"] = 2] = "SingleLineCommentTrivia";
        SyntaxKind2[SyntaxKind2["MultiLineCommentTrivia"] = 3] = "MultiLineCommentTrivia";
        SyntaxKind2[SyntaxKind2["NewLineTrivia"] = 4] = "NewLineTrivia";
        SyntaxKind2[SyntaxKind2["WhitespaceTrivia"] = 5] = "WhitespaceTrivia";
        SyntaxKind2[SyntaxKind2["ShebangTrivia"] = 6] = "ShebangTrivia";
        SyntaxKind2[SyntaxKind2["ConflictMarkerTrivia"] = 7] = "ConflictMarkerTrivia";
        SyntaxKind2[SyntaxKind2["NumericLiteral"] = 8] = "NumericLiteral";
        SyntaxKind2[SyntaxKind2["BigIntLiteral"] = 9] = "BigIntLiteral";
        SyntaxKind2[SyntaxKind2["StringLiteral"] = 10] = "StringLiteral";
        SyntaxKind2[SyntaxKind2["JsxText"] = 11] = "JsxText";
        SyntaxKind2[SyntaxKind2["JsxTextAllWhiteSpaces"] = 12] = "JsxTextAllWhiteSpaces";
        SyntaxKind2[SyntaxKind2["RegularExpressionLiteral"] = 13] = "RegularExpressionLiteral";
        SyntaxKind2[SyntaxKind2["NoSubstitutionTemplateLiteral"] = 14] = "NoSubstitutionTemplateLiteral";
        SyntaxKind2[SyntaxKind2["TemplateHead"] = 15] = "TemplateHead";
        SyntaxKind2[SyntaxKind2["TemplateMiddle"] = 16] = "TemplateMiddle";
        SyntaxKind2[SyntaxKind2["TemplateTail"] = 17] = "TemplateTail";
        SyntaxKind2[SyntaxKind2["OpenBraceToken"] = 18] = "OpenBraceToken";
        SyntaxKind2[SyntaxKind2["CloseBraceToken"] = 19] = "CloseBraceToken";
        SyntaxKind2[SyntaxKind2["OpenParenToken"] = 20] = "OpenParenToken";
        SyntaxKind2[SyntaxKind2["CloseParenToken"] = 21] = "CloseParenToken";
        SyntaxKind2[SyntaxKind2["OpenBracketToken"] = 22] = "OpenBracketToken";
        SyntaxKind2[SyntaxKind2["CloseBracketToken"] = 23] = "CloseBracketToken";
        SyntaxKind2[SyntaxKind2["DotToken"] = 24] = "DotToken";
        SyntaxKind2[SyntaxKind2["DotDotDotToken"] = 25] = "DotDotDotToken";
        SyntaxKind2[SyntaxKind2["SemicolonToken"] = 26] = "SemicolonToken";
        SyntaxKind2[SyntaxKind2["CommaToken"] = 27] = "CommaToken";
        SyntaxKind2[SyntaxKind2["QuestionDotToken"] = 28] = "QuestionDotToken";
        SyntaxKind2[SyntaxKind2["LessThanToken"] = 29] = "LessThanToken";
        SyntaxKind2[SyntaxKind2["LessThanSlashToken"] = 30] = "LessThanSlashToken";
        SyntaxKind2[SyntaxKind2["GreaterThanToken"] = 31] = "GreaterThanToken";
        SyntaxKind2[SyntaxKind2["LessThanEqualsToken"] = 32] = "LessThanEqualsToken";
        SyntaxKind2[SyntaxKind2["GreaterThanEqualsToken"] = 33] = "GreaterThanEqualsToken";
        SyntaxKind2[SyntaxKind2["EqualsEqualsToken"] = 34] = "EqualsEqualsToken";
        SyntaxKind2[SyntaxKind2["ExclamationEqualsToken"] = 35] = "ExclamationEqualsToken";
        SyntaxKind2[SyntaxKind2["EqualsEqualsEqualsToken"] = 36] = "EqualsEqualsEqualsToken";
        SyntaxKind2[SyntaxKind2["ExclamationEqualsEqualsToken"] = 37] = "ExclamationEqualsEqualsToken";
        SyntaxKind2[SyntaxKind2["EqualsGreaterThanToken"] = 38] = "EqualsGreaterThanToken";
        SyntaxKind2[SyntaxKind2["PlusToken"] = 39] = "PlusToken";
        SyntaxKind2[SyntaxKind2["MinusToken"] = 40] = "MinusToken";
        SyntaxKind2[SyntaxKind2["AsteriskToken"] = 41] = "AsteriskToken";
        SyntaxKind2[SyntaxKind2["AsteriskAsteriskToken"] = 42] = "AsteriskAsteriskToken";
        SyntaxKind2[SyntaxKind2["SlashToken"] = 43] = "SlashToken";
        SyntaxKind2[SyntaxKind2["PercentToken"] = 44] = "PercentToken";
        SyntaxKind2[SyntaxKind2["PlusPlusToken"] = 45] = "PlusPlusToken";
        SyntaxKind2[SyntaxKind2["MinusMinusToken"] = 46] = "MinusMinusToken";
        SyntaxKind2[SyntaxKind2["LessThanLessThanToken"] = 47] = "LessThanLessThanToken";
        SyntaxKind2[SyntaxKind2["GreaterThanGreaterThanToken"] = 48] = "GreaterThanGreaterThanToken";
        SyntaxKind2[SyntaxKind2["GreaterThanGreaterThanGreaterThanToken"] = 49] = "GreaterThanGreaterThanGreaterThanToken";
        SyntaxKind2[SyntaxKind2["AmpersandToken"] = 50] = "AmpersandToken";
        SyntaxKind2[SyntaxKind2["BarToken"] = 51] = "BarToken";
        SyntaxKind2[SyntaxKind2["CaretToken"] = 52] = "CaretToken";
        SyntaxKind2[SyntaxKind2["ExclamationToken"] = 53] = "ExclamationToken";
        SyntaxKind2[SyntaxKind2["TildeToken"] = 54] = "TildeToken";
        SyntaxKind2[SyntaxKind2["AmpersandAmpersandToken"] = 55] = "AmpersandAmpersandToken";
        SyntaxKind2[SyntaxKind2["BarBarToken"] = 56] = "BarBarToken";
        SyntaxKind2[SyntaxKind2["QuestionToken"] = 57] = "QuestionToken";
        SyntaxKind2[SyntaxKind2["ColonToken"] = 58] = "ColonToken";
        SyntaxKind2[SyntaxKind2["AtToken"] = 59] = "AtToken";
        SyntaxKind2[SyntaxKind2["QuestionQuestionToken"] = 60] = "QuestionQuestionToken";
        SyntaxKind2[SyntaxKind2["BacktickToken"] = 61] = "BacktickToken";
        SyntaxKind2[SyntaxKind2["EqualsToken"] = 62] = "EqualsToken";
        SyntaxKind2[SyntaxKind2["PlusEqualsToken"] = 63] = "PlusEqualsToken";
        SyntaxKind2[SyntaxKind2["MinusEqualsToken"] = 64] = "MinusEqualsToken";
        SyntaxKind2[SyntaxKind2["AsteriskEqualsToken"] = 65] = "AsteriskEqualsToken";
        SyntaxKind2[SyntaxKind2["AsteriskAsteriskEqualsToken"] = 66] = "AsteriskAsteriskEqualsToken";
        SyntaxKind2[SyntaxKind2["SlashEqualsToken"] = 67] = "SlashEqualsToken";
        SyntaxKind2[SyntaxKind2["PercentEqualsToken"] = 68] = "PercentEqualsToken";
        SyntaxKind2[SyntaxKind2["LessThanLessThanEqualsToken"] = 69] = "LessThanLessThanEqualsToken";
        SyntaxKind2[SyntaxKind2["GreaterThanGreaterThanEqualsToken"] = 70] = "GreaterThanGreaterThanEqualsToken";
        SyntaxKind2[SyntaxKind2["GreaterThanGreaterThanGreaterThanEqualsToken"] = 71] = "GreaterThanGreaterThanGreaterThanEqualsToken";
        SyntaxKind2[SyntaxKind2["AmpersandEqualsToken"] = 72] = "AmpersandEqualsToken";
        SyntaxKind2[SyntaxKind2["BarEqualsToken"] = 73] = "BarEqualsToken";
        SyntaxKind2[SyntaxKind2["BarBarEqualsToken"] = 74] = "BarBarEqualsToken";
        SyntaxKind2[SyntaxKind2["AmpersandAmpersandEqualsToken"] = 75] = "AmpersandAmpersandEqualsToken";
        SyntaxKind2[SyntaxKind2["QuestionQuestionEqualsToken"] = 76] = "QuestionQuestionEqualsToken";
        SyntaxKind2[SyntaxKind2["CaretEqualsToken"] = 77] = "CaretEqualsToken";
        SyntaxKind2[SyntaxKind2["Identifier"] = 78] = "Identifier";
        SyntaxKind2[SyntaxKind2["PrivateIdentifier"] = 79] = "PrivateIdentifier";
        SyntaxKind2[SyntaxKind2["BreakKeyword"] = 80] = "BreakKeyword";
        SyntaxKind2[SyntaxKind2["CaseKeyword"] = 81] = "CaseKeyword";
        SyntaxKind2[SyntaxKind2["CatchKeyword"] = 82] = "CatchKeyword";
        SyntaxKind2[SyntaxKind2["ClassKeyword"] = 83] = "ClassKeyword";
        SyntaxKind2[SyntaxKind2["ConstKeyword"] = 84] = "ConstKeyword";
        SyntaxKind2[SyntaxKind2["ContinueKeyword"] = 85] = "ContinueKeyword";
        SyntaxKind2[SyntaxKind2["DebuggerKeyword"] = 86] = "DebuggerKeyword";
        SyntaxKind2[SyntaxKind2["DefaultKeyword"] = 87] = "DefaultKeyword";
        SyntaxKind2[SyntaxKind2["DeleteKeyword"] = 88] = "DeleteKeyword";
        SyntaxKind2[SyntaxKind2["DoKeyword"] = 89] = "DoKeyword";
        SyntaxKind2[SyntaxKind2["ElseKeyword"] = 90] = "ElseKeyword";
        SyntaxKind2[SyntaxKind2["EnumKeyword"] = 91] = "EnumKeyword";
        SyntaxKind2[SyntaxKind2["ExportKeyword"] = 92] = "ExportKeyword";
        SyntaxKind2[SyntaxKind2["ExtendsKeyword"] = 93] = "ExtendsKeyword";
        SyntaxKind2[SyntaxKind2["FalseKeyword"] = 94] = "FalseKeyword";
        SyntaxKind2[SyntaxKind2["FinallyKeyword"] = 95] = "FinallyKeyword";
        SyntaxKind2[SyntaxKind2["ForKeyword"] = 96] = "ForKeyword";
        SyntaxKind2[SyntaxKind2["FunctionKeyword"] = 97] = "FunctionKeyword";
        SyntaxKind2[SyntaxKind2["IfKeyword"] = 98] = "IfKeyword";
        SyntaxKind2[SyntaxKind2["ImportKeyword"] = 99] = "ImportKeyword";
        SyntaxKind2[SyntaxKind2["InKeyword"] = 100] = "InKeyword";
        SyntaxKind2[SyntaxKind2["InstanceOfKeyword"] = 101] = "InstanceOfKeyword";
        SyntaxKind2[SyntaxKind2["NewKeyword"] = 102] = "NewKeyword";
        SyntaxKind2[SyntaxKind2["NullKeyword"] = 103] = "NullKeyword";
        SyntaxKind2[SyntaxKind2["ReturnKeyword"] = 104] = "ReturnKeyword";
        SyntaxKind2[SyntaxKind2["SuperKeyword"] = 105] = "SuperKeyword";
        SyntaxKind2[SyntaxKind2["SwitchKeyword"] = 106] = "SwitchKeyword";
        SyntaxKind2[SyntaxKind2["ThisKeyword"] = 107] = "ThisKeyword";
        SyntaxKind2[SyntaxKind2["ThrowKeyword"] = 108] = "ThrowKeyword";
        SyntaxKind2[SyntaxKind2["TrueKeyword"] = 109] = "TrueKeyword";
        SyntaxKind2[SyntaxKind2["TryKeyword"] = 110] = "TryKeyword";
        SyntaxKind2[SyntaxKind2["TypeOfKeyword"] = 111] = "TypeOfKeyword";
        SyntaxKind2[SyntaxKind2["VarKeyword"] = 112] = "VarKeyword";
        SyntaxKind2[SyntaxKind2["VoidKeyword"] = 113] = "VoidKeyword";
        SyntaxKind2[SyntaxKind2["WhileKeyword"] = 114] = "WhileKeyword";
        SyntaxKind2[SyntaxKind2["WithKeyword"] = 115] = "WithKeyword";
        SyntaxKind2[SyntaxKind2["ImplementsKeyword"] = 116] = "ImplementsKeyword";
        SyntaxKind2[SyntaxKind2["InterfaceKeyword"] = 117] = "InterfaceKeyword";
        SyntaxKind2[SyntaxKind2["LetKeyword"] = 118] = "LetKeyword";
        SyntaxKind2[SyntaxKind2["PackageKeyword"] = 119] = "PackageKeyword";
        SyntaxKind2[SyntaxKind2["PrivateKeyword"] = 120] = "PrivateKeyword";
        SyntaxKind2[SyntaxKind2["ProtectedKeyword"] = 121] = "ProtectedKeyword";
        SyntaxKind2[SyntaxKind2["PublicKeyword"] = 122] = "PublicKeyword";
        SyntaxKind2[SyntaxKind2["StaticKeyword"] = 123] = "StaticKeyword";
        SyntaxKind2[SyntaxKind2["YieldKeyword"] = 124] = "YieldKeyword";
        SyntaxKind2[SyntaxKind2["AbstractKeyword"] = 125] = "AbstractKeyword";
        SyntaxKind2[SyntaxKind2["AsKeyword"] = 126] = "AsKeyword";
        SyntaxKind2[SyntaxKind2["AssertsKeyword"] = 127] = "AssertsKeyword";
        SyntaxKind2[SyntaxKind2["AnyKeyword"] = 128] = "AnyKeyword";
        SyntaxKind2[SyntaxKind2["AsyncKeyword"] = 129] = "AsyncKeyword";
        SyntaxKind2[SyntaxKind2["AwaitKeyword"] = 130] = "AwaitKeyword";
        SyntaxKind2[SyntaxKind2["BooleanKeyword"] = 131] = "BooleanKeyword";
        SyntaxKind2[SyntaxKind2["ConstructorKeyword"] = 132] = "ConstructorKeyword";
        SyntaxKind2[SyntaxKind2["DeclareKeyword"] = 133] = "DeclareKeyword";
        SyntaxKind2[SyntaxKind2["GetKeyword"] = 134] = "GetKeyword";
        SyntaxKind2[SyntaxKind2["InferKeyword"] = 135] = "InferKeyword";
        SyntaxKind2[SyntaxKind2["IntrinsicKeyword"] = 136] = "IntrinsicKeyword";
        SyntaxKind2[SyntaxKind2["IsKeyword"] = 137] = "IsKeyword";
        SyntaxKind2[SyntaxKind2["KeyOfKeyword"] = 138] = "KeyOfKeyword";
        SyntaxKind2[SyntaxKind2["ModuleKeyword"] = 139] = "ModuleKeyword";
        SyntaxKind2[SyntaxKind2["NamespaceKeyword"] = 140] = "NamespaceKeyword";
        SyntaxKind2[SyntaxKind2["NeverKeyword"] = 141] = "NeverKeyword";
        SyntaxKind2[SyntaxKind2["ReadonlyKeyword"] = 142] = "ReadonlyKeyword";
        SyntaxKind2[SyntaxKind2["RequireKeyword"] = 143] = "RequireKeyword";
        SyntaxKind2[SyntaxKind2["NumberKeyword"] = 144] = "NumberKeyword";
        SyntaxKind2[SyntaxKind2["ObjectKeyword"] = 145] = "ObjectKeyword";
        SyntaxKind2[SyntaxKind2["SetKeyword"] = 146] = "SetKeyword";
        SyntaxKind2[SyntaxKind2["StringKeyword"] = 147] = "StringKeyword";
        SyntaxKind2[SyntaxKind2["SymbolKeyword"] = 148] = "SymbolKeyword";
        SyntaxKind2[SyntaxKind2["TypeKeyword"] = 149] = "TypeKeyword";
        SyntaxKind2[SyntaxKind2["UndefinedKeyword"] = 150] = "UndefinedKeyword";
        SyntaxKind2[SyntaxKind2["UniqueKeyword"] = 151] = "UniqueKeyword";
        SyntaxKind2[SyntaxKind2["UnknownKeyword"] = 152] = "UnknownKeyword";
        SyntaxKind2[SyntaxKind2["FromKeyword"] = 153] = "FromKeyword";
        SyntaxKind2[SyntaxKind2["GlobalKeyword"] = 154] = "GlobalKeyword";
        SyntaxKind2[SyntaxKind2["BigIntKeyword"] = 155] = "BigIntKeyword";
        SyntaxKind2[SyntaxKind2["OverrideKeyword"] = 156] = "OverrideKeyword";
        SyntaxKind2[SyntaxKind2["OfKeyword"] = 157] = "OfKeyword";
        SyntaxKind2[SyntaxKind2["QualifiedName"] = 158] = "QualifiedName";
        SyntaxKind2[SyntaxKind2["ComputedPropertyName"] = 159] = "ComputedPropertyName";
        SyntaxKind2[SyntaxKind2["TypeParameter"] = 160] = "TypeParameter";
        SyntaxKind2[SyntaxKind2["Parameter"] = 161] = "Parameter";
        SyntaxKind2[SyntaxKind2["Decorator"] = 162] = "Decorator";
        SyntaxKind2[SyntaxKind2["PropertySignature"] = 163] = "PropertySignature";
        SyntaxKind2[SyntaxKind2["PropertyDeclaration"] = 164] = "PropertyDeclaration";
        SyntaxKind2[SyntaxKind2["MethodSignature"] = 165] = "MethodSignature";
        SyntaxKind2[SyntaxKind2["MethodDeclaration"] = 166] = "MethodDeclaration";
        SyntaxKind2[SyntaxKind2["Constructor"] = 167] = "Constructor";
        SyntaxKind2[SyntaxKind2["GetAccessor"] = 168] = "GetAccessor";
        SyntaxKind2[SyntaxKind2["SetAccessor"] = 169] = "SetAccessor";
        SyntaxKind2[SyntaxKind2["CallSignature"] = 170] = "CallSignature";
        SyntaxKind2[SyntaxKind2["ConstructSignature"] = 171] = "ConstructSignature";
        SyntaxKind2[SyntaxKind2["IndexSignature"] = 172] = "IndexSignature";
        SyntaxKind2[SyntaxKind2["TypePredicate"] = 173] = "TypePredicate";
        SyntaxKind2[SyntaxKind2["TypeReference"] = 174] = "TypeReference";
        SyntaxKind2[SyntaxKind2["FunctionType"] = 175] = "FunctionType";
        SyntaxKind2[SyntaxKind2["ConstructorType"] = 176] = "ConstructorType";
        SyntaxKind2[SyntaxKind2["TypeQuery"] = 177] = "TypeQuery";
        SyntaxKind2[SyntaxKind2["TypeLiteral"] = 178] = "TypeLiteral";
        SyntaxKind2[SyntaxKind2["ArrayType"] = 179] = "ArrayType";
        SyntaxKind2[SyntaxKind2["TupleType"] = 180] = "TupleType";
        SyntaxKind2[SyntaxKind2["OptionalType"] = 181] = "OptionalType";
        SyntaxKind2[SyntaxKind2["RestType"] = 182] = "RestType";
        SyntaxKind2[SyntaxKind2["UnionType"] = 183] = "UnionType";
        SyntaxKind2[SyntaxKind2["IntersectionType"] = 184] = "IntersectionType";
        SyntaxKind2[SyntaxKind2["ConditionalType"] = 185] = "ConditionalType";
        SyntaxKind2[SyntaxKind2["InferType"] = 186] = "InferType";
        SyntaxKind2[SyntaxKind2["ParenthesizedType"] = 187] = "ParenthesizedType";
        SyntaxKind2[SyntaxKind2["ThisType"] = 188] = "ThisType";
        SyntaxKind2[SyntaxKind2["TypeOperator"] = 189] = "TypeOperator";
        SyntaxKind2[SyntaxKind2["IndexedAccessType"] = 190] = "IndexedAccessType";
        SyntaxKind2[SyntaxKind2["MappedType"] = 191] = "MappedType";
        SyntaxKind2[SyntaxKind2["LiteralType"] = 192] = "LiteralType";
        SyntaxKind2[SyntaxKind2["NamedTupleMember"] = 193] = "NamedTupleMember";
        SyntaxKind2[SyntaxKind2["TemplateLiteralType"] = 194] = "TemplateLiteralType";
        SyntaxKind2[SyntaxKind2["TemplateLiteralTypeSpan"] = 195] = "TemplateLiteralTypeSpan";
        SyntaxKind2[SyntaxKind2["ImportType"] = 196] = "ImportType";
        SyntaxKind2[SyntaxKind2["ObjectBindingPattern"] = 197] = "ObjectBindingPattern";
        SyntaxKind2[SyntaxKind2["ArrayBindingPattern"] = 198] = "ArrayBindingPattern";
        SyntaxKind2[SyntaxKind2["BindingElement"] = 199] = "BindingElement";
        SyntaxKind2[SyntaxKind2["ArrayLiteralExpression"] = 200] = "ArrayLiteralExpression";
        SyntaxKind2[SyntaxKind2["ObjectLiteralExpression"] = 201] = "ObjectLiteralExpression";
        SyntaxKind2[SyntaxKind2["PropertyAccessExpression"] = 202] = "PropertyAccessExpression";
        SyntaxKind2[SyntaxKind2["ElementAccessExpression"] = 203] = "ElementAccessExpression";
        SyntaxKind2[SyntaxKind2["CallExpression"] = 204] = "CallExpression";
        SyntaxKind2[SyntaxKind2["NewExpression"] = 205] = "NewExpression";
        SyntaxKind2[SyntaxKind2["TaggedTemplateExpression"] = 206] = "TaggedTemplateExpression";
        SyntaxKind2[SyntaxKind2["TypeAssertionExpression"] = 207] = "TypeAssertionExpression";
        SyntaxKind2[SyntaxKind2["ParenthesizedExpression"] = 208] = "ParenthesizedExpression";
        SyntaxKind2[SyntaxKind2["FunctionExpression"] = 209] = "FunctionExpression";
        SyntaxKind2[SyntaxKind2["ArrowFunction"] = 210] = "ArrowFunction";
        SyntaxKind2[SyntaxKind2["DeleteExpression"] = 211] = "DeleteExpression";
        SyntaxKind2[SyntaxKind2["TypeOfExpression"] = 212] = "TypeOfExpression";
        SyntaxKind2[SyntaxKind2["VoidExpression"] = 213] = "VoidExpression";
        SyntaxKind2[SyntaxKind2["AwaitExpression"] = 214] = "AwaitExpression";
        SyntaxKind2[SyntaxKind2["PrefixUnaryExpression"] = 215] = "PrefixUnaryExpression";
        SyntaxKind2[SyntaxKind2["PostfixUnaryExpression"] = 216] = "PostfixUnaryExpression";
        SyntaxKind2[SyntaxKind2["BinaryExpression"] = 217] = "BinaryExpression";
        SyntaxKind2[SyntaxKind2["ConditionalExpression"] = 218] = "ConditionalExpression";
        SyntaxKind2[SyntaxKind2["TemplateExpression"] = 219] = "TemplateExpression";
        SyntaxKind2[SyntaxKind2["YieldExpression"] = 220] = "YieldExpression";
        SyntaxKind2[SyntaxKind2["SpreadElement"] = 221] = "SpreadElement";
        SyntaxKind2[SyntaxKind2["ClassExpression"] = 222] = "ClassExpression";
        SyntaxKind2[SyntaxKind2["OmittedExpression"] = 223] = "OmittedExpression";
        SyntaxKind2[SyntaxKind2["ExpressionWithTypeArguments"] = 224] = "ExpressionWithTypeArguments";
        SyntaxKind2[SyntaxKind2["AsExpression"] = 225] = "AsExpression";
        SyntaxKind2[SyntaxKind2["NonNullExpression"] = 226] = "NonNullExpression";
        SyntaxKind2[SyntaxKind2["MetaProperty"] = 227] = "MetaProperty";
        SyntaxKind2[SyntaxKind2["SyntheticExpression"] = 228] = "SyntheticExpression";
        SyntaxKind2[SyntaxKind2["TemplateSpan"] = 229] = "TemplateSpan";
        SyntaxKind2[SyntaxKind2["SemicolonClassElement"] = 230] = "SemicolonClassElement";
        SyntaxKind2[SyntaxKind2["Block"] = 231] = "Block";
        SyntaxKind2[SyntaxKind2["EmptyStatement"] = 232] = "EmptyStatement";
        SyntaxKind2[SyntaxKind2["VariableStatement"] = 233] = "VariableStatement";
        SyntaxKind2[SyntaxKind2["ExpressionStatement"] = 234] = "ExpressionStatement";
        SyntaxKind2[SyntaxKind2["IfStatement"] = 235] = "IfStatement";
        SyntaxKind2[SyntaxKind2["DoStatement"] = 236] = "DoStatement";
        SyntaxKind2[SyntaxKind2["WhileStatement"] = 237] = "WhileStatement";
        SyntaxKind2[SyntaxKind2["ForStatement"] = 238] = "ForStatement";
        SyntaxKind2[SyntaxKind2["ForInStatement"] = 239] = "ForInStatement";
        SyntaxKind2[SyntaxKind2["ForOfStatement"] = 240] = "ForOfStatement";
        SyntaxKind2[SyntaxKind2["ContinueStatement"] = 241] = "ContinueStatement";
        SyntaxKind2[SyntaxKind2["BreakStatement"] = 242] = "BreakStatement";
        SyntaxKind2[SyntaxKind2["ReturnStatement"] = 243] = "ReturnStatement";
        SyntaxKind2[SyntaxKind2["WithStatement"] = 244] = "WithStatement";
        SyntaxKind2[SyntaxKind2["SwitchStatement"] = 245] = "SwitchStatement";
        SyntaxKind2[SyntaxKind2["LabeledStatement"] = 246] = "LabeledStatement";
        SyntaxKind2[SyntaxKind2["ThrowStatement"] = 247] = "ThrowStatement";
        SyntaxKind2[SyntaxKind2["TryStatement"] = 248] = "TryStatement";
        SyntaxKind2[SyntaxKind2["DebuggerStatement"] = 249] = "DebuggerStatement";
        SyntaxKind2[SyntaxKind2["VariableDeclaration"] = 250] = "VariableDeclaration";
        SyntaxKind2[SyntaxKind2["VariableDeclarationList"] = 251] = "VariableDeclarationList";
        SyntaxKind2[SyntaxKind2["FunctionDeclaration"] = 252] = "FunctionDeclaration";
        SyntaxKind2[SyntaxKind2["ClassDeclaration"] = 253] = "ClassDeclaration";
        SyntaxKind2[SyntaxKind2["InterfaceDeclaration"] = 254] = "InterfaceDeclaration";
        SyntaxKind2[SyntaxKind2["TypeAliasDeclaration"] = 255] = "TypeAliasDeclaration";
        SyntaxKind2[SyntaxKind2["EnumDeclaration"] = 256] = "EnumDeclaration";
        SyntaxKind2[SyntaxKind2["ModuleDeclaration"] = 257] = "ModuleDeclaration";
        SyntaxKind2[SyntaxKind2["ModuleBlock"] = 258] = "ModuleBlock";
        SyntaxKind2[SyntaxKind2["CaseBlock"] = 259] = "CaseBlock";
        SyntaxKind2[SyntaxKind2["NamespaceExportDeclaration"] = 260] = "NamespaceExportDeclaration";
        SyntaxKind2[SyntaxKind2["ImportEqualsDeclaration"] = 261] = "ImportEqualsDeclaration";
        SyntaxKind2[SyntaxKind2["ImportDeclaration"] = 262] = "ImportDeclaration";
        SyntaxKind2[SyntaxKind2["ImportClause"] = 263] = "ImportClause";
        SyntaxKind2[SyntaxKind2["NamespaceImport"] = 264] = "NamespaceImport";
        SyntaxKind2[SyntaxKind2["NamedImports"] = 265] = "NamedImports";
        SyntaxKind2[SyntaxKind2["ImportSpecifier"] = 266] = "ImportSpecifier";
        SyntaxKind2[SyntaxKind2["ExportAssignment"] = 267] = "ExportAssignment";
        SyntaxKind2[SyntaxKind2["ExportDeclaration"] = 268] = "ExportDeclaration";
        SyntaxKind2[SyntaxKind2["NamedExports"] = 269] = "NamedExports";
        SyntaxKind2[SyntaxKind2["NamespaceExport"] = 270] = "NamespaceExport";
        SyntaxKind2[SyntaxKind2["ExportSpecifier"] = 271] = "ExportSpecifier";
        SyntaxKind2[SyntaxKind2["MissingDeclaration"] = 272] = "MissingDeclaration";
        SyntaxKind2[SyntaxKind2["ExternalModuleReference"] = 273] = "ExternalModuleReference";
        SyntaxKind2[SyntaxKind2["JsxElement"] = 274] = "JsxElement";
        SyntaxKind2[SyntaxKind2["JsxSelfClosingElement"] = 275] = "JsxSelfClosingElement";
        SyntaxKind2[SyntaxKind2["JsxOpeningElement"] = 276] = "JsxOpeningElement";
        SyntaxKind2[SyntaxKind2["JsxClosingElement"] = 277] = "JsxClosingElement";
        SyntaxKind2[SyntaxKind2["JsxFragment"] = 278] = "JsxFragment";
        SyntaxKind2[SyntaxKind2["JsxOpeningFragment"] = 279] = "JsxOpeningFragment";
        SyntaxKind2[SyntaxKind2["JsxClosingFragment"] = 280] = "JsxClosingFragment";
        SyntaxKind2[SyntaxKind2["JsxAttribute"] = 281] = "JsxAttribute";
        SyntaxKind2[SyntaxKind2["JsxAttributes"] = 282] = "JsxAttributes";
        SyntaxKind2[SyntaxKind2["JsxSpreadAttribute"] = 283] = "JsxSpreadAttribute";
        SyntaxKind2[SyntaxKind2["JsxExpression"] = 284] = "JsxExpression";
        SyntaxKind2[SyntaxKind2["CaseClause"] = 285] = "CaseClause";
        SyntaxKind2[SyntaxKind2["DefaultClause"] = 286] = "DefaultClause";
        SyntaxKind2[SyntaxKind2["HeritageClause"] = 287] = "HeritageClause";
        SyntaxKind2[SyntaxKind2["CatchClause"] = 288] = "CatchClause";
        SyntaxKind2[SyntaxKind2["PropertyAssignment"] = 289] = "PropertyAssignment";
        SyntaxKind2[SyntaxKind2["ShorthandPropertyAssignment"] = 290] = "ShorthandPropertyAssignment";
        SyntaxKind2[SyntaxKind2["SpreadAssignment"] = 291] = "SpreadAssignment";
        SyntaxKind2[SyntaxKind2["EnumMember"] = 292] = "EnumMember";
        SyntaxKind2[SyntaxKind2["UnparsedPrologue"] = 293] = "UnparsedPrologue";
        SyntaxKind2[SyntaxKind2["UnparsedPrepend"] = 294] = "UnparsedPrepend";
        SyntaxKind2[SyntaxKind2["UnparsedText"] = 295] = "UnparsedText";
        SyntaxKind2[SyntaxKind2["UnparsedInternalText"] = 296] = "UnparsedInternalText";
        SyntaxKind2[SyntaxKind2["UnparsedSyntheticReference"] = 297] = "UnparsedSyntheticReference";
        SyntaxKind2[SyntaxKind2["SourceFile"] = 298] = "SourceFile";
        SyntaxKind2[SyntaxKind2["Bundle"] = 299] = "Bundle";
        SyntaxKind2[SyntaxKind2["UnparsedSource"] = 300] = "UnparsedSource";
        SyntaxKind2[SyntaxKind2["InputFiles"] = 301] = "InputFiles";
        SyntaxKind2[SyntaxKind2["JSDocTypeExpression"] = 302] = "JSDocTypeExpression";
        SyntaxKind2[SyntaxKind2["JSDocNameReference"] = 303] = "JSDocNameReference";
        SyntaxKind2[SyntaxKind2["JSDocAllType"] = 304] = "JSDocAllType";
        SyntaxKind2[SyntaxKind2["JSDocUnknownType"] = 305] = "JSDocUnknownType";
        SyntaxKind2[SyntaxKind2["JSDocNullableType"] = 306] = "JSDocNullableType";
        SyntaxKind2[SyntaxKind2["JSDocNonNullableType"] = 307] = "JSDocNonNullableType";
        SyntaxKind2[SyntaxKind2["JSDocOptionalType"] = 308] = "JSDocOptionalType";
        SyntaxKind2[SyntaxKind2["JSDocFunctionType"] = 309] = "JSDocFunctionType";
        SyntaxKind2[SyntaxKind2["JSDocVariadicType"] = 310] = "JSDocVariadicType";
        SyntaxKind2[SyntaxKind2["JSDocNamepathType"] = 311] = "JSDocNamepathType";
        SyntaxKind2[SyntaxKind2["JSDocComment"] = 312] = "JSDocComment";
        SyntaxKind2[SyntaxKind2["JSDocText"] = 313] = "JSDocText";
        SyntaxKind2[SyntaxKind2["JSDocTypeLiteral"] = 314] = "JSDocTypeLiteral";
        SyntaxKind2[SyntaxKind2["JSDocSignature"] = 315] = "JSDocSignature";
        SyntaxKind2[SyntaxKind2["JSDocLink"] = 316] = "JSDocLink";
        SyntaxKind2[SyntaxKind2["JSDocTag"] = 317] = "JSDocTag";
        SyntaxKind2[SyntaxKind2["JSDocAugmentsTag"] = 318] = "JSDocAugmentsTag";
        SyntaxKind2[SyntaxKind2["JSDocImplementsTag"] = 319] = "JSDocImplementsTag";
        SyntaxKind2[SyntaxKind2["JSDocAuthorTag"] = 320] = "JSDocAuthorTag";
        SyntaxKind2[SyntaxKind2["JSDocDeprecatedTag"] = 321] = "JSDocDeprecatedTag";
        SyntaxKind2[SyntaxKind2["JSDocClassTag"] = 322] = "JSDocClassTag";
        SyntaxKind2[SyntaxKind2["JSDocPublicTag"] = 323] = "JSDocPublicTag";
        SyntaxKind2[SyntaxKind2["JSDocPrivateTag"] = 324] = "JSDocPrivateTag";
        SyntaxKind2[SyntaxKind2["JSDocProtectedTag"] = 325] = "JSDocProtectedTag";
        SyntaxKind2[SyntaxKind2["JSDocReadonlyTag"] = 326] = "JSDocReadonlyTag";
        SyntaxKind2[SyntaxKind2["JSDocOverrideTag"] = 327] = "JSDocOverrideTag";
        SyntaxKind2[SyntaxKind2["JSDocCallbackTag"] = 328] = "JSDocCallbackTag";
        SyntaxKind2[SyntaxKind2["JSDocEnumTag"] = 329] = "JSDocEnumTag";
        SyntaxKind2[SyntaxKind2["JSDocParameterTag"] = 330] = "JSDocParameterTag";
        SyntaxKind2[SyntaxKind2["JSDocReturnTag"] = 331] = "JSDocReturnTag";
        SyntaxKind2[SyntaxKind2["JSDocThisTag"] = 332] = "JSDocThisTag";
        SyntaxKind2[SyntaxKind2["JSDocTypeTag"] = 333] = "JSDocTypeTag";
        SyntaxKind2[SyntaxKind2["JSDocTemplateTag"] = 334] = "JSDocTemplateTag";
        SyntaxKind2[SyntaxKind2["JSDocTypedefTag"] = 335] = "JSDocTypedefTag";
        SyntaxKind2[SyntaxKind2["JSDocSeeTag"] = 336] = "JSDocSeeTag";
        SyntaxKind2[SyntaxKind2["JSDocPropertyTag"] = 337] = "JSDocPropertyTag";
        SyntaxKind2[SyntaxKind2["SyntaxList"] = 338] = "SyntaxList";
        SyntaxKind2[SyntaxKind2["NotEmittedStatement"] = 339] = "NotEmittedStatement";
        SyntaxKind2[SyntaxKind2["PartiallyEmittedExpression"] = 340] = "PartiallyEmittedExpression";
        SyntaxKind2[SyntaxKind2["CommaListExpression"] = 341] = "CommaListExpression";
        SyntaxKind2[SyntaxKind2["MergeDeclarationMarker"] = 342] = "MergeDeclarationMarker";
        SyntaxKind2[SyntaxKind2["EndOfDeclarationMarker"] = 343] = "EndOfDeclarationMarker";
        SyntaxKind2[SyntaxKind2["SyntheticReferenceExpression"] = 344] = "SyntheticReferenceExpression";
        SyntaxKind2[SyntaxKind2["Count"] = 345] = "Count";
        SyntaxKind2[SyntaxKind2["FirstAssignment"] = 62] = "FirstAssignment";
        SyntaxKind2[SyntaxKind2["LastAssignment"] = 77] = "LastAssignment";
        SyntaxKind2[SyntaxKind2["FirstCompoundAssignment"] = 63] = "FirstCompoundAssignment";
        SyntaxKind2[SyntaxKind2["LastCompoundAssignment"] = 77] = "LastCompoundAssignment";
        SyntaxKind2[SyntaxKind2["FirstReservedWord"] = 80] = "FirstReservedWord";
        SyntaxKind2[SyntaxKind2["LastReservedWord"] = 115] = "LastReservedWord";
        SyntaxKind2[SyntaxKind2["FirstKeyword"] = 80] = "FirstKeyword";
        SyntaxKind2[SyntaxKind2["LastKeyword"] = 157] = "LastKeyword";
        SyntaxKind2[SyntaxKind2["FirstFutureReservedWord"] = 116] = "FirstFutureReservedWord";
        SyntaxKind2[SyntaxKind2["LastFutureReservedWord"] = 124] = "LastFutureReservedWord";
        SyntaxKind2[SyntaxKind2["FirstTypeNode"] = 173] = "FirstTypeNode";
        SyntaxKind2[SyntaxKind2["LastTypeNode"] = 196] = "LastTypeNode";
        SyntaxKind2[SyntaxKind2["FirstPunctuation"] = 18] = "FirstPunctuation";
        SyntaxKind2[SyntaxKind2["LastPunctuation"] = 77] = "LastPunctuation";
        SyntaxKind2[SyntaxKind2["FirstToken"] = 0] = "FirstToken";
        SyntaxKind2[SyntaxKind2["LastToken"] = 157] = "LastToken";
        SyntaxKind2[SyntaxKind2["FirstTriviaToken"] = 2] = "FirstTriviaToken";
        SyntaxKind2[SyntaxKind2["LastTriviaToken"] = 7] = "LastTriviaToken";
        SyntaxKind2[SyntaxKind2["FirstLiteralToken"] = 8] = "FirstLiteralToken";
        SyntaxKind2[SyntaxKind2["LastLiteralToken"] = 14] = "LastLiteralToken";
        SyntaxKind2[SyntaxKind2["FirstTemplateToken"] = 14] = "FirstTemplateToken";
        SyntaxKind2[SyntaxKind2["LastTemplateToken"] = 17] = "LastTemplateToken";
        SyntaxKind2[SyntaxKind2["FirstBinaryOperator"] = 29] = "FirstBinaryOperator";
        SyntaxKind2[SyntaxKind2["LastBinaryOperator"] = 77] = "LastBinaryOperator";
        SyntaxKind2[SyntaxKind2["FirstStatement"] = 233] = "FirstStatement";
        SyntaxKind2[SyntaxKind2["LastStatement"] = 249] = "LastStatement";
        SyntaxKind2[SyntaxKind2["FirstNode"] = 158] = "FirstNode";
        SyntaxKind2[SyntaxKind2["FirstJSDocNode"] = 302] = "FirstJSDocNode";
        SyntaxKind2[SyntaxKind2["LastJSDocNode"] = 337] = "LastJSDocNode";
        SyntaxKind2[SyntaxKind2["FirstJSDocTagNode"] = 317] = "FirstJSDocTagNode";
        SyntaxKind2[SyntaxKind2["LastJSDocTagNode"] = 337] = "LastJSDocTagNode";
        SyntaxKind2[SyntaxKind2["FirstContextualKeyword"] = 125] = "FirstContextualKeyword";
        SyntaxKind2[SyntaxKind2["LastContextualKeyword"] = 157] = "LastContextualKeyword";
      })(SyntaxKind = ts3.SyntaxKind || (ts3.SyntaxKind = {}));
      var NodeFlags;
      (function(NodeFlags2) {
        NodeFlags2[NodeFlags2["None"] = 0] = "None";
        NodeFlags2[NodeFlags2["Let"] = 1] = "Let";
        NodeFlags2[NodeFlags2["Const"] = 2] = "Const";
        NodeFlags2[NodeFlags2["NestedNamespace"] = 4] = "NestedNamespace";
        NodeFlags2[NodeFlags2["Synthesized"] = 8] = "Synthesized";
        NodeFlags2[NodeFlags2["Namespace"] = 16] = "Namespace";
        NodeFlags2[NodeFlags2["OptionalChain"] = 32] = "OptionalChain";
        NodeFlags2[NodeFlags2["ExportContext"] = 64] = "ExportContext";
        NodeFlags2[NodeFlags2["ContainsThis"] = 128] = "ContainsThis";
        NodeFlags2[NodeFlags2["HasImplicitReturn"] = 256] = "HasImplicitReturn";
        NodeFlags2[NodeFlags2["HasExplicitReturn"] = 512] = "HasExplicitReturn";
        NodeFlags2[NodeFlags2["GlobalAugmentation"] = 1024] = "GlobalAugmentation";
        NodeFlags2[NodeFlags2["HasAsyncFunctions"] = 2048] = "HasAsyncFunctions";
        NodeFlags2[NodeFlags2["DisallowInContext"] = 4096] = "DisallowInContext";
        NodeFlags2[NodeFlags2["YieldContext"] = 8192] = "YieldContext";
        NodeFlags2[NodeFlags2["DecoratorContext"] = 16384] = "DecoratorContext";
        NodeFlags2[NodeFlags2["AwaitContext"] = 32768] = "AwaitContext";
        NodeFlags2[NodeFlags2["ThisNodeHasError"] = 65536] = "ThisNodeHasError";
        NodeFlags2[NodeFlags2["JavaScriptFile"] = 131072] = "JavaScriptFile";
        NodeFlags2[NodeFlags2["ThisNodeOrAnySubNodesHasError"] = 262144] = "ThisNodeOrAnySubNodesHasError";
        NodeFlags2[NodeFlags2["HasAggregatedChildData"] = 524288] = "HasAggregatedChildData";
        NodeFlags2[NodeFlags2["PossiblyContainsDynamicImport"] = 1048576] = "PossiblyContainsDynamicImport";
        NodeFlags2[NodeFlags2["PossiblyContainsImportMeta"] = 2097152] = "PossiblyContainsImportMeta";
        NodeFlags2[NodeFlags2["JSDoc"] = 4194304] = "JSDoc";
        NodeFlags2[NodeFlags2["Ambient"] = 8388608] = "Ambient";
        NodeFlags2[NodeFlags2["InWithStatement"] = 16777216] = "InWithStatement";
        NodeFlags2[NodeFlags2["JsonFile"] = 33554432] = "JsonFile";
        NodeFlags2[NodeFlags2["TypeCached"] = 67108864] = "TypeCached";
        NodeFlags2[NodeFlags2["Deprecated"] = 134217728] = "Deprecated";
        NodeFlags2[NodeFlags2["BlockScoped"] = 3] = "BlockScoped";
        NodeFlags2[NodeFlags2["ReachabilityCheckFlags"] = 768] = "ReachabilityCheckFlags";
        NodeFlags2[NodeFlags2["ReachabilityAndEmitFlags"] = 2816] = "ReachabilityAndEmitFlags";
        NodeFlags2[NodeFlags2["ContextFlags"] = 25358336] = "ContextFlags";
        NodeFlags2[NodeFlags2["TypeExcludesFlags"] = 40960] = "TypeExcludesFlags";
        NodeFlags2[NodeFlags2["PermanentlySetIncrementalFlags"] = 3145728] = "PermanentlySetIncrementalFlags";
      })(NodeFlags = ts3.NodeFlags || (ts3.NodeFlags = {}));
      var ModifierFlags;
      (function(ModifierFlags2) {
        ModifierFlags2[ModifierFlags2["None"] = 0] = "None";
        ModifierFlags2[ModifierFlags2["Export"] = 1] = "Export";
        ModifierFlags2[ModifierFlags2["Ambient"] = 2] = "Ambient";
        ModifierFlags2[ModifierFlags2["Public"] = 4] = "Public";
        ModifierFlags2[ModifierFlags2["Private"] = 8] = "Private";
        ModifierFlags2[ModifierFlags2["Protected"] = 16] = "Protected";
        ModifierFlags2[ModifierFlags2["Static"] = 32] = "Static";
        ModifierFlags2[ModifierFlags2["Readonly"] = 64] = "Readonly";
        ModifierFlags2[ModifierFlags2["Abstract"] = 128] = "Abstract";
        ModifierFlags2[ModifierFlags2["Async"] = 256] = "Async";
        ModifierFlags2[ModifierFlags2["Default"] = 512] = "Default";
        ModifierFlags2[ModifierFlags2["Const"] = 2048] = "Const";
        ModifierFlags2[ModifierFlags2["HasComputedJSDocModifiers"] = 4096] = "HasComputedJSDocModifiers";
        ModifierFlags2[ModifierFlags2["Deprecated"] = 8192] = "Deprecated";
        ModifierFlags2[ModifierFlags2["Override"] = 16384] = "Override";
        ModifierFlags2[ModifierFlags2["HasComputedFlags"] = 536870912] = "HasComputedFlags";
        ModifierFlags2[ModifierFlags2["AccessibilityModifier"] = 28] = "AccessibilityModifier";
        ModifierFlags2[ModifierFlags2["ParameterPropertyModifier"] = 16476] = "ParameterPropertyModifier";
        ModifierFlags2[ModifierFlags2["NonPublicAccessibilityModifier"] = 24] = "NonPublicAccessibilityModifier";
        ModifierFlags2[ModifierFlags2["TypeScriptModifier"] = 18654] = "TypeScriptModifier";
        ModifierFlags2[ModifierFlags2["ExportDefault"] = 513] = "ExportDefault";
        ModifierFlags2[ModifierFlags2["All"] = 27647] = "All";
      })(ModifierFlags = ts3.ModifierFlags || (ts3.ModifierFlags = {}));
      var JsxFlags;
      (function(JsxFlags2) {
        JsxFlags2[JsxFlags2["None"] = 0] = "None";
        JsxFlags2[JsxFlags2["IntrinsicNamedElement"] = 1] = "IntrinsicNamedElement";
        JsxFlags2[JsxFlags2["IntrinsicIndexedElement"] = 2] = "IntrinsicIndexedElement";
        JsxFlags2[JsxFlags2["IntrinsicElement"] = 3] = "IntrinsicElement";
      })(JsxFlags = ts3.JsxFlags || (ts3.JsxFlags = {}));
      var RelationComparisonResult;
      (function(RelationComparisonResult2) {
        RelationComparisonResult2[RelationComparisonResult2["Succeeded"] = 1] = "Succeeded";
        RelationComparisonResult2[RelationComparisonResult2["Failed"] = 2] = "Failed";
        RelationComparisonResult2[RelationComparisonResult2["Reported"] = 4] = "Reported";
        RelationComparisonResult2[RelationComparisonResult2["ReportsUnmeasurable"] = 8] = "ReportsUnmeasurable";
        RelationComparisonResult2[RelationComparisonResult2["ReportsUnreliable"] = 16] = "ReportsUnreliable";
        RelationComparisonResult2[RelationComparisonResult2["ReportsMask"] = 24] = "ReportsMask";
      })(RelationComparisonResult = ts3.RelationComparisonResult || (ts3.RelationComparisonResult = {}));
      var GeneratedIdentifierFlags;
      (function(GeneratedIdentifierFlags2) {
        GeneratedIdentifierFlags2[GeneratedIdentifierFlags2["None"] = 0] = "None";
        GeneratedIdentifierFlags2[GeneratedIdentifierFlags2["Auto"] = 1] = "Auto";
        GeneratedIdentifierFlags2[GeneratedIdentifierFlags2["Loop"] = 2] = "Loop";
        GeneratedIdentifierFlags2[GeneratedIdentifierFlags2["Unique"] = 3] = "Unique";
        GeneratedIdentifierFlags2[GeneratedIdentifierFlags2["Node"] = 4] = "Node";
        GeneratedIdentifierFlags2[GeneratedIdentifierFlags2["KindMask"] = 7] = "KindMask";
        GeneratedIdentifierFlags2[GeneratedIdentifierFlags2["ReservedInNestedScopes"] = 8] = "ReservedInNestedScopes";
        GeneratedIdentifierFlags2[GeneratedIdentifierFlags2["Optimistic"] = 16] = "Optimistic";
        GeneratedIdentifierFlags2[GeneratedIdentifierFlags2["FileLevel"] = 32] = "FileLevel";
        GeneratedIdentifierFlags2[GeneratedIdentifierFlags2["AllowNameSubstitution"] = 64] = "AllowNameSubstitution";
      })(GeneratedIdentifierFlags = ts3.GeneratedIdentifierFlags || (ts3.GeneratedIdentifierFlags = {}));
      var TokenFlags;
      (function(TokenFlags2) {
        TokenFlags2[TokenFlags2["None"] = 0] = "None";
        TokenFlags2[TokenFlags2["PrecedingLineBreak"] = 1] = "PrecedingLineBreak";
        TokenFlags2[TokenFlags2["PrecedingJSDocComment"] = 2] = "PrecedingJSDocComment";
        TokenFlags2[TokenFlags2["Unterminated"] = 4] = "Unterminated";
        TokenFlags2[TokenFlags2["ExtendedUnicodeEscape"] = 8] = "ExtendedUnicodeEscape";
        TokenFlags2[TokenFlags2["Scientific"] = 16] = "Scientific";
        TokenFlags2[TokenFlags2["Octal"] = 32] = "Octal";
        TokenFlags2[TokenFlags2["HexSpecifier"] = 64] = "HexSpecifier";
        TokenFlags2[TokenFlags2["BinarySpecifier"] = 128] = "BinarySpecifier";
        TokenFlags2[TokenFlags2["OctalSpecifier"] = 256] = "OctalSpecifier";
        TokenFlags2[TokenFlags2["ContainsSeparator"] = 512] = "ContainsSeparator";
        TokenFlags2[TokenFlags2["UnicodeEscape"] = 1024] = "UnicodeEscape";
        TokenFlags2[TokenFlags2["ContainsInvalidEscape"] = 2048] = "ContainsInvalidEscape";
        TokenFlags2[TokenFlags2["BinaryOrOctalSpecifier"] = 384] = "BinaryOrOctalSpecifier";
        TokenFlags2[TokenFlags2["NumericLiteralFlags"] = 1008] = "NumericLiteralFlags";
        TokenFlags2[TokenFlags2["TemplateLiteralLikeFlags"] = 2048] = "TemplateLiteralLikeFlags";
      })(TokenFlags = ts3.TokenFlags || (ts3.TokenFlags = {}));
      var FlowFlags;
      (function(FlowFlags2) {
        FlowFlags2[FlowFlags2["Unreachable"] = 1] = "Unreachable";
        FlowFlags2[FlowFlags2["Start"] = 2] = "Start";
        FlowFlags2[FlowFlags2["BranchLabel"] = 4] = "BranchLabel";
        FlowFlags2[FlowFlags2["LoopLabel"] = 8] = "LoopLabel";
        FlowFlags2[FlowFlags2["Assignment"] = 16] = "Assignment";
        FlowFlags2[FlowFlags2["TrueCondition"] = 32] = "TrueCondition";
        FlowFlags2[FlowFlags2["FalseCondition"] = 64] = "FalseCondition";
        FlowFlags2[FlowFlags2["SwitchClause"] = 128] = "SwitchClause";
        FlowFlags2[FlowFlags2["ArrayMutation"] = 256] = "ArrayMutation";
        FlowFlags2[FlowFlags2["Call"] = 512] = "Call";
        FlowFlags2[FlowFlags2["ReduceLabel"] = 1024] = "ReduceLabel";
        FlowFlags2[FlowFlags2["Referenced"] = 2048] = "Referenced";
        FlowFlags2[FlowFlags2["Shared"] = 4096] = "Shared";
        FlowFlags2[FlowFlags2["Label"] = 12] = "Label";
        FlowFlags2[FlowFlags2["Condition"] = 96] = "Condition";
      })(FlowFlags = ts3.FlowFlags || (ts3.FlowFlags = {}));
      var CommentDirectiveType;
      (function(CommentDirectiveType2) {
        CommentDirectiveType2[CommentDirectiveType2["ExpectError"] = 0] = "ExpectError";
        CommentDirectiveType2[CommentDirectiveType2["Ignore"] = 1] = "Ignore";
      })(CommentDirectiveType = ts3.CommentDirectiveType || (ts3.CommentDirectiveType = {}));
      var OperationCanceledException = function() {
        function OperationCanceledException2() {
        }
        return OperationCanceledException2;
      }();
      ts3.OperationCanceledException = OperationCanceledException;
      var FileIncludeKind;
      (function(FileIncludeKind2) {
        FileIncludeKind2[FileIncludeKind2["RootFile"] = 0] = "RootFile";
        FileIncludeKind2[FileIncludeKind2["SourceFromProjectReference"] = 1] = "SourceFromProjectReference";
        FileIncludeKind2[FileIncludeKind2["OutputFromProjectReference"] = 2] = "OutputFromProjectReference";
        FileIncludeKind2[FileIncludeKind2["Import"] = 3] = "Import";
        FileIncludeKind2[FileIncludeKind2["ReferenceFile"] = 4] = "ReferenceFile";
        FileIncludeKind2[FileIncludeKind2["TypeReferenceDirective"] = 5] = "TypeReferenceDirective";
        FileIncludeKind2[FileIncludeKind2["LibFile"] = 6] = "LibFile";
        FileIncludeKind2[FileIncludeKind2["LibReferenceDirective"] = 7] = "LibReferenceDirective";
        FileIncludeKind2[FileIncludeKind2["AutomaticTypeDirectiveFile"] = 8] = "AutomaticTypeDirectiveFile";
      })(FileIncludeKind = ts3.FileIncludeKind || (ts3.FileIncludeKind = {}));
      var FilePreprocessingDiagnosticsKind;
      (function(FilePreprocessingDiagnosticsKind2) {
        FilePreprocessingDiagnosticsKind2[FilePreprocessingDiagnosticsKind2["FilePreprocessingReferencedDiagnostic"] = 0] = "FilePreprocessingReferencedDiagnostic";
        FilePreprocessingDiagnosticsKind2[FilePreprocessingDiagnosticsKind2["FilePreprocessingFileExplainingDiagnostic"] = 1] = "FilePreprocessingFileExplainingDiagnostic";
      })(FilePreprocessingDiagnosticsKind = ts3.FilePreprocessingDiagnosticsKind || (ts3.FilePreprocessingDiagnosticsKind = {}));
      var StructureIsReused;
      (function(StructureIsReused2) {
        StructureIsReused2[StructureIsReused2["Not"] = 0] = "Not";
        StructureIsReused2[StructureIsReused2["SafeModules"] = 1] = "SafeModules";
        StructureIsReused2[StructureIsReused2["Completely"] = 2] = "Completely";
      })(StructureIsReused = ts3.StructureIsReused || (ts3.StructureIsReused = {}));
      var ExitStatus2;
      (function(ExitStatus3) {
        ExitStatus3[ExitStatus3["Success"] = 0] = "Success";
        ExitStatus3[ExitStatus3["DiagnosticsPresent_OutputsSkipped"] = 1] = "DiagnosticsPresent_OutputsSkipped";
        ExitStatus3[ExitStatus3["DiagnosticsPresent_OutputsGenerated"] = 2] = "DiagnosticsPresent_OutputsGenerated";
        ExitStatus3[ExitStatus3["InvalidProject_OutputsSkipped"] = 3] = "InvalidProject_OutputsSkipped";
        ExitStatus3[ExitStatus3["ProjectReferenceCycle_OutputsSkipped"] = 4] = "ProjectReferenceCycle_OutputsSkipped";
        ExitStatus3[ExitStatus3["ProjectReferenceCycle_OutputsSkupped"] = 4] = "ProjectReferenceCycle_OutputsSkupped";
      })(ExitStatus2 = ts3.ExitStatus || (ts3.ExitStatus = {}));
      var UnionReduction;
      (function(UnionReduction2) {
        UnionReduction2[UnionReduction2["None"] = 0] = "None";
        UnionReduction2[UnionReduction2["Literal"] = 1] = "Literal";
        UnionReduction2[UnionReduction2["Subtype"] = 2] = "Subtype";
      })(UnionReduction = ts3.UnionReduction || (ts3.UnionReduction = {}));
      var ContextFlags;
      (function(ContextFlags2) {
        ContextFlags2[ContextFlags2["None"] = 0] = "None";
        ContextFlags2[ContextFlags2["Signature"] = 1] = "Signature";
        ContextFlags2[ContextFlags2["NoConstraints"] = 2] = "NoConstraints";
        ContextFlags2[ContextFlags2["Completions"] = 4] = "Completions";
        ContextFlags2[ContextFlags2["SkipBindingPatterns"] = 8] = "SkipBindingPatterns";
      })(ContextFlags = ts3.ContextFlags || (ts3.ContextFlags = {}));
      var NodeBuilderFlags;
      (function(NodeBuilderFlags2) {
        NodeBuilderFlags2[NodeBuilderFlags2["None"] = 0] = "None";
        NodeBuilderFlags2[NodeBuilderFlags2["NoTruncation"] = 1] = "NoTruncation";
        NodeBuilderFlags2[NodeBuilderFlags2["WriteArrayAsGenericType"] = 2] = "WriteArrayAsGenericType";
        NodeBuilderFlags2[NodeBuilderFlags2["GenerateNamesForShadowedTypeParams"] = 4] = "GenerateNamesForShadowedTypeParams";
        NodeBuilderFlags2[NodeBuilderFlags2["UseStructuralFallback"] = 8] = "UseStructuralFallback";
        NodeBuilderFlags2[NodeBuilderFlags2["ForbidIndexedAccessSymbolReferences"] = 16] = "ForbidIndexedAccessSymbolReferences";
        NodeBuilderFlags2[NodeBuilderFlags2["WriteTypeArgumentsOfSignature"] = 32] = "WriteTypeArgumentsOfSignature";
        NodeBuilderFlags2[NodeBuilderFlags2["UseFullyQualifiedType"] = 64] = "UseFullyQualifiedType";
        NodeBuilderFlags2[NodeBuilderFlags2["UseOnlyExternalAliasing"] = 128] = "UseOnlyExternalAliasing";
        NodeBuilderFlags2[NodeBuilderFlags2["SuppressAnyReturnType"] = 256] = "SuppressAnyReturnType";
        NodeBuilderFlags2[NodeBuilderFlags2["WriteTypeParametersInQualifiedName"] = 512] = "WriteTypeParametersInQualifiedName";
        NodeBuilderFlags2[NodeBuilderFlags2["MultilineObjectLiterals"] = 1024] = "MultilineObjectLiterals";
        NodeBuilderFlags2[NodeBuilderFlags2["WriteClassExpressionAsTypeLiteral"] = 2048] = "WriteClassExpressionAsTypeLiteral";
        NodeBuilderFlags2[NodeBuilderFlags2["UseTypeOfFunction"] = 4096] = "UseTypeOfFunction";
        NodeBuilderFlags2[NodeBuilderFlags2["OmitParameterModifiers"] = 8192] = "OmitParameterModifiers";
        NodeBuilderFlags2[NodeBuilderFlags2["UseAliasDefinedOutsideCurrentScope"] = 16384] = "UseAliasDefinedOutsideCurrentScope";
        NodeBuilderFlags2[NodeBuilderFlags2["UseSingleQuotesForStringLiteralType"] = 268435456] = "UseSingleQuotesForStringLiteralType";
        NodeBuilderFlags2[NodeBuilderFlags2["NoTypeReduction"] = 536870912] = "NoTypeReduction";
        NodeBuilderFlags2[NodeBuilderFlags2["NoUndefinedOptionalParameterType"] = 1073741824] = "NoUndefinedOptionalParameterType";
        NodeBuilderFlags2[NodeBuilderFlags2["AllowThisInObjectLiteral"] = 32768] = "AllowThisInObjectLiteral";
        NodeBuilderFlags2[NodeBuilderFlags2["AllowQualifiedNameInPlaceOfIdentifier"] = 65536] = "AllowQualifiedNameInPlaceOfIdentifier";
        NodeBuilderFlags2[NodeBuilderFlags2["AllowQualifedNameInPlaceOfIdentifier"] = 65536] = "AllowQualifedNameInPlaceOfIdentifier";
        NodeBuilderFlags2[NodeBuilderFlags2["AllowAnonymousIdentifier"] = 131072] = "AllowAnonymousIdentifier";
        NodeBuilderFlags2[NodeBuilderFlags2["AllowEmptyUnionOrIntersection"] = 262144] = "AllowEmptyUnionOrIntersection";
        NodeBuilderFlags2[NodeBuilderFlags2["AllowEmptyTuple"] = 524288] = "AllowEmptyTuple";
        NodeBuilderFlags2[NodeBuilderFlags2["AllowUniqueESSymbolType"] = 1048576] = "AllowUniqueESSymbolType";
        NodeBuilderFlags2[NodeBuilderFlags2["AllowEmptyIndexInfoType"] = 2097152] = "AllowEmptyIndexInfoType";
        NodeBuilderFlags2[NodeBuilderFlags2["AllowNodeModulesRelativePaths"] = 67108864] = "AllowNodeModulesRelativePaths";
        NodeBuilderFlags2[NodeBuilderFlags2["DoNotIncludeSymbolChain"] = 134217728] = "DoNotIncludeSymbolChain";
        NodeBuilderFlags2[NodeBuilderFlags2["IgnoreErrors"] = 70221824] = "IgnoreErrors";
        NodeBuilderFlags2[NodeBuilderFlags2["InObjectTypeLiteral"] = 4194304] = "InObjectTypeLiteral";
        NodeBuilderFlags2[NodeBuilderFlags2["InTypeAlias"] = 8388608] = "InTypeAlias";
        NodeBuilderFlags2[NodeBuilderFlags2["InInitialEntityName"] = 16777216] = "InInitialEntityName";
      })(NodeBuilderFlags = ts3.NodeBuilderFlags || (ts3.NodeBuilderFlags = {}));
      var TypeFormatFlags;
      (function(TypeFormatFlags2) {
        TypeFormatFlags2[TypeFormatFlags2["None"] = 0] = "None";
        TypeFormatFlags2[TypeFormatFlags2["NoTruncation"] = 1] = "NoTruncation";
        TypeFormatFlags2[TypeFormatFlags2["WriteArrayAsGenericType"] = 2] = "WriteArrayAsGenericType";
        TypeFormatFlags2[TypeFormatFlags2["UseStructuralFallback"] = 8] = "UseStructuralFallback";
        TypeFormatFlags2[TypeFormatFlags2["WriteTypeArgumentsOfSignature"] = 32] = "WriteTypeArgumentsOfSignature";
        TypeFormatFlags2[TypeFormatFlags2["UseFullyQualifiedType"] = 64] = "UseFullyQualifiedType";
        TypeFormatFlags2[TypeFormatFlags2["SuppressAnyReturnType"] = 256] = "SuppressAnyReturnType";
        TypeFormatFlags2[TypeFormatFlags2["MultilineObjectLiterals"] = 1024] = "MultilineObjectLiterals";
        TypeFormatFlags2[TypeFormatFlags2["WriteClassExpressionAsTypeLiteral"] = 2048] = "WriteClassExpressionAsTypeLiteral";
        TypeFormatFlags2[TypeFormatFlags2["UseTypeOfFunction"] = 4096] = "UseTypeOfFunction";
        TypeFormatFlags2[TypeFormatFlags2["OmitParameterModifiers"] = 8192] = "OmitParameterModifiers";
        TypeFormatFlags2[TypeFormatFlags2["UseAliasDefinedOutsideCurrentScope"] = 16384] = "UseAliasDefinedOutsideCurrentScope";
        TypeFormatFlags2[TypeFormatFlags2["UseSingleQuotesForStringLiteralType"] = 268435456] = "UseSingleQuotesForStringLiteralType";
        TypeFormatFlags2[TypeFormatFlags2["NoTypeReduction"] = 536870912] = "NoTypeReduction";
        TypeFormatFlags2[TypeFormatFlags2["AllowUniqueESSymbolType"] = 1048576] = "AllowUniqueESSymbolType";
        TypeFormatFlags2[TypeFormatFlags2["AddUndefined"] = 131072] = "AddUndefined";
        TypeFormatFlags2[TypeFormatFlags2["WriteArrowStyleSignature"] = 262144] = "WriteArrowStyleSignature";
        TypeFormatFlags2[TypeFormatFlags2["InArrayType"] = 524288] = "InArrayType";
        TypeFormatFlags2[TypeFormatFlags2["InElementType"] = 2097152] = "InElementType";
        TypeFormatFlags2[TypeFormatFlags2["InFirstTypeArgument"] = 4194304] = "InFirstTypeArgument";
        TypeFormatFlags2[TypeFormatFlags2["InTypeAlias"] = 8388608] = "InTypeAlias";
        TypeFormatFlags2[TypeFormatFlags2["WriteOwnNameForAnyLike"] = 0] = "WriteOwnNameForAnyLike";
        TypeFormatFlags2[TypeFormatFlags2["NodeBuilderFlagsMask"] = 814775659] = "NodeBuilderFlagsMask";
      })(TypeFormatFlags = ts3.TypeFormatFlags || (ts3.TypeFormatFlags = {}));
      var SymbolFormatFlags;
      (function(SymbolFormatFlags2) {
        SymbolFormatFlags2[SymbolFormatFlags2["None"] = 0] = "None";
        SymbolFormatFlags2[SymbolFormatFlags2["WriteTypeParametersOrArguments"] = 1] = "WriteTypeParametersOrArguments";
        SymbolFormatFlags2[SymbolFormatFlags2["UseOnlyExternalAliasing"] = 2] = "UseOnlyExternalAliasing";
        SymbolFormatFlags2[SymbolFormatFlags2["AllowAnyNodeKind"] = 4] = "AllowAnyNodeKind";
        SymbolFormatFlags2[SymbolFormatFlags2["UseAliasDefinedOutsideCurrentScope"] = 8] = "UseAliasDefinedOutsideCurrentScope";
        SymbolFormatFlags2[SymbolFormatFlags2["DoNotIncludeSymbolChain"] = 16] = "DoNotIncludeSymbolChain";
      })(SymbolFormatFlags = ts3.SymbolFormatFlags || (ts3.SymbolFormatFlags = {}));
      var SymbolAccessibility;
      (function(SymbolAccessibility2) {
        SymbolAccessibility2[SymbolAccessibility2["Accessible"] = 0] = "Accessible";
        SymbolAccessibility2[SymbolAccessibility2["NotAccessible"] = 1] = "NotAccessible";
        SymbolAccessibility2[SymbolAccessibility2["CannotBeNamed"] = 2] = "CannotBeNamed";
      })(SymbolAccessibility = ts3.SymbolAccessibility || (ts3.SymbolAccessibility = {}));
      var SyntheticSymbolKind;
      (function(SyntheticSymbolKind2) {
        SyntheticSymbolKind2[SyntheticSymbolKind2["UnionOrIntersection"] = 0] = "UnionOrIntersection";
        SyntheticSymbolKind2[SyntheticSymbolKind2["Spread"] = 1] = "Spread";
      })(SyntheticSymbolKind = ts3.SyntheticSymbolKind || (ts3.SyntheticSymbolKind = {}));
      var TypePredicateKind;
      (function(TypePredicateKind2) {
        TypePredicateKind2[TypePredicateKind2["This"] = 0] = "This";
        TypePredicateKind2[TypePredicateKind2["Identifier"] = 1] = "Identifier";
        TypePredicateKind2[TypePredicateKind2["AssertsThis"] = 2] = "AssertsThis";
        TypePredicateKind2[TypePredicateKind2["AssertsIdentifier"] = 3] = "AssertsIdentifier";
      })(TypePredicateKind = ts3.TypePredicateKind || (ts3.TypePredicateKind = {}));
      var TypeReferenceSerializationKind;
      (function(TypeReferenceSerializationKind2) {
        TypeReferenceSerializationKind2[TypeReferenceSerializationKind2["Unknown"] = 0] = "Unknown";
        TypeReferenceSerializationKind2[TypeReferenceSerializationKind2["TypeWithConstructSignatureAndValue"] = 1] = "TypeWithConstructSignatureAndValue";
        TypeReferenceSerializationKind2[TypeReferenceSerializationKind2["VoidNullableOrNeverType"] = 2] = "VoidNullableOrNeverType";
        TypeReferenceSerializationKind2[TypeReferenceSerializationKind2["NumberLikeType"] = 3] = "NumberLikeType";
        TypeReferenceSerializationKind2[TypeReferenceSerializationKind2["BigIntLikeType"] = 4] = "BigIntLikeType";
        TypeReferenceSerializationKind2[TypeReferenceSerializationKind2["StringLikeType"] = 5] = "StringLikeType";
        TypeReferenceSerializationKind2[TypeReferenceSerializationKind2["BooleanType"] = 6] = "BooleanType";
        TypeReferenceSerializationKind2[TypeReferenceSerializationKind2["ArrayLikeType"] = 7] = "ArrayLikeType";
        TypeReferenceSerializationKind2[TypeReferenceSerializationKind2["ESSymbolType"] = 8] = "ESSymbolType";
        TypeReferenceSerializationKind2[TypeReferenceSerializationKind2["Promise"] = 9] = "Promise";
        TypeReferenceSerializationKind2[TypeReferenceSerializationKind2["TypeWithCallSignature"] = 10] = "TypeWithCallSignature";
        TypeReferenceSerializationKind2[TypeReferenceSerializationKind2["ObjectType"] = 11] = "ObjectType";
      })(TypeReferenceSerializationKind = ts3.TypeReferenceSerializationKind || (ts3.TypeReferenceSerializationKind = {}));
      var SymbolFlags;
      (function(SymbolFlags2) {
        SymbolFlags2[SymbolFlags2["None"] = 0] = "None";
        SymbolFlags2[SymbolFlags2["FunctionScopedVariable"] = 1] = "FunctionScopedVariable";
        SymbolFlags2[SymbolFlags2["BlockScopedVariable"] = 2] = "BlockScopedVariable";
        SymbolFlags2[SymbolFlags2["Property"] = 4] = "Property";
        SymbolFlags2[SymbolFlags2["EnumMember"] = 8] = "EnumMember";
        SymbolFlags2[SymbolFlags2["Function"] = 16] = "Function";
        SymbolFlags2[SymbolFlags2["Class"] = 32] = "Class";
        SymbolFlags2[SymbolFlags2["Interface"] = 64] = "Interface";
        SymbolFlags2[SymbolFlags2["ConstEnum"] = 128] = "ConstEnum";
        SymbolFlags2[SymbolFlags2["RegularEnum"] = 256] = "RegularEnum";
        SymbolFlags2[SymbolFlags2["ValueModule"] = 512] = "ValueModule";
        SymbolFlags2[SymbolFlags2["NamespaceModule"] = 1024] = "NamespaceModule";
        SymbolFlags2[SymbolFlags2["TypeLiteral"] = 2048] = "TypeLiteral";
        SymbolFlags2[SymbolFlags2["ObjectLiteral"] = 4096] = "ObjectLiteral";
        SymbolFlags2[SymbolFlags2["Method"] = 8192] = "Method";
        SymbolFlags2[SymbolFlags2["Constructor"] = 16384] = "Constructor";
        SymbolFlags2[SymbolFlags2["GetAccessor"] = 32768] = "GetAccessor";
        SymbolFlags2[SymbolFlags2["SetAccessor"] = 65536] = "SetAccessor";
        SymbolFlags2[SymbolFlags2["Signature"] = 131072] = "Signature";
        SymbolFlags2[SymbolFlags2["TypeParameter"] = 262144] = "TypeParameter";
        SymbolFlags2[SymbolFlags2["TypeAlias"] = 524288] = "TypeAlias";
        SymbolFlags2[SymbolFlags2["ExportValue"] = 1048576] = "ExportValue";
        SymbolFlags2[SymbolFlags2["Alias"] = 2097152] = "Alias";
        SymbolFlags2[SymbolFlags2["Prototype"] = 4194304] = "Prototype";
        SymbolFlags2[SymbolFlags2["ExportStar"] = 8388608] = "ExportStar";
        SymbolFlags2[SymbolFlags2["Optional"] = 16777216] = "Optional";
        SymbolFlags2[SymbolFlags2["Transient"] = 33554432] = "Transient";
        SymbolFlags2[SymbolFlags2["Assignment"] = 67108864] = "Assignment";
        SymbolFlags2[SymbolFlags2["ModuleExports"] = 134217728] = "ModuleExports";
        SymbolFlags2[SymbolFlags2["All"] = 67108863] = "All";
        SymbolFlags2[SymbolFlags2["Enum"] = 384] = "Enum";
        SymbolFlags2[SymbolFlags2["Variable"] = 3] = "Variable";
        SymbolFlags2[SymbolFlags2["Value"] = 111551] = "Value";
        SymbolFlags2[SymbolFlags2["Type"] = 788968] = "Type";
        SymbolFlags2[SymbolFlags2["Namespace"] = 1920] = "Namespace";
        SymbolFlags2[SymbolFlags2["Module"] = 1536] = "Module";
        SymbolFlags2[SymbolFlags2["Accessor"] = 98304] = "Accessor";
        SymbolFlags2[SymbolFlags2["FunctionScopedVariableExcludes"] = 111550] = "FunctionScopedVariableExcludes";
        SymbolFlags2[SymbolFlags2["BlockScopedVariableExcludes"] = 111551] = "BlockScopedVariableExcludes";
        SymbolFlags2[SymbolFlags2["ParameterExcludes"] = 111551] = "ParameterExcludes";
        SymbolFlags2[SymbolFlags2["PropertyExcludes"] = 0] = "PropertyExcludes";
        SymbolFlags2[SymbolFlags2["EnumMemberExcludes"] = 900095] = "EnumMemberExcludes";
        SymbolFlags2[SymbolFlags2["FunctionExcludes"] = 110991] = "FunctionExcludes";
        SymbolFlags2[SymbolFlags2["ClassExcludes"] = 899503] = "ClassExcludes";
        SymbolFlags2[SymbolFlags2["InterfaceExcludes"] = 788872] = "InterfaceExcludes";
        SymbolFlags2[SymbolFlags2["RegularEnumExcludes"] = 899327] = "RegularEnumExcludes";
        SymbolFlags2[SymbolFlags2["ConstEnumExcludes"] = 899967] = "ConstEnumExcludes";
        SymbolFlags2[SymbolFlags2["ValueModuleExcludes"] = 110735] = "ValueModuleExcludes";
        SymbolFlags2[SymbolFlags2["NamespaceModuleExcludes"] = 0] = "NamespaceModuleExcludes";
        SymbolFlags2[SymbolFlags2["MethodExcludes"] = 103359] = "MethodExcludes";
        SymbolFlags2[SymbolFlags2["GetAccessorExcludes"] = 46015] = "GetAccessorExcludes";
        SymbolFlags2[SymbolFlags2["SetAccessorExcludes"] = 78783] = "SetAccessorExcludes";
        SymbolFlags2[SymbolFlags2["TypeParameterExcludes"] = 526824] = "TypeParameterExcludes";
        SymbolFlags2[SymbolFlags2["TypeAliasExcludes"] = 788968] = "TypeAliasExcludes";
        SymbolFlags2[SymbolFlags2["AliasExcludes"] = 2097152] = "AliasExcludes";
        SymbolFlags2[SymbolFlags2["ModuleMember"] = 2623475] = "ModuleMember";
        SymbolFlags2[SymbolFlags2["ExportHasLocal"] = 944] = "ExportHasLocal";
        SymbolFlags2[SymbolFlags2["BlockScoped"] = 418] = "BlockScoped";
        SymbolFlags2[SymbolFlags2["PropertyOrAccessor"] = 98308] = "PropertyOrAccessor";
        SymbolFlags2[SymbolFlags2["ClassMember"] = 106500] = "ClassMember";
        SymbolFlags2[SymbolFlags2["ExportSupportsDefaultModifier"] = 112] = "ExportSupportsDefaultModifier";
        SymbolFlags2[SymbolFlags2["ExportDoesNotSupportDefaultModifier"] = -113] = "ExportDoesNotSupportDefaultModifier";
        SymbolFlags2[SymbolFlags2["Classifiable"] = 2885600] = "Classifiable";
        SymbolFlags2[SymbolFlags2["LateBindingContainer"] = 6256] = "LateBindingContainer";
      })(SymbolFlags = ts3.SymbolFlags || (ts3.SymbolFlags = {}));
      var EnumKind;
      (function(EnumKind2) {
        EnumKind2[EnumKind2["Numeric"] = 0] = "Numeric";
        EnumKind2[EnumKind2["Literal"] = 1] = "Literal";
      })(EnumKind = ts3.EnumKind || (ts3.EnumKind = {}));
      var CheckFlags;
      (function(CheckFlags2) {
        CheckFlags2[CheckFlags2["Instantiated"] = 1] = "Instantiated";
        CheckFlags2[CheckFlags2["SyntheticProperty"] = 2] = "SyntheticProperty";
        CheckFlags2[CheckFlags2["SyntheticMethod"] = 4] = "SyntheticMethod";
        CheckFlags2[CheckFlags2["Readonly"] = 8] = "Readonly";
        CheckFlags2[CheckFlags2["ReadPartial"] = 16] = "ReadPartial";
        CheckFlags2[CheckFlags2["WritePartial"] = 32] = "WritePartial";
        CheckFlags2[CheckFlags2["HasNonUniformType"] = 64] = "HasNonUniformType";
        CheckFlags2[CheckFlags2["HasLiteralType"] = 128] = "HasLiteralType";
        CheckFlags2[CheckFlags2["ContainsPublic"] = 256] = "ContainsPublic";
        CheckFlags2[CheckFlags2["ContainsProtected"] = 512] = "ContainsProtected";
        CheckFlags2[CheckFlags2["ContainsPrivate"] = 1024] = "ContainsPrivate";
        CheckFlags2[CheckFlags2["ContainsStatic"] = 2048] = "ContainsStatic";
        CheckFlags2[CheckFlags2["Late"] = 4096] = "Late";
        CheckFlags2[CheckFlags2["ReverseMapped"] = 8192] = "ReverseMapped";
        CheckFlags2[CheckFlags2["OptionalParameter"] = 16384] = "OptionalParameter";
        CheckFlags2[CheckFlags2["RestParameter"] = 32768] = "RestParameter";
        CheckFlags2[CheckFlags2["DeferredType"] = 65536] = "DeferredType";
        CheckFlags2[CheckFlags2["HasNeverType"] = 131072] = "HasNeverType";
        CheckFlags2[CheckFlags2["Mapped"] = 262144] = "Mapped";
        CheckFlags2[CheckFlags2["StripOptional"] = 524288] = "StripOptional";
        CheckFlags2[CheckFlags2["Synthetic"] = 6] = "Synthetic";
        CheckFlags2[CheckFlags2["Discriminant"] = 192] = "Discriminant";
        CheckFlags2[CheckFlags2["Partial"] = 48] = "Partial";
      })(CheckFlags = ts3.CheckFlags || (ts3.CheckFlags = {}));
      var InternalSymbolName;
      (function(InternalSymbolName2) {
        InternalSymbolName2["Call"] = "__call";
        InternalSymbolName2["Constructor"] = "__constructor";
        InternalSymbolName2["New"] = "__new";
        InternalSymbolName2["Index"] = "__index";
        InternalSymbolName2["ExportStar"] = "__export";
        InternalSymbolName2["Global"] = "__global";
        InternalSymbolName2["Missing"] = "__missing";
        InternalSymbolName2["Type"] = "__type";
        InternalSymbolName2["Object"] = "__object";
        InternalSymbolName2["JSXAttributes"] = "__jsxAttributes";
        InternalSymbolName2["Class"] = "__class";
        InternalSymbolName2["Function"] = "__function";
        InternalSymbolName2["Computed"] = "__computed";
        InternalSymbolName2["Resolving"] = "__resolving__";
        InternalSymbolName2["ExportEquals"] = "export=";
        InternalSymbolName2["Default"] = "default";
        InternalSymbolName2["This"] = "this";
      })(InternalSymbolName = ts3.InternalSymbolName || (ts3.InternalSymbolName = {}));
      var NodeCheckFlags;
      (function(NodeCheckFlags2) {
        NodeCheckFlags2[NodeCheckFlags2["TypeChecked"] = 1] = "TypeChecked";
        NodeCheckFlags2[NodeCheckFlags2["LexicalThis"] = 2] = "LexicalThis";
        NodeCheckFlags2[NodeCheckFlags2["CaptureThis"] = 4] = "CaptureThis";
        NodeCheckFlags2[NodeCheckFlags2["CaptureNewTarget"] = 8] = "CaptureNewTarget";
        NodeCheckFlags2[NodeCheckFlags2["SuperInstance"] = 256] = "SuperInstance";
        NodeCheckFlags2[NodeCheckFlags2["SuperStatic"] = 512] = "SuperStatic";
        NodeCheckFlags2[NodeCheckFlags2["ContextChecked"] = 1024] = "ContextChecked";
        NodeCheckFlags2[NodeCheckFlags2["AsyncMethodWithSuper"] = 2048] = "AsyncMethodWithSuper";
        NodeCheckFlags2[NodeCheckFlags2["AsyncMethodWithSuperBinding"] = 4096] = "AsyncMethodWithSuperBinding";
        NodeCheckFlags2[NodeCheckFlags2["CaptureArguments"] = 8192] = "CaptureArguments";
        NodeCheckFlags2[NodeCheckFlags2["EnumValuesComputed"] = 16384] = "EnumValuesComputed";
        NodeCheckFlags2[NodeCheckFlags2["LexicalModuleMergesWithClass"] = 32768] = "LexicalModuleMergesWithClass";
        NodeCheckFlags2[NodeCheckFlags2["LoopWithCapturedBlockScopedBinding"] = 65536] = "LoopWithCapturedBlockScopedBinding";
        NodeCheckFlags2[NodeCheckFlags2["ContainsCapturedBlockScopeBinding"] = 131072] = "ContainsCapturedBlockScopeBinding";
        NodeCheckFlags2[NodeCheckFlags2["CapturedBlockScopedBinding"] = 262144] = "CapturedBlockScopedBinding";
        NodeCheckFlags2[NodeCheckFlags2["BlockScopedBindingInLoop"] = 524288] = "BlockScopedBindingInLoop";
        NodeCheckFlags2[NodeCheckFlags2["ClassWithBodyScopedClassBinding"] = 1048576] = "ClassWithBodyScopedClassBinding";
        NodeCheckFlags2[NodeCheckFlags2["BodyScopedClassBinding"] = 2097152] = "BodyScopedClassBinding";
        NodeCheckFlags2[NodeCheckFlags2["NeedsLoopOutParameter"] = 4194304] = "NeedsLoopOutParameter";
        NodeCheckFlags2[NodeCheckFlags2["AssignmentsMarked"] = 8388608] = "AssignmentsMarked";
        NodeCheckFlags2[NodeCheckFlags2["ClassWithConstructorReference"] = 16777216] = "ClassWithConstructorReference";
        NodeCheckFlags2[NodeCheckFlags2["ConstructorReferenceInClass"] = 33554432] = "ConstructorReferenceInClass";
        NodeCheckFlags2[NodeCheckFlags2["ContainsClassWithPrivateIdentifiers"] = 67108864] = "ContainsClassWithPrivateIdentifiers";
      })(NodeCheckFlags = ts3.NodeCheckFlags || (ts3.NodeCheckFlags = {}));
      var TypeFlags;
      (function(TypeFlags2) {
        TypeFlags2[TypeFlags2["Any"] = 1] = "Any";
        TypeFlags2[TypeFlags2["Unknown"] = 2] = "Unknown";
        TypeFlags2[TypeFlags2["String"] = 4] = "String";
        TypeFlags2[TypeFlags2["Number"] = 8] = "Number";
        TypeFlags2[TypeFlags2["Boolean"] = 16] = "Boolean";
        TypeFlags2[TypeFlags2["Enum"] = 32] = "Enum";
        TypeFlags2[TypeFlags2["BigInt"] = 64] = "BigInt";
        TypeFlags2[TypeFlags2["StringLiteral"] = 128] = "StringLiteral";
        TypeFlags2[TypeFlags2["NumberLiteral"] = 256] = "NumberLiteral";
        TypeFlags2[TypeFlags2["BooleanLiteral"] = 512] = "BooleanLiteral";
        TypeFlags2[TypeFlags2["EnumLiteral"] = 1024] = "EnumLiteral";
        TypeFlags2[TypeFlags2["BigIntLiteral"] = 2048] = "BigIntLiteral";
        TypeFlags2[TypeFlags2["ESSymbol"] = 4096] = "ESSymbol";
        TypeFlags2[TypeFlags2["UniqueESSymbol"] = 8192] = "UniqueESSymbol";
        TypeFlags2[TypeFlags2["Void"] = 16384] = "Void";
        TypeFlags2[TypeFlags2["Undefined"] = 32768] = "Undefined";
        TypeFlags2[TypeFlags2["Null"] = 65536] = "Null";
        TypeFlags2[TypeFlags2["Never"] = 131072] = "Never";
        TypeFlags2[TypeFlags2["TypeParameter"] = 262144] = "TypeParameter";
        TypeFlags2[TypeFlags2["Object"] = 524288] = "Object";
        TypeFlags2[TypeFlags2["Union"] = 1048576] = "Union";
        TypeFlags2[TypeFlags2["Intersection"] = 2097152] = "Intersection";
        TypeFlags2[TypeFlags2["Index"] = 4194304] = "Index";
        TypeFlags2[TypeFlags2["IndexedAccess"] = 8388608] = "IndexedAccess";
        TypeFlags2[TypeFlags2["Conditional"] = 16777216] = "Conditional";
        TypeFlags2[TypeFlags2["Substitution"] = 33554432] = "Substitution";
        TypeFlags2[TypeFlags2["NonPrimitive"] = 67108864] = "NonPrimitive";
        TypeFlags2[TypeFlags2["TemplateLiteral"] = 134217728] = "TemplateLiteral";
        TypeFlags2[TypeFlags2["StringMapping"] = 268435456] = "StringMapping";
        TypeFlags2[TypeFlags2["AnyOrUnknown"] = 3] = "AnyOrUnknown";
        TypeFlags2[TypeFlags2["Nullable"] = 98304] = "Nullable";
        TypeFlags2[TypeFlags2["Literal"] = 2944] = "Literal";
        TypeFlags2[TypeFlags2["Unit"] = 109440] = "Unit";
        TypeFlags2[TypeFlags2["StringOrNumberLiteral"] = 384] = "StringOrNumberLiteral";
        TypeFlags2[TypeFlags2["StringOrNumberLiteralOrUnique"] = 8576] = "StringOrNumberLiteralOrUnique";
        TypeFlags2[TypeFlags2["DefinitelyFalsy"] = 117632] = "DefinitelyFalsy";
        TypeFlags2[TypeFlags2["PossiblyFalsy"] = 117724] = "PossiblyFalsy";
        TypeFlags2[TypeFlags2["Intrinsic"] = 67359327] = "Intrinsic";
        TypeFlags2[TypeFlags2["Primitive"] = 131068] = "Primitive";
        TypeFlags2[TypeFlags2["StringLike"] = 402653316] = "StringLike";
        TypeFlags2[TypeFlags2["NumberLike"] = 296] = "NumberLike";
        TypeFlags2[TypeFlags2["BigIntLike"] = 2112] = "BigIntLike";
        TypeFlags2[TypeFlags2["BooleanLike"] = 528] = "BooleanLike";
        TypeFlags2[TypeFlags2["EnumLike"] = 1056] = "EnumLike";
        TypeFlags2[TypeFlags2["ESSymbolLike"] = 12288] = "ESSymbolLike";
        TypeFlags2[TypeFlags2["VoidLike"] = 49152] = "VoidLike";
        TypeFlags2[TypeFlags2["DisjointDomains"] = 469892092] = "DisjointDomains";
        TypeFlags2[TypeFlags2["UnionOrIntersection"] = 3145728] = "UnionOrIntersection";
        TypeFlags2[TypeFlags2["StructuredType"] = 3670016] = "StructuredType";
        TypeFlags2[TypeFlags2["TypeVariable"] = 8650752] = "TypeVariable";
        TypeFlags2[TypeFlags2["InstantiableNonPrimitive"] = 58982400] = "InstantiableNonPrimitive";
        TypeFlags2[TypeFlags2["InstantiablePrimitive"] = 406847488] = "InstantiablePrimitive";
        TypeFlags2[TypeFlags2["Instantiable"] = 465829888] = "Instantiable";
        TypeFlags2[TypeFlags2["StructuredOrInstantiable"] = 469499904] = "StructuredOrInstantiable";
        TypeFlags2[TypeFlags2["ObjectFlagsType"] = 3899393] = "ObjectFlagsType";
        TypeFlags2[TypeFlags2["Simplifiable"] = 25165824] = "Simplifiable";
        TypeFlags2[TypeFlags2["Substructure"] = 469237760] = "Substructure";
        TypeFlags2[TypeFlags2["Narrowable"] = 536624127] = "Narrowable";
        TypeFlags2[TypeFlags2["NotPrimitiveUnion"] = 468598819] = "NotPrimitiveUnion";
        TypeFlags2[TypeFlags2["IncludesMask"] = 205258751] = "IncludesMask";
        TypeFlags2[TypeFlags2["IncludesStructuredOrInstantiable"] = 262144] = "IncludesStructuredOrInstantiable";
        TypeFlags2[TypeFlags2["IncludesNonWideningType"] = 4194304] = "IncludesNonWideningType";
        TypeFlags2[TypeFlags2["IncludesWildcard"] = 8388608] = "IncludesWildcard";
        TypeFlags2[TypeFlags2["IncludesEmptyObject"] = 16777216] = "IncludesEmptyObject";
      })(TypeFlags = ts3.TypeFlags || (ts3.TypeFlags = {}));
      var ObjectFlags;
      (function(ObjectFlags2) {
        ObjectFlags2[ObjectFlags2["Class"] = 1] = "Class";
        ObjectFlags2[ObjectFlags2["Interface"] = 2] = "Interface";
        ObjectFlags2[ObjectFlags2["Reference"] = 4] = "Reference";
        ObjectFlags2[ObjectFlags2["Tuple"] = 8] = "Tuple";
        ObjectFlags2[ObjectFlags2["Anonymous"] = 16] = "Anonymous";
        ObjectFlags2[ObjectFlags2["Mapped"] = 32] = "Mapped";
        ObjectFlags2[ObjectFlags2["Instantiated"] = 64] = "Instantiated";
        ObjectFlags2[ObjectFlags2["ObjectLiteral"] = 128] = "ObjectLiteral";
        ObjectFlags2[ObjectFlags2["EvolvingArray"] = 256] = "EvolvingArray";
        ObjectFlags2[ObjectFlags2["ObjectLiteralPatternWithComputedProperties"] = 512] = "ObjectLiteralPatternWithComputedProperties";
        ObjectFlags2[ObjectFlags2["ReverseMapped"] = 1024] = "ReverseMapped";
        ObjectFlags2[ObjectFlags2["JsxAttributes"] = 2048] = "JsxAttributes";
        ObjectFlags2[ObjectFlags2["MarkerType"] = 4096] = "MarkerType";
        ObjectFlags2[ObjectFlags2["JSLiteral"] = 8192] = "JSLiteral";
        ObjectFlags2[ObjectFlags2["FreshLiteral"] = 16384] = "FreshLiteral";
        ObjectFlags2[ObjectFlags2["ArrayLiteral"] = 32768] = "ArrayLiteral";
        ObjectFlags2[ObjectFlags2["PrimitiveUnion"] = 65536] = "PrimitiveUnion";
        ObjectFlags2[ObjectFlags2["ContainsWideningType"] = 131072] = "ContainsWideningType";
        ObjectFlags2[ObjectFlags2["ContainsObjectOrArrayLiteral"] = 262144] = "ContainsObjectOrArrayLiteral";
        ObjectFlags2[ObjectFlags2["NonInferrableType"] = 524288] = "NonInferrableType";
        ObjectFlags2[ObjectFlags2["CouldContainTypeVariablesComputed"] = 1048576] = "CouldContainTypeVariablesComputed";
        ObjectFlags2[ObjectFlags2["CouldContainTypeVariables"] = 2097152] = "CouldContainTypeVariables";
        ObjectFlags2[ObjectFlags2["ClassOrInterface"] = 3] = "ClassOrInterface";
        ObjectFlags2[ObjectFlags2["RequiresWidening"] = 393216] = "RequiresWidening";
        ObjectFlags2[ObjectFlags2["PropagatingFlags"] = 917504] = "PropagatingFlags";
        ObjectFlags2[ObjectFlags2["ObjectTypeKindMask"] = 1343] = "ObjectTypeKindMask";
        ObjectFlags2[ObjectFlags2["ContainsSpread"] = 4194304] = "ContainsSpread";
        ObjectFlags2[ObjectFlags2["ObjectRestType"] = 8388608] = "ObjectRestType";
        ObjectFlags2[ObjectFlags2["IsClassInstanceClone"] = 16777216] = "IsClassInstanceClone";
        ObjectFlags2[ObjectFlags2["IdenticalBaseTypeCalculated"] = 33554432] = "IdenticalBaseTypeCalculated";
        ObjectFlags2[ObjectFlags2["IdenticalBaseTypeExists"] = 67108864] = "IdenticalBaseTypeExists";
        ObjectFlags2[ObjectFlags2["IsGenericObjectTypeComputed"] = 4194304] = "IsGenericObjectTypeComputed";
        ObjectFlags2[ObjectFlags2["IsGenericObjectType"] = 8388608] = "IsGenericObjectType";
        ObjectFlags2[ObjectFlags2["IsGenericIndexTypeComputed"] = 16777216] = "IsGenericIndexTypeComputed";
        ObjectFlags2[ObjectFlags2["IsGenericIndexType"] = 33554432] = "IsGenericIndexType";
        ObjectFlags2[ObjectFlags2["ContainsIntersections"] = 67108864] = "ContainsIntersections";
        ObjectFlags2[ObjectFlags2["IsNeverIntersectionComputed"] = 67108864] = "IsNeverIntersectionComputed";
        ObjectFlags2[ObjectFlags2["IsNeverIntersection"] = 134217728] = "IsNeverIntersection";
      })(ObjectFlags = ts3.ObjectFlags || (ts3.ObjectFlags = {}));
      var VarianceFlags;
      (function(VarianceFlags2) {
        VarianceFlags2[VarianceFlags2["Invariant"] = 0] = "Invariant";
        VarianceFlags2[VarianceFlags2["Covariant"] = 1] = "Covariant";
        VarianceFlags2[VarianceFlags2["Contravariant"] = 2] = "Contravariant";
        VarianceFlags2[VarianceFlags2["Bivariant"] = 3] = "Bivariant";
        VarianceFlags2[VarianceFlags2["Independent"] = 4] = "Independent";
        VarianceFlags2[VarianceFlags2["VarianceMask"] = 7] = "VarianceMask";
        VarianceFlags2[VarianceFlags2["Unmeasurable"] = 8] = "Unmeasurable";
        VarianceFlags2[VarianceFlags2["Unreliable"] = 16] = "Unreliable";
        VarianceFlags2[VarianceFlags2["AllowsStructuralFallback"] = 24] = "AllowsStructuralFallback";
      })(VarianceFlags = ts3.VarianceFlags || (ts3.VarianceFlags = {}));
      var ElementFlags;
      (function(ElementFlags2) {
        ElementFlags2[ElementFlags2["Required"] = 1] = "Required";
        ElementFlags2[ElementFlags2["Optional"] = 2] = "Optional";
        ElementFlags2[ElementFlags2["Rest"] = 4] = "Rest";
        ElementFlags2[ElementFlags2["Variadic"] = 8] = "Variadic";
        ElementFlags2[ElementFlags2["Fixed"] = 3] = "Fixed";
        ElementFlags2[ElementFlags2["Variable"] = 12] = "Variable";
        ElementFlags2[ElementFlags2["NonRequired"] = 14] = "NonRequired";
        ElementFlags2[ElementFlags2["NonRest"] = 11] = "NonRest";
      })(ElementFlags = ts3.ElementFlags || (ts3.ElementFlags = {}));
      var JsxReferenceKind;
      (function(JsxReferenceKind2) {
        JsxReferenceKind2[JsxReferenceKind2["Component"] = 0] = "Component";
        JsxReferenceKind2[JsxReferenceKind2["Function"] = 1] = "Function";
        JsxReferenceKind2[JsxReferenceKind2["Mixed"] = 2] = "Mixed";
      })(JsxReferenceKind = ts3.JsxReferenceKind || (ts3.JsxReferenceKind = {}));
      var SignatureKind;
      (function(SignatureKind2) {
        SignatureKind2[SignatureKind2["Call"] = 0] = "Call";
        SignatureKind2[SignatureKind2["Construct"] = 1] = "Construct";
      })(SignatureKind = ts3.SignatureKind || (ts3.SignatureKind = {}));
      var SignatureFlags;
      (function(SignatureFlags2) {
        SignatureFlags2[SignatureFlags2["None"] = 0] = "None";
        SignatureFlags2[SignatureFlags2["HasRestParameter"] = 1] = "HasRestParameter";
        SignatureFlags2[SignatureFlags2["HasLiteralTypes"] = 2] = "HasLiteralTypes";
        SignatureFlags2[SignatureFlags2["Abstract"] = 4] = "Abstract";
        SignatureFlags2[SignatureFlags2["IsInnerCallChain"] = 8] = "IsInnerCallChain";
        SignatureFlags2[SignatureFlags2["IsOuterCallChain"] = 16] = "IsOuterCallChain";
        SignatureFlags2[SignatureFlags2["IsUntypedSignatureInJSFile"] = 32] = "IsUntypedSignatureInJSFile";
        SignatureFlags2[SignatureFlags2["PropagatingFlags"] = 39] = "PropagatingFlags";
        SignatureFlags2[SignatureFlags2["CallChainFlags"] = 24] = "CallChainFlags";
      })(SignatureFlags = ts3.SignatureFlags || (ts3.SignatureFlags = {}));
      var IndexKind;
      (function(IndexKind2) {
        IndexKind2[IndexKind2["String"] = 0] = "String";
        IndexKind2[IndexKind2["Number"] = 1] = "Number";
      })(IndexKind = ts3.IndexKind || (ts3.IndexKind = {}));
      var TypeMapKind;
      (function(TypeMapKind2) {
        TypeMapKind2[TypeMapKind2["Simple"] = 0] = "Simple";
        TypeMapKind2[TypeMapKind2["Array"] = 1] = "Array";
        TypeMapKind2[TypeMapKind2["Function"] = 2] = "Function";
        TypeMapKind2[TypeMapKind2["Composite"] = 3] = "Composite";
        TypeMapKind2[TypeMapKind2["Merged"] = 4] = "Merged";
      })(TypeMapKind = ts3.TypeMapKind || (ts3.TypeMapKind = {}));
      var InferencePriority;
      (function(InferencePriority2) {
        InferencePriority2[InferencePriority2["NakedTypeVariable"] = 1] = "NakedTypeVariable";
        InferencePriority2[InferencePriority2["SpeculativeTuple"] = 2] = "SpeculativeTuple";
        InferencePriority2[InferencePriority2["SubstituteSource"] = 4] = "SubstituteSource";
        InferencePriority2[InferencePriority2["HomomorphicMappedType"] = 8] = "HomomorphicMappedType";
        InferencePriority2[InferencePriority2["PartialHomomorphicMappedType"] = 16] = "PartialHomomorphicMappedType";
        InferencePriority2[InferencePriority2["MappedTypeConstraint"] = 32] = "MappedTypeConstraint";
        InferencePriority2[InferencePriority2["ContravariantConditional"] = 64] = "ContravariantConditional";
        InferencePriority2[InferencePriority2["ReturnType"] = 128] = "ReturnType";
        InferencePriority2[InferencePriority2["LiteralKeyof"] = 256] = "LiteralKeyof";
        InferencePriority2[InferencePriority2["NoConstraints"] = 512] = "NoConstraints";
        InferencePriority2[InferencePriority2["AlwaysStrict"] = 1024] = "AlwaysStrict";
        InferencePriority2[InferencePriority2["MaxValue"] = 2048] = "MaxValue";
        InferencePriority2[InferencePriority2["PriorityImpliesCombination"] = 416] = "PriorityImpliesCombination";
        InferencePriority2[InferencePriority2["Circularity"] = -1] = "Circularity";
      })(InferencePriority = ts3.InferencePriority || (ts3.InferencePriority = {}));
      var InferenceFlags;
      (function(InferenceFlags2) {
        InferenceFlags2[InferenceFlags2["None"] = 0] = "None";
        InferenceFlags2[InferenceFlags2["NoDefault"] = 1] = "NoDefault";
        InferenceFlags2[InferenceFlags2["AnyDefault"] = 2] = "AnyDefault";
        InferenceFlags2[InferenceFlags2["SkippedGenericFunction"] = 4] = "SkippedGenericFunction";
      })(InferenceFlags = ts3.InferenceFlags || (ts3.InferenceFlags = {}));
      var Ternary;
      (function(Ternary2) {
        Ternary2[Ternary2["False"] = 0] = "False";
        Ternary2[Ternary2["Unknown"] = 1] = "Unknown";
        Ternary2[Ternary2["Maybe"] = 3] = "Maybe";
        Ternary2[Ternary2["True"] = -1] = "True";
      })(Ternary = ts3.Ternary || (ts3.Ternary = {}));
      var AssignmentDeclarationKind;
      (function(AssignmentDeclarationKind2) {
        AssignmentDeclarationKind2[AssignmentDeclarationKind2["None"] = 0] = "None";
        AssignmentDeclarationKind2[AssignmentDeclarationKind2["ExportsProperty"] = 1] = "ExportsProperty";
        AssignmentDeclarationKind2[AssignmentDeclarationKind2["ModuleExports"] = 2] = "ModuleExports";
        AssignmentDeclarationKind2[AssignmentDeclarationKind2["PrototypeProperty"] = 3] = "PrototypeProperty";
        AssignmentDeclarationKind2[AssignmentDeclarationKind2["ThisProperty"] = 4] = "ThisProperty";
        AssignmentDeclarationKind2[AssignmentDeclarationKind2["Property"] = 5] = "Property";
        AssignmentDeclarationKind2[AssignmentDeclarationKind2["Prototype"] = 6] = "Prototype";
        AssignmentDeclarationKind2[AssignmentDeclarationKind2["ObjectDefinePropertyValue"] = 7] = "ObjectDefinePropertyValue";
        AssignmentDeclarationKind2[AssignmentDeclarationKind2["ObjectDefinePropertyExports"] = 8] = "ObjectDefinePropertyExports";
        AssignmentDeclarationKind2[AssignmentDeclarationKind2["ObjectDefinePrototypeProperty"] = 9] = "ObjectDefinePrototypeProperty";
      })(AssignmentDeclarationKind = ts3.AssignmentDeclarationKind || (ts3.AssignmentDeclarationKind = {}));
      var DiagnosticCategory;
      (function(DiagnosticCategory2) {
        DiagnosticCategory2[DiagnosticCategory2["Warning"] = 0] = "Warning";
        DiagnosticCategory2[DiagnosticCategory2["Error"] = 1] = "Error";
        DiagnosticCategory2[DiagnosticCategory2["Suggestion"] = 2] = "Suggestion";
        DiagnosticCategory2[DiagnosticCategory2["Message"] = 3] = "Message";
      })(DiagnosticCategory = ts3.DiagnosticCategory || (ts3.DiagnosticCategory = {}));
      function diagnosticCategoryName(d, lowerCase) {
        if (lowerCase === void 0) {
          lowerCase = true;
        }
        var name = DiagnosticCategory[d.category];
        return lowerCase ? name.toLowerCase() : name;
      }
      ts3.diagnosticCategoryName = diagnosticCategoryName;
      var ModuleResolutionKind;
      (function(ModuleResolutionKind2) {
        ModuleResolutionKind2[ModuleResolutionKind2["Classic"] = 1] = "Classic";
        ModuleResolutionKind2[ModuleResolutionKind2["NodeJs"] = 2] = "NodeJs";
      })(ModuleResolutionKind = ts3.ModuleResolutionKind || (ts3.ModuleResolutionKind = {}));
      var WatchFileKind;
      (function(WatchFileKind2) {
        WatchFileKind2[WatchFileKind2["FixedPollingInterval"] = 0] = "FixedPollingInterval";
        WatchFileKind2[WatchFileKind2["PriorityPollingInterval"] = 1] = "PriorityPollingInterval";
        WatchFileKind2[WatchFileKind2["DynamicPriorityPolling"] = 2] = "DynamicPriorityPolling";
        WatchFileKind2[WatchFileKind2["FixedChunkSizePolling"] = 3] = "FixedChunkSizePolling";
        WatchFileKind2[WatchFileKind2["UseFsEvents"] = 4] = "UseFsEvents";
        WatchFileKind2[WatchFileKind2["UseFsEventsOnParentDirectory"] = 5] = "UseFsEventsOnParentDirectory";
      })(WatchFileKind = ts3.WatchFileKind || (ts3.WatchFileKind = {}));
      var WatchDirectoryKind;
      (function(WatchDirectoryKind2) {
        WatchDirectoryKind2[WatchDirectoryKind2["UseFsEvents"] = 0] = "UseFsEvents";
        WatchDirectoryKind2[WatchDirectoryKind2["FixedPollingInterval"] = 1] = "FixedPollingInterval";
        WatchDirectoryKind2[WatchDirectoryKind2["DynamicPriorityPolling"] = 2] = "DynamicPriorityPolling";
        WatchDirectoryKind2[WatchDirectoryKind2["FixedChunkSizePolling"] = 3] = "FixedChunkSizePolling";
      })(WatchDirectoryKind = ts3.WatchDirectoryKind || (ts3.WatchDirectoryKind = {}));
      var PollingWatchKind;
      (function(PollingWatchKind2) {
        PollingWatchKind2[PollingWatchKind2["FixedInterval"] = 0] = "FixedInterval";
        PollingWatchKind2[PollingWatchKind2["PriorityInterval"] = 1] = "PriorityInterval";
        PollingWatchKind2[PollingWatchKind2["DynamicPriority"] = 2] = "DynamicPriority";
        PollingWatchKind2[PollingWatchKind2["FixedChunkSize"] = 3] = "FixedChunkSize";
      })(PollingWatchKind = ts3.PollingWatchKind || (ts3.PollingWatchKind = {}));
      var ModuleKind;
      (function(ModuleKind2) {
        ModuleKind2[ModuleKind2["None"] = 0] = "None";
        ModuleKind2[ModuleKind2["CommonJS"] = 1] = "CommonJS";
        ModuleKind2[ModuleKind2["AMD"] = 2] = "AMD";
        ModuleKind2[ModuleKind2["UMD"] = 3] = "UMD";
        ModuleKind2[ModuleKind2["System"] = 4] = "System";
        ModuleKind2[ModuleKind2["ES2015"] = 5] = "ES2015";
        ModuleKind2[ModuleKind2["ES2020"] = 6] = "ES2020";
        ModuleKind2[ModuleKind2["ESNext"] = 99] = "ESNext";
      })(ModuleKind = ts3.ModuleKind || (ts3.ModuleKind = {}));
      var JsxEmit;
      (function(JsxEmit2) {
        JsxEmit2[JsxEmit2["None"] = 0] = "None";
        JsxEmit2[JsxEmit2["Preserve"] = 1] = "Preserve";
        JsxEmit2[JsxEmit2["React"] = 2] = "React";
        JsxEmit2[JsxEmit2["ReactNative"] = 3] = "ReactNative";
        JsxEmit2[JsxEmit2["ReactJSX"] = 4] = "ReactJSX";
        JsxEmit2[JsxEmit2["ReactJSXDev"] = 5] = "ReactJSXDev";
      })(JsxEmit = ts3.JsxEmit || (ts3.JsxEmit = {}));
      var ImportsNotUsedAsValues;
      (function(ImportsNotUsedAsValues2) {
        ImportsNotUsedAsValues2[ImportsNotUsedAsValues2["Remove"] = 0] = "Remove";
        ImportsNotUsedAsValues2[ImportsNotUsedAsValues2["Preserve"] = 1] = "Preserve";
        ImportsNotUsedAsValues2[ImportsNotUsedAsValues2["Error"] = 2] = "Error";
      })(ImportsNotUsedAsValues = ts3.ImportsNotUsedAsValues || (ts3.ImportsNotUsedAsValues = {}));
      var NewLineKind;
      (function(NewLineKind2) {
        NewLineKind2[NewLineKind2["CarriageReturnLineFeed"] = 0] = "CarriageReturnLineFeed";
        NewLineKind2[NewLineKind2["LineFeed"] = 1] = "LineFeed";
      })(NewLineKind = ts3.NewLineKind || (ts3.NewLineKind = {}));
      var ScriptKind;
      (function(ScriptKind2) {
        ScriptKind2[ScriptKind2["Unknown"] = 0] = "Unknown";
        ScriptKind2[ScriptKind2["JS"] = 1] = "JS";
        ScriptKind2[ScriptKind2["JSX"] = 2] = "JSX";
        ScriptKind2[ScriptKind2["TS"] = 3] = "TS";
        ScriptKind2[ScriptKind2["TSX"] = 4] = "TSX";
        ScriptKind2[ScriptKind2["External"] = 5] = "External";
        ScriptKind2[ScriptKind2["JSON"] = 6] = "JSON";
        ScriptKind2[ScriptKind2["Deferred"] = 7] = "Deferred";
      })(ScriptKind = ts3.ScriptKind || (ts3.ScriptKind = {}));
      var ScriptTarget;
      (function(ScriptTarget2) {
        ScriptTarget2[ScriptTarget2["ES3"] = 0] = "ES3";
        ScriptTarget2[ScriptTarget2["ES5"] = 1] = "ES5";
        ScriptTarget2[ScriptTarget2["ES2015"] = 2] = "ES2015";
        ScriptTarget2[ScriptTarget2["ES2016"] = 3] = "ES2016";
        ScriptTarget2[ScriptTarget2["ES2017"] = 4] = "ES2017";
        ScriptTarget2[ScriptTarget2["ES2018"] = 5] = "ES2018";
        ScriptTarget2[ScriptTarget2["ES2019"] = 6] = "ES2019";
        ScriptTarget2[ScriptTarget2["ES2020"] = 7] = "ES2020";
        ScriptTarget2[ScriptTarget2["ES2021"] = 8] = "ES2021";
        ScriptTarget2[ScriptTarget2["ESNext"] = 99] = "ESNext";
        ScriptTarget2[ScriptTarget2["JSON"] = 100] = "JSON";
        ScriptTarget2[ScriptTarget2["Latest"] = 99] = "Latest";
      })(ScriptTarget = ts3.ScriptTarget || (ts3.ScriptTarget = {}));
      var LanguageVariant;
      (function(LanguageVariant2) {
        LanguageVariant2[LanguageVariant2["Standard"] = 0] = "Standard";
        LanguageVariant2[LanguageVariant2["JSX"] = 1] = "JSX";
      })(LanguageVariant = ts3.LanguageVariant || (ts3.LanguageVariant = {}));
      var WatchDirectoryFlags;
      (function(WatchDirectoryFlags2) {
        WatchDirectoryFlags2[WatchDirectoryFlags2["None"] = 0] = "None";
        WatchDirectoryFlags2[WatchDirectoryFlags2["Recursive"] = 1] = "Recursive";
      })(WatchDirectoryFlags = ts3.WatchDirectoryFlags || (ts3.WatchDirectoryFlags = {}));
      var CharacterCodes;
      (function(CharacterCodes2) {
        CharacterCodes2[CharacterCodes2["nullCharacter"] = 0] = "nullCharacter";
        CharacterCodes2[CharacterCodes2["maxAsciiCharacter"] = 127] = "maxAsciiCharacter";
        CharacterCodes2[CharacterCodes2["lineFeed"] = 10] = "lineFeed";
        CharacterCodes2[CharacterCodes2["carriageReturn"] = 13] = "carriageReturn";
        CharacterCodes2[CharacterCodes2["lineSeparator"] = 8232] = "lineSeparator";
        CharacterCodes2[CharacterCodes2["paragraphSeparator"] = 8233] = "paragraphSeparator";
        CharacterCodes2[CharacterCodes2["nextLine"] = 133] = "nextLine";
        CharacterCodes2[CharacterCodes2["space"] = 32] = "space";
        CharacterCodes2[CharacterCodes2["nonBreakingSpace"] = 160] = "nonBreakingSpace";
        CharacterCodes2[CharacterCodes2["enQuad"] = 8192] = "enQuad";
        CharacterCodes2[CharacterCodes2["emQuad"] = 8193] = "emQuad";
        CharacterCodes2[CharacterCodes2["enSpace"] = 8194] = "enSpace";
        CharacterCodes2[CharacterCodes2["emSpace"] = 8195] = "emSpace";
        CharacterCodes2[CharacterCodes2["threePerEmSpace"] = 8196] = "threePerEmSpace";
        CharacterCodes2[CharacterCodes2["fourPerEmSpace"] = 8197] = "fourPerEmSpace";
        CharacterCodes2[CharacterCodes2["sixPerEmSpace"] = 8198] = "sixPerEmSpace";
        CharacterCodes2[CharacterCodes2["figureSpace"] = 8199] = "figureSpace";
        CharacterCodes2[CharacterCodes2["punctuationSpace"] = 8200] = "punctuationSpace";
        CharacterCodes2[CharacterCodes2["thinSpace"] = 8201] = "thinSpace";
        CharacterCodes2[CharacterCodes2["hairSpace"] = 8202] = "hairSpace";
        CharacterCodes2[CharacterCodes2["zeroWidthSpace"] = 8203] = "zeroWidthSpace";
        CharacterCodes2[CharacterCodes2["narrowNoBreakSpace"] = 8239] = "narrowNoBreakSpace";
        CharacterCodes2[CharacterCodes2["ideographicSpace"] = 12288] = "ideographicSpace";
        CharacterCodes2[CharacterCodes2["mathematicalSpace"] = 8287] = "mathematicalSpace";
        CharacterCodes2[CharacterCodes2["ogham"] = 5760] = "ogham";
        CharacterCodes2[CharacterCodes2["_"] = 95] = "_";
        CharacterCodes2[CharacterCodes2["$"] = 36] = "$";
        CharacterCodes2[CharacterCodes2["_0"] = 48] = "_0";
        CharacterCodes2[CharacterCodes2["_1"] = 49] = "_1";
        CharacterCodes2[CharacterCodes2["_2"] = 50] = "_2";
        CharacterCodes2[CharacterCodes2["_3"] = 51] = "_3";
        CharacterCodes2[CharacterCodes2["_4"] = 52] = "_4";
        CharacterCodes2[CharacterCodes2["_5"] = 53] = "_5";
        CharacterCodes2[CharacterCodes2["_6"] = 54] = "_6";
        CharacterCodes2[CharacterCodes2["_7"] = 55] = "_7";
        CharacterCodes2[CharacterCodes2["_8"] = 56] = "_8";
        CharacterCodes2[CharacterCodes2["_9"] = 57] = "_9";
        CharacterCodes2[CharacterCodes2["a"] = 97] = "a";
        CharacterCodes2[CharacterCodes2["b"] = 98] = "b";
        CharacterCodes2[CharacterCodes2["c"] = 99] = "c";
        CharacterCodes2[CharacterCodes2["d"] = 100] = "d";
        CharacterCodes2[CharacterCodes2["e"] = 101] = "e";
        CharacterCodes2[CharacterCodes2["f"] = 102] = "f";
        CharacterCodes2[CharacterCodes2["g"] = 103] = "g";
        CharacterCodes2[CharacterCodes2["h"] = 104] = "h";
        CharacterCodes2[CharacterCodes2["i"] = 105] = "i";
        CharacterCodes2[CharacterCodes2["j"] = 106] = "j";
        CharacterCodes2[CharacterCodes2["k"] = 107] = "k";
        CharacterCodes2[CharacterCodes2["l"] = 108] = "l";
        CharacterCodes2[CharacterCodes2["m"] = 109] = "m";
        CharacterCodes2[CharacterCodes2["n"] = 110] = "n";
        CharacterCodes2[CharacterCodes2["o"] = 111] = "o";
        CharacterCodes2[CharacterCodes2["p"] = 112] = "p";
        CharacterCodes2[CharacterCodes2["q"] = 113] = "q";
        CharacterCodes2[CharacterCodes2["r"] = 114] = "r";
        CharacterCodes2[CharacterCodes2["s"] = 115] = "s";
        CharacterCodes2[CharacterCodes2["t"] = 116] = "t";
        CharacterCodes2[CharacterCodes2["u"] = 117] = "u";
        CharacterCodes2[CharacterCodes2["v"] = 118] = "v";
        CharacterCodes2[CharacterCodes2["w"] = 119] = "w";
        CharacterCodes2[CharacterCodes2["x"] = 120] = "x";
        CharacterCodes2[CharacterCodes2["y"] = 121] = "y";
        CharacterCodes2[CharacterCodes2["z"] = 122] = "z";
        CharacterCodes2[CharacterCodes2["A"] = 65] = "A";
        CharacterCodes2[CharacterCodes2["B"] = 66] = "B";
        CharacterCodes2[CharacterCodes2["C"] = 67] = "C";
        CharacterCodes2[CharacterCodes2["D"] = 68] = "D";
        CharacterCodes2[CharacterCodes2["E"] = 69] = "E";
        CharacterCodes2[CharacterCodes2["F"] = 70] = "F";
        CharacterCodes2[CharacterCodes2["G"] = 71] = "G";
        CharacterCodes2[CharacterCodes2["H"] = 72] = "H";
        CharacterCodes2[CharacterCodes2["I"] = 73] = "I";
        CharacterCodes2[CharacterCodes2["J"] = 74] = "J";
        CharacterCodes2[CharacterCodes2["K"] = 75] = "K";
        CharacterCodes2[CharacterCodes2["L"] = 76] = "L";
        CharacterCodes2[CharacterCodes2["M"] = 77] = "M";
        CharacterCodes2[CharacterCodes2["N"] = 78] = "N";
        CharacterCodes2[CharacterCodes2["O"] = 79] = "O";
        CharacterCodes2[CharacterCodes2["P"] = 80] = "P";
        CharacterCodes2[CharacterCodes2["Q"] = 81] = "Q";
        CharacterCodes2[CharacterCodes2["R"] = 82] = "R";
        CharacterCodes2[CharacterCodes2["S"] = 83] = "S";
        CharacterCodes2[CharacterCodes2["T"] = 84] = "T";
        CharacterCodes2[CharacterCodes2["U"] = 85] = "U";
        CharacterCodes2[CharacterCodes2["V"] = 86] = "V";
        CharacterCodes2[CharacterCodes2["W"] = 87] = "W";
        CharacterCodes2[CharacterCodes2["X"] = 88] = "X";
        CharacterCodes2[CharacterCodes2["Y"] = 89] = "Y";
        CharacterCodes2[CharacterCodes2["Z"] = 90] = "Z";
        CharacterCodes2[CharacterCodes2["ampersand"] = 38] = "ampersand";
        CharacterCodes2[CharacterCodes2["asterisk"] = 42] = "asterisk";
        CharacterCodes2[CharacterCodes2["at"] = 64] = "at";
        CharacterCodes2[CharacterCodes2["backslash"] = 92] = "backslash";
        CharacterCodes2[CharacterCodes2["backtick"] = 96] = "backtick";
        CharacterCodes2[CharacterCodes2["bar"] = 124] = "bar";
        CharacterCodes2[CharacterCodes2["caret"] = 94] = "caret";
        CharacterCodes2[CharacterCodes2["closeBrace"] = 125] = "closeBrace";
        CharacterCodes2[CharacterCodes2["closeBracket"] = 93] = "closeBracket";
        CharacterCodes2[CharacterCodes2["closeParen"] = 41] = "closeParen";
        CharacterCodes2[CharacterCodes2["colon"] = 58] = "colon";
        CharacterCodes2[CharacterCodes2["comma"] = 44] = "comma";
        CharacterCodes2[CharacterCodes2["dot"] = 46] = "dot";
        CharacterCodes2[CharacterCodes2["doubleQuote"] = 34] = "doubleQuote";
        CharacterCodes2[CharacterCodes2["equals"] = 61] = "equals";
        CharacterCodes2[CharacterCodes2["exclamation"] = 33] = "exclamation";
        CharacterCodes2[CharacterCodes2["greaterThan"] = 62] = "greaterThan";
        CharacterCodes2[CharacterCodes2["hash"] = 35] = "hash";
        CharacterCodes2[CharacterCodes2["lessThan"] = 60] = "lessThan";
        CharacterCodes2[CharacterCodes2["minus"] = 45] = "minus";
        CharacterCodes2[CharacterCodes2["openBrace"] = 123] = "openBrace";
        CharacterCodes2[CharacterCodes2["openBracket"] = 91] = "openBracket";
        CharacterCodes2[CharacterCodes2["openParen"] = 40] = "openParen";
        CharacterCodes2[CharacterCodes2["percent"] = 37] = "percent";
        CharacterCodes2[CharacterCodes2["plus"] = 43] = "plus";
        CharacterCodes2[CharacterCodes2["question"] = 63] = "question";
        CharacterCodes2[CharacterCodes2["semicolon"] = 59] = "semicolon";
        CharacterCodes2[CharacterCodes2["singleQuote"] = 39] = "singleQuote";
        CharacterCodes2[CharacterCodes2["slash"] = 47] = "slash";
        CharacterCodes2[CharacterCodes2["tilde"] = 126] = "tilde";
        CharacterCodes2[CharacterCodes2["backspace"] = 8] = "backspace";
        CharacterCodes2[CharacterCodes2["formFeed"] = 12] = "formFeed";
        CharacterCodes2[CharacterCodes2["byteOrderMark"] = 65279] = "byteOrderMark";
        CharacterCodes2[CharacterCodes2["tab"] = 9] = "tab";
        CharacterCodes2[CharacterCodes2["verticalTab"] = 11] = "verticalTab";
      })(CharacterCodes = ts3.CharacterCodes || (ts3.CharacterCodes = {}));
      var Extension;
      (function(Extension2) {
        Extension2["Ts"] = ".ts";
        Extension2["Tsx"] = ".tsx";
        Extension2["Dts"] = ".d.ts";
        Extension2["Js"] = ".js";
        Extension2["Jsx"] = ".jsx";
        Extension2["Json"] = ".json";
        Extension2["TsBuildInfo"] = ".tsbuildinfo";
      })(Extension = ts3.Extension || (ts3.Extension = {}));
      var TransformFlags;
      (function(TransformFlags2) {
        TransformFlags2[TransformFlags2["None"] = 0] = "None";
        TransformFlags2[TransformFlags2["ContainsTypeScript"] = 1] = "ContainsTypeScript";
        TransformFlags2[TransformFlags2["ContainsJsx"] = 2] = "ContainsJsx";
        TransformFlags2[TransformFlags2["ContainsESNext"] = 4] = "ContainsESNext";
        TransformFlags2[TransformFlags2["ContainsES2021"] = 8] = "ContainsES2021";
        TransformFlags2[TransformFlags2["ContainsES2020"] = 16] = "ContainsES2020";
        TransformFlags2[TransformFlags2["ContainsES2019"] = 32] = "ContainsES2019";
        TransformFlags2[TransformFlags2["ContainsES2018"] = 64] = "ContainsES2018";
        TransformFlags2[TransformFlags2["ContainsES2017"] = 128] = "ContainsES2017";
        TransformFlags2[TransformFlags2["ContainsES2016"] = 256] = "ContainsES2016";
        TransformFlags2[TransformFlags2["ContainsES2015"] = 512] = "ContainsES2015";
        TransformFlags2[TransformFlags2["ContainsGenerator"] = 1024] = "ContainsGenerator";
        TransformFlags2[TransformFlags2["ContainsDestructuringAssignment"] = 2048] = "ContainsDestructuringAssignment";
        TransformFlags2[TransformFlags2["ContainsTypeScriptClassSyntax"] = 4096] = "ContainsTypeScriptClassSyntax";
        TransformFlags2[TransformFlags2["ContainsLexicalThis"] = 8192] = "ContainsLexicalThis";
        TransformFlags2[TransformFlags2["ContainsRestOrSpread"] = 16384] = "ContainsRestOrSpread";
        TransformFlags2[TransformFlags2["ContainsObjectRestOrSpread"] = 32768] = "ContainsObjectRestOrSpread";
        TransformFlags2[TransformFlags2["ContainsComputedPropertyName"] = 65536] = "ContainsComputedPropertyName";
        TransformFlags2[TransformFlags2["ContainsBlockScopedBinding"] = 131072] = "ContainsBlockScopedBinding";
        TransformFlags2[TransformFlags2["ContainsBindingPattern"] = 262144] = "ContainsBindingPattern";
        TransformFlags2[TransformFlags2["ContainsYield"] = 524288] = "ContainsYield";
        TransformFlags2[TransformFlags2["ContainsAwait"] = 1048576] = "ContainsAwait";
        TransformFlags2[TransformFlags2["ContainsHoistedDeclarationOrCompletion"] = 2097152] = "ContainsHoistedDeclarationOrCompletion";
        TransformFlags2[TransformFlags2["ContainsDynamicImport"] = 4194304] = "ContainsDynamicImport";
        TransformFlags2[TransformFlags2["ContainsClassFields"] = 8388608] = "ContainsClassFields";
        TransformFlags2[TransformFlags2["ContainsPossibleTopLevelAwait"] = 16777216] = "ContainsPossibleTopLevelAwait";
        TransformFlags2[TransformFlags2["HasComputedFlags"] = 536870912] = "HasComputedFlags";
        TransformFlags2[TransformFlags2["AssertTypeScript"] = 1] = "AssertTypeScript";
        TransformFlags2[TransformFlags2["AssertJsx"] = 2] = "AssertJsx";
        TransformFlags2[TransformFlags2["AssertESNext"] = 4] = "AssertESNext";
        TransformFlags2[TransformFlags2["AssertES2021"] = 8] = "AssertES2021";
        TransformFlags2[TransformFlags2["AssertES2020"] = 16] = "AssertES2020";
        TransformFlags2[TransformFlags2["AssertES2019"] = 32] = "AssertES2019";
        TransformFlags2[TransformFlags2["AssertES2018"] = 64] = "AssertES2018";
        TransformFlags2[TransformFlags2["AssertES2017"] = 128] = "AssertES2017";
        TransformFlags2[TransformFlags2["AssertES2016"] = 256] = "AssertES2016";
        TransformFlags2[TransformFlags2["AssertES2015"] = 512] = "AssertES2015";
        TransformFlags2[TransformFlags2["AssertGenerator"] = 1024] = "AssertGenerator";
        TransformFlags2[TransformFlags2["AssertDestructuringAssignment"] = 2048] = "AssertDestructuringAssignment";
        TransformFlags2[TransformFlags2["OuterExpressionExcludes"] = 536870912] = "OuterExpressionExcludes";
        TransformFlags2[TransformFlags2["PropertyAccessExcludes"] = 536870912] = "PropertyAccessExcludes";
        TransformFlags2[TransformFlags2["NodeExcludes"] = 536870912] = "NodeExcludes";
        TransformFlags2[TransformFlags2["ArrowFunctionExcludes"] = 557748224] = "ArrowFunctionExcludes";
        TransformFlags2[TransformFlags2["FunctionExcludes"] = 557756416] = "FunctionExcludes";
        TransformFlags2[TransformFlags2["ConstructorExcludes"] = 557752320] = "ConstructorExcludes";
        TransformFlags2[TransformFlags2["MethodOrAccessorExcludes"] = 540975104] = "MethodOrAccessorExcludes";
        TransformFlags2[TransformFlags2["PropertyExcludes"] = 536879104] = "PropertyExcludes";
        TransformFlags2[TransformFlags2["ClassExcludes"] = 536940544] = "ClassExcludes";
        TransformFlags2[TransformFlags2["ModuleExcludes"] = 555888640] = "ModuleExcludes";
        TransformFlags2[TransformFlags2["TypeExcludes"] = -2] = "TypeExcludes";
        TransformFlags2[TransformFlags2["ObjectLiteralExcludes"] = 536973312] = "ObjectLiteralExcludes";
        TransformFlags2[TransformFlags2["ArrayLiteralOrCallOrNewExcludes"] = 536887296] = "ArrayLiteralOrCallOrNewExcludes";
        TransformFlags2[TransformFlags2["VariableDeclarationListExcludes"] = 537165824] = "VariableDeclarationListExcludes";
        TransformFlags2[TransformFlags2["ParameterExcludes"] = 536870912] = "ParameterExcludes";
        TransformFlags2[TransformFlags2["CatchClauseExcludes"] = 536903680] = "CatchClauseExcludes";
        TransformFlags2[TransformFlags2["BindingPatternExcludes"] = 536887296] = "BindingPatternExcludes";
        TransformFlags2[TransformFlags2["PropertyNamePropagatingFlags"] = 8192] = "PropertyNamePropagatingFlags";
      })(TransformFlags = ts3.TransformFlags || (ts3.TransformFlags = {}));
      var EmitFlags;
      (function(EmitFlags2) {
        EmitFlags2[EmitFlags2["None"] = 0] = "None";
        EmitFlags2[EmitFlags2["SingleLine"] = 1] = "SingleLine";
        EmitFlags2[EmitFlags2["AdviseOnEmitNode"] = 2] = "AdviseOnEmitNode";
        EmitFlags2[EmitFlags2["NoSubstitution"] = 4] = "NoSubstitution";
        EmitFlags2[EmitFlags2["CapturesThis"] = 8] = "CapturesThis";
        EmitFlags2[EmitFlags2["NoLeadingSourceMap"] = 16] = "NoLeadingSourceMap";
        EmitFlags2[EmitFlags2["NoTrailingSourceMap"] = 32] = "NoTrailingSourceMap";
        EmitFlags2[EmitFlags2["NoSourceMap"] = 48] = "NoSourceMap";
        EmitFlags2[EmitFlags2["NoNestedSourceMaps"] = 64] = "NoNestedSourceMaps";
        EmitFlags2[EmitFlags2["NoTokenLeadingSourceMaps"] = 128] = "NoTokenLeadingSourceMaps";
        EmitFlags2[EmitFlags2["NoTokenTrailingSourceMaps"] = 256] = "NoTokenTrailingSourceMaps";
        EmitFlags2[EmitFlags2["NoTokenSourceMaps"] = 384] = "NoTokenSourceMaps";
        EmitFlags2[EmitFlags2["NoLeadingComments"] = 512] = "NoLeadingComments";
        EmitFlags2[EmitFlags2["NoTrailingComments"] = 1024] = "NoTrailingComments";
        EmitFlags2[EmitFlags2["NoComments"] = 1536] = "NoComments";
        EmitFlags2[EmitFlags2["NoNestedComments"] = 2048] = "NoNestedComments";
        EmitFlags2[EmitFlags2["HelperName"] = 4096] = "HelperName";
        EmitFlags2[EmitFlags2["ExportName"] = 8192] = "ExportName";
        EmitFlags2[EmitFlags2["LocalName"] = 16384] = "LocalName";
        EmitFlags2[EmitFlags2["InternalName"] = 32768] = "InternalName";
        EmitFlags2[EmitFlags2["Indented"] = 65536] = "Indented";
        EmitFlags2[EmitFlags2["NoIndentation"] = 131072] = "NoIndentation";
        EmitFlags2[EmitFlags2["AsyncFunctionBody"] = 262144] = "AsyncFunctionBody";
        EmitFlags2[EmitFlags2["ReuseTempVariableScope"] = 524288] = "ReuseTempVariableScope";
        EmitFlags2[EmitFlags2["CustomPrologue"] = 1048576] = "CustomPrologue";
        EmitFlags2[EmitFlags2["NoHoisting"] = 2097152] = "NoHoisting";
        EmitFlags2[EmitFlags2["HasEndOfDeclarationMarker"] = 4194304] = "HasEndOfDeclarationMarker";
        EmitFlags2[EmitFlags2["Iterator"] = 8388608] = "Iterator";
        EmitFlags2[EmitFlags2["NoAsciiEscaping"] = 16777216] = "NoAsciiEscaping";
        EmitFlags2[EmitFlags2["TypeScriptClassWrapper"] = 33554432] = "TypeScriptClassWrapper";
        EmitFlags2[EmitFlags2["NeverApplyImportHelper"] = 67108864] = "NeverApplyImportHelper";
        EmitFlags2[EmitFlags2["IgnoreSourceNewlines"] = 134217728] = "IgnoreSourceNewlines";
      })(EmitFlags = ts3.EmitFlags || (ts3.EmitFlags = {}));
      var ExternalEmitHelpers;
      (function(ExternalEmitHelpers2) {
        ExternalEmitHelpers2[ExternalEmitHelpers2["Extends"] = 1] = "Extends";
        ExternalEmitHelpers2[ExternalEmitHelpers2["Assign"] = 2] = "Assign";
        ExternalEmitHelpers2[ExternalEmitHelpers2["Rest"] = 4] = "Rest";
        ExternalEmitHelpers2[ExternalEmitHelpers2["Decorate"] = 8] = "Decorate";
        ExternalEmitHelpers2[ExternalEmitHelpers2["Metadata"] = 16] = "Metadata";
        ExternalEmitHelpers2[ExternalEmitHelpers2["Param"] = 32] = "Param";
        ExternalEmitHelpers2[ExternalEmitHelpers2["Awaiter"] = 64] = "Awaiter";
        ExternalEmitHelpers2[ExternalEmitHelpers2["Generator"] = 128] = "Generator";
        ExternalEmitHelpers2[ExternalEmitHelpers2["Values"] = 256] = "Values";
        ExternalEmitHelpers2[ExternalEmitHelpers2["Read"] = 512] = "Read";
        ExternalEmitHelpers2[ExternalEmitHelpers2["SpreadArray"] = 1024] = "SpreadArray";
        ExternalEmitHelpers2[ExternalEmitHelpers2["Await"] = 2048] = "Await";
        ExternalEmitHelpers2[ExternalEmitHelpers2["AsyncGenerator"] = 4096] = "AsyncGenerator";
        ExternalEmitHelpers2[ExternalEmitHelpers2["AsyncDelegator"] = 8192] = "AsyncDelegator";
        ExternalEmitHelpers2[ExternalEmitHelpers2["AsyncValues"] = 16384] = "AsyncValues";
        ExternalEmitHelpers2[ExternalEmitHelpers2["ExportStar"] = 32768] = "ExportStar";
        ExternalEmitHelpers2[ExternalEmitHelpers2["ImportStar"] = 65536] = "ImportStar";
        ExternalEmitHelpers2[ExternalEmitHelpers2["ImportDefault"] = 131072] = "ImportDefault";
        ExternalEmitHelpers2[ExternalEmitHelpers2["MakeTemplateObject"] = 262144] = "MakeTemplateObject";
        ExternalEmitHelpers2[ExternalEmitHelpers2["ClassPrivateFieldGet"] = 524288] = "ClassPrivateFieldGet";
        ExternalEmitHelpers2[ExternalEmitHelpers2["ClassPrivateFieldSet"] = 1048576] = "ClassPrivateFieldSet";
        ExternalEmitHelpers2[ExternalEmitHelpers2["CreateBinding"] = 2097152] = "CreateBinding";
        ExternalEmitHelpers2[ExternalEmitHelpers2["FirstEmitHelper"] = 1] = "FirstEmitHelper";
        ExternalEmitHelpers2[ExternalEmitHelpers2["LastEmitHelper"] = 2097152] = "LastEmitHelper";
        ExternalEmitHelpers2[ExternalEmitHelpers2["ForOfIncludes"] = 256] = "ForOfIncludes";
        ExternalEmitHelpers2[ExternalEmitHelpers2["ForAwaitOfIncludes"] = 16384] = "ForAwaitOfIncludes";
        ExternalEmitHelpers2[ExternalEmitHelpers2["AsyncGeneratorIncludes"] = 6144] = "AsyncGeneratorIncludes";
        ExternalEmitHelpers2[ExternalEmitHelpers2["AsyncDelegatorIncludes"] = 26624] = "AsyncDelegatorIncludes";
        ExternalEmitHelpers2[ExternalEmitHelpers2["SpreadIncludes"] = 1536] = "SpreadIncludes";
      })(ExternalEmitHelpers = ts3.ExternalEmitHelpers || (ts3.ExternalEmitHelpers = {}));
      var EmitHint;
      (function(EmitHint2) {
        EmitHint2[EmitHint2["SourceFile"] = 0] = "SourceFile";
        EmitHint2[EmitHint2["Expression"] = 1] = "Expression";
        EmitHint2[EmitHint2["IdentifierName"] = 2] = "IdentifierName";
        EmitHint2[EmitHint2["MappedTypeParameter"] = 3] = "MappedTypeParameter";
        EmitHint2[EmitHint2["Unspecified"] = 4] = "Unspecified";
        EmitHint2[EmitHint2["EmbeddedStatement"] = 5] = "EmbeddedStatement";
        EmitHint2[EmitHint2["JsxAttributeValue"] = 6] = "JsxAttributeValue";
      })(EmitHint = ts3.EmitHint || (ts3.EmitHint = {}));
      var OuterExpressionKinds;
      (function(OuterExpressionKinds2) {
        OuterExpressionKinds2[OuterExpressionKinds2["Parentheses"] = 1] = "Parentheses";
        OuterExpressionKinds2[OuterExpressionKinds2["TypeAssertions"] = 2] = "TypeAssertions";
        OuterExpressionKinds2[OuterExpressionKinds2["NonNullAssertions"] = 4] = "NonNullAssertions";
        OuterExpressionKinds2[OuterExpressionKinds2["PartiallyEmittedExpressions"] = 8] = "PartiallyEmittedExpressions";
        OuterExpressionKinds2[OuterExpressionKinds2["Assertions"] = 6] = "Assertions";
        OuterExpressionKinds2[OuterExpressionKinds2["All"] = 15] = "All";
      })(OuterExpressionKinds = ts3.OuterExpressionKinds || (ts3.OuterExpressionKinds = {}));
      var LexicalEnvironmentFlags;
      (function(LexicalEnvironmentFlags2) {
        LexicalEnvironmentFlags2[LexicalEnvironmentFlags2["None"] = 0] = "None";
        LexicalEnvironmentFlags2[LexicalEnvironmentFlags2["InParameters"] = 1] = "InParameters";
        LexicalEnvironmentFlags2[LexicalEnvironmentFlags2["VariablesHoistedInParameters"] = 2] = "VariablesHoistedInParameters";
      })(LexicalEnvironmentFlags = ts3.LexicalEnvironmentFlags || (ts3.LexicalEnvironmentFlags = {}));
      var BundleFileSectionKind;
      (function(BundleFileSectionKind2) {
        BundleFileSectionKind2["Prologue"] = "prologue";
        BundleFileSectionKind2["EmitHelpers"] = "emitHelpers";
        BundleFileSectionKind2["NoDefaultLib"] = "no-default-lib";
        BundleFileSectionKind2["Reference"] = "reference";
        BundleFileSectionKind2["Type"] = "type";
        BundleFileSectionKind2["Lib"] = "lib";
        BundleFileSectionKind2["Prepend"] = "prepend";
        BundleFileSectionKind2["Text"] = "text";
        BundleFileSectionKind2["Internal"] = "internal";
      })(BundleFileSectionKind = ts3.BundleFileSectionKind || (ts3.BundleFileSectionKind = {}));
      var ListFormat;
      (function(ListFormat2) {
        ListFormat2[ListFormat2["None"] = 0] = "None";
        ListFormat2[ListFormat2["SingleLine"] = 0] = "SingleLine";
        ListFormat2[ListFormat2["MultiLine"] = 1] = "MultiLine";
        ListFormat2[ListFormat2["PreserveLines"] = 2] = "PreserveLines";
        ListFormat2[ListFormat2["LinesMask"] = 3] = "LinesMask";
        ListFormat2[ListFormat2["NotDelimited"] = 0] = "NotDelimited";
        ListFormat2[ListFormat2["BarDelimited"] = 4] = "BarDelimited";
        ListFormat2[ListFormat2["AmpersandDelimited"] = 8] = "AmpersandDelimited";
        ListFormat2[ListFormat2["CommaDelimited"] = 16] = "CommaDelimited";
        ListFormat2[ListFormat2["AsteriskDelimited"] = 32] = "AsteriskDelimited";
        ListFormat2[ListFormat2["DelimitersMask"] = 60] = "DelimitersMask";
        ListFormat2[ListFormat2["AllowTrailingComma"] = 64] = "AllowTrailingComma";
        ListFormat2[ListFormat2["Indented"] = 128] = "Indented";
        ListFormat2[ListFormat2["SpaceBetweenBraces"] = 256] = "SpaceBetweenBraces";
        ListFormat2[ListFormat2["SpaceBetweenSiblings"] = 512] = "SpaceBetweenSiblings";
        ListFormat2[ListFormat2["Braces"] = 1024] = "Braces";
        ListFormat2[ListFormat2["Parenthesis"] = 2048] = "Parenthesis";
        ListFormat2[ListFormat2["AngleBrackets"] = 4096] = "AngleBrackets";
        ListFormat2[ListFormat2["SquareBrackets"] = 8192] = "SquareBrackets";
        ListFormat2[ListFormat2["BracketsMask"] = 15360] = "BracketsMask";
        ListFormat2[ListFormat2["OptionalIfUndefined"] = 16384] = "OptionalIfUndefined";
        ListFormat2[ListFormat2["OptionalIfEmpty"] = 32768] = "OptionalIfEmpty";
        ListFormat2[ListFormat2["Optional"] = 49152] = "Optional";
        ListFormat2[ListFormat2["PreferNewLine"] = 65536] = "PreferNewLine";
        ListFormat2[ListFormat2["NoTrailingNewLine"] = 131072] = "NoTrailingNewLine";
        ListFormat2[ListFormat2["NoInterveningComments"] = 262144] = "NoInterveningComments";
        ListFormat2[ListFormat2["NoSpaceIfEmpty"] = 524288] = "NoSpaceIfEmpty";
        ListFormat2[ListFormat2["SingleElement"] = 1048576] = "SingleElement";
        ListFormat2[ListFormat2["SpaceAfterList"] = 2097152] = "SpaceAfterList";
        ListFormat2[ListFormat2["Modifiers"] = 262656] = "Modifiers";
        ListFormat2[ListFormat2["HeritageClauses"] = 512] = "HeritageClauses";
        ListFormat2[ListFormat2["SingleLineTypeLiteralMembers"] = 768] = "SingleLineTypeLiteralMembers";
        ListFormat2[ListFormat2["MultiLineTypeLiteralMembers"] = 32897] = "MultiLineTypeLiteralMembers";
        ListFormat2[ListFormat2["SingleLineTupleTypeElements"] = 528] = "SingleLineTupleTypeElements";
        ListFormat2[ListFormat2["MultiLineTupleTypeElements"] = 657] = "MultiLineTupleTypeElements";
        ListFormat2[ListFormat2["UnionTypeConstituents"] = 516] = "UnionTypeConstituents";
        ListFormat2[ListFormat2["IntersectionTypeConstituents"] = 520] = "IntersectionTypeConstituents";
        ListFormat2[ListFormat2["ObjectBindingPatternElements"] = 525136] = "ObjectBindingPatternElements";
        ListFormat2[ListFormat2["ArrayBindingPatternElements"] = 524880] = "ArrayBindingPatternElements";
        ListFormat2[ListFormat2["ObjectLiteralExpressionProperties"] = 526226] = "ObjectLiteralExpressionProperties";
        ListFormat2[ListFormat2["ArrayLiteralExpressionElements"] = 8914] = "ArrayLiteralExpressionElements";
        ListFormat2[ListFormat2["CommaListElements"] = 528] = "CommaListElements";
        ListFormat2[ListFormat2["CallExpressionArguments"] = 2576] = "CallExpressionArguments";
        ListFormat2[ListFormat2["NewExpressionArguments"] = 18960] = "NewExpressionArguments";
        ListFormat2[ListFormat2["TemplateExpressionSpans"] = 262144] = "TemplateExpressionSpans";
        ListFormat2[ListFormat2["SingleLineBlockStatements"] = 768] = "SingleLineBlockStatements";
        ListFormat2[ListFormat2["MultiLineBlockStatements"] = 129] = "MultiLineBlockStatements";
        ListFormat2[ListFormat2["VariableDeclarationList"] = 528] = "VariableDeclarationList";
        ListFormat2[ListFormat2["SingleLineFunctionBodyStatements"] = 768] = "SingleLineFunctionBodyStatements";
        ListFormat2[ListFormat2["MultiLineFunctionBodyStatements"] = 1] = "MultiLineFunctionBodyStatements";
        ListFormat2[ListFormat2["ClassHeritageClauses"] = 0] = "ClassHeritageClauses";
        ListFormat2[ListFormat2["ClassMembers"] = 129] = "ClassMembers";
        ListFormat2[ListFormat2["InterfaceMembers"] = 129] = "InterfaceMembers";
        ListFormat2[ListFormat2["EnumMembers"] = 145] = "EnumMembers";
        ListFormat2[ListFormat2["CaseBlockClauses"] = 129] = "CaseBlockClauses";
        ListFormat2[ListFormat2["NamedImportsOrExportsElements"] = 525136] = "NamedImportsOrExportsElements";
        ListFormat2[ListFormat2["JsxElementOrFragmentChildren"] = 262144] = "JsxElementOrFragmentChildren";
        ListFormat2[ListFormat2["JsxElementAttributes"] = 262656] = "JsxElementAttributes";
        ListFormat2[ListFormat2["CaseOrDefaultClauseStatements"] = 163969] = "CaseOrDefaultClauseStatements";
        ListFormat2[ListFormat2["HeritageClauseTypes"] = 528] = "HeritageClauseTypes";
        ListFormat2[ListFormat2["SourceFileStatements"] = 131073] = "SourceFileStatements";
        ListFormat2[ListFormat2["Decorators"] = 2146305] = "Decorators";
        ListFormat2[ListFormat2["TypeArguments"] = 53776] = "TypeArguments";
        ListFormat2[ListFormat2["TypeParameters"] = 53776] = "TypeParameters";
        ListFormat2[ListFormat2["Parameters"] = 2576] = "Parameters";
        ListFormat2[ListFormat2["IndexSignatureParameters"] = 8848] = "IndexSignatureParameters";
        ListFormat2[ListFormat2["JSDocComment"] = 33] = "JSDocComment";
      })(ListFormat = ts3.ListFormat || (ts3.ListFormat = {}));
      var PragmaKindFlags;
      (function(PragmaKindFlags2) {
        PragmaKindFlags2[PragmaKindFlags2["None"] = 0] = "None";
        PragmaKindFlags2[PragmaKindFlags2["TripleSlashXML"] = 1] = "TripleSlashXML";
        PragmaKindFlags2[PragmaKindFlags2["SingleLine"] = 2] = "SingleLine";
        PragmaKindFlags2[PragmaKindFlags2["MultiLine"] = 4] = "MultiLine";
        PragmaKindFlags2[PragmaKindFlags2["All"] = 7] = "All";
        PragmaKindFlags2[PragmaKindFlags2["Default"] = 7] = "Default";
      })(PragmaKindFlags = ts3.PragmaKindFlags || (ts3.PragmaKindFlags = {}));
      ts3.commentPragmas = {
        "reference": {
          args: [
            { name: "types", optional: true, captureSpan: true },
            { name: "lib", optional: true, captureSpan: true },
            { name: "path", optional: true, captureSpan: true },
            { name: "no-default-lib", optional: true }
          ],
          kind: 1
        },
        "amd-dependency": {
          args: [{ name: "path" }, { name: "name", optional: true }],
          kind: 1
        },
        "amd-module": {
          args: [{ name: "name" }],
          kind: 1
        },
        "ts-check": {
          kind: 2
        },
        "ts-nocheck": {
          kind: 2
        },
        "jsx": {
          args: [{ name: "factory" }],
          kind: 4
        },
        "jsxfrag": {
          args: [{ name: "factory" }],
          kind: 4
        },
        "jsximportsource": {
          args: [{ name: "factory" }],
          kind: 4
        },
        "jsxruntime": {
          args: [{ name: "factory" }],
          kind: 4
        }
      };
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      ts3.directorySeparator = "/";
      ts3.altDirectorySeparator = "\\";
      var urlSchemeSeparator = "://";
      var backslashRegExp = /\\/g;
      function isAnyDirectorySeparator(charCode) {
        return charCode === 47 || charCode === 92;
      }
      ts3.isAnyDirectorySeparator = isAnyDirectorySeparator;
      function isUrl(path2) {
        return getEncodedRootLength(path2) < 0;
      }
      ts3.isUrl = isUrl;
      function isRootedDiskPath(path2) {
        return getEncodedRootLength(path2) > 0;
      }
      ts3.isRootedDiskPath = isRootedDiskPath;
      function isDiskPathRoot(path2) {
        var rootLength = getEncodedRootLength(path2);
        return rootLength > 0 && rootLength === path2.length;
      }
      ts3.isDiskPathRoot = isDiskPathRoot;
      function pathIsAbsolute(path2) {
        return getEncodedRootLength(path2) !== 0;
      }
      ts3.pathIsAbsolute = pathIsAbsolute;
      function pathIsRelative(path2) {
        return /^\.\.?($|[\\/])/.test(path2);
      }
      ts3.pathIsRelative = pathIsRelative;
      function pathIsBareSpecifier(path2) {
        return !pathIsAbsolute(path2) && !pathIsRelative(path2);
      }
      ts3.pathIsBareSpecifier = pathIsBareSpecifier;
      function hasExtension(fileName) {
        return ts3.stringContains(getBaseFileName(fileName), ".");
      }
      ts3.hasExtension = hasExtension;
      function fileExtensionIs(path2, extension) {
        return path2.length > extension.length && ts3.endsWith(path2, extension);
      }
      ts3.fileExtensionIs = fileExtensionIs;
      function fileExtensionIsOneOf(path2, extensions) {
        for (var _i = 0, extensions_1 = extensions; _i < extensions_1.length; _i++) {
          var extension = extensions_1[_i];
          if (fileExtensionIs(path2, extension)) {
            return true;
          }
        }
        return false;
      }
      ts3.fileExtensionIsOneOf = fileExtensionIsOneOf;
      function hasTrailingDirectorySeparator(path2) {
        return path2.length > 0 && isAnyDirectorySeparator(path2.charCodeAt(path2.length - 1));
      }
      ts3.hasTrailingDirectorySeparator = hasTrailingDirectorySeparator;
      function isVolumeCharacter(charCode) {
        return charCode >= 97 && charCode <= 122 || charCode >= 65 && charCode <= 90;
      }
      function getFileUrlVolumeSeparatorEnd(url, start) {
        var ch0 = url.charCodeAt(start);
        if (ch0 === 58)
          return start + 1;
        if (ch0 === 37 && url.charCodeAt(start + 1) === 51) {
          var ch2 = url.charCodeAt(start + 2);
          if (ch2 === 97 || ch2 === 65)
            return start + 3;
        }
        return -1;
      }
      function getEncodedRootLength(path2) {
        if (!path2)
          return 0;
        var ch0 = path2.charCodeAt(0);
        if (ch0 === 47 || ch0 === 92) {
          if (path2.charCodeAt(1) !== ch0)
            return 1;
          var p1 = path2.indexOf(ch0 === 47 ? ts3.directorySeparator : ts3.altDirectorySeparator, 2);
          if (p1 < 0)
            return path2.length;
          return p1 + 1;
        }
        if (isVolumeCharacter(ch0) && path2.charCodeAt(1) === 58) {
          var ch2 = path2.charCodeAt(2);
          if (ch2 === 47 || ch2 === 92)
            return 3;
          if (path2.length === 2)
            return 2;
        }
        var schemeEnd = path2.indexOf(urlSchemeSeparator);
        if (schemeEnd !== -1) {
          var authorityStart = schemeEnd + urlSchemeSeparator.length;
          var authorityEnd = path2.indexOf(ts3.directorySeparator, authorityStart);
          if (authorityEnd !== -1) {
            var scheme = path2.slice(0, schemeEnd);
            var authority = path2.slice(authorityStart, authorityEnd);
            if (scheme === "file" && (authority === "" || authority === "localhost") && isVolumeCharacter(path2.charCodeAt(authorityEnd + 1))) {
              var volumeSeparatorEnd = getFileUrlVolumeSeparatorEnd(path2, authorityEnd + 2);
              if (volumeSeparatorEnd !== -1) {
                if (path2.charCodeAt(volumeSeparatorEnd) === 47) {
                  return ~(volumeSeparatorEnd + 1);
                }
                if (volumeSeparatorEnd === path2.length) {
                  return ~volumeSeparatorEnd;
                }
              }
            }
            return ~(authorityEnd + 1);
          }
          return ~path2.length;
        }
        return 0;
      }
      function getRootLength(path2) {
        var rootLength = getEncodedRootLength(path2);
        return rootLength < 0 ? ~rootLength : rootLength;
      }
      ts3.getRootLength = getRootLength;
      function getDirectoryPath(path2) {
        path2 = normalizeSlashes(path2);
        var rootLength = getRootLength(path2);
        if (rootLength === path2.length)
          return path2;
        path2 = removeTrailingDirectorySeparator(path2);
        return path2.slice(0, Math.max(rootLength, path2.lastIndexOf(ts3.directorySeparator)));
      }
      ts3.getDirectoryPath = getDirectoryPath;
      function getBaseFileName(path2, extensions, ignoreCase) {
        path2 = normalizeSlashes(path2);
        var rootLength = getRootLength(path2);
        if (rootLength === path2.length)
          return "";
        path2 = removeTrailingDirectorySeparator(path2);
        var name = path2.slice(Math.max(getRootLength(path2), path2.lastIndexOf(ts3.directorySeparator) + 1));
        var extension = extensions !== void 0 && ignoreCase !== void 0 ? getAnyExtensionFromPath(name, extensions, ignoreCase) : void 0;
        return extension ? name.slice(0, name.length - extension.length) : name;
      }
      ts3.getBaseFileName = getBaseFileName;
      function tryGetExtensionFromPath(path2, extension, stringEqualityComparer) {
        if (!ts3.startsWith(extension, "."))
          extension = "." + extension;
        if (path2.length >= extension.length && path2.charCodeAt(path2.length - extension.length) === 46) {
          var pathExtension = path2.slice(path2.length - extension.length);
          if (stringEqualityComparer(pathExtension, extension)) {
            return pathExtension;
          }
        }
      }
      function getAnyExtensionFromPathWorker(path2, extensions, stringEqualityComparer) {
        if (typeof extensions === "string") {
          return tryGetExtensionFromPath(path2, extensions, stringEqualityComparer) || "";
        }
        for (var _i = 0, extensions_2 = extensions; _i < extensions_2.length; _i++) {
          var extension = extensions_2[_i];
          var result2 = tryGetExtensionFromPath(path2, extension, stringEqualityComparer);
          if (result2)
            return result2;
        }
        return "";
      }
      function getAnyExtensionFromPath(path2, extensions, ignoreCase) {
        if (extensions) {
          return getAnyExtensionFromPathWorker(removeTrailingDirectorySeparator(path2), extensions, ignoreCase ? ts3.equateStringsCaseInsensitive : ts3.equateStringsCaseSensitive);
        }
        var baseFileName = getBaseFileName(path2);
        var extensionIndex = baseFileName.lastIndexOf(".");
        if (extensionIndex >= 0) {
          return baseFileName.substring(extensionIndex);
        }
        return "";
      }
      ts3.getAnyExtensionFromPath = getAnyExtensionFromPath;
      function pathComponents(path2, rootLength) {
        var root = path2.substring(0, rootLength);
        var rest = path2.substring(rootLength).split(ts3.directorySeparator);
        if (rest.length && !ts3.lastOrUndefined(rest))
          rest.pop();
        return __spreadArray([root], rest);
      }
      function getPathComponents(path2, currentDirectory) {
        if (currentDirectory === void 0) {
          currentDirectory = "";
        }
        path2 = combinePaths(currentDirectory, path2);
        return pathComponents(path2, getRootLength(path2));
      }
      ts3.getPathComponents = getPathComponents;
      function getPathFromPathComponents(pathComponents2) {
        if (pathComponents2.length === 0)
          return "";
        var root = pathComponents2[0] && ensureTrailingDirectorySeparator(pathComponents2[0]);
        return root + pathComponents2.slice(1).join(ts3.directorySeparator);
      }
      ts3.getPathFromPathComponents = getPathFromPathComponents;
      function normalizeSlashes(path2) {
        return path2.replace(backslashRegExp, ts3.directorySeparator);
      }
      ts3.normalizeSlashes = normalizeSlashes;
      function reducePathComponents(components) {
        if (!ts3.some(components))
          return [];
        var reduced = [components[0]];
        for (var i3 = 1; i3 < components.length; i3++) {
          var component = components[i3];
          if (!component)
            continue;
          if (component === ".")
            continue;
          if (component === "..") {
            if (reduced.length > 1) {
              if (reduced[reduced.length - 1] !== "..") {
                reduced.pop();
                continue;
              }
            } else if (reduced[0])
              continue;
          }
          reduced.push(component);
        }
        return reduced;
      }
      ts3.reducePathComponents = reducePathComponents;
      function combinePaths(path2) {
        var paths = [];
        for (var _i = 1; _i < arguments.length; _i++) {
          paths[_i - 1] = arguments[_i];
        }
        if (path2)
          path2 = normalizeSlashes(path2);
        for (var _a2 = 0, paths_1 = paths; _a2 < paths_1.length; _a2++) {
          var relativePath = paths_1[_a2];
          if (!relativePath)
            continue;
          relativePath = normalizeSlashes(relativePath);
          if (!path2 || getRootLength(relativePath) !== 0) {
            path2 = relativePath;
          } else {
            path2 = ensureTrailingDirectorySeparator(path2) + relativePath;
          }
        }
        return path2;
      }
      ts3.combinePaths = combinePaths;
      function resolvePath(path2) {
        var paths = [];
        for (var _i = 1; _i < arguments.length; _i++) {
          paths[_i - 1] = arguments[_i];
        }
        return normalizePath(ts3.some(paths) ? combinePaths.apply(void 0, __spreadArray([path2], paths)) : normalizeSlashes(path2));
      }
      ts3.resolvePath = resolvePath;
      function getNormalizedPathComponents(path2, currentDirectory) {
        return reducePathComponents(getPathComponents(path2, currentDirectory));
      }
      ts3.getNormalizedPathComponents = getNormalizedPathComponents;
      function getNormalizedAbsolutePath(fileName, currentDirectory) {
        return getPathFromPathComponents(getNormalizedPathComponents(fileName, currentDirectory));
      }
      ts3.getNormalizedAbsolutePath = getNormalizedAbsolutePath;
      function normalizePath(path2) {
        path2 = normalizeSlashes(path2);
        var normalized = getPathFromPathComponents(reducePathComponents(getPathComponents(path2)));
        return normalized && hasTrailingDirectorySeparator(path2) ? ensureTrailingDirectorySeparator(normalized) : normalized;
      }
      ts3.normalizePath = normalizePath;
      function getPathWithoutRoot(pathComponents2) {
        if (pathComponents2.length === 0)
          return "";
        return pathComponents2.slice(1).join(ts3.directorySeparator);
      }
      function getNormalizedAbsolutePathWithoutRoot(fileName, currentDirectory) {
        return getPathWithoutRoot(getNormalizedPathComponents(fileName, currentDirectory));
      }
      ts3.getNormalizedAbsolutePathWithoutRoot = getNormalizedAbsolutePathWithoutRoot;
      function toPath(fileName, basePath, getCanonicalFileName) {
        var nonCanonicalizedPath = isRootedDiskPath(fileName) ? normalizePath(fileName) : getNormalizedAbsolutePath(fileName, basePath);
        return getCanonicalFileName(nonCanonicalizedPath);
      }
      ts3.toPath = toPath;
      function normalizePathAndParts(path2) {
        path2 = normalizeSlashes(path2);
        var _a2 = reducePathComponents(getPathComponents(path2)), root = _a2[0], parts = _a2.slice(1);
        if (parts.length) {
          var joinedParts = root + parts.join(ts3.directorySeparator);
          return { path: hasTrailingDirectorySeparator(path2) ? ensureTrailingDirectorySeparator(joinedParts) : joinedParts, parts };
        } else {
          return { path: root, parts };
        }
      }
      ts3.normalizePathAndParts = normalizePathAndParts;
      function removeTrailingDirectorySeparator(path2) {
        if (hasTrailingDirectorySeparator(path2)) {
          return path2.substr(0, path2.length - 1);
        }
        return path2;
      }
      ts3.removeTrailingDirectorySeparator = removeTrailingDirectorySeparator;
      function ensureTrailingDirectorySeparator(path2) {
        if (!hasTrailingDirectorySeparator(path2)) {
          return path2 + ts3.directorySeparator;
        }
        return path2;
      }
      ts3.ensureTrailingDirectorySeparator = ensureTrailingDirectorySeparator;
      function ensurePathIsNonModuleName(path2) {
        return !pathIsAbsolute(path2) && !pathIsRelative(path2) ? "./" + path2 : path2;
      }
      ts3.ensurePathIsNonModuleName = ensurePathIsNonModuleName;
      function changeAnyExtension(path2, ext, extensions, ignoreCase) {
        var pathext = extensions !== void 0 && ignoreCase !== void 0 ? getAnyExtensionFromPath(path2, extensions, ignoreCase) : getAnyExtensionFromPath(path2);
        return pathext ? path2.slice(0, path2.length - pathext.length) + (ts3.startsWith(ext, ".") ? ext : "." + ext) : path2;
      }
      ts3.changeAnyExtension = changeAnyExtension;
      var relativePathSegmentRegExp = /(^|\/)\.{0,2}($|\/)/;
      function comparePathsWorker(a2, b2, componentComparer) {
        if (a2 === b2)
          return 0;
        if (a2 === void 0)
          return -1;
        if (b2 === void 0)
          return 1;
        var aRoot = a2.substring(0, getRootLength(a2));
        var bRoot = b2.substring(0, getRootLength(b2));
        var result2 = ts3.compareStringsCaseInsensitive(aRoot, bRoot);
        if (result2 !== 0) {
          return result2;
        }
        var aRest = a2.substring(aRoot.length);
        var bRest = b2.substring(bRoot.length);
        if (!relativePathSegmentRegExp.test(aRest) && !relativePathSegmentRegExp.test(bRest)) {
          return componentComparer(aRest, bRest);
        }
        var aComponents = reducePathComponents(getPathComponents(a2));
        var bComponents = reducePathComponents(getPathComponents(b2));
        var sharedLength = Math.min(aComponents.length, bComponents.length);
        for (var i3 = 1; i3 < sharedLength; i3++) {
          var result_2 = componentComparer(aComponents[i3], bComponents[i3]);
          if (result_2 !== 0) {
            return result_2;
          }
        }
        return ts3.compareValues(aComponents.length, bComponents.length);
      }
      function comparePathsCaseSensitive(a2, b2) {
        return comparePathsWorker(a2, b2, ts3.compareStringsCaseSensitive);
      }
      ts3.comparePathsCaseSensitive = comparePathsCaseSensitive;
      function comparePathsCaseInsensitive(a2, b2) {
        return comparePathsWorker(a2, b2, ts3.compareStringsCaseInsensitive);
      }
      ts3.comparePathsCaseInsensitive = comparePathsCaseInsensitive;
      function comparePaths(a2, b2, currentDirectory, ignoreCase) {
        if (typeof currentDirectory === "string") {
          a2 = combinePaths(currentDirectory, a2);
          b2 = combinePaths(currentDirectory, b2);
        } else if (typeof currentDirectory === "boolean") {
          ignoreCase = currentDirectory;
        }
        return comparePathsWorker(a2, b2, ts3.getStringComparer(ignoreCase));
      }
      ts3.comparePaths = comparePaths;
      function containsPath(parent, child, currentDirectory, ignoreCase) {
        if (typeof currentDirectory === "string") {
          parent = combinePaths(currentDirectory, parent);
          child = combinePaths(currentDirectory, child);
        } else if (typeof currentDirectory === "boolean") {
          ignoreCase = currentDirectory;
        }
        if (parent === void 0 || child === void 0)
          return false;
        if (parent === child)
          return true;
        var parentComponents = reducePathComponents(getPathComponents(parent));
        var childComponents = reducePathComponents(getPathComponents(child));
        if (childComponents.length < parentComponents.length) {
          return false;
        }
        var componentEqualityComparer = ignoreCase ? ts3.equateStringsCaseInsensitive : ts3.equateStringsCaseSensitive;
        for (var i3 = 0; i3 < parentComponents.length; i3++) {
          var equalityComparer = i3 === 0 ? ts3.equateStringsCaseInsensitive : componentEqualityComparer;
          if (!equalityComparer(parentComponents[i3], childComponents[i3])) {
            return false;
          }
        }
        return true;
      }
      ts3.containsPath = containsPath;
      function startsWithDirectory(fileName, directoryName, getCanonicalFileName) {
        var canonicalFileName = getCanonicalFileName(fileName);
        var canonicalDirectoryName = getCanonicalFileName(directoryName);
        return ts3.startsWith(canonicalFileName, canonicalDirectoryName + "/") || ts3.startsWith(canonicalFileName, canonicalDirectoryName + "\\");
      }
      ts3.startsWithDirectory = startsWithDirectory;
      function getPathComponentsRelativeTo(from, to, stringEqualityComparer, getCanonicalFileName) {
        var fromComponents = reducePathComponents(getPathComponents(from));
        var toComponents = reducePathComponents(getPathComponents(to));
        var start;
        for (start = 0; start < fromComponents.length && start < toComponents.length; start++) {
          var fromComponent = getCanonicalFileName(fromComponents[start]);
          var toComponent = getCanonicalFileName(toComponents[start]);
          var comparer = start === 0 ? ts3.equateStringsCaseInsensitive : stringEqualityComparer;
          if (!comparer(fromComponent, toComponent))
            break;
        }
        if (start === 0) {
          return toComponents;
        }
        var components = toComponents.slice(start);
        var relative = [];
        for (; start < fromComponents.length; start++) {
          relative.push("..");
        }
        return __spreadArray(__spreadArray([""], relative), components);
      }
      ts3.getPathComponentsRelativeTo = getPathComponentsRelativeTo;
      function getRelativePathFromDirectory(fromDirectory, to, getCanonicalFileNameOrIgnoreCase) {
        ts3.Debug.assert(getRootLength(fromDirectory) > 0 === getRootLength(to) > 0, "Paths must either both be absolute or both be relative");
        var getCanonicalFileName = typeof getCanonicalFileNameOrIgnoreCase === "function" ? getCanonicalFileNameOrIgnoreCase : ts3.identity;
        var ignoreCase = typeof getCanonicalFileNameOrIgnoreCase === "boolean" ? getCanonicalFileNameOrIgnoreCase : false;
        var pathComponents2 = getPathComponentsRelativeTo(fromDirectory, to, ignoreCase ? ts3.equateStringsCaseInsensitive : ts3.equateStringsCaseSensitive, getCanonicalFileName);
        return getPathFromPathComponents(pathComponents2);
      }
      ts3.getRelativePathFromDirectory = getRelativePathFromDirectory;
      function convertToRelativePath(absoluteOrRelativePath, basePath, getCanonicalFileName) {
        return !isRootedDiskPath(absoluteOrRelativePath) ? absoluteOrRelativePath : getRelativePathToDirectoryOrUrl(basePath, absoluteOrRelativePath, basePath, getCanonicalFileName, false);
      }
      ts3.convertToRelativePath = convertToRelativePath;
      function getRelativePathFromFile(from, to, getCanonicalFileName) {
        return ensurePathIsNonModuleName(getRelativePathFromDirectory(getDirectoryPath(from), to, getCanonicalFileName));
      }
      ts3.getRelativePathFromFile = getRelativePathFromFile;
      function getRelativePathToDirectoryOrUrl(directoryPathOrUrl, relativeOrAbsolutePath, currentDirectory, getCanonicalFileName, isAbsolutePathAnUrl) {
        var pathComponents2 = getPathComponentsRelativeTo(resolvePath(currentDirectory, directoryPathOrUrl), resolvePath(currentDirectory, relativeOrAbsolutePath), ts3.equateStringsCaseSensitive, getCanonicalFileName);
        var firstComponent = pathComponents2[0];
        if (isAbsolutePathAnUrl && isRootedDiskPath(firstComponent)) {
          var prefix2 = firstComponent.charAt(0) === ts3.directorySeparator ? "file://" : "file:///";
          pathComponents2[0] = prefix2 + firstComponent;
        }
        return getPathFromPathComponents(pathComponents2);
      }
      ts3.getRelativePathToDirectoryOrUrl = getRelativePathToDirectoryOrUrl;
      function forEachAncestorDirectory(directory, callback) {
        while (true) {
          var result2 = callback(directory);
          if (result2 !== void 0) {
            return result2;
          }
          var parentPath = getDirectoryPath(directory);
          if (parentPath === directory) {
            return void 0;
          }
          directory = parentPath;
        }
      }
      ts3.forEachAncestorDirectory = forEachAncestorDirectory;
      function isNodeModulesDirectory(dirPath) {
        return ts3.endsWith(dirPath, "/node_modules");
      }
      ts3.isNodeModulesDirectory = isNodeModulesDirectory;
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      function generateDjb2Hash(data) {
        var acc = 5381;
        for (var i3 = 0; i3 < data.length; i3++) {
          acc = (acc << 5) + acc + data.charCodeAt(i3);
        }
        return acc.toString();
      }
      ts3.generateDjb2Hash = generateDjb2Hash;
      function setStackTraceLimit() {
        if (Error.stackTraceLimit < 100) {
          Error.stackTraceLimit = 100;
        }
      }
      ts3.setStackTraceLimit = setStackTraceLimit;
      var FileWatcherEventKind;
      (function(FileWatcherEventKind2) {
        FileWatcherEventKind2[FileWatcherEventKind2["Created"] = 0] = "Created";
        FileWatcherEventKind2[FileWatcherEventKind2["Changed"] = 1] = "Changed";
        FileWatcherEventKind2[FileWatcherEventKind2["Deleted"] = 2] = "Deleted";
      })(FileWatcherEventKind = ts3.FileWatcherEventKind || (ts3.FileWatcherEventKind = {}));
      var PollingInterval;
      (function(PollingInterval2) {
        PollingInterval2[PollingInterval2["High"] = 2e3] = "High";
        PollingInterval2[PollingInterval2["Medium"] = 500] = "Medium";
        PollingInterval2[PollingInterval2["Low"] = 250] = "Low";
      })(PollingInterval = ts3.PollingInterval || (ts3.PollingInterval = {}));
      ts3.missingFileModifiedTime = new Date(0);
      function getModifiedTime(host, fileName) {
        return host.getModifiedTime(fileName) || ts3.missingFileModifiedTime;
      }
      ts3.getModifiedTime = getModifiedTime;
      function createPollingIntervalBasedLevels(levels) {
        var _a2;
        return _a2 = {}, _a2[PollingInterval.Low] = levels.Low, _a2[PollingInterval.Medium] = levels.Medium, _a2[PollingInterval.High] = levels.High, _a2;
      }
      var defaultChunkLevels = { Low: 32, Medium: 64, High: 256 };
      var pollingChunkSize = createPollingIntervalBasedLevels(defaultChunkLevels);
      ts3.unchangedPollThresholds = createPollingIntervalBasedLevels(defaultChunkLevels);
      function setCustomPollingValues(system) {
        if (!system.getEnvironmentVariable) {
          return;
        }
        var pollingIntervalChanged = setCustomLevels("TSC_WATCH_POLLINGINTERVAL", PollingInterval);
        pollingChunkSize = getCustomPollingBasedLevels("TSC_WATCH_POLLINGCHUNKSIZE", defaultChunkLevels) || pollingChunkSize;
        ts3.unchangedPollThresholds = getCustomPollingBasedLevels("TSC_WATCH_UNCHANGEDPOLLTHRESHOLDS", defaultChunkLevels) || ts3.unchangedPollThresholds;
        function getLevel(envVar, level) {
          return system.getEnvironmentVariable(envVar + "_" + level.toUpperCase());
        }
        function getCustomLevels(baseVariable) {
          var customLevels;
          setCustomLevel("Low");
          setCustomLevel("Medium");
          setCustomLevel("High");
          return customLevels;
          function setCustomLevel(level) {
            var customLevel = getLevel(baseVariable, level);
            if (customLevel) {
              (customLevels || (customLevels = {}))[level] = Number(customLevel);
            }
          }
        }
        function setCustomLevels(baseVariable, levels) {
          var customLevels = getCustomLevels(baseVariable);
          if (customLevels) {
            setLevel("Low");
            setLevel("Medium");
            setLevel("High");
            return true;
          }
          return false;
          function setLevel(level) {
            levels[level] = customLevels[level] || levels[level];
          }
        }
        function getCustomPollingBasedLevels(baseVariable, defaultLevels) {
          var customLevels = getCustomLevels(baseVariable);
          return (pollingIntervalChanged || customLevels) && createPollingIntervalBasedLevels(customLevels ? __assign(__assign({}, defaultLevels), customLevels) : defaultLevels);
        }
      }
      ts3.setCustomPollingValues = setCustomPollingValues;
      function pollWatchedFileQueue(host, queue, pollIndex, chunkSize, callbackOnWatchFileStat) {
        var definedValueCopyToIndex = pollIndex;
        for (var canVisit = queue.length; chunkSize && canVisit; nextPollIndex(), canVisit--) {
          var watchedFile = queue[pollIndex];
          if (!watchedFile) {
            continue;
          } else if (watchedFile.isClosed) {
            queue[pollIndex] = void 0;
            continue;
          }
          chunkSize--;
          var fileChanged = onWatchedFileStat(watchedFile, getModifiedTime(host, watchedFile.fileName));
          if (watchedFile.isClosed) {
            queue[pollIndex] = void 0;
            continue;
          }
          callbackOnWatchFileStat === null || callbackOnWatchFileStat === void 0 ? void 0 : callbackOnWatchFileStat(watchedFile, pollIndex, fileChanged);
          if (queue[pollIndex]) {
            if (definedValueCopyToIndex < pollIndex) {
              queue[definedValueCopyToIndex] = watchedFile;
              queue[pollIndex] = void 0;
            }
            definedValueCopyToIndex++;
          }
        }
        return pollIndex;
        function nextPollIndex() {
          pollIndex++;
          if (pollIndex === queue.length) {
            if (definedValueCopyToIndex < pollIndex) {
              queue.length = definedValueCopyToIndex;
            }
            pollIndex = 0;
            definedValueCopyToIndex = 0;
          }
        }
      }
      function createDynamicPriorityPollingWatchFile(host) {
        var watchedFiles = [];
        var changedFilesInLastPoll = [];
        var lowPollingIntervalQueue = createPollingIntervalQueue(PollingInterval.Low);
        var mediumPollingIntervalQueue = createPollingIntervalQueue(PollingInterval.Medium);
        var highPollingIntervalQueue = createPollingIntervalQueue(PollingInterval.High);
        return watchFile;
        function watchFile(fileName, callback, defaultPollingInterval) {
          var file = {
            fileName,
            callback,
            unchangedPolls: 0,
            mtime: getModifiedTime(host, fileName)
          };
          watchedFiles.push(file);
          addToPollingIntervalQueue(file, defaultPollingInterval);
          return {
            close: function() {
              file.isClosed = true;
              ts3.unorderedRemoveItem(watchedFiles, file);
            }
          };
        }
        function createPollingIntervalQueue(pollingInterval) {
          var queue = [];
          queue.pollingInterval = pollingInterval;
          queue.pollIndex = 0;
          queue.pollScheduled = false;
          return queue;
        }
        function pollPollingIntervalQueue(queue) {
          queue.pollIndex = pollQueue(queue, queue.pollingInterval, queue.pollIndex, pollingChunkSize[queue.pollingInterval]);
          if (queue.length) {
            scheduleNextPoll(queue.pollingInterval);
          } else {
            ts3.Debug.assert(queue.pollIndex === 0);
            queue.pollScheduled = false;
          }
        }
        function pollLowPollingIntervalQueue(queue) {
          pollQueue(changedFilesInLastPoll, PollingInterval.Low, 0, changedFilesInLastPoll.length);
          pollPollingIntervalQueue(queue);
          if (!queue.pollScheduled && changedFilesInLastPoll.length) {
            scheduleNextPoll(PollingInterval.Low);
          }
        }
        function pollQueue(queue, pollingInterval, pollIndex, chunkSize) {
          return pollWatchedFileQueue(host, queue, pollIndex, chunkSize, onWatchFileStat);
          function onWatchFileStat(watchedFile, pollIndex2, fileChanged) {
            if (fileChanged) {
              watchedFile.unchangedPolls = 0;
              if (queue !== changedFilesInLastPoll) {
                queue[pollIndex2] = void 0;
                addChangedFileToLowPollingIntervalQueue(watchedFile);
              }
            } else if (watchedFile.unchangedPolls !== ts3.unchangedPollThresholds[pollingInterval]) {
              watchedFile.unchangedPolls++;
            } else if (queue === changedFilesInLastPoll) {
              watchedFile.unchangedPolls = 1;
              queue[pollIndex2] = void 0;
              addToPollingIntervalQueue(watchedFile, PollingInterval.Low);
            } else if (pollingInterval !== PollingInterval.High) {
              watchedFile.unchangedPolls++;
              queue[pollIndex2] = void 0;
              addToPollingIntervalQueue(watchedFile, pollingInterval === PollingInterval.Low ? PollingInterval.Medium : PollingInterval.High);
            }
          }
        }
        function pollingIntervalQueue(pollingInterval) {
          switch (pollingInterval) {
            case PollingInterval.Low:
              return lowPollingIntervalQueue;
            case PollingInterval.Medium:
              return mediumPollingIntervalQueue;
            case PollingInterval.High:
              return highPollingIntervalQueue;
          }
        }
        function addToPollingIntervalQueue(file, pollingInterval) {
          pollingIntervalQueue(pollingInterval).push(file);
          scheduleNextPollIfNotAlreadyScheduled(pollingInterval);
        }
        function addChangedFileToLowPollingIntervalQueue(file) {
          changedFilesInLastPoll.push(file);
          scheduleNextPollIfNotAlreadyScheduled(PollingInterval.Low);
        }
        function scheduleNextPollIfNotAlreadyScheduled(pollingInterval) {
          if (!pollingIntervalQueue(pollingInterval).pollScheduled) {
            scheduleNextPoll(pollingInterval);
          }
        }
        function scheduleNextPoll(pollingInterval) {
          pollingIntervalQueue(pollingInterval).pollScheduled = host.setTimeout(pollingInterval === PollingInterval.Low ? pollLowPollingIntervalQueue : pollPollingIntervalQueue, pollingInterval, pollingIntervalQueue(pollingInterval));
        }
      }
      ts3.createDynamicPriorityPollingWatchFile = createDynamicPriorityPollingWatchFile;
      function createUseFsEventsOnParentDirectoryWatchFile(fsWatch, useCaseSensitiveFileNames) {
        var fileWatcherCallbacks = ts3.createMultiMap();
        var dirWatchers = new ts3.Map();
        var toCanonicalName = ts3.createGetCanonicalFileName(useCaseSensitiveFileNames);
        return nonPollingWatchFile;
        function nonPollingWatchFile(fileName, callback, _pollingInterval, fallbackOptions) {
          var filePath = toCanonicalName(fileName);
          fileWatcherCallbacks.add(filePath, callback);
          var dirPath = ts3.getDirectoryPath(filePath) || ".";
          var watcher = dirWatchers.get(dirPath) || createDirectoryWatcher(ts3.getDirectoryPath(fileName) || ".", dirPath, fallbackOptions);
          watcher.referenceCount++;
          return {
            close: function() {
              if (watcher.referenceCount === 1) {
                watcher.close();
                dirWatchers.delete(dirPath);
              } else {
                watcher.referenceCount--;
              }
              fileWatcherCallbacks.remove(filePath, callback);
            }
          };
        }
        function createDirectoryWatcher(dirName, dirPath, fallbackOptions) {
          var watcher = fsWatch(dirName, 1, function(_eventName, relativeFileName) {
            if (!ts3.isString(relativeFileName)) {
              return;
            }
            var fileName = ts3.getNormalizedAbsolutePath(relativeFileName, dirName);
            var callbacks = fileName && fileWatcherCallbacks.get(toCanonicalName(fileName));
            if (callbacks) {
              for (var _i = 0, callbacks_1 = callbacks; _i < callbacks_1.length; _i++) {
                var fileCallback = callbacks_1[_i];
                fileCallback(fileName, FileWatcherEventKind.Changed);
              }
            }
          }, false, PollingInterval.Medium, fallbackOptions);
          watcher.referenceCount = 0;
          dirWatchers.set(dirPath, watcher);
          return watcher;
        }
      }
      function createFixedChunkSizePollingWatchFile(host) {
        var watchedFiles = [];
        var pollIndex = 0;
        var pollScheduled;
        return watchFile;
        function watchFile(fileName, callback) {
          var file = {
            fileName,
            callback,
            mtime: getModifiedTime(host, fileName)
          };
          watchedFiles.push(file);
          scheduleNextPoll();
          return {
            close: function() {
              file.isClosed = true;
              ts3.unorderedRemoveItem(watchedFiles, file);
            }
          };
        }
        function pollQueue() {
          pollScheduled = void 0;
          pollIndex = pollWatchedFileQueue(host, watchedFiles, pollIndex, pollingChunkSize[PollingInterval.Low]);
          scheduleNextPoll();
        }
        function scheduleNextPoll() {
          if (!watchedFiles.length || pollScheduled)
            return;
          pollScheduled = host.setTimeout(pollQueue, PollingInterval.High);
        }
      }
      function createSingleFileWatcherPerName(watchFile, useCaseSensitiveFileNames) {
        var cache = new ts3.Map();
        var callbacksCache = ts3.createMultiMap();
        var toCanonicalFileName = ts3.createGetCanonicalFileName(useCaseSensitiveFileNames);
        return function(fileName, callback, pollingInterval, options) {
          var path2 = toCanonicalFileName(fileName);
          var existing = cache.get(path2);
          if (existing) {
            existing.refCount++;
          } else {
            cache.set(path2, {
              watcher: watchFile(fileName, function(fileName2, eventKind) {
                return ts3.forEach(callbacksCache.get(path2), function(cb2) {
                  return cb2(fileName2, eventKind);
                });
              }, pollingInterval, options),
              refCount: 1
            });
          }
          callbacksCache.add(path2, callback);
          return {
            close: function() {
              var watcher = ts3.Debug.checkDefined(cache.get(path2));
              callbacksCache.remove(path2, callback);
              watcher.refCount--;
              if (watcher.refCount)
                return;
              cache.delete(path2);
              ts3.closeFileWatcherOf(watcher);
            }
          };
        };
      }
      ts3.createSingleFileWatcherPerName = createSingleFileWatcherPerName;
      function onWatchedFileStat(watchedFile, modifiedTime) {
        var oldTime = watchedFile.mtime.getTime();
        var newTime = modifiedTime.getTime();
        if (oldTime !== newTime) {
          watchedFile.mtime = modifiedTime;
          watchedFile.callback(watchedFile.fileName, getFileWatcherEventKind(oldTime, newTime));
          return true;
        }
        return false;
      }
      ts3.onWatchedFileStat = onWatchedFileStat;
      function getFileWatcherEventKind(oldTime, newTime) {
        return oldTime === 0 ? FileWatcherEventKind.Created : newTime === 0 ? FileWatcherEventKind.Deleted : FileWatcherEventKind.Changed;
      }
      ts3.getFileWatcherEventKind = getFileWatcherEventKind;
      ts3.ignoredPaths = ["/node_modules/.", "/.git", "/.#"];
      ts3.sysLog = ts3.noop;
      function setSysLog(logger) {
        ts3.sysLog = logger;
      }
      ts3.setSysLog = setSysLog;
      function createDirectoryWatcherSupportingRecursive(_a2) {
        var watchDirectory = _a2.watchDirectory, useCaseSensitiveFileNames = _a2.useCaseSensitiveFileNames, getCurrentDirectory = _a2.getCurrentDirectory, getAccessibleSortedChildDirectories = _a2.getAccessibleSortedChildDirectories, directoryExists = _a2.directoryExists, realpath = _a2.realpath, setTimeout2 = _a2.setTimeout, clearTimeout2 = _a2.clearTimeout;
        var cache = new ts3.Map();
        var callbackCache = ts3.createMultiMap();
        var cacheToUpdateChildWatches = new ts3.Map();
        var timerToUpdateChildWatches;
        var filePathComparer = ts3.getStringComparer(!useCaseSensitiveFileNames);
        var toCanonicalFilePath = ts3.createGetCanonicalFileName(useCaseSensitiveFileNames);
        return function(dirName, callback, recursive, options) {
          return recursive ? createDirectoryWatcher(dirName, options, callback) : watchDirectory(dirName, callback, recursive, options);
        };
        function createDirectoryWatcher(dirName, options, callback) {
          var dirPath = toCanonicalFilePath(dirName);
          var directoryWatcher = cache.get(dirPath);
          if (directoryWatcher) {
            directoryWatcher.refCount++;
          } else {
            directoryWatcher = {
              watcher: watchDirectory(dirName, function(fileName) {
                if (isIgnoredPath(fileName, options))
                  return;
                if (options === null || options === void 0 ? void 0 : options.synchronousWatchDirectory) {
                  invokeCallbacks(dirPath, fileName);
                  updateChildWatches(dirName, dirPath, options);
                } else {
                  nonSyncUpdateChildWatches(dirName, dirPath, fileName, options);
                }
              }, false, options),
              refCount: 1,
              childWatches: ts3.emptyArray
            };
            cache.set(dirPath, directoryWatcher);
            updateChildWatches(dirName, dirPath, options);
          }
          var callbackToAdd = callback && { dirName, callback };
          if (callbackToAdd) {
            callbackCache.add(dirPath, callbackToAdd);
          }
          return {
            dirName,
            close: function() {
              var directoryWatcher2 = ts3.Debug.checkDefined(cache.get(dirPath));
              if (callbackToAdd)
                callbackCache.remove(dirPath, callbackToAdd);
              directoryWatcher2.refCount--;
              if (directoryWatcher2.refCount)
                return;
              cache.delete(dirPath);
              ts3.closeFileWatcherOf(directoryWatcher2);
              directoryWatcher2.childWatches.forEach(ts3.closeFileWatcher);
            }
          };
        }
        function invokeCallbacks(dirPath, fileNameOrInvokeMap, fileNames) {
          var fileName;
          var invokeMap;
          if (ts3.isString(fileNameOrInvokeMap)) {
            fileName = fileNameOrInvokeMap;
          } else {
            invokeMap = fileNameOrInvokeMap;
          }
          callbackCache.forEach(function(callbacks, rootDirName) {
            var _a3;
            if (invokeMap && invokeMap.get(rootDirName) === true)
              return;
            if (rootDirName === dirPath || ts3.startsWith(dirPath, rootDirName) && dirPath[rootDirName.length] === ts3.directorySeparator) {
              if (invokeMap) {
                if (fileNames) {
                  var existing = invokeMap.get(rootDirName);
                  if (existing) {
                    (_a3 = existing).push.apply(_a3, fileNames);
                  } else {
                    invokeMap.set(rootDirName, fileNames.slice());
                  }
                } else {
                  invokeMap.set(rootDirName, true);
                }
              } else {
                callbacks.forEach(function(_a4) {
                  var callback = _a4.callback;
                  return callback(fileName);
                });
              }
            }
          });
        }
        function nonSyncUpdateChildWatches(dirName, dirPath, fileName, options) {
          var parentWatcher = cache.get(dirPath);
          if (parentWatcher && directoryExists(dirName)) {
            scheduleUpdateChildWatches(dirName, dirPath, fileName, options);
            return;
          }
          invokeCallbacks(dirPath, fileName);
          removeChildWatches(parentWatcher);
        }
        function scheduleUpdateChildWatches(dirName, dirPath, fileName, options) {
          var existing = cacheToUpdateChildWatches.get(dirPath);
          if (existing) {
            existing.fileNames.push(fileName);
          } else {
            cacheToUpdateChildWatches.set(dirPath, { dirName, options, fileNames: [fileName] });
          }
          if (timerToUpdateChildWatches) {
            clearTimeout2(timerToUpdateChildWatches);
            timerToUpdateChildWatches = void 0;
          }
          timerToUpdateChildWatches = setTimeout2(onTimerToUpdateChildWatches, 1e3);
        }
        function onTimerToUpdateChildWatches() {
          timerToUpdateChildWatches = void 0;
          ts3.sysLog("sysLog:: onTimerToUpdateChildWatches:: " + cacheToUpdateChildWatches.size);
          var start = ts3.timestamp();
          var invokeMap = new ts3.Map();
          while (!timerToUpdateChildWatches && cacheToUpdateChildWatches.size) {
            var result2 = cacheToUpdateChildWatches.entries().next();
            ts3.Debug.assert(!result2.done);
            var _a3 = result2.value, dirPath = _a3[0], _b = _a3[1], dirName = _b.dirName, options = _b.options, fileNames = _b.fileNames;
            cacheToUpdateChildWatches.delete(dirPath);
            var hasChanges = updateChildWatches(dirName, dirPath, options);
            invokeCallbacks(dirPath, invokeMap, hasChanges ? void 0 : fileNames);
          }
          ts3.sysLog("sysLog:: invokingWatchers:: Elapsed:: " + (ts3.timestamp() - start) + "ms:: " + cacheToUpdateChildWatches.size);
          callbackCache.forEach(function(callbacks, rootDirName) {
            var existing = invokeMap.get(rootDirName);
            if (existing) {
              callbacks.forEach(function(_a4) {
                var callback = _a4.callback, dirName2 = _a4.dirName;
                if (ts3.isArray(existing)) {
                  existing.forEach(callback);
                } else {
                  callback(dirName2);
                }
              });
            }
          });
          var elapsed = ts3.timestamp() - start;
          ts3.sysLog("sysLog:: Elapsed:: " + elapsed + "ms:: onTimerToUpdateChildWatches:: " + cacheToUpdateChildWatches.size + " " + timerToUpdateChildWatches);
        }
        function removeChildWatches(parentWatcher) {
          if (!parentWatcher)
            return;
          var existingChildWatches = parentWatcher.childWatches;
          parentWatcher.childWatches = ts3.emptyArray;
          for (var _i = 0, existingChildWatches_1 = existingChildWatches; _i < existingChildWatches_1.length; _i++) {
            var childWatcher = existingChildWatches_1[_i];
            childWatcher.close();
            removeChildWatches(cache.get(toCanonicalFilePath(childWatcher.dirName)));
          }
        }
        function updateChildWatches(parentDir, parentDirPath, options) {
          var parentWatcher = cache.get(parentDirPath);
          if (!parentWatcher)
            return false;
          var newChildWatches;
          var hasChanges = ts3.enumerateInsertsAndDeletes(directoryExists(parentDir) ? ts3.mapDefined(getAccessibleSortedChildDirectories(parentDir), function(child) {
            var childFullName = ts3.getNormalizedAbsolutePath(child, parentDir);
            return !isIgnoredPath(childFullName, options) && filePathComparer(childFullName, ts3.normalizePath(realpath(childFullName))) === 0 ? childFullName : void 0;
          }) : ts3.emptyArray, parentWatcher.childWatches, function(child, childWatcher) {
            return filePathComparer(child, childWatcher.dirName);
          }, createAndAddChildDirectoryWatcher, ts3.closeFileWatcher, addChildDirectoryWatcher);
          parentWatcher.childWatches = newChildWatches || ts3.emptyArray;
          return hasChanges;
          function createAndAddChildDirectoryWatcher(childName) {
            var result2 = createDirectoryWatcher(childName, options);
            addChildDirectoryWatcher(result2);
          }
          function addChildDirectoryWatcher(childWatcher) {
            (newChildWatches || (newChildWatches = [])).push(childWatcher);
          }
        }
        function isIgnoredPath(path2, options) {
          return ts3.some(ts3.ignoredPaths, function(searchPath) {
            return isInPath(path2, searchPath);
          }) || isIgnoredByWatchOptions(path2, options, useCaseSensitiveFileNames, getCurrentDirectory);
        }
        function isInPath(path2, searchPath) {
          if (ts3.stringContains(path2, searchPath))
            return true;
          if (useCaseSensitiveFileNames)
            return false;
          return ts3.stringContains(toCanonicalFilePath(path2), searchPath);
        }
      }
      ts3.createDirectoryWatcherSupportingRecursive = createDirectoryWatcherSupportingRecursive;
      var FileSystemEntryKind;
      (function(FileSystemEntryKind2) {
        FileSystemEntryKind2[FileSystemEntryKind2["File"] = 0] = "File";
        FileSystemEntryKind2[FileSystemEntryKind2["Directory"] = 1] = "Directory";
      })(FileSystemEntryKind = ts3.FileSystemEntryKind || (ts3.FileSystemEntryKind = {}));
      function createFileWatcherCallback(callback) {
        return function(_fileName, eventKind) {
          return callback(eventKind === FileWatcherEventKind.Changed ? "change" : "rename", "");
        };
      }
      ts3.createFileWatcherCallback = createFileWatcherCallback;
      function createFsWatchCallbackForFileWatcherCallback(fileName, callback, fileExists) {
        return function(eventName) {
          if (eventName === "rename") {
            callback(fileName, fileExists(fileName) ? FileWatcherEventKind.Created : FileWatcherEventKind.Deleted);
          } else {
            callback(fileName, FileWatcherEventKind.Changed);
          }
        };
      }
      function isIgnoredByWatchOptions(pathToCheck, options, useCaseSensitiveFileNames, getCurrentDirectory) {
        return ((options === null || options === void 0 ? void 0 : options.excludeDirectories) || (options === null || options === void 0 ? void 0 : options.excludeFiles)) && (ts3.matchesExclude(pathToCheck, options === null || options === void 0 ? void 0 : options.excludeFiles, useCaseSensitiveFileNames, getCurrentDirectory()) || ts3.matchesExclude(pathToCheck, options === null || options === void 0 ? void 0 : options.excludeDirectories, useCaseSensitiveFileNames, getCurrentDirectory()));
      }
      function createFsWatchCallbackForDirectoryWatcherCallback(directoryName, callback, options, useCaseSensitiveFileNames, getCurrentDirectory) {
        return function(eventName, relativeFileName) {
          if (eventName === "rename") {
            var fileName = !relativeFileName ? directoryName : ts3.normalizePath(ts3.combinePaths(directoryName, relativeFileName));
            if (!relativeFileName || !isIgnoredByWatchOptions(fileName, options, useCaseSensitiveFileNames, getCurrentDirectory)) {
              callback(fileName);
            }
          }
        };
      }
      function createSystemWatchFunctions(_a2) {
        var pollingWatchFile = _a2.pollingWatchFile, getModifiedTime2 = _a2.getModifiedTime, setTimeout2 = _a2.setTimeout, clearTimeout2 = _a2.clearTimeout, fsWatch = _a2.fsWatch, fileExists = _a2.fileExists, useCaseSensitiveFileNames = _a2.useCaseSensitiveFileNames, getCurrentDirectory = _a2.getCurrentDirectory, fsSupportsRecursiveFsWatch = _a2.fsSupportsRecursiveFsWatch, directoryExists = _a2.directoryExists, getAccessibleSortedChildDirectories = _a2.getAccessibleSortedChildDirectories, realpath = _a2.realpath, tscWatchFile = _a2.tscWatchFile, useNonPollingWatchers = _a2.useNonPollingWatchers, tscWatchDirectory = _a2.tscWatchDirectory, defaultWatchFileKind = _a2.defaultWatchFileKind;
        var dynamicPollingWatchFile;
        var fixedChunkSizePollingWatchFile;
        var nonPollingWatchFile;
        var hostRecursiveDirectoryWatcher;
        return {
          watchFile,
          watchDirectory
        };
        function watchFile(fileName, callback, pollingInterval, options) {
          options = updateOptionsForWatchFile(options, useNonPollingWatchers);
          var watchFileKind = ts3.Debug.checkDefined(options.watchFile);
          switch (watchFileKind) {
            case ts3.WatchFileKind.FixedPollingInterval:
              return pollingWatchFile(fileName, callback, PollingInterval.Low, void 0);
            case ts3.WatchFileKind.PriorityPollingInterval:
              return pollingWatchFile(fileName, callback, pollingInterval, void 0);
            case ts3.WatchFileKind.DynamicPriorityPolling:
              return ensureDynamicPollingWatchFile()(fileName, callback, pollingInterval, void 0);
            case ts3.WatchFileKind.FixedChunkSizePolling:
              return ensureFixedChunkSizePollingWatchFile()(fileName, callback, void 0, void 0);
            case ts3.WatchFileKind.UseFsEvents:
              return fsWatch(fileName, 0, createFsWatchCallbackForFileWatcherCallback(fileName, callback, fileExists), false, pollingInterval, ts3.getFallbackOptions(options));
            case ts3.WatchFileKind.UseFsEventsOnParentDirectory:
              if (!nonPollingWatchFile) {
                nonPollingWatchFile = createUseFsEventsOnParentDirectoryWatchFile(fsWatch, useCaseSensitiveFileNames);
              }
              return nonPollingWatchFile(fileName, callback, pollingInterval, ts3.getFallbackOptions(options));
            default:
              ts3.Debug.assertNever(watchFileKind);
          }
        }
        function ensureDynamicPollingWatchFile() {
          return dynamicPollingWatchFile || (dynamicPollingWatchFile = createDynamicPriorityPollingWatchFile({ getModifiedTime: getModifiedTime2, setTimeout: setTimeout2 }));
        }
        function ensureFixedChunkSizePollingWatchFile() {
          return fixedChunkSizePollingWatchFile || (fixedChunkSizePollingWatchFile = createFixedChunkSizePollingWatchFile({ getModifiedTime: getModifiedTime2, setTimeout: setTimeout2 }));
        }
        function updateOptionsForWatchFile(options, useNonPollingWatchers2) {
          if (options && options.watchFile !== void 0)
            return options;
          switch (tscWatchFile) {
            case "PriorityPollingInterval":
              return { watchFile: ts3.WatchFileKind.PriorityPollingInterval };
            case "DynamicPriorityPolling":
              return { watchFile: ts3.WatchFileKind.DynamicPriorityPolling };
            case "UseFsEvents":
              return generateWatchFileOptions(ts3.WatchFileKind.UseFsEvents, ts3.PollingWatchKind.PriorityInterval, options);
            case "UseFsEventsWithFallbackDynamicPolling":
              return generateWatchFileOptions(ts3.WatchFileKind.UseFsEvents, ts3.PollingWatchKind.DynamicPriority, options);
            case "UseFsEventsOnParentDirectory":
              useNonPollingWatchers2 = true;
            default:
              return useNonPollingWatchers2 ? generateWatchFileOptions(ts3.WatchFileKind.UseFsEventsOnParentDirectory, ts3.PollingWatchKind.PriorityInterval, options) : { watchFile: (defaultWatchFileKind === null || defaultWatchFileKind === void 0 ? void 0 : defaultWatchFileKind()) || ts3.WatchFileKind.FixedPollingInterval };
          }
        }
        function generateWatchFileOptions(watchFile2, fallbackPolling, options) {
          var defaultFallbackPolling = options === null || options === void 0 ? void 0 : options.fallbackPolling;
          return {
            watchFile: watchFile2,
            fallbackPolling: defaultFallbackPolling === void 0 ? fallbackPolling : defaultFallbackPolling
          };
        }
        function watchDirectory(directoryName, callback, recursive, options) {
          if (fsSupportsRecursiveFsWatch) {
            return fsWatch(directoryName, 1, createFsWatchCallbackForDirectoryWatcherCallback(directoryName, callback, options, useCaseSensitiveFileNames, getCurrentDirectory), recursive, PollingInterval.Medium, ts3.getFallbackOptions(options));
          }
          if (!hostRecursiveDirectoryWatcher) {
            hostRecursiveDirectoryWatcher = createDirectoryWatcherSupportingRecursive({
              useCaseSensitiveFileNames,
              getCurrentDirectory,
              directoryExists,
              getAccessibleSortedChildDirectories,
              watchDirectory: nonRecursiveWatchDirectory,
              realpath,
              setTimeout: setTimeout2,
              clearTimeout: clearTimeout2
            });
          }
          return hostRecursiveDirectoryWatcher(directoryName, callback, recursive, options);
        }
        function nonRecursiveWatchDirectory(directoryName, callback, recursive, options) {
          ts3.Debug.assert(!recursive);
          var watchDirectoryOptions = updateOptionsForWatchDirectory(options);
          var watchDirectoryKind = ts3.Debug.checkDefined(watchDirectoryOptions.watchDirectory);
          switch (watchDirectoryKind) {
            case ts3.WatchDirectoryKind.FixedPollingInterval:
              return pollingWatchFile(directoryName, function() {
                return callback(directoryName);
              }, PollingInterval.Medium, void 0);
            case ts3.WatchDirectoryKind.DynamicPriorityPolling:
              return ensureDynamicPollingWatchFile()(directoryName, function() {
                return callback(directoryName);
              }, PollingInterval.Medium, void 0);
            case ts3.WatchDirectoryKind.FixedChunkSizePolling:
              return ensureFixedChunkSizePollingWatchFile()(directoryName, function() {
                return callback(directoryName);
              }, void 0, void 0);
            case ts3.WatchDirectoryKind.UseFsEvents:
              return fsWatch(directoryName, 1, createFsWatchCallbackForDirectoryWatcherCallback(directoryName, callback, options, useCaseSensitiveFileNames, getCurrentDirectory), recursive, PollingInterval.Medium, ts3.getFallbackOptions(watchDirectoryOptions));
            default:
              ts3.Debug.assertNever(watchDirectoryKind);
          }
        }
        function updateOptionsForWatchDirectory(options) {
          if (options && options.watchDirectory !== void 0)
            return options;
          switch (tscWatchDirectory) {
            case "RecursiveDirectoryUsingFsWatchFile":
              return { watchDirectory: ts3.WatchDirectoryKind.FixedPollingInterval };
            case "RecursiveDirectoryUsingDynamicPriorityPolling":
              return { watchDirectory: ts3.WatchDirectoryKind.DynamicPriorityPolling };
            default:
              var defaultFallbackPolling = options === null || options === void 0 ? void 0 : options.fallbackPolling;
              return {
                watchDirectory: ts3.WatchDirectoryKind.UseFsEvents,
                fallbackPolling: defaultFallbackPolling !== void 0 ? defaultFallbackPolling : void 0
              };
          }
        }
      }
      ts3.createSystemWatchFunctions = createSystemWatchFunctions;
      function patchWriteFileEnsuringDirectory(sys) {
        var originalWriteFile = sys.writeFile;
        sys.writeFile = function(path2, data, writeBom) {
          return ts3.writeFileEnsuringDirectories(path2, data, !!writeBom, function(path3, data2, writeByteOrderMark) {
            return originalWriteFile.call(sys, path3, data2, writeByteOrderMark);
          }, function(path3) {
            return sys.createDirectory(path3);
          }, function(path3) {
            return sys.directoryExists(path3);
          });
        };
      }
      ts3.patchWriteFileEnsuringDirectory = patchWriteFileEnsuringDirectory;
      function getNodeMajorVersion() {
        if (typeof process === "undefined") {
          return void 0;
        }
        var version = process.version;
        if (!version) {
          return void 0;
        }
        var dot = version.indexOf(".");
        if (dot === -1) {
          return void 0;
        }
        return parseInt(version.substring(1, dot));
      }
      ts3.getNodeMajorVersion = getNodeMajorVersion;
      ts3.sys = function() {
        var byteOrderMarkIndicator = "\uFEFF";
        function getNodeSystem() {
          var _a2;
          var nativePattern = /^native |^\([^)]+\)$|^(internal[\\/]|[a-zA-Z0-9_\s]+(\.js)?$)/;
          var _fs = require("fs");
          var _path = require("path");
          var _os = require("os");
          var _crypto;
          try {
            _crypto = require("crypto");
          } catch (_b) {
            _crypto = void 0;
          }
          var activeSession;
          var profilePath = "./profile.cpuprofile";
          var Buffer2 = require("buffer").Buffer;
          var nodeVersion = getNodeMajorVersion();
          var isNode4OrLater = nodeVersion >= 4;
          var isLinuxOrMacOs = process.platform === "linux" || process.platform === "darwin";
          var platform = _os.platform();
          var useCaseSensitiveFileNames = isFileSystemCaseSensitive();
          var realpathSync = useCaseSensitiveFileNames ? (_a2 = _fs.realpathSync.native) !== null && _a2 !== void 0 ? _a2 : _fs.realpathSync : _fs.realpathSync;
          var fsSupportsRecursiveFsWatch = isNode4OrLater && (process.platform === "win32" || process.platform === "darwin");
          var getCurrentDirectory = ts3.memoize(function() {
            return process.cwd();
          });
          var _c = createSystemWatchFunctions({
            pollingWatchFile: createSingleFileWatcherPerName(fsWatchFileWorker, useCaseSensitiveFileNames),
            getModifiedTime: getModifiedTime2,
            setTimeout,
            clearTimeout,
            fsWatch,
            useCaseSensitiveFileNames,
            getCurrentDirectory,
            fileExists,
            fsSupportsRecursiveFsWatch,
            directoryExists,
            getAccessibleSortedChildDirectories: function(path2) {
              return getAccessibleFileSystemEntries(path2).directories;
            },
            realpath,
            tscWatchFile: process.env.TSC_WATCHFILE,
            useNonPollingWatchers: process.env.TSC_NONPOLLING_WATCHER,
            tscWatchDirectory: process.env.TSC_WATCHDIRECTORY,
            defaultWatchFileKind: function() {
              var _a3, _b;
              return (_b = (_a3 = sys).defaultWatchFileKind) === null || _b === void 0 ? void 0 : _b.call(_a3);
            }
          }), watchFile = _c.watchFile, watchDirectory = _c.watchDirectory;
          var nodeSystem = {
            args: process.argv.slice(2),
            newLine: _os.EOL,
            useCaseSensitiveFileNames,
            write: function(s2) {
              process.stdout.write(s2);
            },
            writeOutputIsTTY: function() {
              return process.stdout.isTTY;
            },
            readFile,
            writeFile,
            watchFile,
            watchDirectory,
            resolvePath: function(path2) {
              return _path.resolve(path2);
            },
            fileExists,
            directoryExists,
            createDirectory: function(directoryName) {
              if (!nodeSystem.directoryExists(directoryName)) {
                try {
                  _fs.mkdirSync(directoryName);
                } catch (e2) {
                  if (e2.code !== "EEXIST") {
                    throw e2;
                  }
                }
              }
            },
            getExecutingFilePath: function() {
              return __filename;
            },
            getCurrentDirectory,
            getDirectories,
            getEnvironmentVariable: function(name) {
              return process.env[name] || "";
            },
            readDirectory,
            getModifiedTime: getModifiedTime2,
            setModifiedTime,
            deleteFile,
            createHash: _crypto ? createSHA256Hash : generateDjb2Hash,
            createSHA256Hash: _crypto ? createSHA256Hash : void 0,
            getMemoryUsage: function() {
              if (global.gc) {
                global.gc();
              }
              return process.memoryUsage().heapUsed;
            },
            getFileSize: function(path2) {
              try {
                var stat = statSync(path2);
                if (stat === null || stat === void 0 ? void 0 : stat.isFile()) {
                  return stat.size;
                }
              } catch (_a3) {
              }
              return 0;
            },
            exit: function(exitCode) {
              disableCPUProfiler(function() {
                return process.exit(exitCode);
              });
            },
            enableCPUProfiler,
            disableCPUProfiler,
            cpuProfilingEnabled: function() {
              return !!activeSession || ts3.contains(process.execArgv, "--cpu-prof") || ts3.contains(process.execArgv, "--prof");
            },
            realpath,
            debugMode: !!process.env.NODE_INSPECTOR_IPC || !!process.env.VSCODE_INSPECTOR_OPTIONS || ts3.some(process.execArgv, function(arg2) {
              return /^--(inspect|debug)(-brk)?(=\d+)?$/i.test(arg2);
            }),
            tryEnableSourceMapsForHost: function() {
              try {
                require_source_map_support().install();
              } catch (_a3) {
              }
            },
            setTimeout,
            clearTimeout,
            clearScreen: function() {
              process.stdout.write("c");
            },
            setBlocking: function() {
              if (process.stdout && process.stdout._handle && process.stdout._handle.setBlocking) {
                process.stdout._handle.setBlocking(true);
              }
            },
            bufferFrom,
            base64decode: function(input) {
              return bufferFrom(input, "base64").toString("utf8");
            },
            base64encode: function(input) {
              return bufferFrom(input).toString("base64");
            },
            require: function(baseDir, moduleName) {
              try {
                var modulePath = ts3.resolveJSModule(moduleName, baseDir, nodeSystem);
                return { module: require(modulePath), modulePath, error: void 0 };
              } catch (error) {
                return { module: void 0, modulePath: void 0, error };
              }
            }
          };
          return nodeSystem;
          function statSync(path2) {
            return _fs.statSync(path2, { throwIfNoEntry: false });
          }
          function enableCPUProfiler(path2, cb2) {
            if (activeSession) {
              cb2();
              return false;
            }
            var inspector = require("inspector");
            if (!inspector || !inspector.Session) {
              cb2();
              return false;
            }
            var session = new inspector.Session();
            session.connect();
            session.post("Profiler.enable", function() {
              session.post("Profiler.start", function() {
                activeSession = session;
                profilePath = path2;
                cb2();
              });
            });
            return true;
          }
          function cleanupPaths(profile) {
            var externalFileCounter = 0;
            var remappedPaths = new ts3.Map();
            var normalizedDir = ts3.normalizeSlashes(__dirname);
            var fileUrlRoot = "file://" + (ts3.getRootLength(normalizedDir) === 1 ? "" : "/") + normalizedDir;
            for (var _i = 0, _a3 = profile.nodes; _i < _a3.length; _i++) {
              var node = _a3[_i];
              if (node.callFrame.url) {
                var url = ts3.normalizeSlashes(node.callFrame.url);
                if (ts3.containsPath(fileUrlRoot, url, useCaseSensitiveFileNames)) {
                  node.callFrame.url = ts3.getRelativePathToDirectoryOrUrl(fileUrlRoot, url, fileUrlRoot, ts3.createGetCanonicalFileName(useCaseSensitiveFileNames), true);
                } else if (!nativePattern.test(url)) {
                  node.callFrame.url = (remappedPaths.has(url) ? remappedPaths : remappedPaths.set(url, "external" + externalFileCounter + ".js")).get(url);
                  externalFileCounter++;
                }
              }
            }
            return profile;
          }
          function disableCPUProfiler(cb2) {
            if (activeSession && activeSession !== "stopping") {
              var s_1 = activeSession;
              activeSession.post("Profiler.stop", function(err2, _a3) {
                var _b;
                var profile = _a3.profile;
                if (!err2) {
                  try {
                    if ((_b = statSync(profilePath)) === null || _b === void 0 ? void 0 : _b.isDirectory()) {
                      profilePath = _path.join(profilePath, new Date().toISOString().replace(/:/g, "-") + "+P" + process.pid + ".cpuprofile");
                    }
                  } catch (_c2) {
                  }
                  try {
                    _fs.mkdirSync(_path.dirname(profilePath), { recursive: true });
                  } catch (_d) {
                  }
                  _fs.writeFileSync(profilePath, JSON.stringify(cleanupPaths(profile)));
                }
                activeSession = void 0;
                s_1.disconnect();
                cb2();
              });
              activeSession = "stopping";
              return true;
            } else {
              cb2();
              return false;
            }
          }
          function bufferFrom(input, encoding) {
            return Buffer2.from && Buffer2.from !== Int8Array.from ? Buffer2.from(input, encoding) : new Buffer2(input, encoding);
          }
          function isFileSystemCaseSensitive() {
            if (platform === "win32" || platform === "win64") {
              return false;
            }
            return !fileExists(swapCase(__filename));
          }
          function swapCase(s2) {
            return s2.replace(/\w/g, function(ch) {
              var up = ch.toUpperCase();
              return ch === up ? ch.toLowerCase() : up;
            });
          }
          function fsWatchFileWorker(fileName, callback, pollingInterval) {
            _fs.watchFile(fileName, { persistent: true, interval: pollingInterval }, fileChanged);
            var eventKind;
            return {
              close: function() {
                return _fs.unwatchFile(fileName, fileChanged);
              }
            };
            function fileChanged(curr, prev) {
              var isPreviouslyDeleted = +prev.mtime === 0 || eventKind === FileWatcherEventKind.Deleted;
              if (+curr.mtime === 0) {
                if (isPreviouslyDeleted) {
                  return;
                }
                eventKind = FileWatcherEventKind.Deleted;
              } else if (isPreviouslyDeleted) {
                eventKind = FileWatcherEventKind.Created;
              } else if (+curr.mtime === +prev.mtime) {
                return;
              } else {
                eventKind = FileWatcherEventKind.Changed;
              }
              callback(fileName, eventKind);
            }
          }
          function fsWatch(fileOrDirectory, entryKind, callback, recursive, fallbackPollingInterval, fallbackOptions) {
            var options;
            var lastDirectoryPartWithDirectorySeparator;
            var lastDirectoryPart;
            if (isLinuxOrMacOs) {
              lastDirectoryPartWithDirectorySeparator = fileOrDirectory.substr(fileOrDirectory.lastIndexOf(ts3.directorySeparator));
              lastDirectoryPart = lastDirectoryPartWithDirectorySeparator.slice(ts3.directorySeparator.length);
            }
            var watcher = !fileSystemEntryExists(fileOrDirectory, entryKind) ? watchMissingFileSystemEntry() : watchPresentFileSystemEntry();
            return {
              close: function() {
                watcher.close();
                watcher = void 0;
              }
            };
            function invokeCallbackAndUpdateWatcher(createWatcher) {
              ts3.sysLog("sysLog:: " + fileOrDirectory + ":: Changing watcher to " + (createWatcher === watchPresentFileSystemEntry ? "Present" : "Missing") + "FileSystemEntryWatcher");
              callback("rename", "");
              if (watcher) {
                watcher.close();
                watcher = createWatcher();
              }
            }
            function watchPresentFileSystemEntry() {
              if (options === void 0) {
                if (fsSupportsRecursiveFsWatch) {
                  options = { persistent: true, recursive: !!recursive };
                } else {
                  options = { persistent: true };
                }
              }
              try {
                var presentWatcher = _fs.watch(fileOrDirectory, options, isLinuxOrMacOs ? callbackChangingToMissingFileSystemEntry : callback);
                presentWatcher.on("error", function() {
                  return invokeCallbackAndUpdateWatcher(watchMissingFileSystemEntry);
                });
                return presentWatcher;
              } catch (e2) {
                return watchPresentFileSystemEntryWithFsWatchFile();
              }
            }
            function callbackChangingToMissingFileSystemEntry(event2, relativeName) {
              return event2 === "rename" && (!relativeName || relativeName === lastDirectoryPart || relativeName.lastIndexOf(lastDirectoryPartWithDirectorySeparator) !== -1 && relativeName.lastIndexOf(lastDirectoryPartWithDirectorySeparator) === relativeName.length - lastDirectoryPartWithDirectorySeparator.length) && !fileSystemEntryExists(fileOrDirectory, entryKind) ? invokeCallbackAndUpdateWatcher(watchMissingFileSystemEntry) : callback(event2, relativeName);
            }
            function watchPresentFileSystemEntryWithFsWatchFile() {
              ts3.sysLog("sysLog:: " + fileOrDirectory + ":: Changing to fsWatchFile");
              return watchFile(fileOrDirectory, createFileWatcherCallback(callback), fallbackPollingInterval, fallbackOptions);
            }
            function watchMissingFileSystemEntry() {
              return watchFile(fileOrDirectory, function(_fileName, eventKind) {
                if (eventKind === FileWatcherEventKind.Created && fileSystemEntryExists(fileOrDirectory, entryKind)) {
                  invokeCallbackAndUpdateWatcher(watchPresentFileSystemEntry);
                }
              }, fallbackPollingInterval, fallbackOptions);
            }
          }
          function readFileWorker(fileName, _encoding) {
            var buffer2;
            try {
              buffer2 = _fs.readFileSync(fileName);
            } catch (e2) {
              return void 0;
            }
            var len = buffer2.length;
            if (len >= 2 && buffer2[0] === 254 && buffer2[1] === 255) {
              len &= ~1;
              for (var i3 = 0; i3 < len; i3 += 2) {
                var temp = buffer2[i3];
                buffer2[i3] = buffer2[i3 + 1];
                buffer2[i3 + 1] = temp;
              }
              return buffer2.toString("utf16le", 2);
            }
            if (len >= 2 && buffer2[0] === 255 && buffer2[1] === 254) {
              return buffer2.toString("utf16le", 2);
            }
            if (len >= 3 && buffer2[0] === 239 && buffer2[1] === 187 && buffer2[2] === 191) {
              return buffer2.toString("utf8", 3);
            }
            return buffer2.toString("utf8");
          }
          function readFile(fileName, _encoding) {
            ts3.perfLogger.logStartReadFile(fileName);
            var file = readFileWorker(fileName, _encoding);
            ts3.perfLogger.logStopReadFile();
            return file;
          }
          function writeFile(fileName, data, writeByteOrderMark) {
            ts3.perfLogger.logEvent("WriteFile: " + fileName);
            if (writeByteOrderMark) {
              data = byteOrderMarkIndicator + data;
            }
            var fd;
            try {
              fd = _fs.openSync(fileName, "w");
              _fs.writeSync(fd, data, void 0, "utf8");
            } finally {
              if (fd !== void 0) {
                _fs.closeSync(fd);
              }
            }
          }
          function getAccessibleFileSystemEntries(path2) {
            ts3.perfLogger.logEvent("ReadDir: " + (path2 || "."));
            try {
              var entries = _fs.readdirSync(path2 || ".", { withFileTypes: true });
              var files = [];
              var directories = [];
              for (var _i = 0, entries_1 = entries; _i < entries_1.length; _i++) {
                var dirent = entries_1[_i];
                var entry = typeof dirent === "string" ? dirent : dirent.name;
                if (entry === "." || entry === "..") {
                  continue;
                }
                var stat = void 0;
                if (typeof dirent === "string" || dirent.isSymbolicLink()) {
                  var name = ts3.combinePaths(path2, entry);
                  try {
                    stat = statSync(name);
                    if (!stat) {
                      continue;
                    }
                  } catch (e2) {
                    continue;
                  }
                } else {
                  stat = dirent;
                }
                if (stat.isFile()) {
                  files.push(entry);
                } else if (stat.isDirectory()) {
                  directories.push(entry);
                }
              }
              files.sort();
              directories.sort();
              return { files, directories };
            } catch (e2) {
              return ts3.emptyFileSystemEntries;
            }
          }
          function readDirectory(path2, extensions, excludes, includes, depth) {
            return ts3.matchFiles(path2, extensions, excludes, includes, useCaseSensitiveFileNames, process.cwd(), depth, getAccessibleFileSystemEntries, realpath);
          }
          function fileSystemEntryExists(path2, entryKind) {
            var originalStackTraceLimit = Error.stackTraceLimit;
            Error.stackTraceLimit = 0;
            try {
              var stat = statSync(path2);
              if (!stat) {
                return false;
              }
              switch (entryKind) {
                case 0:
                  return stat.isFile();
                case 1:
                  return stat.isDirectory();
                default:
                  return false;
              }
            } catch (e2) {
              return false;
            } finally {
              Error.stackTraceLimit = originalStackTraceLimit;
            }
          }
          function fileExists(path2) {
            return fileSystemEntryExists(path2, 0);
          }
          function directoryExists(path2) {
            return fileSystemEntryExists(path2, 1);
          }
          function getDirectories(path2) {
            return getAccessibleFileSystemEntries(path2).directories.slice();
          }
          function realpath(path2) {
            try {
              return realpathSync(path2);
            } catch (_a3) {
              return path2;
            }
          }
          function getModifiedTime2(path2) {
            var _a3;
            try {
              return (_a3 = statSync(path2)) === null || _a3 === void 0 ? void 0 : _a3.mtime;
            } catch (e2) {
              return void 0;
            }
          }
          function setModifiedTime(path2, time) {
            try {
              _fs.utimesSync(path2, time, time);
            } catch (e2) {
              return;
            }
          }
          function deleteFile(path2) {
            try {
              return _fs.unlinkSync(path2);
            } catch (e2) {
              return;
            }
          }
          function createSHA256Hash(data) {
            var hash = _crypto.createHash("sha256");
            hash.update(data);
            return hash.digest("hex");
          }
        }
        var sys;
        if (typeof process !== "undefined" && process.nextTick && !process.browser && typeof require !== "undefined") {
          sys = getNodeSystem();
        }
        if (sys) {
          patchWriteFileEnsuringDirectory(sys);
        }
        return sys;
      }();
      if (ts3.sys && ts3.sys.getEnvironmentVariable) {
        setCustomPollingValues(ts3.sys);
        ts3.Debug.setAssertionLevel(/^development$/i.test(ts3.sys.getEnvironmentVariable("NODE_ENV")) ? 1 : 0);
      }
      if (ts3.sys && ts3.sys.debugMode) {
        ts3.Debug.isDebugging = true;
      }
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      function diag(code, category, key2, message, reportsUnnecessary, elidedInCompatabilityPyramid, reportsDeprecated) {
        return { code, category, key: key2, message, reportsUnnecessary, elidedInCompatabilityPyramid, reportsDeprecated };
      }
      ts3.Diagnostics = {
        Unterminated_string_literal: diag(1002, ts3.DiagnosticCategory.Error, "Unterminated_string_literal_1002", "Unterminated string literal."),
        Identifier_expected: diag(1003, ts3.DiagnosticCategory.Error, "Identifier_expected_1003", "Identifier expected."),
        _0_expected: diag(1005, ts3.DiagnosticCategory.Error, "_0_expected_1005", "'{0}' expected."),
        A_file_cannot_have_a_reference_to_itself: diag(1006, ts3.DiagnosticCategory.Error, "A_file_cannot_have_a_reference_to_itself_1006", "A file cannot have a reference to itself."),
        The_parser_expected_to_find_a_to_match_the_token_here: diag(1007, ts3.DiagnosticCategory.Error, "The_parser_expected_to_find_a_to_match_the_token_here_1007", "The parser expected to find a '}' to match the '{' token here."),
        Trailing_comma_not_allowed: diag(1009, ts3.DiagnosticCategory.Error, "Trailing_comma_not_allowed_1009", "Trailing comma not allowed."),
        Asterisk_Slash_expected: diag(1010, ts3.DiagnosticCategory.Error, "Asterisk_Slash_expected_1010", "'*/' expected."),
        An_element_access_expression_should_take_an_argument: diag(1011, ts3.DiagnosticCategory.Error, "An_element_access_expression_should_take_an_argument_1011", "An element access expression should take an argument."),
        Unexpected_token: diag(1012, ts3.DiagnosticCategory.Error, "Unexpected_token_1012", "Unexpected token."),
        A_rest_parameter_or_binding_pattern_may_not_have_a_trailing_comma: diag(1013, ts3.DiagnosticCategory.Error, "A_rest_parameter_or_binding_pattern_may_not_have_a_trailing_comma_1013", "A rest parameter or binding pattern may not have a trailing comma."),
        A_rest_parameter_must_be_last_in_a_parameter_list: diag(1014, ts3.DiagnosticCategory.Error, "A_rest_parameter_must_be_last_in_a_parameter_list_1014", "A rest parameter must be last in a parameter list."),
        Parameter_cannot_have_question_mark_and_initializer: diag(1015, ts3.DiagnosticCategory.Error, "Parameter_cannot_have_question_mark_and_initializer_1015", "Parameter cannot have question mark and initializer."),
        A_required_parameter_cannot_follow_an_optional_parameter: diag(1016, ts3.DiagnosticCategory.Error, "A_required_parameter_cannot_follow_an_optional_parameter_1016", "A required parameter cannot follow an optional parameter."),
        An_index_signature_cannot_have_a_rest_parameter: diag(1017, ts3.DiagnosticCategory.Error, "An_index_signature_cannot_have_a_rest_parameter_1017", "An index signature cannot have a rest parameter."),
        An_index_signature_parameter_cannot_have_an_accessibility_modifier: diag(1018, ts3.DiagnosticCategory.Error, "An_index_signature_parameter_cannot_have_an_accessibility_modifier_1018", "An index signature parameter cannot have an accessibility modifier."),
        An_index_signature_parameter_cannot_have_a_question_mark: diag(1019, ts3.DiagnosticCategory.Error, "An_index_signature_parameter_cannot_have_a_question_mark_1019", "An index signature parameter cannot have a question mark."),
        An_index_signature_parameter_cannot_have_an_initializer: diag(1020, ts3.DiagnosticCategory.Error, "An_index_signature_parameter_cannot_have_an_initializer_1020", "An index signature parameter cannot have an initializer."),
        An_index_signature_must_have_a_type_annotation: diag(1021, ts3.DiagnosticCategory.Error, "An_index_signature_must_have_a_type_annotation_1021", "An index signature must have a type annotation."),
        An_index_signature_parameter_must_have_a_type_annotation: diag(1022, ts3.DiagnosticCategory.Error, "An_index_signature_parameter_must_have_a_type_annotation_1022", "An index signature parameter must have a type annotation."),
        An_index_signature_parameter_type_must_be_either_string_or_number: diag(1023, ts3.DiagnosticCategory.Error, "An_index_signature_parameter_type_must_be_either_string_or_number_1023", "An index signature parameter type must be either 'string' or 'number'."),
        readonly_modifier_can_only_appear_on_a_property_declaration_or_index_signature: diag(1024, ts3.DiagnosticCategory.Error, "readonly_modifier_can_only_appear_on_a_property_declaration_or_index_signature_1024", "'readonly' modifier can only appear on a property declaration or index signature."),
        An_index_signature_cannot_have_a_trailing_comma: diag(1025, ts3.DiagnosticCategory.Error, "An_index_signature_cannot_have_a_trailing_comma_1025", "An index signature cannot have a trailing comma."),
        Accessibility_modifier_already_seen: diag(1028, ts3.DiagnosticCategory.Error, "Accessibility_modifier_already_seen_1028", "Accessibility modifier already seen."),
        _0_modifier_must_precede_1_modifier: diag(1029, ts3.DiagnosticCategory.Error, "_0_modifier_must_precede_1_modifier_1029", "'{0}' modifier must precede '{1}' modifier."),
        _0_modifier_already_seen: diag(1030, ts3.DiagnosticCategory.Error, "_0_modifier_already_seen_1030", "'{0}' modifier already seen."),
        _0_modifier_cannot_appear_on_class_elements_of_this_kind: diag(1031, ts3.DiagnosticCategory.Error, "_0_modifier_cannot_appear_on_class_elements_of_this_kind_1031", "'{0}' modifier cannot appear on class elements of this kind."),
        super_must_be_followed_by_an_argument_list_or_member_access: diag(1034, ts3.DiagnosticCategory.Error, "super_must_be_followed_by_an_argument_list_or_member_access_1034", "'super' must be followed by an argument list or member access."),
        Only_ambient_modules_can_use_quoted_names: diag(1035, ts3.DiagnosticCategory.Error, "Only_ambient_modules_can_use_quoted_names_1035", "Only ambient modules can use quoted names."),
        Statements_are_not_allowed_in_ambient_contexts: diag(1036, ts3.DiagnosticCategory.Error, "Statements_are_not_allowed_in_ambient_contexts_1036", "Statements are not allowed in ambient contexts."),
        A_declare_modifier_cannot_be_used_in_an_already_ambient_context: diag(1038, ts3.DiagnosticCategory.Error, "A_declare_modifier_cannot_be_used_in_an_already_ambient_context_1038", "A 'declare' modifier cannot be used in an already ambient context."),
        Initializers_are_not_allowed_in_ambient_contexts: diag(1039, ts3.DiagnosticCategory.Error, "Initializers_are_not_allowed_in_ambient_contexts_1039", "Initializers are not allowed in ambient contexts."),
        _0_modifier_cannot_be_used_in_an_ambient_context: diag(1040, ts3.DiagnosticCategory.Error, "_0_modifier_cannot_be_used_in_an_ambient_context_1040", "'{0}' modifier cannot be used in an ambient context."),
        _0_modifier_cannot_be_used_with_a_class_declaration: diag(1041, ts3.DiagnosticCategory.Error, "_0_modifier_cannot_be_used_with_a_class_declaration_1041", "'{0}' modifier cannot be used with a class declaration."),
        _0_modifier_cannot_be_used_here: diag(1042, ts3.DiagnosticCategory.Error, "_0_modifier_cannot_be_used_here_1042", "'{0}' modifier cannot be used here."),
        _0_modifier_cannot_appear_on_a_data_property: diag(1043, ts3.DiagnosticCategory.Error, "_0_modifier_cannot_appear_on_a_data_property_1043", "'{0}' modifier cannot appear on a data property."),
        _0_modifier_cannot_appear_on_a_module_or_namespace_element: diag(1044, ts3.DiagnosticCategory.Error, "_0_modifier_cannot_appear_on_a_module_or_namespace_element_1044", "'{0}' modifier cannot appear on a module or namespace element."),
        A_0_modifier_cannot_be_used_with_an_interface_declaration: diag(1045, ts3.DiagnosticCategory.Error, "A_0_modifier_cannot_be_used_with_an_interface_declaration_1045", "A '{0}' modifier cannot be used with an interface declaration."),
        Top_level_declarations_in_d_ts_files_must_start_with_either_a_declare_or_export_modifier: diag(1046, ts3.DiagnosticCategory.Error, "Top_level_declarations_in_d_ts_files_must_start_with_either_a_declare_or_export_modifier_1046", "Top-level declarations in .d.ts files must start with either a 'declare' or 'export' modifier."),
        A_rest_parameter_cannot_be_optional: diag(1047, ts3.DiagnosticCategory.Error, "A_rest_parameter_cannot_be_optional_1047", "A rest parameter cannot be optional."),
        A_rest_parameter_cannot_have_an_initializer: diag(1048, ts3.DiagnosticCategory.Error, "A_rest_parameter_cannot_have_an_initializer_1048", "A rest parameter cannot have an initializer."),
        A_set_accessor_must_have_exactly_one_parameter: diag(1049, ts3.DiagnosticCategory.Error, "A_set_accessor_must_have_exactly_one_parameter_1049", "A 'set' accessor must have exactly one parameter."),
        A_set_accessor_cannot_have_an_optional_parameter: diag(1051, ts3.DiagnosticCategory.Error, "A_set_accessor_cannot_have_an_optional_parameter_1051", "A 'set' accessor cannot have an optional parameter."),
        A_set_accessor_parameter_cannot_have_an_initializer: diag(1052, ts3.DiagnosticCategory.Error, "A_set_accessor_parameter_cannot_have_an_initializer_1052", "A 'set' accessor parameter cannot have an initializer."),
        A_set_accessor_cannot_have_rest_parameter: diag(1053, ts3.DiagnosticCategory.Error, "A_set_accessor_cannot_have_rest_parameter_1053", "A 'set' accessor cannot have rest parameter."),
        A_get_accessor_cannot_have_parameters: diag(1054, ts3.DiagnosticCategory.Error, "A_get_accessor_cannot_have_parameters_1054", "A 'get' accessor cannot have parameters."),
        Type_0_is_not_a_valid_async_function_return_type_in_ES5_SlashES3_because_it_does_not_refer_to_a_Promise_compatible_constructor_value: diag(1055, ts3.DiagnosticCategory.Error, "Type_0_is_not_a_valid_async_function_return_type_in_ES5_SlashES3_because_it_does_not_refer_to_a_Prom_1055", "Type '{0}' is not a valid async function return type in ES5/ES3 because it does not refer to a Promise-compatible constructor value."),
        Accessors_are_only_available_when_targeting_ECMAScript_5_and_higher: diag(1056, ts3.DiagnosticCategory.Error, "Accessors_are_only_available_when_targeting_ECMAScript_5_and_higher_1056", "Accessors are only available when targeting ECMAScript 5 and higher."),
        An_async_function_or_method_must_have_a_valid_awaitable_return_type: diag(1057, ts3.DiagnosticCategory.Error, "An_async_function_or_method_must_have_a_valid_awaitable_return_type_1057", "An async function or method must have a valid awaitable return type."),
        The_return_type_of_an_async_function_must_either_be_a_valid_promise_or_must_not_contain_a_callable_then_member: diag(1058, ts3.DiagnosticCategory.Error, "The_return_type_of_an_async_function_must_either_be_a_valid_promise_or_must_not_contain_a_callable_t_1058", "The return type of an async function must either be a valid promise or must not contain a callable 'then' member."),
        A_promise_must_have_a_then_method: diag(1059, ts3.DiagnosticCategory.Error, "A_promise_must_have_a_then_method_1059", "A promise must have a 'then' method."),
        The_first_parameter_of_the_then_method_of_a_promise_must_be_a_callback: diag(1060, ts3.DiagnosticCategory.Error, "The_first_parameter_of_the_then_method_of_a_promise_must_be_a_callback_1060", "The first parameter of the 'then' method of a promise must be a callback."),
        Enum_member_must_have_initializer: diag(1061, ts3.DiagnosticCategory.Error, "Enum_member_must_have_initializer_1061", "Enum member must have initializer."),
        Type_is_referenced_directly_or_indirectly_in_the_fulfillment_callback_of_its_own_then_method: diag(1062, ts3.DiagnosticCategory.Error, "Type_is_referenced_directly_or_indirectly_in_the_fulfillment_callback_of_its_own_then_method_1062", "Type is referenced directly or indirectly in the fulfillment callback of its own 'then' method."),
        An_export_assignment_cannot_be_used_in_a_namespace: diag(1063, ts3.DiagnosticCategory.Error, "An_export_assignment_cannot_be_used_in_a_namespace_1063", "An export assignment cannot be used in a namespace."),
        The_return_type_of_an_async_function_or_method_must_be_the_global_Promise_T_type_Did_you_mean_to_write_Promise_0: diag(1064, ts3.DiagnosticCategory.Error, "The_return_type_of_an_async_function_or_method_must_be_the_global_Promise_T_type_Did_you_mean_to_wri_1064", "The return type of an async function or method must be the global Promise<T> type. Did you mean to write 'Promise<{0}>'?"),
        In_ambient_enum_declarations_member_initializer_must_be_constant_expression: diag(1066, ts3.DiagnosticCategory.Error, "In_ambient_enum_declarations_member_initializer_must_be_constant_expression_1066", "In ambient enum declarations member initializer must be constant expression."),
        Unexpected_token_A_constructor_method_accessor_or_property_was_expected: diag(1068, ts3.DiagnosticCategory.Error, "Unexpected_token_A_constructor_method_accessor_or_property_was_expected_1068", "Unexpected token. A constructor, method, accessor, or property was expected."),
        Unexpected_token_A_type_parameter_name_was_expected_without_curly_braces: diag(1069, ts3.DiagnosticCategory.Error, "Unexpected_token_A_type_parameter_name_was_expected_without_curly_braces_1069", "Unexpected token. A type parameter name was expected without curly braces."),
        _0_modifier_cannot_appear_on_a_type_member: diag(1070, ts3.DiagnosticCategory.Error, "_0_modifier_cannot_appear_on_a_type_member_1070", "'{0}' modifier cannot appear on a type member."),
        _0_modifier_cannot_appear_on_an_index_signature: diag(1071, ts3.DiagnosticCategory.Error, "_0_modifier_cannot_appear_on_an_index_signature_1071", "'{0}' modifier cannot appear on an index signature."),
        A_0_modifier_cannot_be_used_with_an_import_declaration: diag(1079, ts3.DiagnosticCategory.Error, "A_0_modifier_cannot_be_used_with_an_import_declaration_1079", "A '{0}' modifier cannot be used with an import declaration."),
        Invalid_reference_directive_syntax: diag(1084, ts3.DiagnosticCategory.Error, "Invalid_reference_directive_syntax_1084", "Invalid 'reference' directive syntax."),
        Octal_literals_are_not_available_when_targeting_ECMAScript_5_and_higher_Use_the_syntax_0: diag(1085, ts3.DiagnosticCategory.Error, "Octal_literals_are_not_available_when_targeting_ECMAScript_5_and_higher_Use_the_syntax_0_1085", "Octal literals are not available when targeting ECMAScript 5 and higher. Use the syntax '{0}'."),
        _0_modifier_cannot_appear_on_a_constructor_declaration: diag(1089, ts3.DiagnosticCategory.Error, "_0_modifier_cannot_appear_on_a_constructor_declaration_1089", "'{0}' modifier cannot appear on a constructor declaration."),
        _0_modifier_cannot_appear_on_a_parameter: diag(1090, ts3.DiagnosticCategory.Error, "_0_modifier_cannot_appear_on_a_parameter_1090", "'{0}' modifier cannot appear on a parameter."),
        Only_a_single_variable_declaration_is_allowed_in_a_for_in_statement: diag(1091, ts3.DiagnosticCategory.Error, "Only_a_single_variable_declaration_is_allowed_in_a_for_in_statement_1091", "Only a single variable declaration is allowed in a 'for...in' statement."),
        Type_parameters_cannot_appear_on_a_constructor_declaration: diag(1092, ts3.DiagnosticCategory.Error, "Type_parameters_cannot_appear_on_a_constructor_declaration_1092", "Type parameters cannot appear on a constructor declaration."),
        Type_annotation_cannot_appear_on_a_constructor_declaration: diag(1093, ts3.DiagnosticCategory.Error, "Type_annotation_cannot_appear_on_a_constructor_declaration_1093", "Type annotation cannot appear on a constructor declaration."),
        An_accessor_cannot_have_type_parameters: diag(1094, ts3.DiagnosticCategory.Error, "An_accessor_cannot_have_type_parameters_1094", "An accessor cannot have type parameters."),
        A_set_accessor_cannot_have_a_return_type_annotation: diag(1095, ts3.DiagnosticCategory.Error, "A_set_accessor_cannot_have_a_return_type_annotation_1095", "A 'set' accessor cannot have a return type annotation."),
        An_index_signature_must_have_exactly_one_parameter: diag(1096, ts3.DiagnosticCategory.Error, "An_index_signature_must_have_exactly_one_parameter_1096", "An index signature must have exactly one parameter."),
        _0_list_cannot_be_empty: diag(1097, ts3.DiagnosticCategory.Error, "_0_list_cannot_be_empty_1097", "'{0}' list cannot be empty."),
        Type_parameter_list_cannot_be_empty: diag(1098, ts3.DiagnosticCategory.Error, "Type_parameter_list_cannot_be_empty_1098", "Type parameter list cannot be empty."),
        Type_argument_list_cannot_be_empty: diag(1099, ts3.DiagnosticCategory.Error, "Type_argument_list_cannot_be_empty_1099", "Type argument list cannot be empty."),
        Invalid_use_of_0_in_strict_mode: diag(1100, ts3.DiagnosticCategory.Error, "Invalid_use_of_0_in_strict_mode_1100", "Invalid use of '{0}' in strict mode."),
        with_statements_are_not_allowed_in_strict_mode: diag(1101, ts3.DiagnosticCategory.Error, "with_statements_are_not_allowed_in_strict_mode_1101", "'with' statements are not allowed in strict mode."),
        delete_cannot_be_called_on_an_identifier_in_strict_mode: diag(1102, ts3.DiagnosticCategory.Error, "delete_cannot_be_called_on_an_identifier_in_strict_mode_1102", "'delete' cannot be called on an identifier in strict mode."),
        for_await_loops_are_only_allowed_within_async_functions_and_at_the_top_levels_of_modules: diag(1103, ts3.DiagnosticCategory.Error, "for_await_loops_are_only_allowed_within_async_functions_and_at_the_top_levels_of_modules_1103", "'for await' loops are only allowed within async functions and at the top levels of modules."),
        A_continue_statement_can_only_be_used_within_an_enclosing_iteration_statement: diag(1104, ts3.DiagnosticCategory.Error, "A_continue_statement_can_only_be_used_within_an_enclosing_iteration_statement_1104", "A 'continue' statement can only be used within an enclosing iteration statement."),
        A_break_statement_can_only_be_used_within_an_enclosing_iteration_or_switch_statement: diag(1105, ts3.DiagnosticCategory.Error, "A_break_statement_can_only_be_used_within_an_enclosing_iteration_or_switch_statement_1105", "A 'break' statement can only be used within an enclosing iteration or switch statement."),
        Jump_target_cannot_cross_function_boundary: diag(1107, ts3.DiagnosticCategory.Error, "Jump_target_cannot_cross_function_boundary_1107", "Jump target cannot cross function boundary."),
        A_return_statement_can_only_be_used_within_a_function_body: diag(1108, ts3.DiagnosticCategory.Error, "A_return_statement_can_only_be_used_within_a_function_body_1108", "A 'return' statement can only be used within a function body."),
        Expression_expected: diag(1109, ts3.DiagnosticCategory.Error, "Expression_expected_1109", "Expression expected."),
        Type_expected: diag(1110, ts3.DiagnosticCategory.Error, "Type_expected_1110", "Type expected."),
        A_default_clause_cannot_appear_more_than_once_in_a_switch_statement: diag(1113, ts3.DiagnosticCategory.Error, "A_default_clause_cannot_appear_more_than_once_in_a_switch_statement_1113", "A 'default' clause cannot appear more than once in a 'switch' statement."),
        Duplicate_label_0: diag(1114, ts3.DiagnosticCategory.Error, "Duplicate_label_0_1114", "Duplicate label '{0}'."),
        A_continue_statement_can_only_jump_to_a_label_of_an_enclosing_iteration_statement: diag(1115, ts3.DiagnosticCategory.Error, "A_continue_statement_can_only_jump_to_a_label_of_an_enclosing_iteration_statement_1115", "A 'continue' statement can only jump to a label of an enclosing iteration statement."),
        A_break_statement_can_only_jump_to_a_label_of_an_enclosing_statement: diag(1116, ts3.DiagnosticCategory.Error, "A_break_statement_can_only_jump_to_a_label_of_an_enclosing_statement_1116", "A 'break' statement can only jump to a label of an enclosing statement."),
        An_object_literal_cannot_have_multiple_properties_with_the_same_name_in_strict_mode: diag(1117, ts3.DiagnosticCategory.Error, "An_object_literal_cannot_have_multiple_properties_with_the_same_name_in_strict_mode_1117", "An object literal cannot have multiple properties with the same name in strict mode."),
        An_object_literal_cannot_have_multiple_get_Slashset_accessors_with_the_same_name: diag(1118, ts3.DiagnosticCategory.Error, "An_object_literal_cannot_have_multiple_get_Slashset_accessors_with_the_same_name_1118", "An object literal cannot have multiple get/set accessors with the same name."),
        An_object_literal_cannot_have_property_and_accessor_with_the_same_name: diag(1119, ts3.DiagnosticCategory.Error, "An_object_literal_cannot_have_property_and_accessor_with_the_same_name_1119", "An object literal cannot have property and accessor with the same name."),
        An_export_assignment_cannot_have_modifiers: diag(1120, ts3.DiagnosticCategory.Error, "An_export_assignment_cannot_have_modifiers_1120", "An export assignment cannot have modifiers."),
        Octal_literals_are_not_allowed_in_strict_mode: diag(1121, ts3.DiagnosticCategory.Error, "Octal_literals_are_not_allowed_in_strict_mode_1121", "Octal literals are not allowed in strict mode."),
        Variable_declaration_list_cannot_be_empty: diag(1123, ts3.DiagnosticCategory.Error, "Variable_declaration_list_cannot_be_empty_1123", "Variable declaration list cannot be empty."),
        Digit_expected: diag(1124, ts3.DiagnosticCategory.Error, "Digit_expected_1124", "Digit expected."),
        Hexadecimal_digit_expected: diag(1125, ts3.DiagnosticCategory.Error, "Hexadecimal_digit_expected_1125", "Hexadecimal digit expected."),
        Unexpected_end_of_text: diag(1126, ts3.DiagnosticCategory.Error, "Unexpected_end_of_text_1126", "Unexpected end of text."),
        Invalid_character: diag(1127, ts3.DiagnosticCategory.Error, "Invalid_character_1127", "Invalid character."),
        Declaration_or_statement_expected: diag(1128, ts3.DiagnosticCategory.Error, "Declaration_or_statement_expected_1128", "Declaration or statement expected."),
        Statement_expected: diag(1129, ts3.DiagnosticCategory.Error, "Statement_expected_1129", "Statement expected."),
        case_or_default_expected: diag(1130, ts3.DiagnosticCategory.Error, "case_or_default_expected_1130", "'case' or 'default' expected."),
        Property_or_signature_expected: diag(1131, ts3.DiagnosticCategory.Error, "Property_or_signature_expected_1131", "Property or signature expected."),
        Enum_member_expected: diag(1132, ts3.DiagnosticCategory.Error, "Enum_member_expected_1132", "Enum member expected."),
        Variable_declaration_expected: diag(1134, ts3.DiagnosticCategory.Error, "Variable_declaration_expected_1134", "Variable declaration expected."),
        Argument_expression_expected: diag(1135, ts3.DiagnosticCategory.Error, "Argument_expression_expected_1135", "Argument expression expected."),
        Property_assignment_expected: diag(1136, ts3.DiagnosticCategory.Error, "Property_assignment_expected_1136", "Property assignment expected."),
        Expression_or_comma_expected: diag(1137, ts3.DiagnosticCategory.Error, "Expression_or_comma_expected_1137", "Expression or comma expected."),
        Parameter_declaration_expected: diag(1138, ts3.DiagnosticCategory.Error, "Parameter_declaration_expected_1138", "Parameter declaration expected."),
        Type_parameter_declaration_expected: diag(1139, ts3.DiagnosticCategory.Error, "Type_parameter_declaration_expected_1139", "Type parameter declaration expected."),
        Type_argument_expected: diag(1140, ts3.DiagnosticCategory.Error, "Type_argument_expected_1140", "Type argument expected."),
        String_literal_expected: diag(1141, ts3.DiagnosticCategory.Error, "String_literal_expected_1141", "String literal expected."),
        Line_break_not_permitted_here: diag(1142, ts3.DiagnosticCategory.Error, "Line_break_not_permitted_here_1142", "Line break not permitted here."),
        or_expected: diag(1144, ts3.DiagnosticCategory.Error, "or_expected_1144", "'{' or ';' expected."),
        Declaration_expected: diag(1146, ts3.DiagnosticCategory.Error, "Declaration_expected_1146", "Declaration expected."),
        Import_declarations_in_a_namespace_cannot_reference_a_module: diag(1147, ts3.DiagnosticCategory.Error, "Import_declarations_in_a_namespace_cannot_reference_a_module_1147", "Import declarations in a namespace cannot reference a module."),
        Cannot_use_imports_exports_or_module_augmentations_when_module_is_none: diag(1148, ts3.DiagnosticCategory.Error, "Cannot_use_imports_exports_or_module_augmentations_when_module_is_none_1148", "Cannot use imports, exports, or module augmentations when '--module' is 'none'."),
        File_name_0_differs_from_already_included_file_name_1_only_in_casing: diag(1149, ts3.DiagnosticCategory.Error, "File_name_0_differs_from_already_included_file_name_1_only_in_casing_1149", "File name '{0}' differs from already included file name '{1}' only in casing."),
        const_declarations_must_be_initialized: diag(1155, ts3.DiagnosticCategory.Error, "const_declarations_must_be_initialized_1155", "'const' declarations must be initialized."),
        const_declarations_can_only_be_declared_inside_a_block: diag(1156, ts3.DiagnosticCategory.Error, "const_declarations_can_only_be_declared_inside_a_block_1156", "'const' declarations can only be declared inside a block."),
        let_declarations_can_only_be_declared_inside_a_block: diag(1157, ts3.DiagnosticCategory.Error, "let_declarations_can_only_be_declared_inside_a_block_1157", "'let' declarations can only be declared inside a block."),
        Unterminated_template_literal: diag(1160, ts3.DiagnosticCategory.Error, "Unterminated_template_literal_1160", "Unterminated template literal."),
        Unterminated_regular_expression_literal: diag(1161, ts3.DiagnosticCategory.Error, "Unterminated_regular_expression_literal_1161", "Unterminated regular expression literal."),
        An_object_member_cannot_be_declared_optional: diag(1162, ts3.DiagnosticCategory.Error, "An_object_member_cannot_be_declared_optional_1162", "An object member cannot be declared optional."),
        A_yield_expression_is_only_allowed_in_a_generator_body: diag(1163, ts3.DiagnosticCategory.Error, "A_yield_expression_is_only_allowed_in_a_generator_body_1163", "A 'yield' expression is only allowed in a generator body."),
        Computed_property_names_are_not_allowed_in_enums: diag(1164, ts3.DiagnosticCategory.Error, "Computed_property_names_are_not_allowed_in_enums_1164", "Computed property names are not allowed in enums."),
        A_computed_property_name_in_an_ambient_context_must_refer_to_an_expression_whose_type_is_a_literal_type_or_a_unique_symbol_type: diag(1165, ts3.DiagnosticCategory.Error, "A_computed_property_name_in_an_ambient_context_must_refer_to_an_expression_whose_type_is_a_literal_t_1165", "A computed property name in an ambient context must refer to an expression whose type is a literal type or a 'unique symbol' type."),
        A_computed_property_name_in_a_class_property_declaration_must_have_a_simple_literal_type_or_a_unique_symbol_type: diag(1166, ts3.DiagnosticCategory.Error, "A_computed_property_name_in_a_class_property_declaration_must_have_a_simple_literal_type_or_a_unique_1166", "A computed property name in a class property declaration must have a simple literal type or a 'unique symbol' type."),
        A_computed_property_name_in_a_method_overload_must_refer_to_an_expression_whose_type_is_a_literal_type_or_a_unique_symbol_type: diag(1168, ts3.DiagnosticCategory.Error, "A_computed_property_name_in_a_method_overload_must_refer_to_an_expression_whose_type_is_a_literal_ty_1168", "A computed property name in a method overload must refer to an expression whose type is a literal type or a 'unique symbol' type."),
        A_computed_property_name_in_an_interface_must_refer_to_an_expression_whose_type_is_a_literal_type_or_a_unique_symbol_type: diag(1169, ts3.DiagnosticCategory.Error, "A_computed_property_name_in_an_interface_must_refer_to_an_expression_whose_type_is_a_literal_type_or_1169", "A computed property name in an interface must refer to an expression whose type is a literal type or a 'unique symbol' type."),
        A_computed_property_name_in_a_type_literal_must_refer_to_an_expression_whose_type_is_a_literal_type_or_a_unique_symbol_type: diag(1170, ts3.DiagnosticCategory.Error, "A_computed_property_name_in_a_type_literal_must_refer_to_an_expression_whose_type_is_a_literal_type__1170", "A computed property name in a type literal must refer to an expression whose type is a literal type or a 'unique symbol' type."),
        A_comma_expression_is_not_allowed_in_a_computed_property_name: diag(1171, ts3.DiagnosticCategory.Error, "A_comma_expression_is_not_allowed_in_a_computed_property_name_1171", "A comma expression is not allowed in a computed property name."),
        extends_clause_already_seen: diag(1172, ts3.DiagnosticCategory.Error, "extends_clause_already_seen_1172", "'extends' clause already seen."),
        extends_clause_must_precede_implements_clause: diag(1173, ts3.DiagnosticCategory.Error, "extends_clause_must_precede_implements_clause_1173", "'extends' clause must precede 'implements' clause."),
        Classes_can_only_extend_a_single_class: diag(1174, ts3.DiagnosticCategory.Error, "Classes_can_only_extend_a_single_class_1174", "Classes can only extend a single class."),
        implements_clause_already_seen: diag(1175, ts3.DiagnosticCategory.Error, "implements_clause_already_seen_1175", "'implements' clause already seen."),
        Interface_declaration_cannot_have_implements_clause: diag(1176, ts3.DiagnosticCategory.Error, "Interface_declaration_cannot_have_implements_clause_1176", "Interface declaration cannot have 'implements' clause."),
        Binary_digit_expected: diag(1177, ts3.DiagnosticCategory.Error, "Binary_digit_expected_1177", "Binary digit expected."),
        Octal_digit_expected: diag(1178, ts3.DiagnosticCategory.Error, "Octal_digit_expected_1178", "Octal digit expected."),
        Unexpected_token_expected: diag(1179, ts3.DiagnosticCategory.Error, "Unexpected_token_expected_1179", "Unexpected token. '{' expected."),
        Property_destructuring_pattern_expected: diag(1180, ts3.DiagnosticCategory.Error, "Property_destructuring_pattern_expected_1180", "Property destructuring pattern expected."),
        Array_element_destructuring_pattern_expected: diag(1181, ts3.DiagnosticCategory.Error, "Array_element_destructuring_pattern_expected_1181", "Array element destructuring pattern expected."),
        A_destructuring_declaration_must_have_an_initializer: diag(1182, ts3.DiagnosticCategory.Error, "A_destructuring_declaration_must_have_an_initializer_1182", "A destructuring declaration must have an initializer."),
        An_implementation_cannot_be_declared_in_ambient_contexts: diag(1183, ts3.DiagnosticCategory.Error, "An_implementation_cannot_be_declared_in_ambient_contexts_1183", "An implementation cannot be declared in ambient contexts."),
        Modifiers_cannot_appear_here: diag(1184, ts3.DiagnosticCategory.Error, "Modifiers_cannot_appear_here_1184", "Modifiers cannot appear here."),
        Merge_conflict_marker_encountered: diag(1185, ts3.DiagnosticCategory.Error, "Merge_conflict_marker_encountered_1185", "Merge conflict marker encountered."),
        A_rest_element_cannot_have_an_initializer: diag(1186, ts3.DiagnosticCategory.Error, "A_rest_element_cannot_have_an_initializer_1186", "A rest element cannot have an initializer."),
        A_parameter_property_may_not_be_declared_using_a_binding_pattern: diag(1187, ts3.DiagnosticCategory.Error, "A_parameter_property_may_not_be_declared_using_a_binding_pattern_1187", "A parameter property may not be declared using a binding pattern."),
        Only_a_single_variable_declaration_is_allowed_in_a_for_of_statement: diag(1188, ts3.DiagnosticCategory.Error, "Only_a_single_variable_declaration_is_allowed_in_a_for_of_statement_1188", "Only a single variable declaration is allowed in a 'for...of' statement."),
        The_variable_declaration_of_a_for_in_statement_cannot_have_an_initializer: diag(1189, ts3.DiagnosticCategory.Error, "The_variable_declaration_of_a_for_in_statement_cannot_have_an_initializer_1189", "The variable declaration of a 'for...in' statement cannot have an initializer."),
        The_variable_declaration_of_a_for_of_statement_cannot_have_an_initializer: diag(1190, ts3.DiagnosticCategory.Error, "The_variable_declaration_of_a_for_of_statement_cannot_have_an_initializer_1190", "The variable declaration of a 'for...of' statement cannot have an initializer."),
        An_import_declaration_cannot_have_modifiers: diag(1191, ts3.DiagnosticCategory.Error, "An_import_declaration_cannot_have_modifiers_1191", "An import declaration cannot have modifiers."),
        Module_0_has_no_default_export: diag(1192, ts3.DiagnosticCategory.Error, "Module_0_has_no_default_export_1192", "Module '{0}' has no default export."),
        An_export_declaration_cannot_have_modifiers: diag(1193, ts3.DiagnosticCategory.Error, "An_export_declaration_cannot_have_modifiers_1193", "An export declaration cannot have modifiers."),
        Export_declarations_are_not_permitted_in_a_namespace: diag(1194, ts3.DiagnosticCategory.Error, "Export_declarations_are_not_permitted_in_a_namespace_1194", "Export declarations are not permitted in a namespace."),
        export_Asterisk_does_not_re_export_a_default: diag(1195, ts3.DiagnosticCategory.Error, "export_Asterisk_does_not_re_export_a_default_1195", "'export *' does not re-export a default."),
        Catch_clause_variable_type_annotation_must_be_any_or_unknown_if_specified: diag(1196, ts3.DiagnosticCategory.Error, "Catch_clause_variable_type_annotation_must_be_any_or_unknown_if_specified_1196", "Catch clause variable type annotation must be 'any' or 'unknown' if specified."),
        Catch_clause_variable_cannot_have_an_initializer: diag(1197, ts3.DiagnosticCategory.Error, "Catch_clause_variable_cannot_have_an_initializer_1197", "Catch clause variable cannot have an initializer."),
        An_extended_Unicode_escape_value_must_be_between_0x0_and_0x10FFFF_inclusive: diag(1198, ts3.DiagnosticCategory.Error, "An_extended_Unicode_escape_value_must_be_between_0x0_and_0x10FFFF_inclusive_1198", "An extended Unicode escape value must be between 0x0 and 0x10FFFF inclusive."),
        Unterminated_Unicode_escape_sequence: diag(1199, ts3.DiagnosticCategory.Error, "Unterminated_Unicode_escape_sequence_1199", "Unterminated Unicode escape sequence."),
        Line_terminator_not_permitted_before_arrow: diag(1200, ts3.DiagnosticCategory.Error, "Line_terminator_not_permitted_before_arrow_1200", "Line terminator not permitted before arrow."),
        Import_assignment_cannot_be_used_when_targeting_ECMAScript_modules_Consider_using_import_Asterisk_as_ns_from_mod_import_a_from_mod_import_d_from_mod_or_another_module_format_instead: diag(1202, ts3.DiagnosticCategory.Error, "Import_assignment_cannot_be_used_when_targeting_ECMAScript_modules_Consider_using_import_Asterisk_as_1202", `Import assignment cannot be used when targeting ECMAScript modules. Consider using 'import * as ns from "mod"', 'import {a} from "mod"', 'import d from "mod"', or another module format instead.`),
        Export_assignment_cannot_be_used_when_targeting_ECMAScript_modules_Consider_using_export_default_or_another_module_format_instead: diag(1203, ts3.DiagnosticCategory.Error, "Export_assignment_cannot_be_used_when_targeting_ECMAScript_modules_Consider_using_export_default_or__1203", "Export assignment cannot be used when targeting ECMAScript modules. Consider using 'export default' or another module format instead."),
        Re_exporting_a_type_when_the_isolatedModules_flag_is_provided_requires_using_export_type: diag(1205, ts3.DiagnosticCategory.Error, "Re_exporting_a_type_when_the_isolatedModules_flag_is_provided_requires_using_export_type_1205", "Re-exporting a type when the '--isolatedModules' flag is provided requires using 'export type'."),
        Decorators_are_not_valid_here: diag(1206, ts3.DiagnosticCategory.Error, "Decorators_are_not_valid_here_1206", "Decorators are not valid here."),
        Decorators_cannot_be_applied_to_multiple_get_Slashset_accessors_of_the_same_name: diag(1207, ts3.DiagnosticCategory.Error, "Decorators_cannot_be_applied_to_multiple_get_Slashset_accessors_of_the_same_name_1207", "Decorators cannot be applied to multiple get/set accessors of the same name."),
        _0_cannot_be_compiled_under_isolatedModules_because_it_is_considered_a_global_script_file_Add_an_import_export_or_an_empty_export_statement_to_make_it_a_module: diag(1208, ts3.DiagnosticCategory.Error, "_0_cannot_be_compiled_under_isolatedModules_because_it_is_considered_a_global_script_file_Add_an_imp_1208", "'{0}' cannot be compiled under '--isolatedModules' because it is considered a global script file. Add an import, export, or an empty 'export {}' statement to make it a module."),
        Invalid_use_of_0_Class_definitions_are_automatically_in_strict_mode: diag(1210, ts3.DiagnosticCategory.Error, "Invalid_use_of_0_Class_definitions_are_automatically_in_strict_mode_1210", "Invalid use of '{0}'. Class definitions are automatically in strict mode."),
        A_class_declaration_without_the_default_modifier_must_have_a_name: diag(1211, ts3.DiagnosticCategory.Error, "A_class_declaration_without_the_default_modifier_must_have_a_name_1211", "A class declaration without the 'default' modifier must have a name."),
        Identifier_expected_0_is_a_reserved_word_in_strict_mode: diag(1212, ts3.DiagnosticCategory.Error, "Identifier_expected_0_is_a_reserved_word_in_strict_mode_1212", "Identifier expected. '{0}' is a reserved word in strict mode."),
        Identifier_expected_0_is_a_reserved_word_in_strict_mode_Class_definitions_are_automatically_in_strict_mode: diag(1213, ts3.DiagnosticCategory.Error, "Identifier_expected_0_is_a_reserved_word_in_strict_mode_Class_definitions_are_automatically_in_stric_1213", "Identifier expected. '{0}' is a reserved word in strict mode. Class definitions are automatically in strict mode."),
        Identifier_expected_0_is_a_reserved_word_in_strict_mode_Modules_are_automatically_in_strict_mode: diag(1214, ts3.DiagnosticCategory.Error, "Identifier_expected_0_is_a_reserved_word_in_strict_mode_Modules_are_automatically_in_strict_mode_1214", "Identifier expected. '{0}' is a reserved word in strict mode. Modules are automatically in strict mode."),
        Invalid_use_of_0_Modules_are_automatically_in_strict_mode: diag(1215, ts3.DiagnosticCategory.Error, "Invalid_use_of_0_Modules_are_automatically_in_strict_mode_1215", "Invalid use of '{0}'. Modules are automatically in strict mode."),
        Identifier_expected_esModule_is_reserved_as_an_exported_marker_when_transforming_ECMAScript_modules: diag(1216, ts3.DiagnosticCategory.Error, "Identifier_expected_esModule_is_reserved_as_an_exported_marker_when_transforming_ECMAScript_modules_1216", "Identifier expected. '__esModule' is reserved as an exported marker when transforming ECMAScript modules."),
        Export_assignment_is_not_supported_when_module_flag_is_system: diag(1218, ts3.DiagnosticCategory.Error, "Export_assignment_is_not_supported_when_module_flag_is_system_1218", "Export assignment is not supported when '--module' flag is 'system'."),
        Experimental_support_for_decorators_is_a_feature_that_is_subject_to_change_in_a_future_release_Set_the_experimentalDecorators_option_in_your_tsconfig_or_jsconfig_to_remove_this_warning: diag(1219, ts3.DiagnosticCategory.Error, "Experimental_support_for_decorators_is_a_feature_that_is_subject_to_change_in_a_future_release_Set_t_1219", "Experimental support for decorators is a feature that is subject to change in a future release. Set the 'experimentalDecorators' option in your 'tsconfig' or 'jsconfig' to remove this warning."),
        Generators_are_only_available_when_targeting_ECMAScript_2015_or_higher: diag(1220, ts3.DiagnosticCategory.Error, "Generators_are_only_available_when_targeting_ECMAScript_2015_or_higher_1220", "Generators are only available when targeting ECMAScript 2015 or higher."),
        Generators_are_not_allowed_in_an_ambient_context: diag(1221, ts3.DiagnosticCategory.Error, "Generators_are_not_allowed_in_an_ambient_context_1221", "Generators are not allowed in an ambient context."),
        An_overload_signature_cannot_be_declared_as_a_generator: diag(1222, ts3.DiagnosticCategory.Error, "An_overload_signature_cannot_be_declared_as_a_generator_1222", "An overload signature cannot be declared as a generator."),
        _0_tag_already_specified: diag(1223, ts3.DiagnosticCategory.Error, "_0_tag_already_specified_1223", "'{0}' tag already specified."),
        Signature_0_must_be_a_type_predicate: diag(1224, ts3.DiagnosticCategory.Error, "Signature_0_must_be_a_type_predicate_1224", "Signature '{0}' must be a type predicate."),
        Cannot_find_parameter_0: diag(1225, ts3.DiagnosticCategory.Error, "Cannot_find_parameter_0_1225", "Cannot find parameter '{0}'."),
        Type_predicate_0_is_not_assignable_to_1: diag(1226, ts3.DiagnosticCategory.Error, "Type_predicate_0_is_not_assignable_to_1_1226", "Type predicate '{0}' is not assignable to '{1}'."),
        Parameter_0_is_not_in_the_same_position_as_parameter_1: diag(1227, ts3.DiagnosticCategory.Error, "Parameter_0_is_not_in_the_same_position_as_parameter_1_1227", "Parameter '{0}' is not in the same position as parameter '{1}'."),
        A_type_predicate_is_only_allowed_in_return_type_position_for_functions_and_methods: diag(1228, ts3.DiagnosticCategory.Error, "A_type_predicate_is_only_allowed_in_return_type_position_for_functions_and_methods_1228", "A type predicate is only allowed in return type position for functions and methods."),
        A_type_predicate_cannot_reference_a_rest_parameter: diag(1229, ts3.DiagnosticCategory.Error, "A_type_predicate_cannot_reference_a_rest_parameter_1229", "A type predicate cannot reference a rest parameter."),
        A_type_predicate_cannot_reference_element_0_in_a_binding_pattern: diag(1230, ts3.DiagnosticCategory.Error, "A_type_predicate_cannot_reference_element_0_in_a_binding_pattern_1230", "A type predicate cannot reference element '{0}' in a binding pattern."),
        An_export_assignment_must_be_at_the_top_level_of_a_file_or_module_declaration: diag(1231, ts3.DiagnosticCategory.Error, "An_export_assignment_must_be_at_the_top_level_of_a_file_or_module_declaration_1231", "An export assignment must be at the top level of a file or module declaration."),
        An_import_declaration_can_only_be_used_in_a_namespace_or_module: diag(1232, ts3.DiagnosticCategory.Error, "An_import_declaration_can_only_be_used_in_a_namespace_or_module_1232", "An import declaration can only be used in a namespace or module."),
        An_export_declaration_can_only_be_used_in_a_module: diag(1233, ts3.DiagnosticCategory.Error, "An_export_declaration_can_only_be_used_in_a_module_1233", "An export declaration can only be used in a module."),
        An_ambient_module_declaration_is_only_allowed_at_the_top_level_in_a_file: diag(1234, ts3.DiagnosticCategory.Error, "An_ambient_module_declaration_is_only_allowed_at_the_top_level_in_a_file_1234", "An ambient module declaration is only allowed at the top level in a file."),
        A_namespace_declaration_is_only_allowed_in_a_namespace_or_module: diag(1235, ts3.DiagnosticCategory.Error, "A_namespace_declaration_is_only_allowed_in_a_namespace_or_module_1235", "A namespace declaration is only allowed in a namespace or module."),
        The_return_type_of_a_property_decorator_function_must_be_either_void_or_any: diag(1236, ts3.DiagnosticCategory.Error, "The_return_type_of_a_property_decorator_function_must_be_either_void_or_any_1236", "The return type of a property decorator function must be either 'void' or 'any'."),
        The_return_type_of_a_parameter_decorator_function_must_be_either_void_or_any: diag(1237, ts3.DiagnosticCategory.Error, "The_return_type_of_a_parameter_decorator_function_must_be_either_void_or_any_1237", "The return type of a parameter decorator function must be either 'void' or 'any'."),
        Unable_to_resolve_signature_of_class_decorator_when_called_as_an_expression: diag(1238, ts3.DiagnosticCategory.Error, "Unable_to_resolve_signature_of_class_decorator_when_called_as_an_expression_1238", "Unable to resolve signature of class decorator when called as an expression."),
        Unable_to_resolve_signature_of_parameter_decorator_when_called_as_an_expression: diag(1239, ts3.DiagnosticCategory.Error, "Unable_to_resolve_signature_of_parameter_decorator_when_called_as_an_expression_1239", "Unable to resolve signature of parameter decorator when called as an expression."),
        Unable_to_resolve_signature_of_property_decorator_when_called_as_an_expression: diag(1240, ts3.DiagnosticCategory.Error, "Unable_to_resolve_signature_of_property_decorator_when_called_as_an_expression_1240", "Unable to resolve signature of property decorator when called as an expression."),
        Unable_to_resolve_signature_of_method_decorator_when_called_as_an_expression: diag(1241, ts3.DiagnosticCategory.Error, "Unable_to_resolve_signature_of_method_decorator_when_called_as_an_expression_1241", "Unable to resolve signature of method decorator when called as an expression."),
        abstract_modifier_can_only_appear_on_a_class_method_or_property_declaration: diag(1242, ts3.DiagnosticCategory.Error, "abstract_modifier_can_only_appear_on_a_class_method_or_property_declaration_1242", "'abstract' modifier can only appear on a class, method, or property declaration."),
        _0_modifier_cannot_be_used_with_1_modifier: diag(1243, ts3.DiagnosticCategory.Error, "_0_modifier_cannot_be_used_with_1_modifier_1243", "'{0}' modifier cannot be used with '{1}' modifier."),
        Abstract_methods_can_only_appear_within_an_abstract_class: diag(1244, ts3.DiagnosticCategory.Error, "Abstract_methods_can_only_appear_within_an_abstract_class_1244", "Abstract methods can only appear within an abstract class."),
        Method_0_cannot_have_an_implementation_because_it_is_marked_abstract: diag(1245, ts3.DiagnosticCategory.Error, "Method_0_cannot_have_an_implementation_because_it_is_marked_abstract_1245", "Method '{0}' cannot have an implementation because it is marked abstract."),
        An_interface_property_cannot_have_an_initializer: diag(1246, ts3.DiagnosticCategory.Error, "An_interface_property_cannot_have_an_initializer_1246", "An interface property cannot have an initializer."),
        A_type_literal_property_cannot_have_an_initializer: diag(1247, ts3.DiagnosticCategory.Error, "A_type_literal_property_cannot_have_an_initializer_1247", "A type literal property cannot have an initializer."),
        A_class_member_cannot_have_the_0_keyword: diag(1248, ts3.DiagnosticCategory.Error, "A_class_member_cannot_have_the_0_keyword_1248", "A class member cannot have the '{0}' keyword."),
        A_decorator_can_only_decorate_a_method_implementation_not_an_overload: diag(1249, ts3.DiagnosticCategory.Error, "A_decorator_can_only_decorate_a_method_implementation_not_an_overload_1249", "A decorator can only decorate a method implementation, not an overload."),
        Function_declarations_are_not_allowed_inside_blocks_in_strict_mode_when_targeting_ES3_or_ES5: diag(1250, ts3.DiagnosticCategory.Error, "Function_declarations_are_not_allowed_inside_blocks_in_strict_mode_when_targeting_ES3_or_ES5_1250", "Function declarations are not allowed inside blocks in strict mode when targeting 'ES3' or 'ES5'."),
        Function_declarations_are_not_allowed_inside_blocks_in_strict_mode_when_targeting_ES3_or_ES5_Class_definitions_are_automatically_in_strict_mode: diag(1251, ts3.DiagnosticCategory.Error, "Function_declarations_are_not_allowed_inside_blocks_in_strict_mode_when_targeting_ES3_or_ES5_Class_d_1251", "Function declarations are not allowed inside blocks in strict mode when targeting 'ES3' or 'ES5'. Class definitions are automatically in strict mode."),
        Function_declarations_are_not_allowed_inside_blocks_in_strict_mode_when_targeting_ES3_or_ES5_Modules_are_automatically_in_strict_mode: diag(1252, ts3.DiagnosticCategory.Error, "Function_declarations_are_not_allowed_inside_blocks_in_strict_mode_when_targeting_ES3_or_ES5_Modules_1252", "Function declarations are not allowed inside blocks in strict mode when targeting 'ES3' or 'ES5'. Modules are automatically in strict mode."),
        _0_tag_cannot_be_used_independently_as_a_top_level_JSDoc_tag: diag(1253, ts3.DiagnosticCategory.Error, "_0_tag_cannot_be_used_independently_as_a_top_level_JSDoc_tag_1253", "'{0}' tag cannot be used independently as a top level JSDoc tag."),
        A_const_initializer_in_an_ambient_context_must_be_a_string_or_numeric_literal_or_literal_enum_reference: diag(1254, ts3.DiagnosticCategory.Error, "A_const_initializer_in_an_ambient_context_must_be_a_string_or_numeric_literal_or_literal_enum_refere_1254", "A 'const' initializer in an ambient context must be a string or numeric literal or literal enum reference."),
        A_definite_assignment_assertion_is_not_permitted_in_this_context: diag(1255, ts3.DiagnosticCategory.Error, "A_definite_assignment_assertion_is_not_permitted_in_this_context_1255", "A definite assignment assertion '!' is not permitted in this context."),
        A_required_element_cannot_follow_an_optional_element: diag(1257, ts3.DiagnosticCategory.Error, "A_required_element_cannot_follow_an_optional_element_1257", "A required element cannot follow an optional element."),
        A_default_export_must_be_at_the_top_level_of_a_file_or_module_declaration: diag(1258, ts3.DiagnosticCategory.Error, "A_default_export_must_be_at_the_top_level_of_a_file_or_module_declaration_1258", "A default export must be at the top level of a file or module declaration."),
        Module_0_can_only_be_default_imported_using_the_1_flag: diag(1259, ts3.DiagnosticCategory.Error, "Module_0_can_only_be_default_imported_using_the_1_flag_1259", "Module '{0}' can only be default-imported using the '{1}' flag"),
        Keywords_cannot_contain_escape_characters: diag(1260, ts3.DiagnosticCategory.Error, "Keywords_cannot_contain_escape_characters_1260", "Keywords cannot contain escape characters."),
        Already_included_file_name_0_differs_from_file_name_1_only_in_casing: diag(1261, ts3.DiagnosticCategory.Error, "Already_included_file_name_0_differs_from_file_name_1_only_in_casing_1261", "Already included file name '{0}' differs from file name '{1}' only in casing."),
        Identifier_expected_0_is_a_reserved_word_at_the_top_level_of_a_module: diag(1262, ts3.DiagnosticCategory.Error, "Identifier_expected_0_is_a_reserved_word_at_the_top_level_of_a_module_1262", "Identifier expected. '{0}' is a reserved word at the top-level of a module."),
        Declarations_with_initializers_cannot_also_have_definite_assignment_assertions: diag(1263, ts3.DiagnosticCategory.Error, "Declarations_with_initializers_cannot_also_have_definite_assignment_assertions_1263", "Declarations with initializers cannot also have definite assignment assertions."),
        Declarations_with_definite_assignment_assertions_must_also_have_type_annotations: diag(1264, ts3.DiagnosticCategory.Error, "Declarations_with_definite_assignment_assertions_must_also_have_type_annotations_1264", "Declarations with definite assignment assertions must also have type annotations."),
        A_rest_element_cannot_follow_another_rest_element: diag(1265, ts3.DiagnosticCategory.Error, "A_rest_element_cannot_follow_another_rest_element_1265", "A rest element cannot follow another rest element."),
        An_optional_element_cannot_follow_a_rest_element: diag(1266, ts3.DiagnosticCategory.Error, "An_optional_element_cannot_follow_a_rest_element_1266", "An optional element cannot follow a rest element."),
        with_statements_are_not_allowed_in_an_async_function_block: diag(1300, ts3.DiagnosticCategory.Error, "with_statements_are_not_allowed_in_an_async_function_block_1300", "'with' statements are not allowed in an async function block."),
        await_expressions_are_only_allowed_within_async_functions_and_at_the_top_levels_of_modules: diag(1308, ts3.DiagnosticCategory.Error, "await_expressions_are_only_allowed_within_async_functions_and_at_the_top_levels_of_modules_1308", "'await' expressions are only allowed within async functions and at the top levels of modules."),
        Did_you_mean_to_use_a_Colon_An_can_only_follow_a_property_name_when_the_containing_object_literal_is_part_of_a_destructuring_pattern: diag(1312, ts3.DiagnosticCategory.Error, "Did_you_mean_to_use_a_Colon_An_can_only_follow_a_property_name_when_the_containing_object_literal_is_1312", "Did you mean to use a ':'? An '=' can only follow a property name when the containing object literal is part of a destructuring pattern."),
        The_body_of_an_if_statement_cannot_be_the_empty_statement: diag(1313, ts3.DiagnosticCategory.Error, "The_body_of_an_if_statement_cannot_be_the_empty_statement_1313", "The body of an 'if' statement cannot be the empty statement."),
        Global_module_exports_may_only_appear_in_module_files: diag(1314, ts3.DiagnosticCategory.Error, "Global_module_exports_may_only_appear_in_module_files_1314", "Global module exports may only appear in module files."),
        Global_module_exports_may_only_appear_in_declaration_files: diag(1315, ts3.DiagnosticCategory.Error, "Global_module_exports_may_only_appear_in_declaration_files_1315", "Global module exports may only appear in declaration files."),
        Global_module_exports_may_only_appear_at_top_level: diag(1316, ts3.DiagnosticCategory.Error, "Global_module_exports_may_only_appear_at_top_level_1316", "Global module exports may only appear at top level."),
        A_parameter_property_cannot_be_declared_using_a_rest_parameter: diag(1317, ts3.DiagnosticCategory.Error, "A_parameter_property_cannot_be_declared_using_a_rest_parameter_1317", "A parameter property cannot be declared using a rest parameter."),
        An_abstract_accessor_cannot_have_an_implementation: diag(1318, ts3.DiagnosticCategory.Error, "An_abstract_accessor_cannot_have_an_implementation_1318", "An abstract accessor cannot have an implementation."),
        A_default_export_can_only_be_used_in_an_ECMAScript_style_module: diag(1319, ts3.DiagnosticCategory.Error, "A_default_export_can_only_be_used_in_an_ECMAScript_style_module_1319", "A default export can only be used in an ECMAScript-style module."),
        Type_of_await_operand_must_either_be_a_valid_promise_or_must_not_contain_a_callable_then_member: diag(1320, ts3.DiagnosticCategory.Error, "Type_of_await_operand_must_either_be_a_valid_promise_or_must_not_contain_a_callable_then_member_1320", "Type of 'await' operand must either be a valid promise or must not contain a callable 'then' member."),
        Type_of_yield_operand_in_an_async_generator_must_either_be_a_valid_promise_or_must_not_contain_a_callable_then_member: diag(1321, ts3.DiagnosticCategory.Error, "Type_of_yield_operand_in_an_async_generator_must_either_be_a_valid_promise_or_must_not_contain_a_cal_1321", "Type of 'yield' operand in an async generator must either be a valid promise or must not contain a callable 'then' member."),
        Type_of_iterated_elements_of_a_yield_Asterisk_operand_must_either_be_a_valid_promise_or_must_not_contain_a_callable_then_member: diag(1322, ts3.DiagnosticCategory.Error, "Type_of_iterated_elements_of_a_yield_Asterisk_operand_must_either_be_a_valid_promise_or_must_not_con_1322", "Type of iterated elements of a 'yield*' operand must either be a valid promise or must not contain a callable 'then' member."),
        Dynamic_imports_are_only_supported_when_the_module_flag_is_set_to_es2020_esnext_commonjs_amd_system_or_umd: diag(1323, ts3.DiagnosticCategory.Error, "Dynamic_imports_are_only_supported_when_the_module_flag_is_set_to_es2020_esnext_commonjs_amd_system__1323", "Dynamic imports are only supported when the '--module' flag is set to 'es2020', 'esnext', 'commonjs', 'amd', 'system', or 'umd'."),
        Dynamic_import_must_have_one_specifier_as_an_argument: diag(1324, ts3.DiagnosticCategory.Error, "Dynamic_import_must_have_one_specifier_as_an_argument_1324", "Dynamic import must have one specifier as an argument."),
        Specifier_of_dynamic_import_cannot_be_spread_element: diag(1325, ts3.DiagnosticCategory.Error, "Specifier_of_dynamic_import_cannot_be_spread_element_1325", "Specifier of dynamic import cannot be spread element."),
        Dynamic_import_cannot_have_type_arguments: diag(1326, ts3.DiagnosticCategory.Error, "Dynamic_import_cannot_have_type_arguments_1326", "Dynamic import cannot have type arguments."),
        String_literal_with_double_quotes_expected: diag(1327, ts3.DiagnosticCategory.Error, "String_literal_with_double_quotes_expected_1327", "String literal with double quotes expected."),
        Property_value_can_only_be_string_literal_numeric_literal_true_false_null_object_literal_or_array_literal: diag(1328, ts3.DiagnosticCategory.Error, "Property_value_can_only_be_string_literal_numeric_literal_true_false_null_object_literal_or_array_li_1328", "Property value can only be string literal, numeric literal, 'true', 'false', 'null', object literal or array literal."),
        _0_accepts_too_few_arguments_to_be_used_as_a_decorator_here_Did_you_mean_to_call_it_first_and_write_0: diag(1329, ts3.DiagnosticCategory.Error, "_0_accepts_too_few_arguments_to_be_used_as_a_decorator_here_Did_you_mean_to_call_it_first_and_write__1329", "'{0}' accepts too few arguments to be used as a decorator here. Did you mean to call it first and write '@{0}()'?"),
        A_property_of_an_interface_or_type_literal_whose_type_is_a_unique_symbol_type_must_be_readonly: diag(1330, ts3.DiagnosticCategory.Error, "A_property_of_an_interface_or_type_literal_whose_type_is_a_unique_symbol_type_must_be_readonly_1330", "A property of an interface or type literal whose type is a 'unique symbol' type must be 'readonly'."),
        A_property_of_a_class_whose_type_is_a_unique_symbol_type_must_be_both_static_and_readonly: diag(1331, ts3.DiagnosticCategory.Error, "A_property_of_a_class_whose_type_is_a_unique_symbol_type_must_be_both_static_and_readonly_1331", "A property of a class whose type is a 'unique symbol' type must be both 'static' and 'readonly'."),
        A_variable_whose_type_is_a_unique_symbol_type_must_be_const: diag(1332, ts3.DiagnosticCategory.Error, "A_variable_whose_type_is_a_unique_symbol_type_must_be_const_1332", "A variable whose type is a 'unique symbol' type must be 'const'."),
        unique_symbol_types_may_not_be_used_on_a_variable_declaration_with_a_binding_name: diag(1333, ts3.DiagnosticCategory.Error, "unique_symbol_types_may_not_be_used_on_a_variable_declaration_with_a_binding_name_1333", "'unique symbol' types may not be used on a variable declaration with a binding name."),
        unique_symbol_types_are_only_allowed_on_variables_in_a_variable_statement: diag(1334, ts3.DiagnosticCategory.Error, "unique_symbol_types_are_only_allowed_on_variables_in_a_variable_statement_1334", "'unique symbol' types are only allowed on variables in a variable statement."),
        unique_symbol_types_are_not_allowed_here: diag(1335, ts3.DiagnosticCategory.Error, "unique_symbol_types_are_not_allowed_here_1335", "'unique symbol' types are not allowed here."),
        An_index_signature_parameter_type_cannot_be_a_type_alias_Consider_writing_0_Colon_1_Colon_2_instead: diag(1336, ts3.DiagnosticCategory.Error, "An_index_signature_parameter_type_cannot_be_a_type_alias_Consider_writing_0_Colon_1_Colon_2_instead_1336", "An index signature parameter type cannot be a type alias. Consider writing '[{0}: {1}]: {2}' instead."),
        An_index_signature_parameter_type_cannot_be_a_union_type_Consider_using_a_mapped_object_type_instead: diag(1337, ts3.DiagnosticCategory.Error, "An_index_signature_parameter_type_cannot_be_a_union_type_Consider_using_a_mapped_object_type_instead_1337", "An index signature parameter type cannot be a union type. Consider using a mapped object type instead."),
        infer_declarations_are_only_permitted_in_the_extends_clause_of_a_conditional_type: diag(1338, ts3.DiagnosticCategory.Error, "infer_declarations_are_only_permitted_in_the_extends_clause_of_a_conditional_type_1338", "'infer' declarations are only permitted in the 'extends' clause of a conditional type."),
        Module_0_does_not_refer_to_a_value_but_is_used_as_a_value_here: diag(1339, ts3.DiagnosticCategory.Error, "Module_0_does_not_refer_to_a_value_but_is_used_as_a_value_here_1339", "Module '{0}' does not refer to a value, but is used as a value here."),
        Module_0_does_not_refer_to_a_type_but_is_used_as_a_type_here_Did_you_mean_typeof_import_0: diag(1340, ts3.DiagnosticCategory.Error, "Module_0_does_not_refer_to_a_type_but_is_used_as_a_type_here_Did_you_mean_typeof_import_0_1340", "Module '{0}' does not refer to a type, but is used as a type here. Did you mean 'typeof import('{0}')'?"),
        Type_arguments_cannot_be_used_here: diag(1342, ts3.DiagnosticCategory.Error, "Type_arguments_cannot_be_used_here_1342", "Type arguments cannot be used here."),
        The_import_meta_meta_property_is_only_allowed_when_the_module_option_is_es2020_esnext_or_system: diag(1343, ts3.DiagnosticCategory.Error, "The_import_meta_meta_property_is_only_allowed_when_the_module_option_is_es2020_esnext_or_system_1343", "The 'import.meta' meta-property is only allowed when the '--module' option is 'es2020', 'esnext', or 'system'."),
        A_label_is_not_allowed_here: diag(1344, ts3.DiagnosticCategory.Error, "A_label_is_not_allowed_here_1344", "'A label is not allowed here."),
        An_expression_of_type_void_cannot_be_tested_for_truthiness: diag(1345, ts3.DiagnosticCategory.Error, "An_expression_of_type_void_cannot_be_tested_for_truthiness_1345", "An expression of type 'void' cannot be tested for truthiness."),
        This_parameter_is_not_allowed_with_use_strict_directive: diag(1346, ts3.DiagnosticCategory.Error, "This_parameter_is_not_allowed_with_use_strict_directive_1346", "This parameter is not allowed with 'use strict' directive."),
        use_strict_directive_cannot_be_used_with_non_simple_parameter_list: diag(1347, ts3.DiagnosticCategory.Error, "use_strict_directive_cannot_be_used_with_non_simple_parameter_list_1347", "'use strict' directive cannot be used with non-simple parameter list."),
        Non_simple_parameter_declared_here: diag(1348, ts3.DiagnosticCategory.Error, "Non_simple_parameter_declared_here_1348", "Non-simple parameter declared here."),
        use_strict_directive_used_here: diag(1349, ts3.DiagnosticCategory.Error, "use_strict_directive_used_here_1349", "'use strict' directive used here."),
        Print_the_final_configuration_instead_of_building: diag(1350, ts3.DiagnosticCategory.Message, "Print_the_final_configuration_instead_of_building_1350", "Print the final configuration instead of building."),
        An_identifier_or_keyword_cannot_immediately_follow_a_numeric_literal: diag(1351, ts3.DiagnosticCategory.Error, "An_identifier_or_keyword_cannot_immediately_follow_a_numeric_literal_1351", "An identifier or keyword cannot immediately follow a numeric literal."),
        A_bigint_literal_cannot_use_exponential_notation: diag(1352, ts3.DiagnosticCategory.Error, "A_bigint_literal_cannot_use_exponential_notation_1352", "A bigint literal cannot use exponential notation."),
        A_bigint_literal_must_be_an_integer: diag(1353, ts3.DiagnosticCategory.Error, "A_bigint_literal_must_be_an_integer_1353", "A bigint literal must be an integer."),
        readonly_type_modifier_is_only_permitted_on_array_and_tuple_literal_types: diag(1354, ts3.DiagnosticCategory.Error, "readonly_type_modifier_is_only_permitted_on_array_and_tuple_literal_types_1354", "'readonly' type modifier is only permitted on array and tuple literal types."),
        A_const_assertions_can_only_be_applied_to_references_to_enum_members_or_string_number_boolean_array_or_object_literals: diag(1355, ts3.DiagnosticCategory.Error, "A_const_assertions_can_only_be_applied_to_references_to_enum_members_or_string_number_boolean_array__1355", "A 'const' assertions can only be applied to references to enum members, or string, number, boolean, array, or object literals."),
        Did_you_mean_to_mark_this_function_as_async: diag(1356, ts3.DiagnosticCategory.Error, "Did_you_mean_to_mark_this_function_as_async_1356", "Did you mean to mark this function as 'async'?"),
        An_enum_member_name_must_be_followed_by_a_or: diag(1357, ts3.DiagnosticCategory.Error, "An_enum_member_name_must_be_followed_by_a_or_1357", "An enum member name must be followed by a ',', '=', or '}'."),
        Tagged_template_expressions_are_not_permitted_in_an_optional_chain: diag(1358, ts3.DiagnosticCategory.Error, "Tagged_template_expressions_are_not_permitted_in_an_optional_chain_1358", "Tagged template expressions are not permitted in an optional chain."),
        Identifier_expected_0_is_a_reserved_word_that_cannot_be_used_here: diag(1359, ts3.DiagnosticCategory.Error, "Identifier_expected_0_is_a_reserved_word_that_cannot_be_used_here_1359", "Identifier expected. '{0}' is a reserved word that cannot be used here."),
        Did_you_mean_to_parenthesize_this_function_type: diag(1360, ts3.DiagnosticCategory.Error, "Did_you_mean_to_parenthesize_this_function_type_1360", "Did you mean to parenthesize this function type?"),
        _0_cannot_be_used_as_a_value_because_it_was_imported_using_import_type: diag(1361, ts3.DiagnosticCategory.Error, "_0_cannot_be_used_as_a_value_because_it_was_imported_using_import_type_1361", "'{0}' cannot be used as a value because it was imported using 'import type'."),
        _0_cannot_be_used_as_a_value_because_it_was_exported_using_export_type: diag(1362, ts3.DiagnosticCategory.Error, "_0_cannot_be_used_as_a_value_because_it_was_exported_using_export_type_1362", "'{0}' cannot be used as a value because it was exported using 'export type'."),
        A_type_only_import_can_specify_a_default_import_or_named_bindings_but_not_both: diag(1363, ts3.DiagnosticCategory.Error, "A_type_only_import_can_specify_a_default_import_or_named_bindings_but_not_both_1363", "A type-only import can specify a default import or named bindings, but not both."),
        Convert_to_type_only_export: diag(1364, ts3.DiagnosticCategory.Message, "Convert_to_type_only_export_1364", "Convert to type-only export"),
        Convert_all_re_exported_types_to_type_only_exports: diag(1365, ts3.DiagnosticCategory.Message, "Convert_all_re_exported_types_to_type_only_exports_1365", "Convert all re-exported types to type-only exports"),
        Split_into_two_separate_import_declarations: diag(1366, ts3.DiagnosticCategory.Message, "Split_into_two_separate_import_declarations_1366", "Split into two separate import declarations"),
        Split_all_invalid_type_only_imports: diag(1367, ts3.DiagnosticCategory.Message, "Split_all_invalid_type_only_imports_1367", "Split all invalid type-only imports"),
        Specify_emit_Slashchecking_behavior_for_imports_that_are_only_used_for_types: diag(1368, ts3.DiagnosticCategory.Message, "Specify_emit_Slashchecking_behavior_for_imports_that_are_only_used_for_types_1368", "Specify emit/checking behavior for imports that are only used for types"),
        Did_you_mean_0: diag(1369, ts3.DiagnosticCategory.Message, "Did_you_mean_0_1369", "Did you mean '{0}'?"),
        This_import_is_never_used_as_a_value_and_must_use_import_type_because_importsNotUsedAsValues_is_set_to_error: diag(1371, ts3.DiagnosticCategory.Error, "This_import_is_never_used_as_a_value_and_must_use_import_type_because_importsNotUsedAsValues_is_set__1371", "This import is never used as a value and must use 'import type' because 'importsNotUsedAsValues' is set to 'error'."),
        Convert_to_type_only_import: diag(1373, ts3.DiagnosticCategory.Message, "Convert_to_type_only_import_1373", "Convert to type-only import"),
        Convert_all_imports_not_used_as_a_value_to_type_only_imports: diag(1374, ts3.DiagnosticCategory.Message, "Convert_all_imports_not_used_as_a_value_to_type_only_imports_1374", "Convert all imports not used as a value to type-only imports"),
        await_expressions_are_only_allowed_at_the_top_level_of_a_file_when_that_file_is_a_module_but_this_file_has_no_imports_or_exports_Consider_adding_an_empty_export_to_make_this_file_a_module: diag(1375, ts3.DiagnosticCategory.Error, "await_expressions_are_only_allowed_at_the_top_level_of_a_file_when_that_file_is_a_module_but_this_fi_1375", "'await' expressions are only allowed at the top level of a file when that file is a module, but this file has no imports or exports. Consider adding an empty 'export {}' to make this file a module."),
        _0_was_imported_here: diag(1376, ts3.DiagnosticCategory.Message, "_0_was_imported_here_1376", "'{0}' was imported here."),
        _0_was_exported_here: diag(1377, ts3.DiagnosticCategory.Message, "_0_was_exported_here_1377", "'{0}' was exported here."),
        Top_level_await_expressions_are_only_allowed_when_the_module_option_is_set_to_esnext_or_system_and_the_target_option_is_set_to_es2017_or_higher: diag(1378, ts3.DiagnosticCategory.Error, "Top_level_await_expressions_are_only_allowed_when_the_module_option_is_set_to_esnext_or_system_and_t_1378", "Top-level 'await' expressions are only allowed when the 'module' option is set to 'esnext' or 'system', and the 'target' option is set to 'es2017' or higher."),
        An_import_alias_cannot_reference_a_declaration_that_was_exported_using_export_type: diag(1379, ts3.DiagnosticCategory.Error, "An_import_alias_cannot_reference_a_declaration_that_was_exported_using_export_type_1379", "An import alias cannot reference a declaration that was exported using 'export type'."),
        An_import_alias_cannot_reference_a_declaration_that_was_imported_using_import_type: diag(1380, ts3.DiagnosticCategory.Error, "An_import_alias_cannot_reference_a_declaration_that_was_imported_using_import_type_1380", "An import alias cannot reference a declaration that was imported using 'import type'."),
        Unexpected_token_Did_you_mean_or_rbrace: diag(1381, ts3.DiagnosticCategory.Error, "Unexpected_token_Did_you_mean_or_rbrace_1381", "Unexpected token. Did you mean `{'}'}` or `&rbrace;`?"),
        Unexpected_token_Did_you_mean_or_gt: diag(1382, ts3.DiagnosticCategory.Error, "Unexpected_token_Did_you_mean_or_gt_1382", "Unexpected token. Did you mean `{'>'}` or `&gt;`?"),
        Only_named_exports_may_use_export_type: diag(1383, ts3.DiagnosticCategory.Error, "Only_named_exports_may_use_export_type_1383", "Only named exports may use 'export type'."),
        A_new_expression_with_type_arguments_must_always_be_followed_by_a_parenthesized_argument_list: diag(1384, ts3.DiagnosticCategory.Error, "A_new_expression_with_type_arguments_must_always_be_followed_by_a_parenthesized_argument_list_1384", "A 'new' expression with type arguments must always be followed by a parenthesized argument list."),
        Function_type_notation_must_be_parenthesized_when_used_in_a_union_type: diag(1385, ts3.DiagnosticCategory.Error, "Function_type_notation_must_be_parenthesized_when_used_in_a_union_type_1385", "Function type notation must be parenthesized when used in a union type."),
        Constructor_type_notation_must_be_parenthesized_when_used_in_a_union_type: diag(1386, ts3.DiagnosticCategory.Error, "Constructor_type_notation_must_be_parenthesized_when_used_in_a_union_type_1386", "Constructor type notation must be parenthesized when used in a union type."),
        Function_type_notation_must_be_parenthesized_when_used_in_an_intersection_type: diag(1387, ts3.DiagnosticCategory.Error, "Function_type_notation_must_be_parenthesized_when_used_in_an_intersection_type_1387", "Function type notation must be parenthesized when used in an intersection type."),
        Constructor_type_notation_must_be_parenthesized_when_used_in_an_intersection_type: diag(1388, ts3.DiagnosticCategory.Error, "Constructor_type_notation_must_be_parenthesized_when_used_in_an_intersection_type_1388", "Constructor type notation must be parenthesized when used in an intersection type."),
        _0_is_not_allowed_as_a_variable_declaration_name: diag(1389, ts3.DiagnosticCategory.Error, "_0_is_not_allowed_as_a_variable_declaration_name_1389", "'{0}' is not allowed as a variable declaration name."),
        Provides_a_root_package_name_when_using_outFile_with_declarations: diag(1390, ts3.DiagnosticCategory.Message, "Provides_a_root_package_name_when_using_outFile_with_declarations_1390", "Provides a root package name when using outFile with declarations."),
        The_bundledPackageName_option_must_be_provided_when_using_outFile_and_node_module_resolution_with_declaration_emit: diag(1391, ts3.DiagnosticCategory.Error, "The_bundledPackageName_option_must_be_provided_when_using_outFile_and_node_module_resolution_with_de_1391", "The 'bundledPackageName' option must be provided when using outFile and node module resolution with declaration emit."),
        An_import_alias_cannot_use_import_type: diag(1392, ts3.DiagnosticCategory.Error, "An_import_alias_cannot_use_import_type_1392", "An import alias cannot use 'import type'"),
        Imported_via_0_from_file_1: diag(1393, ts3.DiagnosticCategory.Message, "Imported_via_0_from_file_1_1393", "Imported via {0} from file '{1}'"),
        Imported_via_0_from_file_1_with_packageId_2: diag(1394, ts3.DiagnosticCategory.Message, "Imported_via_0_from_file_1_with_packageId_2_1394", "Imported via {0} from file '{1}' with packageId '{2}'"),
        Imported_via_0_from_file_1_to_import_importHelpers_as_specified_in_compilerOptions: diag(1395, ts3.DiagnosticCategory.Message, "Imported_via_0_from_file_1_to_import_importHelpers_as_specified_in_compilerOptions_1395", "Imported via {0} from file '{1}' to import 'importHelpers' as specified in compilerOptions"),
        Imported_via_0_from_file_1_with_packageId_2_to_import_importHelpers_as_specified_in_compilerOptions: diag(1396, ts3.DiagnosticCategory.Message, "Imported_via_0_from_file_1_with_packageId_2_to_import_importHelpers_as_specified_in_compilerOptions_1396", "Imported via {0} from file '{1}' with packageId '{2}' to import 'importHelpers' as specified in compilerOptions"),
        Imported_via_0_from_file_1_to_import_jsx_and_jsxs_factory_functions: diag(1397, ts3.DiagnosticCategory.Message, "Imported_via_0_from_file_1_to_import_jsx_and_jsxs_factory_functions_1397", "Imported via {0} from file '{1}' to import 'jsx' and 'jsxs' factory functions"),
        Imported_via_0_from_file_1_with_packageId_2_to_import_jsx_and_jsxs_factory_functions: diag(1398, ts3.DiagnosticCategory.Message, "Imported_via_0_from_file_1_with_packageId_2_to_import_jsx_and_jsxs_factory_functions_1398", "Imported via {0} from file '{1}' with packageId '{2}' to import 'jsx' and 'jsxs' factory functions"),
        File_is_included_via_import_here: diag(1399, ts3.DiagnosticCategory.Message, "File_is_included_via_import_here_1399", "File is included via import here."),
        Referenced_via_0_from_file_1: diag(1400, ts3.DiagnosticCategory.Message, "Referenced_via_0_from_file_1_1400", "Referenced via '{0}' from file '{1}'"),
        File_is_included_via_reference_here: diag(1401, ts3.DiagnosticCategory.Message, "File_is_included_via_reference_here_1401", "File is included via reference here."),
        Type_library_referenced_via_0_from_file_1: diag(1402, ts3.DiagnosticCategory.Message, "Type_library_referenced_via_0_from_file_1_1402", "Type library referenced via '{0}' from file '{1}'"),
        Type_library_referenced_via_0_from_file_1_with_packageId_2: diag(1403, ts3.DiagnosticCategory.Message, "Type_library_referenced_via_0_from_file_1_with_packageId_2_1403", "Type library referenced via '{0}' from file '{1}' with packageId '{2}'"),
        File_is_included_via_type_library_reference_here: diag(1404, ts3.DiagnosticCategory.Message, "File_is_included_via_type_library_reference_here_1404", "File is included via type library reference here."),
        Library_referenced_via_0_from_file_1: diag(1405, ts3.DiagnosticCategory.Message, "Library_referenced_via_0_from_file_1_1405", "Library referenced via '{0}' from file '{1}'"),
        File_is_included_via_library_reference_here: diag(1406, ts3.DiagnosticCategory.Message, "File_is_included_via_library_reference_here_1406", "File is included via library reference here."),
        Matched_by_include_pattern_0_in_1: diag(1407, ts3.DiagnosticCategory.Message, "Matched_by_include_pattern_0_in_1_1407", "Matched by include pattern '{0}' in '{1}'"),
        File_is_matched_by_include_pattern_specified_here: diag(1408, ts3.DiagnosticCategory.Message, "File_is_matched_by_include_pattern_specified_here_1408", "File is matched by include pattern specified here."),
        Part_of_files_list_in_tsconfig_json: diag(1409, ts3.DiagnosticCategory.Message, "Part_of_files_list_in_tsconfig_json_1409", "Part of 'files' list in tsconfig.json"),
        File_is_matched_by_files_list_specified_here: diag(1410, ts3.DiagnosticCategory.Message, "File_is_matched_by_files_list_specified_here_1410", "File is matched by 'files' list specified here."),
        Output_from_referenced_project_0_included_because_1_specified: diag(1411, ts3.DiagnosticCategory.Message, "Output_from_referenced_project_0_included_because_1_specified_1411", "Output from referenced project '{0}' included because '{1}' specified"),
        Output_from_referenced_project_0_included_because_module_is_specified_as_none: diag(1412, ts3.DiagnosticCategory.Message, "Output_from_referenced_project_0_included_because_module_is_specified_as_none_1412", "Output from referenced project '{0}' included because '--module' is specified as 'none'"),
        File_is_output_from_referenced_project_specified_here: diag(1413, ts3.DiagnosticCategory.Message, "File_is_output_from_referenced_project_specified_here_1413", "File is output from referenced project specified here."),
        Source_from_referenced_project_0_included_because_1_specified: diag(1414, ts3.DiagnosticCategory.Message, "Source_from_referenced_project_0_included_because_1_specified_1414", "Source from referenced project '{0}' included because '{1}' specified"),
        Source_from_referenced_project_0_included_because_module_is_specified_as_none: diag(1415, ts3.DiagnosticCategory.Message, "Source_from_referenced_project_0_included_because_module_is_specified_as_none_1415", "Source from referenced project '{0}' included because '--module' is specified as 'none'"),
        File_is_source_from_referenced_project_specified_here: diag(1416, ts3.DiagnosticCategory.Message, "File_is_source_from_referenced_project_specified_here_1416", "File is source from referenced project specified here."),
        Entry_point_of_type_library_0_specified_in_compilerOptions: diag(1417, ts3.DiagnosticCategory.Message, "Entry_point_of_type_library_0_specified_in_compilerOptions_1417", "Entry point of type library '{0}' specified in compilerOptions"),
        Entry_point_of_type_library_0_specified_in_compilerOptions_with_packageId_1: diag(1418, ts3.DiagnosticCategory.Message, "Entry_point_of_type_library_0_specified_in_compilerOptions_with_packageId_1_1418", "Entry point of type library '{0}' specified in compilerOptions with packageId '{1}'"),
        File_is_entry_point_of_type_library_specified_here: diag(1419, ts3.DiagnosticCategory.Message, "File_is_entry_point_of_type_library_specified_here_1419", "File is entry point of type library specified here."),
        Entry_point_for_implicit_type_library_0: diag(1420, ts3.DiagnosticCategory.Message, "Entry_point_for_implicit_type_library_0_1420", "Entry point for implicit type library '{0}'"),
        Entry_point_for_implicit_type_library_0_with_packageId_1: diag(1421, ts3.DiagnosticCategory.Message, "Entry_point_for_implicit_type_library_0_with_packageId_1_1421", "Entry point for implicit type library '{0}' with packageId '{1}'"),
        Library_0_specified_in_compilerOptions: diag(1422, ts3.DiagnosticCategory.Message, "Library_0_specified_in_compilerOptions_1422", "Library '{0}' specified in compilerOptions"),
        File_is_library_specified_here: diag(1423, ts3.DiagnosticCategory.Message, "File_is_library_specified_here_1423", "File is library specified here."),
        Default_library: diag(1424, ts3.DiagnosticCategory.Message, "Default_library_1424", "Default library"),
        Default_library_for_target_0: diag(1425, ts3.DiagnosticCategory.Message, "Default_library_for_target_0_1425", "Default library for target '{0}'"),
        File_is_default_library_for_target_specified_here: diag(1426, ts3.DiagnosticCategory.Message, "File_is_default_library_for_target_specified_here_1426", "File is default library for target specified here."),
        Root_file_specified_for_compilation: diag(1427, ts3.DiagnosticCategory.Message, "Root_file_specified_for_compilation_1427", "Root file specified for compilation"),
        File_is_output_of_project_reference_source_0: diag(1428, ts3.DiagnosticCategory.Message, "File_is_output_of_project_reference_source_0_1428", "File is output of project reference source '{0}'"),
        File_redirects_to_file_0: diag(1429, ts3.DiagnosticCategory.Message, "File_redirects_to_file_0_1429", "File redirects to file '{0}'"),
        The_file_is_in_the_program_because_Colon: diag(1430, ts3.DiagnosticCategory.Message, "The_file_is_in_the_program_because_Colon_1430", "The file is in the program because:"),
        for_await_loops_are_only_allowed_at_the_top_level_of_a_file_when_that_file_is_a_module_but_this_file_has_no_imports_or_exports_Consider_adding_an_empty_export_to_make_this_file_a_module: diag(1431, ts3.DiagnosticCategory.Error, "for_await_loops_are_only_allowed_at_the_top_level_of_a_file_when_that_file_is_a_module_but_this_file_1431", "'for await' loops are only allowed at the top level of a file when that file is a module, but this file has no imports or exports. Consider adding an empty 'export {}' to make this file a module."),
        Top_level_for_await_loops_are_only_allowed_when_the_module_option_is_set_to_esnext_or_system_and_the_target_option_is_set_to_es2017_or_higher: diag(1432, ts3.DiagnosticCategory.Error, "Top_level_for_await_loops_are_only_allowed_when_the_module_option_is_set_to_esnext_or_system_and_the_1432", "Top-level 'for await' loops are only allowed when the 'module' option is set to 'esnext' or 'system', and the 'target' option is set to 'es2017' or higher."),
        Decorators_may_not_be_applied_to_this_parameters: diag(1433, ts3.DiagnosticCategory.Error, "Decorators_may_not_be_applied_to_this_parameters_1433", "Decorators may not be applied to 'this' parameters."),
        The_types_of_0_are_incompatible_between_these_types: diag(2200, ts3.DiagnosticCategory.Error, "The_types_of_0_are_incompatible_between_these_types_2200", "The types of '{0}' are incompatible between these types."),
        The_types_returned_by_0_are_incompatible_between_these_types: diag(2201, ts3.DiagnosticCategory.Error, "The_types_returned_by_0_are_incompatible_between_these_types_2201", "The types returned by '{0}' are incompatible between these types."),
        Call_signature_return_types_0_and_1_are_incompatible: diag(2202, ts3.DiagnosticCategory.Error, "Call_signature_return_types_0_and_1_are_incompatible_2202", "Call signature return types '{0}' and '{1}' are incompatible.", void 0, true),
        Construct_signature_return_types_0_and_1_are_incompatible: diag(2203, ts3.DiagnosticCategory.Error, "Construct_signature_return_types_0_and_1_are_incompatible_2203", "Construct signature return types '{0}' and '{1}' are incompatible.", void 0, true),
        Call_signatures_with_no_arguments_have_incompatible_return_types_0_and_1: diag(2204, ts3.DiagnosticCategory.Error, "Call_signatures_with_no_arguments_have_incompatible_return_types_0_and_1_2204", "Call signatures with no arguments have incompatible return types '{0}' and '{1}'.", void 0, true),
        Construct_signatures_with_no_arguments_have_incompatible_return_types_0_and_1: diag(2205, ts3.DiagnosticCategory.Error, "Construct_signatures_with_no_arguments_have_incompatible_return_types_0_and_1_2205", "Construct signatures with no arguments have incompatible return types '{0}' and '{1}'.", void 0, true),
        Duplicate_identifier_0: diag(2300, ts3.DiagnosticCategory.Error, "Duplicate_identifier_0_2300", "Duplicate identifier '{0}'."),
        Initializer_of_instance_member_variable_0_cannot_reference_identifier_1_declared_in_the_constructor: diag(2301, ts3.DiagnosticCategory.Error, "Initializer_of_instance_member_variable_0_cannot_reference_identifier_1_declared_in_the_constructor_2301", "Initializer of instance member variable '{0}' cannot reference identifier '{1}' declared in the constructor."),
        Static_members_cannot_reference_class_type_parameters: diag(2302, ts3.DiagnosticCategory.Error, "Static_members_cannot_reference_class_type_parameters_2302", "Static members cannot reference class type parameters."),
        Circular_definition_of_import_alias_0: diag(2303, ts3.DiagnosticCategory.Error, "Circular_definition_of_import_alias_0_2303", "Circular definition of import alias '{0}'."),
        Cannot_find_name_0: diag(2304, ts3.DiagnosticCategory.Error, "Cannot_find_name_0_2304", "Cannot find name '{0}'."),
        Module_0_has_no_exported_member_1: diag(2305, ts3.DiagnosticCategory.Error, "Module_0_has_no_exported_member_1_2305", "Module '{0}' has no exported member '{1}'."),
        File_0_is_not_a_module: diag(2306, ts3.DiagnosticCategory.Error, "File_0_is_not_a_module_2306", "File '{0}' is not a module."),
        Cannot_find_module_0_or_its_corresponding_type_declarations: diag(2307, ts3.DiagnosticCategory.Error, "Cannot_find_module_0_or_its_corresponding_type_declarations_2307", "Cannot find module '{0}' or its corresponding type declarations."),
        Module_0_has_already_exported_a_member_named_1_Consider_explicitly_re_exporting_to_resolve_the_ambiguity: diag(2308, ts3.DiagnosticCategory.Error, "Module_0_has_already_exported_a_member_named_1_Consider_explicitly_re_exporting_to_resolve_the_ambig_2308", "Module {0} has already exported a member named '{1}'. Consider explicitly re-exporting to resolve the ambiguity."),
        An_export_assignment_cannot_be_used_in_a_module_with_other_exported_elements: diag(2309, ts3.DiagnosticCategory.Error, "An_export_assignment_cannot_be_used_in_a_module_with_other_exported_elements_2309", "An export assignment cannot be used in a module with other exported elements."),
        Type_0_recursively_references_itself_as_a_base_type: diag(2310, ts3.DiagnosticCategory.Error, "Type_0_recursively_references_itself_as_a_base_type_2310", "Type '{0}' recursively references itself as a base type."),
        A_class_may_only_extend_another_class: diag(2311, ts3.DiagnosticCategory.Error, "A_class_may_only_extend_another_class_2311", "A class may only extend another class."),
        An_interface_can_only_extend_an_object_type_or_intersection_of_object_types_with_statically_known_members: diag(2312, ts3.DiagnosticCategory.Error, "An_interface_can_only_extend_an_object_type_or_intersection_of_object_types_with_statically_known_me_2312", "An interface can only extend an object type or intersection of object types with statically known members."),
        Type_parameter_0_has_a_circular_constraint: diag(2313, ts3.DiagnosticCategory.Error, "Type_parameter_0_has_a_circular_constraint_2313", "Type parameter '{0}' has a circular constraint."),
        Generic_type_0_requires_1_type_argument_s: diag(2314, ts3.DiagnosticCategory.Error, "Generic_type_0_requires_1_type_argument_s_2314", "Generic type '{0}' requires {1} type argument(s)."),
        Type_0_is_not_generic: diag(2315, ts3.DiagnosticCategory.Error, "Type_0_is_not_generic_2315", "Type '{0}' is not generic."),
        Global_type_0_must_be_a_class_or_interface_type: diag(2316, ts3.DiagnosticCategory.Error, "Global_type_0_must_be_a_class_or_interface_type_2316", "Global type '{0}' must be a class or interface type."),
        Global_type_0_must_have_1_type_parameter_s: diag(2317, ts3.DiagnosticCategory.Error, "Global_type_0_must_have_1_type_parameter_s_2317", "Global type '{0}' must have {1} type parameter(s)."),
        Cannot_find_global_type_0: diag(2318, ts3.DiagnosticCategory.Error, "Cannot_find_global_type_0_2318", "Cannot find global type '{0}'."),
        Named_property_0_of_types_1_and_2_are_not_identical: diag(2319, ts3.DiagnosticCategory.Error, "Named_property_0_of_types_1_and_2_are_not_identical_2319", "Named property '{0}' of types '{1}' and '{2}' are not identical."),
        Interface_0_cannot_simultaneously_extend_types_1_and_2: diag(2320, ts3.DiagnosticCategory.Error, "Interface_0_cannot_simultaneously_extend_types_1_and_2_2320", "Interface '{0}' cannot simultaneously extend types '{1}' and '{2}'."),
        Excessive_stack_depth_comparing_types_0_and_1: diag(2321, ts3.DiagnosticCategory.Error, "Excessive_stack_depth_comparing_types_0_and_1_2321", "Excessive stack depth comparing types '{0}' and '{1}'."),
        Type_0_is_not_assignable_to_type_1: diag(2322, ts3.DiagnosticCategory.Error, "Type_0_is_not_assignable_to_type_1_2322", "Type '{0}' is not assignable to type '{1}'."),
        Cannot_redeclare_exported_variable_0: diag(2323, ts3.DiagnosticCategory.Error, "Cannot_redeclare_exported_variable_0_2323", "Cannot redeclare exported variable '{0}'."),
        Property_0_is_missing_in_type_1: diag(2324, ts3.DiagnosticCategory.Error, "Property_0_is_missing_in_type_1_2324", "Property '{0}' is missing in type '{1}'."),
        Property_0_is_private_in_type_1_but_not_in_type_2: diag(2325, ts3.DiagnosticCategory.Error, "Property_0_is_private_in_type_1_but_not_in_type_2_2325", "Property '{0}' is private in type '{1}' but not in type '{2}'."),
        Types_of_property_0_are_incompatible: diag(2326, ts3.DiagnosticCategory.Error, "Types_of_property_0_are_incompatible_2326", "Types of property '{0}' are incompatible."),
        Property_0_is_optional_in_type_1_but_required_in_type_2: diag(2327, ts3.DiagnosticCategory.Error, "Property_0_is_optional_in_type_1_but_required_in_type_2_2327", "Property '{0}' is optional in type '{1}' but required in type '{2}'."),
        Types_of_parameters_0_and_1_are_incompatible: diag(2328, ts3.DiagnosticCategory.Error, "Types_of_parameters_0_and_1_are_incompatible_2328", "Types of parameters '{0}' and '{1}' are incompatible."),
        Index_signature_is_missing_in_type_0: diag(2329, ts3.DiagnosticCategory.Error, "Index_signature_is_missing_in_type_0_2329", "Index signature is missing in type '{0}'."),
        Index_signatures_are_incompatible: diag(2330, ts3.DiagnosticCategory.Error, "Index_signatures_are_incompatible_2330", "Index signatures are incompatible."),
        this_cannot_be_referenced_in_a_module_or_namespace_body: diag(2331, ts3.DiagnosticCategory.Error, "this_cannot_be_referenced_in_a_module_or_namespace_body_2331", "'this' cannot be referenced in a module or namespace body."),
        this_cannot_be_referenced_in_current_location: diag(2332, ts3.DiagnosticCategory.Error, "this_cannot_be_referenced_in_current_location_2332", "'this' cannot be referenced in current location."),
        this_cannot_be_referenced_in_constructor_arguments: diag(2333, ts3.DiagnosticCategory.Error, "this_cannot_be_referenced_in_constructor_arguments_2333", "'this' cannot be referenced in constructor arguments."),
        this_cannot_be_referenced_in_a_static_property_initializer: diag(2334, ts3.DiagnosticCategory.Error, "this_cannot_be_referenced_in_a_static_property_initializer_2334", "'this' cannot be referenced in a static property initializer."),
        super_can_only_be_referenced_in_a_derived_class: diag(2335, ts3.DiagnosticCategory.Error, "super_can_only_be_referenced_in_a_derived_class_2335", "'super' can only be referenced in a derived class."),
        super_cannot_be_referenced_in_constructor_arguments: diag(2336, ts3.DiagnosticCategory.Error, "super_cannot_be_referenced_in_constructor_arguments_2336", "'super' cannot be referenced in constructor arguments."),
        Super_calls_are_not_permitted_outside_constructors_or_in_nested_functions_inside_constructors: diag(2337, ts3.DiagnosticCategory.Error, "Super_calls_are_not_permitted_outside_constructors_or_in_nested_functions_inside_constructors_2337", "Super calls are not permitted outside constructors or in nested functions inside constructors."),
        super_property_access_is_permitted_only_in_a_constructor_member_function_or_member_accessor_of_a_derived_class: diag(2338, ts3.DiagnosticCategory.Error, "super_property_access_is_permitted_only_in_a_constructor_member_function_or_member_accessor_of_a_der_2338", "'super' property access is permitted only in a constructor, member function, or member accessor of a derived class."),
        Property_0_does_not_exist_on_type_1: diag(2339, ts3.DiagnosticCategory.Error, "Property_0_does_not_exist_on_type_1_2339", "Property '{0}' does not exist on type '{1}'."),
        Only_public_and_protected_methods_of_the_base_class_are_accessible_via_the_super_keyword: diag(2340, ts3.DiagnosticCategory.Error, "Only_public_and_protected_methods_of_the_base_class_are_accessible_via_the_super_keyword_2340", "Only public and protected methods of the base class are accessible via the 'super' keyword."),
        Property_0_is_private_and_only_accessible_within_class_1: diag(2341, ts3.DiagnosticCategory.Error, "Property_0_is_private_and_only_accessible_within_class_1_2341", "Property '{0}' is private and only accessible within class '{1}'."),
        An_index_expression_argument_must_be_of_type_string_number_symbol_or_any: diag(2342, ts3.DiagnosticCategory.Error, "An_index_expression_argument_must_be_of_type_string_number_symbol_or_any_2342", "An index expression argument must be of type 'string', 'number', 'symbol', or 'any'."),
        This_syntax_requires_an_imported_helper_named_1_which_does_not_exist_in_0_Consider_upgrading_your_version_of_0: diag(2343, ts3.DiagnosticCategory.Error, "This_syntax_requires_an_imported_helper_named_1_which_does_not_exist_in_0_Consider_upgrading_your_ve_2343", "This syntax requires an imported helper named '{1}' which does not exist in '{0}'. Consider upgrading your version of '{0}'."),
        Type_0_does_not_satisfy_the_constraint_1: diag(2344, ts3.DiagnosticCategory.Error, "Type_0_does_not_satisfy_the_constraint_1_2344", "Type '{0}' does not satisfy the constraint '{1}'."),
        Argument_of_type_0_is_not_assignable_to_parameter_of_type_1: diag(2345, ts3.DiagnosticCategory.Error, "Argument_of_type_0_is_not_assignable_to_parameter_of_type_1_2345", "Argument of type '{0}' is not assignable to parameter of type '{1}'."),
        Call_target_does_not_contain_any_signatures: diag(2346, ts3.DiagnosticCategory.Error, "Call_target_does_not_contain_any_signatures_2346", "Call target does not contain any signatures."),
        Untyped_function_calls_may_not_accept_type_arguments: diag(2347, ts3.DiagnosticCategory.Error, "Untyped_function_calls_may_not_accept_type_arguments_2347", "Untyped function calls may not accept type arguments."),
        Value_of_type_0_is_not_callable_Did_you_mean_to_include_new: diag(2348, ts3.DiagnosticCategory.Error, "Value_of_type_0_is_not_callable_Did_you_mean_to_include_new_2348", "Value of type '{0}' is not callable. Did you mean to include 'new'?"),
        This_expression_is_not_callable: diag(2349, ts3.DiagnosticCategory.Error, "This_expression_is_not_callable_2349", "This expression is not callable."),
        Only_a_void_function_can_be_called_with_the_new_keyword: diag(2350, ts3.DiagnosticCategory.Error, "Only_a_void_function_can_be_called_with_the_new_keyword_2350", "Only a void function can be called with the 'new' keyword."),
        This_expression_is_not_constructable: diag(2351, ts3.DiagnosticCategory.Error, "This_expression_is_not_constructable_2351", "This expression is not constructable."),
        Conversion_of_type_0_to_type_1_may_be_a_mistake_because_neither_type_sufficiently_overlaps_with_the_other_If_this_was_intentional_convert_the_expression_to_unknown_first: diag(2352, ts3.DiagnosticCategory.Error, "Conversion_of_type_0_to_type_1_may_be_a_mistake_because_neither_type_sufficiently_overlaps_with_the__2352", "Conversion of type '{0}' to type '{1}' may be a mistake because neither type sufficiently overlaps with the other. If this was intentional, convert the expression to 'unknown' first."),
        Object_literal_may_only_specify_known_properties_and_0_does_not_exist_in_type_1: diag(2353, ts3.DiagnosticCategory.Error, "Object_literal_may_only_specify_known_properties_and_0_does_not_exist_in_type_1_2353", "Object literal may only specify known properties, and '{0}' does not exist in type '{1}'."),
        This_syntax_requires_an_imported_helper_but_module_0_cannot_be_found: diag(2354, ts3.DiagnosticCategory.Error, "This_syntax_requires_an_imported_helper_but_module_0_cannot_be_found_2354", "This syntax requires an imported helper but module '{0}' cannot be found."),
        A_function_whose_declared_type_is_neither_void_nor_any_must_return_a_value: diag(2355, ts3.DiagnosticCategory.Error, "A_function_whose_declared_type_is_neither_void_nor_any_must_return_a_value_2355", "A function whose declared type is neither 'void' nor 'any' must return a value."),
        An_arithmetic_operand_must_be_of_type_any_number_bigint_or_an_enum_type: diag(2356, ts3.DiagnosticCategory.Error, "An_arithmetic_operand_must_be_of_type_any_number_bigint_or_an_enum_type_2356", "An arithmetic operand must be of type 'any', 'number', 'bigint' or an enum type."),
        The_operand_of_an_increment_or_decrement_operator_must_be_a_variable_or_a_property_access: diag(2357, ts3.DiagnosticCategory.Error, "The_operand_of_an_increment_or_decrement_operator_must_be_a_variable_or_a_property_access_2357", "The operand of an increment or decrement operator must be a variable or a property access."),
        The_left_hand_side_of_an_instanceof_expression_must_be_of_type_any_an_object_type_or_a_type_parameter: diag(2358, ts3.DiagnosticCategory.Error, "The_left_hand_side_of_an_instanceof_expression_must_be_of_type_any_an_object_type_or_a_type_paramete_2358", "The left-hand side of an 'instanceof' expression must be of type 'any', an object type or a type parameter."),
        The_right_hand_side_of_an_instanceof_expression_must_be_of_type_any_or_of_a_type_assignable_to_the_Function_interface_type: diag(2359, ts3.DiagnosticCategory.Error, "The_right_hand_side_of_an_instanceof_expression_must_be_of_type_any_or_of_a_type_assignable_to_the_F_2359", "The right-hand side of an 'instanceof' expression must be of type 'any' or of a type assignable to the 'Function' interface type."),
        The_left_hand_side_of_an_in_expression_must_be_of_type_any_string_number_or_symbol: diag(2360, ts3.DiagnosticCategory.Error, "The_left_hand_side_of_an_in_expression_must_be_of_type_any_string_number_or_symbol_2360", "The left-hand side of an 'in' expression must be of type 'any', 'string', 'number', or 'symbol'."),
        The_right_hand_side_of_an_in_expression_must_not_be_a_primitive: diag(2361, ts3.DiagnosticCategory.Error, "The_right_hand_side_of_an_in_expression_must_not_be_a_primitive_2361", "The right-hand side of an 'in' expression must not be a primitive."),
        The_left_hand_side_of_an_arithmetic_operation_must_be_of_type_any_number_bigint_or_an_enum_type: diag(2362, ts3.DiagnosticCategory.Error, "The_left_hand_side_of_an_arithmetic_operation_must_be_of_type_any_number_bigint_or_an_enum_type_2362", "The left-hand side of an arithmetic operation must be of type 'any', 'number', 'bigint' or an enum type."),
        The_right_hand_side_of_an_arithmetic_operation_must_be_of_type_any_number_bigint_or_an_enum_type: diag(2363, ts3.DiagnosticCategory.Error, "The_right_hand_side_of_an_arithmetic_operation_must_be_of_type_any_number_bigint_or_an_enum_type_2363", "The right-hand side of an arithmetic operation must be of type 'any', 'number', 'bigint' or an enum type."),
        The_left_hand_side_of_an_assignment_expression_must_be_a_variable_or_a_property_access: diag(2364, ts3.DiagnosticCategory.Error, "The_left_hand_side_of_an_assignment_expression_must_be_a_variable_or_a_property_access_2364", "The left-hand side of an assignment expression must be a variable or a property access."),
        Operator_0_cannot_be_applied_to_types_1_and_2: diag(2365, ts3.DiagnosticCategory.Error, "Operator_0_cannot_be_applied_to_types_1_and_2_2365", "Operator '{0}' cannot be applied to types '{1}' and '{2}'."),
        Function_lacks_ending_return_statement_and_return_type_does_not_include_undefined: diag(2366, ts3.DiagnosticCategory.Error, "Function_lacks_ending_return_statement_and_return_type_does_not_include_undefined_2366", "Function lacks ending return statement and return type does not include 'undefined'."),
        This_condition_will_always_return_0_since_the_types_1_and_2_have_no_overlap: diag(2367, ts3.DiagnosticCategory.Error, "This_condition_will_always_return_0_since_the_types_1_and_2_have_no_overlap_2367", "This condition will always return '{0}' since the types '{1}' and '{2}' have no overlap."),
        Type_parameter_name_cannot_be_0: diag(2368, ts3.DiagnosticCategory.Error, "Type_parameter_name_cannot_be_0_2368", "Type parameter name cannot be '{0}'."),
        A_parameter_property_is_only_allowed_in_a_constructor_implementation: diag(2369, ts3.DiagnosticCategory.Error, "A_parameter_property_is_only_allowed_in_a_constructor_implementation_2369", "A parameter property is only allowed in a constructor implementation."),
        A_rest_parameter_must_be_of_an_array_type: diag(2370, ts3.DiagnosticCategory.Error, "A_rest_parameter_must_be_of_an_array_type_2370", "A rest parameter must be of an array type."),
        A_parameter_initializer_is_only_allowed_in_a_function_or_constructor_implementation: diag(2371, ts3.DiagnosticCategory.Error, "A_parameter_initializer_is_only_allowed_in_a_function_or_constructor_implementation_2371", "A parameter initializer is only allowed in a function or constructor implementation."),
        Parameter_0_cannot_reference_itself: diag(2372, ts3.DiagnosticCategory.Error, "Parameter_0_cannot_reference_itself_2372", "Parameter '{0}' cannot reference itself."),
        Parameter_0_cannot_reference_identifier_1_declared_after_it: diag(2373, ts3.DiagnosticCategory.Error, "Parameter_0_cannot_reference_identifier_1_declared_after_it_2373", "Parameter '{0}' cannot reference identifier '{1}' declared after it."),
        Duplicate_string_index_signature: diag(2374, ts3.DiagnosticCategory.Error, "Duplicate_string_index_signature_2374", "Duplicate string index signature."),
        Duplicate_number_index_signature: diag(2375, ts3.DiagnosticCategory.Error, "Duplicate_number_index_signature_2375", "Duplicate number index signature."),
        A_super_call_must_be_the_first_statement_in_the_constructor_when_a_class_contains_initialized_properties_parameter_properties_or_private_identifiers: diag(2376, ts3.DiagnosticCategory.Error, "A_super_call_must_be_the_first_statement_in_the_constructor_when_a_class_contains_initialized_proper_2376", "A 'super' call must be the first statement in the constructor when a class contains initialized properties, parameter properties, or private identifiers."),
        Constructors_for_derived_classes_must_contain_a_super_call: diag(2377, ts3.DiagnosticCategory.Error, "Constructors_for_derived_classes_must_contain_a_super_call_2377", "Constructors for derived classes must contain a 'super' call."),
        A_get_accessor_must_return_a_value: diag(2378, ts3.DiagnosticCategory.Error, "A_get_accessor_must_return_a_value_2378", "A 'get' accessor must return a value."),
        The_return_type_of_a_get_accessor_must_be_assignable_to_its_set_accessor_type: diag(2380, ts3.DiagnosticCategory.Error, "The_return_type_of_a_get_accessor_must_be_assignable_to_its_set_accessor_type_2380", "The return type of a 'get' accessor must be assignable to its 'set' accessor type"),
        A_signature_with_an_implementation_cannot_use_a_string_literal_type: diag(2381, ts3.DiagnosticCategory.Error, "A_signature_with_an_implementation_cannot_use_a_string_literal_type_2381", "A signature with an implementation cannot use a string literal type."),
        Specialized_overload_signature_is_not_assignable_to_any_non_specialized_signature: diag(2382, ts3.DiagnosticCategory.Error, "Specialized_overload_signature_is_not_assignable_to_any_non_specialized_signature_2382", "Specialized overload signature is not assignable to any non-specialized signature."),
        Overload_signatures_must_all_be_exported_or_non_exported: diag(2383, ts3.DiagnosticCategory.Error, "Overload_signatures_must_all_be_exported_or_non_exported_2383", "Overload signatures must all be exported or non-exported."),
        Overload_signatures_must_all_be_ambient_or_non_ambient: diag(2384, ts3.DiagnosticCategory.Error, "Overload_signatures_must_all_be_ambient_or_non_ambient_2384", "Overload signatures must all be ambient or non-ambient."),
        Overload_signatures_must_all_be_public_private_or_protected: diag(2385, ts3.DiagnosticCategory.Error, "Overload_signatures_must_all_be_public_private_or_protected_2385", "Overload signatures must all be public, private or protected."),
        Overload_signatures_must_all_be_optional_or_required: diag(2386, ts3.DiagnosticCategory.Error, "Overload_signatures_must_all_be_optional_or_required_2386", "Overload signatures must all be optional or required."),
        Function_overload_must_be_static: diag(2387, ts3.DiagnosticCategory.Error, "Function_overload_must_be_static_2387", "Function overload must be static."),
        Function_overload_must_not_be_static: diag(2388, ts3.DiagnosticCategory.Error, "Function_overload_must_not_be_static_2388", "Function overload must not be static."),
        Function_implementation_name_must_be_0: diag(2389, ts3.DiagnosticCategory.Error, "Function_implementation_name_must_be_0_2389", "Function implementation name must be '{0}'."),
        Constructor_implementation_is_missing: diag(2390, ts3.DiagnosticCategory.Error, "Constructor_implementation_is_missing_2390", "Constructor implementation is missing."),
        Function_implementation_is_missing_or_not_immediately_following_the_declaration: diag(2391, ts3.DiagnosticCategory.Error, "Function_implementation_is_missing_or_not_immediately_following_the_declaration_2391", "Function implementation is missing or not immediately following the declaration."),
        Multiple_constructor_implementations_are_not_allowed: diag(2392, ts3.DiagnosticCategory.Error, "Multiple_constructor_implementations_are_not_allowed_2392", "Multiple constructor implementations are not allowed."),
        Duplicate_function_implementation: diag(2393, ts3.DiagnosticCategory.Error, "Duplicate_function_implementation_2393", "Duplicate function implementation."),
        This_overload_signature_is_not_compatible_with_its_implementation_signature: diag(2394, ts3.DiagnosticCategory.Error, "This_overload_signature_is_not_compatible_with_its_implementation_signature_2394", "This overload signature is not compatible with its implementation signature."),
        Individual_declarations_in_merged_declaration_0_must_be_all_exported_or_all_local: diag(2395, ts3.DiagnosticCategory.Error, "Individual_declarations_in_merged_declaration_0_must_be_all_exported_or_all_local_2395", "Individual declarations in merged declaration '{0}' must be all exported or all local."),
        Duplicate_identifier_arguments_Compiler_uses_arguments_to_initialize_rest_parameters: diag(2396, ts3.DiagnosticCategory.Error, "Duplicate_identifier_arguments_Compiler_uses_arguments_to_initialize_rest_parameters_2396", "Duplicate identifier 'arguments'. Compiler uses 'arguments' to initialize rest parameters."),
        Declaration_name_conflicts_with_built_in_global_identifier_0: diag(2397, ts3.DiagnosticCategory.Error, "Declaration_name_conflicts_with_built_in_global_identifier_0_2397", "Declaration name conflicts with built-in global identifier '{0}'."),
        constructor_cannot_be_used_as_a_parameter_property_name: diag(2398, ts3.DiagnosticCategory.Error, "constructor_cannot_be_used_as_a_parameter_property_name_2398", "'constructor' cannot be used as a parameter property name."),
        Duplicate_identifier_this_Compiler_uses_variable_declaration_this_to_capture_this_reference: diag(2399, ts3.DiagnosticCategory.Error, "Duplicate_identifier_this_Compiler_uses_variable_declaration_this_to_capture_this_reference_2399", "Duplicate identifier '_this'. Compiler uses variable declaration '_this' to capture 'this' reference."),
        Expression_resolves_to_variable_declaration_this_that_compiler_uses_to_capture_this_reference: diag(2400, ts3.DiagnosticCategory.Error, "Expression_resolves_to_variable_declaration_this_that_compiler_uses_to_capture_this_reference_2400", "Expression resolves to variable declaration '_this' that compiler uses to capture 'this' reference."),
        Duplicate_identifier_super_Compiler_uses_super_to_capture_base_class_reference: diag(2401, ts3.DiagnosticCategory.Error, "Duplicate_identifier_super_Compiler_uses_super_to_capture_base_class_reference_2401", "Duplicate identifier '_super'. Compiler uses '_super' to capture base class reference."),
        Expression_resolves_to_super_that_compiler_uses_to_capture_base_class_reference: diag(2402, ts3.DiagnosticCategory.Error, "Expression_resolves_to_super_that_compiler_uses_to_capture_base_class_reference_2402", "Expression resolves to '_super' that compiler uses to capture base class reference."),
        Subsequent_variable_declarations_must_have_the_same_type_Variable_0_must_be_of_type_1_but_here_has_type_2: diag(2403, ts3.DiagnosticCategory.Error, "Subsequent_variable_declarations_must_have_the_same_type_Variable_0_must_be_of_type_1_but_here_has_t_2403", "Subsequent variable declarations must have the same type.  Variable '{0}' must be of type '{1}', but here has type '{2}'."),
        The_left_hand_side_of_a_for_in_statement_cannot_use_a_type_annotation: diag(2404, ts3.DiagnosticCategory.Error, "The_left_hand_side_of_a_for_in_statement_cannot_use_a_type_annotation_2404", "The left-hand side of a 'for...in' statement cannot use a type annotation."),
        The_left_hand_side_of_a_for_in_statement_must_be_of_type_string_or_any: diag(2405, ts3.DiagnosticCategory.Error, "The_left_hand_side_of_a_for_in_statement_must_be_of_type_string_or_any_2405", "The left-hand side of a 'for...in' statement must be of type 'string' or 'any'."),
        The_left_hand_side_of_a_for_in_statement_must_be_a_variable_or_a_property_access: diag(2406, ts3.DiagnosticCategory.Error, "The_left_hand_side_of_a_for_in_statement_must_be_a_variable_or_a_property_access_2406", "The left-hand side of a 'for...in' statement must be a variable or a property access."),
        The_right_hand_side_of_a_for_in_statement_must_be_of_type_any_an_object_type_or_a_type_parameter_but_here_has_type_0: diag(2407, ts3.DiagnosticCategory.Error, "The_right_hand_side_of_a_for_in_statement_must_be_of_type_any_an_object_type_or_a_type_parameter_but_2407", "The right-hand side of a 'for...in' statement must be of type 'any', an object type or a type parameter, but here has type '{0}'."),
        Setters_cannot_return_a_value: diag(2408, ts3.DiagnosticCategory.Error, "Setters_cannot_return_a_value_2408", "Setters cannot return a value."),
        Return_type_of_constructor_signature_must_be_assignable_to_the_instance_type_of_the_class: diag(2409, ts3.DiagnosticCategory.Error, "Return_type_of_constructor_signature_must_be_assignable_to_the_instance_type_of_the_class_2409", "Return type of constructor signature must be assignable to the instance type of the class."),
        The_with_statement_is_not_supported_All_symbols_in_a_with_block_will_have_type_any: diag(2410, ts3.DiagnosticCategory.Error, "The_with_statement_is_not_supported_All_symbols_in_a_with_block_will_have_type_any_2410", "The 'with' statement is not supported. All symbols in a 'with' block will have type 'any'."),
        Property_0_of_type_1_is_not_assignable_to_string_index_type_2: diag(2411, ts3.DiagnosticCategory.Error, "Property_0_of_type_1_is_not_assignable_to_string_index_type_2_2411", "Property '{0}' of type '{1}' is not assignable to string index type '{2}'."),
        Property_0_of_type_1_is_not_assignable_to_numeric_index_type_2: diag(2412, ts3.DiagnosticCategory.Error, "Property_0_of_type_1_is_not_assignable_to_numeric_index_type_2_2412", "Property '{0}' of type '{1}' is not assignable to numeric index type '{2}'."),
        Numeric_index_type_0_is_not_assignable_to_string_index_type_1: diag(2413, ts3.DiagnosticCategory.Error, "Numeric_index_type_0_is_not_assignable_to_string_index_type_1_2413", "Numeric index type '{0}' is not assignable to string index type '{1}'."),
        Class_name_cannot_be_0: diag(2414, ts3.DiagnosticCategory.Error, "Class_name_cannot_be_0_2414", "Class name cannot be '{0}'."),
        Class_0_incorrectly_extends_base_class_1: diag(2415, ts3.DiagnosticCategory.Error, "Class_0_incorrectly_extends_base_class_1_2415", "Class '{0}' incorrectly extends base class '{1}'."),
        Property_0_in_type_1_is_not_assignable_to_the_same_property_in_base_type_2: diag(2416, ts3.DiagnosticCategory.Error, "Property_0_in_type_1_is_not_assignable_to_the_same_property_in_base_type_2_2416", "Property '{0}' in type '{1}' is not assignable to the same property in base type '{2}'."),
        Class_static_side_0_incorrectly_extends_base_class_static_side_1: diag(2417, ts3.DiagnosticCategory.Error, "Class_static_side_0_incorrectly_extends_base_class_static_side_1_2417", "Class static side '{0}' incorrectly extends base class static side '{1}'."),
        Type_of_computed_property_s_value_is_0_which_is_not_assignable_to_type_1: diag(2418, ts3.DiagnosticCategory.Error, "Type_of_computed_property_s_value_is_0_which_is_not_assignable_to_type_1_2418", "Type of computed property's value is '{0}', which is not assignable to type '{1}'."),
        Types_of_construct_signatures_are_incompatible: diag(2419, ts3.DiagnosticCategory.Error, "Types_of_construct_signatures_are_incompatible_2419", "Types of construct signatures are incompatible."),
        Class_0_incorrectly_implements_interface_1: diag(2420, ts3.DiagnosticCategory.Error, "Class_0_incorrectly_implements_interface_1_2420", "Class '{0}' incorrectly implements interface '{1}'."),
        A_class_can_only_implement_an_object_type_or_intersection_of_object_types_with_statically_known_members: diag(2422, ts3.DiagnosticCategory.Error, "A_class_can_only_implement_an_object_type_or_intersection_of_object_types_with_statically_known_memb_2422", "A class can only implement an object type or intersection of object types with statically known members."),
        Class_0_defines_instance_member_function_1_but_extended_class_2_defines_it_as_instance_member_accessor: diag(2423, ts3.DiagnosticCategory.Error, "Class_0_defines_instance_member_function_1_but_extended_class_2_defines_it_as_instance_member_access_2423", "Class '{0}' defines instance member function '{1}', but extended class '{2}' defines it as instance member accessor."),
        Class_0_defines_instance_member_property_1_but_extended_class_2_defines_it_as_instance_member_function: diag(2425, ts3.DiagnosticCategory.Error, "Class_0_defines_instance_member_property_1_but_extended_class_2_defines_it_as_instance_member_functi_2425", "Class '{0}' defines instance member property '{1}', but extended class '{2}' defines it as instance member function."),
        Class_0_defines_instance_member_accessor_1_but_extended_class_2_defines_it_as_instance_member_function: diag(2426, ts3.DiagnosticCategory.Error, "Class_0_defines_instance_member_accessor_1_but_extended_class_2_defines_it_as_instance_member_functi_2426", "Class '{0}' defines instance member accessor '{1}', but extended class '{2}' defines it as instance member function."),
        Interface_name_cannot_be_0: diag(2427, ts3.DiagnosticCategory.Error, "Interface_name_cannot_be_0_2427", "Interface name cannot be '{0}'."),
        All_declarations_of_0_must_have_identical_type_parameters: diag(2428, ts3.DiagnosticCategory.Error, "All_declarations_of_0_must_have_identical_type_parameters_2428", "All declarations of '{0}' must have identical type parameters."),
        Interface_0_incorrectly_extends_interface_1: diag(2430, ts3.DiagnosticCategory.Error, "Interface_0_incorrectly_extends_interface_1_2430", "Interface '{0}' incorrectly extends interface '{1}'."),
        Enum_name_cannot_be_0: diag(2431, ts3.DiagnosticCategory.Error, "Enum_name_cannot_be_0_2431", "Enum name cannot be '{0}'."),
        In_an_enum_with_multiple_declarations_only_one_declaration_can_omit_an_initializer_for_its_first_enum_element: diag(2432, ts3.DiagnosticCategory.Error, "In_an_enum_with_multiple_declarations_only_one_declaration_can_omit_an_initializer_for_its_first_enu_2432", "In an enum with multiple declarations, only one declaration can omit an initializer for its first enum element."),
        A_namespace_declaration_cannot_be_in_a_different_file_from_a_class_or_function_with_which_it_is_merged: diag(2433, ts3.DiagnosticCategory.Error, "A_namespace_declaration_cannot_be_in_a_different_file_from_a_class_or_function_with_which_it_is_merg_2433", "A namespace declaration cannot be in a different file from a class or function with which it is merged."),
        A_namespace_declaration_cannot_be_located_prior_to_a_class_or_function_with_which_it_is_merged: diag(2434, ts3.DiagnosticCategory.Error, "A_namespace_declaration_cannot_be_located_prior_to_a_class_or_function_with_which_it_is_merged_2434", "A namespace declaration cannot be located prior to a class or function with which it is merged."),
        Ambient_modules_cannot_be_nested_in_other_modules_or_namespaces: diag(2435, ts3.DiagnosticCategory.Error, "Ambient_modules_cannot_be_nested_in_other_modules_or_namespaces_2435", "Ambient modules cannot be nested in other modules or namespaces."),
        Ambient_module_declaration_cannot_specify_relative_module_name: diag(2436, ts3.DiagnosticCategory.Error, "Ambient_module_declaration_cannot_specify_relative_module_name_2436", "Ambient module declaration cannot specify relative module name."),
        Module_0_is_hidden_by_a_local_declaration_with_the_same_name: diag(2437, ts3.DiagnosticCategory.Error, "Module_0_is_hidden_by_a_local_declaration_with_the_same_name_2437", "Module '{0}' is hidden by a local declaration with the same name."),
        Import_name_cannot_be_0: diag(2438, ts3.DiagnosticCategory.Error, "Import_name_cannot_be_0_2438", "Import name cannot be '{0}'."),
        Import_or_export_declaration_in_an_ambient_module_declaration_cannot_reference_module_through_relative_module_name: diag(2439, ts3.DiagnosticCategory.Error, "Import_or_export_declaration_in_an_ambient_module_declaration_cannot_reference_module_through_relati_2439", "Import or export declaration in an ambient module declaration cannot reference module through relative module name."),
        Import_declaration_conflicts_with_local_declaration_of_0: diag(2440, ts3.DiagnosticCategory.Error, "Import_declaration_conflicts_with_local_declaration_of_0_2440", "Import declaration conflicts with local declaration of '{0}'."),
        Duplicate_identifier_0_Compiler_reserves_name_1_in_top_level_scope_of_a_module: diag(2441, ts3.DiagnosticCategory.Error, "Duplicate_identifier_0_Compiler_reserves_name_1_in_top_level_scope_of_a_module_2441", "Duplicate identifier '{0}'. Compiler reserves name '{1}' in top level scope of a module."),
        Types_have_separate_declarations_of_a_private_property_0: diag(2442, ts3.DiagnosticCategory.Error, "Types_have_separate_declarations_of_a_private_property_0_2442", "Types have separate declarations of a private property '{0}'."),
        Property_0_is_protected_but_type_1_is_not_a_class_derived_from_2: diag(2443, ts3.DiagnosticCategory.Error, "Property_0_is_protected_but_type_1_is_not_a_class_derived_from_2_2443", "Property '{0}' is protected but type '{1}' is not a class derived from '{2}'."),
        Property_0_is_protected_in_type_1_but_public_in_type_2: diag(2444, ts3.DiagnosticCategory.Error, "Property_0_is_protected_in_type_1_but_public_in_type_2_2444", "Property '{0}' is protected in type '{1}' but public in type '{2}'."),
        Property_0_is_protected_and_only_accessible_within_class_1_and_its_subclasses: diag(2445, ts3.DiagnosticCategory.Error, "Property_0_is_protected_and_only_accessible_within_class_1_and_its_subclasses_2445", "Property '{0}' is protected and only accessible within class '{1}' and its subclasses."),
        Property_0_is_protected_and_only_accessible_through_an_instance_of_class_1_This_is_an_instance_of_class_2: diag(2446, ts3.DiagnosticCategory.Error, "Property_0_is_protected_and_only_accessible_through_an_instance_of_class_1_This_is_an_instance_of_cl_2446", "Property '{0}' is protected and only accessible through an instance of class '{1}'. This is an instance of class '{2}'."),
        The_0_operator_is_not_allowed_for_boolean_types_Consider_using_1_instead: diag(2447, ts3.DiagnosticCategory.Error, "The_0_operator_is_not_allowed_for_boolean_types_Consider_using_1_instead_2447", "The '{0}' operator is not allowed for boolean types. Consider using '{1}' instead."),
        Block_scoped_variable_0_used_before_its_declaration: diag(2448, ts3.DiagnosticCategory.Error, "Block_scoped_variable_0_used_before_its_declaration_2448", "Block-scoped variable '{0}' used before its declaration."),
        Class_0_used_before_its_declaration: diag(2449, ts3.DiagnosticCategory.Error, "Class_0_used_before_its_declaration_2449", "Class '{0}' used before its declaration."),
        Enum_0_used_before_its_declaration: diag(2450, ts3.DiagnosticCategory.Error, "Enum_0_used_before_its_declaration_2450", "Enum '{0}' used before its declaration."),
        Cannot_redeclare_block_scoped_variable_0: diag(2451, ts3.DiagnosticCategory.Error, "Cannot_redeclare_block_scoped_variable_0_2451", "Cannot redeclare block-scoped variable '{0}'."),
        An_enum_member_cannot_have_a_numeric_name: diag(2452, ts3.DiagnosticCategory.Error, "An_enum_member_cannot_have_a_numeric_name_2452", "An enum member cannot have a numeric name."),
        The_type_argument_for_type_parameter_0_cannot_be_inferred_from_the_usage_Consider_specifying_the_type_arguments_explicitly: diag(2453, ts3.DiagnosticCategory.Error, "The_type_argument_for_type_parameter_0_cannot_be_inferred_from_the_usage_Consider_specifying_the_typ_2453", "The type argument for type parameter '{0}' cannot be inferred from the usage. Consider specifying the type arguments explicitly."),
        Variable_0_is_used_before_being_assigned: diag(2454, ts3.DiagnosticCategory.Error, "Variable_0_is_used_before_being_assigned_2454", "Variable '{0}' is used before being assigned."),
        Type_argument_candidate_1_is_not_a_valid_type_argument_because_it_is_not_a_supertype_of_candidate_0: diag(2455, ts3.DiagnosticCategory.Error, "Type_argument_candidate_1_is_not_a_valid_type_argument_because_it_is_not_a_supertype_of_candidate_0_2455", "Type argument candidate '{1}' is not a valid type argument because it is not a supertype of candidate '{0}'."),
        Type_alias_0_circularly_references_itself: diag(2456, ts3.DiagnosticCategory.Error, "Type_alias_0_circularly_references_itself_2456", "Type alias '{0}' circularly references itself."),
        Type_alias_name_cannot_be_0: diag(2457, ts3.DiagnosticCategory.Error, "Type_alias_name_cannot_be_0_2457", "Type alias name cannot be '{0}'."),
        An_AMD_module_cannot_have_multiple_name_assignments: diag(2458, ts3.DiagnosticCategory.Error, "An_AMD_module_cannot_have_multiple_name_assignments_2458", "An AMD module cannot have multiple name assignments."),
        Module_0_declares_1_locally_but_it_is_not_exported: diag(2459, ts3.DiagnosticCategory.Error, "Module_0_declares_1_locally_but_it_is_not_exported_2459", "Module '{0}' declares '{1}' locally, but it is not exported."),
        Module_0_declares_1_locally_but_it_is_exported_as_2: diag(2460, ts3.DiagnosticCategory.Error, "Module_0_declares_1_locally_but_it_is_exported_as_2_2460", "Module '{0}' declares '{1}' locally, but it is exported as '{2}'."),
        Type_0_is_not_an_array_type: diag(2461, ts3.DiagnosticCategory.Error, "Type_0_is_not_an_array_type_2461", "Type '{0}' is not an array type."),
        A_rest_element_must_be_last_in_a_destructuring_pattern: diag(2462, ts3.DiagnosticCategory.Error, "A_rest_element_must_be_last_in_a_destructuring_pattern_2462", "A rest element must be last in a destructuring pattern."),
        A_binding_pattern_parameter_cannot_be_optional_in_an_implementation_signature: diag(2463, ts3.DiagnosticCategory.Error, "A_binding_pattern_parameter_cannot_be_optional_in_an_implementation_signature_2463", "A binding pattern parameter cannot be optional in an implementation signature."),
        A_computed_property_name_must_be_of_type_string_number_symbol_or_any: diag(2464, ts3.DiagnosticCategory.Error, "A_computed_property_name_must_be_of_type_string_number_symbol_or_any_2464", "A computed property name must be of type 'string', 'number', 'symbol', or 'any'."),
        this_cannot_be_referenced_in_a_computed_property_name: diag(2465, ts3.DiagnosticCategory.Error, "this_cannot_be_referenced_in_a_computed_property_name_2465", "'this' cannot be referenced in a computed property name."),
        super_cannot_be_referenced_in_a_computed_property_name: diag(2466, ts3.DiagnosticCategory.Error, "super_cannot_be_referenced_in_a_computed_property_name_2466", "'super' cannot be referenced in a computed property name."),
        A_computed_property_name_cannot_reference_a_type_parameter_from_its_containing_type: diag(2467, ts3.DiagnosticCategory.Error, "A_computed_property_name_cannot_reference_a_type_parameter_from_its_containing_type_2467", "A computed property name cannot reference a type parameter from its containing type."),
        Cannot_find_global_value_0: diag(2468, ts3.DiagnosticCategory.Error, "Cannot_find_global_value_0_2468", "Cannot find global value '{0}'."),
        The_0_operator_cannot_be_applied_to_type_symbol: diag(2469, ts3.DiagnosticCategory.Error, "The_0_operator_cannot_be_applied_to_type_symbol_2469", "The '{0}' operator cannot be applied to type 'symbol'."),
        Symbol_reference_does_not_refer_to_the_global_Symbol_constructor_object: diag(2470, ts3.DiagnosticCategory.Error, "Symbol_reference_does_not_refer_to_the_global_Symbol_constructor_object_2470", "'Symbol' reference does not refer to the global Symbol constructor object."),
        A_computed_property_name_of_the_form_0_must_be_of_type_symbol: diag(2471, ts3.DiagnosticCategory.Error, "A_computed_property_name_of_the_form_0_must_be_of_type_symbol_2471", "A computed property name of the form '{0}' must be of type 'symbol'."),
        Spread_operator_in_new_expressions_is_only_available_when_targeting_ECMAScript_5_and_higher: diag(2472, ts3.DiagnosticCategory.Error, "Spread_operator_in_new_expressions_is_only_available_when_targeting_ECMAScript_5_and_higher_2472", "Spread operator in 'new' expressions is only available when targeting ECMAScript 5 and higher."),
        Enum_declarations_must_all_be_const_or_non_const: diag(2473, ts3.DiagnosticCategory.Error, "Enum_declarations_must_all_be_const_or_non_const_2473", "Enum declarations must all be const or non-const."),
        const_enum_member_initializers_can_only_contain_literal_values_and_other_computed_enum_values: diag(2474, ts3.DiagnosticCategory.Error, "const_enum_member_initializers_can_only_contain_literal_values_and_other_computed_enum_values_2474", "const enum member initializers can only contain literal values and other computed enum values."),
        const_enums_can_only_be_used_in_property_or_index_access_expressions_or_the_right_hand_side_of_an_import_declaration_or_export_assignment_or_type_query: diag(2475, ts3.DiagnosticCategory.Error, "const_enums_can_only_be_used_in_property_or_index_access_expressions_or_the_right_hand_side_of_an_im_2475", "'const' enums can only be used in property or index access expressions or the right hand side of an import declaration or export assignment or type query."),
        A_const_enum_member_can_only_be_accessed_using_a_string_literal: diag(2476, ts3.DiagnosticCategory.Error, "A_const_enum_member_can_only_be_accessed_using_a_string_literal_2476", "A const enum member can only be accessed using a string literal."),
        const_enum_member_initializer_was_evaluated_to_a_non_finite_value: diag(2477, ts3.DiagnosticCategory.Error, "const_enum_member_initializer_was_evaluated_to_a_non_finite_value_2477", "'const' enum member initializer was evaluated to a non-finite value."),
        const_enum_member_initializer_was_evaluated_to_disallowed_value_NaN: diag(2478, ts3.DiagnosticCategory.Error, "const_enum_member_initializer_was_evaluated_to_disallowed_value_NaN_2478", "'const' enum member initializer was evaluated to disallowed value 'NaN'."),
        Property_0_does_not_exist_on_const_enum_1: diag(2479, ts3.DiagnosticCategory.Error, "Property_0_does_not_exist_on_const_enum_1_2479", "Property '{0}' does not exist on 'const' enum '{1}'."),
        let_is_not_allowed_to_be_used_as_a_name_in_let_or_const_declarations: diag(2480, ts3.DiagnosticCategory.Error, "let_is_not_allowed_to_be_used_as_a_name_in_let_or_const_declarations_2480", "'let' is not allowed to be used as a name in 'let' or 'const' declarations."),
        Cannot_initialize_outer_scoped_variable_0_in_the_same_scope_as_block_scoped_declaration_1: diag(2481, ts3.DiagnosticCategory.Error, "Cannot_initialize_outer_scoped_variable_0_in_the_same_scope_as_block_scoped_declaration_1_2481", "Cannot initialize outer scoped variable '{0}' in the same scope as block scoped declaration '{1}'."),
        The_left_hand_side_of_a_for_of_statement_cannot_use_a_type_annotation: diag(2483, ts3.DiagnosticCategory.Error, "The_left_hand_side_of_a_for_of_statement_cannot_use_a_type_annotation_2483", "The left-hand side of a 'for...of' statement cannot use a type annotation."),
        Export_declaration_conflicts_with_exported_declaration_of_0: diag(2484, ts3.DiagnosticCategory.Error, "Export_declaration_conflicts_with_exported_declaration_of_0_2484", "Export declaration conflicts with exported declaration of '{0}'."),
        The_left_hand_side_of_a_for_of_statement_must_be_a_variable_or_a_property_access: diag(2487, ts3.DiagnosticCategory.Error, "The_left_hand_side_of_a_for_of_statement_must_be_a_variable_or_a_property_access_2487", "The left-hand side of a 'for...of' statement must be a variable or a property access."),
        Type_0_must_have_a_Symbol_iterator_method_that_returns_an_iterator: diag(2488, ts3.DiagnosticCategory.Error, "Type_0_must_have_a_Symbol_iterator_method_that_returns_an_iterator_2488", "Type '{0}' must have a '[Symbol.iterator]()' method that returns an iterator."),
        An_iterator_must_have_a_next_method: diag(2489, ts3.DiagnosticCategory.Error, "An_iterator_must_have_a_next_method_2489", "An iterator must have a 'next()' method."),
        The_type_returned_by_the_0_method_of_an_iterator_must_have_a_value_property: diag(2490, ts3.DiagnosticCategory.Error, "The_type_returned_by_the_0_method_of_an_iterator_must_have_a_value_property_2490", "The type returned by the '{0}()' method of an iterator must have a 'value' property."),
        The_left_hand_side_of_a_for_in_statement_cannot_be_a_destructuring_pattern: diag(2491, ts3.DiagnosticCategory.Error, "The_left_hand_side_of_a_for_in_statement_cannot_be_a_destructuring_pattern_2491", "The left-hand side of a 'for...in' statement cannot be a destructuring pattern."),
        Cannot_redeclare_identifier_0_in_catch_clause: diag(2492, ts3.DiagnosticCategory.Error, "Cannot_redeclare_identifier_0_in_catch_clause_2492", "Cannot redeclare identifier '{0}' in catch clause."),
        Tuple_type_0_of_length_1_has_no_element_at_index_2: diag(2493, ts3.DiagnosticCategory.Error, "Tuple_type_0_of_length_1_has_no_element_at_index_2_2493", "Tuple type '{0}' of length '{1}' has no element at index '{2}'."),
        Using_a_string_in_a_for_of_statement_is_only_supported_in_ECMAScript_5_and_higher: diag(2494, ts3.DiagnosticCategory.Error, "Using_a_string_in_a_for_of_statement_is_only_supported_in_ECMAScript_5_and_higher_2494", "Using a string in a 'for...of' statement is only supported in ECMAScript 5 and higher."),
        Type_0_is_not_an_array_type_or_a_string_type: diag(2495, ts3.DiagnosticCategory.Error, "Type_0_is_not_an_array_type_or_a_string_type_2495", "Type '{0}' is not an array type or a string type."),
        The_arguments_object_cannot_be_referenced_in_an_arrow_function_in_ES3_and_ES5_Consider_using_a_standard_function_expression: diag(2496, ts3.DiagnosticCategory.Error, "The_arguments_object_cannot_be_referenced_in_an_arrow_function_in_ES3_and_ES5_Consider_using_a_stand_2496", "The 'arguments' object cannot be referenced in an arrow function in ES3 and ES5. Consider using a standard function expression."),
        This_module_can_only_be_referenced_with_ECMAScript_imports_Slashexports_by_turning_on_the_0_flag_and_referencing_its_default_export: diag(2497, ts3.DiagnosticCategory.Error, "This_module_can_only_be_referenced_with_ECMAScript_imports_Slashexports_by_turning_on_the_0_flag_and_2497", "This module can only be referenced with ECMAScript imports/exports by turning on the '{0}' flag and referencing its default export."),
        Module_0_uses_export_and_cannot_be_used_with_export_Asterisk: diag(2498, ts3.DiagnosticCategory.Error, "Module_0_uses_export_and_cannot_be_used_with_export_Asterisk_2498", "Module '{0}' uses 'export =' and cannot be used with 'export *'."),
        An_interface_can_only_extend_an_identifier_Slashqualified_name_with_optional_type_arguments: diag(2499, ts3.DiagnosticCategory.Error, "An_interface_can_only_extend_an_identifier_Slashqualified_name_with_optional_type_arguments_2499", "An interface can only extend an identifier/qualified-name with optional type arguments."),
        A_class_can_only_implement_an_identifier_Slashqualified_name_with_optional_type_arguments: diag(2500, ts3.DiagnosticCategory.Error, "A_class_can_only_implement_an_identifier_Slashqualified_name_with_optional_type_arguments_2500", "A class can only implement an identifier/qualified-name with optional type arguments."),
        A_rest_element_cannot_contain_a_binding_pattern: diag(2501, ts3.DiagnosticCategory.Error, "A_rest_element_cannot_contain_a_binding_pattern_2501", "A rest element cannot contain a binding pattern."),
        _0_is_referenced_directly_or_indirectly_in_its_own_type_annotation: diag(2502, ts3.DiagnosticCategory.Error, "_0_is_referenced_directly_or_indirectly_in_its_own_type_annotation_2502", "'{0}' is referenced directly or indirectly in its own type annotation."),
        Cannot_find_namespace_0: diag(2503, ts3.DiagnosticCategory.Error, "Cannot_find_namespace_0_2503", "Cannot find namespace '{0}'."),
        Type_0_must_have_a_Symbol_asyncIterator_method_that_returns_an_async_iterator: diag(2504, ts3.DiagnosticCategory.Error, "Type_0_must_have_a_Symbol_asyncIterator_method_that_returns_an_async_iterator_2504", "Type '{0}' must have a '[Symbol.asyncIterator]()' method that returns an async iterator."),
        A_generator_cannot_have_a_void_type_annotation: diag(2505, ts3.DiagnosticCategory.Error, "A_generator_cannot_have_a_void_type_annotation_2505", "A generator cannot have a 'void' type annotation."),
        _0_is_referenced_directly_or_indirectly_in_its_own_base_expression: diag(2506, ts3.DiagnosticCategory.Error, "_0_is_referenced_directly_or_indirectly_in_its_own_base_expression_2506", "'{0}' is referenced directly or indirectly in its own base expression."),
        Type_0_is_not_a_constructor_function_type: diag(2507, ts3.DiagnosticCategory.Error, "Type_0_is_not_a_constructor_function_type_2507", "Type '{0}' is not a constructor function type."),
        No_base_constructor_has_the_specified_number_of_type_arguments: diag(2508, ts3.DiagnosticCategory.Error, "No_base_constructor_has_the_specified_number_of_type_arguments_2508", "No base constructor has the specified number of type arguments."),
        Base_constructor_return_type_0_is_not_an_object_type_or_intersection_of_object_types_with_statically_known_members: diag(2509, ts3.DiagnosticCategory.Error, "Base_constructor_return_type_0_is_not_an_object_type_or_intersection_of_object_types_with_statically_2509", "Base constructor return type '{0}' is not an object type or intersection of object types with statically known members."),
        Base_constructors_must_all_have_the_same_return_type: diag(2510, ts3.DiagnosticCategory.Error, "Base_constructors_must_all_have_the_same_return_type_2510", "Base constructors must all have the same return type."),
        Cannot_create_an_instance_of_an_abstract_class: diag(2511, ts3.DiagnosticCategory.Error, "Cannot_create_an_instance_of_an_abstract_class_2511", "Cannot create an instance of an abstract class."),
        Overload_signatures_must_all_be_abstract_or_non_abstract: diag(2512, ts3.DiagnosticCategory.Error, "Overload_signatures_must_all_be_abstract_or_non_abstract_2512", "Overload signatures must all be abstract or non-abstract."),
        Abstract_method_0_in_class_1_cannot_be_accessed_via_super_expression: diag(2513, ts3.DiagnosticCategory.Error, "Abstract_method_0_in_class_1_cannot_be_accessed_via_super_expression_2513", "Abstract method '{0}' in class '{1}' cannot be accessed via super expression."),
        Classes_containing_abstract_methods_must_be_marked_abstract: diag(2514, ts3.DiagnosticCategory.Error, "Classes_containing_abstract_methods_must_be_marked_abstract_2514", "Classes containing abstract methods must be marked abstract."),
        Non_abstract_class_0_does_not_implement_inherited_abstract_member_1_from_class_2: diag(2515, ts3.DiagnosticCategory.Error, "Non_abstract_class_0_does_not_implement_inherited_abstract_member_1_from_class_2_2515", "Non-abstract class '{0}' does not implement inherited abstract member '{1}' from class '{2}'."),
        All_declarations_of_an_abstract_method_must_be_consecutive: diag(2516, ts3.DiagnosticCategory.Error, "All_declarations_of_an_abstract_method_must_be_consecutive_2516", "All declarations of an abstract method must be consecutive."),
        Cannot_assign_an_abstract_constructor_type_to_a_non_abstract_constructor_type: diag(2517, ts3.DiagnosticCategory.Error, "Cannot_assign_an_abstract_constructor_type_to_a_non_abstract_constructor_type_2517", "Cannot assign an abstract constructor type to a non-abstract constructor type."),
        A_this_based_type_guard_is_not_compatible_with_a_parameter_based_type_guard: diag(2518, ts3.DiagnosticCategory.Error, "A_this_based_type_guard_is_not_compatible_with_a_parameter_based_type_guard_2518", "A 'this'-based type guard is not compatible with a parameter-based type guard."),
        An_async_iterator_must_have_a_next_method: diag(2519, ts3.DiagnosticCategory.Error, "An_async_iterator_must_have_a_next_method_2519", "An async iterator must have a 'next()' method."),
        Duplicate_identifier_0_Compiler_uses_declaration_1_to_support_async_functions: diag(2520, ts3.DiagnosticCategory.Error, "Duplicate_identifier_0_Compiler_uses_declaration_1_to_support_async_functions_2520", "Duplicate identifier '{0}'. Compiler uses declaration '{1}' to support async functions."),
        Expression_resolves_to_variable_declaration_0_that_compiler_uses_to_support_async_functions: diag(2521, ts3.DiagnosticCategory.Error, "Expression_resolves_to_variable_declaration_0_that_compiler_uses_to_support_async_functions_2521", "Expression resolves to variable declaration '{0}' that compiler uses to support async functions."),
        The_arguments_object_cannot_be_referenced_in_an_async_function_or_method_in_ES3_and_ES5_Consider_using_a_standard_function_or_method: diag(2522, ts3.DiagnosticCategory.Error, "The_arguments_object_cannot_be_referenced_in_an_async_function_or_method_in_ES3_and_ES5_Consider_usi_2522", "The 'arguments' object cannot be referenced in an async function or method in ES3 and ES5. Consider using a standard function or method."),
        yield_expressions_cannot_be_used_in_a_parameter_initializer: diag(2523, ts3.DiagnosticCategory.Error, "yield_expressions_cannot_be_used_in_a_parameter_initializer_2523", "'yield' expressions cannot be used in a parameter initializer."),
        await_expressions_cannot_be_used_in_a_parameter_initializer: diag(2524, ts3.DiagnosticCategory.Error, "await_expressions_cannot_be_used_in_a_parameter_initializer_2524", "'await' expressions cannot be used in a parameter initializer."),
        Initializer_provides_no_value_for_this_binding_element_and_the_binding_element_has_no_default_value: diag(2525, ts3.DiagnosticCategory.Error, "Initializer_provides_no_value_for_this_binding_element_and_the_binding_element_has_no_default_value_2525", "Initializer provides no value for this binding element and the binding element has no default value."),
        A_this_type_is_available_only_in_a_non_static_member_of_a_class_or_interface: diag(2526, ts3.DiagnosticCategory.Error, "A_this_type_is_available_only_in_a_non_static_member_of_a_class_or_interface_2526", "A 'this' type is available only in a non-static member of a class or interface."),
        The_inferred_type_of_0_references_an_inaccessible_1_type_A_type_annotation_is_necessary: diag(2527, ts3.DiagnosticCategory.Error, "The_inferred_type_of_0_references_an_inaccessible_1_type_A_type_annotation_is_necessary_2527", "The inferred type of '{0}' references an inaccessible '{1}' type. A type annotation is necessary."),
        A_module_cannot_have_multiple_default_exports: diag(2528, ts3.DiagnosticCategory.Error, "A_module_cannot_have_multiple_default_exports_2528", "A module cannot have multiple default exports."),
        Duplicate_identifier_0_Compiler_reserves_name_1_in_top_level_scope_of_a_module_containing_async_functions: diag(2529, ts3.DiagnosticCategory.Error, "Duplicate_identifier_0_Compiler_reserves_name_1_in_top_level_scope_of_a_module_containing_async_func_2529", "Duplicate identifier '{0}'. Compiler reserves name '{1}' in top level scope of a module containing async functions."),
        Property_0_is_incompatible_with_index_signature: diag(2530, ts3.DiagnosticCategory.Error, "Property_0_is_incompatible_with_index_signature_2530", "Property '{0}' is incompatible with index signature."),
        Object_is_possibly_null: diag(2531, ts3.DiagnosticCategory.Error, "Object_is_possibly_null_2531", "Object is possibly 'null'."),
        Object_is_possibly_undefined: diag(2532, ts3.DiagnosticCategory.Error, "Object_is_possibly_undefined_2532", "Object is possibly 'undefined'."),
        Object_is_possibly_null_or_undefined: diag(2533, ts3.DiagnosticCategory.Error, "Object_is_possibly_null_or_undefined_2533", "Object is possibly 'null' or 'undefined'."),
        A_function_returning_never_cannot_have_a_reachable_end_point: diag(2534, ts3.DiagnosticCategory.Error, "A_function_returning_never_cannot_have_a_reachable_end_point_2534", "A function returning 'never' cannot have a reachable end point."),
        Enum_type_0_has_members_with_initializers_that_are_not_literals: diag(2535, ts3.DiagnosticCategory.Error, "Enum_type_0_has_members_with_initializers_that_are_not_literals_2535", "Enum type '{0}' has members with initializers that are not literals."),
        Type_0_cannot_be_used_to_index_type_1: diag(2536, ts3.DiagnosticCategory.Error, "Type_0_cannot_be_used_to_index_type_1_2536", "Type '{0}' cannot be used to index type '{1}'."),
        Type_0_has_no_matching_index_signature_for_type_1: diag(2537, ts3.DiagnosticCategory.Error, "Type_0_has_no_matching_index_signature_for_type_1_2537", "Type '{0}' has no matching index signature for type '{1}'."),
        Type_0_cannot_be_used_as_an_index_type: diag(2538, ts3.DiagnosticCategory.Error, "Type_0_cannot_be_used_as_an_index_type_2538", "Type '{0}' cannot be used as an index type."),
        Cannot_assign_to_0_because_it_is_not_a_variable: diag(2539, ts3.DiagnosticCategory.Error, "Cannot_assign_to_0_because_it_is_not_a_variable_2539", "Cannot assign to '{0}' because it is not a variable."),
        Cannot_assign_to_0_because_it_is_a_read_only_property: diag(2540, ts3.DiagnosticCategory.Error, "Cannot_assign_to_0_because_it_is_a_read_only_property_2540", "Cannot assign to '{0}' because it is a read-only property."),
        The_target_of_an_assignment_must_be_a_variable_or_a_property_access: diag(2541, ts3.DiagnosticCategory.Error, "The_target_of_an_assignment_must_be_a_variable_or_a_property_access_2541", "The target of an assignment must be a variable or a property access."),
        Index_signature_in_type_0_only_permits_reading: diag(2542, ts3.DiagnosticCategory.Error, "Index_signature_in_type_0_only_permits_reading_2542", "Index signature in type '{0}' only permits reading."),
        Duplicate_identifier_newTarget_Compiler_uses_variable_declaration_newTarget_to_capture_new_target_meta_property_reference: diag(2543, ts3.DiagnosticCategory.Error, "Duplicate_identifier_newTarget_Compiler_uses_variable_declaration_newTarget_to_capture_new_target_me_2543", "Duplicate identifier '_newTarget'. Compiler uses variable declaration '_newTarget' to capture 'new.target' meta-property reference."),
        Expression_resolves_to_variable_declaration_newTarget_that_compiler_uses_to_capture_new_target_meta_property_reference: diag(2544, ts3.DiagnosticCategory.Error, "Expression_resolves_to_variable_declaration_newTarget_that_compiler_uses_to_capture_new_target_meta__2544", "Expression resolves to variable declaration '_newTarget' that compiler uses to capture 'new.target' meta-property reference."),
        A_mixin_class_must_have_a_constructor_with_a_single_rest_parameter_of_type_any: diag(2545, ts3.DiagnosticCategory.Error, "A_mixin_class_must_have_a_constructor_with_a_single_rest_parameter_of_type_any_2545", "A mixin class must have a constructor with a single rest parameter of type 'any[]'."),
        The_type_returned_by_the_0_method_of_an_async_iterator_must_be_a_promise_for_a_type_with_a_value_property: diag(2547, ts3.DiagnosticCategory.Error, "The_type_returned_by_the_0_method_of_an_async_iterator_must_be_a_promise_for_a_type_with_a_value_pro_2547", "The type returned by the '{0}()' method of an async iterator must be a promise for a type with a 'value' property."),
        Type_0_is_not_an_array_type_or_does_not_have_a_Symbol_iterator_method_that_returns_an_iterator: diag(2548, ts3.DiagnosticCategory.Error, "Type_0_is_not_an_array_type_or_does_not_have_a_Symbol_iterator_method_that_returns_an_iterator_2548", "Type '{0}' is not an array type or does not have a '[Symbol.iterator]()' method that returns an iterator."),
        Type_0_is_not_an_array_type_or_a_string_type_or_does_not_have_a_Symbol_iterator_method_that_returns_an_iterator: diag(2549, ts3.DiagnosticCategory.Error, "Type_0_is_not_an_array_type_or_a_string_type_or_does_not_have_a_Symbol_iterator_method_that_returns__2549", "Type '{0}' is not an array type or a string type or does not have a '[Symbol.iterator]()' method that returns an iterator."),
        Property_0_does_not_exist_on_type_1_Do_you_need_to_change_your_target_library_Try_changing_the_lib_compiler_option_to_2_or_later: diag(2550, ts3.DiagnosticCategory.Error, "Property_0_does_not_exist_on_type_1_Do_you_need_to_change_your_target_library_Try_changing_the_lib_c_2550", "Property '{0}' does not exist on type '{1}'. Do you need to change your target library? Try changing the 'lib' compiler option to '{2}' or later."),
        Property_0_does_not_exist_on_type_1_Did_you_mean_2: diag(2551, ts3.DiagnosticCategory.Error, "Property_0_does_not_exist_on_type_1_Did_you_mean_2_2551", "Property '{0}' does not exist on type '{1}'. Did you mean '{2}'?"),
        Cannot_find_name_0_Did_you_mean_1: diag(2552, ts3.DiagnosticCategory.Error, "Cannot_find_name_0_Did_you_mean_1_2552", "Cannot find name '{0}'. Did you mean '{1}'?"),
        Computed_values_are_not_permitted_in_an_enum_with_string_valued_members: diag(2553, ts3.DiagnosticCategory.Error, "Computed_values_are_not_permitted_in_an_enum_with_string_valued_members_2553", "Computed values are not permitted in an enum with string valued members."),
        Expected_0_arguments_but_got_1: diag(2554, ts3.DiagnosticCategory.Error, "Expected_0_arguments_but_got_1_2554", "Expected {0} arguments, but got {1}."),
        Expected_at_least_0_arguments_but_got_1: diag(2555, ts3.DiagnosticCategory.Error, "Expected_at_least_0_arguments_but_got_1_2555", "Expected at least {0} arguments, but got {1}."),
        A_spread_argument_must_either_have_a_tuple_type_or_be_passed_to_a_rest_parameter: diag(2556, ts3.DiagnosticCategory.Error, "A_spread_argument_must_either_have_a_tuple_type_or_be_passed_to_a_rest_parameter_2556", "A spread argument must either have a tuple type or be passed to a rest parameter."),
        Expected_0_type_arguments_but_got_1: diag(2558, ts3.DiagnosticCategory.Error, "Expected_0_type_arguments_but_got_1_2558", "Expected {0} type arguments, but got {1}."),
        Type_0_has_no_properties_in_common_with_type_1: diag(2559, ts3.DiagnosticCategory.Error, "Type_0_has_no_properties_in_common_with_type_1_2559", "Type '{0}' has no properties in common with type '{1}'."),
        Value_of_type_0_has_no_properties_in_common_with_type_1_Did_you_mean_to_call_it: diag(2560, ts3.DiagnosticCategory.Error, "Value_of_type_0_has_no_properties_in_common_with_type_1_Did_you_mean_to_call_it_2560", "Value of type '{0}' has no properties in common with type '{1}'. Did you mean to call it?"),
        Object_literal_may_only_specify_known_properties_but_0_does_not_exist_in_type_1_Did_you_mean_to_write_2: diag(2561, ts3.DiagnosticCategory.Error, "Object_literal_may_only_specify_known_properties_but_0_does_not_exist_in_type_1_Did_you_mean_to_writ_2561", "Object literal may only specify known properties, but '{0}' does not exist in type '{1}'. Did you mean to write '{2}'?"),
        Base_class_expressions_cannot_reference_class_type_parameters: diag(2562, ts3.DiagnosticCategory.Error, "Base_class_expressions_cannot_reference_class_type_parameters_2562", "Base class expressions cannot reference class type parameters."),
        The_containing_function_or_module_body_is_too_large_for_control_flow_analysis: diag(2563, ts3.DiagnosticCategory.Error, "The_containing_function_or_module_body_is_too_large_for_control_flow_analysis_2563", "The containing function or module body is too large for control flow analysis."),
        Property_0_has_no_initializer_and_is_not_definitely_assigned_in_the_constructor: diag(2564, ts3.DiagnosticCategory.Error, "Property_0_has_no_initializer_and_is_not_definitely_assigned_in_the_constructor_2564", "Property '{0}' has no initializer and is not definitely assigned in the constructor."),
        Property_0_is_used_before_being_assigned: diag(2565, ts3.DiagnosticCategory.Error, "Property_0_is_used_before_being_assigned_2565", "Property '{0}' is used before being assigned."),
        A_rest_element_cannot_have_a_property_name: diag(2566, ts3.DiagnosticCategory.Error, "A_rest_element_cannot_have_a_property_name_2566", "A rest element cannot have a property name."),
        Enum_declarations_can_only_merge_with_namespace_or_other_enum_declarations: diag(2567, ts3.DiagnosticCategory.Error, "Enum_declarations_can_only_merge_with_namespace_or_other_enum_declarations_2567", "Enum declarations can only merge with namespace or other enum declarations."),
        Type_0_is_not_an_array_type_or_a_string_type_Use_compiler_option_downlevelIteration_to_allow_iterating_of_iterators: diag(2569, ts3.DiagnosticCategory.Error, "Type_0_is_not_an_array_type_or_a_string_type_Use_compiler_option_downlevelIteration_to_allow_iterati_2569", "Type '{0}' is not an array type or a string type. Use compiler option '--downlevelIteration' to allow iterating of iterators."),
        Object_is_of_type_unknown: diag(2571, ts3.DiagnosticCategory.Error, "Object_is_of_type_unknown_2571", "Object is of type 'unknown'."),
        Rest_signatures_are_incompatible: diag(2572, ts3.DiagnosticCategory.Error, "Rest_signatures_are_incompatible_2572", "Rest signatures are incompatible."),
        Property_0_is_incompatible_with_rest_element_type: diag(2573, ts3.DiagnosticCategory.Error, "Property_0_is_incompatible_with_rest_element_type_2573", "Property '{0}' is incompatible with rest element type."),
        A_rest_element_type_must_be_an_array_type: diag(2574, ts3.DiagnosticCategory.Error, "A_rest_element_type_must_be_an_array_type_2574", "A rest element type must be an array type."),
        No_overload_expects_0_arguments_but_overloads_do_exist_that_expect_either_1_or_2_arguments: diag(2575, ts3.DiagnosticCategory.Error, "No_overload_expects_0_arguments_but_overloads_do_exist_that_expect_either_1_or_2_arguments_2575", "No overload expects {0} arguments, but overloads do exist that expect either {1} or {2} arguments."),
        Property_0_does_not_exist_on_type_1_Did_you_mean_to_access_the_static_member_2_instead: diag(2576, ts3.DiagnosticCategory.Error, "Property_0_does_not_exist_on_type_1_Did_you_mean_to_access_the_static_member_2_instead_2576", "Property '{0}' does not exist on type '{1}'. Did you mean to access the static member '{2}' instead?"),
        Return_type_annotation_circularly_references_itself: diag(2577, ts3.DiagnosticCategory.Error, "Return_type_annotation_circularly_references_itself_2577", "Return type annotation circularly references itself."),
        Unused_ts_expect_error_directive: diag(2578, ts3.DiagnosticCategory.Error, "Unused_ts_expect_error_directive_2578", "Unused '@ts-expect-error' directive."),
        Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_node_Try_npm_i_save_dev_types_Slashnode: diag(2580, ts3.DiagnosticCategory.Error, "Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_node_Try_npm_i_save_dev_types_Slashno_2580", "Cannot find name '{0}'. Do you need to install type definitions for node? Try `npm i --save-dev @types/node`."),
        Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_jQuery_Try_npm_i_save_dev_types_Slashjquery: diag(2581, ts3.DiagnosticCategory.Error, "Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_jQuery_Try_npm_i_save_dev_types_Slash_2581", "Cannot find name '{0}'. Do you need to install type definitions for jQuery? Try `npm i --save-dev @types/jquery`."),
        Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_a_test_runner_Try_npm_i_save_dev_types_Slashjest_or_npm_i_save_dev_types_Slashmocha: diag(2582, ts3.DiagnosticCategory.Error, "Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_a_test_runner_Try_npm_i_save_dev_type_2582", "Cannot find name '{0}'. Do you need to install type definitions for a test runner? Try `npm i --save-dev @types/jest` or `npm i --save-dev @types/mocha`."),
        Cannot_find_name_0_Do_you_need_to_change_your_target_library_Try_changing_the_lib_compiler_option_to_1_or_later: diag(2583, ts3.DiagnosticCategory.Error, "Cannot_find_name_0_Do_you_need_to_change_your_target_library_Try_changing_the_lib_compiler_option_to_2583", "Cannot find name '{0}'. Do you need to change your target library? Try changing the 'lib' compiler option to '{1}' or later."),
        Cannot_find_name_0_Do_you_need_to_change_your_target_library_Try_changing_the_lib_compiler_option_to_include_dom: diag(2584, ts3.DiagnosticCategory.Error, "Cannot_find_name_0_Do_you_need_to_change_your_target_library_Try_changing_the_lib_compiler_option_to_2584", "Cannot find name '{0}'. Do you need to change your target library? Try changing the 'lib' compiler option to include 'dom'."),
        _0_only_refers_to_a_type_but_is_being_used_as_a_value_here_Do_you_need_to_change_your_target_library_Try_changing_the_lib_compiler_option_to_es2015_or_later: diag(2585, ts3.DiagnosticCategory.Error, "_0_only_refers_to_a_type_but_is_being_used_as_a_value_here_Do_you_need_to_change_your_target_library_2585", "'{0}' only refers to a type, but is being used as a value here. Do you need to change your target library? Try changing the 'lib' compiler option to es2015 or later."),
        Enum_type_0_circularly_references_itself: diag(2586, ts3.DiagnosticCategory.Error, "Enum_type_0_circularly_references_itself_2586", "Enum type '{0}' circularly references itself."),
        JSDoc_type_0_circularly_references_itself: diag(2587, ts3.DiagnosticCategory.Error, "JSDoc_type_0_circularly_references_itself_2587", "JSDoc type '{0}' circularly references itself."),
        Cannot_assign_to_0_because_it_is_a_constant: diag(2588, ts3.DiagnosticCategory.Error, "Cannot_assign_to_0_because_it_is_a_constant_2588", "Cannot assign to '{0}' because it is a constant."),
        Type_instantiation_is_excessively_deep_and_possibly_infinite: diag(2589, ts3.DiagnosticCategory.Error, "Type_instantiation_is_excessively_deep_and_possibly_infinite_2589", "Type instantiation is excessively deep and possibly infinite."),
        Expression_produces_a_union_type_that_is_too_complex_to_represent: diag(2590, ts3.DiagnosticCategory.Error, "Expression_produces_a_union_type_that_is_too_complex_to_represent_2590", "Expression produces a union type that is too complex to represent."),
        Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_node_Try_npm_i_save_dev_types_Slashnode_and_then_add_node_to_the_types_field_in_your_tsconfig: diag(2591, ts3.DiagnosticCategory.Error, "Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_node_Try_npm_i_save_dev_types_Slashno_2591", "Cannot find name '{0}'. Do you need to install type definitions for node? Try `npm i --save-dev @types/node` and then add 'node' to the types field in your tsconfig."),
        Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_jQuery_Try_npm_i_save_dev_types_Slashjquery_and_then_add_jquery_to_the_types_field_in_your_tsconfig: diag(2592, ts3.DiagnosticCategory.Error, "Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_jQuery_Try_npm_i_save_dev_types_Slash_2592", "Cannot find name '{0}'. Do you need to install type definitions for jQuery? Try `npm i --save-dev @types/jquery` and then add 'jquery' to the types field in your tsconfig."),
        Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_a_test_runner_Try_npm_i_save_dev_types_Slashjest_or_npm_i_save_dev_types_Slashmocha_and_then_add_jest_or_mocha_to_the_types_field_in_your_tsconfig: diag(2593, ts3.DiagnosticCategory.Error, "Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_a_test_runner_Try_npm_i_save_dev_type_2593", "Cannot find name '{0}'. Do you need to install type definitions for a test runner? Try `npm i --save-dev @types/jest` or `npm i --save-dev @types/mocha` and then add 'jest' or 'mocha' to the types field in your tsconfig."),
        This_module_is_declared_with_using_export_and_can_only_be_used_with_a_default_import_when_using_the_0_flag: diag(2594, ts3.DiagnosticCategory.Error, "This_module_is_declared_with_using_export_and_can_only_be_used_with_a_default_import_when_using_the__2594", "This module is declared with using 'export =', and can only be used with a default import when using the '{0}' flag."),
        _0_can_only_be_imported_by_using_a_default_import: diag(2595, ts3.DiagnosticCategory.Error, "_0_can_only_be_imported_by_using_a_default_import_2595", "'{0}' can only be imported by using a default import."),
        _0_can_only_be_imported_by_turning_on_the_esModuleInterop_flag_and_using_a_default_import: diag(2596, ts3.DiagnosticCategory.Error, "_0_can_only_be_imported_by_turning_on_the_esModuleInterop_flag_and_using_a_default_import_2596", "'{0}' can only be imported by turning on the 'esModuleInterop' flag and using a default import."),
        _0_can_only_be_imported_by_using_a_require_call_or_by_using_a_default_import: diag(2597, ts3.DiagnosticCategory.Error, "_0_can_only_be_imported_by_using_a_require_call_or_by_using_a_default_import_2597", "'{0}' can only be imported by using a 'require' call or by using a default import."),
        _0_can_only_be_imported_by_using_a_require_call_or_by_turning_on_the_esModuleInterop_flag_and_using_a_default_import: diag(2598, ts3.DiagnosticCategory.Error, "_0_can_only_be_imported_by_using_a_require_call_or_by_turning_on_the_esModuleInterop_flag_and_using__2598", "'{0}' can only be imported by using a 'require' call or by turning on the 'esModuleInterop' flag and using a default import."),
        JSX_element_attributes_type_0_may_not_be_a_union_type: diag(2600, ts3.DiagnosticCategory.Error, "JSX_element_attributes_type_0_may_not_be_a_union_type_2600", "JSX element attributes type '{0}' may not be a union type."),
        The_return_type_of_a_JSX_element_constructor_must_return_an_object_type: diag(2601, ts3.DiagnosticCategory.Error, "The_return_type_of_a_JSX_element_constructor_must_return_an_object_type_2601", "The return type of a JSX element constructor must return an object type."),
        JSX_element_implicitly_has_type_any_because_the_global_type_JSX_Element_does_not_exist: diag(2602, ts3.DiagnosticCategory.Error, "JSX_element_implicitly_has_type_any_because_the_global_type_JSX_Element_does_not_exist_2602", "JSX element implicitly has type 'any' because the global type 'JSX.Element' does not exist."),
        Property_0_in_type_1_is_not_assignable_to_type_2: diag(2603, ts3.DiagnosticCategory.Error, "Property_0_in_type_1_is_not_assignable_to_type_2_2603", "Property '{0}' in type '{1}' is not assignable to type '{2}'."),
        JSX_element_type_0_does_not_have_any_construct_or_call_signatures: diag(2604, ts3.DiagnosticCategory.Error, "JSX_element_type_0_does_not_have_any_construct_or_call_signatures_2604", "JSX element type '{0}' does not have any construct or call signatures."),
        JSX_element_type_0_is_not_a_constructor_function_for_JSX_elements: diag(2605, ts3.DiagnosticCategory.Error, "JSX_element_type_0_is_not_a_constructor_function_for_JSX_elements_2605", "JSX element type '{0}' is not a constructor function for JSX elements."),
        Property_0_of_JSX_spread_attribute_is_not_assignable_to_target_property: diag(2606, ts3.DiagnosticCategory.Error, "Property_0_of_JSX_spread_attribute_is_not_assignable_to_target_property_2606", "Property '{0}' of JSX spread attribute is not assignable to target property."),
        JSX_element_class_does_not_support_attributes_because_it_does_not_have_a_0_property: diag(2607, ts3.DiagnosticCategory.Error, "JSX_element_class_does_not_support_attributes_because_it_does_not_have_a_0_property_2607", "JSX element class does not support attributes because it does not have a '{0}' property."),
        The_global_type_JSX_0_may_not_have_more_than_one_property: diag(2608, ts3.DiagnosticCategory.Error, "The_global_type_JSX_0_may_not_have_more_than_one_property_2608", "The global type 'JSX.{0}' may not have more than one property."),
        JSX_spread_child_must_be_an_array_type: diag(2609, ts3.DiagnosticCategory.Error, "JSX_spread_child_must_be_an_array_type_2609", "JSX spread child must be an array type."),
        _0_is_defined_as_an_accessor_in_class_1_but_is_overridden_here_in_2_as_an_instance_property: diag(2610, ts3.DiagnosticCategory.Error, "_0_is_defined_as_an_accessor_in_class_1_but_is_overridden_here_in_2_as_an_instance_property_2610", "'{0}' is defined as an accessor in class '{1}', but is overridden here in '{2}' as an instance property."),
        _0_is_defined_as_a_property_in_class_1_but_is_overridden_here_in_2_as_an_accessor: diag(2611, ts3.DiagnosticCategory.Error, "_0_is_defined_as_a_property_in_class_1_but_is_overridden_here_in_2_as_an_accessor_2611", "'{0}' is defined as a property in class '{1}', but is overridden here in '{2}' as an accessor."),
        Property_0_will_overwrite_the_base_property_in_1_If_this_is_intentional_add_an_initializer_Otherwise_add_a_declare_modifier_or_remove_the_redundant_declaration: diag(2612, ts3.DiagnosticCategory.Error, "Property_0_will_overwrite_the_base_property_in_1_If_this_is_intentional_add_an_initializer_Otherwise_2612", "Property '{0}' will overwrite the base property in '{1}'. If this is intentional, add an initializer. Otherwise, add a 'declare' modifier or remove the redundant declaration."),
        Module_0_has_no_default_export_Did_you_mean_to_use_import_1_from_0_instead: diag(2613, ts3.DiagnosticCategory.Error, "Module_0_has_no_default_export_Did_you_mean_to_use_import_1_from_0_instead_2613", "Module '{0}' has no default export. Did you mean to use 'import { {1} } from {0}' instead?"),
        Module_0_has_no_exported_member_1_Did_you_mean_to_use_import_1_from_0_instead: diag(2614, ts3.DiagnosticCategory.Error, "Module_0_has_no_exported_member_1_Did_you_mean_to_use_import_1_from_0_instead_2614", "Module '{0}' has no exported member '{1}'. Did you mean to use 'import {1} from {0}' instead?"),
        Type_of_property_0_circularly_references_itself_in_mapped_type_1: diag(2615, ts3.DiagnosticCategory.Error, "Type_of_property_0_circularly_references_itself_in_mapped_type_1_2615", "Type of property '{0}' circularly references itself in mapped type '{1}'."),
        _0_can_only_be_imported_by_using_import_1_require_2_or_a_default_import: diag(2616, ts3.DiagnosticCategory.Error, "_0_can_only_be_imported_by_using_import_1_require_2_or_a_default_import_2616", "'{0}' can only be imported by using 'import {1} = require({2})' or a default import."),
        _0_can_only_be_imported_by_using_import_1_require_2_or_by_turning_on_the_esModuleInterop_flag_and_using_a_default_import: diag(2617, ts3.DiagnosticCategory.Error, "_0_can_only_be_imported_by_using_import_1_require_2_or_by_turning_on_the_esModuleInterop_flag_and_us_2617", "'{0}' can only be imported by using 'import {1} = require({2})' or by turning on the 'esModuleInterop' flag and using a default import."),
        Source_has_0_element_s_but_target_requires_1: diag(2618, ts3.DiagnosticCategory.Error, "Source_has_0_element_s_but_target_requires_1_2618", "Source has {0} element(s) but target requires {1}."),
        Source_has_0_element_s_but_target_allows_only_1: diag(2619, ts3.DiagnosticCategory.Error, "Source_has_0_element_s_but_target_allows_only_1_2619", "Source has {0} element(s) but target allows only {1}."),
        Target_requires_0_element_s_but_source_may_have_fewer: diag(2620, ts3.DiagnosticCategory.Error, "Target_requires_0_element_s_but_source_may_have_fewer_2620", "Target requires {0} element(s) but source may have fewer."),
        Target_allows_only_0_element_s_but_source_may_have_more: diag(2621, ts3.DiagnosticCategory.Error, "Target_allows_only_0_element_s_but_source_may_have_more_2621", "Target allows only {0} element(s) but source may have more."),
        Source_provides_no_match_for_required_element_at_position_0_in_target: diag(2623, ts3.DiagnosticCategory.Error, "Source_provides_no_match_for_required_element_at_position_0_in_target_2623", "Source provides no match for required element at position {0} in target."),
        Source_provides_no_match_for_variadic_element_at_position_0_in_target: diag(2624, ts3.DiagnosticCategory.Error, "Source_provides_no_match_for_variadic_element_at_position_0_in_target_2624", "Source provides no match for variadic element at position {0} in target."),
        Variadic_element_at_position_0_in_source_does_not_match_element_at_position_1_in_target: diag(2625, ts3.DiagnosticCategory.Error, "Variadic_element_at_position_0_in_source_does_not_match_element_at_position_1_in_target_2625", "Variadic element at position {0} in source does not match element at position {1} in target."),
        Type_at_position_0_in_source_is_not_compatible_with_type_at_position_1_in_target: diag(2626, ts3.DiagnosticCategory.Error, "Type_at_position_0_in_source_is_not_compatible_with_type_at_position_1_in_target_2626", "Type at position {0} in source is not compatible with type at position {1} in target."),
        Type_at_positions_0_through_1_in_source_is_not_compatible_with_type_at_position_2_in_target: diag(2627, ts3.DiagnosticCategory.Error, "Type_at_positions_0_through_1_in_source_is_not_compatible_with_type_at_position_2_in_target_2627", "Type at positions {0} through {1} in source is not compatible with type at position {2} in target."),
        Cannot_assign_to_0_because_it_is_an_enum: diag(2628, ts3.DiagnosticCategory.Error, "Cannot_assign_to_0_because_it_is_an_enum_2628", "Cannot assign to '{0}' because it is an enum."),
        Cannot_assign_to_0_because_it_is_a_class: diag(2629, ts3.DiagnosticCategory.Error, "Cannot_assign_to_0_because_it_is_a_class_2629", "Cannot assign to '{0}' because it is a class."),
        Cannot_assign_to_0_because_it_is_a_function: diag(2630, ts3.DiagnosticCategory.Error, "Cannot_assign_to_0_because_it_is_a_function_2630", "Cannot assign to '{0}' because it is a function."),
        Cannot_assign_to_0_because_it_is_a_namespace: diag(2631, ts3.DiagnosticCategory.Error, "Cannot_assign_to_0_because_it_is_a_namespace_2631", "Cannot assign to '{0}' because it is a namespace."),
        Cannot_assign_to_0_because_it_is_an_import: diag(2632, ts3.DiagnosticCategory.Error, "Cannot_assign_to_0_because_it_is_an_import_2632", "Cannot assign to '{0}' because it is an import."),
        JSX_property_access_expressions_cannot_include_JSX_namespace_names: diag(2633, ts3.DiagnosticCategory.Error, "JSX_property_access_expressions_cannot_include_JSX_namespace_names_2633", "JSX property access expressions cannot include JSX namespace names"),
        Cannot_augment_module_0_with_value_exports_because_it_resolves_to_a_non_module_entity: diag(2649, ts3.DiagnosticCategory.Error, "Cannot_augment_module_0_with_value_exports_because_it_resolves_to_a_non_module_entity_2649", "Cannot augment module '{0}' with value exports because it resolves to a non-module entity."),
        A_member_initializer_in_a_enum_declaration_cannot_reference_members_declared_after_it_including_members_defined_in_other_enums: diag(2651, ts3.DiagnosticCategory.Error, "A_member_initializer_in_a_enum_declaration_cannot_reference_members_declared_after_it_including_memb_2651", "A member initializer in a enum declaration cannot reference members declared after it, including members defined in other enums."),
        Merged_declaration_0_cannot_include_a_default_export_declaration_Consider_adding_a_separate_export_default_0_declaration_instead: diag(2652, ts3.DiagnosticCategory.Error, "Merged_declaration_0_cannot_include_a_default_export_declaration_Consider_adding_a_separate_export_d_2652", "Merged declaration '{0}' cannot include a default export declaration. Consider adding a separate 'export default {0}' declaration instead."),
        Non_abstract_class_expression_does_not_implement_inherited_abstract_member_0_from_class_1: diag(2653, ts3.DiagnosticCategory.Error, "Non_abstract_class_expression_does_not_implement_inherited_abstract_member_0_from_class_1_2653", "Non-abstract class expression does not implement inherited abstract member '{0}' from class '{1}'."),
        Exported_external_package_typings_file_cannot_contain_tripleslash_references_Please_contact_the_package_author_to_update_the_package_definition: diag(2654, ts3.DiagnosticCategory.Error, "Exported_external_package_typings_file_cannot_contain_tripleslash_references_Please_contact_the_pack_2654", "Exported external package typings file cannot contain tripleslash references. Please contact the package author to update the package definition."),
        Exported_external_package_typings_file_0_is_not_a_module_Please_contact_the_package_author_to_update_the_package_definition: diag(2656, ts3.DiagnosticCategory.Error, "Exported_external_package_typings_file_0_is_not_a_module_Please_contact_the_package_author_to_update_2656", "Exported external package typings file '{0}' is not a module. Please contact the package author to update the package definition."),
        JSX_expressions_must_have_one_parent_element: diag(2657, ts3.DiagnosticCategory.Error, "JSX_expressions_must_have_one_parent_element_2657", "JSX expressions must have one parent element."),
        Type_0_provides_no_match_for_the_signature_1: diag(2658, ts3.DiagnosticCategory.Error, "Type_0_provides_no_match_for_the_signature_1_2658", "Type '{0}' provides no match for the signature '{1}'."),
        super_is_only_allowed_in_members_of_object_literal_expressions_when_option_target_is_ES2015_or_higher: diag(2659, ts3.DiagnosticCategory.Error, "super_is_only_allowed_in_members_of_object_literal_expressions_when_option_target_is_ES2015_or_highe_2659", "'super' is only allowed in members of object literal expressions when option 'target' is 'ES2015' or higher."),
        super_can_only_be_referenced_in_members_of_derived_classes_or_object_literal_expressions: diag(2660, ts3.DiagnosticCategory.Error, "super_can_only_be_referenced_in_members_of_derived_classes_or_object_literal_expressions_2660", "'super' can only be referenced in members of derived classes or object literal expressions."),
        Cannot_export_0_Only_local_declarations_can_be_exported_from_a_module: diag(2661, ts3.DiagnosticCategory.Error, "Cannot_export_0_Only_local_declarations_can_be_exported_from_a_module_2661", "Cannot export '{0}'. Only local declarations can be exported from a module."),
        Cannot_find_name_0_Did_you_mean_the_static_member_1_0: diag(2662, ts3.DiagnosticCategory.Error, "Cannot_find_name_0_Did_you_mean_the_static_member_1_0_2662", "Cannot find name '{0}'. Did you mean the static member '{1}.{0}'?"),
        Cannot_find_name_0_Did_you_mean_the_instance_member_this_0: diag(2663, ts3.DiagnosticCategory.Error, "Cannot_find_name_0_Did_you_mean_the_instance_member_this_0_2663", "Cannot find name '{0}'. Did you mean the instance member 'this.{0}'?"),
        Invalid_module_name_in_augmentation_module_0_cannot_be_found: diag(2664, ts3.DiagnosticCategory.Error, "Invalid_module_name_in_augmentation_module_0_cannot_be_found_2664", "Invalid module name in augmentation, module '{0}' cannot be found."),
        Invalid_module_name_in_augmentation_Module_0_resolves_to_an_untyped_module_at_1_which_cannot_be_augmented: diag(2665, ts3.DiagnosticCategory.Error, "Invalid_module_name_in_augmentation_Module_0_resolves_to_an_untyped_module_at_1_which_cannot_be_augm_2665", "Invalid module name in augmentation. Module '{0}' resolves to an untyped module at '{1}', which cannot be augmented."),
        Exports_and_export_assignments_are_not_permitted_in_module_augmentations: diag(2666, ts3.DiagnosticCategory.Error, "Exports_and_export_assignments_are_not_permitted_in_module_augmentations_2666", "Exports and export assignments are not permitted in module augmentations."),
        Imports_are_not_permitted_in_module_augmentations_Consider_moving_them_to_the_enclosing_external_module: diag(2667, ts3.DiagnosticCategory.Error, "Imports_are_not_permitted_in_module_augmentations_Consider_moving_them_to_the_enclosing_external_mod_2667", "Imports are not permitted in module augmentations. Consider moving them to the enclosing external module."),
        export_modifier_cannot_be_applied_to_ambient_modules_and_module_augmentations_since_they_are_always_visible: diag(2668, ts3.DiagnosticCategory.Error, "export_modifier_cannot_be_applied_to_ambient_modules_and_module_augmentations_since_they_are_always__2668", "'export' modifier cannot be applied to ambient modules and module augmentations since they are always visible."),
        Augmentations_for_the_global_scope_can_only_be_directly_nested_in_external_modules_or_ambient_module_declarations: diag(2669, ts3.DiagnosticCategory.Error, "Augmentations_for_the_global_scope_can_only_be_directly_nested_in_external_modules_or_ambient_module_2669", "Augmentations for the global scope can only be directly nested in external modules or ambient module declarations."),
        Augmentations_for_the_global_scope_should_have_declare_modifier_unless_they_appear_in_already_ambient_context: diag(2670, ts3.DiagnosticCategory.Error, "Augmentations_for_the_global_scope_should_have_declare_modifier_unless_they_appear_in_already_ambien_2670", "Augmentations for the global scope should have 'declare' modifier unless they appear in already ambient context."),
        Cannot_augment_module_0_because_it_resolves_to_a_non_module_entity: diag(2671, ts3.DiagnosticCategory.Error, "Cannot_augment_module_0_because_it_resolves_to_a_non_module_entity_2671", "Cannot augment module '{0}' because it resolves to a non-module entity."),
        Cannot_assign_a_0_constructor_type_to_a_1_constructor_type: diag(2672, ts3.DiagnosticCategory.Error, "Cannot_assign_a_0_constructor_type_to_a_1_constructor_type_2672", "Cannot assign a '{0}' constructor type to a '{1}' constructor type."),
        Constructor_of_class_0_is_private_and_only_accessible_within_the_class_declaration: diag(2673, ts3.DiagnosticCategory.Error, "Constructor_of_class_0_is_private_and_only_accessible_within_the_class_declaration_2673", "Constructor of class '{0}' is private and only accessible within the class declaration."),
        Constructor_of_class_0_is_protected_and_only_accessible_within_the_class_declaration: diag(2674, ts3.DiagnosticCategory.Error, "Constructor_of_class_0_is_protected_and_only_accessible_within_the_class_declaration_2674", "Constructor of class '{0}' is protected and only accessible within the class declaration."),
        Cannot_extend_a_class_0_Class_constructor_is_marked_as_private: diag(2675, ts3.DiagnosticCategory.Error, "Cannot_extend_a_class_0_Class_constructor_is_marked_as_private_2675", "Cannot extend a class '{0}'. Class constructor is marked as private."),
        Accessors_must_both_be_abstract_or_non_abstract: diag(2676, ts3.DiagnosticCategory.Error, "Accessors_must_both_be_abstract_or_non_abstract_2676", "Accessors must both be abstract or non-abstract."),
        A_type_predicate_s_type_must_be_assignable_to_its_parameter_s_type: diag(2677, ts3.DiagnosticCategory.Error, "A_type_predicate_s_type_must_be_assignable_to_its_parameter_s_type_2677", "A type predicate's type must be assignable to its parameter's type."),
        Type_0_is_not_comparable_to_type_1: diag(2678, ts3.DiagnosticCategory.Error, "Type_0_is_not_comparable_to_type_1_2678", "Type '{0}' is not comparable to type '{1}'."),
        A_function_that_is_called_with_the_new_keyword_cannot_have_a_this_type_that_is_void: diag(2679, ts3.DiagnosticCategory.Error, "A_function_that_is_called_with_the_new_keyword_cannot_have_a_this_type_that_is_void_2679", "A function that is called with the 'new' keyword cannot have a 'this' type that is 'void'."),
        A_0_parameter_must_be_the_first_parameter: diag(2680, ts3.DiagnosticCategory.Error, "A_0_parameter_must_be_the_first_parameter_2680", "A '{0}' parameter must be the first parameter."),
        A_constructor_cannot_have_a_this_parameter: diag(2681, ts3.DiagnosticCategory.Error, "A_constructor_cannot_have_a_this_parameter_2681", "A constructor cannot have a 'this' parameter."),
        get_and_set_accessor_must_have_the_same_this_type: diag(2682, ts3.DiagnosticCategory.Error, "get_and_set_accessor_must_have_the_same_this_type_2682", "'get' and 'set' accessor must have the same 'this' type."),
        this_implicitly_has_type_any_because_it_does_not_have_a_type_annotation: diag(2683, ts3.DiagnosticCategory.Error, "this_implicitly_has_type_any_because_it_does_not_have_a_type_annotation_2683", "'this' implicitly has type 'any' because it does not have a type annotation."),
        The_this_context_of_type_0_is_not_assignable_to_method_s_this_of_type_1: diag(2684, ts3.DiagnosticCategory.Error, "The_this_context_of_type_0_is_not_assignable_to_method_s_this_of_type_1_2684", "The 'this' context of type '{0}' is not assignable to method's 'this' of type '{1}'."),
        The_this_types_of_each_signature_are_incompatible: diag(2685, ts3.DiagnosticCategory.Error, "The_this_types_of_each_signature_are_incompatible_2685", "The 'this' types of each signature are incompatible."),
        _0_refers_to_a_UMD_global_but_the_current_file_is_a_module_Consider_adding_an_import_instead: diag(2686, ts3.DiagnosticCategory.Error, "_0_refers_to_a_UMD_global_but_the_current_file_is_a_module_Consider_adding_an_import_instead_2686", "'{0}' refers to a UMD global, but the current file is a module. Consider adding an import instead."),
        All_declarations_of_0_must_have_identical_modifiers: diag(2687, ts3.DiagnosticCategory.Error, "All_declarations_of_0_must_have_identical_modifiers_2687", "All declarations of '{0}' must have identical modifiers."),
        Cannot_find_type_definition_file_for_0: diag(2688, ts3.DiagnosticCategory.Error, "Cannot_find_type_definition_file_for_0_2688", "Cannot find type definition file for '{0}'."),
        Cannot_extend_an_interface_0_Did_you_mean_implements: diag(2689, ts3.DiagnosticCategory.Error, "Cannot_extend_an_interface_0_Did_you_mean_implements_2689", "Cannot extend an interface '{0}'. Did you mean 'implements'?"),
        _0_only_refers_to_a_type_but_is_being_used_as_a_value_here_Did_you_mean_to_use_1_in_0: diag(2690, ts3.DiagnosticCategory.Error, "_0_only_refers_to_a_type_but_is_being_used_as_a_value_here_Did_you_mean_to_use_1_in_0_2690", "'{0}' only refers to a type, but is being used as a value here. Did you mean to use '{1} in {0}'?"),
        An_import_path_cannot_end_with_a_0_extension_Consider_importing_1_instead: diag(2691, ts3.DiagnosticCategory.Error, "An_import_path_cannot_end_with_a_0_extension_Consider_importing_1_instead_2691", "An import path cannot end with a '{0}' extension. Consider importing '{1}' instead."),
        _0_is_a_primitive_but_1_is_a_wrapper_object_Prefer_using_0_when_possible: diag(2692, ts3.DiagnosticCategory.Error, "_0_is_a_primitive_but_1_is_a_wrapper_object_Prefer_using_0_when_possible_2692", "'{0}' is a primitive, but '{1}' is a wrapper object. Prefer using '{0}' when possible."),
        _0_only_refers_to_a_type_but_is_being_used_as_a_value_here: diag(2693, ts3.DiagnosticCategory.Error, "_0_only_refers_to_a_type_but_is_being_used_as_a_value_here_2693", "'{0}' only refers to a type, but is being used as a value here."),
        Namespace_0_has_no_exported_member_1: diag(2694, ts3.DiagnosticCategory.Error, "Namespace_0_has_no_exported_member_1_2694", "Namespace '{0}' has no exported member '{1}'."),
        Left_side_of_comma_operator_is_unused_and_has_no_side_effects: diag(2695, ts3.DiagnosticCategory.Error, "Left_side_of_comma_operator_is_unused_and_has_no_side_effects_2695", "Left side of comma operator is unused and has no side effects.", true),
        The_Object_type_is_assignable_to_very_few_other_types_Did_you_mean_to_use_the_any_type_instead: diag(2696, ts3.DiagnosticCategory.Error, "The_Object_type_is_assignable_to_very_few_other_types_Did_you_mean_to_use_the_any_type_instead_2696", "The 'Object' type is assignable to very few other types. Did you mean to use the 'any' type instead?"),
        An_async_function_or_method_must_return_a_Promise_Make_sure_you_have_a_declaration_for_Promise_or_include_ES2015_in_your_lib_option: diag(2697, ts3.DiagnosticCategory.Error, "An_async_function_or_method_must_return_a_Promise_Make_sure_you_have_a_declaration_for_Promise_or_in_2697", "An async function or method must return a 'Promise'. Make sure you have a declaration for 'Promise' or include 'ES2015' in your '--lib' option."),
        Spread_types_may_only_be_created_from_object_types: diag(2698, ts3.DiagnosticCategory.Error, "Spread_types_may_only_be_created_from_object_types_2698", "Spread types may only be created from object types."),
        Static_property_0_conflicts_with_built_in_property_Function_0_of_constructor_function_1: diag(2699, ts3.DiagnosticCategory.Error, "Static_property_0_conflicts_with_built_in_property_Function_0_of_constructor_function_1_2699", "Static property '{0}' conflicts with built-in property 'Function.{0}' of constructor function '{1}'."),
        Rest_types_may_only_be_created_from_object_types: diag(2700, ts3.DiagnosticCategory.Error, "Rest_types_may_only_be_created_from_object_types_2700", "Rest types may only be created from object types."),
        The_target_of_an_object_rest_assignment_must_be_a_variable_or_a_property_access: diag(2701, ts3.DiagnosticCategory.Error, "The_target_of_an_object_rest_assignment_must_be_a_variable_or_a_property_access_2701", "The target of an object rest assignment must be a variable or a property access."),
        _0_only_refers_to_a_type_but_is_being_used_as_a_namespace_here: diag(2702, ts3.DiagnosticCategory.Error, "_0_only_refers_to_a_type_but_is_being_used_as_a_namespace_here_2702", "'{0}' only refers to a type, but is being used as a namespace here."),
        The_operand_of_a_delete_operator_must_be_a_property_reference: diag(2703, ts3.DiagnosticCategory.Error, "The_operand_of_a_delete_operator_must_be_a_property_reference_2703", "The operand of a 'delete' operator must be a property reference."),
        The_operand_of_a_delete_operator_cannot_be_a_read_only_property: diag(2704, ts3.DiagnosticCategory.Error, "The_operand_of_a_delete_operator_cannot_be_a_read_only_property_2704", "The operand of a 'delete' operator cannot be a read-only property."),
        An_async_function_or_method_in_ES5_SlashES3_requires_the_Promise_constructor_Make_sure_you_have_a_declaration_for_the_Promise_constructor_or_include_ES2015_in_your_lib_option: diag(2705, ts3.DiagnosticCategory.Error, "An_async_function_or_method_in_ES5_SlashES3_requires_the_Promise_constructor_Make_sure_you_have_a_de_2705", "An async function or method in ES5/ES3 requires the 'Promise' constructor.  Make sure you have a declaration for the 'Promise' constructor or include 'ES2015' in your '--lib' option."),
        Required_type_parameters_may_not_follow_optional_type_parameters: diag(2706, ts3.DiagnosticCategory.Error, "Required_type_parameters_may_not_follow_optional_type_parameters_2706", "Required type parameters may not follow optional type parameters."),
        Generic_type_0_requires_between_1_and_2_type_arguments: diag(2707, ts3.DiagnosticCategory.Error, "Generic_type_0_requires_between_1_and_2_type_arguments_2707", "Generic type '{0}' requires between {1} and {2} type arguments."),
        Cannot_use_namespace_0_as_a_value: diag(2708, ts3.DiagnosticCategory.Error, "Cannot_use_namespace_0_as_a_value_2708", "Cannot use namespace '{0}' as a value."),
        Cannot_use_namespace_0_as_a_type: diag(2709, ts3.DiagnosticCategory.Error, "Cannot_use_namespace_0_as_a_type_2709", "Cannot use namespace '{0}' as a type."),
        _0_are_specified_twice_The_attribute_named_0_will_be_overwritten: diag(2710, ts3.DiagnosticCategory.Error, "_0_are_specified_twice_The_attribute_named_0_will_be_overwritten_2710", "'{0}' are specified twice. The attribute named '{0}' will be overwritten."),
        A_dynamic_import_call_returns_a_Promise_Make_sure_you_have_a_declaration_for_Promise_or_include_ES2015_in_your_lib_option: diag(2711, ts3.DiagnosticCategory.Error, "A_dynamic_import_call_returns_a_Promise_Make_sure_you_have_a_declaration_for_Promise_or_include_ES20_2711", "A dynamic import call returns a 'Promise'. Make sure you have a declaration for 'Promise' or include 'ES2015' in your '--lib' option."),
        A_dynamic_import_call_in_ES5_SlashES3_requires_the_Promise_constructor_Make_sure_you_have_a_declaration_for_the_Promise_constructor_or_include_ES2015_in_your_lib_option: diag(2712, ts3.DiagnosticCategory.Error, "A_dynamic_import_call_in_ES5_SlashES3_requires_the_Promise_constructor_Make_sure_you_have_a_declarat_2712", "A dynamic import call in ES5/ES3 requires the 'Promise' constructor.  Make sure you have a declaration for the 'Promise' constructor or include 'ES2015' in your '--lib' option."),
        Cannot_access_0_1_because_0_is_a_type_but_not_a_namespace_Did_you_mean_to_retrieve_the_type_of_the_property_1_in_0_with_0_1: diag(2713, ts3.DiagnosticCategory.Error, "Cannot_access_0_1_because_0_is_a_type_but_not_a_namespace_Did_you_mean_to_retrieve_the_type_of_the_p_2713", `Cannot access '{0}.{1}' because '{0}' is a type, but not a namespace. Did you mean to retrieve the type of the property '{1}' in '{0}' with '{0}["{1}"]'?`),
        The_expression_of_an_export_assignment_must_be_an_identifier_or_qualified_name_in_an_ambient_context: diag(2714, ts3.DiagnosticCategory.Error, "The_expression_of_an_export_assignment_must_be_an_identifier_or_qualified_name_in_an_ambient_context_2714", "The expression of an export assignment must be an identifier or qualified name in an ambient context."),
        Abstract_property_0_in_class_1_cannot_be_accessed_in_the_constructor: diag(2715, ts3.DiagnosticCategory.Error, "Abstract_property_0_in_class_1_cannot_be_accessed_in_the_constructor_2715", "Abstract property '{0}' in class '{1}' cannot be accessed in the constructor."),
        Type_parameter_0_has_a_circular_default: diag(2716, ts3.DiagnosticCategory.Error, "Type_parameter_0_has_a_circular_default_2716", "Type parameter '{0}' has a circular default."),
        Subsequent_property_declarations_must_have_the_same_type_Property_0_must_be_of_type_1_but_here_has_type_2: diag(2717, ts3.DiagnosticCategory.Error, "Subsequent_property_declarations_must_have_the_same_type_Property_0_must_be_of_type_1_but_here_has_t_2717", "Subsequent property declarations must have the same type.  Property '{0}' must be of type '{1}', but here has type '{2}'."),
        Duplicate_property_0: diag(2718, ts3.DiagnosticCategory.Error, "Duplicate_property_0_2718", "Duplicate property '{0}'."),
        Type_0_is_not_assignable_to_type_1_Two_different_types_with_this_name_exist_but_they_are_unrelated: diag(2719, ts3.DiagnosticCategory.Error, "Type_0_is_not_assignable_to_type_1_Two_different_types_with_this_name_exist_but_they_are_unrelated_2719", "Type '{0}' is not assignable to type '{1}'. Two different types with this name exist, but they are unrelated."),
        Class_0_incorrectly_implements_class_1_Did_you_mean_to_extend_1_and_inherit_its_members_as_a_subclass: diag(2720, ts3.DiagnosticCategory.Error, "Class_0_incorrectly_implements_class_1_Did_you_mean_to_extend_1_and_inherit_its_members_as_a_subclas_2720", "Class '{0}' incorrectly implements class '{1}'. Did you mean to extend '{1}' and inherit its members as a subclass?"),
        Cannot_invoke_an_object_which_is_possibly_null: diag(2721, ts3.DiagnosticCategory.Error, "Cannot_invoke_an_object_which_is_possibly_null_2721", "Cannot invoke an object which is possibly 'null'."),
        Cannot_invoke_an_object_which_is_possibly_undefined: diag(2722, ts3.DiagnosticCategory.Error, "Cannot_invoke_an_object_which_is_possibly_undefined_2722", "Cannot invoke an object which is possibly 'undefined'."),
        Cannot_invoke_an_object_which_is_possibly_null_or_undefined: diag(2723, ts3.DiagnosticCategory.Error, "Cannot_invoke_an_object_which_is_possibly_null_or_undefined_2723", "Cannot invoke an object which is possibly 'null' or 'undefined'."),
        _0_has_no_exported_member_named_1_Did_you_mean_2: diag(2724, ts3.DiagnosticCategory.Error, "_0_has_no_exported_member_named_1_Did_you_mean_2_2724", "'{0}' has no exported member named '{1}'. Did you mean '{2}'?"),
        Class_name_cannot_be_Object_when_targeting_ES5_with_module_0: diag(2725, ts3.DiagnosticCategory.Error, "Class_name_cannot_be_Object_when_targeting_ES5_with_module_0_2725", "Class name cannot be 'Object' when targeting ES5 with module {0}."),
        Cannot_find_lib_definition_for_0: diag(2726, ts3.DiagnosticCategory.Error, "Cannot_find_lib_definition_for_0_2726", "Cannot find lib definition for '{0}'."),
        Cannot_find_lib_definition_for_0_Did_you_mean_1: diag(2727, ts3.DiagnosticCategory.Error, "Cannot_find_lib_definition_for_0_Did_you_mean_1_2727", "Cannot find lib definition for '{0}'. Did you mean '{1}'?"),
        _0_is_declared_here: diag(2728, ts3.DiagnosticCategory.Message, "_0_is_declared_here_2728", "'{0}' is declared here."),
        Property_0_is_used_before_its_initialization: diag(2729, ts3.DiagnosticCategory.Error, "Property_0_is_used_before_its_initialization_2729", "Property '{0}' is used before its initialization."),
        An_arrow_function_cannot_have_a_this_parameter: diag(2730, ts3.DiagnosticCategory.Error, "An_arrow_function_cannot_have_a_this_parameter_2730", "An arrow function cannot have a 'this' parameter."),
        Implicit_conversion_of_a_symbol_to_a_string_will_fail_at_runtime_Consider_wrapping_this_expression_in_String: diag(2731, ts3.DiagnosticCategory.Error, "Implicit_conversion_of_a_symbol_to_a_string_will_fail_at_runtime_Consider_wrapping_this_expression_i_2731", "Implicit conversion of a 'symbol' to a 'string' will fail at runtime. Consider wrapping this expression in 'String(...)'."),
        Cannot_find_module_0_Consider_using_resolveJsonModule_to_import_module_with_json_extension: diag(2732, ts3.DiagnosticCategory.Error, "Cannot_find_module_0_Consider_using_resolveJsonModule_to_import_module_with_json_extension_2732", "Cannot find module '{0}'. Consider using '--resolveJsonModule' to import module with '.json' extension."),
        Property_0_was_also_declared_here: diag(2733, ts3.DiagnosticCategory.Error, "Property_0_was_also_declared_here_2733", "Property '{0}' was also declared here."),
        Are_you_missing_a_semicolon: diag(2734, ts3.DiagnosticCategory.Error, "Are_you_missing_a_semicolon_2734", "Are you missing a semicolon?"),
        Did_you_mean_for_0_to_be_constrained_to_type_new_args_Colon_any_1: diag(2735, ts3.DiagnosticCategory.Error, "Did_you_mean_for_0_to_be_constrained_to_type_new_args_Colon_any_1_2735", "Did you mean for '{0}' to be constrained to type 'new (...args: any[]) => {1}'?"),
        Operator_0_cannot_be_applied_to_type_1: diag(2736, ts3.DiagnosticCategory.Error, "Operator_0_cannot_be_applied_to_type_1_2736", "Operator '{0}' cannot be applied to type '{1}'."),
        BigInt_literals_are_not_available_when_targeting_lower_than_ES2020: diag(2737, ts3.DiagnosticCategory.Error, "BigInt_literals_are_not_available_when_targeting_lower_than_ES2020_2737", "BigInt literals are not available when targeting lower than ES2020."),
        An_outer_value_of_this_is_shadowed_by_this_container: diag(2738, ts3.DiagnosticCategory.Message, "An_outer_value_of_this_is_shadowed_by_this_container_2738", "An outer value of 'this' is shadowed by this container."),
        Type_0_is_missing_the_following_properties_from_type_1_Colon_2: diag(2739, ts3.DiagnosticCategory.Error, "Type_0_is_missing_the_following_properties_from_type_1_Colon_2_2739", "Type '{0}' is missing the following properties from type '{1}': {2}"),
        Type_0_is_missing_the_following_properties_from_type_1_Colon_2_and_3_more: diag(2740, ts3.DiagnosticCategory.Error, "Type_0_is_missing_the_following_properties_from_type_1_Colon_2_and_3_more_2740", "Type '{0}' is missing the following properties from type '{1}': {2}, and {3} more."),
        Property_0_is_missing_in_type_1_but_required_in_type_2: diag(2741, ts3.DiagnosticCategory.Error, "Property_0_is_missing_in_type_1_but_required_in_type_2_2741", "Property '{0}' is missing in type '{1}' but required in type '{2}'."),
        The_inferred_type_of_0_cannot_be_named_without_a_reference_to_1_This_is_likely_not_portable_A_type_annotation_is_necessary: diag(2742, ts3.DiagnosticCategory.Error, "The_inferred_type_of_0_cannot_be_named_without_a_reference_to_1_This_is_likely_not_portable_A_type_a_2742", "The inferred type of '{0}' cannot be named without a reference to '{1}'. This is likely not portable. A type annotation is necessary."),
        No_overload_expects_0_type_arguments_but_overloads_do_exist_that_expect_either_1_or_2_type_arguments: diag(2743, ts3.DiagnosticCategory.Error, "No_overload_expects_0_type_arguments_but_overloads_do_exist_that_expect_either_1_or_2_type_arguments_2743", "No overload expects {0} type arguments, but overloads do exist that expect either {1} or {2} type arguments."),
        Type_parameter_defaults_can_only_reference_previously_declared_type_parameters: diag(2744, ts3.DiagnosticCategory.Error, "Type_parameter_defaults_can_only_reference_previously_declared_type_parameters_2744", "Type parameter defaults can only reference previously declared type parameters."),
        This_JSX_tag_s_0_prop_expects_type_1_which_requires_multiple_children_but_only_a_single_child_was_provided: diag(2745, ts3.DiagnosticCategory.Error, "This_JSX_tag_s_0_prop_expects_type_1_which_requires_multiple_children_but_only_a_single_child_was_pr_2745", "This JSX tag's '{0}' prop expects type '{1}' which requires multiple children, but only a single child was provided."),
        This_JSX_tag_s_0_prop_expects_a_single_child_of_type_1_but_multiple_children_were_provided: diag(2746, ts3.DiagnosticCategory.Error, "This_JSX_tag_s_0_prop_expects_a_single_child_of_type_1_but_multiple_children_were_provided_2746", "This JSX tag's '{0}' prop expects a single child of type '{1}', but multiple children were provided."),
        _0_components_don_t_accept_text_as_child_elements_Text_in_JSX_has_the_type_string_but_the_expected_type_of_1_is_2: diag(2747, ts3.DiagnosticCategory.Error, "_0_components_don_t_accept_text_as_child_elements_Text_in_JSX_has_the_type_string_but_the_expected_t_2747", "'{0}' components don't accept text as child elements. Text in JSX has the type 'string', but the expected type of '{1}' is '{2}'."),
        Cannot_access_ambient_const_enums_when_the_isolatedModules_flag_is_provided: diag(2748, ts3.DiagnosticCategory.Error, "Cannot_access_ambient_const_enums_when_the_isolatedModules_flag_is_provided_2748", "Cannot access ambient const enums when the '--isolatedModules' flag is provided."),
        _0_refers_to_a_value_but_is_being_used_as_a_type_here_Did_you_mean_typeof_0: diag(2749, ts3.DiagnosticCategory.Error, "_0_refers_to_a_value_but_is_being_used_as_a_type_here_Did_you_mean_typeof_0_2749", "'{0}' refers to a value, but is being used as a type here. Did you mean 'typeof {0}'?"),
        The_implementation_signature_is_declared_here: diag(2750, ts3.DiagnosticCategory.Error, "The_implementation_signature_is_declared_here_2750", "The implementation signature is declared here."),
        Circularity_originates_in_type_at_this_location: diag(2751, ts3.DiagnosticCategory.Error, "Circularity_originates_in_type_at_this_location_2751", "Circularity originates in type at this location."),
        The_first_export_default_is_here: diag(2752, ts3.DiagnosticCategory.Error, "The_first_export_default_is_here_2752", "The first export default is here."),
        Another_export_default_is_here: diag(2753, ts3.DiagnosticCategory.Error, "Another_export_default_is_here_2753", "Another export default is here."),
        super_may_not_use_type_arguments: diag(2754, ts3.DiagnosticCategory.Error, "super_may_not_use_type_arguments_2754", "'super' may not use type arguments."),
        No_constituent_of_type_0_is_callable: diag(2755, ts3.DiagnosticCategory.Error, "No_constituent_of_type_0_is_callable_2755", "No constituent of type '{0}' is callable."),
        Not_all_constituents_of_type_0_are_callable: diag(2756, ts3.DiagnosticCategory.Error, "Not_all_constituents_of_type_0_are_callable_2756", "Not all constituents of type '{0}' are callable."),
        Type_0_has_no_call_signatures: diag(2757, ts3.DiagnosticCategory.Error, "Type_0_has_no_call_signatures_2757", "Type '{0}' has no call signatures."),
        Each_member_of_the_union_type_0_has_signatures_but_none_of_those_signatures_are_compatible_with_each_other: diag(2758, ts3.DiagnosticCategory.Error, "Each_member_of_the_union_type_0_has_signatures_but_none_of_those_signatures_are_compatible_with_each_2758", "Each member of the union type '{0}' has signatures, but none of those signatures are compatible with each other."),
        No_constituent_of_type_0_is_constructable: diag(2759, ts3.DiagnosticCategory.Error, "No_constituent_of_type_0_is_constructable_2759", "No constituent of type '{0}' is constructable."),
        Not_all_constituents_of_type_0_are_constructable: diag(2760, ts3.DiagnosticCategory.Error, "Not_all_constituents_of_type_0_are_constructable_2760", "Not all constituents of type '{0}' are constructable."),
        Type_0_has_no_construct_signatures: diag(2761, ts3.DiagnosticCategory.Error, "Type_0_has_no_construct_signatures_2761", "Type '{0}' has no construct signatures."),
        Each_member_of_the_union_type_0_has_construct_signatures_but_none_of_those_signatures_are_compatible_with_each_other: diag(2762, ts3.DiagnosticCategory.Error, "Each_member_of_the_union_type_0_has_construct_signatures_but_none_of_those_signatures_are_compatible_2762", "Each member of the union type '{0}' has construct signatures, but none of those signatures are compatible with each other."),
        Cannot_iterate_value_because_the_next_method_of_its_iterator_expects_type_1_but_for_of_will_always_send_0: diag(2763, ts3.DiagnosticCategory.Error, "Cannot_iterate_value_because_the_next_method_of_its_iterator_expects_type_1_but_for_of_will_always_s_2763", "Cannot iterate value because the 'next' method of its iterator expects type '{1}', but for-of will always send '{0}'."),
        Cannot_iterate_value_because_the_next_method_of_its_iterator_expects_type_1_but_array_spread_will_always_send_0: diag(2764, ts3.DiagnosticCategory.Error, "Cannot_iterate_value_because_the_next_method_of_its_iterator_expects_type_1_but_array_spread_will_al_2764", "Cannot iterate value because the 'next' method of its iterator expects type '{1}', but array spread will always send '{0}'."),
        Cannot_iterate_value_because_the_next_method_of_its_iterator_expects_type_1_but_array_destructuring_will_always_send_0: diag(2765, ts3.DiagnosticCategory.Error, "Cannot_iterate_value_because_the_next_method_of_its_iterator_expects_type_1_but_array_destructuring__2765", "Cannot iterate value because the 'next' method of its iterator expects type '{1}', but array destructuring will always send '{0}'."),
        Cannot_delegate_iteration_to_value_because_the_next_method_of_its_iterator_expects_type_1_but_the_containing_generator_will_always_send_0: diag(2766, ts3.DiagnosticCategory.Error, "Cannot_delegate_iteration_to_value_because_the_next_method_of_its_iterator_expects_type_1_but_the_co_2766", "Cannot delegate iteration to value because the 'next' method of its iterator expects type '{1}', but the containing generator will always send '{0}'."),
        The_0_property_of_an_iterator_must_be_a_method: diag(2767, ts3.DiagnosticCategory.Error, "The_0_property_of_an_iterator_must_be_a_method_2767", "The '{0}' property of an iterator must be a method."),
        The_0_property_of_an_async_iterator_must_be_a_method: diag(2768, ts3.DiagnosticCategory.Error, "The_0_property_of_an_async_iterator_must_be_a_method_2768", "The '{0}' property of an async iterator must be a method."),
        No_overload_matches_this_call: diag(2769, ts3.DiagnosticCategory.Error, "No_overload_matches_this_call_2769", "No overload matches this call."),
        The_last_overload_gave_the_following_error: diag(2770, ts3.DiagnosticCategory.Error, "The_last_overload_gave_the_following_error_2770", "The last overload gave the following error."),
        The_last_overload_is_declared_here: diag(2771, ts3.DiagnosticCategory.Error, "The_last_overload_is_declared_here_2771", "The last overload is declared here."),
        Overload_0_of_1_2_gave_the_following_error: diag(2772, ts3.DiagnosticCategory.Error, "Overload_0_of_1_2_gave_the_following_error_2772", "Overload {0} of {1}, '{2}', gave the following error."),
        Did_you_forget_to_use_await: diag(2773, ts3.DiagnosticCategory.Error, "Did_you_forget_to_use_await_2773", "Did you forget to use 'await'?"),
        This_condition_will_always_return_true_since_this_function_is_always_defined_Did_you_mean_to_call_it_instead: diag(2774, ts3.DiagnosticCategory.Error, "This_condition_will_always_return_true_since_this_function_is_always_defined_Did_you_mean_to_call_it_2774", "This condition will always return true since this function is always defined. Did you mean to call it instead?"),
        Assertions_require_every_name_in_the_call_target_to_be_declared_with_an_explicit_type_annotation: diag(2775, ts3.DiagnosticCategory.Error, "Assertions_require_every_name_in_the_call_target_to_be_declared_with_an_explicit_type_annotation_2775", "Assertions require every name in the call target to be declared with an explicit type annotation."),
        Assertions_require_the_call_target_to_be_an_identifier_or_qualified_name: diag(2776, ts3.DiagnosticCategory.Error, "Assertions_require_the_call_target_to_be_an_identifier_or_qualified_name_2776", "Assertions require the call target to be an identifier or qualified name."),
        The_operand_of_an_increment_or_decrement_operator_may_not_be_an_optional_property_access: diag(2777, ts3.DiagnosticCategory.Error, "The_operand_of_an_increment_or_decrement_operator_may_not_be_an_optional_property_access_2777", "The operand of an increment or decrement operator may not be an optional property access."),
        The_target_of_an_object_rest_assignment_may_not_be_an_optional_property_access: diag(2778, ts3.DiagnosticCategory.Error, "The_target_of_an_object_rest_assignment_may_not_be_an_optional_property_access_2778", "The target of an object rest assignment may not be an optional property access."),
        The_left_hand_side_of_an_assignment_expression_may_not_be_an_optional_property_access: diag(2779, ts3.DiagnosticCategory.Error, "The_left_hand_side_of_an_assignment_expression_may_not_be_an_optional_property_access_2779", "The left-hand side of an assignment expression may not be an optional property access."),
        The_left_hand_side_of_a_for_in_statement_may_not_be_an_optional_property_access: diag(2780, ts3.DiagnosticCategory.Error, "The_left_hand_side_of_a_for_in_statement_may_not_be_an_optional_property_access_2780", "The left-hand side of a 'for...in' statement may not be an optional property access."),
        The_left_hand_side_of_a_for_of_statement_may_not_be_an_optional_property_access: diag(2781, ts3.DiagnosticCategory.Error, "The_left_hand_side_of_a_for_of_statement_may_not_be_an_optional_property_access_2781", "The left-hand side of a 'for...of' statement may not be an optional property access."),
        _0_needs_an_explicit_type_annotation: diag(2782, ts3.DiagnosticCategory.Message, "_0_needs_an_explicit_type_annotation_2782", "'{0}' needs an explicit type annotation."),
        _0_is_specified_more_than_once_so_this_usage_will_be_overwritten: diag(2783, ts3.DiagnosticCategory.Error, "_0_is_specified_more_than_once_so_this_usage_will_be_overwritten_2783", "'{0}' is specified more than once, so this usage will be overwritten."),
        get_and_set_accessors_cannot_declare_this_parameters: diag(2784, ts3.DiagnosticCategory.Error, "get_and_set_accessors_cannot_declare_this_parameters_2784", "'get' and 'set' accessors cannot declare 'this' parameters."),
        This_spread_always_overwrites_this_property: diag(2785, ts3.DiagnosticCategory.Error, "This_spread_always_overwrites_this_property_2785", "This spread always overwrites this property."),
        _0_cannot_be_used_as_a_JSX_component: diag(2786, ts3.DiagnosticCategory.Error, "_0_cannot_be_used_as_a_JSX_component_2786", "'{0}' cannot be used as a JSX component."),
        Its_return_type_0_is_not_a_valid_JSX_element: diag(2787, ts3.DiagnosticCategory.Error, "Its_return_type_0_is_not_a_valid_JSX_element_2787", "Its return type '{0}' is not a valid JSX element."),
        Its_instance_type_0_is_not_a_valid_JSX_element: diag(2788, ts3.DiagnosticCategory.Error, "Its_instance_type_0_is_not_a_valid_JSX_element_2788", "Its instance type '{0}' is not a valid JSX element."),
        Its_element_type_0_is_not_a_valid_JSX_element: diag(2789, ts3.DiagnosticCategory.Error, "Its_element_type_0_is_not_a_valid_JSX_element_2789", "Its element type '{0}' is not a valid JSX element."),
        The_operand_of_a_delete_operator_must_be_optional: diag(2790, ts3.DiagnosticCategory.Error, "The_operand_of_a_delete_operator_must_be_optional_2790", "The operand of a 'delete' operator must be optional."),
        Exponentiation_cannot_be_performed_on_bigint_values_unless_the_target_option_is_set_to_es2016_or_later: diag(2791, ts3.DiagnosticCategory.Error, "Exponentiation_cannot_be_performed_on_bigint_values_unless_the_target_option_is_set_to_es2016_or_lat_2791", "Exponentiation cannot be performed on 'bigint' values unless the 'target' option is set to 'es2016' or later."),
        Cannot_find_module_0_Did_you_mean_to_set_the_moduleResolution_option_to_node_or_to_add_aliases_to_the_paths_option: diag(2792, ts3.DiagnosticCategory.Error, "Cannot_find_module_0_Did_you_mean_to_set_the_moduleResolution_option_to_node_or_to_add_aliases_to_th_2792", "Cannot find module '{0}'. Did you mean to set the 'moduleResolution' option to 'node', or to add aliases to the 'paths' option?"),
        The_call_would_have_succeeded_against_this_implementation_but_implementation_signatures_of_overloads_are_not_externally_visible: diag(2793, ts3.DiagnosticCategory.Error, "The_call_would_have_succeeded_against_this_implementation_but_implementation_signatures_of_overloads_2793", "The call would have succeeded against this implementation, but implementation signatures of overloads are not externally visible."),
        Expected_0_arguments_but_got_1_Did_you_forget_to_include_void_in_your_type_argument_to_Promise: diag(2794, ts3.DiagnosticCategory.Error, "Expected_0_arguments_but_got_1_Did_you_forget_to_include_void_in_your_type_argument_to_Promise_2794", "Expected {0} arguments, but got {1}. Did you forget to include 'void' in your type argument to 'Promise'?"),
        The_intrinsic_keyword_can_only_be_used_to_declare_compiler_provided_intrinsic_types: diag(2795, ts3.DiagnosticCategory.Error, "The_intrinsic_keyword_can_only_be_used_to_declare_compiler_provided_intrinsic_types_2795", "The 'intrinsic' keyword can only be used to declare compiler provided intrinsic types."),
        It_is_likely_that_you_are_missing_a_comma_to_separate_these_two_template_expressions_They_form_a_tagged_template_expression_which_cannot_be_invoked: diag(2796, ts3.DiagnosticCategory.Error, "It_is_likely_that_you_are_missing_a_comma_to_separate_these_two_template_expressions_They_form_a_tag_2796", "It is likely that you are missing a comma to separate these two template expressions. They form a tagged template expression which cannot be invoked."),
        A_mixin_class_that_extends_from_a_type_variable_containing_an_abstract_construct_signature_must_also_be_declared_abstract: diag(2797, ts3.DiagnosticCategory.Error, "A_mixin_class_that_extends_from_a_type_variable_containing_an_abstract_construct_signature_must_also_2797", "A mixin class that extends from a type variable containing an abstract construct signature must also be declared 'abstract'."),
        The_declaration_was_marked_as_deprecated_here: diag(2798, ts3.DiagnosticCategory.Error, "The_declaration_was_marked_as_deprecated_here_2798", "The declaration was marked as deprecated here."),
        Type_produces_a_tuple_type_that_is_too_large_to_represent: diag(2799, ts3.DiagnosticCategory.Error, "Type_produces_a_tuple_type_that_is_too_large_to_represent_2799", "Type produces a tuple type that is too large to represent."),
        Expression_produces_a_tuple_type_that_is_too_large_to_represent: diag(2800, ts3.DiagnosticCategory.Error, "Expression_produces_a_tuple_type_that_is_too_large_to_represent_2800", "Expression produces a tuple type that is too large to represent."),
        This_condition_will_always_return_true_since_this_0_is_always_defined: diag(2801, ts3.DiagnosticCategory.Error, "This_condition_will_always_return_true_since_this_0_is_always_defined_2801", "This condition will always return true since this '{0}' is always defined."),
        Type_0_can_only_be_iterated_through_when_using_the_downlevelIteration_flag_or_with_a_target_of_es2015_or_higher: diag(2802, ts3.DiagnosticCategory.Error, "Type_0_can_only_be_iterated_through_when_using_the_downlevelIteration_flag_or_with_a_target_of_es201_2802", "Type '{0}' can only be iterated through when using the '--downlevelIteration' flag or with a '--target' of 'es2015' or higher."),
        Cannot_assign_to_private_method_0_Private_methods_are_not_writable: diag(2803, ts3.DiagnosticCategory.Error, "Cannot_assign_to_private_method_0_Private_methods_are_not_writable_2803", "Cannot assign to private method '{0}'. Private methods are not writable."),
        Duplicate_identifier_0_Static_and_instance_elements_cannot_share_the_same_private_name: diag(2804, ts3.DiagnosticCategory.Error, "Duplicate_identifier_0_Static_and_instance_elements_cannot_share_the_same_private_name_2804", "Duplicate identifier '{0}'. Static and instance elements cannot share the same private name."),
        Static_fields_with_private_names_can_t_have_initializers_when_the_useDefineForClassFields_flag_is_not_specified_with_a_target_of_esnext_Consider_adding_the_useDefineForClassFields_flag: diag(2805, ts3.DiagnosticCategory.Error, "Static_fields_with_private_names_can_t_have_initializers_when_the_useDefineForClassFields_flag_is_no_2805", "Static fields with private names can't have initializers when the '--useDefineForClassFields' flag is not specified with a '--target' of 'esnext'. Consider adding the '--useDefineForClassFields' flag."),
        Private_accessor_was_defined_without_a_getter: diag(2806, ts3.DiagnosticCategory.Error, "Private_accessor_was_defined_without_a_getter_2806", "Private accessor was defined without a getter."),
        This_syntax_requires_an_imported_helper_named_1_with_2_parameters_which_is_not_compatible_with_the_one_in_0_Consider_upgrading_your_version_of_0: diag(2807, ts3.DiagnosticCategory.Error, "This_syntax_requires_an_imported_helper_named_1_with_2_parameters_which_is_not_compatible_with_the_o_2807", "This syntax requires an imported helper named '{1}' with {2} parameters, which is not compatible with the one in '{0}'. Consider upgrading your version of '{0}'."),
        A_get_accessor_must_be_at_least_as_accessible_as_the_setter: diag(2808, ts3.DiagnosticCategory.Error, "A_get_accessor_must_be_at_least_as_accessible_as_the_setter_2808", "A get accessor must be at least as accessible as the setter"),
        Declaration_or_statement_expected_This_follows_a_block_of_statements_so_if_you_intended_to_write_a_destructuring_assignment_you_might_need_to_wrap_the_the_whole_assignment_in_parentheses: diag(2809, ts3.DiagnosticCategory.Error, "Declaration_or_statement_expected_This_follows_a_block_of_statements_so_if_you_intended_to_write_a_d_2809", "Declaration or statement expected. This '=' follows a block of statements, so if you intended to write a destructuring assignment, you might need to wrap the the whole assignment in parentheses."),
        Property_0_may_not_be_used_in_a_static_property_s_initializer_in_the_same_class_when_target_is_esnext_and_useDefineForClassFields_is_false: diag(2810, ts3.DiagnosticCategory.Error, "Property_0_may_not_be_used_in_a_static_property_s_initializer_in_the_same_class_when_target_is_esnex_2810", "Property '{0}' may not be used in a static property's initializer in the same class when 'target' is 'esnext' and 'useDefineForClassFields' is 'false'."),
        Initializer_for_property_0: diag(2811, ts3.DiagnosticCategory.Error, "Initializer_for_property_0_2811", "Initializer for property '{0}'"),
        Property_0_does_not_exist_on_type_1_Try_changing_the_lib_compiler_option_to_include_dom: diag(2812, ts3.DiagnosticCategory.Error, "Property_0_does_not_exist_on_type_1_Try_changing_the_lib_compiler_option_to_include_dom_2812", "Property '{0}' does not exist on type '{1}'. Try changing the 'lib' compiler option to include 'dom'."),
        Import_declaration_0_is_using_private_name_1: diag(4e3, ts3.DiagnosticCategory.Error, "Import_declaration_0_is_using_private_name_1_4000", "Import declaration '{0}' is using private name '{1}'."),
        Type_parameter_0_of_exported_class_has_or_is_using_private_name_1: diag(4002, ts3.DiagnosticCategory.Error, "Type_parameter_0_of_exported_class_has_or_is_using_private_name_1_4002", "Type parameter '{0}' of exported class has or is using private name '{1}'."),
        Type_parameter_0_of_exported_interface_has_or_is_using_private_name_1: diag(4004, ts3.DiagnosticCategory.Error, "Type_parameter_0_of_exported_interface_has_or_is_using_private_name_1_4004", "Type parameter '{0}' of exported interface has or is using private name '{1}'."),
        Type_parameter_0_of_constructor_signature_from_exported_interface_has_or_is_using_private_name_1: diag(4006, ts3.DiagnosticCategory.Error, "Type_parameter_0_of_constructor_signature_from_exported_interface_has_or_is_using_private_name_1_4006", "Type parameter '{0}' of constructor signature from exported interface has or is using private name '{1}'."),
        Type_parameter_0_of_call_signature_from_exported_interface_has_or_is_using_private_name_1: diag(4008, ts3.DiagnosticCategory.Error, "Type_parameter_0_of_call_signature_from_exported_interface_has_or_is_using_private_name_1_4008", "Type parameter '{0}' of call signature from exported interface has or is using private name '{1}'."),
        Type_parameter_0_of_public_static_method_from_exported_class_has_or_is_using_private_name_1: diag(4010, ts3.DiagnosticCategory.Error, "Type_parameter_0_of_public_static_method_from_exported_class_has_or_is_using_private_name_1_4010", "Type parameter '{0}' of public static method from exported class has or is using private name '{1}'."),
        Type_parameter_0_of_public_method_from_exported_class_has_or_is_using_private_name_1: diag(4012, ts3.DiagnosticCategory.Error, "Type_parameter_0_of_public_method_from_exported_class_has_or_is_using_private_name_1_4012", "Type parameter '{0}' of public method from exported class has or is using private name '{1}'."),
        Type_parameter_0_of_method_from_exported_interface_has_or_is_using_private_name_1: diag(4014, ts3.DiagnosticCategory.Error, "Type_parameter_0_of_method_from_exported_interface_has_or_is_using_private_name_1_4014", "Type parameter '{0}' of method from exported interface has or is using private name '{1}'."),
        Type_parameter_0_of_exported_function_has_or_is_using_private_name_1: diag(4016, ts3.DiagnosticCategory.Error, "Type_parameter_0_of_exported_function_has_or_is_using_private_name_1_4016", "Type parameter '{0}' of exported function has or is using private name '{1}'."),
        Implements_clause_of_exported_class_0_has_or_is_using_private_name_1: diag(4019, ts3.DiagnosticCategory.Error, "Implements_clause_of_exported_class_0_has_or_is_using_private_name_1_4019", "Implements clause of exported class '{0}' has or is using private name '{1}'."),
        extends_clause_of_exported_class_0_has_or_is_using_private_name_1: diag(4020, ts3.DiagnosticCategory.Error, "extends_clause_of_exported_class_0_has_or_is_using_private_name_1_4020", "'extends' clause of exported class '{0}' has or is using private name '{1}'."),
        extends_clause_of_exported_class_has_or_is_using_private_name_0: diag(4021, ts3.DiagnosticCategory.Error, "extends_clause_of_exported_class_has_or_is_using_private_name_0_4021", "'extends' clause of exported class has or is using private name '{0}'."),
        extends_clause_of_exported_interface_0_has_or_is_using_private_name_1: diag(4022, ts3.DiagnosticCategory.Error, "extends_clause_of_exported_interface_0_has_or_is_using_private_name_1_4022", "'extends' clause of exported interface '{0}' has or is using private name '{1}'."),
        Exported_variable_0_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named: diag(4023, ts3.DiagnosticCategory.Error, "Exported_variable_0_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named_4023", "Exported variable '{0}' has or is using name '{1}' from external module {2} but cannot be named."),
        Exported_variable_0_has_or_is_using_name_1_from_private_module_2: diag(4024, ts3.DiagnosticCategory.Error, "Exported_variable_0_has_or_is_using_name_1_from_private_module_2_4024", "Exported variable '{0}' has or is using name '{1}' from private module '{2}'."),
        Exported_variable_0_has_or_is_using_private_name_1: diag(4025, ts3.DiagnosticCategory.Error, "Exported_variable_0_has_or_is_using_private_name_1_4025", "Exported variable '{0}' has or is using private name '{1}'."),
        Public_static_property_0_of_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named: diag(4026, ts3.DiagnosticCategory.Error, "Public_static_property_0_of_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot__4026", "Public static property '{0}' of exported class has or is using name '{1}' from external module {2} but cannot be named."),
        Public_static_property_0_of_exported_class_has_or_is_using_name_1_from_private_module_2: diag(4027, ts3.DiagnosticCategory.Error, "Public_static_property_0_of_exported_class_has_or_is_using_name_1_from_private_module_2_4027", "Public static property '{0}' of exported class has or is using name '{1}' from private module '{2}'."),
        Public_static_property_0_of_exported_class_has_or_is_using_private_name_1: diag(4028, ts3.DiagnosticCategory.Error, "Public_static_property_0_of_exported_class_has_or_is_using_private_name_1_4028", "Public static property '{0}' of exported class has or is using private name '{1}'."),
        Public_property_0_of_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named: diag(4029, ts3.DiagnosticCategory.Error, "Public_property_0_of_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_name_4029", "Public property '{0}' of exported class has or is using name '{1}' from external module {2} but cannot be named."),
        Public_property_0_of_exported_class_has_or_is_using_name_1_from_private_module_2: diag(4030, ts3.DiagnosticCategory.Error, "Public_property_0_of_exported_class_has_or_is_using_name_1_from_private_module_2_4030", "Public property '{0}' of exported class has or is using name '{1}' from private module '{2}'."),
        Public_property_0_of_exported_class_has_or_is_using_private_name_1: diag(4031, ts3.DiagnosticCategory.Error, "Public_property_0_of_exported_class_has_or_is_using_private_name_1_4031", "Public property '{0}' of exported class has or is using private name '{1}'."),
        Property_0_of_exported_interface_has_or_is_using_name_1_from_private_module_2: diag(4032, ts3.DiagnosticCategory.Error, "Property_0_of_exported_interface_has_or_is_using_name_1_from_private_module_2_4032", "Property '{0}' of exported interface has or is using name '{1}' from private module '{2}'."),
        Property_0_of_exported_interface_has_or_is_using_private_name_1: diag(4033, ts3.DiagnosticCategory.Error, "Property_0_of_exported_interface_has_or_is_using_private_name_1_4033", "Property '{0}' of exported interface has or is using private name '{1}'."),
        Parameter_type_of_public_static_setter_0_from_exported_class_has_or_is_using_name_1_from_private_module_2: diag(4034, ts3.DiagnosticCategory.Error, "Parameter_type_of_public_static_setter_0_from_exported_class_has_or_is_using_name_1_from_private_mod_4034", "Parameter type of public static setter '{0}' from exported class has or is using name '{1}' from private module '{2}'."),
        Parameter_type_of_public_static_setter_0_from_exported_class_has_or_is_using_private_name_1: diag(4035, ts3.DiagnosticCategory.Error, "Parameter_type_of_public_static_setter_0_from_exported_class_has_or_is_using_private_name_1_4035", "Parameter type of public static setter '{0}' from exported class has or is using private name '{1}'."),
        Parameter_type_of_public_setter_0_from_exported_class_has_or_is_using_name_1_from_private_module_2: diag(4036, ts3.DiagnosticCategory.Error, "Parameter_type_of_public_setter_0_from_exported_class_has_or_is_using_name_1_from_private_module_2_4036", "Parameter type of public setter '{0}' from exported class has or is using name '{1}' from private module '{2}'."),
        Parameter_type_of_public_setter_0_from_exported_class_has_or_is_using_private_name_1: diag(4037, ts3.DiagnosticCategory.Error, "Parameter_type_of_public_setter_0_from_exported_class_has_or_is_using_private_name_1_4037", "Parameter type of public setter '{0}' from exported class has or is using private name '{1}'."),
        Return_type_of_public_static_getter_0_from_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named: diag(4038, ts3.DiagnosticCategory.Error, "Return_type_of_public_static_getter_0_from_exported_class_has_or_is_using_name_1_from_external_modul_4038", "Return type of public static getter '{0}' from exported class has or is using name '{1}' from external module {2} but cannot be named."),
        Return_type_of_public_static_getter_0_from_exported_class_has_or_is_using_name_1_from_private_module_2: diag(4039, ts3.DiagnosticCategory.Error, "Return_type_of_public_static_getter_0_from_exported_class_has_or_is_using_name_1_from_private_module_4039", "Return type of public static getter '{0}' from exported class has or is using name '{1}' from private module '{2}'."),
        Return_type_of_public_static_getter_0_from_exported_class_has_or_is_using_private_name_1: diag(4040, ts3.DiagnosticCategory.Error, "Return_type_of_public_static_getter_0_from_exported_class_has_or_is_using_private_name_1_4040", "Return type of public static getter '{0}' from exported class has or is using private name '{1}'."),
        Return_type_of_public_getter_0_from_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named: diag(4041, ts3.DiagnosticCategory.Error, "Return_type_of_public_getter_0_from_exported_class_has_or_is_using_name_1_from_external_module_2_but_4041", "Return type of public getter '{0}' from exported class has or is using name '{1}' from external module {2} but cannot be named."),
        Return_type_of_public_getter_0_from_exported_class_has_or_is_using_name_1_from_private_module_2: diag(4042, ts3.DiagnosticCategory.Error, "Return_type_of_public_getter_0_from_exported_class_has_or_is_using_name_1_from_private_module_2_4042", "Return type of public getter '{0}' from exported class has or is using name '{1}' from private module '{2}'."),
        Return_type_of_public_getter_0_from_exported_class_has_or_is_using_private_name_1: diag(4043, ts3.DiagnosticCategory.Error, "Return_type_of_public_getter_0_from_exported_class_has_or_is_using_private_name_1_4043", "Return type of public getter '{0}' from exported class has or is using private name '{1}'."),
        Return_type_of_constructor_signature_from_exported_interface_has_or_is_using_name_0_from_private_module_1: diag(4044, ts3.DiagnosticCategory.Error, "Return_type_of_constructor_signature_from_exported_interface_has_or_is_using_name_0_from_private_mod_4044", "Return type of constructor signature from exported interface has or is using name '{0}' from private module '{1}'."),
        Return_type_of_constructor_signature_from_exported_interface_has_or_is_using_private_name_0: diag(4045, ts3.DiagnosticCategory.Error, "Return_type_of_constructor_signature_from_exported_interface_has_or_is_using_private_name_0_4045", "Return type of constructor signature from exported interface has or is using private name '{0}'."),
        Return_type_of_call_signature_from_exported_interface_has_or_is_using_name_0_from_private_module_1: diag(4046, ts3.DiagnosticCategory.Error, "Return_type_of_call_signature_from_exported_interface_has_or_is_using_name_0_from_private_module_1_4046", "Return type of call signature from exported interface has or is using name '{0}' from private module '{1}'."),
        Return_type_of_call_signature_from_exported_interface_has_or_is_using_private_name_0: diag(4047, ts3.DiagnosticCategory.Error, "Return_type_of_call_signature_from_exported_interface_has_or_is_using_private_name_0_4047", "Return type of call signature from exported interface has or is using private name '{0}'."),
        Return_type_of_index_signature_from_exported_interface_has_or_is_using_name_0_from_private_module_1: diag(4048, ts3.DiagnosticCategory.Error, "Return_type_of_index_signature_from_exported_interface_has_or_is_using_name_0_from_private_module_1_4048", "Return type of index signature from exported interface has or is using name '{0}' from private module '{1}'."),
        Return_type_of_index_signature_from_exported_interface_has_or_is_using_private_name_0: diag(4049, ts3.DiagnosticCategory.Error, "Return_type_of_index_signature_from_exported_interface_has_or_is_using_private_name_0_4049", "Return type of index signature from exported interface has or is using private name '{0}'."),
        Return_type_of_public_static_method_from_exported_class_has_or_is_using_name_0_from_external_module_1_but_cannot_be_named: diag(4050, ts3.DiagnosticCategory.Error, "Return_type_of_public_static_method_from_exported_class_has_or_is_using_name_0_from_external_module__4050", "Return type of public static method from exported class has or is using name '{0}' from external module {1} but cannot be named."),
        Return_type_of_public_static_method_from_exported_class_has_or_is_using_name_0_from_private_module_1: diag(4051, ts3.DiagnosticCategory.Error, "Return_type_of_public_static_method_from_exported_class_has_or_is_using_name_0_from_private_module_1_4051", "Return type of public static method from exported class has or is using name '{0}' from private module '{1}'."),
        Return_type_of_public_static_method_from_exported_class_has_or_is_using_private_name_0: diag(4052, ts3.DiagnosticCategory.Error, "Return_type_of_public_static_method_from_exported_class_has_or_is_using_private_name_0_4052", "Return type of public static method from exported class has or is using private name '{0}'."),
        Return_type_of_public_method_from_exported_class_has_or_is_using_name_0_from_external_module_1_but_cannot_be_named: diag(4053, ts3.DiagnosticCategory.Error, "Return_type_of_public_method_from_exported_class_has_or_is_using_name_0_from_external_module_1_but_c_4053", "Return type of public method from exported class has or is using name '{0}' from external module {1} but cannot be named."),
        Return_type_of_public_method_from_exported_class_has_or_is_using_name_0_from_private_module_1: diag(4054, ts3.DiagnosticCategory.Error, "Return_type_of_public_method_from_exported_class_has_or_is_using_name_0_from_private_module_1_4054", "Return type of public method from exported class has or is using name '{0}' from private module '{1}'."),
        Return_type_of_public_method_from_exported_class_has_or_is_using_private_name_0: diag(4055, ts3.DiagnosticCategory.Error, "Return_type_of_public_method_from_exported_class_has_or_is_using_private_name_0_4055", "Return type of public method from exported class has or is using private name '{0}'."),
        Return_type_of_method_from_exported_interface_has_or_is_using_name_0_from_private_module_1: diag(4056, ts3.DiagnosticCategory.Error, "Return_type_of_method_from_exported_interface_has_or_is_using_name_0_from_private_module_1_4056", "Return type of method from exported interface has or is using name '{0}' from private module '{1}'."),
        Return_type_of_method_from_exported_interface_has_or_is_using_private_name_0: diag(4057, ts3.DiagnosticCategory.Error, "Return_type_of_method_from_exported_interface_has_or_is_using_private_name_0_4057", "Return type of method from exported interface has or is using private name '{0}'."),
        Return_type_of_exported_function_has_or_is_using_name_0_from_external_module_1_but_cannot_be_named: diag(4058, ts3.DiagnosticCategory.Error, "Return_type_of_exported_function_has_or_is_using_name_0_from_external_module_1_but_cannot_be_named_4058", "Return type of exported function has or is using name '{0}' from external module {1} but cannot be named."),
        Return_type_of_exported_function_has_or_is_using_name_0_from_private_module_1: diag(4059, ts3.DiagnosticCategory.Error, "Return_type_of_exported_function_has_or_is_using_name_0_from_private_module_1_4059", "Return type of exported function has or is using name '{0}' from private module '{1}'."),
        Return_type_of_exported_function_has_or_is_using_private_name_0: diag(4060, ts3.DiagnosticCategory.Error, "Return_type_of_exported_function_has_or_is_using_private_name_0_4060", "Return type of exported function has or is using private name '{0}'."),
        Parameter_0_of_constructor_from_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named: diag(4061, ts3.DiagnosticCategory.Error, "Parameter_0_of_constructor_from_exported_class_has_or_is_using_name_1_from_external_module_2_but_can_4061", "Parameter '{0}' of constructor from exported class has or is using name '{1}' from external module {2} but cannot be named."),
        Parameter_0_of_constructor_from_exported_class_has_or_is_using_name_1_from_private_module_2: diag(4062, ts3.DiagnosticCategory.Error, "Parameter_0_of_constructor_from_exported_class_has_or_is_using_name_1_from_private_module_2_4062", "Parameter '{0}' of constructor from exported class has or is using name '{1}' from private module '{2}'."),
        Parameter_0_of_constructor_from_exported_class_has_or_is_using_private_name_1: diag(4063, ts3.DiagnosticCategory.Error, "Parameter_0_of_constructor_from_exported_class_has_or_is_using_private_name_1_4063", "Parameter '{0}' of constructor from exported class has or is using private name '{1}'."),
        Parameter_0_of_constructor_signature_from_exported_interface_has_or_is_using_name_1_from_private_module_2: diag(4064, ts3.DiagnosticCategory.Error, "Parameter_0_of_constructor_signature_from_exported_interface_has_or_is_using_name_1_from_private_mod_4064", "Parameter '{0}' of constructor signature from exported interface has or is using name '{1}' from private module '{2}'."),
        Parameter_0_of_constructor_signature_from_exported_interface_has_or_is_using_private_name_1: diag(4065, ts3.DiagnosticCategory.Error, "Parameter_0_of_constructor_signature_from_exported_interface_has_or_is_using_private_name_1_4065", "Parameter '{0}' of constructor signature from exported interface has or is using private name '{1}'."),
        Parameter_0_of_call_signature_from_exported_interface_has_or_is_using_name_1_from_private_module_2: diag(4066, ts3.DiagnosticCategory.Error, "Parameter_0_of_call_signature_from_exported_interface_has_or_is_using_name_1_from_private_module_2_4066", "Parameter '{0}' of call signature from exported interface has or is using name '{1}' from private module '{2}'."),
        Parameter_0_of_call_signature_from_exported_interface_has_or_is_using_private_name_1: diag(4067, ts3.DiagnosticCategory.Error, "Parameter_0_of_call_signature_from_exported_interface_has_or_is_using_private_name_1_4067", "Parameter '{0}' of call signature from exported interface has or is using private name '{1}'."),
        Parameter_0_of_public_static_method_from_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named: diag(4068, ts3.DiagnosticCategory.Error, "Parameter_0_of_public_static_method_from_exported_class_has_or_is_using_name_1_from_external_module__4068", "Parameter '{0}' of public static method from exported class has or is using name '{1}' from external module {2} but cannot be named."),
        Parameter_0_of_public_static_method_from_exported_class_has_or_is_using_name_1_from_private_module_2: diag(4069, ts3.DiagnosticCategory.Error, "Parameter_0_of_public_static_method_from_exported_class_has_or_is_using_name_1_from_private_module_2_4069", "Parameter '{0}' of public static method from exported class has or is using name '{1}' from private module '{2}'."),
        Parameter_0_of_public_static_method_from_exported_class_has_or_is_using_private_name_1: diag(4070, ts3.DiagnosticCategory.Error, "Parameter_0_of_public_static_method_from_exported_class_has_or_is_using_private_name_1_4070", "Parameter '{0}' of public static method from exported class has or is using private name '{1}'."),
        Parameter_0_of_public_method_from_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named: diag(4071, ts3.DiagnosticCategory.Error, "Parameter_0_of_public_method_from_exported_class_has_or_is_using_name_1_from_external_module_2_but_c_4071", "Parameter '{0}' of public method from exported class has or is using name '{1}' from external module {2} but cannot be named."),
        Parameter_0_of_public_method_from_exported_class_has_or_is_using_name_1_from_private_module_2: diag(4072, ts3.DiagnosticCategory.Error, "Parameter_0_of_public_method_from_exported_class_has_or_is_using_name_1_from_private_module_2_4072", "Parameter '{0}' of public method from exported class has or is using name '{1}' from private module '{2}'."),
        Parameter_0_of_public_method_from_exported_class_has_or_is_using_private_name_1: diag(4073, ts3.DiagnosticCategory.Error, "Parameter_0_of_public_method_from_exported_class_has_or_is_using_private_name_1_4073", "Parameter '{0}' of public method from exported class has or is using private name '{1}'."),
        Parameter_0_of_method_from_exported_interface_has_or_is_using_name_1_from_private_module_2: diag(4074, ts3.DiagnosticCategory.Error, "Parameter_0_of_method_from_exported_interface_has_or_is_using_name_1_from_private_module_2_4074", "Parameter '{0}' of method from exported interface has or is using name '{1}' from private module '{2}'."),
        Parameter_0_of_method_from_exported_interface_has_or_is_using_private_name_1: diag(4075, ts3.DiagnosticCategory.Error, "Parameter_0_of_method_from_exported_interface_has_or_is_using_private_name_1_4075", "Parameter '{0}' of method from exported interface has or is using private name '{1}'."),
        Parameter_0_of_exported_function_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named: diag(4076, ts3.DiagnosticCategory.Error, "Parameter_0_of_exported_function_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named_4076", "Parameter '{0}' of exported function has or is using name '{1}' from external module {2} but cannot be named."),
        Parameter_0_of_exported_function_has_or_is_using_name_1_from_private_module_2: diag(4077, ts3.DiagnosticCategory.Error, "Parameter_0_of_exported_function_has_or_is_using_name_1_from_private_module_2_4077", "Parameter '{0}' of exported function has or is using name '{1}' from private module '{2}'."),
        Parameter_0_of_exported_function_has_or_is_using_private_name_1: diag(4078, ts3.DiagnosticCategory.Error, "Parameter_0_of_exported_function_has_or_is_using_private_name_1_4078", "Parameter '{0}' of exported function has or is using private name '{1}'."),
        Exported_type_alias_0_has_or_is_using_private_name_1: diag(4081, ts3.DiagnosticCategory.Error, "Exported_type_alias_0_has_or_is_using_private_name_1_4081", "Exported type alias '{0}' has or is using private name '{1}'."),
        Default_export_of_the_module_has_or_is_using_private_name_0: diag(4082, ts3.DiagnosticCategory.Error, "Default_export_of_the_module_has_or_is_using_private_name_0_4082", "Default export of the module has or is using private name '{0}'."),
        Type_parameter_0_of_exported_type_alias_has_or_is_using_private_name_1: diag(4083, ts3.DiagnosticCategory.Error, "Type_parameter_0_of_exported_type_alias_has_or_is_using_private_name_1_4083", "Type parameter '{0}' of exported type alias has or is using private name '{1}'."),
        Exported_type_alias_0_has_or_is_using_private_name_1_from_module_2: diag(4084, ts3.DiagnosticCategory.Error, "Exported_type_alias_0_has_or_is_using_private_name_1_from_module_2_4084", "Exported type alias '{0}' has or is using private name '{1}' from module {2}."),
        Conflicting_definitions_for_0_found_at_1_and_2_Consider_installing_a_specific_version_of_this_library_to_resolve_the_conflict: diag(4090, ts3.DiagnosticCategory.Error, "Conflicting_definitions_for_0_found_at_1_and_2_Consider_installing_a_specific_version_of_this_librar_4090", "Conflicting definitions for '{0}' found at '{1}' and '{2}'. Consider installing a specific version of this library to resolve the conflict."),
        Parameter_0_of_index_signature_from_exported_interface_has_or_is_using_name_1_from_private_module_2: diag(4091, ts3.DiagnosticCategory.Error, "Parameter_0_of_index_signature_from_exported_interface_has_or_is_using_name_1_from_private_module_2_4091", "Parameter '{0}' of index signature from exported interface has or is using name '{1}' from private module '{2}'."),
        Parameter_0_of_index_signature_from_exported_interface_has_or_is_using_private_name_1: diag(4092, ts3.DiagnosticCategory.Error, "Parameter_0_of_index_signature_from_exported_interface_has_or_is_using_private_name_1_4092", "Parameter '{0}' of index signature from exported interface has or is using private name '{1}'."),
        Property_0_of_exported_class_expression_may_not_be_private_or_protected: diag(4094, ts3.DiagnosticCategory.Error, "Property_0_of_exported_class_expression_may_not_be_private_or_protected_4094", "Property '{0}' of exported class expression may not be private or protected."),
        Public_static_method_0_of_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named: diag(4095, ts3.DiagnosticCategory.Error, "Public_static_method_0_of_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_4095", "Public static method '{0}' of exported class has or is using name '{1}' from external module {2} but cannot be named."),
        Public_static_method_0_of_exported_class_has_or_is_using_name_1_from_private_module_2: diag(4096, ts3.DiagnosticCategory.Error, "Public_static_method_0_of_exported_class_has_or_is_using_name_1_from_private_module_2_4096", "Public static method '{0}' of exported class has or is using name '{1}' from private module '{2}'."),
        Public_static_method_0_of_exported_class_has_or_is_using_private_name_1: diag(4097, ts3.DiagnosticCategory.Error, "Public_static_method_0_of_exported_class_has_or_is_using_private_name_1_4097", "Public static method '{0}' of exported class has or is using private name '{1}'."),
        Public_method_0_of_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named: diag(4098, ts3.DiagnosticCategory.Error, "Public_method_0_of_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named_4098", "Public method '{0}' of exported class has or is using name '{1}' from external module {2} but cannot be named."),
        Public_method_0_of_exported_class_has_or_is_using_name_1_from_private_module_2: diag(4099, ts3.DiagnosticCategory.Error, "Public_method_0_of_exported_class_has_or_is_using_name_1_from_private_module_2_4099", "Public method '{0}' of exported class has or is using name '{1}' from private module '{2}'."),
        Public_method_0_of_exported_class_has_or_is_using_private_name_1: diag(4100, ts3.DiagnosticCategory.Error, "Public_method_0_of_exported_class_has_or_is_using_private_name_1_4100", "Public method '{0}' of exported class has or is using private name '{1}'."),
        Method_0_of_exported_interface_has_or_is_using_name_1_from_private_module_2: diag(4101, ts3.DiagnosticCategory.Error, "Method_0_of_exported_interface_has_or_is_using_name_1_from_private_module_2_4101", "Method '{0}' of exported interface has or is using name '{1}' from private module '{2}'."),
        Method_0_of_exported_interface_has_or_is_using_private_name_1: diag(4102, ts3.DiagnosticCategory.Error, "Method_0_of_exported_interface_has_or_is_using_private_name_1_4102", "Method '{0}' of exported interface has or is using private name '{1}'."),
        Type_parameter_0_of_exported_mapped_object_type_is_using_private_name_1: diag(4103, ts3.DiagnosticCategory.Error, "Type_parameter_0_of_exported_mapped_object_type_is_using_private_name_1_4103", "Type parameter '{0}' of exported mapped object type is using private name '{1}'."),
        The_type_0_is_readonly_and_cannot_be_assigned_to_the_mutable_type_1: diag(4104, ts3.DiagnosticCategory.Error, "The_type_0_is_readonly_and_cannot_be_assigned_to_the_mutable_type_1_4104", "The type '{0}' is 'readonly' and cannot be assigned to the mutable type '{1}'."),
        Private_or_protected_member_0_cannot_be_accessed_on_a_type_parameter: diag(4105, ts3.DiagnosticCategory.Error, "Private_or_protected_member_0_cannot_be_accessed_on_a_type_parameter_4105", "Private or protected member '{0}' cannot be accessed on a type parameter."),
        Parameter_0_of_accessor_has_or_is_using_private_name_1: diag(4106, ts3.DiagnosticCategory.Error, "Parameter_0_of_accessor_has_or_is_using_private_name_1_4106", "Parameter '{0}' of accessor has or is using private name '{1}'."),
        Parameter_0_of_accessor_has_or_is_using_name_1_from_private_module_2: diag(4107, ts3.DiagnosticCategory.Error, "Parameter_0_of_accessor_has_or_is_using_name_1_from_private_module_2_4107", "Parameter '{0}' of accessor has or is using name '{1}' from private module '{2}'."),
        Parameter_0_of_accessor_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named: diag(4108, ts3.DiagnosticCategory.Error, "Parameter_0_of_accessor_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named_4108", "Parameter '{0}' of accessor has or is using name '{1}' from external module '{2}' but cannot be named."),
        Type_arguments_for_0_circularly_reference_themselves: diag(4109, ts3.DiagnosticCategory.Error, "Type_arguments_for_0_circularly_reference_themselves_4109", "Type arguments for '{0}' circularly reference themselves."),
        Tuple_type_arguments_circularly_reference_themselves: diag(4110, ts3.DiagnosticCategory.Error, "Tuple_type_arguments_circularly_reference_themselves_4110", "Tuple type arguments circularly reference themselves."),
        Property_0_comes_from_an_index_signature_so_it_must_be_accessed_with_0: diag(4111, ts3.DiagnosticCategory.Error, "Property_0_comes_from_an_index_signature_so_it_must_be_accessed_with_0_4111", "Property '{0}' comes from an index signature, so it must be accessed with ['{0}']."),
        This_member_cannot_have_an_override_modifier_because_its_containing_class_0_does_not_extend_another_class: diag(4112, ts3.DiagnosticCategory.Error, "This_member_cannot_have_an_override_modifier_because_its_containing_class_0_does_not_extend_another__4112", "This member cannot have an 'override' modifier because its containing class '{0}' does not extend another class."),
        This_member_cannot_have_an_override_modifier_because_it_is_not_declared_in_the_base_class_0: diag(4113, ts3.DiagnosticCategory.Error, "This_member_cannot_have_an_override_modifier_because_it_is_not_declared_in_the_base_class_0_4113", "This member cannot have an 'override' modifier because it is not declared in the base class '{0}'."),
        This_member_must_have_an_override_modifier_because_it_overrides_a_member_in_the_base_class_0: diag(4114, ts3.DiagnosticCategory.Error, "This_member_must_have_an_override_modifier_because_it_overrides_a_member_in_the_base_class_0_4114", "This member must have an 'override' modifier because it overrides a member in the base class '{0}'."),
        This_parameter_property_must_have_an_override_modifier_because_it_overrides_a_member_in_base_class_0: diag(4115, ts3.DiagnosticCategory.Error, "This_parameter_property_must_have_an_override_modifier_because_it_overrides_a_member_in_base_class_0_4115", "This parameter property must have an 'override' modifier because it overrides a member in base class '{0}'."),
        This_member_must_have_an_override_modifier_because_it_overrides_an_abstract_method_that_is_declared_in_the_base_class_0: diag(4116, ts3.DiagnosticCategory.Error, "This_member_must_have_an_override_modifier_because_it_overrides_an_abstract_method_that_is_declared__4116", "This member must have an 'override' modifier because it overrides an abstract method that is declared in the base class '{0}'."),
        The_current_host_does_not_support_the_0_option: diag(5001, ts3.DiagnosticCategory.Error, "The_current_host_does_not_support_the_0_option_5001", "The current host does not support the '{0}' option."),
        Cannot_find_the_common_subdirectory_path_for_the_input_files: diag(5009, ts3.DiagnosticCategory.Error, "Cannot_find_the_common_subdirectory_path_for_the_input_files_5009", "Cannot find the common subdirectory path for the input files."),
        File_specification_cannot_end_in_a_recursive_directory_wildcard_Asterisk_Asterisk_Colon_0: diag(5010, ts3.DiagnosticCategory.Error, "File_specification_cannot_end_in_a_recursive_directory_wildcard_Asterisk_Asterisk_Colon_0_5010", "File specification cannot end in a recursive directory wildcard ('**'): '{0}'."),
        Cannot_read_file_0_Colon_1: diag(5012, ts3.DiagnosticCategory.Error, "Cannot_read_file_0_Colon_1_5012", "Cannot read file '{0}': {1}."),
        Failed_to_parse_file_0_Colon_1: diag(5014, ts3.DiagnosticCategory.Error, "Failed_to_parse_file_0_Colon_1_5014", "Failed to parse file '{0}': {1}."),
        Unknown_compiler_option_0: diag(5023, ts3.DiagnosticCategory.Error, "Unknown_compiler_option_0_5023", "Unknown compiler option '{0}'."),
        Compiler_option_0_requires_a_value_of_type_1: diag(5024, ts3.DiagnosticCategory.Error, "Compiler_option_0_requires_a_value_of_type_1_5024", "Compiler option '{0}' requires a value of type {1}."),
        Unknown_compiler_option_0_Did_you_mean_1: diag(5025, ts3.DiagnosticCategory.Error, "Unknown_compiler_option_0_Did_you_mean_1_5025", "Unknown compiler option '{0}'. Did you mean '{1}'?"),
        Could_not_write_file_0_Colon_1: diag(5033, ts3.DiagnosticCategory.Error, "Could_not_write_file_0_Colon_1_5033", "Could not write file '{0}': {1}."),
        Option_project_cannot_be_mixed_with_source_files_on_a_command_line: diag(5042, ts3.DiagnosticCategory.Error, "Option_project_cannot_be_mixed_with_source_files_on_a_command_line_5042", "Option 'project' cannot be mixed with source files on a command line."),
        Option_isolatedModules_can_only_be_used_when_either_option_module_is_provided_or_option_target_is_ES2015_or_higher: diag(5047, ts3.DiagnosticCategory.Error, "Option_isolatedModules_can_only_be_used_when_either_option_module_is_provided_or_option_target_is_ES_5047", "Option 'isolatedModules' can only be used when either option '--module' is provided or option 'target' is 'ES2015' or higher."),
        Option_0_cannot_be_specified_when_option_target_is_ES3: diag(5048, ts3.DiagnosticCategory.Error, "Option_0_cannot_be_specified_when_option_target_is_ES3_5048", "Option '{0}' cannot be specified when option 'target' is 'ES3'."),
        Option_0_can_only_be_used_when_either_option_inlineSourceMap_or_option_sourceMap_is_provided: diag(5051, ts3.DiagnosticCategory.Error, "Option_0_can_only_be_used_when_either_option_inlineSourceMap_or_option_sourceMap_is_provided_5051", "Option '{0} can only be used when either option '--inlineSourceMap' or option '--sourceMap' is provided."),
        Option_0_cannot_be_specified_without_specifying_option_1: diag(5052, ts3.DiagnosticCategory.Error, "Option_0_cannot_be_specified_without_specifying_option_1_5052", "Option '{0}' cannot be specified without specifying option '{1}'."),
        Option_0_cannot_be_specified_with_option_1: diag(5053, ts3.DiagnosticCategory.Error, "Option_0_cannot_be_specified_with_option_1_5053", "Option '{0}' cannot be specified with option '{1}'."),
        A_tsconfig_json_file_is_already_defined_at_Colon_0: diag(5054, ts3.DiagnosticCategory.Error, "A_tsconfig_json_file_is_already_defined_at_Colon_0_5054", "A 'tsconfig.json' file is already defined at: '{0}'."),
        Cannot_write_file_0_because_it_would_overwrite_input_file: diag(5055, ts3.DiagnosticCategory.Error, "Cannot_write_file_0_because_it_would_overwrite_input_file_5055", "Cannot write file '{0}' because it would overwrite input file."),
        Cannot_write_file_0_because_it_would_be_overwritten_by_multiple_input_files: diag(5056, ts3.DiagnosticCategory.Error, "Cannot_write_file_0_because_it_would_be_overwritten_by_multiple_input_files_5056", "Cannot write file '{0}' because it would be overwritten by multiple input files."),
        Cannot_find_a_tsconfig_json_file_at_the_specified_directory_Colon_0: diag(5057, ts3.DiagnosticCategory.Error, "Cannot_find_a_tsconfig_json_file_at_the_specified_directory_Colon_0_5057", "Cannot find a tsconfig.json file at the specified directory: '{0}'."),
        The_specified_path_does_not_exist_Colon_0: diag(5058, ts3.DiagnosticCategory.Error, "The_specified_path_does_not_exist_Colon_0_5058", "The specified path does not exist: '{0}'."),
        Invalid_value_for_reactNamespace_0_is_not_a_valid_identifier: diag(5059, ts3.DiagnosticCategory.Error, "Invalid_value_for_reactNamespace_0_is_not_a_valid_identifier_5059", "Invalid value for '--reactNamespace'. '{0}' is not a valid identifier."),
        Pattern_0_can_have_at_most_one_Asterisk_character: diag(5061, ts3.DiagnosticCategory.Error, "Pattern_0_can_have_at_most_one_Asterisk_character_5061", "Pattern '{0}' can have at most one '*' character."),
        Substitution_0_in_pattern_1_can_have_at_most_one_Asterisk_character: diag(5062, ts3.DiagnosticCategory.Error, "Substitution_0_in_pattern_1_can_have_at_most_one_Asterisk_character_5062", "Substitution '{0}' in pattern '{1}' can have at most one '*' character."),
        Substitutions_for_pattern_0_should_be_an_array: diag(5063, ts3.DiagnosticCategory.Error, "Substitutions_for_pattern_0_should_be_an_array_5063", "Substitutions for pattern '{0}' should be an array."),
        Substitution_0_for_pattern_1_has_incorrect_type_expected_string_got_2: diag(5064, ts3.DiagnosticCategory.Error, "Substitution_0_for_pattern_1_has_incorrect_type_expected_string_got_2_5064", "Substitution '{0}' for pattern '{1}' has incorrect type, expected 'string', got '{2}'."),
        File_specification_cannot_contain_a_parent_directory_that_appears_after_a_recursive_directory_wildcard_Asterisk_Asterisk_Colon_0: diag(5065, ts3.DiagnosticCategory.Error, "File_specification_cannot_contain_a_parent_directory_that_appears_after_a_recursive_directory_wildca_5065", "File specification cannot contain a parent directory ('..') that appears after a recursive directory wildcard ('**'): '{0}'."),
        Substitutions_for_pattern_0_shouldn_t_be_an_empty_array: diag(5066, ts3.DiagnosticCategory.Error, "Substitutions_for_pattern_0_shouldn_t_be_an_empty_array_5066", "Substitutions for pattern '{0}' shouldn't be an empty array."),
        Invalid_value_for_jsxFactory_0_is_not_a_valid_identifier_or_qualified_name: diag(5067, ts3.DiagnosticCategory.Error, "Invalid_value_for_jsxFactory_0_is_not_a_valid_identifier_or_qualified_name_5067", "Invalid value for 'jsxFactory'. '{0}' is not a valid identifier or qualified-name."),
        Adding_a_tsconfig_json_file_will_help_organize_projects_that_contain_both_TypeScript_and_JavaScript_files_Learn_more_at_https_Colon_Slash_Slashaka_ms_Slashtsconfig: diag(5068, ts3.DiagnosticCategory.Error, "Adding_a_tsconfig_json_file_will_help_organize_projects_that_contain_both_TypeScript_and_JavaScript__5068", "Adding a tsconfig.json file will help organize projects that contain both TypeScript and JavaScript files. Learn more at https://aka.ms/tsconfig."),
        Option_0_cannot_be_specified_without_specifying_option_1_or_option_2: diag(5069, ts3.DiagnosticCategory.Error, "Option_0_cannot_be_specified_without_specifying_option_1_or_option_2_5069", "Option '{0}' cannot be specified without specifying option '{1}' or option '{2}'."),
        Option_resolveJsonModule_cannot_be_specified_without_node_module_resolution_strategy: diag(5070, ts3.DiagnosticCategory.Error, "Option_resolveJsonModule_cannot_be_specified_without_node_module_resolution_strategy_5070", "Option '--resolveJsonModule' cannot be specified without 'node' module resolution strategy."),
        Option_resolveJsonModule_can_only_be_specified_when_module_code_generation_is_commonjs_amd_es2015_or_esNext: diag(5071, ts3.DiagnosticCategory.Error, "Option_resolveJsonModule_can_only_be_specified_when_module_code_generation_is_commonjs_amd_es2015_or_5071", "Option '--resolveJsonModule' can only be specified when module code generation is 'commonjs', 'amd', 'es2015' or 'esNext'."),
        Unknown_build_option_0: diag(5072, ts3.DiagnosticCategory.Error, "Unknown_build_option_0_5072", "Unknown build option '{0}'."),
        Build_option_0_requires_a_value_of_type_1: diag(5073, ts3.DiagnosticCategory.Error, "Build_option_0_requires_a_value_of_type_1_5073", "Build option '{0}' requires a value of type {1}."),
        Option_incremental_can_only_be_specified_using_tsconfig_emitting_to_single_file_or_when_option_tsBuildInfoFile_is_specified: diag(5074, ts3.DiagnosticCategory.Error, "Option_incremental_can_only_be_specified_using_tsconfig_emitting_to_single_file_or_when_option_tsBui_5074", "Option '--incremental' can only be specified using tsconfig, emitting to single file or when option '--tsBuildInfoFile' is specified."),
        _0_is_assignable_to_the_constraint_of_type_1_but_1_could_be_instantiated_with_a_different_subtype_of_constraint_2: diag(5075, ts3.DiagnosticCategory.Error, "_0_is_assignable_to_the_constraint_of_type_1_but_1_could_be_instantiated_with_a_different_subtype_of_5075", "'{0}' is assignable to the constraint of type '{1}', but '{1}' could be instantiated with a different subtype of constraint '{2}'."),
        _0_and_1_operations_cannot_be_mixed_without_parentheses: diag(5076, ts3.DiagnosticCategory.Error, "_0_and_1_operations_cannot_be_mixed_without_parentheses_5076", "'{0}' and '{1}' operations cannot be mixed without parentheses."),
        Unknown_build_option_0_Did_you_mean_1: diag(5077, ts3.DiagnosticCategory.Error, "Unknown_build_option_0_Did_you_mean_1_5077", "Unknown build option '{0}'. Did you mean '{1}'?"),
        Unknown_watch_option_0: diag(5078, ts3.DiagnosticCategory.Error, "Unknown_watch_option_0_5078", "Unknown watch option '{0}'."),
        Unknown_watch_option_0_Did_you_mean_1: diag(5079, ts3.DiagnosticCategory.Error, "Unknown_watch_option_0_Did_you_mean_1_5079", "Unknown watch option '{0}'. Did you mean '{1}'?"),
        Watch_option_0_requires_a_value_of_type_1: diag(5080, ts3.DiagnosticCategory.Error, "Watch_option_0_requires_a_value_of_type_1_5080", "Watch option '{0}' requires a value of type {1}."),
        Cannot_find_a_tsconfig_json_file_at_the_current_directory_Colon_0: diag(5081, ts3.DiagnosticCategory.Error, "Cannot_find_a_tsconfig_json_file_at_the_current_directory_Colon_0_5081", "Cannot find a tsconfig.json file at the current directory: {0}."),
        _0_could_be_instantiated_with_an_arbitrary_type_which_could_be_unrelated_to_1: diag(5082, ts3.DiagnosticCategory.Error, "_0_could_be_instantiated_with_an_arbitrary_type_which_could_be_unrelated_to_1_5082", "'{0}' could be instantiated with an arbitrary type which could be unrelated to '{1}'."),
        Cannot_read_file_0: diag(5083, ts3.DiagnosticCategory.Error, "Cannot_read_file_0_5083", "Cannot read file '{0}'."),
        Tuple_members_must_all_have_names_or_all_not_have_names: diag(5084, ts3.DiagnosticCategory.Error, "Tuple_members_must_all_have_names_or_all_not_have_names_5084", "Tuple members must all have names or all not have names."),
        A_tuple_member_cannot_be_both_optional_and_rest: diag(5085, ts3.DiagnosticCategory.Error, "A_tuple_member_cannot_be_both_optional_and_rest_5085", "A tuple member cannot be both optional and rest."),
        A_labeled_tuple_element_is_declared_as_optional_with_a_question_mark_after_the_name_and_before_the_colon_rather_than_after_the_type: diag(5086, ts3.DiagnosticCategory.Error, "A_labeled_tuple_element_is_declared_as_optional_with_a_question_mark_after_the_name_and_before_the_c_5086", "A labeled tuple element is declared as optional with a question mark after the name and before the colon, rather than after the type."),
        A_labeled_tuple_element_is_declared_as_rest_with_a_before_the_name_rather_than_before_the_type: diag(5087, ts3.DiagnosticCategory.Error, "A_labeled_tuple_element_is_declared_as_rest_with_a_before_the_name_rather_than_before_the_type_5087", "A labeled tuple element is declared as rest with a '...' before the name, rather than before the type."),
        The_inferred_type_of_0_references_a_type_with_a_cyclic_structure_which_cannot_be_trivially_serialized_A_type_annotation_is_necessary: diag(5088, ts3.DiagnosticCategory.Error, "The_inferred_type_of_0_references_a_type_with_a_cyclic_structure_which_cannot_be_trivially_serialize_5088", "The inferred type of '{0}' references a type with a cyclic structure which cannot be trivially serialized. A type annotation is necessary."),
        Option_0_cannot_be_specified_when_option_jsx_is_1: diag(5089, ts3.DiagnosticCategory.Error, "Option_0_cannot_be_specified_when_option_jsx_is_1_5089", "Option '{0}' cannot be specified when option 'jsx' is '{1}'."),
        Non_relative_paths_are_not_allowed_when_baseUrl_is_not_set_Did_you_forget_a_leading_Slash: diag(5090, ts3.DiagnosticCategory.Error, "Non_relative_paths_are_not_allowed_when_baseUrl_is_not_set_Did_you_forget_a_leading_Slash_5090", "Non-relative paths are not allowed when 'baseUrl' is not set. Did you forget a leading './'?"),
        Option_preserveConstEnums_cannot_be_disabled_when_isolatedModules_is_enabled: diag(5091, ts3.DiagnosticCategory.Error, "Option_preserveConstEnums_cannot_be_disabled_when_isolatedModules_is_enabled_5091", "Option 'preserveConstEnums' cannot be disabled when 'isolatedModules' is enabled."),
        The_root_value_of_a_0_file_must_be_an_object: diag(5092, ts3.DiagnosticCategory.Error, "The_root_value_of_a_0_file_must_be_an_object_5092", "The root value of a '{0}' file must be an object."),
        Compiler_option_0_may_only_be_used_with_build: diag(5093, ts3.DiagnosticCategory.Error, "Compiler_option_0_may_only_be_used_with_build_5093", "Compiler option '--{0}' may only be used with '--build'."),
        Compiler_option_0_may_not_be_used_with_build: diag(5094, ts3.DiagnosticCategory.Error, "Compiler_option_0_may_not_be_used_with_build_5094", "Compiler option '--{0}' may not be used with '--build'."),
        Generates_a_sourcemap_for_each_corresponding_d_ts_file: diag(6e3, ts3.DiagnosticCategory.Message, "Generates_a_sourcemap_for_each_corresponding_d_ts_file_6000", "Generates a sourcemap for each corresponding '.d.ts' file."),
        Concatenate_and_emit_output_to_single_file: diag(6001, ts3.DiagnosticCategory.Message, "Concatenate_and_emit_output_to_single_file_6001", "Concatenate and emit output to single file."),
        Generates_corresponding_d_ts_file: diag(6002, ts3.DiagnosticCategory.Message, "Generates_corresponding_d_ts_file_6002", "Generates corresponding '.d.ts' file."),
        Specify_the_location_where_debugger_should_locate_map_files_instead_of_generated_locations: diag(6003, ts3.DiagnosticCategory.Message, "Specify_the_location_where_debugger_should_locate_map_files_instead_of_generated_locations_6003", "Specify the location where debugger should locate map files instead of generated locations."),
        Specify_the_location_where_debugger_should_locate_TypeScript_files_instead_of_source_locations: diag(6004, ts3.DiagnosticCategory.Message, "Specify_the_location_where_debugger_should_locate_TypeScript_files_instead_of_source_locations_6004", "Specify the location where debugger should locate TypeScript files instead of source locations."),
        Watch_input_files: diag(6005, ts3.DiagnosticCategory.Message, "Watch_input_files_6005", "Watch input files."),
        Redirect_output_structure_to_the_directory: diag(6006, ts3.DiagnosticCategory.Message, "Redirect_output_structure_to_the_directory_6006", "Redirect output structure to the directory."),
        Do_not_erase_const_enum_declarations_in_generated_code: diag(6007, ts3.DiagnosticCategory.Message, "Do_not_erase_const_enum_declarations_in_generated_code_6007", "Do not erase const enum declarations in generated code."),
        Do_not_emit_outputs_if_any_errors_were_reported: diag(6008, ts3.DiagnosticCategory.Message, "Do_not_emit_outputs_if_any_errors_were_reported_6008", "Do not emit outputs if any errors were reported."),
        Do_not_emit_comments_to_output: diag(6009, ts3.DiagnosticCategory.Message, "Do_not_emit_comments_to_output_6009", "Do not emit comments to output."),
        Do_not_emit_outputs: diag(6010, ts3.DiagnosticCategory.Message, "Do_not_emit_outputs_6010", "Do not emit outputs."),
        Allow_default_imports_from_modules_with_no_default_export_This_does_not_affect_code_emit_just_typechecking: diag(6011, ts3.DiagnosticCategory.Message, "Allow_default_imports_from_modules_with_no_default_export_This_does_not_affect_code_emit_just_typech_6011", "Allow default imports from modules with no default export. This does not affect code emit, just typechecking."),
        Skip_type_checking_of_declaration_files: diag(6012, ts3.DiagnosticCategory.Message, "Skip_type_checking_of_declaration_files_6012", "Skip type checking of declaration files."),
        Do_not_resolve_the_real_path_of_symlinks: diag(6013, ts3.DiagnosticCategory.Message, "Do_not_resolve_the_real_path_of_symlinks_6013", "Do not resolve the real path of symlinks."),
        Only_emit_d_ts_declaration_files: diag(6014, ts3.DiagnosticCategory.Message, "Only_emit_d_ts_declaration_files_6014", "Only emit '.d.ts' declaration files."),
        Specify_ECMAScript_target_version_Colon_ES3_default_ES5_ES2015_ES2016_ES2017_ES2018_ES2019_ES2020_ES2021_or_ESNEXT: diag(6015, ts3.DiagnosticCategory.Message, "Specify_ECMAScript_target_version_Colon_ES3_default_ES5_ES2015_ES2016_ES2017_ES2018_ES2019_ES2020_ES_6015", "Specify ECMAScript target version: 'ES3' (default), 'ES5', 'ES2015', 'ES2016', 'ES2017', 'ES2018', 'ES2019', 'ES2020', 'ES2021', or 'ESNEXT'."),
        Specify_module_code_generation_Colon_none_commonjs_amd_system_umd_es2015_es2020_or_ESNext: diag(6016, ts3.DiagnosticCategory.Message, "Specify_module_code_generation_Colon_none_commonjs_amd_system_umd_es2015_es2020_or_ESNext_6016", "Specify module code generation: 'none', 'commonjs', 'amd', 'system', 'umd', 'es2015', 'es2020', or 'ESNext'."),
        Print_this_message: diag(6017, ts3.DiagnosticCategory.Message, "Print_this_message_6017", "Print this message."),
        Print_the_compiler_s_version: diag(6019, ts3.DiagnosticCategory.Message, "Print_the_compiler_s_version_6019", "Print the compiler's version."),
        Compile_the_project_given_the_path_to_its_configuration_file_or_to_a_folder_with_a_tsconfig_json: diag(6020, ts3.DiagnosticCategory.Message, "Compile_the_project_given_the_path_to_its_configuration_file_or_to_a_folder_with_a_tsconfig_json_6020", "Compile the project given the path to its configuration file, or to a folder with a 'tsconfig.json'."),
        Syntax_Colon_0: diag(6023, ts3.DiagnosticCategory.Message, "Syntax_Colon_0_6023", "Syntax: {0}"),
        options: diag(6024, ts3.DiagnosticCategory.Message, "options_6024", "options"),
        file: diag(6025, ts3.DiagnosticCategory.Message, "file_6025", "file"),
        Examples_Colon_0: diag(6026, ts3.DiagnosticCategory.Message, "Examples_Colon_0_6026", "Examples: {0}"),
        Options_Colon: diag(6027, ts3.DiagnosticCategory.Message, "Options_Colon_6027", "Options:"),
        Version_0: diag(6029, ts3.DiagnosticCategory.Message, "Version_0_6029", "Version {0}"),
        Insert_command_line_options_and_files_from_a_file: diag(6030, ts3.DiagnosticCategory.Message, "Insert_command_line_options_and_files_from_a_file_6030", "Insert command line options and files from a file."),
        Starting_compilation_in_watch_mode: diag(6031, ts3.DiagnosticCategory.Message, "Starting_compilation_in_watch_mode_6031", "Starting compilation in watch mode..."),
        File_change_detected_Starting_incremental_compilation: diag(6032, ts3.DiagnosticCategory.Message, "File_change_detected_Starting_incremental_compilation_6032", "File change detected. Starting incremental compilation..."),
        KIND: diag(6034, ts3.DiagnosticCategory.Message, "KIND_6034", "KIND"),
        FILE: diag(6035, ts3.DiagnosticCategory.Message, "FILE_6035", "FILE"),
        VERSION: diag(6036, ts3.DiagnosticCategory.Message, "VERSION_6036", "VERSION"),
        LOCATION: diag(6037, ts3.DiagnosticCategory.Message, "LOCATION_6037", "LOCATION"),
        DIRECTORY: diag(6038, ts3.DiagnosticCategory.Message, "DIRECTORY_6038", "DIRECTORY"),
        STRATEGY: diag(6039, ts3.DiagnosticCategory.Message, "STRATEGY_6039", "STRATEGY"),
        FILE_OR_DIRECTORY: diag(6040, ts3.DiagnosticCategory.Message, "FILE_OR_DIRECTORY_6040", "FILE OR DIRECTORY"),
        Generates_corresponding_map_file: diag(6043, ts3.DiagnosticCategory.Message, "Generates_corresponding_map_file_6043", "Generates corresponding '.map' file."),
        Compiler_option_0_expects_an_argument: diag(6044, ts3.DiagnosticCategory.Error, "Compiler_option_0_expects_an_argument_6044", "Compiler option '{0}' expects an argument."),
        Unterminated_quoted_string_in_response_file_0: diag(6045, ts3.DiagnosticCategory.Error, "Unterminated_quoted_string_in_response_file_0_6045", "Unterminated quoted string in response file '{0}'."),
        Argument_for_0_option_must_be_Colon_1: diag(6046, ts3.DiagnosticCategory.Error, "Argument_for_0_option_must_be_Colon_1_6046", "Argument for '{0}' option must be: {1}."),
        Locale_must_be_of_the_form_language_or_language_territory_For_example_0_or_1: diag(6048, ts3.DiagnosticCategory.Error, "Locale_must_be_of_the_form_language_or_language_territory_For_example_0_or_1_6048", "Locale must be of the form <language> or <language>-<territory>. For example '{0}' or '{1}'."),
        Unsupported_locale_0: diag(6049, ts3.DiagnosticCategory.Error, "Unsupported_locale_0_6049", "Unsupported locale '{0}'."),
        Unable_to_open_file_0: diag(6050, ts3.DiagnosticCategory.Error, "Unable_to_open_file_0_6050", "Unable to open file '{0}'."),
        Corrupted_locale_file_0: diag(6051, ts3.DiagnosticCategory.Error, "Corrupted_locale_file_0_6051", "Corrupted locale file {0}."),
        Raise_error_on_expressions_and_declarations_with_an_implied_any_type: diag(6052, ts3.DiagnosticCategory.Message, "Raise_error_on_expressions_and_declarations_with_an_implied_any_type_6052", "Raise error on expressions and declarations with an implied 'any' type."),
        File_0_not_found: diag(6053, ts3.DiagnosticCategory.Error, "File_0_not_found_6053", "File '{0}' not found."),
        File_0_has_an_unsupported_extension_The_only_supported_extensions_are_1: diag(6054, ts3.DiagnosticCategory.Error, "File_0_has_an_unsupported_extension_The_only_supported_extensions_are_1_6054", "File '{0}' has an unsupported extension. The only supported extensions are {1}."),
        Suppress_noImplicitAny_errors_for_indexing_objects_lacking_index_signatures: diag(6055, ts3.DiagnosticCategory.Message, "Suppress_noImplicitAny_errors_for_indexing_objects_lacking_index_signatures_6055", "Suppress noImplicitAny errors for indexing objects lacking index signatures."),
        Do_not_emit_declarations_for_code_that_has_an_internal_annotation: diag(6056, ts3.DiagnosticCategory.Message, "Do_not_emit_declarations_for_code_that_has_an_internal_annotation_6056", "Do not emit declarations for code that has an '@internal' annotation."),
        Specify_the_root_directory_of_input_files_Use_to_control_the_output_directory_structure_with_outDir: diag(6058, ts3.DiagnosticCategory.Message, "Specify_the_root_directory_of_input_files_Use_to_control_the_output_directory_structure_with_outDir_6058", "Specify the root directory of input files. Use to control the output directory structure with --outDir."),
        File_0_is_not_under_rootDir_1_rootDir_is_expected_to_contain_all_source_files: diag(6059, ts3.DiagnosticCategory.Error, "File_0_is_not_under_rootDir_1_rootDir_is_expected_to_contain_all_source_files_6059", "File '{0}' is not under 'rootDir' '{1}'. 'rootDir' is expected to contain all source files."),
        Specify_the_end_of_line_sequence_to_be_used_when_emitting_files_Colon_CRLF_dos_or_LF_unix: diag(6060, ts3.DiagnosticCategory.Message, "Specify_the_end_of_line_sequence_to_be_used_when_emitting_files_Colon_CRLF_dos_or_LF_unix_6060", "Specify the end of line sequence to be used when emitting files: 'CRLF' (dos) or 'LF' (unix)."),
        NEWLINE: diag(6061, ts3.DiagnosticCategory.Message, "NEWLINE_6061", "NEWLINE"),
        Option_0_can_only_be_specified_in_tsconfig_json_file_or_set_to_null_on_command_line: diag(6064, ts3.DiagnosticCategory.Error, "Option_0_can_only_be_specified_in_tsconfig_json_file_or_set_to_null_on_command_line_6064", "Option '{0}' can only be specified in 'tsconfig.json' file or set to 'null' on command line."),
        Enables_experimental_support_for_ES7_decorators: diag(6065, ts3.DiagnosticCategory.Message, "Enables_experimental_support_for_ES7_decorators_6065", "Enables experimental support for ES7 decorators."),
        Enables_experimental_support_for_emitting_type_metadata_for_decorators: diag(6066, ts3.DiagnosticCategory.Message, "Enables_experimental_support_for_emitting_type_metadata_for_decorators_6066", "Enables experimental support for emitting type metadata for decorators."),
        Enables_experimental_support_for_ES7_async_functions: diag(6068, ts3.DiagnosticCategory.Message, "Enables_experimental_support_for_ES7_async_functions_6068", "Enables experimental support for ES7 async functions."),
        Specify_module_resolution_strategy_Colon_node_Node_js_or_classic_TypeScript_pre_1_6: diag(6069, ts3.DiagnosticCategory.Message, "Specify_module_resolution_strategy_Colon_node_Node_js_or_classic_TypeScript_pre_1_6_6069", "Specify module resolution strategy: 'node' (Node.js) or 'classic' (TypeScript pre-1.6)."),
        Initializes_a_TypeScript_project_and_creates_a_tsconfig_json_file: diag(6070, ts3.DiagnosticCategory.Message, "Initializes_a_TypeScript_project_and_creates_a_tsconfig_json_file_6070", "Initializes a TypeScript project and creates a tsconfig.json file."),
        Successfully_created_a_tsconfig_json_file: diag(6071, ts3.DiagnosticCategory.Message, "Successfully_created_a_tsconfig_json_file_6071", "Successfully created a tsconfig.json file."),
        Suppress_excess_property_checks_for_object_literals: diag(6072, ts3.DiagnosticCategory.Message, "Suppress_excess_property_checks_for_object_literals_6072", "Suppress excess property checks for object literals."),
        Stylize_errors_and_messages_using_color_and_context_experimental: diag(6073, ts3.DiagnosticCategory.Message, "Stylize_errors_and_messages_using_color_and_context_experimental_6073", "Stylize errors and messages using color and context (experimental)."),
        Do_not_report_errors_on_unused_labels: diag(6074, ts3.DiagnosticCategory.Message, "Do_not_report_errors_on_unused_labels_6074", "Do not report errors on unused labels."),
        Report_error_when_not_all_code_paths_in_function_return_a_value: diag(6075, ts3.DiagnosticCategory.Message, "Report_error_when_not_all_code_paths_in_function_return_a_value_6075", "Report error when not all code paths in function return a value."),
        Report_errors_for_fallthrough_cases_in_switch_statement: diag(6076, ts3.DiagnosticCategory.Message, "Report_errors_for_fallthrough_cases_in_switch_statement_6076", "Report errors for fallthrough cases in switch statement."),
        Do_not_report_errors_on_unreachable_code: diag(6077, ts3.DiagnosticCategory.Message, "Do_not_report_errors_on_unreachable_code_6077", "Do not report errors on unreachable code."),
        Disallow_inconsistently_cased_references_to_the_same_file: diag(6078, ts3.DiagnosticCategory.Message, "Disallow_inconsistently_cased_references_to_the_same_file_6078", "Disallow inconsistently-cased references to the same file."),
        Specify_library_files_to_be_included_in_the_compilation: diag(6079, ts3.DiagnosticCategory.Message, "Specify_library_files_to_be_included_in_the_compilation_6079", "Specify library files to be included in the compilation."),
        Specify_JSX_code_generation_Colon_preserve_react_native_react_react_jsx_or_react_jsxdev: diag(6080, ts3.DiagnosticCategory.Message, "Specify_JSX_code_generation_Colon_preserve_react_native_react_react_jsx_or_react_jsxdev_6080", "Specify JSX code generation: 'preserve', 'react-native', 'react', 'react-jsx' or 'react-jsxdev'."),
        File_0_has_an_unsupported_extension_so_skipping_it: diag(6081, ts3.DiagnosticCategory.Message, "File_0_has_an_unsupported_extension_so_skipping_it_6081", "File '{0}' has an unsupported extension, so skipping it."),
        Only_amd_and_system_modules_are_supported_alongside_0: diag(6082, ts3.DiagnosticCategory.Error, "Only_amd_and_system_modules_are_supported_alongside_0_6082", "Only 'amd' and 'system' modules are supported alongside --{0}."),
        Base_directory_to_resolve_non_absolute_module_names: diag(6083, ts3.DiagnosticCategory.Message, "Base_directory_to_resolve_non_absolute_module_names_6083", "Base directory to resolve non-absolute module names."),
        Deprecated_Use_jsxFactory_instead_Specify_the_object_invoked_for_createElement_when_targeting_react_JSX_emit: diag(6084, ts3.DiagnosticCategory.Message, "Deprecated_Use_jsxFactory_instead_Specify_the_object_invoked_for_createElement_when_targeting_react__6084", "[Deprecated] Use '--jsxFactory' instead. Specify the object invoked for createElement when targeting 'react' JSX emit"),
        Enable_tracing_of_the_name_resolution_process: diag(6085, ts3.DiagnosticCategory.Message, "Enable_tracing_of_the_name_resolution_process_6085", "Enable tracing of the name resolution process."),
        Resolving_module_0_from_1: diag(6086, ts3.DiagnosticCategory.Message, "Resolving_module_0_from_1_6086", "======== Resolving module '{0}' from '{1}'. ========"),
        Explicitly_specified_module_resolution_kind_Colon_0: diag(6087, ts3.DiagnosticCategory.Message, "Explicitly_specified_module_resolution_kind_Colon_0_6087", "Explicitly specified module resolution kind: '{0}'."),
        Module_resolution_kind_is_not_specified_using_0: diag(6088, ts3.DiagnosticCategory.Message, "Module_resolution_kind_is_not_specified_using_0_6088", "Module resolution kind is not specified, using '{0}'."),
        Module_name_0_was_successfully_resolved_to_1: diag(6089, ts3.DiagnosticCategory.Message, "Module_name_0_was_successfully_resolved_to_1_6089", "======== Module name '{0}' was successfully resolved to '{1}'. ========"),
        Module_name_0_was_not_resolved: diag(6090, ts3.DiagnosticCategory.Message, "Module_name_0_was_not_resolved_6090", "======== Module name '{0}' was not resolved. ========"),
        paths_option_is_specified_looking_for_a_pattern_to_match_module_name_0: diag(6091, ts3.DiagnosticCategory.Message, "paths_option_is_specified_looking_for_a_pattern_to_match_module_name_0_6091", "'paths' option is specified, looking for a pattern to match module name '{0}'."),
        Module_name_0_matched_pattern_1: diag(6092, ts3.DiagnosticCategory.Message, "Module_name_0_matched_pattern_1_6092", "Module name '{0}', matched pattern '{1}'."),
        Trying_substitution_0_candidate_module_location_Colon_1: diag(6093, ts3.DiagnosticCategory.Message, "Trying_substitution_0_candidate_module_location_Colon_1_6093", "Trying substitution '{0}', candidate module location: '{1}'."),
        Resolving_module_name_0_relative_to_base_url_1_2: diag(6094, ts3.DiagnosticCategory.Message, "Resolving_module_name_0_relative_to_base_url_1_2_6094", "Resolving module name '{0}' relative to base url '{1}' - '{2}'."),
        Loading_module_as_file_Slash_folder_candidate_module_location_0_target_file_type_1: diag(6095, ts3.DiagnosticCategory.Message, "Loading_module_as_file_Slash_folder_candidate_module_location_0_target_file_type_1_6095", "Loading module as file / folder, candidate module location '{0}', target file type '{1}'."),
        File_0_does_not_exist: diag(6096, ts3.DiagnosticCategory.Message, "File_0_does_not_exist_6096", "File '{0}' does not exist."),
        File_0_exist_use_it_as_a_name_resolution_result: diag(6097, ts3.DiagnosticCategory.Message, "File_0_exist_use_it_as_a_name_resolution_result_6097", "File '{0}' exist - use it as a name resolution result."),
        Loading_module_0_from_node_modules_folder_target_file_type_1: diag(6098, ts3.DiagnosticCategory.Message, "Loading_module_0_from_node_modules_folder_target_file_type_1_6098", "Loading module '{0}' from 'node_modules' folder, target file type '{1}'."),
        Found_package_json_at_0: diag(6099, ts3.DiagnosticCategory.Message, "Found_package_json_at_0_6099", "Found 'package.json' at '{0}'."),
        package_json_does_not_have_a_0_field: diag(6100, ts3.DiagnosticCategory.Message, "package_json_does_not_have_a_0_field_6100", "'package.json' does not have a '{0}' field."),
        package_json_has_0_field_1_that_references_2: diag(6101, ts3.DiagnosticCategory.Message, "package_json_has_0_field_1_that_references_2_6101", "'package.json' has '{0}' field '{1}' that references '{2}'."),
        Allow_javascript_files_to_be_compiled: diag(6102, ts3.DiagnosticCategory.Message, "Allow_javascript_files_to_be_compiled_6102", "Allow javascript files to be compiled."),
        Option_0_should_have_array_of_strings_as_a_value: diag(6103, ts3.DiagnosticCategory.Error, "Option_0_should_have_array_of_strings_as_a_value_6103", "Option '{0}' should have array of strings as a value."),
        Checking_if_0_is_the_longest_matching_prefix_for_1_2: diag(6104, ts3.DiagnosticCategory.Message, "Checking_if_0_is_the_longest_matching_prefix_for_1_2_6104", "Checking if '{0}' is the longest matching prefix for '{1}' - '{2}'."),
        Expected_type_of_0_field_in_package_json_to_be_1_got_2: diag(6105, ts3.DiagnosticCategory.Message, "Expected_type_of_0_field_in_package_json_to_be_1_got_2_6105", "Expected type of '{0}' field in 'package.json' to be '{1}', got '{2}'."),
        baseUrl_option_is_set_to_0_using_this_value_to_resolve_non_relative_module_name_1: diag(6106, ts3.DiagnosticCategory.Message, "baseUrl_option_is_set_to_0_using_this_value_to_resolve_non_relative_module_name_1_6106", "'baseUrl' option is set to '{0}', using this value to resolve non-relative module name '{1}'."),
        rootDirs_option_is_set_using_it_to_resolve_relative_module_name_0: diag(6107, ts3.DiagnosticCategory.Message, "rootDirs_option_is_set_using_it_to_resolve_relative_module_name_0_6107", "'rootDirs' option is set, using it to resolve relative module name '{0}'."),
        Longest_matching_prefix_for_0_is_1: diag(6108, ts3.DiagnosticCategory.Message, "Longest_matching_prefix_for_0_is_1_6108", "Longest matching prefix for '{0}' is '{1}'."),
        Loading_0_from_the_root_dir_1_candidate_location_2: diag(6109, ts3.DiagnosticCategory.Message, "Loading_0_from_the_root_dir_1_candidate_location_2_6109", "Loading '{0}' from the root dir '{1}', candidate location '{2}'."),
        Trying_other_entries_in_rootDirs: diag(6110, ts3.DiagnosticCategory.Message, "Trying_other_entries_in_rootDirs_6110", "Trying other entries in 'rootDirs'."),
        Module_resolution_using_rootDirs_has_failed: diag(6111, ts3.DiagnosticCategory.Message, "Module_resolution_using_rootDirs_has_failed_6111", "Module resolution using 'rootDirs' has failed."),
        Do_not_emit_use_strict_directives_in_module_output: diag(6112, ts3.DiagnosticCategory.Message, "Do_not_emit_use_strict_directives_in_module_output_6112", "Do not emit 'use strict' directives in module output."),
        Enable_strict_null_checks: diag(6113, ts3.DiagnosticCategory.Message, "Enable_strict_null_checks_6113", "Enable strict null checks."),
        Unknown_option_excludes_Did_you_mean_exclude: diag(6114, ts3.DiagnosticCategory.Error, "Unknown_option_excludes_Did_you_mean_exclude_6114", "Unknown option 'excludes'. Did you mean 'exclude'?"),
        Raise_error_on_this_expressions_with_an_implied_any_type: diag(6115, ts3.DiagnosticCategory.Message, "Raise_error_on_this_expressions_with_an_implied_any_type_6115", "Raise error on 'this' expressions with an implied 'any' type."),
        Resolving_type_reference_directive_0_containing_file_1_root_directory_2: diag(6116, ts3.DiagnosticCategory.Message, "Resolving_type_reference_directive_0_containing_file_1_root_directory_2_6116", "======== Resolving type reference directive '{0}', containing file '{1}', root directory '{2}'. ========"),
        Resolving_using_primary_search_paths: diag(6117, ts3.DiagnosticCategory.Message, "Resolving_using_primary_search_paths_6117", "Resolving using primary search paths..."),
        Resolving_from_node_modules_folder: diag(6118, ts3.DiagnosticCategory.Message, "Resolving_from_node_modules_folder_6118", "Resolving from node_modules folder..."),
        Type_reference_directive_0_was_successfully_resolved_to_1_primary_Colon_2: diag(6119, ts3.DiagnosticCategory.Message, "Type_reference_directive_0_was_successfully_resolved_to_1_primary_Colon_2_6119", "======== Type reference directive '{0}' was successfully resolved to '{1}', primary: {2}. ========"),
        Type_reference_directive_0_was_not_resolved: diag(6120, ts3.DiagnosticCategory.Message, "Type_reference_directive_0_was_not_resolved_6120", "======== Type reference directive '{0}' was not resolved. ========"),
        Resolving_with_primary_search_path_0: diag(6121, ts3.DiagnosticCategory.Message, "Resolving_with_primary_search_path_0_6121", "Resolving with primary search path '{0}'."),
        Root_directory_cannot_be_determined_skipping_primary_search_paths: diag(6122, ts3.DiagnosticCategory.Message, "Root_directory_cannot_be_determined_skipping_primary_search_paths_6122", "Root directory cannot be determined, skipping primary search paths."),
        Resolving_type_reference_directive_0_containing_file_1_root_directory_not_set: diag(6123, ts3.DiagnosticCategory.Message, "Resolving_type_reference_directive_0_containing_file_1_root_directory_not_set_6123", "======== Resolving type reference directive '{0}', containing file '{1}', root directory not set. ========"),
        Type_declaration_files_to_be_included_in_compilation: diag(6124, ts3.DiagnosticCategory.Message, "Type_declaration_files_to_be_included_in_compilation_6124", "Type declaration files to be included in compilation."),
        Looking_up_in_node_modules_folder_initial_location_0: diag(6125, ts3.DiagnosticCategory.Message, "Looking_up_in_node_modules_folder_initial_location_0_6125", "Looking up in 'node_modules' folder, initial location '{0}'."),
        Containing_file_is_not_specified_and_root_directory_cannot_be_determined_skipping_lookup_in_node_modules_folder: diag(6126, ts3.DiagnosticCategory.Message, "Containing_file_is_not_specified_and_root_directory_cannot_be_determined_skipping_lookup_in_node_mod_6126", "Containing file is not specified and root directory cannot be determined, skipping lookup in 'node_modules' folder."),
        Resolving_type_reference_directive_0_containing_file_not_set_root_directory_1: diag(6127, ts3.DiagnosticCategory.Message, "Resolving_type_reference_directive_0_containing_file_not_set_root_directory_1_6127", "======== Resolving type reference directive '{0}', containing file not set, root directory '{1}'. ========"),
        Resolving_type_reference_directive_0_containing_file_not_set_root_directory_not_set: diag(6128, ts3.DiagnosticCategory.Message, "Resolving_type_reference_directive_0_containing_file_not_set_root_directory_not_set_6128", "======== Resolving type reference directive '{0}', containing file not set, root directory not set. ========"),
        Resolving_real_path_for_0_result_1: diag(6130, ts3.DiagnosticCategory.Message, "Resolving_real_path_for_0_result_1_6130", "Resolving real path for '{0}', result '{1}'."),
        Cannot_compile_modules_using_option_0_unless_the_module_flag_is_amd_or_system: diag(6131, ts3.DiagnosticCategory.Error, "Cannot_compile_modules_using_option_0_unless_the_module_flag_is_amd_or_system_6131", "Cannot compile modules using option '{0}' unless the '--module' flag is 'amd' or 'system'."),
        File_name_0_has_a_1_extension_stripping_it: diag(6132, ts3.DiagnosticCategory.Message, "File_name_0_has_a_1_extension_stripping_it_6132", "File name '{0}' has a '{1}' extension - stripping it."),
        _0_is_declared_but_its_value_is_never_read: diag(6133, ts3.DiagnosticCategory.Error, "_0_is_declared_but_its_value_is_never_read_6133", "'{0}' is declared but its value is never read.", true),
        Report_errors_on_unused_locals: diag(6134, ts3.DiagnosticCategory.Message, "Report_errors_on_unused_locals_6134", "Report errors on unused locals."),
        Report_errors_on_unused_parameters: diag(6135, ts3.DiagnosticCategory.Message, "Report_errors_on_unused_parameters_6135", "Report errors on unused parameters."),
        The_maximum_dependency_depth_to_search_under_node_modules_and_load_JavaScript_files: diag(6136, ts3.DiagnosticCategory.Message, "The_maximum_dependency_depth_to_search_under_node_modules_and_load_JavaScript_files_6136", "The maximum dependency depth to search under node_modules and load JavaScript files."),
        Cannot_import_type_declaration_files_Consider_importing_0_instead_of_1: diag(6137, ts3.DiagnosticCategory.Error, "Cannot_import_type_declaration_files_Consider_importing_0_instead_of_1_6137", "Cannot import type declaration files. Consider importing '{0}' instead of '{1}'."),
        Property_0_is_declared_but_its_value_is_never_read: diag(6138, ts3.DiagnosticCategory.Error, "Property_0_is_declared_but_its_value_is_never_read_6138", "Property '{0}' is declared but its value is never read.", true),
        Import_emit_helpers_from_tslib: diag(6139, ts3.DiagnosticCategory.Message, "Import_emit_helpers_from_tslib_6139", "Import emit helpers from 'tslib'."),
        Auto_discovery_for_typings_is_enabled_in_project_0_Running_extra_resolution_pass_for_module_1_using_cache_location_2: diag(6140, ts3.DiagnosticCategory.Error, "Auto_discovery_for_typings_is_enabled_in_project_0_Running_extra_resolution_pass_for_module_1_using__6140", "Auto discovery for typings is enabled in project '{0}'. Running extra resolution pass for module '{1}' using cache location '{2}'."),
        Parse_in_strict_mode_and_emit_use_strict_for_each_source_file: diag(6141, ts3.DiagnosticCategory.Message, "Parse_in_strict_mode_and_emit_use_strict_for_each_source_file_6141", 'Parse in strict mode and emit "use strict" for each source file.'),
        Module_0_was_resolved_to_1_but_jsx_is_not_set: diag(6142, ts3.DiagnosticCategory.Error, "Module_0_was_resolved_to_1_but_jsx_is_not_set_6142", "Module '{0}' was resolved to '{1}', but '--jsx' is not set."),
        Module_0_was_resolved_as_locally_declared_ambient_module_in_file_1: diag(6144, ts3.DiagnosticCategory.Message, "Module_0_was_resolved_as_locally_declared_ambient_module_in_file_1_6144", "Module '{0}' was resolved as locally declared ambient module in file '{1}'."),
        Module_0_was_resolved_as_ambient_module_declared_in_1_since_this_file_was_not_modified: diag(6145, ts3.DiagnosticCategory.Message, "Module_0_was_resolved_as_ambient_module_declared_in_1_since_this_file_was_not_modified_6145", "Module '{0}' was resolved as ambient module declared in '{1}' since this file was not modified."),
        Specify_the_JSX_factory_function_to_use_when_targeting_react_JSX_emit_e_g_React_createElement_or_h: diag(6146, ts3.DiagnosticCategory.Message, "Specify_the_JSX_factory_function_to_use_when_targeting_react_JSX_emit_e_g_React_createElement_or_h_6146", "Specify the JSX factory function to use when targeting 'react' JSX emit, e.g. 'React.createElement' or 'h'."),
        Resolution_for_module_0_was_found_in_cache_from_location_1: diag(6147, ts3.DiagnosticCategory.Message, "Resolution_for_module_0_was_found_in_cache_from_location_1_6147", "Resolution for module '{0}' was found in cache from location '{1}'."),
        Directory_0_does_not_exist_skipping_all_lookups_in_it: diag(6148, ts3.DiagnosticCategory.Message, "Directory_0_does_not_exist_skipping_all_lookups_in_it_6148", "Directory '{0}' does not exist, skipping all lookups in it."),
        Show_diagnostic_information: diag(6149, ts3.DiagnosticCategory.Message, "Show_diagnostic_information_6149", "Show diagnostic information."),
        Show_verbose_diagnostic_information: diag(6150, ts3.DiagnosticCategory.Message, "Show_verbose_diagnostic_information_6150", "Show verbose diagnostic information."),
        Emit_a_single_file_with_source_maps_instead_of_having_a_separate_file: diag(6151, ts3.DiagnosticCategory.Message, "Emit_a_single_file_with_source_maps_instead_of_having_a_separate_file_6151", "Emit a single file with source maps instead of having a separate file."),
        Emit_the_source_alongside_the_sourcemaps_within_a_single_file_requires_inlineSourceMap_or_sourceMap_to_be_set: diag(6152, ts3.DiagnosticCategory.Message, "Emit_the_source_alongside_the_sourcemaps_within_a_single_file_requires_inlineSourceMap_or_sourceMap__6152", "Emit the source alongside the sourcemaps within a single file; requires '--inlineSourceMap' or '--sourceMap' to be set."),
        Transpile_each_file_as_a_separate_module_similar_to_ts_transpileModule: diag(6153, ts3.DiagnosticCategory.Message, "Transpile_each_file_as_a_separate_module_similar_to_ts_transpileModule_6153", "Transpile each file as a separate module (similar to 'ts.transpileModule')."),
        Print_names_of_generated_files_part_of_the_compilation: diag(6154, ts3.DiagnosticCategory.Message, "Print_names_of_generated_files_part_of_the_compilation_6154", "Print names of generated files part of the compilation."),
        Print_names_of_files_part_of_the_compilation: diag(6155, ts3.DiagnosticCategory.Message, "Print_names_of_files_part_of_the_compilation_6155", "Print names of files part of the compilation."),
        The_locale_used_when_displaying_messages_to_the_user_e_g_en_us: diag(6156, ts3.DiagnosticCategory.Message, "The_locale_used_when_displaying_messages_to_the_user_e_g_en_us_6156", "The locale used when displaying messages to the user (e.g. 'en-us')"),
        Do_not_generate_custom_helper_functions_like_extends_in_compiled_output: diag(6157, ts3.DiagnosticCategory.Message, "Do_not_generate_custom_helper_functions_like_extends_in_compiled_output_6157", "Do not generate custom helper functions like '__extends' in compiled output."),
        Do_not_include_the_default_library_file_lib_d_ts: diag(6158, ts3.DiagnosticCategory.Message, "Do_not_include_the_default_library_file_lib_d_ts_6158", "Do not include the default library file (lib.d.ts)."),
        Do_not_add_triple_slash_references_or_imported_modules_to_the_list_of_compiled_files: diag(6159, ts3.DiagnosticCategory.Message, "Do_not_add_triple_slash_references_or_imported_modules_to_the_list_of_compiled_files_6159", "Do not add triple-slash references or imported modules to the list of compiled files."),
        Deprecated_Use_skipLibCheck_instead_Skip_type_checking_of_default_library_declaration_files: diag(6160, ts3.DiagnosticCategory.Message, "Deprecated_Use_skipLibCheck_instead_Skip_type_checking_of_default_library_declaration_files_6160", "[Deprecated] Use '--skipLibCheck' instead. Skip type checking of default library declaration files."),
        List_of_folders_to_include_type_definitions_from: diag(6161, ts3.DiagnosticCategory.Message, "List_of_folders_to_include_type_definitions_from_6161", "List of folders to include type definitions from."),
        Disable_size_limitations_on_JavaScript_projects: diag(6162, ts3.DiagnosticCategory.Message, "Disable_size_limitations_on_JavaScript_projects_6162", "Disable size limitations on JavaScript projects."),
        The_character_set_of_the_input_files: diag(6163, ts3.DiagnosticCategory.Message, "The_character_set_of_the_input_files_6163", "The character set of the input files."),
        Emit_a_UTF_8_Byte_Order_Mark_BOM_in_the_beginning_of_output_files: diag(6164, ts3.DiagnosticCategory.Message, "Emit_a_UTF_8_Byte_Order_Mark_BOM_in_the_beginning_of_output_files_6164", "Emit a UTF-8 Byte Order Mark (BOM) in the beginning of output files."),
        Do_not_truncate_error_messages: diag(6165, ts3.DiagnosticCategory.Message, "Do_not_truncate_error_messages_6165", "Do not truncate error messages."),
        Output_directory_for_generated_declaration_files: diag(6166, ts3.DiagnosticCategory.Message, "Output_directory_for_generated_declaration_files_6166", "Output directory for generated declaration files."),
        A_series_of_entries_which_re_map_imports_to_lookup_locations_relative_to_the_baseUrl: diag(6167, ts3.DiagnosticCategory.Message, "A_series_of_entries_which_re_map_imports_to_lookup_locations_relative_to_the_baseUrl_6167", "A series of entries which re-map imports to lookup locations relative to the 'baseUrl'."),
        List_of_root_folders_whose_combined_content_represents_the_structure_of_the_project_at_runtime: diag(6168, ts3.DiagnosticCategory.Message, "List_of_root_folders_whose_combined_content_represents_the_structure_of_the_project_at_runtime_6168", "List of root folders whose combined content represents the structure of the project at runtime."),
        Show_all_compiler_options: diag(6169, ts3.DiagnosticCategory.Message, "Show_all_compiler_options_6169", "Show all compiler options."),
        Deprecated_Use_outFile_instead_Concatenate_and_emit_output_to_single_file: diag(6170, ts3.DiagnosticCategory.Message, "Deprecated_Use_outFile_instead_Concatenate_and_emit_output_to_single_file_6170", "[Deprecated] Use '--outFile' instead. Concatenate and emit output to single file"),
        Command_line_Options: diag(6171, ts3.DiagnosticCategory.Message, "Command_line_Options_6171", "Command-line Options"),
        Basic_Options: diag(6172, ts3.DiagnosticCategory.Message, "Basic_Options_6172", "Basic Options"),
        Strict_Type_Checking_Options: diag(6173, ts3.DiagnosticCategory.Message, "Strict_Type_Checking_Options_6173", "Strict Type-Checking Options"),
        Module_Resolution_Options: diag(6174, ts3.DiagnosticCategory.Message, "Module_Resolution_Options_6174", "Module Resolution Options"),
        Source_Map_Options: diag(6175, ts3.DiagnosticCategory.Message, "Source_Map_Options_6175", "Source Map Options"),
        Additional_Checks: diag(6176, ts3.DiagnosticCategory.Message, "Additional_Checks_6176", "Additional Checks"),
        Experimental_Options: diag(6177, ts3.DiagnosticCategory.Message, "Experimental_Options_6177", "Experimental Options"),
        Advanced_Options: diag(6178, ts3.DiagnosticCategory.Message, "Advanced_Options_6178", "Advanced Options"),
        Provide_full_support_for_iterables_in_for_of_spread_and_destructuring_when_targeting_ES5_or_ES3: diag(6179, ts3.DiagnosticCategory.Message, "Provide_full_support_for_iterables_in_for_of_spread_and_destructuring_when_targeting_ES5_or_ES3_6179", "Provide full support for iterables in 'for-of', spread, and destructuring when targeting 'ES5' or 'ES3'."),
        Enable_all_strict_type_checking_options: diag(6180, ts3.DiagnosticCategory.Message, "Enable_all_strict_type_checking_options_6180", "Enable all strict type-checking options."),
        List_of_language_service_plugins: diag(6181, ts3.DiagnosticCategory.Message, "List_of_language_service_plugins_6181", "List of language service plugins."),
        Scoped_package_detected_looking_in_0: diag(6182, ts3.DiagnosticCategory.Message, "Scoped_package_detected_looking_in_0_6182", "Scoped package detected, looking in '{0}'"),
        Reusing_resolution_of_module_0_to_file_1_from_old_program: diag(6183, ts3.DiagnosticCategory.Message, "Reusing_resolution_of_module_0_to_file_1_from_old_program_6183", "Reusing resolution of module '{0}' to file '{1}' from old program."),
        Reusing_module_resolutions_originating_in_0_since_resolutions_are_unchanged_from_old_program: diag(6184, ts3.DiagnosticCategory.Message, "Reusing_module_resolutions_originating_in_0_since_resolutions_are_unchanged_from_old_program_6184", "Reusing module resolutions originating in '{0}' since resolutions are unchanged from old program."),
        Disable_strict_checking_of_generic_signatures_in_function_types: diag(6185, ts3.DiagnosticCategory.Message, "Disable_strict_checking_of_generic_signatures_in_function_types_6185", "Disable strict checking of generic signatures in function types."),
        Enable_strict_checking_of_function_types: diag(6186, ts3.DiagnosticCategory.Message, "Enable_strict_checking_of_function_types_6186", "Enable strict checking of function types."),
        Enable_strict_checking_of_property_initialization_in_classes: diag(6187, ts3.DiagnosticCategory.Message, "Enable_strict_checking_of_property_initialization_in_classes_6187", "Enable strict checking of property initialization in classes."),
        Numeric_separators_are_not_allowed_here: diag(6188, ts3.DiagnosticCategory.Error, "Numeric_separators_are_not_allowed_here_6188", "Numeric separators are not allowed here."),
        Multiple_consecutive_numeric_separators_are_not_permitted: diag(6189, ts3.DiagnosticCategory.Error, "Multiple_consecutive_numeric_separators_are_not_permitted_6189", "Multiple consecutive numeric separators are not permitted."),
        Whether_to_keep_outdated_console_output_in_watch_mode_instead_of_clearing_the_screen: diag(6191, ts3.DiagnosticCategory.Message, "Whether_to_keep_outdated_console_output_in_watch_mode_instead_of_clearing_the_screen_6191", "Whether to keep outdated console output in watch mode instead of clearing the screen."),
        All_imports_in_import_declaration_are_unused: diag(6192, ts3.DiagnosticCategory.Error, "All_imports_in_import_declaration_are_unused_6192", "All imports in import declaration are unused.", true),
        Found_1_error_Watching_for_file_changes: diag(6193, ts3.DiagnosticCategory.Message, "Found_1_error_Watching_for_file_changes_6193", "Found 1 error. Watching for file changes."),
        Found_0_errors_Watching_for_file_changes: diag(6194, ts3.DiagnosticCategory.Message, "Found_0_errors_Watching_for_file_changes_6194", "Found {0} errors. Watching for file changes."),
        Resolve_keyof_to_string_valued_property_names_only_no_numbers_or_symbols: diag(6195, ts3.DiagnosticCategory.Message, "Resolve_keyof_to_string_valued_property_names_only_no_numbers_or_symbols_6195", "Resolve 'keyof' to string valued property names only (no numbers or symbols)."),
        _0_is_declared_but_never_used: diag(6196, ts3.DiagnosticCategory.Error, "_0_is_declared_but_never_used_6196", "'{0}' is declared but never used.", true),
        Include_modules_imported_with_json_extension: diag(6197, ts3.DiagnosticCategory.Message, "Include_modules_imported_with_json_extension_6197", "Include modules imported with '.json' extension"),
        All_destructured_elements_are_unused: diag(6198, ts3.DiagnosticCategory.Error, "All_destructured_elements_are_unused_6198", "All destructured elements are unused.", true),
        All_variables_are_unused: diag(6199, ts3.DiagnosticCategory.Error, "All_variables_are_unused_6199", "All variables are unused.", true),
        Definitions_of_the_following_identifiers_conflict_with_those_in_another_file_Colon_0: diag(6200, ts3.DiagnosticCategory.Error, "Definitions_of_the_following_identifiers_conflict_with_those_in_another_file_Colon_0_6200", "Definitions of the following identifiers conflict with those in another file: {0}"),
        Conflicts_are_in_this_file: diag(6201, ts3.DiagnosticCategory.Message, "Conflicts_are_in_this_file_6201", "Conflicts are in this file."),
        Project_references_may_not_form_a_circular_graph_Cycle_detected_Colon_0: diag(6202, ts3.DiagnosticCategory.Error, "Project_references_may_not_form_a_circular_graph_Cycle_detected_Colon_0_6202", "Project references may not form a circular graph. Cycle detected: {0}"),
        _0_was_also_declared_here: diag(6203, ts3.DiagnosticCategory.Message, "_0_was_also_declared_here_6203", "'{0}' was also declared here."),
        and_here: diag(6204, ts3.DiagnosticCategory.Message, "and_here_6204", "and here."),
        All_type_parameters_are_unused: diag(6205, ts3.DiagnosticCategory.Error, "All_type_parameters_are_unused_6205", "All type parameters are unused."),
        package_json_has_a_typesVersions_field_with_version_specific_path_mappings: diag(6206, ts3.DiagnosticCategory.Message, "package_json_has_a_typesVersions_field_with_version_specific_path_mappings_6206", "'package.json' has a 'typesVersions' field with version-specific path mappings."),
        package_json_does_not_have_a_typesVersions_entry_that_matches_version_0: diag(6207, ts3.DiagnosticCategory.Message, "package_json_does_not_have_a_typesVersions_entry_that_matches_version_0_6207", "'package.json' does not have a 'typesVersions' entry that matches version '{0}'."),
        package_json_has_a_typesVersions_entry_0_that_matches_compiler_version_1_looking_for_a_pattern_to_match_module_name_2: diag(6208, ts3.DiagnosticCategory.Message, "package_json_has_a_typesVersions_entry_0_that_matches_compiler_version_1_looking_for_a_pattern_to_ma_6208", "'package.json' has a 'typesVersions' entry '{0}' that matches compiler version '{1}', looking for a pattern to match module name '{2}'."),
        package_json_has_a_typesVersions_entry_0_that_is_not_a_valid_semver_range: diag(6209, ts3.DiagnosticCategory.Message, "package_json_has_a_typesVersions_entry_0_that_is_not_a_valid_semver_range_6209", "'package.json' has a 'typesVersions' entry '{0}' that is not a valid semver range."),
        An_argument_for_0_was_not_provided: diag(6210, ts3.DiagnosticCategory.Message, "An_argument_for_0_was_not_provided_6210", "An argument for '{0}' was not provided."),
        An_argument_matching_this_binding_pattern_was_not_provided: diag(6211, ts3.DiagnosticCategory.Message, "An_argument_matching_this_binding_pattern_was_not_provided_6211", "An argument matching this binding pattern was not provided."),
        Did_you_mean_to_call_this_expression: diag(6212, ts3.DiagnosticCategory.Message, "Did_you_mean_to_call_this_expression_6212", "Did you mean to call this expression?"),
        Did_you_mean_to_use_new_with_this_expression: diag(6213, ts3.DiagnosticCategory.Message, "Did_you_mean_to_use_new_with_this_expression_6213", "Did you mean to use 'new' with this expression?"),
        Enable_strict_bind_call_and_apply_methods_on_functions: diag(6214, ts3.DiagnosticCategory.Message, "Enable_strict_bind_call_and_apply_methods_on_functions_6214", "Enable strict 'bind', 'call', and 'apply' methods on functions."),
        Using_compiler_options_of_project_reference_redirect_0: diag(6215, ts3.DiagnosticCategory.Message, "Using_compiler_options_of_project_reference_redirect_0_6215", "Using compiler options of project reference redirect '{0}'."),
        Found_1_error: diag(6216, ts3.DiagnosticCategory.Message, "Found_1_error_6216", "Found 1 error."),
        Found_0_errors: diag(6217, ts3.DiagnosticCategory.Message, "Found_0_errors_6217", "Found {0} errors."),
        Module_name_0_was_successfully_resolved_to_1_with_Package_ID_2: diag(6218, ts3.DiagnosticCategory.Message, "Module_name_0_was_successfully_resolved_to_1_with_Package_ID_2_6218", "======== Module name '{0}' was successfully resolved to '{1}' with Package ID '{2}'. ========"),
        Type_reference_directive_0_was_successfully_resolved_to_1_with_Package_ID_2_primary_Colon_3: diag(6219, ts3.DiagnosticCategory.Message, "Type_reference_directive_0_was_successfully_resolved_to_1_with_Package_ID_2_primary_Colon_3_6219", "======== Type reference directive '{0}' was successfully resolved to '{1}' with Package ID '{2}', primary: {3}. ========"),
        package_json_had_a_falsy_0_field: diag(6220, ts3.DiagnosticCategory.Message, "package_json_had_a_falsy_0_field_6220", "'package.json' had a falsy '{0}' field."),
        Disable_use_of_source_files_instead_of_declaration_files_from_referenced_projects: diag(6221, ts3.DiagnosticCategory.Message, "Disable_use_of_source_files_instead_of_declaration_files_from_referenced_projects_6221", "Disable use of source files instead of declaration files from referenced projects."),
        Emit_class_fields_with_Define_instead_of_Set: diag(6222, ts3.DiagnosticCategory.Message, "Emit_class_fields_with_Define_instead_of_Set_6222", "Emit class fields with Define instead of Set."),
        Generates_a_CPU_profile: diag(6223, ts3.DiagnosticCategory.Message, "Generates_a_CPU_profile_6223", "Generates a CPU profile."),
        Disable_solution_searching_for_this_project: diag(6224, ts3.DiagnosticCategory.Message, "Disable_solution_searching_for_this_project_6224", "Disable solution searching for this project."),
        Specify_strategy_for_watching_file_Colon_FixedPollingInterval_default_PriorityPollingInterval_DynamicPriorityPolling_FixedChunkSizePolling_UseFsEvents_UseFsEventsOnParentDirectory: diag(6225, ts3.DiagnosticCategory.Message, "Specify_strategy_for_watching_file_Colon_FixedPollingInterval_default_PriorityPollingInterval_Dynami_6225", "Specify strategy for watching file: 'FixedPollingInterval' (default), 'PriorityPollingInterval', 'DynamicPriorityPolling', 'FixedChunkSizePolling', 'UseFsEvents', 'UseFsEventsOnParentDirectory'."),
        Specify_strategy_for_watching_directory_on_platforms_that_don_t_support_recursive_watching_natively_Colon_UseFsEvents_default_FixedPollingInterval_DynamicPriorityPolling_FixedChunkSizePolling: diag(6226, ts3.DiagnosticCategory.Message, "Specify_strategy_for_watching_directory_on_platforms_that_don_t_support_recursive_watching_natively__6226", "Specify strategy for watching directory on platforms that don't support recursive watching natively: 'UseFsEvents' (default), 'FixedPollingInterval', 'DynamicPriorityPolling', 'FixedChunkSizePolling'."),
        Specify_strategy_for_creating_a_polling_watch_when_it_fails_to_create_using_file_system_events_Colon_FixedInterval_default_PriorityInterval_DynamicPriority_FixedChunkSize: diag(6227, ts3.DiagnosticCategory.Message, "Specify_strategy_for_creating_a_polling_watch_when_it_fails_to_create_using_file_system_events_Colon_6227", "Specify strategy for creating a polling watch when it fails to create using file system events: 'FixedInterval' (default), 'PriorityInterval', 'DynamicPriority', 'FixedChunkSize'."),
        Synchronously_call_callbacks_and_update_the_state_of_directory_watchers_on_platforms_that_don_t_support_recursive_watching_natively: diag(6228, ts3.DiagnosticCategory.Message, "Synchronously_call_callbacks_and_update_the_state_of_directory_watchers_on_platforms_that_don_t_supp_6228", "Synchronously call callbacks and update the state of directory watchers on platforms that don't support recursive watching natively."),
        Tag_0_expects_at_least_1_arguments_but_the_JSX_factory_2_provides_at_most_3: diag(6229, ts3.DiagnosticCategory.Error, "Tag_0_expects_at_least_1_arguments_but_the_JSX_factory_2_provides_at_most_3_6229", "Tag '{0}' expects at least '{1}' arguments, but the JSX factory '{2}' provides at most '{3}'."),
        Option_0_can_only_be_specified_in_tsconfig_json_file_or_set_to_false_or_null_on_command_line: diag(6230, ts3.DiagnosticCategory.Error, "Option_0_can_only_be_specified_in_tsconfig_json_file_or_set_to_false_or_null_on_command_line_6230", "Option '{0}' can only be specified in 'tsconfig.json' file or set to 'false' or 'null' on command line."),
        Could_not_resolve_the_path_0_with_the_extensions_Colon_1: diag(6231, ts3.DiagnosticCategory.Error, "Could_not_resolve_the_path_0_with_the_extensions_Colon_1_6231", "Could not resolve the path '{0}' with the extensions: {1}."),
        Declaration_augments_declaration_in_another_file_This_cannot_be_serialized: diag(6232, ts3.DiagnosticCategory.Error, "Declaration_augments_declaration_in_another_file_This_cannot_be_serialized_6232", "Declaration augments declaration in another file. This cannot be serialized."),
        This_is_the_declaration_being_augmented_Consider_moving_the_augmenting_declaration_into_the_same_file: diag(6233, ts3.DiagnosticCategory.Error, "This_is_the_declaration_being_augmented_Consider_moving_the_augmenting_declaration_into_the_same_fil_6233", "This is the declaration being augmented. Consider moving the augmenting declaration into the same file."),
        This_expression_is_not_callable_because_it_is_a_get_accessor_Did_you_mean_to_use_it_without: diag(6234, ts3.DiagnosticCategory.Error, "This_expression_is_not_callable_because_it_is_a_get_accessor_Did_you_mean_to_use_it_without_6234", "This expression is not callable because it is a 'get' accessor. Did you mean to use it without '()'?"),
        Disable_loading_referenced_projects: diag(6235, ts3.DiagnosticCategory.Message, "Disable_loading_referenced_projects_6235", "Disable loading referenced projects."),
        Arguments_for_the_rest_parameter_0_were_not_provided: diag(6236, ts3.DiagnosticCategory.Error, "Arguments_for_the_rest_parameter_0_were_not_provided_6236", "Arguments for the rest parameter '{0}' were not provided."),
        Generates_an_event_trace_and_a_list_of_types: diag(6237, ts3.DiagnosticCategory.Message, "Generates_an_event_trace_and_a_list_of_types_6237", "Generates an event trace and a list of types."),
        Specify_the_module_specifier_to_be_used_to_import_the_jsx_and_jsxs_factory_functions_from_eg_react: diag(6238, ts3.DiagnosticCategory.Error, "Specify_the_module_specifier_to_be_used_to_import_the_jsx_and_jsxs_factory_functions_from_eg_react_6238", "Specify the module specifier to be used to import the 'jsx' and 'jsxs' factory functions from. eg, react"),
        File_0_exists_according_to_earlier_cached_lookups: diag(6239, ts3.DiagnosticCategory.Message, "File_0_exists_according_to_earlier_cached_lookups_6239", "File '{0}' exists according to earlier cached lookups."),
        File_0_does_not_exist_according_to_earlier_cached_lookups: diag(6240, ts3.DiagnosticCategory.Message, "File_0_does_not_exist_according_to_earlier_cached_lookups_6240", "File '{0}' does not exist according to earlier cached lookups."),
        Resolution_for_type_reference_directive_0_was_found_in_cache_from_location_1: diag(6241, ts3.DiagnosticCategory.Message, "Resolution_for_type_reference_directive_0_was_found_in_cache_from_location_1_6241", "Resolution for type reference directive '{0}' was found in cache from location '{1}'."),
        Resolving_type_reference_directive_0_containing_file_1: diag(6242, ts3.DiagnosticCategory.Message, "Resolving_type_reference_directive_0_containing_file_1_6242", "======== Resolving type reference directive '{0}', containing file '{1}'. ========"),
        Projects_to_reference: diag(6300, ts3.DiagnosticCategory.Message, "Projects_to_reference_6300", "Projects to reference"),
        Enable_project_compilation: diag(6302, ts3.DiagnosticCategory.Message, "Enable_project_compilation_6302", "Enable project compilation"),
        Composite_projects_may_not_disable_declaration_emit: diag(6304, ts3.DiagnosticCategory.Error, "Composite_projects_may_not_disable_declaration_emit_6304", "Composite projects may not disable declaration emit."),
        Output_file_0_has_not_been_built_from_source_file_1: diag(6305, ts3.DiagnosticCategory.Error, "Output_file_0_has_not_been_built_from_source_file_1_6305", "Output file '{0}' has not been built from source file '{1}'."),
        Referenced_project_0_must_have_setting_composite_Colon_true: diag(6306, ts3.DiagnosticCategory.Error, "Referenced_project_0_must_have_setting_composite_Colon_true_6306", `Referenced project '{0}' must have setting "composite": true.`),
        File_0_is_not_listed_within_the_file_list_of_project_1_Projects_must_list_all_files_or_use_an_include_pattern: diag(6307, ts3.DiagnosticCategory.Error, "File_0_is_not_listed_within_the_file_list_of_project_1_Projects_must_list_all_files_or_use_an_includ_6307", "File '{0}' is not listed within the file list of project '{1}'. Projects must list all files or use an 'include' pattern."),
        Cannot_prepend_project_0_because_it_does_not_have_outFile_set: diag(6308, ts3.DiagnosticCategory.Error, "Cannot_prepend_project_0_because_it_does_not_have_outFile_set_6308", "Cannot prepend project '{0}' because it does not have 'outFile' set"),
        Output_file_0_from_project_1_does_not_exist: diag(6309, ts3.DiagnosticCategory.Error, "Output_file_0_from_project_1_does_not_exist_6309", "Output file '{0}' from project '{1}' does not exist"),
        Referenced_project_0_may_not_disable_emit: diag(6310, ts3.DiagnosticCategory.Error, "Referenced_project_0_may_not_disable_emit_6310", "Referenced project '{0}' may not disable emit."),
        Project_0_is_out_of_date_because_oldest_output_1_is_older_than_newest_input_2: diag(6350, ts3.DiagnosticCategory.Message, "Project_0_is_out_of_date_because_oldest_output_1_is_older_than_newest_input_2_6350", "Project '{0}' is out of date because oldest output '{1}' is older than newest input '{2}'"),
        Project_0_is_up_to_date_because_newest_input_1_is_older_than_oldest_output_2: diag(6351, ts3.DiagnosticCategory.Message, "Project_0_is_up_to_date_because_newest_input_1_is_older_than_oldest_output_2_6351", "Project '{0}' is up to date because newest input '{1}' is older than oldest output '{2}'"),
        Project_0_is_out_of_date_because_output_file_1_does_not_exist: diag(6352, ts3.DiagnosticCategory.Message, "Project_0_is_out_of_date_because_output_file_1_does_not_exist_6352", "Project '{0}' is out of date because output file '{1}' does not exist"),
        Project_0_is_out_of_date_because_its_dependency_1_is_out_of_date: diag(6353, ts3.DiagnosticCategory.Message, "Project_0_is_out_of_date_because_its_dependency_1_is_out_of_date_6353", "Project '{0}' is out of date because its dependency '{1}' is out of date"),
        Project_0_is_up_to_date_with_d_ts_files_from_its_dependencies: diag(6354, ts3.DiagnosticCategory.Message, "Project_0_is_up_to_date_with_d_ts_files_from_its_dependencies_6354", "Project '{0}' is up to date with .d.ts files from its dependencies"),
        Projects_in_this_build_Colon_0: diag(6355, ts3.DiagnosticCategory.Message, "Projects_in_this_build_Colon_0_6355", "Projects in this build: {0}"),
        A_non_dry_build_would_delete_the_following_files_Colon_0: diag(6356, ts3.DiagnosticCategory.Message, "A_non_dry_build_would_delete_the_following_files_Colon_0_6356", "A non-dry build would delete the following files: {0}"),
        A_non_dry_build_would_build_project_0: diag(6357, ts3.DiagnosticCategory.Message, "A_non_dry_build_would_build_project_0_6357", "A non-dry build would build project '{0}'"),
        Building_project_0: diag(6358, ts3.DiagnosticCategory.Message, "Building_project_0_6358", "Building project '{0}'..."),
        Updating_output_timestamps_of_project_0: diag(6359, ts3.DiagnosticCategory.Message, "Updating_output_timestamps_of_project_0_6359", "Updating output timestamps of project '{0}'..."),
        delete_this_Project_0_is_up_to_date_because_it_was_previously_built: diag(6360, ts3.DiagnosticCategory.Message, "delete_this_Project_0_is_up_to_date_because_it_was_previously_built_6360", "delete this - Project '{0}' is up to date because it was previously built"),
        Project_0_is_up_to_date: diag(6361, ts3.DiagnosticCategory.Message, "Project_0_is_up_to_date_6361", "Project '{0}' is up to date"),
        Skipping_build_of_project_0_because_its_dependency_1_has_errors: diag(6362, ts3.DiagnosticCategory.Message, "Skipping_build_of_project_0_because_its_dependency_1_has_errors_6362", "Skipping build of project '{0}' because its dependency '{1}' has errors"),
        Project_0_can_t_be_built_because_its_dependency_1_has_errors: diag(6363, ts3.DiagnosticCategory.Message, "Project_0_can_t_be_built_because_its_dependency_1_has_errors_6363", "Project '{0}' can't be built because its dependency '{1}' has errors"),
        Build_one_or_more_projects_and_their_dependencies_if_out_of_date: diag(6364, ts3.DiagnosticCategory.Message, "Build_one_or_more_projects_and_their_dependencies_if_out_of_date_6364", "Build one or more projects and their dependencies, if out of date"),
        Delete_the_outputs_of_all_projects: diag(6365, ts3.DiagnosticCategory.Message, "Delete_the_outputs_of_all_projects_6365", "Delete the outputs of all projects"),
        Enable_verbose_logging: diag(6366, ts3.DiagnosticCategory.Message, "Enable_verbose_logging_6366", "Enable verbose logging"),
        Show_what_would_be_built_or_deleted_if_specified_with_clean: diag(6367, ts3.DiagnosticCategory.Message, "Show_what_would_be_built_or_deleted_if_specified_with_clean_6367", "Show what would be built (or deleted, if specified with '--clean')"),
        Build_all_projects_including_those_that_appear_to_be_up_to_date: diag(6368, ts3.DiagnosticCategory.Message, "Build_all_projects_including_those_that_appear_to_be_up_to_date_6368", "Build all projects, including those that appear to be up to date"),
        Option_build_must_be_the_first_command_line_argument: diag(6369, ts3.DiagnosticCategory.Error, "Option_build_must_be_the_first_command_line_argument_6369", "Option '--build' must be the first command line argument."),
        Options_0_and_1_cannot_be_combined: diag(6370, ts3.DiagnosticCategory.Error, "Options_0_and_1_cannot_be_combined_6370", "Options '{0}' and '{1}' cannot be combined."),
        Updating_unchanged_output_timestamps_of_project_0: diag(6371, ts3.DiagnosticCategory.Message, "Updating_unchanged_output_timestamps_of_project_0_6371", "Updating unchanged output timestamps of project '{0}'..."),
        Project_0_is_out_of_date_because_output_of_its_dependency_1_has_changed: diag(6372, ts3.DiagnosticCategory.Message, "Project_0_is_out_of_date_because_output_of_its_dependency_1_has_changed_6372", "Project '{0}' is out of date because output of its dependency '{1}' has changed"),
        Updating_output_of_project_0: diag(6373, ts3.DiagnosticCategory.Message, "Updating_output_of_project_0_6373", "Updating output of project '{0}'..."),
        A_non_dry_build_would_update_timestamps_for_output_of_project_0: diag(6374, ts3.DiagnosticCategory.Message, "A_non_dry_build_would_update_timestamps_for_output_of_project_0_6374", "A non-dry build would update timestamps for output of project '{0}'"),
        A_non_dry_build_would_update_output_of_project_0: diag(6375, ts3.DiagnosticCategory.Message, "A_non_dry_build_would_update_output_of_project_0_6375", "A non-dry build would update output of project '{0}'"),
        Cannot_update_output_of_project_0_because_there_was_error_reading_file_1: diag(6376, ts3.DiagnosticCategory.Message, "Cannot_update_output_of_project_0_because_there_was_error_reading_file_1_6376", "Cannot update output of project '{0}' because there was error reading file '{1}'"),
        Cannot_write_file_0_because_it_will_overwrite_tsbuildinfo_file_generated_by_referenced_project_1: diag(6377, ts3.DiagnosticCategory.Error, "Cannot_write_file_0_because_it_will_overwrite_tsbuildinfo_file_generated_by_referenced_project_1_6377", "Cannot write file '{0}' because it will overwrite '.tsbuildinfo' file generated by referenced project '{1}'"),
        Enable_incremental_compilation: diag(6378, ts3.DiagnosticCategory.Message, "Enable_incremental_compilation_6378", "Enable incremental compilation"),
        Composite_projects_may_not_disable_incremental_compilation: diag(6379, ts3.DiagnosticCategory.Error, "Composite_projects_may_not_disable_incremental_compilation_6379", "Composite projects may not disable incremental compilation."),
        Specify_file_to_store_incremental_compilation_information: diag(6380, ts3.DiagnosticCategory.Message, "Specify_file_to_store_incremental_compilation_information_6380", "Specify file to store incremental compilation information"),
        Project_0_is_out_of_date_because_output_for_it_was_generated_with_version_1_that_differs_with_current_version_2: diag(6381, ts3.DiagnosticCategory.Message, "Project_0_is_out_of_date_because_output_for_it_was_generated_with_version_1_that_differs_with_curren_6381", "Project '{0}' is out of date because output for it was generated with version '{1}' that differs with current version '{2}'"),
        Skipping_build_of_project_0_because_its_dependency_1_was_not_built: diag(6382, ts3.DiagnosticCategory.Message, "Skipping_build_of_project_0_because_its_dependency_1_was_not_built_6382", "Skipping build of project '{0}' because its dependency '{1}' was not built"),
        Project_0_can_t_be_built_because_its_dependency_1_was_not_built: diag(6383, ts3.DiagnosticCategory.Message, "Project_0_can_t_be_built_because_its_dependency_1_was_not_built_6383", "Project '{0}' can't be built because its dependency '{1}' was not built"),
        Have_recompiles_in_incremental_and_watch_assume_that_changes_within_a_file_will_only_affect_files_directly_depending_on_it: diag(6384, ts3.DiagnosticCategory.Message, "Have_recompiles_in_incremental_and_watch_assume_that_changes_within_a_file_will_only_affect_files_di_6384", "Have recompiles in '--incremental' and '--watch' assume that changes within a file will only affect files directly depending on it."),
        _0_is_deprecated: diag(6385, ts3.DiagnosticCategory.Suggestion, "_0_is_deprecated_6385", "'{0}' is deprecated.", void 0, void 0, true),
        Performance_timings_for_diagnostics_or_extendedDiagnostics_are_not_available_in_this_session_A_native_implementation_of_the_Web_Performance_API_could_not_be_found: diag(6386, ts3.DiagnosticCategory.Message, "Performance_timings_for_diagnostics_or_extendedDiagnostics_are_not_available_in_this_session_A_nativ_6386", "Performance timings for '--diagnostics' or '--extendedDiagnostics' are not available in this session. A native implementation of the Web Performance API could not be found."),
        The_signature_0_of_1_is_deprecated: diag(6387, ts3.DiagnosticCategory.Suggestion, "The_signature_0_of_1_is_deprecated_6387", "The signature '{0}' of '{1}' is deprecated.", void 0, void 0, true),
        Project_0_is_being_forcibly_rebuilt: diag(6388, ts3.DiagnosticCategory.Message, "Project_0_is_being_forcibly_rebuilt_6388", "Project '{0}' is being forcibly rebuilt"),
        The_expected_type_comes_from_property_0_which_is_declared_here_on_type_1: diag(6500, ts3.DiagnosticCategory.Message, "The_expected_type_comes_from_property_0_which_is_declared_here_on_type_1_6500", "The expected type comes from property '{0}' which is declared here on type '{1}'"),
        The_expected_type_comes_from_this_index_signature: diag(6501, ts3.DiagnosticCategory.Message, "The_expected_type_comes_from_this_index_signature_6501", "The expected type comes from this index signature."),
        The_expected_type_comes_from_the_return_type_of_this_signature: diag(6502, ts3.DiagnosticCategory.Message, "The_expected_type_comes_from_the_return_type_of_this_signature_6502", "The expected type comes from the return type of this signature."),
        Print_names_of_files_that_are_part_of_the_compilation_and_then_stop_processing: diag(6503, ts3.DiagnosticCategory.Message, "Print_names_of_files_that_are_part_of_the_compilation_and_then_stop_processing_6503", "Print names of files that are part of the compilation and then stop processing."),
        File_0_is_a_JavaScript_file_Did_you_mean_to_enable_the_allowJs_option: diag(6504, ts3.DiagnosticCategory.Error, "File_0_is_a_JavaScript_file_Did_you_mean_to_enable_the_allowJs_option_6504", "File '{0}' is a JavaScript file. Did you mean to enable the 'allowJs' option?"),
        Print_names_of_files_and_the_reason_they_are_part_of_the_compilation: diag(6505, ts3.DiagnosticCategory.Message, "Print_names_of_files_and_the_reason_they_are_part_of_the_compilation_6505", "Print names of files and the reason they are part of the compilation."),
        Include_undefined_in_index_signature_results: diag(6800, ts3.DiagnosticCategory.Message, "Include_undefined_in_index_signature_results_6800", "Include 'undefined' in index signature results"),
        Ensure_overriding_members_in_derived_classes_are_marked_with_an_override_modifier: diag(6801, ts3.DiagnosticCategory.Message, "Ensure_overriding_members_in_derived_classes_are_marked_with_an_override_modifier_6801", "Ensure overriding members in derived classes are marked with an 'override' modifier."),
        Require_undeclared_properties_from_index_signatures_to_use_element_accesses: diag(6802, ts3.DiagnosticCategory.Message, "Require_undeclared_properties_from_index_signatures_to_use_element_accesses_6802", "Require undeclared properties from index signatures to use element accesses."),
        Variable_0_implicitly_has_an_1_type: diag(7005, ts3.DiagnosticCategory.Error, "Variable_0_implicitly_has_an_1_type_7005", "Variable '{0}' implicitly has an '{1}' type."),
        Parameter_0_implicitly_has_an_1_type: diag(7006, ts3.DiagnosticCategory.Error, "Parameter_0_implicitly_has_an_1_type_7006", "Parameter '{0}' implicitly has an '{1}' type."),
        Member_0_implicitly_has_an_1_type: diag(7008, ts3.DiagnosticCategory.Error, "Member_0_implicitly_has_an_1_type_7008", "Member '{0}' implicitly has an '{1}' type."),
        new_expression_whose_target_lacks_a_construct_signature_implicitly_has_an_any_type: diag(7009, ts3.DiagnosticCategory.Error, "new_expression_whose_target_lacks_a_construct_signature_implicitly_has_an_any_type_7009", "'new' expression, whose target lacks a construct signature, implicitly has an 'any' type."),
        _0_which_lacks_return_type_annotation_implicitly_has_an_1_return_type: diag(7010, ts3.DiagnosticCategory.Error, "_0_which_lacks_return_type_annotation_implicitly_has_an_1_return_type_7010", "'{0}', which lacks return-type annotation, implicitly has an '{1}' return type."),
        Function_expression_which_lacks_return_type_annotation_implicitly_has_an_0_return_type: diag(7011, ts3.DiagnosticCategory.Error, "Function_expression_which_lacks_return_type_annotation_implicitly_has_an_0_return_type_7011", "Function expression, which lacks return-type annotation, implicitly has an '{0}' return type."),
        Construct_signature_which_lacks_return_type_annotation_implicitly_has_an_any_return_type: diag(7013, ts3.DiagnosticCategory.Error, "Construct_signature_which_lacks_return_type_annotation_implicitly_has_an_any_return_type_7013", "Construct signature, which lacks return-type annotation, implicitly has an 'any' return type."),
        Function_type_which_lacks_return_type_annotation_implicitly_has_an_0_return_type: diag(7014, ts3.DiagnosticCategory.Error, "Function_type_which_lacks_return_type_annotation_implicitly_has_an_0_return_type_7014", "Function type, which lacks return-type annotation, implicitly has an '{0}' return type."),
        Element_implicitly_has_an_any_type_because_index_expression_is_not_of_type_number: diag(7015, ts3.DiagnosticCategory.Error, "Element_implicitly_has_an_any_type_because_index_expression_is_not_of_type_number_7015", "Element implicitly has an 'any' type because index expression is not of type 'number'."),
        Could_not_find_a_declaration_file_for_module_0_1_implicitly_has_an_any_type: diag(7016, ts3.DiagnosticCategory.Error, "Could_not_find_a_declaration_file_for_module_0_1_implicitly_has_an_any_type_7016", "Could not find a declaration file for module '{0}'. '{1}' implicitly has an 'any' type."),
        Element_implicitly_has_an_any_type_because_type_0_has_no_index_signature: diag(7017, ts3.DiagnosticCategory.Error, "Element_implicitly_has_an_any_type_because_type_0_has_no_index_signature_7017", "Element implicitly has an 'any' type because type '{0}' has no index signature."),
        Object_literal_s_property_0_implicitly_has_an_1_type: diag(7018, ts3.DiagnosticCategory.Error, "Object_literal_s_property_0_implicitly_has_an_1_type_7018", "Object literal's property '{0}' implicitly has an '{1}' type."),
        Rest_parameter_0_implicitly_has_an_any_type: diag(7019, ts3.DiagnosticCategory.Error, "Rest_parameter_0_implicitly_has_an_any_type_7019", "Rest parameter '{0}' implicitly has an 'any[]' type."),
        Call_signature_which_lacks_return_type_annotation_implicitly_has_an_any_return_type: diag(7020, ts3.DiagnosticCategory.Error, "Call_signature_which_lacks_return_type_annotation_implicitly_has_an_any_return_type_7020", "Call signature, which lacks return-type annotation, implicitly has an 'any' return type."),
        _0_implicitly_has_type_any_because_it_does_not_have_a_type_annotation_and_is_referenced_directly_or_indirectly_in_its_own_initializer: diag(7022, ts3.DiagnosticCategory.Error, "_0_implicitly_has_type_any_because_it_does_not_have_a_type_annotation_and_is_referenced_directly_or__7022", "'{0}' implicitly has type 'any' because it does not have a type annotation and is referenced directly or indirectly in its own initializer."),
        _0_implicitly_has_return_type_any_because_it_does_not_have_a_return_type_annotation_and_is_referenced_directly_or_indirectly_in_one_of_its_return_expressions: diag(7023, ts3.DiagnosticCategory.Error, "_0_implicitly_has_return_type_any_because_it_does_not_have_a_return_type_annotation_and_is_reference_7023", "'{0}' implicitly has return type 'any' because it does not have a return type annotation and is referenced directly or indirectly in one of its return expressions."),
        Function_implicitly_has_return_type_any_because_it_does_not_have_a_return_type_annotation_and_is_referenced_directly_or_indirectly_in_one_of_its_return_expressions: diag(7024, ts3.DiagnosticCategory.Error, "Function_implicitly_has_return_type_any_because_it_does_not_have_a_return_type_annotation_and_is_ref_7024", "Function implicitly has return type 'any' because it does not have a return type annotation and is referenced directly or indirectly in one of its return expressions."),
        Generator_implicitly_has_yield_type_0_because_it_does_not_yield_any_values_Consider_supplying_a_return_type_annotation: diag(7025, ts3.DiagnosticCategory.Error, "Generator_implicitly_has_yield_type_0_because_it_does_not_yield_any_values_Consider_supplying_a_retu_7025", "Generator implicitly has yield type '{0}' because it does not yield any values. Consider supplying a return type annotation."),
        JSX_element_implicitly_has_type_any_because_no_interface_JSX_0_exists: diag(7026, ts3.DiagnosticCategory.Error, "JSX_element_implicitly_has_type_any_because_no_interface_JSX_0_exists_7026", "JSX element implicitly has type 'any' because no interface 'JSX.{0}' exists."),
        Unreachable_code_detected: diag(7027, ts3.DiagnosticCategory.Error, "Unreachable_code_detected_7027", "Unreachable code detected.", true),
        Unused_label: diag(7028, ts3.DiagnosticCategory.Error, "Unused_label_7028", "Unused label.", true),
        Fallthrough_case_in_switch: diag(7029, ts3.DiagnosticCategory.Error, "Fallthrough_case_in_switch_7029", "Fallthrough case in switch."),
        Not_all_code_paths_return_a_value: diag(7030, ts3.DiagnosticCategory.Error, "Not_all_code_paths_return_a_value_7030", "Not all code paths return a value."),
        Binding_element_0_implicitly_has_an_1_type: diag(7031, ts3.DiagnosticCategory.Error, "Binding_element_0_implicitly_has_an_1_type_7031", "Binding element '{0}' implicitly has an '{1}' type."),
        Property_0_implicitly_has_type_any_because_its_set_accessor_lacks_a_parameter_type_annotation: diag(7032, ts3.DiagnosticCategory.Error, "Property_0_implicitly_has_type_any_because_its_set_accessor_lacks_a_parameter_type_annotation_7032", "Property '{0}' implicitly has type 'any', because its set accessor lacks a parameter type annotation."),
        Property_0_implicitly_has_type_any_because_its_get_accessor_lacks_a_return_type_annotation: diag(7033, ts3.DiagnosticCategory.Error, "Property_0_implicitly_has_type_any_because_its_get_accessor_lacks_a_return_type_annotation_7033", "Property '{0}' implicitly has type 'any', because its get accessor lacks a return type annotation."),
        Variable_0_implicitly_has_type_1_in_some_locations_where_its_type_cannot_be_determined: diag(7034, ts3.DiagnosticCategory.Error, "Variable_0_implicitly_has_type_1_in_some_locations_where_its_type_cannot_be_determined_7034", "Variable '{0}' implicitly has type '{1}' in some locations where its type cannot be determined."),
        Try_npm_i_save_dev_types_Slash_1_if_it_exists_or_add_a_new_declaration_d_ts_file_containing_declare_module_0: diag(7035, ts3.DiagnosticCategory.Error, "Try_npm_i_save_dev_types_Slash_1_if_it_exists_or_add_a_new_declaration_d_ts_file_containing_declare__7035", "Try `npm i --save-dev @types/{1}` if it exists or add a new declaration (.d.ts) file containing `declare module '{0}';`"),
        Dynamic_import_s_specifier_must_be_of_type_string_but_here_has_type_0: diag(7036, ts3.DiagnosticCategory.Error, "Dynamic_import_s_specifier_must_be_of_type_string_but_here_has_type_0_7036", "Dynamic import's specifier must be of type 'string', but here has type '{0}'."),
        Enables_emit_interoperability_between_CommonJS_and_ES_Modules_via_creation_of_namespace_objects_for_all_imports_Implies_allowSyntheticDefaultImports: diag(7037, ts3.DiagnosticCategory.Message, "Enables_emit_interoperability_between_CommonJS_and_ES_Modules_via_creation_of_namespace_objects_for__7037", "Enables emit interoperability between CommonJS and ES Modules via creation of namespace objects for all imports. Implies 'allowSyntheticDefaultImports'."),
        Type_originates_at_this_import_A_namespace_style_import_cannot_be_called_or_constructed_and_will_cause_a_failure_at_runtime_Consider_using_a_default_import_or_import_require_here_instead: diag(7038, ts3.DiagnosticCategory.Message, "Type_originates_at_this_import_A_namespace_style_import_cannot_be_called_or_constructed_and_will_cau_7038", "Type originates at this import. A namespace-style import cannot be called or constructed, and will cause a failure at runtime. Consider using a default import or import require here instead."),
        Mapped_object_type_implicitly_has_an_any_template_type: diag(7039, ts3.DiagnosticCategory.Error, "Mapped_object_type_implicitly_has_an_any_template_type_7039", "Mapped object type implicitly has an 'any' template type."),
        If_the_0_package_actually_exposes_this_module_consider_sending_a_pull_request_to_amend_https_Colon_Slash_Slashgithub_com_SlashDefinitelyTyped_SlashDefinitelyTyped_Slashtree_Slashmaster_Slashtypes_Slash_1: diag(7040, ts3.DiagnosticCategory.Error, "If_the_0_package_actually_exposes_this_module_consider_sending_a_pull_request_to_amend_https_Colon_S_7040", "If the '{0}' package actually exposes this module, consider sending a pull request to amend 'https://github.com/DefinitelyTyped/DefinitelyTyped/tree/master/types/{1}'"),
        The_containing_arrow_function_captures_the_global_value_of_this: diag(7041, ts3.DiagnosticCategory.Error, "The_containing_arrow_function_captures_the_global_value_of_this_7041", "The containing arrow function captures the global value of 'this'."),
        Module_0_was_resolved_to_1_but_resolveJsonModule_is_not_used: diag(7042, ts3.DiagnosticCategory.Error, "Module_0_was_resolved_to_1_but_resolveJsonModule_is_not_used_7042", "Module '{0}' was resolved to '{1}', but '--resolveJsonModule' is not used."),
        Variable_0_implicitly_has_an_1_type_but_a_better_type_may_be_inferred_from_usage: diag(7043, ts3.DiagnosticCategory.Suggestion, "Variable_0_implicitly_has_an_1_type_but_a_better_type_may_be_inferred_from_usage_7043", "Variable '{0}' implicitly has an '{1}' type, but a better type may be inferred from usage."),
        Parameter_0_implicitly_has_an_1_type_but_a_better_type_may_be_inferred_from_usage: diag(7044, ts3.DiagnosticCategory.Suggestion, "Parameter_0_implicitly_has_an_1_type_but_a_better_type_may_be_inferred_from_usage_7044", "Parameter '{0}' implicitly has an '{1}' type, but a better type may be inferred from usage."),
        Member_0_implicitly_has_an_1_type_but_a_better_type_may_be_inferred_from_usage: diag(7045, ts3.DiagnosticCategory.Suggestion, "Member_0_implicitly_has_an_1_type_but_a_better_type_may_be_inferred_from_usage_7045", "Member '{0}' implicitly has an '{1}' type, but a better type may be inferred from usage."),
        Variable_0_implicitly_has_type_1_in_some_locations_but_a_better_type_may_be_inferred_from_usage: diag(7046, ts3.DiagnosticCategory.Suggestion, "Variable_0_implicitly_has_type_1_in_some_locations_but_a_better_type_may_be_inferred_from_usage_7046", "Variable '{0}' implicitly has type '{1}' in some locations, but a better type may be inferred from usage."),
        Rest_parameter_0_implicitly_has_an_any_type_but_a_better_type_may_be_inferred_from_usage: diag(7047, ts3.DiagnosticCategory.Suggestion, "Rest_parameter_0_implicitly_has_an_any_type_but_a_better_type_may_be_inferred_from_usage_7047", "Rest parameter '{0}' implicitly has an 'any[]' type, but a better type may be inferred from usage."),
        Property_0_implicitly_has_type_any_but_a_better_type_for_its_get_accessor_may_be_inferred_from_usage: diag(7048, ts3.DiagnosticCategory.Suggestion, "Property_0_implicitly_has_type_any_but_a_better_type_for_its_get_accessor_may_be_inferred_from_usage_7048", "Property '{0}' implicitly has type 'any', but a better type for its get accessor may be inferred from usage."),
        Property_0_implicitly_has_type_any_but_a_better_type_for_its_set_accessor_may_be_inferred_from_usage: diag(7049, ts3.DiagnosticCategory.Suggestion, "Property_0_implicitly_has_type_any_but_a_better_type_for_its_set_accessor_may_be_inferred_from_usage_7049", "Property '{0}' implicitly has type 'any', but a better type for its set accessor may be inferred from usage."),
        _0_implicitly_has_an_1_return_type_but_a_better_type_may_be_inferred_from_usage: diag(7050, ts3.DiagnosticCategory.Suggestion, "_0_implicitly_has_an_1_return_type_but_a_better_type_may_be_inferred_from_usage_7050", "'{0}' implicitly has an '{1}' return type, but a better type may be inferred from usage."),
        Parameter_has_a_name_but_no_type_Did_you_mean_0_Colon_1: diag(7051, ts3.DiagnosticCategory.Error, "Parameter_has_a_name_but_no_type_Did_you_mean_0_Colon_1_7051", "Parameter has a name but no type. Did you mean '{0}: {1}'?"),
        Element_implicitly_has_an_any_type_because_type_0_has_no_index_signature_Did_you_mean_to_call_1: diag(7052, ts3.DiagnosticCategory.Error, "Element_implicitly_has_an_any_type_because_type_0_has_no_index_signature_Did_you_mean_to_call_1_7052", "Element implicitly has an 'any' type because type '{0}' has no index signature. Did you mean to call '{1}'?"),
        Element_implicitly_has_an_any_type_because_expression_of_type_0_can_t_be_used_to_index_type_1: diag(7053, ts3.DiagnosticCategory.Error, "Element_implicitly_has_an_any_type_because_expression_of_type_0_can_t_be_used_to_index_type_1_7053", "Element implicitly has an 'any' type because expression of type '{0}' can't be used to index type '{1}'."),
        No_index_signature_with_a_parameter_of_type_0_was_found_on_type_1: diag(7054, ts3.DiagnosticCategory.Error, "No_index_signature_with_a_parameter_of_type_0_was_found_on_type_1_7054", "No index signature with a parameter of type '{0}' was found on type '{1}'."),
        _0_which_lacks_return_type_annotation_implicitly_has_an_1_yield_type: diag(7055, ts3.DiagnosticCategory.Error, "_0_which_lacks_return_type_annotation_implicitly_has_an_1_yield_type_7055", "'{0}', which lacks return-type annotation, implicitly has an '{1}' yield type."),
        The_inferred_type_of_this_node_exceeds_the_maximum_length_the_compiler_will_serialize_An_explicit_type_annotation_is_needed: diag(7056, ts3.DiagnosticCategory.Error, "The_inferred_type_of_this_node_exceeds_the_maximum_length_the_compiler_will_serialize_An_explicit_ty_7056", "The inferred type of this node exceeds the maximum length the compiler will serialize. An explicit type annotation is needed."),
        yield_expression_implicitly_results_in_an_any_type_because_its_containing_generator_lacks_a_return_type_annotation: diag(7057, ts3.DiagnosticCategory.Error, "yield_expression_implicitly_results_in_an_any_type_because_its_containing_generator_lacks_a_return_t_7057", "'yield' expression implicitly results in an 'any' type because its containing generator lacks a return-type annotation."),
        You_cannot_rename_this_element: diag(8e3, ts3.DiagnosticCategory.Error, "You_cannot_rename_this_element_8000", "You cannot rename this element."),
        You_cannot_rename_elements_that_are_defined_in_the_standard_TypeScript_library: diag(8001, ts3.DiagnosticCategory.Error, "You_cannot_rename_elements_that_are_defined_in_the_standard_TypeScript_library_8001", "You cannot rename elements that are defined in the standard TypeScript library."),
        import_can_only_be_used_in_TypeScript_files: diag(8002, ts3.DiagnosticCategory.Error, "import_can_only_be_used_in_TypeScript_files_8002", "'import ... =' can only be used in TypeScript files."),
        export_can_only_be_used_in_TypeScript_files: diag(8003, ts3.DiagnosticCategory.Error, "export_can_only_be_used_in_TypeScript_files_8003", "'export =' can only be used in TypeScript files."),
        Type_parameter_declarations_can_only_be_used_in_TypeScript_files: diag(8004, ts3.DiagnosticCategory.Error, "Type_parameter_declarations_can_only_be_used_in_TypeScript_files_8004", "Type parameter declarations can only be used in TypeScript files."),
        implements_clauses_can_only_be_used_in_TypeScript_files: diag(8005, ts3.DiagnosticCategory.Error, "implements_clauses_can_only_be_used_in_TypeScript_files_8005", "'implements' clauses can only be used in TypeScript files."),
        _0_declarations_can_only_be_used_in_TypeScript_files: diag(8006, ts3.DiagnosticCategory.Error, "_0_declarations_can_only_be_used_in_TypeScript_files_8006", "'{0}' declarations can only be used in TypeScript files."),
        Type_aliases_can_only_be_used_in_TypeScript_files: diag(8008, ts3.DiagnosticCategory.Error, "Type_aliases_can_only_be_used_in_TypeScript_files_8008", "Type aliases can only be used in TypeScript files."),
        The_0_modifier_can_only_be_used_in_TypeScript_files: diag(8009, ts3.DiagnosticCategory.Error, "The_0_modifier_can_only_be_used_in_TypeScript_files_8009", "The '{0}' modifier can only be used in TypeScript files."),
        Type_annotations_can_only_be_used_in_TypeScript_files: diag(8010, ts3.DiagnosticCategory.Error, "Type_annotations_can_only_be_used_in_TypeScript_files_8010", "Type annotations can only be used in TypeScript files."),
        Type_arguments_can_only_be_used_in_TypeScript_files: diag(8011, ts3.DiagnosticCategory.Error, "Type_arguments_can_only_be_used_in_TypeScript_files_8011", "Type arguments can only be used in TypeScript files."),
        Parameter_modifiers_can_only_be_used_in_TypeScript_files: diag(8012, ts3.DiagnosticCategory.Error, "Parameter_modifiers_can_only_be_used_in_TypeScript_files_8012", "Parameter modifiers can only be used in TypeScript files."),
        Non_null_assertions_can_only_be_used_in_TypeScript_files: diag(8013, ts3.DiagnosticCategory.Error, "Non_null_assertions_can_only_be_used_in_TypeScript_files_8013", "Non-null assertions can only be used in TypeScript files."),
        Type_assertion_expressions_can_only_be_used_in_TypeScript_files: diag(8016, ts3.DiagnosticCategory.Error, "Type_assertion_expressions_can_only_be_used_in_TypeScript_files_8016", "Type assertion expressions can only be used in TypeScript files."),
        Octal_literal_types_must_use_ES2015_syntax_Use_the_syntax_0: diag(8017, ts3.DiagnosticCategory.Error, "Octal_literal_types_must_use_ES2015_syntax_Use_the_syntax_0_8017", "Octal literal types must use ES2015 syntax. Use the syntax '{0}'."),
        Octal_literals_are_not_allowed_in_enums_members_initializer_Use_the_syntax_0: diag(8018, ts3.DiagnosticCategory.Error, "Octal_literals_are_not_allowed_in_enums_members_initializer_Use_the_syntax_0_8018", "Octal literals are not allowed in enums members initializer. Use the syntax '{0}'."),
        Report_errors_in_js_files: diag(8019, ts3.DiagnosticCategory.Message, "Report_errors_in_js_files_8019", "Report errors in .js files."),
        JSDoc_types_can_only_be_used_inside_documentation_comments: diag(8020, ts3.DiagnosticCategory.Error, "JSDoc_types_can_only_be_used_inside_documentation_comments_8020", "JSDoc types can only be used inside documentation comments."),
        JSDoc_typedef_tag_should_either_have_a_type_annotation_or_be_followed_by_property_or_member_tags: diag(8021, ts3.DiagnosticCategory.Error, "JSDoc_typedef_tag_should_either_have_a_type_annotation_or_be_followed_by_property_or_member_tags_8021", "JSDoc '@typedef' tag should either have a type annotation or be followed by '@property' or '@member' tags."),
        JSDoc_0_is_not_attached_to_a_class: diag(8022, ts3.DiagnosticCategory.Error, "JSDoc_0_is_not_attached_to_a_class_8022", "JSDoc '@{0}' is not attached to a class."),
        JSDoc_0_1_does_not_match_the_extends_2_clause: diag(8023, ts3.DiagnosticCategory.Error, "JSDoc_0_1_does_not_match_the_extends_2_clause_8023", "JSDoc '@{0} {1}' does not match the 'extends {2}' clause."),
        JSDoc_param_tag_has_name_0_but_there_is_no_parameter_with_that_name: diag(8024, ts3.DiagnosticCategory.Error, "JSDoc_param_tag_has_name_0_but_there_is_no_parameter_with_that_name_8024", "JSDoc '@param' tag has name '{0}', but there is no parameter with that name."),
        Class_declarations_cannot_have_more_than_one_augments_or_extends_tag: diag(8025, ts3.DiagnosticCategory.Error, "Class_declarations_cannot_have_more_than_one_augments_or_extends_tag_8025", "Class declarations cannot have more than one '@augments' or '@extends' tag."),
        Expected_0_type_arguments_provide_these_with_an_extends_tag: diag(8026, ts3.DiagnosticCategory.Error, "Expected_0_type_arguments_provide_these_with_an_extends_tag_8026", "Expected {0} type arguments; provide these with an '@extends' tag."),
        Expected_0_1_type_arguments_provide_these_with_an_extends_tag: diag(8027, ts3.DiagnosticCategory.Error, "Expected_0_1_type_arguments_provide_these_with_an_extends_tag_8027", "Expected {0}-{1} type arguments; provide these with an '@extends' tag."),
        JSDoc_may_only_appear_in_the_last_parameter_of_a_signature: diag(8028, ts3.DiagnosticCategory.Error, "JSDoc_may_only_appear_in_the_last_parameter_of_a_signature_8028", "JSDoc '...' may only appear in the last parameter of a signature."),
        JSDoc_param_tag_has_name_0_but_there_is_no_parameter_with_that_name_It_would_match_arguments_if_it_had_an_array_type: diag(8029, ts3.DiagnosticCategory.Error, "JSDoc_param_tag_has_name_0_but_there_is_no_parameter_with_that_name_It_would_match_arguments_if_it_h_8029", "JSDoc '@param' tag has name '{0}', but there is no parameter with that name. It would match 'arguments' if it had an array type."),
        The_type_of_a_function_declaration_must_match_the_function_s_signature: diag(8030, ts3.DiagnosticCategory.Error, "The_type_of_a_function_declaration_must_match_the_function_s_signature_8030", "The type of a function declaration must match the function's signature."),
        You_cannot_rename_a_module_via_a_global_import: diag(8031, ts3.DiagnosticCategory.Error, "You_cannot_rename_a_module_via_a_global_import_8031", "You cannot rename a module via a global import."),
        Qualified_name_0_is_not_allowed_without_a_leading_param_object_1: diag(8032, ts3.DiagnosticCategory.Error, "Qualified_name_0_is_not_allowed_without_a_leading_param_object_1_8032", "Qualified name '{0}' is not allowed without a leading '@param {object} {1}'."),
        A_JSDoc_typedef_comment_may_not_contain_multiple_type_tags: diag(8033, ts3.DiagnosticCategory.Error, "A_JSDoc_typedef_comment_may_not_contain_multiple_type_tags_8033", "A JSDoc '@typedef' comment may not contain multiple '@type' tags."),
        The_tag_was_first_specified_here: diag(8034, ts3.DiagnosticCategory.Error, "The_tag_was_first_specified_here_8034", "The tag was first specified here."),
        Only_identifiers_Slashqualified_names_with_optional_type_arguments_are_currently_supported_in_a_class_extends_clause: diag(9002, ts3.DiagnosticCategory.Error, "Only_identifiers_Slashqualified_names_with_optional_type_arguments_are_currently_supported_in_a_clas_9002", "Only identifiers/qualified-names with optional type arguments are currently supported in a class 'extends' clause."),
        class_expressions_are_not_currently_supported: diag(9003, ts3.DiagnosticCategory.Error, "class_expressions_are_not_currently_supported_9003", "'class' expressions are not currently supported."),
        Language_service_is_disabled: diag(9004, ts3.DiagnosticCategory.Error, "Language_service_is_disabled_9004", "Language service is disabled."),
        Declaration_emit_for_this_file_requires_using_private_name_0_An_explicit_type_annotation_may_unblock_declaration_emit: diag(9005, ts3.DiagnosticCategory.Error, "Declaration_emit_for_this_file_requires_using_private_name_0_An_explicit_type_annotation_may_unblock_9005", "Declaration emit for this file requires using private name '{0}'. An explicit type annotation may unblock declaration emit."),
        Declaration_emit_for_this_file_requires_using_private_name_0_from_module_1_An_explicit_type_annotation_may_unblock_declaration_emit: diag(9006, ts3.DiagnosticCategory.Error, "Declaration_emit_for_this_file_requires_using_private_name_0_from_module_1_An_explicit_type_annotati_9006", "Declaration emit for this file requires using private name '{0}' from module '{1}'. An explicit type annotation may unblock declaration emit."),
        JSX_attributes_must_only_be_assigned_a_non_empty_expression: diag(17e3, ts3.DiagnosticCategory.Error, "JSX_attributes_must_only_be_assigned_a_non_empty_expression_17000", "JSX attributes must only be assigned a non-empty 'expression'."),
        JSX_elements_cannot_have_multiple_attributes_with_the_same_name: diag(17001, ts3.DiagnosticCategory.Error, "JSX_elements_cannot_have_multiple_attributes_with_the_same_name_17001", "JSX elements cannot have multiple attributes with the same name."),
        Expected_corresponding_JSX_closing_tag_for_0: diag(17002, ts3.DiagnosticCategory.Error, "Expected_corresponding_JSX_closing_tag_for_0_17002", "Expected corresponding JSX closing tag for '{0}'."),
        JSX_attribute_expected: diag(17003, ts3.DiagnosticCategory.Error, "JSX_attribute_expected_17003", "JSX attribute expected."),
        Cannot_use_JSX_unless_the_jsx_flag_is_provided: diag(17004, ts3.DiagnosticCategory.Error, "Cannot_use_JSX_unless_the_jsx_flag_is_provided_17004", "Cannot use JSX unless the '--jsx' flag is provided."),
        A_constructor_cannot_contain_a_super_call_when_its_class_extends_null: diag(17005, ts3.DiagnosticCategory.Error, "A_constructor_cannot_contain_a_super_call_when_its_class_extends_null_17005", "A constructor cannot contain a 'super' call when its class extends 'null'."),
        An_unary_expression_with_the_0_operator_is_not_allowed_in_the_left_hand_side_of_an_exponentiation_expression_Consider_enclosing_the_expression_in_parentheses: diag(17006, ts3.DiagnosticCategory.Error, "An_unary_expression_with_the_0_operator_is_not_allowed_in_the_left_hand_side_of_an_exponentiation_ex_17006", "An unary expression with the '{0}' operator is not allowed in the left-hand side of an exponentiation expression. Consider enclosing the expression in parentheses."),
        A_type_assertion_expression_is_not_allowed_in_the_left_hand_side_of_an_exponentiation_expression_Consider_enclosing_the_expression_in_parentheses: diag(17007, ts3.DiagnosticCategory.Error, "A_type_assertion_expression_is_not_allowed_in_the_left_hand_side_of_an_exponentiation_expression_Con_17007", "A type assertion expression is not allowed in the left-hand side of an exponentiation expression. Consider enclosing the expression in parentheses."),
        JSX_element_0_has_no_corresponding_closing_tag: diag(17008, ts3.DiagnosticCategory.Error, "JSX_element_0_has_no_corresponding_closing_tag_17008", "JSX element '{0}' has no corresponding closing tag."),
        super_must_be_called_before_accessing_this_in_the_constructor_of_a_derived_class: diag(17009, ts3.DiagnosticCategory.Error, "super_must_be_called_before_accessing_this_in_the_constructor_of_a_derived_class_17009", "'super' must be called before accessing 'this' in the constructor of a derived class."),
        Unknown_type_acquisition_option_0: diag(17010, ts3.DiagnosticCategory.Error, "Unknown_type_acquisition_option_0_17010", "Unknown type acquisition option '{0}'."),
        super_must_be_called_before_accessing_a_property_of_super_in_the_constructor_of_a_derived_class: diag(17011, ts3.DiagnosticCategory.Error, "super_must_be_called_before_accessing_a_property_of_super_in_the_constructor_of_a_derived_class_17011", "'super' must be called before accessing a property of 'super' in the constructor of a derived class."),
        _0_is_not_a_valid_meta_property_for_keyword_1_Did_you_mean_2: diag(17012, ts3.DiagnosticCategory.Error, "_0_is_not_a_valid_meta_property_for_keyword_1_Did_you_mean_2_17012", "'{0}' is not a valid meta-property for keyword '{1}'. Did you mean '{2}'?"),
        Meta_property_0_is_only_allowed_in_the_body_of_a_function_declaration_function_expression_or_constructor: diag(17013, ts3.DiagnosticCategory.Error, "Meta_property_0_is_only_allowed_in_the_body_of_a_function_declaration_function_expression_or_constru_17013", "Meta-property '{0}' is only allowed in the body of a function declaration, function expression, or constructor."),
        JSX_fragment_has_no_corresponding_closing_tag: diag(17014, ts3.DiagnosticCategory.Error, "JSX_fragment_has_no_corresponding_closing_tag_17014", "JSX fragment has no corresponding closing tag."),
        Expected_corresponding_closing_tag_for_JSX_fragment: diag(17015, ts3.DiagnosticCategory.Error, "Expected_corresponding_closing_tag_for_JSX_fragment_17015", "Expected corresponding closing tag for JSX fragment."),
        The_jsxFragmentFactory_compiler_option_must_be_provided_to_use_JSX_fragments_with_the_jsxFactory_compiler_option: diag(17016, ts3.DiagnosticCategory.Error, "The_jsxFragmentFactory_compiler_option_must_be_provided_to_use_JSX_fragments_with_the_jsxFactory_com_17016", "The 'jsxFragmentFactory' compiler option must be provided to use JSX fragments with the 'jsxFactory' compiler option."),
        An_jsxFrag_pragma_is_required_when_using_an_jsx_pragma_with_JSX_fragments: diag(17017, ts3.DiagnosticCategory.Error, "An_jsxFrag_pragma_is_required_when_using_an_jsx_pragma_with_JSX_fragments_17017", "An @jsxFrag pragma is required when using an @jsx pragma with JSX fragments."),
        Unknown_type_acquisition_option_0_Did_you_mean_1: diag(17018, ts3.DiagnosticCategory.Error, "Unknown_type_acquisition_option_0_Did_you_mean_1_17018", "Unknown type acquisition option '{0}'. Did you mean '{1}'?"),
        Circularity_detected_while_resolving_configuration_Colon_0: diag(18e3, ts3.DiagnosticCategory.Error, "Circularity_detected_while_resolving_configuration_Colon_0_18000", "Circularity detected while resolving configuration: {0}"),
        A_path_in_an_extends_option_must_be_relative_or_rooted_but_0_is_not: diag(18001, ts3.DiagnosticCategory.Error, "A_path_in_an_extends_option_must_be_relative_or_rooted_but_0_is_not_18001", "A path in an 'extends' option must be relative or rooted, but '{0}' is not."),
        The_files_list_in_config_file_0_is_empty: diag(18002, ts3.DiagnosticCategory.Error, "The_files_list_in_config_file_0_is_empty_18002", "The 'files' list in config file '{0}' is empty."),
        No_inputs_were_found_in_config_file_0_Specified_include_paths_were_1_and_exclude_paths_were_2: diag(18003, ts3.DiagnosticCategory.Error, "No_inputs_were_found_in_config_file_0_Specified_include_paths_were_1_and_exclude_paths_were_2_18003", "No inputs were found in config file '{0}'. Specified 'include' paths were '{1}' and 'exclude' paths were '{2}'."),
        File_is_a_CommonJS_module_it_may_be_converted_to_an_ES6_module: diag(80001, ts3.DiagnosticCategory.Suggestion, "File_is_a_CommonJS_module_it_may_be_converted_to_an_ES6_module_80001", "File is a CommonJS module; it may be converted to an ES6 module."),
        This_constructor_function_may_be_converted_to_a_class_declaration: diag(80002, ts3.DiagnosticCategory.Suggestion, "This_constructor_function_may_be_converted_to_a_class_declaration_80002", "This constructor function may be converted to a class declaration."),
        Import_may_be_converted_to_a_default_import: diag(80003, ts3.DiagnosticCategory.Suggestion, "Import_may_be_converted_to_a_default_import_80003", "Import may be converted to a default import."),
        JSDoc_types_may_be_moved_to_TypeScript_types: diag(80004, ts3.DiagnosticCategory.Suggestion, "JSDoc_types_may_be_moved_to_TypeScript_types_80004", "JSDoc types may be moved to TypeScript types."),
        require_call_may_be_converted_to_an_import: diag(80005, ts3.DiagnosticCategory.Suggestion, "require_call_may_be_converted_to_an_import_80005", "'require' call may be converted to an import."),
        This_may_be_converted_to_an_async_function: diag(80006, ts3.DiagnosticCategory.Suggestion, "This_may_be_converted_to_an_async_function_80006", "This may be converted to an async function."),
        await_has_no_effect_on_the_type_of_this_expression: diag(80007, ts3.DiagnosticCategory.Suggestion, "await_has_no_effect_on_the_type_of_this_expression_80007", "'await' has no effect on the type of this expression."),
        Numeric_literals_with_absolute_values_equal_to_2_53_or_greater_are_too_large_to_be_represented_accurately_as_integers: diag(80008, ts3.DiagnosticCategory.Suggestion, "Numeric_literals_with_absolute_values_equal_to_2_53_or_greater_are_too_large_to_be_represented_accur_80008", "Numeric literals with absolute values equal to 2^53 or greater are too large to be represented accurately as integers."),
        Add_missing_super_call: diag(90001, ts3.DiagnosticCategory.Message, "Add_missing_super_call_90001", "Add missing 'super()' call"),
        Make_super_call_the_first_statement_in_the_constructor: diag(90002, ts3.DiagnosticCategory.Message, "Make_super_call_the_first_statement_in_the_constructor_90002", "Make 'super()' call the first statement in the constructor"),
        Change_extends_to_implements: diag(90003, ts3.DiagnosticCategory.Message, "Change_extends_to_implements_90003", "Change 'extends' to 'implements'"),
        Remove_unused_declaration_for_Colon_0: diag(90004, ts3.DiagnosticCategory.Message, "Remove_unused_declaration_for_Colon_0_90004", "Remove unused declaration for: '{0}'"),
        Remove_import_from_0: diag(90005, ts3.DiagnosticCategory.Message, "Remove_import_from_0_90005", "Remove import from '{0}'"),
        Implement_interface_0: diag(90006, ts3.DiagnosticCategory.Message, "Implement_interface_0_90006", "Implement interface '{0}'"),
        Implement_inherited_abstract_class: diag(90007, ts3.DiagnosticCategory.Message, "Implement_inherited_abstract_class_90007", "Implement inherited abstract class"),
        Add_0_to_unresolved_variable: diag(90008, ts3.DiagnosticCategory.Message, "Add_0_to_unresolved_variable_90008", "Add '{0}.' to unresolved variable"),
        Remove_variable_statement: diag(90010, ts3.DiagnosticCategory.Message, "Remove_variable_statement_90010", "Remove variable statement"),
        Remove_template_tag: diag(90011, ts3.DiagnosticCategory.Message, "Remove_template_tag_90011", "Remove template tag"),
        Remove_type_parameters: diag(90012, ts3.DiagnosticCategory.Message, "Remove_type_parameters_90012", "Remove type parameters"),
        Import_0_from_module_1: diag(90013, ts3.DiagnosticCategory.Message, "Import_0_from_module_1_90013", `Import '{0}' from module "{1}"`),
        Change_0_to_1: diag(90014, ts3.DiagnosticCategory.Message, "Change_0_to_1_90014", "Change '{0}' to '{1}'"),
        Add_0_to_existing_import_declaration_from_1: diag(90015, ts3.DiagnosticCategory.Message, "Add_0_to_existing_import_declaration_from_1_90015", `Add '{0}' to existing import declaration from "{1}"`),
        Declare_property_0: diag(90016, ts3.DiagnosticCategory.Message, "Declare_property_0_90016", "Declare property '{0}'"),
        Add_index_signature_for_property_0: diag(90017, ts3.DiagnosticCategory.Message, "Add_index_signature_for_property_0_90017", "Add index signature for property '{0}'"),
        Disable_checking_for_this_file: diag(90018, ts3.DiagnosticCategory.Message, "Disable_checking_for_this_file_90018", "Disable checking for this file"),
        Ignore_this_error_message: diag(90019, ts3.DiagnosticCategory.Message, "Ignore_this_error_message_90019", "Ignore this error message"),
        Initialize_property_0_in_the_constructor: diag(90020, ts3.DiagnosticCategory.Message, "Initialize_property_0_in_the_constructor_90020", "Initialize property '{0}' in the constructor"),
        Initialize_static_property_0: diag(90021, ts3.DiagnosticCategory.Message, "Initialize_static_property_0_90021", "Initialize static property '{0}'"),
        Change_spelling_to_0: diag(90022, ts3.DiagnosticCategory.Message, "Change_spelling_to_0_90022", "Change spelling to '{0}'"),
        Declare_method_0: diag(90023, ts3.DiagnosticCategory.Message, "Declare_method_0_90023", "Declare method '{0}'"),
        Declare_static_method_0: diag(90024, ts3.DiagnosticCategory.Message, "Declare_static_method_0_90024", "Declare static method '{0}'"),
        Prefix_0_with_an_underscore: diag(90025, ts3.DiagnosticCategory.Message, "Prefix_0_with_an_underscore_90025", "Prefix '{0}' with an underscore"),
        Rewrite_as_the_indexed_access_type_0: diag(90026, ts3.DiagnosticCategory.Message, "Rewrite_as_the_indexed_access_type_0_90026", "Rewrite as the indexed access type '{0}'"),
        Declare_static_property_0: diag(90027, ts3.DiagnosticCategory.Message, "Declare_static_property_0_90027", "Declare static property '{0}'"),
        Call_decorator_expression: diag(90028, ts3.DiagnosticCategory.Message, "Call_decorator_expression_90028", "Call decorator expression"),
        Add_async_modifier_to_containing_function: diag(90029, ts3.DiagnosticCategory.Message, "Add_async_modifier_to_containing_function_90029", "Add async modifier to containing function"),
        Replace_infer_0_with_unknown: diag(90030, ts3.DiagnosticCategory.Message, "Replace_infer_0_with_unknown_90030", "Replace 'infer {0}' with 'unknown'"),
        Replace_all_unused_infer_with_unknown: diag(90031, ts3.DiagnosticCategory.Message, "Replace_all_unused_infer_with_unknown_90031", "Replace all unused 'infer' with 'unknown'"),
        Import_default_0_from_module_1: diag(90032, ts3.DiagnosticCategory.Message, "Import_default_0_from_module_1_90032", `Import default '{0}' from module "{1}"`),
        Add_default_import_0_to_existing_import_declaration_from_1: diag(90033, ts3.DiagnosticCategory.Message, "Add_default_import_0_to_existing_import_declaration_from_1_90033", `Add default import '{0}' to existing import declaration from "{1}"`),
        Add_parameter_name: diag(90034, ts3.DiagnosticCategory.Message, "Add_parameter_name_90034", "Add parameter name"),
        Declare_private_property_0: diag(90035, ts3.DiagnosticCategory.Message, "Declare_private_property_0_90035", "Declare private property '{0}'"),
        Replace_0_with_Promise_1: diag(90036, ts3.DiagnosticCategory.Message, "Replace_0_with_Promise_1_90036", "Replace '{0}' with 'Promise<{1}>'"),
        Fix_all_incorrect_return_type_of_an_async_functions: diag(90037, ts3.DiagnosticCategory.Message, "Fix_all_incorrect_return_type_of_an_async_functions_90037", "Fix all incorrect return type of an async functions"),
        Declare_private_method_0: diag(90038, ts3.DiagnosticCategory.Message, "Declare_private_method_0_90038", "Declare private method '{0}'"),
        Remove_unused_destructuring_declaration: diag(90039, ts3.DiagnosticCategory.Message, "Remove_unused_destructuring_declaration_90039", "Remove unused destructuring declaration"),
        Remove_unused_declarations_for_Colon_0: diag(90041, ts3.DiagnosticCategory.Message, "Remove_unused_declarations_for_Colon_0_90041", "Remove unused declarations for: '{0}'"),
        Declare_a_private_field_named_0: diag(90053, ts3.DiagnosticCategory.Message, "Declare_a_private_field_named_0_90053", "Declare a private field named '{0}'."),
        Convert_function_to_an_ES2015_class: diag(95001, ts3.DiagnosticCategory.Message, "Convert_function_to_an_ES2015_class_95001", "Convert function to an ES2015 class"),
        Convert_function_0_to_class: diag(95002, ts3.DiagnosticCategory.Message, "Convert_function_0_to_class_95002", "Convert function '{0}' to class"),
        Convert_0_to_1_in_0: diag(95003, ts3.DiagnosticCategory.Message, "Convert_0_to_1_in_0_95003", "Convert '{0}' to '{1} in {0}'"),
        Extract_to_0_in_1: diag(95004, ts3.DiagnosticCategory.Message, "Extract_to_0_in_1_95004", "Extract to {0} in {1}"),
        Extract_function: diag(95005, ts3.DiagnosticCategory.Message, "Extract_function_95005", "Extract function"),
        Extract_constant: diag(95006, ts3.DiagnosticCategory.Message, "Extract_constant_95006", "Extract constant"),
        Extract_to_0_in_enclosing_scope: diag(95007, ts3.DiagnosticCategory.Message, "Extract_to_0_in_enclosing_scope_95007", "Extract to {0} in enclosing scope"),
        Extract_to_0_in_1_scope: diag(95008, ts3.DiagnosticCategory.Message, "Extract_to_0_in_1_scope_95008", "Extract to {0} in {1} scope"),
        Annotate_with_type_from_JSDoc: diag(95009, ts3.DiagnosticCategory.Message, "Annotate_with_type_from_JSDoc_95009", "Annotate with type from JSDoc"),
        Annotate_with_types_from_JSDoc: diag(95010, ts3.DiagnosticCategory.Message, "Annotate_with_types_from_JSDoc_95010", "Annotate with types from JSDoc"),
        Infer_type_of_0_from_usage: diag(95011, ts3.DiagnosticCategory.Message, "Infer_type_of_0_from_usage_95011", "Infer type of '{0}' from usage"),
        Infer_parameter_types_from_usage: diag(95012, ts3.DiagnosticCategory.Message, "Infer_parameter_types_from_usage_95012", "Infer parameter types from usage"),
        Convert_to_default_import: diag(95013, ts3.DiagnosticCategory.Message, "Convert_to_default_import_95013", "Convert to default import"),
        Install_0: diag(95014, ts3.DiagnosticCategory.Message, "Install_0_95014", "Install '{0}'"),
        Replace_import_with_0: diag(95015, ts3.DiagnosticCategory.Message, "Replace_import_with_0_95015", "Replace import with '{0}'."),
        Use_synthetic_default_member: diag(95016, ts3.DiagnosticCategory.Message, "Use_synthetic_default_member_95016", "Use synthetic 'default' member."),
        Convert_to_ES6_module: diag(95017, ts3.DiagnosticCategory.Message, "Convert_to_ES6_module_95017", "Convert to ES6 module"),
        Add_undefined_type_to_property_0: diag(95018, ts3.DiagnosticCategory.Message, "Add_undefined_type_to_property_0_95018", "Add 'undefined' type to property '{0}'"),
        Add_initializer_to_property_0: diag(95019, ts3.DiagnosticCategory.Message, "Add_initializer_to_property_0_95019", "Add initializer to property '{0}'"),
        Add_definite_assignment_assertion_to_property_0: diag(95020, ts3.DiagnosticCategory.Message, "Add_definite_assignment_assertion_to_property_0_95020", "Add definite assignment assertion to property '{0}'"),
        Convert_all_type_literals_to_mapped_type: diag(95021, ts3.DiagnosticCategory.Message, "Convert_all_type_literals_to_mapped_type_95021", "Convert all type literals to mapped type"),
        Add_all_missing_members: diag(95022, ts3.DiagnosticCategory.Message, "Add_all_missing_members_95022", "Add all missing members"),
        Infer_all_types_from_usage: diag(95023, ts3.DiagnosticCategory.Message, "Infer_all_types_from_usage_95023", "Infer all types from usage"),
        Delete_all_unused_declarations: diag(95024, ts3.DiagnosticCategory.Message, "Delete_all_unused_declarations_95024", "Delete all unused declarations"),
        Prefix_all_unused_declarations_with_where_possible: diag(95025, ts3.DiagnosticCategory.Message, "Prefix_all_unused_declarations_with_where_possible_95025", "Prefix all unused declarations with '_' where possible"),
        Fix_all_detected_spelling_errors: diag(95026, ts3.DiagnosticCategory.Message, "Fix_all_detected_spelling_errors_95026", "Fix all detected spelling errors"),
        Add_initializers_to_all_uninitialized_properties: diag(95027, ts3.DiagnosticCategory.Message, "Add_initializers_to_all_uninitialized_properties_95027", "Add initializers to all uninitialized properties"),
        Add_definite_assignment_assertions_to_all_uninitialized_properties: diag(95028, ts3.DiagnosticCategory.Message, "Add_definite_assignment_assertions_to_all_uninitialized_properties_95028", "Add definite assignment assertions to all uninitialized properties"),
        Add_undefined_type_to_all_uninitialized_properties: diag(95029, ts3.DiagnosticCategory.Message, "Add_undefined_type_to_all_uninitialized_properties_95029", "Add undefined type to all uninitialized properties"),
        Change_all_jsdoc_style_types_to_TypeScript: diag(95030, ts3.DiagnosticCategory.Message, "Change_all_jsdoc_style_types_to_TypeScript_95030", "Change all jsdoc-style types to TypeScript"),
        Change_all_jsdoc_style_types_to_TypeScript_and_add_undefined_to_nullable_types: diag(95031, ts3.DiagnosticCategory.Message, "Change_all_jsdoc_style_types_to_TypeScript_and_add_undefined_to_nullable_types_95031", "Change all jsdoc-style types to TypeScript (and add '| undefined' to nullable types)"),
        Implement_all_unimplemented_interfaces: diag(95032, ts3.DiagnosticCategory.Message, "Implement_all_unimplemented_interfaces_95032", "Implement all unimplemented interfaces"),
        Install_all_missing_types_packages: diag(95033, ts3.DiagnosticCategory.Message, "Install_all_missing_types_packages_95033", "Install all missing types packages"),
        Rewrite_all_as_indexed_access_types: diag(95034, ts3.DiagnosticCategory.Message, "Rewrite_all_as_indexed_access_types_95034", "Rewrite all as indexed access types"),
        Convert_all_to_default_imports: diag(95035, ts3.DiagnosticCategory.Message, "Convert_all_to_default_imports_95035", "Convert all to default imports"),
        Make_all_super_calls_the_first_statement_in_their_constructor: diag(95036, ts3.DiagnosticCategory.Message, "Make_all_super_calls_the_first_statement_in_their_constructor_95036", "Make all 'super()' calls the first statement in their constructor"),
        Add_qualifier_to_all_unresolved_variables_matching_a_member_name: diag(95037, ts3.DiagnosticCategory.Message, "Add_qualifier_to_all_unresolved_variables_matching_a_member_name_95037", "Add qualifier to all unresolved variables matching a member name"),
        Change_all_extended_interfaces_to_implements: diag(95038, ts3.DiagnosticCategory.Message, "Change_all_extended_interfaces_to_implements_95038", "Change all extended interfaces to 'implements'"),
        Add_all_missing_super_calls: diag(95039, ts3.DiagnosticCategory.Message, "Add_all_missing_super_calls_95039", "Add all missing super calls"),
        Implement_all_inherited_abstract_classes: diag(95040, ts3.DiagnosticCategory.Message, "Implement_all_inherited_abstract_classes_95040", "Implement all inherited abstract classes"),
        Add_all_missing_async_modifiers: diag(95041, ts3.DiagnosticCategory.Message, "Add_all_missing_async_modifiers_95041", "Add all missing 'async' modifiers"),
        Add_ts_ignore_to_all_error_messages: diag(95042, ts3.DiagnosticCategory.Message, "Add_ts_ignore_to_all_error_messages_95042", "Add '@ts-ignore' to all error messages"),
        Annotate_everything_with_types_from_JSDoc: diag(95043, ts3.DiagnosticCategory.Message, "Annotate_everything_with_types_from_JSDoc_95043", "Annotate everything with types from JSDoc"),
        Add_to_all_uncalled_decorators: diag(95044, ts3.DiagnosticCategory.Message, "Add_to_all_uncalled_decorators_95044", "Add '()' to all uncalled decorators"),
        Convert_all_constructor_functions_to_classes: diag(95045, ts3.DiagnosticCategory.Message, "Convert_all_constructor_functions_to_classes_95045", "Convert all constructor functions to classes"),
        Generate_get_and_set_accessors: diag(95046, ts3.DiagnosticCategory.Message, "Generate_get_and_set_accessors_95046", "Generate 'get' and 'set' accessors"),
        Convert_require_to_import: diag(95047, ts3.DiagnosticCategory.Message, "Convert_require_to_import_95047", "Convert 'require' to 'import'"),
        Convert_all_require_to_import: diag(95048, ts3.DiagnosticCategory.Message, "Convert_all_require_to_import_95048", "Convert all 'require' to 'import'"),
        Move_to_a_new_file: diag(95049, ts3.DiagnosticCategory.Message, "Move_to_a_new_file_95049", "Move to a new file"),
        Remove_unreachable_code: diag(95050, ts3.DiagnosticCategory.Message, "Remove_unreachable_code_95050", "Remove unreachable code"),
        Remove_all_unreachable_code: diag(95051, ts3.DiagnosticCategory.Message, "Remove_all_unreachable_code_95051", "Remove all unreachable code"),
        Add_missing_typeof: diag(95052, ts3.DiagnosticCategory.Message, "Add_missing_typeof_95052", "Add missing 'typeof'"),
        Remove_unused_label: diag(95053, ts3.DiagnosticCategory.Message, "Remove_unused_label_95053", "Remove unused label"),
        Remove_all_unused_labels: diag(95054, ts3.DiagnosticCategory.Message, "Remove_all_unused_labels_95054", "Remove all unused labels"),
        Convert_0_to_mapped_object_type: diag(95055, ts3.DiagnosticCategory.Message, "Convert_0_to_mapped_object_type_95055", "Convert '{0}' to mapped object type"),
        Convert_namespace_import_to_named_imports: diag(95056, ts3.DiagnosticCategory.Message, "Convert_namespace_import_to_named_imports_95056", "Convert namespace import to named imports"),
        Convert_named_imports_to_namespace_import: diag(95057, ts3.DiagnosticCategory.Message, "Convert_named_imports_to_namespace_import_95057", "Convert named imports to namespace import"),
        Add_or_remove_braces_in_an_arrow_function: diag(95058, ts3.DiagnosticCategory.Message, "Add_or_remove_braces_in_an_arrow_function_95058", "Add or remove braces in an arrow function"),
        Add_braces_to_arrow_function: diag(95059, ts3.DiagnosticCategory.Message, "Add_braces_to_arrow_function_95059", "Add braces to arrow function"),
        Remove_braces_from_arrow_function: diag(95060, ts3.DiagnosticCategory.Message, "Remove_braces_from_arrow_function_95060", "Remove braces from arrow function"),
        Convert_default_export_to_named_export: diag(95061, ts3.DiagnosticCategory.Message, "Convert_default_export_to_named_export_95061", "Convert default export to named export"),
        Convert_named_export_to_default_export: diag(95062, ts3.DiagnosticCategory.Message, "Convert_named_export_to_default_export_95062", "Convert named export to default export"),
        Add_missing_enum_member_0: diag(95063, ts3.DiagnosticCategory.Message, "Add_missing_enum_member_0_95063", "Add missing enum member '{0}'"),
        Add_all_missing_imports: diag(95064, ts3.DiagnosticCategory.Message, "Add_all_missing_imports_95064", "Add all missing imports"),
        Convert_to_async_function: diag(95065, ts3.DiagnosticCategory.Message, "Convert_to_async_function_95065", "Convert to async function"),
        Convert_all_to_async_functions: diag(95066, ts3.DiagnosticCategory.Message, "Convert_all_to_async_functions_95066", "Convert all to async functions"),
        Add_missing_call_parentheses: diag(95067, ts3.DiagnosticCategory.Message, "Add_missing_call_parentheses_95067", "Add missing call parentheses"),
        Add_all_missing_call_parentheses: diag(95068, ts3.DiagnosticCategory.Message, "Add_all_missing_call_parentheses_95068", "Add all missing call parentheses"),
        Add_unknown_conversion_for_non_overlapping_types: diag(95069, ts3.DiagnosticCategory.Message, "Add_unknown_conversion_for_non_overlapping_types_95069", "Add 'unknown' conversion for non-overlapping types"),
        Add_unknown_to_all_conversions_of_non_overlapping_types: diag(95070, ts3.DiagnosticCategory.Message, "Add_unknown_to_all_conversions_of_non_overlapping_types_95070", "Add 'unknown' to all conversions of non-overlapping types"),
        Add_missing_new_operator_to_call: diag(95071, ts3.DiagnosticCategory.Message, "Add_missing_new_operator_to_call_95071", "Add missing 'new' operator to call"),
        Add_missing_new_operator_to_all_calls: diag(95072, ts3.DiagnosticCategory.Message, "Add_missing_new_operator_to_all_calls_95072", "Add missing 'new' operator to all calls"),
        Add_names_to_all_parameters_without_names: diag(95073, ts3.DiagnosticCategory.Message, "Add_names_to_all_parameters_without_names_95073", "Add names to all parameters without names"),
        Enable_the_experimentalDecorators_option_in_your_configuration_file: diag(95074, ts3.DiagnosticCategory.Message, "Enable_the_experimentalDecorators_option_in_your_configuration_file_95074", "Enable the 'experimentalDecorators' option in your configuration file"),
        Convert_parameters_to_destructured_object: diag(95075, ts3.DiagnosticCategory.Message, "Convert_parameters_to_destructured_object_95075", "Convert parameters to destructured object"),
        Allow_accessing_UMD_globals_from_modules: diag(95076, ts3.DiagnosticCategory.Message, "Allow_accessing_UMD_globals_from_modules_95076", "Allow accessing UMD globals from modules."),
        Extract_type: diag(95077, ts3.DiagnosticCategory.Message, "Extract_type_95077", "Extract type"),
        Extract_to_type_alias: diag(95078, ts3.DiagnosticCategory.Message, "Extract_to_type_alias_95078", "Extract to type alias"),
        Extract_to_typedef: diag(95079, ts3.DiagnosticCategory.Message, "Extract_to_typedef_95079", "Extract to typedef"),
        Infer_this_type_of_0_from_usage: diag(95080, ts3.DiagnosticCategory.Message, "Infer_this_type_of_0_from_usage_95080", "Infer 'this' type of '{0}' from usage"),
        Add_const_to_unresolved_variable: diag(95081, ts3.DiagnosticCategory.Message, "Add_const_to_unresolved_variable_95081", "Add 'const' to unresolved variable"),
        Add_const_to_all_unresolved_variables: diag(95082, ts3.DiagnosticCategory.Message, "Add_const_to_all_unresolved_variables_95082", "Add 'const' to all unresolved variables"),
        Add_await: diag(95083, ts3.DiagnosticCategory.Message, "Add_await_95083", "Add 'await'"),
        Add_await_to_initializer_for_0: diag(95084, ts3.DiagnosticCategory.Message, "Add_await_to_initializer_for_0_95084", "Add 'await' to initializer for '{0}'"),
        Fix_all_expressions_possibly_missing_await: diag(95085, ts3.DiagnosticCategory.Message, "Fix_all_expressions_possibly_missing_await_95085", "Fix all expressions possibly missing 'await'"),
        Remove_unnecessary_await: diag(95086, ts3.DiagnosticCategory.Message, "Remove_unnecessary_await_95086", "Remove unnecessary 'await'"),
        Remove_all_unnecessary_uses_of_await: diag(95087, ts3.DiagnosticCategory.Message, "Remove_all_unnecessary_uses_of_await_95087", "Remove all unnecessary uses of 'await'"),
        Enable_the_jsx_flag_in_your_configuration_file: diag(95088, ts3.DiagnosticCategory.Message, "Enable_the_jsx_flag_in_your_configuration_file_95088", "Enable the '--jsx' flag in your configuration file"),
        Add_await_to_initializers: diag(95089, ts3.DiagnosticCategory.Message, "Add_await_to_initializers_95089", "Add 'await' to initializers"),
        Extract_to_interface: diag(95090, ts3.DiagnosticCategory.Message, "Extract_to_interface_95090", "Extract to interface"),
        Convert_to_a_bigint_numeric_literal: diag(95091, ts3.DiagnosticCategory.Message, "Convert_to_a_bigint_numeric_literal_95091", "Convert to a bigint numeric literal"),
        Convert_all_to_bigint_numeric_literals: diag(95092, ts3.DiagnosticCategory.Message, "Convert_all_to_bigint_numeric_literals_95092", "Convert all to bigint numeric literals"),
        Convert_const_to_let: diag(95093, ts3.DiagnosticCategory.Message, "Convert_const_to_let_95093", "Convert 'const' to 'let'"),
        Prefix_with_declare: diag(95094, ts3.DiagnosticCategory.Message, "Prefix_with_declare_95094", "Prefix with 'declare'"),
        Prefix_all_incorrect_property_declarations_with_declare: diag(95095, ts3.DiagnosticCategory.Message, "Prefix_all_incorrect_property_declarations_with_declare_95095", "Prefix all incorrect property declarations with 'declare'"),
        Convert_to_template_string: diag(95096, ts3.DiagnosticCategory.Message, "Convert_to_template_string_95096", "Convert to template string"),
        Add_export_to_make_this_file_into_a_module: diag(95097, ts3.DiagnosticCategory.Message, "Add_export_to_make_this_file_into_a_module_95097", "Add 'export {}' to make this file into a module"),
        Set_the_target_option_in_your_configuration_file_to_0: diag(95098, ts3.DiagnosticCategory.Message, "Set_the_target_option_in_your_configuration_file_to_0_95098", "Set the 'target' option in your configuration file to '{0}'"),
        Set_the_module_option_in_your_configuration_file_to_0: diag(95099, ts3.DiagnosticCategory.Message, "Set_the_module_option_in_your_configuration_file_to_0_95099", "Set the 'module' option in your configuration file to '{0}'"),
        Convert_invalid_character_to_its_html_entity_code: diag(95100, ts3.DiagnosticCategory.Message, "Convert_invalid_character_to_its_html_entity_code_95100", "Convert invalid character to its html entity code"),
        Convert_all_invalid_characters_to_HTML_entity_code: diag(95101, ts3.DiagnosticCategory.Message, "Convert_all_invalid_characters_to_HTML_entity_code_95101", "Convert all invalid characters to HTML entity code"),
        Add_class_tag: diag(95102, ts3.DiagnosticCategory.Message, "Add_class_tag_95102", "Add '@class' tag"),
        Add_this_tag: diag(95103, ts3.DiagnosticCategory.Message, "Add_this_tag_95103", "Add '@this' tag"),
        Add_this_parameter: diag(95104, ts3.DiagnosticCategory.Message, "Add_this_parameter_95104", "Add 'this' parameter."),
        Convert_function_expression_0_to_arrow_function: diag(95105, ts3.DiagnosticCategory.Message, "Convert_function_expression_0_to_arrow_function_95105", "Convert function expression '{0}' to arrow function"),
        Convert_function_declaration_0_to_arrow_function: diag(95106, ts3.DiagnosticCategory.Message, "Convert_function_declaration_0_to_arrow_function_95106", "Convert function declaration '{0}' to arrow function"),
        Fix_all_implicit_this_errors: diag(95107, ts3.DiagnosticCategory.Message, "Fix_all_implicit_this_errors_95107", "Fix all implicit-'this' errors"),
        Wrap_invalid_character_in_an_expression_container: diag(95108, ts3.DiagnosticCategory.Message, "Wrap_invalid_character_in_an_expression_container_95108", "Wrap invalid character in an expression container"),
        Wrap_all_invalid_characters_in_an_expression_container: diag(95109, ts3.DiagnosticCategory.Message, "Wrap_all_invalid_characters_in_an_expression_container_95109", "Wrap all invalid characters in an expression container"),
        Visit_https_Colon_Slash_Slashaka_ms_Slashtsconfig_json_to_read_more_about_this_file: diag(95110, ts3.DiagnosticCategory.Message, "Visit_https_Colon_Slash_Slashaka_ms_Slashtsconfig_json_to_read_more_about_this_file_95110", "Visit https://aka.ms/tsconfig.json to read more about this file"),
        Add_a_return_statement: diag(95111, ts3.DiagnosticCategory.Message, "Add_a_return_statement_95111", "Add a return statement"),
        Remove_braces_from_arrow_function_body: diag(95112, ts3.DiagnosticCategory.Message, "Remove_braces_from_arrow_function_body_95112", "Remove braces from arrow function body"),
        Wrap_the_following_body_with_parentheses_which_should_be_an_object_literal: diag(95113, ts3.DiagnosticCategory.Message, "Wrap_the_following_body_with_parentheses_which_should_be_an_object_literal_95113", "Wrap the following body with parentheses which should be an object literal"),
        Add_all_missing_return_statement: diag(95114, ts3.DiagnosticCategory.Message, "Add_all_missing_return_statement_95114", "Add all missing return statement"),
        Remove_braces_from_all_arrow_function_bodies_with_relevant_issues: diag(95115, ts3.DiagnosticCategory.Message, "Remove_braces_from_all_arrow_function_bodies_with_relevant_issues_95115", "Remove braces from all arrow function bodies with relevant issues"),
        Wrap_all_object_literal_with_parentheses: diag(95116, ts3.DiagnosticCategory.Message, "Wrap_all_object_literal_with_parentheses_95116", "Wrap all object literal with parentheses"),
        Move_labeled_tuple_element_modifiers_to_labels: diag(95117, ts3.DiagnosticCategory.Message, "Move_labeled_tuple_element_modifiers_to_labels_95117", "Move labeled tuple element modifiers to labels"),
        Convert_overload_list_to_single_signature: diag(95118, ts3.DiagnosticCategory.Message, "Convert_overload_list_to_single_signature_95118", "Convert overload list to single signature"),
        Generate_get_and_set_accessors_for_all_overriding_properties: diag(95119, ts3.DiagnosticCategory.Message, "Generate_get_and_set_accessors_for_all_overriding_properties_95119", "Generate 'get' and 'set' accessors for all overriding properties"),
        Wrap_in_JSX_fragment: diag(95120, ts3.DiagnosticCategory.Message, "Wrap_in_JSX_fragment_95120", "Wrap in JSX fragment"),
        Wrap_all_unparented_JSX_in_JSX_fragment: diag(95121, ts3.DiagnosticCategory.Message, "Wrap_all_unparented_JSX_in_JSX_fragment_95121", "Wrap all unparented JSX in JSX fragment"),
        Convert_arrow_function_or_function_expression: diag(95122, ts3.DiagnosticCategory.Message, "Convert_arrow_function_or_function_expression_95122", "Convert arrow function or function expression"),
        Convert_to_anonymous_function: diag(95123, ts3.DiagnosticCategory.Message, "Convert_to_anonymous_function_95123", "Convert to anonymous function"),
        Convert_to_named_function: diag(95124, ts3.DiagnosticCategory.Message, "Convert_to_named_function_95124", "Convert to named function"),
        Convert_to_arrow_function: diag(95125, ts3.DiagnosticCategory.Message, "Convert_to_arrow_function_95125", "Convert to arrow function"),
        Remove_parentheses: diag(95126, ts3.DiagnosticCategory.Message, "Remove_parentheses_95126", "Remove parentheses"),
        Could_not_find_a_containing_arrow_function: diag(95127, ts3.DiagnosticCategory.Message, "Could_not_find_a_containing_arrow_function_95127", "Could not find a containing arrow function"),
        Containing_function_is_not_an_arrow_function: diag(95128, ts3.DiagnosticCategory.Message, "Containing_function_is_not_an_arrow_function_95128", "Containing function is not an arrow function"),
        Could_not_find_export_statement: diag(95129, ts3.DiagnosticCategory.Message, "Could_not_find_export_statement_95129", "Could not find export statement"),
        This_file_already_has_a_default_export: diag(95130, ts3.DiagnosticCategory.Message, "This_file_already_has_a_default_export_95130", "This file already has a default export"),
        Could_not_find_import_clause: diag(95131, ts3.DiagnosticCategory.Message, "Could_not_find_import_clause_95131", "Could not find import clause"),
        Could_not_find_namespace_import_or_named_imports: diag(95132, ts3.DiagnosticCategory.Message, "Could_not_find_namespace_import_or_named_imports_95132", "Could not find namespace import or named imports"),
        Selection_is_not_a_valid_type_node: diag(95133, ts3.DiagnosticCategory.Message, "Selection_is_not_a_valid_type_node_95133", "Selection is not a valid type node"),
        No_type_could_be_extracted_from_this_type_node: diag(95134, ts3.DiagnosticCategory.Message, "No_type_could_be_extracted_from_this_type_node_95134", "No type could be extracted from this type node"),
        Could_not_find_property_for_which_to_generate_accessor: diag(95135, ts3.DiagnosticCategory.Message, "Could_not_find_property_for_which_to_generate_accessor_95135", "Could not find property for which to generate accessor"),
        Name_is_not_valid: diag(95136, ts3.DiagnosticCategory.Message, "Name_is_not_valid_95136", "Name is not valid"),
        Can_only_convert_property_with_modifier: diag(95137, ts3.DiagnosticCategory.Message, "Can_only_convert_property_with_modifier_95137", "Can only convert property with modifier"),
        Switch_each_misused_0_to_1: diag(95138, ts3.DiagnosticCategory.Message, "Switch_each_misused_0_to_1_95138", "Switch each misused '{0}' to '{1}'"),
        Convert_to_optional_chain_expression: diag(95139, ts3.DiagnosticCategory.Message, "Convert_to_optional_chain_expression_95139", "Convert to optional chain expression"),
        Could_not_find_convertible_access_expression: diag(95140, ts3.DiagnosticCategory.Message, "Could_not_find_convertible_access_expression_95140", "Could not find convertible access expression"),
        Could_not_find_matching_access_expressions: diag(95141, ts3.DiagnosticCategory.Message, "Could_not_find_matching_access_expressions_95141", "Could not find matching access expressions"),
        Can_only_convert_logical_AND_access_chains: diag(95142, ts3.DiagnosticCategory.Message, "Can_only_convert_logical_AND_access_chains_95142", "Can only convert logical AND access chains"),
        Add_void_to_Promise_resolved_without_a_value: diag(95143, ts3.DiagnosticCategory.Message, "Add_void_to_Promise_resolved_without_a_value_95143", "Add 'void' to Promise resolved without a value"),
        Add_void_to_all_Promises_resolved_without_a_value: diag(95144, ts3.DiagnosticCategory.Message, "Add_void_to_all_Promises_resolved_without_a_value_95144", "Add 'void' to all Promises resolved without a value"),
        Use_element_access_for_0: diag(95145, ts3.DiagnosticCategory.Message, "Use_element_access_for_0_95145", "Use element access for '{0}'"),
        Use_element_access_for_all_undeclared_properties: diag(95146, ts3.DiagnosticCategory.Message, "Use_element_access_for_all_undeclared_properties_95146", "Use element access for all undeclared properties."),
        Delete_all_unused_imports: diag(95147, ts3.DiagnosticCategory.Message, "Delete_all_unused_imports_95147", "Delete all unused imports"),
        Infer_function_return_type: diag(95148, ts3.DiagnosticCategory.Message, "Infer_function_return_type_95148", "Infer function return type"),
        Return_type_must_be_inferred_from_a_function: diag(95149, ts3.DiagnosticCategory.Message, "Return_type_must_be_inferred_from_a_function_95149", "Return type must be inferred from a function"),
        Could_not_determine_function_return_type: diag(95150, ts3.DiagnosticCategory.Message, "Could_not_determine_function_return_type_95150", "Could not determine function return type"),
        Could_not_convert_to_arrow_function: diag(95151, ts3.DiagnosticCategory.Message, "Could_not_convert_to_arrow_function_95151", "Could not convert to arrow function"),
        Could_not_convert_to_named_function: diag(95152, ts3.DiagnosticCategory.Message, "Could_not_convert_to_named_function_95152", "Could not convert to named function"),
        Could_not_convert_to_anonymous_function: diag(95153, ts3.DiagnosticCategory.Message, "Could_not_convert_to_anonymous_function_95153", "Could not convert to anonymous function"),
        Can_only_convert_string_concatenation: diag(95154, ts3.DiagnosticCategory.Message, "Can_only_convert_string_concatenation_95154", "Can only convert string concatenation"),
        Selection_is_not_a_valid_statement_or_statements: diag(95155, ts3.DiagnosticCategory.Message, "Selection_is_not_a_valid_statement_or_statements_95155", "Selection is not a valid statement or statements"),
        Add_missing_function_declaration_0: diag(95156, ts3.DiagnosticCategory.Message, "Add_missing_function_declaration_0_95156", "Add missing function declaration '{0}'"),
        Add_all_missing_function_declarations: diag(95157, ts3.DiagnosticCategory.Message, "Add_all_missing_function_declarations_95157", "Add all missing function declarations"),
        Method_not_implemented: diag(95158, ts3.DiagnosticCategory.Message, "Method_not_implemented_95158", "Method not implemented."),
        Function_not_implemented: diag(95159, ts3.DiagnosticCategory.Message, "Function_not_implemented_95159", "Function not implemented."),
        Add_override_modifier: diag(95160, ts3.DiagnosticCategory.Message, "Add_override_modifier_95160", "Add 'override' modifier"),
        Remove_override_modifier: diag(95161, ts3.DiagnosticCategory.Message, "Remove_override_modifier_95161", "Remove 'override' modifier"),
        Add_all_missing_override_modifiers: diag(95162, ts3.DiagnosticCategory.Message, "Add_all_missing_override_modifiers_95162", "Add all missing 'override' modifiers"),
        Remove_all_unnecessary_override_modifiers: diag(95163, ts3.DiagnosticCategory.Message, "Remove_all_unnecessary_override_modifiers_95163", "Remove all unnecessary 'override' modifiers"),
        No_value_exists_in_scope_for_the_shorthand_property_0_Either_declare_one_or_provide_an_initializer: diag(18004, ts3.DiagnosticCategory.Error, "No_value_exists_in_scope_for_the_shorthand_property_0_Either_declare_one_or_provide_an_initializer_18004", "No value exists in scope for the shorthand property '{0}'. Either declare one or provide an initializer."),
        Classes_may_not_have_a_field_named_constructor: diag(18006, ts3.DiagnosticCategory.Error, "Classes_may_not_have_a_field_named_constructor_18006", "Classes may not have a field named 'constructor'."),
        JSX_expressions_may_not_use_the_comma_operator_Did_you_mean_to_write_an_array: diag(18007, ts3.DiagnosticCategory.Error, "JSX_expressions_may_not_use_the_comma_operator_Did_you_mean_to_write_an_array_18007", "JSX expressions may not use the comma operator. Did you mean to write an array?"),
        Private_identifiers_cannot_be_used_as_parameters: diag(18009, ts3.DiagnosticCategory.Error, "Private_identifiers_cannot_be_used_as_parameters_18009", "Private identifiers cannot be used as parameters."),
        An_accessibility_modifier_cannot_be_used_with_a_private_identifier: diag(18010, ts3.DiagnosticCategory.Error, "An_accessibility_modifier_cannot_be_used_with_a_private_identifier_18010", "An accessibility modifier cannot be used with a private identifier."),
        The_operand_of_a_delete_operator_cannot_be_a_private_identifier: diag(18011, ts3.DiagnosticCategory.Error, "The_operand_of_a_delete_operator_cannot_be_a_private_identifier_18011", "The operand of a 'delete' operator cannot be a private identifier."),
        constructor_is_a_reserved_word: diag(18012, ts3.DiagnosticCategory.Error, "constructor_is_a_reserved_word_18012", "'#constructor' is a reserved word."),
        Property_0_is_not_accessible_outside_class_1_because_it_has_a_private_identifier: diag(18013, ts3.DiagnosticCategory.Error, "Property_0_is_not_accessible_outside_class_1_because_it_has_a_private_identifier_18013", "Property '{0}' is not accessible outside class '{1}' because it has a private identifier."),
        The_property_0_cannot_be_accessed_on_type_1_within_this_class_because_it_is_shadowed_by_another_private_identifier_with_the_same_spelling: diag(18014, ts3.DiagnosticCategory.Error, "The_property_0_cannot_be_accessed_on_type_1_within_this_class_because_it_is_shadowed_by_another_priv_18014", "The property '{0}' cannot be accessed on type '{1}' within this class because it is shadowed by another private identifier with the same spelling."),
        Property_0_in_type_1_refers_to_a_different_member_that_cannot_be_accessed_from_within_type_2: diag(18015, ts3.DiagnosticCategory.Error, "Property_0_in_type_1_refers_to_a_different_member_that_cannot_be_accessed_from_within_type_2_18015", "Property '{0}' in type '{1}' refers to a different member that cannot be accessed from within type '{2}'."),
        Private_identifiers_are_not_allowed_outside_class_bodies: diag(18016, ts3.DiagnosticCategory.Error, "Private_identifiers_are_not_allowed_outside_class_bodies_18016", "Private identifiers are not allowed outside class bodies."),
        The_shadowing_declaration_of_0_is_defined_here: diag(18017, ts3.DiagnosticCategory.Error, "The_shadowing_declaration_of_0_is_defined_here_18017", "The shadowing declaration of '{0}' is defined here"),
        The_declaration_of_0_that_you_probably_intended_to_use_is_defined_here: diag(18018, ts3.DiagnosticCategory.Error, "The_declaration_of_0_that_you_probably_intended_to_use_is_defined_here_18018", "The declaration of '{0}' that you probably intended to use is defined here"),
        _0_modifier_cannot_be_used_with_a_private_identifier: diag(18019, ts3.DiagnosticCategory.Error, "_0_modifier_cannot_be_used_with_a_private_identifier_18019", "'{0}' modifier cannot be used with a private identifier."),
        An_enum_member_cannot_be_named_with_a_private_identifier: diag(18024, ts3.DiagnosticCategory.Error, "An_enum_member_cannot_be_named_with_a_private_identifier_18024", "An enum member cannot be named with a private identifier."),
        can_only_be_used_at_the_start_of_a_file: diag(18026, ts3.DiagnosticCategory.Error, "can_only_be_used_at_the_start_of_a_file_18026", "'#!' can only be used at the start of a file."),
        Compiler_reserves_name_0_when_emitting_private_identifier_downlevel: diag(18027, ts3.DiagnosticCategory.Error, "Compiler_reserves_name_0_when_emitting_private_identifier_downlevel_18027", "Compiler reserves name '{0}' when emitting private identifier downlevel."),
        Private_identifiers_are_only_available_when_targeting_ECMAScript_2015_and_higher: diag(18028, ts3.DiagnosticCategory.Error, "Private_identifiers_are_only_available_when_targeting_ECMAScript_2015_and_higher_18028", "Private identifiers are only available when targeting ECMAScript 2015 and higher."),
        Private_identifiers_are_not_allowed_in_variable_declarations: diag(18029, ts3.DiagnosticCategory.Error, "Private_identifiers_are_not_allowed_in_variable_declarations_18029", "Private identifiers are not allowed in variable declarations."),
        An_optional_chain_cannot_contain_private_identifiers: diag(18030, ts3.DiagnosticCategory.Error, "An_optional_chain_cannot_contain_private_identifiers_18030", "An optional chain cannot contain private identifiers."),
        The_intersection_0_was_reduced_to_never_because_property_1_has_conflicting_types_in_some_constituents: diag(18031, ts3.DiagnosticCategory.Error, "The_intersection_0_was_reduced_to_never_because_property_1_has_conflicting_types_in_some_constituent_18031", "The intersection '{0}' was reduced to 'never' because property '{1}' has conflicting types in some constituents."),
        The_intersection_0_was_reduced_to_never_because_property_1_exists_in_multiple_constituents_and_is_private_in_some: diag(18032, ts3.DiagnosticCategory.Error, "The_intersection_0_was_reduced_to_never_because_property_1_exists_in_multiple_constituents_and_is_pr_18032", "The intersection '{0}' was reduced to 'never' because property '{1}' exists in multiple constituents and is private in some."),
        Only_numeric_enums_can_have_computed_members_but_this_expression_has_type_0_If_you_do_not_need_exhaustiveness_checks_consider_using_an_object_literal_instead: diag(18033, ts3.DiagnosticCategory.Error, "Only_numeric_enums_can_have_computed_members_but_this_expression_has_type_0_If_you_do_not_need_exhau_18033", "Only numeric enums can have computed members, but this expression has type '{0}'. If you do not need exhaustiveness checks, consider using an object literal instead."),
        Specify_the_JSX_fragment_factory_function_to_use_when_targeting_react_JSX_emit_with_jsxFactory_compiler_option_is_specified_e_g_Fragment: diag(18034, ts3.DiagnosticCategory.Message, "Specify_the_JSX_fragment_factory_function_to_use_when_targeting_react_JSX_emit_with_jsxFactory_compi_18034", "Specify the JSX fragment factory function to use when targeting 'react' JSX emit with 'jsxFactory' compiler option is specified, e.g. 'Fragment'."),
        Invalid_value_for_jsxFragmentFactory_0_is_not_a_valid_identifier_or_qualified_name: diag(18035, ts3.DiagnosticCategory.Error, "Invalid_value_for_jsxFragmentFactory_0_is_not_a_valid_identifier_or_qualified_name_18035", "Invalid value for 'jsxFragmentFactory'. '{0}' is not a valid identifier or qualified-name."),
        Class_decorators_can_t_be_used_with_static_private_identifier_Consider_removing_the_experimental_decorator: diag(18036, ts3.DiagnosticCategory.Error, "Class_decorators_can_t_be_used_with_static_private_identifier_Consider_removing_the_experimental_dec_18036", "Class decorators can't be used with static private identifier. Consider removing the experimental decorator.")
      };
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var _a2;
      function tokenIsIdentifierOrKeyword(token) {
        return token >= 78;
      }
      ts3.tokenIsIdentifierOrKeyword = tokenIsIdentifierOrKeyword;
      function tokenIsIdentifierOrKeywordOrGreaterThan(token) {
        return token === 31 || tokenIsIdentifierOrKeyword(token);
      }
      ts3.tokenIsIdentifierOrKeywordOrGreaterThan = tokenIsIdentifierOrKeywordOrGreaterThan;
      var textToKeywordObj = (_a2 = {
        abstract: 125,
        any: 128,
        as: 126,
        asserts: 127,
        bigint: 155,
        boolean: 131,
        break: 80,
        case: 81,
        catch: 82,
        class: 83,
        continue: 85,
        const: 84
      }, _a2["constructor"] = 132, _a2.debugger = 86, _a2.declare = 133, _a2.default = 87, _a2.delete = 88, _a2.do = 89, _a2.else = 90, _a2.enum = 91, _a2.export = 92, _a2.extends = 93, _a2.false = 94, _a2.finally = 95, _a2.for = 96, _a2.from = 153, _a2.function = 97, _a2.get = 134, _a2.if = 98, _a2.implements = 116, _a2.import = 99, _a2.in = 100, _a2.infer = 135, _a2.instanceof = 101, _a2.interface = 117, _a2.intrinsic = 136, _a2.is = 137, _a2.keyof = 138, _a2.let = 118, _a2.module = 139, _a2.namespace = 140, _a2.never = 141, _a2.new = 102, _a2.null = 103, _a2.number = 144, _a2.object = 145, _a2.package = 119, _a2.private = 120, _a2.protected = 121, _a2.public = 122, _a2.override = 156, _a2.readonly = 142, _a2.require = 143, _a2.global = 154, _a2.return = 104, _a2.set = 146, _a2.static = 123, _a2.string = 147, _a2.super = 105, _a2.switch = 106, _a2.symbol = 148, _a2.this = 107, _a2.throw = 108, _a2.true = 109, _a2.try = 110, _a2.type = 149, _a2.typeof = 111, _a2.undefined = 150, _a2.unique = 151, _a2.unknown = 152, _a2.var = 112, _a2.void = 113, _a2.while = 114, _a2.with = 115, _a2.yield = 124, _a2.async = 129, _a2.await = 130, _a2.of = 157, _a2);
      var textToKeyword = new ts3.Map(ts3.getEntries(textToKeywordObj));
      var textToToken = new ts3.Map(ts3.getEntries(__assign(__assign({}, textToKeywordObj), { "{": 18, "}": 19, "(": 20, ")": 21, "[": 22, "]": 23, ".": 24, "...": 25, ";": 26, ",": 27, "<": 29, ">": 31, "<=": 32, ">=": 33, "==": 34, "!=": 35, "===": 36, "!==": 37, "=>": 38, "+": 39, "-": 40, "**": 42, "*": 41, "/": 43, "%": 44, "++": 45, "--": 46, "<<": 47, "</": 30, ">>": 48, ">>>": 49, "&": 50, "|": 51, "^": 52, "!": 53, "~": 54, "&&": 55, "||": 56, "?": 57, "??": 60, "?.": 28, ":": 58, "=": 62, "+=": 63, "-=": 64, "*=": 65, "**=": 66, "/=": 67, "%=": 68, "<<=": 69, ">>=": 70, ">>>=": 71, "&=": 72, "|=": 73, "^=": 77, "||=": 74, "&&=": 75, "??=": 76, "@": 59, "`": 61 })));
      var unicodeES3IdentifierStart = [170, 170, 181, 181, 186, 186, 192, 214, 216, 246, 248, 543, 546, 563, 592, 685, 688, 696, 699, 705, 720, 721, 736, 740, 750, 750, 890, 890, 902, 902, 904, 906, 908, 908, 910, 929, 931, 974, 976, 983, 986, 1011, 1024, 1153, 1164, 1220, 1223, 1224, 1227, 1228, 1232, 1269, 1272, 1273, 1329, 1366, 1369, 1369, 1377, 1415, 1488, 1514, 1520, 1522, 1569, 1594, 1600, 1610, 1649, 1747, 1749, 1749, 1765, 1766, 1786, 1788, 1808, 1808, 1810, 1836, 1920, 1957, 2309, 2361, 2365, 2365, 2384, 2384, 2392, 2401, 2437, 2444, 2447, 2448, 2451, 2472, 2474, 2480, 2482, 2482, 2486, 2489, 2524, 2525, 2527, 2529, 2544, 2545, 2565, 2570, 2575, 2576, 2579, 2600, 2602, 2608, 2610, 2611, 2613, 2614, 2616, 2617, 2649, 2652, 2654, 2654, 2674, 2676, 2693, 2699, 2701, 2701, 2703, 2705, 2707, 2728, 2730, 2736, 2738, 2739, 2741, 2745, 2749, 2749, 2768, 2768, 2784, 2784, 2821, 2828, 2831, 2832, 2835, 2856, 2858, 2864, 2866, 2867, 2870, 2873, 2877, 2877, 2908, 2909, 2911, 2913, 2949, 2954, 2958, 2960, 2962, 2965, 2969, 2970, 2972, 2972, 2974, 2975, 2979, 2980, 2984, 2986, 2990, 2997, 2999, 3001, 3077, 3084, 3086, 3088, 3090, 3112, 3114, 3123, 3125, 3129, 3168, 3169, 3205, 3212, 3214, 3216, 3218, 3240, 3242, 3251, 3253, 3257, 3294, 3294, 3296, 3297, 3333, 3340, 3342, 3344, 3346, 3368, 3370, 3385, 3424, 3425, 3461, 3478, 3482, 3505, 3507, 3515, 3517, 3517, 3520, 3526, 3585, 3632, 3634, 3635, 3648, 3654, 3713, 3714, 3716, 3716, 3719, 3720, 3722, 3722, 3725, 3725, 3732, 3735, 3737, 3743, 3745, 3747, 3749, 3749, 3751, 3751, 3754, 3755, 3757, 3760, 3762, 3763, 3773, 3773, 3776, 3780, 3782, 3782, 3804, 3805, 3840, 3840, 3904, 3911, 3913, 3946, 3976, 3979, 4096, 4129, 4131, 4135, 4137, 4138, 4176, 4181, 4256, 4293, 4304, 4342, 4352, 4441, 4447, 4514, 4520, 4601, 4608, 4614, 4616, 4678, 4680, 4680, 4682, 4685, 4688, 4694, 4696, 4696, 4698, 4701, 4704, 4742, 4744, 4744, 4746, 4749, 4752, 4782, 4784, 4784, 4786, 4789, 4792, 4798, 4800, 4800, 4802, 4805, 4808, 4814, 4816, 4822, 4824, 4846, 4848, 4878, 4880, 4880, 4882, 4885, 4888, 4894, 4896, 4934, 4936, 4954, 5024, 5108, 5121, 5740, 5743, 5750, 5761, 5786, 5792, 5866, 6016, 6067, 6176, 6263, 6272, 6312, 7680, 7835, 7840, 7929, 7936, 7957, 7960, 7965, 7968, 8005, 8008, 8013, 8016, 8023, 8025, 8025, 8027, 8027, 8029, 8029, 8031, 8061, 8064, 8116, 8118, 8124, 8126, 8126, 8130, 8132, 8134, 8140, 8144, 8147, 8150, 8155, 8160, 8172, 8178, 8180, 8182, 8188, 8319, 8319, 8450, 8450, 8455, 8455, 8458, 8467, 8469, 8469, 8473, 8477, 8484, 8484, 8486, 8486, 8488, 8488, 8490, 8493, 8495, 8497, 8499, 8505, 8544, 8579, 12293, 12295, 12321, 12329, 12337, 12341, 12344, 12346, 12353, 12436, 12445, 12446, 12449, 12538, 12540, 12542, 12549, 12588, 12593, 12686, 12704, 12727, 13312, 19893, 19968, 40869, 40960, 42124, 44032, 55203, 63744, 64045, 64256, 64262, 64275, 64279, 64285, 64285, 64287, 64296, 64298, 64310, 64312, 64316, 64318, 64318, 64320, 64321, 64323, 64324, 64326, 64433, 64467, 64829, 64848, 64911, 64914, 64967, 65008, 65019, 65136, 65138, 65140, 65140, 65142, 65276, 65313, 65338, 65345, 65370, 65382, 65470, 65474, 65479, 65482, 65487, 65490, 65495, 65498, 65500];
      var unicodeES3IdentifierPart = [170, 170, 181, 181, 186, 186, 192, 214, 216, 246, 248, 543, 546, 563, 592, 685, 688, 696, 699, 705, 720, 721, 736, 740, 750, 750, 768, 846, 864, 866, 890, 890, 902, 902, 904, 906, 908, 908, 910, 929, 931, 974, 976, 983, 986, 1011, 1024, 1153, 1155, 1158, 1164, 1220, 1223, 1224, 1227, 1228, 1232, 1269, 1272, 1273, 1329, 1366, 1369, 1369, 1377, 1415, 1425, 1441, 1443, 1465, 1467, 1469, 1471, 1471, 1473, 1474, 1476, 1476, 1488, 1514, 1520, 1522, 1569, 1594, 1600, 1621, 1632, 1641, 1648, 1747, 1749, 1756, 1759, 1768, 1770, 1773, 1776, 1788, 1808, 1836, 1840, 1866, 1920, 1968, 2305, 2307, 2309, 2361, 2364, 2381, 2384, 2388, 2392, 2403, 2406, 2415, 2433, 2435, 2437, 2444, 2447, 2448, 2451, 2472, 2474, 2480, 2482, 2482, 2486, 2489, 2492, 2492, 2494, 2500, 2503, 2504, 2507, 2509, 2519, 2519, 2524, 2525, 2527, 2531, 2534, 2545, 2562, 2562, 2565, 2570, 2575, 2576, 2579, 2600, 2602, 2608, 2610, 2611, 2613, 2614, 2616, 2617, 2620, 2620, 2622, 2626, 2631, 2632, 2635, 2637, 2649, 2652, 2654, 2654, 2662, 2676, 2689, 2691, 2693, 2699, 2701, 2701, 2703, 2705, 2707, 2728, 2730, 2736, 2738, 2739, 2741, 2745, 2748, 2757, 2759, 2761, 2763, 2765, 2768, 2768, 2784, 2784, 2790, 2799, 2817, 2819, 2821, 2828, 2831, 2832, 2835, 2856, 2858, 2864, 2866, 2867, 2870, 2873, 2876, 2883, 2887, 2888, 2891, 2893, 2902, 2903, 2908, 2909, 2911, 2913, 2918, 2927, 2946, 2947, 2949, 2954, 2958, 2960, 2962, 2965, 2969, 2970, 2972, 2972, 2974, 2975, 2979, 2980, 2984, 2986, 2990, 2997, 2999, 3001, 3006, 3010, 3014, 3016, 3018, 3021, 3031, 3031, 3047, 3055, 3073, 3075, 3077, 3084, 3086, 3088, 3090, 3112, 3114, 3123, 3125, 3129, 3134, 3140, 3142, 3144, 3146, 3149, 3157, 3158, 3168, 3169, 3174, 3183, 3202, 3203, 3205, 3212, 3214, 3216, 3218, 3240, 3242, 3251, 3253, 3257, 3262, 3268, 3270, 3272, 3274, 3277, 3285, 3286, 3294, 3294, 3296, 3297, 3302, 3311, 3330, 3331, 3333, 3340, 3342, 3344, 3346, 3368, 3370, 3385, 3390, 3395, 3398, 3400, 3402, 3405, 3415, 3415, 3424, 3425, 3430, 3439, 3458, 3459, 3461, 3478, 3482, 3505, 3507, 3515, 3517, 3517, 3520, 3526, 3530, 3530, 3535, 3540, 3542, 3542, 3544, 3551, 3570, 3571, 3585, 3642, 3648, 3662, 3664, 3673, 3713, 3714, 3716, 3716, 3719, 3720, 3722, 3722, 3725, 3725, 3732, 3735, 3737, 3743, 3745, 3747, 3749, 3749, 3751, 3751, 3754, 3755, 3757, 3769, 3771, 3773, 3776, 3780, 3782, 3782, 3784, 3789, 3792, 3801, 3804, 3805, 3840, 3840, 3864, 3865, 3872, 3881, 3893, 3893, 3895, 3895, 3897, 3897, 3902, 3911, 3913, 3946, 3953, 3972, 3974, 3979, 3984, 3991, 3993, 4028, 4038, 4038, 4096, 4129, 4131, 4135, 4137, 4138, 4140, 4146, 4150, 4153, 4160, 4169, 4176, 4185, 4256, 4293, 4304, 4342, 4352, 4441, 4447, 4514, 4520, 4601, 4608, 4614, 4616, 4678, 4680, 4680, 4682, 4685, 4688, 4694, 4696, 4696, 4698, 4701, 4704, 4742, 4744, 4744, 4746, 4749, 4752, 4782, 4784, 4784, 4786, 4789, 4792, 4798, 4800, 4800, 4802, 4805, 4808, 4814, 4816, 4822, 4824, 4846, 4848, 4878, 4880, 4880, 4882, 4885, 4888, 4894, 4896, 4934, 4936, 4954, 4969, 4977, 5024, 5108, 5121, 5740, 5743, 5750, 5761, 5786, 5792, 5866, 6016, 6099, 6112, 6121, 6160, 6169, 6176, 6263, 6272, 6313, 7680, 7835, 7840, 7929, 7936, 7957, 7960, 7965, 7968, 8005, 8008, 8013, 8016, 8023, 8025, 8025, 8027, 8027, 8029, 8029, 8031, 8061, 8064, 8116, 8118, 8124, 8126, 8126, 8130, 8132, 8134, 8140, 8144, 8147, 8150, 8155, 8160, 8172, 8178, 8180, 8182, 8188, 8255, 8256, 8319, 8319, 8400, 8412, 8417, 8417, 8450, 8450, 8455, 8455, 8458, 8467, 8469, 8469, 8473, 8477, 8484, 8484, 8486, 8486, 8488, 8488, 8490, 8493, 8495, 8497, 8499, 8505, 8544, 8579, 12293, 12295, 12321, 12335, 12337, 12341, 12344, 12346, 12353, 12436, 12441, 12442, 12445, 12446, 12449, 12542, 12549, 12588, 12593, 12686, 12704, 12727, 13312, 19893, 19968, 40869, 40960, 42124, 44032, 55203, 63744, 64045, 64256, 64262, 64275, 64279, 64285, 64296, 64298, 64310, 64312, 64316, 64318, 64318, 64320, 64321, 64323, 64324, 64326, 64433, 64467, 64829, 64848, 64911, 64914, 64967, 65008, 65019, 65056, 65059, 65075, 65076, 65101, 65103, 65136, 65138, 65140, 65140, 65142, 65276, 65296, 65305, 65313, 65338, 65343, 65343, 65345, 65370, 65381, 65470, 65474, 65479, 65482, 65487, 65490, 65495, 65498, 65500];
      var unicodeES5IdentifierStart = [170, 170, 181, 181, 186, 186, 192, 214, 216, 246, 248, 705, 710, 721, 736, 740, 748, 748, 750, 750, 880, 884, 886, 887, 890, 893, 902, 902, 904, 906, 908, 908, 910, 929, 931, 1013, 1015, 1153, 1162, 1319, 1329, 1366, 1369, 1369, 1377, 1415, 1488, 1514, 1520, 1522, 1568, 1610, 1646, 1647, 1649, 1747, 1749, 1749, 1765, 1766, 1774, 1775, 1786, 1788, 1791, 1791, 1808, 1808, 1810, 1839, 1869, 1957, 1969, 1969, 1994, 2026, 2036, 2037, 2042, 2042, 2048, 2069, 2074, 2074, 2084, 2084, 2088, 2088, 2112, 2136, 2208, 2208, 2210, 2220, 2308, 2361, 2365, 2365, 2384, 2384, 2392, 2401, 2417, 2423, 2425, 2431, 2437, 2444, 2447, 2448, 2451, 2472, 2474, 2480, 2482, 2482, 2486, 2489, 2493, 2493, 2510, 2510, 2524, 2525, 2527, 2529, 2544, 2545, 2565, 2570, 2575, 2576, 2579, 2600, 2602, 2608, 2610, 2611, 2613, 2614, 2616, 2617, 2649, 2652, 2654, 2654, 2674, 2676, 2693, 2701, 2703, 2705, 2707, 2728, 2730, 2736, 2738, 2739, 2741, 2745, 2749, 2749, 2768, 2768, 2784, 2785, 2821, 2828, 2831, 2832, 2835, 2856, 2858, 2864, 2866, 2867, 2869, 2873, 2877, 2877, 2908, 2909, 2911, 2913, 2929, 2929, 2947, 2947, 2949, 2954, 2958, 2960, 2962, 2965, 2969, 2970, 2972, 2972, 2974, 2975, 2979, 2980, 2984, 2986, 2990, 3001, 3024, 3024, 3077, 3084, 3086, 3088, 3090, 3112, 3114, 3123, 3125, 3129, 3133, 3133, 3160, 3161, 3168, 3169, 3205, 3212, 3214, 3216, 3218, 3240, 3242, 3251, 3253, 3257, 3261, 3261, 3294, 3294, 3296, 3297, 3313, 3314, 3333, 3340, 3342, 3344, 3346, 3386, 3389, 3389, 3406, 3406, 3424, 3425, 3450, 3455, 3461, 3478, 3482, 3505, 3507, 3515, 3517, 3517, 3520, 3526, 3585, 3632, 3634, 3635, 3648, 3654, 3713, 3714, 3716, 3716, 3719, 3720, 3722, 3722, 3725, 3725, 3732, 3735, 3737, 3743, 3745, 3747, 3749, 3749, 3751, 3751, 3754, 3755, 3757, 3760, 3762, 3763, 3773, 3773, 3776, 3780, 3782, 3782, 3804, 3807, 3840, 3840, 3904, 3911, 3913, 3948, 3976, 3980, 4096, 4138, 4159, 4159, 4176, 4181, 4186, 4189, 4193, 4193, 4197, 4198, 4206, 4208, 4213, 4225, 4238, 4238, 4256, 4293, 4295, 4295, 4301, 4301, 4304, 4346, 4348, 4680, 4682, 4685, 4688, 4694, 4696, 4696, 4698, 4701, 4704, 4744, 4746, 4749, 4752, 4784, 4786, 4789, 4792, 4798, 4800, 4800, 4802, 4805, 4808, 4822, 4824, 4880, 4882, 4885, 4888, 4954, 4992, 5007, 5024, 5108, 5121, 5740, 5743, 5759, 5761, 5786, 5792, 5866, 5870, 5872, 5888, 5900, 5902, 5905, 5920, 5937, 5952, 5969, 5984, 5996, 5998, 6e3, 6016, 6067, 6103, 6103, 6108, 6108, 6176, 6263, 6272, 6312, 6314, 6314, 6320, 6389, 6400, 6428, 6480, 6509, 6512, 6516, 6528, 6571, 6593, 6599, 6656, 6678, 6688, 6740, 6823, 6823, 6917, 6963, 6981, 6987, 7043, 7072, 7086, 7087, 7098, 7141, 7168, 7203, 7245, 7247, 7258, 7293, 7401, 7404, 7406, 7409, 7413, 7414, 7424, 7615, 7680, 7957, 7960, 7965, 7968, 8005, 8008, 8013, 8016, 8023, 8025, 8025, 8027, 8027, 8029, 8029, 8031, 8061, 8064, 8116, 8118, 8124, 8126, 8126, 8130, 8132, 8134, 8140, 8144, 8147, 8150, 8155, 8160, 8172, 8178, 8180, 8182, 8188, 8305, 8305, 8319, 8319, 8336, 8348, 8450, 8450, 8455, 8455, 8458, 8467, 8469, 8469, 8473, 8477, 8484, 8484, 8486, 8486, 8488, 8488, 8490, 8493, 8495, 8505, 8508, 8511, 8517, 8521, 8526, 8526, 8544, 8584, 11264, 11310, 11312, 11358, 11360, 11492, 11499, 11502, 11506, 11507, 11520, 11557, 11559, 11559, 11565, 11565, 11568, 11623, 11631, 11631, 11648, 11670, 11680, 11686, 11688, 11694, 11696, 11702, 11704, 11710, 11712, 11718, 11720, 11726, 11728, 11734, 11736, 11742, 11823, 11823, 12293, 12295, 12321, 12329, 12337, 12341, 12344, 12348, 12353, 12438, 12445, 12447, 12449, 12538, 12540, 12543, 12549, 12589, 12593, 12686, 12704, 12730, 12784, 12799, 13312, 19893, 19968, 40908, 40960, 42124, 42192, 42237, 42240, 42508, 42512, 42527, 42538, 42539, 42560, 42606, 42623, 42647, 42656, 42735, 42775, 42783, 42786, 42888, 42891, 42894, 42896, 42899, 42912, 42922, 43e3, 43009, 43011, 43013, 43015, 43018, 43020, 43042, 43072, 43123, 43138, 43187, 43250, 43255, 43259, 43259, 43274, 43301, 43312, 43334, 43360, 43388, 43396, 43442, 43471, 43471, 43520, 43560, 43584, 43586, 43588, 43595, 43616, 43638, 43642, 43642, 43648, 43695, 43697, 43697, 43701, 43702, 43705, 43709, 43712, 43712, 43714, 43714, 43739, 43741, 43744, 43754, 43762, 43764, 43777, 43782, 43785, 43790, 43793, 43798, 43808, 43814, 43816, 43822, 43968, 44002, 44032, 55203, 55216, 55238, 55243, 55291, 63744, 64109, 64112, 64217, 64256, 64262, 64275, 64279, 64285, 64285, 64287, 64296, 64298, 64310, 64312, 64316, 64318, 64318, 64320, 64321, 64323, 64324, 64326, 64433, 64467, 64829, 64848, 64911, 64914, 64967, 65008, 65019, 65136, 65140, 65142, 65276, 65313, 65338, 65345, 65370, 65382, 65470, 65474, 65479, 65482, 65487, 65490, 65495, 65498, 65500];
      var unicodeES5IdentifierPart = [170, 170, 181, 181, 186, 186, 192, 214, 216, 246, 248, 705, 710, 721, 736, 740, 748, 748, 750, 750, 768, 884, 886, 887, 890, 893, 902, 902, 904, 906, 908, 908, 910, 929, 931, 1013, 1015, 1153, 1155, 1159, 1162, 1319, 1329, 1366, 1369, 1369, 1377, 1415, 1425, 1469, 1471, 1471, 1473, 1474, 1476, 1477, 1479, 1479, 1488, 1514, 1520, 1522, 1552, 1562, 1568, 1641, 1646, 1747, 1749, 1756, 1759, 1768, 1770, 1788, 1791, 1791, 1808, 1866, 1869, 1969, 1984, 2037, 2042, 2042, 2048, 2093, 2112, 2139, 2208, 2208, 2210, 2220, 2276, 2302, 2304, 2403, 2406, 2415, 2417, 2423, 2425, 2431, 2433, 2435, 2437, 2444, 2447, 2448, 2451, 2472, 2474, 2480, 2482, 2482, 2486, 2489, 2492, 2500, 2503, 2504, 2507, 2510, 2519, 2519, 2524, 2525, 2527, 2531, 2534, 2545, 2561, 2563, 2565, 2570, 2575, 2576, 2579, 2600, 2602, 2608, 2610, 2611, 2613, 2614, 2616, 2617, 2620, 2620, 2622, 2626, 2631, 2632, 2635, 2637, 2641, 2641, 2649, 2652, 2654, 2654, 2662, 2677, 2689, 2691, 2693, 2701, 2703, 2705, 2707, 2728, 2730, 2736, 2738, 2739, 2741, 2745, 2748, 2757, 2759, 2761, 2763, 2765, 2768, 2768, 2784, 2787, 2790, 2799, 2817, 2819, 2821, 2828, 2831, 2832, 2835, 2856, 2858, 2864, 2866, 2867, 2869, 2873, 2876, 2884, 2887, 2888, 2891, 2893, 2902, 2903, 2908, 2909, 2911, 2915, 2918, 2927, 2929, 2929, 2946, 2947, 2949, 2954, 2958, 2960, 2962, 2965, 2969, 2970, 2972, 2972, 2974, 2975, 2979, 2980, 2984, 2986, 2990, 3001, 3006, 3010, 3014, 3016, 3018, 3021, 3024, 3024, 3031, 3031, 3046, 3055, 3073, 3075, 3077, 3084, 3086, 3088, 3090, 3112, 3114, 3123, 3125, 3129, 3133, 3140, 3142, 3144, 3146, 3149, 3157, 3158, 3160, 3161, 3168, 3171, 3174, 3183, 3202, 3203, 3205, 3212, 3214, 3216, 3218, 3240, 3242, 3251, 3253, 3257, 3260, 3268, 3270, 3272, 3274, 3277, 3285, 3286, 3294, 3294, 3296, 3299, 3302, 3311, 3313, 3314, 3330, 3331, 3333, 3340, 3342, 3344, 3346, 3386, 3389, 3396, 3398, 3400, 3402, 3406, 3415, 3415, 3424, 3427, 3430, 3439, 3450, 3455, 3458, 3459, 3461, 3478, 3482, 3505, 3507, 3515, 3517, 3517, 3520, 3526, 3530, 3530, 3535, 3540, 3542, 3542, 3544, 3551, 3570, 3571, 3585, 3642, 3648, 3662, 3664, 3673, 3713, 3714, 3716, 3716, 3719, 3720, 3722, 3722, 3725, 3725, 3732, 3735, 3737, 3743, 3745, 3747, 3749, 3749, 3751, 3751, 3754, 3755, 3757, 3769, 3771, 3773, 3776, 3780, 3782, 3782, 3784, 3789, 3792, 3801, 3804, 3807, 3840, 3840, 3864, 3865, 3872, 3881, 3893, 3893, 3895, 3895, 3897, 3897, 3902, 3911, 3913, 3948, 3953, 3972, 3974, 3991, 3993, 4028, 4038, 4038, 4096, 4169, 4176, 4253, 4256, 4293, 4295, 4295, 4301, 4301, 4304, 4346, 4348, 4680, 4682, 4685, 4688, 4694, 4696, 4696, 4698, 4701, 4704, 4744, 4746, 4749, 4752, 4784, 4786, 4789, 4792, 4798, 4800, 4800, 4802, 4805, 4808, 4822, 4824, 4880, 4882, 4885, 4888, 4954, 4957, 4959, 4992, 5007, 5024, 5108, 5121, 5740, 5743, 5759, 5761, 5786, 5792, 5866, 5870, 5872, 5888, 5900, 5902, 5908, 5920, 5940, 5952, 5971, 5984, 5996, 5998, 6e3, 6002, 6003, 6016, 6099, 6103, 6103, 6108, 6109, 6112, 6121, 6155, 6157, 6160, 6169, 6176, 6263, 6272, 6314, 6320, 6389, 6400, 6428, 6432, 6443, 6448, 6459, 6470, 6509, 6512, 6516, 6528, 6571, 6576, 6601, 6608, 6617, 6656, 6683, 6688, 6750, 6752, 6780, 6783, 6793, 6800, 6809, 6823, 6823, 6912, 6987, 6992, 7001, 7019, 7027, 7040, 7155, 7168, 7223, 7232, 7241, 7245, 7293, 7376, 7378, 7380, 7414, 7424, 7654, 7676, 7957, 7960, 7965, 7968, 8005, 8008, 8013, 8016, 8023, 8025, 8025, 8027, 8027, 8029, 8029, 8031, 8061, 8064, 8116, 8118, 8124, 8126, 8126, 8130, 8132, 8134, 8140, 8144, 8147, 8150, 8155, 8160, 8172, 8178, 8180, 8182, 8188, 8204, 8205, 8255, 8256, 8276, 8276, 8305, 8305, 8319, 8319, 8336, 8348, 8400, 8412, 8417, 8417, 8421, 8432, 8450, 8450, 8455, 8455, 8458, 8467, 8469, 8469, 8473, 8477, 8484, 8484, 8486, 8486, 8488, 8488, 8490, 8493, 8495, 8505, 8508, 8511, 8517, 8521, 8526, 8526, 8544, 8584, 11264, 11310, 11312, 11358, 11360, 11492, 11499, 11507, 11520, 11557, 11559, 11559, 11565, 11565, 11568, 11623, 11631, 11631, 11647, 11670, 11680, 11686, 11688, 11694, 11696, 11702, 11704, 11710, 11712, 11718, 11720, 11726, 11728, 11734, 11736, 11742, 11744, 11775, 11823, 11823, 12293, 12295, 12321, 12335, 12337, 12341, 12344, 12348, 12353, 12438, 12441, 12442, 12445, 12447, 12449, 12538, 12540, 12543, 12549, 12589, 12593, 12686, 12704, 12730, 12784, 12799, 13312, 19893, 19968, 40908, 40960, 42124, 42192, 42237, 42240, 42508, 42512, 42539, 42560, 42607, 42612, 42621, 42623, 42647, 42655, 42737, 42775, 42783, 42786, 42888, 42891, 42894, 42896, 42899, 42912, 42922, 43e3, 43047, 43072, 43123, 43136, 43204, 43216, 43225, 43232, 43255, 43259, 43259, 43264, 43309, 43312, 43347, 43360, 43388, 43392, 43456, 43471, 43481, 43520, 43574, 43584, 43597, 43600, 43609, 43616, 43638, 43642, 43643, 43648, 43714, 43739, 43741, 43744, 43759, 43762, 43766, 43777, 43782, 43785, 43790, 43793, 43798, 43808, 43814, 43816, 43822, 43968, 44010, 44012, 44013, 44016, 44025, 44032, 55203, 55216, 55238, 55243, 55291, 63744, 64109, 64112, 64217, 64256, 64262, 64275, 64279, 64285, 64296, 64298, 64310, 64312, 64316, 64318, 64318, 64320, 64321, 64323, 64324, 64326, 64433, 64467, 64829, 64848, 64911, 64914, 64967, 65008, 65019, 65024, 65039, 65056, 65062, 65075, 65076, 65101, 65103, 65136, 65140, 65142, 65276, 65296, 65305, 65313, 65338, 65343, 65343, 65345, 65370, 65382, 65470, 65474, 65479, 65482, 65487, 65490, 65495, 65498, 65500];
      var unicodeESNextIdentifierStart = [65, 90, 97, 122, 170, 170, 181, 181, 186, 186, 192, 214, 216, 246, 248, 705, 710, 721, 736, 740, 748, 748, 750, 750, 880, 884, 886, 887, 890, 893, 895, 895, 902, 902, 904, 906, 908, 908, 910, 929, 931, 1013, 1015, 1153, 1162, 1327, 1329, 1366, 1369, 1369, 1376, 1416, 1488, 1514, 1519, 1522, 1568, 1610, 1646, 1647, 1649, 1747, 1749, 1749, 1765, 1766, 1774, 1775, 1786, 1788, 1791, 1791, 1808, 1808, 1810, 1839, 1869, 1957, 1969, 1969, 1994, 2026, 2036, 2037, 2042, 2042, 2048, 2069, 2074, 2074, 2084, 2084, 2088, 2088, 2112, 2136, 2144, 2154, 2208, 2228, 2230, 2237, 2308, 2361, 2365, 2365, 2384, 2384, 2392, 2401, 2417, 2432, 2437, 2444, 2447, 2448, 2451, 2472, 2474, 2480, 2482, 2482, 2486, 2489, 2493, 2493, 2510, 2510, 2524, 2525, 2527, 2529, 2544, 2545, 2556, 2556, 2565, 2570, 2575, 2576, 2579, 2600, 2602, 2608, 2610, 2611, 2613, 2614, 2616, 2617, 2649, 2652, 2654, 2654, 2674, 2676, 2693, 2701, 2703, 2705, 2707, 2728, 2730, 2736, 2738, 2739, 2741, 2745, 2749, 2749, 2768, 2768, 2784, 2785, 2809, 2809, 2821, 2828, 2831, 2832, 2835, 2856, 2858, 2864, 2866, 2867, 2869, 2873, 2877, 2877, 2908, 2909, 2911, 2913, 2929, 2929, 2947, 2947, 2949, 2954, 2958, 2960, 2962, 2965, 2969, 2970, 2972, 2972, 2974, 2975, 2979, 2980, 2984, 2986, 2990, 3001, 3024, 3024, 3077, 3084, 3086, 3088, 3090, 3112, 3114, 3129, 3133, 3133, 3160, 3162, 3168, 3169, 3200, 3200, 3205, 3212, 3214, 3216, 3218, 3240, 3242, 3251, 3253, 3257, 3261, 3261, 3294, 3294, 3296, 3297, 3313, 3314, 3333, 3340, 3342, 3344, 3346, 3386, 3389, 3389, 3406, 3406, 3412, 3414, 3423, 3425, 3450, 3455, 3461, 3478, 3482, 3505, 3507, 3515, 3517, 3517, 3520, 3526, 3585, 3632, 3634, 3635, 3648, 3654, 3713, 3714, 3716, 3716, 3718, 3722, 3724, 3747, 3749, 3749, 3751, 3760, 3762, 3763, 3773, 3773, 3776, 3780, 3782, 3782, 3804, 3807, 3840, 3840, 3904, 3911, 3913, 3948, 3976, 3980, 4096, 4138, 4159, 4159, 4176, 4181, 4186, 4189, 4193, 4193, 4197, 4198, 4206, 4208, 4213, 4225, 4238, 4238, 4256, 4293, 4295, 4295, 4301, 4301, 4304, 4346, 4348, 4680, 4682, 4685, 4688, 4694, 4696, 4696, 4698, 4701, 4704, 4744, 4746, 4749, 4752, 4784, 4786, 4789, 4792, 4798, 4800, 4800, 4802, 4805, 4808, 4822, 4824, 4880, 4882, 4885, 4888, 4954, 4992, 5007, 5024, 5109, 5112, 5117, 5121, 5740, 5743, 5759, 5761, 5786, 5792, 5866, 5870, 5880, 5888, 5900, 5902, 5905, 5920, 5937, 5952, 5969, 5984, 5996, 5998, 6e3, 6016, 6067, 6103, 6103, 6108, 6108, 6176, 6264, 6272, 6312, 6314, 6314, 6320, 6389, 6400, 6430, 6480, 6509, 6512, 6516, 6528, 6571, 6576, 6601, 6656, 6678, 6688, 6740, 6823, 6823, 6917, 6963, 6981, 6987, 7043, 7072, 7086, 7087, 7098, 7141, 7168, 7203, 7245, 7247, 7258, 7293, 7296, 7304, 7312, 7354, 7357, 7359, 7401, 7404, 7406, 7411, 7413, 7414, 7418, 7418, 7424, 7615, 7680, 7957, 7960, 7965, 7968, 8005, 8008, 8013, 8016, 8023, 8025, 8025, 8027, 8027, 8029, 8029, 8031, 8061, 8064, 8116, 8118, 8124, 8126, 8126, 8130, 8132, 8134, 8140, 8144, 8147, 8150, 8155, 8160, 8172, 8178, 8180, 8182, 8188, 8305, 8305, 8319, 8319, 8336, 8348, 8450, 8450, 8455, 8455, 8458, 8467, 8469, 8469, 8472, 8477, 8484, 8484, 8486, 8486, 8488, 8488, 8490, 8505, 8508, 8511, 8517, 8521, 8526, 8526, 8544, 8584, 11264, 11310, 11312, 11358, 11360, 11492, 11499, 11502, 11506, 11507, 11520, 11557, 11559, 11559, 11565, 11565, 11568, 11623, 11631, 11631, 11648, 11670, 11680, 11686, 11688, 11694, 11696, 11702, 11704, 11710, 11712, 11718, 11720, 11726, 11728, 11734, 11736, 11742, 12293, 12295, 12321, 12329, 12337, 12341, 12344, 12348, 12353, 12438, 12443, 12447, 12449, 12538, 12540, 12543, 12549, 12591, 12593, 12686, 12704, 12730, 12784, 12799, 13312, 19893, 19968, 40943, 40960, 42124, 42192, 42237, 42240, 42508, 42512, 42527, 42538, 42539, 42560, 42606, 42623, 42653, 42656, 42735, 42775, 42783, 42786, 42888, 42891, 42943, 42946, 42950, 42999, 43009, 43011, 43013, 43015, 43018, 43020, 43042, 43072, 43123, 43138, 43187, 43250, 43255, 43259, 43259, 43261, 43262, 43274, 43301, 43312, 43334, 43360, 43388, 43396, 43442, 43471, 43471, 43488, 43492, 43494, 43503, 43514, 43518, 43520, 43560, 43584, 43586, 43588, 43595, 43616, 43638, 43642, 43642, 43646, 43695, 43697, 43697, 43701, 43702, 43705, 43709, 43712, 43712, 43714, 43714, 43739, 43741, 43744, 43754, 43762, 43764, 43777, 43782, 43785, 43790, 43793, 43798, 43808, 43814, 43816, 43822, 43824, 43866, 43868, 43879, 43888, 44002, 44032, 55203, 55216, 55238, 55243, 55291, 63744, 64109, 64112, 64217, 64256, 64262, 64275, 64279, 64285, 64285, 64287, 64296, 64298, 64310, 64312, 64316, 64318, 64318, 64320, 64321, 64323, 64324, 64326, 64433, 64467, 64829, 64848, 64911, 64914, 64967, 65008, 65019, 65136, 65140, 65142, 65276, 65313, 65338, 65345, 65370, 65382, 65470, 65474, 65479, 65482, 65487, 65490, 65495, 65498, 65500, 65536, 65547, 65549, 65574, 65576, 65594, 65596, 65597, 65599, 65613, 65616, 65629, 65664, 65786, 65856, 65908, 66176, 66204, 66208, 66256, 66304, 66335, 66349, 66378, 66384, 66421, 66432, 66461, 66464, 66499, 66504, 66511, 66513, 66517, 66560, 66717, 66736, 66771, 66776, 66811, 66816, 66855, 66864, 66915, 67072, 67382, 67392, 67413, 67424, 67431, 67584, 67589, 67592, 67592, 67594, 67637, 67639, 67640, 67644, 67644, 67647, 67669, 67680, 67702, 67712, 67742, 67808, 67826, 67828, 67829, 67840, 67861, 67872, 67897, 67968, 68023, 68030, 68031, 68096, 68096, 68112, 68115, 68117, 68119, 68121, 68149, 68192, 68220, 68224, 68252, 68288, 68295, 68297, 68324, 68352, 68405, 68416, 68437, 68448, 68466, 68480, 68497, 68608, 68680, 68736, 68786, 68800, 68850, 68864, 68899, 69376, 69404, 69415, 69415, 69424, 69445, 69600, 69622, 69635, 69687, 69763, 69807, 69840, 69864, 69891, 69926, 69956, 69956, 69968, 70002, 70006, 70006, 70019, 70066, 70081, 70084, 70106, 70106, 70108, 70108, 70144, 70161, 70163, 70187, 70272, 70278, 70280, 70280, 70282, 70285, 70287, 70301, 70303, 70312, 70320, 70366, 70405, 70412, 70415, 70416, 70419, 70440, 70442, 70448, 70450, 70451, 70453, 70457, 70461, 70461, 70480, 70480, 70493, 70497, 70656, 70708, 70727, 70730, 70751, 70751, 70784, 70831, 70852, 70853, 70855, 70855, 71040, 71086, 71128, 71131, 71168, 71215, 71236, 71236, 71296, 71338, 71352, 71352, 71424, 71450, 71680, 71723, 71840, 71903, 71935, 71935, 72096, 72103, 72106, 72144, 72161, 72161, 72163, 72163, 72192, 72192, 72203, 72242, 72250, 72250, 72272, 72272, 72284, 72329, 72349, 72349, 72384, 72440, 72704, 72712, 72714, 72750, 72768, 72768, 72818, 72847, 72960, 72966, 72968, 72969, 72971, 73008, 73030, 73030, 73056, 73061, 73063, 73064, 73066, 73097, 73112, 73112, 73440, 73458, 73728, 74649, 74752, 74862, 74880, 75075, 77824, 78894, 82944, 83526, 92160, 92728, 92736, 92766, 92880, 92909, 92928, 92975, 92992, 92995, 93027, 93047, 93053, 93071, 93760, 93823, 93952, 94026, 94032, 94032, 94099, 94111, 94176, 94177, 94179, 94179, 94208, 100343, 100352, 101106, 110592, 110878, 110928, 110930, 110948, 110951, 110960, 111355, 113664, 113770, 113776, 113788, 113792, 113800, 113808, 113817, 119808, 119892, 119894, 119964, 119966, 119967, 119970, 119970, 119973, 119974, 119977, 119980, 119982, 119993, 119995, 119995, 119997, 120003, 120005, 120069, 120071, 120074, 120077, 120084, 120086, 120092, 120094, 120121, 120123, 120126, 120128, 120132, 120134, 120134, 120138, 120144, 120146, 120485, 120488, 120512, 120514, 120538, 120540, 120570, 120572, 120596, 120598, 120628, 120630, 120654, 120656, 120686, 120688, 120712, 120714, 120744, 120746, 120770, 120772, 120779, 123136, 123180, 123191, 123197, 123214, 123214, 123584, 123627, 124928, 125124, 125184, 125251, 125259, 125259, 126464, 126467, 126469, 126495, 126497, 126498, 126500, 126500, 126503, 126503, 126505, 126514, 126516, 126519, 126521, 126521, 126523, 126523, 126530, 126530, 126535, 126535, 126537, 126537, 126539, 126539, 126541, 126543, 126545, 126546, 126548, 126548, 126551, 126551, 126553, 126553, 126555, 126555, 126557, 126557, 126559, 126559, 126561, 126562, 126564, 126564, 126567, 126570, 126572, 126578, 126580, 126583, 126585, 126588, 126590, 126590, 126592, 126601, 126603, 126619, 126625, 126627, 126629, 126633, 126635, 126651, 131072, 173782, 173824, 177972, 177984, 178205, 178208, 183969, 183984, 191456, 194560, 195101];
      var unicodeESNextIdentifierPart = [48, 57, 65, 90, 95, 95, 97, 122, 170, 170, 181, 181, 183, 183, 186, 186, 192, 214, 216, 246, 248, 705, 710, 721, 736, 740, 748, 748, 750, 750, 768, 884, 886, 887, 890, 893, 895, 895, 902, 906, 908, 908, 910, 929, 931, 1013, 1015, 1153, 1155, 1159, 1162, 1327, 1329, 1366, 1369, 1369, 1376, 1416, 1425, 1469, 1471, 1471, 1473, 1474, 1476, 1477, 1479, 1479, 1488, 1514, 1519, 1522, 1552, 1562, 1568, 1641, 1646, 1747, 1749, 1756, 1759, 1768, 1770, 1788, 1791, 1791, 1808, 1866, 1869, 1969, 1984, 2037, 2042, 2042, 2045, 2045, 2048, 2093, 2112, 2139, 2144, 2154, 2208, 2228, 2230, 2237, 2259, 2273, 2275, 2403, 2406, 2415, 2417, 2435, 2437, 2444, 2447, 2448, 2451, 2472, 2474, 2480, 2482, 2482, 2486, 2489, 2492, 2500, 2503, 2504, 2507, 2510, 2519, 2519, 2524, 2525, 2527, 2531, 2534, 2545, 2556, 2556, 2558, 2558, 2561, 2563, 2565, 2570, 2575, 2576, 2579, 2600, 2602, 2608, 2610, 2611, 2613, 2614, 2616, 2617, 2620, 2620, 2622, 2626, 2631, 2632, 2635, 2637, 2641, 2641, 2649, 2652, 2654, 2654, 2662, 2677, 2689, 2691, 2693, 2701, 2703, 2705, 2707, 2728, 2730, 2736, 2738, 2739, 2741, 2745, 2748, 2757, 2759, 2761, 2763, 2765, 2768, 2768, 2784, 2787, 2790, 2799, 2809, 2815, 2817, 2819, 2821, 2828, 2831, 2832, 2835, 2856, 2858, 2864, 2866, 2867, 2869, 2873, 2876, 2884, 2887, 2888, 2891, 2893, 2902, 2903, 2908, 2909, 2911, 2915, 2918, 2927, 2929, 2929, 2946, 2947, 2949, 2954, 2958, 2960, 2962, 2965, 2969, 2970, 2972, 2972, 2974, 2975, 2979, 2980, 2984, 2986, 2990, 3001, 3006, 3010, 3014, 3016, 3018, 3021, 3024, 3024, 3031, 3031, 3046, 3055, 3072, 3084, 3086, 3088, 3090, 3112, 3114, 3129, 3133, 3140, 3142, 3144, 3146, 3149, 3157, 3158, 3160, 3162, 3168, 3171, 3174, 3183, 3200, 3203, 3205, 3212, 3214, 3216, 3218, 3240, 3242, 3251, 3253, 3257, 3260, 3268, 3270, 3272, 3274, 3277, 3285, 3286, 3294, 3294, 3296, 3299, 3302, 3311, 3313, 3314, 3328, 3331, 3333, 3340, 3342, 3344, 3346, 3396, 3398, 3400, 3402, 3406, 3412, 3415, 3423, 3427, 3430, 3439, 3450, 3455, 3458, 3459, 3461, 3478, 3482, 3505, 3507, 3515, 3517, 3517, 3520, 3526, 3530, 3530, 3535, 3540, 3542, 3542, 3544, 3551, 3558, 3567, 3570, 3571, 3585, 3642, 3648, 3662, 3664, 3673, 3713, 3714, 3716, 3716, 3718, 3722, 3724, 3747, 3749, 3749, 3751, 3773, 3776, 3780, 3782, 3782, 3784, 3789, 3792, 3801, 3804, 3807, 3840, 3840, 3864, 3865, 3872, 3881, 3893, 3893, 3895, 3895, 3897, 3897, 3902, 3911, 3913, 3948, 3953, 3972, 3974, 3991, 3993, 4028, 4038, 4038, 4096, 4169, 4176, 4253, 4256, 4293, 4295, 4295, 4301, 4301, 4304, 4346, 4348, 4680, 4682, 4685, 4688, 4694, 4696, 4696, 4698, 4701, 4704, 4744, 4746, 4749, 4752, 4784, 4786, 4789, 4792, 4798, 4800, 4800, 4802, 4805, 4808, 4822, 4824, 4880, 4882, 4885, 4888, 4954, 4957, 4959, 4969, 4977, 4992, 5007, 5024, 5109, 5112, 5117, 5121, 5740, 5743, 5759, 5761, 5786, 5792, 5866, 5870, 5880, 5888, 5900, 5902, 5908, 5920, 5940, 5952, 5971, 5984, 5996, 5998, 6e3, 6002, 6003, 6016, 6099, 6103, 6103, 6108, 6109, 6112, 6121, 6155, 6157, 6160, 6169, 6176, 6264, 6272, 6314, 6320, 6389, 6400, 6430, 6432, 6443, 6448, 6459, 6470, 6509, 6512, 6516, 6528, 6571, 6576, 6601, 6608, 6618, 6656, 6683, 6688, 6750, 6752, 6780, 6783, 6793, 6800, 6809, 6823, 6823, 6832, 6845, 6912, 6987, 6992, 7001, 7019, 7027, 7040, 7155, 7168, 7223, 7232, 7241, 7245, 7293, 7296, 7304, 7312, 7354, 7357, 7359, 7376, 7378, 7380, 7418, 7424, 7673, 7675, 7957, 7960, 7965, 7968, 8005, 8008, 8013, 8016, 8023, 8025, 8025, 8027, 8027, 8029, 8029, 8031, 8061, 8064, 8116, 8118, 8124, 8126, 8126, 8130, 8132, 8134, 8140, 8144, 8147, 8150, 8155, 8160, 8172, 8178, 8180, 8182, 8188, 8255, 8256, 8276, 8276, 8305, 8305, 8319, 8319, 8336, 8348, 8400, 8412, 8417, 8417, 8421, 8432, 8450, 8450, 8455, 8455, 8458, 8467, 8469, 8469, 8472, 8477, 8484, 8484, 8486, 8486, 8488, 8488, 8490, 8505, 8508, 8511, 8517, 8521, 8526, 8526, 8544, 8584, 11264, 11310, 11312, 11358, 11360, 11492, 11499, 11507, 11520, 11557, 11559, 11559, 11565, 11565, 11568, 11623, 11631, 11631, 11647, 11670, 11680, 11686, 11688, 11694, 11696, 11702, 11704, 11710, 11712, 11718, 11720, 11726, 11728, 11734, 11736, 11742, 11744, 11775, 12293, 12295, 12321, 12335, 12337, 12341, 12344, 12348, 12353, 12438, 12441, 12447, 12449, 12538, 12540, 12543, 12549, 12591, 12593, 12686, 12704, 12730, 12784, 12799, 13312, 19893, 19968, 40943, 40960, 42124, 42192, 42237, 42240, 42508, 42512, 42539, 42560, 42607, 42612, 42621, 42623, 42737, 42775, 42783, 42786, 42888, 42891, 42943, 42946, 42950, 42999, 43047, 43072, 43123, 43136, 43205, 43216, 43225, 43232, 43255, 43259, 43259, 43261, 43309, 43312, 43347, 43360, 43388, 43392, 43456, 43471, 43481, 43488, 43518, 43520, 43574, 43584, 43597, 43600, 43609, 43616, 43638, 43642, 43714, 43739, 43741, 43744, 43759, 43762, 43766, 43777, 43782, 43785, 43790, 43793, 43798, 43808, 43814, 43816, 43822, 43824, 43866, 43868, 43879, 43888, 44010, 44012, 44013, 44016, 44025, 44032, 55203, 55216, 55238, 55243, 55291, 63744, 64109, 64112, 64217, 64256, 64262, 64275, 64279, 64285, 64296, 64298, 64310, 64312, 64316, 64318, 64318, 64320, 64321, 64323, 64324, 64326, 64433, 64467, 64829, 64848, 64911, 64914, 64967, 65008, 65019, 65024, 65039, 65056, 65071, 65075, 65076, 65101, 65103, 65136, 65140, 65142, 65276, 65296, 65305, 65313, 65338, 65343, 65343, 65345, 65370, 65382, 65470, 65474, 65479, 65482, 65487, 65490, 65495, 65498, 65500, 65536, 65547, 65549, 65574, 65576, 65594, 65596, 65597, 65599, 65613, 65616, 65629, 65664, 65786, 65856, 65908, 66045, 66045, 66176, 66204, 66208, 66256, 66272, 66272, 66304, 66335, 66349, 66378, 66384, 66426, 66432, 66461, 66464, 66499, 66504, 66511, 66513, 66517, 66560, 66717, 66720, 66729, 66736, 66771, 66776, 66811, 66816, 66855, 66864, 66915, 67072, 67382, 67392, 67413, 67424, 67431, 67584, 67589, 67592, 67592, 67594, 67637, 67639, 67640, 67644, 67644, 67647, 67669, 67680, 67702, 67712, 67742, 67808, 67826, 67828, 67829, 67840, 67861, 67872, 67897, 67968, 68023, 68030, 68031, 68096, 68099, 68101, 68102, 68108, 68115, 68117, 68119, 68121, 68149, 68152, 68154, 68159, 68159, 68192, 68220, 68224, 68252, 68288, 68295, 68297, 68326, 68352, 68405, 68416, 68437, 68448, 68466, 68480, 68497, 68608, 68680, 68736, 68786, 68800, 68850, 68864, 68903, 68912, 68921, 69376, 69404, 69415, 69415, 69424, 69456, 69600, 69622, 69632, 69702, 69734, 69743, 69759, 69818, 69840, 69864, 69872, 69881, 69888, 69940, 69942, 69951, 69956, 69958, 69968, 70003, 70006, 70006, 70016, 70084, 70089, 70092, 70096, 70106, 70108, 70108, 70144, 70161, 70163, 70199, 70206, 70206, 70272, 70278, 70280, 70280, 70282, 70285, 70287, 70301, 70303, 70312, 70320, 70378, 70384, 70393, 70400, 70403, 70405, 70412, 70415, 70416, 70419, 70440, 70442, 70448, 70450, 70451, 70453, 70457, 70459, 70468, 70471, 70472, 70475, 70477, 70480, 70480, 70487, 70487, 70493, 70499, 70502, 70508, 70512, 70516, 70656, 70730, 70736, 70745, 70750, 70751, 70784, 70853, 70855, 70855, 70864, 70873, 71040, 71093, 71096, 71104, 71128, 71133, 71168, 71232, 71236, 71236, 71248, 71257, 71296, 71352, 71360, 71369, 71424, 71450, 71453, 71467, 71472, 71481, 71680, 71738, 71840, 71913, 71935, 71935, 72096, 72103, 72106, 72151, 72154, 72161, 72163, 72164, 72192, 72254, 72263, 72263, 72272, 72345, 72349, 72349, 72384, 72440, 72704, 72712, 72714, 72758, 72760, 72768, 72784, 72793, 72818, 72847, 72850, 72871, 72873, 72886, 72960, 72966, 72968, 72969, 72971, 73014, 73018, 73018, 73020, 73021, 73023, 73031, 73040, 73049, 73056, 73061, 73063, 73064, 73066, 73102, 73104, 73105, 73107, 73112, 73120, 73129, 73440, 73462, 73728, 74649, 74752, 74862, 74880, 75075, 77824, 78894, 82944, 83526, 92160, 92728, 92736, 92766, 92768, 92777, 92880, 92909, 92912, 92916, 92928, 92982, 92992, 92995, 93008, 93017, 93027, 93047, 93053, 93071, 93760, 93823, 93952, 94026, 94031, 94087, 94095, 94111, 94176, 94177, 94179, 94179, 94208, 100343, 100352, 101106, 110592, 110878, 110928, 110930, 110948, 110951, 110960, 111355, 113664, 113770, 113776, 113788, 113792, 113800, 113808, 113817, 113821, 113822, 119141, 119145, 119149, 119154, 119163, 119170, 119173, 119179, 119210, 119213, 119362, 119364, 119808, 119892, 119894, 119964, 119966, 119967, 119970, 119970, 119973, 119974, 119977, 119980, 119982, 119993, 119995, 119995, 119997, 120003, 120005, 120069, 120071, 120074, 120077, 120084, 120086, 120092, 120094, 120121, 120123, 120126, 120128, 120132, 120134, 120134, 120138, 120144, 120146, 120485, 120488, 120512, 120514, 120538, 120540, 120570, 120572, 120596, 120598, 120628, 120630, 120654, 120656, 120686, 120688, 120712, 120714, 120744, 120746, 120770, 120772, 120779, 120782, 120831, 121344, 121398, 121403, 121452, 121461, 121461, 121476, 121476, 121499, 121503, 121505, 121519, 122880, 122886, 122888, 122904, 122907, 122913, 122915, 122916, 122918, 122922, 123136, 123180, 123184, 123197, 123200, 123209, 123214, 123214, 123584, 123641, 124928, 125124, 125136, 125142, 125184, 125259, 125264, 125273, 126464, 126467, 126469, 126495, 126497, 126498, 126500, 126500, 126503, 126503, 126505, 126514, 126516, 126519, 126521, 126521, 126523, 126523, 126530, 126530, 126535, 126535, 126537, 126537, 126539, 126539, 126541, 126543, 126545, 126546, 126548, 126548, 126551, 126551, 126553, 126553, 126555, 126555, 126557, 126557, 126559, 126559, 126561, 126562, 126564, 126564, 126567, 126570, 126572, 126578, 126580, 126583, 126585, 126588, 126590, 126590, 126592, 126601, 126603, 126619, 126625, 126627, 126629, 126633, 126635, 126651, 131072, 173782, 173824, 177972, 177984, 178205, 178208, 183969, 183984, 191456, 194560, 195101, 917760, 917999];
      var commentDirectiveRegExSingleLine = /^\s*\/\/\/?\s*@(ts-expect-error|ts-ignore)/;
      var commentDirectiveRegExMultiLine = /^\s*(?:\/|\*)*\s*@(ts-expect-error|ts-ignore)/;
      function lookupInUnicodeMap(code, map2) {
        if (code < map2[0]) {
          return false;
        }
        var lo = 0;
        var hi = map2.length;
        var mid;
        while (lo + 1 < hi) {
          mid = lo + (hi - lo) / 2;
          mid -= mid % 2;
          if (map2[mid] <= code && code <= map2[mid + 1]) {
            return true;
          }
          if (code < map2[mid]) {
            hi = mid;
          } else {
            lo = mid + 2;
          }
        }
        return false;
      }
      function isUnicodeIdentifierStart(code, languageVersion) {
        return languageVersion >= 2 ? lookupInUnicodeMap(code, unicodeESNextIdentifierStart) : languageVersion === 1 ? lookupInUnicodeMap(code, unicodeES5IdentifierStart) : lookupInUnicodeMap(code, unicodeES3IdentifierStart);
      }
      ts3.isUnicodeIdentifierStart = isUnicodeIdentifierStart;
      function isUnicodeIdentifierPart(code, languageVersion) {
        return languageVersion >= 2 ? lookupInUnicodeMap(code, unicodeESNextIdentifierPart) : languageVersion === 1 ? lookupInUnicodeMap(code, unicodeES5IdentifierPart) : lookupInUnicodeMap(code, unicodeES3IdentifierPart);
      }
      function makeReverseMap(source) {
        var result2 = [];
        source.forEach(function(value, name) {
          result2[value] = name;
        });
        return result2;
      }
      var tokenStrings = makeReverseMap(textToToken);
      function tokenToString(t2) {
        return tokenStrings[t2];
      }
      ts3.tokenToString = tokenToString;
      function stringToToken(s2) {
        return textToToken.get(s2);
      }
      ts3.stringToToken = stringToToken;
      function computeLineStarts(text) {
        var result2 = new Array();
        var pos = 0;
        var lineStart = 0;
        while (pos < text.length) {
          var ch = text.charCodeAt(pos);
          pos++;
          switch (ch) {
            case 13:
              if (text.charCodeAt(pos) === 10) {
                pos++;
              }
            case 10:
              result2.push(lineStart);
              lineStart = pos;
              break;
            default:
              if (ch > 127 && isLineBreak(ch)) {
                result2.push(lineStart);
                lineStart = pos;
              }
              break;
          }
        }
        result2.push(lineStart);
        return result2;
      }
      ts3.computeLineStarts = computeLineStarts;
      function getPositionOfLineAndCharacter(sourceFile, line, character, allowEdits) {
        return sourceFile.getPositionOfLineAndCharacter ? sourceFile.getPositionOfLineAndCharacter(line, character, allowEdits) : computePositionOfLineAndCharacter(getLineStarts(sourceFile), line, character, sourceFile.text, allowEdits);
      }
      ts3.getPositionOfLineAndCharacter = getPositionOfLineAndCharacter;
      function computePositionOfLineAndCharacter(lineStarts, line, character, debugText, allowEdits) {
        if (line < 0 || line >= lineStarts.length) {
          if (allowEdits) {
            line = line < 0 ? 0 : line >= lineStarts.length ? lineStarts.length - 1 : line;
          } else {
            ts3.Debug.fail("Bad line number. Line: " + line + ", lineStarts.length: " + lineStarts.length + " , line map is correct? " + (debugText !== void 0 ? ts3.arraysEqual(lineStarts, computeLineStarts(debugText)) : "unknown"));
          }
        }
        var res = lineStarts[line] + character;
        if (allowEdits) {
          return res > lineStarts[line + 1] ? lineStarts[line + 1] : typeof debugText === "string" && res > debugText.length ? debugText.length : res;
        }
        if (line < lineStarts.length - 1) {
          ts3.Debug.assert(res < lineStarts[line + 1]);
        } else if (debugText !== void 0) {
          ts3.Debug.assert(res <= debugText.length);
        }
        return res;
      }
      ts3.computePositionOfLineAndCharacter = computePositionOfLineAndCharacter;
      function getLineStarts(sourceFile) {
        return sourceFile.lineMap || (sourceFile.lineMap = computeLineStarts(sourceFile.text));
      }
      ts3.getLineStarts = getLineStarts;
      function computeLineAndCharacterOfPosition(lineStarts, position) {
        var lineNumber = computeLineOfPosition(lineStarts, position);
        return {
          line: lineNumber,
          character: position - lineStarts[lineNumber]
        };
      }
      ts3.computeLineAndCharacterOfPosition = computeLineAndCharacterOfPosition;
      function computeLineOfPosition(lineStarts, position, lowerBound) {
        var lineNumber = ts3.binarySearch(lineStarts, position, ts3.identity, ts3.compareValues, lowerBound);
        if (lineNumber < 0) {
          lineNumber = ~lineNumber - 1;
          ts3.Debug.assert(lineNumber !== -1, "position cannot precede the beginning of the file");
        }
        return lineNumber;
      }
      ts3.computeLineOfPosition = computeLineOfPosition;
      function getLinesBetweenPositions(sourceFile, pos1, pos2) {
        if (pos1 === pos2)
          return 0;
        var lineStarts = getLineStarts(sourceFile);
        var lower = Math.min(pos1, pos2);
        var isNegative = lower === pos2;
        var upper = isNegative ? pos1 : pos2;
        var lowerLine = computeLineOfPosition(lineStarts, lower);
        var upperLine = computeLineOfPosition(lineStarts, upper, lowerLine);
        return isNegative ? lowerLine - upperLine : upperLine - lowerLine;
      }
      ts3.getLinesBetweenPositions = getLinesBetweenPositions;
      function getLineAndCharacterOfPosition(sourceFile, position) {
        return computeLineAndCharacterOfPosition(getLineStarts(sourceFile), position);
      }
      ts3.getLineAndCharacterOfPosition = getLineAndCharacterOfPosition;
      function isWhiteSpaceLike(ch) {
        return isWhiteSpaceSingleLine(ch) || isLineBreak(ch);
      }
      ts3.isWhiteSpaceLike = isWhiteSpaceLike;
      function isWhiteSpaceSingleLine(ch) {
        return ch === 32 || ch === 9 || ch === 11 || ch === 12 || ch === 160 || ch === 133 || ch === 5760 || ch >= 8192 && ch <= 8203 || ch === 8239 || ch === 8287 || ch === 12288 || ch === 65279;
      }
      ts3.isWhiteSpaceSingleLine = isWhiteSpaceSingleLine;
      function isLineBreak(ch) {
        return ch === 10 || ch === 13 || ch === 8232 || ch === 8233;
      }
      ts3.isLineBreak = isLineBreak;
      function isDigit(ch) {
        return ch >= 48 && ch <= 57;
      }
      function isHexDigit(ch) {
        return isDigit(ch) || ch >= 65 && ch <= 70 || ch >= 97 && ch <= 102;
      }
      function isCodePoint(code) {
        return code <= 1114111;
      }
      function isOctalDigit(ch) {
        return ch >= 48 && ch <= 55;
      }
      ts3.isOctalDigit = isOctalDigit;
      function couldStartTrivia(text, pos) {
        var ch = text.charCodeAt(pos);
        switch (ch) {
          case 13:
          case 10:
          case 9:
          case 11:
          case 12:
          case 32:
          case 47:
          case 60:
          case 124:
          case 61:
          case 62:
            return true;
          case 35:
            return pos === 0;
          default:
            return ch > 127;
        }
      }
      ts3.couldStartTrivia = couldStartTrivia;
      function skipTrivia(text, pos, stopAfterLineBreak, stopAtComments, inJSDoc) {
        if (ts3.positionIsSynthesized(pos)) {
          return pos;
        }
        var canConsumeStar = false;
        while (true) {
          var ch = text.charCodeAt(pos);
          switch (ch) {
            case 13:
              if (text.charCodeAt(pos + 1) === 10) {
                pos++;
              }
            case 10:
              pos++;
              if (stopAfterLineBreak) {
                return pos;
              }
              canConsumeStar = !!inJSDoc;
              continue;
            case 9:
            case 11:
            case 12:
            case 32:
              pos++;
              continue;
            case 47:
              if (stopAtComments) {
                break;
              }
              if (text.charCodeAt(pos + 1) === 47) {
                pos += 2;
                while (pos < text.length) {
                  if (isLineBreak(text.charCodeAt(pos))) {
                    break;
                  }
                  pos++;
                }
                canConsumeStar = false;
                continue;
              }
              if (text.charCodeAt(pos + 1) === 42) {
                pos += 2;
                while (pos < text.length) {
                  if (text.charCodeAt(pos) === 42 && text.charCodeAt(pos + 1) === 47) {
                    pos += 2;
                    break;
                  }
                  pos++;
                }
                canConsumeStar = false;
                continue;
              }
              break;
            case 60:
            case 124:
            case 61:
            case 62:
              if (isConflictMarkerTrivia(text, pos)) {
                pos = scanConflictMarkerTrivia(text, pos);
                canConsumeStar = false;
                continue;
              }
              break;
            case 35:
              if (pos === 0 && isShebangTrivia(text, pos)) {
                pos = scanShebangTrivia(text, pos);
                canConsumeStar = false;
                continue;
              }
              break;
            case 42:
              if (canConsumeStar) {
                pos++;
                canConsumeStar = false;
                continue;
              }
              break;
            default:
              if (ch > 127 && isWhiteSpaceLike(ch)) {
                pos++;
                continue;
              }
              break;
          }
          return pos;
        }
      }
      ts3.skipTrivia = skipTrivia;
      var mergeConflictMarkerLength = "<<<<<<<".length;
      function isConflictMarkerTrivia(text, pos) {
        ts3.Debug.assert(pos >= 0);
        if (pos === 0 || isLineBreak(text.charCodeAt(pos - 1))) {
          var ch = text.charCodeAt(pos);
          if (pos + mergeConflictMarkerLength < text.length) {
            for (var i3 = 0; i3 < mergeConflictMarkerLength; i3++) {
              if (text.charCodeAt(pos + i3) !== ch) {
                return false;
              }
            }
            return ch === 61 || text.charCodeAt(pos + mergeConflictMarkerLength) === 32;
          }
        }
        return false;
      }
      function scanConflictMarkerTrivia(text, pos, error) {
        if (error) {
          error(ts3.Diagnostics.Merge_conflict_marker_encountered, pos, mergeConflictMarkerLength);
        }
        var ch = text.charCodeAt(pos);
        var len = text.length;
        if (ch === 60 || ch === 62) {
          while (pos < len && !isLineBreak(text.charCodeAt(pos))) {
            pos++;
          }
        } else {
          ts3.Debug.assert(ch === 124 || ch === 61);
          while (pos < len) {
            var currentChar = text.charCodeAt(pos);
            if ((currentChar === 61 || currentChar === 62) && currentChar !== ch && isConflictMarkerTrivia(text, pos)) {
              break;
            }
            pos++;
          }
        }
        return pos;
      }
      var shebangTriviaRegex = /^#!.*/;
      function isShebangTrivia(text, pos) {
        ts3.Debug.assert(pos === 0);
        return shebangTriviaRegex.test(text);
      }
      ts3.isShebangTrivia = isShebangTrivia;
      function scanShebangTrivia(text, pos) {
        var shebang = shebangTriviaRegex.exec(text)[0];
        pos = pos + shebang.length;
        return pos;
      }
      ts3.scanShebangTrivia = scanShebangTrivia;
      function iterateCommentRanges(reduce, text, pos, trailing, cb2, state, initial) {
        var pendingPos;
        var pendingEnd;
        var pendingKind;
        var pendingHasTrailingNewLine;
        var hasPendingCommentRange = false;
        var collecting = trailing;
        var accumulator = initial;
        if (pos === 0) {
          collecting = true;
          var shebang = getShebang(text);
          if (shebang) {
            pos = shebang.length;
          }
        }
        scan:
          while (pos >= 0 && pos < text.length) {
            var ch = text.charCodeAt(pos);
            switch (ch) {
              case 13:
                if (text.charCodeAt(pos + 1) === 10) {
                  pos++;
                }
              case 10:
                pos++;
                if (trailing) {
                  break scan;
                }
                collecting = true;
                if (hasPendingCommentRange) {
                  pendingHasTrailingNewLine = true;
                }
                continue;
              case 9:
              case 11:
              case 12:
              case 32:
                pos++;
                continue;
              case 47:
                var nextChar = text.charCodeAt(pos + 1);
                var hasTrailingNewLine = false;
                if (nextChar === 47 || nextChar === 42) {
                  var kind = nextChar === 47 ? 2 : 3;
                  var startPos = pos;
                  pos += 2;
                  if (nextChar === 47) {
                    while (pos < text.length) {
                      if (isLineBreak(text.charCodeAt(pos))) {
                        hasTrailingNewLine = true;
                        break;
                      }
                      pos++;
                    }
                  } else {
                    while (pos < text.length) {
                      if (text.charCodeAt(pos) === 42 && text.charCodeAt(pos + 1) === 47) {
                        pos += 2;
                        break;
                      }
                      pos++;
                    }
                  }
                  if (collecting) {
                    if (hasPendingCommentRange) {
                      accumulator = cb2(pendingPos, pendingEnd, pendingKind, pendingHasTrailingNewLine, state, accumulator);
                      if (!reduce && accumulator) {
                        return accumulator;
                      }
                    }
                    pendingPos = startPos;
                    pendingEnd = pos;
                    pendingKind = kind;
                    pendingHasTrailingNewLine = hasTrailingNewLine;
                    hasPendingCommentRange = true;
                  }
                  continue;
                }
                break scan;
              default:
                if (ch > 127 && isWhiteSpaceLike(ch)) {
                  if (hasPendingCommentRange && isLineBreak(ch)) {
                    pendingHasTrailingNewLine = true;
                  }
                  pos++;
                  continue;
                }
                break scan;
            }
          }
        if (hasPendingCommentRange) {
          accumulator = cb2(pendingPos, pendingEnd, pendingKind, pendingHasTrailingNewLine, state, accumulator);
        }
        return accumulator;
      }
      function forEachLeadingCommentRange(text, pos, cb2, state) {
        return iterateCommentRanges(false, text, pos, false, cb2, state);
      }
      ts3.forEachLeadingCommentRange = forEachLeadingCommentRange;
      function forEachTrailingCommentRange(text, pos, cb2, state) {
        return iterateCommentRanges(false, text, pos, true, cb2, state);
      }
      ts3.forEachTrailingCommentRange = forEachTrailingCommentRange;
      function reduceEachLeadingCommentRange(text, pos, cb2, state, initial) {
        return iterateCommentRanges(true, text, pos, false, cb2, state, initial);
      }
      ts3.reduceEachLeadingCommentRange = reduceEachLeadingCommentRange;
      function reduceEachTrailingCommentRange(text, pos, cb2, state, initial) {
        return iterateCommentRanges(true, text, pos, true, cb2, state, initial);
      }
      ts3.reduceEachTrailingCommentRange = reduceEachTrailingCommentRange;
      function appendCommentRange(pos, end, kind, hasTrailingNewLine, _state, comments) {
        if (!comments) {
          comments = [];
        }
        comments.push({ kind, pos, end, hasTrailingNewLine });
        return comments;
      }
      function getLeadingCommentRanges(text, pos) {
        return reduceEachLeadingCommentRange(text, pos, appendCommentRange, void 0, void 0);
      }
      ts3.getLeadingCommentRanges = getLeadingCommentRanges;
      function getTrailingCommentRanges(text, pos) {
        return reduceEachTrailingCommentRange(text, pos, appendCommentRange, void 0, void 0);
      }
      ts3.getTrailingCommentRanges = getTrailingCommentRanges;
      function getShebang(text) {
        var match = shebangTriviaRegex.exec(text);
        if (match) {
          return match[0];
        }
      }
      ts3.getShebang = getShebang;
      function isIdentifierStart(ch, languageVersion) {
        return ch >= 65 && ch <= 90 || ch >= 97 && ch <= 122 || ch === 36 || ch === 95 || ch > 127 && isUnicodeIdentifierStart(ch, languageVersion);
      }
      ts3.isIdentifierStart = isIdentifierStart;
      function isIdentifierPart(ch, languageVersion, identifierVariant) {
        return ch >= 65 && ch <= 90 || ch >= 97 && ch <= 122 || ch >= 48 && ch <= 57 || ch === 36 || ch === 95 || (identifierVariant === 1 ? ch === 45 || ch === 58 : false) || ch > 127 && isUnicodeIdentifierPart(ch, languageVersion);
      }
      ts3.isIdentifierPart = isIdentifierPart;
      function isIdentifierText(name, languageVersion, identifierVariant) {
        var ch = codePointAt2(name, 0);
        if (!isIdentifierStart(ch, languageVersion)) {
          return false;
        }
        for (var i3 = charSize(ch); i3 < name.length; i3 += charSize(ch)) {
          if (!isIdentifierPart(ch = codePointAt2(name, i3), languageVersion, identifierVariant)) {
            return false;
          }
        }
        return true;
      }
      ts3.isIdentifierText = isIdentifierText;
      function createScanner(languageVersion, skipTrivia2, languageVariant, textInitial, onError, start, length) {
        if (languageVariant === void 0) {
          languageVariant = 0;
        }
        var text = textInitial;
        var pos;
        var end;
        var startPos;
        var tokenPos;
        var token;
        var tokenValue;
        var tokenFlags;
        var commentDirectives;
        var inJSDocType = 0;
        setText(text, start, length);
        var scanner = {
          getStartPos: function() {
            return startPos;
          },
          getTextPos: function() {
            return pos;
          },
          getToken: function() {
            return token;
          },
          getTokenPos: function() {
            return tokenPos;
          },
          getTokenText: function() {
            return text.substring(tokenPos, pos);
          },
          getTokenValue: function() {
            return tokenValue;
          },
          hasUnicodeEscape: function() {
            return (tokenFlags & 1024) !== 0;
          },
          hasExtendedUnicodeEscape: function() {
            return (tokenFlags & 8) !== 0;
          },
          hasPrecedingLineBreak: function() {
            return (tokenFlags & 1) !== 0;
          },
          hasPrecedingJSDocComment: function() {
            return (tokenFlags & 2) !== 0;
          },
          isIdentifier: function() {
            return token === 78 || token > 115;
          },
          isReservedWord: function() {
            return token >= 80 && token <= 115;
          },
          isUnterminated: function() {
            return (tokenFlags & 4) !== 0;
          },
          getCommentDirectives: function() {
            return commentDirectives;
          },
          getNumericLiteralFlags: function() {
            return tokenFlags & 1008;
          },
          getTokenFlags: function() {
            return tokenFlags;
          },
          reScanGreaterToken,
          reScanAsteriskEqualsToken,
          reScanSlashToken,
          reScanTemplateToken,
          reScanTemplateHeadOrNoSubstitutionTemplate,
          scanJsxIdentifier,
          scanJsxAttributeValue,
          reScanJsxAttributeValue,
          reScanJsxToken,
          reScanLessThanToken,
          reScanQuestionToken,
          reScanInvalidIdentifier,
          scanJsxToken,
          scanJsDocToken,
          scan,
          getText,
          clearCommentDirectives,
          setText,
          setScriptTarget,
          setLanguageVariant,
          setOnError,
          setTextPos,
          setInJSDocType,
          tryScan,
          lookAhead,
          scanRange
        };
        if (ts3.Debug.isDebugging) {
          Object.defineProperty(scanner, "__debugShowCurrentPositionInText", {
            get: function() {
              var text2 = scanner.getText();
              return text2.slice(0, scanner.getStartPos()) + "\u2551" + text2.slice(scanner.getStartPos());
            }
          });
        }
        return scanner;
        function error(message, errPos, length2) {
          if (errPos === void 0) {
            errPos = pos;
          }
          if (onError) {
            var oldPos = pos;
            pos = errPos;
            onError(message, length2 || 0);
            pos = oldPos;
          }
        }
        function scanNumberFragment() {
          var start2 = pos;
          var allowSeparator = false;
          var isPreviousTokenSeparator = false;
          var result2 = "";
          while (true) {
            var ch = text.charCodeAt(pos);
            if (ch === 95) {
              tokenFlags |= 512;
              if (allowSeparator) {
                allowSeparator = false;
                isPreviousTokenSeparator = true;
                result2 += text.substring(start2, pos);
              } else if (isPreviousTokenSeparator) {
                error(ts3.Diagnostics.Multiple_consecutive_numeric_separators_are_not_permitted, pos, 1);
              } else {
                error(ts3.Diagnostics.Numeric_separators_are_not_allowed_here, pos, 1);
              }
              pos++;
              start2 = pos;
              continue;
            }
            if (isDigit(ch)) {
              allowSeparator = true;
              isPreviousTokenSeparator = false;
              pos++;
              continue;
            }
            break;
          }
          if (text.charCodeAt(pos - 1) === 95) {
            error(ts3.Diagnostics.Numeric_separators_are_not_allowed_here, pos - 1, 1);
          }
          return result2 + text.substring(start2, pos);
        }
        function scanNumber() {
          var start2 = pos;
          var mainFragment = scanNumberFragment();
          var decimalFragment;
          var scientificFragment;
          if (text.charCodeAt(pos) === 46) {
            pos++;
            decimalFragment = scanNumberFragment();
          }
          var end2 = pos;
          if (text.charCodeAt(pos) === 69 || text.charCodeAt(pos) === 101) {
            pos++;
            tokenFlags |= 16;
            if (text.charCodeAt(pos) === 43 || text.charCodeAt(pos) === 45)
              pos++;
            var preNumericPart = pos;
            var finalFragment = scanNumberFragment();
            if (!finalFragment) {
              error(ts3.Diagnostics.Digit_expected);
            } else {
              scientificFragment = text.substring(end2, preNumericPart) + finalFragment;
              end2 = pos;
            }
          }
          var result2;
          if (tokenFlags & 512) {
            result2 = mainFragment;
            if (decimalFragment) {
              result2 += "." + decimalFragment;
            }
            if (scientificFragment) {
              result2 += scientificFragment;
            }
          } else {
            result2 = text.substring(start2, end2);
          }
          if (decimalFragment !== void 0 || tokenFlags & 16) {
            checkForIdentifierStartAfterNumericLiteral(start2, decimalFragment === void 0 && !!(tokenFlags & 16));
            return {
              type: 8,
              value: "" + +result2
            };
          } else {
            tokenValue = result2;
            var type3 = checkBigIntSuffix();
            checkForIdentifierStartAfterNumericLiteral(start2);
            return { type: type3, value: tokenValue };
          }
        }
        function checkForIdentifierStartAfterNumericLiteral(numericStart, isScientific) {
          if (!isIdentifierStart(codePointAt2(text, pos), languageVersion)) {
            return;
          }
          var identifierStart = pos;
          var length2 = scanIdentifierParts().length;
          if (length2 === 1 && text[identifierStart] === "n") {
            if (isScientific) {
              error(ts3.Diagnostics.A_bigint_literal_cannot_use_exponential_notation, numericStart, identifierStart - numericStart + 1);
            } else {
              error(ts3.Diagnostics.A_bigint_literal_must_be_an_integer, numericStart, identifierStart - numericStart + 1);
            }
          } else {
            error(ts3.Diagnostics.An_identifier_or_keyword_cannot_immediately_follow_a_numeric_literal, identifierStart, length2);
            pos = identifierStart;
          }
        }
        function scanOctalDigits() {
          var start2 = pos;
          while (isOctalDigit(text.charCodeAt(pos))) {
            pos++;
          }
          return +text.substring(start2, pos);
        }
        function scanExactNumberOfHexDigits(count, canHaveSeparators) {
          var valueString = scanHexDigits(count, false, canHaveSeparators);
          return valueString ? parseInt(valueString, 16) : -1;
        }
        function scanMinimumNumberOfHexDigits(count, canHaveSeparators) {
          return scanHexDigits(count, true, canHaveSeparators);
        }
        function scanHexDigits(minCount, scanAsManyAsPossible, canHaveSeparators) {
          var valueChars = [];
          var allowSeparator = false;
          var isPreviousTokenSeparator = false;
          while (valueChars.length < minCount || scanAsManyAsPossible) {
            var ch = text.charCodeAt(pos);
            if (canHaveSeparators && ch === 95) {
              tokenFlags |= 512;
              if (allowSeparator) {
                allowSeparator = false;
                isPreviousTokenSeparator = true;
              } else if (isPreviousTokenSeparator) {
                error(ts3.Diagnostics.Multiple_consecutive_numeric_separators_are_not_permitted, pos, 1);
              } else {
                error(ts3.Diagnostics.Numeric_separators_are_not_allowed_here, pos, 1);
              }
              pos++;
              continue;
            }
            allowSeparator = canHaveSeparators;
            if (ch >= 65 && ch <= 70) {
              ch += 97 - 65;
            } else if (!(ch >= 48 && ch <= 57 || ch >= 97 && ch <= 102)) {
              break;
            }
            valueChars.push(ch);
            pos++;
            isPreviousTokenSeparator = false;
          }
          if (valueChars.length < minCount) {
            valueChars = [];
          }
          if (text.charCodeAt(pos - 1) === 95) {
            error(ts3.Diagnostics.Numeric_separators_are_not_allowed_here, pos - 1, 1);
          }
          return String.fromCharCode.apply(String, valueChars);
        }
        function scanString(jsxAttributeString) {
          if (jsxAttributeString === void 0) {
            jsxAttributeString = false;
          }
          var quote = text.charCodeAt(pos);
          pos++;
          var result2 = "";
          var start2 = pos;
          while (true) {
            if (pos >= end) {
              result2 += text.substring(start2, pos);
              tokenFlags |= 4;
              error(ts3.Diagnostics.Unterminated_string_literal);
              break;
            }
            var ch = text.charCodeAt(pos);
            if (ch === quote) {
              result2 += text.substring(start2, pos);
              pos++;
              break;
            }
            if (ch === 92 && !jsxAttributeString) {
              result2 += text.substring(start2, pos);
              result2 += scanEscapeSequence();
              start2 = pos;
              continue;
            }
            if (isLineBreak(ch) && !jsxAttributeString) {
              result2 += text.substring(start2, pos);
              tokenFlags |= 4;
              error(ts3.Diagnostics.Unterminated_string_literal);
              break;
            }
            pos++;
          }
          return result2;
        }
        function scanTemplateAndSetTokenValue(isTaggedTemplate) {
          var startedWithBacktick = text.charCodeAt(pos) === 96;
          pos++;
          var start2 = pos;
          var contents = "";
          var resultingToken;
          while (true) {
            if (pos >= end) {
              contents += text.substring(start2, pos);
              tokenFlags |= 4;
              error(ts3.Diagnostics.Unterminated_template_literal);
              resultingToken = startedWithBacktick ? 14 : 17;
              break;
            }
            var currChar = text.charCodeAt(pos);
            if (currChar === 96) {
              contents += text.substring(start2, pos);
              pos++;
              resultingToken = startedWithBacktick ? 14 : 17;
              break;
            }
            if (currChar === 36 && pos + 1 < end && text.charCodeAt(pos + 1) === 123) {
              contents += text.substring(start2, pos);
              pos += 2;
              resultingToken = startedWithBacktick ? 15 : 16;
              break;
            }
            if (currChar === 92) {
              contents += text.substring(start2, pos);
              contents += scanEscapeSequence(isTaggedTemplate);
              start2 = pos;
              continue;
            }
            if (currChar === 13) {
              contents += text.substring(start2, pos);
              pos++;
              if (pos < end && text.charCodeAt(pos) === 10) {
                pos++;
              }
              contents += "\n";
              start2 = pos;
              continue;
            }
            pos++;
          }
          ts3.Debug.assert(resultingToken !== void 0);
          tokenValue = contents;
          return resultingToken;
        }
        function scanEscapeSequence(isTaggedTemplate) {
          var start2 = pos;
          pos++;
          if (pos >= end) {
            error(ts3.Diagnostics.Unexpected_end_of_text);
            return "";
          }
          var ch = text.charCodeAt(pos);
          pos++;
          switch (ch) {
            case 48:
              if (isTaggedTemplate && pos < end && isDigit(text.charCodeAt(pos))) {
                pos++;
                tokenFlags |= 2048;
                return text.substring(start2, pos);
              }
              return "\0";
            case 98:
              return "\b";
            case 116:
              return "	";
            case 110:
              return "\n";
            case 118:
              return "\v";
            case 102:
              return "\f";
            case 114:
              return "\r";
            case 39:
              return "'";
            case 34:
              return '"';
            case 117:
              if (isTaggedTemplate) {
                for (var escapePos = pos; escapePos < pos + 4; escapePos++) {
                  if (escapePos < end && !isHexDigit(text.charCodeAt(escapePos)) && text.charCodeAt(escapePos) !== 123) {
                    pos = escapePos;
                    tokenFlags |= 2048;
                    return text.substring(start2, pos);
                  }
                }
              }
              if (pos < end && text.charCodeAt(pos) === 123) {
                pos++;
                if (isTaggedTemplate && !isHexDigit(text.charCodeAt(pos))) {
                  tokenFlags |= 2048;
                  return text.substring(start2, pos);
                }
                if (isTaggedTemplate) {
                  var savePos = pos;
                  var escapedValueString = scanMinimumNumberOfHexDigits(1, false);
                  var escapedValue = escapedValueString ? parseInt(escapedValueString, 16) : -1;
                  if (!isCodePoint(escapedValue) || text.charCodeAt(pos) !== 125) {
                    tokenFlags |= 2048;
                    return text.substring(start2, pos);
                  } else {
                    pos = savePos;
                  }
                }
                tokenFlags |= 8;
                return scanExtendedUnicodeEscape();
              }
              tokenFlags |= 1024;
              return scanHexadecimalEscape(4);
            case 120:
              if (isTaggedTemplate) {
                if (!isHexDigit(text.charCodeAt(pos))) {
                  tokenFlags |= 2048;
                  return text.substring(start2, pos);
                } else if (!isHexDigit(text.charCodeAt(pos + 1))) {
                  pos++;
                  tokenFlags |= 2048;
                  return text.substring(start2, pos);
                }
              }
              return scanHexadecimalEscape(2);
            case 13:
              if (pos < end && text.charCodeAt(pos) === 10) {
                pos++;
              }
            case 10:
            case 8232:
            case 8233:
              return "";
            default:
              return String.fromCharCode(ch);
          }
        }
        function scanHexadecimalEscape(numDigits) {
          var escapedValue = scanExactNumberOfHexDigits(numDigits, false);
          if (escapedValue >= 0) {
            return String.fromCharCode(escapedValue);
          } else {
            error(ts3.Diagnostics.Hexadecimal_digit_expected);
            return "";
          }
        }
        function scanExtendedUnicodeEscape() {
          var escapedValueString = scanMinimumNumberOfHexDigits(1, false);
          var escapedValue = escapedValueString ? parseInt(escapedValueString, 16) : -1;
          var isInvalidExtendedEscape = false;
          if (escapedValue < 0) {
            error(ts3.Diagnostics.Hexadecimal_digit_expected);
            isInvalidExtendedEscape = true;
          } else if (escapedValue > 1114111) {
            error(ts3.Diagnostics.An_extended_Unicode_escape_value_must_be_between_0x0_and_0x10FFFF_inclusive);
            isInvalidExtendedEscape = true;
          }
          if (pos >= end) {
            error(ts3.Diagnostics.Unexpected_end_of_text);
            isInvalidExtendedEscape = true;
          } else if (text.charCodeAt(pos) === 125) {
            pos++;
          } else {
            error(ts3.Diagnostics.Unterminated_Unicode_escape_sequence);
            isInvalidExtendedEscape = true;
          }
          if (isInvalidExtendedEscape) {
            return "";
          }
          return utf16EncodeAsString(escapedValue);
        }
        function peekUnicodeEscape() {
          if (pos + 5 < end && text.charCodeAt(pos + 1) === 117) {
            var start_1 = pos;
            pos += 2;
            var value = scanExactNumberOfHexDigits(4, false);
            pos = start_1;
            return value;
          }
          return -1;
        }
        function peekExtendedUnicodeEscape() {
          if (languageVersion >= 2 && codePointAt2(text, pos + 1) === 117 && codePointAt2(text, pos + 2) === 123) {
            var start_2 = pos;
            pos += 3;
            var escapedValueString = scanMinimumNumberOfHexDigits(1, false);
            var escapedValue = escapedValueString ? parseInt(escapedValueString, 16) : -1;
            pos = start_2;
            return escapedValue;
          }
          return -1;
        }
        function scanIdentifierParts() {
          var result2 = "";
          var start2 = pos;
          while (pos < end) {
            var ch = codePointAt2(text, pos);
            if (isIdentifierPart(ch, languageVersion)) {
              pos += charSize(ch);
            } else if (ch === 92) {
              ch = peekExtendedUnicodeEscape();
              if (ch >= 0 && isIdentifierPart(ch, languageVersion)) {
                pos += 3;
                tokenFlags |= 8;
                result2 += scanExtendedUnicodeEscape();
                start2 = pos;
                continue;
              }
              ch = peekUnicodeEscape();
              if (!(ch >= 0 && isIdentifierPart(ch, languageVersion))) {
                break;
              }
              tokenFlags |= 1024;
              result2 += text.substring(start2, pos);
              result2 += utf16EncodeAsString(ch);
              pos += 6;
              start2 = pos;
            } else {
              break;
            }
          }
          result2 += text.substring(start2, pos);
          return result2;
        }
        function getIdentifierToken() {
          var len = tokenValue.length;
          if (len >= 2 && len <= 12) {
            var ch = tokenValue.charCodeAt(0);
            if (ch >= 97 && ch <= 122) {
              var keyword = textToKeyword.get(tokenValue);
              if (keyword !== void 0) {
                return token = keyword;
              }
            }
          }
          return token = 78;
        }
        function scanBinaryOrOctalDigits(base) {
          var value = "";
          var separatorAllowed = false;
          var isPreviousTokenSeparator = false;
          while (true) {
            var ch = text.charCodeAt(pos);
            if (ch === 95) {
              tokenFlags |= 512;
              if (separatorAllowed) {
                separatorAllowed = false;
                isPreviousTokenSeparator = true;
              } else if (isPreviousTokenSeparator) {
                error(ts3.Diagnostics.Multiple_consecutive_numeric_separators_are_not_permitted, pos, 1);
              } else {
                error(ts3.Diagnostics.Numeric_separators_are_not_allowed_here, pos, 1);
              }
              pos++;
              continue;
            }
            separatorAllowed = true;
            if (!isDigit(ch) || ch - 48 >= base) {
              break;
            }
            value += text[pos];
            pos++;
            isPreviousTokenSeparator = false;
          }
          if (text.charCodeAt(pos - 1) === 95) {
            error(ts3.Diagnostics.Numeric_separators_are_not_allowed_here, pos - 1, 1);
          }
          return value;
        }
        function checkBigIntSuffix() {
          if (text.charCodeAt(pos) === 110) {
            tokenValue += "n";
            if (tokenFlags & 384) {
              tokenValue = ts3.parsePseudoBigInt(tokenValue) + "n";
            }
            pos++;
            return 9;
          } else {
            var numericValue = tokenFlags & 128 ? parseInt(tokenValue.slice(2), 2) : tokenFlags & 256 ? parseInt(tokenValue.slice(2), 8) : +tokenValue;
            tokenValue = "" + numericValue;
            return 8;
          }
        }
        function scan() {
          var _a3;
          startPos = pos;
          tokenFlags = 0;
          var asteriskSeen = false;
          while (true) {
            tokenPos = pos;
            if (pos >= end) {
              return token = 1;
            }
            var ch = codePointAt2(text, pos);
            if (ch === 35 && pos === 0 && isShebangTrivia(text, pos)) {
              pos = scanShebangTrivia(text, pos);
              if (skipTrivia2) {
                continue;
              } else {
                return token = 6;
              }
            }
            switch (ch) {
              case 10:
              case 13:
                tokenFlags |= 1;
                if (skipTrivia2) {
                  pos++;
                  continue;
                } else {
                  if (ch === 13 && pos + 1 < end && text.charCodeAt(pos + 1) === 10) {
                    pos += 2;
                  } else {
                    pos++;
                  }
                  return token = 4;
                }
              case 9:
              case 11:
              case 12:
              case 32:
              case 160:
              case 5760:
              case 8192:
              case 8193:
              case 8194:
              case 8195:
              case 8196:
              case 8197:
              case 8198:
              case 8199:
              case 8200:
              case 8201:
              case 8202:
              case 8203:
              case 8239:
              case 8287:
              case 12288:
              case 65279:
                if (skipTrivia2) {
                  pos++;
                  continue;
                } else {
                  while (pos < end && isWhiteSpaceSingleLine(text.charCodeAt(pos))) {
                    pos++;
                  }
                  return token = 5;
                }
              case 33:
                if (text.charCodeAt(pos + 1) === 61) {
                  if (text.charCodeAt(pos + 2) === 61) {
                    return pos += 3, token = 37;
                  }
                  return pos += 2, token = 35;
                }
                pos++;
                return token = 53;
              case 34:
              case 39:
                tokenValue = scanString();
                return token = 10;
              case 96:
                return token = scanTemplateAndSetTokenValue(false);
              case 37:
                if (text.charCodeAt(pos + 1) === 61) {
                  return pos += 2, token = 68;
                }
                pos++;
                return token = 44;
              case 38:
                if (text.charCodeAt(pos + 1) === 38) {
                  if (text.charCodeAt(pos + 2) === 61) {
                    return pos += 3, token = 75;
                  }
                  return pos += 2, token = 55;
                }
                if (text.charCodeAt(pos + 1) === 61) {
                  return pos += 2, token = 72;
                }
                pos++;
                return token = 50;
              case 40:
                pos++;
                return token = 20;
              case 41:
                pos++;
                return token = 21;
              case 42:
                if (text.charCodeAt(pos + 1) === 61) {
                  return pos += 2, token = 65;
                }
                if (text.charCodeAt(pos + 1) === 42) {
                  if (text.charCodeAt(pos + 2) === 61) {
                    return pos += 3, token = 66;
                  }
                  return pos += 2, token = 42;
                }
                pos++;
                if (inJSDocType && !asteriskSeen && tokenFlags & 1) {
                  asteriskSeen = true;
                  continue;
                }
                return token = 41;
              case 43:
                if (text.charCodeAt(pos + 1) === 43) {
                  return pos += 2, token = 45;
                }
                if (text.charCodeAt(pos + 1) === 61) {
                  return pos += 2, token = 63;
                }
                pos++;
                return token = 39;
              case 44:
                pos++;
                return token = 27;
              case 45:
                if (text.charCodeAt(pos + 1) === 45) {
                  return pos += 2, token = 46;
                }
                if (text.charCodeAt(pos + 1) === 61) {
                  return pos += 2, token = 64;
                }
                pos++;
                return token = 40;
              case 46:
                if (isDigit(text.charCodeAt(pos + 1))) {
                  tokenValue = scanNumber().value;
                  return token = 8;
                }
                if (text.charCodeAt(pos + 1) === 46 && text.charCodeAt(pos + 2) === 46) {
                  return pos += 3, token = 25;
                }
                pos++;
                return token = 24;
              case 47:
                if (text.charCodeAt(pos + 1) === 47) {
                  pos += 2;
                  while (pos < end) {
                    if (isLineBreak(text.charCodeAt(pos))) {
                      break;
                    }
                    pos++;
                  }
                  commentDirectives = appendIfCommentDirective(commentDirectives, text.slice(tokenPos, pos), commentDirectiveRegExSingleLine, tokenPos);
                  if (skipTrivia2) {
                    continue;
                  } else {
                    return token = 2;
                  }
                }
                if (text.charCodeAt(pos + 1) === 42) {
                  pos += 2;
                  if (text.charCodeAt(pos) === 42 && text.charCodeAt(pos + 1) !== 47) {
                    tokenFlags |= 2;
                  }
                  var commentClosed = false;
                  var lastLineStart = tokenPos;
                  while (pos < end) {
                    var ch_1 = text.charCodeAt(pos);
                    if (ch_1 === 42 && text.charCodeAt(pos + 1) === 47) {
                      pos += 2;
                      commentClosed = true;
                      break;
                    }
                    pos++;
                    if (isLineBreak(ch_1)) {
                      lastLineStart = pos;
                      tokenFlags |= 1;
                    }
                  }
                  commentDirectives = appendIfCommentDirective(commentDirectives, text.slice(lastLineStart, pos), commentDirectiveRegExMultiLine, lastLineStart);
                  if (!commentClosed) {
                    error(ts3.Diagnostics.Asterisk_Slash_expected);
                  }
                  if (skipTrivia2) {
                    continue;
                  } else {
                    if (!commentClosed) {
                      tokenFlags |= 4;
                    }
                    return token = 3;
                  }
                }
                if (text.charCodeAt(pos + 1) === 61) {
                  return pos += 2, token = 67;
                }
                pos++;
                return token = 43;
              case 48:
                if (pos + 2 < end && (text.charCodeAt(pos + 1) === 88 || text.charCodeAt(pos + 1) === 120)) {
                  pos += 2;
                  tokenValue = scanMinimumNumberOfHexDigits(1, true);
                  if (!tokenValue) {
                    error(ts3.Diagnostics.Hexadecimal_digit_expected);
                    tokenValue = "0";
                  }
                  tokenValue = "0x" + tokenValue;
                  tokenFlags |= 64;
                  return token = checkBigIntSuffix();
                } else if (pos + 2 < end && (text.charCodeAt(pos + 1) === 66 || text.charCodeAt(pos + 1) === 98)) {
                  pos += 2;
                  tokenValue = scanBinaryOrOctalDigits(2);
                  if (!tokenValue) {
                    error(ts3.Diagnostics.Binary_digit_expected);
                    tokenValue = "0";
                  }
                  tokenValue = "0b" + tokenValue;
                  tokenFlags |= 128;
                  return token = checkBigIntSuffix();
                } else if (pos + 2 < end && (text.charCodeAt(pos + 1) === 79 || text.charCodeAt(pos + 1) === 111)) {
                  pos += 2;
                  tokenValue = scanBinaryOrOctalDigits(8);
                  if (!tokenValue) {
                    error(ts3.Diagnostics.Octal_digit_expected);
                    tokenValue = "0";
                  }
                  tokenValue = "0o" + tokenValue;
                  tokenFlags |= 256;
                  return token = checkBigIntSuffix();
                }
                if (pos + 1 < end && isOctalDigit(text.charCodeAt(pos + 1))) {
                  tokenValue = "" + scanOctalDigits();
                  tokenFlags |= 32;
                  return token = 8;
                }
              case 49:
              case 50:
              case 51:
              case 52:
              case 53:
              case 54:
              case 55:
              case 56:
              case 57:
                _a3 = scanNumber(), token = _a3.type, tokenValue = _a3.value;
                return token;
              case 58:
                pos++;
                return token = 58;
              case 59:
                pos++;
                return token = 26;
              case 60:
                if (isConflictMarkerTrivia(text, pos)) {
                  pos = scanConflictMarkerTrivia(text, pos, error);
                  if (skipTrivia2) {
                    continue;
                  } else {
                    return token = 7;
                  }
                }
                if (text.charCodeAt(pos + 1) === 60) {
                  if (text.charCodeAt(pos + 2) === 61) {
                    return pos += 3, token = 69;
                  }
                  return pos += 2, token = 47;
                }
                if (text.charCodeAt(pos + 1) === 61) {
                  return pos += 2, token = 32;
                }
                if (languageVariant === 1 && text.charCodeAt(pos + 1) === 47 && text.charCodeAt(pos + 2) !== 42) {
                  return pos += 2, token = 30;
                }
                pos++;
                return token = 29;
              case 61:
                if (isConflictMarkerTrivia(text, pos)) {
                  pos = scanConflictMarkerTrivia(text, pos, error);
                  if (skipTrivia2) {
                    continue;
                  } else {
                    return token = 7;
                  }
                }
                if (text.charCodeAt(pos + 1) === 61) {
                  if (text.charCodeAt(pos + 2) === 61) {
                    return pos += 3, token = 36;
                  }
                  return pos += 2, token = 34;
                }
                if (text.charCodeAt(pos + 1) === 62) {
                  return pos += 2, token = 38;
                }
                pos++;
                return token = 62;
              case 62:
                if (isConflictMarkerTrivia(text, pos)) {
                  pos = scanConflictMarkerTrivia(text, pos, error);
                  if (skipTrivia2) {
                    continue;
                  } else {
                    return token = 7;
                  }
                }
                pos++;
                return token = 31;
              case 63:
                if (text.charCodeAt(pos + 1) === 46 && !isDigit(text.charCodeAt(pos + 2))) {
                  return pos += 2, token = 28;
                }
                if (text.charCodeAt(pos + 1) === 63) {
                  if (text.charCodeAt(pos + 2) === 61) {
                    return pos += 3, token = 76;
                  }
                  return pos += 2, token = 60;
                }
                pos++;
                return token = 57;
              case 91:
                pos++;
                return token = 22;
              case 93:
                pos++;
                return token = 23;
              case 94:
                if (text.charCodeAt(pos + 1) === 61) {
                  return pos += 2, token = 77;
                }
                pos++;
                return token = 52;
              case 123:
                pos++;
                return token = 18;
              case 124:
                if (isConflictMarkerTrivia(text, pos)) {
                  pos = scanConflictMarkerTrivia(text, pos, error);
                  if (skipTrivia2) {
                    continue;
                  } else {
                    return token = 7;
                  }
                }
                if (text.charCodeAt(pos + 1) === 124) {
                  if (text.charCodeAt(pos + 2) === 61) {
                    return pos += 3, token = 74;
                  }
                  return pos += 2, token = 56;
                }
                if (text.charCodeAt(pos + 1) === 61) {
                  return pos += 2, token = 73;
                }
                pos++;
                return token = 51;
              case 125:
                pos++;
                return token = 19;
              case 126:
                pos++;
                return token = 54;
              case 64:
                pos++;
                return token = 59;
              case 92:
                var extendedCookedChar = peekExtendedUnicodeEscape();
                if (extendedCookedChar >= 0 && isIdentifierStart(extendedCookedChar, languageVersion)) {
                  pos += 3;
                  tokenFlags |= 8;
                  tokenValue = scanExtendedUnicodeEscape() + scanIdentifierParts();
                  return token = getIdentifierToken();
                }
                var cookedChar = peekUnicodeEscape();
                if (cookedChar >= 0 && isIdentifierStart(cookedChar, languageVersion)) {
                  pos += 6;
                  tokenFlags |= 1024;
                  tokenValue = String.fromCharCode(cookedChar) + scanIdentifierParts();
                  return token = getIdentifierToken();
                }
                error(ts3.Diagnostics.Invalid_character);
                pos++;
                return token = 0;
              case 35:
                if (pos !== 0 && text[pos + 1] === "!") {
                  error(ts3.Diagnostics.can_only_be_used_at_the_start_of_a_file);
                  pos++;
                  return token = 0;
                }
                pos++;
                if (isIdentifierStart(ch = text.charCodeAt(pos), languageVersion)) {
                  pos++;
                  while (pos < end && isIdentifierPart(ch = text.charCodeAt(pos), languageVersion))
                    pos++;
                  tokenValue = text.substring(tokenPos, pos);
                  if (ch === 92) {
                    tokenValue += scanIdentifierParts();
                  }
                } else {
                  tokenValue = "#";
                  error(ts3.Diagnostics.Invalid_character);
                }
                return token = 79;
              default:
                var identifierKind = scanIdentifier(ch, languageVersion);
                if (identifierKind) {
                  return token = identifierKind;
                } else if (isWhiteSpaceSingleLine(ch)) {
                  pos += charSize(ch);
                  continue;
                } else if (isLineBreak(ch)) {
                  tokenFlags |= 1;
                  pos += charSize(ch);
                  continue;
                }
                error(ts3.Diagnostics.Invalid_character);
                pos += charSize(ch);
                return token = 0;
            }
          }
        }
        function reScanInvalidIdentifier() {
          ts3.Debug.assert(token === 0, "'reScanInvalidIdentifier' should only be called when the current token is 'SyntaxKind.Unknown'.");
          pos = tokenPos = startPos;
          tokenFlags = 0;
          var ch = codePointAt2(text, pos);
          var identifierKind = scanIdentifier(ch, 99);
          if (identifierKind) {
            return token = identifierKind;
          }
          pos += charSize(ch);
          return token;
        }
        function scanIdentifier(startCharacter, languageVersion2) {
          var ch = startCharacter;
          if (isIdentifierStart(ch, languageVersion2)) {
            pos += charSize(ch);
            while (pos < end && isIdentifierPart(ch = codePointAt2(text, pos), languageVersion2))
              pos += charSize(ch);
            tokenValue = text.substring(tokenPos, pos);
            if (ch === 92) {
              tokenValue += scanIdentifierParts();
            }
            return getIdentifierToken();
          }
        }
        function reScanGreaterToken() {
          if (token === 31) {
            if (text.charCodeAt(pos) === 62) {
              if (text.charCodeAt(pos + 1) === 62) {
                if (text.charCodeAt(pos + 2) === 61) {
                  return pos += 3, token = 71;
                }
                return pos += 2, token = 49;
              }
              if (text.charCodeAt(pos + 1) === 61) {
                return pos += 2, token = 70;
              }
              pos++;
              return token = 48;
            }
            if (text.charCodeAt(pos) === 61) {
              pos++;
              return token = 33;
            }
          }
          return token;
        }
        function reScanAsteriskEqualsToken() {
          ts3.Debug.assert(token === 65, "'reScanAsteriskEqualsToken' should only be called on a '*='");
          pos = tokenPos + 1;
          return token = 62;
        }
        function reScanSlashToken() {
          if (token === 43 || token === 67) {
            var p = tokenPos + 1;
            var inEscape = false;
            var inCharacterClass = false;
            while (true) {
              if (p >= end) {
                tokenFlags |= 4;
                error(ts3.Diagnostics.Unterminated_regular_expression_literal);
                break;
              }
              var ch = text.charCodeAt(p);
              if (isLineBreak(ch)) {
                tokenFlags |= 4;
                error(ts3.Diagnostics.Unterminated_regular_expression_literal);
                break;
              }
              if (inEscape) {
                inEscape = false;
              } else if (ch === 47 && !inCharacterClass) {
                p++;
                break;
              } else if (ch === 91) {
                inCharacterClass = true;
              } else if (ch === 92) {
                inEscape = true;
              } else if (ch === 93) {
                inCharacterClass = false;
              }
              p++;
            }
            while (p < end && isIdentifierPart(text.charCodeAt(p), languageVersion)) {
              p++;
            }
            pos = p;
            tokenValue = text.substring(tokenPos, pos);
            token = 13;
          }
          return token;
        }
        function appendIfCommentDirective(commentDirectives2, text2, commentDirectiveRegEx, lineStart) {
          var type3 = getDirectiveFromComment(text2, commentDirectiveRegEx);
          if (type3 === void 0) {
            return commentDirectives2;
          }
          return ts3.append(commentDirectives2, {
            range: { pos: lineStart, end: pos },
            type: type3
          });
        }
        function getDirectiveFromComment(text2, commentDirectiveRegEx) {
          var match = commentDirectiveRegEx.exec(text2);
          if (!match) {
            return void 0;
          }
          switch (match[1]) {
            case "ts-expect-error":
              return 0;
            case "ts-ignore":
              return 1;
          }
          return void 0;
        }
        function reScanTemplateToken(isTaggedTemplate) {
          ts3.Debug.assert(token === 19, "'reScanTemplateToken' should only be called on a '}'");
          pos = tokenPos;
          return token = scanTemplateAndSetTokenValue(isTaggedTemplate);
        }
        function reScanTemplateHeadOrNoSubstitutionTemplate() {
          pos = tokenPos;
          return token = scanTemplateAndSetTokenValue(true);
        }
        function reScanJsxToken(allowMultilineJsxText) {
          if (allowMultilineJsxText === void 0) {
            allowMultilineJsxText = true;
          }
          pos = tokenPos = startPos;
          return token = scanJsxToken(allowMultilineJsxText);
        }
        function reScanLessThanToken() {
          if (token === 47) {
            pos = tokenPos + 1;
            return token = 29;
          }
          return token;
        }
        function reScanQuestionToken() {
          ts3.Debug.assert(token === 60, "'reScanQuestionToken' should only be called on a '??'");
          pos = tokenPos + 1;
          return token = 57;
        }
        function scanJsxToken(allowMultilineJsxText) {
          if (allowMultilineJsxText === void 0) {
            allowMultilineJsxText = true;
          }
          startPos = tokenPos = pos;
          if (pos >= end) {
            return token = 1;
          }
          var char = text.charCodeAt(pos);
          if (char === 60) {
            if (text.charCodeAt(pos + 1) === 47) {
              pos += 2;
              return token = 30;
            }
            pos++;
            return token = 29;
          }
          if (char === 123) {
            pos++;
            return token = 18;
          }
          var firstNonWhitespace = 0;
          while (pos < end) {
            char = text.charCodeAt(pos);
            if (char === 123) {
              break;
            }
            if (char === 60) {
              if (isConflictMarkerTrivia(text, pos)) {
                pos = scanConflictMarkerTrivia(text, pos, error);
                return token = 7;
              }
              break;
            }
            if (char === 62) {
              error(ts3.Diagnostics.Unexpected_token_Did_you_mean_or_gt, pos, 1);
            }
            if (char === 125) {
              error(ts3.Diagnostics.Unexpected_token_Did_you_mean_or_rbrace, pos, 1);
            }
            if (isLineBreak(char) && firstNonWhitespace === 0) {
              firstNonWhitespace = -1;
            } else if (!allowMultilineJsxText && isLineBreak(char) && firstNonWhitespace > 0) {
              break;
            } else if (!isWhiteSpaceLike(char)) {
              firstNonWhitespace = pos;
            }
            pos++;
          }
          tokenValue = text.substring(startPos, pos);
          return firstNonWhitespace === -1 ? 12 : 11;
        }
        function scanJsxIdentifier() {
          if (tokenIsIdentifierOrKeyword(token)) {
            var namespaceSeparator = false;
            while (pos < end) {
              var ch = text.charCodeAt(pos);
              if (ch === 45) {
                tokenValue += "-";
                pos++;
                continue;
              } else if (ch === 58 && !namespaceSeparator) {
                tokenValue += ":";
                pos++;
                namespaceSeparator = true;
                token = 78;
                continue;
              }
              var oldPos = pos;
              tokenValue += scanIdentifierParts();
              if (pos === oldPos) {
                break;
              }
            }
            if (tokenValue.slice(-1) === ":") {
              tokenValue = tokenValue.slice(0, -1);
              pos--;
            }
          }
          return token;
        }
        function scanJsxAttributeValue() {
          startPos = pos;
          switch (text.charCodeAt(pos)) {
            case 34:
            case 39:
              tokenValue = scanString(true);
              return token = 10;
            default:
              return scan();
          }
        }
        function reScanJsxAttributeValue() {
          pos = tokenPos = startPos;
          return scanJsxAttributeValue();
        }
        function scanJsDocToken() {
          startPos = tokenPos = pos;
          tokenFlags = 0;
          if (pos >= end) {
            return token = 1;
          }
          var ch = codePointAt2(text, pos);
          pos += charSize(ch);
          switch (ch) {
            case 9:
            case 11:
            case 12:
            case 32:
              while (pos < end && isWhiteSpaceSingleLine(text.charCodeAt(pos))) {
                pos++;
              }
              return token = 5;
            case 64:
              return token = 59;
            case 13:
              if (text.charCodeAt(pos) === 10) {
                pos++;
              }
            case 10:
              tokenFlags |= 1;
              return token = 4;
            case 42:
              return token = 41;
            case 123:
              return token = 18;
            case 125:
              return token = 19;
            case 91:
              return token = 22;
            case 93:
              return token = 23;
            case 60:
              return token = 29;
            case 62:
              return token = 31;
            case 61:
              return token = 62;
            case 44:
              return token = 27;
            case 46:
              return token = 24;
            case 96:
              return token = 61;
            case 92:
              pos--;
              var extendedCookedChar = peekExtendedUnicodeEscape();
              if (extendedCookedChar >= 0 && isIdentifierStart(extendedCookedChar, languageVersion)) {
                pos += 3;
                tokenFlags |= 8;
                tokenValue = scanExtendedUnicodeEscape() + scanIdentifierParts();
                return token = getIdentifierToken();
              }
              var cookedChar = peekUnicodeEscape();
              if (cookedChar >= 0 && isIdentifierStart(cookedChar, languageVersion)) {
                pos += 6;
                tokenFlags |= 1024;
                tokenValue = String.fromCharCode(cookedChar) + scanIdentifierParts();
                return token = getIdentifierToken();
              }
              pos++;
              return token = 0;
          }
          if (isIdentifierStart(ch, languageVersion)) {
            var char = ch;
            while (pos < end && isIdentifierPart(char = codePointAt2(text, pos), languageVersion) || text.charCodeAt(pos) === 45)
              pos += charSize(char);
            tokenValue = text.substring(tokenPos, pos);
            if (char === 92) {
              tokenValue += scanIdentifierParts();
            }
            return token = getIdentifierToken();
          } else {
            return token = 0;
          }
        }
        function speculationHelper(callback, isLookahead) {
          var savePos = pos;
          var saveStartPos = startPos;
          var saveTokenPos = tokenPos;
          var saveToken = token;
          var saveTokenValue = tokenValue;
          var saveTokenFlags = tokenFlags;
          var result2 = callback();
          if (!result2 || isLookahead) {
            pos = savePos;
            startPos = saveStartPos;
            tokenPos = saveTokenPos;
            token = saveToken;
            tokenValue = saveTokenValue;
            tokenFlags = saveTokenFlags;
          }
          return result2;
        }
        function scanRange(start2, length2, callback) {
          var saveEnd = end;
          var savePos = pos;
          var saveStartPos = startPos;
          var saveTokenPos = tokenPos;
          var saveToken = token;
          var saveTokenValue = tokenValue;
          var saveTokenFlags = tokenFlags;
          var saveErrorExpectations = commentDirectives;
          setText(text, start2, length2);
          var result2 = callback();
          end = saveEnd;
          pos = savePos;
          startPos = saveStartPos;
          tokenPos = saveTokenPos;
          token = saveToken;
          tokenValue = saveTokenValue;
          tokenFlags = saveTokenFlags;
          commentDirectives = saveErrorExpectations;
          return result2;
        }
        function lookAhead(callback) {
          return speculationHelper(callback, true);
        }
        function tryScan(callback) {
          return speculationHelper(callback, false);
        }
        function getText() {
          return text;
        }
        function clearCommentDirectives() {
          commentDirectives = void 0;
        }
        function setText(newText, start2, length2) {
          text = newText || "";
          end = length2 === void 0 ? text.length : start2 + length2;
          setTextPos(start2 || 0);
        }
        function setOnError(errorCallback) {
          onError = errorCallback;
        }
        function setScriptTarget(scriptTarget) {
          languageVersion = scriptTarget;
        }
        function setLanguageVariant(variant) {
          languageVariant = variant;
        }
        function setTextPos(textPos) {
          ts3.Debug.assert(textPos >= 0);
          pos = textPos;
          startPos = textPos;
          tokenPos = textPos;
          token = 0;
          tokenValue = void 0;
          tokenFlags = 0;
        }
        function setInJSDocType(inType) {
          inJSDocType += inType ? 1 : -1;
        }
      }
      ts3.createScanner = createScanner;
      var codePointAt2 = String.prototype.codePointAt ? function(s2, i3) {
        return s2.codePointAt(i3);
      } : function codePointAt3(str2, i3) {
        var size = str2.length;
        if (i3 < 0 || i3 >= size) {
          return void 0;
        }
        var first = str2.charCodeAt(i3);
        if (first >= 55296 && first <= 56319 && size > i3 + 1) {
          var second = str2.charCodeAt(i3 + 1);
          if (second >= 56320 && second <= 57343) {
            return (first - 55296) * 1024 + second - 56320 + 65536;
          }
        }
        return first;
      };
      function charSize(ch) {
        if (ch >= 65536) {
          return 2;
        }
        return 1;
      }
      function utf16EncodeAsStringFallback(codePoint) {
        ts3.Debug.assert(0 <= codePoint && codePoint <= 1114111);
        if (codePoint <= 65535) {
          return String.fromCharCode(codePoint);
        }
        var codeUnit1 = Math.floor((codePoint - 65536) / 1024) + 55296;
        var codeUnit2 = (codePoint - 65536) % 1024 + 56320;
        return String.fromCharCode(codeUnit1, codeUnit2);
      }
      var utf16EncodeAsStringWorker = String.fromCodePoint ? function(codePoint) {
        return String.fromCodePoint(codePoint);
      } : utf16EncodeAsStringFallback;
      function utf16EncodeAsString(codePoint) {
        return utf16EncodeAsStringWorker(codePoint);
      }
      ts3.utf16EncodeAsString = utf16EncodeAsString;
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      function isExternalModuleNameRelative(moduleName) {
        return ts3.pathIsRelative(moduleName) || ts3.isRootedDiskPath(moduleName);
      }
      ts3.isExternalModuleNameRelative = isExternalModuleNameRelative;
      function sortAndDeduplicateDiagnostics(diagnostics) {
        return ts3.sortAndDeduplicate(diagnostics, ts3.compareDiagnostics);
      }
      ts3.sortAndDeduplicateDiagnostics = sortAndDeduplicateDiagnostics;
      function getDefaultLibFileName(options) {
        switch (options.target) {
          case 99:
            return "lib.esnext.full.d.ts";
          case 8:
            return "lib.es2021.full.d.ts";
          case 7:
            return "lib.es2020.full.d.ts";
          case 6:
            return "lib.es2019.full.d.ts";
          case 5:
            return "lib.es2018.full.d.ts";
          case 4:
            return "lib.es2017.full.d.ts";
          case 3:
            return "lib.es2016.full.d.ts";
          case 2:
            return "lib.es6.d.ts";
          default:
            return "lib.d.ts";
        }
      }
      ts3.getDefaultLibFileName = getDefaultLibFileName;
      function textSpanEnd(span) {
        return span.start + span.length;
      }
      ts3.textSpanEnd = textSpanEnd;
      function textSpanIsEmpty(span) {
        return span.length === 0;
      }
      ts3.textSpanIsEmpty = textSpanIsEmpty;
      function textSpanContainsPosition(span, position) {
        return position >= span.start && position < textSpanEnd(span);
      }
      ts3.textSpanContainsPosition = textSpanContainsPosition;
      function textRangeContainsPositionInclusive(span, position) {
        return position >= span.pos && position <= span.end;
      }
      ts3.textRangeContainsPositionInclusive = textRangeContainsPositionInclusive;
      function textSpanContainsTextSpan(span, other) {
        return other.start >= span.start && textSpanEnd(other) <= textSpanEnd(span);
      }
      ts3.textSpanContainsTextSpan = textSpanContainsTextSpan;
      function textSpanOverlapsWith(span, other) {
        return textSpanOverlap(span, other) !== void 0;
      }
      ts3.textSpanOverlapsWith = textSpanOverlapsWith;
      function textSpanOverlap(span1, span2) {
        var overlap = textSpanIntersection(span1, span2);
        return overlap && overlap.length === 0 ? void 0 : overlap;
      }
      ts3.textSpanOverlap = textSpanOverlap;
      function textSpanIntersectsWithTextSpan(span, other) {
        return decodedTextSpanIntersectsWith(span.start, span.length, other.start, other.length);
      }
      ts3.textSpanIntersectsWithTextSpan = textSpanIntersectsWithTextSpan;
      function textSpanIntersectsWith(span, start, length) {
        return decodedTextSpanIntersectsWith(span.start, span.length, start, length);
      }
      ts3.textSpanIntersectsWith = textSpanIntersectsWith;
      function decodedTextSpanIntersectsWith(start1, length1, start2, length2) {
        var end1 = start1 + length1;
        var end2 = start2 + length2;
        return start2 <= end1 && end2 >= start1;
      }
      ts3.decodedTextSpanIntersectsWith = decodedTextSpanIntersectsWith;
      function textSpanIntersectsWithPosition(span, position) {
        return position <= textSpanEnd(span) && position >= span.start;
      }
      ts3.textSpanIntersectsWithPosition = textSpanIntersectsWithPosition;
      function textSpanIntersection(span1, span2) {
        var start = Math.max(span1.start, span2.start);
        var end = Math.min(textSpanEnd(span1), textSpanEnd(span2));
        return start <= end ? createTextSpanFromBounds(start, end) : void 0;
      }
      ts3.textSpanIntersection = textSpanIntersection;
      function createTextSpan(start, length) {
        if (start < 0) {
          throw new Error("start < 0");
        }
        if (length < 0) {
          throw new Error("length < 0");
        }
        return { start, length };
      }
      ts3.createTextSpan = createTextSpan;
      function createTextSpanFromBounds(start, end) {
        return createTextSpan(start, end - start);
      }
      ts3.createTextSpanFromBounds = createTextSpanFromBounds;
      function textChangeRangeNewSpan(range) {
        return createTextSpan(range.span.start, range.newLength);
      }
      ts3.textChangeRangeNewSpan = textChangeRangeNewSpan;
      function textChangeRangeIsUnchanged(range) {
        return textSpanIsEmpty(range.span) && range.newLength === 0;
      }
      ts3.textChangeRangeIsUnchanged = textChangeRangeIsUnchanged;
      function createTextChangeRange(span, newLength) {
        if (newLength < 0) {
          throw new Error("newLength < 0");
        }
        return { span, newLength };
      }
      ts3.createTextChangeRange = createTextChangeRange;
      ts3.unchangedTextChangeRange = createTextChangeRange(createTextSpan(0, 0), 0);
      function collapseTextChangeRangesAcrossMultipleVersions(changes) {
        if (changes.length === 0) {
          return ts3.unchangedTextChangeRange;
        }
        if (changes.length === 1) {
          return changes[0];
        }
        var change0 = changes[0];
        var oldStartN = change0.span.start;
        var oldEndN = textSpanEnd(change0.span);
        var newEndN = oldStartN + change0.newLength;
        for (var i3 = 1; i3 < changes.length; i3++) {
          var nextChange = changes[i3];
          var oldStart1 = oldStartN;
          var oldEnd1 = oldEndN;
          var newEnd1 = newEndN;
          var oldStart2 = nextChange.span.start;
          var oldEnd2 = textSpanEnd(nextChange.span);
          var newEnd2 = oldStart2 + nextChange.newLength;
          oldStartN = Math.min(oldStart1, oldStart2);
          oldEndN = Math.max(oldEnd1, oldEnd1 + (oldEnd2 - newEnd1));
          newEndN = Math.max(newEnd2, newEnd2 + (newEnd1 - oldEnd2));
        }
        return createTextChangeRange(createTextSpanFromBounds(oldStartN, oldEndN), newEndN - oldStartN);
      }
      ts3.collapseTextChangeRangesAcrossMultipleVersions = collapseTextChangeRangesAcrossMultipleVersions;
      function getTypeParameterOwner(d) {
        if (d && d.kind === 160) {
          for (var current = d; current; current = current.parent) {
            if (isFunctionLike(current) || isClassLike(current) || current.kind === 254) {
              return current;
            }
          }
        }
      }
      ts3.getTypeParameterOwner = getTypeParameterOwner;
      function isParameterPropertyDeclaration(node, parent) {
        return ts3.hasSyntacticModifier(node, 16476) && parent.kind === 167;
      }
      ts3.isParameterPropertyDeclaration = isParameterPropertyDeclaration;
      function isEmptyBindingPattern(node) {
        if (isBindingPattern(node)) {
          return ts3.every(node.elements, isEmptyBindingElement);
        }
        return false;
      }
      ts3.isEmptyBindingPattern = isEmptyBindingPattern;
      function isEmptyBindingElement(node) {
        if (ts3.isOmittedExpression(node)) {
          return true;
        }
        return isEmptyBindingPattern(node.name);
      }
      ts3.isEmptyBindingElement = isEmptyBindingElement;
      function walkUpBindingElementsAndPatterns(binding) {
        var node = binding.parent;
        while (ts3.isBindingElement(node.parent)) {
          node = node.parent.parent;
        }
        return node.parent;
      }
      ts3.walkUpBindingElementsAndPatterns = walkUpBindingElementsAndPatterns;
      function getCombinedFlags(node, getFlags) {
        if (ts3.isBindingElement(node)) {
          node = walkUpBindingElementsAndPatterns(node);
        }
        var flags = getFlags(node);
        if (node.kind === 250) {
          node = node.parent;
        }
        if (node && node.kind === 251) {
          flags |= getFlags(node);
          node = node.parent;
        }
        if (node && node.kind === 233) {
          flags |= getFlags(node);
        }
        return flags;
      }
      function getCombinedModifierFlags(node) {
        return getCombinedFlags(node, ts3.getEffectiveModifierFlags);
      }
      ts3.getCombinedModifierFlags = getCombinedModifierFlags;
      function getCombinedNodeFlagsAlwaysIncludeJSDoc(node) {
        return getCombinedFlags(node, ts3.getEffectiveModifierFlagsAlwaysIncludeJSDoc);
      }
      ts3.getCombinedNodeFlagsAlwaysIncludeJSDoc = getCombinedNodeFlagsAlwaysIncludeJSDoc;
      function getCombinedNodeFlags(node) {
        return getCombinedFlags(node, function(n2) {
          return n2.flags;
        });
      }
      ts3.getCombinedNodeFlags = getCombinedNodeFlags;
      ts3.supportedLocaleDirectories = ["cs", "de", "es", "fr", "it", "ja", "ko", "pl", "pt-br", "ru", "tr", "zh-cn", "zh-tw"];
      function validateLocaleAndSetLanguage(locale, sys, errors) {
        var lowerCaseLocale = locale.toLowerCase();
        var matchResult = /^([a-z]+)([_\-]([a-z]+))?$/.exec(lowerCaseLocale);
        if (!matchResult) {
          if (errors) {
            errors.push(ts3.createCompilerDiagnostic(ts3.Diagnostics.Locale_must_be_of_the_form_language_or_language_territory_For_example_0_or_1, "en", "ja-jp"));
          }
          return;
        }
        var language = matchResult[1];
        var territory = matchResult[3];
        if (ts3.contains(ts3.supportedLocaleDirectories, lowerCaseLocale) && !trySetLanguageAndTerritory(language, territory, errors)) {
          trySetLanguageAndTerritory(language, void 0, errors);
        }
        ts3.setUILocale(locale);
        function trySetLanguageAndTerritory(language2, territory2, errors2) {
          var compilerFilePath = ts3.normalizePath(sys.getExecutingFilePath());
          var containingDirectoryPath = ts3.getDirectoryPath(compilerFilePath);
          var filePath = ts3.combinePaths(containingDirectoryPath, language2);
          if (territory2) {
            filePath = filePath + "-" + territory2;
          }
          filePath = sys.resolvePath(ts3.combinePaths(filePath, "diagnosticMessages.generated.json"));
          if (!sys.fileExists(filePath)) {
            return false;
          }
          var fileContents = "";
          try {
            fileContents = sys.readFile(filePath);
          } catch (e2) {
            if (errors2) {
              errors2.push(ts3.createCompilerDiagnostic(ts3.Diagnostics.Unable_to_open_file_0, filePath));
            }
            return false;
          }
          try {
            ts3.setLocalizedDiagnosticMessages(JSON.parse(fileContents));
          } catch (_a2) {
            if (errors2) {
              errors2.push(ts3.createCompilerDiagnostic(ts3.Diagnostics.Corrupted_locale_file_0, filePath));
            }
            return false;
          }
          return true;
        }
      }
      ts3.validateLocaleAndSetLanguage = validateLocaleAndSetLanguage;
      function getOriginalNode(node, nodeTest) {
        if (node) {
          while (node.original !== void 0) {
            node = node.original;
          }
        }
        return !nodeTest || nodeTest(node) ? node : void 0;
      }
      ts3.getOriginalNode = getOriginalNode;
      function findAncestor(node, callback) {
        while (node) {
          var result2 = callback(node);
          if (result2 === "quit") {
            return void 0;
          } else if (result2) {
            return node;
          }
          node = node.parent;
        }
        return void 0;
      }
      ts3.findAncestor = findAncestor;
      function isParseTreeNode(node) {
        return (node.flags & 8) === 0;
      }
      ts3.isParseTreeNode = isParseTreeNode;
      function getParseTreeNode(node, nodeTest) {
        if (node === void 0 || isParseTreeNode(node)) {
          return node;
        }
        node = node.original;
        while (node) {
          if (isParseTreeNode(node)) {
            return !nodeTest || nodeTest(node) ? node : void 0;
          }
          node = node.original;
        }
      }
      ts3.getParseTreeNode = getParseTreeNode;
      function escapeLeadingUnderscores(identifier) {
        return identifier.length >= 2 && identifier.charCodeAt(0) === 95 && identifier.charCodeAt(1) === 95 ? "_" + identifier : identifier;
      }
      ts3.escapeLeadingUnderscores = escapeLeadingUnderscores;
      function unescapeLeadingUnderscores(identifier) {
        var id = identifier;
        return id.length >= 3 && id.charCodeAt(0) === 95 && id.charCodeAt(1) === 95 && id.charCodeAt(2) === 95 ? id.substr(1) : id;
      }
      ts3.unescapeLeadingUnderscores = unescapeLeadingUnderscores;
      function idText(identifierOrPrivateName) {
        return unescapeLeadingUnderscores(identifierOrPrivateName.escapedText);
      }
      ts3.idText = idText;
      function symbolName(symbol) {
        if (symbol.valueDeclaration && isPrivateIdentifierClassElementDeclaration(symbol.valueDeclaration)) {
          return idText(symbol.valueDeclaration.name);
        }
        return unescapeLeadingUnderscores(symbol.escapedName);
      }
      ts3.symbolName = symbolName;
      function nameForNamelessJSDocTypedef(declaration) {
        var hostNode = declaration.parent.parent;
        if (!hostNode) {
          return void 0;
        }
        if (isDeclaration(hostNode)) {
          return getDeclarationIdentifier(hostNode);
        }
        switch (hostNode.kind) {
          case 233:
            if (hostNode.declarationList && hostNode.declarationList.declarations[0]) {
              return getDeclarationIdentifier(hostNode.declarationList.declarations[0]);
            }
            break;
          case 234:
            var expr = hostNode.expression;
            if (expr.kind === 217 && expr.operatorToken.kind === 62) {
              expr = expr.left;
            }
            switch (expr.kind) {
              case 202:
                return expr.name;
              case 203:
                var arg2 = expr.argumentExpression;
                if (ts3.isIdentifier(arg2)) {
                  return arg2;
                }
            }
            break;
          case 208: {
            return getDeclarationIdentifier(hostNode.expression);
          }
          case 246: {
            if (isDeclaration(hostNode.statement) || isExpression(hostNode.statement)) {
              return getDeclarationIdentifier(hostNode.statement);
            }
            break;
          }
        }
      }
      function getDeclarationIdentifier(node) {
        var name = getNameOfDeclaration(node);
        return name && ts3.isIdentifier(name) ? name : void 0;
      }
      function nodeHasName(statement, name) {
        if (isNamedDeclaration(statement) && ts3.isIdentifier(statement.name) && idText(statement.name) === idText(name)) {
          return true;
        }
        if (ts3.isVariableStatement(statement) && ts3.some(statement.declarationList.declarations, function(d) {
          return nodeHasName(d, name);
        })) {
          return true;
        }
        return false;
      }
      ts3.nodeHasName = nodeHasName;
      function getNameOfJSDocTypedef(declaration) {
        return declaration.name || nameForNamelessJSDocTypedef(declaration);
      }
      ts3.getNameOfJSDocTypedef = getNameOfJSDocTypedef;
      function isNamedDeclaration(node) {
        return !!node.name;
      }
      ts3.isNamedDeclaration = isNamedDeclaration;
      function getNonAssignedNameOfDeclaration(declaration) {
        switch (declaration.kind) {
          case 78:
            return declaration;
          case 337:
          case 330: {
            var name = declaration.name;
            if (name.kind === 158) {
              return name.right;
            }
            break;
          }
          case 204:
          case 217: {
            var expr_1 = declaration;
            switch (ts3.getAssignmentDeclarationKind(expr_1)) {
              case 1:
              case 4:
              case 5:
              case 3:
                return ts3.getElementOrPropertyAccessArgumentExpressionOrName(expr_1.left);
              case 7:
              case 8:
              case 9:
                return expr_1.arguments[1];
              default:
                return void 0;
            }
          }
          case 335:
            return getNameOfJSDocTypedef(declaration);
          case 329:
            return nameForNamelessJSDocTypedef(declaration);
          case 267: {
            var expression = declaration.expression;
            return ts3.isIdentifier(expression) ? expression : void 0;
          }
          case 203:
            var expr = declaration;
            if (ts3.isBindableStaticElementAccessExpression(expr)) {
              return expr.argumentExpression;
            }
        }
        return declaration.name;
      }
      ts3.getNonAssignedNameOfDeclaration = getNonAssignedNameOfDeclaration;
      function getNameOfDeclaration(declaration) {
        if (declaration === void 0)
          return void 0;
        return getNonAssignedNameOfDeclaration(declaration) || (ts3.isFunctionExpression(declaration) || ts3.isArrowFunction(declaration) || ts3.isClassExpression(declaration) ? getAssignedName(declaration) : void 0);
      }
      ts3.getNameOfDeclaration = getNameOfDeclaration;
      function getAssignedName(node) {
        if (!node.parent) {
          return void 0;
        } else if (ts3.isPropertyAssignment(node.parent) || ts3.isBindingElement(node.parent)) {
          return node.parent.name;
        } else if (ts3.isBinaryExpression(node.parent) && node === node.parent.right) {
          if (ts3.isIdentifier(node.parent.left)) {
            return node.parent.left;
          } else if (ts3.isAccessExpression(node.parent.left)) {
            return ts3.getElementOrPropertyAccessArgumentExpressionOrName(node.parent.left);
          }
        } else if (ts3.isVariableDeclaration(node.parent) && ts3.isIdentifier(node.parent.name)) {
          return node.parent.name;
        }
      }
      ts3.getAssignedName = getAssignedName;
      function getJSDocParameterTagsWorker(param, noCache) {
        if (param.name) {
          if (ts3.isIdentifier(param.name)) {
            var name_1 = param.name.escapedText;
            return getJSDocTagsWorker(param.parent, noCache).filter(function(tag) {
              return ts3.isJSDocParameterTag(tag) && ts3.isIdentifier(tag.name) && tag.name.escapedText === name_1;
            });
          } else {
            var i3 = param.parent.parameters.indexOf(param);
            ts3.Debug.assert(i3 > -1, "Parameters should always be in their parents' parameter list");
            var paramTags = getJSDocTagsWorker(param.parent, noCache).filter(ts3.isJSDocParameterTag);
            if (i3 < paramTags.length) {
              return [paramTags[i3]];
            }
          }
        }
        return ts3.emptyArray;
      }
      function getJSDocParameterTags(param) {
        return getJSDocParameterTagsWorker(param, false);
      }
      ts3.getJSDocParameterTags = getJSDocParameterTags;
      function getJSDocParameterTagsNoCache(param) {
        return getJSDocParameterTagsWorker(param, true);
      }
      ts3.getJSDocParameterTagsNoCache = getJSDocParameterTagsNoCache;
      function getJSDocTypeParameterTagsWorker(param, noCache) {
        var name = param.name.escapedText;
        return getJSDocTagsWorker(param.parent, noCache).filter(function(tag) {
          return ts3.isJSDocTemplateTag(tag) && tag.typeParameters.some(function(tp) {
            return tp.name.escapedText === name;
          });
        });
      }
      function getJSDocTypeParameterTags(param) {
        return getJSDocTypeParameterTagsWorker(param, false);
      }
      ts3.getJSDocTypeParameterTags = getJSDocTypeParameterTags;
      function getJSDocTypeParameterTagsNoCache(param) {
        return getJSDocTypeParameterTagsWorker(param, true);
      }
      ts3.getJSDocTypeParameterTagsNoCache = getJSDocTypeParameterTagsNoCache;
      function hasJSDocParameterTags(node) {
        return !!getFirstJSDocTag(node, ts3.isJSDocParameterTag);
      }
      ts3.hasJSDocParameterTags = hasJSDocParameterTags;
      function getJSDocAugmentsTag(node) {
        return getFirstJSDocTag(node, ts3.isJSDocAugmentsTag);
      }
      ts3.getJSDocAugmentsTag = getJSDocAugmentsTag;
      function getJSDocImplementsTags(node) {
        return getAllJSDocTags(node, ts3.isJSDocImplementsTag);
      }
      ts3.getJSDocImplementsTags = getJSDocImplementsTags;
      function getJSDocClassTag(node) {
        return getFirstJSDocTag(node, ts3.isJSDocClassTag);
      }
      ts3.getJSDocClassTag = getJSDocClassTag;
      function getJSDocPublicTag(node) {
        return getFirstJSDocTag(node, ts3.isJSDocPublicTag);
      }
      ts3.getJSDocPublicTag = getJSDocPublicTag;
      function getJSDocPublicTagNoCache(node) {
        return getFirstJSDocTag(node, ts3.isJSDocPublicTag, true);
      }
      ts3.getJSDocPublicTagNoCache = getJSDocPublicTagNoCache;
      function getJSDocPrivateTag(node) {
        return getFirstJSDocTag(node, ts3.isJSDocPrivateTag);
      }
      ts3.getJSDocPrivateTag = getJSDocPrivateTag;
      function getJSDocPrivateTagNoCache(node) {
        return getFirstJSDocTag(node, ts3.isJSDocPrivateTag, true);
      }
      ts3.getJSDocPrivateTagNoCache = getJSDocPrivateTagNoCache;
      function getJSDocProtectedTag(node) {
        return getFirstJSDocTag(node, ts3.isJSDocProtectedTag);
      }
      ts3.getJSDocProtectedTag = getJSDocProtectedTag;
      function getJSDocProtectedTagNoCache(node) {
        return getFirstJSDocTag(node, ts3.isJSDocProtectedTag, true);
      }
      ts3.getJSDocProtectedTagNoCache = getJSDocProtectedTagNoCache;
      function getJSDocReadonlyTag(node) {
        return getFirstJSDocTag(node, ts3.isJSDocReadonlyTag);
      }
      ts3.getJSDocReadonlyTag = getJSDocReadonlyTag;
      function getJSDocReadonlyTagNoCache(node) {
        return getFirstJSDocTag(node, ts3.isJSDocReadonlyTag, true);
      }
      ts3.getJSDocReadonlyTagNoCache = getJSDocReadonlyTagNoCache;
      function getJSDocOverrideTagNoCache(node) {
        return getFirstJSDocTag(node, ts3.isJSDocOverrideTag, true);
      }
      ts3.getJSDocOverrideTagNoCache = getJSDocOverrideTagNoCache;
      function getJSDocDeprecatedTag(node) {
        return getFirstJSDocTag(node, ts3.isJSDocDeprecatedTag);
      }
      ts3.getJSDocDeprecatedTag = getJSDocDeprecatedTag;
      function getJSDocDeprecatedTagNoCache(node) {
        return getFirstJSDocTag(node, ts3.isJSDocDeprecatedTag, true);
      }
      ts3.getJSDocDeprecatedTagNoCache = getJSDocDeprecatedTagNoCache;
      function getJSDocEnumTag(node) {
        return getFirstJSDocTag(node, ts3.isJSDocEnumTag);
      }
      ts3.getJSDocEnumTag = getJSDocEnumTag;
      function getJSDocThisTag(node) {
        return getFirstJSDocTag(node, ts3.isJSDocThisTag);
      }
      ts3.getJSDocThisTag = getJSDocThisTag;
      function getJSDocReturnTag(node) {
        return getFirstJSDocTag(node, ts3.isJSDocReturnTag);
      }
      ts3.getJSDocReturnTag = getJSDocReturnTag;
      function getJSDocTemplateTag(node) {
        return getFirstJSDocTag(node, ts3.isJSDocTemplateTag);
      }
      ts3.getJSDocTemplateTag = getJSDocTemplateTag;
      function getJSDocTypeTag(node) {
        var tag = getFirstJSDocTag(node, ts3.isJSDocTypeTag);
        if (tag && tag.typeExpression && tag.typeExpression.type) {
          return tag;
        }
        return void 0;
      }
      ts3.getJSDocTypeTag = getJSDocTypeTag;
      function getJSDocType(node) {
        var tag = getFirstJSDocTag(node, ts3.isJSDocTypeTag);
        if (!tag && ts3.isParameter(node)) {
          tag = ts3.find(getJSDocParameterTags(node), function(tag2) {
            return !!tag2.typeExpression;
          });
        }
        return tag && tag.typeExpression && tag.typeExpression.type;
      }
      ts3.getJSDocType = getJSDocType;
      function getJSDocReturnType(node) {
        var returnTag = getJSDocReturnTag(node);
        if (returnTag && returnTag.typeExpression) {
          return returnTag.typeExpression.type;
        }
        var typeTag = getJSDocTypeTag(node);
        if (typeTag && typeTag.typeExpression) {
          var type3 = typeTag.typeExpression.type;
          if (ts3.isTypeLiteralNode(type3)) {
            var sig = ts3.find(type3.members, ts3.isCallSignatureDeclaration);
            return sig && sig.type;
          }
          if (ts3.isFunctionTypeNode(type3) || ts3.isJSDocFunctionType(type3)) {
            return type3.type;
          }
        }
      }
      ts3.getJSDocReturnType = getJSDocReturnType;
      function getJSDocTagsWorker(node, noCache) {
        var tags = node.jsDocCache;
        if (tags === void 0 || noCache) {
          var comments = ts3.getJSDocCommentsAndTags(node, noCache);
          ts3.Debug.assert(comments.length < 2 || comments[0] !== comments[1]);
          tags = ts3.flatMap(comments, function(j) {
            return ts3.isJSDoc(j) ? j.tags : j;
          });
          if (!noCache) {
            node.jsDocCache = tags;
          }
        }
        return tags;
      }
      function getJSDocTags(node) {
        return getJSDocTagsWorker(node, false);
      }
      ts3.getJSDocTags = getJSDocTags;
      function getJSDocTagsNoCache(node) {
        return getJSDocTagsWorker(node, true);
      }
      ts3.getJSDocTagsNoCache = getJSDocTagsNoCache;
      function getFirstJSDocTag(node, predicate, noCache) {
        return ts3.find(getJSDocTagsWorker(node, noCache), predicate);
      }
      function getAllJSDocTags(node, predicate) {
        return getJSDocTags(node).filter(predicate);
      }
      ts3.getAllJSDocTags = getAllJSDocTags;
      function getAllJSDocTagsOfKind(node, kind) {
        return getJSDocTags(node).filter(function(doc) {
          return doc.kind === kind;
        });
      }
      ts3.getAllJSDocTagsOfKind = getAllJSDocTagsOfKind;
      function getTextOfJSDocComment(comment) {
        return typeof comment === "string" ? comment : comment === null || comment === void 0 ? void 0 : comment.map(function(c2) {
          return c2.kind === 313 ? c2.text : "{@link " + (c2.name ? ts3.entityNameToString(c2.name) + " " : "") + c2.text + "}";
        }).join("");
      }
      ts3.getTextOfJSDocComment = getTextOfJSDocComment;
      function getEffectiveTypeParameterDeclarations(node) {
        if (ts3.isJSDocSignature(node)) {
          return ts3.emptyArray;
        }
        if (ts3.isJSDocTypeAlias(node)) {
          ts3.Debug.assert(node.parent.kind === 312);
          return ts3.flatMap(node.parent.tags, function(tag) {
            return ts3.isJSDocTemplateTag(tag) ? tag.typeParameters : void 0;
          });
        }
        if (node.typeParameters) {
          return node.typeParameters;
        }
        if (ts3.isInJSFile(node)) {
          var decls = ts3.getJSDocTypeParameterDeclarations(node);
          if (decls.length) {
            return decls;
          }
          var typeTag = getJSDocType(node);
          if (typeTag && ts3.isFunctionTypeNode(typeTag) && typeTag.typeParameters) {
            return typeTag.typeParameters;
          }
        }
        return ts3.emptyArray;
      }
      ts3.getEffectiveTypeParameterDeclarations = getEffectiveTypeParameterDeclarations;
      function getEffectiveConstraintOfTypeParameter(node) {
        return node.constraint ? node.constraint : ts3.isJSDocTemplateTag(node.parent) && node === node.parent.typeParameters[0] ? node.parent.constraint : void 0;
      }
      ts3.getEffectiveConstraintOfTypeParameter = getEffectiveConstraintOfTypeParameter;
      function isMemberName(node) {
        return node.kind === 78 || node.kind === 79;
      }
      ts3.isMemberName = isMemberName;
      function isGetOrSetAccessorDeclaration(node) {
        return node.kind === 169 || node.kind === 168;
      }
      ts3.isGetOrSetAccessorDeclaration = isGetOrSetAccessorDeclaration;
      function isPropertyAccessChain(node) {
        return ts3.isPropertyAccessExpression(node) && !!(node.flags & 32);
      }
      ts3.isPropertyAccessChain = isPropertyAccessChain;
      function isElementAccessChain(node) {
        return ts3.isElementAccessExpression(node) && !!(node.flags & 32);
      }
      ts3.isElementAccessChain = isElementAccessChain;
      function isCallChain(node) {
        return ts3.isCallExpression(node) && !!(node.flags & 32);
      }
      ts3.isCallChain = isCallChain;
      function isOptionalChain(node) {
        var kind = node.kind;
        return !!(node.flags & 32) && (kind === 202 || kind === 203 || kind === 204 || kind === 226);
      }
      ts3.isOptionalChain = isOptionalChain;
      function isOptionalChainRoot(node) {
        return isOptionalChain(node) && !ts3.isNonNullExpression(node) && !!node.questionDotToken;
      }
      ts3.isOptionalChainRoot = isOptionalChainRoot;
      function isExpressionOfOptionalChainRoot(node) {
        return isOptionalChainRoot(node.parent) && node.parent.expression === node;
      }
      ts3.isExpressionOfOptionalChainRoot = isExpressionOfOptionalChainRoot;
      function isOutermostOptionalChain(node) {
        return !isOptionalChain(node.parent) || isOptionalChainRoot(node.parent) || node !== node.parent.expression;
      }
      ts3.isOutermostOptionalChain = isOutermostOptionalChain;
      function isNullishCoalesce(node) {
        return node.kind === 217 && node.operatorToken.kind === 60;
      }
      ts3.isNullishCoalesce = isNullishCoalesce;
      function isConstTypeReference(node) {
        return ts3.isTypeReferenceNode(node) && ts3.isIdentifier(node.typeName) && node.typeName.escapedText === "const" && !node.typeArguments;
      }
      ts3.isConstTypeReference = isConstTypeReference;
      function skipPartiallyEmittedExpressions(node) {
        return ts3.skipOuterExpressions(node, 8);
      }
      ts3.skipPartiallyEmittedExpressions = skipPartiallyEmittedExpressions;
      function isNonNullChain(node) {
        return ts3.isNonNullExpression(node) && !!(node.flags & 32);
      }
      ts3.isNonNullChain = isNonNullChain;
      function isBreakOrContinueStatement(node) {
        return node.kind === 242 || node.kind === 241;
      }
      ts3.isBreakOrContinueStatement = isBreakOrContinueStatement;
      function isNamedExportBindings(node) {
        return node.kind === 270 || node.kind === 269;
      }
      ts3.isNamedExportBindings = isNamedExportBindings;
      function isUnparsedTextLike(node) {
        switch (node.kind) {
          case 295:
          case 296:
            return true;
          default:
            return false;
        }
      }
      ts3.isUnparsedTextLike = isUnparsedTextLike;
      function isUnparsedNode(node) {
        return isUnparsedTextLike(node) || node.kind === 293 || node.kind === 297;
      }
      ts3.isUnparsedNode = isUnparsedNode;
      function isJSDocPropertyLikeTag(node) {
        return node.kind === 337 || node.kind === 330;
      }
      ts3.isJSDocPropertyLikeTag = isJSDocPropertyLikeTag;
      function isNode(node) {
        return isNodeKind(node.kind);
      }
      ts3.isNode = isNode;
      function isNodeKind(kind) {
        return kind >= 158;
      }
      ts3.isNodeKind = isNodeKind;
      function isTokenKind(kind) {
        return kind >= 0 && kind <= 157;
      }
      ts3.isTokenKind = isTokenKind;
      function isToken(n2) {
        return isTokenKind(n2.kind);
      }
      ts3.isToken = isToken;
      function isNodeArray(array) {
        return array.hasOwnProperty("pos") && array.hasOwnProperty("end");
      }
      ts3.isNodeArray = isNodeArray;
      function isLiteralKind(kind) {
        return 8 <= kind && kind <= 14;
      }
      ts3.isLiteralKind = isLiteralKind;
      function isLiteralExpression(node) {
        return isLiteralKind(node.kind);
      }
      ts3.isLiteralExpression = isLiteralExpression;
      function isTemplateLiteralKind(kind) {
        return 14 <= kind && kind <= 17;
      }
      ts3.isTemplateLiteralKind = isTemplateLiteralKind;
      function isTemplateLiteralToken(node) {
        return isTemplateLiteralKind(node.kind);
      }
      ts3.isTemplateLiteralToken = isTemplateLiteralToken;
      function isTemplateMiddleOrTemplateTail(node) {
        var kind = node.kind;
        return kind === 16 || kind === 17;
      }
      ts3.isTemplateMiddleOrTemplateTail = isTemplateMiddleOrTemplateTail;
      function isImportOrExportSpecifier(node) {
        return ts3.isImportSpecifier(node) || ts3.isExportSpecifier(node);
      }
      ts3.isImportOrExportSpecifier = isImportOrExportSpecifier;
      function isTypeOnlyImportOrExportDeclaration(node) {
        switch (node.kind) {
          case 266:
          case 271:
            return node.parent.parent.isTypeOnly;
          case 264:
            return node.parent.isTypeOnly;
          case 263:
          case 261:
            return node.isTypeOnly;
          default:
            return false;
        }
      }
      ts3.isTypeOnlyImportOrExportDeclaration = isTypeOnlyImportOrExportDeclaration;
      function isStringTextContainingNode(node) {
        return node.kind === 10 || isTemplateLiteralKind(node.kind);
      }
      ts3.isStringTextContainingNode = isStringTextContainingNode;
      function isGeneratedIdentifier(node) {
        return ts3.isIdentifier(node) && (node.autoGenerateFlags & 7) > 0;
      }
      ts3.isGeneratedIdentifier = isGeneratedIdentifier;
      function isPrivateIdentifierClassElementDeclaration(node) {
        return (ts3.isPropertyDeclaration(node) || isMethodOrAccessor(node)) && ts3.isPrivateIdentifier(node.name);
      }
      ts3.isPrivateIdentifierClassElementDeclaration = isPrivateIdentifierClassElementDeclaration;
      function isPrivateIdentifierPropertyAccessExpression(node) {
        return ts3.isPropertyAccessExpression(node) && ts3.isPrivateIdentifier(node.name);
      }
      ts3.isPrivateIdentifierPropertyAccessExpression = isPrivateIdentifierPropertyAccessExpression;
      function isModifierKind(token) {
        switch (token) {
          case 125:
          case 129:
          case 84:
          case 133:
          case 87:
          case 92:
          case 122:
          case 120:
          case 121:
          case 142:
          case 123:
          case 156:
            return true;
        }
        return false;
      }
      ts3.isModifierKind = isModifierKind;
      function isParameterPropertyModifier(kind) {
        return !!(ts3.modifierToFlag(kind) & 16476);
      }
      ts3.isParameterPropertyModifier = isParameterPropertyModifier;
      function isClassMemberModifier(idToken) {
        return isParameterPropertyModifier(idToken) || idToken === 123 || idToken === 156;
      }
      ts3.isClassMemberModifier = isClassMemberModifier;
      function isModifier(node) {
        return isModifierKind(node.kind);
      }
      ts3.isModifier = isModifier;
      function isEntityName(node) {
        var kind = node.kind;
        return kind === 158 || kind === 78;
      }
      ts3.isEntityName = isEntityName;
      function isPropertyName(node) {
        var kind = node.kind;
        return kind === 78 || kind === 79 || kind === 10 || kind === 8 || kind === 159;
      }
      ts3.isPropertyName = isPropertyName;
      function isBindingName(node) {
        var kind = node.kind;
        return kind === 78 || kind === 197 || kind === 198;
      }
      ts3.isBindingName = isBindingName;
      function isFunctionLike(node) {
        return !!node && isFunctionLikeKind(node.kind);
      }
      ts3.isFunctionLike = isFunctionLike;
      function isFunctionLikeDeclaration(node) {
        return node && isFunctionLikeDeclarationKind(node.kind);
      }
      ts3.isFunctionLikeDeclaration = isFunctionLikeDeclaration;
      function isFunctionLikeDeclarationKind(kind) {
        switch (kind) {
          case 252:
          case 166:
          case 167:
          case 168:
          case 169:
          case 209:
          case 210:
            return true;
          default:
            return false;
        }
      }
      function isFunctionLikeKind(kind) {
        switch (kind) {
          case 165:
          case 170:
          case 315:
          case 171:
          case 172:
          case 175:
          case 309:
          case 176:
            return true;
          default:
            return isFunctionLikeDeclarationKind(kind);
        }
      }
      ts3.isFunctionLikeKind = isFunctionLikeKind;
      function isFunctionOrModuleBlock(node) {
        return ts3.isSourceFile(node) || ts3.isModuleBlock(node) || ts3.isBlock(node) && isFunctionLike(node.parent);
      }
      ts3.isFunctionOrModuleBlock = isFunctionOrModuleBlock;
      function isClassElement(node) {
        var kind = node.kind;
        return kind === 167 || kind === 164 || kind === 166 || kind === 168 || kind === 169 || kind === 172 || kind === 230;
      }
      ts3.isClassElement = isClassElement;
      function isClassLike(node) {
        return node && (node.kind === 253 || node.kind === 222);
      }
      ts3.isClassLike = isClassLike;
      function isAccessor(node) {
        return node && (node.kind === 168 || node.kind === 169);
      }
      ts3.isAccessor = isAccessor;
      function isMethodOrAccessor(node) {
        switch (node.kind) {
          case 166:
          case 168:
          case 169:
            return true;
          default:
            return false;
        }
      }
      ts3.isMethodOrAccessor = isMethodOrAccessor;
      function isTypeElement(node) {
        var kind = node.kind;
        return kind === 171 || kind === 170 || kind === 163 || kind === 165 || kind === 172;
      }
      ts3.isTypeElement = isTypeElement;
      function isClassOrTypeElement(node) {
        return isTypeElement(node) || isClassElement(node);
      }
      ts3.isClassOrTypeElement = isClassOrTypeElement;
      function isObjectLiteralElementLike(node) {
        var kind = node.kind;
        return kind === 289 || kind === 290 || kind === 291 || kind === 166 || kind === 168 || kind === 169;
      }
      ts3.isObjectLiteralElementLike = isObjectLiteralElementLike;
      function isTypeNode(node) {
        return ts3.isTypeNodeKind(node.kind);
      }
      ts3.isTypeNode = isTypeNode;
      function isFunctionOrConstructorTypeNode(node) {
        switch (node.kind) {
          case 175:
          case 176:
            return true;
        }
        return false;
      }
      ts3.isFunctionOrConstructorTypeNode = isFunctionOrConstructorTypeNode;
      function isBindingPattern(node) {
        if (node) {
          var kind = node.kind;
          return kind === 198 || kind === 197;
        }
        return false;
      }
      ts3.isBindingPattern = isBindingPattern;
      function isAssignmentPattern(node) {
        var kind = node.kind;
        return kind === 200 || kind === 201;
      }
      ts3.isAssignmentPattern = isAssignmentPattern;
      function isArrayBindingElement(node) {
        var kind = node.kind;
        return kind === 199 || kind === 223;
      }
      ts3.isArrayBindingElement = isArrayBindingElement;
      function isDeclarationBindingElement(bindingElement) {
        switch (bindingElement.kind) {
          case 250:
          case 161:
          case 199:
            return true;
        }
        return false;
      }
      ts3.isDeclarationBindingElement = isDeclarationBindingElement;
      function isBindingOrAssignmentPattern(node) {
        return isObjectBindingOrAssignmentPattern(node) || isArrayBindingOrAssignmentPattern(node);
      }
      ts3.isBindingOrAssignmentPattern = isBindingOrAssignmentPattern;
      function isObjectBindingOrAssignmentPattern(node) {
        switch (node.kind) {
          case 197:
          case 201:
            return true;
        }
        return false;
      }
      ts3.isObjectBindingOrAssignmentPattern = isObjectBindingOrAssignmentPattern;
      function isArrayBindingOrAssignmentPattern(node) {
        switch (node.kind) {
          case 198:
          case 200:
            return true;
        }
        return false;
      }
      ts3.isArrayBindingOrAssignmentPattern = isArrayBindingOrAssignmentPattern;
      function isPropertyAccessOrQualifiedNameOrImportTypeNode(node) {
        var kind = node.kind;
        return kind === 202 || kind === 158 || kind === 196;
      }
      ts3.isPropertyAccessOrQualifiedNameOrImportTypeNode = isPropertyAccessOrQualifiedNameOrImportTypeNode;
      function isPropertyAccessOrQualifiedName(node) {
        var kind = node.kind;
        return kind === 202 || kind === 158;
      }
      ts3.isPropertyAccessOrQualifiedName = isPropertyAccessOrQualifiedName;
      function isCallLikeExpression(node) {
        switch (node.kind) {
          case 276:
          case 275:
          case 204:
          case 205:
          case 206:
          case 162:
            return true;
          default:
            return false;
        }
      }
      ts3.isCallLikeExpression = isCallLikeExpression;
      function isCallOrNewExpression(node) {
        return node.kind === 204 || node.kind === 205;
      }
      ts3.isCallOrNewExpression = isCallOrNewExpression;
      function isTemplateLiteral(node) {
        var kind = node.kind;
        return kind === 219 || kind === 14;
      }
      ts3.isTemplateLiteral = isTemplateLiteral;
      function isLeftHandSideExpression(node) {
        return isLeftHandSideExpressionKind(skipPartiallyEmittedExpressions(node).kind);
      }
      ts3.isLeftHandSideExpression = isLeftHandSideExpression;
      function isLeftHandSideExpressionKind(kind) {
        switch (kind) {
          case 202:
          case 203:
          case 205:
          case 204:
          case 274:
          case 275:
          case 278:
          case 206:
          case 200:
          case 208:
          case 201:
          case 222:
          case 209:
          case 78:
          case 13:
          case 8:
          case 9:
          case 10:
          case 14:
          case 219:
          case 94:
          case 103:
          case 107:
          case 109:
          case 105:
          case 226:
          case 227:
          case 99:
            return true;
          default:
            return false;
        }
      }
      function isUnaryExpression(node) {
        return isUnaryExpressionKind(skipPartiallyEmittedExpressions(node).kind);
      }
      ts3.isUnaryExpression = isUnaryExpression;
      function isUnaryExpressionKind(kind) {
        switch (kind) {
          case 215:
          case 216:
          case 211:
          case 212:
          case 213:
          case 214:
          case 207:
            return true;
          default:
            return isLeftHandSideExpressionKind(kind);
        }
      }
      function isUnaryExpressionWithWrite(expr) {
        switch (expr.kind) {
          case 216:
            return true;
          case 215:
            return expr.operator === 45 || expr.operator === 46;
          default:
            return false;
        }
      }
      ts3.isUnaryExpressionWithWrite = isUnaryExpressionWithWrite;
      function isExpression(node) {
        return isExpressionKind(skipPartiallyEmittedExpressions(node).kind);
      }
      ts3.isExpression = isExpression;
      function isExpressionKind(kind) {
        switch (kind) {
          case 218:
          case 220:
          case 210:
          case 217:
          case 221:
          case 225:
          case 223:
          case 341:
          case 340:
            return true;
          default:
            return isUnaryExpressionKind(kind);
        }
      }
      function isAssertionExpression(node) {
        var kind = node.kind;
        return kind === 207 || kind === 225;
      }
      ts3.isAssertionExpression = isAssertionExpression;
      function isNotEmittedOrPartiallyEmittedNode(node) {
        return ts3.isNotEmittedStatement(node) || ts3.isPartiallyEmittedExpression(node);
      }
      ts3.isNotEmittedOrPartiallyEmittedNode = isNotEmittedOrPartiallyEmittedNode;
      function isIterationStatement(node, lookInLabeledStatements) {
        switch (node.kind) {
          case 238:
          case 239:
          case 240:
          case 236:
          case 237:
            return true;
          case 246:
            return lookInLabeledStatements && isIterationStatement(node.statement, lookInLabeledStatements);
        }
        return false;
      }
      ts3.isIterationStatement = isIterationStatement;
      function isScopeMarker(node) {
        return ts3.isExportAssignment(node) || ts3.isExportDeclaration(node);
      }
      ts3.isScopeMarker = isScopeMarker;
      function hasScopeMarker(statements) {
        return ts3.some(statements, isScopeMarker);
      }
      ts3.hasScopeMarker = hasScopeMarker;
      function needsScopeMarker(result2) {
        return !ts3.isAnyImportOrReExport(result2) && !ts3.isExportAssignment(result2) && !ts3.hasSyntacticModifier(result2, 1) && !ts3.isAmbientModule(result2);
      }
      ts3.needsScopeMarker = needsScopeMarker;
      function isExternalModuleIndicator(result2) {
        return ts3.isAnyImportOrReExport(result2) || ts3.isExportAssignment(result2) || ts3.hasSyntacticModifier(result2, 1);
      }
      ts3.isExternalModuleIndicator = isExternalModuleIndicator;
      function isForInOrOfStatement(node) {
        return node.kind === 239 || node.kind === 240;
      }
      ts3.isForInOrOfStatement = isForInOrOfStatement;
      function isConciseBody(node) {
        return ts3.isBlock(node) || isExpression(node);
      }
      ts3.isConciseBody = isConciseBody;
      function isFunctionBody(node) {
        return ts3.isBlock(node);
      }
      ts3.isFunctionBody = isFunctionBody;
      function isForInitializer(node) {
        return ts3.isVariableDeclarationList(node) || isExpression(node);
      }
      ts3.isForInitializer = isForInitializer;
      function isModuleBody(node) {
        var kind = node.kind;
        return kind === 258 || kind === 257 || kind === 78;
      }
      ts3.isModuleBody = isModuleBody;
      function isNamespaceBody(node) {
        var kind = node.kind;
        return kind === 258 || kind === 257;
      }
      ts3.isNamespaceBody = isNamespaceBody;
      function isJSDocNamespaceBody(node) {
        var kind = node.kind;
        return kind === 78 || kind === 257;
      }
      ts3.isJSDocNamespaceBody = isJSDocNamespaceBody;
      function isNamedImportBindings(node) {
        var kind = node.kind;
        return kind === 265 || kind === 264;
      }
      ts3.isNamedImportBindings = isNamedImportBindings;
      function isModuleOrEnumDeclaration(node) {
        return node.kind === 257 || node.kind === 256;
      }
      ts3.isModuleOrEnumDeclaration = isModuleOrEnumDeclaration;
      function isDeclarationKind(kind) {
        return kind === 210 || kind === 199 || kind === 253 || kind === 222 || kind === 167 || kind === 256 || kind === 292 || kind === 271 || kind === 252 || kind === 209 || kind === 168 || kind === 263 || kind === 261 || kind === 266 || kind === 254 || kind === 281 || kind === 166 || kind === 165 || kind === 257 || kind === 260 || kind === 264 || kind === 270 || kind === 161 || kind === 289 || kind === 164 || kind === 163 || kind === 169 || kind === 290 || kind === 255 || kind === 160 || kind === 250 || kind === 335 || kind === 328 || kind === 337;
      }
      function isDeclarationStatementKind(kind) {
        return kind === 252 || kind === 272 || kind === 253 || kind === 254 || kind === 255 || kind === 256 || kind === 257 || kind === 262 || kind === 261 || kind === 268 || kind === 267 || kind === 260;
      }
      function isStatementKindButNotDeclarationKind(kind) {
        return kind === 242 || kind === 241 || kind === 249 || kind === 236 || kind === 234 || kind === 232 || kind === 239 || kind === 240 || kind === 238 || kind === 235 || kind === 246 || kind === 243 || kind === 245 || kind === 247 || kind === 248 || kind === 233 || kind === 237 || kind === 244 || kind === 339 || kind === 343 || kind === 342;
      }
      function isDeclaration(node) {
        if (node.kind === 160) {
          return node.parent && node.parent.kind !== 334 || ts3.isInJSFile(node);
        }
        return isDeclarationKind(node.kind);
      }
      ts3.isDeclaration = isDeclaration;
      function isDeclarationStatement(node) {
        return isDeclarationStatementKind(node.kind);
      }
      ts3.isDeclarationStatement = isDeclarationStatement;
      function isStatementButNotDeclaration(node) {
        return isStatementKindButNotDeclarationKind(node.kind);
      }
      ts3.isStatementButNotDeclaration = isStatementButNotDeclaration;
      function isStatement(node) {
        var kind = node.kind;
        return isStatementKindButNotDeclarationKind(kind) || isDeclarationStatementKind(kind) || isBlockStatement(node);
      }
      ts3.isStatement = isStatement;
      function isBlockStatement(node) {
        if (node.kind !== 231)
          return false;
        if (node.parent !== void 0) {
          if (node.parent.kind === 248 || node.parent.kind === 288) {
            return false;
          }
        }
        return !ts3.isFunctionBlock(node);
      }
      function isStatementOrBlock(node) {
        var kind = node.kind;
        return isStatementKindButNotDeclarationKind(kind) || isDeclarationStatementKind(kind) || kind === 231;
      }
      ts3.isStatementOrBlock = isStatementOrBlock;
      function isModuleReference(node) {
        var kind = node.kind;
        return kind === 273 || kind === 158 || kind === 78;
      }
      ts3.isModuleReference = isModuleReference;
      function isJsxTagNameExpression(node) {
        var kind = node.kind;
        return kind === 107 || kind === 78 || kind === 202;
      }
      ts3.isJsxTagNameExpression = isJsxTagNameExpression;
      function isJsxChild(node) {
        var kind = node.kind;
        return kind === 274 || kind === 284 || kind === 275 || kind === 11 || kind === 278;
      }
      ts3.isJsxChild = isJsxChild;
      function isJsxAttributeLike(node) {
        var kind = node.kind;
        return kind === 281 || kind === 283;
      }
      ts3.isJsxAttributeLike = isJsxAttributeLike;
      function isStringLiteralOrJsxExpression(node) {
        var kind = node.kind;
        return kind === 10 || kind === 284;
      }
      ts3.isStringLiteralOrJsxExpression = isStringLiteralOrJsxExpression;
      function isJsxOpeningLikeElement(node) {
        var kind = node.kind;
        return kind === 276 || kind === 275;
      }
      ts3.isJsxOpeningLikeElement = isJsxOpeningLikeElement;
      function isCaseOrDefaultClause(node) {
        var kind = node.kind;
        return kind === 285 || kind === 286;
      }
      ts3.isCaseOrDefaultClause = isCaseOrDefaultClause;
      function isJSDocNode(node) {
        return node.kind >= 302 && node.kind <= 337;
      }
      ts3.isJSDocNode = isJSDocNode;
      function isJSDocCommentContainingNode(node) {
        return node.kind === 312 || node.kind === 311 || node.kind === 313 || node.kind === 316 || isJSDocTag(node) || ts3.isJSDocTypeLiteral(node) || ts3.isJSDocSignature(node);
      }
      ts3.isJSDocCommentContainingNode = isJSDocCommentContainingNode;
      function isJSDocTag(node) {
        return node.kind >= 317 && node.kind <= 337;
      }
      ts3.isJSDocTag = isJSDocTag;
      function isSetAccessor(node) {
        return node.kind === 169;
      }
      ts3.isSetAccessor = isSetAccessor;
      function isGetAccessor(node) {
        return node.kind === 168;
      }
      ts3.isGetAccessor = isGetAccessor;
      function hasJSDocNodes(node) {
        var jsDoc = node.jsDoc;
        return !!jsDoc && jsDoc.length > 0;
      }
      ts3.hasJSDocNodes = hasJSDocNodes;
      function hasType(node) {
        return !!node.type;
      }
      ts3.hasType = hasType;
      function hasInitializer(node) {
        return !!node.initializer;
      }
      ts3.hasInitializer = hasInitializer;
      function hasOnlyExpressionInitializer(node) {
        switch (node.kind) {
          case 250:
          case 161:
          case 199:
          case 163:
          case 164:
          case 289:
          case 292:
            return true;
          default:
            return false;
        }
      }
      ts3.hasOnlyExpressionInitializer = hasOnlyExpressionInitializer;
      function isObjectLiteralElement(node) {
        return node.kind === 281 || node.kind === 283 || isObjectLiteralElementLike(node);
      }
      ts3.isObjectLiteralElement = isObjectLiteralElement;
      function isTypeReferenceType(node) {
        return node.kind === 174 || node.kind === 224;
      }
      ts3.isTypeReferenceType = isTypeReferenceType;
      var MAX_SMI_X86 = 1073741823;
      function guessIndentation(lines) {
        var indentation = MAX_SMI_X86;
        for (var _i = 0, lines_1 = lines; _i < lines_1.length; _i++) {
          var line = lines_1[_i];
          if (!line.length) {
            continue;
          }
          var i3 = 0;
          for (; i3 < line.length && i3 < indentation; i3++) {
            if (!ts3.isWhiteSpaceLike(line.charCodeAt(i3))) {
              break;
            }
          }
          if (i3 < indentation) {
            indentation = i3;
          }
          if (indentation === 0) {
            return 0;
          }
        }
        return indentation === MAX_SMI_X86 ? void 0 : indentation;
      }
      ts3.guessIndentation = guessIndentation;
      function isStringLiteralLike(node) {
        return node.kind === 10 || node.kind === 14;
      }
      ts3.isStringLiteralLike = isStringLiteralLike;
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      ts3.resolvingEmptyArray = [];
      ts3.externalHelpersModuleNameText = "tslib";
      ts3.defaultMaximumTruncationLength = 160;
      ts3.noTruncationMaximumTruncationLength = 1e6;
      function getDeclarationOfKind(symbol, kind) {
        var declarations = symbol.declarations;
        if (declarations) {
          for (var _i = 0, declarations_1 = declarations; _i < declarations_1.length; _i++) {
            var declaration = declarations_1[_i];
            if (declaration.kind === kind) {
              return declaration;
            }
          }
        }
        return void 0;
      }
      ts3.getDeclarationOfKind = getDeclarationOfKind;
      function createUnderscoreEscapedMap() {
        return new ts3.Map();
      }
      ts3.createUnderscoreEscapedMap = createUnderscoreEscapedMap;
      function hasEntries(map2) {
        return !!map2 && !!map2.size;
      }
      ts3.hasEntries = hasEntries;
      function createSymbolTable(symbols) {
        var result2 = new ts3.Map();
        if (symbols) {
          for (var _i = 0, symbols_1 = symbols; _i < symbols_1.length; _i++) {
            var symbol = symbols_1[_i];
            result2.set(symbol.escapedName, symbol);
          }
        }
        return result2;
      }
      ts3.createSymbolTable = createSymbolTable;
      function isTransientSymbol(symbol) {
        return (symbol.flags & 33554432) !== 0;
      }
      ts3.isTransientSymbol = isTransientSymbol;
      var stringWriter = createSingleLineStringWriter();
      function createSingleLineStringWriter() {
        var str2 = "";
        var writeText = function(text) {
          return str2 += text;
        };
        return {
          getText: function() {
            return str2;
          },
          write: writeText,
          rawWrite: writeText,
          writeKeyword: writeText,
          writeOperator: writeText,
          writePunctuation: writeText,
          writeSpace: writeText,
          writeStringLiteral: writeText,
          writeLiteral: writeText,
          writeParameter: writeText,
          writeProperty: writeText,
          writeSymbol: function(s2, _) {
            return writeText(s2);
          },
          writeTrailingSemicolon: writeText,
          writeComment: writeText,
          getTextPos: function() {
            return str2.length;
          },
          getLine: function() {
            return 0;
          },
          getColumn: function() {
            return 0;
          },
          getIndent: function() {
            return 0;
          },
          isAtStartOfLine: function() {
            return false;
          },
          hasTrailingComment: function() {
            return false;
          },
          hasTrailingWhitespace: function() {
            return !!str2.length && ts3.isWhiteSpaceLike(str2.charCodeAt(str2.length - 1));
          },
          writeLine: function() {
            return str2 += " ";
          },
          increaseIndent: ts3.noop,
          decreaseIndent: ts3.noop,
          clear: function() {
            return str2 = "";
          },
          trackSymbol: ts3.noop,
          reportInaccessibleThisError: ts3.noop,
          reportInaccessibleUniqueSymbolError: ts3.noop,
          reportPrivateInBaseOfClassExpression: ts3.noop
        };
      }
      function changesAffectModuleResolution(oldOptions, newOptions) {
        return oldOptions.configFilePath !== newOptions.configFilePath || optionsHaveModuleResolutionChanges(oldOptions, newOptions);
      }
      ts3.changesAffectModuleResolution = changesAffectModuleResolution;
      function optionsHaveModuleResolutionChanges(oldOptions, newOptions) {
        return ts3.moduleResolutionOptionDeclarations.some(function(o2) {
          return !isJsonEqual(getCompilerOptionValue(oldOptions, o2), getCompilerOptionValue(newOptions, o2));
        });
      }
      ts3.optionsHaveModuleResolutionChanges = optionsHaveModuleResolutionChanges;
      function forEachAncestor(node, callback) {
        while (true) {
          var res = callback(node);
          if (res === "quit")
            return void 0;
          if (res !== void 0)
            return res;
          if (ts3.isSourceFile(node))
            return void 0;
          node = node.parent;
        }
      }
      ts3.forEachAncestor = forEachAncestor;
      function forEachEntry(map2, callback) {
        var iterator = map2.entries();
        for (var iterResult = iterator.next(); !iterResult.done; iterResult = iterator.next()) {
          var _a2 = iterResult.value, key2 = _a2[0], value = _a2[1];
          var result2 = callback(value, key2);
          if (result2) {
            return result2;
          }
        }
        return void 0;
      }
      ts3.forEachEntry = forEachEntry;
      function forEachKey(map2, callback) {
        var iterator = map2.keys();
        for (var iterResult = iterator.next(); !iterResult.done; iterResult = iterator.next()) {
          var result2 = callback(iterResult.value);
          if (result2) {
            return result2;
          }
        }
        return void 0;
      }
      ts3.forEachKey = forEachKey;
      function copyEntries(source, target) {
        source.forEach(function(value, key2) {
          target.set(key2, value);
        });
      }
      ts3.copyEntries = copyEntries;
      function usingSingleLineStringWriter(action) {
        var oldString = stringWriter.getText();
        try {
          action(stringWriter);
          return stringWriter.getText();
        } finally {
          stringWriter.clear();
          stringWriter.writeKeyword(oldString);
        }
      }
      ts3.usingSingleLineStringWriter = usingSingleLineStringWriter;
      function getFullWidth(node) {
        return node.end - node.pos;
      }
      ts3.getFullWidth = getFullWidth;
      function getResolvedModule(sourceFile, moduleNameText) {
        return sourceFile && sourceFile.resolvedModules && sourceFile.resolvedModules.get(moduleNameText);
      }
      ts3.getResolvedModule = getResolvedModule;
      function setResolvedModule(sourceFile, moduleNameText, resolvedModule) {
        if (!sourceFile.resolvedModules) {
          sourceFile.resolvedModules = new ts3.Map();
        }
        sourceFile.resolvedModules.set(moduleNameText, resolvedModule);
      }
      ts3.setResolvedModule = setResolvedModule;
      function setResolvedTypeReferenceDirective(sourceFile, typeReferenceDirectiveName, resolvedTypeReferenceDirective) {
        if (!sourceFile.resolvedTypeReferenceDirectiveNames) {
          sourceFile.resolvedTypeReferenceDirectiveNames = new ts3.Map();
        }
        sourceFile.resolvedTypeReferenceDirectiveNames.set(typeReferenceDirectiveName, resolvedTypeReferenceDirective);
      }
      ts3.setResolvedTypeReferenceDirective = setResolvedTypeReferenceDirective;
      function projectReferenceIsEqualTo(oldRef, newRef) {
        return oldRef.path === newRef.path && !oldRef.prepend === !newRef.prepend && !oldRef.circular === !newRef.circular;
      }
      ts3.projectReferenceIsEqualTo = projectReferenceIsEqualTo;
      function moduleResolutionIsEqualTo(oldResolution, newResolution) {
        return oldResolution.isExternalLibraryImport === newResolution.isExternalLibraryImport && oldResolution.extension === newResolution.extension && oldResolution.resolvedFileName === newResolution.resolvedFileName && oldResolution.originalPath === newResolution.originalPath && packageIdIsEqual(oldResolution.packageId, newResolution.packageId);
      }
      ts3.moduleResolutionIsEqualTo = moduleResolutionIsEqualTo;
      function packageIdIsEqual(a2, b2) {
        return a2 === b2 || !!a2 && !!b2 && a2.name === b2.name && a2.subModuleName === b2.subModuleName && a2.version === b2.version;
      }
      function packageIdToString(_a2) {
        var name = _a2.name, subModuleName = _a2.subModuleName, version = _a2.version;
        var fullName = subModuleName ? name + "/" + subModuleName : name;
        return fullName + "@" + version;
      }
      ts3.packageIdToString = packageIdToString;
      function typeDirectiveIsEqualTo(oldResolution, newResolution) {
        return oldResolution.resolvedFileName === newResolution.resolvedFileName && oldResolution.primary === newResolution.primary && oldResolution.originalPath === newResolution.originalPath;
      }
      ts3.typeDirectiveIsEqualTo = typeDirectiveIsEqualTo;
      function hasChangesInResolutions(names, newResolutions, oldResolutions, comparer) {
        ts3.Debug.assert(names.length === newResolutions.length);
        for (var i3 = 0; i3 < names.length; i3++) {
          var newResolution = newResolutions[i3];
          var oldResolution = oldResolutions && oldResolutions.get(names[i3]);
          var changed = oldResolution ? !newResolution || !comparer(oldResolution, newResolution) : newResolution;
          if (changed) {
            return true;
          }
        }
        return false;
      }
      ts3.hasChangesInResolutions = hasChangesInResolutions;
      function containsParseError(node) {
        aggregateChildData(node);
        return (node.flags & 262144) !== 0;
      }
      ts3.containsParseError = containsParseError;
      function aggregateChildData(node) {
        if (!(node.flags & 524288)) {
          var thisNodeOrAnySubNodesHasError = (node.flags & 65536) !== 0 || ts3.forEachChild(node, containsParseError);
          if (thisNodeOrAnySubNodesHasError) {
            node.flags |= 262144;
          }
          node.flags |= 524288;
        }
      }
      function getSourceFileOfNode(node) {
        while (node && node.kind !== 298) {
          node = node.parent;
        }
        return node;
      }
      ts3.getSourceFileOfNode = getSourceFileOfNode;
      function isStatementWithLocals(node) {
        switch (node.kind) {
          case 231:
          case 259:
          case 238:
          case 239:
          case 240:
            return true;
        }
        return false;
      }
      ts3.isStatementWithLocals = isStatementWithLocals;
      function getStartPositionOfLine(line, sourceFile) {
        ts3.Debug.assert(line >= 0);
        return ts3.getLineStarts(sourceFile)[line];
      }
      ts3.getStartPositionOfLine = getStartPositionOfLine;
      function nodePosToString(node) {
        var file = getSourceFileOfNode(node);
        var loc = ts3.getLineAndCharacterOfPosition(file, node.pos);
        return file.fileName + "(" + (loc.line + 1) + "," + (loc.character + 1) + ")";
      }
      ts3.nodePosToString = nodePosToString;
      function getEndLinePosition(line, sourceFile) {
        ts3.Debug.assert(line >= 0);
        var lineStarts = ts3.getLineStarts(sourceFile);
        var lineIndex = line;
        var sourceText = sourceFile.text;
        if (lineIndex + 1 === lineStarts.length) {
          return sourceText.length - 1;
        } else {
          var start = lineStarts[lineIndex];
          var pos = lineStarts[lineIndex + 1] - 1;
          ts3.Debug.assert(ts3.isLineBreak(sourceText.charCodeAt(pos)));
          while (start <= pos && ts3.isLineBreak(sourceText.charCodeAt(pos))) {
            pos--;
          }
          return pos;
        }
      }
      ts3.getEndLinePosition = getEndLinePosition;
      function isFileLevelUniqueName(sourceFile, name, hasGlobalName) {
        return !(hasGlobalName && hasGlobalName(name)) && !sourceFile.identifiers.has(name);
      }
      ts3.isFileLevelUniqueName = isFileLevelUniqueName;
      function nodeIsMissing(node) {
        if (node === void 0) {
          return true;
        }
        return node.pos === node.end && node.pos >= 0 && node.kind !== 1;
      }
      ts3.nodeIsMissing = nodeIsMissing;
      function nodeIsPresent(node) {
        return !nodeIsMissing(node);
      }
      ts3.nodeIsPresent = nodeIsPresent;
      function insertStatementsAfterPrologue(to, from, isPrologueDirective2) {
        if (from === void 0 || from.length === 0)
          return to;
        var statementIndex = 0;
        for (; statementIndex < to.length; ++statementIndex) {
          if (!isPrologueDirective2(to[statementIndex])) {
            break;
          }
        }
        to.splice.apply(to, __spreadArray([statementIndex, 0], from));
        return to;
      }
      function insertStatementAfterPrologue(to, statement, isPrologueDirective2) {
        if (statement === void 0)
          return to;
        var statementIndex = 0;
        for (; statementIndex < to.length; ++statementIndex) {
          if (!isPrologueDirective2(to[statementIndex])) {
            break;
          }
        }
        to.splice(statementIndex, 0, statement);
        return to;
      }
      function isAnyPrologueDirective(node) {
        return isPrologueDirective(node) || !!(getEmitFlags(node) & 1048576);
      }
      function insertStatementsAfterStandardPrologue(to, from) {
        return insertStatementsAfterPrologue(to, from, isPrologueDirective);
      }
      ts3.insertStatementsAfterStandardPrologue = insertStatementsAfterStandardPrologue;
      function insertStatementsAfterCustomPrologue(to, from) {
        return insertStatementsAfterPrologue(to, from, isAnyPrologueDirective);
      }
      ts3.insertStatementsAfterCustomPrologue = insertStatementsAfterCustomPrologue;
      function insertStatementAfterStandardPrologue(to, statement) {
        return insertStatementAfterPrologue(to, statement, isPrologueDirective);
      }
      ts3.insertStatementAfterStandardPrologue = insertStatementAfterStandardPrologue;
      function insertStatementAfterCustomPrologue(to, statement) {
        return insertStatementAfterPrologue(to, statement, isAnyPrologueDirective);
      }
      ts3.insertStatementAfterCustomPrologue = insertStatementAfterCustomPrologue;
      function isRecognizedTripleSlashComment(text, commentPos, commentEnd) {
        if (text.charCodeAt(commentPos + 1) === 47 && commentPos + 2 < commentEnd && text.charCodeAt(commentPos + 2) === 47) {
          var textSubStr = text.substring(commentPos, commentEnd);
          return textSubStr.match(ts3.fullTripleSlashReferencePathRegEx) || textSubStr.match(ts3.fullTripleSlashAMDReferencePathRegEx) || textSubStr.match(fullTripleSlashReferenceTypeReferenceDirectiveRegEx) || textSubStr.match(defaultLibReferenceRegEx) ? true : false;
        }
        return false;
      }
      ts3.isRecognizedTripleSlashComment = isRecognizedTripleSlashComment;
      function isPinnedComment(text, start) {
        return text.charCodeAt(start + 1) === 42 && text.charCodeAt(start + 2) === 33;
      }
      ts3.isPinnedComment = isPinnedComment;
      function createCommentDirectivesMap(sourceFile, commentDirectives) {
        var directivesByLine = new ts3.Map(commentDirectives.map(function(commentDirective) {
          return [
            "" + ts3.getLineAndCharacterOfPosition(sourceFile, commentDirective.range.end).line,
            commentDirective
          ];
        }));
        var usedLines = new ts3.Map();
        return { getUnusedExpectations, markUsed };
        function getUnusedExpectations() {
          return ts3.arrayFrom(directivesByLine.entries()).filter(function(_a2) {
            var line = _a2[0], directive = _a2[1];
            return directive.type === 0 && !usedLines.get(line);
          }).map(function(_a2) {
            var _ = _a2[0], directive = _a2[1];
            return directive;
          });
        }
        function markUsed(line) {
          if (!directivesByLine.has("" + line)) {
            return false;
          }
          usedLines.set("" + line, true);
          return true;
        }
      }
      ts3.createCommentDirectivesMap = createCommentDirectivesMap;
      function getTokenPosOfNode(node, sourceFile, includeJsDoc) {
        if (nodeIsMissing(node)) {
          return node.pos;
        }
        if (ts3.isJSDocNode(node) || node.kind === 11) {
          return ts3.skipTrivia((sourceFile || getSourceFileOfNode(node)).text, node.pos, false, true);
        }
        if (includeJsDoc && ts3.hasJSDocNodes(node)) {
          return getTokenPosOfNode(node.jsDoc[0], sourceFile);
        }
        if (node.kind === 338 && node._children.length > 0) {
          return getTokenPosOfNode(node._children[0], sourceFile, includeJsDoc);
        }
        return ts3.skipTrivia((sourceFile || getSourceFileOfNode(node)).text, node.pos, false, false, isInJSDoc(node));
      }
      ts3.getTokenPosOfNode = getTokenPosOfNode;
      function getNonDecoratorTokenPosOfNode(node, sourceFile) {
        if (nodeIsMissing(node) || !node.decorators) {
          return getTokenPosOfNode(node, sourceFile);
        }
        return ts3.skipTrivia((sourceFile || getSourceFileOfNode(node)).text, node.decorators.end);
      }
      ts3.getNonDecoratorTokenPosOfNode = getNonDecoratorTokenPosOfNode;
      function getSourceTextOfNodeFromSourceFile(sourceFile, node, includeTrivia) {
        if (includeTrivia === void 0) {
          includeTrivia = false;
        }
        return getTextOfNodeFromSourceText(sourceFile.text, node, includeTrivia);
      }
      ts3.getSourceTextOfNodeFromSourceFile = getSourceTextOfNodeFromSourceFile;
      function isJSDocTypeExpressionOrChild(node) {
        return !!ts3.findAncestor(node, ts3.isJSDocTypeExpression);
      }
      function isExportNamespaceAsDefaultDeclaration(node) {
        return !!(ts3.isExportDeclaration(node) && node.exportClause && ts3.isNamespaceExport(node.exportClause) && node.exportClause.name.escapedText === "default");
      }
      ts3.isExportNamespaceAsDefaultDeclaration = isExportNamespaceAsDefaultDeclaration;
      function getTextOfNodeFromSourceText(sourceText, node, includeTrivia) {
        if (includeTrivia === void 0) {
          includeTrivia = false;
        }
        if (nodeIsMissing(node)) {
          return "";
        }
        var text = sourceText.substring(includeTrivia ? node.pos : ts3.skipTrivia(sourceText, node.pos), node.end);
        if (isJSDocTypeExpressionOrChild(node)) {
          text = text.replace(/(^|\r?\n|\r)\s*\*\s*/g, "$1");
        }
        return text;
      }
      ts3.getTextOfNodeFromSourceText = getTextOfNodeFromSourceText;
      function getTextOfNode(node, includeTrivia) {
        if (includeTrivia === void 0) {
          includeTrivia = false;
        }
        return getSourceTextOfNodeFromSourceFile(getSourceFileOfNode(node), node, includeTrivia);
      }
      ts3.getTextOfNode = getTextOfNode;
      function getPos(range) {
        return range.pos;
      }
      function indexOfNode(nodeArray, node) {
        return ts3.binarySearch(nodeArray, node, getPos, ts3.compareValues);
      }
      ts3.indexOfNode = indexOfNode;
      function getEmitFlags(node) {
        var emitNode = node.emitNode;
        return emitNode && emitNode.flags || 0;
      }
      ts3.getEmitFlags = getEmitFlags;
      ;
      function getScriptTargetFeatures() {
        return {
          es2015: {
            Array: ["find", "findIndex", "fill", "copyWithin", "entries", "keys", "values"],
            RegExp: ["flags", "sticky", "unicode"],
            Reflect: ["apply", "construct", "defineProperty", "deleteProperty", "get", " getOwnPropertyDescriptor", "getPrototypeOf", "has", "isExtensible", "ownKeys", "preventExtensions", "set", "setPrototypeOf"],
            ArrayConstructor: ["from", "of"],
            ObjectConstructor: ["assign", "getOwnPropertySymbols", "keys", "is", "setPrototypeOf"],
            NumberConstructor: ["isFinite", "isInteger", "isNaN", "isSafeInteger", "parseFloat", "parseInt"],
            Math: ["clz32", "imul", "sign", "log10", "log2", "log1p", "expm1", "cosh", "sinh", "tanh", "acosh", "asinh", "atanh", "hypot", "trunc", "fround", "cbrt"],
            Map: ["entries", "keys", "values"],
            Set: ["entries", "keys", "values"],
            Promise: ts3.emptyArray,
            PromiseConstructor: ["all", "race", "reject", "resolve"],
            Symbol: ["for", "keyFor"],
            WeakMap: ["entries", "keys", "values"],
            WeakSet: ["entries", "keys", "values"],
            Iterator: ts3.emptyArray,
            AsyncIterator: ts3.emptyArray,
            String: ["codePointAt", "includes", "endsWith", "normalize", "repeat", "startsWith", "anchor", "big", "blink", "bold", "fixed", "fontcolor", "fontsize", "italics", "link", "small", "strike", "sub", "sup"],
            StringConstructor: ["fromCodePoint", "raw"]
          },
          es2016: {
            Array: ["includes"]
          },
          es2017: {
            Atomics: ts3.emptyArray,
            SharedArrayBuffer: ts3.emptyArray,
            String: ["padStart", "padEnd"],
            ObjectConstructor: ["values", "entries", "getOwnPropertyDescriptors"],
            DateTimeFormat: ["formatToParts"]
          },
          es2018: {
            Promise: ["finally"],
            RegExpMatchArray: ["groups"],
            RegExpExecArray: ["groups"],
            RegExp: ["dotAll"],
            Intl: ["PluralRules"],
            AsyncIterable: ts3.emptyArray,
            AsyncIterableIterator: ts3.emptyArray,
            AsyncGenerator: ts3.emptyArray,
            AsyncGeneratorFunction: ts3.emptyArray
          },
          es2019: {
            Array: ["flat", "flatMap"],
            ObjectConstructor: ["fromEntries"],
            String: ["trimStart", "trimEnd", "trimLeft", "trimRight"],
            Symbol: ["description"]
          },
          es2020: {
            BigInt: ts3.emptyArray,
            BigInt64Array: ts3.emptyArray,
            BigUint64Array: ts3.emptyArray,
            PromiseConstructor: ["allSettled"],
            SymbolConstructor: ["matchAll"],
            String: ["matchAll"],
            DataView: ["setBigInt64", "setBigUint64", "getBigInt64", "getBigUint64"],
            RelativeTimeFormat: ["format", "formatToParts", "resolvedOptions"]
          },
          es2021: {
            PromiseConstructor: ["any"],
            String: ["replaceAll"]
          },
          esnext: {
            NumberFormat: ["formatToParts"]
          }
        };
      }
      ts3.getScriptTargetFeatures = getScriptTargetFeatures;
      var GetLiteralTextFlags;
      (function(GetLiteralTextFlags2) {
        GetLiteralTextFlags2[GetLiteralTextFlags2["None"] = 0] = "None";
        GetLiteralTextFlags2[GetLiteralTextFlags2["NeverAsciiEscape"] = 1] = "NeverAsciiEscape";
        GetLiteralTextFlags2[GetLiteralTextFlags2["JsxAttributeEscape"] = 2] = "JsxAttributeEscape";
        GetLiteralTextFlags2[GetLiteralTextFlags2["TerminateUnterminatedLiterals"] = 4] = "TerminateUnterminatedLiterals";
        GetLiteralTextFlags2[GetLiteralTextFlags2["AllowNumericSeparator"] = 8] = "AllowNumericSeparator";
      })(GetLiteralTextFlags = ts3.GetLiteralTextFlags || (ts3.GetLiteralTextFlags = {}));
      function getLiteralText(node, sourceFile, flags) {
        if (canUseOriginalText(node, flags)) {
          return getSourceTextOfNodeFromSourceFile(sourceFile, node);
        }
        switch (node.kind) {
          case 10: {
            var escapeText = flags & 2 ? escapeJsxAttributeString : flags & 1 || getEmitFlags(node) & 16777216 ? escapeString2 : escapeNonAsciiString;
            if (node.singleQuote) {
              return "'" + escapeText(node.text, 39) + "'";
            } else {
              return '"' + escapeText(node.text, 34) + '"';
            }
          }
          case 14:
          case 15:
          case 16:
          case 17: {
            var escapeText = flags & 1 || getEmitFlags(node) & 16777216 ? escapeString2 : escapeNonAsciiString;
            var rawText = node.rawText || escapeTemplateSubstitution(escapeText(node.text, 96));
            switch (node.kind) {
              case 14:
                return "`" + rawText + "`";
              case 15:
                return "`" + rawText + "${";
              case 16:
                return "}" + rawText + "${";
              case 17:
                return "}" + rawText + "`";
            }
            break;
          }
          case 8:
          case 9:
            return node.text;
          case 13:
            if (flags & 4 && node.isUnterminated) {
              return node.text + (node.text.charCodeAt(node.text.length - 1) === 92 ? " /" : "/");
            }
            return node.text;
        }
        return ts3.Debug.fail("Literal kind '" + node.kind + "' not accounted for.");
      }
      ts3.getLiteralText = getLiteralText;
      function canUseOriginalText(node, flags) {
        if (nodeIsSynthesized(node) || !node.parent || flags & 4 && node.isUnterminated) {
          return false;
        }
        if (ts3.isNumericLiteral(node) && node.numericLiteralFlags & 512) {
          return !!(flags & 8);
        }
        return !ts3.isBigIntLiteral(node);
      }
      function getTextOfConstantValue(value) {
        return ts3.isString(value) ? '"' + escapeNonAsciiString(value) + '"' : "" + value;
      }
      ts3.getTextOfConstantValue = getTextOfConstantValue;
      function makeIdentifierFromModuleName(moduleName) {
        return ts3.getBaseFileName(moduleName).replace(/^(\d)/, "_$1").replace(/\W/g, "_");
      }
      ts3.makeIdentifierFromModuleName = makeIdentifierFromModuleName;
      function isBlockOrCatchScoped(declaration) {
        return (ts3.getCombinedNodeFlags(declaration) & 3) !== 0 || isCatchClauseVariableDeclarationOrBindingElement(declaration);
      }
      ts3.isBlockOrCatchScoped = isBlockOrCatchScoped;
      function isCatchClauseVariableDeclarationOrBindingElement(declaration) {
        var node = getRootDeclaration(declaration);
        return node.kind === 250 && node.parent.kind === 288;
      }
      ts3.isCatchClauseVariableDeclarationOrBindingElement = isCatchClauseVariableDeclarationOrBindingElement;
      function isAmbientModule(node) {
        return ts3.isModuleDeclaration(node) && (node.name.kind === 10 || isGlobalScopeAugmentation(node));
      }
      ts3.isAmbientModule = isAmbientModule;
      function isModuleWithStringLiteralName(node) {
        return ts3.isModuleDeclaration(node) && node.name.kind === 10;
      }
      ts3.isModuleWithStringLiteralName = isModuleWithStringLiteralName;
      function isNonGlobalAmbientModule(node) {
        return ts3.isModuleDeclaration(node) && ts3.isStringLiteral(node.name);
      }
      ts3.isNonGlobalAmbientModule = isNonGlobalAmbientModule;
      function isEffectiveModuleDeclaration(node) {
        return ts3.isModuleDeclaration(node) || ts3.isIdentifier(node);
      }
      ts3.isEffectiveModuleDeclaration = isEffectiveModuleDeclaration;
      function isShorthandAmbientModuleSymbol(moduleSymbol) {
        return isShorthandAmbientModule(moduleSymbol.valueDeclaration);
      }
      ts3.isShorthandAmbientModuleSymbol = isShorthandAmbientModuleSymbol;
      function isShorthandAmbientModule(node) {
        return !!node && node.kind === 257 && !node.body;
      }
      function isBlockScopedContainerTopLevel(node) {
        return node.kind === 298 || node.kind === 257 || ts3.isFunctionLike(node);
      }
      ts3.isBlockScopedContainerTopLevel = isBlockScopedContainerTopLevel;
      function isGlobalScopeAugmentation(module3) {
        return !!(module3.flags & 1024);
      }
      ts3.isGlobalScopeAugmentation = isGlobalScopeAugmentation;
      function isExternalModuleAugmentation(node) {
        return isAmbientModule(node) && isModuleAugmentationExternal(node);
      }
      ts3.isExternalModuleAugmentation = isExternalModuleAugmentation;
      function isModuleAugmentationExternal(node) {
        switch (node.parent.kind) {
          case 298:
            return ts3.isExternalModule(node.parent);
          case 258:
            return isAmbientModule(node.parent.parent) && ts3.isSourceFile(node.parent.parent.parent) && !ts3.isExternalModule(node.parent.parent.parent);
        }
        return false;
      }
      ts3.isModuleAugmentationExternal = isModuleAugmentationExternal;
      function getNonAugmentationDeclaration(symbol) {
        var _a2;
        return (_a2 = symbol.declarations) === null || _a2 === void 0 ? void 0 : _a2.find(function(d) {
          return !isExternalModuleAugmentation(d) && !(ts3.isModuleDeclaration(d) && isGlobalScopeAugmentation(d));
        });
      }
      ts3.getNonAugmentationDeclaration = getNonAugmentationDeclaration;
      function isEffectiveExternalModule(node, compilerOptions) {
        return ts3.isExternalModule(node) || compilerOptions.isolatedModules || getEmitModuleKind(compilerOptions) === ts3.ModuleKind.CommonJS && !!node.commonJsModuleIndicator;
      }
      ts3.isEffectiveExternalModule = isEffectiveExternalModule;
      function isEffectiveStrictModeSourceFile(node, compilerOptions) {
        switch (node.scriptKind) {
          case 1:
          case 3:
          case 2:
          case 4:
            break;
          default:
            return false;
        }
        if (node.isDeclarationFile) {
          return false;
        }
        if (getStrictOptionValue(compilerOptions, "alwaysStrict")) {
          return true;
        }
        if (ts3.startsWithUseStrict(node.statements)) {
          return true;
        }
        if (ts3.isExternalModule(node) || compilerOptions.isolatedModules) {
          if (getEmitModuleKind(compilerOptions) >= ts3.ModuleKind.ES2015) {
            return true;
          }
          return !compilerOptions.noImplicitUseStrict;
        }
        return false;
      }
      ts3.isEffectiveStrictModeSourceFile = isEffectiveStrictModeSourceFile;
      function isBlockScope(node, parentNode) {
        switch (node.kind) {
          case 298:
          case 259:
          case 288:
          case 257:
          case 238:
          case 239:
          case 240:
          case 167:
          case 166:
          case 168:
          case 169:
          case 252:
          case 209:
          case 210:
            return true;
          case 231:
            return !ts3.isFunctionLike(parentNode);
        }
        return false;
      }
      ts3.isBlockScope = isBlockScope;
      function isDeclarationWithTypeParameters(node) {
        switch (node.kind) {
          case 328:
          case 335:
          case 315:
            return true;
          default:
            ts3.assertType(node);
            return isDeclarationWithTypeParameterChildren(node);
        }
      }
      ts3.isDeclarationWithTypeParameters = isDeclarationWithTypeParameters;
      function isDeclarationWithTypeParameterChildren(node) {
        switch (node.kind) {
          case 170:
          case 171:
          case 165:
          case 172:
          case 175:
          case 176:
          case 309:
          case 253:
          case 222:
          case 254:
          case 255:
          case 334:
          case 252:
          case 166:
          case 167:
          case 168:
          case 169:
          case 209:
          case 210:
            return true;
          default:
            ts3.assertType(node);
            return false;
        }
      }
      ts3.isDeclarationWithTypeParameterChildren = isDeclarationWithTypeParameterChildren;
      function isAnyImportSyntax(node) {
        switch (node.kind) {
          case 262:
          case 261:
            return true;
          default:
            return false;
        }
      }
      ts3.isAnyImportSyntax = isAnyImportSyntax;
      function isLateVisibilityPaintedStatement(node) {
        switch (node.kind) {
          case 262:
          case 261:
          case 233:
          case 253:
          case 252:
          case 257:
          case 255:
          case 254:
          case 256:
            return true;
          default:
            return false;
        }
      }
      ts3.isLateVisibilityPaintedStatement = isLateVisibilityPaintedStatement;
      function hasPossibleExternalModuleReference(node) {
        return isAnyImportOrReExport(node) || ts3.isModuleDeclaration(node) || ts3.isImportTypeNode(node) || isImportCall(node);
      }
      ts3.hasPossibleExternalModuleReference = hasPossibleExternalModuleReference;
      function isAnyImportOrReExport(node) {
        return isAnyImportSyntax(node) || ts3.isExportDeclaration(node);
      }
      ts3.isAnyImportOrReExport = isAnyImportOrReExport;
      function getEnclosingBlockScopeContainer(node) {
        return ts3.findAncestor(node.parent, function(current) {
          return isBlockScope(current, current.parent);
        });
      }
      ts3.getEnclosingBlockScopeContainer = getEnclosingBlockScopeContainer;
      function declarationNameToString(name) {
        return !name || getFullWidth(name) === 0 ? "(Missing)" : getTextOfNode(name);
      }
      ts3.declarationNameToString = declarationNameToString;
      function getNameFromIndexInfo(info) {
        return info.declaration ? declarationNameToString(info.declaration.parameters[0].name) : void 0;
      }
      ts3.getNameFromIndexInfo = getNameFromIndexInfo;
      function isComputedNonLiteralName(name) {
        return name.kind === 159 && !isStringOrNumericLiteralLike(name.expression);
      }
      ts3.isComputedNonLiteralName = isComputedNonLiteralName;
      function getTextOfPropertyName(name) {
        switch (name.kind) {
          case 78:
          case 79:
            return name.escapedText;
          case 10:
          case 8:
          case 14:
            return ts3.escapeLeadingUnderscores(name.text);
          case 159:
            if (isStringOrNumericLiteralLike(name.expression))
              return ts3.escapeLeadingUnderscores(name.expression.text);
            return ts3.Debug.fail("Text of property name cannot be read from non-literal-valued ComputedPropertyNames");
          default:
            return ts3.Debug.assertNever(name);
        }
      }
      ts3.getTextOfPropertyName = getTextOfPropertyName;
      function entityNameToString(name) {
        switch (name.kind) {
          case 107:
            return "this";
          case 79:
          case 78:
            return getFullWidth(name) === 0 ? ts3.idText(name) : getTextOfNode(name);
          case 158:
            return entityNameToString(name.left) + "." + entityNameToString(name.right);
          case 202:
            if (ts3.isIdentifier(name.name) || ts3.isPrivateIdentifier(name.name)) {
              return entityNameToString(name.expression) + "." + entityNameToString(name.name);
            } else {
              return ts3.Debug.assertNever(name.name);
            }
          default:
            return ts3.Debug.assertNever(name);
        }
      }
      ts3.entityNameToString = entityNameToString;
      function createDiagnosticForNode(node, message, arg0, arg1, arg2, arg3) {
        var sourceFile = getSourceFileOfNode(node);
        return createDiagnosticForNodeInSourceFile(sourceFile, node, message, arg0, arg1, arg2, arg3);
      }
      ts3.createDiagnosticForNode = createDiagnosticForNode;
      function createDiagnosticForNodeArray(sourceFile, nodes, message, arg0, arg1, arg2, arg3) {
        var start = ts3.skipTrivia(sourceFile.text, nodes.pos);
        return createFileDiagnostic(sourceFile, start, nodes.end - start, message, arg0, arg1, arg2, arg3);
      }
      ts3.createDiagnosticForNodeArray = createDiagnosticForNodeArray;
      function createDiagnosticForNodeInSourceFile(sourceFile, node, message, arg0, arg1, arg2, arg3) {
        var span = getErrorSpanForNode(sourceFile, node);
        return createFileDiagnostic(sourceFile, span.start, span.length, message, arg0, arg1, arg2, arg3);
      }
      ts3.createDiagnosticForNodeInSourceFile = createDiagnosticForNodeInSourceFile;
      function createDiagnosticForNodeFromMessageChain(node, messageChain, relatedInformation) {
        var sourceFile = getSourceFileOfNode(node);
        var span = getErrorSpanForNode(sourceFile, node);
        return createFileDiagnosticFromMessageChain(sourceFile, span.start, span.length, messageChain, relatedInformation);
      }
      ts3.createDiagnosticForNodeFromMessageChain = createDiagnosticForNodeFromMessageChain;
      function assertDiagnosticLocation(file, start, length) {
        ts3.Debug.assertGreaterThanOrEqual(start, 0);
        ts3.Debug.assertGreaterThanOrEqual(length, 0);
        if (file) {
          ts3.Debug.assertLessThanOrEqual(start, file.text.length);
          ts3.Debug.assertLessThanOrEqual(start + length, file.text.length);
        }
      }
      function createFileDiagnosticFromMessageChain(file, start, length, messageChain, relatedInformation) {
        assertDiagnosticLocation(file, start, length);
        return {
          file,
          start,
          length,
          code: messageChain.code,
          category: messageChain.category,
          messageText: messageChain.next ? messageChain : messageChain.messageText,
          relatedInformation
        };
      }
      ts3.createFileDiagnosticFromMessageChain = createFileDiagnosticFromMessageChain;
      function createDiagnosticForFileFromMessageChain(sourceFile, messageChain, relatedInformation) {
        return {
          file: sourceFile,
          start: 0,
          length: 0,
          code: messageChain.code,
          category: messageChain.category,
          messageText: messageChain.next ? messageChain : messageChain.messageText,
          relatedInformation
        };
      }
      ts3.createDiagnosticForFileFromMessageChain = createDiagnosticForFileFromMessageChain;
      function createDiagnosticForRange(sourceFile, range, message) {
        return {
          file: sourceFile,
          start: range.pos,
          length: range.end - range.pos,
          code: message.code,
          category: message.category,
          messageText: message.message
        };
      }
      ts3.createDiagnosticForRange = createDiagnosticForRange;
      function getSpanOfTokenAtPosition(sourceFile, pos) {
        var scanner = ts3.createScanner(sourceFile.languageVersion, true, sourceFile.languageVariant, sourceFile.text, void 0, pos);
        scanner.scan();
        var start = scanner.getTokenPos();
        return ts3.createTextSpanFromBounds(start, scanner.getTextPos());
      }
      ts3.getSpanOfTokenAtPosition = getSpanOfTokenAtPosition;
      function getErrorSpanForArrowFunction(sourceFile, node) {
        var pos = ts3.skipTrivia(sourceFile.text, node.pos);
        if (node.body && node.body.kind === 231) {
          var startLine = ts3.getLineAndCharacterOfPosition(sourceFile, node.body.pos).line;
          var endLine = ts3.getLineAndCharacterOfPosition(sourceFile, node.body.end).line;
          if (startLine < endLine) {
            return ts3.createTextSpan(pos, getEndLinePosition(startLine, sourceFile) - pos + 1);
          }
        }
        return ts3.createTextSpanFromBounds(pos, node.end);
      }
      function getErrorSpanForNode(sourceFile, node) {
        var errorNode = node;
        switch (node.kind) {
          case 298:
            var pos_1 = ts3.skipTrivia(sourceFile.text, 0, false);
            if (pos_1 === sourceFile.text.length) {
              return ts3.createTextSpan(0, 0);
            }
            return getSpanOfTokenAtPosition(sourceFile, pos_1);
          case 250:
          case 199:
          case 253:
          case 222:
          case 254:
          case 257:
          case 256:
          case 292:
          case 252:
          case 209:
          case 166:
          case 168:
          case 169:
          case 255:
          case 164:
          case 163:
            errorNode = node.name;
            break;
          case 210:
            return getErrorSpanForArrowFunction(sourceFile, node);
          case 285:
          case 286:
            var start = ts3.skipTrivia(sourceFile.text, node.pos);
            var end = node.statements.length > 0 ? node.statements[0].pos : node.end;
            return ts3.createTextSpanFromBounds(start, end);
        }
        if (errorNode === void 0) {
          return getSpanOfTokenAtPosition(sourceFile, node.pos);
        }
        ts3.Debug.assert(!ts3.isJSDoc(errorNode));
        var isMissing = nodeIsMissing(errorNode);
        var pos = isMissing || ts3.isJsxText(node) ? errorNode.pos : ts3.skipTrivia(sourceFile.text, errorNode.pos);
        if (isMissing) {
          ts3.Debug.assert(pos === errorNode.pos, "This failure could trigger https://github.com/Microsoft/TypeScript/issues/20809");
          ts3.Debug.assert(pos === errorNode.end, "This failure could trigger https://github.com/Microsoft/TypeScript/issues/20809");
        } else {
          ts3.Debug.assert(pos >= errorNode.pos, "This failure could trigger https://github.com/Microsoft/TypeScript/issues/20809");
          ts3.Debug.assert(pos <= errorNode.end, "This failure could trigger https://github.com/Microsoft/TypeScript/issues/20809");
        }
        return ts3.createTextSpanFromBounds(pos, errorNode.end);
      }
      ts3.getErrorSpanForNode = getErrorSpanForNode;
      function isExternalOrCommonJsModule(file) {
        return (file.externalModuleIndicator || file.commonJsModuleIndicator) !== void 0;
      }
      ts3.isExternalOrCommonJsModule = isExternalOrCommonJsModule;
      function isJsonSourceFile(file) {
        return file.scriptKind === 6;
      }
      ts3.isJsonSourceFile = isJsonSourceFile;
      function isEnumConst(node) {
        return !!(ts3.getCombinedModifierFlags(node) & 2048);
      }
      ts3.isEnumConst = isEnumConst;
      function isDeclarationReadonly(declaration) {
        return !!(ts3.getCombinedModifierFlags(declaration) & 64 && !ts3.isParameterPropertyDeclaration(declaration, declaration.parent));
      }
      ts3.isDeclarationReadonly = isDeclarationReadonly;
      function isVarConst(node) {
        return !!(ts3.getCombinedNodeFlags(node) & 2);
      }
      ts3.isVarConst = isVarConst;
      function isLet(node) {
        return !!(ts3.getCombinedNodeFlags(node) & 1);
      }
      ts3.isLet = isLet;
      function isSuperCall(n2) {
        return n2.kind === 204 && n2.expression.kind === 105;
      }
      ts3.isSuperCall = isSuperCall;
      function isImportCall(n2) {
        return n2.kind === 204 && n2.expression.kind === 99;
      }
      ts3.isImportCall = isImportCall;
      function isImportMeta(n2) {
        return ts3.isMetaProperty(n2) && n2.keywordToken === 99 && n2.name.escapedText === "meta";
      }
      ts3.isImportMeta = isImportMeta;
      function isLiteralImportTypeNode(n2) {
        return ts3.isImportTypeNode(n2) && ts3.isLiteralTypeNode(n2.argument) && ts3.isStringLiteral(n2.argument.literal);
      }
      ts3.isLiteralImportTypeNode = isLiteralImportTypeNode;
      function isPrologueDirective(node) {
        return node.kind === 234 && node.expression.kind === 10;
      }
      ts3.isPrologueDirective = isPrologueDirective;
      function isCustomPrologue(node) {
        return !!(getEmitFlags(node) & 1048576);
      }
      ts3.isCustomPrologue = isCustomPrologue;
      function isHoistedFunction(node) {
        return isCustomPrologue(node) && ts3.isFunctionDeclaration(node);
      }
      ts3.isHoistedFunction = isHoistedFunction;
      function isHoistedVariable(node) {
        return ts3.isIdentifier(node.name) && !node.initializer;
      }
      function isHoistedVariableStatement(node) {
        return isCustomPrologue(node) && ts3.isVariableStatement(node) && ts3.every(node.declarationList.declarations, isHoistedVariable);
      }
      ts3.isHoistedVariableStatement = isHoistedVariableStatement;
      function getLeadingCommentRangesOfNode(node, sourceFileOfNode) {
        return node.kind !== 11 ? ts3.getLeadingCommentRanges(sourceFileOfNode.text, node.pos) : void 0;
      }
      ts3.getLeadingCommentRangesOfNode = getLeadingCommentRangesOfNode;
      function getJSDocCommentRanges(node, text) {
        var commentRanges = node.kind === 161 || node.kind === 160 || node.kind === 209 || node.kind === 210 || node.kind === 208 || node.kind === 250 ? ts3.concatenate(ts3.getTrailingCommentRanges(text, node.pos), ts3.getLeadingCommentRanges(text, node.pos)) : ts3.getLeadingCommentRanges(text, node.pos);
        return ts3.filter(commentRanges, function(comment) {
          return text.charCodeAt(comment.pos + 1) === 42 && text.charCodeAt(comment.pos + 2) === 42 && text.charCodeAt(comment.pos + 3) !== 47;
        });
      }
      ts3.getJSDocCommentRanges = getJSDocCommentRanges;
      ts3.fullTripleSlashReferencePathRegEx = /^(\/\/\/\s*<reference\s+path\s*=\s*)('|")(.+?)\2.*?\/>/;
      var fullTripleSlashReferenceTypeReferenceDirectiveRegEx = /^(\/\/\/\s*<reference\s+types\s*=\s*)('|")(.+?)\2.*?\/>/;
      ts3.fullTripleSlashAMDReferencePathRegEx = /^(\/\/\/\s*<amd-dependency\s+path\s*=\s*)('|")(.+?)\2.*?\/>/;
      var defaultLibReferenceRegEx = /^(\/\/\/\s*<reference\s+no-default-lib\s*=\s*)('|")(.+?)\2\s*\/>/;
      function isPartOfTypeNode(node) {
        if (173 <= node.kind && node.kind <= 196) {
          return true;
        }
        switch (node.kind) {
          case 128:
          case 152:
          case 144:
          case 155:
          case 147:
          case 131:
          case 148:
          case 145:
          case 150:
          case 141:
            return true;
          case 113:
            return node.parent.kind !== 213;
          case 224:
            return !isExpressionWithTypeArgumentsInClassExtendsClause(node);
          case 160:
            return node.parent.kind === 191 || node.parent.kind === 186;
          case 78:
            if (node.parent.kind === 158 && node.parent.right === node) {
              node = node.parent;
            } else if (node.parent.kind === 202 && node.parent.name === node) {
              node = node.parent;
            }
            ts3.Debug.assert(node.kind === 78 || node.kind === 158 || node.kind === 202, "'node' was expected to be a qualified name, identifier or property access in 'isPartOfTypeNode'.");
          case 158:
          case 202:
          case 107: {
            var parent = node.parent;
            if (parent.kind === 177) {
              return false;
            }
            if (parent.kind === 196) {
              return !parent.isTypeOf;
            }
            if (173 <= parent.kind && parent.kind <= 196) {
              return true;
            }
            switch (parent.kind) {
              case 224:
                return !isExpressionWithTypeArgumentsInClassExtendsClause(parent);
              case 160:
                return node === parent.constraint;
              case 334:
                return node === parent.constraint;
              case 164:
              case 163:
              case 161:
              case 250:
                return node === parent.type;
              case 252:
              case 209:
              case 210:
              case 167:
              case 166:
              case 165:
              case 168:
              case 169:
                return node === parent.type;
              case 170:
              case 171:
              case 172:
                return node === parent.type;
              case 207:
                return node === parent.type;
              case 204:
              case 205:
                return ts3.contains(parent.typeArguments, node);
              case 206:
                return false;
            }
          }
        }
        return false;
      }
      ts3.isPartOfTypeNode = isPartOfTypeNode;
      function isChildOfNodeWithKind(node, kind) {
        while (node) {
          if (node.kind === kind) {
            return true;
          }
          node = node.parent;
        }
        return false;
      }
      ts3.isChildOfNodeWithKind = isChildOfNodeWithKind;
      function forEachReturnStatement(body, visitor) {
        return traverse(body);
        function traverse(node) {
          switch (node.kind) {
            case 243:
              return visitor(node);
            case 259:
            case 231:
            case 235:
            case 236:
            case 237:
            case 238:
            case 239:
            case 240:
            case 244:
            case 245:
            case 285:
            case 286:
            case 246:
            case 248:
            case 288:
              return ts3.forEachChild(node, traverse);
          }
        }
      }
      ts3.forEachReturnStatement = forEachReturnStatement;
      function forEachYieldExpression(body, visitor) {
        return traverse(body);
        function traverse(node) {
          switch (node.kind) {
            case 220:
              visitor(node);
              var operand = node.expression;
              if (operand) {
                traverse(operand);
              }
              return;
            case 256:
            case 254:
            case 257:
            case 255:
              return;
            default:
              if (ts3.isFunctionLike(node)) {
                if (node.name && node.name.kind === 159) {
                  traverse(node.name.expression);
                  return;
                }
              } else if (!isPartOfTypeNode(node)) {
                ts3.forEachChild(node, traverse);
              }
          }
        }
      }
      ts3.forEachYieldExpression = forEachYieldExpression;
      function getRestParameterElementType(node) {
        if (node && node.kind === 179) {
          return node.elementType;
        } else if (node && node.kind === 174) {
          return ts3.singleOrUndefined(node.typeArguments);
        } else {
          return void 0;
        }
      }
      ts3.getRestParameterElementType = getRestParameterElementType;
      function getMembersOfDeclaration(node) {
        switch (node.kind) {
          case 254:
          case 253:
          case 222:
          case 178:
            return node.members;
          case 201:
            return node.properties;
        }
      }
      ts3.getMembersOfDeclaration = getMembersOfDeclaration;
      function isVariableLike(node) {
        if (node) {
          switch (node.kind) {
            case 199:
            case 292:
            case 161:
            case 289:
            case 164:
            case 163:
            case 290:
            case 250:
              return true;
          }
        }
        return false;
      }
      ts3.isVariableLike = isVariableLike;
      function isVariableLikeOrAccessor(node) {
        return isVariableLike(node) || ts3.isAccessor(node);
      }
      ts3.isVariableLikeOrAccessor = isVariableLikeOrAccessor;
      function isVariableDeclarationInVariableStatement(node) {
        return node.parent.kind === 251 && node.parent.parent.kind === 233;
      }
      ts3.isVariableDeclarationInVariableStatement = isVariableDeclarationInVariableStatement;
      function isValidESSymbolDeclaration(node) {
        return ts3.isVariableDeclaration(node) ? isVarConst(node) && ts3.isIdentifier(node.name) && isVariableDeclarationInVariableStatement(node) : ts3.isPropertyDeclaration(node) ? hasEffectiveReadonlyModifier(node) && hasStaticModifier(node) : ts3.isPropertySignature(node) && hasEffectiveReadonlyModifier(node);
      }
      ts3.isValidESSymbolDeclaration = isValidESSymbolDeclaration;
      function introducesArgumentsExoticObject(node) {
        switch (node.kind) {
          case 166:
          case 165:
          case 167:
          case 168:
          case 169:
          case 252:
          case 209:
            return true;
        }
        return false;
      }
      ts3.introducesArgumentsExoticObject = introducesArgumentsExoticObject;
      function unwrapInnermostStatementOfLabel(node, beforeUnwrapLabelCallback) {
        while (true) {
          if (beforeUnwrapLabelCallback) {
            beforeUnwrapLabelCallback(node);
          }
          if (node.statement.kind !== 246) {
            return node.statement;
          }
          node = node.statement;
        }
      }
      ts3.unwrapInnermostStatementOfLabel = unwrapInnermostStatementOfLabel;
      function isFunctionBlock(node) {
        return node && node.kind === 231 && ts3.isFunctionLike(node.parent);
      }
      ts3.isFunctionBlock = isFunctionBlock;
      function isObjectLiteralMethod(node) {
        return node && node.kind === 166 && node.parent.kind === 201;
      }
      ts3.isObjectLiteralMethod = isObjectLiteralMethod;
      function isObjectLiteralOrClassExpressionMethod(node) {
        return node.kind === 166 && (node.parent.kind === 201 || node.parent.kind === 222);
      }
      ts3.isObjectLiteralOrClassExpressionMethod = isObjectLiteralOrClassExpressionMethod;
      function isIdentifierTypePredicate(predicate) {
        return predicate && predicate.kind === 1;
      }
      ts3.isIdentifierTypePredicate = isIdentifierTypePredicate;
      function isThisTypePredicate(predicate) {
        return predicate && predicate.kind === 0;
      }
      ts3.isThisTypePredicate = isThisTypePredicate;
      function getPropertyAssignment(objectLiteral, key2, key22) {
        return objectLiteral.properties.filter(function(property) {
          if (property.kind === 289) {
            var propName = getTextOfPropertyName(property.name);
            return key2 === propName || !!key22 && key22 === propName;
          }
          return false;
        });
      }
      ts3.getPropertyAssignment = getPropertyAssignment;
      function getPropertyArrayElementValue(objectLiteral, propKey, elementValue) {
        return ts3.firstDefined(getPropertyAssignment(objectLiteral, propKey), function(property) {
          return ts3.isArrayLiteralExpression(property.initializer) ? ts3.find(property.initializer.elements, function(element) {
            return ts3.isStringLiteral(element) && element.text === elementValue;
          }) : void 0;
        });
      }
      ts3.getPropertyArrayElementValue = getPropertyArrayElementValue;
      function getTsConfigObjectLiteralExpression(tsConfigSourceFile) {
        if (tsConfigSourceFile && tsConfigSourceFile.statements.length) {
          var expression = tsConfigSourceFile.statements[0].expression;
          return ts3.tryCast(expression, ts3.isObjectLiteralExpression);
        }
      }
      ts3.getTsConfigObjectLiteralExpression = getTsConfigObjectLiteralExpression;
      function getTsConfigPropArrayElementValue(tsConfigSourceFile, propKey, elementValue) {
        return ts3.firstDefined(getTsConfigPropArray(tsConfigSourceFile, propKey), function(property) {
          return ts3.isArrayLiteralExpression(property.initializer) ? ts3.find(property.initializer.elements, function(element) {
            return ts3.isStringLiteral(element) && element.text === elementValue;
          }) : void 0;
        });
      }
      ts3.getTsConfigPropArrayElementValue = getTsConfigPropArrayElementValue;
      function getTsConfigPropArray(tsConfigSourceFile, propKey) {
        var jsonObjectLiteral = getTsConfigObjectLiteralExpression(tsConfigSourceFile);
        return jsonObjectLiteral ? getPropertyAssignment(jsonObjectLiteral, propKey) : ts3.emptyArray;
      }
      ts3.getTsConfigPropArray = getTsConfigPropArray;
      function getContainingFunction(node) {
        return ts3.findAncestor(node.parent, ts3.isFunctionLike);
      }
      ts3.getContainingFunction = getContainingFunction;
      function getContainingFunctionDeclaration(node) {
        return ts3.findAncestor(node.parent, ts3.isFunctionLikeDeclaration);
      }
      ts3.getContainingFunctionDeclaration = getContainingFunctionDeclaration;
      function getContainingClass(node) {
        return ts3.findAncestor(node.parent, ts3.isClassLike);
      }
      ts3.getContainingClass = getContainingClass;
      function getThisContainer(node, includeArrowFunctions) {
        ts3.Debug.assert(node.kind !== 298);
        while (true) {
          node = node.parent;
          if (!node) {
            return ts3.Debug.fail();
          }
          switch (node.kind) {
            case 159:
              if (ts3.isClassLike(node.parent.parent)) {
                return node;
              }
              node = node.parent;
              break;
            case 162:
              if (node.parent.kind === 161 && ts3.isClassElement(node.parent.parent)) {
                node = node.parent.parent;
              } else if (ts3.isClassElement(node.parent)) {
                node = node.parent;
              }
              break;
            case 210:
              if (!includeArrowFunctions) {
                continue;
              }
            case 252:
            case 209:
            case 257:
            case 164:
            case 163:
            case 166:
            case 165:
            case 167:
            case 168:
            case 169:
            case 170:
            case 171:
            case 172:
            case 256:
            case 298:
              return node;
          }
        }
      }
      ts3.getThisContainer = getThisContainer;
      function isInTopLevelContext(node) {
        if (ts3.isIdentifier(node) && (ts3.isClassDeclaration(node.parent) || ts3.isFunctionDeclaration(node.parent)) && node.parent.name === node) {
          node = node.parent;
        }
        var container = getThisContainer(node, true);
        return ts3.isSourceFile(container);
      }
      ts3.isInTopLevelContext = isInTopLevelContext;
      function getNewTargetContainer(node) {
        var container = getThisContainer(node, false);
        if (container) {
          switch (container.kind) {
            case 167:
            case 252:
            case 209:
              return container;
          }
        }
        return void 0;
      }
      ts3.getNewTargetContainer = getNewTargetContainer;
      function getSuperContainer(node, stopOnFunctions) {
        while (true) {
          node = node.parent;
          if (!node) {
            return node;
          }
          switch (node.kind) {
            case 159:
              node = node.parent;
              break;
            case 252:
            case 209:
            case 210:
              if (!stopOnFunctions) {
                continue;
              }
            case 164:
            case 163:
            case 166:
            case 165:
            case 167:
            case 168:
            case 169:
              return node;
            case 162:
              if (node.parent.kind === 161 && ts3.isClassElement(node.parent.parent)) {
                node = node.parent.parent;
              } else if (ts3.isClassElement(node.parent)) {
                node = node.parent;
              }
              break;
          }
        }
      }
      ts3.getSuperContainer = getSuperContainer;
      function getImmediatelyInvokedFunctionExpression(func2) {
        if (func2.kind === 209 || func2.kind === 210) {
          var prev = func2;
          var parent = func2.parent;
          while (parent.kind === 208) {
            prev = parent;
            parent = parent.parent;
          }
          if (parent.kind === 204 && parent.expression === prev) {
            return parent;
          }
        }
      }
      ts3.getImmediatelyInvokedFunctionExpression = getImmediatelyInvokedFunctionExpression;
      function isSuperOrSuperProperty(node) {
        return node.kind === 105 || isSuperProperty(node);
      }
      ts3.isSuperOrSuperProperty = isSuperOrSuperProperty;
      function isSuperProperty(node) {
        var kind = node.kind;
        return (kind === 202 || kind === 203) && node.expression.kind === 105;
      }
      ts3.isSuperProperty = isSuperProperty;
      function isThisProperty(node) {
        var kind = node.kind;
        return (kind === 202 || kind === 203) && node.expression.kind === 107;
      }
      ts3.isThisProperty = isThisProperty;
      function isThisInitializedDeclaration(node) {
        var _a2;
        return !!node && ts3.isVariableDeclaration(node) && ((_a2 = node.initializer) === null || _a2 === void 0 ? void 0 : _a2.kind) === 107;
      }
      ts3.isThisInitializedDeclaration = isThisInitializedDeclaration;
      function isThisInitializedObjectBindingExpression(node) {
        return !!node && (ts3.isShorthandPropertyAssignment(node) || ts3.isPropertyAssignment(node)) && ts3.isBinaryExpression(node.parent.parent) && node.parent.parent.operatorToken.kind === 62 && node.parent.parent.right.kind === 107;
      }
      ts3.isThisInitializedObjectBindingExpression = isThisInitializedObjectBindingExpression;
      function getEntityNameFromTypeNode(node) {
        switch (node.kind) {
          case 174:
            return node.typeName;
          case 224:
            return isEntityNameExpression(node.expression) ? node.expression : void 0;
          case 78:
          case 158:
            return node;
        }
        return void 0;
      }
      ts3.getEntityNameFromTypeNode = getEntityNameFromTypeNode;
      function getInvokedExpression(node) {
        switch (node.kind) {
          case 206:
            return node.tag;
          case 276:
          case 275:
            return node.tagName;
          default:
            return node.expression;
        }
      }
      ts3.getInvokedExpression = getInvokedExpression;
      function nodeCanBeDecorated(node, parent, grandparent) {
        if (ts3.isNamedDeclaration(node) && ts3.isPrivateIdentifier(node.name)) {
          return false;
        }
        switch (node.kind) {
          case 253:
            return true;
          case 164:
            return parent.kind === 253;
          case 168:
          case 169:
          case 166:
            return node.body !== void 0 && parent.kind === 253;
          case 161:
            return parent.body !== void 0 && (parent.kind === 167 || parent.kind === 166 || parent.kind === 169) && grandparent.kind === 253;
        }
        return false;
      }
      ts3.nodeCanBeDecorated = nodeCanBeDecorated;
      function nodeIsDecorated(node, parent, grandparent) {
        return node.decorators !== void 0 && nodeCanBeDecorated(node, parent, grandparent);
      }
      ts3.nodeIsDecorated = nodeIsDecorated;
      function nodeOrChildIsDecorated(node, parent, grandparent) {
        return nodeIsDecorated(node, parent, grandparent) || childIsDecorated(node, parent);
      }
      ts3.nodeOrChildIsDecorated = nodeOrChildIsDecorated;
      function childIsDecorated(node, parent) {
        switch (node.kind) {
          case 253:
            return ts3.some(node.members, function(m) {
              return nodeOrChildIsDecorated(m, node, parent);
            });
          case 166:
          case 169:
            return ts3.some(node.parameters, function(p) {
              return nodeIsDecorated(p, node, parent);
            });
          default:
            return false;
        }
      }
      ts3.childIsDecorated = childIsDecorated;
      function isJSXTagName(node) {
        var parent = node.parent;
        if (parent.kind === 276 || parent.kind === 275 || parent.kind === 277) {
          return parent.tagName === node;
        }
        return false;
      }
      ts3.isJSXTagName = isJSXTagName;
      function isExpressionNode(node) {
        switch (node.kind) {
          case 105:
          case 103:
          case 109:
          case 94:
          case 13:
          case 200:
          case 201:
          case 202:
          case 203:
          case 204:
          case 205:
          case 206:
          case 225:
          case 207:
          case 226:
          case 208:
          case 209:
          case 222:
          case 210:
          case 213:
          case 211:
          case 212:
          case 215:
          case 216:
          case 217:
          case 218:
          case 221:
          case 219:
          case 223:
          case 274:
          case 275:
          case 278:
          case 220:
          case 214:
          case 227:
            return true;
          case 158:
            while (node.parent.kind === 158) {
              node = node.parent;
            }
            return node.parent.kind === 177 || isJSXTagName(node);
          case 78:
            if (node.parent.kind === 177 || isJSXTagName(node)) {
              return true;
            }
          case 8:
          case 9:
          case 10:
          case 14:
          case 107:
            return isInExpressionContext(node);
          default:
            return false;
        }
      }
      ts3.isExpressionNode = isExpressionNode;
      function isInExpressionContext(node) {
        var parent = node.parent;
        switch (parent.kind) {
          case 250:
          case 161:
          case 164:
          case 163:
          case 292:
          case 289:
          case 199:
            return parent.initializer === node;
          case 234:
          case 235:
          case 236:
          case 237:
          case 243:
          case 244:
          case 245:
          case 285:
          case 247:
            return parent.expression === node;
          case 238:
            var forStatement = parent;
            return forStatement.initializer === node && forStatement.initializer.kind !== 251 || forStatement.condition === node || forStatement.incrementor === node;
          case 239:
          case 240:
            var forInStatement = parent;
            return forInStatement.initializer === node && forInStatement.initializer.kind !== 251 || forInStatement.expression === node;
          case 207:
          case 225:
            return node === parent.expression;
          case 229:
            return node === parent.expression;
          case 159:
            return node === parent.expression;
          case 162:
          case 284:
          case 283:
          case 291:
            return true;
          case 224:
            return parent.expression === node && isExpressionWithTypeArgumentsInClassExtendsClause(parent);
          case 290:
            return parent.objectAssignmentInitializer === node;
          default:
            return isExpressionNode(parent);
        }
      }
      ts3.isInExpressionContext = isInExpressionContext;
      function isPartOfTypeQuery(node) {
        while (node.kind === 158 || node.kind === 78) {
          node = node.parent;
        }
        return node.kind === 177;
      }
      ts3.isPartOfTypeQuery = isPartOfTypeQuery;
      function isNamespaceReexportDeclaration(node) {
        return ts3.isNamespaceExport(node) && !!node.parent.moduleSpecifier;
      }
      ts3.isNamespaceReexportDeclaration = isNamespaceReexportDeclaration;
      function isExternalModuleImportEqualsDeclaration(node) {
        return node.kind === 261 && node.moduleReference.kind === 273;
      }
      ts3.isExternalModuleImportEqualsDeclaration = isExternalModuleImportEqualsDeclaration;
      function getExternalModuleImportEqualsDeclarationExpression(node) {
        ts3.Debug.assert(isExternalModuleImportEqualsDeclaration(node));
        return node.moduleReference.expression;
      }
      ts3.getExternalModuleImportEqualsDeclarationExpression = getExternalModuleImportEqualsDeclarationExpression;
      function getExternalModuleRequireArgument(node) {
        return isRequireVariableDeclaration(node) && getLeftmostAccessExpression(node.initializer).arguments[0];
      }
      ts3.getExternalModuleRequireArgument = getExternalModuleRequireArgument;
      function isInternalModuleImportEqualsDeclaration(node) {
        return node.kind === 261 && node.moduleReference.kind !== 273;
      }
      ts3.isInternalModuleImportEqualsDeclaration = isInternalModuleImportEqualsDeclaration;
      function isSourceFileJS(file) {
        return isInJSFile(file);
      }
      ts3.isSourceFileJS = isSourceFileJS;
      function isSourceFileNotJS(file) {
        return !isInJSFile(file);
      }
      ts3.isSourceFileNotJS = isSourceFileNotJS;
      function isInJSFile(node) {
        return !!node && !!(node.flags & 131072);
      }
      ts3.isInJSFile = isInJSFile;
      function isInJsonFile(node) {
        return !!node && !!(node.flags & 33554432);
      }
      ts3.isInJsonFile = isInJsonFile;
      function isSourceFileNotJson(file) {
        return !isJsonSourceFile(file);
      }
      ts3.isSourceFileNotJson = isSourceFileNotJson;
      function isInJSDoc(node) {
        return !!node && !!(node.flags & 4194304);
      }
      ts3.isInJSDoc = isInJSDoc;
      function isJSDocIndexSignature(node) {
        return ts3.isTypeReferenceNode(node) && ts3.isIdentifier(node.typeName) && node.typeName.escapedText === "Object" && node.typeArguments && node.typeArguments.length === 2 && (node.typeArguments[0].kind === 147 || node.typeArguments[0].kind === 144);
      }
      ts3.isJSDocIndexSignature = isJSDocIndexSignature;
      function isRequireCall(callExpression2, requireStringLiteralLikeArgument) {
        if (callExpression2.kind !== 204) {
          return false;
        }
        var _a2 = callExpression2, expression = _a2.expression, args = _a2.arguments;
        if (expression.kind !== 78 || expression.escapedText !== "require") {
          return false;
        }
        if (args.length !== 1) {
          return false;
        }
        var arg2 = args[0];
        return !requireStringLiteralLikeArgument || ts3.isStringLiteralLike(arg2);
      }
      ts3.isRequireCall = isRequireCall;
      function isRequireVariableDeclaration(node) {
        if (node.kind === 199) {
          node = node.parent.parent;
        }
        return ts3.isVariableDeclaration(node) && !!node.initializer && isRequireCall(getLeftmostAccessExpression(node.initializer), true);
      }
      ts3.isRequireVariableDeclaration = isRequireVariableDeclaration;
      function isRequireVariableStatement(node) {
        return ts3.isVariableStatement(node) && node.declarationList.declarations.length > 0 && ts3.every(node.declarationList.declarations, function(decl) {
          return isRequireVariableDeclaration(decl);
        });
      }
      ts3.isRequireVariableStatement = isRequireVariableStatement;
      function isSingleOrDoubleQuote(charCode) {
        return charCode === 39 || charCode === 34;
      }
      ts3.isSingleOrDoubleQuote = isSingleOrDoubleQuote;
      function isStringDoubleQuoted(str2, sourceFile) {
        return getSourceTextOfNodeFromSourceFile(sourceFile, str2).charCodeAt(0) === 34;
      }
      ts3.isStringDoubleQuoted = isStringDoubleQuoted;
      function isAssignmentDeclaration(decl) {
        return ts3.isBinaryExpression(decl) || isAccessExpression(decl) || ts3.isIdentifier(decl) || ts3.isCallExpression(decl);
      }
      ts3.isAssignmentDeclaration = isAssignmentDeclaration;
      function getEffectiveInitializer(node) {
        if (isInJSFile(node) && node.initializer && ts3.isBinaryExpression(node.initializer) && (node.initializer.operatorToken.kind === 56 || node.initializer.operatorToken.kind === 60) && node.name && isEntityNameExpression(node.name) && isSameEntityName(node.name, node.initializer.left)) {
          return node.initializer.right;
        }
        return node.initializer;
      }
      ts3.getEffectiveInitializer = getEffectiveInitializer;
      function getDeclaredExpandoInitializer(node) {
        var init = getEffectiveInitializer(node);
        return init && getExpandoInitializer(init, isPrototypeAccess(node.name));
      }
      ts3.getDeclaredExpandoInitializer = getDeclaredExpandoInitializer;
      function hasExpandoValueProperty(node, isPrototypeAssignment) {
        return ts3.forEach(node.properties, function(p) {
          return ts3.isPropertyAssignment(p) && ts3.isIdentifier(p.name) && p.name.escapedText === "value" && p.initializer && getExpandoInitializer(p.initializer, isPrototypeAssignment);
        });
      }
      function getAssignedExpandoInitializer(node) {
        if (node && node.parent && ts3.isBinaryExpression(node.parent) && node.parent.operatorToken.kind === 62) {
          var isPrototypeAssignment = isPrototypeAccess(node.parent.left);
          return getExpandoInitializer(node.parent.right, isPrototypeAssignment) || getDefaultedExpandoInitializer(node.parent.left, node.parent.right, isPrototypeAssignment);
        }
        if (node && ts3.isCallExpression(node) && isBindableObjectDefinePropertyCall(node)) {
          var result2 = hasExpandoValueProperty(node.arguments[2], node.arguments[1].text === "prototype");
          if (result2) {
            return result2;
          }
        }
      }
      ts3.getAssignedExpandoInitializer = getAssignedExpandoInitializer;
      function getExpandoInitializer(initializer, isPrototypeAssignment) {
        if (ts3.isCallExpression(initializer)) {
          var e2 = skipParentheses(initializer.expression);
          return e2.kind === 209 || e2.kind === 210 ? initializer : void 0;
        }
        if (initializer.kind === 209 || initializer.kind === 222 || initializer.kind === 210) {
          return initializer;
        }
        if (ts3.isObjectLiteralExpression(initializer) && (initializer.properties.length === 0 || isPrototypeAssignment)) {
          return initializer;
        }
      }
      ts3.getExpandoInitializer = getExpandoInitializer;
      function getDefaultedExpandoInitializer(name, initializer, isPrototypeAssignment) {
        var e2 = ts3.isBinaryExpression(initializer) && (initializer.operatorToken.kind === 56 || initializer.operatorToken.kind === 60) && getExpandoInitializer(initializer.right, isPrototypeAssignment);
        if (e2 && isSameEntityName(name, initializer.left)) {
          return e2;
        }
      }
      function isDefaultedExpandoInitializer(node) {
        var name = ts3.isVariableDeclaration(node.parent) ? node.parent.name : ts3.isBinaryExpression(node.parent) && node.parent.operatorToken.kind === 62 ? node.parent.left : void 0;
        return name && getExpandoInitializer(node.right, isPrototypeAccess(name)) && isEntityNameExpression(name) && isSameEntityName(name, node.left);
      }
      ts3.isDefaultedExpandoInitializer = isDefaultedExpandoInitializer;
      function getNameOfExpando(node) {
        if (ts3.isBinaryExpression(node.parent)) {
          var parent = (node.parent.operatorToken.kind === 56 || node.parent.operatorToken.kind === 60) && ts3.isBinaryExpression(node.parent.parent) ? node.parent.parent : node.parent;
          if (parent.operatorToken.kind === 62 && ts3.isIdentifier(parent.left)) {
            return parent.left;
          }
        } else if (ts3.isVariableDeclaration(node.parent)) {
          return node.parent.name;
        }
      }
      ts3.getNameOfExpando = getNameOfExpando;
      function isSameEntityName(name, initializer) {
        if (isPropertyNameLiteral(name) && isPropertyNameLiteral(initializer)) {
          return getTextOfIdentifierOrLiteral(name) === getTextOfIdentifierOrLiteral(initializer);
        }
        if (ts3.isIdentifier(name) && isLiteralLikeAccess(initializer) && (initializer.expression.kind === 107 || ts3.isIdentifier(initializer.expression) && (initializer.expression.escapedText === "window" || initializer.expression.escapedText === "self" || initializer.expression.escapedText === "global"))) {
          var nameOrArgument = getNameOrArgument(initializer);
          if (ts3.isPrivateIdentifier(nameOrArgument)) {
            ts3.Debug.fail("Unexpected PrivateIdentifier in name expression with literal-like access.");
          }
          return isSameEntityName(name, nameOrArgument);
        }
        if (isLiteralLikeAccess(name) && isLiteralLikeAccess(initializer)) {
          return getElementOrPropertyAccessName(name) === getElementOrPropertyAccessName(initializer) && isSameEntityName(name.expression, initializer.expression);
        }
        return false;
      }
      ts3.isSameEntityName = isSameEntityName;
      function getRightMostAssignedExpression(node) {
        while (isAssignmentExpression(node, true)) {
          node = node.right;
        }
        return node;
      }
      ts3.getRightMostAssignedExpression = getRightMostAssignedExpression;
      function isExportsIdentifier(node) {
        return ts3.isIdentifier(node) && node.escapedText === "exports";
      }
      ts3.isExportsIdentifier = isExportsIdentifier;
      function isModuleIdentifier(node) {
        return ts3.isIdentifier(node) && node.escapedText === "module";
      }
      ts3.isModuleIdentifier = isModuleIdentifier;
      function isModuleExportsAccessExpression(node) {
        return (ts3.isPropertyAccessExpression(node) || isLiteralLikeElementAccess(node)) && isModuleIdentifier(node.expression) && getElementOrPropertyAccessName(node) === "exports";
      }
      ts3.isModuleExportsAccessExpression = isModuleExportsAccessExpression;
      function getAssignmentDeclarationKind(expr) {
        var special = getAssignmentDeclarationKindWorker(expr);
        return special === 5 || isInJSFile(expr) ? special : 0;
      }
      ts3.getAssignmentDeclarationKind = getAssignmentDeclarationKind;
      function isBindableObjectDefinePropertyCall(expr) {
        return ts3.length(expr.arguments) === 3 && ts3.isPropertyAccessExpression(expr.expression) && ts3.isIdentifier(expr.expression.expression) && ts3.idText(expr.expression.expression) === "Object" && ts3.idText(expr.expression.name) === "defineProperty" && isStringOrNumericLiteralLike(expr.arguments[1]) && isBindableStaticNameExpression(expr.arguments[0], true);
      }
      ts3.isBindableObjectDefinePropertyCall = isBindableObjectDefinePropertyCall;
      function isLiteralLikeAccess(node) {
        return ts3.isPropertyAccessExpression(node) || isLiteralLikeElementAccess(node);
      }
      ts3.isLiteralLikeAccess = isLiteralLikeAccess;
      function isLiteralLikeElementAccess(node) {
        return ts3.isElementAccessExpression(node) && isStringOrNumericLiteralLike(node.argumentExpression);
      }
      ts3.isLiteralLikeElementAccess = isLiteralLikeElementAccess;
      function isBindableStaticAccessExpression(node, excludeThisKeyword) {
        return ts3.isPropertyAccessExpression(node) && (!excludeThisKeyword && node.expression.kind === 107 || ts3.isIdentifier(node.name) && isBindableStaticNameExpression(node.expression, true)) || isBindableStaticElementAccessExpression(node, excludeThisKeyword);
      }
      ts3.isBindableStaticAccessExpression = isBindableStaticAccessExpression;
      function isBindableStaticElementAccessExpression(node, excludeThisKeyword) {
        return isLiteralLikeElementAccess(node) && (!excludeThisKeyword && node.expression.kind === 107 || isEntityNameExpression(node.expression) || isBindableStaticAccessExpression(node.expression, true));
      }
      ts3.isBindableStaticElementAccessExpression = isBindableStaticElementAccessExpression;
      function isBindableStaticNameExpression(node, excludeThisKeyword) {
        return isEntityNameExpression(node) || isBindableStaticAccessExpression(node, excludeThisKeyword);
      }
      ts3.isBindableStaticNameExpression = isBindableStaticNameExpression;
      function getNameOrArgument(expr) {
        if (ts3.isPropertyAccessExpression(expr)) {
          return expr.name;
        }
        return expr.argumentExpression;
      }
      ts3.getNameOrArgument = getNameOrArgument;
      function getAssignmentDeclarationKindWorker(expr) {
        if (ts3.isCallExpression(expr)) {
          if (!isBindableObjectDefinePropertyCall(expr)) {
            return 0;
          }
          var entityName = expr.arguments[0];
          if (isExportsIdentifier(entityName) || isModuleExportsAccessExpression(entityName)) {
            return 8;
          }
          if (isBindableStaticAccessExpression(entityName) && getElementOrPropertyAccessName(entityName) === "prototype") {
            return 9;
          }
          return 7;
        }
        if (expr.operatorToken.kind !== 62 || !isAccessExpression(expr.left) || isVoidZero(getRightMostAssignedExpression(expr))) {
          return 0;
        }
        if (isBindableStaticNameExpression(expr.left.expression, true) && getElementOrPropertyAccessName(expr.left) === "prototype" && ts3.isObjectLiteralExpression(getInitializerOfBinaryExpression(expr))) {
          return 6;
        }
        return getAssignmentDeclarationPropertyAccessKind(expr.left);
      }
      function isVoidZero(node) {
        return ts3.isVoidExpression(node) && ts3.isNumericLiteral(node.expression) && node.expression.text === "0";
      }
      function getElementOrPropertyAccessArgumentExpressionOrName(node) {
        if (ts3.isPropertyAccessExpression(node)) {
          return node.name;
        }
        var arg2 = skipParentheses(node.argumentExpression);
        if (ts3.isNumericLiteral(arg2) || ts3.isStringLiteralLike(arg2)) {
          return arg2;
        }
        return node;
      }
      ts3.getElementOrPropertyAccessArgumentExpressionOrName = getElementOrPropertyAccessArgumentExpressionOrName;
      function getElementOrPropertyAccessName(node) {
        var name = getElementOrPropertyAccessArgumentExpressionOrName(node);
        if (name) {
          if (ts3.isIdentifier(name)) {
            return name.escapedText;
          }
          if (ts3.isStringLiteralLike(name) || ts3.isNumericLiteral(name)) {
            return ts3.escapeLeadingUnderscores(name.text);
          }
        }
        return void 0;
      }
      ts3.getElementOrPropertyAccessName = getElementOrPropertyAccessName;
      function getAssignmentDeclarationPropertyAccessKind(lhs) {
        if (lhs.expression.kind === 107) {
          return 4;
        } else if (isModuleExportsAccessExpression(lhs)) {
          return 2;
        } else if (isBindableStaticNameExpression(lhs.expression, true)) {
          if (isPrototypeAccess(lhs.expression)) {
            return 3;
          }
          var nextToLast = lhs;
          while (!ts3.isIdentifier(nextToLast.expression)) {
            nextToLast = nextToLast.expression;
          }
          var id = nextToLast.expression;
          if ((id.escapedText === "exports" || id.escapedText === "module" && getElementOrPropertyAccessName(nextToLast) === "exports") && isBindableStaticAccessExpression(lhs)) {
            return 1;
          }
          if (isBindableStaticNameExpression(lhs, true) || ts3.isElementAccessExpression(lhs) && isDynamicName(lhs)) {
            return 5;
          }
        }
        return 0;
      }
      ts3.getAssignmentDeclarationPropertyAccessKind = getAssignmentDeclarationPropertyAccessKind;
      function getInitializerOfBinaryExpression(expr) {
        while (ts3.isBinaryExpression(expr.right)) {
          expr = expr.right;
        }
        return expr.right;
      }
      ts3.getInitializerOfBinaryExpression = getInitializerOfBinaryExpression;
      function isPrototypePropertyAssignment(node) {
        return ts3.isBinaryExpression(node) && getAssignmentDeclarationKind(node) === 3;
      }
      ts3.isPrototypePropertyAssignment = isPrototypePropertyAssignment;
      function isSpecialPropertyDeclaration(expr) {
        return isInJSFile(expr) && expr.parent && expr.parent.kind === 234 && (!ts3.isElementAccessExpression(expr) || isLiteralLikeElementAccess(expr)) && !!ts3.getJSDocTypeTag(expr.parent);
      }
      ts3.isSpecialPropertyDeclaration = isSpecialPropertyDeclaration;
      function setValueDeclaration(symbol, node) {
        var valueDeclaration = symbol.valueDeclaration;
        if (!valueDeclaration || !(node.flags & 8388608 && !(valueDeclaration.flags & 8388608)) && (isAssignmentDeclaration(valueDeclaration) && !isAssignmentDeclaration(node)) || valueDeclaration.kind !== node.kind && isEffectiveModuleDeclaration(valueDeclaration)) {
          symbol.valueDeclaration = node;
        }
      }
      ts3.setValueDeclaration = setValueDeclaration;
      function isFunctionSymbol(symbol) {
        if (!symbol || !symbol.valueDeclaration) {
          return false;
        }
        var decl = symbol.valueDeclaration;
        return decl.kind === 252 || ts3.isVariableDeclaration(decl) && decl.initializer && ts3.isFunctionLike(decl.initializer);
      }
      ts3.isFunctionSymbol = isFunctionSymbol;
      function tryGetModuleSpecifierFromDeclaration(node) {
        var _a2, _b, _c;
        switch (node.kind) {
          case 250:
            return node.initializer.arguments[0].text;
          case 262:
            return (_a2 = ts3.tryCast(node.moduleSpecifier, ts3.isStringLiteralLike)) === null || _a2 === void 0 ? void 0 : _a2.text;
          case 261:
            return (_c = ts3.tryCast((_b = ts3.tryCast(node.moduleReference, ts3.isExternalModuleReference)) === null || _b === void 0 ? void 0 : _b.expression, ts3.isStringLiteralLike)) === null || _c === void 0 ? void 0 : _c.text;
          default:
            ts3.Debug.assertNever(node);
        }
      }
      ts3.tryGetModuleSpecifierFromDeclaration = tryGetModuleSpecifierFromDeclaration;
      function importFromModuleSpecifier(node) {
        return tryGetImportFromModuleSpecifier(node) || ts3.Debug.failBadSyntaxKind(node.parent);
      }
      ts3.importFromModuleSpecifier = importFromModuleSpecifier;
      function tryGetImportFromModuleSpecifier(node) {
        switch (node.parent.kind) {
          case 262:
          case 268:
            return node.parent;
          case 273:
            return node.parent.parent;
          case 204:
            return isImportCall(node.parent) || isRequireCall(node.parent, false) ? node.parent : void 0;
          case 192:
            ts3.Debug.assert(ts3.isStringLiteral(node));
            return ts3.tryCast(node.parent.parent, ts3.isImportTypeNode);
          default:
            return void 0;
        }
      }
      ts3.tryGetImportFromModuleSpecifier = tryGetImportFromModuleSpecifier;
      function getExternalModuleName(node) {
        switch (node.kind) {
          case 262:
          case 268:
            return node.moduleSpecifier;
          case 261:
            return node.moduleReference.kind === 273 ? node.moduleReference.expression : void 0;
          case 196:
            return isLiteralImportTypeNode(node) ? node.argument.literal : void 0;
          case 204:
            return node.arguments[0];
          case 257:
            return node.name.kind === 10 ? node.name : void 0;
          default:
            return ts3.Debug.assertNever(node);
        }
      }
      ts3.getExternalModuleName = getExternalModuleName;
      function getNamespaceDeclarationNode(node) {
        switch (node.kind) {
          case 262:
            return node.importClause && ts3.tryCast(node.importClause.namedBindings, ts3.isNamespaceImport);
          case 261:
            return node;
          case 268:
            return node.exportClause && ts3.tryCast(node.exportClause, ts3.isNamespaceExport);
          default:
            return ts3.Debug.assertNever(node);
        }
      }
      ts3.getNamespaceDeclarationNode = getNamespaceDeclarationNode;
      function isDefaultImport(node) {
        return node.kind === 262 && !!node.importClause && !!node.importClause.name;
      }
      ts3.isDefaultImport = isDefaultImport;
      function forEachImportClauseDeclaration(node, action) {
        if (node.name) {
          var result2 = action(node);
          if (result2)
            return result2;
        }
        if (node.namedBindings) {
          var result2 = ts3.isNamespaceImport(node.namedBindings) ? action(node.namedBindings) : ts3.forEach(node.namedBindings.elements, action);
          if (result2)
            return result2;
        }
      }
      ts3.forEachImportClauseDeclaration = forEachImportClauseDeclaration;
      function hasQuestionToken(node) {
        if (node) {
          switch (node.kind) {
            case 161:
            case 166:
            case 165:
            case 290:
            case 289:
            case 164:
            case 163:
              return node.questionToken !== void 0;
          }
        }
        return false;
      }
      ts3.hasQuestionToken = hasQuestionToken;
      function isJSDocConstructSignature(node) {
        var param = ts3.isJSDocFunctionType(node) ? ts3.firstOrUndefined(node.parameters) : void 0;
        var name = ts3.tryCast(param && param.name, ts3.isIdentifier);
        return !!name && name.escapedText === "new";
      }
      ts3.isJSDocConstructSignature = isJSDocConstructSignature;
      function isJSDocTypeAlias(node) {
        return node.kind === 335 || node.kind === 328 || node.kind === 329;
      }
      ts3.isJSDocTypeAlias = isJSDocTypeAlias;
      function isTypeAlias(node) {
        return isJSDocTypeAlias(node) || ts3.isTypeAliasDeclaration(node);
      }
      ts3.isTypeAlias = isTypeAlias;
      function getSourceOfAssignment(node) {
        return ts3.isExpressionStatement(node) && ts3.isBinaryExpression(node.expression) && node.expression.operatorToken.kind === 62 ? getRightMostAssignedExpression(node.expression) : void 0;
      }
      function getSourceOfDefaultedAssignment(node) {
        return ts3.isExpressionStatement(node) && ts3.isBinaryExpression(node.expression) && getAssignmentDeclarationKind(node.expression) !== 0 && ts3.isBinaryExpression(node.expression.right) && (node.expression.right.operatorToken.kind === 56 || node.expression.right.operatorToken.kind === 60) ? node.expression.right.right : void 0;
      }
      function getSingleInitializerOfVariableStatementOrPropertyDeclaration(node) {
        switch (node.kind) {
          case 233:
            var v = getSingleVariableOfVariableStatement(node);
            return v && v.initializer;
          case 164:
            return node.initializer;
          case 289:
            return node.initializer;
        }
      }
      ts3.getSingleInitializerOfVariableStatementOrPropertyDeclaration = getSingleInitializerOfVariableStatementOrPropertyDeclaration;
      function getSingleVariableOfVariableStatement(node) {
        return ts3.isVariableStatement(node) ? ts3.firstOrUndefined(node.declarationList.declarations) : void 0;
      }
      ts3.getSingleVariableOfVariableStatement = getSingleVariableOfVariableStatement;
      function getNestedModuleDeclaration(node) {
        return ts3.isModuleDeclaration(node) && node.body && node.body.kind === 257 ? node.body : void 0;
      }
      function getJSDocCommentsAndTags(hostNode, noCache) {
        var result2;
        if (isVariableLike(hostNode) && ts3.hasInitializer(hostNode) && ts3.hasJSDocNodes(hostNode.initializer)) {
          result2 = ts3.append(result2, ts3.last(hostNode.initializer.jsDoc));
        }
        var node = hostNode;
        while (node && node.parent) {
          if (ts3.hasJSDocNodes(node)) {
            result2 = ts3.append(result2, ts3.last(node.jsDoc));
          }
          if (node.kind === 161) {
            result2 = ts3.addRange(result2, (noCache ? ts3.getJSDocParameterTagsNoCache : ts3.getJSDocParameterTags)(node));
            break;
          }
          if (node.kind === 160) {
            result2 = ts3.addRange(result2, (noCache ? ts3.getJSDocTypeParameterTagsNoCache : ts3.getJSDocTypeParameterTags)(node));
            break;
          }
          node = getNextJSDocCommentLocation(node);
        }
        return result2 || ts3.emptyArray;
      }
      ts3.getJSDocCommentsAndTags = getJSDocCommentsAndTags;
      function getNextJSDocCommentLocation(node) {
        var parent = node.parent;
        if (parent.kind === 289 || parent.kind === 267 || parent.kind === 164 || parent.kind === 234 && node.kind === 202 || parent.kind === 243 || getNestedModuleDeclaration(parent) || ts3.isBinaryExpression(node) && node.operatorToken.kind === 62) {
          return parent;
        } else if (parent.parent && (getSingleVariableOfVariableStatement(parent.parent) === node || ts3.isBinaryExpression(parent) && parent.operatorToken.kind === 62)) {
          return parent.parent;
        } else if (parent.parent && parent.parent.parent && (getSingleVariableOfVariableStatement(parent.parent.parent) || getSingleInitializerOfVariableStatementOrPropertyDeclaration(parent.parent.parent) === node || getSourceOfDefaultedAssignment(parent.parent.parent))) {
          return parent.parent.parent;
        }
      }
      ts3.getNextJSDocCommentLocation = getNextJSDocCommentLocation;
      function getParameterSymbolFromJSDoc(node) {
        if (node.symbol) {
          return node.symbol;
        }
        if (!ts3.isIdentifier(node.name)) {
          return void 0;
        }
        var name = node.name.escapedText;
        var decl = getHostSignatureFromJSDoc(node);
        if (!decl) {
          return void 0;
        }
        var parameter = ts3.find(decl.parameters, function(p) {
          return p.name.kind === 78 && p.name.escapedText === name;
        });
        return parameter && parameter.symbol;
      }
      ts3.getParameterSymbolFromJSDoc = getParameterSymbolFromJSDoc;
      function getHostSignatureFromJSDoc(node) {
        var host = getEffectiveJSDocHost(node);
        return host && ts3.isFunctionLike(host) ? host : void 0;
      }
      ts3.getHostSignatureFromJSDoc = getHostSignatureFromJSDoc;
      function getEffectiveJSDocHost(node) {
        var host = getJSDocHost(node);
        if (host) {
          return getSourceOfDefaultedAssignment(host) || getSourceOfAssignment(host) || getSingleInitializerOfVariableStatementOrPropertyDeclaration(host) || getSingleVariableOfVariableStatement(host) || getNestedModuleDeclaration(host) || host;
        }
      }
      ts3.getEffectiveJSDocHost = getEffectiveJSDocHost;
      function getJSDocHost(node) {
        var jsDoc = getJSDocRoot(node);
        if (!jsDoc) {
          return void 0;
        }
        var host = jsDoc.parent;
        if (host && host.jsDoc && jsDoc === ts3.lastOrUndefined(host.jsDoc)) {
          return host;
        }
      }
      ts3.getJSDocHost = getJSDocHost;
      function getJSDocRoot(node) {
        return ts3.findAncestor(node.parent, ts3.isJSDoc);
      }
      ts3.getJSDocRoot = getJSDocRoot;
      function getTypeParameterFromJsDoc(node) {
        var name = node.name.escapedText;
        var typeParameters = node.parent.parent.parent.typeParameters;
        return typeParameters && ts3.find(typeParameters, function(p) {
          return p.name.escapedText === name;
        });
      }
      ts3.getTypeParameterFromJsDoc = getTypeParameterFromJsDoc;
      function hasRestParameter(s2) {
        var last = ts3.lastOrUndefined(s2.parameters);
        return !!last && isRestParameter(last);
      }
      ts3.hasRestParameter = hasRestParameter;
      function isRestParameter(node) {
        var type3 = ts3.isJSDocParameterTag(node) ? node.typeExpression && node.typeExpression.type : node.type;
        return node.dotDotDotToken !== void 0 || !!type3 && type3.kind === 310;
      }
      ts3.isRestParameter = isRestParameter;
      function hasTypeArguments(node) {
        return !!node.typeArguments;
      }
      ts3.hasTypeArguments = hasTypeArguments;
      var AssignmentKind;
      (function(AssignmentKind2) {
        AssignmentKind2[AssignmentKind2["None"] = 0] = "None";
        AssignmentKind2[AssignmentKind2["Definite"] = 1] = "Definite";
        AssignmentKind2[AssignmentKind2["Compound"] = 2] = "Compound";
      })(AssignmentKind = ts3.AssignmentKind || (ts3.AssignmentKind = {}));
      function getAssignmentTargetKind(node) {
        var parent = node.parent;
        while (true) {
          switch (parent.kind) {
            case 217:
              var binaryOperator = parent.operatorToken.kind;
              return isAssignmentOperator(binaryOperator) && parent.left === node ? binaryOperator === 62 || isLogicalOrCoalescingAssignmentOperator(binaryOperator) ? 1 : 2 : 0;
            case 215:
            case 216:
              var unaryOperator = parent.operator;
              return unaryOperator === 45 || unaryOperator === 46 ? 2 : 0;
            case 239:
            case 240:
              return parent.initializer === node ? 1 : 0;
            case 208:
            case 200:
            case 221:
            case 226:
              node = parent;
              break;
            case 291:
              node = parent.parent;
              break;
            case 290:
              if (parent.name !== node) {
                return 0;
              }
              node = parent.parent;
              break;
            case 289:
              if (parent.name === node) {
                return 0;
              }
              node = parent.parent;
              break;
            default:
              return 0;
          }
          parent = node.parent;
        }
      }
      ts3.getAssignmentTargetKind = getAssignmentTargetKind;
      function isAssignmentTarget(node) {
        return getAssignmentTargetKind(node) !== 0;
      }
      ts3.isAssignmentTarget = isAssignmentTarget;
      function isNodeWithPossibleHoistedDeclaration(node) {
        switch (node.kind) {
          case 231:
          case 233:
          case 244:
          case 235:
          case 245:
          case 259:
          case 285:
          case 286:
          case 246:
          case 238:
          case 239:
          case 240:
          case 236:
          case 237:
          case 248:
          case 288:
            return true;
        }
        return false;
      }
      ts3.isNodeWithPossibleHoistedDeclaration = isNodeWithPossibleHoistedDeclaration;
      function isValueSignatureDeclaration(node) {
        return ts3.isFunctionExpression(node) || ts3.isArrowFunction(node) || ts3.isMethodOrAccessor(node) || ts3.isFunctionDeclaration(node) || ts3.isConstructorDeclaration(node);
      }
      ts3.isValueSignatureDeclaration = isValueSignatureDeclaration;
      function walkUp(node, kind) {
        while (node && node.kind === kind) {
          node = node.parent;
        }
        return node;
      }
      function walkUpParenthesizedTypes(node) {
        return walkUp(node, 187);
      }
      ts3.walkUpParenthesizedTypes = walkUpParenthesizedTypes;
      function walkUpParenthesizedExpressions(node) {
        return walkUp(node, 208);
      }
      ts3.walkUpParenthesizedExpressions = walkUpParenthesizedExpressions;
      function walkUpParenthesizedTypesAndGetParentAndChild(node) {
        var child;
        while (node && node.kind === 187) {
          child = node;
          node = node.parent;
        }
        return [child, node];
      }
      ts3.walkUpParenthesizedTypesAndGetParentAndChild = walkUpParenthesizedTypesAndGetParentAndChild;
      function skipParentheses(node) {
        return ts3.skipOuterExpressions(node, 1);
      }
      ts3.skipParentheses = skipParentheses;
      function skipParenthesesUp(node) {
        while (node.kind === 208) {
          node = node.parent;
        }
        return node;
      }
      function isDeleteTarget(node) {
        if (node.kind !== 202 && node.kind !== 203) {
          return false;
        }
        node = walkUpParenthesizedExpressions(node.parent);
        return node && node.kind === 211;
      }
      ts3.isDeleteTarget = isDeleteTarget;
      function isNodeDescendantOf(node, ancestor) {
        while (node) {
          if (node === ancestor)
            return true;
          node = node.parent;
        }
        return false;
      }
      ts3.isNodeDescendantOf = isNodeDescendantOf;
      function isDeclarationName(name) {
        return !ts3.isSourceFile(name) && !ts3.isBindingPattern(name) && ts3.isDeclaration(name.parent) && name.parent.name === name;
      }
      ts3.isDeclarationName = isDeclarationName;
      function getDeclarationFromName(name) {
        var parent = name.parent;
        switch (name.kind) {
          case 10:
          case 14:
          case 8:
            if (ts3.isComputedPropertyName(parent))
              return parent.parent;
          case 78:
            if (ts3.isDeclaration(parent)) {
              return parent.name === name ? parent : void 0;
            } else if (ts3.isQualifiedName(parent)) {
              var tag = parent.parent;
              return ts3.isJSDocParameterTag(tag) && tag.name === parent ? tag : void 0;
            } else {
              var binExp = parent.parent;
              return ts3.isBinaryExpression(binExp) && getAssignmentDeclarationKind(binExp) !== 0 && (binExp.left.symbol || binExp.symbol) && ts3.getNameOfDeclaration(binExp) === name ? binExp : void 0;
            }
          case 79:
            return ts3.isDeclaration(parent) && parent.name === name ? parent : void 0;
          default:
            return void 0;
        }
      }
      ts3.getDeclarationFromName = getDeclarationFromName;
      function isLiteralComputedPropertyDeclarationName(node) {
        return isStringOrNumericLiteralLike(node) && node.parent.kind === 159 && ts3.isDeclaration(node.parent.parent);
      }
      ts3.isLiteralComputedPropertyDeclarationName = isLiteralComputedPropertyDeclarationName;
      function isIdentifierName(node) {
        var parent = node.parent;
        switch (parent.kind) {
          case 164:
          case 163:
          case 166:
          case 165:
          case 168:
          case 169:
          case 292:
          case 289:
          case 202:
            return parent.name === node;
          case 158:
            return parent.right === node;
          case 199:
          case 266:
            return parent.propertyName === node;
          case 271:
          case 281:
            return true;
        }
        return false;
      }
      ts3.isIdentifierName = isIdentifierName;
      function isAliasSymbolDeclaration(node) {
        return node.kind === 261 || node.kind === 260 || node.kind === 263 && !!node.name || node.kind === 264 || node.kind === 270 || node.kind === 266 || node.kind === 271 || node.kind === 267 && exportAssignmentIsAlias(node) || ts3.isBinaryExpression(node) && getAssignmentDeclarationKind(node) === 2 && exportAssignmentIsAlias(node) || ts3.isPropertyAccessExpression(node) && ts3.isBinaryExpression(node.parent) && node.parent.left === node && node.parent.operatorToken.kind === 62 && isAliasableExpression(node.parent.right) || node.kind === 290 || node.kind === 289 && isAliasableExpression(node.initializer);
      }
      ts3.isAliasSymbolDeclaration = isAliasSymbolDeclaration;
      function getAliasDeclarationFromName(node) {
        switch (node.parent.kind) {
          case 263:
          case 266:
          case 264:
          case 271:
          case 267:
          case 261:
            return node.parent;
          case 158:
            do {
              node = node.parent;
            } while (node.parent.kind === 158);
            return getAliasDeclarationFromName(node);
        }
      }
      ts3.getAliasDeclarationFromName = getAliasDeclarationFromName;
      function isAliasableExpression(e2) {
        return isEntityNameExpression(e2) || ts3.isClassExpression(e2);
      }
      ts3.isAliasableExpression = isAliasableExpression;
      function exportAssignmentIsAlias(node) {
        var e2 = getExportAssignmentExpression(node);
        return isAliasableExpression(e2);
      }
      ts3.exportAssignmentIsAlias = exportAssignmentIsAlias;
      function getExportAssignmentExpression(node) {
        return ts3.isExportAssignment(node) ? node.expression : node.right;
      }
      ts3.getExportAssignmentExpression = getExportAssignmentExpression;
      function getPropertyAssignmentAliasLikeExpression(node) {
        return node.kind === 290 ? node.name : node.kind === 289 ? node.initializer : node.parent.right;
      }
      ts3.getPropertyAssignmentAliasLikeExpression = getPropertyAssignmentAliasLikeExpression;
      function getEffectiveBaseTypeNode(node) {
        var baseType = getClassExtendsHeritageElement(node);
        if (baseType && isInJSFile(node)) {
          var tag = ts3.getJSDocAugmentsTag(node);
          if (tag) {
            return tag.class;
          }
        }
        return baseType;
      }
      ts3.getEffectiveBaseTypeNode = getEffectiveBaseTypeNode;
      function getClassExtendsHeritageElement(node) {
        var heritageClause = getHeritageClause(node.heritageClauses, 93);
        return heritageClause && heritageClause.types.length > 0 ? heritageClause.types[0] : void 0;
      }
      ts3.getClassExtendsHeritageElement = getClassExtendsHeritageElement;
      function getEffectiveImplementsTypeNodes(node) {
        if (isInJSFile(node)) {
          return ts3.getJSDocImplementsTags(node).map(function(n2) {
            return n2.class;
          });
        } else {
          var heritageClause = getHeritageClause(node.heritageClauses, 116);
          return heritageClause === null || heritageClause === void 0 ? void 0 : heritageClause.types;
        }
      }
      ts3.getEffectiveImplementsTypeNodes = getEffectiveImplementsTypeNodes;
      function getAllSuperTypeNodes(node) {
        return ts3.isInterfaceDeclaration(node) ? getInterfaceBaseTypeNodes(node) || ts3.emptyArray : ts3.isClassLike(node) ? ts3.concatenate(ts3.singleElementArray(getEffectiveBaseTypeNode(node)), getEffectiveImplementsTypeNodes(node)) || ts3.emptyArray : ts3.emptyArray;
      }
      ts3.getAllSuperTypeNodes = getAllSuperTypeNodes;
      function getInterfaceBaseTypeNodes(node) {
        var heritageClause = getHeritageClause(node.heritageClauses, 93);
        return heritageClause ? heritageClause.types : void 0;
      }
      ts3.getInterfaceBaseTypeNodes = getInterfaceBaseTypeNodes;
      function getHeritageClause(clauses, kind) {
        if (clauses) {
          for (var _i = 0, clauses_1 = clauses; _i < clauses_1.length; _i++) {
            var clause = clauses_1[_i];
            if (clause.token === kind) {
              return clause;
            }
          }
        }
        return void 0;
      }
      ts3.getHeritageClause = getHeritageClause;
      function getAncestor(node, kind) {
        while (node) {
          if (node.kind === kind) {
            return node;
          }
          node = node.parent;
        }
        return void 0;
      }
      ts3.getAncestor = getAncestor;
      function isKeyword(token) {
        return 80 <= token && token <= 157;
      }
      ts3.isKeyword = isKeyword;
      function isContextualKeyword(token) {
        return 125 <= token && token <= 157;
      }
      ts3.isContextualKeyword = isContextualKeyword;
      function isNonContextualKeyword(token) {
        return isKeyword(token) && !isContextualKeyword(token);
      }
      ts3.isNonContextualKeyword = isNonContextualKeyword;
      function isFutureReservedKeyword(token) {
        return 116 <= token && token <= 124;
      }
      ts3.isFutureReservedKeyword = isFutureReservedKeyword;
      function isStringANonContextualKeyword(name) {
        var token = ts3.stringToToken(name);
        return token !== void 0 && isNonContextualKeyword(token);
      }
      ts3.isStringANonContextualKeyword = isStringANonContextualKeyword;
      function isStringAKeyword(name) {
        var token = ts3.stringToToken(name);
        return token !== void 0 && isKeyword(token);
      }
      ts3.isStringAKeyword = isStringAKeyword;
      function isIdentifierANonContextualKeyword(_a2) {
        var originalKeywordKind = _a2.originalKeywordKind;
        return !!originalKeywordKind && !isContextualKeyword(originalKeywordKind);
      }
      ts3.isIdentifierANonContextualKeyword = isIdentifierANonContextualKeyword;
      function isTrivia(token) {
        return 2 <= token && token <= 7;
      }
      ts3.isTrivia = isTrivia;
      var FunctionFlags;
      (function(FunctionFlags2) {
        FunctionFlags2[FunctionFlags2["Normal"] = 0] = "Normal";
        FunctionFlags2[FunctionFlags2["Generator"] = 1] = "Generator";
        FunctionFlags2[FunctionFlags2["Async"] = 2] = "Async";
        FunctionFlags2[FunctionFlags2["Invalid"] = 4] = "Invalid";
        FunctionFlags2[FunctionFlags2["AsyncGenerator"] = 3] = "AsyncGenerator";
      })(FunctionFlags = ts3.FunctionFlags || (ts3.FunctionFlags = {}));
      function getFunctionFlags(node) {
        if (!node) {
          return 4;
        }
        var flags = 0;
        switch (node.kind) {
          case 252:
          case 209:
          case 166:
            if (node.asteriskToken) {
              flags |= 1;
            }
          case 210:
            if (hasSyntacticModifier(node, 256)) {
              flags |= 2;
            }
            break;
        }
        if (!node.body) {
          flags |= 4;
        }
        return flags;
      }
      ts3.getFunctionFlags = getFunctionFlags;
      function isAsyncFunction(node) {
        switch (node.kind) {
          case 252:
          case 209:
          case 210:
          case 166:
            return node.body !== void 0 && node.asteriskToken === void 0 && hasSyntacticModifier(node, 256);
        }
        return false;
      }
      ts3.isAsyncFunction = isAsyncFunction;
      function isStringOrNumericLiteralLike(node) {
        return ts3.isStringLiteralLike(node) || ts3.isNumericLiteral(node);
      }
      ts3.isStringOrNumericLiteralLike = isStringOrNumericLiteralLike;
      function isSignedNumericLiteral(node) {
        return ts3.isPrefixUnaryExpression(node) && (node.operator === 39 || node.operator === 40) && ts3.isNumericLiteral(node.operand);
      }
      ts3.isSignedNumericLiteral = isSignedNumericLiteral;
      function hasDynamicName(declaration) {
        var name = ts3.getNameOfDeclaration(declaration);
        return !!name && isDynamicName(name);
      }
      ts3.hasDynamicName = hasDynamicName;
      function isDynamicName(name) {
        if (!(name.kind === 159 || name.kind === 203)) {
          return false;
        }
        var expr = ts3.isElementAccessExpression(name) ? skipParentheses(name.argumentExpression) : name.expression;
        return !isStringOrNumericLiteralLike(expr) && !isSignedNumericLiteral(expr);
      }
      ts3.isDynamicName = isDynamicName;
      function getPropertyNameForPropertyNameNode(name) {
        switch (name.kind) {
          case 78:
          case 79:
            return name.escapedText;
          case 10:
          case 8:
            return ts3.escapeLeadingUnderscores(name.text);
          case 159:
            var nameExpression = name.expression;
            if (isStringOrNumericLiteralLike(nameExpression)) {
              return ts3.escapeLeadingUnderscores(nameExpression.text);
            } else if (isSignedNumericLiteral(nameExpression)) {
              if (nameExpression.operator === 40) {
                return ts3.tokenToString(nameExpression.operator) + nameExpression.operand.text;
              }
              return nameExpression.operand.text;
            }
            return void 0;
          default:
            return ts3.Debug.assertNever(name);
        }
      }
      ts3.getPropertyNameForPropertyNameNode = getPropertyNameForPropertyNameNode;
      function isPropertyNameLiteral(node) {
        switch (node.kind) {
          case 78:
          case 10:
          case 14:
          case 8:
            return true;
          default:
            return false;
        }
      }
      ts3.isPropertyNameLiteral = isPropertyNameLiteral;
      function getTextOfIdentifierOrLiteral(node) {
        return ts3.isMemberName(node) ? ts3.idText(node) : node.text;
      }
      ts3.getTextOfIdentifierOrLiteral = getTextOfIdentifierOrLiteral;
      function getEscapedTextOfIdentifierOrLiteral(node) {
        return ts3.isMemberName(node) ? node.escapedText : ts3.escapeLeadingUnderscores(node.text);
      }
      ts3.getEscapedTextOfIdentifierOrLiteral = getEscapedTextOfIdentifierOrLiteral;
      function getPropertyNameForUniqueESSymbol(symbol) {
        return "__@" + ts3.getSymbolId(symbol) + "@" + symbol.escapedName;
      }
      ts3.getPropertyNameForUniqueESSymbol = getPropertyNameForUniqueESSymbol;
      function getSymbolNameForPrivateIdentifier(containingClassSymbol, description) {
        return "__#" + ts3.getSymbolId(containingClassSymbol) + "@" + description;
      }
      ts3.getSymbolNameForPrivateIdentifier = getSymbolNameForPrivateIdentifier;
      function isKnownSymbol(symbol) {
        return ts3.startsWith(symbol.escapedName, "__@");
      }
      ts3.isKnownSymbol = isKnownSymbol;
      function isESSymbolIdentifier(node) {
        return node.kind === 78 && node.escapedText === "Symbol";
      }
      ts3.isESSymbolIdentifier = isESSymbolIdentifier;
      function isPushOrUnshiftIdentifier(node) {
        return node.escapedText === "push" || node.escapedText === "unshift";
      }
      ts3.isPushOrUnshiftIdentifier = isPushOrUnshiftIdentifier;
      function isParameterDeclaration(node) {
        var root = getRootDeclaration(node);
        return root.kind === 161;
      }
      ts3.isParameterDeclaration = isParameterDeclaration;
      function getRootDeclaration(node) {
        while (node.kind === 199) {
          node = node.parent.parent;
        }
        return node;
      }
      ts3.getRootDeclaration = getRootDeclaration;
      function nodeStartsNewLexicalEnvironment(node) {
        var kind = node.kind;
        return kind === 167 || kind === 209 || kind === 252 || kind === 210 || kind === 166 || kind === 168 || kind === 169 || kind === 257 || kind === 298;
      }
      ts3.nodeStartsNewLexicalEnvironment = nodeStartsNewLexicalEnvironment;
      function nodeIsSynthesized(range) {
        return positionIsSynthesized(range.pos) || positionIsSynthesized(range.end);
      }
      ts3.nodeIsSynthesized = nodeIsSynthesized;
      function getOriginalSourceFile(sourceFile) {
        return ts3.getParseTreeNode(sourceFile, ts3.isSourceFile) || sourceFile;
      }
      ts3.getOriginalSourceFile = getOriginalSourceFile;
      var Associativity;
      (function(Associativity2) {
        Associativity2[Associativity2["Left"] = 0] = "Left";
        Associativity2[Associativity2["Right"] = 1] = "Right";
      })(Associativity = ts3.Associativity || (ts3.Associativity = {}));
      function getExpressionAssociativity(expression) {
        var operator = getOperator(expression);
        var hasArguments = expression.kind === 205 && expression.arguments !== void 0;
        return getOperatorAssociativity(expression.kind, operator, hasArguments);
      }
      ts3.getExpressionAssociativity = getExpressionAssociativity;
      function getOperatorAssociativity(kind, operator, hasArguments) {
        switch (kind) {
          case 205:
            return hasArguments ? 0 : 1;
          case 215:
          case 212:
          case 213:
          case 211:
          case 214:
          case 218:
          case 220:
            return 1;
          case 217:
            switch (operator) {
              case 42:
              case 62:
              case 63:
              case 64:
              case 66:
              case 65:
              case 67:
              case 68:
              case 69:
              case 70:
              case 71:
              case 72:
              case 77:
              case 73:
              case 74:
              case 75:
              case 76:
                return 1;
            }
        }
        return 0;
      }
      ts3.getOperatorAssociativity = getOperatorAssociativity;
      function getExpressionPrecedence(expression) {
        var operator = getOperator(expression);
        var hasArguments = expression.kind === 205 && expression.arguments !== void 0;
        return getOperatorPrecedence(expression.kind, operator, hasArguments);
      }
      ts3.getExpressionPrecedence = getExpressionPrecedence;
      function getOperator(expression) {
        if (expression.kind === 217) {
          return expression.operatorToken.kind;
        } else if (expression.kind === 215 || expression.kind === 216) {
          return expression.operator;
        } else {
          return expression.kind;
        }
      }
      ts3.getOperator = getOperator;
      var OperatorPrecedence;
      (function(OperatorPrecedence2) {
        OperatorPrecedence2[OperatorPrecedence2["Comma"] = 0] = "Comma";
        OperatorPrecedence2[OperatorPrecedence2["Spread"] = 1] = "Spread";
        OperatorPrecedence2[OperatorPrecedence2["Yield"] = 2] = "Yield";
        OperatorPrecedence2[OperatorPrecedence2["Assignment"] = 3] = "Assignment";
        OperatorPrecedence2[OperatorPrecedence2["Conditional"] = 4] = "Conditional";
        OperatorPrecedence2[OperatorPrecedence2["Coalesce"] = 4] = "Coalesce";
        OperatorPrecedence2[OperatorPrecedence2["LogicalOR"] = 5] = "LogicalOR";
        OperatorPrecedence2[OperatorPrecedence2["LogicalAND"] = 6] = "LogicalAND";
        OperatorPrecedence2[OperatorPrecedence2["BitwiseOR"] = 7] = "BitwiseOR";
        OperatorPrecedence2[OperatorPrecedence2["BitwiseXOR"] = 8] = "BitwiseXOR";
        OperatorPrecedence2[OperatorPrecedence2["BitwiseAND"] = 9] = "BitwiseAND";
        OperatorPrecedence2[OperatorPrecedence2["Equality"] = 10] = "Equality";
        OperatorPrecedence2[OperatorPrecedence2["Relational"] = 11] = "Relational";
        OperatorPrecedence2[OperatorPrecedence2["Shift"] = 12] = "Shift";
        OperatorPrecedence2[OperatorPrecedence2["Additive"] = 13] = "Additive";
        OperatorPrecedence2[OperatorPrecedence2["Multiplicative"] = 14] = "Multiplicative";
        OperatorPrecedence2[OperatorPrecedence2["Exponentiation"] = 15] = "Exponentiation";
        OperatorPrecedence2[OperatorPrecedence2["Unary"] = 16] = "Unary";
        OperatorPrecedence2[OperatorPrecedence2["Update"] = 17] = "Update";
        OperatorPrecedence2[OperatorPrecedence2["LeftHandSide"] = 18] = "LeftHandSide";
        OperatorPrecedence2[OperatorPrecedence2["Member"] = 19] = "Member";
        OperatorPrecedence2[OperatorPrecedence2["Primary"] = 20] = "Primary";
        OperatorPrecedence2[OperatorPrecedence2["Highest"] = 20] = "Highest";
        OperatorPrecedence2[OperatorPrecedence2["Lowest"] = 0] = "Lowest";
        OperatorPrecedence2[OperatorPrecedence2["Invalid"] = -1] = "Invalid";
      })(OperatorPrecedence = ts3.OperatorPrecedence || (ts3.OperatorPrecedence = {}));
      function getOperatorPrecedence(nodeKind, operatorKind, hasArguments) {
        switch (nodeKind) {
          case 341:
            return 0;
          case 221:
            return 1;
          case 220:
            return 2;
          case 218:
            return 4;
          case 217:
            switch (operatorKind) {
              case 27:
                return 0;
              case 62:
              case 63:
              case 64:
              case 66:
              case 65:
              case 67:
              case 68:
              case 69:
              case 70:
              case 71:
              case 72:
              case 77:
              case 73:
              case 74:
              case 75:
              case 76:
                return 3;
              default:
                return getBinaryOperatorPrecedence(operatorKind);
            }
          case 207:
          case 226:
          case 215:
          case 212:
          case 213:
          case 211:
          case 214:
            return 16;
          case 216:
            return 17;
          case 204:
            return 18;
          case 205:
            return hasArguments ? 19 : 18;
          case 206:
          case 202:
          case 203:
          case 227:
            return 19;
          case 225:
            return 11;
          case 107:
          case 105:
          case 78:
          case 103:
          case 109:
          case 94:
          case 8:
          case 9:
          case 10:
          case 200:
          case 201:
          case 209:
          case 210:
          case 222:
          case 13:
          case 14:
          case 219:
          case 208:
          case 223:
          case 274:
          case 275:
          case 278:
            return 20;
          default:
            return -1;
        }
      }
      ts3.getOperatorPrecedence = getOperatorPrecedence;
      function getBinaryOperatorPrecedence(kind) {
        switch (kind) {
          case 60:
            return 4;
          case 56:
            return 5;
          case 55:
            return 6;
          case 51:
            return 7;
          case 52:
            return 8;
          case 50:
            return 9;
          case 34:
          case 35:
          case 36:
          case 37:
            return 10;
          case 29:
          case 31:
          case 32:
          case 33:
          case 101:
          case 100:
          case 126:
            return 11;
          case 47:
          case 48:
          case 49:
            return 12;
          case 39:
          case 40:
            return 13;
          case 41:
          case 43:
          case 44:
            return 14;
          case 42:
            return 15;
        }
        return -1;
      }
      ts3.getBinaryOperatorPrecedence = getBinaryOperatorPrecedence;
      function getSemanticJsxChildren(children) {
        return ts3.filter(children, function(i3) {
          switch (i3.kind) {
            case 284:
              return !!i3.expression;
            case 11:
              return !i3.containsOnlyTriviaWhiteSpaces;
            default:
              return true;
          }
        });
      }
      ts3.getSemanticJsxChildren = getSemanticJsxChildren;
      function createDiagnosticCollection() {
        var nonFileDiagnostics = [];
        var filesWithDiagnostics = [];
        var fileDiagnostics = new ts3.Map();
        var hasReadNonFileDiagnostics = false;
        return {
          add,
          lookup,
          getGlobalDiagnostics,
          getDiagnostics
        };
        function lookup(diagnostic) {
          var diagnostics;
          if (diagnostic.file) {
            diagnostics = fileDiagnostics.get(diagnostic.file.fileName);
          } else {
            diagnostics = nonFileDiagnostics;
          }
          if (!diagnostics) {
            return void 0;
          }
          var result2 = ts3.binarySearch(diagnostics, diagnostic, ts3.identity, compareDiagnosticsSkipRelatedInformation);
          if (result2 >= 0) {
            return diagnostics[result2];
          }
          return void 0;
        }
        function add(diagnostic) {
          var diagnostics;
          if (diagnostic.file) {
            diagnostics = fileDiagnostics.get(diagnostic.file.fileName);
            if (!diagnostics) {
              diagnostics = [];
              fileDiagnostics.set(diagnostic.file.fileName, diagnostics);
              ts3.insertSorted(filesWithDiagnostics, diagnostic.file.fileName, ts3.compareStringsCaseSensitive);
            }
          } else {
            if (hasReadNonFileDiagnostics) {
              hasReadNonFileDiagnostics = false;
              nonFileDiagnostics = nonFileDiagnostics.slice();
            }
            diagnostics = nonFileDiagnostics;
          }
          ts3.insertSorted(diagnostics, diagnostic, compareDiagnostics);
        }
        function getGlobalDiagnostics() {
          hasReadNonFileDiagnostics = true;
          return nonFileDiagnostics;
        }
        function getDiagnostics(fileName) {
          if (fileName) {
            return fileDiagnostics.get(fileName) || [];
          }
          var fileDiags = ts3.flatMapToMutable(filesWithDiagnostics, function(f) {
            return fileDiagnostics.get(f);
          });
          if (!nonFileDiagnostics.length) {
            return fileDiags;
          }
          fileDiags.unshift.apply(fileDiags, nonFileDiagnostics);
          return fileDiags;
        }
      }
      ts3.createDiagnosticCollection = createDiagnosticCollection;
      var templateSubstitutionRegExp = /\$\{/g;
      function escapeTemplateSubstitution(str2) {
        return str2.replace(templateSubstitutionRegExp, "\\${");
      }
      function hasInvalidEscape(template) {
        return template && !!(ts3.isNoSubstitutionTemplateLiteral(template) ? template.templateFlags : template.head.templateFlags || ts3.some(template.templateSpans, function(span) {
          return !!span.literal.templateFlags;
        }));
      }
      ts3.hasInvalidEscape = hasInvalidEscape;
      var doubleQuoteEscapedCharsRegExp = /[\\\"\u0000-\u001f\t\v\f\b\r\n\u2028\u2029\u0085]/g;
      var singleQuoteEscapedCharsRegExp = /[\\\'\u0000-\u001f\t\v\f\b\r\n\u2028\u2029\u0085]/g;
      var backtickQuoteEscapedCharsRegExp = /[\\`]/g;
      var escapedCharsMap = new ts3.Map(ts3.getEntries({
        "	": "\\t",
        "\v": "\\v",
        "\f": "\\f",
        "\b": "\\b",
        "\r": "\\r",
        "\n": "\\n",
        "\\": "\\\\",
        '"': '\\"',
        "'": "\\'",
        "`": "\\`",
        "\u2028": "\\u2028",
        "\u2029": "\\u2029",
        "\x85": "\\u0085"
      }));
      function encodeUtf16EscapeSequence(charCode) {
        var hexCharCode = charCode.toString(16).toUpperCase();
        var paddedHexCode = ("0000" + hexCharCode).slice(-4);
        return "\\u" + paddedHexCode;
      }
      function getReplacement(c2, offset, input) {
        if (c2.charCodeAt(0) === 0) {
          var lookAhead = input.charCodeAt(offset + c2.length);
          if (lookAhead >= 48 && lookAhead <= 57) {
            return "\\x00";
          }
          return "\\0";
        }
        return escapedCharsMap.get(c2) || encodeUtf16EscapeSequence(c2.charCodeAt(0));
      }
      function escapeString2(s2, quoteChar) {
        var escapedCharsRegExp = quoteChar === 96 ? backtickQuoteEscapedCharsRegExp : quoteChar === 39 ? singleQuoteEscapedCharsRegExp : doubleQuoteEscapedCharsRegExp;
        return s2.replace(escapedCharsRegExp, getReplacement);
      }
      ts3.escapeString = escapeString2;
      var nonAsciiCharacters = /[^\u0000-\u007F]/g;
      function escapeNonAsciiString(s2, quoteChar) {
        s2 = escapeString2(s2, quoteChar);
        return nonAsciiCharacters.test(s2) ? s2.replace(nonAsciiCharacters, function(c2) {
          return encodeUtf16EscapeSequence(c2.charCodeAt(0));
        }) : s2;
      }
      ts3.escapeNonAsciiString = escapeNonAsciiString;
      var jsxDoubleQuoteEscapedCharsRegExp = /[\"\u0000-\u001f\u2028\u2029\u0085]/g;
      var jsxSingleQuoteEscapedCharsRegExp = /[\'\u0000-\u001f\u2028\u2029\u0085]/g;
      var jsxEscapedCharsMap = new ts3.Map(ts3.getEntries({
        '"': "&quot;",
        "'": "&apos;"
      }));
      function encodeJsxCharacterEntity(charCode) {
        var hexCharCode = charCode.toString(16).toUpperCase();
        return "&#x" + hexCharCode + ";";
      }
      function getJsxAttributeStringReplacement(c2) {
        if (c2.charCodeAt(0) === 0) {
          return "&#0;";
        }
        return jsxEscapedCharsMap.get(c2) || encodeJsxCharacterEntity(c2.charCodeAt(0));
      }
      function escapeJsxAttributeString(s2, quoteChar) {
        var escapedCharsRegExp = quoteChar === 39 ? jsxSingleQuoteEscapedCharsRegExp : jsxDoubleQuoteEscapedCharsRegExp;
        return s2.replace(escapedCharsRegExp, getJsxAttributeStringReplacement);
      }
      ts3.escapeJsxAttributeString = escapeJsxAttributeString;
      function stripQuotes(name) {
        var length = name.length;
        if (length >= 2 && name.charCodeAt(0) === name.charCodeAt(length - 1) && isQuoteOrBacktick(name.charCodeAt(0))) {
          return name.substring(1, length - 1);
        }
        return name;
      }
      ts3.stripQuotes = stripQuotes;
      function isQuoteOrBacktick(charCode) {
        return charCode === 39 || charCode === 34 || charCode === 96;
      }
      function isIntrinsicJsxName(name) {
        var ch = name.charCodeAt(0);
        return ch >= 97 && ch <= 122 || ts3.stringContains(name, "-") || ts3.stringContains(name, ":");
      }
      ts3.isIntrinsicJsxName = isIntrinsicJsxName;
      var indentStrings = ["", "    "];
      function getIndentString(level) {
        var singleLevel = indentStrings[1];
        for (var current = indentStrings.length; current <= level; current++) {
          indentStrings.push(indentStrings[current - 1] + singleLevel);
        }
        return indentStrings[level];
      }
      ts3.getIndentString = getIndentString;
      function getIndentSize() {
        return indentStrings[1].length;
      }
      ts3.getIndentSize = getIndentSize;
      function createTextWriter(newLine) {
        var output;
        var indent;
        var lineStart;
        var lineCount;
        var linePos;
        var hasTrailingComment = false;
        function updateLineCountAndPosFor(s2) {
          var lineStartsOfS = ts3.computeLineStarts(s2);
          if (lineStartsOfS.length > 1) {
            lineCount = lineCount + lineStartsOfS.length - 1;
            linePos = output.length - s2.length + ts3.last(lineStartsOfS);
            lineStart = linePos - output.length === 0;
          } else {
            lineStart = false;
          }
        }
        function writeText(s2) {
          if (s2 && s2.length) {
            if (lineStart) {
              s2 = getIndentString(indent) + s2;
              lineStart = false;
            }
            output += s2;
            updateLineCountAndPosFor(s2);
          }
        }
        function write(s2) {
          if (s2)
            hasTrailingComment = false;
          writeText(s2);
        }
        function writeComment(s2) {
          if (s2)
            hasTrailingComment = true;
          writeText(s2);
        }
        function reset() {
          output = "";
          indent = 0;
          lineStart = true;
          lineCount = 0;
          linePos = 0;
          hasTrailingComment = false;
        }
        function rawWrite(s2) {
          if (s2 !== void 0) {
            output += s2;
            updateLineCountAndPosFor(s2);
            hasTrailingComment = false;
          }
        }
        function writeLiteral(s2) {
          if (s2 && s2.length) {
            write(s2);
          }
        }
        function writeLine(force) {
          if (!lineStart || force) {
            output += newLine;
            lineCount++;
            linePos = output.length;
            lineStart = true;
            hasTrailingComment = false;
          }
        }
        function getTextPosWithWriteLine() {
          return lineStart ? output.length : output.length + newLine.length;
        }
        reset();
        return {
          write,
          rawWrite,
          writeLiteral,
          writeLine,
          increaseIndent: function() {
            indent++;
          },
          decreaseIndent: function() {
            indent--;
          },
          getIndent: function() {
            return indent;
          },
          getTextPos: function() {
            return output.length;
          },
          getLine: function() {
            return lineCount;
          },
          getColumn: function() {
            return lineStart ? indent * getIndentSize() : output.length - linePos;
          },
          getText: function() {
            return output;
          },
          isAtStartOfLine: function() {
            return lineStart;
          },
          hasTrailingComment: function() {
            return hasTrailingComment;
          },
          hasTrailingWhitespace: function() {
            return !!output.length && ts3.isWhiteSpaceLike(output.charCodeAt(output.length - 1));
          },
          clear: reset,
          reportInaccessibleThisError: ts3.noop,
          reportPrivateInBaseOfClassExpression: ts3.noop,
          reportInaccessibleUniqueSymbolError: ts3.noop,
          trackSymbol: ts3.noop,
          writeKeyword: write,
          writeOperator: write,
          writeParameter: write,
          writeProperty: write,
          writePunctuation: write,
          writeSpace: write,
          writeStringLiteral: write,
          writeSymbol: function(s2, _) {
            return write(s2);
          },
          writeTrailingSemicolon: write,
          writeComment,
          getTextPosWithWriteLine
        };
      }
      ts3.createTextWriter = createTextWriter;
      function getTrailingSemicolonDeferringWriter(writer) {
        var pendingTrailingSemicolon = false;
        function commitPendingTrailingSemicolon() {
          if (pendingTrailingSemicolon) {
            writer.writeTrailingSemicolon(";");
            pendingTrailingSemicolon = false;
          }
        }
        return __assign(__assign({}, writer), { writeTrailingSemicolon: function() {
          pendingTrailingSemicolon = true;
        }, writeLiteral: function(s2) {
          commitPendingTrailingSemicolon();
          writer.writeLiteral(s2);
        }, writeStringLiteral: function(s2) {
          commitPendingTrailingSemicolon();
          writer.writeStringLiteral(s2);
        }, writeSymbol: function(s2, sym) {
          commitPendingTrailingSemicolon();
          writer.writeSymbol(s2, sym);
        }, writePunctuation: function(s2) {
          commitPendingTrailingSemicolon();
          writer.writePunctuation(s2);
        }, writeKeyword: function(s2) {
          commitPendingTrailingSemicolon();
          writer.writeKeyword(s2);
        }, writeOperator: function(s2) {
          commitPendingTrailingSemicolon();
          writer.writeOperator(s2);
        }, writeParameter: function(s2) {
          commitPendingTrailingSemicolon();
          writer.writeParameter(s2);
        }, writeSpace: function(s2) {
          commitPendingTrailingSemicolon();
          writer.writeSpace(s2);
        }, writeProperty: function(s2) {
          commitPendingTrailingSemicolon();
          writer.writeProperty(s2);
        }, writeComment: function(s2) {
          commitPendingTrailingSemicolon();
          writer.writeComment(s2);
        }, writeLine: function() {
          commitPendingTrailingSemicolon();
          writer.writeLine();
        }, increaseIndent: function() {
          commitPendingTrailingSemicolon();
          writer.increaseIndent();
        }, decreaseIndent: function() {
          commitPendingTrailingSemicolon();
          writer.decreaseIndent();
        } });
      }
      ts3.getTrailingSemicolonDeferringWriter = getTrailingSemicolonDeferringWriter;
      function hostUsesCaseSensitiveFileNames(host) {
        return host.useCaseSensitiveFileNames ? host.useCaseSensitiveFileNames() : false;
      }
      ts3.hostUsesCaseSensitiveFileNames = hostUsesCaseSensitiveFileNames;
      function hostGetCanonicalFileName(host) {
        return ts3.createGetCanonicalFileName(hostUsesCaseSensitiveFileNames(host));
      }
      ts3.hostGetCanonicalFileName = hostGetCanonicalFileName;
      function getResolvedExternalModuleName(host, file, referenceFile) {
        return file.moduleName || getExternalModuleNameFromPath(host, file.fileName, referenceFile && referenceFile.fileName);
      }
      ts3.getResolvedExternalModuleName = getResolvedExternalModuleName;
      function getCanonicalAbsolutePath(host, path2) {
        return host.getCanonicalFileName(ts3.getNormalizedAbsolutePath(path2, host.getCurrentDirectory()));
      }
      function getExternalModuleNameFromDeclaration(host, resolver, declaration) {
        var file = resolver.getExternalModuleFileFromDeclaration(declaration);
        if (!file || file.isDeclarationFile) {
          return void 0;
        }
        var specifier = getExternalModuleName(declaration);
        if (specifier && ts3.isStringLiteralLike(specifier) && !ts3.pathIsRelative(specifier.text) && getCanonicalAbsolutePath(host, file.path).indexOf(getCanonicalAbsolutePath(host, ts3.ensureTrailingDirectorySeparator(host.getCommonSourceDirectory()))) === -1) {
          return void 0;
        }
        return getResolvedExternalModuleName(host, file);
      }
      ts3.getExternalModuleNameFromDeclaration = getExternalModuleNameFromDeclaration;
      function getExternalModuleNameFromPath(host, fileName, referencePath) {
        var getCanonicalFileName = function(f) {
          return host.getCanonicalFileName(f);
        };
        var dir = ts3.toPath(referencePath ? ts3.getDirectoryPath(referencePath) : host.getCommonSourceDirectory(), host.getCurrentDirectory(), getCanonicalFileName);
        var filePath = ts3.getNormalizedAbsolutePath(fileName, host.getCurrentDirectory());
        var relativePath = ts3.getRelativePathToDirectoryOrUrl(dir, filePath, dir, getCanonicalFileName, false);
        var extensionless = removeFileExtension(relativePath);
        return referencePath ? ts3.ensurePathIsNonModuleName(extensionless) : extensionless;
      }
      ts3.getExternalModuleNameFromPath = getExternalModuleNameFromPath;
      function getOwnEmitOutputFilePath(fileName, host, extension) {
        var compilerOptions = host.getCompilerOptions();
        var emitOutputFilePathWithoutExtension;
        if (compilerOptions.outDir) {
          emitOutputFilePathWithoutExtension = removeFileExtension(getSourceFilePathInNewDir(fileName, host, compilerOptions.outDir));
        } else {
          emitOutputFilePathWithoutExtension = removeFileExtension(fileName);
        }
        return emitOutputFilePathWithoutExtension + extension;
      }
      ts3.getOwnEmitOutputFilePath = getOwnEmitOutputFilePath;
      function getDeclarationEmitOutputFilePath(fileName, host) {
        return getDeclarationEmitOutputFilePathWorker(fileName, host.getCompilerOptions(), host.getCurrentDirectory(), host.getCommonSourceDirectory(), function(f) {
          return host.getCanonicalFileName(f);
        });
      }
      ts3.getDeclarationEmitOutputFilePath = getDeclarationEmitOutputFilePath;
      function getDeclarationEmitOutputFilePathWorker(fileName, options, currentDirectory, commonSourceDirectory, getCanonicalFileName) {
        var outputDir = options.declarationDir || options.outDir;
        var path2 = outputDir ? getSourceFilePathInNewDirWorker(fileName, outputDir, currentDirectory, commonSourceDirectory, getCanonicalFileName) : fileName;
        return removeFileExtension(path2) + ".d.ts";
      }
      ts3.getDeclarationEmitOutputFilePathWorker = getDeclarationEmitOutputFilePathWorker;
      function outFile(options) {
        return options.outFile || options.out;
      }
      ts3.outFile = outFile;
      function getPathsBasePath(options, host) {
        var _a2, _b;
        if (!options.paths)
          return void 0;
        return (_a2 = options.baseUrl) !== null && _a2 !== void 0 ? _a2 : ts3.Debug.checkDefined(options.pathsBasePath || ((_b = host.getCurrentDirectory) === null || _b === void 0 ? void 0 : _b.call(host)), "Encountered 'paths' without a 'baseUrl', config file, or host 'getCurrentDirectory'.");
      }
      ts3.getPathsBasePath = getPathsBasePath;
      function getSourceFilesToEmit(host, targetSourceFile, forceDtsEmit) {
        var options = host.getCompilerOptions();
        if (outFile(options)) {
          var moduleKind = getEmitModuleKind(options);
          var moduleEmitEnabled_1 = options.emitDeclarationOnly || moduleKind === ts3.ModuleKind.AMD || moduleKind === ts3.ModuleKind.System;
          return ts3.filter(host.getSourceFiles(), function(sourceFile) {
            return (moduleEmitEnabled_1 || !ts3.isExternalModule(sourceFile)) && sourceFileMayBeEmitted(sourceFile, host, forceDtsEmit);
          });
        } else {
          var sourceFiles = targetSourceFile === void 0 ? host.getSourceFiles() : [targetSourceFile];
          return ts3.filter(sourceFiles, function(sourceFile) {
            return sourceFileMayBeEmitted(sourceFile, host, forceDtsEmit);
          });
        }
      }
      ts3.getSourceFilesToEmit = getSourceFilesToEmit;
      function sourceFileMayBeEmitted(sourceFile, host, forceDtsEmit) {
        var options = host.getCompilerOptions();
        return !(options.noEmitForJsFiles && isSourceFileJS(sourceFile)) && !sourceFile.isDeclarationFile && !host.isSourceFileFromExternalLibrary(sourceFile) && (forceDtsEmit || !(isJsonSourceFile(sourceFile) && host.getResolvedProjectReferenceToRedirect(sourceFile.fileName)) && !host.isSourceOfProjectReferenceRedirect(sourceFile.fileName));
      }
      ts3.sourceFileMayBeEmitted = sourceFileMayBeEmitted;
      function getSourceFilePathInNewDir(fileName, host, newDirPath) {
        return getSourceFilePathInNewDirWorker(fileName, newDirPath, host.getCurrentDirectory(), host.getCommonSourceDirectory(), function(f) {
          return host.getCanonicalFileName(f);
        });
      }
      ts3.getSourceFilePathInNewDir = getSourceFilePathInNewDir;
      function getSourceFilePathInNewDirWorker(fileName, newDirPath, currentDirectory, commonSourceDirectory, getCanonicalFileName) {
        var sourceFilePath = ts3.getNormalizedAbsolutePath(fileName, currentDirectory);
        var isSourceFileInCommonSourceDirectory = getCanonicalFileName(sourceFilePath).indexOf(getCanonicalFileName(commonSourceDirectory)) === 0;
        sourceFilePath = isSourceFileInCommonSourceDirectory ? sourceFilePath.substring(commonSourceDirectory.length) : sourceFilePath;
        return ts3.combinePaths(newDirPath, sourceFilePath);
      }
      ts3.getSourceFilePathInNewDirWorker = getSourceFilePathInNewDirWorker;
      function writeFile(host, diagnostics, fileName, data, writeByteOrderMark, sourceFiles) {
        host.writeFile(fileName, data, writeByteOrderMark, function(hostErrorMessage) {
          diagnostics.add(createCompilerDiagnostic(ts3.Diagnostics.Could_not_write_file_0_Colon_1, fileName, hostErrorMessage));
        }, sourceFiles);
      }
      ts3.writeFile = writeFile;
      function ensureDirectoriesExist(directoryPath, createDirectory, directoryExists) {
        if (directoryPath.length > ts3.getRootLength(directoryPath) && !directoryExists(directoryPath)) {
          var parentDirectory = ts3.getDirectoryPath(directoryPath);
          ensureDirectoriesExist(parentDirectory, createDirectory, directoryExists);
          createDirectory(directoryPath);
        }
      }
      function writeFileEnsuringDirectories(path2, data, writeByteOrderMark, writeFile2, createDirectory, directoryExists) {
        try {
          writeFile2(path2, data, writeByteOrderMark);
        } catch (_a2) {
          ensureDirectoriesExist(ts3.getDirectoryPath(ts3.normalizePath(path2)), createDirectory, directoryExists);
          writeFile2(path2, data, writeByteOrderMark);
        }
      }
      ts3.writeFileEnsuringDirectories = writeFileEnsuringDirectories;
      function getLineOfLocalPosition(sourceFile, pos) {
        var lineStarts = ts3.getLineStarts(sourceFile);
        return ts3.computeLineOfPosition(lineStarts, pos);
      }
      ts3.getLineOfLocalPosition = getLineOfLocalPosition;
      function getLineOfLocalPositionFromLineMap(lineMap, pos) {
        return ts3.computeLineOfPosition(lineMap, pos);
      }
      ts3.getLineOfLocalPositionFromLineMap = getLineOfLocalPositionFromLineMap;
      function getFirstConstructorWithBody(node) {
        return ts3.find(node.members, function(member) {
          return ts3.isConstructorDeclaration(member) && nodeIsPresent(member.body);
        });
      }
      ts3.getFirstConstructorWithBody = getFirstConstructorWithBody;
      function getSetAccessorValueParameter(accessor) {
        if (accessor && accessor.parameters.length > 0) {
          var hasThis = accessor.parameters.length === 2 && parameterIsThisKeyword(accessor.parameters[0]);
          return accessor.parameters[hasThis ? 1 : 0];
        }
      }
      ts3.getSetAccessorValueParameter = getSetAccessorValueParameter;
      function getSetAccessorTypeAnnotationNode(accessor) {
        var parameter = getSetAccessorValueParameter(accessor);
        return parameter && parameter.type;
      }
      ts3.getSetAccessorTypeAnnotationNode = getSetAccessorTypeAnnotationNode;
      function getThisParameter(signature) {
        if (signature.parameters.length && !ts3.isJSDocSignature(signature)) {
          var thisParameter = signature.parameters[0];
          if (parameterIsThisKeyword(thisParameter)) {
            return thisParameter;
          }
        }
      }
      ts3.getThisParameter = getThisParameter;
      function parameterIsThisKeyword(parameter) {
        return isThisIdentifier(parameter.name);
      }
      ts3.parameterIsThisKeyword = parameterIsThisKeyword;
      function isThisIdentifier(node) {
        return !!node && node.kind === 78 && identifierIsThisKeyword(node);
      }
      ts3.isThisIdentifier = isThisIdentifier;
      function identifierIsThisKeyword(id) {
        return id.originalKeywordKind === 107;
      }
      ts3.identifierIsThisKeyword = identifierIsThisKeyword;
      function getAllAccessorDeclarations(declarations, accessor) {
        var firstAccessor;
        var secondAccessor;
        var getAccessor;
        var setAccessor;
        if (hasDynamicName(accessor)) {
          firstAccessor = accessor;
          if (accessor.kind === 168) {
            getAccessor = accessor;
          } else if (accessor.kind === 169) {
            setAccessor = accessor;
          } else {
            ts3.Debug.fail("Accessor has wrong kind");
          }
        } else {
          ts3.forEach(declarations, function(member) {
            if (ts3.isAccessor(member) && hasSyntacticModifier(member, 32) === hasSyntacticModifier(accessor, 32)) {
              var memberName = getPropertyNameForPropertyNameNode(member.name);
              var accessorName = getPropertyNameForPropertyNameNode(accessor.name);
              if (memberName === accessorName) {
                if (!firstAccessor) {
                  firstAccessor = member;
                } else if (!secondAccessor) {
                  secondAccessor = member;
                }
                if (member.kind === 168 && !getAccessor) {
                  getAccessor = member;
                }
                if (member.kind === 169 && !setAccessor) {
                  setAccessor = member;
                }
              }
            }
          });
        }
        return {
          firstAccessor,
          secondAccessor,
          getAccessor,
          setAccessor
        };
      }
      ts3.getAllAccessorDeclarations = getAllAccessorDeclarations;
      function getEffectiveTypeAnnotationNode(node) {
        if (!isInJSFile(node) && ts3.isFunctionDeclaration(node))
          return void 0;
        var type3 = node.type;
        if (type3 || !isInJSFile(node))
          return type3;
        return ts3.isJSDocPropertyLikeTag(node) ? node.typeExpression && node.typeExpression.type : ts3.getJSDocType(node);
      }
      ts3.getEffectiveTypeAnnotationNode = getEffectiveTypeAnnotationNode;
      function getTypeAnnotationNode(node) {
        return node.type;
      }
      ts3.getTypeAnnotationNode = getTypeAnnotationNode;
      function getEffectiveReturnTypeNode(node) {
        return ts3.isJSDocSignature(node) ? node.type && node.type.typeExpression && node.type.typeExpression.type : node.type || (isInJSFile(node) ? ts3.getJSDocReturnType(node) : void 0);
      }
      ts3.getEffectiveReturnTypeNode = getEffectiveReturnTypeNode;
      function getJSDocTypeParameterDeclarations(node) {
        return ts3.flatMap(ts3.getJSDocTags(node), function(tag) {
          return isNonTypeAliasTemplate(tag) ? tag.typeParameters : void 0;
        });
      }
      ts3.getJSDocTypeParameterDeclarations = getJSDocTypeParameterDeclarations;
      function isNonTypeAliasTemplate(tag) {
        return ts3.isJSDocTemplateTag(tag) && !(tag.parent.kind === 312 && tag.parent.tags.some(isJSDocTypeAlias));
      }
      function getEffectiveSetAccessorTypeAnnotationNode(node) {
        var parameter = getSetAccessorValueParameter(node);
        return parameter && getEffectiveTypeAnnotationNode(parameter);
      }
      ts3.getEffectiveSetAccessorTypeAnnotationNode = getEffectiveSetAccessorTypeAnnotationNode;
      function emitNewLineBeforeLeadingComments(lineMap, writer, node, leadingComments) {
        emitNewLineBeforeLeadingCommentsOfPosition(lineMap, writer, node.pos, leadingComments);
      }
      ts3.emitNewLineBeforeLeadingComments = emitNewLineBeforeLeadingComments;
      function emitNewLineBeforeLeadingCommentsOfPosition(lineMap, writer, pos, leadingComments) {
        if (leadingComments && leadingComments.length && pos !== leadingComments[0].pos && getLineOfLocalPositionFromLineMap(lineMap, pos) !== getLineOfLocalPositionFromLineMap(lineMap, leadingComments[0].pos)) {
          writer.writeLine();
        }
      }
      ts3.emitNewLineBeforeLeadingCommentsOfPosition = emitNewLineBeforeLeadingCommentsOfPosition;
      function emitNewLineBeforeLeadingCommentOfPosition(lineMap, writer, pos, commentPos) {
        if (pos !== commentPos && getLineOfLocalPositionFromLineMap(lineMap, pos) !== getLineOfLocalPositionFromLineMap(lineMap, commentPos)) {
          writer.writeLine();
        }
      }
      ts3.emitNewLineBeforeLeadingCommentOfPosition = emitNewLineBeforeLeadingCommentOfPosition;
      function emitComments(text, lineMap, writer, comments, leadingSeparator, trailingSeparator, newLine, writeComment) {
        if (comments && comments.length > 0) {
          if (leadingSeparator) {
            writer.writeSpace(" ");
          }
          var emitInterveningSeparator = false;
          for (var _i = 0, comments_1 = comments; _i < comments_1.length; _i++) {
            var comment = comments_1[_i];
            if (emitInterveningSeparator) {
              writer.writeSpace(" ");
              emitInterveningSeparator = false;
            }
            writeComment(text, lineMap, writer, comment.pos, comment.end, newLine);
            if (comment.hasTrailingNewLine) {
              writer.writeLine();
            } else {
              emitInterveningSeparator = true;
            }
          }
          if (emitInterveningSeparator && trailingSeparator) {
            writer.writeSpace(" ");
          }
        }
      }
      ts3.emitComments = emitComments;
      function emitDetachedComments(text, lineMap, writer, writeComment, node, newLine, removeComments) {
        var leadingComments;
        var currentDetachedCommentInfo;
        if (removeComments) {
          if (node.pos === 0) {
            leadingComments = ts3.filter(ts3.getLeadingCommentRanges(text, node.pos), isPinnedCommentLocal);
          }
        } else {
          leadingComments = ts3.getLeadingCommentRanges(text, node.pos);
        }
        if (leadingComments) {
          var detachedComments = [];
          var lastComment = void 0;
          for (var _i = 0, leadingComments_1 = leadingComments; _i < leadingComments_1.length; _i++) {
            var comment = leadingComments_1[_i];
            if (lastComment) {
              var lastCommentLine = getLineOfLocalPositionFromLineMap(lineMap, lastComment.end);
              var commentLine = getLineOfLocalPositionFromLineMap(lineMap, comment.pos);
              if (commentLine >= lastCommentLine + 2) {
                break;
              }
            }
            detachedComments.push(comment);
            lastComment = comment;
          }
          if (detachedComments.length) {
            var lastCommentLine = getLineOfLocalPositionFromLineMap(lineMap, ts3.last(detachedComments).end);
            var nodeLine = getLineOfLocalPositionFromLineMap(lineMap, ts3.skipTrivia(text, node.pos));
            if (nodeLine >= lastCommentLine + 2) {
              emitNewLineBeforeLeadingComments(lineMap, writer, node, leadingComments);
              emitComments(text, lineMap, writer, detachedComments, false, true, newLine, writeComment);
              currentDetachedCommentInfo = { nodePos: node.pos, detachedCommentEndPos: ts3.last(detachedComments).end };
            }
          }
        }
        return currentDetachedCommentInfo;
        function isPinnedCommentLocal(comment2) {
          return isPinnedComment(text, comment2.pos);
        }
      }
      ts3.emitDetachedComments = emitDetachedComments;
      function writeCommentRange(text, lineMap, writer, commentPos, commentEnd, newLine) {
        if (text.charCodeAt(commentPos + 1) === 42) {
          var firstCommentLineAndCharacter = ts3.computeLineAndCharacterOfPosition(lineMap, commentPos);
          var lineCount = lineMap.length;
          var firstCommentLineIndent = void 0;
          for (var pos = commentPos, currentLine = firstCommentLineAndCharacter.line; pos < commentEnd; currentLine++) {
            var nextLineStart = currentLine + 1 === lineCount ? text.length + 1 : lineMap[currentLine + 1];
            if (pos !== commentPos) {
              if (firstCommentLineIndent === void 0) {
                firstCommentLineIndent = calculateIndent(text, lineMap[firstCommentLineAndCharacter.line], commentPos);
              }
              var currentWriterIndentSpacing = writer.getIndent() * getIndentSize();
              var spacesToEmit = currentWriterIndentSpacing - firstCommentLineIndent + calculateIndent(text, pos, nextLineStart);
              if (spacesToEmit > 0) {
                var numberOfSingleSpacesToEmit = spacesToEmit % getIndentSize();
                var indentSizeSpaceString = getIndentString((spacesToEmit - numberOfSingleSpacesToEmit) / getIndentSize());
                writer.rawWrite(indentSizeSpaceString);
                while (numberOfSingleSpacesToEmit) {
                  writer.rawWrite(" ");
                  numberOfSingleSpacesToEmit--;
                }
              } else {
                writer.rawWrite("");
              }
            }
            writeTrimmedCurrentLine(text, commentEnd, writer, newLine, pos, nextLineStart);
            pos = nextLineStart;
          }
        } else {
          writer.writeComment(text.substring(commentPos, commentEnd));
        }
      }
      ts3.writeCommentRange = writeCommentRange;
      function writeTrimmedCurrentLine(text, commentEnd, writer, newLine, pos, nextLineStart) {
        var end = Math.min(commentEnd, nextLineStart - 1);
        var currentLineText = text.substring(pos, end).replace(/^\s+|\s+$/g, "");
        if (currentLineText) {
          writer.writeComment(currentLineText);
          if (end !== commentEnd) {
            writer.writeLine();
          }
        } else {
          writer.rawWrite(newLine);
        }
      }
      function calculateIndent(text, pos, end) {
        var currentLineIndent = 0;
        for (; pos < end && ts3.isWhiteSpaceSingleLine(text.charCodeAt(pos)); pos++) {
          if (text.charCodeAt(pos) === 9) {
            currentLineIndent += getIndentSize() - currentLineIndent % getIndentSize();
          } else {
            currentLineIndent++;
          }
        }
        return currentLineIndent;
      }
      function hasEffectiveModifiers(node) {
        return getEffectiveModifierFlags(node) !== 0;
      }
      ts3.hasEffectiveModifiers = hasEffectiveModifiers;
      function hasSyntacticModifiers(node) {
        return getSyntacticModifierFlags(node) !== 0;
      }
      ts3.hasSyntacticModifiers = hasSyntacticModifiers;
      function hasEffectiveModifier(node, flags) {
        return !!getSelectedEffectiveModifierFlags(node, flags);
      }
      ts3.hasEffectiveModifier = hasEffectiveModifier;
      function hasSyntacticModifier(node, flags) {
        return !!getSelectedSyntacticModifierFlags(node, flags);
      }
      ts3.hasSyntacticModifier = hasSyntacticModifier;
      function hasStaticModifier(node) {
        return hasSyntacticModifier(node, 32);
      }
      ts3.hasStaticModifier = hasStaticModifier;
      function hasOverrideModifier(node) {
        return hasEffectiveModifier(node, 16384);
      }
      ts3.hasOverrideModifier = hasOverrideModifier;
      function hasAbstractModifier(node) {
        return hasSyntacticModifier(node, 128);
      }
      ts3.hasAbstractModifier = hasAbstractModifier;
      function hasAmbientModifier(node) {
        return hasSyntacticModifier(node, 2);
      }
      ts3.hasAmbientModifier = hasAmbientModifier;
      function hasEffectiveReadonlyModifier(node) {
        return hasEffectiveModifier(node, 64);
      }
      ts3.hasEffectiveReadonlyModifier = hasEffectiveReadonlyModifier;
      function getSelectedEffectiveModifierFlags(node, flags) {
        return getEffectiveModifierFlags(node) & flags;
      }
      ts3.getSelectedEffectiveModifierFlags = getSelectedEffectiveModifierFlags;
      function getSelectedSyntacticModifierFlags(node, flags) {
        return getSyntacticModifierFlags(node) & flags;
      }
      ts3.getSelectedSyntacticModifierFlags = getSelectedSyntacticModifierFlags;
      function getModifierFlagsWorker(node, includeJSDoc, alwaysIncludeJSDoc) {
        if (node.kind >= 0 && node.kind <= 157) {
          return 0;
        }
        if (!(node.modifierFlagsCache & 536870912)) {
          node.modifierFlagsCache = getSyntacticModifierFlagsNoCache(node) | 536870912;
        }
        if (includeJSDoc && !(node.modifierFlagsCache & 4096) && (alwaysIncludeJSDoc || isInJSFile(node)) && node.parent) {
          node.modifierFlagsCache |= getJSDocModifierFlagsNoCache(node) | 4096;
        }
        return node.modifierFlagsCache & ~(536870912 | 4096);
      }
      function getEffectiveModifierFlags(node) {
        return getModifierFlagsWorker(node, true);
      }
      ts3.getEffectiveModifierFlags = getEffectiveModifierFlags;
      function getEffectiveModifierFlagsAlwaysIncludeJSDoc(node) {
        return getModifierFlagsWorker(node, true, true);
      }
      ts3.getEffectiveModifierFlagsAlwaysIncludeJSDoc = getEffectiveModifierFlagsAlwaysIncludeJSDoc;
      function getSyntacticModifierFlags(node) {
        return getModifierFlagsWorker(node, false);
      }
      ts3.getSyntacticModifierFlags = getSyntacticModifierFlags;
      function getJSDocModifierFlagsNoCache(node) {
        var flags = 0;
        if (!!node.parent && !ts3.isParameter(node)) {
          if (isInJSFile(node)) {
            if (ts3.getJSDocPublicTagNoCache(node))
              flags |= 4;
            if (ts3.getJSDocPrivateTagNoCache(node))
              flags |= 8;
            if (ts3.getJSDocProtectedTagNoCache(node))
              flags |= 16;
            if (ts3.getJSDocReadonlyTagNoCache(node))
              flags |= 64;
            if (ts3.getJSDocOverrideTagNoCache(node))
              flags |= 16384;
          }
          if (ts3.getJSDocDeprecatedTagNoCache(node))
            flags |= 8192;
        }
        return flags;
      }
      function getEffectiveModifierFlagsNoCache(node) {
        return getSyntacticModifierFlagsNoCache(node) | getJSDocModifierFlagsNoCache(node);
      }
      ts3.getEffectiveModifierFlagsNoCache = getEffectiveModifierFlagsNoCache;
      function getSyntacticModifierFlagsNoCache(node) {
        var flags = modifiersToFlags(node.modifiers);
        if (node.flags & 4 || node.kind === 78 && node.isInJSDocNamespace) {
          flags |= 1;
        }
        return flags;
      }
      ts3.getSyntacticModifierFlagsNoCache = getSyntacticModifierFlagsNoCache;
      function modifiersToFlags(modifiers) {
        var flags = 0;
        if (modifiers) {
          for (var _i = 0, modifiers_1 = modifiers; _i < modifiers_1.length; _i++) {
            var modifier = modifiers_1[_i];
            flags |= modifierToFlag(modifier.kind);
          }
        }
        return flags;
      }
      ts3.modifiersToFlags = modifiersToFlags;
      function modifierToFlag(token) {
        switch (token) {
          case 123:
            return 32;
          case 122:
            return 4;
          case 121:
            return 16;
          case 120:
            return 8;
          case 125:
            return 128;
          case 92:
            return 1;
          case 133:
            return 2;
          case 84:
            return 2048;
          case 87:
            return 512;
          case 129:
            return 256;
          case 142:
            return 64;
          case 156:
            return 16384;
        }
        return 0;
      }
      ts3.modifierToFlag = modifierToFlag;
      function createModifiers(modifierFlags) {
        return modifierFlags ? ts3.factory.createNodeArray(ts3.factory.createModifiersFromModifierFlags(modifierFlags)) : void 0;
      }
      ts3.createModifiers = createModifiers;
      function isLogicalOperator(token) {
        return token === 56 || token === 55 || token === 53;
      }
      ts3.isLogicalOperator = isLogicalOperator;
      function isLogicalOrCoalescingAssignmentOperator(token) {
        return token === 74 || token === 75 || token === 76;
      }
      ts3.isLogicalOrCoalescingAssignmentOperator = isLogicalOrCoalescingAssignmentOperator;
      function isLogicalOrCoalescingAssignmentExpression(expr) {
        return isLogicalOrCoalescingAssignmentOperator(expr.operatorToken.kind);
      }
      ts3.isLogicalOrCoalescingAssignmentExpression = isLogicalOrCoalescingAssignmentExpression;
      function isAssignmentOperator(token) {
        return token >= 62 && token <= 77;
      }
      ts3.isAssignmentOperator = isAssignmentOperator;
      function tryGetClassExtendingExpressionWithTypeArguments(node) {
        var cls = tryGetClassImplementingOrExtendingExpressionWithTypeArguments(node);
        return cls && !cls.isImplements ? cls.class : void 0;
      }
      ts3.tryGetClassExtendingExpressionWithTypeArguments = tryGetClassExtendingExpressionWithTypeArguments;
      function tryGetClassImplementingOrExtendingExpressionWithTypeArguments(node) {
        return ts3.isExpressionWithTypeArguments(node) && ts3.isHeritageClause(node.parent) && ts3.isClassLike(node.parent.parent) ? { class: node.parent.parent, isImplements: node.parent.token === 116 } : void 0;
      }
      ts3.tryGetClassImplementingOrExtendingExpressionWithTypeArguments = tryGetClassImplementingOrExtendingExpressionWithTypeArguments;
      function isAssignmentExpression(node, excludeCompoundAssignment) {
        return ts3.isBinaryExpression(node) && (excludeCompoundAssignment ? node.operatorToken.kind === 62 : isAssignmentOperator(node.operatorToken.kind)) && ts3.isLeftHandSideExpression(node.left);
      }
      ts3.isAssignmentExpression = isAssignmentExpression;
      function isLeftHandSideOfAssignment(node) {
        return isAssignmentExpression(node.parent) && node.parent.left === node;
      }
      ts3.isLeftHandSideOfAssignment = isLeftHandSideOfAssignment;
      function isDestructuringAssignment(node) {
        if (isAssignmentExpression(node, true)) {
          var kind = node.left.kind;
          return kind === 201 || kind === 200;
        }
        return false;
      }
      ts3.isDestructuringAssignment = isDestructuringAssignment;
      function isExpressionWithTypeArgumentsInClassExtendsClause(node) {
        return tryGetClassExtendingExpressionWithTypeArguments(node) !== void 0;
      }
      ts3.isExpressionWithTypeArgumentsInClassExtendsClause = isExpressionWithTypeArgumentsInClassExtendsClause;
      function isEntityNameExpression(node) {
        return node.kind === 78 || isPropertyAccessEntityNameExpression(node);
      }
      ts3.isEntityNameExpression = isEntityNameExpression;
      function getFirstIdentifier(node) {
        switch (node.kind) {
          case 78:
            return node;
          case 158:
            do {
              node = node.left;
            } while (node.kind !== 78);
            return node;
          case 202:
            do {
              node = node.expression;
            } while (node.kind !== 78);
            return node;
        }
      }
      ts3.getFirstIdentifier = getFirstIdentifier;
      function isDottedName(node) {
        return node.kind === 78 || node.kind === 107 || node.kind === 105 || node.kind === 227 || node.kind === 202 && isDottedName(node.expression) || node.kind === 208 && isDottedName(node.expression);
      }
      ts3.isDottedName = isDottedName;
      function isPropertyAccessEntityNameExpression(node) {
        return ts3.isPropertyAccessExpression(node) && ts3.isIdentifier(node.name) && isEntityNameExpression(node.expression);
      }
      ts3.isPropertyAccessEntityNameExpression = isPropertyAccessEntityNameExpression;
      function tryGetPropertyAccessOrIdentifierToString(expr) {
        if (ts3.isPropertyAccessExpression(expr)) {
          var baseStr = tryGetPropertyAccessOrIdentifierToString(expr.expression);
          if (baseStr !== void 0) {
            return baseStr + "." + entityNameToString(expr.name);
          }
        } else if (ts3.isElementAccessExpression(expr)) {
          var baseStr = tryGetPropertyAccessOrIdentifierToString(expr.expression);
          if (baseStr !== void 0 && ts3.isPropertyName(expr.argumentExpression)) {
            return baseStr + "." + getPropertyNameForPropertyNameNode(expr.argumentExpression);
          }
        } else if (ts3.isIdentifier(expr)) {
          return ts3.unescapeLeadingUnderscores(expr.escapedText);
        }
        return void 0;
      }
      ts3.tryGetPropertyAccessOrIdentifierToString = tryGetPropertyAccessOrIdentifierToString;
      function isPrototypeAccess(node) {
        return isBindableStaticAccessExpression(node) && getElementOrPropertyAccessName(node) === "prototype";
      }
      ts3.isPrototypeAccess = isPrototypeAccess;
      function isRightSideOfQualifiedNameOrPropertyAccess(node) {
        return node.parent.kind === 158 && node.parent.right === node || node.parent.kind === 202 && node.parent.name === node;
      }
      ts3.isRightSideOfQualifiedNameOrPropertyAccess = isRightSideOfQualifiedNameOrPropertyAccess;
      function isEmptyObjectLiteral(expression) {
        return expression.kind === 201 && expression.properties.length === 0;
      }
      ts3.isEmptyObjectLiteral = isEmptyObjectLiteral;
      function isEmptyArrayLiteral(expression) {
        return expression.kind === 200 && expression.elements.length === 0;
      }
      ts3.isEmptyArrayLiteral = isEmptyArrayLiteral;
      function getLocalSymbolForExportDefault(symbol) {
        if (!isExportDefaultSymbol(symbol) || !symbol.declarations)
          return void 0;
        for (var _i = 0, _a2 = symbol.declarations; _i < _a2.length; _i++) {
          var decl = _a2[_i];
          if (decl.localSymbol)
            return decl.localSymbol;
        }
        return void 0;
      }
      ts3.getLocalSymbolForExportDefault = getLocalSymbolForExportDefault;
      function isExportDefaultSymbol(symbol) {
        return symbol && ts3.length(symbol.declarations) > 0 && hasSyntacticModifier(symbol.declarations[0], 512);
      }
      function tryExtractTSExtension(fileName) {
        return ts3.find(ts3.supportedTSExtensionsForExtractExtension, function(extension) {
          return ts3.fileExtensionIs(fileName, extension);
        });
      }
      ts3.tryExtractTSExtension = tryExtractTSExtension;
      function getExpandedCharCodes(input) {
        var output = [];
        var length = input.length;
        for (var i3 = 0; i3 < length; i3++) {
          var charCode = input.charCodeAt(i3);
          if (charCode < 128) {
            output.push(charCode);
          } else if (charCode < 2048) {
            output.push(charCode >> 6 | 192);
            output.push(charCode & 63 | 128);
          } else if (charCode < 65536) {
            output.push(charCode >> 12 | 224);
            output.push(charCode >> 6 & 63 | 128);
            output.push(charCode & 63 | 128);
          } else if (charCode < 131072) {
            output.push(charCode >> 18 | 240);
            output.push(charCode >> 12 & 63 | 128);
            output.push(charCode >> 6 & 63 | 128);
            output.push(charCode & 63 | 128);
          } else {
            ts3.Debug.assert(false, "Unexpected code point");
          }
        }
        return output;
      }
      var base64Digits = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=";
      function convertToBase64(input) {
        var result2 = "";
        var charCodes = getExpandedCharCodes(input);
        var i3 = 0;
        var length = charCodes.length;
        var byte1, byte2, byte3, byte4;
        while (i3 < length) {
          byte1 = charCodes[i3] >> 2;
          byte2 = (charCodes[i3] & 3) << 4 | charCodes[i3 + 1] >> 4;
          byte3 = (charCodes[i3 + 1] & 15) << 2 | charCodes[i3 + 2] >> 6;
          byte4 = charCodes[i3 + 2] & 63;
          if (i3 + 1 >= length) {
            byte3 = byte4 = 64;
          } else if (i3 + 2 >= length) {
            byte4 = 64;
          }
          result2 += base64Digits.charAt(byte1) + base64Digits.charAt(byte2) + base64Digits.charAt(byte3) + base64Digits.charAt(byte4);
          i3 += 3;
        }
        return result2;
      }
      ts3.convertToBase64 = convertToBase64;
      function getStringFromExpandedCharCodes(codes) {
        var output = "";
        var i3 = 0;
        var length = codes.length;
        while (i3 < length) {
          var charCode = codes[i3];
          if (charCode < 128) {
            output += String.fromCharCode(charCode);
            i3++;
          } else if ((charCode & 192) === 192) {
            var value = charCode & 63;
            i3++;
            var nextCode = codes[i3];
            while ((nextCode & 192) === 128) {
              value = value << 6 | nextCode & 63;
              i3++;
              nextCode = codes[i3];
            }
            output += String.fromCharCode(value);
          } else {
            output += String.fromCharCode(charCode);
            i3++;
          }
        }
        return output;
      }
      function base64encode(host, input) {
        if (host && host.base64encode) {
          return host.base64encode(input);
        }
        return convertToBase64(input);
      }
      ts3.base64encode = base64encode;
      function base64decode(host, input) {
        if (host && host.base64decode) {
          return host.base64decode(input);
        }
        var length = input.length;
        var expandedCharCodes = [];
        var i3 = 0;
        while (i3 < length) {
          if (input.charCodeAt(i3) === base64Digits.charCodeAt(64)) {
            break;
          }
          var ch1 = base64Digits.indexOf(input[i3]);
          var ch2 = base64Digits.indexOf(input[i3 + 1]);
          var ch3 = base64Digits.indexOf(input[i3 + 2]);
          var ch4 = base64Digits.indexOf(input[i3 + 3]);
          var code1 = (ch1 & 63) << 2 | ch2 >> 4 & 3;
          var code2 = (ch2 & 15) << 4 | ch3 >> 2 & 15;
          var code3 = (ch3 & 3) << 6 | ch4 & 63;
          if (code2 === 0 && ch3 !== 0) {
            expandedCharCodes.push(code1);
          } else if (code3 === 0 && ch4 !== 0) {
            expandedCharCodes.push(code1, code2);
          } else {
            expandedCharCodes.push(code1, code2, code3);
          }
          i3 += 4;
        }
        return getStringFromExpandedCharCodes(expandedCharCodes);
      }
      ts3.base64decode = base64decode;
      function readJson(path2, host) {
        try {
          var jsonText = host.readFile(path2);
          if (!jsonText)
            return {};
          var result2 = ts3.parseConfigFileTextToJson(path2, jsonText);
          if (result2.error) {
            return {};
          }
          return result2.config;
        } catch (e2) {
          return {};
        }
      }
      ts3.readJson = readJson;
      function directoryProbablyExists(directoryName, host) {
        return !host.directoryExists || host.directoryExists(directoryName);
      }
      ts3.directoryProbablyExists = directoryProbablyExists;
      var carriageReturnLineFeed = "\r\n";
      var lineFeed = "\n";
      function getNewLineCharacter(options, getNewLine) {
        switch (options.newLine) {
          case 0:
            return carriageReturnLineFeed;
          case 1:
            return lineFeed;
        }
        return getNewLine ? getNewLine() : ts3.sys ? ts3.sys.newLine : carriageReturnLineFeed;
      }
      ts3.getNewLineCharacter = getNewLineCharacter;
      function createRange(pos, end) {
        if (end === void 0) {
          end = pos;
        }
        ts3.Debug.assert(end >= pos || end === -1);
        return { pos, end };
      }
      ts3.createRange = createRange;
      function moveRangeEnd(range, end) {
        return createRange(range.pos, end);
      }
      ts3.moveRangeEnd = moveRangeEnd;
      function moveRangePos(range, pos) {
        return createRange(pos, range.end);
      }
      ts3.moveRangePos = moveRangePos;
      function moveRangePastDecorators(node) {
        return node.decorators && node.decorators.length > 0 ? moveRangePos(node, node.decorators.end) : node;
      }
      ts3.moveRangePastDecorators = moveRangePastDecorators;
      function moveRangePastModifiers(node) {
        return node.modifiers && node.modifiers.length > 0 ? moveRangePos(node, node.modifiers.end) : moveRangePastDecorators(node);
      }
      ts3.moveRangePastModifiers = moveRangePastModifiers;
      function isCollapsedRange(range) {
        return range.pos === range.end;
      }
      ts3.isCollapsedRange = isCollapsedRange;
      function createTokenRange(pos, token) {
        return createRange(pos, pos + ts3.tokenToString(token).length);
      }
      ts3.createTokenRange = createTokenRange;
      function rangeIsOnSingleLine(range, sourceFile) {
        return rangeStartIsOnSameLineAsRangeEnd(range, range, sourceFile);
      }
      ts3.rangeIsOnSingleLine = rangeIsOnSingleLine;
      function rangeStartPositionsAreOnSameLine(range1, range2, sourceFile) {
        return positionsAreOnSameLine(getStartPositionOfRange(range1, sourceFile, false), getStartPositionOfRange(range2, sourceFile, false), sourceFile);
      }
      ts3.rangeStartPositionsAreOnSameLine = rangeStartPositionsAreOnSameLine;
      function rangeEndPositionsAreOnSameLine(range1, range2, sourceFile) {
        return positionsAreOnSameLine(range1.end, range2.end, sourceFile);
      }
      ts3.rangeEndPositionsAreOnSameLine = rangeEndPositionsAreOnSameLine;
      function rangeStartIsOnSameLineAsRangeEnd(range1, range2, sourceFile) {
        return positionsAreOnSameLine(getStartPositionOfRange(range1, sourceFile, false), range2.end, sourceFile);
      }
      ts3.rangeStartIsOnSameLineAsRangeEnd = rangeStartIsOnSameLineAsRangeEnd;
      function rangeEndIsOnSameLineAsRangeStart(range1, range2, sourceFile) {
        return positionsAreOnSameLine(range1.end, getStartPositionOfRange(range2, sourceFile, false), sourceFile);
      }
      ts3.rangeEndIsOnSameLineAsRangeStart = rangeEndIsOnSameLineAsRangeStart;
      function getLinesBetweenRangeEndAndRangeStart(range1, range2, sourceFile, includeSecondRangeComments) {
        var range2Start = getStartPositionOfRange(range2, sourceFile, includeSecondRangeComments);
        return ts3.getLinesBetweenPositions(sourceFile, range1.end, range2Start);
      }
      ts3.getLinesBetweenRangeEndAndRangeStart = getLinesBetweenRangeEndAndRangeStart;
      function getLinesBetweenRangeEndPositions(range1, range2, sourceFile) {
        return ts3.getLinesBetweenPositions(sourceFile, range1.end, range2.end);
      }
      ts3.getLinesBetweenRangeEndPositions = getLinesBetweenRangeEndPositions;
      function isNodeArrayMultiLine(list, sourceFile) {
        return !positionsAreOnSameLine(list.pos, list.end, sourceFile);
      }
      ts3.isNodeArrayMultiLine = isNodeArrayMultiLine;
      function positionsAreOnSameLine(pos1, pos2, sourceFile) {
        return ts3.getLinesBetweenPositions(sourceFile, pos1, pos2) === 0;
      }
      ts3.positionsAreOnSameLine = positionsAreOnSameLine;
      function getStartPositionOfRange(range, sourceFile, includeComments) {
        return positionIsSynthesized(range.pos) ? -1 : ts3.skipTrivia(sourceFile.text, range.pos, false, includeComments);
      }
      ts3.getStartPositionOfRange = getStartPositionOfRange;
      function getLinesBetweenPositionAndPrecedingNonWhitespaceCharacter(pos, stopPos, sourceFile, includeComments) {
        var startPos = ts3.skipTrivia(sourceFile.text, pos, false, includeComments);
        var prevPos = getPreviousNonWhitespacePosition(startPos, stopPos, sourceFile);
        return ts3.getLinesBetweenPositions(sourceFile, prevPos !== null && prevPos !== void 0 ? prevPos : stopPos, startPos);
      }
      ts3.getLinesBetweenPositionAndPrecedingNonWhitespaceCharacter = getLinesBetweenPositionAndPrecedingNonWhitespaceCharacter;
      function getLinesBetweenPositionAndNextNonWhitespaceCharacter(pos, stopPos, sourceFile, includeComments) {
        var nextPos = ts3.skipTrivia(sourceFile.text, pos, false, includeComments);
        return ts3.getLinesBetweenPositions(sourceFile, pos, Math.min(stopPos, nextPos));
      }
      ts3.getLinesBetweenPositionAndNextNonWhitespaceCharacter = getLinesBetweenPositionAndNextNonWhitespaceCharacter;
      function getPreviousNonWhitespacePosition(pos, stopPos, sourceFile) {
        if (stopPos === void 0) {
          stopPos = 0;
        }
        while (pos-- > stopPos) {
          if (!ts3.isWhiteSpaceLike(sourceFile.text.charCodeAt(pos))) {
            return pos;
          }
        }
      }
      function isDeclarationNameOfEnumOrNamespace(node) {
        var parseNode = ts3.getParseTreeNode(node);
        if (parseNode) {
          switch (parseNode.parent.kind) {
            case 256:
            case 257:
              return parseNode === parseNode.parent.name;
          }
        }
        return false;
      }
      ts3.isDeclarationNameOfEnumOrNamespace = isDeclarationNameOfEnumOrNamespace;
      function getInitializedVariables(node) {
        return ts3.filter(node.declarations, isInitializedVariable);
      }
      ts3.getInitializedVariables = getInitializedVariables;
      function isInitializedVariable(node) {
        return node.initializer !== void 0;
      }
      function isWatchSet(options) {
        return options.watch && options.hasOwnProperty("watch");
      }
      ts3.isWatchSet = isWatchSet;
      function closeFileWatcher(watcher) {
        watcher.close();
      }
      ts3.closeFileWatcher = closeFileWatcher;
      function getCheckFlags(symbol) {
        return symbol.flags & 33554432 ? symbol.checkFlags : 0;
      }
      ts3.getCheckFlags = getCheckFlags;
      function getDeclarationModifierFlagsFromSymbol(s2, isWrite) {
        if (isWrite === void 0) {
          isWrite = false;
        }
        if (s2.valueDeclaration) {
          var declaration = isWrite && s2.declarations && ts3.find(s2.declarations, function(d) {
            return d.kind === 169;
          }) || s2.valueDeclaration;
          var flags = ts3.getCombinedModifierFlags(declaration);
          return s2.parent && s2.parent.flags & 32 ? flags : flags & ~28;
        }
        if (getCheckFlags(s2) & 6) {
          var checkFlags = s2.checkFlags;
          var accessModifier = checkFlags & 1024 ? 8 : checkFlags & 256 ? 4 : 16;
          var staticModifier = checkFlags & 2048 ? 32 : 0;
          return accessModifier | staticModifier;
        }
        if (s2.flags & 4194304) {
          return 4 | 32;
        }
        return 0;
      }
      ts3.getDeclarationModifierFlagsFromSymbol = getDeclarationModifierFlagsFromSymbol;
      function skipAlias(symbol, checker) {
        return symbol.flags & 2097152 ? checker.getAliasedSymbol(symbol) : symbol;
      }
      ts3.skipAlias = skipAlias;
      function getCombinedLocalAndExportSymbolFlags(symbol) {
        return symbol.exportSymbol ? symbol.exportSymbol.flags | symbol.flags : symbol.flags;
      }
      ts3.getCombinedLocalAndExportSymbolFlags = getCombinedLocalAndExportSymbolFlags;
      function isWriteOnlyAccess(node) {
        return accessKind(node) === 1;
      }
      ts3.isWriteOnlyAccess = isWriteOnlyAccess;
      function isWriteAccess(node) {
        return accessKind(node) !== 0;
      }
      ts3.isWriteAccess = isWriteAccess;
      var AccessKind;
      (function(AccessKind2) {
        AccessKind2[AccessKind2["Read"] = 0] = "Read";
        AccessKind2[AccessKind2["Write"] = 1] = "Write";
        AccessKind2[AccessKind2["ReadWrite"] = 2] = "ReadWrite";
      })(AccessKind || (AccessKind = {}));
      function accessKind(node) {
        var parent = node.parent;
        if (!parent)
          return 0;
        switch (parent.kind) {
          case 208:
            return accessKind(parent);
          case 216:
          case 215:
            var operator = parent.operator;
            return operator === 45 || operator === 46 ? writeOrReadWrite() : 0;
          case 217:
            var _a2 = parent, left = _a2.left, operatorToken = _a2.operatorToken;
            return left === node && isAssignmentOperator(operatorToken.kind) ? operatorToken.kind === 62 ? 1 : writeOrReadWrite() : 0;
          case 202:
            return parent.name !== node ? 0 : accessKind(parent);
          case 289: {
            var parentAccess = accessKind(parent.parent);
            return node === parent.name ? reverseAccessKind(parentAccess) : parentAccess;
          }
          case 290:
            return node === parent.objectAssignmentInitializer ? 0 : accessKind(parent.parent);
          case 200:
            return accessKind(parent);
          default:
            return 0;
        }
        function writeOrReadWrite() {
          return parent.parent && skipParenthesesUp(parent.parent).kind === 234 ? 1 : 2;
        }
      }
      function reverseAccessKind(a2) {
        switch (a2) {
          case 0:
            return 1;
          case 1:
            return 0;
          case 2:
            return 2;
          default:
            return ts3.Debug.assertNever(a2);
        }
      }
      function compareDataObjects(dst, src) {
        if (!dst || !src || Object.keys(dst).length !== Object.keys(src).length) {
          return false;
        }
        for (var e2 in dst) {
          if (typeof dst[e2] === "object") {
            if (!compareDataObjects(dst[e2], src[e2])) {
              return false;
            }
          } else if (typeof dst[e2] !== "function") {
            if (dst[e2] !== src[e2]) {
              return false;
            }
          }
        }
        return true;
      }
      ts3.compareDataObjects = compareDataObjects;
      function clearMap(map2, onDeleteValue) {
        map2.forEach(onDeleteValue);
        map2.clear();
      }
      ts3.clearMap = clearMap;
      function mutateMapSkippingNewValues(map2, newMap, options) {
        var onDeleteValue = options.onDeleteValue, onExistingValue = options.onExistingValue;
        map2.forEach(function(existingValue, key2) {
          var valueInNewMap = newMap.get(key2);
          if (valueInNewMap === void 0) {
            map2.delete(key2);
            onDeleteValue(existingValue, key2);
          } else if (onExistingValue) {
            onExistingValue(existingValue, valueInNewMap, key2);
          }
        });
      }
      ts3.mutateMapSkippingNewValues = mutateMapSkippingNewValues;
      function mutateMap(map2, newMap, options) {
        mutateMapSkippingNewValues(map2, newMap, options);
        var createNewValue = options.createNewValue;
        newMap.forEach(function(valueInNewMap, key2) {
          if (!map2.has(key2)) {
            map2.set(key2, createNewValue(key2, valueInNewMap));
          }
        });
      }
      ts3.mutateMap = mutateMap;
      function isAbstractConstructorSymbol(symbol) {
        if (symbol.flags & 32) {
          var declaration = getClassLikeDeclarationOfSymbol(symbol);
          return !!declaration && hasSyntacticModifier(declaration, 128);
        }
        return false;
      }
      ts3.isAbstractConstructorSymbol = isAbstractConstructorSymbol;
      function getClassLikeDeclarationOfSymbol(symbol) {
        var _a2;
        return (_a2 = symbol.declarations) === null || _a2 === void 0 ? void 0 : _a2.find(ts3.isClassLike);
      }
      ts3.getClassLikeDeclarationOfSymbol = getClassLikeDeclarationOfSymbol;
      function getObjectFlags(type3) {
        return type3.flags & 3899393 ? type3.objectFlags : 0;
      }
      ts3.getObjectFlags = getObjectFlags;
      function typeHasCallOrConstructSignatures(type3, checker) {
        return checker.getSignaturesOfType(type3, 0).length !== 0 || checker.getSignaturesOfType(type3, 1).length !== 0;
      }
      ts3.typeHasCallOrConstructSignatures = typeHasCallOrConstructSignatures;
      function forSomeAncestorDirectory(directory, callback) {
        return !!ts3.forEachAncestorDirectory(directory, function(d) {
          return callback(d) ? true : void 0;
        });
      }
      ts3.forSomeAncestorDirectory = forSomeAncestorDirectory;
      function isUMDExportSymbol(symbol) {
        return !!symbol && !!symbol.declarations && !!symbol.declarations[0] && ts3.isNamespaceExportDeclaration(symbol.declarations[0]);
      }
      ts3.isUMDExportSymbol = isUMDExportSymbol;
      function showModuleSpecifier(_a2) {
        var moduleSpecifier = _a2.moduleSpecifier;
        return ts3.isStringLiteral(moduleSpecifier) ? moduleSpecifier.text : getTextOfNode(moduleSpecifier);
      }
      ts3.showModuleSpecifier = showModuleSpecifier;
      function getLastChild(node) {
        var lastChild;
        ts3.forEachChild(node, function(child) {
          if (nodeIsPresent(child))
            lastChild = child;
        }, function(children) {
          for (var i3 = children.length - 1; i3 >= 0; i3--) {
            if (nodeIsPresent(children[i3])) {
              lastChild = children[i3];
              break;
            }
          }
        });
        return lastChild;
      }
      ts3.getLastChild = getLastChild;
      function addToSeen(seen, key2, value) {
        if (value === void 0) {
          value = true;
        }
        if (seen.has(key2)) {
          return false;
        }
        seen.set(key2, value);
        return true;
      }
      ts3.addToSeen = addToSeen;
      function isObjectTypeDeclaration(node) {
        return ts3.isClassLike(node) || ts3.isInterfaceDeclaration(node) || ts3.isTypeLiteralNode(node);
      }
      ts3.isObjectTypeDeclaration = isObjectTypeDeclaration;
      function isTypeNodeKind(kind) {
        return kind >= 173 && kind <= 196 || kind === 128 || kind === 152 || kind === 144 || kind === 155 || kind === 145 || kind === 131 || kind === 147 || kind === 148 || kind === 113 || kind === 150 || kind === 141 || kind === 224 || kind === 304 || kind === 305 || kind === 306 || kind === 307 || kind === 308 || kind === 309 || kind === 310;
      }
      ts3.isTypeNodeKind = isTypeNodeKind;
      function isAccessExpression(node) {
        return node.kind === 202 || node.kind === 203;
      }
      ts3.isAccessExpression = isAccessExpression;
      function getNameOfAccessExpression(node) {
        if (node.kind === 202) {
          return node.name;
        }
        ts3.Debug.assert(node.kind === 203);
        return node.argumentExpression;
      }
      ts3.getNameOfAccessExpression = getNameOfAccessExpression;
      function isBundleFileTextLike(section) {
        switch (section.kind) {
          case "text":
          case "internal":
            return true;
          default:
            return false;
        }
      }
      ts3.isBundleFileTextLike = isBundleFileTextLike;
      function isNamedImportsOrExports(node) {
        return node.kind === 265 || node.kind === 269;
      }
      ts3.isNamedImportsOrExports = isNamedImportsOrExports;
      function getLeftmostAccessExpression(expr) {
        while (isAccessExpression(expr)) {
          expr = expr.expression;
        }
        return expr;
      }
      ts3.getLeftmostAccessExpression = getLeftmostAccessExpression;
      function getLeftmostExpression(node, stopAtCallExpressions) {
        while (true) {
          switch (node.kind) {
            case 216:
              node = node.operand;
              continue;
            case 217:
              node = node.left;
              continue;
            case 218:
              node = node.condition;
              continue;
            case 206:
              node = node.tag;
              continue;
            case 204:
              if (stopAtCallExpressions) {
                return node;
              }
            case 225:
            case 203:
            case 202:
            case 226:
            case 340:
              node = node.expression;
              continue;
          }
          return node;
        }
      }
      ts3.getLeftmostExpression = getLeftmostExpression;
      function Symbol2(flags, name) {
        this.flags = flags;
        this.escapedName = name;
        this.declarations = void 0;
        this.valueDeclaration = void 0;
        this.id = void 0;
        this.mergeId = void 0;
        this.parent = void 0;
      }
      function Type2(checker, flags) {
        this.flags = flags;
        if (ts3.Debug.isDebugging || ts3.tracing) {
          this.checker = checker;
        }
      }
      function Signature(checker, flags) {
        this.flags = flags;
        if (ts3.Debug.isDebugging) {
          this.checker = checker;
        }
      }
      function Node2(kind, pos, end) {
        this.pos = pos;
        this.end = end;
        this.kind = kind;
        this.id = 0;
        this.flags = 0;
        this.modifierFlagsCache = 0;
        this.transformFlags = 0;
        this.parent = void 0;
        this.original = void 0;
      }
      function Token(kind, pos, end) {
        this.pos = pos;
        this.end = end;
        this.kind = kind;
        this.id = 0;
        this.flags = 0;
        this.transformFlags = 0;
        this.parent = void 0;
      }
      function Identifier(kind, pos, end) {
        this.pos = pos;
        this.end = end;
        this.kind = kind;
        this.id = 0;
        this.flags = 0;
        this.transformFlags = 0;
        this.parent = void 0;
        this.original = void 0;
        this.flowNode = void 0;
      }
      function SourceMapSource(fileName, text, skipTrivia) {
        this.fileName = fileName;
        this.text = text;
        this.skipTrivia = skipTrivia || function(pos) {
          return pos;
        };
      }
      ts3.objectAllocator = {
        getNodeConstructor: function() {
          return Node2;
        },
        getTokenConstructor: function() {
          return Token;
        },
        getIdentifierConstructor: function() {
          return Identifier;
        },
        getPrivateIdentifierConstructor: function() {
          return Node2;
        },
        getSourceFileConstructor: function() {
          return Node2;
        },
        getSymbolConstructor: function() {
          return Symbol2;
        },
        getTypeConstructor: function() {
          return Type2;
        },
        getSignatureConstructor: function() {
          return Signature;
        },
        getSourceMapSourceConstructor: function() {
          return SourceMapSource;
        }
      };
      function setObjectAllocator(alloc) {
        ts3.objectAllocator = alloc;
      }
      ts3.setObjectAllocator = setObjectAllocator;
      function formatStringFromArgs(text, args, baseIndex) {
        if (baseIndex === void 0) {
          baseIndex = 0;
        }
        return text.replace(/{(\d+)}/g, function(_match, index) {
          return "" + ts3.Debug.checkDefined(args[+index + baseIndex]);
        });
      }
      ts3.formatStringFromArgs = formatStringFromArgs;
      function setLocalizedDiagnosticMessages(messages) {
        ts3.localizedDiagnosticMessages = messages;
      }
      ts3.setLocalizedDiagnosticMessages = setLocalizedDiagnosticMessages;
      function getLocaleSpecificMessage(message) {
        return ts3.localizedDiagnosticMessages && ts3.localizedDiagnosticMessages[message.key] || message.message;
      }
      ts3.getLocaleSpecificMessage = getLocaleSpecificMessage;
      function createDetachedDiagnostic(fileName, start, length, message) {
        assertDiagnosticLocation(void 0, start, length);
        var text = getLocaleSpecificMessage(message);
        if (arguments.length > 4) {
          text = formatStringFromArgs(text, arguments, 4);
        }
        return {
          file: void 0,
          start,
          length,
          messageText: text,
          category: message.category,
          code: message.code,
          reportsUnnecessary: message.reportsUnnecessary,
          fileName
        };
      }
      ts3.createDetachedDiagnostic = createDetachedDiagnostic;
      function isDiagnosticWithDetachedLocation(diagnostic) {
        return diagnostic.file === void 0 && diagnostic.start !== void 0 && diagnostic.length !== void 0 && typeof diagnostic.fileName === "string";
      }
      function attachFileToDiagnostic(diagnostic, file) {
        var fileName = file.fileName || "";
        var length = file.text.length;
        ts3.Debug.assertEqual(diagnostic.fileName, fileName);
        ts3.Debug.assertLessThanOrEqual(diagnostic.start, length);
        ts3.Debug.assertLessThanOrEqual(diagnostic.start + diagnostic.length, length);
        var diagnosticWithLocation = {
          file,
          start: diagnostic.start,
          length: diagnostic.length,
          messageText: diagnostic.messageText,
          category: diagnostic.category,
          code: diagnostic.code,
          reportsUnnecessary: diagnostic.reportsUnnecessary
        };
        if (diagnostic.relatedInformation) {
          diagnosticWithLocation.relatedInformation = [];
          for (var _i = 0, _a2 = diagnostic.relatedInformation; _i < _a2.length; _i++) {
            var related = _a2[_i];
            if (isDiagnosticWithDetachedLocation(related) && related.fileName === fileName) {
              ts3.Debug.assertLessThanOrEqual(related.start, length);
              ts3.Debug.assertLessThanOrEqual(related.start + related.length, length);
              diagnosticWithLocation.relatedInformation.push(attachFileToDiagnostic(related, file));
            } else {
              diagnosticWithLocation.relatedInformation.push(related);
            }
          }
        }
        return diagnosticWithLocation;
      }
      function attachFileToDiagnostics(diagnostics, file) {
        var diagnosticsWithLocation = [];
        for (var _i = 0, diagnostics_1 = diagnostics; _i < diagnostics_1.length; _i++) {
          var diagnostic = diagnostics_1[_i];
          diagnosticsWithLocation.push(attachFileToDiagnostic(diagnostic, file));
        }
        return diagnosticsWithLocation;
      }
      ts3.attachFileToDiagnostics = attachFileToDiagnostics;
      function createFileDiagnostic(file, start, length, message) {
        assertDiagnosticLocation(file, start, length);
        var text = getLocaleSpecificMessage(message);
        if (arguments.length > 4) {
          text = formatStringFromArgs(text, arguments, 4);
        }
        return {
          file,
          start,
          length,
          messageText: text,
          category: message.category,
          code: message.code,
          reportsUnnecessary: message.reportsUnnecessary,
          reportsDeprecated: message.reportsDeprecated
        };
      }
      ts3.createFileDiagnostic = createFileDiagnostic;
      function formatMessage(_dummy, message) {
        var text = getLocaleSpecificMessage(message);
        if (arguments.length > 2) {
          text = formatStringFromArgs(text, arguments, 2);
        }
        return text;
      }
      ts3.formatMessage = formatMessage;
      function createCompilerDiagnostic(message) {
        var text = getLocaleSpecificMessage(message);
        if (arguments.length > 1) {
          text = formatStringFromArgs(text, arguments, 1);
        }
        return {
          file: void 0,
          start: void 0,
          length: void 0,
          messageText: text,
          category: message.category,
          code: message.code,
          reportsUnnecessary: message.reportsUnnecessary,
          reportsDeprecated: message.reportsDeprecated
        };
      }
      ts3.createCompilerDiagnostic = createCompilerDiagnostic;
      function createCompilerDiagnosticFromMessageChain(chain, relatedInformation) {
        return {
          file: void 0,
          start: void 0,
          length: void 0,
          code: chain.code,
          category: chain.category,
          messageText: chain.next ? chain : chain.messageText,
          relatedInformation
        };
      }
      ts3.createCompilerDiagnosticFromMessageChain = createCompilerDiagnosticFromMessageChain;
      function chainDiagnosticMessages(details, message) {
        var text = getLocaleSpecificMessage(message);
        if (arguments.length > 2) {
          text = formatStringFromArgs(text, arguments, 2);
        }
        return {
          messageText: text,
          category: message.category,
          code: message.code,
          next: details === void 0 || Array.isArray(details) ? details : [details]
        };
      }
      ts3.chainDiagnosticMessages = chainDiagnosticMessages;
      function concatenateDiagnosticMessageChains(headChain, tailChain) {
        var lastChain = headChain;
        while (lastChain.next) {
          lastChain = lastChain.next[0];
        }
        lastChain.next = [tailChain];
      }
      ts3.concatenateDiagnosticMessageChains = concatenateDiagnosticMessageChains;
      function getDiagnosticFilePath(diagnostic) {
        return diagnostic.file ? diagnostic.file.path : void 0;
      }
      function compareDiagnostics(d1, d2) {
        return compareDiagnosticsSkipRelatedInformation(d1, d2) || compareRelatedInformation(d1, d2) || 0;
      }
      ts3.compareDiagnostics = compareDiagnostics;
      function compareDiagnosticsSkipRelatedInformation(d1, d2) {
        return ts3.compareStringsCaseSensitive(getDiagnosticFilePath(d1), getDiagnosticFilePath(d2)) || ts3.compareValues(d1.start, d2.start) || ts3.compareValues(d1.length, d2.length) || ts3.compareValues(d1.code, d2.code) || compareMessageText(d1.messageText, d2.messageText) || 0;
      }
      ts3.compareDiagnosticsSkipRelatedInformation = compareDiagnosticsSkipRelatedInformation;
      function compareRelatedInformation(d1, d2) {
        if (!d1.relatedInformation && !d2.relatedInformation) {
          return 0;
        }
        if (d1.relatedInformation && d2.relatedInformation) {
          return ts3.compareValues(d1.relatedInformation.length, d2.relatedInformation.length) || ts3.forEach(d1.relatedInformation, function(d1i, index) {
            var d2i = d2.relatedInformation[index];
            return compareDiagnostics(d1i, d2i);
          }) || 0;
        }
        return d1.relatedInformation ? -1 : 1;
      }
      function compareMessageText(t1, t2) {
        if (typeof t1 === "string" && typeof t2 === "string") {
          return ts3.compareStringsCaseSensitive(t1, t2);
        } else if (typeof t1 === "string") {
          return -1;
        } else if (typeof t2 === "string") {
          return 1;
        }
        var res = ts3.compareStringsCaseSensitive(t1.messageText, t2.messageText);
        if (res) {
          return res;
        }
        if (!t1.next && !t2.next) {
          return 0;
        }
        if (!t1.next) {
          return -1;
        }
        if (!t2.next) {
          return 1;
        }
        var len = Math.min(t1.next.length, t2.next.length);
        for (var i3 = 0; i3 < len; i3++) {
          res = compareMessageText(t1.next[i3], t2.next[i3]);
          if (res) {
            return res;
          }
        }
        if (t1.next.length < t2.next.length) {
          return -1;
        } else if (t1.next.length > t2.next.length) {
          return 1;
        }
        return 0;
      }
      function getLanguageVariant(scriptKind) {
        return scriptKind === 4 || scriptKind === 2 || scriptKind === 1 || scriptKind === 6 ? 1 : 0;
      }
      ts3.getLanguageVariant = getLanguageVariant;
      function getEmitScriptTarget(compilerOptions) {
        return compilerOptions.target || 0;
      }
      ts3.getEmitScriptTarget = getEmitScriptTarget;
      function getEmitModuleKind(compilerOptions) {
        return typeof compilerOptions.module === "number" ? compilerOptions.module : getEmitScriptTarget(compilerOptions) >= 2 ? ts3.ModuleKind.ES2015 : ts3.ModuleKind.CommonJS;
      }
      ts3.getEmitModuleKind = getEmitModuleKind;
      function getEmitModuleResolutionKind(compilerOptions) {
        var moduleResolution = compilerOptions.moduleResolution;
        if (moduleResolution === void 0) {
          moduleResolution = getEmitModuleKind(compilerOptions) === ts3.ModuleKind.CommonJS ? ts3.ModuleResolutionKind.NodeJs : ts3.ModuleResolutionKind.Classic;
        }
        return moduleResolution;
      }
      ts3.getEmitModuleResolutionKind = getEmitModuleResolutionKind;
      function hasJsonModuleEmitEnabled(options) {
        switch (getEmitModuleKind(options)) {
          case ts3.ModuleKind.CommonJS:
          case ts3.ModuleKind.AMD:
          case ts3.ModuleKind.ES2015:
          case ts3.ModuleKind.ES2020:
          case ts3.ModuleKind.ESNext:
            return true;
          default:
            return false;
        }
      }
      ts3.hasJsonModuleEmitEnabled = hasJsonModuleEmitEnabled;
      function unreachableCodeIsError(options) {
        return options.allowUnreachableCode === false;
      }
      ts3.unreachableCodeIsError = unreachableCodeIsError;
      function unusedLabelIsError(options) {
        return options.allowUnusedLabels === false;
      }
      ts3.unusedLabelIsError = unusedLabelIsError;
      function getAreDeclarationMapsEnabled(options) {
        return !!(getEmitDeclarations(options) && options.declarationMap);
      }
      ts3.getAreDeclarationMapsEnabled = getAreDeclarationMapsEnabled;
      function getAllowSyntheticDefaultImports(compilerOptions) {
        var moduleKind = getEmitModuleKind(compilerOptions);
        return compilerOptions.allowSyntheticDefaultImports !== void 0 ? compilerOptions.allowSyntheticDefaultImports : compilerOptions.esModuleInterop || moduleKind === ts3.ModuleKind.System;
      }
      ts3.getAllowSyntheticDefaultImports = getAllowSyntheticDefaultImports;
      function getEmitDeclarations(compilerOptions) {
        return !!(compilerOptions.declaration || compilerOptions.composite);
      }
      ts3.getEmitDeclarations = getEmitDeclarations;
      function shouldPreserveConstEnums(compilerOptions) {
        return !!(compilerOptions.preserveConstEnums || compilerOptions.isolatedModules);
      }
      ts3.shouldPreserveConstEnums = shouldPreserveConstEnums;
      function isIncrementalCompilation(options) {
        return !!(options.incremental || options.composite);
      }
      ts3.isIncrementalCompilation = isIncrementalCompilation;
      function getStrictOptionValue(compilerOptions, flag) {
        return compilerOptions[flag] === void 0 ? !!compilerOptions.strict : !!compilerOptions[flag];
      }
      ts3.getStrictOptionValue = getStrictOptionValue;
      function getAllowJSCompilerOption(compilerOptions) {
        return compilerOptions.allowJs === void 0 ? !!compilerOptions.checkJs : compilerOptions.allowJs;
      }
      ts3.getAllowJSCompilerOption = getAllowJSCompilerOption;
      function getUseDefineForClassFields(compilerOptions) {
        return compilerOptions.useDefineForClassFields === void 0 ? compilerOptions.target === 99 : compilerOptions.useDefineForClassFields;
      }
      ts3.getUseDefineForClassFields = getUseDefineForClassFields;
      function compilerOptionsAffectSemanticDiagnostics(newOptions, oldOptions) {
        return oldOptions !== newOptions && ts3.semanticDiagnosticsOptionDeclarations.some(function(option) {
          return !isJsonEqual(getCompilerOptionValue(oldOptions, option), getCompilerOptionValue(newOptions, option));
        });
      }
      ts3.compilerOptionsAffectSemanticDiagnostics = compilerOptionsAffectSemanticDiagnostics;
      function compilerOptionsAffectEmit(newOptions, oldOptions) {
        return oldOptions !== newOptions && ts3.affectsEmitOptionDeclarations.some(function(option) {
          return !isJsonEqual(getCompilerOptionValue(oldOptions, option), getCompilerOptionValue(newOptions, option));
        });
      }
      ts3.compilerOptionsAffectEmit = compilerOptionsAffectEmit;
      function getCompilerOptionValue(options, option) {
        return option.strictFlag ? getStrictOptionValue(options, option.name) : options[option.name];
      }
      ts3.getCompilerOptionValue = getCompilerOptionValue;
      function getJSXTransformEnabled(options) {
        var jsx = options.jsx;
        return jsx === 2 || jsx === 4 || jsx === 5;
      }
      ts3.getJSXTransformEnabled = getJSXTransformEnabled;
      function getJSXImplicitImportBase(compilerOptions, file) {
        var jsxImportSourcePragmas = file === null || file === void 0 ? void 0 : file.pragmas.get("jsximportsource");
        var jsxImportSourcePragma = ts3.isArray(jsxImportSourcePragmas) ? jsxImportSourcePragmas[jsxImportSourcePragmas.length - 1] : jsxImportSourcePragmas;
        return compilerOptions.jsx === 4 || compilerOptions.jsx === 5 || compilerOptions.jsxImportSource || jsxImportSourcePragma ? (jsxImportSourcePragma === null || jsxImportSourcePragma === void 0 ? void 0 : jsxImportSourcePragma.arguments.factory) || compilerOptions.jsxImportSource || "react" : void 0;
      }
      ts3.getJSXImplicitImportBase = getJSXImplicitImportBase;
      function getJSXRuntimeImport(base, options) {
        return base ? base + "/" + (options.jsx === 5 ? "jsx-dev-runtime" : "jsx-runtime") : void 0;
      }
      ts3.getJSXRuntimeImport = getJSXRuntimeImport;
      function hasZeroOrOneAsteriskCharacter(str2) {
        var seenAsterisk = false;
        for (var i3 = 0; i3 < str2.length; i3++) {
          if (str2.charCodeAt(i3) === 42) {
            if (!seenAsterisk) {
              seenAsterisk = true;
            } else {
              return false;
            }
          }
        }
        return true;
      }
      ts3.hasZeroOrOneAsteriskCharacter = hasZeroOrOneAsteriskCharacter;
      function createSymlinkCache(cwd, getCanonicalFileName) {
        var symlinkedDirectories;
        var symlinkedDirectoriesByRealpath;
        var symlinkedFiles;
        return {
          getSymlinkedFiles: function() {
            return symlinkedFiles;
          },
          getSymlinkedDirectories: function() {
            return symlinkedDirectories;
          },
          getSymlinkedDirectoriesByRealpath: function() {
            return symlinkedDirectoriesByRealpath;
          },
          setSymlinkedFile: function(path2, real) {
            return (symlinkedFiles || (symlinkedFiles = new ts3.Map())).set(path2, real);
          },
          setSymlinkedDirectory: function(symlink, real) {
            var symlinkPath = ts3.toPath(symlink, cwd, getCanonicalFileName);
            if (!containsIgnoredPath(symlinkPath)) {
              symlinkPath = ts3.ensureTrailingDirectorySeparator(symlinkPath);
              if (real !== false && !(symlinkedDirectories === null || symlinkedDirectories === void 0 ? void 0 : symlinkedDirectories.has(symlinkPath))) {
                (symlinkedDirectoriesByRealpath || (symlinkedDirectoriesByRealpath = ts3.createMultiMap())).add(ts3.ensureTrailingDirectorySeparator(real.realPath), symlink);
              }
              (symlinkedDirectories || (symlinkedDirectories = new ts3.Map())).set(symlinkPath, real);
            }
          },
          setSymlinkedDirectoryFromSymlinkedFile: function(symlink, real) {
            this.setSymlinkedFile(ts3.toPath(symlink, cwd, getCanonicalFileName), real);
            var _a2 = guessDirectorySymlink(real, symlink, cwd, getCanonicalFileName) || ts3.emptyArray, commonResolved = _a2[0], commonOriginal = _a2[1];
            if (commonResolved && commonOriginal) {
              this.setSymlinkedDirectory(commonOriginal, {
                real: commonResolved,
                realPath: ts3.toPath(commonResolved, cwd, getCanonicalFileName)
              });
            }
          }
        };
      }
      ts3.createSymlinkCache = createSymlinkCache;
      function discoverProbableSymlinks(files, getCanonicalFileName, cwd) {
        var cache = createSymlinkCache(cwd, getCanonicalFileName);
        var symlinks = ts3.flatMap(files, function(sf) {
          var pairs2 = sf.resolvedModules && ts3.arrayFrom(ts3.mapDefinedIterator(sf.resolvedModules.values(), function(res) {
            return (res === null || res === void 0 ? void 0 : res.originalPath) ? [res.resolvedFileName, res.originalPath] : void 0;
          }));
          return ts3.concatenate(pairs2, sf.resolvedTypeReferenceDirectiveNames && ts3.arrayFrom(ts3.mapDefinedIterator(sf.resolvedTypeReferenceDirectiveNames.values(), function(res) {
            return (res === null || res === void 0 ? void 0 : res.originalPath) && res.resolvedFileName ? [res.resolvedFileName, res.originalPath] : void 0;
          })));
        });
        for (var _i = 0, symlinks_1 = symlinks; _i < symlinks_1.length; _i++) {
          var _a2 = symlinks_1[_i], resolvedPath = _a2[0], originalPath = _a2[1];
          cache.setSymlinkedFile(ts3.toPath(originalPath, cwd, getCanonicalFileName), resolvedPath);
          var _b = guessDirectorySymlink(resolvedPath, originalPath, cwd, getCanonicalFileName) || ts3.emptyArray, commonResolved = _b[0], commonOriginal = _b[1];
          if (commonResolved && commonOriginal) {
            cache.setSymlinkedDirectory(commonOriginal, { real: commonResolved, realPath: ts3.toPath(commonResolved, cwd, getCanonicalFileName) });
          }
        }
        return cache;
      }
      ts3.discoverProbableSymlinks = discoverProbableSymlinks;
      function guessDirectorySymlink(a2, b2, cwd, getCanonicalFileName) {
        var aParts = ts3.getPathComponents(ts3.getNormalizedAbsolutePath(a2, cwd));
        var bParts = ts3.getPathComponents(ts3.getNormalizedAbsolutePath(b2, cwd));
        var isDirectory = false;
        while (!isNodeModulesOrScopedPackageDirectory(aParts[aParts.length - 2], getCanonicalFileName) && !isNodeModulesOrScopedPackageDirectory(bParts[bParts.length - 2], getCanonicalFileName) && getCanonicalFileName(aParts[aParts.length - 1]) === getCanonicalFileName(bParts[bParts.length - 1])) {
          aParts.pop();
          bParts.pop();
          isDirectory = true;
        }
        return isDirectory ? [ts3.getPathFromPathComponents(aParts), ts3.getPathFromPathComponents(bParts)] : void 0;
      }
      function isNodeModulesOrScopedPackageDirectory(s2, getCanonicalFileName) {
        return getCanonicalFileName(s2) === "node_modules" || ts3.startsWith(s2, "@");
      }
      function stripLeadingDirectorySeparator(s2) {
        return ts3.isAnyDirectorySeparator(s2.charCodeAt(0)) ? s2.slice(1) : void 0;
      }
      function tryRemoveDirectoryPrefix(path2, dirPath, getCanonicalFileName) {
        var withoutPrefix = ts3.tryRemovePrefix(path2, dirPath, getCanonicalFileName);
        return withoutPrefix === void 0 ? void 0 : stripLeadingDirectorySeparator(withoutPrefix);
      }
      ts3.tryRemoveDirectoryPrefix = tryRemoveDirectoryPrefix;
      var reservedCharacterPattern = /[^\w\s\/]/g;
      function regExpEscape(text) {
        return text.replace(reservedCharacterPattern, escapeRegExpCharacter);
      }
      ts3.regExpEscape = regExpEscape;
      function escapeRegExpCharacter(match) {
        return "\\" + match;
      }
      var wildcardCharCodes = [42, 63];
      ts3.commonPackageFolders = ["node_modules", "bower_components", "jspm_packages"];
      var implicitExcludePathRegexPattern = "(?!(" + ts3.commonPackageFolders.join("|") + ")(/|$))";
      var filesMatcher = {
        singleAsteriskRegexFragment: "([^./]|(\\.(?!min\\.js$))?)*",
        doubleAsteriskRegexFragment: "(/" + implicitExcludePathRegexPattern + "[^/.][^/]*)*?",
        replaceWildcardCharacter: function(match) {
          return replaceWildcardCharacter(match, filesMatcher.singleAsteriskRegexFragment);
        }
      };
      var directoriesMatcher = {
        singleAsteriskRegexFragment: "[^/]*",
        doubleAsteriskRegexFragment: "(/" + implicitExcludePathRegexPattern + "[^/.][^/]*)*?",
        replaceWildcardCharacter: function(match) {
          return replaceWildcardCharacter(match, directoriesMatcher.singleAsteriskRegexFragment);
        }
      };
      var excludeMatcher = {
        singleAsteriskRegexFragment: "[^/]*",
        doubleAsteriskRegexFragment: "(/.+?)?",
        replaceWildcardCharacter: function(match) {
          return replaceWildcardCharacter(match, excludeMatcher.singleAsteriskRegexFragment);
        }
      };
      var wildcardMatchers = {
        files: filesMatcher,
        directories: directoriesMatcher,
        exclude: excludeMatcher
      };
      function getRegularExpressionForWildcard(specs, basePath, usage) {
        var patterns = getRegularExpressionsForWildcards(specs, basePath, usage);
        if (!patterns || !patterns.length) {
          return void 0;
        }
        var pattern = patterns.map(function(pattern2) {
          return "(" + pattern2 + ")";
        }).join("|");
        var terminator = usage === "exclude" ? "($|/)" : "$";
        return "^(" + pattern + ")" + terminator;
      }
      ts3.getRegularExpressionForWildcard = getRegularExpressionForWildcard;
      function getRegularExpressionsForWildcards(specs, basePath, usage) {
        if (specs === void 0 || specs.length === 0) {
          return void 0;
        }
        return ts3.flatMap(specs, function(spec) {
          return spec && getSubPatternFromSpec(spec, basePath, usage, wildcardMatchers[usage]);
        });
      }
      ts3.getRegularExpressionsForWildcards = getRegularExpressionsForWildcards;
      function isImplicitGlob(lastPathComponent) {
        return !/[.*?]/.test(lastPathComponent);
      }
      ts3.isImplicitGlob = isImplicitGlob;
      function getPatternFromSpec(spec, basePath, usage) {
        var pattern = spec && getSubPatternFromSpec(spec, basePath, usage, wildcardMatchers[usage]);
        return pattern && "^(" + pattern + ")" + (usage === "exclude" ? "($|/)" : "$");
      }
      ts3.getPatternFromSpec = getPatternFromSpec;
      function getSubPatternFromSpec(spec, basePath, usage, _a2) {
        var singleAsteriskRegexFragment = _a2.singleAsteriskRegexFragment, doubleAsteriskRegexFragment = _a2.doubleAsteriskRegexFragment, replaceWildcardCharacter2 = _a2.replaceWildcardCharacter;
        var subpattern = "";
        var hasWrittenComponent = false;
        var components = ts3.getNormalizedPathComponents(spec, basePath);
        var lastComponent = ts3.last(components);
        if (usage !== "exclude" && lastComponent === "**") {
          return void 0;
        }
        components[0] = ts3.removeTrailingDirectorySeparator(components[0]);
        if (isImplicitGlob(lastComponent)) {
          components.push("**", "*");
        }
        var optionalCount = 0;
        for (var _i = 0, components_1 = components; _i < components_1.length; _i++) {
          var component = components_1[_i];
          if (component === "**") {
            subpattern += doubleAsteriskRegexFragment;
          } else {
            if (usage === "directories") {
              subpattern += "(";
              optionalCount++;
            }
            if (hasWrittenComponent) {
              subpattern += ts3.directorySeparator;
            }
            if (usage !== "exclude") {
              var componentPattern = "";
              if (component.charCodeAt(0) === 42) {
                componentPattern += "([^./]" + singleAsteriskRegexFragment + ")?";
                component = component.substr(1);
              } else if (component.charCodeAt(0) === 63) {
                componentPattern += "[^./]";
                component = component.substr(1);
              }
              componentPattern += component.replace(reservedCharacterPattern, replaceWildcardCharacter2);
              if (componentPattern !== component) {
                subpattern += implicitExcludePathRegexPattern;
              }
              subpattern += componentPattern;
            } else {
              subpattern += component.replace(reservedCharacterPattern, replaceWildcardCharacter2);
            }
          }
          hasWrittenComponent = true;
        }
        while (optionalCount > 0) {
          subpattern += ")?";
          optionalCount--;
        }
        return subpattern;
      }
      function replaceWildcardCharacter(match, singleAsteriskRegexFragment) {
        return match === "*" ? singleAsteriskRegexFragment : match === "?" ? "[^/]" : "\\" + match;
      }
      function getFileMatcherPatterns(path2, excludes, includes, useCaseSensitiveFileNames, currentDirectory) {
        path2 = ts3.normalizePath(path2);
        currentDirectory = ts3.normalizePath(currentDirectory);
        var absolutePath = ts3.combinePaths(currentDirectory, path2);
        return {
          includeFilePatterns: ts3.map(getRegularExpressionsForWildcards(includes, absolutePath, "files"), function(pattern) {
            return "^" + pattern + "$";
          }),
          includeFilePattern: getRegularExpressionForWildcard(includes, absolutePath, "files"),
          includeDirectoryPattern: getRegularExpressionForWildcard(includes, absolutePath, "directories"),
          excludePattern: getRegularExpressionForWildcard(excludes, absolutePath, "exclude"),
          basePaths: getBasePaths(path2, includes, useCaseSensitiveFileNames)
        };
      }
      ts3.getFileMatcherPatterns = getFileMatcherPatterns;
      function getRegexFromPattern(pattern, useCaseSensitiveFileNames) {
        return new RegExp(pattern, useCaseSensitiveFileNames ? "" : "i");
      }
      ts3.getRegexFromPattern = getRegexFromPattern;
      function matchFiles(path2, extensions, excludes, includes, useCaseSensitiveFileNames, currentDirectory, depth, getFileSystemEntries, realpath) {
        path2 = ts3.normalizePath(path2);
        currentDirectory = ts3.normalizePath(currentDirectory);
        var patterns = getFileMatcherPatterns(path2, excludes, includes, useCaseSensitiveFileNames, currentDirectory);
        var includeFileRegexes = patterns.includeFilePatterns && patterns.includeFilePatterns.map(function(pattern) {
          return getRegexFromPattern(pattern, useCaseSensitiveFileNames);
        });
        var includeDirectoryRegex = patterns.includeDirectoryPattern && getRegexFromPattern(patterns.includeDirectoryPattern, useCaseSensitiveFileNames);
        var excludeRegex = patterns.excludePattern && getRegexFromPattern(patterns.excludePattern, useCaseSensitiveFileNames);
        var results = includeFileRegexes ? includeFileRegexes.map(function() {
          return [];
        }) : [[]];
        var visited = new ts3.Map();
        var toCanonical = ts3.createGetCanonicalFileName(useCaseSensitiveFileNames);
        for (var _i = 0, _a2 = patterns.basePaths; _i < _a2.length; _i++) {
          var basePath = _a2[_i];
          visitDirectory(basePath, ts3.combinePaths(currentDirectory, basePath), depth);
        }
        return ts3.flatten(results);
        function visitDirectory(path3, absolutePath, depth2) {
          var canonicalPath = toCanonical(realpath(absolutePath));
          if (visited.has(canonicalPath))
            return;
          visited.set(canonicalPath, true);
          var _a3 = getFileSystemEntries(path3), files = _a3.files, directories = _a3.directories;
          var _loop_1 = function(current2) {
            var name2 = ts3.combinePaths(path3, current2);
            var absoluteName2 = ts3.combinePaths(absolutePath, current2);
            if (extensions && !ts3.fileExtensionIsOneOf(name2, extensions))
              return "continue";
            if (excludeRegex && excludeRegex.test(absoluteName2))
              return "continue";
            if (!includeFileRegexes) {
              results[0].push(name2);
            } else {
              var includeIndex = ts3.findIndex(includeFileRegexes, function(re) {
                return re.test(absoluteName2);
              });
              if (includeIndex !== -1) {
                results[includeIndex].push(name2);
              }
            }
          };
          for (var _i2 = 0, _b = ts3.sort(files, ts3.compareStringsCaseSensitive); _i2 < _b.length; _i2++) {
            var current = _b[_i2];
            _loop_1(current);
          }
          if (depth2 !== void 0) {
            depth2--;
            if (depth2 === 0) {
              return;
            }
          }
          for (var _c = 0, _d = ts3.sort(directories, ts3.compareStringsCaseSensitive); _c < _d.length; _c++) {
            var current = _d[_c];
            var name = ts3.combinePaths(path3, current);
            var absoluteName = ts3.combinePaths(absolutePath, current);
            if ((!includeDirectoryRegex || includeDirectoryRegex.test(absoluteName)) && (!excludeRegex || !excludeRegex.test(absoluteName))) {
              visitDirectory(name, absoluteName, depth2);
            }
          }
        }
      }
      ts3.matchFiles = matchFiles;
      function getBasePaths(path2, includes, useCaseSensitiveFileNames) {
        var basePaths = [path2];
        if (includes) {
          var includeBasePaths = [];
          for (var _i = 0, includes_1 = includes; _i < includes_1.length; _i++) {
            var include = includes_1[_i];
            var absolute = ts3.isRootedDiskPath(include) ? include : ts3.normalizePath(ts3.combinePaths(path2, include));
            includeBasePaths.push(getIncludeBasePath(absolute));
          }
          includeBasePaths.sort(ts3.getStringComparer(!useCaseSensitiveFileNames));
          var _loop_2 = function(includeBasePath2) {
            if (ts3.every(basePaths, function(basePath) {
              return !ts3.containsPath(basePath, includeBasePath2, path2, !useCaseSensitiveFileNames);
            })) {
              basePaths.push(includeBasePath2);
            }
          };
          for (var _a2 = 0, includeBasePaths_1 = includeBasePaths; _a2 < includeBasePaths_1.length; _a2++) {
            var includeBasePath = includeBasePaths_1[_a2];
            _loop_2(includeBasePath);
          }
        }
        return basePaths;
      }
      function getIncludeBasePath(absolute) {
        var wildcardOffset = ts3.indexOfAnyCharCode(absolute, wildcardCharCodes);
        if (wildcardOffset < 0) {
          return !ts3.hasExtension(absolute) ? absolute : ts3.removeTrailingDirectorySeparator(ts3.getDirectoryPath(absolute));
        }
        return absolute.substring(0, absolute.lastIndexOf(ts3.directorySeparator, wildcardOffset));
      }
      function ensureScriptKind(fileName, scriptKind) {
        return scriptKind || getScriptKindFromFileName(fileName) || 3;
      }
      ts3.ensureScriptKind = ensureScriptKind;
      function getScriptKindFromFileName(fileName) {
        var ext = fileName.substr(fileName.lastIndexOf("."));
        switch (ext.toLowerCase()) {
          case ".js":
            return 1;
          case ".jsx":
            return 2;
          case ".ts":
            return 3;
          case ".tsx":
            return 4;
          case ".json":
            return 6;
          default:
            return 0;
        }
      }
      ts3.getScriptKindFromFileName = getScriptKindFromFileName;
      ts3.supportedTSExtensions = [".ts", ".tsx", ".d.ts"];
      ts3.supportedTSExtensionsWithJson = [".ts", ".tsx", ".d.ts", ".json"];
      ts3.supportedTSExtensionsForExtractExtension = [".d.ts", ".ts", ".tsx"];
      ts3.supportedJSExtensions = [".js", ".jsx"];
      ts3.supportedJSAndJsonExtensions = [".js", ".jsx", ".json"];
      var allSupportedExtensions = __spreadArray(__spreadArray([], ts3.supportedTSExtensions), ts3.supportedJSExtensions);
      var allSupportedExtensionsWithJson = __spreadArray(__spreadArray(__spreadArray([], ts3.supportedTSExtensions), ts3.supportedJSExtensions), [".json"]);
      function getSupportedExtensions(options, extraFileExtensions) {
        var needJsExtensions = options && getAllowJSCompilerOption(options);
        if (!extraFileExtensions || extraFileExtensions.length === 0) {
          return needJsExtensions ? allSupportedExtensions : ts3.supportedTSExtensions;
        }
        var extensions = __spreadArray(__spreadArray([], needJsExtensions ? allSupportedExtensions : ts3.supportedTSExtensions), ts3.mapDefined(extraFileExtensions, function(x) {
          return x.scriptKind === 7 || needJsExtensions && isJSLike(x.scriptKind) ? x.extension : void 0;
        }));
        return ts3.deduplicate(extensions, ts3.equateStringsCaseSensitive, ts3.compareStringsCaseSensitive);
      }
      ts3.getSupportedExtensions = getSupportedExtensions;
      function getSuppoertedExtensionsWithJsonIfResolveJsonModule(options, supportedExtensions) {
        if (!options || !options.resolveJsonModule) {
          return supportedExtensions;
        }
        if (supportedExtensions === allSupportedExtensions) {
          return allSupportedExtensionsWithJson;
        }
        if (supportedExtensions === ts3.supportedTSExtensions) {
          return ts3.supportedTSExtensionsWithJson;
        }
        return __spreadArray(__spreadArray([], supportedExtensions), [".json"]);
      }
      ts3.getSuppoertedExtensionsWithJsonIfResolveJsonModule = getSuppoertedExtensionsWithJsonIfResolveJsonModule;
      function isJSLike(scriptKind) {
        return scriptKind === 1 || scriptKind === 2;
      }
      function hasJSFileExtension(fileName) {
        return ts3.some(ts3.supportedJSExtensions, function(extension) {
          return ts3.fileExtensionIs(fileName, extension);
        });
      }
      ts3.hasJSFileExtension = hasJSFileExtension;
      function hasTSFileExtension(fileName) {
        return ts3.some(ts3.supportedTSExtensions, function(extension) {
          return ts3.fileExtensionIs(fileName, extension);
        });
      }
      ts3.hasTSFileExtension = hasTSFileExtension;
      function isSupportedSourceFileName(fileName, compilerOptions, extraFileExtensions) {
        if (!fileName) {
          return false;
        }
        var supportedExtensions = getSupportedExtensions(compilerOptions, extraFileExtensions);
        for (var _i = 0, _a2 = getSuppoertedExtensionsWithJsonIfResolveJsonModule(compilerOptions, supportedExtensions); _i < _a2.length; _i++) {
          var extension = _a2[_i];
          if (ts3.fileExtensionIs(fileName, extension)) {
            return true;
          }
        }
        return false;
      }
      ts3.isSupportedSourceFileName = isSupportedSourceFileName;
      function numberOfDirectorySeparators(str2) {
        var match = str2.match(/\//g);
        return match ? match.length : 0;
      }
      function compareNumberOfDirectorySeparators(path1, path2) {
        return ts3.compareValues(numberOfDirectorySeparators(path1), numberOfDirectorySeparators(path2));
      }
      ts3.compareNumberOfDirectorySeparators = compareNumberOfDirectorySeparators;
      var ExtensionPriority;
      (function(ExtensionPriority2) {
        ExtensionPriority2[ExtensionPriority2["TypeScriptFiles"] = 0] = "TypeScriptFiles";
        ExtensionPriority2[ExtensionPriority2["DeclarationAndJavaScriptFiles"] = 2] = "DeclarationAndJavaScriptFiles";
        ExtensionPriority2[ExtensionPriority2["Highest"] = 0] = "Highest";
        ExtensionPriority2[ExtensionPriority2["Lowest"] = 2] = "Lowest";
      })(ExtensionPriority = ts3.ExtensionPriority || (ts3.ExtensionPriority = {}));
      function getExtensionPriority(path2, supportedExtensions) {
        for (var i3 = supportedExtensions.length - 1; i3 >= 0; i3--) {
          if (ts3.fileExtensionIs(path2, supportedExtensions[i3])) {
            return adjustExtensionPriority(i3, supportedExtensions);
          }
        }
        return 0;
      }
      ts3.getExtensionPriority = getExtensionPriority;
      function adjustExtensionPriority(extensionPriority, supportedExtensions) {
        if (extensionPriority < 2) {
          return 0;
        } else if (extensionPriority < supportedExtensions.length) {
          return 2;
        } else {
          return supportedExtensions.length;
        }
      }
      ts3.adjustExtensionPriority = adjustExtensionPriority;
      function getNextLowestExtensionPriority(extensionPriority, supportedExtensions) {
        if (extensionPriority < 2) {
          return 2;
        } else {
          return supportedExtensions.length;
        }
      }
      ts3.getNextLowestExtensionPriority = getNextLowestExtensionPriority;
      var extensionsToRemove = [".d.ts", ".ts", ".js", ".tsx", ".jsx", ".json"];
      function removeFileExtension(path2) {
        for (var _i = 0, extensionsToRemove_1 = extensionsToRemove; _i < extensionsToRemove_1.length; _i++) {
          var ext = extensionsToRemove_1[_i];
          var extensionless = tryRemoveExtension(path2, ext);
          if (extensionless !== void 0) {
            return extensionless;
          }
        }
        return path2;
      }
      ts3.removeFileExtension = removeFileExtension;
      function tryRemoveExtension(path2, extension) {
        return ts3.fileExtensionIs(path2, extension) ? removeExtension(path2, extension) : void 0;
      }
      ts3.tryRemoveExtension = tryRemoveExtension;
      function removeExtension(path2, extension) {
        return path2.substring(0, path2.length - extension.length);
      }
      ts3.removeExtension = removeExtension;
      function changeExtension(path2, newExtension) {
        return ts3.changeAnyExtension(path2, newExtension, extensionsToRemove, false);
      }
      ts3.changeExtension = changeExtension;
      function tryParsePattern(pattern) {
        ts3.Debug.assert(hasZeroOrOneAsteriskCharacter(pattern));
        var indexOfStar = pattern.indexOf("*");
        return indexOfStar === -1 ? void 0 : {
          prefix: pattern.substr(0, indexOfStar),
          suffix: pattern.substr(indexOfStar + 1)
        };
      }
      ts3.tryParsePattern = tryParsePattern;
      function positionIsSynthesized(pos) {
        return !(pos >= 0);
      }
      ts3.positionIsSynthesized = positionIsSynthesized;
      function extensionIsTS(ext) {
        return ext === ".ts" || ext === ".tsx" || ext === ".d.ts";
      }
      ts3.extensionIsTS = extensionIsTS;
      function resolutionExtensionIsTSOrJson(ext) {
        return extensionIsTS(ext) || ext === ".json";
      }
      ts3.resolutionExtensionIsTSOrJson = resolutionExtensionIsTSOrJson;
      function extensionFromPath(path2) {
        var ext = tryGetExtensionFromPath(path2);
        return ext !== void 0 ? ext : ts3.Debug.fail("File " + path2 + " has unknown extension.");
      }
      ts3.extensionFromPath = extensionFromPath;
      function isAnySupportedFileExtension(path2) {
        return tryGetExtensionFromPath(path2) !== void 0;
      }
      ts3.isAnySupportedFileExtension = isAnySupportedFileExtension;
      function tryGetExtensionFromPath(path2) {
        return ts3.find(extensionsToRemove, function(e2) {
          return ts3.fileExtensionIs(path2, e2);
        });
      }
      ts3.tryGetExtensionFromPath = tryGetExtensionFromPath;
      function isCheckJsEnabledForFile(sourceFile, compilerOptions) {
        return sourceFile.checkJsDirective ? sourceFile.checkJsDirective.enabled : compilerOptions.checkJs;
      }
      ts3.isCheckJsEnabledForFile = isCheckJsEnabledForFile;
      ts3.emptyFileSystemEntries = {
        files: ts3.emptyArray,
        directories: ts3.emptyArray
      };
      function matchPatternOrExact(patternStrings, candidate) {
        var patterns = [];
        for (var _i = 0, patternStrings_1 = patternStrings; _i < patternStrings_1.length; _i++) {
          var patternString = patternStrings_1[_i];
          if (!hasZeroOrOneAsteriskCharacter(patternString))
            continue;
          var pattern = tryParsePattern(patternString);
          if (pattern) {
            patterns.push(pattern);
          } else if (patternString === candidate) {
            return patternString;
          }
        }
        return ts3.findBestPatternMatch(patterns, function(_) {
          return _;
        }, candidate);
      }
      ts3.matchPatternOrExact = matchPatternOrExact;
      function sliceAfter(arr, value) {
        var index = arr.indexOf(value);
        ts3.Debug.assert(index !== -1);
        return arr.slice(index);
      }
      ts3.sliceAfter = sliceAfter;
      function addRelatedInfo(diagnostic) {
        var _a2;
        var relatedInformation = [];
        for (var _i = 1; _i < arguments.length; _i++) {
          relatedInformation[_i - 1] = arguments[_i];
        }
        if (!relatedInformation.length) {
          return diagnostic;
        }
        if (!diagnostic.relatedInformation) {
          diagnostic.relatedInformation = [];
        }
        ts3.Debug.assert(diagnostic.relatedInformation !== ts3.emptyArray, "Diagnostic had empty array singleton for related info, but is still being constructed!");
        (_a2 = diagnostic.relatedInformation).push.apply(_a2, relatedInformation);
        return diagnostic;
      }
      ts3.addRelatedInfo = addRelatedInfo;
      function minAndMax(arr, getValue2) {
        ts3.Debug.assert(arr.length !== 0);
        var min = getValue2(arr[0]);
        var max = min;
        for (var i3 = 1; i3 < arr.length; i3++) {
          var value = getValue2(arr[i3]);
          if (value < min) {
            min = value;
          } else if (value > max) {
            max = value;
          }
        }
        return { min, max };
      }
      ts3.minAndMax = minAndMax;
      function rangeOfNode(node) {
        return { pos: getTokenPosOfNode(node), end: node.end };
      }
      ts3.rangeOfNode = rangeOfNode;
      function rangeOfTypeParameters(sourceFile, typeParameters) {
        var pos = typeParameters.pos - 1;
        var end = ts3.skipTrivia(sourceFile.text, typeParameters.end) + 1;
        return { pos, end };
      }
      ts3.rangeOfTypeParameters = rangeOfTypeParameters;
      function skipTypeChecking(sourceFile, options, host) {
        return options.skipLibCheck && sourceFile.isDeclarationFile || options.skipDefaultLibCheck && sourceFile.hasNoDefaultLib || host.isSourceOfProjectReferenceRedirect(sourceFile.fileName);
      }
      ts3.skipTypeChecking = skipTypeChecking;
      function isJsonEqual(a2, b2) {
        return a2 === b2 || typeof a2 === "object" && a2 !== null && typeof b2 === "object" && b2 !== null && ts3.equalOwnProperties(a2, b2, isJsonEqual);
      }
      ts3.isJsonEqual = isJsonEqual;
      function parsePseudoBigInt(stringValue) {
        var log2Base;
        switch (stringValue.charCodeAt(1)) {
          case 98:
          case 66:
            log2Base = 1;
            break;
          case 111:
          case 79:
            log2Base = 3;
            break;
          case 120:
          case 88:
            log2Base = 4;
            break;
          default:
            var nIndex = stringValue.length - 1;
            var nonZeroStart = 0;
            while (stringValue.charCodeAt(nonZeroStart) === 48) {
              nonZeroStart++;
            }
            return stringValue.slice(nonZeroStart, nIndex) || "0";
        }
        var startIndex = 2, endIndex = stringValue.length - 1;
        var bitsNeeded = (endIndex - startIndex) * log2Base;
        var segments = new Uint16Array((bitsNeeded >>> 4) + (bitsNeeded & 15 ? 1 : 0));
        for (var i3 = endIndex - 1, bitOffset = 0; i3 >= startIndex; i3--, bitOffset += log2Base) {
          var segment = bitOffset >>> 4;
          var digitChar = stringValue.charCodeAt(i3);
          var digit = digitChar <= 57 ? digitChar - 48 : 10 + digitChar - (digitChar <= 70 ? 65 : 97);
          var shiftedDigit = digit << (bitOffset & 15);
          segments[segment] |= shiftedDigit;
          var residual = shiftedDigit >>> 16;
          if (residual)
            segments[segment + 1] |= residual;
        }
        var base10Value = "";
        var firstNonzeroSegment = segments.length - 1;
        var segmentsRemaining = true;
        while (segmentsRemaining) {
          var mod10 = 0;
          segmentsRemaining = false;
          for (var segment = firstNonzeroSegment; segment >= 0; segment--) {
            var newSegment = mod10 << 16 | segments[segment];
            var segmentValue = newSegment / 10 | 0;
            segments[segment] = segmentValue;
            mod10 = newSegment - segmentValue * 10;
            if (segmentValue && !segmentsRemaining) {
              firstNonzeroSegment = segment;
              segmentsRemaining = true;
            }
          }
          base10Value = mod10 + base10Value;
        }
        return base10Value;
      }
      ts3.parsePseudoBigInt = parsePseudoBigInt;
      function pseudoBigIntToString(_a2) {
        var negative = _a2.negative, base10Value = _a2.base10Value;
        return (negative && base10Value !== "0" ? "-" : "") + base10Value;
      }
      ts3.pseudoBigIntToString = pseudoBigIntToString;
      function isValidTypeOnlyAliasUseSite(useSite) {
        return !!(useSite.flags & 8388608) || isPartOfTypeQuery(useSite) || isIdentifierInNonEmittingHeritageClause(useSite) || isPartOfPossiblyValidTypeOrAbstractComputedPropertyName(useSite) || !isExpressionNode(useSite);
      }
      ts3.isValidTypeOnlyAliasUseSite = isValidTypeOnlyAliasUseSite;
      function typeOnlyDeclarationIsExport(typeOnlyDeclaration) {
        return typeOnlyDeclaration.kind === 271;
      }
      ts3.typeOnlyDeclarationIsExport = typeOnlyDeclarationIsExport;
      function isPartOfPossiblyValidTypeOrAbstractComputedPropertyName(node) {
        while (node.kind === 78 || node.kind === 202) {
          node = node.parent;
        }
        if (node.kind !== 159) {
          return false;
        }
        if (hasSyntacticModifier(node.parent, 128)) {
          return true;
        }
        var containerKind = node.parent.parent.kind;
        return containerKind === 254 || containerKind === 178;
      }
      function isIdentifierInNonEmittingHeritageClause(node) {
        if (node.kind !== 78)
          return false;
        var heritageClause = ts3.findAncestor(node.parent, function(parent) {
          switch (parent.kind) {
            case 287:
              return true;
            case 202:
            case 224:
              return false;
            default:
              return "quit";
          }
        });
        return (heritageClause === null || heritageClause === void 0 ? void 0 : heritageClause.token) === 116 || (heritageClause === null || heritageClause === void 0 ? void 0 : heritageClause.parent.kind) === 254;
      }
      function isIdentifierTypeReference(node) {
        return ts3.isTypeReferenceNode(node) && ts3.isIdentifier(node.typeName);
      }
      ts3.isIdentifierTypeReference = isIdentifierTypeReference;
      function arrayIsHomogeneous(array, comparer) {
        if (comparer === void 0) {
          comparer = ts3.equateValues;
        }
        if (array.length < 2)
          return true;
        var first = array[0];
        for (var i3 = 1, length_1 = array.length; i3 < length_1; i3++) {
          var target = array[i3];
          if (!comparer(first, target))
            return false;
        }
        return true;
      }
      ts3.arrayIsHomogeneous = arrayIsHomogeneous;
      function setTextRangePos(range, pos) {
        range.pos = pos;
        return range;
      }
      ts3.setTextRangePos = setTextRangePos;
      function setTextRangeEnd(range, end) {
        range.end = end;
        return range;
      }
      ts3.setTextRangeEnd = setTextRangeEnd;
      function setTextRangePosEnd(range, pos, end) {
        return setTextRangeEnd(setTextRangePos(range, pos), end);
      }
      ts3.setTextRangePosEnd = setTextRangePosEnd;
      function setTextRangePosWidth(range, pos, width) {
        return setTextRangePosEnd(range, pos, pos + width);
      }
      ts3.setTextRangePosWidth = setTextRangePosWidth;
      function setNodeFlags(node, newFlags) {
        if (node) {
          node.flags = newFlags;
        }
        return node;
      }
      ts3.setNodeFlags = setNodeFlags;
      function setParent(child, parent) {
        if (child && parent) {
          child.parent = parent;
        }
        return child;
      }
      ts3.setParent = setParent;
      function setEachParent(children, parent) {
        if (children) {
          for (var _i = 0, children_1 = children; _i < children_1.length; _i++) {
            var child = children_1[_i];
            setParent(child, parent);
          }
        }
        return children;
      }
      ts3.setEachParent = setEachParent;
      function setParentRecursive(rootNode, incremental) {
        if (!rootNode)
          return rootNode;
        ts3.forEachChildRecursively(rootNode, ts3.isJSDocNode(rootNode) ? bindParentToChildIgnoringJSDoc : bindParentToChild);
        return rootNode;
        function bindParentToChildIgnoringJSDoc(child, parent) {
          if (incremental && child.parent === parent) {
            return "skip";
          }
          setParent(child, parent);
        }
        function bindJSDoc(child) {
          if (ts3.hasJSDocNodes(child)) {
            for (var _i = 0, _a2 = child.jsDoc; _i < _a2.length; _i++) {
              var doc = _a2[_i];
              bindParentToChildIgnoringJSDoc(doc, child);
              ts3.forEachChildRecursively(doc, bindParentToChildIgnoringJSDoc);
            }
          }
        }
        function bindParentToChild(child, parent) {
          return bindParentToChildIgnoringJSDoc(child, parent) || bindJSDoc(child);
        }
      }
      ts3.setParentRecursive = setParentRecursive;
      function isPackedElement(node) {
        return !ts3.isOmittedExpression(node);
      }
      function isPackedArrayLiteral(node) {
        return ts3.isArrayLiteralExpression(node) && ts3.every(node.elements, isPackedElement);
      }
      ts3.isPackedArrayLiteral = isPackedArrayLiteral;
      function expressionResultIsUnused(node) {
        ts3.Debug.assertIsDefined(node.parent);
        while (true) {
          var parent = node.parent;
          if (ts3.isParenthesizedExpression(parent)) {
            node = parent;
            continue;
          }
          if (ts3.isExpressionStatement(parent) || ts3.isVoidExpression(parent) || ts3.isForStatement(parent) && (parent.initializer === node || parent.incrementor === node)) {
            return true;
          }
          if (ts3.isCommaListExpression(parent)) {
            if (node !== ts3.last(parent.elements))
              return true;
            node = parent;
            continue;
          }
          if (ts3.isBinaryExpression(parent) && parent.operatorToken.kind === 27) {
            if (node === parent.left)
              return true;
            node = parent;
            continue;
          }
          return false;
        }
      }
      ts3.expressionResultIsUnused = expressionResultIsUnused;
      function containsIgnoredPath(path2) {
        return ts3.some(ts3.ignoredPaths, function(p) {
          return ts3.stringContains(path2, p);
        });
      }
      ts3.containsIgnoredPath = containsIgnoredPath;
      function getContainingNodeArray(node) {
        if (!node.parent)
          return void 0;
        switch (node.kind) {
          case 160:
            var parent_1 = node.parent;
            return parent_1.kind === 186 ? void 0 : parent_1.typeParameters;
          case 161:
            return node.parent.parameters;
          case 195:
            return node.parent.templateSpans;
          case 229:
            return node.parent.templateSpans;
          case 162:
            return node.parent.decorators;
          case 287:
            return node.parent.heritageClauses;
        }
        var parent = node.parent;
        if (ts3.isJSDocTag(node)) {
          return ts3.isJSDocTypeLiteral(node.parent) ? void 0 : node.parent.tags;
        }
        switch (parent.kind) {
          case 178:
          case 254:
            return ts3.isTypeElement(node) ? parent.members : void 0;
          case 183:
          case 184:
            return parent.types;
          case 180:
          case 200:
          case 341:
          case 265:
          case 269:
            return parent.elements;
          case 201:
          case 282:
            return parent.properties;
          case 204:
          case 205:
            return ts3.isTypeNode(node) ? parent.typeArguments : parent.expression === node ? void 0 : parent.arguments;
          case 274:
          case 278:
            return ts3.isJsxChild(node) ? parent.children : void 0;
          case 276:
          case 275:
            return ts3.isTypeNode(node) ? parent.typeArguments : void 0;
          case 231:
          case 285:
          case 286:
          case 258:
            return parent.statements;
          case 259:
            return parent.clauses;
          case 253:
          case 222:
            return ts3.isClassElement(node) ? parent.members : void 0;
          case 256:
            return ts3.isEnumMember(node) ? parent.members : void 0;
          case 298:
            return parent.statements;
        }
      }
      ts3.getContainingNodeArray = getContainingNodeArray;
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      function createBaseNodeFactory() {
        var NodeConstructor;
        var TokenConstructor;
        var IdentifierConstructor;
        var PrivateIdentifierConstructor;
        var SourceFileConstructor;
        return {
          createBaseSourceFileNode,
          createBaseIdentifierNode,
          createBasePrivateIdentifierNode,
          createBaseTokenNode,
          createBaseNode
        };
        function createBaseSourceFileNode(kind) {
          return new (SourceFileConstructor || (SourceFileConstructor = ts3.objectAllocator.getSourceFileConstructor()))(kind, -1, -1);
        }
        function createBaseIdentifierNode(kind) {
          return new (IdentifierConstructor || (IdentifierConstructor = ts3.objectAllocator.getIdentifierConstructor()))(kind, -1, -1);
        }
        function createBasePrivateIdentifierNode(kind) {
          return new (PrivateIdentifierConstructor || (PrivateIdentifierConstructor = ts3.objectAllocator.getPrivateIdentifierConstructor()))(kind, -1, -1);
        }
        function createBaseTokenNode(kind) {
          return new (TokenConstructor || (TokenConstructor = ts3.objectAllocator.getTokenConstructor()))(kind, -1, -1);
        }
        function createBaseNode(kind) {
          return new (NodeConstructor || (NodeConstructor = ts3.objectAllocator.getNodeConstructor()))(kind, -1, -1);
        }
      }
      ts3.createBaseNodeFactory = createBaseNodeFactory;
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      function createParenthesizerRules(factory) {
        var binaryLeftOperandParenthesizerCache;
        var binaryRightOperandParenthesizerCache;
        return {
          getParenthesizeLeftSideOfBinaryForOperator,
          getParenthesizeRightSideOfBinaryForOperator,
          parenthesizeLeftSideOfBinary,
          parenthesizeRightSideOfBinary,
          parenthesizeExpressionOfComputedPropertyName,
          parenthesizeConditionOfConditionalExpression,
          parenthesizeBranchOfConditionalExpression,
          parenthesizeExpressionOfExportDefault,
          parenthesizeExpressionOfNew,
          parenthesizeLeftSideOfAccess,
          parenthesizeOperandOfPostfixUnary,
          parenthesizeOperandOfPrefixUnary,
          parenthesizeExpressionsOfCommaDelimitedList,
          parenthesizeExpressionForDisallowedComma,
          parenthesizeExpressionOfExpressionStatement,
          parenthesizeConciseBodyOfArrowFunction,
          parenthesizeMemberOfConditionalType,
          parenthesizeMemberOfElementType,
          parenthesizeElementTypeOfArrayType,
          parenthesizeConstituentTypesOfUnionOrIntersectionType,
          parenthesizeTypeArguments
        };
        function getParenthesizeLeftSideOfBinaryForOperator(operatorKind) {
          binaryLeftOperandParenthesizerCache || (binaryLeftOperandParenthesizerCache = new ts3.Map());
          var parenthesizerRule = binaryLeftOperandParenthesizerCache.get(operatorKind);
          if (!parenthesizerRule) {
            parenthesizerRule = function(node) {
              return parenthesizeLeftSideOfBinary(operatorKind, node);
            };
            binaryLeftOperandParenthesizerCache.set(operatorKind, parenthesizerRule);
          }
          return parenthesizerRule;
        }
        function getParenthesizeRightSideOfBinaryForOperator(operatorKind) {
          binaryRightOperandParenthesizerCache || (binaryRightOperandParenthesizerCache = new ts3.Map());
          var parenthesizerRule = binaryRightOperandParenthesizerCache.get(operatorKind);
          if (!parenthesizerRule) {
            parenthesizerRule = function(node) {
              return parenthesizeRightSideOfBinary(operatorKind, void 0, node);
            };
            binaryRightOperandParenthesizerCache.set(operatorKind, parenthesizerRule);
          }
          return parenthesizerRule;
        }
        function binaryOperandNeedsParentheses(binaryOperator, operand, isLeftSideOfBinary, leftOperand) {
          var binaryOperatorPrecedence = ts3.getOperatorPrecedence(217, binaryOperator);
          var binaryOperatorAssociativity = ts3.getOperatorAssociativity(217, binaryOperator);
          var emittedOperand = ts3.skipPartiallyEmittedExpressions(operand);
          if (!isLeftSideOfBinary && operand.kind === 210 && binaryOperatorPrecedence > 3) {
            return true;
          }
          var operandPrecedence = ts3.getExpressionPrecedence(emittedOperand);
          switch (ts3.compareValues(operandPrecedence, binaryOperatorPrecedence)) {
            case -1:
              if (!isLeftSideOfBinary && binaryOperatorAssociativity === 1 && operand.kind === 220) {
                return false;
              }
              return true;
            case 1:
              return false;
            case 0:
              if (isLeftSideOfBinary) {
                return binaryOperatorAssociativity === 1;
              } else {
                if (ts3.isBinaryExpression(emittedOperand) && emittedOperand.operatorToken.kind === binaryOperator) {
                  if (operatorHasAssociativeProperty(binaryOperator)) {
                    return false;
                  }
                  if (binaryOperator === 39) {
                    var leftKind = leftOperand ? getLiteralKindOfBinaryPlusOperand(leftOperand) : 0;
                    if (ts3.isLiteralKind(leftKind) && leftKind === getLiteralKindOfBinaryPlusOperand(emittedOperand)) {
                      return false;
                    }
                  }
                }
                var operandAssociativity = ts3.getExpressionAssociativity(emittedOperand);
                return operandAssociativity === 0;
              }
          }
        }
        function operatorHasAssociativeProperty(binaryOperator) {
          return binaryOperator === 41 || binaryOperator === 51 || binaryOperator === 50 || binaryOperator === 52;
        }
        function getLiteralKindOfBinaryPlusOperand(node) {
          node = ts3.skipPartiallyEmittedExpressions(node);
          if (ts3.isLiteralKind(node.kind)) {
            return node.kind;
          }
          if (node.kind === 217 && node.operatorToken.kind === 39) {
            if (node.cachedLiteralKind !== void 0) {
              return node.cachedLiteralKind;
            }
            var leftKind = getLiteralKindOfBinaryPlusOperand(node.left);
            var literalKind = ts3.isLiteralKind(leftKind) && leftKind === getLiteralKindOfBinaryPlusOperand(node.right) ? leftKind : 0;
            node.cachedLiteralKind = literalKind;
            return literalKind;
          }
          return 0;
        }
        function parenthesizeBinaryOperand(binaryOperator, operand, isLeftSideOfBinary, leftOperand) {
          var skipped = ts3.skipPartiallyEmittedExpressions(operand);
          if (skipped.kind === 208) {
            return operand;
          }
          return binaryOperandNeedsParentheses(binaryOperator, operand, isLeftSideOfBinary, leftOperand) ? factory.createParenthesizedExpression(operand) : operand;
        }
        function parenthesizeLeftSideOfBinary(binaryOperator, leftSide) {
          return parenthesizeBinaryOperand(binaryOperator, leftSide, true);
        }
        function parenthesizeRightSideOfBinary(binaryOperator, leftSide, rightSide) {
          return parenthesizeBinaryOperand(binaryOperator, rightSide, false, leftSide);
        }
        function parenthesizeExpressionOfComputedPropertyName(expression) {
          return ts3.isCommaSequence(expression) ? factory.createParenthesizedExpression(expression) : expression;
        }
        function parenthesizeConditionOfConditionalExpression(condition) {
          var conditionalPrecedence = ts3.getOperatorPrecedence(218, 57);
          var emittedCondition = ts3.skipPartiallyEmittedExpressions(condition);
          var conditionPrecedence = ts3.getExpressionPrecedence(emittedCondition);
          if (ts3.compareValues(conditionPrecedence, conditionalPrecedence) !== 1) {
            return factory.createParenthesizedExpression(condition);
          }
          return condition;
        }
        function parenthesizeBranchOfConditionalExpression(branch) {
          var emittedExpression = ts3.skipPartiallyEmittedExpressions(branch);
          return ts3.isCommaSequence(emittedExpression) ? factory.createParenthesizedExpression(branch) : branch;
        }
        function parenthesizeExpressionOfExportDefault(expression) {
          var check = ts3.skipPartiallyEmittedExpressions(expression);
          var needsParens = ts3.isCommaSequence(check);
          if (!needsParens) {
            switch (ts3.getLeftmostExpression(check, false).kind) {
              case 222:
              case 209:
                needsParens = true;
            }
          }
          return needsParens ? factory.createParenthesizedExpression(expression) : expression;
        }
        function parenthesizeExpressionOfNew(expression) {
          var leftmostExpr = ts3.getLeftmostExpression(expression, true);
          switch (leftmostExpr.kind) {
            case 204:
              return factory.createParenthesizedExpression(expression);
            case 205:
              return !leftmostExpr.arguments ? factory.createParenthesizedExpression(expression) : expression;
          }
          return parenthesizeLeftSideOfAccess(expression);
        }
        function parenthesizeLeftSideOfAccess(expression) {
          var emittedExpression = ts3.skipPartiallyEmittedExpressions(expression);
          if (ts3.isLeftHandSideExpression(emittedExpression) && (emittedExpression.kind !== 205 || emittedExpression.arguments)) {
            return expression;
          }
          return ts3.setTextRange(factory.createParenthesizedExpression(expression), expression);
        }
        function parenthesizeOperandOfPostfixUnary(operand) {
          return ts3.isLeftHandSideExpression(operand) ? operand : ts3.setTextRange(factory.createParenthesizedExpression(operand), operand);
        }
        function parenthesizeOperandOfPrefixUnary(operand) {
          return ts3.isUnaryExpression(operand) ? operand : ts3.setTextRange(factory.createParenthesizedExpression(operand), operand);
        }
        function parenthesizeExpressionsOfCommaDelimitedList(elements) {
          var result2 = ts3.sameMap(elements, parenthesizeExpressionForDisallowedComma);
          return ts3.setTextRange(factory.createNodeArray(result2, elements.hasTrailingComma), elements);
        }
        function parenthesizeExpressionForDisallowedComma(expression) {
          var emittedExpression = ts3.skipPartiallyEmittedExpressions(expression);
          var expressionPrecedence = ts3.getExpressionPrecedence(emittedExpression);
          var commaPrecedence = ts3.getOperatorPrecedence(217, 27);
          return expressionPrecedence > commaPrecedence ? expression : ts3.setTextRange(factory.createParenthesizedExpression(expression), expression);
        }
        function parenthesizeExpressionOfExpressionStatement(expression) {
          var emittedExpression = ts3.skipPartiallyEmittedExpressions(expression);
          if (ts3.isCallExpression(emittedExpression)) {
            var callee = emittedExpression.expression;
            var kind = ts3.skipPartiallyEmittedExpressions(callee).kind;
            if (kind === 209 || kind === 210) {
              var updated = factory.updateCallExpression(emittedExpression, ts3.setTextRange(factory.createParenthesizedExpression(callee), callee), emittedExpression.typeArguments, emittedExpression.arguments);
              return factory.restoreOuterExpressions(expression, updated, 8);
            }
          }
          var leftmostExpressionKind = ts3.getLeftmostExpression(emittedExpression, false).kind;
          if (leftmostExpressionKind === 201 || leftmostExpressionKind === 209) {
            return ts3.setTextRange(factory.createParenthesizedExpression(expression), expression);
          }
          return expression;
        }
        function parenthesizeConciseBodyOfArrowFunction(body) {
          if (!ts3.isBlock(body) && (ts3.isCommaSequence(body) || ts3.getLeftmostExpression(body, false).kind === 201)) {
            return ts3.setTextRange(factory.createParenthesizedExpression(body), body);
          }
          return body;
        }
        function parenthesizeMemberOfConditionalType(member) {
          return member.kind === 185 ? factory.createParenthesizedType(member) : member;
        }
        function parenthesizeMemberOfElementType(member) {
          switch (member.kind) {
            case 183:
            case 184:
            case 175:
            case 176:
              return factory.createParenthesizedType(member);
          }
          return parenthesizeMemberOfConditionalType(member);
        }
        function parenthesizeElementTypeOfArrayType(member) {
          switch (member.kind) {
            case 177:
            case 189:
            case 186:
              return factory.createParenthesizedType(member);
          }
          return parenthesizeMemberOfElementType(member);
        }
        function parenthesizeConstituentTypesOfUnionOrIntersectionType(members) {
          return factory.createNodeArray(ts3.sameMap(members, parenthesizeMemberOfElementType));
        }
        function parenthesizeOrdinalTypeArgument(node, i3) {
          return i3 === 0 && ts3.isFunctionOrConstructorTypeNode(node) && node.typeParameters ? factory.createParenthesizedType(node) : node;
        }
        function parenthesizeTypeArguments(typeArguments) {
          if (ts3.some(typeArguments)) {
            return factory.createNodeArray(ts3.sameMap(typeArguments, parenthesizeOrdinalTypeArgument));
          }
        }
      }
      ts3.createParenthesizerRules = createParenthesizerRules;
      ts3.nullParenthesizerRules = {
        getParenthesizeLeftSideOfBinaryForOperator: function(_) {
          return ts3.identity;
        },
        getParenthesizeRightSideOfBinaryForOperator: function(_) {
          return ts3.identity;
        },
        parenthesizeLeftSideOfBinary: function(_binaryOperator, leftSide) {
          return leftSide;
        },
        parenthesizeRightSideOfBinary: function(_binaryOperator, _leftSide, rightSide) {
          return rightSide;
        },
        parenthesizeExpressionOfComputedPropertyName: ts3.identity,
        parenthesizeConditionOfConditionalExpression: ts3.identity,
        parenthesizeBranchOfConditionalExpression: ts3.identity,
        parenthesizeExpressionOfExportDefault: ts3.identity,
        parenthesizeExpressionOfNew: function(expression) {
          return ts3.cast(expression, ts3.isLeftHandSideExpression);
        },
        parenthesizeLeftSideOfAccess: function(expression) {
          return ts3.cast(expression, ts3.isLeftHandSideExpression);
        },
        parenthesizeOperandOfPostfixUnary: function(operand) {
          return ts3.cast(operand, ts3.isLeftHandSideExpression);
        },
        parenthesizeOperandOfPrefixUnary: function(operand) {
          return ts3.cast(operand, ts3.isUnaryExpression);
        },
        parenthesizeExpressionsOfCommaDelimitedList: function(nodes) {
          return ts3.cast(nodes, ts3.isNodeArray);
        },
        parenthesizeExpressionForDisallowedComma: ts3.identity,
        parenthesizeExpressionOfExpressionStatement: ts3.identity,
        parenthesizeConciseBodyOfArrowFunction: ts3.identity,
        parenthesizeMemberOfConditionalType: ts3.identity,
        parenthesizeMemberOfElementType: ts3.identity,
        parenthesizeElementTypeOfArrayType: ts3.identity,
        parenthesizeConstituentTypesOfUnionOrIntersectionType: function(nodes) {
          return ts3.cast(nodes, ts3.isNodeArray);
        },
        parenthesizeTypeArguments: function(nodes) {
          return nodes && ts3.cast(nodes, ts3.isNodeArray);
        }
      };
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      function createNodeConverters(factory) {
        return {
          convertToFunctionBlock,
          convertToFunctionExpression,
          convertToArrayAssignmentElement,
          convertToObjectAssignmentElement,
          convertToAssignmentPattern,
          convertToObjectAssignmentPattern,
          convertToArrayAssignmentPattern,
          convertToAssignmentElementTarget
        };
        function convertToFunctionBlock(node, multiLine) {
          if (ts3.isBlock(node))
            return node;
          var returnStatement = factory.createReturnStatement(node);
          ts3.setTextRange(returnStatement, node);
          var body = factory.createBlock([returnStatement], multiLine);
          ts3.setTextRange(body, node);
          return body;
        }
        function convertToFunctionExpression(node) {
          if (!node.body)
            return ts3.Debug.fail("Cannot convert a FunctionDeclaration without a body");
          var updated = factory.createFunctionExpression(node.modifiers, node.asteriskToken, node.name, node.typeParameters, node.parameters, node.type, node.body);
          ts3.setOriginalNode(updated, node);
          ts3.setTextRange(updated, node);
          if (ts3.getStartsOnNewLine(node)) {
            ts3.setStartsOnNewLine(updated, true);
          }
          return updated;
        }
        function convertToArrayAssignmentElement(element) {
          if (ts3.isBindingElement(element)) {
            if (element.dotDotDotToken) {
              ts3.Debug.assertNode(element.name, ts3.isIdentifier);
              return ts3.setOriginalNode(ts3.setTextRange(factory.createSpreadElement(element.name), element), element);
            }
            var expression = convertToAssignmentElementTarget(element.name);
            return element.initializer ? ts3.setOriginalNode(ts3.setTextRange(factory.createAssignment(expression, element.initializer), element), element) : expression;
          }
          return ts3.cast(element, ts3.isExpression);
        }
        function convertToObjectAssignmentElement(element) {
          if (ts3.isBindingElement(element)) {
            if (element.dotDotDotToken) {
              ts3.Debug.assertNode(element.name, ts3.isIdentifier);
              return ts3.setOriginalNode(ts3.setTextRange(factory.createSpreadAssignment(element.name), element), element);
            }
            if (element.propertyName) {
              var expression = convertToAssignmentElementTarget(element.name);
              return ts3.setOriginalNode(ts3.setTextRange(factory.createPropertyAssignment(element.propertyName, element.initializer ? factory.createAssignment(expression, element.initializer) : expression), element), element);
            }
            ts3.Debug.assertNode(element.name, ts3.isIdentifier);
            return ts3.setOriginalNode(ts3.setTextRange(factory.createShorthandPropertyAssignment(element.name, element.initializer), element), element);
          }
          return ts3.cast(element, ts3.isObjectLiteralElementLike);
        }
        function convertToAssignmentPattern(node) {
          switch (node.kind) {
            case 198:
            case 200:
              return convertToArrayAssignmentPattern(node);
            case 197:
            case 201:
              return convertToObjectAssignmentPattern(node);
          }
        }
        function convertToObjectAssignmentPattern(node) {
          if (ts3.isObjectBindingPattern(node)) {
            return ts3.setOriginalNode(ts3.setTextRange(factory.createObjectLiteralExpression(ts3.map(node.elements, convertToObjectAssignmentElement)), node), node);
          }
          return ts3.cast(node, ts3.isObjectLiteralExpression);
        }
        function convertToArrayAssignmentPattern(node) {
          if (ts3.isArrayBindingPattern(node)) {
            return ts3.setOriginalNode(ts3.setTextRange(factory.createArrayLiteralExpression(ts3.map(node.elements, convertToArrayAssignmentElement)), node), node);
          }
          return ts3.cast(node, ts3.isArrayLiteralExpression);
        }
        function convertToAssignmentElementTarget(node) {
          if (ts3.isBindingPattern(node)) {
            return convertToAssignmentPattern(node);
          }
          return ts3.cast(node, ts3.isExpression);
        }
      }
      ts3.createNodeConverters = createNodeConverters;
      ts3.nullNodeConverters = {
        convertToFunctionBlock: ts3.notImplemented,
        convertToFunctionExpression: ts3.notImplemented,
        convertToArrayAssignmentElement: ts3.notImplemented,
        convertToObjectAssignmentElement: ts3.notImplemented,
        convertToAssignmentPattern: ts3.notImplemented,
        convertToObjectAssignmentPattern: ts3.notImplemented,
        convertToArrayAssignmentPattern: ts3.notImplemented,
        convertToAssignmentElementTarget: ts3.notImplemented
      };
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var nextAutoGenerateId = 0;
      var NodeFactoryFlags;
      (function(NodeFactoryFlags2) {
        NodeFactoryFlags2[NodeFactoryFlags2["None"] = 0] = "None";
        NodeFactoryFlags2[NodeFactoryFlags2["NoParenthesizerRules"] = 1] = "NoParenthesizerRules";
        NodeFactoryFlags2[NodeFactoryFlags2["NoNodeConverters"] = 2] = "NoNodeConverters";
        NodeFactoryFlags2[NodeFactoryFlags2["NoIndentationOnFreshPropertyAccess"] = 4] = "NoIndentationOnFreshPropertyAccess";
        NodeFactoryFlags2[NodeFactoryFlags2["NoOriginalNode"] = 8] = "NoOriginalNode";
      })(NodeFactoryFlags = ts3.NodeFactoryFlags || (ts3.NodeFactoryFlags = {}));
      function createNodeFactory(flags, baseFactory2) {
        var update = flags & 8 ? updateWithoutOriginal : updateWithOriginal;
        var parenthesizerRules = ts3.memoize(function() {
          return flags & 1 ? ts3.nullParenthesizerRules : ts3.createParenthesizerRules(factory);
        });
        var converters = ts3.memoize(function() {
          return flags & 2 ? ts3.nullNodeConverters : ts3.createNodeConverters(factory);
        });
        var getBinaryCreateFunction = ts3.memoizeOne(function(operator) {
          return function(left, right) {
            return createBinaryExpression(left, operator, right);
          };
        });
        var getPrefixUnaryCreateFunction = ts3.memoizeOne(function(operator) {
          return function(operand) {
            return createPrefixUnaryExpression(operator, operand);
          };
        });
        var getPostfixUnaryCreateFunction = ts3.memoizeOne(function(operator) {
          return function(operand) {
            return createPostfixUnaryExpression(operand, operator);
          };
        });
        var getJSDocPrimaryTypeCreateFunction = ts3.memoizeOne(function(kind) {
          return function() {
            return createJSDocPrimaryTypeWorker(kind);
          };
        });
        var getJSDocUnaryTypeCreateFunction = ts3.memoizeOne(function(kind) {
          return function(type3) {
            return createJSDocUnaryTypeWorker(kind, type3);
          };
        });
        var getJSDocUnaryTypeUpdateFunction = ts3.memoizeOne(function(kind) {
          return function(node, type3) {
            return updateJSDocUnaryTypeWorker(kind, node, type3);
          };
        });
        var getJSDocSimpleTagCreateFunction = ts3.memoizeOne(function(kind) {
          return function(tagName, comment) {
            return createJSDocSimpleTagWorker(kind, tagName, comment);
          };
        });
        var getJSDocSimpleTagUpdateFunction = ts3.memoizeOne(function(kind) {
          return function(node, tagName, comment) {
            return updateJSDocSimpleTagWorker(kind, node, tagName, comment);
          };
        });
        var getJSDocTypeLikeTagCreateFunction = ts3.memoizeOne(function(kind) {
          return function(tagName, typeExpression, comment) {
            return createJSDocTypeLikeTagWorker(kind, tagName, typeExpression, comment);
          };
        });
        var getJSDocTypeLikeTagUpdateFunction = ts3.memoizeOne(function(kind) {
          return function(node, tagName, typeExpression, comment) {
            return updateJSDocTypeLikeTagWorker(kind, node, tagName, typeExpression, comment);
          };
        });
        var factory = {
          get parenthesizer() {
            return parenthesizerRules();
          },
          get converters() {
            return converters();
          },
          createNodeArray,
          createNumericLiteral,
          createBigIntLiteral,
          createStringLiteral,
          createStringLiteralFromNode,
          createRegularExpressionLiteral,
          createLiteralLikeNode,
          createIdentifier,
          updateIdentifier,
          createTempVariable,
          createLoopVariable,
          createUniqueName,
          getGeneratedNameForNode,
          createPrivateIdentifier,
          createToken,
          createSuper,
          createThis,
          createNull,
          createTrue,
          createFalse,
          createModifier,
          createModifiersFromModifierFlags,
          createQualifiedName,
          updateQualifiedName,
          createComputedPropertyName,
          updateComputedPropertyName,
          createTypeParameterDeclaration,
          updateTypeParameterDeclaration,
          createParameterDeclaration,
          updateParameterDeclaration,
          createDecorator,
          updateDecorator,
          createPropertySignature,
          updatePropertySignature,
          createPropertyDeclaration,
          updatePropertyDeclaration,
          createMethodSignature,
          updateMethodSignature,
          createMethodDeclaration,
          updateMethodDeclaration,
          createConstructorDeclaration,
          updateConstructorDeclaration,
          createGetAccessorDeclaration,
          updateGetAccessorDeclaration,
          createSetAccessorDeclaration,
          updateSetAccessorDeclaration,
          createCallSignature,
          updateCallSignature,
          createConstructSignature,
          updateConstructSignature,
          createIndexSignature,
          updateIndexSignature,
          createTemplateLiteralTypeSpan,
          updateTemplateLiteralTypeSpan,
          createKeywordTypeNode,
          createTypePredicateNode,
          updateTypePredicateNode,
          createTypeReferenceNode,
          updateTypeReferenceNode,
          createFunctionTypeNode,
          updateFunctionTypeNode,
          createConstructorTypeNode,
          updateConstructorTypeNode,
          createTypeQueryNode,
          updateTypeQueryNode,
          createTypeLiteralNode,
          updateTypeLiteralNode,
          createArrayTypeNode,
          updateArrayTypeNode,
          createTupleTypeNode,
          updateTupleTypeNode,
          createNamedTupleMember,
          updateNamedTupleMember,
          createOptionalTypeNode,
          updateOptionalTypeNode,
          createRestTypeNode,
          updateRestTypeNode,
          createUnionTypeNode,
          updateUnionTypeNode,
          createIntersectionTypeNode,
          updateIntersectionTypeNode,
          createConditionalTypeNode,
          updateConditionalTypeNode,
          createInferTypeNode,
          updateInferTypeNode,
          createImportTypeNode,
          updateImportTypeNode,
          createParenthesizedType,
          updateParenthesizedType,
          createThisTypeNode,
          createTypeOperatorNode,
          updateTypeOperatorNode,
          createIndexedAccessTypeNode,
          updateIndexedAccessTypeNode,
          createMappedTypeNode,
          updateMappedTypeNode,
          createLiteralTypeNode,
          updateLiteralTypeNode,
          createTemplateLiteralType,
          updateTemplateLiteralType,
          createObjectBindingPattern,
          updateObjectBindingPattern,
          createArrayBindingPattern,
          updateArrayBindingPattern,
          createBindingElement,
          updateBindingElement,
          createArrayLiteralExpression,
          updateArrayLiteralExpression,
          createObjectLiteralExpression,
          updateObjectLiteralExpression,
          createPropertyAccessExpression: flags & 4 ? function(expression, name) {
            return ts3.setEmitFlags(createPropertyAccessExpression(expression, name), 131072);
          } : createPropertyAccessExpression,
          updatePropertyAccessExpression,
          createPropertyAccessChain: flags & 4 ? function(expression, questionDotToken, name) {
            return ts3.setEmitFlags(createPropertyAccessChain(expression, questionDotToken, name), 131072);
          } : createPropertyAccessChain,
          updatePropertyAccessChain,
          createElementAccessExpression,
          updateElementAccessExpression,
          createElementAccessChain,
          updateElementAccessChain,
          createCallExpression,
          updateCallExpression,
          createCallChain,
          updateCallChain,
          createNewExpression,
          updateNewExpression,
          createTaggedTemplateExpression,
          updateTaggedTemplateExpression,
          createTypeAssertion,
          updateTypeAssertion,
          createParenthesizedExpression,
          updateParenthesizedExpression,
          createFunctionExpression,
          updateFunctionExpression,
          createArrowFunction,
          updateArrowFunction,
          createDeleteExpression,
          updateDeleteExpression,
          createTypeOfExpression,
          updateTypeOfExpression,
          createVoidExpression,
          updateVoidExpression,
          createAwaitExpression,
          updateAwaitExpression,
          createPrefixUnaryExpression,
          updatePrefixUnaryExpression,
          createPostfixUnaryExpression,
          updatePostfixUnaryExpression,
          createBinaryExpression,
          updateBinaryExpression,
          createConditionalExpression,
          updateConditionalExpression,
          createTemplateExpression,
          updateTemplateExpression,
          createTemplateHead,
          createTemplateMiddle,
          createTemplateTail,
          createNoSubstitutionTemplateLiteral,
          createTemplateLiteralLikeNode,
          createYieldExpression,
          updateYieldExpression,
          createSpreadElement,
          updateSpreadElement,
          createClassExpression,
          updateClassExpression,
          createOmittedExpression,
          createExpressionWithTypeArguments,
          updateExpressionWithTypeArguments,
          createAsExpression,
          updateAsExpression,
          createNonNullExpression,
          updateNonNullExpression,
          createNonNullChain,
          updateNonNullChain,
          createMetaProperty,
          updateMetaProperty,
          createTemplateSpan,
          updateTemplateSpan,
          createSemicolonClassElement,
          createBlock,
          updateBlock,
          createVariableStatement,
          updateVariableStatement,
          createEmptyStatement,
          createExpressionStatement,
          updateExpressionStatement,
          createIfStatement,
          updateIfStatement,
          createDoStatement,
          updateDoStatement,
          createWhileStatement,
          updateWhileStatement,
          createForStatement,
          updateForStatement,
          createForInStatement,
          updateForInStatement,
          createForOfStatement,
          updateForOfStatement,
          createContinueStatement,
          updateContinueStatement,
          createBreakStatement,
          updateBreakStatement,
          createReturnStatement,
          updateReturnStatement,
          createWithStatement,
          updateWithStatement,
          createSwitchStatement,
          updateSwitchStatement,
          createLabeledStatement,
          updateLabeledStatement,
          createThrowStatement,
          updateThrowStatement,
          createTryStatement,
          updateTryStatement,
          createDebuggerStatement,
          createVariableDeclaration,
          updateVariableDeclaration,
          createVariableDeclarationList,
          updateVariableDeclarationList,
          createFunctionDeclaration,
          updateFunctionDeclaration,
          createClassDeclaration,
          updateClassDeclaration,
          createInterfaceDeclaration,
          updateInterfaceDeclaration,
          createTypeAliasDeclaration,
          updateTypeAliasDeclaration,
          createEnumDeclaration,
          updateEnumDeclaration,
          createModuleDeclaration,
          updateModuleDeclaration,
          createModuleBlock,
          updateModuleBlock,
          createCaseBlock,
          updateCaseBlock,
          createNamespaceExportDeclaration,
          updateNamespaceExportDeclaration,
          createImportEqualsDeclaration,
          updateImportEqualsDeclaration,
          createImportDeclaration,
          updateImportDeclaration,
          createImportClause,
          updateImportClause,
          createNamespaceImport,
          updateNamespaceImport,
          createNamespaceExport,
          updateNamespaceExport,
          createNamedImports,
          updateNamedImports,
          createImportSpecifier,
          updateImportSpecifier,
          createExportAssignment,
          updateExportAssignment,
          createExportDeclaration,
          updateExportDeclaration,
          createNamedExports,
          updateNamedExports,
          createExportSpecifier,
          updateExportSpecifier,
          createMissingDeclaration,
          createExternalModuleReference,
          updateExternalModuleReference,
          get createJSDocAllType() {
            return getJSDocPrimaryTypeCreateFunction(304);
          },
          get createJSDocUnknownType() {
            return getJSDocPrimaryTypeCreateFunction(305);
          },
          get createJSDocNonNullableType() {
            return getJSDocUnaryTypeCreateFunction(307);
          },
          get updateJSDocNonNullableType() {
            return getJSDocUnaryTypeUpdateFunction(307);
          },
          get createJSDocNullableType() {
            return getJSDocUnaryTypeCreateFunction(306);
          },
          get updateJSDocNullableType() {
            return getJSDocUnaryTypeUpdateFunction(306);
          },
          get createJSDocOptionalType() {
            return getJSDocUnaryTypeCreateFunction(308);
          },
          get updateJSDocOptionalType() {
            return getJSDocUnaryTypeUpdateFunction(308);
          },
          get createJSDocVariadicType() {
            return getJSDocUnaryTypeCreateFunction(310);
          },
          get updateJSDocVariadicType() {
            return getJSDocUnaryTypeUpdateFunction(310);
          },
          get createJSDocNamepathType() {
            return getJSDocUnaryTypeCreateFunction(311);
          },
          get updateJSDocNamepathType() {
            return getJSDocUnaryTypeUpdateFunction(311);
          },
          createJSDocFunctionType,
          updateJSDocFunctionType,
          createJSDocTypeLiteral,
          updateJSDocTypeLiteral,
          createJSDocTypeExpression,
          updateJSDocTypeExpression,
          createJSDocSignature,
          updateJSDocSignature,
          createJSDocTemplateTag,
          updateJSDocTemplateTag,
          createJSDocTypedefTag,
          updateJSDocTypedefTag,
          createJSDocParameterTag,
          updateJSDocParameterTag,
          createJSDocPropertyTag,
          updateJSDocPropertyTag,
          createJSDocCallbackTag,
          updateJSDocCallbackTag,
          createJSDocAugmentsTag,
          updateJSDocAugmentsTag,
          createJSDocImplementsTag,
          updateJSDocImplementsTag,
          createJSDocSeeTag,
          updateJSDocSeeTag,
          createJSDocNameReference,
          updateJSDocNameReference,
          createJSDocLink,
          updateJSDocLink,
          get createJSDocTypeTag() {
            return getJSDocTypeLikeTagCreateFunction(333);
          },
          get updateJSDocTypeTag() {
            return getJSDocTypeLikeTagUpdateFunction(333);
          },
          get createJSDocReturnTag() {
            return getJSDocTypeLikeTagCreateFunction(331);
          },
          get updateJSDocReturnTag() {
            return getJSDocTypeLikeTagUpdateFunction(331);
          },
          get createJSDocThisTag() {
            return getJSDocTypeLikeTagCreateFunction(332);
          },
          get updateJSDocThisTag() {
            return getJSDocTypeLikeTagUpdateFunction(332);
          },
          get createJSDocEnumTag() {
            return getJSDocTypeLikeTagCreateFunction(329);
          },
          get updateJSDocEnumTag() {
            return getJSDocTypeLikeTagUpdateFunction(329);
          },
          get createJSDocAuthorTag() {
            return getJSDocSimpleTagCreateFunction(320);
          },
          get updateJSDocAuthorTag() {
            return getJSDocSimpleTagUpdateFunction(320);
          },
          get createJSDocClassTag() {
            return getJSDocSimpleTagCreateFunction(322);
          },
          get updateJSDocClassTag() {
            return getJSDocSimpleTagUpdateFunction(322);
          },
          get createJSDocPublicTag() {
            return getJSDocSimpleTagCreateFunction(323);
          },
          get updateJSDocPublicTag() {
            return getJSDocSimpleTagUpdateFunction(323);
          },
          get createJSDocPrivateTag() {
            return getJSDocSimpleTagCreateFunction(324);
          },
          get updateJSDocPrivateTag() {
            return getJSDocSimpleTagUpdateFunction(324);
          },
          get createJSDocProtectedTag() {
            return getJSDocSimpleTagCreateFunction(325);
          },
          get updateJSDocProtectedTag() {
            return getJSDocSimpleTagUpdateFunction(325);
          },
          get createJSDocReadonlyTag() {
            return getJSDocSimpleTagCreateFunction(326);
          },
          get updateJSDocReadonlyTag() {
            return getJSDocSimpleTagUpdateFunction(326);
          },
          get createJSDocOverrideTag() {
            return getJSDocSimpleTagCreateFunction(327);
          },
          get updateJSDocOverrideTag() {
            return getJSDocSimpleTagUpdateFunction(327);
          },
          get createJSDocDeprecatedTag() {
            return getJSDocSimpleTagCreateFunction(321);
          },
          get updateJSDocDeprecatedTag() {
            return getJSDocSimpleTagUpdateFunction(321);
          },
          createJSDocUnknownTag,
          updateJSDocUnknownTag,
          createJSDocText,
          updateJSDocText,
          createJSDocComment,
          updateJSDocComment,
          createJsxElement,
          updateJsxElement,
          createJsxSelfClosingElement,
          updateJsxSelfClosingElement,
          createJsxOpeningElement,
          updateJsxOpeningElement,
          createJsxClosingElement,
          updateJsxClosingElement,
          createJsxFragment,
          createJsxText,
          updateJsxText,
          createJsxOpeningFragment,
          createJsxJsxClosingFragment,
          updateJsxFragment,
          createJsxAttribute,
          updateJsxAttribute,
          createJsxAttributes,
          updateJsxAttributes,
          createJsxSpreadAttribute,
          updateJsxSpreadAttribute,
          createJsxExpression,
          updateJsxExpression,
          createCaseClause,
          updateCaseClause,
          createDefaultClause,
          updateDefaultClause,
          createHeritageClause,
          updateHeritageClause,
          createCatchClause,
          updateCatchClause,
          createPropertyAssignment,
          updatePropertyAssignment,
          createShorthandPropertyAssignment,
          updateShorthandPropertyAssignment,
          createSpreadAssignment,
          updateSpreadAssignment,
          createEnumMember,
          updateEnumMember,
          createSourceFile,
          updateSourceFile,
          createBundle,
          updateBundle,
          createUnparsedSource,
          createUnparsedPrologue,
          createUnparsedPrepend,
          createUnparsedTextLike,
          createUnparsedSyntheticReference,
          createInputFiles: createInputFiles2,
          createSyntheticExpression,
          createSyntaxList,
          createNotEmittedStatement,
          createPartiallyEmittedExpression,
          updatePartiallyEmittedExpression,
          createCommaListExpression,
          updateCommaListExpression,
          createEndOfDeclarationMarker,
          createMergeDeclarationMarker,
          createSyntheticReferenceExpression,
          updateSyntheticReferenceExpression,
          cloneNode,
          get createComma() {
            return getBinaryCreateFunction(27);
          },
          get createAssignment() {
            return getBinaryCreateFunction(62);
          },
          get createLogicalOr() {
            return getBinaryCreateFunction(56);
          },
          get createLogicalAnd() {
            return getBinaryCreateFunction(55);
          },
          get createBitwiseOr() {
            return getBinaryCreateFunction(51);
          },
          get createBitwiseXor() {
            return getBinaryCreateFunction(52);
          },
          get createBitwiseAnd() {
            return getBinaryCreateFunction(50);
          },
          get createStrictEquality() {
            return getBinaryCreateFunction(36);
          },
          get createStrictInequality() {
            return getBinaryCreateFunction(37);
          },
          get createEquality() {
            return getBinaryCreateFunction(34);
          },
          get createInequality() {
            return getBinaryCreateFunction(35);
          },
          get createLessThan() {
            return getBinaryCreateFunction(29);
          },
          get createLessThanEquals() {
            return getBinaryCreateFunction(32);
          },
          get createGreaterThan() {
            return getBinaryCreateFunction(31);
          },
          get createGreaterThanEquals() {
            return getBinaryCreateFunction(33);
          },
          get createLeftShift() {
            return getBinaryCreateFunction(47);
          },
          get createRightShift() {
            return getBinaryCreateFunction(48);
          },
          get createUnsignedRightShift() {
            return getBinaryCreateFunction(49);
          },
          get createAdd() {
            return getBinaryCreateFunction(39);
          },
          get createSubtract() {
            return getBinaryCreateFunction(40);
          },
          get createMultiply() {
            return getBinaryCreateFunction(41);
          },
          get createDivide() {
            return getBinaryCreateFunction(43);
          },
          get createModulo() {
            return getBinaryCreateFunction(44);
          },
          get createExponent() {
            return getBinaryCreateFunction(42);
          },
          get createPrefixPlus() {
            return getPrefixUnaryCreateFunction(39);
          },
          get createPrefixMinus() {
            return getPrefixUnaryCreateFunction(40);
          },
          get createPrefixIncrement() {
            return getPrefixUnaryCreateFunction(45);
          },
          get createPrefixDecrement() {
            return getPrefixUnaryCreateFunction(46);
          },
          get createBitwiseNot() {
            return getPrefixUnaryCreateFunction(54);
          },
          get createLogicalNot() {
            return getPrefixUnaryCreateFunction(53);
          },
          get createPostfixIncrement() {
            return getPostfixUnaryCreateFunction(45);
          },
          get createPostfixDecrement() {
            return getPostfixUnaryCreateFunction(46);
          },
          createImmediatelyInvokedFunctionExpression,
          createImmediatelyInvokedArrowFunction,
          createVoidZero,
          createExportDefault,
          createExternalModuleExport,
          createTypeCheck,
          createMethodCall,
          createGlobalMethodCall,
          createFunctionBindCall,
          createFunctionCallCall,
          createFunctionApplyCall,
          createArraySliceCall,
          createArrayConcatCall,
          createObjectDefinePropertyCall,
          createPropertyDescriptor,
          createCallBinding,
          inlineExpressions,
          getInternalName,
          getLocalName,
          getExportName,
          getDeclarationName,
          getNamespaceMemberName,
          getExternalModuleOrNamespaceExportName,
          restoreOuterExpressions,
          restoreEnclosingLabel,
          createUseStrictPrologue,
          copyPrologue,
          copyStandardPrologue,
          copyCustomPrologue,
          ensureUseStrict,
          liftToBlock,
          mergeLexicalEnvironment,
          updateModifiers
        };
        return factory;
        function createNodeArray(elements, hasTrailingComma) {
          if (elements === void 0 || elements === ts3.emptyArray) {
            elements = [];
          } else if (ts3.isNodeArray(elements)) {
            if (elements.transformFlags === void 0) {
              aggregateChildrenFlags(elements);
            }
            ts3.Debug.attachNodeArrayDebugInfo(elements);
            return elements;
          }
          var length = elements.length;
          var array = length >= 1 && length <= 4 ? elements.slice() : elements;
          ts3.setTextRangePosEnd(array, -1, -1);
          array.hasTrailingComma = !!hasTrailingComma;
          aggregateChildrenFlags(array);
          ts3.Debug.attachNodeArrayDebugInfo(array);
          return array;
        }
        function createBaseNode(kind) {
          return baseFactory2.createBaseNode(kind);
        }
        function createBaseDeclaration(kind, decorators, modifiers) {
          var node = createBaseNode(kind);
          node.decorators = asNodeArray(decorators);
          node.modifiers = asNodeArray(modifiers);
          node.transformFlags |= propagateChildrenFlags(node.decorators) | propagateChildrenFlags(node.modifiers);
          node.symbol = void 0;
          node.localSymbol = void 0;
          node.locals = void 0;
          node.nextContainer = void 0;
          return node;
        }
        function createBaseNamedDeclaration(kind, decorators, modifiers, name) {
          var node = createBaseDeclaration(kind, decorators, modifiers);
          name = asName(name);
          node.name = name;
          if (name) {
            switch (node.kind) {
              case 166:
              case 168:
              case 169:
              case 164:
              case 289:
                if (ts3.isIdentifier(name)) {
                  node.transformFlags |= propagateIdentifierNameFlags(name);
                  break;
                }
              default:
                node.transformFlags |= propagateChildFlags(name);
                break;
            }
          }
          return node;
        }
        function createBaseGenericNamedDeclaration(kind, decorators, modifiers, name, typeParameters) {
          var node = createBaseNamedDeclaration(kind, decorators, modifiers, name);
          node.typeParameters = asNodeArray(typeParameters);
          node.transformFlags |= propagateChildrenFlags(node.typeParameters);
          if (typeParameters)
            node.transformFlags |= 1;
          return node;
        }
        function createBaseSignatureDeclaration(kind, decorators, modifiers, name, typeParameters, parameters, type3) {
          var node = createBaseGenericNamedDeclaration(kind, decorators, modifiers, name, typeParameters);
          node.parameters = createNodeArray(parameters);
          node.type = type3;
          node.transformFlags |= propagateChildrenFlags(node.parameters) | propagateChildFlags(node.type);
          if (type3)
            node.transformFlags |= 1;
          return node;
        }
        function updateBaseSignatureDeclaration(updated, original) {
          if (original.typeArguments)
            updated.typeArguments = original.typeArguments;
          return update(updated, original);
        }
        function createBaseFunctionLikeDeclaration(kind, decorators, modifiers, name, typeParameters, parameters, type3, body) {
          var node = createBaseSignatureDeclaration(kind, decorators, modifiers, name, typeParameters, parameters, type3);
          node.body = body;
          node.transformFlags |= propagateChildFlags(node.body) & ~16777216;
          if (!body)
            node.transformFlags |= 1;
          return node;
        }
        function updateBaseFunctionLikeDeclaration(updated, original) {
          if (original.exclamationToken)
            updated.exclamationToken = original.exclamationToken;
          if (original.typeArguments)
            updated.typeArguments = original.typeArguments;
          return updateBaseSignatureDeclaration(updated, original);
        }
        function createBaseInterfaceOrClassLikeDeclaration(kind, decorators, modifiers, name, typeParameters, heritageClauses) {
          var node = createBaseGenericNamedDeclaration(kind, decorators, modifiers, name, typeParameters);
          node.heritageClauses = asNodeArray(heritageClauses);
          node.transformFlags |= propagateChildrenFlags(node.heritageClauses);
          return node;
        }
        function createBaseClassLikeDeclaration(kind, decorators, modifiers, name, typeParameters, heritageClauses, members) {
          var node = createBaseInterfaceOrClassLikeDeclaration(kind, decorators, modifiers, name, typeParameters, heritageClauses);
          node.members = createNodeArray(members);
          node.transformFlags |= propagateChildrenFlags(node.members);
          return node;
        }
        function createBaseBindingLikeDeclaration(kind, decorators, modifiers, name, initializer) {
          var node = createBaseNamedDeclaration(kind, decorators, modifiers, name);
          node.initializer = initializer;
          node.transformFlags |= propagateChildFlags(node.initializer);
          return node;
        }
        function createBaseVariableLikeDeclaration(kind, decorators, modifiers, name, type3, initializer) {
          var node = createBaseBindingLikeDeclaration(kind, decorators, modifiers, name, initializer);
          node.type = type3;
          node.transformFlags |= propagateChildFlags(type3);
          if (type3)
            node.transformFlags |= 1;
          return node;
        }
        function createBaseLiteral(kind, text) {
          var node = createBaseToken(kind);
          node.text = text;
          return node;
        }
        function createNumericLiteral(value, numericLiteralFlags) {
          if (numericLiteralFlags === void 0) {
            numericLiteralFlags = 0;
          }
          var node = createBaseLiteral(8, typeof value === "number" ? value + "" : value);
          node.numericLiteralFlags = numericLiteralFlags;
          if (numericLiteralFlags & 384)
            node.transformFlags |= 512;
          return node;
        }
        function createBigIntLiteral(value) {
          var node = createBaseLiteral(9, typeof value === "string" ? value : ts3.pseudoBigIntToString(value) + "n");
          node.transformFlags |= 4;
          return node;
        }
        function createBaseStringLiteral(text, isSingleQuote) {
          var node = createBaseLiteral(10, text);
          node.singleQuote = isSingleQuote;
          return node;
        }
        function createStringLiteral(text, isSingleQuote, hasExtendedUnicodeEscape) {
          var node = createBaseStringLiteral(text, isSingleQuote);
          node.hasExtendedUnicodeEscape = hasExtendedUnicodeEscape;
          if (hasExtendedUnicodeEscape)
            node.transformFlags |= 512;
          return node;
        }
        function createStringLiteralFromNode(sourceNode) {
          var node = createBaseStringLiteral(ts3.getTextOfIdentifierOrLiteral(sourceNode), void 0);
          node.textSourceNode = sourceNode;
          return node;
        }
        function createRegularExpressionLiteral(text) {
          var node = createBaseLiteral(13, text);
          return node;
        }
        function createLiteralLikeNode(kind, text) {
          switch (kind) {
            case 8:
              return createNumericLiteral(text, 0);
            case 9:
              return createBigIntLiteral(text);
            case 10:
              return createStringLiteral(text, void 0);
            case 11:
              return createJsxText(text, false);
            case 12:
              return createJsxText(text, true);
            case 13:
              return createRegularExpressionLiteral(text);
            case 14:
              return createTemplateLiteralLikeNode(kind, text, void 0, 0);
          }
        }
        function createBaseIdentifier(text, originalKeywordKind) {
          if (originalKeywordKind === void 0 && text) {
            originalKeywordKind = ts3.stringToToken(text);
          }
          if (originalKeywordKind === 78) {
            originalKeywordKind = void 0;
          }
          var node = baseFactory2.createBaseIdentifierNode(78);
          node.originalKeywordKind = originalKeywordKind;
          node.escapedText = ts3.escapeLeadingUnderscores(text);
          return node;
        }
        function createBaseGeneratedIdentifier(text, autoGenerateFlags) {
          var node = createBaseIdentifier(text, void 0);
          node.autoGenerateFlags = autoGenerateFlags;
          node.autoGenerateId = nextAutoGenerateId;
          nextAutoGenerateId++;
          return node;
        }
        function createIdentifier(text, typeArguments, originalKeywordKind) {
          var node = createBaseIdentifier(text, originalKeywordKind);
          if (typeArguments) {
            node.typeArguments = createNodeArray(typeArguments);
          }
          if (node.originalKeywordKind === 130) {
            node.transformFlags |= 16777216;
          }
          return node;
        }
        function updateIdentifier(node, typeArguments) {
          return node.typeArguments !== typeArguments ? update(createIdentifier(ts3.idText(node), typeArguments), node) : node;
        }
        function createTempVariable(recordTempVariable, reservedInNestedScopes) {
          var flags2 = 1;
          if (reservedInNestedScopes)
            flags2 |= 8;
          var name = createBaseGeneratedIdentifier("", flags2);
          if (recordTempVariable) {
            recordTempVariable(name);
          }
          return name;
        }
        function createLoopVariable(reservedInNestedScopes) {
          var flags2 = 2;
          if (reservedInNestedScopes)
            flags2 |= 8;
          return createBaseGeneratedIdentifier("", flags2);
        }
        function createUniqueName(text, flags2) {
          if (flags2 === void 0) {
            flags2 = 0;
          }
          ts3.Debug.assert(!(flags2 & 7), "Argument out of range: flags");
          ts3.Debug.assert((flags2 & (16 | 32)) !== 32, "GeneratedIdentifierFlags.FileLevel cannot be set without also setting GeneratedIdentifierFlags.Optimistic");
          return createBaseGeneratedIdentifier(text, 3 | flags2);
        }
        function getGeneratedNameForNode(node, flags2) {
          if (flags2 === void 0) {
            flags2 = 0;
          }
          ts3.Debug.assert(!(flags2 & 7), "Argument out of range: flags");
          var name = createBaseGeneratedIdentifier(node && ts3.isIdentifier(node) ? ts3.idText(node) : "", 4 | flags2);
          name.original = node;
          return name;
        }
        function createPrivateIdentifier(text) {
          if (!ts3.startsWith(text, "#"))
            ts3.Debug.fail("First character of private identifier must be #: " + text);
          var node = baseFactory2.createBasePrivateIdentifierNode(79);
          node.escapedText = ts3.escapeLeadingUnderscores(text);
          node.transformFlags |= 8388608;
          return node;
        }
        function createBaseToken(kind) {
          return baseFactory2.createBaseTokenNode(kind);
        }
        function createToken(token) {
          ts3.Debug.assert(token >= 0 && token <= 157, "Invalid token");
          ts3.Debug.assert(token <= 14 || token >= 17, "Invalid token. Use 'createTemplateLiteralLikeNode' to create template literals.");
          ts3.Debug.assert(token <= 8 || token >= 14, "Invalid token. Use 'createLiteralLikeNode' to create literals.");
          ts3.Debug.assert(token !== 78, "Invalid token. Use 'createIdentifier' to create identifiers");
          var node = createBaseToken(token);
          var transformFlags = 0;
          switch (token) {
            case 129:
              transformFlags = 128 | 64;
              break;
            case 122:
            case 120:
            case 121:
            case 142:
            case 125:
            case 133:
            case 84:
            case 128:
            case 144:
            case 155:
            case 141:
            case 145:
            case 156:
            case 147:
            case 131:
            case 148:
            case 113:
            case 152:
            case 150:
              transformFlags = 1;
              break;
            case 123:
            case 105:
              transformFlags = 512;
              break;
            case 107:
              transformFlags = 8192;
              break;
          }
          if (transformFlags) {
            node.transformFlags |= transformFlags;
          }
          return node;
        }
        function createSuper() {
          return createToken(105);
        }
        function createThis() {
          return createToken(107);
        }
        function createNull() {
          return createToken(103);
        }
        function createTrue() {
          return createToken(109);
        }
        function createFalse() {
          return createToken(94);
        }
        function createModifier(kind) {
          return createToken(kind);
        }
        function createModifiersFromModifierFlags(flags2) {
          var result2 = [];
          if (flags2 & 1) {
            result2.push(createModifier(92));
          }
          if (flags2 & 2) {
            result2.push(createModifier(133));
          }
          if (flags2 & 512) {
            result2.push(createModifier(87));
          }
          if (flags2 & 2048) {
            result2.push(createModifier(84));
          }
          if (flags2 & 4) {
            result2.push(createModifier(122));
          }
          if (flags2 & 8) {
            result2.push(createModifier(120));
          }
          if (flags2 & 16) {
            result2.push(createModifier(121));
          }
          if (flags2 & 128) {
            result2.push(createModifier(125));
          }
          if (flags2 & 32) {
            result2.push(createModifier(123));
          }
          if (flags2 & 16384) {
            result2.push(createModifier(156));
          }
          if (flags2 & 64) {
            result2.push(createModifier(142));
          }
          if (flags2 & 256) {
            result2.push(createModifier(129));
          }
          return result2;
        }
        function createQualifiedName(left, right) {
          var node = createBaseNode(158);
          node.left = left;
          node.right = asName(right);
          node.transformFlags |= propagateChildFlags(node.left) | propagateIdentifierNameFlags(node.right);
          return node;
        }
        function updateQualifiedName(node, left, right) {
          return node.left !== left || node.right !== right ? update(createQualifiedName(left, right), node) : node;
        }
        function createComputedPropertyName(expression) {
          var node = createBaseNode(159);
          node.expression = parenthesizerRules().parenthesizeExpressionOfComputedPropertyName(expression);
          node.transformFlags |= propagateChildFlags(node.expression) | 512 | 65536;
          return node;
        }
        function updateComputedPropertyName(node, expression) {
          return node.expression !== expression ? update(createComputedPropertyName(expression), node) : node;
        }
        function createTypeParameterDeclaration(name, constraint, defaultType) {
          var node = createBaseNamedDeclaration(160, void 0, void 0, name);
          node.constraint = constraint;
          node.default = defaultType;
          node.transformFlags = 1;
          return node;
        }
        function updateTypeParameterDeclaration(node, name, constraint, defaultType) {
          return node.name !== name || node.constraint !== constraint || node.default !== defaultType ? update(createTypeParameterDeclaration(name, constraint, defaultType), node) : node;
        }
        function createParameterDeclaration(decorators, modifiers, dotDotDotToken, name, questionToken, type3, initializer) {
          var node = createBaseVariableLikeDeclaration(161, decorators, modifiers, name, type3, initializer && parenthesizerRules().parenthesizeExpressionForDisallowedComma(initializer));
          node.dotDotDotToken = dotDotDotToken;
          node.questionToken = questionToken;
          if (ts3.isThisIdentifier(node.name)) {
            node.transformFlags = 1;
          } else {
            node.transformFlags |= propagateChildFlags(node.dotDotDotToken) | propagateChildFlags(node.questionToken);
            if (questionToken)
              node.transformFlags |= 1;
            if (ts3.modifiersToFlags(node.modifiers) & 16476)
              node.transformFlags |= 4096;
            if (initializer || dotDotDotToken)
              node.transformFlags |= 512;
          }
          return node;
        }
        function updateParameterDeclaration(node, decorators, modifiers, dotDotDotToken, name, questionToken, type3, initializer) {
          return node.decorators !== decorators || node.modifiers !== modifiers || node.dotDotDotToken !== dotDotDotToken || node.name !== name || node.questionToken !== questionToken || node.type !== type3 || node.initializer !== initializer ? update(createParameterDeclaration(decorators, modifiers, dotDotDotToken, name, questionToken, type3, initializer), node) : node;
        }
        function createDecorator(expression) {
          var node = createBaseNode(162);
          node.expression = parenthesizerRules().parenthesizeLeftSideOfAccess(expression);
          node.transformFlags |= propagateChildFlags(node.expression) | 1 | 4096;
          return node;
        }
        function updateDecorator(node, expression) {
          return node.expression !== expression ? update(createDecorator(expression), node) : node;
        }
        function createPropertySignature(modifiers, name, questionToken, type3) {
          var node = createBaseNamedDeclaration(163, void 0, modifiers, name);
          node.type = type3;
          node.questionToken = questionToken;
          node.transformFlags = 1;
          return node;
        }
        function updatePropertySignature(node, modifiers, name, questionToken, type3) {
          return node.modifiers !== modifiers || node.name !== name || node.questionToken !== questionToken || node.type !== type3 ? update(createPropertySignature(modifiers, name, questionToken, type3), node) : node;
        }
        function createPropertyDeclaration(decorators, modifiers, name, questionOrExclamationToken, type3, initializer) {
          var node = createBaseVariableLikeDeclaration(164, decorators, modifiers, name, type3, initializer);
          node.questionToken = questionOrExclamationToken && ts3.isQuestionToken(questionOrExclamationToken) ? questionOrExclamationToken : void 0;
          node.exclamationToken = questionOrExclamationToken && ts3.isExclamationToken(questionOrExclamationToken) ? questionOrExclamationToken : void 0;
          node.transformFlags |= propagateChildFlags(node.questionToken) | propagateChildFlags(node.exclamationToken) | 8388608;
          if (ts3.isComputedPropertyName(node.name) || ts3.hasStaticModifier(node) && node.initializer) {
            node.transformFlags |= 4096;
          }
          if (questionOrExclamationToken || ts3.modifiersToFlags(node.modifiers) & 2) {
            node.transformFlags |= 1;
          }
          return node;
        }
        function updatePropertyDeclaration(node, decorators, modifiers, name, questionOrExclamationToken, type3, initializer) {
          return node.decorators !== decorators || node.modifiers !== modifiers || node.name !== name || node.questionToken !== (questionOrExclamationToken !== void 0 && ts3.isQuestionToken(questionOrExclamationToken) ? questionOrExclamationToken : void 0) || node.exclamationToken !== (questionOrExclamationToken !== void 0 && ts3.isExclamationToken(questionOrExclamationToken) ? questionOrExclamationToken : void 0) || node.type !== type3 || node.initializer !== initializer ? update(createPropertyDeclaration(decorators, modifiers, name, questionOrExclamationToken, type3, initializer), node) : node;
        }
        function createMethodSignature(modifiers, name, questionToken, typeParameters, parameters, type3) {
          var node = createBaseSignatureDeclaration(165, void 0, modifiers, name, typeParameters, parameters, type3);
          node.questionToken = questionToken;
          node.transformFlags = 1;
          return node;
        }
        function updateMethodSignature(node, modifiers, name, questionToken, typeParameters, parameters, type3) {
          return node.modifiers !== modifiers || node.name !== name || node.questionToken !== questionToken || node.typeParameters !== typeParameters || node.parameters !== parameters || node.type !== type3 ? updateBaseSignatureDeclaration(createMethodSignature(modifiers, name, questionToken, typeParameters, parameters, type3), node) : node;
        }
        function createMethodDeclaration(decorators, modifiers, asteriskToken, name, questionToken, typeParameters, parameters, type3, body) {
          var node = createBaseFunctionLikeDeclaration(166, decorators, modifiers, name, typeParameters, parameters, type3, body);
          node.asteriskToken = asteriskToken;
          node.questionToken = questionToken;
          node.transformFlags |= propagateChildFlags(node.asteriskToken) | propagateChildFlags(node.questionToken) | 512;
          if (questionToken) {
            node.transformFlags |= 1;
          }
          if (ts3.modifiersToFlags(node.modifiers) & 256) {
            if (asteriskToken) {
              node.transformFlags |= 64;
            } else {
              node.transformFlags |= 128;
            }
          } else if (asteriskToken) {
            node.transformFlags |= 1024;
          }
          return node;
        }
        function updateMethodDeclaration(node, decorators, modifiers, asteriskToken, name, questionToken, typeParameters, parameters, type3, body) {
          return node.decorators !== decorators || node.modifiers !== modifiers || node.asteriskToken !== asteriskToken || node.name !== name || node.questionToken !== questionToken || node.typeParameters !== typeParameters || node.parameters !== parameters || node.type !== type3 || node.body !== body ? updateBaseFunctionLikeDeclaration(createMethodDeclaration(decorators, modifiers, asteriskToken, name, questionToken, typeParameters, parameters, type3, body), node) : node;
        }
        function createConstructorDeclaration(decorators, modifiers, parameters, body) {
          var node = createBaseFunctionLikeDeclaration(167, decorators, modifiers, void 0, void 0, parameters, void 0, body);
          node.transformFlags |= 512;
          return node;
        }
        function updateConstructorDeclaration(node, decorators, modifiers, parameters, body) {
          return node.decorators !== decorators || node.modifiers !== modifiers || node.parameters !== parameters || node.body !== body ? updateBaseFunctionLikeDeclaration(createConstructorDeclaration(decorators, modifiers, parameters, body), node) : node;
        }
        function createGetAccessorDeclaration(decorators, modifiers, name, parameters, type3, body) {
          return createBaseFunctionLikeDeclaration(168, decorators, modifiers, name, void 0, parameters, type3, body);
        }
        function updateGetAccessorDeclaration(node, decorators, modifiers, name, parameters, type3, body) {
          return node.decorators !== decorators || node.modifiers !== modifiers || node.name !== name || node.parameters !== parameters || node.type !== type3 || node.body !== body ? updateBaseFunctionLikeDeclaration(createGetAccessorDeclaration(decorators, modifiers, name, parameters, type3, body), node) : node;
        }
        function createSetAccessorDeclaration(decorators, modifiers, name, parameters, body) {
          return createBaseFunctionLikeDeclaration(169, decorators, modifiers, name, void 0, parameters, void 0, body);
        }
        function updateSetAccessorDeclaration(node, decorators, modifiers, name, parameters, body) {
          return node.decorators !== decorators || node.modifiers !== modifiers || node.name !== name || node.parameters !== parameters || node.body !== body ? updateBaseFunctionLikeDeclaration(createSetAccessorDeclaration(decorators, modifiers, name, parameters, body), node) : node;
        }
        function createCallSignature(typeParameters, parameters, type3) {
          var node = createBaseSignatureDeclaration(170, void 0, void 0, void 0, typeParameters, parameters, type3);
          node.transformFlags = 1;
          return node;
        }
        function updateCallSignature(node, typeParameters, parameters, type3) {
          return node.typeParameters !== typeParameters || node.parameters !== parameters || node.type !== type3 ? updateBaseSignatureDeclaration(createCallSignature(typeParameters, parameters, type3), node) : node;
        }
        function createConstructSignature(typeParameters, parameters, type3) {
          var node = createBaseSignatureDeclaration(171, void 0, void 0, void 0, typeParameters, parameters, type3);
          node.transformFlags = 1;
          return node;
        }
        function updateConstructSignature(node, typeParameters, parameters, type3) {
          return node.typeParameters !== typeParameters || node.parameters !== parameters || node.type !== type3 ? updateBaseSignatureDeclaration(createConstructSignature(typeParameters, parameters, type3), node) : node;
        }
        function createIndexSignature(decorators, modifiers, parameters, type3) {
          var node = createBaseSignatureDeclaration(172, decorators, modifiers, void 0, void 0, parameters, type3);
          node.transformFlags = 1;
          return node;
        }
        function updateIndexSignature(node, decorators, modifiers, parameters, type3) {
          return node.parameters !== parameters || node.type !== type3 || node.decorators !== decorators || node.modifiers !== modifiers ? updateBaseSignatureDeclaration(createIndexSignature(decorators, modifiers, parameters, type3), node) : node;
        }
        function createTemplateLiteralTypeSpan(type3, literal) {
          var node = createBaseNode(195);
          node.type = type3;
          node.literal = literal;
          node.transformFlags = 1;
          return node;
        }
        function updateTemplateLiteralTypeSpan(node, type3, literal) {
          return node.type !== type3 || node.literal !== literal ? update(createTemplateLiteralTypeSpan(type3, literal), node) : node;
        }
        function createKeywordTypeNode(kind) {
          return createToken(kind);
        }
        function createTypePredicateNode(assertsModifier, parameterName, type3) {
          var node = createBaseNode(173);
          node.assertsModifier = assertsModifier;
          node.parameterName = asName(parameterName);
          node.type = type3;
          node.transformFlags = 1;
          return node;
        }
        function updateTypePredicateNode(node, assertsModifier, parameterName, type3) {
          return node.assertsModifier !== assertsModifier || node.parameterName !== parameterName || node.type !== type3 ? update(createTypePredicateNode(assertsModifier, parameterName, type3), node) : node;
        }
        function createTypeReferenceNode(typeName, typeArguments) {
          var node = createBaseNode(174);
          node.typeName = asName(typeName);
          node.typeArguments = typeArguments && parenthesizerRules().parenthesizeTypeArguments(createNodeArray(typeArguments));
          node.transformFlags = 1;
          return node;
        }
        function updateTypeReferenceNode(node, typeName, typeArguments) {
          return node.typeName !== typeName || node.typeArguments !== typeArguments ? update(createTypeReferenceNode(typeName, typeArguments), node) : node;
        }
        function createFunctionTypeNode(typeParameters, parameters, type3) {
          var node = createBaseSignatureDeclaration(175, void 0, void 0, void 0, typeParameters, parameters, type3);
          node.transformFlags = 1;
          return node;
        }
        function updateFunctionTypeNode(node, typeParameters, parameters, type3) {
          return node.typeParameters !== typeParameters || node.parameters !== parameters || node.type !== type3 ? updateBaseSignatureDeclaration(createFunctionTypeNode(typeParameters, parameters, type3), node) : node;
        }
        function createConstructorTypeNode() {
          var args = [];
          for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
          }
          return args.length === 4 ? createConstructorTypeNode1.apply(void 0, args) : args.length === 3 ? createConstructorTypeNode2.apply(void 0, args) : ts3.Debug.fail("Incorrect number of arguments specified.");
        }
        function createConstructorTypeNode1(modifiers, typeParameters, parameters, type3) {
          var node = createBaseSignatureDeclaration(176, void 0, modifiers, void 0, typeParameters, parameters, type3);
          node.transformFlags = 1;
          return node;
        }
        function createConstructorTypeNode2(typeParameters, parameters, type3) {
          return createConstructorTypeNode1(void 0, typeParameters, parameters, type3);
        }
        function updateConstructorTypeNode() {
          var args = [];
          for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
          }
          return args.length === 5 ? updateConstructorTypeNode1.apply(void 0, args) : args.length === 4 ? updateConstructorTypeNode2.apply(void 0, args) : ts3.Debug.fail("Incorrect number of arguments specified.");
        }
        function updateConstructorTypeNode1(node, modifiers, typeParameters, parameters, type3) {
          return node.modifiers !== modifiers || node.typeParameters !== typeParameters || node.parameters !== parameters || node.type !== type3 ? updateBaseSignatureDeclaration(createConstructorTypeNode(modifiers, typeParameters, parameters, type3), node) : node;
        }
        function updateConstructorTypeNode2(node, typeParameters, parameters, type3) {
          return updateConstructorTypeNode1(node, node.modifiers, typeParameters, parameters, type3);
        }
        function createTypeQueryNode(exprName) {
          var node = createBaseNode(177);
          node.exprName = exprName;
          node.transformFlags = 1;
          return node;
        }
        function updateTypeQueryNode(node, exprName) {
          return node.exprName !== exprName ? update(createTypeQueryNode(exprName), node) : node;
        }
        function createTypeLiteralNode(members) {
          var node = createBaseNode(178);
          node.members = createNodeArray(members);
          node.transformFlags = 1;
          return node;
        }
        function updateTypeLiteralNode(node, members) {
          return node.members !== members ? update(createTypeLiteralNode(members), node) : node;
        }
        function createArrayTypeNode(elementType) {
          var node = createBaseNode(179);
          node.elementType = parenthesizerRules().parenthesizeElementTypeOfArrayType(elementType);
          node.transformFlags = 1;
          return node;
        }
        function updateArrayTypeNode(node, elementType) {
          return node.elementType !== elementType ? update(createArrayTypeNode(elementType), node) : node;
        }
        function createTupleTypeNode(elements) {
          var node = createBaseNode(180);
          node.elements = createNodeArray(elements);
          node.transformFlags = 1;
          return node;
        }
        function updateTupleTypeNode(node, elements) {
          return node.elements !== elements ? update(createTupleTypeNode(elements), node) : node;
        }
        function createNamedTupleMember(dotDotDotToken, name, questionToken, type3) {
          var node = createBaseNode(193);
          node.dotDotDotToken = dotDotDotToken;
          node.name = name;
          node.questionToken = questionToken;
          node.type = type3;
          node.transformFlags = 1;
          return node;
        }
        function updateNamedTupleMember(node, dotDotDotToken, name, questionToken, type3) {
          return node.dotDotDotToken !== dotDotDotToken || node.name !== name || node.questionToken !== questionToken || node.type !== type3 ? update(createNamedTupleMember(dotDotDotToken, name, questionToken, type3), node) : node;
        }
        function createOptionalTypeNode(type3) {
          var node = createBaseNode(181);
          node.type = parenthesizerRules().parenthesizeElementTypeOfArrayType(type3);
          node.transformFlags = 1;
          return node;
        }
        function updateOptionalTypeNode(node, type3) {
          return node.type !== type3 ? update(createOptionalTypeNode(type3), node) : node;
        }
        function createRestTypeNode(type3) {
          var node = createBaseNode(182);
          node.type = type3;
          node.transformFlags = 1;
          return node;
        }
        function updateRestTypeNode(node, type3) {
          return node.type !== type3 ? update(createRestTypeNode(type3), node) : node;
        }
        function createUnionOrIntersectionTypeNode(kind, types2) {
          var node = createBaseNode(kind);
          node.types = parenthesizerRules().parenthesizeConstituentTypesOfUnionOrIntersectionType(types2);
          node.transformFlags = 1;
          return node;
        }
        function updateUnionOrIntersectionTypeNode(node, types2) {
          return node.types !== types2 ? update(createUnionOrIntersectionTypeNode(node.kind, types2), node) : node;
        }
        function createUnionTypeNode(types2) {
          return createUnionOrIntersectionTypeNode(183, types2);
        }
        function updateUnionTypeNode(node, types2) {
          return updateUnionOrIntersectionTypeNode(node, types2);
        }
        function createIntersectionTypeNode(types2) {
          return createUnionOrIntersectionTypeNode(184, types2);
        }
        function updateIntersectionTypeNode(node, types2) {
          return updateUnionOrIntersectionTypeNode(node, types2);
        }
        function createConditionalTypeNode(checkType, extendsType, trueType, falseType) {
          var node = createBaseNode(185);
          node.checkType = parenthesizerRules().parenthesizeMemberOfConditionalType(checkType);
          node.extendsType = parenthesizerRules().parenthesizeMemberOfConditionalType(extendsType);
          node.trueType = trueType;
          node.falseType = falseType;
          node.transformFlags = 1;
          return node;
        }
        function updateConditionalTypeNode(node, checkType, extendsType, trueType, falseType) {
          return node.checkType !== checkType || node.extendsType !== extendsType || node.trueType !== trueType || node.falseType !== falseType ? update(createConditionalTypeNode(checkType, extendsType, trueType, falseType), node) : node;
        }
        function createInferTypeNode(typeParameter) {
          var node = createBaseNode(186);
          node.typeParameter = typeParameter;
          node.transformFlags = 1;
          return node;
        }
        function updateInferTypeNode(node, typeParameter) {
          return node.typeParameter !== typeParameter ? update(createInferTypeNode(typeParameter), node) : node;
        }
        function createTemplateLiteralType(head, templateSpans) {
          var node = createBaseNode(194);
          node.head = head;
          node.templateSpans = createNodeArray(templateSpans);
          node.transformFlags = 1;
          return node;
        }
        function updateTemplateLiteralType(node, head, templateSpans) {
          return node.head !== head || node.templateSpans !== templateSpans ? update(createTemplateLiteralType(head, templateSpans), node) : node;
        }
        function createImportTypeNode(argument, qualifier, typeArguments, isTypeOf) {
          if (isTypeOf === void 0) {
            isTypeOf = false;
          }
          var node = createBaseNode(196);
          node.argument = argument;
          node.qualifier = qualifier;
          node.typeArguments = typeArguments && parenthesizerRules().parenthesizeTypeArguments(typeArguments);
          node.isTypeOf = isTypeOf;
          node.transformFlags = 1;
          return node;
        }
        function updateImportTypeNode(node, argument, qualifier, typeArguments, isTypeOf) {
          if (isTypeOf === void 0) {
            isTypeOf = node.isTypeOf;
          }
          return node.argument !== argument || node.qualifier !== qualifier || node.typeArguments !== typeArguments || node.isTypeOf !== isTypeOf ? update(createImportTypeNode(argument, qualifier, typeArguments, isTypeOf), node) : node;
        }
        function createParenthesizedType(type3) {
          var node = createBaseNode(187);
          node.type = type3;
          node.transformFlags = 1;
          return node;
        }
        function updateParenthesizedType(node, type3) {
          return node.type !== type3 ? update(createParenthesizedType(type3), node) : node;
        }
        function createThisTypeNode() {
          var node = createBaseNode(188);
          node.transformFlags = 1;
          return node;
        }
        function createTypeOperatorNode(operator, type3) {
          var node = createBaseNode(189);
          node.operator = operator;
          node.type = parenthesizerRules().parenthesizeMemberOfElementType(type3);
          node.transformFlags = 1;
          return node;
        }
        function updateTypeOperatorNode(node, type3) {
          return node.type !== type3 ? update(createTypeOperatorNode(node.operator, type3), node) : node;
        }
        function createIndexedAccessTypeNode(objectType, indexType) {
          var node = createBaseNode(190);
          node.objectType = parenthesizerRules().parenthesizeMemberOfElementType(objectType);
          node.indexType = indexType;
          node.transformFlags = 1;
          return node;
        }
        function updateIndexedAccessTypeNode(node, objectType, indexType) {
          return node.objectType !== objectType || node.indexType !== indexType ? update(createIndexedAccessTypeNode(objectType, indexType), node) : node;
        }
        function createMappedTypeNode(readonlyToken, typeParameter, nameType, questionToken, type3) {
          var node = createBaseNode(191);
          node.readonlyToken = readonlyToken;
          node.typeParameter = typeParameter;
          node.nameType = nameType;
          node.questionToken = questionToken;
          node.type = type3;
          node.transformFlags = 1;
          return node;
        }
        function updateMappedTypeNode(node, readonlyToken, typeParameter, nameType, questionToken, type3) {
          return node.readonlyToken !== readonlyToken || node.typeParameter !== typeParameter || node.nameType !== nameType || node.questionToken !== questionToken || node.type !== type3 ? update(createMappedTypeNode(readonlyToken, typeParameter, nameType, questionToken, type3), node) : node;
        }
        function createLiteralTypeNode(literal) {
          var node = createBaseNode(192);
          node.literal = literal;
          node.transformFlags = 1;
          return node;
        }
        function updateLiteralTypeNode(node, literal) {
          return node.literal !== literal ? update(createLiteralTypeNode(literal), node) : node;
        }
        function createObjectBindingPattern(elements) {
          var node = createBaseNode(197);
          node.elements = createNodeArray(elements);
          node.transformFlags |= propagateChildrenFlags(node.elements) | 512 | 262144;
          if (node.transformFlags & 16384) {
            node.transformFlags |= 64 | 32768;
          }
          return node;
        }
        function updateObjectBindingPattern(node, elements) {
          return node.elements !== elements ? update(createObjectBindingPattern(elements), node) : node;
        }
        function createArrayBindingPattern(elements) {
          var node = createBaseNode(198);
          node.elements = createNodeArray(elements);
          node.transformFlags |= propagateChildrenFlags(node.elements) | 512 | 262144;
          return node;
        }
        function updateArrayBindingPattern(node, elements) {
          return node.elements !== elements ? update(createArrayBindingPattern(elements), node) : node;
        }
        function createBindingElement(dotDotDotToken, propertyName, name, initializer) {
          var node = createBaseBindingLikeDeclaration(199, void 0, void 0, name, initializer && parenthesizerRules().parenthesizeExpressionForDisallowedComma(initializer));
          node.propertyName = asName(propertyName);
          node.dotDotDotToken = dotDotDotToken;
          node.transformFlags |= propagateChildFlags(node.dotDotDotToken) | 512;
          if (node.propertyName) {
            node.transformFlags |= ts3.isIdentifier(node.propertyName) ? propagateIdentifierNameFlags(node.propertyName) : propagateChildFlags(node.propertyName);
          }
          if (dotDotDotToken)
            node.transformFlags |= 16384;
          return node;
        }
        function updateBindingElement(node, dotDotDotToken, propertyName, name, initializer) {
          return node.propertyName !== propertyName || node.dotDotDotToken !== dotDotDotToken || node.name !== name || node.initializer !== initializer ? update(createBindingElement(dotDotDotToken, propertyName, name, initializer), node) : node;
        }
        function createBaseExpression(kind) {
          var node = createBaseNode(kind);
          return node;
        }
        function createArrayLiteralExpression(elements, multiLine) {
          var node = createBaseExpression(200);
          node.elements = parenthesizerRules().parenthesizeExpressionsOfCommaDelimitedList(createNodeArray(elements));
          node.multiLine = multiLine;
          node.transformFlags |= propagateChildrenFlags(node.elements);
          return node;
        }
        function updateArrayLiteralExpression(node, elements) {
          return node.elements !== elements ? update(createArrayLiteralExpression(elements, node.multiLine), node) : node;
        }
        function createObjectLiteralExpression(properties, multiLine) {
          var node = createBaseExpression(201);
          node.properties = createNodeArray(properties);
          node.multiLine = multiLine;
          node.transformFlags |= propagateChildrenFlags(node.properties);
          return node;
        }
        function updateObjectLiteralExpression(node, properties) {
          return node.properties !== properties ? update(createObjectLiteralExpression(properties, node.multiLine), node) : node;
        }
        function createPropertyAccessExpression(expression, name) {
          var node = createBaseExpression(202);
          node.expression = parenthesizerRules().parenthesizeLeftSideOfAccess(expression);
          node.name = asName(name);
          node.transformFlags = propagateChildFlags(node.expression) | (ts3.isIdentifier(node.name) ? propagateIdentifierNameFlags(node.name) : propagateChildFlags(node.name));
          if (ts3.isSuperKeyword(expression)) {
            node.transformFlags |= 128 | 64;
          }
          return node;
        }
        function updatePropertyAccessExpression(node, expression, name) {
          if (ts3.isPropertyAccessChain(node)) {
            return updatePropertyAccessChain(node, expression, node.questionDotToken, ts3.cast(name, ts3.isIdentifier));
          }
          return node.expression !== expression || node.name !== name ? update(createPropertyAccessExpression(expression, name), node) : node;
        }
        function createPropertyAccessChain(expression, questionDotToken, name) {
          var node = createBaseExpression(202);
          node.flags |= 32;
          node.expression = parenthesizerRules().parenthesizeLeftSideOfAccess(expression);
          node.questionDotToken = questionDotToken;
          node.name = asName(name);
          node.transformFlags |= 16 | propagateChildFlags(node.expression) | propagateChildFlags(node.questionDotToken) | (ts3.isIdentifier(node.name) ? propagateIdentifierNameFlags(node.name) : propagateChildFlags(node.name));
          return node;
        }
        function updatePropertyAccessChain(node, expression, questionDotToken, name) {
          ts3.Debug.assert(!!(node.flags & 32), "Cannot update a PropertyAccessExpression using updatePropertyAccessChain. Use updatePropertyAccess instead.");
          return node.expression !== expression || node.questionDotToken !== questionDotToken || node.name !== name ? update(createPropertyAccessChain(expression, questionDotToken, name), node) : node;
        }
        function createElementAccessExpression(expression, index) {
          var node = createBaseExpression(203);
          node.expression = parenthesizerRules().parenthesizeLeftSideOfAccess(expression);
          node.argumentExpression = asExpression(index);
          node.transformFlags |= propagateChildFlags(node.expression) | propagateChildFlags(node.argumentExpression);
          if (ts3.isSuperKeyword(expression)) {
            node.transformFlags |= 128 | 64;
          }
          return node;
        }
        function updateElementAccessExpression(node, expression, argumentExpression) {
          if (ts3.isElementAccessChain(node)) {
            return updateElementAccessChain(node, expression, node.questionDotToken, argumentExpression);
          }
          return node.expression !== expression || node.argumentExpression !== argumentExpression ? update(createElementAccessExpression(expression, argumentExpression), node) : node;
        }
        function createElementAccessChain(expression, questionDotToken, index) {
          var node = createBaseExpression(203);
          node.flags |= 32;
          node.expression = parenthesizerRules().parenthesizeLeftSideOfAccess(expression);
          node.questionDotToken = questionDotToken;
          node.argumentExpression = asExpression(index);
          node.transformFlags |= propagateChildFlags(node.expression) | propagateChildFlags(node.questionDotToken) | propagateChildFlags(node.argumentExpression) | 16;
          return node;
        }
        function updateElementAccessChain(node, expression, questionDotToken, argumentExpression) {
          ts3.Debug.assert(!!(node.flags & 32), "Cannot update a ElementAccessExpression using updateElementAccessChain. Use updateElementAccess instead.");
          return node.expression !== expression || node.questionDotToken !== questionDotToken || node.argumentExpression !== argumentExpression ? update(createElementAccessChain(expression, questionDotToken, argumentExpression), node) : node;
        }
        function createCallExpression(expression, typeArguments, argumentsArray) {
          var node = createBaseExpression(204);
          node.expression = parenthesizerRules().parenthesizeLeftSideOfAccess(expression);
          node.typeArguments = asNodeArray(typeArguments);
          node.arguments = parenthesizerRules().parenthesizeExpressionsOfCommaDelimitedList(createNodeArray(argumentsArray));
          node.transformFlags |= propagateChildFlags(node.expression) | propagateChildrenFlags(node.typeArguments) | propagateChildrenFlags(node.arguments);
          if (node.typeArguments) {
            node.transformFlags |= 1;
          }
          if (ts3.isImportKeyword(node.expression)) {
            node.transformFlags |= 4194304;
          } else if (ts3.isSuperProperty(node.expression)) {
            node.transformFlags |= 8192;
          }
          return node;
        }
        function updateCallExpression(node, expression, typeArguments, argumentsArray) {
          if (ts3.isCallChain(node)) {
            return updateCallChain(node, expression, node.questionDotToken, typeArguments, argumentsArray);
          }
          return node.expression !== expression || node.typeArguments !== typeArguments || node.arguments !== argumentsArray ? update(createCallExpression(expression, typeArguments, argumentsArray), node) : node;
        }
        function createCallChain(expression, questionDotToken, typeArguments, argumentsArray) {
          var node = createBaseExpression(204);
          node.flags |= 32;
          node.expression = parenthesizerRules().parenthesizeLeftSideOfAccess(expression);
          node.questionDotToken = questionDotToken;
          node.typeArguments = asNodeArray(typeArguments);
          node.arguments = parenthesizerRules().parenthesizeExpressionsOfCommaDelimitedList(createNodeArray(argumentsArray));
          node.transformFlags |= propagateChildFlags(node.expression) | propagateChildFlags(node.questionDotToken) | propagateChildrenFlags(node.typeArguments) | propagateChildrenFlags(node.arguments) | 16;
          if (node.typeArguments) {
            node.transformFlags |= 1;
          }
          if (ts3.isSuperProperty(node.expression)) {
            node.transformFlags |= 8192;
          }
          return node;
        }
        function updateCallChain(node, expression, questionDotToken, typeArguments, argumentsArray) {
          ts3.Debug.assert(!!(node.flags & 32), "Cannot update a CallExpression using updateCallChain. Use updateCall instead.");
          return node.expression !== expression || node.questionDotToken !== questionDotToken || node.typeArguments !== typeArguments || node.arguments !== argumentsArray ? update(createCallChain(expression, questionDotToken, typeArguments, argumentsArray), node) : node;
        }
        function createNewExpression(expression, typeArguments, argumentsArray) {
          var node = createBaseExpression(205);
          node.expression = parenthesizerRules().parenthesizeExpressionOfNew(expression);
          node.typeArguments = asNodeArray(typeArguments);
          node.arguments = argumentsArray ? parenthesizerRules().parenthesizeExpressionsOfCommaDelimitedList(argumentsArray) : void 0;
          node.transformFlags |= propagateChildFlags(node.expression) | propagateChildrenFlags(node.typeArguments) | propagateChildrenFlags(node.arguments) | 16;
          if (node.typeArguments) {
            node.transformFlags |= 1;
          }
          return node;
        }
        function updateNewExpression(node, expression, typeArguments, argumentsArray) {
          return node.expression !== expression || node.typeArguments !== typeArguments || node.arguments !== argumentsArray ? update(createNewExpression(expression, typeArguments, argumentsArray), node) : node;
        }
        function createTaggedTemplateExpression(tag, typeArguments, template) {
          var node = createBaseExpression(206);
          node.tag = parenthesizerRules().parenthesizeLeftSideOfAccess(tag);
          node.typeArguments = asNodeArray(typeArguments);
          node.template = template;
          node.transformFlags |= propagateChildFlags(node.tag) | propagateChildrenFlags(node.typeArguments) | propagateChildFlags(node.template) | 512;
          if (node.typeArguments) {
            node.transformFlags |= 1;
          }
          if (ts3.hasInvalidEscape(node.template)) {
            node.transformFlags |= 64;
          }
          return node;
        }
        function updateTaggedTemplateExpression(node, tag, typeArguments, template) {
          return node.tag !== tag || node.typeArguments !== typeArguments || node.template !== template ? update(createTaggedTemplateExpression(tag, typeArguments, template), node) : node;
        }
        function createTypeAssertion(type3, expression) {
          var node = createBaseExpression(207);
          node.expression = parenthesizerRules().parenthesizeOperandOfPrefixUnary(expression);
          node.type = type3;
          node.transformFlags |= propagateChildFlags(node.expression) | propagateChildFlags(node.type) | 1;
          return node;
        }
        function updateTypeAssertion(node, type3, expression) {
          return node.type !== type3 || node.expression !== expression ? update(createTypeAssertion(type3, expression), node) : node;
        }
        function createParenthesizedExpression(expression) {
          var node = createBaseExpression(208);
          node.expression = expression;
          node.transformFlags = propagateChildFlags(node.expression);
          return node;
        }
        function updateParenthesizedExpression(node, expression) {
          return node.expression !== expression ? update(createParenthesizedExpression(expression), node) : node;
        }
        function createFunctionExpression(modifiers, asteriskToken, name, typeParameters, parameters, type3, body) {
          var node = createBaseFunctionLikeDeclaration(209, void 0, modifiers, name, typeParameters, parameters, type3, body);
          node.asteriskToken = asteriskToken;
          node.transformFlags |= propagateChildFlags(node.asteriskToken);
          if (node.typeParameters) {
            node.transformFlags |= 1;
          }
          if (ts3.modifiersToFlags(node.modifiers) & 256) {
            if (node.asteriskToken) {
              node.transformFlags |= 64;
            } else {
              node.transformFlags |= 128;
            }
          } else if (node.asteriskToken) {
            node.transformFlags |= 1024;
          }
          return node;
        }
        function updateFunctionExpression(node, modifiers, asteriskToken, name, typeParameters, parameters, type3, body) {
          return node.name !== name || node.modifiers !== modifiers || node.asteriskToken !== asteriskToken || node.typeParameters !== typeParameters || node.parameters !== parameters || node.type !== type3 || node.body !== body ? updateBaseFunctionLikeDeclaration(createFunctionExpression(modifiers, asteriskToken, name, typeParameters, parameters, type3, body), node) : node;
        }
        function createArrowFunction(modifiers, typeParameters, parameters, type3, equalsGreaterThanToken, body) {
          var node = createBaseFunctionLikeDeclaration(210, void 0, modifiers, void 0, typeParameters, parameters, type3, parenthesizerRules().parenthesizeConciseBodyOfArrowFunction(body));
          node.equalsGreaterThanToken = equalsGreaterThanToken !== null && equalsGreaterThanToken !== void 0 ? equalsGreaterThanToken : createToken(38);
          node.transformFlags |= propagateChildFlags(node.equalsGreaterThanToken) | 512;
          if (ts3.modifiersToFlags(node.modifiers) & 256) {
            node.transformFlags |= 128;
          }
          return node;
        }
        function updateArrowFunction(node, modifiers, typeParameters, parameters, type3, equalsGreaterThanToken, body) {
          return node.modifiers !== modifiers || node.typeParameters !== typeParameters || node.parameters !== parameters || node.type !== type3 || node.equalsGreaterThanToken !== equalsGreaterThanToken || node.body !== body ? updateBaseFunctionLikeDeclaration(createArrowFunction(modifiers, typeParameters, parameters, type3, equalsGreaterThanToken, body), node) : node;
        }
        function createDeleteExpression(expression) {
          var node = createBaseExpression(211);
          node.expression = parenthesizerRules().parenthesizeOperandOfPrefixUnary(expression);
          node.transformFlags |= propagateChildFlags(node.expression);
          return node;
        }
        function updateDeleteExpression(node, expression) {
          return node.expression !== expression ? update(createDeleteExpression(expression), node) : node;
        }
        function createTypeOfExpression(expression) {
          var node = createBaseExpression(212);
          node.expression = parenthesizerRules().parenthesizeOperandOfPrefixUnary(expression);
          node.transformFlags |= propagateChildFlags(node.expression);
          return node;
        }
        function updateTypeOfExpression(node, expression) {
          return node.expression !== expression ? update(createTypeOfExpression(expression), node) : node;
        }
        function createVoidExpression(expression) {
          var node = createBaseExpression(213);
          node.expression = parenthesizerRules().parenthesizeOperandOfPrefixUnary(expression);
          node.transformFlags |= propagateChildFlags(node.expression);
          return node;
        }
        function updateVoidExpression(node, expression) {
          return node.expression !== expression ? update(createVoidExpression(expression), node) : node;
        }
        function createAwaitExpression(expression) {
          var node = createBaseExpression(214);
          node.expression = parenthesizerRules().parenthesizeOperandOfPrefixUnary(expression);
          node.transformFlags |= propagateChildFlags(node.expression) | 128 | 64 | 1048576;
          return node;
        }
        function updateAwaitExpression(node, expression) {
          return node.expression !== expression ? update(createAwaitExpression(expression), node) : node;
        }
        function createPrefixUnaryExpression(operator, operand) {
          var node = createBaseExpression(215);
          node.operator = operator;
          node.operand = parenthesizerRules().parenthesizeOperandOfPrefixUnary(operand);
          node.transformFlags |= propagateChildFlags(node.operand);
          return node;
        }
        function updatePrefixUnaryExpression(node, operand) {
          return node.operand !== operand ? update(createPrefixUnaryExpression(node.operator, operand), node) : node;
        }
        function createPostfixUnaryExpression(operand, operator) {
          var node = createBaseExpression(216);
          node.operator = operator;
          node.operand = parenthesizerRules().parenthesizeOperandOfPostfixUnary(operand);
          node.transformFlags = propagateChildFlags(node.operand);
          return node;
        }
        function updatePostfixUnaryExpression(node, operand) {
          return node.operand !== operand ? update(createPostfixUnaryExpression(operand, node.operator), node) : node;
        }
        function createBinaryExpression(left, operator, right) {
          var node = createBaseExpression(217);
          var operatorToken = asToken(operator);
          var operatorKind = operatorToken.kind;
          node.left = parenthesizerRules().parenthesizeLeftSideOfBinary(operatorKind, left);
          node.operatorToken = operatorToken;
          node.right = parenthesizerRules().parenthesizeRightSideOfBinary(operatorKind, node.left, right);
          node.transformFlags |= propagateChildFlags(node.left) | propagateChildFlags(node.operatorToken) | propagateChildFlags(node.right);
          if (operatorKind === 60) {
            node.transformFlags |= 16;
          } else if (operatorKind === 62) {
            if (ts3.isObjectLiteralExpression(node.left)) {
              node.transformFlags |= 512 | 64 | 2048 | propagateAssignmentPatternFlags(node.left);
            } else if (ts3.isArrayLiteralExpression(node.left)) {
              node.transformFlags |= 512 | 2048 | propagateAssignmentPatternFlags(node.left);
            }
          } else if (operatorKind === 42 || operatorKind === 66) {
            node.transformFlags |= 256;
          } else if (ts3.isLogicalOrCoalescingAssignmentOperator(operatorKind)) {
            node.transformFlags |= 8;
          }
          return node;
        }
        function propagateAssignmentPatternFlags(node) {
          if (node.transformFlags & 32768)
            return 32768;
          if (node.transformFlags & 64) {
            for (var _i = 0, _a2 = ts3.getElementsOfBindingOrAssignmentPattern(node); _i < _a2.length; _i++) {
              var element = _a2[_i];
              var target = ts3.getTargetOfBindingOrAssignmentElement(element);
              if (target && ts3.isAssignmentPattern(target)) {
                if (target.transformFlags & 32768) {
                  return 32768;
                }
                if (target.transformFlags & 64) {
                  var flags_1 = propagateAssignmentPatternFlags(target);
                  if (flags_1)
                    return flags_1;
                }
              }
            }
          }
          return 0;
        }
        function updateBinaryExpression(node, left, operator, right) {
          return node.left !== left || node.operatorToken !== operator || node.right !== right ? update(createBinaryExpression(left, operator, right), node) : node;
        }
        function createConditionalExpression(condition, questionToken, whenTrue, colonToken, whenFalse) {
          var node = createBaseExpression(218);
          node.condition = parenthesizerRules().parenthesizeConditionOfConditionalExpression(condition);
          node.questionToken = questionToken !== null && questionToken !== void 0 ? questionToken : createToken(57);
          node.whenTrue = parenthesizerRules().parenthesizeBranchOfConditionalExpression(whenTrue);
          node.colonToken = colonToken !== null && colonToken !== void 0 ? colonToken : createToken(58);
          node.whenFalse = parenthesizerRules().parenthesizeBranchOfConditionalExpression(whenFalse);
          node.transformFlags |= propagateChildFlags(node.condition) | propagateChildFlags(node.questionToken) | propagateChildFlags(node.whenTrue) | propagateChildFlags(node.colonToken) | propagateChildFlags(node.whenFalse);
          return node;
        }
        function updateConditionalExpression(node, condition, questionToken, whenTrue, colonToken, whenFalse) {
          return node.condition !== condition || node.questionToken !== questionToken || node.whenTrue !== whenTrue || node.colonToken !== colonToken || node.whenFalse !== whenFalse ? update(createConditionalExpression(condition, questionToken, whenTrue, colonToken, whenFalse), node) : node;
        }
        function createTemplateExpression(head, templateSpans) {
          var node = createBaseExpression(219);
          node.head = head;
          node.templateSpans = createNodeArray(templateSpans);
          node.transformFlags |= propagateChildFlags(node.head) | propagateChildrenFlags(node.templateSpans) | 512;
          return node;
        }
        function updateTemplateExpression(node, head, templateSpans) {
          return node.head !== head || node.templateSpans !== templateSpans ? update(createTemplateExpression(head, templateSpans), node) : node;
        }
        function createTemplateLiteralLikeNodeChecked(kind, text, rawText, templateFlags) {
          if (templateFlags === void 0) {
            templateFlags = 0;
          }
          ts3.Debug.assert(!(templateFlags & ~2048), "Unsupported template flags.");
          var cooked = void 0;
          if (rawText !== void 0 && rawText !== text) {
            cooked = getCookedText(kind, rawText);
            if (typeof cooked === "object") {
              return ts3.Debug.fail("Invalid raw text");
            }
          }
          if (text === void 0) {
            if (cooked === void 0) {
              return ts3.Debug.fail("Arguments 'text' and 'rawText' may not both be undefined.");
            }
            text = cooked;
          } else if (cooked !== void 0) {
            ts3.Debug.assert(text === cooked, "Expected argument 'text' to be the normalized (i.e. 'cooked') version of argument 'rawText'.");
          }
          return createTemplateLiteralLikeNode(kind, text, rawText, templateFlags);
        }
        function createTemplateLiteralLikeNode(kind, text, rawText, templateFlags) {
          var node = createBaseToken(kind);
          node.text = text;
          node.rawText = rawText;
          node.templateFlags = templateFlags & 2048;
          node.transformFlags |= 512;
          if (node.templateFlags) {
            node.transformFlags |= 64;
          }
          return node;
        }
        function createTemplateHead(text, rawText, templateFlags) {
          return createTemplateLiteralLikeNodeChecked(15, text, rawText, templateFlags);
        }
        function createTemplateMiddle(text, rawText, templateFlags) {
          return createTemplateLiteralLikeNodeChecked(16, text, rawText, templateFlags);
        }
        function createTemplateTail(text, rawText, templateFlags) {
          return createTemplateLiteralLikeNodeChecked(17, text, rawText, templateFlags);
        }
        function createNoSubstitutionTemplateLiteral(text, rawText, templateFlags) {
          return createTemplateLiteralLikeNodeChecked(14, text, rawText, templateFlags);
        }
        function createYieldExpression(asteriskToken, expression) {
          ts3.Debug.assert(!asteriskToken || !!expression, "A `YieldExpression` with an asteriskToken must have an expression.");
          var node = createBaseExpression(220);
          node.expression = expression && parenthesizerRules().parenthesizeExpressionForDisallowedComma(expression);
          node.asteriskToken = asteriskToken;
          node.transformFlags |= propagateChildFlags(node.expression) | propagateChildFlags(node.asteriskToken) | 512 | 64 | 524288;
          return node;
        }
        function updateYieldExpression(node, asteriskToken, expression) {
          return node.expression !== expression || node.asteriskToken !== asteriskToken ? update(createYieldExpression(asteriskToken, expression), node) : node;
        }
        function createSpreadElement(expression) {
          var node = createBaseExpression(221);
          node.expression = parenthesizerRules().parenthesizeExpressionForDisallowedComma(expression);
          node.transformFlags |= propagateChildFlags(node.expression) | 512 | 16384;
          return node;
        }
        function updateSpreadElement(node, expression) {
          return node.expression !== expression ? update(createSpreadElement(expression), node) : node;
        }
        function createClassExpression(decorators, modifiers, name, typeParameters, heritageClauses, members) {
          var node = createBaseClassLikeDeclaration(222, decorators, modifiers, name, typeParameters, heritageClauses, members);
          node.transformFlags |= 512;
          return node;
        }
        function updateClassExpression(node, decorators, modifiers, name, typeParameters, heritageClauses, members) {
          return node.decorators !== decorators || node.modifiers !== modifiers || node.name !== name || node.typeParameters !== typeParameters || node.heritageClauses !== heritageClauses || node.members !== members ? update(createClassExpression(decorators, modifiers, name, typeParameters, heritageClauses, members), node) : node;
        }
        function createOmittedExpression() {
          return createBaseExpression(223);
        }
        function createExpressionWithTypeArguments(expression, typeArguments) {
          var node = createBaseNode(224);
          node.expression = parenthesizerRules().parenthesizeLeftSideOfAccess(expression);
          node.typeArguments = typeArguments && parenthesizerRules().parenthesizeTypeArguments(typeArguments);
          node.transformFlags |= propagateChildFlags(node.expression) | propagateChildrenFlags(node.typeArguments) | 512;
          return node;
        }
        function updateExpressionWithTypeArguments(node, expression, typeArguments) {
          return node.expression !== expression || node.typeArguments !== typeArguments ? update(createExpressionWithTypeArguments(expression, typeArguments), node) : node;
        }
        function createAsExpression(expression, type3) {
          var node = createBaseExpression(225);
          node.expression = expression;
          node.type = type3;
          node.transformFlags |= propagateChildFlags(node.expression) | propagateChildFlags(node.type) | 1;
          return node;
        }
        function updateAsExpression(node, expression, type3) {
          return node.expression !== expression || node.type !== type3 ? update(createAsExpression(expression, type3), node) : node;
        }
        function createNonNullExpression(expression) {
          var node = createBaseExpression(226);
          node.expression = parenthesizerRules().parenthesizeLeftSideOfAccess(expression);
          node.transformFlags |= propagateChildFlags(node.expression) | 1;
          return node;
        }
        function updateNonNullExpression(node, expression) {
          if (ts3.isNonNullChain(node)) {
            return updateNonNullChain(node, expression);
          }
          return node.expression !== expression ? update(createNonNullExpression(expression), node) : node;
        }
        function createNonNullChain(expression) {
          var node = createBaseExpression(226);
          node.flags |= 32;
          node.expression = parenthesizerRules().parenthesizeLeftSideOfAccess(expression);
          node.transformFlags |= propagateChildFlags(node.expression) | 1;
          return node;
        }
        function updateNonNullChain(node, expression) {
          ts3.Debug.assert(!!(node.flags & 32), "Cannot update a NonNullExpression using updateNonNullChain. Use updateNonNullExpression instead.");
          return node.expression !== expression ? update(createNonNullChain(expression), node) : node;
        }
        function createMetaProperty(keywordToken, name) {
          var node = createBaseExpression(227);
          node.keywordToken = keywordToken;
          node.name = name;
          node.transformFlags |= propagateChildFlags(node.name);
          switch (keywordToken) {
            case 102:
              node.transformFlags |= 512;
              break;
            case 99:
              node.transformFlags |= 4;
              break;
            default:
              return ts3.Debug.assertNever(keywordToken);
          }
          return node;
        }
        function updateMetaProperty(node, name) {
          return node.name !== name ? update(createMetaProperty(node.keywordToken, name), node) : node;
        }
        function createTemplateSpan(expression, literal) {
          var node = createBaseNode(229);
          node.expression = expression;
          node.literal = literal;
          node.transformFlags |= propagateChildFlags(node.expression) | propagateChildFlags(node.literal) | 512;
          return node;
        }
        function updateTemplateSpan(node, expression, literal) {
          return node.expression !== expression || node.literal !== literal ? update(createTemplateSpan(expression, literal), node) : node;
        }
        function createSemicolonClassElement() {
          var node = createBaseNode(230);
          node.transformFlags |= 512;
          return node;
        }
        function createBlock(statements, multiLine) {
          var node = createBaseNode(231);
          node.statements = createNodeArray(statements);
          node.multiLine = multiLine;
          node.transformFlags |= propagateChildrenFlags(node.statements);
          return node;
        }
        function updateBlock(node, statements) {
          return node.statements !== statements ? update(createBlock(statements, node.multiLine), node) : node;
        }
        function createVariableStatement(modifiers, declarationList) {
          var node = createBaseDeclaration(233, void 0, modifiers);
          node.declarationList = ts3.isArray(declarationList) ? createVariableDeclarationList(declarationList) : declarationList;
          node.transformFlags |= propagateChildFlags(node.declarationList);
          if (ts3.modifiersToFlags(node.modifiers) & 2) {
            node.transformFlags = 1;
          }
          return node;
        }
        function updateVariableStatement(node, modifiers, declarationList) {
          return node.modifiers !== modifiers || node.declarationList !== declarationList ? update(createVariableStatement(modifiers, declarationList), node) : node;
        }
        function createEmptyStatement() {
          return createBaseNode(232);
        }
        function createExpressionStatement(expression) {
          var node = createBaseNode(234);
          node.expression = parenthesizerRules().parenthesizeExpressionOfExpressionStatement(expression);
          node.transformFlags |= propagateChildFlags(node.expression);
          return node;
        }
        function updateExpressionStatement(node, expression) {
          return node.expression !== expression ? update(createExpressionStatement(expression), node) : node;
        }
        function createIfStatement(expression, thenStatement, elseStatement) {
          var node = createBaseNode(235);
          node.expression = expression;
          node.thenStatement = asEmbeddedStatement(thenStatement);
          node.elseStatement = asEmbeddedStatement(elseStatement);
          node.transformFlags |= propagateChildFlags(node.expression) | propagateChildFlags(node.thenStatement) | propagateChildFlags(node.elseStatement);
          return node;
        }
        function updateIfStatement(node, expression, thenStatement, elseStatement) {
          return node.expression !== expression || node.thenStatement !== thenStatement || node.elseStatement !== elseStatement ? update(createIfStatement(expression, thenStatement, elseStatement), node) : node;
        }
        function createDoStatement(statement, expression) {
          var node = createBaseNode(236);
          node.statement = asEmbeddedStatement(statement);
          node.expression = expression;
          node.transformFlags |= propagateChildFlags(node.statement) | propagateChildFlags(node.expression);
          return node;
        }
        function updateDoStatement(node, statement, expression) {
          return node.statement !== statement || node.expression !== expression ? update(createDoStatement(statement, expression), node) : node;
        }
        function createWhileStatement(expression, statement) {
          var node = createBaseNode(237);
          node.expression = expression;
          node.statement = asEmbeddedStatement(statement);
          node.transformFlags |= propagateChildFlags(node.expression) | propagateChildFlags(node.statement);
          return node;
        }
        function updateWhileStatement(node, expression, statement) {
          return node.expression !== expression || node.statement !== statement ? update(createWhileStatement(expression, statement), node) : node;
        }
        function createForStatement(initializer, condition, incrementor, statement) {
          var node = createBaseNode(238);
          node.initializer = initializer;
          node.condition = condition;
          node.incrementor = incrementor;
          node.statement = asEmbeddedStatement(statement);
          node.transformFlags |= propagateChildFlags(node.initializer) | propagateChildFlags(node.condition) | propagateChildFlags(node.incrementor) | propagateChildFlags(node.statement);
          return node;
        }
        function updateForStatement(node, initializer, condition, incrementor, statement) {
          return node.initializer !== initializer || node.condition !== condition || node.incrementor !== incrementor || node.statement !== statement ? update(createForStatement(initializer, condition, incrementor, statement), node) : node;
        }
        function createForInStatement(initializer, expression, statement) {
          var node = createBaseNode(239);
          node.initializer = initializer;
          node.expression = expression;
          node.statement = asEmbeddedStatement(statement);
          node.transformFlags |= propagateChildFlags(node.initializer) | propagateChildFlags(node.expression) | propagateChildFlags(node.statement);
          return node;
        }
        function updateForInStatement(node, initializer, expression, statement) {
          return node.initializer !== initializer || node.expression !== expression || node.statement !== statement ? update(createForInStatement(initializer, expression, statement), node) : node;
        }
        function createForOfStatement(awaitModifier, initializer, expression, statement) {
          var node = createBaseNode(240);
          node.awaitModifier = awaitModifier;
          node.initializer = initializer;
          node.expression = parenthesizerRules().parenthesizeExpressionForDisallowedComma(expression);
          node.statement = asEmbeddedStatement(statement);
          node.transformFlags |= propagateChildFlags(node.awaitModifier) | propagateChildFlags(node.initializer) | propagateChildFlags(node.expression) | propagateChildFlags(node.statement) | 512;
          if (awaitModifier)
            node.transformFlags |= 64;
          return node;
        }
        function updateForOfStatement(node, awaitModifier, initializer, expression, statement) {
          return node.awaitModifier !== awaitModifier || node.initializer !== initializer || node.expression !== expression || node.statement !== statement ? update(createForOfStatement(awaitModifier, initializer, expression, statement), node) : node;
        }
        function createContinueStatement(label) {
          var node = createBaseNode(241);
          node.label = asName(label);
          node.transformFlags |= propagateChildFlags(node.label) | 2097152;
          return node;
        }
        function updateContinueStatement(node, label) {
          return node.label !== label ? update(createContinueStatement(label), node) : node;
        }
        function createBreakStatement(label) {
          var node = createBaseNode(242);
          node.label = asName(label);
          node.transformFlags |= propagateChildFlags(node.label) | 2097152;
          return node;
        }
        function updateBreakStatement(node, label) {
          return node.label !== label ? update(createBreakStatement(label), node) : node;
        }
        function createReturnStatement(expression) {
          var node = createBaseNode(243);
          node.expression = expression;
          node.transformFlags |= propagateChildFlags(node.expression) | 64 | 2097152;
          return node;
        }
        function updateReturnStatement(node, expression) {
          return node.expression !== expression ? update(createReturnStatement(expression), node) : node;
        }
        function createWithStatement(expression, statement) {
          var node = createBaseNode(244);
          node.expression = expression;
          node.statement = asEmbeddedStatement(statement);
          node.transformFlags |= propagateChildFlags(node.expression) | propagateChildFlags(node.statement);
          return node;
        }
        function updateWithStatement(node, expression, statement) {
          return node.expression !== expression || node.statement !== statement ? update(createWithStatement(expression, statement), node) : node;
        }
        function createSwitchStatement(expression, caseBlock) {
          var node = createBaseNode(245);
          node.expression = parenthesizerRules().parenthesizeExpressionForDisallowedComma(expression);
          node.caseBlock = caseBlock;
          node.transformFlags |= propagateChildFlags(node.expression) | propagateChildFlags(node.caseBlock);
          return node;
        }
        function updateSwitchStatement(node, expression, caseBlock) {
          return node.expression !== expression || node.caseBlock !== caseBlock ? update(createSwitchStatement(expression, caseBlock), node) : node;
        }
        function createLabeledStatement(label, statement) {
          var node = createBaseNode(246);
          node.label = asName(label);
          node.statement = asEmbeddedStatement(statement);
          node.transformFlags |= propagateChildFlags(node.label) | propagateChildFlags(node.statement);
          return node;
        }
        function updateLabeledStatement(node, label, statement) {
          return node.label !== label || node.statement !== statement ? update(createLabeledStatement(label, statement), node) : node;
        }
        function createThrowStatement(expression) {
          var node = createBaseNode(247);
          node.expression = expression;
          node.transformFlags |= propagateChildFlags(node.expression);
          return node;
        }
        function updateThrowStatement(node, expression) {
          return node.expression !== expression ? update(createThrowStatement(expression), node) : node;
        }
        function createTryStatement(tryBlock, catchClause, finallyBlock) {
          var node = createBaseNode(248);
          node.tryBlock = tryBlock;
          node.catchClause = catchClause;
          node.finallyBlock = finallyBlock;
          node.transformFlags |= propagateChildFlags(node.tryBlock) | propagateChildFlags(node.catchClause) | propagateChildFlags(node.finallyBlock);
          return node;
        }
        function updateTryStatement(node, tryBlock, catchClause, finallyBlock) {
          return node.tryBlock !== tryBlock || node.catchClause !== catchClause || node.finallyBlock !== finallyBlock ? update(createTryStatement(tryBlock, catchClause, finallyBlock), node) : node;
        }
        function createDebuggerStatement() {
          return createBaseNode(249);
        }
        function createVariableDeclaration(name, exclamationToken, type3, initializer) {
          var node = createBaseVariableLikeDeclaration(250, void 0, void 0, name, type3, initializer && parenthesizerRules().parenthesizeExpressionForDisallowedComma(initializer));
          node.exclamationToken = exclamationToken;
          node.transformFlags |= propagateChildFlags(node.exclamationToken);
          if (exclamationToken) {
            node.transformFlags |= 1;
          }
          return node;
        }
        function updateVariableDeclaration(node, name, exclamationToken, type3, initializer) {
          return node.name !== name || node.type !== type3 || node.exclamationToken !== exclamationToken || node.initializer !== initializer ? update(createVariableDeclaration(name, exclamationToken, type3, initializer), node) : node;
        }
        function createVariableDeclarationList(declarations, flags2) {
          if (flags2 === void 0) {
            flags2 = 0;
          }
          var node = createBaseNode(251);
          node.flags |= flags2 & 3;
          node.declarations = createNodeArray(declarations);
          node.transformFlags |= propagateChildrenFlags(node.declarations) | 2097152;
          if (flags2 & 3) {
            node.transformFlags |= 512 | 131072;
          }
          return node;
        }
        function updateVariableDeclarationList(node, declarations) {
          return node.declarations !== declarations ? update(createVariableDeclarationList(declarations, node.flags), node) : node;
        }
        function createFunctionDeclaration(decorators, modifiers, asteriskToken, name, typeParameters, parameters, type3, body) {
          var node = createBaseFunctionLikeDeclaration(252, decorators, modifiers, name, typeParameters, parameters, type3, body);
          node.asteriskToken = asteriskToken;
          if (!node.body || ts3.modifiersToFlags(node.modifiers) & 2) {
            node.transformFlags = 1;
          } else {
            node.transformFlags |= propagateChildFlags(node.asteriskToken) | 2097152;
            if (ts3.modifiersToFlags(node.modifiers) & 256) {
              if (node.asteriskToken) {
                node.transformFlags |= 64;
              } else {
                node.transformFlags |= 128;
              }
            } else if (node.asteriskToken) {
              node.transformFlags |= 1024;
            }
          }
          return node;
        }
        function updateFunctionDeclaration(node, decorators, modifiers, asteriskToken, name, typeParameters, parameters, type3, body) {
          return node.decorators !== decorators || node.modifiers !== modifiers || node.asteriskToken !== asteriskToken || node.name !== name || node.typeParameters !== typeParameters || node.parameters !== parameters || node.type !== type3 || node.body !== body ? updateBaseFunctionLikeDeclaration(createFunctionDeclaration(decorators, modifiers, asteriskToken, name, typeParameters, parameters, type3, body), node) : node;
        }
        function createClassDeclaration(decorators, modifiers, name, typeParameters, heritageClauses, members) {
          var node = createBaseClassLikeDeclaration(253, decorators, modifiers, name, typeParameters, heritageClauses, members);
          if (ts3.modifiersToFlags(node.modifiers) & 2) {
            node.transformFlags = 1;
          } else {
            node.transformFlags |= 512;
            if (node.transformFlags & 4096) {
              node.transformFlags |= 1;
            }
          }
          return node;
        }
        function updateClassDeclaration(node, decorators, modifiers, name, typeParameters, heritageClauses, members) {
          return node.decorators !== decorators || node.modifiers !== modifiers || node.name !== name || node.typeParameters !== typeParameters || node.heritageClauses !== heritageClauses || node.members !== members ? update(createClassDeclaration(decorators, modifiers, name, typeParameters, heritageClauses, members), node) : node;
        }
        function createInterfaceDeclaration(decorators, modifiers, name, typeParameters, heritageClauses, members) {
          var node = createBaseInterfaceOrClassLikeDeclaration(254, decorators, modifiers, name, typeParameters, heritageClauses);
          node.members = createNodeArray(members);
          node.transformFlags = 1;
          return node;
        }
        function updateInterfaceDeclaration(node, decorators, modifiers, name, typeParameters, heritageClauses, members) {
          return node.decorators !== decorators || node.modifiers !== modifiers || node.name !== name || node.typeParameters !== typeParameters || node.heritageClauses !== heritageClauses || node.members !== members ? update(createInterfaceDeclaration(decorators, modifiers, name, typeParameters, heritageClauses, members), node) : node;
        }
        function createTypeAliasDeclaration(decorators, modifiers, name, typeParameters, type3) {
          var node = createBaseGenericNamedDeclaration(255, decorators, modifiers, name, typeParameters);
          node.type = type3;
          node.transformFlags = 1;
          return node;
        }
        function updateTypeAliasDeclaration(node, decorators, modifiers, name, typeParameters, type3) {
          return node.decorators !== decorators || node.modifiers !== modifiers || node.name !== name || node.typeParameters !== typeParameters || node.type !== type3 ? update(createTypeAliasDeclaration(decorators, modifiers, name, typeParameters, type3), node) : node;
        }
        function createEnumDeclaration(decorators, modifiers, name, members) {
          var node = createBaseNamedDeclaration(256, decorators, modifiers, name);
          node.members = createNodeArray(members);
          node.transformFlags |= propagateChildrenFlags(node.members) | 1;
          node.transformFlags &= ~16777216;
          return node;
        }
        function updateEnumDeclaration(node, decorators, modifiers, name, members) {
          return node.decorators !== decorators || node.modifiers !== modifiers || node.name !== name || node.members !== members ? update(createEnumDeclaration(decorators, modifiers, name, members), node) : node;
        }
        function createModuleDeclaration(decorators, modifiers, name, body, flags2) {
          if (flags2 === void 0) {
            flags2 = 0;
          }
          var node = createBaseDeclaration(257, decorators, modifiers);
          node.flags |= flags2 & (16 | 4 | 1024);
          node.name = name;
          node.body = body;
          if (ts3.modifiersToFlags(node.modifiers) & 2) {
            node.transformFlags = 1;
          } else {
            node.transformFlags |= propagateChildFlags(node.name) | propagateChildFlags(node.body) | 1;
          }
          node.transformFlags &= ~16777216;
          return node;
        }
        function updateModuleDeclaration(node, decorators, modifiers, name, body) {
          return node.decorators !== decorators || node.modifiers !== modifiers || node.name !== name || node.body !== body ? update(createModuleDeclaration(decorators, modifiers, name, body, node.flags), node) : node;
        }
        function createModuleBlock(statements) {
          var node = createBaseNode(258);
          node.statements = createNodeArray(statements);
          node.transformFlags |= propagateChildrenFlags(node.statements);
          return node;
        }
        function updateModuleBlock(node, statements) {
          return node.statements !== statements ? update(createModuleBlock(statements), node) : node;
        }
        function createCaseBlock(clauses) {
          var node = createBaseNode(259);
          node.clauses = createNodeArray(clauses);
          node.transformFlags |= propagateChildrenFlags(node.clauses);
          return node;
        }
        function updateCaseBlock(node, clauses) {
          return node.clauses !== clauses ? update(createCaseBlock(clauses), node) : node;
        }
        function createNamespaceExportDeclaration(name) {
          var node = createBaseNamedDeclaration(260, void 0, void 0, name);
          node.transformFlags = 1;
          return node;
        }
        function updateNamespaceExportDeclaration(node, name) {
          return node.name !== name ? update(createNamespaceExportDeclaration(name), node) : node;
        }
        function createImportEqualsDeclaration(decorators, modifiers, isTypeOnly, name, moduleReference) {
          var node = createBaseNamedDeclaration(261, decorators, modifiers, name);
          node.isTypeOnly = isTypeOnly;
          node.moduleReference = moduleReference;
          node.transformFlags |= propagateChildFlags(node.moduleReference);
          if (!ts3.isExternalModuleReference(node.moduleReference))
            node.transformFlags |= 1;
          node.transformFlags &= ~16777216;
          return node;
        }
        function updateImportEqualsDeclaration(node, decorators, modifiers, isTypeOnly, name, moduleReference) {
          return node.decorators !== decorators || node.modifiers !== modifiers || node.isTypeOnly !== isTypeOnly || node.name !== name || node.moduleReference !== moduleReference ? update(createImportEqualsDeclaration(decorators, modifiers, isTypeOnly, name, moduleReference), node) : node;
        }
        function createImportDeclaration(decorators, modifiers, importClause, moduleSpecifier) {
          var node = createBaseDeclaration(262, decorators, modifiers);
          node.importClause = importClause;
          node.moduleSpecifier = moduleSpecifier;
          node.transformFlags |= propagateChildFlags(node.importClause) | propagateChildFlags(node.moduleSpecifier);
          node.transformFlags &= ~16777216;
          return node;
        }
        function updateImportDeclaration(node, decorators, modifiers, importClause, moduleSpecifier) {
          return node.decorators !== decorators || node.modifiers !== modifiers || node.importClause !== importClause || node.moduleSpecifier !== moduleSpecifier ? update(createImportDeclaration(decorators, modifiers, importClause, moduleSpecifier), node) : node;
        }
        function createImportClause(isTypeOnly, name, namedBindings) {
          var node = createBaseNode(263);
          node.isTypeOnly = isTypeOnly;
          node.name = name;
          node.namedBindings = namedBindings;
          node.transformFlags |= propagateChildFlags(node.name) | propagateChildFlags(node.namedBindings);
          if (isTypeOnly) {
            node.transformFlags |= 1;
          }
          node.transformFlags &= ~16777216;
          return node;
        }
        function updateImportClause(node, isTypeOnly, name, namedBindings) {
          return node.isTypeOnly !== isTypeOnly || node.name !== name || node.namedBindings !== namedBindings ? update(createImportClause(isTypeOnly, name, namedBindings), node) : node;
        }
        function createNamespaceImport(name) {
          var node = createBaseNode(264);
          node.name = name;
          node.transformFlags |= propagateChildFlags(node.name);
          node.transformFlags &= ~16777216;
          return node;
        }
        function updateNamespaceImport(node, name) {
          return node.name !== name ? update(createNamespaceImport(name), node) : node;
        }
        function createNamespaceExport(name) {
          var node = createBaseNode(270);
          node.name = name;
          node.transformFlags |= propagateChildFlags(node.name) | 4;
          node.transformFlags &= ~16777216;
          return node;
        }
        function updateNamespaceExport(node, name) {
          return node.name !== name ? update(createNamespaceExport(name), node) : node;
        }
        function createNamedImports(elements) {
          var node = createBaseNode(265);
          node.elements = createNodeArray(elements);
          node.transformFlags |= propagateChildrenFlags(node.elements);
          node.transformFlags &= ~16777216;
          return node;
        }
        function updateNamedImports(node, elements) {
          return node.elements !== elements ? update(createNamedImports(elements), node) : node;
        }
        function createImportSpecifier(propertyName, name) {
          var node = createBaseNode(266);
          node.propertyName = propertyName;
          node.name = name;
          node.transformFlags |= propagateChildFlags(node.propertyName) | propagateChildFlags(node.name);
          node.transformFlags &= ~16777216;
          return node;
        }
        function updateImportSpecifier(node, propertyName, name) {
          return node.propertyName !== propertyName || node.name !== name ? update(createImportSpecifier(propertyName, name), node) : node;
        }
        function createExportAssignment(decorators, modifiers, isExportEquals, expression) {
          var node = createBaseDeclaration(267, decorators, modifiers);
          node.isExportEquals = isExportEquals;
          node.expression = isExportEquals ? parenthesizerRules().parenthesizeRightSideOfBinary(62, void 0, expression) : parenthesizerRules().parenthesizeExpressionOfExportDefault(expression);
          node.transformFlags |= propagateChildFlags(node.expression);
          node.transformFlags &= ~16777216;
          return node;
        }
        function updateExportAssignment(node, decorators, modifiers, expression) {
          return node.decorators !== decorators || node.modifiers !== modifiers || node.expression !== expression ? update(createExportAssignment(decorators, modifiers, node.isExportEquals, expression), node) : node;
        }
        function createExportDeclaration(decorators, modifiers, isTypeOnly, exportClause, moduleSpecifier) {
          var node = createBaseDeclaration(268, decorators, modifiers);
          node.isTypeOnly = isTypeOnly;
          node.exportClause = exportClause;
          node.moduleSpecifier = moduleSpecifier;
          node.transformFlags |= propagateChildFlags(node.exportClause) | propagateChildFlags(node.moduleSpecifier);
          node.transformFlags &= ~16777216;
          return node;
        }
        function updateExportDeclaration(node, decorators, modifiers, isTypeOnly, exportClause, moduleSpecifier) {
          return node.decorators !== decorators || node.modifiers !== modifiers || node.isTypeOnly !== isTypeOnly || node.exportClause !== exportClause || node.moduleSpecifier !== moduleSpecifier ? update(createExportDeclaration(decorators, modifiers, isTypeOnly, exportClause, moduleSpecifier), node) : node;
        }
        function createNamedExports(elements) {
          var node = createBaseNode(269);
          node.elements = createNodeArray(elements);
          node.transformFlags |= propagateChildrenFlags(node.elements);
          node.transformFlags &= ~16777216;
          return node;
        }
        function updateNamedExports(node, elements) {
          return node.elements !== elements ? update(createNamedExports(elements), node) : node;
        }
        function createExportSpecifier(propertyName, name) {
          var node = createBaseNode(271);
          node.propertyName = asName(propertyName);
          node.name = asName(name);
          node.transformFlags |= propagateChildFlags(node.propertyName) | propagateChildFlags(node.name);
          node.transformFlags &= ~16777216;
          return node;
        }
        function updateExportSpecifier(node, propertyName, name) {
          return node.propertyName !== propertyName || node.name !== name ? update(createExportSpecifier(propertyName, name), node) : node;
        }
        function createMissingDeclaration() {
          var node = createBaseDeclaration(272, void 0, void 0);
          return node;
        }
        function createExternalModuleReference(expression) {
          var node = createBaseNode(273);
          node.expression = expression;
          node.transformFlags |= propagateChildFlags(node.expression);
          node.transformFlags &= ~16777216;
          return node;
        }
        function updateExternalModuleReference(node, expression) {
          return node.expression !== expression ? update(createExternalModuleReference(expression), node) : node;
        }
        function createJSDocPrimaryTypeWorker(kind) {
          return createBaseNode(kind);
        }
        function createJSDocUnaryTypeWorker(kind, type3) {
          var node = createBaseNode(kind);
          node.type = type3;
          return node;
        }
        function updateJSDocUnaryTypeWorker(kind, node, type3) {
          return node.type !== type3 ? update(createJSDocUnaryTypeWorker(kind, type3), node) : node;
        }
        function createJSDocFunctionType(parameters, type3) {
          var node = createBaseSignatureDeclaration(309, void 0, void 0, void 0, void 0, parameters, type3);
          return node;
        }
        function updateJSDocFunctionType(node, parameters, type3) {
          return node.parameters !== parameters || node.type !== type3 ? update(createJSDocFunctionType(parameters, type3), node) : node;
        }
        function createJSDocTypeLiteral(propertyTags, isArrayType) {
          if (isArrayType === void 0) {
            isArrayType = false;
          }
          var node = createBaseNode(314);
          node.jsDocPropertyTags = asNodeArray(propertyTags);
          node.isArrayType = isArrayType;
          return node;
        }
        function updateJSDocTypeLiteral(node, propertyTags, isArrayType) {
          return node.jsDocPropertyTags !== propertyTags || node.isArrayType !== isArrayType ? update(createJSDocTypeLiteral(propertyTags, isArrayType), node) : node;
        }
        function createJSDocTypeExpression(type3) {
          var node = createBaseNode(302);
          node.type = type3;
          return node;
        }
        function updateJSDocTypeExpression(node, type3) {
          return node.type !== type3 ? update(createJSDocTypeExpression(type3), node) : node;
        }
        function createJSDocSignature(typeParameters, parameters, type3) {
          var node = createBaseNode(315);
          node.typeParameters = asNodeArray(typeParameters);
          node.parameters = createNodeArray(parameters);
          node.type = type3;
          return node;
        }
        function updateJSDocSignature(node, typeParameters, parameters, type3) {
          return node.typeParameters !== typeParameters || node.parameters !== parameters || node.type !== type3 ? update(createJSDocSignature(typeParameters, parameters, type3), node) : node;
        }
        function getDefaultTagName(node) {
          var defaultTagName = getDefaultTagNameForKind(node.kind);
          return node.tagName.escapedText === ts3.escapeLeadingUnderscores(defaultTagName) ? node.tagName : createIdentifier(defaultTagName);
        }
        function createBaseJSDocTag(kind, tagName, comment) {
          var node = createBaseNode(kind);
          node.tagName = tagName;
          node.comment = comment;
          return node;
        }
        function createJSDocTemplateTag(tagName, constraint, typeParameters, comment) {
          var node = createBaseJSDocTag(334, tagName !== null && tagName !== void 0 ? tagName : createIdentifier("template"), comment);
          node.constraint = constraint;
          node.typeParameters = createNodeArray(typeParameters);
          return node;
        }
        function updateJSDocTemplateTag(node, tagName, constraint, typeParameters, comment) {
          if (tagName === void 0) {
            tagName = getDefaultTagName(node);
          }
          return node.tagName !== tagName || node.constraint !== constraint || node.typeParameters !== typeParameters || node.comment !== comment ? update(createJSDocTemplateTag(tagName, constraint, typeParameters, comment), node) : node;
        }
        function createJSDocTypedefTag(tagName, typeExpression, fullName, comment) {
          var node = createBaseJSDocTag(335, tagName !== null && tagName !== void 0 ? tagName : createIdentifier("typedef"), comment);
          node.typeExpression = typeExpression;
          node.fullName = fullName;
          node.name = ts3.getJSDocTypeAliasName(fullName);
          return node;
        }
        function updateJSDocTypedefTag(node, tagName, typeExpression, fullName, comment) {
          if (tagName === void 0) {
            tagName = getDefaultTagName(node);
          }
          return node.tagName !== tagName || node.typeExpression !== typeExpression || node.fullName !== fullName || node.comment !== comment ? update(createJSDocTypedefTag(tagName, typeExpression, fullName, comment), node) : node;
        }
        function createJSDocParameterTag(tagName, name, isBracketed, typeExpression, isNameFirst, comment) {
          var node = createBaseJSDocTag(330, tagName !== null && tagName !== void 0 ? tagName : createIdentifier("param"), comment);
          node.typeExpression = typeExpression;
          node.name = name;
          node.isNameFirst = !!isNameFirst;
          node.isBracketed = isBracketed;
          return node;
        }
        function updateJSDocParameterTag(node, tagName, name, isBracketed, typeExpression, isNameFirst, comment) {
          if (tagName === void 0) {
            tagName = getDefaultTagName(node);
          }
          return node.tagName !== tagName || node.name !== name || node.isBracketed !== isBracketed || node.typeExpression !== typeExpression || node.isNameFirst !== isNameFirst || node.comment !== comment ? update(createJSDocParameterTag(tagName, name, isBracketed, typeExpression, isNameFirst, comment), node) : node;
        }
        function createJSDocPropertyTag(tagName, name, isBracketed, typeExpression, isNameFirst, comment) {
          var node = createBaseJSDocTag(337, tagName !== null && tagName !== void 0 ? tagName : createIdentifier("prop"), comment);
          node.typeExpression = typeExpression;
          node.name = name;
          node.isNameFirst = !!isNameFirst;
          node.isBracketed = isBracketed;
          return node;
        }
        function updateJSDocPropertyTag(node, tagName, name, isBracketed, typeExpression, isNameFirst, comment) {
          if (tagName === void 0) {
            tagName = getDefaultTagName(node);
          }
          return node.tagName !== tagName || node.name !== name || node.isBracketed !== isBracketed || node.typeExpression !== typeExpression || node.isNameFirst !== isNameFirst || node.comment !== comment ? update(createJSDocPropertyTag(tagName, name, isBracketed, typeExpression, isNameFirst, comment), node) : node;
        }
        function createJSDocCallbackTag(tagName, typeExpression, fullName, comment) {
          var node = createBaseJSDocTag(328, tagName !== null && tagName !== void 0 ? tagName : createIdentifier("callback"), comment);
          node.typeExpression = typeExpression;
          node.fullName = fullName;
          node.name = ts3.getJSDocTypeAliasName(fullName);
          return node;
        }
        function updateJSDocCallbackTag(node, tagName, typeExpression, fullName, comment) {
          if (tagName === void 0) {
            tagName = getDefaultTagName(node);
          }
          return node.tagName !== tagName || node.typeExpression !== typeExpression || node.fullName !== fullName || node.comment !== comment ? update(createJSDocCallbackTag(tagName, typeExpression, fullName, comment), node) : node;
        }
        function createJSDocAugmentsTag(tagName, className, comment) {
          var node = createBaseJSDocTag(318, tagName !== null && tagName !== void 0 ? tagName : createIdentifier("augments"), comment);
          node.class = className;
          return node;
        }
        function updateJSDocAugmentsTag(node, tagName, className, comment) {
          if (tagName === void 0) {
            tagName = getDefaultTagName(node);
          }
          return node.tagName !== tagName || node.class !== className || node.comment !== comment ? update(createJSDocAugmentsTag(tagName, className, comment), node) : node;
        }
        function createJSDocImplementsTag(tagName, className, comment) {
          var node = createBaseJSDocTag(319, tagName !== null && tagName !== void 0 ? tagName : createIdentifier("implements"), comment);
          node.class = className;
          return node;
        }
        function createJSDocSeeTag(tagName, name, comment) {
          var node = createBaseJSDocTag(336, tagName !== null && tagName !== void 0 ? tagName : createIdentifier("see"), comment);
          node.name = name;
          return node;
        }
        function updateJSDocSeeTag(node, tagName, name, comment) {
          return node.tagName !== tagName || node.name !== name || node.comment !== comment ? update(createJSDocSeeTag(tagName, name, comment), node) : node;
        }
        function createJSDocNameReference(name) {
          var node = createBaseNode(303);
          node.name = name;
          return node;
        }
        function updateJSDocNameReference(node, name) {
          return node.name !== name ? update(createJSDocNameReference(name), node) : node;
        }
        function createJSDocLink(name, text) {
          var node = createBaseNode(316);
          node.name = name;
          node.text = text;
          return node;
        }
        function updateJSDocLink(node, name, text) {
          return node.name !== name ? update(createJSDocLink(name, text), node) : node;
        }
        function updateJSDocImplementsTag(node, tagName, className, comment) {
          if (tagName === void 0) {
            tagName = getDefaultTagName(node);
          }
          return node.tagName !== tagName || node.class !== className || node.comment !== comment ? update(createJSDocImplementsTag(tagName, className, comment), node) : node;
        }
        function createJSDocSimpleTagWorker(kind, tagName, comment) {
          var node = createBaseJSDocTag(kind, tagName !== null && tagName !== void 0 ? tagName : createIdentifier(getDefaultTagNameForKind(kind)), comment);
          return node;
        }
        function updateJSDocSimpleTagWorker(kind, node, tagName, comment) {
          if (tagName === void 0) {
            tagName = getDefaultTagName(node);
          }
          return node.tagName !== tagName || node.comment !== comment ? update(createJSDocSimpleTagWorker(kind, tagName, comment), node) : node;
        }
        function createJSDocTypeLikeTagWorker(kind, tagName, typeExpression, comment) {
          var node = createBaseJSDocTag(kind, tagName !== null && tagName !== void 0 ? tagName : createIdentifier(getDefaultTagNameForKind(kind)), comment);
          node.typeExpression = typeExpression;
          return node;
        }
        function updateJSDocTypeLikeTagWorker(kind, node, tagName, typeExpression, comment) {
          if (tagName === void 0) {
            tagName = getDefaultTagName(node);
          }
          return node.tagName !== tagName || node.typeExpression !== typeExpression || node.comment !== comment ? update(createJSDocTypeLikeTagWorker(kind, tagName, typeExpression, comment), node) : node;
        }
        function createJSDocUnknownTag(tagName, comment) {
          var node = createBaseJSDocTag(317, tagName, comment);
          return node;
        }
        function updateJSDocUnknownTag(node, tagName, comment) {
          return node.tagName !== tagName || node.comment !== comment ? update(createJSDocUnknownTag(tagName, comment), node) : node;
        }
        function createJSDocText(text) {
          var node = createBaseNode(313);
          node.text = text;
          return node;
        }
        function updateJSDocText(node, text) {
          return node.text !== text ? update(createJSDocText(text), node) : node;
        }
        function createJSDocComment(comment, tags) {
          var node = createBaseNode(312);
          node.comment = comment;
          node.tags = asNodeArray(tags);
          return node;
        }
        function updateJSDocComment(node, comment, tags) {
          return node.comment !== comment || node.tags !== tags ? update(createJSDocComment(comment, tags), node) : node;
        }
        function createJsxElement(openingElement, children, closingElement) {
          var node = createBaseNode(274);
          node.openingElement = openingElement;
          node.children = createNodeArray(children);
          node.closingElement = closingElement;
          node.transformFlags |= propagateChildFlags(node.openingElement) | propagateChildrenFlags(node.children) | propagateChildFlags(node.closingElement) | 2;
          return node;
        }
        function updateJsxElement(node, openingElement, children, closingElement) {
          return node.openingElement !== openingElement || node.children !== children || node.closingElement !== closingElement ? update(createJsxElement(openingElement, children, closingElement), node) : node;
        }
        function createJsxSelfClosingElement(tagName, typeArguments, attributes) {
          var node = createBaseNode(275);
          node.tagName = tagName;
          node.typeArguments = asNodeArray(typeArguments);
          node.attributes = attributes;
          node.transformFlags |= propagateChildFlags(node.tagName) | propagateChildrenFlags(node.typeArguments) | propagateChildFlags(node.attributes) | 2;
          if (node.typeArguments) {
            node.transformFlags |= 1;
          }
          return node;
        }
        function updateJsxSelfClosingElement(node, tagName, typeArguments, attributes) {
          return node.tagName !== tagName || node.typeArguments !== typeArguments || node.attributes !== attributes ? update(createJsxSelfClosingElement(tagName, typeArguments, attributes), node) : node;
        }
        function createJsxOpeningElement(tagName, typeArguments, attributes) {
          var node = createBaseNode(276);
          node.tagName = tagName;
          node.typeArguments = asNodeArray(typeArguments);
          node.attributes = attributes;
          node.transformFlags |= propagateChildFlags(node.tagName) | propagateChildrenFlags(node.typeArguments) | propagateChildFlags(node.attributes) | 2;
          if (typeArguments) {
            node.transformFlags |= 1;
          }
          return node;
        }
        function updateJsxOpeningElement(node, tagName, typeArguments, attributes) {
          return node.tagName !== tagName || node.typeArguments !== typeArguments || node.attributes !== attributes ? update(createJsxOpeningElement(tagName, typeArguments, attributes), node) : node;
        }
        function createJsxClosingElement(tagName) {
          var node = createBaseNode(277);
          node.tagName = tagName;
          node.transformFlags |= propagateChildFlags(node.tagName) | 2;
          return node;
        }
        function updateJsxClosingElement(node, tagName) {
          return node.tagName !== tagName ? update(createJsxClosingElement(tagName), node) : node;
        }
        function createJsxFragment(openingFragment, children, closingFragment) {
          var node = createBaseNode(278);
          node.openingFragment = openingFragment;
          node.children = createNodeArray(children);
          node.closingFragment = closingFragment;
          node.transformFlags |= propagateChildFlags(node.openingFragment) | propagateChildrenFlags(node.children) | propagateChildFlags(node.closingFragment) | 2;
          return node;
        }
        function updateJsxFragment(node, openingFragment, children, closingFragment) {
          return node.openingFragment !== openingFragment || node.children !== children || node.closingFragment !== closingFragment ? update(createJsxFragment(openingFragment, children, closingFragment), node) : node;
        }
        function createJsxText(text, containsOnlyTriviaWhiteSpaces) {
          var node = createBaseNode(11);
          node.text = text;
          node.containsOnlyTriviaWhiteSpaces = !!containsOnlyTriviaWhiteSpaces;
          node.transformFlags |= 2;
          return node;
        }
        function updateJsxText(node, text, containsOnlyTriviaWhiteSpaces) {
          return node.text !== text || node.containsOnlyTriviaWhiteSpaces !== containsOnlyTriviaWhiteSpaces ? update(createJsxText(text, containsOnlyTriviaWhiteSpaces), node) : node;
        }
        function createJsxOpeningFragment() {
          var node = createBaseNode(279);
          node.transformFlags |= 2;
          return node;
        }
        function createJsxJsxClosingFragment() {
          var node = createBaseNode(280);
          node.transformFlags |= 2;
          return node;
        }
        function createJsxAttribute(name, initializer) {
          var node = createBaseNode(281);
          node.name = name;
          node.initializer = initializer;
          node.transformFlags |= propagateChildFlags(node.name) | propagateChildFlags(node.initializer) | 2;
          return node;
        }
        function updateJsxAttribute(node, name, initializer) {
          return node.name !== name || node.initializer !== initializer ? update(createJsxAttribute(name, initializer), node) : node;
        }
        function createJsxAttributes(properties) {
          var node = createBaseNode(282);
          node.properties = createNodeArray(properties);
          node.transformFlags |= propagateChildrenFlags(node.properties) | 2;
          return node;
        }
        function updateJsxAttributes(node, properties) {
          return node.properties !== properties ? update(createJsxAttributes(properties), node) : node;
        }
        function createJsxSpreadAttribute(expression) {
          var node = createBaseNode(283);
          node.expression = expression;
          node.transformFlags |= propagateChildFlags(node.expression) | 2;
          return node;
        }
        function updateJsxSpreadAttribute(node, expression) {
          return node.expression !== expression ? update(createJsxSpreadAttribute(expression), node) : node;
        }
        function createJsxExpression(dotDotDotToken, expression) {
          var node = createBaseNode(284);
          node.dotDotDotToken = dotDotDotToken;
          node.expression = expression;
          node.transformFlags |= propagateChildFlags(node.dotDotDotToken) | propagateChildFlags(node.expression) | 2;
          return node;
        }
        function updateJsxExpression(node, expression) {
          return node.expression !== expression ? update(createJsxExpression(node.dotDotDotToken, expression), node) : node;
        }
        function createCaseClause(expression, statements) {
          var node = createBaseNode(285);
          node.expression = parenthesizerRules().parenthesizeExpressionForDisallowedComma(expression);
          node.statements = createNodeArray(statements);
          node.transformFlags |= propagateChildFlags(node.expression) | propagateChildrenFlags(node.statements);
          return node;
        }
        function updateCaseClause(node, expression, statements) {
          return node.expression !== expression || node.statements !== statements ? update(createCaseClause(expression, statements), node) : node;
        }
        function createDefaultClause(statements) {
          var node = createBaseNode(286);
          node.statements = createNodeArray(statements);
          node.transformFlags = propagateChildrenFlags(node.statements);
          return node;
        }
        function updateDefaultClause(node, statements) {
          return node.statements !== statements ? update(createDefaultClause(statements), node) : node;
        }
        function createHeritageClause(token, types2) {
          var node = createBaseNode(287);
          node.token = token;
          node.types = createNodeArray(types2);
          node.transformFlags |= propagateChildrenFlags(node.types);
          switch (token) {
            case 93:
              node.transformFlags |= 512;
              break;
            case 116:
              node.transformFlags |= 1;
              break;
            default:
              return ts3.Debug.assertNever(token);
          }
          return node;
        }
        function updateHeritageClause(node, types2) {
          return node.types !== types2 ? update(createHeritageClause(node.token, types2), node) : node;
        }
        function createCatchClause(variableDeclaration, block) {
          var node = createBaseNode(288);
          variableDeclaration = !ts3.isString(variableDeclaration) ? variableDeclaration : createVariableDeclaration(variableDeclaration, void 0, void 0, void 0);
          node.variableDeclaration = variableDeclaration;
          node.block = block;
          node.transformFlags |= propagateChildFlags(node.variableDeclaration) | propagateChildFlags(node.block);
          if (!variableDeclaration)
            node.transformFlags |= 32;
          return node;
        }
        function updateCatchClause(node, variableDeclaration, block) {
          return node.variableDeclaration !== variableDeclaration || node.block !== block ? update(createCatchClause(variableDeclaration, block), node) : node;
        }
        function createPropertyAssignment(name, initializer) {
          var node = createBaseNamedDeclaration(289, void 0, void 0, name);
          node.initializer = parenthesizerRules().parenthesizeExpressionForDisallowedComma(initializer);
          node.transformFlags |= propagateChildFlags(node.name) | propagateChildFlags(node.initializer);
          return node;
        }
        function finishUpdatePropertyAssignment(updated, original) {
          if (original.decorators)
            updated.decorators = original.decorators;
          if (original.modifiers)
            updated.modifiers = original.modifiers;
          if (original.questionToken)
            updated.questionToken = original.questionToken;
          if (original.exclamationToken)
            updated.exclamationToken = original.exclamationToken;
          return update(updated, original);
        }
        function updatePropertyAssignment(node, name, initializer) {
          return node.name !== name || node.initializer !== initializer ? finishUpdatePropertyAssignment(createPropertyAssignment(name, initializer), node) : node;
        }
        function createShorthandPropertyAssignment(name, objectAssignmentInitializer) {
          var node = createBaseNamedDeclaration(290, void 0, void 0, name);
          node.objectAssignmentInitializer = objectAssignmentInitializer && parenthesizerRules().parenthesizeExpressionForDisallowedComma(objectAssignmentInitializer);
          node.transformFlags |= propagateChildFlags(node.objectAssignmentInitializer) | 512;
          return node;
        }
        function finishUpdateShorthandPropertyAssignment(updated, original) {
          if (original.decorators)
            updated.decorators = original.decorators;
          if (original.modifiers)
            updated.modifiers = original.modifiers;
          if (original.equalsToken)
            updated.equalsToken = original.equalsToken;
          if (original.questionToken)
            updated.questionToken = original.questionToken;
          if (original.exclamationToken)
            updated.exclamationToken = original.exclamationToken;
          return update(updated, original);
        }
        function updateShorthandPropertyAssignment(node, name, objectAssignmentInitializer) {
          return node.name !== name || node.objectAssignmentInitializer !== objectAssignmentInitializer ? finishUpdateShorthandPropertyAssignment(createShorthandPropertyAssignment(name, objectAssignmentInitializer), node) : node;
        }
        function createSpreadAssignment(expression) {
          var node = createBaseNode(291);
          node.expression = parenthesizerRules().parenthesizeExpressionForDisallowedComma(expression);
          node.transformFlags |= propagateChildFlags(node.expression) | 64 | 32768;
          return node;
        }
        function updateSpreadAssignment(node, expression) {
          return node.expression !== expression ? update(createSpreadAssignment(expression), node) : node;
        }
        function createEnumMember(name, initializer) {
          var node = createBaseNode(292);
          node.name = asName(name);
          node.initializer = initializer && parenthesizerRules().parenthesizeExpressionForDisallowedComma(initializer);
          node.transformFlags |= propagateChildFlags(node.name) | propagateChildFlags(node.initializer) | 1;
          return node;
        }
        function updateEnumMember(node, name, initializer) {
          return node.name !== name || node.initializer !== initializer ? update(createEnumMember(name, initializer), node) : node;
        }
        function createSourceFile(statements, endOfFileToken, flags2) {
          var node = baseFactory2.createBaseSourceFileNode(298);
          node.statements = createNodeArray(statements);
          node.endOfFileToken = endOfFileToken;
          node.flags |= flags2;
          node.fileName = "";
          node.text = "";
          node.languageVersion = 0;
          node.languageVariant = 0;
          node.scriptKind = 0;
          node.isDeclarationFile = false;
          node.hasNoDefaultLib = false;
          node.transformFlags |= propagateChildrenFlags(node.statements) | propagateChildFlags(node.endOfFileToken);
          return node;
        }
        function cloneSourceFileWithChanges(source, statements, isDeclarationFile, referencedFiles, typeReferences, hasNoDefaultLib, libReferences) {
          var node = baseFactory2.createBaseSourceFileNode(298);
          for (var p in source) {
            if (p === "emitNode" || ts3.hasProperty(node, p) || !ts3.hasProperty(source, p))
              continue;
            node[p] = source[p];
          }
          node.flags |= source.flags;
          node.statements = createNodeArray(statements);
          node.endOfFileToken = source.endOfFileToken;
          node.isDeclarationFile = isDeclarationFile;
          node.referencedFiles = referencedFiles;
          node.typeReferenceDirectives = typeReferences;
          node.hasNoDefaultLib = hasNoDefaultLib;
          node.libReferenceDirectives = libReferences;
          node.transformFlags = propagateChildrenFlags(node.statements) | propagateChildFlags(node.endOfFileToken);
          return node;
        }
        function updateSourceFile(node, statements, isDeclarationFile, referencedFiles, typeReferenceDirectives, hasNoDefaultLib, libReferenceDirectives) {
          if (isDeclarationFile === void 0) {
            isDeclarationFile = node.isDeclarationFile;
          }
          if (referencedFiles === void 0) {
            referencedFiles = node.referencedFiles;
          }
          if (typeReferenceDirectives === void 0) {
            typeReferenceDirectives = node.typeReferenceDirectives;
          }
          if (hasNoDefaultLib === void 0) {
            hasNoDefaultLib = node.hasNoDefaultLib;
          }
          if (libReferenceDirectives === void 0) {
            libReferenceDirectives = node.libReferenceDirectives;
          }
          return node.statements !== statements || node.isDeclarationFile !== isDeclarationFile || node.referencedFiles !== referencedFiles || node.typeReferenceDirectives !== typeReferenceDirectives || node.hasNoDefaultLib !== hasNoDefaultLib || node.libReferenceDirectives !== libReferenceDirectives ? update(cloneSourceFileWithChanges(node, statements, isDeclarationFile, referencedFiles, typeReferenceDirectives, hasNoDefaultLib, libReferenceDirectives), node) : node;
        }
        function createBundle(sourceFiles, prepends) {
          if (prepends === void 0) {
            prepends = ts3.emptyArray;
          }
          var node = createBaseNode(299);
          node.prepends = prepends;
          node.sourceFiles = sourceFiles;
          return node;
        }
        function updateBundle(node, sourceFiles, prepends) {
          if (prepends === void 0) {
            prepends = ts3.emptyArray;
          }
          return node.sourceFiles !== sourceFiles || node.prepends !== prepends ? update(createBundle(sourceFiles, prepends), node) : node;
        }
        function createUnparsedSource(prologues, syntheticReferences, texts) {
          var node = createBaseNode(300);
          node.prologues = prologues;
          node.syntheticReferences = syntheticReferences;
          node.texts = texts;
          node.fileName = "";
          node.text = "";
          node.referencedFiles = ts3.emptyArray;
          node.libReferenceDirectives = ts3.emptyArray;
          node.getLineAndCharacterOfPosition = function(pos) {
            return ts3.getLineAndCharacterOfPosition(node, pos);
          };
          return node;
        }
        function createBaseUnparsedNode(kind, data) {
          var node = createBaseNode(kind);
          node.data = data;
          return node;
        }
        function createUnparsedPrologue(data) {
          return createBaseUnparsedNode(293, data);
        }
        function createUnparsedPrepend(data, texts) {
          var node = createBaseUnparsedNode(294, data);
          node.texts = texts;
          return node;
        }
        function createUnparsedTextLike(data, internal) {
          return createBaseUnparsedNode(internal ? 296 : 295, data);
        }
        function createUnparsedSyntheticReference(section) {
          var node = createBaseNode(297);
          node.data = section.data;
          node.section = section;
          return node;
        }
        function createInputFiles2() {
          var node = createBaseNode(301);
          node.javascriptText = "";
          node.declarationText = "";
          return node;
        }
        function createSyntheticExpression(type3, isSpread, tupleNameSource) {
          if (isSpread === void 0) {
            isSpread = false;
          }
          var node = createBaseNode(228);
          node.type = type3;
          node.isSpread = isSpread;
          node.tupleNameSource = tupleNameSource;
          return node;
        }
        function createSyntaxList(children) {
          var node = createBaseNode(338);
          node._children = children;
          return node;
        }
        function createNotEmittedStatement(original) {
          var node = createBaseNode(339);
          node.original = original;
          ts3.setTextRange(node, original);
          return node;
        }
        function createPartiallyEmittedExpression(expression, original) {
          var node = createBaseNode(340);
          node.expression = expression;
          node.original = original;
          node.transformFlags |= propagateChildFlags(node.expression) | 1;
          ts3.setTextRange(node, original);
          return node;
        }
        function updatePartiallyEmittedExpression(node, expression) {
          return node.expression !== expression ? update(createPartiallyEmittedExpression(expression, node.original), node) : node;
        }
        function flattenCommaElements(node) {
          if (ts3.nodeIsSynthesized(node) && !ts3.isParseTreeNode(node) && !node.original && !node.emitNode && !node.id) {
            if (ts3.isCommaListExpression(node)) {
              return node.elements;
            }
            if (ts3.isBinaryExpression(node) && ts3.isCommaToken(node.operatorToken)) {
              return [node.left, node.right];
            }
          }
          return node;
        }
        function createCommaListExpression(elements) {
          var node = createBaseNode(341);
          node.elements = createNodeArray(ts3.sameFlatMap(elements, flattenCommaElements));
          node.transformFlags |= propagateChildrenFlags(node.elements);
          return node;
        }
        function updateCommaListExpression(node, elements) {
          return node.elements !== elements ? update(createCommaListExpression(elements), node) : node;
        }
        function createEndOfDeclarationMarker(original) {
          var node = createBaseNode(343);
          node.emitNode = {};
          node.original = original;
          return node;
        }
        function createMergeDeclarationMarker(original) {
          var node = createBaseNode(342);
          node.emitNode = {};
          node.original = original;
          return node;
        }
        function createSyntheticReferenceExpression(expression, thisArg) {
          var node = createBaseNode(344);
          node.expression = expression;
          node.thisArg = thisArg;
          node.transformFlags |= propagateChildFlags(node.expression) | propagateChildFlags(node.thisArg);
          return node;
        }
        function updateSyntheticReferenceExpression(node, expression, thisArg) {
          return node.expression !== expression || node.thisArg !== thisArg ? update(createSyntheticReferenceExpression(expression, thisArg), node) : node;
        }
        function cloneNode(node) {
          if (node === void 0) {
            return node;
          }
          var clone = ts3.isSourceFile(node) ? baseFactory2.createBaseSourceFileNode(298) : ts3.isIdentifier(node) ? baseFactory2.createBaseIdentifierNode(78) : ts3.isPrivateIdentifier(node) ? baseFactory2.createBasePrivateIdentifierNode(79) : !ts3.isNodeKind(node.kind) ? baseFactory2.createBaseTokenNode(node.kind) : baseFactory2.createBaseNode(node.kind);
          clone.flags |= node.flags & ~8;
          clone.transformFlags = node.transformFlags;
          setOriginalNode(clone, node);
          for (var key2 in node) {
            if (clone.hasOwnProperty(key2) || !node.hasOwnProperty(key2)) {
              continue;
            }
            clone[key2] = node[key2];
          }
          return clone;
        }
        function createImmediatelyInvokedFunctionExpression(statements, param, paramValue) {
          return createCallExpression(createFunctionExpression(void 0, void 0, void 0, void 0, param ? [param] : [], void 0, createBlock(statements, true)), void 0, paramValue ? [paramValue] : []);
        }
        function createImmediatelyInvokedArrowFunction(statements, param, paramValue) {
          return createCallExpression(createArrowFunction(void 0, void 0, param ? [param] : [], void 0, void 0, createBlock(statements, true)), void 0, paramValue ? [paramValue] : []);
        }
        function createVoidZero() {
          return createVoidExpression(createNumericLiteral("0"));
        }
        function createExportDefault(expression) {
          return createExportAssignment(void 0, void 0, false, expression);
        }
        function createExternalModuleExport(exportName) {
          return createExportDeclaration(void 0, void 0, false, createNamedExports([
            createExportSpecifier(void 0, exportName)
          ]));
        }
        function createTypeCheck(value, tag) {
          return tag === "undefined" ? factory.createStrictEquality(value, createVoidZero()) : factory.createStrictEquality(createTypeOfExpression(value), createStringLiteral(tag));
        }
        function createMethodCall(object, methodName, argumentsList) {
          return createCallExpression(createPropertyAccessExpression(object, methodName), void 0, argumentsList);
        }
        function createFunctionBindCall(target, thisArg, argumentsList) {
          return createMethodCall(target, "bind", __spreadArray([thisArg], argumentsList));
        }
        function createFunctionCallCall(target, thisArg, argumentsList) {
          return createMethodCall(target, "call", __spreadArray([thisArg], argumentsList));
        }
        function createFunctionApplyCall(target, thisArg, argumentsExpression) {
          return createMethodCall(target, "apply", [thisArg, argumentsExpression]);
        }
        function createGlobalMethodCall(globalObjectName, methodName, argumentsList) {
          return createMethodCall(createIdentifier(globalObjectName), methodName, argumentsList);
        }
        function createArraySliceCall(array, start) {
          return createMethodCall(array, "slice", start === void 0 ? [] : [asExpression(start)]);
        }
        function createArrayConcatCall(array, argumentsList) {
          return createMethodCall(array, "concat", argumentsList);
        }
        function createObjectDefinePropertyCall(target, propertyName, attributes) {
          return createGlobalMethodCall("Object", "defineProperty", [target, asExpression(propertyName), attributes]);
        }
        function tryAddPropertyAssignment(properties, propertyName, expression) {
          if (expression) {
            properties.push(createPropertyAssignment(propertyName, expression));
            return true;
          }
          return false;
        }
        function createPropertyDescriptor(attributes, singleLine) {
          var properties = [];
          tryAddPropertyAssignment(properties, "enumerable", asExpression(attributes.enumerable));
          tryAddPropertyAssignment(properties, "configurable", asExpression(attributes.configurable));
          var isData = tryAddPropertyAssignment(properties, "writable", asExpression(attributes.writable));
          isData = tryAddPropertyAssignment(properties, "value", attributes.value) || isData;
          var isAccessor = tryAddPropertyAssignment(properties, "get", attributes.get);
          isAccessor = tryAddPropertyAssignment(properties, "set", attributes.set) || isAccessor;
          ts3.Debug.assert(!(isData && isAccessor), "A PropertyDescriptor may not be both an accessor descriptor and a data descriptor.");
          return createObjectLiteralExpression(properties, !singleLine);
        }
        function updateOuterExpression(outerExpression, expression) {
          switch (outerExpression.kind) {
            case 208:
              return updateParenthesizedExpression(outerExpression, expression);
            case 207:
              return updateTypeAssertion(outerExpression, outerExpression.type, expression);
            case 225:
              return updateAsExpression(outerExpression, expression, outerExpression.type);
            case 226:
              return updateNonNullExpression(outerExpression, expression);
            case 340:
              return updatePartiallyEmittedExpression(outerExpression, expression);
          }
        }
        function isIgnorableParen(node) {
          return ts3.isParenthesizedExpression(node) && ts3.nodeIsSynthesized(node) && ts3.nodeIsSynthesized(ts3.getSourceMapRange(node)) && ts3.nodeIsSynthesized(ts3.getCommentRange(node)) && !ts3.some(ts3.getSyntheticLeadingComments(node)) && !ts3.some(ts3.getSyntheticTrailingComments(node));
        }
        function restoreOuterExpressions(outerExpression, innerExpression, kinds) {
          if (kinds === void 0) {
            kinds = 15;
          }
          if (outerExpression && ts3.isOuterExpression(outerExpression, kinds) && !isIgnorableParen(outerExpression)) {
            return updateOuterExpression(outerExpression, restoreOuterExpressions(outerExpression.expression, innerExpression));
          }
          return innerExpression;
        }
        function restoreEnclosingLabel(node, outermostLabeledStatement, afterRestoreLabelCallback) {
          if (!outermostLabeledStatement) {
            return node;
          }
          var updated = updateLabeledStatement(outermostLabeledStatement, outermostLabeledStatement.label, ts3.isLabeledStatement(outermostLabeledStatement.statement) ? restoreEnclosingLabel(node, outermostLabeledStatement.statement) : node);
          if (afterRestoreLabelCallback) {
            afterRestoreLabelCallback(outermostLabeledStatement);
          }
          return updated;
        }
        function shouldBeCapturedInTempVariable(node, cacheIdentifiers) {
          var target = ts3.skipParentheses(node);
          switch (target.kind) {
            case 78:
              return cacheIdentifiers;
            case 107:
            case 8:
            case 9:
            case 10:
              return false;
            case 200:
              var elements = target.elements;
              if (elements.length === 0) {
                return false;
              }
              return true;
            case 201:
              return target.properties.length > 0;
            default:
              return true;
          }
        }
        function createCallBinding(expression, recordTempVariable, languageVersion, cacheIdentifiers) {
          if (cacheIdentifiers === void 0) {
            cacheIdentifiers = false;
          }
          var callee = ts3.skipOuterExpressions(expression, 15);
          var thisArg;
          var target;
          if (ts3.isSuperProperty(callee)) {
            thisArg = createThis();
            target = callee;
          } else if (ts3.isSuperKeyword(callee)) {
            thisArg = createThis();
            target = languageVersion !== void 0 && languageVersion < 2 ? ts3.setTextRange(createIdentifier("_super"), callee) : callee;
          } else if (ts3.getEmitFlags(callee) & 4096) {
            thisArg = createVoidZero();
            target = parenthesizerRules().parenthesizeLeftSideOfAccess(callee);
          } else if (ts3.isPropertyAccessExpression(callee)) {
            if (shouldBeCapturedInTempVariable(callee.expression, cacheIdentifiers)) {
              thisArg = createTempVariable(recordTempVariable);
              target = createPropertyAccessExpression(ts3.setTextRange(factory.createAssignment(thisArg, callee.expression), callee.expression), callee.name);
              ts3.setTextRange(target, callee);
            } else {
              thisArg = callee.expression;
              target = callee;
            }
          } else if (ts3.isElementAccessExpression(callee)) {
            if (shouldBeCapturedInTempVariable(callee.expression, cacheIdentifiers)) {
              thisArg = createTempVariable(recordTempVariable);
              target = createElementAccessExpression(ts3.setTextRange(factory.createAssignment(thisArg, callee.expression), callee.expression), callee.argumentExpression);
              ts3.setTextRange(target, callee);
            } else {
              thisArg = callee.expression;
              target = callee;
            }
          } else {
            thisArg = createVoidZero();
            target = parenthesizerRules().parenthesizeLeftSideOfAccess(expression);
          }
          return { target, thisArg };
        }
        function inlineExpressions(expressions) {
          return expressions.length > 10 ? createCommaListExpression(expressions) : ts3.reduceLeft(expressions, factory.createComma);
        }
        function getName(node, allowComments, allowSourceMaps, emitFlags) {
          if (emitFlags === void 0) {
            emitFlags = 0;
          }
          var nodeName = ts3.getNameOfDeclaration(node);
          if (nodeName && ts3.isIdentifier(nodeName) && !ts3.isGeneratedIdentifier(nodeName)) {
            var name = ts3.setParent(ts3.setTextRange(cloneNode(nodeName), nodeName), nodeName.parent);
            emitFlags |= ts3.getEmitFlags(nodeName);
            if (!allowSourceMaps)
              emitFlags |= 48;
            if (!allowComments)
              emitFlags |= 1536;
            if (emitFlags)
              ts3.setEmitFlags(name, emitFlags);
            return name;
          }
          return getGeneratedNameForNode(node);
        }
        function getInternalName(node, allowComments, allowSourceMaps) {
          return getName(node, allowComments, allowSourceMaps, 16384 | 32768);
        }
        function getLocalName(node, allowComments, allowSourceMaps) {
          return getName(node, allowComments, allowSourceMaps, 16384);
        }
        function getExportName(node, allowComments, allowSourceMaps) {
          return getName(node, allowComments, allowSourceMaps, 8192);
        }
        function getDeclarationName(node, allowComments, allowSourceMaps) {
          return getName(node, allowComments, allowSourceMaps);
        }
        function getNamespaceMemberName(ns, name, allowComments, allowSourceMaps) {
          var qualifiedName = createPropertyAccessExpression(ns, ts3.nodeIsSynthesized(name) ? name : cloneNode(name));
          ts3.setTextRange(qualifiedName, name);
          var emitFlags = 0;
          if (!allowSourceMaps)
            emitFlags |= 48;
          if (!allowComments)
            emitFlags |= 1536;
          if (emitFlags)
            ts3.setEmitFlags(qualifiedName, emitFlags);
          return qualifiedName;
        }
        function getExternalModuleOrNamespaceExportName(ns, node, allowComments, allowSourceMaps) {
          if (ns && ts3.hasSyntacticModifier(node, 1)) {
            return getNamespaceMemberName(ns, getName(node), allowComments, allowSourceMaps);
          }
          return getExportName(node, allowComments, allowSourceMaps);
        }
        function copyPrologue(source, target, ensureUseStrict2, visitor) {
          var offset = copyStandardPrologue(source, target, ensureUseStrict2);
          return copyCustomPrologue(source, target, offset, visitor);
        }
        function isUseStrictPrologue(node) {
          return ts3.isStringLiteral(node.expression) && node.expression.text === "use strict";
        }
        function createUseStrictPrologue() {
          return ts3.startOnNewLine(createExpressionStatement(createStringLiteral("use strict")));
        }
        function copyStandardPrologue(source, target, ensureUseStrict2) {
          ts3.Debug.assert(target.length === 0, "Prologue directives should be at the first statement in the target statements array");
          var foundUseStrict = false;
          var statementOffset = 0;
          var numStatements = source.length;
          while (statementOffset < numStatements) {
            var statement = source[statementOffset];
            if (ts3.isPrologueDirective(statement)) {
              if (isUseStrictPrologue(statement)) {
                foundUseStrict = true;
              }
              target.push(statement);
            } else {
              break;
            }
            statementOffset++;
          }
          if (ensureUseStrict2 && !foundUseStrict) {
            target.push(createUseStrictPrologue());
          }
          return statementOffset;
        }
        function copyCustomPrologue(source, target, statementOffset, visitor, filter) {
          if (filter === void 0) {
            filter = ts3.returnTrue;
          }
          var numStatements = source.length;
          while (statementOffset !== void 0 && statementOffset < numStatements) {
            var statement = source[statementOffset];
            if (ts3.getEmitFlags(statement) & 1048576 && filter(statement)) {
              ts3.append(target, visitor ? ts3.visitNode(statement, visitor, ts3.isStatement) : statement);
            } else {
              break;
            }
            statementOffset++;
          }
          return statementOffset;
        }
        function ensureUseStrict(statements) {
          var foundUseStrict = ts3.findUseStrictPrologue(statements);
          if (!foundUseStrict) {
            return ts3.setTextRange(createNodeArray(__spreadArray([createUseStrictPrologue()], statements)), statements);
          }
          return statements;
        }
        function liftToBlock(nodes) {
          ts3.Debug.assert(ts3.every(nodes, ts3.isStatementOrBlock), "Cannot lift nodes to a Block.");
          return ts3.singleOrUndefined(nodes) || createBlock(nodes);
        }
        function findSpanEnd(array, test, start) {
          var i3 = start;
          while (i3 < array.length && test(array[i3])) {
            i3++;
          }
          return i3;
        }
        function mergeLexicalEnvironment(statements, declarations) {
          if (!ts3.some(declarations)) {
            return statements;
          }
          var leftStandardPrologueEnd = findSpanEnd(statements, ts3.isPrologueDirective, 0);
          var leftHoistedFunctionsEnd = findSpanEnd(statements, ts3.isHoistedFunction, leftStandardPrologueEnd);
          var leftHoistedVariablesEnd = findSpanEnd(statements, ts3.isHoistedVariableStatement, leftHoistedFunctionsEnd);
          var rightStandardPrologueEnd = findSpanEnd(declarations, ts3.isPrologueDirective, 0);
          var rightHoistedFunctionsEnd = findSpanEnd(declarations, ts3.isHoistedFunction, rightStandardPrologueEnd);
          var rightHoistedVariablesEnd = findSpanEnd(declarations, ts3.isHoistedVariableStatement, rightHoistedFunctionsEnd);
          var rightCustomPrologueEnd = findSpanEnd(declarations, ts3.isCustomPrologue, rightHoistedVariablesEnd);
          ts3.Debug.assert(rightCustomPrologueEnd === declarations.length, "Expected declarations to be valid standard or custom prologues");
          var left = ts3.isNodeArray(statements) ? statements.slice() : statements;
          if (rightCustomPrologueEnd > rightHoistedVariablesEnd) {
            left.splice.apply(left, __spreadArray([leftHoistedVariablesEnd, 0], declarations.slice(rightHoistedVariablesEnd, rightCustomPrologueEnd)));
          }
          if (rightHoistedVariablesEnd > rightHoistedFunctionsEnd) {
            left.splice.apply(left, __spreadArray([leftHoistedFunctionsEnd, 0], declarations.slice(rightHoistedFunctionsEnd, rightHoistedVariablesEnd)));
          }
          if (rightHoistedFunctionsEnd > rightStandardPrologueEnd) {
            left.splice.apply(left, __spreadArray([leftStandardPrologueEnd, 0], declarations.slice(rightStandardPrologueEnd, rightHoistedFunctionsEnd)));
          }
          if (rightStandardPrologueEnd > 0) {
            if (leftStandardPrologueEnd === 0) {
              left.splice.apply(left, __spreadArray([0, 0], declarations.slice(0, rightStandardPrologueEnd)));
            } else {
              var leftPrologues = new ts3.Map();
              for (var i3 = 0; i3 < leftStandardPrologueEnd; i3++) {
                var leftPrologue = statements[i3];
                leftPrologues.set(leftPrologue.expression.text, true);
              }
              for (var i3 = rightStandardPrologueEnd - 1; i3 >= 0; i3--) {
                var rightPrologue = declarations[i3];
                if (!leftPrologues.has(rightPrologue.expression.text)) {
                  left.unshift(rightPrologue);
                }
              }
            }
          }
          if (ts3.isNodeArray(statements)) {
            return ts3.setTextRange(createNodeArray(left, statements.hasTrailingComma), statements);
          }
          return statements;
        }
        function updateModifiers(node, modifiers) {
          var _a2;
          if (typeof modifiers === "number") {
            modifiers = createModifiersFromModifierFlags(modifiers);
          }
          return ts3.isParameter(node) ? updateParameterDeclaration(node, node.decorators, modifiers, node.dotDotDotToken, node.name, node.questionToken, node.type, node.initializer) : ts3.isPropertySignature(node) ? updatePropertySignature(node, modifiers, node.name, node.questionToken, node.type) : ts3.isPropertyDeclaration(node) ? updatePropertyDeclaration(node, node.decorators, modifiers, node.name, (_a2 = node.questionToken) !== null && _a2 !== void 0 ? _a2 : node.exclamationToken, node.type, node.initializer) : ts3.isMethodSignature(node) ? updateMethodSignature(node, modifiers, node.name, node.questionToken, node.typeParameters, node.parameters, node.type) : ts3.isMethodDeclaration(node) ? updateMethodDeclaration(node, node.decorators, modifiers, node.asteriskToken, node.name, node.questionToken, node.typeParameters, node.parameters, node.type, node.body) : ts3.isConstructorDeclaration(node) ? updateConstructorDeclaration(node, node.decorators, modifiers, node.parameters, node.body) : ts3.isGetAccessorDeclaration(node) ? updateGetAccessorDeclaration(node, node.decorators, modifiers, node.name, node.parameters, node.type, node.body) : ts3.isSetAccessorDeclaration(node) ? updateSetAccessorDeclaration(node, node.decorators, modifiers, node.name, node.parameters, node.body) : ts3.isIndexSignatureDeclaration(node) ? updateIndexSignature(node, node.decorators, modifiers, node.parameters, node.type) : ts3.isFunctionExpression(node) ? updateFunctionExpression(node, modifiers, node.asteriskToken, node.name, node.typeParameters, node.parameters, node.type, node.body) : ts3.isArrowFunction(node) ? updateArrowFunction(node, modifiers, node.typeParameters, node.parameters, node.type, node.equalsGreaterThanToken, node.body) : ts3.isClassExpression(node) ? updateClassExpression(node, node.decorators, modifiers, node.name, node.typeParameters, node.heritageClauses, node.members) : ts3.isVariableStatement(node) ? updateVariableStatement(node, modifiers, node.declarationList) : ts3.isFunctionDeclaration(node) ? updateFunctionDeclaration(node, node.decorators, modifiers, node.asteriskToken, node.name, node.typeParameters, node.parameters, node.type, node.body) : ts3.isClassDeclaration(node) ? updateClassDeclaration(node, node.decorators, modifiers, node.name, node.typeParameters, node.heritageClauses, node.members) : ts3.isInterfaceDeclaration(node) ? updateInterfaceDeclaration(node, node.decorators, modifiers, node.name, node.typeParameters, node.heritageClauses, node.members) : ts3.isTypeAliasDeclaration(node) ? updateTypeAliasDeclaration(node, node.decorators, modifiers, node.name, node.typeParameters, node.type) : ts3.isEnumDeclaration(node) ? updateEnumDeclaration(node, node.decorators, modifiers, node.name, node.members) : ts3.isModuleDeclaration(node) ? updateModuleDeclaration(node, node.decorators, modifiers, node.name, node.body) : ts3.isImportEqualsDeclaration(node) ? updateImportEqualsDeclaration(node, node.decorators, modifiers, node.isTypeOnly, node.name, node.moduleReference) : ts3.isImportDeclaration(node) ? updateImportDeclaration(node, node.decorators, modifiers, node.importClause, node.moduleSpecifier) : ts3.isExportAssignment(node) ? updateExportAssignment(node, node.decorators, modifiers, node.expression) : ts3.isExportDeclaration(node) ? updateExportDeclaration(node, node.decorators, modifiers, node.isTypeOnly, node.exportClause, node.moduleSpecifier) : ts3.Debug.assertNever(node);
        }
        function asNodeArray(array) {
          return array ? createNodeArray(array) : void 0;
        }
        function asName(name) {
          return typeof name === "string" ? createIdentifier(name) : name;
        }
        function asExpression(value) {
          return typeof value === "string" ? createStringLiteral(value) : typeof value === "number" ? createNumericLiteral(value) : typeof value === "boolean" ? value ? createTrue() : createFalse() : value;
        }
        function asToken(value) {
          return typeof value === "number" ? createToken(value) : value;
        }
        function asEmbeddedStatement(statement) {
          return statement && ts3.isNotEmittedStatement(statement) ? ts3.setTextRange(setOriginalNode(createEmptyStatement(), statement), statement) : statement;
        }
      }
      ts3.createNodeFactory = createNodeFactory;
      function updateWithoutOriginal(updated, original) {
        if (updated !== original) {
          ts3.setTextRange(updated, original);
        }
        return updated;
      }
      function updateWithOriginal(updated, original) {
        if (updated !== original) {
          setOriginalNode(updated, original);
          ts3.setTextRange(updated, original);
        }
        return updated;
      }
      function getDefaultTagNameForKind(kind) {
        switch (kind) {
          case 333:
            return "type";
          case 331:
            return "returns";
          case 332:
            return "this";
          case 329:
            return "enum";
          case 320:
            return "author";
          case 322:
            return "class";
          case 323:
            return "public";
          case 324:
            return "private";
          case 325:
            return "protected";
          case 326:
            return "readonly";
          case 327:
            return "override";
          case 334:
            return "template";
          case 335:
            return "typedef";
          case 330:
            return "param";
          case 337:
            return "prop";
          case 328:
            return "callback";
          case 318:
            return "augments";
          case 319:
            return "implements";
          default:
            return ts3.Debug.fail("Unsupported kind: " + ts3.Debug.formatSyntaxKind(kind));
        }
      }
      var rawTextScanner;
      var invalidValueSentinel = {};
      function getCookedText(kind, rawText) {
        if (!rawTextScanner) {
          rawTextScanner = ts3.createScanner(99, false, 0);
        }
        switch (kind) {
          case 14:
            rawTextScanner.setText("`" + rawText + "`");
            break;
          case 15:
            rawTextScanner.setText("`" + rawText + "${");
            break;
          case 16:
            rawTextScanner.setText("}" + rawText + "${");
            break;
          case 17:
            rawTextScanner.setText("}" + rawText + "`");
            break;
        }
        var token = rawTextScanner.scan();
        if (token === 23) {
          token = rawTextScanner.reScanTemplateToken(false);
        }
        if (rawTextScanner.isUnterminated()) {
          rawTextScanner.setText(void 0);
          return invalidValueSentinel;
        }
        var tokenValue;
        switch (token) {
          case 14:
          case 15:
          case 16:
          case 17:
            tokenValue = rawTextScanner.getTokenValue();
            break;
        }
        if (tokenValue === void 0 || rawTextScanner.scan() !== 1) {
          rawTextScanner.setText(void 0);
          return invalidValueSentinel;
        }
        rawTextScanner.setText(void 0);
        return tokenValue;
      }
      function propagateIdentifierNameFlags(node) {
        return propagateChildFlags(node) & ~16777216;
      }
      function propagatePropertyNameFlagsOfChild(node, transformFlags) {
        return transformFlags | node.transformFlags & 8192;
      }
      function propagateChildFlags(child) {
        if (!child)
          return 0;
        var childFlags = child.transformFlags & ~getTransformFlagsSubtreeExclusions(child.kind);
        return ts3.isNamedDeclaration(child) && ts3.isPropertyName(child.name) ? propagatePropertyNameFlagsOfChild(child.name, childFlags) : childFlags;
      }
      function propagateChildrenFlags(children) {
        return children ? children.transformFlags : 0;
      }
      function aggregateChildrenFlags(children) {
        var subtreeFlags = 0;
        for (var _i = 0, children_2 = children; _i < children_2.length; _i++) {
          var child = children_2[_i];
          subtreeFlags |= propagateChildFlags(child);
        }
        children.transformFlags = subtreeFlags;
      }
      function getTransformFlagsSubtreeExclusions(kind) {
        if (kind >= 173 && kind <= 196) {
          return -2;
        }
        switch (kind) {
          case 204:
          case 205:
          case 200:
            return 536887296;
          case 257:
            return 555888640;
          case 161:
            return 536870912;
          case 210:
            return 557748224;
          case 209:
          case 252:
            return 557756416;
          case 251:
            return 537165824;
          case 253:
          case 222:
            return 536940544;
          case 167:
            return 557752320;
          case 164:
            return 536879104;
          case 166:
          case 168:
          case 169:
            return 540975104;
          case 128:
          case 144:
          case 155:
          case 141:
          case 147:
          case 145:
          case 131:
          case 148:
          case 113:
          case 160:
          case 163:
          case 165:
          case 170:
          case 171:
          case 172:
          case 254:
          case 255:
            return -2;
          case 201:
            return 536973312;
          case 288:
            return 536903680;
          case 197:
          case 198:
            return 536887296;
          case 207:
          case 225:
          case 340:
          case 208:
          case 105:
            return 536870912;
          case 202:
          case 203:
            return 536870912;
          default:
            return 536870912;
        }
      }
      ts3.getTransformFlagsSubtreeExclusions = getTransformFlagsSubtreeExclusions;
      var baseFactory = ts3.createBaseNodeFactory();
      function makeSynthetic(node) {
        node.flags |= 8;
        return node;
      }
      var syntheticFactory = {
        createBaseSourceFileNode: function(kind) {
          return makeSynthetic(baseFactory.createBaseSourceFileNode(kind));
        },
        createBaseIdentifierNode: function(kind) {
          return makeSynthetic(baseFactory.createBaseIdentifierNode(kind));
        },
        createBasePrivateIdentifierNode: function(kind) {
          return makeSynthetic(baseFactory.createBasePrivateIdentifierNode(kind));
        },
        createBaseTokenNode: function(kind) {
          return makeSynthetic(baseFactory.createBaseTokenNode(kind));
        },
        createBaseNode: function(kind) {
          return makeSynthetic(baseFactory.createBaseNode(kind));
        }
      };
      ts3.factory = createNodeFactory(4, syntheticFactory);
      function createUnparsedSourceFile(textOrInputFiles, mapPathOrType, mapTextOrStripInternal) {
        var stripInternal;
        var bundleFileInfo;
        var fileName;
        var text;
        var length;
        var sourceMapPath;
        var sourceMapText;
        var getText;
        var getSourceMapText;
        var oldFileOfCurrentEmit;
        if (!ts3.isString(textOrInputFiles)) {
          ts3.Debug.assert(mapPathOrType === "js" || mapPathOrType === "dts");
          fileName = (mapPathOrType === "js" ? textOrInputFiles.javascriptPath : textOrInputFiles.declarationPath) || "";
          sourceMapPath = mapPathOrType === "js" ? textOrInputFiles.javascriptMapPath : textOrInputFiles.declarationMapPath;
          getText = function() {
            return mapPathOrType === "js" ? textOrInputFiles.javascriptText : textOrInputFiles.declarationText;
          };
          getSourceMapText = function() {
            return mapPathOrType === "js" ? textOrInputFiles.javascriptMapText : textOrInputFiles.declarationMapText;
          };
          length = function() {
            return getText().length;
          };
          if (textOrInputFiles.buildInfo && textOrInputFiles.buildInfo.bundle) {
            ts3.Debug.assert(mapTextOrStripInternal === void 0 || typeof mapTextOrStripInternal === "boolean");
            stripInternal = mapTextOrStripInternal;
            bundleFileInfo = mapPathOrType === "js" ? textOrInputFiles.buildInfo.bundle.js : textOrInputFiles.buildInfo.bundle.dts;
            oldFileOfCurrentEmit = textOrInputFiles.oldFileOfCurrentEmit;
          }
        } else {
          fileName = "";
          text = textOrInputFiles;
          length = textOrInputFiles.length;
          sourceMapPath = mapPathOrType;
          sourceMapText = mapTextOrStripInternal;
        }
        var node = oldFileOfCurrentEmit ? parseOldFileOfCurrentEmit(ts3.Debug.assertDefined(bundleFileInfo)) : parseUnparsedSourceFile(bundleFileInfo, stripInternal, length);
        node.fileName = fileName;
        node.sourceMapPath = sourceMapPath;
        node.oldFileOfCurrentEmit = oldFileOfCurrentEmit;
        if (getText && getSourceMapText) {
          Object.defineProperty(node, "text", { get: getText });
          Object.defineProperty(node, "sourceMapText", { get: getSourceMapText });
        } else {
          ts3.Debug.assert(!oldFileOfCurrentEmit);
          node.text = text !== null && text !== void 0 ? text : "";
          node.sourceMapText = sourceMapText;
        }
        return node;
      }
      ts3.createUnparsedSourceFile = createUnparsedSourceFile;
      function parseUnparsedSourceFile(bundleFileInfo, stripInternal, length) {
        var prologues;
        var helpers;
        var referencedFiles;
        var typeReferenceDirectives;
        var libReferenceDirectives;
        var prependChildren;
        var texts;
        var hasNoDefaultLib;
        for (var _i = 0, _a2 = bundleFileInfo ? bundleFileInfo.sections : ts3.emptyArray; _i < _a2.length; _i++) {
          var section = _a2[_i];
          switch (section.kind) {
            case "prologue":
              prologues = ts3.append(prologues, ts3.setTextRange(ts3.factory.createUnparsedPrologue(section.data), section));
              break;
            case "emitHelpers":
              helpers = ts3.append(helpers, ts3.getAllUnscopedEmitHelpers().get(section.data));
              break;
            case "no-default-lib":
              hasNoDefaultLib = true;
              break;
            case "reference":
              referencedFiles = ts3.append(referencedFiles, { pos: -1, end: -1, fileName: section.data });
              break;
            case "type":
              typeReferenceDirectives = ts3.append(typeReferenceDirectives, section.data);
              break;
            case "lib":
              libReferenceDirectives = ts3.append(libReferenceDirectives, { pos: -1, end: -1, fileName: section.data });
              break;
            case "prepend":
              var prependTexts = void 0;
              for (var _b = 0, _c = section.texts; _b < _c.length; _b++) {
                var text = _c[_b];
                if (!stripInternal || text.kind !== "internal") {
                  prependTexts = ts3.append(prependTexts, ts3.setTextRange(ts3.factory.createUnparsedTextLike(text.data, text.kind === "internal"), text));
                }
              }
              prependChildren = ts3.addRange(prependChildren, prependTexts);
              texts = ts3.append(texts, ts3.factory.createUnparsedPrepend(section.data, prependTexts !== null && prependTexts !== void 0 ? prependTexts : ts3.emptyArray));
              break;
            case "internal":
              if (stripInternal) {
                if (!texts)
                  texts = [];
                break;
              }
            case "text":
              texts = ts3.append(texts, ts3.setTextRange(ts3.factory.createUnparsedTextLike(section.data, section.kind === "internal"), section));
              break;
            default:
              ts3.Debug.assertNever(section);
          }
        }
        if (!texts) {
          var textNode = ts3.factory.createUnparsedTextLike(void 0, false);
          ts3.setTextRangePosWidth(textNode, 0, typeof length === "function" ? length() : length);
          texts = [textNode];
        }
        var node = ts3.parseNodeFactory.createUnparsedSource(prologues !== null && prologues !== void 0 ? prologues : ts3.emptyArray, void 0, texts);
        ts3.setEachParent(prologues, node);
        ts3.setEachParent(texts, node);
        ts3.setEachParent(prependChildren, node);
        node.hasNoDefaultLib = hasNoDefaultLib;
        node.helpers = helpers;
        node.referencedFiles = referencedFiles || ts3.emptyArray;
        node.typeReferenceDirectives = typeReferenceDirectives;
        node.libReferenceDirectives = libReferenceDirectives || ts3.emptyArray;
        return node;
      }
      function parseOldFileOfCurrentEmit(bundleFileInfo) {
        var texts;
        var syntheticReferences;
        for (var _i = 0, _a2 = bundleFileInfo.sections; _i < _a2.length; _i++) {
          var section = _a2[_i];
          switch (section.kind) {
            case "internal":
            case "text":
              texts = ts3.append(texts, ts3.setTextRange(ts3.factory.createUnparsedTextLike(section.data, section.kind === "internal"), section));
              break;
            case "no-default-lib":
            case "reference":
            case "type":
            case "lib":
              syntheticReferences = ts3.append(syntheticReferences, ts3.setTextRange(ts3.factory.createUnparsedSyntheticReference(section), section));
              break;
            case "prologue":
            case "emitHelpers":
            case "prepend":
              break;
            default:
              ts3.Debug.assertNever(section);
          }
        }
        var node = ts3.factory.createUnparsedSource(ts3.emptyArray, syntheticReferences, texts !== null && texts !== void 0 ? texts : ts3.emptyArray);
        ts3.setEachParent(syntheticReferences, node);
        ts3.setEachParent(texts, node);
        node.helpers = ts3.map(bundleFileInfo.sources && bundleFileInfo.sources.helpers, function(name) {
          return ts3.getAllUnscopedEmitHelpers().get(name);
        });
        return node;
      }
      function createInputFiles(javascriptTextOrReadFileText, declarationTextOrJavascriptPath, javascriptMapPath, javascriptMapTextOrDeclarationPath, declarationMapPath, declarationMapTextOrBuildInfoPath, javascriptPath, declarationPath, buildInfoPath, buildInfo, oldFileOfCurrentEmit) {
        var node = ts3.parseNodeFactory.createInputFiles();
        if (!ts3.isString(javascriptTextOrReadFileText)) {
          var cache_1 = new ts3.Map();
          var textGetter_1 = function(path2) {
            if (path2 === void 0)
              return void 0;
            var value = cache_1.get(path2);
            if (value === void 0) {
              value = javascriptTextOrReadFileText(path2);
              cache_1.set(path2, value !== void 0 ? value : false);
            }
            return value !== false ? value : void 0;
          };
          var definedTextGetter_1 = function(path2) {
            var result2 = textGetter_1(path2);
            return result2 !== void 0 ? result2 : "/* Input file " + path2 + " was missing */\r\n";
          };
          var buildInfo_1;
          var getAndCacheBuildInfo_1 = function(getText) {
            if (buildInfo_1 === void 0) {
              var result2 = getText();
              buildInfo_1 = result2 !== void 0 ? ts3.getBuildInfo(result2) : false;
            }
            return buildInfo_1 || void 0;
          };
          node.javascriptPath = declarationTextOrJavascriptPath;
          node.javascriptMapPath = javascriptMapPath;
          node.declarationPath = ts3.Debug.assertDefined(javascriptMapTextOrDeclarationPath);
          node.declarationMapPath = declarationMapPath;
          node.buildInfoPath = declarationMapTextOrBuildInfoPath;
          Object.defineProperties(node, {
            javascriptText: { get: function() {
              return definedTextGetter_1(declarationTextOrJavascriptPath);
            } },
            javascriptMapText: { get: function() {
              return textGetter_1(javascriptMapPath);
            } },
            declarationText: { get: function() {
              return definedTextGetter_1(ts3.Debug.assertDefined(javascriptMapTextOrDeclarationPath));
            } },
            declarationMapText: { get: function() {
              return textGetter_1(declarationMapPath);
            } },
            buildInfo: { get: function() {
              return getAndCacheBuildInfo_1(function() {
                return textGetter_1(declarationMapTextOrBuildInfoPath);
              });
            } }
          });
        } else {
          node.javascriptText = javascriptTextOrReadFileText;
          node.javascriptMapPath = javascriptMapPath;
          node.javascriptMapText = javascriptMapTextOrDeclarationPath;
          node.declarationText = declarationTextOrJavascriptPath;
          node.declarationMapPath = declarationMapPath;
          node.declarationMapText = declarationMapTextOrBuildInfoPath;
          node.javascriptPath = javascriptPath;
          node.declarationPath = declarationPath;
          node.buildInfoPath = buildInfoPath;
          node.buildInfo = buildInfo;
          node.oldFileOfCurrentEmit = oldFileOfCurrentEmit;
        }
        return node;
      }
      ts3.createInputFiles = createInputFiles;
      var SourceMapSource;
      function createSourceMapSource(fileName, text, skipTrivia) {
        return new (SourceMapSource || (SourceMapSource = ts3.objectAllocator.getSourceMapSourceConstructor()))(fileName, text, skipTrivia);
      }
      ts3.createSourceMapSource = createSourceMapSource;
      function setOriginalNode(node, original) {
        node.original = original;
        if (original) {
          var emitNode = original.emitNode;
          if (emitNode)
            node.emitNode = mergeEmitNode(emitNode, node.emitNode);
        }
        return node;
      }
      ts3.setOriginalNode = setOriginalNode;
      function mergeEmitNode(sourceEmitNode, destEmitNode) {
        var flags = sourceEmitNode.flags, leadingComments = sourceEmitNode.leadingComments, trailingComments = sourceEmitNode.trailingComments, commentRange = sourceEmitNode.commentRange, sourceMapRange = sourceEmitNode.sourceMapRange, tokenSourceMapRanges = sourceEmitNode.tokenSourceMapRanges, constantValue = sourceEmitNode.constantValue, helpers = sourceEmitNode.helpers, startsOnNewLine = sourceEmitNode.startsOnNewLine;
        if (!destEmitNode)
          destEmitNode = {};
        if (leadingComments)
          destEmitNode.leadingComments = ts3.addRange(leadingComments.slice(), destEmitNode.leadingComments);
        if (trailingComments)
          destEmitNode.trailingComments = ts3.addRange(trailingComments.slice(), destEmitNode.trailingComments);
        if (flags)
          destEmitNode.flags = flags;
        if (commentRange)
          destEmitNode.commentRange = commentRange;
        if (sourceMapRange)
          destEmitNode.sourceMapRange = sourceMapRange;
        if (tokenSourceMapRanges)
          destEmitNode.tokenSourceMapRanges = mergeTokenSourceMapRanges(tokenSourceMapRanges, destEmitNode.tokenSourceMapRanges);
        if (constantValue !== void 0)
          destEmitNode.constantValue = constantValue;
        if (helpers) {
          for (var _i = 0, helpers_1 = helpers; _i < helpers_1.length; _i++) {
            var helper = helpers_1[_i];
            destEmitNode.helpers = ts3.appendIfUnique(destEmitNode.helpers, helper);
          }
        }
        if (startsOnNewLine !== void 0)
          destEmitNode.startsOnNewLine = startsOnNewLine;
        return destEmitNode;
      }
      function mergeTokenSourceMapRanges(sourceRanges, destRanges) {
        if (!destRanges)
          destRanges = [];
        for (var key2 in sourceRanges) {
          destRanges[key2] = sourceRanges[key2];
        }
        return destRanges;
      }
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      function getOrCreateEmitNode(node) {
        var _a2;
        if (!node.emitNode) {
          if (ts3.isParseTreeNode(node)) {
            if (node.kind === 298) {
              return node.emitNode = { annotatedNodes: [node] };
            }
            var sourceFile = (_a2 = ts3.getSourceFileOfNode(ts3.getParseTreeNode(ts3.getSourceFileOfNode(node)))) !== null && _a2 !== void 0 ? _a2 : ts3.Debug.fail("Could not determine parsed source file.");
            getOrCreateEmitNode(sourceFile).annotatedNodes.push(node);
          }
          node.emitNode = {};
        }
        return node.emitNode;
      }
      ts3.getOrCreateEmitNode = getOrCreateEmitNode;
      function disposeEmitNodes(sourceFile) {
        var _a2, _b;
        var annotatedNodes = (_b = (_a2 = ts3.getSourceFileOfNode(ts3.getParseTreeNode(sourceFile))) === null || _a2 === void 0 ? void 0 : _a2.emitNode) === null || _b === void 0 ? void 0 : _b.annotatedNodes;
        if (annotatedNodes) {
          for (var _i = 0, annotatedNodes_1 = annotatedNodes; _i < annotatedNodes_1.length; _i++) {
            var node = annotatedNodes_1[_i];
            node.emitNode = void 0;
          }
        }
      }
      ts3.disposeEmitNodes = disposeEmitNodes;
      function removeAllComments(node) {
        var emitNode = getOrCreateEmitNode(node);
        emitNode.flags |= 1536;
        emitNode.leadingComments = void 0;
        emitNode.trailingComments = void 0;
        return node;
      }
      ts3.removeAllComments = removeAllComments;
      function setEmitFlags(node, emitFlags) {
        getOrCreateEmitNode(node).flags = emitFlags;
        return node;
      }
      ts3.setEmitFlags = setEmitFlags;
      function addEmitFlags(node, emitFlags) {
        var emitNode = getOrCreateEmitNode(node);
        emitNode.flags = emitNode.flags | emitFlags;
        return node;
      }
      ts3.addEmitFlags = addEmitFlags;
      function getSourceMapRange(node) {
        var _a2, _b;
        return (_b = (_a2 = node.emitNode) === null || _a2 === void 0 ? void 0 : _a2.sourceMapRange) !== null && _b !== void 0 ? _b : node;
      }
      ts3.getSourceMapRange = getSourceMapRange;
      function setSourceMapRange(node, range) {
        getOrCreateEmitNode(node).sourceMapRange = range;
        return node;
      }
      ts3.setSourceMapRange = setSourceMapRange;
      function getTokenSourceMapRange(node, token) {
        var _a2, _b;
        return (_b = (_a2 = node.emitNode) === null || _a2 === void 0 ? void 0 : _a2.tokenSourceMapRanges) === null || _b === void 0 ? void 0 : _b[token];
      }
      ts3.getTokenSourceMapRange = getTokenSourceMapRange;
      function setTokenSourceMapRange(node, token, range) {
        var _a2;
        var emitNode = getOrCreateEmitNode(node);
        var tokenSourceMapRanges = (_a2 = emitNode.tokenSourceMapRanges) !== null && _a2 !== void 0 ? _a2 : emitNode.tokenSourceMapRanges = [];
        tokenSourceMapRanges[token] = range;
        return node;
      }
      ts3.setTokenSourceMapRange = setTokenSourceMapRange;
      function getStartsOnNewLine(node) {
        var _a2;
        return (_a2 = node.emitNode) === null || _a2 === void 0 ? void 0 : _a2.startsOnNewLine;
      }
      ts3.getStartsOnNewLine = getStartsOnNewLine;
      function setStartsOnNewLine(node, newLine) {
        getOrCreateEmitNode(node).startsOnNewLine = newLine;
        return node;
      }
      ts3.setStartsOnNewLine = setStartsOnNewLine;
      function getCommentRange(node) {
        var _a2, _b;
        return (_b = (_a2 = node.emitNode) === null || _a2 === void 0 ? void 0 : _a2.commentRange) !== null && _b !== void 0 ? _b : node;
      }
      ts3.getCommentRange = getCommentRange;
      function setCommentRange(node, range) {
        getOrCreateEmitNode(node).commentRange = range;
        return node;
      }
      ts3.setCommentRange = setCommentRange;
      function getSyntheticLeadingComments(node) {
        var _a2;
        return (_a2 = node.emitNode) === null || _a2 === void 0 ? void 0 : _a2.leadingComments;
      }
      ts3.getSyntheticLeadingComments = getSyntheticLeadingComments;
      function setSyntheticLeadingComments(node, comments) {
        getOrCreateEmitNode(node).leadingComments = comments;
        return node;
      }
      ts3.setSyntheticLeadingComments = setSyntheticLeadingComments;
      function addSyntheticLeadingComment(node, kind, text, hasTrailingNewLine) {
        return setSyntheticLeadingComments(node, ts3.append(getSyntheticLeadingComments(node), { kind, pos: -1, end: -1, hasTrailingNewLine, text }));
      }
      ts3.addSyntheticLeadingComment = addSyntheticLeadingComment;
      function getSyntheticTrailingComments(node) {
        var _a2;
        return (_a2 = node.emitNode) === null || _a2 === void 0 ? void 0 : _a2.trailingComments;
      }
      ts3.getSyntheticTrailingComments = getSyntheticTrailingComments;
      function setSyntheticTrailingComments(node, comments) {
        getOrCreateEmitNode(node).trailingComments = comments;
        return node;
      }
      ts3.setSyntheticTrailingComments = setSyntheticTrailingComments;
      function addSyntheticTrailingComment(node, kind, text, hasTrailingNewLine) {
        return setSyntheticTrailingComments(node, ts3.append(getSyntheticTrailingComments(node), { kind, pos: -1, end: -1, hasTrailingNewLine, text }));
      }
      ts3.addSyntheticTrailingComment = addSyntheticTrailingComment;
      function moveSyntheticComments(node, original) {
        setSyntheticLeadingComments(node, getSyntheticLeadingComments(original));
        setSyntheticTrailingComments(node, getSyntheticTrailingComments(original));
        var emit = getOrCreateEmitNode(original);
        emit.leadingComments = void 0;
        emit.trailingComments = void 0;
        return node;
      }
      ts3.moveSyntheticComments = moveSyntheticComments;
      function getConstantValue(node) {
        var _a2;
        return (_a2 = node.emitNode) === null || _a2 === void 0 ? void 0 : _a2.constantValue;
      }
      ts3.getConstantValue = getConstantValue;
      function setConstantValue(node, value) {
        var emitNode = getOrCreateEmitNode(node);
        emitNode.constantValue = value;
        return node;
      }
      ts3.setConstantValue = setConstantValue;
      function addEmitHelper(node, helper) {
        var emitNode = getOrCreateEmitNode(node);
        emitNode.helpers = ts3.append(emitNode.helpers, helper);
        return node;
      }
      ts3.addEmitHelper = addEmitHelper;
      function addEmitHelpers(node, helpers) {
        if (ts3.some(helpers)) {
          var emitNode = getOrCreateEmitNode(node);
          for (var _i = 0, helpers_2 = helpers; _i < helpers_2.length; _i++) {
            var helper = helpers_2[_i];
            emitNode.helpers = ts3.appendIfUnique(emitNode.helpers, helper);
          }
        }
        return node;
      }
      ts3.addEmitHelpers = addEmitHelpers;
      function removeEmitHelper(node, helper) {
        var _a2;
        var helpers = (_a2 = node.emitNode) === null || _a2 === void 0 ? void 0 : _a2.helpers;
        if (helpers) {
          return ts3.orderedRemoveItem(helpers, helper);
        }
        return false;
      }
      ts3.removeEmitHelper = removeEmitHelper;
      function getEmitHelpers(node) {
        var _a2;
        return (_a2 = node.emitNode) === null || _a2 === void 0 ? void 0 : _a2.helpers;
      }
      ts3.getEmitHelpers = getEmitHelpers;
      function moveEmitHelpers(source, target, predicate) {
        var sourceEmitNode = source.emitNode;
        var sourceEmitHelpers = sourceEmitNode && sourceEmitNode.helpers;
        if (!ts3.some(sourceEmitHelpers))
          return;
        var targetEmitNode = getOrCreateEmitNode(target);
        var helpersRemoved = 0;
        for (var i3 = 0; i3 < sourceEmitHelpers.length; i3++) {
          var helper = sourceEmitHelpers[i3];
          if (predicate(helper)) {
            helpersRemoved++;
            targetEmitNode.helpers = ts3.appendIfUnique(targetEmitNode.helpers, helper);
          } else if (helpersRemoved > 0) {
            sourceEmitHelpers[i3 - helpersRemoved] = helper;
          }
        }
        if (helpersRemoved > 0) {
          sourceEmitHelpers.length -= helpersRemoved;
        }
      }
      ts3.moveEmitHelpers = moveEmitHelpers;
      function ignoreSourceNewlines(node) {
        getOrCreateEmitNode(node).flags |= 134217728;
        return node;
      }
      ts3.ignoreSourceNewlines = ignoreSourceNewlines;
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      function createEmitHelperFactory(context) {
        var factory = context.factory;
        return {
          getUnscopedHelperName,
          createDecorateHelper,
          createMetadataHelper,
          createParamHelper,
          createAssignHelper,
          createAwaitHelper,
          createAsyncGeneratorHelper,
          createAsyncDelegatorHelper,
          createAsyncValuesHelper,
          createRestHelper,
          createAwaiterHelper,
          createExtendsHelper,
          createTemplateObjectHelper,
          createSpreadArrayHelper,
          createValuesHelper,
          createReadHelper,
          createGeneratorHelper,
          createCreateBindingHelper,
          createImportStarHelper,
          createImportStarCallbackHelper,
          createImportDefaultHelper,
          createExportStarHelper,
          createClassPrivateFieldGetHelper,
          createClassPrivateFieldSetHelper
        };
        function getUnscopedHelperName(name) {
          return ts3.setEmitFlags(factory.createIdentifier(name), 4096 | 2);
        }
        function createDecorateHelper(decoratorExpressions, target, memberName, descriptor) {
          context.requestEmitHelper(ts3.decorateHelper);
          var argumentsArray = [];
          argumentsArray.push(factory.createArrayLiteralExpression(decoratorExpressions, true));
          argumentsArray.push(target);
          if (memberName) {
            argumentsArray.push(memberName);
            if (descriptor) {
              argumentsArray.push(descriptor);
            }
          }
          return factory.createCallExpression(getUnscopedHelperName("__decorate"), void 0, argumentsArray);
        }
        function createMetadataHelper(metadataKey, metadataValue) {
          context.requestEmitHelper(ts3.metadataHelper);
          return factory.createCallExpression(getUnscopedHelperName("__metadata"), void 0, [
            factory.createStringLiteral(metadataKey),
            metadataValue
          ]);
        }
        function createParamHelper(expression, parameterOffset, location) {
          context.requestEmitHelper(ts3.paramHelper);
          return ts3.setTextRange(factory.createCallExpression(getUnscopedHelperName("__param"), void 0, [
            factory.createNumericLiteral(parameterOffset + ""),
            expression
          ]), location);
        }
        function createAssignHelper(attributesSegments) {
          if (context.getCompilerOptions().target >= 2) {
            return factory.createCallExpression(factory.createPropertyAccessExpression(factory.createIdentifier("Object"), "assign"), void 0, attributesSegments);
          }
          context.requestEmitHelper(ts3.assignHelper);
          return factory.createCallExpression(getUnscopedHelperName("__assign"), void 0, attributesSegments);
        }
        function createAwaitHelper(expression) {
          context.requestEmitHelper(ts3.awaitHelper);
          return factory.createCallExpression(getUnscopedHelperName("__await"), void 0, [expression]);
        }
        function createAsyncGeneratorHelper(generatorFunc, hasLexicalThis) {
          context.requestEmitHelper(ts3.awaitHelper);
          context.requestEmitHelper(ts3.asyncGeneratorHelper);
          (generatorFunc.emitNode || (generatorFunc.emitNode = {})).flags |= 262144 | 524288;
          return factory.createCallExpression(getUnscopedHelperName("__asyncGenerator"), void 0, [
            hasLexicalThis ? factory.createThis() : factory.createVoidZero(),
            factory.createIdentifier("arguments"),
            generatorFunc
          ]);
        }
        function createAsyncDelegatorHelper(expression) {
          context.requestEmitHelper(ts3.awaitHelper);
          context.requestEmitHelper(ts3.asyncDelegator);
          return factory.createCallExpression(getUnscopedHelperName("__asyncDelegator"), void 0, [expression]);
        }
        function createAsyncValuesHelper(expression) {
          context.requestEmitHelper(ts3.asyncValues);
          return factory.createCallExpression(getUnscopedHelperName("__asyncValues"), void 0, [expression]);
        }
        function createRestHelper(value, elements, computedTempVariables, location) {
          context.requestEmitHelper(ts3.restHelper);
          var propertyNames = [];
          var computedTempVariableOffset = 0;
          for (var i3 = 0; i3 < elements.length - 1; i3++) {
            var propertyName = ts3.getPropertyNameOfBindingOrAssignmentElement(elements[i3]);
            if (propertyName) {
              if (ts3.isComputedPropertyName(propertyName)) {
                ts3.Debug.assertIsDefined(computedTempVariables, "Encountered computed property name but 'computedTempVariables' argument was not provided.");
                var temp = computedTempVariables[computedTempVariableOffset];
                computedTempVariableOffset++;
                propertyNames.push(factory.createConditionalExpression(factory.createTypeCheck(temp, "symbol"), void 0, temp, void 0, factory.createAdd(temp, factory.createStringLiteral(""))));
              } else {
                propertyNames.push(factory.createStringLiteralFromNode(propertyName));
              }
            }
          }
          return factory.createCallExpression(getUnscopedHelperName("__rest"), void 0, [
            value,
            ts3.setTextRange(factory.createArrayLiteralExpression(propertyNames), location)
          ]);
        }
        function createAwaiterHelper(hasLexicalThis, hasLexicalArguments, promiseConstructor, body) {
          context.requestEmitHelper(ts3.awaiterHelper);
          var generatorFunc = factory.createFunctionExpression(void 0, factory.createToken(41), void 0, void 0, [], void 0, body);
          (generatorFunc.emitNode || (generatorFunc.emitNode = {})).flags |= 262144 | 524288;
          return factory.createCallExpression(getUnscopedHelperName("__awaiter"), void 0, [
            hasLexicalThis ? factory.createThis() : factory.createVoidZero(),
            hasLexicalArguments ? factory.createIdentifier("arguments") : factory.createVoidZero(),
            promiseConstructor ? ts3.createExpressionFromEntityName(factory, promiseConstructor) : factory.createVoidZero(),
            generatorFunc
          ]);
        }
        function createExtendsHelper(name) {
          context.requestEmitHelper(ts3.extendsHelper);
          return factory.createCallExpression(getUnscopedHelperName("__extends"), void 0, [name, factory.createUniqueName("_super", 16 | 32)]);
        }
        function createTemplateObjectHelper(cooked, raw) {
          context.requestEmitHelper(ts3.templateObjectHelper);
          return factory.createCallExpression(getUnscopedHelperName("__makeTemplateObject"), void 0, [cooked, raw]);
        }
        function createSpreadArrayHelper(to, from) {
          context.requestEmitHelper(ts3.spreadArrayHelper);
          return factory.createCallExpression(getUnscopedHelperName("__spreadArray"), void 0, [to, from]);
        }
        function createValuesHelper(expression) {
          context.requestEmitHelper(ts3.valuesHelper);
          return factory.createCallExpression(getUnscopedHelperName("__values"), void 0, [expression]);
        }
        function createReadHelper(iteratorRecord, count) {
          context.requestEmitHelper(ts3.readHelper);
          return factory.createCallExpression(getUnscopedHelperName("__read"), void 0, count !== void 0 ? [iteratorRecord, factory.createNumericLiteral(count + "")] : [iteratorRecord]);
        }
        function createGeneratorHelper(body) {
          context.requestEmitHelper(ts3.generatorHelper);
          return factory.createCallExpression(getUnscopedHelperName("__generator"), void 0, [factory.createThis(), body]);
        }
        function createCreateBindingHelper(module3, inputName, outputName) {
          context.requestEmitHelper(ts3.createBindingHelper);
          return factory.createCallExpression(getUnscopedHelperName("__createBinding"), void 0, __spreadArray([factory.createIdentifier("exports"), module3, inputName], outputName ? [outputName] : []));
        }
        function createImportStarHelper(expression) {
          context.requestEmitHelper(ts3.importStarHelper);
          return factory.createCallExpression(getUnscopedHelperName("__importStar"), void 0, [expression]);
        }
        function createImportStarCallbackHelper() {
          context.requestEmitHelper(ts3.importStarHelper);
          return getUnscopedHelperName("__importStar");
        }
        function createImportDefaultHelper(expression) {
          context.requestEmitHelper(ts3.importDefaultHelper);
          return factory.createCallExpression(getUnscopedHelperName("__importDefault"), void 0, [expression]);
        }
        function createExportStarHelper(moduleExpression, exportsExpression) {
          if (exportsExpression === void 0) {
            exportsExpression = factory.createIdentifier("exports");
          }
          context.requestEmitHelper(ts3.exportStarHelper);
          context.requestEmitHelper(ts3.createBindingHelper);
          return factory.createCallExpression(getUnscopedHelperName("__exportStar"), void 0, [moduleExpression, exportsExpression]);
        }
        function createClassPrivateFieldGetHelper(receiver, state, kind, f) {
          context.requestEmitHelper(ts3.classPrivateFieldGetHelper);
          var args;
          if (!f) {
            args = [receiver, state, factory.createStringLiteral(kind)];
          } else {
            args = [receiver, state, factory.createStringLiteral(kind), f];
          }
          return factory.createCallExpression(getUnscopedHelperName("__classPrivateFieldGet"), void 0, args);
        }
        function createClassPrivateFieldSetHelper(receiver, state, value, kind, f) {
          context.requestEmitHelper(ts3.classPrivateFieldSetHelper);
          var args;
          if (!f) {
            args = [receiver, state, value, factory.createStringLiteral(kind)];
          } else {
            args = [receiver, state, value, factory.createStringLiteral(kind), f];
          }
          return factory.createCallExpression(getUnscopedHelperName("__classPrivateFieldSet"), void 0, args);
        }
      }
      ts3.createEmitHelperFactory = createEmitHelperFactory;
      function compareEmitHelpers(x, y2) {
        if (x === y2)
          return 0;
        if (x.priority === y2.priority)
          return 0;
        if (x.priority === void 0)
          return 1;
        if (y2.priority === void 0)
          return -1;
        return ts3.compareValues(x.priority, y2.priority);
      }
      ts3.compareEmitHelpers = compareEmitHelpers;
      function helperString(input) {
        var args = [];
        for (var _i = 1; _i < arguments.length; _i++) {
          args[_i - 1] = arguments[_i];
        }
        return function(uniqueName) {
          var result2 = "";
          for (var i3 = 0; i3 < args.length; i3++) {
            result2 += input[i3];
            result2 += uniqueName(args[i3]);
          }
          result2 += input[input.length - 1];
          return result2;
        };
      }
      ts3.helperString = helperString;
      ts3.decorateHelper = {
        name: "typescript:decorate",
        importName: "__decorate",
        scoped: false,
        priority: 2,
        text: '\n            var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {\n                var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;\n                if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);\n                else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;\n                return c > 3 && r && Object.defineProperty(target, key, r), r;\n            };'
      };
      ts3.metadataHelper = {
        name: "typescript:metadata",
        importName: "__metadata",
        scoped: false,
        priority: 3,
        text: '\n            var __metadata = (this && this.__metadata) || function (k, v) {\n                if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);\n            };'
      };
      ts3.paramHelper = {
        name: "typescript:param",
        importName: "__param",
        scoped: false,
        priority: 4,
        text: "\n            var __param = (this && this.__param) || function (paramIndex, decorator) {\n                return function (target, key) { decorator(target, key, paramIndex); }\n            };"
      };
      ts3.assignHelper = {
        name: "typescript:assign",
        importName: "__assign",
        scoped: false,
        priority: 1,
        text: "\n            var __assign = (this && this.__assign) || function () {\n                __assign = Object.assign || function(t) {\n                    for (var s, i = 1, n = arguments.length; i < n; i++) {\n                        s = arguments[i];\n                        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))\n                            t[p] = s[p];\n                    }\n                    return t;\n                };\n                return __assign.apply(this, arguments);\n            };"
      };
      ts3.awaitHelper = {
        name: "typescript:await",
        importName: "__await",
        scoped: false,
        text: "\n            var __await = (this && this.__await) || function (v) { return this instanceof __await ? (this.v = v, this) : new __await(v); }"
      };
      ts3.asyncGeneratorHelper = {
        name: "typescript:asyncGenerator",
        importName: "__asyncGenerator",
        scoped: false,
        dependencies: [ts3.awaitHelper],
        text: '\n            var __asyncGenerator = (this && this.__asyncGenerator) || function (thisArg, _arguments, generator) {\n                if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");\n                var g = generator.apply(thisArg, _arguments || []), i, q = [];\n                return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;\n                function verb(n) { if (g[n]) i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }\n                function resume(n, v) { try { step(g[n](v)); } catch (e) { settle(q[0][3], e); } }\n                function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }\n                function fulfill(value) { resume("next", value); }\n                function reject(value) { resume("throw", value); }\n                function settle(f, v) { if (f(v), q.shift(), q.length) resume(q[0][0], q[0][1]); }\n            };'
      };
      ts3.asyncDelegator = {
        name: "typescript:asyncDelegator",
        importName: "__asyncDelegator",
        scoped: false,
        dependencies: [ts3.awaitHelper],
        text: '\n            var __asyncDelegator = (this && this.__asyncDelegator) || function (o) {\n                var i, p;\n                return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;\n                function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }\n            };'
      };
      ts3.asyncValues = {
        name: "typescript:asyncValues",
        importName: "__asyncValues",
        scoped: false,
        text: '\n            var __asyncValues = (this && this.__asyncValues) || function (o) {\n                if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");\n                var m = o[Symbol.asyncIterator], i;\n                return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);\n                function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }\n                function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }\n            };'
      };
      ts3.restHelper = {
        name: "typescript:rest",
        importName: "__rest",
        scoped: false,
        text: '\n            var __rest = (this && this.__rest) || function (s, e) {\n                var t = {};\n                for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)\n                    t[p] = s[p];\n                if (s != null && typeof Object.getOwnPropertySymbols === "function")\n                    for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {\n                        if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))\n                            t[p[i]] = s[p[i]];\n                    }\n                return t;\n            };'
      };
      ts3.awaiterHelper = {
        name: "typescript:awaiter",
        importName: "__awaiter",
        scoped: false,
        priority: 5,
        text: '\n            var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {\n                function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }\n                return new (P || (P = Promise))(function (resolve, reject) {\n                    function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }\n                    function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }\n                    function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }\n                    step((generator = generator.apply(thisArg, _arguments || [])).next());\n                });\n            };'
      };
      ts3.extendsHelper = {
        name: "typescript:extends",
        importName: "__extends",
        scoped: false,
        priority: 0,
        text: '\n            var __extends = (this && this.__extends) || (function () {\n                var extendStatics = function (d, b) {\n                    extendStatics = Object.setPrototypeOf ||\n                        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||\n                        function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };\n                    return extendStatics(d, b);\n                };\n\n                return function (d, b) {\n                    if (typeof b !== "function" && b !== null)\n                        throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");\n                    extendStatics(d, b);\n                    function __() { this.constructor = d; }\n                    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());\n                };\n            })();'
      };
      ts3.templateObjectHelper = {
        name: "typescript:makeTemplateObject",
        importName: "__makeTemplateObject",
        scoped: false,
        priority: 0,
        text: '\n            var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {\n                if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }\n                return cooked;\n            };'
      };
      ts3.readHelper = {
        name: "typescript:read",
        importName: "__read",
        scoped: false,
        text: '\n            var __read = (this && this.__read) || function (o, n) {\n                var m = typeof Symbol === "function" && o[Symbol.iterator];\n                if (!m) return o;\n                var i = m.call(o), r, ar = [], e;\n                try {\n                    while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);\n                }\n                catch (error) { e = { error: error }; }\n                finally {\n                    try {\n                        if (r && !r.done && (m = i["return"])) m.call(i);\n                    }\n                    finally { if (e) throw e.error; }\n                }\n                return ar;\n            };'
      };
      ts3.spreadArrayHelper = {
        name: "typescript:spreadArray",
        importName: "__spreadArray",
        scoped: false,
        text: "\n            var __spreadArray = (this && this.__spreadArray) || function (to, from) {\n                for (var i = 0, il = from.length, j = to.length; i < il; i++, j++)\n                    to[j] = from[i];\n                return to;\n            };"
      };
      ts3.valuesHelper = {
        name: "typescript:values",
        importName: "__values",
        scoped: false,
        text: '\n            var __values = (this && this.__values) || function(o) {\n                var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;\n                if (m) return m.call(o);\n                if (o && typeof o.length === "number") return {\n                    next: function () {\n                        if (o && i >= o.length) o = void 0;\n                        return { value: o && o[i++], done: !o };\n                    }\n                };\n                throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");\n            };'
      };
      ts3.generatorHelper = {
        name: "typescript:generator",
        importName: "__generator",
        scoped: false,
        priority: 6,
        text: '\n            var __generator = (this && this.__generator) || function (thisArg, body) {\n                var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;\n                return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;\n                function verb(n) { return function (v) { return step([n, v]); }; }\n                function step(op) {\n                    if (f) throw new TypeError("Generator is already executing.");\n                    while (_) try {\n                        if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;\n                        if (y = 0, t) op = [op[0] & 2, t.value];\n                        switch (op[0]) {\n                            case 0: case 1: t = op; break;\n                            case 4: _.label++; return { value: op[1], done: false };\n                            case 5: _.label++; y = op[1]; op = [0]; continue;\n                            case 7: op = _.ops.pop(); _.trys.pop(); continue;\n                            default:\n                                if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }\n                                if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }\n                                if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }\n                                if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }\n                                if (t[2]) _.ops.pop();\n                                _.trys.pop(); continue;\n                        }\n                        op = body.call(thisArg, _);\n                    } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }\n                    if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };\n                }\n            };'
      };
      ts3.createBindingHelper = {
        name: "typescript:commonjscreatebinding",
        importName: "__createBinding",
        scoped: false,
        priority: 1,
        text: "\n            var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {\n                if (k2 === undefined) k2 = k;\n                Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });\n            }) : (function(o, m, k, k2) {\n                if (k2 === undefined) k2 = k;\n                o[k2] = m[k];\n            }));"
      };
      ts3.setModuleDefaultHelper = {
        name: "typescript:commonjscreatevalue",
        importName: "__setModuleDefault",
        scoped: false,
        priority: 1,
        text: '\n            var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {\n                Object.defineProperty(o, "default", { enumerable: true, value: v });\n            }) : function(o, v) {\n                o["default"] = v;\n            });'
      };
      ts3.importStarHelper = {
        name: "typescript:commonjsimportstar",
        importName: "__importStar",
        scoped: false,
        dependencies: [ts3.createBindingHelper, ts3.setModuleDefaultHelper],
        priority: 2,
        text: '\n            var __importStar = (this && this.__importStar) || function (mod) {\n                if (mod && mod.__esModule) return mod;\n                var result = {};\n                if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);\n                __setModuleDefault(result, mod);\n                return result;\n            };'
      };
      ts3.importDefaultHelper = {
        name: "typescript:commonjsimportdefault",
        importName: "__importDefault",
        scoped: false,
        text: '\n            var __importDefault = (this && this.__importDefault) || function (mod) {\n                return (mod && mod.__esModule) ? mod : { "default": mod };\n            };'
      };
      ts3.exportStarHelper = {
        name: "typescript:export-star",
        importName: "__exportStar",
        scoped: false,
        dependencies: [ts3.createBindingHelper],
        priority: 2,
        text: '\n            var __exportStar = (this && this.__exportStar) || function(m, exports) {\n                for (var p in m) if (p !== "default" && !Object.prototype.hasOwnProperty.call(exports, p)) __createBinding(exports, m, p);\n            };'
      };
      ts3.classPrivateFieldGetHelper = {
        name: "typescript:classPrivateFieldGet",
        importName: "__classPrivateFieldGet",
        scoped: false,
        text: '\n            var __classPrivateFieldGet = (this && this.__classPrivateFieldGet) || function (receiver, state, kind, f) {\n                if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a getter");\n                if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot read private member from an object whose class did not declare it");\n                return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);\n            };'
      };
      ts3.classPrivateFieldSetHelper = {
        name: "typescript:classPrivateFieldSet",
        importName: "__classPrivateFieldSet",
        scoped: false,
        text: '\n            var __classPrivateFieldSet = (this && this.__classPrivateFieldSet) || function (receiver, state, value, kind, f) {\n                if (kind === "m") throw new TypeError("Private method is not writable");\n                if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a setter");\n                if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot write private member to an object whose class did not declare it");\n                return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;\n            };'
      };
      var allUnscopedEmitHelpers;
      function getAllUnscopedEmitHelpers() {
        return allUnscopedEmitHelpers || (allUnscopedEmitHelpers = ts3.arrayToMap([
          ts3.decorateHelper,
          ts3.metadataHelper,
          ts3.paramHelper,
          ts3.assignHelper,
          ts3.awaitHelper,
          ts3.asyncGeneratorHelper,
          ts3.asyncDelegator,
          ts3.asyncValues,
          ts3.restHelper,
          ts3.awaiterHelper,
          ts3.extendsHelper,
          ts3.templateObjectHelper,
          ts3.spreadArrayHelper,
          ts3.valuesHelper,
          ts3.readHelper,
          ts3.generatorHelper,
          ts3.importStarHelper,
          ts3.importDefaultHelper,
          ts3.exportStarHelper,
          ts3.classPrivateFieldGetHelper,
          ts3.classPrivateFieldSetHelper,
          ts3.createBindingHelper,
          ts3.setModuleDefaultHelper
        ], function(helper) {
          return helper.name;
        }));
      }
      ts3.getAllUnscopedEmitHelpers = getAllUnscopedEmitHelpers;
      ts3.asyncSuperHelper = {
        name: "typescript:async-super",
        scoped: true,
        text: helperString(__makeTemplateObject(["\n            const ", " = name => super[name];"], ["\n            const ", " = name => super[name];"]), "_superIndex")
      };
      ts3.advancedAsyncSuperHelper = {
        name: "typescript:advanced-async-super",
        scoped: true,
        text: helperString(__makeTemplateObject(["\n            const ", " = (function (geti, seti) {\n                const cache = Object.create(null);\n                return name => cache[name] || (cache[name] = { get value() { return geti(name); }, set value(v) { seti(name, v); } });\n            })(name => super[name], (name, value) => super[name] = value);"], ["\n            const ", " = (function (geti, seti) {\n                const cache = Object.create(null);\n                return name => cache[name] || (cache[name] = { get value() { return geti(name); }, set value(v) { seti(name, v); } });\n            })(name => super[name], (name, value) => super[name] = value);"]), "_superIndex")
      };
      function isCallToHelper(firstSegment, helperName) {
        return ts3.isCallExpression(firstSegment) && ts3.isIdentifier(firstSegment.expression) && ts3.getEmitFlags(firstSegment.expression) & 4096 && firstSegment.expression.escapedText === helperName;
      }
      ts3.isCallToHelper = isCallToHelper;
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      function isNumericLiteral(node) {
        return node.kind === 8;
      }
      ts3.isNumericLiteral = isNumericLiteral;
      function isBigIntLiteral(node) {
        return node.kind === 9;
      }
      ts3.isBigIntLiteral = isBigIntLiteral;
      function isStringLiteral(node) {
        return node.kind === 10;
      }
      ts3.isStringLiteral = isStringLiteral;
      function isJsxText(node) {
        return node.kind === 11;
      }
      ts3.isJsxText = isJsxText;
      function isRegularExpressionLiteral(node) {
        return node.kind === 13;
      }
      ts3.isRegularExpressionLiteral = isRegularExpressionLiteral;
      function isNoSubstitutionTemplateLiteral(node) {
        return node.kind === 14;
      }
      ts3.isNoSubstitutionTemplateLiteral = isNoSubstitutionTemplateLiteral;
      function isTemplateHead(node) {
        return node.kind === 15;
      }
      ts3.isTemplateHead = isTemplateHead;
      function isTemplateMiddle(node) {
        return node.kind === 16;
      }
      ts3.isTemplateMiddle = isTemplateMiddle;
      function isTemplateTail(node) {
        return node.kind === 17;
      }
      ts3.isTemplateTail = isTemplateTail;
      function isDotDotDotToken(node) {
        return node.kind === 25;
      }
      ts3.isDotDotDotToken = isDotDotDotToken;
      function isCommaToken(node) {
        return node.kind === 27;
      }
      ts3.isCommaToken = isCommaToken;
      function isPlusToken(node) {
        return node.kind === 39;
      }
      ts3.isPlusToken = isPlusToken;
      function isMinusToken(node) {
        return node.kind === 40;
      }
      ts3.isMinusToken = isMinusToken;
      function isAsteriskToken(node) {
        return node.kind === 41;
      }
      ts3.isAsteriskToken = isAsteriskToken;
      function isExclamationToken(node) {
        return node.kind === 53;
      }
      ts3.isExclamationToken = isExclamationToken;
      function isQuestionToken(node) {
        return node.kind === 57;
      }
      ts3.isQuestionToken = isQuestionToken;
      function isColonToken(node) {
        return node.kind === 58;
      }
      ts3.isColonToken = isColonToken;
      function isQuestionDotToken(node) {
        return node.kind === 28;
      }
      ts3.isQuestionDotToken = isQuestionDotToken;
      function isEqualsGreaterThanToken(node) {
        return node.kind === 38;
      }
      ts3.isEqualsGreaterThanToken = isEqualsGreaterThanToken;
      function isIdentifier(node) {
        return node.kind === 78;
      }
      ts3.isIdentifier = isIdentifier;
      function isPrivateIdentifier(node) {
        return node.kind === 79;
      }
      ts3.isPrivateIdentifier = isPrivateIdentifier;
      function isExportModifier(node) {
        return node.kind === 92;
      }
      ts3.isExportModifier = isExportModifier;
      function isAsyncModifier(node) {
        return node.kind === 129;
      }
      ts3.isAsyncModifier = isAsyncModifier;
      function isAssertsKeyword(node) {
        return node.kind === 127;
      }
      ts3.isAssertsKeyword = isAssertsKeyword;
      function isAwaitKeyword(node) {
        return node.kind === 130;
      }
      ts3.isAwaitKeyword = isAwaitKeyword;
      function isReadonlyKeyword(node) {
        return node.kind === 142;
      }
      ts3.isReadonlyKeyword = isReadonlyKeyword;
      function isStaticModifier(node) {
        return node.kind === 123;
      }
      ts3.isStaticModifier = isStaticModifier;
      function isSuperKeyword(node) {
        return node.kind === 105;
      }
      ts3.isSuperKeyword = isSuperKeyword;
      function isImportKeyword(node) {
        return node.kind === 99;
      }
      ts3.isImportKeyword = isImportKeyword;
      function isQualifiedName(node) {
        return node.kind === 158;
      }
      ts3.isQualifiedName = isQualifiedName;
      function isComputedPropertyName(node) {
        return node.kind === 159;
      }
      ts3.isComputedPropertyName = isComputedPropertyName;
      function isTypeParameterDeclaration(node) {
        return node.kind === 160;
      }
      ts3.isTypeParameterDeclaration = isTypeParameterDeclaration;
      function isParameter(node) {
        return node.kind === 161;
      }
      ts3.isParameter = isParameter;
      function isDecorator(node) {
        return node.kind === 162;
      }
      ts3.isDecorator = isDecorator;
      function isPropertySignature(node) {
        return node.kind === 163;
      }
      ts3.isPropertySignature = isPropertySignature;
      function isPropertyDeclaration(node) {
        return node.kind === 164;
      }
      ts3.isPropertyDeclaration = isPropertyDeclaration;
      function isMethodSignature(node) {
        return node.kind === 165;
      }
      ts3.isMethodSignature = isMethodSignature;
      function isMethodDeclaration(node) {
        return node.kind === 166;
      }
      ts3.isMethodDeclaration = isMethodDeclaration;
      function isConstructorDeclaration(node) {
        return node.kind === 167;
      }
      ts3.isConstructorDeclaration = isConstructorDeclaration;
      function isGetAccessorDeclaration(node) {
        return node.kind === 168;
      }
      ts3.isGetAccessorDeclaration = isGetAccessorDeclaration;
      function isSetAccessorDeclaration(node) {
        return node.kind === 169;
      }
      ts3.isSetAccessorDeclaration = isSetAccessorDeclaration;
      function isCallSignatureDeclaration(node) {
        return node.kind === 170;
      }
      ts3.isCallSignatureDeclaration = isCallSignatureDeclaration;
      function isConstructSignatureDeclaration(node) {
        return node.kind === 171;
      }
      ts3.isConstructSignatureDeclaration = isConstructSignatureDeclaration;
      function isIndexSignatureDeclaration(node) {
        return node.kind === 172;
      }
      ts3.isIndexSignatureDeclaration = isIndexSignatureDeclaration;
      function isTypePredicateNode(node) {
        return node.kind === 173;
      }
      ts3.isTypePredicateNode = isTypePredicateNode;
      function isTypeReferenceNode(node) {
        return node.kind === 174;
      }
      ts3.isTypeReferenceNode = isTypeReferenceNode;
      function isFunctionTypeNode(node) {
        return node.kind === 175;
      }
      ts3.isFunctionTypeNode = isFunctionTypeNode;
      function isConstructorTypeNode(node) {
        return node.kind === 176;
      }
      ts3.isConstructorTypeNode = isConstructorTypeNode;
      function isTypeQueryNode(node) {
        return node.kind === 177;
      }
      ts3.isTypeQueryNode = isTypeQueryNode;
      function isTypeLiteralNode(node) {
        return node.kind === 178;
      }
      ts3.isTypeLiteralNode = isTypeLiteralNode;
      function isArrayTypeNode(node) {
        return node.kind === 179;
      }
      ts3.isArrayTypeNode = isArrayTypeNode;
      function isTupleTypeNode(node) {
        return node.kind === 180;
      }
      ts3.isTupleTypeNode = isTupleTypeNode;
      function isNamedTupleMember(node) {
        return node.kind === 193;
      }
      ts3.isNamedTupleMember = isNamedTupleMember;
      function isOptionalTypeNode(node) {
        return node.kind === 181;
      }
      ts3.isOptionalTypeNode = isOptionalTypeNode;
      function isRestTypeNode(node) {
        return node.kind === 182;
      }
      ts3.isRestTypeNode = isRestTypeNode;
      function isUnionTypeNode(node) {
        return node.kind === 183;
      }
      ts3.isUnionTypeNode = isUnionTypeNode;
      function isIntersectionTypeNode(node) {
        return node.kind === 184;
      }
      ts3.isIntersectionTypeNode = isIntersectionTypeNode;
      function isConditionalTypeNode(node) {
        return node.kind === 185;
      }
      ts3.isConditionalTypeNode = isConditionalTypeNode;
      function isInferTypeNode(node) {
        return node.kind === 186;
      }
      ts3.isInferTypeNode = isInferTypeNode;
      function isParenthesizedTypeNode(node) {
        return node.kind === 187;
      }
      ts3.isParenthesizedTypeNode = isParenthesizedTypeNode;
      function isThisTypeNode(node) {
        return node.kind === 188;
      }
      ts3.isThisTypeNode = isThisTypeNode;
      function isTypeOperatorNode(node) {
        return node.kind === 189;
      }
      ts3.isTypeOperatorNode = isTypeOperatorNode;
      function isIndexedAccessTypeNode(node) {
        return node.kind === 190;
      }
      ts3.isIndexedAccessTypeNode = isIndexedAccessTypeNode;
      function isMappedTypeNode(node) {
        return node.kind === 191;
      }
      ts3.isMappedTypeNode = isMappedTypeNode;
      function isLiteralTypeNode(node) {
        return node.kind === 192;
      }
      ts3.isLiteralTypeNode = isLiteralTypeNode;
      function isImportTypeNode(node) {
        return node.kind === 196;
      }
      ts3.isImportTypeNode = isImportTypeNode;
      function isTemplateLiteralTypeSpan(node) {
        return node.kind === 195;
      }
      ts3.isTemplateLiteralTypeSpan = isTemplateLiteralTypeSpan;
      function isTemplateLiteralTypeNode(node) {
        return node.kind === 194;
      }
      ts3.isTemplateLiteralTypeNode = isTemplateLiteralTypeNode;
      function isObjectBindingPattern(node) {
        return node.kind === 197;
      }
      ts3.isObjectBindingPattern = isObjectBindingPattern;
      function isArrayBindingPattern(node) {
        return node.kind === 198;
      }
      ts3.isArrayBindingPattern = isArrayBindingPattern;
      function isBindingElement(node) {
        return node.kind === 199;
      }
      ts3.isBindingElement = isBindingElement;
      function isArrayLiteralExpression(node) {
        return node.kind === 200;
      }
      ts3.isArrayLiteralExpression = isArrayLiteralExpression;
      function isObjectLiteralExpression(node) {
        return node.kind === 201;
      }
      ts3.isObjectLiteralExpression = isObjectLiteralExpression;
      function isPropertyAccessExpression(node) {
        return node.kind === 202;
      }
      ts3.isPropertyAccessExpression = isPropertyAccessExpression;
      function isElementAccessExpression(node) {
        return node.kind === 203;
      }
      ts3.isElementAccessExpression = isElementAccessExpression;
      function isCallExpression(node) {
        return node.kind === 204;
      }
      ts3.isCallExpression = isCallExpression;
      function isNewExpression(node) {
        return node.kind === 205;
      }
      ts3.isNewExpression = isNewExpression;
      function isTaggedTemplateExpression(node) {
        return node.kind === 206;
      }
      ts3.isTaggedTemplateExpression = isTaggedTemplateExpression;
      function isTypeAssertionExpression(node) {
        return node.kind === 207;
      }
      ts3.isTypeAssertionExpression = isTypeAssertionExpression;
      function isParenthesizedExpression(node) {
        return node.kind === 208;
      }
      ts3.isParenthesizedExpression = isParenthesizedExpression;
      function isFunctionExpression(node) {
        return node.kind === 209;
      }
      ts3.isFunctionExpression = isFunctionExpression;
      function isArrowFunction(node) {
        return node.kind === 210;
      }
      ts3.isArrowFunction = isArrowFunction;
      function isDeleteExpression(node) {
        return node.kind === 211;
      }
      ts3.isDeleteExpression = isDeleteExpression;
      function isTypeOfExpression(node) {
        return node.kind === 212;
      }
      ts3.isTypeOfExpression = isTypeOfExpression;
      function isVoidExpression(node) {
        return node.kind === 213;
      }
      ts3.isVoidExpression = isVoidExpression;
      function isAwaitExpression(node) {
        return node.kind === 214;
      }
      ts3.isAwaitExpression = isAwaitExpression;
      function isPrefixUnaryExpression(node) {
        return node.kind === 215;
      }
      ts3.isPrefixUnaryExpression = isPrefixUnaryExpression;
      function isPostfixUnaryExpression(node) {
        return node.kind === 216;
      }
      ts3.isPostfixUnaryExpression = isPostfixUnaryExpression;
      function isBinaryExpression(node) {
        return node.kind === 217;
      }
      ts3.isBinaryExpression = isBinaryExpression;
      function isConditionalExpression(node) {
        return node.kind === 218;
      }
      ts3.isConditionalExpression = isConditionalExpression;
      function isTemplateExpression(node) {
        return node.kind === 219;
      }
      ts3.isTemplateExpression = isTemplateExpression;
      function isYieldExpression(node) {
        return node.kind === 220;
      }
      ts3.isYieldExpression = isYieldExpression;
      function isSpreadElement(node) {
        return node.kind === 221;
      }
      ts3.isSpreadElement = isSpreadElement;
      function isClassExpression(node) {
        return node.kind === 222;
      }
      ts3.isClassExpression = isClassExpression;
      function isOmittedExpression(node) {
        return node.kind === 223;
      }
      ts3.isOmittedExpression = isOmittedExpression;
      function isExpressionWithTypeArguments(node) {
        return node.kind === 224;
      }
      ts3.isExpressionWithTypeArguments = isExpressionWithTypeArguments;
      function isAsExpression(node) {
        return node.kind === 225;
      }
      ts3.isAsExpression = isAsExpression;
      function isNonNullExpression(node) {
        return node.kind === 226;
      }
      ts3.isNonNullExpression = isNonNullExpression;
      function isMetaProperty(node) {
        return node.kind === 227;
      }
      ts3.isMetaProperty = isMetaProperty;
      function isSyntheticExpression(node) {
        return node.kind === 228;
      }
      ts3.isSyntheticExpression = isSyntheticExpression;
      function isPartiallyEmittedExpression(node) {
        return node.kind === 340;
      }
      ts3.isPartiallyEmittedExpression = isPartiallyEmittedExpression;
      function isCommaListExpression(node) {
        return node.kind === 341;
      }
      ts3.isCommaListExpression = isCommaListExpression;
      function isTemplateSpan(node) {
        return node.kind === 229;
      }
      ts3.isTemplateSpan = isTemplateSpan;
      function isSemicolonClassElement(node) {
        return node.kind === 230;
      }
      ts3.isSemicolonClassElement = isSemicolonClassElement;
      function isBlock(node) {
        return node.kind === 231;
      }
      ts3.isBlock = isBlock;
      function isVariableStatement(node) {
        return node.kind === 233;
      }
      ts3.isVariableStatement = isVariableStatement;
      function isEmptyStatement(node) {
        return node.kind === 232;
      }
      ts3.isEmptyStatement = isEmptyStatement;
      function isExpressionStatement(node) {
        return node.kind === 234;
      }
      ts3.isExpressionStatement = isExpressionStatement;
      function isIfStatement(node) {
        return node.kind === 235;
      }
      ts3.isIfStatement = isIfStatement;
      function isDoStatement(node) {
        return node.kind === 236;
      }
      ts3.isDoStatement = isDoStatement;
      function isWhileStatement(node) {
        return node.kind === 237;
      }
      ts3.isWhileStatement = isWhileStatement;
      function isForStatement(node) {
        return node.kind === 238;
      }
      ts3.isForStatement = isForStatement;
      function isForInStatement(node) {
        return node.kind === 239;
      }
      ts3.isForInStatement = isForInStatement;
      function isForOfStatement(node) {
        return node.kind === 240;
      }
      ts3.isForOfStatement = isForOfStatement;
      function isContinueStatement(node) {
        return node.kind === 241;
      }
      ts3.isContinueStatement = isContinueStatement;
      function isBreakStatement(node) {
        return node.kind === 242;
      }
      ts3.isBreakStatement = isBreakStatement;
      function isReturnStatement(node) {
        return node.kind === 243;
      }
      ts3.isReturnStatement = isReturnStatement;
      function isWithStatement(node) {
        return node.kind === 244;
      }
      ts3.isWithStatement = isWithStatement;
      function isSwitchStatement(node) {
        return node.kind === 245;
      }
      ts3.isSwitchStatement = isSwitchStatement;
      function isLabeledStatement(node) {
        return node.kind === 246;
      }
      ts3.isLabeledStatement = isLabeledStatement;
      function isThrowStatement(node) {
        return node.kind === 247;
      }
      ts3.isThrowStatement = isThrowStatement;
      function isTryStatement(node) {
        return node.kind === 248;
      }
      ts3.isTryStatement = isTryStatement;
      function isDebuggerStatement(node) {
        return node.kind === 249;
      }
      ts3.isDebuggerStatement = isDebuggerStatement;
      function isVariableDeclaration(node) {
        return node.kind === 250;
      }
      ts3.isVariableDeclaration = isVariableDeclaration;
      function isVariableDeclarationList(node) {
        return node.kind === 251;
      }
      ts3.isVariableDeclarationList = isVariableDeclarationList;
      function isFunctionDeclaration(node) {
        return node.kind === 252;
      }
      ts3.isFunctionDeclaration = isFunctionDeclaration;
      function isClassDeclaration(node) {
        return node.kind === 253;
      }
      ts3.isClassDeclaration = isClassDeclaration;
      function isInterfaceDeclaration(node) {
        return node.kind === 254;
      }
      ts3.isInterfaceDeclaration = isInterfaceDeclaration;
      function isTypeAliasDeclaration(node) {
        return node.kind === 255;
      }
      ts3.isTypeAliasDeclaration = isTypeAliasDeclaration;
      function isEnumDeclaration(node) {
        return node.kind === 256;
      }
      ts3.isEnumDeclaration = isEnumDeclaration;
      function isModuleDeclaration(node) {
        return node.kind === 257;
      }
      ts3.isModuleDeclaration = isModuleDeclaration;
      function isModuleBlock(node) {
        return node.kind === 258;
      }
      ts3.isModuleBlock = isModuleBlock;
      function isCaseBlock(node) {
        return node.kind === 259;
      }
      ts3.isCaseBlock = isCaseBlock;
      function isNamespaceExportDeclaration(node) {
        return node.kind === 260;
      }
      ts3.isNamespaceExportDeclaration = isNamespaceExportDeclaration;
      function isImportEqualsDeclaration(node) {
        return node.kind === 261;
      }
      ts3.isImportEqualsDeclaration = isImportEqualsDeclaration;
      function isImportDeclaration(node) {
        return node.kind === 262;
      }
      ts3.isImportDeclaration = isImportDeclaration;
      function isImportClause(node) {
        return node.kind === 263;
      }
      ts3.isImportClause = isImportClause;
      function isNamespaceImport(node) {
        return node.kind === 264;
      }
      ts3.isNamespaceImport = isNamespaceImport;
      function isNamespaceExport(node) {
        return node.kind === 270;
      }
      ts3.isNamespaceExport = isNamespaceExport;
      function isNamedImports(node) {
        return node.kind === 265;
      }
      ts3.isNamedImports = isNamedImports;
      function isImportSpecifier(node) {
        return node.kind === 266;
      }
      ts3.isImportSpecifier = isImportSpecifier;
      function isExportAssignment(node) {
        return node.kind === 267;
      }
      ts3.isExportAssignment = isExportAssignment;
      function isExportDeclaration(node) {
        return node.kind === 268;
      }
      ts3.isExportDeclaration = isExportDeclaration;
      function isNamedExports(node) {
        return node.kind === 269;
      }
      ts3.isNamedExports = isNamedExports;
      function isExportSpecifier(node) {
        return node.kind === 271;
      }
      ts3.isExportSpecifier = isExportSpecifier;
      function isMissingDeclaration(node) {
        return node.kind === 272;
      }
      ts3.isMissingDeclaration = isMissingDeclaration;
      function isNotEmittedStatement(node) {
        return node.kind === 339;
      }
      ts3.isNotEmittedStatement = isNotEmittedStatement;
      function isSyntheticReference(node) {
        return node.kind === 344;
      }
      ts3.isSyntheticReference = isSyntheticReference;
      function isMergeDeclarationMarker(node) {
        return node.kind === 342;
      }
      ts3.isMergeDeclarationMarker = isMergeDeclarationMarker;
      function isEndOfDeclarationMarker(node) {
        return node.kind === 343;
      }
      ts3.isEndOfDeclarationMarker = isEndOfDeclarationMarker;
      function isExternalModuleReference(node) {
        return node.kind === 273;
      }
      ts3.isExternalModuleReference = isExternalModuleReference;
      function isJsxElement(node) {
        return node.kind === 274;
      }
      ts3.isJsxElement = isJsxElement;
      function isJsxSelfClosingElement(node) {
        return node.kind === 275;
      }
      ts3.isJsxSelfClosingElement = isJsxSelfClosingElement;
      function isJsxOpeningElement(node) {
        return node.kind === 276;
      }
      ts3.isJsxOpeningElement = isJsxOpeningElement;
      function isJsxClosingElement(node) {
        return node.kind === 277;
      }
      ts3.isJsxClosingElement = isJsxClosingElement;
      function isJsxFragment(node) {
        return node.kind === 278;
      }
      ts3.isJsxFragment = isJsxFragment;
      function isJsxOpeningFragment(node) {
        return node.kind === 279;
      }
      ts3.isJsxOpeningFragment = isJsxOpeningFragment;
      function isJsxClosingFragment(node) {
        return node.kind === 280;
      }
      ts3.isJsxClosingFragment = isJsxClosingFragment;
      function isJsxAttribute(node) {
        return node.kind === 281;
      }
      ts3.isJsxAttribute = isJsxAttribute;
      function isJsxAttributes(node) {
        return node.kind === 282;
      }
      ts3.isJsxAttributes = isJsxAttributes;
      function isJsxSpreadAttribute(node) {
        return node.kind === 283;
      }
      ts3.isJsxSpreadAttribute = isJsxSpreadAttribute;
      function isJsxExpression(node) {
        return node.kind === 284;
      }
      ts3.isJsxExpression = isJsxExpression;
      function isCaseClause(node) {
        return node.kind === 285;
      }
      ts3.isCaseClause = isCaseClause;
      function isDefaultClause(node) {
        return node.kind === 286;
      }
      ts3.isDefaultClause = isDefaultClause;
      function isHeritageClause(node) {
        return node.kind === 287;
      }
      ts3.isHeritageClause = isHeritageClause;
      function isCatchClause(node) {
        return node.kind === 288;
      }
      ts3.isCatchClause = isCatchClause;
      function isPropertyAssignment(node) {
        return node.kind === 289;
      }
      ts3.isPropertyAssignment = isPropertyAssignment;
      function isShorthandPropertyAssignment(node) {
        return node.kind === 290;
      }
      ts3.isShorthandPropertyAssignment = isShorthandPropertyAssignment;
      function isSpreadAssignment(node) {
        return node.kind === 291;
      }
      ts3.isSpreadAssignment = isSpreadAssignment;
      function isEnumMember(node) {
        return node.kind === 292;
      }
      ts3.isEnumMember = isEnumMember;
      function isUnparsedPrepend(node) {
        return node.kind === 294;
      }
      ts3.isUnparsedPrepend = isUnparsedPrepend;
      function isSourceFile(node) {
        return node.kind === 298;
      }
      ts3.isSourceFile = isSourceFile;
      function isBundle(node) {
        return node.kind === 299;
      }
      ts3.isBundle = isBundle;
      function isUnparsedSource(node) {
        return node.kind === 300;
      }
      ts3.isUnparsedSource = isUnparsedSource;
      function isJSDocTypeExpression(node) {
        return node.kind === 302;
      }
      ts3.isJSDocTypeExpression = isJSDocTypeExpression;
      function isJSDocNameReference(node) {
        return node.kind === 303;
      }
      ts3.isJSDocNameReference = isJSDocNameReference;
      function isJSDocLink(node) {
        return node.kind === 316;
      }
      ts3.isJSDocLink = isJSDocLink;
      function isJSDocAllType(node) {
        return node.kind === 304;
      }
      ts3.isJSDocAllType = isJSDocAllType;
      function isJSDocUnknownType(node) {
        return node.kind === 305;
      }
      ts3.isJSDocUnknownType = isJSDocUnknownType;
      function isJSDocNullableType(node) {
        return node.kind === 306;
      }
      ts3.isJSDocNullableType = isJSDocNullableType;
      function isJSDocNonNullableType(node) {
        return node.kind === 307;
      }
      ts3.isJSDocNonNullableType = isJSDocNonNullableType;
      function isJSDocOptionalType(node) {
        return node.kind === 308;
      }
      ts3.isJSDocOptionalType = isJSDocOptionalType;
      function isJSDocFunctionType(node) {
        return node.kind === 309;
      }
      ts3.isJSDocFunctionType = isJSDocFunctionType;
      function isJSDocVariadicType(node) {
        return node.kind === 310;
      }
      ts3.isJSDocVariadicType = isJSDocVariadicType;
      function isJSDocNamepathType(node) {
        return node.kind === 311;
      }
      ts3.isJSDocNamepathType = isJSDocNamepathType;
      function isJSDoc(node) {
        return node.kind === 312;
      }
      ts3.isJSDoc = isJSDoc;
      function isJSDocTypeLiteral(node) {
        return node.kind === 314;
      }
      ts3.isJSDocTypeLiteral = isJSDocTypeLiteral;
      function isJSDocSignature(node) {
        return node.kind === 315;
      }
      ts3.isJSDocSignature = isJSDocSignature;
      function isJSDocAugmentsTag(node) {
        return node.kind === 318;
      }
      ts3.isJSDocAugmentsTag = isJSDocAugmentsTag;
      function isJSDocAuthorTag(node) {
        return node.kind === 320;
      }
      ts3.isJSDocAuthorTag = isJSDocAuthorTag;
      function isJSDocClassTag(node) {
        return node.kind === 322;
      }
      ts3.isJSDocClassTag = isJSDocClassTag;
      function isJSDocCallbackTag(node) {
        return node.kind === 328;
      }
      ts3.isJSDocCallbackTag = isJSDocCallbackTag;
      function isJSDocPublicTag(node) {
        return node.kind === 323;
      }
      ts3.isJSDocPublicTag = isJSDocPublicTag;
      function isJSDocPrivateTag(node) {
        return node.kind === 324;
      }
      ts3.isJSDocPrivateTag = isJSDocPrivateTag;
      function isJSDocProtectedTag(node) {
        return node.kind === 325;
      }
      ts3.isJSDocProtectedTag = isJSDocProtectedTag;
      function isJSDocReadonlyTag(node) {
        return node.kind === 326;
      }
      ts3.isJSDocReadonlyTag = isJSDocReadonlyTag;
      function isJSDocOverrideTag(node) {
        return node.kind === 327;
      }
      ts3.isJSDocOverrideTag = isJSDocOverrideTag;
      function isJSDocDeprecatedTag(node) {
        return node.kind === 321;
      }
      ts3.isJSDocDeprecatedTag = isJSDocDeprecatedTag;
      function isJSDocSeeTag(node) {
        return node.kind === 336;
      }
      ts3.isJSDocSeeTag = isJSDocSeeTag;
      function isJSDocEnumTag(node) {
        return node.kind === 329;
      }
      ts3.isJSDocEnumTag = isJSDocEnumTag;
      function isJSDocParameterTag(node) {
        return node.kind === 330;
      }
      ts3.isJSDocParameterTag = isJSDocParameterTag;
      function isJSDocReturnTag(node) {
        return node.kind === 331;
      }
      ts3.isJSDocReturnTag = isJSDocReturnTag;
      function isJSDocThisTag(node) {
        return node.kind === 332;
      }
      ts3.isJSDocThisTag = isJSDocThisTag;
      function isJSDocTypeTag(node) {
        return node.kind === 333;
      }
      ts3.isJSDocTypeTag = isJSDocTypeTag;
      function isJSDocTemplateTag(node) {
        return node.kind === 334;
      }
      ts3.isJSDocTemplateTag = isJSDocTemplateTag;
      function isJSDocTypedefTag(node) {
        return node.kind === 335;
      }
      ts3.isJSDocTypedefTag = isJSDocTypedefTag;
      function isJSDocUnknownTag(node) {
        return node.kind === 317;
      }
      ts3.isJSDocUnknownTag = isJSDocUnknownTag;
      function isJSDocPropertyTag(node) {
        return node.kind === 337;
      }
      ts3.isJSDocPropertyTag = isJSDocPropertyTag;
      function isJSDocImplementsTag(node) {
        return node.kind === 319;
      }
      ts3.isJSDocImplementsTag = isJSDocImplementsTag;
      function isSyntaxList(n2) {
        return n2.kind === 338;
      }
      ts3.isSyntaxList = isSyntaxList;
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      function createEmptyExports(factory) {
        return factory.createExportDeclaration(void 0, void 0, false, factory.createNamedExports([]), void 0);
      }
      ts3.createEmptyExports = createEmptyExports;
      function createMemberAccessForPropertyName(factory, target, memberName, location) {
        if (ts3.isComputedPropertyName(memberName)) {
          return ts3.setTextRange(factory.createElementAccessExpression(target, memberName.expression), location);
        } else {
          var expression = ts3.setTextRange(ts3.isMemberName(memberName) ? factory.createPropertyAccessExpression(target, memberName) : factory.createElementAccessExpression(target, memberName), memberName);
          ts3.getOrCreateEmitNode(expression).flags |= 64;
          return expression;
        }
      }
      ts3.createMemberAccessForPropertyName = createMemberAccessForPropertyName;
      function createReactNamespace(reactNamespace, parent) {
        var react = ts3.parseNodeFactory.createIdentifier(reactNamespace || "React");
        ts3.setParent(react, ts3.getParseTreeNode(parent));
        return react;
      }
      function createJsxFactoryExpressionFromEntityName(factory, jsxFactory, parent) {
        if (ts3.isQualifiedName(jsxFactory)) {
          var left = createJsxFactoryExpressionFromEntityName(factory, jsxFactory.left, parent);
          var right = factory.createIdentifier(ts3.idText(jsxFactory.right));
          right.escapedText = jsxFactory.right.escapedText;
          return factory.createPropertyAccessExpression(left, right);
        } else {
          return createReactNamespace(ts3.idText(jsxFactory), parent);
        }
      }
      function createJsxFactoryExpression(factory, jsxFactoryEntity, reactNamespace, parent) {
        return jsxFactoryEntity ? createJsxFactoryExpressionFromEntityName(factory, jsxFactoryEntity, parent) : factory.createPropertyAccessExpression(createReactNamespace(reactNamespace, parent), "createElement");
      }
      ts3.createJsxFactoryExpression = createJsxFactoryExpression;
      function createJsxFragmentFactoryExpression(factory, jsxFragmentFactoryEntity, reactNamespace, parent) {
        return jsxFragmentFactoryEntity ? createJsxFactoryExpressionFromEntityName(factory, jsxFragmentFactoryEntity, parent) : factory.createPropertyAccessExpression(createReactNamespace(reactNamespace, parent), "Fragment");
      }
      function createExpressionForJsxElement(factory, callee, tagName, props, children, location) {
        var argumentsList = [tagName];
        if (props) {
          argumentsList.push(props);
        }
        if (children && children.length > 0) {
          if (!props) {
            argumentsList.push(factory.createNull());
          }
          if (children.length > 1) {
            for (var _i = 0, children_3 = children; _i < children_3.length; _i++) {
              var child = children_3[_i];
              startOnNewLine(child);
              argumentsList.push(child);
            }
          } else {
            argumentsList.push(children[0]);
          }
        }
        return ts3.setTextRange(factory.createCallExpression(callee, void 0, argumentsList), location);
      }
      ts3.createExpressionForJsxElement = createExpressionForJsxElement;
      function createExpressionForJsxFragment(factory, jsxFactoryEntity, jsxFragmentFactoryEntity, reactNamespace, children, parentElement, location) {
        var tagName = createJsxFragmentFactoryExpression(factory, jsxFragmentFactoryEntity, reactNamespace, parentElement);
        var argumentsList = [tagName, factory.createNull()];
        if (children && children.length > 0) {
          if (children.length > 1) {
            for (var _i = 0, children_4 = children; _i < children_4.length; _i++) {
              var child = children_4[_i];
              startOnNewLine(child);
              argumentsList.push(child);
            }
          } else {
            argumentsList.push(children[0]);
          }
        }
        return ts3.setTextRange(factory.createCallExpression(createJsxFactoryExpression(factory, jsxFactoryEntity, reactNamespace, parentElement), void 0, argumentsList), location);
      }
      ts3.createExpressionForJsxFragment = createExpressionForJsxFragment;
      function createForOfBindingStatement(factory, node, boundValue) {
        if (ts3.isVariableDeclarationList(node)) {
          var firstDeclaration = ts3.first(node.declarations);
          var updatedDeclaration = factory.updateVariableDeclaration(firstDeclaration, firstDeclaration.name, void 0, void 0, boundValue);
          return ts3.setTextRange(factory.createVariableStatement(void 0, factory.updateVariableDeclarationList(node, [updatedDeclaration])), node);
        } else {
          var updatedExpression = ts3.setTextRange(factory.createAssignment(node, boundValue), node);
          return ts3.setTextRange(factory.createExpressionStatement(updatedExpression), node);
        }
      }
      ts3.createForOfBindingStatement = createForOfBindingStatement;
      function insertLeadingStatement(factory, dest, source) {
        if (ts3.isBlock(dest)) {
          return factory.updateBlock(dest, ts3.setTextRange(factory.createNodeArray(__spreadArray([source], dest.statements)), dest.statements));
        } else {
          return factory.createBlock(factory.createNodeArray([dest, source]), true);
        }
      }
      ts3.insertLeadingStatement = insertLeadingStatement;
      function createExpressionFromEntityName(factory, node) {
        if (ts3.isQualifiedName(node)) {
          var left = createExpressionFromEntityName(factory, node.left);
          var right = ts3.setParent(ts3.setTextRange(factory.cloneNode(node.right), node.right), node.right.parent);
          return ts3.setTextRange(factory.createPropertyAccessExpression(left, right), node);
        } else {
          return ts3.setParent(ts3.setTextRange(factory.cloneNode(node), node), node.parent);
        }
      }
      ts3.createExpressionFromEntityName = createExpressionFromEntityName;
      function createExpressionForPropertyName(factory, memberName) {
        if (ts3.isIdentifier(memberName)) {
          return factory.createStringLiteralFromNode(memberName);
        } else if (ts3.isComputedPropertyName(memberName)) {
          return ts3.setParent(ts3.setTextRange(factory.cloneNode(memberName.expression), memberName.expression), memberName.expression.parent);
        } else {
          return ts3.setParent(ts3.setTextRange(factory.cloneNode(memberName), memberName), memberName.parent);
        }
      }
      ts3.createExpressionForPropertyName = createExpressionForPropertyName;
      function createExpressionForAccessorDeclaration(factory, properties, property, receiver, multiLine) {
        var _a2 = ts3.getAllAccessorDeclarations(properties, property), firstAccessor = _a2.firstAccessor, getAccessor = _a2.getAccessor, setAccessor = _a2.setAccessor;
        if (property === firstAccessor) {
          return ts3.setTextRange(factory.createObjectDefinePropertyCall(receiver, createExpressionForPropertyName(factory, property.name), factory.createPropertyDescriptor({
            enumerable: factory.createFalse(),
            configurable: true,
            get: getAccessor && ts3.setTextRange(ts3.setOriginalNode(factory.createFunctionExpression(getAccessor.modifiers, void 0, void 0, void 0, getAccessor.parameters, void 0, getAccessor.body), getAccessor), getAccessor),
            set: setAccessor && ts3.setTextRange(ts3.setOriginalNode(factory.createFunctionExpression(setAccessor.modifiers, void 0, void 0, void 0, setAccessor.parameters, void 0, setAccessor.body), setAccessor), setAccessor)
          }, !multiLine)), firstAccessor);
        }
        return void 0;
      }
      function createExpressionForPropertyAssignment(factory, property, receiver) {
        return ts3.setOriginalNode(ts3.setTextRange(factory.createAssignment(createMemberAccessForPropertyName(factory, receiver, property.name, property.name), property.initializer), property), property);
      }
      function createExpressionForShorthandPropertyAssignment(factory, property, receiver) {
        return ts3.setOriginalNode(ts3.setTextRange(factory.createAssignment(createMemberAccessForPropertyName(factory, receiver, property.name, property.name), factory.cloneNode(property.name)), property), property);
      }
      function createExpressionForMethodDeclaration(factory, method, receiver) {
        return ts3.setOriginalNode(ts3.setTextRange(factory.createAssignment(createMemberAccessForPropertyName(factory, receiver, method.name, method.name), ts3.setOriginalNode(ts3.setTextRange(factory.createFunctionExpression(method.modifiers, method.asteriskToken, void 0, void 0, method.parameters, void 0, method.body), method), method)), method), method);
      }
      function createExpressionForObjectLiteralElementLike(factory, node, property, receiver) {
        if (property.name && ts3.isPrivateIdentifier(property.name)) {
          ts3.Debug.failBadSyntaxKind(property.name, "Private identifiers are not allowed in object literals.");
        }
        switch (property.kind) {
          case 168:
          case 169:
            return createExpressionForAccessorDeclaration(factory, node.properties, property, receiver, !!node.multiLine);
          case 289:
            return createExpressionForPropertyAssignment(factory, property, receiver);
          case 290:
            return createExpressionForShorthandPropertyAssignment(factory, property, receiver);
          case 166:
            return createExpressionForMethodDeclaration(factory, property, receiver);
        }
      }
      ts3.createExpressionForObjectLiteralElementLike = createExpressionForObjectLiteralElementLike;
      function isInternalName(node) {
        return (ts3.getEmitFlags(node) & 32768) !== 0;
      }
      ts3.isInternalName = isInternalName;
      function isLocalName(node) {
        return (ts3.getEmitFlags(node) & 16384) !== 0;
      }
      ts3.isLocalName = isLocalName;
      function isExportName(node) {
        return (ts3.getEmitFlags(node) & 8192) !== 0;
      }
      ts3.isExportName = isExportName;
      function isUseStrictPrologue(node) {
        return ts3.isStringLiteral(node.expression) && node.expression.text === "use strict";
      }
      function findUseStrictPrologue(statements) {
        for (var _i = 0, statements_1 = statements; _i < statements_1.length; _i++) {
          var statement = statements_1[_i];
          if (ts3.isPrologueDirective(statement)) {
            if (isUseStrictPrologue(statement)) {
              return statement;
            }
          } else {
            break;
          }
        }
        return void 0;
      }
      ts3.findUseStrictPrologue = findUseStrictPrologue;
      function startsWithUseStrict(statements) {
        var firstStatement = ts3.firstOrUndefined(statements);
        return firstStatement !== void 0 && ts3.isPrologueDirective(firstStatement) && isUseStrictPrologue(firstStatement);
      }
      ts3.startsWithUseStrict = startsWithUseStrict;
      function isCommaSequence(node) {
        return node.kind === 217 && node.operatorToken.kind === 27 || node.kind === 341;
      }
      ts3.isCommaSequence = isCommaSequence;
      function isOuterExpression(node, kinds) {
        if (kinds === void 0) {
          kinds = 15;
        }
        switch (node.kind) {
          case 208:
            return (kinds & 1) !== 0;
          case 207:
          case 225:
            return (kinds & 2) !== 0;
          case 226:
            return (kinds & 4) !== 0;
          case 340:
            return (kinds & 8) !== 0;
        }
        return false;
      }
      ts3.isOuterExpression = isOuterExpression;
      function skipOuterExpressions(node, kinds) {
        if (kinds === void 0) {
          kinds = 15;
        }
        while (isOuterExpression(node, kinds)) {
          node = node.expression;
        }
        return node;
      }
      ts3.skipOuterExpressions = skipOuterExpressions;
      function skipAssertions(node) {
        return skipOuterExpressions(node, 6);
      }
      ts3.skipAssertions = skipAssertions;
      function startOnNewLine(node) {
        return ts3.setStartsOnNewLine(node, true);
      }
      ts3.startOnNewLine = startOnNewLine;
      function getExternalHelpersModuleName(node) {
        var parseNode = ts3.getOriginalNode(node, ts3.isSourceFile);
        var emitNode = parseNode && parseNode.emitNode;
        return emitNode && emitNode.externalHelpersModuleName;
      }
      ts3.getExternalHelpersModuleName = getExternalHelpersModuleName;
      function hasRecordedExternalHelpers(sourceFile) {
        var parseNode = ts3.getOriginalNode(sourceFile, ts3.isSourceFile);
        var emitNode = parseNode && parseNode.emitNode;
        return !!emitNode && (!!emitNode.externalHelpersModuleName || !!emitNode.externalHelpers);
      }
      ts3.hasRecordedExternalHelpers = hasRecordedExternalHelpers;
      function createExternalHelpersImportDeclarationIfNeeded(nodeFactory, helperFactory, sourceFile, compilerOptions, hasExportStarsToExportValues, hasImportStar, hasImportDefault) {
        if (compilerOptions.importHelpers && ts3.isEffectiveExternalModule(sourceFile, compilerOptions)) {
          var namedBindings = void 0;
          var moduleKind = ts3.getEmitModuleKind(compilerOptions);
          if (moduleKind >= ts3.ModuleKind.ES2015 && moduleKind <= ts3.ModuleKind.ESNext) {
            var helpers = ts3.getEmitHelpers(sourceFile);
            if (helpers) {
              var helperNames = [];
              for (var _i = 0, helpers_3 = helpers; _i < helpers_3.length; _i++) {
                var helper = helpers_3[_i];
                if (!helper.scoped) {
                  var importName = helper.importName;
                  if (importName) {
                    ts3.pushIfUnique(helperNames, importName);
                  }
                }
              }
              if (ts3.some(helperNames)) {
                helperNames.sort(ts3.compareStringsCaseSensitive);
                namedBindings = nodeFactory.createNamedImports(ts3.map(helperNames, function(name) {
                  return ts3.isFileLevelUniqueName(sourceFile, name) ? nodeFactory.createImportSpecifier(void 0, nodeFactory.createIdentifier(name)) : nodeFactory.createImportSpecifier(nodeFactory.createIdentifier(name), helperFactory.getUnscopedHelperName(name));
                }));
                var parseNode = ts3.getOriginalNode(sourceFile, ts3.isSourceFile);
                var emitNode = ts3.getOrCreateEmitNode(parseNode);
                emitNode.externalHelpers = true;
              }
            }
          } else {
            var externalHelpersModuleName = getOrCreateExternalHelpersModuleNameIfNeeded(nodeFactory, sourceFile, compilerOptions, hasExportStarsToExportValues, hasImportStar || hasImportDefault);
            if (externalHelpersModuleName) {
              namedBindings = nodeFactory.createNamespaceImport(externalHelpersModuleName);
            }
          }
          if (namedBindings) {
            var externalHelpersImportDeclaration = nodeFactory.createImportDeclaration(void 0, void 0, nodeFactory.createImportClause(false, void 0, namedBindings), nodeFactory.createStringLiteral(ts3.externalHelpersModuleNameText));
            ts3.addEmitFlags(externalHelpersImportDeclaration, 67108864);
            return externalHelpersImportDeclaration;
          }
        }
      }
      ts3.createExternalHelpersImportDeclarationIfNeeded = createExternalHelpersImportDeclarationIfNeeded;
      function getOrCreateExternalHelpersModuleNameIfNeeded(factory, node, compilerOptions, hasExportStarsToExportValues, hasImportStarOrImportDefault) {
        if (compilerOptions.importHelpers && ts3.isEffectiveExternalModule(node, compilerOptions)) {
          var externalHelpersModuleName = getExternalHelpersModuleName(node);
          if (externalHelpersModuleName) {
            return externalHelpersModuleName;
          }
          var moduleKind = ts3.getEmitModuleKind(compilerOptions);
          var create = (hasExportStarsToExportValues || compilerOptions.esModuleInterop && hasImportStarOrImportDefault) && moduleKind !== ts3.ModuleKind.System && moduleKind < ts3.ModuleKind.ES2015;
          if (!create) {
            var helpers = ts3.getEmitHelpers(node);
            if (helpers) {
              for (var _i = 0, helpers_4 = helpers; _i < helpers_4.length; _i++) {
                var helper = helpers_4[_i];
                if (!helper.scoped) {
                  create = true;
                  break;
                }
              }
            }
          }
          if (create) {
            var parseNode = ts3.getOriginalNode(node, ts3.isSourceFile);
            var emitNode = ts3.getOrCreateEmitNode(parseNode);
            return emitNode.externalHelpersModuleName || (emitNode.externalHelpersModuleName = factory.createUniqueName(ts3.externalHelpersModuleNameText));
          }
        }
      }
      ts3.getOrCreateExternalHelpersModuleNameIfNeeded = getOrCreateExternalHelpersModuleNameIfNeeded;
      function getLocalNameForExternalImport(factory, node, sourceFile) {
        var namespaceDeclaration = ts3.getNamespaceDeclarationNode(node);
        if (namespaceDeclaration && !ts3.isDefaultImport(node) && !ts3.isExportNamespaceAsDefaultDeclaration(node)) {
          var name = namespaceDeclaration.name;
          return ts3.isGeneratedIdentifier(name) ? name : factory.createIdentifier(ts3.getSourceTextOfNodeFromSourceFile(sourceFile, name) || ts3.idText(name));
        }
        if (node.kind === 262 && node.importClause) {
          return factory.getGeneratedNameForNode(node);
        }
        if (node.kind === 268 && node.moduleSpecifier) {
          return factory.getGeneratedNameForNode(node);
        }
        return void 0;
      }
      ts3.getLocalNameForExternalImport = getLocalNameForExternalImport;
      function getExternalModuleNameLiteral(factory, importNode, sourceFile, host, resolver, compilerOptions) {
        var moduleName = ts3.getExternalModuleName(importNode);
        if (moduleName && ts3.isStringLiteral(moduleName)) {
          return tryGetModuleNameFromDeclaration(importNode, host, factory, resolver, compilerOptions) || tryRenameExternalModule(factory, moduleName, sourceFile) || factory.cloneNode(moduleName);
        }
        return void 0;
      }
      ts3.getExternalModuleNameLiteral = getExternalModuleNameLiteral;
      function tryRenameExternalModule(factory, moduleName, sourceFile) {
        var rename = sourceFile.renamedDependencies && sourceFile.renamedDependencies.get(moduleName.text);
        return rename ? factory.createStringLiteral(rename) : void 0;
      }
      function tryGetModuleNameFromFile(factory, file, host, options) {
        if (!file) {
          return void 0;
        }
        if (file.moduleName) {
          return factory.createStringLiteral(file.moduleName);
        }
        if (!file.isDeclarationFile && ts3.outFile(options)) {
          return factory.createStringLiteral(ts3.getExternalModuleNameFromPath(host, file.fileName));
        }
        return void 0;
      }
      ts3.tryGetModuleNameFromFile = tryGetModuleNameFromFile;
      function tryGetModuleNameFromDeclaration(declaration, host, factory, resolver, compilerOptions) {
        return tryGetModuleNameFromFile(factory, resolver.getExternalModuleFileFromDeclaration(declaration), host, compilerOptions);
      }
      function getInitializerOfBindingOrAssignmentElement(bindingElement) {
        if (ts3.isDeclarationBindingElement(bindingElement)) {
          return bindingElement.initializer;
        }
        if (ts3.isPropertyAssignment(bindingElement)) {
          var initializer = bindingElement.initializer;
          return ts3.isAssignmentExpression(initializer, true) ? initializer.right : void 0;
        }
        if (ts3.isShorthandPropertyAssignment(bindingElement)) {
          return bindingElement.objectAssignmentInitializer;
        }
        if (ts3.isAssignmentExpression(bindingElement, true)) {
          return bindingElement.right;
        }
        if (ts3.isSpreadElement(bindingElement)) {
          return getInitializerOfBindingOrAssignmentElement(bindingElement.expression);
        }
      }
      ts3.getInitializerOfBindingOrAssignmentElement = getInitializerOfBindingOrAssignmentElement;
      function getTargetOfBindingOrAssignmentElement(bindingElement) {
        if (ts3.isDeclarationBindingElement(bindingElement)) {
          return bindingElement.name;
        }
        if (ts3.isObjectLiteralElementLike(bindingElement)) {
          switch (bindingElement.kind) {
            case 289:
              return getTargetOfBindingOrAssignmentElement(bindingElement.initializer);
            case 290:
              return bindingElement.name;
            case 291:
              return getTargetOfBindingOrAssignmentElement(bindingElement.expression);
          }
          return void 0;
        }
        if (ts3.isAssignmentExpression(bindingElement, true)) {
          return getTargetOfBindingOrAssignmentElement(bindingElement.left);
        }
        if (ts3.isSpreadElement(bindingElement)) {
          return getTargetOfBindingOrAssignmentElement(bindingElement.expression);
        }
        return bindingElement;
      }
      ts3.getTargetOfBindingOrAssignmentElement = getTargetOfBindingOrAssignmentElement;
      function getRestIndicatorOfBindingOrAssignmentElement(bindingElement) {
        switch (bindingElement.kind) {
          case 161:
          case 199:
            return bindingElement.dotDotDotToken;
          case 221:
          case 291:
            return bindingElement;
        }
        return void 0;
      }
      ts3.getRestIndicatorOfBindingOrAssignmentElement = getRestIndicatorOfBindingOrAssignmentElement;
      function getPropertyNameOfBindingOrAssignmentElement(bindingElement) {
        var propertyName = tryGetPropertyNameOfBindingOrAssignmentElement(bindingElement);
        ts3.Debug.assert(!!propertyName || ts3.isSpreadAssignment(bindingElement), "Invalid property name for binding element.");
        return propertyName;
      }
      ts3.getPropertyNameOfBindingOrAssignmentElement = getPropertyNameOfBindingOrAssignmentElement;
      function tryGetPropertyNameOfBindingOrAssignmentElement(bindingElement) {
        switch (bindingElement.kind) {
          case 199:
            if (bindingElement.propertyName) {
              var propertyName = bindingElement.propertyName;
              if (ts3.isPrivateIdentifier(propertyName)) {
                return ts3.Debug.failBadSyntaxKind(propertyName);
              }
              return ts3.isComputedPropertyName(propertyName) && isStringOrNumericLiteral(propertyName.expression) ? propertyName.expression : propertyName;
            }
            break;
          case 289:
            if (bindingElement.name) {
              var propertyName = bindingElement.name;
              if (ts3.isPrivateIdentifier(propertyName)) {
                return ts3.Debug.failBadSyntaxKind(propertyName);
              }
              return ts3.isComputedPropertyName(propertyName) && isStringOrNumericLiteral(propertyName.expression) ? propertyName.expression : propertyName;
            }
            break;
          case 291:
            if (bindingElement.name && ts3.isPrivateIdentifier(bindingElement.name)) {
              return ts3.Debug.failBadSyntaxKind(bindingElement.name);
            }
            return bindingElement.name;
        }
        var target = getTargetOfBindingOrAssignmentElement(bindingElement);
        if (target && ts3.isPropertyName(target)) {
          return target;
        }
      }
      ts3.tryGetPropertyNameOfBindingOrAssignmentElement = tryGetPropertyNameOfBindingOrAssignmentElement;
      function isStringOrNumericLiteral(node) {
        var kind = node.kind;
        return kind === 10 || kind === 8;
      }
      function getElementsOfBindingOrAssignmentPattern(name) {
        switch (name.kind) {
          case 197:
          case 198:
          case 200:
            return name.elements;
          case 201:
            return name.properties;
        }
      }
      ts3.getElementsOfBindingOrAssignmentPattern = getElementsOfBindingOrAssignmentPattern;
      function getJSDocTypeAliasName(fullName) {
        if (fullName) {
          var rightNode = fullName;
          while (true) {
            if (ts3.isIdentifier(rightNode) || !rightNode.body) {
              return ts3.isIdentifier(rightNode) ? rightNode : rightNode.name;
            }
            rightNode = rightNode.body;
          }
        }
      }
      ts3.getJSDocTypeAliasName = getJSDocTypeAliasName;
      function canHaveModifiers(node) {
        var kind = node.kind;
        return kind === 161 || kind === 163 || kind === 164 || kind === 165 || kind === 166 || kind === 167 || kind === 168 || kind === 169 || kind === 172 || kind === 209 || kind === 210 || kind === 222 || kind === 233 || kind === 252 || kind === 253 || kind === 254 || kind === 255 || kind === 256 || kind === 257 || kind === 261 || kind === 262 || kind === 267 || kind === 268;
      }
      ts3.canHaveModifiers = canHaveModifiers;
      ts3.isTypeNodeOrTypeParameterDeclaration = ts3.or(ts3.isTypeNode, ts3.isTypeParameterDeclaration);
      ts3.isQuestionOrExclamationToken = ts3.or(ts3.isQuestionToken, ts3.isExclamationToken);
      ts3.isIdentifierOrThisTypeNode = ts3.or(ts3.isIdentifier, ts3.isThisTypeNode);
      ts3.isReadonlyKeywordOrPlusOrMinusToken = ts3.or(ts3.isReadonlyKeyword, ts3.isPlusToken, ts3.isMinusToken);
      ts3.isQuestionOrPlusOrMinusToken = ts3.or(ts3.isQuestionToken, ts3.isPlusToken, ts3.isMinusToken);
      ts3.isModuleName = ts3.or(ts3.isIdentifier, ts3.isStringLiteral);
      function isLiteralTypeLikeExpression(node) {
        var kind = node.kind;
        return kind === 103 || kind === 109 || kind === 94 || ts3.isLiteralExpression(node) || ts3.isPrefixUnaryExpression(node);
      }
      ts3.isLiteralTypeLikeExpression = isLiteralTypeLikeExpression;
      function isExponentiationOperator(kind) {
        return kind === 42;
      }
      function isMultiplicativeOperator(kind) {
        return kind === 41 || kind === 43 || kind === 44;
      }
      function isMultiplicativeOperatorOrHigher(kind) {
        return isExponentiationOperator(kind) || isMultiplicativeOperator(kind);
      }
      function isAdditiveOperator(kind) {
        return kind === 39 || kind === 40;
      }
      function isAdditiveOperatorOrHigher(kind) {
        return isAdditiveOperator(kind) || isMultiplicativeOperatorOrHigher(kind);
      }
      function isShiftOperator(kind) {
        return kind === 47 || kind === 48 || kind === 49;
      }
      function isShiftOperatorOrHigher(kind) {
        return isShiftOperator(kind) || isAdditiveOperatorOrHigher(kind);
      }
      function isRelationalOperator(kind) {
        return kind === 29 || kind === 32 || kind === 31 || kind === 33 || kind === 101 || kind === 100;
      }
      function isRelationalOperatorOrHigher(kind) {
        return isRelationalOperator(kind) || isShiftOperatorOrHigher(kind);
      }
      function isEqualityOperator(kind) {
        return kind === 34 || kind === 36 || kind === 35 || kind === 37;
      }
      function isEqualityOperatorOrHigher(kind) {
        return isEqualityOperator(kind) || isRelationalOperatorOrHigher(kind);
      }
      function isBitwiseOperator(kind) {
        return kind === 50 || kind === 51 || kind === 52;
      }
      function isBitwiseOperatorOrHigher(kind) {
        return isBitwiseOperator(kind) || isEqualityOperatorOrHigher(kind);
      }
      function isLogicalOperator(kind) {
        return kind === 55 || kind === 56;
      }
      function isLogicalOperatorOrHigher(kind) {
        return isLogicalOperator(kind) || isBitwiseOperatorOrHigher(kind);
      }
      function isAssignmentOperatorOrHigher(kind) {
        return kind === 60 || isLogicalOperatorOrHigher(kind) || ts3.isAssignmentOperator(kind);
      }
      function isBinaryOperator(kind) {
        return isAssignmentOperatorOrHigher(kind) || kind === 27;
      }
      function isBinaryOperatorToken(node) {
        return isBinaryOperator(node.kind);
      }
      ts3.isBinaryOperatorToken = isBinaryOperatorToken;
      var BinaryExpressionState;
      (function(BinaryExpressionState2) {
        function enter(machine, stackIndex, stateStack, nodeStack, userStateStack, _resultHolder, outerState) {
          var prevUserState = stackIndex > 0 ? userStateStack[stackIndex - 1] : void 0;
          ts3.Debug.assertEqual(stateStack[stackIndex], enter);
          userStateStack[stackIndex] = machine.onEnter(nodeStack[stackIndex], prevUserState, outerState);
          stateStack[stackIndex] = nextState(machine, enter);
          return stackIndex;
        }
        BinaryExpressionState2.enter = enter;
        function left(machine, stackIndex, stateStack, nodeStack, userStateStack, _resultHolder, _outerState) {
          ts3.Debug.assertEqual(stateStack[stackIndex], left);
          ts3.Debug.assertIsDefined(machine.onLeft);
          stateStack[stackIndex] = nextState(machine, left);
          var nextNode = machine.onLeft(nodeStack[stackIndex].left, userStateStack[stackIndex], nodeStack[stackIndex]);
          if (nextNode) {
            checkCircularity(stackIndex, nodeStack, nextNode);
            return pushStack(stackIndex, stateStack, nodeStack, userStateStack, nextNode);
          }
          return stackIndex;
        }
        BinaryExpressionState2.left = left;
        function operator(machine, stackIndex, stateStack, nodeStack, userStateStack, _resultHolder, _outerState) {
          ts3.Debug.assertEqual(stateStack[stackIndex], operator);
          ts3.Debug.assertIsDefined(machine.onOperator);
          stateStack[stackIndex] = nextState(machine, operator);
          machine.onOperator(nodeStack[stackIndex].operatorToken, userStateStack[stackIndex], nodeStack[stackIndex]);
          return stackIndex;
        }
        BinaryExpressionState2.operator = operator;
        function right(machine, stackIndex, stateStack, nodeStack, userStateStack, _resultHolder, _outerState) {
          ts3.Debug.assertEqual(stateStack[stackIndex], right);
          ts3.Debug.assertIsDefined(machine.onRight);
          stateStack[stackIndex] = nextState(machine, right);
          var nextNode = machine.onRight(nodeStack[stackIndex].right, userStateStack[stackIndex], nodeStack[stackIndex]);
          if (nextNode) {
            checkCircularity(stackIndex, nodeStack, nextNode);
            return pushStack(stackIndex, stateStack, nodeStack, userStateStack, nextNode);
          }
          return stackIndex;
        }
        BinaryExpressionState2.right = right;
        function exit2(machine, stackIndex, stateStack, nodeStack, userStateStack, resultHolder, _outerState) {
          ts3.Debug.assertEqual(stateStack[stackIndex], exit2);
          stateStack[stackIndex] = nextState(machine, exit2);
          var result2 = machine.onExit(nodeStack[stackIndex], userStateStack[stackIndex]);
          if (stackIndex > 0) {
            stackIndex--;
            if (machine.foldState) {
              var side = stateStack[stackIndex] === exit2 ? "right" : "left";
              userStateStack[stackIndex] = machine.foldState(userStateStack[stackIndex], result2, side);
            }
          } else {
            resultHolder.value = result2;
          }
          return stackIndex;
        }
        BinaryExpressionState2.exit = exit2;
        function done(_machine, stackIndex, stateStack, _nodeStack, _userStateStack, _resultHolder, _outerState) {
          ts3.Debug.assertEqual(stateStack[stackIndex], done);
          return stackIndex;
        }
        BinaryExpressionState2.done = done;
        function nextState(machine, currentState) {
          switch (currentState) {
            case enter:
              if (machine.onLeft)
                return left;
            case left:
              if (machine.onOperator)
                return operator;
            case operator:
              if (machine.onRight)
                return right;
            case right:
              return exit2;
            case exit2:
              return done;
            case done:
              return done;
            default:
              ts3.Debug.fail("Invalid state");
          }
        }
        BinaryExpressionState2.nextState = nextState;
        function pushStack(stackIndex, stateStack, nodeStack, userStateStack, node) {
          stackIndex++;
          stateStack[stackIndex] = enter;
          nodeStack[stackIndex] = node;
          userStateStack[stackIndex] = void 0;
          return stackIndex;
        }
        function checkCircularity(stackIndex, nodeStack, node) {
          if (ts3.Debug.shouldAssert(2)) {
            while (stackIndex >= 0) {
              ts3.Debug.assert(nodeStack[stackIndex] !== node, "Circular traversal detected.");
              stackIndex--;
            }
          }
        }
      })(BinaryExpressionState || (BinaryExpressionState = {}));
      var BinaryExpressionStateMachine = function() {
        function BinaryExpressionStateMachine2(onEnter, onLeft, onOperator, onRight, onExit, foldState) {
          this.onEnter = onEnter;
          this.onLeft = onLeft;
          this.onOperator = onOperator;
          this.onRight = onRight;
          this.onExit = onExit;
          this.foldState = foldState;
        }
        return BinaryExpressionStateMachine2;
      }();
      function createBinaryExpressionTrampoline(onEnter, onLeft, onOperator, onRight, onExit, foldState) {
        var machine = new BinaryExpressionStateMachine(onEnter, onLeft, onOperator, onRight, onExit, foldState);
        return trampoline;
        function trampoline(node, outerState) {
          var resultHolder = { value: void 0 };
          var stateStack = [BinaryExpressionState.enter];
          var nodeStack = [node];
          var userStateStack = [void 0];
          var stackIndex = 0;
          while (stateStack[stackIndex] !== BinaryExpressionState.done) {
            stackIndex = stateStack[stackIndex](machine, stackIndex, stateStack, nodeStack, userStateStack, resultHolder, outerState);
          }
          ts3.Debug.assertEqual(stackIndex, 0);
          return resultHolder.value;
        }
      }
      ts3.createBinaryExpressionTrampoline = createBinaryExpressionTrampoline;
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      function setTextRange(range, location) {
        return location ? ts3.setTextRangePosEnd(range, location.pos, location.end) : range;
      }
      ts3.setTextRange = setTextRange;
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var SignatureFlags;
      (function(SignatureFlags2) {
        SignatureFlags2[SignatureFlags2["None"] = 0] = "None";
        SignatureFlags2[SignatureFlags2["Yield"] = 1] = "Yield";
        SignatureFlags2[SignatureFlags2["Await"] = 2] = "Await";
        SignatureFlags2[SignatureFlags2["Type"] = 4] = "Type";
        SignatureFlags2[SignatureFlags2["IgnoreMissingOpenBrace"] = 16] = "IgnoreMissingOpenBrace";
        SignatureFlags2[SignatureFlags2["JSDoc"] = 32] = "JSDoc";
      })(SignatureFlags || (SignatureFlags = {}));
      var SpeculationKind;
      (function(SpeculationKind2) {
        SpeculationKind2[SpeculationKind2["TryParse"] = 0] = "TryParse";
        SpeculationKind2[SpeculationKind2["Lookahead"] = 1] = "Lookahead";
        SpeculationKind2[SpeculationKind2["Reparse"] = 2] = "Reparse";
      })(SpeculationKind || (SpeculationKind = {}));
      var NodeConstructor;
      var TokenConstructor;
      var IdentifierConstructor;
      var PrivateIdentifierConstructor;
      var SourceFileConstructor;
      ts3.parseBaseNodeFactory = {
        createBaseSourceFileNode: function(kind) {
          return new (SourceFileConstructor || (SourceFileConstructor = ts3.objectAllocator.getSourceFileConstructor()))(kind, -1, -1);
        },
        createBaseIdentifierNode: function(kind) {
          return new (IdentifierConstructor || (IdentifierConstructor = ts3.objectAllocator.getIdentifierConstructor()))(kind, -1, -1);
        },
        createBasePrivateIdentifierNode: function(kind) {
          return new (PrivateIdentifierConstructor || (PrivateIdentifierConstructor = ts3.objectAllocator.getPrivateIdentifierConstructor()))(kind, -1, -1);
        },
        createBaseTokenNode: function(kind) {
          return new (TokenConstructor || (TokenConstructor = ts3.objectAllocator.getTokenConstructor()))(kind, -1, -1);
        },
        createBaseNode: function(kind) {
          return new (NodeConstructor || (NodeConstructor = ts3.objectAllocator.getNodeConstructor()))(kind, -1, -1);
        }
      };
      ts3.parseNodeFactory = ts3.createNodeFactory(1, ts3.parseBaseNodeFactory);
      function visitNode(cbNode, node) {
        return node && cbNode(node);
      }
      function visitNodes(cbNode, cbNodes, nodes) {
        if (nodes) {
          if (cbNodes) {
            return cbNodes(nodes);
          }
          for (var _i = 0, nodes_1 = nodes; _i < nodes_1.length; _i++) {
            var node = nodes_1[_i];
            var result2 = cbNode(node);
            if (result2) {
              return result2;
            }
          }
        }
      }
      function isJSDocLikeText(text, start) {
        return text.charCodeAt(start + 1) === 42 && text.charCodeAt(start + 2) === 42 && text.charCodeAt(start + 3) !== 47;
      }
      ts3.isJSDocLikeText = isJSDocLikeText;
      function forEachChild(node, cbNode, cbNodes) {
        if (!node || node.kind <= 157) {
          return;
        }
        switch (node.kind) {
          case 158:
            return visitNode(cbNode, node.left) || visitNode(cbNode, node.right);
          case 160:
            return visitNode(cbNode, node.name) || visitNode(cbNode, node.constraint) || visitNode(cbNode, node.default) || visitNode(cbNode, node.expression);
          case 290:
            return visitNodes(cbNode, cbNodes, node.decorators) || visitNodes(cbNode, cbNodes, node.modifiers) || visitNode(cbNode, node.name) || visitNode(cbNode, node.questionToken) || visitNode(cbNode, node.exclamationToken) || visitNode(cbNode, node.equalsToken) || visitNode(cbNode, node.objectAssignmentInitializer);
          case 291:
            return visitNode(cbNode, node.expression);
          case 161:
            return visitNodes(cbNode, cbNodes, node.decorators) || visitNodes(cbNode, cbNodes, node.modifiers) || visitNode(cbNode, node.dotDotDotToken) || visitNode(cbNode, node.name) || visitNode(cbNode, node.questionToken) || visitNode(cbNode, node.type) || visitNode(cbNode, node.initializer);
          case 164:
            return visitNodes(cbNode, cbNodes, node.decorators) || visitNodes(cbNode, cbNodes, node.modifiers) || visitNode(cbNode, node.name) || visitNode(cbNode, node.questionToken) || visitNode(cbNode, node.exclamationToken) || visitNode(cbNode, node.type) || visitNode(cbNode, node.initializer);
          case 163:
            return visitNodes(cbNode, cbNodes, node.decorators) || visitNodes(cbNode, cbNodes, node.modifiers) || visitNode(cbNode, node.name) || visitNode(cbNode, node.questionToken) || visitNode(cbNode, node.type) || visitNode(cbNode, node.initializer);
          case 289:
            return visitNodes(cbNode, cbNodes, node.decorators) || visitNodes(cbNode, cbNodes, node.modifiers) || visitNode(cbNode, node.name) || visitNode(cbNode, node.questionToken) || visitNode(cbNode, node.initializer);
          case 250:
            return visitNodes(cbNode, cbNodes, node.decorators) || visitNodes(cbNode, cbNodes, node.modifiers) || visitNode(cbNode, node.name) || visitNode(cbNode, node.exclamationToken) || visitNode(cbNode, node.type) || visitNode(cbNode, node.initializer);
          case 199:
            return visitNodes(cbNode, cbNodes, node.decorators) || visitNodes(cbNode, cbNodes, node.modifiers) || visitNode(cbNode, node.dotDotDotToken) || visitNode(cbNode, node.propertyName) || visitNode(cbNode, node.name) || visitNode(cbNode, node.initializer);
          case 175:
          case 176:
          case 170:
          case 171:
          case 172:
            return visitNodes(cbNode, cbNodes, node.decorators) || visitNodes(cbNode, cbNodes, node.modifiers) || visitNodes(cbNode, cbNodes, node.typeParameters) || visitNodes(cbNode, cbNodes, node.parameters) || visitNode(cbNode, node.type);
          case 166:
          case 165:
          case 167:
          case 168:
          case 169:
          case 209:
          case 252:
          case 210:
            return visitNodes(cbNode, cbNodes, node.decorators) || visitNodes(cbNode, cbNodes, node.modifiers) || visitNode(cbNode, node.asteriskToken) || visitNode(cbNode, node.name) || visitNode(cbNode, node.questionToken) || visitNode(cbNode, node.exclamationToken) || visitNodes(cbNode, cbNodes, node.typeParameters) || visitNodes(cbNode, cbNodes, node.parameters) || visitNode(cbNode, node.type) || visitNode(cbNode, node.equalsGreaterThanToken) || visitNode(cbNode, node.body);
          case 174:
            return visitNode(cbNode, node.typeName) || visitNodes(cbNode, cbNodes, node.typeArguments);
          case 173:
            return visitNode(cbNode, node.assertsModifier) || visitNode(cbNode, node.parameterName) || visitNode(cbNode, node.type);
          case 177:
            return visitNode(cbNode, node.exprName);
          case 178:
            return visitNodes(cbNode, cbNodes, node.members);
          case 179:
            return visitNode(cbNode, node.elementType);
          case 180:
            return visitNodes(cbNode, cbNodes, node.elements);
          case 183:
          case 184:
            return visitNodes(cbNode, cbNodes, node.types);
          case 185:
            return visitNode(cbNode, node.checkType) || visitNode(cbNode, node.extendsType) || visitNode(cbNode, node.trueType) || visitNode(cbNode, node.falseType);
          case 186:
            return visitNode(cbNode, node.typeParameter);
          case 196:
            return visitNode(cbNode, node.argument) || visitNode(cbNode, node.qualifier) || visitNodes(cbNode, cbNodes, node.typeArguments);
          case 187:
          case 189:
            return visitNode(cbNode, node.type);
          case 190:
            return visitNode(cbNode, node.objectType) || visitNode(cbNode, node.indexType);
          case 191:
            return visitNode(cbNode, node.readonlyToken) || visitNode(cbNode, node.typeParameter) || visitNode(cbNode, node.nameType) || visitNode(cbNode, node.questionToken) || visitNode(cbNode, node.type);
          case 192:
            return visitNode(cbNode, node.literal);
          case 193:
            return visitNode(cbNode, node.dotDotDotToken) || visitNode(cbNode, node.name) || visitNode(cbNode, node.questionToken) || visitNode(cbNode, node.type);
          case 197:
          case 198:
            return visitNodes(cbNode, cbNodes, node.elements);
          case 200:
            return visitNodes(cbNode, cbNodes, node.elements);
          case 201:
            return visitNodes(cbNode, cbNodes, node.properties);
          case 202:
            return visitNode(cbNode, node.expression) || visitNode(cbNode, node.questionDotToken) || visitNode(cbNode, node.name);
          case 203:
            return visitNode(cbNode, node.expression) || visitNode(cbNode, node.questionDotToken) || visitNode(cbNode, node.argumentExpression);
          case 204:
          case 205:
            return visitNode(cbNode, node.expression) || visitNode(cbNode, node.questionDotToken) || visitNodes(cbNode, cbNodes, node.typeArguments) || visitNodes(cbNode, cbNodes, node.arguments);
          case 206:
            return visitNode(cbNode, node.tag) || visitNode(cbNode, node.questionDotToken) || visitNodes(cbNode, cbNodes, node.typeArguments) || visitNode(cbNode, node.template);
          case 207:
            return visitNode(cbNode, node.type) || visitNode(cbNode, node.expression);
          case 208:
            return visitNode(cbNode, node.expression);
          case 211:
            return visitNode(cbNode, node.expression);
          case 212:
            return visitNode(cbNode, node.expression);
          case 213:
            return visitNode(cbNode, node.expression);
          case 215:
            return visitNode(cbNode, node.operand);
          case 220:
            return visitNode(cbNode, node.asteriskToken) || visitNode(cbNode, node.expression);
          case 214:
            return visitNode(cbNode, node.expression);
          case 216:
            return visitNode(cbNode, node.operand);
          case 217:
            return visitNode(cbNode, node.left) || visitNode(cbNode, node.operatorToken) || visitNode(cbNode, node.right);
          case 225:
            return visitNode(cbNode, node.expression) || visitNode(cbNode, node.type);
          case 226:
            return visitNode(cbNode, node.expression);
          case 227:
            return visitNode(cbNode, node.name);
          case 218:
            return visitNode(cbNode, node.condition) || visitNode(cbNode, node.questionToken) || visitNode(cbNode, node.whenTrue) || visitNode(cbNode, node.colonToken) || visitNode(cbNode, node.whenFalse);
          case 221:
            return visitNode(cbNode, node.expression);
          case 231:
          case 258:
            return visitNodes(cbNode, cbNodes, node.statements);
          case 298:
            return visitNodes(cbNode, cbNodes, node.statements) || visitNode(cbNode, node.endOfFileToken);
          case 233:
            return visitNodes(cbNode, cbNodes, node.decorators) || visitNodes(cbNode, cbNodes, node.modifiers) || visitNode(cbNode, node.declarationList);
          case 251:
            return visitNodes(cbNode, cbNodes, node.declarations);
          case 234:
            return visitNode(cbNode, node.expression);
          case 235:
            return visitNode(cbNode, node.expression) || visitNode(cbNode, node.thenStatement) || visitNode(cbNode, node.elseStatement);
          case 236:
            return visitNode(cbNode, node.statement) || visitNode(cbNode, node.expression);
          case 237:
            return visitNode(cbNode, node.expression) || visitNode(cbNode, node.statement);
          case 238:
            return visitNode(cbNode, node.initializer) || visitNode(cbNode, node.condition) || visitNode(cbNode, node.incrementor) || visitNode(cbNode, node.statement);
          case 239:
            return visitNode(cbNode, node.initializer) || visitNode(cbNode, node.expression) || visitNode(cbNode, node.statement);
          case 240:
            return visitNode(cbNode, node.awaitModifier) || visitNode(cbNode, node.initializer) || visitNode(cbNode, node.expression) || visitNode(cbNode, node.statement);
          case 241:
          case 242:
            return visitNode(cbNode, node.label);
          case 243:
            return visitNode(cbNode, node.expression);
          case 244:
            return visitNode(cbNode, node.expression) || visitNode(cbNode, node.statement);
          case 245:
            return visitNode(cbNode, node.expression) || visitNode(cbNode, node.caseBlock);
          case 259:
            return visitNodes(cbNode, cbNodes, node.clauses);
          case 285:
            return visitNode(cbNode, node.expression) || visitNodes(cbNode, cbNodes, node.statements);
          case 286:
            return visitNodes(cbNode, cbNodes, node.statements);
          case 246:
            return visitNode(cbNode, node.label) || visitNode(cbNode, node.statement);
          case 247:
            return visitNode(cbNode, node.expression);
          case 248:
            return visitNode(cbNode, node.tryBlock) || visitNode(cbNode, node.catchClause) || visitNode(cbNode, node.finallyBlock);
          case 288:
            return visitNode(cbNode, node.variableDeclaration) || visitNode(cbNode, node.block);
          case 162:
            return visitNode(cbNode, node.expression);
          case 253:
          case 222:
            return visitNodes(cbNode, cbNodes, node.decorators) || visitNodes(cbNode, cbNodes, node.modifiers) || visitNode(cbNode, node.name) || visitNodes(cbNode, cbNodes, node.typeParameters) || visitNodes(cbNode, cbNodes, node.heritageClauses) || visitNodes(cbNode, cbNodes, node.members);
          case 254:
            return visitNodes(cbNode, cbNodes, node.decorators) || visitNodes(cbNode, cbNodes, node.modifiers) || visitNode(cbNode, node.name) || visitNodes(cbNode, cbNodes, node.typeParameters) || visitNodes(cbNode, cbNodes, node.heritageClauses) || visitNodes(cbNode, cbNodes, node.members);
          case 255:
            return visitNodes(cbNode, cbNodes, node.decorators) || visitNodes(cbNode, cbNodes, node.modifiers) || visitNode(cbNode, node.name) || visitNodes(cbNode, cbNodes, node.typeParameters) || visitNode(cbNode, node.type);
          case 256:
            return visitNodes(cbNode, cbNodes, node.decorators) || visitNodes(cbNode, cbNodes, node.modifiers) || visitNode(cbNode, node.name) || visitNodes(cbNode, cbNodes, node.members);
          case 292:
            return visitNode(cbNode, node.name) || visitNode(cbNode, node.initializer);
          case 257:
            return visitNodes(cbNode, cbNodes, node.decorators) || visitNodes(cbNode, cbNodes, node.modifiers) || visitNode(cbNode, node.name) || visitNode(cbNode, node.body);
          case 261:
            return visitNodes(cbNode, cbNodes, node.decorators) || visitNodes(cbNode, cbNodes, node.modifiers) || visitNode(cbNode, node.name) || visitNode(cbNode, node.moduleReference);
          case 262:
            return visitNodes(cbNode, cbNodes, node.decorators) || visitNodes(cbNode, cbNodes, node.modifiers) || visitNode(cbNode, node.importClause) || visitNode(cbNode, node.moduleSpecifier);
          case 263:
            return visitNode(cbNode, node.name) || visitNode(cbNode, node.namedBindings);
          case 260:
            return visitNode(cbNode, node.name);
          case 264:
            return visitNode(cbNode, node.name);
          case 270:
            return visitNode(cbNode, node.name);
          case 265:
          case 269:
            return visitNodes(cbNode, cbNodes, node.elements);
          case 268:
            return visitNodes(cbNode, cbNodes, node.decorators) || visitNodes(cbNode, cbNodes, node.modifiers) || visitNode(cbNode, node.exportClause) || visitNode(cbNode, node.moduleSpecifier);
          case 266:
          case 271:
            return visitNode(cbNode, node.propertyName) || visitNode(cbNode, node.name);
          case 267:
            return visitNodes(cbNode, cbNodes, node.decorators) || visitNodes(cbNode, cbNodes, node.modifiers) || visitNode(cbNode, node.expression);
          case 219:
            return visitNode(cbNode, node.head) || visitNodes(cbNode, cbNodes, node.templateSpans);
          case 229:
            return visitNode(cbNode, node.expression) || visitNode(cbNode, node.literal);
          case 194:
            return visitNode(cbNode, node.head) || visitNodes(cbNode, cbNodes, node.templateSpans);
          case 195:
            return visitNode(cbNode, node.type) || visitNode(cbNode, node.literal);
          case 159:
            return visitNode(cbNode, node.expression);
          case 287:
            return visitNodes(cbNode, cbNodes, node.types);
          case 224:
            return visitNode(cbNode, node.expression) || visitNodes(cbNode, cbNodes, node.typeArguments);
          case 273:
            return visitNode(cbNode, node.expression);
          case 272:
            return visitNodes(cbNode, cbNodes, node.decorators);
          case 341:
            return visitNodes(cbNode, cbNodes, node.elements);
          case 274:
            return visitNode(cbNode, node.openingElement) || visitNodes(cbNode, cbNodes, node.children) || visitNode(cbNode, node.closingElement);
          case 278:
            return visitNode(cbNode, node.openingFragment) || visitNodes(cbNode, cbNodes, node.children) || visitNode(cbNode, node.closingFragment);
          case 275:
          case 276:
            return visitNode(cbNode, node.tagName) || visitNodes(cbNode, cbNodes, node.typeArguments) || visitNode(cbNode, node.attributes);
          case 282:
            return visitNodes(cbNode, cbNodes, node.properties);
          case 281:
            return visitNode(cbNode, node.name) || visitNode(cbNode, node.initializer);
          case 283:
            return visitNode(cbNode, node.expression);
          case 284:
            return visitNode(cbNode, node.dotDotDotToken) || visitNode(cbNode, node.expression);
          case 277:
            return visitNode(cbNode, node.tagName);
          case 181:
          case 182:
          case 302:
          case 307:
          case 306:
          case 308:
          case 310:
            return visitNode(cbNode, node.type);
          case 309:
            return visitNodes(cbNode, cbNodes, node.parameters) || visitNode(cbNode, node.type);
          case 312:
            return (typeof node.comment === "string" ? void 0 : visitNodes(cbNode, cbNodes, node.comment)) || visitNodes(cbNode, cbNodes, node.tags);
          case 336:
            return visitNode(cbNode, node.tagName) || visitNode(cbNode, node.name) || (typeof node.comment === "string" ? void 0 : visitNodes(cbNode, cbNodes, node.comment));
          case 303:
            return visitNode(cbNode, node.name);
          case 330:
          case 337:
            return visitNode(cbNode, node.tagName) || (node.isNameFirst ? visitNode(cbNode, node.name) || visitNode(cbNode, node.typeExpression) || (typeof node.comment === "string" ? void 0 : visitNodes(cbNode, cbNodes, node.comment)) : visitNode(cbNode, node.typeExpression) || visitNode(cbNode, node.name) || (typeof node.comment === "string" ? void 0 : visitNodes(cbNode, cbNodes, node.comment)));
          case 320:
            return visitNode(cbNode, node.tagName) || (typeof node.comment === "string" ? void 0 : visitNodes(cbNode, cbNodes, node.comment));
          case 319:
            return visitNode(cbNode, node.tagName) || visitNode(cbNode, node.class) || (typeof node.comment === "string" ? void 0 : visitNodes(cbNode, cbNodes, node.comment));
          case 318:
            return visitNode(cbNode, node.tagName) || visitNode(cbNode, node.class) || (typeof node.comment === "string" ? void 0 : visitNodes(cbNode, cbNodes, node.comment));
          case 334:
            return visitNode(cbNode, node.tagName) || visitNode(cbNode, node.constraint) || visitNodes(cbNode, cbNodes, node.typeParameters) || (typeof node.comment === "string" ? void 0 : visitNodes(cbNode, cbNodes, node.comment));
          case 335:
            return visitNode(cbNode, node.tagName) || (node.typeExpression && node.typeExpression.kind === 302 ? visitNode(cbNode, node.typeExpression) || visitNode(cbNode, node.fullName) || (typeof node.comment === "string" ? void 0 : visitNodes(cbNode, cbNodes, node.comment)) : visitNode(cbNode, node.fullName) || visitNode(cbNode, node.typeExpression)) || (typeof node.comment === "string" ? void 0 : visitNodes(cbNode, cbNodes, node.comment));
          case 328:
            return visitNode(cbNode, node.tagName) || visitNode(cbNode, node.fullName) || visitNode(cbNode, node.typeExpression) || (typeof node.comment === "string" ? void 0 : visitNodes(cbNode, cbNodes, node.comment));
          case 331:
          case 333:
          case 332:
          case 329:
            return visitNode(cbNode, node.tagName) || visitNode(cbNode, node.typeExpression) || (typeof node.comment === "string" ? void 0 : visitNodes(cbNode, cbNodes, node.comment));
          case 315:
            return ts3.forEach(node.typeParameters, cbNode) || ts3.forEach(node.parameters, cbNode) || visitNode(cbNode, node.type);
          case 316:
            return visitNode(cbNode, node.name);
          case 314:
            return ts3.forEach(node.jsDocPropertyTags, cbNode);
          case 317:
          case 322:
          case 323:
          case 324:
          case 325:
          case 326:
          case 321:
            return visitNode(cbNode, node.tagName) || (typeof node.comment === "string" ? void 0 : visitNodes(cbNode, cbNodes, node.comment));
          case 340:
            return visitNode(cbNode, node.expression);
        }
      }
      ts3.forEachChild = forEachChild;
      function forEachChildRecursively(rootNode, cbNode, cbNodes) {
        var queue = gatherPossibleChildren(rootNode);
        var parents = [];
        while (parents.length < queue.length) {
          parents.push(rootNode);
        }
        while (queue.length !== 0) {
          var current = queue.pop();
          var parent = parents.pop();
          if (ts3.isArray(current)) {
            if (cbNodes) {
              var res = cbNodes(current, parent);
              if (res) {
                if (res === "skip")
                  continue;
                return res;
              }
            }
            for (var i3 = current.length - 1; i3 >= 0; --i3) {
              queue.push(current[i3]);
              parents.push(parent);
            }
          } else {
            var res = cbNode(current, parent);
            if (res) {
              if (res === "skip")
                continue;
              return res;
            }
            if (current.kind >= 158) {
              for (var _i = 0, _a2 = gatherPossibleChildren(current); _i < _a2.length; _i++) {
                var child = _a2[_i];
                queue.push(child);
                parents.push(current);
              }
            }
          }
        }
      }
      ts3.forEachChildRecursively = forEachChildRecursively;
      function gatherPossibleChildren(node) {
        var children = [];
        forEachChild(node, addWorkItem, addWorkItem);
        return children;
        function addWorkItem(n2) {
          children.unshift(n2);
        }
      }
      function createSourceFile(fileName, sourceText, languageVersion, setParentNodes, scriptKind) {
        if (setParentNodes === void 0) {
          setParentNodes = false;
        }
        ts3.tracing === null || ts3.tracing === void 0 ? void 0 : ts3.tracing.push("parse", "createSourceFile", { path: fileName }, true);
        ts3.performance.mark("beforeParse");
        var result2;
        ts3.perfLogger.logStartParseSourceFile(fileName);
        if (languageVersion === 100) {
          result2 = Parser.parseSourceFile(fileName, sourceText, languageVersion, void 0, setParentNodes, 6);
        } else {
          result2 = Parser.parseSourceFile(fileName, sourceText, languageVersion, void 0, setParentNodes, scriptKind);
        }
        ts3.perfLogger.logStopParseSourceFile();
        ts3.performance.mark("afterParse");
        ts3.performance.measure("Parse", "beforeParse", "afterParse");
        ts3.tracing === null || ts3.tracing === void 0 ? void 0 : ts3.tracing.pop();
        return result2;
      }
      ts3.createSourceFile = createSourceFile;
      function parseIsolatedEntityName(text, languageVersion) {
        return Parser.parseIsolatedEntityName(text, languageVersion);
      }
      ts3.parseIsolatedEntityName = parseIsolatedEntityName;
      function parseJsonText(fileName, sourceText) {
        return Parser.parseJsonText(fileName, sourceText);
      }
      ts3.parseJsonText = parseJsonText;
      function isExternalModule(file) {
        return file.externalModuleIndicator !== void 0;
      }
      ts3.isExternalModule = isExternalModule;
      function updateSourceFile(sourceFile, newText, textChangeRange, aggressiveChecks) {
        if (aggressiveChecks === void 0) {
          aggressiveChecks = false;
        }
        var newSourceFile = IncrementalParser.updateSourceFile(sourceFile, newText, textChangeRange, aggressiveChecks);
        newSourceFile.flags |= sourceFile.flags & 3145728;
        return newSourceFile;
      }
      ts3.updateSourceFile = updateSourceFile;
      function parseIsolatedJSDocComment(content, start, length) {
        var result2 = Parser.JSDocParser.parseIsolatedJSDocComment(content, start, length);
        if (result2 && result2.jsDoc) {
          Parser.fixupParentReferences(result2.jsDoc);
        }
        return result2;
      }
      ts3.parseIsolatedJSDocComment = parseIsolatedJSDocComment;
      function parseJSDocTypeExpressionForTests(content, start, length) {
        return Parser.JSDocParser.parseJSDocTypeExpressionForTests(content, start, length);
      }
      ts3.parseJSDocTypeExpressionForTests = parseJSDocTypeExpressionForTests;
      var Parser;
      (function(Parser2) {
        var scanner = ts3.createScanner(99, true);
        var disallowInAndDecoratorContext = 4096 | 16384;
        var NodeConstructor2;
        var TokenConstructor2;
        var IdentifierConstructor2;
        var PrivateIdentifierConstructor2;
        var SourceFileConstructor2;
        function countNode(node) {
          nodeCount++;
          return node;
        }
        var baseNodeFactory = {
          createBaseSourceFileNode: function(kind) {
            return countNode(new SourceFileConstructor2(kind, 0, 0));
          },
          createBaseIdentifierNode: function(kind) {
            return countNode(new IdentifierConstructor2(kind, 0, 0));
          },
          createBasePrivateIdentifierNode: function(kind) {
            return countNode(new PrivateIdentifierConstructor2(kind, 0, 0));
          },
          createBaseTokenNode: function(kind) {
            return countNode(new TokenConstructor2(kind, 0, 0));
          },
          createBaseNode: function(kind) {
            return countNode(new NodeConstructor2(kind, 0, 0));
          }
        };
        var factory = ts3.createNodeFactory(1 | 2 | 8, baseNodeFactory);
        var fileName;
        var sourceFlags;
        var sourceText;
        var languageVersion;
        var scriptKind;
        var languageVariant;
        var parseDiagnostics;
        var jsDocDiagnostics;
        var syntaxCursor;
        var currentToken;
        var nodeCount;
        var identifiers;
        var privateIdentifiers;
        var identifierCount;
        var parsingContext;
        var notParenthesizedArrow;
        var contextFlags;
        var topLevel = true;
        var parseErrorBeforeNextFinishedNode = false;
        function parseSourceFile(fileName2, sourceText2, languageVersion2, syntaxCursor2, setParentNodes, scriptKind2) {
          var _a2;
          if (setParentNodes === void 0) {
            setParentNodes = false;
          }
          scriptKind2 = ts3.ensureScriptKind(fileName2, scriptKind2);
          if (scriptKind2 === 6) {
            var result_3 = parseJsonText2(fileName2, sourceText2, languageVersion2, syntaxCursor2, setParentNodes);
            ts3.convertToObjectWorker(result_3, (_a2 = result_3.statements[0]) === null || _a2 === void 0 ? void 0 : _a2.expression, result_3.parseDiagnostics, false, void 0, void 0);
            result_3.referencedFiles = ts3.emptyArray;
            result_3.typeReferenceDirectives = ts3.emptyArray;
            result_3.libReferenceDirectives = ts3.emptyArray;
            result_3.amdDependencies = ts3.emptyArray;
            result_3.hasNoDefaultLib = false;
            result_3.pragmas = ts3.emptyMap;
            return result_3;
          }
          initializeState(fileName2, sourceText2, languageVersion2, syntaxCursor2, scriptKind2);
          var result2 = parseSourceFileWorker(languageVersion2, setParentNodes, scriptKind2);
          clearState();
          return result2;
        }
        Parser2.parseSourceFile = parseSourceFile;
        function parseIsolatedEntityName2(content, languageVersion2) {
          initializeState("", content, languageVersion2, void 0, 1);
          nextToken();
          var entityName = parseEntityName(true);
          var isInvalid = token() === 1 && !parseDiagnostics.length;
          clearState();
          return isInvalid ? entityName : void 0;
        }
        Parser2.parseIsolatedEntityName = parseIsolatedEntityName2;
        function parseJsonText2(fileName2, sourceText2, languageVersion2, syntaxCursor2, setParentNodes) {
          if (languageVersion2 === void 0) {
            languageVersion2 = 2;
          }
          if (setParentNodes === void 0) {
            setParentNodes = false;
          }
          initializeState(fileName2, sourceText2, languageVersion2, syntaxCursor2, 6);
          sourceFlags = contextFlags;
          nextToken();
          var pos = getNodePos();
          var statements, endOfFileToken;
          if (token() === 1) {
            statements = createNodeArray([], pos, pos);
            endOfFileToken = parseTokenNode();
          } else {
            var expressions = void 0;
            while (token() !== 1) {
              var expression_1 = void 0;
              switch (token()) {
                case 22:
                  expression_1 = parseArrayLiteralExpression();
                  break;
                case 109:
                case 94:
                case 103:
                  expression_1 = parseTokenNode();
                  break;
                case 40:
                  if (lookAhead(function() {
                    return nextToken() === 8 && nextToken() !== 58;
                  })) {
                    expression_1 = parsePrefixUnaryExpression();
                  } else {
                    expression_1 = parseObjectLiteralExpression();
                  }
                  break;
                case 8:
                case 10:
                  if (lookAhead(function() {
                    return nextToken() !== 58;
                  })) {
                    expression_1 = parseLiteralNode();
                    break;
                  }
                default:
                  expression_1 = parseObjectLiteralExpression();
                  break;
              }
              if (expressions && ts3.isArray(expressions)) {
                expressions.push(expression_1);
              } else if (expressions) {
                expressions = [expressions, expression_1];
              } else {
                expressions = expression_1;
                if (token() !== 1) {
                  parseErrorAtCurrentToken(ts3.Diagnostics.Unexpected_token);
                }
              }
            }
            var expression = ts3.isArray(expressions) ? finishNode(factory.createArrayLiteralExpression(expressions), pos) : ts3.Debug.checkDefined(expressions);
            var statement = factory.createExpressionStatement(expression);
            finishNode(statement, pos);
            statements = createNodeArray([statement], pos);
            endOfFileToken = parseExpectedToken(1, ts3.Diagnostics.Unexpected_token);
          }
          var sourceFile = createSourceFile2(fileName2, 2, 6, false, statements, endOfFileToken, sourceFlags);
          if (setParentNodes) {
            fixupParentReferences(sourceFile);
          }
          sourceFile.nodeCount = nodeCount;
          sourceFile.identifierCount = identifierCount;
          sourceFile.identifiers = identifiers;
          sourceFile.parseDiagnostics = ts3.attachFileToDiagnostics(parseDiagnostics, sourceFile);
          if (jsDocDiagnostics) {
            sourceFile.jsDocDiagnostics = ts3.attachFileToDiagnostics(jsDocDiagnostics, sourceFile);
          }
          var result2 = sourceFile;
          clearState();
          return result2;
        }
        Parser2.parseJsonText = parseJsonText2;
        function initializeState(_fileName, _sourceText, _languageVersion, _syntaxCursor, _scriptKind) {
          NodeConstructor2 = ts3.objectAllocator.getNodeConstructor();
          TokenConstructor2 = ts3.objectAllocator.getTokenConstructor();
          IdentifierConstructor2 = ts3.objectAllocator.getIdentifierConstructor();
          PrivateIdentifierConstructor2 = ts3.objectAllocator.getPrivateIdentifierConstructor();
          SourceFileConstructor2 = ts3.objectAllocator.getSourceFileConstructor();
          fileName = ts3.normalizePath(_fileName);
          sourceText = _sourceText;
          languageVersion = _languageVersion;
          syntaxCursor = _syntaxCursor;
          scriptKind = _scriptKind;
          languageVariant = ts3.getLanguageVariant(_scriptKind);
          parseDiagnostics = [];
          parsingContext = 0;
          identifiers = new ts3.Map();
          privateIdentifiers = new ts3.Map();
          identifierCount = 0;
          nodeCount = 0;
          sourceFlags = 0;
          topLevel = true;
          switch (scriptKind) {
            case 1:
            case 2:
              contextFlags = 131072;
              break;
            case 6:
              contextFlags = 131072 | 33554432;
              break;
            default:
              contextFlags = 0;
              break;
          }
          parseErrorBeforeNextFinishedNode = false;
          scanner.setText(sourceText);
          scanner.setOnError(scanError);
          scanner.setScriptTarget(languageVersion);
          scanner.setLanguageVariant(languageVariant);
        }
        function clearState() {
          scanner.clearCommentDirectives();
          scanner.setText("");
          scanner.setOnError(void 0);
          sourceText = void 0;
          languageVersion = void 0;
          syntaxCursor = void 0;
          scriptKind = void 0;
          languageVariant = void 0;
          sourceFlags = 0;
          parseDiagnostics = void 0;
          jsDocDiagnostics = void 0;
          parsingContext = 0;
          identifiers = void 0;
          notParenthesizedArrow = void 0;
          topLevel = true;
        }
        function parseSourceFileWorker(languageVersion2, setParentNodes, scriptKind2) {
          var isDeclarationFile = isDeclarationFileName(fileName);
          if (isDeclarationFile) {
            contextFlags |= 8388608;
          }
          sourceFlags = contextFlags;
          nextToken();
          var statements = parseList(0, parseStatement);
          ts3.Debug.assert(token() === 1);
          var endOfFileToken = addJSDocComment(parseTokenNode());
          var sourceFile = createSourceFile2(fileName, languageVersion2, scriptKind2, isDeclarationFile, statements, endOfFileToken, sourceFlags);
          processCommentPragmas(sourceFile, sourceText);
          processPragmasIntoFields(sourceFile, reportPragmaDiagnostic);
          sourceFile.commentDirectives = scanner.getCommentDirectives();
          sourceFile.nodeCount = nodeCount;
          sourceFile.identifierCount = identifierCount;
          sourceFile.identifiers = identifiers;
          sourceFile.parseDiagnostics = ts3.attachFileToDiagnostics(parseDiagnostics, sourceFile);
          if (jsDocDiagnostics) {
            sourceFile.jsDocDiagnostics = ts3.attachFileToDiagnostics(jsDocDiagnostics, sourceFile);
          }
          if (setParentNodes) {
            fixupParentReferences(sourceFile);
          }
          return sourceFile;
          function reportPragmaDiagnostic(pos, end, diagnostic) {
            parseDiagnostics.push(ts3.createDetachedDiagnostic(fileName, pos, end, diagnostic));
          }
        }
        function withJSDoc(node, hasJSDoc) {
          return hasJSDoc ? addJSDocComment(node) : node;
        }
        var hasDeprecatedTag = false;
        function addJSDocComment(node) {
          ts3.Debug.assert(!node.jsDoc);
          var jsDoc = ts3.mapDefined(ts3.getJSDocCommentRanges(node, sourceText), function(comment) {
            return JSDocParser.parseJSDocComment(node, comment.pos, comment.end - comment.pos);
          });
          if (jsDoc.length)
            node.jsDoc = jsDoc;
          if (hasDeprecatedTag) {
            hasDeprecatedTag = false;
            node.flags |= 134217728;
          }
          return node;
        }
        function reparseTopLevelAwait(sourceFile) {
          var savedSyntaxCursor = syntaxCursor;
          var baseSyntaxCursor = IncrementalParser.createSyntaxCursor(sourceFile);
          syntaxCursor = { currentNode: currentNode2 };
          var statements = [];
          var savedParseDiagnostics = parseDiagnostics;
          parseDiagnostics = [];
          var pos = 0;
          var start = findNextStatementWithAwait(sourceFile.statements, 0);
          var _loop_3 = function() {
            var prevStatement = sourceFile.statements[pos];
            var nextStatement = sourceFile.statements[start];
            ts3.addRange(statements, sourceFile.statements, pos, start);
            pos = findNextStatementWithoutAwait(sourceFile.statements, start);
            var diagnosticStart2 = ts3.findIndex(savedParseDiagnostics, function(diagnostic) {
              return diagnostic.start >= prevStatement.pos;
            });
            var diagnosticEnd = diagnosticStart2 >= 0 ? ts3.findIndex(savedParseDiagnostics, function(diagnostic) {
              return diagnostic.start >= nextStatement.pos;
            }, diagnosticStart2) : -1;
            if (diagnosticStart2 >= 0) {
              ts3.addRange(parseDiagnostics, savedParseDiagnostics, diagnosticStart2, diagnosticEnd >= 0 ? diagnosticEnd : void 0);
            }
            speculationHelper(function() {
              var savedContextFlags = contextFlags;
              contextFlags |= 32768;
              scanner.setTextPos(nextStatement.pos);
              nextToken();
              while (token() !== 1) {
                var startPos = scanner.getStartPos();
                var statement = parseListElement(0, parseStatement);
                statements.push(statement);
                if (startPos === scanner.getStartPos()) {
                  nextToken();
                }
                if (pos >= 0) {
                  var nonAwaitStatement = sourceFile.statements[pos];
                  if (statement.end === nonAwaitStatement.pos) {
                    break;
                  }
                  if (statement.end > nonAwaitStatement.pos) {
                    pos = findNextStatementWithoutAwait(sourceFile.statements, pos + 1);
                  }
                }
              }
              contextFlags = savedContextFlags;
            }, 2);
            start = pos >= 0 ? findNextStatementWithAwait(sourceFile.statements, pos) : -1;
          };
          while (start !== -1) {
            _loop_3();
          }
          if (pos >= 0) {
            var prevStatement_1 = sourceFile.statements[pos];
            ts3.addRange(statements, sourceFile.statements, pos);
            var diagnosticStart = ts3.findIndex(savedParseDiagnostics, function(diagnostic) {
              return diagnostic.start >= prevStatement_1.pos;
            });
            if (diagnosticStart >= 0) {
              ts3.addRange(parseDiagnostics, savedParseDiagnostics, diagnosticStart);
            }
          }
          syntaxCursor = savedSyntaxCursor;
          return factory.updateSourceFile(sourceFile, ts3.setTextRange(factory.createNodeArray(statements), sourceFile.statements));
          function containsPossibleTopLevelAwait(node) {
            return !(node.flags & 32768) && !!(node.transformFlags & 16777216);
          }
          function findNextStatementWithAwait(statements2, start2) {
            for (var i3 = start2; i3 < statements2.length; i3++) {
              if (containsPossibleTopLevelAwait(statements2[i3])) {
                return i3;
              }
            }
            return -1;
          }
          function findNextStatementWithoutAwait(statements2, start2) {
            for (var i3 = start2; i3 < statements2.length; i3++) {
              if (!containsPossibleTopLevelAwait(statements2[i3])) {
                return i3;
              }
            }
            return -1;
          }
          function currentNode2(position) {
            var node = baseSyntaxCursor.currentNode(position);
            if (topLevel && node && containsPossibleTopLevelAwait(node)) {
              node.intersectsChange = true;
            }
            return node;
          }
        }
        function fixupParentReferences(rootNode) {
          ts3.setParentRecursive(rootNode, true);
        }
        Parser2.fixupParentReferences = fixupParentReferences;
        function createSourceFile2(fileName2, languageVersion2, scriptKind2, isDeclarationFile, statements, endOfFileToken, flags) {
          var sourceFile = factory.createSourceFile(statements, endOfFileToken, flags);
          ts3.setTextRangePosWidth(sourceFile, 0, sourceText.length);
          setExternalModuleIndicator(sourceFile);
          if (!isDeclarationFile && isExternalModule(sourceFile) && sourceFile.transformFlags & 16777216) {
            sourceFile = reparseTopLevelAwait(sourceFile);
          }
          sourceFile.text = sourceText;
          sourceFile.bindDiagnostics = [];
          sourceFile.bindSuggestionDiagnostics = void 0;
          sourceFile.languageVersion = languageVersion2;
          sourceFile.fileName = fileName2;
          sourceFile.languageVariant = ts3.getLanguageVariant(scriptKind2);
          sourceFile.isDeclarationFile = isDeclarationFile;
          sourceFile.scriptKind = scriptKind2;
          return sourceFile;
        }
        function setContextFlag(val, flag) {
          if (val) {
            contextFlags |= flag;
          } else {
            contextFlags &= ~flag;
          }
        }
        function setDisallowInContext(val) {
          setContextFlag(val, 4096);
        }
        function setYieldContext(val) {
          setContextFlag(val, 8192);
        }
        function setDecoratorContext(val) {
          setContextFlag(val, 16384);
        }
        function setAwaitContext(val) {
          setContextFlag(val, 32768);
        }
        function doOutsideOfContext(context, func2) {
          var contextFlagsToClear = context & contextFlags;
          if (contextFlagsToClear) {
            setContextFlag(false, contextFlagsToClear);
            var result2 = func2();
            setContextFlag(true, contextFlagsToClear);
            return result2;
          }
          return func2();
        }
        function doInsideOfContext(context, func2) {
          var contextFlagsToSet = context & ~contextFlags;
          if (contextFlagsToSet) {
            setContextFlag(true, contextFlagsToSet);
            var result2 = func2();
            setContextFlag(false, contextFlagsToSet);
            return result2;
          }
          return func2();
        }
        function allowInAnd(func2) {
          return doOutsideOfContext(4096, func2);
        }
        function disallowInAnd(func2) {
          return doInsideOfContext(4096, func2);
        }
        function doInYieldContext(func2) {
          return doInsideOfContext(8192, func2);
        }
        function doInDecoratorContext(func2) {
          return doInsideOfContext(16384, func2);
        }
        function doInAwaitContext(func2) {
          return doInsideOfContext(32768, func2);
        }
        function doOutsideOfAwaitContext(func2) {
          return doOutsideOfContext(32768, func2);
        }
        function doInYieldAndAwaitContext(func2) {
          return doInsideOfContext(8192 | 32768, func2);
        }
        function doOutsideOfYieldAndAwaitContext(func2) {
          return doOutsideOfContext(8192 | 32768, func2);
        }
        function inContext(flags) {
          return (contextFlags & flags) !== 0;
        }
        function inYieldContext() {
          return inContext(8192);
        }
        function inDisallowInContext() {
          return inContext(4096);
        }
        function inDecoratorContext() {
          return inContext(16384);
        }
        function inAwaitContext() {
          return inContext(32768);
        }
        function parseErrorAtCurrentToken(message, arg0) {
          parseErrorAt(scanner.getTokenPos(), scanner.getTextPos(), message, arg0);
        }
        function parseErrorAtPosition(start, length, message, arg0) {
          var lastError = ts3.lastOrUndefined(parseDiagnostics);
          if (!lastError || start !== lastError.start) {
            parseDiagnostics.push(ts3.createDetachedDiagnostic(fileName, start, length, message, arg0));
          }
          parseErrorBeforeNextFinishedNode = true;
        }
        function parseErrorAt(start, end, message, arg0) {
          parseErrorAtPosition(start, end - start, message, arg0);
        }
        function parseErrorAtRange(range, message, arg0) {
          parseErrorAt(range.pos, range.end, message, arg0);
        }
        function scanError(message, length) {
          parseErrorAtPosition(scanner.getTextPos(), length, message);
        }
        function getNodePos() {
          return scanner.getStartPos();
        }
        function hasPrecedingJSDocComment() {
          return scanner.hasPrecedingJSDocComment();
        }
        function token() {
          return currentToken;
        }
        function nextTokenWithoutCheck() {
          return currentToken = scanner.scan();
        }
        function nextTokenAnd(func2) {
          nextToken();
          return func2();
        }
        function nextToken() {
          if (ts3.isKeyword(currentToken) && (scanner.hasUnicodeEscape() || scanner.hasExtendedUnicodeEscape())) {
            parseErrorAt(scanner.getTokenPos(), scanner.getTextPos(), ts3.Diagnostics.Keywords_cannot_contain_escape_characters);
          }
          return nextTokenWithoutCheck();
        }
        function nextTokenJSDoc() {
          return currentToken = scanner.scanJsDocToken();
        }
        function reScanGreaterToken() {
          return currentToken = scanner.reScanGreaterToken();
        }
        function reScanSlashToken() {
          return currentToken = scanner.reScanSlashToken();
        }
        function reScanTemplateToken(isTaggedTemplate) {
          return currentToken = scanner.reScanTemplateToken(isTaggedTemplate);
        }
        function reScanTemplateHeadOrNoSubstitutionTemplate() {
          return currentToken = scanner.reScanTemplateHeadOrNoSubstitutionTemplate();
        }
        function reScanLessThanToken() {
          return currentToken = scanner.reScanLessThanToken();
        }
        function scanJsxIdentifier() {
          return currentToken = scanner.scanJsxIdentifier();
        }
        function scanJsxText() {
          return currentToken = scanner.scanJsxToken();
        }
        function scanJsxAttributeValue() {
          return currentToken = scanner.scanJsxAttributeValue();
        }
        function speculationHelper(callback, speculationKind) {
          var saveToken = currentToken;
          var saveParseDiagnosticsLength = parseDiagnostics.length;
          var saveParseErrorBeforeNextFinishedNode = parseErrorBeforeNextFinishedNode;
          var saveContextFlags = contextFlags;
          var result2 = speculationKind !== 0 ? scanner.lookAhead(callback) : scanner.tryScan(callback);
          ts3.Debug.assert(saveContextFlags === contextFlags);
          if (!result2 || speculationKind !== 0) {
            currentToken = saveToken;
            if (speculationKind !== 2) {
              parseDiagnostics.length = saveParseDiagnosticsLength;
            }
            parseErrorBeforeNextFinishedNode = saveParseErrorBeforeNextFinishedNode;
          }
          return result2;
        }
        function lookAhead(callback) {
          return speculationHelper(callback, 1);
        }
        function tryParse(callback) {
          return speculationHelper(callback, 0);
        }
        function isBindingIdentifier() {
          if (token() === 78) {
            return true;
          }
          return token() > 115;
        }
        function isIdentifier() {
          if (token() === 78) {
            return true;
          }
          if (token() === 124 && inYieldContext()) {
            return false;
          }
          if (token() === 130 && inAwaitContext()) {
            return false;
          }
          return token() > 115;
        }
        function parseExpected(kind, diagnosticMessage, shouldAdvance) {
          if (shouldAdvance === void 0) {
            shouldAdvance = true;
          }
          if (token() === kind) {
            if (shouldAdvance) {
              nextToken();
            }
            return true;
          }
          if (diagnosticMessage) {
            parseErrorAtCurrentToken(diagnosticMessage);
          } else {
            parseErrorAtCurrentToken(ts3.Diagnostics._0_expected, ts3.tokenToString(kind));
          }
          return false;
        }
        function parseExpectedJSDoc(kind) {
          if (token() === kind) {
            nextTokenJSDoc();
            return true;
          }
          parseErrorAtCurrentToken(ts3.Diagnostics._0_expected, ts3.tokenToString(kind));
          return false;
        }
        function parseOptional(t2) {
          if (token() === t2) {
            nextToken();
            return true;
          }
          return false;
        }
        function parseOptionalToken(t2) {
          if (token() === t2) {
            return parseTokenNode();
          }
          return void 0;
        }
        function parseOptionalTokenJSDoc(t2) {
          if (token() === t2) {
            return parseTokenNodeJSDoc();
          }
          return void 0;
        }
        function parseExpectedToken(t2, diagnosticMessage, arg0) {
          return parseOptionalToken(t2) || createMissingNode(t2, false, diagnosticMessage || ts3.Diagnostics._0_expected, arg0 || ts3.tokenToString(t2));
        }
        function parseExpectedTokenJSDoc(t2) {
          return parseOptionalTokenJSDoc(t2) || createMissingNode(t2, false, ts3.Diagnostics._0_expected, ts3.tokenToString(t2));
        }
        function parseTokenNode() {
          var pos = getNodePos();
          var kind = token();
          nextToken();
          return finishNode(factory.createToken(kind), pos);
        }
        function parseTokenNodeJSDoc() {
          var pos = getNodePos();
          var kind = token();
          nextTokenJSDoc();
          return finishNode(factory.createToken(kind), pos);
        }
        function canParseSemicolon() {
          if (token() === 26) {
            return true;
          }
          return token() === 19 || token() === 1 || scanner.hasPrecedingLineBreak();
        }
        function parseSemicolon() {
          if (canParseSemicolon()) {
            if (token() === 26) {
              nextToken();
            }
            return true;
          } else {
            return parseExpected(26);
          }
        }
        function createNodeArray(elements, pos, end, hasTrailingComma) {
          var array = factory.createNodeArray(elements, hasTrailingComma);
          ts3.setTextRangePosEnd(array, pos, end !== null && end !== void 0 ? end : scanner.getStartPos());
          return array;
        }
        function finishNode(node, pos, end) {
          ts3.setTextRangePosEnd(node, pos, end !== null && end !== void 0 ? end : scanner.getStartPos());
          if (contextFlags) {
            node.flags |= contextFlags;
          }
          if (parseErrorBeforeNextFinishedNode) {
            parseErrorBeforeNextFinishedNode = false;
            node.flags |= 65536;
          }
          return node;
        }
        function createMissingNode(kind, reportAtCurrentPosition, diagnosticMessage, arg0) {
          if (reportAtCurrentPosition) {
            parseErrorAtPosition(scanner.getStartPos(), 0, diagnosticMessage, arg0);
          } else if (diagnosticMessage) {
            parseErrorAtCurrentToken(diagnosticMessage, arg0);
          }
          var pos = getNodePos();
          var result2 = kind === 78 ? factory.createIdentifier("", void 0, void 0) : ts3.isTemplateLiteralKind(kind) ? factory.createTemplateLiteralLikeNode(kind, "", "", void 0) : kind === 8 ? factory.createNumericLiteral("", void 0) : kind === 10 ? factory.createStringLiteral("", void 0) : kind === 272 ? factory.createMissingDeclaration() : factory.createToken(kind);
          return finishNode(result2, pos);
        }
        function internIdentifier(text) {
          var identifier = identifiers.get(text);
          if (identifier === void 0) {
            identifiers.set(text, identifier = text);
          }
          return identifier;
        }
        function createIdentifier(isIdentifier2, diagnosticMessage, privateIdentifierDiagnosticMessage) {
          if (isIdentifier2) {
            identifierCount++;
            var pos = getNodePos();
            var originalKeywordKind = token();
            var text = internIdentifier(scanner.getTokenValue());
            nextTokenWithoutCheck();
            return finishNode(factory.createIdentifier(text, void 0, originalKeywordKind), pos);
          }
          if (token() === 79) {
            parseErrorAtCurrentToken(privateIdentifierDiagnosticMessage || ts3.Diagnostics.Private_identifiers_are_not_allowed_outside_class_bodies);
            return createIdentifier(true);
          }
          if (token() === 0 && scanner.tryScan(function() {
            return scanner.reScanInvalidIdentifier() === 78;
          })) {
            return createIdentifier(true);
          }
          identifierCount++;
          var reportAtCurrentPosition = token() === 1;
          var isReservedWord = scanner.isReservedWord();
          var msgArg = scanner.getTokenText();
          var defaultMessage = isReservedWord ? ts3.Diagnostics.Identifier_expected_0_is_a_reserved_word_that_cannot_be_used_here : ts3.Diagnostics.Identifier_expected;
          return createMissingNode(78, reportAtCurrentPosition, diagnosticMessage || defaultMessage, msgArg);
        }
        function parseBindingIdentifier(privateIdentifierDiagnosticMessage) {
          return createIdentifier(isBindingIdentifier(), void 0, privateIdentifierDiagnosticMessage);
        }
        function parseIdentifier(diagnosticMessage, privateIdentifierDiagnosticMessage) {
          return createIdentifier(isIdentifier(), diagnosticMessage, privateIdentifierDiagnosticMessage);
        }
        function parseIdentifierName(diagnosticMessage) {
          return createIdentifier(ts3.tokenIsIdentifierOrKeyword(token()), diagnosticMessage);
        }
        function isLiteralPropertyName() {
          return ts3.tokenIsIdentifierOrKeyword(token()) || token() === 10 || token() === 8;
        }
        function parsePropertyNameWorker(allowComputedPropertyNames) {
          if (token() === 10 || token() === 8) {
            var node = parseLiteralNode();
            node.text = internIdentifier(node.text);
            return node;
          }
          if (allowComputedPropertyNames && token() === 22) {
            return parseComputedPropertyName();
          }
          if (token() === 79) {
            return parsePrivateIdentifier();
          }
          return parseIdentifierName();
        }
        function parsePropertyName() {
          return parsePropertyNameWorker(true);
        }
        function parseComputedPropertyName() {
          var pos = getNodePos();
          parseExpected(22);
          var expression = allowInAnd(parseExpression);
          parseExpected(23);
          return finishNode(factory.createComputedPropertyName(expression), pos);
        }
        function internPrivateIdentifier(text) {
          var privateIdentifier = privateIdentifiers.get(text);
          if (privateIdentifier === void 0) {
            privateIdentifiers.set(text, privateIdentifier = text);
          }
          return privateIdentifier;
        }
        function parsePrivateIdentifier() {
          var pos = getNodePos();
          var node = factory.createPrivateIdentifier(internPrivateIdentifier(scanner.getTokenText()));
          nextToken();
          return finishNode(node, pos);
        }
        function parseContextualModifier(t2) {
          return token() === t2 && tryParse(nextTokenCanFollowModifier);
        }
        function nextTokenIsOnSameLineAndCanFollowModifier() {
          nextToken();
          if (scanner.hasPrecedingLineBreak()) {
            return false;
          }
          return canFollowModifier();
        }
        function nextTokenCanFollowModifier() {
          switch (token()) {
            case 84:
              return nextToken() === 91;
            case 92:
              nextToken();
              if (token() === 87) {
                return lookAhead(nextTokenCanFollowDefaultKeyword);
              }
              if (token() === 149) {
                return lookAhead(nextTokenCanFollowExportModifier);
              }
              return canFollowExportModifier();
            case 87:
              return nextTokenCanFollowDefaultKeyword();
            case 123:
              return nextTokenIsOnSameLineAndCanFollowModifier();
            case 134:
            case 146:
              nextToken();
              return canFollowModifier();
            default:
              return nextTokenIsOnSameLineAndCanFollowModifier();
          }
        }
        function canFollowExportModifier() {
          return token() !== 41 && token() !== 126 && token() !== 18 && canFollowModifier();
        }
        function nextTokenCanFollowExportModifier() {
          nextToken();
          return canFollowExportModifier();
        }
        function parseAnyContextualModifier() {
          return ts3.isModifierKind(token()) && tryParse(nextTokenCanFollowModifier);
        }
        function canFollowModifier() {
          return token() === 22 || token() === 18 || token() === 41 || token() === 25 || isLiteralPropertyName();
        }
        function nextTokenCanFollowDefaultKeyword() {
          nextToken();
          return token() === 83 || token() === 97 || token() === 117 || token() === 125 && lookAhead(nextTokenIsClassKeywordOnSameLine) || token() === 129 && lookAhead(nextTokenIsFunctionKeywordOnSameLine);
        }
        function isListElement(parsingContext2, inErrorRecovery) {
          var node = currentNode(parsingContext2);
          if (node) {
            return true;
          }
          switch (parsingContext2) {
            case 0:
            case 1:
            case 3:
              return !(token() === 26 && inErrorRecovery) && isStartOfStatement();
            case 2:
              return token() === 81 || token() === 87;
            case 4:
              return lookAhead(isTypeMemberStart);
            case 5:
              return lookAhead(isClassMemberStart) || token() === 26 && !inErrorRecovery;
            case 6:
              return token() === 22 || isLiteralPropertyName();
            case 12:
              switch (token()) {
                case 22:
                case 41:
                case 25:
                case 24:
                  return true;
                default:
                  return isLiteralPropertyName();
              }
            case 18:
              return isLiteralPropertyName();
            case 9:
              return token() === 22 || token() === 25 || isLiteralPropertyName();
            case 7:
              if (token() === 18) {
                return lookAhead(isValidHeritageClauseObjectLiteral);
              }
              if (!inErrorRecovery) {
                return isStartOfLeftHandSideExpression() && !isHeritageClauseExtendsOrImplementsKeyword();
              } else {
                return isIdentifier() && !isHeritageClauseExtendsOrImplementsKeyword();
              }
            case 8:
              return isBindingIdentifierOrPrivateIdentifierOrPattern();
            case 10:
              return token() === 27 || token() === 25 || isBindingIdentifierOrPrivateIdentifierOrPattern();
            case 19:
              return isIdentifier();
            case 15:
              switch (token()) {
                case 27:
                case 24:
                  return true;
              }
            case 11:
              return token() === 25 || isStartOfExpression();
            case 16:
              return isStartOfParameter(false);
            case 17:
              return isStartOfParameter(true);
            case 20:
            case 21:
              return token() === 27 || isStartOfType();
            case 22:
              return isHeritageClause();
            case 23:
              return ts3.tokenIsIdentifierOrKeyword(token());
            case 13:
              return ts3.tokenIsIdentifierOrKeyword(token()) || token() === 18;
            case 14:
              return true;
          }
          return ts3.Debug.fail("Non-exhaustive case in 'isListElement'.");
        }
        function isValidHeritageClauseObjectLiteral() {
          ts3.Debug.assert(token() === 18);
          if (nextToken() === 19) {
            var next = nextToken();
            return next === 27 || next === 18 || next === 93 || next === 116;
          }
          return true;
        }
        function nextTokenIsIdentifier() {
          nextToken();
          return isIdentifier();
        }
        function nextTokenIsIdentifierOrKeyword() {
          nextToken();
          return ts3.tokenIsIdentifierOrKeyword(token());
        }
        function nextTokenIsIdentifierOrKeywordOrGreaterThan() {
          nextToken();
          return ts3.tokenIsIdentifierOrKeywordOrGreaterThan(token());
        }
        function isHeritageClauseExtendsOrImplementsKeyword() {
          if (token() === 116 || token() === 93) {
            return lookAhead(nextTokenIsStartOfExpression);
          }
          return false;
        }
        function nextTokenIsStartOfExpression() {
          nextToken();
          return isStartOfExpression();
        }
        function nextTokenIsStartOfType() {
          nextToken();
          return isStartOfType();
        }
        function isListTerminator(kind) {
          if (token() === 1) {
            return true;
          }
          switch (kind) {
            case 1:
            case 2:
            case 4:
            case 5:
            case 6:
            case 12:
            case 9:
            case 23:
              return token() === 19;
            case 3:
              return token() === 19 || token() === 81 || token() === 87;
            case 7:
              return token() === 18 || token() === 93 || token() === 116;
            case 8:
              return isVariableDeclaratorListTerminator();
            case 19:
              return token() === 31 || token() === 20 || token() === 18 || token() === 93 || token() === 116;
            case 11:
              return token() === 21 || token() === 26;
            case 15:
            case 21:
            case 10:
              return token() === 23;
            case 17:
            case 16:
            case 18:
              return token() === 21 || token() === 23;
            case 20:
              return token() !== 27;
            case 22:
              return token() === 18 || token() === 19;
            case 13:
              return token() === 31 || token() === 43;
            case 14:
              return token() === 29 && lookAhead(nextTokenIsSlash);
            default:
              return false;
          }
        }
        function isVariableDeclaratorListTerminator() {
          if (canParseSemicolon()) {
            return true;
          }
          if (isInOrOfKeyword(token())) {
            return true;
          }
          if (token() === 38) {
            return true;
          }
          return false;
        }
        function isInSomeParsingContext() {
          for (var kind = 0; kind < 24; kind++) {
            if (parsingContext & 1 << kind) {
              if (isListElement(kind, true) || isListTerminator(kind)) {
                return true;
              }
            }
          }
          return false;
        }
        function parseList(kind, parseElement) {
          var saveParsingContext = parsingContext;
          parsingContext |= 1 << kind;
          var list = [];
          var listPos = getNodePos();
          while (!isListTerminator(kind)) {
            if (isListElement(kind, false)) {
              list.push(parseListElement(kind, parseElement));
              continue;
            }
            if (abortParsingListOrMoveToNextToken(kind)) {
              break;
            }
          }
          parsingContext = saveParsingContext;
          return createNodeArray(list, listPos);
        }
        function parseListElement(parsingContext2, parseElement) {
          var node = currentNode(parsingContext2);
          if (node) {
            return consumeNode(node);
          }
          return parseElement();
        }
        function currentNode(parsingContext2) {
          if (!syntaxCursor || !isReusableParsingContext(parsingContext2) || parseErrorBeforeNextFinishedNode) {
            return void 0;
          }
          var node = syntaxCursor.currentNode(scanner.getStartPos());
          if (ts3.nodeIsMissing(node) || node.intersectsChange || ts3.containsParseError(node)) {
            return void 0;
          }
          var nodeContextFlags = node.flags & 25358336;
          if (nodeContextFlags !== contextFlags) {
            return void 0;
          }
          if (!canReuseNode(node, parsingContext2)) {
            return void 0;
          }
          if (node.jsDocCache) {
            node.jsDocCache = void 0;
          }
          return node;
        }
        function consumeNode(node) {
          scanner.setTextPos(node.end);
          nextToken();
          return node;
        }
        function isReusableParsingContext(parsingContext2) {
          switch (parsingContext2) {
            case 5:
            case 2:
            case 0:
            case 1:
            case 3:
            case 6:
            case 4:
            case 8:
            case 17:
            case 16:
              return true;
          }
          return false;
        }
        function canReuseNode(node, parsingContext2) {
          switch (parsingContext2) {
            case 5:
              return isReusableClassMember(node);
            case 2:
              return isReusableSwitchClause(node);
            case 0:
            case 1:
            case 3:
              return isReusableStatement(node);
            case 6:
              return isReusableEnumMember(node);
            case 4:
              return isReusableTypeMember(node);
            case 8:
              return isReusableVariableDeclaration(node);
            case 17:
            case 16:
              return isReusableParameter(node);
          }
          return false;
        }
        function isReusableClassMember(node) {
          if (node) {
            switch (node.kind) {
              case 167:
              case 172:
              case 168:
              case 169:
              case 164:
              case 230:
                return true;
              case 166:
                var methodDeclaration = node;
                var nameIsConstructor = methodDeclaration.name.kind === 78 && methodDeclaration.name.originalKeywordKind === 132;
                return !nameIsConstructor;
            }
          }
          return false;
        }
        function isReusableSwitchClause(node) {
          if (node) {
            switch (node.kind) {
              case 285:
              case 286:
                return true;
            }
          }
          return false;
        }
        function isReusableStatement(node) {
          if (node) {
            switch (node.kind) {
              case 252:
              case 233:
              case 231:
              case 235:
              case 234:
              case 247:
              case 243:
              case 245:
              case 242:
              case 241:
              case 239:
              case 240:
              case 238:
              case 237:
              case 244:
              case 232:
              case 248:
              case 246:
              case 236:
              case 249:
              case 262:
              case 261:
              case 268:
              case 267:
              case 257:
              case 253:
              case 254:
              case 256:
              case 255:
                return true;
            }
          }
          return false;
        }
        function isReusableEnumMember(node) {
          return node.kind === 292;
        }
        function isReusableTypeMember(node) {
          if (node) {
            switch (node.kind) {
              case 171:
              case 165:
              case 172:
              case 163:
              case 170:
                return true;
            }
          }
          return false;
        }
        function isReusableVariableDeclaration(node) {
          if (node.kind !== 250) {
            return false;
          }
          var variableDeclarator = node;
          return variableDeclarator.initializer === void 0;
        }
        function isReusableParameter(node) {
          if (node.kind !== 161) {
            return false;
          }
          var parameter = node;
          return parameter.initializer === void 0;
        }
        function abortParsingListOrMoveToNextToken(kind) {
          parsingContextErrors(kind);
          if (isInSomeParsingContext()) {
            return true;
          }
          nextToken();
          return false;
        }
        function parsingContextErrors(context) {
          switch (context) {
            case 0:
              return parseErrorAtCurrentToken(ts3.Diagnostics.Declaration_or_statement_expected);
            case 1:
              return parseErrorAtCurrentToken(ts3.Diagnostics.Declaration_or_statement_expected);
            case 2:
              return parseErrorAtCurrentToken(ts3.Diagnostics.case_or_default_expected);
            case 3:
              return parseErrorAtCurrentToken(ts3.Diagnostics.Statement_expected);
            case 18:
            case 4:
              return parseErrorAtCurrentToken(ts3.Diagnostics.Property_or_signature_expected);
            case 5:
              return parseErrorAtCurrentToken(ts3.Diagnostics.Unexpected_token_A_constructor_method_accessor_or_property_was_expected);
            case 6:
              return parseErrorAtCurrentToken(ts3.Diagnostics.Enum_member_expected);
            case 7:
              return parseErrorAtCurrentToken(ts3.Diagnostics.Expression_expected);
            case 8:
              return ts3.isKeyword(token()) ? parseErrorAtCurrentToken(ts3.Diagnostics._0_is_not_allowed_as_a_variable_declaration_name, ts3.tokenToString(token())) : parseErrorAtCurrentToken(ts3.Diagnostics.Variable_declaration_expected);
            case 9:
              return parseErrorAtCurrentToken(ts3.Diagnostics.Property_destructuring_pattern_expected);
            case 10:
              return parseErrorAtCurrentToken(ts3.Diagnostics.Array_element_destructuring_pattern_expected);
            case 11:
              return parseErrorAtCurrentToken(ts3.Diagnostics.Argument_expression_expected);
            case 12:
              return parseErrorAtCurrentToken(ts3.Diagnostics.Property_assignment_expected);
            case 15:
              return parseErrorAtCurrentToken(ts3.Diagnostics.Expression_or_comma_expected);
            case 17:
              return parseErrorAtCurrentToken(ts3.Diagnostics.Parameter_declaration_expected);
            case 16:
              return parseErrorAtCurrentToken(ts3.Diagnostics.Parameter_declaration_expected);
            case 19:
              return parseErrorAtCurrentToken(ts3.Diagnostics.Type_parameter_declaration_expected);
            case 20:
              return parseErrorAtCurrentToken(ts3.Diagnostics.Type_argument_expected);
            case 21:
              return parseErrorAtCurrentToken(ts3.Diagnostics.Type_expected);
            case 22:
              return parseErrorAtCurrentToken(ts3.Diagnostics.Unexpected_token_expected);
            case 23:
              return parseErrorAtCurrentToken(ts3.Diagnostics.Identifier_expected);
            case 13:
              return parseErrorAtCurrentToken(ts3.Diagnostics.Identifier_expected);
            case 14:
              return parseErrorAtCurrentToken(ts3.Diagnostics.Identifier_expected);
            default:
              return [void 0];
          }
        }
        function parseDelimitedList(kind, parseElement, considerSemicolonAsDelimiter) {
          var saveParsingContext = parsingContext;
          parsingContext |= 1 << kind;
          var list = [];
          var listPos = getNodePos();
          var commaStart = -1;
          while (true) {
            if (isListElement(kind, false)) {
              var startPos = scanner.getStartPos();
              list.push(parseListElement(kind, parseElement));
              commaStart = scanner.getTokenPos();
              if (parseOptional(27)) {
                continue;
              }
              commaStart = -1;
              if (isListTerminator(kind)) {
                break;
              }
              parseExpected(27, getExpectedCommaDiagnostic(kind));
              if (considerSemicolonAsDelimiter && token() === 26 && !scanner.hasPrecedingLineBreak()) {
                nextToken();
              }
              if (startPos === scanner.getStartPos()) {
                nextToken();
              }
              continue;
            }
            if (isListTerminator(kind)) {
              break;
            }
            if (abortParsingListOrMoveToNextToken(kind)) {
              break;
            }
          }
          parsingContext = saveParsingContext;
          return createNodeArray(list, listPos, void 0, commaStart >= 0);
        }
        function getExpectedCommaDiagnostic(kind) {
          return kind === 6 ? ts3.Diagnostics.An_enum_member_name_must_be_followed_by_a_or : void 0;
        }
        function createMissingList() {
          var list = createNodeArray([], getNodePos());
          list.isMissingList = true;
          return list;
        }
        function isMissingList(arr) {
          return !!arr.isMissingList;
        }
        function parseBracketedList(kind, parseElement, open, close) {
          if (parseExpected(open)) {
            var result2 = parseDelimitedList(kind, parseElement);
            parseExpected(close);
            return result2;
          }
          return createMissingList();
        }
        function parseEntityName(allowReservedWords, diagnosticMessage) {
          var pos = getNodePos();
          var entity = allowReservedWords ? parseIdentifierName(diagnosticMessage) : parseIdentifier(diagnosticMessage);
          var dotPos = getNodePos();
          while (parseOptional(24)) {
            if (token() === 29) {
              entity.jsdocDotPos = dotPos;
              break;
            }
            dotPos = getNodePos();
            entity = finishNode(factory.createQualifiedName(entity, parseRightSideOfDot(allowReservedWords, false)), pos);
          }
          return entity;
        }
        function createQualifiedName(entity, name) {
          return finishNode(factory.createQualifiedName(entity, name), entity.pos);
        }
        function parseRightSideOfDot(allowIdentifierNames, allowPrivateIdentifiers) {
          if (scanner.hasPrecedingLineBreak() && ts3.tokenIsIdentifierOrKeyword(token())) {
            var matchesPattern = lookAhead(nextTokenIsIdentifierOrKeywordOnSameLine);
            if (matchesPattern) {
              return createMissingNode(78, true, ts3.Diagnostics.Identifier_expected);
            }
          }
          if (token() === 79) {
            var node = parsePrivateIdentifier();
            return allowPrivateIdentifiers ? node : createMissingNode(78, true, ts3.Diagnostics.Identifier_expected);
          }
          return allowIdentifierNames ? parseIdentifierName() : parseIdentifier();
        }
        function parseTemplateSpans(isTaggedTemplate) {
          var pos = getNodePos();
          var list = [];
          var node;
          do {
            node = parseTemplateSpan(isTaggedTemplate);
            list.push(node);
          } while (node.literal.kind === 16);
          return createNodeArray(list, pos);
        }
        function parseTemplateExpression(isTaggedTemplate) {
          var pos = getNodePos();
          return finishNode(factory.createTemplateExpression(parseTemplateHead(isTaggedTemplate), parseTemplateSpans(isTaggedTemplate)), pos);
        }
        function parseTemplateType() {
          var pos = getNodePos();
          return finishNode(factory.createTemplateLiteralType(parseTemplateHead(false), parseTemplateTypeSpans()), pos);
        }
        function parseTemplateTypeSpans() {
          var pos = getNodePos();
          var list = [];
          var node;
          do {
            node = parseTemplateTypeSpan();
            list.push(node);
          } while (node.literal.kind === 16);
          return createNodeArray(list, pos);
        }
        function parseTemplateTypeSpan() {
          var pos = getNodePos();
          return finishNode(factory.createTemplateLiteralTypeSpan(parseType(), parseLiteralOfTemplateSpan(false)), pos);
        }
        function parseLiteralOfTemplateSpan(isTaggedTemplate) {
          if (token() === 19) {
            reScanTemplateToken(isTaggedTemplate);
            return parseTemplateMiddleOrTemplateTail();
          } else {
            return parseExpectedToken(17, ts3.Diagnostics._0_expected, ts3.tokenToString(19));
          }
        }
        function parseTemplateSpan(isTaggedTemplate) {
          var pos = getNodePos();
          return finishNode(factory.createTemplateSpan(allowInAnd(parseExpression), parseLiteralOfTemplateSpan(isTaggedTemplate)), pos);
        }
        function parseLiteralNode() {
          return parseLiteralLikeNode(token());
        }
        function parseTemplateHead(isTaggedTemplate) {
          if (isTaggedTemplate) {
            reScanTemplateHeadOrNoSubstitutionTemplate();
          }
          var fragment = parseLiteralLikeNode(token());
          ts3.Debug.assert(fragment.kind === 15, "Template head has wrong token kind");
          return fragment;
        }
        function parseTemplateMiddleOrTemplateTail() {
          var fragment = parseLiteralLikeNode(token());
          ts3.Debug.assert(fragment.kind === 16 || fragment.kind === 17, "Template fragment has wrong token kind");
          return fragment;
        }
        function getTemplateLiteralRawText(kind) {
          var isLast = kind === 14 || kind === 17;
          var tokenText = scanner.getTokenText();
          return tokenText.substring(1, tokenText.length - (scanner.isUnterminated() ? 0 : isLast ? 1 : 2));
        }
        function parseLiteralLikeNode(kind) {
          var pos = getNodePos();
          var node = ts3.isTemplateLiteralKind(kind) ? factory.createTemplateLiteralLikeNode(kind, scanner.getTokenValue(), getTemplateLiteralRawText(kind), scanner.getTokenFlags() & 2048) : kind === 8 ? factory.createNumericLiteral(scanner.getTokenValue(), scanner.getNumericLiteralFlags()) : kind === 10 ? factory.createStringLiteral(scanner.getTokenValue(), void 0, scanner.hasExtendedUnicodeEscape()) : ts3.isLiteralKind(kind) ? factory.createLiteralLikeNode(kind, scanner.getTokenValue()) : ts3.Debug.fail();
          if (scanner.hasExtendedUnicodeEscape()) {
            node.hasExtendedUnicodeEscape = true;
          }
          if (scanner.isUnterminated()) {
            node.isUnterminated = true;
          }
          nextToken();
          return finishNode(node, pos);
        }
        function parseEntityNameOfTypeReference() {
          return parseEntityName(true, ts3.Diagnostics.Type_expected);
        }
        function parseTypeArgumentsOfTypeReference() {
          if (!scanner.hasPrecedingLineBreak() && reScanLessThanToken() === 29) {
            return parseBracketedList(20, parseType, 29, 31);
          }
        }
        function parseTypeReference() {
          var pos = getNodePos();
          return finishNode(factory.createTypeReferenceNode(parseEntityNameOfTypeReference(), parseTypeArgumentsOfTypeReference()), pos);
        }
        function typeHasArrowFunctionBlockingParseError(node) {
          switch (node.kind) {
            case 174:
              return ts3.nodeIsMissing(node.typeName);
            case 175:
            case 176: {
              var _a2 = node, parameters = _a2.parameters, type3 = _a2.type;
              return isMissingList(parameters) || typeHasArrowFunctionBlockingParseError(type3);
            }
            case 187:
              return typeHasArrowFunctionBlockingParseError(node.type);
            default:
              return false;
          }
        }
        function parseThisTypePredicate(lhs) {
          nextToken();
          return finishNode(factory.createTypePredicateNode(void 0, lhs, parseType()), lhs.pos);
        }
        function parseThisTypeNode() {
          var pos = getNodePos();
          nextToken();
          return finishNode(factory.createThisTypeNode(), pos);
        }
        function parseJSDocAllType() {
          var pos = getNodePos();
          nextToken();
          return finishNode(factory.createJSDocAllType(), pos);
        }
        function parseJSDocNonNullableType() {
          var pos = getNodePos();
          nextToken();
          return finishNode(factory.createJSDocNonNullableType(parseNonArrayType()), pos);
        }
        function parseJSDocUnknownOrNullableType() {
          var pos = getNodePos();
          nextToken();
          if (token() === 27 || token() === 19 || token() === 21 || token() === 31 || token() === 62 || token() === 51) {
            return finishNode(factory.createJSDocUnknownType(), pos);
          } else {
            return finishNode(factory.createJSDocNullableType(parseType()), pos);
          }
        }
        function parseJSDocFunctionType() {
          var pos = getNodePos();
          var hasJSDoc = hasPrecedingJSDocComment();
          if (lookAhead(nextTokenIsOpenParen)) {
            nextToken();
            var parameters = parseParameters(4 | 32);
            var type3 = parseReturnType(58, false);
            return withJSDoc(finishNode(factory.createJSDocFunctionType(parameters, type3), pos), hasJSDoc);
          }
          return finishNode(factory.createTypeReferenceNode(parseIdentifierName(), void 0), pos);
        }
        function parseJSDocParameter() {
          var pos = getNodePos();
          var name;
          if (token() === 107 || token() === 102) {
            name = parseIdentifierName();
            parseExpected(58);
          }
          return finishNode(factory.createParameterDeclaration(void 0, void 0, void 0, name, void 0, parseJSDocType(), void 0), pos);
        }
        function parseJSDocType() {
          scanner.setInJSDocType(true);
          var pos = getNodePos();
          if (parseOptional(139)) {
            var moduleTag = factory.createJSDocNamepathType(void 0);
            terminate:
              while (true) {
                switch (token()) {
                  case 19:
                  case 1:
                  case 27:
                  case 5:
                    break terminate;
                  default:
                    nextTokenJSDoc();
                }
              }
            scanner.setInJSDocType(false);
            return finishNode(moduleTag, pos);
          }
          var hasDotDotDot = parseOptional(25);
          var type3 = parseTypeOrTypePredicate();
          scanner.setInJSDocType(false);
          if (hasDotDotDot) {
            type3 = finishNode(factory.createJSDocVariadicType(type3), pos);
          }
          if (token() === 62) {
            nextToken();
            return finishNode(factory.createJSDocOptionalType(type3), pos);
          }
          return type3;
        }
        function parseTypeQuery() {
          var pos = getNodePos();
          parseExpected(111);
          return finishNode(factory.createTypeQueryNode(parseEntityName(true)), pos);
        }
        function parseTypeParameter() {
          var pos = getNodePos();
          var name = parseIdentifier();
          var constraint;
          var expression;
          if (parseOptional(93)) {
            if (isStartOfType() || !isStartOfExpression()) {
              constraint = parseType();
            } else {
              expression = parseUnaryExpressionOrHigher();
            }
          }
          var defaultType = parseOptional(62) ? parseType() : void 0;
          var node = factory.createTypeParameterDeclaration(name, constraint, defaultType);
          node.expression = expression;
          return finishNode(node, pos);
        }
        function parseTypeParameters() {
          if (token() === 29) {
            return parseBracketedList(19, parseTypeParameter, 29, 31);
          }
        }
        function isStartOfParameter(isJSDocParameter) {
          return token() === 25 || isBindingIdentifierOrPrivateIdentifierOrPattern() || ts3.isModifierKind(token()) || token() === 59 || isStartOfType(!isJSDocParameter);
        }
        function parseNameOfParameter(modifiers) {
          var name = parseIdentifierOrPattern(ts3.Diagnostics.Private_identifiers_cannot_be_used_as_parameters);
          if (ts3.getFullWidth(name) === 0 && !ts3.some(modifiers) && ts3.isModifierKind(token())) {
            nextToken();
          }
          return name;
        }
        function parseParameterInOuterAwaitContext() {
          return parseParameterWorker(true);
        }
        function parseParameter() {
          return parseParameterWorker(false);
        }
        function parseParameterWorker(inOuterAwaitContext) {
          var pos = getNodePos();
          var hasJSDoc = hasPrecedingJSDocComment();
          var decorators = inOuterAwaitContext ? doInAwaitContext(parseDecorators) : parseDecorators();
          if (token() === 107) {
            var node_1 = factory.createParameterDeclaration(decorators, void 0, void 0, createIdentifier(true), void 0, parseTypeAnnotation(), void 0);
            if (decorators) {
              parseErrorAtRange(decorators[0], ts3.Diagnostics.Decorators_may_not_be_applied_to_this_parameters);
            }
            return withJSDoc(finishNode(node_1, pos), hasJSDoc);
          }
          var savedTopLevel = topLevel;
          topLevel = false;
          var modifiers = parseModifiers();
          var node = withJSDoc(finishNode(factory.createParameterDeclaration(decorators, modifiers, parseOptionalToken(25), parseNameOfParameter(modifiers), parseOptionalToken(57), parseTypeAnnotation(), parseInitializer()), pos), hasJSDoc);
          topLevel = savedTopLevel;
          return node;
        }
        function parseReturnType(returnToken, isType) {
          if (shouldParseReturnType(returnToken, isType)) {
            return parseTypeOrTypePredicate();
          }
        }
        function shouldParseReturnType(returnToken, isType) {
          if (returnToken === 38) {
            parseExpected(returnToken);
            return true;
          } else if (parseOptional(58)) {
            return true;
          } else if (isType && token() === 38) {
            parseErrorAtCurrentToken(ts3.Diagnostics._0_expected, ts3.tokenToString(58));
            nextToken();
            return true;
          }
          return false;
        }
        function parseParametersWorker(flags) {
          var savedYieldContext = inYieldContext();
          var savedAwaitContext = inAwaitContext();
          setYieldContext(!!(flags & 1));
          setAwaitContext(!!(flags & 2));
          var parameters = flags & 32 ? parseDelimitedList(17, parseJSDocParameter) : parseDelimitedList(16, savedAwaitContext ? parseParameterInOuterAwaitContext : parseParameter);
          setYieldContext(savedYieldContext);
          setAwaitContext(savedAwaitContext);
          return parameters;
        }
        function parseParameters(flags) {
          if (!parseExpected(20)) {
            return createMissingList();
          }
          var parameters = parseParametersWorker(flags);
          parseExpected(21);
          return parameters;
        }
        function parseTypeMemberSemicolon() {
          if (parseOptional(27)) {
            return;
          }
          parseSemicolon();
        }
        function parseSignatureMember(kind) {
          var pos = getNodePos();
          var hasJSDoc = hasPrecedingJSDocComment();
          if (kind === 171) {
            parseExpected(102);
          }
          var typeParameters = parseTypeParameters();
          var parameters = parseParameters(4);
          var type3 = parseReturnType(58, true);
          parseTypeMemberSemicolon();
          var node = kind === 170 ? factory.createCallSignature(typeParameters, parameters, type3) : factory.createConstructSignature(typeParameters, parameters, type3);
          return withJSDoc(finishNode(node, pos), hasJSDoc);
        }
        function isIndexSignature() {
          return token() === 22 && lookAhead(isUnambiguouslyIndexSignature);
        }
        function isUnambiguouslyIndexSignature() {
          nextToken();
          if (token() === 25 || token() === 23) {
            return true;
          }
          if (ts3.isModifierKind(token())) {
            nextToken();
            if (isIdentifier()) {
              return true;
            }
          } else if (!isIdentifier()) {
            return false;
          } else {
            nextToken();
          }
          if (token() === 58 || token() === 27) {
            return true;
          }
          if (token() !== 57) {
            return false;
          }
          nextToken();
          return token() === 58 || token() === 27 || token() === 23;
        }
        function parseIndexSignatureDeclaration(pos, hasJSDoc, decorators, modifiers) {
          var parameters = parseBracketedList(16, parseParameter, 22, 23);
          var type3 = parseTypeAnnotation();
          parseTypeMemberSemicolon();
          var node = factory.createIndexSignature(decorators, modifiers, parameters, type3);
          return withJSDoc(finishNode(node, pos), hasJSDoc);
        }
        function parsePropertyOrMethodSignature(pos, hasJSDoc, modifiers) {
          var name = parsePropertyName();
          var questionToken = parseOptionalToken(57);
          var node;
          if (token() === 20 || token() === 29) {
            var typeParameters = parseTypeParameters();
            var parameters = parseParameters(4);
            var type3 = parseReturnType(58, true);
            node = factory.createMethodSignature(modifiers, name, questionToken, typeParameters, parameters, type3);
          } else {
            var type3 = parseTypeAnnotation();
            node = factory.createPropertySignature(modifiers, name, questionToken, type3);
            if (token() === 62)
              node.initializer = parseInitializer();
          }
          parseTypeMemberSemicolon();
          return withJSDoc(finishNode(node, pos), hasJSDoc);
        }
        function isTypeMemberStart() {
          if (token() === 20 || token() === 29 || token() === 134 || token() === 146) {
            return true;
          }
          var idToken = false;
          while (ts3.isModifierKind(token())) {
            idToken = true;
            nextToken();
          }
          if (token() === 22) {
            return true;
          }
          if (isLiteralPropertyName()) {
            idToken = true;
            nextToken();
          }
          if (idToken) {
            return token() === 20 || token() === 29 || token() === 57 || token() === 58 || token() === 27 || canParseSemicolon();
          }
          return false;
        }
        function parseTypeMember() {
          if (token() === 20 || token() === 29) {
            return parseSignatureMember(170);
          }
          if (token() === 102 && lookAhead(nextTokenIsOpenParenOrLessThan)) {
            return parseSignatureMember(171);
          }
          var pos = getNodePos();
          var hasJSDoc = hasPrecedingJSDocComment();
          var modifiers = parseModifiers();
          if (parseContextualModifier(134)) {
            return parseAccessorDeclaration(pos, hasJSDoc, void 0, modifiers, 168);
          }
          if (parseContextualModifier(146)) {
            return parseAccessorDeclaration(pos, hasJSDoc, void 0, modifiers, 169);
          }
          if (isIndexSignature()) {
            return parseIndexSignatureDeclaration(pos, hasJSDoc, void 0, modifiers);
          }
          return parsePropertyOrMethodSignature(pos, hasJSDoc, modifiers);
        }
        function nextTokenIsOpenParenOrLessThan() {
          nextToken();
          return token() === 20 || token() === 29;
        }
        function nextTokenIsDot() {
          return nextToken() === 24;
        }
        function nextTokenIsOpenParenOrLessThanOrDot() {
          switch (nextToken()) {
            case 20:
            case 29:
            case 24:
              return true;
          }
          return false;
        }
        function parseTypeLiteral() {
          var pos = getNodePos();
          return finishNode(factory.createTypeLiteralNode(parseObjectTypeMembers()), pos);
        }
        function parseObjectTypeMembers() {
          var members;
          if (parseExpected(18)) {
            members = parseList(4, parseTypeMember);
            parseExpected(19);
          } else {
            members = createMissingList();
          }
          return members;
        }
        function isStartOfMappedType() {
          nextToken();
          if (token() === 39 || token() === 40) {
            return nextToken() === 142;
          }
          if (token() === 142) {
            nextToken();
          }
          return token() === 22 && nextTokenIsIdentifier() && nextToken() === 100;
        }
        function parseMappedTypeParameter() {
          var pos = getNodePos();
          var name = parseIdentifierName();
          parseExpected(100);
          var type3 = parseType();
          return finishNode(factory.createTypeParameterDeclaration(name, type3, void 0), pos);
        }
        function parseMappedType() {
          var pos = getNodePos();
          parseExpected(18);
          var readonlyToken;
          if (token() === 142 || token() === 39 || token() === 40) {
            readonlyToken = parseTokenNode();
            if (readonlyToken.kind !== 142) {
              parseExpected(142);
            }
          }
          parseExpected(22);
          var typeParameter = parseMappedTypeParameter();
          var nameType = parseOptional(126) ? parseType() : void 0;
          parseExpected(23);
          var questionToken;
          if (token() === 57 || token() === 39 || token() === 40) {
            questionToken = parseTokenNode();
            if (questionToken.kind !== 57) {
              parseExpected(57);
            }
          }
          var type3 = parseTypeAnnotation();
          parseSemicolon();
          parseExpected(19);
          return finishNode(factory.createMappedTypeNode(readonlyToken, typeParameter, nameType, questionToken, type3), pos);
        }
        function parseTupleElementType() {
          var pos = getNodePos();
          if (parseOptional(25)) {
            return finishNode(factory.createRestTypeNode(parseType()), pos);
          }
          var type3 = parseType();
          if (ts3.isJSDocNullableType(type3) && type3.pos === type3.type.pos) {
            var node = factory.createOptionalTypeNode(type3.type);
            ts3.setTextRange(node, type3);
            node.flags = type3.flags;
            return node;
          }
          return type3;
        }
        function isNextTokenColonOrQuestionColon() {
          return nextToken() === 58 || token() === 57 && nextToken() === 58;
        }
        function isTupleElementName() {
          if (token() === 25) {
            return ts3.tokenIsIdentifierOrKeyword(nextToken()) && isNextTokenColonOrQuestionColon();
          }
          return ts3.tokenIsIdentifierOrKeyword(token()) && isNextTokenColonOrQuestionColon();
        }
        function parseTupleElementNameOrTupleElementType() {
          if (lookAhead(isTupleElementName)) {
            var pos = getNodePos();
            var hasJSDoc = hasPrecedingJSDocComment();
            var dotDotDotToken = parseOptionalToken(25);
            var name = parseIdentifierName();
            var questionToken = parseOptionalToken(57);
            parseExpected(58);
            var type3 = parseTupleElementType();
            var node = factory.createNamedTupleMember(dotDotDotToken, name, questionToken, type3);
            return withJSDoc(finishNode(node, pos), hasJSDoc);
          }
          return parseTupleElementType();
        }
        function parseTupleType() {
          var pos = getNodePos();
          return finishNode(factory.createTupleTypeNode(parseBracketedList(21, parseTupleElementNameOrTupleElementType, 22, 23)), pos);
        }
        function parseParenthesizedType() {
          var pos = getNodePos();
          parseExpected(20);
          var type3 = parseType();
          parseExpected(21);
          return finishNode(factory.createParenthesizedType(type3), pos);
        }
        function parseModifiersForConstructorType() {
          var modifiers;
          if (token() === 125) {
            var pos = getNodePos();
            nextToken();
            var modifier = finishNode(factory.createToken(125), pos);
            modifiers = createNodeArray([modifier], pos);
          }
          return modifiers;
        }
        function parseFunctionOrConstructorType() {
          var pos = getNodePos();
          var hasJSDoc = hasPrecedingJSDocComment();
          var modifiers = parseModifiersForConstructorType();
          var isConstructorType = parseOptional(102);
          var typeParameters = parseTypeParameters();
          var parameters = parseParameters(4);
          var type3 = parseReturnType(38, false);
          var node = isConstructorType ? factory.createConstructorTypeNode(modifiers, typeParameters, parameters, type3) : factory.createFunctionTypeNode(typeParameters, parameters, type3);
          if (!isConstructorType)
            node.modifiers = modifiers;
          return withJSDoc(finishNode(node, pos), hasJSDoc);
        }
        function parseKeywordAndNoDot() {
          var node = parseTokenNode();
          return token() === 24 ? void 0 : node;
        }
        function parseLiteralTypeNode(negative) {
          var pos = getNodePos();
          if (negative) {
            nextToken();
          }
          var expression = token() === 109 || token() === 94 || token() === 103 ? parseTokenNode() : parseLiteralLikeNode(token());
          if (negative) {
            expression = finishNode(factory.createPrefixUnaryExpression(40, expression), pos);
          }
          return finishNode(factory.createLiteralTypeNode(expression), pos);
        }
        function isStartOfTypeOfImportType() {
          nextToken();
          return token() === 99;
        }
        function parseImportType() {
          sourceFlags |= 1048576;
          var pos = getNodePos();
          var isTypeOf = parseOptional(111);
          parseExpected(99);
          parseExpected(20);
          var type3 = parseType();
          parseExpected(21);
          var qualifier = parseOptional(24) ? parseEntityNameOfTypeReference() : void 0;
          var typeArguments = parseTypeArgumentsOfTypeReference();
          return finishNode(factory.createImportTypeNode(type3, qualifier, typeArguments, isTypeOf), pos);
        }
        function nextTokenIsNumericOrBigIntLiteral() {
          nextToken();
          return token() === 8 || token() === 9;
        }
        function parseNonArrayType() {
          switch (token()) {
            case 128:
            case 152:
            case 147:
            case 144:
            case 155:
            case 148:
            case 131:
            case 150:
            case 141:
            case 145:
              return tryParse(parseKeywordAndNoDot) || parseTypeReference();
            case 65:
              scanner.reScanAsteriskEqualsToken();
            case 41:
              return parseJSDocAllType();
            case 60:
              scanner.reScanQuestionToken();
            case 57:
              return parseJSDocUnknownOrNullableType();
            case 97:
              return parseJSDocFunctionType();
            case 53:
              return parseJSDocNonNullableType();
            case 14:
            case 10:
            case 8:
            case 9:
            case 109:
            case 94:
            case 103:
              return parseLiteralTypeNode();
            case 40:
              return lookAhead(nextTokenIsNumericOrBigIntLiteral) ? parseLiteralTypeNode(true) : parseTypeReference();
            case 113:
              return parseTokenNode();
            case 107: {
              var thisKeyword = parseThisTypeNode();
              if (token() === 137 && !scanner.hasPrecedingLineBreak()) {
                return parseThisTypePredicate(thisKeyword);
              } else {
                return thisKeyword;
              }
            }
            case 111:
              return lookAhead(isStartOfTypeOfImportType) ? parseImportType() : parseTypeQuery();
            case 18:
              return lookAhead(isStartOfMappedType) ? parseMappedType() : parseTypeLiteral();
            case 22:
              return parseTupleType();
            case 20:
              return parseParenthesizedType();
            case 99:
              return parseImportType();
            case 127:
              return lookAhead(nextTokenIsIdentifierOrKeywordOnSameLine) ? parseAssertsTypePredicate() : parseTypeReference();
            case 15:
              return parseTemplateType();
            default:
              return parseTypeReference();
          }
        }
        function isStartOfType(inStartOfParameter) {
          switch (token()) {
            case 128:
            case 152:
            case 147:
            case 144:
            case 155:
            case 131:
            case 142:
            case 148:
            case 151:
            case 113:
            case 150:
            case 103:
            case 107:
            case 111:
            case 141:
            case 18:
            case 22:
            case 29:
            case 51:
            case 50:
            case 102:
            case 10:
            case 8:
            case 9:
            case 109:
            case 94:
            case 145:
            case 41:
            case 57:
            case 53:
            case 25:
            case 135:
            case 99:
            case 127:
            case 14:
            case 15:
              return true;
            case 97:
              return !inStartOfParameter;
            case 40:
              return !inStartOfParameter && lookAhead(nextTokenIsNumericOrBigIntLiteral);
            case 20:
              return !inStartOfParameter && lookAhead(isStartOfParenthesizedOrFunctionType);
            default:
              return isIdentifier();
          }
        }
        function isStartOfParenthesizedOrFunctionType() {
          nextToken();
          return token() === 21 || isStartOfParameter(false) || isStartOfType();
        }
        function parsePostfixTypeOrHigher() {
          var pos = getNodePos();
          var type3 = parseNonArrayType();
          while (!scanner.hasPrecedingLineBreak()) {
            switch (token()) {
              case 53:
                nextToken();
                type3 = finishNode(factory.createJSDocNonNullableType(type3), pos);
                break;
              case 57:
                if (lookAhead(nextTokenIsStartOfType)) {
                  return type3;
                }
                nextToken();
                type3 = finishNode(factory.createJSDocNullableType(type3), pos);
                break;
              case 22:
                parseExpected(22);
                if (isStartOfType()) {
                  var indexType = parseType();
                  parseExpected(23);
                  type3 = finishNode(factory.createIndexedAccessTypeNode(type3, indexType), pos);
                } else {
                  parseExpected(23);
                  type3 = finishNode(factory.createArrayTypeNode(type3), pos);
                }
                break;
              default:
                return type3;
            }
          }
          return type3;
        }
        function parseTypeOperator(operator) {
          var pos = getNodePos();
          parseExpected(operator);
          return finishNode(factory.createTypeOperatorNode(operator, parseTypeOperatorOrHigher()), pos);
        }
        function parseTypeParameterOfInferType() {
          var pos = getNodePos();
          return finishNode(factory.createTypeParameterDeclaration(parseIdentifier(), void 0, void 0), pos);
        }
        function parseInferType() {
          var pos = getNodePos();
          parseExpected(135);
          return finishNode(factory.createInferTypeNode(parseTypeParameterOfInferType()), pos);
        }
        function parseTypeOperatorOrHigher() {
          var operator = token();
          switch (operator) {
            case 138:
            case 151:
            case 142:
              return parseTypeOperator(operator);
            case 135:
              return parseInferType();
          }
          return parsePostfixTypeOrHigher();
        }
        function parseFunctionOrConstructorTypeToError(isInUnionType) {
          if (isStartOfFunctionTypeOrConstructorType()) {
            var type3 = parseFunctionOrConstructorType();
            var diagnostic = void 0;
            if (ts3.isFunctionTypeNode(type3)) {
              diagnostic = isInUnionType ? ts3.Diagnostics.Function_type_notation_must_be_parenthesized_when_used_in_a_union_type : ts3.Diagnostics.Function_type_notation_must_be_parenthesized_when_used_in_an_intersection_type;
            } else {
              diagnostic = isInUnionType ? ts3.Diagnostics.Constructor_type_notation_must_be_parenthesized_when_used_in_a_union_type : ts3.Diagnostics.Constructor_type_notation_must_be_parenthesized_when_used_in_an_intersection_type;
            }
            parseErrorAtRange(type3, diagnostic);
            return type3;
          }
          return void 0;
        }
        function parseUnionOrIntersectionType(operator, parseConstituentType, createTypeNode) {
          var pos = getNodePos();
          var isUnionType = operator === 51;
          var hasLeadingOperator = parseOptional(operator);
          var type3 = hasLeadingOperator && parseFunctionOrConstructorTypeToError(isUnionType) || parseConstituentType();
          if (token() === operator || hasLeadingOperator) {
            var types2 = [type3];
            while (parseOptional(operator)) {
              types2.push(parseFunctionOrConstructorTypeToError(isUnionType) || parseConstituentType());
            }
            type3 = finishNode(createTypeNode(createNodeArray(types2, pos)), pos);
          }
          return type3;
        }
        function parseIntersectionTypeOrHigher() {
          return parseUnionOrIntersectionType(50, parseTypeOperatorOrHigher, factory.createIntersectionTypeNode);
        }
        function parseUnionTypeOrHigher() {
          return parseUnionOrIntersectionType(51, parseIntersectionTypeOrHigher, factory.createUnionTypeNode);
        }
        function nextTokenIsNewKeyword() {
          nextToken();
          return token() === 102;
        }
        function isStartOfFunctionTypeOrConstructorType() {
          if (token() === 29) {
            return true;
          }
          if (token() === 20 && lookAhead(isUnambiguouslyStartOfFunctionType)) {
            return true;
          }
          return token() === 102 || token() === 125 && lookAhead(nextTokenIsNewKeyword);
        }
        function skipParameterStart() {
          if (ts3.isModifierKind(token())) {
            parseModifiers();
          }
          if (isIdentifier() || token() === 107) {
            nextToken();
            return true;
          }
          if (token() === 22 || token() === 18) {
            var previousErrorCount = parseDiagnostics.length;
            parseIdentifierOrPattern();
            return previousErrorCount === parseDiagnostics.length;
          }
          return false;
        }
        function isUnambiguouslyStartOfFunctionType() {
          nextToken();
          if (token() === 21 || token() === 25) {
            return true;
          }
          if (skipParameterStart()) {
            if (token() === 58 || token() === 27 || token() === 57 || token() === 62) {
              return true;
            }
            if (token() === 21) {
              nextToken();
              if (token() === 38) {
                return true;
              }
            }
          }
          return false;
        }
        function parseTypeOrTypePredicate() {
          var pos = getNodePos();
          var typePredicateVariable = isIdentifier() && tryParse(parseTypePredicatePrefix);
          var type3 = parseType();
          if (typePredicateVariable) {
            return finishNode(factory.createTypePredicateNode(void 0, typePredicateVariable, type3), pos);
          } else {
            return type3;
          }
        }
        function parseTypePredicatePrefix() {
          var id = parseIdentifier();
          if (token() === 137 && !scanner.hasPrecedingLineBreak()) {
            nextToken();
            return id;
          }
        }
        function parseAssertsTypePredicate() {
          var pos = getNodePos();
          var assertsModifier = parseExpectedToken(127);
          var parameterName = token() === 107 ? parseThisTypeNode() : parseIdentifier();
          var type3 = parseOptional(137) ? parseType() : void 0;
          return finishNode(factory.createTypePredicateNode(assertsModifier, parameterName, type3), pos);
        }
        function parseType() {
          return doOutsideOfContext(40960, parseTypeWorker);
        }
        function parseTypeWorker(noConditionalTypes) {
          if (isStartOfFunctionTypeOrConstructorType()) {
            return parseFunctionOrConstructorType();
          }
          var pos = getNodePos();
          var type3 = parseUnionTypeOrHigher();
          if (!noConditionalTypes && !scanner.hasPrecedingLineBreak() && parseOptional(93)) {
            var extendsType = parseTypeWorker(true);
            parseExpected(57);
            var trueType = parseTypeWorker();
            parseExpected(58);
            var falseType = parseTypeWorker();
            return finishNode(factory.createConditionalTypeNode(type3, extendsType, trueType, falseType), pos);
          }
          return type3;
        }
        function parseTypeAnnotation() {
          return parseOptional(58) ? parseType() : void 0;
        }
        function isStartOfLeftHandSideExpression() {
          switch (token()) {
            case 107:
            case 105:
            case 103:
            case 109:
            case 94:
            case 8:
            case 9:
            case 10:
            case 14:
            case 15:
            case 20:
            case 22:
            case 18:
            case 97:
            case 83:
            case 102:
            case 43:
            case 67:
            case 78:
              return true;
            case 99:
              return lookAhead(nextTokenIsOpenParenOrLessThanOrDot);
            default:
              return isIdentifier();
          }
        }
        function isStartOfExpression() {
          if (isStartOfLeftHandSideExpression()) {
            return true;
          }
          switch (token()) {
            case 39:
            case 40:
            case 54:
            case 53:
            case 88:
            case 111:
            case 113:
            case 45:
            case 46:
            case 29:
            case 130:
            case 124:
            case 79:
              return true;
            default:
              if (isBinaryOperator()) {
                return true;
              }
              return isIdentifier();
          }
        }
        function isStartOfExpressionStatement() {
          return token() !== 18 && token() !== 97 && token() !== 83 && token() !== 59 && isStartOfExpression();
        }
        function parseExpression() {
          var saveDecoratorContext = inDecoratorContext();
          if (saveDecoratorContext) {
            setDecoratorContext(false);
          }
          var pos = getNodePos();
          var expr = parseAssignmentExpressionOrHigher();
          var operatorToken;
          while (operatorToken = parseOptionalToken(27)) {
            expr = makeBinaryExpression(expr, operatorToken, parseAssignmentExpressionOrHigher(), pos);
          }
          if (saveDecoratorContext) {
            setDecoratorContext(true);
          }
          return expr;
        }
        function parseInitializer() {
          return parseOptional(62) ? parseAssignmentExpressionOrHigher() : void 0;
        }
        function parseAssignmentExpressionOrHigher() {
          if (isYieldExpression()) {
            return parseYieldExpression();
          }
          var arrowExpression = tryParseParenthesizedArrowFunctionExpression() || tryParseAsyncSimpleArrowFunctionExpression();
          if (arrowExpression) {
            return arrowExpression;
          }
          var pos = getNodePos();
          var expr = parseBinaryExpressionOrHigher(0);
          if (expr.kind === 78 && token() === 38) {
            return parseSimpleArrowFunctionExpression(pos, expr, void 0);
          }
          if (ts3.isLeftHandSideExpression(expr) && ts3.isAssignmentOperator(reScanGreaterToken())) {
            return makeBinaryExpression(expr, parseTokenNode(), parseAssignmentExpressionOrHigher(), pos);
          }
          return parseConditionalExpressionRest(expr, pos);
        }
        function isYieldExpression() {
          if (token() === 124) {
            if (inYieldContext()) {
              return true;
            }
            return lookAhead(nextTokenIsIdentifierOrKeywordOrLiteralOnSameLine);
          }
          return false;
        }
        function nextTokenIsIdentifierOnSameLine() {
          nextToken();
          return !scanner.hasPrecedingLineBreak() && isIdentifier();
        }
        function parseYieldExpression() {
          var pos = getNodePos();
          nextToken();
          if (!scanner.hasPrecedingLineBreak() && (token() === 41 || isStartOfExpression())) {
            return finishNode(factory.createYieldExpression(parseOptionalToken(41), parseAssignmentExpressionOrHigher()), pos);
          } else {
            return finishNode(factory.createYieldExpression(void 0, void 0), pos);
          }
        }
        function parseSimpleArrowFunctionExpression(pos, identifier, asyncModifier) {
          ts3.Debug.assert(token() === 38, "parseSimpleArrowFunctionExpression should only have been called if we had a =>");
          var parameter = factory.createParameterDeclaration(void 0, void 0, void 0, identifier, void 0, void 0, void 0);
          finishNode(parameter, identifier.pos);
          var parameters = createNodeArray([parameter], parameter.pos, parameter.end);
          var equalsGreaterThanToken = parseExpectedToken(38);
          var body = parseArrowFunctionExpressionBody(!!asyncModifier);
          var node = factory.createArrowFunction(asyncModifier, void 0, parameters, void 0, equalsGreaterThanToken, body);
          return addJSDocComment(finishNode(node, pos));
        }
        function tryParseParenthesizedArrowFunctionExpression() {
          var triState = isParenthesizedArrowFunctionExpression();
          if (triState === 0) {
            return void 0;
          }
          return triState === 1 ? parseParenthesizedArrowFunctionExpression(true) : tryParse(parsePossibleParenthesizedArrowFunctionExpression);
        }
        function isParenthesizedArrowFunctionExpression() {
          if (token() === 20 || token() === 29 || token() === 129) {
            return lookAhead(isParenthesizedArrowFunctionExpressionWorker);
          }
          if (token() === 38) {
            return 1;
          }
          return 0;
        }
        function isParenthesizedArrowFunctionExpressionWorker() {
          if (token() === 129) {
            nextToken();
            if (scanner.hasPrecedingLineBreak()) {
              return 0;
            }
            if (token() !== 20 && token() !== 29) {
              return 0;
            }
          }
          var first = token();
          var second = nextToken();
          if (first === 20) {
            if (second === 21) {
              var third = nextToken();
              switch (third) {
                case 38:
                case 58:
                case 18:
                  return 1;
                default:
                  return 0;
              }
            }
            if (second === 22 || second === 18) {
              return 2;
            }
            if (second === 25) {
              return 1;
            }
            if (ts3.isModifierKind(second) && second !== 129 && lookAhead(nextTokenIsIdentifier)) {
              return 1;
            }
            if (!isIdentifier() && second !== 107) {
              return 0;
            }
            switch (nextToken()) {
              case 58:
                return 1;
              case 57:
                nextToken();
                if (token() === 58 || token() === 27 || token() === 62 || token() === 21) {
                  return 1;
                }
                return 0;
              case 27:
              case 62:
              case 21:
                return 2;
            }
            return 0;
          } else {
            ts3.Debug.assert(first === 29);
            if (!isIdentifier()) {
              return 0;
            }
            if (languageVariant === 1) {
              var isArrowFunctionInJsx = lookAhead(function() {
                var third2 = nextToken();
                if (third2 === 93) {
                  var fourth = nextToken();
                  switch (fourth) {
                    case 62:
                    case 31:
                      return false;
                    default:
                      return true;
                  }
                } else if (third2 === 27) {
                  return true;
                }
                return false;
              });
              if (isArrowFunctionInJsx) {
                return 1;
              }
              return 0;
            }
            return 2;
          }
        }
        function parsePossibleParenthesizedArrowFunctionExpression() {
          var tokenPos = scanner.getTokenPos();
          if (notParenthesizedArrow === null || notParenthesizedArrow === void 0 ? void 0 : notParenthesizedArrow.has(tokenPos)) {
            return void 0;
          }
          var result2 = parseParenthesizedArrowFunctionExpression(false);
          if (!result2) {
            (notParenthesizedArrow || (notParenthesizedArrow = new ts3.Set())).add(tokenPos);
          }
          return result2;
        }
        function tryParseAsyncSimpleArrowFunctionExpression() {
          if (token() === 129) {
            if (lookAhead(isUnParenthesizedAsyncArrowFunctionWorker) === 1) {
              var pos = getNodePos();
              var asyncModifier = parseModifiersForArrowFunction();
              var expr = parseBinaryExpressionOrHigher(0);
              return parseSimpleArrowFunctionExpression(pos, expr, asyncModifier);
            }
          }
          return void 0;
        }
        function isUnParenthesizedAsyncArrowFunctionWorker() {
          if (token() === 129) {
            nextToken();
            if (scanner.hasPrecedingLineBreak() || token() === 38) {
              return 0;
            }
            var expr = parseBinaryExpressionOrHigher(0);
            if (!scanner.hasPrecedingLineBreak() && expr.kind === 78 && token() === 38) {
              return 1;
            }
          }
          return 0;
        }
        function parseParenthesizedArrowFunctionExpression(allowAmbiguity) {
          var pos = getNodePos();
          var hasJSDoc = hasPrecedingJSDocComment();
          var modifiers = parseModifiersForArrowFunction();
          var isAsync = ts3.some(modifiers, ts3.isAsyncModifier) ? 2 : 0;
          var typeParameters = parseTypeParameters();
          var parameters;
          if (!parseExpected(20)) {
            if (!allowAmbiguity) {
              return void 0;
            }
            parameters = createMissingList();
          } else {
            parameters = parseParametersWorker(isAsync);
            if (!parseExpected(21) && !allowAmbiguity) {
              return void 0;
            }
          }
          var type3 = parseReturnType(58, false);
          if (type3 && !allowAmbiguity && typeHasArrowFunctionBlockingParseError(type3)) {
            return void 0;
          }
          var hasJSDocFunctionType = type3 && ts3.isJSDocFunctionType(type3);
          if (!allowAmbiguity && token() !== 38 && (hasJSDocFunctionType || token() !== 18)) {
            return void 0;
          }
          var lastToken = token();
          var equalsGreaterThanToken = parseExpectedToken(38);
          var body = lastToken === 38 || lastToken === 18 ? parseArrowFunctionExpressionBody(ts3.some(modifiers, ts3.isAsyncModifier)) : parseIdentifier();
          var node = factory.createArrowFunction(modifiers, typeParameters, parameters, type3, equalsGreaterThanToken, body);
          return withJSDoc(finishNode(node, pos), hasJSDoc);
        }
        function parseArrowFunctionExpressionBody(isAsync) {
          if (token() === 18) {
            return parseFunctionBlock(isAsync ? 2 : 0);
          }
          if (token() !== 26 && token() !== 97 && token() !== 83 && isStartOfStatement() && !isStartOfExpressionStatement()) {
            return parseFunctionBlock(16 | (isAsync ? 2 : 0));
          }
          var savedTopLevel = topLevel;
          topLevel = false;
          var node = isAsync ? doInAwaitContext(parseAssignmentExpressionOrHigher) : doOutsideOfAwaitContext(parseAssignmentExpressionOrHigher);
          topLevel = savedTopLevel;
          return node;
        }
        function parseConditionalExpressionRest(leftOperand, pos) {
          var questionToken = parseOptionalToken(57);
          if (!questionToken) {
            return leftOperand;
          }
          var colonToken;
          return finishNode(factory.createConditionalExpression(leftOperand, questionToken, doOutsideOfContext(disallowInAndDecoratorContext, parseAssignmentExpressionOrHigher), colonToken = parseExpectedToken(58), ts3.nodeIsPresent(colonToken) ? parseAssignmentExpressionOrHigher() : createMissingNode(78, false, ts3.Diagnostics._0_expected, ts3.tokenToString(58))), pos);
        }
        function parseBinaryExpressionOrHigher(precedence) {
          var pos = getNodePos();
          var leftOperand = parseUnaryExpressionOrHigher();
          return parseBinaryExpressionRest(precedence, leftOperand, pos);
        }
        function isInOrOfKeyword(t2) {
          return t2 === 100 || t2 === 157;
        }
        function parseBinaryExpressionRest(precedence, leftOperand, pos) {
          while (true) {
            reScanGreaterToken();
            var newPrecedence = ts3.getBinaryOperatorPrecedence(token());
            var consumeCurrentOperator = token() === 42 ? newPrecedence >= precedence : newPrecedence > precedence;
            if (!consumeCurrentOperator) {
              break;
            }
            if (token() === 100 && inDisallowInContext()) {
              break;
            }
            if (token() === 126) {
              if (scanner.hasPrecedingLineBreak()) {
                break;
              } else {
                nextToken();
                leftOperand = makeAsExpression(leftOperand, parseType());
              }
            } else {
              leftOperand = makeBinaryExpression(leftOperand, parseTokenNode(), parseBinaryExpressionOrHigher(newPrecedence), pos);
            }
          }
          return leftOperand;
        }
        function isBinaryOperator() {
          if (inDisallowInContext() && token() === 100) {
            return false;
          }
          return ts3.getBinaryOperatorPrecedence(token()) > 0;
        }
        function makeBinaryExpression(left, operatorToken, right, pos) {
          return finishNode(factory.createBinaryExpression(left, operatorToken, right), pos);
        }
        function makeAsExpression(left, right) {
          return finishNode(factory.createAsExpression(left, right), left.pos);
        }
        function parsePrefixUnaryExpression() {
          var pos = getNodePos();
          return finishNode(factory.createPrefixUnaryExpression(token(), nextTokenAnd(parseSimpleUnaryExpression)), pos);
        }
        function parseDeleteExpression() {
          var pos = getNodePos();
          return finishNode(factory.createDeleteExpression(nextTokenAnd(parseSimpleUnaryExpression)), pos);
        }
        function parseTypeOfExpression() {
          var pos = getNodePos();
          return finishNode(factory.createTypeOfExpression(nextTokenAnd(parseSimpleUnaryExpression)), pos);
        }
        function parseVoidExpression() {
          var pos = getNodePos();
          return finishNode(factory.createVoidExpression(nextTokenAnd(parseSimpleUnaryExpression)), pos);
        }
        function isAwaitExpression() {
          if (token() === 130) {
            if (inAwaitContext()) {
              return true;
            }
            return lookAhead(nextTokenIsIdentifierOrKeywordOrLiteralOnSameLine);
          }
          return false;
        }
        function parseAwaitExpression() {
          var pos = getNodePos();
          return finishNode(factory.createAwaitExpression(nextTokenAnd(parseSimpleUnaryExpression)), pos);
        }
        function parseUnaryExpressionOrHigher() {
          if (isUpdateExpression()) {
            var pos = getNodePos();
            var updateExpression = parseUpdateExpression();
            return token() === 42 ? parseBinaryExpressionRest(ts3.getBinaryOperatorPrecedence(token()), updateExpression, pos) : updateExpression;
          }
          var unaryOperator = token();
          var simpleUnaryExpression = parseSimpleUnaryExpression();
          if (token() === 42) {
            var pos = ts3.skipTrivia(sourceText, simpleUnaryExpression.pos);
            var end = simpleUnaryExpression.end;
            if (simpleUnaryExpression.kind === 207) {
              parseErrorAt(pos, end, ts3.Diagnostics.A_type_assertion_expression_is_not_allowed_in_the_left_hand_side_of_an_exponentiation_expression_Consider_enclosing_the_expression_in_parentheses);
            } else {
              parseErrorAt(pos, end, ts3.Diagnostics.An_unary_expression_with_the_0_operator_is_not_allowed_in_the_left_hand_side_of_an_exponentiation_expression_Consider_enclosing_the_expression_in_parentheses, ts3.tokenToString(unaryOperator));
            }
          }
          return simpleUnaryExpression;
        }
        function parseSimpleUnaryExpression() {
          switch (token()) {
            case 39:
            case 40:
            case 54:
            case 53:
              return parsePrefixUnaryExpression();
            case 88:
              return parseDeleteExpression();
            case 111:
              return parseTypeOfExpression();
            case 113:
              return parseVoidExpression();
            case 29:
              return parseTypeAssertion();
            case 130:
              if (isAwaitExpression()) {
                return parseAwaitExpression();
              }
            default:
              return parseUpdateExpression();
          }
        }
        function isUpdateExpression() {
          switch (token()) {
            case 39:
            case 40:
            case 54:
            case 53:
            case 88:
            case 111:
            case 113:
            case 130:
              return false;
            case 29:
              if (languageVariant !== 1) {
                return false;
              }
            default:
              return true;
          }
        }
        function parseUpdateExpression() {
          if (token() === 45 || token() === 46) {
            var pos = getNodePos();
            return finishNode(factory.createPrefixUnaryExpression(token(), nextTokenAnd(parseLeftHandSideExpressionOrHigher)), pos);
          } else if (languageVariant === 1 && token() === 29 && lookAhead(nextTokenIsIdentifierOrKeywordOrGreaterThan)) {
            return parseJsxElementOrSelfClosingElementOrFragment(true);
          }
          var expression = parseLeftHandSideExpressionOrHigher();
          ts3.Debug.assert(ts3.isLeftHandSideExpression(expression));
          if ((token() === 45 || token() === 46) && !scanner.hasPrecedingLineBreak()) {
            var operator = token();
            nextToken();
            return finishNode(factory.createPostfixUnaryExpression(expression, operator), expression.pos);
          }
          return expression;
        }
        function parseLeftHandSideExpressionOrHigher() {
          var pos = getNodePos();
          var expression;
          if (token() === 99) {
            if (lookAhead(nextTokenIsOpenParenOrLessThan)) {
              sourceFlags |= 1048576;
              expression = parseTokenNode();
            } else if (lookAhead(nextTokenIsDot)) {
              nextToken();
              nextToken();
              expression = finishNode(factory.createMetaProperty(99, parseIdentifierName()), pos);
              sourceFlags |= 2097152;
            } else {
              expression = parseMemberExpressionOrHigher();
            }
          } else {
            expression = token() === 105 ? parseSuperExpression() : parseMemberExpressionOrHigher();
          }
          return parseCallExpressionRest(pos, expression);
        }
        function parseMemberExpressionOrHigher() {
          var pos = getNodePos();
          var expression = parsePrimaryExpression();
          return parseMemberExpressionRest(pos, expression, true);
        }
        function parseSuperExpression() {
          var pos = getNodePos();
          var expression = parseTokenNode();
          if (token() === 29) {
            var startPos = getNodePos();
            var typeArguments = tryParse(parseTypeArgumentsInExpression);
            if (typeArguments !== void 0) {
              parseErrorAt(startPos, getNodePos(), ts3.Diagnostics.super_may_not_use_type_arguments);
            }
          }
          if (token() === 20 || token() === 24 || token() === 22) {
            return expression;
          }
          parseExpectedToken(24, ts3.Diagnostics.super_must_be_followed_by_an_argument_list_or_member_access);
          return finishNode(factory.createPropertyAccessExpression(expression, parseRightSideOfDot(true, true)), pos);
        }
        function parseJsxElementOrSelfClosingElementOrFragment(inExpressionContext, topInvalidNodePosition) {
          var pos = getNodePos();
          var opening = parseJsxOpeningOrSelfClosingElementOrOpeningFragment(inExpressionContext);
          var result2;
          if (opening.kind === 276) {
            var children = parseJsxChildren(opening);
            var closingElement = parseJsxClosingElement(inExpressionContext);
            if (!tagNamesAreEquivalent(opening.tagName, closingElement.tagName)) {
              parseErrorAtRange(closingElement, ts3.Diagnostics.Expected_corresponding_JSX_closing_tag_for_0, ts3.getTextOfNodeFromSourceText(sourceText, opening.tagName));
            }
            result2 = finishNode(factory.createJsxElement(opening, children, closingElement), pos);
          } else if (opening.kind === 279) {
            result2 = finishNode(factory.createJsxFragment(opening, parseJsxChildren(opening), parseJsxClosingFragment(inExpressionContext)), pos);
          } else {
            ts3.Debug.assert(opening.kind === 275);
            result2 = opening;
          }
          if (inExpressionContext && token() === 29) {
            var topBadPos_1 = typeof topInvalidNodePosition === "undefined" ? result2.pos : topInvalidNodePosition;
            var invalidElement = tryParse(function() {
              return parseJsxElementOrSelfClosingElementOrFragment(true, topBadPos_1);
            });
            if (invalidElement) {
              var operatorToken = createMissingNode(27, false);
              ts3.setTextRangePosWidth(operatorToken, invalidElement.pos, 0);
              parseErrorAt(ts3.skipTrivia(sourceText, topBadPos_1), invalidElement.end, ts3.Diagnostics.JSX_expressions_must_have_one_parent_element);
              return finishNode(factory.createBinaryExpression(result2, operatorToken, invalidElement), pos);
            }
          }
          return result2;
        }
        function parseJsxText() {
          var pos = getNodePos();
          var node = factory.createJsxText(scanner.getTokenValue(), currentToken === 12);
          currentToken = scanner.scanJsxToken();
          return finishNode(node, pos);
        }
        function parseJsxChild(openingTag, token2) {
          switch (token2) {
            case 1:
              if (ts3.isJsxOpeningFragment(openingTag)) {
                parseErrorAtRange(openingTag, ts3.Diagnostics.JSX_fragment_has_no_corresponding_closing_tag);
              } else {
                var tag = openingTag.tagName;
                var start = ts3.skipTrivia(sourceText, tag.pos);
                parseErrorAt(start, tag.end, ts3.Diagnostics.JSX_element_0_has_no_corresponding_closing_tag, ts3.getTextOfNodeFromSourceText(sourceText, openingTag.tagName));
              }
              return void 0;
            case 30:
            case 7:
              return void 0;
            case 11:
            case 12:
              return parseJsxText();
            case 18:
              return parseJsxExpression(false);
            case 29:
              return parseJsxElementOrSelfClosingElementOrFragment(false);
            default:
              return ts3.Debug.assertNever(token2);
          }
        }
        function parseJsxChildren(openingTag) {
          var list = [];
          var listPos = getNodePos();
          var saveParsingContext = parsingContext;
          parsingContext |= 1 << 14;
          while (true) {
            var child = parseJsxChild(openingTag, currentToken = scanner.reScanJsxToken());
            if (!child)
              break;
            list.push(child);
          }
          parsingContext = saveParsingContext;
          return createNodeArray(list, listPos);
        }
        function parseJsxAttributes() {
          var pos = getNodePos();
          return finishNode(factory.createJsxAttributes(parseList(13, parseJsxAttribute)), pos);
        }
        function parseJsxOpeningOrSelfClosingElementOrOpeningFragment(inExpressionContext) {
          var pos = getNodePos();
          parseExpected(29);
          if (token() === 31) {
            scanJsxText();
            return finishNode(factory.createJsxOpeningFragment(), pos);
          }
          var tagName = parseJsxElementName();
          var typeArguments = (contextFlags & 131072) === 0 ? tryParseTypeArguments() : void 0;
          var attributes = parseJsxAttributes();
          var node;
          if (token() === 31) {
            scanJsxText();
            node = factory.createJsxOpeningElement(tagName, typeArguments, attributes);
          } else {
            parseExpected(43);
            if (inExpressionContext) {
              parseExpected(31);
            } else {
              parseExpected(31, void 0, false);
              scanJsxText();
            }
            node = factory.createJsxSelfClosingElement(tagName, typeArguments, attributes);
          }
          return finishNode(node, pos);
        }
        function parseJsxElementName() {
          var pos = getNodePos();
          scanJsxIdentifier();
          var expression = token() === 107 ? parseTokenNode() : parseIdentifierName();
          while (parseOptional(24)) {
            expression = finishNode(factory.createPropertyAccessExpression(expression, parseRightSideOfDot(true, false)), pos);
          }
          return expression;
        }
        function parseJsxExpression(inExpressionContext) {
          var pos = getNodePos();
          if (!parseExpected(18)) {
            return void 0;
          }
          var dotDotDotToken;
          var expression;
          if (token() !== 19) {
            dotDotDotToken = parseOptionalToken(25);
            expression = parseExpression();
          }
          if (inExpressionContext) {
            parseExpected(19);
          } else {
            if (parseExpected(19, void 0, false)) {
              scanJsxText();
            }
          }
          return finishNode(factory.createJsxExpression(dotDotDotToken, expression), pos);
        }
        function parseJsxAttribute() {
          if (token() === 18) {
            return parseJsxSpreadAttribute();
          }
          scanJsxIdentifier();
          var pos = getNodePos();
          return finishNode(factory.createJsxAttribute(parseIdentifierName(), token() !== 62 ? void 0 : scanJsxAttributeValue() === 10 ? parseLiteralNode() : parseJsxExpression(true)), pos);
        }
        function parseJsxSpreadAttribute() {
          var pos = getNodePos();
          parseExpected(18);
          parseExpected(25);
          var expression = parseExpression();
          parseExpected(19);
          return finishNode(factory.createJsxSpreadAttribute(expression), pos);
        }
        function parseJsxClosingElement(inExpressionContext) {
          var pos = getNodePos();
          parseExpected(30);
          var tagName = parseJsxElementName();
          if (inExpressionContext) {
            parseExpected(31);
          } else {
            parseExpected(31, void 0, false);
            scanJsxText();
          }
          return finishNode(factory.createJsxClosingElement(tagName), pos);
        }
        function parseJsxClosingFragment(inExpressionContext) {
          var pos = getNodePos();
          parseExpected(30);
          if (ts3.tokenIsIdentifierOrKeyword(token())) {
            parseErrorAtRange(parseJsxElementName(), ts3.Diagnostics.Expected_corresponding_closing_tag_for_JSX_fragment);
          }
          if (inExpressionContext) {
            parseExpected(31);
          } else {
            parseExpected(31, void 0, false);
            scanJsxText();
          }
          return finishNode(factory.createJsxJsxClosingFragment(), pos);
        }
        function parseTypeAssertion() {
          var pos = getNodePos();
          parseExpected(29);
          var type3 = parseType();
          parseExpected(31);
          var expression = parseSimpleUnaryExpression();
          return finishNode(factory.createTypeAssertion(type3, expression), pos);
        }
        function nextTokenIsIdentifierOrKeywordOrOpenBracketOrTemplate() {
          nextToken();
          return ts3.tokenIsIdentifierOrKeyword(token()) || token() === 22 || isTemplateStartOfTaggedTemplate();
        }
        function isStartOfOptionalPropertyOrElementAccessChain() {
          return token() === 28 && lookAhead(nextTokenIsIdentifierOrKeywordOrOpenBracketOrTemplate);
        }
        function tryReparseOptionalChain(node) {
          if (node.flags & 32) {
            return true;
          }
          if (ts3.isNonNullExpression(node)) {
            var expr = node.expression;
            while (ts3.isNonNullExpression(expr) && !(expr.flags & 32)) {
              expr = expr.expression;
            }
            if (expr.flags & 32) {
              while (ts3.isNonNullExpression(node)) {
                node.flags |= 32;
                node = node.expression;
              }
              return true;
            }
          }
          return false;
        }
        function parsePropertyAccessExpressionRest(pos, expression, questionDotToken) {
          var name = parseRightSideOfDot(true, true);
          var isOptionalChain = questionDotToken || tryReparseOptionalChain(expression);
          var propertyAccess = isOptionalChain ? factory.createPropertyAccessChain(expression, questionDotToken, name) : factory.createPropertyAccessExpression(expression, name);
          if (isOptionalChain && ts3.isPrivateIdentifier(propertyAccess.name)) {
            parseErrorAtRange(propertyAccess.name, ts3.Diagnostics.An_optional_chain_cannot_contain_private_identifiers);
          }
          return finishNode(propertyAccess, pos);
        }
        function parseElementAccessExpressionRest(pos, expression, questionDotToken) {
          var argumentExpression;
          if (token() === 23) {
            argumentExpression = createMissingNode(78, true, ts3.Diagnostics.An_element_access_expression_should_take_an_argument);
          } else {
            var argument = allowInAnd(parseExpression);
            if (ts3.isStringOrNumericLiteralLike(argument)) {
              argument.text = internIdentifier(argument.text);
            }
            argumentExpression = argument;
          }
          parseExpected(23);
          var indexedAccess = questionDotToken || tryReparseOptionalChain(expression) ? factory.createElementAccessChain(expression, questionDotToken, argumentExpression) : factory.createElementAccessExpression(expression, argumentExpression);
          return finishNode(indexedAccess, pos);
        }
        function parseMemberExpressionRest(pos, expression, allowOptionalChain) {
          while (true) {
            var questionDotToken = void 0;
            var isPropertyAccess = false;
            if (allowOptionalChain && isStartOfOptionalPropertyOrElementAccessChain()) {
              questionDotToken = parseExpectedToken(28);
              isPropertyAccess = ts3.tokenIsIdentifierOrKeyword(token());
            } else {
              isPropertyAccess = parseOptional(24);
            }
            if (isPropertyAccess) {
              expression = parsePropertyAccessExpressionRest(pos, expression, questionDotToken);
              continue;
            }
            if (!questionDotToken && token() === 53 && !scanner.hasPrecedingLineBreak()) {
              nextToken();
              expression = finishNode(factory.createNonNullExpression(expression), pos);
              continue;
            }
            if ((questionDotToken || !inDecoratorContext()) && parseOptional(22)) {
              expression = parseElementAccessExpressionRest(pos, expression, questionDotToken);
              continue;
            }
            if (isTemplateStartOfTaggedTemplate()) {
              expression = parseTaggedTemplateRest(pos, expression, questionDotToken, void 0);
              continue;
            }
            return expression;
          }
        }
        function isTemplateStartOfTaggedTemplate() {
          return token() === 14 || token() === 15;
        }
        function parseTaggedTemplateRest(pos, tag, questionDotToken, typeArguments) {
          var tagExpression = factory.createTaggedTemplateExpression(tag, typeArguments, token() === 14 ? (reScanTemplateHeadOrNoSubstitutionTemplate(), parseLiteralNode()) : parseTemplateExpression(true));
          if (questionDotToken || tag.flags & 32) {
            tagExpression.flags |= 32;
          }
          tagExpression.questionDotToken = questionDotToken;
          return finishNode(tagExpression, pos);
        }
        function parseCallExpressionRest(pos, expression) {
          while (true) {
            expression = parseMemberExpressionRest(pos, expression, true);
            var questionDotToken = parseOptionalToken(28);
            if ((contextFlags & 131072) === 0 && (token() === 29 || token() === 47)) {
              var typeArguments = tryParse(parseTypeArgumentsInExpression);
              if (typeArguments) {
                if (isTemplateStartOfTaggedTemplate()) {
                  expression = parseTaggedTemplateRest(pos, expression, questionDotToken, typeArguments);
                  continue;
                }
                var argumentList = parseArgumentList();
                var callExpr = questionDotToken || tryReparseOptionalChain(expression) ? factory.createCallChain(expression, questionDotToken, typeArguments, argumentList) : factory.createCallExpression(expression, typeArguments, argumentList);
                expression = finishNode(callExpr, pos);
                continue;
              }
            } else if (token() === 20) {
              var argumentList = parseArgumentList();
              var callExpr = questionDotToken || tryReparseOptionalChain(expression) ? factory.createCallChain(expression, questionDotToken, void 0, argumentList) : factory.createCallExpression(expression, void 0, argumentList);
              expression = finishNode(callExpr, pos);
              continue;
            }
            if (questionDotToken) {
              var name = createMissingNode(78, false, ts3.Diagnostics.Identifier_expected);
              expression = finishNode(factory.createPropertyAccessChain(expression, questionDotToken, name), pos);
            }
            break;
          }
          return expression;
        }
        function parseArgumentList() {
          parseExpected(20);
          var result2 = parseDelimitedList(11, parseArgumentExpression);
          parseExpected(21);
          return result2;
        }
        function parseTypeArgumentsInExpression() {
          if ((contextFlags & 131072) !== 0) {
            return void 0;
          }
          if (reScanLessThanToken() !== 29) {
            return void 0;
          }
          nextToken();
          var typeArguments = parseDelimitedList(20, parseType);
          if (!parseExpected(31)) {
            return void 0;
          }
          return typeArguments && canFollowTypeArgumentsInExpression() ? typeArguments : void 0;
        }
        function canFollowTypeArgumentsInExpression() {
          switch (token()) {
            case 20:
            case 14:
            case 15:
            case 24:
            case 21:
            case 23:
            case 58:
            case 26:
            case 57:
            case 34:
            case 36:
            case 35:
            case 37:
            case 55:
            case 56:
            case 60:
            case 52:
            case 50:
            case 51:
            case 19:
            case 1:
              return true;
            case 27:
            case 18:
            default:
              return false;
          }
        }
        function parsePrimaryExpression() {
          switch (token()) {
            case 8:
            case 9:
            case 10:
            case 14:
              return parseLiteralNode();
            case 107:
            case 105:
            case 103:
            case 109:
            case 94:
              return parseTokenNode();
            case 20:
              return parseParenthesizedExpression();
            case 22:
              return parseArrayLiteralExpression();
            case 18:
              return parseObjectLiteralExpression();
            case 129:
              if (!lookAhead(nextTokenIsFunctionKeywordOnSameLine)) {
                break;
              }
              return parseFunctionExpression();
            case 83:
              return parseClassExpression();
            case 97:
              return parseFunctionExpression();
            case 102:
              return parseNewExpressionOrNewDotTarget();
            case 43:
            case 67:
              if (reScanSlashToken() === 13) {
                return parseLiteralNode();
              }
              break;
            case 15:
              return parseTemplateExpression(false);
          }
          return parseIdentifier(ts3.Diagnostics.Expression_expected);
        }
        function parseParenthesizedExpression() {
          var pos = getNodePos();
          var hasJSDoc = hasPrecedingJSDocComment();
          parseExpected(20);
          var expression = allowInAnd(parseExpression);
          parseExpected(21);
          return withJSDoc(finishNode(factory.createParenthesizedExpression(expression), pos), hasJSDoc);
        }
        function parseSpreadElement() {
          var pos = getNodePos();
          parseExpected(25);
          var expression = parseAssignmentExpressionOrHigher();
          return finishNode(factory.createSpreadElement(expression), pos);
        }
        function parseArgumentOrArrayLiteralElement() {
          return token() === 25 ? parseSpreadElement() : token() === 27 ? finishNode(factory.createOmittedExpression(), getNodePos()) : parseAssignmentExpressionOrHigher();
        }
        function parseArgumentExpression() {
          return doOutsideOfContext(disallowInAndDecoratorContext, parseArgumentOrArrayLiteralElement);
        }
        function parseArrayLiteralExpression() {
          var pos = getNodePos();
          parseExpected(22);
          var multiLine = scanner.hasPrecedingLineBreak();
          var elements = parseDelimitedList(15, parseArgumentOrArrayLiteralElement);
          parseExpected(23);
          return finishNode(factory.createArrayLiteralExpression(elements, multiLine), pos);
        }
        function parseObjectLiteralElement() {
          var pos = getNodePos();
          var hasJSDoc = hasPrecedingJSDocComment();
          if (parseOptionalToken(25)) {
            var expression = parseAssignmentExpressionOrHigher();
            return withJSDoc(finishNode(factory.createSpreadAssignment(expression), pos), hasJSDoc);
          }
          var decorators = parseDecorators();
          var modifiers = parseModifiers();
          if (parseContextualModifier(134)) {
            return parseAccessorDeclaration(pos, hasJSDoc, decorators, modifiers, 168);
          }
          if (parseContextualModifier(146)) {
            return parseAccessorDeclaration(pos, hasJSDoc, decorators, modifiers, 169);
          }
          var asteriskToken = parseOptionalToken(41);
          var tokenIsIdentifier = isIdentifier();
          var name = parsePropertyName();
          var questionToken = parseOptionalToken(57);
          var exclamationToken = parseOptionalToken(53);
          if (asteriskToken || token() === 20 || token() === 29) {
            return parseMethodDeclaration(pos, hasJSDoc, decorators, modifiers, asteriskToken, name, questionToken, exclamationToken);
          }
          var node;
          var isShorthandPropertyAssignment = tokenIsIdentifier && token() !== 58;
          if (isShorthandPropertyAssignment) {
            var equalsToken = parseOptionalToken(62);
            var objectAssignmentInitializer = equalsToken ? allowInAnd(parseAssignmentExpressionOrHigher) : void 0;
            node = factory.createShorthandPropertyAssignment(name, objectAssignmentInitializer);
            node.equalsToken = equalsToken;
          } else {
            parseExpected(58);
            var initializer = allowInAnd(parseAssignmentExpressionOrHigher);
            node = factory.createPropertyAssignment(name, initializer);
          }
          node.decorators = decorators;
          node.modifiers = modifiers;
          node.questionToken = questionToken;
          node.exclamationToken = exclamationToken;
          return withJSDoc(finishNode(node, pos), hasJSDoc);
        }
        function parseObjectLiteralExpression() {
          var pos = getNodePos();
          var openBracePosition = scanner.getTokenPos();
          parseExpected(18);
          var multiLine = scanner.hasPrecedingLineBreak();
          var properties = parseDelimitedList(12, parseObjectLiteralElement, true);
          if (!parseExpected(19)) {
            var lastError = ts3.lastOrUndefined(parseDiagnostics);
            if (lastError && lastError.code === ts3.Diagnostics._0_expected.code) {
              ts3.addRelatedInfo(lastError, ts3.createDetachedDiagnostic(fileName, openBracePosition, 1, ts3.Diagnostics.The_parser_expected_to_find_a_to_match_the_token_here));
            }
          }
          return finishNode(factory.createObjectLiteralExpression(properties, multiLine), pos);
        }
        function parseFunctionExpression() {
          var saveDecoratorContext = inDecoratorContext();
          if (saveDecoratorContext) {
            setDecoratorContext(false);
          }
          var pos = getNodePos();
          var hasJSDoc = hasPrecedingJSDocComment();
          var modifiers = parseModifiers();
          parseExpected(97);
          var asteriskToken = parseOptionalToken(41);
          var isGenerator = asteriskToken ? 1 : 0;
          var isAsync = ts3.some(modifiers, ts3.isAsyncModifier) ? 2 : 0;
          var name = isGenerator && isAsync ? doInYieldAndAwaitContext(parseOptionalBindingIdentifier) : isGenerator ? doInYieldContext(parseOptionalBindingIdentifier) : isAsync ? doInAwaitContext(parseOptionalBindingIdentifier) : parseOptionalBindingIdentifier();
          var typeParameters = parseTypeParameters();
          var parameters = parseParameters(isGenerator | isAsync);
          var type3 = parseReturnType(58, false);
          var body = parseFunctionBlock(isGenerator | isAsync);
          if (saveDecoratorContext) {
            setDecoratorContext(true);
          }
          var node = factory.createFunctionExpression(modifiers, asteriskToken, name, typeParameters, parameters, type3, body);
          return withJSDoc(finishNode(node, pos), hasJSDoc);
        }
        function parseOptionalBindingIdentifier() {
          return isBindingIdentifier() ? parseBindingIdentifier() : void 0;
        }
        function parseNewExpressionOrNewDotTarget() {
          var pos = getNodePos();
          parseExpected(102);
          if (parseOptional(24)) {
            var name = parseIdentifierName();
            return finishNode(factory.createMetaProperty(102, name), pos);
          }
          var expressionPos = getNodePos();
          var expression = parsePrimaryExpression();
          var typeArguments;
          while (true) {
            expression = parseMemberExpressionRest(expressionPos, expression, false);
            typeArguments = tryParse(parseTypeArgumentsInExpression);
            if (isTemplateStartOfTaggedTemplate()) {
              ts3.Debug.assert(!!typeArguments, "Expected a type argument list; all plain tagged template starts should be consumed in 'parseMemberExpressionRest'");
              expression = parseTaggedTemplateRest(expressionPos, expression, void 0, typeArguments);
              typeArguments = void 0;
            }
            break;
          }
          var argumentsArray;
          if (token() === 20) {
            argumentsArray = parseArgumentList();
          } else if (typeArguments) {
            parseErrorAt(pos, scanner.getStartPos(), ts3.Diagnostics.A_new_expression_with_type_arguments_must_always_be_followed_by_a_parenthesized_argument_list);
          }
          return finishNode(factory.createNewExpression(expression, typeArguments, argumentsArray), pos);
        }
        function parseBlock(ignoreMissingOpenBrace, diagnosticMessage) {
          var pos = getNodePos();
          var hasJSDoc = hasPrecedingJSDocComment();
          var openBracePosition = scanner.getTokenPos();
          if (parseExpected(18, diagnosticMessage) || ignoreMissingOpenBrace) {
            var multiLine = scanner.hasPrecedingLineBreak();
            var statements = parseList(1, parseStatement);
            if (!parseExpected(19)) {
              var lastError = ts3.lastOrUndefined(parseDiagnostics);
              if (lastError && lastError.code === ts3.Diagnostics._0_expected.code) {
                ts3.addRelatedInfo(lastError, ts3.createDetachedDiagnostic(fileName, openBracePosition, 1, ts3.Diagnostics.The_parser_expected_to_find_a_to_match_the_token_here));
              }
            }
            var result2 = withJSDoc(finishNode(factory.createBlock(statements, multiLine), pos), hasJSDoc);
            if (token() === 62) {
              parseErrorAtCurrentToken(ts3.Diagnostics.Declaration_or_statement_expected_This_follows_a_block_of_statements_so_if_you_intended_to_write_a_destructuring_assignment_you_might_need_to_wrap_the_the_whole_assignment_in_parentheses);
              nextToken();
            }
            return result2;
          } else {
            var statements = createMissingList();
            return withJSDoc(finishNode(factory.createBlock(statements, void 0), pos), hasJSDoc);
          }
        }
        function parseFunctionBlock(flags, diagnosticMessage) {
          var savedYieldContext = inYieldContext();
          setYieldContext(!!(flags & 1));
          var savedAwaitContext = inAwaitContext();
          setAwaitContext(!!(flags & 2));
          var savedTopLevel = topLevel;
          topLevel = false;
          var saveDecoratorContext = inDecoratorContext();
          if (saveDecoratorContext) {
            setDecoratorContext(false);
          }
          var block = parseBlock(!!(flags & 16), diagnosticMessage);
          if (saveDecoratorContext) {
            setDecoratorContext(true);
          }
          topLevel = savedTopLevel;
          setYieldContext(savedYieldContext);
          setAwaitContext(savedAwaitContext);
          return block;
        }
        function parseEmptyStatement() {
          var pos = getNodePos();
          var hasJSDoc = hasPrecedingJSDocComment();
          parseExpected(26);
          return withJSDoc(finishNode(factory.createEmptyStatement(), pos), hasJSDoc);
        }
        function parseIfStatement() {
          var pos = getNodePos();
          var hasJSDoc = hasPrecedingJSDocComment();
          parseExpected(98);
          parseExpected(20);
          var expression = allowInAnd(parseExpression);
          parseExpected(21);
          var thenStatement = parseStatement();
          var elseStatement = parseOptional(90) ? parseStatement() : void 0;
          return withJSDoc(finishNode(factory.createIfStatement(expression, thenStatement, elseStatement), pos), hasJSDoc);
        }
        function parseDoStatement() {
          var pos = getNodePos();
          var hasJSDoc = hasPrecedingJSDocComment();
          parseExpected(89);
          var statement = parseStatement();
          parseExpected(114);
          parseExpected(20);
          var expression = allowInAnd(parseExpression);
          parseExpected(21);
          parseOptional(26);
          return withJSDoc(finishNode(factory.createDoStatement(statement, expression), pos), hasJSDoc);
        }
        function parseWhileStatement() {
          var pos = getNodePos();
          var hasJSDoc = hasPrecedingJSDocComment();
          parseExpected(114);
          parseExpected(20);
          var expression = allowInAnd(parseExpression);
          parseExpected(21);
          var statement = parseStatement();
          return withJSDoc(finishNode(factory.createWhileStatement(expression, statement), pos), hasJSDoc);
        }
        function parseForOrForInOrForOfStatement() {
          var pos = getNodePos();
          var hasJSDoc = hasPrecedingJSDocComment();
          parseExpected(96);
          var awaitToken = parseOptionalToken(130);
          parseExpected(20);
          var initializer;
          if (token() !== 26) {
            if (token() === 112 || token() === 118 || token() === 84) {
              initializer = parseVariableDeclarationList(true);
            } else {
              initializer = disallowInAnd(parseExpression);
            }
          }
          var node;
          if (awaitToken ? parseExpected(157) : parseOptional(157)) {
            var expression = allowInAnd(parseAssignmentExpressionOrHigher);
            parseExpected(21);
            node = factory.createForOfStatement(awaitToken, initializer, expression, parseStatement());
          } else if (parseOptional(100)) {
            var expression = allowInAnd(parseExpression);
            parseExpected(21);
            node = factory.createForInStatement(initializer, expression, parseStatement());
          } else {
            parseExpected(26);
            var condition = token() !== 26 && token() !== 21 ? allowInAnd(parseExpression) : void 0;
            parseExpected(26);
            var incrementor = token() !== 21 ? allowInAnd(parseExpression) : void 0;
            parseExpected(21);
            node = factory.createForStatement(initializer, condition, incrementor, parseStatement());
          }
          return withJSDoc(finishNode(node, pos), hasJSDoc);
        }
        function parseBreakOrContinueStatement(kind) {
          var pos = getNodePos();
          var hasJSDoc = hasPrecedingJSDocComment();
          parseExpected(kind === 242 ? 80 : 85);
          var label = canParseSemicolon() ? void 0 : parseIdentifier();
          parseSemicolon();
          var node = kind === 242 ? factory.createBreakStatement(label) : factory.createContinueStatement(label);
          return withJSDoc(finishNode(node, pos), hasJSDoc);
        }
        function parseReturnStatement() {
          var pos = getNodePos();
          var hasJSDoc = hasPrecedingJSDocComment();
          parseExpected(104);
          var expression = canParseSemicolon() ? void 0 : allowInAnd(parseExpression);
          parseSemicolon();
          return withJSDoc(finishNode(factory.createReturnStatement(expression), pos), hasJSDoc);
        }
        function parseWithStatement() {
          var pos = getNodePos();
          var hasJSDoc = hasPrecedingJSDocComment();
          parseExpected(115);
          parseExpected(20);
          var expression = allowInAnd(parseExpression);
          parseExpected(21);
          var statement = doInsideOfContext(16777216, parseStatement);
          return withJSDoc(finishNode(factory.createWithStatement(expression, statement), pos), hasJSDoc);
        }
        function parseCaseClause() {
          var pos = getNodePos();
          parseExpected(81);
          var expression = allowInAnd(parseExpression);
          parseExpected(58);
          var statements = parseList(3, parseStatement);
          return finishNode(factory.createCaseClause(expression, statements), pos);
        }
        function parseDefaultClause() {
          var pos = getNodePos();
          parseExpected(87);
          parseExpected(58);
          var statements = parseList(3, parseStatement);
          return finishNode(factory.createDefaultClause(statements), pos);
        }
        function parseCaseOrDefaultClause() {
          return token() === 81 ? parseCaseClause() : parseDefaultClause();
        }
        function parseCaseBlock() {
          var pos = getNodePos();
          parseExpected(18);
          var clauses = parseList(2, parseCaseOrDefaultClause);
          parseExpected(19);
          return finishNode(factory.createCaseBlock(clauses), pos);
        }
        function parseSwitchStatement() {
          var pos = getNodePos();
          var hasJSDoc = hasPrecedingJSDocComment();
          parseExpected(106);
          parseExpected(20);
          var expression = allowInAnd(parseExpression);
          parseExpected(21);
          var caseBlock = parseCaseBlock();
          return withJSDoc(finishNode(factory.createSwitchStatement(expression, caseBlock), pos), hasJSDoc);
        }
        function parseThrowStatement() {
          var pos = getNodePos();
          var hasJSDoc = hasPrecedingJSDocComment();
          parseExpected(108);
          var expression = scanner.hasPrecedingLineBreak() ? void 0 : allowInAnd(parseExpression);
          if (expression === void 0) {
            identifierCount++;
            expression = finishNode(factory.createIdentifier(""), getNodePos());
          }
          parseSemicolon();
          return withJSDoc(finishNode(factory.createThrowStatement(expression), pos), hasJSDoc);
        }
        function parseTryStatement() {
          var pos = getNodePos();
          var hasJSDoc = hasPrecedingJSDocComment();
          parseExpected(110);
          var tryBlock = parseBlock(false);
          var catchClause = token() === 82 ? parseCatchClause() : void 0;
          var finallyBlock;
          if (!catchClause || token() === 95) {
            parseExpected(95);
            finallyBlock = parseBlock(false);
          }
          return withJSDoc(finishNode(factory.createTryStatement(tryBlock, catchClause, finallyBlock), pos), hasJSDoc);
        }
        function parseCatchClause() {
          var pos = getNodePos();
          parseExpected(82);
          var variableDeclaration;
          if (parseOptional(20)) {
            variableDeclaration = parseVariableDeclaration();
            parseExpected(21);
          } else {
            variableDeclaration = void 0;
          }
          var block = parseBlock(false);
          return finishNode(factory.createCatchClause(variableDeclaration, block), pos);
        }
        function parseDebuggerStatement() {
          var pos = getNodePos();
          var hasJSDoc = hasPrecedingJSDocComment();
          parseExpected(86);
          parseSemicolon();
          return withJSDoc(finishNode(factory.createDebuggerStatement(), pos), hasJSDoc);
        }
        function parseExpressionOrLabeledStatement() {
          var pos = getNodePos();
          var hasJSDoc = hasPrecedingJSDocComment();
          var node;
          var hasParen = token() === 20;
          var expression = allowInAnd(parseExpression);
          if (ts3.isIdentifier(expression) && parseOptional(58)) {
            node = factory.createLabeledStatement(expression, parseStatement());
          } else {
            parseSemicolon();
            node = factory.createExpressionStatement(expression);
            if (hasParen) {
              hasJSDoc = false;
            }
          }
          return withJSDoc(finishNode(node, pos), hasJSDoc);
        }
        function nextTokenIsIdentifierOrKeywordOnSameLine() {
          nextToken();
          return ts3.tokenIsIdentifierOrKeyword(token()) && !scanner.hasPrecedingLineBreak();
        }
        function nextTokenIsClassKeywordOnSameLine() {
          nextToken();
          return token() === 83 && !scanner.hasPrecedingLineBreak();
        }
        function nextTokenIsFunctionKeywordOnSameLine() {
          nextToken();
          return token() === 97 && !scanner.hasPrecedingLineBreak();
        }
        function nextTokenIsIdentifierOrKeywordOrLiteralOnSameLine() {
          nextToken();
          return (ts3.tokenIsIdentifierOrKeyword(token()) || token() === 8 || token() === 9 || token() === 10) && !scanner.hasPrecedingLineBreak();
        }
        function isDeclaration() {
          while (true) {
            switch (token()) {
              case 112:
              case 118:
              case 84:
              case 97:
              case 83:
              case 91:
                return true;
              case 117:
              case 149:
                return nextTokenIsIdentifierOnSameLine();
              case 139:
              case 140:
                return nextTokenIsIdentifierOrStringLiteralOnSameLine();
              case 125:
              case 129:
              case 133:
              case 120:
              case 121:
              case 122:
              case 142:
                nextToken();
                if (scanner.hasPrecedingLineBreak()) {
                  return false;
                }
                continue;
              case 154:
                nextToken();
                return token() === 18 || token() === 78 || token() === 92;
              case 99:
                nextToken();
                return token() === 10 || token() === 41 || token() === 18 || ts3.tokenIsIdentifierOrKeyword(token());
              case 92:
                var currentToken_1 = nextToken();
                if (currentToken_1 === 149) {
                  currentToken_1 = lookAhead(nextToken);
                }
                if (currentToken_1 === 62 || currentToken_1 === 41 || currentToken_1 === 18 || currentToken_1 === 87 || currentToken_1 === 126) {
                  return true;
                }
                continue;
              case 123:
                nextToken();
                continue;
              default:
                return false;
            }
          }
        }
        function isStartOfDeclaration() {
          return lookAhead(isDeclaration);
        }
        function isStartOfStatement() {
          switch (token()) {
            case 59:
            case 26:
            case 18:
            case 112:
            case 118:
            case 97:
            case 83:
            case 91:
            case 98:
            case 89:
            case 114:
            case 96:
            case 85:
            case 80:
            case 104:
            case 115:
            case 106:
            case 108:
            case 110:
            case 86:
            case 82:
            case 95:
              return true;
            case 99:
              return isStartOfDeclaration() || lookAhead(nextTokenIsOpenParenOrLessThanOrDot);
            case 84:
            case 92:
              return isStartOfDeclaration();
            case 129:
            case 133:
            case 117:
            case 139:
            case 140:
            case 149:
            case 154:
              return true;
            case 122:
            case 120:
            case 121:
            case 123:
            case 142:
              return isStartOfDeclaration() || !lookAhead(nextTokenIsIdentifierOrKeywordOnSameLine);
            default:
              return isStartOfExpression();
          }
        }
        function nextTokenIsIdentifierOrStartOfDestructuring() {
          nextToken();
          return isIdentifier() || token() === 18 || token() === 22;
        }
        function isLetDeclaration() {
          return lookAhead(nextTokenIsIdentifierOrStartOfDestructuring);
        }
        function parseStatement() {
          switch (token()) {
            case 26:
              return parseEmptyStatement();
            case 18:
              return parseBlock(false);
            case 112:
              return parseVariableStatement(getNodePos(), hasPrecedingJSDocComment(), void 0, void 0);
            case 118:
              if (isLetDeclaration()) {
                return parseVariableStatement(getNodePos(), hasPrecedingJSDocComment(), void 0, void 0);
              }
              break;
            case 97:
              return parseFunctionDeclaration(getNodePos(), hasPrecedingJSDocComment(), void 0, void 0);
            case 83:
              return parseClassDeclaration(getNodePos(), hasPrecedingJSDocComment(), void 0, void 0);
            case 98:
              return parseIfStatement();
            case 89:
              return parseDoStatement();
            case 114:
              return parseWhileStatement();
            case 96:
              return parseForOrForInOrForOfStatement();
            case 85:
              return parseBreakOrContinueStatement(241);
            case 80:
              return parseBreakOrContinueStatement(242);
            case 104:
              return parseReturnStatement();
            case 115:
              return parseWithStatement();
            case 106:
              return parseSwitchStatement();
            case 108:
              return parseThrowStatement();
            case 110:
            case 82:
            case 95:
              return parseTryStatement();
            case 86:
              return parseDebuggerStatement();
            case 59:
              return parseDeclaration();
            case 129:
            case 117:
            case 149:
            case 139:
            case 140:
            case 133:
            case 84:
            case 91:
            case 92:
            case 99:
            case 120:
            case 121:
            case 122:
            case 125:
            case 123:
            case 142:
            case 154:
              if (isStartOfDeclaration()) {
                return parseDeclaration();
              }
              break;
          }
          return parseExpressionOrLabeledStatement();
        }
        function isDeclareModifier(modifier) {
          return modifier.kind === 133;
        }
        function parseDeclaration() {
          var isAmbient = ts3.some(lookAhead(function() {
            return parseDecorators(), parseModifiers();
          }), isDeclareModifier);
          if (isAmbient) {
            var node = tryReuseAmbientDeclaration();
            if (node) {
              return node;
            }
          }
          var pos = getNodePos();
          var hasJSDoc = hasPrecedingJSDocComment();
          var decorators = parseDecorators();
          var modifiers = parseModifiers();
          if (isAmbient) {
            for (var _i = 0, _a2 = modifiers; _i < _a2.length; _i++) {
              var m = _a2[_i];
              m.flags |= 8388608;
            }
            return doInsideOfContext(8388608, function() {
              return parseDeclarationWorker(pos, hasJSDoc, decorators, modifiers);
            });
          } else {
            return parseDeclarationWorker(pos, hasJSDoc, decorators, modifiers);
          }
        }
        function tryReuseAmbientDeclaration() {
          return doInsideOfContext(8388608, function() {
            var node = currentNode(parsingContext);
            if (node) {
              return consumeNode(node);
            }
          });
        }
        function parseDeclarationWorker(pos, hasJSDoc, decorators, modifiers) {
          switch (token()) {
            case 112:
            case 118:
            case 84:
              return parseVariableStatement(pos, hasJSDoc, decorators, modifiers);
            case 97:
              return parseFunctionDeclaration(pos, hasJSDoc, decorators, modifiers);
            case 83:
              return parseClassDeclaration(pos, hasJSDoc, decorators, modifiers);
            case 117:
              return parseInterfaceDeclaration(pos, hasJSDoc, decorators, modifiers);
            case 149:
              return parseTypeAliasDeclaration(pos, hasJSDoc, decorators, modifiers);
            case 91:
              return parseEnumDeclaration(pos, hasJSDoc, decorators, modifiers);
            case 154:
            case 139:
            case 140:
              return parseModuleDeclaration(pos, hasJSDoc, decorators, modifiers);
            case 99:
              return parseImportDeclarationOrImportEqualsDeclaration(pos, hasJSDoc, decorators, modifiers);
            case 92:
              nextToken();
              switch (token()) {
                case 87:
                case 62:
                  return parseExportAssignment(pos, hasJSDoc, decorators, modifiers);
                case 126:
                  return parseNamespaceExportDeclaration(pos, hasJSDoc, decorators, modifiers);
                default:
                  return parseExportDeclaration(pos, hasJSDoc, decorators, modifiers);
              }
            default:
              if (decorators || modifiers) {
                var missing = createMissingNode(272, true, ts3.Diagnostics.Declaration_expected);
                ts3.setTextRangePos(missing, pos);
                missing.decorators = decorators;
                missing.modifiers = modifiers;
                return missing;
              }
              return void 0;
          }
        }
        function nextTokenIsIdentifierOrStringLiteralOnSameLine() {
          nextToken();
          return !scanner.hasPrecedingLineBreak() && (isIdentifier() || token() === 10);
        }
        function parseFunctionBlockOrSemicolon(flags, diagnosticMessage) {
          if (token() !== 18 && canParseSemicolon()) {
            parseSemicolon();
            return;
          }
          return parseFunctionBlock(flags, diagnosticMessage);
        }
        function parseArrayBindingElement() {
          var pos = getNodePos();
          if (token() === 27) {
            return finishNode(factory.createOmittedExpression(), pos);
          }
          var dotDotDotToken = parseOptionalToken(25);
          var name = parseIdentifierOrPattern();
          var initializer = parseInitializer();
          return finishNode(factory.createBindingElement(dotDotDotToken, void 0, name, initializer), pos);
        }
        function parseObjectBindingElement() {
          var pos = getNodePos();
          var dotDotDotToken = parseOptionalToken(25);
          var tokenIsIdentifier = isBindingIdentifier();
          var propertyName = parsePropertyName();
          var name;
          if (tokenIsIdentifier && token() !== 58) {
            name = propertyName;
            propertyName = void 0;
          } else {
            parseExpected(58);
            name = parseIdentifierOrPattern();
          }
          var initializer = parseInitializer();
          return finishNode(factory.createBindingElement(dotDotDotToken, propertyName, name, initializer), pos);
        }
        function parseObjectBindingPattern() {
          var pos = getNodePos();
          parseExpected(18);
          var elements = parseDelimitedList(9, parseObjectBindingElement);
          parseExpected(19);
          return finishNode(factory.createObjectBindingPattern(elements), pos);
        }
        function parseArrayBindingPattern() {
          var pos = getNodePos();
          parseExpected(22);
          var elements = parseDelimitedList(10, parseArrayBindingElement);
          parseExpected(23);
          return finishNode(factory.createArrayBindingPattern(elements), pos);
        }
        function isBindingIdentifierOrPrivateIdentifierOrPattern() {
          return token() === 18 || token() === 22 || token() === 79 || isBindingIdentifier();
        }
        function parseIdentifierOrPattern(privateIdentifierDiagnosticMessage) {
          if (token() === 22) {
            return parseArrayBindingPattern();
          }
          if (token() === 18) {
            return parseObjectBindingPattern();
          }
          return parseBindingIdentifier(privateIdentifierDiagnosticMessage);
        }
        function parseVariableDeclarationAllowExclamation() {
          return parseVariableDeclaration(true);
        }
        function parseVariableDeclaration(allowExclamation) {
          var pos = getNodePos();
          var hasJSDoc = hasPrecedingJSDocComment();
          var name = parseIdentifierOrPattern(ts3.Diagnostics.Private_identifiers_are_not_allowed_in_variable_declarations);
          var exclamationToken;
          if (allowExclamation && name.kind === 78 && token() === 53 && !scanner.hasPrecedingLineBreak()) {
            exclamationToken = parseTokenNode();
          }
          var type3 = parseTypeAnnotation();
          var initializer = isInOrOfKeyword(token()) ? void 0 : parseInitializer();
          var node = factory.createVariableDeclaration(name, exclamationToken, type3, initializer);
          return withJSDoc(finishNode(node, pos), hasJSDoc);
        }
        function parseVariableDeclarationList(inForStatementInitializer) {
          var pos = getNodePos();
          var flags = 0;
          switch (token()) {
            case 112:
              break;
            case 118:
              flags |= 1;
              break;
            case 84:
              flags |= 2;
              break;
            default:
              ts3.Debug.fail();
          }
          nextToken();
          var declarations;
          if (token() === 157 && lookAhead(canFollowContextualOfKeyword)) {
            declarations = createMissingList();
          } else {
            var savedDisallowIn = inDisallowInContext();
            setDisallowInContext(inForStatementInitializer);
            declarations = parseDelimitedList(8, inForStatementInitializer ? parseVariableDeclaration : parseVariableDeclarationAllowExclamation);
            setDisallowInContext(savedDisallowIn);
          }
          return finishNode(factory.createVariableDeclarationList(declarations, flags), pos);
        }
        function canFollowContextualOfKeyword() {
          return nextTokenIsIdentifier() && nextToken() === 21;
        }
        function parseVariableStatement(pos, hasJSDoc, decorators, modifiers) {
          var declarationList = parseVariableDeclarationList(false);
          parseSemicolon();
          var node = factory.createVariableStatement(modifiers, declarationList);
          node.decorators = decorators;
          return withJSDoc(finishNode(node, pos), hasJSDoc);
        }
        function parseFunctionDeclaration(pos, hasJSDoc, decorators, modifiers) {
          var savedAwaitContext = inAwaitContext();
          var modifierFlags = ts3.modifiersToFlags(modifiers);
          parseExpected(97);
          var asteriskToken = parseOptionalToken(41);
          var name = modifierFlags & 512 ? parseOptionalBindingIdentifier() : parseBindingIdentifier();
          var isGenerator = asteriskToken ? 1 : 0;
          var isAsync = modifierFlags & 256 ? 2 : 0;
          var typeParameters = parseTypeParameters();
          if (modifierFlags & 1)
            setAwaitContext(true);
          var parameters = parseParameters(isGenerator | isAsync);
          var type3 = parseReturnType(58, false);
          var body = parseFunctionBlockOrSemicolon(isGenerator | isAsync, ts3.Diagnostics.or_expected);
          setAwaitContext(savedAwaitContext);
          var node = factory.createFunctionDeclaration(decorators, modifiers, asteriskToken, name, typeParameters, parameters, type3, body);
          return withJSDoc(finishNode(node, pos), hasJSDoc);
        }
        function parseConstructorName() {
          if (token() === 132) {
            return parseExpected(132);
          }
          if (token() === 10 && lookAhead(nextToken) === 20) {
            return tryParse(function() {
              var literalNode = parseLiteralNode();
              return literalNode.text === "constructor" ? literalNode : void 0;
            });
          }
        }
        function tryParseConstructorDeclaration(pos, hasJSDoc, decorators, modifiers) {
          return tryParse(function() {
            if (parseConstructorName()) {
              var typeParameters = parseTypeParameters();
              var parameters = parseParameters(0);
              var type3 = parseReturnType(58, false);
              var body = parseFunctionBlockOrSemicolon(0, ts3.Diagnostics.or_expected);
              var node = factory.createConstructorDeclaration(decorators, modifiers, parameters, body);
              node.typeParameters = typeParameters;
              node.type = type3;
              return withJSDoc(finishNode(node, pos), hasJSDoc);
            }
          });
        }
        function parseMethodDeclaration(pos, hasJSDoc, decorators, modifiers, asteriskToken, name, questionToken, exclamationToken, diagnosticMessage) {
          var isGenerator = asteriskToken ? 1 : 0;
          var isAsync = ts3.some(modifiers, ts3.isAsyncModifier) ? 2 : 0;
          var typeParameters = parseTypeParameters();
          var parameters = parseParameters(isGenerator | isAsync);
          var type3 = parseReturnType(58, false);
          var body = parseFunctionBlockOrSemicolon(isGenerator | isAsync, diagnosticMessage);
          var node = factory.createMethodDeclaration(decorators, modifiers, asteriskToken, name, questionToken, typeParameters, parameters, type3, body);
          node.exclamationToken = exclamationToken;
          return withJSDoc(finishNode(node, pos), hasJSDoc);
        }
        function parsePropertyDeclaration(pos, hasJSDoc, decorators, modifiers, name, questionToken) {
          var exclamationToken = !questionToken && !scanner.hasPrecedingLineBreak() ? parseOptionalToken(53) : void 0;
          var type3 = parseTypeAnnotation();
          var initializer = doOutsideOfContext(8192 | 32768 | 4096, parseInitializer);
          parseSemicolon();
          var node = factory.createPropertyDeclaration(decorators, modifiers, name, questionToken || exclamationToken, type3, initializer);
          return withJSDoc(finishNode(node, pos), hasJSDoc);
        }
        function parsePropertyOrMethodDeclaration(pos, hasJSDoc, decorators, modifiers) {
          var asteriskToken = parseOptionalToken(41);
          var name = parsePropertyName();
          var questionToken = parseOptionalToken(57);
          if (asteriskToken || token() === 20 || token() === 29) {
            return parseMethodDeclaration(pos, hasJSDoc, decorators, modifiers, asteriskToken, name, questionToken, void 0, ts3.Diagnostics.or_expected);
          }
          return parsePropertyDeclaration(pos, hasJSDoc, decorators, modifiers, name, questionToken);
        }
        function parseAccessorDeclaration(pos, hasJSDoc, decorators, modifiers, kind) {
          var name = parsePropertyName();
          var typeParameters = parseTypeParameters();
          var parameters = parseParameters(0);
          var type3 = parseReturnType(58, false);
          var body = parseFunctionBlockOrSemicolon(0);
          var node = kind === 168 ? factory.createGetAccessorDeclaration(decorators, modifiers, name, parameters, type3, body) : factory.createSetAccessorDeclaration(decorators, modifiers, name, parameters, body);
          node.typeParameters = typeParameters;
          if (type3 && node.kind === 169)
            node.type = type3;
          return withJSDoc(finishNode(node, pos), hasJSDoc);
        }
        function isClassMemberStart() {
          var idToken;
          if (token() === 59) {
            return true;
          }
          while (ts3.isModifierKind(token())) {
            idToken = token();
            if (ts3.isClassMemberModifier(idToken)) {
              return true;
            }
            nextToken();
          }
          if (token() === 41) {
            return true;
          }
          if (isLiteralPropertyName()) {
            idToken = token();
            nextToken();
          }
          if (token() === 22) {
            return true;
          }
          if (idToken !== void 0) {
            if (!ts3.isKeyword(idToken) || idToken === 146 || idToken === 134) {
              return true;
            }
            switch (token()) {
              case 20:
              case 29:
              case 53:
              case 58:
              case 62:
              case 57:
                return true;
              default:
                return canParseSemicolon();
            }
          }
          return false;
        }
        function parseDecoratorExpression() {
          if (inAwaitContext() && token() === 130) {
            var pos = getNodePos();
            var awaitExpression = parseIdentifier(ts3.Diagnostics.Expression_expected);
            nextToken();
            var memberExpression = parseMemberExpressionRest(pos, awaitExpression, true);
            return parseCallExpressionRest(pos, memberExpression);
          }
          return parseLeftHandSideExpressionOrHigher();
        }
        function tryParseDecorator() {
          var pos = getNodePos();
          if (!parseOptional(59)) {
            return void 0;
          }
          var expression = doInDecoratorContext(parseDecoratorExpression);
          return finishNode(factory.createDecorator(expression), pos);
        }
        function parseDecorators() {
          var pos = getNodePos();
          var list, decorator;
          while (decorator = tryParseDecorator()) {
            list = ts3.append(list, decorator);
          }
          return list && createNodeArray(list, pos);
        }
        function tryParseModifier(permitInvalidConstAsModifier) {
          var pos = getNodePos();
          var kind = token();
          if (token() === 84 && permitInvalidConstAsModifier) {
            if (!tryParse(nextTokenIsOnSameLineAndCanFollowModifier)) {
              return void 0;
            }
          } else {
            if (!parseAnyContextualModifier()) {
              return void 0;
            }
          }
          return finishNode(factory.createToken(kind), pos);
        }
        function parseModifiers(permitInvalidConstAsModifier) {
          var pos = getNodePos();
          var list, modifier;
          while (modifier = tryParseModifier(permitInvalidConstAsModifier)) {
            list = ts3.append(list, modifier);
          }
          return list && createNodeArray(list, pos);
        }
        function parseModifiersForArrowFunction() {
          var modifiers;
          if (token() === 129) {
            var pos = getNodePos();
            nextToken();
            var modifier = finishNode(factory.createToken(129), pos);
            modifiers = createNodeArray([modifier], pos);
          }
          return modifiers;
        }
        function parseClassElement() {
          var pos = getNodePos();
          if (token() === 26) {
            nextToken();
            return finishNode(factory.createSemicolonClassElement(), pos);
          }
          var hasJSDoc = hasPrecedingJSDocComment();
          var decorators = parseDecorators();
          var modifiers = parseModifiers(true);
          if (parseContextualModifier(134)) {
            return parseAccessorDeclaration(pos, hasJSDoc, decorators, modifiers, 168);
          }
          if (parseContextualModifier(146)) {
            return parseAccessorDeclaration(pos, hasJSDoc, decorators, modifiers, 169);
          }
          if (token() === 132 || token() === 10) {
            var constructorDeclaration = tryParseConstructorDeclaration(pos, hasJSDoc, decorators, modifiers);
            if (constructorDeclaration) {
              return constructorDeclaration;
            }
          }
          if (isIndexSignature()) {
            return parseIndexSignatureDeclaration(pos, hasJSDoc, decorators, modifiers);
          }
          if (ts3.tokenIsIdentifierOrKeyword(token()) || token() === 10 || token() === 8 || token() === 41 || token() === 22) {
            var isAmbient = ts3.some(modifiers, isDeclareModifier);
            if (isAmbient) {
              for (var _i = 0, _a2 = modifiers; _i < _a2.length; _i++) {
                var m = _a2[_i];
                m.flags |= 8388608;
              }
              return doInsideOfContext(8388608, function() {
                return parsePropertyOrMethodDeclaration(pos, hasJSDoc, decorators, modifiers);
              });
            } else {
              return parsePropertyOrMethodDeclaration(pos, hasJSDoc, decorators, modifiers);
            }
          }
          if (decorators || modifiers) {
            var name = createMissingNode(78, true, ts3.Diagnostics.Declaration_expected);
            return parsePropertyDeclaration(pos, hasJSDoc, decorators, modifiers, name, void 0);
          }
          return ts3.Debug.fail("Should not have attempted to parse class member declaration.");
        }
        function parseClassExpression() {
          return parseClassDeclarationOrExpression(getNodePos(), hasPrecedingJSDocComment(), void 0, void 0, 222);
        }
        function parseClassDeclaration(pos, hasJSDoc, decorators, modifiers) {
          return parseClassDeclarationOrExpression(pos, hasJSDoc, decorators, modifiers, 253);
        }
        function parseClassDeclarationOrExpression(pos, hasJSDoc, decorators, modifiers, kind) {
          var savedAwaitContext = inAwaitContext();
          parseExpected(83);
          var name = parseNameOfClassDeclarationOrExpression();
          var typeParameters = parseTypeParameters();
          if (ts3.some(modifiers, ts3.isExportModifier))
            setAwaitContext(true);
          var heritageClauses = parseHeritageClauses();
          var members;
          if (parseExpected(18)) {
            members = parseClassMembers();
            parseExpected(19);
          } else {
            members = createMissingList();
          }
          setAwaitContext(savedAwaitContext);
          var node = kind === 253 ? factory.createClassDeclaration(decorators, modifiers, name, typeParameters, heritageClauses, members) : factory.createClassExpression(decorators, modifiers, name, typeParameters, heritageClauses, members);
          return withJSDoc(finishNode(node, pos), hasJSDoc);
        }
        function parseNameOfClassDeclarationOrExpression() {
          return isBindingIdentifier() && !isImplementsClause() ? createIdentifier(isBindingIdentifier()) : void 0;
        }
        function isImplementsClause() {
          return token() === 116 && lookAhead(nextTokenIsIdentifierOrKeyword);
        }
        function parseHeritageClauses() {
          if (isHeritageClause()) {
            return parseList(22, parseHeritageClause);
          }
          return void 0;
        }
        function parseHeritageClause() {
          var pos = getNodePos();
          var tok = token();
          ts3.Debug.assert(tok === 93 || tok === 116);
          nextToken();
          var types2 = parseDelimitedList(7, parseExpressionWithTypeArguments);
          return finishNode(factory.createHeritageClause(tok, types2), pos);
        }
        function parseExpressionWithTypeArguments() {
          var pos = getNodePos();
          var expression = parseLeftHandSideExpressionOrHigher();
          var typeArguments = tryParseTypeArguments();
          return finishNode(factory.createExpressionWithTypeArguments(expression, typeArguments), pos);
        }
        function tryParseTypeArguments() {
          return token() === 29 ? parseBracketedList(20, parseType, 29, 31) : void 0;
        }
        function isHeritageClause() {
          return token() === 93 || token() === 116;
        }
        function parseClassMembers() {
          return parseList(5, parseClassElement);
        }
        function parseInterfaceDeclaration(pos, hasJSDoc, decorators, modifiers) {
          parseExpected(117);
          var name = parseIdentifier();
          var typeParameters = parseTypeParameters();
          var heritageClauses = parseHeritageClauses();
          var members = parseObjectTypeMembers();
          var node = factory.createInterfaceDeclaration(decorators, modifiers, name, typeParameters, heritageClauses, members);
          return withJSDoc(finishNode(node, pos), hasJSDoc);
        }
        function parseTypeAliasDeclaration(pos, hasJSDoc, decorators, modifiers) {
          parseExpected(149);
          var name = parseIdentifier();
          var typeParameters = parseTypeParameters();
          parseExpected(62);
          var type3 = token() === 136 && tryParse(parseKeywordAndNoDot) || parseType();
          parseSemicolon();
          var node = factory.createTypeAliasDeclaration(decorators, modifiers, name, typeParameters, type3);
          return withJSDoc(finishNode(node, pos), hasJSDoc);
        }
        function parseEnumMember() {
          var pos = getNodePos();
          var hasJSDoc = hasPrecedingJSDocComment();
          var name = parsePropertyName();
          var initializer = allowInAnd(parseInitializer);
          return withJSDoc(finishNode(factory.createEnumMember(name, initializer), pos), hasJSDoc);
        }
        function parseEnumDeclaration(pos, hasJSDoc, decorators, modifiers) {
          parseExpected(91);
          var name = parseIdentifier();
          var members;
          if (parseExpected(18)) {
            members = doOutsideOfYieldAndAwaitContext(function() {
              return parseDelimitedList(6, parseEnumMember);
            });
            parseExpected(19);
          } else {
            members = createMissingList();
          }
          var node = factory.createEnumDeclaration(decorators, modifiers, name, members);
          return withJSDoc(finishNode(node, pos), hasJSDoc);
        }
        function parseModuleBlock() {
          var pos = getNodePos();
          var statements;
          if (parseExpected(18)) {
            statements = parseList(1, parseStatement);
            parseExpected(19);
          } else {
            statements = createMissingList();
          }
          return finishNode(factory.createModuleBlock(statements), pos);
        }
        function parseModuleOrNamespaceDeclaration(pos, hasJSDoc, decorators, modifiers, flags) {
          var namespaceFlag = flags & 16;
          var name = parseIdentifier();
          var body = parseOptional(24) ? parseModuleOrNamespaceDeclaration(getNodePos(), false, void 0, void 0, 4 | namespaceFlag) : parseModuleBlock();
          var node = factory.createModuleDeclaration(decorators, modifiers, name, body, flags);
          return withJSDoc(finishNode(node, pos), hasJSDoc);
        }
        function parseAmbientExternalModuleDeclaration(pos, hasJSDoc, decorators, modifiers) {
          var flags = 0;
          var name;
          if (token() === 154) {
            name = parseIdentifier();
            flags |= 1024;
          } else {
            name = parseLiteralNode();
            name.text = internIdentifier(name.text);
          }
          var body;
          if (token() === 18) {
            body = parseModuleBlock();
          } else {
            parseSemicolon();
          }
          var node = factory.createModuleDeclaration(decorators, modifiers, name, body, flags);
          return withJSDoc(finishNode(node, pos), hasJSDoc);
        }
        function parseModuleDeclaration(pos, hasJSDoc, decorators, modifiers) {
          var flags = 0;
          if (token() === 154) {
            return parseAmbientExternalModuleDeclaration(pos, hasJSDoc, decorators, modifiers);
          } else if (parseOptional(140)) {
            flags |= 16;
          } else {
            parseExpected(139);
            if (token() === 10) {
              return parseAmbientExternalModuleDeclaration(pos, hasJSDoc, decorators, modifiers);
            }
          }
          return parseModuleOrNamespaceDeclaration(pos, hasJSDoc, decorators, modifiers, flags);
        }
        function isExternalModuleReference() {
          return token() === 143 && lookAhead(nextTokenIsOpenParen);
        }
        function nextTokenIsOpenParen() {
          return nextToken() === 20;
        }
        function nextTokenIsSlash() {
          return nextToken() === 43;
        }
        function parseNamespaceExportDeclaration(pos, hasJSDoc, decorators, modifiers) {
          parseExpected(126);
          parseExpected(140);
          var name = parseIdentifier();
          parseSemicolon();
          var node = factory.createNamespaceExportDeclaration(name);
          node.decorators = decorators;
          node.modifiers = modifiers;
          return withJSDoc(finishNode(node, pos), hasJSDoc);
        }
        function parseImportDeclarationOrImportEqualsDeclaration(pos, hasJSDoc, decorators, modifiers) {
          parseExpected(99);
          var afterImportPos = scanner.getStartPos();
          var identifier;
          if (isIdentifier()) {
            identifier = parseIdentifier();
          }
          var isTypeOnly = false;
          if (token() !== 153 && (identifier === null || identifier === void 0 ? void 0 : identifier.escapedText) === "type" && (isIdentifier() || tokenAfterImportDefinitelyProducesImportDeclaration())) {
            isTypeOnly = true;
            identifier = isIdentifier() ? parseIdentifier() : void 0;
          }
          if (identifier && !tokenAfterImportedIdentifierDefinitelyProducesImportDeclaration()) {
            return parseImportEqualsDeclaration(pos, hasJSDoc, decorators, modifiers, identifier, isTypeOnly);
          }
          var importClause;
          if (identifier || token() === 41 || token() === 18) {
            importClause = parseImportClause(identifier, afterImportPos, isTypeOnly);
            parseExpected(153);
          }
          var moduleSpecifier = parseModuleSpecifier();
          parseSemicolon();
          var node = factory.createImportDeclaration(decorators, modifiers, importClause, moduleSpecifier);
          return withJSDoc(finishNode(node, pos), hasJSDoc);
        }
        function tokenAfterImportDefinitelyProducesImportDeclaration() {
          return token() === 41 || token() === 18;
        }
        function tokenAfterImportedIdentifierDefinitelyProducesImportDeclaration() {
          return token() === 27 || token() === 153;
        }
        function parseImportEqualsDeclaration(pos, hasJSDoc, decorators, modifiers, identifier, isTypeOnly) {
          parseExpected(62);
          var moduleReference = parseModuleReference();
          parseSemicolon();
          var node = factory.createImportEqualsDeclaration(decorators, modifiers, isTypeOnly, identifier, moduleReference);
          var finished = withJSDoc(finishNode(node, pos), hasJSDoc);
          return finished;
        }
        function parseImportClause(identifier, pos, isTypeOnly) {
          var namedBindings;
          if (!identifier || parseOptional(27)) {
            namedBindings = token() === 41 ? parseNamespaceImport() : parseNamedImportsOrExports(265);
          }
          return finishNode(factory.createImportClause(isTypeOnly, identifier, namedBindings), pos);
        }
        function parseModuleReference() {
          return isExternalModuleReference() ? parseExternalModuleReference() : parseEntityName(false);
        }
        function parseExternalModuleReference() {
          var pos = getNodePos();
          parseExpected(143);
          parseExpected(20);
          var expression = parseModuleSpecifier();
          parseExpected(21);
          return finishNode(factory.createExternalModuleReference(expression), pos);
        }
        function parseModuleSpecifier() {
          if (token() === 10) {
            var result2 = parseLiteralNode();
            result2.text = internIdentifier(result2.text);
            return result2;
          } else {
            return parseExpression();
          }
        }
        function parseNamespaceImport() {
          var pos = getNodePos();
          parseExpected(41);
          parseExpected(126);
          var name = parseIdentifier();
          return finishNode(factory.createNamespaceImport(name), pos);
        }
        function parseNamedImportsOrExports(kind) {
          var pos = getNodePos();
          var node = kind === 265 ? factory.createNamedImports(parseBracketedList(23, parseImportSpecifier, 18, 19)) : factory.createNamedExports(parseBracketedList(23, parseExportSpecifier, 18, 19));
          return finishNode(node, pos);
        }
        function parseExportSpecifier() {
          return parseImportOrExportSpecifier(271);
        }
        function parseImportSpecifier() {
          return parseImportOrExportSpecifier(266);
        }
        function parseImportOrExportSpecifier(kind) {
          var pos = getNodePos();
          var checkIdentifierIsKeyword = ts3.isKeyword(token()) && !isIdentifier();
          var checkIdentifierStart = scanner.getTokenPos();
          var checkIdentifierEnd = scanner.getTextPos();
          var identifierName = parseIdentifierName();
          var propertyName;
          var name;
          if (token() === 126) {
            propertyName = identifierName;
            parseExpected(126);
            checkIdentifierIsKeyword = ts3.isKeyword(token()) && !isIdentifier();
            checkIdentifierStart = scanner.getTokenPos();
            checkIdentifierEnd = scanner.getTextPos();
            name = parseIdentifierName();
          } else {
            name = identifierName;
          }
          if (kind === 266 && checkIdentifierIsKeyword) {
            parseErrorAt(checkIdentifierStart, checkIdentifierEnd, ts3.Diagnostics.Identifier_expected);
          }
          var node = kind === 266 ? factory.createImportSpecifier(propertyName, name) : factory.createExportSpecifier(propertyName, name);
          return finishNode(node, pos);
        }
        function parseNamespaceExport(pos) {
          return finishNode(factory.createNamespaceExport(parseIdentifierName()), pos);
        }
        function parseExportDeclaration(pos, hasJSDoc, decorators, modifiers) {
          var savedAwaitContext = inAwaitContext();
          setAwaitContext(true);
          var exportClause;
          var moduleSpecifier;
          var isTypeOnly = parseOptional(149);
          var namespaceExportPos = getNodePos();
          if (parseOptional(41)) {
            if (parseOptional(126)) {
              exportClause = parseNamespaceExport(namespaceExportPos);
            }
            parseExpected(153);
            moduleSpecifier = parseModuleSpecifier();
          } else {
            exportClause = parseNamedImportsOrExports(269);
            if (token() === 153 || token() === 10 && !scanner.hasPrecedingLineBreak()) {
              parseExpected(153);
              moduleSpecifier = parseModuleSpecifier();
            }
          }
          parseSemicolon();
          setAwaitContext(savedAwaitContext);
          var node = factory.createExportDeclaration(decorators, modifiers, isTypeOnly, exportClause, moduleSpecifier);
          return withJSDoc(finishNode(node, pos), hasJSDoc);
        }
        function parseExportAssignment(pos, hasJSDoc, decorators, modifiers) {
          var savedAwaitContext = inAwaitContext();
          setAwaitContext(true);
          var isExportEquals;
          if (parseOptional(62)) {
            isExportEquals = true;
          } else {
            parseExpected(87);
          }
          var expression = parseAssignmentExpressionOrHigher();
          parseSemicolon();
          setAwaitContext(savedAwaitContext);
          var node = factory.createExportAssignment(decorators, modifiers, isExportEquals, expression);
          return withJSDoc(finishNode(node, pos), hasJSDoc);
        }
        function setExternalModuleIndicator(sourceFile) {
          sourceFile.externalModuleIndicator = ts3.forEach(sourceFile.statements, isAnExternalModuleIndicatorNode) || getImportMetaIfNecessary(sourceFile);
        }
        function isAnExternalModuleIndicatorNode(node) {
          return hasModifierOfKind(node, 92) || ts3.isImportEqualsDeclaration(node) && ts3.isExternalModuleReference(node.moduleReference) || ts3.isImportDeclaration(node) || ts3.isExportAssignment(node) || ts3.isExportDeclaration(node) ? node : void 0;
        }
        function getImportMetaIfNecessary(sourceFile) {
          return sourceFile.flags & 2097152 ? walkTreeForExternalModuleIndicators(sourceFile) : void 0;
        }
        function walkTreeForExternalModuleIndicators(node) {
          return isImportMeta(node) ? node : forEachChild(node, walkTreeForExternalModuleIndicators);
        }
        function hasModifierOfKind(node, kind) {
          return ts3.some(node.modifiers, function(m) {
            return m.kind === kind;
          });
        }
        function isImportMeta(node) {
          return ts3.isMetaProperty(node) && node.keywordToken === 99 && node.name.escapedText === "meta";
        }
        var ParsingContext;
        (function(ParsingContext2) {
          ParsingContext2[ParsingContext2["SourceElements"] = 0] = "SourceElements";
          ParsingContext2[ParsingContext2["BlockStatements"] = 1] = "BlockStatements";
          ParsingContext2[ParsingContext2["SwitchClauses"] = 2] = "SwitchClauses";
          ParsingContext2[ParsingContext2["SwitchClauseStatements"] = 3] = "SwitchClauseStatements";
          ParsingContext2[ParsingContext2["TypeMembers"] = 4] = "TypeMembers";
          ParsingContext2[ParsingContext2["ClassMembers"] = 5] = "ClassMembers";
          ParsingContext2[ParsingContext2["EnumMembers"] = 6] = "EnumMembers";
          ParsingContext2[ParsingContext2["HeritageClauseElement"] = 7] = "HeritageClauseElement";
          ParsingContext2[ParsingContext2["VariableDeclarations"] = 8] = "VariableDeclarations";
          ParsingContext2[ParsingContext2["ObjectBindingElements"] = 9] = "ObjectBindingElements";
          ParsingContext2[ParsingContext2["ArrayBindingElements"] = 10] = "ArrayBindingElements";
          ParsingContext2[ParsingContext2["ArgumentExpressions"] = 11] = "ArgumentExpressions";
          ParsingContext2[ParsingContext2["ObjectLiteralMembers"] = 12] = "ObjectLiteralMembers";
          ParsingContext2[ParsingContext2["JsxAttributes"] = 13] = "JsxAttributes";
          ParsingContext2[ParsingContext2["JsxChildren"] = 14] = "JsxChildren";
          ParsingContext2[ParsingContext2["ArrayLiteralMembers"] = 15] = "ArrayLiteralMembers";
          ParsingContext2[ParsingContext2["Parameters"] = 16] = "Parameters";
          ParsingContext2[ParsingContext2["JSDocParameters"] = 17] = "JSDocParameters";
          ParsingContext2[ParsingContext2["RestProperties"] = 18] = "RestProperties";
          ParsingContext2[ParsingContext2["TypeParameters"] = 19] = "TypeParameters";
          ParsingContext2[ParsingContext2["TypeArguments"] = 20] = "TypeArguments";
          ParsingContext2[ParsingContext2["TupleElementTypes"] = 21] = "TupleElementTypes";
          ParsingContext2[ParsingContext2["HeritageClauses"] = 22] = "HeritageClauses";
          ParsingContext2[ParsingContext2["ImportOrExportSpecifiers"] = 23] = "ImportOrExportSpecifiers";
          ParsingContext2[ParsingContext2["Count"] = 24] = "Count";
        })(ParsingContext || (ParsingContext = {}));
        var Tristate;
        (function(Tristate2) {
          Tristate2[Tristate2["False"] = 0] = "False";
          Tristate2[Tristate2["True"] = 1] = "True";
          Tristate2[Tristate2["Unknown"] = 2] = "Unknown";
        })(Tristate || (Tristate = {}));
        var JSDocParser;
        (function(JSDocParser2) {
          function parseJSDocTypeExpressionForTests2(content, start, length) {
            initializeState("file.js", content, 99, void 0, 1);
            scanner.setText(content, start, length);
            currentToken = scanner.scan();
            var jsDocTypeExpression = parseJSDocTypeExpression();
            var sourceFile = createSourceFile2("file.js", 99, 1, false, [], factory.createToken(1), 0);
            var diagnostics = ts3.attachFileToDiagnostics(parseDiagnostics, sourceFile);
            if (jsDocDiagnostics) {
              sourceFile.jsDocDiagnostics = ts3.attachFileToDiagnostics(jsDocDiagnostics, sourceFile);
            }
            clearState();
            return jsDocTypeExpression ? { jsDocTypeExpression, diagnostics } : void 0;
          }
          JSDocParser2.parseJSDocTypeExpressionForTests = parseJSDocTypeExpressionForTests2;
          function parseJSDocTypeExpression(mayOmitBraces) {
            var pos = getNodePos();
            var hasBrace = (mayOmitBraces ? parseOptional : parseExpected)(18);
            var type3 = doInsideOfContext(4194304, parseJSDocType);
            if (!mayOmitBraces || hasBrace) {
              parseExpectedJSDoc(19);
            }
            var result2 = factory.createJSDocTypeExpression(type3);
            fixupParentReferences(result2);
            return finishNode(result2, pos);
          }
          JSDocParser2.parseJSDocTypeExpression = parseJSDocTypeExpression;
          function parseJSDocNameReference() {
            var pos = getNodePos();
            var hasBrace = parseOptional(18);
            var entityName = parseEntityName(false);
            if (hasBrace) {
              parseExpectedJSDoc(19);
            }
            var result2 = factory.createJSDocNameReference(entityName);
            fixupParentReferences(result2);
            return finishNode(result2, pos);
          }
          JSDocParser2.parseJSDocNameReference = parseJSDocNameReference;
          function parseIsolatedJSDocComment2(content, start, length) {
            initializeState("", content, 99, void 0, 1);
            var jsDoc = doInsideOfContext(4194304, function() {
              return parseJSDocCommentWorker(start, length);
            });
            var sourceFile = { languageVariant: 0, text: content };
            var diagnostics = ts3.attachFileToDiagnostics(parseDiagnostics, sourceFile);
            clearState();
            return jsDoc ? { jsDoc, diagnostics } : void 0;
          }
          JSDocParser2.parseIsolatedJSDocComment = parseIsolatedJSDocComment2;
          function parseJSDocComment(parent, start, length) {
            var saveToken = currentToken;
            var saveParseDiagnosticsLength = parseDiagnostics.length;
            var saveParseErrorBeforeNextFinishedNode = parseErrorBeforeNextFinishedNode;
            var comment = doInsideOfContext(4194304, function() {
              return parseJSDocCommentWorker(start, length);
            });
            ts3.setParent(comment, parent);
            if (contextFlags & 131072) {
              if (!jsDocDiagnostics) {
                jsDocDiagnostics = [];
              }
              jsDocDiagnostics.push.apply(jsDocDiagnostics, parseDiagnostics);
            }
            currentToken = saveToken;
            parseDiagnostics.length = saveParseDiagnosticsLength;
            parseErrorBeforeNextFinishedNode = saveParseErrorBeforeNextFinishedNode;
            return comment;
          }
          JSDocParser2.parseJSDocComment = parseJSDocComment;
          var JSDocState;
          (function(JSDocState2) {
            JSDocState2[JSDocState2["BeginningOfLine"] = 0] = "BeginningOfLine";
            JSDocState2[JSDocState2["SawAsterisk"] = 1] = "SawAsterisk";
            JSDocState2[JSDocState2["SavingComments"] = 2] = "SavingComments";
            JSDocState2[JSDocState2["SavingBackticks"] = 3] = "SavingBackticks";
          })(JSDocState || (JSDocState = {}));
          var PropertyLikeParse;
          (function(PropertyLikeParse2) {
            PropertyLikeParse2[PropertyLikeParse2["Property"] = 1] = "Property";
            PropertyLikeParse2[PropertyLikeParse2["Parameter"] = 2] = "Parameter";
            PropertyLikeParse2[PropertyLikeParse2["CallbackParameter"] = 4] = "CallbackParameter";
          })(PropertyLikeParse || (PropertyLikeParse = {}));
          function parseJSDocCommentWorker(start, length) {
            if (start === void 0) {
              start = 0;
            }
            var content = sourceText;
            var end = length === void 0 ? content.length : start + length;
            length = end - start;
            ts3.Debug.assert(start >= 0);
            ts3.Debug.assert(start <= end);
            ts3.Debug.assert(end <= content.length);
            if (!isJSDocLikeText(content, start)) {
              return void 0;
            }
            var tags;
            var tagsPos;
            var tagsEnd;
            var linkEnd;
            var commentsPos;
            var comments = [];
            var parts = [];
            return scanner.scanRange(start + 3, length - 5, function() {
              var state = 1;
              var margin;
              var indent = start - (content.lastIndexOf("\n", start) + 1) + 4;
              function pushComment(text) {
                if (!margin) {
                  margin = indent;
                }
                comments.push(text);
                indent += text.length;
              }
              nextTokenJSDoc();
              while (parseOptionalJsdoc(5))
                ;
              if (parseOptionalJsdoc(4)) {
                state = 0;
                indent = 0;
              }
              loop:
                while (true) {
                  switch (token()) {
                    case 59:
                      if (state === 0 || state === 1) {
                        removeTrailingWhitespace(comments);
                        if (!commentsPos)
                          commentsPos = getNodePos();
                        addTag(parseTag(indent));
                        state = 0;
                        margin = void 0;
                      } else {
                        pushComment(scanner.getTokenText());
                      }
                      break;
                    case 4:
                      comments.push(scanner.getTokenText());
                      state = 0;
                      indent = 0;
                      break;
                    case 41:
                      var asterisk = scanner.getTokenText();
                      if (state === 1 || state === 2) {
                        state = 2;
                        pushComment(asterisk);
                      } else {
                        state = 1;
                        indent += asterisk.length;
                      }
                      break;
                    case 5:
                      var whitespace = scanner.getTokenText();
                      if (state === 2) {
                        comments.push(whitespace);
                      } else if (margin !== void 0 && indent + whitespace.length > margin) {
                        comments.push(whitespace.slice(margin - indent));
                      }
                      indent += whitespace.length;
                      break;
                    case 1:
                      break loop;
                    case 18:
                      state = 2;
                      var commentEnd = scanner.getStartPos();
                      var linkStart = scanner.getTextPos() - 1;
                      var link = parseJSDocLink(linkStart);
                      if (link) {
                        if (!linkEnd) {
                          removeLeadingNewlines(comments);
                        }
                        parts.push(finishNode(factory.createJSDocText(comments.join("")), linkEnd !== null && linkEnd !== void 0 ? linkEnd : start, commentEnd));
                        parts.push(link);
                        comments = [];
                        linkEnd = scanner.getTextPos();
                        break;
                      }
                    default:
                      state = 2;
                      pushComment(scanner.getTokenText());
                      break;
                  }
                  nextTokenJSDoc();
                }
              removeTrailingWhitespace(comments);
              if (parts.length && comments.length) {
                parts.push(finishNode(factory.createJSDocText(comments.join("")), linkEnd !== null && linkEnd !== void 0 ? linkEnd : start, commentsPos));
              }
              if (parts.length && tags)
                ts3.Debug.assertIsDefined(commentsPos, "having parsed tags implies that the end of the comment span should be set");
              var tagsArray = tags && createNodeArray(tags, tagsPos, tagsEnd);
              return finishNode(factory.createJSDocComment(parts.length ? createNodeArray(parts, start, commentsPos) : comments.length ? comments.join("") : void 0, tagsArray), start, end);
            });
            function removeLeadingNewlines(comments2) {
              while (comments2.length && (comments2[0] === "\n" || comments2[0] === "\r")) {
                comments2.shift();
              }
            }
            function removeTrailingWhitespace(comments2) {
              while (comments2.length && comments2[comments2.length - 1].trim() === "") {
                comments2.pop();
              }
            }
            function isNextNonwhitespaceTokenEndOfFile() {
              while (true) {
                nextTokenJSDoc();
                if (token() === 1) {
                  return true;
                }
                if (!(token() === 5 || token() === 4)) {
                  return false;
                }
              }
            }
            function skipWhitespace() {
              if (token() === 5 || token() === 4) {
                if (lookAhead(isNextNonwhitespaceTokenEndOfFile)) {
                  return;
                }
              }
              while (token() === 5 || token() === 4) {
                nextTokenJSDoc();
              }
            }
            function skipWhitespaceOrAsterisk() {
              if (token() === 5 || token() === 4) {
                if (lookAhead(isNextNonwhitespaceTokenEndOfFile)) {
                  return "";
                }
              }
              var precedingLineBreak = scanner.hasPrecedingLineBreak();
              var seenLineBreak = false;
              var indentText = "";
              while (precedingLineBreak && token() === 41 || token() === 5 || token() === 4) {
                indentText += scanner.getTokenText();
                if (token() === 4) {
                  precedingLineBreak = true;
                  seenLineBreak = true;
                  indentText = "";
                } else if (token() === 41) {
                  precedingLineBreak = false;
                }
                nextTokenJSDoc();
              }
              return seenLineBreak ? indentText : "";
            }
            function parseTag(margin) {
              ts3.Debug.assert(token() === 59);
              var start2 = scanner.getTokenPos();
              nextTokenJSDoc();
              var tagName = parseJSDocIdentifierName(void 0);
              var indentText = skipWhitespaceOrAsterisk();
              var tag;
              switch (tagName.escapedText) {
                case "author":
                  tag = parseAuthorTag(start2, tagName, margin, indentText);
                  break;
                case "implements":
                  tag = parseImplementsTag(start2, tagName, margin, indentText);
                  break;
                case "augments":
                case "extends":
                  tag = parseAugmentsTag(start2, tagName, margin, indentText);
                  break;
                case "class":
                case "constructor":
                  tag = parseSimpleTag(start2, factory.createJSDocClassTag, tagName, margin, indentText);
                  break;
                case "public":
                  tag = parseSimpleTag(start2, factory.createJSDocPublicTag, tagName, margin, indentText);
                  break;
                case "private":
                  tag = parseSimpleTag(start2, factory.createJSDocPrivateTag, tagName, margin, indentText);
                  break;
                case "protected":
                  tag = parseSimpleTag(start2, factory.createJSDocProtectedTag, tagName, margin, indentText);
                  break;
                case "readonly":
                  tag = parseSimpleTag(start2, factory.createJSDocReadonlyTag, tagName, margin, indentText);
                  break;
                case "override":
                  tag = parseSimpleTag(start2, factory.createJSDocOverrideTag, tagName, margin, indentText);
                  break;
                case "deprecated":
                  hasDeprecatedTag = true;
                  tag = parseSimpleTag(start2, factory.createJSDocDeprecatedTag, tagName, margin, indentText);
                  break;
                case "this":
                  tag = parseThisTag(start2, tagName, margin, indentText);
                  break;
                case "enum":
                  tag = parseEnumTag(start2, tagName, margin, indentText);
                  break;
                case "arg":
                case "argument":
                case "param":
                  return parseParameterOrPropertyTag(start2, tagName, 2, margin);
                case "return":
                case "returns":
                  tag = parseReturnTag(start2, tagName, margin, indentText);
                  break;
                case "template":
                  tag = parseTemplateTag(start2, tagName, margin, indentText);
                  break;
                case "type":
                  tag = parseTypeTag(start2, tagName, margin, indentText);
                  break;
                case "typedef":
                  tag = parseTypedefTag(start2, tagName, margin, indentText);
                  break;
                case "callback":
                  tag = parseCallbackTag(start2, tagName, margin, indentText);
                  break;
                case "see":
                  tag = parseSeeTag(start2, tagName, margin, indentText);
                  break;
                default:
                  tag = parseUnknownTag(start2, tagName, margin, indentText);
                  break;
              }
              return tag;
            }
            function parseTrailingTagComments(pos, end2, margin, indentText) {
              if (!indentText) {
                margin += end2 - pos;
              }
              return parseTagComments(margin, indentText.slice(margin));
            }
            function parseTagComments(indent, initialMargin) {
              var commentsPos2 = getNodePos();
              var comments2 = [];
              var parts2 = [];
              var linkEnd2;
              var state = 0;
              var previousWhitespace = true;
              var margin;
              function pushComment(text) {
                if (!margin) {
                  margin = indent;
                }
                comments2.push(text);
                indent += text.length;
              }
              if (initialMargin !== void 0) {
                if (initialMargin !== "") {
                  pushComment(initialMargin);
                }
                state = 1;
              }
              var tok = token();
              loop:
                while (true) {
                  switch (tok) {
                    case 4:
                      state = 0;
                      comments2.push(scanner.getTokenText());
                      indent = 0;
                      break;
                    case 59:
                      if (state === 3 || state === 2 && (!previousWhitespace || lookAhead(isNextJSDocTokenWhitespace))) {
                        comments2.push(scanner.getTokenText());
                        break;
                      }
                      scanner.setTextPos(scanner.getTextPos() - 1);
                    case 1:
                      break loop;
                    case 5:
                      if (state === 2 || state === 3) {
                        pushComment(scanner.getTokenText());
                      } else {
                        var whitespace = scanner.getTokenText();
                        if (margin !== void 0 && indent + whitespace.length > margin) {
                          comments2.push(whitespace.slice(margin - indent));
                        }
                        indent += whitespace.length;
                      }
                      break;
                    case 18:
                      state = 2;
                      var commentEnd = scanner.getStartPos();
                      var linkStart = scanner.getTextPos() - 1;
                      var link = parseJSDocLink(linkStart);
                      if (link) {
                        parts2.push(finishNode(factory.createJSDocText(comments2.join("")), linkEnd2 !== null && linkEnd2 !== void 0 ? linkEnd2 : commentsPos2, commentEnd));
                        parts2.push(link);
                        comments2 = [];
                        linkEnd2 = scanner.getTextPos();
                      } else {
                        pushComment(scanner.getTokenText());
                      }
                      break;
                    case 61:
                      if (state === 3) {
                        state = 2;
                      } else {
                        state = 3;
                      }
                      pushComment(scanner.getTokenText());
                      break;
                    case 41:
                      if (state === 0) {
                        state = 1;
                        indent += 1;
                        break;
                      }
                    default:
                      if (state !== 3) {
                        state = 2;
                      }
                      pushComment(scanner.getTokenText());
                      break;
                  }
                  previousWhitespace = token() === 5;
                  tok = nextTokenJSDoc();
                }
              removeLeadingNewlines(comments2);
              removeTrailingWhitespace(comments2);
              if (parts2.length) {
                if (comments2.length) {
                  parts2.push(finishNode(factory.createJSDocText(comments2.join("")), linkEnd2 !== null && linkEnd2 !== void 0 ? linkEnd2 : commentsPos2));
                }
                return createNodeArray(parts2, commentsPos2, scanner.getTextPos());
              } else if (comments2.length) {
                return comments2.join("");
              }
            }
            function isNextJSDocTokenWhitespace() {
              var next = nextTokenJSDoc();
              return next === 5 || next === 4;
            }
            function parseJSDocLink(start2) {
              if (!tryParse(parseJSDocLinkPrefix)) {
                return void 0;
              }
              nextTokenJSDoc();
              skipWhitespace();
              var name = ts3.tokenIsIdentifierOrKeyword(token()) ? parseEntityName(true) : void 0;
              var text = [];
              while (token() !== 19 && token() !== 4 && token() !== 1) {
                text.push(scanner.getTokenText());
                nextTokenJSDoc();
              }
              return finishNode(factory.createJSDocLink(name, text.join("")), start2, scanner.getTextPos());
            }
            function parseJSDocLinkPrefix() {
              skipWhitespaceOrAsterisk();
              return token() === 18 && nextTokenJSDoc() === 59 && ts3.tokenIsIdentifierOrKeyword(nextTokenJSDoc()) && scanner.getTokenValue() === "link";
            }
            function parseUnknownTag(start2, tagName, indent, indentText) {
              return finishNode(factory.createJSDocUnknownTag(tagName, parseTrailingTagComments(start2, getNodePos(), indent, indentText)), start2);
            }
            function addTag(tag) {
              if (!tag) {
                return;
              }
              if (!tags) {
                tags = [tag];
                tagsPos = tag.pos;
              } else {
                tags.push(tag);
              }
              tagsEnd = tag.end;
            }
            function tryParseTypeExpression() {
              skipWhitespaceOrAsterisk();
              return token() === 18 ? parseJSDocTypeExpression() : void 0;
            }
            function parseBracketNameInPropertyAndParamTag() {
              var isBracketed = parseOptionalJsdoc(22);
              if (isBracketed) {
                skipWhitespace();
              }
              var isBackquoted = parseOptionalJsdoc(61);
              var name = parseJSDocEntityName();
              if (isBackquoted) {
                parseExpectedTokenJSDoc(61);
              }
              if (isBracketed) {
                skipWhitespace();
                if (parseOptionalToken(62)) {
                  parseExpression();
                }
                parseExpected(23);
              }
              return { name, isBracketed };
            }
            function isObjectOrObjectArrayTypeReference(node) {
              switch (node.kind) {
                case 145:
                  return true;
                case 179:
                  return isObjectOrObjectArrayTypeReference(node.elementType);
                default:
                  return ts3.isTypeReferenceNode(node) && ts3.isIdentifier(node.typeName) && node.typeName.escapedText === "Object" && !node.typeArguments;
              }
            }
            function parseParameterOrPropertyTag(start2, tagName, target, indent) {
              var typeExpression = tryParseTypeExpression();
              var isNameFirst = !typeExpression;
              skipWhitespaceOrAsterisk();
              var _a2 = parseBracketNameInPropertyAndParamTag(), name = _a2.name, isBracketed = _a2.isBracketed;
              var indentText = skipWhitespaceOrAsterisk();
              if (isNameFirst && !lookAhead(parseJSDocLinkPrefix)) {
                typeExpression = tryParseTypeExpression();
              }
              var comment = parseTrailingTagComments(start2, getNodePos(), indent, indentText);
              var nestedTypeLiteral = target !== 4 && parseNestedTypeLiteral(typeExpression, name, target, indent);
              if (nestedTypeLiteral) {
                typeExpression = nestedTypeLiteral;
                isNameFirst = true;
              }
              var result2 = target === 1 ? factory.createJSDocPropertyTag(tagName, name, isBracketed, typeExpression, isNameFirst, comment) : factory.createJSDocParameterTag(tagName, name, isBracketed, typeExpression, isNameFirst, comment);
              return finishNode(result2, start2);
            }
            function parseNestedTypeLiteral(typeExpression, name, target, indent) {
              if (typeExpression && isObjectOrObjectArrayTypeReference(typeExpression.type)) {
                var pos = getNodePos();
                var child = void 0;
                var children = void 0;
                while (child = tryParse(function() {
                  return parseChildParameterOrPropertyTag(target, indent, name);
                })) {
                  if (child.kind === 330 || child.kind === 337) {
                    children = ts3.append(children, child);
                  }
                }
                if (children) {
                  var literal = finishNode(factory.createJSDocTypeLiteral(children, typeExpression.type.kind === 179), pos);
                  return finishNode(factory.createJSDocTypeExpression(literal), pos);
                }
              }
            }
            function parseReturnTag(start2, tagName, indent, indentText) {
              if (ts3.some(tags, ts3.isJSDocReturnTag)) {
                parseErrorAt(tagName.pos, scanner.getTokenPos(), ts3.Diagnostics._0_tag_already_specified, tagName.escapedText);
              }
              var typeExpression = tryParseTypeExpression();
              return finishNode(factory.createJSDocReturnTag(tagName, typeExpression, parseTrailingTagComments(start2, getNodePos(), indent, indentText)), start2);
            }
            function parseTypeTag(start2, tagName, indent, indentText) {
              if (ts3.some(tags, ts3.isJSDocTypeTag)) {
                parseErrorAt(tagName.pos, scanner.getTokenPos(), ts3.Diagnostics._0_tag_already_specified, tagName.escapedText);
              }
              var typeExpression = parseJSDocTypeExpression(true);
              var comments2 = indent !== void 0 && indentText !== void 0 ? parseTrailingTagComments(start2, getNodePos(), indent, indentText) : void 0;
              return finishNode(factory.createJSDocTypeTag(tagName, typeExpression, comments2), start2);
            }
            function parseSeeTag(start2, tagName, indent, indentText) {
              var isLink = lookAhead(function() {
                return nextTokenJSDoc() === 59 && ts3.tokenIsIdentifierOrKeyword(nextTokenJSDoc()) && scanner.getTokenValue() === "link";
              });
              var nameExpression = isLink ? void 0 : parseJSDocNameReference();
              var comments2 = indent !== void 0 && indentText !== void 0 ? parseTrailingTagComments(start2, getNodePos(), indent, indentText) : void 0;
              return finishNode(factory.createJSDocSeeTag(tagName, nameExpression, comments2), start2);
            }
            function parseAuthorTag(start2, tagName, indent, indentText) {
              var commentStart = getNodePos();
              var textOnly = parseAuthorNameAndEmail();
              var commentEnd = scanner.getStartPos();
              var comments2 = parseTrailingTagComments(start2, commentEnd, indent, indentText);
              if (!comments2) {
                commentEnd = scanner.getStartPos();
              }
              var allParts = typeof comments2 !== "string" ? createNodeArray(ts3.concatenate([finishNode(textOnly, commentStart, commentEnd)], comments2), commentStart) : textOnly.text + comments2;
              return finishNode(factory.createJSDocAuthorTag(tagName, allParts), start2);
            }
            function parseAuthorNameAndEmail() {
              var comments2 = [];
              var inEmail = false;
              var token2 = scanner.getToken();
              while (token2 !== 1 && token2 !== 4) {
                if (token2 === 29) {
                  inEmail = true;
                } else if (token2 === 59 && !inEmail) {
                  break;
                } else if (token2 === 31 && inEmail) {
                  comments2.push(scanner.getTokenText());
                  scanner.setTextPos(scanner.getTokenPos() + 1);
                  break;
                }
                comments2.push(scanner.getTokenText());
                token2 = nextTokenJSDoc();
              }
              return factory.createJSDocText(comments2.join(""));
            }
            function parseImplementsTag(start2, tagName, margin, indentText) {
              var className = parseExpressionWithTypeArgumentsForAugments();
              return finishNode(factory.createJSDocImplementsTag(tagName, className, parseTrailingTagComments(start2, getNodePos(), margin, indentText)), start2);
            }
            function parseAugmentsTag(start2, tagName, margin, indentText) {
              var className = parseExpressionWithTypeArgumentsForAugments();
              return finishNode(factory.createJSDocAugmentsTag(tagName, className, parseTrailingTagComments(start2, getNodePos(), margin, indentText)), start2);
            }
            function parseExpressionWithTypeArgumentsForAugments() {
              var usedBrace = parseOptional(18);
              var pos = getNodePos();
              var expression = parsePropertyAccessEntityNameExpression();
              var typeArguments = tryParseTypeArguments();
              var node = factory.createExpressionWithTypeArguments(expression, typeArguments);
              var res = finishNode(node, pos);
              if (usedBrace) {
                parseExpected(19);
              }
              return res;
            }
            function parsePropertyAccessEntityNameExpression() {
              var pos = getNodePos();
              var node = parseJSDocIdentifierName();
              while (parseOptional(24)) {
                var name = parseJSDocIdentifierName();
                node = finishNode(factory.createPropertyAccessExpression(node, name), pos);
              }
              return node;
            }
            function parseSimpleTag(start2, createTag, tagName, margin, indentText) {
              return finishNode(createTag(tagName, parseTrailingTagComments(start2, getNodePos(), margin, indentText)), start2);
            }
            function parseThisTag(start2, tagName, margin, indentText) {
              var typeExpression = parseJSDocTypeExpression(true);
              skipWhitespace();
              return finishNode(factory.createJSDocThisTag(tagName, typeExpression, parseTrailingTagComments(start2, getNodePos(), margin, indentText)), start2);
            }
            function parseEnumTag(start2, tagName, margin, indentText) {
              var typeExpression = parseJSDocTypeExpression(true);
              skipWhitespace();
              return finishNode(factory.createJSDocEnumTag(tagName, typeExpression, parseTrailingTagComments(start2, getNodePos(), margin, indentText)), start2);
            }
            function parseTypedefTag(start2, tagName, indent, indentText) {
              var _a2;
              var typeExpression = tryParseTypeExpression();
              skipWhitespaceOrAsterisk();
              var fullName = parseJSDocTypeNameWithNamespace();
              skipWhitespace();
              var comment = parseTagComments(indent);
              var end2;
              if (!typeExpression || isObjectOrObjectArrayTypeReference(typeExpression.type)) {
                var child = void 0;
                var childTypeTag = void 0;
                var jsDocPropertyTags = void 0;
                var hasChildren = false;
                while (child = tryParse(function() {
                  return parseChildPropertyTag(indent);
                })) {
                  hasChildren = true;
                  if (child.kind === 333) {
                    if (childTypeTag) {
                      parseErrorAtCurrentToken(ts3.Diagnostics.A_JSDoc_typedef_comment_may_not_contain_multiple_type_tags);
                      var lastError = ts3.lastOrUndefined(parseDiagnostics);
                      if (lastError) {
                        ts3.addRelatedInfo(lastError, ts3.createDetachedDiagnostic(fileName, 0, 0, ts3.Diagnostics.The_tag_was_first_specified_here));
                      }
                      break;
                    } else {
                      childTypeTag = child;
                    }
                  } else {
                    jsDocPropertyTags = ts3.append(jsDocPropertyTags, child);
                  }
                }
                if (hasChildren) {
                  var isArrayType = typeExpression && typeExpression.type.kind === 179;
                  var jsdocTypeLiteral = factory.createJSDocTypeLiteral(jsDocPropertyTags, isArrayType);
                  typeExpression = childTypeTag && childTypeTag.typeExpression && !isObjectOrObjectArrayTypeReference(childTypeTag.typeExpression.type) ? childTypeTag.typeExpression : finishNode(jsdocTypeLiteral, start2);
                  end2 = typeExpression.end;
                }
              }
              end2 = end2 || comment !== void 0 ? getNodePos() : ((_a2 = fullName !== null && fullName !== void 0 ? fullName : typeExpression) !== null && _a2 !== void 0 ? _a2 : tagName).end;
              if (!comment) {
                comment = parseTrailingTagComments(start2, end2, indent, indentText);
              }
              var typedefTag = factory.createJSDocTypedefTag(tagName, typeExpression, fullName, comment);
              return finishNode(typedefTag, start2, end2);
            }
            function parseJSDocTypeNameWithNamespace(nested) {
              var pos = scanner.getTokenPos();
              if (!ts3.tokenIsIdentifierOrKeyword(token())) {
                return void 0;
              }
              var typeNameOrNamespaceName = parseJSDocIdentifierName();
              if (parseOptional(24)) {
                var body = parseJSDocTypeNameWithNamespace(true);
                var jsDocNamespaceNode = factory.createModuleDeclaration(void 0, void 0, typeNameOrNamespaceName, body, nested ? 4 : void 0);
                return finishNode(jsDocNamespaceNode, pos);
              }
              if (nested) {
                typeNameOrNamespaceName.isInJSDocNamespace = true;
              }
              return typeNameOrNamespaceName;
            }
            function parseCallbackTagParameters(indent) {
              var pos = getNodePos();
              var child;
              var parameters;
              while (child = tryParse(function() {
                return parseChildParameterOrPropertyTag(4, indent);
              })) {
                parameters = ts3.append(parameters, child);
              }
              return createNodeArray(parameters || [], pos);
            }
            function parseCallbackTag(start2, tagName, indent, indentText) {
              var fullName = parseJSDocTypeNameWithNamespace();
              skipWhitespace();
              var comment = parseTagComments(indent);
              var parameters = parseCallbackTagParameters(indent);
              var returnTag = tryParse(function() {
                if (parseOptionalJsdoc(59)) {
                  var tag = parseTag(indent);
                  if (tag && tag.kind === 331) {
                    return tag;
                  }
                }
              });
              var typeExpression = finishNode(factory.createJSDocSignature(void 0, parameters, returnTag), start2);
              if (!comment) {
                comment = parseTrailingTagComments(start2, getNodePos(), indent, indentText);
              }
              return finishNode(factory.createJSDocCallbackTag(tagName, typeExpression, fullName, comment), start2);
            }
            function escapedTextsEqual(a2, b2) {
              while (!ts3.isIdentifier(a2) || !ts3.isIdentifier(b2)) {
                if (!ts3.isIdentifier(a2) && !ts3.isIdentifier(b2) && a2.right.escapedText === b2.right.escapedText) {
                  a2 = a2.left;
                  b2 = b2.left;
                } else {
                  return false;
                }
              }
              return a2.escapedText === b2.escapedText;
            }
            function parseChildPropertyTag(indent) {
              return parseChildParameterOrPropertyTag(1, indent);
            }
            function parseChildParameterOrPropertyTag(target, indent, name) {
              var canParseTag = true;
              var seenAsterisk = false;
              while (true) {
                switch (nextTokenJSDoc()) {
                  case 59:
                    if (canParseTag) {
                      var child = tryParseChildTag(target, indent);
                      if (child && (child.kind === 330 || child.kind === 337) && target !== 4 && name && (ts3.isIdentifier(child.name) || !escapedTextsEqual(name, child.name.left))) {
                        return false;
                      }
                      return child;
                    }
                    seenAsterisk = false;
                    break;
                  case 4:
                    canParseTag = true;
                    seenAsterisk = false;
                    break;
                  case 41:
                    if (seenAsterisk) {
                      canParseTag = false;
                    }
                    seenAsterisk = true;
                    break;
                  case 78:
                    canParseTag = false;
                    break;
                  case 1:
                    return false;
                }
              }
            }
            function tryParseChildTag(target, indent) {
              ts3.Debug.assert(token() === 59);
              var start2 = scanner.getStartPos();
              nextTokenJSDoc();
              var tagName = parseJSDocIdentifierName();
              skipWhitespace();
              var t2;
              switch (tagName.escapedText) {
                case "type":
                  return target === 1 && parseTypeTag(start2, tagName);
                case "prop":
                case "property":
                  t2 = 1;
                  break;
                case "arg":
                case "argument":
                case "param":
                  t2 = 2 | 4;
                  break;
                default:
                  return false;
              }
              if (!(target & t2)) {
                return false;
              }
              return parseParameterOrPropertyTag(start2, tagName, target, indent);
            }
            function parseTemplateTagTypeParameter() {
              var typeParameterPos = getNodePos();
              var name = parseJSDocIdentifierName(ts3.Diagnostics.Unexpected_token_A_type_parameter_name_was_expected_without_curly_braces);
              if (ts3.nodeIsMissing(name)) {
                return void 0;
              }
              return finishNode(factory.createTypeParameterDeclaration(name, void 0, void 0), typeParameterPos);
            }
            function parseTemplateTagTypeParameters() {
              var pos = getNodePos();
              var typeParameters = [];
              do {
                skipWhitespace();
                var node = parseTemplateTagTypeParameter();
                if (node !== void 0) {
                  typeParameters.push(node);
                }
                skipWhitespaceOrAsterisk();
              } while (parseOptionalJsdoc(27));
              return createNodeArray(typeParameters, pos);
            }
            function parseTemplateTag(start2, tagName, indent, indentText) {
              var constraint = token() === 18 ? parseJSDocTypeExpression() : void 0;
              var typeParameters = parseTemplateTagTypeParameters();
              return finishNode(factory.createJSDocTemplateTag(tagName, constraint, typeParameters, parseTrailingTagComments(start2, getNodePos(), indent, indentText)), start2);
            }
            function parseOptionalJsdoc(t2) {
              if (token() === t2) {
                nextTokenJSDoc();
                return true;
              }
              return false;
            }
            function parseJSDocEntityName() {
              var entity = parseJSDocIdentifierName();
              if (parseOptional(22)) {
                parseExpected(23);
              }
              while (parseOptional(24)) {
                var name = parseJSDocIdentifierName();
                if (parseOptional(22)) {
                  parseExpected(23);
                }
                entity = createQualifiedName(entity, name);
              }
              return entity;
            }
            function parseJSDocIdentifierName(message) {
              if (!ts3.tokenIsIdentifierOrKeyword(token())) {
                return createMissingNode(78, !message, message || ts3.Diagnostics.Identifier_expected);
              }
              identifierCount++;
              var pos = scanner.getTokenPos();
              var end2 = scanner.getTextPos();
              var originalKeywordKind = token();
              var text = internIdentifier(scanner.getTokenValue());
              var result2 = finishNode(factory.createIdentifier(text, void 0, originalKeywordKind), pos, end2);
              nextTokenJSDoc();
              return result2;
            }
          }
        })(JSDocParser = Parser2.JSDocParser || (Parser2.JSDocParser = {}));
      })(Parser || (Parser = {}));
      var IncrementalParser;
      (function(IncrementalParser2) {
        function updateSourceFile2(sourceFile, newText, textChangeRange, aggressiveChecks) {
          aggressiveChecks = aggressiveChecks || ts3.Debug.shouldAssert(2);
          checkChangeRange(sourceFile, newText, textChangeRange, aggressiveChecks);
          if (ts3.textChangeRangeIsUnchanged(textChangeRange)) {
            return sourceFile;
          }
          if (sourceFile.statements.length === 0) {
            return Parser.parseSourceFile(sourceFile.fileName, newText, sourceFile.languageVersion, void 0, true, sourceFile.scriptKind);
          }
          var incrementalSourceFile = sourceFile;
          ts3.Debug.assert(!incrementalSourceFile.hasBeenIncrementallyParsed);
          incrementalSourceFile.hasBeenIncrementallyParsed = true;
          Parser.fixupParentReferences(incrementalSourceFile);
          var oldText = sourceFile.text;
          var syntaxCursor = createSyntaxCursor(sourceFile);
          var changeRange = extendToAffectedRange(sourceFile, textChangeRange);
          checkChangeRange(sourceFile, newText, changeRange, aggressiveChecks);
          ts3.Debug.assert(changeRange.span.start <= textChangeRange.span.start);
          ts3.Debug.assert(ts3.textSpanEnd(changeRange.span) === ts3.textSpanEnd(textChangeRange.span));
          ts3.Debug.assert(ts3.textSpanEnd(ts3.textChangeRangeNewSpan(changeRange)) === ts3.textSpanEnd(ts3.textChangeRangeNewSpan(textChangeRange)));
          var delta = ts3.textChangeRangeNewSpan(changeRange).length - changeRange.span.length;
          updateTokenPositionsAndMarkElements(incrementalSourceFile, changeRange.span.start, ts3.textSpanEnd(changeRange.span), ts3.textSpanEnd(ts3.textChangeRangeNewSpan(changeRange)), delta, oldText, newText, aggressiveChecks);
          var result2 = Parser.parseSourceFile(sourceFile.fileName, newText, sourceFile.languageVersion, syntaxCursor, true, sourceFile.scriptKind);
          result2.commentDirectives = getNewCommentDirectives(sourceFile.commentDirectives, result2.commentDirectives, changeRange.span.start, ts3.textSpanEnd(changeRange.span), delta, oldText, newText, aggressiveChecks);
          return result2;
        }
        IncrementalParser2.updateSourceFile = updateSourceFile2;
        function getNewCommentDirectives(oldDirectives, newDirectives, changeStart, changeRangeOldEnd, delta, oldText, newText, aggressiveChecks) {
          if (!oldDirectives)
            return newDirectives;
          var commentDirectives;
          var addedNewlyScannedDirectives = false;
          for (var _i = 0, oldDirectives_1 = oldDirectives; _i < oldDirectives_1.length; _i++) {
            var directive = oldDirectives_1[_i];
            var range = directive.range, type3 = directive.type;
            if (range.end < changeStart) {
              commentDirectives = ts3.append(commentDirectives, directive);
            } else if (range.pos > changeRangeOldEnd) {
              addNewlyScannedDirectives();
              var updatedDirective = {
                range: { pos: range.pos + delta, end: range.end + delta },
                type: type3
              };
              commentDirectives = ts3.append(commentDirectives, updatedDirective);
              if (aggressiveChecks) {
                ts3.Debug.assert(oldText.substring(range.pos, range.end) === newText.substring(updatedDirective.range.pos, updatedDirective.range.end));
              }
            }
          }
          addNewlyScannedDirectives();
          return commentDirectives;
          function addNewlyScannedDirectives() {
            if (addedNewlyScannedDirectives)
              return;
            addedNewlyScannedDirectives = true;
            if (!commentDirectives) {
              commentDirectives = newDirectives;
            } else if (newDirectives) {
              commentDirectives.push.apply(commentDirectives, newDirectives);
            }
          }
        }
        function moveElementEntirelyPastChangeRange(element, isArray, delta, oldText, newText, aggressiveChecks) {
          if (isArray) {
            visitArray(element);
          } else {
            visitNode2(element);
          }
          return;
          function visitNode2(node) {
            var text = "";
            if (aggressiveChecks && shouldCheckNode(node)) {
              text = oldText.substring(node.pos, node.end);
            }
            if (node._children) {
              node._children = void 0;
            }
            ts3.setTextRangePosEnd(node, node.pos + delta, node.end + delta);
            if (aggressiveChecks && shouldCheckNode(node)) {
              ts3.Debug.assert(text === newText.substring(node.pos, node.end));
            }
            forEachChild(node, visitNode2, visitArray);
            if (ts3.hasJSDocNodes(node)) {
              for (var _i = 0, _a2 = node.jsDoc; _i < _a2.length; _i++) {
                var jsDocComment = _a2[_i];
                visitNode2(jsDocComment);
              }
            }
            checkNodePositions(node, aggressiveChecks);
          }
          function visitArray(array) {
            array._children = void 0;
            ts3.setTextRangePosEnd(array, array.pos + delta, array.end + delta);
            for (var _i = 0, array_8 = array; _i < array_8.length; _i++) {
              var node = array_8[_i];
              visitNode2(node);
            }
          }
        }
        function shouldCheckNode(node) {
          switch (node.kind) {
            case 10:
            case 8:
            case 78:
              return true;
          }
          return false;
        }
        function adjustIntersectingElement(element, changeStart, changeRangeOldEnd, changeRangeNewEnd, delta) {
          ts3.Debug.assert(element.end >= changeStart, "Adjusting an element that was entirely before the change range");
          ts3.Debug.assert(element.pos <= changeRangeOldEnd, "Adjusting an element that was entirely after the change range");
          ts3.Debug.assert(element.pos <= element.end);
          var pos = Math.min(element.pos, changeRangeNewEnd);
          var end = element.end >= changeRangeOldEnd ? element.end + delta : Math.min(element.end, changeRangeNewEnd);
          ts3.Debug.assert(pos <= end);
          if (element.parent) {
            ts3.Debug.assertGreaterThanOrEqual(pos, element.parent.pos);
            ts3.Debug.assertLessThanOrEqual(end, element.parent.end);
          }
          ts3.setTextRangePosEnd(element, pos, end);
        }
        function checkNodePositions(node, aggressiveChecks) {
          if (aggressiveChecks) {
            var pos_2 = node.pos;
            var visitNode_1 = function(child) {
              ts3.Debug.assert(child.pos >= pos_2);
              pos_2 = child.end;
            };
            if (ts3.hasJSDocNodes(node)) {
              for (var _i = 0, _a2 = node.jsDoc; _i < _a2.length; _i++) {
                var jsDocComment = _a2[_i];
                visitNode_1(jsDocComment);
              }
            }
            forEachChild(node, visitNode_1);
            ts3.Debug.assert(pos_2 <= node.end);
          }
        }
        function updateTokenPositionsAndMarkElements(sourceFile, changeStart, changeRangeOldEnd, changeRangeNewEnd, delta, oldText, newText, aggressiveChecks) {
          visitNode2(sourceFile);
          return;
          function visitNode2(child) {
            ts3.Debug.assert(child.pos <= child.end);
            if (child.pos > changeRangeOldEnd) {
              moveElementEntirelyPastChangeRange(child, false, delta, oldText, newText, aggressiveChecks);
              return;
            }
            var fullEnd = child.end;
            if (fullEnd >= changeStart) {
              child.intersectsChange = true;
              child._children = void 0;
              adjustIntersectingElement(child, changeStart, changeRangeOldEnd, changeRangeNewEnd, delta);
              forEachChild(child, visitNode2, visitArray);
              if (ts3.hasJSDocNodes(child)) {
                for (var _i = 0, _a2 = child.jsDoc; _i < _a2.length; _i++) {
                  var jsDocComment = _a2[_i];
                  visitNode2(jsDocComment);
                }
              }
              checkNodePositions(child, aggressiveChecks);
              return;
            }
            ts3.Debug.assert(fullEnd < changeStart);
          }
          function visitArray(array) {
            ts3.Debug.assert(array.pos <= array.end);
            if (array.pos > changeRangeOldEnd) {
              moveElementEntirelyPastChangeRange(array, true, delta, oldText, newText, aggressiveChecks);
              return;
            }
            var fullEnd = array.end;
            if (fullEnd >= changeStart) {
              array.intersectsChange = true;
              array._children = void 0;
              adjustIntersectingElement(array, changeStart, changeRangeOldEnd, changeRangeNewEnd, delta);
              for (var _i = 0, array_9 = array; _i < array_9.length; _i++) {
                var node = array_9[_i];
                visitNode2(node);
              }
              return;
            }
            ts3.Debug.assert(fullEnd < changeStart);
          }
        }
        function extendToAffectedRange(sourceFile, changeRange) {
          var maxLookahead = 1;
          var start = changeRange.span.start;
          for (var i3 = 0; start > 0 && i3 <= maxLookahead; i3++) {
            var nearestNode = findNearestNodeStartingBeforeOrAtPosition(sourceFile, start);
            ts3.Debug.assert(nearestNode.pos <= start);
            var position = nearestNode.pos;
            start = Math.max(0, position - 1);
          }
          var finalSpan = ts3.createTextSpanFromBounds(start, ts3.textSpanEnd(changeRange.span));
          var finalLength = changeRange.newLength + (changeRange.span.start - start);
          return ts3.createTextChangeRange(finalSpan, finalLength);
        }
        function findNearestNodeStartingBeforeOrAtPosition(sourceFile, position) {
          var bestResult = sourceFile;
          var lastNodeEntirelyBeforePosition;
          forEachChild(sourceFile, visit);
          if (lastNodeEntirelyBeforePosition) {
            var lastChildOfLastEntireNodeBeforePosition = getLastDescendant(lastNodeEntirelyBeforePosition);
            if (lastChildOfLastEntireNodeBeforePosition.pos > bestResult.pos) {
              bestResult = lastChildOfLastEntireNodeBeforePosition;
            }
          }
          return bestResult;
          function getLastDescendant(node) {
            while (true) {
              var lastChild = ts3.getLastChild(node);
              if (lastChild) {
                node = lastChild;
              } else {
                return node;
              }
            }
          }
          function visit(child) {
            if (ts3.nodeIsMissing(child)) {
              return;
            }
            if (child.pos <= position) {
              if (child.pos >= bestResult.pos) {
                bestResult = child;
              }
              if (position < child.end) {
                forEachChild(child, visit);
                return true;
              } else {
                ts3.Debug.assert(child.end <= position);
                lastNodeEntirelyBeforePosition = child;
              }
            } else {
              ts3.Debug.assert(child.pos > position);
              return true;
            }
          }
        }
        function checkChangeRange(sourceFile, newText, textChangeRange, aggressiveChecks) {
          var oldText = sourceFile.text;
          if (textChangeRange) {
            ts3.Debug.assert(oldText.length - textChangeRange.span.length + textChangeRange.newLength === newText.length);
            if (aggressiveChecks || ts3.Debug.shouldAssert(3)) {
              var oldTextPrefix = oldText.substr(0, textChangeRange.span.start);
              var newTextPrefix = newText.substr(0, textChangeRange.span.start);
              ts3.Debug.assert(oldTextPrefix === newTextPrefix);
              var oldTextSuffix = oldText.substring(ts3.textSpanEnd(textChangeRange.span), oldText.length);
              var newTextSuffix = newText.substring(ts3.textSpanEnd(ts3.textChangeRangeNewSpan(textChangeRange)), newText.length);
              ts3.Debug.assert(oldTextSuffix === newTextSuffix);
            }
          }
        }
        function createSyntaxCursor(sourceFile) {
          var currentArray = sourceFile.statements;
          var currentArrayIndex = 0;
          ts3.Debug.assert(currentArrayIndex < currentArray.length);
          var current = currentArray[currentArrayIndex];
          var lastQueriedPosition = -1;
          return {
            currentNode: function(position) {
              if (position !== lastQueriedPosition) {
                if (current && current.end === position && currentArrayIndex < currentArray.length - 1) {
                  currentArrayIndex++;
                  current = currentArray[currentArrayIndex];
                }
                if (!current || current.pos !== position) {
                  findHighestListElementThatStartsAtPosition(position);
                }
              }
              lastQueriedPosition = position;
              ts3.Debug.assert(!current || current.pos === position);
              return current;
            }
          };
          function findHighestListElementThatStartsAtPosition(position) {
            currentArray = void 0;
            currentArrayIndex = -1;
            current = void 0;
            forEachChild(sourceFile, visitNode2, visitArray);
            return;
            function visitNode2(node) {
              if (position >= node.pos && position < node.end) {
                forEachChild(node, visitNode2, visitArray);
                return true;
              }
              return false;
            }
            function visitArray(array) {
              if (position >= array.pos && position < array.end) {
                for (var i3 = 0; i3 < array.length; i3++) {
                  var child = array[i3];
                  if (child) {
                    if (child.pos === position) {
                      currentArray = array;
                      currentArrayIndex = i3;
                      current = child;
                      return true;
                    } else {
                      if (child.pos < position && position < child.end) {
                        forEachChild(child, visitNode2, visitArray);
                        return true;
                      }
                    }
                  }
                }
              }
              return false;
            }
          }
        }
        IncrementalParser2.createSyntaxCursor = createSyntaxCursor;
        var InvalidPosition;
        (function(InvalidPosition2) {
          InvalidPosition2[InvalidPosition2["Value"] = -1] = "Value";
        })(InvalidPosition || (InvalidPosition = {}));
      })(IncrementalParser || (IncrementalParser = {}));
      function isDeclarationFileName(fileName) {
        return ts3.fileExtensionIs(fileName, ".d.ts");
      }
      ts3.isDeclarationFileName = isDeclarationFileName;
      function processCommentPragmas(context, sourceText) {
        var pragmas = [];
        for (var _i = 0, _a2 = ts3.getLeadingCommentRanges(sourceText, 0) || ts3.emptyArray; _i < _a2.length; _i++) {
          var range = _a2[_i];
          var comment = sourceText.substring(range.pos, range.end);
          extractPragmas(pragmas, range, comment);
        }
        context.pragmas = new ts3.Map();
        for (var _b = 0, pragmas_1 = pragmas; _b < pragmas_1.length; _b++) {
          var pragma = pragmas_1[_b];
          if (context.pragmas.has(pragma.name)) {
            var currentValue = context.pragmas.get(pragma.name);
            if (currentValue instanceof Array) {
              currentValue.push(pragma.args);
            } else {
              context.pragmas.set(pragma.name, [currentValue, pragma.args]);
            }
            continue;
          }
          context.pragmas.set(pragma.name, pragma.args);
        }
      }
      ts3.processCommentPragmas = processCommentPragmas;
      function processPragmasIntoFields(context, reportDiagnostic) {
        context.checkJsDirective = void 0;
        context.referencedFiles = [];
        context.typeReferenceDirectives = [];
        context.libReferenceDirectives = [];
        context.amdDependencies = [];
        context.hasNoDefaultLib = false;
        context.pragmas.forEach(function(entryOrList, key2) {
          switch (key2) {
            case "reference": {
              var referencedFiles_1 = context.referencedFiles;
              var typeReferenceDirectives_1 = context.typeReferenceDirectives;
              var libReferenceDirectives_1 = context.libReferenceDirectives;
              ts3.forEach(ts3.toArray(entryOrList), function(arg2) {
                var _a2 = arg2.arguments, types2 = _a2.types, lib = _a2.lib, path2 = _a2.path;
                if (arg2.arguments["no-default-lib"]) {
                  context.hasNoDefaultLib = true;
                } else if (types2) {
                  typeReferenceDirectives_1.push({ pos: types2.pos, end: types2.end, fileName: types2.value });
                } else if (lib) {
                  libReferenceDirectives_1.push({ pos: lib.pos, end: lib.end, fileName: lib.value });
                } else if (path2) {
                  referencedFiles_1.push({ pos: path2.pos, end: path2.end, fileName: path2.value });
                } else {
                  reportDiagnostic(arg2.range.pos, arg2.range.end - arg2.range.pos, ts3.Diagnostics.Invalid_reference_directive_syntax);
                }
              });
              break;
            }
            case "amd-dependency": {
              context.amdDependencies = ts3.map(ts3.toArray(entryOrList), function(x) {
                return { name: x.arguments.name, path: x.arguments.path };
              });
              break;
            }
            case "amd-module": {
              if (entryOrList instanceof Array) {
                for (var _i = 0, entryOrList_1 = entryOrList; _i < entryOrList_1.length; _i++) {
                  var entry = entryOrList_1[_i];
                  if (context.moduleName) {
                    reportDiagnostic(entry.range.pos, entry.range.end - entry.range.pos, ts3.Diagnostics.An_AMD_module_cannot_have_multiple_name_assignments);
                  }
                  context.moduleName = entry.arguments.name;
                }
              } else {
                context.moduleName = entryOrList.arguments.name;
              }
              break;
            }
            case "ts-nocheck":
            case "ts-check": {
              ts3.forEach(ts3.toArray(entryOrList), function(entry2) {
                if (!context.checkJsDirective || entry2.range.pos > context.checkJsDirective.pos) {
                  context.checkJsDirective = {
                    enabled: key2 === "ts-check",
                    end: entry2.range.end,
                    pos: entry2.range.pos
                  };
                }
              });
              break;
            }
            case "jsx":
            case "jsxfrag":
            case "jsximportsource":
            case "jsxruntime":
              return;
            default:
              ts3.Debug.fail("Unhandled pragma kind");
          }
        });
      }
      ts3.processPragmasIntoFields = processPragmasIntoFields;
      var namedArgRegExCache = new ts3.Map();
      function getNamedArgRegEx(name) {
        if (namedArgRegExCache.has(name)) {
          return namedArgRegExCache.get(name);
        }
        var result2 = new RegExp("(\\s" + name + `\\s*=\\s*)('|")(.+?)\\2`, "im");
        namedArgRegExCache.set(name, result2);
        return result2;
      }
      var tripleSlashXMLCommentStartRegEx = /^\/\/\/\s*<(\S+)\s.*?\/>/im;
      var singleLinePragmaRegEx = /^\/\/\/?\s*@(\S+)\s*(.*)\s*$/im;
      function extractPragmas(pragmas, range, text) {
        var tripleSlash = range.kind === 2 && tripleSlashXMLCommentStartRegEx.exec(text);
        if (tripleSlash) {
          var name = tripleSlash[1].toLowerCase();
          var pragma = ts3.commentPragmas[name];
          if (!pragma || !(pragma.kind & 1)) {
            return;
          }
          if (pragma.args) {
            var argument = {};
            for (var _i = 0, _a2 = pragma.args; _i < _a2.length; _i++) {
              var arg2 = _a2[_i];
              var matcher = getNamedArgRegEx(arg2.name);
              var matchResult = matcher.exec(text);
              if (!matchResult && !arg2.optional) {
                return;
              } else if (matchResult) {
                if (arg2.captureSpan) {
                  var startPos = range.pos + matchResult.index + matchResult[1].length + matchResult[2].length;
                  argument[arg2.name] = {
                    value: matchResult[3],
                    pos: startPos,
                    end: startPos + matchResult[3].length
                  };
                } else {
                  argument[arg2.name] = matchResult[3];
                }
              }
            }
            pragmas.push({ name, args: { arguments: argument, range } });
          } else {
            pragmas.push({ name, args: { arguments: {}, range } });
          }
          return;
        }
        var singleLine = range.kind === 2 && singleLinePragmaRegEx.exec(text);
        if (singleLine) {
          return addPragmaForMatch(pragmas, range, 2, singleLine);
        }
        if (range.kind === 3) {
          var multiLinePragmaRegEx = /\s*@(\S+)\s*(.*)\s*$/gim;
          var multiLineMatch = void 0;
          while (multiLineMatch = multiLinePragmaRegEx.exec(text)) {
            addPragmaForMatch(pragmas, range, 4, multiLineMatch);
          }
        }
      }
      function addPragmaForMatch(pragmas, range, kind, match) {
        if (!match)
          return;
        var name = match[1].toLowerCase();
        var pragma = ts3.commentPragmas[name];
        if (!pragma || !(pragma.kind & kind)) {
          return;
        }
        var args = match[2];
        var argument = getNamedPragmaArguments(pragma, args);
        if (argument === "fail")
          return;
        pragmas.push({ name, args: { arguments: argument, range } });
        return;
      }
      function getNamedPragmaArguments(pragma, text) {
        if (!text)
          return {};
        if (!pragma.args)
          return {};
        var args = text.split(/\s+/);
        var argMap = {};
        for (var i3 = 0; i3 < pragma.args.length; i3++) {
          var argument = pragma.args[i3];
          if (!args[i3] && !argument.optional) {
            return "fail";
          }
          if (argument.captureSpan) {
            return ts3.Debug.fail("Capture spans not yet implemented for non-xml pragmas");
          }
          argMap[argument.name] = args[i3];
        }
        return argMap;
      }
      function tagNamesAreEquivalent(lhs, rhs) {
        if (lhs.kind !== rhs.kind) {
          return false;
        }
        if (lhs.kind === 78) {
          return lhs.escapedText === rhs.escapedText;
        }
        if (lhs.kind === 107) {
          return true;
        }
        return lhs.name.escapedText === rhs.name.escapedText && tagNamesAreEquivalent(lhs.expression, rhs.expression);
      }
      ts3.tagNamesAreEquivalent = tagNamesAreEquivalent;
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      ts3.compileOnSaveCommandLineOption = { name: "compileOnSave", type: "boolean" };
      var jsxOptionMap = new ts3.Map(ts3.getEntries({
        "preserve": 1,
        "react-native": 3,
        "react": 2,
        "react-jsx": 4,
        "react-jsxdev": 5
      }));
      ts3.inverseJsxOptionMap = new ts3.Map(ts3.arrayFrom(ts3.mapIterator(jsxOptionMap.entries(), function(_a2) {
        var key2 = _a2[0], value = _a2[1];
        return ["" + value, key2];
      })));
      var libEntries = [
        ["es5", "lib.es5.d.ts"],
        ["es6", "lib.es2015.d.ts"],
        ["es2015", "lib.es2015.d.ts"],
        ["es7", "lib.es2016.d.ts"],
        ["es2016", "lib.es2016.d.ts"],
        ["es2017", "lib.es2017.d.ts"],
        ["es2018", "lib.es2018.d.ts"],
        ["es2019", "lib.es2019.d.ts"],
        ["es2020", "lib.es2020.d.ts"],
        ["es2021", "lib.es2021.d.ts"],
        ["esnext", "lib.esnext.d.ts"],
        ["dom", "lib.dom.d.ts"],
        ["dom.iterable", "lib.dom.iterable.d.ts"],
        ["webworker", "lib.webworker.d.ts"],
        ["webworker.importscripts", "lib.webworker.importscripts.d.ts"],
        ["webworker.iterable", "lib.webworker.iterable.d.ts"],
        ["scripthost", "lib.scripthost.d.ts"],
        ["es2015.core", "lib.es2015.core.d.ts"],
        ["es2015.collection", "lib.es2015.collection.d.ts"],
        ["es2015.generator", "lib.es2015.generator.d.ts"],
        ["es2015.iterable", "lib.es2015.iterable.d.ts"],
        ["es2015.promise", "lib.es2015.promise.d.ts"],
        ["es2015.proxy", "lib.es2015.proxy.d.ts"],
        ["es2015.reflect", "lib.es2015.reflect.d.ts"],
        ["es2015.symbol", "lib.es2015.symbol.d.ts"],
        ["es2015.symbol.wellknown", "lib.es2015.symbol.wellknown.d.ts"],
        ["es2016.array.include", "lib.es2016.array.include.d.ts"],
        ["es2017.object", "lib.es2017.object.d.ts"],
        ["es2017.sharedmemory", "lib.es2017.sharedmemory.d.ts"],
        ["es2017.string", "lib.es2017.string.d.ts"],
        ["es2017.intl", "lib.es2017.intl.d.ts"],
        ["es2017.typedarrays", "lib.es2017.typedarrays.d.ts"],
        ["es2018.asyncgenerator", "lib.es2018.asyncgenerator.d.ts"],
        ["es2018.asynciterable", "lib.es2018.asynciterable.d.ts"],
        ["es2018.intl", "lib.es2018.intl.d.ts"],
        ["es2018.promise", "lib.es2018.promise.d.ts"],
        ["es2018.regexp", "lib.es2018.regexp.d.ts"],
        ["es2019.array", "lib.es2019.array.d.ts"],
        ["es2019.object", "lib.es2019.object.d.ts"],
        ["es2019.string", "lib.es2019.string.d.ts"],
        ["es2019.symbol", "lib.es2019.symbol.d.ts"],
        ["es2020.bigint", "lib.es2020.bigint.d.ts"],
        ["es2020.promise", "lib.es2020.promise.d.ts"],
        ["es2020.sharedmemory", "lib.es2020.sharedmemory.d.ts"],
        ["es2020.string", "lib.es2020.string.d.ts"],
        ["es2020.symbol.wellknown", "lib.es2020.symbol.wellknown.d.ts"],
        ["es2020.intl", "lib.es2020.intl.d.ts"],
        ["es2021.promise", "lib.es2021.promise.d.ts"],
        ["es2021.string", "lib.es2021.string.d.ts"],
        ["es2021.weakref", "lib.es2021.weakref.d.ts"],
        ["esnext.array", "lib.es2019.array.d.ts"],
        ["esnext.symbol", "lib.es2019.symbol.d.ts"],
        ["esnext.asynciterable", "lib.es2018.asynciterable.d.ts"],
        ["esnext.intl", "lib.esnext.intl.d.ts"],
        ["esnext.bigint", "lib.es2020.bigint.d.ts"],
        ["esnext.string", "lib.es2021.string.d.ts"],
        ["esnext.promise", "lib.es2021.promise.d.ts"],
        ["esnext.weakref", "lib.es2021.weakref.d.ts"]
      ];
      ts3.libs = libEntries.map(function(entry) {
        return entry[0];
      });
      ts3.libMap = new ts3.Map(libEntries);
      ts3.optionsForWatch = [
        {
          name: "watchFile",
          type: new ts3.Map(ts3.getEntries({
            fixedpollinginterval: ts3.WatchFileKind.FixedPollingInterval,
            prioritypollinginterval: ts3.WatchFileKind.PriorityPollingInterval,
            dynamicprioritypolling: ts3.WatchFileKind.DynamicPriorityPolling,
            fixedchunksizepolling: ts3.WatchFileKind.FixedChunkSizePolling,
            usefsevents: ts3.WatchFileKind.UseFsEvents,
            usefseventsonparentdirectory: ts3.WatchFileKind.UseFsEventsOnParentDirectory
          })),
          category: ts3.Diagnostics.Advanced_Options,
          description: ts3.Diagnostics.Specify_strategy_for_watching_file_Colon_FixedPollingInterval_default_PriorityPollingInterval_DynamicPriorityPolling_FixedChunkSizePolling_UseFsEvents_UseFsEventsOnParentDirectory
        },
        {
          name: "watchDirectory",
          type: new ts3.Map(ts3.getEntries({
            usefsevents: ts3.WatchDirectoryKind.UseFsEvents,
            fixedpollinginterval: ts3.WatchDirectoryKind.FixedPollingInterval,
            dynamicprioritypolling: ts3.WatchDirectoryKind.DynamicPriorityPolling,
            fixedchunksizepolling: ts3.WatchDirectoryKind.FixedChunkSizePolling
          })),
          category: ts3.Diagnostics.Advanced_Options,
          description: ts3.Diagnostics.Specify_strategy_for_watching_directory_on_platforms_that_don_t_support_recursive_watching_natively_Colon_UseFsEvents_default_FixedPollingInterval_DynamicPriorityPolling_FixedChunkSizePolling
        },
        {
          name: "fallbackPolling",
          type: new ts3.Map(ts3.getEntries({
            fixedinterval: ts3.PollingWatchKind.FixedInterval,
            priorityinterval: ts3.PollingWatchKind.PriorityInterval,
            dynamicpriority: ts3.PollingWatchKind.DynamicPriority,
            fixedchunksize: ts3.PollingWatchKind.FixedChunkSize
          })),
          category: ts3.Diagnostics.Advanced_Options,
          description: ts3.Diagnostics.Specify_strategy_for_creating_a_polling_watch_when_it_fails_to_create_using_file_system_events_Colon_FixedInterval_default_PriorityInterval_DynamicPriority_FixedChunkSize
        },
        {
          name: "synchronousWatchDirectory",
          type: "boolean",
          category: ts3.Diagnostics.Advanced_Options,
          description: ts3.Diagnostics.Synchronously_call_callbacks_and_update_the_state_of_directory_watchers_on_platforms_that_don_t_support_recursive_watching_natively
        },
        {
          name: "excludeDirectories",
          type: "list",
          element: {
            name: "excludeDirectory",
            type: "string",
            isFilePath: true,
            extraValidation: specToDiagnostic
          },
          category: ts3.Diagnostics.Advanced_Options,
          description: ts3.Diagnostics.Synchronously_call_callbacks_and_update_the_state_of_directory_watchers_on_platforms_that_don_t_support_recursive_watching_natively
        },
        {
          name: "excludeFiles",
          type: "list",
          element: {
            name: "excludeFile",
            type: "string",
            isFilePath: true,
            extraValidation: specToDiagnostic
          },
          category: ts3.Diagnostics.Advanced_Options,
          description: ts3.Diagnostics.Synchronously_call_callbacks_and_update_the_state_of_directory_watchers_on_platforms_that_don_t_support_recursive_watching_natively
        }
      ];
      ts3.commonOptionsWithBuild = [
        {
          name: "help",
          shortName: "h",
          type: "boolean",
          showInSimplifiedHelpView: true,
          category: ts3.Diagnostics.Command_line_Options,
          description: ts3.Diagnostics.Print_this_message
        },
        {
          name: "help",
          shortName: "?",
          type: "boolean"
        },
        {
          name: "watch",
          shortName: "w",
          type: "boolean",
          showInSimplifiedHelpView: true,
          category: ts3.Diagnostics.Command_line_Options,
          description: ts3.Diagnostics.Watch_input_files
        },
        {
          name: "preserveWatchOutput",
          type: "boolean",
          showInSimplifiedHelpView: false,
          category: ts3.Diagnostics.Command_line_Options,
          description: ts3.Diagnostics.Whether_to_keep_outdated_console_output_in_watch_mode_instead_of_clearing_the_screen
        },
        {
          name: "listFiles",
          type: "boolean",
          category: ts3.Diagnostics.Advanced_Options,
          description: ts3.Diagnostics.Print_names_of_files_part_of_the_compilation
        },
        {
          name: "explainFiles",
          type: "boolean",
          category: ts3.Diagnostics.Advanced_Options,
          description: ts3.Diagnostics.Print_names_of_files_and_the_reason_they_are_part_of_the_compilation
        },
        {
          name: "listEmittedFiles",
          type: "boolean",
          category: ts3.Diagnostics.Advanced_Options,
          description: ts3.Diagnostics.Print_names_of_generated_files_part_of_the_compilation
        },
        {
          name: "pretty",
          type: "boolean",
          showInSimplifiedHelpView: true,
          category: ts3.Diagnostics.Command_line_Options,
          description: ts3.Diagnostics.Stylize_errors_and_messages_using_color_and_context_experimental
        },
        {
          name: "traceResolution",
          type: "boolean",
          category: ts3.Diagnostics.Advanced_Options,
          description: ts3.Diagnostics.Enable_tracing_of_the_name_resolution_process
        },
        {
          name: "diagnostics",
          type: "boolean",
          category: ts3.Diagnostics.Advanced_Options,
          description: ts3.Diagnostics.Show_diagnostic_information
        },
        {
          name: "extendedDiagnostics",
          type: "boolean",
          category: ts3.Diagnostics.Advanced_Options,
          description: ts3.Diagnostics.Show_verbose_diagnostic_information
        },
        {
          name: "generateCpuProfile",
          type: "string",
          isFilePath: true,
          paramType: ts3.Diagnostics.FILE_OR_DIRECTORY,
          category: ts3.Diagnostics.Advanced_Options,
          description: ts3.Diagnostics.Generates_a_CPU_profile
        },
        {
          name: "generateTrace",
          type: "string",
          isFilePath: true,
          isCommandLineOnly: true,
          paramType: ts3.Diagnostics.DIRECTORY,
          category: ts3.Diagnostics.Advanced_Options,
          description: ts3.Diagnostics.Generates_an_event_trace_and_a_list_of_types
        },
        {
          name: "incremental",
          shortName: "i",
          type: "boolean",
          category: ts3.Diagnostics.Basic_Options,
          description: ts3.Diagnostics.Enable_incremental_compilation,
          transpileOptionValue: void 0
        },
        {
          name: "assumeChangesOnlyAffectDirectDependencies",
          type: "boolean",
          affectsSemanticDiagnostics: true,
          affectsEmit: true,
          category: ts3.Diagnostics.Advanced_Options,
          description: ts3.Diagnostics.Have_recompiles_in_incremental_and_watch_assume_that_changes_within_a_file_will_only_affect_files_directly_depending_on_it
        },
        {
          name: "locale",
          type: "string",
          category: ts3.Diagnostics.Advanced_Options,
          description: ts3.Diagnostics.The_locale_used_when_displaying_messages_to_the_user_e_g_en_us
        }
      ];
      ts3.targetOptionDeclaration = {
        name: "target",
        shortName: "t",
        type: new ts3.Map(ts3.getEntries({
          es3: 0,
          es5: 1,
          es6: 2,
          es2015: 2,
          es2016: 3,
          es2017: 4,
          es2018: 5,
          es2019: 6,
          es2020: 7,
          es2021: 8,
          esnext: 99
        })),
        affectsSourceFile: true,
        affectsModuleResolution: true,
        affectsEmit: true,
        paramType: ts3.Diagnostics.VERSION,
        showInSimplifiedHelpView: true,
        category: ts3.Diagnostics.Basic_Options,
        description: ts3.Diagnostics.Specify_ECMAScript_target_version_Colon_ES3_default_ES5_ES2015_ES2016_ES2017_ES2018_ES2019_ES2020_ES2021_or_ESNEXT
      };
      var commandOptionsWithoutBuild = [
        {
          name: "all",
          type: "boolean",
          showInSimplifiedHelpView: true,
          category: ts3.Diagnostics.Command_line_Options,
          description: ts3.Diagnostics.Show_all_compiler_options
        },
        {
          name: "version",
          shortName: "v",
          type: "boolean",
          showInSimplifiedHelpView: true,
          category: ts3.Diagnostics.Command_line_Options,
          description: ts3.Diagnostics.Print_the_compiler_s_version
        },
        {
          name: "init",
          type: "boolean",
          showInSimplifiedHelpView: true,
          category: ts3.Diagnostics.Command_line_Options,
          description: ts3.Diagnostics.Initializes_a_TypeScript_project_and_creates_a_tsconfig_json_file
        },
        {
          name: "project",
          shortName: "p",
          type: "string",
          isFilePath: true,
          showInSimplifiedHelpView: true,
          category: ts3.Diagnostics.Command_line_Options,
          paramType: ts3.Diagnostics.FILE_OR_DIRECTORY,
          description: ts3.Diagnostics.Compile_the_project_given_the_path_to_its_configuration_file_or_to_a_folder_with_a_tsconfig_json
        },
        {
          name: "build",
          type: "boolean",
          shortName: "b",
          showInSimplifiedHelpView: true,
          category: ts3.Diagnostics.Command_line_Options,
          description: ts3.Diagnostics.Build_one_or_more_projects_and_their_dependencies_if_out_of_date
        },
        {
          name: "showConfig",
          type: "boolean",
          category: ts3.Diagnostics.Command_line_Options,
          isCommandLineOnly: true,
          description: ts3.Diagnostics.Print_the_final_configuration_instead_of_building
        },
        {
          name: "listFilesOnly",
          type: "boolean",
          category: ts3.Diagnostics.Command_line_Options,
          affectsSemanticDiagnostics: true,
          affectsEmit: true,
          isCommandLineOnly: true,
          description: ts3.Diagnostics.Print_names_of_files_that_are_part_of_the_compilation_and_then_stop_processing
        },
        ts3.targetOptionDeclaration,
        {
          name: "module",
          shortName: "m",
          type: new ts3.Map(ts3.getEntries({
            none: ts3.ModuleKind.None,
            commonjs: ts3.ModuleKind.CommonJS,
            amd: ts3.ModuleKind.AMD,
            system: ts3.ModuleKind.System,
            umd: ts3.ModuleKind.UMD,
            es6: ts3.ModuleKind.ES2015,
            es2015: ts3.ModuleKind.ES2015,
            es2020: ts3.ModuleKind.ES2020,
            esnext: ts3.ModuleKind.ESNext
          })),
          affectsModuleResolution: true,
          affectsEmit: true,
          paramType: ts3.Diagnostics.KIND,
          showInSimplifiedHelpView: true,
          category: ts3.Diagnostics.Basic_Options,
          description: ts3.Diagnostics.Specify_module_code_generation_Colon_none_commonjs_amd_system_umd_es2015_es2020_or_ESNext
        },
        {
          name: "lib",
          type: "list",
          element: {
            name: "lib",
            type: ts3.libMap
          },
          affectsModuleResolution: true,
          showInSimplifiedHelpView: true,
          category: ts3.Diagnostics.Basic_Options,
          description: ts3.Diagnostics.Specify_library_files_to_be_included_in_the_compilation,
          transpileOptionValue: void 0
        },
        {
          name: "allowJs",
          type: "boolean",
          affectsModuleResolution: true,
          showInSimplifiedHelpView: true,
          category: ts3.Diagnostics.Basic_Options,
          description: ts3.Diagnostics.Allow_javascript_files_to_be_compiled
        },
        {
          name: "checkJs",
          type: "boolean",
          category: ts3.Diagnostics.Basic_Options,
          description: ts3.Diagnostics.Report_errors_in_js_files
        },
        {
          name: "jsx",
          type: jsxOptionMap,
          affectsSourceFile: true,
          affectsEmit: true,
          affectsModuleResolution: true,
          paramType: ts3.Diagnostics.KIND,
          showInSimplifiedHelpView: true,
          category: ts3.Diagnostics.Basic_Options,
          description: ts3.Diagnostics.Specify_JSX_code_generation_Colon_preserve_react_native_react_react_jsx_or_react_jsxdev
        },
        {
          name: "declaration",
          shortName: "d",
          type: "boolean",
          affectsEmit: true,
          showInSimplifiedHelpView: true,
          category: ts3.Diagnostics.Basic_Options,
          description: ts3.Diagnostics.Generates_corresponding_d_ts_file,
          transpileOptionValue: void 0
        },
        {
          name: "declarationMap",
          type: "boolean",
          affectsEmit: true,
          showInSimplifiedHelpView: true,
          category: ts3.Diagnostics.Basic_Options,
          description: ts3.Diagnostics.Generates_a_sourcemap_for_each_corresponding_d_ts_file,
          transpileOptionValue: void 0
        },
        {
          name: "emitDeclarationOnly",
          type: "boolean",
          affectsEmit: true,
          category: ts3.Diagnostics.Advanced_Options,
          description: ts3.Diagnostics.Only_emit_d_ts_declaration_files,
          transpileOptionValue: void 0
        },
        {
          name: "sourceMap",
          type: "boolean",
          affectsEmit: true,
          showInSimplifiedHelpView: true,
          category: ts3.Diagnostics.Basic_Options,
          description: ts3.Diagnostics.Generates_corresponding_map_file
        },
        {
          name: "outFile",
          type: "string",
          affectsEmit: true,
          isFilePath: true,
          paramType: ts3.Diagnostics.FILE,
          showInSimplifiedHelpView: true,
          category: ts3.Diagnostics.Basic_Options,
          description: ts3.Diagnostics.Concatenate_and_emit_output_to_single_file,
          transpileOptionValue: void 0
        },
        {
          name: "outDir",
          type: "string",
          affectsEmit: true,
          isFilePath: true,
          paramType: ts3.Diagnostics.DIRECTORY,
          showInSimplifiedHelpView: true,
          category: ts3.Diagnostics.Basic_Options,
          description: ts3.Diagnostics.Redirect_output_structure_to_the_directory
        },
        {
          name: "rootDir",
          type: "string",
          affectsEmit: true,
          isFilePath: true,
          paramType: ts3.Diagnostics.LOCATION,
          category: ts3.Diagnostics.Basic_Options,
          description: ts3.Diagnostics.Specify_the_root_directory_of_input_files_Use_to_control_the_output_directory_structure_with_outDir
        },
        {
          name: "composite",
          type: "boolean",
          affectsEmit: true,
          isTSConfigOnly: true,
          category: ts3.Diagnostics.Basic_Options,
          description: ts3.Diagnostics.Enable_project_compilation,
          transpileOptionValue: void 0
        },
        {
          name: "tsBuildInfoFile",
          type: "string",
          affectsEmit: true,
          isFilePath: true,
          paramType: ts3.Diagnostics.FILE,
          category: ts3.Diagnostics.Basic_Options,
          description: ts3.Diagnostics.Specify_file_to_store_incremental_compilation_information,
          transpileOptionValue: void 0
        },
        {
          name: "removeComments",
          type: "boolean",
          affectsEmit: true,
          showInSimplifiedHelpView: true,
          category: ts3.Diagnostics.Basic_Options,
          description: ts3.Diagnostics.Do_not_emit_comments_to_output
        },
        {
          name: "noEmit",
          type: "boolean",
          showInSimplifiedHelpView: true,
          category: ts3.Diagnostics.Basic_Options,
          description: ts3.Diagnostics.Do_not_emit_outputs,
          transpileOptionValue: void 0
        },
        {
          name: "importHelpers",
          type: "boolean",
          affectsEmit: true,
          category: ts3.Diagnostics.Basic_Options,
          description: ts3.Diagnostics.Import_emit_helpers_from_tslib
        },
        {
          name: "importsNotUsedAsValues",
          type: new ts3.Map(ts3.getEntries({
            remove: 0,
            preserve: 1,
            error: 2
          })),
          affectsEmit: true,
          affectsSemanticDiagnostics: true,
          category: ts3.Diagnostics.Advanced_Options,
          description: ts3.Diagnostics.Specify_emit_Slashchecking_behavior_for_imports_that_are_only_used_for_types
        },
        {
          name: "downlevelIteration",
          type: "boolean",
          affectsEmit: true,
          category: ts3.Diagnostics.Basic_Options,
          description: ts3.Diagnostics.Provide_full_support_for_iterables_in_for_of_spread_and_destructuring_when_targeting_ES5_or_ES3
        },
        {
          name: "isolatedModules",
          type: "boolean",
          category: ts3.Diagnostics.Basic_Options,
          description: ts3.Diagnostics.Transpile_each_file_as_a_separate_module_similar_to_ts_transpileModule,
          transpileOptionValue: true
        },
        {
          name: "strict",
          type: "boolean",
          showInSimplifiedHelpView: true,
          category: ts3.Diagnostics.Strict_Type_Checking_Options,
          description: ts3.Diagnostics.Enable_all_strict_type_checking_options
        },
        {
          name: "noImplicitAny",
          type: "boolean",
          affectsSemanticDiagnostics: true,
          strictFlag: true,
          showInSimplifiedHelpView: true,
          category: ts3.Diagnostics.Strict_Type_Checking_Options,
          description: ts3.Diagnostics.Raise_error_on_expressions_and_declarations_with_an_implied_any_type
        },
        {
          name: "strictNullChecks",
          type: "boolean",
          affectsSemanticDiagnostics: true,
          strictFlag: true,
          showInSimplifiedHelpView: true,
          category: ts3.Diagnostics.Strict_Type_Checking_Options,
          description: ts3.Diagnostics.Enable_strict_null_checks
        },
        {
          name: "strictFunctionTypes",
          type: "boolean",
          affectsSemanticDiagnostics: true,
          strictFlag: true,
          showInSimplifiedHelpView: true,
          category: ts3.Diagnostics.Strict_Type_Checking_Options,
          description: ts3.Diagnostics.Enable_strict_checking_of_function_types
        },
        {
          name: "strictBindCallApply",
          type: "boolean",
          strictFlag: true,
          showInSimplifiedHelpView: true,
          category: ts3.Diagnostics.Strict_Type_Checking_Options,
          description: ts3.Diagnostics.Enable_strict_bind_call_and_apply_methods_on_functions
        },
        {
          name: "strictPropertyInitialization",
          type: "boolean",
          affectsSemanticDiagnostics: true,
          strictFlag: true,
          showInSimplifiedHelpView: true,
          category: ts3.Diagnostics.Strict_Type_Checking_Options,
          description: ts3.Diagnostics.Enable_strict_checking_of_property_initialization_in_classes
        },
        {
          name: "noImplicitThis",
          type: "boolean",
          affectsSemanticDiagnostics: true,
          strictFlag: true,
          showInSimplifiedHelpView: true,
          category: ts3.Diagnostics.Strict_Type_Checking_Options,
          description: ts3.Diagnostics.Raise_error_on_this_expressions_with_an_implied_any_type
        },
        {
          name: "alwaysStrict",
          type: "boolean",
          affectsSourceFile: true,
          strictFlag: true,
          showInSimplifiedHelpView: true,
          category: ts3.Diagnostics.Strict_Type_Checking_Options,
          description: ts3.Diagnostics.Parse_in_strict_mode_and_emit_use_strict_for_each_source_file
        },
        {
          name: "noUnusedLocals",
          type: "boolean",
          affectsSemanticDiagnostics: true,
          showInSimplifiedHelpView: true,
          category: ts3.Diagnostics.Additional_Checks,
          description: ts3.Diagnostics.Report_errors_on_unused_locals
        },
        {
          name: "noUnusedParameters",
          type: "boolean",
          affectsSemanticDiagnostics: true,
          showInSimplifiedHelpView: true,
          category: ts3.Diagnostics.Additional_Checks,
          description: ts3.Diagnostics.Report_errors_on_unused_parameters
        },
        {
          name: "noImplicitReturns",
          type: "boolean",
          affectsSemanticDiagnostics: true,
          showInSimplifiedHelpView: true,
          category: ts3.Diagnostics.Additional_Checks,
          description: ts3.Diagnostics.Report_error_when_not_all_code_paths_in_function_return_a_value
        },
        {
          name: "noFallthroughCasesInSwitch",
          type: "boolean",
          affectsBindDiagnostics: true,
          affectsSemanticDiagnostics: true,
          showInSimplifiedHelpView: true,
          category: ts3.Diagnostics.Additional_Checks,
          description: ts3.Diagnostics.Report_errors_for_fallthrough_cases_in_switch_statement
        },
        {
          name: "noUncheckedIndexedAccess",
          type: "boolean",
          affectsSemanticDiagnostics: true,
          showInSimplifiedHelpView: false,
          category: ts3.Diagnostics.Additional_Checks,
          description: ts3.Diagnostics.Include_undefined_in_index_signature_results
        },
        {
          name: "noImplicitOverride",
          type: "boolean",
          affectsSemanticDiagnostics: true,
          showInSimplifiedHelpView: false,
          category: ts3.Diagnostics.Additional_Checks,
          description: ts3.Diagnostics.Ensure_overriding_members_in_derived_classes_are_marked_with_an_override_modifier
        },
        {
          name: "noPropertyAccessFromIndexSignature",
          type: "boolean",
          showInSimplifiedHelpView: false,
          category: ts3.Diagnostics.Additional_Checks,
          description: ts3.Diagnostics.Require_undeclared_properties_from_index_signatures_to_use_element_accesses
        },
        {
          name: "moduleResolution",
          type: new ts3.Map(ts3.getEntries({
            node: ts3.ModuleResolutionKind.NodeJs,
            classic: ts3.ModuleResolutionKind.Classic
          })),
          affectsModuleResolution: true,
          paramType: ts3.Diagnostics.STRATEGY,
          category: ts3.Diagnostics.Module_Resolution_Options,
          description: ts3.Diagnostics.Specify_module_resolution_strategy_Colon_node_Node_js_or_classic_TypeScript_pre_1_6
        },
        {
          name: "baseUrl",
          type: "string",
          affectsModuleResolution: true,
          isFilePath: true,
          category: ts3.Diagnostics.Module_Resolution_Options,
          description: ts3.Diagnostics.Base_directory_to_resolve_non_absolute_module_names
        },
        {
          name: "paths",
          type: "object",
          affectsModuleResolution: true,
          isTSConfigOnly: true,
          category: ts3.Diagnostics.Module_Resolution_Options,
          description: ts3.Diagnostics.A_series_of_entries_which_re_map_imports_to_lookup_locations_relative_to_the_baseUrl,
          transpileOptionValue: void 0
        },
        {
          name: "rootDirs",
          type: "list",
          isTSConfigOnly: true,
          element: {
            name: "rootDirs",
            type: "string",
            isFilePath: true
          },
          affectsModuleResolution: true,
          category: ts3.Diagnostics.Module_Resolution_Options,
          description: ts3.Diagnostics.List_of_root_folders_whose_combined_content_represents_the_structure_of_the_project_at_runtime,
          transpileOptionValue: void 0
        },
        {
          name: "typeRoots",
          type: "list",
          element: {
            name: "typeRoots",
            type: "string",
            isFilePath: true
          },
          affectsModuleResolution: true,
          category: ts3.Diagnostics.Module_Resolution_Options,
          description: ts3.Diagnostics.List_of_folders_to_include_type_definitions_from
        },
        {
          name: "types",
          type: "list",
          element: {
            name: "types",
            type: "string"
          },
          affectsModuleResolution: true,
          showInSimplifiedHelpView: true,
          category: ts3.Diagnostics.Module_Resolution_Options,
          description: ts3.Diagnostics.Type_declaration_files_to_be_included_in_compilation,
          transpileOptionValue: void 0
        },
        {
          name: "allowSyntheticDefaultImports",
          type: "boolean",
          affectsSemanticDiagnostics: true,
          category: ts3.Diagnostics.Module_Resolution_Options,
          description: ts3.Diagnostics.Allow_default_imports_from_modules_with_no_default_export_This_does_not_affect_code_emit_just_typechecking
        },
        {
          name: "esModuleInterop",
          type: "boolean",
          affectsSemanticDiagnostics: true,
          affectsEmit: true,
          showInSimplifiedHelpView: true,
          category: ts3.Diagnostics.Module_Resolution_Options,
          description: ts3.Diagnostics.Enables_emit_interoperability_between_CommonJS_and_ES_Modules_via_creation_of_namespace_objects_for_all_imports_Implies_allowSyntheticDefaultImports
        },
        {
          name: "preserveSymlinks",
          type: "boolean",
          category: ts3.Diagnostics.Module_Resolution_Options,
          description: ts3.Diagnostics.Do_not_resolve_the_real_path_of_symlinks
        },
        {
          name: "allowUmdGlobalAccess",
          type: "boolean",
          affectsSemanticDiagnostics: true,
          category: ts3.Diagnostics.Module_Resolution_Options,
          description: ts3.Diagnostics.Allow_accessing_UMD_globals_from_modules
        },
        {
          name: "sourceRoot",
          type: "string",
          affectsEmit: true,
          paramType: ts3.Diagnostics.LOCATION,
          category: ts3.Diagnostics.Source_Map_Options,
          description: ts3.Diagnostics.Specify_the_location_where_debugger_should_locate_TypeScript_files_instead_of_source_locations
        },
        {
          name: "mapRoot",
          type: "string",
          affectsEmit: true,
          paramType: ts3.Diagnostics.LOCATION,
          category: ts3.Diagnostics.Source_Map_Options,
          description: ts3.Diagnostics.Specify_the_location_where_debugger_should_locate_map_files_instead_of_generated_locations
        },
        {
          name: "inlineSourceMap",
          type: "boolean",
          affectsEmit: true,
          category: ts3.Diagnostics.Source_Map_Options,
          description: ts3.Diagnostics.Emit_a_single_file_with_source_maps_instead_of_having_a_separate_file
        },
        {
          name: "inlineSources",
          type: "boolean",
          affectsEmit: true,
          category: ts3.Diagnostics.Source_Map_Options,
          description: ts3.Diagnostics.Emit_the_source_alongside_the_sourcemaps_within_a_single_file_requires_inlineSourceMap_or_sourceMap_to_be_set
        },
        {
          name: "experimentalDecorators",
          type: "boolean",
          affectsSemanticDiagnostics: true,
          category: ts3.Diagnostics.Experimental_Options,
          description: ts3.Diagnostics.Enables_experimental_support_for_ES7_decorators
        },
        {
          name: "emitDecoratorMetadata",
          type: "boolean",
          affectsSemanticDiagnostics: true,
          affectsEmit: true,
          category: ts3.Diagnostics.Experimental_Options,
          description: ts3.Diagnostics.Enables_experimental_support_for_emitting_type_metadata_for_decorators
        },
        {
          name: "jsxFactory",
          type: "string",
          category: ts3.Diagnostics.Advanced_Options,
          description: ts3.Diagnostics.Specify_the_JSX_factory_function_to_use_when_targeting_react_JSX_emit_e_g_React_createElement_or_h
        },
        {
          name: "jsxFragmentFactory",
          type: "string",
          category: ts3.Diagnostics.Advanced_Options,
          description: ts3.Diagnostics.Specify_the_JSX_fragment_factory_function_to_use_when_targeting_react_JSX_emit_with_jsxFactory_compiler_option_is_specified_e_g_Fragment
        },
        {
          name: "jsxImportSource",
          type: "string",
          affectsSemanticDiagnostics: true,
          affectsEmit: true,
          affectsModuleResolution: true,
          category: ts3.Diagnostics.Advanced_Options,
          description: ts3.Diagnostics.Specify_the_module_specifier_to_be_used_to_import_the_jsx_and_jsxs_factory_functions_from_eg_react
        },
        {
          name: "resolveJsonModule",
          type: "boolean",
          affectsModuleResolution: true,
          category: ts3.Diagnostics.Advanced_Options,
          description: ts3.Diagnostics.Include_modules_imported_with_json_extension
        },
        {
          name: "out",
          type: "string",
          affectsEmit: true,
          isFilePath: false,
          category: ts3.Diagnostics.Advanced_Options,
          paramType: ts3.Diagnostics.FILE,
          description: ts3.Diagnostics.Deprecated_Use_outFile_instead_Concatenate_and_emit_output_to_single_file,
          transpileOptionValue: void 0
        },
        {
          name: "reactNamespace",
          type: "string",
          affectsEmit: true,
          category: ts3.Diagnostics.Advanced_Options,
          description: ts3.Diagnostics.Deprecated_Use_jsxFactory_instead_Specify_the_object_invoked_for_createElement_when_targeting_react_JSX_emit
        },
        {
          name: "skipDefaultLibCheck",
          type: "boolean",
          category: ts3.Diagnostics.Advanced_Options,
          description: ts3.Diagnostics.Deprecated_Use_skipLibCheck_instead_Skip_type_checking_of_default_library_declaration_files
        },
        {
          name: "charset",
          type: "string",
          category: ts3.Diagnostics.Advanced_Options,
          description: ts3.Diagnostics.The_character_set_of_the_input_files
        },
        {
          name: "emitBOM",
          type: "boolean",
          affectsEmit: true,
          category: ts3.Diagnostics.Advanced_Options,
          description: ts3.Diagnostics.Emit_a_UTF_8_Byte_Order_Mark_BOM_in_the_beginning_of_output_files
        },
        {
          name: "newLine",
          type: new ts3.Map(ts3.getEntries({
            crlf: 0,
            lf: 1
          })),
          affectsEmit: true,
          paramType: ts3.Diagnostics.NEWLINE,
          category: ts3.Diagnostics.Advanced_Options,
          description: ts3.Diagnostics.Specify_the_end_of_line_sequence_to_be_used_when_emitting_files_Colon_CRLF_dos_or_LF_unix
        },
        {
          name: "noErrorTruncation",
          type: "boolean",
          affectsSemanticDiagnostics: true,
          category: ts3.Diagnostics.Advanced_Options,
          description: ts3.Diagnostics.Do_not_truncate_error_messages
        },
        {
          name: "noLib",
          type: "boolean",
          affectsModuleResolution: true,
          category: ts3.Diagnostics.Advanced_Options,
          description: ts3.Diagnostics.Do_not_include_the_default_library_file_lib_d_ts,
          transpileOptionValue: true
        },
        {
          name: "noResolve",
          type: "boolean",
          affectsModuleResolution: true,
          category: ts3.Diagnostics.Advanced_Options,
          description: ts3.Diagnostics.Do_not_add_triple_slash_references_or_imported_modules_to_the_list_of_compiled_files,
          transpileOptionValue: true
        },
        {
          name: "stripInternal",
          type: "boolean",
          affectsEmit: true,
          category: ts3.Diagnostics.Advanced_Options,
          description: ts3.Diagnostics.Do_not_emit_declarations_for_code_that_has_an_internal_annotation
        },
        {
          name: "disableSizeLimit",
          type: "boolean",
          affectsSourceFile: true,
          category: ts3.Diagnostics.Advanced_Options,
          description: ts3.Diagnostics.Disable_size_limitations_on_JavaScript_projects
        },
        {
          name: "disableSourceOfProjectReferenceRedirect",
          type: "boolean",
          isTSConfigOnly: true,
          category: ts3.Diagnostics.Advanced_Options,
          description: ts3.Diagnostics.Disable_use_of_source_files_instead_of_declaration_files_from_referenced_projects
        },
        {
          name: "disableSolutionSearching",
          type: "boolean",
          isTSConfigOnly: true,
          category: ts3.Diagnostics.Advanced_Options,
          description: ts3.Diagnostics.Disable_solution_searching_for_this_project
        },
        {
          name: "disableReferencedProjectLoad",
          type: "boolean",
          isTSConfigOnly: true,
          category: ts3.Diagnostics.Advanced_Options,
          description: ts3.Diagnostics.Disable_loading_referenced_projects
        },
        {
          name: "noImplicitUseStrict",
          type: "boolean",
          affectsSemanticDiagnostics: true,
          category: ts3.Diagnostics.Advanced_Options,
          description: ts3.Diagnostics.Do_not_emit_use_strict_directives_in_module_output
        },
        {
          name: "noEmitHelpers",
          type: "boolean",
          affectsEmit: true,
          category: ts3.Diagnostics.Advanced_Options,
          description: ts3.Diagnostics.Do_not_generate_custom_helper_functions_like_extends_in_compiled_output
        },
        {
          name: "noEmitOnError",
          type: "boolean",
          affectsEmit: true,
          category: ts3.Diagnostics.Advanced_Options,
          description: ts3.Diagnostics.Do_not_emit_outputs_if_any_errors_were_reported,
          transpileOptionValue: void 0
        },
        {
          name: "preserveConstEnums",
          type: "boolean",
          affectsEmit: true,
          category: ts3.Diagnostics.Advanced_Options,
          description: ts3.Diagnostics.Do_not_erase_const_enum_declarations_in_generated_code
        },
        {
          name: "declarationDir",
          type: "string",
          affectsEmit: true,
          isFilePath: true,
          paramType: ts3.Diagnostics.DIRECTORY,
          category: ts3.Diagnostics.Advanced_Options,
          description: ts3.Diagnostics.Output_directory_for_generated_declaration_files,
          transpileOptionValue: void 0
        },
        {
          name: "skipLibCheck",
          type: "boolean",
          category: ts3.Diagnostics.Advanced_Options,
          description: ts3.Diagnostics.Skip_type_checking_of_declaration_files
        },
        {
          name: "allowUnusedLabels",
          type: "boolean",
          affectsBindDiagnostics: true,
          affectsSemanticDiagnostics: true,
          category: ts3.Diagnostics.Advanced_Options,
          description: ts3.Diagnostics.Do_not_report_errors_on_unused_labels
        },
        {
          name: "allowUnreachableCode",
          type: "boolean",
          affectsBindDiagnostics: true,
          affectsSemanticDiagnostics: true,
          category: ts3.Diagnostics.Advanced_Options,
          description: ts3.Diagnostics.Do_not_report_errors_on_unreachable_code
        },
        {
          name: "suppressExcessPropertyErrors",
          type: "boolean",
          affectsSemanticDiagnostics: true,
          category: ts3.Diagnostics.Advanced_Options,
          description: ts3.Diagnostics.Suppress_excess_property_checks_for_object_literals
        },
        {
          name: "suppressImplicitAnyIndexErrors",
          type: "boolean",
          affectsSemanticDiagnostics: true,
          category: ts3.Diagnostics.Advanced_Options,
          description: ts3.Diagnostics.Suppress_noImplicitAny_errors_for_indexing_objects_lacking_index_signatures
        },
        {
          name: "forceConsistentCasingInFileNames",
          type: "boolean",
          affectsModuleResolution: true,
          category: ts3.Diagnostics.Advanced_Options,
          description: ts3.Diagnostics.Disallow_inconsistently_cased_references_to_the_same_file
        },
        {
          name: "maxNodeModuleJsDepth",
          type: "number",
          affectsModuleResolution: true,
          category: ts3.Diagnostics.Advanced_Options,
          description: ts3.Diagnostics.The_maximum_dependency_depth_to_search_under_node_modules_and_load_JavaScript_files
        },
        {
          name: "noStrictGenericChecks",
          type: "boolean",
          affectsSemanticDiagnostics: true,
          category: ts3.Diagnostics.Advanced_Options,
          description: ts3.Diagnostics.Disable_strict_checking_of_generic_signatures_in_function_types
        },
        {
          name: "useDefineForClassFields",
          type: "boolean",
          affectsSemanticDiagnostics: true,
          affectsEmit: true,
          category: ts3.Diagnostics.Advanced_Options,
          description: ts3.Diagnostics.Emit_class_fields_with_Define_instead_of_Set
        },
        {
          name: "keyofStringsOnly",
          type: "boolean",
          category: ts3.Diagnostics.Advanced_Options,
          description: ts3.Diagnostics.Resolve_keyof_to_string_valued_property_names_only_no_numbers_or_symbols
        },
        {
          name: "plugins",
          type: "list",
          isTSConfigOnly: true,
          element: {
            name: "plugin",
            type: "object"
          },
          description: ts3.Diagnostics.List_of_language_service_plugins
        }
      ];
      ts3.optionDeclarations = __spreadArray(__spreadArray([], ts3.commonOptionsWithBuild), commandOptionsWithoutBuild);
      ts3.semanticDiagnosticsOptionDeclarations = ts3.optionDeclarations.filter(function(option) {
        return !!option.affectsSemanticDiagnostics;
      });
      ts3.affectsEmitOptionDeclarations = ts3.optionDeclarations.filter(function(option) {
        return !!option.affectsEmit;
      });
      ts3.moduleResolutionOptionDeclarations = ts3.optionDeclarations.filter(function(option) {
        return !!option.affectsModuleResolution;
      });
      ts3.sourceFileAffectingCompilerOptions = ts3.optionDeclarations.filter(function(option) {
        return !!option.affectsSourceFile || !!option.affectsModuleResolution || !!option.affectsBindDiagnostics;
      });
      ts3.transpileOptionValueCompilerOptions = ts3.optionDeclarations.filter(function(option) {
        return ts3.hasProperty(option, "transpileOptionValue");
      });
      var commandOptionsOnlyBuild = [
        {
          name: "verbose",
          shortName: "v",
          category: ts3.Diagnostics.Command_line_Options,
          description: ts3.Diagnostics.Enable_verbose_logging,
          type: "boolean"
        },
        {
          name: "dry",
          shortName: "d",
          category: ts3.Diagnostics.Command_line_Options,
          description: ts3.Diagnostics.Show_what_would_be_built_or_deleted_if_specified_with_clean,
          type: "boolean"
        },
        {
          name: "force",
          shortName: "f",
          category: ts3.Diagnostics.Command_line_Options,
          description: ts3.Diagnostics.Build_all_projects_including_those_that_appear_to_be_up_to_date,
          type: "boolean"
        },
        {
          name: "clean",
          category: ts3.Diagnostics.Command_line_Options,
          description: ts3.Diagnostics.Delete_the_outputs_of_all_projects,
          type: "boolean"
        }
      ];
      ts3.buildOpts = __spreadArray(__spreadArray([], ts3.commonOptionsWithBuild), commandOptionsOnlyBuild);
      ts3.typeAcquisitionDeclarations = [
        {
          name: "enableAutoDiscovery",
          type: "boolean"
        },
        {
          name: "enable",
          type: "boolean"
        },
        {
          name: "include",
          type: "list",
          element: {
            name: "include",
            type: "string"
          }
        },
        {
          name: "exclude",
          type: "list",
          element: {
            name: "exclude",
            type: "string"
          }
        },
        {
          name: "disableFilenameBasedTypeAcquisition",
          type: "boolean"
        }
      ];
      function createOptionNameMap(optionDeclarations) {
        var optionsNameMap = new ts3.Map();
        var shortOptionNames = new ts3.Map();
        ts3.forEach(optionDeclarations, function(option) {
          optionsNameMap.set(option.name.toLowerCase(), option);
          if (option.shortName) {
            shortOptionNames.set(option.shortName, option.name);
          }
        });
        return { optionsNameMap, shortOptionNames };
      }
      ts3.createOptionNameMap = createOptionNameMap;
      var optionsNameMapCache;
      function getOptionsNameMap() {
        return optionsNameMapCache || (optionsNameMapCache = createOptionNameMap(ts3.optionDeclarations));
      }
      ts3.getOptionsNameMap = getOptionsNameMap;
      var compilerOptionsAlternateMode = {
        diagnostic: ts3.Diagnostics.Compiler_option_0_may_only_be_used_with_build,
        getOptionsNameMap: getBuildOptionsNameMap
      };
      ts3.defaultInitCompilerOptions = {
        module: ts3.ModuleKind.CommonJS,
        target: 1,
        strict: true,
        esModuleInterop: true,
        forceConsistentCasingInFileNames: true,
        skipLibCheck: true
      };
      function convertEnableAutoDiscoveryToEnable(typeAcquisition) {
        if (typeAcquisition && typeAcquisition.enableAutoDiscovery !== void 0 && typeAcquisition.enable === void 0) {
          return {
            enable: typeAcquisition.enableAutoDiscovery,
            include: typeAcquisition.include || [],
            exclude: typeAcquisition.exclude || []
          };
        }
        return typeAcquisition;
      }
      ts3.convertEnableAutoDiscoveryToEnable = convertEnableAutoDiscoveryToEnable;
      function createCompilerDiagnosticForInvalidCustomType(opt) {
        return createDiagnosticForInvalidCustomType(opt, ts3.createCompilerDiagnostic);
      }
      ts3.createCompilerDiagnosticForInvalidCustomType = createCompilerDiagnosticForInvalidCustomType;
      function createDiagnosticForInvalidCustomType(opt, createDiagnostic) {
        var namesOfType = ts3.arrayFrom(opt.type.keys()).map(function(key2) {
          return "'" + key2 + "'";
        }).join(", ");
        return createDiagnostic(ts3.Diagnostics.Argument_for_0_option_must_be_Colon_1, "--" + opt.name, namesOfType);
      }
      function parseCustomTypeOption(opt, value, errors) {
        return convertJsonOptionOfCustomType(opt, trimString(value || ""), errors);
      }
      ts3.parseCustomTypeOption = parseCustomTypeOption;
      function parseListTypeOption(opt, value, errors) {
        if (value === void 0) {
          value = "";
        }
        value = trimString(value);
        if (ts3.startsWith(value, "-")) {
          return void 0;
        }
        if (value === "") {
          return [];
        }
        var values = value.split(",");
        switch (opt.element.type) {
          case "number":
            return ts3.mapDefined(values, function(v) {
              return validateJsonOptionValue(opt.element, parseInt(v), errors);
            });
          case "string":
            return ts3.mapDefined(values, function(v) {
              return validateJsonOptionValue(opt.element, v || "", errors);
            });
          default:
            return ts3.mapDefined(values, function(v) {
              return parseCustomTypeOption(opt.element, v, errors);
            });
        }
      }
      ts3.parseListTypeOption = parseListTypeOption;
      function getOptionName(option) {
        return option.name;
      }
      function createUnknownOptionError(unknownOption, diagnostics, createDiagnostics, unknownOptionErrorText) {
        var _a2;
        if ((_a2 = diagnostics.alternateMode) === null || _a2 === void 0 ? void 0 : _a2.getOptionsNameMap().optionsNameMap.has(unknownOption.toLowerCase())) {
          return createDiagnostics(diagnostics.alternateMode.diagnostic, unknownOption);
        }
        var possibleOption = ts3.getSpellingSuggestion(unknownOption, diagnostics.optionDeclarations, getOptionName);
        return possibleOption ? createDiagnostics(diagnostics.unknownDidYouMeanDiagnostic, unknownOptionErrorText || unknownOption, possibleOption.name) : createDiagnostics(diagnostics.unknownOptionDiagnostic, unknownOptionErrorText || unknownOption);
      }
      function parseCommandLineWorker(diagnostics, commandLine, readFile) {
        var options = {};
        var watchOptions;
        var fileNames = [];
        var errors = [];
        parseStrings(commandLine);
        return {
          options,
          watchOptions,
          fileNames,
          errors
        };
        function parseStrings(args) {
          var i3 = 0;
          while (i3 < args.length) {
            var s2 = args[i3];
            i3++;
            if (s2.charCodeAt(0) === 64) {
              parseResponseFile(s2.slice(1));
            } else if (s2.charCodeAt(0) === 45) {
              var inputOptionName = s2.slice(s2.charCodeAt(1) === 45 ? 2 : 1);
              var opt = getOptionDeclarationFromName(diagnostics.getOptionsNameMap, inputOptionName, true);
              if (opt) {
                i3 = parseOptionValue(args, i3, diagnostics, opt, options, errors);
              } else {
                var watchOpt = getOptionDeclarationFromName(watchOptionsDidYouMeanDiagnostics.getOptionsNameMap, inputOptionName, true);
                if (watchOpt) {
                  i3 = parseOptionValue(args, i3, watchOptionsDidYouMeanDiagnostics, watchOpt, watchOptions || (watchOptions = {}), errors);
                } else {
                  errors.push(createUnknownOptionError(inputOptionName, diagnostics, ts3.createCompilerDiagnostic, s2));
                }
              }
            } else {
              fileNames.push(s2);
            }
          }
        }
        function parseResponseFile(fileName) {
          var text = tryReadFile(fileName, readFile || function(fileName2) {
            return ts3.sys.readFile(fileName2);
          });
          if (!ts3.isString(text)) {
            errors.push(text);
            return;
          }
          var args = [];
          var pos = 0;
          while (true) {
            while (pos < text.length && text.charCodeAt(pos) <= 32)
              pos++;
            if (pos >= text.length)
              break;
            var start = pos;
            if (text.charCodeAt(start) === 34) {
              pos++;
              while (pos < text.length && text.charCodeAt(pos) !== 34)
                pos++;
              if (pos < text.length) {
                args.push(text.substring(start + 1, pos));
                pos++;
              } else {
                errors.push(ts3.createCompilerDiagnostic(ts3.Diagnostics.Unterminated_quoted_string_in_response_file_0, fileName));
              }
            } else {
              while (text.charCodeAt(pos) > 32)
                pos++;
              args.push(text.substring(start, pos));
            }
          }
          parseStrings(args);
        }
      }
      ts3.parseCommandLineWorker = parseCommandLineWorker;
      function parseOptionValue(args, i3, diagnostics, opt, options, errors) {
        if (opt.isTSConfigOnly) {
          var optValue = args[i3];
          if (optValue === "null") {
            options[opt.name] = void 0;
            i3++;
          } else if (opt.type === "boolean") {
            if (optValue === "false") {
              options[opt.name] = validateJsonOptionValue(opt, false, errors);
              i3++;
            } else {
              if (optValue === "true")
                i3++;
              errors.push(ts3.createCompilerDiagnostic(ts3.Diagnostics.Option_0_can_only_be_specified_in_tsconfig_json_file_or_set_to_false_or_null_on_command_line, opt.name));
            }
          } else {
            errors.push(ts3.createCompilerDiagnostic(ts3.Diagnostics.Option_0_can_only_be_specified_in_tsconfig_json_file_or_set_to_null_on_command_line, opt.name));
            if (optValue && !ts3.startsWith(optValue, "-"))
              i3++;
          }
        } else {
          if (!args[i3] && opt.type !== "boolean") {
            errors.push(ts3.createCompilerDiagnostic(diagnostics.optionTypeMismatchDiagnostic, opt.name, getCompilerOptionValueTypeString(opt)));
          }
          if (args[i3] !== "null") {
            switch (opt.type) {
              case "number":
                options[opt.name] = validateJsonOptionValue(opt, parseInt(args[i3]), errors);
                i3++;
                break;
              case "boolean":
                var optValue = args[i3];
                options[opt.name] = validateJsonOptionValue(opt, optValue !== "false", errors);
                if (optValue === "false" || optValue === "true") {
                  i3++;
                }
                break;
              case "string":
                options[opt.name] = validateJsonOptionValue(opt, args[i3] || "", errors);
                i3++;
                break;
              case "list":
                var result2 = parseListTypeOption(opt, args[i3], errors);
                options[opt.name] = result2 || [];
                if (result2) {
                  i3++;
                }
                break;
              default:
                options[opt.name] = parseCustomTypeOption(opt, args[i3], errors);
                i3++;
                break;
            }
          } else {
            options[opt.name] = void 0;
            i3++;
          }
        }
        return i3;
      }
      ts3.compilerOptionsDidYouMeanDiagnostics = {
        alternateMode: compilerOptionsAlternateMode,
        getOptionsNameMap,
        optionDeclarations: ts3.optionDeclarations,
        unknownOptionDiagnostic: ts3.Diagnostics.Unknown_compiler_option_0,
        unknownDidYouMeanDiagnostic: ts3.Diagnostics.Unknown_compiler_option_0_Did_you_mean_1,
        optionTypeMismatchDiagnostic: ts3.Diagnostics.Compiler_option_0_expects_an_argument
      };
      function parseCommandLine(commandLine, readFile) {
        return parseCommandLineWorker(ts3.compilerOptionsDidYouMeanDiagnostics, commandLine, readFile);
      }
      ts3.parseCommandLine = parseCommandLine;
      function getOptionFromName(optionName, allowShort) {
        return getOptionDeclarationFromName(getOptionsNameMap, optionName, allowShort);
      }
      ts3.getOptionFromName = getOptionFromName;
      function getOptionDeclarationFromName(getOptionNameMap, optionName, allowShort) {
        if (allowShort === void 0) {
          allowShort = false;
        }
        optionName = optionName.toLowerCase();
        var _a2 = getOptionNameMap(), optionsNameMap = _a2.optionsNameMap, shortOptionNames = _a2.shortOptionNames;
        if (allowShort) {
          var short = shortOptionNames.get(optionName);
          if (short !== void 0) {
            optionName = short;
          }
        }
        return optionsNameMap.get(optionName);
      }
      var buildOptionsNameMapCache;
      function getBuildOptionsNameMap() {
        return buildOptionsNameMapCache || (buildOptionsNameMapCache = createOptionNameMap(ts3.buildOpts));
      }
      var buildOptionsAlternateMode = {
        diagnostic: ts3.Diagnostics.Compiler_option_0_may_not_be_used_with_build,
        getOptionsNameMap
      };
      var buildOptionsDidYouMeanDiagnostics = {
        alternateMode: buildOptionsAlternateMode,
        getOptionsNameMap: getBuildOptionsNameMap,
        optionDeclarations: ts3.buildOpts,
        unknownOptionDiagnostic: ts3.Diagnostics.Unknown_build_option_0,
        unknownDidYouMeanDiagnostic: ts3.Diagnostics.Unknown_build_option_0_Did_you_mean_1,
        optionTypeMismatchDiagnostic: ts3.Diagnostics.Build_option_0_requires_a_value_of_type_1
      };
      function parseBuildCommand(args) {
        var _a2 = parseCommandLineWorker(buildOptionsDidYouMeanDiagnostics, args), options = _a2.options, watchOptions = _a2.watchOptions, projects = _a2.fileNames, errors = _a2.errors;
        var buildOptions = options;
        if (projects.length === 0) {
          projects.push(".");
        }
        if (buildOptions.clean && buildOptions.force) {
          errors.push(ts3.createCompilerDiagnostic(ts3.Diagnostics.Options_0_and_1_cannot_be_combined, "clean", "force"));
        }
        if (buildOptions.clean && buildOptions.verbose) {
          errors.push(ts3.createCompilerDiagnostic(ts3.Diagnostics.Options_0_and_1_cannot_be_combined, "clean", "verbose"));
        }
        if (buildOptions.clean && buildOptions.watch) {
          errors.push(ts3.createCompilerDiagnostic(ts3.Diagnostics.Options_0_and_1_cannot_be_combined, "clean", "watch"));
        }
        if (buildOptions.watch && buildOptions.dry) {
          errors.push(ts3.createCompilerDiagnostic(ts3.Diagnostics.Options_0_and_1_cannot_be_combined, "watch", "dry"));
        }
        return { buildOptions, watchOptions, projects, errors };
      }
      ts3.parseBuildCommand = parseBuildCommand;
      function getDiagnosticText(_message) {
        var _args = [];
        for (var _i = 1; _i < arguments.length; _i++) {
          _args[_i - 1] = arguments[_i];
        }
        var diagnostic = ts3.createCompilerDiagnostic.apply(void 0, arguments);
        return diagnostic.messageText;
      }
      ts3.getDiagnosticText = getDiagnosticText;
      function getParsedCommandLineOfConfigFile(configFileName, optionsToExtend, host, extendedConfigCache, watchOptionsToExtend, extraFileExtensions) {
        var configFileText = tryReadFile(configFileName, function(fileName) {
          return host.readFile(fileName);
        });
        if (!ts3.isString(configFileText)) {
          host.onUnRecoverableConfigFileDiagnostic(configFileText);
          return void 0;
        }
        var result2 = ts3.parseJsonText(configFileName, configFileText);
        var cwd = host.getCurrentDirectory();
        result2.path = ts3.toPath(configFileName, cwd, ts3.createGetCanonicalFileName(host.useCaseSensitiveFileNames));
        result2.resolvedPath = result2.path;
        result2.originalFileName = result2.fileName;
        return parseJsonSourceFileConfigFileContent(result2, host, ts3.getNormalizedAbsolutePath(ts3.getDirectoryPath(configFileName), cwd), optionsToExtend, ts3.getNormalizedAbsolutePath(configFileName, cwd), void 0, extraFileExtensions, extendedConfigCache, watchOptionsToExtend);
      }
      ts3.getParsedCommandLineOfConfigFile = getParsedCommandLineOfConfigFile;
      function readConfigFile(fileName, readFile) {
        var textOrDiagnostic = tryReadFile(fileName, readFile);
        return ts3.isString(textOrDiagnostic) ? parseConfigFileTextToJson(fileName, textOrDiagnostic) : { config: {}, error: textOrDiagnostic };
      }
      ts3.readConfigFile = readConfigFile;
      function parseConfigFileTextToJson(fileName, jsonText) {
        var jsonSourceFile = ts3.parseJsonText(fileName, jsonText);
        return {
          config: convertConfigFileToObject(jsonSourceFile, jsonSourceFile.parseDiagnostics, false, void 0),
          error: jsonSourceFile.parseDiagnostics.length ? jsonSourceFile.parseDiagnostics[0] : void 0
        };
      }
      ts3.parseConfigFileTextToJson = parseConfigFileTextToJson;
      function readJsonConfigFile(fileName, readFile) {
        var textOrDiagnostic = tryReadFile(fileName, readFile);
        return ts3.isString(textOrDiagnostic) ? ts3.parseJsonText(fileName, textOrDiagnostic) : { fileName, parseDiagnostics: [textOrDiagnostic] };
      }
      ts3.readJsonConfigFile = readJsonConfigFile;
      function tryReadFile(fileName, readFile) {
        var text;
        try {
          text = readFile(fileName);
        } catch (e2) {
          return ts3.createCompilerDiagnostic(ts3.Diagnostics.Cannot_read_file_0_Colon_1, fileName, e2.message);
        }
        return text === void 0 ? ts3.createCompilerDiagnostic(ts3.Diagnostics.Cannot_read_file_0, fileName) : text;
      }
      ts3.tryReadFile = tryReadFile;
      function commandLineOptionsToMap(options) {
        return ts3.arrayToMap(options, getOptionName);
      }
      var typeAcquisitionDidYouMeanDiagnostics = {
        optionDeclarations: ts3.typeAcquisitionDeclarations,
        unknownOptionDiagnostic: ts3.Diagnostics.Unknown_type_acquisition_option_0,
        unknownDidYouMeanDiagnostic: ts3.Diagnostics.Unknown_type_acquisition_option_0_Did_you_mean_1
      };
      var watchOptionsNameMapCache;
      function getWatchOptionsNameMap() {
        return watchOptionsNameMapCache || (watchOptionsNameMapCache = createOptionNameMap(ts3.optionsForWatch));
      }
      var watchOptionsDidYouMeanDiagnostics = {
        getOptionsNameMap: getWatchOptionsNameMap,
        optionDeclarations: ts3.optionsForWatch,
        unknownOptionDiagnostic: ts3.Diagnostics.Unknown_watch_option_0,
        unknownDidYouMeanDiagnostic: ts3.Diagnostics.Unknown_watch_option_0_Did_you_mean_1,
        optionTypeMismatchDiagnostic: ts3.Diagnostics.Watch_option_0_requires_a_value_of_type_1
      };
      var commandLineCompilerOptionsMapCache;
      function getCommandLineCompilerOptionsMap() {
        return commandLineCompilerOptionsMapCache || (commandLineCompilerOptionsMapCache = commandLineOptionsToMap(ts3.optionDeclarations));
      }
      var commandLineWatchOptionsMapCache;
      function getCommandLineWatchOptionsMap() {
        return commandLineWatchOptionsMapCache || (commandLineWatchOptionsMapCache = commandLineOptionsToMap(ts3.optionsForWatch));
      }
      var commandLineTypeAcquisitionMapCache;
      function getCommandLineTypeAcquisitionMap() {
        return commandLineTypeAcquisitionMapCache || (commandLineTypeAcquisitionMapCache = commandLineOptionsToMap(ts3.typeAcquisitionDeclarations));
      }
      var _tsconfigRootOptions;
      function getTsconfigRootOptionsMap() {
        if (_tsconfigRootOptions === void 0) {
          _tsconfigRootOptions = {
            name: void 0,
            type: "object",
            elementOptions: commandLineOptionsToMap([
              {
                name: "compilerOptions",
                type: "object",
                elementOptions: getCommandLineCompilerOptionsMap(),
                extraKeyDiagnostics: ts3.compilerOptionsDidYouMeanDiagnostics
              },
              {
                name: "watchOptions",
                type: "object",
                elementOptions: getCommandLineWatchOptionsMap(),
                extraKeyDiagnostics: watchOptionsDidYouMeanDiagnostics
              },
              {
                name: "typingOptions",
                type: "object",
                elementOptions: getCommandLineTypeAcquisitionMap(),
                extraKeyDiagnostics: typeAcquisitionDidYouMeanDiagnostics
              },
              {
                name: "typeAcquisition",
                type: "object",
                elementOptions: getCommandLineTypeAcquisitionMap(),
                extraKeyDiagnostics: typeAcquisitionDidYouMeanDiagnostics
              },
              {
                name: "extends",
                type: "string"
              },
              {
                name: "references",
                type: "list",
                element: {
                  name: "references",
                  type: "object"
                }
              },
              {
                name: "files",
                type: "list",
                element: {
                  name: "files",
                  type: "string"
                }
              },
              {
                name: "include",
                type: "list",
                element: {
                  name: "include",
                  type: "string"
                }
              },
              {
                name: "exclude",
                type: "list",
                element: {
                  name: "exclude",
                  type: "string"
                }
              },
              ts3.compileOnSaveCommandLineOption
            ])
          };
        }
        return _tsconfigRootOptions;
      }
      function convertConfigFileToObject(sourceFile, errors, reportOptionsErrors, optionsIterator) {
        var _a2;
        var rootExpression = (_a2 = sourceFile.statements[0]) === null || _a2 === void 0 ? void 0 : _a2.expression;
        var knownRootOptions = reportOptionsErrors ? getTsconfigRootOptionsMap() : void 0;
        if (rootExpression && rootExpression.kind !== 201) {
          errors.push(ts3.createDiagnosticForNodeInSourceFile(sourceFile, rootExpression, ts3.Diagnostics.The_root_value_of_a_0_file_must_be_an_object, ts3.getBaseFileName(sourceFile.fileName) === "jsconfig.json" ? "jsconfig.json" : "tsconfig.json"));
          if (ts3.isArrayLiteralExpression(rootExpression)) {
            var firstObject = ts3.find(rootExpression.elements, ts3.isObjectLiteralExpression);
            if (firstObject) {
              return convertToObjectWorker(sourceFile, firstObject, errors, true, knownRootOptions, optionsIterator);
            }
          }
          return {};
        }
        return convertToObjectWorker(sourceFile, rootExpression, errors, true, knownRootOptions, optionsIterator);
      }
      function convertToObject(sourceFile, errors) {
        var _a2;
        return convertToObjectWorker(sourceFile, (_a2 = sourceFile.statements[0]) === null || _a2 === void 0 ? void 0 : _a2.expression, errors, true, void 0, void 0);
      }
      ts3.convertToObject = convertToObject;
      function convertToObjectWorker(sourceFile, rootExpression, errors, returnValue, knownRootOptions, jsonConversionNotifier) {
        if (!rootExpression) {
          return returnValue ? {} : void 0;
        }
        return convertPropertyValueToJson(rootExpression, knownRootOptions);
        function isRootOptionMap(knownOptions) {
          return knownRootOptions && knownRootOptions.elementOptions === knownOptions;
        }
        function convertObjectLiteralExpressionToJson(node, knownOptions, extraKeyDiagnostics, parentOption) {
          var result2 = returnValue ? {} : void 0;
          var _loop_4 = function(element2) {
            if (element2.kind !== 289) {
              errors.push(ts3.createDiagnosticForNodeInSourceFile(sourceFile, element2, ts3.Diagnostics.Property_assignment_expected));
              return "continue";
            }
            if (element2.questionToken) {
              errors.push(ts3.createDiagnosticForNodeInSourceFile(sourceFile, element2.questionToken, ts3.Diagnostics.The_0_modifier_can_only_be_used_in_TypeScript_files, "?"));
            }
            if (!isDoubleQuotedString(element2.name)) {
              errors.push(ts3.createDiagnosticForNodeInSourceFile(sourceFile, element2.name, ts3.Diagnostics.String_literal_with_double_quotes_expected));
            }
            var textOfKey = ts3.isComputedNonLiteralName(element2.name) ? void 0 : ts3.getTextOfPropertyName(element2.name);
            var keyText = textOfKey && ts3.unescapeLeadingUnderscores(textOfKey);
            var option = keyText && knownOptions ? knownOptions.get(keyText) : void 0;
            if (keyText && extraKeyDiagnostics && !option) {
              if (knownOptions) {
                errors.push(createUnknownOptionError(keyText, extraKeyDiagnostics, function(message, arg0, arg1) {
                  return ts3.createDiagnosticForNodeInSourceFile(sourceFile, element2.name, message, arg0, arg1);
                }));
              } else {
                errors.push(ts3.createDiagnosticForNodeInSourceFile(sourceFile, element2.name, extraKeyDiagnostics.unknownOptionDiagnostic, keyText));
              }
            }
            var value = convertPropertyValueToJson(element2.initializer, option);
            if (typeof keyText !== "undefined") {
              if (returnValue) {
                result2[keyText] = value;
              }
              if (jsonConversionNotifier && (parentOption || isRootOptionMap(knownOptions))) {
                var isValidOptionValue = isCompilerOptionsValue(option, value);
                if (parentOption) {
                  if (isValidOptionValue) {
                    jsonConversionNotifier.onSetValidOptionKeyValueInParent(parentOption, option, value);
                  }
                } else if (isRootOptionMap(knownOptions)) {
                  if (isValidOptionValue) {
                    jsonConversionNotifier.onSetValidOptionKeyValueInRoot(keyText, element2.name, value, element2.initializer);
                  } else if (!option) {
                    jsonConversionNotifier.onSetUnknownOptionKeyValueInRoot(keyText, element2.name, value, element2.initializer);
                  }
                }
              }
            }
          };
          for (var _i = 0, _a2 = node.properties; _i < _a2.length; _i++) {
            var element = _a2[_i];
            _loop_4(element);
          }
          return result2;
        }
        function convertArrayLiteralExpressionToJson(elements, elementOption) {
          if (!returnValue) {
            elements.forEach(function(element) {
              return convertPropertyValueToJson(element, elementOption);
            });
            return void 0;
          }
          return ts3.filter(elements.map(function(element) {
            return convertPropertyValueToJson(element, elementOption);
          }), function(v) {
            return v !== void 0;
          });
        }
        function convertPropertyValueToJson(valueExpression, option) {
          var invalidReported;
          switch (valueExpression.kind) {
            case 109:
              reportInvalidOptionValue(option && option.type !== "boolean");
              return validateValue(true);
            case 94:
              reportInvalidOptionValue(option && option.type !== "boolean");
              return validateValue(false);
            case 103:
              reportInvalidOptionValue(option && option.name === "extends");
              return validateValue(null);
            case 10:
              if (!isDoubleQuotedString(valueExpression)) {
                errors.push(ts3.createDiagnosticForNodeInSourceFile(sourceFile, valueExpression, ts3.Diagnostics.String_literal_with_double_quotes_expected));
              }
              reportInvalidOptionValue(option && (ts3.isString(option.type) && option.type !== "string"));
              var text = valueExpression.text;
              if (option && !ts3.isString(option.type)) {
                var customOption = option;
                if (!customOption.type.has(text.toLowerCase())) {
                  errors.push(createDiagnosticForInvalidCustomType(customOption, function(message, arg0, arg1) {
                    return ts3.createDiagnosticForNodeInSourceFile(sourceFile, valueExpression, message, arg0, arg1);
                  }));
                  invalidReported = true;
                }
              }
              return validateValue(text);
            case 8:
              reportInvalidOptionValue(option && option.type !== "number");
              return validateValue(Number(valueExpression.text));
            case 215:
              if (valueExpression.operator !== 40 || valueExpression.operand.kind !== 8) {
                break;
              }
              reportInvalidOptionValue(option && option.type !== "number");
              return validateValue(-Number(valueExpression.operand.text));
            case 201:
              reportInvalidOptionValue(option && option.type !== "object");
              var objectLiteralExpression = valueExpression;
              if (option) {
                var _a2 = option, elementOptions = _a2.elementOptions, extraKeyDiagnostics = _a2.extraKeyDiagnostics, optionName = _a2.name;
                return validateValue(convertObjectLiteralExpressionToJson(objectLiteralExpression, elementOptions, extraKeyDiagnostics, optionName));
              } else {
                return validateValue(convertObjectLiteralExpressionToJson(objectLiteralExpression, void 0, void 0, void 0));
              }
            case 200:
              reportInvalidOptionValue(option && option.type !== "list");
              return validateValue(convertArrayLiteralExpressionToJson(valueExpression.elements, option && option.element));
          }
          if (option) {
            reportInvalidOptionValue(true);
          } else {
            errors.push(ts3.createDiagnosticForNodeInSourceFile(sourceFile, valueExpression, ts3.Diagnostics.Property_value_can_only_be_string_literal_numeric_literal_true_false_null_object_literal_or_array_literal));
          }
          return void 0;
          function validateValue(value) {
            var _a3;
            if (!invalidReported) {
              var diagnostic = (_a3 = option === null || option === void 0 ? void 0 : option.extraValidation) === null || _a3 === void 0 ? void 0 : _a3.call(option, value);
              if (diagnostic) {
                errors.push(ts3.createDiagnosticForNodeInSourceFile.apply(void 0, __spreadArray([sourceFile, valueExpression], diagnostic)));
                return void 0;
              }
            }
            return value;
          }
          function reportInvalidOptionValue(isError) {
            if (isError) {
              errors.push(ts3.createDiagnosticForNodeInSourceFile(sourceFile, valueExpression, ts3.Diagnostics.Compiler_option_0_requires_a_value_of_type_1, option.name, getCompilerOptionValueTypeString(option)));
              invalidReported = true;
            }
          }
        }
        function isDoubleQuotedString(node) {
          return ts3.isStringLiteral(node) && ts3.isStringDoubleQuoted(node, sourceFile);
        }
      }
      ts3.convertToObjectWorker = convertToObjectWorker;
      function getCompilerOptionValueTypeString(option) {
        return option.type === "list" ? "Array" : ts3.isString(option.type) ? option.type : "string";
      }
      function isCompilerOptionsValue(option, value) {
        if (option) {
          if (isNullOrUndefined(value))
            return true;
          if (option.type === "list") {
            return ts3.isArray(value);
          }
          var expectedType = ts3.isString(option.type) ? option.type : "string";
          return typeof value === expectedType;
        }
        return false;
      }
      function convertToTSConfig(configParseResult, configFileName, host) {
        var _a2, _b, _c;
        var getCanonicalFileName = ts3.createGetCanonicalFileName(host.useCaseSensitiveFileNames);
        var files = ts3.map(ts3.filter(configParseResult.fileNames, !((_b = (_a2 = configParseResult.options.configFile) === null || _a2 === void 0 ? void 0 : _a2.configFileSpecs) === null || _b === void 0 ? void 0 : _b.validatedIncludeSpecs) ? ts3.returnTrue : matchesSpecs(configFileName, configParseResult.options.configFile.configFileSpecs.validatedIncludeSpecs, configParseResult.options.configFile.configFileSpecs.validatedExcludeSpecs, host)), function(f) {
          return ts3.getRelativePathFromFile(ts3.getNormalizedAbsolutePath(configFileName, host.getCurrentDirectory()), ts3.getNormalizedAbsolutePath(f, host.getCurrentDirectory()), getCanonicalFileName);
        });
        var optionMap = serializeCompilerOptions(configParseResult.options, { configFilePath: ts3.getNormalizedAbsolutePath(configFileName, host.getCurrentDirectory()), useCaseSensitiveFileNames: host.useCaseSensitiveFileNames });
        var watchOptionMap = configParseResult.watchOptions && serializeWatchOptions(configParseResult.watchOptions);
        var config = __assign(__assign({ compilerOptions: __assign(__assign({}, optionMapToObject(optionMap)), { showConfig: void 0, configFile: void 0, configFilePath: void 0, help: void 0, init: void 0, listFiles: void 0, listEmittedFiles: void 0, project: void 0, build: void 0, version: void 0 }), watchOptions: watchOptionMap && optionMapToObject(watchOptionMap), references: ts3.map(configParseResult.projectReferences, function(r2) {
          return __assign(__assign({}, r2), { path: r2.originalPath ? r2.originalPath : "", originalPath: void 0 });
        }), files: ts3.length(files) ? files : void 0 }, ((_c = configParseResult.options.configFile) === null || _c === void 0 ? void 0 : _c.configFileSpecs) ? {
          include: filterSameAsDefaultInclude(configParseResult.options.configFile.configFileSpecs.validatedIncludeSpecs),
          exclude: configParseResult.options.configFile.configFileSpecs.validatedExcludeSpecs
        } : {}), { compileOnSave: !!configParseResult.compileOnSave ? true : void 0 });
        return config;
      }
      ts3.convertToTSConfig = convertToTSConfig;
      function optionMapToObject(optionMap) {
        return __assign({}, ts3.arrayFrom(optionMap.entries()).reduce(function(prev, cur) {
          var _a2;
          return __assign(__assign({}, prev), (_a2 = {}, _a2[cur[0]] = cur[1], _a2));
        }, {}));
      }
      function filterSameAsDefaultInclude(specs) {
        if (!ts3.length(specs))
          return void 0;
        if (ts3.length(specs) !== 1)
          return specs;
        if (specs[0] === "**/*")
          return void 0;
        return specs;
      }
      function matchesSpecs(path2, includeSpecs, excludeSpecs, host) {
        if (!includeSpecs)
          return ts3.returnTrue;
        var patterns = ts3.getFileMatcherPatterns(path2, excludeSpecs, includeSpecs, host.useCaseSensitiveFileNames, host.getCurrentDirectory());
        var excludeRe = patterns.excludePattern && ts3.getRegexFromPattern(patterns.excludePattern, host.useCaseSensitiveFileNames);
        var includeRe = patterns.includeFilePattern && ts3.getRegexFromPattern(patterns.includeFilePattern, host.useCaseSensitiveFileNames);
        if (includeRe) {
          if (excludeRe) {
            return function(path3) {
              return !(includeRe.test(path3) && !excludeRe.test(path3));
            };
          }
          return function(path3) {
            return !includeRe.test(path3);
          };
        }
        if (excludeRe) {
          return function(path3) {
            return excludeRe.test(path3);
          };
        }
        return ts3.returnTrue;
      }
      function getCustomTypeMapOfCommandLineOption(optionDefinition) {
        if (optionDefinition.type === "string" || optionDefinition.type === "number" || optionDefinition.type === "boolean" || optionDefinition.type === "object") {
          return void 0;
        } else if (optionDefinition.type === "list") {
          return getCustomTypeMapOfCommandLineOption(optionDefinition.element);
        } else {
          return optionDefinition.type;
        }
      }
      function getNameOfCompilerOptionValue(value, customTypeMap) {
        return ts3.forEachEntry(customTypeMap, function(mapValue, key2) {
          if (mapValue === value) {
            return key2;
          }
        });
      }
      function serializeCompilerOptions(options, pathOptions) {
        return serializeOptionBaseObject(options, getOptionsNameMap(), pathOptions);
      }
      function serializeWatchOptions(options) {
        return serializeOptionBaseObject(options, getWatchOptionsNameMap());
      }
      function serializeOptionBaseObject(options, _a2, pathOptions) {
        var optionsNameMap = _a2.optionsNameMap;
        var result2 = new ts3.Map();
        var getCanonicalFileName = pathOptions && ts3.createGetCanonicalFileName(pathOptions.useCaseSensitiveFileNames);
        var _loop_5 = function(name2) {
          if (ts3.hasProperty(options, name2)) {
            if (optionsNameMap.has(name2) && optionsNameMap.get(name2).category === ts3.Diagnostics.Command_line_Options) {
              return "continue";
            }
            var value = options[name2];
            var optionDefinition = optionsNameMap.get(name2.toLowerCase());
            if (optionDefinition) {
              var customTypeMap_1 = getCustomTypeMapOfCommandLineOption(optionDefinition);
              if (!customTypeMap_1) {
                if (pathOptions && optionDefinition.isFilePath) {
                  result2.set(name2, ts3.getRelativePathFromFile(pathOptions.configFilePath, ts3.getNormalizedAbsolutePath(value, ts3.getDirectoryPath(pathOptions.configFilePath)), getCanonicalFileName));
                } else {
                  result2.set(name2, value);
                }
              } else {
                if (optionDefinition.type === "list") {
                  result2.set(name2, value.map(function(element) {
                    return getNameOfCompilerOptionValue(element, customTypeMap_1);
                  }));
                } else {
                  result2.set(name2, getNameOfCompilerOptionValue(value, customTypeMap_1));
                }
              }
            }
          }
        };
        for (var name in options) {
          _loop_5(name);
        }
        return result2;
      }
      function generateTSConfig(options, fileNames, newLine) {
        var compilerOptions = ts3.extend(options, ts3.defaultInitCompilerOptions);
        var compilerOptionsMap = serializeCompilerOptions(compilerOptions);
        return writeConfigurations();
        function getDefaultValueForOption(option) {
          switch (option.type) {
            case "number":
              return 1;
            case "boolean":
              return true;
            case "string":
              return option.isFilePath ? "./" : "";
            case "list":
              return [];
            case "object":
              return {};
            default:
              var iterResult = option.type.keys().next();
              if (!iterResult.done)
                return iterResult.value;
              return ts3.Debug.fail("Expected 'option.type' to have entries.");
          }
        }
        function makePadding(paddingLength) {
          return Array(paddingLength + 1).join(" ");
        }
        function isAllowedOption(_a2) {
          var category = _a2.category, name = _a2.name;
          return category !== void 0 && category !== ts3.Diagnostics.Command_line_Options && (category !== ts3.Diagnostics.Advanced_Options || compilerOptionsMap.has(name));
        }
        function writeConfigurations() {
          var categorizedOptions = ts3.createMultiMap();
          for (var _i = 0, optionDeclarations_1 = ts3.optionDeclarations; _i < optionDeclarations_1.length; _i++) {
            var option = optionDeclarations_1[_i];
            var category = option.category;
            if (isAllowedOption(option)) {
              categorizedOptions.add(ts3.getLocaleSpecificMessage(category), option);
            }
          }
          var marginLength = 0;
          var seenKnownKeys = 0;
          var entries = [];
          categorizedOptions.forEach(function(options2, category2) {
            if (entries.length !== 0) {
              entries.push({ value: "" });
            }
            entries.push({ value: "/* " + category2 + " */" });
            for (var _i2 = 0, options_1 = options2; _i2 < options_1.length; _i2++) {
              var option2 = options_1[_i2];
              var optionName = void 0;
              if (compilerOptionsMap.has(option2.name)) {
                optionName = '"' + option2.name + '": ' + JSON.stringify(compilerOptionsMap.get(option2.name)) + ((seenKnownKeys += 1) === compilerOptionsMap.size ? "" : ",");
              } else {
                optionName = '// "' + option2.name + '": ' + JSON.stringify(getDefaultValueForOption(option2)) + ",";
              }
              entries.push({
                value: optionName,
                description: "/* " + (option2.description && ts3.getLocaleSpecificMessage(option2.description) || option2.name) + " */"
              });
              marginLength = Math.max(optionName.length, marginLength);
            }
          });
          var tab = makePadding(2);
          var result2 = [];
          result2.push("{");
          result2.push(tab + '"compilerOptions": {');
          result2.push("" + tab + tab + "/* " + ts3.getLocaleSpecificMessage(ts3.Diagnostics.Visit_https_Colon_Slash_Slashaka_ms_Slashtsconfig_json_to_read_more_about_this_file) + " */");
          result2.push("");
          for (var _a2 = 0, entries_2 = entries; _a2 < entries_2.length; _a2++) {
            var entry = entries_2[_a2];
            var value = entry.value, _b = entry.description, description = _b === void 0 ? "" : _b;
            result2.push(value && "" + tab + tab + value + (description && makePadding(marginLength - value.length + 2) + description));
          }
          if (fileNames.length) {
            result2.push(tab + "},");
            result2.push(tab + '"files": [');
            for (var i3 = 0; i3 < fileNames.length; i3++) {
              result2.push("" + tab + tab + JSON.stringify(fileNames[i3]) + (i3 === fileNames.length - 1 ? "" : ","));
            }
            result2.push(tab + "]");
          } else {
            result2.push(tab + "}");
          }
          result2.push("}");
          return result2.join(newLine) + newLine;
        }
      }
      ts3.generateTSConfig = generateTSConfig;
      function convertToOptionsWithAbsolutePaths(options, toAbsolutePath) {
        var result2 = {};
        var optionsNameMap = getOptionsNameMap().optionsNameMap;
        for (var name in options) {
          if (ts3.hasProperty(options, name)) {
            result2[name] = convertToOptionValueWithAbsolutePaths(optionsNameMap.get(name.toLowerCase()), options[name], toAbsolutePath);
          }
        }
        if (result2.configFilePath) {
          result2.configFilePath = toAbsolutePath(result2.configFilePath);
        }
        return result2;
      }
      ts3.convertToOptionsWithAbsolutePaths = convertToOptionsWithAbsolutePaths;
      function convertToOptionValueWithAbsolutePaths(option, value, toAbsolutePath) {
        if (option && !isNullOrUndefined(value)) {
          if (option.type === "list") {
            var values = value;
            if (option.element.isFilePath && values.length) {
              return values.map(toAbsolutePath);
            }
          } else if (option.isFilePath) {
            return toAbsolutePath(value);
          }
        }
        return value;
      }
      function parseJsonConfigFileContent(json2, host, basePath, existingOptions, configFileName, resolutionStack, extraFileExtensions, extendedConfigCache, existingWatchOptions) {
        return parseJsonConfigFileContentWorker(json2, void 0, host, basePath, existingOptions, existingWatchOptions, configFileName, resolutionStack, extraFileExtensions, extendedConfigCache);
      }
      ts3.parseJsonConfigFileContent = parseJsonConfigFileContent;
      function parseJsonSourceFileConfigFileContent(sourceFile, host, basePath, existingOptions, configFileName, resolutionStack, extraFileExtensions, extendedConfigCache, existingWatchOptions) {
        return parseJsonConfigFileContentWorker(void 0, sourceFile, host, basePath, existingOptions, existingWatchOptions, configFileName, resolutionStack, extraFileExtensions, extendedConfigCache);
      }
      ts3.parseJsonSourceFileConfigFileContent = parseJsonSourceFileConfigFileContent;
      function setConfigFileInOptions(options, configFile) {
        if (configFile) {
          Object.defineProperty(options, "configFile", { enumerable: false, writable: false, value: configFile });
        }
      }
      ts3.setConfigFileInOptions = setConfigFileInOptions;
      function isNullOrUndefined(x) {
        return x === void 0 || x === null;
      }
      function directoryOfCombinedPath(fileName, basePath) {
        return ts3.getDirectoryPath(ts3.getNormalizedAbsolutePath(fileName, basePath));
      }
      function parseJsonConfigFileContentWorker(json2, sourceFile, host, basePath, existingOptions, existingWatchOptions, configFileName, resolutionStack, extraFileExtensions, extendedConfigCache) {
        if (existingOptions === void 0) {
          existingOptions = {};
        }
        if (resolutionStack === void 0) {
          resolutionStack = [];
        }
        if (extraFileExtensions === void 0) {
          extraFileExtensions = [];
        }
        ts3.Debug.assert(json2 === void 0 && sourceFile !== void 0 || json2 !== void 0 && sourceFile === void 0);
        var errors = [];
        var parsedConfig = parseConfig(json2, sourceFile, host, basePath, configFileName, resolutionStack, errors, extendedConfigCache);
        var raw = parsedConfig.raw;
        var options = ts3.extend(existingOptions, parsedConfig.options || {});
        var watchOptions = existingWatchOptions && parsedConfig.watchOptions ? ts3.extend(existingWatchOptions, parsedConfig.watchOptions) : parsedConfig.watchOptions || existingWatchOptions;
        options.configFilePath = configFileName && ts3.normalizeSlashes(configFileName);
        var configFileSpecs = getConfigFileSpecs();
        if (sourceFile)
          sourceFile.configFileSpecs = configFileSpecs;
        setConfigFileInOptions(options, sourceFile);
        var basePathForFileNames = ts3.normalizePath(configFileName ? directoryOfCombinedPath(configFileName, basePath) : basePath);
        return {
          options,
          watchOptions,
          fileNames: getFileNames(basePathForFileNames),
          projectReferences: getProjectReferences(basePathForFileNames),
          typeAcquisition: parsedConfig.typeAcquisition || getDefaultTypeAcquisition(),
          raw,
          errors,
          wildcardDirectories: getWildcardDirectories(configFileSpecs, basePathForFileNames, host.useCaseSensitiveFileNames),
          compileOnSave: !!raw.compileOnSave
        };
        function getConfigFileSpecs() {
          var referencesOfRaw = getPropFromRaw("references", function(element) {
            return typeof element === "object";
          }, "object");
          var filesSpecs = toPropValue(getSpecsFromRaw("files"));
          if (filesSpecs) {
            var hasZeroOrNoReferences = referencesOfRaw === "no-prop" || ts3.isArray(referencesOfRaw) && referencesOfRaw.length === 0;
            var hasExtends = ts3.hasProperty(raw, "extends");
            if (filesSpecs.length === 0 && hasZeroOrNoReferences && !hasExtends) {
              if (sourceFile) {
                var fileName = configFileName || "tsconfig.json";
                var diagnosticMessage = ts3.Diagnostics.The_files_list_in_config_file_0_is_empty;
                var nodeValue = ts3.firstDefined(ts3.getTsConfigPropArray(sourceFile, "files"), function(property) {
                  return property.initializer;
                });
                var error = nodeValue ? ts3.createDiagnosticForNodeInSourceFile(sourceFile, nodeValue, diagnosticMessage, fileName) : ts3.createCompilerDiagnostic(diagnosticMessage, fileName);
                errors.push(error);
              } else {
                createCompilerDiagnosticOnlyIfJson(ts3.Diagnostics.The_files_list_in_config_file_0_is_empty, configFileName || "tsconfig.json");
              }
            }
          }
          var includeSpecs = toPropValue(getSpecsFromRaw("include"));
          var excludeOfRaw = getSpecsFromRaw("exclude");
          var excludeSpecs = toPropValue(excludeOfRaw);
          if (excludeOfRaw === "no-prop" && raw.compilerOptions) {
            var outDir = raw.compilerOptions.outDir;
            var declarationDir = raw.compilerOptions.declarationDir;
            if (outDir || declarationDir) {
              excludeSpecs = [outDir, declarationDir].filter(function(d) {
                return !!d;
              });
            }
          }
          if (filesSpecs === void 0 && includeSpecs === void 0) {
            includeSpecs = ["**/*"];
          }
          var validatedIncludeSpecs, validatedExcludeSpecs;
          if (includeSpecs) {
            validatedIncludeSpecs = validateSpecs(includeSpecs, errors, true, sourceFile, "include");
          }
          if (excludeSpecs) {
            validatedExcludeSpecs = validateSpecs(excludeSpecs, errors, false, sourceFile, "exclude");
          }
          return {
            filesSpecs,
            includeSpecs,
            excludeSpecs,
            validatedFilesSpec: ts3.filter(filesSpecs, ts3.isString),
            validatedIncludeSpecs,
            validatedExcludeSpecs
          };
        }
        function getFileNames(basePath2) {
          var fileNames = getFileNamesFromConfigSpecs(configFileSpecs, basePath2, options, host, extraFileExtensions);
          if (shouldReportNoInputFiles(fileNames, canJsonReportNoInputFiles(raw), resolutionStack)) {
            errors.push(getErrorForNoInputFiles(configFileSpecs, configFileName));
          }
          return fileNames;
        }
        function getProjectReferences(basePath2) {
          var projectReferences;
          var referencesOfRaw = getPropFromRaw("references", function(element) {
            return typeof element === "object";
          }, "object");
          if (ts3.isArray(referencesOfRaw)) {
            for (var _i = 0, referencesOfRaw_1 = referencesOfRaw; _i < referencesOfRaw_1.length; _i++) {
              var ref2 = referencesOfRaw_1[_i];
              if (typeof ref2.path !== "string") {
                createCompilerDiagnosticOnlyIfJson(ts3.Diagnostics.Compiler_option_0_requires_a_value_of_type_1, "reference.path", "string");
              } else {
                (projectReferences || (projectReferences = [])).push({
                  path: ts3.getNormalizedAbsolutePath(ref2.path, basePath2),
                  originalPath: ref2.path,
                  prepend: ref2.prepend,
                  circular: ref2.circular
                });
              }
            }
          }
          return projectReferences;
        }
        function toPropValue(specResult) {
          return ts3.isArray(specResult) ? specResult : void 0;
        }
        function getSpecsFromRaw(prop) {
          return getPropFromRaw(prop, ts3.isString, "string");
        }
        function getPropFromRaw(prop, validateElement, elementTypeName) {
          if (ts3.hasProperty(raw, prop) && !isNullOrUndefined(raw[prop])) {
            if (ts3.isArray(raw[prop])) {
              var result2 = raw[prop];
              if (!sourceFile && !ts3.every(result2, validateElement)) {
                errors.push(ts3.createCompilerDiagnostic(ts3.Diagnostics.Compiler_option_0_requires_a_value_of_type_1, prop, elementTypeName));
              }
              return result2;
            } else {
              createCompilerDiagnosticOnlyIfJson(ts3.Diagnostics.Compiler_option_0_requires_a_value_of_type_1, prop, "Array");
              return "not-array";
            }
          }
          return "no-prop";
        }
        function createCompilerDiagnosticOnlyIfJson(message, arg0, arg1) {
          if (!sourceFile) {
            errors.push(ts3.createCompilerDiagnostic(message, arg0, arg1));
          }
        }
      }
      function isErrorNoInputFiles(error) {
        return error.code === ts3.Diagnostics.No_inputs_were_found_in_config_file_0_Specified_include_paths_were_1_and_exclude_paths_were_2.code;
      }
      function getErrorForNoInputFiles(_a2, configFileName) {
        var includeSpecs = _a2.includeSpecs, excludeSpecs = _a2.excludeSpecs;
        return ts3.createCompilerDiagnostic(ts3.Diagnostics.No_inputs_were_found_in_config_file_0_Specified_include_paths_were_1_and_exclude_paths_were_2, configFileName || "tsconfig.json", JSON.stringify(includeSpecs || []), JSON.stringify(excludeSpecs || []));
      }
      function shouldReportNoInputFiles(fileNames, canJsonReportNoInutFiles, resolutionStack) {
        return fileNames.length === 0 && canJsonReportNoInutFiles && (!resolutionStack || resolutionStack.length === 0);
      }
      function canJsonReportNoInputFiles(raw) {
        return !ts3.hasProperty(raw, "files") && !ts3.hasProperty(raw, "references");
      }
      ts3.canJsonReportNoInputFiles = canJsonReportNoInputFiles;
      function updateErrorForNoInputFiles(fileNames, configFileName, configFileSpecs, configParseDiagnostics, canJsonReportNoInutFiles) {
        var existingErrors = configParseDiagnostics.length;
        if (shouldReportNoInputFiles(fileNames, canJsonReportNoInutFiles)) {
          configParseDiagnostics.push(getErrorForNoInputFiles(configFileSpecs, configFileName));
        } else {
          ts3.filterMutate(configParseDiagnostics, function(error) {
            return !isErrorNoInputFiles(error);
          });
        }
        return existingErrors !== configParseDiagnostics.length;
      }
      ts3.updateErrorForNoInputFiles = updateErrorForNoInputFiles;
      function isSuccessfulParsedTsconfig(value) {
        return !!value.options;
      }
      function parseConfig(json2, sourceFile, host, basePath, configFileName, resolutionStack, errors, extendedConfigCache) {
        var _a2;
        basePath = ts3.normalizeSlashes(basePath);
        var resolvedPath = ts3.getNormalizedAbsolutePath(configFileName || "", basePath);
        if (resolutionStack.indexOf(resolvedPath) >= 0) {
          errors.push(ts3.createCompilerDiagnostic(ts3.Diagnostics.Circularity_detected_while_resolving_configuration_Colon_0, __spreadArray(__spreadArray([], resolutionStack), [resolvedPath]).join(" -> ")));
          return { raw: json2 || convertToObject(sourceFile, errors) };
        }
        var ownConfig = json2 ? parseOwnConfigOfJson(json2, host, basePath, configFileName, errors) : parseOwnConfigOfJsonSourceFile(sourceFile, host, basePath, configFileName, errors);
        if ((_a2 = ownConfig.options) === null || _a2 === void 0 ? void 0 : _a2.paths) {
          ownConfig.options.pathsBasePath = basePath;
        }
        if (ownConfig.extendedConfigPath) {
          resolutionStack = resolutionStack.concat([resolvedPath]);
          var extendedConfig = getExtendedConfig(sourceFile, ownConfig.extendedConfigPath, host, resolutionStack, errors, extendedConfigCache);
          if (extendedConfig && isSuccessfulParsedTsconfig(extendedConfig)) {
            var baseRaw_1 = extendedConfig.raw;
            var raw_1 = ownConfig.raw;
            var relativeDifference_1;
            var setPropertyInRawIfNotUndefined = function(propertyName) {
              if (!raw_1[propertyName] && baseRaw_1[propertyName]) {
                raw_1[propertyName] = ts3.map(baseRaw_1[propertyName], function(path2) {
                  return ts3.isRootedDiskPath(path2) ? path2 : ts3.combinePaths(relativeDifference_1 || (relativeDifference_1 = ts3.convertToRelativePath(ts3.getDirectoryPath(ownConfig.extendedConfigPath), basePath, ts3.createGetCanonicalFileName(host.useCaseSensitiveFileNames))), path2);
                });
              }
            };
            setPropertyInRawIfNotUndefined("include");
            setPropertyInRawIfNotUndefined("exclude");
            setPropertyInRawIfNotUndefined("files");
            if (raw_1.compileOnSave === void 0) {
              raw_1.compileOnSave = baseRaw_1.compileOnSave;
            }
            ownConfig.options = ts3.assign({}, extendedConfig.options, ownConfig.options);
            ownConfig.watchOptions = ownConfig.watchOptions && extendedConfig.watchOptions ? ts3.assign({}, extendedConfig.watchOptions, ownConfig.watchOptions) : ownConfig.watchOptions || extendedConfig.watchOptions;
          }
        }
        return ownConfig;
      }
      function parseOwnConfigOfJson(json2, host, basePath, configFileName, errors) {
        if (ts3.hasProperty(json2, "excludes")) {
          errors.push(ts3.createCompilerDiagnostic(ts3.Diagnostics.Unknown_option_excludes_Did_you_mean_exclude));
        }
        var options = convertCompilerOptionsFromJsonWorker(json2.compilerOptions, basePath, errors, configFileName);
        var typeAcquisition = convertTypeAcquisitionFromJsonWorker(json2.typeAcquisition || json2.typingOptions, basePath, errors, configFileName);
        var watchOptions = convertWatchOptionsFromJsonWorker(json2.watchOptions, basePath, errors);
        json2.compileOnSave = convertCompileOnSaveOptionFromJson(json2, basePath, errors);
        var extendedConfigPath;
        if (json2.extends) {
          if (!ts3.isString(json2.extends)) {
            errors.push(ts3.createCompilerDiagnostic(ts3.Diagnostics.Compiler_option_0_requires_a_value_of_type_1, "extends", "string"));
          } else {
            var newBase = configFileName ? directoryOfCombinedPath(configFileName, basePath) : basePath;
            extendedConfigPath = getExtendsConfigPath(json2.extends, host, newBase, errors, ts3.createCompilerDiagnostic);
          }
        }
        return { raw: json2, options, watchOptions, typeAcquisition, extendedConfigPath };
      }
      function parseOwnConfigOfJsonSourceFile(sourceFile, host, basePath, configFileName, errors) {
        var options = getDefaultCompilerOptions(configFileName);
        var typeAcquisition, typingOptionstypeAcquisition;
        var watchOptions;
        var extendedConfigPath;
        var optionsIterator = {
          onSetValidOptionKeyValueInParent: function(parentOption, option, value) {
            var currentOption;
            switch (parentOption) {
              case "compilerOptions":
                currentOption = options;
                break;
              case "watchOptions":
                currentOption = watchOptions || (watchOptions = {});
                break;
              case "typeAcquisition":
                currentOption = typeAcquisition || (typeAcquisition = getDefaultTypeAcquisition(configFileName));
                break;
              case "typingOptions":
                currentOption = typingOptionstypeAcquisition || (typingOptionstypeAcquisition = getDefaultTypeAcquisition(configFileName));
                break;
              default:
                ts3.Debug.fail("Unknown option");
            }
            currentOption[option.name] = normalizeOptionValue(option, basePath, value);
          },
          onSetValidOptionKeyValueInRoot: function(key2, _keyNode, value, valueNode) {
            switch (key2) {
              case "extends":
                var newBase = configFileName ? directoryOfCombinedPath(configFileName, basePath) : basePath;
                extendedConfigPath = getExtendsConfigPath(value, host, newBase, errors, function(message, arg0) {
                  return ts3.createDiagnosticForNodeInSourceFile(sourceFile, valueNode, message, arg0);
                });
                return;
            }
          },
          onSetUnknownOptionKeyValueInRoot: function(key2, keyNode, _value, _valueNode) {
            if (key2 === "excludes") {
              errors.push(ts3.createDiagnosticForNodeInSourceFile(sourceFile, keyNode, ts3.Diagnostics.Unknown_option_excludes_Did_you_mean_exclude));
            }
          }
        };
        var json2 = convertConfigFileToObject(sourceFile, errors, true, optionsIterator);
        if (!typeAcquisition) {
          if (typingOptionstypeAcquisition) {
            typeAcquisition = typingOptionstypeAcquisition.enableAutoDiscovery !== void 0 ? {
              enable: typingOptionstypeAcquisition.enableAutoDiscovery,
              include: typingOptionstypeAcquisition.include,
              exclude: typingOptionstypeAcquisition.exclude
            } : typingOptionstypeAcquisition;
          } else {
            typeAcquisition = getDefaultTypeAcquisition(configFileName);
          }
        }
        return { raw: json2, options, watchOptions, typeAcquisition, extendedConfigPath };
      }
      function getExtendsConfigPath(extendedConfig, host, basePath, errors, createDiagnostic) {
        extendedConfig = ts3.normalizeSlashes(extendedConfig);
        if (ts3.isRootedDiskPath(extendedConfig) || ts3.startsWith(extendedConfig, "./") || ts3.startsWith(extendedConfig, "../")) {
          var extendedConfigPath = ts3.getNormalizedAbsolutePath(extendedConfig, basePath);
          if (!host.fileExists(extendedConfigPath) && !ts3.endsWith(extendedConfigPath, ".json")) {
            extendedConfigPath = extendedConfigPath + ".json";
            if (!host.fileExists(extendedConfigPath)) {
              errors.push(createDiagnostic(ts3.Diagnostics.File_0_not_found, extendedConfig));
              return void 0;
            }
          }
          return extendedConfigPath;
        }
        var resolved = ts3.nodeModuleNameResolver(extendedConfig, ts3.combinePaths(basePath, "tsconfig.json"), { moduleResolution: ts3.ModuleResolutionKind.NodeJs }, host, void 0, void 0, true);
        if (resolved.resolvedModule) {
          return resolved.resolvedModule.resolvedFileName;
        }
        errors.push(createDiagnostic(ts3.Diagnostics.File_0_not_found, extendedConfig));
        return void 0;
      }
      function getExtendedConfig(sourceFile, extendedConfigPath, host, resolutionStack, errors, extendedConfigCache) {
        var _a2;
        var path2 = host.useCaseSensitiveFileNames ? extendedConfigPath : ts3.toFileNameLowerCase(extendedConfigPath);
        var value;
        var extendedResult;
        var extendedConfig;
        if (extendedConfigCache && (value = extendedConfigCache.get(path2))) {
          extendedResult = value.extendedResult, extendedConfig = value.extendedConfig;
        } else {
          extendedResult = readJsonConfigFile(extendedConfigPath, function(path3) {
            return host.readFile(path3);
          });
          if (!extendedResult.parseDiagnostics.length) {
            extendedConfig = parseConfig(void 0, extendedResult, host, ts3.getDirectoryPath(extendedConfigPath), ts3.getBaseFileName(extendedConfigPath), resolutionStack, errors, extendedConfigCache);
          }
          if (extendedConfigCache) {
            extendedConfigCache.set(path2, { extendedResult, extendedConfig });
          }
        }
        if (sourceFile) {
          sourceFile.extendedSourceFiles = [extendedResult.fileName];
          if (extendedResult.extendedSourceFiles) {
            (_a2 = sourceFile.extendedSourceFiles).push.apply(_a2, extendedResult.extendedSourceFiles);
          }
        }
        if (extendedResult.parseDiagnostics.length) {
          errors.push.apply(errors, extendedResult.parseDiagnostics);
          return void 0;
        }
        return extendedConfig;
      }
      function convertCompileOnSaveOptionFromJson(jsonOption, basePath, errors) {
        if (!ts3.hasProperty(jsonOption, ts3.compileOnSaveCommandLineOption.name)) {
          return false;
        }
        var result2 = convertJsonOption(ts3.compileOnSaveCommandLineOption, jsonOption.compileOnSave, basePath, errors);
        return typeof result2 === "boolean" && result2;
      }
      function convertCompilerOptionsFromJson(jsonOptions, basePath, configFileName) {
        var errors = [];
        var options = convertCompilerOptionsFromJsonWorker(jsonOptions, basePath, errors, configFileName);
        return { options, errors };
      }
      ts3.convertCompilerOptionsFromJson = convertCompilerOptionsFromJson;
      function convertTypeAcquisitionFromJson(jsonOptions, basePath, configFileName) {
        var errors = [];
        var options = convertTypeAcquisitionFromJsonWorker(jsonOptions, basePath, errors, configFileName);
        return { options, errors };
      }
      ts3.convertTypeAcquisitionFromJson = convertTypeAcquisitionFromJson;
      function getDefaultCompilerOptions(configFileName) {
        var options = configFileName && ts3.getBaseFileName(configFileName) === "jsconfig.json" ? { allowJs: true, maxNodeModuleJsDepth: 2, allowSyntheticDefaultImports: true, skipLibCheck: true, noEmit: true } : {};
        return options;
      }
      function convertCompilerOptionsFromJsonWorker(jsonOptions, basePath, errors, configFileName) {
        var options = getDefaultCompilerOptions(configFileName);
        convertOptionsFromJson(getCommandLineCompilerOptionsMap(), jsonOptions, basePath, options, ts3.compilerOptionsDidYouMeanDiagnostics, errors);
        if (configFileName) {
          options.configFilePath = ts3.normalizeSlashes(configFileName);
        }
        return options;
      }
      function getDefaultTypeAcquisition(configFileName) {
        return { enable: !!configFileName && ts3.getBaseFileName(configFileName) === "jsconfig.json", include: [], exclude: [] };
      }
      function convertTypeAcquisitionFromJsonWorker(jsonOptions, basePath, errors, configFileName) {
        var options = getDefaultTypeAcquisition(configFileName);
        var typeAcquisition = convertEnableAutoDiscoveryToEnable(jsonOptions);
        convertOptionsFromJson(getCommandLineTypeAcquisitionMap(), typeAcquisition, basePath, options, typeAcquisitionDidYouMeanDiagnostics, errors);
        return options;
      }
      function convertWatchOptionsFromJsonWorker(jsonOptions, basePath, errors) {
        return convertOptionsFromJson(getCommandLineWatchOptionsMap(), jsonOptions, basePath, void 0, watchOptionsDidYouMeanDiagnostics, errors);
      }
      function convertOptionsFromJson(optionsNameMap, jsonOptions, basePath, defaultOptions, diagnostics, errors) {
        if (!jsonOptions) {
          return;
        }
        for (var id in jsonOptions) {
          var opt = optionsNameMap.get(id);
          if (opt) {
            (defaultOptions || (defaultOptions = {}))[opt.name] = convertJsonOption(opt, jsonOptions[id], basePath, errors);
          } else {
            errors.push(createUnknownOptionError(id, diagnostics, ts3.createCompilerDiagnostic));
          }
        }
        return defaultOptions;
      }
      function convertJsonOption(opt, value, basePath, errors) {
        if (isCompilerOptionsValue(opt, value)) {
          var optType = opt.type;
          if (optType === "list" && ts3.isArray(value)) {
            return convertJsonOptionOfListType(opt, value, basePath, errors);
          } else if (!ts3.isString(optType)) {
            return convertJsonOptionOfCustomType(opt, value, errors);
          }
          var validatedValue = validateJsonOptionValue(opt, value, errors);
          return isNullOrUndefined(validatedValue) ? validatedValue : normalizeNonListOptionValue(opt, basePath, validatedValue);
        } else {
          errors.push(ts3.createCompilerDiagnostic(ts3.Diagnostics.Compiler_option_0_requires_a_value_of_type_1, opt.name, getCompilerOptionValueTypeString(opt)));
        }
      }
      ts3.convertJsonOption = convertJsonOption;
      function normalizeOptionValue(option, basePath, value) {
        if (isNullOrUndefined(value))
          return void 0;
        if (option.type === "list") {
          var listOption_1 = option;
          if (listOption_1.element.isFilePath || !ts3.isString(listOption_1.element.type)) {
            return ts3.filter(ts3.map(value, function(v) {
              return normalizeOptionValue(listOption_1.element, basePath, v);
            }), function(v) {
              return !!v;
            });
          }
          return value;
        } else if (!ts3.isString(option.type)) {
          return option.type.get(ts3.isString(value) ? value.toLowerCase() : value);
        }
        return normalizeNonListOptionValue(option, basePath, value);
      }
      function normalizeNonListOptionValue(option, basePath, value) {
        if (option.isFilePath) {
          value = ts3.getNormalizedAbsolutePath(value, basePath);
          if (value === "") {
            value = ".";
          }
        }
        return value;
      }
      function validateJsonOptionValue(opt, value, errors) {
        var _a2;
        if (isNullOrUndefined(value))
          return void 0;
        var d = (_a2 = opt.extraValidation) === null || _a2 === void 0 ? void 0 : _a2.call(opt, value);
        if (!d)
          return value;
        errors.push(ts3.createCompilerDiagnostic.apply(void 0, d));
        return void 0;
      }
      function convertJsonOptionOfCustomType(opt, value, errors) {
        if (isNullOrUndefined(value))
          return void 0;
        var key2 = value.toLowerCase();
        var val = opt.type.get(key2);
        if (val !== void 0) {
          return validateJsonOptionValue(opt, val, errors);
        } else {
          errors.push(createCompilerDiagnosticForInvalidCustomType(opt));
        }
      }
      function convertJsonOptionOfListType(option, values, basePath, errors) {
        return ts3.filter(ts3.map(values, function(v) {
          return convertJsonOption(option.element, v, basePath, errors);
        }), function(v) {
          return !!v;
        });
      }
      function trimString(s2) {
        return typeof s2.trim === "function" ? s2.trim() : s2.replace(/^[\s]+|[\s]+$/g, "");
      }
      var invalidTrailingRecursionPattern = /(^|\/)\*\*\/?$/;
      var invalidDotDotAfterRecursiveWildcardPattern = /(^|\/)\*\*\/(.*\/)?\.\.($|\/)/;
      var watchRecursivePattern = /\/[^/]*?[*?][^/]*\//;
      var wildcardDirectoryPattern = /^[^*?]*(?=\/[^/]*[*?])/;
      function getFileNamesFromConfigSpecs(configFileSpecs, basePath, options, host, extraFileExtensions) {
        if (extraFileExtensions === void 0) {
          extraFileExtensions = ts3.emptyArray;
        }
        basePath = ts3.normalizePath(basePath);
        var keyMapper = ts3.createGetCanonicalFileName(host.useCaseSensitiveFileNames);
        var literalFileMap = new ts3.Map();
        var wildcardFileMap = new ts3.Map();
        var wildCardJsonFileMap = new ts3.Map();
        var validatedFilesSpec = configFileSpecs.validatedFilesSpec, validatedIncludeSpecs = configFileSpecs.validatedIncludeSpecs, validatedExcludeSpecs = configFileSpecs.validatedExcludeSpecs;
        var supportedExtensions = ts3.getSupportedExtensions(options, extraFileExtensions);
        var supportedExtensionsWithJsonIfResolveJsonModule = ts3.getSuppoertedExtensionsWithJsonIfResolveJsonModule(options, supportedExtensions);
        if (validatedFilesSpec) {
          for (var _i = 0, validatedFilesSpec_1 = validatedFilesSpec; _i < validatedFilesSpec_1.length; _i++) {
            var fileName = validatedFilesSpec_1[_i];
            var file = ts3.getNormalizedAbsolutePath(fileName, basePath);
            literalFileMap.set(keyMapper(file), file);
          }
        }
        var jsonOnlyIncludeRegexes;
        if (validatedIncludeSpecs && validatedIncludeSpecs.length > 0) {
          var _loop_6 = function(file2) {
            if (ts3.fileExtensionIs(file2, ".json")) {
              if (!jsonOnlyIncludeRegexes) {
                var includes = validatedIncludeSpecs.filter(function(s2) {
                  return ts3.endsWith(s2, ".json");
                });
                var includeFilePatterns = ts3.map(ts3.getRegularExpressionsForWildcards(includes, basePath, "files"), function(pattern) {
                  return "^" + pattern + "$";
                });
                jsonOnlyIncludeRegexes = includeFilePatterns ? includeFilePatterns.map(function(pattern) {
                  return ts3.getRegexFromPattern(pattern, host.useCaseSensitiveFileNames);
                }) : ts3.emptyArray;
              }
              var includeIndex = ts3.findIndex(jsonOnlyIncludeRegexes, function(re) {
                return re.test(file2);
              });
              if (includeIndex !== -1) {
                var key_1 = keyMapper(file2);
                if (!literalFileMap.has(key_1) && !wildCardJsonFileMap.has(key_1)) {
                  wildCardJsonFileMap.set(key_1, file2);
                }
              }
              return "continue";
            }
            if (hasFileWithHigherPriorityExtension(file2, literalFileMap, wildcardFileMap, supportedExtensions, keyMapper)) {
              return "continue";
            }
            removeWildcardFilesWithLowerPriorityExtension(file2, wildcardFileMap, supportedExtensions, keyMapper);
            var key2 = keyMapper(file2);
            if (!literalFileMap.has(key2) && !wildcardFileMap.has(key2)) {
              wildcardFileMap.set(key2, file2);
            }
          };
          for (var _a2 = 0, _b = host.readDirectory(basePath, supportedExtensionsWithJsonIfResolveJsonModule, validatedExcludeSpecs, validatedIncludeSpecs, void 0); _a2 < _b.length; _a2++) {
            var file = _b[_a2];
            _loop_6(file);
          }
        }
        var literalFiles = ts3.arrayFrom(literalFileMap.values());
        var wildcardFiles = ts3.arrayFrom(wildcardFileMap.values());
        return literalFiles.concat(wildcardFiles, ts3.arrayFrom(wildCardJsonFileMap.values()));
      }
      ts3.getFileNamesFromConfigSpecs = getFileNamesFromConfigSpecs;
      function isExcludedFile(pathToCheck, spec, basePath, useCaseSensitiveFileNames, currentDirectory) {
        var validatedFilesSpec = spec.validatedFilesSpec, validatedIncludeSpecs = spec.validatedIncludeSpecs, validatedExcludeSpecs = spec.validatedExcludeSpecs;
        if (!ts3.length(validatedIncludeSpecs) || !ts3.length(validatedExcludeSpecs))
          return false;
        basePath = ts3.normalizePath(basePath);
        var keyMapper = ts3.createGetCanonicalFileName(useCaseSensitiveFileNames);
        if (validatedFilesSpec) {
          for (var _i = 0, validatedFilesSpec_2 = validatedFilesSpec; _i < validatedFilesSpec_2.length; _i++) {
            var fileName = validatedFilesSpec_2[_i];
            if (keyMapper(ts3.getNormalizedAbsolutePath(fileName, basePath)) === pathToCheck)
              return false;
          }
        }
        return matchesExcludeWorker(pathToCheck, validatedExcludeSpecs, useCaseSensitiveFileNames, currentDirectory, basePath);
      }
      ts3.isExcludedFile = isExcludedFile;
      function matchesExclude(pathToCheck, excludeSpecs, useCaseSensitiveFileNames, currentDirectory) {
        return matchesExcludeWorker(pathToCheck, ts3.filter(excludeSpecs, function(spec) {
          return !invalidDotDotAfterRecursiveWildcardPattern.test(spec);
        }), useCaseSensitiveFileNames, currentDirectory);
      }
      ts3.matchesExclude = matchesExclude;
      function matchesExcludeWorker(pathToCheck, excludeSpecs, useCaseSensitiveFileNames, currentDirectory, basePath) {
        var excludePattern = ts3.getRegularExpressionForWildcard(excludeSpecs, ts3.combinePaths(ts3.normalizePath(currentDirectory), basePath), "exclude");
        var excludeRegex = excludePattern && ts3.getRegexFromPattern(excludePattern, useCaseSensitiveFileNames);
        if (!excludeRegex)
          return false;
        if (excludeRegex.test(pathToCheck))
          return true;
        return !ts3.hasExtension(pathToCheck) && excludeRegex.test(ts3.ensureTrailingDirectorySeparator(pathToCheck));
      }
      function validateSpecs(specs, errors, disallowTrailingRecursion, jsonSourceFile, specKey) {
        return specs.filter(function(spec) {
          if (!ts3.isString(spec))
            return false;
          var diag = specToDiagnostic(spec, disallowTrailingRecursion);
          if (diag !== void 0) {
            errors.push(createDiagnostic.apply(void 0, diag));
          }
          return diag === void 0;
        });
        function createDiagnostic(message, spec) {
          var element = ts3.getTsConfigPropArrayElementValue(jsonSourceFile, specKey, spec);
          return element ? ts3.createDiagnosticForNodeInSourceFile(jsonSourceFile, element, message, spec) : ts3.createCompilerDiagnostic(message, spec);
        }
      }
      function specToDiagnostic(spec, disallowTrailingRecursion) {
        if (disallowTrailingRecursion && invalidTrailingRecursionPattern.test(spec)) {
          return [ts3.Diagnostics.File_specification_cannot_end_in_a_recursive_directory_wildcard_Asterisk_Asterisk_Colon_0, spec];
        } else if (invalidDotDotAfterRecursiveWildcardPattern.test(spec)) {
          return [ts3.Diagnostics.File_specification_cannot_contain_a_parent_directory_that_appears_after_a_recursive_directory_wildcard_Asterisk_Asterisk_Colon_0, spec];
        }
      }
      function getWildcardDirectories(_a2, path2, useCaseSensitiveFileNames) {
        var include = _a2.validatedIncludeSpecs, exclude = _a2.validatedExcludeSpecs;
        var rawExcludeRegex = ts3.getRegularExpressionForWildcard(exclude, path2, "exclude");
        var excludeRegex = rawExcludeRegex && new RegExp(rawExcludeRegex, useCaseSensitiveFileNames ? "" : "i");
        var wildcardDirectories = {};
        if (include !== void 0) {
          var recursiveKeys = [];
          for (var _i = 0, include_1 = include; _i < include_1.length; _i++) {
            var file = include_1[_i];
            var spec = ts3.normalizePath(ts3.combinePaths(path2, file));
            if (excludeRegex && excludeRegex.test(spec)) {
              continue;
            }
            var match = getWildcardDirectoryFromSpec(spec, useCaseSensitiveFileNames);
            if (match) {
              var key2 = match.key, flags = match.flags;
              var existingFlags = wildcardDirectories[key2];
              if (existingFlags === void 0 || existingFlags < flags) {
                wildcardDirectories[key2] = flags;
                if (flags === 1) {
                  recursiveKeys.push(key2);
                }
              }
            }
          }
          for (var key2 in wildcardDirectories) {
            if (ts3.hasProperty(wildcardDirectories, key2)) {
              for (var _b = 0, recursiveKeys_1 = recursiveKeys; _b < recursiveKeys_1.length; _b++) {
                var recursiveKey = recursiveKeys_1[_b];
                if (key2 !== recursiveKey && ts3.containsPath(recursiveKey, key2, path2, !useCaseSensitiveFileNames)) {
                  delete wildcardDirectories[key2];
                }
              }
            }
          }
        }
        return wildcardDirectories;
      }
      function getWildcardDirectoryFromSpec(spec, useCaseSensitiveFileNames) {
        var match = wildcardDirectoryPattern.exec(spec);
        if (match) {
          return {
            key: useCaseSensitiveFileNames ? match[0] : ts3.toFileNameLowerCase(match[0]),
            flags: watchRecursivePattern.test(spec) ? 1 : 0
          };
        }
        if (ts3.isImplicitGlob(spec)) {
          return {
            key: useCaseSensitiveFileNames ? spec : ts3.toFileNameLowerCase(spec),
            flags: 1
          };
        }
        return void 0;
      }
      function hasFileWithHigherPriorityExtension(file, literalFiles, wildcardFiles, extensions, keyMapper) {
        var extensionPriority = ts3.getExtensionPriority(file, extensions);
        var adjustedExtensionPriority = ts3.adjustExtensionPriority(extensionPriority, extensions);
        for (var i3 = 0; i3 < adjustedExtensionPriority; i3++) {
          var higherPriorityExtension = extensions[i3];
          var higherPriorityPath = keyMapper(ts3.changeExtension(file, higherPriorityExtension));
          if (literalFiles.has(higherPriorityPath) || wildcardFiles.has(higherPriorityPath)) {
            return true;
          }
        }
        return false;
      }
      function removeWildcardFilesWithLowerPriorityExtension(file, wildcardFiles, extensions, keyMapper) {
        var extensionPriority = ts3.getExtensionPriority(file, extensions);
        var nextExtensionPriority = ts3.getNextLowestExtensionPriority(extensionPriority, extensions);
        for (var i3 = nextExtensionPriority; i3 < extensions.length; i3++) {
          var lowerPriorityExtension = extensions[i3];
          var lowerPriorityPath = keyMapper(ts3.changeExtension(file, lowerPriorityExtension));
          wildcardFiles.delete(lowerPriorityPath);
        }
      }
      function convertCompilerOptionsForTelemetry(opts) {
        var out = {};
        for (var key2 in opts) {
          if (opts.hasOwnProperty(key2)) {
            var type3 = getOptionFromName(key2);
            if (type3 !== void 0) {
              out[key2] = getOptionValueWithEmptyStrings(opts[key2], type3);
            }
          }
        }
        return out;
      }
      ts3.convertCompilerOptionsForTelemetry = convertCompilerOptionsForTelemetry;
      function getOptionValueWithEmptyStrings(value, option) {
        switch (option.type) {
          case "object":
            return "";
          case "string":
            return "";
          case "number":
            return typeof value === "number" ? value : "";
          case "boolean":
            return typeof value === "boolean" ? value : "";
          case "list":
            var elementType_1 = option.element;
            return ts3.isArray(value) ? value.map(function(v) {
              return getOptionValueWithEmptyStrings(v, elementType_1);
            }) : "";
          default:
            return ts3.forEachEntry(option.type, function(optionEnumValue, optionStringValue) {
              if (optionEnumValue === value) {
                return optionStringValue;
              }
            });
        }
      }
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      function trace(host) {
        host.trace(ts3.formatMessage.apply(void 0, arguments));
      }
      ts3.trace = trace;
      function isTraceEnabled(compilerOptions, host) {
        return !!compilerOptions.traceResolution && host.trace !== void 0;
      }
      ts3.isTraceEnabled = isTraceEnabled;
      function withPackageId(packageInfo, r2) {
        var packageId;
        if (r2 && packageInfo) {
          var packageJsonContent = packageInfo.packageJsonContent;
          if (typeof packageJsonContent.name === "string" && typeof packageJsonContent.version === "string") {
            packageId = {
              name: packageJsonContent.name,
              subModuleName: r2.path.slice(packageInfo.packageDirectory.length + ts3.directorySeparator.length),
              version: packageJsonContent.version
            };
          }
        }
        return r2 && { path: r2.path, extension: r2.ext, packageId };
      }
      function noPackageId(r2) {
        return withPackageId(void 0, r2);
      }
      function removeIgnoredPackageId(r2) {
        if (r2) {
          ts3.Debug.assert(r2.packageId === void 0);
          return { path: r2.path, ext: r2.extension };
        }
      }
      var Extensions;
      (function(Extensions2) {
        Extensions2[Extensions2["TypeScript"] = 0] = "TypeScript";
        Extensions2[Extensions2["JavaScript"] = 1] = "JavaScript";
        Extensions2[Extensions2["Json"] = 2] = "Json";
        Extensions2[Extensions2["TSConfig"] = 3] = "TSConfig";
        Extensions2[Extensions2["DtsOnly"] = 4] = "DtsOnly";
      })(Extensions || (Extensions = {}));
      function resolvedTypeScriptOnly(resolved) {
        if (!resolved) {
          return void 0;
        }
        ts3.Debug.assert(ts3.extensionIsTS(resolved.extension));
        return { fileName: resolved.path, packageId: resolved.packageId };
      }
      function createResolvedModuleWithFailedLookupLocations(resolved, isExternalLibraryImport, failedLookupLocations, resultFromCache) {
        var _a2;
        if (resultFromCache) {
          (_a2 = resultFromCache.failedLookupLocations).push.apply(_a2, failedLookupLocations);
          return resultFromCache;
        }
        return {
          resolvedModule: resolved && { resolvedFileName: resolved.path, originalPath: resolved.originalPath === true ? void 0 : resolved.originalPath, extension: resolved.extension, isExternalLibraryImport, packageId: resolved.packageId },
          failedLookupLocations
        };
      }
      function readPackageJsonField(jsonContent, fieldName, typeOfTag, state) {
        if (!ts3.hasProperty(jsonContent, fieldName)) {
          if (state.traceEnabled) {
            trace(state.host, ts3.Diagnostics.package_json_does_not_have_a_0_field, fieldName);
          }
          return;
        }
        var value = jsonContent[fieldName];
        if (typeof value !== typeOfTag || value === null) {
          if (state.traceEnabled) {
            trace(state.host, ts3.Diagnostics.Expected_type_of_0_field_in_package_json_to_be_1_got_2, fieldName, typeOfTag, value === null ? "null" : typeof value);
          }
          return;
        }
        return value;
      }
      function readPackageJsonPathField(jsonContent, fieldName, baseDirectory, state) {
        var fileName = readPackageJsonField(jsonContent, fieldName, "string", state);
        if (fileName === void 0) {
          return;
        }
        if (!fileName) {
          if (state.traceEnabled) {
            trace(state.host, ts3.Diagnostics.package_json_had_a_falsy_0_field, fieldName);
          }
          return;
        }
        var path2 = ts3.normalizePath(ts3.combinePaths(baseDirectory, fileName));
        if (state.traceEnabled) {
          trace(state.host, ts3.Diagnostics.package_json_has_0_field_1_that_references_2, fieldName, fileName, path2);
        }
        return path2;
      }
      function readPackageJsonTypesFields(jsonContent, baseDirectory, state) {
        return readPackageJsonPathField(jsonContent, "typings", baseDirectory, state) || readPackageJsonPathField(jsonContent, "types", baseDirectory, state);
      }
      function readPackageJsonTSConfigField(jsonContent, baseDirectory, state) {
        return readPackageJsonPathField(jsonContent, "tsconfig", baseDirectory, state);
      }
      function readPackageJsonMainField(jsonContent, baseDirectory, state) {
        return readPackageJsonPathField(jsonContent, "main", baseDirectory, state);
      }
      function readPackageJsonTypesVersionsField(jsonContent, state) {
        var typesVersions = readPackageJsonField(jsonContent, "typesVersions", "object", state);
        if (typesVersions === void 0)
          return;
        if (state.traceEnabled) {
          trace(state.host, ts3.Diagnostics.package_json_has_a_typesVersions_field_with_version_specific_path_mappings);
        }
        return typesVersions;
      }
      function readPackageJsonTypesVersionPaths(jsonContent, state) {
        var typesVersions = readPackageJsonTypesVersionsField(jsonContent, state);
        if (typesVersions === void 0)
          return;
        if (state.traceEnabled) {
          for (var key2 in typesVersions) {
            if (ts3.hasProperty(typesVersions, key2) && !ts3.VersionRange.tryParse(key2)) {
              trace(state.host, ts3.Diagnostics.package_json_has_a_typesVersions_entry_0_that_is_not_a_valid_semver_range, key2);
            }
          }
        }
        var result2 = getPackageJsonTypesVersionsPaths(typesVersions);
        if (!result2) {
          if (state.traceEnabled) {
            trace(state.host, ts3.Diagnostics.package_json_does_not_have_a_typesVersions_entry_that_matches_version_0, ts3.versionMajorMinor);
          }
          return;
        }
        var bestVersionKey = result2.version, bestVersionPaths = result2.paths;
        if (typeof bestVersionPaths !== "object") {
          if (state.traceEnabled) {
            trace(state.host, ts3.Diagnostics.Expected_type_of_0_field_in_package_json_to_be_1_got_2, "typesVersions['" + bestVersionKey + "']", "object", typeof bestVersionPaths);
          }
          return;
        }
        return result2;
      }
      var typeScriptVersion;
      function getPackageJsonTypesVersionsPaths(typesVersions) {
        if (!typeScriptVersion)
          typeScriptVersion = new ts3.Version(ts3.version);
        for (var key2 in typesVersions) {
          if (!ts3.hasProperty(typesVersions, key2))
            continue;
          var keyRange = ts3.VersionRange.tryParse(key2);
          if (keyRange === void 0) {
            continue;
          }
          if (keyRange.test(typeScriptVersion)) {
            return { version: key2, paths: typesVersions[key2] };
          }
        }
      }
      ts3.getPackageJsonTypesVersionsPaths = getPackageJsonTypesVersionsPaths;
      function getEffectiveTypeRoots(options, host) {
        if (options.typeRoots) {
          return options.typeRoots;
        }
        var currentDirectory;
        if (options.configFilePath) {
          currentDirectory = ts3.getDirectoryPath(options.configFilePath);
        } else if (host.getCurrentDirectory) {
          currentDirectory = host.getCurrentDirectory();
        }
        if (currentDirectory !== void 0) {
          return getDefaultTypeRoots(currentDirectory, host);
        }
      }
      ts3.getEffectiveTypeRoots = getEffectiveTypeRoots;
      function getDefaultTypeRoots(currentDirectory, host) {
        if (!host.directoryExists) {
          return [ts3.combinePaths(currentDirectory, nodeModulesAtTypes)];
        }
        var typeRoots;
        ts3.forEachAncestorDirectory(ts3.normalizePath(currentDirectory), function(directory) {
          var atTypes = ts3.combinePaths(directory, nodeModulesAtTypes);
          if (host.directoryExists(atTypes)) {
            (typeRoots || (typeRoots = [])).push(atTypes);
          }
          return void 0;
        });
        return typeRoots;
      }
      var nodeModulesAtTypes = ts3.combinePaths("node_modules", "@types");
      function resolveTypeReferenceDirective(typeReferenceDirectiveName, containingFile, options, host, redirectedReference, cache) {
        var traceEnabled = isTraceEnabled(options, host);
        if (redirectedReference) {
          options = redirectedReference.commandLine.options;
        }
        var containingDirectory = containingFile ? ts3.getDirectoryPath(containingFile) : void 0;
        var perFolderCache = containingDirectory ? cache && cache.getOrCreateCacheForDirectory(containingDirectory, redirectedReference) : void 0;
        var result2 = perFolderCache && perFolderCache.get(typeReferenceDirectiveName);
        if (result2) {
          if (traceEnabled) {
            trace(host, ts3.Diagnostics.Resolving_type_reference_directive_0_containing_file_1, typeReferenceDirectiveName, containingFile);
            if (redirectedReference)
              trace(host, ts3.Diagnostics.Using_compiler_options_of_project_reference_redirect_0, redirectedReference.sourceFile.fileName);
            trace(host, ts3.Diagnostics.Resolution_for_type_reference_directive_0_was_found_in_cache_from_location_1, typeReferenceDirectiveName, containingDirectory);
            traceResult(result2);
          }
          return result2;
        }
        var typeRoots = getEffectiveTypeRoots(options, host);
        if (traceEnabled) {
          if (containingFile === void 0) {
            if (typeRoots === void 0) {
              trace(host, ts3.Diagnostics.Resolving_type_reference_directive_0_containing_file_not_set_root_directory_not_set, typeReferenceDirectiveName);
            } else {
              trace(host, ts3.Diagnostics.Resolving_type_reference_directive_0_containing_file_not_set_root_directory_1, typeReferenceDirectiveName, typeRoots);
            }
          } else {
            if (typeRoots === void 0) {
              trace(host, ts3.Diagnostics.Resolving_type_reference_directive_0_containing_file_1_root_directory_not_set, typeReferenceDirectiveName, containingFile);
            } else {
              trace(host, ts3.Diagnostics.Resolving_type_reference_directive_0_containing_file_1_root_directory_2, typeReferenceDirectiveName, containingFile, typeRoots);
            }
          }
          if (redirectedReference) {
            trace(host, ts3.Diagnostics.Using_compiler_options_of_project_reference_redirect_0, redirectedReference.sourceFile.fileName);
          }
        }
        var failedLookupLocations = [];
        var moduleResolutionState = { compilerOptions: options, host, traceEnabled, failedLookupLocations, packageJsonInfoCache: cache };
        var resolved = primaryLookup();
        var primary = true;
        if (!resolved) {
          resolved = secondaryLookup();
          primary = false;
        }
        var resolvedTypeReferenceDirective;
        if (resolved) {
          var fileName = resolved.fileName, packageId = resolved.packageId;
          var resolvedFileName = options.preserveSymlinks ? fileName : realPath(fileName, host, traceEnabled);
          resolvedTypeReferenceDirective = {
            primary,
            resolvedFileName,
            originalPath: fileName === resolvedFileName ? void 0 : fileName,
            packageId,
            isExternalLibraryImport: pathContainsNodeModules(fileName)
          };
        }
        result2 = { resolvedTypeReferenceDirective, failedLookupLocations };
        perFolderCache === null || perFolderCache === void 0 ? void 0 : perFolderCache.set(typeReferenceDirectiveName, result2);
        if (traceEnabled)
          traceResult(result2);
        return result2;
        function traceResult(result3) {
          var _a2;
          if (!((_a2 = result3.resolvedTypeReferenceDirective) === null || _a2 === void 0 ? void 0 : _a2.resolvedFileName)) {
            trace(host, ts3.Diagnostics.Type_reference_directive_0_was_not_resolved, typeReferenceDirectiveName);
          } else if (result3.resolvedTypeReferenceDirective.packageId) {
            trace(host, ts3.Diagnostics.Type_reference_directive_0_was_successfully_resolved_to_1_with_Package_ID_2_primary_Colon_3, typeReferenceDirectiveName, result3.resolvedTypeReferenceDirective.resolvedFileName, ts3.packageIdToString(result3.resolvedTypeReferenceDirective.packageId), result3.resolvedTypeReferenceDirective.primary);
          } else {
            trace(host, ts3.Diagnostics.Type_reference_directive_0_was_successfully_resolved_to_1_primary_Colon_2, typeReferenceDirectiveName, result3.resolvedTypeReferenceDirective.resolvedFileName, result3.resolvedTypeReferenceDirective.primary);
          }
        }
        function primaryLookup() {
          if (typeRoots && typeRoots.length) {
            if (traceEnabled) {
              trace(host, ts3.Diagnostics.Resolving_with_primary_search_path_0, typeRoots.join(", "));
            }
            return ts3.firstDefined(typeRoots, function(typeRoot) {
              var candidate = ts3.combinePaths(typeRoot, typeReferenceDirectiveName);
              var candidateDirectory = ts3.getDirectoryPath(candidate);
              var directoryExists = ts3.directoryProbablyExists(candidateDirectory, host);
              if (!directoryExists && traceEnabled) {
                trace(host, ts3.Diagnostics.Directory_0_does_not_exist_skipping_all_lookups_in_it, candidateDirectory);
              }
              return resolvedTypeScriptOnly(loadNodeModuleFromDirectory(Extensions.DtsOnly, candidate, !directoryExists, moduleResolutionState));
            });
          } else {
            if (traceEnabled) {
              trace(host, ts3.Diagnostics.Root_directory_cannot_be_determined_skipping_primary_search_paths);
            }
          }
        }
        function secondaryLookup() {
          var initialLocationForSecondaryLookup = containingFile && ts3.getDirectoryPath(containingFile);
          if (initialLocationForSecondaryLookup !== void 0) {
            if (traceEnabled) {
              trace(host, ts3.Diagnostics.Looking_up_in_node_modules_folder_initial_location_0, initialLocationForSecondaryLookup);
            }
            var result_4;
            if (!ts3.isExternalModuleNameRelative(typeReferenceDirectiveName)) {
              var searchResult = loadModuleFromNearestNodeModulesDirectory(Extensions.DtsOnly, typeReferenceDirectiveName, initialLocationForSecondaryLookup, moduleResolutionState, void 0, void 0);
              result_4 = searchResult && searchResult.value;
            } else {
              var candidate = ts3.normalizePathAndParts(ts3.combinePaths(initialLocationForSecondaryLookup, typeReferenceDirectiveName)).path;
              result_4 = nodeLoadModuleByRelativeName(Extensions.DtsOnly, candidate, false, moduleResolutionState, true);
            }
            return resolvedTypeScriptOnly(result_4);
          } else {
            if (traceEnabled) {
              trace(host, ts3.Diagnostics.Containing_file_is_not_specified_and_root_directory_cannot_be_determined_skipping_lookup_in_node_modules_folder);
            }
          }
        }
      }
      ts3.resolveTypeReferenceDirective = resolveTypeReferenceDirective;
      function getAutomaticTypeDirectiveNames(options, host) {
        if (options.types) {
          return options.types;
        }
        var result2 = [];
        if (host.directoryExists && host.getDirectories) {
          var typeRoots = getEffectiveTypeRoots(options, host);
          if (typeRoots) {
            for (var _i = 0, typeRoots_1 = typeRoots; _i < typeRoots_1.length; _i++) {
              var root = typeRoots_1[_i];
              if (host.directoryExists(root)) {
                for (var _a2 = 0, _b = host.getDirectories(root); _a2 < _b.length; _a2++) {
                  var typeDirectivePath = _b[_a2];
                  var normalized = ts3.normalizePath(typeDirectivePath);
                  var packageJsonPath = ts3.combinePaths(root, normalized, "package.json");
                  var isNotNeededPackage = host.fileExists(packageJsonPath) && ts3.readJson(packageJsonPath, host).typings === null;
                  if (!isNotNeededPackage) {
                    var baseFileName = ts3.getBaseFileName(normalized);
                    if (baseFileName.charCodeAt(0) !== 46) {
                      result2.push(baseFileName);
                    }
                  }
                }
              }
            }
          }
        }
        return result2;
      }
      ts3.getAutomaticTypeDirectiveNames = getAutomaticTypeDirectiveNames;
      function createCacheWithRedirects(options) {
        var ownMap = new ts3.Map();
        var redirectsMap = new ts3.Map();
        return {
          getOwnMap,
          redirectsMap,
          getOrCreateMapOfCacheRedirects,
          clear,
          setOwnOptions,
          setOwnMap
        };
        function getOwnMap() {
          return ownMap;
        }
        function setOwnOptions(newOptions) {
          options = newOptions;
        }
        function setOwnMap(newOwnMap) {
          ownMap = newOwnMap;
        }
        function getOrCreateMapOfCacheRedirects(redirectedReference) {
          if (!redirectedReference) {
            return ownMap;
          }
          var path2 = redirectedReference.sourceFile.path;
          var redirects = redirectsMap.get(path2);
          if (!redirects) {
            redirects = !options || ts3.optionsHaveModuleResolutionChanges(options, redirectedReference.commandLine.options) ? new ts3.Map() : ownMap;
            redirectsMap.set(path2, redirects);
          }
          return redirects;
        }
        function clear() {
          ownMap.clear();
          redirectsMap.clear();
        }
      }
      ts3.createCacheWithRedirects = createCacheWithRedirects;
      function createPackageJsonInfoCache(currentDirectory, getCanonicalFileName) {
        var cache;
        return { getPackageJsonInfo: getPackageJsonInfo2, setPackageJsonInfo, clear };
        function getPackageJsonInfo2(packageJsonPath) {
          return cache === null || cache === void 0 ? void 0 : cache.get(ts3.toPath(packageJsonPath, currentDirectory, getCanonicalFileName));
        }
        function setPackageJsonInfo(packageJsonPath, info) {
          (cache || (cache = new ts3.Map())).set(ts3.toPath(packageJsonPath, currentDirectory, getCanonicalFileName), info);
        }
        function clear() {
          cache = void 0;
        }
      }
      function getOrCreateCache(cacheWithRedirects, redirectedReference, key2, create) {
        var cache = cacheWithRedirects.getOrCreateMapOfCacheRedirects(redirectedReference);
        var result2 = cache.get(key2);
        if (!result2) {
          result2 = create();
          cache.set(key2, result2);
        }
        return result2;
      }
      function updateRedirectsMap(options, directoryToModuleNameMap, moduleNameToDirectoryMap) {
        if (!options.configFile)
          return;
        if (directoryToModuleNameMap.redirectsMap.size === 0) {
          ts3.Debug.assert(!moduleNameToDirectoryMap || moduleNameToDirectoryMap.redirectsMap.size === 0);
          ts3.Debug.assert(directoryToModuleNameMap.getOwnMap().size === 0);
          ts3.Debug.assert(!moduleNameToDirectoryMap || moduleNameToDirectoryMap.getOwnMap().size === 0);
          directoryToModuleNameMap.redirectsMap.set(options.configFile.path, directoryToModuleNameMap.getOwnMap());
          moduleNameToDirectoryMap === null || moduleNameToDirectoryMap === void 0 ? void 0 : moduleNameToDirectoryMap.redirectsMap.set(options.configFile.path, moduleNameToDirectoryMap.getOwnMap());
        } else {
          ts3.Debug.assert(!moduleNameToDirectoryMap || moduleNameToDirectoryMap.redirectsMap.size > 0);
          var ref2 = {
            sourceFile: options.configFile,
            commandLine: { options }
          };
          directoryToModuleNameMap.setOwnMap(directoryToModuleNameMap.getOrCreateMapOfCacheRedirects(ref2));
          moduleNameToDirectoryMap === null || moduleNameToDirectoryMap === void 0 ? void 0 : moduleNameToDirectoryMap.setOwnMap(moduleNameToDirectoryMap.getOrCreateMapOfCacheRedirects(ref2));
        }
        directoryToModuleNameMap.setOwnOptions(options);
        moduleNameToDirectoryMap === null || moduleNameToDirectoryMap === void 0 ? void 0 : moduleNameToDirectoryMap.setOwnOptions(options);
      }
      function createPerDirectoryResolutionCache(currentDirectory, getCanonicalFileName, directoryToModuleNameMap) {
        return {
          getOrCreateCacheForDirectory,
          clear,
          update
        };
        function clear() {
          directoryToModuleNameMap.clear();
        }
        function update(options) {
          updateRedirectsMap(options, directoryToModuleNameMap);
        }
        function getOrCreateCacheForDirectory(directoryName, redirectedReference) {
          var path2 = ts3.toPath(directoryName, currentDirectory, getCanonicalFileName);
          return getOrCreateCache(directoryToModuleNameMap, redirectedReference, path2, function() {
            return new ts3.Map();
          });
        }
      }
      function createModuleResolutionCache(currentDirectory, getCanonicalFileName, options, directoryToModuleNameMap, moduleNameToDirectoryMap) {
        var preDirectoryResolutionCache = createPerDirectoryResolutionCache(currentDirectory, getCanonicalFileName, directoryToModuleNameMap || (directoryToModuleNameMap = createCacheWithRedirects(options)));
        moduleNameToDirectoryMap || (moduleNameToDirectoryMap = createCacheWithRedirects(options));
        var packageJsonInfoCache = createPackageJsonInfoCache(currentDirectory, getCanonicalFileName);
        return __assign(__assign(__assign({}, packageJsonInfoCache), preDirectoryResolutionCache), { getOrCreateCacheForModuleName, clear, update, getPackageJsonInfoCache: function() {
          return packageJsonInfoCache;
        } });
        function clear() {
          preDirectoryResolutionCache.clear();
          moduleNameToDirectoryMap.clear();
          packageJsonInfoCache.clear();
        }
        function update(options2) {
          updateRedirectsMap(options2, directoryToModuleNameMap, moduleNameToDirectoryMap);
        }
        function getOrCreateCacheForModuleName(nonRelativeModuleName, redirectedReference) {
          ts3.Debug.assert(!ts3.isExternalModuleNameRelative(nonRelativeModuleName));
          return getOrCreateCache(moduleNameToDirectoryMap, redirectedReference, nonRelativeModuleName, createPerModuleNameCache);
        }
        function createPerModuleNameCache() {
          var directoryPathMap = new ts3.Map();
          return { get, set: set2 };
          function get(directory) {
            return directoryPathMap.get(ts3.toPath(directory, currentDirectory, getCanonicalFileName));
          }
          function set2(directory, result2) {
            var path2 = ts3.toPath(directory, currentDirectory, getCanonicalFileName);
            if (directoryPathMap.has(path2)) {
              return;
            }
            directoryPathMap.set(path2, result2);
            var resolvedFileName = result2.resolvedModule && (result2.resolvedModule.originalPath || result2.resolvedModule.resolvedFileName);
            var commonPrefix = resolvedFileName && getCommonPrefix(path2, resolvedFileName);
            var current = path2;
            while (current !== commonPrefix) {
              var parent = ts3.getDirectoryPath(current);
              if (parent === current || directoryPathMap.has(parent)) {
                break;
              }
              directoryPathMap.set(parent, result2);
              current = parent;
            }
          }
          function getCommonPrefix(directory, resolution) {
            var resolutionDirectory = ts3.toPath(ts3.getDirectoryPath(resolution), currentDirectory, getCanonicalFileName);
            var i3 = 0;
            var limit = Math.min(directory.length, resolutionDirectory.length);
            while (i3 < limit && directory.charCodeAt(i3) === resolutionDirectory.charCodeAt(i3)) {
              i3++;
            }
            if (i3 === directory.length && (resolutionDirectory.length === i3 || resolutionDirectory[i3] === ts3.directorySeparator)) {
              return directory;
            }
            var rootLength = ts3.getRootLength(directory);
            if (i3 < rootLength) {
              return void 0;
            }
            var sep = directory.lastIndexOf(ts3.directorySeparator, i3 - 1);
            if (sep === -1) {
              return void 0;
            }
            return directory.substr(0, Math.max(sep, rootLength));
          }
        }
      }
      ts3.createModuleResolutionCache = createModuleResolutionCache;
      function createTypeReferenceDirectiveResolutionCache(currentDirectory, getCanonicalFileName, options, packageJsonInfoCache, directoryToModuleNameMap) {
        var preDirectoryResolutionCache = createPerDirectoryResolutionCache(currentDirectory, getCanonicalFileName, directoryToModuleNameMap || (directoryToModuleNameMap = createCacheWithRedirects(options)));
        packageJsonInfoCache || (packageJsonInfoCache = createPackageJsonInfoCache(currentDirectory, getCanonicalFileName));
        return __assign(__assign(__assign({}, packageJsonInfoCache), preDirectoryResolutionCache), { clear });
        function clear() {
          preDirectoryResolutionCache.clear();
          packageJsonInfoCache.clear();
        }
      }
      ts3.createTypeReferenceDirectiveResolutionCache = createTypeReferenceDirectiveResolutionCache;
      function resolveModuleNameFromCache(moduleName, containingFile, cache) {
        var containingDirectory = ts3.getDirectoryPath(containingFile);
        var perFolderCache = cache && cache.getOrCreateCacheForDirectory(containingDirectory);
        return perFolderCache && perFolderCache.get(moduleName);
      }
      ts3.resolveModuleNameFromCache = resolveModuleNameFromCache;
      function resolveModuleName(moduleName, containingFile, compilerOptions, host, cache, redirectedReference) {
        var traceEnabled = isTraceEnabled(compilerOptions, host);
        if (redirectedReference) {
          compilerOptions = redirectedReference.commandLine.options;
        }
        if (traceEnabled) {
          trace(host, ts3.Diagnostics.Resolving_module_0_from_1, moduleName, containingFile);
          if (redirectedReference) {
            trace(host, ts3.Diagnostics.Using_compiler_options_of_project_reference_redirect_0, redirectedReference.sourceFile.fileName);
          }
        }
        var containingDirectory = ts3.getDirectoryPath(containingFile);
        var perFolderCache = cache && cache.getOrCreateCacheForDirectory(containingDirectory, redirectedReference);
        var result2 = perFolderCache && perFolderCache.get(moduleName);
        if (result2) {
          if (traceEnabled) {
            trace(host, ts3.Diagnostics.Resolution_for_module_0_was_found_in_cache_from_location_1, moduleName, containingDirectory);
          }
        } else {
          var moduleResolution = compilerOptions.moduleResolution;
          if (moduleResolution === void 0) {
            moduleResolution = ts3.getEmitModuleKind(compilerOptions) === ts3.ModuleKind.CommonJS ? ts3.ModuleResolutionKind.NodeJs : ts3.ModuleResolutionKind.Classic;
            if (traceEnabled) {
              trace(host, ts3.Diagnostics.Module_resolution_kind_is_not_specified_using_0, ts3.ModuleResolutionKind[moduleResolution]);
            }
          } else {
            if (traceEnabled) {
              trace(host, ts3.Diagnostics.Explicitly_specified_module_resolution_kind_Colon_0, ts3.ModuleResolutionKind[moduleResolution]);
            }
          }
          ts3.perfLogger.logStartResolveModule(moduleName);
          switch (moduleResolution) {
            case ts3.ModuleResolutionKind.NodeJs:
              result2 = nodeModuleNameResolver(moduleName, containingFile, compilerOptions, host, cache, redirectedReference);
              break;
            case ts3.ModuleResolutionKind.Classic:
              result2 = classicNameResolver(moduleName, containingFile, compilerOptions, host, cache, redirectedReference);
              break;
            default:
              return ts3.Debug.fail("Unexpected moduleResolution: " + moduleResolution);
          }
          if (result2 && result2.resolvedModule)
            ts3.perfLogger.logInfoEvent('Module "' + moduleName + '" resolved to "' + result2.resolvedModule.resolvedFileName + '"');
          ts3.perfLogger.logStopResolveModule(result2 && result2.resolvedModule ? "" + result2.resolvedModule.resolvedFileName : "null");
          if (perFolderCache) {
            perFolderCache.set(moduleName, result2);
            if (!ts3.isExternalModuleNameRelative(moduleName)) {
              cache.getOrCreateCacheForModuleName(moduleName, redirectedReference).set(containingDirectory, result2);
            }
          }
        }
        if (traceEnabled) {
          if (result2.resolvedModule) {
            if (result2.resolvedModule.packageId) {
              trace(host, ts3.Diagnostics.Module_name_0_was_successfully_resolved_to_1_with_Package_ID_2, moduleName, result2.resolvedModule.resolvedFileName, ts3.packageIdToString(result2.resolvedModule.packageId));
            } else {
              trace(host, ts3.Diagnostics.Module_name_0_was_successfully_resolved_to_1, moduleName, result2.resolvedModule.resolvedFileName);
            }
          } else {
            trace(host, ts3.Diagnostics.Module_name_0_was_not_resolved, moduleName);
          }
        }
        return result2;
      }
      ts3.resolveModuleName = resolveModuleName;
      function tryLoadModuleUsingOptionalResolutionSettings(extensions, moduleName, containingDirectory, loader2, state) {
        var resolved = tryLoadModuleUsingPathsIfEligible(extensions, moduleName, loader2, state);
        if (resolved)
          return resolved.value;
        if (!ts3.isExternalModuleNameRelative(moduleName)) {
          return tryLoadModuleUsingBaseUrl(extensions, moduleName, loader2, state);
        } else {
          return tryLoadModuleUsingRootDirs(extensions, moduleName, containingDirectory, loader2, state);
        }
      }
      function tryLoadModuleUsingPathsIfEligible(extensions, moduleName, loader2, state) {
        var _a2 = state.compilerOptions, baseUrl = _a2.baseUrl, paths = _a2.paths;
        if (paths && !ts3.pathIsRelative(moduleName)) {
          if (state.traceEnabled) {
            if (baseUrl) {
              trace(state.host, ts3.Diagnostics.baseUrl_option_is_set_to_0_using_this_value_to_resolve_non_relative_module_name_1, baseUrl, moduleName);
            }
            trace(state.host, ts3.Diagnostics.paths_option_is_specified_looking_for_a_pattern_to_match_module_name_0, moduleName);
          }
          var baseDirectory = ts3.getPathsBasePath(state.compilerOptions, state.host);
          return tryLoadModuleUsingPaths(extensions, moduleName, baseDirectory, paths, loader2, false, state);
        }
      }
      function tryLoadModuleUsingRootDirs(extensions, moduleName, containingDirectory, loader2, state) {
        if (!state.compilerOptions.rootDirs) {
          return void 0;
        }
        if (state.traceEnabled) {
          trace(state.host, ts3.Diagnostics.rootDirs_option_is_set_using_it_to_resolve_relative_module_name_0, moduleName);
        }
        var candidate = ts3.normalizePath(ts3.combinePaths(containingDirectory, moduleName));
        var matchedRootDir;
        var matchedNormalizedPrefix;
        for (var _i = 0, _a2 = state.compilerOptions.rootDirs; _i < _a2.length; _i++) {
          var rootDir = _a2[_i];
          var normalizedRoot = ts3.normalizePath(rootDir);
          if (!ts3.endsWith(normalizedRoot, ts3.directorySeparator)) {
            normalizedRoot += ts3.directorySeparator;
          }
          var isLongestMatchingPrefix = ts3.startsWith(candidate, normalizedRoot) && (matchedNormalizedPrefix === void 0 || matchedNormalizedPrefix.length < normalizedRoot.length);
          if (state.traceEnabled) {
            trace(state.host, ts3.Diagnostics.Checking_if_0_is_the_longest_matching_prefix_for_1_2, normalizedRoot, candidate, isLongestMatchingPrefix);
          }
          if (isLongestMatchingPrefix) {
            matchedNormalizedPrefix = normalizedRoot;
            matchedRootDir = rootDir;
          }
        }
        if (matchedNormalizedPrefix) {
          if (state.traceEnabled) {
            trace(state.host, ts3.Diagnostics.Longest_matching_prefix_for_0_is_1, candidate, matchedNormalizedPrefix);
          }
          var suffix = candidate.substr(matchedNormalizedPrefix.length);
          if (state.traceEnabled) {
            trace(state.host, ts3.Diagnostics.Loading_0_from_the_root_dir_1_candidate_location_2, suffix, matchedNormalizedPrefix, candidate);
          }
          var resolvedFileName = loader2(extensions, candidate, !ts3.directoryProbablyExists(containingDirectory, state.host), state);
          if (resolvedFileName) {
            return resolvedFileName;
          }
          if (state.traceEnabled) {
            trace(state.host, ts3.Diagnostics.Trying_other_entries_in_rootDirs);
          }
          for (var _b = 0, _c = state.compilerOptions.rootDirs; _b < _c.length; _b++) {
            var rootDir = _c[_b];
            if (rootDir === matchedRootDir) {
              continue;
            }
            var candidate_1 = ts3.combinePaths(ts3.normalizePath(rootDir), suffix);
            if (state.traceEnabled) {
              trace(state.host, ts3.Diagnostics.Loading_0_from_the_root_dir_1_candidate_location_2, suffix, rootDir, candidate_1);
            }
            var baseDirectory = ts3.getDirectoryPath(candidate_1);
            var resolvedFileName_1 = loader2(extensions, candidate_1, !ts3.directoryProbablyExists(baseDirectory, state.host), state);
            if (resolvedFileName_1) {
              return resolvedFileName_1;
            }
          }
          if (state.traceEnabled) {
            trace(state.host, ts3.Diagnostics.Module_resolution_using_rootDirs_has_failed);
          }
        }
        return void 0;
      }
      function tryLoadModuleUsingBaseUrl(extensions, moduleName, loader2, state) {
        var baseUrl = state.compilerOptions.baseUrl;
        if (!baseUrl) {
          return void 0;
        }
        if (state.traceEnabled) {
          trace(state.host, ts3.Diagnostics.baseUrl_option_is_set_to_0_using_this_value_to_resolve_non_relative_module_name_1, baseUrl, moduleName);
        }
        var candidate = ts3.normalizePath(ts3.combinePaths(baseUrl, moduleName));
        if (state.traceEnabled) {
          trace(state.host, ts3.Diagnostics.Resolving_module_name_0_relative_to_base_url_1_2, moduleName, baseUrl, candidate);
        }
        return loader2(extensions, candidate, !ts3.directoryProbablyExists(ts3.getDirectoryPath(candidate), state.host), state);
      }
      function resolveJSModule(moduleName, initialDir, host) {
        var _a2 = tryResolveJSModuleWorker(moduleName, initialDir, host), resolvedModule = _a2.resolvedModule, failedLookupLocations = _a2.failedLookupLocations;
        if (!resolvedModule) {
          throw new Error("Could not resolve JS module '" + moduleName + "' starting at '" + initialDir + "'. Looked in: " + failedLookupLocations.join(", "));
        }
        return resolvedModule.resolvedFileName;
      }
      ts3.resolveJSModule = resolveJSModule;
      function tryResolveJSModule(moduleName, initialDir, host) {
        var resolvedModule = tryResolveJSModuleWorker(moduleName, initialDir, host).resolvedModule;
        return resolvedModule && resolvedModule.resolvedFileName;
      }
      ts3.tryResolveJSModule = tryResolveJSModule;
      var jsOnlyExtensions = [Extensions.JavaScript];
      var tsExtensions = [Extensions.TypeScript, Extensions.JavaScript];
      var tsPlusJsonExtensions = __spreadArray(__spreadArray([], tsExtensions), [Extensions.Json]);
      var tsconfigExtensions = [Extensions.TSConfig];
      function tryResolveJSModuleWorker(moduleName, initialDir, host) {
        return nodeModuleNameResolverWorker(moduleName, initialDir, { moduleResolution: ts3.ModuleResolutionKind.NodeJs, allowJs: true }, host, void 0, jsOnlyExtensions, void 0);
      }
      function nodeModuleNameResolver(moduleName, containingFile, compilerOptions, host, cache, redirectedReference, lookupConfig) {
        return nodeModuleNameResolverWorker(moduleName, ts3.getDirectoryPath(containingFile), compilerOptions, host, cache, lookupConfig ? tsconfigExtensions : compilerOptions.resolveJsonModule ? tsPlusJsonExtensions : tsExtensions, redirectedReference);
      }
      ts3.nodeModuleNameResolver = nodeModuleNameResolver;
      function nodeModuleNameResolverWorker(moduleName, containingDirectory, compilerOptions, host, cache, extensions, redirectedReference) {
        var _a2, _b;
        var traceEnabled = isTraceEnabled(compilerOptions, host);
        var failedLookupLocations = [];
        var state = { compilerOptions, host, traceEnabled, failedLookupLocations, packageJsonInfoCache: cache };
        var result2 = ts3.forEach(extensions, function(ext) {
          return tryResolve(ext);
        });
        return createResolvedModuleWithFailedLookupLocations((_a2 = result2 === null || result2 === void 0 ? void 0 : result2.value) === null || _a2 === void 0 ? void 0 : _a2.resolved, (_b = result2 === null || result2 === void 0 ? void 0 : result2.value) === null || _b === void 0 ? void 0 : _b.isExternalLibraryImport, failedLookupLocations, state.resultFromCache);
        function tryResolve(extensions2) {
          var loader2 = function(extensions3, candidate2, onlyRecordFailures, state2) {
            return nodeLoadModuleByRelativeName(extensions3, candidate2, onlyRecordFailures, state2, true);
          };
          var resolved = tryLoadModuleUsingOptionalResolutionSettings(extensions2, moduleName, containingDirectory, loader2, state);
          if (resolved) {
            return toSearchResult({ resolved, isExternalLibraryImport: pathContainsNodeModules(resolved.path) });
          }
          if (!ts3.isExternalModuleNameRelative(moduleName)) {
            if (traceEnabled) {
              trace(host, ts3.Diagnostics.Loading_module_0_from_node_modules_folder_target_file_type_1, moduleName, Extensions[extensions2]);
            }
            var resolved_1 = loadModuleFromNearestNodeModulesDirectory(extensions2, moduleName, containingDirectory, state, cache, redirectedReference);
            if (!resolved_1)
              return void 0;
            var resolvedValue = resolved_1.value;
            if (!compilerOptions.preserveSymlinks && resolvedValue && !resolvedValue.originalPath) {
              var path2 = realPath(resolvedValue.path, host, traceEnabled);
              var originalPath = path2 === resolvedValue.path ? void 0 : resolvedValue.path;
              resolvedValue = __assign(__assign({}, resolvedValue), { path: path2, originalPath });
            }
            return { value: resolvedValue && { resolved: resolvedValue, isExternalLibraryImport: true } };
          } else {
            var _a3 = ts3.normalizePathAndParts(ts3.combinePaths(containingDirectory, moduleName)), candidate = _a3.path, parts = _a3.parts;
            var resolved_2 = nodeLoadModuleByRelativeName(extensions2, candidate, false, state, true);
            return resolved_2 && toSearchResult({ resolved: resolved_2, isExternalLibraryImport: ts3.contains(parts, "node_modules") });
          }
        }
      }
      function realPath(path2, host, traceEnabled) {
        if (!host.realpath) {
          return path2;
        }
        var real = ts3.normalizePath(host.realpath(path2));
        if (traceEnabled) {
          trace(host, ts3.Diagnostics.Resolving_real_path_for_0_result_1, path2, real);
        }
        ts3.Debug.assert(host.fileExists(real), path2 + " linked to nonexistent file " + real);
        return real;
      }
      function nodeLoadModuleByRelativeName(extensions, candidate, onlyRecordFailures, state, considerPackageJson) {
        if (state.traceEnabled) {
          trace(state.host, ts3.Diagnostics.Loading_module_as_file_Slash_folder_candidate_module_location_0_target_file_type_1, candidate, Extensions[extensions]);
        }
        if (!ts3.hasTrailingDirectorySeparator(candidate)) {
          if (!onlyRecordFailures) {
            var parentOfCandidate = ts3.getDirectoryPath(candidate);
            if (!ts3.directoryProbablyExists(parentOfCandidate, state.host)) {
              if (state.traceEnabled) {
                trace(state.host, ts3.Diagnostics.Directory_0_does_not_exist_skipping_all_lookups_in_it, parentOfCandidate);
              }
              onlyRecordFailures = true;
            }
          }
          var resolvedFromFile = loadModuleFromFile(extensions, candidate, onlyRecordFailures, state);
          if (resolvedFromFile) {
            var packageDirectory = considerPackageJson ? parseNodeModuleFromPath(resolvedFromFile.path) : void 0;
            var packageInfo = packageDirectory ? getPackageJsonInfo(packageDirectory, false, state) : void 0;
            return withPackageId(packageInfo, resolvedFromFile);
          }
        }
        if (!onlyRecordFailures) {
          var candidateExists = ts3.directoryProbablyExists(candidate, state.host);
          if (!candidateExists) {
            if (state.traceEnabled) {
              trace(state.host, ts3.Diagnostics.Directory_0_does_not_exist_skipping_all_lookups_in_it, candidate);
            }
            onlyRecordFailures = true;
          }
        }
        return loadNodeModuleFromDirectory(extensions, candidate, onlyRecordFailures, state, considerPackageJson);
      }
      ts3.nodeModulesPathPart = "/node_modules/";
      function pathContainsNodeModules(path2) {
        return ts3.stringContains(path2, ts3.nodeModulesPathPart);
      }
      ts3.pathContainsNodeModules = pathContainsNodeModules;
      function parseNodeModuleFromPath(resolved) {
        var path2 = ts3.normalizePath(resolved);
        var idx = path2.lastIndexOf(ts3.nodeModulesPathPart);
        if (idx === -1) {
          return void 0;
        }
        var indexAfterNodeModules = idx + ts3.nodeModulesPathPart.length;
        var indexAfterPackageName = moveToNextDirectorySeparatorIfAvailable(path2, indexAfterNodeModules);
        if (path2.charCodeAt(indexAfterNodeModules) === 64) {
          indexAfterPackageName = moveToNextDirectorySeparatorIfAvailable(path2, indexAfterPackageName);
        }
        return path2.slice(0, indexAfterPackageName);
      }
      ts3.parseNodeModuleFromPath = parseNodeModuleFromPath;
      function moveToNextDirectorySeparatorIfAvailable(path2, prevSeparatorIndex) {
        var nextSeparatorIndex = path2.indexOf(ts3.directorySeparator, prevSeparatorIndex + 1);
        return nextSeparatorIndex === -1 ? prevSeparatorIndex : nextSeparatorIndex;
      }
      function loadModuleFromFileNoPackageId(extensions, candidate, onlyRecordFailures, state) {
        return noPackageId(loadModuleFromFile(extensions, candidate, onlyRecordFailures, state));
      }
      function loadModuleFromFile(extensions, candidate, onlyRecordFailures, state) {
        if (extensions === Extensions.Json || extensions === Extensions.TSConfig) {
          var extensionLess = ts3.tryRemoveExtension(candidate, ".json");
          return extensionLess === void 0 && extensions === Extensions.Json ? void 0 : tryAddingExtensions(extensionLess || candidate, extensions, onlyRecordFailures, state);
        }
        var resolvedByAddingExtension = tryAddingExtensions(candidate, extensions, onlyRecordFailures, state);
        if (resolvedByAddingExtension) {
          return resolvedByAddingExtension;
        }
        if (ts3.hasJSFileExtension(candidate)) {
          var extensionless = ts3.removeFileExtension(candidate);
          if (state.traceEnabled) {
            var extension = candidate.substring(extensionless.length);
            trace(state.host, ts3.Diagnostics.File_name_0_has_a_1_extension_stripping_it, candidate, extension);
          }
          return tryAddingExtensions(extensionless, extensions, onlyRecordFailures, state);
        }
      }
      function tryAddingExtensions(candidate, extensions, onlyRecordFailures, state) {
        if (!onlyRecordFailures) {
          var directory = ts3.getDirectoryPath(candidate);
          if (directory) {
            onlyRecordFailures = !ts3.directoryProbablyExists(directory, state.host);
          }
        }
        switch (extensions) {
          case Extensions.DtsOnly:
            return tryExtension(".d.ts");
          case Extensions.TypeScript:
            return tryExtension(".ts") || tryExtension(".tsx") || tryExtension(".d.ts");
          case Extensions.JavaScript:
            return tryExtension(".js") || tryExtension(".jsx");
          case Extensions.TSConfig:
          case Extensions.Json:
            return tryExtension(".json");
        }
        function tryExtension(ext) {
          var path2 = tryFile(candidate + ext, onlyRecordFailures, state);
          return path2 === void 0 ? void 0 : { path: path2, ext };
        }
      }
      function tryFile(fileName, onlyRecordFailures, state) {
        if (!onlyRecordFailures) {
          if (state.host.fileExists(fileName)) {
            if (state.traceEnabled) {
              trace(state.host, ts3.Diagnostics.File_0_exist_use_it_as_a_name_resolution_result, fileName);
            }
            return fileName;
          } else {
            if (state.traceEnabled) {
              trace(state.host, ts3.Diagnostics.File_0_does_not_exist, fileName);
            }
          }
        }
        state.failedLookupLocations.push(fileName);
        return void 0;
      }
      function loadNodeModuleFromDirectory(extensions, candidate, onlyRecordFailures, state, considerPackageJson) {
        if (considerPackageJson === void 0) {
          considerPackageJson = true;
        }
        var packageInfo = considerPackageJson ? getPackageJsonInfo(candidate, onlyRecordFailures, state) : void 0;
        var packageJsonContent = packageInfo && packageInfo.packageJsonContent;
        var versionPaths = packageInfo && packageInfo.versionPaths;
        return withPackageId(packageInfo, loadNodeModuleFromDirectoryWorker(extensions, candidate, onlyRecordFailures, state, packageJsonContent, versionPaths));
      }
      function getPackageJsonInfo(packageDirectory, onlyRecordFailures, state) {
        var _a2, _b, _c;
        var host = state.host, traceEnabled = state.traceEnabled;
        var packageJsonPath = ts3.combinePaths(packageDirectory, "package.json");
        if (onlyRecordFailures) {
          state.failedLookupLocations.push(packageJsonPath);
          return void 0;
        }
        var existing = (_a2 = state.packageJsonInfoCache) === null || _a2 === void 0 ? void 0 : _a2.getPackageJsonInfo(packageJsonPath);
        if (existing !== void 0) {
          if (typeof existing !== "boolean") {
            if (traceEnabled)
              trace(host, ts3.Diagnostics.File_0_exists_according_to_earlier_cached_lookups, packageJsonPath);
            return existing;
          } else {
            if (existing && traceEnabled)
              trace(host, ts3.Diagnostics.File_0_does_not_exist_according_to_earlier_cached_lookups, packageJsonPath);
            state.failedLookupLocations.push(packageJsonPath);
            return void 0;
          }
        }
        var directoryExists = ts3.directoryProbablyExists(packageDirectory, host);
        if (directoryExists && host.fileExists(packageJsonPath)) {
          var packageJsonContent = ts3.readJson(packageJsonPath, host);
          if (traceEnabled) {
            trace(host, ts3.Diagnostics.Found_package_json_at_0, packageJsonPath);
          }
          var versionPaths = readPackageJsonTypesVersionPaths(packageJsonContent, state);
          var result2 = { packageDirectory, packageJsonContent, versionPaths };
          (_b = state.packageJsonInfoCache) === null || _b === void 0 ? void 0 : _b.setPackageJsonInfo(packageJsonPath, result2);
          return result2;
        } else {
          if (directoryExists && traceEnabled) {
            trace(host, ts3.Diagnostics.File_0_does_not_exist, packageJsonPath);
          }
          (_c = state.packageJsonInfoCache) === null || _c === void 0 ? void 0 : _c.setPackageJsonInfo(packageJsonPath, directoryExists);
          state.failedLookupLocations.push(packageJsonPath);
        }
      }
      function loadNodeModuleFromDirectoryWorker(extensions, candidate, onlyRecordFailures, state, jsonContent, versionPaths) {
        var packageFile;
        if (jsonContent) {
          switch (extensions) {
            case Extensions.JavaScript:
            case Extensions.Json:
              packageFile = readPackageJsonMainField(jsonContent, candidate, state);
              break;
            case Extensions.TypeScript:
              packageFile = readPackageJsonTypesFields(jsonContent, candidate, state) || readPackageJsonMainField(jsonContent, candidate, state);
              break;
            case Extensions.DtsOnly:
              packageFile = readPackageJsonTypesFields(jsonContent, candidate, state);
              break;
            case Extensions.TSConfig:
              packageFile = readPackageJsonTSConfigField(jsonContent, candidate, state);
              break;
            default:
              return ts3.Debug.assertNever(extensions);
          }
        }
        var loader2 = function(extensions2, candidate2, onlyRecordFailures2, state2) {
          var fromFile = tryFile(candidate2, onlyRecordFailures2, state2);
          if (fromFile) {
            var resolved = resolvedIfExtensionMatches(extensions2, fromFile);
            if (resolved) {
              return noPackageId(resolved);
            }
            if (state2.traceEnabled) {
              trace(state2.host, ts3.Diagnostics.File_0_has_an_unsupported_extension_so_skipping_it, fromFile);
            }
          }
          var nextExtensions = extensions2 === Extensions.DtsOnly ? Extensions.TypeScript : extensions2;
          return nodeLoadModuleByRelativeName(nextExtensions, candidate2, onlyRecordFailures2, state2, false);
        };
        var onlyRecordFailuresForPackageFile = packageFile ? !ts3.directoryProbablyExists(ts3.getDirectoryPath(packageFile), state.host) : void 0;
        var onlyRecordFailuresForIndex = onlyRecordFailures || !ts3.directoryProbablyExists(candidate, state.host);
        var indexPath = ts3.combinePaths(candidate, extensions === Extensions.TSConfig ? "tsconfig" : "index");
        if (versionPaths && (!packageFile || ts3.containsPath(candidate, packageFile))) {
          var moduleName = ts3.getRelativePathFromDirectory(candidate, packageFile || indexPath, false);
          if (state.traceEnabled) {
            trace(state.host, ts3.Diagnostics.package_json_has_a_typesVersions_entry_0_that_matches_compiler_version_1_looking_for_a_pattern_to_match_module_name_2, versionPaths.version, ts3.version, moduleName);
          }
          var result2 = tryLoadModuleUsingPaths(extensions, moduleName, candidate, versionPaths.paths, loader2, onlyRecordFailuresForPackageFile || onlyRecordFailuresForIndex, state);
          if (result2) {
            return removeIgnoredPackageId(result2.value);
          }
        }
        var packageFileResult = packageFile && removeIgnoredPackageId(loader2(extensions, packageFile, onlyRecordFailuresForPackageFile, state));
        if (packageFileResult)
          return packageFileResult;
        return loadModuleFromFile(extensions, indexPath, onlyRecordFailuresForIndex, state);
      }
      function resolvedIfExtensionMatches(extensions, path2) {
        var ext = ts3.tryGetExtensionFromPath(path2);
        return ext !== void 0 && extensionIsOk(extensions, ext) ? { path: path2, ext } : void 0;
      }
      function extensionIsOk(extensions, extension) {
        switch (extensions) {
          case Extensions.JavaScript:
            return extension === ".js" || extension === ".jsx";
          case Extensions.TSConfig:
          case Extensions.Json:
            return extension === ".json";
          case Extensions.TypeScript:
            return extension === ".ts" || extension === ".tsx" || extension === ".d.ts";
          case Extensions.DtsOnly:
            return extension === ".d.ts";
        }
      }
      function parsePackageName(moduleName) {
        var idx = moduleName.indexOf(ts3.directorySeparator);
        if (moduleName[0] === "@") {
          idx = moduleName.indexOf(ts3.directorySeparator, idx + 1);
        }
        return idx === -1 ? { packageName: moduleName, rest: "" } : { packageName: moduleName.slice(0, idx), rest: moduleName.slice(idx + 1) };
      }
      ts3.parsePackageName = parsePackageName;
      function loadModuleFromNearestNodeModulesDirectory(extensions, moduleName, directory, state, cache, redirectedReference) {
        return loadModuleFromNearestNodeModulesDirectoryWorker(extensions, moduleName, directory, state, false, cache, redirectedReference);
      }
      function loadModuleFromNearestNodeModulesDirectoryTypesScope(moduleName, directory, state) {
        return loadModuleFromNearestNodeModulesDirectoryWorker(Extensions.DtsOnly, moduleName, directory, state, true, void 0, void 0);
      }
      function loadModuleFromNearestNodeModulesDirectoryWorker(extensions, moduleName, directory, state, typesScopeOnly, cache, redirectedReference) {
        var perModuleNameCache = cache && cache.getOrCreateCacheForModuleName(moduleName, redirectedReference);
        return ts3.forEachAncestorDirectory(ts3.normalizeSlashes(directory), function(ancestorDirectory) {
          if (ts3.getBaseFileName(ancestorDirectory) !== "node_modules") {
            var resolutionFromCache = tryFindNonRelativeModuleNameInCache(perModuleNameCache, moduleName, ancestorDirectory, state);
            if (resolutionFromCache) {
              return resolutionFromCache;
            }
            return toSearchResult(loadModuleFromImmediateNodeModulesDirectory(extensions, moduleName, ancestorDirectory, state, typesScopeOnly));
          }
        });
      }
      function loadModuleFromImmediateNodeModulesDirectory(extensions, moduleName, directory, state, typesScopeOnly) {
        var nodeModulesFolder = ts3.combinePaths(directory, "node_modules");
        var nodeModulesFolderExists = ts3.directoryProbablyExists(nodeModulesFolder, state.host);
        if (!nodeModulesFolderExists && state.traceEnabled) {
          trace(state.host, ts3.Diagnostics.Directory_0_does_not_exist_skipping_all_lookups_in_it, nodeModulesFolder);
        }
        var packageResult = typesScopeOnly ? void 0 : loadModuleFromSpecificNodeModulesDirectory(extensions, moduleName, nodeModulesFolder, nodeModulesFolderExists, state);
        if (packageResult) {
          return packageResult;
        }
        if (extensions === Extensions.TypeScript || extensions === Extensions.DtsOnly) {
          var nodeModulesAtTypes_1 = ts3.combinePaths(nodeModulesFolder, "@types");
          var nodeModulesAtTypesExists = nodeModulesFolderExists;
          if (nodeModulesFolderExists && !ts3.directoryProbablyExists(nodeModulesAtTypes_1, state.host)) {
            if (state.traceEnabled) {
              trace(state.host, ts3.Diagnostics.Directory_0_does_not_exist_skipping_all_lookups_in_it, nodeModulesAtTypes_1);
            }
            nodeModulesAtTypesExists = false;
          }
          return loadModuleFromSpecificNodeModulesDirectory(Extensions.DtsOnly, mangleScopedPackageNameWithTrace(moduleName, state), nodeModulesAtTypes_1, nodeModulesAtTypesExists, state);
        }
      }
      function loadModuleFromSpecificNodeModulesDirectory(extensions, moduleName, nodeModulesDirectory, nodeModulesDirectoryExists, state) {
        var candidate = ts3.normalizePath(ts3.combinePaths(nodeModulesDirectory, moduleName));
        var packageInfo = getPackageJsonInfo(candidate, !nodeModulesDirectoryExists, state);
        if (packageInfo) {
          var fromFile = loadModuleFromFile(extensions, candidate, !nodeModulesDirectoryExists, state);
          if (fromFile) {
            return noPackageId(fromFile);
          }
          var fromDirectory = loadNodeModuleFromDirectoryWorker(extensions, candidate, !nodeModulesDirectoryExists, state, packageInfo.packageJsonContent, packageInfo.versionPaths);
          return withPackageId(packageInfo, fromDirectory);
        }
        var loader2 = function(extensions2, candidate2, onlyRecordFailures, state2) {
          var pathAndExtension = loadModuleFromFile(extensions2, candidate2, onlyRecordFailures, state2) || loadNodeModuleFromDirectoryWorker(extensions2, candidate2, onlyRecordFailures, state2, packageInfo && packageInfo.packageJsonContent, packageInfo && packageInfo.versionPaths);
          return withPackageId(packageInfo, pathAndExtension);
        };
        var _a2 = parsePackageName(moduleName), packageName = _a2.packageName, rest = _a2.rest;
        if (rest !== "") {
          var packageDirectory = ts3.combinePaths(nodeModulesDirectory, packageName);
          packageInfo = getPackageJsonInfo(packageDirectory, !nodeModulesDirectoryExists, state);
          if (packageInfo && packageInfo.versionPaths) {
            if (state.traceEnabled) {
              trace(state.host, ts3.Diagnostics.package_json_has_a_typesVersions_entry_0_that_matches_compiler_version_1_looking_for_a_pattern_to_match_module_name_2, packageInfo.versionPaths.version, ts3.version, rest);
            }
            var packageDirectoryExists = nodeModulesDirectoryExists && ts3.directoryProbablyExists(packageDirectory, state.host);
            var fromPaths = tryLoadModuleUsingPaths(extensions, rest, packageDirectory, packageInfo.versionPaths.paths, loader2, !packageDirectoryExists, state);
            if (fromPaths) {
              return fromPaths.value;
            }
          }
        }
        return loader2(extensions, candidate, !nodeModulesDirectoryExists, state);
      }
      function tryLoadModuleUsingPaths(extensions, moduleName, baseDirectory, paths, loader2, onlyRecordFailures, state) {
        var matchedPattern = ts3.matchPatternOrExact(ts3.getOwnKeys(paths), moduleName);
        if (matchedPattern) {
          var matchedStar_1 = ts3.isString(matchedPattern) ? void 0 : ts3.matchedText(matchedPattern, moduleName);
          var matchedPatternText = ts3.isString(matchedPattern) ? matchedPattern : ts3.patternText(matchedPattern);
          if (state.traceEnabled) {
            trace(state.host, ts3.Diagnostics.Module_name_0_matched_pattern_1, moduleName, matchedPatternText);
          }
          var resolved = ts3.forEach(paths[matchedPatternText], function(subst) {
            var path2 = matchedStar_1 ? subst.replace("*", matchedStar_1) : subst;
            var candidate = ts3.normalizePath(ts3.combinePaths(baseDirectory, path2));
            if (state.traceEnabled) {
              trace(state.host, ts3.Diagnostics.Trying_substitution_0_candidate_module_location_Colon_1, subst, path2);
            }
            var extension = ts3.tryGetExtensionFromPath(subst);
            if (extension !== void 0) {
              var path_1 = tryFile(candidate, onlyRecordFailures, state);
              if (path_1 !== void 0) {
                return noPackageId({ path: path_1, ext: extension });
              }
            }
            return loader2(extensions, candidate, onlyRecordFailures || !ts3.directoryProbablyExists(ts3.getDirectoryPath(candidate), state.host), state);
          });
          return { value: resolved };
        }
      }
      var mangledScopedPackageSeparator = "__";
      function mangleScopedPackageNameWithTrace(packageName, state) {
        var mangled = mangleScopedPackageName(packageName);
        if (state.traceEnabled && mangled !== packageName) {
          trace(state.host, ts3.Diagnostics.Scoped_package_detected_looking_in_0, mangled);
        }
        return mangled;
      }
      function getTypesPackageName(packageName) {
        return "@types/" + mangleScopedPackageName(packageName);
      }
      ts3.getTypesPackageName = getTypesPackageName;
      function mangleScopedPackageName(packageName) {
        if (ts3.startsWith(packageName, "@")) {
          var replaceSlash = packageName.replace(ts3.directorySeparator, mangledScopedPackageSeparator);
          if (replaceSlash !== packageName) {
            return replaceSlash.slice(1);
          }
        }
        return packageName;
      }
      ts3.mangleScopedPackageName = mangleScopedPackageName;
      function getPackageNameFromTypesPackageName(mangledName) {
        var withoutAtTypePrefix = ts3.removePrefix(mangledName, "@types/");
        if (withoutAtTypePrefix !== mangledName) {
          return unmangleScopedPackageName(withoutAtTypePrefix);
        }
        return mangledName;
      }
      ts3.getPackageNameFromTypesPackageName = getPackageNameFromTypesPackageName;
      function unmangleScopedPackageName(typesPackageName) {
        return ts3.stringContains(typesPackageName, mangledScopedPackageSeparator) ? "@" + typesPackageName.replace(mangledScopedPackageSeparator, ts3.directorySeparator) : typesPackageName;
      }
      ts3.unmangleScopedPackageName = unmangleScopedPackageName;
      function tryFindNonRelativeModuleNameInCache(cache, moduleName, containingDirectory, state) {
        var result2 = cache && cache.get(containingDirectory);
        if (result2) {
          if (state.traceEnabled) {
            trace(state.host, ts3.Diagnostics.Resolution_for_module_0_was_found_in_cache_from_location_1, moduleName, containingDirectory);
          }
          state.resultFromCache = result2;
          return { value: result2.resolvedModule && { path: result2.resolvedModule.resolvedFileName, originalPath: result2.resolvedModule.originalPath || true, extension: result2.resolvedModule.extension, packageId: result2.resolvedModule.packageId } };
        }
      }
      function classicNameResolver(moduleName, containingFile, compilerOptions, host, cache, redirectedReference) {
        var traceEnabled = isTraceEnabled(compilerOptions, host);
        var failedLookupLocations = [];
        var state = { compilerOptions, host, traceEnabled, failedLookupLocations, packageJsonInfoCache: cache };
        var containingDirectory = ts3.getDirectoryPath(containingFile);
        var resolved = tryResolve(Extensions.TypeScript) || tryResolve(Extensions.JavaScript);
        return createResolvedModuleWithFailedLookupLocations(resolved && resolved.value, false, failedLookupLocations, state.resultFromCache);
        function tryResolve(extensions) {
          var resolvedUsingSettings = tryLoadModuleUsingOptionalResolutionSettings(extensions, moduleName, containingDirectory, loadModuleFromFileNoPackageId, state);
          if (resolvedUsingSettings) {
            return { value: resolvedUsingSettings };
          }
          if (!ts3.isExternalModuleNameRelative(moduleName)) {
            var perModuleNameCache_1 = cache && cache.getOrCreateCacheForModuleName(moduleName, redirectedReference);
            var resolved_3 = ts3.forEachAncestorDirectory(containingDirectory, function(directory) {
              var resolutionFromCache = tryFindNonRelativeModuleNameInCache(perModuleNameCache_1, moduleName, directory, state);
              if (resolutionFromCache) {
                return resolutionFromCache;
              }
              var searchName = ts3.normalizePath(ts3.combinePaths(directory, moduleName));
              return toSearchResult(loadModuleFromFileNoPackageId(extensions, searchName, false, state));
            });
            if (resolved_3) {
              return resolved_3;
            }
            if (extensions === Extensions.TypeScript) {
              return loadModuleFromNearestNodeModulesDirectoryTypesScope(moduleName, containingDirectory, state);
            }
          } else {
            var candidate = ts3.normalizePath(ts3.combinePaths(containingDirectory, moduleName));
            return toSearchResult(loadModuleFromFileNoPackageId(extensions, candidate, false, state));
          }
        }
      }
      ts3.classicNameResolver = classicNameResolver;
      function loadModuleFromGlobalCache(moduleName, projectName, compilerOptions, host, globalCache, packageJsonInfoCache) {
        var traceEnabled = isTraceEnabled(compilerOptions, host);
        if (traceEnabled) {
          trace(host, ts3.Diagnostics.Auto_discovery_for_typings_is_enabled_in_project_0_Running_extra_resolution_pass_for_module_1_using_cache_location_2, projectName, moduleName, globalCache);
        }
        var failedLookupLocations = [];
        var state = { compilerOptions, host, traceEnabled, failedLookupLocations, packageJsonInfoCache };
        var resolved = loadModuleFromImmediateNodeModulesDirectory(Extensions.DtsOnly, moduleName, globalCache, state, false);
        return createResolvedModuleWithFailedLookupLocations(resolved, true, failedLookupLocations, state.resultFromCache);
      }
      ts3.loadModuleFromGlobalCache = loadModuleFromGlobalCache;
      function toSearchResult(value) {
        return value !== void 0 ? { value } : void 0;
      }
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var ModuleInstanceState;
      (function(ModuleInstanceState2) {
        ModuleInstanceState2[ModuleInstanceState2["NonInstantiated"] = 0] = "NonInstantiated";
        ModuleInstanceState2[ModuleInstanceState2["Instantiated"] = 1] = "Instantiated";
        ModuleInstanceState2[ModuleInstanceState2["ConstEnumOnly"] = 2] = "ConstEnumOnly";
      })(ModuleInstanceState = ts3.ModuleInstanceState || (ts3.ModuleInstanceState = {}));
      function getModuleInstanceState(node, visited) {
        if (node.body && !node.body.parent) {
          ts3.setParent(node.body, node);
          ts3.setParentRecursive(node.body, false);
        }
        return node.body ? getModuleInstanceStateCached(node.body, visited) : 1;
      }
      ts3.getModuleInstanceState = getModuleInstanceState;
      function getModuleInstanceStateCached(node, visited) {
        if (visited === void 0) {
          visited = new ts3.Map();
        }
        var nodeId = ts3.getNodeId(node);
        if (visited.has(nodeId)) {
          return visited.get(nodeId) || 0;
        }
        visited.set(nodeId, void 0);
        var result2 = getModuleInstanceStateWorker(node, visited);
        visited.set(nodeId, result2);
        return result2;
      }
      function getModuleInstanceStateWorker(node, visited) {
        switch (node.kind) {
          case 254:
          case 255:
            return 0;
          case 256:
            if (ts3.isEnumConst(node)) {
              return 2;
            }
            break;
          case 262:
          case 261:
            if (!ts3.hasSyntacticModifier(node, 1)) {
              return 0;
            }
            break;
          case 268:
            var exportDeclaration = node;
            if (!exportDeclaration.moduleSpecifier && exportDeclaration.exportClause && exportDeclaration.exportClause.kind === 269) {
              var state = 0;
              for (var _i = 0, _a2 = exportDeclaration.exportClause.elements; _i < _a2.length; _i++) {
                var specifier = _a2[_i];
                var specifierState = getModuleInstanceStateForAliasTarget(specifier, visited);
                if (specifierState > state) {
                  state = specifierState;
                }
                if (state === 1) {
                  return state;
                }
              }
              return state;
            }
            break;
          case 258: {
            var state_1 = 0;
            ts3.forEachChild(node, function(n2) {
              var childState = getModuleInstanceStateCached(n2, visited);
              switch (childState) {
                case 0:
                  return;
                case 2:
                  state_1 = 2;
                  return;
                case 1:
                  state_1 = 1;
                  return true;
                default:
                  ts3.Debug.assertNever(childState);
              }
            });
            return state_1;
          }
          case 257:
            return getModuleInstanceState(node, visited);
          case 78:
            if (node.isInJSDocNamespace) {
              return 0;
            }
        }
        return 1;
      }
      function getModuleInstanceStateForAliasTarget(specifier, visited) {
        var name = specifier.propertyName || specifier.name;
        var p = specifier.parent;
        while (p) {
          if (ts3.isBlock(p) || ts3.isModuleBlock(p) || ts3.isSourceFile(p)) {
            var statements = p.statements;
            var found = void 0;
            for (var _i = 0, statements_2 = statements; _i < statements_2.length; _i++) {
              var statement = statements_2[_i];
              if (ts3.nodeHasName(statement, name)) {
                if (!statement.parent) {
                  ts3.setParent(statement, p);
                  ts3.setParentRecursive(statement, false);
                }
                var state = getModuleInstanceStateCached(statement, visited);
                if (found === void 0 || state > found) {
                  found = state;
                }
                if (found === 1) {
                  return found;
                }
              }
            }
            if (found !== void 0) {
              return found;
            }
          }
          p = p.parent;
        }
        return 1;
      }
      var ContainerFlags;
      (function(ContainerFlags2) {
        ContainerFlags2[ContainerFlags2["None"] = 0] = "None";
        ContainerFlags2[ContainerFlags2["IsContainer"] = 1] = "IsContainer";
        ContainerFlags2[ContainerFlags2["IsBlockScopedContainer"] = 2] = "IsBlockScopedContainer";
        ContainerFlags2[ContainerFlags2["IsControlFlowContainer"] = 4] = "IsControlFlowContainer";
        ContainerFlags2[ContainerFlags2["IsFunctionLike"] = 8] = "IsFunctionLike";
        ContainerFlags2[ContainerFlags2["IsFunctionExpression"] = 16] = "IsFunctionExpression";
        ContainerFlags2[ContainerFlags2["HasLocals"] = 32] = "HasLocals";
        ContainerFlags2[ContainerFlags2["IsInterface"] = 64] = "IsInterface";
        ContainerFlags2[ContainerFlags2["IsObjectLiteralOrClassExpressionMethod"] = 128] = "IsObjectLiteralOrClassExpressionMethod";
      })(ContainerFlags || (ContainerFlags = {}));
      function initFlowNode(node) {
        ts3.Debug.attachFlowNodeDebugInfo(node);
        return node;
      }
      var binder = createBinder();
      function bindSourceFile(file, options) {
        ts3.tracing === null || ts3.tracing === void 0 ? void 0 : ts3.tracing.push("bind", "bindSourceFile", { path: file.path }, true);
        ts3.performance.mark("beforeBind");
        ts3.perfLogger.logStartBindFile("" + file.fileName);
        binder(file, options);
        ts3.perfLogger.logStopBindFile();
        ts3.performance.mark("afterBind");
        ts3.performance.measure("Bind", "beforeBind", "afterBind");
        ts3.tracing === null || ts3.tracing === void 0 ? void 0 : ts3.tracing.pop();
      }
      ts3.bindSourceFile = bindSourceFile;
      function createBinder() {
        var file;
        var options;
        var languageVersion;
        var parent;
        var container;
        var thisParentContainer;
        var blockScopeContainer;
        var lastContainer;
        var delayedTypeAliases;
        var seenThisKeyword;
        var currentFlow;
        var currentBreakTarget;
        var currentContinueTarget;
        var currentReturnTarget;
        var currentTrueTarget;
        var currentFalseTarget;
        var currentExceptionTarget;
        var preSwitchCaseFlow;
        var activeLabelList;
        var hasExplicitReturn;
        var emitFlags;
        var inStrictMode;
        var inAssignmentPattern = false;
        var symbolCount = 0;
        var Symbol2;
        var classifiableNames;
        var unreachableFlow = { flags: 1 };
        var reportedUnreachableFlow = { flags: 1 };
        var bindBinaryExpressionFlow = createBindBinaryExpressionFlow();
        function createDiagnosticForNode(node, message, arg0, arg1, arg2) {
          return ts3.createDiagnosticForNodeInSourceFile(ts3.getSourceFileOfNode(node) || file, node, message, arg0, arg1, arg2);
        }
        function bindSourceFile2(f, opts) {
          file = f;
          options = opts;
          languageVersion = ts3.getEmitScriptTarget(options);
          inStrictMode = bindInStrictMode(file, opts);
          classifiableNames = new ts3.Set();
          symbolCount = 0;
          Symbol2 = ts3.objectAllocator.getSymbolConstructor();
          ts3.Debug.attachFlowNodeDebugInfo(unreachableFlow);
          ts3.Debug.attachFlowNodeDebugInfo(reportedUnreachableFlow);
          if (!file.locals) {
            bind(file);
            file.symbolCount = symbolCount;
            file.classifiableNames = classifiableNames;
            delayedBindJSDocTypedefTag();
          }
          file = void 0;
          options = void 0;
          languageVersion = void 0;
          parent = void 0;
          container = void 0;
          thisParentContainer = void 0;
          blockScopeContainer = void 0;
          lastContainer = void 0;
          delayedTypeAliases = void 0;
          seenThisKeyword = false;
          currentFlow = void 0;
          currentBreakTarget = void 0;
          currentContinueTarget = void 0;
          currentReturnTarget = void 0;
          currentTrueTarget = void 0;
          currentFalseTarget = void 0;
          currentExceptionTarget = void 0;
          activeLabelList = void 0;
          hasExplicitReturn = false;
          inAssignmentPattern = false;
          emitFlags = 0;
        }
        return bindSourceFile2;
        function bindInStrictMode(file2, opts) {
          if (ts3.getStrictOptionValue(opts, "alwaysStrict") && !file2.isDeclarationFile) {
            return true;
          } else {
            return !!file2.externalModuleIndicator;
          }
        }
        function createSymbol(flags, name) {
          symbolCount++;
          return new Symbol2(flags, name);
        }
        function addDeclarationToSymbol(symbol, node, symbolFlags) {
          symbol.flags |= symbolFlags;
          node.symbol = symbol;
          symbol.declarations = ts3.appendIfUnique(symbol.declarations, node);
          if (symbolFlags & (32 | 384 | 1536 | 3) && !symbol.exports) {
            symbol.exports = ts3.createSymbolTable();
          }
          if (symbolFlags & (32 | 64 | 2048 | 4096) && !symbol.members) {
            symbol.members = ts3.createSymbolTable();
          }
          if (symbol.constEnumOnlyModule && symbol.flags & (16 | 32 | 256)) {
            symbol.constEnumOnlyModule = false;
          }
          if (symbolFlags & 111551) {
            ts3.setValueDeclaration(symbol, node);
          }
        }
        function getDeclarationName(node) {
          if (node.kind === 267) {
            return node.isExportEquals ? "export=" : "default";
          }
          var name = ts3.getNameOfDeclaration(node);
          if (name) {
            if (ts3.isAmbientModule(node)) {
              var moduleName = ts3.getTextOfIdentifierOrLiteral(name);
              return ts3.isGlobalScopeAugmentation(node) ? "__global" : '"' + moduleName + '"';
            }
            if (name.kind === 159) {
              var nameExpression = name.expression;
              if (ts3.isStringOrNumericLiteralLike(nameExpression)) {
                return ts3.escapeLeadingUnderscores(nameExpression.text);
              }
              if (ts3.isSignedNumericLiteral(nameExpression)) {
                return ts3.tokenToString(nameExpression.operator) + nameExpression.operand.text;
              } else {
                ts3.Debug.fail("Only computed properties with literal names have declaration names");
              }
            }
            if (ts3.isPrivateIdentifier(name)) {
              var containingClass = ts3.getContainingClass(node);
              if (!containingClass) {
                return void 0;
              }
              var containingClassSymbol = containingClass.symbol;
              return ts3.getSymbolNameForPrivateIdentifier(containingClassSymbol, name.escapedText);
            }
            return ts3.isPropertyNameLiteral(name) ? ts3.getEscapedTextOfIdentifierOrLiteral(name) : void 0;
          }
          switch (node.kind) {
            case 167:
              return "__constructor";
            case 175:
            case 170:
            case 315:
              return "__call";
            case 176:
            case 171:
              return "__new";
            case 172:
              return "__index";
            case 268:
              return "__export";
            case 298:
              return "export=";
            case 217:
              if (ts3.getAssignmentDeclarationKind(node) === 2) {
                return "export=";
              }
              ts3.Debug.fail("Unknown binary declaration kind");
              break;
            case 309:
              return ts3.isJSDocConstructSignature(node) ? "__new" : "__call";
            case 161:
              ts3.Debug.assert(node.parent.kind === 309, "Impossible parameter parent kind", function() {
                return "parent is: " + (ts3.SyntaxKind ? ts3.SyntaxKind[node.parent.kind] : node.parent.kind) + ", expected JSDocFunctionType";
              });
              var functionType = node.parent;
              var index = functionType.parameters.indexOf(node);
              return "arg" + index;
          }
        }
        function getDisplayName(node) {
          return ts3.isNamedDeclaration(node) ? ts3.declarationNameToString(node.name) : ts3.unescapeLeadingUnderscores(ts3.Debug.checkDefined(getDeclarationName(node)));
        }
        function declareSymbol(symbolTable, parent2, node, includes, excludes, isReplaceableByMethod) {
          ts3.Debug.assert(!ts3.hasDynamicName(node));
          var isDefaultExport = ts3.hasSyntacticModifier(node, 512) || ts3.isExportSpecifier(node) && node.name.escapedText === "default";
          var name = isDefaultExport && parent2 ? "default" : getDeclarationName(node);
          var symbol;
          if (name === void 0) {
            symbol = createSymbol(0, "__missing");
          } else {
            symbol = symbolTable.get(name);
            if (includes & 2885600) {
              classifiableNames.add(name);
            }
            if (!symbol) {
              symbolTable.set(name, symbol = createSymbol(0, name));
              if (isReplaceableByMethod)
                symbol.isReplaceableByMethod = true;
            } else if (isReplaceableByMethod && !symbol.isReplaceableByMethod) {
              return symbol;
            } else if (symbol.flags & excludes) {
              if (symbol.isReplaceableByMethod) {
                symbolTable.set(name, symbol = createSymbol(0, name));
              } else if (!(includes & 3 && symbol.flags & 67108864)) {
                if (ts3.isNamedDeclaration(node)) {
                  ts3.setParent(node.name, node);
                }
                var message_1 = symbol.flags & 2 ? ts3.Diagnostics.Cannot_redeclare_block_scoped_variable_0 : ts3.Diagnostics.Duplicate_identifier_0;
                var messageNeedsName_1 = true;
                if (symbol.flags & 384 || includes & 384) {
                  message_1 = ts3.Diagnostics.Enum_declarations_can_only_merge_with_namespace_or_other_enum_declarations;
                  messageNeedsName_1 = false;
                }
                var multipleDefaultExports_1 = false;
                if (ts3.length(symbol.declarations)) {
                  if (isDefaultExport) {
                    message_1 = ts3.Diagnostics.A_module_cannot_have_multiple_default_exports;
                    messageNeedsName_1 = false;
                    multipleDefaultExports_1 = true;
                  } else {
                    if (symbol.declarations && symbol.declarations.length && (node.kind === 267 && !node.isExportEquals)) {
                      message_1 = ts3.Diagnostics.A_module_cannot_have_multiple_default_exports;
                      messageNeedsName_1 = false;
                      multipleDefaultExports_1 = true;
                    }
                  }
                }
                var relatedInformation_1 = [];
                if (ts3.isTypeAliasDeclaration(node) && ts3.nodeIsMissing(node.type) && ts3.hasSyntacticModifier(node, 1) && symbol.flags & (2097152 | 788968 | 1920)) {
                  relatedInformation_1.push(createDiagnosticForNode(node, ts3.Diagnostics.Did_you_mean_0, "export type { " + ts3.unescapeLeadingUnderscores(node.name.escapedText) + " }"));
                }
                var declarationName_1 = ts3.getNameOfDeclaration(node) || node;
                ts3.forEach(symbol.declarations, function(declaration, index) {
                  var decl = ts3.getNameOfDeclaration(declaration) || declaration;
                  var diag2 = createDiagnosticForNode(decl, message_1, messageNeedsName_1 ? getDisplayName(declaration) : void 0);
                  file.bindDiagnostics.push(multipleDefaultExports_1 ? ts3.addRelatedInfo(diag2, createDiagnosticForNode(declarationName_1, index === 0 ? ts3.Diagnostics.Another_export_default_is_here : ts3.Diagnostics.and_here)) : diag2);
                  if (multipleDefaultExports_1) {
                    relatedInformation_1.push(createDiagnosticForNode(decl, ts3.Diagnostics.The_first_export_default_is_here));
                  }
                });
                var diag = createDiagnosticForNode(declarationName_1, message_1, messageNeedsName_1 ? getDisplayName(node) : void 0);
                file.bindDiagnostics.push(ts3.addRelatedInfo.apply(void 0, __spreadArray([diag], relatedInformation_1)));
                symbol = createSymbol(0, name);
              }
            }
          }
          addDeclarationToSymbol(symbol, node, includes);
          if (symbol.parent) {
            ts3.Debug.assert(symbol.parent === parent2, "Existing symbol parent should match new one");
          } else {
            symbol.parent = parent2;
          }
          return symbol;
        }
        function declareModuleMember(node, symbolFlags, symbolExcludes) {
          var hasExportModifier = !!(ts3.getCombinedModifierFlags(node) & 1) || jsdocTreatAsExported(node);
          if (symbolFlags & 2097152) {
            if (node.kind === 271 || node.kind === 261 && hasExportModifier) {
              return declareSymbol(container.symbol.exports, container.symbol, node, symbolFlags, symbolExcludes);
            } else {
              return declareSymbol(container.locals, void 0, node, symbolFlags, symbolExcludes);
            }
          } else {
            if (ts3.isJSDocTypeAlias(node))
              ts3.Debug.assert(ts3.isInJSFile(node));
            if (!ts3.isAmbientModule(node) && (hasExportModifier || container.flags & 64)) {
              if (!container.locals || ts3.hasSyntacticModifier(node, 512) && !getDeclarationName(node)) {
                return declareSymbol(container.symbol.exports, container.symbol, node, symbolFlags, symbolExcludes);
              }
              var exportKind = symbolFlags & 111551 ? 1048576 : 0;
              var local = declareSymbol(container.locals, void 0, node, exportKind, symbolExcludes);
              local.exportSymbol = declareSymbol(container.symbol.exports, container.symbol, node, symbolFlags, symbolExcludes);
              node.localSymbol = local;
              return local;
            } else {
              return declareSymbol(container.locals, void 0, node, symbolFlags, symbolExcludes);
            }
          }
        }
        function jsdocTreatAsExported(node) {
          if (node.parent && ts3.isModuleDeclaration(node)) {
            node = node.parent;
          }
          if (!ts3.isJSDocTypeAlias(node))
            return false;
          if (!ts3.isJSDocEnumTag(node) && !!node.fullName)
            return true;
          var declName = ts3.getNameOfDeclaration(node);
          if (!declName)
            return false;
          if (ts3.isPropertyAccessEntityNameExpression(declName.parent) && isTopLevelNamespaceAssignment(declName.parent))
            return true;
          if (ts3.isDeclaration(declName.parent) && ts3.getCombinedModifierFlags(declName.parent) & 1)
            return true;
          return false;
        }
        function bindContainer(node, containerFlags) {
          var saveContainer = container;
          var saveThisParentContainer = thisParentContainer;
          var savedBlockScopeContainer = blockScopeContainer;
          if (containerFlags & 1) {
            if (node.kind !== 210) {
              thisParentContainer = container;
            }
            container = blockScopeContainer = node;
            if (containerFlags & 32) {
              container.locals = ts3.createSymbolTable();
            }
            addToContainerChain(container);
          } else if (containerFlags & 2) {
            blockScopeContainer = node;
            blockScopeContainer.locals = void 0;
          }
          if (containerFlags & 4) {
            var saveCurrentFlow = currentFlow;
            var saveBreakTarget = currentBreakTarget;
            var saveContinueTarget = currentContinueTarget;
            var saveReturnTarget = currentReturnTarget;
            var saveExceptionTarget = currentExceptionTarget;
            var saveActiveLabelList = activeLabelList;
            var saveHasExplicitReturn = hasExplicitReturn;
            var isIIFE = containerFlags & 16 && !ts3.hasSyntacticModifier(node, 256) && !node.asteriskToken && !!ts3.getImmediatelyInvokedFunctionExpression(node);
            if (!isIIFE) {
              currentFlow = initFlowNode({ flags: 2 });
              if (containerFlags & (16 | 128)) {
                currentFlow.node = node;
              }
            }
            currentReturnTarget = isIIFE || node.kind === 167 || ts3.isInJSFile(node) && (node.kind === 252 || node.kind === 209) ? createBranchLabel() : void 0;
            currentExceptionTarget = void 0;
            currentBreakTarget = void 0;
            currentContinueTarget = void 0;
            activeLabelList = void 0;
            hasExplicitReturn = false;
            bindChildren(node);
            node.flags &= ~2816;
            if (!(currentFlow.flags & 1) && containerFlags & 8 && ts3.nodeIsPresent(node.body)) {
              node.flags |= 256;
              if (hasExplicitReturn)
                node.flags |= 512;
              node.endFlowNode = currentFlow;
            }
            if (node.kind === 298) {
              node.flags |= emitFlags;
              node.endFlowNode = currentFlow;
            }
            if (currentReturnTarget) {
              addAntecedent(currentReturnTarget, currentFlow);
              currentFlow = finishFlowLabel(currentReturnTarget);
              if (node.kind === 167 || ts3.isInJSFile(node) && (node.kind === 252 || node.kind === 209)) {
                node.returnFlowNode = currentFlow;
              }
            }
            if (!isIIFE) {
              currentFlow = saveCurrentFlow;
            }
            currentBreakTarget = saveBreakTarget;
            currentContinueTarget = saveContinueTarget;
            currentReturnTarget = saveReturnTarget;
            currentExceptionTarget = saveExceptionTarget;
            activeLabelList = saveActiveLabelList;
            hasExplicitReturn = saveHasExplicitReturn;
          } else if (containerFlags & 64) {
            seenThisKeyword = false;
            bindChildren(node);
            node.flags = seenThisKeyword ? node.flags | 128 : node.flags & ~128;
          } else {
            bindChildren(node);
          }
          container = saveContainer;
          thisParentContainer = saveThisParentContainer;
          blockScopeContainer = savedBlockScopeContainer;
        }
        function bindEachFunctionsFirst(nodes) {
          bindEach(nodes, function(n2) {
            return n2.kind === 252 ? bind(n2) : void 0;
          });
          bindEach(nodes, function(n2) {
            return n2.kind !== 252 ? bind(n2) : void 0;
          });
        }
        function bindEach(nodes, bindFunction) {
          if (bindFunction === void 0) {
            bindFunction = bind;
          }
          if (nodes === void 0) {
            return;
          }
          ts3.forEach(nodes, bindFunction);
        }
        function bindEachChild(node) {
          ts3.forEachChild(node, bind, bindEach);
        }
        function bindChildren(node) {
          var saveInAssignmentPattern = inAssignmentPattern;
          inAssignmentPattern = false;
          if (checkUnreachable(node)) {
            bindEachChild(node);
            bindJSDoc(node);
            inAssignmentPattern = saveInAssignmentPattern;
            return;
          }
          if (node.kind >= 233 && node.kind <= 249 && !options.allowUnreachableCode) {
            node.flowNode = currentFlow;
          }
          switch (node.kind) {
            case 237:
              bindWhileStatement(node);
              break;
            case 236:
              bindDoStatement(node);
              break;
            case 238:
              bindForStatement(node);
              break;
            case 239:
            case 240:
              bindForInOrForOfStatement(node);
              break;
            case 235:
              bindIfStatement(node);
              break;
            case 243:
            case 247:
              bindReturnOrThrow(node);
              break;
            case 242:
            case 241:
              bindBreakOrContinueStatement(node);
              break;
            case 248:
              bindTryStatement(node);
              break;
            case 245:
              bindSwitchStatement(node);
              break;
            case 259:
              bindCaseBlock(node);
              break;
            case 285:
              bindCaseClause(node);
              break;
            case 234:
              bindExpressionStatement(node);
              break;
            case 246:
              bindLabeledStatement(node);
              break;
            case 215:
              bindPrefixUnaryExpressionFlow(node);
              break;
            case 216:
              bindPostfixUnaryExpressionFlow(node);
              break;
            case 217:
              if (ts3.isDestructuringAssignment(node)) {
                inAssignmentPattern = saveInAssignmentPattern;
                bindDestructuringAssignmentFlow(node);
                return;
              }
              bindBinaryExpressionFlow(node);
              break;
            case 211:
              bindDeleteExpressionFlow(node);
              break;
            case 218:
              bindConditionalExpressionFlow(node);
              break;
            case 250:
              bindVariableDeclarationFlow(node);
              break;
            case 202:
            case 203:
              bindAccessExpressionFlow(node);
              break;
            case 204:
              bindCallExpressionFlow(node);
              break;
            case 226:
              bindNonNullExpressionFlow(node);
              break;
            case 335:
            case 328:
            case 329:
              bindJSDocTypeAlias(node);
              break;
            case 298: {
              bindEachFunctionsFirst(node.statements);
              bind(node.endOfFileToken);
              break;
            }
            case 231:
            case 258:
              bindEachFunctionsFirst(node.statements);
              break;
            case 199:
              bindBindingElementFlow(node);
              break;
            case 201:
            case 200:
            case 289:
            case 221:
              inAssignmentPattern = saveInAssignmentPattern;
            default:
              bindEachChild(node);
              break;
          }
          bindJSDoc(node);
          inAssignmentPattern = saveInAssignmentPattern;
        }
        function isNarrowingExpression(expr) {
          switch (expr.kind) {
            case 78:
            case 79:
            case 107:
            case 202:
            case 203:
              return containsNarrowableReference(expr);
            case 204:
              return hasNarrowableArgument(expr);
            case 208:
            case 226:
              return isNarrowingExpression(expr.expression);
            case 217:
              return isNarrowingBinaryExpression(expr);
            case 215:
              return expr.operator === 53 && isNarrowingExpression(expr.operand);
            case 212:
              return isNarrowingExpression(expr.expression);
          }
          return false;
        }
        function isNarrowableReference(expr) {
          return ts3.isDottedName(expr) || (ts3.isPropertyAccessExpression(expr) || ts3.isNonNullExpression(expr) || ts3.isParenthesizedExpression(expr)) && isNarrowableReference(expr.expression) || ts3.isBinaryExpression(expr) && expr.operatorToken.kind === 27 && isNarrowableReference(expr.right) || ts3.isElementAccessExpression(expr) && ts3.isStringOrNumericLiteralLike(expr.argumentExpression) && isNarrowableReference(expr.expression) || ts3.isAssignmentExpression(expr) && isNarrowableReference(expr.left);
        }
        function containsNarrowableReference(expr) {
          return isNarrowableReference(expr) || ts3.isOptionalChain(expr) && containsNarrowableReference(expr.expression);
        }
        function hasNarrowableArgument(expr) {
          if (expr.arguments) {
            for (var _i = 0, _a2 = expr.arguments; _i < _a2.length; _i++) {
              var argument = _a2[_i];
              if (containsNarrowableReference(argument)) {
                return true;
              }
            }
          }
          if (expr.expression.kind === 202 && containsNarrowableReference(expr.expression.expression)) {
            return true;
          }
          return false;
        }
        function isNarrowingTypeofOperands(expr1, expr2) {
          return ts3.isTypeOfExpression(expr1) && isNarrowableOperand(expr1.expression) && ts3.isStringLiteralLike(expr2);
        }
        function isNarrowableInOperands(left, right) {
          return ts3.isStringLiteralLike(left) && isNarrowingExpression(right);
        }
        function isNarrowingBinaryExpression(expr) {
          switch (expr.operatorToken.kind) {
            case 62:
            case 74:
            case 75:
            case 76:
              return containsNarrowableReference(expr.left);
            case 34:
            case 35:
            case 36:
            case 37:
              return isNarrowableOperand(expr.left) || isNarrowableOperand(expr.right) || isNarrowingTypeofOperands(expr.right, expr.left) || isNarrowingTypeofOperands(expr.left, expr.right);
            case 101:
              return isNarrowableOperand(expr.left);
            case 100:
              return isNarrowableInOperands(expr.left, expr.right);
            case 27:
              return isNarrowingExpression(expr.right);
          }
          return false;
        }
        function isNarrowableOperand(expr) {
          switch (expr.kind) {
            case 208:
              return isNarrowableOperand(expr.expression);
            case 217:
              switch (expr.operatorToken.kind) {
                case 62:
                  return isNarrowableOperand(expr.left);
                case 27:
                  return isNarrowableOperand(expr.right);
              }
          }
          return containsNarrowableReference(expr);
        }
        function createBranchLabel() {
          return initFlowNode({ flags: 4, antecedents: void 0 });
        }
        function createLoopLabel() {
          return initFlowNode({ flags: 8, antecedents: void 0 });
        }
        function createReduceLabel(target, antecedents, antecedent) {
          return initFlowNode({ flags: 1024, target, antecedents, antecedent });
        }
        function setFlowNodeReferenced(flow) {
          flow.flags |= flow.flags & 2048 ? 4096 : 2048;
        }
        function addAntecedent(label, antecedent) {
          if (!(antecedent.flags & 1) && !ts3.contains(label.antecedents, antecedent)) {
            (label.antecedents || (label.antecedents = [])).push(antecedent);
            setFlowNodeReferenced(antecedent);
          }
        }
        function createFlowCondition(flags, antecedent, expression) {
          if (antecedent.flags & 1) {
            return antecedent;
          }
          if (!expression) {
            return flags & 32 ? antecedent : unreachableFlow;
          }
          if ((expression.kind === 109 && flags & 64 || expression.kind === 94 && flags & 32) && !ts3.isExpressionOfOptionalChainRoot(expression) && !ts3.isNullishCoalesce(expression.parent)) {
            return unreachableFlow;
          }
          if (!isNarrowingExpression(expression)) {
            return antecedent;
          }
          setFlowNodeReferenced(antecedent);
          return initFlowNode({ flags, antecedent, node: expression });
        }
        function createFlowSwitchClause(antecedent, switchStatement, clauseStart, clauseEnd) {
          setFlowNodeReferenced(antecedent);
          return initFlowNode({ flags: 128, antecedent, switchStatement, clauseStart, clauseEnd });
        }
        function createFlowMutation(flags, antecedent, node) {
          setFlowNodeReferenced(antecedent);
          var result2 = initFlowNode({ flags, antecedent, node });
          if (currentExceptionTarget) {
            addAntecedent(currentExceptionTarget, result2);
          }
          return result2;
        }
        function createFlowCall(antecedent, node) {
          setFlowNodeReferenced(antecedent);
          return initFlowNode({ flags: 512, antecedent, node });
        }
        function finishFlowLabel(flow) {
          var antecedents = flow.antecedents;
          if (!antecedents) {
            return unreachableFlow;
          }
          if (antecedents.length === 1) {
            return antecedents[0];
          }
          return flow;
        }
        function isStatementCondition(node) {
          var parent2 = node.parent;
          switch (parent2.kind) {
            case 235:
            case 237:
            case 236:
              return parent2.expression === node;
            case 238:
            case 218:
              return parent2.condition === node;
          }
          return false;
        }
        function isLogicalExpression(node) {
          while (true) {
            if (node.kind === 208) {
              node = node.expression;
            } else if (node.kind === 215 && node.operator === 53) {
              node = node.operand;
            } else {
              return node.kind === 217 && (node.operatorToken.kind === 55 || node.operatorToken.kind === 56 || node.operatorToken.kind === 60);
            }
          }
        }
        function isLogicalAssignmentExpression(node) {
          node = ts3.skipParentheses(node);
          return ts3.isBinaryExpression(node) && ts3.isLogicalOrCoalescingAssignmentOperator(node.operatorToken.kind);
        }
        function isTopLevelLogicalExpression(node) {
          while (ts3.isParenthesizedExpression(node.parent) || ts3.isPrefixUnaryExpression(node.parent) && node.parent.operator === 53) {
            node = node.parent;
          }
          return !isStatementCondition(node) && !isLogicalAssignmentExpression(node.parent) && !isLogicalExpression(node.parent) && !(ts3.isOptionalChain(node.parent) && node.parent.expression === node);
        }
        function doWithConditionalBranches(action, value, trueTarget, falseTarget) {
          var savedTrueTarget = currentTrueTarget;
          var savedFalseTarget = currentFalseTarget;
          currentTrueTarget = trueTarget;
          currentFalseTarget = falseTarget;
          action(value);
          currentTrueTarget = savedTrueTarget;
          currentFalseTarget = savedFalseTarget;
        }
        function bindCondition(node, trueTarget, falseTarget) {
          doWithConditionalBranches(bind, node, trueTarget, falseTarget);
          if (!node || !isLogicalAssignmentExpression(node) && !isLogicalExpression(node) && !(ts3.isOptionalChain(node) && ts3.isOutermostOptionalChain(node))) {
            addAntecedent(trueTarget, createFlowCondition(32, currentFlow, node));
            addAntecedent(falseTarget, createFlowCondition(64, currentFlow, node));
          }
        }
        function bindIterativeStatement(node, breakTarget, continueTarget) {
          var saveBreakTarget = currentBreakTarget;
          var saveContinueTarget = currentContinueTarget;
          currentBreakTarget = breakTarget;
          currentContinueTarget = continueTarget;
          bind(node);
          currentBreakTarget = saveBreakTarget;
          currentContinueTarget = saveContinueTarget;
        }
        function setContinueTarget(node, target) {
          var label = activeLabelList;
          while (label && node.parent.kind === 246) {
            label.continueTarget = target;
            label = label.next;
            node = node.parent;
          }
          return target;
        }
        function bindWhileStatement(node) {
          var preWhileLabel = setContinueTarget(node, createLoopLabel());
          var preBodyLabel = createBranchLabel();
          var postWhileLabel = createBranchLabel();
          addAntecedent(preWhileLabel, currentFlow);
          currentFlow = preWhileLabel;
          bindCondition(node.expression, preBodyLabel, postWhileLabel);
          currentFlow = finishFlowLabel(preBodyLabel);
          bindIterativeStatement(node.statement, postWhileLabel, preWhileLabel);
          addAntecedent(preWhileLabel, currentFlow);
          currentFlow = finishFlowLabel(postWhileLabel);
        }
        function bindDoStatement(node) {
          var preDoLabel = createLoopLabel();
          var preConditionLabel = setContinueTarget(node, createBranchLabel());
          var postDoLabel = createBranchLabel();
          addAntecedent(preDoLabel, currentFlow);
          currentFlow = preDoLabel;
          bindIterativeStatement(node.statement, postDoLabel, preConditionLabel);
          addAntecedent(preConditionLabel, currentFlow);
          currentFlow = finishFlowLabel(preConditionLabel);
          bindCondition(node.expression, preDoLabel, postDoLabel);
          currentFlow = finishFlowLabel(postDoLabel);
        }
        function bindForStatement(node) {
          var preLoopLabel = setContinueTarget(node, createLoopLabel());
          var preBodyLabel = createBranchLabel();
          var postLoopLabel = createBranchLabel();
          bind(node.initializer);
          addAntecedent(preLoopLabel, currentFlow);
          currentFlow = preLoopLabel;
          bindCondition(node.condition, preBodyLabel, postLoopLabel);
          currentFlow = finishFlowLabel(preBodyLabel);
          bindIterativeStatement(node.statement, postLoopLabel, preLoopLabel);
          bind(node.incrementor);
          addAntecedent(preLoopLabel, currentFlow);
          currentFlow = finishFlowLabel(postLoopLabel);
        }
        function bindForInOrForOfStatement(node) {
          var preLoopLabel = setContinueTarget(node, createLoopLabel());
          var postLoopLabel = createBranchLabel();
          bind(node.expression);
          addAntecedent(preLoopLabel, currentFlow);
          currentFlow = preLoopLabel;
          if (node.kind === 240) {
            bind(node.awaitModifier);
          }
          addAntecedent(postLoopLabel, currentFlow);
          bind(node.initializer);
          if (node.initializer.kind !== 251) {
            bindAssignmentTargetFlow(node.initializer);
          }
          bindIterativeStatement(node.statement, postLoopLabel, preLoopLabel);
          addAntecedent(preLoopLabel, currentFlow);
          currentFlow = finishFlowLabel(postLoopLabel);
        }
        function bindIfStatement(node) {
          var thenLabel = createBranchLabel();
          var elseLabel = createBranchLabel();
          var postIfLabel = createBranchLabel();
          bindCondition(node.expression, thenLabel, elseLabel);
          currentFlow = finishFlowLabel(thenLabel);
          bind(node.thenStatement);
          addAntecedent(postIfLabel, currentFlow);
          currentFlow = finishFlowLabel(elseLabel);
          bind(node.elseStatement);
          addAntecedent(postIfLabel, currentFlow);
          currentFlow = finishFlowLabel(postIfLabel);
        }
        function bindReturnOrThrow(node) {
          bind(node.expression);
          if (node.kind === 243) {
            hasExplicitReturn = true;
            if (currentReturnTarget) {
              addAntecedent(currentReturnTarget, currentFlow);
            }
          }
          currentFlow = unreachableFlow;
        }
        function findActiveLabel(name) {
          for (var label = activeLabelList; label; label = label.next) {
            if (label.name === name) {
              return label;
            }
          }
          return void 0;
        }
        function bindBreakOrContinueFlow(node, breakTarget, continueTarget) {
          var flowLabel = node.kind === 242 ? breakTarget : continueTarget;
          if (flowLabel) {
            addAntecedent(flowLabel, currentFlow);
            currentFlow = unreachableFlow;
          }
        }
        function bindBreakOrContinueStatement(node) {
          bind(node.label);
          if (node.label) {
            var activeLabel = findActiveLabel(node.label.escapedText);
            if (activeLabel) {
              activeLabel.referenced = true;
              bindBreakOrContinueFlow(node, activeLabel.breakTarget, activeLabel.continueTarget);
            }
          } else {
            bindBreakOrContinueFlow(node, currentBreakTarget, currentContinueTarget);
          }
        }
        function bindTryStatement(node) {
          var saveReturnTarget = currentReturnTarget;
          var saveExceptionTarget = currentExceptionTarget;
          var normalExitLabel = createBranchLabel();
          var returnLabel = createBranchLabel();
          var exceptionLabel = createBranchLabel();
          if (node.finallyBlock) {
            currentReturnTarget = returnLabel;
          }
          addAntecedent(exceptionLabel, currentFlow);
          currentExceptionTarget = exceptionLabel;
          bind(node.tryBlock);
          addAntecedent(normalExitLabel, currentFlow);
          if (node.catchClause) {
            currentFlow = finishFlowLabel(exceptionLabel);
            exceptionLabel = createBranchLabel();
            addAntecedent(exceptionLabel, currentFlow);
            currentExceptionTarget = exceptionLabel;
            bind(node.catchClause);
            addAntecedent(normalExitLabel, currentFlow);
          }
          currentReturnTarget = saveReturnTarget;
          currentExceptionTarget = saveExceptionTarget;
          if (node.finallyBlock) {
            var finallyLabel = createBranchLabel();
            finallyLabel.antecedents = ts3.concatenate(ts3.concatenate(normalExitLabel.antecedents, exceptionLabel.antecedents), returnLabel.antecedents);
            currentFlow = finallyLabel;
            bind(node.finallyBlock);
            if (currentFlow.flags & 1) {
              currentFlow = unreachableFlow;
            } else {
              if (currentReturnTarget && returnLabel.antecedents) {
                addAntecedent(currentReturnTarget, createReduceLabel(finallyLabel, returnLabel.antecedents, currentFlow));
              }
              if (currentExceptionTarget && exceptionLabel.antecedents) {
                addAntecedent(currentExceptionTarget, createReduceLabel(finallyLabel, exceptionLabel.antecedents, currentFlow));
              }
              currentFlow = normalExitLabel.antecedents ? createReduceLabel(finallyLabel, normalExitLabel.antecedents, currentFlow) : unreachableFlow;
            }
          } else {
            currentFlow = finishFlowLabel(normalExitLabel);
          }
        }
        function bindSwitchStatement(node) {
          var postSwitchLabel = createBranchLabel();
          bind(node.expression);
          var saveBreakTarget = currentBreakTarget;
          var savePreSwitchCaseFlow = preSwitchCaseFlow;
          currentBreakTarget = postSwitchLabel;
          preSwitchCaseFlow = currentFlow;
          bind(node.caseBlock);
          addAntecedent(postSwitchLabel, currentFlow);
          var hasDefault = ts3.forEach(node.caseBlock.clauses, function(c2) {
            return c2.kind === 286;
          });
          node.possiblyExhaustive = !hasDefault && !postSwitchLabel.antecedents;
          if (!hasDefault) {
            addAntecedent(postSwitchLabel, createFlowSwitchClause(preSwitchCaseFlow, node, 0, 0));
          }
          currentBreakTarget = saveBreakTarget;
          preSwitchCaseFlow = savePreSwitchCaseFlow;
          currentFlow = finishFlowLabel(postSwitchLabel);
        }
        function bindCaseBlock(node) {
          var clauses = node.clauses;
          var isNarrowingSwitch = isNarrowingExpression(node.parent.expression);
          var fallthroughFlow = unreachableFlow;
          for (var i3 = 0; i3 < clauses.length; i3++) {
            var clauseStart = i3;
            while (!clauses[i3].statements.length && i3 + 1 < clauses.length) {
              bind(clauses[i3]);
              i3++;
            }
            var preCaseLabel = createBranchLabel();
            addAntecedent(preCaseLabel, isNarrowingSwitch ? createFlowSwitchClause(preSwitchCaseFlow, node.parent, clauseStart, i3 + 1) : preSwitchCaseFlow);
            addAntecedent(preCaseLabel, fallthroughFlow);
            currentFlow = finishFlowLabel(preCaseLabel);
            var clause = clauses[i3];
            bind(clause);
            fallthroughFlow = currentFlow;
            if (!(currentFlow.flags & 1) && i3 !== clauses.length - 1 && options.noFallthroughCasesInSwitch) {
              clause.fallthroughFlowNode = currentFlow;
            }
          }
        }
        function bindCaseClause(node) {
          var saveCurrentFlow = currentFlow;
          currentFlow = preSwitchCaseFlow;
          bind(node.expression);
          currentFlow = saveCurrentFlow;
          bindEach(node.statements);
        }
        function bindExpressionStatement(node) {
          bind(node.expression);
          maybeBindExpressionFlowIfCall(node.expression);
        }
        function maybeBindExpressionFlowIfCall(node) {
          if (node.kind === 204) {
            var call = node;
            if (call.expression.kind !== 105 && ts3.isDottedName(call.expression)) {
              currentFlow = createFlowCall(currentFlow, call);
            }
          }
        }
        function bindLabeledStatement(node) {
          var postStatementLabel = createBranchLabel();
          activeLabelList = {
            next: activeLabelList,
            name: node.label.escapedText,
            breakTarget: postStatementLabel,
            continueTarget: void 0,
            referenced: false
          };
          bind(node.label);
          bind(node.statement);
          if (!activeLabelList.referenced && !options.allowUnusedLabels) {
            errorOrSuggestionOnNode(ts3.unusedLabelIsError(options), node.label, ts3.Diagnostics.Unused_label);
          }
          activeLabelList = activeLabelList.next;
          addAntecedent(postStatementLabel, currentFlow);
          currentFlow = finishFlowLabel(postStatementLabel);
        }
        function bindDestructuringTargetFlow(node) {
          if (node.kind === 217 && node.operatorToken.kind === 62) {
            bindAssignmentTargetFlow(node.left);
          } else {
            bindAssignmentTargetFlow(node);
          }
        }
        function bindAssignmentTargetFlow(node) {
          if (isNarrowableReference(node)) {
            currentFlow = createFlowMutation(16, currentFlow, node);
          } else if (node.kind === 200) {
            for (var _i = 0, _a2 = node.elements; _i < _a2.length; _i++) {
              var e2 = _a2[_i];
              if (e2.kind === 221) {
                bindAssignmentTargetFlow(e2.expression);
              } else {
                bindDestructuringTargetFlow(e2);
              }
            }
          } else if (node.kind === 201) {
            for (var _b = 0, _c = node.properties; _b < _c.length; _b++) {
              var p = _c[_b];
              if (p.kind === 289) {
                bindDestructuringTargetFlow(p.initializer);
              } else if (p.kind === 290) {
                bindAssignmentTargetFlow(p.name);
              } else if (p.kind === 291) {
                bindAssignmentTargetFlow(p.expression);
              }
            }
          }
        }
        function bindLogicalLikeExpression(node, trueTarget, falseTarget) {
          var preRightLabel = createBranchLabel();
          if (node.operatorToken.kind === 55 || node.operatorToken.kind === 75) {
            bindCondition(node.left, preRightLabel, falseTarget);
          } else {
            bindCondition(node.left, trueTarget, preRightLabel);
          }
          currentFlow = finishFlowLabel(preRightLabel);
          bind(node.operatorToken);
          if (ts3.isLogicalOrCoalescingAssignmentOperator(node.operatorToken.kind)) {
            doWithConditionalBranches(bind, node.right, trueTarget, falseTarget);
            bindAssignmentTargetFlow(node.left);
            addAntecedent(trueTarget, createFlowCondition(32, currentFlow, node));
            addAntecedent(falseTarget, createFlowCondition(64, currentFlow, node));
          } else {
            bindCondition(node.right, trueTarget, falseTarget);
          }
        }
        function bindPrefixUnaryExpressionFlow(node) {
          if (node.operator === 53) {
            var saveTrueTarget = currentTrueTarget;
            currentTrueTarget = currentFalseTarget;
            currentFalseTarget = saveTrueTarget;
            bindEachChild(node);
            currentFalseTarget = currentTrueTarget;
            currentTrueTarget = saveTrueTarget;
          } else {
            bindEachChild(node);
            if (node.operator === 45 || node.operator === 46) {
              bindAssignmentTargetFlow(node.operand);
            }
          }
        }
        function bindPostfixUnaryExpressionFlow(node) {
          bindEachChild(node);
          if (node.operator === 45 || node.operator === 46) {
            bindAssignmentTargetFlow(node.operand);
          }
        }
        function bindDestructuringAssignmentFlow(node) {
          if (inAssignmentPattern) {
            inAssignmentPattern = false;
            bind(node.operatorToken);
            bind(node.right);
            inAssignmentPattern = true;
            bind(node.left);
          } else {
            inAssignmentPattern = true;
            bind(node.left);
            inAssignmentPattern = false;
            bind(node.operatorToken);
            bind(node.right);
          }
          bindAssignmentTargetFlow(node.left);
        }
        function createBindBinaryExpressionFlow() {
          return ts3.createBinaryExpressionTrampoline(onEnter, onLeft, onOperator, onRight, onExit, void 0);
          function onEnter(node, state) {
            if (state) {
              state.stackIndex++;
              ts3.setParent(node, parent);
              var saveInStrictMode = inStrictMode;
              bindWorker(node);
              var saveParent = parent;
              parent = node;
              state.skip = false;
              state.inStrictModeStack[state.stackIndex] = saveInStrictMode;
              state.parentStack[state.stackIndex] = saveParent;
            } else {
              state = {
                stackIndex: 0,
                skip: false,
                inStrictModeStack: [void 0],
                parentStack: [void 0]
              };
            }
            var operator = node.operatorToken.kind;
            if (operator === 55 || operator === 56 || operator === 60 || ts3.isLogicalOrCoalescingAssignmentOperator(operator)) {
              if (isTopLevelLogicalExpression(node)) {
                var postExpressionLabel = createBranchLabel();
                bindLogicalLikeExpression(node, postExpressionLabel, postExpressionLabel);
                currentFlow = finishFlowLabel(postExpressionLabel);
              } else {
                bindLogicalLikeExpression(node, currentTrueTarget, currentFalseTarget);
              }
              state.skip = true;
            }
            return state;
          }
          function onLeft(left, state, _node) {
            if (!state.skip) {
              return maybeBind(left);
            }
          }
          function onOperator(operatorToken, state, node) {
            if (!state.skip) {
              if (operatorToken.kind === 27) {
                maybeBindExpressionFlowIfCall(node.left);
              }
              bind(operatorToken);
            }
          }
          function onRight(right, state, _node) {
            if (!state.skip) {
              return maybeBind(right);
            }
          }
          function onExit(node, state) {
            if (!state.skip) {
              var operator = node.operatorToken.kind;
              if (ts3.isAssignmentOperator(operator) && !ts3.isAssignmentTarget(node)) {
                bindAssignmentTargetFlow(node.left);
                if (operator === 62 && node.left.kind === 203) {
                  var elementAccess = node.left;
                  if (isNarrowableOperand(elementAccess.expression)) {
                    currentFlow = createFlowMutation(256, currentFlow, node);
                  }
                }
              }
            }
            var savedInStrictMode = state.inStrictModeStack[state.stackIndex];
            var savedParent = state.parentStack[state.stackIndex];
            if (savedInStrictMode !== void 0) {
              inStrictMode = savedInStrictMode;
            }
            if (savedParent !== void 0) {
              parent = savedParent;
            }
            state.skip = false;
            state.stackIndex--;
          }
          function maybeBind(node) {
            if (node && ts3.isBinaryExpression(node) && !ts3.isDestructuringAssignment(node)) {
              return node;
            }
            bind(node);
          }
        }
        function bindDeleteExpressionFlow(node) {
          bindEachChild(node);
          if (node.expression.kind === 202) {
            bindAssignmentTargetFlow(node.expression);
          }
        }
        function bindConditionalExpressionFlow(node) {
          var trueLabel = createBranchLabel();
          var falseLabel = createBranchLabel();
          var postExpressionLabel = createBranchLabel();
          bindCondition(node.condition, trueLabel, falseLabel);
          currentFlow = finishFlowLabel(trueLabel);
          bind(node.questionToken);
          bind(node.whenTrue);
          addAntecedent(postExpressionLabel, currentFlow);
          currentFlow = finishFlowLabel(falseLabel);
          bind(node.colonToken);
          bind(node.whenFalse);
          addAntecedent(postExpressionLabel, currentFlow);
          currentFlow = finishFlowLabel(postExpressionLabel);
        }
        function bindInitializedVariableFlow(node) {
          var name = !ts3.isOmittedExpression(node) ? node.name : void 0;
          if (ts3.isBindingPattern(name)) {
            for (var _i = 0, _a2 = name.elements; _i < _a2.length; _i++) {
              var child = _a2[_i];
              bindInitializedVariableFlow(child);
            }
          } else {
            currentFlow = createFlowMutation(16, currentFlow, node);
          }
        }
        function bindVariableDeclarationFlow(node) {
          bindEachChild(node);
          if (node.initializer || ts3.isForInOrOfStatement(node.parent.parent)) {
            bindInitializedVariableFlow(node);
          }
        }
        function bindBindingElementFlow(node) {
          if (ts3.isBindingPattern(node.name)) {
            bindEach(node.decorators);
            bindEach(node.modifiers);
            bind(node.dotDotDotToken);
            bind(node.propertyName);
            bind(node.initializer);
            bind(node.name);
          } else {
            bindEachChild(node);
          }
        }
        function bindJSDocTypeAlias(node) {
          ts3.setParent(node.tagName, node);
          if (node.kind !== 329 && node.fullName) {
            ts3.setParent(node.fullName, node);
            ts3.setParentRecursive(node.fullName, false);
          }
        }
        function bindJSDocClassTag(node) {
          bindEachChild(node);
          var host = ts3.getHostSignatureFromJSDoc(node);
          if (host && host.kind !== 166) {
            addDeclarationToSymbol(host.symbol, host, 32);
          }
        }
        function bindOptionalExpression(node, trueTarget, falseTarget) {
          doWithConditionalBranches(bind, node, trueTarget, falseTarget);
          if (!ts3.isOptionalChain(node) || ts3.isOutermostOptionalChain(node)) {
            addAntecedent(trueTarget, createFlowCondition(32, currentFlow, node));
            addAntecedent(falseTarget, createFlowCondition(64, currentFlow, node));
          }
        }
        function bindOptionalChainRest(node) {
          switch (node.kind) {
            case 202:
              bind(node.questionDotToken);
              bind(node.name);
              break;
            case 203:
              bind(node.questionDotToken);
              bind(node.argumentExpression);
              break;
            case 204:
              bind(node.questionDotToken);
              bindEach(node.typeArguments);
              bindEach(node.arguments);
              break;
          }
        }
        function bindOptionalChain(node, trueTarget, falseTarget) {
          var preChainLabel = ts3.isOptionalChainRoot(node) ? createBranchLabel() : void 0;
          bindOptionalExpression(node.expression, preChainLabel || trueTarget, falseTarget);
          if (preChainLabel) {
            currentFlow = finishFlowLabel(preChainLabel);
          }
          doWithConditionalBranches(bindOptionalChainRest, node, trueTarget, falseTarget);
          if (ts3.isOutermostOptionalChain(node)) {
            addAntecedent(trueTarget, createFlowCondition(32, currentFlow, node));
            addAntecedent(falseTarget, createFlowCondition(64, currentFlow, node));
          }
        }
        function bindOptionalChainFlow(node) {
          if (isTopLevelLogicalExpression(node)) {
            var postExpressionLabel = createBranchLabel();
            bindOptionalChain(node, postExpressionLabel, postExpressionLabel);
            currentFlow = finishFlowLabel(postExpressionLabel);
          } else {
            bindOptionalChain(node, currentTrueTarget, currentFalseTarget);
          }
        }
        function bindNonNullExpressionFlow(node) {
          if (ts3.isOptionalChain(node)) {
            bindOptionalChainFlow(node);
          } else {
            bindEachChild(node);
          }
        }
        function bindAccessExpressionFlow(node) {
          if (ts3.isOptionalChain(node)) {
            bindOptionalChainFlow(node);
          } else {
            bindEachChild(node);
          }
        }
        function bindCallExpressionFlow(node) {
          if (ts3.isOptionalChain(node)) {
            bindOptionalChainFlow(node);
          } else {
            var expr = ts3.skipParentheses(node.expression);
            if (expr.kind === 209 || expr.kind === 210) {
              bindEach(node.typeArguments);
              bindEach(node.arguments);
              bind(node.expression);
            } else {
              bindEachChild(node);
              if (node.expression.kind === 105) {
                currentFlow = createFlowCall(currentFlow, node);
              }
            }
          }
          if (node.expression.kind === 202) {
            var propertyAccess = node.expression;
            if (ts3.isIdentifier(propertyAccess.name) && isNarrowableOperand(propertyAccess.expression) && ts3.isPushOrUnshiftIdentifier(propertyAccess.name)) {
              currentFlow = createFlowMutation(256, currentFlow, node);
            }
          }
        }
        function getContainerFlags(node) {
          switch (node.kind) {
            case 222:
            case 253:
            case 256:
            case 201:
            case 178:
            case 314:
            case 282:
              return 1;
            case 254:
              return 1 | 64;
            case 257:
            case 255:
            case 191:
              return 1 | 32;
            case 298:
              return 1 | 4 | 32;
            case 166:
              if (ts3.isObjectLiteralOrClassExpressionMethod(node)) {
                return 1 | 4 | 32 | 8 | 128;
              }
            case 167:
            case 252:
            case 165:
            case 168:
            case 169:
            case 170:
            case 315:
            case 309:
            case 175:
            case 171:
            case 172:
            case 176:
              return 1 | 4 | 32 | 8;
            case 209:
            case 210:
              return 1 | 4 | 32 | 8 | 16;
            case 258:
              return 4;
            case 164:
              return node.initializer ? 4 : 0;
            case 288:
            case 238:
            case 239:
            case 240:
            case 259:
              return 2;
            case 231:
              return ts3.isFunctionLike(node.parent) ? 0 : 2;
          }
          return 0;
        }
        function addToContainerChain(next) {
          if (lastContainer) {
            lastContainer.nextContainer = next;
          }
          lastContainer = next;
        }
        function declareSymbolAndAddToSymbolTable(node, symbolFlags, symbolExcludes) {
          switch (container.kind) {
            case 257:
              return declareModuleMember(node, symbolFlags, symbolExcludes);
            case 298:
              return declareSourceFileMember(node, symbolFlags, symbolExcludes);
            case 222:
            case 253:
              return declareClassMember(node, symbolFlags, symbolExcludes);
            case 256:
              return declareSymbol(container.symbol.exports, container.symbol, node, symbolFlags, symbolExcludes);
            case 178:
            case 314:
            case 201:
            case 254:
            case 282:
              return declareSymbol(container.symbol.members, container.symbol, node, symbolFlags, symbolExcludes);
            case 175:
            case 176:
            case 170:
            case 171:
            case 315:
            case 172:
            case 166:
            case 165:
            case 167:
            case 168:
            case 169:
            case 252:
            case 209:
            case 210:
            case 309:
            case 335:
            case 328:
            case 255:
            case 191:
              return declareSymbol(container.locals, void 0, node, symbolFlags, symbolExcludes);
          }
        }
        function declareClassMember(node, symbolFlags, symbolExcludes) {
          return ts3.hasSyntacticModifier(node, 32) ? declareSymbol(container.symbol.exports, container.symbol, node, symbolFlags, symbolExcludes) : declareSymbol(container.symbol.members, container.symbol, node, symbolFlags, symbolExcludes);
        }
        function declareSourceFileMember(node, symbolFlags, symbolExcludes) {
          return ts3.isExternalModule(file) ? declareModuleMember(node, symbolFlags, symbolExcludes) : declareSymbol(file.locals, void 0, node, symbolFlags, symbolExcludes);
        }
        function hasExportDeclarations(node) {
          var body = ts3.isSourceFile(node) ? node : ts3.tryCast(node.body, ts3.isModuleBlock);
          return !!body && body.statements.some(function(s2) {
            return ts3.isExportDeclaration(s2) || ts3.isExportAssignment(s2);
          });
        }
        function setExportContextFlag(node) {
          if (node.flags & 8388608 && !hasExportDeclarations(node)) {
            node.flags |= 64;
          } else {
            node.flags &= ~64;
          }
        }
        function bindModuleDeclaration(node) {
          setExportContextFlag(node);
          if (ts3.isAmbientModule(node)) {
            if (ts3.hasSyntacticModifier(node, 1)) {
              errorOnFirstToken(node, ts3.Diagnostics.export_modifier_cannot_be_applied_to_ambient_modules_and_module_augmentations_since_they_are_always_visible);
            }
            if (ts3.isModuleAugmentationExternal(node)) {
              declareModuleSymbol(node);
            } else {
              var pattern = void 0;
              if (node.name.kind === 10) {
                var text = node.name.text;
                if (ts3.hasZeroOrOneAsteriskCharacter(text)) {
                  pattern = ts3.tryParsePattern(text);
                } else {
                  errorOnFirstToken(node.name, ts3.Diagnostics.Pattern_0_can_have_at_most_one_Asterisk_character, text);
                }
              }
              var symbol = declareSymbolAndAddToSymbolTable(node, 512, 110735);
              file.patternAmbientModules = ts3.append(file.patternAmbientModules, pattern && { pattern, symbol });
            }
          } else {
            var state = declareModuleSymbol(node);
            if (state !== 0) {
              var symbol = node.symbol;
              symbol.constEnumOnlyModule = !(symbol.flags & (16 | 32 | 256)) && state === 2 && symbol.constEnumOnlyModule !== false;
            }
          }
        }
        function declareModuleSymbol(node) {
          var state = getModuleInstanceState(node);
          var instantiated = state !== 0;
          declareSymbolAndAddToSymbolTable(node, instantiated ? 512 : 1024, instantiated ? 110735 : 0);
          return state;
        }
        function bindFunctionOrConstructorType(node) {
          var symbol = createSymbol(131072, getDeclarationName(node));
          addDeclarationToSymbol(symbol, node, 131072);
          var typeLiteralSymbol = createSymbol(2048, "__type");
          addDeclarationToSymbol(typeLiteralSymbol, node, 2048);
          typeLiteralSymbol.members = ts3.createSymbolTable();
          typeLiteralSymbol.members.set(symbol.escapedName, symbol);
        }
        function bindObjectLiteralExpression(node) {
          var ElementKind;
          (function(ElementKind2) {
            ElementKind2[ElementKind2["Property"] = 1] = "Property";
            ElementKind2[ElementKind2["Accessor"] = 2] = "Accessor";
          })(ElementKind || (ElementKind = {}));
          if (inStrictMode && !ts3.isAssignmentTarget(node)) {
            var seen = new ts3.Map();
            for (var _i = 0, _a2 = node.properties; _i < _a2.length; _i++) {
              var prop = _a2[_i];
              if (prop.kind === 291 || prop.name.kind !== 78) {
                continue;
              }
              var identifier = prop.name;
              var currentKind = prop.kind === 289 || prop.kind === 290 || prop.kind === 166 ? 1 : 2;
              var existingKind = seen.get(identifier.escapedText);
              if (!existingKind) {
                seen.set(identifier.escapedText, currentKind);
                continue;
              }
              if (currentKind === 1 && existingKind === 1) {
                var span = ts3.getErrorSpanForNode(file, identifier);
                file.bindDiagnostics.push(ts3.createFileDiagnostic(file, span.start, span.length, ts3.Diagnostics.An_object_literal_cannot_have_multiple_properties_with_the_same_name_in_strict_mode));
              }
            }
          }
          return bindAnonymousDeclaration(node, 4096, "__object");
        }
        function bindJsxAttributes(node) {
          return bindAnonymousDeclaration(node, 4096, "__jsxAttributes");
        }
        function bindJsxAttribute(node, symbolFlags, symbolExcludes) {
          return declareSymbolAndAddToSymbolTable(node, symbolFlags, symbolExcludes);
        }
        function bindAnonymousDeclaration(node, symbolFlags, name) {
          var symbol = createSymbol(symbolFlags, name);
          if (symbolFlags & (8 | 106500)) {
            symbol.parent = container.symbol;
          }
          addDeclarationToSymbol(symbol, node, symbolFlags);
          return symbol;
        }
        function bindBlockScopedDeclaration(node, symbolFlags, symbolExcludes) {
          switch (blockScopeContainer.kind) {
            case 257:
              declareModuleMember(node, symbolFlags, symbolExcludes);
              break;
            case 298:
              if (ts3.isExternalOrCommonJsModule(container)) {
                declareModuleMember(node, symbolFlags, symbolExcludes);
                break;
              }
            default:
              if (!blockScopeContainer.locals) {
                blockScopeContainer.locals = ts3.createSymbolTable();
                addToContainerChain(blockScopeContainer);
              }
              declareSymbol(blockScopeContainer.locals, void 0, node, symbolFlags, symbolExcludes);
          }
        }
        function delayedBindJSDocTypedefTag() {
          if (!delayedTypeAliases) {
            return;
          }
          var saveContainer = container;
          var saveLastContainer = lastContainer;
          var saveBlockScopeContainer = blockScopeContainer;
          var saveParent = parent;
          var saveCurrentFlow = currentFlow;
          for (var _i = 0, delayedTypeAliases_1 = delayedTypeAliases; _i < delayedTypeAliases_1.length; _i++) {
            var typeAlias = delayedTypeAliases_1[_i];
            var host = typeAlias.parent.parent;
            container = ts3.findAncestor(host.parent, function(n2) {
              return !!(getContainerFlags(n2) & 1);
            }) || file;
            blockScopeContainer = ts3.getEnclosingBlockScopeContainer(host) || file;
            currentFlow = initFlowNode({ flags: 2 });
            parent = typeAlias;
            bind(typeAlias.typeExpression);
            var declName = ts3.getNameOfDeclaration(typeAlias);
            if ((ts3.isJSDocEnumTag(typeAlias) || !typeAlias.fullName) && declName && ts3.isPropertyAccessEntityNameExpression(declName.parent)) {
              var isTopLevel = isTopLevelNamespaceAssignment(declName.parent);
              if (isTopLevel) {
                bindPotentiallyMissingNamespaces(file.symbol, declName.parent, isTopLevel, !!ts3.findAncestor(declName, function(d) {
                  return ts3.isPropertyAccessExpression(d) && d.name.escapedText === "prototype";
                }), false);
                var oldContainer = container;
                switch (ts3.getAssignmentDeclarationPropertyAccessKind(declName.parent)) {
                  case 1:
                  case 2:
                    if (!ts3.isExternalOrCommonJsModule(file)) {
                      container = void 0;
                    } else {
                      container = file;
                    }
                    break;
                  case 4:
                    container = declName.parent.expression;
                    break;
                  case 3:
                    container = declName.parent.expression.name;
                    break;
                  case 5:
                    container = isExportsOrModuleExportsOrAlias(file, declName.parent.expression) ? file : ts3.isPropertyAccessExpression(declName.parent.expression) ? declName.parent.expression.name : declName.parent.expression;
                    break;
                  case 0:
                    return ts3.Debug.fail("Shouldn't have detected typedef or enum on non-assignment declaration");
                }
                if (container) {
                  declareModuleMember(typeAlias, 524288, 788968);
                }
                container = oldContainer;
              }
            } else if (ts3.isJSDocEnumTag(typeAlias) || !typeAlias.fullName || typeAlias.fullName.kind === 78) {
              parent = typeAlias.parent;
              bindBlockScopedDeclaration(typeAlias, 524288, 788968);
            } else {
              bind(typeAlias.fullName);
            }
          }
          container = saveContainer;
          lastContainer = saveLastContainer;
          blockScopeContainer = saveBlockScopeContainer;
          parent = saveParent;
          currentFlow = saveCurrentFlow;
        }
        function checkContextualIdentifier(node) {
          if (!file.parseDiagnostics.length && !(node.flags & 8388608) && !(node.flags & 4194304) && !ts3.isIdentifierName(node)) {
            if (inStrictMode && node.originalKeywordKind >= 116 && node.originalKeywordKind <= 124) {
              file.bindDiagnostics.push(createDiagnosticForNode(node, getStrictModeIdentifierMessage(node), ts3.declarationNameToString(node)));
            } else if (node.originalKeywordKind === 130) {
              if (ts3.isExternalModule(file) && ts3.isInTopLevelContext(node)) {
                file.bindDiagnostics.push(createDiagnosticForNode(node, ts3.Diagnostics.Identifier_expected_0_is_a_reserved_word_at_the_top_level_of_a_module, ts3.declarationNameToString(node)));
              } else if (node.flags & 32768) {
                file.bindDiagnostics.push(createDiagnosticForNode(node, ts3.Diagnostics.Identifier_expected_0_is_a_reserved_word_that_cannot_be_used_here, ts3.declarationNameToString(node)));
              }
            } else if (node.originalKeywordKind === 124 && node.flags & 8192) {
              file.bindDiagnostics.push(createDiagnosticForNode(node, ts3.Diagnostics.Identifier_expected_0_is_a_reserved_word_that_cannot_be_used_here, ts3.declarationNameToString(node)));
            }
          }
        }
        function getStrictModeIdentifierMessage(node) {
          if (ts3.getContainingClass(node)) {
            return ts3.Diagnostics.Identifier_expected_0_is_a_reserved_word_in_strict_mode_Class_definitions_are_automatically_in_strict_mode;
          }
          if (file.externalModuleIndicator) {
            return ts3.Diagnostics.Identifier_expected_0_is_a_reserved_word_in_strict_mode_Modules_are_automatically_in_strict_mode;
          }
          return ts3.Diagnostics.Identifier_expected_0_is_a_reserved_word_in_strict_mode;
        }
        function checkPrivateIdentifier(node) {
          if (node.escapedText === "#constructor") {
            if (!file.parseDiagnostics.length) {
              file.bindDiagnostics.push(createDiagnosticForNode(node, ts3.Diagnostics.constructor_is_a_reserved_word, ts3.declarationNameToString(node)));
            }
          }
        }
        function checkStrictModeBinaryExpression(node) {
          if (inStrictMode && ts3.isLeftHandSideExpression(node.left) && ts3.isAssignmentOperator(node.operatorToken.kind)) {
            checkStrictModeEvalOrArguments(node, node.left);
          }
        }
        function checkStrictModeCatchClause(node) {
          if (inStrictMode && node.variableDeclaration) {
            checkStrictModeEvalOrArguments(node, node.variableDeclaration.name);
          }
        }
        function checkStrictModeDeleteExpression(node) {
          if (inStrictMode && node.expression.kind === 78) {
            var span = ts3.getErrorSpanForNode(file, node.expression);
            file.bindDiagnostics.push(ts3.createFileDiagnostic(file, span.start, span.length, ts3.Diagnostics.delete_cannot_be_called_on_an_identifier_in_strict_mode));
          }
        }
        function isEvalOrArgumentsIdentifier(node) {
          return ts3.isIdentifier(node) && (node.escapedText === "eval" || node.escapedText === "arguments");
        }
        function checkStrictModeEvalOrArguments(contextNode, name) {
          if (name && name.kind === 78) {
            var identifier = name;
            if (isEvalOrArgumentsIdentifier(identifier)) {
              var span = ts3.getErrorSpanForNode(file, name);
              file.bindDiagnostics.push(ts3.createFileDiagnostic(file, span.start, span.length, getStrictModeEvalOrArgumentsMessage(contextNode), ts3.idText(identifier)));
            }
          }
        }
        function getStrictModeEvalOrArgumentsMessage(node) {
          if (ts3.getContainingClass(node)) {
            return ts3.Diagnostics.Invalid_use_of_0_Class_definitions_are_automatically_in_strict_mode;
          }
          if (file.externalModuleIndicator) {
            return ts3.Diagnostics.Invalid_use_of_0_Modules_are_automatically_in_strict_mode;
          }
          return ts3.Diagnostics.Invalid_use_of_0_in_strict_mode;
        }
        function checkStrictModeFunctionName(node) {
          if (inStrictMode) {
            checkStrictModeEvalOrArguments(node, node.name);
          }
        }
        function getStrictModeBlockScopeFunctionDeclarationMessage(node) {
          if (ts3.getContainingClass(node)) {
            return ts3.Diagnostics.Function_declarations_are_not_allowed_inside_blocks_in_strict_mode_when_targeting_ES3_or_ES5_Class_definitions_are_automatically_in_strict_mode;
          }
          if (file.externalModuleIndicator) {
            return ts3.Diagnostics.Function_declarations_are_not_allowed_inside_blocks_in_strict_mode_when_targeting_ES3_or_ES5_Modules_are_automatically_in_strict_mode;
          }
          return ts3.Diagnostics.Function_declarations_are_not_allowed_inside_blocks_in_strict_mode_when_targeting_ES3_or_ES5;
        }
        function checkStrictModeFunctionDeclaration(node) {
          if (languageVersion < 2) {
            if (blockScopeContainer.kind !== 298 && blockScopeContainer.kind !== 257 && !ts3.isFunctionLike(blockScopeContainer)) {
              var errorSpan = ts3.getErrorSpanForNode(file, node);
              file.bindDiagnostics.push(ts3.createFileDiagnostic(file, errorSpan.start, errorSpan.length, getStrictModeBlockScopeFunctionDeclarationMessage(node)));
            }
          }
        }
        function checkStrictModeNumericLiteral(node) {
          if (inStrictMode && node.numericLiteralFlags & 32) {
            file.bindDiagnostics.push(createDiagnosticForNode(node, ts3.Diagnostics.Octal_literals_are_not_allowed_in_strict_mode));
          }
        }
        function checkStrictModePostfixUnaryExpression(node) {
          if (inStrictMode) {
            checkStrictModeEvalOrArguments(node, node.operand);
          }
        }
        function checkStrictModePrefixUnaryExpression(node) {
          if (inStrictMode) {
            if (node.operator === 45 || node.operator === 46) {
              checkStrictModeEvalOrArguments(node, node.operand);
            }
          }
        }
        function checkStrictModeWithStatement(node) {
          if (inStrictMode) {
            errorOnFirstToken(node, ts3.Diagnostics.with_statements_are_not_allowed_in_strict_mode);
          }
        }
        function checkStrictModeLabeledStatement(node) {
          if (inStrictMode && options.target >= 2) {
            if (ts3.isDeclarationStatement(node.statement) || ts3.isVariableStatement(node.statement)) {
              errorOnFirstToken(node.label, ts3.Diagnostics.A_label_is_not_allowed_here);
            }
          }
        }
        function errorOnFirstToken(node, message, arg0, arg1, arg2) {
          var span = ts3.getSpanOfTokenAtPosition(file, node.pos);
          file.bindDiagnostics.push(ts3.createFileDiagnostic(file, span.start, span.length, message, arg0, arg1, arg2));
        }
        function errorOrSuggestionOnNode(isError, node, message) {
          errorOrSuggestionOnRange(isError, node, node, message);
        }
        function errorOrSuggestionOnRange(isError, startNode, endNode, message) {
          addErrorOrSuggestionDiagnostic(isError, { pos: ts3.getTokenPosOfNode(startNode, file), end: endNode.end }, message);
        }
        function addErrorOrSuggestionDiagnostic(isError, range, message) {
          var diag = ts3.createFileDiagnostic(file, range.pos, range.end - range.pos, message);
          if (isError) {
            file.bindDiagnostics.push(diag);
          } else {
            file.bindSuggestionDiagnostics = ts3.append(file.bindSuggestionDiagnostics, __assign(__assign({}, diag), { category: ts3.DiagnosticCategory.Suggestion }));
          }
        }
        function bind(node) {
          if (!node) {
            return;
          }
          ts3.setParent(node, parent);
          var saveInStrictMode = inStrictMode;
          bindWorker(node);
          if (node.kind > 157) {
            var saveParent = parent;
            parent = node;
            var containerFlags = getContainerFlags(node);
            if (containerFlags === 0) {
              bindChildren(node);
            } else {
              bindContainer(node, containerFlags);
            }
            parent = saveParent;
          } else {
            var saveParent = parent;
            if (node.kind === 1)
              parent = node;
            bindJSDoc(node);
            parent = saveParent;
          }
          inStrictMode = saveInStrictMode;
        }
        function bindJSDoc(node) {
          if (ts3.hasJSDocNodes(node)) {
            if (ts3.isInJSFile(node)) {
              for (var _i = 0, _a2 = node.jsDoc; _i < _a2.length; _i++) {
                var j = _a2[_i];
                bind(j);
              }
            } else {
              for (var _b = 0, _c = node.jsDoc; _b < _c.length; _b++) {
                var j = _c[_b];
                ts3.setParent(j, node);
                ts3.setParentRecursive(j, false);
              }
            }
          }
        }
        function updateStrictModeStatementList(statements) {
          if (!inStrictMode) {
            for (var _i = 0, statements_3 = statements; _i < statements_3.length; _i++) {
              var statement = statements_3[_i];
              if (!ts3.isPrologueDirective(statement)) {
                return;
              }
              if (isUseStrictPrologueDirective(statement)) {
                inStrictMode = true;
                return;
              }
            }
          }
        }
        function isUseStrictPrologueDirective(node) {
          var nodeText = ts3.getSourceTextOfNodeFromSourceFile(file, node.expression);
          return nodeText === '"use strict"' || nodeText === "'use strict'";
        }
        function bindWorker(node) {
          switch (node.kind) {
            case 78:
              if (node.isInJSDocNamespace) {
                var parentNode = node.parent;
                while (parentNode && !ts3.isJSDocTypeAlias(parentNode)) {
                  parentNode = parentNode.parent;
                }
                bindBlockScopedDeclaration(parentNode, 524288, 788968);
                break;
              }
            case 107:
              if (currentFlow && (ts3.isExpression(node) || parent.kind === 290)) {
                node.flowNode = currentFlow;
              }
              return checkContextualIdentifier(node);
            case 158:
              if (currentFlow && parent.kind === 177) {
                node.flowNode = currentFlow;
              }
              break;
            case 227:
            case 105:
              node.flowNode = currentFlow;
              break;
            case 79:
              return checkPrivateIdentifier(node);
            case 202:
            case 203:
              var expr = node;
              if (currentFlow && isNarrowableReference(expr)) {
                expr.flowNode = currentFlow;
              }
              if (ts3.isSpecialPropertyDeclaration(expr)) {
                bindSpecialPropertyDeclaration(expr);
              }
              if (ts3.isInJSFile(expr) && file.commonJsModuleIndicator && ts3.isModuleExportsAccessExpression(expr) && !lookupSymbolForName(blockScopeContainer, "module")) {
                declareSymbol(file.locals, void 0, expr.expression, 1 | 134217728, 111550);
              }
              break;
            case 217:
              var specialKind = ts3.getAssignmentDeclarationKind(node);
              switch (specialKind) {
                case 1:
                  bindExportsPropertyAssignment(node);
                  break;
                case 2:
                  bindModuleExportsAssignment(node);
                  break;
                case 3:
                  bindPrototypePropertyAssignment(node.left, node);
                  break;
                case 6:
                  bindPrototypeAssignment(node);
                  break;
                case 4:
                  bindThisPropertyAssignment(node);
                  break;
                case 5:
                  var expression = node.left.expression;
                  if (ts3.isInJSFile(node) && ts3.isIdentifier(expression)) {
                    var symbol = lookupSymbolForName(blockScopeContainer, expression.escapedText);
                    if (ts3.isThisInitializedDeclaration(symbol === null || symbol === void 0 ? void 0 : symbol.valueDeclaration)) {
                      bindThisPropertyAssignment(node);
                      break;
                    }
                  }
                  bindSpecialPropertyAssignment(node);
                  break;
                case 0:
                  break;
                default:
                  ts3.Debug.fail("Unknown binary expression special property assignment kind");
              }
              return checkStrictModeBinaryExpression(node);
            case 288:
              return checkStrictModeCatchClause(node);
            case 211:
              return checkStrictModeDeleteExpression(node);
            case 8:
              return checkStrictModeNumericLiteral(node);
            case 216:
              return checkStrictModePostfixUnaryExpression(node);
            case 215:
              return checkStrictModePrefixUnaryExpression(node);
            case 244:
              return checkStrictModeWithStatement(node);
            case 246:
              return checkStrictModeLabeledStatement(node);
            case 188:
              seenThisKeyword = true;
              return;
            case 173:
              break;
            case 160:
              return bindTypeParameter(node);
            case 161:
              return bindParameter(node);
            case 250:
              return bindVariableDeclarationOrBindingElement(node);
            case 199:
              node.flowNode = currentFlow;
              return bindVariableDeclarationOrBindingElement(node);
            case 164:
            case 163:
              return bindPropertyWorker(node);
            case 289:
            case 290:
              return bindPropertyOrMethodOrAccessor(node, 4, 0);
            case 292:
              return bindPropertyOrMethodOrAccessor(node, 8, 900095);
            case 170:
            case 171:
            case 172:
              return declareSymbolAndAddToSymbolTable(node, 131072, 0);
            case 166:
            case 165:
              return bindPropertyOrMethodOrAccessor(node, 8192 | (node.questionToken ? 16777216 : 0), ts3.isObjectLiteralMethod(node) ? 0 : 103359);
            case 252:
              return bindFunctionDeclaration(node);
            case 167:
              return declareSymbolAndAddToSymbolTable(node, 16384, 0);
            case 168:
              return bindPropertyOrMethodOrAccessor(node, 32768, 46015);
            case 169:
              return bindPropertyOrMethodOrAccessor(node, 65536, 78783);
            case 175:
            case 309:
            case 315:
            case 176:
              return bindFunctionOrConstructorType(node);
            case 178:
            case 314:
            case 191:
              return bindAnonymousTypeWorker(node);
            case 322:
              return bindJSDocClassTag(node);
            case 201:
              return bindObjectLiteralExpression(node);
            case 209:
            case 210:
              return bindFunctionExpression(node);
            case 204:
              var assignmentKind = ts3.getAssignmentDeclarationKind(node);
              switch (assignmentKind) {
                case 7:
                  return bindObjectDefinePropertyAssignment(node);
                case 8:
                  return bindObjectDefinePropertyExport(node);
                case 9:
                  return bindObjectDefinePrototypeProperty(node);
                case 0:
                  break;
                default:
                  return ts3.Debug.fail("Unknown call expression assignment declaration kind");
              }
              if (ts3.isInJSFile(node)) {
                bindCallExpression(node);
              }
              break;
            case 222:
            case 253:
              inStrictMode = true;
              return bindClassLikeDeclaration(node);
            case 254:
              return bindBlockScopedDeclaration(node, 64, 788872);
            case 255:
              return bindBlockScopedDeclaration(node, 524288, 788968);
            case 256:
              return bindEnumDeclaration(node);
            case 257:
              return bindModuleDeclaration(node);
            case 282:
              return bindJsxAttributes(node);
            case 281:
              return bindJsxAttribute(node, 4, 0);
            case 261:
            case 264:
            case 266:
            case 271:
              return declareSymbolAndAddToSymbolTable(node, 2097152, 2097152);
            case 260:
              return bindNamespaceExportDeclaration(node);
            case 263:
              return bindImportClause(node);
            case 268:
              return bindExportDeclaration(node);
            case 267:
              return bindExportAssignment(node);
            case 298:
              updateStrictModeStatementList(node.statements);
              return bindSourceFileIfExternalModule();
            case 231:
              if (!ts3.isFunctionLike(node.parent)) {
                return;
              }
            case 258:
              return updateStrictModeStatementList(node.statements);
            case 330:
              if (node.parent.kind === 315) {
                return bindParameter(node);
              }
              if (node.parent.kind !== 314) {
                break;
              }
            case 337:
              var propTag = node;
              var flags = propTag.isBracketed || propTag.typeExpression && propTag.typeExpression.type.kind === 308 ? 4 | 16777216 : 4;
              return declareSymbolAndAddToSymbolTable(propTag, flags, 0);
            case 335:
            case 328:
            case 329:
              return (delayedTypeAliases || (delayedTypeAliases = [])).push(node);
          }
        }
        function bindPropertyWorker(node) {
          return bindPropertyOrMethodOrAccessor(node, 4 | (node.questionToken ? 16777216 : 0), 0);
        }
        function bindAnonymousTypeWorker(node) {
          return bindAnonymousDeclaration(node, 2048, "__type");
        }
        function bindSourceFileIfExternalModule() {
          setExportContextFlag(file);
          if (ts3.isExternalModule(file)) {
            bindSourceFileAsExternalModule();
          } else if (ts3.isJsonSourceFile(file)) {
            bindSourceFileAsExternalModule();
            var originalSymbol = file.symbol;
            declareSymbol(file.symbol.exports, file.symbol, file, 4, 67108863);
            file.symbol = originalSymbol;
          }
        }
        function bindSourceFileAsExternalModule() {
          bindAnonymousDeclaration(file, 512, '"' + ts3.removeFileExtension(file.fileName) + '"');
        }
        function bindExportAssignment(node) {
          if (!container.symbol || !container.symbol.exports) {
            bindAnonymousDeclaration(node, 111551, getDeclarationName(node));
          } else {
            var flags = ts3.exportAssignmentIsAlias(node) ? 2097152 : 4;
            var symbol = declareSymbol(container.symbol.exports, container.symbol, node, flags, 67108863);
            if (node.isExportEquals) {
              ts3.setValueDeclaration(symbol, node);
            }
          }
        }
        function bindNamespaceExportDeclaration(node) {
          if (node.modifiers && node.modifiers.length) {
            file.bindDiagnostics.push(createDiagnosticForNode(node, ts3.Diagnostics.Modifiers_cannot_appear_here));
          }
          var diag = !ts3.isSourceFile(node.parent) ? ts3.Diagnostics.Global_module_exports_may_only_appear_at_top_level : !ts3.isExternalModule(node.parent) ? ts3.Diagnostics.Global_module_exports_may_only_appear_in_module_files : !node.parent.isDeclarationFile ? ts3.Diagnostics.Global_module_exports_may_only_appear_in_declaration_files : void 0;
          if (diag) {
            file.bindDiagnostics.push(createDiagnosticForNode(node, diag));
          } else {
            file.symbol.globalExports = file.symbol.globalExports || ts3.createSymbolTable();
            declareSymbol(file.symbol.globalExports, file.symbol, node, 2097152, 2097152);
          }
        }
        function bindExportDeclaration(node) {
          if (!container.symbol || !container.symbol.exports) {
            bindAnonymousDeclaration(node, 8388608, getDeclarationName(node));
          } else if (!node.exportClause) {
            declareSymbol(container.symbol.exports, container.symbol, node, 8388608, 0);
          } else if (ts3.isNamespaceExport(node.exportClause)) {
            ts3.setParent(node.exportClause, node);
            declareSymbol(container.symbol.exports, container.symbol, node.exportClause, 2097152, 2097152);
          }
        }
        function bindImportClause(node) {
          if (node.name) {
            declareSymbolAndAddToSymbolTable(node, 2097152, 2097152);
          }
        }
        function setCommonJsModuleIndicator(node) {
          if (file.externalModuleIndicator) {
            return false;
          }
          if (!file.commonJsModuleIndicator) {
            file.commonJsModuleIndicator = node;
            bindSourceFileAsExternalModule();
          }
          return true;
        }
        function bindObjectDefinePropertyExport(node) {
          if (!setCommonJsModuleIndicator(node)) {
            return;
          }
          var symbol = forEachIdentifierInEntityName(node.arguments[0], void 0, function(id, symbol2) {
            if (symbol2) {
              addDeclarationToSymbol(symbol2, id, 1536 | 67108864);
            }
            return symbol2;
          });
          if (symbol) {
            var flags = 4 | 1048576;
            declareSymbol(symbol.exports, symbol, node, flags, 0);
          }
        }
        function bindExportsPropertyAssignment(node) {
          if (!setCommonJsModuleIndicator(node)) {
            return;
          }
          var symbol = forEachIdentifierInEntityName(node.left.expression, void 0, function(id, symbol2) {
            if (symbol2) {
              addDeclarationToSymbol(symbol2, id, 1536 | 67108864);
            }
            return symbol2;
          });
          if (symbol) {
            var isAlias = ts3.isAliasableExpression(node.right) && (ts3.isExportsIdentifier(node.left.expression) || ts3.isModuleExportsAccessExpression(node.left.expression));
            var flags = isAlias ? 2097152 : 4 | 1048576;
            ts3.setParent(node.left, node);
            declareSymbol(symbol.exports, symbol, node.left, flags, 0);
          }
        }
        function bindModuleExportsAssignment(node) {
          if (!setCommonJsModuleIndicator(node)) {
            return;
          }
          var assignedExpression = ts3.getRightMostAssignedExpression(node.right);
          if (ts3.isEmptyObjectLiteral(assignedExpression) || container === file && isExportsOrModuleExportsOrAlias(file, assignedExpression)) {
            return;
          }
          if (ts3.isObjectLiteralExpression(assignedExpression) && ts3.every(assignedExpression.properties, ts3.isShorthandPropertyAssignment)) {
            ts3.forEach(assignedExpression.properties, bindExportAssignedObjectMemberAlias);
            return;
          }
          var flags = ts3.exportAssignmentIsAlias(node) ? 2097152 : 4 | 1048576 | 512;
          var symbol = declareSymbol(file.symbol.exports, file.symbol, node, flags | 67108864, 0);
          ts3.setValueDeclaration(symbol, node);
        }
        function bindExportAssignedObjectMemberAlias(node) {
          declareSymbol(file.symbol.exports, file.symbol, node, 2097152 | 67108864, 0);
        }
        function bindThisPropertyAssignment(node) {
          ts3.Debug.assert(ts3.isInJSFile(node));
          var hasPrivateIdentifier = ts3.isBinaryExpression(node) && ts3.isPropertyAccessExpression(node.left) && ts3.isPrivateIdentifier(node.left.name) || ts3.isPropertyAccessExpression(node) && ts3.isPrivateIdentifier(node.name);
          if (hasPrivateIdentifier) {
            return;
          }
          var thisContainer = ts3.getThisContainer(node, false);
          switch (thisContainer.kind) {
            case 252:
            case 209:
              var constructorSymbol = thisContainer.symbol;
              if (ts3.isBinaryExpression(thisContainer.parent) && thisContainer.parent.operatorToken.kind === 62) {
                var l2 = thisContainer.parent.left;
                if (ts3.isBindableStaticAccessExpression(l2) && ts3.isPrototypeAccess(l2.expression)) {
                  constructorSymbol = lookupSymbolForPropertyAccess(l2.expression.expression, thisParentContainer);
                }
              }
              if (constructorSymbol && constructorSymbol.valueDeclaration) {
                constructorSymbol.members = constructorSymbol.members || ts3.createSymbolTable();
                if (ts3.hasDynamicName(node)) {
                  bindDynamicallyNamedThisPropertyAssignment(node, constructorSymbol);
                } else {
                  declareSymbol(constructorSymbol.members, constructorSymbol, node, 4 | 67108864, 0 & ~4);
                }
                addDeclarationToSymbol(constructorSymbol, constructorSymbol.valueDeclaration, 32);
              }
              break;
            case 167:
            case 164:
            case 166:
            case 168:
            case 169:
              var containingClass = thisContainer.parent;
              var symbolTable = ts3.hasSyntacticModifier(thisContainer, 32) ? containingClass.symbol.exports : containingClass.symbol.members;
              if (ts3.hasDynamicName(node)) {
                bindDynamicallyNamedThisPropertyAssignment(node, containingClass.symbol);
              } else {
                declareSymbol(symbolTable, containingClass.symbol, node, 4 | 67108864, 0, true);
              }
              break;
            case 298:
              if (ts3.hasDynamicName(node)) {
                break;
              } else if (thisContainer.commonJsModuleIndicator) {
                declareSymbol(thisContainer.symbol.exports, thisContainer.symbol, node, 4 | 1048576, 0);
              } else {
                declareSymbolAndAddToSymbolTable(node, 1, 111550);
              }
              break;
            default:
              ts3.Debug.failBadSyntaxKind(thisContainer);
          }
        }
        function bindDynamicallyNamedThisPropertyAssignment(node, symbol) {
          bindAnonymousDeclaration(node, 4, "__computed");
          addLateBoundAssignmentDeclarationToSymbol(node, symbol);
        }
        function addLateBoundAssignmentDeclarationToSymbol(node, symbol) {
          if (symbol) {
            (symbol.assignmentDeclarationMembers || (symbol.assignmentDeclarationMembers = new ts3.Map())).set(ts3.getNodeId(node), node);
          }
        }
        function bindSpecialPropertyDeclaration(node) {
          if (node.expression.kind === 107) {
            bindThisPropertyAssignment(node);
          } else if (ts3.isBindableStaticAccessExpression(node) && node.parent.parent.kind === 298) {
            if (ts3.isPrototypeAccess(node.expression)) {
              bindPrototypePropertyAssignment(node, node.parent);
            } else {
              bindStaticPropertyAssignment(node);
            }
          }
        }
        function bindPrototypeAssignment(node) {
          ts3.setParent(node.left, node);
          ts3.setParent(node.right, node);
          bindPropertyAssignment(node.left.expression, node.left, false, true);
        }
        function bindObjectDefinePrototypeProperty(node) {
          var namespaceSymbol = lookupSymbolForPropertyAccess(node.arguments[0].expression);
          if (namespaceSymbol && namespaceSymbol.valueDeclaration) {
            addDeclarationToSymbol(namespaceSymbol, namespaceSymbol.valueDeclaration, 32);
          }
          bindPotentiallyNewExpandoMemberToNamespace(node, namespaceSymbol, true);
        }
        function bindPrototypePropertyAssignment(lhs, parent2) {
          var classPrototype = lhs.expression;
          var constructorFunction = classPrototype.expression;
          ts3.setParent(constructorFunction, classPrototype);
          ts3.setParent(classPrototype, lhs);
          ts3.setParent(lhs, parent2);
          bindPropertyAssignment(constructorFunction, lhs, true, true);
        }
        function bindObjectDefinePropertyAssignment(node) {
          var namespaceSymbol = lookupSymbolForPropertyAccess(node.arguments[0]);
          var isToplevel = node.parent.parent.kind === 298;
          namespaceSymbol = bindPotentiallyMissingNamespaces(namespaceSymbol, node.arguments[0], isToplevel, false, false);
          bindPotentiallyNewExpandoMemberToNamespace(node, namespaceSymbol, false);
        }
        function bindSpecialPropertyAssignment(node) {
          var _a2;
          var parentSymbol = lookupSymbolForPropertyAccess(node.left.expression, container) || lookupSymbolForPropertyAccess(node.left.expression, blockScopeContainer);
          if (!ts3.isInJSFile(node) && !ts3.isFunctionSymbol(parentSymbol)) {
            return;
          }
          var rootExpr = ts3.getLeftmostAccessExpression(node.left);
          if (ts3.isIdentifier(rootExpr) && ((_a2 = lookupSymbolForName(container, rootExpr.escapedText)) === null || _a2 === void 0 ? void 0 : _a2.flags) & 2097152) {
            return;
          }
          ts3.setParent(node.left, node);
          ts3.setParent(node.right, node);
          if (ts3.isIdentifier(node.left.expression) && container === file && isExportsOrModuleExportsOrAlias(file, node.left.expression)) {
            bindExportsPropertyAssignment(node);
          } else if (ts3.hasDynamicName(node)) {
            bindAnonymousDeclaration(node, 4 | 67108864, "__computed");
            var sym = bindPotentiallyMissingNamespaces(parentSymbol, node.left.expression, isTopLevelNamespaceAssignment(node.left), false, false);
            addLateBoundAssignmentDeclarationToSymbol(node, sym);
          } else {
            bindStaticPropertyAssignment(ts3.cast(node.left, ts3.isBindableStaticNameExpression));
          }
        }
        function bindStaticPropertyAssignment(node) {
          ts3.Debug.assert(!ts3.isIdentifier(node));
          ts3.setParent(node.expression, node);
          bindPropertyAssignment(node.expression, node, false, false);
        }
        function bindPotentiallyMissingNamespaces(namespaceSymbol, entityName, isToplevel, isPrototypeProperty, containerIsClass) {
          if ((namespaceSymbol === null || namespaceSymbol === void 0 ? void 0 : namespaceSymbol.flags) & 2097152) {
            return namespaceSymbol;
          }
          if (isToplevel && !isPrototypeProperty) {
            var flags_2 = 1536 | 67108864;
            var excludeFlags_1 = 110735 & ~67108864;
            namespaceSymbol = forEachIdentifierInEntityName(entityName, namespaceSymbol, function(id, symbol, parent2) {
              if (symbol) {
                addDeclarationToSymbol(symbol, id, flags_2);
                return symbol;
              } else {
                var table = parent2 ? parent2.exports : file.jsGlobalAugmentations || (file.jsGlobalAugmentations = ts3.createSymbolTable());
                return declareSymbol(table, parent2, id, flags_2, excludeFlags_1);
              }
            });
          }
          if (containerIsClass && namespaceSymbol && namespaceSymbol.valueDeclaration) {
            addDeclarationToSymbol(namespaceSymbol, namespaceSymbol.valueDeclaration, 32);
          }
          return namespaceSymbol;
        }
        function bindPotentiallyNewExpandoMemberToNamespace(declaration, namespaceSymbol, isPrototypeProperty) {
          if (!namespaceSymbol || !isExpandoSymbol(namespaceSymbol)) {
            return;
          }
          var symbolTable = isPrototypeProperty ? namespaceSymbol.members || (namespaceSymbol.members = ts3.createSymbolTable()) : namespaceSymbol.exports || (namespaceSymbol.exports = ts3.createSymbolTable());
          var includes = 0;
          var excludes = 0;
          if (ts3.isFunctionLikeDeclaration(ts3.getAssignedExpandoInitializer(declaration))) {
            includes = 8192;
            excludes = 103359;
          } else if (ts3.isCallExpression(declaration) && ts3.isBindableObjectDefinePropertyCall(declaration)) {
            if (ts3.some(declaration.arguments[2].properties, function(p) {
              var id = ts3.getNameOfDeclaration(p);
              return !!id && ts3.isIdentifier(id) && ts3.idText(id) === "set";
            })) {
              includes |= 65536 | 4;
              excludes |= 78783;
            }
            if (ts3.some(declaration.arguments[2].properties, function(p) {
              var id = ts3.getNameOfDeclaration(p);
              return !!id && ts3.isIdentifier(id) && ts3.idText(id) === "get";
            })) {
              includes |= 32768 | 4;
              excludes |= 46015;
            }
          }
          if (includes === 0) {
            includes = 4;
            excludes = 0;
          }
          declareSymbol(symbolTable, namespaceSymbol, declaration, includes | 67108864, excludes & ~67108864);
        }
        function isTopLevelNamespaceAssignment(propertyAccess) {
          return ts3.isBinaryExpression(propertyAccess.parent) ? getParentOfBinaryExpression(propertyAccess.parent).parent.kind === 298 : propertyAccess.parent.parent.kind === 298;
        }
        function bindPropertyAssignment(name, propertyAccess, isPrototypeProperty, containerIsClass) {
          var namespaceSymbol = lookupSymbolForPropertyAccess(name, container) || lookupSymbolForPropertyAccess(name, blockScopeContainer);
          var isToplevel = isTopLevelNamespaceAssignment(propertyAccess);
          namespaceSymbol = bindPotentiallyMissingNamespaces(namespaceSymbol, propertyAccess.expression, isToplevel, isPrototypeProperty, containerIsClass);
          bindPotentiallyNewExpandoMemberToNamespace(propertyAccess, namespaceSymbol, isPrototypeProperty);
        }
        function isExpandoSymbol(symbol) {
          if (symbol.flags & (16 | 32 | 1024)) {
            return true;
          }
          var node = symbol.valueDeclaration;
          if (node && ts3.isCallExpression(node)) {
            return !!ts3.getAssignedExpandoInitializer(node);
          }
          var init = !node ? void 0 : ts3.isVariableDeclaration(node) ? node.initializer : ts3.isBinaryExpression(node) ? node.right : ts3.isPropertyAccessExpression(node) && ts3.isBinaryExpression(node.parent) ? node.parent.right : void 0;
          init = init && ts3.getRightMostAssignedExpression(init);
          if (init) {
            var isPrototypeAssignment = ts3.isPrototypeAccess(ts3.isVariableDeclaration(node) ? node.name : ts3.isBinaryExpression(node) ? node.left : node);
            return !!ts3.getExpandoInitializer(ts3.isBinaryExpression(init) && (init.operatorToken.kind === 56 || init.operatorToken.kind === 60) ? init.right : init, isPrototypeAssignment);
          }
          return false;
        }
        function getParentOfBinaryExpression(expr) {
          while (ts3.isBinaryExpression(expr.parent)) {
            expr = expr.parent;
          }
          return expr.parent;
        }
        function lookupSymbolForPropertyAccess(node, lookupContainer) {
          if (lookupContainer === void 0) {
            lookupContainer = container;
          }
          if (ts3.isIdentifier(node)) {
            return lookupSymbolForName(lookupContainer, node.escapedText);
          } else {
            var symbol = lookupSymbolForPropertyAccess(node.expression);
            return symbol && symbol.exports && symbol.exports.get(ts3.getElementOrPropertyAccessName(node));
          }
        }
        function forEachIdentifierInEntityName(e2, parent2, action) {
          if (isExportsOrModuleExportsOrAlias(file, e2)) {
            return file.symbol;
          } else if (ts3.isIdentifier(e2)) {
            return action(e2, lookupSymbolForPropertyAccess(e2), parent2);
          } else {
            var s2 = forEachIdentifierInEntityName(e2.expression, parent2, action);
            var name = ts3.getNameOrArgument(e2);
            if (ts3.isPrivateIdentifier(name)) {
              ts3.Debug.fail("unexpected PrivateIdentifier");
            }
            return action(name, s2 && s2.exports && s2.exports.get(ts3.getElementOrPropertyAccessName(e2)), s2);
          }
        }
        function bindCallExpression(node) {
          if (!file.commonJsModuleIndicator && ts3.isRequireCall(node, false)) {
            setCommonJsModuleIndicator(node);
          }
        }
        function bindClassLikeDeclaration(node) {
          if (node.kind === 253) {
            bindBlockScopedDeclaration(node, 32, 899503);
          } else {
            var bindingName = node.name ? node.name.escapedText : "__class";
            bindAnonymousDeclaration(node, 32, bindingName);
            if (node.name) {
              classifiableNames.add(node.name.escapedText);
            }
          }
          var symbol = node.symbol;
          var prototypeSymbol = createSymbol(4 | 4194304, "prototype");
          var symbolExport = symbol.exports.get(prototypeSymbol.escapedName);
          if (symbolExport) {
            if (node.name) {
              ts3.setParent(node.name, node);
            }
            file.bindDiagnostics.push(createDiagnosticForNode(symbolExport.declarations[0], ts3.Diagnostics.Duplicate_identifier_0, ts3.symbolName(prototypeSymbol)));
          }
          symbol.exports.set(prototypeSymbol.escapedName, prototypeSymbol);
          prototypeSymbol.parent = symbol;
        }
        function bindEnumDeclaration(node) {
          return ts3.isEnumConst(node) ? bindBlockScopedDeclaration(node, 128, 899967) : bindBlockScopedDeclaration(node, 256, 899327);
        }
        function bindVariableDeclarationOrBindingElement(node) {
          if (inStrictMode) {
            checkStrictModeEvalOrArguments(node, node.name);
          }
          if (!ts3.isBindingPattern(node.name)) {
            if (ts3.isInJSFile(node) && ts3.isRequireVariableDeclaration(node) && !ts3.getJSDocTypeTag(node)) {
              declareSymbolAndAddToSymbolTable(node, 2097152, 2097152);
            } else if (ts3.isBlockOrCatchScoped(node)) {
              bindBlockScopedDeclaration(node, 2, 111551);
            } else if (ts3.isParameterDeclaration(node)) {
              declareSymbolAndAddToSymbolTable(node, 1, 111551);
            } else {
              declareSymbolAndAddToSymbolTable(node, 1, 111550);
            }
          }
        }
        function bindParameter(node) {
          if (node.kind === 330 && container.kind !== 315) {
            return;
          }
          if (inStrictMode && !(node.flags & 8388608)) {
            checkStrictModeEvalOrArguments(node, node.name);
          }
          if (ts3.isBindingPattern(node.name)) {
            bindAnonymousDeclaration(node, 1, "__" + node.parent.parameters.indexOf(node));
          } else {
            declareSymbolAndAddToSymbolTable(node, 1, 111551);
          }
          if (ts3.isParameterPropertyDeclaration(node, node.parent)) {
            var classDeclaration = node.parent.parent;
            declareSymbol(classDeclaration.symbol.members, classDeclaration.symbol, node, 4 | (node.questionToken ? 16777216 : 0), 0);
          }
        }
        function bindFunctionDeclaration(node) {
          if (!file.isDeclarationFile && !(node.flags & 8388608)) {
            if (ts3.isAsyncFunction(node)) {
              emitFlags |= 2048;
            }
          }
          checkStrictModeFunctionName(node);
          if (inStrictMode) {
            checkStrictModeFunctionDeclaration(node);
            bindBlockScopedDeclaration(node, 16, 110991);
          } else {
            declareSymbolAndAddToSymbolTable(node, 16, 110991);
          }
        }
        function bindFunctionExpression(node) {
          if (!file.isDeclarationFile && !(node.flags & 8388608)) {
            if (ts3.isAsyncFunction(node)) {
              emitFlags |= 2048;
            }
          }
          if (currentFlow) {
            node.flowNode = currentFlow;
          }
          checkStrictModeFunctionName(node);
          var bindingName = node.name ? node.name.escapedText : "__function";
          return bindAnonymousDeclaration(node, 16, bindingName);
        }
        function bindPropertyOrMethodOrAccessor(node, symbolFlags, symbolExcludes) {
          if (!file.isDeclarationFile && !(node.flags & 8388608) && ts3.isAsyncFunction(node)) {
            emitFlags |= 2048;
          }
          if (currentFlow && ts3.isObjectLiteralOrClassExpressionMethod(node)) {
            node.flowNode = currentFlow;
          }
          return ts3.hasDynamicName(node) ? bindAnonymousDeclaration(node, symbolFlags, "__computed") : declareSymbolAndAddToSymbolTable(node, symbolFlags, symbolExcludes);
        }
        function getInferTypeContainer(node) {
          var extendsType = ts3.findAncestor(node, function(n2) {
            return n2.parent && ts3.isConditionalTypeNode(n2.parent) && n2.parent.extendsType === n2;
          });
          return extendsType && extendsType.parent;
        }
        function bindTypeParameter(node) {
          if (ts3.isJSDocTemplateTag(node.parent)) {
            var container_1 = ts3.find(node.parent.parent.tags, ts3.isJSDocTypeAlias) || ts3.getHostSignatureFromJSDoc(node.parent);
            if (container_1) {
              if (!container_1.locals) {
                container_1.locals = ts3.createSymbolTable();
              }
              declareSymbol(container_1.locals, void 0, node, 262144, 526824);
            } else {
              declareSymbolAndAddToSymbolTable(node, 262144, 526824);
            }
          } else if (node.parent.kind === 186) {
            var container_2 = getInferTypeContainer(node.parent);
            if (container_2) {
              if (!container_2.locals) {
                container_2.locals = ts3.createSymbolTable();
              }
              declareSymbol(container_2.locals, void 0, node, 262144, 526824);
            } else {
              bindAnonymousDeclaration(node, 262144, getDeclarationName(node));
            }
          } else {
            declareSymbolAndAddToSymbolTable(node, 262144, 526824);
          }
        }
        function shouldReportErrorOnModuleDeclaration(node) {
          var instanceState = getModuleInstanceState(node);
          return instanceState === 1 || instanceState === 2 && ts3.shouldPreserveConstEnums(options);
        }
        function checkUnreachable(node) {
          if (!(currentFlow.flags & 1)) {
            return false;
          }
          if (currentFlow === unreachableFlow) {
            var reportError = ts3.isStatementButNotDeclaration(node) && node.kind !== 232 || node.kind === 253 || node.kind === 257 && shouldReportErrorOnModuleDeclaration(node);
            if (reportError) {
              currentFlow = reportedUnreachableFlow;
              if (!options.allowUnreachableCode) {
                var isError_1 = ts3.unreachableCodeIsError(options) && !(node.flags & 8388608) && (!ts3.isVariableStatement(node) || !!(ts3.getCombinedNodeFlags(node.declarationList) & 3) || node.declarationList.declarations.some(function(d) {
                  return !!d.initializer;
                }));
                eachUnreachableRange(node, function(start, end) {
                  return errorOrSuggestionOnRange(isError_1, start, end, ts3.Diagnostics.Unreachable_code_detected);
                });
              }
            }
          }
          return true;
        }
      }
      function eachUnreachableRange(node, cb2) {
        if (ts3.isStatement(node) && isExecutableStatement(node) && ts3.isBlock(node.parent)) {
          var statements = node.parent.statements;
          var slice_1 = ts3.sliceAfter(statements, node);
          ts3.getRangesWhere(slice_1, isExecutableStatement, function(start, afterEnd) {
            return cb2(slice_1[start], slice_1[afterEnd - 1]);
          });
        } else {
          cb2(node, node);
        }
      }
      function isExecutableStatement(s2) {
        return !ts3.isFunctionDeclaration(s2) && !isPurelyTypeDeclaration(s2) && !ts3.isEnumDeclaration(s2) && !(ts3.isVariableStatement(s2) && !(ts3.getCombinedNodeFlags(s2) & (1 | 2)) && s2.declarationList.declarations.some(function(d) {
          return !d.initializer;
        }));
      }
      function isPurelyTypeDeclaration(s2) {
        switch (s2.kind) {
          case 254:
          case 255:
            return true;
          case 257:
            return getModuleInstanceState(s2) !== 1;
          case 256:
            return ts3.hasSyntacticModifier(s2, 2048);
          default:
            return false;
        }
      }
      function isExportsOrModuleExportsOrAlias(sourceFile, node) {
        var i3 = 0;
        var q = [node];
        while (q.length && i3 < 100) {
          i3++;
          node = q.shift();
          if (ts3.isExportsIdentifier(node) || ts3.isModuleExportsAccessExpression(node)) {
            return true;
          } else if (ts3.isIdentifier(node)) {
            var symbol = lookupSymbolForName(sourceFile, node.escapedText);
            if (!!symbol && !!symbol.valueDeclaration && ts3.isVariableDeclaration(symbol.valueDeclaration) && !!symbol.valueDeclaration.initializer) {
              var init = symbol.valueDeclaration.initializer;
              q.push(init);
              if (ts3.isAssignmentExpression(init, true)) {
                q.push(init.left);
                q.push(init.right);
              }
            }
          }
        }
        return false;
      }
      ts3.isExportsOrModuleExportsOrAlias = isExportsOrModuleExportsOrAlias;
      function lookupSymbolForName(container, name) {
        var local = container.locals && container.locals.get(name);
        if (local) {
          return local.exportSymbol || local;
        }
        if (ts3.isSourceFile(container) && container.jsGlobalAugmentations && container.jsGlobalAugmentations.has(name)) {
          return container.jsGlobalAugmentations.get(name);
        }
        return container.symbol && container.symbol.exports && container.symbol.exports.get(name);
      }
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      function createGetSymbolWalker(getRestTypeOfSignature, getTypePredicateOfSignature, getReturnTypeOfSignature, getBaseTypes, resolveStructuredTypeMembers, getTypeOfSymbol, getResolvedSymbol, getIndexTypeOfStructuredType, getConstraintOfTypeParameter, getFirstIdentifier, getTypeArguments) {
        return getSymbolWalker;
        function getSymbolWalker(accept) {
          if (accept === void 0) {
            accept = function() {
              return true;
            };
          }
          var visitedTypes = [];
          var visitedSymbols = [];
          return {
            walkType: function(type3) {
              try {
                visitType(type3);
                return { visitedTypes: ts3.getOwnValues(visitedTypes), visitedSymbols: ts3.getOwnValues(visitedSymbols) };
              } finally {
                ts3.clear(visitedTypes);
                ts3.clear(visitedSymbols);
              }
            },
            walkSymbol: function(symbol) {
              try {
                visitSymbol(symbol);
                return { visitedTypes: ts3.getOwnValues(visitedTypes), visitedSymbols: ts3.getOwnValues(visitedSymbols) };
              } finally {
                ts3.clear(visitedTypes);
                ts3.clear(visitedSymbols);
              }
            }
          };
          function visitType(type3) {
            if (!type3) {
              return;
            }
            if (visitedTypes[type3.id]) {
              return;
            }
            visitedTypes[type3.id] = type3;
            var shouldBail = visitSymbol(type3.symbol);
            if (shouldBail)
              return;
            if (type3.flags & 524288) {
              var objectType = type3;
              var objectFlags = objectType.objectFlags;
              if (objectFlags & 4) {
                visitTypeReference(type3);
              }
              if (objectFlags & 32) {
                visitMappedType(type3);
              }
              if (objectFlags & (1 | 2)) {
                visitInterfaceType(type3);
              }
              if (objectFlags & (8 | 16)) {
                visitObjectType(objectType);
              }
            }
            if (type3.flags & 262144) {
              visitTypeParameter(type3);
            }
            if (type3.flags & 3145728) {
              visitUnionOrIntersectionType(type3);
            }
            if (type3.flags & 4194304) {
              visitIndexType(type3);
            }
            if (type3.flags & 8388608) {
              visitIndexedAccessType(type3);
            }
          }
          function visitTypeReference(type3) {
            visitType(type3.target);
            ts3.forEach(getTypeArguments(type3), visitType);
          }
          function visitTypeParameter(type3) {
            visitType(getConstraintOfTypeParameter(type3));
          }
          function visitUnionOrIntersectionType(type3) {
            ts3.forEach(type3.types, visitType);
          }
          function visitIndexType(type3) {
            visitType(type3.type);
          }
          function visitIndexedAccessType(type3) {
            visitType(type3.objectType);
            visitType(type3.indexType);
            visitType(type3.constraint);
          }
          function visitMappedType(type3) {
            visitType(type3.typeParameter);
            visitType(type3.constraintType);
            visitType(type3.templateType);
            visitType(type3.modifiersType);
          }
          function visitSignature(signature) {
            var typePredicate = getTypePredicateOfSignature(signature);
            if (typePredicate) {
              visitType(typePredicate.type);
            }
            ts3.forEach(signature.typeParameters, visitType);
            for (var _i = 0, _a2 = signature.parameters; _i < _a2.length; _i++) {
              var parameter = _a2[_i];
              visitSymbol(parameter);
            }
            visitType(getRestTypeOfSignature(signature));
            visitType(getReturnTypeOfSignature(signature));
          }
          function visitInterfaceType(interfaceT) {
            visitObjectType(interfaceT);
            ts3.forEach(interfaceT.typeParameters, visitType);
            ts3.forEach(getBaseTypes(interfaceT), visitType);
            visitType(interfaceT.thisType);
          }
          function visitObjectType(type3) {
            var stringIndexType = getIndexTypeOfStructuredType(type3, 0);
            visitType(stringIndexType);
            var numberIndexType = getIndexTypeOfStructuredType(type3, 1);
            visitType(numberIndexType);
            var resolved = resolveStructuredTypeMembers(type3);
            for (var _i = 0, _a2 = resolved.callSignatures; _i < _a2.length; _i++) {
              var signature = _a2[_i];
              visitSignature(signature);
            }
            for (var _b = 0, _c = resolved.constructSignatures; _b < _c.length; _b++) {
              var signature = _c[_b];
              visitSignature(signature);
            }
            for (var _d = 0, _e = resolved.properties; _d < _e.length; _d++) {
              var p = _e[_d];
              visitSymbol(p);
            }
          }
          function visitSymbol(symbol) {
            if (!symbol) {
              return false;
            }
            var symbolId = ts3.getSymbolId(symbol);
            if (visitedSymbols[symbolId]) {
              return false;
            }
            visitedSymbols[symbolId] = symbol;
            if (!accept(symbol)) {
              return true;
            }
            var t2 = getTypeOfSymbol(symbol);
            visitType(t2);
            if (symbol.exports) {
              symbol.exports.forEach(visitSymbol);
            }
            ts3.forEach(symbol.declarations, function(d) {
              if (d.type && d.type.kind === 177) {
                var query = d.type;
                var entity = getResolvedSymbol(getFirstIdentifier(query.exprName));
                visitSymbol(entity);
              }
            });
            return false;
          }
        }
      }
      ts3.createGetSymbolWalker = createGetSymbolWalker;
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var ambientModuleSymbolRegex = /^".+"$/;
      var anon = "(anonymous)";
      var nextSymbolId = 1;
      var nextNodeId = 1;
      var nextMergeId = 1;
      var nextFlowId = 1;
      var IterationUse;
      (function(IterationUse2) {
        IterationUse2[IterationUse2["AllowsSyncIterablesFlag"] = 1] = "AllowsSyncIterablesFlag";
        IterationUse2[IterationUse2["AllowsAsyncIterablesFlag"] = 2] = "AllowsAsyncIterablesFlag";
        IterationUse2[IterationUse2["AllowsStringInputFlag"] = 4] = "AllowsStringInputFlag";
        IterationUse2[IterationUse2["ForOfFlag"] = 8] = "ForOfFlag";
        IterationUse2[IterationUse2["YieldStarFlag"] = 16] = "YieldStarFlag";
        IterationUse2[IterationUse2["SpreadFlag"] = 32] = "SpreadFlag";
        IterationUse2[IterationUse2["DestructuringFlag"] = 64] = "DestructuringFlag";
        IterationUse2[IterationUse2["PossiblyOutOfBounds"] = 128] = "PossiblyOutOfBounds";
        IterationUse2[IterationUse2["Element"] = 1] = "Element";
        IterationUse2[IterationUse2["Spread"] = 33] = "Spread";
        IterationUse2[IterationUse2["Destructuring"] = 65] = "Destructuring";
        IterationUse2[IterationUse2["ForOf"] = 13] = "ForOf";
        IterationUse2[IterationUse2["ForAwaitOf"] = 15] = "ForAwaitOf";
        IterationUse2[IterationUse2["YieldStar"] = 17] = "YieldStar";
        IterationUse2[IterationUse2["AsyncYieldStar"] = 19] = "AsyncYieldStar";
        IterationUse2[IterationUse2["GeneratorReturnType"] = 1] = "GeneratorReturnType";
        IterationUse2[IterationUse2["AsyncGeneratorReturnType"] = 2] = "AsyncGeneratorReturnType";
      })(IterationUse || (IterationUse = {}));
      var IterationTypeKind;
      (function(IterationTypeKind2) {
        IterationTypeKind2[IterationTypeKind2["Yield"] = 0] = "Yield";
        IterationTypeKind2[IterationTypeKind2["Return"] = 1] = "Return";
        IterationTypeKind2[IterationTypeKind2["Next"] = 2] = "Next";
      })(IterationTypeKind || (IterationTypeKind = {}));
      var WideningKind;
      (function(WideningKind2) {
        WideningKind2[WideningKind2["Normal"] = 0] = "Normal";
        WideningKind2[WideningKind2["FunctionReturn"] = 1] = "FunctionReturn";
        WideningKind2[WideningKind2["GeneratorNext"] = 2] = "GeneratorNext";
        WideningKind2[WideningKind2["GeneratorYield"] = 3] = "GeneratorYield";
      })(WideningKind || (WideningKind = {}));
      var TypeFacts;
      (function(TypeFacts2) {
        TypeFacts2[TypeFacts2["None"] = 0] = "None";
        TypeFacts2[TypeFacts2["TypeofEQString"] = 1] = "TypeofEQString";
        TypeFacts2[TypeFacts2["TypeofEQNumber"] = 2] = "TypeofEQNumber";
        TypeFacts2[TypeFacts2["TypeofEQBigInt"] = 4] = "TypeofEQBigInt";
        TypeFacts2[TypeFacts2["TypeofEQBoolean"] = 8] = "TypeofEQBoolean";
        TypeFacts2[TypeFacts2["TypeofEQSymbol"] = 16] = "TypeofEQSymbol";
        TypeFacts2[TypeFacts2["TypeofEQObject"] = 32] = "TypeofEQObject";
        TypeFacts2[TypeFacts2["TypeofEQFunction"] = 64] = "TypeofEQFunction";
        TypeFacts2[TypeFacts2["TypeofEQHostObject"] = 128] = "TypeofEQHostObject";
        TypeFacts2[TypeFacts2["TypeofNEString"] = 256] = "TypeofNEString";
        TypeFacts2[TypeFacts2["TypeofNENumber"] = 512] = "TypeofNENumber";
        TypeFacts2[TypeFacts2["TypeofNEBigInt"] = 1024] = "TypeofNEBigInt";
        TypeFacts2[TypeFacts2["TypeofNEBoolean"] = 2048] = "TypeofNEBoolean";
        TypeFacts2[TypeFacts2["TypeofNESymbol"] = 4096] = "TypeofNESymbol";
        TypeFacts2[TypeFacts2["TypeofNEObject"] = 8192] = "TypeofNEObject";
        TypeFacts2[TypeFacts2["TypeofNEFunction"] = 16384] = "TypeofNEFunction";
        TypeFacts2[TypeFacts2["TypeofNEHostObject"] = 32768] = "TypeofNEHostObject";
        TypeFacts2[TypeFacts2["EQUndefined"] = 65536] = "EQUndefined";
        TypeFacts2[TypeFacts2["EQNull"] = 131072] = "EQNull";
        TypeFacts2[TypeFacts2["EQUndefinedOrNull"] = 262144] = "EQUndefinedOrNull";
        TypeFacts2[TypeFacts2["NEUndefined"] = 524288] = "NEUndefined";
        TypeFacts2[TypeFacts2["NENull"] = 1048576] = "NENull";
        TypeFacts2[TypeFacts2["NEUndefinedOrNull"] = 2097152] = "NEUndefinedOrNull";
        TypeFacts2[TypeFacts2["Truthy"] = 4194304] = "Truthy";
        TypeFacts2[TypeFacts2["Falsy"] = 8388608] = "Falsy";
        TypeFacts2[TypeFacts2["All"] = 16777215] = "All";
        TypeFacts2[TypeFacts2["BaseStringStrictFacts"] = 3735041] = "BaseStringStrictFacts";
        TypeFacts2[TypeFacts2["BaseStringFacts"] = 12582401] = "BaseStringFacts";
        TypeFacts2[TypeFacts2["StringStrictFacts"] = 16317953] = "StringStrictFacts";
        TypeFacts2[TypeFacts2["StringFacts"] = 16776705] = "StringFacts";
        TypeFacts2[TypeFacts2["EmptyStringStrictFacts"] = 12123649] = "EmptyStringStrictFacts";
        TypeFacts2[TypeFacts2["EmptyStringFacts"] = 12582401] = "EmptyStringFacts";
        TypeFacts2[TypeFacts2["NonEmptyStringStrictFacts"] = 7929345] = "NonEmptyStringStrictFacts";
        TypeFacts2[TypeFacts2["NonEmptyStringFacts"] = 16776705] = "NonEmptyStringFacts";
        TypeFacts2[TypeFacts2["BaseNumberStrictFacts"] = 3734786] = "BaseNumberStrictFacts";
        TypeFacts2[TypeFacts2["BaseNumberFacts"] = 12582146] = "BaseNumberFacts";
        TypeFacts2[TypeFacts2["NumberStrictFacts"] = 16317698] = "NumberStrictFacts";
        TypeFacts2[TypeFacts2["NumberFacts"] = 16776450] = "NumberFacts";
        TypeFacts2[TypeFacts2["ZeroNumberStrictFacts"] = 12123394] = "ZeroNumberStrictFacts";
        TypeFacts2[TypeFacts2["ZeroNumberFacts"] = 12582146] = "ZeroNumberFacts";
        TypeFacts2[TypeFacts2["NonZeroNumberStrictFacts"] = 7929090] = "NonZeroNumberStrictFacts";
        TypeFacts2[TypeFacts2["NonZeroNumberFacts"] = 16776450] = "NonZeroNumberFacts";
        TypeFacts2[TypeFacts2["BaseBigIntStrictFacts"] = 3734276] = "BaseBigIntStrictFacts";
        TypeFacts2[TypeFacts2["BaseBigIntFacts"] = 12581636] = "BaseBigIntFacts";
        TypeFacts2[TypeFacts2["BigIntStrictFacts"] = 16317188] = "BigIntStrictFacts";
        TypeFacts2[TypeFacts2["BigIntFacts"] = 16775940] = "BigIntFacts";
        TypeFacts2[TypeFacts2["ZeroBigIntStrictFacts"] = 12122884] = "ZeroBigIntStrictFacts";
        TypeFacts2[TypeFacts2["ZeroBigIntFacts"] = 12581636] = "ZeroBigIntFacts";
        TypeFacts2[TypeFacts2["NonZeroBigIntStrictFacts"] = 7928580] = "NonZeroBigIntStrictFacts";
        TypeFacts2[TypeFacts2["NonZeroBigIntFacts"] = 16775940] = "NonZeroBigIntFacts";
        TypeFacts2[TypeFacts2["BaseBooleanStrictFacts"] = 3733256] = "BaseBooleanStrictFacts";
        TypeFacts2[TypeFacts2["BaseBooleanFacts"] = 12580616] = "BaseBooleanFacts";
        TypeFacts2[TypeFacts2["BooleanStrictFacts"] = 16316168] = "BooleanStrictFacts";
        TypeFacts2[TypeFacts2["BooleanFacts"] = 16774920] = "BooleanFacts";
        TypeFacts2[TypeFacts2["FalseStrictFacts"] = 12121864] = "FalseStrictFacts";
        TypeFacts2[TypeFacts2["FalseFacts"] = 12580616] = "FalseFacts";
        TypeFacts2[TypeFacts2["TrueStrictFacts"] = 7927560] = "TrueStrictFacts";
        TypeFacts2[TypeFacts2["TrueFacts"] = 16774920] = "TrueFacts";
        TypeFacts2[TypeFacts2["SymbolStrictFacts"] = 7925520] = "SymbolStrictFacts";
        TypeFacts2[TypeFacts2["SymbolFacts"] = 16772880] = "SymbolFacts";
        TypeFacts2[TypeFacts2["ObjectStrictFacts"] = 7888800] = "ObjectStrictFacts";
        TypeFacts2[TypeFacts2["ObjectFacts"] = 16736160] = "ObjectFacts";
        TypeFacts2[TypeFacts2["FunctionStrictFacts"] = 7880640] = "FunctionStrictFacts";
        TypeFacts2[TypeFacts2["FunctionFacts"] = 16728e3] = "FunctionFacts";
        TypeFacts2[TypeFacts2["UndefinedFacts"] = 9830144] = "UndefinedFacts";
        TypeFacts2[TypeFacts2["NullFacts"] = 9363232] = "NullFacts";
        TypeFacts2[TypeFacts2["EmptyObjectStrictFacts"] = 16318463] = "EmptyObjectStrictFacts";
        TypeFacts2[TypeFacts2["AllTypeofNE"] = 556800] = "AllTypeofNE";
        TypeFacts2[TypeFacts2["EmptyObjectFacts"] = 16777215] = "EmptyObjectFacts";
      })(TypeFacts || (TypeFacts = {}));
      var typeofEQFacts = new ts3.Map(ts3.getEntries({
        string: 1,
        number: 2,
        bigint: 4,
        boolean: 8,
        symbol: 16,
        undefined: 65536,
        object: 32,
        function: 64
      }));
      var typeofNEFacts = new ts3.Map(ts3.getEntries({
        string: 256,
        number: 512,
        bigint: 1024,
        boolean: 2048,
        symbol: 4096,
        undefined: 524288,
        object: 8192,
        function: 16384
      }));
      var TypeSystemPropertyName;
      (function(TypeSystemPropertyName2) {
        TypeSystemPropertyName2[TypeSystemPropertyName2["Type"] = 0] = "Type";
        TypeSystemPropertyName2[TypeSystemPropertyName2["ResolvedBaseConstructorType"] = 1] = "ResolvedBaseConstructorType";
        TypeSystemPropertyName2[TypeSystemPropertyName2["DeclaredType"] = 2] = "DeclaredType";
        TypeSystemPropertyName2[TypeSystemPropertyName2["ResolvedReturnType"] = 3] = "ResolvedReturnType";
        TypeSystemPropertyName2[TypeSystemPropertyName2["ImmediateBaseConstraint"] = 4] = "ImmediateBaseConstraint";
        TypeSystemPropertyName2[TypeSystemPropertyName2["EnumTagType"] = 5] = "EnumTagType";
        TypeSystemPropertyName2[TypeSystemPropertyName2["ResolvedTypeArguments"] = 6] = "ResolvedTypeArguments";
        TypeSystemPropertyName2[TypeSystemPropertyName2["ResolvedBaseTypes"] = 7] = "ResolvedBaseTypes";
      })(TypeSystemPropertyName || (TypeSystemPropertyName = {}));
      var CheckMode;
      (function(CheckMode2) {
        CheckMode2[CheckMode2["Normal"] = 0] = "Normal";
        CheckMode2[CheckMode2["Contextual"] = 1] = "Contextual";
        CheckMode2[CheckMode2["Inferential"] = 2] = "Inferential";
        CheckMode2[CheckMode2["SkipContextSensitive"] = 4] = "SkipContextSensitive";
        CheckMode2[CheckMode2["SkipGenericFunctions"] = 8] = "SkipGenericFunctions";
        CheckMode2[CheckMode2["IsForSignatureHelp"] = 16] = "IsForSignatureHelp";
      })(CheckMode || (CheckMode = {}));
      var AccessFlags;
      (function(AccessFlags2) {
        AccessFlags2[AccessFlags2["None"] = 0] = "None";
        AccessFlags2[AccessFlags2["NoIndexSignatures"] = 1] = "NoIndexSignatures";
        AccessFlags2[AccessFlags2["Writing"] = 2] = "Writing";
        AccessFlags2[AccessFlags2["CacheSymbol"] = 4] = "CacheSymbol";
        AccessFlags2[AccessFlags2["NoTupleBoundsCheck"] = 8] = "NoTupleBoundsCheck";
        AccessFlags2[AccessFlags2["ExpressionPosition"] = 16] = "ExpressionPosition";
      })(AccessFlags || (AccessFlags = {}));
      var SignatureCheckMode;
      (function(SignatureCheckMode2) {
        SignatureCheckMode2[SignatureCheckMode2["BivariantCallback"] = 1] = "BivariantCallback";
        SignatureCheckMode2[SignatureCheckMode2["StrictCallback"] = 2] = "StrictCallback";
        SignatureCheckMode2[SignatureCheckMode2["IgnoreReturnTypes"] = 4] = "IgnoreReturnTypes";
        SignatureCheckMode2[SignatureCheckMode2["StrictArity"] = 8] = "StrictArity";
        SignatureCheckMode2[SignatureCheckMode2["Callback"] = 3] = "Callback";
      })(SignatureCheckMode || (SignatureCheckMode = {}));
      var IntersectionState;
      (function(IntersectionState2) {
        IntersectionState2[IntersectionState2["None"] = 0] = "None";
        IntersectionState2[IntersectionState2["Source"] = 1] = "Source";
        IntersectionState2[IntersectionState2["Target"] = 2] = "Target";
        IntersectionState2[IntersectionState2["PropertyCheck"] = 4] = "PropertyCheck";
        IntersectionState2[IntersectionState2["UnionIntersectionCheck"] = 8] = "UnionIntersectionCheck";
        IntersectionState2[IntersectionState2["InPropertyCheck"] = 16] = "InPropertyCheck";
      })(IntersectionState || (IntersectionState = {}));
      var MappedTypeModifiers;
      (function(MappedTypeModifiers2) {
        MappedTypeModifiers2[MappedTypeModifiers2["IncludeReadonly"] = 1] = "IncludeReadonly";
        MappedTypeModifiers2[MappedTypeModifiers2["ExcludeReadonly"] = 2] = "ExcludeReadonly";
        MappedTypeModifiers2[MappedTypeModifiers2["IncludeOptional"] = 4] = "IncludeOptional";
        MappedTypeModifiers2[MappedTypeModifiers2["ExcludeOptional"] = 8] = "ExcludeOptional";
      })(MappedTypeModifiers || (MappedTypeModifiers = {}));
      var ExpandingFlags;
      (function(ExpandingFlags2) {
        ExpandingFlags2[ExpandingFlags2["None"] = 0] = "None";
        ExpandingFlags2[ExpandingFlags2["Source"] = 1] = "Source";
        ExpandingFlags2[ExpandingFlags2["Target"] = 2] = "Target";
        ExpandingFlags2[ExpandingFlags2["Both"] = 3] = "Both";
      })(ExpandingFlags || (ExpandingFlags = {}));
      var MembersOrExportsResolutionKind;
      (function(MembersOrExportsResolutionKind2) {
        MembersOrExportsResolutionKind2["resolvedExports"] = "resolvedExports";
        MembersOrExportsResolutionKind2["resolvedMembers"] = "resolvedMembers";
      })(MembersOrExportsResolutionKind || (MembersOrExportsResolutionKind = {}));
      var UnusedKind;
      (function(UnusedKind2) {
        UnusedKind2[UnusedKind2["Local"] = 0] = "Local";
        UnusedKind2[UnusedKind2["Parameter"] = 1] = "Parameter";
      })(UnusedKind || (UnusedKind = {}));
      var isNotOverloadAndNotAccessor = ts3.and(isNotOverload, isNotAccessor);
      var DeclarationMeaning;
      (function(DeclarationMeaning2) {
        DeclarationMeaning2[DeclarationMeaning2["GetAccessor"] = 1] = "GetAccessor";
        DeclarationMeaning2[DeclarationMeaning2["SetAccessor"] = 2] = "SetAccessor";
        DeclarationMeaning2[DeclarationMeaning2["PropertyAssignment"] = 4] = "PropertyAssignment";
        DeclarationMeaning2[DeclarationMeaning2["Method"] = 8] = "Method";
        DeclarationMeaning2[DeclarationMeaning2["PrivateStatic"] = 16] = "PrivateStatic";
        DeclarationMeaning2[DeclarationMeaning2["GetOrSetAccessor"] = 3] = "GetOrSetAccessor";
        DeclarationMeaning2[DeclarationMeaning2["PropertyAssignmentOrMethod"] = 12] = "PropertyAssignmentOrMethod";
      })(DeclarationMeaning || (DeclarationMeaning = {}));
      var DeclarationSpaces;
      (function(DeclarationSpaces2) {
        DeclarationSpaces2[DeclarationSpaces2["None"] = 0] = "None";
        DeclarationSpaces2[DeclarationSpaces2["ExportValue"] = 1] = "ExportValue";
        DeclarationSpaces2[DeclarationSpaces2["ExportType"] = 2] = "ExportType";
        DeclarationSpaces2[DeclarationSpaces2["ExportNamespace"] = 4] = "ExportNamespace";
      })(DeclarationSpaces || (DeclarationSpaces = {}));
      var MinArgumentCountFlags;
      (function(MinArgumentCountFlags2) {
        MinArgumentCountFlags2[MinArgumentCountFlags2["None"] = 0] = "None";
        MinArgumentCountFlags2[MinArgumentCountFlags2["StrongArityForUntypedJS"] = 1] = "StrongArityForUntypedJS";
        MinArgumentCountFlags2[MinArgumentCountFlags2["VoidIsNonOptional"] = 2] = "VoidIsNonOptional";
      })(MinArgumentCountFlags || (MinArgumentCountFlags = {}));
      var IntrinsicTypeKind;
      (function(IntrinsicTypeKind2) {
        IntrinsicTypeKind2[IntrinsicTypeKind2["Uppercase"] = 0] = "Uppercase";
        IntrinsicTypeKind2[IntrinsicTypeKind2["Lowercase"] = 1] = "Lowercase";
        IntrinsicTypeKind2[IntrinsicTypeKind2["Capitalize"] = 2] = "Capitalize";
        IntrinsicTypeKind2[IntrinsicTypeKind2["Uncapitalize"] = 3] = "Uncapitalize";
      })(IntrinsicTypeKind || (IntrinsicTypeKind = {}));
      var intrinsicTypeKinds = new ts3.Map(ts3.getEntries({
        Uppercase: 0,
        Lowercase: 1,
        Capitalize: 2,
        Uncapitalize: 3
      }));
      function SymbolLinks() {
      }
      function NodeLinks() {
        this.flags = 0;
      }
      function getNodeId(node) {
        if (!node.id) {
          node.id = nextNodeId;
          nextNodeId++;
        }
        return node.id;
      }
      ts3.getNodeId = getNodeId;
      function getSymbolId(symbol) {
        if (!symbol.id) {
          symbol.id = nextSymbolId;
          nextSymbolId++;
        }
        return symbol.id;
      }
      ts3.getSymbolId = getSymbolId;
      function isInstantiatedModule(node, preserveConstEnums) {
        var moduleState = ts3.getModuleInstanceState(node);
        return moduleState === 1 || preserveConstEnums && moduleState === 2;
      }
      ts3.isInstantiatedModule = isInstantiatedModule;
      function createTypeChecker(host, produceDiagnostics) {
        var getPackagesSet = ts3.memoize(function() {
          var set2 = new ts3.Set();
          host.getSourceFiles().forEach(function(sf) {
            if (!sf.resolvedModules)
              return;
            ts3.forEachEntry(sf.resolvedModules, function(r2) {
              if (r2 && r2.packageId)
                set2.add(r2.packageId.name);
            });
          });
          return set2;
        });
        var cancellationToken;
        var requestedExternalEmitHelpers;
        var externalHelpersModule;
        var Symbol2 = ts3.objectAllocator.getSymbolConstructor();
        var Type2 = ts3.objectAllocator.getTypeConstructor();
        var Signature = ts3.objectAllocator.getSignatureConstructor();
        var typeCount = 0;
        var symbolCount = 0;
        var enumCount = 0;
        var totalInstantiationCount = 0;
        var instantiationCount = 0;
        var instantiationDepth = 0;
        var currentNode;
        var emptySymbols = ts3.createSymbolTable();
        var arrayVariances = [1];
        var compilerOptions = host.getCompilerOptions();
        var languageVersion = ts3.getEmitScriptTarget(compilerOptions);
        var moduleKind = ts3.getEmitModuleKind(compilerOptions);
        var useDefineForClassFields = ts3.getUseDefineForClassFields(compilerOptions);
        var allowSyntheticDefaultImports = ts3.getAllowSyntheticDefaultImports(compilerOptions);
        var strictNullChecks = ts3.getStrictOptionValue(compilerOptions, "strictNullChecks");
        var strictFunctionTypes = ts3.getStrictOptionValue(compilerOptions, "strictFunctionTypes");
        var strictBindCallApply = ts3.getStrictOptionValue(compilerOptions, "strictBindCallApply");
        var strictPropertyInitialization = ts3.getStrictOptionValue(compilerOptions, "strictPropertyInitialization");
        var noImplicitAny = ts3.getStrictOptionValue(compilerOptions, "noImplicitAny");
        var noImplicitThis = ts3.getStrictOptionValue(compilerOptions, "noImplicitThis");
        var keyofStringsOnly = !!compilerOptions.keyofStringsOnly;
        var freshObjectLiteralFlag = compilerOptions.suppressExcessPropertyErrors ? 0 : 16384;
        var checkBinaryExpression = createCheckBinaryExpression();
        var emitResolver = createResolver();
        var nodeBuilder = createNodeBuilder();
        var globals = ts3.createSymbolTable();
        var undefinedSymbol = createSymbol(4, "undefined");
        undefinedSymbol.declarations = [];
        var globalThisSymbol = createSymbol(1536, "globalThis", 8);
        globalThisSymbol.exports = globals;
        globalThisSymbol.declarations = [];
        globals.set(globalThisSymbol.escapedName, globalThisSymbol);
        var argumentsSymbol = createSymbol(4, "arguments");
        var requireSymbol = createSymbol(4, "require");
        var apparentArgumentCount;
        var checker = {
          getNodeCount: function() {
            return ts3.sum(host.getSourceFiles(), "nodeCount");
          },
          getIdentifierCount: function() {
            return ts3.sum(host.getSourceFiles(), "identifierCount");
          },
          getSymbolCount: function() {
            return ts3.sum(host.getSourceFiles(), "symbolCount") + symbolCount;
          },
          getTypeCount: function() {
            return typeCount;
          },
          getInstantiationCount: function() {
            return totalInstantiationCount;
          },
          getRelationCacheSizes: function() {
            return {
              assignable: assignableRelation.size,
              identity: identityRelation.size,
              subtype: subtypeRelation.size,
              strictSubtype: strictSubtypeRelation.size
            };
          },
          isUndefinedSymbol: function(symbol) {
            return symbol === undefinedSymbol;
          },
          isArgumentsSymbol: function(symbol) {
            return symbol === argumentsSymbol;
          },
          isUnknownSymbol: function(symbol) {
            return symbol === unknownSymbol;
          },
          getMergedSymbol,
          getDiagnostics,
          getGlobalDiagnostics,
          getRecursionIdentity,
          getTypeOfSymbolAtLocation: function(symbol, locationIn) {
            var location = ts3.getParseTreeNode(locationIn);
            return location ? getTypeOfSymbolAtLocation(symbol, location) : errorType;
          },
          getSymbolsOfParameterPropertyDeclaration: function(parameterIn, parameterName) {
            var parameter = ts3.getParseTreeNode(parameterIn, ts3.isParameter);
            if (parameter === void 0)
              return ts3.Debug.fail("Cannot get symbols of a synthetic parameter that cannot be resolved to a parse-tree node.");
            return getSymbolsOfParameterPropertyDeclaration(parameter, ts3.escapeLeadingUnderscores(parameterName));
          },
          getDeclaredTypeOfSymbol,
          getPropertiesOfType,
          getPropertyOfType: function(type3, name) {
            return getPropertyOfType(type3, ts3.escapeLeadingUnderscores(name));
          },
          getPrivateIdentifierPropertyOfType: function(leftType, name, location) {
            var node = ts3.getParseTreeNode(location);
            if (!node) {
              return void 0;
            }
            var propName = ts3.escapeLeadingUnderscores(name);
            var lexicallyScopedIdentifier = lookupSymbolForPrivateIdentifierDeclaration(propName, node);
            return lexicallyScopedIdentifier ? getPrivateIdentifierPropertyOfType(leftType, lexicallyScopedIdentifier) : void 0;
          },
          getTypeOfPropertyOfType: function(type3, name) {
            return getTypeOfPropertyOfType(type3, ts3.escapeLeadingUnderscores(name));
          },
          getIndexInfoOfType,
          getSignaturesOfType,
          getIndexTypeOfType,
          getBaseTypes,
          getBaseTypeOfLiteralType,
          getWidenedType,
          getTypeFromTypeNode: function(nodeIn) {
            var node = ts3.getParseTreeNode(nodeIn, ts3.isTypeNode);
            return node ? getTypeFromTypeNode(node) : errorType;
          },
          getParameterType: getTypeAtPosition,
          getPromisedTypeOfPromise,
          getAwaitedType: function(type3) {
            return getAwaitedType(type3);
          },
          getReturnTypeOfSignature,
          isNullableType,
          getNullableType,
          getNonNullableType,
          getNonOptionalType: removeOptionalTypeMarker,
          getTypeArguments,
          typeToTypeNode: nodeBuilder.typeToTypeNode,
          indexInfoToIndexSignatureDeclaration: nodeBuilder.indexInfoToIndexSignatureDeclaration,
          signatureToSignatureDeclaration: nodeBuilder.signatureToSignatureDeclaration,
          symbolToEntityName: nodeBuilder.symbolToEntityName,
          symbolToExpression: nodeBuilder.symbolToExpression,
          symbolToTypeParameterDeclarations: nodeBuilder.symbolToTypeParameterDeclarations,
          symbolToParameterDeclaration: nodeBuilder.symbolToParameterDeclaration,
          typeParameterToDeclaration: nodeBuilder.typeParameterToDeclaration,
          getSymbolsInScope: function(locationIn, meaning) {
            var location = ts3.getParseTreeNode(locationIn);
            return location ? getSymbolsInScope(location, meaning) : [];
          },
          getSymbolAtLocation: function(nodeIn) {
            var node = ts3.getParseTreeNode(nodeIn);
            return node ? getSymbolAtLocation(node, true) : void 0;
          },
          getShorthandAssignmentValueSymbol: function(nodeIn) {
            var node = ts3.getParseTreeNode(nodeIn);
            return node ? getShorthandAssignmentValueSymbol(node) : void 0;
          },
          getExportSpecifierLocalTargetSymbol: function(nodeIn) {
            var node = ts3.getParseTreeNode(nodeIn, ts3.isExportSpecifier);
            return node ? getExportSpecifierLocalTargetSymbol(node) : void 0;
          },
          getExportSymbolOfSymbol: function(symbol) {
            return getMergedSymbol(symbol.exportSymbol || symbol);
          },
          getTypeAtLocation: function(nodeIn) {
            var node = ts3.getParseTreeNode(nodeIn);
            return node ? getTypeOfNode(node) : errorType;
          },
          getTypeOfAssignmentPattern: function(nodeIn) {
            var node = ts3.getParseTreeNode(nodeIn, ts3.isAssignmentPattern);
            return node && getTypeOfAssignmentPattern(node) || errorType;
          },
          getPropertySymbolOfDestructuringAssignment: function(locationIn) {
            var location = ts3.getParseTreeNode(locationIn, ts3.isIdentifier);
            return location ? getPropertySymbolOfDestructuringAssignment(location) : void 0;
          },
          signatureToString: function(signature, enclosingDeclaration, flags, kind) {
            return signatureToString(signature, ts3.getParseTreeNode(enclosingDeclaration), flags, kind);
          },
          typeToString: function(type3, enclosingDeclaration, flags) {
            return typeToString(type3, ts3.getParseTreeNode(enclosingDeclaration), flags);
          },
          symbolToString: function(symbol, enclosingDeclaration, meaning, flags) {
            return symbolToString(symbol, ts3.getParseTreeNode(enclosingDeclaration), meaning, flags);
          },
          typePredicateToString: function(predicate, enclosingDeclaration, flags) {
            return typePredicateToString(predicate, ts3.getParseTreeNode(enclosingDeclaration), flags);
          },
          writeSignature: function(signature, enclosingDeclaration, flags, kind, writer) {
            return signatureToString(signature, ts3.getParseTreeNode(enclosingDeclaration), flags, kind, writer);
          },
          writeType: function(type3, enclosingDeclaration, flags, writer) {
            return typeToString(type3, ts3.getParseTreeNode(enclosingDeclaration), flags, writer);
          },
          writeSymbol: function(symbol, enclosingDeclaration, meaning, flags, writer) {
            return symbolToString(symbol, ts3.getParseTreeNode(enclosingDeclaration), meaning, flags, writer);
          },
          writeTypePredicate: function(predicate, enclosingDeclaration, flags, writer) {
            return typePredicateToString(predicate, ts3.getParseTreeNode(enclosingDeclaration), flags, writer);
          },
          getAugmentedPropertiesOfType,
          getRootSymbols,
          getSymbolOfExpando,
          getContextualType: function(nodeIn, contextFlags) {
            var node = ts3.getParseTreeNode(nodeIn, ts3.isExpression);
            if (!node) {
              return void 0;
            }
            var containingCall = ts3.findAncestor(node, ts3.isCallLikeExpression);
            var containingCallResolvedSignature = containingCall && getNodeLinks(containingCall).resolvedSignature;
            if (contextFlags & 4 && containingCall) {
              var toMarkSkip = node;
              do {
                getNodeLinks(toMarkSkip).skipDirectInference = true;
                toMarkSkip = toMarkSkip.parent;
              } while (toMarkSkip && toMarkSkip !== containingCall);
              getNodeLinks(containingCall).resolvedSignature = void 0;
            }
            var result2 = getContextualType(node, contextFlags);
            if (contextFlags & 4 && containingCall) {
              var toMarkSkip = node;
              do {
                getNodeLinks(toMarkSkip).skipDirectInference = void 0;
                toMarkSkip = toMarkSkip.parent;
              } while (toMarkSkip && toMarkSkip !== containingCall);
              getNodeLinks(containingCall).resolvedSignature = containingCallResolvedSignature;
            }
            return result2;
          },
          getContextualTypeForObjectLiteralElement: function(nodeIn) {
            var node = ts3.getParseTreeNode(nodeIn, ts3.isObjectLiteralElementLike);
            return node ? getContextualTypeForObjectLiteralElement(node) : void 0;
          },
          getContextualTypeForArgumentAtIndex: function(nodeIn, argIndex) {
            var node = ts3.getParseTreeNode(nodeIn, ts3.isCallLikeExpression);
            return node && getContextualTypeForArgumentAtIndex(node, argIndex);
          },
          getContextualTypeForJsxAttribute: function(nodeIn) {
            var node = ts3.getParseTreeNode(nodeIn, ts3.isJsxAttributeLike);
            return node && getContextualTypeForJsxAttribute(node);
          },
          isContextSensitive,
          getTypeOfPropertyOfContextualType,
          getFullyQualifiedName,
          getResolvedSignature: function(node, candidatesOutArray, argumentCount) {
            return getResolvedSignatureWorker(node, candidatesOutArray, argumentCount, 0);
          },
          getResolvedSignatureForSignatureHelp: function(node, candidatesOutArray, argumentCount) {
            return getResolvedSignatureWorker(node, candidatesOutArray, argumentCount, 16);
          },
          getExpandedParameters,
          hasEffectiveRestParameter,
          getConstantValue: function(nodeIn) {
            var node = ts3.getParseTreeNode(nodeIn, canHaveConstantValue);
            return node ? getConstantValue(node) : void 0;
          },
          isValidPropertyAccess: function(nodeIn, propertyName) {
            var node = ts3.getParseTreeNode(nodeIn, ts3.isPropertyAccessOrQualifiedNameOrImportTypeNode);
            return !!node && isValidPropertyAccess(node, ts3.escapeLeadingUnderscores(propertyName));
          },
          isValidPropertyAccessForCompletions: function(nodeIn, type3, property) {
            var node = ts3.getParseTreeNode(nodeIn, ts3.isPropertyAccessExpression);
            return !!node && isValidPropertyAccessForCompletions(node, type3, property);
          },
          getSignatureFromDeclaration: function(declarationIn) {
            var declaration = ts3.getParseTreeNode(declarationIn, ts3.isFunctionLike);
            return declaration ? getSignatureFromDeclaration(declaration) : void 0;
          },
          isImplementationOfOverload: function(nodeIn) {
            var node = ts3.getParseTreeNode(nodeIn, ts3.isFunctionLike);
            return node ? isImplementationOfOverload(node) : void 0;
          },
          getImmediateAliasedSymbol,
          getAliasedSymbol: resolveAlias,
          getEmitResolver,
          getExportsOfModule: getExportsOfModuleAsArray,
          getExportsAndPropertiesOfModule,
          getSymbolWalker: ts3.createGetSymbolWalker(getRestTypeOfSignature, getTypePredicateOfSignature, getReturnTypeOfSignature, getBaseTypes, resolveStructuredTypeMembers, getTypeOfSymbol, getResolvedSymbol, getIndexTypeOfStructuredType, getConstraintOfTypeParameter, ts3.getFirstIdentifier, getTypeArguments),
          getAmbientModules,
          getJsxIntrinsicTagNamesAt,
          isOptionalParameter: function(nodeIn) {
            var node = ts3.getParseTreeNode(nodeIn, ts3.isParameter);
            return node ? isOptionalParameter(node) : false;
          },
          tryGetMemberInModuleExports: function(name, symbol) {
            return tryGetMemberInModuleExports(ts3.escapeLeadingUnderscores(name), symbol);
          },
          tryGetMemberInModuleExportsAndProperties: function(name, symbol) {
            return tryGetMemberInModuleExportsAndProperties(ts3.escapeLeadingUnderscores(name), symbol);
          },
          tryFindAmbientModule: function(moduleName) {
            return tryFindAmbientModule(moduleName, true);
          },
          tryFindAmbientModuleWithoutAugmentations: function(moduleName) {
            return tryFindAmbientModule(moduleName, false);
          },
          getApparentType,
          getUnionType,
          isTypeAssignableTo,
          createAnonymousType,
          createSignature,
          createSymbol,
          createIndexInfo,
          getAnyType: function() {
            return anyType;
          },
          getStringType: function() {
            return stringType;
          },
          getNumberType: function() {
            return numberType;
          },
          createPromiseType,
          createArrayType,
          getElementTypeOfArrayType,
          getBooleanType: function() {
            return booleanType;
          },
          getFalseType: function(fresh) {
            return fresh ? falseType : regularFalseType;
          },
          getTrueType: function(fresh) {
            return fresh ? trueType : regularTrueType;
          },
          getVoidType: function() {
            return voidType;
          },
          getUndefinedType: function() {
            return undefinedType;
          },
          getNullType: function() {
            return nullType;
          },
          getESSymbolType: function() {
            return esSymbolType;
          },
          getNeverType: function() {
            return neverType;
          },
          getOptionalType: function() {
            return optionalType;
          },
          isSymbolAccessible,
          isArrayType,
          isTupleType,
          isArrayLikeType,
          isTypeInvalidDueToUnionDiscriminant,
          getAllPossiblePropertiesOfTypes,
          getSuggestedSymbolForNonexistentProperty,
          getSuggestionForNonexistentProperty,
          getSuggestedSymbolForNonexistentJSXAttribute,
          getSuggestedSymbolForNonexistentSymbol: function(location, name, meaning) {
            return getSuggestedSymbolForNonexistentSymbol(location, ts3.escapeLeadingUnderscores(name), meaning);
          },
          getSuggestionForNonexistentSymbol: function(location, name, meaning) {
            return getSuggestionForNonexistentSymbol(location, ts3.escapeLeadingUnderscores(name), meaning);
          },
          getSuggestedSymbolForNonexistentModule,
          getSuggestionForNonexistentExport,
          getBaseConstraintOfType,
          getDefaultFromTypeParameter: function(type3) {
            return type3 && type3.flags & 262144 ? getDefaultFromTypeParameter(type3) : void 0;
          },
          resolveName: function(name, location, meaning, excludeGlobals) {
            return resolveName(location, ts3.escapeLeadingUnderscores(name), meaning, void 0, void 0, false, excludeGlobals);
          },
          getJsxNamespace: function(n2) {
            return ts3.unescapeLeadingUnderscores(getJsxNamespace(n2));
          },
          getJsxFragmentFactory: function(n2) {
            var jsxFragmentFactory = getJsxFragmentFactoryEntity(n2);
            return jsxFragmentFactory && ts3.unescapeLeadingUnderscores(ts3.getFirstIdentifier(jsxFragmentFactory).escapedText);
          },
          getAccessibleSymbolChain,
          getTypePredicateOfSignature,
          resolveExternalModuleName: function(moduleSpecifierIn) {
            var moduleSpecifier = ts3.getParseTreeNode(moduleSpecifierIn, ts3.isExpression);
            return moduleSpecifier && resolveExternalModuleName(moduleSpecifier, moduleSpecifier, true);
          },
          resolveExternalModuleSymbol,
          tryGetThisTypeAt: function(nodeIn, includeGlobalThis) {
            var node = ts3.getParseTreeNode(nodeIn);
            return node && tryGetThisTypeAt(node, includeGlobalThis);
          },
          getTypeArgumentConstraint: function(nodeIn) {
            var node = ts3.getParseTreeNode(nodeIn, ts3.isTypeNode);
            return node && getTypeArgumentConstraint(node);
          },
          getSuggestionDiagnostics: function(fileIn, ct) {
            var file = ts3.getParseTreeNode(fileIn, ts3.isSourceFile) || ts3.Debug.fail("Could not determine parsed source file.");
            if (ts3.skipTypeChecking(file, compilerOptions, host)) {
              return ts3.emptyArray;
            }
            var diagnostics2;
            try {
              cancellationToken = ct;
              checkSourceFile(file);
              ts3.Debug.assert(!!(getNodeLinks(file).flags & 1));
              diagnostics2 = ts3.addRange(diagnostics2, suggestionDiagnostics.getDiagnostics(file.fileName));
              checkUnusedIdentifiers(getPotentiallyUnusedIdentifiers(file), function(containingNode, kind, diag) {
                if (!ts3.containsParseError(containingNode) && !unusedIsError(kind, !!(containingNode.flags & 8388608))) {
                  (diagnostics2 || (diagnostics2 = [])).push(__assign(__assign({}, diag), { category: ts3.DiagnosticCategory.Suggestion }));
                }
              });
              return diagnostics2 || ts3.emptyArray;
            } finally {
              cancellationToken = void 0;
            }
          },
          runWithCancellationToken: function(token, callback) {
            try {
              cancellationToken = token;
              return callback(checker);
            } finally {
              cancellationToken = void 0;
            }
          },
          getLocalTypeParametersOfClassOrInterfaceOrTypeAlias,
          isDeclarationVisible
        };
        function getResolvedSignatureWorker(nodeIn, candidatesOutArray, argumentCount, checkMode) {
          var node = ts3.getParseTreeNode(nodeIn, ts3.isCallLikeExpression);
          apparentArgumentCount = argumentCount;
          var res = node ? getResolvedSignature(node, candidatesOutArray, checkMode) : void 0;
          apparentArgumentCount = void 0;
          return res;
        }
        var tupleTypes = new ts3.Map();
        var unionTypes = new ts3.Map();
        var intersectionTypes = new ts3.Map();
        var literalTypes = new ts3.Map();
        var indexedAccessTypes = new ts3.Map();
        var templateLiteralTypes = new ts3.Map();
        var stringMappingTypes = new ts3.Map();
        var substitutionTypes = new ts3.Map();
        var subtypeReductionCache = new ts3.Map();
        var evolvingArrayTypes = [];
        var undefinedProperties = new ts3.Map();
        var unknownSymbol = createSymbol(4, "unknown");
        var resolvingSymbol = createSymbol(0, "__resolving__");
        var anyType = createIntrinsicType(1, "any");
        var autoType = createIntrinsicType(1, "any");
        var wildcardType = createIntrinsicType(1, "any");
        var errorType = createIntrinsicType(1, "error");
        var nonInferrableAnyType = createIntrinsicType(1, "any", 131072);
        var intrinsicMarkerType = createIntrinsicType(1, "intrinsic");
        var unknownType = createIntrinsicType(2, "unknown");
        var undefinedType = createIntrinsicType(32768, "undefined");
        var undefinedWideningType = strictNullChecks ? undefinedType : createIntrinsicType(32768, "undefined", 131072);
        var optionalType = createIntrinsicType(32768, "undefined");
        var nullType = createIntrinsicType(65536, "null");
        var nullWideningType = strictNullChecks ? nullType : createIntrinsicType(65536, "null", 131072);
        var stringType = createIntrinsicType(4, "string");
        var numberType = createIntrinsicType(8, "number");
        var bigintType = createIntrinsicType(64, "bigint");
        var falseType = createIntrinsicType(512, "false");
        var regularFalseType = createIntrinsicType(512, "false");
        var trueType = createIntrinsicType(512, "true");
        var regularTrueType = createIntrinsicType(512, "true");
        trueType.regularType = regularTrueType;
        trueType.freshType = trueType;
        regularTrueType.regularType = regularTrueType;
        regularTrueType.freshType = trueType;
        falseType.regularType = regularFalseType;
        falseType.freshType = falseType;
        regularFalseType.regularType = regularFalseType;
        regularFalseType.freshType = falseType;
        var booleanType = createBooleanType([regularFalseType, regularTrueType]);
        createBooleanType([regularFalseType, trueType]);
        createBooleanType([falseType, regularTrueType]);
        createBooleanType([falseType, trueType]);
        var esSymbolType = createIntrinsicType(4096, "symbol");
        var voidType = createIntrinsicType(16384, "void");
        var neverType = createIntrinsicType(131072, "never");
        var silentNeverType = createIntrinsicType(131072, "never");
        var nonInferrableType = createIntrinsicType(131072, "never", 524288);
        var implicitNeverType = createIntrinsicType(131072, "never");
        var unreachableNeverType = createIntrinsicType(131072, "never");
        var nonPrimitiveType = createIntrinsicType(67108864, "object");
        var stringNumberSymbolType = getUnionType([stringType, numberType, esSymbolType]);
        var keyofConstraintType = keyofStringsOnly ? stringType : stringNumberSymbolType;
        var numberOrBigIntType = getUnionType([numberType, bigintType]);
        var templateConstraintType = getUnionType([stringType, numberType, booleanType, bigintType, nullType, undefinedType]);
        var restrictiveMapper = makeFunctionTypeMapper(function(t2) {
          return t2.flags & 262144 ? getRestrictiveTypeParameter(t2) : t2;
        });
        var permissiveMapper = makeFunctionTypeMapper(function(t2) {
          return t2.flags & 262144 ? wildcardType : t2;
        });
        var emptyObjectType = createAnonymousType(void 0, emptySymbols, ts3.emptyArray, ts3.emptyArray, void 0, void 0);
        var emptyJsxObjectType = createAnonymousType(void 0, emptySymbols, ts3.emptyArray, ts3.emptyArray, void 0, void 0);
        emptyJsxObjectType.objectFlags |= 2048;
        var emptyTypeLiteralSymbol = createSymbol(2048, "__type");
        emptyTypeLiteralSymbol.members = ts3.createSymbolTable();
        var emptyTypeLiteralType = createAnonymousType(emptyTypeLiteralSymbol, emptySymbols, ts3.emptyArray, ts3.emptyArray, void 0, void 0);
        var emptyGenericType = createAnonymousType(void 0, emptySymbols, ts3.emptyArray, ts3.emptyArray, void 0, void 0);
        emptyGenericType.instantiations = new ts3.Map();
        var anyFunctionType = createAnonymousType(void 0, emptySymbols, ts3.emptyArray, ts3.emptyArray, void 0, void 0);
        anyFunctionType.objectFlags |= 524288;
        var noConstraintType = createAnonymousType(void 0, emptySymbols, ts3.emptyArray, ts3.emptyArray, void 0, void 0);
        var circularConstraintType = createAnonymousType(void 0, emptySymbols, ts3.emptyArray, ts3.emptyArray, void 0, void 0);
        var resolvingDefaultType = createAnonymousType(void 0, emptySymbols, ts3.emptyArray, ts3.emptyArray, void 0, void 0);
        var markerSuperType = createTypeParameter();
        var markerSubType = createTypeParameter();
        markerSubType.constraint = markerSuperType;
        var markerOtherType = createTypeParameter();
        var noTypePredicate = createTypePredicate(1, "<<unresolved>>", 0, anyType);
        var anySignature = createSignature(void 0, void 0, void 0, ts3.emptyArray, anyType, void 0, 0, 0);
        var unknownSignature = createSignature(void 0, void 0, void 0, ts3.emptyArray, errorType, void 0, 0, 0);
        var resolvingSignature = createSignature(void 0, void 0, void 0, ts3.emptyArray, anyType, void 0, 0, 0);
        var silentNeverSignature = createSignature(void 0, void 0, void 0, ts3.emptyArray, silentNeverType, void 0, 0, 0);
        var enumNumberIndexInfo = createIndexInfo(stringType, true);
        var iterationTypesCache = new ts3.Map();
        var noIterationTypes = {
          get yieldType() {
            return ts3.Debug.fail("Not supported");
          },
          get returnType() {
            return ts3.Debug.fail("Not supported");
          },
          get nextType() {
            return ts3.Debug.fail("Not supported");
          }
        };
        var anyIterationTypes = createIterationTypes(anyType, anyType, anyType);
        var anyIterationTypesExceptNext = createIterationTypes(anyType, anyType, unknownType);
        var defaultIterationTypes = createIterationTypes(neverType, anyType, undefinedType);
        var asyncIterationTypesResolver = {
          iterableCacheKey: "iterationTypesOfAsyncIterable",
          iteratorCacheKey: "iterationTypesOfAsyncIterator",
          iteratorSymbolName: "asyncIterator",
          getGlobalIteratorType: getGlobalAsyncIteratorType,
          getGlobalIterableType: getGlobalAsyncIterableType,
          getGlobalIterableIteratorType: getGlobalAsyncIterableIteratorType,
          getGlobalGeneratorType: getGlobalAsyncGeneratorType,
          resolveIterationType: getAwaitedType,
          mustHaveANextMethodDiagnostic: ts3.Diagnostics.An_async_iterator_must_have_a_next_method,
          mustBeAMethodDiagnostic: ts3.Diagnostics.The_0_property_of_an_async_iterator_must_be_a_method,
          mustHaveAValueDiagnostic: ts3.Diagnostics.The_type_returned_by_the_0_method_of_an_async_iterator_must_be_a_promise_for_a_type_with_a_value_property
        };
        var syncIterationTypesResolver = {
          iterableCacheKey: "iterationTypesOfIterable",
          iteratorCacheKey: "iterationTypesOfIterator",
          iteratorSymbolName: "iterator",
          getGlobalIteratorType,
          getGlobalIterableType,
          getGlobalIterableIteratorType,
          getGlobalGeneratorType,
          resolveIterationType: function(type3, _errorNode) {
            return type3;
          },
          mustHaveANextMethodDiagnostic: ts3.Diagnostics.An_iterator_must_have_a_next_method,
          mustBeAMethodDiagnostic: ts3.Diagnostics.The_0_property_of_an_iterator_must_be_a_method,
          mustHaveAValueDiagnostic: ts3.Diagnostics.The_type_returned_by_the_0_method_of_an_iterator_must_have_a_value_property
        };
        var amalgamatedDuplicates;
        var reverseMappedCache = new ts3.Map();
        var inInferTypeForHomomorphicMappedType = false;
        var ambientModulesCache;
        var patternAmbientModules;
        var patternAmbientModuleAugmentations;
        var globalObjectType;
        var globalFunctionType;
        var globalCallableFunctionType;
        var globalNewableFunctionType;
        var globalArrayType;
        var globalReadonlyArrayType;
        var globalStringType;
        var globalNumberType;
        var globalBooleanType;
        var globalRegExpType;
        var globalThisType;
        var anyArrayType;
        var autoArrayType;
        var anyReadonlyArrayType;
        var deferredGlobalNonNullableTypeAlias;
        var deferredGlobalESSymbolConstructorSymbol;
        var deferredGlobalESSymbolConstructorTypeSymbol;
        var deferredGlobalESSymbolType;
        var deferredGlobalTypedPropertyDescriptorType;
        var deferredGlobalPromiseType;
        var deferredGlobalPromiseLikeType;
        var deferredGlobalPromiseConstructorSymbol;
        var deferredGlobalPromiseConstructorLikeType;
        var deferredGlobalIterableType;
        var deferredGlobalIteratorType;
        var deferredGlobalIterableIteratorType;
        var deferredGlobalGeneratorType;
        var deferredGlobalIteratorYieldResultType;
        var deferredGlobalIteratorReturnResultType;
        var deferredGlobalAsyncIterableType;
        var deferredGlobalAsyncIteratorType;
        var deferredGlobalAsyncIterableIteratorType;
        var deferredGlobalAsyncGeneratorType;
        var deferredGlobalTemplateStringsArrayType;
        var deferredGlobalImportMetaType;
        var deferredGlobalExtractSymbol;
        var deferredGlobalOmitSymbol;
        var deferredGlobalBigIntType;
        var allPotentiallyUnusedIdentifiers = new ts3.Map();
        var flowLoopStart = 0;
        var flowLoopCount = 0;
        var sharedFlowCount = 0;
        var flowAnalysisDisabled = false;
        var flowInvocationCount = 0;
        var lastFlowNode;
        var lastFlowNodeReachable;
        var flowTypeCache;
        var emptyStringType = getLiteralType("");
        var zeroType = getLiteralType(0);
        var zeroBigIntType = getLiteralType({ negative: false, base10Value: "0" });
        var resolutionTargets = [];
        var resolutionResults = [];
        var resolutionPropertyNames = [];
        var suggestionCount = 0;
        var maximumSuggestionCount = 10;
        var mergedSymbols = [];
        var symbolLinks = [];
        var nodeLinks = [];
        var flowLoopCaches = [];
        var flowLoopNodes = [];
        var flowLoopKeys = [];
        var flowLoopTypes = [];
        var sharedFlowNodes = [];
        var sharedFlowTypes = [];
        var flowNodeReachable = [];
        var flowNodePostSuper = [];
        var potentialThisCollisions = [];
        var potentialNewTargetCollisions = [];
        var potentialWeakMapSetCollisions = [];
        var awaitedTypeStack = [];
        var diagnostics = ts3.createDiagnosticCollection();
        var suggestionDiagnostics = ts3.createDiagnosticCollection();
        var typeofTypesByName = new ts3.Map(ts3.getEntries({
          string: stringType,
          number: numberType,
          bigint: bigintType,
          boolean: booleanType,
          symbol: esSymbolType,
          undefined: undefinedType
        }));
        var typeofType = createTypeofType();
        var _jsxNamespace;
        var _jsxFactoryEntity;
        var outofbandVarianceMarkerHandler;
        var subtypeRelation = new ts3.Map();
        var strictSubtypeRelation = new ts3.Map();
        var assignableRelation = new ts3.Map();
        var comparableRelation = new ts3.Map();
        var identityRelation = new ts3.Map();
        var enumRelation = new ts3.Map();
        var builtinGlobals = ts3.createSymbolTable();
        builtinGlobals.set(undefinedSymbol.escapedName, undefinedSymbol);
        initializeTypeChecker();
        return checker;
        function getJsxNamespace(location) {
          if (location) {
            var file = ts3.getSourceFileOfNode(location);
            if (file) {
              if (ts3.isJsxOpeningFragment(location)) {
                if (file.localJsxFragmentNamespace) {
                  return file.localJsxFragmentNamespace;
                }
                var jsxFragmentPragma = file.pragmas.get("jsxfrag");
                if (jsxFragmentPragma) {
                  var chosenPragma = ts3.isArray(jsxFragmentPragma) ? jsxFragmentPragma[0] : jsxFragmentPragma;
                  file.localJsxFragmentFactory = ts3.parseIsolatedEntityName(chosenPragma.arguments.factory, languageVersion);
                  ts3.visitNode(file.localJsxFragmentFactory, markAsSynthetic);
                  if (file.localJsxFragmentFactory) {
                    return file.localJsxFragmentNamespace = ts3.getFirstIdentifier(file.localJsxFragmentFactory).escapedText;
                  }
                }
                var entity = getJsxFragmentFactoryEntity(location);
                if (entity) {
                  file.localJsxFragmentFactory = entity;
                  return file.localJsxFragmentNamespace = ts3.getFirstIdentifier(entity).escapedText;
                }
              } else {
                if (file.localJsxNamespace) {
                  return file.localJsxNamespace;
                }
                var jsxPragma = file.pragmas.get("jsx");
                if (jsxPragma) {
                  var chosenPragma = ts3.isArray(jsxPragma) ? jsxPragma[0] : jsxPragma;
                  file.localJsxFactory = ts3.parseIsolatedEntityName(chosenPragma.arguments.factory, languageVersion);
                  ts3.visitNode(file.localJsxFactory, markAsSynthetic);
                  if (file.localJsxFactory) {
                    return file.localJsxNamespace = ts3.getFirstIdentifier(file.localJsxFactory).escapedText;
                  }
                }
              }
            }
          }
          if (!_jsxNamespace) {
            _jsxNamespace = "React";
            if (compilerOptions.jsxFactory) {
              _jsxFactoryEntity = ts3.parseIsolatedEntityName(compilerOptions.jsxFactory, languageVersion);
              ts3.visitNode(_jsxFactoryEntity, markAsSynthetic);
              if (_jsxFactoryEntity) {
                _jsxNamespace = ts3.getFirstIdentifier(_jsxFactoryEntity).escapedText;
              }
            } else if (compilerOptions.reactNamespace) {
              _jsxNamespace = ts3.escapeLeadingUnderscores(compilerOptions.reactNamespace);
            }
          }
          if (!_jsxFactoryEntity) {
            _jsxFactoryEntity = ts3.factory.createQualifiedName(ts3.factory.createIdentifier(ts3.unescapeLeadingUnderscores(_jsxNamespace)), "createElement");
          }
          return _jsxNamespace;
          function markAsSynthetic(node) {
            ts3.setTextRangePosEnd(node, -1, -1);
            return ts3.visitEachChild(node, markAsSynthetic, ts3.nullTransformationContext);
          }
        }
        function getEmitResolver(sourceFile, cancellationToken2) {
          getDiagnostics(sourceFile, cancellationToken2);
          return emitResolver;
        }
        function lookupOrIssueError(location, message, arg0, arg1, arg2, arg3) {
          var diagnostic = location ? ts3.createDiagnosticForNode(location, message, arg0, arg1, arg2, arg3) : ts3.createCompilerDiagnostic(message, arg0, arg1, arg2, arg3);
          var existing = diagnostics.lookup(diagnostic);
          if (existing) {
            return existing;
          } else {
            diagnostics.add(diagnostic);
            return diagnostic;
          }
        }
        function errorSkippedOn(key2, location, message, arg0, arg1, arg2, arg3) {
          var diagnostic = error(location, message, arg0, arg1, arg2, arg3);
          diagnostic.skippedOn = key2;
          return diagnostic;
        }
        function error(location, message, arg0, arg1, arg2, arg3) {
          var diagnostic = location ? ts3.createDiagnosticForNode(location, message, arg0, arg1, arg2, arg3) : ts3.createCompilerDiagnostic(message, arg0, arg1, arg2, arg3);
          diagnostics.add(diagnostic);
          return diagnostic;
        }
        function addErrorOrSuggestion(isError, diagnostic) {
          if (isError) {
            diagnostics.add(diagnostic);
          } else {
            suggestionDiagnostics.add(__assign(__assign({}, diagnostic), { category: ts3.DiagnosticCategory.Suggestion }));
          }
        }
        function errorOrSuggestion(isError, location, message, arg0, arg1, arg2, arg3) {
          if (location.pos < 0 || location.end < 0) {
            if (!isError) {
              return;
            }
            var file = ts3.getSourceFileOfNode(location);
            addErrorOrSuggestion(isError, "message" in message ? ts3.createFileDiagnostic(file, 0, 0, message, arg0, arg1, arg2, arg3) : ts3.createDiagnosticForFileFromMessageChain(file, message));
            return;
          }
          addErrorOrSuggestion(isError, "message" in message ? ts3.createDiagnosticForNode(location, message, arg0, arg1, arg2, arg3) : ts3.createDiagnosticForNodeFromMessageChain(location, message));
        }
        function errorAndMaybeSuggestAwait(location, maybeMissingAwait, message, arg0, arg1, arg2, arg3) {
          var diagnostic = error(location, message, arg0, arg1, arg2, arg3);
          if (maybeMissingAwait) {
            var related = ts3.createDiagnosticForNode(location, ts3.Diagnostics.Did_you_forget_to_use_await);
            ts3.addRelatedInfo(diagnostic, related);
          }
          return diagnostic;
        }
        function addDeprecatedSuggestionWorker(declarations, diagnostic) {
          var deprecatedTag = Array.isArray(declarations) ? ts3.forEach(declarations, ts3.getJSDocDeprecatedTag) : ts3.getJSDocDeprecatedTag(declarations);
          if (deprecatedTag) {
            ts3.addRelatedInfo(diagnostic, ts3.createDiagnosticForNode(deprecatedTag, ts3.Diagnostics.The_declaration_was_marked_as_deprecated_here));
          }
          suggestionDiagnostics.add(diagnostic);
          return diagnostic;
        }
        function addDeprecatedSuggestion(location, declarations, deprecatedEntity) {
          var diagnostic = ts3.createDiagnosticForNode(location, ts3.Diagnostics._0_is_deprecated, deprecatedEntity);
          return addDeprecatedSuggestionWorker(declarations, diagnostic);
        }
        function addDeprecatedSuggestionWithSignature(location, declaration, deprecatedEntity, signatureString) {
          var diagnostic = deprecatedEntity ? ts3.createDiagnosticForNode(location, ts3.Diagnostics.The_signature_0_of_1_is_deprecated, signatureString, deprecatedEntity) : ts3.createDiagnosticForNode(location, ts3.Diagnostics._0_is_deprecated, signatureString);
          return addDeprecatedSuggestionWorker(declaration, diagnostic);
        }
        function createSymbol(flags, name, checkFlags) {
          symbolCount++;
          var symbol = new Symbol2(flags | 33554432, name);
          symbol.checkFlags = checkFlags || 0;
          return symbol;
        }
        function getExcludedSymbolFlags(flags) {
          var result2 = 0;
          if (flags & 2)
            result2 |= 111551;
          if (flags & 1)
            result2 |= 111550;
          if (flags & 4)
            result2 |= 0;
          if (flags & 8)
            result2 |= 900095;
          if (flags & 16)
            result2 |= 110991;
          if (flags & 32)
            result2 |= 899503;
          if (flags & 64)
            result2 |= 788872;
          if (flags & 256)
            result2 |= 899327;
          if (flags & 128)
            result2 |= 899967;
          if (flags & 512)
            result2 |= 110735;
          if (flags & 8192)
            result2 |= 103359;
          if (flags & 32768)
            result2 |= 46015;
          if (flags & 65536)
            result2 |= 78783;
          if (flags & 262144)
            result2 |= 526824;
          if (flags & 524288)
            result2 |= 788968;
          if (flags & 2097152)
            result2 |= 2097152;
          return result2;
        }
        function recordMergedSymbol(target, source) {
          if (!source.mergeId) {
            source.mergeId = nextMergeId;
            nextMergeId++;
          }
          mergedSymbols[source.mergeId] = target;
        }
        function cloneSymbol(symbol) {
          var result2 = createSymbol(symbol.flags, symbol.escapedName);
          result2.declarations = symbol.declarations ? symbol.declarations.slice() : [];
          result2.parent = symbol.parent;
          if (symbol.valueDeclaration)
            result2.valueDeclaration = symbol.valueDeclaration;
          if (symbol.constEnumOnlyModule)
            result2.constEnumOnlyModule = true;
          if (symbol.members)
            result2.members = new ts3.Map(symbol.members);
          if (symbol.exports)
            result2.exports = new ts3.Map(symbol.exports);
          recordMergedSymbol(result2, symbol);
          return result2;
        }
        function mergeSymbol(target, source, unidirectional) {
          if (unidirectional === void 0) {
            unidirectional = false;
          }
          if (!(target.flags & getExcludedSymbolFlags(source.flags)) || (source.flags | target.flags) & 67108864) {
            if (source === target) {
              return target;
            }
            if (!(target.flags & 33554432)) {
              var resolvedTarget = resolveSymbol(target);
              if (resolvedTarget === unknownSymbol) {
                return source;
              }
              target = cloneSymbol(resolvedTarget);
            }
            if (source.flags & 512 && target.flags & 512 && target.constEnumOnlyModule && !source.constEnumOnlyModule) {
              target.constEnumOnlyModule = false;
            }
            target.flags |= source.flags;
            if (source.valueDeclaration) {
              ts3.setValueDeclaration(target, source.valueDeclaration);
            }
            ts3.addRange(target.declarations, source.declarations);
            if (source.members) {
              if (!target.members)
                target.members = ts3.createSymbolTable();
              mergeSymbolTable(target.members, source.members, unidirectional);
            }
            if (source.exports) {
              if (!target.exports)
                target.exports = ts3.createSymbolTable();
              mergeSymbolTable(target.exports, source.exports, unidirectional);
            }
            if (!unidirectional) {
              recordMergedSymbol(target, source);
            }
          } else if (target.flags & 1024) {
            if (target !== globalThisSymbol) {
              error(source.declarations && ts3.getNameOfDeclaration(source.declarations[0]), ts3.Diagnostics.Cannot_augment_module_0_with_value_exports_because_it_resolves_to_a_non_module_entity, symbolToString(target));
            }
          } else {
            var isEitherEnum = !!(target.flags & 384 || source.flags & 384);
            var isEitherBlockScoped_1 = !!(target.flags & 2 || source.flags & 2);
            var message = isEitherEnum ? ts3.Diagnostics.Enum_declarations_can_only_merge_with_namespace_or_other_enum_declarations : isEitherBlockScoped_1 ? ts3.Diagnostics.Cannot_redeclare_block_scoped_variable_0 : ts3.Diagnostics.Duplicate_identifier_0;
            var sourceSymbolFile = source.declarations && ts3.getSourceFileOfNode(source.declarations[0]);
            var targetSymbolFile = target.declarations && ts3.getSourceFileOfNode(target.declarations[0]);
            var symbolName_1 = symbolToString(source);
            if (sourceSymbolFile && targetSymbolFile && amalgamatedDuplicates && !isEitherEnum && sourceSymbolFile !== targetSymbolFile) {
              var firstFile_1 = ts3.comparePaths(sourceSymbolFile.path, targetSymbolFile.path) === -1 ? sourceSymbolFile : targetSymbolFile;
              var secondFile_1 = firstFile_1 === sourceSymbolFile ? targetSymbolFile : sourceSymbolFile;
              var filesDuplicates = ts3.getOrUpdate(amalgamatedDuplicates, firstFile_1.path + "|" + secondFile_1.path, function() {
                return { firstFile: firstFile_1, secondFile: secondFile_1, conflictingSymbols: new ts3.Map() };
              });
              var conflictingSymbolInfo = ts3.getOrUpdate(filesDuplicates.conflictingSymbols, symbolName_1, function() {
                return { isBlockScoped: isEitherBlockScoped_1, firstFileLocations: [], secondFileLocations: [] };
              });
              addDuplicateLocations(conflictingSymbolInfo.firstFileLocations, source);
              addDuplicateLocations(conflictingSymbolInfo.secondFileLocations, target);
            } else {
              addDuplicateDeclarationErrorsForSymbols(source, message, symbolName_1, target);
              addDuplicateDeclarationErrorsForSymbols(target, message, symbolName_1, source);
            }
          }
          return target;
          function addDuplicateLocations(locs, symbol) {
            if (symbol.declarations) {
              for (var _i = 0, _a2 = symbol.declarations; _i < _a2.length; _i++) {
                var decl = _a2[_i];
                ts3.pushIfUnique(locs, decl);
              }
            }
          }
        }
        function addDuplicateDeclarationErrorsForSymbols(target, message, symbolName, source) {
          ts3.forEach(target.declarations, function(node) {
            addDuplicateDeclarationError(node, message, symbolName, source.declarations);
          });
        }
        function addDuplicateDeclarationError(node, message, symbolName, relatedNodes) {
          var errorNode = (ts3.getExpandoInitializer(node, false) ? ts3.getNameOfExpando(node) : ts3.getNameOfDeclaration(node)) || node;
          var err2 = lookupOrIssueError(errorNode, message, symbolName);
          var _loop_7 = function(relatedNode2) {
            var adjustedNode = (ts3.getExpandoInitializer(relatedNode2, false) ? ts3.getNameOfExpando(relatedNode2) : ts3.getNameOfDeclaration(relatedNode2)) || relatedNode2;
            if (adjustedNode === errorNode)
              return "continue";
            err2.relatedInformation = err2.relatedInformation || [];
            var leadingMessage = ts3.createDiagnosticForNode(adjustedNode, ts3.Diagnostics._0_was_also_declared_here, symbolName);
            var followOnMessage = ts3.createDiagnosticForNode(adjustedNode, ts3.Diagnostics.and_here);
            if (ts3.length(err2.relatedInformation) >= 5 || ts3.some(err2.relatedInformation, function(r2) {
              return ts3.compareDiagnostics(r2, followOnMessage) === 0 || ts3.compareDiagnostics(r2, leadingMessage) === 0;
            }))
              return "continue";
            ts3.addRelatedInfo(err2, !ts3.length(err2.relatedInformation) ? leadingMessage : followOnMessage);
          };
          for (var _i = 0, _a2 = relatedNodes || ts3.emptyArray; _i < _a2.length; _i++) {
            var relatedNode = _a2[_i];
            _loop_7(relatedNode);
          }
        }
        function combineSymbolTables(first, second) {
          if (!(first === null || first === void 0 ? void 0 : first.size))
            return second;
          if (!(second === null || second === void 0 ? void 0 : second.size))
            return first;
          var combined = ts3.createSymbolTable();
          mergeSymbolTable(combined, first);
          mergeSymbolTable(combined, second);
          return combined;
        }
        function mergeSymbolTable(target, source, unidirectional) {
          if (unidirectional === void 0) {
            unidirectional = false;
          }
          source.forEach(function(sourceSymbol, id) {
            var targetSymbol = target.get(id);
            target.set(id, targetSymbol ? mergeSymbol(targetSymbol, sourceSymbol, unidirectional) : sourceSymbol);
          });
        }
        function mergeModuleAugmentation(moduleName) {
          var _a2, _b, _c;
          var moduleAugmentation = moduleName.parent;
          if (((_a2 = moduleAugmentation.symbol.declarations) === null || _a2 === void 0 ? void 0 : _a2[0]) !== moduleAugmentation) {
            ts3.Debug.assert(moduleAugmentation.symbol.declarations.length > 1);
            return;
          }
          if (ts3.isGlobalScopeAugmentation(moduleAugmentation)) {
            mergeSymbolTable(globals, moduleAugmentation.symbol.exports);
          } else {
            var moduleNotFoundError = !(moduleName.parent.parent.flags & 8388608) ? ts3.Diagnostics.Invalid_module_name_in_augmentation_module_0_cannot_be_found : void 0;
            var mainModule_1 = resolveExternalModuleNameWorker(moduleName, moduleName, moduleNotFoundError, true);
            if (!mainModule_1) {
              return;
            }
            mainModule_1 = resolveExternalModuleSymbol(mainModule_1);
            if (mainModule_1.flags & 1920) {
              if (ts3.some(patternAmbientModules, function(module3) {
                return mainModule_1 === module3.symbol;
              })) {
                var merged = mergeSymbol(moduleAugmentation.symbol, mainModule_1, true);
                if (!patternAmbientModuleAugmentations) {
                  patternAmbientModuleAugmentations = new ts3.Map();
                }
                patternAmbientModuleAugmentations.set(moduleName.text, merged);
              } else {
                if (((_b = mainModule_1.exports) === null || _b === void 0 ? void 0 : _b.get("__export")) && ((_c = moduleAugmentation.symbol.exports) === null || _c === void 0 ? void 0 : _c.size)) {
                  var resolvedExports = getResolvedMembersOrExportsOfSymbol(mainModule_1, "resolvedExports");
                  for (var _i = 0, _d = ts3.arrayFrom(moduleAugmentation.symbol.exports.entries()); _i < _d.length; _i++) {
                    var _e = _d[_i], key2 = _e[0], value = _e[1];
                    if (resolvedExports.has(key2) && !mainModule_1.exports.has(key2)) {
                      mergeSymbol(resolvedExports.get(key2), value);
                    }
                  }
                }
                mergeSymbol(mainModule_1, moduleAugmentation.symbol);
              }
            } else {
              error(moduleName, ts3.Diagnostics.Cannot_augment_module_0_because_it_resolves_to_a_non_module_entity, moduleName.text);
            }
          }
        }
        function addToSymbolTable(target, source, message) {
          source.forEach(function(sourceSymbol, id) {
            var targetSymbol = target.get(id);
            if (targetSymbol) {
              ts3.forEach(targetSymbol.declarations, addDeclarationDiagnostic(ts3.unescapeLeadingUnderscores(id), message));
            } else {
              target.set(id, sourceSymbol);
            }
          });
          function addDeclarationDiagnostic(id, message2) {
            return function(declaration) {
              return diagnostics.add(ts3.createDiagnosticForNode(declaration, message2, id));
            };
          }
        }
        function getSymbolLinks(symbol) {
          if (symbol.flags & 33554432)
            return symbol;
          var id = getSymbolId(symbol);
          return symbolLinks[id] || (symbolLinks[id] = new SymbolLinks());
        }
        function getNodeLinks(node) {
          var nodeId = getNodeId(node);
          return nodeLinks[nodeId] || (nodeLinks[nodeId] = new NodeLinks());
        }
        function isGlobalSourceFile(node) {
          return node.kind === 298 && !ts3.isExternalOrCommonJsModule(node);
        }
        function getSymbol(symbols, name, meaning) {
          if (meaning) {
            var symbol = getMergedSymbol(symbols.get(name));
            if (symbol) {
              ts3.Debug.assert((ts3.getCheckFlags(symbol) & 1) === 0, "Should never get an instantiated symbol here.");
              if (symbol.flags & meaning) {
                return symbol;
              }
              if (symbol.flags & 2097152) {
                var target = resolveAlias(symbol);
                if (target === unknownSymbol || target.flags & meaning) {
                  return symbol;
                }
              }
            }
          }
        }
        function getSymbolsOfParameterPropertyDeclaration(parameter, parameterName) {
          var constructorDeclaration = parameter.parent;
          var classDeclaration = parameter.parent.parent;
          var parameterSymbol = getSymbol(constructorDeclaration.locals, parameterName, 111551);
          var propertySymbol = getSymbol(getMembersOfSymbol(classDeclaration.symbol), parameterName, 111551);
          if (parameterSymbol && propertySymbol) {
            return [parameterSymbol, propertySymbol];
          }
          return ts3.Debug.fail("There should exist two symbols, one as property declaration and one as parameter declaration");
        }
        function isBlockScopedNameDeclaredBeforeUse(declaration, usage) {
          var declarationFile = ts3.getSourceFileOfNode(declaration);
          var useFile = ts3.getSourceFileOfNode(usage);
          var declContainer = ts3.getEnclosingBlockScopeContainer(declaration);
          if (declarationFile !== useFile) {
            if (moduleKind && (declarationFile.externalModuleIndicator || useFile.externalModuleIndicator) || !ts3.outFile(compilerOptions) || isInTypeQuery(usage) || declaration.flags & 8388608) {
              return true;
            }
            if (isUsedInFunctionOrInstanceProperty(usage, declaration)) {
              return true;
            }
            var sourceFiles = host.getSourceFiles();
            return sourceFiles.indexOf(declarationFile) <= sourceFiles.indexOf(useFile);
          }
          if (declaration.pos <= usage.pos && !(ts3.isPropertyDeclaration(declaration) && ts3.isThisProperty(usage.parent) && !declaration.initializer && !declaration.exclamationToken)) {
            if (declaration.kind === 199) {
              var errorBindingElement = ts3.getAncestor(usage, 199);
              if (errorBindingElement) {
                return ts3.findAncestor(errorBindingElement, ts3.isBindingElement) !== ts3.findAncestor(declaration, ts3.isBindingElement) || declaration.pos < errorBindingElement.pos;
              }
              return isBlockScopedNameDeclaredBeforeUse(ts3.getAncestor(declaration, 250), usage);
            } else if (declaration.kind === 250) {
              return !isImmediatelyUsedInInitializerOfBlockScopedVariable(declaration, usage);
            } else if (ts3.isClassDeclaration(declaration)) {
              return !ts3.findAncestor(usage, function(n2) {
                return ts3.isComputedPropertyName(n2) && n2.parent.parent === declaration;
              });
            } else if (ts3.isPropertyDeclaration(declaration)) {
              return !isPropertyImmediatelyReferencedWithinDeclaration(declaration, usage, false);
            } else if (ts3.isParameterPropertyDeclaration(declaration, declaration.parent)) {
              return !(compilerOptions.target === 99 && useDefineForClassFields && ts3.getContainingClass(declaration) === ts3.getContainingClass(usage) && isUsedInFunctionOrInstanceProperty(usage, declaration));
            }
            return true;
          }
          if (usage.parent.kind === 271 || usage.parent.kind === 267 && usage.parent.isExportEquals) {
            return true;
          }
          if (usage.kind === 267 && usage.isExportEquals) {
            return true;
          }
          if (!!(usage.flags & 4194304) || isInTypeQuery(usage) || usageInTypeDeclaration()) {
            return true;
          }
          if (isUsedInFunctionOrInstanceProperty(usage, declaration)) {
            if (compilerOptions.target === 99 && useDefineForClassFields && ts3.getContainingClass(declaration) && (ts3.isPropertyDeclaration(declaration) || ts3.isParameterPropertyDeclaration(declaration, declaration.parent))) {
              return !isPropertyImmediatelyReferencedWithinDeclaration(declaration, usage, true);
            } else {
              return true;
            }
          }
          return false;
          function usageInTypeDeclaration() {
            return !!ts3.findAncestor(usage, function(node) {
              return ts3.isInterfaceDeclaration(node) || ts3.isTypeAliasDeclaration(node);
            });
          }
          function isImmediatelyUsedInInitializerOfBlockScopedVariable(declaration2, usage2) {
            switch (declaration2.parent.parent.kind) {
              case 233:
              case 238:
              case 240:
                if (isSameScopeDescendentOf(usage2, declaration2, declContainer)) {
                  return true;
                }
                break;
            }
            var grandparent = declaration2.parent.parent;
            return ts3.isForInOrOfStatement(grandparent) && isSameScopeDescendentOf(usage2, grandparent.expression, declContainer);
          }
          function isUsedInFunctionOrInstanceProperty(usage2, declaration2) {
            return !!ts3.findAncestor(usage2, function(current) {
              if (current === declContainer) {
                return "quit";
              }
              if (ts3.isFunctionLike(current)) {
                return true;
              }
              var initializerOfProperty = current.parent && current.parent.kind === 164 && current.parent.initializer === current;
              if (initializerOfProperty) {
                if (ts3.hasSyntacticModifier(current.parent, 32)) {
                  if (declaration2.kind === 166) {
                    return true;
                  }
                } else {
                  var isDeclarationInstanceProperty = declaration2.kind === 164 && !ts3.hasSyntacticModifier(declaration2, 32);
                  if (!isDeclarationInstanceProperty || ts3.getContainingClass(usage2) !== ts3.getContainingClass(declaration2)) {
                    return true;
                  }
                }
              }
              return false;
            });
          }
          function isPropertyImmediatelyReferencedWithinDeclaration(declaration2, usage2, stopAtAnyPropertyDeclaration) {
            if (usage2.end > declaration2.end) {
              return false;
            }
            var ancestorChangingReferenceScope = ts3.findAncestor(usage2, function(node) {
              if (node === declaration2) {
                return "quit";
              }
              switch (node.kind) {
                case 210:
                  return true;
                case 164:
                  return stopAtAnyPropertyDeclaration && (ts3.isPropertyDeclaration(declaration2) && node.parent === declaration2.parent || ts3.isParameterPropertyDeclaration(declaration2, declaration2.parent) && node.parent === declaration2.parent.parent) ? "quit" : true;
                case 231:
                  switch (node.parent.kind) {
                    case 168:
                    case 166:
                    case 169:
                      return true;
                    default:
                      return false;
                  }
                default:
                  return false;
              }
            });
            return ancestorChangingReferenceScope === void 0;
          }
        }
        function useOuterVariableScopeInParameter(result2, location, lastLocation) {
          var target = ts3.getEmitScriptTarget(compilerOptions);
          var functionLocation = location;
          if (ts3.isParameter(lastLocation) && functionLocation.body && result2.valueDeclaration && result2.valueDeclaration.pos >= functionLocation.body.pos && result2.valueDeclaration.end <= functionLocation.body.end) {
            if (target >= 2) {
              var links = getNodeLinks(functionLocation);
              if (links.declarationRequiresScopeChange === void 0) {
                links.declarationRequiresScopeChange = ts3.forEach(functionLocation.parameters, requiresScopeChange) || false;
              }
              return !links.declarationRequiresScopeChange;
            }
          }
          return false;
          function requiresScopeChange(node) {
            return requiresScopeChangeWorker(node.name) || !!node.initializer && requiresScopeChangeWorker(node.initializer);
          }
          function requiresScopeChangeWorker(node) {
            switch (node.kind) {
              case 210:
              case 209:
              case 252:
              case 167:
                return false;
              case 166:
              case 168:
              case 169:
              case 289:
                return requiresScopeChangeWorker(node.name);
              case 164:
                if (ts3.hasStaticModifier(node)) {
                  return target < 99 || !useDefineForClassFields;
                }
                return requiresScopeChangeWorker(node.name);
              default:
                if (ts3.isNullishCoalesce(node) || ts3.isOptionalChain(node)) {
                  return target < 7;
                }
                if (ts3.isBindingElement(node) && node.dotDotDotToken && ts3.isObjectBindingPattern(node.parent)) {
                  return target < 4;
                }
                if (ts3.isTypeNode(node))
                  return false;
                return ts3.forEachChild(node, requiresScopeChangeWorker) || false;
            }
          }
        }
        function resolveName(location, name, meaning, nameNotFoundMessage, nameArg, isUse, excludeGlobals, suggestedNameNotFoundMessage) {
          if (excludeGlobals === void 0) {
            excludeGlobals = false;
          }
          return resolveNameHelper(location, name, meaning, nameNotFoundMessage, nameArg, isUse, excludeGlobals, getSymbol, suggestedNameNotFoundMessage);
        }
        function resolveNameHelper(location, name, meaning, nameNotFoundMessage, nameArg, isUse, excludeGlobals, lookup, suggestedNameNotFoundMessage) {
          var _a2;
          var originalLocation = location;
          var result2;
          var lastLocation;
          var lastSelfReferenceLocation;
          var propertyWithInvalidInitializer;
          var associatedDeclarationForContainingInitializerOrBindingName;
          var withinDeferredContext = false;
          var errorLocation = location;
          var grandparent;
          var isInExternalModule = false;
          loop:
            while (location) {
              if (location.locals && !isGlobalSourceFile(location)) {
                if (result2 = lookup(location.locals, name, meaning)) {
                  var useResult = true;
                  if (ts3.isFunctionLike(location) && lastLocation && lastLocation !== location.body) {
                    if (meaning & result2.flags & 788968 && lastLocation.kind !== 312) {
                      useResult = result2.flags & 262144 ? lastLocation === location.type || lastLocation.kind === 161 || lastLocation.kind === 160 : false;
                    }
                    if (meaning & result2.flags & 3) {
                      if (useOuterVariableScopeInParameter(result2, location, lastLocation)) {
                        useResult = false;
                      } else if (result2.flags & 1) {
                        useResult = lastLocation.kind === 161 || lastLocation === location.type && !!ts3.findAncestor(result2.valueDeclaration, ts3.isParameter);
                      }
                    }
                  } else if (location.kind === 185) {
                    useResult = lastLocation === location.trueType;
                  }
                  if (useResult) {
                    break loop;
                  } else {
                    result2 = void 0;
                  }
                }
              }
              withinDeferredContext = withinDeferredContext || getIsDeferredContext(location, lastLocation);
              switch (location.kind) {
                case 298:
                  if (!ts3.isExternalOrCommonJsModule(location))
                    break;
                  isInExternalModule = true;
                case 257:
                  var moduleExports = getSymbolOfNode(location).exports || emptySymbols;
                  if (location.kind === 298 || ts3.isModuleDeclaration(location) && location.flags & 8388608 && !ts3.isGlobalScopeAugmentation(location)) {
                    if (result2 = moduleExports.get("default")) {
                      var localSymbol = ts3.getLocalSymbolForExportDefault(result2);
                      if (localSymbol && result2.flags & meaning && localSymbol.escapedName === name) {
                        break loop;
                      }
                      result2 = void 0;
                    }
                    var moduleExport = moduleExports.get(name);
                    if (moduleExport && moduleExport.flags === 2097152 && (ts3.getDeclarationOfKind(moduleExport, 271) || ts3.getDeclarationOfKind(moduleExport, 270))) {
                      break;
                    }
                  }
                  if (name !== "default" && (result2 = lookup(moduleExports, name, meaning & 2623475))) {
                    if (ts3.isSourceFile(location) && location.commonJsModuleIndicator && !((_a2 = result2.declarations) === null || _a2 === void 0 ? void 0 : _a2.some(ts3.isJSDocTypeAlias))) {
                      result2 = void 0;
                    } else {
                      break loop;
                    }
                  }
                  break;
                case 256:
                  if (result2 = lookup(getSymbolOfNode(location).exports, name, meaning & 8)) {
                    break loop;
                  }
                  break;
                case 164:
                  if (!ts3.hasSyntacticModifier(location, 32)) {
                    var ctor = findConstructorDeclaration(location.parent);
                    if (ctor && ctor.locals) {
                      if (lookup(ctor.locals, name, meaning & 111551)) {
                        propertyWithInvalidInitializer = location;
                      }
                    }
                  }
                  break;
                case 253:
                case 222:
                case 254:
                  if (result2 = lookup(getSymbolOfNode(location).members || emptySymbols, name, meaning & 788968)) {
                    if (!isTypeParameterSymbolDeclaredInContainer(result2, location)) {
                      result2 = void 0;
                      break;
                    }
                    if (lastLocation && ts3.hasSyntacticModifier(lastLocation, 32)) {
                      error(errorLocation, ts3.Diagnostics.Static_members_cannot_reference_class_type_parameters);
                      return void 0;
                    }
                    break loop;
                  }
                  if (location.kind === 222 && meaning & 32) {
                    var className = location.name;
                    if (className && name === className.escapedText) {
                      result2 = location.symbol;
                      break loop;
                    }
                  }
                  break;
                case 224:
                  if (lastLocation === location.expression && location.parent.token === 93) {
                    var container = location.parent.parent;
                    if (ts3.isClassLike(container) && (result2 = lookup(getSymbolOfNode(container).members, name, meaning & 788968))) {
                      if (nameNotFoundMessage) {
                        error(errorLocation, ts3.Diagnostics.Base_class_expressions_cannot_reference_class_type_parameters);
                      }
                      return void 0;
                    }
                  }
                  break;
                case 159:
                  grandparent = location.parent.parent;
                  if (ts3.isClassLike(grandparent) || grandparent.kind === 254) {
                    if (result2 = lookup(getSymbolOfNode(grandparent).members, name, meaning & 788968)) {
                      error(errorLocation, ts3.Diagnostics.A_computed_property_name_cannot_reference_a_type_parameter_from_its_containing_type);
                      return void 0;
                    }
                  }
                  break;
                case 210:
                  if (compilerOptions.target >= 2) {
                    break;
                  }
                case 166:
                case 167:
                case 168:
                case 169:
                case 252:
                  if (meaning & 3 && name === "arguments") {
                    result2 = argumentsSymbol;
                    break loop;
                  }
                  break;
                case 209:
                  if (meaning & 3 && name === "arguments") {
                    result2 = argumentsSymbol;
                    break loop;
                  }
                  if (meaning & 16) {
                    var functionName = location.name;
                    if (functionName && name === functionName.escapedText) {
                      result2 = location.symbol;
                      break loop;
                    }
                  }
                  break;
                case 162:
                  if (location.parent && location.parent.kind === 161) {
                    location = location.parent;
                  }
                  if (location.parent && (ts3.isClassElement(location.parent) || location.parent.kind === 253)) {
                    location = location.parent;
                  }
                  break;
                case 335:
                case 328:
                case 329:
                  var root = ts3.getJSDocRoot(location);
                  if (root) {
                    location = root.parent;
                  }
                  break;
                case 161:
                  if (lastLocation && (lastLocation === location.initializer || lastLocation === location.name && ts3.isBindingPattern(lastLocation))) {
                    if (!associatedDeclarationForContainingInitializerOrBindingName) {
                      associatedDeclarationForContainingInitializerOrBindingName = location;
                    }
                  }
                  break;
                case 199:
                  if (lastLocation && (lastLocation === location.initializer || lastLocation === location.name && ts3.isBindingPattern(lastLocation))) {
                    if (ts3.isParameterDeclaration(location) && !associatedDeclarationForContainingInitializerOrBindingName) {
                      associatedDeclarationForContainingInitializerOrBindingName = location;
                    }
                  }
                  break;
                case 186:
                  if (meaning & 262144) {
                    var parameterName = location.typeParameter.name;
                    if (parameterName && name === parameterName.escapedText) {
                      result2 = location.typeParameter.symbol;
                      break loop;
                    }
                  }
                  break;
              }
              if (isSelfReferenceLocation(location)) {
                lastSelfReferenceLocation = location;
              }
              lastLocation = location;
              location = location.parent;
            }
          if (isUse && result2 && (!lastSelfReferenceLocation || result2 !== lastSelfReferenceLocation.symbol)) {
            result2.isReferenced |= meaning;
          }
          if (!result2) {
            if (lastLocation) {
              ts3.Debug.assert(lastLocation.kind === 298);
              if (lastLocation.commonJsModuleIndicator && name === "exports" && meaning & lastLocation.symbol.flags) {
                return lastLocation.symbol;
              }
            }
            if (!excludeGlobals) {
              result2 = lookup(globals, name, meaning);
            }
          }
          if (!result2) {
            if (originalLocation && ts3.isInJSFile(originalLocation) && originalLocation.parent) {
              if (ts3.isRequireCall(originalLocation.parent, false)) {
                return requireSymbol;
              }
            }
          }
          if (!result2) {
            if (nameNotFoundMessage) {
              if (!errorLocation || !checkAndReportErrorForMissingPrefix(errorLocation, name, nameArg) && !checkAndReportErrorForExtendingInterface(errorLocation) && !checkAndReportErrorForUsingTypeAsNamespace(errorLocation, name, meaning) && !checkAndReportErrorForExportingPrimitiveType(errorLocation, name) && !checkAndReportErrorForUsingTypeAsValue(errorLocation, name, meaning) && !checkAndReportErrorForUsingNamespaceModuleAsValue(errorLocation, name, meaning) && !checkAndReportErrorForUsingValueAsType(errorLocation, name, meaning)) {
                var suggestion = void 0;
                if (suggestedNameNotFoundMessage && suggestionCount < maximumSuggestionCount) {
                  suggestion = getSuggestedSymbolForNonexistentSymbol(originalLocation, name, meaning);
                  var isGlobalScopeAugmentationDeclaration = suggestion && suggestion.valueDeclaration && ts3.isAmbientModule(suggestion.valueDeclaration) && ts3.isGlobalScopeAugmentation(suggestion.valueDeclaration);
                  if (isGlobalScopeAugmentationDeclaration) {
                    suggestion = void 0;
                  }
                  if (suggestion) {
                    var suggestionName = symbolToString(suggestion);
                    var diagnostic = error(errorLocation, suggestedNameNotFoundMessage, diagnosticName(nameArg), suggestionName);
                    if (suggestion.valueDeclaration) {
                      ts3.addRelatedInfo(diagnostic, ts3.createDiagnosticForNode(suggestion.valueDeclaration, ts3.Diagnostics._0_is_declared_here, suggestionName));
                    }
                  }
                }
                if (!suggestion) {
                  if (nameArg) {
                    var lib = getSuggestedLibForNonExistentName(nameArg);
                    if (lib) {
                      error(errorLocation, nameNotFoundMessage, diagnosticName(nameArg), lib);
                    } else {
                      error(errorLocation, nameNotFoundMessage, diagnosticName(nameArg));
                    }
                  }
                }
                suggestionCount++;
              }
            }
            return void 0;
          }
          if (nameNotFoundMessage) {
            if (propertyWithInvalidInitializer && !(compilerOptions.target === 99 && useDefineForClassFields)) {
              var propertyName = propertyWithInvalidInitializer.name;
              error(errorLocation, ts3.Diagnostics.Initializer_of_instance_member_variable_0_cannot_reference_identifier_1_declared_in_the_constructor, ts3.declarationNameToString(propertyName), diagnosticName(nameArg));
              return void 0;
            }
            if (errorLocation && (meaning & 2 || (meaning & 32 || meaning & 384) && (meaning & 111551) === 111551)) {
              var exportOrLocalSymbol = getExportSymbolOfValueSymbolIfExported(result2);
              if (exportOrLocalSymbol.flags & 2 || exportOrLocalSymbol.flags & 32 || exportOrLocalSymbol.flags & 384) {
                checkResolvedBlockScopedVariable(exportOrLocalSymbol, errorLocation);
              }
            }
            if (result2 && isInExternalModule && (meaning & 111551) === 111551 && !(originalLocation.flags & 4194304)) {
              var merged = getMergedSymbol(result2);
              if (ts3.length(merged.declarations) && ts3.every(merged.declarations, function(d) {
                return ts3.isNamespaceExportDeclaration(d) || ts3.isSourceFile(d) && !!d.symbol.globalExports;
              })) {
                errorOrSuggestion(!compilerOptions.allowUmdGlobalAccess, errorLocation, ts3.Diagnostics._0_refers_to_a_UMD_global_but_the_current_file_is_a_module_Consider_adding_an_import_instead, ts3.unescapeLeadingUnderscores(name));
              }
            }
            if (result2 && associatedDeclarationForContainingInitializerOrBindingName && !withinDeferredContext && (meaning & 111551) === 111551) {
              var candidate = getMergedSymbol(getLateBoundSymbol(result2));
              var root = ts3.getRootDeclaration(associatedDeclarationForContainingInitializerOrBindingName);
              if (candidate === getSymbolOfNode(associatedDeclarationForContainingInitializerOrBindingName)) {
                error(errorLocation, ts3.Diagnostics.Parameter_0_cannot_reference_itself, ts3.declarationNameToString(associatedDeclarationForContainingInitializerOrBindingName.name));
              } else if (candidate.valueDeclaration && candidate.valueDeclaration.pos > associatedDeclarationForContainingInitializerOrBindingName.pos && root.parent.locals && lookup(root.parent.locals, candidate.escapedName, meaning) === candidate) {
                error(errorLocation, ts3.Diagnostics.Parameter_0_cannot_reference_identifier_1_declared_after_it, ts3.declarationNameToString(associatedDeclarationForContainingInitializerOrBindingName.name), ts3.declarationNameToString(errorLocation));
              }
            }
            if (result2 && errorLocation && meaning & 111551 && result2.flags & 2097152) {
              checkSymbolUsageInExpressionContext(result2, name, errorLocation);
            }
          }
          return result2;
        }
        function checkSymbolUsageInExpressionContext(symbol, name, useSite) {
          if (!ts3.isValidTypeOnlyAliasUseSite(useSite)) {
            var typeOnlyDeclaration = getTypeOnlyAliasDeclaration(symbol);
            if (typeOnlyDeclaration) {
              var isExport = ts3.typeOnlyDeclarationIsExport(typeOnlyDeclaration);
              var message = isExport ? ts3.Diagnostics._0_cannot_be_used_as_a_value_because_it_was_exported_using_export_type : ts3.Diagnostics._0_cannot_be_used_as_a_value_because_it_was_imported_using_import_type;
              var relatedMessage = isExport ? ts3.Diagnostics._0_was_exported_here : ts3.Diagnostics._0_was_imported_here;
              var unescapedName = ts3.unescapeLeadingUnderscores(name);
              ts3.addRelatedInfo(error(useSite, message, unescapedName), ts3.createDiagnosticForNode(typeOnlyDeclaration, relatedMessage, unescapedName));
            }
          }
        }
        function getIsDeferredContext(location, lastLocation) {
          if (location.kind !== 210 && location.kind !== 209) {
            return ts3.isTypeQueryNode(location) || (ts3.isFunctionLikeDeclaration(location) || location.kind === 164 && !ts3.hasSyntacticModifier(location, 32)) && (!lastLocation || lastLocation !== location.name);
          }
          if (lastLocation && lastLocation === location.name) {
            return false;
          }
          if (location.asteriskToken || ts3.hasSyntacticModifier(location, 256)) {
            return true;
          }
          return !ts3.getImmediatelyInvokedFunctionExpression(location);
        }
        function isSelfReferenceLocation(node) {
          switch (node.kind) {
            case 252:
            case 253:
            case 254:
            case 256:
            case 255:
            case 257:
              return true;
            default:
              return false;
          }
        }
        function diagnosticName(nameArg) {
          return ts3.isString(nameArg) ? ts3.unescapeLeadingUnderscores(nameArg) : ts3.declarationNameToString(nameArg);
        }
        function isTypeParameterSymbolDeclaredInContainer(symbol, container) {
          if (symbol.declarations) {
            for (var _i = 0, _a2 = symbol.declarations; _i < _a2.length; _i++) {
              var decl = _a2[_i];
              if (decl.kind === 160) {
                var parent = ts3.isJSDocTemplateTag(decl.parent) ? ts3.getJSDocHost(decl.parent) : decl.parent;
                if (parent === container) {
                  return !(ts3.isJSDocTemplateTag(decl.parent) && ts3.find(decl.parent.parent.tags, ts3.isJSDocTypeAlias));
                }
              }
            }
          }
          return false;
        }
        function checkAndReportErrorForMissingPrefix(errorLocation, name, nameArg) {
          if (!ts3.isIdentifier(errorLocation) || errorLocation.escapedText !== name || isTypeReferenceIdentifier(errorLocation) || isInTypeQuery(errorLocation)) {
            return false;
          }
          var container = ts3.getThisContainer(errorLocation, false);
          var location = container;
          while (location) {
            if (ts3.isClassLike(location.parent)) {
              var classSymbol = getSymbolOfNode(location.parent);
              if (!classSymbol) {
                break;
              }
              var constructorType = getTypeOfSymbol(classSymbol);
              if (getPropertyOfType(constructorType, name)) {
                error(errorLocation, ts3.Diagnostics.Cannot_find_name_0_Did_you_mean_the_static_member_1_0, diagnosticName(nameArg), symbolToString(classSymbol));
                return true;
              }
              if (location === container && !ts3.hasSyntacticModifier(location, 32)) {
                var instanceType = getDeclaredTypeOfSymbol(classSymbol).thisType;
                if (getPropertyOfType(instanceType, name)) {
                  error(errorLocation, ts3.Diagnostics.Cannot_find_name_0_Did_you_mean_the_instance_member_this_0, diagnosticName(nameArg));
                  return true;
                }
              }
            }
            location = location.parent;
          }
          return false;
        }
        function checkAndReportErrorForExtendingInterface(errorLocation) {
          var expression = getEntityNameForExtendingInterface(errorLocation);
          if (expression && resolveEntityName(expression, 64, true)) {
            error(errorLocation, ts3.Diagnostics.Cannot_extend_an_interface_0_Did_you_mean_implements, ts3.getTextOfNode(expression));
            return true;
          }
          return false;
        }
        function getEntityNameForExtendingInterface(node) {
          switch (node.kind) {
            case 78:
            case 202:
              return node.parent ? getEntityNameForExtendingInterface(node.parent) : void 0;
            case 224:
              if (ts3.isEntityNameExpression(node.expression)) {
                return node.expression;
              }
            default:
              return void 0;
          }
        }
        function checkAndReportErrorForUsingTypeAsNamespace(errorLocation, name, meaning) {
          var namespaceMeaning = 1920 | (ts3.isInJSFile(errorLocation) ? 111551 : 0);
          if (meaning === namespaceMeaning) {
            var symbol = resolveSymbol(resolveName(errorLocation, name, 788968 & ~namespaceMeaning, void 0, void 0, false));
            var parent = errorLocation.parent;
            if (symbol) {
              if (ts3.isQualifiedName(parent)) {
                ts3.Debug.assert(parent.left === errorLocation, "Should only be resolving left side of qualified name as a namespace");
                var propName = parent.right.escapedText;
                var propType = getPropertyOfType(getDeclaredTypeOfSymbol(symbol), propName);
                if (propType) {
                  error(parent, ts3.Diagnostics.Cannot_access_0_1_because_0_is_a_type_but_not_a_namespace_Did_you_mean_to_retrieve_the_type_of_the_property_1_in_0_with_0_1, ts3.unescapeLeadingUnderscores(name), ts3.unescapeLeadingUnderscores(propName));
                  return true;
                }
              }
              error(errorLocation, ts3.Diagnostics._0_only_refers_to_a_type_but_is_being_used_as_a_namespace_here, ts3.unescapeLeadingUnderscores(name));
              return true;
            }
          }
          return false;
        }
        function checkAndReportErrorForUsingValueAsType(errorLocation, name, meaning) {
          if (meaning & (788968 & ~1920)) {
            var symbol = resolveSymbol(resolveName(errorLocation, name, ~788968 & 111551, void 0, void 0, false));
            if (symbol && !(symbol.flags & 1920)) {
              error(errorLocation, ts3.Diagnostics._0_refers_to_a_value_but_is_being_used_as_a_type_here_Did_you_mean_typeof_0, ts3.unescapeLeadingUnderscores(name));
              return true;
            }
          }
          return false;
        }
        function isPrimitiveTypeName(name) {
          return name === "any" || name === "string" || name === "number" || name === "boolean" || name === "never" || name === "unknown";
        }
        function checkAndReportErrorForExportingPrimitiveType(errorLocation, name) {
          if (isPrimitiveTypeName(name) && errorLocation.parent.kind === 271) {
            error(errorLocation, ts3.Diagnostics.Cannot_export_0_Only_local_declarations_can_be_exported_from_a_module, name);
            return true;
          }
          return false;
        }
        function checkAndReportErrorForUsingTypeAsValue(errorLocation, name, meaning) {
          if (meaning & (111551 & ~1024)) {
            if (isPrimitiveTypeName(name)) {
              error(errorLocation, ts3.Diagnostics._0_only_refers_to_a_type_but_is_being_used_as_a_value_here, ts3.unescapeLeadingUnderscores(name));
              return true;
            }
            var symbol = resolveSymbol(resolveName(errorLocation, name, 788968 & ~111551, void 0, void 0, false));
            if (symbol && !(symbol.flags & 1024)) {
              var rawName = ts3.unescapeLeadingUnderscores(name);
              if (isES2015OrLaterConstructorName(name)) {
                error(errorLocation, ts3.Diagnostics._0_only_refers_to_a_type_but_is_being_used_as_a_value_here_Do_you_need_to_change_your_target_library_Try_changing_the_lib_compiler_option_to_es2015_or_later, rawName);
              } else if (maybeMappedType(errorLocation, symbol)) {
                error(errorLocation, ts3.Diagnostics._0_only_refers_to_a_type_but_is_being_used_as_a_value_here_Did_you_mean_to_use_1_in_0, rawName, rawName === "K" ? "P" : "K");
              } else {
                error(errorLocation, ts3.Diagnostics._0_only_refers_to_a_type_but_is_being_used_as_a_value_here, rawName);
              }
              return true;
            }
          }
          return false;
        }
        function maybeMappedType(node, symbol) {
          var container = ts3.findAncestor(node.parent, function(n2) {
            return ts3.isComputedPropertyName(n2) || ts3.isPropertySignature(n2) ? false : ts3.isTypeLiteralNode(n2) || "quit";
          });
          if (container && container.members.length === 1) {
            var type3 = getDeclaredTypeOfSymbol(symbol);
            return !!(type3.flags & 1048576) && allTypesAssignableToKind(type3, 384, true);
          }
          return false;
        }
        function isES2015OrLaterConstructorName(n2) {
          switch (n2) {
            case "Promise":
            case "Symbol":
            case "Map":
            case "WeakMap":
            case "Set":
            case "WeakSet":
              return true;
          }
          return false;
        }
        function checkAndReportErrorForUsingNamespaceModuleAsValue(errorLocation, name, meaning) {
          if (meaning & (111551 & ~1024 & ~788968)) {
            var symbol = resolveSymbol(resolveName(errorLocation, name, 1024 & ~111551, void 0, void 0, false));
            if (symbol) {
              error(errorLocation, ts3.Diagnostics.Cannot_use_namespace_0_as_a_value, ts3.unescapeLeadingUnderscores(name));
              return true;
            }
          } else if (meaning & (788968 & ~1024 & ~111551)) {
            var symbol = resolveSymbol(resolveName(errorLocation, name, (512 | 1024) & ~788968, void 0, void 0, false));
            if (symbol) {
              error(errorLocation, ts3.Diagnostics.Cannot_use_namespace_0_as_a_type, ts3.unescapeLeadingUnderscores(name));
              return true;
            }
          }
          return false;
        }
        function checkResolvedBlockScopedVariable(result2, errorLocation) {
          var _a2;
          ts3.Debug.assert(!!(result2.flags & 2 || result2.flags & 32 || result2.flags & 384));
          if (result2.flags & (16 | 1 | 67108864) && result2.flags & 32) {
            return;
          }
          var declaration = (_a2 = result2.declarations) === null || _a2 === void 0 ? void 0 : _a2.find(function(d) {
            return ts3.isBlockOrCatchScoped(d) || ts3.isClassLike(d) || d.kind === 256;
          });
          if (declaration === void 0)
            return ts3.Debug.fail("checkResolvedBlockScopedVariable could not find block-scoped declaration");
          if (!(declaration.flags & 8388608) && !isBlockScopedNameDeclaredBeforeUse(declaration, errorLocation)) {
            var diagnosticMessage = void 0;
            var declarationName = ts3.declarationNameToString(ts3.getNameOfDeclaration(declaration));
            if (result2.flags & 2) {
              diagnosticMessage = error(errorLocation, ts3.Diagnostics.Block_scoped_variable_0_used_before_its_declaration, declarationName);
            } else if (result2.flags & 32) {
              diagnosticMessage = error(errorLocation, ts3.Diagnostics.Class_0_used_before_its_declaration, declarationName);
            } else if (result2.flags & 256) {
              diagnosticMessage = error(errorLocation, ts3.Diagnostics.Enum_0_used_before_its_declaration, declarationName);
            } else {
              ts3.Debug.assert(!!(result2.flags & 128));
              if (ts3.shouldPreserveConstEnums(compilerOptions)) {
                diagnosticMessage = error(errorLocation, ts3.Diagnostics.Enum_0_used_before_its_declaration, declarationName);
              }
            }
            if (diagnosticMessage) {
              ts3.addRelatedInfo(diagnosticMessage, ts3.createDiagnosticForNode(declaration, ts3.Diagnostics._0_is_declared_here, declarationName));
            }
          }
        }
        function isSameScopeDescendentOf(initial, parent, stopAt) {
          return !!parent && !!ts3.findAncestor(initial, function(n2) {
            return n2 === stopAt || ts3.isFunctionLike(n2) ? "quit" : n2 === parent;
          });
        }
        function getAnyImportSyntax(node) {
          switch (node.kind) {
            case 261:
              return node;
            case 263:
              return node.parent;
            case 264:
              return node.parent.parent;
            case 266:
              return node.parent.parent.parent;
            default:
              return void 0;
          }
        }
        function getDeclarationOfAliasSymbol(symbol) {
          return symbol.declarations && ts3.findLast(symbol.declarations, isAliasSymbolDeclaration);
        }
        function isAliasSymbolDeclaration(node) {
          return node.kind === 261 || node.kind === 260 || node.kind === 263 && !!node.name || node.kind === 264 || node.kind === 270 || node.kind === 266 || node.kind === 271 || node.kind === 267 && ts3.exportAssignmentIsAlias(node) || ts3.isBinaryExpression(node) && ts3.getAssignmentDeclarationKind(node) === 2 && ts3.exportAssignmentIsAlias(node) || ts3.isAccessExpression(node) && ts3.isBinaryExpression(node.parent) && node.parent.left === node && node.parent.operatorToken.kind === 62 && isAliasableOrJsExpression(node.parent.right) || node.kind === 290 || node.kind === 289 && isAliasableOrJsExpression(node.initializer) || ts3.isRequireVariableDeclaration(node);
        }
        function isAliasableOrJsExpression(e2) {
          return ts3.isAliasableExpression(e2) || ts3.isFunctionExpression(e2) && isJSConstructor(e2);
        }
        function getTargetOfImportEqualsDeclaration(node, dontResolveAlias) {
          var commonJSPropertyAccess = getCommonJSPropertyAccess(node);
          if (commonJSPropertyAccess) {
            var name = ts3.getLeftmostAccessExpression(commonJSPropertyAccess.expression).arguments[0];
            return ts3.isIdentifier(commonJSPropertyAccess.name) ? resolveSymbol(getPropertyOfType(resolveExternalModuleTypeByLiteral(name), commonJSPropertyAccess.name.escapedText)) : void 0;
          }
          if (ts3.isVariableDeclaration(node) || node.moduleReference.kind === 273) {
            var immediate = resolveExternalModuleName(node, ts3.getExternalModuleRequireArgument(node) || ts3.getExternalModuleImportEqualsDeclarationExpression(node));
            var resolved_4 = resolveExternalModuleSymbol(immediate);
            markSymbolOfAliasDeclarationIfTypeOnly(node, immediate, resolved_4, false);
            return resolved_4;
          }
          var resolved = getSymbolOfPartOfRightHandSideOfImportEquals(node.moduleReference, dontResolveAlias);
          checkAndReportErrorForResolvingImportAliasToTypeOnlySymbol(node, resolved);
          return resolved;
        }
        function checkAndReportErrorForResolvingImportAliasToTypeOnlySymbol(node, resolved) {
          if (markSymbolOfAliasDeclarationIfTypeOnly(node, void 0, resolved, false) && !node.isTypeOnly) {
            var typeOnlyDeclaration = getTypeOnlyAliasDeclaration(getSymbolOfNode(node));
            var isExport = ts3.typeOnlyDeclarationIsExport(typeOnlyDeclaration);
            var message = isExport ? ts3.Diagnostics.An_import_alias_cannot_reference_a_declaration_that_was_exported_using_export_type : ts3.Diagnostics.An_import_alias_cannot_reference_a_declaration_that_was_imported_using_import_type;
            var relatedMessage = isExport ? ts3.Diagnostics._0_was_exported_here : ts3.Diagnostics._0_was_imported_here;
            var name = ts3.unescapeLeadingUnderscores(typeOnlyDeclaration.name.escapedText);
            ts3.addRelatedInfo(error(node.moduleReference, message), ts3.createDiagnosticForNode(typeOnlyDeclaration, relatedMessage, name));
          }
        }
        function resolveExportByName(moduleSymbol, name, sourceNode, dontResolveAlias) {
          var exportValue = moduleSymbol.exports.get("export=");
          var exportSymbol = exportValue ? getPropertyOfType(getTypeOfSymbol(exportValue), name) : moduleSymbol.exports.get(name);
          var resolved = resolveSymbol(exportSymbol, dontResolveAlias);
          markSymbolOfAliasDeclarationIfTypeOnly(sourceNode, exportSymbol, resolved, false);
          return resolved;
        }
        function isSyntacticDefault(node) {
          return ts3.isExportAssignment(node) && !node.isExportEquals || ts3.hasSyntacticModifier(node, 512) || ts3.isExportSpecifier(node);
        }
        function canHaveSyntheticDefault(file, moduleSymbol, dontResolveAlias) {
          if (!allowSyntheticDefaultImports) {
            return false;
          }
          if (!file || file.isDeclarationFile) {
            var defaultExportSymbol = resolveExportByName(moduleSymbol, "default", void 0, true);
            if (defaultExportSymbol && ts3.some(defaultExportSymbol.declarations, isSyntacticDefault)) {
              return false;
            }
            if (resolveExportByName(moduleSymbol, ts3.escapeLeadingUnderscores("__esModule"), void 0, dontResolveAlias)) {
              return false;
            }
            return true;
          }
          if (!ts3.isSourceFileJS(file)) {
            return hasExportAssignmentSymbol(moduleSymbol);
          }
          return !file.externalModuleIndicator && !resolveExportByName(moduleSymbol, ts3.escapeLeadingUnderscores("__esModule"), void 0, dontResolveAlias);
        }
        function getTargetOfImportClause(node, dontResolveAlias) {
          var _a2;
          var moduleSymbol = resolveExternalModuleName(node, node.parent.moduleSpecifier);
          if (moduleSymbol) {
            var exportDefaultSymbol = void 0;
            if (ts3.isShorthandAmbientModuleSymbol(moduleSymbol)) {
              exportDefaultSymbol = moduleSymbol;
            } else {
              exportDefaultSymbol = resolveExportByName(moduleSymbol, "default", node, dontResolveAlias);
            }
            var file = (_a2 = moduleSymbol.declarations) === null || _a2 === void 0 ? void 0 : _a2.find(ts3.isSourceFile);
            var hasSyntheticDefault = canHaveSyntheticDefault(file, moduleSymbol, dontResolveAlias);
            if (!exportDefaultSymbol && !hasSyntheticDefault) {
              if (hasExportAssignmentSymbol(moduleSymbol)) {
                var compilerOptionName = moduleKind >= ts3.ModuleKind.ES2015 ? "allowSyntheticDefaultImports" : "esModuleInterop";
                var exportEqualsSymbol = moduleSymbol.exports.get("export=");
                var exportAssignment = exportEqualsSymbol.valueDeclaration;
                var err2 = error(node.name, ts3.Diagnostics.Module_0_can_only_be_default_imported_using_the_1_flag, symbolToString(moduleSymbol), compilerOptionName);
                if (exportAssignment) {
                  ts3.addRelatedInfo(err2, ts3.createDiagnosticForNode(exportAssignment, ts3.Diagnostics.This_module_is_declared_with_using_export_and_can_only_be_used_with_a_default_import_when_using_the_0_flag, compilerOptionName));
                }
              } else {
                reportNonDefaultExport(moduleSymbol, node);
              }
            } else if (hasSyntheticDefault) {
              var resolved = resolveExternalModuleSymbol(moduleSymbol, dontResolveAlias) || resolveSymbol(moduleSymbol, dontResolveAlias);
              markSymbolOfAliasDeclarationIfTypeOnly(node, moduleSymbol, resolved, false);
              return resolved;
            }
            markSymbolOfAliasDeclarationIfTypeOnly(node, exportDefaultSymbol, void 0, false);
            return exportDefaultSymbol;
          }
        }
        function reportNonDefaultExport(moduleSymbol, node) {
          var _a2, _b, _c;
          if ((_a2 = moduleSymbol.exports) === null || _a2 === void 0 ? void 0 : _a2.has(node.symbol.escapedName)) {
            error(node.name, ts3.Diagnostics.Module_0_has_no_default_export_Did_you_mean_to_use_import_1_from_0_instead, symbolToString(moduleSymbol), symbolToString(node.symbol));
          } else {
            var diagnostic = error(node.name, ts3.Diagnostics.Module_0_has_no_default_export, symbolToString(moduleSymbol));
            var exportStar = (_b = moduleSymbol.exports) === null || _b === void 0 ? void 0 : _b.get("__export");
            if (exportStar) {
              var defaultExport = (_c = exportStar.declarations) === null || _c === void 0 ? void 0 : _c.find(function(decl) {
                var _a3, _b2;
                return !!(ts3.isExportDeclaration(decl) && decl.moduleSpecifier && ((_b2 = (_a3 = resolveExternalModuleName(decl, decl.moduleSpecifier)) === null || _a3 === void 0 ? void 0 : _a3.exports) === null || _b2 === void 0 ? void 0 : _b2.has("default")));
              });
              if (defaultExport) {
                ts3.addRelatedInfo(diagnostic, ts3.createDiagnosticForNode(defaultExport, ts3.Diagnostics.export_Asterisk_does_not_re_export_a_default));
              }
            }
          }
        }
        function getTargetOfNamespaceImport(node, dontResolveAlias) {
          var moduleSpecifier = node.parent.parent.moduleSpecifier;
          var immediate = resolveExternalModuleName(node, moduleSpecifier);
          var resolved = resolveESModuleSymbol(immediate, moduleSpecifier, dontResolveAlias, false);
          markSymbolOfAliasDeclarationIfTypeOnly(node, immediate, resolved, false);
          return resolved;
        }
        function getTargetOfNamespaceExport(node, dontResolveAlias) {
          var moduleSpecifier = node.parent.moduleSpecifier;
          var immediate = moduleSpecifier && resolveExternalModuleName(node, moduleSpecifier);
          var resolved = moduleSpecifier && resolveESModuleSymbol(immediate, moduleSpecifier, dontResolveAlias, false);
          markSymbolOfAliasDeclarationIfTypeOnly(node, immediate, resolved, false);
          return resolved;
        }
        function combineValueAndTypeSymbols(valueSymbol, typeSymbol) {
          if (valueSymbol === unknownSymbol && typeSymbol === unknownSymbol) {
            return unknownSymbol;
          }
          if (valueSymbol.flags & (788968 | 1920)) {
            return valueSymbol;
          }
          var result2 = createSymbol(valueSymbol.flags | typeSymbol.flags, valueSymbol.escapedName);
          result2.declarations = ts3.deduplicate(ts3.concatenate(valueSymbol.declarations, typeSymbol.declarations), ts3.equateValues);
          result2.parent = valueSymbol.parent || typeSymbol.parent;
          if (valueSymbol.valueDeclaration)
            result2.valueDeclaration = valueSymbol.valueDeclaration;
          if (typeSymbol.members)
            result2.members = new ts3.Map(typeSymbol.members);
          if (valueSymbol.exports)
            result2.exports = new ts3.Map(valueSymbol.exports);
          return result2;
        }
        function getExportOfModule(symbol, name, specifier, dontResolveAlias) {
          if (symbol.flags & 1536) {
            var exportSymbol = getExportsOfSymbol(symbol).get(name.escapedText);
            var resolved = resolveSymbol(exportSymbol, dontResolveAlias);
            markSymbolOfAliasDeclarationIfTypeOnly(specifier, exportSymbol, resolved, false);
            return resolved;
          }
        }
        function getPropertyOfVariable(symbol, name) {
          if (symbol.flags & 3) {
            var typeAnnotation = symbol.valueDeclaration.type;
            if (typeAnnotation) {
              return resolveSymbol(getPropertyOfType(getTypeFromTypeNode(typeAnnotation), name));
            }
          }
        }
        function getExternalModuleMember(node, specifier, dontResolveAlias) {
          var _a2, _b;
          if (dontResolveAlias === void 0) {
            dontResolveAlias = false;
          }
          var moduleSpecifier = ts3.getExternalModuleRequireArgument(node) || node.moduleSpecifier;
          var moduleSymbol = resolveExternalModuleName(node, moduleSpecifier);
          var name = !ts3.isPropertyAccessExpression(specifier) && specifier.propertyName || specifier.name;
          if (!ts3.isIdentifier(name)) {
            return void 0;
          }
          var suppressInteropError = name.escapedText === "default" && !!(compilerOptions.allowSyntheticDefaultImports || compilerOptions.esModuleInterop);
          var targetSymbol = resolveESModuleSymbol(moduleSymbol, moduleSpecifier, false, suppressInteropError);
          if (targetSymbol) {
            if (name.escapedText) {
              if (ts3.isShorthandAmbientModuleSymbol(moduleSymbol)) {
                return moduleSymbol;
              }
              var symbolFromVariable = void 0;
              if (moduleSymbol && moduleSymbol.exports && moduleSymbol.exports.get("export=")) {
                symbolFromVariable = getPropertyOfType(getTypeOfSymbol(targetSymbol), name.escapedText, true);
              } else {
                symbolFromVariable = getPropertyOfVariable(targetSymbol, name.escapedText);
              }
              symbolFromVariable = resolveSymbol(symbolFromVariable, dontResolveAlias);
              var symbolFromModule = getExportOfModule(targetSymbol, name, specifier, dontResolveAlias);
              if (symbolFromModule === void 0 && name.escapedText === "default") {
                var file = (_a2 = moduleSymbol.declarations) === null || _a2 === void 0 ? void 0 : _a2.find(ts3.isSourceFile);
                if (canHaveSyntheticDefault(file, moduleSymbol, dontResolveAlias)) {
                  symbolFromModule = resolveExternalModuleSymbol(moduleSymbol, dontResolveAlias) || resolveSymbol(moduleSymbol, dontResolveAlias);
                }
              }
              var symbol = symbolFromModule && symbolFromVariable && symbolFromModule !== symbolFromVariable ? combineValueAndTypeSymbols(symbolFromVariable, symbolFromModule) : symbolFromModule || symbolFromVariable;
              if (!symbol) {
                var moduleName = getFullyQualifiedName(moduleSymbol, node);
                var declarationName = ts3.declarationNameToString(name);
                var suggestion = getSuggestedSymbolForNonexistentModule(name, targetSymbol);
                if (suggestion !== void 0) {
                  var suggestionName = symbolToString(suggestion);
                  var diagnostic = error(name, ts3.Diagnostics._0_has_no_exported_member_named_1_Did_you_mean_2, moduleName, declarationName, suggestionName);
                  if (suggestion.valueDeclaration) {
                    ts3.addRelatedInfo(diagnostic, ts3.createDiagnosticForNode(suggestion.valueDeclaration, ts3.Diagnostics._0_is_declared_here, suggestionName));
                  }
                } else {
                  if ((_b = moduleSymbol.exports) === null || _b === void 0 ? void 0 : _b.has("default")) {
                    error(name, ts3.Diagnostics.Module_0_has_no_exported_member_1_Did_you_mean_to_use_import_1_from_0_instead, moduleName, declarationName);
                  } else {
                    reportNonExportedMember(node, name, declarationName, moduleSymbol, moduleName);
                  }
                }
              }
              return symbol;
            }
          }
        }
        function reportNonExportedMember(node, name, declarationName, moduleSymbol, moduleName) {
          var _a2, _b;
          var localSymbol = (_b = (_a2 = moduleSymbol.valueDeclaration) === null || _a2 === void 0 ? void 0 : _a2.locals) === null || _b === void 0 ? void 0 : _b.get(name.escapedText);
          var exports3 = moduleSymbol.exports;
          if (localSymbol) {
            var exportedEqualsSymbol = exports3 === null || exports3 === void 0 ? void 0 : exports3.get("export=");
            if (exportedEqualsSymbol) {
              getSymbolIfSameReference(exportedEqualsSymbol, localSymbol) ? reportInvalidImportEqualsExportMember(node, name, declarationName, moduleName) : error(name, ts3.Diagnostics.Module_0_has_no_exported_member_1, moduleName, declarationName);
            } else {
              var exportedSymbol = exports3 ? ts3.find(symbolsToArray(exports3), function(symbol) {
                return !!getSymbolIfSameReference(symbol, localSymbol);
              }) : void 0;
              var diagnostic = exportedSymbol ? error(name, ts3.Diagnostics.Module_0_declares_1_locally_but_it_is_exported_as_2, moduleName, declarationName, symbolToString(exportedSymbol)) : error(name, ts3.Diagnostics.Module_0_declares_1_locally_but_it_is_not_exported, moduleName, declarationName);
              if (localSymbol.declarations) {
                ts3.addRelatedInfo.apply(void 0, __spreadArray([diagnostic], ts3.map(localSymbol.declarations, function(decl, index) {
                  return ts3.createDiagnosticForNode(decl, index === 0 ? ts3.Diagnostics._0_is_declared_here : ts3.Diagnostics.and_here, declarationName);
                })));
              }
            }
          } else {
            error(name, ts3.Diagnostics.Module_0_has_no_exported_member_1, moduleName, declarationName);
          }
        }
        function reportInvalidImportEqualsExportMember(node, name, declarationName, moduleName) {
          if (moduleKind >= ts3.ModuleKind.ES2015) {
            var message = compilerOptions.esModuleInterop ? ts3.Diagnostics._0_can_only_be_imported_by_using_a_default_import : ts3.Diagnostics._0_can_only_be_imported_by_turning_on_the_esModuleInterop_flag_and_using_a_default_import;
            error(name, message, declarationName);
          } else {
            if (ts3.isInJSFile(node)) {
              var message = compilerOptions.esModuleInterop ? ts3.Diagnostics._0_can_only_be_imported_by_using_a_require_call_or_by_using_a_default_import : ts3.Diagnostics._0_can_only_be_imported_by_using_a_require_call_or_by_turning_on_the_esModuleInterop_flag_and_using_a_default_import;
              error(name, message, declarationName);
            } else {
              var message = compilerOptions.esModuleInterop ? ts3.Diagnostics._0_can_only_be_imported_by_using_import_1_require_2_or_a_default_import : ts3.Diagnostics._0_can_only_be_imported_by_using_import_1_require_2_or_by_turning_on_the_esModuleInterop_flag_and_using_a_default_import;
              error(name, message, declarationName, declarationName, moduleName);
            }
          }
        }
        function getTargetOfImportSpecifier(node, dontResolveAlias) {
          var root = ts3.isBindingElement(node) ? ts3.getRootDeclaration(node) : node.parent.parent.parent;
          var commonJSPropertyAccess = getCommonJSPropertyAccess(root);
          var resolved = getExternalModuleMember(root, commonJSPropertyAccess || node, dontResolveAlias);
          var name = node.propertyName || node.name;
          if (commonJSPropertyAccess && resolved && ts3.isIdentifier(name)) {
            return resolveSymbol(getPropertyOfType(getTypeOfSymbol(resolved), name.escapedText), dontResolveAlias);
          }
          markSymbolOfAliasDeclarationIfTypeOnly(node, void 0, resolved, false);
          return resolved;
        }
        function getCommonJSPropertyAccess(node) {
          if (ts3.isVariableDeclaration(node) && node.initializer && ts3.isPropertyAccessExpression(node.initializer)) {
            return node.initializer;
          }
        }
        function getTargetOfNamespaceExportDeclaration(node, dontResolveAlias) {
          var resolved = resolveExternalModuleSymbol(node.parent.symbol, dontResolveAlias);
          markSymbolOfAliasDeclarationIfTypeOnly(node, void 0, resolved, false);
          return resolved;
        }
        function getTargetOfExportSpecifier(node, meaning, dontResolveAlias) {
          var resolved = node.parent.parent.moduleSpecifier ? getExternalModuleMember(node.parent.parent, node, dontResolveAlias) : resolveEntityName(node.propertyName || node.name, meaning, false, dontResolveAlias);
          markSymbolOfAliasDeclarationIfTypeOnly(node, void 0, resolved, false);
          return resolved;
        }
        function getTargetOfExportAssignment(node, dontResolveAlias) {
          var expression = ts3.isExportAssignment(node) ? node.expression : node.right;
          var resolved = getTargetOfAliasLikeExpression(expression, dontResolveAlias);
          markSymbolOfAliasDeclarationIfTypeOnly(node, void 0, resolved, false);
          return resolved;
        }
        function getTargetOfAliasLikeExpression(expression, dontResolveAlias) {
          if (ts3.isClassExpression(expression)) {
            return checkExpressionCached(expression).symbol;
          }
          if (!ts3.isEntityName(expression) && !ts3.isEntityNameExpression(expression)) {
            return void 0;
          }
          var aliasLike = resolveEntityName(expression, 111551 | 788968 | 1920, true, dontResolveAlias);
          if (aliasLike) {
            return aliasLike;
          }
          checkExpressionCached(expression);
          return getNodeLinks(expression).resolvedSymbol;
        }
        function getTargetOfPropertyAssignment(node, dontRecursivelyResolve) {
          var expression = node.initializer;
          return getTargetOfAliasLikeExpression(expression, dontRecursivelyResolve);
        }
        function getTargetOfAccessExpression(node, dontRecursivelyResolve) {
          if (!(ts3.isBinaryExpression(node.parent) && node.parent.left === node && node.parent.operatorToken.kind === 62)) {
            return void 0;
          }
          return getTargetOfAliasLikeExpression(node.parent.right, dontRecursivelyResolve);
        }
        function getTargetOfAliasDeclaration(node, dontRecursivelyResolve) {
          if (dontRecursivelyResolve === void 0) {
            dontRecursivelyResolve = false;
          }
          switch (node.kind) {
            case 261:
            case 250:
              return getTargetOfImportEqualsDeclaration(node, dontRecursivelyResolve);
            case 263:
              return getTargetOfImportClause(node, dontRecursivelyResolve);
            case 264:
              return getTargetOfNamespaceImport(node, dontRecursivelyResolve);
            case 270:
              return getTargetOfNamespaceExport(node, dontRecursivelyResolve);
            case 266:
            case 199:
              return getTargetOfImportSpecifier(node, dontRecursivelyResolve);
            case 271:
              return getTargetOfExportSpecifier(node, 111551 | 788968 | 1920, dontRecursivelyResolve);
            case 267:
            case 217:
              return getTargetOfExportAssignment(node, dontRecursivelyResolve);
            case 260:
              return getTargetOfNamespaceExportDeclaration(node, dontRecursivelyResolve);
            case 290:
              return resolveEntityName(node.name, 111551 | 788968 | 1920, true, dontRecursivelyResolve);
            case 289:
              return getTargetOfPropertyAssignment(node, dontRecursivelyResolve);
            case 203:
            case 202:
              return getTargetOfAccessExpression(node, dontRecursivelyResolve);
            default:
              return ts3.Debug.fail();
          }
        }
        function isNonLocalAlias(symbol, excludes) {
          if (excludes === void 0) {
            excludes = 111551 | 788968 | 1920;
          }
          if (!symbol)
            return false;
          return (symbol.flags & (2097152 | excludes)) === 2097152 || !!(symbol.flags & 2097152 && symbol.flags & 67108864);
        }
        function resolveSymbol(symbol, dontResolveAlias) {
          return !dontResolveAlias && isNonLocalAlias(symbol) ? resolveAlias(symbol) : symbol;
        }
        function resolveAlias(symbol) {
          ts3.Debug.assert((symbol.flags & 2097152) !== 0, "Should only get Alias here.");
          var links = getSymbolLinks(symbol);
          if (!links.target) {
            links.target = resolvingSymbol;
            var node = getDeclarationOfAliasSymbol(symbol);
            if (!node)
              return ts3.Debug.fail();
            var target = getTargetOfAliasDeclaration(node);
            if (links.target === resolvingSymbol) {
              links.target = target || unknownSymbol;
            } else {
              error(node, ts3.Diagnostics.Circular_definition_of_import_alias_0, symbolToString(symbol));
            }
          } else if (links.target === resolvingSymbol) {
            links.target = unknownSymbol;
          }
          return links.target;
        }
        function tryResolveAlias(symbol) {
          var links = getSymbolLinks(symbol);
          if (links.target !== resolvingSymbol) {
            return resolveAlias(symbol);
          }
          return void 0;
        }
        function markSymbolOfAliasDeclarationIfTypeOnly(aliasDeclaration, immediateTarget, finalTarget, overwriteEmpty) {
          if (!aliasDeclaration || ts3.isPropertyAccessExpression(aliasDeclaration))
            return false;
          var sourceSymbol = getSymbolOfNode(aliasDeclaration);
          if (ts3.isTypeOnlyImportOrExportDeclaration(aliasDeclaration)) {
            var links_1 = getSymbolLinks(sourceSymbol);
            links_1.typeOnlyDeclaration = aliasDeclaration;
            return true;
          }
          var links = getSymbolLinks(sourceSymbol);
          return markSymbolOfAliasDeclarationIfTypeOnlyWorker(links, immediateTarget, overwriteEmpty) || markSymbolOfAliasDeclarationIfTypeOnlyWorker(links, finalTarget, overwriteEmpty);
        }
        function markSymbolOfAliasDeclarationIfTypeOnlyWorker(aliasDeclarationLinks, target, overwriteEmpty) {
          var _a2, _b, _c;
          if (target && (aliasDeclarationLinks.typeOnlyDeclaration === void 0 || overwriteEmpty && aliasDeclarationLinks.typeOnlyDeclaration === false)) {
            var exportSymbol = (_b = (_a2 = target.exports) === null || _a2 === void 0 ? void 0 : _a2.get("export=")) !== null && _b !== void 0 ? _b : target;
            var typeOnly = exportSymbol.declarations && ts3.find(exportSymbol.declarations, ts3.isTypeOnlyImportOrExportDeclaration);
            aliasDeclarationLinks.typeOnlyDeclaration = (_c = typeOnly !== null && typeOnly !== void 0 ? typeOnly : getSymbolLinks(exportSymbol).typeOnlyDeclaration) !== null && _c !== void 0 ? _c : false;
          }
          return !!aliasDeclarationLinks.typeOnlyDeclaration;
        }
        function getTypeOnlyAliasDeclaration(symbol) {
          if (!(symbol.flags & 2097152)) {
            return void 0;
          }
          var links = getSymbolLinks(symbol);
          return links.typeOnlyDeclaration || void 0;
        }
        function markExportAsReferenced(node) {
          var symbol = getSymbolOfNode(node);
          var target = resolveAlias(symbol);
          if (target) {
            var markAlias = target === unknownSymbol || target.flags & 111551 && !isConstEnumOrConstEnumOnlyModule(target) && !getTypeOnlyAliasDeclaration(symbol);
            if (markAlias) {
              markAliasSymbolAsReferenced(symbol);
            }
          }
        }
        function markAliasSymbolAsReferenced(symbol) {
          var links = getSymbolLinks(symbol);
          if (!links.referenced) {
            links.referenced = true;
            var node = getDeclarationOfAliasSymbol(symbol);
            if (!node)
              return ts3.Debug.fail();
            if (ts3.isInternalModuleImportEqualsDeclaration(node)) {
              var target = resolveSymbol(symbol);
              if (target === unknownSymbol || target.flags & 111551) {
                checkExpressionCached(node.moduleReference);
              }
            }
          }
        }
        function markConstEnumAliasAsReferenced(symbol) {
          var links = getSymbolLinks(symbol);
          if (!links.constEnumReferenced) {
            links.constEnumReferenced = true;
          }
        }
        function getSymbolOfPartOfRightHandSideOfImportEquals(entityName, dontResolveAlias) {
          if (entityName.kind === 78 && ts3.isRightSideOfQualifiedNameOrPropertyAccess(entityName)) {
            entityName = entityName.parent;
          }
          if (entityName.kind === 78 || entityName.parent.kind === 158) {
            return resolveEntityName(entityName, 1920, false, dontResolveAlias);
          } else {
            ts3.Debug.assert(entityName.parent.kind === 261);
            return resolveEntityName(entityName, 111551 | 788968 | 1920, false, dontResolveAlias);
          }
        }
        function getFullyQualifiedName(symbol, containingLocation) {
          return symbol.parent ? getFullyQualifiedName(symbol.parent, containingLocation) + "." + symbolToString(symbol) : symbolToString(symbol, containingLocation, void 0, 16 | 4);
        }
        function resolveEntityName(name, meaning, ignoreErrors, dontResolveAlias, location) {
          if (ts3.nodeIsMissing(name)) {
            return void 0;
          }
          var namespaceMeaning = 1920 | (ts3.isInJSFile(name) ? meaning & 111551 : 0);
          var symbol;
          if (name.kind === 78) {
            var message = meaning === namespaceMeaning || ts3.nodeIsSynthesized(name) ? ts3.Diagnostics.Cannot_find_namespace_0 : getCannotFindNameDiagnosticForName(ts3.getFirstIdentifier(name));
            var symbolFromJSPrototype = ts3.isInJSFile(name) && !ts3.nodeIsSynthesized(name) ? resolveEntityNameFromAssignmentDeclaration(name, meaning) : void 0;
            symbol = getMergedSymbol(resolveName(location || name, name.escapedText, meaning, ignoreErrors || symbolFromJSPrototype ? void 0 : message, name, true));
            if (!symbol) {
              return getMergedSymbol(symbolFromJSPrototype);
            }
          } else if (name.kind === 158 || name.kind === 202) {
            var left = name.kind === 158 ? name.left : name.expression;
            var right = name.kind === 158 ? name.right : name.name;
            var namespace = resolveEntityName(left, namespaceMeaning, ignoreErrors, false, location);
            if (!namespace || ts3.nodeIsMissing(right)) {
              return void 0;
            } else if (namespace === unknownSymbol) {
              return namespace;
            }
            if (namespace.valueDeclaration && ts3.isInJSFile(namespace.valueDeclaration) && ts3.isVariableDeclaration(namespace.valueDeclaration) && namespace.valueDeclaration.initializer && isCommonJsRequire(namespace.valueDeclaration.initializer)) {
              var moduleName = namespace.valueDeclaration.initializer.arguments[0];
              var moduleSym = resolveExternalModuleName(moduleName, moduleName);
              if (moduleSym) {
                var resolvedModuleSymbol = resolveExternalModuleSymbol(moduleSym);
                if (resolvedModuleSymbol) {
                  namespace = resolvedModuleSymbol;
                }
              }
            }
            symbol = getMergedSymbol(getSymbol(getExportsOfSymbol(namespace), right.escapedText, meaning));
            if (!symbol) {
              if (!ignoreErrors) {
                var namespaceName = getFullyQualifiedName(namespace);
                var declarationName = ts3.declarationNameToString(right);
                var suggestion = getSuggestedSymbolForNonexistentModule(right, namespace);
                suggestion ? error(right, ts3.Diagnostics._0_has_no_exported_member_named_1_Did_you_mean_2, namespaceName, declarationName, symbolToString(suggestion)) : error(right, ts3.Diagnostics.Namespace_0_has_no_exported_member_1, namespaceName, declarationName);
              }
              return void 0;
            }
          } else {
            throw ts3.Debug.assertNever(name, "Unknown entity name kind.");
          }
          ts3.Debug.assert((ts3.getCheckFlags(symbol) & 1) === 0, "Should never get an instantiated symbol here.");
          if (!ts3.nodeIsSynthesized(name) && ts3.isEntityName(name) && (symbol.flags & 2097152 || name.parent.kind === 267)) {
            markSymbolOfAliasDeclarationIfTypeOnly(ts3.getAliasDeclarationFromName(name), symbol, void 0, true);
          }
          return symbol.flags & meaning || dontResolveAlias ? symbol : resolveAlias(symbol);
        }
        function resolveEntityNameFromAssignmentDeclaration(name, meaning) {
          if (isJSDocTypeReference(name.parent)) {
            var secondaryLocation = getAssignmentDeclarationLocation(name.parent);
            if (secondaryLocation) {
              return resolveName(secondaryLocation, name.escapedText, meaning, void 0, name, true);
            }
          }
        }
        function getAssignmentDeclarationLocation(node) {
          var typeAlias = ts3.findAncestor(node, function(node2) {
            return !(ts3.isJSDocNode(node2) || node2.flags & 4194304) ? "quit" : ts3.isJSDocTypeAlias(node2);
          });
          if (typeAlias) {
            return;
          }
          var host2 = ts3.getJSDocHost(node);
          if (host2 && ts3.isExpressionStatement(host2) && ts3.isBinaryExpression(host2.expression) && ts3.getAssignmentDeclarationKind(host2.expression) === 3) {
            var symbol = getSymbolOfNode(host2.expression.left);
            if (symbol) {
              return getDeclarationOfJSPrototypeContainer(symbol);
            }
          }
          if (host2 && (ts3.isObjectLiteralMethod(host2) || ts3.isPropertyAssignment(host2)) && ts3.isBinaryExpression(host2.parent.parent) && ts3.getAssignmentDeclarationKind(host2.parent.parent) === 6) {
            var symbol = getSymbolOfNode(host2.parent.parent.left);
            if (symbol) {
              return getDeclarationOfJSPrototypeContainer(symbol);
            }
          }
          var sig = ts3.getEffectiveJSDocHost(node);
          if (sig && ts3.isFunctionLike(sig)) {
            var symbol = getSymbolOfNode(sig);
            return symbol && symbol.valueDeclaration;
          }
        }
        function getDeclarationOfJSPrototypeContainer(symbol) {
          var decl = symbol.parent.valueDeclaration;
          if (!decl) {
            return void 0;
          }
          var initializer = ts3.isAssignmentDeclaration(decl) ? ts3.getAssignedExpandoInitializer(decl) : ts3.hasOnlyExpressionInitializer(decl) ? ts3.getDeclaredExpandoInitializer(decl) : void 0;
          return initializer || decl;
        }
        function getExpandoSymbol(symbol) {
          var decl = symbol.valueDeclaration;
          if (!decl || !ts3.isInJSFile(decl) || symbol.flags & 524288 || ts3.getExpandoInitializer(decl, false)) {
            return void 0;
          }
          var init = ts3.isVariableDeclaration(decl) ? ts3.getDeclaredExpandoInitializer(decl) : ts3.getAssignedExpandoInitializer(decl);
          if (init) {
            var initSymbol = getSymbolOfNode(init);
            if (initSymbol) {
              return mergeJSSymbols(initSymbol, symbol);
            }
          }
        }
        function resolveExternalModuleName(location, moduleReferenceExpression, ignoreErrors) {
          var isClassic = ts3.getEmitModuleResolutionKind(compilerOptions) === ts3.ModuleResolutionKind.Classic;
          var errorMessage = isClassic ? ts3.Diagnostics.Cannot_find_module_0_Did_you_mean_to_set_the_moduleResolution_option_to_node_or_to_add_aliases_to_the_paths_option : ts3.Diagnostics.Cannot_find_module_0_or_its_corresponding_type_declarations;
          return resolveExternalModuleNameWorker(location, moduleReferenceExpression, ignoreErrors ? void 0 : errorMessage);
        }
        function resolveExternalModuleNameWorker(location, moduleReferenceExpression, moduleNotFoundError, isForAugmentation) {
          if (isForAugmentation === void 0) {
            isForAugmentation = false;
          }
          return ts3.isStringLiteralLike(moduleReferenceExpression) ? resolveExternalModule(location, moduleReferenceExpression.text, moduleNotFoundError, moduleReferenceExpression, isForAugmentation) : void 0;
        }
        function resolveExternalModule(location, moduleReference, moduleNotFoundError, errorNode, isForAugmentation) {
          if (isForAugmentation === void 0) {
            isForAugmentation = false;
          }
          if (ts3.startsWith(moduleReference, "@types/")) {
            var diag = ts3.Diagnostics.Cannot_import_type_declaration_files_Consider_importing_0_instead_of_1;
            var withoutAtTypePrefix = ts3.removePrefix(moduleReference, "@types/");
            error(errorNode, diag, withoutAtTypePrefix, moduleReference);
          }
          var ambientModule = tryFindAmbientModule(moduleReference, true);
          if (ambientModule) {
            return ambientModule;
          }
          var currentSourceFile = ts3.getSourceFileOfNode(location);
          var resolvedModule = ts3.getResolvedModule(currentSourceFile, moduleReference);
          var resolutionDiagnostic = resolvedModule && ts3.getResolutionDiagnostic(compilerOptions, resolvedModule);
          var sourceFile = resolvedModule && !resolutionDiagnostic && host.getSourceFile(resolvedModule.resolvedFileName);
          if (sourceFile) {
            if (sourceFile.symbol) {
              if (resolvedModule.isExternalLibraryImport && !ts3.resolutionExtensionIsTSOrJson(resolvedModule.extension)) {
                errorOnImplicitAnyModule(false, errorNode, resolvedModule, moduleReference);
              }
              return getMergedSymbol(sourceFile.symbol);
            }
            if (moduleNotFoundError) {
              error(errorNode, ts3.Diagnostics.File_0_is_not_a_module, sourceFile.fileName);
            }
            return void 0;
          }
          if (patternAmbientModules) {
            var pattern = ts3.findBestPatternMatch(patternAmbientModules, function(_) {
              return _.pattern;
            }, moduleReference);
            if (pattern) {
              var augmentation = patternAmbientModuleAugmentations && patternAmbientModuleAugmentations.get(moduleReference);
              if (augmentation) {
                return getMergedSymbol(augmentation);
              }
              return getMergedSymbol(pattern.symbol);
            }
          }
          if (resolvedModule && !ts3.resolutionExtensionIsTSOrJson(resolvedModule.extension) && resolutionDiagnostic === void 0 || resolutionDiagnostic === ts3.Diagnostics.Could_not_find_a_declaration_file_for_module_0_1_implicitly_has_an_any_type) {
            if (isForAugmentation) {
              var diag = ts3.Diagnostics.Invalid_module_name_in_augmentation_Module_0_resolves_to_an_untyped_module_at_1_which_cannot_be_augmented;
              error(errorNode, diag, moduleReference, resolvedModule.resolvedFileName);
            } else {
              errorOnImplicitAnyModule(noImplicitAny && !!moduleNotFoundError, errorNode, resolvedModule, moduleReference);
            }
            return void 0;
          }
          if (moduleNotFoundError) {
            if (resolvedModule) {
              var redirect = host.getProjectReferenceRedirect(resolvedModule.resolvedFileName);
              if (redirect) {
                error(errorNode, ts3.Diagnostics.Output_file_0_has_not_been_built_from_source_file_1, redirect, resolvedModule.resolvedFileName);
                return void 0;
              }
            }
            if (resolutionDiagnostic) {
              error(errorNode, resolutionDiagnostic, moduleReference, resolvedModule.resolvedFileName);
            } else {
              var tsExtension = ts3.tryExtractTSExtension(moduleReference);
              if (tsExtension) {
                var diag = ts3.Diagnostics.An_import_path_cannot_end_with_a_0_extension_Consider_importing_1_instead;
                var importSourceWithoutExtension = ts3.removeExtension(moduleReference, tsExtension);
                var replacedImportSource = importSourceWithoutExtension;
                var moduleKind_1 = ts3.getEmitModuleKind(compilerOptions);
                if (moduleKind_1 >= ts3.ModuleKind.ES2015) {
                  replacedImportSource += ".js";
                }
                error(errorNode, diag, tsExtension, replacedImportSource);
              } else if (!compilerOptions.resolveJsonModule && ts3.fileExtensionIs(moduleReference, ".json") && ts3.getEmitModuleResolutionKind(compilerOptions) === ts3.ModuleResolutionKind.NodeJs && ts3.hasJsonModuleEmitEnabled(compilerOptions)) {
                error(errorNode, ts3.Diagnostics.Cannot_find_module_0_Consider_using_resolveJsonModule_to_import_module_with_json_extension, moduleReference);
              } else {
                error(errorNode, moduleNotFoundError, moduleReference);
              }
            }
          }
          return void 0;
        }
        function errorOnImplicitAnyModule(isError, errorNode, _a2, moduleReference) {
          var packageId = _a2.packageId, resolvedFileName = _a2.resolvedFileName;
          var errorInfo = !ts3.isExternalModuleNameRelative(moduleReference) && packageId ? typesPackageExists(packageId.name) ? ts3.chainDiagnosticMessages(void 0, ts3.Diagnostics.If_the_0_package_actually_exposes_this_module_consider_sending_a_pull_request_to_amend_https_Colon_Slash_Slashgithub_com_SlashDefinitelyTyped_SlashDefinitelyTyped_Slashtree_Slashmaster_Slashtypes_Slash_1, packageId.name, ts3.mangleScopedPackageName(packageId.name)) : ts3.chainDiagnosticMessages(void 0, ts3.Diagnostics.Try_npm_i_save_dev_types_Slash_1_if_it_exists_or_add_a_new_declaration_d_ts_file_containing_declare_module_0, moduleReference, ts3.mangleScopedPackageName(packageId.name)) : void 0;
          errorOrSuggestion(isError, errorNode, ts3.chainDiagnosticMessages(errorInfo, ts3.Diagnostics.Could_not_find_a_declaration_file_for_module_0_1_implicitly_has_an_any_type, moduleReference, resolvedFileName));
        }
        function typesPackageExists(packageName) {
          return getPackagesSet().has(ts3.getTypesPackageName(packageName));
        }
        function resolveExternalModuleSymbol(moduleSymbol, dontResolveAlias) {
          if (moduleSymbol === null || moduleSymbol === void 0 ? void 0 : moduleSymbol.exports) {
            var exportEquals = resolveSymbol(moduleSymbol.exports.get("export="), dontResolveAlias);
            var exported = getCommonJsExportEquals(getMergedSymbol(exportEquals), getMergedSymbol(moduleSymbol));
            return getMergedSymbol(exported) || moduleSymbol;
          }
          return void 0;
        }
        function getCommonJsExportEquals(exported, moduleSymbol) {
          if (!exported || exported === unknownSymbol || exported === moduleSymbol || moduleSymbol.exports.size === 1 || exported.flags & 2097152) {
            return exported;
          }
          var links = getSymbolLinks(exported);
          if (links.cjsExportMerged) {
            return links.cjsExportMerged;
          }
          var merged = exported.flags & 33554432 ? exported : cloneSymbol(exported);
          merged.flags = merged.flags | 512;
          if (merged.exports === void 0) {
            merged.exports = ts3.createSymbolTable();
          }
          moduleSymbol.exports.forEach(function(s2, name) {
            if (name === "export=")
              return;
            merged.exports.set(name, merged.exports.has(name) ? mergeSymbol(merged.exports.get(name), s2) : s2);
          });
          getSymbolLinks(merged).cjsExportMerged = merged;
          return links.cjsExportMerged = merged;
        }
        function resolveESModuleSymbol(moduleSymbol, referencingLocation, dontResolveAlias, suppressInteropError) {
          var symbol = resolveExternalModuleSymbol(moduleSymbol, dontResolveAlias);
          if (!dontResolveAlias && symbol) {
            if (!suppressInteropError && !(symbol.flags & (1536 | 3)) && !ts3.getDeclarationOfKind(symbol, 298)) {
              var compilerOptionName = moduleKind >= ts3.ModuleKind.ES2015 ? "allowSyntheticDefaultImports" : "esModuleInterop";
              error(referencingLocation, ts3.Diagnostics.This_module_can_only_be_referenced_with_ECMAScript_imports_Slashexports_by_turning_on_the_0_flag_and_referencing_its_default_export, compilerOptionName);
              return symbol;
            }
            if (compilerOptions.esModuleInterop) {
              var referenceParent = referencingLocation.parent;
              if (ts3.isImportDeclaration(referenceParent) && ts3.getNamespaceDeclarationNode(referenceParent) || ts3.isImportCall(referenceParent)) {
                var type3 = getTypeOfSymbol(symbol);
                var sigs = getSignaturesOfStructuredType(type3, 0);
                if (!sigs || !sigs.length) {
                  sigs = getSignaturesOfStructuredType(type3, 1);
                }
                if (sigs && sigs.length) {
                  var moduleType = getTypeWithSyntheticDefaultImportType(type3, symbol, moduleSymbol);
                  var result2 = createSymbol(symbol.flags, symbol.escapedName);
                  result2.declarations = symbol.declarations ? symbol.declarations.slice() : [];
                  result2.parent = symbol.parent;
                  result2.target = symbol;
                  result2.originatingImport = referenceParent;
                  if (symbol.valueDeclaration)
                    result2.valueDeclaration = symbol.valueDeclaration;
                  if (symbol.constEnumOnlyModule)
                    result2.constEnumOnlyModule = true;
                  if (symbol.members)
                    result2.members = new ts3.Map(symbol.members);
                  if (symbol.exports)
                    result2.exports = new ts3.Map(symbol.exports);
                  var resolvedModuleType = resolveStructuredTypeMembers(moduleType);
                  result2.type = createAnonymousType(result2, resolvedModuleType.members, ts3.emptyArray, ts3.emptyArray, resolvedModuleType.stringIndexInfo, resolvedModuleType.numberIndexInfo);
                  return result2;
                }
              }
            }
          }
          return symbol;
        }
        function hasExportAssignmentSymbol(moduleSymbol) {
          return moduleSymbol.exports.get("export=") !== void 0;
        }
        function getExportsOfModuleAsArray(moduleSymbol) {
          return symbolsToArray(getExportsOfModule(moduleSymbol));
        }
        function getExportsAndPropertiesOfModule(moduleSymbol) {
          var exports3 = getExportsOfModuleAsArray(moduleSymbol);
          var exportEquals = resolveExternalModuleSymbol(moduleSymbol);
          if (exportEquals !== moduleSymbol) {
            var type3 = getTypeOfSymbol(exportEquals);
            if (shouldTreatPropertiesOfExternalModuleAsExports(type3)) {
              ts3.addRange(exports3, getPropertiesOfType(type3));
            }
          }
          return exports3;
        }
        function tryGetMemberInModuleExports(memberName, moduleSymbol) {
          var symbolTable = getExportsOfModule(moduleSymbol);
          if (symbolTable) {
            return symbolTable.get(memberName);
          }
        }
        function tryGetMemberInModuleExportsAndProperties(memberName, moduleSymbol) {
          var symbol = tryGetMemberInModuleExports(memberName, moduleSymbol);
          if (symbol) {
            return symbol;
          }
          var exportEquals = resolveExternalModuleSymbol(moduleSymbol);
          if (exportEquals === moduleSymbol) {
            return void 0;
          }
          var type3 = getTypeOfSymbol(exportEquals);
          return shouldTreatPropertiesOfExternalModuleAsExports(type3) ? getPropertyOfType(type3, memberName) : void 0;
        }
        function shouldTreatPropertiesOfExternalModuleAsExports(resolvedExternalModuleType) {
          return !(resolvedExternalModuleType.flags & 131068 || ts3.getObjectFlags(resolvedExternalModuleType) & 1 || isArrayType(resolvedExternalModuleType) || isTupleType(resolvedExternalModuleType));
        }
        function getExportsOfSymbol(symbol) {
          return symbol.flags & 6256 ? getResolvedMembersOrExportsOfSymbol(symbol, "resolvedExports") : symbol.flags & 1536 ? getExportsOfModule(symbol) : symbol.exports || emptySymbols;
        }
        function getExportsOfModule(moduleSymbol) {
          var links = getSymbolLinks(moduleSymbol);
          return links.resolvedExports || (links.resolvedExports = getExportsOfModuleWorker(moduleSymbol));
        }
        function extendExportSymbols(target, source, lookupTable, exportNode) {
          if (!source)
            return;
          source.forEach(function(sourceSymbol, id) {
            if (id === "default")
              return;
            var targetSymbol = target.get(id);
            if (!targetSymbol) {
              target.set(id, sourceSymbol);
              if (lookupTable && exportNode) {
                lookupTable.set(id, {
                  specifierText: ts3.getTextOfNode(exportNode.moduleSpecifier)
                });
              }
            } else if (lookupTable && exportNode && targetSymbol && resolveSymbol(targetSymbol) !== resolveSymbol(sourceSymbol)) {
              var collisionTracker = lookupTable.get(id);
              if (!collisionTracker.exportsWithDuplicate) {
                collisionTracker.exportsWithDuplicate = [exportNode];
              } else {
                collisionTracker.exportsWithDuplicate.push(exportNode);
              }
            }
          });
        }
        function getExportsOfModuleWorker(moduleSymbol) {
          var visitedSymbols = [];
          moduleSymbol = resolveExternalModuleSymbol(moduleSymbol);
          return visit(moduleSymbol) || emptySymbols;
          function visit(symbol) {
            if (!(symbol && symbol.exports && ts3.pushIfUnique(visitedSymbols, symbol))) {
              return;
            }
            var symbols = new ts3.Map(symbol.exports);
            var exportStars = symbol.exports.get("__export");
            if (exportStars) {
              var nestedSymbols = ts3.createSymbolTable();
              var lookupTable_1 = new ts3.Map();
              if (exportStars.declarations) {
                for (var _i = 0, _a2 = exportStars.declarations; _i < _a2.length; _i++) {
                  var node = _a2[_i];
                  var resolvedModule = resolveExternalModuleName(node, node.moduleSpecifier);
                  var exportedSymbols = visit(resolvedModule);
                  extendExportSymbols(nestedSymbols, exportedSymbols, lookupTable_1, node);
                }
              }
              lookupTable_1.forEach(function(_a3, id) {
                var exportsWithDuplicate = _a3.exportsWithDuplicate;
                if (id === "export=" || !(exportsWithDuplicate && exportsWithDuplicate.length) || symbols.has(id)) {
                  return;
                }
                for (var _i2 = 0, exportsWithDuplicate_1 = exportsWithDuplicate; _i2 < exportsWithDuplicate_1.length; _i2++) {
                  var node2 = exportsWithDuplicate_1[_i2];
                  diagnostics.add(ts3.createDiagnosticForNode(node2, ts3.Diagnostics.Module_0_has_already_exported_a_member_named_1_Consider_explicitly_re_exporting_to_resolve_the_ambiguity, lookupTable_1.get(id).specifierText, ts3.unescapeLeadingUnderscores(id)));
                }
              });
              extendExportSymbols(symbols, nestedSymbols);
            }
            return symbols;
          }
        }
        function getMergedSymbol(symbol) {
          var merged;
          return symbol && symbol.mergeId && (merged = mergedSymbols[symbol.mergeId]) ? merged : symbol;
        }
        function getSymbolOfNode(node) {
          return getMergedSymbol(node.symbol && getLateBoundSymbol(node.symbol));
        }
        function getParentOfSymbol(symbol) {
          return getMergedSymbol(symbol.parent && getLateBoundSymbol(symbol.parent));
        }
        function getAlternativeContainingModules(symbol, enclosingDeclaration) {
          var containingFile = ts3.getSourceFileOfNode(enclosingDeclaration);
          var id = getNodeId(containingFile);
          var links = getSymbolLinks(symbol);
          var results;
          if (links.extendedContainersByFile && (results = links.extendedContainersByFile.get(id))) {
            return results;
          }
          if (containingFile && containingFile.imports) {
            for (var _i = 0, _a2 = containingFile.imports; _i < _a2.length; _i++) {
              var importRef = _a2[_i];
              if (ts3.nodeIsSynthesized(importRef))
                continue;
              var resolvedModule = resolveExternalModuleName(enclosingDeclaration, importRef, true);
              if (!resolvedModule)
                continue;
              var ref2 = getAliasForSymbolInContainer(resolvedModule, symbol);
              if (!ref2)
                continue;
              results = ts3.append(results, resolvedModule);
            }
            if (ts3.length(results)) {
              (links.extendedContainersByFile || (links.extendedContainersByFile = new ts3.Map())).set(id, results);
              return results;
            }
          }
          if (links.extendedContainers) {
            return links.extendedContainers;
          }
          var otherFiles = host.getSourceFiles();
          for (var _b = 0, otherFiles_1 = otherFiles; _b < otherFiles_1.length; _b++) {
            var file = otherFiles_1[_b];
            if (!ts3.isExternalModule(file))
              continue;
            var sym = getSymbolOfNode(file);
            var ref2 = getAliasForSymbolInContainer(sym, symbol);
            if (!ref2)
              continue;
            results = ts3.append(results, sym);
          }
          return links.extendedContainers = results || ts3.emptyArray;
        }
        function getContainersOfSymbol(symbol, enclosingDeclaration, meaning) {
          var container = getParentOfSymbol(symbol);
          if (container && !(symbol.flags & 262144)) {
            var additionalContainers = ts3.mapDefined(container.declarations, fileSymbolIfFileSymbolExportEqualsContainer);
            var reexportContainers = enclosingDeclaration && getAlternativeContainingModules(symbol, enclosingDeclaration);
            var objectLiteralContainer = getVariableDeclarationOfObjectLiteral(container, meaning);
            if (enclosingDeclaration && container.flags & getQualifiedLeftMeaning(meaning) && getAccessibleSymbolChain(container, enclosingDeclaration, 1920, false)) {
              return ts3.append(ts3.concatenate(ts3.concatenate([container], additionalContainers), reexportContainers), objectLiteralContainer);
            }
            var firstVariableMatch = !(container.flags & getQualifiedLeftMeaning(meaning)) && container.flags & 788968 && getDeclaredTypeOfSymbol(container).flags & 524288 && meaning === 111551 ? forEachSymbolTableInScope(enclosingDeclaration, function(t2) {
              return ts3.forEachEntry(t2, function(s2) {
                if (s2.flags & getQualifiedLeftMeaning(meaning) && getTypeOfSymbol(s2) === getDeclaredTypeOfSymbol(container)) {
                  return s2;
                }
              });
            }) : void 0;
            var res = firstVariableMatch ? __spreadArray(__spreadArray([firstVariableMatch], additionalContainers), [container]) : __spreadArray(__spreadArray([], additionalContainers), [container]);
            res = ts3.append(res, objectLiteralContainer);
            res = ts3.addRange(res, reexportContainers);
            return res;
          }
          var candidates = ts3.mapDefined(symbol.declarations, function(d) {
            if (!ts3.isAmbientModule(d) && d.parent && hasNonGlobalAugmentationExternalModuleSymbol(d.parent)) {
              return getSymbolOfNode(d.parent);
            }
            if (ts3.isClassExpression(d) && ts3.isBinaryExpression(d.parent) && d.parent.operatorToken.kind === 62 && ts3.isAccessExpression(d.parent.left) && ts3.isEntityNameExpression(d.parent.left.expression)) {
              if (ts3.isModuleExportsAccessExpression(d.parent.left) || ts3.isExportsIdentifier(d.parent.left.expression)) {
                return getSymbolOfNode(ts3.getSourceFileOfNode(d));
              }
              checkExpressionCached(d.parent.left.expression);
              return getNodeLinks(d.parent.left.expression).resolvedSymbol;
            }
          });
          if (!ts3.length(candidates)) {
            return void 0;
          }
          return ts3.mapDefined(candidates, function(candidate) {
            return getAliasForSymbolInContainer(candidate, symbol) ? candidate : void 0;
          });
          function fileSymbolIfFileSymbolExportEqualsContainer(d) {
            return container && getFileSymbolIfFileSymbolExportEqualsContainer(d, container);
          }
        }
        function getVariableDeclarationOfObjectLiteral(symbol, meaning) {
          var firstDecl = !!ts3.length(symbol.declarations) && ts3.first(symbol.declarations);
          if (meaning & 111551 && firstDecl && firstDecl.parent && ts3.isVariableDeclaration(firstDecl.parent)) {
            if (ts3.isObjectLiteralExpression(firstDecl) && firstDecl === firstDecl.parent.initializer || ts3.isTypeLiteralNode(firstDecl) && firstDecl === firstDecl.parent.type) {
              return getSymbolOfNode(firstDecl.parent);
            }
          }
        }
        function getFileSymbolIfFileSymbolExportEqualsContainer(d, container) {
          var fileSymbol = getExternalModuleContainer(d);
          var exported = fileSymbol && fileSymbol.exports && fileSymbol.exports.get("export=");
          return exported && getSymbolIfSameReference(exported, container) ? fileSymbol : void 0;
        }
        function getAliasForSymbolInContainer(container, symbol) {
          if (container === getParentOfSymbol(symbol)) {
            return symbol;
          }
          var exportEquals = container.exports && container.exports.get("export=");
          if (exportEquals && getSymbolIfSameReference(exportEquals, symbol)) {
            return container;
          }
          var exports3 = getExportsOfSymbol(container);
          var quick = exports3.get(symbol.escapedName);
          if (quick && getSymbolIfSameReference(quick, symbol)) {
            return quick;
          }
          return ts3.forEachEntry(exports3, function(exported) {
            if (getSymbolIfSameReference(exported, symbol)) {
              return exported;
            }
          });
        }
        function getSymbolIfSameReference(s1, s2) {
          if (getMergedSymbol(resolveSymbol(getMergedSymbol(s1))) === getMergedSymbol(resolveSymbol(getMergedSymbol(s2)))) {
            return s1;
          }
        }
        function getExportSymbolOfValueSymbolIfExported(symbol) {
          return getMergedSymbol(symbol && (symbol.flags & 1048576) !== 0 ? symbol.exportSymbol : symbol);
        }
        function symbolIsValue(symbol) {
          return !!(symbol.flags & 111551 || symbol.flags & 2097152 && resolveAlias(symbol).flags & 111551 && !getTypeOnlyAliasDeclaration(symbol));
        }
        function findConstructorDeclaration(node) {
          var members = node.members;
          for (var _i = 0, members_3 = members; _i < members_3.length; _i++) {
            var member = members_3[_i];
            if (member.kind === 167 && ts3.nodeIsPresent(member.body)) {
              return member;
            }
          }
        }
        function createType(flags) {
          var result2 = new Type2(checker, flags);
          typeCount++;
          result2.id = typeCount;
          if (produceDiagnostics) {
            ts3.tracing === null || ts3.tracing === void 0 ? void 0 : ts3.tracing.recordType(result2);
          }
          return result2;
        }
        function createOriginType(flags) {
          return new Type2(checker, flags);
        }
        function createIntrinsicType(kind, intrinsicName, objectFlags) {
          if (objectFlags === void 0) {
            objectFlags = 0;
          }
          var type3 = createType(kind);
          type3.intrinsicName = intrinsicName;
          type3.objectFlags = objectFlags;
          return type3;
        }
        function createBooleanType(trueFalseTypes) {
          var type3 = getUnionType(trueFalseTypes);
          type3.flags |= 16;
          type3.intrinsicName = "boolean";
          return type3;
        }
        function createObjectType(objectFlags, symbol) {
          var type3 = createType(524288);
          type3.objectFlags = objectFlags;
          type3.symbol = symbol;
          type3.members = void 0;
          type3.properties = void 0;
          type3.callSignatures = void 0;
          type3.constructSignatures = void 0;
          type3.stringIndexInfo = void 0;
          type3.numberIndexInfo = void 0;
          return type3;
        }
        function createTypeofType() {
          return getUnionType(ts3.arrayFrom(typeofEQFacts.keys(), getLiteralType));
        }
        function createTypeParameter(symbol) {
          var type3 = createType(262144);
          if (symbol)
            type3.symbol = symbol;
          return type3;
        }
        function isReservedMemberName(name) {
          return name.charCodeAt(0) === 95 && name.charCodeAt(1) === 95 && name.charCodeAt(2) !== 95 && name.charCodeAt(2) !== 64 && name.charCodeAt(2) !== 35;
        }
        function getNamedMembers(members) {
          var result2;
          members.forEach(function(symbol, id) {
            if (!isReservedMemberName(id) && symbolIsValue(symbol)) {
              (result2 || (result2 = [])).push(symbol);
            }
          });
          return result2 || ts3.emptyArray;
        }
        function getNamedOrIndexSignatureMembers(members) {
          var result2 = getNamedMembers(members);
          var index = getIndexSymbolFromSymbolTable(members);
          return index ? ts3.concatenate(result2, [index]) : result2;
        }
        function setStructuredTypeMembers(type3, members, callSignatures, constructSignatures, stringIndexInfo, numberIndexInfo) {
          var resolved = type3;
          resolved.members = members;
          resolved.properties = ts3.emptyArray;
          resolved.callSignatures = callSignatures;
          resolved.constructSignatures = constructSignatures;
          resolved.stringIndexInfo = stringIndexInfo;
          resolved.numberIndexInfo = numberIndexInfo;
          if (members !== emptySymbols)
            resolved.properties = getNamedMembers(members);
          return resolved;
        }
        function createAnonymousType(symbol, members, callSignatures, constructSignatures, stringIndexInfo, numberIndexInfo) {
          return setStructuredTypeMembers(createObjectType(16, symbol), members, callSignatures, constructSignatures, stringIndexInfo, numberIndexInfo);
        }
        function getResolvedTypeWithoutAbstractConstructSignatures(type3) {
          if (type3.constructSignatures.length === 0)
            return type3;
          if (type3.objectTypeWithoutAbstractConstructSignatures)
            return type3.objectTypeWithoutAbstractConstructSignatures;
          var constructSignatures = ts3.filter(type3.constructSignatures, function(signature) {
            return !(signature.flags & 4);
          });
          if (type3.constructSignatures === constructSignatures)
            return type3;
          var typeCopy = createAnonymousType(type3.symbol, type3.members, type3.callSignatures, ts3.some(constructSignatures) ? constructSignatures : ts3.emptyArray, type3.stringIndexInfo, type3.numberIndexInfo);
          type3.objectTypeWithoutAbstractConstructSignatures = typeCopy;
          typeCopy.objectTypeWithoutAbstractConstructSignatures = typeCopy;
          return typeCopy;
        }
        function forEachSymbolTableInScope(enclosingDeclaration, callback) {
          var result2;
          var _loop_8 = function(location2) {
            if (location2.locals && !isGlobalSourceFile(location2)) {
              if (result2 = callback(location2.locals, void 0, true)) {
                return { value: result2 };
              }
            }
            switch (location2.kind) {
              case 298:
                if (!ts3.isExternalOrCommonJsModule(location2)) {
                  break;
                }
              case 257:
                var sym = getSymbolOfNode(location2);
                if (result2 = callback((sym === null || sym === void 0 ? void 0 : sym.exports) || emptySymbols, void 0, true)) {
                  return { value: result2 };
                }
                break;
              case 253:
              case 222:
              case 254:
                var table_1;
                (getSymbolOfNode(location2).members || emptySymbols).forEach(function(memberSymbol, key2) {
                  if (memberSymbol.flags & (788968 & ~67108864)) {
                    (table_1 || (table_1 = ts3.createSymbolTable())).set(key2, memberSymbol);
                  }
                });
                if (table_1 && (result2 = callback(table_1))) {
                  return { value: result2 };
                }
                break;
            }
          };
          for (var location = enclosingDeclaration; location; location = location.parent) {
            var state_2 = _loop_8(location);
            if (typeof state_2 === "object")
              return state_2.value;
          }
          return callback(globals, void 0, true);
        }
        function getQualifiedLeftMeaning(rightMeaning) {
          return rightMeaning === 111551 ? 111551 : 1920;
        }
        function getAccessibleSymbolChain(symbol, enclosingDeclaration, meaning, useOnlyExternalAliasing, visitedSymbolTablesMap) {
          if (visitedSymbolTablesMap === void 0) {
            visitedSymbolTablesMap = new ts3.Map();
          }
          if (!(symbol && !isPropertyOrMethodDeclarationSymbol(symbol))) {
            return void 0;
          }
          var id = getSymbolId(symbol);
          var visitedSymbolTables = visitedSymbolTablesMap.get(id);
          if (!visitedSymbolTables) {
            visitedSymbolTablesMap.set(id, visitedSymbolTables = []);
          }
          return forEachSymbolTableInScope(enclosingDeclaration, getAccessibleSymbolChainFromSymbolTable);
          function getAccessibleSymbolChainFromSymbolTable(symbols, ignoreQualification, isLocalNameLookup) {
            if (!ts3.pushIfUnique(visitedSymbolTables, symbols)) {
              return void 0;
            }
            var result2 = trySymbolTable(symbols, ignoreQualification, isLocalNameLookup);
            visitedSymbolTables.pop();
            return result2;
          }
          function canQualifySymbol(symbolFromSymbolTable, meaning2) {
            return !needsQualification(symbolFromSymbolTable, enclosingDeclaration, meaning2) || !!getAccessibleSymbolChain(symbolFromSymbolTable.parent, enclosingDeclaration, getQualifiedLeftMeaning(meaning2), useOnlyExternalAliasing, visitedSymbolTablesMap);
          }
          function isAccessible(symbolFromSymbolTable, resolvedAliasSymbol, ignoreQualification) {
            return (symbol === (resolvedAliasSymbol || symbolFromSymbolTable) || getMergedSymbol(symbol) === getMergedSymbol(resolvedAliasSymbol || symbolFromSymbolTable)) && !ts3.some(symbolFromSymbolTable.declarations, hasNonGlobalAugmentationExternalModuleSymbol) && (ignoreQualification || canQualifySymbol(getMergedSymbol(symbolFromSymbolTable), meaning));
          }
          function trySymbolTable(symbols, ignoreQualification, isLocalNameLookup) {
            if (isAccessible(symbols.get(symbol.escapedName), void 0, ignoreQualification)) {
              return [symbol];
            }
            var result2 = ts3.forEachEntry(symbols, function(symbolFromSymbolTable) {
              if (symbolFromSymbolTable.flags & 2097152 && symbolFromSymbolTable.escapedName !== "export=" && symbolFromSymbolTable.escapedName !== "default" && !(ts3.isUMDExportSymbol(symbolFromSymbolTable) && enclosingDeclaration && ts3.isExternalModule(ts3.getSourceFileOfNode(enclosingDeclaration))) && (!useOnlyExternalAliasing || ts3.some(symbolFromSymbolTable.declarations, ts3.isExternalModuleImportEqualsDeclaration)) && (isLocalNameLookup ? !ts3.some(symbolFromSymbolTable.declarations, ts3.isNamespaceReexportDeclaration) : true) && (ignoreQualification || !ts3.getDeclarationOfKind(symbolFromSymbolTable, 271))) {
                var resolvedImportedSymbol = resolveAlias(symbolFromSymbolTable);
                var candidate = getCandidateListForSymbol(symbolFromSymbolTable, resolvedImportedSymbol, ignoreQualification);
                if (candidate) {
                  return candidate;
                }
              }
              if (symbolFromSymbolTable.escapedName === symbol.escapedName && symbolFromSymbolTable.exportSymbol) {
                if (isAccessible(getMergedSymbol(symbolFromSymbolTable.exportSymbol), void 0, ignoreQualification)) {
                  return [symbol];
                }
              }
            });
            return result2 || (symbols === globals ? getCandidateListForSymbol(globalThisSymbol, globalThisSymbol, ignoreQualification) : void 0);
          }
          function getCandidateListForSymbol(symbolFromSymbolTable, resolvedImportedSymbol, ignoreQualification) {
            if (isAccessible(symbolFromSymbolTable, resolvedImportedSymbol, ignoreQualification)) {
              return [symbolFromSymbolTable];
            }
            var candidateTable = getExportsOfSymbol(resolvedImportedSymbol);
            var accessibleSymbolsFromExports = candidateTable && getAccessibleSymbolChainFromSymbolTable(candidateTable, true);
            if (accessibleSymbolsFromExports && canQualifySymbol(symbolFromSymbolTable, getQualifiedLeftMeaning(meaning))) {
              return [symbolFromSymbolTable].concat(accessibleSymbolsFromExports);
            }
          }
        }
        function needsQualification(symbol, enclosingDeclaration, meaning) {
          var qualify = false;
          forEachSymbolTableInScope(enclosingDeclaration, function(symbolTable) {
            var symbolFromSymbolTable = getMergedSymbol(symbolTable.get(symbol.escapedName));
            if (!symbolFromSymbolTable) {
              return false;
            }
            if (symbolFromSymbolTable === symbol) {
              return true;
            }
            symbolFromSymbolTable = symbolFromSymbolTable.flags & 2097152 && !ts3.getDeclarationOfKind(symbolFromSymbolTable, 271) ? resolveAlias(symbolFromSymbolTable) : symbolFromSymbolTable;
            if (symbolFromSymbolTable.flags & meaning) {
              qualify = true;
              return true;
            }
            return false;
          });
          return qualify;
        }
        function isPropertyOrMethodDeclarationSymbol(symbol) {
          if (symbol.declarations && symbol.declarations.length) {
            for (var _i = 0, _a2 = symbol.declarations; _i < _a2.length; _i++) {
              var declaration = _a2[_i];
              switch (declaration.kind) {
                case 164:
                case 166:
                case 168:
                case 169:
                  continue;
                default:
                  return false;
              }
            }
            return true;
          }
          return false;
        }
        function isTypeSymbolAccessible(typeSymbol, enclosingDeclaration) {
          var access = isSymbolAccessibleWorker(typeSymbol, enclosingDeclaration, 788968, false, true);
          return access.accessibility === 0;
        }
        function isValueSymbolAccessible(typeSymbol, enclosingDeclaration) {
          var access = isSymbolAccessibleWorker(typeSymbol, enclosingDeclaration, 111551, false, true);
          return access.accessibility === 0;
        }
        function isSymbolAccessibleByFlags(typeSymbol, enclosingDeclaration, flags) {
          var access = isSymbolAccessibleWorker(typeSymbol, enclosingDeclaration, flags, false, false);
          return access.accessibility === 0;
        }
        function isAnySymbolAccessible(symbols, enclosingDeclaration, initialSymbol, meaning, shouldComputeAliasesToMakeVisible, allowModules) {
          if (!ts3.length(symbols))
            return;
          var hadAccessibleChain;
          var earlyModuleBail = false;
          for (var _i = 0, _a2 = symbols; _i < _a2.length; _i++) {
            var symbol = _a2[_i];
            var accessibleSymbolChain = getAccessibleSymbolChain(symbol, enclosingDeclaration, meaning, false);
            if (accessibleSymbolChain) {
              hadAccessibleChain = symbol;
              var hasAccessibleDeclarations = hasVisibleDeclarations(accessibleSymbolChain[0], shouldComputeAliasesToMakeVisible);
              if (hasAccessibleDeclarations) {
                return hasAccessibleDeclarations;
              }
            }
            if (allowModules) {
              if (ts3.some(symbol.declarations, hasNonGlobalAugmentationExternalModuleSymbol)) {
                if (shouldComputeAliasesToMakeVisible) {
                  earlyModuleBail = true;
                  continue;
                }
                return {
                  accessibility: 0
                };
              }
            }
            var containers = getContainersOfSymbol(symbol, enclosingDeclaration, meaning);
            var parentResult = isAnySymbolAccessible(containers, enclosingDeclaration, initialSymbol, initialSymbol === symbol ? getQualifiedLeftMeaning(meaning) : meaning, shouldComputeAliasesToMakeVisible, allowModules);
            if (parentResult) {
              return parentResult;
            }
          }
          if (earlyModuleBail) {
            return {
              accessibility: 0
            };
          }
          if (hadAccessibleChain) {
            return {
              accessibility: 1,
              errorSymbolName: symbolToString(initialSymbol, enclosingDeclaration, meaning),
              errorModuleName: hadAccessibleChain !== initialSymbol ? symbolToString(hadAccessibleChain, enclosingDeclaration, 1920) : void 0
            };
          }
        }
        function isSymbolAccessible(symbol, enclosingDeclaration, meaning, shouldComputeAliasesToMakeVisible) {
          return isSymbolAccessibleWorker(symbol, enclosingDeclaration, meaning, shouldComputeAliasesToMakeVisible, true);
        }
        function isSymbolAccessibleWorker(symbol, enclosingDeclaration, meaning, shouldComputeAliasesToMakeVisible, allowModules) {
          if (symbol && enclosingDeclaration) {
            var result2 = isAnySymbolAccessible([symbol], enclosingDeclaration, symbol, meaning, shouldComputeAliasesToMakeVisible, allowModules);
            if (result2) {
              return result2;
            }
            var symbolExternalModule = ts3.forEach(symbol.declarations, getExternalModuleContainer);
            if (symbolExternalModule) {
              var enclosingExternalModule = getExternalModuleContainer(enclosingDeclaration);
              if (symbolExternalModule !== enclosingExternalModule) {
                return {
                  accessibility: 2,
                  errorSymbolName: symbolToString(symbol, enclosingDeclaration, meaning),
                  errorModuleName: symbolToString(symbolExternalModule),
                  errorNode: ts3.isInJSFile(enclosingDeclaration) ? enclosingDeclaration : void 0
                };
              }
            }
            return {
              accessibility: 1,
              errorSymbolName: symbolToString(symbol, enclosingDeclaration, meaning)
            };
          }
          return { accessibility: 0 };
        }
        function getExternalModuleContainer(declaration) {
          var node = ts3.findAncestor(declaration, hasExternalModuleSymbol);
          return node && getSymbolOfNode(node);
        }
        function hasExternalModuleSymbol(declaration) {
          return ts3.isAmbientModule(declaration) || declaration.kind === 298 && ts3.isExternalOrCommonJsModule(declaration);
        }
        function hasNonGlobalAugmentationExternalModuleSymbol(declaration) {
          return ts3.isModuleWithStringLiteralName(declaration) || declaration.kind === 298 && ts3.isExternalOrCommonJsModule(declaration);
        }
        function hasVisibleDeclarations(symbol, shouldComputeAliasToMakeVisible) {
          var aliasesToMakeVisible;
          if (!ts3.every(ts3.filter(symbol.declarations, function(d) {
            return d.kind !== 78;
          }), getIsDeclarationVisible)) {
            return void 0;
          }
          return { accessibility: 0, aliasesToMakeVisible };
          function getIsDeclarationVisible(declaration) {
            var _a2, _b;
            if (!isDeclarationVisible(declaration)) {
              var anyImportSyntax = getAnyImportSyntax(declaration);
              if (anyImportSyntax && !ts3.hasSyntacticModifier(anyImportSyntax, 1) && isDeclarationVisible(anyImportSyntax.parent)) {
                return addVisibleAlias(declaration, anyImportSyntax);
              } else if (ts3.isVariableDeclaration(declaration) && ts3.isVariableStatement(declaration.parent.parent) && !ts3.hasSyntacticModifier(declaration.parent.parent, 1) && isDeclarationVisible(declaration.parent.parent.parent)) {
                return addVisibleAlias(declaration, declaration.parent.parent);
              } else if (ts3.isLateVisibilityPaintedStatement(declaration) && !ts3.hasSyntacticModifier(declaration, 1) && isDeclarationVisible(declaration.parent)) {
                return addVisibleAlias(declaration, declaration);
              } else if (symbol.flags & 2097152 && ts3.isBindingElement(declaration) && ts3.isInJSFile(declaration) && ((_a2 = declaration.parent) === null || _a2 === void 0 ? void 0 : _a2.parent) && ts3.isVariableDeclaration(declaration.parent.parent) && ((_b = declaration.parent.parent.parent) === null || _b === void 0 ? void 0 : _b.parent) && ts3.isVariableStatement(declaration.parent.parent.parent.parent) && !ts3.hasSyntacticModifier(declaration.parent.parent.parent.parent, 1) && declaration.parent.parent.parent.parent.parent && isDeclarationVisible(declaration.parent.parent.parent.parent.parent)) {
                return addVisibleAlias(declaration, declaration.parent.parent.parent.parent);
              }
              return false;
            }
            return true;
          }
          function addVisibleAlias(declaration, aliasingStatement) {
            if (shouldComputeAliasToMakeVisible) {
              getNodeLinks(declaration).isVisible = true;
              aliasesToMakeVisible = ts3.appendIfUnique(aliasesToMakeVisible, aliasingStatement);
            }
            return true;
          }
        }
        function isEntityNameVisible(entityName, enclosingDeclaration) {
          var meaning;
          if (entityName.parent.kind === 177 || ts3.isExpressionWithTypeArgumentsInClassExtendsClause(entityName.parent) || entityName.parent.kind === 159) {
            meaning = 111551 | 1048576;
          } else if (entityName.kind === 158 || entityName.kind === 202 || entityName.parent.kind === 261) {
            meaning = 1920;
          } else {
            meaning = 788968;
          }
          var firstIdentifier = ts3.getFirstIdentifier(entityName);
          var symbol = resolveName(enclosingDeclaration, firstIdentifier.escapedText, meaning, void 0, void 0, false);
          if (symbol && symbol.flags & 262144 && meaning & 788968) {
            return { accessibility: 0 };
          }
          return symbol && hasVisibleDeclarations(symbol, true) || {
            accessibility: 1,
            errorSymbolName: ts3.getTextOfNode(firstIdentifier),
            errorNode: firstIdentifier
          };
        }
        function symbolToString(symbol, enclosingDeclaration, meaning, flags, writer) {
          if (flags === void 0) {
            flags = 4;
          }
          var nodeFlags = 70221824;
          if (flags & 2) {
            nodeFlags |= 128;
          }
          if (flags & 1) {
            nodeFlags |= 512;
          }
          if (flags & 8) {
            nodeFlags |= 16384;
          }
          if (flags & 16) {
            nodeFlags |= 134217728;
          }
          var builder = flags & 4 ? nodeBuilder.symbolToExpression : nodeBuilder.symbolToEntityName;
          return writer ? symbolToStringWorker(writer).getText() : ts3.usingSingleLineStringWriter(symbolToStringWorker);
          function symbolToStringWorker(writer2) {
            var entity = builder(symbol, meaning, enclosingDeclaration, nodeFlags);
            var printer2 = (enclosingDeclaration === null || enclosingDeclaration === void 0 ? void 0 : enclosingDeclaration.kind) === 298 ? ts3.createPrinter({ removeComments: true, neverAsciiEscape: true }) : ts3.createPrinter({ removeComments: true });
            var sourceFile = enclosingDeclaration && ts3.getSourceFileOfNode(enclosingDeclaration);
            printer2.writeNode(4, entity, sourceFile, writer2);
            return writer2;
          }
        }
        function signatureToString(signature, enclosingDeclaration, flags, kind, writer) {
          if (flags === void 0) {
            flags = 0;
          }
          return writer ? signatureToStringWorker(writer).getText() : ts3.usingSingleLineStringWriter(signatureToStringWorker);
          function signatureToStringWorker(writer2) {
            var sigOutput;
            if (flags & 262144) {
              sigOutput = kind === 1 ? 176 : 175;
            } else {
              sigOutput = kind === 1 ? 171 : 170;
            }
            var sig = nodeBuilder.signatureToSignatureDeclaration(signature, sigOutput, enclosingDeclaration, toNodeBuilderFlags(flags) | 70221824 | 512);
            var printer2 = ts3.createPrinter({ removeComments: true, omitTrailingSemicolon: true });
            var sourceFile = enclosingDeclaration && ts3.getSourceFileOfNode(enclosingDeclaration);
            printer2.writeNode(4, sig, sourceFile, ts3.getTrailingSemicolonDeferringWriter(writer2));
            return writer2;
          }
        }
        function typeToString(type3, enclosingDeclaration, flags, writer) {
          if (flags === void 0) {
            flags = 1048576 | 16384;
          }
          if (writer === void 0) {
            writer = ts3.createTextWriter("");
          }
          var noTruncation = compilerOptions.noErrorTruncation || flags & 1;
          var typeNode = nodeBuilder.typeToTypeNode(type3, enclosingDeclaration, toNodeBuilderFlags(flags) | 70221824 | (noTruncation ? 1 : 0), writer);
          if (typeNode === void 0)
            return ts3.Debug.fail("should always get typenode");
          var options = { removeComments: true };
          var printer2 = ts3.createPrinter(options);
          var sourceFile = enclosingDeclaration && ts3.getSourceFileOfNode(enclosingDeclaration);
          printer2.writeNode(4, typeNode, sourceFile, writer);
          var result2 = writer.getText();
          var maxLength = noTruncation ? ts3.noTruncationMaximumTruncationLength * 2 : ts3.defaultMaximumTruncationLength * 2;
          if (maxLength && result2 && result2.length >= maxLength) {
            return result2.substr(0, maxLength - "...".length) + "...";
          }
          return result2;
        }
        function getTypeNamesForErrorDisplay(left, right) {
          var leftStr = symbolValueDeclarationIsContextSensitive(left.symbol) ? typeToString(left, left.symbol.valueDeclaration) : typeToString(left);
          var rightStr = symbolValueDeclarationIsContextSensitive(right.symbol) ? typeToString(right, right.symbol.valueDeclaration) : typeToString(right);
          if (leftStr === rightStr) {
            leftStr = getTypeNameForErrorDisplay(left);
            rightStr = getTypeNameForErrorDisplay(right);
          }
          return [leftStr, rightStr];
        }
        function getTypeNameForErrorDisplay(type3) {
          return typeToString(type3, void 0, 64);
        }
        function symbolValueDeclarationIsContextSensitive(symbol) {
          return symbol && !!symbol.valueDeclaration && ts3.isExpression(symbol.valueDeclaration) && !isContextSensitive(symbol.valueDeclaration);
        }
        function toNodeBuilderFlags(flags) {
          if (flags === void 0) {
            flags = 0;
          }
          return flags & 814775659;
        }
        function isClassInstanceSide(type3) {
          return !!type3.symbol && !!(type3.symbol.flags & 32) && (type3 === getDeclaredTypeOfClassOrInterface(type3.symbol) || !!(type3.flags & 524288) && !!(ts3.getObjectFlags(type3) & 16777216));
        }
        function createNodeBuilder() {
          return {
            typeToTypeNode: function(type3, enclosingDeclaration, flags, tracker) {
              return withContext(enclosingDeclaration, flags, tracker, function(context) {
                return typeToTypeNodeHelper(type3, context);
              });
            },
            indexInfoToIndexSignatureDeclaration: function(indexInfo, kind, enclosingDeclaration, flags, tracker) {
              return withContext(enclosingDeclaration, flags, tracker, function(context) {
                return indexInfoToIndexSignatureDeclarationHelper(indexInfo, kind, context, void 0);
              });
            },
            signatureToSignatureDeclaration: function(signature, kind, enclosingDeclaration, flags, tracker) {
              return withContext(enclosingDeclaration, flags, tracker, function(context) {
                return signatureToSignatureDeclarationHelper(signature, kind, context);
              });
            },
            symbolToEntityName: function(symbol, meaning, enclosingDeclaration, flags, tracker) {
              return withContext(enclosingDeclaration, flags, tracker, function(context) {
                return symbolToName(symbol, context, meaning, false);
              });
            },
            symbolToExpression: function(symbol, meaning, enclosingDeclaration, flags, tracker) {
              return withContext(enclosingDeclaration, flags, tracker, function(context) {
                return symbolToExpression(symbol, context, meaning);
              });
            },
            symbolToTypeParameterDeclarations: function(symbol, enclosingDeclaration, flags, tracker) {
              return withContext(enclosingDeclaration, flags, tracker, function(context) {
                return typeParametersToTypeParameterDeclarations(symbol, context);
              });
            },
            symbolToParameterDeclaration: function(symbol, enclosingDeclaration, flags, tracker) {
              return withContext(enclosingDeclaration, flags, tracker, function(context) {
                return symbolToParameterDeclaration(symbol, context);
              });
            },
            typeParameterToDeclaration: function(parameter, enclosingDeclaration, flags, tracker) {
              return withContext(enclosingDeclaration, flags, tracker, function(context) {
                return typeParameterToDeclaration(parameter, context);
              });
            },
            symbolTableToDeclarationStatements: function(symbolTable, enclosingDeclaration, flags, tracker, bundled) {
              return withContext(enclosingDeclaration, flags, tracker, function(context) {
                return symbolTableToDeclarationStatements(symbolTable, context, bundled);
              });
            }
          };
          function withContext(enclosingDeclaration, flags, tracker, cb2) {
            var _a2, _b;
            ts3.Debug.assert(enclosingDeclaration === void 0 || (enclosingDeclaration.flags & 8) === 0);
            var context = {
              enclosingDeclaration,
              flags: flags || 0,
              tracker: tracker && tracker.trackSymbol ? tracker : { trackSymbol: ts3.noop, moduleResolverHost: flags & 134217728 ? {
                getCommonSourceDirectory: !!host.getCommonSourceDirectory ? function() {
                  return host.getCommonSourceDirectory();
                } : function() {
                  return "";
                },
                getSourceFiles: function() {
                  return host.getSourceFiles();
                },
                getCurrentDirectory: function() {
                  return host.getCurrentDirectory();
                },
                getSymlinkCache: ts3.maybeBind(host, host.getSymlinkCache),
                useCaseSensitiveFileNames: ts3.maybeBind(host, host.useCaseSensitiveFileNames),
                redirectTargetsMap: host.redirectTargetsMap,
                getProjectReferenceRedirect: function(fileName) {
                  return host.getProjectReferenceRedirect(fileName);
                },
                isSourceOfProjectReferenceRedirect: function(fileName) {
                  return host.isSourceOfProjectReferenceRedirect(fileName);
                },
                fileExists: function(fileName) {
                  return host.fileExists(fileName);
                },
                getFileIncludeReasons: function() {
                  return host.getFileIncludeReasons();
                }
              } : void 0 },
              encounteredError: false,
              visitedTypes: void 0,
              symbolDepth: void 0,
              inferTypeParameters: void 0,
              approximateLength: 0
            };
            var resultingNode = cb2(context);
            if (context.truncating && context.flags & 1) {
              (_b = (_a2 = context.tracker) === null || _a2 === void 0 ? void 0 : _a2.reportTruncationError) === null || _b === void 0 ? void 0 : _b.call(_a2);
            }
            return context.encounteredError ? void 0 : resultingNode;
          }
          function checkTruncationLength(context) {
            if (context.truncating)
              return context.truncating;
            return context.truncating = context.approximateLength > (context.flags & 1 ? ts3.noTruncationMaximumTruncationLength : ts3.defaultMaximumTruncationLength);
          }
          function typeToTypeNodeHelper(type3, context) {
            if (cancellationToken && cancellationToken.throwIfCancellationRequested) {
              cancellationToken.throwIfCancellationRequested();
            }
            var inTypeAlias = context.flags & 8388608;
            context.flags &= ~8388608;
            if (!type3) {
              if (!(context.flags & 262144)) {
                context.encounteredError = true;
                return void 0;
              }
              context.approximateLength += 3;
              return ts3.factory.createKeywordTypeNode(128);
            }
            if (!(context.flags & 536870912)) {
              type3 = getReducedType(type3);
            }
            if (type3.flags & 1) {
              context.approximateLength += 3;
              return ts3.factory.createKeywordTypeNode(type3 === intrinsicMarkerType ? 136 : 128);
            }
            if (type3.flags & 2) {
              return ts3.factory.createKeywordTypeNode(152);
            }
            if (type3.flags & 4) {
              context.approximateLength += 6;
              return ts3.factory.createKeywordTypeNode(147);
            }
            if (type3.flags & 8) {
              context.approximateLength += 6;
              return ts3.factory.createKeywordTypeNode(144);
            }
            if (type3.flags & 64) {
              context.approximateLength += 6;
              return ts3.factory.createKeywordTypeNode(155);
            }
            if (type3.flags & 16) {
              context.approximateLength += 7;
              return ts3.factory.createKeywordTypeNode(131);
            }
            if (type3.flags & 1024 && !(type3.flags & 1048576)) {
              var parentSymbol = getParentOfSymbol(type3.symbol);
              var parentName = symbolToTypeNode(parentSymbol, context, 788968);
              if (getDeclaredTypeOfSymbol(parentSymbol) === type3) {
                return parentName;
              }
              var memberName = ts3.symbolName(type3.symbol);
              if (ts3.isIdentifierText(memberName, 0)) {
                return appendReferenceToType(parentName, ts3.factory.createTypeReferenceNode(memberName, void 0));
              }
              if (ts3.isImportTypeNode(parentName)) {
                parentName.isTypeOf = true;
                return ts3.factory.createIndexedAccessTypeNode(parentName, ts3.factory.createLiteralTypeNode(ts3.factory.createStringLiteral(memberName)));
              } else if (ts3.isTypeReferenceNode(parentName)) {
                return ts3.factory.createIndexedAccessTypeNode(ts3.factory.createTypeQueryNode(parentName.typeName), ts3.factory.createLiteralTypeNode(ts3.factory.createStringLiteral(memberName)));
              } else {
                return ts3.Debug.fail("Unhandled type node kind returned from `symbolToTypeNode`.");
              }
            }
            if (type3.flags & 1056) {
              return symbolToTypeNode(type3.symbol, context, 788968);
            }
            if (type3.flags & 128) {
              context.approximateLength += type3.value.length + 2;
              return ts3.factory.createLiteralTypeNode(ts3.setEmitFlags(ts3.factory.createStringLiteral(type3.value, !!(context.flags & 268435456)), 16777216));
            }
            if (type3.flags & 256) {
              var value = type3.value;
              context.approximateLength += ("" + value).length;
              return ts3.factory.createLiteralTypeNode(value < 0 ? ts3.factory.createPrefixUnaryExpression(40, ts3.factory.createNumericLiteral(-value)) : ts3.factory.createNumericLiteral(value));
            }
            if (type3.flags & 2048) {
              context.approximateLength += ts3.pseudoBigIntToString(type3.value).length + 1;
              return ts3.factory.createLiteralTypeNode(ts3.factory.createBigIntLiteral(type3.value));
            }
            if (type3.flags & 512) {
              context.approximateLength += type3.intrinsicName.length;
              return ts3.factory.createLiteralTypeNode(type3.intrinsicName === "true" ? ts3.factory.createTrue() : ts3.factory.createFalse());
            }
            if (type3.flags & 8192) {
              if (!(context.flags & 1048576)) {
                if (isValueSymbolAccessible(type3.symbol, context.enclosingDeclaration)) {
                  context.approximateLength += 6;
                  return symbolToTypeNode(type3.symbol, context, 111551);
                }
                if (context.tracker.reportInaccessibleUniqueSymbolError) {
                  context.tracker.reportInaccessibleUniqueSymbolError();
                }
              }
              context.approximateLength += 13;
              return ts3.factory.createTypeOperatorNode(151, ts3.factory.createKeywordTypeNode(148));
            }
            if (type3.flags & 16384) {
              context.approximateLength += 4;
              return ts3.factory.createKeywordTypeNode(113);
            }
            if (type3.flags & 32768) {
              context.approximateLength += 9;
              return ts3.factory.createKeywordTypeNode(150);
            }
            if (type3.flags & 65536) {
              context.approximateLength += 4;
              return ts3.factory.createLiteralTypeNode(ts3.factory.createNull());
            }
            if (type3.flags & 131072) {
              context.approximateLength += 5;
              return ts3.factory.createKeywordTypeNode(141);
            }
            if (type3.flags & 4096) {
              context.approximateLength += 6;
              return ts3.factory.createKeywordTypeNode(148);
            }
            if (type3.flags & 67108864) {
              context.approximateLength += 6;
              return ts3.factory.createKeywordTypeNode(145);
            }
            if (isThisTypeParameter(type3)) {
              if (context.flags & 4194304) {
                if (!context.encounteredError && !(context.flags & 32768)) {
                  context.encounteredError = true;
                }
                if (context.tracker.reportInaccessibleThisError) {
                  context.tracker.reportInaccessibleThisError();
                }
              }
              context.approximateLength += 4;
              return ts3.factory.createThisTypeNode();
            }
            if (!inTypeAlias && type3.aliasSymbol && (context.flags & 16384 || isTypeSymbolAccessible(type3.aliasSymbol, context.enclosingDeclaration))) {
              var typeArgumentNodes = mapToTypeNodes(type3.aliasTypeArguments, context);
              if (isReservedMemberName(type3.aliasSymbol.escapedName) && !(type3.aliasSymbol.flags & 32))
                return ts3.factory.createTypeReferenceNode(ts3.factory.createIdentifier(""), typeArgumentNodes);
              return symbolToTypeNode(type3.aliasSymbol, context, 788968, typeArgumentNodes);
            }
            var objectFlags = ts3.getObjectFlags(type3);
            if (objectFlags & 4) {
              ts3.Debug.assert(!!(type3.flags & 524288));
              return type3.node ? visitAndTransformType(type3, typeReferenceToTypeNode) : typeReferenceToTypeNode(type3);
            }
            if (type3.flags & 262144 || objectFlags & 3) {
              if (type3.flags & 262144 && ts3.contains(context.inferTypeParameters, type3)) {
                context.approximateLength += ts3.symbolName(type3.symbol).length + 6;
                return ts3.factory.createInferTypeNode(typeParameterToDeclarationWithConstraint(type3, context, void 0));
              }
              if (context.flags & 4 && type3.flags & 262144 && !isTypeSymbolAccessible(type3.symbol, context.enclosingDeclaration)) {
                var name = typeParameterToName(type3, context);
                context.approximateLength += ts3.idText(name).length;
                return ts3.factory.createTypeReferenceNode(ts3.factory.createIdentifier(ts3.idText(name)), void 0);
              }
              return type3.symbol ? symbolToTypeNode(type3.symbol, context, 788968) : ts3.factory.createTypeReferenceNode(ts3.factory.createIdentifier("?"), void 0);
            }
            if (type3.flags & 1048576 && type3.origin) {
              type3 = type3.origin;
            }
            if (type3.flags & (1048576 | 2097152)) {
              var types2 = type3.flags & 1048576 ? formatUnionTypes(type3.types) : type3.types;
              if (ts3.length(types2) === 1) {
                return typeToTypeNodeHelper(types2[0], context);
              }
              var typeNodes = mapToTypeNodes(types2, context, true);
              if (typeNodes && typeNodes.length > 0) {
                return type3.flags & 1048576 ? ts3.factory.createUnionTypeNode(typeNodes) : ts3.factory.createIntersectionTypeNode(typeNodes);
              } else {
                if (!context.encounteredError && !(context.flags & 262144)) {
                  context.encounteredError = true;
                }
                return void 0;
              }
            }
            if (objectFlags & (16 | 32)) {
              ts3.Debug.assert(!!(type3.flags & 524288));
              return createAnonymousTypeNode(type3);
            }
            if (type3.flags & 4194304) {
              var indexedType = type3.type;
              context.approximateLength += 6;
              var indexTypeNode = typeToTypeNodeHelper(indexedType, context);
              return ts3.factory.createTypeOperatorNode(138, indexTypeNode);
            }
            if (type3.flags & 134217728) {
              var texts_1 = type3.texts;
              var types_1 = type3.types;
              var templateHead = ts3.factory.createTemplateHead(texts_1[0]);
              var templateSpans = ts3.factory.createNodeArray(ts3.map(types_1, function(t2, i3) {
                return ts3.factory.createTemplateLiteralTypeSpan(typeToTypeNodeHelper(t2, context), (i3 < types_1.length - 1 ? ts3.factory.createTemplateMiddle : ts3.factory.createTemplateTail)(texts_1[i3 + 1]));
              }));
              context.approximateLength += 2;
              return ts3.factory.createTemplateLiteralType(templateHead, templateSpans);
            }
            if (type3.flags & 268435456) {
              var typeNode = typeToTypeNodeHelper(type3.type, context);
              return symbolToTypeNode(type3.symbol, context, 788968, [typeNode]);
            }
            if (type3.flags & 8388608) {
              var objectTypeNode = typeToTypeNodeHelper(type3.objectType, context);
              var indexTypeNode = typeToTypeNodeHelper(type3.indexType, context);
              context.approximateLength += 2;
              return ts3.factory.createIndexedAccessTypeNode(objectTypeNode, indexTypeNode);
            }
            if (type3.flags & 16777216) {
              var checkTypeNode = typeToTypeNodeHelper(type3.checkType, context);
              var saveInferTypeParameters = context.inferTypeParameters;
              context.inferTypeParameters = type3.root.inferTypeParameters;
              var extendsTypeNode = typeToTypeNodeHelper(type3.extendsType, context);
              context.inferTypeParameters = saveInferTypeParameters;
              var trueTypeNode = typeToTypeNodeOrCircularityElision(getTrueTypeFromConditionalType(type3));
              var falseTypeNode = typeToTypeNodeOrCircularityElision(getFalseTypeFromConditionalType(type3));
              context.approximateLength += 15;
              return ts3.factory.createConditionalTypeNode(checkTypeNode, extendsTypeNode, trueTypeNode, falseTypeNode);
            }
            if (type3.flags & 33554432) {
              return typeToTypeNodeHelper(type3.baseType, context);
            }
            return ts3.Debug.fail("Should be unreachable.");
            function typeToTypeNodeOrCircularityElision(type4) {
              var _a2, _b, _c;
              if (type4.flags & 1048576) {
                if ((_a2 = context.visitedTypes) === null || _a2 === void 0 ? void 0 : _a2.has(getTypeId(type4))) {
                  if (!(context.flags & 131072)) {
                    context.encounteredError = true;
                    (_c = (_b = context.tracker) === null || _b === void 0 ? void 0 : _b.reportCyclicStructureError) === null || _c === void 0 ? void 0 : _c.call(_b);
                  }
                  return createElidedInformationPlaceholder(context);
                }
                return visitAndTransformType(type4, function(type5) {
                  return typeToTypeNodeHelper(type5, context);
                });
              }
              return typeToTypeNodeHelper(type4, context);
            }
            function createMappedTypeNodeFromType(type4) {
              ts3.Debug.assert(!!(type4.flags & 524288));
              var readonlyToken = type4.declaration.readonlyToken ? ts3.factory.createToken(type4.declaration.readonlyToken.kind) : void 0;
              var questionToken = type4.declaration.questionToken ? ts3.factory.createToken(type4.declaration.questionToken.kind) : void 0;
              var appropriateConstraintTypeNode;
              if (isMappedTypeWithKeyofConstraintDeclaration(type4)) {
                appropriateConstraintTypeNode = ts3.factory.createTypeOperatorNode(138, typeToTypeNodeHelper(getModifiersTypeFromMappedType(type4), context));
              } else {
                appropriateConstraintTypeNode = typeToTypeNodeHelper(getConstraintTypeFromMappedType(type4), context);
              }
              var typeParameterNode = typeParameterToDeclarationWithConstraint(getTypeParameterFromMappedType(type4), context, appropriateConstraintTypeNode);
              var nameTypeNode = type4.declaration.nameType ? typeToTypeNodeHelper(getNameTypeFromMappedType(type4), context) : void 0;
              var templateTypeNode = typeToTypeNodeHelper(getTemplateTypeFromMappedType(type4), context);
              var mappedTypeNode = ts3.factory.createMappedTypeNode(readonlyToken, typeParameterNode, nameTypeNode, questionToken, templateTypeNode);
              context.approximateLength += 10;
              return ts3.setEmitFlags(mappedTypeNode, 1);
            }
            function createAnonymousTypeNode(type4) {
              var _a2;
              var typeId = type4.id;
              var symbol = type4.symbol;
              if (symbol) {
                var isInstanceType = isClassInstanceSide(type4) ? 788968 : 111551;
                if (isJSConstructor(symbol.valueDeclaration)) {
                  return symbolToTypeNode(symbol, context, isInstanceType);
                } else if (symbol.flags & 32 && !getBaseTypeVariableOfClass(symbol) && !(symbol.valueDeclaration && symbol.valueDeclaration.kind === 222 && context.flags & 2048) || symbol.flags & (384 | 512) || shouldWriteTypeOfFunctionSymbol()) {
                  return symbolToTypeNode(symbol, context, isInstanceType);
                } else if ((_a2 = context.visitedTypes) === null || _a2 === void 0 ? void 0 : _a2.has(typeId)) {
                  var typeAlias = getTypeAliasForTypeLiteral(type4);
                  if (typeAlias) {
                    return symbolToTypeNode(typeAlias, context, 788968);
                  } else {
                    return createElidedInformationPlaceholder(context);
                  }
                } else {
                  return visitAndTransformType(type4, createTypeNodeFromObjectType);
                }
              } else {
                return createTypeNodeFromObjectType(type4);
              }
              function shouldWriteTypeOfFunctionSymbol() {
                var _a3;
                var isStaticMethodSymbol = !!(symbol.flags & 8192) && ts3.some(symbol.declarations, function(declaration) {
                  return ts3.hasSyntacticModifier(declaration, 32);
                });
                var isNonLocalFunctionSymbol = !!(symbol.flags & 16) && (symbol.parent || ts3.forEach(symbol.declarations, function(declaration) {
                  return declaration.parent.kind === 298 || declaration.parent.kind === 258;
                }));
                if (isStaticMethodSymbol || isNonLocalFunctionSymbol) {
                  return (!!(context.flags & 4096) || ((_a3 = context.visitedTypes) === null || _a3 === void 0 ? void 0 : _a3.has(typeId))) && (!(context.flags & 8) || isValueSymbolAccessible(symbol, context.enclosingDeclaration));
                }
              }
            }
            function visitAndTransformType(type4, transform) {
              var typeId = type4.id;
              var isConstructorObject = ts3.getObjectFlags(type4) & 16 && type4.symbol && type4.symbol.flags & 32;
              var id = ts3.getObjectFlags(type4) & 4 && type4.node ? "N" + getNodeId(type4.node) : type4.symbol ? (isConstructorObject ? "+" : "") + getSymbolId(type4.symbol) : void 0;
              if (!context.visitedTypes) {
                context.visitedTypes = new ts3.Set();
              }
              if (id && !context.symbolDepth) {
                context.symbolDepth = new ts3.Map();
              }
              var depth;
              if (id) {
                depth = context.symbolDepth.get(id) || 0;
                if (depth > 10) {
                  return createElidedInformationPlaceholder(context);
                }
                context.symbolDepth.set(id, depth + 1);
              }
              context.visitedTypes.add(typeId);
              var result2 = transform(type4);
              context.visitedTypes.delete(typeId);
              if (id) {
                context.symbolDepth.set(id, depth);
              }
              return result2;
            }
            function createTypeNodeFromObjectType(type4) {
              if (isGenericMappedType(type4) || type4.containsError) {
                return createMappedTypeNodeFromType(type4);
              }
              var resolved = resolveStructuredTypeMembers(type4);
              if (!resolved.properties.length && !resolved.stringIndexInfo && !resolved.numberIndexInfo) {
                if (!resolved.callSignatures.length && !resolved.constructSignatures.length) {
                  context.approximateLength += 2;
                  return ts3.setEmitFlags(ts3.factory.createTypeLiteralNode(void 0), 1);
                }
                if (resolved.callSignatures.length === 1 && !resolved.constructSignatures.length) {
                  var signature = resolved.callSignatures[0];
                  var signatureNode = signatureToSignatureDeclarationHelper(signature, 175, context);
                  return signatureNode;
                }
                if (resolved.constructSignatures.length === 1 && !resolved.callSignatures.length) {
                  var signature = resolved.constructSignatures[0];
                  var signatureNode = signatureToSignatureDeclarationHelper(signature, 176, context);
                  return signatureNode;
                }
              }
              var abstractSignatures = ts3.filter(resolved.constructSignatures, function(signature2) {
                return !!(signature2.flags & 4);
              });
              if (ts3.some(abstractSignatures)) {
                var types3 = ts3.map(abstractSignatures, getOrCreateTypeFromSignature);
                var typeElementCount = resolved.callSignatures.length + (resolved.constructSignatures.length - abstractSignatures.length) + (resolved.stringIndexInfo ? 1 : 0) + (resolved.numberIndexInfo ? 1 : 0) + (context.flags & 2048 ? ts3.countWhere(resolved.properties, function(p) {
                  return !(p.flags & 4194304);
                }) : ts3.length(resolved.properties));
                if (typeElementCount) {
                  types3.push(getResolvedTypeWithoutAbstractConstructSignatures(resolved));
                }
                return typeToTypeNodeHelper(getIntersectionType(types3), context);
              }
              var savedFlags = context.flags;
              context.flags |= 4194304;
              var members = createTypeNodesFromResolvedType(resolved);
              context.flags = savedFlags;
              var typeLiteralNode = ts3.factory.createTypeLiteralNode(members);
              context.approximateLength += 2;
              ts3.setEmitFlags(typeLiteralNode, context.flags & 1024 ? 0 : 1);
              return typeLiteralNode;
            }
            function typeReferenceToTypeNode(type4) {
              var typeArguments = getTypeArguments(type4);
              if (type4.target === globalArrayType || type4.target === globalReadonlyArrayType) {
                if (context.flags & 2) {
                  var typeArgumentNode = typeToTypeNodeHelper(typeArguments[0], context);
                  return ts3.factory.createTypeReferenceNode(type4.target === globalArrayType ? "Array" : "ReadonlyArray", [typeArgumentNode]);
                }
                var elementType = typeToTypeNodeHelper(typeArguments[0], context);
                var arrayType = ts3.factory.createArrayTypeNode(elementType);
                return type4.target === globalArrayType ? arrayType : ts3.factory.createTypeOperatorNode(142, arrayType);
              } else if (type4.target.objectFlags & 8) {
                if (typeArguments.length > 0) {
                  var arity = getTypeReferenceArity(type4);
                  var tupleConstituentNodes = mapToTypeNodes(typeArguments.slice(0, arity), context);
                  if (tupleConstituentNodes) {
                    if (type4.target.labeledElementDeclarations) {
                      for (var i3 = 0; i3 < tupleConstituentNodes.length; i3++) {
                        var flags = type4.target.elementFlags[i3];
                        tupleConstituentNodes[i3] = ts3.factory.createNamedTupleMember(flags & 12 ? ts3.factory.createToken(25) : void 0, ts3.factory.createIdentifier(ts3.unescapeLeadingUnderscores(getTupleElementLabel(type4.target.labeledElementDeclarations[i3]))), flags & 2 ? ts3.factory.createToken(57) : void 0, flags & 4 ? ts3.factory.createArrayTypeNode(tupleConstituentNodes[i3]) : tupleConstituentNodes[i3]);
                      }
                    } else {
                      for (var i3 = 0; i3 < Math.min(arity, tupleConstituentNodes.length); i3++) {
                        var flags = type4.target.elementFlags[i3];
                        tupleConstituentNodes[i3] = flags & 12 ? ts3.factory.createRestTypeNode(flags & 4 ? ts3.factory.createArrayTypeNode(tupleConstituentNodes[i3]) : tupleConstituentNodes[i3]) : flags & 2 ? ts3.factory.createOptionalTypeNode(tupleConstituentNodes[i3]) : tupleConstituentNodes[i3];
                      }
                    }
                    var tupleTypeNode = ts3.setEmitFlags(ts3.factory.createTupleTypeNode(tupleConstituentNodes), 1);
                    return type4.target.readonly ? ts3.factory.createTypeOperatorNode(142, tupleTypeNode) : tupleTypeNode;
                  }
                }
                if (context.encounteredError || context.flags & 524288) {
                  var tupleTypeNode = ts3.setEmitFlags(ts3.factory.createTupleTypeNode([]), 1);
                  return type4.target.readonly ? ts3.factory.createTypeOperatorNode(142, tupleTypeNode) : tupleTypeNode;
                }
                context.encounteredError = true;
                return void 0;
              } else if (context.flags & 2048 && type4.symbol.valueDeclaration && ts3.isClassLike(type4.symbol.valueDeclaration) && !isValueSymbolAccessible(type4.symbol, context.enclosingDeclaration)) {
                return createAnonymousTypeNode(type4);
              } else {
                var outerTypeParameters = type4.target.outerTypeParameters;
                var i3 = 0;
                var resultType = void 0;
                if (outerTypeParameters) {
                  var length_2 = outerTypeParameters.length;
                  while (i3 < length_2) {
                    var start = i3;
                    var parent = getParentSymbolOfTypeParameter(outerTypeParameters[i3]);
                    do {
                      i3++;
                    } while (i3 < length_2 && getParentSymbolOfTypeParameter(outerTypeParameters[i3]) === parent);
                    if (!ts3.rangeEquals(outerTypeParameters, typeArguments, start, i3)) {
                      var typeArgumentSlice = mapToTypeNodes(typeArguments.slice(start, i3), context);
                      var flags_3 = context.flags;
                      context.flags |= 16;
                      var ref2 = symbolToTypeNode(parent, context, 788968, typeArgumentSlice);
                      context.flags = flags_3;
                      resultType = !resultType ? ref2 : appendReferenceToType(resultType, ref2);
                    }
                  }
                }
                var typeArgumentNodes2 = void 0;
                if (typeArguments.length > 0) {
                  var typeParameterCount = (type4.target.typeParameters || ts3.emptyArray).length;
                  typeArgumentNodes2 = mapToTypeNodes(typeArguments.slice(i3, typeParameterCount), context);
                }
                var flags = context.flags;
                context.flags |= 16;
                var finalRef = symbolToTypeNode(type4.symbol, context, 788968, typeArgumentNodes2);
                context.flags = flags;
                return !resultType ? finalRef : appendReferenceToType(resultType, finalRef);
              }
            }
            function appendReferenceToType(root, ref2) {
              if (ts3.isImportTypeNode(root)) {
                var typeArguments = root.typeArguments;
                var qualifier = root.qualifier;
                if (qualifier) {
                  if (ts3.isIdentifier(qualifier)) {
                    qualifier = ts3.factory.updateIdentifier(qualifier, typeArguments);
                  } else {
                    qualifier = ts3.factory.updateQualifiedName(qualifier, qualifier.left, ts3.factory.updateIdentifier(qualifier.right, typeArguments));
                  }
                }
                typeArguments = ref2.typeArguments;
                var ids = getAccessStack(ref2);
                for (var _i = 0, ids_1 = ids; _i < ids_1.length; _i++) {
                  var id = ids_1[_i];
                  qualifier = qualifier ? ts3.factory.createQualifiedName(qualifier, id) : id;
                }
                return ts3.factory.updateImportTypeNode(root, root.argument, qualifier, typeArguments, root.isTypeOf);
              } else {
                var typeArguments = root.typeArguments;
                var typeName = root.typeName;
                if (ts3.isIdentifier(typeName)) {
                  typeName = ts3.factory.updateIdentifier(typeName, typeArguments);
                } else {
                  typeName = ts3.factory.updateQualifiedName(typeName, typeName.left, ts3.factory.updateIdentifier(typeName.right, typeArguments));
                }
                typeArguments = ref2.typeArguments;
                var ids = getAccessStack(ref2);
                for (var _a2 = 0, ids_2 = ids; _a2 < ids_2.length; _a2++) {
                  var id = ids_2[_a2];
                  typeName = ts3.factory.createQualifiedName(typeName, id);
                }
                return ts3.factory.updateTypeReferenceNode(root, typeName, typeArguments);
              }
            }
            function getAccessStack(ref2) {
              var state = ref2.typeName;
              var ids = [];
              while (!ts3.isIdentifier(state)) {
                ids.unshift(state.right);
                state = state.left;
              }
              ids.unshift(state);
              return ids;
            }
            function createTypeNodesFromResolvedType(resolvedType) {
              if (checkTruncationLength(context)) {
                return [ts3.factory.createPropertySignature(void 0, "...", void 0, void 0)];
              }
              var typeElements = [];
              for (var _i = 0, _a2 = resolvedType.callSignatures; _i < _a2.length; _i++) {
                var signature = _a2[_i];
                typeElements.push(signatureToSignatureDeclarationHelper(signature, 170, context));
              }
              for (var _b = 0, _c = resolvedType.constructSignatures; _b < _c.length; _b++) {
                var signature = _c[_b];
                if (signature.flags & 4)
                  continue;
                typeElements.push(signatureToSignatureDeclarationHelper(signature, 171, context));
              }
              if (resolvedType.stringIndexInfo) {
                var indexSignature = void 0;
                if (resolvedType.objectFlags & 1024) {
                  indexSignature = indexInfoToIndexSignatureDeclarationHelper(createIndexInfo(anyType, resolvedType.stringIndexInfo.isReadonly, resolvedType.stringIndexInfo.declaration), 0, context, createElidedInformationPlaceholder(context));
                } else {
                  indexSignature = indexInfoToIndexSignatureDeclarationHelper(resolvedType.stringIndexInfo, 0, context, void 0);
                }
                typeElements.push(indexSignature);
              }
              if (resolvedType.numberIndexInfo) {
                typeElements.push(indexInfoToIndexSignatureDeclarationHelper(resolvedType.numberIndexInfo, 1, context, void 0));
              }
              var properties = resolvedType.properties;
              if (!properties) {
                return typeElements;
              }
              var i3 = 0;
              for (var _d = 0, properties_1 = properties; _d < properties_1.length; _d++) {
                var propertySymbol = properties_1[_d];
                i3++;
                if (context.flags & 2048) {
                  if (propertySymbol.flags & 4194304) {
                    continue;
                  }
                  if (ts3.getDeclarationModifierFlagsFromSymbol(propertySymbol) & (8 | 16) && context.tracker.reportPrivateInBaseOfClassExpression) {
                    context.tracker.reportPrivateInBaseOfClassExpression(ts3.unescapeLeadingUnderscores(propertySymbol.escapedName));
                  }
                }
                if (checkTruncationLength(context) && i3 + 2 < properties.length - 1) {
                  typeElements.push(ts3.factory.createPropertySignature(void 0, "... " + (properties.length - i3) + " more ...", void 0, void 0));
                  addPropertyToElementList(properties[properties.length - 1], context, typeElements);
                  break;
                }
                addPropertyToElementList(propertySymbol, context, typeElements);
              }
              return typeElements.length ? typeElements : void 0;
            }
          }
          function createElidedInformationPlaceholder(context) {
            context.approximateLength += 3;
            if (!(context.flags & 1)) {
              return ts3.factory.createTypeReferenceNode(ts3.factory.createIdentifier("..."), void 0);
            }
            return ts3.factory.createKeywordTypeNode(128);
          }
          function shouldUsePlaceholderForProperty(propertySymbol, context) {
            var _a2;
            return !!(ts3.getCheckFlags(propertySymbol) & 8192) && (ts3.contains(context.reverseMappedStack, propertySymbol) || ((_a2 = context.reverseMappedStack) === null || _a2 === void 0 ? void 0 : _a2[0]) && !(ts3.getObjectFlags(ts3.last(context.reverseMappedStack).propertyType) & 16));
          }
          function addPropertyToElementList(propertySymbol, context, typeElements) {
            var _a2;
            var propertyIsReverseMapped = !!(ts3.getCheckFlags(propertySymbol) & 8192);
            var propertyType = shouldUsePlaceholderForProperty(propertySymbol, context) ? anyType : getTypeOfSymbol(propertySymbol);
            var saveEnclosingDeclaration = context.enclosingDeclaration;
            context.enclosingDeclaration = void 0;
            if (context.tracker.trackSymbol && ts3.getCheckFlags(propertySymbol) & 4096 && isLateBoundName(propertySymbol.escapedName)) {
              var decl = ts3.first(propertySymbol.declarations);
              if (propertySymbol.declarations && hasLateBindableName(decl)) {
                if (ts3.isBinaryExpression(decl)) {
                  var name = ts3.getNameOfDeclaration(decl);
                  if (name && ts3.isElementAccessExpression(name) && ts3.isPropertyAccessEntityNameExpression(name.argumentExpression)) {
                    trackComputedName(name.argumentExpression, saveEnclosingDeclaration, context);
                  }
                } else {
                  trackComputedName(decl.name.expression, saveEnclosingDeclaration, context);
                }
              }
            }
            context.enclosingDeclaration = propertySymbol.valueDeclaration || ((_a2 = propertySymbol.declarations) === null || _a2 === void 0 ? void 0 : _a2[0]) || saveEnclosingDeclaration;
            var propertyName = getPropertyNameNodeForSymbol(propertySymbol, context);
            context.enclosingDeclaration = saveEnclosingDeclaration;
            context.approximateLength += ts3.symbolName(propertySymbol).length + 1;
            var optionalToken = propertySymbol.flags & 16777216 ? ts3.factory.createToken(57) : void 0;
            if (propertySymbol.flags & (16 | 8192) && !getPropertiesOfObjectType(propertyType).length && !isReadonlySymbol(propertySymbol)) {
              var signatures = getSignaturesOfType(filterType(propertyType, function(t2) {
                return !(t2.flags & 32768);
              }), 0);
              for (var _i = 0, signatures_1 = signatures; _i < signatures_1.length; _i++) {
                var signature = signatures_1[_i];
                var methodDeclaration = signatureToSignatureDeclarationHelper(signature, 165, context, { name: propertyName, questionToken: optionalToken });
                typeElements.push(preserveCommentsOn(methodDeclaration));
              }
            } else {
              var propertyTypeNode = void 0;
              if (shouldUsePlaceholderForProperty(propertySymbol, context)) {
                propertyTypeNode = createElidedInformationPlaceholder(context);
              } else {
                if (propertyIsReverseMapped) {
                  context.reverseMappedStack || (context.reverseMappedStack = []);
                  context.reverseMappedStack.push(propertySymbol);
                }
                propertyTypeNode = propertyType ? serializeTypeForDeclaration(context, propertyType, propertySymbol, saveEnclosingDeclaration) : ts3.factory.createKeywordTypeNode(128);
                if (propertyIsReverseMapped) {
                  context.reverseMappedStack.pop();
                }
              }
              var modifiers = isReadonlySymbol(propertySymbol) ? [ts3.factory.createToken(142)] : void 0;
              if (modifiers) {
                context.approximateLength += 9;
              }
              var propertySignature = ts3.factory.createPropertySignature(modifiers, propertyName, optionalToken, propertyTypeNode);
              typeElements.push(preserveCommentsOn(propertySignature));
            }
            function preserveCommentsOn(node) {
              var _a3;
              if (ts3.some(propertySymbol.declarations, function(d2) {
                return d2.kind === 337;
              })) {
                var d = (_a3 = propertySymbol.declarations) === null || _a3 === void 0 ? void 0 : _a3.find(function(d2) {
                  return d2.kind === 337;
                });
                var commentText = ts3.getTextOfJSDocComment(d.comment);
                if (commentText) {
                  ts3.setSyntheticLeadingComments(node, [{ kind: 3, text: "*\n * " + commentText.replace(/\n/g, "\n * ") + "\n ", pos: -1, end: -1, hasTrailingNewLine: true }]);
                }
              } else if (propertySymbol.valueDeclaration) {
                ts3.setCommentRange(node, propertySymbol.valueDeclaration);
              }
              return node;
            }
          }
          function mapToTypeNodes(types2, context, isBareList) {
            if (ts3.some(types2)) {
              if (checkTruncationLength(context)) {
                if (!isBareList) {
                  return [ts3.factory.createTypeReferenceNode("...", void 0)];
                } else if (types2.length > 2) {
                  return [
                    typeToTypeNodeHelper(types2[0], context),
                    ts3.factory.createTypeReferenceNode("... " + (types2.length - 2) + " more ...", void 0),
                    typeToTypeNodeHelper(types2[types2.length - 1], context)
                  ];
                }
              }
              var mayHaveNameCollisions = !(context.flags & 64);
              var seenNames = mayHaveNameCollisions ? ts3.createUnderscoreEscapedMultiMap() : void 0;
              var result_5 = [];
              var i3 = 0;
              for (var _i = 0, types_2 = types2; _i < types_2.length; _i++) {
                var type3 = types_2[_i];
                i3++;
                if (checkTruncationLength(context) && i3 + 2 < types2.length - 1) {
                  result_5.push(ts3.factory.createTypeReferenceNode("... " + (types2.length - i3) + " more ...", void 0));
                  var typeNode_1 = typeToTypeNodeHelper(types2[types2.length - 1], context);
                  if (typeNode_1) {
                    result_5.push(typeNode_1);
                  }
                  break;
                }
                context.approximateLength += 2;
                var typeNode = typeToTypeNodeHelper(type3, context);
                if (typeNode) {
                  result_5.push(typeNode);
                  if (seenNames && ts3.isIdentifierTypeReference(typeNode)) {
                    seenNames.add(typeNode.typeName.escapedText, [type3, result_5.length - 1]);
                  }
                }
              }
              if (seenNames) {
                var saveContextFlags = context.flags;
                context.flags |= 64;
                seenNames.forEach(function(types3) {
                  if (!ts3.arrayIsHomogeneous(types3, function(_a3, _b) {
                    var a2 = _a3[0];
                    var b2 = _b[0];
                    return typesAreSameReference(a2, b2);
                  })) {
                    for (var _i2 = 0, types_3 = types3; _i2 < types_3.length; _i2++) {
                      var _a2 = types_3[_i2], type4 = _a2[0], resultIndex = _a2[1];
                      result_5[resultIndex] = typeToTypeNodeHelper(type4, context);
                    }
                  }
                });
                context.flags = saveContextFlags;
              }
              return result_5;
            }
          }
          function typesAreSameReference(a2, b2) {
            return a2 === b2 || !!a2.symbol && a2.symbol === b2.symbol || !!a2.aliasSymbol && a2.aliasSymbol === b2.aliasSymbol;
          }
          function indexInfoToIndexSignatureDeclarationHelper(indexInfo, kind, context, typeNode) {
            var name = ts3.getNameFromIndexInfo(indexInfo) || "x";
            var indexerTypeNode = ts3.factory.createKeywordTypeNode(kind === 0 ? 147 : 144);
            var indexingParameter = ts3.factory.createParameterDeclaration(void 0, void 0, void 0, name, void 0, indexerTypeNode, void 0);
            if (!typeNode) {
              typeNode = typeToTypeNodeHelper(indexInfo.type || anyType, context);
            }
            if (!indexInfo.type && !(context.flags & 2097152)) {
              context.encounteredError = true;
            }
            context.approximateLength += name.length + 4;
            return ts3.factory.createIndexSignature(void 0, indexInfo.isReadonly ? [ts3.factory.createToken(142)] : void 0, [indexingParameter], typeNode);
          }
          function signatureToSignatureDeclarationHelper(signature, kind, context, options) {
            var _a2, _b, _c, _d;
            var suppressAny = context.flags & 256;
            if (suppressAny)
              context.flags &= ~256;
            var typeParameters;
            var typeArguments;
            if (context.flags & 32 && signature.target && signature.mapper && signature.target.typeParameters) {
              typeArguments = signature.target.typeParameters.map(function(parameter) {
                return typeToTypeNodeHelper(instantiateType(parameter, signature.mapper), context);
              });
            } else {
              typeParameters = signature.typeParameters && signature.typeParameters.map(function(parameter) {
                return typeParameterToDeclaration(parameter, context);
              });
            }
            var expandedParams = getExpandedParameters(signature, true)[0];
            var parameters = (ts3.some(expandedParams, function(p) {
              return p !== expandedParams[expandedParams.length - 1] && !!(ts3.getCheckFlags(p) & 32768);
            }) ? signature.parameters : expandedParams).map(function(parameter) {
              return symbolToParameterDeclaration(parameter, context, kind === 167, options === null || options === void 0 ? void 0 : options.privateSymbolVisitor, options === null || options === void 0 ? void 0 : options.bundledImports);
            });
            if (signature.thisParameter) {
              var thisParameter = symbolToParameterDeclaration(signature.thisParameter, context);
              parameters.unshift(thisParameter);
            }
            var returnTypeNode;
            var typePredicate = getTypePredicateOfSignature(signature);
            if (typePredicate) {
              var assertsModifier = typePredicate.kind === 2 || typePredicate.kind === 3 ? ts3.factory.createToken(127) : void 0;
              var parameterName = typePredicate.kind === 1 || typePredicate.kind === 3 ? ts3.setEmitFlags(ts3.factory.createIdentifier(typePredicate.parameterName), 16777216) : ts3.factory.createThisTypeNode();
              var typeNode = typePredicate.type && typeToTypeNodeHelper(typePredicate.type, context);
              returnTypeNode = ts3.factory.createTypePredicateNode(assertsModifier, parameterName, typeNode);
            } else {
              var returnType2 = getReturnTypeOfSignature(signature);
              if (returnType2 && !(suppressAny && isTypeAny(returnType2))) {
                returnTypeNode = serializeReturnTypeForSignature(context, returnType2, signature, options === null || options === void 0 ? void 0 : options.privateSymbolVisitor, options === null || options === void 0 ? void 0 : options.bundledImports);
              } else if (!suppressAny) {
                returnTypeNode = ts3.factory.createKeywordTypeNode(128);
              }
            }
            var modifiers = options === null || options === void 0 ? void 0 : options.modifiers;
            if (kind === 176 && signature.flags & 4) {
              var flags = ts3.modifiersToFlags(modifiers);
              modifiers = ts3.factory.createModifiersFromModifierFlags(flags | 128);
            }
            context.approximateLength += 3;
            var node = kind === 170 ? ts3.factory.createCallSignature(typeParameters, parameters, returnTypeNode) : kind === 171 ? ts3.factory.createConstructSignature(typeParameters, parameters, returnTypeNode) : kind === 165 ? ts3.factory.createMethodSignature(modifiers, (_a2 = options === null || options === void 0 ? void 0 : options.name) !== null && _a2 !== void 0 ? _a2 : ts3.factory.createIdentifier(""), options === null || options === void 0 ? void 0 : options.questionToken, typeParameters, parameters, returnTypeNode) : kind === 166 ? ts3.factory.createMethodDeclaration(void 0, modifiers, void 0, (_b = options === null || options === void 0 ? void 0 : options.name) !== null && _b !== void 0 ? _b : ts3.factory.createIdentifier(""), void 0, typeParameters, parameters, returnTypeNode, void 0) : kind === 167 ? ts3.factory.createConstructorDeclaration(void 0, modifiers, parameters, void 0) : kind === 168 ? ts3.factory.createGetAccessorDeclaration(void 0, modifiers, (_c = options === null || options === void 0 ? void 0 : options.name) !== null && _c !== void 0 ? _c : ts3.factory.createIdentifier(""), parameters, returnTypeNode, void 0) : kind === 169 ? ts3.factory.createSetAccessorDeclaration(void 0, modifiers, (_d = options === null || options === void 0 ? void 0 : options.name) !== null && _d !== void 0 ? _d : ts3.factory.createIdentifier(""), parameters, void 0) : kind === 172 ? ts3.factory.createIndexSignature(void 0, modifiers, parameters, returnTypeNode) : kind === 309 ? ts3.factory.createJSDocFunctionType(parameters, returnTypeNode) : kind === 175 ? ts3.factory.createFunctionTypeNode(typeParameters, parameters, returnTypeNode !== null && returnTypeNode !== void 0 ? returnTypeNode : ts3.factory.createTypeReferenceNode(ts3.factory.createIdentifier(""))) : kind === 176 ? ts3.factory.createConstructorTypeNode(modifiers, typeParameters, parameters, returnTypeNode !== null && returnTypeNode !== void 0 ? returnTypeNode : ts3.factory.createTypeReferenceNode(ts3.factory.createIdentifier(""))) : kind === 252 ? ts3.factory.createFunctionDeclaration(void 0, modifiers, void 0, (options === null || options === void 0 ? void 0 : options.name) ? ts3.cast(options.name, ts3.isIdentifier) : ts3.factory.createIdentifier(""), typeParameters, parameters, returnTypeNode, void 0) : kind === 209 ? ts3.factory.createFunctionExpression(modifiers, void 0, (options === null || options === void 0 ? void 0 : options.name) ? ts3.cast(options.name, ts3.isIdentifier) : ts3.factory.createIdentifier(""), typeParameters, parameters, returnTypeNode, ts3.factory.createBlock([])) : kind === 210 ? ts3.factory.createArrowFunction(modifiers, typeParameters, parameters, returnTypeNode, void 0, ts3.factory.createBlock([])) : ts3.Debug.assertNever(kind);
            if (typeArguments) {
              node.typeArguments = ts3.factory.createNodeArray(typeArguments);
            }
            return node;
          }
          function typeParameterToDeclarationWithConstraint(type3, context, constraintNode) {
            var savedContextFlags = context.flags;
            context.flags &= ~512;
            var name = typeParameterToName(type3, context);
            var defaultParameter = getDefaultFromTypeParameter(type3);
            var defaultParameterNode = defaultParameter && typeToTypeNodeHelper(defaultParameter, context);
            context.flags = savedContextFlags;
            return ts3.factory.createTypeParameterDeclaration(name, constraintNode, defaultParameterNode);
          }
          function typeParameterToDeclaration(type3, context, constraint) {
            if (constraint === void 0) {
              constraint = getConstraintOfTypeParameter(type3);
            }
            var constraintNode = constraint && typeToTypeNodeHelper(constraint, context);
            return typeParameterToDeclarationWithConstraint(type3, context, constraintNode);
          }
          function symbolToParameterDeclaration(parameterSymbol, context, preserveModifierFlags, privateSymbolVisitor, bundledImports) {
            var parameterDeclaration = ts3.getDeclarationOfKind(parameterSymbol, 161);
            if (!parameterDeclaration && !ts3.isTransientSymbol(parameterSymbol)) {
              parameterDeclaration = ts3.getDeclarationOfKind(parameterSymbol, 330);
            }
            var parameterType = getTypeOfSymbol(parameterSymbol);
            if (parameterDeclaration && isRequiredInitializedParameter(parameterDeclaration)) {
              parameterType = getOptionalType(parameterType);
            }
            if (context.flags & 1073741824 && parameterDeclaration && !ts3.isJSDocParameterTag(parameterDeclaration) && isOptionalUninitializedParameter(parameterDeclaration)) {
              parameterType = getTypeWithFacts(parameterType, 524288);
            }
            var parameterTypeNode = serializeTypeForDeclaration(context, parameterType, parameterSymbol, context.enclosingDeclaration, privateSymbolVisitor, bundledImports);
            var modifiers = !(context.flags & 8192) && preserveModifierFlags && parameterDeclaration && parameterDeclaration.modifiers ? parameterDeclaration.modifiers.map(ts3.factory.cloneNode) : void 0;
            var isRest = parameterDeclaration && ts3.isRestParameter(parameterDeclaration) || ts3.getCheckFlags(parameterSymbol) & 32768;
            var dotDotDotToken = isRest ? ts3.factory.createToken(25) : void 0;
            var name = parameterDeclaration ? parameterDeclaration.name ? parameterDeclaration.name.kind === 78 ? ts3.setEmitFlags(ts3.factory.cloneNode(parameterDeclaration.name), 16777216) : parameterDeclaration.name.kind === 158 ? ts3.setEmitFlags(ts3.factory.cloneNode(parameterDeclaration.name.right), 16777216) : cloneBindingName(parameterDeclaration.name) : ts3.symbolName(parameterSymbol) : ts3.symbolName(parameterSymbol);
            var isOptional = parameterDeclaration && isOptionalParameter(parameterDeclaration) || ts3.getCheckFlags(parameterSymbol) & 16384;
            var questionToken = isOptional ? ts3.factory.createToken(57) : void 0;
            var parameterNode = ts3.factory.createParameterDeclaration(void 0, modifiers, dotDotDotToken, name, questionToken, parameterTypeNode, void 0);
            context.approximateLength += ts3.symbolName(parameterSymbol).length + 3;
            return parameterNode;
            function cloneBindingName(node) {
              return elideInitializerAndSetEmitFlags(node);
              function elideInitializerAndSetEmitFlags(node2) {
                if (context.tracker.trackSymbol && ts3.isComputedPropertyName(node2) && isLateBindableName(node2)) {
                  trackComputedName(node2.expression, context.enclosingDeclaration, context);
                }
                var visited = ts3.visitEachChild(node2, elideInitializerAndSetEmitFlags, ts3.nullTransformationContext, void 0, elideInitializerAndSetEmitFlags);
                if (ts3.isBindingElement(visited)) {
                  visited = ts3.factory.updateBindingElement(visited, visited.dotDotDotToken, visited.propertyName, visited.name, void 0);
                }
                if (!ts3.nodeIsSynthesized(visited)) {
                  visited = ts3.factory.cloneNode(visited);
                }
                return ts3.setEmitFlags(visited, 1 | 16777216);
              }
            }
          }
          function trackComputedName(accessExpression, enclosingDeclaration, context) {
            if (!context.tracker.trackSymbol)
              return;
            var firstIdentifier = ts3.getFirstIdentifier(accessExpression);
            var name = resolveName(firstIdentifier, firstIdentifier.escapedText, 111551 | 1048576, void 0, void 0, true);
            if (name) {
              context.tracker.trackSymbol(name, enclosingDeclaration, 111551);
            }
          }
          function lookupSymbolChain(symbol, context, meaning, yieldModuleSymbol) {
            context.tracker.trackSymbol(symbol, context.enclosingDeclaration, meaning);
            return lookupSymbolChainWorker(symbol, context, meaning, yieldModuleSymbol);
          }
          function lookupSymbolChainWorker(symbol, context, meaning, yieldModuleSymbol) {
            var chain;
            var isTypeParameter = symbol.flags & 262144;
            if (!isTypeParameter && (context.enclosingDeclaration || context.flags & 64) && !(context.flags & 134217728)) {
              chain = ts3.Debug.checkDefined(getSymbolChain(symbol, meaning, true));
              ts3.Debug.assert(chain && chain.length > 0);
            } else {
              chain = [symbol];
            }
            return chain;
            function getSymbolChain(symbol2, meaning2, endOfChain) {
              var accessibleSymbolChain = getAccessibleSymbolChain(symbol2, context.enclosingDeclaration, meaning2, !!(context.flags & 128));
              var parentSpecifiers;
              if (!accessibleSymbolChain || needsQualification(accessibleSymbolChain[0], context.enclosingDeclaration, accessibleSymbolChain.length === 1 ? meaning2 : getQualifiedLeftMeaning(meaning2))) {
                var parents_1 = getContainersOfSymbol(accessibleSymbolChain ? accessibleSymbolChain[0] : symbol2, context.enclosingDeclaration, meaning2);
                if (ts3.length(parents_1)) {
                  parentSpecifiers = parents_1.map(function(symbol3) {
                    return ts3.some(symbol3.declarations, hasNonGlobalAugmentationExternalModuleSymbol) ? getSpecifierForModuleSymbol(symbol3, context) : void 0;
                  });
                  var indices = parents_1.map(function(_, i3) {
                    return i3;
                  });
                  indices.sort(sortByBestName);
                  var sortedParents = indices.map(function(i3) {
                    return parents_1[i3];
                  });
                  for (var _i = 0, sortedParents_1 = sortedParents; _i < sortedParents_1.length; _i++) {
                    var parent = sortedParents_1[_i];
                    var parentChain = getSymbolChain(parent, getQualifiedLeftMeaning(meaning2), false);
                    if (parentChain) {
                      if (parent.exports && parent.exports.get("export=") && getSymbolIfSameReference(parent.exports.get("export="), symbol2)) {
                        accessibleSymbolChain = parentChain;
                        break;
                      }
                      accessibleSymbolChain = parentChain.concat(accessibleSymbolChain || [getAliasForSymbolInContainer(parent, symbol2) || symbol2]);
                      break;
                    }
                  }
                }
              }
              if (accessibleSymbolChain) {
                return accessibleSymbolChain;
              }
              if (endOfChain || !(symbol2.flags & (2048 | 4096))) {
                if (!endOfChain && !yieldModuleSymbol && !!ts3.forEach(symbol2.declarations, hasNonGlobalAugmentationExternalModuleSymbol)) {
                  return;
                }
                return [symbol2];
              }
              function sortByBestName(a2, b2) {
                var specifierA = parentSpecifiers[a2];
                var specifierB = parentSpecifiers[b2];
                if (specifierA && specifierB) {
                  var isBRelative = ts3.pathIsRelative(specifierB);
                  if (ts3.pathIsRelative(specifierA) === isBRelative) {
                    return ts3.moduleSpecifiers.countPathComponents(specifierA) - ts3.moduleSpecifiers.countPathComponents(specifierB);
                  }
                  if (isBRelative) {
                    return -1;
                  }
                  return 1;
                }
                return 0;
              }
            }
          }
          function typeParametersToTypeParameterDeclarations(symbol, context) {
            var typeParameterNodes;
            var targetSymbol = getTargetSymbol(symbol);
            if (targetSymbol.flags & (32 | 64 | 524288)) {
              typeParameterNodes = ts3.factory.createNodeArray(ts3.map(getLocalTypeParametersOfClassOrInterfaceOrTypeAlias(symbol), function(tp) {
                return typeParameterToDeclaration(tp, context);
              }));
            }
            return typeParameterNodes;
          }
          function lookupTypeParameterNodes(chain, index, context) {
            var _a2;
            ts3.Debug.assert(chain && 0 <= index && index < chain.length);
            var symbol = chain[index];
            var symbolId = getSymbolId(symbol);
            if ((_a2 = context.typeParameterSymbolList) === null || _a2 === void 0 ? void 0 : _a2.has(symbolId)) {
              return void 0;
            }
            (context.typeParameterSymbolList || (context.typeParameterSymbolList = new ts3.Set())).add(symbolId);
            var typeParameterNodes;
            if (context.flags & 512 && index < chain.length - 1) {
              var parentSymbol = symbol;
              var nextSymbol_1 = chain[index + 1];
              if (ts3.getCheckFlags(nextSymbol_1) & 1) {
                var params = getTypeParametersOfClassOrInterface(parentSymbol.flags & 2097152 ? resolveAlias(parentSymbol) : parentSymbol);
                typeParameterNodes = mapToTypeNodes(ts3.map(params, function(t2) {
                  return getMappedType(t2, nextSymbol_1.mapper);
                }), context);
              } else {
                typeParameterNodes = typeParametersToTypeParameterDeclarations(symbol, context);
              }
            }
            return typeParameterNodes;
          }
          function getTopmostIndexedAccessType(top) {
            if (ts3.isIndexedAccessTypeNode(top.objectType)) {
              return getTopmostIndexedAccessType(top.objectType);
            }
            return top;
          }
          function getSpecifierForModuleSymbol(symbol, context) {
            var _a2;
            var file = ts3.getDeclarationOfKind(symbol, 298);
            if (!file) {
              var equivalentFileSymbol = ts3.firstDefined(symbol.declarations, function(d) {
                return getFileSymbolIfFileSymbolExportEqualsContainer(d, symbol);
              });
              if (equivalentFileSymbol) {
                file = ts3.getDeclarationOfKind(equivalentFileSymbol, 298);
              }
            }
            if (file && file.moduleName !== void 0) {
              return file.moduleName;
            }
            if (!file) {
              if (context.tracker.trackReferencedAmbientModule) {
                var ambientDecls = ts3.filter(symbol.declarations, ts3.isAmbientModule);
                if (ts3.length(ambientDecls)) {
                  for (var _i = 0, _b = ambientDecls; _i < _b.length; _i++) {
                    var decl = _b[_i];
                    context.tracker.trackReferencedAmbientModule(decl, symbol);
                  }
                }
              }
              if (ambientModuleSymbolRegex.test(symbol.escapedName)) {
                return symbol.escapedName.substring(1, symbol.escapedName.length - 1);
              }
            }
            if (!context.enclosingDeclaration || !context.tracker.moduleResolverHost) {
              if (ambientModuleSymbolRegex.test(symbol.escapedName)) {
                return symbol.escapedName.substring(1, symbol.escapedName.length - 1);
              }
              return ts3.getSourceFileOfNode(ts3.getNonAugmentationDeclaration(symbol)).fileName;
            }
            var contextFile = ts3.getSourceFileOfNode(ts3.getOriginalNode(context.enclosingDeclaration));
            var links = getSymbolLinks(symbol);
            var specifier = links.specifierCache && links.specifierCache.get(contextFile.path);
            if (!specifier) {
              var isBundle_1 = !!ts3.outFile(compilerOptions);
              var moduleResolverHost = context.tracker.moduleResolverHost;
              var specifierCompilerOptions = isBundle_1 ? __assign(__assign({}, compilerOptions), { baseUrl: moduleResolverHost.getCommonSourceDirectory() }) : compilerOptions;
              specifier = ts3.first(ts3.moduleSpecifiers.getModuleSpecifiers(symbol, checker, specifierCompilerOptions, contextFile, moduleResolverHost, { importModuleSpecifierPreference: isBundle_1 ? "non-relative" : "project-relative", importModuleSpecifierEnding: isBundle_1 ? "minimal" : void 0 }));
              (_a2 = links.specifierCache) !== null && _a2 !== void 0 ? _a2 : links.specifierCache = new ts3.Map();
              links.specifierCache.set(contextFile.path, specifier);
            }
            return specifier;
          }
          function symbolToTypeNode(symbol, context, meaning, overrideTypeArguments) {
            var chain = lookupSymbolChain(symbol, context, meaning, !(context.flags & 16384));
            var isTypeOf = meaning === 111551;
            if (ts3.some(chain[0].declarations, hasNonGlobalAugmentationExternalModuleSymbol)) {
              var nonRootParts = chain.length > 1 ? createAccessFromSymbolChain(chain, chain.length - 1, 1) : void 0;
              var typeParameterNodes = overrideTypeArguments || lookupTypeParameterNodes(chain, 0, context);
              var specifier = getSpecifierForModuleSymbol(chain[0], context);
              if (!(context.flags & 67108864) && ts3.getEmitModuleResolutionKind(compilerOptions) === ts3.ModuleResolutionKind.NodeJs && specifier.indexOf("/node_modules/") >= 0) {
                context.encounteredError = true;
                if (context.tracker.reportLikelyUnsafeImportRequiredError) {
                  context.tracker.reportLikelyUnsafeImportRequiredError(specifier);
                }
              }
              var lit = ts3.factory.createLiteralTypeNode(ts3.factory.createStringLiteral(specifier));
              if (context.tracker.trackExternalModuleSymbolOfImportTypeNode)
                context.tracker.trackExternalModuleSymbolOfImportTypeNode(chain[0]);
              context.approximateLength += specifier.length + 10;
              if (!nonRootParts || ts3.isEntityName(nonRootParts)) {
                if (nonRootParts) {
                  var lastId = ts3.isIdentifier(nonRootParts) ? nonRootParts : nonRootParts.right;
                  lastId.typeArguments = void 0;
                }
                return ts3.factory.createImportTypeNode(lit, nonRootParts, typeParameterNodes, isTypeOf);
              } else {
                var splitNode = getTopmostIndexedAccessType(nonRootParts);
                var qualifier = splitNode.objectType.typeName;
                return ts3.factory.createIndexedAccessTypeNode(ts3.factory.createImportTypeNode(lit, qualifier, typeParameterNodes, isTypeOf), splitNode.indexType);
              }
            }
            var entityName = createAccessFromSymbolChain(chain, chain.length - 1, 0);
            if (ts3.isIndexedAccessTypeNode(entityName)) {
              return entityName;
            }
            if (isTypeOf) {
              return ts3.factory.createTypeQueryNode(entityName);
            } else {
              var lastId = ts3.isIdentifier(entityName) ? entityName : entityName.right;
              var lastTypeArgs = lastId.typeArguments;
              lastId.typeArguments = void 0;
              return ts3.factory.createTypeReferenceNode(entityName, lastTypeArgs);
            }
            function createAccessFromSymbolChain(chain2, index, stopper) {
              var typeParameterNodes2 = index === chain2.length - 1 ? overrideTypeArguments : lookupTypeParameterNodes(chain2, index, context);
              var symbol2 = chain2[index];
              var parent = chain2[index - 1];
              var symbolName;
              if (index === 0) {
                context.flags |= 16777216;
                symbolName = getNameOfSymbolAsWritten(symbol2, context);
                context.approximateLength += (symbolName ? symbolName.length : 0) + 1;
                context.flags ^= 16777216;
              } else {
                if (parent && getExportsOfSymbol(parent)) {
                  var exports_1 = getExportsOfSymbol(parent);
                  ts3.forEachEntry(exports_1, function(ex, name) {
                    if (getSymbolIfSameReference(ex, symbol2) && !isLateBoundName(name) && name !== "export=") {
                      symbolName = ts3.unescapeLeadingUnderscores(name);
                      return true;
                    }
                  });
                }
              }
              if (!symbolName) {
                symbolName = getNameOfSymbolAsWritten(symbol2, context);
              }
              context.approximateLength += symbolName.length + 1;
              if (!(context.flags & 16) && parent && getMembersOfSymbol(parent) && getMembersOfSymbol(parent).get(symbol2.escapedName) && getSymbolIfSameReference(getMembersOfSymbol(parent).get(symbol2.escapedName), symbol2)) {
                var LHS = createAccessFromSymbolChain(chain2, index - 1, stopper);
                if (ts3.isIndexedAccessTypeNode(LHS)) {
                  return ts3.factory.createIndexedAccessTypeNode(LHS, ts3.factory.createLiteralTypeNode(ts3.factory.createStringLiteral(symbolName)));
                } else {
                  return ts3.factory.createIndexedAccessTypeNode(ts3.factory.createTypeReferenceNode(LHS, typeParameterNodes2), ts3.factory.createLiteralTypeNode(ts3.factory.createStringLiteral(symbolName)));
                }
              }
              var identifier = ts3.setEmitFlags(ts3.factory.createIdentifier(symbolName, typeParameterNodes2), 16777216);
              identifier.symbol = symbol2;
              if (index > stopper) {
                var LHS = createAccessFromSymbolChain(chain2, index - 1, stopper);
                if (!ts3.isEntityName(LHS)) {
                  return ts3.Debug.fail("Impossible construct - an export of an indexed access cannot be reachable");
                }
                return ts3.factory.createQualifiedName(LHS, identifier);
              }
              return identifier;
            }
          }
          function typeParameterShadowsNameInScope(escapedName, context, type3) {
            var result2 = resolveName(context.enclosingDeclaration, escapedName, 788968, void 0, escapedName, false);
            if (result2) {
              if (result2.flags & 262144 && result2 === type3.symbol) {
                return false;
              }
              return true;
            }
            return false;
          }
          function typeParameterToName(type3, context) {
            var _a2;
            if (context.flags & 4 && context.typeParameterNames) {
              var cached = context.typeParameterNames.get(getTypeId(type3));
              if (cached) {
                return cached;
              }
            }
            var result2 = symbolToName(type3.symbol, context, 788968, true);
            if (!(result2.kind & 78)) {
              return ts3.factory.createIdentifier("(Missing type parameter)");
            }
            if (context.flags & 4) {
              var rawtext = result2.escapedText;
              var i3 = 0;
              var text = rawtext;
              while (((_a2 = context.typeParameterNamesByText) === null || _a2 === void 0 ? void 0 : _a2.has(text)) || typeParameterShadowsNameInScope(text, context, type3)) {
                i3++;
                text = rawtext + "_" + i3;
              }
              if (text !== rawtext) {
                result2 = ts3.factory.createIdentifier(text, result2.typeArguments);
              }
              (context.typeParameterNames || (context.typeParameterNames = new ts3.Map())).set(getTypeId(type3), result2);
              (context.typeParameterNamesByText || (context.typeParameterNamesByText = new ts3.Set())).add(result2.escapedText);
            }
            return result2;
          }
          function symbolToName(symbol, context, meaning, expectsIdentifier) {
            var chain = lookupSymbolChain(symbol, context, meaning);
            if (expectsIdentifier && chain.length !== 1 && !context.encounteredError && !(context.flags & 65536)) {
              context.encounteredError = true;
            }
            return createEntityNameFromSymbolChain(chain, chain.length - 1);
            function createEntityNameFromSymbolChain(chain2, index) {
              var typeParameterNodes = lookupTypeParameterNodes(chain2, index, context);
              var symbol2 = chain2[index];
              if (index === 0) {
                context.flags |= 16777216;
              }
              var symbolName = getNameOfSymbolAsWritten(symbol2, context);
              if (index === 0) {
                context.flags ^= 16777216;
              }
              var identifier = ts3.setEmitFlags(ts3.factory.createIdentifier(symbolName, typeParameterNodes), 16777216);
              identifier.symbol = symbol2;
              return index > 0 ? ts3.factory.createQualifiedName(createEntityNameFromSymbolChain(chain2, index - 1), identifier) : identifier;
            }
          }
          function symbolToExpression(symbol, context, meaning) {
            var chain = lookupSymbolChain(symbol, context, meaning);
            return createExpressionFromSymbolChain(chain, chain.length - 1);
            function createExpressionFromSymbolChain(chain2, index) {
              var typeParameterNodes = lookupTypeParameterNodes(chain2, index, context);
              var symbol2 = chain2[index];
              if (index === 0) {
                context.flags |= 16777216;
              }
              var symbolName = getNameOfSymbolAsWritten(symbol2, context);
              if (index === 0) {
                context.flags ^= 16777216;
              }
              var firstChar = symbolName.charCodeAt(0);
              if (ts3.isSingleOrDoubleQuote(firstChar) && ts3.some(symbol2.declarations, hasNonGlobalAugmentationExternalModuleSymbol)) {
                return ts3.factory.createStringLiteral(getSpecifierForModuleSymbol(symbol2, context));
              }
              var canUsePropertyAccess = firstChar === 35 ? symbolName.length > 1 && ts3.isIdentifierStart(symbolName.charCodeAt(1), languageVersion) : ts3.isIdentifierStart(firstChar, languageVersion);
              if (index === 0 || canUsePropertyAccess) {
                var identifier = ts3.setEmitFlags(ts3.factory.createIdentifier(symbolName, typeParameterNodes), 16777216);
                identifier.symbol = symbol2;
                return index > 0 ? ts3.factory.createPropertyAccessExpression(createExpressionFromSymbolChain(chain2, index - 1), identifier) : identifier;
              } else {
                if (firstChar === 91) {
                  symbolName = symbolName.substring(1, symbolName.length - 1);
                  firstChar = symbolName.charCodeAt(0);
                }
                var expression = void 0;
                if (ts3.isSingleOrDoubleQuote(firstChar)) {
                  expression = ts3.factory.createStringLiteral(symbolName.substring(1, symbolName.length - 1).replace(/\\./g, function(s2) {
                    return s2.substring(1);
                  }), firstChar === 39);
                } else if ("" + +symbolName === symbolName) {
                  expression = ts3.factory.createNumericLiteral(+symbolName);
                }
                if (!expression) {
                  expression = ts3.setEmitFlags(ts3.factory.createIdentifier(symbolName, typeParameterNodes), 16777216);
                  expression.symbol = symbol2;
                }
                return ts3.factory.createElementAccessExpression(createExpressionFromSymbolChain(chain2, index - 1), expression);
              }
            }
          }
          function isStringNamed(d) {
            var name = ts3.getNameOfDeclaration(d);
            return !!name && ts3.isStringLiteral(name);
          }
          function isSingleQuotedStringNamed(d) {
            var name = ts3.getNameOfDeclaration(d);
            return !!(name && ts3.isStringLiteral(name) && (name.singleQuote || !ts3.nodeIsSynthesized(name) && ts3.startsWith(ts3.getTextOfNode(name, false), "'")));
          }
          function getPropertyNameNodeForSymbol(symbol, context) {
            var singleQuote = !!ts3.length(symbol.declarations) && ts3.every(symbol.declarations, isSingleQuotedStringNamed);
            var fromNameType = getPropertyNameNodeForSymbolFromNameType(symbol, context, singleQuote);
            if (fromNameType) {
              return fromNameType;
            }
            var rawName = ts3.unescapeLeadingUnderscores(symbol.escapedName);
            var stringNamed = !!ts3.length(symbol.declarations) && ts3.every(symbol.declarations, isStringNamed);
            return createPropertyNameNodeForIdentifierOrLiteral(rawName, stringNamed, singleQuote);
          }
          function getPropertyNameNodeForSymbolFromNameType(symbol, context, singleQuote) {
            var nameType = getSymbolLinks(symbol).nameType;
            if (nameType) {
              if (nameType.flags & 384) {
                var name = "" + nameType.value;
                if (!ts3.isIdentifierText(name, compilerOptions.target) && !isNumericLiteralName(name)) {
                  return ts3.factory.createStringLiteral(name, !!singleQuote);
                }
                if (isNumericLiteralName(name) && ts3.startsWith(name, "-")) {
                  return ts3.factory.createComputedPropertyName(ts3.factory.createNumericLiteral(+name));
                }
                return createPropertyNameNodeForIdentifierOrLiteral(name);
              }
              if (nameType.flags & 8192) {
                return ts3.factory.createComputedPropertyName(symbolToExpression(nameType.symbol, context, 111551));
              }
            }
          }
          function createPropertyNameNodeForIdentifierOrLiteral(name, stringNamed, singleQuote) {
            return ts3.isIdentifierText(name, compilerOptions.target) ? ts3.factory.createIdentifier(name) : !stringNamed && isNumericLiteralName(name) && +name >= 0 ? ts3.factory.createNumericLiteral(+name) : ts3.factory.createStringLiteral(name, !!singleQuote);
          }
          function cloneNodeBuilderContext(context) {
            var initial = __assign({}, context);
            if (initial.typeParameterNames) {
              initial.typeParameterNames = new ts3.Map(initial.typeParameterNames);
            }
            if (initial.typeParameterNamesByText) {
              initial.typeParameterNamesByText = new ts3.Set(initial.typeParameterNamesByText);
            }
            if (initial.typeParameterSymbolList) {
              initial.typeParameterSymbolList = new ts3.Set(initial.typeParameterSymbolList);
            }
            return initial;
          }
          function getDeclarationWithTypeAnnotation(symbol, enclosingDeclaration) {
            return symbol.declarations && ts3.find(symbol.declarations, function(s2) {
              return !!ts3.getEffectiveTypeAnnotationNode(s2) && (!enclosingDeclaration || !!ts3.findAncestor(s2, function(n2) {
                return n2 === enclosingDeclaration;
              }));
            });
          }
          function existingTypeNodeIsNotReferenceOrIsReferenceWithCompatibleTypeArgumentCount(existing, type3) {
            return !(ts3.getObjectFlags(type3) & 4) || !ts3.isTypeReferenceNode(existing) || ts3.length(existing.typeArguments) >= getMinTypeArgumentCount(type3.target.typeParameters);
          }
          function serializeTypeForDeclaration(context, type3, symbol, enclosingDeclaration, includePrivateSymbol, bundled) {
            if (type3 !== errorType && enclosingDeclaration) {
              var declWithExistingAnnotation = getDeclarationWithTypeAnnotation(symbol, enclosingDeclaration);
              if (declWithExistingAnnotation && !ts3.isFunctionLikeDeclaration(declWithExistingAnnotation) && !ts3.isGetAccessorDeclaration(declWithExistingAnnotation)) {
                var existing = ts3.getEffectiveTypeAnnotationNode(declWithExistingAnnotation);
                if (getTypeFromTypeNode(existing) === type3 && existingTypeNodeIsNotReferenceOrIsReferenceWithCompatibleTypeArgumentCount(existing, type3)) {
                  var result_6 = serializeExistingTypeNode(context, existing, includePrivateSymbol, bundled);
                  if (result_6) {
                    return result_6;
                  }
                }
              }
            }
            var oldFlags = context.flags;
            if (type3.flags & 8192 && type3.symbol === symbol && (!context.enclosingDeclaration || ts3.some(symbol.declarations, function(d) {
              return ts3.getSourceFileOfNode(d) === ts3.getSourceFileOfNode(context.enclosingDeclaration);
            }))) {
              context.flags |= 1048576;
            }
            var result2 = typeToTypeNodeHelper(type3, context);
            context.flags = oldFlags;
            return result2;
          }
          function serializeReturnTypeForSignature(context, type3, signature, includePrivateSymbol, bundled) {
            if (type3 !== errorType && context.enclosingDeclaration) {
              var annotation = signature.declaration && ts3.getEffectiveReturnTypeNode(signature.declaration);
              if (!!ts3.findAncestor(annotation, function(n2) {
                return n2 === context.enclosingDeclaration;
              }) && annotation) {
                var annotated = getTypeFromTypeNode(annotation);
                var thisInstantiated = annotated.flags & 262144 && annotated.isThisType ? instantiateType(annotated, signature.mapper) : annotated;
                if (thisInstantiated === type3 && existingTypeNodeIsNotReferenceOrIsReferenceWithCompatibleTypeArgumentCount(annotation, type3)) {
                  var result2 = serializeExistingTypeNode(context, annotation, includePrivateSymbol, bundled);
                  if (result2) {
                    return result2;
                  }
                }
              }
            }
            return typeToTypeNodeHelper(type3, context);
          }
          function trackExistingEntityName(node, context, includePrivateSymbol) {
            var _a2, _b;
            var introducesError = false;
            var leftmost = ts3.getFirstIdentifier(node);
            if (ts3.isInJSFile(node) && (ts3.isExportsIdentifier(leftmost) || ts3.isModuleExportsAccessExpression(leftmost.parent) || ts3.isQualifiedName(leftmost.parent) && ts3.isModuleIdentifier(leftmost.parent.left) && ts3.isExportsIdentifier(leftmost.parent.right))) {
              introducesError = true;
              return { introducesError, node };
            }
            var sym = resolveEntityName(leftmost, 67108863, true, true);
            if (sym) {
              if (isSymbolAccessible(sym, context.enclosingDeclaration, 67108863, false).accessibility !== 0) {
                introducesError = true;
              } else {
                (_b = (_a2 = context.tracker) === null || _a2 === void 0 ? void 0 : _a2.trackSymbol) === null || _b === void 0 ? void 0 : _b.call(_a2, sym, context.enclosingDeclaration, 67108863);
                includePrivateSymbol === null || includePrivateSymbol === void 0 ? void 0 : includePrivateSymbol(sym);
              }
              if (ts3.isIdentifier(node)) {
                var name = sym.flags & 262144 ? typeParameterToName(getDeclaredTypeOfSymbol(sym), context) : ts3.factory.cloneNode(node);
                name.symbol = sym;
                return { introducesError, node: ts3.setEmitFlags(ts3.setOriginalNode(name, node), 16777216) };
              }
            }
            return { introducesError, node };
          }
          function serializeExistingTypeNode(context, existing, includePrivateSymbol, bundled) {
            if (cancellationToken && cancellationToken.throwIfCancellationRequested) {
              cancellationToken.throwIfCancellationRequested();
            }
            var hadError = false;
            var file = ts3.getSourceFileOfNode(existing);
            var transformed = ts3.visitNode(existing, visitExistingNodeTreeSymbols);
            if (hadError) {
              return void 0;
            }
            return transformed === existing ? ts3.setTextRange(ts3.factory.cloneNode(existing), existing) : transformed;
            function visitExistingNodeTreeSymbols(node) {
              if (ts3.isJSDocAllType(node) || node.kind === 311) {
                return ts3.factory.createKeywordTypeNode(128);
              }
              if (ts3.isJSDocUnknownType(node)) {
                return ts3.factory.createKeywordTypeNode(152);
              }
              if (ts3.isJSDocNullableType(node)) {
                return ts3.factory.createUnionTypeNode([ts3.visitNode(node.type, visitExistingNodeTreeSymbols), ts3.factory.createLiteralTypeNode(ts3.factory.createNull())]);
              }
              if (ts3.isJSDocOptionalType(node)) {
                return ts3.factory.createUnionTypeNode([ts3.visitNode(node.type, visitExistingNodeTreeSymbols), ts3.factory.createKeywordTypeNode(150)]);
              }
              if (ts3.isJSDocNonNullableType(node)) {
                return ts3.visitNode(node.type, visitExistingNodeTreeSymbols);
              }
              if (ts3.isJSDocVariadicType(node)) {
                return ts3.factory.createArrayTypeNode(ts3.visitNode(node.type, visitExistingNodeTreeSymbols));
              }
              if (ts3.isJSDocTypeLiteral(node)) {
                return ts3.factory.createTypeLiteralNode(ts3.map(node.jsDocPropertyTags, function(t2) {
                  var name = ts3.isIdentifier(t2.name) ? t2.name : t2.name.right;
                  var typeViaParent = getTypeOfPropertyOfType(getTypeFromTypeNode(node), name.escapedText);
                  var overrideTypeNode = typeViaParent && t2.typeExpression && getTypeFromTypeNode(t2.typeExpression.type) !== typeViaParent ? typeToTypeNodeHelper(typeViaParent, context) : void 0;
                  return ts3.factory.createPropertySignature(void 0, name, t2.isBracketed || t2.typeExpression && ts3.isJSDocOptionalType(t2.typeExpression.type) ? ts3.factory.createToken(57) : void 0, overrideTypeNode || t2.typeExpression && ts3.visitNode(t2.typeExpression.type, visitExistingNodeTreeSymbols) || ts3.factory.createKeywordTypeNode(128));
                }));
              }
              if (ts3.isTypeReferenceNode(node) && ts3.isIdentifier(node.typeName) && node.typeName.escapedText === "") {
                return ts3.setOriginalNode(ts3.factory.createKeywordTypeNode(128), node);
              }
              if ((ts3.isExpressionWithTypeArguments(node) || ts3.isTypeReferenceNode(node)) && ts3.isJSDocIndexSignature(node)) {
                return ts3.factory.createTypeLiteralNode([ts3.factory.createIndexSignature(void 0, void 0, [ts3.factory.createParameterDeclaration(void 0, void 0, void 0, "x", void 0, ts3.visitNode(node.typeArguments[0], visitExistingNodeTreeSymbols))], ts3.visitNode(node.typeArguments[1], visitExistingNodeTreeSymbols))]);
              }
              if (ts3.isJSDocFunctionType(node)) {
                if (ts3.isJSDocConstructSignature(node)) {
                  var newTypeNode_1;
                  return ts3.factory.createConstructorTypeNode(node.modifiers, ts3.visitNodes(node.typeParameters, visitExistingNodeTreeSymbols), ts3.mapDefined(node.parameters, function(p, i3) {
                    return p.name && ts3.isIdentifier(p.name) && p.name.escapedText === "new" ? (newTypeNode_1 = p.type, void 0) : ts3.factory.createParameterDeclaration(void 0, void 0, getEffectiveDotDotDotForParameter(p), getNameForJSDocFunctionParameter(p, i3), p.questionToken, ts3.visitNode(p.type, visitExistingNodeTreeSymbols), void 0);
                  }), ts3.visitNode(newTypeNode_1 || node.type, visitExistingNodeTreeSymbols) || ts3.factory.createKeywordTypeNode(128));
                } else {
                  return ts3.factory.createFunctionTypeNode(ts3.visitNodes(node.typeParameters, visitExistingNodeTreeSymbols), ts3.map(node.parameters, function(p, i3) {
                    return ts3.factory.createParameterDeclaration(void 0, void 0, getEffectiveDotDotDotForParameter(p), getNameForJSDocFunctionParameter(p, i3), p.questionToken, ts3.visitNode(p.type, visitExistingNodeTreeSymbols), void 0);
                  }), ts3.visitNode(node.type, visitExistingNodeTreeSymbols) || ts3.factory.createKeywordTypeNode(128));
                }
              }
              if (ts3.isTypeReferenceNode(node) && ts3.isInJSDoc(node) && (!existingTypeNodeIsNotReferenceOrIsReferenceWithCompatibleTypeArgumentCount(node, getTypeFromTypeNode(node)) || getIntendedTypeFromJSDocTypeReference(node) || unknownSymbol === resolveTypeReferenceName(getTypeReferenceName(node), 788968, true))) {
                return ts3.setOriginalNode(typeToTypeNodeHelper(getTypeFromTypeNode(node), context), node);
              }
              if (ts3.isLiteralImportTypeNode(node)) {
                var nodeSymbol = getNodeLinks(node).resolvedSymbol;
                if (ts3.isInJSDoc(node) && nodeSymbol && (!node.isTypeOf && !(nodeSymbol.flags & 788968) || !(ts3.length(node.typeArguments) >= getMinTypeArgumentCount(getLocalTypeParametersOfClassOrInterfaceOrTypeAlias(nodeSymbol))))) {
                  return ts3.setOriginalNode(typeToTypeNodeHelper(getTypeFromTypeNode(node), context), node);
                }
                return ts3.factory.updateImportTypeNode(node, ts3.factory.updateLiteralTypeNode(node.argument, rewriteModuleSpecifier(node, node.argument.literal)), node.qualifier, ts3.visitNodes(node.typeArguments, visitExistingNodeTreeSymbols, ts3.isTypeNode), node.isTypeOf);
              }
              if (ts3.isEntityName(node) || ts3.isEntityNameExpression(node)) {
                var _a2 = trackExistingEntityName(node, context, includePrivateSymbol), introducesError = _a2.introducesError, result2 = _a2.node;
                hadError = hadError || introducesError;
                if (result2 !== node) {
                  return result2;
                }
              }
              if (file && ts3.isTupleTypeNode(node) && ts3.getLineAndCharacterOfPosition(file, node.pos).line === ts3.getLineAndCharacterOfPosition(file, node.end).line) {
                ts3.setEmitFlags(node, 1);
              }
              return ts3.visitEachChild(node, visitExistingNodeTreeSymbols, ts3.nullTransformationContext);
              function getEffectiveDotDotDotForParameter(p) {
                return p.dotDotDotToken || (p.type && ts3.isJSDocVariadicType(p.type) ? ts3.factory.createToken(25) : void 0);
              }
              function getNameForJSDocFunctionParameter(p, index) {
                return p.name && ts3.isIdentifier(p.name) && p.name.escapedText === "this" ? "this" : getEffectiveDotDotDotForParameter(p) ? "args" : "arg" + index;
              }
              function rewriteModuleSpecifier(parent, lit) {
                if (bundled) {
                  if (context.tracker && context.tracker.moduleResolverHost) {
                    var targetFile = getExternalModuleFileFromDeclaration(parent);
                    if (targetFile) {
                      var getCanonicalFileName = ts3.createGetCanonicalFileName(!!host.useCaseSensitiveFileNames);
                      var resolverHost = {
                        getCanonicalFileName,
                        getCurrentDirectory: function() {
                          return context.tracker.moduleResolverHost.getCurrentDirectory();
                        },
                        getCommonSourceDirectory: function() {
                          return context.tracker.moduleResolverHost.getCommonSourceDirectory();
                        }
                      };
                      var newName = ts3.getResolvedExternalModuleName(resolverHost, targetFile);
                      return ts3.factory.createStringLiteral(newName);
                    }
                  }
                } else {
                  if (context.tracker && context.tracker.trackExternalModuleSymbolOfImportTypeNode) {
                    var moduleSym = resolveExternalModuleNameWorker(lit, lit, void 0);
                    if (moduleSym) {
                      context.tracker.trackExternalModuleSymbolOfImportTypeNode(moduleSym);
                    }
                  }
                }
                return lit;
              }
            }
          }
          function symbolTableToDeclarationStatements(symbolTable, context, bundled) {
            var serializePropertySymbolForClass = makeSerializePropertySymbol(ts3.factory.createPropertyDeclaration, 166, true);
            var serializePropertySymbolForInterfaceWorker = makeSerializePropertySymbol(function(_decorators, mods, name, question, type3) {
              return ts3.factory.createPropertySignature(mods, name, question, type3);
            }, 165, false);
            var enclosingDeclaration = context.enclosingDeclaration;
            var results = [];
            var visitedSymbols = new ts3.Set();
            var deferredPrivatesStack = [];
            var oldcontext = context;
            context = __assign(__assign({}, oldcontext), { usedSymbolNames: new ts3.Set(oldcontext.usedSymbolNames), remappedSymbolNames: new ts3.Map(), tracker: __assign(__assign({}, oldcontext.tracker), { trackSymbol: function(sym, decl, meaning) {
              var accessibleResult = isSymbolAccessible(sym, decl, meaning, false);
              if (accessibleResult.accessibility === 0) {
                var chain = lookupSymbolChainWorker(sym, context, meaning);
                if (!(sym.flags & 4)) {
                  includePrivateSymbol(chain[0]);
                }
              } else if (oldcontext.tracker && oldcontext.tracker.trackSymbol) {
                oldcontext.tracker.trackSymbol(sym, decl, meaning);
              }
            } }) });
            ts3.forEachEntry(symbolTable, function(symbol, name) {
              var baseName = ts3.unescapeLeadingUnderscores(name);
              void getInternalSymbolName(symbol, baseName);
            });
            var addingDeclare = !bundled;
            var exportEquals = symbolTable.get("export=");
            if (exportEquals && symbolTable.size > 1 && exportEquals.flags & 2097152) {
              symbolTable = ts3.createSymbolTable();
              symbolTable.set("export=", exportEquals);
            }
            visitSymbolTable(symbolTable);
            return mergeRedundantStatements(results);
            function isIdentifierAndNotUndefined(node) {
              return !!node && node.kind === 78;
            }
            function getNamesOfDeclaration(statement) {
              if (ts3.isVariableStatement(statement)) {
                return ts3.filter(ts3.map(statement.declarationList.declarations, ts3.getNameOfDeclaration), isIdentifierAndNotUndefined);
              }
              return ts3.filter([ts3.getNameOfDeclaration(statement)], isIdentifierAndNotUndefined);
            }
            function flattenExportAssignedNamespace(statements) {
              var exportAssignment = ts3.find(statements, ts3.isExportAssignment);
              var nsIndex = ts3.findIndex(statements, ts3.isModuleDeclaration);
              var ns = nsIndex !== -1 ? statements[nsIndex] : void 0;
              if (ns && exportAssignment && exportAssignment.isExportEquals && ts3.isIdentifier(exportAssignment.expression) && ts3.isIdentifier(ns.name) && ts3.idText(ns.name) === ts3.idText(exportAssignment.expression) && ns.body && ts3.isModuleBlock(ns.body)) {
                var excessExports = ts3.filter(statements, function(s2) {
                  return !!(ts3.getEffectiveModifierFlags(s2) & 1);
                });
                var name_2 = ns.name;
                var body = ns.body;
                if (ts3.length(excessExports)) {
                  ns = ts3.factory.updateModuleDeclaration(ns, ns.decorators, ns.modifiers, ns.name, body = ts3.factory.updateModuleBlock(body, ts3.factory.createNodeArray(__spreadArray(__spreadArray([], ns.body.statements), [ts3.factory.createExportDeclaration(void 0, void 0, false, ts3.factory.createNamedExports(ts3.map(ts3.flatMap(excessExports, function(e2) {
                    return getNamesOfDeclaration(e2);
                  }), function(id) {
                    return ts3.factory.createExportSpecifier(void 0, id);
                  })), void 0)]))));
                  statements = __spreadArray(__spreadArray(__spreadArray([], statements.slice(0, nsIndex)), [ns]), statements.slice(nsIndex + 1));
                }
                if (!ts3.find(statements, function(s2) {
                  return s2 !== ns && ts3.nodeHasName(s2, name_2);
                })) {
                  results = [];
                  var mixinExportFlag_1 = !ts3.some(body.statements, function(s2) {
                    return ts3.hasSyntacticModifier(s2, 1) || ts3.isExportAssignment(s2) || ts3.isExportDeclaration(s2);
                  });
                  ts3.forEach(body.statements, function(s2) {
                    addResult(s2, mixinExportFlag_1 ? 1 : 0);
                  });
                  statements = __spreadArray(__spreadArray([], ts3.filter(statements, function(s2) {
                    return s2 !== ns && s2 !== exportAssignment;
                  })), results);
                }
              }
              return statements;
            }
            function mergeExportDeclarations(statements) {
              var exports3 = ts3.filter(statements, function(d) {
                return ts3.isExportDeclaration(d) && !d.moduleSpecifier && !!d.exportClause && ts3.isNamedExports(d.exportClause);
              });
              if (ts3.length(exports3) > 1) {
                var nonExports = ts3.filter(statements, function(d) {
                  return !ts3.isExportDeclaration(d) || !!d.moduleSpecifier || !d.exportClause;
                });
                statements = __spreadArray(__spreadArray([], nonExports), [ts3.factory.createExportDeclaration(void 0, void 0, false, ts3.factory.createNamedExports(ts3.flatMap(exports3, function(e2) {
                  return ts3.cast(e2.exportClause, ts3.isNamedExports).elements;
                })), void 0)]);
              }
              var reexports = ts3.filter(statements, function(d) {
                return ts3.isExportDeclaration(d) && !!d.moduleSpecifier && !!d.exportClause && ts3.isNamedExports(d.exportClause);
              });
              if (ts3.length(reexports) > 1) {
                var groups = ts3.group(reexports, function(decl) {
                  return ts3.isStringLiteral(decl.moduleSpecifier) ? ">" + decl.moduleSpecifier.text : ">";
                });
                if (groups.length !== reexports.length) {
                  var _loop_9 = function(group_12) {
                    if (group_12.length > 1) {
                      statements = __spreadArray(__spreadArray([], ts3.filter(statements, function(s2) {
                        return group_12.indexOf(s2) === -1;
                      })), [
                        ts3.factory.createExportDeclaration(void 0, void 0, false, ts3.factory.createNamedExports(ts3.flatMap(group_12, function(e2) {
                          return ts3.cast(e2.exportClause, ts3.isNamedExports).elements;
                        })), group_12[0].moduleSpecifier)
                      ]);
                    }
                  };
                  for (var _i = 0, groups_1 = groups; _i < groups_1.length; _i++) {
                    var group_1 = groups_1[_i];
                    _loop_9(group_1);
                  }
                }
              }
              return statements;
            }
            function inlineExportModifiers(statements) {
              var index = ts3.findIndex(statements, function(d) {
                return ts3.isExportDeclaration(d) && !d.moduleSpecifier && !!d.exportClause && ts3.isNamedExports(d.exportClause);
              });
              if (index >= 0) {
                var exportDecl = statements[index];
                var replacements = ts3.mapDefined(exportDecl.exportClause.elements, function(e2) {
                  if (!e2.propertyName) {
                    var indices = ts3.indicesOf(statements);
                    var associatedIndices = ts3.filter(indices, function(i3) {
                      return ts3.nodeHasName(statements[i3], e2.name);
                    });
                    if (ts3.length(associatedIndices) && ts3.every(associatedIndices, function(i3) {
                      return canHaveExportModifier(statements[i3]);
                    })) {
                      for (var _i = 0, associatedIndices_1 = associatedIndices; _i < associatedIndices_1.length; _i++) {
                        var index_1 = associatedIndices_1[_i];
                        statements[index_1] = addExportModifier(statements[index_1]);
                      }
                      return void 0;
                    }
                  }
                  return e2;
                });
                if (!ts3.length(replacements)) {
                  ts3.orderedRemoveItemAt(statements, index);
                } else {
                  statements[index] = ts3.factory.updateExportDeclaration(exportDecl, exportDecl.decorators, exportDecl.modifiers, exportDecl.isTypeOnly, ts3.factory.updateNamedExports(exportDecl.exportClause, replacements), exportDecl.moduleSpecifier);
                }
              }
              return statements;
            }
            function mergeRedundantStatements(statements) {
              statements = flattenExportAssignedNamespace(statements);
              statements = mergeExportDeclarations(statements);
              statements = inlineExportModifiers(statements);
              if (enclosingDeclaration && (ts3.isSourceFile(enclosingDeclaration) && ts3.isExternalOrCommonJsModule(enclosingDeclaration) || ts3.isModuleDeclaration(enclosingDeclaration)) && (!ts3.some(statements, ts3.isExternalModuleIndicator) || !ts3.hasScopeMarker(statements) && ts3.some(statements, ts3.needsScopeMarker))) {
                statements.push(ts3.createEmptyExports(ts3.factory));
              }
              return statements;
            }
            function canHaveExportModifier(node) {
              return ts3.isEnumDeclaration(node) || ts3.isVariableStatement(node) || ts3.isFunctionDeclaration(node) || ts3.isClassDeclaration(node) || ts3.isModuleDeclaration(node) && !ts3.isExternalModuleAugmentation(node) && !ts3.isGlobalScopeAugmentation(node) || ts3.isInterfaceDeclaration(node) || isTypeDeclaration(node);
            }
            function addExportModifier(node) {
              var flags = (ts3.getEffectiveModifierFlags(node) | 1) & ~2;
              return ts3.factory.updateModifiers(node, flags);
            }
            function removeExportModifier(node) {
              var flags = ts3.getEffectiveModifierFlags(node) & ~1;
              return ts3.factory.updateModifiers(node, flags);
            }
            function visitSymbolTable(symbolTable2, suppressNewPrivateContext, propertyAsAlias) {
              if (!suppressNewPrivateContext) {
                deferredPrivatesStack.push(new ts3.Map());
              }
              symbolTable2.forEach(function(symbol) {
                serializeSymbol(symbol, false, !!propertyAsAlias);
              });
              if (!suppressNewPrivateContext) {
                deferredPrivatesStack[deferredPrivatesStack.length - 1].forEach(function(symbol) {
                  serializeSymbol(symbol, true, !!propertyAsAlias);
                });
                deferredPrivatesStack.pop();
              }
            }
            function serializeSymbol(symbol, isPrivate, propertyAsAlias) {
              var visitedSym = getMergedSymbol(symbol);
              if (visitedSymbols.has(getSymbolId(visitedSym))) {
                return;
              }
              visitedSymbols.add(getSymbolId(visitedSym));
              var skipMembershipCheck = !isPrivate;
              if (skipMembershipCheck || !!ts3.length(symbol.declarations) && ts3.some(symbol.declarations, function(d) {
                return !!ts3.findAncestor(d, function(n2) {
                  return n2 === enclosingDeclaration;
                });
              })) {
                var oldContext = context;
                context = cloneNodeBuilderContext(context);
                var result2 = serializeSymbolWorker(symbol, isPrivate, propertyAsAlias);
                context = oldContext;
                return result2;
              }
            }
            function serializeSymbolWorker(symbol, isPrivate, propertyAsAlias) {
              var _a2, _b;
              var symbolName = ts3.unescapeLeadingUnderscores(symbol.escapedName);
              var isDefault = symbol.escapedName === "default";
              if (isPrivate && !(context.flags & 131072) && ts3.isStringANonContextualKeyword(symbolName) && !isDefault) {
                context.encounteredError = true;
                return;
              }
              var needsPostExportDefault = isDefault && !!(symbol.flags & -113 || symbol.flags & 16 && ts3.length(getPropertiesOfType(getTypeOfSymbol(symbol)))) && !(symbol.flags & 2097152);
              var needsExportDeclaration = !needsPostExportDefault && !isPrivate && ts3.isStringANonContextualKeyword(symbolName) && !isDefault;
              if (needsPostExportDefault || needsExportDeclaration) {
                isPrivate = true;
              }
              var modifierFlags = (!isPrivate ? 1 : 0) | (isDefault && !needsPostExportDefault ? 512 : 0);
              var isConstMergedWithNS = symbol.flags & 1536 && symbol.flags & (2 | 1 | 4) && symbol.escapedName !== "export=";
              var isConstMergedWithNSPrintableAsSignatureMerge = isConstMergedWithNS && isTypeRepresentableAsFunctionNamespaceMerge(getTypeOfSymbol(symbol), symbol);
              if (symbol.flags & (16 | 8192) || isConstMergedWithNSPrintableAsSignatureMerge) {
                serializeAsFunctionNamespaceMerge(getTypeOfSymbol(symbol), symbol, getInternalSymbolName(symbol, symbolName), modifierFlags);
              }
              if (symbol.flags & 524288) {
                serializeTypeAlias(symbol, symbolName, modifierFlags);
              }
              if (symbol.flags & (2 | 1 | 4) && symbol.escapedName !== "export=" && !(symbol.flags & 4194304) && !(symbol.flags & 32) && !isConstMergedWithNSPrintableAsSignatureMerge) {
                if (propertyAsAlias) {
                  var createdExport = serializeMaybeAliasAssignment(symbol);
                  if (createdExport) {
                    needsExportDeclaration = false;
                    needsPostExportDefault = false;
                  }
                } else {
                  var type3 = getTypeOfSymbol(symbol);
                  var localName = getInternalSymbolName(symbol, symbolName);
                  if (!(symbol.flags & 16) && isTypeRepresentableAsFunctionNamespaceMerge(type3, symbol)) {
                    serializeAsFunctionNamespaceMerge(type3, symbol, localName, modifierFlags);
                  } else {
                    var flags = !(symbol.flags & 2) ? void 0 : isConstVariable(symbol) ? 2 : 1;
                    var name = needsPostExportDefault || !(symbol.flags & 4) ? localName : getUnusedName(localName, symbol);
                    var textRange = symbol.declarations && ts3.find(symbol.declarations, function(d) {
                      return ts3.isVariableDeclaration(d);
                    });
                    if (textRange && ts3.isVariableDeclarationList(textRange.parent) && textRange.parent.declarations.length === 1) {
                      textRange = textRange.parent.parent;
                    }
                    var propertyAccessRequire = (_a2 = symbol.declarations) === null || _a2 === void 0 ? void 0 : _a2.find(ts3.isPropertyAccessExpression);
                    if (propertyAccessRequire && ts3.isBinaryExpression(propertyAccessRequire.parent) && ts3.isIdentifier(propertyAccessRequire.parent.right) && ((_b = type3.symbol) === null || _b === void 0 ? void 0 : _b.valueDeclaration) && ts3.isSourceFile(type3.symbol.valueDeclaration)) {
                      var alias = localName === propertyAccessRequire.parent.right.escapedText ? void 0 : propertyAccessRequire.parent.right;
                      addResult(ts3.factory.createExportDeclaration(void 0, void 0, false, ts3.factory.createNamedExports([ts3.factory.createExportSpecifier(alias, localName)])), 0);
                      context.tracker.trackSymbol(type3.symbol, context.enclosingDeclaration, 111551);
                    } else {
                      var statement = ts3.setTextRange(ts3.factory.createVariableStatement(void 0, ts3.factory.createVariableDeclarationList([
                        ts3.factory.createVariableDeclaration(name, void 0, serializeTypeForDeclaration(context, type3, symbol, enclosingDeclaration, includePrivateSymbol, bundled))
                      ], flags)), textRange);
                      addResult(statement, name !== localName ? modifierFlags & ~1 : modifierFlags);
                      if (name !== localName && !isPrivate) {
                        addResult(ts3.factory.createExportDeclaration(void 0, void 0, false, ts3.factory.createNamedExports([ts3.factory.createExportSpecifier(name, localName)])), 0);
                        needsExportDeclaration = false;
                        needsPostExportDefault = false;
                      }
                    }
                  }
                }
              }
              if (symbol.flags & 384) {
                serializeEnum(symbol, symbolName, modifierFlags);
              }
              if (symbol.flags & 32) {
                if (symbol.flags & 4 && symbol.valueDeclaration && ts3.isBinaryExpression(symbol.valueDeclaration.parent) && ts3.isClassExpression(symbol.valueDeclaration.parent.right)) {
                  serializeAsAlias(symbol, getInternalSymbolName(symbol, symbolName), modifierFlags);
                } else {
                  serializeAsClass(symbol, getInternalSymbolName(symbol, symbolName), modifierFlags);
                }
              }
              if (symbol.flags & (512 | 1024) && (!isConstMergedWithNS || isTypeOnlyNamespace(symbol)) || isConstMergedWithNSPrintableAsSignatureMerge) {
                serializeModule(symbol, symbolName, modifierFlags);
              }
              if (symbol.flags & 64 && !(symbol.flags & 32)) {
                serializeInterface(symbol, symbolName, modifierFlags);
              }
              if (symbol.flags & 2097152) {
                serializeAsAlias(symbol, getInternalSymbolName(symbol, symbolName), modifierFlags);
              }
              if (symbol.flags & 4 && symbol.escapedName === "export=") {
                serializeMaybeAliasAssignment(symbol);
              }
              if (symbol.flags & 8388608) {
                if (symbol.declarations) {
                  for (var _i = 0, _c = symbol.declarations; _i < _c.length; _i++) {
                    var node = _c[_i];
                    var resolvedModule = resolveExternalModuleName(node, node.moduleSpecifier);
                    if (!resolvedModule)
                      continue;
                    addResult(ts3.factory.createExportDeclaration(void 0, void 0, false, void 0, ts3.factory.createStringLiteral(getSpecifierForModuleSymbol(resolvedModule, context))), 0);
                  }
                }
              }
              if (needsPostExportDefault) {
                addResult(ts3.factory.createExportAssignment(void 0, void 0, false, ts3.factory.createIdentifier(getInternalSymbolName(symbol, symbolName))), 0);
              } else if (needsExportDeclaration) {
                addResult(ts3.factory.createExportDeclaration(void 0, void 0, false, ts3.factory.createNamedExports([ts3.factory.createExportSpecifier(getInternalSymbolName(symbol, symbolName), symbolName)])), 0);
              }
            }
            function includePrivateSymbol(symbol) {
              if (ts3.some(symbol.declarations, ts3.isParameterDeclaration))
                return;
              ts3.Debug.assertIsDefined(deferredPrivatesStack[deferredPrivatesStack.length - 1]);
              getUnusedName(ts3.unescapeLeadingUnderscores(symbol.escapedName), symbol);
              var isExternalImportAlias = !!(symbol.flags & 2097152) && !ts3.some(symbol.declarations, function(d) {
                return !!ts3.findAncestor(d, ts3.isExportDeclaration) || ts3.isNamespaceExport(d) || ts3.isImportEqualsDeclaration(d) && !ts3.isExternalModuleReference(d.moduleReference);
              });
              deferredPrivatesStack[isExternalImportAlias ? 0 : deferredPrivatesStack.length - 1].set(getSymbolId(symbol), symbol);
            }
            function isExportingScope(enclosingDeclaration2) {
              return ts3.isSourceFile(enclosingDeclaration2) && (ts3.isExternalOrCommonJsModule(enclosingDeclaration2) || ts3.isJsonSourceFile(enclosingDeclaration2)) || ts3.isAmbientModule(enclosingDeclaration2) && !ts3.isGlobalScopeAugmentation(enclosingDeclaration2);
            }
            function addResult(node, additionalModifierFlags) {
              if (ts3.canHaveModifiers(node)) {
                var newModifierFlags = 0;
                var enclosingDeclaration_1 = context.enclosingDeclaration && (ts3.isJSDocTypeAlias(context.enclosingDeclaration) ? ts3.getSourceFileOfNode(context.enclosingDeclaration) : context.enclosingDeclaration);
                if (additionalModifierFlags & 1 && enclosingDeclaration_1 && (isExportingScope(enclosingDeclaration_1) || ts3.isModuleDeclaration(enclosingDeclaration_1)) && canHaveExportModifier(node)) {
                  newModifierFlags |= 1;
                }
                if (addingDeclare && !(newModifierFlags & 1) && (!enclosingDeclaration_1 || !(enclosingDeclaration_1.flags & 8388608)) && (ts3.isEnumDeclaration(node) || ts3.isVariableStatement(node) || ts3.isFunctionDeclaration(node) || ts3.isClassDeclaration(node) || ts3.isModuleDeclaration(node))) {
                  newModifierFlags |= 2;
                }
                if (additionalModifierFlags & 512 && (ts3.isClassDeclaration(node) || ts3.isInterfaceDeclaration(node) || ts3.isFunctionDeclaration(node))) {
                  newModifierFlags |= 512;
                }
                if (newModifierFlags) {
                  node = ts3.factory.updateModifiers(node, newModifierFlags | ts3.getEffectiveModifierFlags(node));
                }
              }
              results.push(node);
            }
            function serializeTypeAlias(symbol, symbolName, modifierFlags) {
              var _a2;
              var aliasType = getDeclaredTypeOfTypeAlias(symbol);
              var typeParams = getSymbolLinks(symbol).typeParameters;
              var typeParamDecls = ts3.map(typeParams, function(p) {
                return typeParameterToDeclaration(p, context);
              });
              var jsdocAliasDecl = (_a2 = symbol.declarations) === null || _a2 === void 0 ? void 0 : _a2.find(ts3.isJSDocTypeAlias);
              var commentText = ts3.getTextOfJSDocComment(jsdocAliasDecl ? jsdocAliasDecl.comment || jsdocAliasDecl.parent.comment : void 0);
              var oldFlags = context.flags;
              context.flags |= 8388608;
              var oldEnclosingDecl = context.enclosingDeclaration;
              context.enclosingDeclaration = jsdocAliasDecl;
              var typeNode = jsdocAliasDecl && jsdocAliasDecl.typeExpression && ts3.isJSDocTypeExpression(jsdocAliasDecl.typeExpression) && serializeExistingTypeNode(context, jsdocAliasDecl.typeExpression.type, includePrivateSymbol, bundled) || typeToTypeNodeHelper(aliasType, context);
              addResult(ts3.setSyntheticLeadingComments(ts3.factory.createTypeAliasDeclaration(void 0, void 0, getInternalSymbolName(symbol, symbolName), typeParamDecls, typeNode), !commentText ? [] : [{ kind: 3, text: "*\n * " + commentText.replace(/\n/g, "\n * ") + "\n ", pos: -1, end: -1, hasTrailingNewLine: true }]), modifierFlags);
              context.flags = oldFlags;
              context.enclosingDeclaration = oldEnclosingDecl;
            }
            function serializeInterface(symbol, symbolName, modifierFlags) {
              var interfaceType = getDeclaredTypeOfClassOrInterface(symbol);
              var localParams = getLocalTypeParametersOfClassOrInterfaceOrTypeAlias(symbol);
              var typeParamDecls = ts3.map(localParams, function(p) {
                return typeParameterToDeclaration(p, context);
              });
              var baseTypes = getBaseTypes(interfaceType);
              var baseType = ts3.length(baseTypes) ? getIntersectionType(baseTypes) : void 0;
              var members = ts3.flatMap(getPropertiesOfType(interfaceType), function(p) {
                return serializePropertySymbolForInterface(p, baseType);
              });
              var callSignatures = serializeSignatures(0, interfaceType, baseType, 170);
              var constructSignatures = serializeSignatures(1, interfaceType, baseType, 171);
              var indexSignatures = serializeIndexSignatures(interfaceType, baseType);
              var heritageClauses = !ts3.length(baseTypes) ? void 0 : [ts3.factory.createHeritageClause(93, ts3.mapDefined(baseTypes, function(b2) {
                return trySerializeAsTypeReference(b2, 111551);
              }))];
              addResult(ts3.factory.createInterfaceDeclaration(void 0, void 0, getInternalSymbolName(symbol, symbolName), typeParamDecls, heritageClauses, __spreadArray(__spreadArray(__spreadArray(__spreadArray([], indexSignatures), constructSignatures), callSignatures), members)), modifierFlags);
            }
            function getNamespaceMembersForSerialization(symbol) {
              return !symbol.exports ? [] : ts3.filter(ts3.arrayFrom(symbol.exports.values()), isNamespaceMember);
            }
            function isTypeOnlyNamespace(symbol) {
              return ts3.every(getNamespaceMembersForSerialization(symbol), function(m) {
                return !(resolveSymbol(m).flags & 111551);
              });
            }
            function serializeModule(symbol, symbolName, modifierFlags) {
              var members = getNamespaceMembersForSerialization(symbol);
              var locationMap = ts3.arrayToMultiMap(members, function(m) {
                return m.parent && m.parent === symbol ? "real" : "merged";
              });
              var realMembers = locationMap.get("real") || ts3.emptyArray;
              var mergedMembers = locationMap.get("merged") || ts3.emptyArray;
              if (ts3.length(realMembers)) {
                var localName = getInternalSymbolName(symbol, symbolName);
                serializeAsNamespaceDeclaration(realMembers, localName, modifierFlags, !!(symbol.flags & (16 | 67108864)));
              }
              if (ts3.length(mergedMembers)) {
                var containingFile_1 = ts3.getSourceFileOfNode(context.enclosingDeclaration);
                var localName = getInternalSymbolName(symbol, symbolName);
                var nsBody = ts3.factory.createModuleBlock([ts3.factory.createExportDeclaration(void 0, void 0, false, ts3.factory.createNamedExports(ts3.mapDefined(ts3.filter(mergedMembers, function(n2) {
                  return n2.escapedName !== "export=";
                }), function(s2) {
                  var _a2, _b;
                  var name = ts3.unescapeLeadingUnderscores(s2.escapedName);
                  var localName2 = getInternalSymbolName(s2, name);
                  var aliasDecl = s2.declarations && getDeclarationOfAliasSymbol(s2);
                  if (containingFile_1 && (aliasDecl ? containingFile_1 !== ts3.getSourceFileOfNode(aliasDecl) : !ts3.some(s2.declarations, function(d) {
                    return ts3.getSourceFileOfNode(d) === containingFile_1;
                  }))) {
                    (_b = (_a2 = context.tracker) === null || _a2 === void 0 ? void 0 : _a2.reportNonlocalAugmentation) === null || _b === void 0 ? void 0 : _b.call(_a2, containingFile_1, symbol, s2);
                    return void 0;
                  }
                  var target = aliasDecl && getTargetOfAliasDeclaration(aliasDecl, true);
                  includePrivateSymbol(target || s2);
                  var targetName = target ? getInternalSymbolName(target, ts3.unescapeLeadingUnderscores(target.escapedName)) : localName2;
                  return ts3.factory.createExportSpecifier(name === targetName ? void 0 : targetName, name);
                })))]);
                addResult(ts3.factory.createModuleDeclaration(void 0, void 0, ts3.factory.createIdentifier(localName), nsBody, 16), 0);
              }
            }
            function serializeEnum(symbol, symbolName, modifierFlags) {
              addResult(ts3.factory.createEnumDeclaration(void 0, ts3.factory.createModifiersFromModifierFlags(isConstEnumSymbol(symbol) ? 2048 : 0), getInternalSymbolName(symbol, symbolName), ts3.map(ts3.filter(getPropertiesOfType(getTypeOfSymbol(symbol)), function(p) {
                return !!(p.flags & 8);
              }), function(p) {
                var initializedValue = p.declarations && p.declarations[0] && ts3.isEnumMember(p.declarations[0]) ? getConstantValue(p.declarations[0]) : void 0;
                return ts3.factory.createEnumMember(ts3.unescapeLeadingUnderscores(p.escapedName), initializedValue === void 0 ? void 0 : typeof initializedValue === "string" ? ts3.factory.createStringLiteral(initializedValue) : ts3.factory.createNumericLiteral(initializedValue));
              })), modifierFlags);
            }
            function serializeAsFunctionNamespaceMerge(type3, symbol, localName, modifierFlags) {
              var signatures = getSignaturesOfType(type3, 0);
              for (var _i = 0, signatures_2 = signatures; _i < signatures_2.length; _i++) {
                var sig = signatures_2[_i];
                var decl = signatureToSignatureDeclarationHelper(sig, 252, context, { name: ts3.factory.createIdentifier(localName), privateSymbolVisitor: includePrivateSymbol, bundledImports: bundled });
                addResult(ts3.setTextRange(decl, getSignatureTextRangeLocation(sig)), modifierFlags);
              }
              if (!(symbol.flags & (512 | 1024) && !!symbol.exports && !!symbol.exports.size)) {
                var props = ts3.filter(getPropertiesOfType(type3), isNamespaceMember);
                serializeAsNamespaceDeclaration(props, localName, modifierFlags, true);
              }
            }
            function getSignatureTextRangeLocation(signature) {
              if (signature.declaration && signature.declaration.parent) {
                if (ts3.isBinaryExpression(signature.declaration.parent) && ts3.getAssignmentDeclarationKind(signature.declaration.parent) === 5) {
                  return signature.declaration.parent;
                }
                if (ts3.isVariableDeclaration(signature.declaration.parent) && signature.declaration.parent.parent) {
                  return signature.declaration.parent.parent;
                }
              }
              return signature.declaration;
            }
            function serializeAsNamespaceDeclaration(props, localName, modifierFlags, suppressNewPrivateContext) {
              if (ts3.length(props)) {
                var localVsRemoteMap = ts3.arrayToMultiMap(props, function(p) {
                  return !ts3.length(p.declarations) || ts3.some(p.declarations, function(d) {
                    return ts3.getSourceFileOfNode(d) === ts3.getSourceFileOfNode(context.enclosingDeclaration);
                  }) ? "local" : "remote";
                });
                var localProps = localVsRemoteMap.get("local") || ts3.emptyArray;
                var fakespace = ts3.parseNodeFactory.createModuleDeclaration(void 0, void 0, ts3.factory.createIdentifier(localName), ts3.factory.createModuleBlock([]), 16);
                ts3.setParent(fakespace, enclosingDeclaration);
                fakespace.locals = ts3.createSymbolTable(props);
                fakespace.symbol = props[0].parent;
                var oldResults = results;
                results = [];
                var oldAddingDeclare = addingDeclare;
                addingDeclare = false;
                var subcontext = __assign(__assign({}, context), { enclosingDeclaration: fakespace });
                var oldContext = context;
                context = subcontext;
                visitSymbolTable(ts3.createSymbolTable(localProps), suppressNewPrivateContext, true);
                context = oldContext;
                addingDeclare = oldAddingDeclare;
                var declarations = results;
                results = oldResults;
                var defaultReplaced = ts3.map(declarations, function(d) {
                  return ts3.isExportAssignment(d) && !d.isExportEquals && ts3.isIdentifier(d.expression) ? ts3.factory.createExportDeclaration(void 0, void 0, false, ts3.factory.createNamedExports([ts3.factory.createExportSpecifier(d.expression, ts3.factory.createIdentifier("default"))])) : d;
                });
                var exportModifierStripped = ts3.every(defaultReplaced, function(d) {
                  return ts3.hasSyntacticModifier(d, 1);
                }) ? ts3.map(defaultReplaced, removeExportModifier) : defaultReplaced;
                fakespace = ts3.factory.updateModuleDeclaration(fakespace, fakespace.decorators, fakespace.modifiers, fakespace.name, ts3.factory.createModuleBlock(exportModifierStripped));
                addResult(fakespace, modifierFlags);
              }
            }
            function isNamespaceMember(p) {
              return !!(p.flags & (788968 | 1920 | 2097152)) || !(p.flags & 4194304 || p.escapedName === "prototype" || p.valueDeclaration && ts3.getEffectiveModifierFlags(p.valueDeclaration) & 32 && ts3.isClassLike(p.valueDeclaration.parent));
            }
            function sanitizeJSDocImplements(clauses) {
              var result2 = ts3.mapDefined(clauses, function(e2) {
                var _a2;
                var oldEnclosing = context.enclosingDeclaration;
                context.enclosingDeclaration = e2;
                var expr = e2.expression;
                if (ts3.isEntityNameExpression(expr)) {
                  if (ts3.isIdentifier(expr) && ts3.idText(expr) === "") {
                    return cleanup(void 0);
                  }
                  var introducesError = void 0;
                  _a2 = trackExistingEntityName(expr, context, includePrivateSymbol), introducesError = _a2.introducesError, expr = _a2.node;
                  if (introducesError) {
                    return cleanup(void 0);
                  }
                }
                return cleanup(ts3.factory.createExpressionWithTypeArguments(expr, ts3.map(e2.typeArguments, function(a2) {
                  return serializeExistingTypeNode(context, a2, includePrivateSymbol, bundled) || typeToTypeNodeHelper(getTypeFromTypeNode(a2), context);
                })));
                function cleanup(result3) {
                  context.enclosingDeclaration = oldEnclosing;
                  return result3;
                }
              });
              if (result2.length === clauses.length) {
                return result2;
              }
              return void 0;
            }
            function serializeAsClass(symbol, localName, modifierFlags) {
              var _a2, _b;
              var originalDecl = (_a2 = symbol.declarations) === null || _a2 === void 0 ? void 0 : _a2.find(ts3.isClassLike);
              var oldEnclosing = context.enclosingDeclaration;
              context.enclosingDeclaration = originalDecl || oldEnclosing;
              var localParams = getLocalTypeParametersOfClassOrInterfaceOrTypeAlias(symbol);
              var typeParamDecls = ts3.map(localParams, function(p) {
                return typeParameterToDeclaration(p, context);
              });
              var classType = getDeclaredTypeOfClassOrInterface(symbol);
              var baseTypes = getBaseTypes(classType);
              var originalImplements = originalDecl && ts3.getEffectiveImplementsTypeNodes(originalDecl);
              var implementsExpressions = originalImplements && sanitizeJSDocImplements(originalImplements) || ts3.mapDefined(getImplementsTypes(classType), serializeImplementedType);
              var staticType = getTypeOfSymbol(symbol);
              var isClass = !!((_b = staticType.symbol) === null || _b === void 0 ? void 0 : _b.valueDeclaration) && ts3.isClassLike(staticType.symbol.valueDeclaration);
              var staticBaseType = isClass ? getBaseConstructorTypeOfClass(staticType) : anyType;
              var heritageClauses = __spreadArray(__spreadArray([], !ts3.length(baseTypes) ? [] : [ts3.factory.createHeritageClause(93, ts3.map(baseTypes, function(b2) {
                return serializeBaseType(b2, staticBaseType, localName);
              }))]), !ts3.length(implementsExpressions) ? [] : [ts3.factory.createHeritageClause(116, implementsExpressions)]);
              var symbolProps = getNonInterhitedProperties(classType, baseTypes, getPropertiesOfType(classType));
              var publicSymbolProps = ts3.filter(symbolProps, function(s2) {
                var valueDecl = s2.valueDeclaration;
                return !!valueDecl && !(ts3.isNamedDeclaration(valueDecl) && ts3.isPrivateIdentifier(valueDecl.name));
              });
              var hasPrivateIdentifier = ts3.some(symbolProps, function(s2) {
                var valueDecl = s2.valueDeclaration;
                return !!valueDecl && ts3.isNamedDeclaration(valueDecl) && ts3.isPrivateIdentifier(valueDecl.name);
              });
              var privateProperties = hasPrivateIdentifier ? [ts3.factory.createPropertyDeclaration(void 0, void 0, ts3.factory.createPrivateIdentifier("#private"), void 0, void 0, void 0)] : ts3.emptyArray;
              var publicProperties = ts3.flatMap(publicSymbolProps, function(p) {
                return serializePropertySymbolForClass(p, false, baseTypes[0]);
              });
              var staticMembers = ts3.flatMap(ts3.filter(getPropertiesOfType(staticType), function(p) {
                return !(p.flags & 4194304) && p.escapedName !== "prototype" && !isNamespaceMember(p);
              }), function(p) {
                return serializePropertySymbolForClass(p, true, staticBaseType);
              });
              var isNonConstructableClassLikeInJsFile = !isClass && !!symbol.valueDeclaration && ts3.isInJSFile(symbol.valueDeclaration) && !ts3.some(getSignaturesOfType(staticType, 1));
              var constructors = isNonConstructableClassLikeInJsFile ? [ts3.factory.createConstructorDeclaration(void 0, ts3.factory.createModifiersFromModifierFlags(8), [], void 0)] : serializeSignatures(1, staticType, staticBaseType, 167);
              var indexSignatures = serializeIndexSignatures(classType, baseTypes[0]);
              context.enclosingDeclaration = oldEnclosing;
              addResult(ts3.setTextRange(ts3.factory.createClassDeclaration(void 0, void 0, localName, typeParamDecls, heritageClauses, __spreadArray(__spreadArray(__spreadArray(__spreadArray(__spreadArray([], indexSignatures), staticMembers), constructors), publicProperties), privateProperties)), symbol.declarations && ts3.filter(symbol.declarations, function(d) {
                return ts3.isClassDeclaration(d) || ts3.isClassExpression(d);
              })[0]), modifierFlags);
            }
            function serializeAsAlias(symbol, localName, modifierFlags) {
              var _a2, _b, _c, _d, _e;
              var node = getDeclarationOfAliasSymbol(symbol);
              if (!node)
                return ts3.Debug.fail();
              var target = getMergedSymbol(getTargetOfAliasDeclaration(node, true));
              if (!target) {
                return;
              }
              var verbatimTargetName = ts3.unescapeLeadingUnderscores(target.escapedName);
              if (verbatimTargetName === "export=" && (compilerOptions.esModuleInterop || compilerOptions.allowSyntheticDefaultImports)) {
                verbatimTargetName = "default";
              }
              var targetName = getInternalSymbolName(target, verbatimTargetName);
              includePrivateSymbol(target);
              switch (node.kind) {
                case 199:
                  if (((_b = (_a2 = node.parent) === null || _a2 === void 0 ? void 0 : _a2.parent) === null || _b === void 0 ? void 0 : _b.kind) === 250) {
                    var specifier_1 = getSpecifierForModuleSymbol(target.parent || target, context);
                    var propertyName = node.propertyName;
                    addResult(ts3.factory.createImportDeclaration(void 0, void 0, ts3.factory.createImportClause(false, void 0, ts3.factory.createNamedImports([ts3.factory.createImportSpecifier(propertyName && ts3.isIdentifier(propertyName) ? ts3.factory.createIdentifier(ts3.idText(propertyName)) : void 0, ts3.factory.createIdentifier(localName))])), ts3.factory.createStringLiteral(specifier_1)), 0);
                    break;
                  }
                  ts3.Debug.failBadSyntaxKind(((_c = node.parent) === null || _c === void 0 ? void 0 : _c.parent) || node, "Unhandled binding element grandparent kind in declaration serialization");
                  break;
                case 290:
                  if (((_e = (_d = node.parent) === null || _d === void 0 ? void 0 : _d.parent) === null || _e === void 0 ? void 0 : _e.kind) === 217) {
                    serializeExportSpecifier(ts3.unescapeLeadingUnderscores(symbol.escapedName), targetName);
                  }
                  break;
                case 250:
                  if (ts3.isPropertyAccessExpression(node.initializer)) {
                    var initializer = node.initializer;
                    var uniqueName = ts3.factory.createUniqueName(localName);
                    var specifier_2 = getSpecifierForModuleSymbol(target.parent || target, context);
                    addResult(ts3.factory.createImportEqualsDeclaration(void 0, void 0, false, uniqueName, ts3.factory.createExternalModuleReference(ts3.factory.createStringLiteral(specifier_2))), 0);
                    addResult(ts3.factory.createImportEqualsDeclaration(void 0, void 0, false, ts3.factory.createIdentifier(localName), ts3.factory.createQualifiedName(uniqueName, initializer.name)), modifierFlags);
                    break;
                  }
                case 261:
                  if (target.escapedName === "export=" && ts3.some(target.declarations, ts3.isJsonSourceFile)) {
                    serializeMaybeAliasAssignment(symbol);
                    break;
                  }
                  var isLocalImport = !(target.flags & 512) && !ts3.isVariableDeclaration(node);
                  addResult(ts3.factory.createImportEqualsDeclaration(void 0, void 0, false, ts3.factory.createIdentifier(localName), isLocalImport ? symbolToName(target, context, 67108863, false) : ts3.factory.createExternalModuleReference(ts3.factory.createStringLiteral(getSpecifierForModuleSymbol(target, context)))), isLocalImport ? modifierFlags : 0);
                  break;
                case 260:
                  addResult(ts3.factory.createNamespaceExportDeclaration(ts3.idText(node.name)), 0);
                  break;
                case 263:
                  addResult(ts3.factory.createImportDeclaration(void 0, void 0, ts3.factory.createImportClause(false, ts3.factory.createIdentifier(localName), void 0), ts3.factory.createStringLiteral(getSpecifierForModuleSymbol(target.parent || target, context))), 0);
                  break;
                case 264:
                  addResult(ts3.factory.createImportDeclaration(void 0, void 0, ts3.factory.createImportClause(false, void 0, ts3.factory.createNamespaceImport(ts3.factory.createIdentifier(localName))), ts3.factory.createStringLiteral(getSpecifierForModuleSymbol(target, context))), 0);
                  break;
                case 270:
                  addResult(ts3.factory.createExportDeclaration(void 0, void 0, false, ts3.factory.createNamespaceExport(ts3.factory.createIdentifier(localName)), ts3.factory.createStringLiteral(getSpecifierForModuleSymbol(target, context))), 0);
                  break;
                case 266:
                  addResult(ts3.factory.createImportDeclaration(void 0, void 0, ts3.factory.createImportClause(false, void 0, ts3.factory.createNamedImports([
                    ts3.factory.createImportSpecifier(localName !== verbatimTargetName ? ts3.factory.createIdentifier(verbatimTargetName) : void 0, ts3.factory.createIdentifier(localName))
                  ])), ts3.factory.createStringLiteral(getSpecifierForModuleSymbol(target.parent || target, context))), 0);
                  break;
                case 271:
                  var specifier = node.parent.parent.moduleSpecifier;
                  serializeExportSpecifier(ts3.unescapeLeadingUnderscores(symbol.escapedName), specifier ? verbatimTargetName : targetName, specifier && ts3.isStringLiteralLike(specifier) ? ts3.factory.createStringLiteral(specifier.text) : void 0);
                  break;
                case 267:
                  serializeMaybeAliasAssignment(symbol);
                  break;
                case 217:
                case 202:
                case 203:
                  if (symbol.escapedName === "default" || symbol.escapedName === "export=") {
                    serializeMaybeAliasAssignment(symbol);
                  } else {
                    serializeExportSpecifier(localName, targetName);
                  }
                  break;
                default:
                  return ts3.Debug.failBadSyntaxKind(node, "Unhandled alias declaration kind in symbol serializer!");
              }
            }
            function serializeExportSpecifier(localName, targetName, specifier) {
              addResult(ts3.factory.createExportDeclaration(void 0, void 0, false, ts3.factory.createNamedExports([ts3.factory.createExportSpecifier(localName !== targetName ? targetName : void 0, localName)]), specifier), 0);
            }
            function serializeMaybeAliasAssignment(symbol) {
              if (symbol.flags & 4194304) {
                return false;
              }
              var name = ts3.unescapeLeadingUnderscores(symbol.escapedName);
              var isExportEquals = name === "export=";
              var isDefault = name === "default";
              var isExportAssignmentCompatibleSymbolName = isExportEquals || isDefault;
              var aliasDecl = symbol.declarations && getDeclarationOfAliasSymbol(symbol);
              var target = aliasDecl && getTargetOfAliasDeclaration(aliasDecl, true);
              if (target && ts3.length(target.declarations) && ts3.some(target.declarations, function(d) {
                return ts3.getSourceFileOfNode(d) === ts3.getSourceFileOfNode(enclosingDeclaration);
              })) {
                var expr = aliasDecl && (ts3.isExportAssignment(aliasDecl) || ts3.isBinaryExpression(aliasDecl) ? ts3.getExportAssignmentExpression(aliasDecl) : ts3.getPropertyAssignmentAliasLikeExpression(aliasDecl));
                var first_1 = expr && ts3.isEntityNameExpression(expr) ? getFirstNonModuleExportsIdentifier(expr) : void 0;
                var referenced = first_1 && resolveEntityName(first_1, 67108863, true, true, enclosingDeclaration);
                if (referenced || target) {
                  includePrivateSymbol(referenced || target);
                }
                var oldTrack = context.tracker.trackSymbol;
                context.tracker.trackSymbol = ts3.noop;
                if (isExportAssignmentCompatibleSymbolName) {
                  results.push(ts3.factory.createExportAssignment(void 0, void 0, isExportEquals, symbolToExpression(target, context, 67108863)));
                } else {
                  if (first_1 === expr && first_1) {
                    serializeExportSpecifier(name, ts3.idText(first_1));
                  } else if (expr && ts3.isClassExpression(expr)) {
                    serializeExportSpecifier(name, getInternalSymbolName(target, ts3.symbolName(target)));
                  } else {
                    var varName = getUnusedName(name, symbol);
                    addResult(ts3.factory.createImportEqualsDeclaration(void 0, void 0, false, ts3.factory.createIdentifier(varName), symbolToName(target, context, 67108863, false)), 0);
                    serializeExportSpecifier(name, varName);
                  }
                }
                context.tracker.trackSymbol = oldTrack;
                return true;
              } else {
                var varName = getUnusedName(name, symbol);
                var typeToSerialize = getWidenedType(getTypeOfSymbol(getMergedSymbol(symbol)));
                if (isTypeRepresentableAsFunctionNamespaceMerge(typeToSerialize, symbol)) {
                  serializeAsFunctionNamespaceMerge(typeToSerialize, symbol, varName, isExportAssignmentCompatibleSymbolName ? 0 : 1);
                } else {
                  var statement = ts3.factory.createVariableStatement(void 0, ts3.factory.createVariableDeclarationList([
                    ts3.factory.createVariableDeclaration(varName, void 0, serializeTypeForDeclaration(context, typeToSerialize, symbol, enclosingDeclaration, includePrivateSymbol, bundled))
                  ], 2));
                  addResult(statement, target && target.flags & 4 && target.escapedName === "export=" ? 2 : name === varName ? 1 : 0);
                }
                if (isExportAssignmentCompatibleSymbolName) {
                  results.push(ts3.factory.createExportAssignment(void 0, void 0, isExportEquals, ts3.factory.createIdentifier(varName)));
                  return true;
                } else if (name !== varName) {
                  serializeExportSpecifier(name, varName);
                  return true;
                }
                return false;
              }
            }
            function isTypeRepresentableAsFunctionNamespaceMerge(typeToSerialize, hostSymbol) {
              var ctxSrc = ts3.getSourceFileOfNode(context.enclosingDeclaration);
              return ts3.getObjectFlags(typeToSerialize) & (16 | 32) && !getIndexInfoOfType(typeToSerialize, 0) && !getIndexInfoOfType(typeToSerialize, 1) && !isClassInstanceSide(typeToSerialize) && !!(ts3.length(ts3.filter(getPropertiesOfType(typeToSerialize), isNamespaceMember)) || ts3.length(getSignaturesOfType(typeToSerialize, 0))) && !ts3.length(getSignaturesOfType(typeToSerialize, 1)) && !getDeclarationWithTypeAnnotation(hostSymbol, enclosingDeclaration) && !(typeToSerialize.symbol && ts3.some(typeToSerialize.symbol.declarations, function(d) {
                return ts3.getSourceFileOfNode(d) !== ctxSrc;
              })) && !ts3.some(getPropertiesOfType(typeToSerialize), function(p) {
                return isLateBoundName(p.escapedName);
              }) && !ts3.some(getPropertiesOfType(typeToSerialize), function(p) {
                return ts3.some(p.declarations, function(d) {
                  return ts3.getSourceFileOfNode(d) !== ctxSrc;
                });
              }) && ts3.every(getPropertiesOfType(typeToSerialize), function(p) {
                return ts3.isIdentifierText(ts3.symbolName(p), languageVersion);
              });
            }
            function makeSerializePropertySymbol(createProperty, methodKind, useAccessors) {
              return function serializePropertySymbol(p, isStatic, baseType) {
                var _a2, _b, _c, _d, _e;
                var modifierFlags = ts3.getDeclarationModifierFlagsFromSymbol(p);
                var isPrivate = !!(modifierFlags & 8);
                if (isStatic && p.flags & (788968 | 1920 | 2097152)) {
                  return [];
                }
                if (p.flags & 4194304 || baseType && getPropertyOfType(baseType, p.escapedName) && isReadonlySymbol(getPropertyOfType(baseType, p.escapedName)) === isReadonlySymbol(p) && (p.flags & 16777216) === (getPropertyOfType(baseType, p.escapedName).flags & 16777216) && isTypeIdenticalTo(getTypeOfSymbol(p), getTypeOfPropertyOfType(baseType, p.escapedName))) {
                  return [];
                }
                var flag = modifierFlags & ~256 | (isStatic ? 32 : 0);
                var name = getPropertyNameNodeForSymbol(p, context);
                var firstPropertyLikeDecl = (_a2 = p.declarations) === null || _a2 === void 0 ? void 0 : _a2.find(ts3.or(ts3.isPropertyDeclaration, ts3.isAccessor, ts3.isVariableDeclaration, ts3.isPropertySignature, ts3.isBinaryExpression, ts3.isPropertyAccessExpression));
                if (p.flags & 98304 && useAccessors) {
                  var result2 = [];
                  if (p.flags & 65536) {
                    result2.push(ts3.setTextRange(ts3.factory.createSetAccessorDeclaration(void 0, ts3.factory.createModifiersFromModifierFlags(flag), name, [ts3.factory.createParameterDeclaration(void 0, void 0, void 0, "arg", void 0, isPrivate ? void 0 : serializeTypeForDeclaration(context, getTypeOfSymbol(p), p, enclosingDeclaration, includePrivateSymbol, bundled))], void 0), ((_b = p.declarations) === null || _b === void 0 ? void 0 : _b.find(ts3.isSetAccessor)) || firstPropertyLikeDecl));
                  }
                  if (p.flags & 32768) {
                    var isPrivate_1 = modifierFlags & 8;
                    result2.push(ts3.setTextRange(ts3.factory.createGetAccessorDeclaration(void 0, ts3.factory.createModifiersFromModifierFlags(flag), name, [], isPrivate_1 ? void 0 : serializeTypeForDeclaration(context, getTypeOfSymbol(p), p, enclosingDeclaration, includePrivateSymbol, bundled), void 0), ((_c = p.declarations) === null || _c === void 0 ? void 0 : _c.find(ts3.isGetAccessor)) || firstPropertyLikeDecl));
                  }
                  return result2;
                } else if (p.flags & (4 | 3 | 98304)) {
                  return ts3.setTextRange(createProperty(void 0, ts3.factory.createModifiersFromModifierFlags((isReadonlySymbol(p) ? 64 : 0) | flag), name, p.flags & 16777216 ? ts3.factory.createToken(57) : void 0, isPrivate ? void 0 : serializeTypeForDeclaration(context, getTypeOfSymbol(p), p, enclosingDeclaration, includePrivateSymbol, bundled), void 0), ((_d = p.declarations) === null || _d === void 0 ? void 0 : _d.find(ts3.or(ts3.isPropertyDeclaration, ts3.isVariableDeclaration))) || firstPropertyLikeDecl);
                }
                if (p.flags & (8192 | 16)) {
                  var type3 = getTypeOfSymbol(p);
                  var signatures = getSignaturesOfType(type3, 0);
                  if (flag & 8) {
                    return ts3.setTextRange(createProperty(void 0, ts3.factory.createModifiersFromModifierFlags((isReadonlySymbol(p) ? 64 : 0) | flag), name, p.flags & 16777216 ? ts3.factory.createToken(57) : void 0, void 0, void 0), ((_e = p.declarations) === null || _e === void 0 ? void 0 : _e.find(ts3.isFunctionLikeDeclaration)) || signatures[0] && signatures[0].declaration || p.declarations && p.declarations[0]);
                  }
                  var results_1 = [];
                  for (var _i = 0, signatures_3 = signatures; _i < signatures_3.length; _i++) {
                    var sig = signatures_3[_i];
                    var decl = signatureToSignatureDeclarationHelper(sig, methodKind, context, {
                      name,
                      questionToken: p.flags & 16777216 ? ts3.factory.createToken(57) : void 0,
                      modifiers: flag ? ts3.factory.createModifiersFromModifierFlags(flag) : void 0
                    });
                    var location = sig.declaration && ts3.isPrototypePropertyAssignment(sig.declaration.parent) ? sig.declaration.parent : sig.declaration;
                    results_1.push(ts3.setTextRange(decl, location));
                  }
                  return results_1;
                }
                return ts3.Debug.fail("Unhandled class member kind! " + (p.__debugFlags || p.flags));
              };
            }
            function serializePropertySymbolForInterface(p, baseType) {
              return serializePropertySymbolForInterfaceWorker(p, false, baseType);
            }
            function serializeSignatures(kind, input, baseType, outputKind) {
              var signatures = getSignaturesOfType(input, kind);
              if (kind === 1) {
                if (!baseType && ts3.every(signatures, function(s3) {
                  return ts3.length(s3.parameters) === 0;
                })) {
                  return [];
                }
                if (baseType) {
                  var baseSigs = getSignaturesOfType(baseType, 1);
                  if (!ts3.length(baseSigs) && ts3.every(signatures, function(s3) {
                    return ts3.length(s3.parameters) === 0;
                  })) {
                    return [];
                  }
                  if (baseSigs.length === signatures.length) {
                    var failed = false;
                    for (var i3 = 0; i3 < baseSigs.length; i3++) {
                      if (!compareSignaturesIdentical(signatures[i3], baseSigs[i3], false, false, true, compareTypesIdentical)) {
                        failed = true;
                        break;
                      }
                    }
                    if (!failed) {
                      return [];
                    }
                  }
                }
                var privateProtected = 0;
                for (var _i = 0, signatures_4 = signatures; _i < signatures_4.length; _i++) {
                  var s2 = signatures_4[_i];
                  if (s2.declaration) {
                    privateProtected |= ts3.getSelectedEffectiveModifierFlags(s2.declaration, 8 | 16);
                  }
                }
                if (privateProtected) {
                  return [ts3.setTextRange(ts3.factory.createConstructorDeclaration(void 0, ts3.factory.createModifiersFromModifierFlags(privateProtected), [], void 0), signatures[0].declaration)];
                }
              }
              var results2 = [];
              for (var _a2 = 0, signatures_5 = signatures; _a2 < signatures_5.length; _a2++) {
                var sig = signatures_5[_a2];
                var decl = signatureToSignatureDeclarationHelper(sig, outputKind, context);
                results2.push(ts3.setTextRange(decl, sig.declaration));
              }
              return results2;
            }
            function serializeIndexSignatures(input, baseType) {
              var results2 = [];
              for (var _i = 0, _a2 = [0, 1]; _i < _a2.length; _i++) {
                var type3 = _a2[_i];
                var info = getIndexInfoOfType(input, type3);
                if (info) {
                  if (baseType) {
                    var baseInfo = getIndexInfoOfType(baseType, type3);
                    if (baseInfo) {
                      if (isTypeIdenticalTo(info.type, baseInfo.type)) {
                        continue;
                      }
                    }
                  }
                  results2.push(indexInfoToIndexSignatureDeclarationHelper(info, type3, context, void 0));
                }
              }
              return results2;
            }
            function serializeBaseType(t2, staticType, rootName) {
              var ref2 = trySerializeAsTypeReference(t2, 111551);
              if (ref2) {
                return ref2;
              }
              var tempName = getUnusedName(rootName + "_base");
              var statement = ts3.factory.createVariableStatement(void 0, ts3.factory.createVariableDeclarationList([
                ts3.factory.createVariableDeclaration(tempName, void 0, typeToTypeNodeHelper(staticType, context))
              ], 2));
              addResult(statement, 0);
              return ts3.factory.createExpressionWithTypeArguments(ts3.factory.createIdentifier(tempName), void 0);
            }
            function trySerializeAsTypeReference(t2, flags) {
              var typeArgs;
              var reference;
              if (t2.target && isSymbolAccessibleByFlags(t2.target.symbol, enclosingDeclaration, flags)) {
                typeArgs = ts3.map(getTypeArguments(t2), function(t3) {
                  return typeToTypeNodeHelper(t3, context);
                });
                reference = symbolToExpression(t2.target.symbol, context, 788968);
              } else if (t2.symbol && isSymbolAccessibleByFlags(t2.symbol, enclosingDeclaration, flags)) {
                reference = symbolToExpression(t2.symbol, context, 788968);
              }
              if (reference) {
                return ts3.factory.createExpressionWithTypeArguments(reference, typeArgs);
              }
            }
            function serializeImplementedType(t2) {
              var ref2 = trySerializeAsTypeReference(t2, 788968);
              if (ref2) {
                return ref2;
              }
              if (t2.symbol) {
                return ts3.factory.createExpressionWithTypeArguments(symbolToExpression(t2.symbol, context, 788968), void 0);
              }
            }
            function getUnusedName(input, symbol) {
              var _a2, _b;
              var id = symbol ? getSymbolId(symbol) : void 0;
              if (id) {
                if (context.remappedSymbolNames.has(id)) {
                  return context.remappedSymbolNames.get(id);
                }
              }
              if (symbol) {
                input = getNameCandidateWorker(symbol, input);
              }
              var i3 = 0;
              var original = input;
              while ((_a2 = context.usedSymbolNames) === null || _a2 === void 0 ? void 0 : _a2.has(input)) {
                i3++;
                input = original + "_" + i3;
              }
              (_b = context.usedSymbolNames) === null || _b === void 0 ? void 0 : _b.add(input);
              if (id) {
                context.remappedSymbolNames.set(id, input);
              }
              return input;
            }
            function getNameCandidateWorker(symbol, localName) {
              if (localName === "default" || localName === "__class" || localName === "__function") {
                var flags = context.flags;
                context.flags |= 16777216;
                var nameCandidate = getNameOfSymbolAsWritten(symbol, context);
                context.flags = flags;
                localName = nameCandidate.length > 0 && ts3.isSingleOrDoubleQuote(nameCandidate.charCodeAt(0)) ? ts3.stripQuotes(nameCandidate) : nameCandidate;
              }
              if (localName === "default") {
                localName = "_default";
              } else if (localName === "export=") {
                localName = "_exports";
              }
              localName = ts3.isIdentifierText(localName, languageVersion) && !ts3.isStringANonContextualKeyword(localName) ? localName : "_" + localName.replace(/[^a-zA-Z0-9]/g, "_");
              return localName;
            }
            function getInternalSymbolName(symbol, localName) {
              var id = getSymbolId(symbol);
              if (context.remappedSymbolNames.has(id)) {
                return context.remappedSymbolNames.get(id);
              }
              localName = getNameCandidateWorker(symbol, localName);
              context.remappedSymbolNames.set(id, localName);
              return localName;
            }
          }
        }
        function typePredicateToString(typePredicate, enclosingDeclaration, flags, writer) {
          if (flags === void 0) {
            flags = 16384;
          }
          return writer ? typePredicateToStringWorker(writer).getText() : ts3.usingSingleLineStringWriter(typePredicateToStringWorker);
          function typePredicateToStringWorker(writer2) {
            var predicate = ts3.factory.createTypePredicateNode(typePredicate.kind === 2 || typePredicate.kind === 3 ? ts3.factory.createToken(127) : void 0, typePredicate.kind === 1 || typePredicate.kind === 3 ? ts3.factory.createIdentifier(typePredicate.parameterName) : ts3.factory.createThisTypeNode(), typePredicate.type && nodeBuilder.typeToTypeNode(typePredicate.type, enclosingDeclaration, toNodeBuilderFlags(flags) | 70221824 | 512));
            var printer2 = ts3.createPrinter({ removeComments: true });
            var sourceFile = enclosingDeclaration && ts3.getSourceFileOfNode(enclosingDeclaration);
            printer2.writeNode(4, predicate, sourceFile, writer2);
            return writer2;
          }
        }
        function formatUnionTypes(types2) {
          var result2 = [];
          var flags = 0;
          for (var i3 = 0; i3 < types2.length; i3++) {
            var t2 = types2[i3];
            flags |= t2.flags;
            if (!(t2.flags & 98304)) {
              if (t2.flags & (512 | 1024)) {
                var baseType = t2.flags & 512 ? booleanType : getBaseTypeOfEnumLiteralType(t2);
                if (baseType.flags & 1048576) {
                  var count = baseType.types.length;
                  if (i3 + count <= types2.length && getRegularTypeOfLiteralType(types2[i3 + count - 1]) === getRegularTypeOfLiteralType(baseType.types[count - 1])) {
                    result2.push(baseType);
                    i3 += count - 1;
                    continue;
                  }
                }
              }
              result2.push(t2);
            }
          }
          if (flags & 65536)
            result2.push(nullType);
          if (flags & 32768)
            result2.push(undefinedType);
          return result2 || types2;
        }
        function visibilityToString(flags) {
          if (flags === 8) {
            return "private";
          }
          if (flags === 16) {
            return "protected";
          }
          return "public";
        }
        function getTypeAliasForTypeLiteral(type3) {
          if (type3.symbol && type3.symbol.flags & 2048 && type3.symbol.declarations) {
            var node = ts3.walkUpParenthesizedTypes(type3.symbol.declarations[0].parent);
            if (node.kind === 255) {
              return getSymbolOfNode(node);
            }
          }
          return void 0;
        }
        function isTopLevelInExternalModuleAugmentation(node) {
          return node && node.parent && node.parent.kind === 258 && ts3.isExternalModuleAugmentation(node.parent.parent);
        }
        function isDefaultBindingContext(location) {
          return location.kind === 298 || ts3.isAmbientModule(location);
        }
        function getNameOfSymbolFromNameType(symbol, context) {
          var nameType = getSymbolLinks(symbol).nameType;
          if (nameType) {
            if (nameType.flags & 384) {
              var name = "" + nameType.value;
              if (!ts3.isIdentifierText(name, compilerOptions.target) && !isNumericLiteralName(name)) {
                return '"' + ts3.escapeString(name, 34) + '"';
              }
              if (isNumericLiteralName(name) && ts3.startsWith(name, "-")) {
                return "[" + name + "]";
              }
              return name;
            }
            if (nameType.flags & 8192) {
              return "[" + getNameOfSymbolAsWritten(nameType.symbol, context) + "]";
            }
          }
        }
        function getNameOfSymbolAsWritten(symbol, context) {
          if (context && symbol.escapedName === "default" && !(context.flags & 16384) && (!(context.flags & 16777216) || !symbol.declarations || context.enclosingDeclaration && ts3.findAncestor(symbol.declarations[0], isDefaultBindingContext) !== ts3.findAncestor(context.enclosingDeclaration, isDefaultBindingContext))) {
            return "default";
          }
          if (symbol.declarations && symbol.declarations.length) {
            var declaration = ts3.firstDefined(symbol.declarations, function(d) {
              return ts3.getNameOfDeclaration(d) ? d : void 0;
            });
            var name_3 = declaration && ts3.getNameOfDeclaration(declaration);
            if (declaration && name_3) {
              if (ts3.isCallExpression(declaration) && ts3.isBindableObjectDefinePropertyCall(declaration)) {
                return ts3.symbolName(symbol);
              }
              if (ts3.isComputedPropertyName(name_3) && !(ts3.getCheckFlags(symbol) & 4096)) {
                var nameType = getSymbolLinks(symbol).nameType;
                if (nameType && nameType.flags & 384) {
                  var result2 = getNameOfSymbolFromNameType(symbol, context);
                  if (result2 !== void 0) {
                    return result2;
                  }
                }
              }
              return ts3.declarationNameToString(name_3);
            }
            if (!declaration) {
              declaration = symbol.declarations[0];
            }
            if (declaration.parent && declaration.parent.kind === 250) {
              return ts3.declarationNameToString(declaration.parent.name);
            }
            switch (declaration.kind) {
              case 222:
              case 209:
              case 210:
                if (context && !context.encounteredError && !(context.flags & 131072)) {
                  context.encounteredError = true;
                }
                return declaration.kind === 222 ? "(Anonymous class)" : "(Anonymous function)";
            }
          }
          var name = getNameOfSymbolFromNameType(symbol, context);
          return name !== void 0 ? name : ts3.symbolName(symbol);
        }
        function isDeclarationVisible(node) {
          if (node) {
            var links = getNodeLinks(node);
            if (links.isVisible === void 0) {
              links.isVisible = !!determineIfDeclarationIsVisible();
            }
            return links.isVisible;
          }
          return false;
          function determineIfDeclarationIsVisible() {
            switch (node.kind) {
              case 328:
              case 335:
              case 329:
                return !!(node.parent && node.parent.parent && node.parent.parent.parent && ts3.isSourceFile(node.parent.parent.parent));
              case 199:
                return isDeclarationVisible(node.parent.parent);
              case 250:
                if (ts3.isBindingPattern(node.name) && !node.name.elements.length) {
                  return false;
                }
              case 257:
              case 253:
              case 254:
              case 255:
              case 252:
              case 256:
              case 261:
                if (ts3.isExternalModuleAugmentation(node)) {
                  return true;
                }
                var parent = getDeclarationContainer(node);
                if (!(ts3.getCombinedModifierFlags(node) & 1) && !(node.kind !== 261 && parent.kind !== 298 && parent.flags & 8388608)) {
                  return isGlobalSourceFile(parent);
                }
                return isDeclarationVisible(parent);
              case 164:
              case 163:
              case 168:
              case 169:
              case 166:
              case 165:
                if (ts3.hasEffectiveModifier(node, 8 | 16)) {
                  return false;
                }
              case 167:
              case 171:
              case 170:
              case 172:
              case 161:
              case 258:
              case 175:
              case 176:
              case 178:
              case 174:
              case 179:
              case 180:
              case 183:
              case 184:
              case 187:
              case 193:
                return isDeclarationVisible(node.parent);
              case 263:
              case 264:
              case 266:
                return false;
              case 160:
              case 298:
              case 260:
                return true;
              case 267:
                return false;
              default:
                return false;
            }
          }
        }
        function collectLinkedAliases(node, setVisibility) {
          var exportSymbol;
          if (node.parent && node.parent.kind === 267) {
            exportSymbol = resolveName(node, node.escapedText, 111551 | 788968 | 1920 | 2097152, void 0, node, false);
          } else if (node.parent.kind === 271) {
            exportSymbol = getTargetOfExportSpecifier(node.parent, 111551 | 788968 | 1920 | 2097152);
          }
          var result2;
          var visited;
          if (exportSymbol) {
            visited = new ts3.Set();
            visited.add(getSymbolId(exportSymbol));
            buildVisibleNodeList(exportSymbol.declarations);
          }
          return result2;
          function buildVisibleNodeList(declarations) {
            ts3.forEach(declarations, function(declaration) {
              var resultNode = getAnyImportSyntax(declaration) || declaration;
              if (setVisibility) {
                getNodeLinks(declaration).isVisible = true;
              } else {
                result2 = result2 || [];
                ts3.pushIfUnique(result2, resultNode);
              }
              if (ts3.isInternalModuleImportEqualsDeclaration(declaration)) {
                var internalModuleReference = declaration.moduleReference;
                var firstIdentifier = ts3.getFirstIdentifier(internalModuleReference);
                var importSymbol = resolveName(declaration, firstIdentifier.escapedText, 111551 | 788968 | 1920, void 0, void 0, false);
                if (importSymbol && visited) {
                  if (ts3.tryAddToSet(visited, getSymbolId(importSymbol))) {
                    buildVisibleNodeList(importSymbol.declarations);
                  }
                }
              }
            });
          }
        }
        function pushTypeResolution(target, propertyName) {
          var resolutionCycleStartIndex = findResolutionCycleStartIndex(target, propertyName);
          if (resolutionCycleStartIndex >= 0) {
            var length_3 = resolutionTargets.length;
            for (var i3 = resolutionCycleStartIndex; i3 < length_3; i3++) {
              resolutionResults[i3] = false;
            }
            return false;
          }
          resolutionTargets.push(target);
          resolutionResults.push(true);
          resolutionPropertyNames.push(propertyName);
          return true;
        }
        function findResolutionCycleStartIndex(target, propertyName) {
          for (var i3 = resolutionTargets.length - 1; i3 >= 0; i3--) {
            if (hasType(resolutionTargets[i3], resolutionPropertyNames[i3])) {
              return -1;
            }
            if (resolutionTargets[i3] === target && resolutionPropertyNames[i3] === propertyName) {
              return i3;
            }
          }
          return -1;
        }
        function hasType(target, propertyName) {
          switch (propertyName) {
            case 0:
              return !!getSymbolLinks(target).type;
            case 5:
              return !!getNodeLinks(target).resolvedEnumType;
            case 2:
              return !!getSymbolLinks(target).declaredType;
            case 1:
              return !!target.resolvedBaseConstructorType;
            case 3:
              return !!target.resolvedReturnType;
            case 4:
              return !!target.immediateBaseConstraint;
            case 6:
              return !!target.resolvedTypeArguments;
            case 7:
              return !!target.baseTypesResolved;
          }
          return ts3.Debug.assertNever(propertyName);
        }
        function popTypeResolution() {
          resolutionTargets.pop();
          resolutionPropertyNames.pop();
          return resolutionResults.pop();
        }
        function getDeclarationContainer(node) {
          return ts3.findAncestor(ts3.getRootDeclaration(node), function(node2) {
            switch (node2.kind) {
              case 250:
              case 251:
              case 266:
              case 265:
              case 264:
              case 263:
                return false;
              default:
                return true;
            }
          }).parent;
        }
        function getTypeOfPrototypeProperty(prototype) {
          var classType = getDeclaredTypeOfSymbol(getParentOfSymbol(prototype));
          return classType.typeParameters ? createTypeReference(classType, ts3.map(classType.typeParameters, function(_) {
            return anyType;
          })) : classType;
        }
        function getTypeOfPropertyOfType(type3, name) {
          var prop = getPropertyOfType(type3, name);
          return prop ? getTypeOfSymbol(prop) : void 0;
        }
        function getTypeOfPropertyOrIndexSignature(type3, name) {
          return getTypeOfPropertyOfType(type3, name) || isNumericLiteralName(name) && getIndexTypeOfType(type3, 1) || getIndexTypeOfType(type3, 0) || unknownType;
        }
        function isTypeAny(type3) {
          return type3 && (type3.flags & 1) !== 0;
        }
        function getTypeForBindingElementParent(node) {
          var symbol = getSymbolOfNode(node);
          return symbol && getSymbolLinks(symbol).type || getTypeForVariableLikeDeclaration(node, false);
        }
        function getRestType(source, properties, symbol) {
          source = filterType(source, function(t2) {
            return !(t2.flags & 98304);
          });
          if (source.flags & 131072) {
            return emptyObjectType;
          }
          if (source.flags & 1048576) {
            return mapType(source, function(t2) {
              return getRestType(t2, properties, symbol);
            });
          }
          var omitKeyType = getUnionType(ts3.map(properties, getLiteralTypeFromPropertyName));
          if (isGenericObjectType(source) || isGenericIndexType(omitKeyType)) {
            if (omitKeyType.flags & 131072) {
              return source;
            }
            var omitTypeAlias = getGlobalOmitSymbol();
            if (!omitTypeAlias) {
              return errorType;
            }
            return getTypeAliasInstantiation(omitTypeAlias, [source, omitKeyType]);
          }
          var members = ts3.createSymbolTable();
          for (var _i = 0, _a2 = getPropertiesOfType(source); _i < _a2.length; _i++) {
            var prop = _a2[_i];
            if (!isTypeAssignableTo(getLiteralTypeFromProperty(prop, 8576), omitKeyType) && !(ts3.getDeclarationModifierFlagsFromSymbol(prop) & (8 | 16)) && isSpreadableProperty(prop)) {
              members.set(prop.escapedName, getSpreadSymbol(prop, false));
            }
          }
          var stringIndexInfo = getIndexInfoOfType(source, 0);
          var numberIndexInfo = getIndexInfoOfType(source, 1);
          var result2 = createAnonymousType(symbol, members, ts3.emptyArray, ts3.emptyArray, stringIndexInfo, numberIndexInfo);
          result2.objectFlags |= 8388608;
          return result2;
        }
        function isGenericTypeWithUndefinedConstraint(type3) {
          return !!(type3.flags & 465829888) && maybeTypeOfKind(getBaseConstraintOfType(type3) || unknownType, 32768);
        }
        function getNonUndefinedType(type3) {
          var typeOrConstraint = someType(type3, isGenericTypeWithUndefinedConstraint) ? mapType(type3, function(t2) {
            return t2.flags & 465829888 ? getBaseConstraintOrType(t2) : t2;
          }) : type3;
          return getTypeWithFacts(typeOrConstraint, 524288);
        }
        function getFlowTypeOfDestructuring(node, declaredType) {
          var reference = getSyntheticElementAccess(node);
          return reference ? getFlowTypeOfReference(reference, declaredType) : declaredType;
        }
        function getSyntheticElementAccess(node) {
          var parentAccess = getParentElementAccess(node);
          if (parentAccess && parentAccess.flowNode) {
            var propName = getDestructuringPropertyName(node);
            if (propName) {
              var literal = ts3.setTextRange(ts3.parseNodeFactory.createStringLiteral(propName), node);
              var lhsExpr = ts3.isLeftHandSideExpression(parentAccess) ? parentAccess : ts3.parseNodeFactory.createParenthesizedExpression(parentAccess);
              var result2 = ts3.setTextRange(ts3.parseNodeFactory.createElementAccessExpression(lhsExpr, literal), node);
              ts3.setParent(literal, result2);
              ts3.setParent(result2, node);
              if (lhsExpr !== parentAccess) {
                ts3.setParent(lhsExpr, result2);
              }
              result2.flowNode = parentAccess.flowNode;
              return result2;
            }
          }
        }
        function getParentElementAccess(node) {
          var ancestor = node.parent.parent;
          switch (ancestor.kind) {
            case 199:
            case 289:
              return getSyntheticElementAccess(ancestor);
            case 200:
              return getSyntheticElementAccess(node.parent);
            case 250:
              return ancestor.initializer;
            case 217:
              return ancestor.right;
          }
        }
        function getDestructuringPropertyName(node) {
          var parent = node.parent;
          if (node.kind === 199 && parent.kind === 197) {
            return getLiteralPropertyNameText(node.propertyName || node.name);
          }
          if (node.kind === 289 || node.kind === 290) {
            return getLiteralPropertyNameText(node.name);
          }
          return "" + parent.elements.indexOf(node);
        }
        function getLiteralPropertyNameText(name) {
          var type3 = getLiteralTypeFromPropertyName(name);
          return type3.flags & (128 | 256) ? "" + type3.value : void 0;
        }
        function getTypeForBindingElement(declaration) {
          var pattern = declaration.parent;
          var parentType = getTypeForBindingElementParent(pattern.parent);
          if (!parentType || isTypeAny(parentType)) {
            return parentType;
          }
          if (strictNullChecks && declaration.flags & 8388608 && ts3.isParameterDeclaration(declaration)) {
            parentType = getNonNullableType(parentType);
          } else if (strictNullChecks && pattern.parent.initializer && !(getTypeFacts(getTypeOfInitializer(pattern.parent.initializer)) & 65536)) {
            parentType = getTypeWithFacts(parentType, 524288);
          }
          var type3;
          if (pattern.kind === 197) {
            if (declaration.dotDotDotToken) {
              parentType = getReducedType(parentType);
              if (parentType.flags & 2 || !isValidSpreadType(parentType)) {
                error(declaration, ts3.Diagnostics.Rest_types_may_only_be_created_from_object_types);
                return errorType;
              }
              var literalMembers = [];
              for (var _i = 0, _a2 = pattern.elements; _i < _a2.length; _i++) {
                var element = _a2[_i];
                if (!element.dotDotDotToken) {
                  literalMembers.push(element.propertyName || element.name);
                }
              }
              type3 = getRestType(parentType, literalMembers, declaration.symbol);
            } else {
              var name = declaration.propertyName || declaration.name;
              var indexType = getLiteralTypeFromPropertyName(name);
              var declaredType = getIndexedAccessType(parentType, indexType, void 0, name, void 0, void 0, 16);
              type3 = getFlowTypeOfDestructuring(declaration, declaredType);
            }
          } else {
            var elementType = checkIteratedTypeOrElementType(65 | (declaration.dotDotDotToken ? 0 : 128), parentType, undefinedType, pattern);
            var index_2 = pattern.elements.indexOf(declaration);
            if (declaration.dotDotDotToken) {
              type3 = everyType(parentType, isTupleType) ? mapType(parentType, function(t2) {
                return sliceTupleType(t2, index_2);
              }) : createArrayType(elementType);
            } else if (isArrayLikeType(parentType)) {
              var indexType = getLiteralType(index_2);
              var accessFlags = hasDefaultValue(declaration) ? 8 : 0;
              var declaredType = getIndexedAccessTypeOrUndefined(parentType, indexType, void 0, declaration.name, accessFlags | 16) || errorType;
              type3 = getFlowTypeOfDestructuring(declaration, declaredType);
            } else {
              type3 = elementType;
            }
          }
          if (!declaration.initializer) {
            return type3;
          }
          if (ts3.getEffectiveTypeAnnotationNode(ts3.walkUpBindingElementsAndPatterns(declaration))) {
            return strictNullChecks && !(getFalsyFlags(checkDeclarationInitializer(declaration)) & 32768) ? getNonUndefinedType(type3) : type3;
          }
          return widenTypeInferredFromInitializer(declaration, getUnionType([getNonUndefinedType(type3), checkDeclarationInitializer(declaration)], 2));
        }
        function getTypeForDeclarationFromJSDocComment(declaration) {
          var jsdocType = ts3.getJSDocType(declaration);
          if (jsdocType) {
            return getTypeFromTypeNode(jsdocType);
          }
          return void 0;
        }
        function isNullOrUndefined(node) {
          var expr = ts3.skipParentheses(node);
          return expr.kind === 103 || expr.kind === 78 && getResolvedSymbol(expr) === undefinedSymbol;
        }
        function isEmptyArrayLiteral(node) {
          var expr = ts3.skipParentheses(node);
          return expr.kind === 200 && expr.elements.length === 0;
        }
        function addOptionality(type3, optional) {
          if (optional === void 0) {
            optional = true;
          }
          return strictNullChecks && optional ? getOptionalType(type3) : type3;
        }
        function getTypeForVariableLikeDeclaration(declaration, includeOptionality) {
          if (ts3.isVariableDeclaration(declaration) && declaration.parent.parent.kind === 239) {
            var indexType = getIndexType(getNonNullableTypeIfNeeded(checkExpression(declaration.parent.parent.expression)));
            return indexType.flags & (262144 | 4194304) ? getExtractStringType(indexType) : stringType;
          }
          if (ts3.isVariableDeclaration(declaration) && declaration.parent.parent.kind === 240) {
            var forOfStatement = declaration.parent.parent;
            return checkRightHandSideOfForOf(forOfStatement) || anyType;
          }
          if (ts3.isBindingPattern(declaration.parent)) {
            return getTypeForBindingElement(declaration);
          }
          var isOptional = includeOptionality && (ts3.isParameter(declaration) && isJSDocOptionalParameter(declaration) || isOptionalJSDocPropertyLikeTag(declaration) || !ts3.isBindingElement(declaration) && !ts3.isVariableDeclaration(declaration) && !!declaration.questionToken);
          var declaredType = tryGetTypeFromEffectiveTypeNode(declaration);
          if (declaredType) {
            return addOptionality(declaredType, isOptional);
          }
          if ((noImplicitAny || ts3.isInJSFile(declaration)) && ts3.isVariableDeclaration(declaration) && !ts3.isBindingPattern(declaration.name) && !(ts3.getCombinedModifierFlags(declaration) & 1) && !(declaration.flags & 8388608)) {
            if (!(ts3.getCombinedNodeFlags(declaration) & 2) && (!declaration.initializer || isNullOrUndefined(declaration.initializer))) {
              return autoType;
            }
            if (declaration.initializer && isEmptyArrayLiteral(declaration.initializer)) {
              return autoArrayType;
            }
          }
          if (ts3.isParameter(declaration)) {
            var func2 = declaration.parent;
            if (func2.kind === 169 && hasBindableName(func2)) {
              var getter = ts3.getDeclarationOfKind(getSymbolOfNode(declaration.parent), 168);
              if (getter) {
                var getterSignature = getSignatureFromDeclaration(getter);
                var thisParameter = getAccessorThisParameter(func2);
                if (thisParameter && declaration === thisParameter) {
                  ts3.Debug.assert(!thisParameter.type);
                  return getTypeOfSymbol(getterSignature.thisParameter);
                }
                return getReturnTypeOfSignature(getterSignature);
              }
            }
            if (ts3.isInJSFile(declaration)) {
              var typeTag = ts3.getJSDocType(func2);
              if (typeTag && ts3.isFunctionTypeNode(typeTag)) {
                var signature = getSignatureFromDeclaration(typeTag);
                var pos = func2.parameters.indexOf(declaration);
                return declaration.dotDotDotToken ? getRestTypeAtPosition(signature, pos) : getTypeAtPosition(signature, pos);
              }
            }
            var type3 = declaration.symbol.escapedName === "this" ? getContextualThisParameterType(func2) : getContextuallyTypedParameterType(declaration);
            if (type3) {
              return addOptionality(type3, isOptional);
            }
          }
          if (ts3.hasOnlyExpressionInitializer(declaration) && !!declaration.initializer) {
            if (ts3.isInJSFile(declaration) && !ts3.isParameter(declaration)) {
              var containerObjectType = getJSContainerObjectType(declaration, getSymbolOfNode(declaration), ts3.getDeclaredExpandoInitializer(declaration));
              if (containerObjectType) {
                return containerObjectType;
              }
            }
            var type3 = widenTypeInferredFromInitializer(declaration, checkDeclarationInitializer(declaration));
            return addOptionality(type3, isOptional);
          }
          if (ts3.isPropertyDeclaration(declaration) && !ts3.hasStaticModifier(declaration) && (noImplicitAny || ts3.isInJSFile(declaration))) {
            var constructor = findConstructorDeclaration(declaration.parent);
            var type3 = constructor ? getFlowTypeInConstructor(declaration.symbol, constructor) : ts3.getEffectiveModifierFlags(declaration) & 2 ? getTypeOfPropertyInBaseClass(declaration.symbol) : void 0;
            return type3 && addOptionality(type3, isOptional);
          }
          if (ts3.isJsxAttribute(declaration)) {
            return trueType;
          }
          if (ts3.isBindingPattern(declaration.name)) {
            return getTypeFromBindingPattern(declaration.name, false, true);
          }
          return void 0;
        }
        function isConstructorDeclaredProperty(symbol) {
          if (symbol.valueDeclaration && ts3.isBinaryExpression(symbol.valueDeclaration)) {
            var links = getSymbolLinks(symbol);
            if (links.isConstructorDeclaredProperty === void 0) {
              links.isConstructorDeclaredProperty = false;
              links.isConstructorDeclaredProperty = !!getDeclaringConstructor(symbol) && ts3.every(symbol.declarations, function(declaration) {
                return ts3.isBinaryExpression(declaration) && isPossiblyAliasedThisProperty(declaration) && (declaration.left.kind !== 203 || ts3.isStringOrNumericLiteralLike(declaration.left.argumentExpression)) && !getAnnotatedTypeForAssignmentDeclaration(void 0, declaration, symbol, declaration);
              });
            }
            return links.isConstructorDeclaredProperty;
          }
          return false;
        }
        function isAutoTypedProperty(symbol) {
          var declaration = symbol.valueDeclaration;
          return declaration && ts3.isPropertyDeclaration(declaration) && !ts3.getEffectiveTypeAnnotationNode(declaration) && !declaration.initializer && (noImplicitAny || ts3.isInJSFile(declaration));
        }
        function getDeclaringConstructor(symbol) {
          if (!symbol.declarations) {
            return;
          }
          for (var _i = 0, _a2 = symbol.declarations; _i < _a2.length; _i++) {
            var declaration = _a2[_i];
            var container = ts3.getThisContainer(declaration, false);
            if (container && (container.kind === 167 || isJSConstructor(container))) {
              return container;
            }
          }
          ;
        }
        function getFlowTypeFromCommonJSExport(symbol) {
          var file = ts3.getSourceFileOfNode(symbol.declarations[0]);
          var accessName = ts3.unescapeLeadingUnderscores(symbol.escapedName);
          var areAllModuleExports = symbol.declarations.every(function(d) {
            return ts3.isInJSFile(d) && ts3.isAccessExpression(d) && ts3.isModuleExportsAccessExpression(d.expression);
          });
          var reference = areAllModuleExports ? ts3.factory.createPropertyAccessExpression(ts3.factory.createPropertyAccessExpression(ts3.factory.createIdentifier("module"), ts3.factory.createIdentifier("exports")), accessName) : ts3.factory.createPropertyAccessExpression(ts3.factory.createIdentifier("exports"), accessName);
          if (areAllModuleExports) {
            ts3.setParent(reference.expression.expression, reference.expression);
          }
          ts3.setParent(reference.expression, reference);
          ts3.setParent(reference, file);
          reference.flowNode = file.endFlowNode;
          return getFlowTypeOfReference(reference, autoType, undefinedType);
        }
        function getFlowTypeInConstructor(symbol, constructor) {
          var accessName = ts3.startsWith(symbol.escapedName, "__#") ? ts3.factory.createPrivateIdentifier(symbol.escapedName.split("@")[1]) : ts3.unescapeLeadingUnderscores(symbol.escapedName);
          var reference = ts3.factory.createPropertyAccessExpression(ts3.factory.createThis(), accessName);
          ts3.setParent(reference.expression, reference);
          ts3.setParent(reference, constructor);
          reference.flowNode = constructor.returnFlowNode;
          var flowType = getFlowTypeOfProperty(reference, symbol);
          if (noImplicitAny && (flowType === autoType || flowType === autoArrayType)) {
            error(symbol.valueDeclaration, ts3.Diagnostics.Member_0_implicitly_has_an_1_type, symbolToString(symbol), typeToString(flowType));
          }
          return everyType(flowType, isNullableType) ? void 0 : convertAutoToAny(flowType);
        }
        function getFlowTypeOfProperty(reference, prop) {
          var initialType = (prop === null || prop === void 0 ? void 0 : prop.valueDeclaration) && (!isAutoTypedProperty(prop) || ts3.getEffectiveModifierFlags(prop.valueDeclaration) & 2) && getTypeOfPropertyInBaseClass(prop) || undefinedType;
          return getFlowTypeOfReference(reference, autoType, initialType);
        }
        function getWidenedTypeForAssignmentDeclaration(symbol, resolvedSymbol) {
          var container = ts3.getAssignedExpandoInitializer(symbol.valueDeclaration);
          if (container) {
            var tag = ts3.getJSDocTypeTag(container);
            if (tag && tag.typeExpression) {
              return getTypeFromTypeNode(tag.typeExpression);
            }
            var containerObjectType = symbol.valueDeclaration && getJSContainerObjectType(symbol.valueDeclaration, symbol, container);
            return containerObjectType || getWidenedLiteralType(checkExpressionCached(container));
          }
          var type3;
          var definedInConstructor = false;
          var definedInMethod = false;
          if (isConstructorDeclaredProperty(symbol)) {
            type3 = getFlowTypeInConstructor(symbol, getDeclaringConstructor(symbol));
          }
          if (!type3) {
            var types2 = void 0;
            if (symbol.declarations) {
              var jsdocType = void 0;
              for (var _i = 0, _a2 = symbol.declarations; _i < _a2.length; _i++) {
                var declaration = _a2[_i];
                var expression = ts3.isBinaryExpression(declaration) || ts3.isCallExpression(declaration) ? declaration : ts3.isAccessExpression(declaration) ? ts3.isBinaryExpression(declaration.parent) ? declaration.parent : declaration : void 0;
                if (!expression) {
                  continue;
                }
                var kind = ts3.isAccessExpression(expression) ? ts3.getAssignmentDeclarationPropertyAccessKind(expression) : ts3.getAssignmentDeclarationKind(expression);
                if (kind === 4 || ts3.isBinaryExpression(expression) && isPossiblyAliasedThisProperty(expression, kind)) {
                  if (isDeclarationInConstructor(expression)) {
                    definedInConstructor = true;
                  } else {
                    definedInMethod = true;
                  }
                }
                if (!ts3.isCallExpression(expression)) {
                  jsdocType = getAnnotatedTypeForAssignmentDeclaration(jsdocType, expression, symbol, declaration);
                }
                if (!jsdocType) {
                  (types2 || (types2 = [])).push(ts3.isBinaryExpression(expression) || ts3.isCallExpression(expression) ? getInitializerTypeFromAssignmentDeclaration(symbol, resolvedSymbol, expression, kind) : neverType);
                }
              }
              type3 = jsdocType;
            }
            if (!type3) {
              if (!ts3.length(types2)) {
                return errorType;
              }
              var constructorTypes = definedInConstructor && symbol.declarations ? getConstructorDefinedThisAssignmentTypes(types2, symbol.declarations) : void 0;
              if (definedInMethod) {
                var propType = getTypeOfPropertyInBaseClass(symbol);
                if (propType) {
                  (constructorTypes || (constructorTypes = [])).push(propType);
                  definedInConstructor = true;
                }
              }
              var sourceTypes = ts3.some(constructorTypes, function(t2) {
                return !!(t2.flags & ~98304);
              }) ? constructorTypes : types2;
              type3 = getUnionType(sourceTypes, 2);
            }
          }
          var widened = getWidenedType(addOptionality(type3, definedInMethod && !definedInConstructor));
          if (symbol.valueDeclaration && filterType(widened, function(t2) {
            return !!(t2.flags & ~98304);
          }) === neverType) {
            reportImplicitAny(symbol.valueDeclaration, anyType);
            return anyType;
          }
          return widened;
        }
        function getJSContainerObjectType(decl, symbol, init) {
          var _a2, _b;
          if (!ts3.isInJSFile(decl) || !init || !ts3.isObjectLiteralExpression(init) || init.properties.length) {
            return void 0;
          }
          var exports3 = ts3.createSymbolTable();
          while (ts3.isBinaryExpression(decl) || ts3.isPropertyAccessExpression(decl)) {
            var s_2 = getSymbolOfNode(decl);
            if ((_a2 = s_2 === null || s_2 === void 0 ? void 0 : s_2.exports) === null || _a2 === void 0 ? void 0 : _a2.size) {
              mergeSymbolTable(exports3, s_2.exports);
            }
            decl = ts3.isBinaryExpression(decl) ? decl.parent : decl.parent.parent;
          }
          var s2 = getSymbolOfNode(decl);
          if ((_b = s2 === null || s2 === void 0 ? void 0 : s2.exports) === null || _b === void 0 ? void 0 : _b.size) {
            mergeSymbolTable(exports3, s2.exports);
          }
          var type3 = createAnonymousType(symbol, exports3, ts3.emptyArray, ts3.emptyArray, void 0, void 0);
          type3.objectFlags |= 8192;
          return type3;
        }
        function getAnnotatedTypeForAssignmentDeclaration(declaredType, expression, symbol, declaration) {
          var _a2;
          var typeNode = ts3.getEffectiveTypeAnnotationNode(expression.parent);
          if (typeNode) {
            var type3 = getWidenedType(getTypeFromTypeNode(typeNode));
            if (!declaredType) {
              return type3;
            } else if (declaredType !== errorType && type3 !== errorType && !isTypeIdenticalTo(declaredType, type3)) {
              errorNextVariableOrPropertyDeclarationMustHaveSameType(void 0, declaredType, declaration, type3);
            }
          }
          if ((_a2 = symbol.parent) === null || _a2 === void 0 ? void 0 : _a2.valueDeclaration) {
            var typeNode_2 = ts3.getEffectiveTypeAnnotationNode(symbol.parent.valueDeclaration);
            if (typeNode_2) {
              return getTypeOfPropertyOfType(getTypeFromTypeNode(typeNode_2), symbol.escapedName);
            }
          }
          return declaredType;
        }
        function getInitializerTypeFromAssignmentDeclaration(symbol, resolvedSymbol, expression, kind) {
          if (ts3.isCallExpression(expression)) {
            if (resolvedSymbol) {
              return getTypeOfSymbol(resolvedSymbol);
            }
            var objectLitType = checkExpressionCached(expression.arguments[2]);
            var valueType = getTypeOfPropertyOfType(objectLitType, "value");
            if (valueType) {
              return valueType;
            }
            var getFunc = getTypeOfPropertyOfType(objectLitType, "get");
            if (getFunc) {
              var getSig = getSingleCallSignature(getFunc);
              if (getSig) {
                return getReturnTypeOfSignature(getSig);
              }
            }
            var setFunc = getTypeOfPropertyOfType(objectLitType, "set");
            if (setFunc) {
              var setSig = getSingleCallSignature(setFunc);
              if (setSig) {
                return getTypeOfFirstParameterOfSignature(setSig);
              }
            }
            return anyType;
          }
          if (containsSameNamedThisProperty(expression.left, expression.right)) {
            return anyType;
          }
          var type3 = resolvedSymbol ? getTypeOfSymbol(resolvedSymbol) : getWidenedLiteralType(checkExpressionCached(expression.right));
          if (type3.flags & 524288 && kind === 2 && symbol.escapedName === "export=") {
            var exportedType = resolveStructuredTypeMembers(type3);
            var members_4 = ts3.createSymbolTable();
            ts3.copyEntries(exportedType.members, members_4);
            var initialSize = members_4.size;
            if (resolvedSymbol && !resolvedSymbol.exports) {
              resolvedSymbol.exports = ts3.createSymbolTable();
            }
            (resolvedSymbol || symbol).exports.forEach(function(s2, name) {
              var _a2;
              var exportedMember = members_4.get(name);
              if (exportedMember && exportedMember !== s2) {
                if (s2.flags & 111551 && exportedMember.flags & 111551) {
                  if (s2.valueDeclaration && exportedMember.valueDeclaration && ts3.getSourceFileOfNode(s2.valueDeclaration) !== ts3.getSourceFileOfNode(exportedMember.valueDeclaration)) {
                    var unescapedName = ts3.unescapeLeadingUnderscores(s2.escapedName);
                    var exportedMemberName = ((_a2 = ts3.tryCast(exportedMember.valueDeclaration, ts3.isNamedDeclaration)) === null || _a2 === void 0 ? void 0 : _a2.name) || exportedMember.valueDeclaration;
                    ts3.addRelatedInfo(error(s2.valueDeclaration, ts3.Diagnostics.Duplicate_identifier_0, unescapedName), ts3.createDiagnosticForNode(exportedMemberName, ts3.Diagnostics._0_was_also_declared_here, unescapedName));
                    ts3.addRelatedInfo(error(exportedMemberName, ts3.Diagnostics.Duplicate_identifier_0, unescapedName), ts3.createDiagnosticForNode(s2.valueDeclaration, ts3.Diagnostics._0_was_also_declared_here, unescapedName));
                  }
                  var union = createSymbol(s2.flags | exportedMember.flags, name);
                  union.type = getUnionType([getTypeOfSymbol(s2), getTypeOfSymbol(exportedMember)]);
                  union.valueDeclaration = exportedMember.valueDeclaration;
                  union.declarations = ts3.concatenate(exportedMember.declarations, s2.declarations);
                  members_4.set(name, union);
                } else {
                  members_4.set(name, mergeSymbol(s2, exportedMember));
                }
              } else {
                members_4.set(name, s2);
              }
            });
            var result2 = createAnonymousType(initialSize !== members_4.size ? void 0 : exportedType.symbol, members_4, exportedType.callSignatures, exportedType.constructSignatures, exportedType.stringIndexInfo, exportedType.numberIndexInfo);
            result2.objectFlags |= ts3.getObjectFlags(type3) & 8192;
            if (result2.symbol && result2.symbol.flags & 32 && type3 === getDeclaredTypeOfClassOrInterface(result2.symbol)) {
              result2.objectFlags |= 16777216;
            }
            return result2;
          }
          if (isEmptyArrayLiteralType(type3)) {
            reportImplicitAny(expression, anyArrayType);
            return anyArrayType;
          }
          return type3;
        }
        function containsSameNamedThisProperty(thisProperty, expression) {
          return ts3.isPropertyAccessExpression(thisProperty) && thisProperty.expression.kind === 107 && ts3.forEachChildRecursively(expression, function(n2) {
            return isMatchingReference(thisProperty, n2);
          });
        }
        function isDeclarationInConstructor(expression) {
          var thisContainer = ts3.getThisContainer(expression, false);
          return thisContainer.kind === 167 || thisContainer.kind === 252 || thisContainer.kind === 209 && !ts3.isPrototypePropertyAssignment(thisContainer.parent);
        }
        function getConstructorDefinedThisAssignmentTypes(types2, declarations) {
          ts3.Debug.assert(types2.length === declarations.length);
          return types2.filter(function(_, i3) {
            var declaration = declarations[i3];
            var expression = ts3.isBinaryExpression(declaration) ? declaration : ts3.isBinaryExpression(declaration.parent) ? declaration.parent : void 0;
            return expression && isDeclarationInConstructor(expression);
          });
        }
        function getTypeFromBindingElement(element, includePatternInType, reportErrors) {
          if (element.initializer) {
            var contextualType = ts3.isBindingPattern(element.name) ? getTypeFromBindingPattern(element.name, true, false) : unknownType;
            return addOptionality(widenTypeInferredFromInitializer(element, checkDeclarationInitializer(element, contextualType)));
          }
          if (ts3.isBindingPattern(element.name)) {
            return getTypeFromBindingPattern(element.name, includePatternInType, reportErrors);
          }
          if (reportErrors && !declarationBelongsToPrivateAmbientMember(element)) {
            reportImplicitAny(element, anyType);
          }
          return includePatternInType ? nonInferrableAnyType : anyType;
        }
        function getTypeFromObjectBindingPattern(pattern, includePatternInType, reportErrors) {
          var members = ts3.createSymbolTable();
          var stringIndexInfo;
          var objectFlags = 128 | 262144;
          ts3.forEach(pattern.elements, function(e2) {
            var name = e2.propertyName || e2.name;
            if (e2.dotDotDotToken) {
              stringIndexInfo = createIndexInfo(anyType, false);
              return;
            }
            var exprType = getLiteralTypeFromPropertyName(name);
            if (!isTypeUsableAsPropertyName(exprType)) {
              objectFlags |= 512;
              return;
            }
            var text = getPropertyNameFromType(exprType);
            var flags = 4 | (e2.initializer ? 16777216 : 0);
            var symbol = createSymbol(flags, text);
            symbol.type = getTypeFromBindingElement(e2, includePatternInType, reportErrors);
            symbol.bindingElement = e2;
            members.set(symbol.escapedName, symbol);
          });
          var result2 = createAnonymousType(void 0, members, ts3.emptyArray, ts3.emptyArray, stringIndexInfo, void 0);
          result2.objectFlags |= objectFlags;
          if (includePatternInType) {
            result2.pattern = pattern;
            result2.objectFlags |= 262144;
          }
          return result2;
        }
        function getTypeFromArrayBindingPattern(pattern, includePatternInType, reportErrors) {
          var elements = pattern.elements;
          var lastElement = ts3.lastOrUndefined(elements);
          var restElement = lastElement && lastElement.kind === 199 && lastElement.dotDotDotToken ? lastElement : void 0;
          if (elements.length === 0 || elements.length === 1 && restElement) {
            return languageVersion >= 2 ? createIterableType(anyType) : anyArrayType;
          }
          var elementTypes = ts3.map(elements, function(e2) {
            return ts3.isOmittedExpression(e2) ? anyType : getTypeFromBindingElement(e2, includePatternInType, reportErrors);
          });
          var minLength = ts3.findLastIndex(elements, function(e2) {
            return !(e2 === restElement || ts3.isOmittedExpression(e2) || hasDefaultValue(e2));
          }, elements.length - 1) + 1;
          var elementFlags = ts3.map(elements, function(e2, i3) {
            return e2 === restElement ? 4 : i3 >= minLength ? 2 : 1;
          });
          var result2 = createTupleType(elementTypes, elementFlags);
          if (includePatternInType) {
            result2 = cloneTypeReference(result2);
            result2.pattern = pattern;
            result2.objectFlags |= 262144;
          }
          return result2;
        }
        function getTypeFromBindingPattern(pattern, includePatternInType, reportErrors) {
          if (includePatternInType === void 0) {
            includePatternInType = false;
          }
          if (reportErrors === void 0) {
            reportErrors = false;
          }
          return pattern.kind === 197 ? getTypeFromObjectBindingPattern(pattern, includePatternInType, reportErrors) : getTypeFromArrayBindingPattern(pattern, includePatternInType, reportErrors);
        }
        function getWidenedTypeForVariableLikeDeclaration(declaration, reportErrors) {
          return widenTypeForVariableLikeDeclaration(getTypeForVariableLikeDeclaration(declaration, true), declaration, reportErrors);
        }
        function isGlobalSymbolConstructor(node) {
          var symbol = getSymbolOfNode(node);
          var globalSymbol = getGlobalESSymbolConstructorTypeSymbol(false);
          return globalSymbol && symbol && symbol === globalSymbol;
        }
        function widenTypeForVariableLikeDeclaration(type3, declaration, reportErrors) {
          if (type3) {
            if (type3.flags & 4096 && isGlobalSymbolConstructor(declaration.parent)) {
              type3 = getESSymbolLikeTypeForNode(declaration);
            }
            if (reportErrors) {
              reportErrorsFromWidening(declaration, type3);
            }
            if (type3.flags & 8192 && (ts3.isBindingElement(declaration) || !declaration.type) && type3.symbol !== getSymbolOfNode(declaration)) {
              type3 = esSymbolType;
            }
            return getWidenedType(type3);
          }
          type3 = ts3.isParameter(declaration) && declaration.dotDotDotToken ? anyArrayType : anyType;
          if (reportErrors) {
            if (!declarationBelongsToPrivateAmbientMember(declaration)) {
              reportImplicitAny(declaration, type3);
            }
          }
          return type3;
        }
        function declarationBelongsToPrivateAmbientMember(declaration) {
          var root = ts3.getRootDeclaration(declaration);
          var memberDeclaration = root.kind === 161 ? root.parent : root;
          return isPrivateWithinAmbient(memberDeclaration);
        }
        function tryGetTypeFromEffectiveTypeNode(declaration) {
          var typeNode = ts3.getEffectiveTypeAnnotationNode(declaration);
          if (typeNode) {
            return getTypeFromTypeNode(typeNode);
          }
        }
        function getTypeOfVariableOrParameterOrProperty(symbol) {
          var links = getSymbolLinks(symbol);
          if (!links.type) {
            var type3 = getTypeOfVariableOrParameterOrPropertyWorker(symbol);
            if (!links.type) {
              links.type = type3;
            }
          }
          return links.type;
        }
        function getTypeOfVariableOrParameterOrPropertyWorker(symbol) {
          if (symbol.flags & 4194304) {
            return getTypeOfPrototypeProperty(symbol);
          }
          if (symbol === requireSymbol) {
            return anyType;
          }
          if (symbol.flags & 134217728 && symbol.valueDeclaration) {
            var fileSymbol = getSymbolOfNode(ts3.getSourceFileOfNode(symbol.valueDeclaration));
            var result2 = createSymbol(fileSymbol.flags, "exports");
            result2.declarations = fileSymbol.declarations ? fileSymbol.declarations.slice() : [];
            result2.parent = symbol;
            result2.target = fileSymbol;
            if (fileSymbol.valueDeclaration)
              result2.valueDeclaration = fileSymbol.valueDeclaration;
            if (fileSymbol.members)
              result2.members = new ts3.Map(fileSymbol.members);
            if (fileSymbol.exports)
              result2.exports = new ts3.Map(fileSymbol.exports);
            var members = ts3.createSymbolTable();
            members.set("exports", result2);
            return createAnonymousType(symbol, members, ts3.emptyArray, ts3.emptyArray, void 0, void 0);
          }
          ts3.Debug.assertIsDefined(symbol.valueDeclaration);
          var declaration = symbol.valueDeclaration;
          if (ts3.isCatchClauseVariableDeclarationOrBindingElement(declaration)) {
            var typeNode = ts3.getEffectiveTypeAnnotationNode(declaration);
            if (typeNode === void 0) {
              return anyType;
            }
            var type_1 = getTypeOfNode(typeNode);
            return isTypeAny(type_1) || type_1 === unknownType ? type_1 : errorType;
          }
          if (ts3.isSourceFile(declaration) && ts3.isJsonSourceFile(declaration)) {
            if (!declaration.statements.length) {
              return emptyObjectType;
            }
            return getWidenedType(getWidenedLiteralType(checkExpression(declaration.statements[0].expression)));
          }
          if (!pushTypeResolution(symbol, 0)) {
            if (symbol.flags & 512 && !(symbol.flags & 67108864)) {
              return getTypeOfFuncClassEnumModule(symbol);
            }
            return reportCircularityError(symbol);
          }
          var type3;
          if (declaration.kind === 267) {
            type3 = widenTypeForVariableLikeDeclaration(checkExpressionCached(declaration.expression), declaration);
          } else if (ts3.isBinaryExpression(declaration) || ts3.isInJSFile(declaration) && (ts3.isCallExpression(declaration) || (ts3.isPropertyAccessExpression(declaration) || ts3.isBindableStaticElementAccessExpression(declaration)) && ts3.isBinaryExpression(declaration.parent))) {
            type3 = getWidenedTypeForAssignmentDeclaration(symbol);
          } else if (ts3.isPropertyAccessExpression(declaration) || ts3.isElementAccessExpression(declaration) || ts3.isIdentifier(declaration) || ts3.isStringLiteralLike(declaration) || ts3.isNumericLiteral(declaration) || ts3.isClassDeclaration(declaration) || ts3.isFunctionDeclaration(declaration) || ts3.isMethodDeclaration(declaration) && !ts3.isObjectLiteralMethod(declaration) || ts3.isMethodSignature(declaration) || ts3.isSourceFile(declaration)) {
            if (symbol.flags & (16 | 8192 | 32 | 384 | 512)) {
              return getTypeOfFuncClassEnumModule(symbol);
            }
            type3 = ts3.isBinaryExpression(declaration.parent) ? getWidenedTypeForAssignmentDeclaration(symbol) : tryGetTypeFromEffectiveTypeNode(declaration) || anyType;
          } else if (ts3.isPropertyAssignment(declaration)) {
            type3 = tryGetTypeFromEffectiveTypeNode(declaration) || checkPropertyAssignment(declaration);
          } else if (ts3.isJsxAttribute(declaration)) {
            type3 = tryGetTypeFromEffectiveTypeNode(declaration) || checkJsxAttribute(declaration);
          } else if (ts3.isShorthandPropertyAssignment(declaration)) {
            type3 = tryGetTypeFromEffectiveTypeNode(declaration) || checkExpressionForMutableLocation(declaration.name, 0);
          } else if (ts3.isObjectLiteralMethod(declaration)) {
            type3 = tryGetTypeFromEffectiveTypeNode(declaration) || checkObjectLiteralMethod(declaration, 0);
          } else if (ts3.isParameter(declaration) || ts3.isPropertyDeclaration(declaration) || ts3.isPropertySignature(declaration) || ts3.isVariableDeclaration(declaration) || ts3.isBindingElement(declaration) || ts3.isJSDocPropertyLikeTag(declaration)) {
            type3 = getWidenedTypeForVariableLikeDeclaration(declaration, true);
          } else if (ts3.isEnumDeclaration(declaration)) {
            type3 = getTypeOfFuncClassEnumModule(symbol);
          } else if (ts3.isEnumMember(declaration)) {
            type3 = getTypeOfEnumMember(symbol);
          } else if (ts3.isAccessor(declaration)) {
            type3 = resolveTypeOfAccessors(symbol) || ts3.Debug.fail("Non-write accessor resolution must always produce a type");
          } else {
            return ts3.Debug.fail("Unhandled declaration kind! " + ts3.Debug.formatSyntaxKind(declaration.kind) + " for " + ts3.Debug.formatSymbol(symbol));
          }
          if (!popTypeResolution()) {
            if (symbol.flags & 512 && !(symbol.flags & 67108864)) {
              return getTypeOfFuncClassEnumModule(symbol);
            }
            return reportCircularityError(symbol);
          }
          return type3;
        }
        function getAnnotatedAccessorTypeNode(accessor) {
          if (accessor) {
            if (accessor.kind === 168) {
              var getterTypeAnnotation = ts3.getEffectiveReturnTypeNode(accessor);
              return getterTypeAnnotation;
            } else {
              var setterTypeAnnotation = ts3.getEffectiveSetAccessorTypeAnnotationNode(accessor);
              return setterTypeAnnotation;
            }
          }
          return void 0;
        }
        function getAnnotatedAccessorType(accessor) {
          var node = getAnnotatedAccessorTypeNode(accessor);
          return node && getTypeFromTypeNode(node);
        }
        function getAnnotatedAccessorThisParameter(accessor) {
          var parameter = getAccessorThisParameter(accessor);
          return parameter && parameter.symbol;
        }
        function getThisTypeOfDeclaration(declaration) {
          return getThisTypeOfSignature(getSignatureFromDeclaration(declaration));
        }
        function getTypeOfAccessors(symbol) {
          var links = getSymbolLinks(symbol);
          return links.type || (links.type = getTypeOfAccessorsWorker(symbol) || ts3.Debug.fail("Read type of accessor must always produce a type"));
        }
        function getTypeOfSetAccessor(symbol) {
          var links = getSymbolLinks(symbol);
          return links.writeType || (links.writeType = getTypeOfAccessorsWorker(symbol, true));
        }
        function getTypeOfAccessorsWorker(symbol, writing) {
          if (writing === void 0) {
            writing = false;
          }
          if (!pushTypeResolution(symbol, 0)) {
            return errorType;
          }
          var type3 = resolveTypeOfAccessors(symbol, writing);
          if (!popTypeResolution()) {
            type3 = anyType;
            if (noImplicitAny) {
              var getter = ts3.getDeclarationOfKind(symbol, 168);
              error(getter, ts3.Diagnostics._0_implicitly_has_return_type_any_because_it_does_not_have_a_return_type_annotation_and_is_referenced_directly_or_indirectly_in_one_of_its_return_expressions, symbolToString(symbol));
            }
          }
          return type3;
        }
        function resolveTypeOfAccessors(symbol, writing) {
          if (writing === void 0) {
            writing = false;
          }
          var getter = ts3.getDeclarationOfKind(symbol, 168);
          var setter = ts3.getDeclarationOfKind(symbol, 169);
          var setterType = getAnnotatedAccessorType(setter);
          if (writing && setterType) {
            return instantiateTypeIfNeeded(setterType, symbol);
          }
          if (getter && ts3.isInJSFile(getter)) {
            var jsDocType = getTypeForDeclarationFromJSDocComment(getter);
            if (jsDocType) {
              return instantiateTypeIfNeeded(jsDocType, symbol);
            }
          }
          var getterType = getAnnotatedAccessorType(getter);
          if (getterType) {
            return instantiateTypeIfNeeded(getterType, symbol);
          }
          if (setterType) {
            return setterType;
          }
          if (getter && getter.body) {
            var returnTypeFromBody = getReturnTypeFromBody(getter);
            return instantiateTypeIfNeeded(returnTypeFromBody, symbol);
          }
          if (setter) {
            if (!isPrivateWithinAmbient(setter)) {
              errorOrSuggestion(noImplicitAny, setter, ts3.Diagnostics.Property_0_implicitly_has_type_any_because_its_set_accessor_lacks_a_parameter_type_annotation, symbolToString(symbol));
            }
            return anyType;
          } else if (getter) {
            ts3.Debug.assert(!!getter, "there must exist a getter as we are current checking either setter or getter in this function");
            if (!isPrivateWithinAmbient(getter)) {
              errorOrSuggestion(noImplicitAny, getter, ts3.Diagnostics.Property_0_implicitly_has_type_any_because_its_get_accessor_lacks_a_return_type_annotation, symbolToString(symbol));
            }
            return anyType;
          }
          return void 0;
          function instantiateTypeIfNeeded(type3, symbol2) {
            if (ts3.getCheckFlags(symbol2) & 1) {
              var links = getSymbolLinks(symbol2);
              return instantiateType(type3, links.mapper);
            }
            return type3;
          }
        }
        function getBaseTypeVariableOfClass(symbol) {
          var baseConstructorType = getBaseConstructorTypeOfClass(getDeclaredTypeOfClassOrInterface(symbol));
          return baseConstructorType.flags & 8650752 ? baseConstructorType : baseConstructorType.flags & 2097152 ? ts3.find(baseConstructorType.types, function(t2) {
            return !!(t2.flags & 8650752);
          }) : void 0;
        }
        function getTypeOfFuncClassEnumModule(symbol) {
          var links = getSymbolLinks(symbol);
          var originalLinks = links;
          if (!links.type) {
            var expando = symbol.valueDeclaration && getSymbolOfExpando(symbol.valueDeclaration, false);
            if (expando) {
              var merged = mergeJSSymbols(symbol, expando);
              if (merged) {
                symbol = links = merged;
              }
            }
            originalLinks.type = links.type = getTypeOfFuncClassEnumModuleWorker(symbol);
          }
          return links.type;
        }
        function getTypeOfFuncClassEnumModuleWorker(symbol) {
          var declaration = symbol.valueDeclaration;
          if (symbol.flags & 1536 && ts3.isShorthandAmbientModuleSymbol(symbol)) {
            return anyType;
          } else if (declaration && (declaration.kind === 217 || ts3.isAccessExpression(declaration) && declaration.parent.kind === 217)) {
            return getWidenedTypeForAssignmentDeclaration(symbol);
          } else if (symbol.flags & 512 && declaration && ts3.isSourceFile(declaration) && declaration.commonJsModuleIndicator) {
            var resolvedModule = resolveExternalModuleSymbol(symbol);
            if (resolvedModule !== symbol) {
              if (!pushTypeResolution(symbol, 0)) {
                return errorType;
              }
              var exportEquals = getMergedSymbol(symbol.exports.get("export="));
              var type_2 = getWidenedTypeForAssignmentDeclaration(exportEquals, exportEquals === resolvedModule ? void 0 : resolvedModule);
              if (!popTypeResolution()) {
                return reportCircularityError(symbol);
              }
              return type_2;
            }
          }
          var type3 = createObjectType(16, symbol);
          if (symbol.flags & 32) {
            var baseTypeVariable = getBaseTypeVariableOfClass(symbol);
            return baseTypeVariable ? getIntersectionType([type3, baseTypeVariable]) : type3;
          } else {
            return strictNullChecks && symbol.flags & 16777216 ? getOptionalType(type3) : type3;
          }
        }
        function getTypeOfEnumMember(symbol) {
          var links = getSymbolLinks(symbol);
          return links.type || (links.type = getDeclaredTypeOfEnumMember(symbol));
        }
        function getTypeOfAlias(symbol) {
          var links = getSymbolLinks(symbol);
          if (!links.type) {
            var targetSymbol = resolveAlias(symbol);
            var exportSymbol = symbol.declarations && getTargetOfAliasDeclaration(getDeclarationOfAliasSymbol(symbol), true);
            links.type = (exportSymbol === null || exportSymbol === void 0 ? void 0 : exportSymbol.declarations) && isDuplicatedCommonJSExport(exportSymbol.declarations) && symbol.declarations.length ? getFlowTypeFromCommonJSExport(exportSymbol) : isDuplicatedCommonJSExport(symbol.declarations) ? autoType : targetSymbol.flags & 111551 ? getTypeOfSymbol(targetSymbol) : errorType;
          }
          return links.type;
        }
        function getTypeOfInstantiatedSymbol(symbol) {
          var links = getSymbolLinks(symbol);
          if (!links.type) {
            if (!pushTypeResolution(symbol, 0)) {
              return links.type = errorType;
            }
            var type3 = instantiateType(getTypeOfSymbol(links.target), links.mapper);
            if (!popTypeResolution()) {
              type3 = reportCircularityError(symbol);
            }
            links.type = type3;
          }
          return links.type;
        }
        function reportCircularityError(symbol) {
          var declaration = symbol.valueDeclaration;
          if (ts3.getEffectiveTypeAnnotationNode(declaration)) {
            error(symbol.valueDeclaration, ts3.Diagnostics._0_is_referenced_directly_or_indirectly_in_its_own_type_annotation, symbolToString(symbol));
            return errorType;
          }
          if (noImplicitAny && (declaration.kind !== 161 || declaration.initializer)) {
            error(symbol.valueDeclaration, ts3.Diagnostics._0_implicitly_has_type_any_because_it_does_not_have_a_type_annotation_and_is_referenced_directly_or_indirectly_in_its_own_initializer, symbolToString(symbol));
          }
          return anyType;
        }
        function getTypeOfSymbolWithDeferredType(symbol) {
          var links = getSymbolLinks(symbol);
          if (!links.type) {
            ts3.Debug.assertIsDefined(links.deferralParent);
            ts3.Debug.assertIsDefined(links.deferralConstituents);
            links.type = links.deferralParent.flags & 1048576 ? getUnionType(links.deferralConstituents) : getIntersectionType(links.deferralConstituents);
          }
          return links.type;
        }
        function getSetAccessorTypeOfSymbol(symbol) {
          if (symbol.flags & 98304) {
            var type3 = getTypeOfSetAccessor(symbol);
            if (type3) {
              return type3;
            }
          }
          return getTypeOfSymbol(symbol);
        }
        function getTypeOfSymbol(symbol) {
          var checkFlags = ts3.getCheckFlags(symbol);
          if (checkFlags & 65536) {
            return getTypeOfSymbolWithDeferredType(symbol);
          }
          if (checkFlags & 1) {
            return getTypeOfInstantiatedSymbol(symbol);
          }
          if (checkFlags & 262144) {
            return getTypeOfMappedSymbol(symbol);
          }
          if (checkFlags & 8192) {
            return getTypeOfReverseMappedSymbol(symbol);
          }
          if (symbol.flags & (3 | 4)) {
            return getTypeOfVariableOrParameterOrProperty(symbol);
          }
          if (symbol.flags & (16 | 8192 | 32 | 384 | 512)) {
            return getTypeOfFuncClassEnumModule(symbol);
          }
          if (symbol.flags & 8) {
            return getTypeOfEnumMember(symbol);
          }
          if (symbol.flags & 98304) {
            return getTypeOfAccessors(symbol);
          }
          if (symbol.flags & 2097152) {
            return getTypeOfAlias(symbol);
          }
          return errorType;
        }
        function isReferenceToType(type3, target) {
          return type3 !== void 0 && target !== void 0 && (ts3.getObjectFlags(type3) & 4) !== 0 && type3.target === target;
        }
        function getTargetType(type3) {
          return ts3.getObjectFlags(type3) & 4 ? type3.target : type3;
        }
        function hasBaseType(type3, checkBase) {
          return check(type3);
          function check(type4) {
            if (ts3.getObjectFlags(type4) & (3 | 4)) {
              var target = getTargetType(type4);
              return target === checkBase || ts3.some(getBaseTypes(target), check);
            } else if (type4.flags & 2097152) {
              return ts3.some(type4.types, check);
            }
            return false;
          }
        }
        function appendTypeParameters(typeParameters, declarations) {
          for (var _i = 0, declarations_2 = declarations; _i < declarations_2.length; _i++) {
            var declaration = declarations_2[_i];
            typeParameters = ts3.appendIfUnique(typeParameters, getDeclaredTypeOfTypeParameter(getSymbolOfNode(declaration)));
          }
          return typeParameters;
        }
        function getOuterTypeParameters(node, includeThisTypes) {
          while (true) {
            node = node.parent;
            if (node && ts3.isBinaryExpression(node)) {
              var assignmentKind = ts3.getAssignmentDeclarationKind(node);
              if (assignmentKind === 6 || assignmentKind === 3) {
                var symbol = getSymbolOfNode(node.left);
                if (symbol && symbol.parent && !ts3.findAncestor(symbol.parent.valueDeclaration, function(d) {
                  return node === d;
                })) {
                  node = symbol.parent.valueDeclaration;
                }
              }
            }
            if (!node) {
              return void 0;
            }
            switch (node.kind) {
              case 253:
              case 222:
              case 254:
              case 170:
              case 171:
              case 165:
              case 175:
              case 176:
              case 309:
              case 252:
              case 166:
              case 209:
              case 210:
              case 255:
              case 334:
              case 335:
              case 329:
              case 328:
              case 191:
              case 185: {
                var outerTypeParameters = getOuterTypeParameters(node, includeThisTypes);
                if (node.kind === 191) {
                  return ts3.append(outerTypeParameters, getDeclaredTypeOfTypeParameter(getSymbolOfNode(node.typeParameter)));
                } else if (node.kind === 185) {
                  return ts3.concatenate(outerTypeParameters, getInferTypeParameters(node));
                }
                var outerAndOwnTypeParameters = appendTypeParameters(outerTypeParameters, ts3.getEffectiveTypeParameterDeclarations(node));
                var thisType = includeThisTypes && (node.kind === 253 || node.kind === 222 || node.kind === 254 || isJSConstructor(node)) && getDeclaredTypeOfClassOrInterface(getSymbolOfNode(node)).thisType;
                return thisType ? ts3.append(outerAndOwnTypeParameters, thisType) : outerAndOwnTypeParameters;
              }
              case 330:
                var paramSymbol = ts3.getParameterSymbolFromJSDoc(node);
                if (paramSymbol) {
                  node = paramSymbol.valueDeclaration;
                }
                break;
              case 312: {
                var outerTypeParameters = getOuterTypeParameters(node, includeThisTypes);
                return node.tags ? appendTypeParameters(outerTypeParameters, ts3.flatMap(node.tags, function(t2) {
                  return ts3.isJSDocTemplateTag(t2) ? t2.typeParameters : void 0;
                })) : outerTypeParameters;
              }
            }
          }
        }
        function getOuterTypeParametersOfClassOrInterface(symbol) {
          var declaration = symbol.flags & 32 ? symbol.valueDeclaration : ts3.getDeclarationOfKind(symbol, 254);
          ts3.Debug.assert(!!declaration, "Class was missing valueDeclaration -OR- non-class had no interface declarations");
          return getOuterTypeParameters(declaration);
        }
        function getLocalTypeParametersOfClassOrInterfaceOrTypeAlias(symbol) {
          if (!symbol.declarations) {
            return;
          }
          var result2;
          for (var _i = 0, _a2 = symbol.declarations; _i < _a2.length; _i++) {
            var node = _a2[_i];
            if (node.kind === 254 || node.kind === 253 || node.kind === 222 || isJSConstructor(node) || ts3.isTypeAlias(node)) {
              var declaration = node;
              result2 = appendTypeParameters(result2, ts3.getEffectiveTypeParameterDeclarations(declaration));
            }
          }
          return result2;
        }
        function getTypeParametersOfClassOrInterface(symbol) {
          return ts3.concatenate(getOuterTypeParametersOfClassOrInterface(symbol), getLocalTypeParametersOfClassOrInterfaceOrTypeAlias(symbol));
        }
        function isMixinConstructorType(type3) {
          var signatures = getSignaturesOfType(type3, 1);
          if (signatures.length === 1) {
            var s2 = signatures[0];
            if (!s2.typeParameters && s2.parameters.length === 1 && signatureHasRestParameter(s2)) {
              var paramType = getTypeOfParameter(s2.parameters[0]);
              return isTypeAny(paramType) || getElementTypeOfArrayType(paramType) === anyType;
            }
          }
          return false;
        }
        function isConstructorType(type3) {
          if (getSignaturesOfType(type3, 1).length > 0) {
            return true;
          }
          if (type3.flags & 8650752) {
            var constraint = getBaseConstraintOfType(type3);
            return !!constraint && isMixinConstructorType(constraint);
          }
          return false;
        }
        function getBaseTypeNodeOfClass(type3) {
          return ts3.getEffectiveBaseTypeNode(type3.symbol.valueDeclaration);
        }
        function getConstructorsForTypeArguments(type3, typeArgumentNodes, location) {
          var typeArgCount = ts3.length(typeArgumentNodes);
          var isJavascript = ts3.isInJSFile(location);
          return ts3.filter(getSignaturesOfType(type3, 1), function(sig) {
            return (isJavascript || typeArgCount >= getMinTypeArgumentCount(sig.typeParameters)) && typeArgCount <= ts3.length(sig.typeParameters);
          });
        }
        function getInstantiatedConstructorsForTypeArguments(type3, typeArgumentNodes, location) {
          var signatures = getConstructorsForTypeArguments(type3, typeArgumentNodes, location);
          var typeArguments = ts3.map(typeArgumentNodes, getTypeFromTypeNode);
          return ts3.sameMap(signatures, function(sig) {
            return ts3.some(sig.typeParameters) ? getSignatureInstantiation(sig, typeArguments, ts3.isInJSFile(location)) : sig;
          });
        }
        function getBaseConstructorTypeOfClass(type3) {
          if (!type3.resolvedBaseConstructorType) {
            var decl = type3.symbol.valueDeclaration;
            var extended = ts3.getEffectiveBaseTypeNode(decl);
            var baseTypeNode = getBaseTypeNodeOfClass(type3);
            if (!baseTypeNode) {
              return type3.resolvedBaseConstructorType = undefinedType;
            }
            if (!pushTypeResolution(type3, 1)) {
              return errorType;
            }
            var baseConstructorType = checkExpression(baseTypeNode.expression);
            if (extended && baseTypeNode !== extended) {
              ts3.Debug.assert(!extended.typeArguments);
              checkExpression(extended.expression);
            }
            if (baseConstructorType.flags & (524288 | 2097152)) {
              resolveStructuredTypeMembers(baseConstructorType);
            }
            if (!popTypeResolution()) {
              error(type3.symbol.valueDeclaration, ts3.Diagnostics._0_is_referenced_directly_or_indirectly_in_its_own_base_expression, symbolToString(type3.symbol));
              return type3.resolvedBaseConstructorType = errorType;
            }
            if (!(baseConstructorType.flags & 1) && baseConstructorType !== nullWideningType && !isConstructorType(baseConstructorType)) {
              var err2 = error(baseTypeNode.expression, ts3.Diagnostics.Type_0_is_not_a_constructor_function_type, typeToString(baseConstructorType));
              if (baseConstructorType.flags & 262144) {
                var constraint = getConstraintFromTypeParameter(baseConstructorType);
                var ctorReturn = unknownType;
                if (constraint) {
                  var ctorSig = getSignaturesOfType(constraint, 1);
                  if (ctorSig[0]) {
                    ctorReturn = getReturnTypeOfSignature(ctorSig[0]);
                  }
                }
                if (baseConstructorType.symbol.declarations) {
                  ts3.addRelatedInfo(err2, ts3.createDiagnosticForNode(baseConstructorType.symbol.declarations[0], ts3.Diagnostics.Did_you_mean_for_0_to_be_constrained_to_type_new_args_Colon_any_1, symbolToString(baseConstructorType.symbol), typeToString(ctorReturn)));
                }
              }
              return type3.resolvedBaseConstructorType = errorType;
            }
            type3.resolvedBaseConstructorType = baseConstructorType;
          }
          return type3.resolvedBaseConstructorType;
        }
        function getImplementsTypes(type3) {
          var resolvedImplementsTypes = ts3.emptyArray;
          if (type3.symbol.declarations) {
            for (var _i = 0, _a2 = type3.symbol.declarations; _i < _a2.length; _i++) {
              var declaration = _a2[_i];
              var implementsTypeNodes = ts3.getEffectiveImplementsTypeNodes(declaration);
              if (!implementsTypeNodes)
                continue;
              for (var _b = 0, implementsTypeNodes_1 = implementsTypeNodes; _b < implementsTypeNodes_1.length; _b++) {
                var node = implementsTypeNodes_1[_b];
                var implementsType = getTypeFromTypeNode(node);
                if (implementsType !== errorType) {
                  if (resolvedImplementsTypes === ts3.emptyArray) {
                    resolvedImplementsTypes = [implementsType];
                  } else {
                    resolvedImplementsTypes.push(implementsType);
                  }
                }
              }
            }
          }
          return resolvedImplementsTypes;
        }
        function reportCircularBaseType(node, type3) {
          error(node, ts3.Diagnostics.Type_0_recursively_references_itself_as_a_base_type, typeToString(type3, void 0, 2));
        }
        function getBaseTypes(type3) {
          if (!type3.baseTypesResolved) {
            if (pushTypeResolution(type3, 7)) {
              if (type3.objectFlags & 8) {
                type3.resolvedBaseTypes = [getTupleBaseType(type3)];
              } else if (type3.symbol.flags & (32 | 64)) {
                if (type3.symbol.flags & 32) {
                  resolveBaseTypesOfClass(type3);
                }
                if (type3.symbol.flags & 64) {
                  resolveBaseTypesOfInterface(type3);
                }
              } else {
                ts3.Debug.fail("type must be class or interface");
              }
              if (!popTypeResolution() && type3.symbol.declarations) {
                for (var _i = 0, _a2 = type3.symbol.declarations; _i < _a2.length; _i++) {
                  var declaration = _a2[_i];
                  if (declaration.kind === 253 || declaration.kind === 254) {
                    reportCircularBaseType(declaration, type3);
                  }
                }
              }
            }
            type3.baseTypesResolved = true;
          }
          return type3.resolvedBaseTypes;
        }
        function getTupleBaseType(type3) {
          var elementTypes = ts3.sameMap(type3.typeParameters, function(t2, i3) {
            return type3.elementFlags[i3] & 8 ? getIndexedAccessType(t2, numberType) : t2;
          });
          return createArrayType(getUnionType(elementTypes || ts3.emptyArray), type3.readonly);
        }
        function resolveBaseTypesOfClass(type3) {
          type3.resolvedBaseTypes = ts3.resolvingEmptyArray;
          var baseConstructorType = getApparentType(getBaseConstructorTypeOfClass(type3));
          if (!(baseConstructorType.flags & (524288 | 2097152 | 1))) {
            return type3.resolvedBaseTypes = ts3.emptyArray;
          }
          var baseTypeNode = getBaseTypeNodeOfClass(type3);
          var baseType;
          var originalBaseType = baseConstructorType.symbol ? getDeclaredTypeOfSymbol(baseConstructorType.symbol) : void 0;
          if (baseConstructorType.symbol && baseConstructorType.symbol.flags & 32 && areAllOuterTypeParametersApplied(originalBaseType)) {
            baseType = getTypeFromClassOrInterfaceReference(baseTypeNode, baseConstructorType.symbol);
          } else if (baseConstructorType.flags & 1) {
            baseType = baseConstructorType;
          } else {
            var constructors = getInstantiatedConstructorsForTypeArguments(baseConstructorType, baseTypeNode.typeArguments, baseTypeNode);
            if (!constructors.length) {
              error(baseTypeNode.expression, ts3.Diagnostics.No_base_constructor_has_the_specified_number_of_type_arguments);
              return type3.resolvedBaseTypes = ts3.emptyArray;
            }
            baseType = getReturnTypeOfSignature(constructors[0]);
          }
          if (baseType === errorType) {
            return type3.resolvedBaseTypes = ts3.emptyArray;
          }
          var reducedBaseType = getReducedType(baseType);
          if (!isValidBaseType(reducedBaseType)) {
            var elaboration = elaborateNeverIntersection(void 0, baseType);
            var diagnostic = ts3.chainDiagnosticMessages(elaboration, ts3.Diagnostics.Base_constructor_return_type_0_is_not_an_object_type_or_intersection_of_object_types_with_statically_known_members, typeToString(reducedBaseType));
            diagnostics.add(ts3.createDiagnosticForNodeFromMessageChain(baseTypeNode.expression, diagnostic));
            return type3.resolvedBaseTypes = ts3.emptyArray;
          }
          if (type3 === reducedBaseType || hasBaseType(reducedBaseType, type3)) {
            error(type3.symbol.valueDeclaration, ts3.Diagnostics.Type_0_recursively_references_itself_as_a_base_type, typeToString(type3, void 0, 2));
            return type3.resolvedBaseTypes = ts3.emptyArray;
          }
          if (type3.resolvedBaseTypes === ts3.resolvingEmptyArray) {
            type3.members = void 0;
          }
          return type3.resolvedBaseTypes = [reducedBaseType];
        }
        function areAllOuterTypeParametersApplied(type3) {
          var outerTypeParameters = type3.outerTypeParameters;
          if (outerTypeParameters) {
            var last_1 = outerTypeParameters.length - 1;
            var typeArguments = getTypeArguments(type3);
            return outerTypeParameters[last_1].symbol !== typeArguments[last_1].symbol;
          }
          return true;
        }
        function isValidBaseType(type3) {
          if (type3.flags & 262144) {
            var constraint = getBaseConstraintOfType(type3);
            if (constraint) {
              return isValidBaseType(constraint);
            }
          }
          return !!(type3.flags & (524288 | 67108864 | 1) && !isGenericMappedType(type3) || type3.flags & 2097152 && ts3.every(type3.types, isValidBaseType));
        }
        function resolveBaseTypesOfInterface(type3) {
          type3.resolvedBaseTypes = type3.resolvedBaseTypes || ts3.emptyArray;
          if (type3.symbol.declarations) {
            for (var _i = 0, _a2 = type3.symbol.declarations; _i < _a2.length; _i++) {
              var declaration = _a2[_i];
              if (declaration.kind === 254 && ts3.getInterfaceBaseTypeNodes(declaration)) {
                for (var _b = 0, _c = ts3.getInterfaceBaseTypeNodes(declaration); _b < _c.length; _b++) {
                  var node = _c[_b];
                  var baseType = getReducedType(getTypeFromTypeNode(node));
                  if (baseType !== errorType) {
                    if (isValidBaseType(baseType)) {
                      if (type3 !== baseType && !hasBaseType(baseType, type3)) {
                        if (type3.resolvedBaseTypes === ts3.emptyArray) {
                          type3.resolvedBaseTypes = [baseType];
                        } else {
                          type3.resolvedBaseTypes.push(baseType);
                        }
                      } else {
                        reportCircularBaseType(declaration, type3);
                      }
                    } else {
                      error(node, ts3.Diagnostics.An_interface_can_only_extend_an_object_type_or_intersection_of_object_types_with_statically_known_members);
                    }
                  }
                }
              }
            }
          }
        }
        function isThislessInterface(symbol) {
          if (!symbol.declarations) {
            return true;
          }
          for (var _i = 0, _a2 = symbol.declarations; _i < _a2.length; _i++) {
            var declaration = _a2[_i];
            if (declaration.kind === 254) {
              if (declaration.flags & 128) {
                return false;
              }
              var baseTypeNodes = ts3.getInterfaceBaseTypeNodes(declaration);
              if (baseTypeNodes) {
                for (var _b = 0, baseTypeNodes_1 = baseTypeNodes; _b < baseTypeNodes_1.length; _b++) {
                  var node = baseTypeNodes_1[_b];
                  if (ts3.isEntityNameExpression(node.expression)) {
                    var baseSymbol = resolveEntityName(node.expression, 788968, true);
                    if (!baseSymbol || !(baseSymbol.flags & 64) || getDeclaredTypeOfClassOrInterface(baseSymbol).thisType) {
                      return false;
                    }
                  }
                }
              }
            }
          }
          return true;
        }
        function getDeclaredTypeOfClassOrInterface(symbol) {
          var links = getSymbolLinks(symbol);
          var originalLinks = links;
          if (!links.declaredType) {
            var kind = symbol.flags & 32 ? 1 : 2;
            var merged = mergeJSSymbols(symbol, symbol.valueDeclaration && getAssignedClassSymbol(symbol.valueDeclaration));
            if (merged) {
              symbol = links = merged;
            }
            var type3 = originalLinks.declaredType = links.declaredType = createObjectType(kind, symbol);
            var outerTypeParameters = getOuterTypeParametersOfClassOrInterface(symbol);
            var localTypeParameters = getLocalTypeParametersOfClassOrInterfaceOrTypeAlias(symbol);
            if (outerTypeParameters || localTypeParameters || kind === 1 || !isThislessInterface(symbol)) {
              type3.objectFlags |= 4;
              type3.typeParameters = ts3.concatenate(outerTypeParameters, localTypeParameters);
              type3.outerTypeParameters = outerTypeParameters;
              type3.localTypeParameters = localTypeParameters;
              type3.instantiations = new ts3.Map();
              type3.instantiations.set(getTypeListId(type3.typeParameters), type3);
              type3.target = type3;
              type3.resolvedTypeArguments = type3.typeParameters;
              type3.thisType = createTypeParameter(symbol);
              type3.thisType.isThisType = true;
              type3.thisType.constraint = type3;
            }
          }
          return links.declaredType;
        }
        function getDeclaredTypeOfTypeAlias(symbol) {
          var _a2;
          var links = getSymbolLinks(symbol);
          if (!links.declaredType) {
            if (!pushTypeResolution(symbol, 2)) {
              return errorType;
            }
            var declaration = ts3.Debug.checkDefined((_a2 = symbol.declarations) === null || _a2 === void 0 ? void 0 : _a2.find(ts3.isTypeAlias), "Type alias symbol with no valid declaration found");
            var typeNode = ts3.isJSDocTypeAlias(declaration) ? declaration.typeExpression : declaration.type;
            var type3 = typeNode ? getTypeFromTypeNode(typeNode) : errorType;
            if (popTypeResolution()) {
              var typeParameters = getLocalTypeParametersOfClassOrInterfaceOrTypeAlias(symbol);
              if (typeParameters) {
                links.typeParameters = typeParameters;
                links.instantiations = new ts3.Map();
                links.instantiations.set(getTypeListId(typeParameters), type3);
              }
            } else {
              type3 = errorType;
              error(ts3.isNamedDeclaration(declaration) ? declaration.name : declaration || declaration, ts3.Diagnostics.Type_alias_0_circularly_references_itself, symbolToString(symbol));
            }
            links.declaredType = type3;
          }
          return links.declaredType;
        }
        function isStringConcatExpression(expr) {
          if (ts3.isStringLiteralLike(expr)) {
            return true;
          } else if (expr.kind === 217) {
            return isStringConcatExpression(expr.left) && isStringConcatExpression(expr.right);
          }
          return false;
        }
        function isLiteralEnumMember(member) {
          var expr = member.initializer;
          if (!expr) {
            return !(member.flags & 8388608);
          }
          switch (expr.kind) {
            case 10:
            case 8:
            case 14:
              return true;
            case 215:
              return expr.operator === 40 && expr.operand.kind === 8;
            case 78:
              return ts3.nodeIsMissing(expr) || !!getSymbolOfNode(member.parent).exports.get(expr.escapedText);
            case 217:
              return isStringConcatExpression(expr);
            default:
              return false;
          }
        }
        function getEnumKind(symbol) {
          var links = getSymbolLinks(symbol);
          if (links.enumKind !== void 0) {
            return links.enumKind;
          }
          var hasNonLiteralMember = false;
          if (symbol.declarations) {
            for (var _i = 0, _a2 = symbol.declarations; _i < _a2.length; _i++) {
              var declaration = _a2[_i];
              if (declaration.kind === 256) {
                for (var _b = 0, _c = declaration.members; _b < _c.length; _b++) {
                  var member = _c[_b];
                  if (member.initializer && ts3.isStringLiteralLike(member.initializer)) {
                    return links.enumKind = 1;
                  }
                  if (!isLiteralEnumMember(member)) {
                    hasNonLiteralMember = true;
                  }
                }
              }
            }
          }
          return links.enumKind = hasNonLiteralMember ? 0 : 1;
        }
        function getBaseTypeOfEnumLiteralType(type3) {
          return type3.flags & 1024 && !(type3.flags & 1048576) ? getDeclaredTypeOfSymbol(getParentOfSymbol(type3.symbol)) : type3;
        }
        function getDeclaredTypeOfEnum(symbol) {
          var links = getSymbolLinks(symbol);
          if (links.declaredType) {
            return links.declaredType;
          }
          if (getEnumKind(symbol) === 1) {
            enumCount++;
            var memberTypeList = [];
            if (symbol.declarations) {
              for (var _i = 0, _a2 = symbol.declarations; _i < _a2.length; _i++) {
                var declaration = _a2[_i];
                if (declaration.kind === 256) {
                  for (var _b = 0, _c = declaration.members; _b < _c.length; _b++) {
                    var member = _c[_b];
                    var value = getEnumMemberValue(member);
                    var memberType = getFreshTypeOfLiteralType(getLiteralType(value !== void 0 ? value : 0, enumCount, getSymbolOfNode(member)));
                    getSymbolLinks(getSymbolOfNode(member)).declaredType = memberType;
                    memberTypeList.push(getRegularTypeOfLiteralType(memberType));
                  }
                }
              }
            }
            if (memberTypeList.length) {
              var enumType_1 = getUnionType(memberTypeList, 1, symbol, void 0);
              if (enumType_1.flags & 1048576) {
                enumType_1.flags |= 1024;
                enumType_1.symbol = symbol;
              }
              return links.declaredType = enumType_1;
            }
          }
          var enumType = createType(32);
          enumType.symbol = symbol;
          return links.declaredType = enumType;
        }
        function getDeclaredTypeOfEnumMember(symbol) {
          var links = getSymbolLinks(symbol);
          if (!links.declaredType) {
            var enumType = getDeclaredTypeOfEnum(getParentOfSymbol(symbol));
            if (!links.declaredType) {
              links.declaredType = enumType;
            }
          }
          return links.declaredType;
        }
        function getDeclaredTypeOfTypeParameter(symbol) {
          var links = getSymbolLinks(symbol);
          return links.declaredType || (links.declaredType = createTypeParameter(symbol));
        }
        function getDeclaredTypeOfAlias(symbol) {
          var links = getSymbolLinks(symbol);
          return links.declaredType || (links.declaredType = getDeclaredTypeOfSymbol(resolveAlias(symbol)));
        }
        function getDeclaredTypeOfSymbol(symbol) {
          return tryGetDeclaredTypeOfSymbol(symbol) || errorType;
        }
        function tryGetDeclaredTypeOfSymbol(symbol) {
          if (symbol.flags & (32 | 64)) {
            return getDeclaredTypeOfClassOrInterface(symbol);
          }
          if (symbol.flags & 524288) {
            return getDeclaredTypeOfTypeAlias(symbol);
          }
          if (symbol.flags & 262144) {
            return getDeclaredTypeOfTypeParameter(symbol);
          }
          if (symbol.flags & 384) {
            return getDeclaredTypeOfEnum(symbol);
          }
          if (symbol.flags & 8) {
            return getDeclaredTypeOfEnumMember(symbol);
          }
          if (symbol.flags & 2097152) {
            return getDeclaredTypeOfAlias(symbol);
          }
          return void 0;
        }
        function isThislessType(node) {
          switch (node.kind) {
            case 128:
            case 152:
            case 147:
            case 144:
            case 155:
            case 131:
            case 148:
            case 145:
            case 113:
            case 150:
            case 141:
            case 192:
              return true;
            case 179:
              return isThislessType(node.elementType);
            case 174:
              return !node.typeArguments || node.typeArguments.every(isThislessType);
          }
          return false;
        }
        function isThislessTypeParameter(node) {
          var constraint = ts3.getEffectiveConstraintOfTypeParameter(node);
          return !constraint || isThislessType(constraint);
        }
        function isThislessVariableLikeDeclaration(node) {
          var typeNode = ts3.getEffectiveTypeAnnotationNode(node);
          return typeNode ? isThislessType(typeNode) : !ts3.hasInitializer(node);
        }
        function isThislessFunctionLikeDeclaration(node) {
          var returnType2 = ts3.getEffectiveReturnTypeNode(node);
          var typeParameters = ts3.getEffectiveTypeParameterDeclarations(node);
          return (node.kind === 167 || !!returnType2 && isThislessType(returnType2)) && node.parameters.every(isThislessVariableLikeDeclaration) && typeParameters.every(isThislessTypeParameter);
        }
        function isThisless(symbol) {
          if (symbol.declarations && symbol.declarations.length === 1) {
            var declaration = symbol.declarations[0];
            if (declaration) {
              switch (declaration.kind) {
                case 164:
                case 163:
                  return isThislessVariableLikeDeclaration(declaration);
                case 166:
                case 165:
                case 167:
                case 168:
                case 169:
                  return isThislessFunctionLikeDeclaration(declaration);
              }
            }
          }
          return false;
        }
        function createInstantiatedSymbolTable(symbols, mapper, mappingThisOnly) {
          var result2 = ts3.createSymbolTable();
          for (var _i = 0, symbols_2 = symbols; _i < symbols_2.length; _i++) {
            var symbol = symbols_2[_i];
            result2.set(symbol.escapedName, mappingThisOnly && isThisless(symbol) ? symbol : instantiateSymbol(symbol, mapper));
          }
          return result2;
        }
        function addInheritedMembers(symbols, baseSymbols) {
          for (var _i = 0, baseSymbols_1 = baseSymbols; _i < baseSymbols_1.length; _i++) {
            var s2 = baseSymbols_1[_i];
            if (!symbols.has(s2.escapedName) && !isStaticPrivateIdentifierProperty(s2)) {
              symbols.set(s2.escapedName, s2);
            }
          }
        }
        function isStaticPrivateIdentifierProperty(s2) {
          return !!s2.valueDeclaration && ts3.isPrivateIdentifierClassElementDeclaration(s2.valueDeclaration) && ts3.hasSyntacticModifier(s2.valueDeclaration, 32);
        }
        function resolveDeclaredMembers(type3) {
          if (!type3.declaredProperties) {
            var symbol = type3.symbol;
            var members = getMembersOfSymbol(symbol);
            type3.declaredProperties = getNamedMembers(members);
            type3.declaredCallSignatures = ts3.emptyArray;
            type3.declaredConstructSignatures = ts3.emptyArray;
            type3.declaredCallSignatures = getSignaturesOfSymbol(members.get("__call"));
            type3.declaredConstructSignatures = getSignaturesOfSymbol(members.get("__new"));
            type3.declaredStringIndexInfo = getIndexInfoOfSymbol(symbol, 0);
            type3.declaredNumberIndexInfo = getIndexInfoOfSymbol(symbol, 1);
          }
          return type3;
        }
        function isTypeUsableAsPropertyName(type3) {
          return !!(type3.flags & 8576);
        }
        function isLateBindableName(node) {
          if (!ts3.isComputedPropertyName(node) && !ts3.isElementAccessExpression(node)) {
            return false;
          }
          var expr = ts3.isComputedPropertyName(node) ? node.expression : node.argumentExpression;
          return ts3.isEntityNameExpression(expr) && isTypeUsableAsPropertyName(ts3.isComputedPropertyName(node) ? checkComputedPropertyName(node) : checkExpressionCached(expr));
        }
        function isLateBoundName(name) {
          return name.charCodeAt(0) === 95 && name.charCodeAt(1) === 95 && name.charCodeAt(2) === 64;
        }
        function hasLateBindableName(node) {
          var name = ts3.getNameOfDeclaration(node);
          return !!name && isLateBindableName(name);
        }
        function hasBindableName(node) {
          return !ts3.hasDynamicName(node) || hasLateBindableName(node);
        }
        function isNonBindableDynamicName(node) {
          return ts3.isDynamicName(node) && !isLateBindableName(node);
        }
        function getPropertyNameFromType(type3) {
          if (type3.flags & 8192) {
            return type3.escapedName;
          }
          if (type3.flags & (128 | 256)) {
            return ts3.escapeLeadingUnderscores("" + type3.value);
          }
          return ts3.Debug.fail();
        }
        function addDeclarationToLateBoundSymbol(symbol, member, symbolFlags) {
          ts3.Debug.assert(!!(ts3.getCheckFlags(symbol) & 4096), "Expected a late-bound symbol.");
          symbol.flags |= symbolFlags;
          getSymbolLinks(member.symbol).lateSymbol = symbol;
          if (!symbol.declarations) {
            symbol.declarations = [member];
          } else {
            symbol.declarations.push(member);
          }
          if (symbolFlags & 111551) {
            if (!symbol.valueDeclaration || symbol.valueDeclaration.kind !== member.kind) {
              symbol.valueDeclaration = member;
            }
          }
        }
        function lateBindMember(parent, earlySymbols, lateSymbols, decl) {
          ts3.Debug.assert(!!decl.symbol, "The member is expected to have a symbol.");
          var links = getNodeLinks(decl);
          if (!links.resolvedSymbol) {
            links.resolvedSymbol = decl.symbol;
            var declName = ts3.isBinaryExpression(decl) ? decl.left : decl.name;
            var type3 = ts3.isElementAccessExpression(declName) ? checkExpressionCached(declName.argumentExpression) : checkComputedPropertyName(declName);
            if (isTypeUsableAsPropertyName(type3)) {
              var memberName = getPropertyNameFromType(type3);
              var symbolFlags = decl.symbol.flags;
              var lateSymbol = lateSymbols.get(memberName);
              if (!lateSymbol)
                lateSymbols.set(memberName, lateSymbol = createSymbol(0, memberName, 4096));
              var earlySymbol = earlySymbols && earlySymbols.get(memberName);
              if (lateSymbol.flags & getExcludedSymbolFlags(symbolFlags) || earlySymbol) {
                var declarations = earlySymbol ? ts3.concatenate(earlySymbol.declarations, lateSymbol.declarations) : lateSymbol.declarations;
                var name_4 = !(type3.flags & 8192) && ts3.unescapeLeadingUnderscores(memberName) || ts3.declarationNameToString(declName);
                ts3.forEach(declarations, function(declaration) {
                  return error(ts3.getNameOfDeclaration(declaration) || declaration, ts3.Diagnostics.Property_0_was_also_declared_here, name_4);
                });
                error(declName || decl, ts3.Diagnostics.Duplicate_property_0, name_4);
                lateSymbol = createSymbol(0, memberName, 4096);
              }
              lateSymbol.nameType = type3;
              addDeclarationToLateBoundSymbol(lateSymbol, decl, symbolFlags);
              if (lateSymbol.parent) {
                ts3.Debug.assert(lateSymbol.parent === parent, "Existing symbol parent should match new one");
              } else {
                lateSymbol.parent = parent;
              }
              return links.resolvedSymbol = lateSymbol;
            }
          }
          return links.resolvedSymbol;
        }
        function getResolvedMembersOrExportsOfSymbol(symbol, resolutionKind) {
          var links = getSymbolLinks(symbol);
          if (!links[resolutionKind]) {
            var isStatic = resolutionKind === "resolvedExports";
            var earlySymbols = !isStatic ? symbol.members : symbol.flags & 1536 ? getExportsOfModuleWorker(symbol) : symbol.exports;
            links[resolutionKind] = earlySymbols || emptySymbols;
            var lateSymbols = ts3.createSymbolTable();
            for (var _i = 0, _a2 = symbol.declarations || ts3.emptyArray; _i < _a2.length; _i++) {
              var decl = _a2[_i];
              var members = ts3.getMembersOfDeclaration(decl);
              if (members) {
                for (var _b = 0, members_5 = members; _b < members_5.length; _b++) {
                  var member = members_5[_b];
                  if (isStatic === ts3.hasStaticModifier(member) && hasLateBindableName(member)) {
                    lateBindMember(symbol, earlySymbols, lateSymbols, member);
                  }
                }
              }
            }
            var assignments = symbol.assignmentDeclarationMembers;
            if (assignments) {
              var decls = ts3.arrayFrom(assignments.values());
              for (var _c = 0, decls_1 = decls; _c < decls_1.length; _c++) {
                var member = decls_1[_c];
                var assignmentKind = ts3.getAssignmentDeclarationKind(member);
                var isInstanceMember = assignmentKind === 3 || ts3.isBinaryExpression(member) && isPossiblyAliasedThisProperty(member, assignmentKind) || assignmentKind === 9 || assignmentKind === 6;
                if (isStatic === !isInstanceMember && hasLateBindableName(member)) {
                  lateBindMember(symbol, earlySymbols, lateSymbols, member);
                }
              }
            }
            links[resolutionKind] = combineSymbolTables(earlySymbols, lateSymbols) || emptySymbols;
          }
          return links[resolutionKind];
        }
        function getMembersOfSymbol(symbol) {
          return symbol.flags & 6256 ? getResolvedMembersOrExportsOfSymbol(symbol, "resolvedMembers") : symbol.members || emptySymbols;
        }
        function getLateBoundSymbol(symbol) {
          if (symbol.flags & 106500 && symbol.escapedName === "__computed") {
            var links = getSymbolLinks(symbol);
            if (!links.lateSymbol && ts3.some(symbol.declarations, hasLateBindableName)) {
              var parent = getMergedSymbol(symbol.parent);
              if (ts3.some(symbol.declarations, ts3.hasStaticModifier)) {
                getExportsOfSymbol(parent);
              } else {
                getMembersOfSymbol(parent);
              }
            }
            return links.lateSymbol || (links.lateSymbol = symbol);
          }
          return symbol;
        }
        function getTypeWithThisArgument(type3, thisArgument, needApparentType) {
          if (ts3.getObjectFlags(type3) & 4) {
            var target = type3.target;
            var typeArguments = getTypeArguments(type3);
            if (ts3.length(target.typeParameters) === ts3.length(typeArguments)) {
              var ref2 = createTypeReference(target, ts3.concatenate(typeArguments, [thisArgument || target.thisType]));
              return needApparentType ? getApparentType(ref2) : ref2;
            }
          } else if (type3.flags & 2097152) {
            var types2 = ts3.sameMap(type3.types, function(t2) {
              return getTypeWithThisArgument(t2, thisArgument, needApparentType);
            });
            return types2 !== type3.types ? getIntersectionType(types2) : type3;
          }
          return needApparentType ? getApparentType(type3) : type3;
        }
        function resolveObjectTypeMembers(type3, source, typeParameters, typeArguments) {
          var mapper;
          var members;
          var callSignatures;
          var constructSignatures;
          var stringIndexInfo;
          var numberIndexInfo;
          if (ts3.rangeEquals(typeParameters, typeArguments, 0, typeParameters.length)) {
            members = source.symbol ? getMembersOfSymbol(source.symbol) : ts3.createSymbolTable(source.declaredProperties);
            callSignatures = source.declaredCallSignatures;
            constructSignatures = source.declaredConstructSignatures;
            stringIndexInfo = source.declaredStringIndexInfo;
            numberIndexInfo = source.declaredNumberIndexInfo;
          } else {
            mapper = createTypeMapper(typeParameters, typeArguments);
            members = createInstantiatedSymbolTable(source.declaredProperties, mapper, typeParameters.length === 1);
            callSignatures = instantiateSignatures(source.declaredCallSignatures, mapper);
            constructSignatures = instantiateSignatures(source.declaredConstructSignatures, mapper);
            stringIndexInfo = instantiateIndexInfo(source.declaredStringIndexInfo, mapper);
            numberIndexInfo = instantiateIndexInfo(source.declaredNumberIndexInfo, mapper);
          }
          var baseTypes = getBaseTypes(source);
          if (baseTypes.length) {
            if (source.symbol && members === getMembersOfSymbol(source.symbol)) {
              members = ts3.createSymbolTable(source.declaredProperties);
            }
            setStructuredTypeMembers(type3, members, callSignatures, constructSignatures, stringIndexInfo, numberIndexInfo);
            var thisArgument = ts3.lastOrUndefined(typeArguments);
            for (var _i = 0, baseTypes_1 = baseTypes; _i < baseTypes_1.length; _i++) {
              var baseType = baseTypes_1[_i];
              var instantiatedBaseType = thisArgument ? getTypeWithThisArgument(instantiateType(baseType, mapper), thisArgument) : baseType;
              addInheritedMembers(members, getPropertiesOfType(instantiatedBaseType));
              callSignatures = ts3.concatenate(callSignatures, getSignaturesOfType(instantiatedBaseType, 0));
              constructSignatures = ts3.concatenate(constructSignatures, getSignaturesOfType(instantiatedBaseType, 1));
              if (!stringIndexInfo) {
                stringIndexInfo = instantiatedBaseType === anyType ? createIndexInfo(anyType, false) : getIndexInfoOfType(instantiatedBaseType, 0);
              }
              numberIndexInfo = numberIndexInfo || getIndexInfoOfType(instantiatedBaseType, 1);
            }
          }
          setStructuredTypeMembers(type3, members, callSignatures, constructSignatures, stringIndexInfo, numberIndexInfo);
        }
        function resolveClassOrInterfaceMembers(type3) {
          resolveObjectTypeMembers(type3, resolveDeclaredMembers(type3), ts3.emptyArray, ts3.emptyArray);
        }
        function resolveTypeReferenceMembers(type3) {
          var source = resolveDeclaredMembers(type3.target);
          var typeParameters = ts3.concatenate(source.typeParameters, [source.thisType]);
          var typeArguments = getTypeArguments(type3);
          var paddedTypeArguments = typeArguments.length === typeParameters.length ? typeArguments : ts3.concatenate(typeArguments, [type3]);
          resolveObjectTypeMembers(type3, source, typeParameters, paddedTypeArguments);
        }
        function createSignature(declaration, typeParameters, thisParameter, parameters, resolvedReturnType, resolvedTypePredicate, minArgumentCount, flags) {
          var sig = new Signature(checker, flags);
          sig.declaration = declaration;
          sig.typeParameters = typeParameters;
          sig.parameters = parameters;
          sig.thisParameter = thisParameter;
          sig.resolvedReturnType = resolvedReturnType;
          sig.resolvedTypePredicate = resolvedTypePredicate;
          sig.minArgumentCount = minArgumentCount;
          sig.resolvedMinArgumentCount = void 0;
          sig.target = void 0;
          sig.mapper = void 0;
          sig.compositeSignatures = void 0;
          sig.compositeKind = void 0;
          return sig;
        }
        function cloneSignature(sig) {
          var result2 = createSignature(sig.declaration, sig.typeParameters, sig.thisParameter, sig.parameters, void 0, void 0, sig.minArgumentCount, sig.flags & 39);
          result2.target = sig.target;
          result2.mapper = sig.mapper;
          result2.compositeSignatures = sig.compositeSignatures;
          result2.compositeKind = sig.compositeKind;
          return result2;
        }
        function createUnionSignature(signature, unionSignatures) {
          var result2 = cloneSignature(signature);
          result2.compositeSignatures = unionSignatures;
          result2.compositeKind = 1048576;
          result2.target = void 0;
          result2.mapper = void 0;
          return result2;
        }
        function getOptionalCallSignature(signature, callChainFlags) {
          if ((signature.flags & 24) === callChainFlags) {
            return signature;
          }
          if (!signature.optionalCallSignatureCache) {
            signature.optionalCallSignatureCache = {};
          }
          var key2 = callChainFlags === 8 ? "inner" : "outer";
          return signature.optionalCallSignatureCache[key2] || (signature.optionalCallSignatureCache[key2] = createOptionalCallSignature(signature, callChainFlags));
        }
        function createOptionalCallSignature(signature, callChainFlags) {
          ts3.Debug.assert(callChainFlags === 8 || callChainFlags === 16, "An optional call signature can either be for an inner call chain or an outer call chain, but not both.");
          var result2 = cloneSignature(signature);
          result2.flags |= callChainFlags;
          return result2;
        }
        function getExpandedParameters(sig, skipUnionExpanding) {
          if (signatureHasRestParameter(sig)) {
            var restIndex_1 = sig.parameters.length - 1;
            var restType = getTypeOfSymbol(sig.parameters[restIndex_1]);
            if (isTupleType(restType)) {
              return [expandSignatureParametersWithTupleMembers(restType, restIndex_1)];
            } else if (!skipUnionExpanding && restType.flags & 1048576 && ts3.every(restType.types, isTupleType)) {
              return ts3.map(restType.types, function(t2) {
                return expandSignatureParametersWithTupleMembers(t2, restIndex_1);
              });
            }
          }
          return [sig.parameters];
          function expandSignatureParametersWithTupleMembers(restType2, restIndex) {
            var elementTypes = getTypeArguments(restType2);
            var associatedNames = restType2.target.labeledElementDeclarations;
            var restParams = ts3.map(elementTypes, function(t2, i3) {
              var tupleLabelName = !!associatedNames && getTupleElementLabel(associatedNames[i3]);
              var name = tupleLabelName || getParameterNameAtPosition(sig, restIndex + i3, restType2);
              var flags = restType2.target.elementFlags[i3];
              var checkFlags = flags & 12 ? 32768 : flags & 2 ? 16384 : 0;
              var symbol = createSymbol(1, name, checkFlags);
              symbol.type = flags & 4 ? createArrayType(t2) : t2;
              return symbol;
            });
            return ts3.concatenate(sig.parameters.slice(0, restIndex), restParams);
          }
        }
        function getDefaultConstructSignatures(classType) {
          var baseConstructorType = getBaseConstructorTypeOfClass(classType);
          var baseSignatures = getSignaturesOfType(baseConstructorType, 1);
          var declaration = ts3.getClassLikeDeclarationOfSymbol(classType.symbol);
          var isAbstract = !!declaration && ts3.hasSyntacticModifier(declaration, 128);
          if (baseSignatures.length === 0) {
            return [createSignature(void 0, classType.localTypeParameters, void 0, ts3.emptyArray, classType, void 0, 0, isAbstract ? 4 : 0)];
          }
          var baseTypeNode = getBaseTypeNodeOfClass(classType);
          var isJavaScript = ts3.isInJSFile(baseTypeNode);
          var typeArguments = typeArgumentsFromTypeReferenceNode(baseTypeNode);
          var typeArgCount = ts3.length(typeArguments);
          var result2 = [];
          for (var _i = 0, baseSignatures_1 = baseSignatures; _i < baseSignatures_1.length; _i++) {
            var baseSig = baseSignatures_1[_i];
            var minTypeArgumentCount = getMinTypeArgumentCount(baseSig.typeParameters);
            var typeParamCount = ts3.length(baseSig.typeParameters);
            if (isJavaScript || typeArgCount >= minTypeArgumentCount && typeArgCount <= typeParamCount) {
              var sig = typeParamCount ? createSignatureInstantiation(baseSig, fillMissingTypeArguments(typeArguments, baseSig.typeParameters, minTypeArgumentCount, isJavaScript)) : cloneSignature(baseSig);
              sig.typeParameters = classType.localTypeParameters;
              sig.resolvedReturnType = classType;
              sig.flags = isAbstract ? sig.flags | 4 : sig.flags & ~4;
              result2.push(sig);
            }
          }
          return result2;
        }
        function findMatchingSignature(signatureList, signature, partialMatch, ignoreThisTypes, ignoreReturnTypes) {
          for (var _i = 0, signatureList_1 = signatureList; _i < signatureList_1.length; _i++) {
            var s2 = signatureList_1[_i];
            if (compareSignaturesIdentical(s2, signature, partialMatch, ignoreThisTypes, ignoreReturnTypes, partialMatch ? compareTypesSubtypeOf : compareTypesIdentical)) {
              return s2;
            }
          }
        }
        function findMatchingSignatures(signatureLists, signature, listIndex) {
          if (signature.typeParameters) {
            if (listIndex > 0) {
              return void 0;
            }
            for (var i3 = 1; i3 < signatureLists.length; i3++) {
              if (!findMatchingSignature(signatureLists[i3], signature, false, false, false)) {
                return void 0;
              }
            }
            return [signature];
          }
          var result2;
          for (var i3 = 0; i3 < signatureLists.length; i3++) {
            var match = i3 === listIndex ? signature : findMatchingSignature(signatureLists[i3], signature, true, false, true);
            if (!match) {
              return void 0;
            }
            result2 = ts3.appendIfUnique(result2, match);
          }
          return result2;
        }
        function getUnionSignatures(signatureLists) {
          var result2;
          var indexWithLengthOverOne;
          for (var i3 = 0; i3 < signatureLists.length; i3++) {
            if (signatureLists[i3].length === 0)
              return ts3.emptyArray;
            if (signatureLists[i3].length > 1) {
              indexWithLengthOverOne = indexWithLengthOverOne === void 0 ? i3 : -1;
            }
            for (var _i = 0, _a2 = signatureLists[i3]; _i < _a2.length; _i++) {
              var signature = _a2[_i];
              if (!result2 || !findMatchingSignature(result2, signature, false, false, true)) {
                var unionSignatures = findMatchingSignatures(signatureLists, signature, i3);
                if (unionSignatures) {
                  var s2 = signature;
                  if (unionSignatures.length > 1) {
                    var thisParameter = signature.thisParameter;
                    var firstThisParameterOfUnionSignatures = ts3.forEach(unionSignatures, function(sig) {
                      return sig.thisParameter;
                    });
                    if (firstThisParameterOfUnionSignatures) {
                      var thisType = getIntersectionType(ts3.mapDefined(unionSignatures, function(sig) {
                        return sig.thisParameter && getTypeOfSymbol(sig.thisParameter);
                      }));
                      thisParameter = createSymbolWithType(firstThisParameterOfUnionSignatures, thisType);
                    }
                    s2 = createUnionSignature(signature, unionSignatures);
                    s2.thisParameter = thisParameter;
                  }
                  (result2 || (result2 = [])).push(s2);
                }
              }
            }
          }
          if (!ts3.length(result2) && indexWithLengthOverOne !== -1) {
            var masterList = signatureLists[indexWithLengthOverOne !== void 0 ? indexWithLengthOverOne : 0];
            var results = masterList.slice();
            var _loop_10 = function(signatures2) {
              if (signatures2 !== masterList) {
                var signature_1 = signatures2[0];
                ts3.Debug.assert(!!signature_1, "getUnionSignatures bails early on empty signature lists and should not have empty lists on second pass");
                results = !!signature_1.typeParameters && ts3.some(results, function(s3) {
                  return !!s3.typeParameters && !compareTypeParametersIdentical(signature_1.typeParameters, s3.typeParameters);
                }) ? void 0 : ts3.map(results, function(sig) {
                  return combineSignaturesOfUnionMembers(sig, signature_1);
                });
                if (!results) {
                  return "break";
                }
              }
            };
            for (var _b = 0, signatureLists_1 = signatureLists; _b < signatureLists_1.length; _b++) {
              var signatures = signatureLists_1[_b];
              var state_3 = _loop_10(signatures);
              if (state_3 === "break")
                break;
            }
            result2 = results;
          }
          return result2 || ts3.emptyArray;
        }
        function compareTypeParametersIdentical(sourceParams, targetParams) {
          if (ts3.length(sourceParams) !== ts3.length(targetParams)) {
            return false;
          }
          if (!sourceParams || !targetParams) {
            return true;
          }
          var mapper = createTypeMapper(targetParams, sourceParams);
          for (var i3 = 0; i3 < sourceParams.length; i3++) {
            var source = sourceParams[i3];
            var target = targetParams[i3];
            if (source === target)
              continue;
            if (!isTypeIdenticalTo(getConstraintFromTypeParameter(source) || unknownType, instantiateType(getConstraintFromTypeParameter(target) || unknownType, mapper)))
              return false;
          }
          return true;
        }
        function combineUnionThisParam(left, right, mapper) {
          if (!left || !right) {
            return left || right;
          }
          var thisType = getIntersectionType([getTypeOfSymbol(left), instantiateType(getTypeOfSymbol(right), mapper)]);
          return createSymbolWithType(left, thisType);
        }
        function combineUnionParameters(left, right, mapper) {
          var leftCount = getParameterCount(left);
          var rightCount = getParameterCount(right);
          var longest = leftCount >= rightCount ? left : right;
          var shorter = longest === left ? right : left;
          var longestCount = longest === left ? leftCount : rightCount;
          var eitherHasEffectiveRest = hasEffectiveRestParameter(left) || hasEffectiveRestParameter(right);
          var needsExtraRestElement = eitherHasEffectiveRest && !hasEffectiveRestParameter(longest);
          var params = new Array(longestCount + (needsExtraRestElement ? 1 : 0));
          for (var i3 = 0; i3 < longestCount; i3++) {
            var longestParamType = tryGetTypeAtPosition(longest, i3);
            if (longest === right) {
              longestParamType = instantiateType(longestParamType, mapper);
            }
            var shorterParamType = tryGetTypeAtPosition(shorter, i3) || unknownType;
            if (shorter === right) {
              shorterParamType = instantiateType(shorterParamType, mapper);
            }
            var unionParamType = getIntersectionType([longestParamType, shorterParamType]);
            var isRestParam = eitherHasEffectiveRest && !needsExtraRestElement && i3 === longestCount - 1;
            var isOptional = i3 >= getMinArgumentCount(longest) && i3 >= getMinArgumentCount(shorter);
            var leftName = i3 >= leftCount ? void 0 : getParameterNameAtPosition(left, i3);
            var rightName = i3 >= rightCount ? void 0 : getParameterNameAtPosition(right, i3);
            var paramName = leftName === rightName ? leftName : !leftName ? rightName : !rightName ? leftName : void 0;
            var paramSymbol = createSymbol(1 | (isOptional && !isRestParam ? 16777216 : 0), paramName || "arg" + i3);
            paramSymbol.type = isRestParam ? createArrayType(unionParamType) : unionParamType;
            params[i3] = paramSymbol;
          }
          if (needsExtraRestElement) {
            var restParamSymbol = createSymbol(1, "args");
            restParamSymbol.type = createArrayType(getTypeAtPosition(shorter, longestCount));
            if (shorter === right) {
              restParamSymbol.type = instantiateType(restParamSymbol.type, mapper);
            }
            params[longestCount] = restParamSymbol;
          }
          return params;
        }
        function combineSignaturesOfUnionMembers(left, right) {
          var typeParams = left.typeParameters || right.typeParameters;
          var paramMapper;
          if (left.typeParameters && right.typeParameters) {
            paramMapper = createTypeMapper(right.typeParameters, left.typeParameters);
          }
          var declaration = left.declaration;
          var params = combineUnionParameters(left, right, paramMapper);
          var thisParam = combineUnionThisParam(left.thisParameter, right.thisParameter, paramMapper);
          var minArgCount = Math.max(left.minArgumentCount, right.minArgumentCount);
          var result2 = createSignature(declaration, typeParams, thisParam, params, void 0, void 0, minArgCount, (left.flags | right.flags) & 39);
          result2.compositeKind = 1048576;
          result2.compositeSignatures = ts3.concatenate(left.compositeKind !== 2097152 && left.compositeSignatures || [left], [right]);
          if (paramMapper) {
            result2.mapper = left.compositeKind !== 2097152 && left.mapper && left.compositeSignatures ? combineTypeMappers(left.mapper, paramMapper) : paramMapper;
          }
          return result2;
        }
        function getUnionIndexInfo(types2, kind) {
          var indexTypes = [];
          var isAnyReadonly = false;
          for (var _i = 0, types_4 = types2; _i < types_4.length; _i++) {
            var type3 = types_4[_i];
            var indexInfo = getIndexInfoOfType(getApparentType(type3), kind);
            if (!indexInfo) {
              return void 0;
            }
            indexTypes.push(indexInfo.type);
            isAnyReadonly = isAnyReadonly || indexInfo.isReadonly;
          }
          return createIndexInfo(getUnionType(indexTypes, 2), isAnyReadonly);
        }
        function resolveUnionTypeMembers(type3) {
          var callSignatures = getUnionSignatures(ts3.map(type3.types, function(t2) {
            return t2 === globalFunctionType ? [unknownSignature] : getSignaturesOfType(t2, 0);
          }));
          var constructSignatures = getUnionSignatures(ts3.map(type3.types, function(t2) {
            return getSignaturesOfType(t2, 1);
          }));
          var stringIndexInfo = getUnionIndexInfo(type3.types, 0);
          var numberIndexInfo = getUnionIndexInfo(type3.types, 1);
          setStructuredTypeMembers(type3, emptySymbols, callSignatures, constructSignatures, stringIndexInfo, numberIndexInfo);
        }
        function intersectTypes(type1, type22) {
          return !type1 ? type22 : !type22 ? type1 : getIntersectionType([type1, type22]);
        }
        function intersectIndexInfos(info1, info2) {
          return !info1 ? info2 : !info2 ? info1 : createIndexInfo(getIntersectionType([info1.type, info2.type]), info1.isReadonly && info2.isReadonly);
        }
        function unionSpreadIndexInfos(info1, info2) {
          return info1 && info2 && createIndexInfo(getUnionType([info1.type, info2.type]), info1.isReadonly || info2.isReadonly);
        }
        function findMixins(types2) {
          var constructorTypeCount = ts3.countWhere(types2, function(t2) {
            return getSignaturesOfType(t2, 1).length > 0;
          });
          var mixinFlags = ts3.map(types2, isMixinConstructorType);
          if (constructorTypeCount > 0 && constructorTypeCount === ts3.countWhere(mixinFlags, function(b2) {
            return b2;
          })) {
            var firstMixinIndex = mixinFlags.indexOf(true);
            mixinFlags[firstMixinIndex] = false;
          }
          return mixinFlags;
        }
        function includeMixinType(type3, types2, mixinFlags, index) {
          var mixedTypes = [];
          for (var i3 = 0; i3 < types2.length; i3++) {
            if (i3 === index) {
              mixedTypes.push(type3);
            } else if (mixinFlags[i3]) {
              mixedTypes.push(getReturnTypeOfSignature(getSignaturesOfType(types2[i3], 1)[0]));
            }
          }
          return getIntersectionType(mixedTypes);
        }
        function resolveIntersectionTypeMembers(type3) {
          var callSignatures;
          var constructSignatures;
          var stringIndexInfo;
          var numberIndexInfo;
          var types2 = type3.types;
          var mixinFlags = findMixins(types2);
          var mixinCount = ts3.countWhere(mixinFlags, function(b2) {
            return b2;
          });
          var _loop_11 = function(i4) {
            var t2 = type3.types[i4];
            if (!mixinFlags[i4]) {
              var signatures = getSignaturesOfType(t2, 1);
              if (signatures.length && mixinCount > 0) {
                signatures = ts3.map(signatures, function(s2) {
                  var clone = cloneSignature(s2);
                  clone.resolvedReturnType = includeMixinType(getReturnTypeOfSignature(s2), types2, mixinFlags, i4);
                  return clone;
                });
              }
              constructSignatures = appendSignatures(constructSignatures, signatures);
            }
            callSignatures = appendSignatures(callSignatures, getSignaturesOfType(t2, 0));
            stringIndexInfo = intersectIndexInfos(stringIndexInfo, getIndexInfoOfType(t2, 0));
            numberIndexInfo = intersectIndexInfos(numberIndexInfo, getIndexInfoOfType(t2, 1));
          };
          for (var i3 = 0; i3 < types2.length; i3++) {
            _loop_11(i3);
          }
          setStructuredTypeMembers(type3, emptySymbols, callSignatures || ts3.emptyArray, constructSignatures || ts3.emptyArray, stringIndexInfo, numberIndexInfo);
        }
        function appendSignatures(signatures, newSignatures) {
          var _loop_12 = function(sig2) {
            if (!signatures || ts3.every(signatures, function(s2) {
              return !compareSignaturesIdentical(s2, sig2, false, false, false, compareTypesIdentical);
            })) {
              signatures = ts3.append(signatures, sig2);
            }
          };
          for (var _i = 0, newSignatures_1 = newSignatures; _i < newSignatures_1.length; _i++) {
            var sig = newSignatures_1[_i];
            _loop_12(sig);
          }
          return signatures;
        }
        function resolveAnonymousTypeMembers(type3) {
          var symbol = getMergedSymbol(type3.symbol);
          if (type3.target) {
            setStructuredTypeMembers(type3, emptySymbols, ts3.emptyArray, ts3.emptyArray, void 0, void 0);
            var members = createInstantiatedSymbolTable(getPropertiesOfObjectType(type3.target), type3.mapper, false);
            var callSignatures = instantiateSignatures(getSignaturesOfType(type3.target, 0), type3.mapper);
            var constructSignatures = instantiateSignatures(getSignaturesOfType(type3.target, 1), type3.mapper);
            var stringIndexInfo = instantiateIndexInfo(getIndexInfoOfType(type3.target, 0), type3.mapper);
            var numberIndexInfo = instantiateIndexInfo(getIndexInfoOfType(type3.target, 1), type3.mapper);
            setStructuredTypeMembers(type3, members, callSignatures, constructSignatures, stringIndexInfo, numberIndexInfo);
          } else if (symbol.flags & 2048) {
            setStructuredTypeMembers(type3, emptySymbols, ts3.emptyArray, ts3.emptyArray, void 0, void 0);
            var members = getMembersOfSymbol(symbol);
            var callSignatures = getSignaturesOfSymbol(members.get("__call"));
            var constructSignatures = getSignaturesOfSymbol(members.get("__new"));
            var stringIndexInfo = getIndexInfoOfSymbol(symbol, 0);
            var numberIndexInfo = getIndexInfoOfSymbol(symbol, 1);
            setStructuredTypeMembers(type3, members, callSignatures, constructSignatures, stringIndexInfo, numberIndexInfo);
          } else {
            var members = emptySymbols;
            var stringIndexInfo = void 0;
            var numberIndexInfo = void 0;
            if (symbol.exports) {
              members = getExportsOfSymbol(symbol);
              if (symbol === globalThisSymbol) {
                var varsOnly_1 = new ts3.Map();
                members.forEach(function(p) {
                  if (!(p.flags & 418)) {
                    varsOnly_1.set(p.escapedName, p);
                  }
                });
                members = varsOnly_1;
              }
            }
            var baseConstructorIndexInfo = void 0;
            setStructuredTypeMembers(type3, members, ts3.emptyArray, ts3.emptyArray, void 0, void 0);
            if (symbol.flags & 32) {
              var classType = getDeclaredTypeOfClassOrInterface(symbol);
              var baseConstructorType = getBaseConstructorTypeOfClass(classType);
              if (baseConstructorType.flags & (524288 | 2097152 | 8650752)) {
                members = ts3.createSymbolTable(getNamedOrIndexSignatureMembers(members));
                addInheritedMembers(members, getPropertiesOfType(baseConstructorType));
              } else if (baseConstructorType === anyType) {
                baseConstructorIndexInfo = createIndexInfo(anyType, false);
              }
            }
            var indexSymbol = getIndexSymbolFromSymbolTable(members);
            if (indexSymbol) {
              stringIndexInfo = getIndexInfoOfIndexSymbol(indexSymbol, 0);
              numberIndexInfo = getIndexInfoOfIndexSymbol(indexSymbol, 1);
            } else {
              stringIndexInfo = baseConstructorIndexInfo;
              if (symbol.flags & 384 && (getDeclaredTypeOfSymbol(symbol).flags & 32 || ts3.some(type3.properties, function(prop) {
                return !!(getTypeOfSymbol(prop).flags & 296);
              }))) {
                numberIndexInfo = enumNumberIndexInfo;
              }
            }
            setStructuredTypeMembers(type3, members, ts3.emptyArray, ts3.emptyArray, stringIndexInfo, numberIndexInfo);
            if (symbol.flags & (16 | 8192)) {
              type3.callSignatures = getSignaturesOfSymbol(symbol);
            }
            if (symbol.flags & 32) {
              var classType_1 = getDeclaredTypeOfClassOrInterface(symbol);
              var constructSignatures = symbol.members ? getSignaturesOfSymbol(symbol.members.get("__constructor")) : ts3.emptyArray;
              if (symbol.flags & 16) {
                constructSignatures = ts3.addRange(constructSignatures.slice(), ts3.mapDefined(type3.callSignatures, function(sig) {
                  return isJSConstructor(sig.declaration) ? createSignature(sig.declaration, sig.typeParameters, sig.thisParameter, sig.parameters, classType_1, void 0, sig.minArgumentCount, sig.flags & 39) : void 0;
                }));
              }
              if (!constructSignatures.length) {
                constructSignatures = getDefaultConstructSignatures(classType_1);
              }
              type3.constructSignatures = constructSignatures;
            }
          }
        }
        function replaceIndexedAccess(instantiable, type3, replacement) {
          return instantiateType(instantiable, createTypeMapper([type3.indexType, type3.objectType], [getLiteralType(0), createTupleType([replacement])]));
        }
        function getIndexInfoOfIndexSymbol(indexSymbol, indexKind) {
          var declaration = getIndexDeclarationOfIndexSymbol(indexSymbol, indexKind);
          if (!declaration)
            return void 0;
          return createIndexInfo(declaration.type ? getTypeFromTypeNode(declaration.type) : anyType, ts3.hasEffectiveModifier(declaration, 64), declaration);
        }
        function resolveReverseMappedTypeMembers(type3) {
          var indexInfo = getIndexInfoOfType(type3.source, 0);
          var modifiers = getMappedTypeModifiers(type3.mappedType);
          var readonlyMask = modifiers & 1 ? false : true;
          var optionalMask = modifiers & 4 ? 0 : 16777216;
          var stringIndexInfo = indexInfo && createIndexInfo(inferReverseMappedType(indexInfo.type, type3.mappedType, type3.constraintType), readonlyMask && indexInfo.isReadonly);
          var members = ts3.createSymbolTable();
          for (var _i = 0, _a2 = getPropertiesOfType(type3.source); _i < _a2.length; _i++) {
            var prop = _a2[_i];
            var checkFlags = 8192 | (readonlyMask && isReadonlySymbol(prop) ? 8 : 0);
            var inferredProp = createSymbol(4 | prop.flags & optionalMask, prop.escapedName, checkFlags);
            inferredProp.declarations = prop.declarations;
            inferredProp.nameType = getSymbolLinks(prop).nameType;
            inferredProp.propertyType = getTypeOfSymbol(prop);
            if (type3.constraintType.type.flags & 8388608 && type3.constraintType.type.objectType.flags & 262144 && type3.constraintType.type.indexType.flags & 262144) {
              var newTypeParam = type3.constraintType.type.objectType;
              var newMappedType = replaceIndexedAccess(type3.mappedType, type3.constraintType.type, newTypeParam);
              inferredProp.mappedType = newMappedType;
              inferredProp.constraintType = getIndexType(newTypeParam);
            } else {
              inferredProp.mappedType = type3.mappedType;
              inferredProp.constraintType = type3.constraintType;
            }
            members.set(prop.escapedName, inferredProp);
          }
          setStructuredTypeMembers(type3, members, ts3.emptyArray, ts3.emptyArray, stringIndexInfo, void 0);
        }
        function getLowerBoundOfKeyType(type3) {
          if (type3.flags & 4194304) {
            var t2 = getApparentType(type3.type);
            return isGenericTupleType(t2) ? getKnownKeysOfTupleType(t2) : getIndexType(t2);
          }
          if (type3.flags & 16777216) {
            if (type3.root.isDistributive) {
              var checkType = type3.checkType;
              var constraint = getLowerBoundOfKeyType(checkType);
              if (constraint !== checkType) {
                return getConditionalTypeInstantiation(type3, prependTypeMapping(type3.root.checkType, constraint, type3.mapper));
              }
            }
            return type3;
          }
          if (type3.flags & 1048576) {
            return mapType(type3, getLowerBoundOfKeyType);
          }
          if (type3.flags & 2097152) {
            return getIntersectionType(ts3.sameMap(type3.types, getLowerBoundOfKeyType));
          }
          return type3;
        }
        function getIsLateCheckFlag(s2) {
          return ts3.getCheckFlags(s2) & 4096;
        }
        function resolveMappedTypeMembers(type3) {
          var members = ts3.createSymbolTable();
          var stringIndexInfo;
          var numberIndexInfo;
          setStructuredTypeMembers(type3, emptySymbols, ts3.emptyArray, ts3.emptyArray, void 0, void 0);
          var typeParameter = getTypeParameterFromMappedType(type3);
          var constraintType = getConstraintTypeFromMappedType(type3);
          var nameType = getNameTypeFromMappedType(type3.target || type3);
          var templateType = getTemplateTypeFromMappedType(type3.target || type3);
          var modifiersType = getApparentType(getModifiersTypeFromMappedType(type3));
          var templateModifiers = getMappedTypeModifiers(type3);
          var include = keyofStringsOnly ? 128 : 8576;
          if (isMappedTypeWithKeyofConstraintDeclaration(type3)) {
            for (var _i = 0, _a2 = getPropertiesOfType(modifiersType); _i < _a2.length; _i++) {
              var prop = _a2[_i];
              addMemberForKeyType(getLiteralTypeFromProperty(prop, include));
            }
            if (modifiersType.flags & 1 || getIndexInfoOfType(modifiersType, 0)) {
              addMemberForKeyType(stringType);
            }
            if (!keyofStringsOnly && getIndexInfoOfType(modifiersType, 1)) {
              addMemberForKeyType(numberType);
            }
          } else {
            forEachType(getLowerBoundOfKeyType(constraintType), addMemberForKeyType);
          }
          setStructuredTypeMembers(type3, members, ts3.emptyArray, ts3.emptyArray, stringIndexInfo, numberIndexInfo);
          function addMemberForKeyType(keyType) {
            var propNameType = nameType ? instantiateType(nameType, appendTypeMapping(type3.mapper, typeParameter, keyType)) : keyType;
            forEachType(propNameType, function(t2) {
              return addMemberForKeyTypeWorker(keyType, t2);
            });
          }
          function addMemberForKeyTypeWorker(keyType, propNameType) {
            if (isTypeUsableAsPropertyName(propNameType)) {
              var propName = getPropertyNameFromType(propNameType);
              var existingProp = members.get(propName);
              if (existingProp) {
                existingProp.nameType = getUnionType([existingProp.nameType, propNameType]);
                existingProp.keyType = getUnionType([existingProp.keyType, keyType]);
              } else {
                var modifiersProp = isTypeUsableAsPropertyName(keyType) ? getPropertyOfType(modifiersType, getPropertyNameFromType(keyType)) : void 0;
                var isOptional = !!(templateModifiers & 4 || !(templateModifiers & 8) && modifiersProp && modifiersProp.flags & 16777216);
                var isReadonly = !!(templateModifiers & 1 || !(templateModifiers & 2) && modifiersProp && isReadonlySymbol(modifiersProp));
                var stripOptional = strictNullChecks && !isOptional && modifiersProp && modifiersProp.flags & 16777216;
                var lateFlag = modifiersProp ? getIsLateCheckFlag(modifiersProp) : 0;
                var prop2 = createSymbol(4 | (isOptional ? 16777216 : 0), propName, lateFlag | 262144 | (isReadonly ? 8 : 0) | (stripOptional ? 524288 : 0));
                prop2.mappedType = type3;
                prop2.nameType = propNameType;
                prop2.keyType = keyType;
                if (modifiersProp) {
                  prop2.syntheticOrigin = modifiersProp;
                  prop2.declarations = modifiersProp.declarations;
                }
                members.set(propName, prop2);
              }
            } else if (propNameType.flags & (1 | 4 | 8 | 32)) {
              var propType = instantiateType(templateType, appendTypeMapping(type3.mapper, typeParameter, keyType));
              if (propNameType.flags & (1 | 4)) {
                stringIndexInfo = createIndexInfo(stringIndexInfo ? getUnionType([stringIndexInfo.type, propType]) : propType, !!(templateModifiers & 1));
              } else {
                numberIndexInfo = createIndexInfo(numberIndexInfo ? getUnionType([numberIndexInfo.type, propType]) : propType, !!(templateModifiers & 1));
              }
            }
          }
        }
        function getTypeOfMappedSymbol(symbol) {
          if (!symbol.type) {
            var mappedType = symbol.mappedType;
            if (!pushTypeResolution(symbol, 0)) {
              mappedType.containsError = true;
              return errorType;
            }
            var templateType = getTemplateTypeFromMappedType(mappedType.target || mappedType);
            var mapper = appendTypeMapping(mappedType.mapper, getTypeParameterFromMappedType(mappedType), symbol.keyType);
            var propType = instantiateType(templateType, mapper);
            var type3 = strictNullChecks && symbol.flags & 16777216 && !maybeTypeOfKind(propType, 32768 | 16384) ? getOptionalType(propType) : symbol.checkFlags & 524288 ? getTypeWithFacts(propType, 524288) : propType;
            if (!popTypeResolution()) {
              error(currentNode, ts3.Diagnostics.Type_of_property_0_circularly_references_itself_in_mapped_type_1, symbolToString(symbol), typeToString(mappedType));
              type3 = errorType;
            }
            symbol.type = type3;
          }
          return symbol.type;
        }
        function getTypeParameterFromMappedType(type3) {
          return type3.typeParameter || (type3.typeParameter = getDeclaredTypeOfTypeParameter(getSymbolOfNode(type3.declaration.typeParameter)));
        }
        function getConstraintTypeFromMappedType(type3) {
          return type3.constraintType || (type3.constraintType = getConstraintOfTypeParameter(getTypeParameterFromMappedType(type3)) || errorType);
        }
        function getNameTypeFromMappedType(type3) {
          return type3.declaration.nameType ? type3.nameType || (type3.nameType = instantiateType(getTypeFromTypeNode(type3.declaration.nameType), type3.mapper)) : void 0;
        }
        function getTemplateTypeFromMappedType(type3) {
          return type3.templateType || (type3.templateType = type3.declaration.type ? instantiateType(addOptionality(getTypeFromTypeNode(type3.declaration.type), !!(getMappedTypeModifiers(type3) & 4)), type3.mapper) : errorType);
        }
        function getConstraintDeclarationForMappedType(type3) {
          return ts3.getEffectiveConstraintOfTypeParameter(type3.declaration.typeParameter);
        }
        function isMappedTypeWithKeyofConstraintDeclaration(type3) {
          var constraintDeclaration = getConstraintDeclarationForMappedType(type3);
          return constraintDeclaration.kind === 189 && constraintDeclaration.operator === 138;
        }
        function getModifiersTypeFromMappedType(type3) {
          if (!type3.modifiersType) {
            if (isMappedTypeWithKeyofConstraintDeclaration(type3)) {
              type3.modifiersType = instantiateType(getTypeFromTypeNode(getConstraintDeclarationForMappedType(type3).type), type3.mapper);
            } else {
              var declaredType = getTypeFromMappedTypeNode(type3.declaration);
              var constraint = getConstraintTypeFromMappedType(declaredType);
              var extendedConstraint = constraint && constraint.flags & 262144 ? getConstraintOfTypeParameter(constraint) : constraint;
              type3.modifiersType = extendedConstraint && extendedConstraint.flags & 4194304 ? instantiateType(extendedConstraint.type, type3.mapper) : unknownType;
            }
          }
          return type3.modifiersType;
        }
        function getMappedTypeModifiers(type3) {
          var declaration = type3.declaration;
          return (declaration.readonlyToken ? declaration.readonlyToken.kind === 40 ? 2 : 1 : 0) | (declaration.questionToken ? declaration.questionToken.kind === 40 ? 8 : 4 : 0);
        }
        function getMappedTypeOptionality(type3) {
          var modifiers = getMappedTypeModifiers(type3);
          return modifiers & 8 ? -1 : modifiers & 4 ? 1 : 0;
        }
        function getCombinedMappedTypeOptionality(type3) {
          var optionality = getMappedTypeOptionality(type3);
          var modifiersType = getModifiersTypeFromMappedType(type3);
          return optionality || (isGenericMappedType(modifiersType) ? getMappedTypeOptionality(modifiersType) : 0);
        }
        function isPartialMappedType(type3) {
          return !!(ts3.getObjectFlags(type3) & 32 && getMappedTypeModifiers(type3) & 4);
        }
        function isGenericMappedType(type3) {
          return !!(ts3.getObjectFlags(type3) & 32) && isGenericIndexType(getConstraintTypeFromMappedType(type3));
        }
        function resolveStructuredTypeMembers(type3) {
          if (!type3.members) {
            if (type3.flags & 524288) {
              if (type3.objectFlags & 4) {
                resolveTypeReferenceMembers(type3);
              } else if (type3.objectFlags & 3) {
                resolveClassOrInterfaceMembers(type3);
              } else if (type3.objectFlags & 1024) {
                resolveReverseMappedTypeMembers(type3);
              } else if (type3.objectFlags & 16) {
                resolveAnonymousTypeMembers(type3);
              } else if (type3.objectFlags & 32) {
                resolveMappedTypeMembers(type3);
              }
            } else if (type3.flags & 1048576) {
              resolveUnionTypeMembers(type3);
            } else if (type3.flags & 2097152) {
              resolveIntersectionTypeMembers(type3);
            }
          }
          return type3;
        }
        function getPropertiesOfObjectType(type3) {
          if (type3.flags & 524288) {
            return resolveStructuredTypeMembers(type3).properties;
          }
          return ts3.emptyArray;
        }
        function getPropertyOfObjectType(type3, name) {
          if (type3.flags & 524288) {
            var resolved = resolveStructuredTypeMembers(type3);
            var symbol = resolved.members.get(name);
            if (symbol && symbolIsValue(symbol)) {
              return symbol;
            }
          }
        }
        function getPropertiesOfUnionOrIntersectionType(type3) {
          if (!type3.resolvedProperties) {
            var members = ts3.createSymbolTable();
            for (var _i = 0, _a2 = type3.types; _i < _a2.length; _i++) {
              var current = _a2[_i];
              for (var _b = 0, _c = getPropertiesOfType(current); _b < _c.length; _b++) {
                var prop = _c[_b];
                if (!members.has(prop.escapedName)) {
                  var combinedProp = getPropertyOfUnionOrIntersectionType(type3, prop.escapedName);
                  if (combinedProp) {
                    members.set(prop.escapedName, combinedProp);
                  }
                }
              }
              if (type3.flags & 1048576 && !getIndexInfoOfType(current, 0) && !getIndexInfoOfType(current, 1)) {
                break;
              }
            }
            type3.resolvedProperties = getNamedMembers(members);
          }
          return type3.resolvedProperties;
        }
        function getPropertiesOfType(type3) {
          type3 = getReducedApparentType(type3);
          return type3.flags & 3145728 ? getPropertiesOfUnionOrIntersectionType(type3) : getPropertiesOfObjectType(type3);
        }
        function isTypeInvalidDueToUnionDiscriminant(contextualType, obj) {
          var list = obj.properties;
          return list.some(function(property) {
            var nameType = property.name && getLiteralTypeFromPropertyName(property.name);
            var name = nameType && isTypeUsableAsPropertyName(nameType) ? getPropertyNameFromType(nameType) : void 0;
            var expected = name === void 0 ? void 0 : getTypeOfPropertyOfType(contextualType, name);
            return !!expected && isLiteralType(expected) && !isTypeAssignableTo(getTypeOfNode(property), expected);
          });
        }
        function getAllPossiblePropertiesOfTypes(types2) {
          var unionType = getUnionType(types2);
          if (!(unionType.flags & 1048576)) {
            return getAugmentedPropertiesOfType(unionType);
          }
          var props = ts3.createSymbolTable();
          for (var _i = 0, types_5 = types2; _i < types_5.length; _i++) {
            var memberType = types_5[_i];
            for (var _a2 = 0, _b = getAugmentedPropertiesOfType(memberType); _a2 < _b.length; _a2++) {
              var escapedName = _b[_a2].escapedName;
              if (!props.has(escapedName)) {
                var prop = createUnionOrIntersectionProperty(unionType, escapedName);
                if (prop)
                  props.set(escapedName, prop);
              }
            }
          }
          return ts3.arrayFrom(props.values());
        }
        function getConstraintOfType(type3) {
          return type3.flags & 262144 ? getConstraintOfTypeParameter(type3) : type3.flags & 8388608 ? getConstraintOfIndexedAccess(type3) : type3.flags & 16777216 ? getConstraintOfConditionalType(type3) : getBaseConstraintOfType(type3);
        }
        function getConstraintOfTypeParameter(typeParameter) {
          return hasNonCircularBaseConstraint(typeParameter) ? getConstraintFromTypeParameter(typeParameter) : void 0;
        }
        function getConstraintOfIndexedAccess(type3) {
          return hasNonCircularBaseConstraint(type3) ? getConstraintFromIndexedAccess(type3) : void 0;
        }
        function getSimplifiedTypeOrConstraint(type3) {
          var simplified = getSimplifiedType(type3, false);
          return simplified !== type3 ? simplified : getConstraintOfType(type3);
        }
        function getConstraintFromIndexedAccess(type3) {
          var indexConstraint = getSimplifiedTypeOrConstraint(type3.indexType);
          if (indexConstraint && indexConstraint !== type3.indexType) {
            var indexedAccess = getIndexedAccessTypeOrUndefined(type3.objectType, indexConstraint, type3.noUncheckedIndexedAccessCandidate);
            if (indexedAccess) {
              return indexedAccess;
            }
          }
          var objectConstraint = getSimplifiedTypeOrConstraint(type3.objectType);
          if (objectConstraint && objectConstraint !== type3.objectType) {
            return getIndexedAccessTypeOrUndefined(objectConstraint, type3.indexType, type3.noUncheckedIndexedAccessCandidate);
          }
          return void 0;
        }
        function getDefaultConstraintOfConditionalType(type3) {
          if (!type3.resolvedDefaultConstraint) {
            var trueConstraint = getInferredTrueTypeFromConditionalType(type3);
            var falseConstraint = getFalseTypeFromConditionalType(type3);
            type3.resolvedDefaultConstraint = isTypeAny(trueConstraint) ? falseConstraint : isTypeAny(falseConstraint) ? trueConstraint : getUnionType([trueConstraint, falseConstraint]);
          }
          return type3.resolvedDefaultConstraint;
        }
        function getConstraintOfDistributiveConditionalType(type3) {
          if (type3.root.isDistributive && type3.restrictiveInstantiation !== type3) {
            var simplified = getSimplifiedType(type3.checkType, false);
            var constraint = simplified === type3.checkType ? getConstraintOfType(simplified) : simplified;
            if (constraint && constraint !== type3.checkType) {
              var instantiated = getConditionalTypeInstantiation(type3, prependTypeMapping(type3.root.checkType, constraint, type3.mapper));
              if (!(instantiated.flags & 131072)) {
                return instantiated;
              }
            }
          }
          return void 0;
        }
        function getConstraintFromConditionalType(type3) {
          return getConstraintOfDistributiveConditionalType(type3) || getDefaultConstraintOfConditionalType(type3);
        }
        function getConstraintOfConditionalType(type3) {
          return hasNonCircularBaseConstraint(type3) ? getConstraintFromConditionalType(type3) : void 0;
        }
        function getEffectiveConstraintOfIntersection(types2, targetIsUnion) {
          var constraints;
          var hasDisjointDomainType = false;
          for (var _i = 0, types_6 = types2; _i < types_6.length; _i++) {
            var t2 = types_6[_i];
            if (t2.flags & 465829888) {
              var constraint = getConstraintOfType(t2);
              while (constraint && constraint.flags & (262144 | 4194304 | 16777216)) {
                constraint = getConstraintOfType(constraint);
              }
              if (constraint) {
                constraints = ts3.append(constraints, constraint);
                if (targetIsUnion) {
                  constraints = ts3.append(constraints, t2);
                }
              }
            } else if (t2.flags & 469892092) {
              hasDisjointDomainType = true;
            }
          }
          if (constraints && (targetIsUnion || hasDisjointDomainType)) {
            if (hasDisjointDomainType) {
              for (var _a2 = 0, types_7 = types2; _a2 < types_7.length; _a2++) {
                var t2 = types_7[_a2];
                if (t2.flags & 469892092) {
                  constraints = ts3.append(constraints, t2);
                }
              }
            }
            return getIntersectionType(constraints);
          }
          return void 0;
        }
        function getBaseConstraintOfType(type3) {
          if (type3.flags & (58982400 | 3145728 | 134217728 | 268435456)) {
            var constraint = getResolvedBaseConstraint(type3);
            return constraint !== noConstraintType && constraint !== circularConstraintType ? constraint : void 0;
          }
          return type3.flags & 4194304 ? keyofConstraintType : void 0;
        }
        function getBaseConstraintOrType(type3) {
          return getBaseConstraintOfType(type3) || type3;
        }
        function hasNonCircularBaseConstraint(type3) {
          return getResolvedBaseConstraint(type3) !== circularConstraintType;
        }
        function getResolvedBaseConstraint(type3) {
          if (type3.resolvedBaseConstraint) {
            return type3.resolvedBaseConstraint;
          }
          var stack = [];
          return type3.resolvedBaseConstraint = getTypeWithThisArgument(getImmediateBaseConstraint(type3), type3);
          function getImmediateBaseConstraint(t2) {
            if (!t2.immediateBaseConstraint) {
              if (!pushTypeResolution(t2, 4)) {
                return circularConstraintType;
              }
              var result2 = void 0;
              if (stack.length < 10 || stack.length < 50 && !isDeeplyNestedType(t2, stack, stack.length)) {
                stack.push(t2);
                result2 = computeBaseConstraint(getSimplifiedType(t2, false));
                stack.pop();
              }
              if (!popTypeResolution()) {
                if (t2.flags & 262144) {
                  var errorNode = getConstraintDeclaration(t2);
                  if (errorNode) {
                    var diagnostic = error(errorNode, ts3.Diagnostics.Type_parameter_0_has_a_circular_constraint, typeToString(t2));
                    if (currentNode && !ts3.isNodeDescendantOf(errorNode, currentNode) && !ts3.isNodeDescendantOf(currentNode, errorNode)) {
                      ts3.addRelatedInfo(diagnostic, ts3.createDiagnosticForNode(currentNode, ts3.Diagnostics.Circularity_originates_in_type_at_this_location));
                    }
                  }
                }
                result2 = circularConstraintType;
              }
              t2.immediateBaseConstraint = result2 || noConstraintType;
            }
            return t2.immediateBaseConstraint;
          }
          function getBaseConstraint(t2) {
            var c2 = getImmediateBaseConstraint(t2);
            return c2 !== noConstraintType && c2 !== circularConstraintType ? c2 : void 0;
          }
          function computeBaseConstraint(t2) {
            if (t2.flags & 262144) {
              var constraint = getConstraintFromTypeParameter(t2);
              return t2.isThisType || !constraint ? constraint : getBaseConstraint(constraint);
            }
            if (t2.flags & 3145728) {
              var types2 = t2.types;
              var baseTypes = [];
              var different = false;
              for (var _i = 0, types_8 = types2; _i < types_8.length; _i++) {
                var type_3 = types_8[_i];
                var baseType = getBaseConstraint(type_3);
                if (baseType) {
                  if (baseType !== type_3) {
                    different = true;
                  }
                  baseTypes.push(baseType);
                } else {
                  different = true;
                }
              }
              if (!different) {
                return t2;
              }
              return t2.flags & 1048576 && baseTypes.length === types2.length ? getUnionType(baseTypes) : t2.flags & 2097152 && baseTypes.length ? getIntersectionType(baseTypes) : void 0;
            }
            if (t2.flags & 4194304) {
              return keyofConstraintType;
            }
            if (t2.flags & 134217728) {
              var types2 = t2.types;
              var constraints = ts3.mapDefined(types2, getBaseConstraint);
              return constraints.length === types2.length ? getTemplateLiteralType(t2.texts, constraints) : stringType;
            }
            if (t2.flags & 268435456) {
              var constraint = getBaseConstraint(t2.type);
              return constraint ? getStringMappingType(t2.symbol, constraint) : stringType;
            }
            if (t2.flags & 8388608) {
              var baseObjectType = getBaseConstraint(t2.objectType);
              var baseIndexType = getBaseConstraint(t2.indexType);
              var baseIndexedAccess = baseObjectType && baseIndexType && getIndexedAccessTypeOrUndefined(baseObjectType, baseIndexType, t2.noUncheckedIndexedAccessCandidate);
              return baseIndexedAccess && getBaseConstraint(baseIndexedAccess);
            }
            if (t2.flags & 16777216) {
              var constraint = getConstraintFromConditionalType(t2);
              return constraint && getBaseConstraint(constraint);
            }
            if (t2.flags & 33554432) {
              return getBaseConstraint(t2.substitute);
            }
            return t2;
          }
        }
        function getApparentTypeOfIntersectionType(type3) {
          return type3.resolvedApparentType || (type3.resolvedApparentType = getTypeWithThisArgument(type3, type3, true));
        }
        function getResolvedTypeParameterDefault(typeParameter) {
          if (!typeParameter.default) {
            if (typeParameter.target) {
              var targetDefault = getResolvedTypeParameterDefault(typeParameter.target);
              typeParameter.default = targetDefault ? instantiateType(targetDefault, typeParameter.mapper) : noConstraintType;
            } else {
              typeParameter.default = resolvingDefaultType;
              var defaultDeclaration = typeParameter.symbol && ts3.forEach(typeParameter.symbol.declarations, function(decl) {
                return ts3.isTypeParameterDeclaration(decl) && decl.default;
              });
              var defaultType = defaultDeclaration ? getTypeFromTypeNode(defaultDeclaration) : noConstraintType;
              if (typeParameter.default === resolvingDefaultType) {
                typeParameter.default = defaultType;
              }
            }
          } else if (typeParameter.default === resolvingDefaultType) {
            typeParameter.default = circularConstraintType;
          }
          return typeParameter.default;
        }
        function getDefaultFromTypeParameter(typeParameter) {
          var defaultType = getResolvedTypeParameterDefault(typeParameter);
          return defaultType !== noConstraintType && defaultType !== circularConstraintType ? defaultType : void 0;
        }
        function hasNonCircularTypeParameterDefault(typeParameter) {
          return getResolvedTypeParameterDefault(typeParameter) !== circularConstraintType;
        }
        function hasTypeParameterDefault(typeParameter) {
          return !!(typeParameter.symbol && ts3.forEach(typeParameter.symbol.declarations, function(decl) {
            return ts3.isTypeParameterDeclaration(decl) && decl.default;
          }));
        }
        function getApparentTypeOfMappedType(type3) {
          return type3.resolvedApparentType || (type3.resolvedApparentType = getResolvedApparentTypeOfMappedType(type3));
        }
        function getResolvedApparentTypeOfMappedType(type3) {
          var typeVariable = getHomomorphicTypeVariable(type3);
          if (typeVariable && !type3.declaration.nameType) {
            var constraint = getConstraintOfTypeParameter(typeVariable);
            if (constraint && (isArrayType(constraint) || isTupleType(constraint))) {
              return instantiateType(type3, prependTypeMapping(typeVariable, constraint, type3.mapper));
            }
          }
          return type3;
        }
        function getApparentType(type3) {
          var t2 = type3.flags & 465829888 ? getBaseConstraintOfType(type3) || unknownType : type3;
          return ts3.getObjectFlags(t2) & 32 ? getApparentTypeOfMappedType(t2) : t2.flags & 2097152 ? getApparentTypeOfIntersectionType(t2) : t2.flags & 402653316 ? globalStringType : t2.flags & 296 ? globalNumberType : t2.flags & 2112 ? getGlobalBigIntType(languageVersion >= 7) : t2.flags & 528 ? globalBooleanType : t2.flags & 12288 ? getGlobalESSymbolType(languageVersion >= 2) : t2.flags & 67108864 ? emptyObjectType : t2.flags & 4194304 ? keyofConstraintType : t2.flags & 2 && !strictNullChecks ? emptyObjectType : t2;
        }
        function getReducedApparentType(type3) {
          return getReducedType(getApparentType(getReducedType(type3)));
        }
        function createUnionOrIntersectionProperty(containingType, name, skipObjectFunctionPropertyAugment) {
          var _a2, _b;
          var singleProp;
          var propSet;
          var indexTypes;
          var isUnion = containingType.flags & 1048576;
          var optionalFlag = isUnion ? 0 : 16777216;
          var syntheticFlag = 4;
          var checkFlags = 0;
          var mergedInstantiations = false;
          for (var _i = 0, _c = containingType.types; _i < _c.length; _i++) {
            var current = _c[_i];
            var type3 = getApparentType(current);
            if (!(type3 === errorType || type3.flags & 131072)) {
              var prop = getPropertyOfType(type3, name, skipObjectFunctionPropertyAugment);
              var modifiers = prop ? ts3.getDeclarationModifierFlagsFromSymbol(prop) : 0;
              if (prop) {
                if (isUnion) {
                  optionalFlag |= prop.flags & 16777216;
                } else {
                  optionalFlag &= prop.flags;
                }
                if (!singleProp) {
                  singleProp = prop;
                } else if (prop !== singleProp) {
                  var isInstantiation = (getTargetSymbol(prop) || prop) === (getTargetSymbol(singleProp) || singleProp);
                  if (isInstantiation && compareProperties(singleProp, prop, function(a2, b2) {
                    return a2 === b2 ? -1 : 0;
                  }) === -1) {
                    mergedInstantiations = !!singleProp.parent && !!ts3.length(getLocalTypeParametersOfClassOrInterfaceOrTypeAlias(singleProp.parent));
                  } else {
                    if (!propSet) {
                      propSet = new ts3.Map();
                      propSet.set(getSymbolId(singleProp), singleProp);
                    }
                    var id = getSymbolId(prop);
                    if (!propSet.has(id)) {
                      propSet.set(id, prop);
                    }
                  }
                }
                checkFlags |= (isReadonlySymbol(prop) ? 8 : 0) | (!(modifiers & 24) ? 256 : 0) | (modifiers & 16 ? 512 : 0) | (modifiers & 8 ? 1024 : 0) | (modifiers & 32 ? 2048 : 0);
                if (!isPrototypeProperty(prop)) {
                  syntheticFlag = 2;
                }
              } else if (isUnion) {
                var indexInfo = !isLateBoundName(name) && (isNumericLiteralName(name) && getIndexInfoOfType(type3, 1) || getIndexInfoOfType(type3, 0));
                if (indexInfo) {
                  checkFlags |= 32 | (indexInfo.isReadonly ? 8 : 0);
                  indexTypes = ts3.append(indexTypes, isTupleType(type3) ? getRestTypeOfTupleType(type3) || undefinedType : indexInfo.type);
                } else if (isObjectLiteralType(type3) && !(ts3.getObjectFlags(type3) & 4194304)) {
                  checkFlags |= 32;
                  indexTypes = ts3.append(indexTypes, undefinedType);
                } else {
                  checkFlags |= 16;
                }
              }
            }
          }
          if (!singleProp || isUnion && (propSet || checkFlags & 48) && checkFlags & (1024 | 512)) {
            return void 0;
          }
          if (!propSet && !(checkFlags & 16) && !indexTypes) {
            if (mergedInstantiations) {
              var clone_1 = createSymbolWithType(singleProp, singleProp.type);
              clone_1.parent = (_b = (_a2 = singleProp.valueDeclaration) === null || _a2 === void 0 ? void 0 : _a2.symbol) === null || _b === void 0 ? void 0 : _b.parent;
              clone_1.containingType = containingType;
              clone_1.mapper = singleProp.mapper;
              return clone_1;
            } else {
              return singleProp;
            }
          }
          var props = propSet ? ts3.arrayFrom(propSet.values()) : [singleProp];
          var declarations;
          var firstType;
          var nameType;
          var propTypes = [];
          var firstValueDeclaration;
          var hasNonUniformValueDeclaration = false;
          for (var _d = 0, props_1 = props; _d < props_1.length; _d++) {
            var prop = props_1[_d];
            if (!firstValueDeclaration) {
              firstValueDeclaration = prop.valueDeclaration;
            } else if (prop.valueDeclaration && prop.valueDeclaration !== firstValueDeclaration) {
              hasNonUniformValueDeclaration = true;
            }
            declarations = ts3.addRange(declarations, prop.declarations);
            var type3 = getTypeOfSymbol(prop);
            if (!firstType) {
              firstType = type3;
              nameType = getSymbolLinks(prop).nameType;
            } else if (type3 !== firstType) {
              checkFlags |= 64;
            }
            if (isLiteralType(type3)) {
              checkFlags |= 128;
            }
            if (type3.flags & 131072) {
              checkFlags |= 131072;
            }
            propTypes.push(type3);
          }
          ts3.addRange(propTypes, indexTypes);
          var result2 = createSymbol(4 | optionalFlag, name, syntheticFlag | checkFlags);
          result2.containingType = containingType;
          if (!hasNonUniformValueDeclaration && firstValueDeclaration) {
            result2.valueDeclaration = firstValueDeclaration;
            if (firstValueDeclaration.symbol.parent) {
              result2.parent = firstValueDeclaration.symbol.parent;
            }
          }
          result2.declarations = declarations;
          result2.nameType = nameType;
          if (propTypes.length > 2) {
            result2.checkFlags |= 65536;
            result2.deferralParent = containingType;
            result2.deferralConstituents = propTypes;
          } else {
            result2.type = isUnion ? getUnionType(propTypes) : getIntersectionType(propTypes);
          }
          return result2;
        }
        function getUnionOrIntersectionProperty(type3, name, skipObjectFunctionPropertyAugment) {
          var _a2, _b;
          var property = ((_a2 = type3.propertyCacheWithoutObjectFunctionPropertyAugment) === null || _a2 === void 0 ? void 0 : _a2.get(name)) || !skipObjectFunctionPropertyAugment ? (_b = type3.propertyCache) === null || _b === void 0 ? void 0 : _b.get(name) : void 0;
          if (!property) {
            property = createUnionOrIntersectionProperty(type3, name, skipObjectFunctionPropertyAugment);
            if (property) {
              var properties = skipObjectFunctionPropertyAugment ? type3.propertyCacheWithoutObjectFunctionPropertyAugment || (type3.propertyCacheWithoutObjectFunctionPropertyAugment = ts3.createSymbolTable()) : type3.propertyCache || (type3.propertyCache = ts3.createSymbolTable());
              properties.set(name, property);
            }
          }
          return property;
        }
        function getPropertyOfUnionOrIntersectionType(type3, name, skipObjectFunctionPropertyAugment) {
          var property = getUnionOrIntersectionProperty(type3, name, skipObjectFunctionPropertyAugment);
          return property && !(ts3.getCheckFlags(property) & 16) ? property : void 0;
        }
        function getReducedType(type3) {
          if (type3.flags & 1048576 && type3.objectFlags & 67108864) {
            return type3.resolvedReducedType || (type3.resolvedReducedType = getReducedUnionType(type3));
          } else if (type3.flags & 2097152) {
            if (!(type3.objectFlags & 67108864)) {
              type3.objectFlags |= 67108864 | (ts3.some(getPropertiesOfUnionOrIntersectionType(type3), isNeverReducedProperty) ? 134217728 : 0);
            }
            return type3.objectFlags & 134217728 ? neverType : type3;
          }
          return type3;
        }
        function getReducedUnionType(unionType) {
          var reducedTypes = ts3.sameMap(unionType.types, getReducedType);
          if (reducedTypes === unionType.types) {
            return unionType;
          }
          var reduced = getUnionType(reducedTypes);
          if (reduced.flags & 1048576) {
            reduced.resolvedReducedType = reduced;
          }
          return reduced;
        }
        function isNeverReducedProperty(prop) {
          return isDiscriminantWithNeverType(prop) || isConflictingPrivateProperty(prop);
        }
        function isDiscriminantWithNeverType(prop) {
          return !(prop.flags & 16777216) && (ts3.getCheckFlags(prop) & (192 | 131072)) === 192 && !!(getTypeOfSymbol(prop).flags & 131072);
        }
        function isConflictingPrivateProperty(prop) {
          return !prop.valueDeclaration && !!(ts3.getCheckFlags(prop) & 1024);
        }
        function elaborateNeverIntersection(errorInfo, type3) {
          if (type3.flags & 2097152 && ts3.getObjectFlags(type3) & 134217728) {
            var neverProp = ts3.find(getPropertiesOfUnionOrIntersectionType(type3), isDiscriminantWithNeverType);
            if (neverProp) {
              return ts3.chainDiagnosticMessages(errorInfo, ts3.Diagnostics.The_intersection_0_was_reduced_to_never_because_property_1_has_conflicting_types_in_some_constituents, typeToString(type3, void 0, 536870912), symbolToString(neverProp));
            }
            var privateProp = ts3.find(getPropertiesOfUnionOrIntersectionType(type3), isConflictingPrivateProperty);
            if (privateProp) {
              return ts3.chainDiagnosticMessages(errorInfo, ts3.Diagnostics.The_intersection_0_was_reduced_to_never_because_property_1_exists_in_multiple_constituents_and_is_private_in_some, typeToString(type3, void 0, 536870912), symbolToString(privateProp));
            }
          }
          return errorInfo;
        }
        function getPropertyOfType(type3, name, skipObjectFunctionPropertyAugment) {
          type3 = getReducedApparentType(type3);
          if (type3.flags & 524288) {
            var resolved = resolveStructuredTypeMembers(type3);
            var symbol = resolved.members.get(name);
            if (symbol && symbolIsValue(symbol)) {
              return symbol;
            }
            if (skipObjectFunctionPropertyAugment)
              return void 0;
            var functionType = resolved === anyFunctionType ? globalFunctionType : resolved.callSignatures.length ? globalCallableFunctionType : resolved.constructSignatures.length ? globalNewableFunctionType : void 0;
            if (functionType) {
              var symbol_1 = getPropertyOfObjectType(functionType, name);
              if (symbol_1) {
                return symbol_1;
              }
            }
            return getPropertyOfObjectType(globalObjectType, name);
          }
          if (type3.flags & 3145728) {
            return getPropertyOfUnionOrIntersectionType(type3, name, skipObjectFunctionPropertyAugment);
          }
          return void 0;
        }
        function getSignaturesOfStructuredType(type3, kind) {
          if (type3.flags & 3670016) {
            var resolved = resolveStructuredTypeMembers(type3);
            return kind === 0 ? resolved.callSignatures : resolved.constructSignatures;
          }
          return ts3.emptyArray;
        }
        function getSignaturesOfType(type3, kind) {
          return getSignaturesOfStructuredType(getReducedApparentType(type3), kind);
        }
        function getIndexInfoOfStructuredType(type3, kind) {
          if (type3.flags & 3670016) {
            var resolved = resolveStructuredTypeMembers(type3);
            return kind === 0 ? resolved.stringIndexInfo : resolved.numberIndexInfo;
          }
        }
        function getIndexTypeOfStructuredType(type3, kind) {
          var info = getIndexInfoOfStructuredType(type3, kind);
          return info && info.type;
        }
        function getIndexInfoOfType(type3, kind) {
          return getIndexInfoOfStructuredType(getReducedApparentType(type3), kind);
        }
        function getIndexTypeOfType(type3, kind) {
          return getIndexTypeOfStructuredType(getReducedApparentType(type3), kind);
        }
        function getImplicitIndexTypeOfType(type3, kind) {
          if (isObjectTypeWithInferableIndex(type3)) {
            var propTypes = [];
            for (var _i = 0, _a2 = getPropertiesOfType(type3); _i < _a2.length; _i++) {
              var prop = _a2[_i];
              if (kind === 0 || isNumericLiteralName(prop.escapedName)) {
                var propType = getTypeOfSymbol(prop);
                propTypes.push(prop.flags & 16777216 ? getTypeWithFacts(propType, 524288) : propType);
              }
            }
            if (kind === 0) {
              ts3.append(propTypes, getIndexTypeOfType(type3, 1));
            }
            if (propTypes.length) {
              return getUnionType(propTypes);
            }
          }
          return void 0;
        }
        function getTypeParametersFromDeclaration(declaration) {
          var result2;
          for (var _i = 0, _a2 = ts3.getEffectiveTypeParameterDeclarations(declaration); _i < _a2.length; _i++) {
            var node = _a2[_i];
            result2 = ts3.appendIfUnique(result2, getDeclaredTypeOfTypeParameter(node.symbol));
          }
          return result2;
        }
        function symbolsToArray(symbols) {
          var result2 = [];
          symbols.forEach(function(symbol, id) {
            if (!isReservedMemberName(id)) {
              result2.push(symbol);
            }
          });
          return result2;
        }
        function isJSDocOptionalParameter(node) {
          return ts3.isInJSFile(node) && (node.type && node.type.kind === 308 || ts3.getJSDocParameterTags(node).some(function(_a2) {
            var isBracketed = _a2.isBracketed, typeExpression = _a2.typeExpression;
            return isBracketed || !!typeExpression && typeExpression.type.kind === 308;
          }));
        }
        function tryFindAmbientModule(moduleName, withAugmentations) {
          if (ts3.isExternalModuleNameRelative(moduleName)) {
            return void 0;
          }
          var symbol = getSymbol(globals, '"' + moduleName + '"', 512);
          return symbol && withAugmentations ? getMergedSymbol(symbol) : symbol;
        }
        function isOptionalParameter(node) {
          if (ts3.hasQuestionToken(node) || isOptionalJSDocPropertyLikeTag(node) || isJSDocOptionalParameter(node)) {
            return true;
          }
          if (node.initializer) {
            var signature = getSignatureFromDeclaration(node.parent);
            var parameterIndex = node.parent.parameters.indexOf(node);
            ts3.Debug.assert(parameterIndex >= 0);
            return parameterIndex >= getMinArgumentCount(signature, 1 | 2);
          }
          var iife = ts3.getImmediatelyInvokedFunctionExpression(node.parent);
          if (iife) {
            return !node.type && !node.dotDotDotToken && node.parent.parameters.indexOf(node) >= iife.arguments.length;
          }
          return false;
        }
        function isOptionalPropertyDeclaration(node) {
          return ts3.isPropertyDeclaration(node) && node.questionToken;
        }
        function isOptionalJSDocPropertyLikeTag(node) {
          if (!ts3.isJSDocPropertyLikeTag(node)) {
            return false;
          }
          var isBracketed = node.isBracketed, typeExpression = node.typeExpression;
          return isBracketed || !!typeExpression && typeExpression.type.kind === 308;
        }
        function createTypePredicate(kind, parameterName, parameterIndex, type3) {
          return { kind, parameterName, parameterIndex, type: type3 };
        }
        function getMinTypeArgumentCount(typeParameters) {
          var minTypeArgumentCount = 0;
          if (typeParameters) {
            for (var i3 = 0; i3 < typeParameters.length; i3++) {
              if (!hasTypeParameterDefault(typeParameters[i3])) {
                minTypeArgumentCount = i3 + 1;
              }
            }
          }
          return minTypeArgumentCount;
        }
        function fillMissingTypeArguments(typeArguments, typeParameters, minTypeArgumentCount, isJavaScriptImplicitAny) {
          var numTypeParameters = ts3.length(typeParameters);
          if (!numTypeParameters) {
            return [];
          }
          var numTypeArguments = ts3.length(typeArguments);
          if (isJavaScriptImplicitAny || numTypeArguments >= minTypeArgumentCount && numTypeArguments <= numTypeParameters) {
            var result2 = typeArguments ? typeArguments.slice() : [];
            for (var i3 = numTypeArguments; i3 < numTypeParameters; i3++) {
              result2[i3] = errorType;
            }
            var baseDefaultType = getDefaultTypeArgumentType(isJavaScriptImplicitAny);
            for (var i3 = numTypeArguments; i3 < numTypeParameters; i3++) {
              var defaultType = getDefaultFromTypeParameter(typeParameters[i3]);
              if (isJavaScriptImplicitAny && defaultType && (isTypeIdenticalTo(defaultType, unknownType) || isTypeIdenticalTo(defaultType, emptyObjectType))) {
                defaultType = anyType;
              }
              result2[i3] = defaultType ? instantiateType(defaultType, createTypeMapper(typeParameters, result2)) : baseDefaultType;
            }
            result2.length = typeParameters.length;
            return result2;
          }
          return typeArguments && typeArguments.slice();
        }
        function getSignatureFromDeclaration(declaration) {
          var links = getNodeLinks(declaration);
          if (!links.resolvedSignature) {
            var parameters = [];
            var flags = 0;
            var minArgumentCount = 0;
            var thisParameter = void 0;
            var hasThisParameter = false;
            var iife = ts3.getImmediatelyInvokedFunctionExpression(declaration);
            var isJSConstructSignature = ts3.isJSDocConstructSignature(declaration);
            var isUntypedSignatureInJSFile = !iife && ts3.isInJSFile(declaration) && ts3.isValueSignatureDeclaration(declaration) && !ts3.hasJSDocParameterTags(declaration) && !ts3.getJSDocType(declaration);
            if (isUntypedSignatureInJSFile) {
              flags |= 32;
            }
            for (var i3 = isJSConstructSignature ? 1 : 0; i3 < declaration.parameters.length; i3++) {
              var param = declaration.parameters[i3];
              var paramSymbol = param.symbol;
              var type3 = ts3.isJSDocParameterTag(param) ? param.typeExpression && param.typeExpression.type : param.type;
              if (paramSymbol && !!(paramSymbol.flags & 4) && !ts3.isBindingPattern(param.name)) {
                var resolvedSymbol = resolveName(param, paramSymbol.escapedName, 111551, void 0, void 0, false);
                paramSymbol = resolvedSymbol;
              }
              if (i3 === 0 && paramSymbol.escapedName === "this") {
                hasThisParameter = true;
                thisParameter = param.symbol;
              } else {
                parameters.push(paramSymbol);
              }
              if (type3 && type3.kind === 192) {
                flags |= 2;
              }
              var isOptionalParameter_1 = isOptionalJSDocPropertyLikeTag(param) || param.initializer || param.questionToken || param.dotDotDotToken || iife && parameters.length > iife.arguments.length && !type3 || isJSDocOptionalParameter(param);
              if (!isOptionalParameter_1) {
                minArgumentCount = parameters.length;
              }
            }
            if ((declaration.kind === 168 || declaration.kind === 169) && hasBindableName(declaration) && (!hasThisParameter || !thisParameter)) {
              var otherKind = declaration.kind === 168 ? 169 : 168;
              var other = ts3.getDeclarationOfKind(getSymbolOfNode(declaration), otherKind);
              if (other) {
                thisParameter = getAnnotatedAccessorThisParameter(other);
              }
            }
            var classType = declaration.kind === 167 ? getDeclaredTypeOfClassOrInterface(getMergedSymbol(declaration.parent.symbol)) : void 0;
            var typeParameters = classType ? classType.localTypeParameters : getTypeParametersFromDeclaration(declaration);
            if (ts3.hasRestParameter(declaration) || ts3.isInJSFile(declaration) && maybeAddJsSyntheticRestParameter(declaration, parameters)) {
              flags |= 1;
            }
            if (ts3.isConstructorTypeNode(declaration) && ts3.hasSyntacticModifier(declaration, 128) || ts3.isConstructorDeclaration(declaration) && ts3.hasSyntacticModifier(declaration.parent, 128)) {
              flags |= 4;
            }
            links.resolvedSignature = createSignature(declaration, typeParameters, thisParameter, parameters, void 0, void 0, minArgumentCount, flags);
          }
          return links.resolvedSignature;
        }
        function maybeAddJsSyntheticRestParameter(declaration, parameters) {
          if (ts3.isJSDocSignature(declaration) || !containsArgumentsReference(declaration)) {
            return false;
          }
          var lastParam = ts3.lastOrUndefined(declaration.parameters);
          var lastParamTags = lastParam ? ts3.getJSDocParameterTags(lastParam) : ts3.getJSDocTags(declaration).filter(ts3.isJSDocParameterTag);
          var lastParamVariadicType = ts3.firstDefined(lastParamTags, function(p) {
            return p.typeExpression && ts3.isJSDocVariadicType(p.typeExpression.type) ? p.typeExpression.type : void 0;
          });
          var syntheticArgsSymbol = createSymbol(3, "args", 32768);
          syntheticArgsSymbol.type = lastParamVariadicType ? createArrayType(getTypeFromTypeNode(lastParamVariadicType.type)) : anyArrayType;
          if (lastParamVariadicType) {
            parameters.pop();
          }
          parameters.push(syntheticArgsSymbol);
          return true;
        }
        function getSignatureOfTypeTag(node) {
          if (!(ts3.isInJSFile(node) && ts3.isFunctionLikeDeclaration(node)))
            return void 0;
          var typeTag = ts3.getJSDocTypeTag(node);
          return (typeTag === null || typeTag === void 0 ? void 0 : typeTag.typeExpression) && getSingleCallSignature(getTypeFromTypeNode(typeTag.typeExpression));
        }
        function getReturnTypeOfTypeTag(node) {
          var signature = getSignatureOfTypeTag(node);
          return signature && getReturnTypeOfSignature(signature);
        }
        function containsArgumentsReference(declaration) {
          var links = getNodeLinks(declaration);
          if (links.containsArgumentsReference === void 0) {
            if (links.flags & 8192) {
              links.containsArgumentsReference = true;
            } else {
              links.containsArgumentsReference = traverse(declaration.body);
            }
          }
          return links.containsArgumentsReference;
          function traverse(node) {
            if (!node)
              return false;
            switch (node.kind) {
              case 78:
                return node.escapedText === argumentsSymbol.escapedName && getResolvedSymbol(node) === argumentsSymbol;
              case 164:
              case 166:
              case 168:
              case 169:
                return node.name.kind === 159 && traverse(node.name);
              case 202:
              case 203:
                return traverse(node.expression);
              default:
                return !ts3.nodeStartsNewLexicalEnvironment(node) && !ts3.isPartOfTypeNode(node) && !!ts3.forEachChild(node, traverse);
            }
          }
        }
        function getSignaturesOfSymbol(symbol) {
          if (!symbol || !symbol.declarations)
            return ts3.emptyArray;
          var result2 = [];
          for (var i3 = 0; i3 < symbol.declarations.length; i3++) {
            var decl = symbol.declarations[i3];
            if (!ts3.isFunctionLike(decl))
              continue;
            if (i3 > 0 && decl.body) {
              var previous = symbol.declarations[i3 - 1];
              if (decl.parent === previous.parent && decl.kind === previous.kind && decl.pos === previous.end) {
                continue;
              }
            }
            result2.push(getSignatureFromDeclaration(decl));
          }
          return result2;
        }
        function resolveExternalModuleTypeByLiteral(name) {
          var moduleSym = resolveExternalModuleName(name, name);
          if (moduleSym) {
            var resolvedModuleSymbol = resolveExternalModuleSymbol(moduleSym);
            if (resolvedModuleSymbol) {
              return getTypeOfSymbol(resolvedModuleSymbol);
            }
          }
          return anyType;
        }
        function getThisTypeOfSignature(signature) {
          if (signature.thisParameter) {
            return getTypeOfSymbol(signature.thisParameter);
          }
        }
        function getTypePredicateOfSignature(signature) {
          if (!signature.resolvedTypePredicate) {
            if (signature.target) {
              var targetTypePredicate = getTypePredicateOfSignature(signature.target);
              signature.resolvedTypePredicate = targetTypePredicate ? instantiateTypePredicate(targetTypePredicate, signature.mapper) : noTypePredicate;
            } else if (signature.compositeSignatures) {
              signature.resolvedTypePredicate = getUnionOrIntersectionTypePredicate(signature.compositeSignatures, signature.compositeKind) || noTypePredicate;
            } else {
              var type3 = signature.declaration && ts3.getEffectiveReturnTypeNode(signature.declaration);
              var jsdocPredicate = void 0;
              if (!type3 && ts3.isInJSFile(signature.declaration)) {
                var jsdocSignature = getSignatureOfTypeTag(signature.declaration);
                if (jsdocSignature && signature !== jsdocSignature) {
                  jsdocPredicate = getTypePredicateOfSignature(jsdocSignature);
                }
              }
              signature.resolvedTypePredicate = type3 && ts3.isTypePredicateNode(type3) ? createTypePredicateFromTypePredicateNode(type3, signature) : jsdocPredicate || noTypePredicate;
            }
            ts3.Debug.assert(!!signature.resolvedTypePredicate);
          }
          return signature.resolvedTypePredicate === noTypePredicate ? void 0 : signature.resolvedTypePredicate;
        }
        function createTypePredicateFromTypePredicateNode(node, signature) {
          var parameterName = node.parameterName;
          var type3 = node.type && getTypeFromTypeNode(node.type);
          return parameterName.kind === 188 ? createTypePredicate(node.assertsModifier ? 2 : 0, void 0, void 0, type3) : createTypePredicate(node.assertsModifier ? 3 : 1, parameterName.escapedText, ts3.findIndex(signature.parameters, function(p) {
            return p.escapedName === parameterName.escapedText;
          }), type3);
        }
        function getUnionOrIntersectionType(types2, kind, unionReduction) {
          return kind !== 2097152 ? getUnionType(types2, unionReduction) : getIntersectionType(types2);
        }
        function getReturnTypeOfSignature(signature) {
          if (!signature.resolvedReturnType) {
            if (!pushTypeResolution(signature, 3)) {
              return errorType;
            }
            var type3 = signature.target ? instantiateType(getReturnTypeOfSignature(signature.target), signature.mapper) : signature.compositeSignatures ? instantiateType(getUnionOrIntersectionType(ts3.map(signature.compositeSignatures, getReturnTypeOfSignature), signature.compositeKind, 2), signature.mapper) : getReturnTypeFromAnnotation(signature.declaration) || (ts3.nodeIsMissing(signature.declaration.body) ? anyType : getReturnTypeFromBody(signature.declaration));
            if (signature.flags & 8) {
              type3 = addOptionalTypeMarker(type3);
            } else if (signature.flags & 16) {
              type3 = getOptionalType(type3);
            }
            if (!popTypeResolution()) {
              if (signature.declaration) {
                var typeNode = ts3.getEffectiveReturnTypeNode(signature.declaration);
                if (typeNode) {
                  error(typeNode, ts3.Diagnostics.Return_type_annotation_circularly_references_itself);
                } else if (noImplicitAny) {
                  var declaration = signature.declaration;
                  var name = ts3.getNameOfDeclaration(declaration);
                  if (name) {
                    error(name, ts3.Diagnostics._0_implicitly_has_return_type_any_because_it_does_not_have_a_return_type_annotation_and_is_referenced_directly_or_indirectly_in_one_of_its_return_expressions, ts3.declarationNameToString(name));
                  } else {
                    error(declaration, ts3.Diagnostics.Function_implicitly_has_return_type_any_because_it_does_not_have_a_return_type_annotation_and_is_referenced_directly_or_indirectly_in_one_of_its_return_expressions);
                  }
                }
              }
              type3 = anyType;
            }
            signature.resolvedReturnType = type3;
          }
          return signature.resolvedReturnType;
        }
        function getReturnTypeFromAnnotation(declaration) {
          if (declaration.kind === 167) {
            return getDeclaredTypeOfClassOrInterface(getMergedSymbol(declaration.parent.symbol));
          }
          if (ts3.isJSDocConstructSignature(declaration)) {
            return getTypeFromTypeNode(declaration.parameters[0].type);
          }
          var typeNode = ts3.getEffectiveReturnTypeNode(declaration);
          if (typeNode) {
            return getTypeFromTypeNode(typeNode);
          }
          if (declaration.kind === 168 && hasBindableName(declaration)) {
            var jsDocType = ts3.isInJSFile(declaration) && getTypeForDeclarationFromJSDocComment(declaration);
            if (jsDocType) {
              return jsDocType;
            }
            var setter = ts3.getDeclarationOfKind(getSymbolOfNode(declaration), 169);
            var setterType = getAnnotatedAccessorType(setter);
            if (setterType) {
              return setterType;
            }
          }
          return getReturnTypeOfTypeTag(declaration);
        }
        function isResolvingReturnTypeOfSignature(signature) {
          return !signature.resolvedReturnType && findResolutionCycleStartIndex(signature, 3) >= 0;
        }
        function getRestTypeOfSignature(signature) {
          return tryGetRestTypeOfSignature(signature) || anyType;
        }
        function tryGetRestTypeOfSignature(signature) {
          if (signatureHasRestParameter(signature)) {
            var sigRestType = getTypeOfSymbol(signature.parameters[signature.parameters.length - 1]);
            var restType = isTupleType(sigRestType) ? getRestTypeOfTupleType(sigRestType) : sigRestType;
            return restType && getIndexTypeOfType(restType, 1);
          }
          return void 0;
        }
        function getSignatureInstantiation(signature, typeArguments, isJavascript, inferredTypeParameters) {
          var instantiatedSignature = getSignatureInstantiationWithoutFillingInTypeArguments(signature, fillMissingTypeArguments(typeArguments, signature.typeParameters, getMinTypeArgumentCount(signature.typeParameters), isJavascript));
          if (inferredTypeParameters) {
            var returnSignature = getSingleCallOrConstructSignature(getReturnTypeOfSignature(instantiatedSignature));
            if (returnSignature) {
              var newReturnSignature = cloneSignature(returnSignature);
              newReturnSignature.typeParameters = inferredTypeParameters;
              var newInstantiatedSignature = cloneSignature(instantiatedSignature);
              newInstantiatedSignature.resolvedReturnType = getOrCreateTypeFromSignature(newReturnSignature);
              return newInstantiatedSignature;
            }
          }
          return instantiatedSignature;
        }
        function getSignatureInstantiationWithoutFillingInTypeArguments(signature, typeArguments) {
          var instantiations = signature.instantiations || (signature.instantiations = new ts3.Map());
          var id = getTypeListId(typeArguments);
          var instantiation = instantiations.get(id);
          if (!instantiation) {
            instantiations.set(id, instantiation = createSignatureInstantiation(signature, typeArguments));
          }
          return instantiation;
        }
        function createSignatureInstantiation(signature, typeArguments) {
          return instantiateSignature(signature, createSignatureTypeMapper(signature, typeArguments), true);
        }
        function createSignatureTypeMapper(signature, typeArguments) {
          return createTypeMapper(signature.typeParameters, typeArguments);
        }
        function getErasedSignature(signature) {
          return signature.typeParameters ? signature.erasedSignatureCache || (signature.erasedSignatureCache = createErasedSignature(signature)) : signature;
        }
        function createErasedSignature(signature) {
          return instantiateSignature(signature, createTypeEraser(signature.typeParameters), true);
        }
        function getCanonicalSignature(signature) {
          return signature.typeParameters ? signature.canonicalSignatureCache || (signature.canonicalSignatureCache = createCanonicalSignature(signature)) : signature;
        }
        function createCanonicalSignature(signature) {
          return getSignatureInstantiation(signature, ts3.map(signature.typeParameters, function(tp) {
            return tp.target && !getConstraintOfTypeParameter(tp.target) ? tp.target : tp;
          }), ts3.isInJSFile(signature.declaration));
        }
        function getBaseSignature(signature) {
          var typeParameters = signature.typeParameters;
          if (typeParameters) {
            if (signature.baseSignatureCache) {
              return signature.baseSignatureCache;
            }
            var typeEraser = createTypeEraser(typeParameters);
            var baseConstraintMapper_1 = createTypeMapper(typeParameters, ts3.map(typeParameters, function(tp) {
              return getConstraintOfTypeParameter(tp) || unknownType;
            }));
            var baseConstraints = ts3.map(typeParameters, function(tp) {
              return instantiateType(tp, baseConstraintMapper_1) || unknownType;
            });
            for (var i3 = 0; i3 < typeParameters.length - 1; i3++) {
              baseConstraints = instantiateTypes(baseConstraints, baseConstraintMapper_1);
            }
            baseConstraints = instantiateTypes(baseConstraints, typeEraser);
            return signature.baseSignatureCache = instantiateSignature(signature, createTypeMapper(typeParameters, baseConstraints), true);
          }
          return signature;
        }
        function getOrCreateTypeFromSignature(signature) {
          if (!signature.isolatedSignatureType) {
            var kind = signature.declaration ? signature.declaration.kind : 0;
            var isConstructor = kind === 167 || kind === 171 || kind === 176;
            var type3 = createObjectType(16);
            type3.members = emptySymbols;
            type3.properties = ts3.emptyArray;
            type3.callSignatures = !isConstructor ? [signature] : ts3.emptyArray;
            type3.constructSignatures = isConstructor ? [signature] : ts3.emptyArray;
            signature.isolatedSignatureType = type3;
          }
          return signature.isolatedSignatureType;
        }
        function getIndexSymbol(symbol) {
          return symbol.members ? getIndexSymbolFromSymbolTable(symbol.members) : void 0;
        }
        function getIndexSymbolFromSymbolTable(symbolTable) {
          return symbolTable.get("__index");
        }
        function getIndexDeclarationOfSymbol(symbol, kind) {
          var indexSymbol = symbol && getIndexSymbol(symbol);
          return indexSymbol && getIndexDeclarationOfIndexSymbol(indexSymbol, kind);
        }
        function getIndexDeclarationOfSymbolTable(symbolTable, kind) {
          var indexSymbol = symbolTable && getIndexSymbolFromSymbolTable(symbolTable);
          return indexSymbol && getIndexDeclarationOfIndexSymbol(indexSymbol, kind);
        }
        function getIndexDeclarationOfIndexSymbol(indexSymbol, kind) {
          var syntaxKind = kind === 1 ? 144 : 147;
          if (indexSymbol === null || indexSymbol === void 0 ? void 0 : indexSymbol.declarations) {
            for (var _i = 0, _a2 = indexSymbol.declarations; _i < _a2.length; _i++) {
              var decl = _a2[_i];
              var node = ts3.cast(decl, ts3.isIndexSignatureDeclaration);
              if (node.parameters.length === 1) {
                var parameter = node.parameters[0];
                if (parameter.type && parameter.type.kind === syntaxKind) {
                  return node;
                }
              }
            }
          }
          return void 0;
        }
        function createIndexInfo(type3, isReadonly, declaration) {
          return { type: type3, isReadonly, declaration };
        }
        function getIndexInfoOfSymbol(symbol, kind) {
          var declaration = getIndexDeclarationOfSymbol(symbol, kind);
          if (declaration) {
            return createIndexInfo(declaration.type ? getTypeFromTypeNode(declaration.type) : anyType, ts3.hasEffectiveModifier(declaration, 64), declaration);
          }
          return void 0;
        }
        function getConstraintDeclaration(type3) {
          return ts3.mapDefined(ts3.filter(type3.symbol && type3.symbol.declarations, ts3.isTypeParameterDeclaration), ts3.getEffectiveConstraintOfTypeParameter)[0];
        }
        function getInferredTypeParameterConstraint(typeParameter) {
          var _a2;
          var inferences;
          if ((_a2 = typeParameter.symbol) === null || _a2 === void 0 ? void 0 : _a2.declarations) {
            for (var _i = 0, _b = typeParameter.symbol.declarations; _i < _b.length; _i++) {
              var declaration = _b[_i];
              if (declaration.parent.kind === 186) {
                var _c = ts3.walkUpParenthesizedTypesAndGetParentAndChild(declaration.parent.parent), _d = _c[0], childTypeParameter = _d === void 0 ? declaration.parent : _d, grandParent = _c[1];
                if (grandParent.kind === 174) {
                  var typeReference = grandParent;
                  var typeParameters = getTypeParametersForTypeReference(typeReference);
                  if (typeParameters) {
                    var index = typeReference.typeArguments.indexOf(childTypeParameter);
                    if (index < typeParameters.length) {
                      var declaredConstraint = getConstraintOfTypeParameter(typeParameters[index]);
                      if (declaredConstraint) {
                        var mapper = createTypeMapper(typeParameters, getEffectiveTypeArguments(typeReference, typeParameters));
                        var constraint = instantiateType(declaredConstraint, mapper);
                        if (constraint !== typeParameter) {
                          inferences = ts3.append(inferences, constraint);
                        }
                      }
                    }
                  }
                } else if (grandParent.kind === 161 && grandParent.dotDotDotToken || grandParent.kind === 182 || grandParent.kind === 193 && grandParent.dotDotDotToken) {
                  inferences = ts3.append(inferences, createArrayType(unknownType));
                } else if (grandParent.kind === 195) {
                  inferences = ts3.append(inferences, stringType);
                } else if (grandParent.kind === 160 && grandParent.parent.kind === 191) {
                  inferences = ts3.append(inferences, keyofConstraintType);
                } else if (grandParent.kind === 191 && grandParent.type && ts3.skipParentheses(grandParent.type) === declaration.parent && grandParent.parent.kind === 185 && grandParent.parent.extendsType === grandParent && grandParent.parent.checkType.kind === 191 && grandParent.parent.checkType.type) {
                  var checkMappedType_1 = grandParent.parent.checkType;
                  var nodeType = getTypeFromTypeNode(checkMappedType_1.type);
                  inferences = ts3.append(inferences, instantiateType(nodeType, makeUnaryTypeMapper(getDeclaredTypeOfTypeParameter(getSymbolOfNode(checkMappedType_1.typeParameter)), checkMappedType_1.typeParameter.constraint ? getTypeFromTypeNode(checkMappedType_1.typeParameter.constraint) : keyofConstraintType)));
                }
              }
            }
          }
          return inferences && getIntersectionType(inferences);
        }
        function getConstraintFromTypeParameter(typeParameter) {
          if (!typeParameter.constraint) {
            if (typeParameter.target) {
              var targetConstraint = getConstraintOfTypeParameter(typeParameter.target);
              typeParameter.constraint = targetConstraint ? instantiateType(targetConstraint, typeParameter.mapper) : noConstraintType;
            } else {
              var constraintDeclaration = getConstraintDeclaration(typeParameter);
              if (!constraintDeclaration) {
                typeParameter.constraint = getInferredTypeParameterConstraint(typeParameter) || noConstraintType;
              } else {
                var type3 = getTypeFromTypeNode(constraintDeclaration);
                if (type3.flags & 1 && type3 !== errorType) {
                  type3 = constraintDeclaration.parent.parent.kind === 191 ? keyofConstraintType : unknownType;
                }
                typeParameter.constraint = type3;
              }
            }
          }
          return typeParameter.constraint === noConstraintType ? void 0 : typeParameter.constraint;
        }
        function getParentSymbolOfTypeParameter(typeParameter) {
          var tp = ts3.getDeclarationOfKind(typeParameter.symbol, 160);
          var host2 = ts3.isJSDocTemplateTag(tp.parent) ? ts3.getHostSignatureFromJSDoc(tp.parent) : tp.parent;
          return host2 && getSymbolOfNode(host2);
        }
        function getTypeListId(types2) {
          var result2 = "";
          if (types2) {
            var length_4 = types2.length;
            var i3 = 0;
            while (i3 < length_4) {
              var startId = types2[i3].id;
              var count = 1;
              while (i3 + count < length_4 && types2[i3 + count].id === startId + count) {
                count++;
              }
              if (result2.length) {
                result2 += ",";
              }
              result2 += startId;
              if (count > 1) {
                result2 += ":" + count;
              }
              i3 += count;
            }
          }
          return result2;
        }
        function getAliasId(aliasSymbol, aliasTypeArguments) {
          return aliasSymbol ? "@" + getSymbolId(aliasSymbol) + (aliasTypeArguments ? ":" + getTypeListId(aliasTypeArguments) : "") : "";
        }
        function getPropagatingFlagsOfTypes(types2, excludeKinds) {
          var result2 = 0;
          for (var _i = 0, types_9 = types2; _i < types_9.length; _i++) {
            var type3 = types_9[_i];
            if (!(type3.flags & excludeKinds)) {
              result2 |= ts3.getObjectFlags(type3);
            }
          }
          return result2 & 917504;
        }
        function createTypeReference(target, typeArguments) {
          var id = getTypeListId(typeArguments);
          var type3 = target.instantiations.get(id);
          if (!type3) {
            type3 = createObjectType(4, target.symbol);
            target.instantiations.set(id, type3);
            type3.objectFlags |= typeArguments ? getPropagatingFlagsOfTypes(typeArguments, 0) : 0;
            type3.target = target;
            type3.resolvedTypeArguments = typeArguments;
          }
          return type3;
        }
        function cloneTypeReference(source) {
          var type3 = createType(source.flags);
          type3.symbol = source.symbol;
          type3.objectFlags = source.objectFlags;
          type3.target = source.target;
          type3.resolvedTypeArguments = source.resolvedTypeArguments;
          return type3;
        }
        function createDeferredTypeReference(target, node, mapper, aliasSymbol, aliasTypeArguments) {
          if (!aliasSymbol) {
            aliasSymbol = getAliasSymbolForTypeNode(node);
            var localAliasTypeArguments = getTypeArgumentsForAliasSymbol(aliasSymbol);
            aliasTypeArguments = mapper ? instantiateTypes(localAliasTypeArguments, mapper) : localAliasTypeArguments;
          }
          var type3 = createObjectType(4, target.symbol);
          type3.target = target;
          type3.node = node;
          type3.mapper = mapper;
          type3.aliasSymbol = aliasSymbol;
          type3.aliasTypeArguments = aliasTypeArguments;
          return type3;
        }
        function getTypeArguments(type3) {
          var _a2, _b;
          if (!type3.resolvedTypeArguments) {
            if (!pushTypeResolution(type3, 6)) {
              return ((_a2 = type3.target.localTypeParameters) === null || _a2 === void 0 ? void 0 : _a2.map(function() {
                return errorType;
              })) || ts3.emptyArray;
            }
            var node = type3.node;
            var typeArguments = !node ? ts3.emptyArray : node.kind === 174 ? ts3.concatenate(type3.target.outerTypeParameters, getEffectiveTypeArguments(node, type3.target.localTypeParameters)) : node.kind === 179 ? [getTypeFromTypeNode(node.elementType)] : ts3.map(node.elements, getTypeFromTypeNode);
            if (popTypeResolution()) {
              type3.resolvedTypeArguments = type3.mapper ? instantiateTypes(typeArguments, type3.mapper) : typeArguments;
            } else {
              type3.resolvedTypeArguments = ((_b = type3.target.localTypeParameters) === null || _b === void 0 ? void 0 : _b.map(function() {
                return errorType;
              })) || ts3.emptyArray;
              error(type3.node || currentNode, type3.target.symbol ? ts3.Diagnostics.Type_arguments_for_0_circularly_reference_themselves : ts3.Diagnostics.Tuple_type_arguments_circularly_reference_themselves, type3.target.symbol && symbolToString(type3.target.symbol));
            }
          }
          return type3.resolvedTypeArguments;
        }
        function getTypeReferenceArity(type3) {
          return ts3.length(type3.target.typeParameters);
        }
        function getTypeFromClassOrInterfaceReference(node, symbol) {
          var type3 = getDeclaredTypeOfSymbol(getMergedSymbol(symbol));
          var typeParameters = type3.localTypeParameters;
          if (typeParameters) {
            var numTypeArguments = ts3.length(node.typeArguments);
            var minTypeArgumentCount = getMinTypeArgumentCount(typeParameters);
            var isJs = ts3.isInJSFile(node);
            var isJsImplicitAny = !noImplicitAny && isJs;
            if (!isJsImplicitAny && (numTypeArguments < minTypeArgumentCount || numTypeArguments > typeParameters.length)) {
              var missingAugmentsTag = isJs && ts3.isExpressionWithTypeArguments(node) && !ts3.isJSDocAugmentsTag(node.parent);
              var diag = minTypeArgumentCount === typeParameters.length ? missingAugmentsTag ? ts3.Diagnostics.Expected_0_type_arguments_provide_these_with_an_extends_tag : ts3.Diagnostics.Generic_type_0_requires_1_type_argument_s : missingAugmentsTag ? ts3.Diagnostics.Expected_0_1_type_arguments_provide_these_with_an_extends_tag : ts3.Diagnostics.Generic_type_0_requires_between_1_and_2_type_arguments;
              var typeStr = typeToString(type3, void 0, 2);
              error(node, diag, typeStr, minTypeArgumentCount, typeParameters.length);
              if (!isJs) {
                return errorType;
              }
            }
            if (node.kind === 174 && isDeferredTypeReferenceNode(node, ts3.length(node.typeArguments) !== typeParameters.length)) {
              return createDeferredTypeReference(type3, node, void 0);
            }
            var typeArguments = ts3.concatenate(type3.outerTypeParameters, fillMissingTypeArguments(typeArgumentsFromTypeReferenceNode(node), typeParameters, minTypeArgumentCount, isJs));
            return createTypeReference(type3, typeArguments);
          }
          return checkNoTypeArguments(node, symbol) ? type3 : errorType;
        }
        function getTypeAliasInstantiation(symbol, typeArguments, aliasSymbol, aliasTypeArguments) {
          var type3 = getDeclaredTypeOfSymbol(symbol);
          if (type3 === intrinsicMarkerType && intrinsicTypeKinds.has(symbol.escapedName) && typeArguments && typeArguments.length === 1) {
            return getStringMappingType(symbol, typeArguments[0]);
          }
          var links = getSymbolLinks(symbol);
          var typeParameters = links.typeParameters;
          var id = getTypeListId(typeArguments) + getAliasId(aliasSymbol, aliasTypeArguments);
          var instantiation = links.instantiations.get(id);
          if (!instantiation) {
            links.instantiations.set(id, instantiation = instantiateTypeWithAlias(type3, createTypeMapper(typeParameters, fillMissingTypeArguments(typeArguments, typeParameters, getMinTypeArgumentCount(typeParameters), ts3.isInJSFile(symbol.valueDeclaration))), aliasSymbol, aliasTypeArguments));
          }
          return instantiation;
        }
        function getTypeFromTypeAliasReference(node, symbol) {
          var type3 = getDeclaredTypeOfSymbol(symbol);
          var typeParameters = getSymbolLinks(symbol).typeParameters;
          if (typeParameters) {
            var numTypeArguments = ts3.length(node.typeArguments);
            var minTypeArgumentCount = getMinTypeArgumentCount(typeParameters);
            if (numTypeArguments < minTypeArgumentCount || numTypeArguments > typeParameters.length) {
              error(node, minTypeArgumentCount === typeParameters.length ? ts3.Diagnostics.Generic_type_0_requires_1_type_argument_s : ts3.Diagnostics.Generic_type_0_requires_between_1_and_2_type_arguments, symbolToString(symbol), minTypeArgumentCount, typeParameters.length);
              return errorType;
            }
            var aliasSymbol = getAliasSymbolForTypeNode(node);
            var newAliasSymbol = aliasSymbol && (isLocalTypeAlias(symbol) || !isLocalTypeAlias(aliasSymbol)) ? aliasSymbol : void 0;
            return getTypeAliasInstantiation(symbol, typeArgumentsFromTypeReferenceNode(node), newAliasSymbol, getTypeArgumentsForAliasSymbol(newAliasSymbol));
          }
          return checkNoTypeArguments(node, symbol) ? type3 : errorType;
        }
        function isLocalTypeAlias(symbol) {
          var _a2;
          var declaration = (_a2 = symbol.declarations) === null || _a2 === void 0 ? void 0 : _a2.find(ts3.isTypeAlias);
          return !!(declaration && ts3.getContainingFunction(declaration));
        }
        function getTypeReferenceName(node) {
          switch (node.kind) {
            case 174:
              return node.typeName;
            case 224:
              var expr = node.expression;
              if (ts3.isEntityNameExpression(expr)) {
                return expr;
              }
          }
          return void 0;
        }
        function resolveTypeReferenceName(typeReferenceName, meaning, ignoreErrors) {
          if (!typeReferenceName) {
            return unknownSymbol;
          }
          return resolveEntityName(typeReferenceName, meaning, ignoreErrors) || unknownSymbol;
        }
        function getTypeReferenceType(node, symbol) {
          if (symbol === unknownSymbol) {
            return errorType;
          }
          symbol = getExpandoSymbol(symbol) || symbol;
          if (symbol.flags & (32 | 64)) {
            return getTypeFromClassOrInterfaceReference(node, symbol);
          }
          if (symbol.flags & 524288) {
            return getTypeFromTypeAliasReference(node, symbol);
          }
          var res = tryGetDeclaredTypeOfSymbol(symbol);
          if (res) {
            return checkNoTypeArguments(node, symbol) ? getRegularTypeOfLiteralType(res) : errorType;
          }
          if (symbol.flags & 111551 && isJSDocTypeReference(node)) {
            var jsdocType = getTypeFromJSDocValueReference(node, symbol);
            if (jsdocType) {
              return jsdocType;
            } else {
              resolveTypeReferenceName(getTypeReferenceName(node), 788968);
              return getTypeOfSymbol(symbol);
            }
          }
          return errorType;
        }
        function getTypeFromJSDocValueReference(node, symbol) {
          var links = getNodeLinks(node);
          if (!links.resolvedJSDocType) {
            var valueType = getTypeOfSymbol(symbol);
            var typeType = valueType;
            if (symbol.valueDeclaration) {
              var isImportTypeWithQualifier = node.kind === 196 && node.qualifier;
              if (valueType.symbol && valueType.symbol !== symbol && isImportTypeWithQualifier) {
                typeType = getTypeReferenceType(node, valueType.symbol);
              }
            }
            links.resolvedJSDocType = typeType;
          }
          return links.resolvedJSDocType;
        }
        function getSubstitutionType(baseType, substitute) {
          if (substitute.flags & 3 || substitute === baseType) {
            return baseType;
          }
          var id = getTypeId(baseType) + ">" + getTypeId(substitute);
          var cached = substitutionTypes.get(id);
          if (cached) {
            return cached;
          }
          var result2 = createType(33554432);
          result2.baseType = baseType;
          result2.substitute = substitute;
          substitutionTypes.set(id, result2);
          return result2;
        }
        function isUnaryTupleTypeNode(node) {
          return node.kind === 180 && node.elements.length === 1;
        }
        function getImpliedConstraint(type3, checkNode, extendsNode) {
          return isUnaryTupleTypeNode(checkNode) && isUnaryTupleTypeNode(extendsNode) ? getImpliedConstraint(type3, checkNode.elements[0], extendsNode.elements[0]) : getActualTypeVariable(getTypeFromTypeNode(checkNode)) === type3 ? getTypeFromTypeNode(extendsNode) : void 0;
        }
        function getConditionalFlowTypeOfType(type3, node) {
          var constraints;
          var covariant = true;
          while (node && !ts3.isStatement(node) && node.kind !== 312) {
            var parent = node.parent;
            if (parent.kind === 161) {
              covariant = !covariant;
            }
            if ((covariant || type3.flags & 8650752) && parent.kind === 185 && node === parent.trueType) {
              var constraint = getImpliedConstraint(type3, parent.checkType, parent.extendsType);
              if (constraint) {
                constraints = ts3.append(constraints, constraint);
              }
            }
            node = parent;
          }
          return constraints ? getSubstitutionType(type3, getIntersectionType(ts3.append(constraints, type3))) : type3;
        }
        function isJSDocTypeReference(node) {
          return !!(node.flags & 4194304) && (node.kind === 174 || node.kind === 196);
        }
        function checkNoTypeArguments(node, symbol) {
          if (node.typeArguments) {
            error(node, ts3.Diagnostics.Type_0_is_not_generic, symbol ? symbolToString(symbol) : node.typeName ? ts3.declarationNameToString(node.typeName) : anon);
            return false;
          }
          return true;
        }
        function getIntendedTypeFromJSDocTypeReference(node) {
          if (ts3.isIdentifier(node.typeName)) {
            var typeArgs = node.typeArguments;
            switch (node.typeName.escapedText) {
              case "String":
                checkNoTypeArguments(node);
                return stringType;
              case "Number":
                checkNoTypeArguments(node);
                return numberType;
              case "Boolean":
                checkNoTypeArguments(node);
                return booleanType;
              case "Void":
                checkNoTypeArguments(node);
                return voidType;
              case "Undefined":
                checkNoTypeArguments(node);
                return undefinedType;
              case "Null":
                checkNoTypeArguments(node);
                return nullType;
              case "Function":
              case "function":
                checkNoTypeArguments(node);
                return globalFunctionType;
              case "array":
                return (!typeArgs || !typeArgs.length) && !noImplicitAny ? anyArrayType : void 0;
              case "promise":
                return (!typeArgs || !typeArgs.length) && !noImplicitAny ? createPromiseType(anyType) : void 0;
              case "Object":
                if (typeArgs && typeArgs.length === 2) {
                  if (ts3.isJSDocIndexSignature(node)) {
                    var indexed = getTypeFromTypeNode(typeArgs[0]);
                    var target = getTypeFromTypeNode(typeArgs[1]);
                    var index = createIndexInfo(target, false);
                    return createAnonymousType(void 0, emptySymbols, ts3.emptyArray, ts3.emptyArray, indexed === stringType ? index : void 0, indexed === numberType ? index : void 0);
                  }
                  return anyType;
                }
                checkNoTypeArguments(node);
                return !noImplicitAny ? anyType : void 0;
            }
          }
        }
        function getTypeFromJSDocNullableTypeNode(node) {
          var type3 = getTypeFromTypeNode(node.type);
          return strictNullChecks ? getNullableType(type3, 65536) : type3;
        }
        function getTypeFromTypeReference(node) {
          var links = getNodeLinks(node);
          if (!links.resolvedType) {
            if (ts3.isConstTypeReference(node) && ts3.isAssertionExpression(node.parent)) {
              links.resolvedSymbol = unknownSymbol;
              return links.resolvedType = checkExpressionCached(node.parent.expression);
            }
            var symbol = void 0;
            var type3 = void 0;
            var meaning = 788968;
            if (isJSDocTypeReference(node)) {
              type3 = getIntendedTypeFromJSDocTypeReference(node);
              if (!type3) {
                symbol = resolveTypeReferenceName(getTypeReferenceName(node), meaning, true);
                if (symbol === unknownSymbol) {
                  symbol = resolveTypeReferenceName(getTypeReferenceName(node), meaning | 111551);
                } else {
                  resolveTypeReferenceName(getTypeReferenceName(node), meaning);
                }
                type3 = getTypeReferenceType(node, symbol);
              }
            }
            if (!type3) {
              symbol = resolveTypeReferenceName(getTypeReferenceName(node), meaning);
              type3 = getTypeReferenceType(node, symbol);
            }
            links.resolvedSymbol = symbol;
            links.resolvedType = type3;
          }
          return links.resolvedType;
        }
        function typeArgumentsFromTypeReferenceNode(node) {
          return ts3.map(node.typeArguments, getTypeFromTypeNode);
        }
        function getTypeFromTypeQueryNode(node) {
          var links = getNodeLinks(node);
          if (!links.resolvedType) {
            links.resolvedType = getRegularTypeOfLiteralType(getWidenedType(checkExpression(node.exprName)));
          }
          return links.resolvedType;
        }
        function getTypeOfGlobalSymbol(symbol, arity) {
          function getTypeDeclaration(symbol2) {
            var declarations = symbol2.declarations;
            if (declarations) {
              for (var _i = 0, declarations_3 = declarations; _i < declarations_3.length; _i++) {
                var declaration = declarations_3[_i];
                switch (declaration.kind) {
                  case 253:
                  case 254:
                  case 256:
                    return declaration;
                }
              }
            }
          }
          if (!symbol) {
            return arity ? emptyGenericType : emptyObjectType;
          }
          var type3 = getDeclaredTypeOfSymbol(symbol);
          if (!(type3.flags & 524288)) {
            error(getTypeDeclaration(symbol), ts3.Diagnostics.Global_type_0_must_be_a_class_or_interface_type, ts3.symbolName(symbol));
            return arity ? emptyGenericType : emptyObjectType;
          }
          if (ts3.length(type3.typeParameters) !== arity) {
            error(getTypeDeclaration(symbol), ts3.Diagnostics.Global_type_0_must_have_1_type_parameter_s, ts3.symbolName(symbol), arity);
            return arity ? emptyGenericType : emptyObjectType;
          }
          return type3;
        }
        function getGlobalValueSymbol(name, reportErrors) {
          return getGlobalSymbol(name, 111551, reportErrors ? ts3.Diagnostics.Cannot_find_global_value_0 : void 0);
        }
        function getGlobalTypeSymbol(name, reportErrors) {
          return getGlobalSymbol(name, 788968, reportErrors ? ts3.Diagnostics.Cannot_find_global_type_0 : void 0);
        }
        function getGlobalSymbol(name, meaning, diagnostic) {
          return resolveName(void 0, name, meaning, diagnostic, name, false);
        }
        function getGlobalType(name, arity, reportErrors) {
          var symbol = getGlobalTypeSymbol(name, reportErrors);
          return symbol || reportErrors ? getTypeOfGlobalSymbol(symbol, arity) : void 0;
        }
        function getGlobalTypedPropertyDescriptorType() {
          return deferredGlobalTypedPropertyDescriptorType || (deferredGlobalTypedPropertyDescriptorType = getGlobalType("TypedPropertyDescriptor", 1, true)) || emptyGenericType;
        }
        function getGlobalTemplateStringsArrayType() {
          return deferredGlobalTemplateStringsArrayType || (deferredGlobalTemplateStringsArrayType = getGlobalType("TemplateStringsArray", 0, true)) || emptyObjectType;
        }
        function getGlobalImportMetaType() {
          return deferredGlobalImportMetaType || (deferredGlobalImportMetaType = getGlobalType("ImportMeta", 0, true)) || emptyObjectType;
        }
        function getGlobalESSymbolConstructorSymbol(reportErrors) {
          return deferredGlobalESSymbolConstructorSymbol || (deferredGlobalESSymbolConstructorSymbol = getGlobalValueSymbol("Symbol", reportErrors));
        }
        function getGlobalESSymbolConstructorTypeSymbol(reportErrors) {
          return deferredGlobalESSymbolConstructorTypeSymbol || (deferredGlobalESSymbolConstructorTypeSymbol = getGlobalTypeSymbol("SymbolConstructor", reportErrors));
        }
        function getGlobalESSymbolType(reportErrors) {
          return deferredGlobalESSymbolType || (deferredGlobalESSymbolType = getGlobalType("Symbol", 0, reportErrors)) || emptyObjectType;
        }
        function getGlobalPromiseType(reportErrors) {
          return deferredGlobalPromiseType || (deferredGlobalPromiseType = getGlobalType("Promise", 1, reportErrors)) || emptyGenericType;
        }
        function getGlobalPromiseLikeType(reportErrors) {
          return deferredGlobalPromiseLikeType || (deferredGlobalPromiseLikeType = getGlobalType("PromiseLike", 1, reportErrors)) || emptyGenericType;
        }
        function getGlobalPromiseConstructorSymbol(reportErrors) {
          return deferredGlobalPromiseConstructorSymbol || (deferredGlobalPromiseConstructorSymbol = getGlobalValueSymbol("Promise", reportErrors));
        }
        function getGlobalPromiseConstructorLikeType(reportErrors) {
          return deferredGlobalPromiseConstructorLikeType || (deferredGlobalPromiseConstructorLikeType = getGlobalType("PromiseConstructorLike", 0, reportErrors)) || emptyObjectType;
        }
        function getGlobalAsyncIterableType(reportErrors) {
          return deferredGlobalAsyncIterableType || (deferredGlobalAsyncIterableType = getGlobalType("AsyncIterable", 1, reportErrors)) || emptyGenericType;
        }
        function getGlobalAsyncIteratorType(reportErrors) {
          return deferredGlobalAsyncIteratorType || (deferredGlobalAsyncIteratorType = getGlobalType("AsyncIterator", 3, reportErrors)) || emptyGenericType;
        }
        function getGlobalAsyncIterableIteratorType(reportErrors) {
          return deferredGlobalAsyncIterableIteratorType || (deferredGlobalAsyncIterableIteratorType = getGlobalType("AsyncIterableIterator", 1, reportErrors)) || emptyGenericType;
        }
        function getGlobalAsyncGeneratorType(reportErrors) {
          return deferredGlobalAsyncGeneratorType || (deferredGlobalAsyncGeneratorType = getGlobalType("AsyncGenerator", 3, reportErrors)) || emptyGenericType;
        }
        function getGlobalIterableType(reportErrors) {
          return deferredGlobalIterableType || (deferredGlobalIterableType = getGlobalType("Iterable", 1, reportErrors)) || emptyGenericType;
        }
        function getGlobalIteratorType(reportErrors) {
          return deferredGlobalIteratorType || (deferredGlobalIteratorType = getGlobalType("Iterator", 3, reportErrors)) || emptyGenericType;
        }
        function getGlobalIterableIteratorType(reportErrors) {
          return deferredGlobalIterableIteratorType || (deferredGlobalIterableIteratorType = getGlobalType("IterableIterator", 1, reportErrors)) || emptyGenericType;
        }
        function getGlobalGeneratorType(reportErrors) {
          return deferredGlobalGeneratorType || (deferredGlobalGeneratorType = getGlobalType("Generator", 3, reportErrors)) || emptyGenericType;
        }
        function getGlobalIteratorYieldResultType(reportErrors) {
          return deferredGlobalIteratorYieldResultType || (deferredGlobalIteratorYieldResultType = getGlobalType("IteratorYieldResult", 1, reportErrors)) || emptyGenericType;
        }
        function getGlobalIteratorReturnResultType(reportErrors) {
          return deferredGlobalIteratorReturnResultType || (deferredGlobalIteratorReturnResultType = getGlobalType("IteratorReturnResult", 1, reportErrors)) || emptyGenericType;
        }
        function getGlobalTypeOrUndefined(name, arity) {
          if (arity === void 0) {
            arity = 0;
          }
          var symbol = getGlobalSymbol(name, 788968, void 0);
          return symbol && getTypeOfGlobalSymbol(symbol, arity);
        }
        function getGlobalExtractSymbol() {
          return deferredGlobalExtractSymbol || (deferredGlobalExtractSymbol = getGlobalSymbol("Extract", 524288, ts3.Diagnostics.Cannot_find_global_type_0));
        }
        function getGlobalOmitSymbol() {
          return deferredGlobalOmitSymbol || (deferredGlobalOmitSymbol = getGlobalSymbol("Omit", 524288, ts3.Diagnostics.Cannot_find_global_type_0));
        }
        function getGlobalBigIntType(reportErrors) {
          return deferredGlobalBigIntType || (deferredGlobalBigIntType = getGlobalType("BigInt", 0, reportErrors)) || emptyObjectType;
        }
        function createTypeFromGenericGlobalType(genericGlobalType, typeArguments) {
          return genericGlobalType !== emptyGenericType ? createTypeReference(genericGlobalType, typeArguments) : emptyObjectType;
        }
        function createTypedPropertyDescriptorType(propertyType) {
          return createTypeFromGenericGlobalType(getGlobalTypedPropertyDescriptorType(), [propertyType]);
        }
        function createIterableType(iteratedType) {
          return createTypeFromGenericGlobalType(getGlobalIterableType(true), [iteratedType]);
        }
        function createArrayType(elementType, readonly) {
          return createTypeFromGenericGlobalType(readonly ? globalReadonlyArrayType : globalArrayType, [elementType]);
        }
        function getTupleElementFlags(node) {
          switch (node.kind) {
            case 181:
              return 2;
            case 182:
              return getRestTypeElementFlags(node);
            case 193:
              return node.questionToken ? 2 : node.dotDotDotToken ? getRestTypeElementFlags(node) : 1;
            default:
              return 1;
          }
        }
        function getRestTypeElementFlags(node) {
          return getArrayElementTypeNode(node.type) ? 4 : 8;
        }
        function getArrayOrTupleTargetType(node) {
          var readonly = isReadonlyTypeOperator(node.parent);
          var elementType = getArrayElementTypeNode(node);
          if (elementType) {
            return readonly ? globalReadonlyArrayType : globalArrayType;
          }
          var elementFlags = ts3.map(node.elements, getTupleElementFlags);
          var missingName = ts3.some(node.elements, function(e2) {
            return e2.kind !== 193;
          });
          return getTupleTargetType(elementFlags, readonly, missingName ? void 0 : node.elements);
        }
        function isDeferredTypeReferenceNode(node, hasDefaultTypeArguments) {
          return !!getAliasSymbolForTypeNode(node) || isResolvedByTypeAlias(node) && (node.kind === 179 ? mayResolveTypeAlias(node.elementType) : node.kind === 180 ? ts3.some(node.elements, mayResolveTypeAlias) : hasDefaultTypeArguments || ts3.some(node.typeArguments, mayResolveTypeAlias));
        }
        function isResolvedByTypeAlias(node) {
          var parent = node.parent;
          switch (parent.kind) {
            case 187:
            case 193:
            case 174:
            case 183:
            case 184:
            case 190:
            case 185:
            case 189:
            case 179:
            case 180:
              return isResolvedByTypeAlias(parent);
            case 255:
              return true;
          }
          return false;
        }
        function mayResolveTypeAlias(node) {
          switch (node.kind) {
            case 174:
              return isJSDocTypeReference(node) || !!(resolveTypeReferenceName(node.typeName, 788968).flags & 524288);
            case 177:
              return true;
            case 189:
              return node.operator !== 151 && mayResolveTypeAlias(node.type);
            case 187:
            case 181:
            case 193:
            case 308:
            case 306:
            case 307:
            case 302:
              return mayResolveTypeAlias(node.type);
            case 182:
              return node.type.kind !== 179 || mayResolveTypeAlias(node.type.elementType);
            case 183:
            case 184:
              return ts3.some(node.types, mayResolveTypeAlias);
            case 190:
              return mayResolveTypeAlias(node.objectType) || mayResolveTypeAlias(node.indexType);
            case 185:
              return mayResolveTypeAlias(node.checkType) || mayResolveTypeAlias(node.extendsType) || mayResolveTypeAlias(node.trueType) || mayResolveTypeAlias(node.falseType);
          }
          return false;
        }
        function getTypeFromArrayOrTupleTypeNode(node) {
          var links = getNodeLinks(node);
          if (!links.resolvedType) {
            var target = getArrayOrTupleTargetType(node);
            if (target === emptyGenericType) {
              links.resolvedType = emptyObjectType;
            } else if (!(node.kind === 180 && ts3.some(node.elements, function(e2) {
              return !!(getTupleElementFlags(e2) & 8);
            })) && isDeferredTypeReferenceNode(node)) {
              links.resolvedType = node.kind === 180 && node.elements.length === 0 ? target : createDeferredTypeReference(target, node, void 0);
            } else {
              var elementTypes = node.kind === 179 ? [getTypeFromTypeNode(node.elementType)] : ts3.map(node.elements, getTypeFromTypeNode);
              links.resolvedType = createNormalizedTypeReference(target, elementTypes);
            }
          }
          return links.resolvedType;
        }
        function isReadonlyTypeOperator(node) {
          return ts3.isTypeOperatorNode(node) && node.operator === 142;
        }
        function createTupleType(elementTypes, elementFlags, readonly, namedMemberDeclarations) {
          if (readonly === void 0) {
            readonly = false;
          }
          var tupleTarget = getTupleTargetType(elementFlags || ts3.map(elementTypes, function(_) {
            return 1;
          }), readonly, namedMemberDeclarations);
          return tupleTarget === emptyGenericType ? emptyObjectType : elementTypes.length ? createNormalizedTypeReference(tupleTarget, elementTypes) : tupleTarget;
        }
        function getTupleTargetType(elementFlags, readonly, namedMemberDeclarations) {
          if (elementFlags.length === 1 && elementFlags[0] & 4) {
            return readonly ? globalReadonlyArrayType : globalArrayType;
          }
          var key2 = ts3.map(elementFlags, function(f) {
            return f & 1 ? "#" : f & 2 ? "?" : f & 4 ? "." : "*";
          }).join() + (readonly ? "R" : "") + (namedMemberDeclarations && namedMemberDeclarations.length ? "," + ts3.map(namedMemberDeclarations, getNodeId).join(",") : "");
          var type3 = tupleTypes.get(key2);
          if (!type3) {
            tupleTypes.set(key2, type3 = createTupleTargetType(elementFlags, readonly, namedMemberDeclarations));
          }
          return type3;
        }
        function createTupleTargetType(elementFlags, readonly, namedMemberDeclarations) {
          var arity = elementFlags.length;
          var minLength = ts3.countWhere(elementFlags, function(f) {
            return !!(f & (1 | 8));
          });
          var typeParameters;
          var properties = [];
          var combinedFlags = 0;
          if (arity) {
            typeParameters = new Array(arity);
            for (var i3 = 0; i3 < arity; i3++) {
              var typeParameter = typeParameters[i3] = createTypeParameter();
              var flags = elementFlags[i3];
              combinedFlags |= flags;
              if (!(combinedFlags & 12)) {
                var property = createSymbol(4 | (flags & 2 ? 16777216 : 0), "" + i3, readonly ? 8 : 0);
                property.tupleLabelDeclaration = namedMemberDeclarations === null || namedMemberDeclarations === void 0 ? void 0 : namedMemberDeclarations[i3];
                property.type = typeParameter;
                properties.push(property);
              }
            }
          }
          var fixedLength = properties.length;
          var lengthSymbol = createSymbol(4, "length");
          if (combinedFlags & 12) {
            lengthSymbol.type = numberType;
          } else {
            var literalTypes_1 = [];
            for (var i3 = minLength; i3 <= arity; i3++)
              literalTypes_1.push(getLiteralType(i3));
            lengthSymbol.type = getUnionType(literalTypes_1);
          }
          properties.push(lengthSymbol);
          var type3 = createObjectType(8 | 4);
          type3.typeParameters = typeParameters;
          type3.outerTypeParameters = void 0;
          type3.localTypeParameters = typeParameters;
          type3.instantiations = new ts3.Map();
          type3.instantiations.set(getTypeListId(type3.typeParameters), type3);
          type3.target = type3;
          type3.resolvedTypeArguments = type3.typeParameters;
          type3.thisType = createTypeParameter();
          type3.thisType.isThisType = true;
          type3.thisType.constraint = type3;
          type3.declaredProperties = properties;
          type3.declaredCallSignatures = ts3.emptyArray;
          type3.declaredConstructSignatures = ts3.emptyArray;
          type3.declaredStringIndexInfo = void 0;
          type3.declaredNumberIndexInfo = void 0;
          type3.elementFlags = elementFlags;
          type3.minLength = minLength;
          type3.fixedLength = fixedLength;
          type3.hasRestElement = !!(combinedFlags & 12);
          type3.combinedFlags = combinedFlags;
          type3.readonly = readonly;
          type3.labeledElementDeclarations = namedMemberDeclarations;
          return type3;
        }
        function createNormalizedTypeReference(target, typeArguments) {
          return target.objectFlags & 8 ? createNormalizedTupleType(target, typeArguments) : createTypeReference(target, typeArguments);
        }
        function createNormalizedTupleType(target, elementTypes) {
          var _a2, _b, _c;
          if (!(target.combinedFlags & 14)) {
            return createTypeReference(target, elementTypes);
          }
          if (target.combinedFlags & 8) {
            var unionIndex_1 = ts3.findIndex(elementTypes, function(t2, i4) {
              return !!(target.elementFlags[i4] & 8 && t2.flags & (131072 | 1048576));
            });
            if (unionIndex_1 >= 0) {
              return checkCrossProductUnion(ts3.map(elementTypes, function(t2, i4) {
                return target.elementFlags[i4] & 8 ? t2 : unknownType;
              })) ? mapType(elementTypes[unionIndex_1], function(t2) {
                return createNormalizedTupleType(target, ts3.replaceElement(elementTypes, unionIndex_1, t2));
              }) : errorType;
            }
          }
          var expandedTypes = [];
          var expandedFlags = [];
          var expandedDeclarations = [];
          var lastRequiredIndex = -1;
          var firstRestIndex = -1;
          var lastOptionalOrRestIndex = -1;
          var _loop_13 = function(i4) {
            var type3 = elementTypes[i4];
            var flags = target.elementFlags[i4];
            if (flags & 8) {
              if (type3.flags & 58982400 || isGenericMappedType(type3)) {
                addElement(type3, 8, (_a2 = target.labeledElementDeclarations) === null || _a2 === void 0 ? void 0 : _a2[i4]);
              } else if (isTupleType(type3)) {
                var elements = getTypeArguments(type3);
                if (elements.length + expandedTypes.length >= 1e4) {
                  error(currentNode, ts3.isPartOfTypeNode(currentNode) ? ts3.Diagnostics.Type_produces_a_tuple_type_that_is_too_large_to_represent : ts3.Diagnostics.Expression_produces_a_tuple_type_that_is_too_large_to_represent);
                  return { value: errorType };
                }
                ts3.forEach(elements, function(t2, n2) {
                  var _a3;
                  return addElement(t2, type3.target.elementFlags[n2], (_a3 = type3.target.labeledElementDeclarations) === null || _a3 === void 0 ? void 0 : _a3[n2]);
                });
              } else {
                addElement(isArrayLikeType(type3) && getIndexTypeOfType(type3, 1) || errorType, 4, (_b = target.labeledElementDeclarations) === null || _b === void 0 ? void 0 : _b[i4]);
              }
            } else {
              addElement(type3, flags, (_c = target.labeledElementDeclarations) === null || _c === void 0 ? void 0 : _c[i4]);
            }
          };
          for (var i3 = 0; i3 < elementTypes.length; i3++) {
            var state_4 = _loop_13(i3);
            if (typeof state_4 === "object")
              return state_4.value;
          }
          for (var i3 = 0; i3 < lastRequiredIndex; i3++) {
            if (expandedFlags[i3] & 2)
              expandedFlags[i3] = 1;
          }
          if (firstRestIndex >= 0 && firstRestIndex < lastOptionalOrRestIndex) {
            expandedTypes[firstRestIndex] = getUnionType(ts3.sameMap(expandedTypes.slice(firstRestIndex, lastOptionalOrRestIndex + 1), function(t2, i4) {
              return expandedFlags[firstRestIndex + i4] & 8 ? getIndexedAccessType(t2, numberType) : t2;
            }));
            expandedTypes.splice(firstRestIndex + 1, lastOptionalOrRestIndex - firstRestIndex);
            expandedFlags.splice(firstRestIndex + 1, lastOptionalOrRestIndex - firstRestIndex);
            expandedDeclarations === null || expandedDeclarations === void 0 ? void 0 : expandedDeclarations.splice(firstRestIndex + 1, lastOptionalOrRestIndex - firstRestIndex);
          }
          var tupleTarget = getTupleTargetType(expandedFlags, target.readonly, expandedDeclarations);
          return tupleTarget === emptyGenericType ? emptyObjectType : expandedFlags.length ? createTypeReference(tupleTarget, expandedTypes) : tupleTarget;
          function addElement(type3, flags, declaration) {
            if (flags & 1) {
              lastRequiredIndex = expandedFlags.length;
            }
            if (flags & 4 && firstRestIndex < 0) {
              firstRestIndex = expandedFlags.length;
            }
            if (flags & (2 | 4)) {
              lastOptionalOrRestIndex = expandedFlags.length;
            }
            expandedTypes.push(type3);
            expandedFlags.push(flags);
            if (expandedDeclarations && declaration) {
              expandedDeclarations.push(declaration);
            } else {
              expandedDeclarations = void 0;
            }
          }
        }
        function sliceTupleType(type3, index, endSkipCount) {
          if (endSkipCount === void 0) {
            endSkipCount = 0;
          }
          var target = type3.target;
          var endIndex = getTypeReferenceArity(type3) - endSkipCount;
          return index > target.fixedLength ? getRestArrayTypeOfTupleType(type3) || createTupleType(ts3.emptyArray) : createTupleType(getTypeArguments(type3).slice(index, endIndex), target.elementFlags.slice(index, endIndex), false, target.labeledElementDeclarations && target.labeledElementDeclarations.slice(index, endIndex));
        }
        function getKnownKeysOfTupleType(type3) {
          return getUnionType(ts3.append(ts3.arrayOf(type3.target.fixedLength, function(i3) {
            return getLiteralType("" + i3);
          }), getIndexType(type3.target.readonly ? globalReadonlyArrayType : globalArrayType)));
        }
        function getStartElementCount(type3, flags) {
          var index = ts3.findIndex(type3.elementFlags, function(f) {
            return !(f & flags);
          });
          return index >= 0 ? index : type3.elementFlags.length;
        }
        function getEndElementCount(type3, flags) {
          return type3.elementFlags.length - ts3.findLastIndex(type3.elementFlags, function(f) {
            return !(f & flags);
          }) - 1;
        }
        function getTypeFromOptionalTypeNode(node) {
          var type3 = getTypeFromTypeNode(node.type);
          return strictNullChecks ? getOptionalType(type3) : type3;
        }
        function getTypeId(type3) {
          return type3.id;
        }
        function containsType(types2, type3) {
          return ts3.binarySearch(types2, type3, getTypeId, ts3.compareValues) >= 0;
        }
        function insertType(types2, type3) {
          var index = ts3.binarySearch(types2, type3, getTypeId, ts3.compareValues);
          if (index < 0) {
            types2.splice(~index, 0, type3);
            return true;
          }
          return false;
        }
        function addTypeToUnion(typeSet, includes, type3) {
          var flags = type3.flags;
          if (flags & 1048576) {
            return addTypesToUnion(typeSet, includes | (isNamedUnionType(type3) ? 1048576 : 0), type3.types);
          }
          if (!(flags & 131072)) {
            includes |= flags & 205258751;
            if (flags & 469499904)
              includes |= 262144;
            if (type3 === wildcardType)
              includes |= 8388608;
            if (!strictNullChecks && flags & 98304) {
              if (!(ts3.getObjectFlags(type3) & 131072))
                includes |= 4194304;
            } else {
              var len = typeSet.length;
              var index = len && type3.id > typeSet[len - 1].id ? ~len : ts3.binarySearch(typeSet, type3, getTypeId, ts3.compareValues);
              if (index < 0) {
                typeSet.splice(~index, 0, type3);
              }
            }
          }
          return includes;
        }
        function addTypesToUnion(typeSet, includes, types2) {
          for (var _i = 0, types_10 = types2; _i < types_10.length; _i++) {
            var type3 = types_10[_i];
            includes = addTypeToUnion(typeSet, includes, type3);
          }
          return includes;
        }
        function removeSubtypes(types2, hasObjectTypes) {
          var id = getTypeListId(types2);
          var match = subtypeReductionCache.get(id);
          if (match) {
            return match;
          }
          var hasEmptyObject = hasObjectTypes && ts3.some(types2, function(t3) {
            return !!(t3.flags & 524288) && !isGenericMappedType(t3) && isEmptyResolvedType(resolveStructuredTypeMembers(t3));
          });
          var len = types2.length;
          var i3 = len;
          var count = 0;
          while (i3 > 0) {
            i3--;
            var source = types2[i3];
            if (hasEmptyObject || source.flags & 469499904) {
              var keyProperty = source.flags & (524288 | 2097152 | 58982400) ? ts3.find(getPropertiesOfType(source), function(p) {
                return isUnitType(getTypeOfSymbol(p));
              }) : void 0;
              var keyPropertyType = keyProperty && getRegularTypeOfLiteralType(getTypeOfSymbol(keyProperty));
              for (var _i = 0, types_11 = types2; _i < types_11.length; _i++) {
                var target = types_11[_i];
                if (source !== target) {
                  if (count === 1e5) {
                    var estimatedCount = count / (len - i3) * len;
                    if (estimatedCount > 1e6) {
                      ts3.tracing === null || ts3.tracing === void 0 ? void 0 : ts3.tracing.instant("checkTypes", "removeSubtypes_DepthLimit", { typeIds: types2.map(function(t3) {
                        return t3.id;
                      }) });
                      error(currentNode, ts3.Diagnostics.Expression_produces_a_union_type_that_is_too_complex_to_represent);
                      return void 0;
                    }
                  }
                  count++;
                  if (keyProperty && target.flags & (524288 | 2097152 | 58982400)) {
                    var t2 = getTypeOfPropertyOfType(target, keyProperty.escapedName);
                    if (t2 && isUnitType(t2) && getRegularTypeOfLiteralType(t2) !== keyPropertyType) {
                      continue;
                    }
                  }
                  if (isTypeRelatedTo(source, target, strictSubtypeRelation) && (!(ts3.getObjectFlags(getTargetType(source)) & 1) || !(ts3.getObjectFlags(getTargetType(target)) & 1) || isTypeDerivedFrom(source, target))) {
                    ts3.orderedRemoveItemAt(types2, i3);
                    break;
                  }
                }
              }
            }
          }
          subtypeReductionCache.set(id, types2);
          return types2;
        }
        function removeRedundantLiteralTypes(types2, includes, reduceVoidUndefined) {
          var i3 = types2.length;
          while (i3 > 0) {
            i3--;
            var t2 = types2[i3];
            var flags = t2.flags;
            var remove = flags & 128 && includes & 4 || flags & 256 && includes & 8 || flags & 2048 && includes & 64 || flags & 8192 && includes & 4096 || reduceVoidUndefined && flags & 32768 && includes & 16384 || isFreshLiteralType(t2) && containsType(types2, t2.regularType);
            if (remove) {
              ts3.orderedRemoveItemAt(types2, i3);
            }
          }
        }
        function removeStringLiteralsMatchedByTemplateLiterals(types2) {
          var templates = ts3.filter(types2, isPatternLiteralType);
          if (templates.length) {
            var i3 = types2.length;
            var _loop_14 = function() {
              i3--;
              var t2 = types2[i3];
              if (t2.flags & 128 && ts3.some(templates, function(template) {
                return isTypeSubtypeOf(t2, template);
              })) {
                ts3.orderedRemoveItemAt(types2, i3);
              }
            };
            while (i3 > 0) {
              _loop_14();
            }
          }
        }
        function isNamedUnionType(type3) {
          return !!(type3.flags & 1048576 && (type3.aliasSymbol || type3.origin));
        }
        function addNamedUnions(namedUnions, types2) {
          for (var _i = 0, types_12 = types2; _i < types_12.length; _i++) {
            var t2 = types_12[_i];
            if (t2.flags & 1048576) {
              var origin = t2.origin;
              if (t2.aliasSymbol || origin && !(origin.flags & 1048576)) {
                ts3.pushIfUnique(namedUnions, t2);
              } else if (origin && origin.flags & 1048576) {
                addNamedUnions(namedUnions, origin.types);
              }
            }
          }
        }
        function createOriginUnionOrIntersectionType(flags, types2) {
          var result2 = createOriginType(flags);
          result2.types = types2;
          return result2;
        }
        function getUnionType(types2, unionReduction, aliasSymbol, aliasTypeArguments, origin) {
          if (unionReduction === void 0) {
            unionReduction = 1;
          }
          if (types2.length === 0) {
            return neverType;
          }
          if (types2.length === 1) {
            return types2[0];
          }
          var typeSet = [];
          var includes = addTypesToUnion(typeSet, 0, types2);
          if (unionReduction !== 0) {
            if (includes & 3) {
              return includes & 1 ? includes & 8388608 ? wildcardType : anyType : unknownType;
            }
            if (includes & (2944 | 8192) || includes & 16384 && includes & 32768) {
              removeRedundantLiteralTypes(typeSet, includes, !!(unionReduction & 2));
            }
            if (includes & 128 && includes & 134217728) {
              removeStringLiteralsMatchedByTemplateLiterals(typeSet);
            }
            if (unionReduction === 2) {
              typeSet = removeSubtypes(typeSet, !!(includes & 524288));
              if (!typeSet) {
                return errorType;
              }
            }
            if (typeSet.length === 0) {
              return includes & 65536 ? includes & 4194304 ? nullType : nullWideningType : includes & 32768 ? includes & 4194304 ? undefinedType : undefinedWideningType : neverType;
            }
          }
          if (!origin && includes & 1048576) {
            var namedUnions = [];
            addNamedUnions(namedUnions, types2);
            var reducedTypes = [];
            var _loop_15 = function(t3) {
              if (!ts3.some(namedUnions, function(union) {
                return containsType(union.types, t3);
              })) {
                reducedTypes.push(t3);
              }
            };
            for (var _i = 0, typeSet_1 = typeSet; _i < typeSet_1.length; _i++) {
              var t2 = typeSet_1[_i];
              _loop_15(t2);
            }
            if (!aliasSymbol && namedUnions.length === 1 && reducedTypes.length === 0) {
              return namedUnions[0];
            }
            var namedTypesCount = ts3.reduceLeft(namedUnions, function(sum, union) {
              return sum + union.types.length;
            }, 0);
            if (namedTypesCount + reducedTypes.length === typeSet.length) {
              for (var _a2 = 0, namedUnions_1 = namedUnions; _a2 < namedUnions_1.length; _a2++) {
                var t2 = namedUnions_1[_a2];
                insertType(reducedTypes, t2);
              }
              origin = createOriginUnionOrIntersectionType(1048576, reducedTypes);
            }
          }
          var objectFlags = (includes & 468598819 ? 0 : 65536) | (includes & 2097152 ? 67108864 : 0);
          return getUnionTypeFromSortedList(typeSet, objectFlags, aliasSymbol, aliasTypeArguments, origin);
        }
        function getUnionOrIntersectionTypePredicate(signatures, kind) {
          var first;
          var types2 = [];
          for (var _i = 0, signatures_6 = signatures; _i < signatures_6.length; _i++) {
            var sig = signatures_6[_i];
            var pred = getTypePredicateOfSignature(sig);
            if (!pred || pred.kind === 2 || pred.kind === 3) {
              if (kind !== 2097152) {
                continue;
              } else {
                return;
              }
            }
            if (first) {
              if (!typePredicateKindsMatch(first, pred)) {
                return void 0;
              }
            } else {
              first = pred;
            }
            types2.push(pred.type);
          }
          if (!first) {
            return void 0;
          }
          var compositeType = getUnionOrIntersectionType(types2, kind);
          return createTypePredicate(first.kind, first.parameterName, first.parameterIndex, compositeType);
        }
        function typePredicateKindsMatch(a2, b2) {
          return a2.kind === b2.kind && a2.parameterIndex === b2.parameterIndex;
        }
        function createUnionType(types2, aliasSymbol, aliasTypeArguments, origin) {
          var result2 = createType(1048576);
          result2.objectFlags = getPropagatingFlagsOfTypes(types2, 98304);
          result2.types = types2;
          result2.origin = origin;
          result2.aliasSymbol = aliasSymbol;
          result2.aliasTypeArguments = aliasTypeArguments;
          return result2;
        }
        function getUnionTypeFromSortedList(types2, objectFlags, aliasSymbol, aliasTypeArguments, origin) {
          if (types2.length === 0) {
            return neverType;
          }
          if (types2.length === 1) {
            return types2[0];
          }
          var typeKey = !origin ? getTypeListId(types2) : origin.flags & 1048576 ? "|" + getTypeListId(origin.types) : origin.flags & 2097152 ? "&" + getTypeListId(origin.types) : "#" + origin.type.id + "|" + getTypeListId(types2);
          var id = typeKey + getAliasId(aliasSymbol, aliasTypeArguments);
          var type3 = unionTypes.get(id);
          if (!type3) {
            type3 = createUnionType(types2, aliasSymbol, aliasTypeArguments, origin);
            type3.objectFlags |= objectFlags;
            unionTypes.set(id, type3);
          }
          return type3;
        }
        function getTypeFromUnionTypeNode(node) {
          var links = getNodeLinks(node);
          if (!links.resolvedType) {
            var aliasSymbol = getAliasSymbolForTypeNode(node);
            links.resolvedType = getUnionType(ts3.map(node.types, getTypeFromTypeNode), 1, aliasSymbol, getTypeArgumentsForAliasSymbol(aliasSymbol));
          }
          return links.resolvedType;
        }
        function addTypeToIntersection(typeSet, includes, type3) {
          var flags = type3.flags;
          if (flags & 2097152) {
            return addTypesToIntersection(typeSet, includes, type3.types);
          }
          if (isEmptyAnonymousObjectType(type3)) {
            if (!(includes & 16777216)) {
              includes |= 16777216;
              typeSet.set(type3.id.toString(), type3);
            }
          } else {
            if (flags & 3) {
              if (type3 === wildcardType)
                includes |= 8388608;
            } else if ((strictNullChecks || !(flags & 98304)) && !typeSet.has(type3.id.toString())) {
              if (type3.flags & 109440 && includes & 109440) {
                includes |= 67108864;
              }
              typeSet.set(type3.id.toString(), type3);
            }
            includes |= flags & 205258751;
          }
          return includes;
        }
        function addTypesToIntersection(typeSet, includes, types2) {
          for (var _i = 0, types_13 = types2; _i < types_13.length; _i++) {
            var type3 = types_13[_i];
            includes = addTypeToIntersection(typeSet, includes, getRegularTypeOfLiteralType(type3));
          }
          return includes;
        }
        function removeRedundantPrimitiveTypes(types2, includes) {
          var i3 = types2.length;
          while (i3 > 0) {
            i3--;
            var t2 = types2[i3];
            var remove = t2.flags & 4 && includes & 128 || t2.flags & 8 && includes & 256 || t2.flags & 64 && includes & 2048 || t2.flags & 4096 && includes & 8192;
            if (remove) {
              ts3.orderedRemoveItemAt(types2, i3);
            }
          }
        }
        function eachUnionContains(unionTypes2, type3) {
          for (var _i = 0, unionTypes_1 = unionTypes2; _i < unionTypes_1.length; _i++) {
            var u2 = unionTypes_1[_i];
            if (!containsType(u2.types, type3)) {
              var primitive = type3.flags & 128 ? stringType : type3.flags & 256 ? numberType : type3.flags & 2048 ? bigintType : type3.flags & 8192 ? esSymbolType : void 0;
              if (!primitive || !containsType(u2.types, primitive)) {
                return false;
              }
            }
          }
          return true;
        }
        function extractRedundantTemplateLiterals(types2) {
          var i3 = types2.length;
          var literals = ts3.filter(types2, function(t3) {
            return !!(t3.flags & 128);
          });
          while (i3 > 0) {
            i3--;
            var t2 = types2[i3];
            if (!(t2.flags & 134217728))
              continue;
            for (var _i = 0, literals_1 = literals; _i < literals_1.length; _i++) {
              var t22 = literals_1[_i];
              if (isTypeSubtypeOf(t22, t2)) {
                ts3.orderedRemoveItemAt(types2, i3);
                break;
              } else if (isPatternLiteralType(t2)) {
                return true;
              }
            }
          }
          return false;
        }
        function extractIrreducible(types2, flag) {
          if (ts3.every(types2, function(t2) {
            return !!(t2.flags & 1048576) && ts3.some(t2.types, function(tt) {
              return !!(tt.flags & flag);
            });
          })) {
            for (var i3 = 0; i3 < types2.length; i3++) {
              types2[i3] = filterType(types2[i3], function(t2) {
                return !(t2.flags & flag);
              });
            }
            return true;
          }
          return false;
        }
        function intersectUnionsOfPrimitiveTypes(types2) {
          var unionTypes2;
          var index = ts3.findIndex(types2, function(t3) {
            return !!(ts3.getObjectFlags(t3) & 65536);
          });
          if (index < 0) {
            return false;
          }
          var i3 = index + 1;
          while (i3 < types2.length) {
            var t2 = types2[i3];
            if (ts3.getObjectFlags(t2) & 65536) {
              (unionTypes2 || (unionTypes2 = [types2[index]])).push(t2);
              ts3.orderedRemoveItemAt(types2, i3);
            } else {
              i3++;
            }
          }
          if (!unionTypes2) {
            return false;
          }
          var checked = [];
          var result2 = [];
          for (var _i = 0, unionTypes_2 = unionTypes2; _i < unionTypes_2.length; _i++) {
            var u2 = unionTypes_2[_i];
            for (var _a2 = 0, _b = u2.types; _a2 < _b.length; _a2++) {
              var t2 = _b[_a2];
              if (insertType(checked, t2)) {
                if (eachUnionContains(unionTypes2, t2)) {
                  insertType(result2, t2);
                }
              }
            }
          }
          types2[index] = getUnionTypeFromSortedList(result2, 65536);
          return true;
        }
        function createIntersectionType(types2, aliasSymbol, aliasTypeArguments) {
          var result2 = createType(2097152);
          result2.objectFlags = getPropagatingFlagsOfTypes(types2, 98304);
          result2.types = types2;
          result2.aliasSymbol = aliasSymbol;
          result2.aliasTypeArguments = aliasTypeArguments;
          return result2;
        }
        function getIntersectionType(types2, aliasSymbol, aliasTypeArguments) {
          var typeMembershipMap = new ts3.Map();
          var includes = addTypesToIntersection(typeMembershipMap, 0, types2);
          var typeSet = ts3.arrayFrom(typeMembershipMap.values());
          if (includes & 131072 || strictNullChecks && includes & 98304 && includes & (524288 | 67108864 | 16777216) || includes & 67108864 && includes & (469892092 & ~67108864) || includes & 402653316 && includes & (469892092 & ~402653316) || includes & 296 && includes & (469892092 & ~296) || includes & 2112 && includes & (469892092 & ~2112) || includes & 12288 && includes & (469892092 & ~12288) || includes & 49152 && includes & (469892092 & ~49152)) {
            return neverType;
          }
          if (includes & 134217728 && includes & 128 && extractRedundantTemplateLiterals(typeSet)) {
            return neverType;
          }
          if (includes & 1) {
            return includes & 8388608 ? wildcardType : anyType;
          }
          if (!strictNullChecks && includes & 98304) {
            return includes & 32768 ? undefinedType : nullType;
          }
          if (includes & 4 && includes & 128 || includes & 8 && includes & 256 || includes & 64 && includes & 2048 || includes & 4096 && includes & 8192) {
            removeRedundantPrimitiveTypes(typeSet, includes);
          }
          if (includes & 16777216 && includes & 524288) {
            ts3.orderedRemoveItemAt(typeSet, ts3.findIndex(typeSet, isEmptyAnonymousObjectType));
          }
          if (typeSet.length === 0) {
            return unknownType;
          }
          if (typeSet.length === 1) {
            return typeSet[0];
          }
          var id = getTypeListId(typeSet) + getAliasId(aliasSymbol, aliasTypeArguments);
          var result2 = intersectionTypes.get(id);
          if (!result2) {
            if (includes & 1048576) {
              if (intersectUnionsOfPrimitiveTypes(typeSet)) {
                result2 = getIntersectionType(typeSet, aliasSymbol, aliasTypeArguments);
              } else if (extractIrreducible(typeSet, 32768)) {
                result2 = getUnionType([getIntersectionType(typeSet), undefinedType], 1, aliasSymbol, aliasTypeArguments);
              } else if (extractIrreducible(typeSet, 65536)) {
                result2 = getUnionType([getIntersectionType(typeSet), nullType], 1, aliasSymbol, aliasTypeArguments);
              } else {
                if (!checkCrossProductUnion(typeSet)) {
                  return errorType;
                }
                var constituents = getCrossProductIntersections(typeSet);
                var origin = ts3.some(constituents, function(t2) {
                  return !!(t2.flags & 2097152);
                }) ? createOriginUnionOrIntersectionType(2097152, typeSet) : void 0;
                result2 = getUnionType(constituents, 1, aliasSymbol, aliasTypeArguments, origin);
              }
            } else {
              result2 = createIntersectionType(typeSet, aliasSymbol, aliasTypeArguments);
            }
            intersectionTypes.set(id, result2);
          }
          return result2;
        }
        function getCrossProductUnionSize(types2) {
          return ts3.reduceLeft(types2, function(n2, t2) {
            return t2.flags & 1048576 ? n2 * t2.types.length : t2.flags & 131072 ? 0 : n2;
          }, 1);
        }
        function checkCrossProductUnion(types2) {
          var size = getCrossProductUnionSize(types2);
          if (size >= 1e5) {
            ts3.tracing === null || ts3.tracing === void 0 ? void 0 : ts3.tracing.instant("checkTypes", "checkCrossProductUnion_DepthLimit", { typeIds: types2.map(function(t2) {
              return t2.id;
            }), size });
            error(currentNode, ts3.Diagnostics.Expression_produces_a_union_type_that_is_too_complex_to_represent);
            return false;
          }
          return true;
        }
        function getCrossProductIntersections(types2) {
          var count = getCrossProductUnionSize(types2);
          var intersections = [];
          for (var i3 = 0; i3 < count; i3++) {
            var constituents = types2.slice();
            var n2 = i3;
            for (var j = types2.length - 1; j >= 0; j--) {
              if (types2[j].flags & 1048576) {
                var sourceTypes = types2[j].types;
                var length_5 = sourceTypes.length;
                constituents[j] = sourceTypes[n2 % length_5];
                n2 = Math.floor(n2 / length_5);
              }
            }
            var t2 = getIntersectionType(constituents);
            if (!(t2.flags & 131072))
              intersections.push(t2);
          }
          return intersections;
        }
        function getTypeFromIntersectionTypeNode(node) {
          var links = getNodeLinks(node);
          if (!links.resolvedType) {
            var aliasSymbol = getAliasSymbolForTypeNode(node);
            links.resolvedType = getIntersectionType(ts3.map(node.types, getTypeFromTypeNode), aliasSymbol, getTypeArgumentsForAliasSymbol(aliasSymbol));
          }
          return links.resolvedType;
        }
        function createIndexType(type3, stringsOnly) {
          var result2 = createType(4194304);
          result2.type = type3;
          result2.stringsOnly = stringsOnly;
          return result2;
        }
        function createOriginIndexType(type3) {
          var result2 = createOriginType(4194304);
          result2.type = type3;
          return result2;
        }
        function getIndexTypeForGenericType(type3, stringsOnly) {
          return stringsOnly ? type3.resolvedStringIndexType || (type3.resolvedStringIndexType = createIndexType(type3, true)) : type3.resolvedIndexType || (type3.resolvedIndexType = createIndexType(type3, false));
        }
        function instantiateTypeAsMappedNameType(nameType, type3, t2) {
          return instantiateType(nameType, appendTypeMapping(type3.mapper, getTypeParameterFromMappedType(type3), t2));
        }
        function getIndexTypeForMappedType(type3, noIndexSignatures) {
          var constraint = filterType(getConstraintTypeFromMappedType(type3), function(t2) {
            return !(noIndexSignatures && t2.flags & (1 | 4));
          });
          var nameType = type3.declaration.nameType && getTypeFromTypeNode(type3.declaration.nameType);
          var properties = nameType && everyType(constraint, function(t2) {
            return !!(t2.flags & (4 | 8 | 131072));
          }) && getPropertiesOfType(getApparentType(getModifiersTypeFromMappedType(type3)));
          return nameType ? getUnionType([mapType(constraint, function(t2) {
            return instantiateTypeAsMappedNameType(nameType, type3, t2);
          }), mapType(getUnionType(ts3.map(properties || ts3.emptyArray, function(p) {
            return getLiteralTypeFromProperty(p, 8576);
          })), function(t2) {
            return instantiateTypeAsMappedNameType(nameType, type3, t2);
          })]) : constraint;
        }
        function maybeNonDistributiveNameType(type3) {
          return !!(type3 && (type3.flags & 16777216 && (!type3.root.isDistributive || maybeNonDistributiveNameType(type3.checkType)) || type3.flags & (3145728 | 134217728) && ts3.some(type3.types, maybeNonDistributiveNameType) || type3.flags & (4194304 | 268435456) && maybeNonDistributiveNameType(type3.type) || type3.flags & 8388608 && maybeNonDistributiveNameType(type3.indexType) || type3.flags & 33554432 && maybeNonDistributiveNameType(type3.substitute)));
        }
        function getLiteralTypeFromPropertyName(name) {
          if (ts3.isPrivateIdentifier(name)) {
            return neverType;
          }
          return ts3.isIdentifier(name) ? getLiteralType(ts3.unescapeLeadingUnderscores(name.escapedText)) : getRegularTypeOfLiteralType(ts3.isComputedPropertyName(name) ? checkComputedPropertyName(name) : checkExpression(name));
        }
        function getBigIntLiteralType(node) {
          return getLiteralType({
            negative: false,
            base10Value: ts3.parsePseudoBigInt(node.text)
          });
        }
        function getLiteralTypeFromProperty(prop, include) {
          if (!(ts3.getDeclarationModifierFlagsFromSymbol(prop) & 24)) {
            var type3 = getSymbolLinks(getLateBoundSymbol(prop)).nameType;
            if (!type3) {
              if (prop.escapedName === "default") {
                type3 = getLiteralType("default");
              } else {
                var name = prop.valueDeclaration && ts3.getNameOfDeclaration(prop.valueDeclaration);
                type3 = name && getLiteralTypeFromPropertyName(name) || (!ts3.isKnownSymbol(prop) ? getLiteralType(ts3.symbolName(prop)) : void 0);
              }
            }
            if (type3 && type3.flags & include) {
              return type3;
            }
          }
          return neverType;
        }
        function getLiteralTypeFromProperties(type3, include, includeOrigin) {
          var origin = includeOrigin && (ts3.getObjectFlags(type3) & (3 | 4) || type3.aliasSymbol) ? createOriginIndexType(type3) : void 0;
          return getUnionType(ts3.map(getPropertiesOfType(type3), function(p) {
            return getLiteralTypeFromProperty(p, include);
          }), 1, void 0, void 0, origin);
        }
        function getNonEnumNumberIndexInfo(type3) {
          var numberIndexInfo = getIndexInfoOfType(type3, 1);
          return numberIndexInfo !== enumNumberIndexInfo ? numberIndexInfo : void 0;
        }
        function getIndexType(type3, stringsOnly, noIndexSignatures) {
          if (stringsOnly === void 0) {
            stringsOnly = keyofStringsOnly;
          }
          var includeOrigin = stringsOnly === keyofStringsOnly && !noIndexSignatures;
          type3 = getReducedType(type3);
          return type3.flags & 1048576 ? getIntersectionType(ts3.map(type3.types, function(t2) {
            return getIndexType(t2, stringsOnly, noIndexSignatures);
          })) : type3.flags & 2097152 ? getUnionType(ts3.map(type3.types, function(t2) {
            return getIndexType(t2, stringsOnly, noIndexSignatures);
          })) : type3.flags & 58982400 || isGenericTupleType(type3) || isGenericMappedType(type3) && maybeNonDistributiveNameType(getNameTypeFromMappedType(type3)) ? getIndexTypeForGenericType(type3, stringsOnly) : ts3.getObjectFlags(type3) & 32 ? getIndexTypeForMappedType(type3, noIndexSignatures) : type3 === wildcardType ? wildcardType : type3.flags & 2 ? neverType : type3.flags & (1 | 131072) ? keyofConstraintType : stringsOnly ? !noIndexSignatures && getIndexInfoOfType(type3, 0) ? stringType : getLiteralTypeFromProperties(type3, 128, includeOrigin) : !noIndexSignatures && getIndexInfoOfType(type3, 0) ? getUnionType([stringType, numberType, getLiteralTypeFromProperties(type3, 8192, includeOrigin)]) : getNonEnumNumberIndexInfo(type3) ? getUnionType([numberType, getLiteralTypeFromProperties(type3, 128 | 8192, includeOrigin)]) : getLiteralTypeFromProperties(type3, 8576, includeOrigin);
        }
        function getExtractStringType(type3) {
          if (keyofStringsOnly) {
            return type3;
          }
          var extractTypeAlias = getGlobalExtractSymbol();
          return extractTypeAlias ? getTypeAliasInstantiation(extractTypeAlias, [type3, stringType]) : stringType;
        }
        function getIndexTypeOrString(type3) {
          var indexType = getExtractStringType(getIndexType(type3));
          return indexType.flags & 131072 ? stringType : indexType;
        }
        function getTypeFromTypeOperatorNode(node) {
          var links = getNodeLinks(node);
          if (!links.resolvedType) {
            switch (node.operator) {
              case 138:
                links.resolvedType = getIndexType(getTypeFromTypeNode(node.type));
                break;
              case 151:
                links.resolvedType = node.type.kind === 148 ? getESSymbolLikeTypeForNode(ts3.walkUpParenthesizedTypes(node.parent)) : errorType;
                break;
              case 142:
                links.resolvedType = getTypeFromTypeNode(node.type);
                break;
              default:
                throw ts3.Debug.assertNever(node.operator);
            }
          }
          return links.resolvedType;
        }
        function getTypeFromTemplateTypeNode(node) {
          var links = getNodeLinks(node);
          if (!links.resolvedType) {
            links.resolvedType = getTemplateLiteralType(__spreadArray([node.head.text], ts3.map(node.templateSpans, function(span) {
              return span.literal.text;
            })), ts3.map(node.templateSpans, function(span) {
              return getTypeFromTypeNode(span.type);
            }));
          }
          return links.resolvedType;
        }
        function getTemplateLiteralType(texts, types2) {
          var unionIndex = ts3.findIndex(types2, function(t2) {
            return !!(t2.flags & (131072 | 1048576));
          });
          if (unionIndex >= 0) {
            return checkCrossProductUnion(types2) ? mapType(types2[unionIndex], function(t2) {
              return getTemplateLiteralType(texts, ts3.replaceElement(types2, unionIndex, t2));
            }) : errorType;
          }
          if (ts3.contains(types2, wildcardType)) {
            return wildcardType;
          }
          var newTypes = [];
          var newTexts = [];
          var text = texts[0];
          if (!addSpans(texts, types2)) {
            return stringType;
          }
          if (newTypes.length === 0) {
            return getLiteralType(text);
          }
          newTexts.push(text);
          if (ts3.every(newTexts, function(t2) {
            return t2 === "";
          }) && ts3.every(newTypes, function(t2) {
            return !!(t2.flags & 4);
          })) {
            return stringType;
          }
          var id = getTypeListId(newTypes) + "|" + ts3.map(newTexts, function(t2) {
            return t2.length;
          }).join(",") + "|" + newTexts.join("");
          var type3 = templateLiteralTypes.get(id);
          if (!type3) {
            templateLiteralTypes.set(id, type3 = createTemplateLiteralType(newTexts, newTypes));
          }
          return type3;
          function addSpans(texts2, types3) {
            for (var i3 = 0; i3 < types3.length; i3++) {
              var t2 = types3[i3];
              if (t2.flags & (2944 | 65536 | 32768)) {
                text += getTemplateStringForType(t2) || "";
                text += texts2[i3 + 1];
              } else if (t2.flags & 134217728) {
                text += t2.texts[0];
                if (!addSpans(t2.texts, t2.types))
                  return false;
                text += texts2[i3 + 1];
              } else if (isGenericIndexType(t2) || isPatternLiteralPlaceholderType(t2)) {
                newTypes.push(t2);
                newTexts.push(text);
                text = texts2[i3 + 1];
              } else {
                return false;
              }
            }
            return true;
          }
        }
        function getTemplateStringForType(type3) {
          return type3.flags & 128 ? type3.value : type3.flags & 256 ? "" + type3.value : type3.flags & 2048 ? ts3.pseudoBigIntToString(type3.value) : type3.flags & (512 | 98304) ? type3.intrinsicName : void 0;
        }
        function createTemplateLiteralType(texts, types2) {
          var type3 = createType(134217728);
          type3.texts = texts;
          type3.types = types2;
          return type3;
        }
        function getStringMappingType(symbol, type3) {
          return type3.flags & (1048576 | 131072) ? mapType(type3, function(t2) {
            return getStringMappingType(symbol, t2);
          }) : isGenericIndexType(type3) ? getStringMappingTypeForGenericType(symbol, type3) : type3.flags & 128 ? getLiteralType(applyStringMapping(symbol, type3.value)) : type3;
        }
        function applyStringMapping(symbol, str2) {
          switch (intrinsicTypeKinds.get(symbol.escapedName)) {
            case 0:
              return str2.toUpperCase();
            case 1:
              return str2.toLowerCase();
            case 2:
              return str2.charAt(0).toUpperCase() + str2.slice(1);
            case 3:
              return str2.charAt(0).toLowerCase() + str2.slice(1);
          }
          return str2;
        }
        function getStringMappingTypeForGenericType(symbol, type3) {
          var id = getSymbolId(symbol) + "," + getTypeId(type3);
          var result2 = stringMappingTypes.get(id);
          if (!result2) {
            stringMappingTypes.set(id, result2 = createStringMappingType(symbol, type3));
          }
          return result2;
        }
        function createStringMappingType(symbol, type3) {
          var result2 = createType(268435456);
          result2.symbol = symbol;
          result2.type = type3;
          return result2;
        }
        function createIndexedAccessType(objectType, indexType, aliasSymbol, aliasTypeArguments, shouldIncludeUndefined) {
          var type3 = createType(8388608);
          type3.objectType = objectType;
          type3.indexType = indexType;
          type3.aliasSymbol = aliasSymbol;
          type3.aliasTypeArguments = aliasTypeArguments;
          type3.noUncheckedIndexedAccessCandidate = shouldIncludeUndefined;
          return type3;
        }
        function isJSLiteralType(type3) {
          if (noImplicitAny) {
            return false;
          }
          if (ts3.getObjectFlags(type3) & 8192) {
            return true;
          }
          if (type3.flags & 1048576) {
            return ts3.every(type3.types, isJSLiteralType);
          }
          if (type3.flags & 2097152) {
            return ts3.some(type3.types, isJSLiteralType);
          }
          if (type3.flags & 465829888) {
            var constraint = getResolvedBaseConstraint(type3);
            return constraint !== type3 && isJSLiteralType(constraint);
          }
          return false;
        }
        function getPropertyNameFromIndex(indexType, accessNode) {
          return isTypeUsableAsPropertyName(indexType) ? getPropertyNameFromType(indexType) : accessNode && ts3.isPropertyName(accessNode) ? ts3.getPropertyNameForPropertyNameNode(accessNode) : void 0;
        }
        function isUncalledFunctionReference(node, symbol) {
          if (symbol.flags & (16 | 8192)) {
            var parent = ts3.findAncestor(node.parent, function(n2) {
              return !ts3.isAccessExpression(n2);
            }) || node.parent;
            if (ts3.isCallLikeExpression(parent)) {
              return ts3.isCallOrNewExpression(parent) && ts3.isIdentifier(node) && hasMatchingArgument(parent, node);
            }
            return ts3.every(symbol.declarations, function(d) {
              return !ts3.isFunctionLike(d) || !!(ts3.getCombinedNodeFlags(d) & 134217728);
            });
          }
          return true;
        }
        function getPropertyTypeForIndexType(originalObjectType, objectType, indexType, fullIndexType, suppressNoImplicitAnyError, accessNode, accessFlags, noUncheckedIndexedAccessCandidate, reportDeprecated) {
          var _a2;
          var accessExpression = accessNode && accessNode.kind === 203 ? accessNode : void 0;
          var propName = accessNode && ts3.isPrivateIdentifier(accessNode) ? void 0 : getPropertyNameFromIndex(indexType, accessNode);
          if (propName !== void 0) {
            var prop = getPropertyOfType(objectType, propName);
            if (prop) {
              if (reportDeprecated && accessNode && prop.declarations && getDeclarationNodeFlagsFromSymbol(prop) & 134217728 && isUncalledFunctionReference(accessNode, prop)) {
                var deprecatedNode = (_a2 = accessExpression === null || accessExpression === void 0 ? void 0 : accessExpression.argumentExpression) !== null && _a2 !== void 0 ? _a2 : ts3.isIndexedAccessTypeNode(accessNode) ? accessNode.indexType : accessNode;
                addDeprecatedSuggestion(deprecatedNode, prop.declarations, propName);
              }
              if (accessExpression) {
                markPropertyAsReferenced(prop, accessExpression, isSelfTypeAccess(accessExpression.expression, objectType.symbol));
                if (isAssignmentToReadonlyEntity(accessExpression, prop, ts3.getAssignmentTargetKind(accessExpression))) {
                  error(accessExpression.argumentExpression, ts3.Diagnostics.Cannot_assign_to_0_because_it_is_a_read_only_property, symbolToString(prop));
                  return void 0;
                }
                if (accessFlags & 4) {
                  getNodeLinks(accessNode).resolvedSymbol = prop;
                }
                if (isThisPropertyAccessInConstructor(accessExpression, prop)) {
                  return autoType;
                }
              }
              var propType = getTypeOfSymbol(prop);
              return accessExpression && ts3.getAssignmentTargetKind(accessExpression) !== 1 ? getFlowTypeOfReference(accessExpression, propType) : propType;
            }
            if (everyType(objectType, isTupleType) && isNumericLiteralName(propName) && +propName >= 0) {
              if (accessNode && everyType(objectType, function(t2) {
                return !t2.target.hasRestElement;
              }) && !(accessFlags & 8)) {
                var indexNode = getIndexNodeForAccessExpression(accessNode);
                if (isTupleType(objectType)) {
                  error(indexNode, ts3.Diagnostics.Tuple_type_0_of_length_1_has_no_element_at_index_2, typeToString(objectType), getTypeReferenceArity(objectType), ts3.unescapeLeadingUnderscores(propName));
                } else {
                  error(indexNode, ts3.Diagnostics.Property_0_does_not_exist_on_type_1, ts3.unescapeLeadingUnderscores(propName), typeToString(objectType));
                }
              }
              errorIfWritingToReadonlyIndex(getIndexInfoOfType(objectType, 1));
              return mapType(objectType, function(t2) {
                var restType = getRestTypeOfTupleType(t2) || undefinedType;
                return noUncheckedIndexedAccessCandidate ? getUnionType([restType, undefinedType]) : restType;
              });
            }
          }
          if (!(indexType.flags & 98304) && isTypeAssignableToKind(indexType, 402653316 | 296 | 12288)) {
            if (objectType.flags & (1 | 131072)) {
              return objectType;
            }
            var stringIndexInfo = getIndexInfoOfType(objectType, 0);
            var indexInfo = isTypeAssignableToKind(indexType, 296) && getIndexInfoOfType(objectType, 1) || stringIndexInfo;
            if (indexInfo) {
              if (accessFlags & 1 && indexInfo === stringIndexInfo) {
                if (accessExpression) {
                  error(accessExpression, ts3.Diagnostics.Type_0_cannot_be_used_to_index_type_1, typeToString(indexType), typeToString(originalObjectType));
                }
                return void 0;
              }
              if (accessNode && !isTypeAssignableToKind(indexType, 4 | 8)) {
                var indexNode = getIndexNodeForAccessExpression(accessNode);
                error(indexNode, ts3.Diagnostics.Type_0_cannot_be_used_as_an_index_type, typeToString(indexType));
                return noUncheckedIndexedAccessCandidate ? getUnionType([indexInfo.type, undefinedType]) : indexInfo.type;
              }
              errorIfWritingToReadonlyIndex(indexInfo);
              return noUncheckedIndexedAccessCandidate ? getUnionType([indexInfo.type, undefinedType]) : indexInfo.type;
            }
            if (indexType.flags & 131072) {
              return neverType;
            }
            if (isJSLiteralType(objectType)) {
              return anyType;
            }
            if (accessExpression && !isConstEnumObjectType(objectType)) {
              if (isObjectLiteralType(objectType)) {
                if (noImplicitAny && indexType.flags & (128 | 256)) {
                  diagnostics.add(ts3.createDiagnosticForNode(accessExpression, ts3.Diagnostics.Property_0_does_not_exist_on_type_1, indexType.value, typeToString(objectType)));
                  return undefinedType;
                } else if (indexType.flags & (8 | 4)) {
                  var types2 = ts3.map(objectType.properties, function(property) {
                    return getTypeOfSymbol(property);
                  });
                  return getUnionType(ts3.append(types2, undefinedType));
                }
              }
              if (objectType.symbol === globalThisSymbol && propName !== void 0 && globalThisSymbol.exports.has(propName) && globalThisSymbol.exports.get(propName).flags & 418) {
                error(accessExpression, ts3.Diagnostics.Property_0_does_not_exist_on_type_1, ts3.unescapeLeadingUnderscores(propName), typeToString(objectType));
              } else if (noImplicitAny && !compilerOptions.suppressImplicitAnyIndexErrors && !suppressNoImplicitAnyError) {
                if (propName !== void 0 && typeHasStaticProperty(propName, objectType)) {
                  var typeName = typeToString(objectType);
                  error(accessExpression, ts3.Diagnostics.Property_0_does_not_exist_on_type_1_Did_you_mean_to_access_the_static_member_2_instead, propName, typeName, typeName + "[" + ts3.getTextOfNode(accessExpression.argumentExpression) + "]");
                } else if (getIndexTypeOfType(objectType, 1)) {
                  error(accessExpression.argumentExpression, ts3.Diagnostics.Element_implicitly_has_an_any_type_because_index_expression_is_not_of_type_number);
                } else {
                  var suggestion = void 0;
                  if (propName !== void 0 && (suggestion = getSuggestionForNonexistentProperty(propName, objectType))) {
                    if (suggestion !== void 0) {
                      error(accessExpression.argumentExpression, ts3.Diagnostics.Property_0_does_not_exist_on_type_1_Did_you_mean_2, propName, typeToString(objectType), suggestion);
                    }
                  } else {
                    var suggestion_1 = getSuggestionForNonexistentIndexSignature(objectType, accessExpression, indexType);
                    if (suggestion_1 !== void 0) {
                      error(accessExpression, ts3.Diagnostics.Element_implicitly_has_an_any_type_because_type_0_has_no_index_signature_Did_you_mean_to_call_1, typeToString(objectType), suggestion_1);
                    } else {
                      var errorInfo = void 0;
                      if (indexType.flags & 1024) {
                        errorInfo = ts3.chainDiagnosticMessages(void 0, ts3.Diagnostics.Property_0_does_not_exist_on_type_1, "[" + typeToString(indexType) + "]", typeToString(objectType));
                      } else if (indexType.flags & 8192) {
                        var symbolName_2 = getFullyQualifiedName(indexType.symbol, accessExpression);
                        errorInfo = ts3.chainDiagnosticMessages(void 0, ts3.Diagnostics.Property_0_does_not_exist_on_type_1, "[" + symbolName_2 + "]", typeToString(objectType));
                      } else if (indexType.flags & 128) {
                        errorInfo = ts3.chainDiagnosticMessages(void 0, ts3.Diagnostics.Property_0_does_not_exist_on_type_1, indexType.value, typeToString(objectType));
                      } else if (indexType.flags & 256) {
                        errorInfo = ts3.chainDiagnosticMessages(void 0, ts3.Diagnostics.Property_0_does_not_exist_on_type_1, indexType.value, typeToString(objectType));
                      } else if (indexType.flags & (8 | 4)) {
                        errorInfo = ts3.chainDiagnosticMessages(void 0, ts3.Diagnostics.No_index_signature_with_a_parameter_of_type_0_was_found_on_type_1, typeToString(indexType), typeToString(objectType));
                      }
                      errorInfo = ts3.chainDiagnosticMessages(errorInfo, ts3.Diagnostics.Element_implicitly_has_an_any_type_because_expression_of_type_0_can_t_be_used_to_index_type_1, typeToString(fullIndexType), typeToString(objectType));
                      diagnostics.add(ts3.createDiagnosticForNodeFromMessageChain(accessExpression, errorInfo));
                    }
                  }
                }
              }
              return void 0;
            }
          }
          if (isJSLiteralType(objectType)) {
            return anyType;
          }
          if (accessNode) {
            var indexNode = getIndexNodeForAccessExpression(accessNode);
            if (indexType.flags & (128 | 256)) {
              error(indexNode, ts3.Diagnostics.Property_0_does_not_exist_on_type_1, "" + indexType.value, typeToString(objectType));
            } else if (indexType.flags & (4 | 8)) {
              error(indexNode, ts3.Diagnostics.Type_0_has_no_matching_index_signature_for_type_1, typeToString(objectType), typeToString(indexType));
            } else {
              error(indexNode, ts3.Diagnostics.Type_0_cannot_be_used_as_an_index_type, typeToString(indexType));
            }
          }
          if (isTypeAny(indexType)) {
            return indexType;
          }
          return void 0;
          function errorIfWritingToReadonlyIndex(indexInfo2) {
            if (indexInfo2 && indexInfo2.isReadonly && accessExpression && (ts3.isAssignmentTarget(accessExpression) || ts3.isDeleteTarget(accessExpression))) {
              error(accessExpression, ts3.Diagnostics.Index_signature_in_type_0_only_permits_reading, typeToString(objectType));
            }
          }
        }
        function getIndexNodeForAccessExpression(accessNode) {
          return accessNode.kind === 203 ? accessNode.argumentExpression : accessNode.kind === 190 ? accessNode.indexType : accessNode.kind === 159 ? accessNode.expression : accessNode;
        }
        function isPatternLiteralPlaceholderType(type3) {
          return !!(type3.flags & (1 | 4 | 8 | 64));
        }
        function isPatternLiteralType(type3) {
          return !!(type3.flags & 134217728) && ts3.every(type3.types, isPatternLiteralPlaceholderType);
        }
        function isGenericObjectType(type3) {
          if (type3.flags & 3145728) {
            if (!(type3.objectFlags & 4194304)) {
              type3.objectFlags |= 4194304 | (ts3.some(type3.types, isGenericObjectType) ? 8388608 : 0);
            }
            return !!(type3.objectFlags & 8388608);
          }
          if (type3.flags & 33554432) {
            if (!(type3.objectFlags & 4194304)) {
              type3.objectFlags |= 4194304 | (isGenericObjectType(type3.substitute) || isGenericObjectType(type3.baseType) ? 8388608 : 0);
            }
            return !!(type3.objectFlags & 8388608);
          }
          return !!(type3.flags & 58982400) || isGenericMappedType(type3) || isGenericTupleType(type3);
        }
        function isGenericIndexType(type3) {
          if (type3.flags & 3145728) {
            if (!(type3.objectFlags & 16777216)) {
              type3.objectFlags |= 16777216 | (ts3.some(type3.types, isGenericIndexType) ? 33554432 : 0);
            }
            return !!(type3.objectFlags & 33554432);
          }
          if (type3.flags & 33554432) {
            if (!(type3.objectFlags & 16777216)) {
              type3.objectFlags |= 16777216 | (isGenericIndexType(type3.substitute) || isGenericIndexType(type3.baseType) ? 33554432 : 0);
            }
            return !!(type3.objectFlags & 33554432);
          }
          return !!(type3.flags & (58982400 | 4194304 | 134217728 | 268435456)) && !isPatternLiteralType(type3);
        }
        function isThisTypeParameter(type3) {
          return !!(type3.flags & 262144 && type3.isThisType);
        }
        function getSimplifiedType(type3, writing) {
          return type3.flags & 8388608 ? getSimplifiedIndexedAccessType(type3, writing) : type3.flags & 16777216 ? getSimplifiedConditionalType(type3, writing) : type3;
        }
        function distributeIndexOverObjectType(objectType, indexType, writing) {
          if (objectType.flags & 3145728) {
            var types2 = ts3.map(objectType.types, function(t2) {
              return getSimplifiedType(getIndexedAccessType(t2, indexType), writing);
            });
            return objectType.flags & 2097152 || writing ? getIntersectionType(types2) : getUnionType(types2);
          }
        }
        function distributeObjectOverIndexType(objectType, indexType, writing) {
          if (indexType.flags & 1048576) {
            var types2 = ts3.map(indexType.types, function(t2) {
              return getSimplifiedType(getIndexedAccessType(objectType, t2), writing);
            });
            return writing ? getIntersectionType(types2) : getUnionType(types2);
          }
        }
        function getSimplifiedIndexedAccessType(type3, writing) {
          var cache = writing ? "simplifiedForWriting" : "simplifiedForReading";
          if (type3[cache]) {
            return type3[cache] === circularConstraintType ? type3 : type3[cache];
          }
          type3[cache] = circularConstraintType;
          var objectType = getSimplifiedType(type3.objectType, writing);
          var indexType = getSimplifiedType(type3.indexType, writing);
          var distributedOverIndex = distributeObjectOverIndexType(objectType, indexType, writing);
          if (distributedOverIndex) {
            return type3[cache] = distributedOverIndex;
          }
          if (!(indexType.flags & 465829888)) {
            var distributedOverObject = distributeIndexOverObjectType(objectType, indexType, writing);
            if (distributedOverObject) {
              return type3[cache] = distributedOverObject;
            }
          }
          if (isGenericTupleType(objectType) && indexType.flags & 296) {
            var elementType = getElementTypeOfSliceOfTupleType(objectType, indexType.flags & 8 ? 0 : objectType.target.fixedLength, 0, writing);
            if (elementType) {
              return type3[cache] = elementType;
            }
          }
          if (isGenericMappedType(objectType)) {
            return type3[cache] = mapType(substituteIndexedMappedType(objectType, type3.indexType), function(t2) {
              return getSimplifiedType(t2, writing);
            });
          }
          return type3[cache] = type3;
        }
        function isConditionalTypeAlwaysTrueDisregardingInferTypes(type3) {
          var extendsInferParamMapper = type3.root.inferTypeParameters && createTypeMapper(type3.root.inferTypeParameters, ts3.map(type3.root.inferTypeParameters, function() {
            return wildcardType;
          }));
          var checkType = type3.checkType;
          var extendsType = type3.extendsType;
          return isTypeAssignableTo(getRestrictiveInstantiation(checkType), getRestrictiveInstantiation(instantiateType(extendsType, extendsInferParamMapper)));
        }
        function getSimplifiedConditionalType(type3, writing) {
          var checkType = type3.checkType;
          var extendsType = type3.extendsType;
          var trueType2 = getTrueTypeFromConditionalType(type3);
          var falseType2 = getFalseTypeFromConditionalType(type3);
          if (falseType2.flags & 131072 && getActualTypeVariable(trueType2) === getActualTypeVariable(checkType)) {
            if (checkType.flags & 1 || isTypeAssignableTo(getRestrictiveInstantiation(checkType), getRestrictiveInstantiation(extendsType))) {
              return getSimplifiedType(trueType2, writing);
            } else if (isIntersectionEmpty(checkType, extendsType)) {
              return neverType;
            }
          } else if (trueType2.flags & 131072 && getActualTypeVariable(falseType2) === getActualTypeVariable(checkType)) {
            if (!(checkType.flags & 1) && isTypeAssignableTo(getRestrictiveInstantiation(checkType), getRestrictiveInstantiation(extendsType))) {
              return neverType;
            } else if (checkType.flags & 1 || isIntersectionEmpty(checkType, extendsType)) {
              return getSimplifiedType(falseType2, writing);
            }
          }
          return type3;
        }
        function isIntersectionEmpty(type1, type22) {
          return !!(getUnionType([intersectTypes(type1, type22), neverType]).flags & 131072);
        }
        function substituteIndexedMappedType(objectType, index) {
          var mapper = createTypeMapper([getTypeParameterFromMappedType(objectType)], [index]);
          var templateMapper = combineTypeMappers(objectType.mapper, mapper);
          return instantiateType(getTemplateTypeFromMappedType(objectType), templateMapper);
        }
        function getIndexedAccessType(objectType, indexType, noUncheckedIndexedAccessCandidate, accessNode, aliasSymbol, aliasTypeArguments, accessFlags) {
          if (accessFlags === void 0) {
            accessFlags = 0;
          }
          return getIndexedAccessTypeOrUndefined(objectType, indexType, noUncheckedIndexedAccessCandidate, accessNode, accessFlags, aliasSymbol, aliasTypeArguments) || (accessNode ? errorType : unknownType);
        }
        function indexTypeLessThan(indexType, limit) {
          return everyType(indexType, function(t2) {
            if (t2.flags & 384) {
              var propName = getPropertyNameFromType(t2);
              if (isNumericLiteralName(propName)) {
                var index = +propName;
                return index >= 0 && index < limit;
              }
            }
            return false;
          });
        }
        function getIndexedAccessTypeOrUndefined(objectType, indexType, noUncheckedIndexedAccessCandidate, accessNode, accessFlags, aliasSymbol, aliasTypeArguments) {
          if (accessFlags === void 0) {
            accessFlags = 0;
          }
          if (objectType === wildcardType || indexType === wildcardType) {
            return wildcardType;
          }
          var shouldIncludeUndefined = noUncheckedIndexedAccessCandidate || !!compilerOptions.noUncheckedIndexedAccess && (accessFlags & (2 | 16)) === 16;
          if (isStringIndexSignatureOnlyType(objectType) && !(indexType.flags & 98304) && isTypeAssignableToKind(indexType, 4 | 8)) {
            indexType = stringType;
          }
          if (isGenericIndexType(indexType) || (accessNode && accessNode.kind !== 190 ? isGenericTupleType(objectType) && !indexTypeLessThan(indexType, objectType.target.fixedLength) : isGenericObjectType(objectType) && !(isTupleType(objectType) && indexTypeLessThan(indexType, objectType.target.fixedLength)))) {
            if (objectType.flags & 3) {
              return objectType;
            }
            var id = objectType.id + "," + indexType.id + (shouldIncludeUndefined ? "?" : "") + getAliasId(aliasSymbol, aliasTypeArguments);
            var type3 = indexedAccessTypes.get(id);
            if (!type3) {
              indexedAccessTypes.set(id, type3 = createIndexedAccessType(objectType, indexType, aliasSymbol, aliasTypeArguments, shouldIncludeUndefined));
            }
            return type3;
          }
          var apparentObjectType = getReducedApparentType(objectType);
          if (indexType.flags & 1048576 && !(indexType.flags & 16)) {
            var propTypes = [];
            var wasMissingProp = false;
            for (var _i = 0, _a2 = indexType.types; _i < _a2.length; _i++) {
              var t2 = _a2[_i];
              var propType = getPropertyTypeForIndexType(objectType, apparentObjectType, t2, indexType, wasMissingProp, accessNode, accessFlags, shouldIncludeUndefined);
              if (propType) {
                propTypes.push(propType);
              } else if (!accessNode) {
                return void 0;
              } else {
                wasMissingProp = true;
              }
            }
            if (wasMissingProp) {
              return void 0;
            }
            return accessFlags & 2 ? getIntersectionType(propTypes, aliasSymbol, aliasTypeArguments) : getUnionType(propTypes, 1, aliasSymbol, aliasTypeArguments);
          }
          return getPropertyTypeForIndexType(objectType, apparentObjectType, indexType, indexType, false, accessNode, accessFlags | 4, shouldIncludeUndefined, true);
        }
        function getTypeFromIndexedAccessTypeNode(node) {
          var links = getNodeLinks(node);
          if (!links.resolvedType) {
            var objectType = getTypeFromTypeNode(node.objectType);
            var indexType = getTypeFromTypeNode(node.indexType);
            var potentialAlias = getAliasSymbolForTypeNode(node);
            var resolved = getIndexedAccessType(objectType, indexType, void 0, node, potentialAlias, getTypeArgumentsForAliasSymbol(potentialAlias));
            links.resolvedType = resolved.flags & 8388608 && resolved.objectType === objectType && resolved.indexType === indexType ? getConditionalFlowTypeOfType(resolved, node) : resolved;
          }
          return links.resolvedType;
        }
        function getTypeFromMappedTypeNode(node) {
          var links = getNodeLinks(node);
          if (!links.resolvedType) {
            var type3 = createObjectType(32, node.symbol);
            type3.declaration = node;
            type3.aliasSymbol = getAliasSymbolForTypeNode(node);
            type3.aliasTypeArguments = getTypeArgumentsForAliasSymbol(type3.aliasSymbol);
            links.resolvedType = type3;
            getConstraintTypeFromMappedType(type3);
          }
          return links.resolvedType;
        }
        function getActualTypeVariable(type3) {
          if (type3.flags & 33554432) {
            return type3.baseType;
          }
          if (type3.flags & 8388608 && (type3.objectType.flags & 33554432 || type3.indexType.flags & 33554432)) {
            return getIndexedAccessType(getActualTypeVariable(type3.objectType), getActualTypeVariable(type3.indexType));
          }
          return type3;
        }
        function isTypicalNondistributiveConditional(root) {
          return !root.isDistributive && root.node.checkType.kind === 180 && ts3.length(root.node.checkType.elements) === 1 && root.node.extendsType.kind === 180 && ts3.length(root.node.extendsType.elements) === 1;
        }
        function unwrapNondistributiveConditionalTuple(root, type3) {
          return isTypicalNondistributiveConditional(root) && isTupleType(type3) ? getTypeArguments(type3)[0] : type3;
        }
        function getConditionalType(root, mapper, aliasSymbol, aliasTypeArguments) {
          var result2;
          var extraTypes;
          while (true) {
            var isUnwrapped = isTypicalNondistributiveConditional(root);
            var checkType = instantiateType(unwrapNondistributiveConditionalTuple(root, getActualTypeVariable(root.checkType)), mapper);
            var checkTypeInstantiable = isGenericObjectType(checkType) || isGenericIndexType(checkType);
            var extendsType = instantiateType(unwrapNondistributiveConditionalTuple(root, root.extendsType), mapper);
            if (checkType === wildcardType || extendsType === wildcardType) {
              return wildcardType;
            }
            var combinedMapper = void 0;
            if (root.inferTypeParameters) {
              var context = createInferenceContext(root.inferTypeParameters, void 0, 0);
              if (!checkTypeInstantiable) {
                inferTypes(context.inferences, checkType, extendsType, 512 | 1024);
              }
              combinedMapper = mapper ? combineTypeMappers(context.mapper, mapper) : context.mapper;
            }
            var inferredExtendsType = combinedMapper ? instantiateType(unwrapNondistributiveConditionalTuple(root, root.extendsType), combinedMapper) : extendsType;
            if (!checkTypeInstantiable && !isGenericObjectType(inferredExtendsType) && !isGenericIndexType(inferredExtendsType)) {
              if (!(inferredExtendsType.flags & 3) && (checkType.flags & 1 && !isUnwrapped || !isTypeAssignableTo(getPermissiveInstantiation(checkType), getPermissiveInstantiation(inferredExtendsType)))) {
                if (checkType.flags & 1 && !isUnwrapped) {
                  (extraTypes || (extraTypes = [])).push(instantiateType(getTypeFromTypeNode(root.node.trueType), combinedMapper || mapper));
                }
                var falseType_1 = getTypeFromTypeNode(root.node.falseType);
                if (falseType_1.flags & 16777216) {
                  var newRoot = falseType_1.root;
                  if (newRoot.node.parent === root.node && (!newRoot.isDistributive || newRoot.checkType === root.checkType)) {
                    root = newRoot;
                    continue;
                  }
                }
                result2 = instantiateType(falseType_1, mapper);
                break;
              }
              if (inferredExtendsType.flags & 3 || isTypeAssignableTo(getRestrictiveInstantiation(checkType), getRestrictiveInstantiation(inferredExtendsType))) {
                result2 = instantiateType(getTypeFromTypeNode(root.node.trueType), combinedMapper || mapper);
                break;
              }
            }
            result2 = createType(16777216);
            result2.root = root;
            result2.checkType = instantiateType(root.checkType, mapper);
            result2.extendsType = instantiateType(root.extendsType, mapper);
            result2.mapper = mapper;
            result2.combinedMapper = combinedMapper;
            result2.aliasSymbol = aliasSymbol || root.aliasSymbol;
            result2.aliasTypeArguments = aliasSymbol ? aliasTypeArguments : instantiateTypes(root.aliasTypeArguments, mapper);
            break;
          }
          return extraTypes ? getUnionType(ts3.append(extraTypes, result2)) : result2;
        }
        function getTrueTypeFromConditionalType(type3) {
          return type3.resolvedTrueType || (type3.resolvedTrueType = instantiateType(getTypeFromTypeNode(type3.root.node.trueType), type3.mapper));
        }
        function getFalseTypeFromConditionalType(type3) {
          return type3.resolvedFalseType || (type3.resolvedFalseType = instantiateType(getTypeFromTypeNode(type3.root.node.falseType), type3.mapper));
        }
        function getInferredTrueTypeFromConditionalType(type3) {
          return type3.resolvedInferredTrueType || (type3.resolvedInferredTrueType = type3.combinedMapper ? instantiateType(getTypeFromTypeNode(type3.root.node.trueType), type3.combinedMapper) : getTrueTypeFromConditionalType(type3));
        }
        function getInferTypeParameters(node) {
          var result2;
          if (node.locals) {
            node.locals.forEach(function(symbol) {
              if (symbol.flags & 262144) {
                result2 = ts3.append(result2, getDeclaredTypeOfSymbol(symbol));
              }
            });
          }
          return result2;
        }
        function getTypeFromConditionalTypeNode(node) {
          var links = getNodeLinks(node);
          if (!links.resolvedType) {
            var checkType = getTypeFromTypeNode(node.checkType);
            var aliasSymbol = getAliasSymbolForTypeNode(node);
            var aliasTypeArguments = getTypeArgumentsForAliasSymbol(aliasSymbol);
            var allOuterTypeParameters = getOuterTypeParameters(node, true);
            var outerTypeParameters = aliasTypeArguments ? allOuterTypeParameters : ts3.filter(allOuterTypeParameters, function(tp) {
              return isTypeParameterPossiblyReferenced(tp, node);
            });
            var root = {
              node,
              checkType,
              extendsType: getTypeFromTypeNode(node.extendsType),
              isDistributive: !!(checkType.flags & 262144),
              inferTypeParameters: getInferTypeParameters(node),
              outerTypeParameters,
              instantiations: void 0,
              aliasSymbol,
              aliasTypeArguments
            };
            links.resolvedType = getConditionalType(root, void 0);
            if (outerTypeParameters) {
              root.instantiations = new ts3.Map();
              root.instantiations.set(getTypeListId(outerTypeParameters), links.resolvedType);
            }
          }
          return links.resolvedType;
        }
        function getTypeFromInferTypeNode(node) {
          var links = getNodeLinks(node);
          if (!links.resolvedType) {
            links.resolvedType = getDeclaredTypeOfTypeParameter(getSymbolOfNode(node.typeParameter));
          }
          return links.resolvedType;
        }
        function getIdentifierChain(node) {
          if (ts3.isIdentifier(node)) {
            return [node];
          } else {
            return ts3.append(getIdentifierChain(node.left), node.right);
          }
        }
        function getTypeFromImportTypeNode(node) {
          var links = getNodeLinks(node);
          if (!links.resolvedType) {
            if (node.isTypeOf && node.typeArguments) {
              error(node, ts3.Diagnostics.Type_arguments_cannot_be_used_here);
              links.resolvedSymbol = unknownSymbol;
              return links.resolvedType = errorType;
            }
            if (!ts3.isLiteralImportTypeNode(node)) {
              error(node.argument, ts3.Diagnostics.String_literal_expected);
              links.resolvedSymbol = unknownSymbol;
              return links.resolvedType = errorType;
            }
            var targetMeaning = node.isTypeOf ? 111551 : node.flags & 4194304 ? 111551 | 788968 : 788968;
            var innerModuleSymbol = resolveExternalModuleName(node, node.argument.literal);
            if (!innerModuleSymbol) {
              links.resolvedSymbol = unknownSymbol;
              return links.resolvedType = errorType;
            }
            var moduleSymbol = resolveExternalModuleSymbol(innerModuleSymbol, false);
            if (!ts3.nodeIsMissing(node.qualifier)) {
              var nameStack = getIdentifierChain(node.qualifier);
              var currentNamespace = moduleSymbol;
              var current = void 0;
              while (current = nameStack.shift()) {
                var meaning = nameStack.length ? 1920 : targetMeaning;
                var mergedResolvedSymbol = getMergedSymbol(resolveSymbol(currentNamespace));
                var next = node.isTypeOf ? getPropertyOfType(getTypeOfSymbol(mergedResolvedSymbol), current.escapedText) : getSymbol(getExportsOfSymbol(mergedResolvedSymbol), current.escapedText, meaning);
                if (!next) {
                  error(current, ts3.Diagnostics.Namespace_0_has_no_exported_member_1, getFullyQualifiedName(currentNamespace), ts3.declarationNameToString(current));
                  return links.resolvedType = errorType;
                }
                getNodeLinks(current).resolvedSymbol = next;
                getNodeLinks(current.parent).resolvedSymbol = next;
                currentNamespace = next;
              }
              links.resolvedType = resolveImportSymbolType(node, links, currentNamespace, targetMeaning);
            } else {
              if (moduleSymbol.flags & targetMeaning) {
                links.resolvedType = resolveImportSymbolType(node, links, moduleSymbol, targetMeaning);
              } else {
                var errorMessage = targetMeaning === 111551 ? ts3.Diagnostics.Module_0_does_not_refer_to_a_value_but_is_used_as_a_value_here : ts3.Diagnostics.Module_0_does_not_refer_to_a_type_but_is_used_as_a_type_here_Did_you_mean_typeof_import_0;
                error(node, errorMessage, node.argument.literal.text);
                links.resolvedSymbol = unknownSymbol;
                links.resolvedType = errorType;
              }
            }
          }
          return links.resolvedType;
        }
        function resolveImportSymbolType(node, links, symbol, meaning) {
          var resolvedSymbol = resolveSymbol(symbol);
          links.resolvedSymbol = resolvedSymbol;
          if (meaning === 111551) {
            return getTypeOfSymbol(symbol);
          } else {
            return getTypeReferenceType(node, resolvedSymbol);
          }
        }
        function getTypeFromTypeLiteralOrFunctionOrConstructorTypeNode(node) {
          var links = getNodeLinks(node);
          if (!links.resolvedType) {
            var aliasSymbol = getAliasSymbolForTypeNode(node);
            if (getMembersOfSymbol(node.symbol).size === 0 && !aliasSymbol) {
              links.resolvedType = emptyTypeLiteralType;
            } else {
              var type3 = createObjectType(16, node.symbol);
              type3.aliasSymbol = aliasSymbol;
              type3.aliasTypeArguments = getTypeArgumentsForAliasSymbol(aliasSymbol);
              if (ts3.isJSDocTypeLiteral(node) && node.isArrayType) {
                type3 = createArrayType(type3);
              }
              links.resolvedType = type3;
            }
          }
          return links.resolvedType;
        }
        function getAliasSymbolForTypeNode(node) {
          var host2 = node.parent;
          while (ts3.isParenthesizedTypeNode(host2) || ts3.isJSDocTypeExpression(host2) || ts3.isTypeOperatorNode(host2) && host2.operator === 142) {
            host2 = host2.parent;
          }
          return ts3.isTypeAlias(host2) ? getSymbolOfNode(host2) : void 0;
        }
        function getTypeArgumentsForAliasSymbol(symbol) {
          return symbol ? getLocalTypeParametersOfClassOrInterfaceOrTypeAlias(symbol) : void 0;
        }
        function isNonGenericObjectType(type3) {
          return !!(type3.flags & 524288) && !isGenericMappedType(type3);
        }
        function isEmptyObjectTypeOrSpreadsIntoEmptyObject(type3) {
          return isEmptyObjectType(type3) || !!(type3.flags & (65536 | 32768 | 528 | 296 | 2112 | 402653316 | 1056 | 67108864 | 4194304));
        }
        function tryMergeUnionOfObjectTypeAndEmptyObject(type3, readonly) {
          if (ts3.every(type3.types, isEmptyObjectTypeOrSpreadsIntoEmptyObject)) {
            return ts3.find(type3.types, isEmptyObjectType) || emptyObjectType;
          }
          var firstType = ts3.find(type3.types, function(t2) {
            return !isEmptyObjectTypeOrSpreadsIntoEmptyObject(t2);
          });
          if (!firstType) {
            return void 0;
          }
          var secondType = firstType && ts3.find(type3.types, function(t2) {
            return t2 !== firstType && !isEmptyObjectTypeOrSpreadsIntoEmptyObject(t2);
          });
          if (secondType) {
            return void 0;
          }
          return getAnonymousPartialType(firstType);
          function getAnonymousPartialType(type4) {
            var members = ts3.createSymbolTable();
            for (var _i = 0, _a2 = getPropertiesOfType(type4); _i < _a2.length; _i++) {
              var prop = _a2[_i];
              if (ts3.getDeclarationModifierFlagsFromSymbol(prop) & (8 | 16)) {
              } else if (isSpreadableProperty(prop)) {
                var isSetonlyAccessor = prop.flags & 65536 && !(prop.flags & 32768);
                var flags = 4 | 16777216;
                var result2 = createSymbol(flags, prop.escapedName, getIsLateCheckFlag(prop) | (readonly ? 8 : 0));
                result2.type = isSetonlyAccessor ? undefinedType : getUnionType([getTypeOfSymbol(prop), undefinedType]);
                result2.declarations = prop.declarations;
                result2.nameType = getSymbolLinks(prop).nameType;
                result2.syntheticOrigin = prop;
                members.set(prop.escapedName, result2);
              }
            }
            var spread = createAnonymousType(type4.symbol, members, ts3.emptyArray, ts3.emptyArray, getIndexInfoOfType(type4, 0), getIndexInfoOfType(type4, 1));
            spread.objectFlags |= 128 | 262144;
            return spread;
          }
        }
        function getSpreadType(left, right, symbol, objectFlags, readonly) {
          if (left.flags & 1 || right.flags & 1) {
            return anyType;
          }
          if (left.flags & 2 || right.flags & 2) {
            return unknownType;
          }
          if (left.flags & 131072) {
            return right;
          }
          if (right.flags & 131072) {
            return left;
          }
          if (left.flags & 1048576) {
            var merged = tryMergeUnionOfObjectTypeAndEmptyObject(left, readonly);
            if (merged) {
              return getSpreadType(merged, right, symbol, objectFlags, readonly);
            }
            return checkCrossProductUnion([left, right]) ? mapType(left, function(t2) {
              return getSpreadType(t2, right, symbol, objectFlags, readonly);
            }) : errorType;
          }
          if (right.flags & 1048576) {
            var merged = tryMergeUnionOfObjectTypeAndEmptyObject(right, readonly);
            if (merged) {
              return getSpreadType(left, merged, symbol, objectFlags, readonly);
            }
            return checkCrossProductUnion([left, right]) ? mapType(right, function(t2) {
              return getSpreadType(left, t2, symbol, objectFlags, readonly);
            }) : errorType;
          }
          if (right.flags & (528 | 296 | 2112 | 402653316 | 1056 | 67108864 | 4194304)) {
            return left;
          }
          if (isGenericObjectType(left) || isGenericObjectType(right)) {
            if (isEmptyObjectType(left)) {
              return right;
            }
            if (left.flags & 2097152) {
              var types2 = left.types;
              var lastLeft = types2[types2.length - 1];
              if (isNonGenericObjectType(lastLeft) && isNonGenericObjectType(right)) {
                return getIntersectionType(ts3.concatenate(types2.slice(0, types2.length - 1), [getSpreadType(lastLeft, right, symbol, objectFlags, readonly)]));
              }
            }
            return getIntersectionType([left, right]);
          }
          var members = ts3.createSymbolTable();
          var skippedPrivateMembers = new ts3.Set();
          var stringIndexInfo;
          var numberIndexInfo;
          if (left === emptyObjectType) {
            stringIndexInfo = getIndexInfoOfType(right, 0);
            numberIndexInfo = getIndexInfoOfType(right, 1);
          } else {
            stringIndexInfo = unionSpreadIndexInfos(getIndexInfoOfType(left, 0), getIndexInfoOfType(right, 0));
            numberIndexInfo = unionSpreadIndexInfos(getIndexInfoOfType(left, 1), getIndexInfoOfType(right, 1));
          }
          for (var _i = 0, _a2 = getPropertiesOfType(right); _i < _a2.length; _i++) {
            var rightProp = _a2[_i];
            if (ts3.getDeclarationModifierFlagsFromSymbol(rightProp) & (8 | 16)) {
              skippedPrivateMembers.add(rightProp.escapedName);
            } else if (isSpreadableProperty(rightProp)) {
              members.set(rightProp.escapedName, getSpreadSymbol(rightProp, readonly));
            }
          }
          for (var _b = 0, _c = getPropertiesOfType(left); _b < _c.length; _b++) {
            var leftProp = _c[_b];
            if (skippedPrivateMembers.has(leftProp.escapedName) || !isSpreadableProperty(leftProp)) {
              continue;
            }
            if (members.has(leftProp.escapedName)) {
              var rightProp = members.get(leftProp.escapedName);
              var rightType = getTypeOfSymbol(rightProp);
              if (rightProp.flags & 16777216) {
                var declarations = ts3.concatenate(leftProp.declarations, rightProp.declarations);
                var flags = 4 | leftProp.flags & 16777216;
                var result2 = createSymbol(flags, leftProp.escapedName);
                result2.type = getUnionType([getTypeOfSymbol(leftProp), getTypeWithFacts(rightType, 524288)]);
                result2.leftSpread = leftProp;
                result2.rightSpread = rightProp;
                result2.declarations = declarations;
                result2.nameType = getSymbolLinks(leftProp).nameType;
                members.set(leftProp.escapedName, result2);
              }
            } else {
              members.set(leftProp.escapedName, getSpreadSymbol(leftProp, readonly));
            }
          }
          var spread = createAnonymousType(symbol, members, ts3.emptyArray, ts3.emptyArray, getIndexInfoWithReadonly(stringIndexInfo, readonly), getIndexInfoWithReadonly(numberIndexInfo, readonly));
          spread.objectFlags |= 128 | 262144 | 4194304 | objectFlags;
          return spread;
        }
        function isSpreadableProperty(prop) {
          var _a2;
          return !ts3.some(prop.declarations, ts3.isPrivateIdentifierClassElementDeclaration) && (!(prop.flags & (8192 | 32768 | 65536)) || !((_a2 = prop.declarations) === null || _a2 === void 0 ? void 0 : _a2.some(function(decl) {
            return ts3.isClassLike(decl.parent);
          })));
        }
        function getSpreadSymbol(prop, readonly) {
          var isSetonlyAccessor = prop.flags & 65536 && !(prop.flags & 32768);
          if (!isSetonlyAccessor && readonly === isReadonlySymbol(prop)) {
            return prop;
          }
          var flags = 4 | prop.flags & 16777216;
          var result2 = createSymbol(flags, prop.escapedName, getIsLateCheckFlag(prop) | (readonly ? 8 : 0));
          result2.type = isSetonlyAccessor ? undefinedType : getTypeOfSymbol(prop);
          result2.declarations = prop.declarations;
          result2.nameType = getSymbolLinks(prop).nameType;
          result2.syntheticOrigin = prop;
          return result2;
        }
        function getIndexInfoWithReadonly(info, readonly) {
          return info && info.isReadonly !== readonly ? createIndexInfo(info.type, readonly, info.declaration) : info;
        }
        function createLiteralType(flags, value, symbol) {
          var type3 = createType(flags);
          type3.symbol = symbol;
          type3.value = value;
          return type3;
        }
        function getFreshTypeOfLiteralType(type3) {
          if (type3.flags & 2944) {
            if (!type3.freshType) {
              var freshType = createLiteralType(type3.flags, type3.value, type3.symbol);
              freshType.regularType = type3;
              freshType.freshType = freshType;
              type3.freshType = freshType;
            }
            return type3.freshType;
          }
          return type3;
        }
        function getRegularTypeOfLiteralType(type3) {
          return type3.flags & 2944 ? type3.regularType : type3.flags & 1048576 ? type3.regularType || (type3.regularType = mapType(type3, getRegularTypeOfLiteralType)) : type3;
        }
        function isFreshLiteralType(type3) {
          return !!(type3.flags & 2944) && type3.freshType === type3;
        }
        function getLiteralType(value, enumId, symbol) {
          var qualifier = typeof value === "number" ? "#" : typeof value === "string" ? "@" : "n";
          var key2 = (enumId ? enumId : "") + qualifier + (typeof value === "object" ? ts3.pseudoBigIntToString(value) : value);
          var type3 = literalTypes.get(key2);
          if (!type3) {
            var flags = (typeof value === "number" ? 256 : typeof value === "string" ? 128 : 2048) | (enumId ? 1024 : 0);
            literalTypes.set(key2, type3 = createLiteralType(flags, value, symbol));
            type3.regularType = type3;
          }
          return type3;
        }
        function getTypeFromLiteralTypeNode(node) {
          if (node.literal.kind === 103) {
            return nullType;
          }
          var links = getNodeLinks(node);
          if (!links.resolvedType) {
            links.resolvedType = getRegularTypeOfLiteralType(checkExpression(node.literal));
          }
          return links.resolvedType;
        }
        function createUniqueESSymbolType(symbol) {
          var type3 = createType(8192);
          type3.symbol = symbol;
          type3.escapedName = "__@" + type3.symbol.escapedName + "@" + getSymbolId(type3.symbol);
          return type3;
        }
        function getESSymbolLikeTypeForNode(node) {
          if (ts3.isValidESSymbolDeclaration(node)) {
            var symbol = getSymbolOfNode(node);
            var links = getSymbolLinks(symbol);
            return links.uniqueESSymbolType || (links.uniqueESSymbolType = createUniqueESSymbolType(symbol));
          }
          return esSymbolType;
        }
        function getThisType(node) {
          var container = ts3.getThisContainer(node, false);
          var parent = container && container.parent;
          if (parent && (ts3.isClassLike(parent) || parent.kind === 254)) {
            if (!ts3.hasSyntacticModifier(container, 32) && (!ts3.isConstructorDeclaration(container) || ts3.isNodeDescendantOf(node, container.body))) {
              return getDeclaredTypeOfClassOrInterface(getSymbolOfNode(parent)).thisType;
            }
          }
          if (parent && ts3.isObjectLiteralExpression(parent) && ts3.isBinaryExpression(parent.parent) && ts3.getAssignmentDeclarationKind(parent.parent) === 6) {
            return getDeclaredTypeOfClassOrInterface(getSymbolOfNode(parent.parent.left).parent).thisType;
          }
          var host2 = node.flags & 4194304 ? ts3.getHostSignatureFromJSDoc(node) : void 0;
          if (host2 && ts3.isFunctionExpression(host2) && ts3.isBinaryExpression(host2.parent) && ts3.getAssignmentDeclarationKind(host2.parent) === 3) {
            return getDeclaredTypeOfClassOrInterface(getSymbolOfNode(host2.parent.left).parent).thisType;
          }
          if (isJSConstructor(container) && ts3.isNodeDescendantOf(node, container.body)) {
            return getDeclaredTypeOfClassOrInterface(getSymbolOfNode(container)).thisType;
          }
          error(node, ts3.Diagnostics.A_this_type_is_available_only_in_a_non_static_member_of_a_class_or_interface);
          return errorType;
        }
        function getTypeFromThisTypeNode(node) {
          var links = getNodeLinks(node);
          if (!links.resolvedType) {
            links.resolvedType = getThisType(node);
          }
          return links.resolvedType;
        }
        function getTypeFromRestTypeNode(node) {
          return getTypeFromTypeNode(getArrayElementTypeNode(node.type) || node.type);
        }
        function getArrayElementTypeNode(node) {
          switch (node.kind) {
            case 187:
              return getArrayElementTypeNode(node.type);
            case 180:
              if (node.elements.length === 1) {
                node = node.elements[0];
                if (node.kind === 182 || node.kind === 193 && node.dotDotDotToken) {
                  return getArrayElementTypeNode(node.type);
                }
              }
              break;
            case 179:
              return node.elementType;
          }
          return void 0;
        }
        function getTypeFromNamedTupleTypeNode(node) {
          var links = getNodeLinks(node);
          return links.resolvedType || (links.resolvedType = node.dotDotDotToken ? getTypeFromRestTypeNode(node) : node.questionToken && strictNullChecks ? getOptionalType(getTypeFromTypeNode(node.type)) : getTypeFromTypeNode(node.type));
        }
        function getTypeFromTypeNode(node) {
          return getConditionalFlowTypeOfType(getTypeFromTypeNodeWorker(node), node);
        }
        function getTypeFromTypeNodeWorker(node) {
          switch (node.kind) {
            case 128:
            case 304:
            case 305:
              return anyType;
            case 152:
              return unknownType;
            case 147:
              return stringType;
            case 144:
              return numberType;
            case 155:
              return bigintType;
            case 131:
              return booleanType;
            case 148:
              return esSymbolType;
            case 113:
              return voidType;
            case 150:
              return undefinedType;
            case 103:
              return nullType;
            case 141:
              return neverType;
            case 145:
              return node.flags & 131072 && !noImplicitAny ? anyType : nonPrimitiveType;
            case 136:
              return intrinsicMarkerType;
            case 188:
            case 107:
              return getTypeFromThisTypeNode(node);
            case 192:
              return getTypeFromLiteralTypeNode(node);
            case 174:
              return getTypeFromTypeReference(node);
            case 173:
              return node.assertsModifier ? voidType : booleanType;
            case 224:
              return getTypeFromTypeReference(node);
            case 177:
              return getTypeFromTypeQueryNode(node);
            case 179:
            case 180:
              return getTypeFromArrayOrTupleTypeNode(node);
            case 181:
              return getTypeFromOptionalTypeNode(node);
            case 183:
              return getTypeFromUnionTypeNode(node);
            case 184:
              return getTypeFromIntersectionTypeNode(node);
            case 306:
              return getTypeFromJSDocNullableTypeNode(node);
            case 308:
              return addOptionality(getTypeFromTypeNode(node.type));
            case 193:
              return getTypeFromNamedTupleTypeNode(node);
            case 187:
            case 307:
            case 302:
              return getTypeFromTypeNode(node.type);
            case 182:
              return getTypeFromRestTypeNode(node);
            case 310:
              return getTypeFromJSDocVariadicType(node);
            case 175:
            case 176:
            case 178:
            case 314:
            case 309:
            case 315:
              return getTypeFromTypeLiteralOrFunctionOrConstructorTypeNode(node);
            case 189:
              return getTypeFromTypeOperatorNode(node);
            case 190:
              return getTypeFromIndexedAccessTypeNode(node);
            case 191:
              return getTypeFromMappedTypeNode(node);
            case 185:
              return getTypeFromConditionalTypeNode(node);
            case 186:
              return getTypeFromInferTypeNode(node);
            case 194:
              return getTypeFromTemplateTypeNode(node);
            case 196:
              return getTypeFromImportTypeNode(node);
            case 78:
            case 158:
            case 202:
              var symbol = getSymbolAtLocation(node);
              return symbol ? getDeclaredTypeOfSymbol(symbol) : errorType;
            default:
              return errorType;
          }
        }
        function instantiateList(items, mapper, instantiator) {
          if (items && items.length) {
            for (var i3 = 0; i3 < items.length; i3++) {
              var item = items[i3];
              var mapped = instantiator(item, mapper);
              if (item !== mapped) {
                var result2 = i3 === 0 ? [] : items.slice(0, i3);
                result2.push(mapped);
                for (i3++; i3 < items.length; i3++) {
                  result2.push(instantiator(items[i3], mapper));
                }
                return result2;
              }
            }
          }
          return items;
        }
        function instantiateTypes(types2, mapper) {
          return instantiateList(types2, mapper, instantiateType);
        }
        function instantiateSignatures(signatures, mapper) {
          return instantiateList(signatures, mapper, instantiateSignature);
        }
        function createTypeMapper(sources, targets) {
          return sources.length === 1 ? makeUnaryTypeMapper(sources[0], targets ? targets[0] : anyType) : makeArrayTypeMapper(sources, targets);
        }
        function getMappedType(type3, mapper) {
          switch (mapper.kind) {
            case 0:
              return type3 === mapper.source ? mapper.target : type3;
            case 1:
              var sources = mapper.sources;
              var targets = mapper.targets;
              for (var i3 = 0; i3 < sources.length; i3++) {
                if (type3 === sources[i3]) {
                  return targets ? targets[i3] : anyType;
                }
              }
              return type3;
            case 2:
              return mapper.func(type3);
            case 3:
            case 4:
              var t1 = getMappedType(type3, mapper.mapper1);
              return t1 !== type3 && mapper.kind === 3 ? instantiateType(t1, mapper.mapper2) : getMappedType(t1, mapper.mapper2);
          }
        }
        function makeUnaryTypeMapper(source, target) {
          return { kind: 0, source, target };
        }
        function makeArrayTypeMapper(sources, targets) {
          return { kind: 1, sources, targets };
        }
        function makeFunctionTypeMapper(func2) {
          return { kind: 2, func: func2 };
        }
        function makeCompositeTypeMapper(kind, mapper1, mapper2) {
          return { kind, mapper1, mapper2 };
        }
        function createTypeEraser(sources) {
          return createTypeMapper(sources, void 0);
        }
        function createBackreferenceMapper(context, index) {
          return makeFunctionTypeMapper(function(t2) {
            return ts3.findIndex(context.inferences, function(info) {
              return info.typeParameter === t2;
            }) >= index ? unknownType : t2;
          });
        }
        function combineTypeMappers(mapper1, mapper2) {
          return mapper1 ? makeCompositeTypeMapper(3, mapper1, mapper2) : mapper2;
        }
        function mergeTypeMappers(mapper1, mapper2) {
          return mapper1 ? makeCompositeTypeMapper(4, mapper1, mapper2) : mapper2;
        }
        function prependTypeMapping(source, target, mapper) {
          return !mapper ? makeUnaryTypeMapper(source, target) : makeCompositeTypeMapper(4, makeUnaryTypeMapper(source, target), mapper);
        }
        function appendTypeMapping(mapper, source, target) {
          return !mapper ? makeUnaryTypeMapper(source, target) : makeCompositeTypeMapper(4, mapper, makeUnaryTypeMapper(source, target));
        }
        function getRestrictiveTypeParameter(tp) {
          return tp.constraint === unknownType ? tp : tp.restrictiveInstantiation || (tp.restrictiveInstantiation = createTypeParameter(tp.symbol), tp.restrictiveInstantiation.constraint = unknownType, tp.restrictiveInstantiation);
        }
        function cloneTypeParameter(typeParameter) {
          var result2 = createTypeParameter(typeParameter.symbol);
          result2.target = typeParameter;
          return result2;
        }
        function instantiateTypePredicate(predicate, mapper) {
          return createTypePredicate(predicate.kind, predicate.parameterName, predicate.parameterIndex, instantiateType(predicate.type, mapper));
        }
        function instantiateSignature(signature, mapper, eraseTypeParameters) {
          var freshTypeParameters;
          if (signature.typeParameters && !eraseTypeParameters) {
            freshTypeParameters = ts3.map(signature.typeParameters, cloneTypeParameter);
            mapper = combineTypeMappers(createTypeMapper(signature.typeParameters, freshTypeParameters), mapper);
            for (var _i = 0, freshTypeParameters_1 = freshTypeParameters; _i < freshTypeParameters_1.length; _i++) {
              var tp = freshTypeParameters_1[_i];
              tp.mapper = mapper;
            }
          }
          var result2 = createSignature(signature.declaration, freshTypeParameters, signature.thisParameter && instantiateSymbol(signature.thisParameter, mapper), instantiateList(signature.parameters, mapper, instantiateSymbol), void 0, void 0, signature.minArgumentCount, signature.flags & 39);
          result2.target = signature;
          result2.mapper = mapper;
          return result2;
        }
        function instantiateSymbol(symbol, mapper) {
          var links = getSymbolLinks(symbol);
          if (links.type && !couldContainTypeVariables(links.type)) {
            return symbol;
          }
          if (ts3.getCheckFlags(symbol) & 1) {
            symbol = links.target;
            mapper = combineTypeMappers(links.mapper, mapper);
          }
          var result2 = createSymbol(symbol.flags, symbol.escapedName, 1 | ts3.getCheckFlags(symbol) & (8 | 4096 | 16384 | 32768));
          result2.declarations = symbol.declarations;
          result2.parent = symbol.parent;
          result2.target = symbol;
          result2.mapper = mapper;
          if (symbol.valueDeclaration) {
            result2.valueDeclaration = symbol.valueDeclaration;
          }
          if (links.nameType) {
            result2.nameType = links.nameType;
          }
          return result2;
        }
        function getObjectTypeInstantiation(type3, mapper, aliasSymbol, aliasTypeArguments) {
          var declaration = type3.objectFlags & 4 ? type3.node : type3.symbol.declarations[0];
          var links = getNodeLinks(declaration);
          var target = type3.objectFlags & 4 ? links.resolvedType : type3.objectFlags & 64 ? type3.target : type3;
          var typeParameters = links.outerTypeParameters;
          if (!typeParameters) {
            var outerTypeParameters = getOuterTypeParameters(declaration, true);
            if (isJSConstructor(declaration)) {
              var templateTagParameters = getTypeParametersFromDeclaration(declaration);
              outerTypeParameters = ts3.addRange(outerTypeParameters, templateTagParameters);
            }
            typeParameters = outerTypeParameters || ts3.emptyArray;
            var allDeclarations_1 = type3.objectFlags & 4 ? [declaration] : type3.symbol.declarations;
            typeParameters = (target.objectFlags & 4 || target.symbol.flags & 8192 || target.symbol.flags & 2048) && !target.aliasTypeArguments ? ts3.filter(typeParameters, function(tp) {
              return ts3.some(allDeclarations_1, function(d) {
                return isTypeParameterPossiblyReferenced(tp, d);
              });
            }) : typeParameters;
            links.outerTypeParameters = typeParameters;
          }
          if (typeParameters.length) {
            var combinedMapper_1 = combineTypeMappers(type3.mapper, mapper);
            var typeArguments = ts3.map(typeParameters, function(t2) {
              return getMappedType(t2, combinedMapper_1);
            });
            var newAliasSymbol = aliasSymbol || type3.aliasSymbol;
            var newAliasTypeArguments = aliasSymbol ? aliasTypeArguments : instantiateTypes(type3.aliasTypeArguments, mapper);
            var id = getTypeListId(typeArguments) + getAliasId(newAliasSymbol, newAliasTypeArguments);
            if (!target.instantiations) {
              target.instantiations = new ts3.Map();
              target.instantiations.set(getTypeListId(typeParameters) + getAliasId(target.aliasSymbol, target.aliasTypeArguments), target);
            }
            var result2 = target.instantiations.get(id);
            if (!result2) {
              var newMapper = createTypeMapper(typeParameters, typeArguments);
              result2 = target.objectFlags & 4 ? createDeferredTypeReference(type3.target, type3.node, newMapper, newAliasSymbol, newAliasTypeArguments) : target.objectFlags & 32 ? instantiateMappedType(target, newMapper, newAliasSymbol, newAliasTypeArguments) : instantiateAnonymousType(target, newMapper, newAliasSymbol, newAliasTypeArguments);
              target.instantiations.set(id, result2);
            }
            return result2;
          }
          return type3;
        }
        function maybeTypeParameterReference(node) {
          return !(node.parent.kind === 174 && node.parent.typeArguments && node === node.parent.typeName || node.parent.kind === 196 && node.parent.typeArguments && node === node.parent.qualifier);
        }
        function isTypeParameterPossiblyReferenced(tp, node) {
          if (tp.symbol && tp.symbol.declarations && tp.symbol.declarations.length === 1) {
            var container = tp.symbol.declarations[0].parent;
            for (var n2 = node; n2 !== container; n2 = n2.parent) {
              if (!n2 || n2.kind === 231 || n2.kind === 185 && ts3.forEachChild(n2.extendsType, containsReference)) {
                return true;
              }
            }
            return containsReference(node);
          }
          return true;
          function containsReference(node2) {
            switch (node2.kind) {
              case 188:
                return !!tp.isThisType;
              case 78:
                return !tp.isThisType && ts3.isPartOfTypeNode(node2) && maybeTypeParameterReference(node2) && getTypeFromTypeNodeWorker(node2) === tp;
              case 177:
                return true;
              case 166:
              case 165:
                return !node2.type && !!node2.body || ts3.some(node2.typeParameters, containsReference) || ts3.some(node2.parameters, containsReference) || !!node2.type && containsReference(node2.type);
            }
            return !!ts3.forEachChild(node2, containsReference);
          }
        }
        function getHomomorphicTypeVariable(type3) {
          var constraintType = getConstraintTypeFromMappedType(type3);
          if (constraintType.flags & 4194304) {
            var typeVariable = getActualTypeVariable(constraintType.type);
            if (typeVariable.flags & 262144) {
              return typeVariable;
            }
          }
          return void 0;
        }
        function instantiateMappedType(type3, mapper, aliasSymbol, aliasTypeArguments) {
          var typeVariable = getHomomorphicTypeVariable(type3);
          if (typeVariable) {
            var mappedTypeVariable = instantiateType(typeVariable, mapper);
            if (typeVariable !== mappedTypeVariable) {
              return mapTypeWithAlias(getReducedType(mappedTypeVariable), function(t2) {
                if (t2.flags & (3 | 58982400 | 524288 | 2097152) && t2 !== wildcardType && t2 !== errorType) {
                  if (!type3.declaration.nameType) {
                    if (isArrayType(t2)) {
                      return instantiateMappedArrayType(t2, type3, prependTypeMapping(typeVariable, t2, mapper));
                    }
                    if (isGenericTupleType(t2)) {
                      return instantiateMappedGenericTupleType(t2, type3, typeVariable, mapper);
                    }
                    if (isTupleType(t2)) {
                      return instantiateMappedTupleType(t2, type3, prependTypeMapping(typeVariable, t2, mapper));
                    }
                  }
                  return instantiateAnonymousType(type3, prependTypeMapping(typeVariable, t2, mapper));
                }
                return t2;
              }, aliasSymbol, aliasTypeArguments);
            }
          }
          return instantiateType(getConstraintTypeFromMappedType(type3), mapper) === wildcardType ? wildcardType : instantiateAnonymousType(type3, mapper, aliasSymbol, aliasTypeArguments);
        }
        function getModifiedReadonlyState(state, modifiers) {
          return modifiers & 1 ? true : modifiers & 2 ? false : state;
        }
        function instantiateMappedGenericTupleType(tupleType, mappedType, typeVariable, mapper) {
          var elementFlags = tupleType.target.elementFlags;
          var elementTypes = ts3.map(getTypeArguments(tupleType), function(t2, i3) {
            var singleton = elementFlags[i3] & 8 ? t2 : elementFlags[i3] & 4 ? createArrayType(t2) : createTupleType([t2], [elementFlags[i3]]);
            return instantiateMappedType(mappedType, prependTypeMapping(typeVariable, singleton, mapper));
          });
          var newReadonly = getModifiedReadonlyState(tupleType.target.readonly, getMappedTypeModifiers(mappedType));
          return createTupleType(elementTypes, ts3.map(elementTypes, function(_) {
            return 8;
          }), newReadonly);
        }
        function instantiateMappedArrayType(arrayType, mappedType, mapper) {
          var elementType = instantiateMappedTypeTemplate(mappedType, numberType, true, mapper);
          return elementType === errorType ? errorType : createArrayType(elementType, getModifiedReadonlyState(isReadonlyArrayType(arrayType), getMappedTypeModifiers(mappedType)));
        }
        function instantiateMappedTupleType(tupleType, mappedType, mapper) {
          var elementFlags = tupleType.target.elementFlags;
          var elementTypes = ts3.map(getTypeArguments(tupleType), function(_, i3) {
            return instantiateMappedTypeTemplate(mappedType, getLiteralType("" + i3), !!(elementFlags[i3] & 2), mapper);
          });
          var modifiers = getMappedTypeModifiers(mappedType);
          var newTupleModifiers = modifiers & 4 ? ts3.map(elementFlags, function(f) {
            return f & 1 ? 2 : f;
          }) : modifiers & 8 ? ts3.map(elementFlags, function(f) {
            return f & 2 ? 1 : f;
          }) : elementFlags;
          var newReadonly = getModifiedReadonlyState(tupleType.target.readonly, modifiers);
          return ts3.contains(elementTypes, errorType) ? errorType : createTupleType(elementTypes, newTupleModifiers, newReadonly, tupleType.target.labeledElementDeclarations);
        }
        function instantiateMappedTypeTemplate(type3, key2, isOptional, mapper) {
          var templateMapper = appendTypeMapping(mapper, getTypeParameterFromMappedType(type3), key2);
          var propType = instantiateType(getTemplateTypeFromMappedType(type3.target || type3), templateMapper);
          var modifiers = getMappedTypeModifiers(type3);
          return strictNullChecks && modifiers & 4 && !maybeTypeOfKind(propType, 32768 | 16384) ? getOptionalType(propType) : strictNullChecks && modifiers & 8 && isOptional ? getTypeWithFacts(propType, 524288) : propType;
        }
        function instantiateAnonymousType(type3, mapper, aliasSymbol, aliasTypeArguments) {
          var result2 = createObjectType(type3.objectFlags | 64, type3.symbol);
          if (type3.objectFlags & 32) {
            result2.declaration = type3.declaration;
            var origTypeParameter = getTypeParameterFromMappedType(type3);
            var freshTypeParameter = cloneTypeParameter(origTypeParameter);
            result2.typeParameter = freshTypeParameter;
            mapper = combineTypeMappers(makeUnaryTypeMapper(origTypeParameter, freshTypeParameter), mapper);
            freshTypeParameter.mapper = mapper;
          }
          result2.target = type3;
          result2.mapper = mapper;
          result2.aliasSymbol = aliasSymbol || type3.aliasSymbol;
          result2.aliasTypeArguments = aliasSymbol ? aliasTypeArguments : instantiateTypes(type3.aliasTypeArguments, mapper);
          return result2;
        }
        function getConditionalTypeInstantiation(type3, mapper, aliasSymbol, aliasTypeArguments) {
          var root = type3.root;
          if (root.outerTypeParameters) {
            var typeArguments = ts3.map(root.outerTypeParameters, function(t2) {
              return getMappedType(t2, mapper);
            });
            var id = getTypeListId(typeArguments) + getAliasId(aliasSymbol, aliasTypeArguments);
            var result2 = root.instantiations.get(id);
            if (!result2) {
              var newMapper = createTypeMapper(root.outerTypeParameters, typeArguments);
              result2 = instantiateConditionalType(root, newMapper, aliasSymbol, aliasTypeArguments);
              root.instantiations.set(id, result2);
            }
            return result2;
          }
          return type3;
        }
        function instantiateConditionalType(root, mapper, aliasSymbol, aliasTypeArguments) {
          if (root.isDistributive) {
            var checkType_1 = root.checkType;
            var instantiatedType = getMappedType(checkType_1, mapper);
            if (checkType_1 !== instantiatedType && instantiatedType.flags & (1048576 | 131072)) {
              return mapTypeWithAlias(instantiatedType, function(t2) {
                return getConditionalType(root, prependTypeMapping(checkType_1, t2, mapper));
              }, aliasSymbol, aliasTypeArguments);
            }
          }
          return getConditionalType(root, mapper, aliasSymbol, aliasTypeArguments);
        }
        function instantiateType(type3, mapper) {
          return type3 && mapper ? instantiateTypeWithAlias(type3, mapper, void 0, void 0) : type3;
        }
        function instantiateTypeWithAlias(type3, mapper, aliasSymbol, aliasTypeArguments) {
          if (!couldContainTypeVariables(type3)) {
            return type3;
          }
          if (instantiationDepth === 50 || instantiationCount >= 5e6) {
            ts3.tracing === null || ts3.tracing === void 0 ? void 0 : ts3.tracing.instant("checkTypes", "instantiateType_DepthLimit", { typeId: type3.id, instantiationDepth, instantiationCount });
            error(currentNode, ts3.Diagnostics.Type_instantiation_is_excessively_deep_and_possibly_infinite);
            return errorType;
          }
          totalInstantiationCount++;
          instantiationCount++;
          instantiationDepth++;
          var result2 = instantiateTypeWorker(type3, mapper, aliasSymbol, aliasTypeArguments);
          instantiationDepth--;
          return result2;
        }
        function instantiateTypeWorker(type3, mapper, aliasSymbol, aliasTypeArguments) {
          var flags = type3.flags;
          if (flags & 262144) {
            return getMappedType(type3, mapper);
          }
          if (flags & 524288) {
            var objectFlags = type3.objectFlags;
            if (objectFlags & (4 | 16 | 32)) {
              if (objectFlags & 4 && !type3.node) {
                var resolvedTypeArguments = type3.resolvedTypeArguments;
                var newTypeArguments = instantiateTypes(resolvedTypeArguments, mapper);
                return newTypeArguments !== resolvedTypeArguments ? createNormalizedTypeReference(type3.target, newTypeArguments) : type3;
              }
              if (objectFlags & 1024) {
                return instantiateReverseMappedType(type3, mapper);
              }
              return getObjectTypeInstantiation(type3, mapper, aliasSymbol, aliasTypeArguments);
            }
            return type3;
          }
          if (flags & 3145728) {
            var origin = type3.flags & 1048576 ? type3.origin : void 0;
            var types2 = origin && origin.flags & 3145728 ? origin.types : type3.types;
            var newTypes = instantiateTypes(types2, mapper);
            if (newTypes === types2 && aliasSymbol === type3.aliasSymbol) {
              return type3;
            }
            var newAliasSymbol = aliasSymbol || type3.aliasSymbol;
            var newAliasTypeArguments = aliasSymbol ? aliasTypeArguments : instantiateTypes(type3.aliasTypeArguments, mapper);
            return flags & 2097152 || origin && origin.flags & 2097152 ? getIntersectionType(newTypes, newAliasSymbol, newAliasTypeArguments) : getUnionType(newTypes, 1, newAliasSymbol, newAliasTypeArguments);
          }
          if (flags & 4194304) {
            return getIndexType(instantiateType(type3.type, mapper));
          }
          if (flags & 134217728) {
            return getTemplateLiteralType(type3.texts, instantiateTypes(type3.types, mapper));
          }
          if (flags & 268435456) {
            return getStringMappingType(type3.symbol, instantiateType(type3.type, mapper));
          }
          if (flags & 8388608) {
            var newAliasSymbol = aliasSymbol || type3.aliasSymbol;
            var newAliasTypeArguments = aliasSymbol ? aliasTypeArguments : instantiateTypes(type3.aliasTypeArguments, mapper);
            return getIndexedAccessType(instantiateType(type3.objectType, mapper), instantiateType(type3.indexType, mapper), type3.noUncheckedIndexedAccessCandidate, void 0, newAliasSymbol, newAliasTypeArguments);
          }
          if (flags & 16777216) {
            return getConditionalTypeInstantiation(type3, combineTypeMappers(type3.mapper, mapper), aliasSymbol, aliasTypeArguments);
          }
          if (flags & 33554432) {
            var maybeVariable = instantiateType(type3.baseType, mapper);
            if (maybeVariable.flags & 8650752) {
              return getSubstitutionType(maybeVariable, instantiateType(type3.substitute, mapper));
            } else {
              var sub = instantiateType(type3.substitute, mapper);
              if (sub.flags & 3 || isTypeAssignableTo(getRestrictiveInstantiation(maybeVariable), getRestrictiveInstantiation(sub))) {
                return maybeVariable;
              }
              return sub;
            }
          }
          return type3;
        }
        function instantiateReverseMappedType(type3, mapper) {
          var innerMappedType = instantiateType(type3.mappedType, mapper);
          if (!(ts3.getObjectFlags(innerMappedType) & 32)) {
            return type3;
          }
          var innerIndexType = instantiateType(type3.constraintType, mapper);
          if (!(innerIndexType.flags & 4194304)) {
            return type3;
          }
          var instantiated = inferTypeForHomomorphicMappedType(instantiateType(type3.source, mapper), innerMappedType, innerIndexType);
          if (instantiated) {
            return instantiated;
          }
          return type3;
        }
        function getPermissiveInstantiation(type3) {
          return type3.flags & (131068 | 3 | 131072) ? type3 : type3.permissiveInstantiation || (type3.permissiveInstantiation = instantiateType(type3, permissiveMapper));
        }
        function getRestrictiveInstantiation(type3) {
          if (type3.flags & (131068 | 3 | 131072)) {
            return type3;
          }
          if (type3.restrictiveInstantiation) {
            return type3.restrictiveInstantiation;
          }
          type3.restrictiveInstantiation = instantiateType(type3, restrictiveMapper);
          type3.restrictiveInstantiation.restrictiveInstantiation = type3.restrictiveInstantiation;
          return type3.restrictiveInstantiation;
        }
        function instantiateIndexInfo(info, mapper) {
          return info && createIndexInfo(instantiateType(info.type, mapper), info.isReadonly, info.declaration);
        }
        function isContextSensitive(node) {
          ts3.Debug.assert(node.kind !== 166 || ts3.isObjectLiteralMethod(node));
          switch (node.kind) {
            case 209:
            case 210:
            case 166:
            case 252:
              return isContextSensitiveFunctionLikeDeclaration(node);
            case 201:
              return ts3.some(node.properties, isContextSensitive);
            case 200:
              return ts3.some(node.elements, isContextSensitive);
            case 218:
              return isContextSensitive(node.whenTrue) || isContextSensitive(node.whenFalse);
            case 217:
              return (node.operatorToken.kind === 56 || node.operatorToken.kind === 60) && (isContextSensitive(node.left) || isContextSensitive(node.right));
            case 289:
              return isContextSensitive(node.initializer);
            case 208:
              return isContextSensitive(node.expression);
            case 282:
              return ts3.some(node.properties, isContextSensitive) || ts3.isJsxOpeningElement(node.parent) && ts3.some(node.parent.parent.children, isContextSensitive);
            case 281: {
              var initializer = node.initializer;
              return !!initializer && isContextSensitive(initializer);
            }
            case 284: {
              var expression = node.expression;
              return !!expression && isContextSensitive(expression);
            }
          }
          return false;
        }
        function isContextSensitiveFunctionLikeDeclaration(node) {
          return (!ts3.isFunctionDeclaration(node) || ts3.isInJSFile(node) && !!getTypeForDeclarationFromJSDocComment(node)) && (hasContextSensitiveParameters(node) || hasContextSensitiveReturnExpression(node));
        }
        function hasContextSensitiveParameters(node) {
          if (!node.typeParameters) {
            if (ts3.some(node.parameters, function(p) {
              return !ts3.getEffectiveTypeAnnotationNode(p);
            })) {
              return true;
            }
            if (node.kind !== 210) {
              var parameter = ts3.firstOrUndefined(node.parameters);
              if (!(parameter && ts3.parameterIsThisKeyword(parameter))) {
                return true;
              }
            }
          }
          return false;
        }
        function hasContextSensitiveReturnExpression(node) {
          return !node.typeParameters && !ts3.getEffectiveReturnTypeNode(node) && !!node.body && node.body.kind !== 231 && isContextSensitive(node.body);
        }
        function isContextSensitiveFunctionOrObjectLiteralMethod(func2) {
          return (ts3.isInJSFile(func2) && ts3.isFunctionDeclaration(func2) || isFunctionExpressionOrArrowFunction(func2) || ts3.isObjectLiteralMethod(func2)) && isContextSensitiveFunctionLikeDeclaration(func2);
        }
        function getTypeWithoutSignatures(type3) {
          if (type3.flags & 524288) {
            var resolved = resolveStructuredTypeMembers(type3);
            if (resolved.constructSignatures.length || resolved.callSignatures.length) {
              var result2 = createObjectType(16, type3.symbol);
              result2.members = resolved.members;
              result2.properties = resolved.properties;
              result2.callSignatures = ts3.emptyArray;
              result2.constructSignatures = ts3.emptyArray;
              return result2;
            }
          } else if (type3.flags & 2097152) {
            return getIntersectionType(ts3.map(type3.types, getTypeWithoutSignatures));
          }
          return type3;
        }
        function isTypeIdenticalTo(source, target) {
          return isTypeRelatedTo(source, target, identityRelation);
        }
        function compareTypesIdentical(source, target) {
          return isTypeRelatedTo(source, target, identityRelation) ? -1 : 0;
        }
        function compareTypesAssignable(source, target) {
          return isTypeRelatedTo(source, target, assignableRelation) ? -1 : 0;
        }
        function compareTypesSubtypeOf(source, target) {
          return isTypeRelatedTo(source, target, subtypeRelation) ? -1 : 0;
        }
        function isTypeSubtypeOf(source, target) {
          return isTypeRelatedTo(source, target, subtypeRelation);
        }
        function isTypeAssignableTo(source, target) {
          return isTypeRelatedTo(source, target, assignableRelation);
        }
        function isTypeDerivedFrom(source, target) {
          return source.flags & 1048576 ? ts3.every(source.types, function(t2) {
            return isTypeDerivedFrom(t2, target);
          }) : target.flags & 1048576 ? ts3.some(target.types, function(t2) {
            return isTypeDerivedFrom(source, t2);
          }) : source.flags & 58982400 ? isTypeDerivedFrom(getBaseConstraintOfType(source) || unknownType, target) : target === globalObjectType ? !!(source.flags & (524288 | 67108864)) : target === globalFunctionType ? !!(source.flags & 524288) && isFunctionObjectType(source) : hasBaseType(source, getTargetType(target)) || isArrayType(target) && !isReadonlyArrayType(target) && isTypeDerivedFrom(source, globalReadonlyArrayType);
        }
        function isTypeComparableTo(source, target) {
          return isTypeRelatedTo(source, target, comparableRelation);
        }
        function areTypesComparable(type1, type22) {
          return isTypeComparableTo(type1, type22) || isTypeComparableTo(type22, type1);
        }
        function checkTypeAssignableTo(source, target, errorNode, headMessage, containingMessageChain, errorOutputObject) {
          return checkTypeRelatedTo(source, target, assignableRelation, errorNode, headMessage, containingMessageChain, errorOutputObject);
        }
        function checkTypeAssignableToAndOptionallyElaborate(source, target, errorNode, expr, headMessage, containingMessageChain) {
          return checkTypeRelatedToAndOptionallyElaborate(source, target, assignableRelation, errorNode, expr, headMessage, containingMessageChain, void 0);
        }
        function checkTypeRelatedToAndOptionallyElaborate(source, target, relation, errorNode, expr, headMessage, containingMessageChain, errorOutputContainer) {
          if (isTypeRelatedTo(source, target, relation))
            return true;
          if (!errorNode || !elaborateError(expr, source, target, relation, headMessage, containingMessageChain, errorOutputContainer)) {
            return checkTypeRelatedTo(source, target, relation, errorNode, headMessage, containingMessageChain, errorOutputContainer);
          }
          return false;
        }
        function isOrHasGenericConditional(type3) {
          return !!(type3.flags & 16777216 || type3.flags & 2097152 && ts3.some(type3.types, isOrHasGenericConditional));
        }
        function elaborateError(node, source, target, relation, headMessage, containingMessageChain, errorOutputContainer) {
          if (!node || isOrHasGenericConditional(target))
            return false;
          if (!checkTypeRelatedTo(source, target, relation, void 0) && elaborateDidYouMeanToCallOrConstruct(node, source, target, relation, headMessage, containingMessageChain, errorOutputContainer)) {
            return true;
          }
          switch (node.kind) {
            case 284:
            case 208:
              return elaborateError(node.expression, source, target, relation, headMessage, containingMessageChain, errorOutputContainer);
            case 217:
              switch (node.operatorToken.kind) {
                case 62:
                case 27:
                  return elaborateError(node.right, source, target, relation, headMessage, containingMessageChain, errorOutputContainer);
              }
              break;
            case 201:
              return elaborateObjectLiteral(node, source, target, relation, containingMessageChain, errorOutputContainer);
            case 200:
              return elaborateArrayLiteral(node, source, target, relation, containingMessageChain, errorOutputContainer);
            case 282:
              return elaborateJsxComponents(node, source, target, relation, containingMessageChain, errorOutputContainer);
            case 210:
              return elaborateArrowFunction(node, source, target, relation, containingMessageChain, errorOutputContainer);
          }
          return false;
        }
        function elaborateDidYouMeanToCallOrConstruct(node, source, target, relation, headMessage, containingMessageChain, errorOutputContainer) {
          var callSignatures = getSignaturesOfType(source, 0);
          var constructSignatures = getSignaturesOfType(source, 1);
          for (var _i = 0, _a2 = [constructSignatures, callSignatures]; _i < _a2.length; _i++) {
            var signatures = _a2[_i];
            if (ts3.some(signatures, function(s2) {
              var returnType2 = getReturnTypeOfSignature(s2);
              return !(returnType2.flags & (1 | 131072)) && checkTypeRelatedTo(returnType2, target, relation, void 0);
            })) {
              var resultObj = errorOutputContainer || {};
              checkTypeAssignableTo(source, target, node, headMessage, containingMessageChain, resultObj);
              var diagnostic = resultObj.errors[resultObj.errors.length - 1];
              ts3.addRelatedInfo(diagnostic, ts3.createDiagnosticForNode(node, signatures === constructSignatures ? ts3.Diagnostics.Did_you_mean_to_use_new_with_this_expression : ts3.Diagnostics.Did_you_mean_to_call_this_expression));
              return true;
            }
          }
          return false;
        }
        function elaborateArrowFunction(node, source, target, relation, containingMessageChain, errorOutputContainer) {
          if (ts3.isBlock(node.body)) {
            return false;
          }
          if (ts3.some(node.parameters, ts3.hasType)) {
            return false;
          }
          var sourceSig = getSingleCallSignature(source);
          if (!sourceSig) {
            return false;
          }
          var targetSignatures = getSignaturesOfType(target, 0);
          if (!ts3.length(targetSignatures)) {
            return false;
          }
          var returnExpression = node.body;
          var sourceReturn = getReturnTypeOfSignature(sourceSig);
          var targetReturn = getUnionType(ts3.map(targetSignatures, getReturnTypeOfSignature));
          if (!checkTypeRelatedTo(sourceReturn, targetReturn, relation, void 0)) {
            var elaborated = returnExpression && elaborateError(returnExpression, sourceReturn, targetReturn, relation, void 0, containingMessageChain, errorOutputContainer);
            if (elaborated) {
              return elaborated;
            }
            var resultObj = errorOutputContainer || {};
            checkTypeRelatedTo(sourceReturn, targetReturn, relation, returnExpression, void 0, containingMessageChain, resultObj);
            if (resultObj.errors) {
              if (target.symbol && ts3.length(target.symbol.declarations)) {
                ts3.addRelatedInfo(resultObj.errors[resultObj.errors.length - 1], ts3.createDiagnosticForNode(target.symbol.declarations[0], ts3.Diagnostics.The_expected_type_comes_from_the_return_type_of_this_signature));
              }
              if ((ts3.getFunctionFlags(node) & 2) === 0 && !getTypeOfPropertyOfType(sourceReturn, "then") && checkTypeRelatedTo(createPromiseType(sourceReturn), targetReturn, relation, void 0)) {
                ts3.addRelatedInfo(resultObj.errors[resultObj.errors.length - 1], ts3.createDiagnosticForNode(node, ts3.Diagnostics.Did_you_mean_to_mark_this_function_as_async));
              }
              return true;
            }
          }
          return false;
        }
        function getBestMatchIndexedAccessTypeOrUndefined(source, target, nameType) {
          var idx = getIndexedAccessTypeOrUndefined(target, nameType);
          if (idx) {
            return idx;
          }
          if (target.flags & 1048576) {
            var best = getBestMatchingType(source, target);
            if (best) {
              return getIndexedAccessTypeOrUndefined(best, nameType);
            }
          }
        }
        function checkExpressionForMutableLocationWithContextualType(next, sourcePropType) {
          next.contextualType = sourcePropType;
          try {
            return checkExpressionForMutableLocation(next, 1, sourcePropType);
          } finally {
            next.contextualType = void 0;
          }
        }
        function elaborateElementwise(iterator, source, target, relation, containingMessageChain, errorOutputContainer) {
          var reportedError = false;
          for (var status = iterator.next(); !status.done; status = iterator.next()) {
            var _a2 = status.value, prop = _a2.errorNode, next = _a2.innerExpression, nameType = _a2.nameType, errorMessage = _a2.errorMessage;
            var targetPropType = getBestMatchIndexedAccessTypeOrUndefined(source, target, nameType);
            if (!targetPropType || targetPropType.flags & 8388608)
              continue;
            var sourcePropType = getIndexedAccessTypeOrUndefined(source, nameType);
            if (sourcePropType && !checkTypeRelatedTo(sourcePropType, targetPropType, relation, void 0)) {
              var elaborated = next && elaborateError(next, sourcePropType, targetPropType, relation, void 0, containingMessageChain, errorOutputContainer);
              if (elaborated) {
                reportedError = true;
              } else {
                var resultObj = errorOutputContainer || {};
                var specificSource = next ? checkExpressionForMutableLocationWithContextualType(next, sourcePropType) : sourcePropType;
                var result2 = checkTypeRelatedTo(specificSource, targetPropType, relation, prop, errorMessage, containingMessageChain, resultObj);
                if (result2 && specificSource !== sourcePropType) {
                  checkTypeRelatedTo(sourcePropType, targetPropType, relation, prop, errorMessage, containingMessageChain, resultObj);
                }
                if (resultObj.errors) {
                  var reportedDiag = resultObj.errors[resultObj.errors.length - 1];
                  var propertyName = isTypeUsableAsPropertyName(nameType) ? getPropertyNameFromType(nameType) : void 0;
                  var targetProp = propertyName !== void 0 ? getPropertyOfType(target, propertyName) : void 0;
                  var issuedElaboration = false;
                  if (!targetProp) {
                    var indexInfo = isTypeAssignableToKind(nameType, 296) && getIndexInfoOfType(target, 1) || getIndexInfoOfType(target, 0) || void 0;
                    if (indexInfo && indexInfo.declaration && !ts3.getSourceFileOfNode(indexInfo.declaration).hasNoDefaultLib) {
                      issuedElaboration = true;
                      ts3.addRelatedInfo(reportedDiag, ts3.createDiagnosticForNode(indexInfo.declaration, ts3.Diagnostics.The_expected_type_comes_from_this_index_signature));
                    }
                  }
                  if (!issuedElaboration && (targetProp && ts3.length(targetProp.declarations) || target.symbol && ts3.length(target.symbol.declarations))) {
                    var targetNode = targetProp && ts3.length(targetProp.declarations) ? targetProp.declarations[0] : target.symbol.declarations[0];
                    if (!ts3.getSourceFileOfNode(targetNode).hasNoDefaultLib) {
                      ts3.addRelatedInfo(reportedDiag, ts3.createDiagnosticForNode(targetNode, ts3.Diagnostics.The_expected_type_comes_from_property_0_which_is_declared_here_on_type_1, propertyName && !(nameType.flags & 8192) ? ts3.unescapeLeadingUnderscores(propertyName) : typeToString(nameType), typeToString(target)));
                    }
                  }
                }
                reportedError = true;
              }
            }
          }
          return reportedError;
        }
        function generateJsxAttributes(node) {
          var _i, _a2, prop;
          return __generator(this, function(_b) {
            switch (_b.label) {
              case 0:
                if (!ts3.length(node.properties))
                  return [2];
                _i = 0, _a2 = node.properties;
                _b.label = 1;
              case 1:
                if (!(_i < _a2.length))
                  return [3, 4];
                prop = _a2[_i];
                if (ts3.isJsxSpreadAttribute(prop))
                  return [3, 3];
                return [4, { errorNode: prop.name, innerExpression: prop.initializer, nameType: getLiteralType(ts3.idText(prop.name)) }];
              case 2:
                _b.sent();
                _b.label = 3;
              case 3:
                _i++;
                return [3, 1];
              case 4:
                return [2];
            }
          });
        }
        function generateJsxChildren(node, getInvalidTextDiagnostic) {
          var memberOffset, i3, child, nameType, elem;
          return __generator(this, function(_a2) {
            switch (_a2.label) {
              case 0:
                if (!ts3.length(node.children))
                  return [2];
                memberOffset = 0;
                i3 = 0;
                _a2.label = 1;
              case 1:
                if (!(i3 < node.children.length))
                  return [3, 5];
                child = node.children[i3];
                nameType = getLiteralType(i3 - memberOffset);
                elem = getElaborationElementForJsxChild(child, nameType, getInvalidTextDiagnostic);
                if (!elem)
                  return [3, 3];
                return [4, elem];
              case 2:
                _a2.sent();
                return [3, 4];
              case 3:
                memberOffset++;
                _a2.label = 4;
              case 4:
                i3++;
                return [3, 1];
              case 5:
                return [2];
            }
          });
        }
        function getElaborationElementForJsxChild(child, nameType, getInvalidTextDiagnostic) {
          switch (child.kind) {
            case 284:
              return { errorNode: child, innerExpression: child.expression, nameType };
            case 11:
              if (child.containsOnlyTriviaWhiteSpaces) {
                break;
              }
              return { errorNode: child, innerExpression: void 0, nameType, errorMessage: getInvalidTextDiagnostic() };
            case 274:
            case 275:
            case 278:
              return { errorNode: child, innerExpression: child, nameType };
            default:
              return ts3.Debug.assertNever(child, "Found invalid jsx child");
          }
        }
        function elaborateJsxComponents(node, source, target, relation, containingMessageChain, errorOutputContainer) {
          var result2 = elaborateElementwise(generateJsxAttributes(node), source, target, relation, containingMessageChain, errorOutputContainer);
          var invalidTextDiagnostic;
          if (ts3.isJsxOpeningElement(node.parent) && ts3.isJsxElement(node.parent.parent)) {
            var containingElement = node.parent.parent;
            var childPropName = getJsxElementChildrenPropertyName(getJsxNamespaceAt(node));
            var childrenPropName = childPropName === void 0 ? "children" : ts3.unescapeLeadingUnderscores(childPropName);
            var childrenNameType = getLiteralType(childrenPropName);
            var childrenTargetType = getIndexedAccessType(target, childrenNameType);
            var validChildren = ts3.getSemanticJsxChildren(containingElement.children);
            if (!ts3.length(validChildren)) {
              return result2;
            }
            var moreThanOneRealChildren = ts3.length(validChildren) > 1;
            var arrayLikeTargetParts = filterType(childrenTargetType, isArrayOrTupleLikeType);
            var nonArrayLikeTargetParts = filterType(childrenTargetType, function(t2) {
              return !isArrayOrTupleLikeType(t2);
            });
            if (moreThanOneRealChildren) {
              if (arrayLikeTargetParts !== neverType) {
                var realSource = createTupleType(checkJsxChildren(containingElement, 0));
                var children = generateJsxChildren(containingElement, getInvalidTextualChildDiagnostic);
                result2 = elaborateElementwise(children, realSource, arrayLikeTargetParts, relation, containingMessageChain, errorOutputContainer) || result2;
              } else if (!isTypeRelatedTo(getIndexedAccessType(source, childrenNameType), childrenTargetType, relation)) {
                result2 = true;
                var diag = error(containingElement.openingElement.tagName, ts3.Diagnostics.This_JSX_tag_s_0_prop_expects_a_single_child_of_type_1_but_multiple_children_were_provided, childrenPropName, typeToString(childrenTargetType));
                if (errorOutputContainer && errorOutputContainer.skipLogging) {
                  (errorOutputContainer.errors || (errorOutputContainer.errors = [])).push(diag);
                }
              }
            } else {
              if (nonArrayLikeTargetParts !== neverType) {
                var child = validChildren[0];
                var elem_1 = getElaborationElementForJsxChild(child, childrenNameType, getInvalidTextualChildDiagnostic);
                if (elem_1) {
                  result2 = elaborateElementwise(function() {
                    return __generator(this, function(_a2) {
                      switch (_a2.label) {
                        case 0:
                          return [4, elem_1];
                        case 1:
                          _a2.sent();
                          return [2];
                      }
                    });
                  }(), source, target, relation, containingMessageChain, errorOutputContainer) || result2;
                }
              } else if (!isTypeRelatedTo(getIndexedAccessType(source, childrenNameType), childrenTargetType, relation)) {
                result2 = true;
                var diag = error(containingElement.openingElement.tagName, ts3.Diagnostics.This_JSX_tag_s_0_prop_expects_type_1_which_requires_multiple_children_but_only_a_single_child_was_provided, childrenPropName, typeToString(childrenTargetType));
                if (errorOutputContainer && errorOutputContainer.skipLogging) {
                  (errorOutputContainer.errors || (errorOutputContainer.errors = [])).push(diag);
                }
              }
            }
          }
          return result2;
          function getInvalidTextualChildDiagnostic() {
            if (!invalidTextDiagnostic) {
              var tagNameText = ts3.getTextOfNode(node.parent.tagName);
              var childPropName2 = getJsxElementChildrenPropertyName(getJsxNamespaceAt(node));
              var childrenPropName2 = childPropName2 === void 0 ? "children" : ts3.unescapeLeadingUnderscores(childPropName2);
              var childrenTargetType2 = getIndexedAccessType(target, getLiteralType(childrenPropName2));
              var diagnostic = ts3.Diagnostics._0_components_don_t_accept_text_as_child_elements_Text_in_JSX_has_the_type_string_but_the_expected_type_of_1_is_2;
              invalidTextDiagnostic = __assign(__assign({}, diagnostic), { key: "!!ALREADY FORMATTED!!", message: ts3.formatMessage(void 0, diagnostic, tagNameText, childrenPropName2, typeToString(childrenTargetType2)) });
            }
            return invalidTextDiagnostic;
          }
        }
        function generateLimitedTupleElements(node, target) {
          var len, i3, elem, nameType;
          return __generator(this, function(_a2) {
            switch (_a2.label) {
              case 0:
                len = ts3.length(node.elements);
                if (!len)
                  return [2];
                i3 = 0;
                _a2.label = 1;
              case 1:
                if (!(i3 < len))
                  return [3, 4];
                if (isTupleLikeType(target) && !getPropertyOfType(target, "" + i3))
                  return [3, 3];
                elem = node.elements[i3];
                if (ts3.isOmittedExpression(elem))
                  return [3, 3];
                nameType = getLiteralType(i3);
                return [4, { errorNode: elem, innerExpression: elem, nameType }];
              case 2:
                _a2.sent();
                _a2.label = 3;
              case 3:
                i3++;
                return [3, 1];
              case 4:
                return [2];
            }
          });
        }
        function elaborateArrayLiteral(node, source, target, relation, containingMessageChain, errorOutputContainer) {
          if (target.flags & 131068)
            return false;
          if (isTupleLikeType(source)) {
            return elaborateElementwise(generateLimitedTupleElements(node, target), source, target, relation, containingMessageChain, errorOutputContainer);
          }
          var oldContext = node.contextualType;
          node.contextualType = target;
          try {
            var tupleizedType = checkArrayLiteral(node, 1, true);
            node.contextualType = oldContext;
            if (isTupleLikeType(tupleizedType)) {
              return elaborateElementwise(generateLimitedTupleElements(node, target), tupleizedType, target, relation, containingMessageChain, errorOutputContainer);
            }
            return false;
          } finally {
            node.contextualType = oldContext;
          }
        }
        function generateObjectLiteralElements(node) {
          var _i, _a2, prop, type3, _b;
          return __generator(this, function(_c) {
            switch (_c.label) {
              case 0:
                if (!ts3.length(node.properties))
                  return [2];
                _i = 0, _a2 = node.properties;
                _c.label = 1;
              case 1:
                if (!(_i < _a2.length))
                  return [3, 8];
                prop = _a2[_i];
                if (ts3.isSpreadAssignment(prop))
                  return [3, 7];
                type3 = getLiteralTypeFromProperty(getSymbolOfNode(prop), 8576);
                if (!type3 || type3.flags & 131072) {
                  return [3, 7];
                }
                _b = prop.kind;
                switch (_b) {
                  case 169:
                    return [3, 2];
                  case 168:
                    return [3, 2];
                  case 166:
                    return [3, 2];
                  case 290:
                    return [3, 2];
                  case 289:
                    return [3, 4];
                }
                return [3, 6];
              case 2:
                return [4, { errorNode: prop.name, innerExpression: void 0, nameType: type3 }];
              case 3:
                _c.sent();
                return [3, 7];
              case 4:
                return [4, { errorNode: prop.name, innerExpression: prop.initializer, nameType: type3, errorMessage: ts3.isComputedNonLiteralName(prop.name) ? ts3.Diagnostics.Type_of_computed_property_s_value_is_0_which_is_not_assignable_to_type_1 : void 0 }];
              case 5:
                _c.sent();
                return [3, 7];
              case 6:
                ts3.Debug.assertNever(prop);
                _c.label = 7;
              case 7:
                _i++;
                return [3, 1];
              case 8:
                return [2];
            }
          });
        }
        function elaborateObjectLiteral(node, source, target, relation, containingMessageChain, errorOutputContainer) {
          if (target.flags & 131068)
            return false;
          return elaborateElementwise(generateObjectLiteralElements(node), source, target, relation, containingMessageChain, errorOutputContainer);
        }
        function checkTypeComparableTo(source, target, errorNode, headMessage, containingMessageChain) {
          return checkTypeRelatedTo(source, target, comparableRelation, errorNode, headMessage, containingMessageChain);
        }
        function isSignatureAssignableTo(source, target, ignoreReturnTypes) {
          return compareSignaturesRelated(source, target, ignoreReturnTypes ? 4 : 0, false, void 0, void 0, compareTypesAssignable, void 0) !== 0;
        }
        function isAnySignature(s2) {
          return !s2.typeParameters && (!s2.thisParameter || isTypeAny(getTypeOfParameter(s2.thisParameter))) && s2.parameters.length === 1 && signatureHasRestParameter(s2) && (getTypeOfParameter(s2.parameters[0]) === anyArrayType || isTypeAny(getTypeOfParameter(s2.parameters[0]))) && isTypeAny(getReturnTypeOfSignature(s2));
        }
        function compareSignaturesRelated(source, target, checkMode, reportErrors, errorReporter, incompatibleErrorReporter, compareTypes, reportUnreliableMarkers) {
          if (source === target) {
            return -1;
          }
          if (isAnySignature(target)) {
            return -1;
          }
          var targetCount = getParameterCount(target);
          var sourceHasMoreParameters = !hasEffectiveRestParameter(target) && (checkMode & 8 ? hasEffectiveRestParameter(source) || getParameterCount(source) > targetCount : getMinArgumentCount(source) > targetCount);
          if (sourceHasMoreParameters) {
            return 0;
          }
          if (source.typeParameters && source.typeParameters !== target.typeParameters) {
            target = getCanonicalSignature(target);
            source = instantiateSignatureInContextOf(source, target, void 0, compareTypes);
          }
          var sourceCount = getParameterCount(source);
          var sourceRestType = getNonArrayRestType(source);
          var targetRestType = getNonArrayRestType(target);
          if (sourceRestType || targetRestType) {
            void instantiateType(sourceRestType || targetRestType, reportUnreliableMarkers);
          }
          if (sourceRestType && targetRestType && sourceCount !== targetCount) {
            return 0;
          }
          var kind = target.declaration ? target.declaration.kind : 0;
          var strictVariance = !(checkMode & 3) && strictFunctionTypes && kind !== 166 && kind !== 165 && kind !== 167;
          var result2 = -1;
          var sourceThisType = getThisTypeOfSignature(source);
          if (sourceThisType && sourceThisType !== voidType) {
            var targetThisType = getThisTypeOfSignature(target);
            if (targetThisType) {
              var related = !strictVariance && compareTypes(sourceThisType, targetThisType, false) || compareTypes(targetThisType, sourceThisType, reportErrors);
              if (!related) {
                if (reportErrors) {
                  errorReporter(ts3.Diagnostics.The_this_types_of_each_signature_are_incompatible);
                }
                return 0;
              }
              result2 &= related;
            }
          }
          var paramCount = sourceRestType || targetRestType ? Math.min(sourceCount, targetCount) : Math.max(sourceCount, targetCount);
          var restIndex = sourceRestType || targetRestType ? paramCount - 1 : -1;
          for (var i3 = 0; i3 < paramCount; i3++) {
            var sourceType = i3 === restIndex ? getRestTypeAtPosition(source, i3) : tryGetTypeAtPosition(source, i3);
            var targetType = i3 === restIndex ? getRestTypeAtPosition(target, i3) : tryGetTypeAtPosition(target, i3);
            if (sourceType && targetType) {
              var sourceSig = checkMode & 3 ? void 0 : getSingleCallSignature(getNonNullableType(sourceType));
              var targetSig = checkMode & 3 ? void 0 : getSingleCallSignature(getNonNullableType(targetType));
              var callbacks = sourceSig && targetSig && !getTypePredicateOfSignature(sourceSig) && !getTypePredicateOfSignature(targetSig) && (getFalsyFlags(sourceType) & 98304) === (getFalsyFlags(targetType) & 98304);
              var related = callbacks ? compareSignaturesRelated(targetSig, sourceSig, checkMode & 8 | (strictVariance ? 2 : 1), reportErrors, errorReporter, incompatibleErrorReporter, compareTypes, reportUnreliableMarkers) : !(checkMode & 3) && !strictVariance && compareTypes(sourceType, targetType, false) || compareTypes(targetType, sourceType, reportErrors);
              if (related && checkMode & 8 && i3 >= getMinArgumentCount(source) && i3 < getMinArgumentCount(target) && compareTypes(sourceType, targetType, false)) {
                related = 0;
              }
              if (!related) {
                if (reportErrors) {
                  errorReporter(ts3.Diagnostics.Types_of_parameters_0_and_1_are_incompatible, ts3.unescapeLeadingUnderscores(getParameterNameAtPosition(source, i3)), ts3.unescapeLeadingUnderscores(getParameterNameAtPosition(target, i3)));
                }
                return 0;
              }
              result2 &= related;
            }
          }
          if (!(checkMode & 4)) {
            var targetReturnType = isResolvingReturnTypeOfSignature(target) ? anyType : target.declaration && isJSConstructor(target.declaration) ? getDeclaredTypeOfClassOrInterface(getMergedSymbol(target.declaration.symbol)) : getReturnTypeOfSignature(target);
            if (targetReturnType === voidType) {
              return result2;
            }
            var sourceReturnType = isResolvingReturnTypeOfSignature(source) ? anyType : source.declaration && isJSConstructor(source.declaration) ? getDeclaredTypeOfClassOrInterface(getMergedSymbol(source.declaration.symbol)) : getReturnTypeOfSignature(source);
            var targetTypePredicate = getTypePredicateOfSignature(target);
            if (targetTypePredicate) {
              var sourceTypePredicate = getTypePredicateOfSignature(source);
              if (sourceTypePredicate) {
                result2 &= compareTypePredicateRelatedTo(sourceTypePredicate, targetTypePredicate, reportErrors, errorReporter, compareTypes);
              } else if (ts3.isIdentifierTypePredicate(targetTypePredicate)) {
                if (reportErrors) {
                  errorReporter(ts3.Diagnostics.Signature_0_must_be_a_type_predicate, signatureToString(source));
                }
                return 0;
              }
            } else {
              result2 &= checkMode & 1 && compareTypes(targetReturnType, sourceReturnType, false) || compareTypes(sourceReturnType, targetReturnType, reportErrors);
              if (!result2 && reportErrors && incompatibleErrorReporter) {
                incompatibleErrorReporter(sourceReturnType, targetReturnType);
              }
            }
          }
          return result2;
        }
        function compareTypePredicateRelatedTo(source, target, reportErrors, errorReporter, compareTypes) {
          if (source.kind !== target.kind) {
            if (reportErrors) {
              errorReporter(ts3.Diagnostics.A_this_based_type_guard_is_not_compatible_with_a_parameter_based_type_guard);
              errorReporter(ts3.Diagnostics.Type_predicate_0_is_not_assignable_to_1, typePredicateToString(source), typePredicateToString(target));
            }
            return 0;
          }
          if (source.kind === 1 || source.kind === 3) {
            if (source.parameterIndex !== target.parameterIndex) {
              if (reportErrors) {
                errorReporter(ts3.Diagnostics.Parameter_0_is_not_in_the_same_position_as_parameter_1, source.parameterName, target.parameterName);
                errorReporter(ts3.Diagnostics.Type_predicate_0_is_not_assignable_to_1, typePredicateToString(source), typePredicateToString(target));
              }
              return 0;
            }
          }
          var related = source.type === target.type ? -1 : source.type && target.type ? compareTypes(source.type, target.type, reportErrors) : 0;
          if (related === 0 && reportErrors) {
            errorReporter(ts3.Diagnostics.Type_predicate_0_is_not_assignable_to_1, typePredicateToString(source), typePredicateToString(target));
          }
          return related;
        }
        function isImplementationCompatibleWithOverload(implementation, overload) {
          var erasedSource = getErasedSignature(implementation);
          var erasedTarget = getErasedSignature(overload);
          var sourceReturnType = getReturnTypeOfSignature(erasedSource);
          var targetReturnType = getReturnTypeOfSignature(erasedTarget);
          if (targetReturnType === voidType || isTypeRelatedTo(targetReturnType, sourceReturnType, assignableRelation) || isTypeRelatedTo(sourceReturnType, targetReturnType, assignableRelation)) {
            return isSignatureAssignableTo(erasedSource, erasedTarget, true);
          }
          return false;
        }
        function isEmptyResolvedType(t2) {
          return t2 !== anyFunctionType && t2.properties.length === 0 && t2.callSignatures.length === 0 && t2.constructSignatures.length === 0 && !t2.stringIndexInfo && !t2.numberIndexInfo;
        }
        function isEmptyObjectType(type3) {
          return type3.flags & 524288 ? !isGenericMappedType(type3) && isEmptyResolvedType(resolveStructuredTypeMembers(type3)) : type3.flags & 67108864 ? true : type3.flags & 1048576 ? ts3.some(type3.types, isEmptyObjectType) : type3.flags & 2097152 ? ts3.every(type3.types, isEmptyObjectType) : false;
        }
        function isEmptyAnonymousObjectType(type3) {
          return !!(ts3.getObjectFlags(type3) & 16 && (type3.members && isEmptyResolvedType(type3) || type3.symbol && type3.symbol.flags & 2048 && getMembersOfSymbol(type3.symbol).size === 0));
        }
        function isStringIndexSignatureOnlyType(type3) {
          return type3.flags & 524288 && !isGenericMappedType(type3) && getPropertiesOfType(type3).length === 0 && getIndexInfoOfType(type3, 0) && !getIndexInfoOfType(type3, 1) || type3.flags & 3145728 && ts3.every(type3.types, isStringIndexSignatureOnlyType) || false;
        }
        function isEnumTypeRelatedTo(sourceSymbol, targetSymbol, errorReporter) {
          if (sourceSymbol === targetSymbol) {
            return true;
          }
          var id = getSymbolId(sourceSymbol) + "," + getSymbolId(targetSymbol);
          var entry = enumRelation.get(id);
          if (entry !== void 0 && !(!(entry & 4) && entry & 2 && errorReporter)) {
            return !!(entry & 1);
          }
          if (sourceSymbol.escapedName !== targetSymbol.escapedName || !(sourceSymbol.flags & 256) || !(targetSymbol.flags & 256)) {
            enumRelation.set(id, 2 | 4);
            return false;
          }
          var targetEnumType = getTypeOfSymbol(targetSymbol);
          for (var _i = 0, _a2 = getPropertiesOfType(getTypeOfSymbol(sourceSymbol)); _i < _a2.length; _i++) {
            var property = _a2[_i];
            if (property.flags & 8) {
              var targetProperty = getPropertyOfType(targetEnumType, property.escapedName);
              if (!targetProperty || !(targetProperty.flags & 8)) {
                if (errorReporter) {
                  errorReporter(ts3.Diagnostics.Property_0_is_missing_in_type_1, ts3.symbolName(property), typeToString(getDeclaredTypeOfSymbol(targetSymbol), void 0, 64));
                  enumRelation.set(id, 2 | 4);
                } else {
                  enumRelation.set(id, 2);
                }
                return false;
              }
            }
          }
          enumRelation.set(id, 1);
          return true;
        }
        function isSimpleTypeRelatedTo(source, target, relation, errorReporter) {
          var s2 = source.flags;
          var t2 = target.flags;
          if (t2 & 3 || s2 & 131072 || source === wildcardType)
            return true;
          if (t2 & 131072)
            return false;
          if (s2 & 402653316 && t2 & 4)
            return true;
          if (s2 & 128 && s2 & 1024 && t2 & 128 && !(t2 & 1024) && source.value === target.value)
            return true;
          if (s2 & 296 && t2 & 8)
            return true;
          if (s2 & 256 && s2 & 1024 && t2 & 256 && !(t2 & 1024) && source.value === target.value)
            return true;
          if (s2 & 2112 && t2 & 64)
            return true;
          if (s2 & 528 && t2 & 16)
            return true;
          if (s2 & 12288 && t2 & 4096)
            return true;
          if (s2 & 32 && t2 & 32 && isEnumTypeRelatedTo(source.symbol, target.symbol, errorReporter))
            return true;
          if (s2 & 1024 && t2 & 1024) {
            if (s2 & 1048576 && t2 & 1048576 && isEnumTypeRelatedTo(source.symbol, target.symbol, errorReporter))
              return true;
            if (s2 & 2944 && t2 & 2944 && source.value === target.value && isEnumTypeRelatedTo(getParentOfSymbol(source.symbol), getParentOfSymbol(target.symbol), errorReporter))
              return true;
          }
          if (s2 & 32768 && (!strictNullChecks || t2 & (32768 | 16384)))
            return true;
          if (s2 & 65536 && (!strictNullChecks || t2 & 65536))
            return true;
          if (s2 & 524288 && t2 & 67108864)
            return true;
          if (relation === assignableRelation || relation === comparableRelation) {
            if (s2 & 1)
              return true;
            if (s2 & (8 | 256) && !(s2 & 1024) && (t2 & 32 || relation === assignableRelation && t2 & 256 && t2 & 1024))
              return true;
          }
          return false;
        }
        function isTypeRelatedTo(source, target, relation) {
          if (isFreshLiteralType(source)) {
            source = source.regularType;
          }
          if (isFreshLiteralType(target)) {
            target = target.regularType;
          }
          if (source === target) {
            return true;
          }
          if (relation !== identityRelation) {
            if (relation === comparableRelation && !(target.flags & 131072) && isSimpleTypeRelatedTo(target, source, relation) || isSimpleTypeRelatedTo(source, target, relation)) {
              return true;
            }
          } else {
            if (!(source.flags & 3145728) && !(target.flags & 3145728) && source.flags !== target.flags && !(source.flags & 469237760))
              return false;
          }
          if (source.flags & 524288 && target.flags & 524288) {
            var related = relation.get(getRelationKey(source, target, 0, relation));
            if (related !== void 0) {
              return !!(related & 1);
            }
          }
          if (source.flags & 469499904 || target.flags & 469499904) {
            return checkTypeRelatedTo(source, target, relation, void 0);
          }
          return false;
        }
        function isIgnoredJsxProperty(source, sourceProp) {
          return ts3.getObjectFlags(source) & 2048 && !isUnhyphenatedJsxName(sourceProp.escapedName);
        }
        function getNormalizedType(type3, writing) {
          while (true) {
            var t2 = isFreshLiteralType(type3) ? type3.regularType : ts3.getObjectFlags(type3) & 4 && type3.node ? createTypeReference(type3.target, getTypeArguments(type3)) : type3.flags & 3145728 ? getReducedType(type3) : type3.flags & 33554432 ? writing ? type3.baseType : type3.substitute : type3.flags & 25165824 ? getSimplifiedType(type3, writing) : type3;
            t2 = getSingleBaseForNonAugmentingSubtype(t2) || t2;
            if (t2 === type3)
              break;
            type3 = t2;
          }
          return type3;
        }
        function checkTypeRelatedTo(source, target, relation, errorNode, headMessage, containingMessageChain, errorOutputContainer) {
          var errorInfo;
          var relatedInfo;
          var maybeKeys;
          var sourceStack;
          var targetStack;
          var maybeCount = 0;
          var depth = 0;
          var expandingFlags = 0;
          var overflow = false;
          var overrideNextErrorInfo = 0;
          var lastSkippedInfo;
          var incompatibleStack = [];
          var inPropertyCheck = false;
          ts3.Debug.assert(relation !== identityRelation || !errorNode, "no error reporting in identity checking");
          var result2 = isRelatedTo(source, target, !!errorNode, headMessage);
          if (incompatibleStack.length) {
            reportIncompatibleStack();
          }
          if (overflow) {
            ts3.tracing === null || ts3.tracing === void 0 ? void 0 : ts3.tracing.instant("checkTypes", "checkTypeRelatedTo_DepthLimit", { sourceId: source.id, targetId: target.id, depth });
            var diag = error(errorNode || currentNode, ts3.Diagnostics.Excessive_stack_depth_comparing_types_0_and_1, typeToString(source), typeToString(target));
            if (errorOutputContainer) {
              (errorOutputContainer.errors || (errorOutputContainer.errors = [])).push(diag);
            }
          } else if (errorInfo) {
            if (containingMessageChain) {
              var chain = containingMessageChain();
              if (chain) {
                ts3.concatenateDiagnosticMessageChains(chain, errorInfo);
                errorInfo = chain;
              }
            }
            var relatedInformation = void 0;
            if (headMessage && errorNode && !result2 && source.symbol) {
              var links = getSymbolLinks(source.symbol);
              if (links.originatingImport && !ts3.isImportCall(links.originatingImport)) {
                var helpfulRetry = checkTypeRelatedTo(getTypeOfSymbol(links.target), target, relation, void 0);
                if (helpfulRetry) {
                  var diag_1 = ts3.createDiagnosticForNode(links.originatingImport, ts3.Diagnostics.Type_originates_at_this_import_A_namespace_style_import_cannot_be_called_or_constructed_and_will_cause_a_failure_at_runtime_Consider_using_a_default_import_or_import_require_here_instead);
                  relatedInformation = ts3.append(relatedInformation, diag_1);
                }
              }
            }
            var diag = ts3.createDiagnosticForNodeFromMessageChain(errorNode, errorInfo, relatedInformation);
            if (relatedInfo) {
              ts3.addRelatedInfo.apply(void 0, __spreadArray([diag], relatedInfo));
            }
            if (errorOutputContainer) {
              (errorOutputContainer.errors || (errorOutputContainer.errors = [])).push(diag);
            }
            if (!errorOutputContainer || !errorOutputContainer.skipLogging) {
              diagnostics.add(diag);
            }
          }
          if (errorNode && errorOutputContainer && errorOutputContainer.skipLogging && result2 === 0) {
            ts3.Debug.assert(!!errorOutputContainer.errors, "missed opportunity to interact with error.");
          }
          return result2 !== 0;
          function resetErrorInfo(saved) {
            errorInfo = saved.errorInfo;
            lastSkippedInfo = saved.lastSkippedInfo;
            incompatibleStack = saved.incompatibleStack;
            overrideNextErrorInfo = saved.overrideNextErrorInfo;
            relatedInfo = saved.relatedInfo;
          }
          function captureErrorCalculationState() {
            return {
              errorInfo,
              lastSkippedInfo,
              incompatibleStack: incompatibleStack.slice(),
              overrideNextErrorInfo,
              relatedInfo: !relatedInfo ? void 0 : relatedInfo.slice()
            };
          }
          function reportIncompatibleError(message, arg0, arg1, arg2, arg3) {
            overrideNextErrorInfo++;
            lastSkippedInfo = void 0;
            incompatibleStack.push([message, arg0, arg1, arg2, arg3]);
          }
          function reportIncompatibleStack() {
            var stack = incompatibleStack;
            incompatibleStack = [];
            var info = lastSkippedInfo;
            lastSkippedInfo = void 0;
            if (stack.length === 1) {
              reportError.apply(void 0, stack[0]);
              if (info) {
                reportRelationError.apply(void 0, __spreadArray([void 0], info));
              }
              return;
            }
            var path2 = "";
            var secondaryRootErrors = [];
            while (stack.length) {
              var _a2 = stack.pop(), msg = _a2[0], args = _a2.slice(1);
              switch (msg.code) {
                case ts3.Diagnostics.Types_of_property_0_are_incompatible.code: {
                  if (path2.indexOf("new ") === 0) {
                    path2 = "(" + path2 + ")";
                  }
                  var str2 = "" + args[0];
                  if (path2.length === 0) {
                    path2 = "" + str2;
                  } else if (ts3.isIdentifierText(str2, compilerOptions.target)) {
                    path2 = path2 + "." + str2;
                  } else if (str2[0] === "[" && str2[str2.length - 1] === "]") {
                    path2 = "" + path2 + str2;
                  } else {
                    path2 = path2 + "[" + str2 + "]";
                  }
                  break;
                }
                case ts3.Diagnostics.Call_signature_return_types_0_and_1_are_incompatible.code:
                case ts3.Diagnostics.Construct_signature_return_types_0_and_1_are_incompatible.code:
                case ts3.Diagnostics.Call_signatures_with_no_arguments_have_incompatible_return_types_0_and_1.code:
                case ts3.Diagnostics.Construct_signatures_with_no_arguments_have_incompatible_return_types_0_and_1.code: {
                  if (path2.length === 0) {
                    var mappedMsg = msg;
                    if (msg.code === ts3.Diagnostics.Call_signatures_with_no_arguments_have_incompatible_return_types_0_and_1.code) {
                      mappedMsg = ts3.Diagnostics.Call_signature_return_types_0_and_1_are_incompatible;
                    } else if (msg.code === ts3.Diagnostics.Construct_signatures_with_no_arguments_have_incompatible_return_types_0_and_1.code) {
                      mappedMsg = ts3.Diagnostics.Construct_signature_return_types_0_and_1_are_incompatible;
                    }
                    secondaryRootErrors.unshift([mappedMsg, args[0], args[1]]);
                  } else {
                    var prefix2 = msg.code === ts3.Diagnostics.Construct_signature_return_types_0_and_1_are_incompatible.code || msg.code === ts3.Diagnostics.Construct_signatures_with_no_arguments_have_incompatible_return_types_0_and_1.code ? "new " : "";
                    var params = msg.code === ts3.Diagnostics.Call_signatures_with_no_arguments_have_incompatible_return_types_0_and_1.code || msg.code === ts3.Diagnostics.Construct_signatures_with_no_arguments_have_incompatible_return_types_0_and_1.code ? "" : "...";
                    path2 = "" + prefix2 + path2 + "(" + params + ")";
                  }
                  break;
                }
                case ts3.Diagnostics.Type_at_position_0_in_source_is_not_compatible_with_type_at_position_1_in_target.code: {
                  secondaryRootErrors.unshift([ts3.Diagnostics.Type_at_position_0_in_source_is_not_compatible_with_type_at_position_1_in_target, args[0], args[1]]);
                  break;
                }
                case ts3.Diagnostics.Type_at_positions_0_through_1_in_source_is_not_compatible_with_type_at_position_2_in_target.code: {
                  secondaryRootErrors.unshift([ts3.Diagnostics.Type_at_positions_0_through_1_in_source_is_not_compatible_with_type_at_position_2_in_target, args[0], args[1], args[2]]);
                  break;
                }
                default:
                  return ts3.Debug.fail("Unhandled Diagnostic: " + msg.code);
              }
            }
            if (path2) {
              reportError(path2[path2.length - 1] === ")" ? ts3.Diagnostics.The_types_returned_by_0_are_incompatible_between_these_types : ts3.Diagnostics.The_types_of_0_are_incompatible_between_these_types, path2);
            } else {
              secondaryRootErrors.shift();
            }
            for (var _i = 0, secondaryRootErrors_1 = secondaryRootErrors; _i < secondaryRootErrors_1.length; _i++) {
              var _b = secondaryRootErrors_1[_i], msg = _b[0], args = _b.slice(1);
              var originalValue = msg.elidedInCompatabilityPyramid;
              msg.elidedInCompatabilityPyramid = false;
              reportError.apply(void 0, __spreadArray([msg], args));
              msg.elidedInCompatabilityPyramid = originalValue;
            }
            if (info) {
              reportRelationError.apply(void 0, __spreadArray([void 0], info));
            }
          }
          function reportError(message, arg0, arg1, arg2, arg3) {
            ts3.Debug.assert(!!errorNode);
            if (incompatibleStack.length)
              reportIncompatibleStack();
            if (message.elidedInCompatabilityPyramid)
              return;
            errorInfo = ts3.chainDiagnosticMessages(errorInfo, message, arg0, arg1, arg2, arg3);
          }
          function associateRelatedInfo(info) {
            ts3.Debug.assert(!!errorInfo);
            if (!relatedInfo) {
              relatedInfo = [info];
            } else {
              relatedInfo.push(info);
            }
          }
          function reportRelationError(message, source2, target2) {
            if (incompatibleStack.length)
              reportIncompatibleStack();
            var _a2 = getTypeNamesForErrorDisplay(source2, target2), sourceType = _a2[0], targetType = _a2[1];
            var generalizedSource = source2;
            var generalizedSourceType = sourceType;
            if (isLiteralType(source2) && !typeCouldHaveTopLevelSingletonTypes(target2)) {
              generalizedSource = getBaseTypeOfLiteralType(source2);
              ts3.Debug.assert(!isTypeAssignableTo(generalizedSource, target2), "generalized source shouldn't be assignable");
              generalizedSourceType = getTypeNameForErrorDisplay(generalizedSource);
            }
            if (target2.flags & 262144) {
              var constraint = getBaseConstraintOfType(target2);
              var needsOriginalSource = void 0;
              if (constraint && (isTypeAssignableTo(generalizedSource, constraint) || (needsOriginalSource = isTypeAssignableTo(source2, constraint)))) {
                reportError(ts3.Diagnostics._0_is_assignable_to_the_constraint_of_type_1_but_1_could_be_instantiated_with_a_different_subtype_of_constraint_2, needsOriginalSource ? sourceType : generalizedSourceType, targetType, typeToString(constraint));
              } else {
                errorInfo = void 0;
                reportError(ts3.Diagnostics._0_could_be_instantiated_with_an_arbitrary_type_which_could_be_unrelated_to_1, targetType, generalizedSourceType);
              }
            }
            if (!message) {
              if (relation === comparableRelation) {
                message = ts3.Diagnostics.Type_0_is_not_comparable_to_type_1;
              } else if (sourceType === targetType) {
                message = ts3.Diagnostics.Type_0_is_not_assignable_to_type_1_Two_different_types_with_this_name_exist_but_they_are_unrelated;
              } else {
                message = ts3.Diagnostics.Type_0_is_not_assignable_to_type_1;
              }
            }
            reportError(message, generalizedSourceType, targetType);
          }
          function tryElaborateErrorsForPrimitivesAndObjects(source2, target2) {
            var sourceType = symbolValueDeclarationIsContextSensitive(source2.symbol) ? typeToString(source2, source2.symbol.valueDeclaration) : typeToString(source2);
            var targetType = symbolValueDeclarationIsContextSensitive(target2.symbol) ? typeToString(target2, target2.symbol.valueDeclaration) : typeToString(target2);
            if (globalStringType === source2 && stringType === target2 || globalNumberType === source2 && numberType === target2 || globalBooleanType === source2 && booleanType === target2 || getGlobalESSymbolType(false) === source2 && esSymbolType === target2) {
              reportError(ts3.Diagnostics._0_is_a_primitive_but_1_is_a_wrapper_object_Prefer_using_0_when_possible, targetType, sourceType);
            }
          }
          function tryElaborateArrayLikeErrors(source2, target2, reportErrors) {
            if (isTupleType(source2)) {
              if (source2.target.readonly && isMutableArrayOrTuple(target2)) {
                if (reportErrors) {
                  reportError(ts3.Diagnostics.The_type_0_is_readonly_and_cannot_be_assigned_to_the_mutable_type_1, typeToString(source2), typeToString(target2));
                }
                return false;
              }
              return isTupleType(target2) || isArrayType(target2);
            }
            if (isReadonlyArrayType(source2) && isMutableArrayOrTuple(target2)) {
              if (reportErrors) {
                reportError(ts3.Diagnostics.The_type_0_is_readonly_and_cannot_be_assigned_to_the_mutable_type_1, typeToString(source2), typeToString(target2));
              }
              return false;
            }
            if (isTupleType(target2)) {
              return isArrayType(source2);
            }
            return true;
          }
          function isRelatedTo(originalSource, originalTarget, reportErrors, headMessage2, intersectionState) {
            if (reportErrors === void 0) {
              reportErrors = false;
            }
            if (intersectionState === void 0) {
              intersectionState = 0;
            }
            if (originalSource.flags & 524288 && originalTarget.flags & 131068) {
              if (isSimpleTypeRelatedTo(originalSource, originalTarget, relation, reportErrors ? reportError : void 0)) {
                return -1;
              }
              reportErrorResults(originalSource, originalTarget, 0, !!(ts3.getObjectFlags(originalSource) & 2048));
              return 0;
            }
            var source2 = getNormalizedType(originalSource, false);
            var target2 = getNormalizedType(originalTarget, true);
            if (source2 === target2)
              return -1;
            if (relation === identityRelation) {
              return isIdenticalTo(source2, target2);
            }
            if (source2.flags & 262144 && getConstraintOfType(source2) === target2) {
              return -1;
            }
            if (target2.flags & 1048576 && source2.flags & 524288 && target2.types.length <= 3 && maybeTypeOfKind(target2, 98304)) {
              var nullStrippedTarget = extractTypesOfKind(target2, ~98304);
              if (!(nullStrippedTarget.flags & (1048576 | 131072))) {
                target2 = getNormalizedType(nullStrippedTarget, true);
              }
              if (source2 === nullStrippedTarget)
                return -1;
            }
            if (relation === comparableRelation && !(target2.flags & 131072) && isSimpleTypeRelatedTo(target2, source2, relation) || isSimpleTypeRelatedTo(source2, target2, relation, reportErrors ? reportError : void 0))
              return -1;
            var isComparingJsxAttributes = !!(ts3.getObjectFlags(source2) & 2048);
            var isPerformingExcessPropertyChecks = !(intersectionState & 2) && (isObjectLiteralType(source2) && ts3.getObjectFlags(source2) & 16384);
            if (isPerformingExcessPropertyChecks) {
              if (hasExcessProperties(source2, target2, reportErrors)) {
                if (reportErrors) {
                  reportRelationError(headMessage2, source2, originalTarget.aliasSymbol ? originalTarget : target2);
                }
                return 0;
              }
            }
            var isPerformingCommonPropertyChecks = relation !== comparableRelation && !(intersectionState & 2) && source2.flags & (131068 | 524288 | 2097152) && source2 !== globalObjectType && target2.flags & (524288 | 2097152) && isWeakType(target2) && (getPropertiesOfType(source2).length > 0 || typeHasCallOrConstructSignatures(source2));
            if (isPerformingCommonPropertyChecks && !hasCommonProperties(source2, target2, isComparingJsxAttributes)) {
              if (reportErrors) {
                var sourceString = typeToString(originalSource.aliasSymbol ? originalSource : source2);
                var targetString = typeToString(originalTarget.aliasSymbol ? originalTarget : target2);
                var calls = getSignaturesOfType(source2, 0);
                var constructs = getSignaturesOfType(source2, 1);
                if (calls.length > 0 && isRelatedTo(getReturnTypeOfSignature(calls[0]), target2, false) || constructs.length > 0 && isRelatedTo(getReturnTypeOfSignature(constructs[0]), target2, false)) {
                  reportError(ts3.Diagnostics.Value_of_type_0_has_no_properties_in_common_with_type_1_Did_you_mean_to_call_it, sourceString, targetString);
                } else {
                  reportError(ts3.Diagnostics.Type_0_has_no_properties_in_common_with_type_1, sourceString, targetString);
                }
              }
              return 0;
            }
            traceUnionsOrIntersectionsTooLarge(source2, target2);
            var result3 = 0;
            var saveErrorInfo = captureErrorCalculationState();
            if (source2.flags & 3145728 || target2.flags & 3145728) {
              result3 = getConstituentCount(source2) * getConstituentCount(target2) >= 4 ? recursiveTypeRelatedTo(source2, target2, reportErrors, intersectionState | 8) : structuredTypeRelatedTo(source2, target2, reportErrors, intersectionState | 8);
            }
            if (!result3 && !(source2.flags & 1048576) && (source2.flags & 469499904 || target2.flags & 469499904)) {
              if (result3 = recursiveTypeRelatedTo(source2, target2, reportErrors, intersectionState)) {
                resetErrorInfo(saveErrorInfo);
              }
            }
            if (!result3 && source2.flags & (2097152 | 262144)) {
              var constraint = getEffectiveConstraintOfIntersection(source2.flags & 2097152 ? source2.types : [source2], !!(target2.flags & 1048576));
              if (constraint && (source2.flags & 2097152 || target2.flags & 1048576)) {
                if (everyType(constraint, function(c2) {
                  return c2 !== source2;
                })) {
                  if (result3 = isRelatedTo(constraint, target2, false, void 0, intersectionState)) {
                    resetErrorInfo(saveErrorInfo);
                  }
                }
              }
            }
            if (result3 && !inPropertyCheck && (target2.flags & 2097152 && (isPerformingExcessPropertyChecks || isPerformingCommonPropertyChecks) || isNonGenericObjectType(target2) && !isArrayType(target2) && !isTupleType(target2) && source2.flags & 2097152 && getApparentType(source2).flags & 3670016 && !ts3.some(source2.types, function(t2) {
              return !!(ts3.getObjectFlags(t2) & 524288);
            }))) {
              inPropertyCheck = true;
              result3 &= recursiveTypeRelatedTo(source2, target2, reportErrors, 4);
              inPropertyCheck = false;
            }
            reportErrorResults(source2, target2, result3, isComparingJsxAttributes);
            return result3;
            function reportErrorResults(source3, target3, result4, isComparingJsxAttributes2) {
              if (!result4 && reportErrors) {
                var sourceHasBase = !!getSingleBaseForNonAugmentingSubtype(originalSource);
                var targetHasBase = !!getSingleBaseForNonAugmentingSubtype(originalTarget);
                source3 = originalSource.aliasSymbol || sourceHasBase ? originalSource : source3;
                target3 = originalTarget.aliasSymbol || targetHasBase ? originalTarget : target3;
                var maybeSuppress = overrideNextErrorInfo > 0;
                if (maybeSuppress) {
                  overrideNextErrorInfo--;
                }
                if (source3.flags & 524288 && target3.flags & 524288) {
                  var currentError = errorInfo;
                  tryElaborateArrayLikeErrors(source3, target3, reportErrors);
                  if (errorInfo !== currentError) {
                    maybeSuppress = !!errorInfo;
                  }
                }
                if (source3.flags & 524288 && target3.flags & 131068) {
                  tryElaborateErrorsForPrimitivesAndObjects(source3, target3);
                } else if (source3.symbol && source3.flags & 524288 && globalObjectType === source3) {
                  reportError(ts3.Diagnostics.The_Object_type_is_assignable_to_very_few_other_types_Did_you_mean_to_use_the_any_type_instead);
                } else if (isComparingJsxAttributes2 && target3.flags & 2097152) {
                  var targetTypes = target3.types;
                  var intrinsicAttributes = getJsxType(JsxNames.IntrinsicAttributes, errorNode);
                  var intrinsicClassAttributes = getJsxType(JsxNames.IntrinsicClassAttributes, errorNode);
                  if (intrinsicAttributes !== errorType && intrinsicClassAttributes !== errorType && (ts3.contains(targetTypes, intrinsicAttributes) || ts3.contains(targetTypes, intrinsicClassAttributes))) {
                    return result4;
                  }
                } else {
                  errorInfo = elaborateNeverIntersection(errorInfo, originalTarget);
                }
                if (!headMessage2 && maybeSuppress) {
                  lastSkippedInfo = [source3, target3];
                  return result4;
                }
                reportRelationError(headMessage2, source3, target3);
              }
            }
          }
          function traceUnionsOrIntersectionsTooLarge(source2, target2) {
            if (!ts3.tracing) {
              return;
            }
            if (source2.flags & 3145728 && target2.flags & 3145728) {
              var sourceUnionOrIntersection = source2;
              var targetUnionOrIntersection = target2;
              if (sourceUnionOrIntersection.objectFlags & targetUnionOrIntersection.objectFlags & 65536) {
                return;
              }
              var sourceSize = sourceUnionOrIntersection.types.length;
              var targetSize = targetUnionOrIntersection.types.length;
              if (sourceSize * targetSize > 1e6) {
                ts3.tracing.instant("checkTypes", "traceUnionsOrIntersectionsTooLarge_DepthLimit", {
                  sourceId: source2.id,
                  sourceSize,
                  targetId: target2.id,
                  targetSize,
                  pos: errorNode === null || errorNode === void 0 ? void 0 : errorNode.pos,
                  end: errorNode === null || errorNode === void 0 ? void 0 : errorNode.end
                });
              }
            }
          }
          function isIdenticalTo(source2, target2) {
            var flags = source2.flags & target2.flags;
            if (!(flags & 469237760)) {
              return 0;
            }
            traceUnionsOrIntersectionsTooLarge(source2, target2);
            if (flags & 3145728) {
              var result_7 = eachTypeRelatedToSomeType(source2, target2);
              if (result_7) {
                result_7 &= eachTypeRelatedToSomeType(target2, source2);
              }
              return result_7;
            }
            return recursiveTypeRelatedTo(source2, target2, false, 0);
          }
          function getTypeOfPropertyInTypes(types2, name) {
            var appendPropType = function(propTypes, type3) {
              type3 = getApparentType(type3);
              var prop = type3.flags & 3145728 ? getPropertyOfUnionOrIntersectionType(type3, name) : getPropertyOfObjectType(type3, name);
              var propType = prop && getTypeOfSymbol(prop) || isNumericLiteralName(name) && getIndexTypeOfType(type3, 1) || getIndexTypeOfType(type3, 0) || undefinedType;
              return ts3.append(propTypes, propType);
            };
            return getUnionType(ts3.reduceLeft(types2, appendPropType, void 0) || ts3.emptyArray);
          }
          function hasExcessProperties(source2, target2, reportErrors) {
            var _a2;
            if (!isExcessPropertyCheckTarget(target2) || !noImplicitAny && ts3.getObjectFlags(target2) & 8192) {
              return false;
            }
            var isComparingJsxAttributes = !!(ts3.getObjectFlags(source2) & 2048);
            if ((relation === assignableRelation || relation === comparableRelation) && (isTypeSubsetOf(globalObjectType, target2) || !isComparingJsxAttributes && isEmptyObjectType(target2))) {
              return false;
            }
            var reducedTarget = target2;
            var checkTypes;
            if (target2.flags & 1048576) {
              reducedTarget = findMatchingDiscriminantType(source2, target2, isRelatedTo) || filterPrimitivesIfContainsNonPrimitive(target2);
              checkTypes = reducedTarget.flags & 1048576 ? reducedTarget.types : [reducedTarget];
            }
            var _loop_16 = function(prop2) {
              if (shouldCheckAsExcessProperty(prop2, source2.symbol) && !isIgnoredJsxProperty(source2, prop2)) {
                if (!isKnownProperty(reducedTarget, prop2.escapedName, isComparingJsxAttributes)) {
                  if (reportErrors) {
                    var errorTarget = filterType(reducedTarget, isExcessPropertyCheckTarget);
                    if (!errorNode)
                      return { value: ts3.Debug.fail() };
                    if (ts3.isJsxAttributes(errorNode) || ts3.isJsxOpeningLikeElement(errorNode) || ts3.isJsxOpeningLikeElement(errorNode.parent)) {
                      if (prop2.valueDeclaration && ts3.isJsxAttribute(prop2.valueDeclaration) && ts3.getSourceFileOfNode(errorNode) === ts3.getSourceFileOfNode(prop2.valueDeclaration.name)) {
                        errorNode = prop2.valueDeclaration.name;
                      }
                      var propName = symbolToString(prop2);
                      var suggestionSymbol = getSuggestedSymbolForNonexistentJSXAttribute(propName, errorTarget);
                      var suggestion = suggestionSymbol ? symbolToString(suggestionSymbol) : void 0;
                      if (suggestion) {
                        reportError(ts3.Diagnostics.Property_0_does_not_exist_on_type_1_Did_you_mean_2, propName, typeToString(errorTarget), suggestion);
                      } else {
                        reportError(ts3.Diagnostics.Property_0_does_not_exist_on_type_1, propName, typeToString(errorTarget));
                      }
                    } else {
                      var objectLiteralDeclaration_1 = ((_a2 = source2.symbol) === null || _a2 === void 0 ? void 0 : _a2.declarations) && ts3.firstOrUndefined(source2.symbol.declarations);
                      var suggestion = void 0;
                      if (prop2.valueDeclaration && ts3.findAncestor(prop2.valueDeclaration, function(d) {
                        return d === objectLiteralDeclaration_1;
                      }) && ts3.getSourceFileOfNode(objectLiteralDeclaration_1) === ts3.getSourceFileOfNode(errorNode)) {
                        var propDeclaration = prop2.valueDeclaration;
                        ts3.Debug.assertNode(propDeclaration, ts3.isObjectLiteralElementLike);
                        errorNode = propDeclaration;
                        var name = propDeclaration.name;
                        if (ts3.isIdentifier(name)) {
                          suggestion = getSuggestionForNonexistentProperty(name, errorTarget);
                        }
                      }
                      if (suggestion !== void 0) {
                        reportError(ts3.Diagnostics.Object_literal_may_only_specify_known_properties_but_0_does_not_exist_in_type_1_Did_you_mean_to_write_2, symbolToString(prop2), typeToString(errorTarget), suggestion);
                      } else {
                        reportError(ts3.Diagnostics.Object_literal_may_only_specify_known_properties_and_0_does_not_exist_in_type_1, symbolToString(prop2), typeToString(errorTarget));
                      }
                    }
                  }
                  return { value: true };
                }
                if (checkTypes && !isRelatedTo(getTypeOfSymbol(prop2), getTypeOfPropertyInTypes(checkTypes, prop2.escapedName), reportErrors)) {
                  if (reportErrors) {
                    reportIncompatibleError(ts3.Diagnostics.Types_of_property_0_are_incompatible, symbolToString(prop2));
                  }
                  return { value: true };
                }
              }
            };
            for (var _i = 0, _b = getPropertiesOfType(source2); _i < _b.length; _i++) {
              var prop = _b[_i];
              var state_5 = _loop_16(prop);
              if (typeof state_5 === "object")
                return state_5.value;
            }
            return false;
          }
          function shouldCheckAsExcessProperty(prop, container) {
            return prop.valueDeclaration && container.valueDeclaration && prop.valueDeclaration.parent === container.valueDeclaration;
          }
          function eachTypeRelatedToSomeType(source2, target2) {
            var result3 = -1;
            var sourceTypes = source2.types;
            for (var _i = 0, sourceTypes_1 = sourceTypes; _i < sourceTypes_1.length; _i++) {
              var sourceType = sourceTypes_1[_i];
              var related = typeRelatedToSomeType(sourceType, target2, false);
              if (!related) {
                return 0;
              }
              result3 &= related;
            }
            return result3;
          }
          function typeRelatedToSomeType(source2, target2, reportErrors) {
            var targetTypes = target2.types;
            if (target2.flags & 1048576) {
              if (containsType(targetTypes, source2)) {
                return -1;
              }
              var match = getMatchingUnionConstituentForType(target2, source2);
              if (match) {
                var related = isRelatedTo(source2, match, false);
                if (related) {
                  return related;
                }
              }
            }
            for (var _i = 0, targetTypes_1 = targetTypes; _i < targetTypes_1.length; _i++) {
              var type3 = targetTypes_1[_i];
              var related = isRelatedTo(source2, type3, false);
              if (related) {
                return related;
              }
            }
            if (reportErrors) {
              var bestMatchingType = getBestMatchingType(source2, target2, isRelatedTo);
              isRelatedTo(source2, bestMatchingType || targetTypes[targetTypes.length - 1], true);
            }
            return 0;
          }
          function typeRelatedToEachType(source2, target2, reportErrors, intersectionState) {
            var result3 = -1;
            var targetTypes = target2.types;
            for (var _i = 0, targetTypes_2 = targetTypes; _i < targetTypes_2.length; _i++) {
              var targetType = targetTypes_2[_i];
              var related = isRelatedTo(source2, targetType, reportErrors, void 0, intersectionState);
              if (!related) {
                return 0;
              }
              result3 &= related;
            }
            return result3;
          }
          function someTypeRelatedToType(source2, target2, reportErrors, intersectionState) {
            var sourceTypes = source2.types;
            if (source2.flags & 1048576 && containsType(sourceTypes, target2)) {
              return -1;
            }
            var len = sourceTypes.length;
            for (var i3 = 0; i3 < len; i3++) {
              var related = isRelatedTo(sourceTypes[i3], target2, reportErrors && i3 === len - 1, void 0, intersectionState);
              if (related) {
                return related;
              }
            }
            return 0;
          }
          function getUndefinedStrippedTargetIfNeeded(source2, target2) {
            if (source2.flags & 1048576 && target2.flags & 1048576 && !(source2.types[0].flags & 32768) && target2.types[0].flags & 32768) {
              return extractTypesOfKind(target2, ~32768);
            }
            return target2;
          }
          function eachTypeRelatedToType(source2, target2, reportErrors, intersectionState) {
            var result3 = -1;
            var sourceTypes = source2.types;
            var undefinedStrippedTarget = getUndefinedStrippedTargetIfNeeded(source2, target2);
            for (var i3 = 0; i3 < sourceTypes.length; i3++) {
              var sourceType = sourceTypes[i3];
              if (undefinedStrippedTarget.flags & 1048576 && sourceTypes.length >= undefinedStrippedTarget.types.length && sourceTypes.length % undefinedStrippedTarget.types.length === 0) {
                var related_1 = isRelatedTo(sourceType, undefinedStrippedTarget.types[i3 % undefinedStrippedTarget.types.length], false, void 0, intersectionState);
                if (related_1) {
                  result3 &= related_1;
                  continue;
                }
              }
              var related = isRelatedTo(sourceType, target2, reportErrors, void 0, intersectionState);
              if (!related) {
                return 0;
              }
              result3 &= related;
            }
            return result3;
          }
          function typeArgumentsRelatedTo(sources, targets, variances, reportErrors, intersectionState) {
            if (sources === void 0) {
              sources = ts3.emptyArray;
            }
            if (targets === void 0) {
              targets = ts3.emptyArray;
            }
            if (variances === void 0) {
              variances = ts3.emptyArray;
            }
            if (sources.length !== targets.length && relation === identityRelation) {
              return 0;
            }
            var length = sources.length <= targets.length ? sources.length : targets.length;
            var result3 = -1;
            for (var i3 = 0; i3 < length; i3++) {
              var varianceFlags = i3 < variances.length ? variances[i3] : 1;
              var variance = varianceFlags & 7;
              if (variance !== 4) {
                var s2 = sources[i3];
                var t2 = targets[i3];
                var related = -1;
                if (varianceFlags & 8) {
                  related = relation === identityRelation ? isRelatedTo(s2, t2, false) : compareTypesIdentical(s2, t2);
                } else if (variance === 1) {
                  related = isRelatedTo(s2, t2, reportErrors, void 0, intersectionState);
                } else if (variance === 2) {
                  related = isRelatedTo(t2, s2, reportErrors, void 0, intersectionState);
                } else if (variance === 3) {
                  related = isRelatedTo(t2, s2, false);
                  if (!related) {
                    related = isRelatedTo(s2, t2, reportErrors, void 0, intersectionState);
                  }
                } else {
                  related = isRelatedTo(s2, t2, reportErrors, void 0, intersectionState);
                  if (related) {
                    related &= isRelatedTo(t2, s2, reportErrors, void 0, intersectionState);
                  }
                }
                if (!related) {
                  return 0;
                }
                result3 &= related;
              }
            }
            return result3;
          }
          function recursiveTypeRelatedTo(source2, target2, reportErrors, intersectionState) {
            if (overflow) {
              return 0;
            }
            var id = getRelationKey(source2, target2, intersectionState | (inPropertyCheck ? 16 : 0), relation);
            var entry = relation.get(id);
            if (entry !== void 0) {
              if (reportErrors && entry & 2 && !(entry & 4)) {
              } else {
                if (outofbandVarianceMarkerHandler) {
                  var saved = entry & 24;
                  if (saved & 8) {
                    instantiateType(source2, makeFunctionTypeMapper(reportUnmeasurableMarkers));
                  }
                  if (saved & 16) {
                    instantiateType(source2, makeFunctionTypeMapper(reportUnreliableMarkers));
                  }
                }
                return entry & 1 ? -1 : 0;
              }
            }
            if (!maybeKeys) {
              maybeKeys = [];
              sourceStack = [];
              targetStack = [];
            } else {
              var broadestEquivalentId = id.split(",").map(function(i4) {
                return i4.replace(/-\d+/g, function(_match, offset) {
                  var index = ts3.length(id.slice(0, offset).match(/[-=]/g) || void 0);
                  return "=" + index;
                });
              }).join(",");
              for (var i3 = 0; i3 < maybeCount; i3++) {
                if (id === maybeKeys[i3] || broadestEquivalentId === maybeKeys[i3]) {
                  return 3;
                }
              }
              if (depth === 100) {
                overflow = true;
                return 0;
              }
            }
            var maybeStart = maybeCount;
            maybeKeys[maybeCount] = id;
            maybeCount++;
            sourceStack[depth] = source2;
            targetStack[depth] = target2;
            depth++;
            var saveExpandingFlags = expandingFlags;
            if (!(expandingFlags & 1) && isDeeplyNestedType(source2, sourceStack, depth))
              expandingFlags |= 1;
            if (!(expandingFlags & 2) && isDeeplyNestedType(target2, targetStack, depth))
              expandingFlags |= 2;
            var originalHandler;
            var propagatingVarianceFlags = 0;
            if (outofbandVarianceMarkerHandler) {
              originalHandler = outofbandVarianceMarkerHandler;
              outofbandVarianceMarkerHandler = function(onlyUnreliable) {
                propagatingVarianceFlags |= onlyUnreliable ? 16 : 8;
                return originalHandler(onlyUnreliable);
              };
            }
            if (expandingFlags === 3) {
              ts3.tracing === null || ts3.tracing === void 0 ? void 0 : ts3.tracing.instant("checkTypes", "recursiveTypeRelatedTo_DepthLimit", {
                sourceId: source2.id,
                sourceIdStack: sourceStack.map(function(t2) {
                  return t2.id;
                }),
                targetId: target2.id,
                targetIdStack: targetStack.map(function(t2) {
                  return t2.id;
                }),
                depth
              });
            }
            var result3 = expandingFlags !== 3 ? structuredTypeRelatedTo(source2, target2, reportErrors, intersectionState) : 3;
            if (outofbandVarianceMarkerHandler) {
              outofbandVarianceMarkerHandler = originalHandler;
            }
            expandingFlags = saveExpandingFlags;
            depth--;
            if (result3) {
              if (result3 === -1 || depth === 0) {
                if (result3 === -1 || result3 === 3) {
                  for (var i3 = maybeStart; i3 < maybeCount; i3++) {
                    relation.set(maybeKeys[i3], 1 | propagatingVarianceFlags);
                  }
                }
                maybeCount = maybeStart;
              }
            } else {
              relation.set(id, (reportErrors ? 4 : 0) | 2 | propagatingVarianceFlags);
              maybeCount = maybeStart;
            }
            return result3;
          }
          function structuredTypeRelatedTo(source2, target2, reportErrors, intersectionState) {
            ts3.tracing === null || ts3.tracing === void 0 ? void 0 : ts3.tracing.push("checkTypes", "structuredTypeRelatedTo", { sourceId: source2.id, targetId: target2.id });
            var result3 = structuredTypeRelatedToWorker(source2, target2, reportErrors, intersectionState);
            ts3.tracing === null || ts3.tracing === void 0 ? void 0 : ts3.tracing.pop();
            return result3;
          }
          function structuredTypeRelatedToWorker(source2, target2, reportErrors, intersectionState) {
            if (intersectionState & 4) {
              return propertiesRelatedTo(source2, target2, reportErrors, void 0, 0);
            }
            if (intersectionState & 8) {
              if (source2.flags & 1048576) {
                return relation === comparableRelation ? someTypeRelatedToType(source2, target2, reportErrors && !(source2.flags & 131068), intersectionState & ~8) : eachTypeRelatedToType(source2, target2, reportErrors && !(source2.flags & 131068), intersectionState & ~8);
              }
              if (target2.flags & 1048576) {
                return typeRelatedToSomeType(getRegularTypeOfObjectLiteral(source2), target2, reportErrors && !(source2.flags & 131068) && !(target2.flags & 131068));
              }
              if (target2.flags & 2097152) {
                return typeRelatedToEachType(getRegularTypeOfObjectLiteral(source2), target2, reportErrors, 2);
              }
              if (relation === comparableRelation && target2.flags & 131068) {
                var constraints = ts3.sameMap(source2.types, function(t2) {
                  return t2.flags & 131068 ? t2 : getBaseConstraintOfType(t2) || unknownType;
                });
                if (constraints !== source2.types) {
                  source2 = getIntersectionType(constraints);
                  if (!(source2.flags & 2097152)) {
                    return isRelatedTo(source2, target2, false);
                  }
                }
              }
              return someTypeRelatedToType(source2, target2, false, 1);
            }
            var flags = source2.flags & target2.flags;
            if (relation === identityRelation && !(flags & 524288)) {
              if (flags & 4194304) {
                return isRelatedTo(source2.type, target2.type, false);
              }
              var result_8 = 0;
              if (flags & 8388608) {
                if (result_8 = isRelatedTo(source2.objectType, target2.objectType, false)) {
                  if (result_8 &= isRelatedTo(source2.indexType, target2.indexType, false)) {
                    return result_8;
                  }
                }
              }
              if (flags & 16777216) {
                if (source2.root.isDistributive === target2.root.isDistributive) {
                  if (result_8 = isRelatedTo(source2.checkType, target2.checkType, false)) {
                    if (result_8 &= isRelatedTo(source2.extendsType, target2.extendsType, false)) {
                      if (result_8 &= isRelatedTo(getTrueTypeFromConditionalType(source2), getTrueTypeFromConditionalType(target2), false)) {
                        if (result_8 &= isRelatedTo(getFalseTypeFromConditionalType(source2), getFalseTypeFromConditionalType(target2), false)) {
                          return result_8;
                        }
                      }
                    }
                  }
                }
              }
              if (flags & 33554432) {
                return isRelatedTo(source2.substitute, target2.substitute, false);
              }
              return 0;
            }
            var result3;
            var originalErrorInfo;
            var varianceCheckFailed = false;
            var saveErrorInfo = captureErrorCalculationState();
            if (source2.flags & (524288 | 16777216) && source2.aliasSymbol && source2.aliasTypeArguments && source2.aliasSymbol === target2.aliasSymbol && !(source2.aliasTypeArgumentsContainsMarker || target2.aliasTypeArgumentsContainsMarker)) {
              var variances = getAliasVariances(source2.aliasSymbol);
              if (variances === ts3.emptyArray) {
                return 1;
              }
              var varianceResult = relateVariances(source2.aliasTypeArguments, target2.aliasTypeArguments, variances, intersectionState);
              if (varianceResult !== void 0) {
                return varianceResult;
              }
            }
            if (isSingleElementGenericTupleType(source2) && !source2.target.readonly && (result3 = isRelatedTo(getTypeArguments(source2)[0], target2)) || isSingleElementGenericTupleType(target2) && (target2.target.readonly || isMutableArrayOrTuple(getBaseConstraintOfType(source2) || source2)) && (result3 = isRelatedTo(source2, getTypeArguments(target2)[0]))) {
              return result3;
            }
            if (target2.flags & 262144) {
              if (ts3.getObjectFlags(source2) & 32 && !source2.declaration.nameType && isRelatedTo(getIndexType(target2), getConstraintTypeFromMappedType(source2))) {
                if (!(getMappedTypeModifiers(source2) & 4)) {
                  var templateType = getTemplateTypeFromMappedType(source2);
                  var indexedAccessType = getIndexedAccessType(target2, getTypeParameterFromMappedType(source2));
                  if (result3 = isRelatedTo(templateType, indexedAccessType, reportErrors)) {
                    return result3;
                  }
                }
              }
            } else if (target2.flags & 4194304) {
              var targetType = target2.type;
              if (source2.flags & 4194304) {
                if (result3 = isRelatedTo(targetType, source2.type, false)) {
                  return result3;
                }
              }
              if (isTupleType(targetType)) {
                if (result3 = isRelatedTo(source2, getKnownKeysOfTupleType(targetType), reportErrors)) {
                  return result3;
                }
              } else {
                var constraint = getSimplifiedTypeOrConstraint(targetType);
                if (constraint) {
                  if (isRelatedTo(source2, getIndexType(constraint, target2.stringsOnly), reportErrors) === -1) {
                    return -1;
                  }
                }
              }
            } else if (target2.flags & 8388608) {
              if (source2.flags & 8388608) {
                if (result3 = isRelatedTo(source2.objectType, target2.objectType, reportErrors)) {
                  result3 &= isRelatedTo(source2.indexType, target2.indexType, reportErrors);
                }
                if (result3) {
                  resetErrorInfo(saveErrorInfo);
                  return result3;
                }
                if (reportErrors) {
                  originalErrorInfo = errorInfo;
                }
              }
              if (relation === assignableRelation || relation === comparableRelation) {
                var objectType = target2.objectType;
                var indexType = target2.indexType;
                var baseObjectType = getBaseConstraintOfType(objectType) || objectType;
                var baseIndexType = getBaseConstraintOfType(indexType) || indexType;
                if (!isGenericObjectType(baseObjectType) && !isGenericIndexType(baseIndexType)) {
                  var accessFlags = 2 | (baseObjectType !== objectType ? 1 : 0);
                  var constraint = getIndexedAccessTypeOrUndefined(baseObjectType, baseIndexType, target2.noUncheckedIndexedAccessCandidate, void 0, accessFlags);
                  if (constraint) {
                    if (reportErrors && originalErrorInfo) {
                      resetErrorInfo(saveErrorInfo);
                    }
                    if (result3 = isRelatedTo(source2, constraint, reportErrors)) {
                      return result3;
                    }
                    if (reportErrors && originalErrorInfo && errorInfo) {
                      errorInfo = countMessageChainBreadth([originalErrorInfo]) <= countMessageChainBreadth([errorInfo]) ? originalErrorInfo : errorInfo;
                    }
                  }
                }
              }
              if (reportErrors) {
                originalErrorInfo = void 0;
              }
            } else if (isGenericMappedType(target2) && !target2.declaration.nameType) {
              var template = getTemplateTypeFromMappedType(target2);
              var modifiers = getMappedTypeModifiers(target2);
              if (!(modifiers & 8)) {
                if (template.flags & 8388608 && template.objectType === source2 && template.indexType === getTypeParameterFromMappedType(target2)) {
                  return -1;
                }
                if (!isGenericMappedType(source2)) {
                  var targetConstraint = getConstraintTypeFromMappedType(target2);
                  var sourceKeys = getIndexType(source2, void 0, true);
                  var includeOptional = modifiers & 4;
                  var filteredByApplicability = includeOptional ? intersectTypes(targetConstraint, sourceKeys) : void 0;
                  if (includeOptional ? !(filteredByApplicability.flags & 131072) : isRelatedTo(targetConstraint, sourceKeys)) {
                    var templateType = getTemplateTypeFromMappedType(target2);
                    var typeParameter = getTypeParameterFromMappedType(target2);
                    var nonNullComponent = extractTypesOfKind(templateType, ~98304);
                    if (nonNullComponent.flags & 8388608 && nonNullComponent.indexType === typeParameter) {
                      if (result3 = isRelatedTo(source2, nonNullComponent.objectType, reportErrors)) {
                        return result3;
                      }
                    } else {
                      var indexingType = filteredByApplicability ? getIntersectionType([filteredByApplicability, typeParameter]) : typeParameter;
                      var indexedAccessType = getIndexedAccessType(source2, indexingType);
                      if (result3 = isRelatedTo(indexedAccessType, templateType, reportErrors)) {
                        return result3;
                      }
                    }
                  }
                  originalErrorInfo = errorInfo;
                  resetErrorInfo(saveErrorInfo);
                }
              }
            } else if (target2.flags & 16777216) {
              var c2 = target2;
              var skipTrue = !isTypeAssignableTo(getPermissiveInstantiation(c2.checkType), getPermissiveInstantiation(c2.extendsType));
              var skipFalse = !skipTrue && isConditionalTypeAlwaysTrueDisregardingInferTypes(c2);
              var distributionMapper = void 0;
              var checkVar = getActualTypeVariable(c2.root.checkType);
              if (c2.root.isDistributive && checkVar.flags & 262144) {
                var newParam = cloneTypeParameter(checkVar);
                distributionMapper = prependTypeMapping(checkVar, newParam, c2.mapper);
                newParam.mapper = distributionMapper;
              }
              var localResult = void 0;
              if (skipTrue || (localResult = isRelatedTo(source2, distributionMapper ? instantiateType(getTypeFromTypeNode(c2.root.node.trueType), distributionMapper) : getTrueTypeFromConditionalType(c2), false))) {
                if (!skipFalse) {
                  localResult = (localResult || 3) & isRelatedTo(source2, distributionMapper ? instantiateType(getTypeFromTypeNode(c2.root.node.falseType), distributionMapper) : getFalseTypeFromConditionalType(c2), false);
                }
              }
              if (localResult) {
                resetErrorInfo(saveErrorInfo);
                return localResult;
              }
            } else if (target2.flags & 134217728) {
              if (source2.flags & 134217728) {
                instantiateType(source2, makeFunctionTypeMapper(reportUnreliableMarkers));
              }
              var result_9 = inferTypesFromTemplateLiteralType(source2, target2);
              if (result_9 && ts3.every(result_9, function(r2, i3) {
                return isValidTypeForTemplateLiteralPlaceholder(r2, target2.types[i3]);
              })) {
                return -1;
              }
            }
            if (source2.flags & 8650752) {
              if (!(source2.flags & 8388608 && target2.flags & 8388608)) {
                var constraint = getConstraintOfType(source2);
                if (!constraint || source2.flags & 262144 && constraint.flags & 1) {
                  if (result3 = isRelatedTo(emptyObjectType, extractTypesOfKind(target2, ~67108864))) {
                    resetErrorInfo(saveErrorInfo);
                    return result3;
                  }
                } else if (result3 = isRelatedTo(constraint, target2, false, void 0, intersectionState)) {
                  resetErrorInfo(saveErrorInfo);
                  return result3;
                } else if (result3 = isRelatedTo(getTypeWithThisArgument(constraint, source2), target2, reportErrors && !(target2.flags & source2.flags & 262144), void 0, intersectionState)) {
                  resetErrorInfo(saveErrorInfo);
                  return result3;
                }
              }
            } else if (source2.flags & 4194304) {
              if (result3 = isRelatedTo(keyofConstraintType, target2, reportErrors)) {
                resetErrorInfo(saveErrorInfo);
                return result3;
              }
            } else if (source2.flags & 134217728) {
              if (!(target2.flags & 134217728)) {
                var baseConstraint = getBaseConstraintOfType(source2);
                var constraint = baseConstraint && baseConstraint !== source2 ? baseConstraint : stringType;
                if (result3 = isRelatedTo(constraint, target2, reportErrors)) {
                  resetErrorInfo(saveErrorInfo);
                  return result3;
                }
              }
            } else if (source2.flags & 268435456) {
              if (target2.flags & 268435456 && source2.symbol === target2.symbol) {
                if (result3 = isRelatedTo(source2.type, target2.type, reportErrors)) {
                  resetErrorInfo(saveErrorInfo);
                  return result3;
                }
              } else {
                var constraint = getBaseConstraintOfType(source2);
                if (constraint && (result3 = isRelatedTo(constraint, target2, reportErrors))) {
                  resetErrorInfo(saveErrorInfo);
                  return result3;
                }
              }
            } else if (source2.flags & 16777216) {
              if (target2.flags & 16777216) {
                var sourceParams = source2.root.inferTypeParameters;
                var sourceExtends = source2.extendsType;
                var mapper = void 0;
                if (sourceParams) {
                  var ctx = createInferenceContext(sourceParams, void 0, 0, isRelatedTo);
                  inferTypes(ctx.inferences, target2.extendsType, sourceExtends, 512 | 1024);
                  sourceExtends = instantiateType(sourceExtends, ctx.mapper);
                  mapper = ctx.mapper;
                }
                if (isTypeIdenticalTo(sourceExtends, target2.extendsType) && (isRelatedTo(source2.checkType, target2.checkType) || isRelatedTo(target2.checkType, source2.checkType))) {
                  if (result3 = isRelatedTo(instantiateType(getTrueTypeFromConditionalType(source2), mapper), getTrueTypeFromConditionalType(target2), reportErrors)) {
                    result3 &= isRelatedTo(getFalseTypeFromConditionalType(source2), getFalseTypeFromConditionalType(target2), reportErrors);
                  }
                  if (result3) {
                    resetErrorInfo(saveErrorInfo);
                    return result3;
                  }
                }
              } else {
                var distributiveConstraint = getConstraintOfDistributiveConditionalType(source2);
                if (distributiveConstraint) {
                  if (result3 = isRelatedTo(distributiveConstraint, target2, reportErrors)) {
                    resetErrorInfo(saveErrorInfo);
                    return result3;
                  }
                }
              }
              var defaultConstraint = getDefaultConstraintOfConditionalType(source2);
              if (defaultConstraint) {
                if (result3 = isRelatedTo(defaultConstraint, target2, reportErrors)) {
                  resetErrorInfo(saveErrorInfo);
                  return result3;
                }
              }
            } else {
              if (relation !== subtypeRelation && relation !== strictSubtypeRelation && isPartialMappedType(target2) && isEmptyObjectType(source2)) {
                return -1;
              }
              if (isGenericMappedType(target2)) {
                if (isGenericMappedType(source2)) {
                  if (result3 = mappedTypeRelatedTo(source2, target2, reportErrors)) {
                    resetErrorInfo(saveErrorInfo);
                    return result3;
                  }
                }
                return 0;
              }
              var sourceIsPrimitive = !!(source2.flags & 131068);
              if (relation !== identityRelation) {
                source2 = getApparentType(source2);
              } else if (isGenericMappedType(source2)) {
                return 0;
              }
              if (ts3.getObjectFlags(source2) & 4 && ts3.getObjectFlags(target2) & 4 && source2.target === target2.target && !(ts3.getObjectFlags(source2) & 4096 || ts3.getObjectFlags(target2) & 4096)) {
                var variances = getVariances(source2.target);
                if (variances === ts3.emptyArray) {
                  return 1;
                }
                var varianceResult = relateVariances(getTypeArguments(source2), getTypeArguments(target2), variances, intersectionState);
                if (varianceResult !== void 0) {
                  return varianceResult;
                }
              } else if (isReadonlyArrayType(target2) ? isArrayType(source2) || isTupleType(source2) : isArrayType(target2) && isTupleType(source2) && !source2.target.readonly) {
                if (relation !== identityRelation) {
                  return isRelatedTo(getIndexTypeOfType(source2, 1) || anyType, getIndexTypeOfType(target2, 1) || anyType, reportErrors);
                } else {
                  return 0;
                }
              } else if ((relation === subtypeRelation || relation === strictSubtypeRelation) && isEmptyObjectType(target2) && ts3.getObjectFlags(target2) & 16384 && !isEmptyObjectType(source2)) {
                return 0;
              }
              if (source2.flags & (524288 | 2097152) && target2.flags & 524288) {
                var reportStructuralErrors = reportErrors && errorInfo === saveErrorInfo.errorInfo && !sourceIsPrimitive;
                result3 = propertiesRelatedTo(source2, target2, reportStructuralErrors, void 0, intersectionState);
                if (result3) {
                  result3 &= signaturesRelatedTo(source2, target2, 0, reportStructuralErrors);
                  if (result3) {
                    result3 &= signaturesRelatedTo(source2, target2, 1, reportStructuralErrors);
                    if (result3) {
                      result3 &= indexTypesRelatedTo(source2, target2, 0, sourceIsPrimitive, reportStructuralErrors, intersectionState);
                      if (result3) {
                        result3 &= indexTypesRelatedTo(source2, target2, 1, sourceIsPrimitive, reportStructuralErrors, intersectionState);
                      }
                    }
                  }
                }
                if (varianceCheckFailed && result3) {
                  errorInfo = originalErrorInfo || errorInfo || saveErrorInfo.errorInfo;
                } else if (result3) {
                  return result3;
                }
              }
              if (source2.flags & (524288 | 2097152) && target2.flags & 1048576) {
                var objectOnlyTarget = extractTypesOfKind(target2, 524288 | 2097152 | 33554432);
                if (objectOnlyTarget.flags & 1048576) {
                  var result_10 = typeRelatedToDiscriminatedType(source2, objectOnlyTarget);
                  if (result_10) {
                    return result_10;
                  }
                }
              }
            }
            return 0;
            function countMessageChainBreadth(info) {
              if (!info)
                return 0;
              return ts3.reduceLeft(info, function(value, chain2) {
                return value + 1 + countMessageChainBreadth(chain2.next);
              }, 0);
            }
            function relateVariances(sourceTypeArguments, targetTypeArguments, variances2, intersectionState2) {
              if (result3 = typeArgumentsRelatedTo(sourceTypeArguments, targetTypeArguments, variances2, reportErrors, intersectionState2)) {
                return result3;
              }
              if (ts3.some(variances2, function(v) {
                return !!(v & 24);
              })) {
                originalErrorInfo = void 0;
                resetErrorInfo(saveErrorInfo);
                return void 0;
              }
              var allowStructuralFallback = targetTypeArguments && hasCovariantVoidArgument(targetTypeArguments, variances2);
              varianceCheckFailed = !allowStructuralFallback;
              if (variances2 !== ts3.emptyArray && !allowStructuralFallback) {
                if (varianceCheckFailed && !(reportErrors && ts3.some(variances2, function(v) {
                  return (v & 7) === 0;
                }))) {
                  return 0;
                }
                originalErrorInfo = errorInfo;
                resetErrorInfo(saveErrorInfo);
              }
            }
          }
          function reportUnmeasurableMarkers(p) {
            if (outofbandVarianceMarkerHandler && (p === markerSuperType || p === markerSubType || p === markerOtherType)) {
              outofbandVarianceMarkerHandler(false);
            }
            return p;
          }
          function reportUnreliableMarkers(p) {
            if (outofbandVarianceMarkerHandler && (p === markerSuperType || p === markerSubType || p === markerOtherType)) {
              outofbandVarianceMarkerHandler(true);
            }
            return p;
          }
          function mappedTypeRelatedTo(source2, target2, reportErrors) {
            var modifiersRelated = relation === comparableRelation || (relation === identityRelation ? getMappedTypeModifiers(source2) === getMappedTypeModifiers(target2) : getCombinedMappedTypeOptionality(source2) <= getCombinedMappedTypeOptionality(target2));
            if (modifiersRelated) {
              var result_11;
              var targetConstraint = getConstraintTypeFromMappedType(target2);
              var sourceConstraint = instantiateType(getConstraintTypeFromMappedType(source2), makeFunctionTypeMapper(getCombinedMappedTypeOptionality(source2) < 0 ? reportUnmeasurableMarkers : reportUnreliableMarkers));
              if (result_11 = isRelatedTo(targetConstraint, sourceConstraint, reportErrors)) {
                var mapper = createTypeMapper([getTypeParameterFromMappedType(source2)], [getTypeParameterFromMappedType(target2)]);
                if (instantiateType(getNameTypeFromMappedType(source2), mapper) === instantiateType(getNameTypeFromMappedType(target2), mapper)) {
                  return result_11 & isRelatedTo(instantiateType(getTemplateTypeFromMappedType(source2), mapper), getTemplateTypeFromMappedType(target2), reportErrors);
                }
              }
            }
            return 0;
          }
          function typeRelatedToDiscriminatedType(source2, target2) {
            var sourceProperties = getPropertiesOfType(source2);
            var sourcePropertiesFiltered = findDiscriminantProperties(sourceProperties, target2);
            if (!sourcePropertiesFiltered)
              return 0;
            var numCombinations = 1;
            for (var _i = 0, sourcePropertiesFiltered_1 = sourcePropertiesFiltered; _i < sourcePropertiesFiltered_1.length; _i++) {
              var sourceProperty = sourcePropertiesFiltered_1[_i];
              numCombinations *= countTypes(getTypeOfSymbol(sourceProperty));
              if (numCombinations > 25) {
                ts3.tracing === null || ts3.tracing === void 0 ? void 0 : ts3.tracing.instant("checkTypes", "typeRelatedToDiscriminatedType_DepthLimit", { sourceId: source2.id, targetId: target2.id, numCombinations });
                return 0;
              }
            }
            var sourceDiscriminantTypes = new Array(sourcePropertiesFiltered.length);
            var excludedProperties = new ts3.Set();
            for (var i3 = 0; i3 < sourcePropertiesFiltered.length; i3++) {
              var sourceProperty = sourcePropertiesFiltered[i3];
              var sourcePropertyType = getTypeOfSymbol(sourceProperty);
              sourceDiscriminantTypes[i3] = sourcePropertyType.flags & 1048576 ? sourcePropertyType.types : [sourcePropertyType];
              excludedProperties.add(sourceProperty.escapedName);
            }
            var discriminantCombinations = ts3.cartesianProduct(sourceDiscriminantTypes);
            var matchingTypes = [];
            var _loop_17 = function(combination2) {
              var hasMatch = false;
              outer:
                for (var _c = 0, _d = target2.types; _c < _d.length; _c++) {
                  var type4 = _d[_c];
                  var _loop_18 = function(i5) {
                    var sourceProperty2 = sourcePropertiesFiltered[i5];
                    var targetProperty = getPropertyOfType(type4, sourceProperty2.escapedName);
                    if (!targetProperty)
                      return "continue-outer";
                    if (sourceProperty2 === targetProperty)
                      return "continue";
                    var related = propertyRelatedTo(source2, target2, sourceProperty2, targetProperty, function(_) {
                      return combination2[i5];
                    }, false, 0, strictNullChecks || relation === comparableRelation);
                    if (!related) {
                      return "continue-outer";
                    }
                  };
                  for (var i4 = 0; i4 < sourcePropertiesFiltered.length; i4++) {
                    var state_7 = _loop_18(i4);
                    switch (state_7) {
                      case "continue-outer":
                        continue outer;
                    }
                  }
                  ts3.pushIfUnique(matchingTypes, type4, ts3.equateValues);
                  hasMatch = true;
                }
              if (!hasMatch) {
                return { value: 0 };
              }
            };
            for (var _a2 = 0, discriminantCombinations_1 = discriminantCombinations; _a2 < discriminantCombinations_1.length; _a2++) {
              var combination = discriminantCombinations_1[_a2];
              var state_6 = _loop_17(combination);
              if (typeof state_6 === "object")
                return state_6.value;
            }
            var result3 = -1;
            for (var _b = 0, matchingTypes_1 = matchingTypes; _b < matchingTypes_1.length; _b++) {
              var type3 = matchingTypes_1[_b];
              result3 &= propertiesRelatedTo(source2, type3, false, excludedProperties, 0);
              if (result3) {
                result3 &= signaturesRelatedTo(source2, type3, 0, false);
                if (result3) {
                  result3 &= signaturesRelatedTo(source2, type3, 1, false);
                  if (result3) {
                    result3 &= indexTypesRelatedTo(source2, type3, 0, false, false, 0);
                    if (result3 && !(isTupleType(source2) && isTupleType(type3))) {
                      result3 &= indexTypesRelatedTo(source2, type3, 1, false, false, 0);
                    }
                  }
                }
              }
              if (!result3) {
                return result3;
              }
            }
            return result3;
          }
          function excludeProperties(properties, excludedProperties) {
            if (!excludedProperties || properties.length === 0)
              return properties;
            var result3;
            for (var i3 = 0; i3 < properties.length; i3++) {
              if (!excludedProperties.has(properties[i3].escapedName)) {
                if (result3) {
                  result3.push(properties[i3]);
                }
              } else if (!result3) {
                result3 = properties.slice(0, i3);
              }
            }
            return result3 || properties;
          }
          function isPropertySymbolTypeRelated(sourceProp, targetProp, getTypeOfSourceProperty, reportErrors, intersectionState) {
            var targetIsOptional = strictNullChecks && !!(ts3.getCheckFlags(targetProp) & 48);
            var source2 = getTypeOfSourceProperty(sourceProp);
            if (ts3.getCheckFlags(targetProp) & 65536 && !getSymbolLinks(targetProp).type) {
              var links2 = getSymbolLinks(targetProp);
              ts3.Debug.assertIsDefined(links2.deferralParent);
              ts3.Debug.assertIsDefined(links2.deferralConstituents);
              var unionParent = !!(links2.deferralParent.flags & 1048576);
              var result_12 = unionParent ? 0 : -1;
              var targetTypes = links2.deferralConstituents;
              for (var _i = 0, targetTypes_3 = targetTypes; _i < targetTypes_3.length; _i++) {
                var targetType = targetTypes_3[_i];
                var related = isRelatedTo(source2, targetType, false, void 0, unionParent ? 0 : 2);
                if (!unionParent) {
                  if (!related) {
                    return isRelatedTo(source2, addOptionality(getTypeOfSymbol(targetProp), targetIsOptional), reportErrors);
                  }
                  result_12 &= related;
                } else {
                  if (related) {
                    return related;
                  }
                }
              }
              if (unionParent && !result_12 && targetIsOptional) {
                result_12 = isRelatedTo(source2, undefinedType);
              }
              if (unionParent && !result_12 && reportErrors) {
                return isRelatedTo(source2, addOptionality(getTypeOfSymbol(targetProp), targetIsOptional), reportErrors);
              }
              return result_12;
            } else {
              return isRelatedTo(source2, addOptionality(getTypeOfSymbol(targetProp), targetIsOptional), reportErrors, void 0, intersectionState);
            }
          }
          function propertyRelatedTo(source2, target2, sourceProp, targetProp, getTypeOfSourceProperty, reportErrors, intersectionState, skipOptional) {
            var sourcePropFlags = ts3.getDeclarationModifierFlagsFromSymbol(sourceProp);
            var targetPropFlags = ts3.getDeclarationModifierFlagsFromSymbol(targetProp);
            if (sourcePropFlags & 8 || targetPropFlags & 8) {
              if (sourceProp.valueDeclaration !== targetProp.valueDeclaration) {
                if (reportErrors) {
                  if (sourcePropFlags & 8 && targetPropFlags & 8) {
                    reportError(ts3.Diagnostics.Types_have_separate_declarations_of_a_private_property_0, symbolToString(targetProp));
                  } else {
                    reportError(ts3.Diagnostics.Property_0_is_private_in_type_1_but_not_in_type_2, symbolToString(targetProp), typeToString(sourcePropFlags & 8 ? source2 : target2), typeToString(sourcePropFlags & 8 ? target2 : source2));
                  }
                }
                return 0;
              }
            } else if (targetPropFlags & 16) {
              if (!isValidOverrideOf(sourceProp, targetProp)) {
                if (reportErrors) {
                  reportError(ts3.Diagnostics.Property_0_is_protected_but_type_1_is_not_a_class_derived_from_2, symbolToString(targetProp), typeToString(getDeclaringClass(sourceProp) || source2), typeToString(getDeclaringClass(targetProp) || target2));
                }
                return 0;
              }
            } else if (sourcePropFlags & 16) {
              if (reportErrors) {
                reportError(ts3.Diagnostics.Property_0_is_protected_in_type_1_but_public_in_type_2, symbolToString(targetProp), typeToString(source2), typeToString(target2));
              }
              return 0;
            }
            var related = isPropertySymbolTypeRelated(sourceProp, targetProp, getTypeOfSourceProperty, reportErrors, intersectionState);
            if (!related) {
              if (reportErrors) {
                reportIncompatibleError(ts3.Diagnostics.Types_of_property_0_are_incompatible, symbolToString(targetProp));
              }
              return 0;
            }
            if (!skipOptional && sourceProp.flags & 16777216 && !(targetProp.flags & 16777216)) {
              if (reportErrors) {
                reportError(ts3.Diagnostics.Property_0_is_optional_in_type_1_but_required_in_type_2, symbolToString(targetProp), typeToString(source2), typeToString(target2));
              }
              return 0;
            }
            return related;
          }
          function reportUnmatchedProperty(source2, target2, unmatchedProperty, requireOptionalProperties) {
            var shouldSkipElaboration = false;
            if (unmatchedProperty.valueDeclaration && ts3.isNamedDeclaration(unmatchedProperty.valueDeclaration) && ts3.isPrivateIdentifier(unmatchedProperty.valueDeclaration.name) && source2.symbol && source2.symbol.flags & 32) {
              var privateIdentifierDescription = unmatchedProperty.valueDeclaration.name.escapedText;
              var symbolTableKey = ts3.getSymbolNameForPrivateIdentifier(source2.symbol, privateIdentifierDescription);
              if (symbolTableKey && getPropertyOfType(source2, symbolTableKey)) {
                var sourceName = ts3.factory.getDeclarationName(source2.symbol.valueDeclaration);
                var targetName = ts3.factory.getDeclarationName(target2.symbol.valueDeclaration);
                reportError(ts3.Diagnostics.Property_0_in_type_1_refers_to_a_different_member_that_cannot_be_accessed_from_within_type_2, diagnosticName(privateIdentifierDescription), diagnosticName(sourceName.escapedText === "" ? anon : sourceName), diagnosticName(targetName.escapedText === "" ? anon : targetName));
                return;
              }
            }
            var props = ts3.arrayFrom(getUnmatchedProperties(source2, target2, requireOptionalProperties, false));
            if (!headMessage || headMessage.code !== ts3.Diagnostics.Class_0_incorrectly_implements_interface_1.code && headMessage.code !== ts3.Diagnostics.Class_0_incorrectly_implements_class_1_Did_you_mean_to_extend_1_and_inherit_its_members_as_a_subclass.code) {
              shouldSkipElaboration = true;
            }
            if (props.length === 1) {
              var propName = symbolToString(unmatchedProperty);
              reportError.apply(void 0, __spreadArray([ts3.Diagnostics.Property_0_is_missing_in_type_1_but_required_in_type_2, propName], getTypeNamesForErrorDisplay(source2, target2)));
              if (ts3.length(unmatchedProperty.declarations)) {
                associateRelatedInfo(ts3.createDiagnosticForNode(unmatchedProperty.declarations[0], ts3.Diagnostics._0_is_declared_here, propName));
              }
              if (shouldSkipElaboration && errorInfo) {
                overrideNextErrorInfo++;
              }
            } else if (tryElaborateArrayLikeErrors(source2, target2, false)) {
              if (props.length > 5) {
                reportError(ts3.Diagnostics.Type_0_is_missing_the_following_properties_from_type_1_Colon_2_and_3_more, typeToString(source2), typeToString(target2), ts3.map(props.slice(0, 4), function(p) {
                  return symbolToString(p);
                }).join(", "), props.length - 4);
              } else {
                reportError(ts3.Diagnostics.Type_0_is_missing_the_following_properties_from_type_1_Colon_2, typeToString(source2), typeToString(target2), ts3.map(props, function(p) {
                  return symbolToString(p);
                }).join(", "));
              }
              if (shouldSkipElaboration && errorInfo) {
                overrideNextErrorInfo++;
              }
            }
          }
          function propertiesRelatedTo(source2, target2, reportErrors, excludedProperties, intersectionState) {
            if (relation === identityRelation) {
              return propertiesIdenticalTo(source2, target2, excludedProperties);
            }
            var result3 = -1;
            if (isTupleType(target2)) {
              if (isArrayType(source2) || isTupleType(source2)) {
                if (!target2.target.readonly && (isReadonlyArrayType(source2) || isTupleType(source2) && source2.target.readonly)) {
                  return 0;
                }
                var sourceArity = getTypeReferenceArity(source2);
                var targetArity = getTypeReferenceArity(target2);
                var sourceRestFlag = isTupleType(source2) ? source2.target.combinedFlags & 4 : 4;
                var targetRestFlag = target2.target.combinedFlags & 4;
                var sourceMinLength = isTupleType(source2) ? source2.target.minLength : 0;
                var targetMinLength = target2.target.minLength;
                if (!sourceRestFlag && sourceArity < targetMinLength) {
                  if (reportErrors) {
                    reportError(ts3.Diagnostics.Source_has_0_element_s_but_target_requires_1, sourceArity, targetMinLength);
                  }
                  return 0;
                }
                if (!targetRestFlag && targetArity < sourceMinLength) {
                  if (reportErrors) {
                    reportError(ts3.Diagnostics.Source_has_0_element_s_but_target_allows_only_1, sourceMinLength, targetArity);
                  }
                  return 0;
                }
                if (!targetRestFlag && sourceRestFlag) {
                  if (reportErrors) {
                    if (sourceMinLength < targetMinLength) {
                      reportError(ts3.Diagnostics.Target_requires_0_element_s_but_source_may_have_fewer, targetMinLength);
                    } else {
                      reportError(ts3.Diagnostics.Target_allows_only_0_element_s_but_source_may_have_more, targetArity);
                    }
                  }
                  return 0;
                }
                var sourceTypeArguments = getTypeArguments(source2);
                var targetTypeArguments = getTypeArguments(target2);
                var startCount = Math.min(isTupleType(source2) ? getStartElementCount(source2.target, 11) : 0, getStartElementCount(target2.target, 11));
                var endCount = Math.min(isTupleType(source2) ? getEndElementCount(source2.target, 11) : 0, targetRestFlag ? getEndElementCount(target2.target, 11) : 0);
                var canExcludeDiscriminants = !!excludedProperties;
                for (var i3 = 0; i3 < targetArity; i3++) {
                  var sourceIndex = i3 < targetArity - endCount ? i3 : i3 + sourceArity - targetArity;
                  var sourceFlags = isTupleType(source2) && (i3 < startCount || i3 >= targetArity - endCount) ? source2.target.elementFlags[sourceIndex] : 4;
                  var targetFlags = target2.target.elementFlags[i3];
                  if (targetFlags & 8 && !(sourceFlags & 8)) {
                    if (reportErrors) {
                      reportError(ts3.Diagnostics.Source_provides_no_match_for_variadic_element_at_position_0_in_target, i3);
                    }
                    return 0;
                  }
                  if (sourceFlags & 8 && !(targetFlags & 12)) {
                    if (reportErrors) {
                      reportError(ts3.Diagnostics.Variadic_element_at_position_0_in_source_does_not_match_element_at_position_1_in_target, sourceIndex, i3);
                    }
                    return 0;
                  }
                  if (targetFlags & 1 && !(sourceFlags & 1)) {
                    if (reportErrors) {
                      reportError(ts3.Diagnostics.Source_provides_no_match_for_required_element_at_position_0_in_target, i3);
                    }
                    return 0;
                  }
                  if (canExcludeDiscriminants) {
                    if (sourceFlags & 12 || targetFlags & 12) {
                      canExcludeDiscriminants = false;
                    }
                    if (canExcludeDiscriminants && (excludedProperties === null || excludedProperties === void 0 ? void 0 : excludedProperties.has("" + i3))) {
                      continue;
                    }
                  }
                  var sourceType = !isTupleType(source2) ? sourceTypeArguments[0] : i3 < startCount || i3 >= targetArity - endCount ? sourceTypeArguments[sourceIndex] : getElementTypeOfSliceOfTupleType(source2, startCount, endCount) || neverType;
                  var targetType = targetTypeArguments[i3];
                  var targetCheckType = sourceFlags & 8 && targetFlags & 4 ? createArrayType(targetType) : targetType;
                  var related = isRelatedTo(sourceType, targetCheckType, reportErrors, void 0, intersectionState);
                  if (!related) {
                    if (reportErrors) {
                      if (i3 < startCount || i3 >= targetArity - endCount || sourceArity - startCount - endCount === 1) {
                        reportIncompatibleError(ts3.Diagnostics.Type_at_position_0_in_source_is_not_compatible_with_type_at_position_1_in_target, sourceIndex, i3);
                      } else {
                        reportIncompatibleError(ts3.Diagnostics.Type_at_positions_0_through_1_in_source_is_not_compatible_with_type_at_position_2_in_target, startCount, sourceArity - endCount - 1, i3);
                      }
                    }
                    return 0;
                  }
                  result3 &= related;
                }
                return result3;
              }
              if (target2.target.combinedFlags & 12) {
                return 0;
              }
            }
            var requireOptionalProperties = (relation === subtypeRelation || relation === strictSubtypeRelation) && !isObjectLiteralType(source2) && !isEmptyArrayLiteralType(source2) && !isTupleType(source2);
            var unmatchedProperty = getUnmatchedProperty(source2, target2, requireOptionalProperties, false);
            if (unmatchedProperty) {
              if (reportErrors) {
                reportUnmatchedProperty(source2, target2, unmatchedProperty, requireOptionalProperties);
              }
              return 0;
            }
            if (isObjectLiteralType(target2)) {
              for (var _i = 0, _a2 = excludeProperties(getPropertiesOfType(source2), excludedProperties); _i < _a2.length; _i++) {
                var sourceProp = _a2[_i];
                if (!getPropertyOfObjectType(target2, sourceProp.escapedName)) {
                  var sourceType = getTypeOfSymbol(sourceProp);
                  if (!(sourceType === undefinedType || sourceType === undefinedWideningType || sourceType === optionalType)) {
                    if (reportErrors) {
                      reportError(ts3.Diagnostics.Property_0_does_not_exist_on_type_1, symbolToString(sourceProp), typeToString(target2));
                    }
                    return 0;
                  }
                }
              }
            }
            var properties = getPropertiesOfType(target2);
            var numericNamesOnly = isTupleType(source2) && isTupleType(target2);
            for (var _b = 0, _c = excludeProperties(properties, excludedProperties); _b < _c.length; _b++) {
              var targetProp = _c[_b];
              var name = targetProp.escapedName;
              if (!(targetProp.flags & 4194304) && (!numericNamesOnly || isNumericLiteralName(name) || name === "length")) {
                var sourceProp = getPropertyOfType(source2, name);
                if (sourceProp && sourceProp !== targetProp) {
                  var related = propertyRelatedTo(source2, target2, sourceProp, targetProp, getTypeOfSymbol, reportErrors, intersectionState, relation === comparableRelation);
                  if (!related) {
                    return 0;
                  }
                  result3 &= related;
                }
              }
            }
            return result3;
          }
          function propertiesIdenticalTo(source2, target2, excludedProperties) {
            if (!(source2.flags & 524288 && target2.flags & 524288)) {
              return 0;
            }
            var sourceProperties = excludeProperties(getPropertiesOfObjectType(source2), excludedProperties);
            var targetProperties = excludeProperties(getPropertiesOfObjectType(target2), excludedProperties);
            if (sourceProperties.length !== targetProperties.length) {
              return 0;
            }
            var result3 = -1;
            for (var _i = 0, sourceProperties_1 = sourceProperties; _i < sourceProperties_1.length; _i++) {
              var sourceProp = sourceProperties_1[_i];
              var targetProp = getPropertyOfObjectType(target2, sourceProp.escapedName);
              if (!targetProp) {
                return 0;
              }
              var related = compareProperties(sourceProp, targetProp, isRelatedTo);
              if (!related) {
                return 0;
              }
              result3 &= related;
            }
            return result3;
          }
          function signaturesRelatedTo(source2, target2, kind, reportErrors) {
            var _a2, _b;
            if (relation === identityRelation) {
              return signaturesIdenticalTo(source2, target2, kind);
            }
            if (target2 === anyFunctionType || source2 === anyFunctionType) {
              return -1;
            }
            var sourceIsJSConstructor = source2.symbol && isJSConstructor(source2.symbol.valueDeclaration);
            var targetIsJSConstructor = target2.symbol && isJSConstructor(target2.symbol.valueDeclaration);
            var sourceSignatures = getSignaturesOfType(source2, sourceIsJSConstructor && kind === 1 ? 0 : kind);
            var targetSignatures = getSignaturesOfType(target2, targetIsJSConstructor && kind === 1 ? 0 : kind);
            if (kind === 1 && sourceSignatures.length && targetSignatures.length) {
              var sourceIsAbstract = !!(sourceSignatures[0].flags & 4);
              var targetIsAbstract = !!(targetSignatures[0].flags & 4);
              if (sourceIsAbstract && !targetIsAbstract) {
                if (reportErrors) {
                  reportError(ts3.Diagnostics.Cannot_assign_an_abstract_constructor_type_to_a_non_abstract_constructor_type);
                }
                return 0;
              }
              if (!constructorVisibilitiesAreCompatible(sourceSignatures[0], targetSignatures[0], reportErrors)) {
                return 0;
              }
            }
            var result3 = -1;
            var saveErrorInfo = captureErrorCalculationState();
            var incompatibleReporter = kind === 1 ? reportIncompatibleConstructSignatureReturn : reportIncompatibleCallSignatureReturn;
            var sourceObjectFlags = ts3.getObjectFlags(source2);
            var targetObjectFlags = ts3.getObjectFlags(target2);
            if (sourceObjectFlags & 64 && targetObjectFlags & 64 && source2.symbol === target2.symbol) {
              for (var i3 = 0; i3 < targetSignatures.length; i3++) {
                var related = signatureRelatedTo(sourceSignatures[i3], targetSignatures[i3], true, reportErrors, incompatibleReporter(sourceSignatures[i3], targetSignatures[i3]));
                if (!related) {
                  return 0;
                }
                result3 &= related;
              }
            } else if (sourceSignatures.length === 1 && targetSignatures.length === 1) {
              var eraseGenerics = relation === comparableRelation || !!compilerOptions.noStrictGenericChecks;
              var sourceSignature = ts3.first(sourceSignatures);
              var targetSignature = ts3.first(targetSignatures);
              result3 = signatureRelatedTo(sourceSignature, targetSignature, eraseGenerics, reportErrors, incompatibleReporter(sourceSignature, targetSignature));
              if (!result3 && reportErrors && kind === 1 && sourceObjectFlags & targetObjectFlags && (((_a2 = targetSignature.declaration) === null || _a2 === void 0 ? void 0 : _a2.kind) === 167 || ((_b = sourceSignature.declaration) === null || _b === void 0 ? void 0 : _b.kind) === 167)) {
                var constructSignatureToString = function(signature) {
                  return signatureToString(signature, void 0, 262144, kind);
                };
                reportError(ts3.Diagnostics.Type_0_is_not_assignable_to_type_1, constructSignatureToString(sourceSignature), constructSignatureToString(targetSignature));
                reportError(ts3.Diagnostics.Types_of_construct_signatures_are_incompatible);
                return result3;
              }
            } else {
              outer:
                for (var _i = 0, targetSignatures_1 = targetSignatures; _i < targetSignatures_1.length; _i++) {
                  var t2 = targetSignatures_1[_i];
                  var shouldElaborateErrors = reportErrors;
                  for (var _c = 0, sourceSignatures_1 = sourceSignatures; _c < sourceSignatures_1.length; _c++) {
                    var s2 = sourceSignatures_1[_c];
                    var related = signatureRelatedTo(s2, t2, true, shouldElaborateErrors, incompatibleReporter(s2, t2));
                    if (related) {
                      result3 &= related;
                      resetErrorInfo(saveErrorInfo);
                      continue outer;
                    }
                    shouldElaborateErrors = false;
                  }
                  if (shouldElaborateErrors) {
                    reportError(ts3.Diagnostics.Type_0_provides_no_match_for_the_signature_1, typeToString(source2), signatureToString(t2, void 0, void 0, kind));
                  }
                  return 0;
                }
            }
            return result3;
          }
          function reportIncompatibleCallSignatureReturn(siga, sigb) {
            if (siga.parameters.length === 0 && sigb.parameters.length === 0) {
              return function(source2, target2) {
                return reportIncompatibleError(ts3.Diagnostics.Call_signatures_with_no_arguments_have_incompatible_return_types_0_and_1, typeToString(source2), typeToString(target2));
              };
            }
            return function(source2, target2) {
              return reportIncompatibleError(ts3.Diagnostics.Call_signature_return_types_0_and_1_are_incompatible, typeToString(source2), typeToString(target2));
            };
          }
          function reportIncompatibleConstructSignatureReturn(siga, sigb) {
            if (siga.parameters.length === 0 && sigb.parameters.length === 0) {
              return function(source2, target2) {
                return reportIncompatibleError(ts3.Diagnostics.Construct_signatures_with_no_arguments_have_incompatible_return_types_0_and_1, typeToString(source2), typeToString(target2));
              };
            }
            return function(source2, target2) {
              return reportIncompatibleError(ts3.Diagnostics.Construct_signature_return_types_0_and_1_are_incompatible, typeToString(source2), typeToString(target2));
            };
          }
          function signatureRelatedTo(source2, target2, erase, reportErrors, incompatibleReporter) {
            return compareSignaturesRelated(erase ? getErasedSignature(source2) : source2, erase ? getErasedSignature(target2) : target2, relation === strictSubtypeRelation ? 8 : 0, reportErrors, reportError, incompatibleReporter, isRelatedTo, makeFunctionTypeMapper(reportUnreliableMarkers));
          }
          function signaturesIdenticalTo(source2, target2, kind) {
            var sourceSignatures = getSignaturesOfType(source2, kind);
            var targetSignatures = getSignaturesOfType(target2, kind);
            if (sourceSignatures.length !== targetSignatures.length) {
              return 0;
            }
            var result3 = -1;
            for (var i3 = 0; i3 < sourceSignatures.length; i3++) {
              var related = compareSignaturesIdentical(sourceSignatures[i3], targetSignatures[i3], false, false, false, isRelatedTo);
              if (!related) {
                return 0;
              }
              result3 &= related;
            }
            return result3;
          }
          function eachPropertyRelatedTo(source2, target2, kind, reportErrors) {
            var result3 = -1;
            var props = source2.flags & 2097152 ? getPropertiesOfUnionOrIntersectionType(source2) : getPropertiesOfObjectType(source2);
            for (var _i = 0, props_2 = props; _i < props_2.length; _i++) {
              var prop = props_2[_i];
              if (isIgnoredJsxProperty(source2, prop)) {
                continue;
              }
              var nameType = getSymbolLinks(prop).nameType;
              if (nameType && nameType.flags & 8192) {
                continue;
              }
              if (kind === 0 || isNumericLiteralName(prop.escapedName)) {
                var propType = getTypeOfSymbol(prop);
                var type3 = propType.flags & 32768 || !(kind === 0 && prop.flags & 16777216) ? propType : getTypeWithFacts(propType, 524288);
                var related = isRelatedTo(type3, target2, reportErrors);
                if (!related) {
                  if (reportErrors) {
                    reportError(ts3.Diagnostics.Property_0_is_incompatible_with_index_signature, symbolToString(prop));
                  }
                  return 0;
                }
                result3 &= related;
              }
            }
            return result3;
          }
          function indexTypeRelatedTo(sourceType, targetType, reportErrors) {
            var related = isRelatedTo(sourceType, targetType, reportErrors);
            if (!related && reportErrors) {
              reportError(ts3.Diagnostics.Index_signatures_are_incompatible);
            }
            return related;
          }
          function indexTypesRelatedTo(source2, target2, kind, sourceIsPrimitive, reportErrors, intersectionState) {
            if (relation === identityRelation) {
              return indexTypesIdenticalTo(source2, target2, kind);
            }
            var targetType = getIndexTypeOfType(target2, kind);
            if (!targetType) {
              return -1;
            }
            if (targetType.flags & 1 && !sourceIsPrimitive) {
              var stringIndexType = kind === 0 ? targetType : getIndexTypeOfType(target2, 0);
              if (stringIndexType && stringIndexType.flags & 1) {
                return -1;
              }
            }
            if (isGenericMappedType(source2)) {
              return getIndexTypeOfType(target2, 0) ? isRelatedTo(getTemplateTypeFromMappedType(source2), targetType, reportErrors) : 0;
            }
            var indexType = getIndexTypeOfType(source2, kind) || kind === 1 && getIndexTypeOfType(source2, 0);
            if (indexType) {
              return indexTypeRelatedTo(indexType, targetType, reportErrors);
            }
            if (!(intersectionState & 1) && isObjectTypeWithInferableIndex(source2)) {
              var related = eachPropertyRelatedTo(source2, targetType, kind, reportErrors);
              if (related && kind === 0) {
                var numberIndexType = getIndexTypeOfType(source2, 1);
                if (numberIndexType) {
                  related &= indexTypeRelatedTo(numberIndexType, targetType, reportErrors);
                }
              }
              return related;
            }
            if (reportErrors) {
              reportError(ts3.Diagnostics.Index_signature_is_missing_in_type_0, typeToString(source2));
            }
            return 0;
          }
          function indexTypesIdenticalTo(source2, target2, indexKind) {
            var targetInfo = getIndexInfoOfType(target2, indexKind);
            var sourceInfo = getIndexInfoOfType(source2, indexKind);
            if (!sourceInfo && !targetInfo) {
              return -1;
            }
            if (sourceInfo && targetInfo && sourceInfo.isReadonly === targetInfo.isReadonly) {
              return isRelatedTo(sourceInfo.type, targetInfo.type);
            }
            return 0;
          }
          function constructorVisibilitiesAreCompatible(sourceSignature, targetSignature, reportErrors) {
            if (!sourceSignature.declaration || !targetSignature.declaration) {
              return true;
            }
            var sourceAccessibility = ts3.getSelectedEffectiveModifierFlags(sourceSignature.declaration, 24);
            var targetAccessibility = ts3.getSelectedEffectiveModifierFlags(targetSignature.declaration, 24);
            if (targetAccessibility === 8) {
              return true;
            }
            if (targetAccessibility === 16 && sourceAccessibility !== 8) {
              return true;
            }
            if (targetAccessibility !== 16 && !sourceAccessibility) {
              return true;
            }
            if (reportErrors) {
              reportError(ts3.Diagnostics.Cannot_assign_a_0_constructor_type_to_a_1_constructor_type, visibilityToString(sourceAccessibility), visibilityToString(targetAccessibility));
            }
            return false;
          }
        }
        function typeCouldHaveTopLevelSingletonTypes(type3) {
          if (type3.flags & 16) {
            return false;
          }
          if (type3.flags & 3145728) {
            return !!ts3.forEach(type3.types, typeCouldHaveTopLevelSingletonTypes);
          }
          if (type3.flags & 465829888) {
            var constraint = getConstraintOfType(type3);
            if (constraint && constraint !== type3) {
              return typeCouldHaveTopLevelSingletonTypes(constraint);
            }
          }
          return isUnitType(type3) || !!(type3.flags & 134217728);
        }
        function getBestMatchingType(source, target, isRelatedTo) {
          if (isRelatedTo === void 0) {
            isRelatedTo = compareTypesAssignable;
          }
          return findMatchingDiscriminantType(source, target, isRelatedTo, true) || findMatchingTypeReferenceOrTypeAliasReference(source, target) || findBestTypeForObjectLiteral(source, target) || findBestTypeForInvokable(source, target) || findMostOverlappyType(source, target);
        }
        function discriminateTypeByDiscriminableItems(target, discriminators, related, defaultValue, skipPartial) {
          var discriminable = target.types.map(function(_) {
            return void 0;
          });
          for (var _i = 0, discriminators_1 = discriminators; _i < discriminators_1.length; _i++) {
            var _a2 = discriminators_1[_i], getDiscriminatingType = _a2[0], propertyName = _a2[1];
            var targetProp = getUnionOrIntersectionProperty(target, propertyName);
            if (skipPartial && targetProp && ts3.getCheckFlags(targetProp) & 16) {
              continue;
            }
            var i3 = 0;
            for (var _b = 0, _c = target.types; _b < _c.length; _b++) {
              var type3 = _c[_b];
              var targetType = getTypeOfPropertyOfType(type3, propertyName);
              if (targetType && related(getDiscriminatingType(), targetType)) {
                discriminable[i3] = discriminable[i3] === void 0 ? true : discriminable[i3];
              } else {
                discriminable[i3] = false;
              }
              i3++;
            }
          }
          var match = discriminable.indexOf(true);
          if (match === -1) {
            return defaultValue;
          }
          var nextMatch = discriminable.indexOf(true, match + 1);
          while (nextMatch !== -1) {
            if (!isTypeIdenticalTo(target.types[match], target.types[nextMatch])) {
              return defaultValue;
            }
            nextMatch = discriminable.indexOf(true, nextMatch + 1);
          }
          return target.types[match];
        }
        function isWeakType(type3) {
          if (type3.flags & 524288) {
            var resolved = resolveStructuredTypeMembers(type3);
            return resolved.callSignatures.length === 0 && resolved.constructSignatures.length === 0 && !resolved.stringIndexInfo && !resolved.numberIndexInfo && resolved.properties.length > 0 && ts3.every(resolved.properties, function(p) {
              return !!(p.flags & 16777216);
            });
          }
          if (type3.flags & 2097152) {
            return ts3.every(type3.types, isWeakType);
          }
          return false;
        }
        function hasCommonProperties(source, target, isComparingJsxAttributes) {
          for (var _i = 0, _a2 = getPropertiesOfType(source); _i < _a2.length; _i++) {
            var prop = _a2[_i];
            if (isKnownProperty(target, prop.escapedName, isComparingJsxAttributes)) {
              return true;
            }
          }
          return false;
        }
        function getMarkerTypeReference(type3, source, target) {
          var result2 = createTypeReference(type3, ts3.map(type3.typeParameters, function(t2) {
            return t2 === source ? target : t2;
          }));
          result2.objectFlags |= 4096;
          return result2;
        }
        function getAliasVariances(symbol) {
          var links = getSymbolLinks(symbol);
          return getVariancesWorker(links.typeParameters, links, function(_links, param, marker) {
            var type3 = getTypeAliasInstantiation(symbol, instantiateTypes(links.typeParameters, makeUnaryTypeMapper(param, marker)));
            type3.aliasTypeArgumentsContainsMarker = true;
            return type3;
          });
        }
        function getVariancesWorker(typeParameters, cache, createMarkerType) {
          var _a2, _b, _c;
          if (typeParameters === void 0) {
            typeParameters = ts3.emptyArray;
          }
          var variances = cache.variances;
          if (!variances) {
            ts3.tracing === null || ts3.tracing === void 0 ? void 0 : ts3.tracing.push("checkTypes", "getVariancesWorker", { arity: typeParameters.length, id: (_c = (_a2 = cache.id) !== null && _a2 !== void 0 ? _a2 : (_b = cache.declaredType) === null || _b === void 0 ? void 0 : _b.id) !== null && _c !== void 0 ? _c : -1 });
            cache.variances = ts3.emptyArray;
            variances = [];
            var _loop_19 = function(tp2) {
              var unmeasurable = false;
              var unreliable = false;
              var oldHandler = outofbandVarianceMarkerHandler;
              outofbandVarianceMarkerHandler = function(onlyUnreliable) {
                return onlyUnreliable ? unreliable = true : unmeasurable = true;
              };
              var typeWithSuper = createMarkerType(cache, tp2, markerSuperType);
              var typeWithSub = createMarkerType(cache, tp2, markerSubType);
              var variance = (isTypeAssignableTo(typeWithSub, typeWithSuper) ? 1 : 0) | (isTypeAssignableTo(typeWithSuper, typeWithSub) ? 2 : 0);
              if (variance === 3 && isTypeAssignableTo(createMarkerType(cache, tp2, markerOtherType), typeWithSuper)) {
                variance = 4;
              }
              outofbandVarianceMarkerHandler = oldHandler;
              if (unmeasurable || unreliable) {
                if (unmeasurable) {
                  variance |= 8;
                }
                if (unreliable) {
                  variance |= 16;
                }
              }
              variances.push(variance);
            };
            for (var _i = 0, typeParameters_1 = typeParameters; _i < typeParameters_1.length; _i++) {
              var tp = typeParameters_1[_i];
              _loop_19(tp);
            }
            cache.variances = variances;
            ts3.tracing === null || ts3.tracing === void 0 ? void 0 : ts3.tracing.pop();
          }
          return variances;
        }
        function getVariances(type3) {
          if (type3 === globalArrayType || type3 === globalReadonlyArrayType || type3.objectFlags & 8) {
            return arrayVariances;
          }
          return getVariancesWorker(type3.typeParameters, type3, getMarkerTypeReference);
        }
        function hasCovariantVoidArgument(typeArguments, variances) {
          for (var i3 = 0; i3 < variances.length; i3++) {
            if ((variances[i3] & 7) === 1 && typeArguments[i3].flags & 16384) {
              return true;
            }
          }
          return false;
        }
        function isUnconstrainedTypeParameter(type3) {
          return type3.flags & 262144 && !getConstraintOfTypeParameter(type3);
        }
        function isNonDeferredTypeReference(type3) {
          return !!(ts3.getObjectFlags(type3) & 4) && !type3.node;
        }
        function isTypeReferenceWithGenericArguments(type3) {
          return isNonDeferredTypeReference(type3) && ts3.some(getTypeArguments(type3), function(t2) {
            return !!(t2.flags & 262144) || isTypeReferenceWithGenericArguments(t2);
          });
        }
        function getTypeReferenceId(type3, typeParameters, depth) {
          if (depth === void 0) {
            depth = 0;
          }
          var result2 = "" + type3.target.id;
          for (var _i = 0, _a2 = getTypeArguments(type3); _i < _a2.length; _i++) {
            var t2 = _a2[_i];
            if (isUnconstrainedTypeParameter(t2)) {
              var index = typeParameters.indexOf(t2);
              if (index < 0) {
                index = typeParameters.length;
                typeParameters.push(t2);
              }
              result2 += "=" + index;
            } else if (depth < 4 && isTypeReferenceWithGenericArguments(t2)) {
              result2 += "<" + getTypeReferenceId(t2, typeParameters, depth + 1) + ">";
            } else {
              result2 += "-" + t2.id;
            }
          }
          return result2;
        }
        function getRelationKey(source, target, intersectionState, relation) {
          if (relation === identityRelation && source.id > target.id) {
            var temp = source;
            source = target;
            target = temp;
          }
          var postFix = intersectionState ? ":" + intersectionState : "";
          if (isTypeReferenceWithGenericArguments(source) && isTypeReferenceWithGenericArguments(target)) {
            var typeParameters = [];
            return getTypeReferenceId(source, typeParameters) + "," + getTypeReferenceId(target, typeParameters) + postFix;
          }
          return source.id + "," + target.id + postFix;
        }
        function forEachProperty(prop, callback) {
          if (ts3.getCheckFlags(prop) & 6) {
            for (var _i = 0, _a2 = prop.containingType.types; _i < _a2.length; _i++) {
              var t2 = _a2[_i];
              var p = getPropertyOfType(t2, prop.escapedName);
              var result2 = p && forEachProperty(p, callback);
              if (result2) {
                return result2;
              }
            }
            return void 0;
          }
          return callback(prop);
        }
        function getDeclaringClass(prop) {
          return prop.parent && prop.parent.flags & 32 ? getDeclaredTypeOfSymbol(getParentOfSymbol(prop)) : void 0;
        }
        function getTypeOfPropertyInBaseClass(property) {
          var classType = getDeclaringClass(property);
          var baseClassType = classType && getBaseTypes(classType)[0];
          return baseClassType && getTypeOfPropertyOfType(baseClassType, property.escapedName);
        }
        function isPropertyInClassDerivedFrom(prop, baseClass) {
          return forEachProperty(prop, function(sp) {
            var sourceClass = getDeclaringClass(sp);
            return sourceClass ? hasBaseType(sourceClass, baseClass) : false;
          });
        }
        function isValidOverrideOf(sourceProp, targetProp) {
          return !forEachProperty(targetProp, function(tp) {
            return ts3.getDeclarationModifierFlagsFromSymbol(tp) & 16 ? !isPropertyInClassDerivedFrom(sourceProp, getDeclaringClass(tp)) : false;
          });
        }
        function isClassDerivedFromDeclaringClasses(checkClass, prop, writing) {
          return forEachProperty(prop, function(p) {
            return ts3.getDeclarationModifierFlagsFromSymbol(p, writing) & 16 ? !hasBaseType(checkClass, getDeclaringClass(p)) : false;
          }) ? void 0 : checkClass;
        }
        function isDeeplyNestedType(type3, stack, depth) {
          if (depth >= 5) {
            var identity_1 = getRecursionIdentity(type3);
            var count = 0;
            for (var i3 = 0; i3 < depth; i3++) {
              if (getRecursionIdentity(stack[i3]) === identity_1) {
                count++;
                if (count >= 5) {
                  return true;
                }
              }
            }
          }
          return false;
        }
        function getRecursionIdentity(type3) {
          if (type3.flags & 524288 && !isObjectOrArrayLiteralType(type3)) {
            if (ts3.getObjectFlags(type3) && 4 && type3.node) {
              return type3.node;
            }
            if (type3.symbol && !(ts3.getObjectFlags(type3) & 16 && type3.symbol.flags & 32)) {
              return type3.symbol;
            }
            if (isTupleType(type3)) {
              return type3.target;
            }
          }
          if (type3.flags & 262144) {
            return type3.symbol;
          }
          if (type3.flags & 8388608) {
            do {
              type3 = type3.objectType;
            } while (type3.flags & 8388608);
            return type3;
          }
          if (type3.flags & 16777216) {
            return type3.root;
          }
          return type3;
        }
        function isPropertyIdenticalTo(sourceProp, targetProp) {
          return compareProperties(sourceProp, targetProp, compareTypesIdentical) !== 0;
        }
        function compareProperties(sourceProp, targetProp, compareTypes) {
          if (sourceProp === targetProp) {
            return -1;
          }
          var sourcePropAccessibility = ts3.getDeclarationModifierFlagsFromSymbol(sourceProp) & 24;
          var targetPropAccessibility = ts3.getDeclarationModifierFlagsFromSymbol(targetProp) & 24;
          if (sourcePropAccessibility !== targetPropAccessibility) {
            return 0;
          }
          if (sourcePropAccessibility) {
            if (getTargetSymbol(sourceProp) !== getTargetSymbol(targetProp)) {
              return 0;
            }
          } else {
            if ((sourceProp.flags & 16777216) !== (targetProp.flags & 16777216)) {
              return 0;
            }
          }
          if (isReadonlySymbol(sourceProp) !== isReadonlySymbol(targetProp)) {
            return 0;
          }
          return compareTypes(getTypeOfSymbol(sourceProp), getTypeOfSymbol(targetProp));
        }
        function isMatchingSignature(source, target, partialMatch) {
          var sourceParameterCount = getParameterCount(source);
          var targetParameterCount = getParameterCount(target);
          var sourceMinArgumentCount = getMinArgumentCount(source);
          var targetMinArgumentCount = getMinArgumentCount(target);
          var sourceHasRestParameter = hasEffectiveRestParameter(source);
          var targetHasRestParameter = hasEffectiveRestParameter(target);
          if (sourceParameterCount === targetParameterCount && sourceMinArgumentCount === targetMinArgumentCount && sourceHasRestParameter === targetHasRestParameter) {
            return true;
          }
          if (partialMatch && sourceMinArgumentCount <= targetMinArgumentCount) {
            return true;
          }
          return false;
        }
        function compareSignaturesIdentical(source, target, partialMatch, ignoreThisTypes, ignoreReturnTypes, compareTypes) {
          if (source === target) {
            return -1;
          }
          if (!isMatchingSignature(source, target, partialMatch)) {
            return 0;
          }
          if (ts3.length(source.typeParameters) !== ts3.length(target.typeParameters)) {
            return 0;
          }
          if (target.typeParameters) {
            var mapper = createTypeMapper(source.typeParameters, target.typeParameters);
            for (var i3 = 0; i3 < target.typeParameters.length; i3++) {
              var s2 = source.typeParameters[i3];
              var t2 = target.typeParameters[i3];
              if (!(s2 === t2 || compareTypes(instantiateType(getConstraintFromTypeParameter(s2), mapper) || unknownType, getConstraintFromTypeParameter(t2) || unknownType) && compareTypes(instantiateType(getDefaultFromTypeParameter(s2), mapper) || unknownType, getDefaultFromTypeParameter(t2) || unknownType))) {
                return 0;
              }
            }
            source = instantiateSignature(source, mapper, true);
          }
          var result2 = -1;
          if (!ignoreThisTypes) {
            var sourceThisType = getThisTypeOfSignature(source);
            if (sourceThisType) {
              var targetThisType = getThisTypeOfSignature(target);
              if (targetThisType) {
                var related = compareTypes(sourceThisType, targetThisType);
                if (!related) {
                  return 0;
                }
                result2 &= related;
              }
            }
          }
          var targetLen = getParameterCount(target);
          for (var i3 = 0; i3 < targetLen; i3++) {
            var s2 = getTypeAtPosition(source, i3);
            var t2 = getTypeAtPosition(target, i3);
            var related = compareTypes(t2, s2);
            if (!related) {
              return 0;
            }
            result2 &= related;
          }
          if (!ignoreReturnTypes) {
            var sourceTypePredicate = getTypePredicateOfSignature(source);
            var targetTypePredicate = getTypePredicateOfSignature(target);
            result2 &= sourceTypePredicate || targetTypePredicate ? compareTypePredicatesIdentical(sourceTypePredicate, targetTypePredicate, compareTypes) : compareTypes(getReturnTypeOfSignature(source), getReturnTypeOfSignature(target));
          }
          return result2;
        }
        function compareTypePredicatesIdentical(source, target, compareTypes) {
          return !(source && target && typePredicateKindsMatch(source, target)) ? 0 : source.type === target.type ? -1 : source.type && target.type ? compareTypes(source.type, target.type) : 0;
        }
        function literalTypesWithSameBaseType(types2) {
          var commonBaseType;
          for (var _i = 0, types_14 = types2; _i < types_14.length; _i++) {
            var t2 = types_14[_i];
            var baseType = getBaseTypeOfLiteralType(t2);
            if (!commonBaseType) {
              commonBaseType = baseType;
            }
            if (baseType === t2 || baseType !== commonBaseType) {
              return false;
            }
          }
          return true;
        }
        function getSupertypeOrUnion(types2) {
          if (types2.length === 1) {
            return types2[0];
          }
          return literalTypesWithSameBaseType(types2) ? getUnionType(types2) : ts3.reduceLeft(types2, function(s2, t2) {
            return isTypeSubtypeOf(s2, t2) ? t2 : s2;
          });
        }
        function getCommonSupertype(types2) {
          if (!strictNullChecks) {
            return getSupertypeOrUnion(types2);
          }
          var primaryTypes = ts3.filter(types2, function(t2) {
            return !(t2.flags & 98304);
          });
          return primaryTypes.length ? getNullableType(getSupertypeOrUnion(primaryTypes), getFalsyFlagsOfTypes(types2) & 98304) : getUnionType(types2, 2);
        }
        function getCommonSubtype(types2) {
          return ts3.reduceLeft(types2, function(s2, t2) {
            return isTypeSubtypeOf(t2, s2) ? t2 : s2;
          });
        }
        function isArrayType(type3) {
          return !!(ts3.getObjectFlags(type3) & 4) && (type3.target === globalArrayType || type3.target === globalReadonlyArrayType);
        }
        function isReadonlyArrayType(type3) {
          return !!(ts3.getObjectFlags(type3) & 4) && type3.target === globalReadonlyArrayType;
        }
        function isMutableArrayOrTuple(type3) {
          return isArrayType(type3) && !isReadonlyArrayType(type3) || isTupleType(type3) && !type3.target.readonly;
        }
        function getElementTypeOfArrayType(type3) {
          return isArrayType(type3) ? getTypeArguments(type3)[0] : void 0;
        }
        function isArrayLikeType(type3) {
          return isArrayType(type3) || !(type3.flags & 98304) && isTypeAssignableTo(type3, anyReadonlyArrayType);
        }
        function getSingleBaseForNonAugmentingSubtype(type3) {
          if (!(ts3.getObjectFlags(type3) & 4) || !(ts3.getObjectFlags(type3.target) & 3)) {
            return void 0;
          }
          if (ts3.getObjectFlags(type3) & 33554432) {
            return ts3.getObjectFlags(type3) & 67108864 ? type3.cachedEquivalentBaseType : void 0;
          }
          type3.objectFlags |= 33554432;
          var target = type3.target;
          var bases = getBaseTypes(target);
          if (bases.length !== 1) {
            return void 0;
          }
          if (getMembersOfSymbol(type3.symbol).size) {
            return void 0;
          }
          var instantiatedBase = !ts3.length(target.typeParameters) ? bases[0] : instantiateType(bases[0], createTypeMapper(target.typeParameters, getTypeArguments(type3).slice(0, target.typeParameters.length)));
          if (ts3.length(getTypeArguments(type3)) > ts3.length(target.typeParameters)) {
            instantiatedBase = getTypeWithThisArgument(instantiatedBase, ts3.last(getTypeArguments(type3)));
          }
          type3.objectFlags |= 67108864;
          return type3.cachedEquivalentBaseType = instantiatedBase;
        }
        function isEmptyArrayLiteralType(type3) {
          var elementType = getElementTypeOfArrayType(type3);
          return strictNullChecks ? elementType === implicitNeverType : elementType === undefinedWideningType;
        }
        function isTupleLikeType(type3) {
          return isTupleType(type3) || !!getPropertyOfType(type3, "0");
        }
        function isArrayOrTupleLikeType(type3) {
          return isArrayLikeType(type3) || isTupleLikeType(type3);
        }
        function getTupleElementType(type3, index) {
          var propType = getTypeOfPropertyOfType(type3, "" + index);
          if (propType) {
            return propType;
          }
          if (everyType(type3, isTupleType)) {
            return mapType(type3, function(t2) {
              return getRestTypeOfTupleType(t2) || undefinedType;
            });
          }
          return void 0;
        }
        function isNeitherUnitTypeNorNever(type3) {
          return !(type3.flags & (109440 | 131072));
        }
        function isUnitType(type3) {
          return !!(type3.flags & 109440);
        }
        function isUnitLikeType(type3) {
          return type3.flags & 2097152 ? ts3.some(type3.types, isUnitType) : !!(type3.flags & 109440);
        }
        function extractUnitType(type3) {
          return type3.flags & 2097152 ? ts3.find(type3.types, isUnitType) || type3 : type3;
        }
        function isLiteralType(type3) {
          return type3.flags & 16 ? true : type3.flags & 1048576 ? type3.flags & 1024 ? true : ts3.every(type3.types, isUnitType) : isUnitType(type3);
        }
        function getBaseTypeOfLiteralType(type3) {
          return type3.flags & 1024 ? getBaseTypeOfEnumLiteralType(type3) : type3.flags & 128 ? stringType : type3.flags & 256 ? numberType : type3.flags & 2048 ? bigintType : type3.flags & 512 ? booleanType : type3.flags & 1048576 ? mapType(type3, getBaseTypeOfLiteralType) : type3;
        }
        function getWidenedLiteralType(type3) {
          return type3.flags & 1024 && isFreshLiteralType(type3) ? getBaseTypeOfEnumLiteralType(type3) : type3.flags & 128 && isFreshLiteralType(type3) ? stringType : type3.flags & 256 && isFreshLiteralType(type3) ? numberType : type3.flags & 2048 && isFreshLiteralType(type3) ? bigintType : type3.flags & 512 && isFreshLiteralType(type3) ? booleanType : type3.flags & 1048576 ? mapType(type3, getWidenedLiteralType) : type3;
        }
        function getWidenedUniqueESSymbolType(type3) {
          return type3.flags & 8192 ? esSymbolType : type3.flags & 1048576 ? mapType(type3, getWidenedUniqueESSymbolType) : type3;
        }
        function getWidenedLiteralLikeTypeForContextualType(type3, contextualType) {
          if (!isLiteralOfContextualType(type3, contextualType)) {
            type3 = getWidenedUniqueESSymbolType(getWidenedLiteralType(type3));
          }
          return type3;
        }
        function getWidenedLiteralLikeTypeForContextualReturnTypeIfNeeded(type3, contextualSignatureReturnType, isAsync) {
          if (type3 && isUnitType(type3)) {
            var contextualType = !contextualSignatureReturnType ? void 0 : isAsync ? getPromisedTypeOfPromise(contextualSignatureReturnType) : contextualSignatureReturnType;
            type3 = getWidenedLiteralLikeTypeForContextualType(type3, contextualType);
          }
          return type3;
        }
        function getWidenedLiteralLikeTypeForContextualIterationTypeIfNeeded(type3, contextualSignatureReturnType, kind, isAsyncGenerator) {
          if (type3 && isUnitType(type3)) {
            var contextualType = !contextualSignatureReturnType ? void 0 : getIterationTypeOfGeneratorFunctionReturnType(kind, contextualSignatureReturnType, isAsyncGenerator);
            type3 = getWidenedLiteralLikeTypeForContextualType(type3, contextualType);
          }
          return type3;
        }
        function isTupleType(type3) {
          return !!(ts3.getObjectFlags(type3) & 4 && type3.target.objectFlags & 8);
        }
        function isGenericTupleType(type3) {
          return isTupleType(type3) && !!(type3.target.combinedFlags & 8);
        }
        function isSingleElementGenericTupleType(type3) {
          return isGenericTupleType(type3) && type3.target.elementFlags.length === 1;
        }
        function getRestTypeOfTupleType(type3) {
          return getElementTypeOfSliceOfTupleType(type3, type3.target.fixedLength);
        }
        function getRestArrayTypeOfTupleType(type3) {
          var restType = getRestTypeOfTupleType(type3);
          return restType && createArrayType(restType);
        }
        function getElementTypeOfSliceOfTupleType(type3, index, endSkipCount, writing) {
          if (endSkipCount === void 0) {
            endSkipCount = 0;
          }
          if (writing === void 0) {
            writing = false;
          }
          var length = getTypeReferenceArity(type3) - endSkipCount;
          if (index < length) {
            var typeArguments = getTypeArguments(type3);
            var elementTypes = [];
            for (var i3 = index; i3 < length; i3++) {
              var t2 = typeArguments[i3];
              elementTypes.push(type3.target.elementFlags[i3] & 8 ? getIndexedAccessType(t2, numberType) : t2);
            }
            return writing ? getIntersectionType(elementTypes) : getUnionType(elementTypes);
          }
          return void 0;
        }
        function isTupleTypeStructureMatching(t1, t2) {
          return getTypeReferenceArity(t1) === getTypeReferenceArity(t2) && ts3.every(t1.target.elementFlags, function(f, i3) {
            return (f & 12) === (t2.target.elementFlags[i3] & 12);
          });
        }
        function isZeroBigInt(_a2) {
          var value = _a2.value;
          return value.base10Value === "0";
        }
        function getFalsyFlagsOfTypes(types2) {
          var result2 = 0;
          for (var _i = 0, types_15 = types2; _i < types_15.length; _i++) {
            var t2 = types_15[_i];
            result2 |= getFalsyFlags(t2);
          }
          return result2;
        }
        function getFalsyFlags(type3) {
          return type3.flags & 1048576 ? getFalsyFlagsOfTypes(type3.types) : type3.flags & 128 ? type3.value === "" ? 128 : 0 : type3.flags & 256 ? type3.value === 0 ? 256 : 0 : type3.flags & 2048 ? isZeroBigInt(type3) ? 2048 : 0 : type3.flags & 512 ? type3 === falseType || type3 === regularFalseType ? 512 : 0 : type3.flags & 117724;
        }
        function removeDefinitelyFalsyTypes(type3) {
          return getFalsyFlags(type3) & 117632 ? filterType(type3, function(t2) {
            return !(getFalsyFlags(t2) & 117632);
          }) : type3;
        }
        function extractDefinitelyFalsyTypes(type3) {
          return mapType(type3, getDefinitelyFalsyPartOfType);
        }
        function getDefinitelyFalsyPartOfType(type3) {
          return type3.flags & 4 ? emptyStringType : type3.flags & 8 ? zeroType : type3.flags & 64 ? zeroBigIntType : type3 === regularFalseType || type3 === falseType || type3.flags & (16384 | 32768 | 65536 | 3) || type3.flags & 128 && type3.value === "" || type3.flags & 256 && type3.value === 0 || type3.flags & 2048 && isZeroBigInt(type3) ? type3 : neverType;
        }
        function getNullableType(type3, flags) {
          var missing = flags & ~type3.flags & (32768 | 65536);
          return missing === 0 ? type3 : missing === 32768 ? getUnionType([type3, undefinedType]) : missing === 65536 ? getUnionType([type3, nullType]) : getUnionType([type3, undefinedType, nullType]);
        }
        function getOptionalType(type3) {
          ts3.Debug.assert(strictNullChecks);
          return type3.flags & 32768 ? type3 : getUnionType([type3, undefinedType]);
        }
        function getGlobalNonNullableTypeInstantiation(type3) {
          var reducedType = getTypeWithFacts(type3, 2097152);
          if (!deferredGlobalNonNullableTypeAlias) {
            deferredGlobalNonNullableTypeAlias = getGlobalSymbol("NonNullable", 524288, void 0) || unknownSymbol;
          }
          return deferredGlobalNonNullableTypeAlias !== unknownSymbol ? getTypeAliasInstantiation(deferredGlobalNonNullableTypeAlias, [reducedType]) : reducedType;
        }
        function getNonNullableType(type3) {
          return strictNullChecks ? getGlobalNonNullableTypeInstantiation(type3) : type3;
        }
        function addOptionalTypeMarker(type3) {
          return strictNullChecks ? getUnionType([type3, optionalType]) : type3;
        }
        function isNotOptionalTypeMarker(type3) {
          return type3 !== optionalType;
        }
        function removeOptionalTypeMarker(type3) {
          return strictNullChecks ? filterType(type3, isNotOptionalTypeMarker) : type3;
        }
        function propagateOptionalTypeMarker(type3, node, wasOptional) {
          return wasOptional ? ts3.isOutermostOptionalChain(node) ? getOptionalType(type3) : addOptionalTypeMarker(type3) : type3;
        }
        function getOptionalExpressionType(exprType, expression) {
          return ts3.isExpressionOfOptionalChainRoot(expression) ? getNonNullableType(exprType) : ts3.isOptionalChain(expression) ? removeOptionalTypeMarker(exprType) : exprType;
        }
        function isCoercibleUnderDoubleEquals(source, target) {
          return (source.flags & (8 | 4 | 512)) !== 0 && (target.flags & (8 | 4 | 16)) !== 0;
        }
        function isObjectTypeWithInferableIndex(type3) {
          return type3.flags & 2097152 ? ts3.every(type3.types, isObjectTypeWithInferableIndex) : !!(type3.symbol && (type3.symbol.flags & (4096 | 2048 | 384 | 512)) !== 0 && !typeHasCallOrConstructSignatures(type3)) || !!(ts3.getObjectFlags(type3) & 1024 && isObjectTypeWithInferableIndex(type3.source));
        }
        function createSymbolWithType(source, type3) {
          var symbol = createSymbol(source.flags, source.escapedName, ts3.getCheckFlags(source) & 8);
          symbol.declarations = source.declarations;
          symbol.parent = source.parent;
          symbol.type = type3;
          symbol.target = source;
          if (source.valueDeclaration) {
            symbol.valueDeclaration = source.valueDeclaration;
          }
          var nameType = getSymbolLinks(source).nameType;
          if (nameType) {
            symbol.nameType = nameType;
          }
          return symbol;
        }
        function transformTypeOfMembers(type3, f) {
          var members = ts3.createSymbolTable();
          for (var _i = 0, _a2 = getPropertiesOfObjectType(type3); _i < _a2.length; _i++) {
            var property = _a2[_i];
            var original = getTypeOfSymbol(property);
            var updated = f(original);
            members.set(property.escapedName, updated === original ? property : createSymbolWithType(property, updated));
          }
          return members;
        }
        function getRegularTypeOfObjectLiteral(type3) {
          if (!(isObjectLiteralType(type3) && ts3.getObjectFlags(type3) & 16384)) {
            return type3;
          }
          var regularType = type3.regularType;
          if (regularType) {
            return regularType;
          }
          var resolved = type3;
          var members = transformTypeOfMembers(type3, getRegularTypeOfObjectLiteral);
          var regularNew = createAnonymousType(resolved.symbol, members, resolved.callSignatures, resolved.constructSignatures, resolved.stringIndexInfo, resolved.numberIndexInfo);
          regularNew.flags = resolved.flags;
          regularNew.objectFlags |= resolved.objectFlags & ~16384;
          type3.regularType = regularNew;
          return regularNew;
        }
        function createWideningContext(parent, propertyName, siblings) {
          return { parent, propertyName, siblings, resolvedProperties: void 0 };
        }
        function getSiblingsOfContext(context) {
          if (!context.siblings) {
            var siblings_1 = [];
            for (var _i = 0, _a2 = getSiblingsOfContext(context.parent); _i < _a2.length; _i++) {
              var type3 = _a2[_i];
              if (isObjectLiteralType(type3)) {
                var prop = getPropertyOfObjectType(type3, context.propertyName);
                if (prop) {
                  forEachType(getTypeOfSymbol(prop), function(t2) {
                    siblings_1.push(t2);
                  });
                }
              }
            }
            context.siblings = siblings_1;
          }
          return context.siblings;
        }
        function getPropertiesOfContext(context) {
          if (!context.resolvedProperties) {
            var names = new ts3.Map();
            for (var _i = 0, _a2 = getSiblingsOfContext(context); _i < _a2.length; _i++) {
              var t2 = _a2[_i];
              if (isObjectLiteralType(t2) && !(ts3.getObjectFlags(t2) & 4194304)) {
                for (var _b = 0, _c = getPropertiesOfType(t2); _b < _c.length; _b++) {
                  var prop = _c[_b];
                  names.set(prop.escapedName, prop);
                }
              }
            }
            context.resolvedProperties = ts3.arrayFrom(names.values());
          }
          return context.resolvedProperties;
        }
        function getWidenedProperty(prop, context) {
          if (!(prop.flags & 4)) {
            return prop;
          }
          var original = getTypeOfSymbol(prop);
          var propContext = context && createWideningContext(context, prop.escapedName, void 0);
          var widened = getWidenedTypeWithContext(original, propContext);
          return widened === original ? prop : createSymbolWithType(prop, widened);
        }
        function getUndefinedProperty(prop) {
          var cached = undefinedProperties.get(prop.escapedName);
          if (cached) {
            return cached;
          }
          var result2 = createSymbolWithType(prop, undefinedType);
          result2.flags |= 16777216;
          undefinedProperties.set(prop.escapedName, result2);
          return result2;
        }
        function getWidenedTypeOfObjectLiteral(type3, context) {
          var members = ts3.createSymbolTable();
          for (var _i = 0, _a2 = getPropertiesOfObjectType(type3); _i < _a2.length; _i++) {
            var prop = _a2[_i];
            members.set(prop.escapedName, getWidenedProperty(prop, context));
          }
          if (context) {
            for (var _b = 0, _c = getPropertiesOfContext(context); _b < _c.length; _b++) {
              var prop = _c[_b];
              if (!members.has(prop.escapedName)) {
                members.set(prop.escapedName, getUndefinedProperty(prop));
              }
            }
          }
          var stringIndexInfo = getIndexInfoOfType(type3, 0);
          var numberIndexInfo = getIndexInfoOfType(type3, 1);
          var result2 = createAnonymousType(type3.symbol, members, ts3.emptyArray, ts3.emptyArray, stringIndexInfo && createIndexInfo(getWidenedType(stringIndexInfo.type), stringIndexInfo.isReadonly), numberIndexInfo && createIndexInfo(getWidenedType(numberIndexInfo.type), numberIndexInfo.isReadonly));
          result2.objectFlags |= ts3.getObjectFlags(type3) & (8192 | 524288);
          return result2;
        }
        function getWidenedType(type3) {
          return getWidenedTypeWithContext(type3, void 0);
        }
        function getWidenedTypeWithContext(type3, context) {
          if (ts3.getObjectFlags(type3) & 393216) {
            if (context === void 0 && type3.widened) {
              return type3.widened;
            }
            var result2 = void 0;
            if (type3.flags & (1 | 98304)) {
              result2 = anyType;
            } else if (isObjectLiteralType(type3)) {
              result2 = getWidenedTypeOfObjectLiteral(type3, context);
            } else if (type3.flags & 1048576) {
              var unionContext_1 = context || createWideningContext(void 0, void 0, type3.types);
              var widenedTypes = ts3.sameMap(type3.types, function(t2) {
                return t2.flags & 98304 ? t2 : getWidenedTypeWithContext(t2, unionContext_1);
              });
              result2 = getUnionType(widenedTypes, ts3.some(widenedTypes, isEmptyObjectType) ? 2 : 1);
            } else if (type3.flags & 2097152) {
              result2 = getIntersectionType(ts3.sameMap(type3.types, getWidenedType));
            } else if (isArrayType(type3) || isTupleType(type3)) {
              result2 = createTypeReference(type3.target, ts3.sameMap(getTypeArguments(type3), getWidenedType));
            }
            if (result2 && context === void 0) {
              type3.widened = result2;
            }
            return result2 || type3;
          }
          return type3;
        }
        function reportWideningErrorsInType(type3) {
          var errorReported = false;
          if (ts3.getObjectFlags(type3) & 131072) {
            if (type3.flags & 1048576) {
              if (ts3.some(type3.types, isEmptyObjectType)) {
                errorReported = true;
              } else {
                for (var _i = 0, _a2 = type3.types; _i < _a2.length; _i++) {
                  var t2 = _a2[_i];
                  if (reportWideningErrorsInType(t2)) {
                    errorReported = true;
                  }
                }
              }
            }
            if (isArrayType(type3) || isTupleType(type3)) {
              for (var _b = 0, _c = getTypeArguments(type3); _b < _c.length; _b++) {
                var t2 = _c[_b];
                if (reportWideningErrorsInType(t2)) {
                  errorReported = true;
                }
              }
            }
            if (isObjectLiteralType(type3)) {
              for (var _d = 0, _e = getPropertiesOfObjectType(type3); _d < _e.length; _d++) {
                var p = _e[_d];
                var t2 = getTypeOfSymbol(p);
                if (ts3.getObjectFlags(t2) & 131072) {
                  if (!reportWideningErrorsInType(t2)) {
                    error(p.valueDeclaration, ts3.Diagnostics.Object_literal_s_property_0_implicitly_has_an_1_type, symbolToString(p), typeToString(getWidenedType(t2)));
                  }
                  errorReported = true;
                }
              }
            }
          }
          return errorReported;
        }
        function reportImplicitAny(declaration, type3, wideningKind) {
          var typeAsString = typeToString(getWidenedType(type3));
          if (ts3.isInJSFile(declaration) && !ts3.isCheckJsEnabledForFile(ts3.getSourceFileOfNode(declaration), compilerOptions)) {
            return;
          }
          var diagnostic;
          switch (declaration.kind) {
            case 217:
            case 164:
            case 163:
              diagnostic = noImplicitAny ? ts3.Diagnostics.Member_0_implicitly_has_an_1_type : ts3.Diagnostics.Member_0_implicitly_has_an_1_type_but_a_better_type_may_be_inferred_from_usage;
              break;
            case 161:
              var param = declaration;
              if (ts3.isIdentifier(param.name) && (ts3.isCallSignatureDeclaration(param.parent) || ts3.isMethodSignature(param.parent) || ts3.isFunctionTypeNode(param.parent)) && param.parent.parameters.indexOf(param) > -1 && (resolveName(param, param.name.escapedText, 788968, void 0, param.name.escapedText, true) || param.name.originalKeywordKind && ts3.isTypeNodeKind(param.name.originalKeywordKind))) {
                var newName = "arg" + param.parent.parameters.indexOf(param);
                errorOrSuggestion(noImplicitAny, declaration, ts3.Diagnostics.Parameter_has_a_name_but_no_type_Did_you_mean_0_Colon_1, newName, ts3.declarationNameToString(param.name));
                return;
              }
              diagnostic = declaration.dotDotDotToken ? noImplicitAny ? ts3.Diagnostics.Rest_parameter_0_implicitly_has_an_any_type : ts3.Diagnostics.Rest_parameter_0_implicitly_has_an_any_type_but_a_better_type_may_be_inferred_from_usage : noImplicitAny ? ts3.Diagnostics.Parameter_0_implicitly_has_an_1_type : ts3.Diagnostics.Parameter_0_implicitly_has_an_1_type_but_a_better_type_may_be_inferred_from_usage;
              break;
            case 199:
              diagnostic = ts3.Diagnostics.Binding_element_0_implicitly_has_an_1_type;
              if (!noImplicitAny) {
                return;
              }
              break;
            case 309:
              error(declaration, ts3.Diagnostics.Function_type_which_lacks_return_type_annotation_implicitly_has_an_0_return_type, typeAsString);
              return;
            case 252:
            case 166:
            case 165:
            case 168:
            case 169:
            case 209:
            case 210:
              if (noImplicitAny && !declaration.name) {
                if (wideningKind === 3) {
                  error(declaration, ts3.Diagnostics.Generator_implicitly_has_yield_type_0_because_it_does_not_yield_any_values_Consider_supplying_a_return_type_annotation, typeAsString);
                } else {
                  error(declaration, ts3.Diagnostics.Function_expression_which_lacks_return_type_annotation_implicitly_has_an_0_return_type, typeAsString);
                }
                return;
              }
              diagnostic = !noImplicitAny ? ts3.Diagnostics._0_implicitly_has_an_1_return_type_but_a_better_type_may_be_inferred_from_usage : wideningKind === 3 ? ts3.Diagnostics._0_which_lacks_return_type_annotation_implicitly_has_an_1_yield_type : ts3.Diagnostics._0_which_lacks_return_type_annotation_implicitly_has_an_1_return_type;
              break;
            case 191:
              if (noImplicitAny) {
                error(declaration, ts3.Diagnostics.Mapped_object_type_implicitly_has_an_any_template_type);
              }
              return;
            default:
              diagnostic = noImplicitAny ? ts3.Diagnostics.Variable_0_implicitly_has_an_1_type : ts3.Diagnostics.Variable_0_implicitly_has_an_1_type_but_a_better_type_may_be_inferred_from_usage;
          }
          errorOrSuggestion(noImplicitAny, declaration, diagnostic, ts3.declarationNameToString(ts3.getNameOfDeclaration(declaration)), typeAsString);
        }
        function reportErrorsFromWidening(declaration, type3, wideningKind) {
          if (produceDiagnostics && noImplicitAny && ts3.getObjectFlags(type3) & 131072 && (!wideningKind || !getContextualSignatureForFunctionLikeDeclaration(declaration))) {
            if (!reportWideningErrorsInType(type3)) {
              reportImplicitAny(declaration, type3, wideningKind);
            }
          }
        }
        function applyToParameterTypes(source, target, callback) {
          var sourceCount = getParameterCount(source);
          var targetCount = getParameterCount(target);
          var sourceRestType = getEffectiveRestType(source);
          var targetRestType = getEffectiveRestType(target);
          var targetNonRestCount = targetRestType ? targetCount - 1 : targetCount;
          var paramCount = sourceRestType ? targetNonRestCount : Math.min(sourceCount, targetNonRestCount);
          var sourceThisType = getThisTypeOfSignature(source);
          if (sourceThisType) {
            var targetThisType = getThisTypeOfSignature(target);
            if (targetThisType) {
              callback(sourceThisType, targetThisType);
            }
          }
          for (var i3 = 0; i3 < paramCount; i3++) {
            callback(getTypeAtPosition(source, i3), getTypeAtPosition(target, i3));
          }
          if (targetRestType) {
            callback(getRestTypeAtPosition(source, paramCount), targetRestType);
          }
        }
        function applyToReturnTypes(source, target, callback) {
          var sourceTypePredicate = getTypePredicateOfSignature(source);
          var targetTypePredicate = getTypePredicateOfSignature(target);
          if (sourceTypePredicate && targetTypePredicate && typePredicateKindsMatch(sourceTypePredicate, targetTypePredicate) && sourceTypePredicate.type && targetTypePredicate.type) {
            callback(sourceTypePredicate.type, targetTypePredicate.type);
          } else {
            callback(getReturnTypeOfSignature(source), getReturnTypeOfSignature(target));
          }
        }
        function createInferenceContext(typeParameters, signature, flags, compareTypes) {
          return createInferenceContextWorker(typeParameters.map(createInferenceInfo), signature, flags, compareTypes || compareTypesAssignable);
        }
        function cloneInferenceContext(context, extraFlags) {
          if (extraFlags === void 0) {
            extraFlags = 0;
          }
          return context && createInferenceContextWorker(ts3.map(context.inferences, cloneInferenceInfo), context.signature, context.flags | extraFlags, context.compareTypes);
        }
        function createInferenceContextWorker(inferences, signature, flags, compareTypes) {
          var context = {
            inferences,
            signature,
            flags,
            compareTypes,
            mapper: makeFunctionTypeMapper(function(t2) {
              return mapToInferredType(context, t2, true);
            }),
            nonFixingMapper: makeFunctionTypeMapper(function(t2) {
              return mapToInferredType(context, t2, false);
            })
          };
          return context;
        }
        function mapToInferredType(context, t2, fix) {
          var inferences = context.inferences;
          for (var i3 = 0; i3 < inferences.length; i3++) {
            var inference = inferences[i3];
            if (t2 === inference.typeParameter) {
              if (fix && !inference.isFixed) {
                clearCachedInferences(inferences);
                inference.isFixed = true;
              }
              return getInferredType(context, i3);
            }
          }
          return t2;
        }
        function clearCachedInferences(inferences) {
          for (var _i = 0, inferences_1 = inferences; _i < inferences_1.length; _i++) {
            var inference = inferences_1[_i];
            if (!inference.isFixed) {
              inference.inferredType = void 0;
            }
          }
        }
        function createInferenceInfo(typeParameter) {
          return {
            typeParameter,
            candidates: void 0,
            contraCandidates: void 0,
            inferredType: void 0,
            priority: void 0,
            topLevel: true,
            isFixed: false,
            impliedArity: void 0
          };
        }
        function cloneInferenceInfo(inference) {
          return {
            typeParameter: inference.typeParameter,
            candidates: inference.candidates && inference.candidates.slice(),
            contraCandidates: inference.contraCandidates && inference.contraCandidates.slice(),
            inferredType: inference.inferredType,
            priority: inference.priority,
            topLevel: inference.topLevel,
            isFixed: inference.isFixed,
            impliedArity: inference.impliedArity
          };
        }
        function cloneInferredPartOfContext(context) {
          var inferences = ts3.filter(context.inferences, hasInferenceCandidates);
          return inferences.length ? createInferenceContextWorker(ts3.map(inferences, cloneInferenceInfo), context.signature, context.flags, context.compareTypes) : void 0;
        }
        function getMapperFromContext(context) {
          return context && context.mapper;
        }
        function couldContainTypeVariables(type3) {
          var objectFlags = ts3.getObjectFlags(type3);
          if (objectFlags & 1048576) {
            return !!(objectFlags & 2097152);
          }
          var result2 = !!(type3.flags & 465829888 || type3.flags & 524288 && !isNonGenericTopLevelType(type3) && (objectFlags & 4 && (type3.node || ts3.forEach(getTypeArguments(type3), couldContainTypeVariables)) || objectFlags & 16 && type3.symbol && type3.symbol.flags & (16 | 8192 | 32 | 2048 | 4096) && type3.symbol.declarations || objectFlags & (32 | 1024 | 8388608)) || type3.flags & 3145728 && !(type3.flags & 1024) && !isNonGenericTopLevelType(type3) && ts3.some(type3.types, couldContainTypeVariables));
          if (type3.flags & 3899393) {
            type3.objectFlags |= 1048576 | (result2 ? 2097152 : 0);
          }
          return result2;
        }
        function isNonGenericTopLevelType(type3) {
          if (type3.aliasSymbol && !type3.aliasTypeArguments) {
            var declaration = ts3.getDeclarationOfKind(type3.aliasSymbol, 255);
            return !!(declaration && ts3.findAncestor(declaration.parent, function(n2) {
              return n2.kind === 298 ? true : n2.kind === 257 ? false : "quit";
            }));
          }
          return false;
        }
        function isTypeParameterAtTopLevel(type3, typeParameter) {
          return !!(type3 === typeParameter || type3.flags & 3145728 && ts3.some(type3.types, function(t2) {
            return isTypeParameterAtTopLevel(t2, typeParameter);
          }) || type3.flags & 16777216 && (getTrueTypeFromConditionalType(type3) === typeParameter || getFalseTypeFromConditionalType(type3) === typeParameter));
        }
        function createEmptyObjectTypeFromStringLiteral(type3) {
          var members = ts3.createSymbolTable();
          forEachType(type3, function(t2) {
            if (!(t2.flags & 128)) {
              return;
            }
            var name = ts3.escapeLeadingUnderscores(t2.value);
            var literalProp = createSymbol(4, name);
            literalProp.type = anyType;
            if (t2.symbol) {
              literalProp.declarations = t2.symbol.declarations;
              literalProp.valueDeclaration = t2.symbol.valueDeclaration;
            }
            members.set(name, literalProp);
          });
          var indexInfo = type3.flags & 4 ? createIndexInfo(emptyObjectType, false) : void 0;
          return createAnonymousType(void 0, members, ts3.emptyArray, ts3.emptyArray, indexInfo, void 0);
        }
        function inferTypeForHomomorphicMappedType(source, target, constraint) {
          if (inInferTypeForHomomorphicMappedType) {
            return void 0;
          }
          var key2 = source.id + "," + target.id + "," + constraint.id;
          if (reverseMappedCache.has(key2)) {
            return reverseMappedCache.get(key2);
          }
          inInferTypeForHomomorphicMappedType = true;
          var type3 = createReverseMappedType(source, target, constraint);
          inInferTypeForHomomorphicMappedType = false;
          reverseMappedCache.set(key2, type3);
          return type3;
        }
        function isPartiallyInferableType(type3) {
          return !(ts3.getObjectFlags(type3) & 524288) || isObjectLiteralType(type3) && ts3.some(getPropertiesOfType(type3), function(prop) {
            return isPartiallyInferableType(getTypeOfSymbol(prop));
          }) || isTupleType(type3) && ts3.some(getTypeArguments(type3), isPartiallyInferableType);
        }
        function createReverseMappedType(source, target, constraint) {
          if (!(getIndexInfoOfType(source, 0) || getPropertiesOfType(source).length !== 0 && isPartiallyInferableType(source))) {
            return void 0;
          }
          if (isArrayType(source)) {
            return createArrayType(inferReverseMappedType(getTypeArguments(source)[0], target, constraint), isReadonlyArrayType(source));
          }
          if (isTupleType(source)) {
            var elementTypes = ts3.map(getTypeArguments(source), function(t2) {
              return inferReverseMappedType(t2, target, constraint);
            });
            var elementFlags = getMappedTypeModifiers(target) & 4 ? ts3.sameMap(source.target.elementFlags, function(f) {
              return f & 2 ? 1 : f;
            }) : source.target.elementFlags;
            return createTupleType(elementTypes, elementFlags, source.target.readonly, source.target.labeledElementDeclarations);
          }
          var reversed = createObjectType(1024 | 16, void 0);
          reversed.source = source;
          reversed.mappedType = target;
          reversed.constraintType = constraint;
          return reversed;
        }
        function getTypeOfReverseMappedSymbol(symbol) {
          var links = getSymbolLinks(symbol);
          if (!links.type) {
            links.type = inferReverseMappedType(symbol.propertyType, symbol.mappedType, symbol.constraintType);
          }
          return links.type;
        }
        function inferReverseMappedType(sourceType, target, constraint) {
          var typeParameter = getIndexedAccessType(constraint.type, getTypeParameterFromMappedType(target));
          var templateType = getTemplateTypeFromMappedType(target);
          var inference = createInferenceInfo(typeParameter);
          inferTypes([inference], sourceType, templateType);
          return getTypeFromInference(inference) || unknownType;
        }
        function getUnmatchedProperties(source, target, requireOptionalProperties, matchDiscriminantProperties) {
          var properties, _i, properties_2, targetProp, sourceProp, targetType, sourceType;
          return __generator(this, function(_a2) {
            switch (_a2.label) {
              case 0:
                properties = getPropertiesOfType(target);
                _i = 0, properties_2 = properties;
                _a2.label = 1;
              case 1:
                if (!(_i < properties_2.length))
                  return [3, 6];
                targetProp = properties_2[_i];
                if (isStaticPrivateIdentifierProperty(targetProp)) {
                  return [3, 5];
                }
                if (!(requireOptionalProperties || !(targetProp.flags & 16777216 || ts3.getCheckFlags(targetProp) & 48)))
                  return [3, 5];
                sourceProp = getPropertyOfType(source, targetProp.escapedName);
                if (!!sourceProp)
                  return [3, 3];
                return [4, targetProp];
              case 2:
                _a2.sent();
                return [3, 5];
              case 3:
                if (!matchDiscriminantProperties)
                  return [3, 5];
                targetType = getTypeOfSymbol(targetProp);
                if (!(targetType.flags & 109440))
                  return [3, 5];
                sourceType = getTypeOfSymbol(sourceProp);
                if (!!(sourceType.flags & 1 || getRegularTypeOfLiteralType(sourceType) === getRegularTypeOfLiteralType(targetType)))
                  return [3, 5];
                return [4, targetProp];
              case 4:
                _a2.sent();
                _a2.label = 5;
              case 5:
                _i++;
                return [3, 1];
              case 6:
                return [2];
            }
          });
        }
        function getUnmatchedProperty(source, target, requireOptionalProperties, matchDiscriminantProperties) {
          var result2 = getUnmatchedProperties(source, target, requireOptionalProperties, matchDiscriminantProperties).next();
          if (!result2.done)
            return result2.value;
        }
        function tupleTypesDefinitelyUnrelated(source, target) {
          return !(target.target.combinedFlags & 8) && target.target.minLength > source.target.minLength || !target.target.hasRestElement && (source.target.hasRestElement || target.target.fixedLength < source.target.fixedLength);
        }
        function typesDefinitelyUnrelated(source, target) {
          return isTupleType(source) && isTupleType(target) ? tupleTypesDefinitelyUnrelated(source, target) : !!getUnmatchedProperty(source, target, false, true) && !!getUnmatchedProperty(target, source, false, false);
        }
        function getTypeFromInference(inference) {
          return inference.candidates ? getUnionType(inference.candidates, 2) : inference.contraCandidates ? getIntersectionType(inference.contraCandidates) : void 0;
        }
        function hasSkipDirectInferenceFlag(node) {
          return !!getNodeLinks(node).skipDirectInference;
        }
        function isFromInferenceBlockedSource(type3) {
          return !!(type3.symbol && ts3.some(type3.symbol.declarations, hasSkipDirectInferenceFlag));
        }
        function isValidBigIntString(s2) {
          var scanner = ts3.createScanner(99, false);
          var success = true;
          scanner.setOnError(function() {
            return success = false;
          });
          scanner.setText(s2 + "n");
          var result2 = scanner.scan();
          if (result2 === 40) {
            result2 = scanner.scan();
          }
          var flags = scanner.getTokenFlags();
          return success && result2 === 9 && scanner.getTextPos() === s2.length + 1 && !(flags & 512);
        }
        function isValidTypeForTemplateLiteralPlaceholder(source, target) {
          if (source === target || target.flags & (1 | 4)) {
            return true;
          }
          if (source.flags & 128) {
            var value = source.value;
            return !!(target.flags & 8 && value !== "" && isFinite(+value) || target.flags & 64 && value !== "" && isValidBigIntString(value) || target.flags & (512 | 98304) && value === target.intrinsicName);
          }
          if (source.flags & 134217728) {
            var texts = source.texts;
            return texts.length === 2 && texts[0] === "" && texts[1] === "" && isTypeAssignableTo(source.types[0], target);
          }
          return isTypeAssignableTo(source, target);
        }
        function inferTypesFromTemplateLiteralType(source, target) {
          return source.flags & 128 ? inferFromLiteralPartsToTemplateLiteral([source.value], ts3.emptyArray, target) : source.flags & 134217728 ? ts3.arraysEqual(source.texts, target.texts) ? ts3.map(source.types, getStringLikeTypeForType) : inferFromLiteralPartsToTemplateLiteral(source.texts, source.types, target) : void 0;
        }
        function getStringLikeTypeForType(type3) {
          return type3.flags & (1 | 402653316) ? type3 : getTemplateLiteralType(["", ""], [type3]);
        }
        function inferFromLiteralPartsToTemplateLiteral(sourceTexts, sourceTypes, target) {
          var lastSourceIndex = sourceTexts.length - 1;
          var sourceStartText = sourceTexts[0];
          var sourceEndText = sourceTexts[lastSourceIndex];
          var targetTexts = target.texts;
          var lastTargetIndex = targetTexts.length - 1;
          var targetStartText = targetTexts[0];
          var targetEndText = targetTexts[lastTargetIndex];
          if (lastSourceIndex === 0 && sourceStartText.length < targetStartText.length + targetEndText.length || !sourceStartText.startsWith(targetStartText) || !sourceEndText.endsWith(targetEndText))
            return void 0;
          var remainingEndText = sourceEndText.slice(0, sourceEndText.length - targetEndText.length);
          var matches = [];
          var seg = 0;
          var pos = targetStartText.length;
          for (var i3 = 1; i3 < lastTargetIndex; i3++) {
            var delim = targetTexts[i3];
            if (delim.length > 0) {
              var s2 = seg;
              var p = pos;
              while (true) {
                p = getSourceText(s2).indexOf(delim, p);
                if (p >= 0)
                  break;
                s2++;
                if (s2 === sourceTexts.length)
                  return void 0;
                p = 0;
              }
              addMatch(s2, p);
              pos += delim.length;
            } else if (pos < getSourceText(seg).length) {
              addMatch(seg, pos + 1);
            } else if (seg < lastSourceIndex) {
              addMatch(seg + 1, 0);
            } else {
              return void 0;
            }
          }
          addMatch(lastSourceIndex, getSourceText(lastSourceIndex).length);
          return matches;
          function getSourceText(index) {
            return index < lastSourceIndex ? sourceTexts[index] : remainingEndText;
          }
          function addMatch(s3, p2) {
            var matchType = s3 === seg ? getLiteralType(getSourceText(s3).slice(pos, p2)) : getTemplateLiteralType(__spreadArray(__spreadArray([sourceTexts[seg].slice(pos)], sourceTexts.slice(seg + 1, s3)), [getSourceText(s3).slice(0, p2)]), sourceTypes.slice(seg, s3));
            matches.push(matchType);
            seg = s3;
            pos = p2;
          }
        }
        function inferTypes(inferences, originalSource, originalTarget, priority, contravariant) {
          if (priority === void 0) {
            priority = 0;
          }
          if (contravariant === void 0) {
            contravariant = false;
          }
          var bivariant = false;
          var propagationType;
          var inferencePriority = 2048;
          var allowComplexConstraintInference = true;
          var visited;
          var sourceStack;
          var targetStack;
          var expandingFlags = 0;
          inferFromTypes(originalSource, originalTarget);
          function inferFromTypes(source, target) {
            if (!couldContainTypeVariables(target)) {
              return;
            }
            if (source === wildcardType) {
              var savePropagationType = propagationType;
              propagationType = source;
              inferFromTypes(target, target);
              propagationType = savePropagationType;
              return;
            }
            if (source.aliasSymbol && source.aliasTypeArguments && source.aliasSymbol === target.aliasSymbol) {
              inferFromTypeArguments(source.aliasTypeArguments, target.aliasTypeArguments, getAliasVariances(source.aliasSymbol));
              return;
            }
            if (source === target && source.flags & 3145728) {
              for (var _i = 0, _a2 = source.types; _i < _a2.length; _i++) {
                var t2 = _a2[_i];
                inferFromTypes(t2, t2);
              }
              return;
            }
            if (target.flags & 1048576) {
              var _b = inferFromMatchingTypes(source.flags & 1048576 ? source.types : [source], target.types, isTypeOrBaseIdenticalTo), tempSources = _b[0], tempTargets = _b[1];
              var _c = inferFromMatchingTypes(tempSources, tempTargets, isTypeCloselyMatchedBy), sources = _c[0], targets = _c[1];
              if (targets.length === 0) {
                return;
              }
              target = getUnionType(targets);
              if (sources.length === 0) {
                inferWithPriority(source, target, 1);
                return;
              }
              source = getUnionType(sources);
            } else if (target.flags & 2097152 && ts3.some(target.types, function(t3) {
              return !!getInferenceInfoForType(t3) || isGenericMappedType(t3) && !!getInferenceInfoForType(getHomomorphicTypeVariable(t3) || neverType);
            })) {
              if (!(source.flags & 1048576)) {
                var _d = inferFromMatchingTypes(source.flags & 2097152 ? source.types : [source], target.types, isTypeIdenticalTo), sources = _d[0], targets = _d[1];
                if (sources.length === 0 || targets.length === 0) {
                  return;
                }
                source = getIntersectionType(sources);
                target = getIntersectionType(targets);
              }
            } else if (target.flags & (8388608 | 33554432)) {
              target = getActualTypeVariable(target);
            }
            if (target.flags & 8650752) {
              if (ts3.getObjectFlags(source) & 524288 || source === nonInferrableAnyType || source === silentNeverType || priority & 128 && (source === autoType || source === autoArrayType) || isFromInferenceBlockedSource(source)) {
                return;
              }
              var inference = getInferenceInfoForType(target);
              if (inference) {
                if (!inference.isFixed) {
                  if (inference.priority === void 0 || priority < inference.priority) {
                    inference.candidates = void 0;
                    inference.contraCandidates = void 0;
                    inference.topLevel = true;
                    inference.priority = priority;
                  }
                  if (priority === inference.priority) {
                    var candidate = propagationType || source;
                    if (contravariant && !bivariant) {
                      if (!ts3.contains(inference.contraCandidates, candidate)) {
                        inference.contraCandidates = ts3.append(inference.contraCandidates, candidate);
                        clearCachedInferences(inferences);
                      }
                    } else if (!ts3.contains(inference.candidates, candidate)) {
                      inference.candidates = ts3.append(inference.candidates, candidate);
                      clearCachedInferences(inferences);
                    }
                  }
                  if (!(priority & 128) && target.flags & 262144 && inference.topLevel && !isTypeParameterAtTopLevel(originalTarget, target)) {
                    inference.topLevel = false;
                    clearCachedInferences(inferences);
                  }
                }
                inferencePriority = Math.min(inferencePriority, priority);
                return;
              } else {
                var simplified = getSimplifiedType(target, false);
                if (simplified !== target) {
                  invokeOnce(source, simplified, inferFromTypes);
                } else if (target.flags & 8388608) {
                  var indexType = getSimplifiedType(target.indexType, false);
                  if (indexType.flags & 465829888) {
                    var simplified_1 = distributeIndexOverObjectType(getSimplifiedType(target.objectType, false), indexType, false);
                    if (simplified_1 && simplified_1 !== target) {
                      invokeOnce(source, simplified_1, inferFromTypes);
                    }
                  }
                }
              }
            }
            if (ts3.getObjectFlags(source) & 4 && ts3.getObjectFlags(target) & 4 && (source.target === target.target || isArrayType(source) && isArrayType(target)) && !(source.node && target.node)) {
              inferFromTypeArguments(getTypeArguments(source), getTypeArguments(target), getVariances(source.target));
            } else if (source.flags & 4194304 && target.flags & 4194304) {
              contravariant = !contravariant;
              inferFromTypes(source.type, target.type);
              contravariant = !contravariant;
            } else if ((isLiteralType(source) || source.flags & 4) && target.flags & 4194304) {
              var empty = createEmptyObjectTypeFromStringLiteral(source);
              contravariant = !contravariant;
              inferWithPriority(empty, target.type, 256);
              contravariant = !contravariant;
            } else if (source.flags & 8388608 && target.flags & 8388608) {
              inferFromTypes(source.objectType, target.objectType);
              inferFromTypes(source.indexType, target.indexType);
            } else if (source.flags & 268435456 && target.flags & 268435456) {
              if (source.symbol === target.symbol) {
                inferFromTypes(source.type, target.type);
              }
            } else if (source.flags & 33554432) {
              inferFromTypes(source.baseType, target);
              var oldPriority = priority;
              priority |= 4;
              inferFromTypes(source.substitute, target);
              priority = oldPriority;
            } else if (target.flags & 16777216) {
              invokeOnce(source, target, inferToConditionalType);
            } else if (target.flags & 3145728) {
              inferToMultipleTypes(source, target.types, target.flags);
            } else if (source.flags & 1048576) {
              var sourceTypes = source.types;
              for (var _e = 0, sourceTypes_2 = sourceTypes; _e < sourceTypes_2.length; _e++) {
                var sourceType = sourceTypes_2[_e];
                inferFromTypes(sourceType, target);
              }
            } else if (target.flags & 134217728) {
              inferToTemplateLiteralType(source, target);
            } else {
              source = getReducedType(source);
              if (!(priority & 512 && source.flags & (2097152 | 465829888))) {
                var apparentSource = getApparentType(source);
                if (apparentSource !== source && allowComplexConstraintInference && !(apparentSource.flags & (524288 | 2097152))) {
                  allowComplexConstraintInference = false;
                  return inferFromTypes(apparentSource, target);
                }
                source = apparentSource;
              }
              if (source.flags & (524288 | 2097152)) {
                invokeOnce(source, target, inferFromObjectTypes);
              }
            }
          }
          function inferWithPriority(source, target, newPriority) {
            var savePriority = priority;
            priority |= newPriority;
            inferFromTypes(source, target);
            priority = savePriority;
          }
          function invokeOnce(source, target, action) {
            var key2 = source.id + "," + target.id;
            var status = visited && visited.get(key2);
            if (status !== void 0) {
              inferencePriority = Math.min(inferencePriority, status);
              return;
            }
            (visited || (visited = new ts3.Map())).set(key2, -1);
            var saveInferencePriority = inferencePriority;
            inferencePriority = 2048;
            var saveExpandingFlags = expandingFlags;
            var sourceIdentity = getRecursionIdentity(source);
            var targetIdentity = getRecursionIdentity(target);
            if (ts3.contains(sourceStack, sourceIdentity))
              expandingFlags |= 1;
            if (ts3.contains(targetStack, targetIdentity))
              expandingFlags |= 2;
            if (expandingFlags !== 3) {
              (sourceStack || (sourceStack = [])).push(sourceIdentity);
              (targetStack || (targetStack = [])).push(targetIdentity);
              action(source, target);
              targetStack.pop();
              sourceStack.pop();
            } else {
              inferencePriority = -1;
            }
            expandingFlags = saveExpandingFlags;
            visited.set(key2, inferencePriority);
            inferencePriority = Math.min(inferencePriority, saveInferencePriority);
          }
          function inferFromMatchingTypes(sources, targets, matches) {
            var matchedSources;
            var matchedTargets;
            for (var _i = 0, targets_1 = targets; _i < targets_1.length; _i++) {
              var t2 = targets_1[_i];
              for (var _a2 = 0, sources_1 = sources; _a2 < sources_1.length; _a2++) {
                var s2 = sources_1[_a2];
                if (matches(s2, t2)) {
                  inferFromTypes(s2, t2);
                  matchedSources = ts3.appendIfUnique(matchedSources, s2);
                  matchedTargets = ts3.appendIfUnique(matchedTargets, t2);
                }
              }
            }
            return [
              matchedSources ? ts3.filter(sources, function(t3) {
                return !ts3.contains(matchedSources, t3);
              }) : sources,
              matchedTargets ? ts3.filter(targets, function(t3) {
                return !ts3.contains(matchedTargets, t3);
              }) : targets
            ];
          }
          function inferFromTypeArguments(sourceTypes, targetTypes, variances) {
            var count = sourceTypes.length < targetTypes.length ? sourceTypes.length : targetTypes.length;
            for (var i3 = 0; i3 < count; i3++) {
              if (i3 < variances.length && (variances[i3] & 7) === 2) {
                inferFromContravariantTypes(sourceTypes[i3], targetTypes[i3]);
              } else {
                inferFromTypes(sourceTypes[i3], targetTypes[i3]);
              }
            }
          }
          function inferFromContravariantTypes(source, target) {
            if (strictFunctionTypes || priority & 1024) {
              contravariant = !contravariant;
              inferFromTypes(source, target);
              contravariant = !contravariant;
            } else {
              inferFromTypes(source, target);
            }
          }
          function getInferenceInfoForType(type3) {
            if (type3.flags & 8650752) {
              for (var _i = 0, inferences_2 = inferences; _i < inferences_2.length; _i++) {
                var inference = inferences_2[_i];
                if (type3 === inference.typeParameter) {
                  return inference;
                }
              }
            }
            return void 0;
          }
          function getSingleTypeVariableFromIntersectionTypes(types2) {
            var typeVariable;
            for (var _i = 0, types_16 = types2; _i < types_16.length; _i++) {
              var type3 = types_16[_i];
              var t2 = type3.flags & 2097152 && ts3.find(type3.types, function(t3) {
                return !!getInferenceInfoForType(t3);
              });
              if (!t2 || typeVariable && t2 !== typeVariable) {
                return void 0;
              }
              typeVariable = t2;
            }
            return typeVariable;
          }
          function inferToMultipleTypes(source, targets, targetFlags) {
            var typeVariableCount = 0;
            if (targetFlags & 1048576) {
              var nakedTypeVariable = void 0;
              var sources = source.flags & 1048576 ? source.types : [source];
              var matched_1 = new Array(sources.length);
              var inferenceCircularity = false;
              for (var _i = 0, targets_2 = targets; _i < targets_2.length; _i++) {
                var t2 = targets_2[_i];
                if (getInferenceInfoForType(t2)) {
                  nakedTypeVariable = t2;
                  typeVariableCount++;
                } else {
                  for (var i3 = 0; i3 < sources.length; i3++) {
                    var saveInferencePriority = inferencePriority;
                    inferencePriority = 2048;
                    inferFromTypes(sources[i3], t2);
                    if (inferencePriority === priority)
                      matched_1[i3] = true;
                    inferenceCircularity = inferenceCircularity || inferencePriority === -1;
                    inferencePriority = Math.min(inferencePriority, saveInferencePriority);
                  }
                }
              }
              if (typeVariableCount === 0) {
                var intersectionTypeVariable = getSingleTypeVariableFromIntersectionTypes(targets);
                if (intersectionTypeVariable) {
                  inferWithPriority(source, intersectionTypeVariable, 1);
                }
                return;
              }
              if (typeVariableCount === 1 && !inferenceCircularity) {
                var unmatched = ts3.flatMap(sources, function(s2, i4) {
                  return matched_1[i4] ? void 0 : s2;
                });
                if (unmatched.length) {
                  inferFromTypes(getUnionType(unmatched), nakedTypeVariable);
                  return;
                }
              }
            } else {
              for (var _a2 = 0, targets_3 = targets; _a2 < targets_3.length; _a2++) {
                var t2 = targets_3[_a2];
                if (getInferenceInfoForType(t2)) {
                  typeVariableCount++;
                } else {
                  inferFromTypes(source, t2);
                }
              }
            }
            if (targetFlags & 2097152 ? typeVariableCount === 1 : typeVariableCount > 0) {
              for (var _b = 0, targets_4 = targets; _b < targets_4.length; _b++) {
                var t2 = targets_4[_b];
                if (getInferenceInfoForType(t2)) {
                  inferWithPriority(source, t2, 1);
                }
              }
            }
          }
          function inferToMappedType(source, target, constraintType) {
            if (constraintType.flags & 1048576) {
              var result2 = false;
              for (var _i = 0, _a2 = constraintType.types; _i < _a2.length; _i++) {
                var type3 = _a2[_i];
                result2 = inferToMappedType(source, target, type3) || result2;
              }
              return result2;
            }
            if (constraintType.flags & 4194304) {
              var inference = getInferenceInfoForType(constraintType.type);
              if (inference && !inference.isFixed && !isFromInferenceBlockedSource(source)) {
                var inferredType = inferTypeForHomomorphicMappedType(source, target, constraintType);
                if (inferredType) {
                  inferWithPriority(inferredType, inference.typeParameter, ts3.getObjectFlags(source) & 524288 ? 16 : 8);
                }
              }
              return true;
            }
            if (constraintType.flags & 262144) {
              inferWithPriority(getIndexType(source), constraintType, 32);
              var extendedConstraint = getConstraintOfType(constraintType);
              if (extendedConstraint && inferToMappedType(source, target, extendedConstraint)) {
                return true;
              }
              var propTypes = ts3.map(getPropertiesOfType(source), getTypeOfSymbol);
              var stringIndexType = getIndexTypeOfType(source, 0);
              var numberIndexInfo = getNonEnumNumberIndexInfo(source);
              var numberIndexType = numberIndexInfo && numberIndexInfo.type;
              inferFromTypes(getUnionType(ts3.append(ts3.append(propTypes, stringIndexType), numberIndexType)), getTemplateTypeFromMappedType(target));
              return true;
            }
            return false;
          }
          function inferToConditionalType(source, target) {
            if (source.flags & 16777216) {
              inferFromTypes(source.checkType, target.checkType);
              inferFromTypes(source.extendsType, target.extendsType);
              inferFromTypes(getTrueTypeFromConditionalType(source), getTrueTypeFromConditionalType(target));
              inferFromTypes(getFalseTypeFromConditionalType(source), getFalseTypeFromConditionalType(target));
            } else {
              var savePriority = priority;
              priority |= contravariant ? 64 : 0;
              var targetTypes = [getTrueTypeFromConditionalType(target), getFalseTypeFromConditionalType(target)];
              inferToMultipleTypes(source, targetTypes, target.flags);
              priority = savePriority;
            }
          }
          function inferToTemplateLiteralType(source, target) {
            var matches = inferTypesFromTemplateLiteralType(source, target);
            var types2 = target.types;
            for (var i3 = 0; i3 < types2.length; i3++) {
              inferFromTypes(matches ? matches[i3] : neverType, types2[i3]);
            }
          }
          function inferFromObjectTypes(source, target) {
            if (ts3.getObjectFlags(source) & 4 && ts3.getObjectFlags(target) & 4 && (source.target === target.target || isArrayType(source) && isArrayType(target))) {
              inferFromTypeArguments(getTypeArguments(source), getTypeArguments(target), getVariances(source.target));
              return;
            }
            if (isGenericMappedType(source) && isGenericMappedType(target)) {
              inferFromTypes(getConstraintTypeFromMappedType(source), getConstraintTypeFromMappedType(target));
              inferFromTypes(getTemplateTypeFromMappedType(source), getTemplateTypeFromMappedType(target));
              var sourceNameType = getNameTypeFromMappedType(source);
              var targetNameType = getNameTypeFromMappedType(target);
              if (sourceNameType && targetNameType)
                inferFromTypes(sourceNameType, targetNameType);
            }
            if (ts3.getObjectFlags(target) & 32 && !target.declaration.nameType) {
              var constraintType = getConstraintTypeFromMappedType(target);
              if (inferToMappedType(source, target, constraintType)) {
                return;
              }
            }
            if (!typesDefinitelyUnrelated(source, target)) {
              if (isArrayType(source) || isTupleType(source)) {
                if (isTupleType(target)) {
                  var sourceArity = getTypeReferenceArity(source);
                  var targetArity = getTypeReferenceArity(target);
                  var elementTypes = getTypeArguments(target);
                  var elementFlags = target.target.elementFlags;
                  if (isTupleType(source) && isTupleTypeStructureMatching(source, target)) {
                    for (var i3 = 0; i3 < targetArity; i3++) {
                      inferFromTypes(getTypeArguments(source)[i3], elementTypes[i3]);
                    }
                    return;
                  }
                  var startLength = isTupleType(source) ? Math.min(source.target.fixedLength, target.target.fixedLength) : 0;
                  var endLength = Math.min(isTupleType(source) ? getEndElementCount(source.target, 3) : 0, target.target.hasRestElement ? getEndElementCount(target.target, 3) : 0);
                  for (var i3 = 0; i3 < startLength; i3++) {
                    inferFromTypes(getTypeArguments(source)[i3], elementTypes[i3]);
                  }
                  if (!isTupleType(source) || sourceArity - startLength - endLength === 1 && source.target.elementFlags[startLength] & 4) {
                    var restType = getTypeArguments(source)[startLength];
                    for (var i3 = startLength; i3 < targetArity - endLength; i3++) {
                      inferFromTypes(elementFlags[i3] & 8 ? createArrayType(restType) : restType, elementTypes[i3]);
                    }
                  } else {
                    var middleLength = targetArity - startLength - endLength;
                    if (middleLength === 2 && elementFlags[startLength] & elementFlags[startLength + 1] & 8 && isTupleType(source)) {
                      var targetInfo = getInferenceInfoForType(elementTypes[startLength]);
                      if (targetInfo && targetInfo.impliedArity !== void 0) {
                        inferFromTypes(sliceTupleType(source, startLength, endLength + sourceArity - targetInfo.impliedArity), elementTypes[startLength]);
                        inferFromTypes(sliceTupleType(source, startLength + targetInfo.impliedArity, endLength), elementTypes[startLength + 1]);
                      }
                    } else if (middleLength === 1 && elementFlags[startLength] & 8) {
                      var endsInOptional = target.target.elementFlags[targetArity - 1] & 2;
                      var sourceSlice = isTupleType(source) ? sliceTupleType(source, startLength, endLength) : createArrayType(getTypeArguments(source)[0]);
                      inferWithPriority(sourceSlice, elementTypes[startLength], endsInOptional ? 2 : 0);
                    } else if (middleLength === 1 && elementFlags[startLength] & 4) {
                      var restType = isTupleType(source) ? getElementTypeOfSliceOfTupleType(source, startLength, endLength) : getTypeArguments(source)[0];
                      if (restType) {
                        inferFromTypes(restType, elementTypes[startLength]);
                      }
                    }
                  }
                  for (var i3 = 0; i3 < endLength; i3++) {
                    inferFromTypes(getTypeArguments(source)[sourceArity - i3 - 1], elementTypes[targetArity - i3 - 1]);
                  }
                  return;
                }
                if (isArrayType(target)) {
                  inferFromIndexTypes(source, target);
                  return;
                }
              }
              inferFromProperties(source, target);
              inferFromSignatures(source, target, 0);
              inferFromSignatures(source, target, 1);
              inferFromIndexTypes(source, target);
            }
          }
          function inferFromProperties(source, target) {
            var properties = getPropertiesOfObjectType(target);
            for (var _i = 0, properties_3 = properties; _i < properties_3.length; _i++) {
              var targetProp = properties_3[_i];
              var sourceProp = getPropertyOfType(source, targetProp.escapedName);
              if (sourceProp) {
                inferFromTypes(getTypeOfSymbol(sourceProp), getTypeOfSymbol(targetProp));
              }
            }
          }
          function inferFromSignatures(source, target, kind) {
            var sourceSignatures = getSignaturesOfType(source, kind);
            var targetSignatures = getSignaturesOfType(target, kind);
            var sourceLen = sourceSignatures.length;
            var targetLen = targetSignatures.length;
            var len = sourceLen < targetLen ? sourceLen : targetLen;
            var skipParameters = !!(ts3.getObjectFlags(source) & 524288);
            for (var i3 = 0; i3 < len; i3++) {
              inferFromSignature(getBaseSignature(sourceSignatures[sourceLen - len + i3]), getErasedSignature(targetSignatures[targetLen - len + i3]), skipParameters);
            }
          }
          function inferFromSignature(source, target, skipParameters) {
            if (!skipParameters) {
              var saveBivariant = bivariant;
              var kind = target.declaration ? target.declaration.kind : 0;
              bivariant = bivariant || kind === 166 || kind === 165 || kind === 167;
              applyToParameterTypes(source, target, inferFromContravariantTypes);
              bivariant = saveBivariant;
            }
            applyToReturnTypes(source, target, inferFromTypes);
          }
          function inferFromIndexTypes(source, target) {
            var priority2 = ts3.getObjectFlags(source) & ts3.getObjectFlags(target) & 32 ? 8 : 0;
            var targetStringIndexType = getIndexTypeOfType(target, 0);
            if (targetStringIndexType) {
              var sourceIndexType = getIndexTypeOfType(source, 0) || getImplicitIndexTypeOfType(source, 0);
              if (sourceIndexType) {
                inferWithPriority(sourceIndexType, targetStringIndexType, priority2);
              }
            }
            var targetNumberIndexType = getIndexTypeOfType(target, 1);
            if (targetNumberIndexType) {
              var sourceIndexType = getIndexTypeOfType(source, 1) || getIndexTypeOfType(source, 0) || getImplicitIndexTypeOfType(source, 1);
              if (sourceIndexType) {
                inferWithPriority(sourceIndexType, targetNumberIndexType, priority2);
              }
            }
          }
        }
        function isTypeOrBaseIdenticalTo(s2, t2) {
          return isTypeIdenticalTo(s2, t2) || !!(t2.flags & 4 && s2.flags & 128 || t2.flags & 8 && s2.flags & 256);
        }
        function isTypeCloselyMatchedBy(s2, t2) {
          return !!(s2.flags & 524288 && t2.flags & 524288 && s2.symbol && s2.symbol === t2.symbol || s2.aliasSymbol && s2.aliasTypeArguments && s2.aliasSymbol === t2.aliasSymbol);
        }
        function hasPrimitiveConstraint(type3) {
          var constraint = getConstraintOfTypeParameter(type3);
          return !!constraint && maybeTypeOfKind(constraint.flags & 16777216 ? getDefaultConstraintOfConditionalType(constraint) : constraint, 131068 | 4194304 | 134217728 | 268435456);
        }
        function isObjectLiteralType(type3) {
          return !!(ts3.getObjectFlags(type3) & 128);
        }
        function isObjectOrArrayLiteralType(type3) {
          return !!(ts3.getObjectFlags(type3) & (128 | 32768));
        }
        function unionObjectAndArrayLiteralCandidates(candidates) {
          if (candidates.length > 1) {
            var objectLiterals = ts3.filter(candidates, isObjectOrArrayLiteralType);
            if (objectLiterals.length) {
              var literalsType = getUnionType(objectLiterals, 2);
              return ts3.concatenate(ts3.filter(candidates, function(t2) {
                return !isObjectOrArrayLiteralType(t2);
              }), [literalsType]);
            }
          }
          return candidates;
        }
        function getContravariantInference(inference) {
          return inference.priority & 416 ? getIntersectionType(inference.contraCandidates) : getCommonSubtype(inference.contraCandidates);
        }
        function getCovariantInference(inference, signature) {
          var candidates = unionObjectAndArrayLiteralCandidates(inference.candidates);
          var primitiveConstraint = hasPrimitiveConstraint(inference.typeParameter);
          var widenLiteralTypes = !primitiveConstraint && inference.topLevel && (inference.isFixed || !isTypeParameterAtTopLevel(getReturnTypeOfSignature(signature), inference.typeParameter));
          var baseCandidates = primitiveConstraint ? ts3.sameMap(candidates, getRegularTypeOfLiteralType) : widenLiteralTypes ? ts3.sameMap(candidates, getWidenedLiteralType) : candidates;
          var unwidenedType = inference.priority & 416 ? getUnionType(baseCandidates, 2) : getCommonSupertype(baseCandidates);
          return getWidenedType(unwidenedType);
        }
        function getInferredType(context, index) {
          var inference = context.inferences[index];
          if (!inference.inferredType) {
            var inferredType = void 0;
            var signature = context.signature;
            if (signature) {
              var inferredCovariantType = inference.candidates ? getCovariantInference(inference, signature) : void 0;
              if (inference.contraCandidates) {
                var inferredContravariantType = getContravariantInference(inference);
                inferredType = inferredCovariantType && !(inferredCovariantType.flags & 131072) && isTypeSubtypeOf(inferredCovariantType, inferredContravariantType) ? inferredCovariantType : inferredContravariantType;
              } else if (inferredCovariantType) {
                inferredType = inferredCovariantType;
              } else if (context.flags & 1) {
                inferredType = silentNeverType;
              } else {
                var defaultType = getDefaultFromTypeParameter(inference.typeParameter);
                if (defaultType) {
                  inferredType = instantiateType(defaultType, mergeTypeMappers(createBackreferenceMapper(context, index), context.nonFixingMapper));
                }
              }
            } else {
              inferredType = getTypeFromInference(inference);
            }
            inference.inferredType = inferredType || getDefaultTypeArgumentType(!!(context.flags & 2));
            var constraint = getConstraintOfTypeParameter(inference.typeParameter);
            if (constraint) {
              var instantiatedConstraint = instantiateType(constraint, context.nonFixingMapper);
              if (!inferredType || !context.compareTypes(inferredType, getTypeWithThisArgument(instantiatedConstraint, inferredType))) {
                inference.inferredType = inferredType = instantiatedConstraint;
              }
            }
          }
          return inference.inferredType;
        }
        function getDefaultTypeArgumentType(isInJavaScriptFile) {
          return isInJavaScriptFile ? anyType : unknownType;
        }
        function getInferredTypes(context) {
          var result2 = [];
          for (var i3 = 0; i3 < context.inferences.length; i3++) {
            result2.push(getInferredType(context, i3));
          }
          return result2;
        }
        function getCannotFindNameDiagnosticForName(node) {
          switch (node.escapedText) {
            case "document":
            case "console":
              return ts3.Diagnostics.Cannot_find_name_0_Do_you_need_to_change_your_target_library_Try_changing_the_lib_compiler_option_to_include_dom;
            case "$":
              return compilerOptions.types ? ts3.Diagnostics.Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_jQuery_Try_npm_i_save_dev_types_Slashjquery_and_then_add_jquery_to_the_types_field_in_your_tsconfig : ts3.Diagnostics.Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_jQuery_Try_npm_i_save_dev_types_Slashjquery;
            case "describe":
            case "suite":
            case "it":
            case "test":
              return compilerOptions.types ? ts3.Diagnostics.Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_a_test_runner_Try_npm_i_save_dev_types_Slashjest_or_npm_i_save_dev_types_Slashmocha_and_then_add_jest_or_mocha_to_the_types_field_in_your_tsconfig : ts3.Diagnostics.Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_a_test_runner_Try_npm_i_save_dev_types_Slashjest_or_npm_i_save_dev_types_Slashmocha;
            case "process":
            case "require":
            case "Buffer":
            case "module":
              return compilerOptions.types ? ts3.Diagnostics.Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_node_Try_npm_i_save_dev_types_Slashnode_and_then_add_node_to_the_types_field_in_your_tsconfig : ts3.Diagnostics.Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_node_Try_npm_i_save_dev_types_Slashnode;
            case "Map":
            case "Set":
            case "Promise":
            case "Symbol":
            case "WeakMap":
            case "WeakSet":
            case "Iterator":
            case "AsyncIterator":
            case "SharedArrayBuffer":
            case "Atomics":
            case "AsyncIterable":
            case "AsyncIterableIterator":
            case "AsyncGenerator":
            case "AsyncGeneratorFunction":
            case "BigInt":
            case "Reflect":
            case "BigInt64Array":
            case "BigUint64Array":
              return ts3.Diagnostics.Cannot_find_name_0_Do_you_need_to_change_your_target_library_Try_changing_the_lib_compiler_option_to_1_or_later;
            default:
              if (node.parent.kind === 290) {
                return ts3.Diagnostics.No_value_exists_in_scope_for_the_shorthand_property_0_Either_declare_one_or_provide_an_initializer;
              } else {
                return ts3.Diagnostics.Cannot_find_name_0;
              }
          }
        }
        function getResolvedSymbol(node) {
          var links = getNodeLinks(node);
          if (!links.resolvedSymbol) {
            links.resolvedSymbol = !ts3.nodeIsMissing(node) && resolveName(node, node.escapedText, 111551 | 1048576, getCannotFindNameDiagnosticForName(node), node, !ts3.isWriteOnlyAccess(node), false, ts3.Diagnostics.Cannot_find_name_0_Did_you_mean_1) || unknownSymbol;
          }
          return links.resolvedSymbol;
        }
        function isInTypeQuery(node) {
          return !!ts3.findAncestor(node, function(n2) {
            return n2.kind === 177 ? true : n2.kind === 78 || n2.kind === 158 ? false : "quit";
          });
        }
        function getFlowCacheKey(node, declaredType, initialType, flowContainer) {
          switch (node.kind) {
            case 78:
              var symbol = getResolvedSymbol(node);
              return symbol !== unknownSymbol ? (flowContainer ? getNodeId(flowContainer) : "-1") + "|" + getTypeId(declaredType) + "|" + getTypeId(initialType) + "|" + getSymbolId(symbol) : void 0;
            case 107:
              return "0|" + (flowContainer ? getNodeId(flowContainer) : "-1") + "|" + getTypeId(declaredType) + "|" + getTypeId(initialType);
            case 226:
            case 208:
              return getFlowCacheKey(node.expression, declaredType, initialType, flowContainer);
            case 202:
            case 203:
              var propName = getAccessedPropertyName(node);
              if (propName !== void 0) {
                var key2 = getFlowCacheKey(node.expression, declaredType, initialType, flowContainer);
                return key2 && key2 + "." + propName;
              }
          }
          return void 0;
        }
        function isMatchingReference(source, target) {
          switch (target.kind) {
            case 208:
            case 226:
              return isMatchingReference(source, target.expression);
            case 217:
              return ts3.isAssignmentExpression(target) && isMatchingReference(source, target.left) || ts3.isBinaryExpression(target) && target.operatorToken.kind === 27 && isMatchingReference(source, target.right);
          }
          switch (source.kind) {
            case 227:
              return target.kind === 227 && source.keywordToken === target.keywordToken && source.name.escapedText === target.name.escapedText;
            case 78:
            case 79:
              return target.kind === 78 && getResolvedSymbol(source) === getResolvedSymbol(target) || (target.kind === 250 || target.kind === 199) && getExportSymbolOfValueSymbolIfExported(getResolvedSymbol(source)) === getSymbolOfNode(target);
            case 107:
              return target.kind === 107;
            case 105:
              return target.kind === 105;
            case 226:
            case 208:
              return isMatchingReference(source.expression, target);
            case 202:
            case 203:
              return ts3.isAccessExpression(target) && getAccessedPropertyName(source) === getAccessedPropertyName(target) && isMatchingReference(source.expression, target.expression);
            case 158:
              return ts3.isAccessExpression(target) && source.right.escapedText === getAccessedPropertyName(target) && isMatchingReference(source.left, target.expression);
            case 217:
              return ts3.isBinaryExpression(source) && source.operatorToken.kind === 27 && isMatchingReference(source.right, target);
          }
          return false;
        }
        function containsTruthyCheck(source, target) {
          return isMatchingReference(source, target) || target.kind === 217 && target.operatorToken.kind === 55 && (containsTruthyCheck(source, target.left) || containsTruthyCheck(source, target.right));
        }
        function getAccessedPropertyName(access) {
          return access.kind === 202 ? access.name.escapedText : ts3.isStringOrNumericLiteralLike(access.argumentExpression) ? ts3.escapeLeadingUnderscores(access.argumentExpression.text) : void 0;
        }
        function containsMatchingReference(source, target) {
          while (ts3.isAccessExpression(source)) {
            source = source.expression;
            if (isMatchingReference(source, target)) {
              return true;
            }
          }
          return false;
        }
        function optionalChainContainsReference(source, target) {
          while (ts3.isOptionalChain(source)) {
            source = source.expression;
            if (isMatchingReference(source, target)) {
              return true;
            }
          }
          return false;
        }
        function isDiscriminantProperty(type3, name) {
          if (type3 && type3.flags & 1048576) {
            var prop = getUnionOrIntersectionProperty(type3, name);
            if (prop && ts3.getCheckFlags(prop) & 2) {
              if (prop.isDiscriminantProperty === void 0) {
                prop.isDiscriminantProperty = (prop.checkFlags & 192) === 192 && !maybeTypeOfKind(getTypeOfSymbol(prop), 465829888);
              }
              return !!prop.isDiscriminantProperty;
            }
          }
          return false;
        }
        function findDiscriminantProperties(sourceProperties, target) {
          var result2;
          for (var _i = 0, sourceProperties_2 = sourceProperties; _i < sourceProperties_2.length; _i++) {
            var sourceProperty = sourceProperties_2[_i];
            if (isDiscriminantProperty(target, sourceProperty.escapedName)) {
              if (result2) {
                result2.push(sourceProperty);
                continue;
              }
              result2 = [sourceProperty];
            }
          }
          return result2;
        }
        function mapTypesByKeyProperty(types2, name) {
          var map2 = new ts3.Map();
          var count = 0;
          var _loop_20 = function(type4) {
            if (type4.flags & (524288 | 2097152 | 58982400)) {
              var discriminant = getTypeOfPropertyOfType(type4, name);
              if (discriminant) {
                if (!isLiteralType(discriminant)) {
                  return { value: void 0 };
                }
                var duplicate_1 = false;
                forEachType(discriminant, function(t2) {
                  var id = getTypeId(getRegularTypeOfLiteralType(t2));
                  var existing = map2.get(id);
                  if (!existing) {
                    map2.set(id, type4);
                  } else if (existing !== unknownType) {
                    map2.set(id, unknownType);
                    duplicate_1 = true;
                  }
                });
                if (!duplicate_1)
                  count++;
              }
            }
          };
          for (var _i = 0, types_17 = types2; _i < types_17.length; _i++) {
            var type3 = types_17[_i];
            var state_8 = _loop_20(type3);
            if (typeof state_8 === "object")
              return state_8.value;
          }
          return count >= 10 && count * 2 >= types2.length ? map2 : void 0;
        }
        function getKeyPropertyName(unionType) {
          var types2 = unionType.types;
          if (types2.length < 10 || ts3.getObjectFlags(unionType) & 65536) {
            return void 0;
          }
          if (unionType.keyPropertyName === void 0) {
            var keyPropertyName = ts3.forEach(types2, function(t2) {
              return t2.flags & (524288 | 58982400) ? ts3.forEach(getPropertiesOfType(t2), function(p) {
                return isUnitType(getTypeOfSymbol(p)) ? p.escapedName : void 0;
              }) : void 0;
            });
            var mapByKeyProperty = keyPropertyName && mapTypesByKeyProperty(types2, keyPropertyName);
            unionType.keyPropertyName = mapByKeyProperty ? keyPropertyName : "";
            unionType.constituentMap = mapByKeyProperty;
          }
          return unionType.keyPropertyName.length ? unionType.keyPropertyName : void 0;
        }
        function getConstituentTypeForKeyType(unionType, keyType) {
          var _a2;
          var result2 = (_a2 = unionType.constituentMap) === null || _a2 === void 0 ? void 0 : _a2.get(getTypeId(getRegularTypeOfLiteralType(keyType)));
          return result2 !== unknownType ? result2 : void 0;
        }
        function getMatchingUnionConstituentForType(unionType, type3) {
          var keyPropertyName = getKeyPropertyName(unionType);
          var propType = keyPropertyName && getTypeOfPropertyOfType(type3, keyPropertyName);
          return propType && getConstituentTypeForKeyType(unionType, propType);
        }
        function getMatchingUnionConstituentForObjectLiteral(unionType, node) {
          var keyPropertyName = getKeyPropertyName(unionType);
          var propNode = keyPropertyName && ts3.find(node.properties, function(p) {
            return p.symbol && p.kind === 289 && p.symbol.escapedName === keyPropertyName && isPossiblyDiscriminantValue(p.initializer);
          });
          var propType = propNode && getTypeOfExpression(propNode.initializer);
          return propType && getConstituentTypeForKeyType(unionType, propType);
        }
        function isOrContainsMatchingReference(source, target) {
          return isMatchingReference(source, target) || containsMatchingReference(source, target);
        }
        function hasMatchingArgument(expression, reference) {
          if (expression.arguments) {
            for (var _i = 0, _a2 = expression.arguments; _i < _a2.length; _i++) {
              var argument = _a2[_i];
              if (isOrContainsMatchingReference(reference, argument)) {
                return true;
              }
            }
          }
          if (expression.expression.kind === 202 && isOrContainsMatchingReference(reference, expression.expression.expression)) {
            return true;
          }
          return false;
        }
        function getFlowNodeId(flow) {
          if (!flow.id || flow.id < 0) {
            flow.id = nextFlowId;
            nextFlowId++;
          }
          return flow.id;
        }
        function typeMaybeAssignableTo(source, target) {
          if (!(source.flags & 1048576)) {
            return isTypeAssignableTo(source, target);
          }
          for (var _i = 0, _a2 = source.types; _i < _a2.length; _i++) {
            var t2 = _a2[_i];
            if (isTypeAssignableTo(t2, target)) {
              return true;
            }
          }
          return false;
        }
        function getAssignmentReducedType(declaredType, assignedType) {
          if (declaredType !== assignedType) {
            if (assignedType.flags & 131072) {
              return assignedType;
            }
            var reducedType = filterType(declaredType, function(t2) {
              return typeMaybeAssignableTo(assignedType, t2);
            });
            if (assignedType.flags & 512 && isFreshLiteralType(assignedType)) {
              reducedType = mapType(reducedType, getFreshTypeOfLiteralType);
            }
            if (isTypeAssignableTo(assignedType, reducedType)) {
              return reducedType;
            }
          }
          return declaredType;
        }
        function isFunctionObjectType(type3) {
          var resolved = resolveStructuredTypeMembers(type3);
          return !!(resolved.callSignatures.length || resolved.constructSignatures.length || resolved.members.get("bind") && isTypeSubtypeOf(type3, globalFunctionType));
        }
        function getTypeFacts(type3, ignoreObjects) {
          if (ignoreObjects === void 0) {
            ignoreObjects = false;
          }
          var flags = type3.flags;
          if (flags & 4) {
            return strictNullChecks ? 16317953 : 16776705;
          }
          if (flags & 128) {
            var isEmpty = type3.value === "";
            return strictNullChecks ? isEmpty ? 12123649 : 7929345 : isEmpty ? 12582401 : 16776705;
          }
          if (flags & (8 | 32)) {
            return strictNullChecks ? 16317698 : 16776450;
          }
          if (flags & 256) {
            var isZero = type3.value === 0;
            return strictNullChecks ? isZero ? 12123394 : 7929090 : isZero ? 12582146 : 16776450;
          }
          if (flags & 64) {
            return strictNullChecks ? 16317188 : 16775940;
          }
          if (flags & 2048) {
            var isZero = isZeroBigInt(type3);
            return strictNullChecks ? isZero ? 12122884 : 7928580 : isZero ? 12581636 : 16775940;
          }
          if (flags & 16) {
            return strictNullChecks ? 16316168 : 16774920;
          }
          if (flags & 528) {
            return strictNullChecks ? type3 === falseType || type3 === regularFalseType ? 12121864 : 7927560 : type3 === falseType || type3 === regularFalseType ? 12580616 : 16774920;
          }
          if (flags & 524288 && !ignoreObjects) {
            return ts3.getObjectFlags(type3) & 16 && isEmptyObjectType(type3) ? strictNullChecks ? 16318463 : 16777215 : isFunctionObjectType(type3) ? strictNullChecks ? 7880640 : 16728e3 : strictNullChecks ? 7888800 : 16736160;
          }
          if (flags & (16384 | 32768)) {
            return 9830144;
          }
          if (flags & 65536) {
            return 9363232;
          }
          if (flags & 12288) {
            return strictNullChecks ? 7925520 : 16772880;
          }
          if (flags & 67108864) {
            return strictNullChecks ? 7888800 : 16736160;
          }
          if (flags & 131072) {
            return 0;
          }
          if (flags & 465829888) {
            return !isPatternLiteralType(type3) ? getTypeFacts(getBaseConstraintOfType(type3) || unknownType, ignoreObjects) : strictNullChecks ? 7929345 : 16776705;
          }
          if (flags & 1048576) {
            return ts3.reduceLeft(type3.types, function(facts, t2) {
              return facts | getTypeFacts(t2, ignoreObjects);
            }, 0);
          }
          if (flags & 2097152) {
            ignoreObjects || (ignoreObjects = maybeTypeOfKind(type3, 131068));
            return ts3.reduceLeft(type3.types, function(facts, t2) {
              return facts & getTypeFacts(t2, ignoreObjects);
            }, 16777215);
          }
          return 16777215;
        }
        function getTypeWithFacts(type3, include) {
          return filterType(type3, function(t2) {
            return (getTypeFacts(t2) & include) !== 0;
          });
        }
        function getTypeWithDefault(type3, defaultExpression) {
          return defaultExpression ? getUnionType([getNonUndefinedType(type3), getTypeOfExpression(defaultExpression)]) : type3;
        }
        function getTypeOfDestructuredProperty(type3, name) {
          var nameType = getLiteralTypeFromPropertyName(name);
          if (!isTypeUsableAsPropertyName(nameType))
            return errorType;
          var text = getPropertyNameFromType(nameType);
          return getTypeOfPropertyOfType(type3, text) || isNumericLiteralName(text) && includeUndefinedInIndexSignature(getIndexTypeOfType(type3, 1)) || includeUndefinedInIndexSignature(getIndexTypeOfType(type3, 0)) || errorType;
        }
        function getTypeOfDestructuredArrayElement(type3, index) {
          return everyType(type3, isTupleLikeType) && getTupleElementType(type3, index) || includeUndefinedInIndexSignature(checkIteratedTypeOrElementType(65, type3, undefinedType, void 0)) || errorType;
        }
        function includeUndefinedInIndexSignature(type3) {
          if (!type3)
            return type3;
          return compilerOptions.noUncheckedIndexedAccess ? getUnionType([type3, undefinedType]) : type3;
        }
        function getTypeOfDestructuredSpreadExpression(type3) {
          return createArrayType(checkIteratedTypeOrElementType(65, type3, undefinedType, void 0) || errorType);
        }
        function getAssignedTypeOfBinaryExpression(node) {
          var isDestructuringDefaultAssignment = node.parent.kind === 200 && isDestructuringAssignmentTarget(node.parent) || node.parent.kind === 289 && isDestructuringAssignmentTarget(node.parent.parent);
          return isDestructuringDefaultAssignment ? getTypeWithDefault(getAssignedType(node), node.right) : getTypeOfExpression(node.right);
        }
        function isDestructuringAssignmentTarget(parent) {
          return parent.parent.kind === 217 && parent.parent.left === parent || parent.parent.kind === 240 && parent.parent.initializer === parent;
        }
        function getAssignedTypeOfArrayLiteralElement(node, element) {
          return getTypeOfDestructuredArrayElement(getAssignedType(node), node.elements.indexOf(element));
        }
        function getAssignedTypeOfSpreadExpression(node) {
          return getTypeOfDestructuredSpreadExpression(getAssignedType(node.parent));
        }
        function getAssignedTypeOfPropertyAssignment(node) {
          return getTypeOfDestructuredProperty(getAssignedType(node.parent), node.name);
        }
        function getAssignedTypeOfShorthandPropertyAssignment(node) {
          return getTypeWithDefault(getAssignedTypeOfPropertyAssignment(node), node.objectAssignmentInitializer);
        }
        function getAssignedType(node) {
          var parent = node.parent;
          switch (parent.kind) {
            case 239:
              return stringType;
            case 240:
              return checkRightHandSideOfForOf(parent) || errorType;
            case 217:
              return getAssignedTypeOfBinaryExpression(parent);
            case 211:
              return undefinedType;
            case 200:
              return getAssignedTypeOfArrayLiteralElement(parent, node);
            case 221:
              return getAssignedTypeOfSpreadExpression(parent);
            case 289:
              return getAssignedTypeOfPropertyAssignment(parent);
            case 290:
              return getAssignedTypeOfShorthandPropertyAssignment(parent);
          }
          return errorType;
        }
        function getInitialTypeOfBindingElement(node) {
          var pattern = node.parent;
          var parentType = getInitialType(pattern.parent);
          var type3 = pattern.kind === 197 ? getTypeOfDestructuredProperty(parentType, node.propertyName || node.name) : !node.dotDotDotToken ? getTypeOfDestructuredArrayElement(parentType, pattern.elements.indexOf(node)) : getTypeOfDestructuredSpreadExpression(parentType);
          return getTypeWithDefault(type3, node.initializer);
        }
        function getTypeOfInitializer(node) {
          var links = getNodeLinks(node);
          return links.resolvedType || getTypeOfExpression(node);
        }
        function getInitialTypeOfVariableDeclaration(node) {
          if (node.initializer) {
            return getTypeOfInitializer(node.initializer);
          }
          if (node.parent.parent.kind === 239) {
            return stringType;
          }
          if (node.parent.parent.kind === 240) {
            return checkRightHandSideOfForOf(node.parent.parent) || errorType;
          }
          return errorType;
        }
        function getInitialType(node) {
          return node.kind === 250 ? getInitialTypeOfVariableDeclaration(node) : getInitialTypeOfBindingElement(node);
        }
        function isEmptyArrayAssignment(node) {
          return node.kind === 250 && node.initializer && isEmptyArrayLiteral(node.initializer) || node.kind !== 199 && node.parent.kind === 217 && isEmptyArrayLiteral(node.parent.right);
        }
        function getReferenceCandidate(node) {
          switch (node.kind) {
            case 208:
              return getReferenceCandidate(node.expression);
            case 217:
              switch (node.operatorToken.kind) {
                case 62:
                case 74:
                case 75:
                case 76:
                  return getReferenceCandidate(node.left);
                case 27:
                  return getReferenceCandidate(node.right);
              }
          }
          return node;
        }
        function getReferenceRoot(node) {
          var parent = node.parent;
          return parent.kind === 208 || parent.kind === 217 && parent.operatorToken.kind === 62 && parent.left === node || parent.kind === 217 && parent.operatorToken.kind === 27 && parent.right === node ? getReferenceRoot(parent) : node;
        }
        function getTypeOfSwitchClause(clause) {
          if (clause.kind === 285) {
            return getRegularTypeOfLiteralType(getTypeOfExpression(clause.expression));
          }
          return neverType;
        }
        function getSwitchClauseTypes(switchStatement) {
          var links = getNodeLinks(switchStatement);
          if (!links.switchTypes) {
            links.switchTypes = [];
            for (var _i = 0, _a2 = switchStatement.caseBlock.clauses; _i < _a2.length; _i++) {
              var clause = _a2[_i];
              links.switchTypes.push(getTypeOfSwitchClause(clause));
            }
          }
          return links.switchTypes;
        }
        function getSwitchClauseTypeOfWitnesses(switchStatement, retainDefault) {
          var witnesses = [];
          for (var _i = 0, _a2 = switchStatement.caseBlock.clauses; _i < _a2.length; _i++) {
            var clause = _a2[_i];
            if (clause.kind === 285) {
              if (ts3.isStringLiteralLike(clause.expression)) {
                witnesses.push(clause.expression.text);
                continue;
              }
              return ts3.emptyArray;
            }
            if (retainDefault)
              witnesses.push(void 0);
          }
          return witnesses;
        }
        function eachTypeContainedIn(source, types2) {
          return source.flags & 1048576 ? !ts3.forEach(source.types, function(t2) {
            return !ts3.contains(types2, t2);
          }) : ts3.contains(types2, source);
        }
        function isTypeSubsetOf(source, target) {
          return source === target || target.flags & 1048576 && isTypeSubsetOfUnion(source, target);
        }
        function isTypeSubsetOfUnion(source, target) {
          if (source.flags & 1048576) {
            for (var _i = 0, _a2 = source.types; _i < _a2.length; _i++) {
              var t2 = _a2[_i];
              if (!containsType(target.types, t2)) {
                return false;
              }
            }
            return true;
          }
          if (source.flags & 1024 && getBaseTypeOfEnumLiteralType(source) === target) {
            return true;
          }
          return containsType(target.types, source);
        }
        function forEachType(type3, f) {
          return type3.flags & 1048576 ? ts3.forEach(type3.types, f) : f(type3);
        }
        function someType(type3, f) {
          return type3.flags & 1048576 ? ts3.some(type3.types, f) : f(type3);
        }
        function everyType(type3, f) {
          return type3.flags & 1048576 ? ts3.every(type3.types, f) : f(type3);
        }
        function everyContainedType(type3, f) {
          return type3.flags & 3145728 ? ts3.every(type3.types, f) : f(type3);
        }
        function filterType(type3, f) {
          if (type3.flags & 1048576) {
            var types2 = type3.types;
            var filtered = ts3.filter(types2, f);
            if (filtered === types2) {
              return type3;
            }
            var origin = type3.origin;
            var newOrigin = void 0;
            if (origin && origin.flags & 1048576) {
              var originTypes = origin.types;
              var originFiltered = ts3.filter(originTypes, function(t2) {
                return !!(t2.flags & 1048576) || f(t2);
              });
              if (originTypes.length - originFiltered.length === types2.length - filtered.length) {
                if (originFiltered.length === 1) {
                  return originFiltered[0];
                }
                newOrigin = createOriginUnionOrIntersectionType(1048576, originFiltered);
              }
            }
            return getUnionTypeFromSortedList(filtered, type3.objectFlags, void 0, void 0, newOrigin);
          }
          return type3.flags & 131072 || f(type3) ? type3 : neverType;
        }
        function countTypes(type3) {
          return type3.flags & 1048576 ? type3.types.length : 1;
        }
        function mapType(type3, mapper, noReductions) {
          if (type3.flags & 131072) {
            return type3;
          }
          if (!(type3.flags & 1048576)) {
            return mapper(type3);
          }
          var origin = type3.origin;
          var types2 = origin && origin.flags & 1048576 ? origin.types : type3.types;
          var mappedTypes;
          var changed = false;
          for (var _i = 0, types_18 = types2; _i < types_18.length; _i++) {
            var t2 = types_18[_i];
            var mapped = t2.flags & 1048576 ? mapType(t2, mapper, noReductions) : mapper(t2);
            changed || (changed = t2 !== mapped);
            if (mapped) {
              if (!mappedTypes) {
                mappedTypes = [mapped];
              } else {
                mappedTypes.push(mapped);
              }
            }
          }
          return changed ? mappedTypes && getUnionType(mappedTypes, noReductions ? 0 : 1) : type3;
        }
        function mapTypeWithAlias(type3, mapper, aliasSymbol, aliasTypeArguments) {
          return type3.flags & 1048576 && aliasSymbol ? getUnionType(ts3.map(type3.types, mapper), 1, aliasSymbol, aliasTypeArguments) : mapType(type3, mapper);
        }
        function getConstituentCount(type3) {
          return type3.flags & 3145728 ? type3.types.length : 1;
        }
        function extractTypesOfKind(type3, kind) {
          return filterType(type3, function(t2) {
            return (t2.flags & kind) !== 0;
          });
        }
        function replacePrimitivesWithLiterals(typeWithPrimitives, typeWithLiterals) {
          if (isTypeSubsetOf(stringType, typeWithPrimitives) && maybeTypeOfKind(typeWithLiterals, 128) || isTypeSubsetOf(numberType, typeWithPrimitives) && maybeTypeOfKind(typeWithLiterals, 256) || isTypeSubsetOf(bigintType, typeWithPrimitives) && maybeTypeOfKind(typeWithLiterals, 2048)) {
            return mapType(typeWithPrimitives, function(t2) {
              return t2.flags & 4 ? extractTypesOfKind(typeWithLiterals, 4 | 128) : t2.flags & 8 ? extractTypesOfKind(typeWithLiterals, 8 | 256) : t2.flags & 64 ? extractTypesOfKind(typeWithLiterals, 64 | 2048) : t2;
            });
          }
          return typeWithPrimitives;
        }
        function isIncomplete(flowType) {
          return flowType.flags === 0;
        }
        function getTypeFromFlowType(flowType) {
          return flowType.flags === 0 ? flowType.type : flowType;
        }
        function createFlowType(type3, incomplete) {
          return incomplete ? { flags: 0, type: type3.flags & 131072 ? silentNeverType : type3 } : type3;
        }
        function createEvolvingArrayType(elementType) {
          var result2 = createObjectType(256);
          result2.elementType = elementType;
          return result2;
        }
        function getEvolvingArrayType(elementType) {
          return evolvingArrayTypes[elementType.id] || (evolvingArrayTypes[elementType.id] = createEvolvingArrayType(elementType));
        }
        function addEvolvingArrayElementType(evolvingArrayType, node) {
          var elementType = getRegularTypeOfObjectLiteral(getBaseTypeOfLiteralType(getContextFreeTypeOfExpression(node)));
          return isTypeSubsetOf(elementType, evolvingArrayType.elementType) ? evolvingArrayType : getEvolvingArrayType(getUnionType([evolvingArrayType.elementType, elementType]));
        }
        function createFinalArrayType(elementType) {
          return elementType.flags & 131072 ? autoArrayType : createArrayType(elementType.flags & 1048576 ? getUnionType(elementType.types, 2) : elementType);
        }
        function getFinalArrayType(evolvingArrayType) {
          return evolvingArrayType.finalArrayType || (evolvingArrayType.finalArrayType = createFinalArrayType(evolvingArrayType.elementType));
        }
        function finalizeEvolvingArrayType(type3) {
          return ts3.getObjectFlags(type3) & 256 ? getFinalArrayType(type3) : type3;
        }
        function getElementTypeOfEvolvingArrayType(type3) {
          return ts3.getObjectFlags(type3) & 256 ? type3.elementType : neverType;
        }
        function isEvolvingArrayTypeList(types2) {
          var hasEvolvingArrayType = false;
          for (var _i = 0, types_19 = types2; _i < types_19.length; _i++) {
            var t2 = types_19[_i];
            if (!(t2.flags & 131072)) {
              if (!(ts3.getObjectFlags(t2) & 256)) {
                return false;
              }
              hasEvolvingArrayType = true;
            }
          }
          return hasEvolvingArrayType;
        }
        function isEvolvingArrayOperationTarget(node) {
          var root = getReferenceRoot(node);
          var parent = root.parent;
          var isLengthPushOrUnshift = ts3.isPropertyAccessExpression(parent) && (parent.name.escapedText === "length" || parent.parent.kind === 204 && ts3.isIdentifier(parent.name) && ts3.isPushOrUnshiftIdentifier(parent.name));
          var isElementAssignment = parent.kind === 203 && parent.expression === root && parent.parent.kind === 217 && parent.parent.operatorToken.kind === 62 && parent.parent.left === parent && !ts3.isAssignmentTarget(parent.parent) && isTypeAssignableToKind(getTypeOfExpression(parent.argumentExpression), 296);
          return isLengthPushOrUnshift || isElementAssignment;
        }
        function isDeclarationWithExplicitTypeAnnotation(declaration) {
          return (declaration.kind === 250 || declaration.kind === 161 || declaration.kind === 164 || declaration.kind === 163) && !!ts3.getEffectiveTypeAnnotationNode(declaration);
        }
        function getExplicitTypeOfSymbol(symbol, diagnostic) {
          if (symbol.flags & (16 | 8192 | 32 | 512)) {
            return getTypeOfSymbol(symbol);
          }
          if (symbol.flags & (3 | 4)) {
            if (ts3.getCheckFlags(symbol) & 262144) {
              var origin = symbol.syntheticOrigin;
              if (origin && getExplicitTypeOfSymbol(origin)) {
                return getTypeOfSymbol(symbol);
              }
            }
            var declaration = symbol.valueDeclaration;
            if (declaration) {
              if (isDeclarationWithExplicitTypeAnnotation(declaration)) {
                return getTypeOfSymbol(symbol);
              }
              if (ts3.isVariableDeclaration(declaration) && declaration.parent.parent.kind === 240) {
                var statement = declaration.parent.parent;
                var expressionType = getTypeOfDottedName(statement.expression, void 0);
                if (expressionType) {
                  var use = statement.awaitModifier ? 15 : 13;
                  return checkIteratedTypeOrElementType(use, expressionType, undefinedType, void 0);
                }
              }
              if (diagnostic) {
                ts3.addRelatedInfo(diagnostic, ts3.createDiagnosticForNode(declaration, ts3.Diagnostics._0_needs_an_explicit_type_annotation, symbolToString(symbol)));
              }
            }
          }
        }
        function getTypeOfDottedName(node, diagnostic) {
          if (!(node.flags & 16777216)) {
            switch (node.kind) {
              case 78:
                var symbol = getExportSymbolOfValueSymbolIfExported(getResolvedSymbol(node));
                return getExplicitTypeOfSymbol(symbol.flags & 2097152 ? resolveAlias(symbol) : symbol, diagnostic);
              case 107:
                return getExplicitThisType(node);
              case 105:
                return checkSuperExpression(node);
              case 202: {
                var type3 = getTypeOfDottedName(node.expression, diagnostic);
                if (type3) {
                  var name = node.name;
                  var prop = void 0;
                  if (ts3.isPrivateIdentifier(name)) {
                    if (!type3.symbol) {
                      return void 0;
                    }
                    prop = getPropertyOfType(type3, ts3.getSymbolNameForPrivateIdentifier(type3.symbol, name.escapedText));
                  } else {
                    prop = getPropertyOfType(type3, name.escapedText);
                  }
                  return prop && getExplicitTypeOfSymbol(prop, diagnostic);
                }
                return void 0;
              }
              case 208:
                return getTypeOfDottedName(node.expression, diagnostic);
            }
          }
        }
        function getEffectsSignature(node) {
          var links = getNodeLinks(node);
          var signature = links.effectsSignature;
          if (signature === void 0) {
            var funcType = void 0;
            if (node.parent.kind === 234) {
              funcType = getTypeOfDottedName(node.expression, void 0);
            } else if (node.expression.kind !== 105) {
              if (ts3.isOptionalChain(node)) {
                funcType = checkNonNullType(getOptionalExpressionType(checkExpression(node.expression), node.expression), node.expression);
              } else {
                funcType = checkNonNullExpression(node.expression);
              }
            }
            var signatures = getSignaturesOfType(funcType && getApparentType(funcType) || unknownType, 0);
            var candidate = signatures.length === 1 && !signatures[0].typeParameters ? signatures[0] : ts3.some(signatures, hasTypePredicateOrNeverReturnType) ? getResolvedSignature(node) : void 0;
            signature = links.effectsSignature = candidate && hasTypePredicateOrNeverReturnType(candidate) ? candidate : unknownSignature;
          }
          return signature === unknownSignature ? void 0 : signature;
        }
        function hasTypePredicateOrNeverReturnType(signature) {
          return !!(getTypePredicateOfSignature(signature) || signature.declaration && (getReturnTypeFromAnnotation(signature.declaration) || unknownType).flags & 131072);
        }
        function getTypePredicateArgument(predicate, callExpression2) {
          if (predicate.kind === 1 || predicate.kind === 3) {
            return callExpression2.arguments[predicate.parameterIndex];
          }
          var invokedExpression = ts3.skipParentheses(callExpression2.expression);
          return ts3.isAccessExpression(invokedExpression) ? ts3.skipParentheses(invokedExpression.expression) : void 0;
        }
        function reportFlowControlError(node) {
          var block = ts3.findAncestor(node, ts3.isFunctionOrModuleBlock);
          var sourceFile = ts3.getSourceFileOfNode(node);
          var span = ts3.getSpanOfTokenAtPosition(sourceFile, block.statements.pos);
          diagnostics.add(ts3.createFileDiagnostic(sourceFile, span.start, span.length, ts3.Diagnostics.The_containing_function_or_module_body_is_too_large_for_control_flow_analysis));
        }
        function isReachableFlowNode(flow) {
          var result2 = isReachableFlowNodeWorker(flow, false);
          lastFlowNode = flow;
          lastFlowNodeReachable = result2;
          return result2;
        }
        function isFalseExpression(expr) {
          var node = ts3.skipParentheses(expr);
          return node.kind === 94 || node.kind === 217 && (node.operatorToken.kind === 55 && (isFalseExpression(node.left) || isFalseExpression(node.right)) || node.operatorToken.kind === 56 && isFalseExpression(node.left) && isFalseExpression(node.right));
        }
        function isReachableFlowNodeWorker(flow, noCacheCheck) {
          while (true) {
            if (flow === lastFlowNode) {
              return lastFlowNodeReachable;
            }
            var flags = flow.flags;
            if (flags & 4096) {
              if (!noCacheCheck) {
                var id = getFlowNodeId(flow);
                var reachable = flowNodeReachable[id];
                return reachable !== void 0 ? reachable : flowNodeReachable[id] = isReachableFlowNodeWorker(flow, true);
              }
              noCacheCheck = false;
            }
            if (flags & (16 | 96 | 256)) {
              flow = flow.antecedent;
            } else if (flags & 512) {
              var signature = getEffectsSignature(flow.node);
              if (signature) {
                var predicate = getTypePredicateOfSignature(signature);
                if (predicate && predicate.kind === 3 && !predicate.type) {
                  var predicateArgument = flow.node.arguments[predicate.parameterIndex];
                  if (predicateArgument && isFalseExpression(predicateArgument)) {
                    return false;
                  }
                }
                if (getReturnTypeOfSignature(signature).flags & 131072) {
                  return false;
                }
              }
              flow = flow.antecedent;
            } else if (flags & 4) {
              return ts3.some(flow.antecedents, function(f) {
                return isReachableFlowNodeWorker(f, false);
              });
            } else if (flags & 8) {
              var antecedents = flow.antecedents;
              if (antecedents === void 0 || antecedents.length === 0) {
                return false;
              }
              flow = antecedents[0];
            } else if (flags & 128) {
              if (flow.clauseStart === flow.clauseEnd && isExhaustiveSwitchStatement(flow.switchStatement)) {
                return false;
              }
              flow = flow.antecedent;
            } else if (flags & 1024) {
              lastFlowNode = void 0;
              var target = flow.target;
              var saveAntecedents = target.antecedents;
              target.antecedents = flow.antecedents;
              var result2 = isReachableFlowNodeWorker(flow.antecedent, false);
              target.antecedents = saveAntecedents;
              return result2;
            } else {
              return !(flags & 1);
            }
          }
        }
        function isPostSuperFlowNode(flow, noCacheCheck) {
          while (true) {
            var flags = flow.flags;
            if (flags & 4096) {
              if (!noCacheCheck) {
                var id = getFlowNodeId(flow);
                var postSuper = flowNodePostSuper[id];
                return postSuper !== void 0 ? postSuper : flowNodePostSuper[id] = isPostSuperFlowNode(flow, true);
              }
              noCacheCheck = false;
            }
            if (flags & (16 | 96 | 256 | 128)) {
              flow = flow.antecedent;
            } else if (flags & 512) {
              if (flow.node.expression.kind === 105) {
                return true;
              }
              flow = flow.antecedent;
            } else if (flags & 4) {
              return ts3.every(flow.antecedents, function(f) {
                return isPostSuperFlowNode(f, false);
              });
            } else if (flags & 8) {
              flow = flow.antecedents[0];
            } else if (flags & 1024) {
              var target = flow.target;
              var saveAntecedents = target.antecedents;
              target.antecedents = flow.antecedents;
              var result2 = isPostSuperFlowNode(flow.antecedent, false);
              target.antecedents = saveAntecedents;
              return result2;
            } else {
              return !!(flags & 1);
            }
          }
        }
        function getFlowTypeOfReference(reference, declaredType, initialType, flowContainer, couldBeUninitialized) {
          if (initialType === void 0) {
            initialType = declaredType;
          }
          var key2;
          var isKeySet = false;
          var flowDepth = 0;
          if (flowAnalysisDisabled) {
            return errorType;
          }
          if (!reference.flowNode || !couldBeUninitialized && !(declaredType.flags & 536624127)) {
            return declaredType;
          }
          flowInvocationCount++;
          var sharedFlowStart = sharedFlowCount;
          var evolvedType = getTypeFromFlowType(getTypeAtFlowNode(reference.flowNode));
          sharedFlowCount = sharedFlowStart;
          var resultType = ts3.getObjectFlags(evolvedType) & 256 && isEvolvingArrayOperationTarget(reference) ? autoArrayType : finalizeEvolvingArrayType(evolvedType);
          if (resultType === unreachableNeverType || reference.parent && reference.parent.kind === 226 && !(resultType.flags & 131072) && getTypeWithFacts(resultType, 2097152).flags & 131072) {
            return declaredType;
          }
          return resultType;
          function getOrSetCacheKey() {
            if (isKeySet) {
              return key2;
            }
            isKeySet = true;
            return key2 = getFlowCacheKey(reference, declaredType, initialType, flowContainer);
          }
          function getTypeAtFlowNode(flow) {
            if (flowDepth === 2e3) {
              ts3.tracing === null || ts3.tracing === void 0 ? void 0 : ts3.tracing.instant("checkTypes", "getTypeAtFlowNode_DepthLimit", { flowId: flow.id });
              flowAnalysisDisabled = true;
              reportFlowControlError(reference);
              return errorType;
            }
            flowDepth++;
            var sharedFlow;
            while (true) {
              var flags = flow.flags;
              if (flags & 4096) {
                for (var i3 = sharedFlowStart; i3 < sharedFlowCount; i3++) {
                  if (sharedFlowNodes[i3] === flow) {
                    flowDepth--;
                    return sharedFlowTypes[i3];
                  }
                }
                sharedFlow = flow;
              }
              var type3 = void 0;
              if (flags & 16) {
                type3 = getTypeAtFlowAssignment(flow);
                if (!type3) {
                  flow = flow.antecedent;
                  continue;
                }
              } else if (flags & 512) {
                type3 = getTypeAtFlowCall(flow);
                if (!type3) {
                  flow = flow.antecedent;
                  continue;
                }
              } else if (flags & 96) {
                type3 = getTypeAtFlowCondition(flow);
              } else if (flags & 128) {
                type3 = getTypeAtSwitchClause(flow);
              } else if (flags & 12) {
                if (flow.antecedents.length === 1) {
                  flow = flow.antecedents[0];
                  continue;
                }
                type3 = flags & 4 ? getTypeAtFlowBranchLabel(flow) : getTypeAtFlowLoopLabel(flow);
              } else if (flags & 256) {
                type3 = getTypeAtFlowArrayMutation(flow);
                if (!type3) {
                  flow = flow.antecedent;
                  continue;
                }
              } else if (flags & 1024) {
                var target = flow.target;
                var saveAntecedents = target.antecedents;
                target.antecedents = flow.antecedents;
                type3 = getTypeAtFlowNode(flow.antecedent);
                target.antecedents = saveAntecedents;
              } else if (flags & 2) {
                var container = flow.node;
                if (container && container !== flowContainer && reference.kind !== 202 && reference.kind !== 203 && reference.kind !== 107) {
                  flow = container.flowNode;
                  continue;
                }
                type3 = initialType;
              } else {
                type3 = convertAutoToAny(declaredType);
              }
              if (sharedFlow) {
                sharedFlowNodes[sharedFlowCount] = sharedFlow;
                sharedFlowTypes[sharedFlowCount] = type3;
                sharedFlowCount++;
              }
              flowDepth--;
              return type3;
            }
          }
          function getInitialOrAssignedType(flow) {
            var node = flow.node;
            return getNarrowableTypeForReference(node.kind === 250 || node.kind === 199 ? getInitialType(node) : getAssignedType(node), reference);
          }
          function getTypeAtFlowAssignment(flow) {
            var node = flow.node;
            if (isMatchingReference(reference, node)) {
              if (!isReachableFlowNode(flow)) {
                return unreachableNeverType;
              }
              if (ts3.getAssignmentTargetKind(node) === 2) {
                var flowType = getTypeAtFlowNode(flow.antecedent);
                return createFlowType(getBaseTypeOfLiteralType(getTypeFromFlowType(flowType)), isIncomplete(flowType));
              }
              if (declaredType === autoType || declaredType === autoArrayType) {
                if (isEmptyArrayAssignment(node)) {
                  return getEvolvingArrayType(neverType);
                }
                var assignedType = getWidenedLiteralType(getInitialOrAssignedType(flow));
                return isTypeAssignableTo(assignedType, declaredType) ? assignedType : anyArrayType;
              }
              if (declaredType.flags & 1048576) {
                return getAssignmentReducedType(declaredType, getInitialOrAssignedType(flow));
              }
              return declaredType;
            }
            if (containsMatchingReference(reference, node)) {
              if (!isReachableFlowNode(flow)) {
                return unreachableNeverType;
              }
              if (ts3.isVariableDeclaration(node) && (ts3.isInJSFile(node) || ts3.isVarConst(node))) {
                var init = ts3.getDeclaredExpandoInitializer(node);
                if (init && (init.kind === 209 || init.kind === 210)) {
                  return getTypeAtFlowNode(flow.antecedent);
                }
              }
              return declaredType;
            }
            if (ts3.isVariableDeclaration(node) && node.parent.parent.kind === 239 && isMatchingReference(reference, node.parent.parent.expression)) {
              return getNonNullableTypeIfNeeded(getTypeFromFlowType(getTypeAtFlowNode(flow.antecedent)));
            }
            return void 0;
          }
          function narrowTypeByAssertion(type3, expr) {
            var node = ts3.skipParentheses(expr);
            if (node.kind === 94) {
              return unreachableNeverType;
            }
            if (node.kind === 217) {
              if (node.operatorToken.kind === 55) {
                return narrowTypeByAssertion(narrowTypeByAssertion(type3, node.left), node.right);
              }
              if (node.operatorToken.kind === 56) {
                return getUnionType([narrowTypeByAssertion(type3, node.left), narrowTypeByAssertion(type3, node.right)]);
              }
            }
            return narrowType(type3, node, true);
          }
          function getTypeAtFlowCall(flow) {
            var signature = getEffectsSignature(flow.node);
            if (signature) {
              var predicate = getTypePredicateOfSignature(signature);
              if (predicate && (predicate.kind === 2 || predicate.kind === 3)) {
                var flowType = getTypeAtFlowNode(flow.antecedent);
                var type3 = finalizeEvolvingArrayType(getTypeFromFlowType(flowType));
                var narrowedType = predicate.type ? narrowTypeByTypePredicate(type3, predicate, flow.node, true) : predicate.kind === 3 && predicate.parameterIndex >= 0 && predicate.parameterIndex < flow.node.arguments.length ? narrowTypeByAssertion(type3, flow.node.arguments[predicate.parameterIndex]) : type3;
                return narrowedType === type3 ? flowType : createFlowType(narrowedType, isIncomplete(flowType));
              }
              if (getReturnTypeOfSignature(signature).flags & 131072) {
                return unreachableNeverType;
              }
            }
            return void 0;
          }
          function getTypeAtFlowArrayMutation(flow) {
            if (declaredType === autoType || declaredType === autoArrayType) {
              var node = flow.node;
              var expr = node.kind === 204 ? node.expression.expression : node.left.expression;
              if (isMatchingReference(reference, getReferenceCandidate(expr))) {
                var flowType = getTypeAtFlowNode(flow.antecedent);
                var type3 = getTypeFromFlowType(flowType);
                if (ts3.getObjectFlags(type3) & 256) {
                  var evolvedType_1 = type3;
                  if (node.kind === 204) {
                    for (var _i = 0, _a2 = node.arguments; _i < _a2.length; _i++) {
                      var arg2 = _a2[_i];
                      evolvedType_1 = addEvolvingArrayElementType(evolvedType_1, arg2);
                    }
                  } else {
                    var indexType = getContextFreeTypeOfExpression(node.left.argumentExpression);
                    if (isTypeAssignableToKind(indexType, 296)) {
                      evolvedType_1 = addEvolvingArrayElementType(evolvedType_1, node.right);
                    }
                  }
                  return evolvedType_1 === type3 ? flowType : createFlowType(evolvedType_1, isIncomplete(flowType));
                }
                return flowType;
              }
            }
            return void 0;
          }
          function getTypeAtFlowCondition(flow) {
            var flowType = getTypeAtFlowNode(flow.antecedent);
            var type3 = getTypeFromFlowType(flowType);
            if (type3.flags & 131072) {
              return flowType;
            }
            var assumeTrue = (flow.flags & 32) !== 0;
            var nonEvolvingType = finalizeEvolvingArrayType(type3);
            var narrowedType = narrowType(nonEvolvingType, flow.node, assumeTrue);
            if (narrowedType === nonEvolvingType) {
              return flowType;
            }
            return createFlowType(narrowedType, isIncomplete(flowType));
          }
          function getTypeAtSwitchClause(flow) {
            var expr = flow.switchStatement.expression;
            var flowType = getTypeAtFlowNode(flow.antecedent);
            var type3 = getTypeFromFlowType(flowType);
            if (isMatchingReference(reference, expr)) {
              type3 = narrowTypeBySwitchOnDiscriminant(type3, flow.switchStatement, flow.clauseStart, flow.clauseEnd);
            } else if (expr.kind === 212 && isMatchingReference(reference, expr.expression)) {
              type3 = narrowBySwitchOnTypeOf(type3, flow.switchStatement, flow.clauseStart, flow.clauseEnd);
            } else {
              if (strictNullChecks) {
                if (optionalChainContainsReference(expr, reference)) {
                  type3 = narrowTypeBySwitchOptionalChainContainment(type3, flow.switchStatement, flow.clauseStart, flow.clauseEnd, function(t2) {
                    return !(t2.flags & (32768 | 131072));
                  });
                } else if (expr.kind === 212 && optionalChainContainsReference(expr.expression, reference)) {
                  type3 = narrowTypeBySwitchOptionalChainContainment(type3, flow.switchStatement, flow.clauseStart, flow.clauseEnd, function(t2) {
                    return !(t2.flags & 131072 || t2.flags & 128 && t2.value === "undefined");
                  });
                }
              }
              if (isMatchingReferenceDiscriminant(expr, type3)) {
                type3 = narrowTypeBySwitchOnDiscriminantProperty(type3, expr, flow.switchStatement, flow.clauseStart, flow.clauseEnd);
              }
            }
            return createFlowType(type3, isIncomplete(flowType));
          }
          function getTypeAtFlowBranchLabel(flow) {
            var antecedentTypes = [];
            var subtypeReduction = false;
            var seenIncomplete = false;
            var bypassFlow;
            for (var _i = 0, _a2 = flow.antecedents; _i < _a2.length; _i++) {
              var antecedent = _a2[_i];
              if (!bypassFlow && antecedent.flags & 128 && antecedent.clauseStart === antecedent.clauseEnd) {
                bypassFlow = antecedent;
                continue;
              }
              var flowType = getTypeAtFlowNode(antecedent);
              var type3 = getTypeFromFlowType(flowType);
              if (type3 === declaredType && declaredType === initialType) {
                return type3;
              }
              ts3.pushIfUnique(antecedentTypes, type3);
              if (!isTypeSubsetOf(type3, declaredType)) {
                subtypeReduction = true;
              }
              if (isIncomplete(flowType)) {
                seenIncomplete = true;
              }
            }
            if (bypassFlow) {
              var flowType = getTypeAtFlowNode(bypassFlow);
              var type3 = getTypeFromFlowType(flowType);
              if (!ts3.contains(antecedentTypes, type3) && !isExhaustiveSwitchStatement(bypassFlow.switchStatement)) {
                if (type3 === declaredType && declaredType === initialType) {
                  return type3;
                }
                antecedentTypes.push(type3);
                if (!isTypeSubsetOf(type3, declaredType)) {
                  subtypeReduction = true;
                }
                if (isIncomplete(flowType)) {
                  seenIncomplete = true;
                }
              }
            }
            return createFlowType(getUnionOrEvolvingArrayType(antecedentTypes, subtypeReduction ? 2 : 1), seenIncomplete);
          }
          function getTypeAtFlowLoopLabel(flow) {
            var id = getFlowNodeId(flow);
            var cache = flowLoopCaches[id] || (flowLoopCaches[id] = new ts3.Map());
            var key3 = getOrSetCacheKey();
            if (!key3) {
              return declaredType;
            }
            var cached = cache.get(key3);
            if (cached) {
              return cached;
            }
            for (var i3 = flowLoopStart; i3 < flowLoopCount; i3++) {
              if (flowLoopNodes[i3] === flow && flowLoopKeys[i3] === key3 && flowLoopTypes[i3].length) {
                return createFlowType(getUnionOrEvolvingArrayType(flowLoopTypes[i3], 1), true);
              }
            }
            var antecedentTypes = [];
            var subtypeReduction = false;
            var firstAntecedentType;
            for (var _i = 0, _a2 = flow.antecedents; _i < _a2.length; _i++) {
              var antecedent = _a2[_i];
              var flowType = void 0;
              if (!firstAntecedentType) {
                flowType = firstAntecedentType = getTypeAtFlowNode(antecedent);
              } else {
                flowLoopNodes[flowLoopCount] = flow;
                flowLoopKeys[flowLoopCount] = key3;
                flowLoopTypes[flowLoopCount] = antecedentTypes;
                flowLoopCount++;
                var saveFlowTypeCache = flowTypeCache;
                flowTypeCache = void 0;
                flowType = getTypeAtFlowNode(antecedent);
                flowTypeCache = saveFlowTypeCache;
                flowLoopCount--;
                var cached_1 = cache.get(key3);
                if (cached_1) {
                  return cached_1;
                }
              }
              var type3 = getTypeFromFlowType(flowType);
              ts3.pushIfUnique(antecedentTypes, type3);
              if (!isTypeSubsetOf(type3, declaredType)) {
                subtypeReduction = true;
              }
              if (type3 === declaredType) {
                break;
              }
            }
            var result2 = getUnionOrEvolvingArrayType(antecedentTypes, subtypeReduction ? 2 : 1);
            if (isIncomplete(firstAntecedentType)) {
              return createFlowType(result2, true);
            }
            cache.set(key3, result2);
            return result2;
          }
          function getUnionOrEvolvingArrayType(types2, subtypeReduction) {
            if (isEvolvingArrayTypeList(types2)) {
              return getEvolvingArrayType(getUnionType(ts3.map(types2, getElementTypeOfEvolvingArrayType)));
            }
            var result2 = getUnionType(ts3.sameMap(types2, finalizeEvolvingArrayType), subtypeReduction);
            if (result2 !== declaredType && result2.flags & declaredType.flags & 1048576 && ts3.arraysEqual(result2.types, declaredType.types)) {
              return declaredType;
            }
            return result2;
          }
          function isMatchingReferenceDiscriminant(expr, computedType) {
            var type3 = declaredType.flags & 1048576 ? declaredType : computedType;
            if (!(type3.flags & 1048576) || !ts3.isAccessExpression(expr)) {
              return false;
            }
            var name = getAccessedPropertyName(expr);
            if (name === void 0) {
              return false;
            }
            return isMatchingReference(reference, expr.expression) && isDiscriminantProperty(type3, name);
          }
          function narrowTypeByDiscriminant(type3, access, narrowType2) {
            var propName = getAccessedPropertyName(access);
            if (propName === void 0) {
              return type3;
            }
            var removeNullable = strictNullChecks && ts3.isOptionalChain(access) && maybeTypeOfKind(type3, 98304);
            var propType = getTypeOfPropertyOfType(removeNullable ? getTypeWithFacts(type3, 2097152) : type3, propName);
            if (!propType) {
              return type3;
            }
            propType = removeNullable ? getOptionalType(propType) : propType;
            var narrowedPropType = narrowType2(propType);
            return filterType(type3, function(t2) {
              var discriminantType = getTypeOfPropertyOrIndexSignature(t2, propName);
              return !(discriminantType.flags & 131072) && isTypeComparableTo(discriminantType, narrowedPropType);
            });
          }
          function narrowTypeByDiscriminantProperty(type3, access, operator, value, assumeTrue) {
            if ((operator === 36 || operator === 37) && type3.flags & 1048576) {
              var keyPropertyName = getKeyPropertyName(type3);
              if (keyPropertyName && keyPropertyName === getAccessedPropertyName(access)) {
                var candidate_2 = getConstituentTypeForKeyType(type3, getTypeOfExpression(value));
                if (candidate_2) {
                  return operator === (assumeTrue ? 36 : 37) ? candidate_2 : isUnitType(getTypeOfPropertyOfType(candidate_2, keyPropertyName) || unknownType) ? filterType(type3, function(t2) {
                    return t2 !== candidate_2;
                  }) : type3;
                }
              }
            }
            return narrowTypeByDiscriminant(type3, access, function(t2) {
              return narrowTypeByEquality(t2, operator, value, assumeTrue);
            });
          }
          function narrowTypeBySwitchOnDiscriminantProperty(type3, access, switchStatement, clauseStart, clauseEnd) {
            if (clauseStart < clauseEnd && type3.flags & 1048576 && getKeyPropertyName(type3) === getAccessedPropertyName(access)) {
              var clauseTypes = getSwitchClauseTypes(switchStatement).slice(clauseStart, clauseEnd);
              var candidate = getUnionType(ts3.map(clauseTypes, function(t2) {
                return getConstituentTypeForKeyType(type3, t2) || unknownType;
              }));
              if (candidate !== unknownType) {
                return candidate;
              }
            }
            return narrowTypeByDiscriminant(type3, access, function(t2) {
              return narrowTypeBySwitchOnDiscriminant(t2, switchStatement, clauseStart, clauseEnd);
            });
          }
          function narrowTypeByTruthiness(type3, expr, assumeTrue) {
            if (isMatchingReference(reference, expr)) {
              return getTypeWithFacts(type3, assumeTrue ? 4194304 : 8388608);
            }
            if (strictNullChecks && assumeTrue && optionalChainContainsReference(expr, reference)) {
              type3 = getTypeWithFacts(type3, 2097152);
            }
            if (isMatchingReferenceDiscriminant(expr, type3)) {
              return narrowTypeByDiscriminant(type3, expr, function(t2) {
                return getTypeWithFacts(t2, assumeTrue ? 4194304 : 8388608);
              });
            }
            return type3;
          }
          function isTypePresencePossible(type3, propName, assumeTrue) {
            if (getIndexInfoOfType(type3, 0)) {
              return true;
            }
            var prop = getPropertyOfType(type3, propName);
            if (prop) {
              return prop.flags & 16777216 ? true : assumeTrue;
            }
            return !assumeTrue;
          }
          function narrowByInKeyword(type3, literal, assumeTrue) {
            if (type3.flags & 1048576 || type3.flags & 524288 && declaredType !== type3 || isThisTypeParameter(type3) || type3.flags & 2097152 && ts3.every(type3.types, function(t2) {
              return t2.symbol !== globalThisSymbol;
            })) {
              var propName_1 = ts3.escapeLeadingUnderscores(literal.text);
              return filterType(type3, function(t2) {
                return isTypePresencePossible(t2, propName_1, assumeTrue);
              });
            }
            return type3;
          }
          function narrowTypeByBinaryExpression(type3, expr, assumeTrue) {
            switch (expr.operatorToken.kind) {
              case 62:
              case 74:
              case 75:
              case 76:
                return narrowTypeByTruthiness(narrowType(type3, expr.right, assumeTrue), expr.left, assumeTrue);
              case 34:
              case 35:
              case 36:
              case 37:
                var operator = expr.operatorToken.kind;
                var left = getReferenceCandidate(expr.left);
                var right = getReferenceCandidate(expr.right);
                if (left.kind === 212 && ts3.isStringLiteralLike(right)) {
                  return narrowTypeByTypeof(type3, left, operator, right, assumeTrue);
                }
                if (right.kind === 212 && ts3.isStringLiteralLike(left)) {
                  return narrowTypeByTypeof(type3, right, operator, left, assumeTrue);
                }
                if (isMatchingReference(reference, left)) {
                  return narrowTypeByEquality(type3, operator, right, assumeTrue);
                }
                if (isMatchingReference(reference, right)) {
                  return narrowTypeByEquality(type3, operator, left, assumeTrue);
                }
                if (strictNullChecks) {
                  if (optionalChainContainsReference(left, reference)) {
                    type3 = narrowTypeByOptionalChainContainment(type3, operator, right, assumeTrue);
                  } else if (optionalChainContainsReference(right, reference)) {
                    type3 = narrowTypeByOptionalChainContainment(type3, operator, left, assumeTrue);
                  }
                }
                if (isMatchingReferenceDiscriminant(left, type3)) {
                  return narrowTypeByDiscriminantProperty(type3, left, operator, right, assumeTrue);
                }
                if (isMatchingReferenceDiscriminant(right, type3)) {
                  return narrowTypeByDiscriminantProperty(type3, right, operator, left, assumeTrue);
                }
                if (isMatchingConstructorReference(left)) {
                  return narrowTypeByConstructor(type3, operator, right, assumeTrue);
                }
                if (isMatchingConstructorReference(right)) {
                  return narrowTypeByConstructor(type3, operator, left, assumeTrue);
                }
                break;
              case 101:
                return narrowTypeByInstanceof(type3, expr, assumeTrue);
              case 100:
                var target = getReferenceCandidate(expr.right);
                if (ts3.isStringLiteralLike(expr.left) && isMatchingReference(reference, target)) {
                  return narrowByInKeyword(type3, expr.left, assumeTrue);
                }
                break;
              case 27:
                return narrowType(type3, expr.right, assumeTrue);
            }
            return type3;
          }
          function narrowTypeByOptionalChainContainment(type3, operator, value, assumeTrue) {
            var equalsOperator = operator === 34 || operator === 36;
            var nullableFlags = operator === 34 || operator === 35 ? 98304 : 32768;
            var valueType = getTypeOfExpression(value);
            var removeNullable = equalsOperator !== assumeTrue && everyType(valueType, function(t2) {
              return !!(t2.flags & nullableFlags);
            }) || equalsOperator === assumeTrue && everyType(valueType, function(t2) {
              return !(t2.flags & (3 | nullableFlags));
            });
            return removeNullable ? getTypeWithFacts(type3, 2097152) : type3;
          }
          function narrowTypeByEquality(type3, operator, value, assumeTrue) {
            if (type3.flags & 1) {
              return type3;
            }
            if (operator === 35 || operator === 37) {
              assumeTrue = !assumeTrue;
            }
            var valueType = getTypeOfExpression(value);
            if (type3.flags & 2 && assumeTrue && (operator === 36 || operator === 37)) {
              if (valueType.flags & (131068 | 67108864)) {
                return valueType;
              }
              if (valueType.flags & 524288) {
                return nonPrimitiveType;
              }
              return type3;
            }
            if (valueType.flags & 98304) {
              if (!strictNullChecks) {
                return type3;
              }
              var doubleEquals = operator === 34 || operator === 35;
              var facts = doubleEquals ? assumeTrue ? 262144 : 2097152 : valueType.flags & 65536 ? assumeTrue ? 131072 : 1048576 : assumeTrue ? 65536 : 524288;
              return getTypeWithFacts(type3, facts);
            }
            if (assumeTrue) {
              var filterFn = operator === 34 ? function(t2) {
                return areTypesComparable(t2, valueType) || isCoercibleUnderDoubleEquals(t2, valueType);
              } : function(t2) {
                return areTypesComparable(t2, valueType);
              };
              return replacePrimitivesWithLiterals(filterType(type3, filterFn), valueType);
            }
            if (isUnitType(valueType)) {
              return filterType(type3, function(t2) {
                return !(isUnitLikeType(t2) && areTypesComparable(t2, valueType));
              });
            }
            return type3;
          }
          function narrowTypeByTypeof(type3, typeOfExpr, operator, literal, assumeTrue) {
            if (operator === 35 || operator === 37) {
              assumeTrue = !assumeTrue;
            }
            var target = getReferenceCandidate(typeOfExpr.expression);
            if (!isMatchingReference(reference, target)) {
              if (strictNullChecks && optionalChainContainsReference(target, reference) && assumeTrue === (literal.text !== "undefined")) {
                return getTypeWithFacts(type3, 2097152);
              }
              return type3;
            }
            if (type3.flags & 1 && literal.text === "function") {
              return type3;
            }
            if (assumeTrue && type3.flags & 2 && literal.text === "object") {
              if (typeOfExpr.parent.parent.kind === 217) {
                var expr = typeOfExpr.parent.parent;
                if (expr.operatorToken.kind === 55 && expr.right === typeOfExpr.parent && containsTruthyCheck(reference, expr.left)) {
                  return nonPrimitiveType;
                }
              }
              return getUnionType([nonPrimitiveType, nullType]);
            }
            var facts = assumeTrue ? typeofEQFacts.get(literal.text) || 128 : typeofNEFacts.get(literal.text) || 32768;
            var impliedType = getImpliedTypeFromTypeofGuard(type3, literal.text);
            return getTypeWithFacts(assumeTrue && impliedType ? mapType(type3, narrowUnionMemberByTypeof(impliedType)) : type3, facts);
          }
          function narrowTypeBySwitchOptionalChainContainment(type3, switchStatement, clauseStart, clauseEnd, clauseCheck) {
            var everyClauseChecks = clauseStart !== clauseEnd && ts3.every(getSwitchClauseTypes(switchStatement).slice(clauseStart, clauseEnd), clauseCheck);
            return everyClauseChecks ? getTypeWithFacts(type3, 2097152) : type3;
          }
          function narrowTypeBySwitchOnDiscriminant(type3, switchStatement, clauseStart, clauseEnd) {
            var switchTypes = getSwitchClauseTypes(switchStatement);
            if (!switchTypes.length) {
              return type3;
            }
            var clauseTypes = switchTypes.slice(clauseStart, clauseEnd);
            var hasDefaultClause = clauseStart === clauseEnd || ts3.contains(clauseTypes, neverType);
            if (type3.flags & 2 && !hasDefaultClause) {
              var groundClauseTypes = void 0;
              for (var i3 = 0; i3 < clauseTypes.length; i3 += 1) {
                var t2 = clauseTypes[i3];
                if (t2.flags & (131068 | 67108864)) {
                  if (groundClauseTypes !== void 0) {
                    groundClauseTypes.push(t2);
                  }
                } else if (t2.flags & 524288) {
                  if (groundClauseTypes === void 0) {
                    groundClauseTypes = clauseTypes.slice(0, i3);
                  }
                  groundClauseTypes.push(nonPrimitiveType);
                } else {
                  return type3;
                }
              }
              return getUnionType(groundClauseTypes === void 0 ? clauseTypes : groundClauseTypes);
            }
            var discriminantType = getUnionType(clauseTypes);
            var caseType = discriminantType.flags & 131072 ? neverType : replacePrimitivesWithLiterals(filterType(type3, function(t3) {
              return areTypesComparable(discriminantType, t3);
            }), discriminantType);
            if (!hasDefaultClause) {
              return caseType;
            }
            var defaultType = filterType(type3, function(t3) {
              return !(isUnitLikeType(t3) && ts3.contains(switchTypes, getRegularTypeOfLiteralType(extractUnitType(t3))));
            });
            return caseType.flags & 131072 ? defaultType : getUnionType([caseType, defaultType]);
          }
          function getImpliedTypeFromTypeofGuard(type3, text) {
            switch (text) {
              case "function":
                return type3.flags & 1 ? type3 : globalFunctionType;
              case "object":
                return type3.flags & 2 ? getUnionType([nonPrimitiveType, nullType]) : type3;
              default:
                return typeofTypesByName.get(text);
            }
          }
          function narrowUnionMemberByTypeof(candidate) {
            return function(type3) {
              if (isTypeSubtypeOf(type3, candidate)) {
                return type3;
              }
              if (isTypeSubtypeOf(candidate, type3)) {
                return candidate;
              }
              if (type3.flags & 465829888) {
                var constraint = getBaseConstraintOfType(type3) || anyType;
                if (isTypeSubtypeOf(candidate, constraint)) {
                  return getIntersectionType([type3, candidate]);
                }
              }
              return type3;
            };
          }
          function narrowBySwitchOnTypeOf(type3, switchStatement, clauseStart, clauseEnd) {
            var switchWitnesses = getSwitchClauseTypeOfWitnesses(switchStatement, true);
            if (!switchWitnesses.length) {
              return type3;
            }
            var defaultCaseLocation = ts3.findIndex(switchWitnesses, function(elem) {
              return elem === void 0;
            });
            var hasDefaultClause = clauseStart === clauseEnd || defaultCaseLocation >= clauseStart && defaultCaseLocation < clauseEnd;
            var clauseWitnesses;
            var switchFacts;
            if (defaultCaseLocation > -1) {
              var witnesses = switchWitnesses.filter(function(witness) {
                return witness !== void 0;
              });
              var fixedClauseStart = defaultCaseLocation < clauseStart ? clauseStart - 1 : clauseStart;
              var fixedClauseEnd = defaultCaseLocation < clauseEnd ? clauseEnd - 1 : clauseEnd;
              clauseWitnesses = witnesses.slice(fixedClauseStart, fixedClauseEnd);
              switchFacts = getFactsFromTypeofSwitch(fixedClauseStart, fixedClauseEnd, witnesses, hasDefaultClause);
            } else {
              clauseWitnesses = switchWitnesses.slice(clauseStart, clauseEnd);
              switchFacts = getFactsFromTypeofSwitch(clauseStart, clauseEnd, switchWitnesses, hasDefaultClause);
            }
            if (hasDefaultClause) {
              return filterType(type3, function(t2) {
                return (getTypeFacts(t2) & switchFacts) === switchFacts;
              });
            }
            var impliedType = getTypeWithFacts(getUnionType(clauseWitnesses.map(function(text) {
              return getImpliedTypeFromTypeofGuard(type3, text) || type3;
            })), switchFacts);
            return getTypeWithFacts(mapType(type3, narrowUnionMemberByTypeof(impliedType)), switchFacts);
          }
          function isMatchingConstructorReference(expr) {
            return (ts3.isPropertyAccessExpression(expr) && ts3.idText(expr.name) === "constructor" || ts3.isElementAccessExpression(expr) && ts3.isStringLiteralLike(expr.argumentExpression) && expr.argumentExpression.text === "constructor") && isMatchingReference(reference, expr.expression);
          }
          function narrowTypeByConstructor(type3, operator, identifier, assumeTrue) {
            if (assumeTrue ? operator !== 34 && operator !== 36 : operator !== 35 && operator !== 37) {
              return type3;
            }
            var identifierType = getTypeOfExpression(identifier);
            if (!isFunctionType(identifierType) && !isConstructorType(identifierType)) {
              return type3;
            }
            var prototypeProperty = getPropertyOfType(identifierType, "prototype");
            if (!prototypeProperty) {
              return type3;
            }
            var prototypeType = getTypeOfSymbol(prototypeProperty);
            var candidate = !isTypeAny(prototypeType) ? prototypeType : void 0;
            if (!candidate || candidate === globalObjectType || candidate === globalFunctionType) {
              return type3;
            }
            if (isTypeAny(type3)) {
              return candidate;
            }
            return filterType(type3, function(t2) {
              return isConstructedBy(t2, candidate);
            });
            function isConstructedBy(source, target) {
              if (source.flags & 524288 && ts3.getObjectFlags(source) & 1 || target.flags & 524288 && ts3.getObjectFlags(target) & 1) {
                return source.symbol === target.symbol;
              }
              return isTypeSubtypeOf(source, target);
            }
          }
          function narrowTypeByInstanceof(type3, expr, assumeTrue) {
            var left = getReferenceCandidate(expr.left);
            if (!isMatchingReference(reference, left)) {
              if (assumeTrue && strictNullChecks && optionalChainContainsReference(left, reference)) {
                return getTypeWithFacts(type3, 2097152);
              }
              return type3;
            }
            var rightType = getTypeOfExpression(expr.right);
            if (!isTypeDerivedFrom(rightType, globalFunctionType)) {
              return type3;
            }
            var targetType;
            var prototypeProperty = getPropertyOfType(rightType, "prototype");
            if (prototypeProperty) {
              var prototypePropertyType = getTypeOfSymbol(prototypeProperty);
              if (!isTypeAny(prototypePropertyType)) {
                targetType = prototypePropertyType;
              }
            }
            if (isTypeAny(type3) && (targetType === globalObjectType || targetType === globalFunctionType)) {
              return type3;
            }
            if (!targetType) {
              var constructSignatures = getSignaturesOfType(rightType, 1);
              targetType = constructSignatures.length ? getUnionType(ts3.map(constructSignatures, function(signature) {
                return getReturnTypeOfSignature(getErasedSignature(signature));
              })) : emptyObjectType;
            }
            if (!assumeTrue && rightType.flags & 1048576) {
              var nonConstructorTypeInUnion = ts3.find(rightType.types, function(t2) {
                return !isConstructorType(t2);
              });
              if (!nonConstructorTypeInUnion)
                return type3;
            }
            return getNarrowedType(type3, targetType, assumeTrue, isTypeDerivedFrom);
          }
          function getNarrowedType(type3, candidate, assumeTrue, isRelated) {
            if (!assumeTrue) {
              return filterType(type3, function(t2) {
                if (!isRelated(t2, candidate)) {
                  return true;
                }
                var constraint = getBaseConstraintOfType(t2);
                if (constraint && constraint !== t2) {
                  return !isRelated(constraint, candidate);
                }
                return false;
              });
            }
            if (type3.flags & 1048576) {
              var assignableType = filterType(type3, function(t2) {
                return isRelated(t2, candidate);
              });
              if (!(assignableType.flags & 131072)) {
                return assignableType;
              }
            }
            return isTypeSubtypeOf(candidate, type3) ? candidate : isTypeAssignableTo(type3, candidate) ? type3 : isTypeAssignableTo(candidate, type3) ? candidate : getIntersectionType([type3, candidate]);
          }
          function narrowTypeByCallExpression(type3, callExpression2, assumeTrue) {
            if (hasMatchingArgument(callExpression2, reference)) {
              var signature = assumeTrue || !ts3.isCallChain(callExpression2) ? getEffectsSignature(callExpression2) : void 0;
              var predicate = signature && getTypePredicateOfSignature(signature);
              if (predicate && (predicate.kind === 0 || predicate.kind === 1)) {
                return narrowTypeByTypePredicate(type3, predicate, callExpression2, assumeTrue);
              }
            }
            return type3;
          }
          function narrowTypeByTypePredicate(type3, predicate, callExpression2, assumeTrue) {
            if (predicate.type && !(isTypeAny(type3) && (predicate.type === globalObjectType || predicate.type === globalFunctionType))) {
              var predicateArgument = getTypePredicateArgument(predicate, callExpression2);
              if (predicateArgument) {
                if (isMatchingReference(reference, predicateArgument)) {
                  return getNarrowedType(type3, predicate.type, assumeTrue, isTypeSubtypeOf);
                }
                if (strictNullChecks && assumeTrue && optionalChainContainsReference(predicateArgument, reference) && !(getTypeFacts(predicate.type) & 65536)) {
                  type3 = getTypeWithFacts(type3, 2097152);
                }
                if (isMatchingReferenceDiscriminant(predicateArgument, type3)) {
                  return narrowTypeByDiscriminant(type3, predicateArgument, function(t2) {
                    return getNarrowedType(t2, predicate.type, assumeTrue, isTypeSubtypeOf);
                  });
                }
              }
            }
            return type3;
          }
          function narrowType(type3, expr, assumeTrue) {
            if (ts3.isExpressionOfOptionalChainRoot(expr) || ts3.isBinaryExpression(expr.parent) && expr.parent.operatorToken.kind === 60 && expr.parent.left === expr) {
              return narrowTypeByOptionality(type3, expr, assumeTrue);
            }
            switch (expr.kind) {
              case 78:
              case 107:
              case 105:
              case 202:
              case 203:
                return narrowTypeByTruthiness(type3, expr, assumeTrue);
              case 204:
                return narrowTypeByCallExpression(type3, expr, assumeTrue);
              case 208:
              case 226:
                return narrowType(type3, expr.expression, assumeTrue);
              case 217:
                return narrowTypeByBinaryExpression(type3, expr, assumeTrue);
              case 215:
                if (expr.operator === 53) {
                  return narrowType(type3, expr.operand, !assumeTrue);
                }
                break;
            }
            return type3;
          }
          function narrowTypeByOptionality(type3, expr, assumePresent) {
            if (isMatchingReference(reference, expr)) {
              return getTypeWithFacts(type3, assumePresent ? 2097152 : 262144);
            }
            if (isMatchingReferenceDiscriminant(expr, type3)) {
              return narrowTypeByDiscriminant(type3, expr, function(t2) {
                return getTypeWithFacts(t2, assumePresent ? 2097152 : 262144);
              });
            }
            return type3;
          }
        }
        function getTypeOfSymbolAtLocation(symbol, location) {
          symbol = symbol.exportSymbol || symbol;
          if (location.kind === 78 || location.kind === 79) {
            if (ts3.isRightSideOfQualifiedNameOrPropertyAccess(location)) {
              location = location.parent;
            }
            if (ts3.isExpressionNode(location) && (!ts3.isAssignmentTarget(location) || ts3.isWriteAccess(location))) {
              var type3 = getTypeOfExpression(location);
              if (getExportSymbolOfValueSymbolIfExported(getNodeLinks(location).resolvedSymbol) === symbol) {
                return type3;
              }
            }
          }
          if (ts3.isDeclarationName(location) && ts3.isSetAccessor(location.parent) && getAnnotatedAccessorTypeNode(location.parent)) {
            return resolveTypeOfAccessors(location.parent.symbol, true);
          }
          return getTypeOfSymbol(symbol);
        }
        function getControlFlowContainer(node) {
          return ts3.findAncestor(node.parent, function(node2) {
            return ts3.isFunctionLike(node2) && !ts3.getImmediatelyInvokedFunctionExpression(node2) || node2.kind === 258 || node2.kind === 298 || node2.kind === 164;
          });
        }
        function isParameterAssigned(symbol) {
          if (!symbol.valueDeclaration) {
            return false;
          }
          var func2 = ts3.getRootDeclaration(symbol.valueDeclaration).parent;
          var links = getNodeLinks(func2);
          if (!(links.flags & 8388608)) {
            links.flags |= 8388608;
            if (!hasParentWithAssignmentsMarked(func2)) {
              markParameterAssignments(func2);
            }
          }
          return symbol.isAssigned || false;
        }
        function hasParentWithAssignmentsMarked(node) {
          return !!ts3.findAncestor(node.parent, function(node2) {
            return ts3.isFunctionLike(node2) && !!(getNodeLinks(node2).flags & 8388608);
          });
        }
        function markParameterAssignments(node) {
          if (node.kind === 78) {
            if (ts3.isAssignmentTarget(node)) {
              var symbol = getResolvedSymbol(node);
              if (symbol.valueDeclaration && ts3.getRootDeclaration(symbol.valueDeclaration).kind === 161) {
                symbol.isAssigned = true;
              }
            }
          } else {
            ts3.forEachChild(node, markParameterAssignments);
          }
        }
        function isConstVariable(symbol) {
          return symbol.flags & 3 && (getDeclarationNodeFlagsFromSymbol(symbol) & 2) !== 0 && getTypeOfSymbol(symbol) !== autoArrayType;
        }
        function removeOptionalityFromDeclaredType(declaredType, declaration) {
          if (pushTypeResolution(declaration.symbol, 2)) {
            var annotationIncludesUndefined = strictNullChecks && declaration.kind === 161 && declaration.initializer && getFalsyFlags(declaredType) & 32768 && !(getFalsyFlags(checkExpression(declaration.initializer)) & 32768);
            popTypeResolution();
            return annotationIncludesUndefined ? getTypeWithFacts(declaredType, 524288) : declaredType;
          } else {
            reportCircularityError(declaration.symbol);
            return declaredType;
          }
        }
        function isConstraintPosition(node) {
          var parent = node.parent;
          return parent.kind === 202 || parent.kind === 204 && parent.expression === node || parent.kind === 203 && parent.expression === node && !isGenericIndexType(getTypeOfExpression(parent.argumentExpression));
        }
        function isGenericTypeWithUnionConstraint(type3) {
          return !!(type3.flags & 465829888 && getBaseConstraintOrType(type3).flags & (98304 | 1048576));
        }
        function containsGenericType(type3) {
          return !!(type3.flags & 465829888 || type3.flags & 3145728 && ts3.some(type3.types, containsGenericType));
        }
        function hasContextualTypeWithNoGenericTypes(node) {
          var contextualType = (ts3.isIdentifier(node) || ts3.isPropertyAccessExpression(node) || ts3.isElementAccessExpression(node)) && !((ts3.isJsxOpeningElement(node.parent) || ts3.isJsxSelfClosingElement(node.parent)) && node.parent.tagName === node) && getContextualType(node);
          return contextualType && !someType(contextualType, containsGenericType);
        }
        function getNarrowableTypeForReference(type3, reference, checkMode) {
          var substituteConstraints = !(checkMode && checkMode & 2) && someType(type3, isGenericTypeWithUnionConstraint) && (isConstraintPosition(reference) || hasContextualTypeWithNoGenericTypes(reference));
          return substituteConstraints ? mapType(type3, function(t2) {
            return t2.flags & 465829888 ? getBaseConstraintOrType(t2) : t2;
          }) : type3;
        }
        function isExportOrExportExpression(location) {
          return !!ts3.findAncestor(location, function(e2) {
            return e2.parent && ts3.isExportAssignment(e2.parent) && e2.parent.expression === e2 && ts3.isEntityNameExpression(e2);
          });
        }
        function markAliasReferenced(symbol, location) {
          if (isNonLocalAlias(symbol, 111551) && !isInTypeQuery(location) && !getTypeOnlyAliasDeclaration(symbol)) {
            var target = resolveAlias(symbol);
            if (target.flags & 111551) {
              if (compilerOptions.isolatedModules || ts3.shouldPreserveConstEnums(compilerOptions) && isExportOrExportExpression(location) || !isConstEnumOrConstEnumOnlyModule(target)) {
                markAliasSymbolAsReferenced(symbol);
              } else {
                markConstEnumAliasAsReferenced(symbol);
              }
            }
          }
        }
        function checkIdentifier(node, checkMode) {
          var symbol = getResolvedSymbol(node);
          if (symbol === unknownSymbol) {
            return errorType;
          }
          if (symbol === argumentsSymbol) {
            var container = ts3.getContainingFunction(node);
            if (languageVersion < 2) {
              if (container.kind === 210) {
                error(node, ts3.Diagnostics.The_arguments_object_cannot_be_referenced_in_an_arrow_function_in_ES3_and_ES5_Consider_using_a_standard_function_expression);
              } else if (ts3.hasSyntacticModifier(container, 256)) {
                error(node, ts3.Diagnostics.The_arguments_object_cannot_be_referenced_in_an_async_function_or_method_in_ES3_and_ES5_Consider_using_a_standard_function_or_method);
              }
            }
            getNodeLinks(container).flags |= 8192;
            return getTypeOfSymbol(symbol);
          }
          if (!(node.parent && ts3.isPropertyAccessExpression(node.parent) && node.parent.expression === node)) {
            markAliasReferenced(symbol, node);
          }
          var localOrExportSymbol = getExportSymbolOfValueSymbolIfExported(symbol);
          var sourceSymbol = localOrExportSymbol.flags & 2097152 ? resolveAlias(localOrExportSymbol) : localOrExportSymbol;
          if (sourceSymbol.declarations && getDeclarationNodeFlagsFromSymbol(sourceSymbol) & 134217728 && isUncalledFunctionReference(node, sourceSymbol)) {
            addDeprecatedSuggestion(node, sourceSymbol.declarations, node.escapedText);
          }
          var declaration = localOrExportSymbol.valueDeclaration;
          if (declaration && localOrExportSymbol.flags & 32) {
            if (declaration.kind === 253 && ts3.nodeIsDecorated(declaration)) {
              var container = ts3.getContainingClass(node);
              while (container !== void 0) {
                if (container === declaration && container.name !== node) {
                  getNodeLinks(declaration).flags |= 16777216;
                  getNodeLinks(node).flags |= 33554432;
                  break;
                }
                container = ts3.getContainingClass(container);
              }
            } else if (declaration.kind === 222) {
              var container = ts3.getThisContainer(node, false);
              while (container.kind !== 298) {
                if (container.parent === declaration) {
                  if (container.kind === 164 && ts3.hasSyntacticModifier(container, 32)) {
                    getNodeLinks(declaration).flags |= 16777216;
                    getNodeLinks(node).flags |= 33554432;
                  }
                  break;
                }
                container = ts3.getThisContainer(container, false);
              }
            }
          }
          checkNestedBlockScopedBinding(node, symbol);
          var type3 = getTypeOfSymbol(localOrExportSymbol);
          var assignmentKind = ts3.getAssignmentTargetKind(node);
          if (assignmentKind) {
            if (!(localOrExportSymbol.flags & 3) && !(ts3.isInJSFile(node) && localOrExportSymbol.flags & 512)) {
              var assignmentError = localOrExportSymbol.flags & 384 ? ts3.Diagnostics.Cannot_assign_to_0_because_it_is_an_enum : localOrExportSymbol.flags & 32 ? ts3.Diagnostics.Cannot_assign_to_0_because_it_is_a_class : localOrExportSymbol.flags & 1536 ? ts3.Diagnostics.Cannot_assign_to_0_because_it_is_a_namespace : localOrExportSymbol.flags & 16 ? ts3.Diagnostics.Cannot_assign_to_0_because_it_is_a_function : localOrExportSymbol.flags & 2097152 ? ts3.Diagnostics.Cannot_assign_to_0_because_it_is_an_import : ts3.Diagnostics.Cannot_assign_to_0_because_it_is_not_a_variable;
              error(node, assignmentError, symbolToString(symbol));
              return errorType;
            }
            if (isReadonlySymbol(localOrExportSymbol)) {
              if (localOrExportSymbol.flags & 3) {
                error(node, ts3.Diagnostics.Cannot_assign_to_0_because_it_is_a_constant, symbolToString(symbol));
              } else {
                error(node, ts3.Diagnostics.Cannot_assign_to_0_because_it_is_a_read_only_property, symbolToString(symbol));
              }
              return errorType;
            }
          }
          var isAlias = localOrExportSymbol.flags & 2097152;
          if (localOrExportSymbol.flags & 3) {
            if (assignmentKind === 1) {
              return type3;
            }
          } else if (isAlias) {
            declaration = getDeclarationOfAliasSymbol(symbol);
          } else {
            return type3;
          }
          if (!declaration) {
            return type3;
          }
          type3 = getNarrowableTypeForReference(type3, node, checkMode);
          var isParameter = ts3.getRootDeclaration(declaration).kind === 161;
          var declarationContainer = getControlFlowContainer(declaration);
          var flowContainer = getControlFlowContainer(node);
          var isOuterVariable = flowContainer !== declarationContainer;
          var isSpreadDestructuringAssignmentTarget = node.parent && node.parent.parent && ts3.isSpreadAssignment(node.parent) && isDestructuringAssignmentTarget(node.parent.parent);
          var isModuleExports = symbol.flags & 134217728;
          while (flowContainer !== declarationContainer && (flowContainer.kind === 209 || flowContainer.kind === 210 || ts3.isObjectLiteralOrClassExpressionMethod(flowContainer)) && (isConstVariable(localOrExportSymbol) || isParameter && !isParameterAssigned(localOrExportSymbol))) {
            flowContainer = getControlFlowContainer(flowContainer);
          }
          var assumeInitialized = isParameter || isAlias || isOuterVariable || isSpreadDestructuringAssignmentTarget || isModuleExports || ts3.isBindingElement(declaration) || type3 !== autoType && type3 !== autoArrayType && (!strictNullChecks || (type3.flags & (3 | 16384)) !== 0 || isInTypeQuery(node) || node.parent.kind === 271) || node.parent.kind === 226 || declaration.kind === 250 && declaration.exclamationToken || declaration.flags & 8388608;
          var initialType = assumeInitialized ? isParameter ? removeOptionalityFromDeclaredType(type3, declaration) : type3 : type3 === autoType || type3 === autoArrayType ? undefinedType : getOptionalType(type3);
          var flowType = getFlowTypeOfReference(node, type3, initialType, flowContainer, !assumeInitialized);
          if (!isEvolvingArrayOperationTarget(node) && (type3 === autoType || type3 === autoArrayType)) {
            if (flowType === autoType || flowType === autoArrayType) {
              if (noImplicitAny) {
                error(ts3.getNameOfDeclaration(declaration), ts3.Diagnostics.Variable_0_implicitly_has_type_1_in_some_locations_where_its_type_cannot_be_determined, symbolToString(symbol), typeToString(flowType));
                error(node, ts3.Diagnostics.Variable_0_implicitly_has_an_1_type, symbolToString(symbol), typeToString(flowType));
              }
              return convertAutoToAny(flowType);
            }
          } else if (!assumeInitialized && !(getFalsyFlags(type3) & 32768) && getFalsyFlags(flowType) & 32768) {
            error(node, ts3.Diagnostics.Variable_0_is_used_before_being_assigned, symbolToString(symbol));
            return type3;
          }
          return assignmentKind ? getBaseTypeOfLiteralType(flowType) : flowType;
        }
        function isInsideFunctionOrInstancePropertyInitializer(node, threshold) {
          return !!ts3.findAncestor(node, function(n2) {
            return n2 === threshold ? "quit" : ts3.isFunctionLike(n2) || n2.parent && ts3.isPropertyDeclaration(n2.parent) && !ts3.hasStaticModifier(n2.parent) && n2.parent.initializer === n2;
          });
        }
        function getPartOfForStatementContainingNode(node, container) {
          return ts3.findAncestor(node, function(n2) {
            return n2 === container ? "quit" : n2 === container.initializer || n2 === container.condition || n2 === container.incrementor || n2 === container.statement;
          });
        }
        function getEnclosingIterationStatement(node) {
          return ts3.findAncestor(node, function(n2) {
            return !n2 || ts3.nodeStartsNewLexicalEnvironment(n2) ? "quit" : ts3.isIterationStatement(n2, false);
          });
        }
        function checkNestedBlockScopedBinding(node, symbol) {
          if (languageVersion >= 2 || (symbol.flags & (2 | 32)) === 0 || !symbol.valueDeclaration || ts3.isSourceFile(symbol.valueDeclaration) || symbol.valueDeclaration.parent.kind === 288) {
            return;
          }
          var container = ts3.getEnclosingBlockScopeContainer(symbol.valueDeclaration);
          var isCaptured = isInsideFunctionOrInstancePropertyInitializer(node, container);
          var enclosingIterationStatement = getEnclosingIterationStatement(container);
          if (enclosingIterationStatement) {
            if (isCaptured) {
              var capturesBlockScopeBindingInLoopBody = true;
              if (ts3.isForStatement(container)) {
                var varDeclList = ts3.getAncestor(symbol.valueDeclaration, 251);
                if (varDeclList && varDeclList.parent === container) {
                  var part = getPartOfForStatementContainingNode(node.parent, container);
                  if (part) {
                    var links = getNodeLinks(part);
                    links.flags |= 131072;
                    var capturedBindings = links.capturedBlockScopeBindings || (links.capturedBlockScopeBindings = []);
                    ts3.pushIfUnique(capturedBindings, symbol);
                    if (part === container.initializer) {
                      capturesBlockScopeBindingInLoopBody = false;
                    }
                  }
                }
              }
              if (capturesBlockScopeBindingInLoopBody) {
                getNodeLinks(enclosingIterationStatement).flags |= 65536;
              }
            }
            if (ts3.isForStatement(container)) {
              var varDeclList = ts3.getAncestor(symbol.valueDeclaration, 251);
              if (varDeclList && varDeclList.parent === container && isAssignedInBodyOfForStatement(node, container)) {
                getNodeLinks(symbol.valueDeclaration).flags |= 4194304;
              }
            }
            getNodeLinks(symbol.valueDeclaration).flags |= 524288;
          }
          if (isCaptured) {
            getNodeLinks(symbol.valueDeclaration).flags |= 262144;
          }
        }
        function isBindingCapturedByNode(node, decl) {
          var links = getNodeLinks(node);
          return !!links && ts3.contains(links.capturedBlockScopeBindings, getSymbolOfNode(decl));
        }
        function isAssignedInBodyOfForStatement(node, container) {
          var current = node;
          while (current.parent.kind === 208) {
            current = current.parent;
          }
          var isAssigned = false;
          if (ts3.isAssignmentTarget(current)) {
            isAssigned = true;
          } else if (current.parent.kind === 215 || current.parent.kind === 216) {
            var expr = current.parent;
            isAssigned = expr.operator === 45 || expr.operator === 46;
          }
          if (!isAssigned) {
            return false;
          }
          return !!ts3.findAncestor(current, function(n2) {
            return n2 === container ? "quit" : n2 === container.statement;
          });
        }
        function captureLexicalThis(node, container) {
          getNodeLinks(node).flags |= 2;
          if (container.kind === 164 || container.kind === 167) {
            var classNode = container.parent;
            getNodeLinks(classNode).flags |= 4;
          } else {
            getNodeLinks(container).flags |= 4;
          }
        }
        function findFirstSuperCall(node) {
          return ts3.isSuperCall(node) ? node : ts3.isFunctionLike(node) ? void 0 : ts3.forEachChild(node, findFirstSuperCall);
        }
        function classDeclarationExtendsNull(classDecl) {
          var classSymbol = getSymbolOfNode(classDecl);
          var classInstanceType = getDeclaredTypeOfSymbol(classSymbol);
          var baseConstructorType = getBaseConstructorTypeOfClass(classInstanceType);
          return baseConstructorType === nullWideningType;
        }
        function checkThisBeforeSuper(node, container, diagnosticMessage) {
          var containingClassDecl = container.parent;
          var baseTypeNode = ts3.getClassExtendsHeritageElement(containingClassDecl);
          if (baseTypeNode && !classDeclarationExtendsNull(containingClassDecl)) {
            if (node.flowNode && !isPostSuperFlowNode(node.flowNode, false)) {
              error(node, diagnosticMessage);
            }
          }
        }
        function checkThisExpression(node) {
          var container = ts3.getThisContainer(node, true);
          var capturedByArrowFunction = false;
          if (container.kind === 167) {
            checkThisBeforeSuper(node, container, ts3.Diagnostics.super_must_be_called_before_accessing_this_in_the_constructor_of_a_derived_class);
          }
          if (container.kind === 210) {
            container = ts3.getThisContainer(container, false);
            capturedByArrowFunction = true;
          }
          switch (container.kind) {
            case 257:
              error(node, ts3.Diagnostics.this_cannot_be_referenced_in_a_module_or_namespace_body);
              break;
            case 256:
              error(node, ts3.Diagnostics.this_cannot_be_referenced_in_current_location);
              break;
            case 167:
              if (isInConstructorArgumentInitializer(node, container)) {
                error(node, ts3.Diagnostics.this_cannot_be_referenced_in_constructor_arguments);
              }
              break;
            case 164:
            case 163:
              if (ts3.hasSyntacticModifier(container, 32) && !(compilerOptions.target === 99 && useDefineForClassFields)) {
                error(node, ts3.Diagnostics.this_cannot_be_referenced_in_a_static_property_initializer);
              }
              break;
            case 159:
              error(node, ts3.Diagnostics.this_cannot_be_referenced_in_a_computed_property_name);
              break;
          }
          if (capturedByArrowFunction && languageVersion < 2) {
            captureLexicalThis(node, container);
          }
          var type3 = tryGetThisTypeAt(node, true, container);
          if (noImplicitThis) {
            var globalThisType_1 = getTypeOfSymbol(globalThisSymbol);
            if (type3 === globalThisType_1 && capturedByArrowFunction) {
              error(node, ts3.Diagnostics.The_containing_arrow_function_captures_the_global_value_of_this);
            } else if (!type3) {
              var diag = error(node, ts3.Diagnostics.this_implicitly_has_type_any_because_it_does_not_have_a_type_annotation);
              if (!ts3.isSourceFile(container)) {
                var outsideThis = tryGetThisTypeAt(container);
                if (outsideThis && outsideThis !== globalThisType_1) {
                  ts3.addRelatedInfo(diag, ts3.createDiagnosticForNode(container, ts3.Diagnostics.An_outer_value_of_this_is_shadowed_by_this_container));
                }
              }
            }
          }
          return type3 || anyType;
        }
        function tryGetThisTypeAt(node, includeGlobalThis, container) {
          if (includeGlobalThis === void 0) {
            includeGlobalThis = true;
          }
          if (container === void 0) {
            container = ts3.getThisContainer(node, false);
          }
          var isInJS = ts3.isInJSFile(node);
          if (ts3.isFunctionLike(container) && (!isInParameterInitializerBeforeContainingFunction(node) || ts3.getThisParameter(container))) {
            var thisType = getThisTypeOfDeclaration(container) || isInJS && getTypeForThisExpressionFromJSDoc(container);
            if (!thisType) {
              var className = getClassNameFromPrototypeMethod(container);
              if (isInJS && className) {
                var classSymbol = checkExpression(className).symbol;
                if (classSymbol && classSymbol.members && classSymbol.flags & 16) {
                  thisType = getDeclaredTypeOfSymbol(classSymbol).thisType;
                }
              } else if (isJSConstructor(container)) {
                thisType = getDeclaredTypeOfSymbol(getMergedSymbol(container.symbol)).thisType;
              }
              thisType || (thisType = getContextualThisParameterType(container));
            }
            if (thisType) {
              return getFlowTypeOfReference(node, thisType);
            }
          }
          if (ts3.isClassLike(container.parent)) {
            var symbol = getSymbolOfNode(container.parent);
            var type3 = ts3.hasSyntacticModifier(container, 32) ? getTypeOfSymbol(symbol) : getDeclaredTypeOfSymbol(symbol).thisType;
            return getFlowTypeOfReference(node, type3);
          }
          if (ts3.isSourceFile(container)) {
            if (container.commonJsModuleIndicator) {
              var fileSymbol = getSymbolOfNode(container);
              return fileSymbol && getTypeOfSymbol(fileSymbol);
            } else if (container.externalModuleIndicator) {
              return undefinedType;
            } else if (includeGlobalThis) {
              return getTypeOfSymbol(globalThisSymbol);
            }
          }
        }
        function getExplicitThisType(node) {
          var container = ts3.getThisContainer(node, false);
          if (ts3.isFunctionLike(container)) {
            var signature = getSignatureFromDeclaration(container);
            if (signature.thisParameter) {
              return getExplicitTypeOfSymbol(signature.thisParameter);
            }
          }
          if (ts3.isClassLike(container.parent)) {
            var symbol = getSymbolOfNode(container.parent);
            return ts3.hasSyntacticModifier(container, 32) ? getTypeOfSymbol(symbol) : getDeclaredTypeOfSymbol(symbol).thisType;
          }
        }
        function getClassNameFromPrototypeMethod(container) {
          if (container.kind === 209 && ts3.isBinaryExpression(container.parent) && ts3.getAssignmentDeclarationKind(container.parent) === 3) {
            return container.parent.left.expression.expression;
          } else if (container.kind === 166 && container.parent.kind === 201 && ts3.isBinaryExpression(container.parent.parent) && ts3.getAssignmentDeclarationKind(container.parent.parent) === 6) {
            return container.parent.parent.left.expression;
          } else if (container.kind === 209 && container.parent.kind === 289 && container.parent.parent.kind === 201 && ts3.isBinaryExpression(container.parent.parent.parent) && ts3.getAssignmentDeclarationKind(container.parent.parent.parent) === 6) {
            return container.parent.parent.parent.left.expression;
          } else if (container.kind === 209 && ts3.isPropertyAssignment(container.parent) && ts3.isIdentifier(container.parent.name) && (container.parent.name.escapedText === "value" || container.parent.name.escapedText === "get" || container.parent.name.escapedText === "set") && ts3.isObjectLiteralExpression(container.parent.parent) && ts3.isCallExpression(container.parent.parent.parent) && container.parent.parent.parent.arguments[2] === container.parent.parent && ts3.getAssignmentDeclarationKind(container.parent.parent.parent) === 9) {
            return container.parent.parent.parent.arguments[0].expression;
          } else if (ts3.isMethodDeclaration(container) && ts3.isIdentifier(container.name) && (container.name.escapedText === "value" || container.name.escapedText === "get" || container.name.escapedText === "set") && ts3.isObjectLiteralExpression(container.parent) && ts3.isCallExpression(container.parent.parent) && container.parent.parent.arguments[2] === container.parent && ts3.getAssignmentDeclarationKind(container.parent.parent) === 9) {
            return container.parent.parent.arguments[0].expression;
          }
        }
        function getTypeForThisExpressionFromJSDoc(node) {
          var jsdocType = ts3.getJSDocType(node);
          if (jsdocType && jsdocType.kind === 309) {
            var jsDocFunctionType = jsdocType;
            if (jsDocFunctionType.parameters.length > 0 && jsDocFunctionType.parameters[0].name && jsDocFunctionType.parameters[0].name.escapedText === "this") {
              return getTypeFromTypeNode(jsDocFunctionType.parameters[0].type);
            }
          }
          var thisTag = ts3.getJSDocThisTag(node);
          if (thisTag && thisTag.typeExpression) {
            return getTypeFromTypeNode(thisTag.typeExpression);
          }
        }
        function isInConstructorArgumentInitializer(node, constructorDecl) {
          return !!ts3.findAncestor(node, function(n2) {
            return ts3.isFunctionLikeDeclaration(n2) ? "quit" : n2.kind === 161 && n2.parent === constructorDecl;
          });
        }
        function checkSuperExpression(node) {
          var isCallExpression = node.parent.kind === 204 && node.parent.expression === node;
          var immediateContainer = ts3.getSuperContainer(node, true);
          var container = immediateContainer;
          var needToCaptureLexicalThis = false;
          if (!isCallExpression) {
            while (container && container.kind === 210) {
              container = ts3.getSuperContainer(container, true);
              needToCaptureLexicalThis = languageVersion < 2;
            }
          }
          var canUseSuperExpression = isLegalUsageOfSuperExpression(container);
          var nodeCheckFlag = 0;
          if (!canUseSuperExpression) {
            var current = ts3.findAncestor(node, function(n2) {
              return n2 === container ? "quit" : n2.kind === 159;
            });
            if (current && current.kind === 159) {
              error(node, ts3.Diagnostics.super_cannot_be_referenced_in_a_computed_property_name);
            } else if (isCallExpression) {
              error(node, ts3.Diagnostics.Super_calls_are_not_permitted_outside_constructors_or_in_nested_functions_inside_constructors);
            } else if (!container || !container.parent || !(ts3.isClassLike(container.parent) || container.parent.kind === 201)) {
              error(node, ts3.Diagnostics.super_can_only_be_referenced_in_members_of_derived_classes_or_object_literal_expressions);
            } else {
              error(node, ts3.Diagnostics.super_property_access_is_permitted_only_in_a_constructor_member_function_or_member_accessor_of_a_derived_class);
            }
            return errorType;
          }
          if (!isCallExpression && immediateContainer.kind === 167) {
            checkThisBeforeSuper(node, container, ts3.Diagnostics.super_must_be_called_before_accessing_a_property_of_super_in_the_constructor_of_a_derived_class);
          }
          if (ts3.hasSyntacticModifier(container, 32) || isCallExpression) {
            nodeCheckFlag = 512;
          } else {
            nodeCheckFlag = 256;
          }
          getNodeLinks(node).flags |= nodeCheckFlag;
          if (container.kind === 166 && ts3.hasSyntacticModifier(container, 256)) {
            if (ts3.isSuperProperty(node.parent) && ts3.isAssignmentTarget(node.parent)) {
              getNodeLinks(container).flags |= 4096;
            } else {
              getNodeLinks(container).flags |= 2048;
            }
          }
          if (needToCaptureLexicalThis) {
            captureLexicalThis(node.parent, container);
          }
          if (container.parent.kind === 201) {
            if (languageVersion < 2) {
              error(node, ts3.Diagnostics.super_is_only_allowed_in_members_of_object_literal_expressions_when_option_target_is_ES2015_or_higher);
              return errorType;
            } else {
              return anyType;
            }
          }
          var classLikeDeclaration = container.parent;
          if (!ts3.getClassExtendsHeritageElement(classLikeDeclaration)) {
            error(node, ts3.Diagnostics.super_can_only_be_referenced_in_a_derived_class);
            return errorType;
          }
          var classType = getDeclaredTypeOfSymbol(getSymbolOfNode(classLikeDeclaration));
          var baseClassType = classType && getBaseTypes(classType)[0];
          if (!baseClassType) {
            return errorType;
          }
          if (container.kind === 167 && isInConstructorArgumentInitializer(node, container)) {
            error(node, ts3.Diagnostics.super_cannot_be_referenced_in_constructor_arguments);
            return errorType;
          }
          return nodeCheckFlag === 512 ? getBaseConstructorTypeOfClass(classType) : getTypeWithThisArgument(baseClassType, classType.thisType);
          function isLegalUsageOfSuperExpression(container2) {
            if (!container2) {
              return false;
            }
            if (isCallExpression) {
              return container2.kind === 167;
            } else {
              if (ts3.isClassLike(container2.parent) || container2.parent.kind === 201) {
                if (ts3.hasSyntacticModifier(container2, 32)) {
                  return container2.kind === 166 || container2.kind === 165 || container2.kind === 168 || container2.kind === 169;
                } else {
                  return container2.kind === 166 || container2.kind === 165 || container2.kind === 168 || container2.kind === 169 || container2.kind === 164 || container2.kind === 163 || container2.kind === 167;
                }
              }
            }
            return false;
          }
        }
        function getContainingObjectLiteral(func2) {
          return (func2.kind === 166 || func2.kind === 168 || func2.kind === 169) && func2.parent.kind === 201 ? func2.parent : func2.kind === 209 && func2.parent.kind === 289 ? func2.parent.parent : void 0;
        }
        function getThisTypeArgument(type3) {
          return ts3.getObjectFlags(type3) & 4 && type3.target === globalThisType ? getTypeArguments(type3)[0] : void 0;
        }
        function getThisTypeFromContextualType(type3) {
          return mapType(type3, function(t2) {
            return t2.flags & 2097152 ? ts3.forEach(t2.types, getThisTypeArgument) : getThisTypeArgument(t2);
          });
        }
        function getContextualThisParameterType(func2) {
          if (func2.kind === 210) {
            return void 0;
          }
          if (isContextSensitiveFunctionOrObjectLiteralMethod(func2)) {
            var contextualSignature = getContextualSignature(func2);
            if (contextualSignature) {
              var thisParameter = contextualSignature.thisParameter;
              if (thisParameter) {
                return getTypeOfSymbol(thisParameter);
              }
            }
          }
          var inJs = ts3.isInJSFile(func2);
          if (noImplicitThis || inJs) {
            var containingLiteral = getContainingObjectLiteral(func2);
            if (containingLiteral) {
              var contextualType = getApparentTypeOfContextualType(containingLiteral);
              var literal = containingLiteral;
              var type3 = contextualType;
              while (type3) {
                var thisType = getThisTypeFromContextualType(type3);
                if (thisType) {
                  return instantiateType(thisType, getMapperFromContext(getInferenceContext(containingLiteral)));
                }
                if (literal.parent.kind !== 289) {
                  break;
                }
                literal = literal.parent.parent;
                type3 = getApparentTypeOfContextualType(literal);
              }
              return getWidenedType(contextualType ? getNonNullableType(contextualType) : checkExpressionCached(containingLiteral));
            }
            var parent = ts3.walkUpParenthesizedExpressions(func2.parent);
            if (parent.kind === 217 && parent.operatorToken.kind === 62) {
              var target = parent.left;
              if (ts3.isAccessExpression(target)) {
                var expression = target.expression;
                if (inJs && ts3.isIdentifier(expression)) {
                  var sourceFile = ts3.getSourceFileOfNode(parent);
                  if (sourceFile.commonJsModuleIndicator && getResolvedSymbol(expression) === sourceFile.symbol) {
                    return void 0;
                  }
                }
                return getWidenedType(checkExpressionCached(expression));
              }
            }
          }
          return void 0;
        }
        function getContextuallyTypedParameterType(parameter) {
          var func2 = parameter.parent;
          if (!isContextSensitiveFunctionOrObjectLiteralMethod(func2)) {
            return void 0;
          }
          var iife = ts3.getImmediatelyInvokedFunctionExpression(func2);
          if (iife && iife.arguments) {
            var args = getEffectiveCallArguments(iife);
            var indexOfParameter = func2.parameters.indexOf(parameter);
            if (parameter.dotDotDotToken) {
              return getSpreadArgumentType(args, indexOfParameter, args.length, anyType, void 0, 0);
            }
            var links = getNodeLinks(iife);
            var cached = links.resolvedSignature;
            links.resolvedSignature = anySignature;
            var type3 = indexOfParameter < args.length ? getWidenedLiteralType(checkExpression(args[indexOfParameter])) : parameter.initializer ? void 0 : undefinedWideningType;
            links.resolvedSignature = cached;
            return type3;
          }
          var contextualSignature = getContextualSignature(func2);
          if (contextualSignature) {
            var index = func2.parameters.indexOf(parameter) - (ts3.getThisParameter(func2) ? 1 : 0);
            return parameter.dotDotDotToken && ts3.lastOrUndefined(func2.parameters) === parameter ? getRestTypeAtPosition(contextualSignature, index) : tryGetTypeAtPosition(contextualSignature, index);
          }
        }
        function getContextualTypeForVariableLikeDeclaration(declaration) {
          var typeNode = ts3.getEffectiveTypeAnnotationNode(declaration);
          if (typeNode) {
            return getTypeFromTypeNode(typeNode);
          }
          switch (declaration.kind) {
            case 161:
              return getContextuallyTypedParameterType(declaration);
            case 199:
              return getContextualTypeForBindingElement(declaration);
            case 164:
              if (ts3.hasSyntacticModifier(declaration, 32)) {
                return getContextualTypeForStaticPropertyDeclaration(declaration);
              }
          }
        }
        function getContextualTypeForBindingElement(declaration) {
          var parent = declaration.parent.parent;
          var name = declaration.propertyName || declaration.name;
          var parentType = getContextualTypeForVariableLikeDeclaration(parent) || parent.kind !== 199 && parent.initializer && checkDeclarationInitializer(parent);
          if (!parentType || ts3.isBindingPattern(name) || ts3.isComputedNonLiteralName(name))
            return void 0;
          if (parent.name.kind === 198) {
            var index = ts3.indexOfNode(declaration.parent.elements, declaration);
            if (index < 0)
              return void 0;
            return getContextualTypeForElementExpression(parentType, index);
          }
          var nameType = getLiteralTypeFromPropertyName(name);
          if (isTypeUsableAsPropertyName(nameType)) {
            var text = getPropertyNameFromType(nameType);
            return getTypeOfPropertyOfType(parentType, text);
          }
        }
        function getContextualTypeForStaticPropertyDeclaration(declaration) {
          var parentType = ts3.isExpression(declaration.parent) && getContextualType(declaration.parent);
          if (!parentType)
            return void 0;
          return getTypeOfPropertyOfContextualType(parentType, getSymbolOfNode(declaration).escapedName);
        }
        function getContextualTypeForInitializerExpression(node, contextFlags) {
          var declaration = node.parent;
          if (ts3.hasInitializer(declaration) && node === declaration.initializer) {
            var result2 = getContextualTypeForVariableLikeDeclaration(declaration);
            if (result2) {
              return result2;
            }
            if (!(contextFlags & 8) && ts3.isBindingPattern(declaration.name)) {
              return getTypeFromBindingPattern(declaration.name, true, false);
            }
          }
          return void 0;
        }
        function getContextualTypeForReturnExpression(node) {
          var func2 = ts3.getContainingFunction(node);
          if (func2) {
            var contextualReturnType = getContextualReturnType(func2);
            if (contextualReturnType) {
              var functionFlags = ts3.getFunctionFlags(func2);
              if (functionFlags & 1) {
                var use = functionFlags & 2 ? 2 : 1;
                var iterationTypes = getIterationTypesOfIterable(contextualReturnType, use, void 0);
                if (!iterationTypes) {
                  return void 0;
                }
                contextualReturnType = iterationTypes.returnType;
              }
              if (functionFlags & 2) {
                var contextualAwaitedType = mapType(contextualReturnType, getAwaitedType);
                return contextualAwaitedType && getUnionType([contextualAwaitedType, createPromiseLikeType(contextualAwaitedType)]);
              }
              return contextualReturnType;
            }
          }
          return void 0;
        }
        function getContextualTypeForAwaitOperand(node, contextFlags) {
          var contextualType = getContextualType(node, contextFlags);
          if (contextualType) {
            var contextualAwaitedType = getAwaitedType(contextualType);
            return contextualAwaitedType && getUnionType([contextualAwaitedType, createPromiseLikeType(contextualAwaitedType)]);
          }
          return void 0;
        }
        function getContextualTypeForYieldOperand(node) {
          var func2 = ts3.getContainingFunction(node);
          if (func2) {
            var functionFlags = ts3.getFunctionFlags(func2);
            var contextualReturnType = getContextualReturnType(func2);
            if (contextualReturnType) {
              return node.asteriskToken ? contextualReturnType : getIterationTypeOfGeneratorFunctionReturnType(0, contextualReturnType, (functionFlags & 2) !== 0);
            }
          }
          return void 0;
        }
        function isInParameterInitializerBeforeContainingFunction(node) {
          var inBindingInitializer = false;
          while (node.parent && !ts3.isFunctionLike(node.parent)) {
            if (ts3.isParameter(node.parent) && (inBindingInitializer || node.parent.initializer === node)) {
              return true;
            }
            if (ts3.isBindingElement(node.parent) && node.parent.initializer === node) {
              inBindingInitializer = true;
            }
            node = node.parent;
          }
          return false;
        }
        function getContextualIterationType(kind, functionDecl) {
          var isAsync = !!(ts3.getFunctionFlags(functionDecl) & 2);
          var contextualReturnType = getContextualReturnType(functionDecl);
          if (contextualReturnType) {
            return getIterationTypeOfGeneratorFunctionReturnType(kind, contextualReturnType, isAsync) || void 0;
          }
          return void 0;
        }
        function getContextualReturnType(functionDecl) {
          var returnType2 = getReturnTypeFromAnnotation(functionDecl);
          if (returnType2) {
            return returnType2;
          }
          var signature = getContextualSignatureForFunctionLikeDeclaration(functionDecl);
          if (signature && !isResolvingReturnTypeOfSignature(signature)) {
            return getReturnTypeOfSignature(signature);
          }
          return void 0;
        }
        function getContextualTypeForArgument(callTarget, arg2) {
          var args = getEffectiveCallArguments(callTarget);
          var argIndex = args.indexOf(arg2);
          return argIndex === -1 ? void 0 : getContextualTypeForArgumentAtIndex(callTarget, argIndex);
        }
        function getContextualTypeForArgumentAtIndex(callTarget, argIndex) {
          var signature = getNodeLinks(callTarget).resolvedSignature === resolvingSignature ? resolvingSignature : getResolvedSignature(callTarget);
          if (ts3.isJsxOpeningLikeElement(callTarget) && argIndex === 0) {
            return getEffectiveFirstArgumentForJsxSignature(signature, callTarget);
          }
          return getTypeAtPosition(signature, argIndex);
        }
        function getContextualTypeForSubstitutionExpression(template, substitutionExpression) {
          if (template.parent.kind === 206) {
            return getContextualTypeForArgument(template.parent, substitutionExpression);
          }
          return void 0;
        }
        function getContextualTypeForBinaryOperand(node, contextFlags) {
          var binaryExpression = node.parent;
          var left = binaryExpression.left, operatorToken = binaryExpression.operatorToken, right = binaryExpression.right;
          switch (operatorToken.kind) {
            case 62:
            case 75:
            case 74:
            case 76:
              return node === right ? getContextualTypeForAssignmentDeclaration(binaryExpression) : void 0;
            case 56:
            case 60:
              var type3 = getContextualType(binaryExpression, contextFlags);
              return node === right && (type3 && type3.pattern || !type3 && !ts3.isDefaultedExpandoInitializer(binaryExpression)) ? getTypeOfExpression(left) : type3;
            case 55:
            case 27:
              return node === right ? getContextualType(binaryExpression, contextFlags) : void 0;
            default:
              return void 0;
          }
        }
        function getContextualTypeForAssignmentDeclaration(binaryExpression) {
          var _a2, _b;
          var kind = ts3.getAssignmentDeclarationKind(binaryExpression);
          switch (kind) {
            case 0:
              return getTypeOfExpression(binaryExpression.left);
            case 4:
              return getContextualTypeForThisPropertyAssignment(binaryExpression);
            case 5:
              if (isPossiblyAliasedThisProperty(binaryExpression, kind)) {
                return getContextualTypeForThisPropertyAssignment(binaryExpression);
              } else if (!binaryExpression.left.symbol) {
                return getTypeOfExpression(binaryExpression.left);
              } else {
                var decl = binaryExpression.left.symbol.valueDeclaration;
                if (!decl) {
                  return void 0;
                }
                var lhs = ts3.cast(binaryExpression.left, ts3.isAccessExpression);
                var overallAnnotation = ts3.getEffectiveTypeAnnotationNode(decl);
                if (overallAnnotation) {
                  return getTypeFromTypeNode(overallAnnotation);
                } else if (ts3.isIdentifier(lhs.expression)) {
                  var id = lhs.expression;
                  var parentSymbol = resolveName(id, id.escapedText, 111551, void 0, id.escapedText, true);
                  if (parentSymbol) {
                    var annotated_1 = parentSymbol.valueDeclaration && ts3.getEffectiveTypeAnnotationNode(parentSymbol.valueDeclaration);
                    if (annotated_1) {
                      var nameStr = ts3.getElementOrPropertyAccessName(lhs);
                      if (nameStr !== void 0) {
                        return getTypeOfPropertyOfContextualType(getTypeFromTypeNode(annotated_1), nameStr);
                      }
                    }
                    return void 0;
                  }
                }
                return ts3.isInJSFile(decl) ? void 0 : getTypeOfExpression(binaryExpression.left);
              }
            case 1:
            case 6:
            case 3:
              var valueDeclaration = (_a2 = binaryExpression.left.symbol) === null || _a2 === void 0 ? void 0 : _a2.valueDeclaration;
            case 2:
              valueDeclaration || (valueDeclaration = (_b = binaryExpression.symbol) === null || _b === void 0 ? void 0 : _b.valueDeclaration);
              var annotated = valueDeclaration && ts3.getEffectiveTypeAnnotationNode(valueDeclaration);
              return annotated ? getTypeFromTypeNode(annotated) : void 0;
            case 7:
            case 8:
            case 9:
              return ts3.Debug.fail("Does not apply");
            default:
              return ts3.Debug.assertNever(kind);
          }
        }
        function isPossiblyAliasedThisProperty(declaration, kind) {
          if (kind === void 0) {
            kind = ts3.getAssignmentDeclarationKind(declaration);
          }
          if (kind === 4) {
            return true;
          }
          if (!ts3.isInJSFile(declaration) || kind !== 5 || !ts3.isIdentifier(declaration.left.expression)) {
            return false;
          }
          var name = declaration.left.expression.escapedText;
          var symbol = resolveName(declaration.left, name, 111551, void 0, void 0, true, true);
          return ts3.isThisInitializedDeclaration(symbol === null || symbol === void 0 ? void 0 : symbol.valueDeclaration);
        }
        function getContextualTypeForThisPropertyAssignment(binaryExpression) {
          if (!binaryExpression.symbol)
            return getTypeOfExpression(binaryExpression.left);
          if (binaryExpression.symbol.valueDeclaration) {
            var annotated = ts3.getEffectiveTypeAnnotationNode(binaryExpression.symbol.valueDeclaration);
            if (annotated) {
              var type3 = getTypeFromTypeNode(annotated);
              if (type3) {
                return type3;
              }
            }
          }
          var thisAccess = ts3.cast(binaryExpression.left, ts3.isAccessExpression);
          if (!ts3.isObjectLiteralMethod(ts3.getThisContainer(thisAccess.expression, false))) {
            return void 0;
          }
          var thisType = checkThisExpression(thisAccess.expression);
          var nameStr = ts3.getElementOrPropertyAccessName(thisAccess);
          return nameStr !== void 0 && getTypeOfPropertyOfContextualType(thisType, nameStr) || void 0;
        }
        function isCircularMappedProperty(symbol) {
          return !!(ts3.getCheckFlags(symbol) & 262144 && !symbol.type && findResolutionCycleStartIndex(symbol, 0) >= 0);
        }
        function getTypeOfPropertyOfContextualType(type3, name) {
          return mapType(type3, function(t2) {
            if (isGenericMappedType(t2)) {
              var constraint = getConstraintTypeFromMappedType(t2);
              var constraintOfConstraint = getBaseConstraintOfType(constraint) || constraint;
              var propertyNameType = getLiteralType(ts3.unescapeLeadingUnderscores(name));
              if (isTypeAssignableTo(propertyNameType, constraintOfConstraint)) {
                return substituteIndexedMappedType(t2, propertyNameType);
              }
            } else if (t2.flags & 3670016) {
              var prop = getPropertyOfType(t2, name);
              if (prop) {
                return isCircularMappedProperty(prop) ? void 0 : getTypeOfSymbol(prop);
              }
              if (isTupleType(t2)) {
                var restType = getRestTypeOfTupleType(t2);
                if (restType && isNumericLiteralName(name) && +name >= 0) {
                  return restType;
                }
              }
              return isNumericLiteralName(name) && getIndexTypeOfContextualType(t2, 1) || getIndexTypeOfContextualType(t2, 0);
            }
            return void 0;
          }, true);
        }
        function getIndexTypeOfContextualType(type3, kind) {
          return mapType(type3, function(t2) {
            return getIndexTypeOfStructuredType(t2, kind);
          }, true);
        }
        function getContextualTypeForObjectLiteralMethod(node, contextFlags) {
          ts3.Debug.assert(ts3.isObjectLiteralMethod(node));
          if (node.flags & 16777216) {
            return void 0;
          }
          return getContextualTypeForObjectLiteralElement(node, contextFlags);
        }
        function getContextualTypeForObjectLiteralElement(element, contextFlags) {
          var objectLiteral = element.parent;
          var propertyAssignmentType = ts3.isPropertyAssignment(element) && getContextualTypeForVariableLikeDeclaration(element);
          if (propertyAssignmentType) {
            return propertyAssignmentType;
          }
          var type3 = getApparentTypeOfContextualType(objectLiteral, contextFlags);
          if (type3) {
            if (hasBindableName(element)) {
              var symbolName_3 = getSymbolOfNode(element).escapedName;
              var propertyType = getTypeOfPropertyOfContextualType(type3, symbolName_3);
              if (propertyType) {
                return propertyType;
              }
            }
            return isNumericName(element.name) && getIndexTypeOfContextualType(type3, 1) || getIndexTypeOfContextualType(type3, 0);
          }
          return void 0;
        }
        function getContextualTypeForElementExpression(arrayContextualType, index) {
          return arrayContextualType && (getTypeOfPropertyOfContextualType(arrayContextualType, "" + index) || mapType(arrayContextualType, function(t2) {
            return getIteratedTypeOrElementType(1, t2, undefinedType, void 0, false);
          }, true));
        }
        function getContextualTypeForConditionalOperand(node, contextFlags) {
          var conditional = node.parent;
          return node === conditional.whenTrue || node === conditional.whenFalse ? getContextualType(conditional, contextFlags) : void 0;
        }
        function getContextualTypeForChildJsxExpression(node, child) {
          var attributesType = getApparentTypeOfContextualType(node.openingElement.tagName);
          var jsxChildrenPropertyName = getJsxElementChildrenPropertyName(getJsxNamespaceAt(node));
          if (!(attributesType && !isTypeAny(attributesType) && jsxChildrenPropertyName && jsxChildrenPropertyName !== "")) {
            return void 0;
          }
          var realChildren = ts3.getSemanticJsxChildren(node.children);
          var childIndex = realChildren.indexOf(child);
          var childFieldType = getTypeOfPropertyOfContextualType(attributesType, jsxChildrenPropertyName);
          return childFieldType && (realChildren.length === 1 ? childFieldType : mapType(childFieldType, function(t2) {
            if (isArrayLikeType(t2)) {
              return getIndexedAccessType(t2, getLiteralType(childIndex));
            } else {
              return t2;
            }
          }, true));
        }
        function getContextualTypeForJsxExpression(node) {
          var exprParent = node.parent;
          return ts3.isJsxAttributeLike(exprParent) ? getContextualType(node) : ts3.isJsxElement(exprParent) ? getContextualTypeForChildJsxExpression(exprParent, node) : void 0;
        }
        function getContextualTypeForJsxAttribute(attribute) {
          if (ts3.isJsxAttribute(attribute)) {
            var attributesType = getApparentTypeOfContextualType(attribute.parent);
            if (!attributesType || isTypeAny(attributesType)) {
              return void 0;
            }
            return getTypeOfPropertyOfContextualType(attributesType, attribute.name.escapedText);
          } else {
            return getContextualType(attribute.parent);
          }
        }
        function isPossiblyDiscriminantValue(node) {
          switch (node.kind) {
            case 10:
            case 8:
            case 9:
            case 14:
            case 109:
            case 94:
            case 103:
            case 78:
            case 150:
              return true;
            case 202:
            case 208:
              return isPossiblyDiscriminantValue(node.expression);
            case 284:
              return !node.expression || isPossiblyDiscriminantValue(node.expression);
          }
          return false;
        }
        function discriminateContextualTypeByObjectMembers(node, contextualType) {
          return getMatchingUnionConstituentForObjectLiteral(contextualType, node) || discriminateTypeByDiscriminableItems(contextualType, ts3.concatenate(ts3.map(ts3.filter(node.properties, function(p) {
            return !!p.symbol && p.kind === 289 && isPossiblyDiscriminantValue(p.initializer) && isDiscriminantProperty(contextualType, p.symbol.escapedName);
          }), function(prop) {
            return [function() {
              return getContextFreeTypeOfExpression(prop.initializer);
            }, prop.symbol.escapedName];
          }), ts3.map(ts3.filter(getPropertiesOfType(contextualType), function(s2) {
            var _a2;
            return !!(s2.flags & 16777216) && !!((_a2 = node === null || node === void 0 ? void 0 : node.symbol) === null || _a2 === void 0 ? void 0 : _a2.members) && !node.symbol.members.has(s2.escapedName) && isDiscriminantProperty(contextualType, s2.escapedName);
          }), function(s2) {
            return [function() {
              return undefinedType;
            }, s2.escapedName];
          })), isTypeAssignableTo, contextualType);
        }
        function discriminateContextualTypeByJSXAttributes(node, contextualType) {
          return discriminateTypeByDiscriminableItems(contextualType, ts3.concatenate(ts3.map(ts3.filter(node.properties, function(p) {
            return !!p.symbol && p.kind === 281 && isDiscriminantProperty(contextualType, p.symbol.escapedName) && (!p.initializer || isPossiblyDiscriminantValue(p.initializer));
          }), function(prop) {
            return [!prop.initializer ? function() {
              return trueType;
            } : function() {
              return checkExpression(prop.initializer);
            }, prop.symbol.escapedName];
          }), ts3.map(ts3.filter(getPropertiesOfType(contextualType), function(s2) {
            var _a2;
            return !!(s2.flags & 16777216) && !!((_a2 = node === null || node === void 0 ? void 0 : node.symbol) === null || _a2 === void 0 ? void 0 : _a2.members) && !node.symbol.members.has(s2.escapedName) && isDiscriminantProperty(contextualType, s2.escapedName);
          }), function(s2) {
            return [function() {
              return undefinedType;
            }, s2.escapedName];
          })), isTypeAssignableTo, contextualType);
        }
        function getApparentTypeOfContextualType(node, contextFlags) {
          var contextualType = ts3.isObjectLiteralMethod(node) ? getContextualTypeForObjectLiteralMethod(node, contextFlags) : getContextualType(node, contextFlags);
          var instantiatedType = instantiateContextualType(contextualType, node, contextFlags);
          if (instantiatedType && !(contextFlags && contextFlags & 2 && instantiatedType.flags & 8650752)) {
            var apparentType = mapType(instantiatedType, getApparentType, true);
            return apparentType.flags & 1048576 && ts3.isObjectLiteralExpression(node) ? discriminateContextualTypeByObjectMembers(node, apparentType) : apparentType.flags & 1048576 && ts3.isJsxAttributes(node) ? discriminateContextualTypeByJSXAttributes(node, apparentType) : apparentType;
          }
        }
        function instantiateContextualType(contextualType, node, contextFlags) {
          if (contextualType && maybeTypeOfKind(contextualType, 465829888)) {
            var inferenceContext = getInferenceContext(node);
            if (inferenceContext && ts3.some(inferenceContext.inferences, hasInferenceCandidates)) {
              if (contextFlags && contextFlags & 1) {
                return instantiateInstantiableTypes(contextualType, inferenceContext.nonFixingMapper);
              }
              if (inferenceContext.returnMapper) {
                return instantiateInstantiableTypes(contextualType, inferenceContext.returnMapper);
              }
            }
          }
          return contextualType;
        }
        function instantiateInstantiableTypes(type3, mapper) {
          if (type3.flags & 465829888) {
            return instantiateType(type3, mapper);
          }
          if (type3.flags & 1048576) {
            return getUnionType(ts3.map(type3.types, function(t2) {
              return instantiateInstantiableTypes(t2, mapper);
            }), 0);
          }
          if (type3.flags & 2097152) {
            return getIntersectionType(ts3.map(type3.types, function(t2) {
              return instantiateInstantiableTypes(t2, mapper);
            }));
          }
          return type3;
        }
        function getContextualType(node, contextFlags) {
          if (node.flags & 16777216) {
            return void 0;
          }
          if (node.contextualType) {
            return node.contextualType;
          }
          var parent = node.parent;
          switch (parent.kind) {
            case 250:
            case 161:
            case 164:
            case 163:
            case 199:
              return getContextualTypeForInitializerExpression(node, contextFlags);
            case 210:
            case 243:
              return getContextualTypeForReturnExpression(node);
            case 220:
              return getContextualTypeForYieldOperand(parent);
            case 214:
              return getContextualTypeForAwaitOperand(parent, contextFlags);
            case 204:
              if (parent.expression.kind === 99) {
                return stringType;
              }
            case 205:
              return getContextualTypeForArgument(parent, node);
            case 207:
            case 225:
              return ts3.isConstTypeReference(parent.type) ? tryFindWhenConstTypeReference(parent) : getTypeFromTypeNode(parent.type);
            case 217:
              return getContextualTypeForBinaryOperand(node, contextFlags);
            case 289:
            case 290:
              return getContextualTypeForObjectLiteralElement(parent, contextFlags);
            case 291:
              return getContextualType(parent.parent, contextFlags);
            case 200: {
              var arrayLiteral = parent;
              var type3 = getApparentTypeOfContextualType(arrayLiteral, contextFlags);
              return getContextualTypeForElementExpression(type3, ts3.indexOfNode(arrayLiteral.elements, node));
            }
            case 218:
              return getContextualTypeForConditionalOperand(node, contextFlags);
            case 229:
              ts3.Debug.assert(parent.parent.kind === 219);
              return getContextualTypeForSubstitutionExpression(parent.parent, node);
            case 208: {
              var tag = ts3.isInJSFile(parent) ? ts3.getJSDocTypeTag(parent) : void 0;
              return tag ? getTypeFromTypeNode(tag.typeExpression.type) : getContextualType(parent, contextFlags);
            }
            case 226:
              return getContextualType(parent, contextFlags);
            case 284:
              return getContextualTypeForJsxExpression(parent);
            case 281:
            case 283:
              return getContextualTypeForJsxAttribute(parent);
            case 276:
            case 275:
              return getContextualJsxElementAttributesType(parent, contextFlags);
          }
          return void 0;
          function tryFindWhenConstTypeReference(node2) {
            return getContextualType(node2);
          }
        }
        function getInferenceContext(node) {
          var ancestor = ts3.findAncestor(node, function(n2) {
            return !!n2.inferenceContext;
          });
          return ancestor && ancestor.inferenceContext;
        }
        function getContextualJsxElementAttributesType(node, contextFlags) {
          if (ts3.isJsxOpeningElement(node) && node.parent.contextualType && contextFlags !== 4) {
            return node.parent.contextualType;
          }
          return getContextualTypeForArgumentAtIndex(node, 0);
        }
        function getEffectiveFirstArgumentForJsxSignature(signature, node) {
          return getJsxReferenceKind(node) !== 0 ? getJsxPropsTypeFromCallSignature(signature, node) : getJsxPropsTypeFromClassType(signature, node);
        }
        function getJsxPropsTypeFromCallSignature(sig, context) {
          var propsType = getTypeOfFirstParameterOfSignatureWithFallback(sig, unknownType);
          propsType = getJsxManagedAttributesFromLocatedAttributes(context, getJsxNamespaceAt(context), propsType);
          var intrinsicAttribs = getJsxType(JsxNames.IntrinsicAttributes, context);
          if (intrinsicAttribs !== errorType) {
            propsType = intersectTypes(intrinsicAttribs, propsType);
          }
          return propsType;
        }
        function getJsxPropsTypeForSignatureFromMember(sig, forcedLookupLocation) {
          if (sig.compositeSignatures) {
            var results = [];
            for (var _i = 0, _a2 = sig.compositeSignatures; _i < _a2.length; _i++) {
              var signature = _a2[_i];
              var instance = getReturnTypeOfSignature(signature);
              if (isTypeAny(instance)) {
                return instance;
              }
              var propType = getTypeOfPropertyOfType(instance, forcedLookupLocation);
              if (!propType) {
                return;
              }
              results.push(propType);
            }
            return getIntersectionType(results);
          }
          var instanceType = getReturnTypeOfSignature(sig);
          return isTypeAny(instanceType) ? instanceType : getTypeOfPropertyOfType(instanceType, forcedLookupLocation);
        }
        function getStaticTypeOfReferencedJsxConstructor(context) {
          if (isJsxIntrinsicIdentifier(context.tagName)) {
            var result2 = getIntrinsicAttributesTypeFromJsxOpeningLikeElement(context);
            var fakeSignature = createSignatureForJSXIntrinsic(context, result2);
            return getOrCreateTypeFromSignature(fakeSignature);
          }
          var tagType = checkExpressionCached(context.tagName);
          if (tagType.flags & 128) {
            var result2 = getIntrinsicAttributesTypeFromStringLiteralType(tagType, context);
            if (!result2) {
              return errorType;
            }
            var fakeSignature = createSignatureForJSXIntrinsic(context, result2);
            return getOrCreateTypeFromSignature(fakeSignature);
          }
          return tagType;
        }
        function getJsxManagedAttributesFromLocatedAttributes(context, ns, attributesType) {
          var managedSym = getJsxLibraryManagedAttributes(ns);
          if (managedSym) {
            var declaredManagedType = getDeclaredTypeOfSymbol(managedSym);
            var ctorType = getStaticTypeOfReferencedJsxConstructor(context);
            if (managedSym.flags & 524288) {
              var params = getSymbolLinks(managedSym).typeParameters;
              if (ts3.length(params) >= 2) {
                var args = fillMissingTypeArguments([ctorType, attributesType], params, 2, ts3.isInJSFile(context));
                return getTypeAliasInstantiation(managedSym, args);
              }
            }
            if (ts3.length(declaredManagedType.typeParameters) >= 2) {
              var args = fillMissingTypeArguments([ctorType, attributesType], declaredManagedType.typeParameters, 2, ts3.isInJSFile(context));
              return createTypeReference(declaredManagedType, args);
            }
          }
          return attributesType;
        }
        function getJsxPropsTypeFromClassType(sig, context) {
          var ns = getJsxNamespaceAt(context);
          var forcedLookupLocation = getJsxElementPropertiesName(ns);
          var attributesType = forcedLookupLocation === void 0 ? getTypeOfFirstParameterOfSignatureWithFallback(sig, unknownType) : forcedLookupLocation === "" ? getReturnTypeOfSignature(sig) : getJsxPropsTypeForSignatureFromMember(sig, forcedLookupLocation);
          if (!attributesType) {
            if (!!forcedLookupLocation && !!ts3.length(context.attributes.properties)) {
              error(context, ts3.Diagnostics.JSX_element_class_does_not_support_attributes_because_it_does_not_have_a_0_property, ts3.unescapeLeadingUnderscores(forcedLookupLocation));
            }
            return unknownType;
          }
          attributesType = getJsxManagedAttributesFromLocatedAttributes(context, ns, attributesType);
          if (isTypeAny(attributesType)) {
            return attributesType;
          } else {
            var apparentAttributesType = attributesType;
            var intrinsicClassAttribs = getJsxType(JsxNames.IntrinsicClassAttributes, context);
            if (intrinsicClassAttribs !== errorType) {
              var typeParams = getLocalTypeParametersOfClassOrInterfaceOrTypeAlias(intrinsicClassAttribs.symbol);
              var hostClassType = getReturnTypeOfSignature(sig);
              apparentAttributesType = intersectTypes(typeParams ? createTypeReference(intrinsicClassAttribs, fillMissingTypeArguments([hostClassType], typeParams, getMinTypeArgumentCount(typeParams), ts3.isInJSFile(context))) : intrinsicClassAttribs, apparentAttributesType);
            }
            var intrinsicAttribs = getJsxType(JsxNames.IntrinsicAttributes, context);
            if (intrinsicAttribs !== errorType) {
              apparentAttributesType = intersectTypes(intrinsicAttribs, apparentAttributesType);
            }
            return apparentAttributesType;
          }
        }
        function getIntersectedSignatures(signatures) {
          return ts3.getStrictOptionValue(compilerOptions, "noImplicitAny") ? ts3.reduceLeft(signatures, function(left, right) {
            return left === right || !left ? left : compareTypeParametersIdentical(left.typeParameters, right.typeParameters) ? combineSignaturesOfIntersectionMembers(left, right) : void 0;
          }) : void 0;
        }
        function combineIntersectionThisParam(left, right, mapper) {
          if (!left || !right) {
            return left || right;
          }
          var thisType = getUnionType([getTypeOfSymbol(left), instantiateType(getTypeOfSymbol(right), mapper)]);
          return createSymbolWithType(left, thisType);
        }
        function combineIntersectionParameters(left, right, mapper) {
          var leftCount = getParameterCount(left);
          var rightCount = getParameterCount(right);
          var longest = leftCount >= rightCount ? left : right;
          var shorter = longest === left ? right : left;
          var longestCount = longest === left ? leftCount : rightCount;
          var eitherHasEffectiveRest = hasEffectiveRestParameter(left) || hasEffectiveRestParameter(right);
          var needsExtraRestElement = eitherHasEffectiveRest && !hasEffectiveRestParameter(longest);
          var params = new Array(longestCount + (needsExtraRestElement ? 1 : 0));
          for (var i3 = 0; i3 < longestCount; i3++) {
            var longestParamType = tryGetTypeAtPosition(longest, i3);
            if (longest === right) {
              longestParamType = instantiateType(longestParamType, mapper);
            }
            var shorterParamType = tryGetTypeAtPosition(shorter, i3) || unknownType;
            if (shorter === right) {
              shorterParamType = instantiateType(shorterParamType, mapper);
            }
            var unionParamType = getUnionType([longestParamType, shorterParamType]);
            var isRestParam = eitherHasEffectiveRest && !needsExtraRestElement && i3 === longestCount - 1;
            var isOptional = i3 >= getMinArgumentCount(longest) && i3 >= getMinArgumentCount(shorter);
            var leftName = i3 >= leftCount ? void 0 : getParameterNameAtPosition(left, i3);
            var rightName = i3 >= rightCount ? void 0 : getParameterNameAtPosition(right, i3);
            var paramName = leftName === rightName ? leftName : !leftName ? rightName : !rightName ? leftName : void 0;
            var paramSymbol = createSymbol(1 | (isOptional && !isRestParam ? 16777216 : 0), paramName || "arg" + i3);
            paramSymbol.type = isRestParam ? createArrayType(unionParamType) : unionParamType;
            params[i3] = paramSymbol;
          }
          if (needsExtraRestElement) {
            var restParamSymbol = createSymbol(1, "args");
            restParamSymbol.type = createArrayType(getTypeAtPosition(shorter, longestCount));
            if (shorter === right) {
              restParamSymbol.type = instantiateType(restParamSymbol.type, mapper);
            }
            params[longestCount] = restParamSymbol;
          }
          return params;
        }
        function combineSignaturesOfIntersectionMembers(left, right) {
          var typeParams = left.typeParameters || right.typeParameters;
          var paramMapper;
          if (left.typeParameters && right.typeParameters) {
            paramMapper = createTypeMapper(right.typeParameters, left.typeParameters);
          }
          var declaration = left.declaration;
          var params = combineIntersectionParameters(left, right, paramMapper);
          var thisParam = combineIntersectionThisParam(left.thisParameter, right.thisParameter, paramMapper);
          var minArgCount = Math.max(left.minArgumentCount, right.minArgumentCount);
          var result2 = createSignature(declaration, typeParams, thisParam, params, void 0, void 0, minArgCount, (left.flags | right.flags) & 39);
          result2.compositeKind = 2097152;
          result2.compositeSignatures = ts3.concatenate(left.compositeKind === 2097152 && left.compositeSignatures || [left], [right]);
          if (paramMapper) {
            result2.mapper = left.compositeKind === 2097152 && left.mapper && left.compositeSignatures ? combineTypeMappers(left.mapper, paramMapper) : paramMapper;
          }
          return result2;
        }
        function getContextualCallSignature(type3, node) {
          var signatures = getSignaturesOfType(type3, 0);
          var applicableByArity = ts3.filter(signatures, function(s2) {
            return !isAritySmaller(s2, node);
          });
          return applicableByArity.length === 1 ? applicableByArity[0] : getIntersectedSignatures(applicableByArity);
        }
        function isAritySmaller(signature, target) {
          var targetParameterCount = 0;
          for (; targetParameterCount < target.parameters.length; targetParameterCount++) {
            var param = target.parameters[targetParameterCount];
            if (param.initializer || param.questionToken || param.dotDotDotToken || isJSDocOptionalParameter(param)) {
              break;
            }
          }
          if (target.parameters.length && ts3.parameterIsThisKeyword(target.parameters[0])) {
            targetParameterCount--;
          }
          return !hasEffectiveRestParameter(signature) && getParameterCount(signature) < targetParameterCount;
        }
        function isFunctionExpressionOrArrowFunction(node) {
          return node.kind === 209 || node.kind === 210;
        }
        function getContextualSignatureForFunctionLikeDeclaration(node) {
          return isFunctionExpressionOrArrowFunction(node) || ts3.isObjectLiteralMethod(node) ? getContextualSignature(node) : void 0;
        }
        function getContextualSignature(node) {
          ts3.Debug.assert(node.kind !== 166 || ts3.isObjectLiteralMethod(node));
          var typeTagSignature = getSignatureOfTypeTag(node);
          if (typeTagSignature) {
            return typeTagSignature;
          }
          var type3 = getApparentTypeOfContextualType(node, 1);
          if (!type3) {
            return void 0;
          }
          if (!(type3.flags & 1048576)) {
            return getContextualCallSignature(type3, node);
          }
          var signatureList;
          var types2 = type3.types;
          for (var _i = 0, types_20 = types2; _i < types_20.length; _i++) {
            var current = types_20[_i];
            var signature = getContextualCallSignature(current, node);
            if (signature) {
              if (!signatureList) {
                signatureList = [signature];
              } else if (!compareSignaturesIdentical(signatureList[0], signature, false, true, true, compareTypesIdentical)) {
                return void 0;
              } else {
                signatureList.push(signature);
              }
            }
          }
          if (signatureList) {
            return signatureList.length === 1 ? signatureList[0] : createUnionSignature(signatureList[0], signatureList);
          }
        }
        function checkSpreadExpression(node, checkMode) {
          if (languageVersion < 2) {
            checkExternalEmitHelpers(node, compilerOptions.downlevelIteration ? 1536 : 1024);
          }
          var arrayOrIterableType = checkExpression(node.expression, checkMode);
          return checkIteratedTypeOrElementType(33, arrayOrIterableType, undefinedType, node.expression);
        }
        function checkSyntheticExpression(node) {
          return node.isSpread ? getIndexedAccessType(node.type, numberType) : node.type;
        }
        function hasDefaultValue(node) {
          return node.kind === 199 && !!node.initializer || node.kind === 217 && node.operatorToken.kind === 62;
        }
        function checkArrayLiteral(node, checkMode, forceTuple) {
          var elements = node.elements;
          var elementCount = elements.length;
          var elementTypes = [];
          var elementFlags = [];
          var contextualType = getApparentTypeOfContextualType(node);
          var inDestructuringPattern = ts3.isAssignmentTarget(node);
          var inConstContext = isConstContext(node);
          for (var i3 = 0; i3 < elementCount; i3++) {
            var e2 = elements[i3];
            if (e2.kind === 221) {
              if (languageVersion < 2) {
                checkExternalEmitHelpers(e2, compilerOptions.downlevelIteration ? 1536 : 1024);
              }
              var spreadType = checkExpression(e2.expression, checkMode, forceTuple);
              if (isArrayLikeType(spreadType)) {
                elementTypes.push(spreadType);
                elementFlags.push(8);
              } else if (inDestructuringPattern) {
                var restElementType = getIndexTypeOfType(spreadType, 1) || getIteratedTypeOrElementType(65, spreadType, undefinedType, void 0, false) || unknownType;
                elementTypes.push(restElementType);
                elementFlags.push(4);
              } else {
                elementTypes.push(checkIteratedTypeOrElementType(33, spreadType, undefinedType, e2.expression));
                elementFlags.push(4);
              }
            } else {
              var elementContextualType = getContextualTypeForElementExpression(contextualType, elementTypes.length);
              var type3 = checkExpressionForMutableLocation(e2, checkMode, elementContextualType, forceTuple);
              elementTypes.push(type3);
              elementFlags.push(1);
            }
          }
          if (inDestructuringPattern) {
            return createTupleType(elementTypes, elementFlags);
          }
          if (forceTuple || inConstContext || contextualType && someType(contextualType, isTupleLikeType)) {
            return createArrayLiteralType(createTupleType(elementTypes, elementFlags, inConstContext));
          }
          return createArrayLiteralType(createArrayType(elementTypes.length ? getUnionType(ts3.sameMap(elementTypes, function(t2, i4) {
            return elementFlags[i4] & 8 ? getIndexedAccessTypeOrUndefined(t2, numberType) || anyType : t2;
          }), 2) : strictNullChecks ? implicitNeverType : undefinedWideningType, inConstContext));
        }
        function createArrayLiteralType(type3) {
          if (!(ts3.getObjectFlags(type3) & 4)) {
            return type3;
          }
          var literalType = type3.literalType;
          if (!literalType) {
            literalType = type3.literalType = cloneTypeReference(type3);
            literalType.objectFlags |= 32768 | 262144;
          }
          return literalType;
        }
        function isNumericName(name) {
          switch (name.kind) {
            case 159:
              return isNumericComputedName(name);
            case 78:
              return isNumericLiteralName(name.escapedText);
            case 8:
            case 10:
              return isNumericLiteralName(name.text);
            default:
              return false;
          }
        }
        function isNumericComputedName(name) {
          return isTypeAssignableToKind(checkComputedPropertyName(name), 296);
        }
        function isInfinityOrNaNString(name) {
          return name === "Infinity" || name === "-Infinity" || name === "NaN";
        }
        function isNumericLiteralName(name) {
          return (+name).toString() === name;
        }
        function checkComputedPropertyName(node) {
          var links = getNodeLinks(node.expression);
          if (!links.resolvedType) {
            links.resolvedType = checkExpression(node.expression);
            if (ts3.isPropertyDeclaration(node.parent) && !ts3.hasStaticModifier(node.parent) && ts3.isClassExpression(node.parent.parent)) {
              var container = ts3.getEnclosingBlockScopeContainer(node.parent.parent);
              var enclosingIterationStatement = getEnclosingIterationStatement(container);
              if (enclosingIterationStatement) {
                getNodeLinks(enclosingIterationStatement).flags |= 65536;
                getNodeLinks(node).flags |= 524288;
                getNodeLinks(node.parent.parent).flags |= 524288;
              }
            }
            if (links.resolvedType.flags & 98304 || !isTypeAssignableToKind(links.resolvedType, 402653316 | 296 | 12288) && !isTypeAssignableTo(links.resolvedType, stringNumberSymbolType)) {
              error(node, ts3.Diagnostics.A_computed_property_name_must_be_of_type_string_number_symbol_or_any);
            }
          }
          return links.resolvedType;
        }
        function isSymbolWithNumericName(symbol) {
          var _a2;
          var firstDecl = (_a2 = symbol.declarations) === null || _a2 === void 0 ? void 0 : _a2[0];
          return isNumericLiteralName(symbol.escapedName) || firstDecl && ts3.isNamedDeclaration(firstDecl) && isNumericName(firstDecl.name);
        }
        function getObjectLiteralIndexInfo(node, offset, properties, kind) {
          var propTypes = [];
          for (var i3 = offset; i3 < properties.length; i3++) {
            if (kind === 0 || isSymbolWithNumericName(properties[i3])) {
              propTypes.push(getTypeOfSymbol(properties[i3]));
            }
          }
          var unionType = propTypes.length ? getUnionType(propTypes, 2) : undefinedType;
          return createIndexInfo(unionType, isConstContext(node));
        }
        function getImmediateAliasedSymbol(symbol) {
          ts3.Debug.assert((symbol.flags & 2097152) !== 0, "Should only get Alias here.");
          var links = getSymbolLinks(symbol);
          if (!links.immediateTarget) {
            var node = getDeclarationOfAliasSymbol(symbol);
            if (!node)
              return ts3.Debug.fail();
            links.immediateTarget = getTargetOfAliasDeclaration(node, true);
          }
          return links.immediateTarget;
        }
        function checkObjectLiteral(node, checkMode) {
          var inDestructuringPattern = ts3.isAssignmentTarget(node);
          checkGrammarObjectLiteralExpression(node, inDestructuringPattern);
          var allPropertiesTable = strictNullChecks ? ts3.createSymbolTable() : void 0;
          var propertiesTable = ts3.createSymbolTable();
          var propertiesArray = [];
          var spread = emptyObjectType;
          var contextualType = getApparentTypeOfContextualType(node);
          var contextualTypeHasPattern = contextualType && contextualType.pattern && (contextualType.pattern.kind === 197 || contextualType.pattern.kind === 201);
          var inConstContext = isConstContext(node);
          var checkFlags = inConstContext ? 8 : 0;
          var isInJavascript = ts3.isInJSFile(node) && !ts3.isInJsonFile(node);
          var enumTag = ts3.getJSDocEnumTag(node);
          var isJSObjectLiteral = !contextualType && isInJavascript && !enumTag;
          var objectFlags = freshObjectLiteralFlag;
          var patternWithComputedProperties = false;
          var hasComputedStringProperty = false;
          var hasComputedNumberProperty = false;
          for (var _i = 0, _a2 = node.properties; _i < _a2.length; _i++) {
            var elem = _a2[_i];
            if (elem.name && ts3.isComputedPropertyName(elem.name)) {
              checkComputedPropertyName(elem.name);
            }
          }
          var offset = 0;
          for (var _b = 0, _c = node.properties; _b < _c.length; _b++) {
            var memberDecl = _c[_b];
            var member = getSymbolOfNode(memberDecl);
            var computedNameType = memberDecl.name && memberDecl.name.kind === 159 ? checkComputedPropertyName(memberDecl.name) : void 0;
            if (memberDecl.kind === 289 || memberDecl.kind === 290 || ts3.isObjectLiteralMethod(memberDecl)) {
              var type3 = memberDecl.kind === 289 ? checkPropertyAssignment(memberDecl, checkMode) : memberDecl.kind === 290 ? checkExpressionForMutableLocation(!inDestructuringPattern && memberDecl.objectAssignmentInitializer ? memberDecl.objectAssignmentInitializer : memberDecl.name, checkMode) : checkObjectLiteralMethod(memberDecl, checkMode);
              if (isInJavascript) {
                var jsDocType = getTypeForDeclarationFromJSDocComment(memberDecl);
                if (jsDocType) {
                  checkTypeAssignableTo(type3, jsDocType, memberDecl);
                  type3 = jsDocType;
                } else if (enumTag && enumTag.typeExpression) {
                  checkTypeAssignableTo(type3, getTypeFromTypeNode(enumTag.typeExpression), memberDecl);
                }
              }
              objectFlags |= ts3.getObjectFlags(type3) & 917504;
              var nameType = computedNameType && isTypeUsableAsPropertyName(computedNameType) ? computedNameType : void 0;
              var prop = nameType ? createSymbol(4 | member.flags, getPropertyNameFromType(nameType), checkFlags | 4096) : createSymbol(4 | member.flags, member.escapedName, checkFlags);
              if (nameType) {
                prop.nameType = nameType;
              }
              if (inDestructuringPattern) {
                var isOptional = memberDecl.kind === 289 && hasDefaultValue(memberDecl.initializer) || memberDecl.kind === 290 && memberDecl.objectAssignmentInitializer;
                if (isOptional) {
                  prop.flags |= 16777216;
                }
              } else if (contextualTypeHasPattern && !(ts3.getObjectFlags(contextualType) & 512)) {
                var impliedProp = getPropertyOfType(contextualType, member.escapedName);
                if (impliedProp) {
                  prop.flags |= impliedProp.flags & 16777216;
                } else if (!compilerOptions.suppressExcessPropertyErrors && !getIndexInfoOfType(contextualType, 0)) {
                  error(memberDecl.name, ts3.Diagnostics.Object_literal_may_only_specify_known_properties_and_0_does_not_exist_in_type_1, symbolToString(member), typeToString(contextualType));
                }
              }
              prop.declarations = member.declarations;
              prop.parent = member.parent;
              if (member.valueDeclaration) {
                prop.valueDeclaration = member.valueDeclaration;
              }
              prop.type = type3;
              prop.target = member;
              member = prop;
              allPropertiesTable === null || allPropertiesTable === void 0 ? void 0 : allPropertiesTable.set(prop.escapedName, prop);
            } else if (memberDecl.kind === 291) {
              if (languageVersion < 2) {
                checkExternalEmitHelpers(memberDecl, 2);
              }
              if (propertiesArray.length > 0) {
                spread = getSpreadType(spread, createObjectLiteralType(), node.symbol, objectFlags, inConstContext);
                propertiesArray = [];
                propertiesTable = ts3.createSymbolTable();
                hasComputedStringProperty = false;
                hasComputedNumberProperty = false;
              }
              var type3 = getReducedType(checkExpression(memberDecl.expression));
              if (isValidSpreadType(type3)) {
                if (allPropertiesTable) {
                  checkSpreadPropOverrides(type3, allPropertiesTable, memberDecl);
                }
                offset = propertiesArray.length;
                if (spread === errorType) {
                  continue;
                }
                spread = getSpreadType(spread, type3, node.symbol, objectFlags, inConstContext);
              } else {
                error(memberDecl, ts3.Diagnostics.Spread_types_may_only_be_created_from_object_types);
                spread = errorType;
              }
              continue;
            } else {
              ts3.Debug.assert(memberDecl.kind === 168 || memberDecl.kind === 169);
              checkNodeDeferred(memberDecl);
            }
            if (computedNameType && !(computedNameType.flags & 8576)) {
              if (isTypeAssignableTo(computedNameType, stringNumberSymbolType)) {
                if (isTypeAssignableTo(computedNameType, numberType)) {
                  hasComputedNumberProperty = true;
                } else {
                  hasComputedStringProperty = true;
                }
                if (inDestructuringPattern) {
                  patternWithComputedProperties = true;
                }
              }
            } else {
              propertiesTable.set(member.escapedName, member);
            }
            propertiesArray.push(member);
          }
          if (contextualTypeHasPattern && node.parent.kind !== 291) {
            for (var _d = 0, _e = getPropertiesOfType(contextualType); _d < _e.length; _d++) {
              var prop = _e[_d];
              if (!propertiesTable.get(prop.escapedName) && !getPropertyOfType(spread, prop.escapedName)) {
                if (!(prop.flags & 16777216)) {
                  error(prop.valueDeclaration || prop.bindingElement, ts3.Diagnostics.Initializer_provides_no_value_for_this_binding_element_and_the_binding_element_has_no_default_value);
                }
                propertiesTable.set(prop.escapedName, prop);
                propertiesArray.push(prop);
              }
            }
          }
          if (spread === errorType) {
            return errorType;
          }
          if (spread !== emptyObjectType) {
            if (propertiesArray.length > 0) {
              spread = getSpreadType(spread, createObjectLiteralType(), node.symbol, objectFlags, inConstContext);
              propertiesArray = [];
              propertiesTable = ts3.createSymbolTable();
              hasComputedStringProperty = false;
              hasComputedNumberProperty = false;
            }
            return mapType(spread, function(t2) {
              return t2 === emptyObjectType ? createObjectLiteralType() : t2;
            });
          }
          return createObjectLiteralType();
          function createObjectLiteralType() {
            var stringIndexInfo = hasComputedStringProperty ? getObjectLiteralIndexInfo(node, offset, propertiesArray, 0) : void 0;
            var numberIndexInfo = hasComputedNumberProperty ? getObjectLiteralIndexInfo(node, offset, propertiesArray, 1) : void 0;
            var result2 = createAnonymousType(node.symbol, propertiesTable, ts3.emptyArray, ts3.emptyArray, stringIndexInfo, numberIndexInfo);
            result2.objectFlags |= objectFlags | 128 | 262144;
            if (isJSObjectLiteral) {
              result2.objectFlags |= 8192;
            }
            if (patternWithComputedProperties) {
              result2.objectFlags |= 512;
            }
            if (inDestructuringPattern) {
              result2.pattern = node;
            }
            return result2;
          }
        }
        function isValidSpreadType(type3) {
          if (type3.flags & 465829888) {
            var constraint = getBaseConstraintOfType(type3);
            if (constraint !== void 0) {
              return isValidSpreadType(constraint);
            }
          }
          return !!(type3.flags & (1 | 67108864 | 524288 | 58982400) || getFalsyFlags(type3) & 117632 && isValidSpreadType(removeDefinitelyFalsyTypes(type3)) || type3.flags & 3145728 && ts3.every(type3.types, isValidSpreadType));
        }
        function checkJsxSelfClosingElementDeferred(node) {
          checkJsxOpeningLikeElementOrOpeningFragment(node);
        }
        function checkJsxSelfClosingElement(node, _checkMode) {
          checkNodeDeferred(node);
          return getJsxElementTypeAt(node) || anyType;
        }
        function checkJsxElementDeferred(node) {
          checkJsxOpeningLikeElementOrOpeningFragment(node.openingElement);
          if (isJsxIntrinsicIdentifier(node.closingElement.tagName)) {
            getIntrinsicTagSymbol(node.closingElement);
          } else {
            checkExpression(node.closingElement.tagName);
          }
          checkJsxChildren(node);
        }
        function checkJsxElement(node, _checkMode) {
          checkNodeDeferred(node);
          return getJsxElementTypeAt(node) || anyType;
        }
        function checkJsxFragment(node) {
          checkJsxOpeningLikeElementOrOpeningFragment(node.openingFragment);
          var nodeSourceFile = ts3.getSourceFileOfNode(node);
          if (ts3.getJSXTransformEnabled(compilerOptions) && (compilerOptions.jsxFactory || nodeSourceFile.pragmas.has("jsx")) && !compilerOptions.jsxFragmentFactory && !nodeSourceFile.pragmas.has("jsxfrag")) {
            error(node, compilerOptions.jsxFactory ? ts3.Diagnostics.The_jsxFragmentFactory_compiler_option_must_be_provided_to_use_JSX_fragments_with_the_jsxFactory_compiler_option : ts3.Diagnostics.An_jsxFrag_pragma_is_required_when_using_an_jsx_pragma_with_JSX_fragments);
          }
          checkJsxChildren(node);
          return getJsxElementTypeAt(node) || anyType;
        }
        function isUnhyphenatedJsxName(name) {
          return !ts3.stringContains(name, "-");
        }
        function isJsxIntrinsicIdentifier(tagName) {
          return tagName.kind === 78 && ts3.isIntrinsicJsxName(tagName.escapedText);
        }
        function checkJsxAttribute(node, checkMode) {
          return node.initializer ? checkExpressionForMutableLocation(node.initializer, checkMode) : trueType;
        }
        function createJsxAttributesTypeFromAttributesProperty(openingLikeElement, checkMode) {
          var attributes = openingLikeElement.attributes;
          var allAttributesTable = strictNullChecks ? ts3.createSymbolTable() : void 0;
          var attributesTable = ts3.createSymbolTable();
          var spread = emptyJsxObjectType;
          var hasSpreadAnyType = false;
          var typeToIntersect;
          var explicitlySpecifyChildrenAttribute = false;
          var objectFlags = 2048;
          var jsxChildrenPropertyName = getJsxElementChildrenPropertyName(getJsxNamespaceAt(openingLikeElement));
          for (var _i = 0, _a2 = attributes.properties; _i < _a2.length; _i++) {
            var attributeDecl = _a2[_i];
            var member = attributeDecl.symbol;
            if (ts3.isJsxAttribute(attributeDecl)) {
              var exprType = checkJsxAttribute(attributeDecl, checkMode);
              objectFlags |= ts3.getObjectFlags(exprType) & 917504;
              var attributeSymbol = createSymbol(4 | member.flags, member.escapedName);
              attributeSymbol.declarations = member.declarations;
              attributeSymbol.parent = member.parent;
              if (member.valueDeclaration) {
                attributeSymbol.valueDeclaration = member.valueDeclaration;
              }
              attributeSymbol.type = exprType;
              attributeSymbol.target = member;
              attributesTable.set(attributeSymbol.escapedName, attributeSymbol);
              allAttributesTable === null || allAttributesTable === void 0 ? void 0 : allAttributesTable.set(attributeSymbol.escapedName, attributeSymbol);
              if (attributeDecl.name.escapedText === jsxChildrenPropertyName) {
                explicitlySpecifyChildrenAttribute = true;
              }
            } else {
              ts3.Debug.assert(attributeDecl.kind === 283);
              if (attributesTable.size > 0) {
                spread = getSpreadType(spread, createJsxAttributesType(), attributes.symbol, objectFlags, false);
                attributesTable = ts3.createSymbolTable();
              }
              var exprType = getReducedType(checkExpressionCached(attributeDecl.expression, checkMode));
              if (isTypeAny(exprType)) {
                hasSpreadAnyType = true;
              }
              if (isValidSpreadType(exprType)) {
                spread = getSpreadType(spread, exprType, attributes.symbol, objectFlags, false);
                if (allAttributesTable) {
                  checkSpreadPropOverrides(exprType, allAttributesTable, attributeDecl);
                }
              } else {
                typeToIntersect = typeToIntersect ? getIntersectionType([typeToIntersect, exprType]) : exprType;
              }
            }
          }
          if (!hasSpreadAnyType) {
            if (attributesTable.size > 0) {
              spread = getSpreadType(spread, createJsxAttributesType(), attributes.symbol, objectFlags, false);
            }
          }
          var parent = openingLikeElement.parent.kind === 274 ? openingLikeElement.parent : void 0;
          if (parent && parent.openingElement === openingLikeElement && parent.children.length > 0) {
            var childrenTypes = checkJsxChildren(parent, checkMode);
            if (!hasSpreadAnyType && jsxChildrenPropertyName && jsxChildrenPropertyName !== "") {
              if (explicitlySpecifyChildrenAttribute) {
                error(attributes, ts3.Diagnostics._0_are_specified_twice_The_attribute_named_0_will_be_overwritten, ts3.unescapeLeadingUnderscores(jsxChildrenPropertyName));
              }
              var contextualType = getApparentTypeOfContextualType(openingLikeElement.attributes);
              var childrenContextualType = contextualType && getTypeOfPropertyOfContextualType(contextualType, jsxChildrenPropertyName);
              var childrenPropSymbol = createSymbol(4, jsxChildrenPropertyName);
              childrenPropSymbol.type = childrenTypes.length === 1 ? childrenTypes[0] : childrenContextualType && someType(childrenContextualType, isTupleLikeType) ? createTupleType(childrenTypes) : createArrayType(getUnionType(childrenTypes));
              childrenPropSymbol.valueDeclaration = ts3.factory.createPropertySignature(void 0, ts3.unescapeLeadingUnderscores(jsxChildrenPropertyName), void 0, void 0);
              ts3.setParent(childrenPropSymbol.valueDeclaration, attributes);
              childrenPropSymbol.valueDeclaration.symbol = childrenPropSymbol;
              var childPropMap = ts3.createSymbolTable();
              childPropMap.set(jsxChildrenPropertyName, childrenPropSymbol);
              spread = getSpreadType(spread, createAnonymousType(attributes.symbol, childPropMap, ts3.emptyArray, ts3.emptyArray, void 0, void 0), attributes.symbol, objectFlags, false);
            }
          }
          if (hasSpreadAnyType) {
            return anyType;
          }
          if (typeToIntersect && spread !== emptyJsxObjectType) {
            return getIntersectionType([typeToIntersect, spread]);
          }
          return typeToIntersect || (spread === emptyJsxObjectType ? createJsxAttributesType() : spread);
          function createJsxAttributesType() {
            objectFlags |= freshObjectLiteralFlag;
            var result2 = createAnonymousType(attributes.symbol, attributesTable, ts3.emptyArray, ts3.emptyArray, void 0, void 0);
            result2.objectFlags |= objectFlags | 128 | 262144;
            return result2;
          }
        }
        function checkJsxChildren(node, checkMode) {
          var childrenTypes = [];
          for (var _i = 0, _a2 = node.children; _i < _a2.length; _i++) {
            var child = _a2[_i];
            if (child.kind === 11) {
              if (!child.containsOnlyTriviaWhiteSpaces) {
                childrenTypes.push(stringType);
              }
            } else if (child.kind === 284 && !child.expression) {
              continue;
            } else {
              childrenTypes.push(checkExpressionForMutableLocation(child, checkMode));
            }
          }
          return childrenTypes;
        }
        function checkSpreadPropOverrides(type3, props, spread) {
          for (var _i = 0, _a2 = getPropertiesOfType(type3); _i < _a2.length; _i++) {
            var right = _a2[_i];
            var left = props.get(right.escapedName);
            var rightType = getTypeOfSymbol(right);
            if (left && !maybeTypeOfKind(rightType, 98304) && !(maybeTypeOfKind(rightType, 3) && right.flags & 16777216)) {
              var diagnostic = error(left.valueDeclaration, ts3.Diagnostics._0_is_specified_more_than_once_so_this_usage_will_be_overwritten, ts3.unescapeLeadingUnderscores(left.escapedName));
              ts3.addRelatedInfo(diagnostic, ts3.createDiagnosticForNode(spread, ts3.Diagnostics.This_spread_always_overwrites_this_property));
            }
          }
        }
        function checkJsxAttributes(node, checkMode) {
          return createJsxAttributesTypeFromAttributesProperty(node.parent, checkMode);
        }
        function getJsxType(name, location) {
          var namespace = getJsxNamespaceAt(location);
          var exports3 = namespace && getExportsOfSymbol(namespace);
          var typeSymbol = exports3 && getSymbol(exports3, name, 788968);
          return typeSymbol ? getDeclaredTypeOfSymbol(typeSymbol) : errorType;
        }
        function getIntrinsicTagSymbol(node) {
          var links = getNodeLinks(node);
          if (!links.resolvedSymbol) {
            var intrinsicElementsType = getJsxType(JsxNames.IntrinsicElements, node);
            if (intrinsicElementsType !== errorType) {
              if (!ts3.isIdentifier(node.tagName))
                return ts3.Debug.fail();
              var intrinsicProp = getPropertyOfType(intrinsicElementsType, node.tagName.escapedText);
              if (intrinsicProp) {
                links.jsxFlags |= 1;
                return links.resolvedSymbol = intrinsicProp;
              }
              var indexSignatureType = getIndexTypeOfType(intrinsicElementsType, 0);
              if (indexSignatureType) {
                links.jsxFlags |= 2;
                return links.resolvedSymbol = intrinsicElementsType.symbol;
              }
              error(node, ts3.Diagnostics.Property_0_does_not_exist_on_type_1, ts3.idText(node.tagName), "JSX." + JsxNames.IntrinsicElements);
              return links.resolvedSymbol = unknownSymbol;
            } else {
              if (noImplicitAny) {
                error(node, ts3.Diagnostics.JSX_element_implicitly_has_type_any_because_no_interface_JSX_0_exists, ts3.unescapeLeadingUnderscores(JsxNames.IntrinsicElements));
              }
              return links.resolvedSymbol = unknownSymbol;
            }
          }
          return links.resolvedSymbol;
        }
        function getJsxNamespaceContainerForImplicitImport(location) {
          var file = location && ts3.getSourceFileOfNode(location);
          var links = file && getNodeLinks(file);
          if (links && links.jsxImplicitImportContainer === false) {
            return void 0;
          }
          if (links && links.jsxImplicitImportContainer) {
            return links.jsxImplicitImportContainer;
          }
          var runtimeImportSpecifier = ts3.getJSXRuntimeImport(ts3.getJSXImplicitImportBase(compilerOptions, file), compilerOptions);
          if (!runtimeImportSpecifier) {
            return void 0;
          }
          var isClassic = ts3.getEmitModuleResolutionKind(compilerOptions) === ts3.ModuleResolutionKind.Classic;
          var errorMessage = isClassic ? ts3.Diagnostics.Cannot_find_module_0_Did_you_mean_to_set_the_moduleResolution_option_to_node_or_to_add_aliases_to_the_paths_option : ts3.Diagnostics.Cannot_find_module_0_or_its_corresponding_type_declarations;
          var mod = resolveExternalModule(location, runtimeImportSpecifier, errorMessage, location);
          var result2 = mod && mod !== unknownSymbol ? getMergedSymbol(resolveSymbol(mod)) : void 0;
          if (links) {
            links.jsxImplicitImportContainer = result2 || false;
          }
          return result2;
        }
        function getJsxNamespaceAt(location) {
          var links = location && getNodeLinks(location);
          if (links && links.jsxNamespace) {
            return links.jsxNamespace;
          }
          if (!links || links.jsxNamespace !== false) {
            var resolvedNamespace = getJsxNamespaceContainerForImplicitImport(location);
            if (!resolvedNamespace || resolvedNamespace === unknownSymbol) {
              var namespaceName = getJsxNamespace(location);
              resolvedNamespace = resolveName(location, namespaceName, 1920, void 0, namespaceName, false);
            }
            if (resolvedNamespace) {
              var candidate = resolveSymbol(getSymbol(getExportsOfSymbol(resolveSymbol(resolvedNamespace)), JsxNames.JSX, 1920));
              if (candidate && candidate !== unknownSymbol) {
                if (links) {
                  links.jsxNamespace = candidate;
                }
                return candidate;
              }
            }
            if (links) {
              links.jsxNamespace = false;
            }
          }
          var s2 = resolveSymbol(getGlobalSymbol(JsxNames.JSX, 1920, void 0));
          if (s2 === unknownSymbol) {
            return void 0;
          }
          return s2;
        }
        function getNameFromJsxElementAttributesContainer(nameOfAttribPropContainer, jsxNamespace) {
          var jsxElementAttribPropInterfaceSym = jsxNamespace && getSymbol(jsxNamespace.exports, nameOfAttribPropContainer, 788968);
          var jsxElementAttribPropInterfaceType = jsxElementAttribPropInterfaceSym && getDeclaredTypeOfSymbol(jsxElementAttribPropInterfaceSym);
          var propertiesOfJsxElementAttribPropInterface = jsxElementAttribPropInterfaceType && getPropertiesOfType(jsxElementAttribPropInterfaceType);
          if (propertiesOfJsxElementAttribPropInterface) {
            if (propertiesOfJsxElementAttribPropInterface.length === 0) {
              return "";
            } else if (propertiesOfJsxElementAttribPropInterface.length === 1) {
              return propertiesOfJsxElementAttribPropInterface[0].escapedName;
            } else if (propertiesOfJsxElementAttribPropInterface.length > 1 && jsxElementAttribPropInterfaceSym.declarations) {
              error(jsxElementAttribPropInterfaceSym.declarations[0], ts3.Diagnostics.The_global_type_JSX_0_may_not_have_more_than_one_property, ts3.unescapeLeadingUnderscores(nameOfAttribPropContainer));
            }
          }
          return void 0;
        }
        function getJsxLibraryManagedAttributes(jsxNamespace) {
          return jsxNamespace && getSymbol(jsxNamespace.exports, JsxNames.LibraryManagedAttributes, 788968);
        }
        function getJsxElementPropertiesName(jsxNamespace) {
          return getNameFromJsxElementAttributesContainer(JsxNames.ElementAttributesPropertyNameContainer, jsxNamespace);
        }
        function getJsxElementChildrenPropertyName(jsxNamespace) {
          return getNameFromJsxElementAttributesContainer(JsxNames.ElementChildrenAttributeNameContainer, jsxNamespace);
        }
        function getUninstantiatedJsxSignaturesOfType(elementType, caller) {
          if (elementType.flags & 4) {
            return [anySignature];
          } else if (elementType.flags & 128) {
            var intrinsicType = getIntrinsicAttributesTypeFromStringLiteralType(elementType, caller);
            if (!intrinsicType) {
              error(caller, ts3.Diagnostics.Property_0_does_not_exist_on_type_1, elementType.value, "JSX." + JsxNames.IntrinsicElements);
              return ts3.emptyArray;
            } else {
              var fakeSignature = createSignatureForJSXIntrinsic(caller, intrinsicType);
              return [fakeSignature];
            }
          }
          var apparentElemType = getApparentType(elementType);
          var signatures = getSignaturesOfType(apparentElemType, 1);
          if (signatures.length === 0) {
            signatures = getSignaturesOfType(apparentElemType, 0);
          }
          if (signatures.length === 0 && apparentElemType.flags & 1048576) {
            signatures = getUnionSignatures(ts3.map(apparentElemType.types, function(t2) {
              return getUninstantiatedJsxSignaturesOfType(t2, caller);
            }));
          }
          return signatures;
        }
        function getIntrinsicAttributesTypeFromStringLiteralType(type3, location) {
          var intrinsicElementsType = getJsxType(JsxNames.IntrinsicElements, location);
          if (intrinsicElementsType !== errorType) {
            var stringLiteralTypeName = type3.value;
            var intrinsicProp = getPropertyOfType(intrinsicElementsType, ts3.escapeLeadingUnderscores(stringLiteralTypeName));
            if (intrinsicProp) {
              return getTypeOfSymbol(intrinsicProp);
            }
            var indexSignatureType = getIndexTypeOfType(intrinsicElementsType, 0);
            if (indexSignatureType) {
              return indexSignatureType;
            }
            return void 0;
          }
          return anyType;
        }
        function checkJsxReturnAssignableToAppropriateBound(refKind, elemInstanceType, openingLikeElement) {
          if (refKind === 1) {
            var sfcReturnConstraint = getJsxStatelessElementTypeAt(openingLikeElement);
            if (sfcReturnConstraint) {
              checkTypeRelatedTo(elemInstanceType, sfcReturnConstraint, assignableRelation, openingLikeElement.tagName, ts3.Diagnostics.Its_return_type_0_is_not_a_valid_JSX_element, generateInitialErrorChain);
            }
          } else if (refKind === 0) {
            var classConstraint = getJsxElementClassTypeAt(openingLikeElement);
            if (classConstraint) {
              checkTypeRelatedTo(elemInstanceType, classConstraint, assignableRelation, openingLikeElement.tagName, ts3.Diagnostics.Its_instance_type_0_is_not_a_valid_JSX_element, generateInitialErrorChain);
            }
          } else {
            var sfcReturnConstraint = getJsxStatelessElementTypeAt(openingLikeElement);
            var classConstraint = getJsxElementClassTypeAt(openingLikeElement);
            if (!sfcReturnConstraint || !classConstraint) {
              return;
            }
            var combined = getUnionType([sfcReturnConstraint, classConstraint]);
            checkTypeRelatedTo(elemInstanceType, combined, assignableRelation, openingLikeElement.tagName, ts3.Diagnostics.Its_element_type_0_is_not_a_valid_JSX_element, generateInitialErrorChain);
          }
          function generateInitialErrorChain() {
            var componentName = ts3.getTextOfNode(openingLikeElement.tagName);
            return ts3.chainDiagnosticMessages(void 0, ts3.Diagnostics._0_cannot_be_used_as_a_JSX_component, componentName);
          }
        }
        function getIntrinsicAttributesTypeFromJsxOpeningLikeElement(node) {
          ts3.Debug.assert(isJsxIntrinsicIdentifier(node.tagName));
          var links = getNodeLinks(node);
          if (!links.resolvedJsxElementAttributesType) {
            var symbol = getIntrinsicTagSymbol(node);
            if (links.jsxFlags & 1) {
              return links.resolvedJsxElementAttributesType = getTypeOfSymbol(symbol) || errorType;
            } else if (links.jsxFlags & 2) {
              return links.resolvedJsxElementAttributesType = getIndexTypeOfType(getJsxType(JsxNames.IntrinsicElements, node), 0) || errorType;
            } else {
              return links.resolvedJsxElementAttributesType = errorType;
            }
          }
          return links.resolvedJsxElementAttributesType;
        }
        function getJsxElementClassTypeAt(location) {
          var type3 = getJsxType(JsxNames.ElementClass, location);
          if (type3 === errorType)
            return void 0;
          return type3;
        }
        function getJsxElementTypeAt(location) {
          return getJsxType(JsxNames.Element, location);
        }
        function getJsxStatelessElementTypeAt(location) {
          var jsxElementType = getJsxElementTypeAt(location);
          if (jsxElementType) {
            return getUnionType([jsxElementType, nullType]);
          }
        }
        function getJsxIntrinsicTagNamesAt(location) {
          var intrinsics = getJsxType(JsxNames.IntrinsicElements, location);
          return intrinsics ? getPropertiesOfType(intrinsics) : ts3.emptyArray;
        }
        function checkJsxPreconditions(errorNode) {
          if ((compilerOptions.jsx || 0) === 0) {
            error(errorNode, ts3.Diagnostics.Cannot_use_JSX_unless_the_jsx_flag_is_provided);
          }
          if (getJsxElementTypeAt(errorNode) === void 0) {
            if (noImplicitAny) {
              error(errorNode, ts3.Diagnostics.JSX_element_implicitly_has_type_any_because_the_global_type_JSX_Element_does_not_exist);
            }
          }
        }
        function checkJsxOpeningLikeElementOrOpeningFragment(node) {
          var isNodeOpeningLikeElement = ts3.isJsxOpeningLikeElement(node);
          if (isNodeOpeningLikeElement) {
            checkGrammarJsxElement(node);
          }
          checkJsxPreconditions(node);
          if (!getJsxNamespaceContainerForImplicitImport(node)) {
            var jsxFactoryRefErr = diagnostics && compilerOptions.jsx === 2 ? ts3.Diagnostics.Cannot_find_name_0 : void 0;
            var jsxFactoryNamespace = getJsxNamespace(node);
            var jsxFactoryLocation = isNodeOpeningLikeElement ? node.tagName : node;
            var jsxFactorySym = void 0;
            if (!(ts3.isJsxOpeningFragment(node) && jsxFactoryNamespace === "null")) {
              jsxFactorySym = resolveName(jsxFactoryLocation, jsxFactoryNamespace, 111551, jsxFactoryRefErr, jsxFactoryNamespace, true);
            }
            if (jsxFactorySym) {
              jsxFactorySym.isReferenced = 67108863;
              if (jsxFactorySym.flags & 2097152 && !getTypeOnlyAliasDeclaration(jsxFactorySym)) {
                markAliasSymbolAsReferenced(jsxFactorySym);
              }
            }
          }
          if (isNodeOpeningLikeElement) {
            var jsxOpeningLikeNode = node;
            var sig = getResolvedSignature(jsxOpeningLikeNode);
            checkDeprecatedSignature(sig, node);
            checkJsxReturnAssignableToAppropriateBound(getJsxReferenceKind(jsxOpeningLikeNode), getReturnTypeOfSignature(sig), jsxOpeningLikeNode);
          }
        }
        function isKnownProperty(targetType, name, isComparingJsxAttributes) {
          if (targetType.flags & 524288) {
            var resolved = resolveStructuredTypeMembers(targetType);
            if (resolved.stringIndexInfo || resolved.numberIndexInfo && isNumericLiteralName(name) || getPropertyOfObjectType(targetType, name) || isComparingJsxAttributes && !isUnhyphenatedJsxName(name)) {
              return true;
            }
          } else if (targetType.flags & 3145728 && isExcessPropertyCheckTarget(targetType)) {
            for (var _i = 0, _a2 = targetType.types; _i < _a2.length; _i++) {
              var t2 = _a2[_i];
              if (isKnownProperty(t2, name, isComparingJsxAttributes)) {
                return true;
              }
            }
          }
          return false;
        }
        function isExcessPropertyCheckTarget(type3) {
          return !!(type3.flags & 524288 && !(ts3.getObjectFlags(type3) & 512) || type3.flags & 67108864 || type3.flags & 1048576 && ts3.some(type3.types, isExcessPropertyCheckTarget) || type3.flags & 2097152 && ts3.every(type3.types, isExcessPropertyCheckTarget));
        }
        function checkJsxExpression(node, checkMode) {
          checkGrammarJsxExpression(node);
          if (node.expression) {
            var type3 = checkExpression(node.expression, checkMode);
            if (node.dotDotDotToken && type3 !== anyType && !isArrayType(type3)) {
              error(node, ts3.Diagnostics.JSX_spread_child_must_be_an_array_type);
            }
            return type3;
          } else {
            return errorType;
          }
        }
        function getDeclarationNodeFlagsFromSymbol(s2) {
          return s2.valueDeclaration ? ts3.getCombinedNodeFlags(s2.valueDeclaration) : 0;
        }
        function isPrototypeProperty(symbol) {
          if (symbol.flags & 8192 || ts3.getCheckFlags(symbol) & 4) {
            return true;
          }
          if (ts3.isInJSFile(symbol.valueDeclaration)) {
            var parent = symbol.valueDeclaration.parent;
            return parent && ts3.isBinaryExpression(parent) && ts3.getAssignmentDeclarationKind(parent) === 3;
          }
        }
        function checkPropertyAccessibility(node, isSuper, writing, type3, prop, reportError) {
          if (reportError === void 0) {
            reportError = true;
          }
          var flags = ts3.getDeclarationModifierFlagsFromSymbol(prop, writing);
          var errorNode = node.kind === 158 ? node.right : node.kind === 196 ? node : node.kind === 199 && node.propertyName ? node.propertyName : node.name;
          if (isSuper) {
            if (languageVersion < 2) {
              if (symbolHasNonMethodDeclaration(prop)) {
                if (reportError) {
                  error(errorNode, ts3.Diagnostics.Only_public_and_protected_methods_of_the_base_class_are_accessible_via_the_super_keyword);
                }
                return false;
              }
            }
            if (flags & 128) {
              if (reportError) {
                error(errorNode, ts3.Diagnostics.Abstract_method_0_in_class_1_cannot_be_accessed_via_super_expression, symbolToString(prop), typeToString(getDeclaringClass(prop)));
              }
              return false;
            }
          }
          if (flags & 128 && symbolHasNonMethodDeclaration(prop) && (ts3.isThisProperty(node) || ts3.isThisInitializedObjectBindingExpression(node) || ts3.isObjectBindingPattern(node.parent) && ts3.isThisInitializedDeclaration(node.parent.parent))) {
            var declaringClassDeclaration = ts3.getClassLikeDeclarationOfSymbol(getParentOfSymbol(prop));
            if (declaringClassDeclaration && isNodeUsedDuringClassInitialization(node)) {
              if (reportError) {
                error(errorNode, ts3.Diagnostics.Abstract_property_0_in_class_1_cannot_be_accessed_in_the_constructor, symbolToString(prop), ts3.getTextOfIdentifierOrLiteral(declaringClassDeclaration.name));
              }
              return false;
            }
          }
          if (!(flags & 24)) {
            return true;
          }
          if (flags & 8) {
            var declaringClassDeclaration = ts3.getClassLikeDeclarationOfSymbol(getParentOfSymbol(prop));
            if (!isNodeWithinClass(node, declaringClassDeclaration)) {
              if (reportError) {
                error(errorNode, ts3.Diagnostics.Property_0_is_private_and_only_accessible_within_class_1, symbolToString(prop), typeToString(getDeclaringClass(prop)));
              }
              return false;
            }
            return true;
          }
          if (isSuper) {
            return true;
          }
          var enclosingClass = forEachEnclosingClass(node, function(enclosingDeclaration) {
            var enclosingClass2 = getDeclaredTypeOfSymbol(getSymbolOfNode(enclosingDeclaration));
            return isClassDerivedFromDeclaringClasses(enclosingClass2, prop, writing) ? enclosingClass2 : void 0;
          });
          if (!enclosingClass) {
            var thisParameter = void 0;
            if (flags & 32 || !(thisParameter = getThisParameterFromNodeContext(node)) || !thisParameter.type) {
              if (reportError) {
                error(errorNode, ts3.Diagnostics.Property_0_is_protected_and_only_accessible_within_class_1_and_its_subclasses, symbolToString(prop), typeToString(getDeclaringClass(prop) || type3));
              }
              return false;
            }
            var thisType = getTypeFromTypeNode(thisParameter.type);
            enclosingClass = (thisType.flags & 262144 ? getConstraintOfTypeParameter(thisType) : thisType).target;
          }
          if (flags & 32) {
            return true;
          }
          if (type3.flags & 262144) {
            type3 = type3.isThisType ? getConstraintOfTypeParameter(type3) : getBaseConstraintOfType(type3);
          }
          if (!type3 || !hasBaseType(type3, enclosingClass)) {
            if (reportError) {
              error(errorNode, ts3.Diagnostics.Property_0_is_protected_and_only_accessible_through_an_instance_of_class_1_This_is_an_instance_of_class_2, symbolToString(prop), typeToString(enclosingClass), typeToString(type3));
            }
            return false;
          }
          return true;
        }
        function getThisParameterFromNodeContext(node) {
          var thisContainer = ts3.getThisContainer(node, false);
          return thisContainer && ts3.isFunctionLike(thisContainer) ? ts3.getThisParameter(thisContainer) : void 0;
        }
        function symbolHasNonMethodDeclaration(symbol) {
          return !!forEachProperty(symbol, function(prop) {
            return !(prop.flags & 8192);
          });
        }
        function checkNonNullExpression(node) {
          return checkNonNullType(checkExpression(node), node);
        }
        function isNullableType(type3) {
          return !!((strictNullChecks ? getFalsyFlags(type3) : type3.flags) & 98304);
        }
        function getNonNullableTypeIfNeeded(type3) {
          return isNullableType(type3) ? getNonNullableType(type3) : type3;
        }
        function reportObjectPossiblyNullOrUndefinedError(node, flags) {
          error(node, flags & 32768 ? flags & 65536 ? ts3.Diagnostics.Object_is_possibly_null_or_undefined : ts3.Diagnostics.Object_is_possibly_undefined : ts3.Diagnostics.Object_is_possibly_null);
        }
        function reportCannotInvokePossiblyNullOrUndefinedError(node, flags) {
          error(node, flags & 32768 ? flags & 65536 ? ts3.Diagnostics.Cannot_invoke_an_object_which_is_possibly_null_or_undefined : ts3.Diagnostics.Cannot_invoke_an_object_which_is_possibly_undefined : ts3.Diagnostics.Cannot_invoke_an_object_which_is_possibly_null);
        }
        function checkNonNullTypeWithReporter(type3, node, reportError) {
          if (strictNullChecks && type3.flags & 2) {
            error(node, ts3.Diagnostics.Object_is_of_type_unknown);
            return errorType;
          }
          var kind = (strictNullChecks ? getFalsyFlags(type3) : type3.flags) & 98304;
          if (kind) {
            reportError(node, kind);
            var t2 = getNonNullableType(type3);
            return t2.flags & (98304 | 131072) ? errorType : t2;
          }
          return type3;
        }
        function checkNonNullType(type3, node) {
          return checkNonNullTypeWithReporter(type3, node, reportObjectPossiblyNullOrUndefinedError);
        }
        function checkNonNullNonVoidType(type3, node) {
          var nonNullType = checkNonNullType(type3, node);
          if (nonNullType !== errorType && nonNullType.flags & 16384) {
            error(node, ts3.Diagnostics.Object_is_possibly_undefined);
          }
          return nonNullType;
        }
        function checkPropertyAccessExpression(node, checkMode) {
          return node.flags & 32 ? checkPropertyAccessChain(node, checkMode) : checkPropertyAccessExpressionOrQualifiedName(node, node.expression, checkNonNullExpression(node.expression), node.name, checkMode);
        }
        function checkPropertyAccessChain(node, checkMode) {
          var leftType = checkExpression(node.expression);
          var nonOptionalType = getOptionalExpressionType(leftType, node.expression);
          return propagateOptionalTypeMarker(checkPropertyAccessExpressionOrQualifiedName(node, node.expression, checkNonNullType(nonOptionalType, node.expression), node.name, checkMode), node, nonOptionalType !== leftType);
        }
        function checkQualifiedName(node, checkMode) {
          return checkPropertyAccessExpressionOrQualifiedName(node, node.left, checkNonNullExpression(node.left), node.right, checkMode);
        }
        function isMethodAccessForCall(node) {
          while (node.parent.kind === 208) {
            node = node.parent;
          }
          return ts3.isCallOrNewExpression(node.parent) && node.parent.expression === node;
        }
        function lookupSymbolForPrivateIdentifierDeclaration(propName, location) {
          for (var containingClass = ts3.getContainingClass(location); !!containingClass; containingClass = ts3.getContainingClass(containingClass)) {
            var symbol = containingClass.symbol;
            var name = ts3.getSymbolNameForPrivateIdentifier(symbol, propName);
            var prop = symbol.members && symbol.members.get(name) || symbol.exports && symbol.exports.get(name);
            if (prop) {
              return prop;
            }
          }
        }
        function getPrivateIdentifierPropertyOfType(leftType, lexicallyScopedIdentifier) {
          return getPropertyOfType(leftType, lexicallyScopedIdentifier.escapedName);
        }
        function checkPrivateIdentifierPropertyAccess(leftType, right, lexicallyScopedIdentifier) {
          var propertyOnType;
          var properties = getPropertiesOfType(leftType);
          if (properties) {
            ts3.forEach(properties, function(symbol) {
              var decl = symbol.valueDeclaration;
              if (decl && ts3.isNamedDeclaration(decl) && ts3.isPrivateIdentifier(decl.name) && decl.name.escapedText === right.escapedText) {
                propertyOnType = symbol;
                return true;
              }
            });
          }
          var diagName = diagnosticName(right);
          if (propertyOnType) {
            var typeValueDecl = ts3.Debug.checkDefined(propertyOnType.valueDeclaration);
            var typeClass_1 = ts3.Debug.checkDefined(ts3.getContainingClass(typeValueDecl));
            if (lexicallyScopedIdentifier === null || lexicallyScopedIdentifier === void 0 ? void 0 : lexicallyScopedIdentifier.valueDeclaration) {
              var lexicalValueDecl = lexicallyScopedIdentifier.valueDeclaration;
              var lexicalClass = ts3.getContainingClass(lexicalValueDecl);
              ts3.Debug.assert(!!lexicalClass);
              if (ts3.findAncestor(lexicalClass, function(n2) {
                return typeClass_1 === n2;
              })) {
                var diagnostic = error(right, ts3.Diagnostics.The_property_0_cannot_be_accessed_on_type_1_within_this_class_because_it_is_shadowed_by_another_private_identifier_with_the_same_spelling, diagName, typeToString(leftType));
                ts3.addRelatedInfo(diagnostic, ts3.createDiagnosticForNode(lexicalValueDecl, ts3.Diagnostics.The_shadowing_declaration_of_0_is_defined_here, diagName), ts3.createDiagnosticForNode(typeValueDecl, ts3.Diagnostics.The_declaration_of_0_that_you_probably_intended_to_use_is_defined_here, diagName));
                return true;
              }
            }
            error(right, ts3.Diagnostics.Property_0_is_not_accessible_outside_class_1_because_it_has_a_private_identifier, diagName, diagnosticName(typeClass_1.name || anon));
            return true;
          }
          return false;
        }
        function isThisPropertyAccessInConstructor(node, prop) {
          return (isConstructorDeclaredProperty(prop) || ts3.isThisProperty(node) && isAutoTypedProperty(prop)) && ts3.getThisContainer(node, true) === getDeclaringConstructor(prop);
        }
        function checkPropertyAccessExpressionOrQualifiedName(node, left, leftType, right, checkMode) {
          var parentSymbol = getNodeLinks(left).resolvedSymbol;
          var assignmentKind = ts3.getAssignmentTargetKind(node);
          var apparentType = getApparentType(assignmentKind !== 0 || isMethodAccessForCall(node) ? getWidenedType(leftType) : leftType);
          var isAnyLike = isTypeAny(apparentType) || apparentType === silentNeverType;
          var prop;
          if (ts3.isPrivateIdentifier(right)) {
            if (languageVersion < 99) {
              if (assignmentKind !== 0) {
                checkExternalEmitHelpers(node, 1048576);
              }
              if (assignmentKind !== 1) {
                checkExternalEmitHelpers(node, 524288);
              }
            }
            var lexicallyScopedSymbol = lookupSymbolForPrivateIdentifierDeclaration(right.escapedText, right);
            if (assignmentKind && lexicallyScopedSymbol && lexicallyScopedSymbol.valueDeclaration && ts3.isMethodDeclaration(lexicallyScopedSymbol.valueDeclaration)) {
              grammarErrorOnNode(right, ts3.Diagnostics.Cannot_assign_to_private_method_0_Private_methods_are_not_writable, ts3.idText(right));
            }
            if ((lexicallyScopedSymbol === null || lexicallyScopedSymbol === void 0 ? void 0 : lexicallyScopedSymbol.valueDeclaration) && (compilerOptions.target === 99 && !useDefineForClassFields)) {
              var lexicalClass_1 = ts3.getContainingClass(lexicallyScopedSymbol.valueDeclaration);
              var parentStaticFieldInitializer = ts3.findAncestor(node, function(n2) {
                if (n2 === lexicalClass_1)
                  return "quit";
                if (ts3.isPropertyDeclaration(n2.parent) && ts3.hasStaticModifier(n2.parent) && n2.parent.initializer === n2 && n2.parent.parent === lexicalClass_1) {
                  return true;
                }
                return false;
              });
              if (parentStaticFieldInitializer) {
                var parentStaticFieldInitializerSymbol = getSymbolOfNode(parentStaticFieldInitializer.parent);
                ts3.Debug.assert(parentStaticFieldInitializerSymbol, "Initializer without declaration symbol");
                var diagnostic = error(node, ts3.Diagnostics.Property_0_may_not_be_used_in_a_static_property_s_initializer_in_the_same_class_when_target_is_esnext_and_useDefineForClassFields_is_false, ts3.symbolName(lexicallyScopedSymbol));
                ts3.addRelatedInfo(diagnostic, ts3.createDiagnosticForNode(parentStaticFieldInitializer.parent, ts3.Diagnostics.Initializer_for_property_0, ts3.symbolName(parentStaticFieldInitializerSymbol)));
              }
            }
            if (isAnyLike) {
              if (lexicallyScopedSymbol) {
                return apparentType;
              }
              if (!ts3.getContainingClass(right)) {
                grammarErrorOnNode(right, ts3.Diagnostics.Private_identifiers_are_not_allowed_outside_class_bodies);
                return anyType;
              }
            }
            prop = lexicallyScopedSymbol ? getPrivateIdentifierPropertyOfType(leftType, lexicallyScopedSymbol) : void 0;
            if (!prop && checkPrivateIdentifierPropertyAccess(leftType, right, lexicallyScopedSymbol)) {
              return errorType;
            } else {
              var isSetonlyAccessor = prop && prop.flags & 65536 && !(prop.flags & 32768);
              if (isSetonlyAccessor && assignmentKind !== 1) {
                error(node, ts3.Diagnostics.Private_accessor_was_defined_without_a_getter);
              }
            }
          } else {
            if (isAnyLike) {
              if (ts3.isIdentifier(left) && parentSymbol) {
                markAliasReferenced(parentSymbol, node);
              }
              return apparentType;
            }
            prop = getPropertyOfType(apparentType, right.escapedText);
          }
          if (ts3.isIdentifier(left) && parentSymbol && (compilerOptions.isolatedModules || !(prop && isConstEnumOrConstEnumOnlyModule(prop)) || ts3.shouldPreserveConstEnums(compilerOptions) && isExportOrExportExpression(node))) {
            markAliasReferenced(parentSymbol, node);
          }
          var propType;
          if (!prop) {
            var indexInfo = !ts3.isPrivateIdentifier(right) && (assignmentKind === 0 || !isGenericObjectType(leftType) || isThisTypeParameter(leftType)) ? getIndexInfoOfType(apparentType, 0) : void 0;
            if (!(indexInfo && indexInfo.type)) {
              if (isJSLiteralType(leftType)) {
                return anyType;
              }
              if (leftType.symbol === globalThisSymbol) {
                if (globalThisSymbol.exports.has(right.escapedText) && globalThisSymbol.exports.get(right.escapedText).flags & 418) {
                  error(right, ts3.Diagnostics.Property_0_does_not_exist_on_type_1, ts3.unescapeLeadingUnderscores(right.escapedText), typeToString(leftType));
                } else if (noImplicitAny) {
                  error(right, ts3.Diagnostics.Element_implicitly_has_an_any_type_because_type_0_has_no_index_signature, typeToString(leftType));
                }
                return anyType;
              }
              if (right.escapedText && !checkAndReportErrorForExtendingInterface(node)) {
                reportNonexistentProperty(right, isThisTypeParameter(leftType) ? apparentType : leftType);
              }
              return errorType;
            }
            if (indexInfo.isReadonly && (ts3.isAssignmentTarget(node) || ts3.isDeleteTarget(node))) {
              error(node, ts3.Diagnostics.Index_signature_in_type_0_only_permits_reading, typeToString(apparentType));
            }
            propType = compilerOptions.noUncheckedIndexedAccess && !ts3.isAssignmentTarget(node) ? getUnionType([indexInfo.type, undefinedType]) : indexInfo.type;
            if (compilerOptions.noPropertyAccessFromIndexSignature && ts3.isPropertyAccessExpression(node)) {
              error(right, ts3.Diagnostics.Property_0_comes_from_an_index_signature_so_it_must_be_accessed_with_0, ts3.unescapeLeadingUnderscores(right.escapedText));
            }
          } else {
            if (prop.declarations && getDeclarationNodeFlagsFromSymbol(prop) & 134217728 && isUncalledFunctionReference(node, prop)) {
              addDeprecatedSuggestion(right, prop.declarations, right.escapedText);
            }
            checkPropertyNotUsedBeforeDeclaration(prop, node, right);
            markPropertyAsReferenced(prop, node, isSelfTypeAccess(left, parentSymbol));
            getNodeLinks(node).resolvedSymbol = prop;
            var writing = ts3.isWriteAccess(node);
            checkPropertyAccessibility(node, left.kind === 105, writing, apparentType, prop);
            if (isAssignmentToReadonlyEntity(node, prop, assignmentKind)) {
              error(right, ts3.Diagnostics.Cannot_assign_to_0_because_it_is_a_read_only_property, ts3.idText(right));
              return errorType;
            }
            propType = isThisPropertyAccessInConstructor(node, prop) ? autoType : writing ? getSetAccessorTypeOfSymbol(prop) : getTypeOfSymbol(prop);
          }
          return getFlowTypeOfAccessExpression(node, prop, propType, right, checkMode);
        }
        function getFlowTypeOfAccessExpression(node, prop, propType, errorNode, checkMode) {
          var assignmentKind = ts3.getAssignmentTargetKind(node);
          if (assignmentKind === 1 || prop && !(prop.flags & (3 | 4 | 98304)) && !(prop.flags & 8192 && propType.flags & 1048576) && !isDuplicatedCommonJSExport(prop.declarations)) {
            return propType;
          }
          if (propType === autoType) {
            return getFlowTypeOfProperty(node, prop);
          }
          propType = getNarrowableTypeForReference(propType, node, checkMode);
          var assumeUninitialized = false;
          if (strictNullChecks && strictPropertyInitialization && ts3.isAccessExpression(node) && node.expression.kind === 107) {
            var declaration = prop && prop.valueDeclaration;
            if (declaration && isInstancePropertyWithoutInitializer(declaration)) {
              var flowContainer = getControlFlowContainer(node);
              if (flowContainer.kind === 167 && flowContainer.parent === declaration.parent && !(declaration.flags & 8388608)) {
                assumeUninitialized = true;
              }
            }
          } else if (strictNullChecks && prop && prop.valueDeclaration && ts3.isPropertyAccessExpression(prop.valueDeclaration) && ts3.getAssignmentDeclarationPropertyAccessKind(prop.valueDeclaration) && getControlFlowContainer(node) === getControlFlowContainer(prop.valueDeclaration)) {
            assumeUninitialized = true;
          }
          var flowType = getFlowTypeOfReference(node, propType, assumeUninitialized ? getOptionalType(propType) : propType);
          if (assumeUninitialized && !(getFalsyFlags(propType) & 32768) && getFalsyFlags(flowType) & 32768) {
            error(errorNode, ts3.Diagnostics.Property_0_is_used_before_being_assigned, symbolToString(prop));
            return propType;
          }
          return assignmentKind ? getBaseTypeOfLiteralType(flowType) : flowType;
        }
        function checkPropertyNotUsedBeforeDeclaration(prop, node, right) {
          var valueDeclaration = prop.valueDeclaration;
          if (!valueDeclaration || ts3.getSourceFileOfNode(node).isDeclarationFile) {
            return;
          }
          var diagnosticMessage;
          var declarationName = ts3.idText(right);
          if (isInPropertyInitializer(node) && !isOptionalPropertyDeclaration(valueDeclaration) && !(ts3.isAccessExpression(node) && ts3.isAccessExpression(node.expression)) && !isBlockScopedNameDeclaredBeforeUse(valueDeclaration, right) && (compilerOptions.useDefineForClassFields || !isPropertyDeclaredInAncestorClass(prop))) {
            diagnosticMessage = error(right, ts3.Diagnostics.Property_0_is_used_before_its_initialization, declarationName);
          } else if (valueDeclaration.kind === 253 && node.parent.kind !== 174 && !(valueDeclaration.flags & 8388608) && !isBlockScopedNameDeclaredBeforeUse(valueDeclaration, right)) {
            diagnosticMessage = error(right, ts3.Diagnostics.Class_0_used_before_its_declaration, declarationName);
          }
          if (diagnosticMessage) {
            ts3.addRelatedInfo(diagnosticMessage, ts3.createDiagnosticForNode(valueDeclaration, ts3.Diagnostics._0_is_declared_here, declarationName));
          }
        }
        function isInPropertyInitializer(node) {
          return !!ts3.findAncestor(node, function(node2) {
            switch (node2.kind) {
              case 164:
                return true;
              case 289:
              case 166:
              case 168:
              case 169:
              case 291:
              case 159:
              case 229:
              case 284:
              case 281:
              case 282:
              case 283:
              case 276:
              case 224:
              case 287:
                return false;
              default:
                return ts3.isExpressionNode(node2) ? false : "quit";
            }
          });
        }
        function isPropertyDeclaredInAncestorClass(prop) {
          if (!(prop.parent.flags & 32)) {
            return false;
          }
          var classType = getTypeOfSymbol(prop.parent);
          while (true) {
            classType = classType.symbol && getSuperClass(classType);
            if (!classType) {
              return false;
            }
            var superProperty = getPropertyOfType(classType, prop.escapedName);
            if (superProperty && superProperty.valueDeclaration) {
              return true;
            }
          }
        }
        function getSuperClass(classType) {
          var x = getBaseTypes(classType);
          if (x.length === 0) {
            return void 0;
          }
          return getIntersectionType(x);
        }
        function reportNonexistentProperty(propNode, containingType) {
          var errorInfo;
          var relatedInfo;
          if (!ts3.isPrivateIdentifier(propNode) && containingType.flags & 1048576 && !(containingType.flags & 131068)) {
            for (var _i = 0, _a2 = containingType.types; _i < _a2.length; _i++) {
              var subtype = _a2[_i];
              if (!getPropertyOfType(subtype, propNode.escapedText) && !getIndexInfoOfType(subtype, 0)) {
                errorInfo = ts3.chainDiagnosticMessages(errorInfo, ts3.Diagnostics.Property_0_does_not_exist_on_type_1, ts3.declarationNameToString(propNode), typeToString(subtype));
                break;
              }
            }
          }
          if (typeHasStaticProperty(propNode.escapedText, containingType)) {
            var propName = ts3.declarationNameToString(propNode);
            var typeName = typeToString(containingType);
            errorInfo = ts3.chainDiagnosticMessages(errorInfo, ts3.Diagnostics.Property_0_does_not_exist_on_type_1_Did_you_mean_to_access_the_static_member_2_instead, propName, typeName, typeName + "." + propName);
          } else {
            var promisedType = getPromisedTypeOfPromise(containingType);
            if (promisedType && getPropertyOfType(promisedType, propNode.escapedText)) {
              errorInfo = ts3.chainDiagnosticMessages(errorInfo, ts3.Diagnostics.Property_0_does_not_exist_on_type_1, ts3.declarationNameToString(propNode), typeToString(containingType));
              relatedInfo = ts3.createDiagnosticForNode(propNode, ts3.Diagnostics.Did_you_forget_to_use_await);
            } else {
              var missingProperty = ts3.declarationNameToString(propNode);
              var container = typeToString(containingType);
              var libSuggestion = getSuggestedLibForNonExistentProperty(missingProperty, containingType);
              if (libSuggestion !== void 0) {
                errorInfo = ts3.chainDiagnosticMessages(errorInfo, ts3.Diagnostics.Property_0_does_not_exist_on_type_1_Do_you_need_to_change_your_target_library_Try_changing_the_lib_compiler_option_to_2_or_later, missingProperty, container, libSuggestion);
              } else {
                var suggestion = getSuggestedSymbolForNonexistentProperty(propNode, containingType);
                if (suggestion !== void 0) {
                  var suggestedName = ts3.symbolName(suggestion);
                  errorInfo = ts3.chainDiagnosticMessages(errorInfo, ts3.Diagnostics.Property_0_does_not_exist_on_type_1_Did_you_mean_2, missingProperty, container, suggestedName);
                  relatedInfo = suggestion.valueDeclaration && ts3.createDiagnosticForNode(suggestion.valueDeclaration, ts3.Diagnostics._0_is_declared_here, suggestedName);
                } else {
                  var diagnostic = containerSeemsToBeEmptyDomElement(containingType) ? ts3.Diagnostics.Property_0_does_not_exist_on_type_1_Try_changing_the_lib_compiler_option_to_include_dom : ts3.Diagnostics.Property_0_does_not_exist_on_type_1;
                  errorInfo = ts3.chainDiagnosticMessages(elaborateNeverIntersection(errorInfo, containingType), diagnostic, missingProperty, container);
                }
              }
            }
          }
          var resultDiagnostic = ts3.createDiagnosticForNodeFromMessageChain(propNode, errorInfo);
          if (relatedInfo) {
            ts3.addRelatedInfo(resultDiagnostic, relatedInfo);
          }
          diagnostics.add(resultDiagnostic);
        }
        function containerSeemsToBeEmptyDomElement(containingType) {
          return compilerOptions.lib && !compilerOptions.lib.includes("dom") && everyContainedType(containingType, function(type3) {
            return type3.symbol && /^(EventTarget|Node|((HTML[a-zA-Z]*)?Element))$/.test(ts3.unescapeLeadingUnderscores(type3.symbol.escapedName));
          }) && isEmptyObjectType(containingType);
        }
        function typeHasStaticProperty(propName, containingType) {
          var prop = containingType.symbol && getPropertyOfType(getTypeOfSymbol(containingType.symbol), propName);
          return prop !== void 0 && !!prop.valueDeclaration && ts3.hasSyntacticModifier(prop.valueDeclaration, 32);
        }
        function getSuggestedLibForNonExistentName(name) {
          var missingName = diagnosticName(name);
          var allFeatures = ts3.getScriptTargetFeatures();
          var libTargets = ts3.getOwnKeys(allFeatures);
          for (var _i = 0, libTargets_1 = libTargets; _i < libTargets_1.length; _i++) {
            var libTarget = libTargets_1[_i];
            var containingTypes = ts3.getOwnKeys(allFeatures[libTarget]);
            if (containingTypes !== void 0 && ts3.contains(containingTypes, missingName)) {
              return libTarget;
            }
          }
        }
        function getSuggestedLibForNonExistentProperty(missingProperty, containingType) {
          var container = getApparentType(containingType).symbol;
          if (!container) {
            return void 0;
          }
          var allFeatures = ts3.getScriptTargetFeatures();
          var libTargets = ts3.getOwnKeys(allFeatures);
          for (var _i = 0, libTargets_2 = libTargets; _i < libTargets_2.length; _i++) {
            var libTarget = libTargets_2[_i];
            var featuresOfLib = allFeatures[libTarget];
            var featuresOfContainingType = featuresOfLib[ts3.symbolName(container)];
            if (featuresOfContainingType !== void 0 && ts3.contains(featuresOfContainingType, missingProperty)) {
              return libTarget;
            }
          }
        }
        function getSuggestedSymbolForNonexistentProperty(name, containingType) {
          var props = getPropertiesOfType(containingType);
          if (typeof name !== "string") {
            var parent_2 = name.parent;
            if (ts3.isPropertyAccessExpression(parent_2)) {
              props = ts3.filter(props, function(prop) {
                return isValidPropertyAccessForCompletions(parent_2, containingType, prop);
              });
            }
            name = ts3.idText(name);
          }
          return getSpellingSuggestionForName(name, props, 111551);
        }
        function getSuggestedSymbolForNonexistentJSXAttribute(name, containingType) {
          var strName = ts3.isString(name) ? name : ts3.idText(name);
          var properties = getPropertiesOfType(containingType);
          var jsxSpecific = strName === "for" ? ts3.find(properties, function(x) {
            return ts3.symbolName(x) === "htmlFor";
          }) : strName === "class" ? ts3.find(properties, function(x) {
            return ts3.symbolName(x) === "className";
          }) : void 0;
          return jsxSpecific !== null && jsxSpecific !== void 0 ? jsxSpecific : getSpellingSuggestionForName(strName, properties, 111551);
        }
        function getSuggestionForNonexistentProperty(name, containingType) {
          var suggestion = getSuggestedSymbolForNonexistentProperty(name, containingType);
          return suggestion && ts3.symbolName(suggestion);
        }
        function getSuggestedSymbolForNonexistentSymbol(location, outerName, meaning) {
          ts3.Debug.assert(outerName !== void 0, "outername should always be defined");
          var result2 = resolveNameHelper(location, outerName, meaning, void 0, outerName, false, false, function(symbols, name, meaning2) {
            ts3.Debug.assertEqual(outerName, name, "name should equal outerName");
            var symbol = getSymbol(symbols, name, meaning2);
            return symbol || getSpellingSuggestionForName(ts3.unescapeLeadingUnderscores(name), ts3.arrayFrom(symbols.values()), meaning2);
          });
          return result2;
        }
        function getSuggestionForNonexistentSymbol(location, outerName, meaning) {
          var symbolResult = getSuggestedSymbolForNonexistentSymbol(location, outerName, meaning);
          return symbolResult && ts3.symbolName(symbolResult);
        }
        function getSuggestedSymbolForNonexistentModule(name, targetModule) {
          return targetModule.exports && getSpellingSuggestionForName(ts3.idText(name), getExportsOfModuleAsArray(targetModule), 2623475);
        }
        function getSuggestionForNonexistentExport(name, targetModule) {
          var suggestion = getSuggestedSymbolForNonexistentModule(name, targetModule);
          return suggestion && ts3.symbolName(suggestion);
        }
        function getSuggestionForNonexistentIndexSignature(objectType, expr, keyedType) {
          function hasProp(name) {
            var prop = getPropertyOfObjectType(objectType, name);
            if (prop) {
              var s2 = getSingleCallSignature(getTypeOfSymbol(prop));
              return !!s2 && getMinArgumentCount(s2) >= 1 && isTypeAssignableTo(keyedType, getTypeAtPosition(s2, 0));
            }
            return false;
          }
          ;
          var suggestedMethod = ts3.isAssignmentTarget(expr) ? "set" : "get";
          if (!hasProp(suggestedMethod)) {
            return void 0;
          }
          var suggestion = ts3.tryGetPropertyAccessOrIdentifierToString(expr.expression);
          if (suggestion === void 0) {
            suggestion = suggestedMethod;
          } else {
            suggestion += "." + suggestedMethod;
          }
          return suggestion;
        }
        function getSpellingSuggestionForName(name, symbols, meaning) {
          return ts3.getSpellingSuggestion(name, symbols, getCandidateName);
          function getCandidateName(candidate) {
            var candidateName = ts3.symbolName(candidate);
            if (ts3.startsWith(candidateName, '"')) {
              return void 0;
            }
            if (candidate.flags & meaning) {
              return candidateName;
            }
            if (candidate.flags & 2097152) {
              var alias = tryResolveAlias(candidate);
              if (alias && alias.flags & meaning) {
                return candidateName;
              }
            }
            return void 0;
          }
        }
        function markPropertyAsReferenced(prop, nodeForCheckWriteOnly, isSelfTypeAccess2) {
          var valueDeclaration = prop && prop.flags & 106500 && prop.valueDeclaration;
          if (!valueDeclaration) {
            return;
          }
          var hasPrivateModifier = ts3.hasEffectiveModifier(valueDeclaration, 8);
          var hasPrivateIdentifier = prop.valueDeclaration && ts3.isNamedDeclaration(prop.valueDeclaration) && ts3.isPrivateIdentifier(prop.valueDeclaration.name);
          if (!hasPrivateModifier && !hasPrivateIdentifier) {
            return;
          }
          if (nodeForCheckWriteOnly && ts3.isWriteOnlyAccess(nodeForCheckWriteOnly) && !(prop.flags & 65536)) {
            return;
          }
          if (isSelfTypeAccess2) {
            var containingMethod = ts3.findAncestor(nodeForCheckWriteOnly, ts3.isFunctionLikeDeclaration);
            if (containingMethod && containingMethod.symbol === prop) {
              return;
            }
          }
          (ts3.getCheckFlags(prop) & 1 ? getSymbolLinks(prop).target : prop).isReferenced = 67108863;
        }
        function isSelfTypeAccess(name, parent) {
          return name.kind === 107 || !!parent && ts3.isEntityNameExpression(name) && parent === getResolvedSymbol(ts3.getFirstIdentifier(name));
        }
        function isValidPropertyAccess(node, propertyName) {
          switch (node.kind) {
            case 202:
              return isValidPropertyAccessWithType(node, node.expression.kind === 105, propertyName, getWidenedType(checkExpression(node.expression)));
            case 158:
              return isValidPropertyAccessWithType(node, false, propertyName, getWidenedType(checkExpression(node.left)));
            case 196:
              return isValidPropertyAccessWithType(node, false, propertyName, getTypeFromTypeNode(node));
          }
        }
        function isValidPropertyAccessForCompletions(node, type3, property) {
          return isValidPropertyAccessWithType(node, node.kind === 202 && node.expression.kind === 105, property.escapedName, type3);
        }
        function isValidPropertyAccessWithType(node, isSuper, propertyName, type3) {
          if (type3 === errorType || isTypeAny(type3)) {
            return true;
          }
          var prop = getPropertyOfType(type3, propertyName);
          if (prop) {
            if (prop.valueDeclaration && ts3.isPrivateIdentifierClassElementDeclaration(prop.valueDeclaration)) {
              var declClass_1 = ts3.getContainingClass(prop.valueDeclaration);
              return !ts3.isOptionalChain(node) && !!ts3.findAncestor(node, function(parent) {
                return parent === declClass_1;
              });
            }
            return checkPropertyAccessibility(node, isSuper, false, type3, prop, false);
          }
          return ts3.isInJSFile(node) && (type3.flags & 1048576) !== 0 && type3.types.some(function(elementType) {
            return isValidPropertyAccessWithType(node, isSuper, propertyName, elementType);
          });
        }
        function getForInVariableSymbol(node) {
          var initializer = node.initializer;
          if (initializer.kind === 251) {
            var variable = initializer.declarations[0];
            if (variable && !ts3.isBindingPattern(variable.name)) {
              return getSymbolOfNode(variable);
            }
          } else if (initializer.kind === 78) {
            return getResolvedSymbol(initializer);
          }
          return void 0;
        }
        function hasNumericPropertyNames(type3) {
          return getIndexTypeOfType(type3, 1) && !getIndexTypeOfType(type3, 0);
        }
        function isForInVariableForNumericPropertyNames(expr) {
          var e2 = ts3.skipParentheses(expr);
          if (e2.kind === 78) {
            var symbol = getResolvedSymbol(e2);
            if (symbol.flags & 3) {
              var child = expr;
              var node = expr.parent;
              while (node) {
                if (node.kind === 239 && child === node.statement && getForInVariableSymbol(node) === symbol && hasNumericPropertyNames(getTypeOfExpression(node.expression))) {
                  return true;
                }
                child = node;
                node = node.parent;
              }
            }
          }
          return false;
        }
        function checkIndexedAccess(node, checkMode) {
          return node.flags & 32 ? checkElementAccessChain(node, checkMode) : checkElementAccessExpression(node, checkNonNullExpression(node.expression), checkMode);
        }
        function checkElementAccessChain(node, checkMode) {
          var exprType = checkExpression(node.expression);
          var nonOptionalType = getOptionalExpressionType(exprType, node.expression);
          return propagateOptionalTypeMarker(checkElementAccessExpression(node, checkNonNullType(nonOptionalType, node.expression), checkMode), node, nonOptionalType !== exprType);
        }
        function checkElementAccessExpression(node, exprType, checkMode) {
          var objectType = ts3.getAssignmentTargetKind(node) !== 0 || isMethodAccessForCall(node) ? getWidenedType(exprType) : exprType;
          var indexExpression = node.argumentExpression;
          var indexType = checkExpression(indexExpression);
          if (objectType === errorType || objectType === silentNeverType) {
            return objectType;
          }
          if (isConstEnumObjectType(objectType) && !ts3.isStringLiteralLike(indexExpression)) {
            error(indexExpression, ts3.Diagnostics.A_const_enum_member_can_only_be_accessed_using_a_string_literal);
            return errorType;
          }
          var effectiveIndexType = isForInVariableForNumericPropertyNames(indexExpression) ? numberType : indexType;
          var accessFlags = ts3.isAssignmentTarget(node) ? 2 | (isGenericObjectType(objectType) && !isThisTypeParameter(objectType) ? 1 : 0) : 0;
          var indexedAccessType = getIndexedAccessTypeOrUndefined(objectType, effectiveIndexType, void 0, node, accessFlags | 16) || errorType;
          return checkIndexedAccessIndexType(getFlowTypeOfAccessExpression(node, getNodeLinks(node).resolvedSymbol, indexedAccessType, indexExpression, checkMode), node);
        }
        function callLikeExpressionMayHaveTypeArguments(node) {
          return ts3.isCallOrNewExpression(node) || ts3.isTaggedTemplateExpression(node) || ts3.isJsxOpeningLikeElement(node);
        }
        function resolveUntypedCall(node) {
          if (callLikeExpressionMayHaveTypeArguments(node)) {
            ts3.forEach(node.typeArguments, checkSourceElement);
          }
          if (node.kind === 206) {
            checkExpression(node.template);
          } else if (ts3.isJsxOpeningLikeElement(node)) {
            checkExpression(node.attributes);
          } else if (node.kind !== 162) {
            ts3.forEach(node.arguments, function(argument) {
              checkExpression(argument);
            });
          }
          return anySignature;
        }
        function resolveErrorCall(node) {
          resolveUntypedCall(node);
          return unknownSignature;
        }
        function reorderCandidates(signatures, result2, callChainFlags) {
          var lastParent;
          var lastSymbol;
          var cutoffIndex = 0;
          var index;
          var specializedIndex = -1;
          var spliceIndex;
          ts3.Debug.assert(!result2.length);
          for (var _i = 0, signatures_7 = signatures; _i < signatures_7.length; _i++) {
            var signature = signatures_7[_i];
            var symbol = signature.declaration && getSymbolOfNode(signature.declaration);
            var parent = signature.declaration && signature.declaration.parent;
            if (!lastSymbol || symbol === lastSymbol) {
              if (lastParent && parent === lastParent) {
                index = index + 1;
              } else {
                lastParent = parent;
                index = cutoffIndex;
              }
            } else {
              index = cutoffIndex = result2.length;
              lastParent = parent;
            }
            lastSymbol = symbol;
            if (signatureHasLiteralTypes(signature)) {
              specializedIndex++;
              spliceIndex = specializedIndex;
              cutoffIndex++;
            } else {
              spliceIndex = index;
            }
            result2.splice(spliceIndex, 0, callChainFlags ? getOptionalCallSignature(signature, callChainFlags) : signature);
          }
        }
        function isSpreadArgument(arg2) {
          return !!arg2 && (arg2.kind === 221 || arg2.kind === 228 && arg2.isSpread);
        }
        function getSpreadArgumentIndex(args) {
          return ts3.findIndex(args, isSpreadArgument);
        }
        function acceptsVoid(t2) {
          return !!(t2.flags & 16384);
        }
        function acceptsVoidUndefinedUnknownOrAny(t2) {
          return !!(t2.flags & (16384 | 32768 | 2 | 1));
        }
        function hasCorrectArity(node, args, signature, signatureHelpTrailingComma) {
          if (signatureHelpTrailingComma === void 0) {
            signatureHelpTrailingComma = false;
          }
          var argCount;
          var callIsIncomplete = false;
          var effectiveParameterCount = getParameterCount(signature);
          var effectiveMinimumArguments = getMinArgumentCount(signature);
          if (node.kind === 206) {
            argCount = args.length;
            if (node.template.kind === 219) {
              var lastSpan = ts3.last(node.template.templateSpans);
              callIsIncomplete = ts3.nodeIsMissing(lastSpan.literal) || !!lastSpan.literal.isUnterminated;
            } else {
              var templateLiteral = node.template;
              ts3.Debug.assert(templateLiteral.kind === 14);
              callIsIncomplete = !!templateLiteral.isUnterminated;
            }
          } else if (node.kind === 162) {
            argCount = getDecoratorArgumentCount(node, signature);
          } else if (ts3.isJsxOpeningLikeElement(node)) {
            callIsIncomplete = node.attributes.end === node.end;
            if (callIsIncomplete) {
              return true;
            }
            argCount = effectiveMinimumArguments === 0 ? args.length : 1;
            effectiveParameterCount = args.length === 0 ? effectiveParameterCount : 1;
            effectiveMinimumArguments = Math.min(effectiveMinimumArguments, 1);
          } else if (!node.arguments) {
            ts3.Debug.assert(node.kind === 205);
            return getMinArgumentCount(signature) === 0;
          } else {
            argCount = signatureHelpTrailingComma ? args.length + 1 : args.length;
            callIsIncomplete = node.arguments.end === node.end;
            var spreadArgIndex = getSpreadArgumentIndex(args);
            if (spreadArgIndex >= 0) {
              return spreadArgIndex >= getMinArgumentCount(signature) && (hasEffectiveRestParameter(signature) || spreadArgIndex < getParameterCount(signature));
            }
          }
          if (!hasEffectiveRestParameter(signature) && argCount > effectiveParameterCount) {
            return false;
          }
          if (callIsIncomplete || argCount >= effectiveMinimumArguments) {
            return true;
          }
          for (var i3 = argCount; i3 < effectiveMinimumArguments; i3++) {
            var type3 = getTypeAtPosition(signature, i3);
            if (filterType(type3, ts3.isInJSFile(node) && !strictNullChecks ? acceptsVoidUndefinedUnknownOrAny : acceptsVoid).flags & 131072) {
              return false;
            }
          }
          return true;
        }
        function hasCorrectTypeArgumentArity(signature, typeArguments) {
          var numTypeParameters = ts3.length(signature.typeParameters);
          var minTypeArgumentCount = getMinTypeArgumentCount(signature.typeParameters);
          return !ts3.some(typeArguments) || typeArguments.length >= minTypeArgumentCount && typeArguments.length <= numTypeParameters;
        }
        function getSingleCallSignature(type3) {
          return getSingleSignature(type3, 0, false);
        }
        function getSingleCallOrConstructSignature(type3) {
          return getSingleSignature(type3, 0, false) || getSingleSignature(type3, 1, false);
        }
        function getSingleSignature(type3, kind, allowMembers) {
          if (type3.flags & 524288) {
            var resolved = resolveStructuredTypeMembers(type3);
            if (allowMembers || resolved.properties.length === 0 && !resolved.stringIndexInfo && !resolved.numberIndexInfo) {
              if (kind === 0 && resolved.callSignatures.length === 1 && resolved.constructSignatures.length === 0) {
                return resolved.callSignatures[0];
              }
              if (kind === 1 && resolved.constructSignatures.length === 1 && resolved.callSignatures.length === 0) {
                return resolved.constructSignatures[0];
              }
            }
          }
          return void 0;
        }
        function instantiateSignatureInContextOf(signature, contextualSignature, inferenceContext, compareTypes) {
          var context = createInferenceContext(signature.typeParameters, signature, 0, compareTypes);
          var restType = getEffectiveRestType(contextualSignature);
          var mapper = inferenceContext && (restType && restType.flags & 262144 ? inferenceContext.nonFixingMapper : inferenceContext.mapper);
          var sourceSignature = mapper ? instantiateSignature(contextualSignature, mapper) : contextualSignature;
          applyToParameterTypes(sourceSignature, signature, function(source, target) {
            inferTypes(context.inferences, source, target);
          });
          if (!inferenceContext) {
            applyToReturnTypes(contextualSignature, signature, function(source, target) {
              inferTypes(context.inferences, source, target, 128);
            });
          }
          return getSignatureInstantiation(signature, getInferredTypes(context), ts3.isInJSFile(contextualSignature.declaration));
        }
        function inferJsxTypeArguments(node, signature, checkMode, context) {
          var paramType = getEffectiveFirstArgumentForJsxSignature(signature, node);
          var checkAttrType = checkExpressionWithContextualType(node.attributes, paramType, context, checkMode);
          inferTypes(context.inferences, checkAttrType, paramType);
          return getInferredTypes(context);
        }
        function getThisArgumentType(thisArgumentNode) {
          if (!thisArgumentNode) {
            return voidType;
          }
          var thisArgumentType = checkExpression(thisArgumentNode);
          return ts3.isOptionalChainRoot(thisArgumentNode.parent) ? getNonNullableType(thisArgumentType) : ts3.isOptionalChain(thisArgumentNode.parent) ? removeOptionalTypeMarker(thisArgumentType) : thisArgumentType;
        }
        function inferTypeArguments(node, signature, args, checkMode, context) {
          if (ts3.isJsxOpeningLikeElement(node)) {
            return inferJsxTypeArguments(node, signature, checkMode, context);
          }
          if (node.kind !== 162) {
            var contextualType = getContextualType(node, ts3.every(signature.typeParameters, function(p) {
              return !!getDefaultFromTypeParameter(p);
            }) ? 8 : 0);
            if (contextualType) {
              var outerContext = getInferenceContext(node);
              var outerMapper = getMapperFromContext(cloneInferenceContext(outerContext, 1));
              var instantiatedType = instantiateType(contextualType, outerMapper);
              var contextualSignature = getSingleCallSignature(instantiatedType);
              var inferenceSourceType = contextualSignature && contextualSignature.typeParameters ? getOrCreateTypeFromSignature(getSignatureInstantiationWithoutFillingInTypeArguments(contextualSignature, contextualSignature.typeParameters)) : instantiatedType;
              var inferenceTargetType = getReturnTypeOfSignature(signature);
              inferTypes(context.inferences, inferenceSourceType, inferenceTargetType, 128);
              var returnContext = createInferenceContext(signature.typeParameters, signature, context.flags);
              var returnSourceType = instantiateType(contextualType, outerContext && outerContext.returnMapper);
              inferTypes(returnContext.inferences, returnSourceType, inferenceTargetType);
              context.returnMapper = ts3.some(returnContext.inferences, hasInferenceCandidates) ? getMapperFromContext(cloneInferredPartOfContext(returnContext)) : void 0;
            }
          }
          var restType = getNonArrayRestType(signature);
          var argCount = restType ? Math.min(getParameterCount(signature) - 1, args.length) : args.length;
          if (restType && restType.flags & 262144) {
            var info = ts3.find(context.inferences, function(info2) {
              return info2.typeParameter === restType;
            });
            if (info) {
              info.impliedArity = ts3.findIndex(args, isSpreadArgument, argCount) < 0 ? args.length - argCount : void 0;
            }
          }
          var thisType = getThisTypeOfSignature(signature);
          if (thisType) {
            var thisArgumentNode = getThisArgumentOfCall(node);
            inferTypes(context.inferences, getThisArgumentType(thisArgumentNode), thisType);
          }
          for (var i3 = 0; i3 < argCount; i3++) {
            var arg2 = args[i3];
            if (arg2.kind !== 223) {
              var paramType = getTypeAtPosition(signature, i3);
              var argType = checkExpressionWithContextualType(arg2, paramType, context, checkMode);
              inferTypes(context.inferences, argType, paramType);
            }
          }
          if (restType) {
            var spreadType = getSpreadArgumentType(args, argCount, args.length, restType, context, checkMode);
            inferTypes(context.inferences, spreadType, restType);
          }
          return getInferredTypes(context);
        }
        function getMutableArrayOrTupleType(type3) {
          return type3.flags & 1048576 ? mapType(type3, getMutableArrayOrTupleType) : type3.flags & 1 || isMutableArrayOrTuple(getBaseConstraintOfType(type3) || type3) ? type3 : isTupleType(type3) ? createTupleType(getTypeArguments(type3), type3.target.elementFlags, false, type3.target.labeledElementDeclarations) : createTupleType([type3], [8]);
        }
        function getSpreadArgumentType(args, index, argCount, restType, context, checkMode) {
          if (index >= argCount - 1) {
            var arg2 = args[argCount - 1];
            if (isSpreadArgument(arg2)) {
              return getMutableArrayOrTupleType(arg2.kind === 228 ? arg2.type : checkExpressionWithContextualType(arg2.expression, restType, context, checkMode));
            }
          }
          var types2 = [];
          var flags = [];
          var names = [];
          for (var i3 = index; i3 < argCount; i3++) {
            var arg2 = args[i3];
            if (isSpreadArgument(arg2)) {
              var spreadType = arg2.kind === 228 ? arg2.type : checkExpression(arg2.expression);
              if (isArrayLikeType(spreadType)) {
                types2.push(spreadType);
                flags.push(8);
              } else {
                types2.push(checkIteratedTypeOrElementType(33, spreadType, undefinedType, arg2.kind === 221 ? arg2.expression : arg2));
                flags.push(4);
              }
            } else {
              var contextualType = getIndexedAccessType(restType, getLiteralType(i3 - index));
              var argType = checkExpressionWithContextualType(arg2, contextualType, context, checkMode);
              var hasPrimitiveContextualType = maybeTypeOfKind(contextualType, 131068 | 4194304 | 134217728 | 268435456);
              types2.push(hasPrimitiveContextualType ? getRegularTypeOfLiteralType(argType) : getWidenedLiteralType(argType));
              flags.push(1);
            }
            if (arg2.kind === 228 && arg2.tupleNameSource) {
              names.push(arg2.tupleNameSource);
            }
          }
          return createTupleType(types2, flags, false, ts3.length(names) === ts3.length(types2) ? names : void 0);
        }
        function checkTypeArguments(signature, typeArgumentNodes, reportErrors, headMessage) {
          var isJavascript = ts3.isInJSFile(signature.declaration);
          var typeParameters = signature.typeParameters;
          var typeArgumentTypes = fillMissingTypeArguments(ts3.map(typeArgumentNodes, getTypeFromTypeNode), typeParameters, getMinTypeArgumentCount(typeParameters), isJavascript);
          var mapper;
          for (var i3 = 0; i3 < typeArgumentNodes.length; i3++) {
            ts3.Debug.assert(typeParameters[i3] !== void 0, "Should not call checkTypeArguments with too many type arguments");
            var constraint = getConstraintOfTypeParameter(typeParameters[i3]);
            if (constraint) {
              var errorInfo = reportErrors && headMessage ? function() {
                return ts3.chainDiagnosticMessages(void 0, ts3.Diagnostics.Type_0_does_not_satisfy_the_constraint_1);
              } : void 0;
              var typeArgumentHeadMessage = headMessage || ts3.Diagnostics.Type_0_does_not_satisfy_the_constraint_1;
              if (!mapper) {
                mapper = createTypeMapper(typeParameters, typeArgumentTypes);
              }
              var typeArgument = typeArgumentTypes[i3];
              if (!checkTypeAssignableTo(typeArgument, getTypeWithThisArgument(instantiateType(constraint, mapper), typeArgument), reportErrors ? typeArgumentNodes[i3] : void 0, typeArgumentHeadMessage, errorInfo)) {
                return void 0;
              }
            }
          }
          return typeArgumentTypes;
        }
        function getJsxReferenceKind(node) {
          if (isJsxIntrinsicIdentifier(node.tagName)) {
            return 2;
          }
          var tagType = getApparentType(checkExpression(node.tagName));
          if (ts3.length(getSignaturesOfType(tagType, 1))) {
            return 0;
          }
          if (ts3.length(getSignaturesOfType(tagType, 0))) {
            return 1;
          }
          return 2;
        }
        function checkApplicableSignatureForJsxOpeningLikeElement(node, signature, relation, checkMode, reportErrors, containingMessageChain, errorOutputContainer) {
          var paramType = getEffectiveFirstArgumentForJsxSignature(signature, node);
          var attributesType = checkExpressionWithContextualType(node.attributes, paramType, void 0, checkMode);
          return checkTagNameDoesNotExpectTooManyArguments() && checkTypeRelatedToAndOptionallyElaborate(attributesType, paramType, relation, reportErrors ? node.tagName : void 0, node.attributes, void 0, containingMessageChain, errorOutputContainer);
          function checkTagNameDoesNotExpectTooManyArguments() {
            var _a2;
            if (getJsxNamespaceContainerForImplicitImport(node)) {
              return true;
            }
            var tagType = ts3.isJsxOpeningElement(node) || ts3.isJsxSelfClosingElement(node) && !isJsxIntrinsicIdentifier(node.tagName) ? checkExpression(node.tagName) : void 0;
            if (!tagType) {
              return true;
            }
            var tagCallSignatures = getSignaturesOfType(tagType, 0);
            if (!ts3.length(tagCallSignatures)) {
              return true;
            }
            var factory = getJsxFactoryEntity(node);
            if (!factory) {
              return true;
            }
            var factorySymbol = resolveEntityName(factory, 111551, true, false, node);
            if (!factorySymbol) {
              return true;
            }
            var factoryType = getTypeOfSymbol(factorySymbol);
            var callSignatures = getSignaturesOfType(factoryType, 0);
            if (!ts3.length(callSignatures)) {
              return true;
            }
            var hasFirstParamSignatures = false;
            var maxParamCount = 0;
            for (var _i = 0, callSignatures_1 = callSignatures; _i < callSignatures_1.length; _i++) {
              var sig = callSignatures_1[_i];
              var firstparam = getTypeAtPosition(sig, 0);
              var signaturesOfParam = getSignaturesOfType(firstparam, 0);
              if (!ts3.length(signaturesOfParam))
                continue;
              for (var _b = 0, signaturesOfParam_1 = signaturesOfParam; _b < signaturesOfParam_1.length; _b++) {
                var paramSig = signaturesOfParam_1[_b];
                hasFirstParamSignatures = true;
                if (hasEffectiveRestParameter(paramSig)) {
                  return true;
                }
                var paramCount = getParameterCount(paramSig);
                if (paramCount > maxParamCount) {
                  maxParamCount = paramCount;
                }
              }
            }
            if (!hasFirstParamSignatures) {
              return true;
            }
            var absoluteMinArgCount = Infinity;
            for (var _c = 0, tagCallSignatures_1 = tagCallSignatures; _c < tagCallSignatures_1.length; _c++) {
              var tagSig = tagCallSignatures_1[_c];
              var tagRequiredArgCount = getMinArgumentCount(tagSig);
              if (tagRequiredArgCount < absoluteMinArgCount) {
                absoluteMinArgCount = tagRequiredArgCount;
              }
            }
            if (absoluteMinArgCount <= maxParamCount) {
              return true;
            }
            if (reportErrors) {
              var diag = ts3.createDiagnosticForNode(node.tagName, ts3.Diagnostics.Tag_0_expects_at_least_1_arguments_but_the_JSX_factory_2_provides_at_most_3, ts3.entityNameToString(node.tagName), absoluteMinArgCount, ts3.entityNameToString(factory), maxParamCount);
              var tagNameDeclaration = (_a2 = getSymbolAtLocation(node.tagName)) === null || _a2 === void 0 ? void 0 : _a2.valueDeclaration;
              if (tagNameDeclaration) {
                ts3.addRelatedInfo(diag, ts3.createDiagnosticForNode(tagNameDeclaration, ts3.Diagnostics._0_is_declared_here, ts3.entityNameToString(node.tagName)));
              }
              if (errorOutputContainer && errorOutputContainer.skipLogging) {
                (errorOutputContainer.errors || (errorOutputContainer.errors = [])).push(diag);
              }
              if (!errorOutputContainer.skipLogging) {
                diagnostics.add(diag);
              }
            }
            return false;
          }
        }
        function getSignatureApplicabilityError(node, args, signature, relation, checkMode, reportErrors, containingMessageChain) {
          var errorOutputContainer = { errors: void 0, skipLogging: true };
          if (ts3.isJsxOpeningLikeElement(node)) {
            if (!checkApplicableSignatureForJsxOpeningLikeElement(node, signature, relation, checkMode, reportErrors, containingMessageChain, errorOutputContainer)) {
              ts3.Debug.assert(!reportErrors || !!errorOutputContainer.errors, "jsx should have errors when reporting errors");
              return errorOutputContainer.errors || ts3.emptyArray;
            }
            return void 0;
          }
          var thisType = getThisTypeOfSignature(signature);
          if (thisType && thisType !== voidType && node.kind !== 205) {
            var thisArgumentNode = getThisArgumentOfCall(node);
            var thisArgumentType = getThisArgumentType(thisArgumentNode);
            var errorNode = reportErrors ? thisArgumentNode || node : void 0;
            var headMessage_1 = ts3.Diagnostics.The_this_context_of_type_0_is_not_assignable_to_method_s_this_of_type_1;
            if (!checkTypeRelatedTo(thisArgumentType, thisType, relation, errorNode, headMessage_1, containingMessageChain, errorOutputContainer)) {
              ts3.Debug.assert(!reportErrors || !!errorOutputContainer.errors, "this parameter should have errors when reporting errors");
              return errorOutputContainer.errors || ts3.emptyArray;
            }
          }
          var headMessage = ts3.Diagnostics.Argument_of_type_0_is_not_assignable_to_parameter_of_type_1;
          var restType = getNonArrayRestType(signature);
          var argCount = restType ? Math.min(getParameterCount(signature) - 1, args.length) : args.length;
          for (var i3 = 0; i3 < argCount; i3++) {
            var arg2 = args[i3];
            if (arg2.kind !== 223) {
              var paramType = getTypeAtPosition(signature, i3);
              var argType = checkExpressionWithContextualType(arg2, paramType, void 0, checkMode);
              var checkArgType = checkMode & 4 ? getRegularTypeOfObjectLiteral(argType) : argType;
              if (!checkTypeRelatedToAndOptionallyElaborate(checkArgType, paramType, relation, reportErrors ? arg2 : void 0, arg2, headMessage, containingMessageChain, errorOutputContainer)) {
                ts3.Debug.assert(!reportErrors || !!errorOutputContainer.errors, "parameter should have errors when reporting errors");
                maybeAddMissingAwaitInfo(arg2, checkArgType, paramType);
                return errorOutputContainer.errors || ts3.emptyArray;
              }
            }
          }
          if (restType) {
            var spreadType = getSpreadArgumentType(args, argCount, args.length, restType, void 0, checkMode);
            var restArgCount = args.length - argCount;
            var errorNode = !reportErrors ? void 0 : restArgCount === 0 ? node : restArgCount === 1 ? args[argCount] : ts3.setTextRangePosEnd(createSyntheticExpression(node, spreadType), args[argCount].pos, args[args.length - 1].end);
            if (!checkTypeRelatedTo(spreadType, restType, relation, errorNode, headMessage, void 0, errorOutputContainer)) {
              ts3.Debug.assert(!reportErrors || !!errorOutputContainer.errors, "rest parameter should have errors when reporting errors");
              maybeAddMissingAwaitInfo(errorNode, spreadType, restType);
              return errorOutputContainer.errors || ts3.emptyArray;
            }
          }
          return void 0;
          function maybeAddMissingAwaitInfo(errorNode2, source, target) {
            if (errorNode2 && reportErrors && errorOutputContainer.errors && errorOutputContainer.errors.length) {
              if (getAwaitedTypeOfPromise(target)) {
                return;
              }
              var awaitedTypeOfSource = getAwaitedTypeOfPromise(source);
              if (awaitedTypeOfSource && isTypeRelatedTo(awaitedTypeOfSource, target, relation)) {
                ts3.addRelatedInfo(errorOutputContainer.errors[0], ts3.createDiagnosticForNode(errorNode2, ts3.Diagnostics.Did_you_forget_to_use_await));
              }
            }
          }
        }
        function getThisArgumentOfCall(node) {
          if (node.kind === 204) {
            var callee = ts3.skipOuterExpressions(node.expression);
            if (ts3.isAccessExpression(callee)) {
              return callee.expression;
            }
          }
        }
        function createSyntheticExpression(parent, type3, isSpread, tupleNameSource) {
          var result2 = ts3.parseNodeFactory.createSyntheticExpression(type3, isSpread, tupleNameSource);
          ts3.setTextRange(result2, parent);
          ts3.setParent(result2, parent);
          return result2;
        }
        function getEffectiveCallArguments(node) {
          if (node.kind === 206) {
            var template = node.template;
            var args_3 = [createSyntheticExpression(template, getGlobalTemplateStringsArrayType())];
            if (template.kind === 219) {
              ts3.forEach(template.templateSpans, function(span) {
                args_3.push(span.expression);
              });
            }
            return args_3;
          }
          if (node.kind === 162) {
            return getEffectiveDecoratorArguments(node);
          }
          if (ts3.isJsxOpeningLikeElement(node)) {
            return node.attributes.properties.length > 0 || ts3.isJsxOpeningElement(node) && node.parent.children.length > 0 ? [node.attributes] : ts3.emptyArray;
          }
          var args = node.arguments || ts3.emptyArray;
          var spreadIndex = getSpreadArgumentIndex(args);
          if (spreadIndex >= 0) {
            var effectiveArgs_1 = args.slice(0, spreadIndex);
            var _loop_21 = function(i4) {
              var arg2 = args[i4];
              var spreadType = arg2.kind === 221 && (flowLoopCount ? checkExpression(arg2.expression) : checkExpressionCached(arg2.expression));
              if (spreadType && isTupleType(spreadType)) {
                ts3.forEach(getTypeArguments(spreadType), function(t2, i5) {
                  var _a2;
                  var flags = spreadType.target.elementFlags[i5];
                  var syntheticArg = createSyntheticExpression(arg2, flags & 4 ? createArrayType(t2) : t2, !!(flags & 12), (_a2 = spreadType.target.labeledElementDeclarations) === null || _a2 === void 0 ? void 0 : _a2[i5]);
                  effectiveArgs_1.push(syntheticArg);
                });
              } else {
                effectiveArgs_1.push(arg2);
              }
            };
            for (var i3 = spreadIndex; i3 < args.length; i3++) {
              _loop_21(i3);
            }
            return effectiveArgs_1;
          }
          return args;
        }
        function getEffectiveDecoratorArguments(node) {
          var parent = node.parent;
          var expr = node.expression;
          switch (parent.kind) {
            case 253:
            case 222:
              return [
                createSyntheticExpression(expr, getTypeOfSymbol(getSymbolOfNode(parent)))
              ];
            case 161:
              var func2 = parent.parent;
              return [
                createSyntheticExpression(expr, parent.parent.kind === 167 ? getTypeOfSymbol(getSymbolOfNode(func2)) : errorType),
                createSyntheticExpression(expr, anyType),
                createSyntheticExpression(expr, numberType)
              ];
            case 164:
            case 166:
            case 168:
            case 169:
              var hasPropDesc = parent.kind !== 164 && languageVersion !== 0;
              return [
                createSyntheticExpression(expr, getParentTypeOfClassElement(parent)),
                createSyntheticExpression(expr, getClassElementPropertyKeyType(parent)),
                createSyntheticExpression(expr, hasPropDesc ? createTypedPropertyDescriptorType(getTypeOfNode(parent)) : anyType)
              ];
          }
          return ts3.Debug.fail();
        }
        function getDecoratorArgumentCount(node, signature) {
          switch (node.parent.kind) {
            case 253:
            case 222:
              return 1;
            case 164:
              return 2;
            case 166:
            case 168:
            case 169:
              return languageVersion === 0 || signature.parameters.length <= 2 ? 2 : 3;
            case 161:
              return 3;
            default:
              return ts3.Debug.fail();
          }
        }
        function getDiagnosticSpanForCallNode(node, doNotIncludeArguments) {
          var start;
          var length;
          var sourceFile = ts3.getSourceFileOfNode(node);
          if (ts3.isPropertyAccessExpression(node.expression)) {
            var nameSpan = ts3.getErrorSpanForNode(sourceFile, node.expression.name);
            start = nameSpan.start;
            length = doNotIncludeArguments ? nameSpan.length : node.end - start;
          } else {
            var expressionSpan = ts3.getErrorSpanForNode(sourceFile, node.expression);
            start = expressionSpan.start;
            length = doNotIncludeArguments ? expressionSpan.length : node.end - start;
          }
          return { start, length, sourceFile };
        }
        function getDiagnosticForCallNode(node, message, arg0, arg1, arg2, arg3) {
          if (ts3.isCallExpression(node)) {
            var _a2 = getDiagnosticSpanForCallNode(node), sourceFile = _a2.sourceFile, start = _a2.start, length_6 = _a2.length;
            return ts3.createFileDiagnostic(sourceFile, start, length_6, message, arg0, arg1, arg2, arg3);
          } else {
            return ts3.createDiagnosticForNode(node, message, arg0, arg1, arg2, arg3);
          }
        }
        function isPromiseResolveArityError(node) {
          if (!ts3.isCallExpression(node) || !ts3.isIdentifier(node.expression))
            return false;
          var symbol = resolveName(node.expression, node.expression.escapedText, 111551, void 0, void 0, false);
          var decl = symbol === null || symbol === void 0 ? void 0 : symbol.valueDeclaration;
          if (!decl || !ts3.isParameter(decl) || !isFunctionExpressionOrArrowFunction(decl.parent) || !ts3.isNewExpression(decl.parent.parent) || !ts3.isIdentifier(decl.parent.parent.expression)) {
            return false;
          }
          var globalPromiseSymbol = getGlobalPromiseConstructorSymbol(false);
          if (!globalPromiseSymbol)
            return false;
          var constructorSymbol = getSymbolAtLocation(decl.parent.parent.expression, true);
          return constructorSymbol === globalPromiseSymbol;
        }
        function getArgumentArityError(node, signatures, args) {
          var _a2;
          var spreadIndex = getSpreadArgumentIndex(args);
          if (spreadIndex > -1) {
            return ts3.createDiagnosticForNode(args[spreadIndex], ts3.Diagnostics.A_spread_argument_must_either_have_a_tuple_type_or_be_passed_to_a_rest_parameter);
          }
          var min = Number.POSITIVE_INFINITY;
          var max = Number.NEGATIVE_INFINITY;
          var maxBelow = Number.NEGATIVE_INFINITY;
          var minAbove = Number.POSITIVE_INFINITY;
          var closestSignature;
          for (var _i = 0, signatures_8 = signatures; _i < signatures_8.length; _i++) {
            var sig = signatures_8[_i];
            var minParameter = getMinArgumentCount(sig);
            var maxParameter = getParameterCount(sig);
            if (minParameter < min) {
              min = minParameter;
              closestSignature = sig;
            }
            max = Math.max(max, maxParameter);
            if (minParameter < args.length && minParameter > maxBelow)
              maxBelow = minParameter;
            if (args.length < maxParameter && maxParameter < minAbove)
              minAbove = maxParameter;
          }
          var hasRestParameter = ts3.some(signatures, hasEffectiveRestParameter);
          var parameterRange = hasRestParameter ? min : min < max ? min + "-" + max : min;
          var error2 = hasRestParameter ? ts3.Diagnostics.Expected_at_least_0_arguments_but_got_1 : parameterRange === 1 && args.length === 0 && isPromiseResolveArityError(node) ? ts3.Diagnostics.Expected_0_arguments_but_got_1_Did_you_forget_to_include_void_in_your_type_argument_to_Promise : ts3.Diagnostics.Expected_0_arguments_but_got_1;
          if (min < args.length && args.length < max) {
            return getDiagnosticForCallNode(node, ts3.Diagnostics.No_overload_expects_0_arguments_but_overloads_do_exist_that_expect_either_1_or_2_arguments, args.length, maxBelow, minAbove);
          } else if (args.length < min) {
            var diagnostic = getDiagnosticForCallNode(node, error2, parameterRange, args.length);
            var parameter = (_a2 = closestSignature === null || closestSignature === void 0 ? void 0 : closestSignature.declaration) === null || _a2 === void 0 ? void 0 : _a2.parameters[closestSignature.thisParameter ? args.length + 1 : args.length];
            if (parameter) {
              var parameterError = ts3.createDiagnosticForNode(parameter, ts3.isBindingPattern(parameter.name) ? ts3.Diagnostics.An_argument_matching_this_binding_pattern_was_not_provided : ts3.isRestParameter(parameter) ? ts3.Diagnostics.Arguments_for_the_rest_parameter_0_were_not_provided : ts3.Diagnostics.An_argument_for_0_was_not_provided, !parameter.name ? args.length : !ts3.isBindingPattern(parameter.name) ? ts3.idText(ts3.getFirstIdentifier(parameter.name)) : void 0);
              return ts3.addRelatedInfo(diagnostic, parameterError);
            }
            return diagnostic;
          } else {
            var errorSpan = ts3.factory.createNodeArray(args.slice(max));
            var pos = ts3.first(errorSpan).pos;
            var end = ts3.last(errorSpan).end;
            if (end === pos) {
              end++;
            }
            ts3.setTextRangePosEnd(errorSpan, pos, end);
            return ts3.createDiagnosticForNodeArray(ts3.getSourceFileOfNode(node), errorSpan, error2, parameterRange, args.length);
          }
        }
        function getTypeArgumentArityError(node, signatures, typeArguments) {
          var argCount = typeArguments.length;
          if (signatures.length === 1) {
            var sig = signatures[0];
            var min_1 = getMinTypeArgumentCount(sig.typeParameters);
            var max = ts3.length(sig.typeParameters);
            return ts3.createDiagnosticForNodeArray(ts3.getSourceFileOfNode(node), typeArguments, ts3.Diagnostics.Expected_0_type_arguments_but_got_1, min_1 < max ? min_1 + "-" + max : min_1, argCount);
          }
          var belowArgCount = -Infinity;
          var aboveArgCount = Infinity;
          for (var _i = 0, signatures_9 = signatures; _i < signatures_9.length; _i++) {
            var sig = signatures_9[_i];
            var min_2 = getMinTypeArgumentCount(sig.typeParameters);
            var max = ts3.length(sig.typeParameters);
            if (min_2 > argCount) {
              aboveArgCount = Math.min(aboveArgCount, min_2);
            } else if (max < argCount) {
              belowArgCount = Math.max(belowArgCount, max);
            }
          }
          if (belowArgCount !== -Infinity && aboveArgCount !== Infinity) {
            return ts3.createDiagnosticForNodeArray(ts3.getSourceFileOfNode(node), typeArguments, ts3.Diagnostics.No_overload_expects_0_type_arguments_but_overloads_do_exist_that_expect_either_1_or_2_type_arguments, argCount, belowArgCount, aboveArgCount);
          }
          return ts3.createDiagnosticForNodeArray(ts3.getSourceFileOfNode(node), typeArguments, ts3.Diagnostics.Expected_0_type_arguments_but_got_1, belowArgCount === -Infinity ? aboveArgCount : belowArgCount, argCount);
        }
        function resolveCall(node, signatures, candidatesOutArray, checkMode, callChainFlags, fallbackError) {
          var isTaggedTemplate = node.kind === 206;
          var isDecorator = node.kind === 162;
          var isJsxOpeningOrSelfClosingElement = ts3.isJsxOpeningLikeElement(node);
          var reportErrors = !candidatesOutArray && produceDiagnostics;
          var typeArguments;
          if (!isDecorator) {
            typeArguments = node.typeArguments;
            if (isTaggedTemplate || isJsxOpeningOrSelfClosingElement || node.expression.kind !== 105) {
              ts3.forEach(typeArguments, checkSourceElement);
            }
          }
          var candidates = candidatesOutArray || [];
          reorderCandidates(signatures, candidates, callChainFlags);
          if (!candidates.length) {
            if (reportErrors) {
              diagnostics.add(getDiagnosticForCallNode(node, ts3.Diagnostics.Call_target_does_not_contain_any_signatures));
            }
            return resolveErrorCall(node);
          }
          var args = getEffectiveCallArguments(node);
          var isSingleNonGenericCandidate = candidates.length === 1 && !candidates[0].typeParameters;
          var argCheckMode = !isDecorator && !isSingleNonGenericCandidate && ts3.some(args, isContextSensitive) ? 4 : 0;
          var candidatesForArgumentError;
          var candidateForArgumentArityError;
          var candidateForTypeArgumentError;
          var result2;
          var signatureHelpTrailingComma = !!(checkMode & 16) && node.kind === 204 && node.arguments.hasTrailingComma;
          if (candidates.length > 1) {
            result2 = chooseOverload(candidates, subtypeRelation, isSingleNonGenericCandidate, signatureHelpTrailingComma);
          }
          if (!result2) {
            result2 = chooseOverload(candidates, assignableRelation, isSingleNonGenericCandidate, signatureHelpTrailingComma);
          }
          if (result2) {
            return result2;
          }
          if (reportErrors) {
            if (candidatesForArgumentError) {
              if (candidatesForArgumentError.length === 1 || candidatesForArgumentError.length > 3) {
                var last_2 = candidatesForArgumentError[candidatesForArgumentError.length - 1];
                var chain_1;
                if (candidatesForArgumentError.length > 3) {
                  chain_1 = ts3.chainDiagnosticMessages(chain_1, ts3.Diagnostics.The_last_overload_gave_the_following_error);
                  chain_1 = ts3.chainDiagnosticMessages(chain_1, ts3.Diagnostics.No_overload_matches_this_call);
                }
                var diags = getSignatureApplicabilityError(node, args, last_2, assignableRelation, 0, true, function() {
                  return chain_1;
                });
                if (diags) {
                  for (var _i = 0, diags_1 = diags; _i < diags_1.length; _i++) {
                    var d = diags_1[_i];
                    if (last_2.declaration && candidatesForArgumentError.length > 3) {
                      ts3.addRelatedInfo(d, ts3.createDiagnosticForNode(last_2.declaration, ts3.Diagnostics.The_last_overload_is_declared_here));
                    }
                    addImplementationSuccessElaboration(last_2, d);
                    diagnostics.add(d);
                  }
                } else {
                  ts3.Debug.fail("No error for last overload signature");
                }
              } else {
                var allDiagnostics = [];
                var max = 0;
                var min_3 = Number.MAX_VALUE;
                var minIndex = 0;
                var i_1 = 0;
                var _loop_22 = function(c3) {
                  var chain_2 = function() {
                    return ts3.chainDiagnosticMessages(void 0, ts3.Diagnostics.Overload_0_of_1_2_gave_the_following_error, i_1 + 1, candidates.length, signatureToString(c3));
                  };
                  var diags_2 = getSignatureApplicabilityError(node, args, c3, assignableRelation, 0, true, chain_2);
                  if (diags_2) {
                    if (diags_2.length <= min_3) {
                      min_3 = diags_2.length;
                      minIndex = i_1;
                    }
                    max = Math.max(max, diags_2.length);
                    allDiagnostics.push(diags_2);
                  } else {
                    ts3.Debug.fail("No error for 3 or fewer overload signatures");
                  }
                  i_1++;
                };
                for (var _a2 = 0, candidatesForArgumentError_1 = candidatesForArgumentError; _a2 < candidatesForArgumentError_1.length; _a2++) {
                  var c2 = candidatesForArgumentError_1[_a2];
                  _loop_22(c2);
                }
                var diags_3 = max > 1 ? allDiagnostics[minIndex] : ts3.flatten(allDiagnostics);
                ts3.Debug.assert(diags_3.length > 0, "No errors reported for 3 or fewer overload signatures");
                var chain = ts3.chainDiagnosticMessages(ts3.map(diags_3, function(d2) {
                  return typeof d2.messageText === "string" ? d2 : d2.messageText;
                }), ts3.Diagnostics.No_overload_matches_this_call);
                var related = __spreadArray([], ts3.flatMap(diags_3, function(d2) {
                  return d2.relatedInformation;
                }));
                var diag = void 0;
                if (ts3.every(diags_3, function(d2) {
                  return d2.start === diags_3[0].start && d2.length === diags_3[0].length && d2.file === diags_3[0].file;
                })) {
                  var _b = diags_3[0], file = _b.file, start = _b.start, length_7 = _b.length;
                  diag = { file, start, length: length_7, code: chain.code, category: chain.category, messageText: chain, relatedInformation: related };
                } else {
                  diag = ts3.createDiagnosticForNodeFromMessageChain(node, chain, related);
                }
                addImplementationSuccessElaboration(candidatesForArgumentError[0], diag);
                diagnostics.add(diag);
              }
            } else if (candidateForArgumentArityError) {
              diagnostics.add(getArgumentArityError(node, [candidateForArgumentArityError], args));
            } else if (candidateForTypeArgumentError) {
              checkTypeArguments(candidateForTypeArgumentError, node.typeArguments, true, fallbackError);
            } else {
              var signaturesWithCorrectTypeArgumentArity = ts3.filter(signatures, function(s2) {
                return hasCorrectTypeArgumentArity(s2, typeArguments);
              });
              if (signaturesWithCorrectTypeArgumentArity.length === 0) {
                diagnostics.add(getTypeArgumentArityError(node, signatures, typeArguments));
              } else if (!isDecorator) {
                diagnostics.add(getArgumentArityError(node, signaturesWithCorrectTypeArgumentArity, args));
              } else if (fallbackError) {
                diagnostics.add(getDiagnosticForCallNode(node, fallbackError));
              }
            }
          }
          return getCandidateForOverloadFailure(node, candidates, args, !!candidatesOutArray);
          function addImplementationSuccessElaboration(failed, diagnostic) {
            var _a3, _b2;
            var oldCandidatesForArgumentError = candidatesForArgumentError;
            var oldCandidateForArgumentArityError = candidateForArgumentArityError;
            var oldCandidateForTypeArgumentError = candidateForTypeArgumentError;
            var failedSignatureDeclarations = ((_b2 = (_a3 = failed.declaration) === null || _a3 === void 0 ? void 0 : _a3.symbol) === null || _b2 === void 0 ? void 0 : _b2.declarations) || ts3.emptyArray;
            var isOverload = failedSignatureDeclarations.length > 1;
            var implDecl = isOverload ? ts3.find(failedSignatureDeclarations, function(d2) {
              return ts3.isFunctionLikeDeclaration(d2) && ts3.nodeIsPresent(d2.body);
            }) : void 0;
            if (implDecl) {
              var candidate = getSignatureFromDeclaration(implDecl);
              var isSingleNonGenericCandidate_1 = !candidate.typeParameters;
              if (chooseOverload([candidate], assignableRelation, isSingleNonGenericCandidate_1)) {
                ts3.addRelatedInfo(diagnostic, ts3.createDiagnosticForNode(implDecl, ts3.Diagnostics.The_call_would_have_succeeded_against_this_implementation_but_implementation_signatures_of_overloads_are_not_externally_visible));
              }
            }
            candidatesForArgumentError = oldCandidatesForArgumentError;
            candidateForArgumentArityError = oldCandidateForArgumentArityError;
            candidateForTypeArgumentError = oldCandidateForTypeArgumentError;
          }
          function chooseOverload(candidates2, relation, isSingleNonGenericCandidate2, signatureHelpTrailingComma2) {
            if (signatureHelpTrailingComma2 === void 0) {
              signatureHelpTrailingComma2 = false;
            }
            candidatesForArgumentError = void 0;
            candidateForArgumentArityError = void 0;
            candidateForTypeArgumentError = void 0;
            if (isSingleNonGenericCandidate2) {
              var candidate = candidates2[0];
              if (ts3.some(typeArguments) || !hasCorrectArity(node, args, candidate, signatureHelpTrailingComma2)) {
                return void 0;
              }
              if (getSignatureApplicabilityError(node, args, candidate, relation, 0, false, void 0)) {
                candidatesForArgumentError = [candidate];
                return void 0;
              }
              return candidate;
            }
            for (var candidateIndex = 0; candidateIndex < candidates2.length; candidateIndex++) {
              var candidate = candidates2[candidateIndex];
              if (!hasCorrectTypeArgumentArity(candidate, typeArguments) || !hasCorrectArity(node, args, candidate, signatureHelpTrailingComma2)) {
                continue;
              }
              var checkCandidate = void 0;
              var inferenceContext = void 0;
              if (candidate.typeParameters) {
                var typeArgumentTypes = void 0;
                if (ts3.some(typeArguments)) {
                  typeArgumentTypes = checkTypeArguments(candidate, typeArguments, false);
                  if (!typeArgumentTypes) {
                    candidateForTypeArgumentError = candidate;
                    continue;
                  }
                } else {
                  inferenceContext = createInferenceContext(candidate.typeParameters, candidate, ts3.isInJSFile(node) ? 2 : 0);
                  typeArgumentTypes = inferTypeArguments(node, candidate, args, argCheckMode | 8, inferenceContext);
                  argCheckMode |= inferenceContext.flags & 4 ? 8 : 0;
                }
                checkCandidate = getSignatureInstantiation(candidate, typeArgumentTypes, ts3.isInJSFile(candidate.declaration), inferenceContext && inferenceContext.inferredTypeParameters);
                if (getNonArrayRestType(candidate) && !hasCorrectArity(node, args, checkCandidate, signatureHelpTrailingComma2)) {
                  candidateForArgumentArityError = checkCandidate;
                  continue;
                }
              } else {
                checkCandidate = candidate;
              }
              if (getSignatureApplicabilityError(node, args, checkCandidate, relation, argCheckMode, false, void 0)) {
                (candidatesForArgumentError || (candidatesForArgumentError = [])).push(checkCandidate);
                continue;
              }
              if (argCheckMode) {
                argCheckMode = 0;
                if (inferenceContext) {
                  var typeArgumentTypes = inferTypeArguments(node, candidate, args, argCheckMode, inferenceContext);
                  checkCandidate = getSignatureInstantiation(candidate, typeArgumentTypes, ts3.isInJSFile(candidate.declaration), inferenceContext && inferenceContext.inferredTypeParameters);
                  if (getNonArrayRestType(candidate) && !hasCorrectArity(node, args, checkCandidate, signatureHelpTrailingComma2)) {
                    candidateForArgumentArityError = checkCandidate;
                    continue;
                  }
                }
                if (getSignatureApplicabilityError(node, args, checkCandidate, relation, argCheckMode, false, void 0)) {
                  (candidatesForArgumentError || (candidatesForArgumentError = [])).push(checkCandidate);
                  continue;
                }
              }
              candidates2[candidateIndex] = checkCandidate;
              return checkCandidate;
            }
            return void 0;
          }
        }
        function getCandidateForOverloadFailure(node, candidates, args, hasCandidatesOutArray) {
          ts3.Debug.assert(candidates.length > 0);
          checkNodeDeferred(node);
          return hasCandidatesOutArray || candidates.length === 1 || candidates.some(function(c2) {
            return !!c2.typeParameters;
          }) ? pickLongestCandidateSignature(node, candidates, args) : createUnionOfSignaturesForOverloadFailure(candidates);
        }
        function createUnionOfSignaturesForOverloadFailure(candidates) {
          var thisParameters = ts3.mapDefined(candidates, function(c2) {
            return c2.thisParameter;
          });
          var thisParameter;
          if (thisParameters.length) {
            thisParameter = createCombinedSymbolFromTypes(thisParameters, thisParameters.map(getTypeOfParameter));
          }
          var _a2 = ts3.minAndMax(candidates, getNumNonRestParameters), minArgumentCount = _a2.min, maxNonRestParam = _a2.max;
          var parameters = [];
          var _loop_23 = function(i4) {
            var symbols = ts3.mapDefined(candidates, function(s2) {
              return signatureHasRestParameter(s2) ? i4 < s2.parameters.length - 1 ? s2.parameters[i4] : ts3.last(s2.parameters) : i4 < s2.parameters.length ? s2.parameters[i4] : void 0;
            });
            ts3.Debug.assert(symbols.length !== 0);
            parameters.push(createCombinedSymbolFromTypes(symbols, ts3.mapDefined(candidates, function(candidate) {
              return tryGetTypeAtPosition(candidate, i4);
            })));
          };
          for (var i3 = 0; i3 < maxNonRestParam; i3++) {
            _loop_23(i3);
          }
          var restParameterSymbols = ts3.mapDefined(candidates, function(c2) {
            return signatureHasRestParameter(c2) ? ts3.last(c2.parameters) : void 0;
          });
          var flags = 0;
          if (restParameterSymbols.length !== 0) {
            var type3 = createArrayType(getUnionType(ts3.mapDefined(candidates, tryGetRestTypeOfSignature), 2));
            parameters.push(createCombinedSymbolForOverloadFailure(restParameterSymbols, type3));
            flags |= 1;
          }
          if (candidates.some(signatureHasLiteralTypes)) {
            flags |= 2;
          }
          return createSignature(candidates[0].declaration, void 0, thisParameter, parameters, getIntersectionType(candidates.map(getReturnTypeOfSignature)), void 0, minArgumentCount, flags);
        }
        function getNumNonRestParameters(signature) {
          var numParams = signature.parameters.length;
          return signatureHasRestParameter(signature) ? numParams - 1 : numParams;
        }
        function createCombinedSymbolFromTypes(sources, types2) {
          return createCombinedSymbolForOverloadFailure(sources, getUnionType(types2, 2));
        }
        function createCombinedSymbolForOverloadFailure(sources, type3) {
          return createSymbolWithType(ts3.first(sources), type3);
        }
        function pickLongestCandidateSignature(node, candidates, args) {
          var bestIndex = getLongestCandidateIndex(candidates, apparentArgumentCount === void 0 ? args.length : apparentArgumentCount);
          var candidate = candidates[bestIndex];
          var typeParameters = candidate.typeParameters;
          if (!typeParameters) {
            return candidate;
          }
          var typeArgumentNodes = callLikeExpressionMayHaveTypeArguments(node) ? node.typeArguments : void 0;
          var instantiated = typeArgumentNodes ? createSignatureInstantiation(candidate, getTypeArgumentsFromNodes(typeArgumentNodes, typeParameters, ts3.isInJSFile(node))) : inferSignatureInstantiationForOverloadFailure(node, typeParameters, candidate, args);
          candidates[bestIndex] = instantiated;
          return instantiated;
        }
        function getTypeArgumentsFromNodes(typeArgumentNodes, typeParameters, isJs) {
          var typeArguments = typeArgumentNodes.map(getTypeOfNode);
          while (typeArguments.length > typeParameters.length) {
            typeArguments.pop();
          }
          while (typeArguments.length < typeParameters.length) {
            typeArguments.push(getConstraintOfTypeParameter(typeParameters[typeArguments.length]) || getDefaultTypeArgumentType(isJs));
          }
          return typeArguments;
        }
        function inferSignatureInstantiationForOverloadFailure(node, typeParameters, candidate, args) {
          var inferenceContext = createInferenceContext(typeParameters, candidate, ts3.isInJSFile(node) ? 2 : 0);
          var typeArgumentTypes = inferTypeArguments(node, candidate, args, 4 | 8, inferenceContext);
          return createSignatureInstantiation(candidate, typeArgumentTypes);
        }
        function getLongestCandidateIndex(candidates, argsCount) {
          var maxParamsIndex = -1;
          var maxParams = -1;
          for (var i3 = 0; i3 < candidates.length; i3++) {
            var candidate = candidates[i3];
            var paramCount = getParameterCount(candidate);
            if (hasEffectiveRestParameter(candidate) || paramCount >= argsCount) {
              return i3;
            }
            if (paramCount > maxParams) {
              maxParams = paramCount;
              maxParamsIndex = i3;
            }
          }
          return maxParamsIndex;
        }
        function resolveCallExpression(node, candidatesOutArray, checkMode) {
          if (node.expression.kind === 105) {
            var superType = checkSuperExpression(node.expression);
            if (isTypeAny(superType)) {
              for (var _i = 0, _a2 = node.arguments; _i < _a2.length; _i++) {
                var arg2 = _a2[_i];
                checkExpression(arg2);
              }
              return anySignature;
            }
            if (superType !== errorType) {
              var baseTypeNode = ts3.getEffectiveBaseTypeNode(ts3.getContainingClass(node));
              if (baseTypeNode) {
                var baseConstructors = getInstantiatedConstructorsForTypeArguments(superType, baseTypeNode.typeArguments, baseTypeNode);
                return resolveCall(node, baseConstructors, candidatesOutArray, checkMode, 0);
              }
            }
            return resolveUntypedCall(node);
          }
          var callChainFlags;
          var funcType = checkExpression(node.expression);
          if (ts3.isCallChain(node)) {
            var nonOptionalType = getOptionalExpressionType(funcType, node.expression);
            callChainFlags = nonOptionalType === funcType ? 0 : ts3.isOutermostOptionalChain(node) ? 16 : 8;
            funcType = nonOptionalType;
          } else {
            callChainFlags = 0;
          }
          funcType = checkNonNullTypeWithReporter(funcType, node.expression, reportCannotInvokePossiblyNullOrUndefinedError);
          if (funcType === silentNeverType) {
            return silentNeverSignature;
          }
          var apparentType = getApparentType(funcType);
          if (apparentType === errorType) {
            return resolveErrorCall(node);
          }
          var callSignatures = getSignaturesOfType(apparentType, 0);
          var numConstructSignatures = getSignaturesOfType(apparentType, 1).length;
          if (isUntypedFunctionCall(funcType, apparentType, callSignatures.length, numConstructSignatures)) {
            if (funcType !== errorType && node.typeArguments) {
              error(node, ts3.Diagnostics.Untyped_function_calls_may_not_accept_type_arguments);
            }
            return resolveUntypedCall(node);
          }
          if (!callSignatures.length) {
            if (numConstructSignatures) {
              error(node, ts3.Diagnostics.Value_of_type_0_is_not_callable_Did_you_mean_to_include_new, typeToString(funcType));
            } else {
              var relatedInformation = void 0;
              if (node.arguments.length === 1) {
                var text = ts3.getSourceFileOfNode(node).text;
                if (ts3.isLineBreak(text.charCodeAt(ts3.skipTrivia(text, node.expression.end, true) - 1))) {
                  relatedInformation = ts3.createDiagnosticForNode(node.expression, ts3.Diagnostics.Are_you_missing_a_semicolon);
                }
              }
              invocationError(node.expression, apparentType, 0, relatedInformation);
            }
            return resolveErrorCall(node);
          }
          if (checkMode & 8 && !node.typeArguments && callSignatures.some(isGenericFunctionReturningFunction)) {
            skippedGenericFunction(node, checkMode);
            return resolvingSignature;
          }
          if (callSignatures.some(function(sig) {
            return ts3.isInJSFile(sig.declaration) && !!ts3.getJSDocClassTag(sig.declaration);
          })) {
            error(node, ts3.Diagnostics.Value_of_type_0_is_not_callable_Did_you_mean_to_include_new, typeToString(funcType));
            return resolveErrorCall(node);
          }
          return resolveCall(node, callSignatures, candidatesOutArray, checkMode, callChainFlags);
        }
        function isGenericFunctionReturningFunction(signature) {
          return !!(signature.typeParameters && isFunctionType(getReturnTypeOfSignature(signature)));
        }
        function isUntypedFunctionCall(funcType, apparentFuncType, numCallSignatures, numConstructSignatures) {
          return isTypeAny(funcType) || isTypeAny(apparentFuncType) && !!(funcType.flags & 262144) || !numCallSignatures && !numConstructSignatures && !(apparentFuncType.flags & 1048576) && !(getReducedType(apparentFuncType).flags & 131072) && isTypeAssignableTo(funcType, globalFunctionType);
        }
        function resolveNewExpression(node, candidatesOutArray, checkMode) {
          if (node.arguments && languageVersion < 1) {
            var spreadIndex = getSpreadArgumentIndex(node.arguments);
            if (spreadIndex >= 0) {
              error(node.arguments[spreadIndex], ts3.Diagnostics.Spread_operator_in_new_expressions_is_only_available_when_targeting_ECMAScript_5_and_higher);
            }
          }
          var expressionType = checkNonNullExpression(node.expression);
          if (expressionType === silentNeverType) {
            return silentNeverSignature;
          }
          expressionType = getApparentType(expressionType);
          if (expressionType === errorType) {
            return resolveErrorCall(node);
          }
          if (isTypeAny(expressionType)) {
            if (node.typeArguments) {
              error(node, ts3.Diagnostics.Untyped_function_calls_may_not_accept_type_arguments);
            }
            return resolveUntypedCall(node);
          }
          var constructSignatures = getSignaturesOfType(expressionType, 1);
          if (constructSignatures.length) {
            if (!isConstructorAccessible(node, constructSignatures[0])) {
              return resolveErrorCall(node);
            }
            if (constructSignatures.some(function(signature2) {
              return signature2.flags & 4;
            })) {
              error(node, ts3.Diagnostics.Cannot_create_an_instance_of_an_abstract_class);
              return resolveErrorCall(node);
            }
            var valueDecl = expressionType.symbol && ts3.getClassLikeDeclarationOfSymbol(expressionType.symbol);
            if (valueDecl && ts3.hasSyntacticModifier(valueDecl, 128)) {
              error(node, ts3.Diagnostics.Cannot_create_an_instance_of_an_abstract_class);
              return resolveErrorCall(node);
            }
            return resolveCall(node, constructSignatures, candidatesOutArray, checkMode, 0);
          }
          var callSignatures = getSignaturesOfType(expressionType, 0);
          if (callSignatures.length) {
            var signature = resolveCall(node, callSignatures, candidatesOutArray, checkMode, 0);
            if (!noImplicitAny) {
              if (signature.declaration && !isJSConstructor(signature.declaration) && getReturnTypeOfSignature(signature) !== voidType) {
                error(node, ts3.Diagnostics.Only_a_void_function_can_be_called_with_the_new_keyword);
              }
              if (getThisTypeOfSignature(signature) === voidType) {
                error(node, ts3.Diagnostics.A_function_that_is_called_with_the_new_keyword_cannot_have_a_this_type_that_is_void);
              }
            }
            return signature;
          }
          invocationError(node.expression, expressionType, 1);
          return resolveErrorCall(node);
        }
        function typeHasProtectedAccessibleBase(target, type3) {
          var baseTypes = getBaseTypes(type3);
          if (!ts3.length(baseTypes)) {
            return false;
          }
          var firstBase = baseTypes[0];
          if (firstBase.flags & 2097152) {
            var types2 = firstBase.types;
            var mixinFlags = findMixins(types2);
            var i3 = 0;
            for (var _i = 0, _a2 = firstBase.types; _i < _a2.length; _i++) {
              var intersectionMember = _a2[_i];
              if (!mixinFlags[i3]) {
                if (ts3.getObjectFlags(intersectionMember) & (1 | 2)) {
                  if (intersectionMember.symbol === target) {
                    return true;
                  }
                  if (typeHasProtectedAccessibleBase(target, intersectionMember)) {
                    return true;
                  }
                }
              }
              i3++;
            }
            return false;
          }
          if (firstBase.symbol === target) {
            return true;
          }
          return typeHasProtectedAccessibleBase(target, firstBase);
        }
        function isConstructorAccessible(node, signature) {
          if (!signature || !signature.declaration) {
            return true;
          }
          var declaration = signature.declaration;
          var modifiers = ts3.getSelectedEffectiveModifierFlags(declaration, 24);
          if (!modifiers || declaration.kind !== 167) {
            return true;
          }
          var declaringClassDeclaration = ts3.getClassLikeDeclarationOfSymbol(declaration.parent.symbol);
          var declaringClass = getDeclaredTypeOfSymbol(declaration.parent.symbol);
          if (!isNodeWithinClass(node, declaringClassDeclaration)) {
            var containingClass = ts3.getContainingClass(node);
            if (containingClass && modifiers & 16) {
              var containingType = getTypeOfNode(containingClass);
              if (typeHasProtectedAccessibleBase(declaration.parent.symbol, containingType)) {
                return true;
              }
            }
            if (modifiers & 8) {
              error(node, ts3.Diagnostics.Constructor_of_class_0_is_private_and_only_accessible_within_the_class_declaration, typeToString(declaringClass));
            }
            if (modifiers & 16) {
              error(node, ts3.Diagnostics.Constructor_of_class_0_is_protected_and_only_accessible_within_the_class_declaration, typeToString(declaringClass));
            }
            return false;
          }
          return true;
        }
        function invocationErrorDetails(errorTarget, apparentType, kind) {
          var errorInfo;
          var isCall = kind === 0;
          var awaitedType = getAwaitedType(apparentType);
          var maybeMissingAwait = awaitedType && getSignaturesOfType(awaitedType, kind).length > 0;
          if (apparentType.flags & 1048576) {
            var types2 = apparentType.types;
            var hasSignatures = false;
            for (var _i = 0, types_21 = types2; _i < types_21.length; _i++) {
              var constituent = types_21[_i];
              var signatures = getSignaturesOfType(constituent, kind);
              if (signatures.length !== 0) {
                hasSignatures = true;
                if (errorInfo) {
                  break;
                }
              } else {
                if (!errorInfo) {
                  errorInfo = ts3.chainDiagnosticMessages(errorInfo, isCall ? ts3.Diagnostics.Type_0_has_no_call_signatures : ts3.Diagnostics.Type_0_has_no_construct_signatures, typeToString(constituent));
                  errorInfo = ts3.chainDiagnosticMessages(errorInfo, isCall ? ts3.Diagnostics.Not_all_constituents_of_type_0_are_callable : ts3.Diagnostics.Not_all_constituents_of_type_0_are_constructable, typeToString(apparentType));
                }
                if (hasSignatures) {
                  break;
                }
              }
            }
            if (!hasSignatures) {
              errorInfo = ts3.chainDiagnosticMessages(void 0, isCall ? ts3.Diagnostics.No_constituent_of_type_0_is_callable : ts3.Diagnostics.No_constituent_of_type_0_is_constructable, typeToString(apparentType));
            }
            if (!errorInfo) {
              errorInfo = ts3.chainDiagnosticMessages(errorInfo, isCall ? ts3.Diagnostics.Each_member_of_the_union_type_0_has_signatures_but_none_of_those_signatures_are_compatible_with_each_other : ts3.Diagnostics.Each_member_of_the_union_type_0_has_construct_signatures_but_none_of_those_signatures_are_compatible_with_each_other, typeToString(apparentType));
            }
          } else {
            errorInfo = ts3.chainDiagnosticMessages(errorInfo, isCall ? ts3.Diagnostics.Type_0_has_no_call_signatures : ts3.Diagnostics.Type_0_has_no_construct_signatures, typeToString(apparentType));
          }
          var headMessage = isCall ? ts3.Diagnostics.This_expression_is_not_callable : ts3.Diagnostics.This_expression_is_not_constructable;
          if (ts3.isCallExpression(errorTarget.parent) && errorTarget.parent.arguments.length === 0) {
            var resolvedSymbol = getNodeLinks(errorTarget).resolvedSymbol;
            if (resolvedSymbol && resolvedSymbol.flags & 32768) {
              headMessage = ts3.Diagnostics.This_expression_is_not_callable_because_it_is_a_get_accessor_Did_you_mean_to_use_it_without;
            }
          }
          return {
            messageChain: ts3.chainDiagnosticMessages(errorInfo, headMessage),
            relatedMessage: maybeMissingAwait ? ts3.Diagnostics.Did_you_forget_to_use_await : void 0
          };
        }
        function invocationError(errorTarget, apparentType, kind, relatedInformation) {
          var _a2 = invocationErrorDetails(errorTarget, apparentType, kind), messageChain = _a2.messageChain, relatedInfo = _a2.relatedMessage;
          var diagnostic = ts3.createDiagnosticForNodeFromMessageChain(errorTarget, messageChain);
          if (relatedInfo) {
            ts3.addRelatedInfo(diagnostic, ts3.createDiagnosticForNode(errorTarget, relatedInfo));
          }
          if (ts3.isCallExpression(errorTarget.parent)) {
            var _b = getDiagnosticSpanForCallNode(errorTarget.parent, true), start = _b.start, length_8 = _b.length;
            diagnostic.start = start;
            diagnostic.length = length_8;
          }
          diagnostics.add(diagnostic);
          invocationErrorRecovery(apparentType, kind, relatedInformation ? ts3.addRelatedInfo(diagnostic, relatedInformation) : diagnostic);
        }
        function invocationErrorRecovery(apparentType, kind, diagnostic) {
          if (!apparentType.symbol) {
            return;
          }
          var importNode = getSymbolLinks(apparentType.symbol).originatingImport;
          if (importNode && !ts3.isImportCall(importNode)) {
            var sigs = getSignaturesOfType(getTypeOfSymbol(getSymbolLinks(apparentType.symbol).target), kind);
            if (!sigs || !sigs.length)
              return;
            ts3.addRelatedInfo(diagnostic, ts3.createDiagnosticForNode(importNode, ts3.Diagnostics.Type_originates_at_this_import_A_namespace_style_import_cannot_be_called_or_constructed_and_will_cause_a_failure_at_runtime_Consider_using_a_default_import_or_import_require_here_instead));
          }
        }
        function resolveTaggedTemplateExpression(node, candidatesOutArray, checkMode) {
          var tagType = checkExpression(node.tag);
          var apparentType = getApparentType(tagType);
          if (apparentType === errorType) {
            return resolveErrorCall(node);
          }
          var callSignatures = getSignaturesOfType(apparentType, 0);
          var numConstructSignatures = getSignaturesOfType(apparentType, 1).length;
          if (isUntypedFunctionCall(tagType, apparentType, callSignatures.length, numConstructSignatures)) {
            return resolveUntypedCall(node);
          }
          if (!callSignatures.length) {
            if (ts3.isArrayLiteralExpression(node.parent)) {
              var diagnostic = ts3.createDiagnosticForNode(node.tag, ts3.Diagnostics.It_is_likely_that_you_are_missing_a_comma_to_separate_these_two_template_expressions_They_form_a_tagged_template_expression_which_cannot_be_invoked);
              diagnostics.add(diagnostic);
              return resolveErrorCall(node);
            }
            invocationError(node.tag, apparentType, 0);
            return resolveErrorCall(node);
          }
          return resolveCall(node, callSignatures, candidatesOutArray, checkMode, 0);
        }
        function getDiagnosticHeadMessageForDecoratorResolution(node) {
          switch (node.parent.kind) {
            case 253:
            case 222:
              return ts3.Diagnostics.Unable_to_resolve_signature_of_class_decorator_when_called_as_an_expression;
            case 161:
              return ts3.Diagnostics.Unable_to_resolve_signature_of_parameter_decorator_when_called_as_an_expression;
            case 164:
              return ts3.Diagnostics.Unable_to_resolve_signature_of_property_decorator_when_called_as_an_expression;
            case 166:
            case 168:
            case 169:
              return ts3.Diagnostics.Unable_to_resolve_signature_of_method_decorator_when_called_as_an_expression;
            default:
              return ts3.Debug.fail();
          }
        }
        function resolveDecorator(node, candidatesOutArray, checkMode) {
          var funcType = checkExpression(node.expression);
          var apparentType = getApparentType(funcType);
          if (apparentType === errorType) {
            return resolveErrorCall(node);
          }
          var callSignatures = getSignaturesOfType(apparentType, 0);
          var numConstructSignatures = getSignaturesOfType(apparentType, 1).length;
          if (isUntypedFunctionCall(funcType, apparentType, callSignatures.length, numConstructSignatures)) {
            return resolveUntypedCall(node);
          }
          if (isPotentiallyUncalledDecorator(node, callSignatures)) {
            var nodeStr = ts3.getTextOfNode(node.expression, false);
            error(node, ts3.Diagnostics._0_accepts_too_few_arguments_to_be_used_as_a_decorator_here_Did_you_mean_to_call_it_first_and_write_0, nodeStr);
            return resolveErrorCall(node);
          }
          var headMessage = getDiagnosticHeadMessageForDecoratorResolution(node);
          if (!callSignatures.length) {
            var errorDetails = invocationErrorDetails(node.expression, apparentType, 0);
            var messageChain = ts3.chainDiagnosticMessages(errorDetails.messageChain, headMessage);
            var diag = ts3.createDiagnosticForNodeFromMessageChain(node.expression, messageChain);
            if (errorDetails.relatedMessage) {
              ts3.addRelatedInfo(diag, ts3.createDiagnosticForNode(node.expression, errorDetails.relatedMessage));
            }
            diagnostics.add(diag);
            invocationErrorRecovery(apparentType, 0, diag);
            return resolveErrorCall(node);
          }
          return resolveCall(node, callSignatures, candidatesOutArray, checkMode, 0, headMessage);
        }
        function createSignatureForJSXIntrinsic(node, result2) {
          var namespace = getJsxNamespaceAt(node);
          var exports3 = namespace && getExportsOfSymbol(namespace);
          var typeSymbol = exports3 && getSymbol(exports3, JsxNames.Element, 788968);
          var returnNode = typeSymbol && nodeBuilder.symbolToEntityName(typeSymbol, 788968, node);
          var declaration = ts3.factory.createFunctionTypeNode(void 0, [ts3.factory.createParameterDeclaration(void 0, void 0, void 0, "props", void 0, nodeBuilder.typeToTypeNode(result2, node))], returnNode ? ts3.factory.createTypeReferenceNode(returnNode, void 0) : ts3.factory.createKeywordTypeNode(128));
          var parameterSymbol = createSymbol(1, "props");
          parameterSymbol.type = result2;
          return createSignature(declaration, void 0, void 0, [parameterSymbol], typeSymbol ? getDeclaredTypeOfSymbol(typeSymbol) : errorType, void 0, 1, 0);
        }
        function resolveJsxOpeningLikeElement(node, candidatesOutArray, checkMode) {
          if (isJsxIntrinsicIdentifier(node.tagName)) {
            var result2 = getIntrinsicAttributesTypeFromJsxOpeningLikeElement(node);
            var fakeSignature = createSignatureForJSXIntrinsic(node, result2);
            checkTypeAssignableToAndOptionallyElaborate(checkExpressionWithContextualType(node.attributes, getEffectiveFirstArgumentForJsxSignature(fakeSignature, node), void 0, 0), result2, node.tagName, node.attributes);
            if (ts3.length(node.typeArguments)) {
              ts3.forEach(node.typeArguments, checkSourceElement);
              diagnostics.add(ts3.createDiagnosticForNodeArray(ts3.getSourceFileOfNode(node), node.typeArguments, ts3.Diagnostics.Expected_0_type_arguments_but_got_1, 0, ts3.length(node.typeArguments)));
            }
            return fakeSignature;
          }
          var exprTypes = checkExpression(node.tagName);
          var apparentType = getApparentType(exprTypes);
          if (apparentType === errorType) {
            return resolveErrorCall(node);
          }
          var signatures = getUninstantiatedJsxSignaturesOfType(exprTypes, node);
          if (isUntypedFunctionCall(exprTypes, apparentType, signatures.length, 0)) {
            return resolveUntypedCall(node);
          }
          if (signatures.length === 0) {
            error(node.tagName, ts3.Diagnostics.JSX_element_type_0_does_not_have_any_construct_or_call_signatures, ts3.getTextOfNode(node.tagName));
            return resolveErrorCall(node);
          }
          return resolveCall(node, signatures, candidatesOutArray, checkMode, 0);
        }
        function isPotentiallyUncalledDecorator(decorator, signatures) {
          return signatures.length && ts3.every(signatures, function(signature) {
            return signature.minArgumentCount === 0 && !signatureHasRestParameter(signature) && signature.parameters.length < getDecoratorArgumentCount(decorator, signature);
          });
        }
        function resolveSignature(node, candidatesOutArray, checkMode) {
          switch (node.kind) {
            case 204:
              return resolveCallExpression(node, candidatesOutArray, checkMode);
            case 205:
              return resolveNewExpression(node, candidatesOutArray, checkMode);
            case 206:
              return resolveTaggedTemplateExpression(node, candidatesOutArray, checkMode);
            case 162:
              return resolveDecorator(node, candidatesOutArray, checkMode);
            case 276:
            case 275:
              return resolveJsxOpeningLikeElement(node, candidatesOutArray, checkMode);
          }
          throw ts3.Debug.assertNever(node, "Branch in 'resolveSignature' should be unreachable.");
        }
        function getResolvedSignature(node, candidatesOutArray, checkMode) {
          var links = getNodeLinks(node);
          var cached = links.resolvedSignature;
          if (cached && cached !== resolvingSignature && !candidatesOutArray) {
            return cached;
          }
          links.resolvedSignature = resolvingSignature;
          var result2 = resolveSignature(node, candidatesOutArray, checkMode || 0);
          if (result2 !== resolvingSignature) {
            links.resolvedSignature = flowLoopStart === flowLoopCount ? result2 : cached;
          }
          return result2;
        }
        function isJSConstructor(node) {
          var _a2;
          if (!node || !ts3.isInJSFile(node)) {
            return false;
          }
          var func2 = ts3.isFunctionDeclaration(node) || ts3.isFunctionExpression(node) ? node : ts3.isVariableDeclaration(node) && node.initializer && ts3.isFunctionExpression(node.initializer) ? node.initializer : void 0;
          if (func2) {
            if (ts3.getJSDocClassTag(node))
              return true;
            var symbol = getSymbolOfNode(func2);
            return !!((_a2 = symbol === null || symbol === void 0 ? void 0 : symbol.members) === null || _a2 === void 0 ? void 0 : _a2.size);
          }
          return false;
        }
        function mergeJSSymbols(target, source) {
          var _a2, _b;
          if (source) {
            var links = getSymbolLinks(source);
            if (!links.inferredClassSymbol || !links.inferredClassSymbol.has(getSymbolId(target))) {
              var inferred = ts3.isTransientSymbol(target) ? target : cloneSymbol(target);
              inferred.exports = inferred.exports || ts3.createSymbolTable();
              inferred.members = inferred.members || ts3.createSymbolTable();
              inferred.flags |= source.flags & 32;
              if ((_a2 = source.exports) === null || _a2 === void 0 ? void 0 : _a2.size) {
                mergeSymbolTable(inferred.exports, source.exports);
              }
              if ((_b = source.members) === null || _b === void 0 ? void 0 : _b.size) {
                mergeSymbolTable(inferred.members, source.members);
              }
              (links.inferredClassSymbol || (links.inferredClassSymbol = new ts3.Map())).set(getSymbolId(inferred), inferred);
              return inferred;
            }
            return links.inferredClassSymbol.get(getSymbolId(target));
          }
        }
        function getAssignedClassSymbol(decl) {
          var _a2;
          var assignmentSymbol = decl && getSymbolOfExpando(decl, true);
          var prototype = (_a2 = assignmentSymbol === null || assignmentSymbol === void 0 ? void 0 : assignmentSymbol.exports) === null || _a2 === void 0 ? void 0 : _a2.get("prototype");
          var init = (prototype === null || prototype === void 0 ? void 0 : prototype.valueDeclaration) && getAssignedJSPrototype(prototype.valueDeclaration);
          return init ? getSymbolOfNode(init) : void 0;
        }
        function getSymbolOfExpando(node, allowDeclaration) {
          if (!node.parent) {
            return void 0;
          }
          var name;
          var decl;
          if (ts3.isVariableDeclaration(node.parent) && node.parent.initializer === node) {
            if (!ts3.isInJSFile(node) && !(ts3.isVarConst(node.parent) && ts3.isFunctionLikeDeclaration(node))) {
              return void 0;
            }
            name = node.parent.name;
            decl = node.parent;
          } else if (ts3.isBinaryExpression(node.parent)) {
            var parentNode = node.parent;
            var parentNodeOperator = node.parent.operatorToken.kind;
            if (parentNodeOperator === 62 && (allowDeclaration || parentNode.right === node)) {
              name = parentNode.left;
              decl = name;
            } else if (parentNodeOperator === 56 || parentNodeOperator === 60) {
              if (ts3.isVariableDeclaration(parentNode.parent) && parentNode.parent.initializer === parentNode) {
                name = parentNode.parent.name;
                decl = parentNode.parent;
              } else if (ts3.isBinaryExpression(parentNode.parent) && parentNode.parent.operatorToken.kind === 62 && (allowDeclaration || parentNode.parent.right === parentNode)) {
                name = parentNode.parent.left;
                decl = name;
              }
              if (!name || !ts3.isBindableStaticNameExpression(name) || !ts3.isSameEntityName(name, parentNode.left)) {
                return void 0;
              }
            }
          } else if (allowDeclaration && ts3.isFunctionDeclaration(node)) {
            name = node.name;
            decl = node;
          }
          if (!decl || !name || !allowDeclaration && !ts3.getExpandoInitializer(node, ts3.isPrototypeAccess(name))) {
            return void 0;
          }
          return getSymbolOfNode(decl);
        }
        function getAssignedJSPrototype(node) {
          if (!node.parent) {
            return false;
          }
          var parent = node.parent;
          while (parent && parent.kind === 202) {
            parent = parent.parent;
          }
          if (parent && ts3.isBinaryExpression(parent) && ts3.isPrototypeAccess(parent.left) && parent.operatorToken.kind === 62) {
            var right = ts3.getInitializerOfBinaryExpression(parent);
            return ts3.isObjectLiteralExpression(right) && right;
          }
        }
        function checkCallExpression(node, checkMode) {
          var _a2;
          if (!checkGrammarTypeArguments(node, node.typeArguments))
            checkGrammarArguments(node.arguments);
          var signature = getResolvedSignature(node, void 0, checkMode);
          if (signature === resolvingSignature) {
            return nonInferrableType;
          }
          checkDeprecatedSignature(signature, node);
          if (node.expression.kind === 105) {
            return voidType;
          }
          if (node.kind === 205) {
            var declaration = signature.declaration;
            if (declaration && declaration.kind !== 167 && declaration.kind !== 171 && declaration.kind !== 176 && !ts3.isJSDocConstructSignature(declaration) && !isJSConstructor(declaration)) {
              if (noImplicitAny) {
                error(node, ts3.Diagnostics.new_expression_whose_target_lacks_a_construct_signature_implicitly_has_an_any_type);
              }
              return anyType;
            }
          }
          if (ts3.isInJSFile(node) && isCommonJsRequire(node)) {
            return resolveExternalModuleTypeByLiteral(node.arguments[0]);
          }
          var returnType2 = getReturnTypeOfSignature(signature);
          if (returnType2.flags & 12288 && isSymbolOrSymbolForCall(node)) {
            return getESSymbolLikeTypeForNode(ts3.walkUpParenthesizedExpressions(node.parent));
          }
          if (node.kind === 204 && !node.questionDotToken && node.parent.kind === 234 && returnType2.flags & 16384 && getTypePredicateOfSignature(signature)) {
            if (!ts3.isDottedName(node.expression)) {
              error(node.expression, ts3.Diagnostics.Assertions_require_the_call_target_to_be_an_identifier_or_qualified_name);
            } else if (!getEffectsSignature(node)) {
              var diagnostic = error(node.expression, ts3.Diagnostics.Assertions_require_every_name_in_the_call_target_to_be_declared_with_an_explicit_type_annotation);
              getTypeOfDottedName(node.expression, diagnostic);
            }
          }
          if (ts3.isInJSFile(node)) {
            var jsSymbol = getSymbolOfExpando(node, false);
            if ((_a2 = jsSymbol === null || jsSymbol === void 0 ? void 0 : jsSymbol.exports) === null || _a2 === void 0 ? void 0 : _a2.size) {
              var jsAssignmentType = createAnonymousType(jsSymbol, jsSymbol.exports, ts3.emptyArray, ts3.emptyArray, void 0, void 0);
              jsAssignmentType.objectFlags |= 8192;
              return getIntersectionType([returnType2, jsAssignmentType]);
            }
          }
          return returnType2;
        }
        function checkDeprecatedSignature(signature, node) {
          if (signature.declaration && signature.declaration.flags & 134217728) {
            var suggestionNode = getDeprecatedSuggestionNode(node);
            var name = ts3.tryGetPropertyAccessOrIdentifierToString(ts3.getInvokedExpression(node));
            addDeprecatedSuggestionWithSignature(suggestionNode, signature.declaration, name, signatureToString(signature));
          }
        }
        function getDeprecatedSuggestionNode(node) {
          node = ts3.skipParentheses(node);
          switch (node.kind) {
            case 204:
            case 162:
            case 205:
              return getDeprecatedSuggestionNode(node.expression);
            case 206:
              return getDeprecatedSuggestionNode(node.tag);
            case 276:
            case 275:
              return getDeprecatedSuggestionNode(node.tagName);
            case 203:
              return node.argumentExpression;
            case 202:
              return node.name;
            case 174:
              var typeReference = node;
              return ts3.isQualifiedName(typeReference.typeName) ? typeReference.typeName.right : typeReference;
            default:
              return node;
          }
        }
        function isSymbolOrSymbolForCall(node) {
          if (!ts3.isCallExpression(node))
            return false;
          var left = node.expression;
          if (ts3.isPropertyAccessExpression(left) && left.name.escapedText === "for") {
            left = left.expression;
          }
          if (!ts3.isIdentifier(left) || left.escapedText !== "Symbol") {
            return false;
          }
          var globalESSymbol = getGlobalESSymbolConstructorSymbol(false);
          if (!globalESSymbol) {
            return false;
          }
          return globalESSymbol === resolveName(left, "Symbol", 111551, void 0, void 0, false);
        }
        function checkImportCallExpression(node) {
          if (!checkGrammarArguments(node.arguments))
            checkGrammarImportCallExpression(node);
          if (node.arguments.length === 0) {
            return createPromiseReturnType(node, anyType);
          }
          var specifier = node.arguments[0];
          var specifierType = checkExpressionCached(specifier);
          for (var i3 = 1; i3 < node.arguments.length; ++i3) {
            checkExpressionCached(node.arguments[i3]);
          }
          if (specifierType.flags & 32768 || specifierType.flags & 65536 || !isTypeAssignableTo(specifierType, stringType)) {
            error(specifier, ts3.Diagnostics.Dynamic_import_s_specifier_must_be_of_type_string_but_here_has_type_0, typeToString(specifierType));
          }
          var moduleSymbol = resolveExternalModuleName(node, specifier);
          if (moduleSymbol) {
            var esModuleSymbol = resolveESModuleSymbol(moduleSymbol, specifier, true, false);
            if (esModuleSymbol) {
              return createPromiseReturnType(node, getTypeWithSyntheticDefaultImportType(getTypeOfSymbol(esModuleSymbol), esModuleSymbol, moduleSymbol));
            }
          }
          return createPromiseReturnType(node, anyType);
        }
        function getTypeWithSyntheticDefaultImportType(type3, symbol, originalSymbol) {
          var _a2;
          if (allowSyntheticDefaultImports && type3 && type3 !== errorType) {
            var synthType = type3;
            if (!synthType.syntheticType) {
              var file = (_a2 = originalSymbol.declarations) === null || _a2 === void 0 ? void 0 : _a2.find(ts3.isSourceFile);
              var hasSyntheticDefault = canHaveSyntheticDefault(file, originalSymbol, false);
              if (hasSyntheticDefault) {
                var memberTable = ts3.createSymbolTable();
                var newSymbol = createSymbol(2097152, "default");
                newSymbol.parent = originalSymbol;
                newSymbol.nameType = getLiteralType("default");
                newSymbol.target = resolveSymbol(symbol);
                memberTable.set("default", newSymbol);
                var anonymousSymbol = createSymbol(2048, "__type");
                var defaultContainingObject = createAnonymousType(anonymousSymbol, memberTable, ts3.emptyArray, ts3.emptyArray, void 0, void 0);
                anonymousSymbol.type = defaultContainingObject;
                synthType.syntheticType = isValidSpreadType(type3) ? getSpreadType(type3, defaultContainingObject, anonymousSymbol, 0, false) : defaultContainingObject;
              } else {
                synthType.syntheticType = type3;
              }
            }
            return synthType.syntheticType;
          }
          return type3;
        }
        function isCommonJsRequire(node) {
          if (!ts3.isRequireCall(node, true)) {
            return false;
          }
          if (!ts3.isIdentifier(node.expression))
            return ts3.Debug.fail();
          var resolvedRequire = resolveName(node.expression, node.expression.escapedText, 111551, void 0, void 0, true);
          if (resolvedRequire === requireSymbol) {
            return true;
          }
          if (resolvedRequire.flags & 2097152) {
            return false;
          }
          var targetDeclarationKind = resolvedRequire.flags & 16 ? 252 : resolvedRequire.flags & 3 ? 250 : 0;
          if (targetDeclarationKind !== 0) {
            var decl = ts3.getDeclarationOfKind(resolvedRequire, targetDeclarationKind);
            return !!decl && !!(decl.flags & 8388608);
          }
          return false;
        }
        function checkTaggedTemplateExpression(node) {
          if (!checkGrammarTaggedTemplateChain(node))
            checkGrammarTypeArguments(node, node.typeArguments);
          if (languageVersion < 2) {
            checkExternalEmitHelpers(node, 262144);
          }
          var signature = getResolvedSignature(node);
          checkDeprecatedSignature(signature, node);
          return getReturnTypeOfSignature(signature);
        }
        function checkAssertion(node) {
          return checkAssertionWorker(node, node.type, node.expression);
        }
        function isValidConstAssertionArgument(node) {
          switch (node.kind) {
            case 10:
            case 14:
            case 8:
            case 9:
            case 109:
            case 94:
            case 200:
            case 201:
            case 219:
              return true;
            case 208:
              return isValidConstAssertionArgument(node.expression);
            case 215:
              var op = node.operator;
              var arg2 = node.operand;
              return op === 40 && (arg2.kind === 8 || arg2.kind === 9) || op === 39 && arg2.kind === 8;
            case 202:
            case 203:
              var expr = node.expression;
              if (ts3.isIdentifier(expr)) {
                var symbol = getSymbolAtLocation(expr);
                if (symbol && symbol.flags & 2097152) {
                  symbol = resolveAlias(symbol);
                }
                return !!(symbol && symbol.flags & 384 && getEnumKind(symbol) === 1);
              }
          }
          return false;
        }
        function checkAssertionWorker(errNode, type3, expression, checkMode) {
          var exprType = checkExpression(expression, checkMode);
          if (ts3.isConstTypeReference(type3)) {
            if (!isValidConstAssertionArgument(expression)) {
              error(expression, ts3.Diagnostics.A_const_assertions_can_only_be_applied_to_references_to_enum_members_or_string_number_boolean_array_or_object_literals);
            }
            return getRegularTypeOfLiteralType(exprType);
          }
          checkSourceElement(type3);
          exprType = getRegularTypeOfObjectLiteral(getBaseTypeOfLiteralType(exprType));
          var targetType = getTypeFromTypeNode(type3);
          if (produceDiagnostics && targetType !== errorType) {
            var widenedType = getWidenedType(exprType);
            if (!isTypeComparableTo(targetType, widenedType)) {
              checkTypeComparableTo(exprType, targetType, errNode, ts3.Diagnostics.Conversion_of_type_0_to_type_1_may_be_a_mistake_because_neither_type_sufficiently_overlaps_with_the_other_If_this_was_intentional_convert_the_expression_to_unknown_first);
            }
          }
          return targetType;
        }
        function checkNonNullChain(node) {
          var leftType = checkExpression(node.expression);
          var nonOptionalType = getOptionalExpressionType(leftType, node.expression);
          return propagateOptionalTypeMarker(getNonNullableType(nonOptionalType), node, nonOptionalType !== leftType);
        }
        function checkNonNullAssertion(node) {
          return node.flags & 32 ? checkNonNullChain(node) : getNonNullableType(checkExpression(node.expression));
        }
        function checkMetaProperty(node) {
          checkGrammarMetaProperty(node);
          if (node.keywordToken === 102) {
            return checkNewTargetMetaProperty(node);
          }
          if (node.keywordToken === 99) {
            return checkImportMetaProperty(node);
          }
          return ts3.Debug.assertNever(node.keywordToken);
        }
        function checkNewTargetMetaProperty(node) {
          var container = ts3.getNewTargetContainer(node);
          if (!container) {
            error(node, ts3.Diagnostics.Meta_property_0_is_only_allowed_in_the_body_of_a_function_declaration_function_expression_or_constructor, "new.target");
            return errorType;
          } else if (container.kind === 167) {
            var symbol = getSymbolOfNode(container.parent);
            return getTypeOfSymbol(symbol);
          } else {
            var symbol = getSymbolOfNode(container);
            return getTypeOfSymbol(symbol);
          }
        }
        function checkImportMetaProperty(node) {
          if (moduleKind !== ts3.ModuleKind.ES2020 && moduleKind !== ts3.ModuleKind.ESNext && moduleKind !== ts3.ModuleKind.System) {
            error(node, ts3.Diagnostics.The_import_meta_meta_property_is_only_allowed_when_the_module_option_is_es2020_esnext_or_system);
          }
          var file = ts3.getSourceFileOfNode(node);
          ts3.Debug.assert(!!(file.flags & 2097152), "Containing file is missing import meta node flag.");
          ts3.Debug.assert(!!file.externalModuleIndicator, "Containing file should be a module.");
          return node.name.escapedText === "meta" ? getGlobalImportMetaType() : errorType;
        }
        function getTypeOfParameter(symbol) {
          var type3 = getTypeOfSymbol(symbol);
          if (strictNullChecks) {
            var declaration = symbol.valueDeclaration;
            if (declaration && ts3.hasInitializer(declaration)) {
              return getOptionalType(type3);
            }
          }
          return type3;
        }
        function getTupleElementLabel(d) {
          ts3.Debug.assert(ts3.isIdentifier(d.name));
          return d.name.escapedText;
        }
        function getParameterNameAtPosition(signature, pos, overrideRestType) {
          var paramCount = signature.parameters.length - (signatureHasRestParameter(signature) ? 1 : 0);
          if (pos < paramCount) {
            return signature.parameters[pos].escapedName;
          }
          var restParameter = signature.parameters[paramCount] || unknownSymbol;
          var restType = overrideRestType || getTypeOfSymbol(restParameter);
          if (isTupleType(restType)) {
            var associatedNames = restType.target.labeledElementDeclarations;
            var index = pos - paramCount;
            return associatedNames && getTupleElementLabel(associatedNames[index]) || restParameter.escapedName + "_" + index;
          }
          return restParameter.escapedName;
        }
        function isValidDeclarationForTupleLabel(d) {
          return d.kind === 193 || ts3.isParameter(d) && d.name && ts3.isIdentifier(d.name);
        }
        function getNameableDeclarationAtPosition(signature, pos) {
          var paramCount = signature.parameters.length - (signatureHasRestParameter(signature) ? 1 : 0);
          if (pos < paramCount) {
            var decl = signature.parameters[pos].valueDeclaration;
            return decl && isValidDeclarationForTupleLabel(decl) ? decl : void 0;
          }
          var restParameter = signature.parameters[paramCount] || unknownSymbol;
          var restType = getTypeOfSymbol(restParameter);
          if (isTupleType(restType)) {
            var associatedNames = restType.target.labeledElementDeclarations;
            var index = pos - paramCount;
            return associatedNames && associatedNames[index];
          }
          return restParameter.valueDeclaration && isValidDeclarationForTupleLabel(restParameter.valueDeclaration) ? restParameter.valueDeclaration : void 0;
        }
        function getTypeAtPosition(signature, pos) {
          return tryGetTypeAtPosition(signature, pos) || anyType;
        }
        function tryGetTypeAtPosition(signature, pos) {
          var paramCount = signature.parameters.length - (signatureHasRestParameter(signature) ? 1 : 0);
          if (pos < paramCount) {
            return getTypeOfParameter(signature.parameters[pos]);
          }
          if (signatureHasRestParameter(signature)) {
            var restType = getTypeOfSymbol(signature.parameters[paramCount]);
            var index = pos - paramCount;
            if (!isTupleType(restType) || restType.target.hasRestElement || index < restType.target.fixedLength) {
              return getIndexedAccessType(restType, getLiteralType(index));
            }
          }
          return void 0;
        }
        function getRestTypeAtPosition(source, pos) {
          var parameterCount = getParameterCount(source);
          var minArgumentCount = getMinArgumentCount(source);
          var restType = getEffectiveRestType(source);
          if (restType && pos >= parameterCount - 1) {
            return pos === parameterCount - 1 ? restType : createArrayType(getIndexedAccessType(restType, numberType));
          }
          var types2 = [];
          var flags = [];
          var names = [];
          for (var i3 = pos; i3 < parameterCount; i3++) {
            if (!restType || i3 < parameterCount - 1) {
              types2.push(getTypeAtPosition(source, i3));
              flags.push(i3 < minArgumentCount ? 1 : 2);
            } else {
              types2.push(restType);
              flags.push(8);
            }
            var name = getNameableDeclarationAtPosition(source, i3);
            if (name) {
              names.push(name);
            }
          }
          return createTupleType(types2, flags, false, ts3.length(names) === ts3.length(types2) ? names : void 0);
        }
        function getParameterCount(signature) {
          var length = signature.parameters.length;
          if (signatureHasRestParameter(signature)) {
            var restType = getTypeOfSymbol(signature.parameters[length - 1]);
            if (isTupleType(restType)) {
              return length + restType.target.fixedLength - (restType.target.hasRestElement ? 0 : 1);
            }
          }
          return length;
        }
        function getMinArgumentCount(signature, flags) {
          var strongArityForUntypedJS = flags & 1;
          var voidIsNonOptional = flags & 2;
          if (voidIsNonOptional || signature.resolvedMinArgumentCount === void 0) {
            var minArgumentCount = void 0;
            if (signatureHasRestParameter(signature)) {
              var restType = getTypeOfSymbol(signature.parameters[signature.parameters.length - 1]);
              if (isTupleType(restType)) {
                var firstOptionalIndex = ts3.findIndex(restType.target.elementFlags, function(f) {
                  return !(f & 1);
                });
                var requiredCount = firstOptionalIndex < 0 ? restType.target.fixedLength : firstOptionalIndex;
                if (requiredCount > 0) {
                  minArgumentCount = signature.parameters.length - 1 + requiredCount;
                }
              }
            }
            if (minArgumentCount === void 0) {
              if (!strongArityForUntypedJS && signature.flags & 32) {
                return 0;
              }
              minArgumentCount = signature.minArgumentCount;
            }
            if (voidIsNonOptional) {
              return minArgumentCount;
            }
            for (var i3 = minArgumentCount - 1; i3 >= 0; i3--) {
              var type3 = getTypeAtPosition(signature, i3);
              if (filterType(type3, acceptsVoid).flags & 131072) {
                break;
              }
              minArgumentCount = i3;
            }
            signature.resolvedMinArgumentCount = minArgumentCount;
          }
          return signature.resolvedMinArgumentCount;
        }
        function hasEffectiveRestParameter(signature) {
          if (signatureHasRestParameter(signature)) {
            var restType = getTypeOfSymbol(signature.parameters[signature.parameters.length - 1]);
            return !isTupleType(restType) || restType.target.hasRestElement;
          }
          return false;
        }
        function getEffectiveRestType(signature) {
          if (signatureHasRestParameter(signature)) {
            var restType = getTypeOfSymbol(signature.parameters[signature.parameters.length - 1]);
            if (!isTupleType(restType)) {
              return restType;
            }
            if (restType.target.hasRestElement) {
              return sliceTupleType(restType, restType.target.fixedLength);
            }
          }
          return void 0;
        }
        function getNonArrayRestType(signature) {
          var restType = getEffectiveRestType(signature);
          return restType && !isArrayType(restType) && !isTypeAny(restType) && (getReducedType(restType).flags & 131072) === 0 ? restType : void 0;
        }
        function getTypeOfFirstParameterOfSignature(signature) {
          return getTypeOfFirstParameterOfSignatureWithFallback(signature, neverType);
        }
        function getTypeOfFirstParameterOfSignatureWithFallback(signature, fallbackType) {
          return signature.parameters.length > 0 ? getTypeAtPosition(signature, 0) : fallbackType;
        }
        function inferFromAnnotatedParameters(signature, context, inferenceContext) {
          var len = signature.parameters.length - (signatureHasRestParameter(signature) ? 1 : 0);
          for (var i3 = 0; i3 < len; i3++) {
            var declaration = signature.parameters[i3].valueDeclaration;
            if (declaration.type) {
              var typeNode = ts3.getEffectiveTypeAnnotationNode(declaration);
              if (typeNode) {
                inferTypes(inferenceContext.inferences, getTypeFromTypeNode(typeNode), getTypeAtPosition(context, i3));
              }
            }
          }
          var restType = getEffectiveRestType(context);
          if (restType && restType.flags & 262144) {
            var instantiatedContext = instantiateSignature(context, inferenceContext.nonFixingMapper);
            assignContextualParameterTypes(signature, instantiatedContext);
            var restPos = getParameterCount(context) - 1;
            inferTypes(inferenceContext.inferences, getRestTypeAtPosition(signature, restPos), restType);
          }
        }
        function assignContextualParameterTypes(signature, context) {
          if (context.typeParameters) {
            if (!signature.typeParameters) {
              signature.typeParameters = context.typeParameters;
            } else {
              return;
            }
          }
          if (context.thisParameter) {
            var parameter = signature.thisParameter;
            if (!parameter || parameter.valueDeclaration && !parameter.valueDeclaration.type) {
              if (!parameter) {
                signature.thisParameter = createSymbolWithType(context.thisParameter, void 0);
              }
              assignParameterType(signature.thisParameter, getTypeOfSymbol(context.thisParameter));
            }
          }
          var len = signature.parameters.length - (signatureHasRestParameter(signature) ? 1 : 0);
          for (var i3 = 0; i3 < len; i3++) {
            var parameter = signature.parameters[i3];
            if (!ts3.getEffectiveTypeAnnotationNode(parameter.valueDeclaration)) {
              var contextualParameterType = tryGetTypeAtPosition(context, i3);
              assignParameterType(parameter, contextualParameterType);
            }
          }
          if (signatureHasRestParameter(signature)) {
            var parameter = ts3.last(signature.parameters);
            if (ts3.isTransientSymbol(parameter) || !ts3.getEffectiveTypeAnnotationNode(parameter.valueDeclaration)) {
              var contextualParameterType = getRestTypeAtPosition(context, len);
              assignParameterType(parameter, contextualParameterType);
            }
          }
        }
        function assignNonContextualParameterTypes(signature) {
          if (signature.thisParameter) {
            assignParameterType(signature.thisParameter);
          }
          for (var _i = 0, _a2 = signature.parameters; _i < _a2.length; _i++) {
            var parameter = _a2[_i];
            assignParameterType(parameter);
          }
        }
        function assignParameterType(parameter, type3) {
          var links = getSymbolLinks(parameter);
          if (!links.type) {
            var declaration = parameter.valueDeclaration;
            links.type = type3 || getWidenedTypeForVariableLikeDeclaration(declaration, true);
            if (declaration.name.kind !== 78) {
              if (links.type === unknownType) {
                links.type = getTypeFromBindingPattern(declaration.name);
              }
              assignBindingElementTypes(declaration.name);
            }
          }
        }
        function assignBindingElementTypes(pattern) {
          for (var _i = 0, _a2 = pattern.elements; _i < _a2.length; _i++) {
            var element = _a2[_i];
            if (!ts3.isOmittedExpression(element)) {
              if (element.name.kind === 78) {
                getSymbolLinks(getSymbolOfNode(element)).type = getTypeForBindingElement(element);
              } else {
                assignBindingElementTypes(element.name);
              }
            }
          }
        }
        function createPromiseType(promisedType) {
          var globalPromiseType = getGlobalPromiseType(true);
          if (globalPromiseType !== emptyGenericType) {
            promisedType = getAwaitedType(promisedType) || unknownType;
            return createTypeReference(globalPromiseType, [promisedType]);
          }
          return unknownType;
        }
        function createPromiseLikeType(promisedType) {
          var globalPromiseLikeType = getGlobalPromiseLikeType(true);
          if (globalPromiseLikeType !== emptyGenericType) {
            promisedType = getAwaitedType(promisedType) || unknownType;
            return createTypeReference(globalPromiseLikeType, [promisedType]);
          }
          return unknownType;
        }
        function createPromiseReturnType(func2, promisedType) {
          var promiseType = createPromiseType(promisedType);
          if (promiseType === unknownType) {
            error(func2, ts3.isImportCall(func2) ? ts3.Diagnostics.A_dynamic_import_call_returns_a_Promise_Make_sure_you_have_a_declaration_for_Promise_or_include_ES2015_in_your_lib_option : ts3.Diagnostics.An_async_function_or_method_must_return_a_Promise_Make_sure_you_have_a_declaration_for_Promise_or_include_ES2015_in_your_lib_option);
            return errorType;
          } else if (!getGlobalPromiseConstructorSymbol(true)) {
            error(func2, ts3.isImportCall(func2) ? ts3.Diagnostics.A_dynamic_import_call_in_ES5_SlashES3_requires_the_Promise_constructor_Make_sure_you_have_a_declaration_for_the_Promise_constructor_or_include_ES2015_in_your_lib_option : ts3.Diagnostics.An_async_function_or_method_in_ES5_SlashES3_requires_the_Promise_constructor_Make_sure_you_have_a_declaration_for_the_Promise_constructor_or_include_ES2015_in_your_lib_option);
          }
          return promiseType;
        }
        function getReturnTypeFromBody(func2, checkMode) {
          if (!func2.body) {
            return errorType;
          }
          var functionFlags = ts3.getFunctionFlags(func2);
          var isAsync = (functionFlags & 2) !== 0;
          var isGenerator = (functionFlags & 1) !== 0;
          var returnType2;
          var yieldType;
          var nextType;
          var fallbackReturnType = voidType;
          if (func2.body.kind !== 231) {
            returnType2 = checkExpressionCached(func2.body, checkMode && checkMode & ~8);
            if (isAsync) {
              returnType2 = checkAwaitedType(returnType2, func2, ts3.Diagnostics.The_return_type_of_an_async_function_must_either_be_a_valid_promise_or_must_not_contain_a_callable_then_member);
            }
          } else if (isGenerator) {
            var returnTypes = checkAndAggregateReturnExpressionTypes(func2, checkMode);
            if (!returnTypes) {
              fallbackReturnType = neverType;
            } else if (returnTypes.length > 0) {
              returnType2 = getUnionType(returnTypes, 2);
            }
            var _a2 = checkAndAggregateYieldOperandTypes(func2, checkMode), yieldTypes = _a2.yieldTypes, nextTypes = _a2.nextTypes;
            yieldType = ts3.some(yieldTypes) ? getUnionType(yieldTypes, 2) : void 0;
            nextType = ts3.some(nextTypes) ? getIntersectionType(nextTypes) : void 0;
          } else {
            var types2 = checkAndAggregateReturnExpressionTypes(func2, checkMode);
            if (!types2) {
              return functionFlags & 2 ? createPromiseReturnType(func2, neverType) : neverType;
            }
            if (types2.length === 0) {
              return functionFlags & 2 ? createPromiseReturnType(func2, voidType) : voidType;
            }
            returnType2 = getUnionType(types2, 2);
          }
          if (returnType2 || yieldType || nextType) {
            if (yieldType)
              reportErrorsFromWidening(func2, yieldType, 3);
            if (returnType2)
              reportErrorsFromWidening(func2, returnType2, 1);
            if (nextType)
              reportErrorsFromWidening(func2, nextType, 2);
            if (returnType2 && isUnitType(returnType2) || yieldType && isUnitType(yieldType) || nextType && isUnitType(nextType)) {
              var contextualSignature = getContextualSignatureForFunctionLikeDeclaration(func2);
              var contextualType = !contextualSignature ? void 0 : contextualSignature === getSignatureFromDeclaration(func2) ? isGenerator ? void 0 : returnType2 : instantiateContextualType(getReturnTypeOfSignature(contextualSignature), func2);
              if (isGenerator) {
                yieldType = getWidenedLiteralLikeTypeForContextualIterationTypeIfNeeded(yieldType, contextualType, 0, isAsync);
                returnType2 = getWidenedLiteralLikeTypeForContextualIterationTypeIfNeeded(returnType2, contextualType, 1, isAsync);
                nextType = getWidenedLiteralLikeTypeForContextualIterationTypeIfNeeded(nextType, contextualType, 2, isAsync);
              } else {
                returnType2 = getWidenedLiteralLikeTypeForContextualReturnTypeIfNeeded(returnType2, contextualType, isAsync);
              }
            }
            if (yieldType)
              yieldType = getWidenedType(yieldType);
            if (returnType2)
              returnType2 = getWidenedType(returnType2);
            if (nextType)
              nextType = getWidenedType(nextType);
          }
          if (isGenerator) {
            return createGeneratorReturnType(yieldType || neverType, returnType2 || fallbackReturnType, nextType || getContextualIterationType(2, func2) || unknownType, isAsync);
          } else {
            return isAsync ? createPromiseType(returnType2 || fallbackReturnType) : returnType2 || fallbackReturnType;
          }
        }
        function createGeneratorReturnType(yieldType, returnType2, nextType, isAsyncGenerator) {
          var resolver = isAsyncGenerator ? asyncIterationTypesResolver : syncIterationTypesResolver;
          var globalGeneratorType = resolver.getGlobalGeneratorType(false);
          yieldType = resolver.resolveIterationType(yieldType, void 0) || unknownType;
          returnType2 = resolver.resolveIterationType(returnType2, void 0) || unknownType;
          nextType = resolver.resolveIterationType(nextType, void 0) || unknownType;
          if (globalGeneratorType === emptyGenericType) {
            var globalType = resolver.getGlobalIterableIteratorType(false);
            var iterationTypes = globalType !== emptyGenericType ? getIterationTypesOfGlobalIterableType(globalType, resolver) : void 0;
            var iterableIteratorReturnType = iterationTypes ? iterationTypes.returnType : anyType;
            var iterableIteratorNextType = iterationTypes ? iterationTypes.nextType : undefinedType;
            if (isTypeAssignableTo(returnType2, iterableIteratorReturnType) && isTypeAssignableTo(iterableIteratorNextType, nextType)) {
              if (globalType !== emptyGenericType) {
                return createTypeFromGenericGlobalType(globalType, [yieldType]);
              }
              resolver.getGlobalIterableIteratorType(true);
              return emptyObjectType;
            }
            resolver.getGlobalGeneratorType(true);
            return emptyObjectType;
          }
          return createTypeFromGenericGlobalType(globalGeneratorType, [yieldType, returnType2, nextType]);
        }
        function checkAndAggregateYieldOperandTypes(func2, checkMode) {
          var yieldTypes = [];
          var nextTypes = [];
          var isAsync = (ts3.getFunctionFlags(func2) & 2) !== 0;
          ts3.forEachYieldExpression(func2.body, function(yieldExpression) {
            var yieldExpressionType = yieldExpression.expression ? checkExpression(yieldExpression.expression, checkMode) : undefinedWideningType;
            ts3.pushIfUnique(yieldTypes, getYieldedTypeOfYieldExpression(yieldExpression, yieldExpressionType, anyType, isAsync));
            var nextType;
            if (yieldExpression.asteriskToken) {
              var iterationTypes = getIterationTypesOfIterable(yieldExpressionType, isAsync ? 19 : 17, yieldExpression.expression);
              nextType = iterationTypes && iterationTypes.nextType;
            } else {
              nextType = getContextualType(yieldExpression);
            }
            if (nextType)
              ts3.pushIfUnique(nextTypes, nextType);
          });
          return { yieldTypes, nextTypes };
        }
        function getYieldedTypeOfYieldExpression(node, expressionType, sentType, isAsync) {
          var errorNode = node.expression || node;
          var yieldedType = node.asteriskToken ? checkIteratedTypeOrElementType(isAsync ? 19 : 17, expressionType, sentType, errorNode) : expressionType;
          return !isAsync ? yieldedType : getAwaitedType(yieldedType, errorNode, node.asteriskToken ? ts3.Diagnostics.Type_of_iterated_elements_of_a_yield_Asterisk_operand_must_either_be_a_valid_promise_or_must_not_contain_a_callable_then_member : ts3.Diagnostics.Type_of_yield_operand_in_an_async_generator_must_either_be_a_valid_promise_or_must_not_contain_a_callable_then_member);
        }
        function getFactsFromTypeofSwitch(start, end, witnesses, hasDefault) {
          var facts = 0;
          if (hasDefault) {
            for (var i3 = end; i3 < witnesses.length; i3++) {
              facts |= typeofNEFacts.get(witnesses[i3]) || 32768;
            }
            for (var i3 = start; i3 < end; i3++) {
              facts &= ~(typeofNEFacts.get(witnesses[i3]) || 0);
            }
            for (var i3 = 0; i3 < start; i3++) {
              facts |= typeofNEFacts.get(witnesses[i3]) || 32768;
            }
          } else {
            for (var i3 = start; i3 < end; i3++) {
              facts |= typeofEQFacts.get(witnesses[i3]) || 128;
            }
            for (var i3 = 0; i3 < start; i3++) {
              facts &= ~(typeofEQFacts.get(witnesses[i3]) || 0);
            }
          }
          return facts;
        }
        function isExhaustiveSwitchStatement(node) {
          var links = getNodeLinks(node);
          return links.isExhaustive !== void 0 ? links.isExhaustive : links.isExhaustive = computeExhaustiveSwitchStatement(node);
        }
        function computeExhaustiveSwitchStatement(node) {
          if (node.expression.kind === 212) {
            var operandType = getTypeOfExpression(node.expression.expression);
            var witnesses = getSwitchClauseTypeOfWitnesses(node, false);
            var notEqualFacts_1 = getFactsFromTypeofSwitch(0, 0, witnesses, true);
            var type_4 = getBaseConstraintOfType(operandType) || operandType;
            if (type_4.flags & 3) {
              return (556800 & notEqualFacts_1) === 556800;
            }
            return !!(filterType(type_4, function(t2) {
              return (getTypeFacts(t2) & notEqualFacts_1) === notEqualFacts_1;
            }).flags & 131072);
          }
          var type3 = getTypeOfExpression(node.expression);
          if (!isLiteralType(type3)) {
            return false;
          }
          var switchTypes = getSwitchClauseTypes(node);
          if (!switchTypes.length || ts3.some(switchTypes, isNeitherUnitTypeNorNever)) {
            return false;
          }
          return eachTypeContainedIn(mapType(type3, getRegularTypeOfLiteralType), switchTypes);
        }
        function functionHasImplicitReturn(func2) {
          return func2.endFlowNode && isReachableFlowNode(func2.endFlowNode);
        }
        function checkAndAggregateReturnExpressionTypes(func2, checkMode) {
          var functionFlags = ts3.getFunctionFlags(func2);
          var aggregatedTypes = [];
          var hasReturnWithNoExpression = functionHasImplicitReturn(func2);
          var hasReturnOfTypeNever = false;
          ts3.forEachReturnStatement(func2.body, function(returnStatement) {
            var expr = returnStatement.expression;
            if (expr) {
              var type3 = checkExpressionCached(expr, checkMode && checkMode & ~8);
              if (functionFlags & 2) {
                type3 = checkAwaitedType(type3, func2, ts3.Diagnostics.The_return_type_of_an_async_function_must_either_be_a_valid_promise_or_must_not_contain_a_callable_then_member);
              }
              if (type3.flags & 131072) {
                hasReturnOfTypeNever = true;
              }
              ts3.pushIfUnique(aggregatedTypes, type3);
            } else {
              hasReturnWithNoExpression = true;
            }
          });
          if (aggregatedTypes.length === 0 && !hasReturnWithNoExpression && (hasReturnOfTypeNever || mayReturnNever(func2))) {
            return void 0;
          }
          if (strictNullChecks && aggregatedTypes.length && hasReturnWithNoExpression && !(isJSConstructor(func2) && aggregatedTypes.some(function(t2) {
            return t2.symbol === func2.symbol;
          }))) {
            ts3.pushIfUnique(aggregatedTypes, undefinedType);
          }
          return aggregatedTypes;
        }
        function mayReturnNever(func2) {
          switch (func2.kind) {
            case 209:
            case 210:
              return true;
            case 166:
              return func2.parent.kind === 201;
            default:
              return false;
          }
        }
        function checkAllCodePathsInNonVoidFunctionReturnOrThrow(func2, returnType2) {
          if (!produceDiagnostics) {
            return;
          }
          var functionFlags = ts3.getFunctionFlags(func2);
          var type3 = returnType2 && unwrapReturnType(returnType2, functionFlags);
          if (type3 && maybeTypeOfKind(type3, 1 | 16384)) {
            return;
          }
          if (func2.kind === 165 || ts3.nodeIsMissing(func2.body) || func2.body.kind !== 231 || !functionHasImplicitReturn(func2)) {
            return;
          }
          var hasExplicitReturn = func2.flags & 512;
          var errorNode = ts3.getEffectiveReturnTypeNode(func2) || func2;
          if (type3 && type3.flags & 131072) {
            error(errorNode, ts3.Diagnostics.A_function_returning_never_cannot_have_a_reachable_end_point);
          } else if (type3 && !hasExplicitReturn) {
            error(errorNode, ts3.Diagnostics.A_function_whose_declared_type_is_neither_void_nor_any_must_return_a_value);
          } else if (type3 && strictNullChecks && !isTypeAssignableTo(undefinedType, type3)) {
            error(errorNode, ts3.Diagnostics.Function_lacks_ending_return_statement_and_return_type_does_not_include_undefined);
          } else if (compilerOptions.noImplicitReturns) {
            if (!type3) {
              if (!hasExplicitReturn) {
                return;
              }
              var inferredReturnType = getReturnTypeOfSignature(getSignatureFromDeclaration(func2));
              if (isUnwrappedReturnTypeVoidOrAny(func2, inferredReturnType)) {
                return;
              }
            }
            error(errorNode, ts3.Diagnostics.Not_all_code_paths_return_a_value);
          }
        }
        function checkFunctionExpressionOrObjectLiteralMethod(node, checkMode) {
          ts3.Debug.assert(node.kind !== 166 || ts3.isObjectLiteralMethod(node));
          checkNodeDeferred(node);
          if (checkMode && checkMode & 4 && isContextSensitive(node)) {
            if (!ts3.getEffectiveReturnTypeNode(node) && !hasContextSensitiveParameters(node)) {
              var contextualSignature = getContextualSignature(node);
              if (contextualSignature && couldContainTypeVariables(getReturnTypeOfSignature(contextualSignature))) {
                var links = getNodeLinks(node);
                if (links.contextFreeType) {
                  return links.contextFreeType;
                }
                var returnType2 = getReturnTypeFromBody(node, checkMode);
                var returnOnlySignature = createSignature(void 0, void 0, void 0, ts3.emptyArray, returnType2, void 0, 0, 0);
                var returnOnlyType = createAnonymousType(node.symbol, emptySymbols, [returnOnlySignature], ts3.emptyArray, void 0, void 0);
                returnOnlyType.objectFlags |= 524288;
                return links.contextFreeType = returnOnlyType;
              }
            }
            return anyFunctionType;
          }
          var hasGrammarError = checkGrammarFunctionLikeDeclaration(node);
          if (!hasGrammarError && node.kind === 209) {
            checkGrammarForGenerator(node);
          }
          contextuallyCheckFunctionExpressionOrObjectLiteralMethod(node, checkMode);
          return getTypeOfSymbol(getSymbolOfNode(node));
        }
        function contextuallyCheckFunctionExpressionOrObjectLiteralMethod(node, checkMode) {
          var links = getNodeLinks(node);
          if (!(links.flags & 1024)) {
            var contextualSignature = getContextualSignature(node);
            if (!(links.flags & 1024)) {
              links.flags |= 1024;
              var signature = ts3.firstOrUndefined(getSignaturesOfType(getTypeOfSymbol(getSymbolOfNode(node)), 0));
              if (!signature) {
                return;
              }
              if (isContextSensitive(node)) {
                if (contextualSignature) {
                  var inferenceContext = getInferenceContext(node);
                  if (checkMode && checkMode & 2) {
                    inferFromAnnotatedParameters(signature, contextualSignature, inferenceContext);
                  }
                  var instantiatedContextualSignature = inferenceContext ? instantiateSignature(contextualSignature, inferenceContext.mapper) : contextualSignature;
                  assignContextualParameterTypes(signature, instantiatedContextualSignature);
                } else {
                  assignNonContextualParameterTypes(signature);
                }
              }
              if (contextualSignature && !getReturnTypeFromAnnotation(node) && !signature.resolvedReturnType) {
                var returnType2 = getReturnTypeFromBody(node, checkMode);
                if (!signature.resolvedReturnType) {
                  signature.resolvedReturnType = returnType2;
                }
              }
              checkSignatureDeclaration(node);
            }
          }
        }
        function checkFunctionExpressionOrObjectLiteralMethodDeferred(node) {
          ts3.Debug.assert(node.kind !== 166 || ts3.isObjectLiteralMethod(node));
          var functionFlags = ts3.getFunctionFlags(node);
          var returnType2 = getReturnTypeFromAnnotation(node);
          checkAllCodePathsInNonVoidFunctionReturnOrThrow(node, returnType2);
          if (node.body) {
            if (!ts3.getEffectiveReturnTypeNode(node)) {
              getReturnTypeOfSignature(getSignatureFromDeclaration(node));
            }
            if (node.body.kind === 231) {
              checkSourceElement(node.body);
            } else {
              var exprType = checkExpression(node.body);
              var returnOrPromisedType = returnType2 && unwrapReturnType(returnType2, functionFlags);
              if (returnOrPromisedType) {
                if ((functionFlags & 3) === 2) {
                  var awaitedType = checkAwaitedType(exprType, node.body, ts3.Diagnostics.The_return_type_of_an_async_function_must_either_be_a_valid_promise_or_must_not_contain_a_callable_then_member);
                  checkTypeAssignableToAndOptionallyElaborate(awaitedType, returnOrPromisedType, node.body, node.body);
                } else {
                  checkTypeAssignableToAndOptionallyElaborate(exprType, returnOrPromisedType, node.body, node.body);
                }
              }
            }
          }
        }
        function checkArithmeticOperandType(operand, type3, diagnostic, isAwaitValid) {
          if (isAwaitValid === void 0) {
            isAwaitValid = false;
          }
          if (!isTypeAssignableTo(type3, numberOrBigIntType)) {
            var awaitedType = isAwaitValid && getAwaitedTypeOfPromise(type3);
            errorAndMaybeSuggestAwait(operand, !!awaitedType && isTypeAssignableTo(awaitedType, numberOrBigIntType), diagnostic);
            return false;
          }
          return true;
        }
        function isReadonlyAssignmentDeclaration(d) {
          if (!ts3.isCallExpression(d)) {
            return false;
          }
          if (!ts3.isBindableObjectDefinePropertyCall(d)) {
            return false;
          }
          var objectLitType = checkExpressionCached(d.arguments[2]);
          var valueType = getTypeOfPropertyOfType(objectLitType, "value");
          if (valueType) {
            var writableProp = getPropertyOfType(objectLitType, "writable");
            var writableType = writableProp && getTypeOfSymbol(writableProp);
            if (!writableType || writableType === falseType || writableType === regularFalseType) {
              return true;
            }
            if (writableProp && writableProp.valueDeclaration && ts3.isPropertyAssignment(writableProp.valueDeclaration)) {
              var initializer = writableProp.valueDeclaration.initializer;
              var rawOriginalType = checkExpression(initializer);
              if (rawOriginalType === falseType || rawOriginalType === regularFalseType) {
                return true;
              }
            }
            return false;
          }
          var setProp = getPropertyOfType(objectLitType, "set");
          return !setProp;
        }
        function isReadonlySymbol(symbol) {
          return !!(ts3.getCheckFlags(symbol) & 8 || symbol.flags & 4 && ts3.getDeclarationModifierFlagsFromSymbol(symbol) & 64 || symbol.flags & 3 && getDeclarationNodeFlagsFromSymbol(symbol) & 2 || symbol.flags & 98304 && !(symbol.flags & 65536) || symbol.flags & 8 || ts3.some(symbol.declarations, isReadonlyAssignmentDeclaration));
        }
        function isAssignmentToReadonlyEntity(expr, symbol, assignmentKind) {
          var _a2, _b;
          if (assignmentKind === 0) {
            return false;
          }
          if (isReadonlySymbol(symbol)) {
            if (symbol.flags & 4 && ts3.isAccessExpression(expr) && expr.expression.kind === 107) {
              var ctor = ts3.getContainingFunction(expr);
              if (!(ctor && (ctor.kind === 167 || isJSConstructor(ctor)))) {
                return true;
              }
              if (symbol.valueDeclaration) {
                var isAssignmentDeclaration_1 = ts3.isBinaryExpression(symbol.valueDeclaration);
                var isLocalPropertyDeclaration = ctor.parent === symbol.valueDeclaration.parent;
                var isLocalParameterProperty = ctor === symbol.valueDeclaration.parent;
                var isLocalThisPropertyAssignment = isAssignmentDeclaration_1 && ((_a2 = symbol.parent) === null || _a2 === void 0 ? void 0 : _a2.valueDeclaration) === ctor.parent;
                var isLocalThisPropertyAssignmentConstructorFunction = isAssignmentDeclaration_1 && ((_b = symbol.parent) === null || _b === void 0 ? void 0 : _b.valueDeclaration) === ctor;
                var isWriteableSymbol = isLocalPropertyDeclaration || isLocalParameterProperty || isLocalThisPropertyAssignment || isLocalThisPropertyAssignmentConstructorFunction;
                return !isWriteableSymbol;
              }
            }
            return true;
          }
          if (ts3.isAccessExpression(expr)) {
            var node = ts3.skipParentheses(expr.expression);
            if (node.kind === 78) {
              var symbol_2 = getNodeLinks(node).resolvedSymbol;
              if (symbol_2.flags & 2097152) {
                var declaration = getDeclarationOfAliasSymbol(symbol_2);
                return !!declaration && declaration.kind === 264;
              }
            }
          }
          return false;
        }
        function checkReferenceExpression(expr, invalidReferenceMessage, invalidOptionalChainMessage) {
          var node = ts3.skipOuterExpressions(expr, 6 | 1);
          if (node.kind !== 78 && !ts3.isAccessExpression(node)) {
            error(expr, invalidReferenceMessage);
            return false;
          }
          if (node.flags & 32) {
            error(expr, invalidOptionalChainMessage);
            return false;
          }
          return true;
        }
        function checkDeleteExpression(node) {
          checkExpression(node.expression);
          var expr = ts3.skipParentheses(node.expression);
          if (!ts3.isAccessExpression(expr)) {
            error(expr, ts3.Diagnostics.The_operand_of_a_delete_operator_must_be_a_property_reference);
            return booleanType;
          }
          if (ts3.isPropertyAccessExpression(expr) && ts3.isPrivateIdentifier(expr.name)) {
            error(expr, ts3.Diagnostics.The_operand_of_a_delete_operator_cannot_be_a_private_identifier);
          }
          var links = getNodeLinks(expr);
          var symbol = getExportSymbolOfValueSymbolIfExported(links.resolvedSymbol);
          if (symbol) {
            if (isReadonlySymbol(symbol)) {
              error(expr, ts3.Diagnostics.The_operand_of_a_delete_operator_cannot_be_a_read_only_property);
            }
            checkDeleteExpressionMustBeOptional(expr, getTypeOfSymbol(symbol));
          }
          return booleanType;
        }
        function checkDeleteExpressionMustBeOptional(expr, type3) {
          var AnyOrUnknownOrNeverFlags = 3 | 131072;
          if (strictNullChecks && !(type3.flags & AnyOrUnknownOrNeverFlags) && !(getFalsyFlags(type3) & 32768)) {
            error(expr, ts3.Diagnostics.The_operand_of_a_delete_operator_must_be_optional);
          }
        }
        function checkTypeOfExpression(node) {
          checkExpression(node.expression);
          return typeofType;
        }
        function checkVoidExpression(node) {
          checkExpression(node.expression);
          return undefinedWideningType;
        }
        function checkAwaitExpression(node) {
          if (produceDiagnostics) {
            if (!(node.flags & 32768)) {
              if (ts3.isInTopLevelContext(node)) {
                var sourceFile = ts3.getSourceFileOfNode(node);
                if (!hasParseDiagnostics(sourceFile)) {
                  var span = void 0;
                  if (!ts3.isEffectiveExternalModule(sourceFile, compilerOptions)) {
                    if (!span)
                      span = ts3.getSpanOfTokenAtPosition(sourceFile, node.pos);
                    var diagnostic = ts3.createFileDiagnostic(sourceFile, span.start, span.length, ts3.Diagnostics.await_expressions_are_only_allowed_at_the_top_level_of_a_file_when_that_file_is_a_module_but_this_file_has_no_imports_or_exports_Consider_adding_an_empty_export_to_make_this_file_a_module);
                    diagnostics.add(diagnostic);
                  }
                  if (moduleKind !== ts3.ModuleKind.ESNext && moduleKind !== ts3.ModuleKind.System || languageVersion < 4) {
                    span = ts3.getSpanOfTokenAtPosition(sourceFile, node.pos);
                    var diagnostic = ts3.createFileDiagnostic(sourceFile, span.start, span.length, ts3.Diagnostics.Top_level_await_expressions_are_only_allowed_when_the_module_option_is_set_to_esnext_or_system_and_the_target_option_is_set_to_es2017_or_higher);
                    diagnostics.add(diagnostic);
                  }
                }
              } else {
                var sourceFile = ts3.getSourceFileOfNode(node);
                if (!hasParseDiagnostics(sourceFile)) {
                  var span = ts3.getSpanOfTokenAtPosition(sourceFile, node.pos);
                  var diagnostic = ts3.createFileDiagnostic(sourceFile, span.start, span.length, ts3.Diagnostics.await_expressions_are_only_allowed_within_async_functions_and_at_the_top_levels_of_modules);
                  var func2 = ts3.getContainingFunction(node);
                  if (func2 && func2.kind !== 167 && (ts3.getFunctionFlags(func2) & 2) === 0) {
                    var relatedInfo = ts3.createDiagnosticForNode(func2, ts3.Diagnostics.Did_you_mean_to_mark_this_function_as_async);
                    ts3.addRelatedInfo(diagnostic, relatedInfo);
                  }
                  diagnostics.add(diagnostic);
                }
              }
            }
            if (isInParameterInitializerBeforeContainingFunction(node)) {
              error(node, ts3.Diagnostics.await_expressions_cannot_be_used_in_a_parameter_initializer);
            }
          }
          var operandType = checkExpression(node.expression);
          var awaitedType = checkAwaitedType(operandType, node, ts3.Diagnostics.Type_of_await_operand_must_either_be_a_valid_promise_or_must_not_contain_a_callable_then_member);
          if (awaitedType === operandType && awaitedType !== errorType && !(operandType.flags & 3)) {
            addErrorOrSuggestion(false, ts3.createDiagnosticForNode(node, ts3.Diagnostics.await_has_no_effect_on_the_type_of_this_expression));
          }
          return awaitedType;
        }
        function checkPrefixUnaryExpression(node) {
          var operandType = checkExpression(node.operand);
          if (operandType === silentNeverType) {
            return silentNeverType;
          }
          switch (node.operand.kind) {
            case 8:
              switch (node.operator) {
                case 40:
                  return getFreshTypeOfLiteralType(getLiteralType(-node.operand.text));
                case 39:
                  return getFreshTypeOfLiteralType(getLiteralType(+node.operand.text));
              }
              break;
            case 9:
              if (node.operator === 40) {
                return getFreshTypeOfLiteralType(getLiteralType({
                  negative: true,
                  base10Value: ts3.parsePseudoBigInt(node.operand.text)
                }));
              }
          }
          switch (node.operator) {
            case 39:
            case 40:
            case 54:
              checkNonNullType(operandType, node.operand);
              if (maybeTypeOfKind(operandType, 12288)) {
                error(node.operand, ts3.Diagnostics.The_0_operator_cannot_be_applied_to_type_symbol, ts3.tokenToString(node.operator));
              }
              if (node.operator === 39) {
                if (maybeTypeOfKind(operandType, 2112)) {
                  error(node.operand, ts3.Diagnostics.Operator_0_cannot_be_applied_to_type_1, ts3.tokenToString(node.operator), typeToString(getBaseTypeOfLiteralType(operandType)));
                }
                return numberType;
              }
              return getUnaryResultType(operandType);
            case 53:
              checkTruthinessExpression(node.operand);
              var facts = getTypeFacts(operandType) & (4194304 | 8388608);
              return facts === 4194304 ? falseType : facts === 8388608 ? trueType : booleanType;
            case 45:
            case 46:
              var ok = checkArithmeticOperandType(node.operand, checkNonNullType(operandType, node.operand), ts3.Diagnostics.An_arithmetic_operand_must_be_of_type_any_number_bigint_or_an_enum_type);
              if (ok) {
                checkReferenceExpression(node.operand, ts3.Diagnostics.The_operand_of_an_increment_or_decrement_operator_must_be_a_variable_or_a_property_access, ts3.Diagnostics.The_operand_of_an_increment_or_decrement_operator_may_not_be_an_optional_property_access);
              }
              return getUnaryResultType(operandType);
          }
          return errorType;
        }
        function checkPostfixUnaryExpression(node) {
          var operandType = checkExpression(node.operand);
          if (operandType === silentNeverType) {
            return silentNeverType;
          }
          var ok = checkArithmeticOperandType(node.operand, checkNonNullType(operandType, node.operand), ts3.Diagnostics.An_arithmetic_operand_must_be_of_type_any_number_bigint_or_an_enum_type);
          if (ok) {
            checkReferenceExpression(node.operand, ts3.Diagnostics.The_operand_of_an_increment_or_decrement_operator_must_be_a_variable_or_a_property_access, ts3.Diagnostics.The_operand_of_an_increment_or_decrement_operator_may_not_be_an_optional_property_access);
          }
          return getUnaryResultType(operandType);
        }
        function getUnaryResultType(operandType) {
          if (maybeTypeOfKind(operandType, 2112)) {
            return isTypeAssignableToKind(operandType, 3) || maybeTypeOfKind(operandType, 296) ? numberOrBigIntType : bigintType;
          }
          return numberType;
        }
        function maybeTypeOfKind(type3, kind) {
          if (type3.flags & kind) {
            return true;
          }
          if (type3.flags & 3145728) {
            var types2 = type3.types;
            for (var _i = 0, types_22 = types2; _i < types_22.length; _i++) {
              var t2 = types_22[_i];
              if (maybeTypeOfKind(t2, kind)) {
                return true;
              }
            }
          }
          return false;
        }
        function isTypeAssignableToKind(source, kind, strict) {
          if (source.flags & kind) {
            return true;
          }
          if (strict && source.flags & (3 | 16384 | 32768 | 65536)) {
            return false;
          }
          return !!(kind & 296) && isTypeAssignableTo(source, numberType) || !!(kind & 2112) && isTypeAssignableTo(source, bigintType) || !!(kind & 402653316) && isTypeAssignableTo(source, stringType) || !!(kind & 528) && isTypeAssignableTo(source, booleanType) || !!(kind & 16384) && isTypeAssignableTo(source, voidType) || !!(kind & 131072) && isTypeAssignableTo(source, neverType) || !!(kind & 65536) && isTypeAssignableTo(source, nullType) || !!(kind & 32768) && isTypeAssignableTo(source, undefinedType) || !!(kind & 4096) && isTypeAssignableTo(source, esSymbolType) || !!(kind & 67108864) && isTypeAssignableTo(source, nonPrimitiveType);
        }
        function allTypesAssignableToKind(source, kind, strict) {
          return source.flags & 1048576 ? ts3.every(source.types, function(subType) {
            return allTypesAssignableToKind(subType, kind, strict);
          }) : isTypeAssignableToKind(source, kind, strict);
        }
        function isConstEnumObjectType(type3) {
          return !!(ts3.getObjectFlags(type3) & 16) && !!type3.symbol && isConstEnumSymbol(type3.symbol);
        }
        function isConstEnumSymbol(symbol) {
          return (symbol.flags & 128) !== 0;
        }
        function checkInstanceOfExpression(left, right, leftType, rightType) {
          if (leftType === silentNeverType || rightType === silentNeverType) {
            return silentNeverType;
          }
          if (!isTypeAny(leftType) && allTypesAssignableToKind(leftType, 131068)) {
            error(left, ts3.Diagnostics.The_left_hand_side_of_an_instanceof_expression_must_be_of_type_any_an_object_type_or_a_type_parameter);
          }
          if (!(isTypeAny(rightType) || typeHasCallOrConstructSignatures(rightType) || isTypeSubtypeOf(rightType, globalFunctionType))) {
            error(right, ts3.Diagnostics.The_right_hand_side_of_an_instanceof_expression_must_be_of_type_any_or_of_a_type_assignable_to_the_Function_interface_type);
          }
          return booleanType;
        }
        function checkInExpression(left, right, leftType, rightType) {
          if (leftType === silentNeverType || rightType === silentNeverType) {
            return silentNeverType;
          }
          leftType = checkNonNullType(leftType, left);
          rightType = checkNonNullType(rightType, right);
          if (!(allTypesAssignableToKind(leftType, 402653316 | 296 | 12288) || isTypeAssignableToKind(leftType, 4194304 | 134217728 | 268435456 | 262144))) {
            error(left, ts3.Diagnostics.The_left_hand_side_of_an_in_expression_must_be_of_type_any_string_number_or_symbol);
          }
          var rightTypeConstraint = getConstraintOfType(rightType);
          if (!allTypesAssignableToKind(rightType, 67108864 | 58982400) || rightTypeConstraint && (isTypeAssignableToKind(rightType, 3145728) && !allTypesAssignableToKind(rightTypeConstraint, 67108864 | 58982400) || !maybeTypeOfKind(rightTypeConstraint, 67108864 | 58982400 | 524288))) {
            error(right, ts3.Diagnostics.The_right_hand_side_of_an_in_expression_must_not_be_a_primitive);
          }
          return booleanType;
        }
        function checkObjectLiteralAssignment(node, sourceType, rightIsThis) {
          var properties = node.properties;
          if (strictNullChecks && properties.length === 0) {
            return checkNonNullType(sourceType, node);
          }
          for (var i3 = 0; i3 < properties.length; i3++) {
            checkObjectLiteralDestructuringPropertyAssignment(node, sourceType, i3, properties, rightIsThis);
          }
          return sourceType;
        }
        function checkObjectLiteralDestructuringPropertyAssignment(node, objectLiteralType, propertyIndex, allProperties, rightIsThis) {
          if (rightIsThis === void 0) {
            rightIsThis = false;
          }
          var properties = node.properties;
          var property = properties[propertyIndex];
          if (property.kind === 289 || property.kind === 290) {
            var name = property.name;
            var exprType = getLiteralTypeFromPropertyName(name);
            if (isTypeUsableAsPropertyName(exprType)) {
              var text = getPropertyNameFromType(exprType);
              var prop = getPropertyOfType(objectLiteralType, text);
              if (prop) {
                markPropertyAsReferenced(prop, property, rightIsThis);
                checkPropertyAccessibility(property, false, true, objectLiteralType, prop);
              }
            }
            var elementType = getIndexedAccessType(objectLiteralType, exprType, void 0, name, void 0, void 0, 16);
            var type3 = getFlowTypeOfDestructuring(property, elementType);
            return checkDestructuringAssignment(property.kind === 290 ? property : property.initializer, type3);
          } else if (property.kind === 291) {
            if (propertyIndex < properties.length - 1) {
              error(property, ts3.Diagnostics.A_rest_element_must_be_last_in_a_destructuring_pattern);
            } else {
              if (languageVersion < 99) {
                checkExternalEmitHelpers(property, 4);
              }
              var nonRestNames = [];
              if (allProperties) {
                for (var _i = 0, allProperties_1 = allProperties; _i < allProperties_1.length; _i++) {
                  var otherProperty = allProperties_1[_i];
                  if (!ts3.isSpreadAssignment(otherProperty)) {
                    nonRestNames.push(otherProperty.name);
                  }
                }
              }
              var type3 = getRestType(objectLiteralType, nonRestNames, objectLiteralType.symbol);
              checkGrammarForDisallowedTrailingComma(allProperties, ts3.Diagnostics.A_rest_parameter_or_binding_pattern_may_not_have_a_trailing_comma);
              return checkDestructuringAssignment(property.expression, type3);
            }
          } else {
            error(property, ts3.Diagnostics.Property_assignment_expected);
          }
        }
        function checkArrayLiteralAssignment(node, sourceType, checkMode) {
          var elements = node.elements;
          if (languageVersion < 2 && compilerOptions.downlevelIteration) {
            checkExternalEmitHelpers(node, 512);
          }
          var possiblyOutOfBoundsType = checkIteratedTypeOrElementType(65 | 128, sourceType, undefinedType, node) || errorType;
          var inBoundsType = compilerOptions.noUncheckedIndexedAccess ? void 0 : possiblyOutOfBoundsType;
          for (var i3 = 0; i3 < elements.length; i3++) {
            var type3 = possiblyOutOfBoundsType;
            if (node.elements[i3].kind === 221) {
              type3 = inBoundsType = inBoundsType !== null && inBoundsType !== void 0 ? inBoundsType : checkIteratedTypeOrElementType(65, sourceType, undefinedType, node) || errorType;
            }
            checkArrayLiteralDestructuringElementAssignment(node, sourceType, i3, type3, checkMode);
          }
          return sourceType;
        }
        function checkArrayLiteralDestructuringElementAssignment(node, sourceType, elementIndex, elementType, checkMode) {
          var elements = node.elements;
          var element = elements[elementIndex];
          if (element.kind !== 223) {
            if (element.kind !== 221) {
              var indexType = getLiteralType(elementIndex);
              if (isArrayLikeType(sourceType)) {
                var accessFlags = 16 | (hasDefaultValue(element) ? 8 : 0);
                var elementType_2 = getIndexedAccessTypeOrUndefined(sourceType, indexType, void 0, createSyntheticExpression(element, indexType), accessFlags) || errorType;
                var assignedType = hasDefaultValue(element) ? getTypeWithFacts(elementType_2, 524288) : elementType_2;
                var type3 = getFlowTypeOfDestructuring(element, assignedType);
                return checkDestructuringAssignment(element, type3, checkMode);
              }
              return checkDestructuringAssignment(element, elementType, checkMode);
            }
            if (elementIndex < elements.length - 1) {
              error(element, ts3.Diagnostics.A_rest_element_must_be_last_in_a_destructuring_pattern);
            } else {
              var restExpression = element.expression;
              if (restExpression.kind === 217 && restExpression.operatorToken.kind === 62) {
                error(restExpression.operatorToken, ts3.Diagnostics.A_rest_element_cannot_have_an_initializer);
              } else {
                checkGrammarForDisallowedTrailingComma(node.elements, ts3.Diagnostics.A_rest_parameter_or_binding_pattern_may_not_have_a_trailing_comma);
                var type3 = everyType(sourceType, isTupleType) ? mapType(sourceType, function(t2) {
                  return sliceTupleType(t2, elementIndex);
                }) : createArrayType(elementType);
                return checkDestructuringAssignment(restExpression, type3, checkMode);
              }
            }
          }
          return void 0;
        }
        function checkDestructuringAssignment(exprOrAssignment, sourceType, checkMode, rightIsThis) {
          var target;
          if (exprOrAssignment.kind === 290) {
            var prop = exprOrAssignment;
            if (prop.objectAssignmentInitializer) {
              if (strictNullChecks && !(getFalsyFlags(checkExpression(prop.objectAssignmentInitializer)) & 32768)) {
                sourceType = getTypeWithFacts(sourceType, 524288);
              }
              checkBinaryLikeExpression(prop.name, prop.equalsToken, prop.objectAssignmentInitializer, checkMode);
            }
            target = exprOrAssignment.name;
          } else {
            target = exprOrAssignment;
          }
          if (target.kind === 217 && target.operatorToken.kind === 62) {
            checkBinaryExpression(target, checkMode);
            target = target.left;
          }
          if (target.kind === 201) {
            return checkObjectLiteralAssignment(target, sourceType, rightIsThis);
          }
          if (target.kind === 200) {
            return checkArrayLiteralAssignment(target, sourceType, checkMode);
          }
          return checkReferenceAssignment(target, sourceType, checkMode);
        }
        function checkReferenceAssignment(target, sourceType, checkMode) {
          var targetType = checkExpression(target, checkMode);
          var error2 = target.parent.kind === 291 ? ts3.Diagnostics.The_target_of_an_object_rest_assignment_must_be_a_variable_or_a_property_access : ts3.Diagnostics.The_left_hand_side_of_an_assignment_expression_must_be_a_variable_or_a_property_access;
          var optionalError = target.parent.kind === 291 ? ts3.Diagnostics.The_target_of_an_object_rest_assignment_may_not_be_an_optional_property_access : ts3.Diagnostics.The_left_hand_side_of_an_assignment_expression_may_not_be_an_optional_property_access;
          if (checkReferenceExpression(target, error2, optionalError)) {
            checkTypeAssignableToAndOptionallyElaborate(sourceType, targetType, target, target);
          }
          if (ts3.isPrivateIdentifierPropertyAccessExpression(target)) {
            checkExternalEmitHelpers(target.parent, 1048576);
          }
          return sourceType;
        }
        function isSideEffectFree(node) {
          node = ts3.skipParentheses(node);
          switch (node.kind) {
            case 78:
            case 10:
            case 13:
            case 206:
            case 219:
            case 14:
            case 8:
            case 9:
            case 109:
            case 94:
            case 103:
            case 150:
            case 209:
            case 222:
            case 210:
            case 200:
            case 201:
            case 212:
            case 226:
            case 275:
            case 274:
              return true;
            case 218:
              return isSideEffectFree(node.whenTrue) && isSideEffectFree(node.whenFalse);
            case 217:
              if (ts3.isAssignmentOperator(node.operatorToken.kind)) {
                return false;
              }
              return isSideEffectFree(node.left) && isSideEffectFree(node.right);
            case 215:
            case 216:
              switch (node.operator) {
                case 53:
                case 39:
                case 40:
                case 54:
                  return true;
              }
              return false;
            case 213:
            case 207:
            case 225:
            default:
              return false;
          }
        }
        function isTypeEqualityComparableTo(source, target) {
          return (target.flags & 98304) !== 0 || isTypeComparableTo(source, target);
        }
        function createCheckBinaryExpression() {
          var trampoline = ts3.createBinaryExpressionTrampoline(onEnter, onLeft, onOperator, onRight, onExit, foldState);
          return function(node, checkMode) {
            var result2 = trampoline(node, checkMode);
            ts3.Debug.assertIsDefined(result2);
            return result2;
          };
          function onEnter(node, state, checkMode) {
            if (state) {
              state.stackIndex++;
              state.skip = false;
              setLeftType(state, void 0);
              setLastResult(state, void 0);
            } else {
              state = {
                checkMode,
                skip: false,
                stackIndex: 0,
                typeStack: [void 0, void 0]
              };
            }
            if (ts3.isInJSFile(node) && ts3.getAssignedExpandoInitializer(node)) {
              state.skip = true;
              setLastResult(state, checkExpression(node.right, checkMode));
              return state;
            }
            checkGrammarNullishCoalesceWithLogicalExpression(node);
            var operator = node.operatorToken.kind;
            if (operator === 62 && (node.left.kind === 201 || node.left.kind === 200)) {
              state.skip = true;
              setLastResult(state, checkDestructuringAssignment(node.left, checkExpression(node.right, checkMode), checkMode, node.right.kind === 107));
              return state;
            }
            return state;
          }
          function onLeft(left, state, _node) {
            if (!state.skip) {
              return maybeCheckExpression(state, left);
            }
          }
          function onOperator(operatorToken, state, node) {
            if (!state.skip) {
              var leftType = getLastResult(state);
              ts3.Debug.assertIsDefined(leftType);
              setLeftType(state, leftType);
              setLastResult(state, void 0);
              var operator = operatorToken.kind;
              if (operator === 55 || operator === 56 || operator === 60) {
                if (operator === 55) {
                  var parent = ts3.walkUpParenthesizedExpressions(node.parent);
                  checkTestingKnownTruthyCallableOrAwaitableType(node.left, leftType, ts3.isIfStatement(parent) ? parent.thenStatement : void 0);
                }
                checkTruthinessOfType(leftType, node.left);
              }
            }
          }
          function onRight(right, state, _node) {
            if (!state.skip) {
              return maybeCheckExpression(state, right);
            }
          }
          function onExit(node, state) {
            var result2;
            if (state.skip) {
              result2 = getLastResult(state);
            } else {
              var leftType = getLeftType(state);
              ts3.Debug.assertIsDefined(leftType);
              var rightType = getLastResult(state);
              ts3.Debug.assertIsDefined(rightType);
              result2 = checkBinaryLikeExpressionWorker(node.left, node.operatorToken, node.right, leftType, rightType, node);
            }
            state.skip = false;
            setLeftType(state, void 0);
            setLastResult(state, void 0);
            state.stackIndex--;
            return result2;
          }
          function foldState(state, result2, _side) {
            setLastResult(state, result2);
            return state;
          }
          function maybeCheckExpression(state, node) {
            if (ts3.isBinaryExpression(node)) {
              return node;
            }
            setLastResult(state, checkExpression(node, state.checkMode));
          }
          function getLeftType(state) {
            return state.typeStack[state.stackIndex];
          }
          function setLeftType(state, type3) {
            state.typeStack[state.stackIndex] = type3;
          }
          function getLastResult(state) {
            return state.typeStack[state.stackIndex + 1];
          }
          function setLastResult(state, type3) {
            state.typeStack[state.stackIndex + 1] = type3;
          }
        }
        function checkGrammarNullishCoalesceWithLogicalExpression(node) {
          var left = node.left, operatorToken = node.operatorToken, right = node.right;
          if (operatorToken.kind === 60) {
            if (ts3.isBinaryExpression(left) && (left.operatorToken.kind === 56 || left.operatorToken.kind === 55)) {
              grammarErrorOnNode(left, ts3.Diagnostics._0_and_1_operations_cannot_be_mixed_without_parentheses, ts3.tokenToString(left.operatorToken.kind), ts3.tokenToString(operatorToken.kind));
            }
            if (ts3.isBinaryExpression(right) && (right.operatorToken.kind === 56 || right.operatorToken.kind === 55)) {
              grammarErrorOnNode(right, ts3.Diagnostics._0_and_1_operations_cannot_be_mixed_without_parentheses, ts3.tokenToString(right.operatorToken.kind), ts3.tokenToString(operatorToken.kind));
            }
          }
        }
        function checkBinaryLikeExpression(left, operatorToken, right, checkMode, errorNode) {
          var operator = operatorToken.kind;
          if (operator === 62 && (left.kind === 201 || left.kind === 200)) {
            return checkDestructuringAssignment(left, checkExpression(right, checkMode), checkMode, right.kind === 107);
          }
          var leftType;
          if (operator === 55 || operator === 56 || operator === 60) {
            leftType = checkTruthinessExpression(left, checkMode);
          } else {
            leftType = checkExpression(left, checkMode);
          }
          var rightType = checkExpression(right, checkMode);
          return checkBinaryLikeExpressionWorker(left, operatorToken, right, leftType, rightType, errorNode);
        }
        function checkBinaryLikeExpressionWorker(left, operatorToken, right, leftType, rightType, errorNode) {
          var operator = operatorToken.kind;
          switch (operator) {
            case 41:
            case 42:
            case 65:
            case 66:
            case 43:
            case 67:
            case 44:
            case 68:
            case 40:
            case 64:
            case 47:
            case 69:
            case 48:
            case 70:
            case 49:
            case 71:
            case 51:
            case 73:
            case 52:
            case 77:
            case 50:
            case 72:
              if (leftType === silentNeverType || rightType === silentNeverType) {
                return silentNeverType;
              }
              leftType = checkNonNullType(leftType, left);
              rightType = checkNonNullType(rightType, right);
              var suggestedOperator = void 0;
              if (leftType.flags & 528 && rightType.flags & 528 && (suggestedOperator = getSuggestedBooleanOperator(operatorToken.kind)) !== void 0) {
                error(errorNode || operatorToken, ts3.Diagnostics.The_0_operator_is_not_allowed_for_boolean_types_Consider_using_1_instead, ts3.tokenToString(operatorToken.kind), ts3.tokenToString(suggestedOperator));
                return numberType;
              } else {
                var leftOk = checkArithmeticOperandType(left, leftType, ts3.Diagnostics.The_left_hand_side_of_an_arithmetic_operation_must_be_of_type_any_number_bigint_or_an_enum_type, true);
                var rightOk = checkArithmeticOperandType(right, rightType, ts3.Diagnostics.The_right_hand_side_of_an_arithmetic_operation_must_be_of_type_any_number_bigint_or_an_enum_type, true);
                var resultType_1;
                if (isTypeAssignableToKind(leftType, 3) && isTypeAssignableToKind(rightType, 3) || !(maybeTypeOfKind(leftType, 2112) || maybeTypeOfKind(rightType, 2112))) {
                  resultType_1 = numberType;
                } else if (bothAreBigIntLike(leftType, rightType)) {
                  switch (operator) {
                    case 49:
                    case 71:
                      reportOperatorError();
                      break;
                    case 42:
                    case 66:
                      if (languageVersion < 3) {
                        error(errorNode, ts3.Diagnostics.Exponentiation_cannot_be_performed_on_bigint_values_unless_the_target_option_is_set_to_es2016_or_later);
                      }
                  }
                  resultType_1 = bigintType;
                } else {
                  reportOperatorError(bothAreBigIntLike);
                  resultType_1 = errorType;
                }
                if (leftOk && rightOk) {
                  checkAssignmentOperator(resultType_1);
                }
                return resultType_1;
              }
            case 39:
            case 63:
              if (leftType === silentNeverType || rightType === silentNeverType) {
                return silentNeverType;
              }
              if (!isTypeAssignableToKind(leftType, 402653316) && !isTypeAssignableToKind(rightType, 402653316)) {
                leftType = checkNonNullType(leftType, left);
                rightType = checkNonNullType(rightType, right);
              }
              var resultType = void 0;
              if (isTypeAssignableToKind(leftType, 296, true) && isTypeAssignableToKind(rightType, 296, true)) {
                resultType = numberType;
              } else if (isTypeAssignableToKind(leftType, 2112, true) && isTypeAssignableToKind(rightType, 2112, true)) {
                resultType = bigintType;
              } else if (isTypeAssignableToKind(leftType, 402653316, true) || isTypeAssignableToKind(rightType, 402653316, true)) {
                resultType = stringType;
              } else if (isTypeAny(leftType) || isTypeAny(rightType)) {
                resultType = leftType === errorType || rightType === errorType ? errorType : anyType;
              }
              if (resultType && !checkForDisallowedESSymbolOperand(operator)) {
                return resultType;
              }
              if (!resultType) {
                var closeEnoughKind_1 = 296 | 2112 | 402653316 | 3;
                reportOperatorError(function(left2, right2) {
                  return isTypeAssignableToKind(left2, closeEnoughKind_1) && isTypeAssignableToKind(right2, closeEnoughKind_1);
                });
                return anyType;
              }
              if (operator === 63) {
                checkAssignmentOperator(resultType);
              }
              return resultType;
            case 29:
            case 31:
            case 32:
            case 33:
              if (checkForDisallowedESSymbolOperand(operator)) {
                leftType = getBaseTypeOfLiteralType(checkNonNullType(leftType, left));
                rightType = getBaseTypeOfLiteralType(checkNonNullType(rightType, right));
                reportOperatorErrorUnless(function(left2, right2) {
                  return isTypeComparableTo(left2, right2) || isTypeComparableTo(right2, left2) || isTypeAssignableTo(left2, numberOrBigIntType) && isTypeAssignableTo(right2, numberOrBigIntType);
                });
              }
              return booleanType;
            case 34:
            case 35:
            case 36:
            case 37:
              reportOperatorErrorUnless(function(left2, right2) {
                return isTypeEqualityComparableTo(left2, right2) || isTypeEqualityComparableTo(right2, left2);
              });
              return booleanType;
            case 101:
              return checkInstanceOfExpression(left, right, leftType, rightType);
            case 100:
              return checkInExpression(left, right, leftType, rightType);
            case 55:
            case 75: {
              var resultType_2 = getTypeFacts(leftType) & 4194304 ? getUnionType([extractDefinitelyFalsyTypes(strictNullChecks ? leftType : getBaseTypeOfLiteralType(rightType)), rightType]) : leftType;
              if (operator === 75) {
                checkAssignmentOperator(rightType);
              }
              return resultType_2;
            }
            case 56:
            case 74: {
              var resultType_3 = getTypeFacts(leftType) & 8388608 ? getUnionType([removeDefinitelyFalsyTypes(leftType), rightType], 2) : leftType;
              if (operator === 74) {
                checkAssignmentOperator(rightType);
              }
              return resultType_3;
            }
            case 60:
            case 76: {
              var resultType_4 = getTypeFacts(leftType) & 262144 ? getUnionType([getNonNullableType(leftType), rightType], 2) : leftType;
              if (operator === 76) {
                checkAssignmentOperator(rightType);
              }
              return resultType_4;
            }
            case 62:
              var declKind = ts3.isBinaryExpression(left.parent) ? ts3.getAssignmentDeclarationKind(left.parent) : 0;
              checkAssignmentDeclaration(declKind, rightType);
              if (isAssignmentDeclaration(declKind)) {
                if (!(rightType.flags & 524288) || declKind !== 2 && declKind !== 6 && !isEmptyObjectType(rightType) && !isFunctionObjectType(rightType) && !(ts3.getObjectFlags(rightType) & 1)) {
                  checkAssignmentOperator(rightType);
                }
                return leftType;
              } else {
                checkAssignmentOperator(rightType);
                return getRegularTypeOfObjectLiteral(rightType);
              }
            case 27:
              if (!compilerOptions.allowUnreachableCode && isSideEffectFree(left) && !isEvalNode(right)) {
                var sf = ts3.getSourceFileOfNode(left);
                var sourceText = sf.text;
                var start_3 = ts3.skipTrivia(sourceText, left.pos);
                var isInDiag2657 = sf.parseDiagnostics.some(function(diag) {
                  if (diag.code !== ts3.Diagnostics.JSX_expressions_must_have_one_parent_element.code)
                    return false;
                  return ts3.textSpanContainsPosition(diag, start_3);
                });
                if (!isInDiag2657)
                  error(left, ts3.Diagnostics.Left_side_of_comma_operator_is_unused_and_has_no_side_effects);
              }
              return rightType;
            default:
              return ts3.Debug.fail();
          }
          function bothAreBigIntLike(left2, right2) {
            return isTypeAssignableToKind(left2, 2112) && isTypeAssignableToKind(right2, 2112);
          }
          function checkAssignmentDeclaration(kind, rightType2) {
            if (kind === 2) {
              for (var _i = 0, _a2 = getPropertiesOfObjectType(rightType2); _i < _a2.length; _i++) {
                var prop = _a2[_i];
                var propType = getTypeOfSymbol(prop);
                if (propType.symbol && propType.symbol.flags & 32) {
                  var name = prop.escapedName;
                  var symbol = resolveName(prop.valueDeclaration, name, 788968, void 0, name, false);
                  if ((symbol === null || symbol === void 0 ? void 0 : symbol.declarations) && symbol.declarations.some(ts3.isJSDocTypedefTag)) {
                    addDuplicateDeclarationErrorsForSymbols(symbol, ts3.Diagnostics.Duplicate_identifier_0, ts3.unescapeLeadingUnderscores(name), prop);
                    addDuplicateDeclarationErrorsForSymbols(prop, ts3.Diagnostics.Duplicate_identifier_0, ts3.unescapeLeadingUnderscores(name), symbol);
                  }
                }
              }
            }
          }
          function isEvalNode(node) {
            return node.kind === 78 && node.escapedText === "eval";
          }
          function checkForDisallowedESSymbolOperand(operator2) {
            var offendingSymbolOperand = maybeTypeOfKind(leftType, 12288) ? left : maybeTypeOfKind(rightType, 12288) ? right : void 0;
            if (offendingSymbolOperand) {
              error(offendingSymbolOperand, ts3.Diagnostics.The_0_operator_cannot_be_applied_to_type_symbol, ts3.tokenToString(operator2));
              return false;
            }
            return true;
          }
          function getSuggestedBooleanOperator(operator2) {
            switch (operator2) {
              case 51:
              case 73:
                return 56;
              case 52:
              case 77:
                return 37;
              case 50:
              case 72:
                return 55;
              default:
                return void 0;
            }
          }
          function checkAssignmentOperator(valueType) {
            if (produceDiagnostics && ts3.isAssignmentOperator(operator)) {
              if (checkReferenceExpression(left, ts3.Diagnostics.The_left_hand_side_of_an_assignment_expression_must_be_a_variable_or_a_property_access, ts3.Diagnostics.The_left_hand_side_of_an_assignment_expression_may_not_be_an_optional_property_access) && (!ts3.isIdentifier(left) || ts3.unescapeLeadingUnderscores(left.escapedText) !== "exports")) {
                checkTypeAssignableToAndOptionallyElaborate(valueType, leftType, left, right);
              }
            }
          }
          function isAssignmentDeclaration(kind) {
            var _a2;
            switch (kind) {
              case 2:
                return true;
              case 1:
              case 5:
              case 6:
              case 3:
              case 4:
                var symbol = getSymbolOfNode(left);
                var init = ts3.getAssignedExpandoInitializer(right);
                return !!init && ts3.isObjectLiteralExpression(init) && !!((_a2 = symbol === null || symbol === void 0 ? void 0 : symbol.exports) === null || _a2 === void 0 ? void 0 : _a2.size);
              default:
                return false;
            }
          }
          function reportOperatorErrorUnless(typesAreCompatible) {
            if (!typesAreCompatible(leftType, rightType)) {
              reportOperatorError(typesAreCompatible);
              return true;
            }
            return false;
          }
          function reportOperatorError(isRelated) {
            var _a2;
            var wouldWorkWithAwait = false;
            var errNode = errorNode || operatorToken;
            if (isRelated) {
              var awaitedLeftType = getAwaitedType(leftType);
              var awaitedRightType = getAwaitedType(rightType);
              wouldWorkWithAwait = !(awaitedLeftType === leftType && awaitedRightType === rightType) && !!(awaitedLeftType && awaitedRightType) && isRelated(awaitedLeftType, awaitedRightType);
            }
            var effectiveLeft = leftType;
            var effectiveRight = rightType;
            if (!wouldWorkWithAwait && isRelated) {
              _a2 = getBaseTypesIfUnrelated(leftType, rightType, isRelated), effectiveLeft = _a2[0], effectiveRight = _a2[1];
            }
            var _b = getTypeNamesForErrorDisplay(effectiveLeft, effectiveRight), leftStr = _b[0], rightStr = _b[1];
            if (!tryGiveBetterPrimaryError(errNode, wouldWorkWithAwait, leftStr, rightStr)) {
              errorAndMaybeSuggestAwait(errNode, wouldWorkWithAwait, ts3.Diagnostics.Operator_0_cannot_be_applied_to_types_1_and_2, ts3.tokenToString(operatorToken.kind), leftStr, rightStr);
            }
          }
          function tryGiveBetterPrimaryError(errNode, maybeMissingAwait, leftStr, rightStr) {
            var typeName;
            switch (operatorToken.kind) {
              case 36:
              case 34:
                typeName = "false";
                break;
              case 37:
              case 35:
                typeName = "true";
            }
            if (typeName) {
              return errorAndMaybeSuggestAwait(errNode, maybeMissingAwait, ts3.Diagnostics.This_condition_will_always_return_0_since_the_types_1_and_2_have_no_overlap, typeName, leftStr, rightStr);
            }
            return void 0;
          }
        }
        function getBaseTypesIfUnrelated(leftType, rightType, isRelated) {
          var effectiveLeft = leftType;
          var effectiveRight = rightType;
          var leftBase = getBaseTypeOfLiteralType(leftType);
          var rightBase = getBaseTypeOfLiteralType(rightType);
          if (!isRelated(leftBase, rightBase)) {
            effectiveLeft = leftBase;
            effectiveRight = rightBase;
          }
          return [effectiveLeft, effectiveRight];
        }
        function checkYieldExpression(node) {
          if (produceDiagnostics) {
            if (!(node.flags & 8192)) {
              grammarErrorOnFirstToken(node, ts3.Diagnostics.A_yield_expression_is_only_allowed_in_a_generator_body);
            }
            if (isInParameterInitializerBeforeContainingFunction(node)) {
              error(node, ts3.Diagnostics.yield_expressions_cannot_be_used_in_a_parameter_initializer);
            }
          }
          var func2 = ts3.getContainingFunction(node);
          if (!func2)
            return anyType;
          var functionFlags = ts3.getFunctionFlags(func2);
          if (!(functionFlags & 1)) {
            return anyType;
          }
          var isAsync = (functionFlags & 2) !== 0;
          if (node.asteriskToken) {
            if (isAsync && languageVersion < 99) {
              checkExternalEmitHelpers(node, 26624);
            }
            if (!isAsync && languageVersion < 2 && compilerOptions.downlevelIteration) {
              checkExternalEmitHelpers(node, 256);
            }
          }
          var returnType2 = getReturnTypeFromAnnotation(func2);
          var iterationTypes = returnType2 && getIterationTypesOfGeneratorFunctionReturnType(returnType2, isAsync);
          var signatureYieldType = iterationTypes && iterationTypes.yieldType || anyType;
          var signatureNextType = iterationTypes && iterationTypes.nextType || anyType;
          var resolvedSignatureNextType = isAsync ? getAwaitedType(signatureNextType) || anyType : signatureNextType;
          var yieldExpressionType = node.expression ? checkExpression(node.expression) : undefinedWideningType;
          var yieldedType = getYieldedTypeOfYieldExpression(node, yieldExpressionType, resolvedSignatureNextType, isAsync);
          if (returnType2 && yieldedType) {
            checkTypeAssignableToAndOptionallyElaborate(yieldedType, signatureYieldType, node.expression || node, node.expression);
          }
          if (node.asteriskToken) {
            var use = isAsync ? 19 : 17;
            return getIterationTypeOfIterable(use, 1, yieldExpressionType, node.expression) || anyType;
          } else if (returnType2) {
            return getIterationTypeOfGeneratorFunctionReturnType(2, returnType2, isAsync) || anyType;
          }
          var type3 = getContextualIterationType(2, func2);
          if (!type3) {
            type3 = anyType;
            if (produceDiagnostics && noImplicitAny && !ts3.expressionResultIsUnused(node)) {
              var contextualType = getContextualType(node);
              if (!contextualType || isTypeAny(contextualType)) {
                error(node, ts3.Diagnostics.yield_expression_implicitly_results_in_an_any_type_because_its_containing_generator_lacks_a_return_type_annotation);
              }
            }
          }
          return type3;
        }
        function checkConditionalExpression(node, checkMode) {
          var type3 = checkTruthinessExpression(node.condition);
          checkTestingKnownTruthyCallableOrAwaitableType(node.condition, type3, node.whenTrue);
          var type1 = checkExpression(node.whenTrue, checkMode);
          var type22 = checkExpression(node.whenFalse, checkMode);
          return getUnionType([type1, type22], 2);
        }
        function checkTemplateExpression(node) {
          var texts = [node.head.text];
          var types2 = [];
          for (var _i = 0, _a2 = node.templateSpans; _i < _a2.length; _i++) {
            var span = _a2[_i];
            var type3 = checkExpression(span.expression);
            if (maybeTypeOfKind(type3, 12288)) {
              error(span.expression, ts3.Diagnostics.Implicit_conversion_of_a_symbol_to_a_string_will_fail_at_runtime_Consider_wrapping_this_expression_in_String);
            }
            texts.push(span.literal.text);
            types2.push(isTypeAssignableTo(type3, templateConstraintType) ? type3 : stringType);
          }
          return isConstContext(node) || someType(getContextualType(node) || unknownType, isTemplateLiteralContextualType) ? getTemplateLiteralType(texts, types2) : stringType;
        }
        function isTemplateLiteralContextualType(type3) {
          return !!(type3.flags & (128 | 134217728) || type3.flags & 58982400 && maybeTypeOfKind(getBaseConstraintOfType(type3) || unknownType, 402653316));
        }
        function getContextNode(node) {
          if (node.kind === 282 && !ts3.isJsxSelfClosingElement(node.parent)) {
            return node.parent.parent;
          }
          return node;
        }
        function checkExpressionWithContextualType(node, contextualType, inferenceContext, checkMode) {
          var context = getContextNode(node);
          var saveContextualType = context.contextualType;
          var saveInferenceContext = context.inferenceContext;
          try {
            context.contextualType = contextualType;
            context.inferenceContext = inferenceContext;
            var type3 = checkExpression(node, checkMode | 1 | (inferenceContext ? 2 : 0));
            var result2 = maybeTypeOfKind(type3, 2944) && isLiteralOfContextualType(type3, instantiateContextualType(contextualType, node)) ? getRegularTypeOfLiteralType(type3) : type3;
            return result2;
          } finally {
            context.contextualType = saveContextualType;
            context.inferenceContext = saveInferenceContext;
          }
        }
        function checkExpressionCached(node, checkMode) {
          var links = getNodeLinks(node);
          if (!links.resolvedType) {
            if (checkMode && checkMode !== 0) {
              return checkExpression(node, checkMode);
            }
            var saveFlowLoopStart = flowLoopStart;
            var saveFlowTypeCache = flowTypeCache;
            flowLoopStart = flowLoopCount;
            flowTypeCache = void 0;
            links.resolvedType = checkExpression(node, checkMode);
            flowTypeCache = saveFlowTypeCache;
            flowLoopStart = saveFlowLoopStart;
          }
          return links.resolvedType;
        }
        function isTypeAssertion(node) {
          node = ts3.skipParentheses(node);
          return node.kind === 207 || node.kind === 225;
        }
        function checkDeclarationInitializer(declaration, contextualType) {
          var initializer = ts3.getEffectiveInitializer(declaration);
          var type3 = getQuickTypeOfExpression(initializer) || (contextualType ? checkExpressionWithContextualType(initializer, contextualType, void 0, 0) : checkExpressionCached(initializer));
          return ts3.isParameter(declaration) && declaration.name.kind === 198 && isTupleType(type3) && !type3.target.hasRestElement && getTypeReferenceArity(type3) < declaration.name.elements.length ? padTupleType(type3, declaration.name) : type3;
        }
        function padTupleType(type3, pattern) {
          var patternElements = pattern.elements;
          var elementTypes = getTypeArguments(type3).slice();
          var elementFlags = type3.target.elementFlags.slice();
          for (var i3 = getTypeReferenceArity(type3); i3 < patternElements.length; i3++) {
            var e2 = patternElements[i3];
            if (i3 < patternElements.length - 1 || !(e2.kind === 199 && e2.dotDotDotToken)) {
              elementTypes.push(!ts3.isOmittedExpression(e2) && hasDefaultValue(e2) ? getTypeFromBindingElement(e2, false, false) : anyType);
              elementFlags.push(2);
              if (!ts3.isOmittedExpression(e2) && !hasDefaultValue(e2)) {
                reportImplicitAny(e2, anyType);
              }
            }
          }
          return createTupleType(elementTypes, elementFlags, type3.target.readonly);
        }
        function widenTypeInferredFromInitializer(declaration, type3) {
          var widened = ts3.getCombinedNodeFlags(declaration) & 2 || ts3.isDeclarationReadonly(declaration) ? type3 : getWidenedLiteralType(type3);
          if (ts3.isInJSFile(declaration)) {
            if (widened.flags & 98304) {
              reportImplicitAny(declaration, anyType);
              return anyType;
            } else if (isEmptyArrayLiteralType(widened)) {
              reportImplicitAny(declaration, anyArrayType);
              return anyArrayType;
            }
          }
          return widened;
        }
        function isLiteralOfContextualType(candidateType, contextualType) {
          if (contextualType) {
            if (contextualType.flags & 3145728) {
              var types2 = contextualType.types;
              return ts3.some(types2, function(t2) {
                return isLiteralOfContextualType(candidateType, t2);
              });
            }
            if (contextualType.flags & 58982400) {
              var constraint = getBaseConstraintOfType(contextualType) || unknownType;
              return maybeTypeOfKind(constraint, 4) && maybeTypeOfKind(candidateType, 128) || maybeTypeOfKind(constraint, 8) && maybeTypeOfKind(candidateType, 256) || maybeTypeOfKind(constraint, 64) && maybeTypeOfKind(candidateType, 2048) || maybeTypeOfKind(constraint, 4096) && maybeTypeOfKind(candidateType, 8192) || isLiteralOfContextualType(candidateType, constraint);
            }
            return !!(contextualType.flags & (128 | 4194304 | 134217728 | 268435456) && maybeTypeOfKind(candidateType, 128) || contextualType.flags & 256 && maybeTypeOfKind(candidateType, 256) || contextualType.flags & 2048 && maybeTypeOfKind(candidateType, 2048) || contextualType.flags & 512 && maybeTypeOfKind(candidateType, 512) || contextualType.flags & 8192 && maybeTypeOfKind(candidateType, 8192));
          }
          return false;
        }
        function isConstContext(node) {
          var parent = node.parent;
          return ts3.isAssertionExpression(parent) && ts3.isConstTypeReference(parent.type) || (ts3.isParenthesizedExpression(parent) || ts3.isArrayLiteralExpression(parent) || ts3.isSpreadElement(parent)) && isConstContext(parent) || (ts3.isPropertyAssignment(parent) || ts3.isShorthandPropertyAssignment(parent) || ts3.isTemplateSpan(parent)) && isConstContext(parent.parent);
        }
        function checkExpressionForMutableLocation(node, checkMode, contextualType, forceTuple) {
          var type3 = checkExpression(node, checkMode, forceTuple);
          return isConstContext(node) ? getRegularTypeOfLiteralType(type3) : isTypeAssertion(node) ? type3 : getWidenedLiteralLikeTypeForContextualType(type3, instantiateContextualType(arguments.length === 2 ? getContextualType(node) : contextualType, node));
        }
        function checkPropertyAssignment(node, checkMode) {
          if (node.name.kind === 159) {
            checkComputedPropertyName(node.name);
          }
          return checkExpressionForMutableLocation(node.initializer, checkMode);
        }
        function checkObjectLiteralMethod(node, checkMode) {
          checkGrammarMethod(node);
          if (node.name.kind === 159) {
            checkComputedPropertyName(node.name);
          }
          var uninstantiatedType = checkFunctionExpressionOrObjectLiteralMethod(node, checkMode);
          return instantiateTypeWithSingleGenericCallSignature(node, uninstantiatedType, checkMode);
        }
        function instantiateTypeWithSingleGenericCallSignature(node, type3, checkMode) {
          if (checkMode && checkMode & (2 | 8)) {
            var callSignature = getSingleSignature(type3, 0, true);
            var constructSignature = getSingleSignature(type3, 1, true);
            var signature = callSignature || constructSignature;
            if (signature && signature.typeParameters) {
              var contextualType = getApparentTypeOfContextualType(node, 2);
              if (contextualType) {
                var contextualSignature = getSingleSignature(getNonNullableType(contextualType), callSignature ? 0 : 1, false);
                if (contextualSignature && !contextualSignature.typeParameters) {
                  if (checkMode & 8) {
                    skippedGenericFunction(node, checkMode);
                    return anyFunctionType;
                  }
                  var context = getInferenceContext(node);
                  var returnType2 = context.signature && getReturnTypeOfSignature(context.signature);
                  var returnSignature = returnType2 && getSingleCallOrConstructSignature(returnType2);
                  if (returnSignature && !returnSignature.typeParameters && !ts3.every(context.inferences, hasInferenceCandidates)) {
                    var uniqueTypeParameters = getUniqueTypeParameters(context, signature.typeParameters);
                    var instantiatedSignature = getSignatureInstantiationWithoutFillingInTypeArguments(signature, uniqueTypeParameters);
                    var inferences_3 = ts3.map(context.inferences, function(info) {
                      return createInferenceInfo(info.typeParameter);
                    });
                    applyToParameterTypes(instantiatedSignature, contextualSignature, function(source, target) {
                      inferTypes(inferences_3, source, target, 0, true);
                    });
                    if (ts3.some(inferences_3, hasInferenceCandidates)) {
                      applyToReturnTypes(instantiatedSignature, contextualSignature, function(source, target) {
                        inferTypes(inferences_3, source, target);
                      });
                      if (!hasOverlappingInferences(context.inferences, inferences_3)) {
                        mergeInferences(context.inferences, inferences_3);
                        context.inferredTypeParameters = ts3.concatenate(context.inferredTypeParameters, uniqueTypeParameters);
                        return getOrCreateTypeFromSignature(instantiatedSignature);
                      }
                    }
                  }
                  return getOrCreateTypeFromSignature(instantiateSignatureInContextOf(signature, contextualSignature, context));
                }
              }
            }
          }
          return type3;
        }
        function skippedGenericFunction(node, checkMode) {
          if (checkMode & 2) {
            var context = getInferenceContext(node);
            context.flags |= 4;
          }
        }
        function hasInferenceCandidates(info) {
          return !!(info.candidates || info.contraCandidates);
        }
        function hasOverlappingInferences(a2, b2) {
          for (var i3 = 0; i3 < a2.length; i3++) {
            if (hasInferenceCandidates(a2[i3]) && hasInferenceCandidates(b2[i3])) {
              return true;
            }
          }
          return false;
        }
        function mergeInferences(target, source) {
          for (var i3 = 0; i3 < target.length; i3++) {
            if (!hasInferenceCandidates(target[i3]) && hasInferenceCandidates(source[i3])) {
              target[i3] = source[i3];
            }
          }
        }
        function getUniqueTypeParameters(context, typeParameters) {
          var result2 = [];
          var oldTypeParameters;
          var newTypeParameters;
          for (var _i = 0, typeParameters_2 = typeParameters; _i < typeParameters_2.length; _i++) {
            var tp = typeParameters_2[_i];
            var name = tp.symbol.escapedName;
            if (hasTypeParameterByName(context.inferredTypeParameters, name) || hasTypeParameterByName(result2, name)) {
              var newName = getUniqueTypeParameterName(ts3.concatenate(context.inferredTypeParameters, result2), name);
              var symbol = createSymbol(262144, newName);
              var newTypeParameter = createTypeParameter(symbol);
              newTypeParameter.target = tp;
              oldTypeParameters = ts3.append(oldTypeParameters, tp);
              newTypeParameters = ts3.append(newTypeParameters, newTypeParameter);
              result2.push(newTypeParameter);
            } else {
              result2.push(tp);
            }
          }
          if (newTypeParameters) {
            var mapper = createTypeMapper(oldTypeParameters, newTypeParameters);
            for (var _a2 = 0, newTypeParameters_1 = newTypeParameters; _a2 < newTypeParameters_1.length; _a2++) {
              var tp = newTypeParameters_1[_a2];
              tp.mapper = mapper;
            }
          }
          return result2;
        }
        function hasTypeParameterByName(typeParameters, name) {
          return ts3.some(typeParameters, function(tp) {
            return tp.symbol.escapedName === name;
          });
        }
        function getUniqueTypeParameterName(typeParameters, baseName) {
          var len = baseName.length;
          while (len > 1 && baseName.charCodeAt(len - 1) >= 48 && baseName.charCodeAt(len - 1) <= 57)
            len--;
          var s2 = baseName.slice(0, len);
          for (var index = 1; true; index++) {
            var augmentedName = s2 + index;
            if (!hasTypeParameterByName(typeParameters, augmentedName)) {
              return augmentedName;
            }
          }
        }
        function getReturnTypeOfSingleNonGenericCallSignature(funcType) {
          var signature = getSingleCallSignature(funcType);
          if (signature && !signature.typeParameters) {
            return getReturnTypeOfSignature(signature);
          }
        }
        function getReturnTypeOfSingleNonGenericSignatureOfCallChain(expr) {
          var funcType = checkExpression(expr.expression);
          var nonOptionalType = getOptionalExpressionType(funcType, expr.expression);
          var returnType2 = getReturnTypeOfSingleNonGenericCallSignature(funcType);
          return returnType2 && propagateOptionalTypeMarker(returnType2, expr, nonOptionalType !== funcType);
        }
        function getTypeOfExpression(node) {
          var quickType = getQuickTypeOfExpression(node);
          if (quickType) {
            return quickType;
          }
          if (node.flags & 67108864 && flowTypeCache) {
            var cachedType = flowTypeCache[getNodeId(node)];
            if (cachedType) {
              return cachedType;
            }
          }
          var startInvocationCount = flowInvocationCount;
          var type3 = checkExpression(node);
          if (flowInvocationCount !== startInvocationCount) {
            var cache = flowTypeCache || (flowTypeCache = []);
            cache[getNodeId(node)] = type3;
            ts3.setNodeFlags(node, node.flags | 67108864);
          }
          return type3;
        }
        function getQuickTypeOfExpression(node) {
          var expr = ts3.skipParentheses(node);
          if (ts3.isCallExpression(expr) && expr.expression.kind !== 105 && !ts3.isRequireCall(expr, true) && !isSymbolOrSymbolForCall(expr)) {
            var type3 = ts3.isCallChain(expr) ? getReturnTypeOfSingleNonGenericSignatureOfCallChain(expr) : getReturnTypeOfSingleNonGenericCallSignature(checkNonNullExpression(expr.expression));
            if (type3) {
              return type3;
            }
          } else if (ts3.isAssertionExpression(expr) && !ts3.isConstTypeReference(expr.type)) {
            return getTypeFromTypeNode(expr.type);
          } else if (node.kind === 8 || node.kind === 10 || node.kind === 109 || node.kind === 94) {
            return checkExpression(node);
          }
          return void 0;
        }
        function getContextFreeTypeOfExpression(node) {
          var links = getNodeLinks(node);
          if (links.contextFreeType) {
            return links.contextFreeType;
          }
          var saveContextualType = node.contextualType;
          node.contextualType = anyType;
          try {
            var type3 = links.contextFreeType = checkExpression(node, 4);
            return type3;
          } finally {
            node.contextualType = saveContextualType;
          }
        }
        function checkExpression(node, checkMode, forceTuple) {
          ts3.tracing === null || ts3.tracing === void 0 ? void 0 : ts3.tracing.push("check", "checkExpression", { kind: node.kind, pos: node.pos, end: node.end });
          var saveCurrentNode = currentNode;
          currentNode = node;
          instantiationCount = 0;
          var uninstantiatedType = checkExpressionWorker(node, checkMode, forceTuple);
          var type3 = instantiateTypeWithSingleGenericCallSignature(node, uninstantiatedType, checkMode);
          if (isConstEnumObjectType(type3)) {
            checkConstEnumAccess(node, type3);
          }
          currentNode = saveCurrentNode;
          ts3.tracing === null || ts3.tracing === void 0 ? void 0 : ts3.tracing.pop();
          return type3;
        }
        function checkConstEnumAccess(node, type3) {
          var ok = node.parent.kind === 202 && node.parent.expression === node || node.parent.kind === 203 && node.parent.expression === node || ((node.kind === 78 || node.kind === 158) && isInRightSideOfImportOrExportAssignment(node) || node.parent.kind === 177 && node.parent.exprName === node) || node.parent.kind === 271;
          if (!ok) {
            error(node, ts3.Diagnostics.const_enums_can_only_be_used_in_property_or_index_access_expressions_or_the_right_hand_side_of_an_import_declaration_or_export_assignment_or_type_query);
          }
          if (compilerOptions.isolatedModules) {
            ts3.Debug.assert(!!(type3.symbol.flags & 128));
            var constEnumDeclaration = type3.symbol.valueDeclaration;
            if (constEnumDeclaration.flags & 8388608) {
              error(node, ts3.Diagnostics.Cannot_access_ambient_const_enums_when_the_isolatedModules_flag_is_provided);
            }
          }
        }
        function checkParenthesizedExpression(node, checkMode) {
          var tag = ts3.isInJSFile(node) ? ts3.getJSDocTypeTag(node) : void 0;
          if (tag) {
            return checkAssertionWorker(tag, tag.typeExpression.type, node.expression, checkMode);
          }
          return checkExpression(node.expression, checkMode);
        }
        function checkExpressionWorker(node, checkMode, forceTuple) {
          var kind = node.kind;
          if (cancellationToken) {
            switch (kind) {
              case 222:
              case 209:
              case 210:
                cancellationToken.throwIfCancellationRequested();
            }
          }
          switch (kind) {
            case 78:
              return checkIdentifier(node, checkMode);
            case 107:
              return checkThisExpression(node);
            case 105:
              return checkSuperExpression(node);
            case 103:
              return nullWideningType;
            case 14:
            case 10:
              return getFreshTypeOfLiteralType(getLiteralType(node.text));
            case 8:
              checkGrammarNumericLiteral(node);
              return getFreshTypeOfLiteralType(getLiteralType(+node.text));
            case 9:
              checkGrammarBigIntLiteral(node);
              return getFreshTypeOfLiteralType(getBigIntLiteralType(node));
            case 109:
              return trueType;
            case 94:
              return falseType;
            case 219:
              return checkTemplateExpression(node);
            case 13:
              return globalRegExpType;
            case 200:
              return checkArrayLiteral(node, checkMode, forceTuple);
            case 201:
              return checkObjectLiteral(node, checkMode);
            case 202:
              return checkPropertyAccessExpression(node, checkMode);
            case 158:
              return checkQualifiedName(node, checkMode);
            case 203:
              return checkIndexedAccess(node, checkMode);
            case 204:
              if (node.expression.kind === 99) {
                return checkImportCallExpression(node);
              }
            case 205:
              return checkCallExpression(node, checkMode);
            case 206:
              return checkTaggedTemplateExpression(node);
            case 208:
              return checkParenthesizedExpression(node, checkMode);
            case 222:
              return checkClassExpression(node);
            case 209:
            case 210:
              return checkFunctionExpressionOrObjectLiteralMethod(node, checkMode);
            case 212:
              return checkTypeOfExpression(node);
            case 207:
            case 225:
              return checkAssertion(node);
            case 226:
              return checkNonNullAssertion(node);
            case 227:
              return checkMetaProperty(node);
            case 211:
              return checkDeleteExpression(node);
            case 213:
              return checkVoidExpression(node);
            case 214:
              return checkAwaitExpression(node);
            case 215:
              return checkPrefixUnaryExpression(node);
            case 216:
              return checkPostfixUnaryExpression(node);
            case 217:
              return checkBinaryExpression(node, checkMode);
            case 218:
              return checkConditionalExpression(node, checkMode);
            case 221:
              return checkSpreadExpression(node, checkMode);
            case 223:
              return undefinedWideningType;
            case 220:
              return checkYieldExpression(node);
            case 228:
              return checkSyntheticExpression(node);
            case 284:
              return checkJsxExpression(node, checkMode);
            case 274:
              return checkJsxElement(node, checkMode);
            case 275:
              return checkJsxSelfClosingElement(node, checkMode);
            case 278:
              return checkJsxFragment(node);
            case 282:
              return checkJsxAttributes(node, checkMode);
            case 276:
              ts3.Debug.fail("Shouldn't ever directly check a JsxOpeningElement");
          }
          return errorType;
        }
        function checkTypeParameter(node) {
          if (node.expression) {
            grammarErrorOnFirstToken(node.expression, ts3.Diagnostics.Type_expected);
          }
          checkSourceElement(node.constraint);
          checkSourceElement(node.default);
          var typeParameter = getDeclaredTypeOfTypeParameter(getSymbolOfNode(node));
          getBaseConstraintOfType(typeParameter);
          if (!hasNonCircularTypeParameterDefault(typeParameter)) {
            error(node.default, ts3.Diagnostics.Type_parameter_0_has_a_circular_default, typeToString(typeParameter));
          }
          var constraintType = getConstraintOfTypeParameter(typeParameter);
          var defaultType = getDefaultFromTypeParameter(typeParameter);
          if (constraintType && defaultType) {
            checkTypeAssignableTo(defaultType, getTypeWithThisArgument(instantiateType(constraintType, makeUnaryTypeMapper(typeParameter, defaultType)), defaultType), node.default, ts3.Diagnostics.Type_0_does_not_satisfy_the_constraint_1);
          }
          if (produceDiagnostics) {
            checkTypeNameIsReserved(node.name, ts3.Diagnostics.Type_parameter_name_cannot_be_0);
          }
        }
        function checkParameter(node) {
          checkGrammarDecoratorsAndModifiers(node);
          checkVariableLikeDeclaration(node);
          var func2 = ts3.getContainingFunction(node);
          if (ts3.hasSyntacticModifier(node, 16476)) {
            if (!(func2.kind === 167 && ts3.nodeIsPresent(func2.body))) {
              error(node, ts3.Diagnostics.A_parameter_property_is_only_allowed_in_a_constructor_implementation);
            }
            if (func2.kind === 167 && ts3.isIdentifier(node.name) && node.name.escapedText === "constructor") {
              error(node.name, ts3.Diagnostics.constructor_cannot_be_used_as_a_parameter_property_name);
            }
          }
          if (node.questionToken && ts3.isBindingPattern(node.name) && func2.body) {
            error(node, ts3.Diagnostics.A_binding_pattern_parameter_cannot_be_optional_in_an_implementation_signature);
          }
          if (node.name && ts3.isIdentifier(node.name) && (node.name.escapedText === "this" || node.name.escapedText === "new")) {
            if (func2.parameters.indexOf(node) !== 0) {
              error(node, ts3.Diagnostics.A_0_parameter_must_be_the_first_parameter, node.name.escapedText);
            }
            if (func2.kind === 167 || func2.kind === 171 || func2.kind === 176) {
              error(node, ts3.Diagnostics.A_constructor_cannot_have_a_this_parameter);
            }
            if (func2.kind === 210) {
              error(node, ts3.Diagnostics.An_arrow_function_cannot_have_a_this_parameter);
            }
            if (func2.kind === 168 || func2.kind === 169) {
              error(node, ts3.Diagnostics.get_and_set_accessors_cannot_declare_this_parameters);
            }
          }
          if (node.dotDotDotToken && !ts3.isBindingPattern(node.name) && !isTypeAssignableTo(getReducedType(getTypeOfSymbol(node.symbol)), anyReadonlyArrayType)) {
            error(node, ts3.Diagnostics.A_rest_parameter_must_be_of_an_array_type);
          }
        }
        function checkTypePredicate(node) {
          var parent = getTypePredicateParent(node);
          if (!parent) {
            error(node, ts3.Diagnostics.A_type_predicate_is_only_allowed_in_return_type_position_for_functions_and_methods);
            return;
          }
          var signature = getSignatureFromDeclaration(parent);
          var typePredicate = getTypePredicateOfSignature(signature);
          if (!typePredicate) {
            return;
          }
          checkSourceElement(node.type);
          var parameterName = node.parameterName;
          if (typePredicate.kind === 0 || typePredicate.kind === 2) {
            getTypeFromThisTypeNode(parameterName);
          } else {
            if (typePredicate.parameterIndex >= 0) {
              if (signatureHasRestParameter(signature) && typePredicate.parameterIndex === signature.parameters.length - 1) {
                error(parameterName, ts3.Diagnostics.A_type_predicate_cannot_reference_a_rest_parameter);
              } else {
                if (typePredicate.type) {
                  var leadingError = function() {
                    return ts3.chainDiagnosticMessages(void 0, ts3.Diagnostics.A_type_predicate_s_type_must_be_assignable_to_its_parameter_s_type);
                  };
                  checkTypeAssignableTo(typePredicate.type, getTypeOfSymbol(signature.parameters[typePredicate.parameterIndex]), node.type, void 0, leadingError);
                }
              }
            } else if (parameterName) {
              var hasReportedError = false;
              for (var _i = 0, _a2 = parent.parameters; _i < _a2.length; _i++) {
                var name = _a2[_i].name;
                if (ts3.isBindingPattern(name) && checkIfTypePredicateVariableIsDeclaredInBindingPattern(name, parameterName, typePredicate.parameterName)) {
                  hasReportedError = true;
                  break;
                }
              }
              if (!hasReportedError) {
                error(node.parameterName, ts3.Diagnostics.Cannot_find_parameter_0, typePredicate.parameterName);
              }
            }
          }
        }
        function getTypePredicateParent(node) {
          switch (node.parent.kind) {
            case 210:
            case 170:
            case 252:
            case 209:
            case 175:
            case 166:
            case 165:
              var parent = node.parent;
              if (node === parent.type) {
                return parent;
              }
          }
        }
        function checkIfTypePredicateVariableIsDeclaredInBindingPattern(pattern, predicateVariableNode, predicateVariableName) {
          for (var _i = 0, _a2 = pattern.elements; _i < _a2.length; _i++) {
            var element = _a2[_i];
            if (ts3.isOmittedExpression(element)) {
              continue;
            }
            var name = element.name;
            if (name.kind === 78 && name.escapedText === predicateVariableName) {
              error(predicateVariableNode, ts3.Diagnostics.A_type_predicate_cannot_reference_element_0_in_a_binding_pattern, predicateVariableName);
              return true;
            } else if (name.kind === 198 || name.kind === 197) {
              if (checkIfTypePredicateVariableIsDeclaredInBindingPattern(name, predicateVariableNode, predicateVariableName)) {
                return true;
              }
            }
          }
        }
        function checkSignatureDeclaration(node) {
          if (node.kind === 172) {
            checkGrammarIndexSignature(node);
          } else if (node.kind === 175 || node.kind === 252 || node.kind === 176 || node.kind === 170 || node.kind === 167 || node.kind === 171) {
            checkGrammarFunctionLikeDeclaration(node);
          }
          var functionFlags = ts3.getFunctionFlags(node);
          if (!(functionFlags & 4)) {
            if ((functionFlags & 3) === 3 && languageVersion < 99) {
              checkExternalEmitHelpers(node, 6144);
            }
            if ((functionFlags & 3) === 2 && languageVersion < 4) {
              checkExternalEmitHelpers(node, 64);
            }
            if ((functionFlags & 3) !== 0 && languageVersion < 2) {
              checkExternalEmitHelpers(node, 128);
            }
          }
          checkTypeParameters(node.typeParameters);
          ts3.forEach(node.parameters, checkParameter);
          if (node.type) {
            checkSourceElement(node.type);
          }
          if (produceDiagnostics) {
            checkCollisionWithArgumentsInGeneratedCode(node);
            var returnTypeNode = ts3.getEffectiveReturnTypeNode(node);
            if (noImplicitAny && !returnTypeNode) {
              switch (node.kind) {
                case 171:
                  error(node, ts3.Diagnostics.Construct_signature_which_lacks_return_type_annotation_implicitly_has_an_any_return_type);
                  break;
                case 170:
                  error(node, ts3.Diagnostics.Call_signature_which_lacks_return_type_annotation_implicitly_has_an_any_return_type);
                  break;
              }
            }
            if (returnTypeNode) {
              var functionFlags_1 = ts3.getFunctionFlags(node);
              if ((functionFlags_1 & (4 | 1)) === 1) {
                var returnType2 = getTypeFromTypeNode(returnTypeNode);
                if (returnType2 === voidType) {
                  error(returnTypeNode, ts3.Diagnostics.A_generator_cannot_have_a_void_type_annotation);
                } else {
                  var generatorYieldType = getIterationTypeOfGeneratorFunctionReturnType(0, returnType2, (functionFlags_1 & 2) !== 0) || anyType;
                  var generatorReturnType = getIterationTypeOfGeneratorFunctionReturnType(1, returnType2, (functionFlags_1 & 2) !== 0) || generatorYieldType;
                  var generatorNextType = getIterationTypeOfGeneratorFunctionReturnType(2, returnType2, (functionFlags_1 & 2) !== 0) || unknownType;
                  var generatorInstantiation = createGeneratorReturnType(generatorYieldType, generatorReturnType, generatorNextType, !!(functionFlags_1 & 2));
                  checkTypeAssignableTo(generatorInstantiation, returnType2, returnTypeNode);
                }
              } else if ((functionFlags_1 & 3) === 2) {
                checkAsyncFunctionReturnType(node, returnTypeNode);
              }
            }
            if (node.kind !== 172 && node.kind !== 309) {
              registerForUnusedIdentifiersCheck(node);
            }
          }
        }
        function checkClassForDuplicateDeclarations(node) {
          var instanceNames = new ts3.Map();
          var staticNames = new ts3.Map();
          var privateIdentifiers = new ts3.Map();
          for (var _i = 0, _a2 = node.members; _i < _a2.length; _i++) {
            var member = _a2[_i];
            if (member.kind === 167) {
              for (var _b = 0, _c = member.parameters; _b < _c.length; _b++) {
                var param = _c[_b];
                if (ts3.isParameterPropertyDeclaration(param, member) && !ts3.isBindingPattern(param.name)) {
                  addName(instanceNames, param.name, param.name.escapedText, 3);
                }
              }
            } else {
              var isStatic = ts3.hasSyntacticModifier(member, 32);
              var name = member.name;
              if (!name) {
                continue;
              }
              var isPrivate = ts3.isPrivateIdentifier(name);
              var privateStaticFlags = isPrivate && isStatic ? 16 : 0;
              var names = isPrivate ? privateIdentifiers : isStatic ? staticNames : instanceNames;
              var memberName = name && ts3.getPropertyNameForPropertyNameNode(name);
              if (memberName) {
                switch (member.kind) {
                  case 168:
                    addName(names, name, memberName, 1 | privateStaticFlags);
                    break;
                  case 169:
                    addName(names, name, memberName, 2 | privateStaticFlags);
                    break;
                  case 164:
                    addName(names, name, memberName, 3 | privateStaticFlags);
                    break;
                  case 166:
                    addName(names, name, memberName, 8 | privateStaticFlags);
                    break;
                }
              }
            }
          }
          function addName(names2, location, name2, meaning) {
            var prev = names2.get(name2);
            if (prev) {
              if ((prev & 16) !== (meaning & 16)) {
                error(location, ts3.Diagnostics.Duplicate_identifier_0_Static_and_instance_elements_cannot_share_the_same_private_name, ts3.getTextOfNode(location));
              } else {
                var prevIsMethod = !!(prev & 8);
                var isMethod = !!(meaning & 8);
                if (prevIsMethod || isMethod) {
                  if (prevIsMethod !== isMethod) {
                    error(location, ts3.Diagnostics.Duplicate_identifier_0, ts3.getTextOfNode(location));
                  }
                } else if (prev & meaning & ~16) {
                  error(location, ts3.Diagnostics.Duplicate_identifier_0, ts3.getTextOfNode(location));
                } else {
                  names2.set(name2, prev | meaning);
                }
              }
            } else {
              names2.set(name2, meaning);
            }
          }
        }
        function checkClassForStaticPropertyNameConflicts(node) {
          for (var _i = 0, _a2 = node.members; _i < _a2.length; _i++) {
            var member = _a2[_i];
            var memberNameNode = member.name;
            var isStatic = ts3.hasSyntacticModifier(member, 32);
            if (isStatic && memberNameNode) {
              var memberName = ts3.getPropertyNameForPropertyNameNode(memberNameNode);
              switch (memberName) {
                case "name":
                case "length":
                case "caller":
                case "arguments":
                case "prototype":
                  var message = ts3.Diagnostics.Static_property_0_conflicts_with_built_in_property_Function_0_of_constructor_function_1;
                  var className = getNameOfSymbolAsWritten(getSymbolOfNode(node));
                  error(memberNameNode, message, memberName, className);
                  break;
              }
            }
          }
        }
        function checkObjectTypeForDuplicateDeclarations(node) {
          var names = new ts3.Map();
          for (var _i = 0, _a2 = node.members; _i < _a2.length; _i++) {
            var member = _a2[_i];
            if (member.kind === 163) {
              var memberName = void 0;
              var name = member.name;
              switch (name.kind) {
                case 10:
                case 8:
                  memberName = name.text;
                  break;
                case 78:
                  memberName = ts3.idText(name);
                  break;
                default:
                  continue;
              }
              if (names.get(memberName)) {
                error(ts3.getNameOfDeclaration(member.symbol.valueDeclaration), ts3.Diagnostics.Duplicate_identifier_0, memberName);
                error(member.name, ts3.Diagnostics.Duplicate_identifier_0, memberName);
              } else {
                names.set(memberName, true);
              }
            }
          }
        }
        function checkTypeForDuplicateIndexSignatures(node) {
          if (node.kind === 254) {
            var nodeSymbol = getSymbolOfNode(node);
            if (nodeSymbol.declarations && nodeSymbol.declarations.length > 0 && nodeSymbol.declarations[0] !== node) {
              return;
            }
          }
          var indexSymbol = getIndexSymbol(getSymbolOfNode(node));
          if (indexSymbol === null || indexSymbol === void 0 ? void 0 : indexSymbol.declarations) {
            var seenNumericIndexer = false;
            var seenStringIndexer = false;
            for (var _i = 0, _a2 = indexSymbol.declarations; _i < _a2.length; _i++) {
              var decl = _a2[_i];
              var declaration = decl;
              if (declaration.parameters.length === 1 && declaration.parameters[0].type) {
                switch (declaration.parameters[0].type.kind) {
                  case 147:
                    if (!seenStringIndexer) {
                      seenStringIndexer = true;
                    } else {
                      error(declaration, ts3.Diagnostics.Duplicate_string_index_signature);
                    }
                    break;
                  case 144:
                    if (!seenNumericIndexer) {
                      seenNumericIndexer = true;
                    } else {
                      error(declaration, ts3.Diagnostics.Duplicate_number_index_signature);
                    }
                    break;
                }
              }
            }
          }
        }
        function checkPropertyDeclaration(node) {
          if (!checkGrammarDecoratorsAndModifiers(node) && !checkGrammarProperty(node))
            checkGrammarComputedPropertyName(node.name);
          checkVariableLikeDeclaration(node);
          setNodeLinksForPrivateIdentifierScope(node);
          if (ts3.isPrivateIdentifier(node.name) && ts3.hasStaticModifier(node) && node.initializer && languageVersion === 99 && !compilerOptions.useDefineForClassFields) {
            error(node.initializer, ts3.Diagnostics.Static_fields_with_private_names_can_t_have_initializers_when_the_useDefineForClassFields_flag_is_not_specified_with_a_target_of_esnext_Consider_adding_the_useDefineForClassFields_flag);
          }
        }
        function checkPropertySignature(node) {
          if (ts3.isPrivateIdentifier(node.name)) {
            error(node, ts3.Diagnostics.Private_identifiers_are_not_allowed_outside_class_bodies);
          }
          return checkPropertyDeclaration(node);
        }
        function checkMethodDeclaration(node) {
          if (!checkGrammarMethod(node))
            checkGrammarComputedPropertyName(node.name);
          checkFunctionOrMethodDeclaration(node);
          if (ts3.hasSyntacticModifier(node, 128) && node.kind === 166 && node.body) {
            error(node, ts3.Diagnostics.Method_0_cannot_have_an_implementation_because_it_is_marked_abstract, ts3.declarationNameToString(node.name));
          }
          if (ts3.isPrivateIdentifier(node.name) && !ts3.getContainingClass(node)) {
            error(node, ts3.Diagnostics.Private_identifiers_are_not_allowed_outside_class_bodies);
          }
          setNodeLinksForPrivateIdentifierScope(node);
        }
        function setNodeLinksForPrivateIdentifierScope(node) {
          if (ts3.isPrivateIdentifier(node.name) && languageVersion < 99) {
            for (var lexicalScope = ts3.getEnclosingBlockScopeContainer(node); !!lexicalScope; lexicalScope = ts3.getEnclosingBlockScopeContainer(lexicalScope)) {
              getNodeLinks(lexicalScope).flags |= 67108864;
            }
            if (ts3.isClassExpression(node.parent)) {
              var enclosingIterationStatement = getEnclosingIterationStatement(node.parent);
              if (enclosingIterationStatement) {
                getNodeLinks(node.name).flags |= 524288;
                getNodeLinks(enclosingIterationStatement).flags |= 65536;
              }
            }
          }
        }
        function checkConstructorDeclaration(node) {
          checkSignatureDeclaration(node);
          if (!checkGrammarConstructorTypeParameters(node))
            checkGrammarConstructorTypeAnnotation(node);
          checkSourceElement(node.body);
          var symbol = getSymbolOfNode(node);
          var firstDeclaration = ts3.getDeclarationOfKind(symbol, node.kind);
          if (node === firstDeclaration) {
            checkFunctionOrConstructorSymbol(symbol);
          }
          if (ts3.nodeIsMissing(node.body)) {
            return;
          }
          if (!produceDiagnostics) {
            return;
          }
          function isInstancePropertyWithInitializerOrPrivateIdentifierProperty(n2) {
            if (ts3.isPrivateIdentifierClassElementDeclaration(n2)) {
              return true;
            }
            return n2.kind === 164 && !ts3.hasSyntacticModifier(n2, 32) && !!n2.initializer;
          }
          var containingClassDecl = node.parent;
          if (ts3.getClassExtendsHeritageElement(containingClassDecl)) {
            captureLexicalThis(node.parent, containingClassDecl);
            var classExtendsNull = classDeclarationExtendsNull(containingClassDecl);
            var superCall = findFirstSuperCall(node.body);
            if (superCall) {
              if (classExtendsNull) {
                error(superCall, ts3.Diagnostics.A_constructor_cannot_contain_a_super_call_when_its_class_extends_null);
              }
              var superCallShouldBeFirst = (compilerOptions.target !== 99 || !useDefineForClassFields) && (ts3.some(node.parent.members, isInstancePropertyWithInitializerOrPrivateIdentifierProperty) || ts3.some(node.parameters, function(p) {
                return ts3.hasSyntacticModifier(p, 16476);
              }));
              if (superCallShouldBeFirst) {
                var statements = node.body.statements;
                var superCallStatement = void 0;
                for (var _i = 0, statements_4 = statements; _i < statements_4.length; _i++) {
                  var statement = statements_4[_i];
                  if (statement.kind === 234 && ts3.isSuperCall(statement.expression)) {
                    superCallStatement = statement;
                    break;
                  }
                  if (!ts3.isPrologueDirective(statement)) {
                    break;
                  }
                }
                if (!superCallStatement) {
                  error(node, ts3.Diagnostics.A_super_call_must_be_the_first_statement_in_the_constructor_when_a_class_contains_initialized_properties_parameter_properties_or_private_identifiers);
                }
              }
            } else if (!classExtendsNull) {
              error(node, ts3.Diagnostics.Constructors_for_derived_classes_must_contain_a_super_call);
            }
          }
        }
        function checkAccessorDeclaration(node) {
          if (produceDiagnostics) {
            if (!checkGrammarFunctionLikeDeclaration(node) && !checkGrammarAccessor(node))
              checkGrammarComputedPropertyName(node.name);
            checkDecorators(node);
            checkSignatureDeclaration(node);
            if (node.kind === 168) {
              if (!(node.flags & 8388608) && ts3.nodeIsPresent(node.body) && node.flags & 256) {
                if (!(node.flags & 512)) {
                  error(node.name, ts3.Diagnostics.A_get_accessor_must_return_a_value);
                }
              }
            }
            if (node.name.kind === 159) {
              checkComputedPropertyName(node.name);
            }
            if (hasBindableName(node)) {
              var symbol = getSymbolOfNode(node);
              var getter = ts3.getDeclarationOfKind(symbol, 168);
              var setter = ts3.getDeclarationOfKind(symbol, 169);
              if (getter && setter && !(getNodeCheckFlags(getter) & 1)) {
                getNodeLinks(getter).flags |= 1;
                var getterFlags = ts3.getEffectiveModifierFlags(getter);
                var setterFlags = ts3.getEffectiveModifierFlags(setter);
                if ((getterFlags & 128) !== (setterFlags & 128)) {
                  error(getter.name, ts3.Diagnostics.Accessors_must_both_be_abstract_or_non_abstract);
                  error(setter.name, ts3.Diagnostics.Accessors_must_both_be_abstract_or_non_abstract);
                }
                if (getterFlags & 16 && !(setterFlags & (16 | 8)) || getterFlags & 8 && !(setterFlags & 8)) {
                  error(getter.name, ts3.Diagnostics.A_get_accessor_must_be_at_least_as_accessible_as_the_setter);
                  error(setter.name, ts3.Diagnostics.A_get_accessor_must_be_at_least_as_accessible_as_the_setter);
                }
                var getterType = getAnnotatedAccessorType(getter);
                var setterType = getAnnotatedAccessorType(setter);
                if (getterType && setterType) {
                  checkTypeAssignableTo(getterType, setterType, getter, ts3.Diagnostics.The_return_type_of_a_get_accessor_must_be_assignable_to_its_set_accessor_type);
                }
              }
            }
            var returnType2 = getTypeOfAccessors(getSymbolOfNode(node));
            if (node.kind === 168) {
              checkAllCodePathsInNonVoidFunctionReturnOrThrow(node, returnType2);
            }
          }
          checkSourceElement(node.body);
          setNodeLinksForPrivateIdentifierScope(node);
        }
        function checkMissingDeclaration(node) {
          checkDecorators(node);
        }
        function getEffectiveTypeArguments(node, typeParameters) {
          return fillMissingTypeArguments(ts3.map(node.typeArguments, getTypeFromTypeNode), typeParameters, getMinTypeArgumentCount(typeParameters), ts3.isInJSFile(node));
        }
        function checkTypeArgumentConstraints(node, typeParameters) {
          var typeArguments;
          var mapper;
          var result2 = true;
          for (var i3 = 0; i3 < typeParameters.length; i3++) {
            var constraint = getConstraintOfTypeParameter(typeParameters[i3]);
            if (constraint) {
              if (!typeArguments) {
                typeArguments = getEffectiveTypeArguments(node, typeParameters);
                mapper = createTypeMapper(typeParameters, typeArguments);
              }
              result2 = result2 && checkTypeAssignableTo(typeArguments[i3], instantiateType(constraint, mapper), node.typeArguments[i3], ts3.Diagnostics.Type_0_does_not_satisfy_the_constraint_1);
            }
          }
          return result2;
        }
        function getTypeParametersForTypeReference(node) {
          var type3 = getTypeFromTypeReference(node);
          if (type3 !== errorType) {
            var symbol = getNodeLinks(node).resolvedSymbol;
            if (symbol) {
              return symbol.flags & 524288 && getSymbolLinks(symbol).typeParameters || (ts3.getObjectFlags(type3) & 4 ? type3.target.localTypeParameters : void 0);
            }
          }
          return void 0;
        }
        function checkTypeReferenceNode(node) {
          checkGrammarTypeArguments(node, node.typeArguments);
          if (node.kind === 174 && node.typeName.jsdocDotPos !== void 0 && !ts3.isInJSFile(node) && !ts3.isInJSDoc(node)) {
            grammarErrorAtPos(node, node.typeName.jsdocDotPos, 1, ts3.Diagnostics.JSDoc_types_can_only_be_used_inside_documentation_comments);
          }
          ts3.forEach(node.typeArguments, checkSourceElement);
          var type3 = getTypeFromTypeReference(node);
          if (type3 !== errorType) {
            if (node.typeArguments && produceDiagnostics) {
              var typeParameters = getTypeParametersForTypeReference(node);
              if (typeParameters) {
                checkTypeArgumentConstraints(node, typeParameters);
              }
            }
            var symbol = getNodeLinks(node).resolvedSymbol;
            if (symbol) {
              if (ts3.some(symbol.declarations, function(d) {
                return isTypeDeclaration(d) && !!(d.flags & 134217728);
              })) {
                addDeprecatedSuggestion(getDeprecatedSuggestionNode(node), symbol.declarations, symbol.escapedName);
              }
              if (type3.flags & 32 && symbol.flags & 8) {
                error(node, ts3.Diagnostics.Enum_type_0_has_members_with_initializers_that_are_not_literals, typeToString(type3));
              }
            }
          }
        }
        function getTypeArgumentConstraint(node) {
          var typeReferenceNode = ts3.tryCast(node.parent, ts3.isTypeReferenceType);
          if (!typeReferenceNode)
            return void 0;
          var typeParameters = getTypeParametersForTypeReference(typeReferenceNode);
          var constraint = getConstraintOfTypeParameter(typeParameters[typeReferenceNode.typeArguments.indexOf(node)]);
          return constraint && instantiateType(constraint, createTypeMapper(typeParameters, getEffectiveTypeArguments(typeReferenceNode, typeParameters)));
        }
        function checkTypeQuery(node) {
          getTypeFromTypeQueryNode(node);
        }
        function checkTypeLiteral(node) {
          ts3.forEach(node.members, checkSourceElement);
          if (produceDiagnostics) {
            var type3 = getTypeFromTypeLiteralOrFunctionOrConstructorTypeNode(node);
            checkIndexConstraints(type3);
            checkTypeForDuplicateIndexSignatures(node);
            checkObjectTypeForDuplicateDeclarations(node);
          }
        }
        function checkArrayType(node) {
          checkSourceElement(node.elementType);
        }
        function checkTupleType(node) {
          var elementTypes = node.elements;
          var seenOptionalElement = false;
          var seenRestElement = false;
          var hasNamedElement = ts3.some(elementTypes, ts3.isNamedTupleMember);
          for (var _i = 0, elementTypes_1 = elementTypes; _i < elementTypes_1.length; _i++) {
            var e2 = elementTypes_1[_i];
            if (e2.kind !== 193 && hasNamedElement) {
              grammarErrorOnNode(e2, ts3.Diagnostics.Tuple_members_must_all_have_names_or_all_not_have_names);
              break;
            }
            var flags = getTupleElementFlags(e2);
            if (flags & 8) {
              var type3 = getTypeFromTypeNode(e2.type);
              if (!isArrayLikeType(type3)) {
                error(e2, ts3.Diagnostics.A_rest_element_type_must_be_an_array_type);
                break;
              }
              if (isArrayType(type3) || isTupleType(type3) && type3.target.combinedFlags & 4) {
                seenRestElement = true;
              }
            } else if (flags & 4) {
              if (seenRestElement) {
                grammarErrorOnNode(e2, ts3.Diagnostics.A_rest_element_cannot_follow_another_rest_element);
                break;
              }
              seenRestElement = true;
            } else if (flags & 2) {
              if (seenRestElement) {
                grammarErrorOnNode(e2, ts3.Diagnostics.An_optional_element_cannot_follow_a_rest_element);
                break;
              }
              seenOptionalElement = true;
            } else if (seenOptionalElement) {
              grammarErrorOnNode(e2, ts3.Diagnostics.A_required_element_cannot_follow_an_optional_element);
              break;
            }
          }
          ts3.forEach(node.elements, checkSourceElement);
          getTypeFromTypeNode(node);
        }
        function checkUnionOrIntersectionType(node) {
          ts3.forEach(node.types, checkSourceElement);
          getTypeFromTypeNode(node);
        }
        function checkIndexedAccessIndexType(type3, accessNode) {
          if (!(type3.flags & 8388608)) {
            return type3;
          }
          var objectType = type3.objectType;
          var indexType = type3.indexType;
          if (isTypeAssignableTo(indexType, getIndexType(objectType, false))) {
            if (accessNode.kind === 203 && ts3.isAssignmentTarget(accessNode) && ts3.getObjectFlags(objectType) & 32 && getMappedTypeModifiers(objectType) & 1) {
              error(accessNode, ts3.Diagnostics.Index_signature_in_type_0_only_permits_reading, typeToString(objectType));
            }
            return type3;
          }
          var apparentObjectType = getApparentType(objectType);
          if (getIndexInfoOfType(apparentObjectType, 1) && isTypeAssignableToKind(indexType, 296)) {
            return type3;
          }
          if (isGenericObjectType(objectType)) {
            var propertyName_1 = getPropertyNameFromIndex(indexType, accessNode);
            if (propertyName_1) {
              var propertySymbol = forEachType(apparentObjectType, function(t2) {
                return getPropertyOfType(t2, propertyName_1);
              });
              if (propertySymbol && ts3.getDeclarationModifierFlagsFromSymbol(propertySymbol) & 24) {
                error(accessNode, ts3.Diagnostics.Private_or_protected_member_0_cannot_be_accessed_on_a_type_parameter, ts3.unescapeLeadingUnderscores(propertyName_1));
                return errorType;
              }
            }
          }
          error(accessNode, ts3.Diagnostics.Type_0_cannot_be_used_to_index_type_1, typeToString(indexType), typeToString(objectType));
          return errorType;
        }
        function checkIndexedAccessType(node) {
          checkSourceElement(node.objectType);
          checkSourceElement(node.indexType);
          checkIndexedAccessIndexType(getTypeFromIndexedAccessTypeNode(node), node);
        }
        function checkMappedType(node) {
          checkSourceElement(node.typeParameter);
          checkSourceElement(node.nameType);
          checkSourceElement(node.type);
          if (!node.type) {
            reportImplicitAny(node, anyType);
          }
          var type3 = getTypeFromMappedTypeNode(node);
          var nameType = getNameTypeFromMappedType(type3);
          if (nameType) {
            checkTypeAssignableTo(nameType, keyofConstraintType, node.nameType);
          } else {
            var constraintType = getConstraintTypeFromMappedType(type3);
            checkTypeAssignableTo(constraintType, keyofConstraintType, ts3.getEffectiveConstraintOfTypeParameter(node.typeParameter));
          }
        }
        function checkThisType(node) {
          getTypeFromThisTypeNode(node);
        }
        function checkTypeOperator(node) {
          checkGrammarTypeOperatorNode(node);
          checkSourceElement(node.type);
        }
        function checkConditionalType(node) {
          ts3.forEachChild(node, checkSourceElement);
        }
        function checkInferType(node) {
          if (!ts3.findAncestor(node, function(n2) {
            return n2.parent && n2.parent.kind === 185 && n2.parent.extendsType === n2;
          })) {
            grammarErrorOnNode(node, ts3.Diagnostics.infer_declarations_are_only_permitted_in_the_extends_clause_of_a_conditional_type);
          }
          checkSourceElement(node.typeParameter);
          registerForUnusedIdentifiersCheck(node);
        }
        function checkTemplateLiteralType(node) {
          for (var _i = 0, _a2 = node.templateSpans; _i < _a2.length; _i++) {
            var span = _a2[_i];
            checkSourceElement(span.type);
            var type3 = getTypeFromTypeNode(span.type);
            checkTypeAssignableTo(type3, templateConstraintType, span.type);
          }
          getTypeFromTypeNode(node);
        }
        function checkImportType(node) {
          checkSourceElement(node.argument);
          getTypeFromTypeNode(node);
        }
        function checkNamedTupleMember(node) {
          if (node.dotDotDotToken && node.questionToken) {
            grammarErrorOnNode(node, ts3.Diagnostics.A_tuple_member_cannot_be_both_optional_and_rest);
          }
          if (node.type.kind === 181) {
            grammarErrorOnNode(node.type, ts3.Diagnostics.A_labeled_tuple_element_is_declared_as_optional_with_a_question_mark_after_the_name_and_before_the_colon_rather_than_after_the_type);
          }
          if (node.type.kind === 182) {
            grammarErrorOnNode(node.type, ts3.Diagnostics.A_labeled_tuple_element_is_declared_as_rest_with_a_before_the_name_rather_than_before_the_type);
          }
          checkSourceElement(node.type);
          getTypeFromTypeNode(node);
        }
        function isPrivateWithinAmbient(node) {
          return (ts3.hasEffectiveModifier(node, 8) || ts3.isPrivateIdentifierClassElementDeclaration(node)) && !!(node.flags & 8388608);
        }
        function getEffectiveDeclarationFlags(n2, flagsToCheck) {
          var flags = ts3.getCombinedModifierFlags(n2);
          if (n2.parent.kind !== 254 && n2.parent.kind !== 253 && n2.parent.kind !== 222 && n2.flags & 8388608) {
            if (!(flags & 2) && !(ts3.isModuleBlock(n2.parent) && ts3.isModuleDeclaration(n2.parent.parent) && ts3.isGlobalScopeAugmentation(n2.parent.parent))) {
              flags |= 1;
            }
            flags |= 2;
          }
          return flags & flagsToCheck;
        }
        function checkFunctionOrConstructorSymbol(symbol) {
          if (!produceDiagnostics) {
            return;
          }
          function getCanonicalOverload(overloads, implementation) {
            var implementationSharesContainerWithFirstOverload = implementation !== void 0 && implementation.parent === overloads[0].parent;
            return implementationSharesContainerWithFirstOverload ? implementation : overloads[0];
          }
          function checkFlagAgreementBetweenOverloads(overloads, implementation, flagsToCheck2, someOverloadFlags, allOverloadFlags) {
            var someButNotAllOverloadFlags = someOverloadFlags ^ allOverloadFlags;
            if (someButNotAllOverloadFlags !== 0) {
              var canonicalFlags_1 = getEffectiveDeclarationFlags(getCanonicalOverload(overloads, implementation), flagsToCheck2);
              ts3.forEach(overloads, function(o2) {
                var deviation = getEffectiveDeclarationFlags(o2, flagsToCheck2) ^ canonicalFlags_1;
                if (deviation & 1) {
                  error(ts3.getNameOfDeclaration(o2), ts3.Diagnostics.Overload_signatures_must_all_be_exported_or_non_exported);
                } else if (deviation & 2) {
                  error(ts3.getNameOfDeclaration(o2), ts3.Diagnostics.Overload_signatures_must_all_be_ambient_or_non_ambient);
                } else if (deviation & (8 | 16)) {
                  error(ts3.getNameOfDeclaration(o2) || o2, ts3.Diagnostics.Overload_signatures_must_all_be_public_private_or_protected);
                } else if (deviation & 128) {
                  error(ts3.getNameOfDeclaration(o2), ts3.Diagnostics.Overload_signatures_must_all_be_abstract_or_non_abstract);
                }
              });
            }
          }
          function checkQuestionTokenAgreementBetweenOverloads(overloads, implementation, someHaveQuestionToken2, allHaveQuestionToken2) {
            if (someHaveQuestionToken2 !== allHaveQuestionToken2) {
              var canonicalHasQuestionToken_1 = ts3.hasQuestionToken(getCanonicalOverload(overloads, implementation));
              ts3.forEach(overloads, function(o2) {
                var deviation = ts3.hasQuestionToken(o2) !== canonicalHasQuestionToken_1;
                if (deviation) {
                  error(ts3.getNameOfDeclaration(o2), ts3.Diagnostics.Overload_signatures_must_all_be_optional_or_required);
                }
              });
            }
          }
          var flagsToCheck = 1 | 2 | 8 | 16 | 128;
          var someNodeFlags = 0;
          var allNodeFlags = flagsToCheck;
          var someHaveQuestionToken = false;
          var allHaveQuestionToken = true;
          var hasOverloads = false;
          var bodyDeclaration;
          var lastSeenNonAmbientDeclaration;
          var previousDeclaration;
          var declarations = symbol.declarations;
          var isConstructor = (symbol.flags & 16384) !== 0;
          function reportImplementationExpectedError(node2) {
            if (node2.name && ts3.nodeIsMissing(node2.name)) {
              return;
            }
            var seen = false;
            var subsequentNode = ts3.forEachChild(node2.parent, function(c2) {
              if (seen) {
                return c2;
              } else {
                seen = c2 === node2;
              }
            });
            if (subsequentNode && subsequentNode.pos === node2.end) {
              if (subsequentNode.kind === node2.kind) {
                var errorNode_1 = subsequentNode.name || subsequentNode;
                var subsequentName = subsequentNode.name;
                if (node2.name && subsequentName && (ts3.isPrivateIdentifier(node2.name) && ts3.isPrivateIdentifier(subsequentName) && node2.name.escapedText === subsequentName.escapedText || ts3.isComputedPropertyName(node2.name) && ts3.isComputedPropertyName(subsequentName) || ts3.isPropertyNameLiteral(node2.name) && ts3.isPropertyNameLiteral(subsequentName) && ts3.getEscapedTextOfIdentifierOrLiteral(node2.name) === ts3.getEscapedTextOfIdentifierOrLiteral(subsequentName))) {
                  var reportError = (node2.kind === 166 || node2.kind === 165) && ts3.hasSyntacticModifier(node2, 32) !== ts3.hasSyntacticModifier(subsequentNode, 32);
                  if (reportError) {
                    var diagnostic = ts3.hasSyntacticModifier(node2, 32) ? ts3.Diagnostics.Function_overload_must_be_static : ts3.Diagnostics.Function_overload_must_not_be_static;
                    error(errorNode_1, diagnostic);
                  }
                  return;
                }
                if (ts3.nodeIsPresent(subsequentNode.body)) {
                  error(errorNode_1, ts3.Diagnostics.Function_implementation_name_must_be_0, ts3.declarationNameToString(node2.name));
                  return;
                }
              }
            }
            var errorNode = node2.name || node2;
            if (isConstructor) {
              error(errorNode, ts3.Diagnostics.Constructor_implementation_is_missing);
            } else {
              if (ts3.hasSyntacticModifier(node2, 128)) {
                error(errorNode, ts3.Diagnostics.All_declarations_of_an_abstract_method_must_be_consecutive);
              } else {
                error(errorNode, ts3.Diagnostics.Function_implementation_is_missing_or_not_immediately_following_the_declaration);
              }
            }
          }
          var duplicateFunctionDeclaration = false;
          var multipleConstructorImplementation = false;
          var hasNonAmbientClass = false;
          var functionDeclarations = [];
          if (declarations) {
            for (var _i = 0, declarations_4 = declarations; _i < declarations_4.length; _i++) {
              var current = declarations_4[_i];
              var node = current;
              var inAmbientContext = node.flags & 8388608;
              var inAmbientContextOrInterface = node.parent && (node.parent.kind === 254 || node.parent.kind === 178) || inAmbientContext;
              if (inAmbientContextOrInterface) {
                previousDeclaration = void 0;
              }
              if ((node.kind === 253 || node.kind === 222) && !inAmbientContext) {
                hasNonAmbientClass = true;
              }
              if (node.kind === 252 || node.kind === 166 || node.kind === 165 || node.kind === 167) {
                functionDeclarations.push(node);
                var currentNodeFlags = getEffectiveDeclarationFlags(node, flagsToCheck);
                someNodeFlags |= currentNodeFlags;
                allNodeFlags &= currentNodeFlags;
                someHaveQuestionToken = someHaveQuestionToken || ts3.hasQuestionToken(node);
                allHaveQuestionToken = allHaveQuestionToken && ts3.hasQuestionToken(node);
                var bodyIsPresent = ts3.nodeIsPresent(node.body);
                if (bodyIsPresent && bodyDeclaration) {
                  if (isConstructor) {
                    multipleConstructorImplementation = true;
                  } else {
                    duplicateFunctionDeclaration = true;
                  }
                } else if ((previousDeclaration === null || previousDeclaration === void 0 ? void 0 : previousDeclaration.parent) === node.parent && previousDeclaration.end !== node.pos) {
                  reportImplementationExpectedError(previousDeclaration);
                }
                if (bodyIsPresent) {
                  if (!bodyDeclaration) {
                    bodyDeclaration = node;
                  }
                } else {
                  hasOverloads = true;
                }
                previousDeclaration = node;
                if (!inAmbientContextOrInterface) {
                  lastSeenNonAmbientDeclaration = node;
                }
              }
            }
          }
          if (multipleConstructorImplementation) {
            ts3.forEach(functionDeclarations, function(declaration) {
              error(declaration, ts3.Diagnostics.Multiple_constructor_implementations_are_not_allowed);
            });
          }
          if (duplicateFunctionDeclaration) {
            ts3.forEach(functionDeclarations, function(declaration) {
              error(ts3.getNameOfDeclaration(declaration) || declaration, ts3.Diagnostics.Duplicate_function_implementation);
            });
          }
          if (hasNonAmbientClass && !isConstructor && symbol.flags & 16) {
            ts3.forEach(declarations, function(declaration) {
              addDuplicateDeclarationError(declaration, ts3.Diagnostics.Duplicate_identifier_0, ts3.symbolName(symbol), declarations);
            });
          }
          if (lastSeenNonAmbientDeclaration && !lastSeenNonAmbientDeclaration.body && !ts3.hasSyntacticModifier(lastSeenNonAmbientDeclaration, 128) && !lastSeenNonAmbientDeclaration.questionToken) {
            reportImplementationExpectedError(lastSeenNonAmbientDeclaration);
          }
          if (hasOverloads) {
            if (declarations) {
              checkFlagAgreementBetweenOverloads(declarations, bodyDeclaration, flagsToCheck, someNodeFlags, allNodeFlags);
              checkQuestionTokenAgreementBetweenOverloads(declarations, bodyDeclaration, someHaveQuestionToken, allHaveQuestionToken);
            }
            if (bodyDeclaration) {
              var signatures = getSignaturesOfSymbol(symbol);
              var bodySignature = getSignatureFromDeclaration(bodyDeclaration);
              for (var _a2 = 0, signatures_10 = signatures; _a2 < signatures_10.length; _a2++) {
                var signature = signatures_10[_a2];
                if (!isImplementationCompatibleWithOverload(bodySignature, signature)) {
                  ts3.addRelatedInfo(error(signature.declaration, ts3.Diagnostics.This_overload_signature_is_not_compatible_with_its_implementation_signature), ts3.createDiagnosticForNode(bodyDeclaration, ts3.Diagnostics.The_implementation_signature_is_declared_here));
                  break;
                }
              }
            }
          }
        }
        function checkExportsOnMergedDeclarations(node) {
          if (!produceDiagnostics) {
            return;
          }
          var symbol = node.localSymbol;
          if (!symbol) {
            symbol = getSymbolOfNode(node);
            if (!symbol.exportSymbol) {
              return;
            }
          }
          if (ts3.getDeclarationOfKind(symbol, node.kind) !== node) {
            return;
          }
          var exportedDeclarationSpaces = 0;
          var nonExportedDeclarationSpaces = 0;
          var defaultExportedDeclarationSpaces = 0;
          for (var _i = 0, _a2 = symbol.declarations; _i < _a2.length; _i++) {
            var d = _a2[_i];
            var declarationSpaces = getDeclarationSpaces(d);
            var effectiveDeclarationFlags = getEffectiveDeclarationFlags(d, 1 | 512);
            if (effectiveDeclarationFlags & 1) {
              if (effectiveDeclarationFlags & 512) {
                defaultExportedDeclarationSpaces |= declarationSpaces;
              } else {
                exportedDeclarationSpaces |= declarationSpaces;
              }
            } else {
              nonExportedDeclarationSpaces |= declarationSpaces;
            }
          }
          var nonDefaultExportedDeclarationSpaces = exportedDeclarationSpaces | nonExportedDeclarationSpaces;
          var commonDeclarationSpacesForExportsAndLocals = exportedDeclarationSpaces & nonExportedDeclarationSpaces;
          var commonDeclarationSpacesForDefaultAndNonDefault = defaultExportedDeclarationSpaces & nonDefaultExportedDeclarationSpaces;
          if (commonDeclarationSpacesForExportsAndLocals || commonDeclarationSpacesForDefaultAndNonDefault) {
            for (var _b = 0, _c = symbol.declarations; _b < _c.length; _b++) {
              var d = _c[_b];
              var declarationSpaces = getDeclarationSpaces(d);
              var name = ts3.getNameOfDeclaration(d);
              if (declarationSpaces & commonDeclarationSpacesForDefaultAndNonDefault) {
                error(name, ts3.Diagnostics.Merged_declaration_0_cannot_include_a_default_export_declaration_Consider_adding_a_separate_export_default_0_declaration_instead, ts3.declarationNameToString(name));
              } else if (declarationSpaces & commonDeclarationSpacesForExportsAndLocals) {
                error(name, ts3.Diagnostics.Individual_declarations_in_merged_declaration_0_must_be_all_exported_or_all_local, ts3.declarationNameToString(name));
              }
            }
          }
          function getDeclarationSpaces(decl) {
            var d2 = decl;
            switch (d2.kind) {
              case 254:
              case 255:
              case 335:
              case 328:
              case 329:
                return 2;
              case 257:
                return ts3.isAmbientModule(d2) || ts3.getModuleInstanceState(d2) !== 0 ? 4 | 1 : 4;
              case 253:
              case 256:
              case 292:
                return 2 | 1;
              case 298:
                return 2 | 1 | 4;
              case 267:
              case 217:
                var node_2 = d2;
                var expression = ts3.isExportAssignment(node_2) ? node_2.expression : node_2.right;
                if (!ts3.isEntityNameExpression(expression)) {
                  return 1;
                }
                d2 = expression;
              case 261:
              case 264:
              case 263:
                var result_13 = 0;
                var target = resolveAlias(getSymbolOfNode(d2));
                ts3.forEach(target.declarations, function(d3) {
                  result_13 |= getDeclarationSpaces(d3);
                });
                return result_13;
              case 250:
              case 199:
              case 252:
              case 266:
              case 78:
                return 1;
              default:
                return ts3.Debug.failBadSyntaxKind(d2);
            }
          }
        }
        function getAwaitedTypeOfPromise(type3, errorNode, diagnosticMessage, arg0) {
          var promisedType = getPromisedTypeOfPromise(type3, errorNode);
          return promisedType && getAwaitedType(promisedType, errorNode, diagnosticMessage, arg0);
        }
        function getPromisedTypeOfPromise(type3, errorNode) {
          if (isTypeAny(type3)) {
            return void 0;
          }
          var typeAsPromise = type3;
          if (typeAsPromise.promisedTypeOfPromise) {
            return typeAsPromise.promisedTypeOfPromise;
          }
          if (isReferenceToType(type3, getGlobalPromiseType(false))) {
            return typeAsPromise.promisedTypeOfPromise = getTypeArguments(type3)[0];
          }
          var thenFunction = getTypeOfPropertyOfType(type3, "then");
          if (isTypeAny(thenFunction)) {
            return void 0;
          }
          var thenSignatures = thenFunction ? getSignaturesOfType(thenFunction, 0) : ts3.emptyArray;
          if (thenSignatures.length === 0) {
            if (errorNode) {
              error(errorNode, ts3.Diagnostics.A_promise_must_have_a_then_method);
            }
            return void 0;
          }
          var onfulfilledParameterType = getTypeWithFacts(getUnionType(ts3.map(thenSignatures, getTypeOfFirstParameterOfSignature)), 2097152);
          if (isTypeAny(onfulfilledParameterType)) {
            return void 0;
          }
          var onfulfilledParameterSignatures = getSignaturesOfType(onfulfilledParameterType, 0);
          if (onfulfilledParameterSignatures.length === 0) {
            if (errorNode) {
              error(errorNode, ts3.Diagnostics.The_first_parameter_of_the_then_method_of_a_promise_must_be_a_callback);
            }
            return void 0;
          }
          return typeAsPromise.promisedTypeOfPromise = getUnionType(ts3.map(onfulfilledParameterSignatures, getTypeOfFirstParameterOfSignature), 2);
        }
        function checkAwaitedType(type3, errorNode, diagnosticMessage, arg0) {
          var awaitedType = getAwaitedType(type3, errorNode, diagnosticMessage, arg0);
          return awaitedType || errorType;
        }
        function isThenableType(type3) {
          var thenFunction = getTypeOfPropertyOfType(type3, "then");
          return !!thenFunction && getSignaturesOfType(getTypeWithFacts(thenFunction, 2097152), 0).length > 0;
        }
        function getAwaitedType(type3, errorNode, diagnosticMessage, arg0) {
          if (isTypeAny(type3)) {
            return type3;
          }
          var typeAsAwaitable = type3;
          if (typeAsAwaitable.awaitedTypeOfType) {
            return typeAsAwaitable.awaitedTypeOfType;
          }
          return typeAsAwaitable.awaitedTypeOfType = mapType(type3, errorNode ? function(constituentType) {
            return getAwaitedTypeWorker(constituentType, errorNode, diagnosticMessage, arg0);
          } : getAwaitedTypeWorker);
        }
        function getAwaitedTypeWorker(type3, errorNode, diagnosticMessage, arg0) {
          var typeAsAwaitable = type3;
          if (typeAsAwaitable.awaitedTypeOfType) {
            return typeAsAwaitable.awaitedTypeOfType;
          }
          var promisedType = getPromisedTypeOfPromise(type3);
          if (promisedType) {
            if (type3.id === promisedType.id || awaitedTypeStack.lastIndexOf(promisedType.id) >= 0) {
              if (errorNode) {
                error(errorNode, ts3.Diagnostics.Type_is_referenced_directly_or_indirectly_in_the_fulfillment_callback_of_its_own_then_method);
              }
              return void 0;
            }
            awaitedTypeStack.push(type3.id);
            var awaitedType = getAwaitedType(promisedType, errorNode, diagnosticMessage, arg0);
            awaitedTypeStack.pop();
            if (!awaitedType) {
              return void 0;
            }
            return typeAsAwaitable.awaitedTypeOfType = awaitedType;
          }
          if (isThenableType(type3)) {
            if (errorNode) {
              if (!diagnosticMessage)
                return ts3.Debug.fail();
              error(errorNode, diagnosticMessage, arg0);
            }
            return void 0;
          }
          return typeAsAwaitable.awaitedTypeOfType = type3;
        }
        function checkAsyncFunctionReturnType(node, returnTypeNode) {
          var returnType2 = getTypeFromTypeNode(returnTypeNode);
          if (languageVersion >= 2) {
            if (returnType2 === errorType) {
              return;
            }
            var globalPromiseType = getGlobalPromiseType(true);
            if (globalPromiseType !== emptyGenericType && !isReferenceToType(returnType2, globalPromiseType)) {
              error(returnTypeNode, ts3.Diagnostics.The_return_type_of_an_async_function_or_method_must_be_the_global_Promise_T_type_Did_you_mean_to_write_Promise_0, typeToString(getAwaitedType(returnType2) || voidType));
              return;
            }
          } else {
            markTypeNodeAsReferenced(returnTypeNode);
            if (returnType2 === errorType) {
              return;
            }
            var promiseConstructorName = ts3.getEntityNameFromTypeNode(returnTypeNode);
            if (promiseConstructorName === void 0) {
              error(returnTypeNode, ts3.Diagnostics.Type_0_is_not_a_valid_async_function_return_type_in_ES5_SlashES3_because_it_does_not_refer_to_a_Promise_compatible_constructor_value, typeToString(returnType2));
              return;
            }
            var promiseConstructorSymbol = resolveEntityName(promiseConstructorName, 111551, true);
            var promiseConstructorType = promiseConstructorSymbol ? getTypeOfSymbol(promiseConstructorSymbol) : errorType;
            if (promiseConstructorType === errorType) {
              if (promiseConstructorName.kind === 78 && promiseConstructorName.escapedText === "Promise" && getTargetType(returnType2) === getGlobalPromiseType(false)) {
                error(returnTypeNode, ts3.Diagnostics.An_async_function_or_method_in_ES5_SlashES3_requires_the_Promise_constructor_Make_sure_you_have_a_declaration_for_the_Promise_constructor_or_include_ES2015_in_your_lib_option);
              } else {
                error(returnTypeNode, ts3.Diagnostics.Type_0_is_not_a_valid_async_function_return_type_in_ES5_SlashES3_because_it_does_not_refer_to_a_Promise_compatible_constructor_value, ts3.entityNameToString(promiseConstructorName));
              }
              return;
            }
            var globalPromiseConstructorLikeType = getGlobalPromiseConstructorLikeType(true);
            if (globalPromiseConstructorLikeType === emptyObjectType) {
              error(returnTypeNode, ts3.Diagnostics.Type_0_is_not_a_valid_async_function_return_type_in_ES5_SlashES3_because_it_does_not_refer_to_a_Promise_compatible_constructor_value, ts3.entityNameToString(promiseConstructorName));
              return;
            }
            if (!checkTypeAssignableTo(promiseConstructorType, globalPromiseConstructorLikeType, returnTypeNode, ts3.Diagnostics.Type_0_is_not_a_valid_async_function_return_type_in_ES5_SlashES3_because_it_does_not_refer_to_a_Promise_compatible_constructor_value)) {
              return;
            }
            var rootName = promiseConstructorName && ts3.getFirstIdentifier(promiseConstructorName);
            var collidingSymbol = getSymbol(node.locals, rootName.escapedText, 111551);
            if (collidingSymbol) {
              error(collidingSymbol.valueDeclaration, ts3.Diagnostics.Duplicate_identifier_0_Compiler_uses_declaration_1_to_support_async_functions, ts3.idText(rootName), ts3.entityNameToString(promiseConstructorName));
              return;
            }
          }
          checkAwaitedType(returnType2, node, ts3.Diagnostics.The_return_type_of_an_async_function_must_either_be_a_valid_promise_or_must_not_contain_a_callable_then_member);
        }
        function checkDecorator(node) {
          var signature = getResolvedSignature(node);
          checkDeprecatedSignature(signature, node);
          var returnType2 = getReturnTypeOfSignature(signature);
          if (returnType2.flags & 1) {
            return;
          }
          var expectedReturnType;
          var headMessage = getDiagnosticHeadMessageForDecoratorResolution(node);
          var errorInfo;
          switch (node.parent.kind) {
            case 253:
              var classSymbol = getSymbolOfNode(node.parent);
              var classConstructorType = getTypeOfSymbol(classSymbol);
              expectedReturnType = getUnionType([classConstructorType, voidType]);
              break;
            case 161:
              expectedReturnType = voidType;
              errorInfo = ts3.chainDiagnosticMessages(void 0, ts3.Diagnostics.The_return_type_of_a_parameter_decorator_function_must_be_either_void_or_any);
              break;
            case 164:
              expectedReturnType = voidType;
              errorInfo = ts3.chainDiagnosticMessages(void 0, ts3.Diagnostics.The_return_type_of_a_property_decorator_function_must_be_either_void_or_any);
              break;
            case 166:
            case 168:
            case 169:
              var methodType = getTypeOfNode(node.parent);
              var descriptorType = createTypedPropertyDescriptorType(methodType);
              expectedReturnType = getUnionType([descriptorType, voidType]);
              break;
            default:
              return ts3.Debug.fail();
          }
          checkTypeAssignableTo(returnType2, expectedReturnType, node, headMessage, function() {
            return errorInfo;
          });
        }
        function markTypeNodeAsReferenced(node) {
          markEntityNameOrEntityExpressionAsReference(node && ts3.getEntityNameFromTypeNode(node));
        }
        function markEntityNameOrEntityExpressionAsReference(typeName) {
          if (!typeName)
            return;
          var rootName = ts3.getFirstIdentifier(typeName);
          var meaning = (typeName.kind === 78 ? 788968 : 1920) | 2097152;
          var rootSymbol = resolveName(rootName, rootName.escapedText, meaning, void 0, void 0, true);
          if (rootSymbol && rootSymbol.flags & 2097152 && symbolIsValue(rootSymbol) && !isConstEnumOrConstEnumOnlyModule(resolveAlias(rootSymbol)) && !getTypeOnlyAliasDeclaration(rootSymbol)) {
            markAliasSymbolAsReferenced(rootSymbol);
          }
        }
        function markDecoratorMedataDataTypeNodeAsReferenced(node) {
          var entityName = getEntityNameForDecoratorMetadata(node);
          if (entityName && ts3.isEntityName(entityName)) {
            markEntityNameOrEntityExpressionAsReference(entityName);
          }
        }
        function getEntityNameForDecoratorMetadata(node) {
          if (node) {
            switch (node.kind) {
              case 184:
              case 183:
                return getEntityNameForDecoratorMetadataFromTypeList(node.types);
              case 185:
                return getEntityNameForDecoratorMetadataFromTypeList([node.trueType, node.falseType]);
              case 187:
              case 193:
                return getEntityNameForDecoratorMetadata(node.type);
              case 174:
                return node.typeName;
            }
          }
        }
        function getEntityNameForDecoratorMetadataFromTypeList(types2) {
          var commonEntityName;
          for (var _i = 0, types_23 = types2; _i < types_23.length; _i++) {
            var typeNode = types_23[_i];
            while (typeNode.kind === 187 || typeNode.kind === 193) {
              typeNode = typeNode.type;
            }
            if (typeNode.kind === 141) {
              continue;
            }
            if (!strictNullChecks && (typeNode.kind === 192 && typeNode.literal.kind === 103 || typeNode.kind === 150)) {
              continue;
            }
            var individualEntityName = getEntityNameForDecoratorMetadata(typeNode);
            if (!individualEntityName) {
              return void 0;
            }
            if (commonEntityName) {
              if (!ts3.isIdentifier(commonEntityName) || !ts3.isIdentifier(individualEntityName) || commonEntityName.escapedText !== individualEntityName.escapedText) {
                return void 0;
              }
            } else {
              commonEntityName = individualEntityName;
            }
          }
          return commonEntityName;
        }
        function getParameterTypeNodeForDecoratorCheck(node) {
          var typeNode = ts3.getEffectiveTypeAnnotationNode(node);
          return ts3.isRestParameter(node) ? ts3.getRestParameterElementType(typeNode) : typeNode;
        }
        function checkDecorators(node) {
          if (!node.decorators) {
            return;
          }
          if (!ts3.nodeCanBeDecorated(node, node.parent, node.parent.parent)) {
            return;
          }
          if (!compilerOptions.experimentalDecorators) {
            error(node, ts3.Diagnostics.Experimental_support_for_decorators_is_a_feature_that_is_subject_to_change_in_a_future_release_Set_the_experimentalDecorators_option_in_your_tsconfig_or_jsconfig_to_remove_this_warning);
          }
          var firstDecorator = node.decorators[0];
          checkExternalEmitHelpers(firstDecorator, 8);
          if (node.kind === 161) {
            checkExternalEmitHelpers(firstDecorator, 32);
          }
          if (compilerOptions.emitDecoratorMetadata) {
            checkExternalEmitHelpers(firstDecorator, 16);
            switch (node.kind) {
              case 253:
                var constructor = ts3.getFirstConstructorWithBody(node);
                if (constructor) {
                  for (var _i = 0, _a2 = constructor.parameters; _i < _a2.length; _i++) {
                    var parameter = _a2[_i];
                    markDecoratorMedataDataTypeNodeAsReferenced(getParameterTypeNodeForDecoratorCheck(parameter));
                  }
                }
                break;
              case 168:
              case 169:
                var otherKind = node.kind === 168 ? 169 : 168;
                var otherAccessor = ts3.getDeclarationOfKind(getSymbolOfNode(node), otherKind);
                markDecoratorMedataDataTypeNodeAsReferenced(getAnnotatedAccessorTypeNode(node) || otherAccessor && getAnnotatedAccessorTypeNode(otherAccessor));
                break;
              case 166:
                for (var _b = 0, _c = node.parameters; _b < _c.length; _b++) {
                  var parameter = _c[_b];
                  markDecoratorMedataDataTypeNodeAsReferenced(getParameterTypeNodeForDecoratorCheck(parameter));
                }
                markDecoratorMedataDataTypeNodeAsReferenced(ts3.getEffectiveReturnTypeNode(node));
                break;
              case 164:
                markDecoratorMedataDataTypeNodeAsReferenced(ts3.getEffectiveTypeAnnotationNode(node));
                break;
              case 161:
                markDecoratorMedataDataTypeNodeAsReferenced(getParameterTypeNodeForDecoratorCheck(node));
                var containingSignature = node.parent;
                for (var _d = 0, _e = containingSignature.parameters; _d < _e.length; _d++) {
                  var parameter = _e[_d];
                  markDecoratorMedataDataTypeNodeAsReferenced(getParameterTypeNodeForDecoratorCheck(parameter));
                }
                break;
            }
          }
          ts3.forEach(node.decorators, checkDecorator);
        }
        function checkFunctionDeclaration(node) {
          if (produceDiagnostics) {
            checkFunctionOrMethodDeclaration(node);
            checkGrammarForGenerator(node);
            checkCollisionWithRequireExportsInGeneratedCode(node, node.name);
            checkCollisionWithGlobalPromiseInGeneratedCode(node, node.name);
          }
        }
        function checkJSDocTypeAliasTag(node) {
          if (!node.typeExpression) {
            error(node.name, ts3.Diagnostics.JSDoc_typedef_tag_should_either_have_a_type_annotation_or_be_followed_by_property_or_member_tags);
          }
          if (node.name) {
            checkTypeNameIsReserved(node.name, ts3.Diagnostics.Type_alias_name_cannot_be_0);
          }
          checkSourceElement(node.typeExpression);
        }
        function checkJSDocTemplateTag(node) {
          checkSourceElement(node.constraint);
          for (var _i = 0, _a2 = node.typeParameters; _i < _a2.length; _i++) {
            var tp = _a2[_i];
            checkSourceElement(tp);
          }
        }
        function checkJSDocTypeTag(node) {
          checkSourceElement(node.typeExpression);
        }
        function checkJSDocParameterTag(node) {
          checkSourceElement(node.typeExpression);
          if (!ts3.getParameterSymbolFromJSDoc(node)) {
            var decl = ts3.getHostSignatureFromJSDoc(node);
            if (decl) {
              var i3 = ts3.getJSDocTags(decl).filter(ts3.isJSDocParameterTag).indexOf(node);
              if (i3 > -1 && i3 < decl.parameters.length && ts3.isBindingPattern(decl.parameters[i3].name)) {
                return;
              }
              if (!containsArgumentsReference(decl)) {
                if (ts3.isQualifiedName(node.name)) {
                  error(node.name, ts3.Diagnostics.Qualified_name_0_is_not_allowed_without_a_leading_param_object_1, ts3.entityNameToString(node.name), ts3.entityNameToString(node.name.left));
                } else {
                  error(node.name, ts3.Diagnostics.JSDoc_param_tag_has_name_0_but_there_is_no_parameter_with_that_name, ts3.idText(node.name));
                }
              } else if (ts3.findLast(ts3.getJSDocTags(decl), ts3.isJSDocParameterTag) === node && node.typeExpression && node.typeExpression.type && !isArrayType(getTypeFromTypeNode(node.typeExpression.type))) {
                error(node.name, ts3.Diagnostics.JSDoc_param_tag_has_name_0_but_there_is_no_parameter_with_that_name_It_would_match_arguments_if_it_had_an_array_type, ts3.idText(node.name.kind === 158 ? node.name.right : node.name));
              }
            }
          }
        }
        function checkJSDocPropertyTag(node) {
          checkSourceElement(node.typeExpression);
        }
        function checkJSDocFunctionType(node) {
          if (produceDiagnostics && !node.type && !ts3.isJSDocConstructSignature(node)) {
            reportImplicitAny(node, anyType);
          }
          checkSignatureDeclaration(node);
        }
        function checkJSDocImplementsTag(node) {
          var classLike = ts3.getEffectiveJSDocHost(node);
          if (!classLike || !ts3.isClassDeclaration(classLike) && !ts3.isClassExpression(classLike)) {
            error(classLike, ts3.Diagnostics.JSDoc_0_is_not_attached_to_a_class, ts3.idText(node.tagName));
          }
        }
        function checkJSDocAugmentsTag(node) {
          var classLike = ts3.getEffectiveJSDocHost(node);
          if (!classLike || !ts3.isClassDeclaration(classLike) && !ts3.isClassExpression(classLike)) {
            error(classLike, ts3.Diagnostics.JSDoc_0_is_not_attached_to_a_class, ts3.idText(node.tagName));
            return;
          }
          var augmentsTags = ts3.getJSDocTags(classLike).filter(ts3.isJSDocAugmentsTag);
          ts3.Debug.assert(augmentsTags.length > 0);
          if (augmentsTags.length > 1) {
            error(augmentsTags[1], ts3.Diagnostics.Class_declarations_cannot_have_more_than_one_augments_or_extends_tag);
          }
          var name = getIdentifierFromEntityNameExpression(node.class.expression);
          var extend3 = ts3.getClassExtendsHeritageElement(classLike);
          if (extend3) {
            var className = getIdentifierFromEntityNameExpression(extend3.expression);
            if (className && name.escapedText !== className.escapedText) {
              error(name, ts3.Diagnostics.JSDoc_0_1_does_not_match_the_extends_2_clause, ts3.idText(node.tagName), ts3.idText(name), ts3.idText(className));
            }
          }
        }
        function getIdentifierFromEntityNameExpression(node) {
          switch (node.kind) {
            case 78:
              return node;
            case 202:
              return node.name;
            default:
              return void 0;
          }
        }
        function checkFunctionOrMethodDeclaration(node) {
          var _a2;
          checkDecorators(node);
          checkSignatureDeclaration(node);
          var functionFlags = ts3.getFunctionFlags(node);
          if (node.name && node.name.kind === 159) {
            checkComputedPropertyName(node.name);
          }
          if (hasBindableName(node)) {
            var symbol = getSymbolOfNode(node);
            var localSymbol = node.localSymbol || symbol;
            var firstDeclaration = (_a2 = localSymbol.declarations) === null || _a2 === void 0 ? void 0 : _a2.find(function(declaration) {
              return declaration.kind === node.kind && !(declaration.flags & 131072);
            });
            if (node === firstDeclaration) {
              checkFunctionOrConstructorSymbol(localSymbol);
            }
            if (symbol.parent) {
              checkFunctionOrConstructorSymbol(symbol);
            }
          }
          var body = node.kind === 165 ? void 0 : node.body;
          checkSourceElement(body);
          checkAllCodePathsInNonVoidFunctionReturnOrThrow(node, getReturnTypeFromAnnotation(node));
          if (produceDiagnostics && !ts3.getEffectiveReturnTypeNode(node)) {
            if (ts3.nodeIsMissing(body) && !isPrivateWithinAmbient(node)) {
              reportImplicitAny(node, anyType);
            }
            if (functionFlags & 1 && ts3.nodeIsPresent(body)) {
              getReturnTypeOfSignature(getSignatureFromDeclaration(node));
            }
          }
          if (ts3.isInJSFile(node)) {
            var typeTag = ts3.getJSDocTypeTag(node);
            if (typeTag && typeTag.typeExpression && !getContextualCallSignature(getTypeFromTypeNode(typeTag.typeExpression), node)) {
              error(typeTag.typeExpression.type, ts3.Diagnostics.The_type_of_a_function_declaration_must_match_the_function_s_signature);
            }
          }
        }
        function registerForUnusedIdentifiersCheck(node) {
          if (produceDiagnostics) {
            var sourceFile = ts3.getSourceFileOfNode(node);
            var potentiallyUnusedIdentifiers = allPotentiallyUnusedIdentifiers.get(sourceFile.path);
            if (!potentiallyUnusedIdentifiers) {
              potentiallyUnusedIdentifiers = [];
              allPotentiallyUnusedIdentifiers.set(sourceFile.path, potentiallyUnusedIdentifiers);
            }
            potentiallyUnusedIdentifiers.push(node);
          }
        }
        function checkUnusedIdentifiers(potentiallyUnusedIdentifiers, addDiagnostic) {
          for (var _i = 0, potentiallyUnusedIdentifiers_1 = potentiallyUnusedIdentifiers; _i < potentiallyUnusedIdentifiers_1.length; _i++) {
            var node = potentiallyUnusedIdentifiers_1[_i];
            switch (node.kind) {
              case 253:
              case 222:
                checkUnusedClassMembers(node, addDiagnostic);
                checkUnusedTypeParameters(node, addDiagnostic);
                break;
              case 298:
              case 257:
              case 231:
              case 259:
              case 238:
              case 239:
              case 240:
                checkUnusedLocalsAndParameters(node, addDiagnostic);
                break;
              case 167:
              case 209:
              case 252:
              case 210:
              case 166:
              case 168:
              case 169:
                if (node.body) {
                  checkUnusedLocalsAndParameters(node, addDiagnostic);
                }
                checkUnusedTypeParameters(node, addDiagnostic);
                break;
              case 165:
              case 170:
              case 171:
              case 175:
              case 176:
              case 255:
              case 254:
                checkUnusedTypeParameters(node, addDiagnostic);
                break;
              case 186:
                checkUnusedInferTypeParameter(node, addDiagnostic);
                break;
              default:
                ts3.Debug.assertNever(node, "Node should not have been registered for unused identifiers check");
            }
          }
        }
        function errorUnusedLocal(declaration, name, addDiagnostic) {
          var node = ts3.getNameOfDeclaration(declaration) || declaration;
          var message = isTypeDeclaration(declaration) ? ts3.Diagnostics._0_is_declared_but_never_used : ts3.Diagnostics._0_is_declared_but_its_value_is_never_read;
          addDiagnostic(declaration, 0, ts3.createDiagnosticForNode(node, message, name));
        }
        function isIdentifierThatStartsWithUnderscore(node) {
          return ts3.isIdentifier(node) && ts3.idText(node).charCodeAt(0) === 95;
        }
        function checkUnusedClassMembers(node, addDiagnostic) {
          for (var _i = 0, _a2 = node.members; _i < _a2.length; _i++) {
            var member = _a2[_i];
            switch (member.kind) {
              case 166:
              case 164:
              case 168:
              case 169:
                if (member.kind === 169 && member.symbol.flags & 32768) {
                  break;
                }
                var symbol = getSymbolOfNode(member);
                if (!symbol.isReferenced && (ts3.hasEffectiveModifier(member, 8) || ts3.isNamedDeclaration(member) && ts3.isPrivateIdentifier(member.name)) && !(member.flags & 8388608)) {
                  addDiagnostic(member, 0, ts3.createDiagnosticForNode(member.name, ts3.Diagnostics._0_is_declared_but_its_value_is_never_read, symbolToString(symbol)));
                }
                break;
              case 167:
                for (var _b = 0, _c = member.parameters; _b < _c.length; _b++) {
                  var parameter = _c[_b];
                  if (!parameter.symbol.isReferenced && ts3.hasSyntacticModifier(parameter, 8)) {
                    addDiagnostic(parameter, 0, ts3.createDiagnosticForNode(parameter.name, ts3.Diagnostics.Property_0_is_declared_but_its_value_is_never_read, ts3.symbolName(parameter.symbol)));
                  }
                }
                break;
              case 172:
              case 230:
                break;
              default:
                ts3.Debug.fail();
            }
          }
        }
        function checkUnusedInferTypeParameter(node, addDiagnostic) {
          var typeParameter = node.typeParameter;
          if (isTypeParameterUnused(typeParameter)) {
            addDiagnostic(node, 1, ts3.createDiagnosticForNode(node, ts3.Diagnostics._0_is_declared_but_its_value_is_never_read, ts3.idText(typeParameter.name)));
          }
        }
        function checkUnusedTypeParameters(node, addDiagnostic) {
          var declarations = getSymbolOfNode(node).declarations;
          if (!declarations || ts3.last(declarations) !== node)
            return;
          var typeParameters = ts3.getEffectiveTypeParameterDeclarations(node);
          var seenParentsWithEveryUnused = new ts3.Set();
          for (var _i = 0, typeParameters_3 = typeParameters; _i < typeParameters_3.length; _i++) {
            var typeParameter = typeParameters_3[_i];
            if (!isTypeParameterUnused(typeParameter))
              continue;
            var name = ts3.idText(typeParameter.name);
            var parent = typeParameter.parent;
            if (parent.kind !== 186 && parent.typeParameters.every(isTypeParameterUnused)) {
              if (ts3.tryAddToSet(seenParentsWithEveryUnused, parent)) {
                var sourceFile = ts3.getSourceFileOfNode(parent);
                var range = ts3.isJSDocTemplateTag(parent) ? ts3.rangeOfNode(parent) : ts3.rangeOfTypeParameters(sourceFile, parent.typeParameters);
                var only = parent.typeParameters.length === 1;
                var message = only ? ts3.Diagnostics._0_is_declared_but_its_value_is_never_read : ts3.Diagnostics.All_type_parameters_are_unused;
                var arg0 = only ? name : void 0;
                addDiagnostic(typeParameter, 1, ts3.createFileDiagnostic(sourceFile, range.pos, range.end - range.pos, message, arg0));
              }
            } else {
              addDiagnostic(typeParameter, 1, ts3.createDiagnosticForNode(typeParameter, ts3.Diagnostics._0_is_declared_but_its_value_is_never_read, name));
            }
          }
        }
        function isTypeParameterUnused(typeParameter) {
          return !(getMergedSymbol(typeParameter.symbol).isReferenced & 262144) && !isIdentifierThatStartsWithUnderscore(typeParameter.name);
        }
        function addToGroup(map2, key2, value, getKey) {
          var keyString = String(getKey(key2));
          var group = map2.get(keyString);
          if (group) {
            group[1].push(value);
          } else {
            map2.set(keyString, [key2, [value]]);
          }
        }
        function tryGetRootParameterDeclaration(node) {
          return ts3.tryCast(ts3.getRootDeclaration(node), ts3.isParameter);
        }
        function isValidUnusedLocalDeclaration(declaration) {
          if (ts3.isBindingElement(declaration)) {
            if (ts3.isObjectBindingPattern(declaration.parent)) {
              return !!(declaration.propertyName && isIdentifierThatStartsWithUnderscore(declaration.name));
            }
            return isIdentifierThatStartsWithUnderscore(declaration.name);
          }
          return ts3.isAmbientModule(declaration) || (ts3.isVariableDeclaration(declaration) && ts3.isForInOrOfStatement(declaration.parent.parent) || isImportedDeclaration(declaration)) && isIdentifierThatStartsWithUnderscore(declaration.name);
        }
        function checkUnusedLocalsAndParameters(nodeWithLocals, addDiagnostic) {
          var unusedImports = new ts3.Map();
          var unusedDestructures = new ts3.Map();
          var unusedVariables = new ts3.Map();
          nodeWithLocals.locals.forEach(function(local) {
            if (local.flags & 262144 ? !(local.flags & 3 && !(local.isReferenced & 3)) : local.isReferenced || local.exportSymbol) {
              return;
            }
            if (local.declarations) {
              for (var _i = 0, _a2 = local.declarations; _i < _a2.length; _i++) {
                var declaration = _a2[_i];
                if (isValidUnusedLocalDeclaration(declaration)) {
                  continue;
                }
                if (isImportedDeclaration(declaration)) {
                  addToGroup(unusedImports, importClauseFromImported(declaration), declaration, getNodeId);
                } else if (ts3.isBindingElement(declaration) && ts3.isObjectBindingPattern(declaration.parent)) {
                  var lastElement = ts3.last(declaration.parent.elements);
                  if (declaration === lastElement || !ts3.last(declaration.parent.elements).dotDotDotToken) {
                    addToGroup(unusedDestructures, declaration.parent, declaration, getNodeId);
                  }
                } else if (ts3.isVariableDeclaration(declaration)) {
                  addToGroup(unusedVariables, declaration.parent, declaration, getNodeId);
                } else {
                  var parameter = local.valueDeclaration && tryGetRootParameterDeclaration(local.valueDeclaration);
                  var name = local.valueDeclaration && ts3.getNameOfDeclaration(local.valueDeclaration);
                  if (parameter && name) {
                    if (!ts3.isParameterPropertyDeclaration(parameter, parameter.parent) && !ts3.parameterIsThisKeyword(parameter) && !isIdentifierThatStartsWithUnderscore(name)) {
                      if (ts3.isBindingElement(declaration) && ts3.isArrayBindingPattern(declaration.parent)) {
                        addToGroup(unusedDestructures, declaration.parent, declaration, getNodeId);
                      } else {
                        addDiagnostic(parameter, 1, ts3.createDiagnosticForNode(name, ts3.Diagnostics._0_is_declared_but_its_value_is_never_read, ts3.symbolName(local)));
                      }
                    }
                  } else {
                    errorUnusedLocal(declaration, ts3.symbolName(local), addDiagnostic);
                  }
                }
              }
            }
          });
          unusedImports.forEach(function(_a2) {
            var importClause = _a2[0], unuseds = _a2[1];
            var importDecl = importClause.parent;
            var nDeclarations = (importClause.name ? 1 : 0) + (importClause.namedBindings ? importClause.namedBindings.kind === 264 ? 1 : importClause.namedBindings.elements.length : 0);
            if (nDeclarations === unuseds.length) {
              addDiagnostic(importDecl, 0, unuseds.length === 1 ? ts3.createDiagnosticForNode(importDecl, ts3.Diagnostics._0_is_declared_but_its_value_is_never_read, ts3.idText(ts3.first(unuseds).name)) : ts3.createDiagnosticForNode(importDecl, ts3.Diagnostics.All_imports_in_import_declaration_are_unused));
            } else {
              for (var _i = 0, unuseds_1 = unuseds; _i < unuseds_1.length; _i++) {
                var unused = unuseds_1[_i];
                errorUnusedLocal(unused, ts3.idText(unused.name), addDiagnostic);
              }
            }
          });
          unusedDestructures.forEach(function(_a2) {
            var bindingPattern = _a2[0], bindingElements = _a2[1];
            var kind = tryGetRootParameterDeclaration(bindingPattern.parent) ? 1 : 0;
            if (bindingPattern.elements.length === bindingElements.length) {
              if (bindingElements.length === 1 && bindingPattern.parent.kind === 250 && bindingPattern.parent.parent.kind === 251) {
                addToGroup(unusedVariables, bindingPattern.parent.parent, bindingPattern.parent, getNodeId);
              } else {
                addDiagnostic(bindingPattern, kind, bindingElements.length === 1 ? ts3.createDiagnosticForNode(bindingPattern, ts3.Diagnostics._0_is_declared_but_its_value_is_never_read, bindingNameText(ts3.first(bindingElements).name)) : ts3.createDiagnosticForNode(bindingPattern, ts3.Diagnostics.All_destructured_elements_are_unused));
              }
            } else {
              for (var _i = 0, bindingElements_1 = bindingElements; _i < bindingElements_1.length; _i++) {
                var e2 = bindingElements_1[_i];
                addDiagnostic(e2, kind, ts3.createDiagnosticForNode(e2, ts3.Diagnostics._0_is_declared_but_its_value_is_never_read, bindingNameText(e2.name)));
              }
            }
          });
          unusedVariables.forEach(function(_a2) {
            var declarationList = _a2[0], declarations = _a2[1];
            if (declarationList.declarations.length === declarations.length) {
              addDiagnostic(declarationList, 0, declarations.length === 1 ? ts3.createDiagnosticForNode(ts3.first(declarations).name, ts3.Diagnostics._0_is_declared_but_its_value_is_never_read, bindingNameText(ts3.first(declarations).name)) : ts3.createDiagnosticForNode(declarationList.parent.kind === 233 ? declarationList.parent : declarationList, ts3.Diagnostics.All_variables_are_unused));
            } else {
              for (var _i = 0, declarations_5 = declarations; _i < declarations_5.length; _i++) {
                var decl = declarations_5[_i];
                addDiagnostic(decl, 0, ts3.createDiagnosticForNode(decl, ts3.Diagnostics._0_is_declared_but_its_value_is_never_read, bindingNameText(decl.name)));
              }
            }
          });
        }
        function bindingNameText(name) {
          switch (name.kind) {
            case 78:
              return ts3.idText(name);
            case 198:
            case 197:
              return bindingNameText(ts3.cast(ts3.first(name.elements), ts3.isBindingElement).name);
            default:
              return ts3.Debug.assertNever(name);
          }
        }
        function isImportedDeclaration(node) {
          return node.kind === 263 || node.kind === 266 || node.kind === 264;
        }
        function importClauseFromImported(decl) {
          return decl.kind === 263 ? decl : decl.kind === 264 ? decl.parent : decl.parent.parent;
        }
        function checkBlock(node) {
          if (node.kind === 231) {
            checkGrammarStatementInAmbientContext(node);
          }
          if (ts3.isFunctionOrModuleBlock(node)) {
            var saveFlowAnalysisDisabled = flowAnalysisDisabled;
            ts3.forEach(node.statements, checkSourceElement);
            flowAnalysisDisabled = saveFlowAnalysisDisabled;
          } else {
            ts3.forEach(node.statements, checkSourceElement);
          }
          if (node.locals) {
            registerForUnusedIdentifiersCheck(node);
          }
        }
        function checkCollisionWithArgumentsInGeneratedCode(node) {
          if (languageVersion >= 2 || !ts3.hasRestParameter(node) || node.flags & 8388608 || ts3.nodeIsMissing(node.body)) {
            return;
          }
          ts3.forEach(node.parameters, function(p) {
            if (p.name && !ts3.isBindingPattern(p.name) && p.name.escapedText === argumentsSymbol.escapedName) {
              errorSkippedOn("noEmit", p, ts3.Diagnostics.Duplicate_identifier_arguments_Compiler_uses_arguments_to_initialize_rest_parameters);
            }
          });
        }
        function needCollisionCheckForIdentifier(node, identifier, name) {
          if (!(identifier && identifier.escapedText === name)) {
            return false;
          }
          if (node.kind === 164 || node.kind === 163 || node.kind === 166 || node.kind === 165 || node.kind === 168 || node.kind === 169) {
            return false;
          }
          if (node.flags & 8388608) {
            return false;
          }
          var root = ts3.getRootDeclaration(node);
          if (root.kind === 161 && ts3.nodeIsMissing(root.parent.body)) {
            return false;
          }
          return true;
        }
        function checkIfThisIsCapturedInEnclosingScope(node) {
          ts3.findAncestor(node, function(current) {
            if (getNodeCheckFlags(current) & 4) {
              var isDeclaration_1 = node.kind !== 78;
              if (isDeclaration_1) {
                error(ts3.getNameOfDeclaration(node), ts3.Diagnostics.Duplicate_identifier_this_Compiler_uses_variable_declaration_this_to_capture_this_reference);
              } else {
                error(node, ts3.Diagnostics.Expression_resolves_to_variable_declaration_this_that_compiler_uses_to_capture_this_reference);
              }
              return true;
            }
            return false;
          });
        }
        function checkIfNewTargetIsCapturedInEnclosingScope(node) {
          ts3.findAncestor(node, function(current) {
            if (getNodeCheckFlags(current) & 8) {
              var isDeclaration_2 = node.kind !== 78;
              if (isDeclaration_2) {
                error(ts3.getNameOfDeclaration(node), ts3.Diagnostics.Duplicate_identifier_newTarget_Compiler_uses_variable_declaration_newTarget_to_capture_new_target_meta_property_reference);
              } else {
                error(node, ts3.Diagnostics.Expression_resolves_to_variable_declaration_newTarget_that_compiler_uses_to_capture_new_target_meta_property_reference);
              }
              return true;
            }
            return false;
          });
        }
        function checkWeakMapSetCollision(node) {
          var enclosingBlockScope = ts3.getEnclosingBlockScopeContainer(node);
          if (getNodeCheckFlags(enclosingBlockScope) & 67108864) {
            ts3.Debug.assert(ts3.isNamedDeclaration(node) && ts3.isIdentifier(node.name) && typeof node.name.escapedText === "string", "The target of a WeakMap/WeakSet collision check should be an identifier");
            errorSkippedOn("noEmit", node, ts3.Diagnostics.Compiler_reserves_name_0_when_emitting_private_identifier_downlevel, node.name.escapedText);
          }
        }
        function checkCollisionWithRequireExportsInGeneratedCode(node, name) {
          if (moduleKind >= ts3.ModuleKind.ES2015) {
            return;
          }
          if (!needCollisionCheckForIdentifier(node, name, "require") && !needCollisionCheckForIdentifier(node, name, "exports")) {
            return;
          }
          if (ts3.isModuleDeclaration(node) && ts3.getModuleInstanceState(node) !== 1) {
            return;
          }
          var parent = getDeclarationContainer(node);
          if (parent.kind === 298 && ts3.isExternalOrCommonJsModule(parent)) {
            errorSkippedOn("noEmit", name, ts3.Diagnostics.Duplicate_identifier_0_Compiler_reserves_name_1_in_top_level_scope_of_a_module, ts3.declarationNameToString(name), ts3.declarationNameToString(name));
          }
        }
        function checkCollisionWithGlobalPromiseInGeneratedCode(node, name) {
          if (languageVersion >= 4 || !needCollisionCheckForIdentifier(node, name, "Promise")) {
            return;
          }
          if (ts3.isModuleDeclaration(node) && ts3.getModuleInstanceState(node) !== 1) {
            return;
          }
          var parent = getDeclarationContainer(node);
          if (parent.kind === 298 && ts3.isExternalOrCommonJsModule(parent) && parent.flags & 2048) {
            errorSkippedOn("noEmit", name, ts3.Diagnostics.Duplicate_identifier_0_Compiler_reserves_name_1_in_top_level_scope_of_a_module_containing_async_functions, ts3.declarationNameToString(name), ts3.declarationNameToString(name));
          }
        }
        function checkVarDeclaredNamesNotShadowed(node) {
          if ((ts3.getCombinedNodeFlags(node) & 3) !== 0 || ts3.isParameterDeclaration(node)) {
            return;
          }
          if (node.kind === 250 && !node.initializer) {
            return;
          }
          var symbol = getSymbolOfNode(node);
          if (symbol.flags & 1) {
            if (!ts3.isIdentifier(node.name))
              return ts3.Debug.fail();
            var localDeclarationSymbol = resolveName(node, node.name.escapedText, 3, void 0, void 0, false);
            if (localDeclarationSymbol && localDeclarationSymbol !== symbol && localDeclarationSymbol.flags & 2) {
              if (getDeclarationNodeFlagsFromSymbol(localDeclarationSymbol) & 3) {
                var varDeclList = ts3.getAncestor(localDeclarationSymbol.valueDeclaration, 251);
                var container = varDeclList.parent.kind === 233 && varDeclList.parent.parent ? varDeclList.parent.parent : void 0;
                var namesShareScope = container && (container.kind === 231 && ts3.isFunctionLike(container.parent) || container.kind === 258 || container.kind === 257 || container.kind === 298);
                if (!namesShareScope) {
                  var name = symbolToString(localDeclarationSymbol);
                  error(node, ts3.Diagnostics.Cannot_initialize_outer_scoped_variable_0_in_the_same_scope_as_block_scoped_declaration_1, name, name);
                }
              }
            }
          }
        }
        function convertAutoToAny(type3) {
          return type3 === autoType ? anyType : type3 === autoArrayType ? anyArrayType : type3;
        }
        function checkVariableLikeDeclaration(node) {
          var _a2;
          checkDecorators(node);
          if (!ts3.isBindingElement(node)) {
            checkSourceElement(node.type);
          }
          if (!node.name) {
            return;
          }
          if (node.name.kind === 159) {
            checkComputedPropertyName(node.name);
            if (node.initializer) {
              checkExpressionCached(node.initializer);
            }
          }
          if (ts3.isBindingElement(node)) {
            if (ts3.isObjectBindingPattern(node.parent) && node.dotDotDotToken && languageVersion < 5) {
              checkExternalEmitHelpers(node, 4);
            }
            if (node.propertyName && node.propertyName.kind === 159) {
              checkComputedPropertyName(node.propertyName);
            }
            var parent = node.parent.parent;
            var parentType = getTypeForBindingElementParent(parent);
            var name = node.propertyName || node.name;
            if (parentType && !ts3.isBindingPattern(name)) {
              var exprType = getLiteralTypeFromPropertyName(name);
              if (isTypeUsableAsPropertyName(exprType)) {
                var nameText = getPropertyNameFromType(exprType);
                var property = getPropertyOfType(parentType, nameText);
                if (property) {
                  markPropertyAsReferenced(property, void 0, false);
                  checkPropertyAccessibility(node, !!parent.initializer && parent.initializer.kind === 105, false, parentType, property);
                }
              }
            }
          }
          if (ts3.isBindingPattern(node.name)) {
            if (node.name.kind === 198 && languageVersion < 2 && compilerOptions.downlevelIteration) {
              checkExternalEmitHelpers(node, 512);
            }
            ts3.forEach(node.name.elements, checkSourceElement);
          }
          if (node.initializer && ts3.isParameterDeclaration(node) && ts3.nodeIsMissing(ts3.getContainingFunction(node).body)) {
            error(node, ts3.Diagnostics.A_parameter_initializer_is_only_allowed_in_a_function_or_constructor_implementation);
            return;
          }
          if (ts3.isBindingPattern(node.name)) {
            var needCheckInitializer = node.initializer && node.parent.parent.kind !== 239;
            var needCheckWidenedType = node.name.elements.length === 0;
            if (needCheckInitializer || needCheckWidenedType) {
              var widenedType = getWidenedTypeForVariableLikeDeclaration(node);
              if (needCheckInitializer) {
                var initializerType = checkExpressionCached(node.initializer);
                if (strictNullChecks && needCheckWidenedType) {
                  checkNonNullNonVoidType(initializerType, node);
                } else {
                  checkTypeAssignableToAndOptionallyElaborate(initializerType, getWidenedTypeForVariableLikeDeclaration(node), node, node.initializer);
                }
              }
              if (needCheckWidenedType) {
                if (ts3.isArrayBindingPattern(node.name)) {
                  checkIteratedTypeOrElementType(65, widenedType, undefinedType, node);
                } else if (strictNullChecks) {
                  checkNonNullNonVoidType(widenedType, node);
                }
              }
            }
            return;
          }
          var symbol = getSymbolOfNode(node);
          if (symbol.flags & 2097152 && ts3.isRequireVariableDeclaration(node)) {
            checkAliasSymbol(node);
            return;
          }
          var type3 = convertAutoToAny(getTypeOfSymbol(symbol));
          if (node === symbol.valueDeclaration) {
            var initializer = ts3.getEffectiveInitializer(node);
            if (initializer) {
              var isJSObjectLiteralInitializer = ts3.isInJSFile(node) && ts3.isObjectLiteralExpression(initializer) && (initializer.properties.length === 0 || ts3.isPrototypeAccess(node.name)) && !!((_a2 = symbol.exports) === null || _a2 === void 0 ? void 0 : _a2.size);
              if (!isJSObjectLiteralInitializer && node.parent.parent.kind !== 239) {
                checkTypeAssignableToAndOptionallyElaborate(checkExpressionCached(initializer), type3, node, initializer, void 0);
              }
            }
            if (symbol.declarations && symbol.declarations.length > 1) {
              if (ts3.some(symbol.declarations, function(d) {
                return d !== node && ts3.isVariableLike(d) && !areDeclarationFlagsIdentical(d, node);
              })) {
                error(node.name, ts3.Diagnostics.All_declarations_of_0_must_have_identical_modifiers, ts3.declarationNameToString(node.name));
              }
            }
          } else {
            var declarationType = convertAutoToAny(getWidenedTypeForVariableLikeDeclaration(node));
            if (type3 !== errorType && declarationType !== errorType && !isTypeIdenticalTo(type3, declarationType) && !(symbol.flags & 67108864)) {
              errorNextVariableOrPropertyDeclarationMustHaveSameType(symbol.valueDeclaration, type3, node, declarationType);
            }
            if (node.initializer) {
              checkTypeAssignableToAndOptionallyElaborate(checkExpressionCached(node.initializer), declarationType, node, node.initializer, void 0);
            }
            if (symbol.valueDeclaration && !areDeclarationFlagsIdentical(node, symbol.valueDeclaration)) {
              error(node.name, ts3.Diagnostics.All_declarations_of_0_must_have_identical_modifiers, ts3.declarationNameToString(node.name));
            }
          }
          if (node.kind !== 164 && node.kind !== 163) {
            checkExportsOnMergedDeclarations(node);
            if (node.kind === 250 || node.kind === 199) {
              checkVarDeclaredNamesNotShadowed(node);
            }
            checkCollisionWithRequireExportsInGeneratedCode(node, node.name);
            checkCollisionWithGlobalPromiseInGeneratedCode(node, node.name);
            if (languageVersion < 99 && (needCollisionCheckForIdentifier(node, node.name, "WeakMap") || needCollisionCheckForIdentifier(node, node.name, "WeakSet"))) {
              potentialWeakMapSetCollisions.push(node);
            }
          }
        }
        function errorNextVariableOrPropertyDeclarationMustHaveSameType(firstDeclaration, firstType, nextDeclaration, nextType) {
          var nextDeclarationName = ts3.getNameOfDeclaration(nextDeclaration);
          var message = nextDeclaration.kind === 164 || nextDeclaration.kind === 163 ? ts3.Diagnostics.Subsequent_property_declarations_must_have_the_same_type_Property_0_must_be_of_type_1_but_here_has_type_2 : ts3.Diagnostics.Subsequent_variable_declarations_must_have_the_same_type_Variable_0_must_be_of_type_1_but_here_has_type_2;
          var declName = ts3.declarationNameToString(nextDeclarationName);
          var err2 = error(nextDeclarationName, message, declName, typeToString(firstType), typeToString(nextType));
          if (firstDeclaration) {
            ts3.addRelatedInfo(err2, ts3.createDiagnosticForNode(firstDeclaration, ts3.Diagnostics._0_was_also_declared_here, declName));
          }
        }
        function areDeclarationFlagsIdentical(left, right) {
          if (left.kind === 161 && right.kind === 250 || left.kind === 250 && right.kind === 161) {
            return true;
          }
          if (ts3.hasQuestionToken(left) !== ts3.hasQuestionToken(right)) {
            return false;
          }
          var interestingFlags = 8 | 16 | 256 | 128 | 64 | 32;
          return ts3.getSelectedEffectiveModifierFlags(left, interestingFlags) === ts3.getSelectedEffectiveModifierFlags(right, interestingFlags);
        }
        function checkVariableDeclaration(node) {
          ts3.tracing === null || ts3.tracing === void 0 ? void 0 : ts3.tracing.push("check", "checkVariableDeclaration", { kind: node.kind, pos: node.pos, end: node.end });
          checkGrammarVariableDeclaration(node);
          checkVariableLikeDeclaration(node);
          ts3.tracing === null || ts3.tracing === void 0 ? void 0 : ts3.tracing.pop();
        }
        function checkBindingElement(node) {
          checkGrammarBindingElement(node);
          return checkVariableLikeDeclaration(node);
        }
        function checkVariableStatement(node) {
          if (!checkGrammarDecoratorsAndModifiers(node) && !checkGrammarVariableDeclarationList(node.declarationList))
            checkGrammarForDisallowedLetOrConstStatement(node);
          ts3.forEach(node.declarationList.declarations, checkSourceElement);
        }
        function checkExpressionStatement(node) {
          checkGrammarStatementInAmbientContext(node);
          checkExpression(node.expression);
        }
        function checkIfStatement(node) {
          checkGrammarStatementInAmbientContext(node);
          var type3 = checkTruthinessExpression(node.expression);
          checkTestingKnownTruthyCallableOrAwaitableType(node.expression, type3, node.thenStatement);
          checkSourceElement(node.thenStatement);
          if (node.thenStatement.kind === 232) {
            error(node.thenStatement, ts3.Diagnostics.The_body_of_an_if_statement_cannot_be_the_empty_statement);
          }
          checkSourceElement(node.elseStatement);
        }
        function checkTestingKnownTruthyCallableOrAwaitableType(condExpr, type3, body) {
          if (!strictNullChecks)
            return;
          if (getFalsyFlags(type3))
            return;
          var location = ts3.isBinaryExpression(condExpr) ? condExpr.right : condExpr;
          var testedNode = ts3.isIdentifier(location) ? location : ts3.isPropertyAccessExpression(location) ? location.name : ts3.isBinaryExpression(location) && ts3.isIdentifier(location.right) ? location.right : void 0;
          var isPropertyExpressionCast = ts3.isPropertyAccessExpression(location) && ts3.isAssertionExpression(ts3.skipParentheses(location.expression));
          if (!testedNode || isPropertyExpressionCast) {
            return;
          }
          var callSignatures = getSignaturesOfType(type3, 0);
          var isPromise = !!getAwaitedTypeOfPromise(type3);
          if (callSignatures.length === 0 && !isPromise) {
            return;
          }
          var testedSymbol = getSymbolAtLocation(testedNode);
          if (!testedSymbol) {
            return;
          }
          var isUsed = ts3.isBinaryExpression(condExpr.parent) && isSymbolUsedInBinaryExpressionChain(condExpr.parent, testedSymbol) || body && isSymbolUsedInConditionBody(condExpr, body, testedNode, testedSymbol);
          if (!isUsed) {
            if (isPromise) {
              errorAndMaybeSuggestAwait(location, true, ts3.Diagnostics.This_condition_will_always_return_true_since_this_0_is_always_defined, getTypeNameForErrorDisplay(type3));
            } else {
              error(location, ts3.Diagnostics.This_condition_will_always_return_true_since_this_function_is_always_defined_Did_you_mean_to_call_it_instead);
            }
          }
        }
        function isSymbolUsedInConditionBody(expr, body, testedNode, testedSymbol) {
          return !!ts3.forEachChild(body, function check(childNode) {
            if (ts3.isIdentifier(childNode)) {
              var childSymbol = getSymbolAtLocation(childNode);
              if (childSymbol && childSymbol === testedSymbol) {
                if (ts3.isIdentifier(expr)) {
                  return true;
                }
                var testedExpression = testedNode.parent;
                var childExpression = childNode.parent;
                while (testedExpression && childExpression) {
                  if (ts3.isIdentifier(testedExpression) && ts3.isIdentifier(childExpression) || testedExpression.kind === 107 && childExpression.kind === 107) {
                    return getSymbolAtLocation(testedExpression) === getSymbolAtLocation(childExpression);
                  } else if (ts3.isPropertyAccessExpression(testedExpression) && ts3.isPropertyAccessExpression(childExpression)) {
                    if (getSymbolAtLocation(testedExpression.name) !== getSymbolAtLocation(childExpression.name)) {
                      return false;
                    }
                    childExpression = childExpression.expression;
                    testedExpression = testedExpression.expression;
                  } else if (ts3.isCallExpression(testedExpression) && ts3.isCallExpression(childExpression)) {
                    childExpression = childExpression.expression;
                    testedExpression = testedExpression.expression;
                  } else {
                    return false;
                  }
                }
              }
            }
            return ts3.forEachChild(childNode, check);
          });
        }
        function isSymbolUsedInBinaryExpressionChain(node, testedSymbol) {
          while (ts3.isBinaryExpression(node) && node.operatorToken.kind === 55) {
            var isUsed = ts3.forEachChild(node.right, function visit(child) {
              if (ts3.isIdentifier(child)) {
                var symbol = getSymbolAtLocation(child);
                if (symbol && symbol === testedSymbol) {
                  return true;
                }
              }
              return ts3.forEachChild(child, visit);
            });
            if (isUsed) {
              return true;
            }
            node = node.parent;
          }
          return false;
        }
        function checkDoStatement(node) {
          checkGrammarStatementInAmbientContext(node);
          checkSourceElement(node.statement);
          checkTruthinessExpression(node.expression);
        }
        function checkWhileStatement(node) {
          checkGrammarStatementInAmbientContext(node);
          checkTruthinessExpression(node.expression);
          checkSourceElement(node.statement);
        }
        function checkTruthinessOfType(type3, node) {
          if (type3.flags & 16384) {
            error(node, ts3.Diagnostics.An_expression_of_type_void_cannot_be_tested_for_truthiness);
          }
          return type3;
        }
        function checkTruthinessExpression(node, checkMode) {
          return checkTruthinessOfType(checkExpression(node, checkMode), node);
        }
        function checkForStatement(node) {
          if (!checkGrammarStatementInAmbientContext(node)) {
            if (node.initializer && node.initializer.kind === 251) {
              checkGrammarVariableDeclarationList(node.initializer);
            }
          }
          if (node.initializer) {
            if (node.initializer.kind === 251) {
              ts3.forEach(node.initializer.declarations, checkVariableDeclaration);
            } else {
              checkExpression(node.initializer);
            }
          }
          if (node.condition)
            checkTruthinessExpression(node.condition);
          if (node.incrementor)
            checkExpression(node.incrementor);
          checkSourceElement(node.statement);
          if (node.locals) {
            registerForUnusedIdentifiersCheck(node);
          }
        }
        function checkForOfStatement(node) {
          checkGrammarForInOrForOfStatement(node);
          if (node.awaitModifier) {
            var functionFlags = ts3.getFunctionFlags(ts3.getContainingFunction(node));
            if ((functionFlags & (4 | 2)) === 2 && languageVersion < 99) {
              checkExternalEmitHelpers(node, 16384);
            }
          } else if (compilerOptions.downlevelIteration && languageVersion < 2) {
            checkExternalEmitHelpers(node, 256);
          }
          if (node.initializer.kind === 251) {
            checkForInOrForOfVariableDeclaration(node);
          } else {
            var varExpr = node.initializer;
            var iteratedType = checkRightHandSideOfForOf(node);
            if (varExpr.kind === 200 || varExpr.kind === 201) {
              checkDestructuringAssignment(varExpr, iteratedType || errorType);
            } else {
              var leftType = checkExpression(varExpr);
              checkReferenceExpression(varExpr, ts3.Diagnostics.The_left_hand_side_of_a_for_of_statement_must_be_a_variable_or_a_property_access, ts3.Diagnostics.The_left_hand_side_of_a_for_of_statement_may_not_be_an_optional_property_access);
              if (iteratedType) {
                checkTypeAssignableToAndOptionallyElaborate(iteratedType, leftType, varExpr, node.expression);
              }
            }
          }
          checkSourceElement(node.statement);
          if (node.locals) {
            registerForUnusedIdentifiersCheck(node);
          }
        }
        function checkForInStatement(node) {
          checkGrammarForInOrForOfStatement(node);
          var rightType = getNonNullableTypeIfNeeded(checkExpression(node.expression));
          if (node.initializer.kind === 251) {
            var variable = node.initializer.declarations[0];
            if (variable && ts3.isBindingPattern(variable.name)) {
              error(variable.name, ts3.Diagnostics.The_left_hand_side_of_a_for_in_statement_cannot_be_a_destructuring_pattern);
            }
            checkForInOrForOfVariableDeclaration(node);
          } else {
            var varExpr = node.initializer;
            var leftType = checkExpression(varExpr);
            if (varExpr.kind === 200 || varExpr.kind === 201) {
              error(varExpr, ts3.Diagnostics.The_left_hand_side_of_a_for_in_statement_cannot_be_a_destructuring_pattern);
            } else if (!isTypeAssignableTo(getIndexTypeOrString(rightType), leftType)) {
              error(varExpr, ts3.Diagnostics.The_left_hand_side_of_a_for_in_statement_must_be_of_type_string_or_any);
            } else {
              checkReferenceExpression(varExpr, ts3.Diagnostics.The_left_hand_side_of_a_for_in_statement_must_be_a_variable_or_a_property_access, ts3.Diagnostics.The_left_hand_side_of_a_for_in_statement_may_not_be_an_optional_property_access);
            }
          }
          if (rightType === neverType || !isTypeAssignableToKind(rightType, 67108864 | 58982400)) {
            error(node.expression, ts3.Diagnostics.The_right_hand_side_of_a_for_in_statement_must_be_of_type_any_an_object_type_or_a_type_parameter_but_here_has_type_0, typeToString(rightType));
          }
          checkSourceElement(node.statement);
          if (node.locals) {
            registerForUnusedIdentifiersCheck(node);
          }
        }
        function checkForInOrForOfVariableDeclaration(iterationStatement) {
          var variableDeclarationList = iterationStatement.initializer;
          if (variableDeclarationList.declarations.length >= 1) {
            var decl = variableDeclarationList.declarations[0];
            checkVariableDeclaration(decl);
          }
        }
        function checkRightHandSideOfForOf(statement) {
          var use = statement.awaitModifier ? 15 : 13;
          return checkIteratedTypeOrElementType(use, checkNonNullExpression(statement.expression), undefinedType, statement.expression);
        }
        function checkIteratedTypeOrElementType(use, inputType, sentType, errorNode) {
          if (isTypeAny(inputType)) {
            return inputType;
          }
          return getIteratedTypeOrElementType(use, inputType, sentType, errorNode, true) || anyType;
        }
        function getIteratedTypeOrElementType(use, inputType, sentType, errorNode, checkAssignability) {
          var allowAsyncIterables = (use & 2) !== 0;
          if (inputType === neverType) {
            reportTypeNotIterableError(errorNode, inputType, allowAsyncIterables);
            return void 0;
          }
          var uplevelIteration = languageVersion >= 2;
          var downlevelIteration = !uplevelIteration && compilerOptions.downlevelIteration;
          var possibleOutOfBounds = compilerOptions.noUncheckedIndexedAccess && !!(use & 128);
          if (uplevelIteration || downlevelIteration || allowAsyncIterables) {
            var iterationTypes = getIterationTypesOfIterable(inputType, use, uplevelIteration ? errorNode : void 0);
            if (checkAssignability) {
              if (iterationTypes) {
                var diagnostic = use & 8 ? ts3.Diagnostics.Cannot_iterate_value_because_the_next_method_of_its_iterator_expects_type_1_but_for_of_will_always_send_0 : use & 32 ? ts3.Diagnostics.Cannot_iterate_value_because_the_next_method_of_its_iterator_expects_type_1_but_array_spread_will_always_send_0 : use & 64 ? ts3.Diagnostics.Cannot_iterate_value_because_the_next_method_of_its_iterator_expects_type_1_but_array_destructuring_will_always_send_0 : use & 16 ? ts3.Diagnostics.Cannot_delegate_iteration_to_value_because_the_next_method_of_its_iterator_expects_type_1_but_the_containing_generator_will_always_send_0 : void 0;
                if (diagnostic) {
                  checkTypeAssignableTo(sentType, iterationTypes.nextType, errorNode, diagnostic);
                }
              }
            }
            if (iterationTypes || uplevelIteration) {
              return possibleOutOfBounds ? includeUndefinedInIndexSignature(iterationTypes && iterationTypes.yieldType) : iterationTypes && iterationTypes.yieldType;
            }
          }
          var arrayType = inputType;
          var reportedError = false;
          var hasStringConstituent = false;
          if (use & 4) {
            if (arrayType.flags & 1048576) {
              var arrayTypes = inputType.types;
              var filteredTypes = ts3.filter(arrayTypes, function(t2) {
                return !(t2.flags & 402653316);
              });
              if (filteredTypes !== arrayTypes) {
                arrayType = getUnionType(filteredTypes, 2);
              }
            } else if (arrayType.flags & 402653316) {
              arrayType = neverType;
            }
            hasStringConstituent = arrayType !== inputType;
            if (hasStringConstituent) {
              if (languageVersion < 1) {
                if (errorNode) {
                  error(errorNode, ts3.Diagnostics.Using_a_string_in_a_for_of_statement_is_only_supported_in_ECMAScript_5_and_higher);
                  reportedError = true;
                }
              }
              if (arrayType.flags & 131072) {
                return possibleOutOfBounds ? includeUndefinedInIndexSignature(stringType) : stringType;
              }
            }
          }
          if (!isArrayLikeType(arrayType)) {
            if (errorNode && !reportedError) {
              var allowsStrings = !!(use & 4) && !hasStringConstituent;
              var _a2 = getIterationDiagnosticDetails(allowsStrings, downlevelIteration), defaultDiagnostic = _a2[0], maybeMissingAwait = _a2[1];
              errorAndMaybeSuggestAwait(errorNode, maybeMissingAwait && !!getAwaitedTypeOfPromise(arrayType), defaultDiagnostic, typeToString(arrayType));
            }
            return hasStringConstituent ? possibleOutOfBounds ? includeUndefinedInIndexSignature(stringType) : stringType : void 0;
          }
          var arrayElementType = getIndexTypeOfType(arrayType, 1);
          if (hasStringConstituent && arrayElementType) {
            if (arrayElementType.flags & 402653316 && !compilerOptions.noUncheckedIndexedAccess) {
              return stringType;
            }
            return getUnionType(possibleOutOfBounds ? [arrayElementType, stringType, undefinedType] : [arrayElementType, stringType], 2);
          }
          return use & 128 ? includeUndefinedInIndexSignature(arrayElementType) : arrayElementType;
          function getIterationDiagnosticDetails(allowsStrings2, downlevelIteration2) {
            var _a3;
            if (downlevelIteration2) {
              return allowsStrings2 ? [ts3.Diagnostics.Type_0_is_not_an_array_type_or_a_string_type_or_does_not_have_a_Symbol_iterator_method_that_returns_an_iterator, true] : [ts3.Diagnostics.Type_0_is_not_an_array_type_or_does_not_have_a_Symbol_iterator_method_that_returns_an_iterator, true];
            }
            var yieldType = getIterationTypeOfIterable(use, 0, inputType, void 0);
            if (yieldType) {
              return [ts3.Diagnostics.Type_0_is_not_an_array_type_or_a_string_type_Use_compiler_option_downlevelIteration_to_allow_iterating_of_iterators, false];
            }
            if (isES2015OrLaterIterable((_a3 = inputType.symbol) === null || _a3 === void 0 ? void 0 : _a3.escapedName)) {
              return [ts3.Diagnostics.Type_0_can_only_be_iterated_through_when_using_the_downlevelIteration_flag_or_with_a_target_of_es2015_or_higher, true];
            }
            return allowsStrings2 ? [ts3.Diagnostics.Type_0_is_not_an_array_type_or_a_string_type, true] : [ts3.Diagnostics.Type_0_is_not_an_array_type, true];
          }
        }
        function isES2015OrLaterIterable(n2) {
          switch (n2) {
            case "Float32Array":
            case "Float64Array":
            case "Int16Array":
            case "Int32Array":
            case "Int8Array":
            case "NodeList":
            case "Uint16Array":
            case "Uint32Array":
            case "Uint8Array":
            case "Uint8ClampedArray":
              return true;
          }
          return false;
        }
        function getIterationTypeOfIterable(use, typeKind, inputType, errorNode) {
          if (isTypeAny(inputType)) {
            return void 0;
          }
          var iterationTypes = getIterationTypesOfIterable(inputType, use, errorNode);
          return iterationTypes && iterationTypes[getIterationTypesKeyFromIterationTypeKind(typeKind)];
        }
        function createIterationTypes(yieldType, returnType2, nextType) {
          if (yieldType === void 0) {
            yieldType = neverType;
          }
          if (returnType2 === void 0) {
            returnType2 = neverType;
          }
          if (nextType === void 0) {
            nextType = unknownType;
          }
          if (yieldType.flags & 67359327 && returnType2.flags & (1 | 131072 | 2 | 16384 | 32768) && nextType.flags & (1 | 131072 | 2 | 16384 | 32768)) {
            var id = getTypeListId([yieldType, returnType2, nextType]);
            var iterationTypes = iterationTypesCache.get(id);
            if (!iterationTypes) {
              iterationTypes = { yieldType, returnType: returnType2, nextType };
              iterationTypesCache.set(id, iterationTypes);
            }
            return iterationTypes;
          }
          return { yieldType, returnType: returnType2, nextType };
        }
        function combineIterationTypes(array) {
          var yieldTypes;
          var returnTypes;
          var nextTypes;
          for (var _i = 0, array_10 = array; _i < array_10.length; _i++) {
            var iterationTypes = array_10[_i];
            if (iterationTypes === void 0 || iterationTypes === noIterationTypes) {
              continue;
            }
            if (iterationTypes === anyIterationTypes) {
              return anyIterationTypes;
            }
            yieldTypes = ts3.append(yieldTypes, iterationTypes.yieldType);
            returnTypes = ts3.append(returnTypes, iterationTypes.returnType);
            nextTypes = ts3.append(nextTypes, iterationTypes.nextType);
          }
          if (yieldTypes || returnTypes || nextTypes) {
            return createIterationTypes(yieldTypes && getUnionType(yieldTypes), returnTypes && getUnionType(returnTypes), nextTypes && getIntersectionType(nextTypes));
          }
          return noIterationTypes;
        }
        function getCachedIterationTypes(type3, cacheKey) {
          return type3[cacheKey];
        }
        function setCachedIterationTypes(type3, cacheKey, cachedTypes) {
          return type3[cacheKey] = cachedTypes;
        }
        function getIterationTypesOfIterable(type3, use, errorNode) {
          if (isTypeAny(type3)) {
            return anyIterationTypes;
          }
          if (!(type3.flags & 1048576)) {
            var iterationTypes_1 = getIterationTypesOfIterableWorker(type3, use, errorNode);
            if (iterationTypes_1 === noIterationTypes) {
              if (errorNode) {
                reportTypeNotIterableError(errorNode, type3, !!(use & 2));
              }
              return void 0;
            }
            return iterationTypes_1;
          }
          var cacheKey = use & 2 ? "iterationTypesOfAsyncIterable" : "iterationTypesOfIterable";
          var cachedTypes = getCachedIterationTypes(type3, cacheKey);
          if (cachedTypes)
            return cachedTypes === noIterationTypes ? void 0 : cachedTypes;
          var allIterationTypes;
          for (var _i = 0, _a2 = type3.types; _i < _a2.length; _i++) {
            var constituent = _a2[_i];
            var iterationTypes_2 = getIterationTypesOfIterableWorker(constituent, use, errorNode);
            if (iterationTypes_2 === noIterationTypes) {
              if (errorNode) {
                reportTypeNotIterableError(errorNode, type3, !!(use & 2));
              }
              setCachedIterationTypes(type3, cacheKey, noIterationTypes);
              return void 0;
            } else {
              allIterationTypes = ts3.append(allIterationTypes, iterationTypes_2);
            }
          }
          var iterationTypes = allIterationTypes ? combineIterationTypes(allIterationTypes) : noIterationTypes;
          setCachedIterationTypes(type3, cacheKey, iterationTypes);
          return iterationTypes === noIterationTypes ? void 0 : iterationTypes;
        }
        function getAsyncFromSyncIterationTypes(iterationTypes, errorNode) {
          if (iterationTypes === noIterationTypes)
            return noIterationTypes;
          if (iterationTypes === anyIterationTypes)
            return anyIterationTypes;
          var yieldType = iterationTypes.yieldType, returnType2 = iterationTypes.returnType, nextType = iterationTypes.nextType;
          return createIterationTypes(getAwaitedType(yieldType, errorNode) || anyType, getAwaitedType(returnType2, errorNode) || anyType, nextType);
        }
        function getIterationTypesOfIterableWorker(type3, use, errorNode) {
          if (isTypeAny(type3)) {
            return anyIterationTypes;
          }
          if (use & 2) {
            var iterationTypes = getIterationTypesOfIterableCached(type3, asyncIterationTypesResolver) || getIterationTypesOfIterableFast(type3, asyncIterationTypesResolver);
            if (iterationTypes) {
              return iterationTypes;
            }
          }
          if (use & 1) {
            var iterationTypes = getIterationTypesOfIterableCached(type3, syncIterationTypesResolver) || getIterationTypesOfIterableFast(type3, syncIterationTypesResolver);
            if (iterationTypes) {
              if (use & 2) {
                if (iterationTypes !== noIterationTypes) {
                  return setCachedIterationTypes(type3, "iterationTypesOfAsyncIterable", getAsyncFromSyncIterationTypes(iterationTypes, errorNode));
                }
              } else {
                return iterationTypes;
              }
            }
          }
          if (use & 2) {
            var iterationTypes = getIterationTypesOfIterableSlow(type3, asyncIterationTypesResolver, errorNode);
            if (iterationTypes !== noIterationTypes) {
              return iterationTypes;
            }
          }
          if (use & 1) {
            var iterationTypes = getIterationTypesOfIterableSlow(type3, syncIterationTypesResolver, errorNode);
            if (iterationTypes !== noIterationTypes) {
              if (use & 2) {
                return setCachedIterationTypes(type3, "iterationTypesOfAsyncIterable", iterationTypes ? getAsyncFromSyncIterationTypes(iterationTypes, errorNode) : noIterationTypes);
              } else {
                return iterationTypes;
              }
            }
          }
          return noIterationTypes;
        }
        function getIterationTypesOfIterableCached(type3, resolver) {
          return getCachedIterationTypes(type3, resolver.iterableCacheKey);
        }
        function getIterationTypesOfGlobalIterableType(globalType, resolver) {
          var globalIterationTypes = getIterationTypesOfIterableCached(globalType, resolver) || getIterationTypesOfIterableSlow(globalType, resolver, void 0);
          return globalIterationTypes === noIterationTypes ? defaultIterationTypes : globalIterationTypes;
        }
        function getIterationTypesOfIterableFast(type3, resolver) {
          var globalType;
          if (isReferenceToType(type3, globalType = resolver.getGlobalIterableType(false)) || isReferenceToType(type3, globalType = resolver.getGlobalIterableIteratorType(false))) {
            var yieldType = getTypeArguments(type3)[0];
            var _a2 = getIterationTypesOfGlobalIterableType(globalType, resolver), returnType2 = _a2.returnType, nextType = _a2.nextType;
            return setCachedIterationTypes(type3, resolver.iterableCacheKey, createIterationTypes(yieldType, returnType2, nextType));
          }
          if (isReferenceToType(type3, resolver.getGlobalGeneratorType(false))) {
            var _b = getTypeArguments(type3), yieldType = _b[0], returnType2 = _b[1], nextType = _b[2];
            return setCachedIterationTypes(type3, resolver.iterableCacheKey, createIterationTypes(yieldType, returnType2, nextType));
          }
        }
        function getPropertyNameForKnownSymbolName(symbolName) {
          var ctorType = getGlobalESSymbolConstructorSymbol(false);
          var uniqueType = ctorType && getTypeOfPropertyOfType(getTypeOfSymbol(ctorType), ts3.escapeLeadingUnderscores(symbolName));
          return uniqueType && isTypeUsableAsPropertyName(uniqueType) ? getPropertyNameFromType(uniqueType) : "__@" + symbolName;
        }
        function getIterationTypesOfIterableSlow(type3, resolver, errorNode) {
          var _a2;
          var method = getPropertyOfType(type3, getPropertyNameForKnownSymbolName(resolver.iteratorSymbolName));
          var methodType = method && !(method.flags & 16777216) ? getTypeOfSymbol(method) : void 0;
          if (isTypeAny(methodType)) {
            return setCachedIterationTypes(type3, resolver.iterableCacheKey, anyIterationTypes);
          }
          var signatures = methodType ? getSignaturesOfType(methodType, 0) : void 0;
          if (!ts3.some(signatures)) {
            return setCachedIterationTypes(type3, resolver.iterableCacheKey, noIterationTypes);
          }
          var iteratorType = getIntersectionType(ts3.map(signatures, getReturnTypeOfSignature));
          var iterationTypes = (_a2 = getIterationTypesOfIterator(iteratorType, resolver, errorNode)) !== null && _a2 !== void 0 ? _a2 : noIterationTypes;
          return setCachedIterationTypes(type3, resolver.iterableCacheKey, iterationTypes);
        }
        function reportTypeNotIterableError(errorNode, type3, allowAsyncIterables) {
          var message = allowAsyncIterables ? ts3.Diagnostics.Type_0_must_have_a_Symbol_asyncIterator_method_that_returns_an_async_iterator : ts3.Diagnostics.Type_0_must_have_a_Symbol_iterator_method_that_returns_an_iterator;
          errorAndMaybeSuggestAwait(errorNode, !!getAwaitedTypeOfPromise(type3), message, typeToString(type3));
        }
        function getIterationTypesOfIterator(type3, resolver, errorNode) {
          if (isTypeAny(type3)) {
            return anyIterationTypes;
          }
          var iterationTypes = getIterationTypesOfIteratorCached(type3, resolver) || getIterationTypesOfIteratorFast(type3, resolver) || getIterationTypesOfIteratorSlow(type3, resolver, errorNode);
          return iterationTypes === noIterationTypes ? void 0 : iterationTypes;
        }
        function getIterationTypesOfIteratorCached(type3, resolver) {
          return getCachedIterationTypes(type3, resolver.iteratorCacheKey);
        }
        function getIterationTypesOfIteratorFast(type3, resolver) {
          var globalType = resolver.getGlobalIterableIteratorType(false);
          if (isReferenceToType(type3, globalType)) {
            var yieldType = getTypeArguments(type3)[0];
            var globalIterationTypes = getIterationTypesOfIteratorCached(globalType, resolver) || getIterationTypesOfIteratorSlow(globalType, resolver, void 0);
            var _a2 = globalIterationTypes === noIterationTypes ? defaultIterationTypes : globalIterationTypes, returnType2 = _a2.returnType, nextType = _a2.nextType;
            return setCachedIterationTypes(type3, resolver.iteratorCacheKey, createIterationTypes(yieldType, returnType2, nextType));
          }
          if (isReferenceToType(type3, resolver.getGlobalIteratorType(false)) || isReferenceToType(type3, resolver.getGlobalGeneratorType(false))) {
            var _b = getTypeArguments(type3), yieldType = _b[0], returnType2 = _b[1], nextType = _b[2];
            return setCachedIterationTypes(type3, resolver.iteratorCacheKey, createIterationTypes(yieldType, returnType2, nextType));
          }
        }
        function isIteratorResult(type3, kind) {
          var doneType = getTypeOfPropertyOfType(type3, "done") || falseType;
          return isTypeAssignableTo(kind === 0 ? falseType : trueType, doneType);
        }
        function isYieldIteratorResult(type3) {
          return isIteratorResult(type3, 0);
        }
        function isReturnIteratorResult(type3) {
          return isIteratorResult(type3, 1);
        }
        function getIterationTypesOfIteratorResult(type3) {
          if (isTypeAny(type3)) {
            return anyIterationTypes;
          }
          var cachedTypes = getCachedIterationTypes(type3, "iterationTypesOfIteratorResult");
          if (cachedTypes) {
            return cachedTypes;
          }
          if (isReferenceToType(type3, getGlobalIteratorYieldResultType(false))) {
            var yieldType_1 = getTypeArguments(type3)[0];
            return setCachedIterationTypes(type3, "iterationTypesOfIteratorResult", createIterationTypes(yieldType_1, void 0, void 0));
          }
          if (isReferenceToType(type3, getGlobalIteratorReturnResultType(false))) {
            var returnType_1 = getTypeArguments(type3)[0];
            return setCachedIterationTypes(type3, "iterationTypesOfIteratorResult", createIterationTypes(void 0, returnType_1, void 0));
          }
          var yieldIteratorResult = filterType(type3, isYieldIteratorResult);
          var yieldType = yieldIteratorResult !== neverType ? getTypeOfPropertyOfType(yieldIteratorResult, "value") : void 0;
          var returnIteratorResult = filterType(type3, isReturnIteratorResult);
          var returnType2 = returnIteratorResult !== neverType ? getTypeOfPropertyOfType(returnIteratorResult, "value") : void 0;
          if (!yieldType && !returnType2) {
            return setCachedIterationTypes(type3, "iterationTypesOfIteratorResult", noIterationTypes);
          }
          return setCachedIterationTypes(type3, "iterationTypesOfIteratorResult", createIterationTypes(yieldType, returnType2 || voidType, void 0));
        }
        function getIterationTypesOfMethod(type3, resolver, methodName, errorNode) {
          var _a2, _b, _c, _d;
          var method = getPropertyOfType(type3, methodName);
          if (!method && methodName !== "next") {
            return void 0;
          }
          var methodType = method && !(methodName === "next" && method.flags & 16777216) ? methodName === "next" ? getTypeOfSymbol(method) : getTypeWithFacts(getTypeOfSymbol(method), 2097152) : void 0;
          if (isTypeAny(methodType)) {
            return methodName === "next" ? anyIterationTypes : anyIterationTypesExceptNext;
          }
          var methodSignatures = methodType ? getSignaturesOfType(methodType, 0) : ts3.emptyArray;
          if (methodSignatures.length === 0) {
            if (errorNode) {
              var diagnostic = methodName === "next" ? resolver.mustHaveANextMethodDiagnostic : resolver.mustBeAMethodDiagnostic;
              error(errorNode, diagnostic, methodName);
            }
            return methodName === "next" ? anyIterationTypes : void 0;
          }
          if ((methodType === null || methodType === void 0 ? void 0 : methodType.symbol) && methodSignatures.length === 1) {
            var globalGeneratorType = resolver.getGlobalGeneratorType(false);
            var globalIteratorType = resolver.getGlobalIteratorType(false);
            var isGeneratorMethod = ((_b = (_a2 = globalGeneratorType.symbol) === null || _a2 === void 0 ? void 0 : _a2.members) === null || _b === void 0 ? void 0 : _b.get(methodName)) === methodType.symbol;
            var isIteratorMethod = !isGeneratorMethod && ((_d = (_c = globalIteratorType.symbol) === null || _c === void 0 ? void 0 : _c.members) === null || _d === void 0 ? void 0 : _d.get(methodName)) === methodType.symbol;
            if (isGeneratorMethod || isIteratorMethod) {
              var globalType = isGeneratorMethod ? globalGeneratorType : globalIteratorType;
              var mapper = methodType.mapper;
              return createIterationTypes(getMappedType(globalType.typeParameters[0], mapper), getMappedType(globalType.typeParameters[1], mapper), methodName === "next" ? getMappedType(globalType.typeParameters[2], mapper) : void 0);
            }
          }
          var methodParameterTypes;
          var methodReturnTypes;
          for (var _i = 0, methodSignatures_1 = methodSignatures; _i < methodSignatures_1.length; _i++) {
            var signature = methodSignatures_1[_i];
            if (methodName !== "throw" && ts3.some(signature.parameters)) {
              methodParameterTypes = ts3.append(methodParameterTypes, getTypeAtPosition(signature, 0));
            }
            methodReturnTypes = ts3.append(methodReturnTypes, getReturnTypeOfSignature(signature));
          }
          var returnTypes;
          var nextType;
          if (methodName !== "throw") {
            var methodParameterType = methodParameterTypes ? getUnionType(methodParameterTypes) : unknownType;
            if (methodName === "next") {
              nextType = methodParameterType;
            } else if (methodName === "return") {
              var resolvedMethodParameterType = resolver.resolveIterationType(methodParameterType, errorNode) || anyType;
              returnTypes = ts3.append(returnTypes, resolvedMethodParameterType);
            }
          }
          var yieldType;
          var methodReturnType = methodReturnTypes ? getIntersectionType(methodReturnTypes) : neverType;
          var resolvedMethodReturnType = resolver.resolveIterationType(methodReturnType, errorNode) || anyType;
          var iterationTypes = getIterationTypesOfIteratorResult(resolvedMethodReturnType);
          if (iterationTypes === noIterationTypes) {
            if (errorNode) {
              error(errorNode, resolver.mustHaveAValueDiagnostic, methodName);
            }
            yieldType = anyType;
            returnTypes = ts3.append(returnTypes, anyType);
          } else {
            yieldType = iterationTypes.yieldType;
            returnTypes = ts3.append(returnTypes, iterationTypes.returnType);
          }
          return createIterationTypes(yieldType, getUnionType(returnTypes), nextType);
        }
        function getIterationTypesOfIteratorSlow(type3, resolver, errorNode) {
          var iterationTypes = combineIterationTypes([
            getIterationTypesOfMethod(type3, resolver, "next", errorNode),
            getIterationTypesOfMethod(type3, resolver, "return", errorNode),
            getIterationTypesOfMethod(type3, resolver, "throw", errorNode)
          ]);
          return setCachedIterationTypes(type3, resolver.iteratorCacheKey, iterationTypes);
        }
        function getIterationTypeOfGeneratorFunctionReturnType(kind, returnType2, isAsyncGenerator) {
          if (isTypeAny(returnType2)) {
            return void 0;
          }
          var iterationTypes = getIterationTypesOfGeneratorFunctionReturnType(returnType2, isAsyncGenerator);
          return iterationTypes && iterationTypes[getIterationTypesKeyFromIterationTypeKind(kind)];
        }
        function getIterationTypesOfGeneratorFunctionReturnType(type3, isAsyncGenerator) {
          if (isTypeAny(type3)) {
            return anyIterationTypes;
          }
          var use = isAsyncGenerator ? 2 : 1;
          var resolver = isAsyncGenerator ? asyncIterationTypesResolver : syncIterationTypesResolver;
          return getIterationTypesOfIterable(type3, use, void 0) || getIterationTypesOfIterator(type3, resolver, void 0);
        }
        function checkBreakOrContinueStatement(node) {
          if (!checkGrammarStatementInAmbientContext(node))
            checkGrammarBreakOrContinueStatement(node);
        }
        function unwrapReturnType(returnType2, functionFlags) {
          var _a2, _b;
          var isGenerator = !!(functionFlags & 1);
          var isAsync = !!(functionFlags & 2);
          return isGenerator ? (_a2 = getIterationTypeOfGeneratorFunctionReturnType(1, returnType2, isAsync)) !== null && _a2 !== void 0 ? _a2 : errorType : isAsync ? (_b = getAwaitedType(returnType2)) !== null && _b !== void 0 ? _b : errorType : returnType2;
        }
        function isUnwrappedReturnTypeVoidOrAny(func2, returnType2) {
          var unwrappedReturnType = unwrapReturnType(returnType2, ts3.getFunctionFlags(func2));
          return !!unwrappedReturnType && maybeTypeOfKind(unwrappedReturnType, 16384 | 3);
        }
        function checkReturnStatement(node) {
          var _a2;
          if (checkGrammarStatementInAmbientContext(node)) {
            return;
          }
          var func2 = ts3.getContainingFunction(node);
          if (!func2) {
            grammarErrorOnFirstToken(node, ts3.Diagnostics.A_return_statement_can_only_be_used_within_a_function_body);
            return;
          }
          var signature = getSignatureFromDeclaration(func2);
          var returnType2 = getReturnTypeOfSignature(signature);
          var functionFlags = ts3.getFunctionFlags(func2);
          if (strictNullChecks || node.expression || returnType2.flags & 131072) {
            var exprType = node.expression ? checkExpressionCached(node.expression) : undefinedType;
            if (func2.kind === 169) {
              if (node.expression) {
                error(node, ts3.Diagnostics.Setters_cannot_return_a_value);
              }
            } else if (func2.kind === 167) {
              if (node.expression && !checkTypeAssignableToAndOptionallyElaborate(exprType, returnType2, node, node.expression)) {
                error(node, ts3.Diagnostics.Return_type_of_constructor_signature_must_be_assignable_to_the_instance_type_of_the_class);
              }
            } else if (getReturnTypeFromAnnotation(func2)) {
              var unwrappedReturnType = (_a2 = unwrapReturnType(returnType2, functionFlags)) !== null && _a2 !== void 0 ? _a2 : returnType2;
              var unwrappedExprType = functionFlags & 2 ? checkAwaitedType(exprType, node, ts3.Diagnostics.The_return_type_of_an_async_function_must_either_be_a_valid_promise_or_must_not_contain_a_callable_then_member) : exprType;
              if (unwrappedReturnType) {
                checkTypeAssignableToAndOptionallyElaborate(unwrappedExprType, unwrappedReturnType, node, node.expression);
              }
            }
          } else if (func2.kind !== 167 && compilerOptions.noImplicitReturns && !isUnwrappedReturnTypeVoidOrAny(func2, returnType2)) {
            error(node, ts3.Diagnostics.Not_all_code_paths_return_a_value);
          }
        }
        function checkWithStatement(node) {
          if (!checkGrammarStatementInAmbientContext(node)) {
            if (node.flags & 32768) {
              grammarErrorOnFirstToken(node, ts3.Diagnostics.with_statements_are_not_allowed_in_an_async_function_block);
            }
          }
          checkExpression(node.expression);
          var sourceFile = ts3.getSourceFileOfNode(node);
          if (!hasParseDiagnostics(sourceFile)) {
            var start = ts3.getSpanOfTokenAtPosition(sourceFile, node.pos).start;
            var end = node.statement.pos;
            grammarErrorAtPos(sourceFile, start, end - start, ts3.Diagnostics.The_with_statement_is_not_supported_All_symbols_in_a_with_block_will_have_type_any);
          }
        }
        function checkSwitchStatement(node) {
          checkGrammarStatementInAmbientContext(node);
          var firstDefaultClause;
          var hasDuplicateDefaultClause = false;
          var expressionType = checkExpression(node.expression);
          var expressionIsLiteral = isLiteralType(expressionType);
          ts3.forEach(node.caseBlock.clauses, function(clause) {
            if (clause.kind === 286 && !hasDuplicateDefaultClause) {
              if (firstDefaultClause === void 0) {
                firstDefaultClause = clause;
              } else {
                grammarErrorOnNode(clause, ts3.Diagnostics.A_default_clause_cannot_appear_more_than_once_in_a_switch_statement);
                hasDuplicateDefaultClause = true;
              }
            }
            if (produceDiagnostics && clause.kind === 285) {
              var caseType = checkExpression(clause.expression);
              var caseIsLiteral = isLiteralType(caseType);
              var comparedExpressionType = expressionType;
              if (!caseIsLiteral || !expressionIsLiteral) {
                caseType = caseIsLiteral ? getBaseTypeOfLiteralType(caseType) : caseType;
                comparedExpressionType = getBaseTypeOfLiteralType(expressionType);
              }
              if (!isTypeEqualityComparableTo(comparedExpressionType, caseType)) {
                checkTypeComparableTo(caseType, comparedExpressionType, clause.expression, void 0);
              }
            }
            ts3.forEach(clause.statements, checkSourceElement);
            if (compilerOptions.noFallthroughCasesInSwitch && clause.fallthroughFlowNode && isReachableFlowNode(clause.fallthroughFlowNode)) {
              error(clause, ts3.Diagnostics.Fallthrough_case_in_switch);
            }
          });
          if (node.caseBlock.locals) {
            registerForUnusedIdentifiersCheck(node.caseBlock);
          }
        }
        function checkLabeledStatement(node) {
          if (!checkGrammarStatementInAmbientContext(node)) {
            ts3.findAncestor(node.parent, function(current) {
              if (ts3.isFunctionLike(current)) {
                return "quit";
              }
              if (current.kind === 246 && current.label.escapedText === node.label.escapedText) {
                grammarErrorOnNode(node.label, ts3.Diagnostics.Duplicate_label_0, ts3.getTextOfNode(node.label));
                return true;
              }
              return false;
            });
          }
          checkSourceElement(node.statement);
        }
        function checkThrowStatement(node) {
          if (!checkGrammarStatementInAmbientContext(node)) {
            if (ts3.isIdentifier(node.expression) && !node.expression.escapedText) {
              grammarErrorAfterFirstToken(node, ts3.Diagnostics.Line_break_not_permitted_here);
            }
          }
          if (node.expression) {
            checkExpression(node.expression);
          }
        }
        function checkTryStatement(node) {
          checkGrammarStatementInAmbientContext(node);
          checkBlock(node.tryBlock);
          var catchClause = node.catchClause;
          if (catchClause) {
            if (catchClause.variableDeclaration) {
              var declaration = catchClause.variableDeclaration;
              var typeNode = ts3.getEffectiveTypeAnnotationNode(ts3.getRootDeclaration(declaration));
              if (typeNode) {
                var type3 = getTypeForVariableLikeDeclaration(declaration, false);
                if (type3 && !(type3.flags & 3)) {
                  grammarErrorOnFirstToken(typeNode, ts3.Diagnostics.Catch_clause_variable_type_annotation_must_be_any_or_unknown_if_specified);
                }
              } else if (declaration.initializer) {
                grammarErrorOnFirstToken(declaration.initializer, ts3.Diagnostics.Catch_clause_variable_cannot_have_an_initializer);
              } else {
                var blockLocals_1 = catchClause.block.locals;
                if (blockLocals_1) {
                  ts3.forEachKey(catchClause.locals, function(caughtName) {
                    var blockLocal = blockLocals_1.get(caughtName);
                    if ((blockLocal === null || blockLocal === void 0 ? void 0 : blockLocal.valueDeclaration) && (blockLocal.flags & 2) !== 0) {
                      grammarErrorOnNode(blockLocal.valueDeclaration, ts3.Diagnostics.Cannot_redeclare_identifier_0_in_catch_clause, caughtName);
                    }
                  });
                }
              }
            }
            checkBlock(catchClause.block);
          }
          if (node.finallyBlock) {
            checkBlock(node.finallyBlock);
          }
        }
        function checkIndexConstraints(type3, isStatic) {
          var _a2, _b, _c, _d;
          var declaredNumberIndexer = getIndexDeclarationOfSymbolTable(isStatic ? (_a2 = type3.symbol) === null || _a2 === void 0 ? void 0 : _a2.exports : (_b = type3.symbol) === null || _b === void 0 ? void 0 : _b.members, 1);
          var declaredStringIndexer = getIndexDeclarationOfSymbolTable(isStatic ? (_c = type3.symbol) === null || _c === void 0 ? void 0 : _c.exports : (_d = type3.symbol) === null || _d === void 0 ? void 0 : _d.members, 0);
          var stringIndexType = getIndexTypeOfType(type3, 0);
          var numberIndexType = getIndexTypeOfType(type3, 1);
          if (stringIndexType || numberIndexType) {
            ts3.forEach(getPropertiesOfObjectType(type3), function(prop) {
              if (isStatic && prop.flags & 4194304)
                return;
              var propType2 = getTypeOfSymbol(prop);
              checkIndexConstraintForProperty(prop, propType2, type3, declaredStringIndexer, stringIndexType, 0);
              checkIndexConstraintForProperty(prop, propType2, type3, declaredNumberIndexer, numberIndexType, 1);
            });
            var classDeclaration = type3.symbol.valueDeclaration;
            if (ts3.getObjectFlags(type3) & 1 && classDeclaration && ts3.isClassLike(classDeclaration)) {
              for (var _i = 0, _e = classDeclaration.members; _i < _e.length; _i++) {
                var member = _e[_i];
                if (!ts3.hasSyntacticModifier(member, 32) && !hasBindableName(member)) {
                  var symbol = getSymbolOfNode(member);
                  var propType = getTypeOfSymbol(symbol);
                  checkIndexConstraintForProperty(symbol, propType, type3, declaredStringIndexer, stringIndexType, 0);
                  checkIndexConstraintForProperty(symbol, propType, type3, declaredNumberIndexer, numberIndexType, 1);
                }
              }
            }
          }
          var errorNode;
          if (stringIndexType && numberIndexType) {
            errorNode = declaredNumberIndexer || declaredStringIndexer;
            if (!errorNode && ts3.getObjectFlags(type3) & 2) {
              var someBaseTypeHasBothIndexers = ts3.forEach(getBaseTypes(type3), function(base) {
                return getIndexTypeOfType(base, 0) && getIndexTypeOfType(base, 1);
              });
              errorNode = someBaseTypeHasBothIndexers || !type3.symbol.declarations ? void 0 : type3.symbol.declarations[0];
            }
          }
          if (errorNode && !isTypeAssignableTo(numberIndexType, stringIndexType)) {
            error(errorNode, ts3.Diagnostics.Numeric_index_type_0_is_not_assignable_to_string_index_type_1, typeToString(numberIndexType), typeToString(stringIndexType));
          }
          function checkIndexConstraintForProperty(prop, propertyType, containingType, indexDeclaration, indexType, indexKind) {
            if (!indexType || ts3.isKnownSymbol(prop)) {
              return;
            }
            var propDeclaration = prop.valueDeclaration;
            var name = propDeclaration && ts3.getNameOfDeclaration(propDeclaration);
            if (name && ts3.isPrivateIdentifier(name)) {
              return;
            }
            if (indexKind === 1 && !(name ? isNumericName(name) : isNumericLiteralName(prop.escapedName))) {
              return;
            }
            var errorNode2;
            if (propDeclaration && name && (propDeclaration.kind === 217 || name.kind === 159 || prop.parent === containingType.symbol)) {
              errorNode2 = propDeclaration;
            } else if (indexDeclaration) {
              errorNode2 = indexDeclaration;
            } else if (ts3.getObjectFlags(containingType) & 2) {
              var someBaseClassHasBothPropertyAndIndexer = ts3.forEach(getBaseTypes(containingType), function(base) {
                return getPropertyOfObjectType(base, prop.escapedName) && getIndexTypeOfType(base, indexKind);
              });
              errorNode2 = someBaseClassHasBothPropertyAndIndexer || !containingType.symbol.declarations ? void 0 : containingType.symbol.declarations[0];
            }
            if (errorNode2 && !isTypeAssignableTo(propertyType, indexType)) {
              var errorMessage = indexKind === 0 ? ts3.Diagnostics.Property_0_of_type_1_is_not_assignable_to_string_index_type_2 : ts3.Diagnostics.Property_0_of_type_1_is_not_assignable_to_numeric_index_type_2;
              error(errorNode2, errorMessage, symbolToString(prop), typeToString(propertyType), typeToString(indexType));
            }
          }
        }
        function checkTypeNameIsReserved(name, message) {
          switch (name.escapedText) {
            case "any":
            case "unknown":
            case "never":
            case "number":
            case "bigint":
            case "boolean":
            case "string":
            case "symbol":
            case "void":
            case "object":
              error(name, message, name.escapedText);
          }
        }
        function checkClassNameCollisionWithObject(name) {
          if (languageVersion === 1 && name.escapedText === "Object" && moduleKind < ts3.ModuleKind.ES2015) {
            error(name, ts3.Diagnostics.Class_name_cannot_be_Object_when_targeting_ES5_with_module_0, ts3.ModuleKind[moduleKind]);
          }
        }
        function checkTypeParameters(typeParameterDeclarations) {
          if (typeParameterDeclarations) {
            var seenDefault = false;
            for (var i3 = 0; i3 < typeParameterDeclarations.length; i3++) {
              var node = typeParameterDeclarations[i3];
              checkTypeParameter(node);
              if (produceDiagnostics) {
                if (node.default) {
                  seenDefault = true;
                  checkTypeParametersNotReferenced(node.default, typeParameterDeclarations, i3);
                } else if (seenDefault) {
                  error(node, ts3.Diagnostics.Required_type_parameters_may_not_follow_optional_type_parameters);
                }
                for (var j = 0; j < i3; j++) {
                  if (typeParameterDeclarations[j].symbol === node.symbol) {
                    error(node.name, ts3.Diagnostics.Duplicate_identifier_0, ts3.declarationNameToString(node.name));
                  }
                }
              }
            }
          }
        }
        function checkTypeParametersNotReferenced(root, typeParameters, index) {
          visit(root);
          function visit(node) {
            if (node.kind === 174) {
              var type3 = getTypeFromTypeReference(node);
              if (type3.flags & 262144) {
                for (var i3 = index; i3 < typeParameters.length; i3++) {
                  if (type3.symbol === getSymbolOfNode(typeParameters[i3])) {
                    error(node, ts3.Diagnostics.Type_parameter_defaults_can_only_reference_previously_declared_type_parameters);
                  }
                }
              }
            }
            ts3.forEachChild(node, visit);
          }
        }
        function checkTypeParameterListsIdentical(symbol) {
          if (symbol.declarations && symbol.declarations.length === 1) {
            return;
          }
          var links = getSymbolLinks(symbol);
          if (!links.typeParametersChecked) {
            links.typeParametersChecked = true;
            var declarations = getClassOrInterfaceDeclarationsOfSymbol(symbol);
            if (!declarations || declarations.length <= 1) {
              return;
            }
            var type3 = getDeclaredTypeOfSymbol(symbol);
            if (!areTypeParametersIdentical(declarations, type3.localTypeParameters)) {
              var name = symbolToString(symbol);
              for (var _i = 0, declarations_6 = declarations; _i < declarations_6.length; _i++) {
                var declaration = declarations_6[_i];
                error(declaration.name, ts3.Diagnostics.All_declarations_of_0_must_have_identical_type_parameters, name);
              }
            }
          }
        }
        function areTypeParametersIdentical(declarations, targetParameters) {
          var maxTypeArgumentCount = ts3.length(targetParameters);
          var minTypeArgumentCount = getMinTypeArgumentCount(targetParameters);
          for (var _i = 0, declarations_7 = declarations; _i < declarations_7.length; _i++) {
            var declaration = declarations_7[_i];
            var sourceParameters = ts3.getEffectiveTypeParameterDeclarations(declaration);
            var numTypeParameters = sourceParameters.length;
            if (numTypeParameters < minTypeArgumentCount || numTypeParameters > maxTypeArgumentCount) {
              return false;
            }
            for (var i3 = 0; i3 < numTypeParameters; i3++) {
              var source = sourceParameters[i3];
              var target = targetParameters[i3];
              if (source.name.escapedText !== target.symbol.escapedName) {
                return false;
              }
              var constraint = ts3.getEffectiveConstraintOfTypeParameter(source);
              var sourceConstraint = constraint && getTypeFromTypeNode(constraint);
              var targetConstraint = getConstraintOfTypeParameter(target);
              if (sourceConstraint && targetConstraint && !isTypeIdenticalTo(sourceConstraint, targetConstraint)) {
                return false;
              }
              var sourceDefault = source.default && getTypeFromTypeNode(source.default);
              var targetDefault = getDefaultFromTypeParameter(target);
              if (sourceDefault && targetDefault && !isTypeIdenticalTo(sourceDefault, targetDefault)) {
                return false;
              }
            }
          }
          return true;
        }
        function checkClassExpression(node) {
          checkClassLikeDeclaration(node);
          checkNodeDeferred(node);
          return getTypeOfSymbol(getSymbolOfNode(node));
        }
        function checkClassExpressionDeferred(node) {
          ts3.forEach(node.members, checkSourceElement);
          registerForUnusedIdentifiersCheck(node);
        }
        function checkClassDeclaration(node) {
          if (ts3.some(node.decorators) && ts3.some(node.members, function(p) {
            return ts3.hasStaticModifier(p) && ts3.isPrivateIdentifierClassElementDeclaration(p);
          })) {
            grammarErrorOnNode(node.decorators[0], ts3.Diagnostics.Class_decorators_can_t_be_used_with_static_private_identifier_Consider_removing_the_experimental_decorator);
          }
          if (!node.name && !ts3.hasSyntacticModifier(node, 512)) {
            grammarErrorOnFirstToken(node, ts3.Diagnostics.A_class_declaration_without_the_default_modifier_must_have_a_name);
          }
          checkClassLikeDeclaration(node);
          ts3.forEach(node.members, checkSourceElement);
          registerForUnusedIdentifiersCheck(node);
        }
        function checkClassLikeDeclaration(node) {
          checkGrammarClassLikeDeclaration(node);
          checkDecorators(node);
          if (node.name) {
            checkTypeNameIsReserved(node.name, ts3.Diagnostics.Class_name_cannot_be_0);
            checkCollisionWithRequireExportsInGeneratedCode(node, node.name);
            checkCollisionWithGlobalPromiseInGeneratedCode(node, node.name);
            if (!(node.flags & 8388608)) {
              checkClassNameCollisionWithObject(node.name);
            }
          }
          checkTypeParameters(ts3.getEffectiveTypeParameterDeclarations(node));
          checkExportsOnMergedDeclarations(node);
          var symbol = getSymbolOfNode(node);
          var type3 = getDeclaredTypeOfSymbol(symbol);
          var typeWithThis = getTypeWithThisArgument(type3);
          var staticType = getTypeOfSymbol(symbol);
          checkTypeParameterListsIdentical(symbol);
          checkFunctionOrConstructorSymbol(symbol);
          checkClassForDuplicateDeclarations(node);
          var nodeInAmbientContext = !!(node.flags & 8388608);
          if (!nodeInAmbientContext) {
            checkClassForStaticPropertyNameConflicts(node);
          }
          var baseTypeNode = ts3.getEffectiveBaseTypeNode(node);
          if (baseTypeNode) {
            ts3.forEach(baseTypeNode.typeArguments, checkSourceElement);
            if (languageVersion < 2) {
              checkExternalEmitHelpers(baseTypeNode.parent, 1);
            }
            var extendsNode = ts3.getClassExtendsHeritageElement(node);
            if (extendsNode && extendsNode !== baseTypeNode) {
              checkExpression(extendsNode.expression);
            }
            var baseTypes = getBaseTypes(type3);
            if (baseTypes.length && produceDiagnostics) {
              var baseType_1 = baseTypes[0];
              var baseConstructorType = getBaseConstructorTypeOfClass(type3);
              var staticBaseType = getApparentType(baseConstructorType);
              checkBaseTypeAccessibility(staticBaseType, baseTypeNode);
              checkSourceElement(baseTypeNode.expression);
              if (ts3.some(baseTypeNode.typeArguments)) {
                ts3.forEach(baseTypeNode.typeArguments, checkSourceElement);
                for (var _i = 0, _a2 = getConstructorsForTypeArguments(staticBaseType, baseTypeNode.typeArguments, baseTypeNode); _i < _a2.length; _i++) {
                  var constructor = _a2[_i];
                  if (!checkTypeArgumentConstraints(baseTypeNode, constructor.typeParameters)) {
                    break;
                  }
                }
              }
              var baseWithThis = getTypeWithThisArgument(baseType_1, type3.thisType);
              if (!checkTypeAssignableTo(typeWithThis, baseWithThis, void 0)) {
                issueMemberSpecificError(node, typeWithThis, baseWithThis, ts3.Diagnostics.Class_0_incorrectly_extends_base_class_1);
              } else {
                checkTypeAssignableTo(staticType, getTypeWithoutSignatures(staticBaseType), node.name || node, ts3.Diagnostics.Class_static_side_0_incorrectly_extends_base_class_static_side_1);
              }
              if (baseConstructorType.flags & 8650752) {
                if (!isMixinConstructorType(staticType)) {
                  error(node.name || node, ts3.Diagnostics.A_mixin_class_must_have_a_constructor_with_a_single_rest_parameter_of_type_any);
                } else {
                  var constructSignatures = getSignaturesOfType(baseConstructorType, 1);
                  if (constructSignatures.some(function(signature) {
                    return signature.flags & 4;
                  }) && !ts3.hasSyntacticModifier(node, 128)) {
                    error(node.name || node, ts3.Diagnostics.A_mixin_class_that_extends_from_a_type_variable_containing_an_abstract_construct_signature_must_also_be_declared_abstract);
                  }
                }
              }
              if (!(staticBaseType.symbol && staticBaseType.symbol.flags & 32) && !(baseConstructorType.flags & 8650752)) {
                var constructors = getInstantiatedConstructorsForTypeArguments(staticBaseType, baseTypeNode.typeArguments, baseTypeNode);
                if (ts3.forEach(constructors, function(sig) {
                  return !isJSConstructor(sig.declaration) && !isTypeIdenticalTo(getReturnTypeOfSignature(sig), baseType_1);
                })) {
                  error(baseTypeNode.expression, ts3.Diagnostics.Base_constructors_must_all_have_the_same_return_type);
                }
              }
              checkKindsOfPropertyMemberOverrides(type3, baseType_1);
            }
          }
          checkMembersForMissingOverrideModifier(node, type3, typeWithThis, staticType);
          var implementedTypeNodes = ts3.getEffectiveImplementsTypeNodes(node);
          if (implementedTypeNodes) {
            for (var _b = 0, implementedTypeNodes_1 = implementedTypeNodes; _b < implementedTypeNodes_1.length; _b++) {
              var typeRefNode = implementedTypeNodes_1[_b];
              if (!ts3.isEntityNameExpression(typeRefNode.expression) || ts3.isOptionalChain(typeRefNode.expression)) {
                error(typeRefNode.expression, ts3.Diagnostics.A_class_can_only_implement_an_identifier_Slashqualified_name_with_optional_type_arguments);
              }
              checkTypeReferenceNode(typeRefNode);
              if (produceDiagnostics) {
                var t2 = getReducedType(getTypeFromTypeNode(typeRefNode));
                if (t2 !== errorType) {
                  if (isValidBaseType(t2)) {
                    var genericDiag = t2.symbol && t2.symbol.flags & 32 ? ts3.Diagnostics.Class_0_incorrectly_implements_class_1_Did_you_mean_to_extend_1_and_inherit_its_members_as_a_subclass : ts3.Diagnostics.Class_0_incorrectly_implements_interface_1;
                    var baseWithThis = getTypeWithThisArgument(t2, type3.thisType);
                    if (!checkTypeAssignableTo(typeWithThis, baseWithThis, void 0)) {
                      issueMemberSpecificError(node, typeWithThis, baseWithThis, genericDiag);
                    }
                  } else {
                    error(typeRefNode, ts3.Diagnostics.A_class_can_only_implement_an_object_type_or_intersection_of_object_types_with_statically_known_members);
                  }
                }
              }
            }
          }
          if (produceDiagnostics) {
            checkIndexConstraints(type3);
            checkIndexConstraints(staticType, true);
            checkTypeForDuplicateIndexSignatures(node);
            checkPropertyInitialization(node);
          }
        }
        function checkMembersForMissingOverrideModifier(node, type3, typeWithThis, staticType) {
          var nodeInAmbientContext = !!(node.flags & 8388608);
          var baseTypeNode = ts3.getEffectiveBaseTypeNode(node);
          var baseTypes = baseTypeNode && getBaseTypes(type3);
          var baseWithThis = (baseTypes === null || baseTypes === void 0 ? void 0 : baseTypes.length) ? getTypeWithThisArgument(ts3.first(baseTypes), type3.thisType) : void 0;
          var baseStaticType = getBaseConstructorTypeOfClass(type3);
          var _loop_24 = function(member2) {
            if (ts3.hasAmbientModifier(member2)) {
              return "continue";
            }
            if (ts3.isConstructorDeclaration(member2)) {
              ts3.forEach(member2.parameters, function(param) {
                if (ts3.isParameterPropertyDeclaration(param, member2)) {
                  checkClassMember(param, true);
                }
              });
            }
            checkClassMember(member2);
          };
          for (var _i = 0, _a2 = node.members; _i < _a2.length; _i++) {
            var member = _a2[_i];
            _loop_24(member);
          }
          function checkClassMember(member2, memberIsParameterProperty) {
            var hasOverride = ts3.hasOverrideModifier(member2);
            var hasStatic = ts3.hasStaticModifier(member2);
            if (baseWithThis && (hasOverride || compilerOptions.noImplicitOverride)) {
              var declaredProp = member2.name && getSymbolAtLocation(member2.name) || getSymbolAtLocation(member2);
              if (!declaredProp) {
                return;
              }
              var thisType = hasStatic ? staticType : typeWithThis;
              var baseType = hasStatic ? baseStaticType : baseWithThis;
              var prop = getPropertyOfType(thisType, declaredProp.escapedName);
              var baseProp = getPropertyOfType(baseType, declaredProp.escapedName);
              var baseClassName = typeToString(baseWithThis);
              if (prop && !baseProp && hasOverride) {
                error(member2, ts3.Diagnostics.This_member_cannot_have_an_override_modifier_because_it_is_not_declared_in_the_base_class_0, baseClassName);
              } else if (prop && (baseProp === null || baseProp === void 0 ? void 0 : baseProp.valueDeclaration) && compilerOptions.noImplicitOverride && !nodeInAmbientContext) {
                var baseHasAbstract = ts3.hasAbstractModifier(baseProp.valueDeclaration);
                if (hasOverride) {
                  return;
                }
                if (!baseHasAbstract) {
                  var diag = memberIsParameterProperty ? ts3.Diagnostics.This_parameter_property_must_have_an_override_modifier_because_it_overrides_a_member_in_base_class_0 : ts3.Diagnostics.This_member_must_have_an_override_modifier_because_it_overrides_a_member_in_the_base_class_0;
                  error(member2, diag, baseClassName);
                } else if (ts3.hasAbstractModifier(member2) && baseHasAbstract) {
                  error(member2, ts3.Diagnostics.This_member_must_have_an_override_modifier_because_it_overrides_an_abstract_method_that_is_declared_in_the_base_class_0, baseClassName);
                }
              }
            } else if (hasOverride) {
              var className = typeToString(type3);
              error(member2, ts3.Diagnostics.This_member_cannot_have_an_override_modifier_because_its_containing_class_0_does_not_extend_another_class, className);
            }
          }
        }
        function issueMemberSpecificError(node, typeWithThis, baseWithThis, broadDiag) {
          var issuedMemberError = false;
          var _loop_25 = function(member2) {
            if (ts3.hasStaticModifier(member2)) {
              return "continue";
            }
            var declaredProp = member2.name && getSymbolAtLocation(member2.name) || getSymbolAtLocation(member2);
            if (declaredProp) {
              var prop = getPropertyOfType(typeWithThis, declaredProp.escapedName);
              var baseProp = getPropertyOfType(baseWithThis, declaredProp.escapedName);
              if (prop && baseProp) {
                var rootChain = function() {
                  return ts3.chainDiagnosticMessages(void 0, ts3.Diagnostics.Property_0_in_type_1_is_not_assignable_to_the_same_property_in_base_type_2, symbolToString(declaredProp), typeToString(typeWithThis), typeToString(baseWithThis));
                };
                if (!checkTypeAssignableTo(getTypeOfSymbol(prop), getTypeOfSymbol(baseProp), member2.name || member2, void 0, rootChain)) {
                  issuedMemberError = true;
                }
              }
            }
          };
          for (var _i = 0, _a2 = node.members; _i < _a2.length; _i++) {
            var member = _a2[_i];
            _loop_25(member);
          }
          if (!issuedMemberError) {
            checkTypeAssignableTo(typeWithThis, baseWithThis, node.name || node, broadDiag);
          }
        }
        function checkBaseTypeAccessibility(type3, node) {
          var signatures = getSignaturesOfType(type3, 1);
          if (signatures.length) {
            var declaration = signatures[0].declaration;
            if (declaration && ts3.hasEffectiveModifier(declaration, 8)) {
              var typeClassDeclaration = ts3.getClassLikeDeclarationOfSymbol(type3.symbol);
              if (!isNodeWithinClass(node, typeClassDeclaration)) {
                error(node, ts3.Diagnostics.Cannot_extend_a_class_0_Class_constructor_is_marked_as_private, getFullyQualifiedName(type3.symbol));
              }
            }
          }
        }
        function getTargetSymbol(s2) {
          return ts3.getCheckFlags(s2) & 1 ? s2.target : s2;
        }
        function getClassOrInterfaceDeclarationsOfSymbol(symbol) {
          return ts3.filter(symbol.declarations, function(d) {
            return d.kind === 253 || d.kind === 254;
          });
        }
        function checkKindsOfPropertyMemberOverrides(type3, baseType) {
          var _a2, _b;
          var baseProperties = getPropertiesOfType(baseType);
          basePropertyCheck:
            for (var _i = 0, baseProperties_1 = baseProperties; _i < baseProperties_1.length; _i++) {
              var baseProperty = baseProperties_1[_i];
              var base = getTargetSymbol(baseProperty);
              if (base.flags & 4194304) {
                continue;
              }
              var baseSymbol = getPropertyOfObjectType(type3, base.escapedName);
              if (!baseSymbol) {
                continue;
              }
              var derived = getTargetSymbol(baseSymbol);
              var baseDeclarationFlags = ts3.getDeclarationModifierFlagsFromSymbol(base);
              ts3.Debug.assert(!!derived, "derived should point to something, even if it is the base class' declaration.");
              if (derived === base) {
                var derivedClassDecl = ts3.getClassLikeDeclarationOfSymbol(type3.symbol);
                if (baseDeclarationFlags & 128 && (!derivedClassDecl || !ts3.hasSyntacticModifier(derivedClassDecl, 128))) {
                  for (var _c = 0, _d = getBaseTypes(type3); _c < _d.length; _c++) {
                    var otherBaseType = _d[_c];
                    if (otherBaseType === baseType)
                      continue;
                    var baseSymbol_1 = getPropertyOfObjectType(otherBaseType, base.escapedName);
                    var derivedElsewhere = baseSymbol_1 && getTargetSymbol(baseSymbol_1);
                    if (derivedElsewhere && derivedElsewhere !== base) {
                      continue basePropertyCheck;
                    }
                  }
                  if (derivedClassDecl.kind === 222) {
                    error(derivedClassDecl, ts3.Diagnostics.Non_abstract_class_expression_does_not_implement_inherited_abstract_member_0_from_class_1, symbolToString(baseProperty), typeToString(baseType));
                  } else {
                    error(derivedClassDecl, ts3.Diagnostics.Non_abstract_class_0_does_not_implement_inherited_abstract_member_1_from_class_2, typeToString(type3), symbolToString(baseProperty), typeToString(baseType));
                  }
                }
              } else {
                var derivedDeclarationFlags = ts3.getDeclarationModifierFlagsFromSymbol(derived);
                if (baseDeclarationFlags & 8 || derivedDeclarationFlags & 8) {
                  continue;
                }
                var errorMessage = void 0;
                var basePropertyFlags = base.flags & 98308;
                var derivedPropertyFlags = derived.flags & 98308;
                if (basePropertyFlags && derivedPropertyFlags) {
                  if (baseDeclarationFlags & 128 && !(base.valueDeclaration && ts3.isPropertyDeclaration(base.valueDeclaration) && base.valueDeclaration.initializer) || base.valueDeclaration && base.valueDeclaration.parent.kind === 254 || derived.valueDeclaration && ts3.isBinaryExpression(derived.valueDeclaration)) {
                    continue;
                  }
                  var overriddenInstanceProperty = basePropertyFlags !== 4 && derivedPropertyFlags === 4;
                  var overriddenInstanceAccessor = basePropertyFlags === 4 && derivedPropertyFlags !== 4;
                  if (overriddenInstanceProperty || overriddenInstanceAccessor) {
                    var errorMessage_1 = overriddenInstanceProperty ? ts3.Diagnostics._0_is_defined_as_an_accessor_in_class_1_but_is_overridden_here_in_2_as_an_instance_property : ts3.Diagnostics._0_is_defined_as_a_property_in_class_1_but_is_overridden_here_in_2_as_an_accessor;
                    error(ts3.getNameOfDeclaration(derived.valueDeclaration) || derived.valueDeclaration, errorMessage_1, symbolToString(base), typeToString(baseType), typeToString(type3));
                  } else if (useDefineForClassFields) {
                    var uninitialized = (_a2 = derived.declarations) === null || _a2 === void 0 ? void 0 : _a2.find(function(d) {
                      return d.kind === 164 && !d.initializer;
                    });
                    if (uninitialized && !(derived.flags & 33554432) && !(baseDeclarationFlags & 128) && !(derivedDeclarationFlags & 128) && !((_b = derived.declarations) === null || _b === void 0 ? void 0 : _b.some(function(d) {
                      return !!(d.flags & 8388608);
                    }))) {
                      var constructor = findConstructorDeclaration(ts3.getClassLikeDeclarationOfSymbol(type3.symbol));
                      var propName = uninitialized.name;
                      if (uninitialized.exclamationToken || !constructor || !ts3.isIdentifier(propName) || !strictNullChecks || !isPropertyInitializedInConstructor(propName, type3, constructor)) {
                        var errorMessage_2 = ts3.Diagnostics.Property_0_will_overwrite_the_base_property_in_1_If_this_is_intentional_add_an_initializer_Otherwise_add_a_declare_modifier_or_remove_the_redundant_declaration;
                        error(ts3.getNameOfDeclaration(derived.valueDeclaration) || derived.valueDeclaration, errorMessage_2, symbolToString(base), typeToString(baseType));
                      }
                    }
                  }
                  continue;
                } else if (isPrototypeProperty(base)) {
                  if (isPrototypeProperty(derived) || derived.flags & 4) {
                    continue;
                  } else {
                    ts3.Debug.assert(!!(derived.flags & 98304));
                    errorMessage = ts3.Diagnostics.Class_0_defines_instance_member_function_1_but_extended_class_2_defines_it_as_instance_member_accessor;
                  }
                } else if (base.flags & 98304) {
                  errorMessage = ts3.Diagnostics.Class_0_defines_instance_member_accessor_1_but_extended_class_2_defines_it_as_instance_member_function;
                } else {
                  errorMessage = ts3.Diagnostics.Class_0_defines_instance_member_property_1_but_extended_class_2_defines_it_as_instance_member_function;
                }
                error(ts3.getNameOfDeclaration(derived.valueDeclaration) || derived.valueDeclaration, errorMessage, typeToString(baseType), symbolToString(base), typeToString(type3));
              }
            }
        }
        function getNonInterhitedProperties(type3, baseTypes, properties) {
          if (!ts3.length(baseTypes)) {
            return properties;
          }
          var seen = new ts3.Map();
          ts3.forEach(properties, function(p) {
            seen.set(p.escapedName, p);
          });
          for (var _i = 0, baseTypes_2 = baseTypes; _i < baseTypes_2.length; _i++) {
            var base = baseTypes_2[_i];
            var properties_5 = getPropertiesOfType(getTypeWithThisArgument(base, type3.thisType));
            for (var _a2 = 0, properties_4 = properties_5; _a2 < properties_4.length; _a2++) {
              var prop = properties_4[_a2];
              var existing = seen.get(prop.escapedName);
              if (existing && !isPropertyIdenticalTo(existing, prop)) {
                seen.delete(prop.escapedName);
              }
            }
          }
          return ts3.arrayFrom(seen.values());
        }
        function checkInheritedPropertiesAreIdentical(type3, typeNode) {
          var baseTypes = getBaseTypes(type3);
          if (baseTypes.length < 2) {
            return true;
          }
          var seen = new ts3.Map();
          ts3.forEach(resolveDeclaredMembers(type3).declaredProperties, function(p) {
            seen.set(p.escapedName, { prop: p, containingType: type3 });
          });
          var ok = true;
          for (var _i = 0, baseTypes_3 = baseTypes; _i < baseTypes_3.length; _i++) {
            var base = baseTypes_3[_i];
            var properties = getPropertiesOfType(getTypeWithThisArgument(base, type3.thisType));
            for (var _a2 = 0, properties_6 = properties; _a2 < properties_6.length; _a2++) {
              var prop = properties_6[_a2];
              var existing = seen.get(prop.escapedName);
              if (!existing) {
                seen.set(prop.escapedName, { prop, containingType: base });
              } else {
                var isInheritedProperty = existing.containingType !== type3;
                if (isInheritedProperty && !isPropertyIdenticalTo(existing.prop, prop)) {
                  ok = false;
                  var typeName1 = typeToString(existing.containingType);
                  var typeName2 = typeToString(base);
                  var errorInfo = ts3.chainDiagnosticMessages(void 0, ts3.Diagnostics.Named_property_0_of_types_1_and_2_are_not_identical, symbolToString(prop), typeName1, typeName2);
                  errorInfo = ts3.chainDiagnosticMessages(errorInfo, ts3.Diagnostics.Interface_0_cannot_simultaneously_extend_types_1_and_2, typeToString(type3), typeName1, typeName2);
                  diagnostics.add(ts3.createDiagnosticForNodeFromMessageChain(typeNode, errorInfo));
                }
              }
            }
          }
          return ok;
        }
        function checkPropertyInitialization(node) {
          if (!strictNullChecks || !strictPropertyInitialization || node.flags & 8388608) {
            return;
          }
          var constructor = findConstructorDeclaration(node);
          for (var _i = 0, _a2 = node.members; _i < _a2.length; _i++) {
            var member = _a2[_i];
            if (ts3.getEffectiveModifierFlags(member) & 2) {
              continue;
            }
            if (isInstancePropertyWithoutInitializer(member)) {
              var propName = member.name;
              if (ts3.isIdentifier(propName) || ts3.isPrivateIdentifier(propName)) {
                var type3 = getTypeOfSymbol(getSymbolOfNode(member));
                if (!(type3.flags & 3 || getFalsyFlags(type3) & 32768)) {
                  if (!constructor || !isPropertyInitializedInConstructor(propName, type3, constructor)) {
                    error(member.name, ts3.Diagnostics.Property_0_has_no_initializer_and_is_not_definitely_assigned_in_the_constructor, ts3.declarationNameToString(propName));
                  }
                }
              }
            }
          }
        }
        function isInstancePropertyWithoutInitializer(node) {
          return node.kind === 164 && !ts3.hasSyntacticModifier(node, 32 | 128) && !node.exclamationToken && !node.initializer;
        }
        function isPropertyInitializedInConstructor(propName, propType, constructor) {
          var reference = ts3.factory.createPropertyAccessExpression(ts3.factory.createThis(), propName);
          ts3.setParent(reference.expression, reference);
          ts3.setParent(reference, constructor);
          reference.flowNode = constructor.returnFlowNode;
          var flowType = getFlowTypeOfReference(reference, propType, getOptionalType(propType));
          return !(getFalsyFlags(flowType) & 32768);
        }
        function checkInterfaceDeclaration(node) {
          if (!checkGrammarDecoratorsAndModifiers(node))
            checkGrammarInterfaceDeclaration(node);
          checkTypeParameters(node.typeParameters);
          if (produceDiagnostics) {
            checkTypeNameIsReserved(node.name, ts3.Diagnostics.Interface_name_cannot_be_0);
            checkExportsOnMergedDeclarations(node);
            var symbol = getSymbolOfNode(node);
            checkTypeParameterListsIdentical(symbol);
            var firstInterfaceDecl = ts3.getDeclarationOfKind(symbol, 254);
            if (node === firstInterfaceDecl) {
              var type3 = getDeclaredTypeOfSymbol(symbol);
              var typeWithThis = getTypeWithThisArgument(type3);
              if (checkInheritedPropertiesAreIdentical(type3, node.name)) {
                for (var _i = 0, _a2 = getBaseTypes(type3); _i < _a2.length; _i++) {
                  var baseType = _a2[_i];
                  checkTypeAssignableTo(typeWithThis, getTypeWithThisArgument(baseType, type3.thisType), node.name, ts3.Diagnostics.Interface_0_incorrectly_extends_interface_1);
                }
                checkIndexConstraints(type3);
              }
            }
            checkObjectTypeForDuplicateDeclarations(node);
          }
          ts3.forEach(ts3.getInterfaceBaseTypeNodes(node), function(heritageElement) {
            if (!ts3.isEntityNameExpression(heritageElement.expression) || ts3.isOptionalChain(heritageElement.expression)) {
              error(heritageElement.expression, ts3.Diagnostics.An_interface_can_only_extend_an_identifier_Slashqualified_name_with_optional_type_arguments);
            }
            checkTypeReferenceNode(heritageElement);
          });
          ts3.forEach(node.members, checkSourceElement);
          if (produceDiagnostics) {
            checkTypeForDuplicateIndexSignatures(node);
            registerForUnusedIdentifiersCheck(node);
          }
        }
        function checkTypeAliasDeclaration(node) {
          checkGrammarDecoratorsAndModifiers(node);
          checkTypeNameIsReserved(node.name, ts3.Diagnostics.Type_alias_name_cannot_be_0);
          checkExportsOnMergedDeclarations(node);
          checkTypeParameters(node.typeParameters);
          if (node.type.kind === 136) {
            if (!intrinsicTypeKinds.has(node.name.escapedText) || ts3.length(node.typeParameters) !== 1) {
              error(node.type, ts3.Diagnostics.The_intrinsic_keyword_can_only_be_used_to_declare_compiler_provided_intrinsic_types);
            }
          } else {
            checkSourceElement(node.type);
            registerForUnusedIdentifiersCheck(node);
          }
        }
        function computeEnumMemberValues(node) {
          var nodeLinks2 = getNodeLinks(node);
          if (!(nodeLinks2.flags & 16384)) {
            nodeLinks2.flags |= 16384;
            var autoValue = 0;
            for (var _i = 0, _a2 = node.members; _i < _a2.length; _i++) {
              var member = _a2[_i];
              var value = computeMemberValue(member, autoValue);
              getNodeLinks(member).enumMemberValue = value;
              autoValue = typeof value === "number" ? value + 1 : void 0;
            }
          }
        }
        function computeMemberValue(member, autoValue) {
          if (ts3.isComputedNonLiteralName(member.name)) {
            error(member.name, ts3.Diagnostics.Computed_property_names_are_not_allowed_in_enums);
          } else {
            var text = ts3.getTextOfPropertyName(member.name);
            if (isNumericLiteralName(text) && !isInfinityOrNaNString(text)) {
              error(member.name, ts3.Diagnostics.An_enum_member_cannot_have_a_numeric_name);
            }
          }
          if (member.initializer) {
            return computeConstantValue(member);
          }
          if (member.parent.flags & 8388608 && !ts3.isEnumConst(member.parent) && getEnumKind(getSymbolOfNode(member.parent)) === 0) {
            return void 0;
          }
          if (autoValue !== void 0) {
            return autoValue;
          }
          error(member.name, ts3.Diagnostics.Enum_member_must_have_initializer);
          return void 0;
        }
        function computeConstantValue(member) {
          var enumKind = getEnumKind(getSymbolOfNode(member.parent));
          var isConstEnum = ts3.isEnumConst(member.parent);
          var initializer = member.initializer;
          var value = enumKind === 1 && !isLiteralEnumMember(member) ? void 0 : evaluate(initializer);
          if (value !== void 0) {
            if (isConstEnum && typeof value === "number" && !isFinite(value)) {
              error(initializer, isNaN(value) ? ts3.Diagnostics.const_enum_member_initializer_was_evaluated_to_disallowed_value_NaN : ts3.Diagnostics.const_enum_member_initializer_was_evaluated_to_a_non_finite_value);
            }
          } else if (enumKind === 1) {
            error(initializer, ts3.Diagnostics.Computed_values_are_not_permitted_in_an_enum_with_string_valued_members);
            return 0;
          } else if (isConstEnum) {
            error(initializer, ts3.Diagnostics.const_enum_member_initializers_can_only_contain_literal_values_and_other_computed_enum_values);
          } else if (member.parent.flags & 8388608) {
            error(initializer, ts3.Diagnostics.In_ambient_enum_declarations_member_initializer_must_be_constant_expression);
          } else {
            var source = checkExpression(initializer);
            if (!isTypeAssignableToKind(source, 296)) {
              error(initializer, ts3.Diagnostics.Only_numeric_enums_can_have_computed_members_but_this_expression_has_type_0_If_you_do_not_need_exhaustiveness_checks_consider_using_an_object_literal_instead, typeToString(source));
            } else {
              checkTypeAssignableTo(source, getDeclaredTypeOfSymbol(getSymbolOfNode(member.parent)), initializer, void 0);
            }
          }
          return value;
          function evaluate(expr) {
            switch (expr.kind) {
              case 215:
                var value_2 = evaluate(expr.operand);
                if (typeof value_2 === "number") {
                  switch (expr.operator) {
                    case 39:
                      return value_2;
                    case 40:
                      return -value_2;
                    case 54:
                      return ~value_2;
                  }
                }
                break;
              case 217:
                var left = evaluate(expr.left);
                var right = evaluate(expr.right);
                if (typeof left === "number" && typeof right === "number") {
                  switch (expr.operatorToken.kind) {
                    case 51:
                      return left | right;
                    case 50:
                      return left & right;
                    case 48:
                      return left >> right;
                    case 49:
                      return left >>> right;
                    case 47:
                      return left << right;
                    case 52:
                      return left ^ right;
                    case 41:
                      return left * right;
                    case 43:
                      return left / right;
                    case 39:
                      return left + right;
                    case 40:
                      return left - right;
                    case 44:
                      return left % right;
                    case 42:
                      return Math.pow(left, right);
                  }
                } else if (typeof left === "string" && typeof right === "string" && expr.operatorToken.kind === 39) {
                  return left + right;
                }
                break;
              case 10:
              case 14:
                return expr.text;
              case 8:
                checkGrammarNumericLiteral(expr);
                return +expr.text;
              case 208:
                return evaluate(expr.expression);
              case 78:
                var identifier = expr;
                if (isInfinityOrNaNString(identifier.escapedText)) {
                  return +identifier.escapedText;
                }
                return ts3.nodeIsMissing(expr) ? 0 : evaluateEnumMember(expr, getSymbolOfNode(member.parent), identifier.escapedText);
              case 203:
              case 202:
                var ex = expr;
                if (isConstantMemberAccess(ex)) {
                  var type3 = getTypeOfExpression(ex.expression);
                  if (type3.symbol && type3.symbol.flags & 384) {
                    var name = void 0;
                    if (ex.kind === 202) {
                      name = ex.name.escapedText;
                    } else {
                      name = ts3.escapeLeadingUnderscores(ts3.cast(ex.argumentExpression, ts3.isLiteralExpression).text);
                    }
                    return evaluateEnumMember(expr, type3.symbol, name);
                  }
                }
                break;
            }
            return void 0;
          }
          function evaluateEnumMember(expr, enumSymbol, name) {
            var memberSymbol = enumSymbol.exports.get(name);
            if (memberSymbol) {
              var declaration = memberSymbol.valueDeclaration;
              if (declaration !== member) {
                if (declaration && isBlockScopedNameDeclaredBeforeUse(declaration, member)) {
                  return getEnumMemberValue(declaration);
                }
                error(expr, ts3.Diagnostics.A_member_initializer_in_a_enum_declaration_cannot_reference_members_declared_after_it_including_members_defined_in_other_enums);
                return 0;
              } else {
                error(expr, ts3.Diagnostics.Property_0_is_used_before_being_assigned, symbolToString(memberSymbol));
              }
            }
            return void 0;
          }
        }
        function isConstantMemberAccess(node) {
          return node.kind === 78 || node.kind === 202 && isConstantMemberAccess(node.expression) || node.kind === 203 && isConstantMemberAccess(node.expression) && ts3.isStringLiteralLike(node.argumentExpression);
        }
        function checkEnumDeclaration(node) {
          if (!produceDiagnostics) {
            return;
          }
          checkGrammarDecoratorsAndModifiers(node);
          checkTypeNameIsReserved(node.name, ts3.Diagnostics.Enum_name_cannot_be_0);
          checkCollisionWithRequireExportsInGeneratedCode(node, node.name);
          checkCollisionWithGlobalPromiseInGeneratedCode(node, node.name);
          checkExportsOnMergedDeclarations(node);
          node.members.forEach(checkEnumMember);
          computeEnumMemberValues(node);
          var enumSymbol = getSymbolOfNode(node);
          var firstDeclaration = ts3.getDeclarationOfKind(enumSymbol, node.kind);
          if (node === firstDeclaration) {
            if (enumSymbol.declarations && enumSymbol.declarations.length > 1) {
              var enumIsConst_1 = ts3.isEnumConst(node);
              ts3.forEach(enumSymbol.declarations, function(decl) {
                if (ts3.isEnumDeclaration(decl) && ts3.isEnumConst(decl) !== enumIsConst_1) {
                  error(ts3.getNameOfDeclaration(decl), ts3.Diagnostics.Enum_declarations_must_all_be_const_or_non_const);
                }
              });
            }
            var seenEnumMissingInitialInitializer_1 = false;
            ts3.forEach(enumSymbol.declarations, function(declaration) {
              if (declaration.kind !== 256) {
                return false;
              }
              var enumDeclaration = declaration;
              if (!enumDeclaration.members.length) {
                return false;
              }
              var firstEnumMember = enumDeclaration.members[0];
              if (!firstEnumMember.initializer) {
                if (seenEnumMissingInitialInitializer_1) {
                  error(firstEnumMember.name, ts3.Diagnostics.In_an_enum_with_multiple_declarations_only_one_declaration_can_omit_an_initializer_for_its_first_enum_element);
                } else {
                  seenEnumMissingInitialInitializer_1 = true;
                }
              }
            });
          }
        }
        function checkEnumMember(node) {
          if (ts3.isPrivateIdentifier(node.name)) {
            error(node, ts3.Diagnostics.An_enum_member_cannot_be_named_with_a_private_identifier);
          }
        }
        function getFirstNonAmbientClassOrFunctionDeclaration(symbol) {
          var declarations = symbol.declarations;
          if (declarations) {
            for (var _i = 0, declarations_8 = declarations; _i < declarations_8.length; _i++) {
              var declaration = declarations_8[_i];
              if ((declaration.kind === 253 || declaration.kind === 252 && ts3.nodeIsPresent(declaration.body)) && !(declaration.flags & 8388608)) {
                return declaration;
              }
            }
          }
          return void 0;
        }
        function inSameLexicalScope(node1, node2) {
          var container1 = ts3.getEnclosingBlockScopeContainer(node1);
          var container2 = ts3.getEnclosingBlockScopeContainer(node2);
          if (isGlobalSourceFile(container1)) {
            return isGlobalSourceFile(container2);
          } else if (isGlobalSourceFile(container2)) {
            return false;
          } else {
            return container1 === container2;
          }
        }
        function checkModuleDeclaration(node) {
          if (produceDiagnostics) {
            var isGlobalAugmentation = ts3.isGlobalScopeAugmentation(node);
            var inAmbientContext = node.flags & 8388608;
            if (isGlobalAugmentation && !inAmbientContext) {
              error(node.name, ts3.Diagnostics.Augmentations_for_the_global_scope_should_have_declare_modifier_unless_they_appear_in_already_ambient_context);
            }
            var isAmbientExternalModule = ts3.isAmbientModule(node);
            var contextErrorMessage = isAmbientExternalModule ? ts3.Diagnostics.An_ambient_module_declaration_is_only_allowed_at_the_top_level_in_a_file : ts3.Diagnostics.A_namespace_declaration_is_only_allowed_in_a_namespace_or_module;
            if (checkGrammarModuleElementContext(node, contextErrorMessage)) {
              return;
            }
            if (!checkGrammarDecoratorsAndModifiers(node)) {
              if (!inAmbientContext && node.name.kind === 10) {
                grammarErrorOnNode(node.name, ts3.Diagnostics.Only_ambient_modules_can_use_quoted_names);
              }
            }
            if (ts3.isIdentifier(node.name)) {
              checkCollisionWithRequireExportsInGeneratedCode(node, node.name);
              checkCollisionWithGlobalPromiseInGeneratedCode(node, node.name);
            }
            checkExportsOnMergedDeclarations(node);
            var symbol = getSymbolOfNode(node);
            if (symbol.flags & 512 && !inAmbientContext && symbol.declarations && symbol.declarations.length > 1 && isInstantiatedModule(node, ts3.shouldPreserveConstEnums(compilerOptions))) {
              var firstNonAmbientClassOrFunc = getFirstNonAmbientClassOrFunctionDeclaration(symbol);
              if (firstNonAmbientClassOrFunc) {
                if (ts3.getSourceFileOfNode(node) !== ts3.getSourceFileOfNode(firstNonAmbientClassOrFunc)) {
                  error(node.name, ts3.Diagnostics.A_namespace_declaration_cannot_be_in_a_different_file_from_a_class_or_function_with_which_it_is_merged);
                } else if (node.pos < firstNonAmbientClassOrFunc.pos) {
                  error(node.name, ts3.Diagnostics.A_namespace_declaration_cannot_be_located_prior_to_a_class_or_function_with_which_it_is_merged);
                }
              }
              var mergedClass = ts3.getDeclarationOfKind(symbol, 253);
              if (mergedClass && inSameLexicalScope(node, mergedClass)) {
                getNodeLinks(node).flags |= 32768;
              }
            }
            if (isAmbientExternalModule) {
              if (ts3.isExternalModuleAugmentation(node)) {
                var checkBody = isGlobalAugmentation || getSymbolOfNode(node).flags & 33554432;
                if (checkBody && node.body) {
                  for (var _i = 0, _a2 = node.body.statements; _i < _a2.length; _i++) {
                    var statement = _a2[_i];
                    checkModuleAugmentationElement(statement, isGlobalAugmentation);
                  }
                }
              } else if (isGlobalSourceFile(node.parent)) {
                if (isGlobalAugmentation) {
                  error(node.name, ts3.Diagnostics.Augmentations_for_the_global_scope_can_only_be_directly_nested_in_external_modules_or_ambient_module_declarations);
                } else if (ts3.isExternalModuleNameRelative(ts3.getTextOfIdentifierOrLiteral(node.name))) {
                  error(node.name, ts3.Diagnostics.Ambient_module_declaration_cannot_specify_relative_module_name);
                }
              } else {
                if (isGlobalAugmentation) {
                  error(node.name, ts3.Diagnostics.Augmentations_for_the_global_scope_can_only_be_directly_nested_in_external_modules_or_ambient_module_declarations);
                } else {
                  error(node.name, ts3.Diagnostics.Ambient_modules_cannot_be_nested_in_other_modules_or_namespaces);
                }
              }
            }
          }
          if (node.body) {
            checkSourceElement(node.body);
            if (!ts3.isGlobalScopeAugmentation(node)) {
              registerForUnusedIdentifiersCheck(node);
            }
          }
        }
        function checkModuleAugmentationElement(node, isGlobalAugmentation) {
          var _a2;
          switch (node.kind) {
            case 233:
              for (var _i = 0, _b = node.declarationList.declarations; _i < _b.length; _i++) {
                var decl = _b[_i];
                checkModuleAugmentationElement(decl, isGlobalAugmentation);
              }
              break;
            case 267:
            case 268:
              grammarErrorOnFirstToken(node, ts3.Diagnostics.Exports_and_export_assignments_are_not_permitted_in_module_augmentations);
              break;
            case 261:
            case 262:
              grammarErrorOnFirstToken(node, ts3.Diagnostics.Imports_are_not_permitted_in_module_augmentations_Consider_moving_them_to_the_enclosing_external_module);
              break;
            case 199:
            case 250:
              var name = node.name;
              if (ts3.isBindingPattern(name)) {
                for (var _c = 0, _d = name.elements; _c < _d.length; _c++) {
                  var el = _d[_c];
                  checkModuleAugmentationElement(el, isGlobalAugmentation);
                }
                break;
              }
            case 253:
            case 256:
            case 252:
            case 254:
            case 257:
            case 255:
              if (isGlobalAugmentation) {
                return;
              }
              var symbol = getSymbolOfNode(node);
              if (symbol) {
                var reportError = !(symbol.flags & 33554432);
                if (!reportError) {
                  reportError = !!((_a2 = symbol.parent) === null || _a2 === void 0 ? void 0 : _a2.declarations) && ts3.isExternalModuleAugmentation(symbol.parent.declarations[0]);
                }
              }
              break;
          }
        }
        function getFirstNonModuleExportsIdentifier(node) {
          switch (node.kind) {
            case 78:
              return node;
            case 158:
              do {
                node = node.left;
              } while (node.kind !== 78);
              return node;
            case 202:
              do {
                if (ts3.isModuleExportsAccessExpression(node.expression) && !ts3.isPrivateIdentifier(node.name)) {
                  return node.name;
                }
                node = node.expression;
              } while (node.kind !== 78);
              return node;
          }
        }
        function checkExternalImportOrExportDeclaration(node) {
          var moduleName = ts3.getExternalModuleName(node);
          if (!moduleName || ts3.nodeIsMissing(moduleName)) {
            return false;
          }
          if (!ts3.isStringLiteral(moduleName)) {
            error(moduleName, ts3.Diagnostics.String_literal_expected);
            return false;
          }
          var inAmbientExternalModule = node.parent.kind === 258 && ts3.isAmbientModule(node.parent.parent);
          if (node.parent.kind !== 298 && !inAmbientExternalModule) {
            error(moduleName, node.kind === 268 ? ts3.Diagnostics.Export_declarations_are_not_permitted_in_a_namespace : ts3.Diagnostics.Import_declarations_in_a_namespace_cannot_reference_a_module);
            return false;
          }
          if (inAmbientExternalModule && ts3.isExternalModuleNameRelative(moduleName.text)) {
            if (!isTopLevelInExternalModuleAugmentation(node)) {
              error(node, ts3.Diagnostics.Import_or_export_declaration_in_an_ambient_module_declaration_cannot_reference_module_through_relative_module_name);
              return false;
            }
          }
          return true;
        }
        function checkAliasSymbol(node) {
          var _a2;
          var symbol = getSymbolOfNode(node);
          var target = resolveAlias(symbol);
          if (target !== unknownSymbol) {
            symbol = getMergedSymbol(symbol.exportSymbol || symbol);
            var excludedMeanings = (symbol.flags & (111551 | 1048576) ? 111551 : 0) | (symbol.flags & 788968 ? 788968 : 0) | (symbol.flags & 1920 ? 1920 : 0);
            if (target.flags & excludedMeanings) {
              var message = node.kind === 271 ? ts3.Diagnostics.Export_declaration_conflicts_with_exported_declaration_of_0 : ts3.Diagnostics.Import_declaration_conflicts_with_local_declaration_of_0;
              error(node, message, symbolToString(symbol));
            }
            if (compilerOptions.isolatedModules && node.kind === 271 && !node.parent.parent.isTypeOnly && !(target.flags & 111551) && !(node.flags & 8388608)) {
              error(node, ts3.Diagnostics.Re_exporting_a_type_when_the_isolatedModules_flag_is_provided_requires_using_export_type);
            }
            if (ts3.isImportSpecifier(node) && ((_a2 = target.declarations) === null || _a2 === void 0 ? void 0 : _a2.every(function(d) {
              return !!(ts3.getCombinedNodeFlags(d) & 134217728);
            }))) {
              addDeprecatedSuggestion(node.name, target.declarations, symbol.escapedName);
            }
          }
        }
        function checkImportBinding(node) {
          checkCollisionWithRequireExportsInGeneratedCode(node, node.name);
          checkCollisionWithGlobalPromiseInGeneratedCode(node, node.name);
          checkAliasSymbol(node);
          if (node.kind === 266 && ts3.idText(node.propertyName || node.name) === "default" && compilerOptions.esModuleInterop && moduleKind !== ts3.ModuleKind.System && moduleKind < ts3.ModuleKind.ES2015) {
            checkExternalEmitHelpers(node, 131072);
          }
        }
        function checkImportDeclaration(node) {
          if (checkGrammarModuleElementContext(node, ts3.Diagnostics.An_import_declaration_can_only_be_used_in_a_namespace_or_module)) {
            return;
          }
          if (!checkGrammarDecoratorsAndModifiers(node) && ts3.hasEffectiveModifiers(node)) {
            grammarErrorOnFirstToken(node, ts3.Diagnostics.An_import_declaration_cannot_have_modifiers);
          }
          if (checkExternalImportOrExportDeclaration(node)) {
            var importClause = node.importClause;
            if (importClause && !checkGrammarImportClause(importClause)) {
              if (importClause.name) {
                checkImportBinding(importClause);
              }
              if (importClause.namedBindings) {
                if (importClause.namedBindings.kind === 264) {
                  checkImportBinding(importClause.namedBindings);
                  if (moduleKind !== ts3.ModuleKind.System && moduleKind < ts3.ModuleKind.ES2015 && compilerOptions.esModuleInterop) {
                    checkExternalEmitHelpers(node, 65536);
                  }
                } else {
                  var moduleExisted = resolveExternalModuleName(node, node.moduleSpecifier);
                  if (moduleExisted) {
                    ts3.forEach(importClause.namedBindings.elements, checkImportBinding);
                  }
                }
              }
            }
          }
        }
        function checkImportEqualsDeclaration(node) {
          if (checkGrammarModuleElementContext(node, ts3.Diagnostics.An_import_declaration_can_only_be_used_in_a_namespace_or_module)) {
            return;
          }
          checkGrammarDecoratorsAndModifiers(node);
          if (ts3.isInternalModuleImportEqualsDeclaration(node) || checkExternalImportOrExportDeclaration(node)) {
            checkImportBinding(node);
            if (ts3.hasSyntacticModifier(node, 1)) {
              markExportAsReferenced(node);
            }
            if (node.moduleReference.kind !== 273) {
              var target = resolveAlias(getSymbolOfNode(node));
              if (target !== unknownSymbol) {
                if (target.flags & 111551) {
                  var moduleName = ts3.getFirstIdentifier(node.moduleReference);
                  if (!(resolveEntityName(moduleName, 111551 | 1920).flags & 1920)) {
                    error(moduleName, ts3.Diagnostics.Module_0_is_hidden_by_a_local_declaration_with_the_same_name, ts3.declarationNameToString(moduleName));
                  }
                }
                if (target.flags & 788968) {
                  checkTypeNameIsReserved(node.name, ts3.Diagnostics.Import_name_cannot_be_0);
                }
              }
              if (node.isTypeOnly) {
                grammarErrorOnNode(node, ts3.Diagnostics.An_import_alias_cannot_use_import_type);
              }
            } else {
              if (moduleKind >= ts3.ModuleKind.ES2015 && !node.isTypeOnly && !(node.flags & 8388608)) {
                grammarErrorOnNode(node, ts3.Diagnostics.Import_assignment_cannot_be_used_when_targeting_ECMAScript_modules_Consider_using_import_Asterisk_as_ns_from_mod_import_a_from_mod_import_d_from_mod_or_another_module_format_instead);
              }
            }
          }
        }
        function checkExportDeclaration(node) {
          if (checkGrammarModuleElementContext(node, ts3.Diagnostics.An_export_declaration_can_only_be_used_in_a_module)) {
            return;
          }
          if (!checkGrammarDecoratorsAndModifiers(node) && ts3.hasEffectiveModifiers(node)) {
            grammarErrorOnFirstToken(node, ts3.Diagnostics.An_export_declaration_cannot_have_modifiers);
          }
          if (node.moduleSpecifier && node.exportClause && ts3.isNamedExports(node.exportClause) && ts3.length(node.exportClause.elements) && languageVersion === 0) {
            checkExternalEmitHelpers(node, 2097152);
          }
          checkGrammarExportDeclaration(node);
          if (!node.moduleSpecifier || checkExternalImportOrExportDeclaration(node)) {
            if (node.exportClause && !ts3.isNamespaceExport(node.exportClause)) {
              ts3.forEach(node.exportClause.elements, checkExportSpecifier);
              var inAmbientExternalModule = node.parent.kind === 258 && ts3.isAmbientModule(node.parent.parent);
              var inAmbientNamespaceDeclaration = !inAmbientExternalModule && node.parent.kind === 258 && !node.moduleSpecifier && node.flags & 8388608;
              if (node.parent.kind !== 298 && !inAmbientExternalModule && !inAmbientNamespaceDeclaration) {
                error(node, ts3.Diagnostics.Export_declarations_are_not_permitted_in_a_namespace);
              }
            } else {
              var moduleSymbol = resolveExternalModuleName(node, node.moduleSpecifier);
              if (moduleSymbol && hasExportAssignmentSymbol(moduleSymbol)) {
                error(node.moduleSpecifier, ts3.Diagnostics.Module_0_uses_export_and_cannot_be_used_with_export_Asterisk, symbolToString(moduleSymbol));
              } else if (node.exportClause) {
                checkAliasSymbol(node.exportClause);
              }
              if (moduleKind !== ts3.ModuleKind.System && moduleKind < ts3.ModuleKind.ES2015) {
                if (node.exportClause) {
                  if (compilerOptions.esModuleInterop) {
                    checkExternalEmitHelpers(node, 65536);
                  }
                } else {
                  checkExternalEmitHelpers(node, 32768);
                }
              }
            }
          }
        }
        function checkGrammarExportDeclaration(node) {
          var _a2;
          var isTypeOnlyExportStar = node.isTypeOnly && ((_a2 = node.exportClause) === null || _a2 === void 0 ? void 0 : _a2.kind) !== 269;
          if (isTypeOnlyExportStar) {
            grammarErrorOnNode(node, ts3.Diagnostics.Only_named_exports_may_use_export_type);
          }
          return !isTypeOnlyExportStar;
        }
        function checkGrammarModuleElementContext(node, errorMessage) {
          var isInAppropriateContext = node.parent.kind === 298 || node.parent.kind === 258 || node.parent.kind === 257;
          if (!isInAppropriateContext) {
            grammarErrorOnFirstToken(node, errorMessage);
          }
          return !isInAppropriateContext;
        }
        function importClauseContainsReferencedImport(importClause) {
          return ts3.forEachImportClauseDeclaration(importClause, function(declaration) {
            return !!getSymbolOfNode(declaration).isReferenced;
          });
        }
        function importClauseContainsConstEnumUsedAsValue(importClause) {
          return ts3.forEachImportClauseDeclaration(importClause, function(declaration) {
            return !!getSymbolLinks(getSymbolOfNode(declaration)).constEnumReferenced;
          });
        }
        function canConvertImportDeclarationToTypeOnly(statement) {
          return ts3.isImportDeclaration(statement) && statement.importClause && !statement.importClause.isTypeOnly && importClauseContainsReferencedImport(statement.importClause) && !isReferencedAliasDeclaration(statement.importClause, true) && !importClauseContainsConstEnumUsedAsValue(statement.importClause);
        }
        function canConvertImportEqualsDeclarationToTypeOnly(statement) {
          return ts3.isImportEqualsDeclaration(statement) && ts3.isExternalModuleReference(statement.moduleReference) && !statement.isTypeOnly && getSymbolOfNode(statement).isReferenced && !isReferencedAliasDeclaration(statement, false) && !getSymbolLinks(getSymbolOfNode(statement)).constEnumReferenced;
        }
        function checkImportsForTypeOnlyConversion(sourceFile) {
          for (var _i = 0, _a2 = sourceFile.statements; _i < _a2.length; _i++) {
            var statement = _a2[_i];
            if (canConvertImportDeclarationToTypeOnly(statement) || canConvertImportEqualsDeclarationToTypeOnly(statement)) {
              error(statement, ts3.Diagnostics.This_import_is_never_used_as_a_value_and_must_use_import_type_because_importsNotUsedAsValues_is_set_to_error);
            }
          }
        }
        function checkExportSpecifier(node) {
          checkAliasSymbol(node);
          if (ts3.getEmitDeclarations(compilerOptions)) {
            collectLinkedAliases(node.propertyName || node.name, true);
          }
          if (!node.parent.parent.moduleSpecifier) {
            var exportedName = node.propertyName || node.name;
            var symbol = resolveName(exportedName, exportedName.escapedText, 111551 | 788968 | 1920 | 2097152, void 0, void 0, true);
            if (symbol && (symbol === undefinedSymbol || symbol === globalThisSymbol || symbol.declarations && isGlobalSourceFile(getDeclarationContainer(symbol.declarations[0])))) {
              error(exportedName, ts3.Diagnostics.Cannot_export_0_Only_local_declarations_can_be_exported_from_a_module, ts3.idText(exportedName));
            } else {
              markExportAsReferenced(node);
              var target = symbol && (symbol.flags & 2097152 ? resolveAlias(symbol) : symbol);
              if (!target || target === unknownSymbol || target.flags & 111551) {
                checkExpressionCached(node.propertyName || node.name);
              }
            }
          } else {
            if (compilerOptions.esModuleInterop && moduleKind !== ts3.ModuleKind.System && moduleKind < ts3.ModuleKind.ES2015 && ts3.idText(node.propertyName || node.name) === "default") {
              checkExternalEmitHelpers(node, 131072);
            }
          }
        }
        function checkExportAssignment(node) {
          var illegalContextMessage = node.isExportEquals ? ts3.Diagnostics.An_export_assignment_must_be_at_the_top_level_of_a_file_or_module_declaration : ts3.Diagnostics.A_default_export_must_be_at_the_top_level_of_a_file_or_module_declaration;
          if (checkGrammarModuleElementContext(node, illegalContextMessage)) {
            return;
          }
          var container = node.parent.kind === 298 ? node.parent : node.parent.parent;
          if (container.kind === 257 && !ts3.isAmbientModule(container)) {
            if (node.isExportEquals) {
              error(node, ts3.Diagnostics.An_export_assignment_cannot_be_used_in_a_namespace);
            } else {
              error(node, ts3.Diagnostics.A_default_export_can_only_be_used_in_an_ECMAScript_style_module);
            }
            return;
          }
          if (!checkGrammarDecoratorsAndModifiers(node) && ts3.hasEffectiveModifiers(node)) {
            grammarErrorOnFirstToken(node, ts3.Diagnostics.An_export_assignment_cannot_have_modifiers);
          }
          if (node.expression.kind === 78) {
            var id = node.expression;
            var sym = resolveEntityName(id, 67108863, true, true, node);
            if (sym) {
              markAliasReferenced(sym, id);
              var target = sym.flags & 2097152 ? resolveAlias(sym) : sym;
              if (target === unknownSymbol || target.flags & 111551) {
                checkExpressionCached(node.expression);
              }
            } else {
              checkExpressionCached(node.expression);
            }
            if (ts3.getEmitDeclarations(compilerOptions)) {
              collectLinkedAliases(node.expression, true);
            }
          } else {
            checkExpressionCached(node.expression);
          }
          checkExternalModuleExports(container);
          if (node.flags & 8388608 && !ts3.isEntityNameExpression(node.expression)) {
            grammarErrorOnNode(node.expression, ts3.Diagnostics.The_expression_of_an_export_assignment_must_be_an_identifier_or_qualified_name_in_an_ambient_context);
          }
          if (node.isExportEquals && !(node.flags & 8388608)) {
            if (moduleKind >= ts3.ModuleKind.ES2015) {
              grammarErrorOnNode(node, ts3.Diagnostics.Export_assignment_cannot_be_used_when_targeting_ECMAScript_modules_Consider_using_export_default_or_another_module_format_instead);
            } else if (moduleKind === ts3.ModuleKind.System) {
              grammarErrorOnNode(node, ts3.Diagnostics.Export_assignment_is_not_supported_when_module_flag_is_system);
            }
          }
        }
        function hasExportedMembers(moduleSymbol) {
          return ts3.forEachEntry(moduleSymbol.exports, function(_, id) {
            return id !== "export=";
          });
        }
        function checkExternalModuleExports(node) {
          var moduleSymbol = getSymbolOfNode(node);
          var links = getSymbolLinks(moduleSymbol);
          if (!links.exportsChecked) {
            var exportEqualsSymbol = moduleSymbol.exports.get("export=");
            if (exportEqualsSymbol && hasExportedMembers(moduleSymbol)) {
              var declaration = getDeclarationOfAliasSymbol(exportEqualsSymbol) || exportEqualsSymbol.valueDeclaration;
              if (declaration && !isTopLevelInExternalModuleAugmentation(declaration) && !ts3.isInJSFile(declaration)) {
                error(declaration, ts3.Diagnostics.An_export_assignment_cannot_be_used_in_a_module_with_other_exported_elements);
              }
            }
            var exports_2 = getExportsOfModule(moduleSymbol);
            if (exports_2) {
              exports_2.forEach(function(_a2, id) {
                var declarations = _a2.declarations, flags = _a2.flags;
                if (id === "__export") {
                  return;
                }
                if (flags & (1920 | 64 | 384)) {
                  return;
                }
                var exportedDeclarationsCount = ts3.countWhere(declarations, isNotOverloadAndNotAccessor);
                if (flags & 524288 && exportedDeclarationsCount <= 2) {
                  return;
                }
                if (exportedDeclarationsCount > 1) {
                  if (!isDuplicatedCommonJSExport(declarations)) {
                    for (var _i = 0, _b = declarations; _i < _b.length; _i++) {
                      var declaration2 = _b[_i];
                      if (isNotOverload(declaration2)) {
                        diagnostics.add(ts3.createDiagnosticForNode(declaration2, ts3.Diagnostics.Cannot_redeclare_exported_variable_0, ts3.unescapeLeadingUnderscores(id)));
                      }
                    }
                  }
                }
              });
            }
            links.exportsChecked = true;
          }
        }
        function isDuplicatedCommonJSExport(declarations) {
          return declarations && declarations.length > 1 && declarations.every(function(d) {
            return ts3.isInJSFile(d) && ts3.isAccessExpression(d) && (ts3.isExportsIdentifier(d.expression) || ts3.isModuleExportsAccessExpression(d.expression));
          });
        }
        function checkSourceElement(node) {
          if (node) {
            var saveCurrentNode = currentNode;
            currentNode = node;
            instantiationCount = 0;
            checkSourceElementWorker(node);
            currentNode = saveCurrentNode;
          }
        }
        function checkSourceElementWorker(node) {
          if (ts3.isInJSFile(node)) {
            ts3.forEach(node.jsDoc, function(_a2) {
              var tags = _a2.tags;
              return ts3.forEach(tags, checkSourceElement);
            });
          }
          var kind = node.kind;
          if (cancellationToken) {
            switch (kind) {
              case 257:
              case 253:
              case 254:
              case 252:
                cancellationToken.throwIfCancellationRequested();
            }
          }
          if (kind >= 233 && kind <= 249 && node.flowNode && !isReachableFlowNode(node.flowNode)) {
            errorOrSuggestion(compilerOptions.allowUnreachableCode === false, node, ts3.Diagnostics.Unreachable_code_detected);
          }
          switch (kind) {
            case 160:
              return checkTypeParameter(node);
            case 161:
              return checkParameter(node);
            case 164:
              return checkPropertyDeclaration(node);
            case 163:
              return checkPropertySignature(node);
            case 176:
            case 175:
            case 170:
            case 171:
            case 172:
              return checkSignatureDeclaration(node);
            case 166:
            case 165:
              return checkMethodDeclaration(node);
            case 167:
              return checkConstructorDeclaration(node);
            case 168:
            case 169:
              return checkAccessorDeclaration(node);
            case 174:
              return checkTypeReferenceNode(node);
            case 173:
              return checkTypePredicate(node);
            case 177:
              return checkTypeQuery(node);
            case 178:
              return checkTypeLiteral(node);
            case 179:
              return checkArrayType(node);
            case 180:
              return checkTupleType(node);
            case 183:
            case 184:
              return checkUnionOrIntersectionType(node);
            case 187:
            case 181:
            case 182:
              return checkSourceElement(node.type);
            case 188:
              return checkThisType(node);
            case 189:
              return checkTypeOperator(node);
            case 185:
              return checkConditionalType(node);
            case 186:
              return checkInferType(node);
            case 194:
              return checkTemplateLiteralType(node);
            case 196:
              return checkImportType(node);
            case 193:
              return checkNamedTupleMember(node);
            case 318:
              return checkJSDocAugmentsTag(node);
            case 319:
              return checkJSDocImplementsTag(node);
            case 335:
            case 328:
            case 329:
              return checkJSDocTypeAliasTag(node);
            case 334:
              return checkJSDocTemplateTag(node);
            case 333:
              return checkJSDocTypeTag(node);
            case 330:
              return checkJSDocParameterTag(node);
            case 337:
              return checkJSDocPropertyTag(node);
            case 309:
              checkJSDocFunctionType(node);
            case 307:
            case 306:
            case 304:
            case 305:
            case 314:
              checkJSDocTypeIsInJsFile(node);
              ts3.forEachChild(node, checkSourceElement);
              return;
            case 310:
              checkJSDocVariadicType(node);
              return;
            case 302:
              return checkSourceElement(node.type);
            case 190:
              return checkIndexedAccessType(node);
            case 191:
              return checkMappedType(node);
            case 252:
              return checkFunctionDeclaration(node);
            case 231:
            case 258:
              return checkBlock(node);
            case 233:
              return checkVariableStatement(node);
            case 234:
              return checkExpressionStatement(node);
            case 235:
              return checkIfStatement(node);
            case 236:
              return checkDoStatement(node);
            case 237:
              return checkWhileStatement(node);
            case 238:
              return checkForStatement(node);
            case 239:
              return checkForInStatement(node);
            case 240:
              return checkForOfStatement(node);
            case 241:
            case 242:
              return checkBreakOrContinueStatement(node);
            case 243:
              return checkReturnStatement(node);
            case 244:
              return checkWithStatement(node);
            case 245:
              return checkSwitchStatement(node);
            case 246:
              return checkLabeledStatement(node);
            case 247:
              return checkThrowStatement(node);
            case 248:
              return checkTryStatement(node);
            case 250:
              return checkVariableDeclaration(node);
            case 199:
              return checkBindingElement(node);
            case 253:
              return checkClassDeclaration(node);
            case 254:
              return checkInterfaceDeclaration(node);
            case 255:
              return checkTypeAliasDeclaration(node);
            case 256:
              return checkEnumDeclaration(node);
            case 257:
              return checkModuleDeclaration(node);
            case 262:
              return checkImportDeclaration(node);
            case 261:
              return checkImportEqualsDeclaration(node);
            case 268:
              return checkExportDeclaration(node);
            case 267:
              return checkExportAssignment(node);
            case 232:
            case 249:
              checkGrammarStatementInAmbientContext(node);
              return;
            case 272:
              return checkMissingDeclaration(node);
          }
        }
        function checkJSDocTypeIsInJsFile(node) {
          if (!ts3.isInJSFile(node)) {
            grammarErrorOnNode(node, ts3.Diagnostics.JSDoc_types_can_only_be_used_inside_documentation_comments);
          }
        }
        function checkJSDocVariadicType(node) {
          checkJSDocTypeIsInJsFile(node);
          checkSourceElement(node.type);
          var parent = node.parent;
          if (ts3.isParameter(parent) && ts3.isJSDocFunctionType(parent.parent)) {
            if (ts3.last(parent.parent.parameters) !== parent) {
              error(node, ts3.Diagnostics.A_rest_parameter_must_be_last_in_a_parameter_list);
            }
            return;
          }
          if (!ts3.isJSDocTypeExpression(parent)) {
            error(node, ts3.Diagnostics.JSDoc_may_only_appear_in_the_last_parameter_of_a_signature);
          }
          var paramTag = node.parent.parent;
          if (!ts3.isJSDocParameterTag(paramTag)) {
            error(node, ts3.Diagnostics.JSDoc_may_only_appear_in_the_last_parameter_of_a_signature);
            return;
          }
          var param = ts3.getParameterSymbolFromJSDoc(paramTag);
          if (!param) {
            return;
          }
          var host2 = ts3.getHostSignatureFromJSDoc(paramTag);
          if (!host2 || ts3.last(host2.parameters).symbol !== param) {
            error(node, ts3.Diagnostics.A_rest_parameter_must_be_last_in_a_parameter_list);
          }
        }
        function getTypeFromJSDocVariadicType(node) {
          var type3 = getTypeFromTypeNode(node.type);
          var parent = node.parent;
          var paramTag = node.parent.parent;
          if (ts3.isJSDocTypeExpression(node.parent) && ts3.isJSDocParameterTag(paramTag)) {
            var host_1 = ts3.getHostSignatureFromJSDoc(paramTag);
            var isCallbackTag = ts3.isJSDocCallbackTag(paramTag.parent.parent);
            if (host_1 || isCallbackTag) {
              var lastParamDeclaration = isCallbackTag ? ts3.lastOrUndefined(paramTag.parent.parent.typeExpression.parameters) : ts3.lastOrUndefined(host_1.parameters);
              var symbol = ts3.getParameterSymbolFromJSDoc(paramTag);
              if (!lastParamDeclaration || symbol && lastParamDeclaration.symbol === symbol && ts3.isRestParameter(lastParamDeclaration)) {
                return createArrayType(type3);
              }
            }
          }
          if (ts3.isParameter(parent) && ts3.isJSDocFunctionType(parent.parent)) {
            return createArrayType(type3);
          }
          return addOptionality(type3);
        }
        function checkNodeDeferred(node) {
          var enclosingFile = ts3.getSourceFileOfNode(node);
          var links = getNodeLinks(enclosingFile);
          if (!(links.flags & 1)) {
            links.deferredNodes = links.deferredNodes || new ts3.Map();
            var id = getNodeId(node);
            links.deferredNodes.set(id, node);
          }
        }
        function checkDeferredNodes(context) {
          var links = getNodeLinks(context);
          if (links.deferredNodes) {
            links.deferredNodes.forEach(checkDeferredNode);
          }
        }
        function checkDeferredNode(node) {
          ts3.tracing === null || ts3.tracing === void 0 ? void 0 : ts3.tracing.push("check", "checkDeferredNode", { kind: node.kind, pos: node.pos, end: node.end });
          var saveCurrentNode = currentNode;
          currentNode = node;
          instantiationCount = 0;
          switch (node.kind) {
            case 204:
            case 205:
            case 206:
            case 162:
            case 276:
              resolveUntypedCall(node);
              break;
            case 209:
            case 210:
            case 166:
            case 165:
              checkFunctionExpressionOrObjectLiteralMethodDeferred(node);
              break;
            case 168:
            case 169:
              checkAccessorDeclaration(node);
              break;
            case 222:
              checkClassExpressionDeferred(node);
              break;
            case 275:
              checkJsxSelfClosingElementDeferred(node);
              break;
            case 274:
              checkJsxElementDeferred(node);
              break;
          }
          currentNode = saveCurrentNode;
          ts3.tracing === null || ts3.tracing === void 0 ? void 0 : ts3.tracing.pop();
        }
        function checkSourceFile(node) {
          ts3.tracing === null || ts3.tracing === void 0 ? void 0 : ts3.tracing.push("check", "checkSourceFile", { path: node.path }, true);
          ts3.performance.mark("beforeCheck");
          checkSourceFileWorker(node);
          ts3.performance.mark("afterCheck");
          ts3.performance.measure("Check", "beforeCheck", "afterCheck");
          ts3.tracing === null || ts3.tracing === void 0 ? void 0 : ts3.tracing.pop();
        }
        function unusedIsError(kind, isAmbient) {
          if (isAmbient) {
            return false;
          }
          switch (kind) {
            case 0:
              return !!compilerOptions.noUnusedLocals;
            case 1:
              return !!compilerOptions.noUnusedParameters;
            default:
              return ts3.Debug.assertNever(kind);
          }
        }
        function getPotentiallyUnusedIdentifiers(sourceFile) {
          return allPotentiallyUnusedIdentifiers.get(sourceFile.path) || ts3.emptyArray;
        }
        function checkSourceFileWorker(node) {
          var links = getNodeLinks(node);
          if (!(links.flags & 1)) {
            if (ts3.skipTypeChecking(node, compilerOptions, host)) {
              return;
            }
            checkGrammarSourceFile(node);
            ts3.clear(potentialThisCollisions);
            ts3.clear(potentialNewTargetCollisions);
            ts3.clear(potentialWeakMapSetCollisions);
            ts3.forEach(node.statements, checkSourceElement);
            checkSourceElement(node.endOfFileToken);
            checkDeferredNodes(node);
            if (ts3.isExternalOrCommonJsModule(node)) {
              registerForUnusedIdentifiersCheck(node);
            }
            if (!node.isDeclarationFile && (compilerOptions.noUnusedLocals || compilerOptions.noUnusedParameters)) {
              checkUnusedIdentifiers(getPotentiallyUnusedIdentifiers(node), function(containingNode, kind, diag) {
                if (!ts3.containsParseError(containingNode) && unusedIsError(kind, !!(containingNode.flags & 8388608))) {
                  diagnostics.add(diag);
                }
              });
            }
            if (compilerOptions.importsNotUsedAsValues === 2 && !node.isDeclarationFile && ts3.isExternalModule(node)) {
              checkImportsForTypeOnlyConversion(node);
            }
            if (ts3.isExternalOrCommonJsModule(node)) {
              checkExternalModuleExports(node);
            }
            if (potentialThisCollisions.length) {
              ts3.forEach(potentialThisCollisions, checkIfThisIsCapturedInEnclosingScope);
              ts3.clear(potentialThisCollisions);
            }
            if (potentialNewTargetCollisions.length) {
              ts3.forEach(potentialNewTargetCollisions, checkIfNewTargetIsCapturedInEnclosingScope);
              ts3.clear(potentialNewTargetCollisions);
            }
            if (potentialWeakMapSetCollisions.length) {
              ts3.forEach(potentialWeakMapSetCollisions, checkWeakMapSetCollision);
              ts3.clear(potentialWeakMapSetCollisions);
            }
            links.flags |= 1;
          }
        }
        function getDiagnostics(sourceFile, ct) {
          try {
            cancellationToken = ct;
            return getDiagnosticsWorker(sourceFile);
          } finally {
            cancellationToken = void 0;
          }
        }
        function getDiagnosticsWorker(sourceFile) {
          throwIfNonDiagnosticsProducing();
          if (sourceFile) {
            var previousGlobalDiagnostics = diagnostics.getGlobalDiagnostics();
            var previousGlobalDiagnosticsSize = previousGlobalDiagnostics.length;
            checkSourceFile(sourceFile);
            var semanticDiagnostics = diagnostics.getDiagnostics(sourceFile.fileName);
            var currentGlobalDiagnostics = diagnostics.getGlobalDiagnostics();
            if (currentGlobalDiagnostics !== previousGlobalDiagnostics) {
              var deferredGlobalDiagnostics = ts3.relativeComplement(previousGlobalDiagnostics, currentGlobalDiagnostics, ts3.compareDiagnostics);
              return ts3.concatenate(deferredGlobalDiagnostics, semanticDiagnostics);
            } else if (previousGlobalDiagnosticsSize === 0 && currentGlobalDiagnostics.length > 0) {
              return ts3.concatenate(currentGlobalDiagnostics, semanticDiagnostics);
            }
            return semanticDiagnostics;
          }
          ts3.forEach(host.getSourceFiles(), checkSourceFile);
          return diagnostics.getDiagnostics();
        }
        function getGlobalDiagnostics() {
          throwIfNonDiagnosticsProducing();
          return diagnostics.getGlobalDiagnostics();
        }
        function throwIfNonDiagnosticsProducing() {
          if (!produceDiagnostics) {
            throw new Error("Trying to get diagnostics from a type checker that does not produce them.");
          }
        }
        function getSymbolsInScope(location, meaning) {
          if (location.flags & 16777216) {
            return [];
          }
          var symbols = ts3.createSymbolTable();
          var isStatic = false;
          populateSymbols();
          symbols.delete("this");
          return symbolsToArray(symbols);
          function populateSymbols() {
            while (location) {
              if (location.locals && !isGlobalSourceFile(location)) {
                copySymbols(location.locals, meaning);
              }
              switch (location.kind) {
                case 298:
                  if (!ts3.isExternalModule(location))
                    break;
                case 257:
                  copyLocallyVisibleExportSymbols(getSymbolOfNode(location).exports, meaning & 2623475);
                  break;
                case 256:
                  copySymbols(getSymbolOfNode(location).exports, meaning & 8);
                  break;
                case 222:
                  var className = location.name;
                  if (className) {
                    copySymbol(location.symbol, meaning);
                  }
                case 253:
                case 254:
                  if (!isStatic) {
                    copySymbols(getMembersOfSymbol(getSymbolOfNode(location)), meaning & 788968);
                  }
                  break;
                case 209:
                  var funcName = location.name;
                  if (funcName) {
                    copySymbol(location.symbol, meaning);
                  }
                  break;
              }
              if (ts3.introducesArgumentsExoticObject(location)) {
                copySymbol(argumentsSymbol, meaning);
              }
              isStatic = ts3.hasSyntacticModifier(location, 32);
              location = location.parent;
            }
            copySymbols(globals, meaning);
          }
          function copySymbol(symbol, meaning2) {
            if (ts3.getCombinedLocalAndExportSymbolFlags(symbol) & meaning2) {
              var id = symbol.escapedName;
              if (!symbols.has(id)) {
                symbols.set(id, symbol);
              }
            }
          }
          function copySymbols(source, meaning2) {
            if (meaning2) {
              source.forEach(function(symbol) {
                copySymbol(symbol, meaning2);
              });
            }
          }
          function copyLocallyVisibleExportSymbols(source, meaning2) {
            if (meaning2) {
              source.forEach(function(symbol) {
                if (!ts3.getDeclarationOfKind(symbol, 271) && !ts3.getDeclarationOfKind(symbol, 270)) {
                  copySymbol(symbol, meaning2);
                }
              });
            }
          }
        }
        function isTypeDeclarationName(name) {
          return name.kind === 78 && isTypeDeclaration(name.parent) && ts3.getNameOfDeclaration(name.parent) === name;
        }
        function isTypeDeclaration(node) {
          switch (node.kind) {
            case 160:
            case 253:
            case 254:
            case 255:
            case 256:
            case 335:
            case 328:
            case 329:
              return true;
            case 263:
              return node.isTypeOnly;
            case 266:
            case 271:
              return node.parent.parent.isTypeOnly;
            default:
              return false;
          }
        }
        function isTypeReferenceIdentifier(node) {
          while (node.parent.kind === 158) {
            node = node.parent;
          }
          return node.parent.kind === 174;
        }
        function isHeritageClauseElementIdentifier(node) {
          while (node.parent.kind === 202) {
            node = node.parent;
          }
          return node.parent.kind === 224;
        }
        function getJSDocEntryNameReference(node) {
          while (node.parent.kind === 158) {
            node = node.parent;
          }
          while (node.parent.kind === 202) {
            node = node.parent;
          }
          return ts3.isJSDocNameReference(node.parent) ? node.parent : void 0;
        }
        function forEachEnclosingClass(node, callback) {
          var result2;
          while (true) {
            node = ts3.getContainingClass(node);
            if (!node)
              break;
            if (result2 = callback(node))
              break;
          }
          return result2;
        }
        function isNodeUsedDuringClassInitialization(node) {
          return !!ts3.findAncestor(node, function(element) {
            if (ts3.isConstructorDeclaration(element) && ts3.nodeIsPresent(element.body) || ts3.isPropertyDeclaration(element)) {
              return true;
            } else if (ts3.isClassLike(element) || ts3.isFunctionLikeDeclaration(element)) {
              return "quit";
            }
            return false;
          });
        }
        function isNodeWithinClass(node, classDeclaration) {
          return !!forEachEnclosingClass(node, function(n2) {
            return n2 === classDeclaration;
          });
        }
        function getLeftSideOfImportEqualsOrExportAssignment(nodeOnRightSide) {
          while (nodeOnRightSide.parent.kind === 158) {
            nodeOnRightSide = nodeOnRightSide.parent;
          }
          if (nodeOnRightSide.parent.kind === 261) {
            return nodeOnRightSide.parent.moduleReference === nodeOnRightSide ? nodeOnRightSide.parent : void 0;
          }
          if (nodeOnRightSide.parent.kind === 267) {
            return nodeOnRightSide.parent.expression === nodeOnRightSide ? nodeOnRightSide.parent : void 0;
          }
          return void 0;
        }
        function isInRightSideOfImportOrExportAssignment(node) {
          return getLeftSideOfImportEqualsOrExportAssignment(node) !== void 0;
        }
        function getSpecialPropertyAssignmentSymbolFromEntityName(entityName) {
          var specialPropertyAssignmentKind = ts3.getAssignmentDeclarationKind(entityName.parent.parent);
          switch (specialPropertyAssignmentKind) {
            case 1:
            case 3:
              return getSymbolOfNode(entityName.parent);
            case 4:
            case 2:
            case 5:
              return getSymbolOfNode(entityName.parent.parent);
          }
        }
        function isImportTypeQualifierPart(node) {
          var parent = node.parent;
          while (ts3.isQualifiedName(parent)) {
            node = parent;
            parent = parent.parent;
          }
          if (parent && parent.kind === 196 && parent.qualifier === node) {
            return parent;
          }
          return void 0;
        }
        function getSymbolOfNameOrPropertyAccessExpression(name) {
          if (ts3.isDeclarationName(name)) {
            return getSymbolOfNode(name.parent);
          }
          if (ts3.isInJSFile(name) && name.parent.kind === 202 && name.parent === name.parent.parent.left) {
            if (!ts3.isPrivateIdentifier(name)) {
              var specialPropertyAssignmentSymbol = getSpecialPropertyAssignmentSymbolFromEntityName(name);
              if (specialPropertyAssignmentSymbol) {
                return specialPropertyAssignmentSymbol;
              }
            }
          }
          if (name.parent.kind === 267 && ts3.isEntityNameExpression(name)) {
            var success = resolveEntityName(name, 111551 | 788968 | 1920 | 2097152, true);
            if (success && success !== unknownSymbol) {
              return success;
            }
          } else if (!ts3.isPropertyAccessExpression(name) && !ts3.isPrivateIdentifier(name) && isInRightSideOfImportOrExportAssignment(name)) {
            var importEqualsDeclaration = ts3.getAncestor(name, 261);
            ts3.Debug.assert(importEqualsDeclaration !== void 0);
            return getSymbolOfPartOfRightHandSideOfImportEquals(name, true);
          }
          if (!ts3.isPropertyAccessExpression(name) && !ts3.isPrivateIdentifier(name)) {
            var possibleImportNode = isImportTypeQualifierPart(name);
            if (possibleImportNode) {
              getTypeFromTypeNode(possibleImportNode);
              var sym = getNodeLinks(name).resolvedSymbol;
              return sym === unknownSymbol ? void 0 : sym;
            }
          }
          while (ts3.isRightSideOfQualifiedNameOrPropertyAccess(name)) {
            name = name.parent;
          }
          if (isHeritageClauseElementIdentifier(name)) {
            var meaning = 0;
            if (name.parent.kind === 224) {
              meaning = 788968;
              if (ts3.isExpressionWithTypeArgumentsInClassExtendsClause(name.parent)) {
                meaning |= 111551;
              }
            } else {
              meaning = 1920;
            }
            meaning |= 2097152;
            var entityNameSymbol = ts3.isEntityNameExpression(name) ? resolveEntityName(name, meaning) : void 0;
            if (entityNameSymbol) {
              return entityNameSymbol;
            }
          }
          if (name.parent.kind === 330) {
            return ts3.getParameterSymbolFromJSDoc(name.parent);
          }
          if (name.parent.kind === 160 && name.parent.parent.kind === 334) {
            ts3.Debug.assert(!ts3.isInJSFile(name));
            var typeParameter = ts3.getTypeParameterFromJsDoc(name.parent);
            return typeParameter && typeParameter.symbol;
          }
          if (ts3.isExpressionNode(name)) {
            if (ts3.nodeIsMissing(name)) {
              return void 0;
            }
            if (name.kind === 78) {
              if (ts3.isJSXTagName(name) && isJsxIntrinsicIdentifier(name)) {
                var symbol = getIntrinsicTagSymbol(name.parent);
                return symbol === unknownSymbol ? void 0 : symbol;
              }
              return resolveEntityName(name, 111551, false, true);
            } else if (name.kind === 202 || name.kind === 158) {
              var links = getNodeLinks(name);
              if (links.resolvedSymbol) {
                return links.resolvedSymbol;
              }
              if (name.kind === 202) {
                checkPropertyAccessExpression(name, 0);
              } else {
                checkQualifiedName(name, 0);
              }
              return links.resolvedSymbol;
            }
          } else if (isTypeReferenceIdentifier(name)) {
            var meaning = name.parent.kind === 174 ? 788968 : 1920;
            return resolveEntityName(name, meaning, false, true);
          }
          var jsdocReference = getJSDocEntryNameReference(name);
          if (jsdocReference || ts3.isJSDocLink(name.parent)) {
            var meaning = 788968 | 1920 | 111551;
            var symbol = resolveEntityName(name, meaning, false, false, ts3.getHostSignatureFromJSDoc(name));
            if (symbol) {
              return symbol;
            } else if (ts3.isQualifiedName(name) && ts3.isIdentifier(name.left)) {
              var links = getNodeLinks(name);
              if (links.resolvedSymbol) {
                return links.resolvedSymbol;
              }
              checkQualifiedName(name, 0);
              if (links.resolvedSymbol) {
                return links.resolvedSymbol;
              }
              var s2 = resolveEntityName(name.left, meaning, false);
              if (s2) {
                var t2 = getDeclaredTypeOfSymbol(s2);
                return getPropertyOfType(t2, name.right.escapedText);
              }
            }
          }
          if (name.parent.kind === 173) {
            return resolveEntityName(name, 1);
          }
          return void 0;
        }
        function getSymbolAtLocation(node, ignoreErrors) {
          if (node.kind === 298) {
            return ts3.isExternalModule(node) ? getMergedSymbol(node.symbol) : void 0;
          }
          var parent = node.parent;
          var grandParent = parent.parent;
          if (node.flags & 16777216) {
            return void 0;
          }
          if (isDeclarationNameOrImportPropertyName(node)) {
            var parentSymbol = getSymbolOfNode(parent);
            return ts3.isImportOrExportSpecifier(node.parent) && node.parent.propertyName === node ? getImmediateAliasedSymbol(parentSymbol) : parentSymbol;
          } else if (ts3.isLiteralComputedPropertyDeclarationName(node)) {
            return getSymbolOfNode(parent.parent);
          }
          if (node.kind === 78) {
            if (isInRightSideOfImportOrExportAssignment(node)) {
              return getSymbolOfNameOrPropertyAccessExpression(node);
            } else if (parent.kind === 199 && grandParent.kind === 197 && node === parent.propertyName) {
              var typeOfPattern = getTypeOfNode(grandParent);
              var propertyDeclaration = getPropertyOfType(typeOfPattern, node.escapedText);
              if (propertyDeclaration) {
                return propertyDeclaration;
              }
            }
          }
          switch (node.kind) {
            case 78:
            case 79:
            case 202:
            case 158:
              return getSymbolOfNameOrPropertyAccessExpression(node);
            case 107:
              var container = ts3.getThisContainer(node, false);
              if (ts3.isFunctionLike(container)) {
                var sig = getSignatureFromDeclaration(container);
                if (sig.thisParameter) {
                  return sig.thisParameter;
                }
              }
              if (ts3.isInExpressionContext(node)) {
                return checkExpression(node).symbol;
              }
            case 188:
              return getTypeFromThisTypeNode(node).symbol;
            case 105:
              return checkExpression(node).symbol;
            case 132:
              var constructorDeclaration = node.parent;
              if (constructorDeclaration && constructorDeclaration.kind === 167) {
                return constructorDeclaration.parent.symbol;
              }
              return void 0;
            case 10:
            case 14:
              if (ts3.isExternalModuleImportEqualsDeclaration(node.parent.parent) && ts3.getExternalModuleImportEqualsDeclarationExpression(node.parent.parent) === node || (node.parent.kind === 262 || node.parent.kind === 268) && node.parent.moduleSpecifier === node || (ts3.isInJSFile(node) && ts3.isRequireCall(node.parent, false) || ts3.isImportCall(node.parent)) || ts3.isLiteralTypeNode(node.parent) && ts3.isLiteralImportTypeNode(node.parent.parent) && node.parent.parent.argument === node.parent) {
                return resolveExternalModuleName(node, node, ignoreErrors);
              }
              if (ts3.isCallExpression(parent) && ts3.isBindableObjectDefinePropertyCall(parent) && parent.arguments[1] === node) {
                return getSymbolOfNode(parent);
              }
            case 8:
              var objectType = ts3.isElementAccessExpression(parent) ? parent.argumentExpression === node ? getTypeOfExpression(parent.expression) : void 0 : ts3.isLiteralTypeNode(parent) && ts3.isIndexedAccessTypeNode(grandParent) ? getTypeFromTypeNode(grandParent.objectType) : void 0;
              return objectType && getPropertyOfType(objectType, ts3.escapeLeadingUnderscores(node.text));
            case 87:
            case 97:
            case 38:
            case 83:
              return getSymbolOfNode(node.parent);
            case 196:
              return ts3.isLiteralImportTypeNode(node) ? getSymbolAtLocation(node.argument.literal, ignoreErrors) : void 0;
            case 92:
              return ts3.isExportAssignment(node.parent) ? ts3.Debug.checkDefined(node.parent.symbol) : void 0;
            default:
              return void 0;
          }
        }
        function getShorthandAssignmentValueSymbol(location) {
          if (location && location.kind === 290) {
            return resolveEntityName(location.name, 111551 | 2097152);
          }
          return void 0;
        }
        function getExportSpecifierLocalTargetSymbol(node) {
          if (ts3.isExportSpecifier(node)) {
            return node.parent.parent.moduleSpecifier ? getExternalModuleMember(node.parent.parent, node) : resolveEntityName(node.propertyName || node.name, 111551 | 788968 | 1920 | 2097152);
          } else {
            return resolveEntityName(node, 111551 | 788968 | 1920 | 2097152);
          }
        }
        function getTypeOfNode(node) {
          if (ts3.isSourceFile(node) && !ts3.isExternalModule(node)) {
            return errorType;
          }
          if (node.flags & 16777216) {
            return errorType;
          }
          var classDecl = ts3.tryGetClassImplementingOrExtendingExpressionWithTypeArguments(node);
          var classType = classDecl && getDeclaredTypeOfClassOrInterface(getSymbolOfNode(classDecl.class));
          if (ts3.isPartOfTypeNode(node)) {
            var typeFromTypeNode = getTypeFromTypeNode(node);
            return classType ? getTypeWithThisArgument(typeFromTypeNode, classType.thisType) : typeFromTypeNode;
          }
          if (ts3.isExpressionNode(node)) {
            return getRegularTypeOfExpression(node);
          }
          if (classType && !classDecl.isImplements) {
            var baseType = ts3.firstOrUndefined(getBaseTypes(classType));
            return baseType ? getTypeWithThisArgument(baseType, classType.thisType) : errorType;
          }
          if (isTypeDeclaration(node)) {
            var symbol = getSymbolOfNode(node);
            return getDeclaredTypeOfSymbol(symbol);
          }
          if (isTypeDeclarationName(node)) {
            var symbol = getSymbolAtLocation(node);
            return symbol ? getDeclaredTypeOfSymbol(symbol) : errorType;
          }
          if (ts3.isDeclaration(node)) {
            var symbol = getSymbolOfNode(node);
            return getTypeOfSymbol(symbol);
          }
          if (isDeclarationNameOrImportPropertyName(node)) {
            var symbol = getSymbolAtLocation(node);
            if (symbol) {
              return getTypeOfSymbol(symbol);
            }
            return errorType;
          }
          if (ts3.isBindingPattern(node)) {
            return getTypeForVariableLikeDeclaration(node.parent, true) || errorType;
          }
          if (isInRightSideOfImportOrExportAssignment(node)) {
            var symbol = getSymbolAtLocation(node);
            if (symbol) {
              var declaredType = getDeclaredTypeOfSymbol(symbol);
              return declaredType !== errorType ? declaredType : getTypeOfSymbol(symbol);
            }
          }
          return errorType;
        }
        function getTypeOfAssignmentPattern(expr) {
          ts3.Debug.assert(expr.kind === 201 || expr.kind === 200);
          if (expr.parent.kind === 240) {
            var iteratedType = checkRightHandSideOfForOf(expr.parent);
            return checkDestructuringAssignment(expr, iteratedType || errorType);
          }
          if (expr.parent.kind === 217) {
            var iteratedType = getTypeOfExpression(expr.parent.right);
            return checkDestructuringAssignment(expr, iteratedType || errorType);
          }
          if (expr.parent.kind === 289) {
            var node_3 = ts3.cast(expr.parent.parent, ts3.isObjectLiteralExpression);
            var typeOfParentObjectLiteral = getTypeOfAssignmentPattern(node_3) || errorType;
            var propertyIndex = ts3.indexOfNode(node_3.properties, expr.parent);
            return checkObjectLiteralDestructuringPropertyAssignment(node_3, typeOfParentObjectLiteral, propertyIndex);
          }
          var node = ts3.cast(expr.parent, ts3.isArrayLiteralExpression);
          var typeOfArrayLiteral = getTypeOfAssignmentPattern(node) || errorType;
          var elementType = checkIteratedTypeOrElementType(65, typeOfArrayLiteral, undefinedType, expr.parent) || errorType;
          return checkArrayLiteralDestructuringElementAssignment(node, typeOfArrayLiteral, node.elements.indexOf(expr), elementType);
        }
        function getPropertySymbolOfDestructuringAssignment(location) {
          var typeOfObjectLiteral = getTypeOfAssignmentPattern(ts3.cast(location.parent.parent, ts3.isAssignmentPattern));
          return typeOfObjectLiteral && getPropertyOfType(typeOfObjectLiteral, location.escapedText);
        }
        function getRegularTypeOfExpression(expr) {
          if (ts3.isRightSideOfQualifiedNameOrPropertyAccess(expr)) {
            expr = expr.parent;
          }
          return getRegularTypeOfLiteralType(getTypeOfExpression(expr));
        }
        function getParentTypeOfClassElement(node) {
          var classSymbol = getSymbolOfNode(node.parent);
          return ts3.hasSyntacticModifier(node, 32) ? getTypeOfSymbol(classSymbol) : getDeclaredTypeOfSymbol(classSymbol);
        }
        function getClassElementPropertyKeyType(element) {
          var name = element.name;
          switch (name.kind) {
            case 78:
              return getLiteralType(ts3.idText(name));
            case 8:
            case 10:
              return getLiteralType(name.text);
            case 159:
              var nameType = checkComputedPropertyName(name);
              return isTypeAssignableToKind(nameType, 12288) ? nameType : stringType;
            default:
              return ts3.Debug.fail("Unsupported property name.");
          }
        }
        function getAugmentedPropertiesOfType(type3) {
          type3 = getApparentType(type3);
          var propsByName = ts3.createSymbolTable(getPropertiesOfType(type3));
          var functionType = getSignaturesOfType(type3, 0).length ? globalCallableFunctionType : getSignaturesOfType(type3, 1).length ? globalNewableFunctionType : void 0;
          if (functionType) {
            ts3.forEach(getPropertiesOfType(functionType), function(p) {
              if (!propsByName.has(p.escapedName)) {
                propsByName.set(p.escapedName, p);
              }
            });
          }
          return getNamedMembers(propsByName);
        }
        function typeHasCallOrConstructSignatures(type3) {
          return ts3.typeHasCallOrConstructSignatures(type3, checker);
        }
        function getRootSymbols(symbol) {
          var roots = getImmediateRootSymbols(symbol);
          return roots ? ts3.flatMap(roots, getRootSymbols) : [symbol];
        }
        function getImmediateRootSymbols(symbol) {
          if (ts3.getCheckFlags(symbol) & 6) {
            return ts3.mapDefined(getSymbolLinks(symbol).containingType.types, function(type3) {
              return getPropertyOfType(type3, symbol.escapedName);
            });
          } else if (symbol.flags & 33554432) {
            var _a2 = symbol, leftSpread = _a2.leftSpread, rightSpread = _a2.rightSpread, syntheticOrigin = _a2.syntheticOrigin;
            return leftSpread ? [leftSpread, rightSpread] : syntheticOrigin ? [syntheticOrigin] : ts3.singleElementArray(tryGetAliasTarget(symbol));
          }
          return void 0;
        }
        function tryGetAliasTarget(symbol) {
          var target;
          var next = symbol;
          while (next = getSymbolLinks(next).target) {
            target = next;
          }
          return target;
        }
        function isArgumentsLocalBinding(nodeIn) {
          if (ts3.isGeneratedIdentifier(nodeIn))
            return false;
          var node = ts3.getParseTreeNode(nodeIn, ts3.isIdentifier);
          if (!node)
            return false;
          var parent = node.parent;
          if (!parent)
            return false;
          var isPropertyName = (ts3.isPropertyAccessExpression(parent) || ts3.isPropertyAssignment(parent)) && parent.name === node;
          return !isPropertyName && getReferencedValueSymbol(node) === argumentsSymbol;
        }
        function moduleExportsSomeValue(moduleReferenceExpression) {
          var moduleSymbol = resolveExternalModuleName(moduleReferenceExpression.parent, moduleReferenceExpression);
          if (!moduleSymbol || ts3.isShorthandAmbientModuleSymbol(moduleSymbol)) {
            return true;
          }
          var hasExportAssignment = hasExportAssignmentSymbol(moduleSymbol);
          moduleSymbol = resolveExternalModuleSymbol(moduleSymbol);
          var symbolLinks2 = getSymbolLinks(moduleSymbol);
          if (symbolLinks2.exportsSomeValue === void 0) {
            symbolLinks2.exportsSomeValue = hasExportAssignment ? !!(moduleSymbol.flags & 111551) : ts3.forEachEntry(getExportsOfModule(moduleSymbol), isValue);
          }
          return symbolLinks2.exportsSomeValue;
          function isValue(s2) {
            s2 = resolveSymbol(s2);
            return s2 && !!(s2.flags & 111551);
          }
        }
        function isNameOfModuleOrEnumDeclaration(node) {
          return ts3.isModuleOrEnumDeclaration(node.parent) && node === node.parent.name;
        }
        function getReferencedExportContainer(nodeIn, prefixLocals) {
          var _a2;
          var node = ts3.getParseTreeNode(nodeIn, ts3.isIdentifier);
          if (node) {
            var symbol = getReferencedValueSymbol(node, isNameOfModuleOrEnumDeclaration(node));
            if (symbol) {
              if (symbol.flags & 1048576) {
                var exportSymbol = getMergedSymbol(symbol.exportSymbol);
                if (!prefixLocals && exportSymbol.flags & 944 && !(exportSymbol.flags & 3)) {
                  return void 0;
                }
                symbol = exportSymbol;
              }
              var parentSymbol_1 = getParentOfSymbol(symbol);
              if (parentSymbol_1) {
                if (parentSymbol_1.flags & 512 && ((_a2 = parentSymbol_1.valueDeclaration) === null || _a2 === void 0 ? void 0 : _a2.kind) === 298) {
                  var symbolFile = parentSymbol_1.valueDeclaration;
                  var referenceFile = ts3.getSourceFileOfNode(node);
                  var symbolIsUmdExport = symbolFile !== referenceFile;
                  return symbolIsUmdExport ? void 0 : symbolFile;
                }
                return ts3.findAncestor(node.parent, function(n2) {
                  return ts3.isModuleOrEnumDeclaration(n2) && getSymbolOfNode(n2) === parentSymbol_1;
                });
              }
            }
          }
        }
        function getReferencedImportDeclaration(nodeIn) {
          if (nodeIn.generatedImportReference) {
            return nodeIn.generatedImportReference;
          }
          var node = ts3.getParseTreeNode(nodeIn, ts3.isIdentifier);
          if (node) {
            var symbol = getReferencedValueSymbol(node);
            if (isNonLocalAlias(symbol, 111551) && !getTypeOnlyAliasDeclaration(symbol)) {
              return getDeclarationOfAliasSymbol(symbol);
            }
          }
          return void 0;
        }
        function isSymbolOfDestructuredElementOfCatchBinding(symbol) {
          return symbol.valueDeclaration && ts3.isBindingElement(symbol.valueDeclaration) && ts3.walkUpBindingElementsAndPatterns(symbol.valueDeclaration).parent.kind === 288;
        }
        function isSymbolOfDeclarationWithCollidingName(symbol) {
          if (symbol.flags & 418 && symbol.valueDeclaration && !ts3.isSourceFile(symbol.valueDeclaration)) {
            var links = getSymbolLinks(symbol);
            if (links.isDeclarationWithCollidingName === void 0) {
              var container = ts3.getEnclosingBlockScopeContainer(symbol.valueDeclaration);
              if (ts3.isStatementWithLocals(container) || isSymbolOfDestructuredElementOfCatchBinding(symbol)) {
                var nodeLinks_1 = getNodeLinks(symbol.valueDeclaration);
                if (resolveName(container.parent, symbol.escapedName, 111551, void 0, void 0, false)) {
                  links.isDeclarationWithCollidingName = true;
                } else if (nodeLinks_1.flags & 262144) {
                  var isDeclaredInLoop = nodeLinks_1.flags & 524288;
                  var inLoopInitializer = ts3.isIterationStatement(container, false);
                  var inLoopBodyBlock = container.kind === 231 && ts3.isIterationStatement(container.parent, false);
                  links.isDeclarationWithCollidingName = !ts3.isBlockScopedContainerTopLevel(container) && (!isDeclaredInLoop || !inLoopInitializer && !inLoopBodyBlock);
                } else {
                  links.isDeclarationWithCollidingName = false;
                }
              }
            }
            return links.isDeclarationWithCollidingName;
          }
          return false;
        }
        function getReferencedDeclarationWithCollidingName(nodeIn) {
          if (!ts3.isGeneratedIdentifier(nodeIn)) {
            var node = ts3.getParseTreeNode(nodeIn, ts3.isIdentifier);
            if (node) {
              var symbol = getReferencedValueSymbol(node);
              if (symbol && isSymbolOfDeclarationWithCollidingName(symbol)) {
                return symbol.valueDeclaration;
              }
            }
          }
          return void 0;
        }
        function isDeclarationWithCollidingName(nodeIn) {
          var node = ts3.getParseTreeNode(nodeIn, ts3.isDeclaration);
          if (node) {
            var symbol = getSymbolOfNode(node);
            if (symbol) {
              return isSymbolOfDeclarationWithCollidingName(symbol);
            }
          }
          return false;
        }
        function isValueAliasDeclaration(node) {
          switch (node.kind) {
            case 261:
              return isAliasResolvedToValue(getSymbolOfNode(node) || unknownSymbol);
            case 263:
            case 264:
            case 266:
            case 271:
              var symbol = getSymbolOfNode(node) || unknownSymbol;
              return isAliasResolvedToValue(symbol) && !getTypeOnlyAliasDeclaration(symbol);
            case 268:
              var exportClause = node.exportClause;
              return !!exportClause && (ts3.isNamespaceExport(exportClause) || ts3.some(exportClause.elements, isValueAliasDeclaration));
            case 267:
              return node.expression && node.expression.kind === 78 ? isAliasResolvedToValue(getSymbolOfNode(node) || unknownSymbol) : true;
          }
          return false;
        }
        function isTopLevelValueImportEqualsWithEntityName(nodeIn) {
          var node = ts3.getParseTreeNode(nodeIn, ts3.isImportEqualsDeclaration);
          if (node === void 0 || node.parent.kind !== 298 || !ts3.isInternalModuleImportEqualsDeclaration(node)) {
            return false;
          }
          var isValue = isAliasResolvedToValue(getSymbolOfNode(node));
          return isValue && node.moduleReference && !ts3.nodeIsMissing(node.moduleReference);
        }
        function isAliasResolvedToValue(symbol) {
          var target = resolveAlias(symbol);
          if (target === unknownSymbol) {
            return true;
          }
          return !!(target.flags & 111551) && (ts3.shouldPreserveConstEnums(compilerOptions) || !isConstEnumOrConstEnumOnlyModule(target));
        }
        function isConstEnumOrConstEnumOnlyModule(s2) {
          return isConstEnumSymbol(s2) || !!s2.constEnumOnlyModule;
        }
        function isReferencedAliasDeclaration(node, checkChildren) {
          if (isAliasSymbolDeclaration(node)) {
            var symbol = getSymbolOfNode(node);
            var links = symbol && getSymbolLinks(symbol);
            if (links === null || links === void 0 ? void 0 : links.referenced) {
              return true;
            }
            var target = getSymbolLinks(symbol).target;
            if (target && ts3.getEffectiveModifierFlags(node) & 1 && target.flags & 111551 && (ts3.shouldPreserveConstEnums(compilerOptions) || !isConstEnumOrConstEnumOnlyModule(target))) {
              return true;
            }
          }
          if (checkChildren) {
            return !!ts3.forEachChild(node, function(node2) {
              return isReferencedAliasDeclaration(node2, checkChildren);
            });
          }
          return false;
        }
        function isImplementationOfOverload(node) {
          if (ts3.nodeIsPresent(node.body)) {
            if (ts3.isGetAccessor(node) || ts3.isSetAccessor(node))
              return false;
            var symbol = getSymbolOfNode(node);
            var signaturesOfSymbol = getSignaturesOfSymbol(symbol);
            return signaturesOfSymbol.length > 1 || signaturesOfSymbol.length === 1 && signaturesOfSymbol[0].declaration !== node;
          }
          return false;
        }
        function isRequiredInitializedParameter(parameter) {
          return !!strictNullChecks && !isOptionalParameter(parameter) && !ts3.isJSDocParameterTag(parameter) && !!parameter.initializer && !ts3.hasSyntacticModifier(parameter, 16476);
        }
        function isOptionalUninitializedParameterProperty(parameter) {
          return strictNullChecks && isOptionalParameter(parameter) && !parameter.initializer && ts3.hasSyntacticModifier(parameter, 16476);
        }
        function isOptionalUninitializedParameter(parameter) {
          return !!strictNullChecks && isOptionalParameter(parameter) && !parameter.initializer;
        }
        function isExpandoFunctionDeclaration(node) {
          var declaration = ts3.getParseTreeNode(node, ts3.isFunctionDeclaration);
          if (!declaration) {
            return false;
          }
          var symbol = getSymbolOfNode(declaration);
          if (!symbol || !(symbol.flags & 16)) {
            return false;
          }
          return !!ts3.forEachEntry(getExportsOfSymbol(symbol), function(p) {
            return p.flags & 111551 && p.valueDeclaration && ts3.isPropertyAccessExpression(p.valueDeclaration);
          });
        }
        function getPropertiesOfContainerFunction(node) {
          var declaration = ts3.getParseTreeNode(node, ts3.isFunctionDeclaration);
          if (!declaration) {
            return ts3.emptyArray;
          }
          var symbol = getSymbolOfNode(declaration);
          return symbol && getPropertiesOfType(getTypeOfSymbol(symbol)) || ts3.emptyArray;
        }
        function getNodeCheckFlags(node) {
          return getNodeLinks(node).flags || 0;
        }
        function getEnumMemberValue(node) {
          computeEnumMemberValues(node.parent);
          return getNodeLinks(node).enumMemberValue;
        }
        function canHaveConstantValue(node) {
          switch (node.kind) {
            case 292:
            case 202:
            case 203:
              return true;
          }
          return false;
        }
        function getConstantValue(node) {
          if (node.kind === 292) {
            return getEnumMemberValue(node);
          }
          var symbol = getNodeLinks(node).resolvedSymbol;
          if (symbol && symbol.flags & 8) {
            var member = symbol.valueDeclaration;
            if (ts3.isEnumConst(member.parent)) {
              return getEnumMemberValue(member);
            }
          }
          return void 0;
        }
        function isFunctionType(type3) {
          return !!(type3.flags & 524288) && getSignaturesOfType(type3, 0).length > 0;
        }
        function getTypeReferenceSerializationKind(typeNameIn, location) {
          var _a2;
          var typeName = ts3.getParseTreeNode(typeNameIn, ts3.isEntityName);
          if (!typeName)
            return ts3.TypeReferenceSerializationKind.Unknown;
          if (location) {
            location = ts3.getParseTreeNode(location);
            if (!location)
              return ts3.TypeReferenceSerializationKind.Unknown;
          }
          var valueSymbol = resolveEntityName(typeName, 111551, true, true, location);
          var isTypeOnly = ((_a2 = valueSymbol === null || valueSymbol === void 0 ? void 0 : valueSymbol.declarations) === null || _a2 === void 0 ? void 0 : _a2.every(ts3.isTypeOnlyImportOrExportDeclaration)) || false;
          var resolvedSymbol = valueSymbol && valueSymbol.flags & 2097152 ? resolveAlias(valueSymbol) : valueSymbol;
          var typeSymbol = resolveEntityName(typeName, 788968, true, false, location);
          if (resolvedSymbol && resolvedSymbol === typeSymbol) {
            var globalPromiseSymbol = getGlobalPromiseConstructorSymbol(false);
            if (globalPromiseSymbol && resolvedSymbol === globalPromiseSymbol) {
              return ts3.TypeReferenceSerializationKind.Promise;
            }
            var constructorType = getTypeOfSymbol(resolvedSymbol);
            if (constructorType && isConstructorType(constructorType)) {
              return isTypeOnly ? ts3.TypeReferenceSerializationKind.TypeWithCallSignature : ts3.TypeReferenceSerializationKind.TypeWithConstructSignatureAndValue;
            }
          }
          if (!typeSymbol) {
            return isTypeOnly ? ts3.TypeReferenceSerializationKind.ObjectType : ts3.TypeReferenceSerializationKind.Unknown;
          }
          var type3 = getDeclaredTypeOfSymbol(typeSymbol);
          if (type3 === errorType) {
            return isTypeOnly ? ts3.TypeReferenceSerializationKind.ObjectType : ts3.TypeReferenceSerializationKind.Unknown;
          } else if (type3.flags & 3) {
            return ts3.TypeReferenceSerializationKind.ObjectType;
          } else if (isTypeAssignableToKind(type3, 16384 | 98304 | 131072)) {
            return ts3.TypeReferenceSerializationKind.VoidNullableOrNeverType;
          } else if (isTypeAssignableToKind(type3, 528)) {
            return ts3.TypeReferenceSerializationKind.BooleanType;
          } else if (isTypeAssignableToKind(type3, 296)) {
            return ts3.TypeReferenceSerializationKind.NumberLikeType;
          } else if (isTypeAssignableToKind(type3, 2112)) {
            return ts3.TypeReferenceSerializationKind.BigIntLikeType;
          } else if (isTypeAssignableToKind(type3, 402653316)) {
            return ts3.TypeReferenceSerializationKind.StringLikeType;
          } else if (isTupleType(type3)) {
            return ts3.TypeReferenceSerializationKind.ArrayLikeType;
          } else if (isTypeAssignableToKind(type3, 12288)) {
            return ts3.TypeReferenceSerializationKind.ESSymbolType;
          } else if (isFunctionType(type3)) {
            return ts3.TypeReferenceSerializationKind.TypeWithCallSignature;
          } else if (isArrayType(type3)) {
            return ts3.TypeReferenceSerializationKind.ArrayLikeType;
          } else {
            return ts3.TypeReferenceSerializationKind.ObjectType;
          }
        }
        function createTypeOfDeclaration(declarationIn, enclosingDeclaration, flags, tracker, addUndefined) {
          var declaration = ts3.getParseTreeNode(declarationIn, ts3.isVariableLikeOrAccessor);
          if (!declaration) {
            return ts3.factory.createToken(128);
          }
          var symbol = getSymbolOfNode(declaration);
          var type3 = symbol && !(symbol.flags & (2048 | 131072)) ? getWidenedLiteralType(getTypeOfSymbol(symbol)) : errorType;
          if (type3.flags & 8192 && type3.symbol === symbol) {
            flags |= 1048576;
          }
          if (addUndefined) {
            type3 = getOptionalType(type3);
          }
          return nodeBuilder.typeToTypeNode(type3, enclosingDeclaration, flags | 1024, tracker);
        }
        function createReturnTypeOfSignatureDeclaration(signatureDeclarationIn, enclosingDeclaration, flags, tracker) {
          var signatureDeclaration = ts3.getParseTreeNode(signatureDeclarationIn, ts3.isFunctionLike);
          if (!signatureDeclaration) {
            return ts3.factory.createToken(128);
          }
          var signature = getSignatureFromDeclaration(signatureDeclaration);
          return nodeBuilder.typeToTypeNode(getReturnTypeOfSignature(signature), enclosingDeclaration, flags | 1024, tracker);
        }
        function createTypeOfExpression(exprIn, enclosingDeclaration, flags, tracker) {
          var expr = ts3.getParseTreeNode(exprIn, ts3.isExpression);
          if (!expr) {
            return ts3.factory.createToken(128);
          }
          var type3 = getWidenedType(getRegularTypeOfExpression(expr));
          return nodeBuilder.typeToTypeNode(type3, enclosingDeclaration, flags | 1024, tracker);
        }
        function hasGlobalName(name) {
          return globals.has(ts3.escapeLeadingUnderscores(name));
        }
        function getReferencedValueSymbol(reference, startInDeclarationContainer) {
          var resolvedSymbol = getNodeLinks(reference).resolvedSymbol;
          if (resolvedSymbol) {
            return resolvedSymbol;
          }
          var location = reference;
          if (startInDeclarationContainer) {
            var parent = reference.parent;
            if (ts3.isDeclaration(parent) && reference === parent.name) {
              location = getDeclarationContainer(parent);
            }
          }
          return resolveName(location, reference.escapedText, 111551 | 1048576 | 2097152, void 0, void 0, true);
        }
        function getReferencedValueDeclaration(referenceIn) {
          if (!ts3.isGeneratedIdentifier(referenceIn)) {
            var reference = ts3.getParseTreeNode(referenceIn, ts3.isIdentifier);
            if (reference) {
              var symbol = getReferencedValueSymbol(reference);
              if (symbol) {
                return getExportSymbolOfValueSymbolIfExported(symbol).valueDeclaration;
              }
            }
          }
          return void 0;
        }
        function isLiteralConstDeclaration(node) {
          if (ts3.isDeclarationReadonly(node) || ts3.isVariableDeclaration(node) && ts3.isVarConst(node)) {
            return isFreshLiteralType(getTypeOfSymbol(getSymbolOfNode(node)));
          }
          return false;
        }
        function literalTypeToNode(type3, enclosing, tracker) {
          var enumResult = type3.flags & 1024 ? nodeBuilder.symbolToExpression(type3.symbol, 111551, enclosing, void 0, tracker) : type3 === trueType ? ts3.factory.createTrue() : type3 === falseType && ts3.factory.createFalse();
          if (enumResult)
            return enumResult;
          var literalValue = type3.value;
          return typeof literalValue === "object" ? ts3.factory.createBigIntLiteral(literalValue) : typeof literalValue === "number" ? ts3.factory.createNumericLiteral(literalValue) : ts3.factory.createStringLiteral(literalValue);
        }
        function createLiteralConstValue(node, tracker) {
          var type3 = getTypeOfSymbol(getSymbolOfNode(node));
          return literalTypeToNode(type3, node, tracker);
        }
        function getJsxFactoryEntity(location) {
          return location ? (getJsxNamespace(location), ts3.getSourceFileOfNode(location).localJsxFactory || _jsxFactoryEntity) : _jsxFactoryEntity;
        }
        function getJsxFragmentFactoryEntity(location) {
          if (location) {
            var file = ts3.getSourceFileOfNode(location);
            if (file) {
              if (file.localJsxFragmentFactory) {
                return file.localJsxFragmentFactory;
              }
              var jsxFragPragmas = file.pragmas.get("jsxfrag");
              var jsxFragPragma = ts3.isArray(jsxFragPragmas) ? jsxFragPragmas[0] : jsxFragPragmas;
              if (jsxFragPragma) {
                file.localJsxFragmentFactory = ts3.parseIsolatedEntityName(jsxFragPragma.arguments.factory, languageVersion);
                return file.localJsxFragmentFactory;
              }
            }
          }
          if (compilerOptions.jsxFragmentFactory) {
            return ts3.parseIsolatedEntityName(compilerOptions.jsxFragmentFactory, languageVersion);
          }
        }
        function createResolver() {
          var resolvedTypeReferenceDirectives = host.getResolvedTypeReferenceDirectives();
          var fileToDirective;
          if (resolvedTypeReferenceDirectives) {
            fileToDirective = new ts3.Map();
            resolvedTypeReferenceDirectives.forEach(function(resolvedDirective, key2) {
              if (!resolvedDirective || !resolvedDirective.resolvedFileName) {
                return;
              }
              var file = host.getSourceFile(resolvedDirective.resolvedFileName);
              if (file) {
                addReferencedFilesToTypeDirective(file, key2);
              }
            });
          }
          return {
            getReferencedExportContainer,
            getReferencedImportDeclaration,
            getReferencedDeclarationWithCollidingName,
            isDeclarationWithCollidingName,
            isValueAliasDeclaration: function(nodeIn) {
              var node = ts3.getParseTreeNode(nodeIn);
              return node ? isValueAliasDeclaration(node) : true;
            },
            hasGlobalName,
            isReferencedAliasDeclaration: function(nodeIn, checkChildren) {
              var node = ts3.getParseTreeNode(nodeIn);
              return node ? isReferencedAliasDeclaration(node, checkChildren) : true;
            },
            getNodeCheckFlags: function(nodeIn) {
              var node = ts3.getParseTreeNode(nodeIn);
              return node ? getNodeCheckFlags(node) : 0;
            },
            isTopLevelValueImportEqualsWithEntityName,
            isDeclarationVisible,
            isImplementationOfOverload,
            isRequiredInitializedParameter,
            isOptionalUninitializedParameterProperty,
            isExpandoFunctionDeclaration,
            getPropertiesOfContainerFunction,
            createTypeOfDeclaration,
            createReturnTypeOfSignatureDeclaration,
            createTypeOfExpression,
            createLiteralConstValue,
            isSymbolAccessible,
            isEntityNameVisible,
            getConstantValue: function(nodeIn) {
              var node = ts3.getParseTreeNode(nodeIn, canHaveConstantValue);
              return node ? getConstantValue(node) : void 0;
            },
            collectLinkedAliases,
            getReferencedValueDeclaration,
            getTypeReferenceSerializationKind,
            isOptionalParameter,
            moduleExportsSomeValue,
            isArgumentsLocalBinding,
            getExternalModuleFileFromDeclaration: function(nodeIn) {
              var node = ts3.getParseTreeNode(nodeIn, ts3.hasPossibleExternalModuleReference);
              return node && getExternalModuleFileFromDeclaration(node);
            },
            getTypeReferenceDirectivesForEntityName,
            getTypeReferenceDirectivesForSymbol,
            isLiteralConstDeclaration,
            isLateBound: function(nodeIn) {
              var node = ts3.getParseTreeNode(nodeIn, ts3.isDeclaration);
              var symbol = node && getSymbolOfNode(node);
              return !!(symbol && ts3.getCheckFlags(symbol) & 4096);
            },
            getJsxFactoryEntity,
            getJsxFragmentFactoryEntity,
            getAllAccessorDeclarations: function(accessor) {
              accessor = ts3.getParseTreeNode(accessor, ts3.isGetOrSetAccessorDeclaration);
              var otherKind = accessor.kind === 169 ? 168 : 169;
              var otherAccessor = ts3.getDeclarationOfKind(getSymbolOfNode(accessor), otherKind);
              var firstAccessor = otherAccessor && otherAccessor.pos < accessor.pos ? otherAccessor : accessor;
              var secondAccessor = otherAccessor && otherAccessor.pos < accessor.pos ? accessor : otherAccessor;
              var setAccessor = accessor.kind === 169 ? accessor : otherAccessor;
              var getAccessor = accessor.kind === 168 ? accessor : otherAccessor;
              return {
                firstAccessor,
                secondAccessor,
                setAccessor,
                getAccessor
              };
            },
            getSymbolOfExternalModuleSpecifier: function(moduleName) {
              return resolveExternalModuleNameWorker(moduleName, moduleName, void 0);
            },
            isBindingCapturedByNode: function(node, decl) {
              var parseNode = ts3.getParseTreeNode(node);
              var parseDecl = ts3.getParseTreeNode(decl);
              return !!parseNode && !!parseDecl && (ts3.isVariableDeclaration(parseDecl) || ts3.isBindingElement(parseDecl)) && isBindingCapturedByNode(parseNode, parseDecl);
            },
            getDeclarationStatementsForSourceFile: function(node, flags, tracker, bundled) {
              var n2 = ts3.getParseTreeNode(node);
              ts3.Debug.assert(n2 && n2.kind === 298, "Non-sourcefile node passed into getDeclarationsForSourceFile");
              var sym = getSymbolOfNode(node);
              if (!sym) {
                return !node.locals ? [] : nodeBuilder.symbolTableToDeclarationStatements(node.locals, node, flags, tracker, bundled);
              }
              return !sym.exports ? [] : nodeBuilder.symbolTableToDeclarationStatements(sym.exports, node, flags, tracker, bundled);
            },
            isImportRequiredByAugmentation
          };
          function isImportRequiredByAugmentation(node) {
            var file = ts3.getSourceFileOfNode(node);
            if (!file.symbol)
              return false;
            var importTarget = getExternalModuleFileFromDeclaration(node);
            if (!importTarget)
              return false;
            if (importTarget === file)
              return false;
            var exports3 = getExportsOfModule(file.symbol);
            for (var _i = 0, _a2 = ts3.arrayFrom(exports3.values()); _i < _a2.length; _i++) {
              var s2 = _a2[_i];
              if (s2.mergeId) {
                var merged = getMergedSymbol(s2);
                if (merged.declarations) {
                  for (var _b = 0, _c = merged.declarations; _b < _c.length; _b++) {
                    var d = _c[_b];
                    var declFile = ts3.getSourceFileOfNode(d);
                    if (declFile === importTarget) {
                      return true;
                    }
                  }
                }
              }
            }
            return false;
          }
          function isInHeritageClause(node) {
            return node.parent && node.parent.kind === 224 && node.parent.parent && node.parent.parent.kind === 287;
          }
          function getTypeReferenceDirectivesForEntityName(node) {
            if (!fileToDirective) {
              return void 0;
            }
            var meaning = 788968 | 1920;
            if (node.kind === 78 && isInTypeQuery(node) || node.kind === 202 && !isInHeritageClause(node)) {
              meaning = 111551 | 1048576;
            }
            var symbol = resolveEntityName(node, meaning, true);
            return symbol && symbol !== unknownSymbol ? getTypeReferenceDirectivesForSymbol(symbol, meaning) : void 0;
          }
          function getTypeReferenceDirectivesForSymbol(symbol, meaning) {
            if (!fileToDirective || !isSymbolFromTypeDeclarationFile(symbol)) {
              return void 0;
            }
            var typeReferenceDirectives;
            for (var _i = 0, _a2 = symbol.declarations; _i < _a2.length; _i++) {
              var decl = _a2[_i];
              if (decl.symbol && decl.symbol.flags & meaning) {
                var file = ts3.getSourceFileOfNode(decl);
                var typeReferenceDirective = fileToDirective.get(file.path);
                if (typeReferenceDirective) {
                  (typeReferenceDirectives || (typeReferenceDirectives = [])).push(typeReferenceDirective);
                } else {
                  return void 0;
                }
              }
            }
            return typeReferenceDirectives;
          }
          function isSymbolFromTypeDeclarationFile(symbol) {
            if (!symbol.declarations) {
              return false;
            }
            var current = symbol;
            while (true) {
              var parent = getParentOfSymbol(current);
              if (parent) {
                current = parent;
              } else {
                break;
              }
            }
            if (current.valueDeclaration && current.valueDeclaration.kind === 298 && current.flags & 512) {
              return false;
            }
            for (var _i = 0, _a2 = symbol.declarations; _i < _a2.length; _i++) {
              var decl = _a2[_i];
              var file = ts3.getSourceFileOfNode(decl);
              if (fileToDirective.has(file.path)) {
                return true;
              }
            }
            return false;
          }
          function addReferencedFilesToTypeDirective(file, key2) {
            if (fileToDirective.has(file.path))
              return;
            fileToDirective.set(file.path, key2);
            for (var _i = 0, _a2 = file.referencedFiles; _i < _a2.length; _i++) {
              var fileName = _a2[_i].fileName;
              var resolvedFile = ts3.resolveTripleslashReference(fileName, file.fileName);
              var referencedFile = host.getSourceFile(resolvedFile);
              if (referencedFile) {
                addReferencedFilesToTypeDirective(referencedFile, key2);
              }
            }
          }
        }
        function getExternalModuleFileFromDeclaration(declaration) {
          var specifier = declaration.kind === 257 ? ts3.tryCast(declaration.name, ts3.isStringLiteral) : ts3.getExternalModuleName(declaration);
          var moduleSymbol = resolveExternalModuleNameWorker(specifier, specifier, void 0);
          if (!moduleSymbol) {
            return void 0;
          }
          return ts3.getDeclarationOfKind(moduleSymbol, 298);
        }
        function initializeTypeChecker() {
          for (var _i = 0, _a2 = host.getSourceFiles(); _i < _a2.length; _i++) {
            var file = _a2[_i];
            ts3.bindSourceFile(file, compilerOptions);
          }
          amalgamatedDuplicates = new ts3.Map();
          var augmentations;
          for (var _b = 0, _c = host.getSourceFiles(); _b < _c.length; _b++) {
            var file = _c[_b];
            if (file.redirectInfo) {
              continue;
            }
            if (!ts3.isExternalOrCommonJsModule(file)) {
              var fileGlobalThisSymbol = file.locals.get("globalThis");
              if (fileGlobalThisSymbol === null || fileGlobalThisSymbol === void 0 ? void 0 : fileGlobalThisSymbol.declarations) {
                for (var _d = 0, _e = fileGlobalThisSymbol.declarations; _d < _e.length; _d++) {
                  var declaration = _e[_d];
                  diagnostics.add(ts3.createDiagnosticForNode(declaration, ts3.Diagnostics.Declaration_name_conflicts_with_built_in_global_identifier_0, "globalThis"));
                }
              }
              mergeSymbolTable(globals, file.locals);
            }
            if (file.jsGlobalAugmentations) {
              mergeSymbolTable(globals, file.jsGlobalAugmentations);
            }
            if (file.patternAmbientModules && file.patternAmbientModules.length) {
              patternAmbientModules = ts3.concatenate(patternAmbientModules, file.patternAmbientModules);
            }
            if (file.moduleAugmentations.length) {
              (augmentations || (augmentations = [])).push(file.moduleAugmentations);
            }
            if (file.symbol && file.symbol.globalExports) {
              var source = file.symbol.globalExports;
              source.forEach(function(sourceSymbol, id) {
                if (!globals.has(id)) {
                  globals.set(id, sourceSymbol);
                }
              });
            }
          }
          if (augmentations) {
            for (var _f = 0, augmentations_1 = augmentations; _f < augmentations_1.length; _f++) {
              var list = augmentations_1[_f];
              for (var _g = 0, list_1 = list; _g < list_1.length; _g++) {
                var augmentation = list_1[_g];
                if (!ts3.isGlobalScopeAugmentation(augmentation.parent))
                  continue;
                mergeModuleAugmentation(augmentation);
              }
            }
          }
          addToSymbolTable(globals, builtinGlobals, ts3.Diagnostics.Declaration_name_conflicts_with_built_in_global_identifier_0);
          getSymbolLinks(undefinedSymbol).type = undefinedWideningType;
          getSymbolLinks(argumentsSymbol).type = getGlobalType("IArguments", 0, true);
          getSymbolLinks(unknownSymbol).type = errorType;
          getSymbolLinks(globalThisSymbol).type = createObjectType(16, globalThisSymbol);
          globalArrayType = getGlobalType("Array", 1, true);
          globalObjectType = getGlobalType("Object", 0, true);
          globalFunctionType = getGlobalType("Function", 0, true);
          globalCallableFunctionType = strictBindCallApply && getGlobalType("CallableFunction", 0, true) || globalFunctionType;
          globalNewableFunctionType = strictBindCallApply && getGlobalType("NewableFunction", 0, true) || globalFunctionType;
          globalStringType = getGlobalType("String", 0, true);
          globalNumberType = getGlobalType("Number", 0, true);
          globalBooleanType = getGlobalType("Boolean", 0, true);
          globalRegExpType = getGlobalType("RegExp", 0, true);
          anyArrayType = createArrayType(anyType);
          autoArrayType = createArrayType(autoType);
          if (autoArrayType === emptyObjectType) {
            autoArrayType = createAnonymousType(void 0, emptySymbols, ts3.emptyArray, ts3.emptyArray, void 0, void 0);
          }
          globalReadonlyArrayType = getGlobalTypeOrUndefined("ReadonlyArray", 1) || globalArrayType;
          anyReadonlyArrayType = globalReadonlyArrayType ? createTypeFromGenericGlobalType(globalReadonlyArrayType, [anyType]) : anyArrayType;
          globalThisType = getGlobalTypeOrUndefined("ThisType", 1);
          if (augmentations) {
            for (var _h = 0, augmentations_2 = augmentations; _h < augmentations_2.length; _h++) {
              var list = augmentations_2[_h];
              for (var _j = 0, list_2 = list; _j < list_2.length; _j++) {
                var augmentation = list_2[_j];
                if (ts3.isGlobalScopeAugmentation(augmentation.parent))
                  continue;
                mergeModuleAugmentation(augmentation);
              }
            }
          }
          amalgamatedDuplicates.forEach(function(_a3) {
            var firstFile = _a3.firstFile, secondFile = _a3.secondFile, conflictingSymbols = _a3.conflictingSymbols;
            if (conflictingSymbols.size < 8) {
              conflictingSymbols.forEach(function(_a4, symbolName) {
                var isBlockScoped = _a4.isBlockScoped, firstFileLocations = _a4.firstFileLocations, secondFileLocations = _a4.secondFileLocations;
                var message = isBlockScoped ? ts3.Diagnostics.Cannot_redeclare_block_scoped_variable_0 : ts3.Diagnostics.Duplicate_identifier_0;
                for (var _i2 = 0, firstFileLocations_1 = firstFileLocations; _i2 < firstFileLocations_1.length; _i2++) {
                  var node = firstFileLocations_1[_i2];
                  addDuplicateDeclarationError(node, message, symbolName, secondFileLocations);
                }
                for (var _b2 = 0, secondFileLocations_1 = secondFileLocations; _b2 < secondFileLocations_1.length; _b2++) {
                  var node = secondFileLocations_1[_b2];
                  addDuplicateDeclarationError(node, message, symbolName, firstFileLocations);
                }
              });
            } else {
              var list2 = ts3.arrayFrom(conflictingSymbols.keys()).join(", ");
              diagnostics.add(ts3.addRelatedInfo(ts3.createDiagnosticForNode(firstFile, ts3.Diagnostics.Definitions_of_the_following_identifiers_conflict_with_those_in_another_file_Colon_0, list2), ts3.createDiagnosticForNode(secondFile, ts3.Diagnostics.Conflicts_are_in_this_file)));
              diagnostics.add(ts3.addRelatedInfo(ts3.createDiagnosticForNode(secondFile, ts3.Diagnostics.Definitions_of_the_following_identifiers_conflict_with_those_in_another_file_Colon_0, list2), ts3.createDiagnosticForNode(firstFile, ts3.Diagnostics.Conflicts_are_in_this_file)));
            }
          });
          amalgamatedDuplicates = void 0;
        }
        function checkExternalEmitHelpers(location, helpers) {
          if ((requestedExternalEmitHelpers & helpers) !== helpers && compilerOptions.importHelpers) {
            var sourceFile = ts3.getSourceFileOfNode(location);
            if (ts3.isEffectiveExternalModule(sourceFile, compilerOptions) && !(location.flags & 8388608)) {
              var helpersModule = resolveHelpersModule(sourceFile, location);
              if (helpersModule !== unknownSymbol) {
                var uncheckedHelpers = helpers & ~requestedExternalEmitHelpers;
                for (var helper = 1; helper <= 2097152; helper <<= 1) {
                  if (uncheckedHelpers & helper) {
                    var name = getHelperName(helper);
                    var symbol = getSymbol(helpersModule.exports, ts3.escapeLeadingUnderscores(name), 111551);
                    if (!symbol) {
                      error(location, ts3.Diagnostics.This_syntax_requires_an_imported_helper_named_1_which_does_not_exist_in_0_Consider_upgrading_your_version_of_0, ts3.externalHelpersModuleNameText, name);
                    } else if (helper & 524288) {
                      if (!ts3.some(getSignaturesOfSymbol(symbol), function(signature) {
                        return getParameterCount(signature) > 3;
                      })) {
                        error(location, ts3.Diagnostics.This_syntax_requires_an_imported_helper_named_1_with_2_parameters_which_is_not_compatible_with_the_one_in_0_Consider_upgrading_your_version_of_0, ts3.externalHelpersModuleNameText, name, 4);
                      }
                    } else if (helper & 1048576) {
                      if (!ts3.some(getSignaturesOfSymbol(symbol), function(signature) {
                        return getParameterCount(signature) > 4;
                      })) {
                        error(location, ts3.Diagnostics.This_syntax_requires_an_imported_helper_named_1_with_2_parameters_which_is_not_compatible_with_the_one_in_0_Consider_upgrading_your_version_of_0, ts3.externalHelpersModuleNameText, name, 5);
                      }
                    }
                  }
                }
              }
              requestedExternalEmitHelpers |= helpers;
            }
          }
        }
        function getHelperName(helper) {
          switch (helper) {
            case 1:
              return "__extends";
            case 2:
              return "__assign";
            case 4:
              return "__rest";
            case 8:
              return "__decorate";
            case 16:
              return "__metadata";
            case 32:
              return "__param";
            case 64:
              return "__awaiter";
            case 128:
              return "__generator";
            case 256:
              return "__values";
            case 512:
              return "__read";
            case 1024:
              return "__spreadArray";
            case 2048:
              return "__await";
            case 4096:
              return "__asyncGenerator";
            case 8192:
              return "__asyncDelegator";
            case 16384:
              return "__asyncValues";
            case 32768:
              return "__exportStar";
            case 65536:
              return "__importStar";
            case 131072:
              return "__importDefault";
            case 262144:
              return "__makeTemplateObject";
            case 524288:
              return "__classPrivateFieldGet";
            case 1048576:
              return "__classPrivateFieldSet";
            case 2097152:
              return "__createBinding";
            default:
              return ts3.Debug.fail("Unrecognized helper");
          }
        }
        function resolveHelpersModule(node, errorNode) {
          if (!externalHelpersModule) {
            externalHelpersModule = resolveExternalModule(node, ts3.externalHelpersModuleNameText, ts3.Diagnostics.This_syntax_requires_an_imported_helper_but_module_0_cannot_be_found, errorNode) || unknownSymbol;
          }
          return externalHelpersModule;
        }
        function checkGrammarDecoratorsAndModifiers(node) {
          return checkGrammarDecorators(node) || checkGrammarModifiers(node);
        }
        function checkGrammarDecorators(node) {
          if (!node.decorators) {
            return false;
          }
          if (!ts3.nodeCanBeDecorated(node, node.parent, node.parent.parent)) {
            if (node.kind === 166 && !ts3.nodeIsPresent(node.body)) {
              return grammarErrorOnFirstToken(node, ts3.Diagnostics.A_decorator_can_only_decorate_a_method_implementation_not_an_overload);
            } else {
              return grammarErrorOnFirstToken(node, ts3.Diagnostics.Decorators_are_not_valid_here);
            }
          } else if (node.kind === 168 || node.kind === 169) {
            var accessors = ts3.getAllAccessorDeclarations(node.parent.members, node);
            if (accessors.firstAccessor.decorators && node === accessors.secondAccessor) {
              return grammarErrorOnFirstToken(node, ts3.Diagnostics.Decorators_cannot_be_applied_to_multiple_get_Slashset_accessors_of_the_same_name);
            }
          }
          return false;
        }
        function checkGrammarModifiers(node) {
          var quickResult = reportObviousModifierErrors(node);
          if (quickResult !== void 0) {
            return quickResult;
          }
          var lastStatic, lastDeclare, lastAsync, lastReadonly, lastOverride;
          var flags = 0;
          for (var _i = 0, _a2 = node.modifiers; _i < _a2.length; _i++) {
            var modifier = _a2[_i];
            if (modifier.kind !== 142) {
              if (node.kind === 163 || node.kind === 165) {
                return grammarErrorOnNode(modifier, ts3.Diagnostics._0_modifier_cannot_appear_on_a_type_member, ts3.tokenToString(modifier.kind));
              }
              if (node.kind === 172 && (modifier.kind !== 123 || !ts3.isClassLike(node.parent))) {
                return grammarErrorOnNode(modifier, ts3.Diagnostics._0_modifier_cannot_appear_on_an_index_signature, ts3.tokenToString(modifier.kind));
              }
            }
            switch (modifier.kind) {
              case 84:
                if (node.kind !== 256) {
                  return grammarErrorOnNode(node, ts3.Diagnostics.A_class_member_cannot_have_the_0_keyword, ts3.tokenToString(84));
                }
                break;
              case 156:
                if (flags & 16384) {
                  return grammarErrorOnNode(modifier, ts3.Diagnostics._0_modifier_already_seen, "override");
                } else if (flags & 2) {
                  return grammarErrorOnNode(modifier, ts3.Diagnostics._0_modifier_cannot_be_used_with_1_modifier, "override", "declare");
                } else if (flags & 64) {
                  return grammarErrorOnNode(modifier, ts3.Diagnostics._0_modifier_must_precede_1_modifier, "override", "readonly");
                } else if (flags & 256) {
                  return grammarErrorOnNode(modifier, ts3.Diagnostics._0_modifier_must_precede_1_modifier, "override", "async");
                }
                flags |= 16384;
                lastOverride = modifier;
                break;
              case 122:
              case 121:
              case 120:
                var text = visibilityToString(ts3.modifierToFlag(modifier.kind));
                if (flags & 28) {
                  return grammarErrorOnNode(modifier, ts3.Diagnostics.Accessibility_modifier_already_seen);
                } else if (flags & 16384) {
                  return grammarErrorOnNode(modifier, ts3.Diagnostics._0_modifier_must_precede_1_modifier, text, "override");
                } else if (flags & 32) {
                  return grammarErrorOnNode(modifier, ts3.Diagnostics._0_modifier_must_precede_1_modifier, text, "static");
                } else if (flags & 64) {
                  return grammarErrorOnNode(modifier, ts3.Diagnostics._0_modifier_must_precede_1_modifier, text, "readonly");
                } else if (flags & 256) {
                  return grammarErrorOnNode(modifier, ts3.Diagnostics._0_modifier_must_precede_1_modifier, text, "async");
                } else if (node.parent.kind === 258 || node.parent.kind === 298) {
                  return grammarErrorOnNode(modifier, ts3.Diagnostics._0_modifier_cannot_appear_on_a_module_or_namespace_element, text);
                } else if (flags & 128) {
                  if (modifier.kind === 120) {
                    return grammarErrorOnNode(modifier, ts3.Diagnostics._0_modifier_cannot_be_used_with_1_modifier, text, "abstract");
                  } else {
                    return grammarErrorOnNode(modifier, ts3.Diagnostics._0_modifier_must_precede_1_modifier, text, "abstract");
                  }
                } else if (ts3.isPrivateIdentifierClassElementDeclaration(node)) {
                  return grammarErrorOnNode(modifier, ts3.Diagnostics.An_accessibility_modifier_cannot_be_used_with_a_private_identifier);
                }
                flags |= ts3.modifierToFlag(modifier.kind);
                break;
              case 123:
                if (flags & 32) {
                  return grammarErrorOnNode(modifier, ts3.Diagnostics._0_modifier_already_seen, "static");
                } else if (flags & 64) {
                  return grammarErrorOnNode(modifier, ts3.Diagnostics._0_modifier_must_precede_1_modifier, "static", "readonly");
                } else if (flags & 256) {
                  return grammarErrorOnNode(modifier, ts3.Diagnostics._0_modifier_must_precede_1_modifier, "static", "async");
                } else if (node.parent.kind === 258 || node.parent.kind === 298) {
                  return grammarErrorOnNode(modifier, ts3.Diagnostics._0_modifier_cannot_appear_on_a_module_or_namespace_element, "static");
                } else if (node.kind === 161) {
                  return grammarErrorOnNode(modifier, ts3.Diagnostics._0_modifier_cannot_appear_on_a_parameter, "static");
                } else if (flags & 128) {
                  return grammarErrorOnNode(modifier, ts3.Diagnostics._0_modifier_cannot_be_used_with_1_modifier, "static", "abstract");
                } else if (flags & 16384) {
                  return grammarErrorOnNode(modifier, ts3.Diagnostics._0_modifier_must_precede_1_modifier, "static", "override");
                }
                flags |= 32;
                lastStatic = modifier;
                break;
              case 142:
                if (flags & 64) {
                  return grammarErrorOnNode(modifier, ts3.Diagnostics._0_modifier_already_seen, "readonly");
                } else if (node.kind !== 164 && node.kind !== 163 && node.kind !== 172 && node.kind !== 161) {
                  return grammarErrorOnNode(modifier, ts3.Diagnostics.readonly_modifier_can_only_appear_on_a_property_declaration_or_index_signature);
                }
                flags |= 64;
                lastReadonly = modifier;
                break;
              case 92:
                if (flags & 1) {
                  return grammarErrorOnNode(modifier, ts3.Diagnostics._0_modifier_already_seen, "export");
                } else if (flags & 2) {
                  return grammarErrorOnNode(modifier, ts3.Diagnostics._0_modifier_must_precede_1_modifier, "export", "declare");
                } else if (flags & 128) {
                  return grammarErrorOnNode(modifier, ts3.Diagnostics._0_modifier_must_precede_1_modifier, "export", "abstract");
                } else if (flags & 256) {
                  return grammarErrorOnNode(modifier, ts3.Diagnostics._0_modifier_must_precede_1_modifier, "export", "async");
                } else if (ts3.isClassLike(node.parent)) {
                  return grammarErrorOnNode(modifier, ts3.Diagnostics._0_modifier_cannot_appear_on_class_elements_of_this_kind, "export");
                } else if (node.kind === 161) {
                  return grammarErrorOnNode(modifier, ts3.Diagnostics._0_modifier_cannot_appear_on_a_parameter, "export");
                }
                flags |= 1;
                break;
              case 87:
                var container = node.parent.kind === 298 ? node.parent : node.parent.parent;
                if (container.kind === 257 && !ts3.isAmbientModule(container)) {
                  return grammarErrorOnNode(modifier, ts3.Diagnostics.A_default_export_can_only_be_used_in_an_ECMAScript_style_module);
                }
                flags |= 512;
                break;
              case 133:
                if (flags & 2) {
                  return grammarErrorOnNode(modifier, ts3.Diagnostics._0_modifier_already_seen, "declare");
                } else if (flags & 256) {
                  return grammarErrorOnNode(modifier, ts3.Diagnostics._0_modifier_cannot_be_used_in_an_ambient_context, "async");
                } else if (flags & 16384) {
                  return grammarErrorOnNode(modifier, ts3.Diagnostics._0_modifier_cannot_be_used_in_an_ambient_context, "override");
                } else if (ts3.isClassLike(node.parent) && !ts3.isPropertyDeclaration(node)) {
                  return grammarErrorOnNode(modifier, ts3.Diagnostics._0_modifier_cannot_appear_on_class_elements_of_this_kind, "declare");
                } else if (node.kind === 161) {
                  return grammarErrorOnNode(modifier, ts3.Diagnostics._0_modifier_cannot_appear_on_a_parameter, "declare");
                } else if (node.parent.flags & 8388608 && node.parent.kind === 258) {
                  return grammarErrorOnNode(modifier, ts3.Diagnostics.A_declare_modifier_cannot_be_used_in_an_already_ambient_context);
                } else if (ts3.isPrivateIdentifierClassElementDeclaration(node)) {
                  return grammarErrorOnNode(modifier, ts3.Diagnostics._0_modifier_cannot_be_used_with_a_private_identifier, "declare");
                }
                flags |= 2;
                lastDeclare = modifier;
                break;
              case 125:
                if (flags & 128) {
                  return grammarErrorOnNode(modifier, ts3.Diagnostics._0_modifier_already_seen, "abstract");
                }
                if (node.kind !== 253 && node.kind !== 176) {
                  if (node.kind !== 166 && node.kind !== 164 && node.kind !== 168 && node.kind !== 169) {
                    return grammarErrorOnNode(modifier, ts3.Diagnostics.abstract_modifier_can_only_appear_on_a_class_method_or_property_declaration);
                  }
                  if (!(node.parent.kind === 253 && ts3.hasSyntacticModifier(node.parent, 128))) {
                    return grammarErrorOnNode(modifier, ts3.Diagnostics.Abstract_methods_can_only_appear_within_an_abstract_class);
                  }
                  if (flags & 32) {
                    return grammarErrorOnNode(modifier, ts3.Diagnostics._0_modifier_cannot_be_used_with_1_modifier, "static", "abstract");
                  }
                  if (flags & 8) {
                    return grammarErrorOnNode(modifier, ts3.Diagnostics._0_modifier_cannot_be_used_with_1_modifier, "private", "abstract");
                  }
                  if (flags & 256 && lastAsync) {
                    return grammarErrorOnNode(lastAsync, ts3.Diagnostics._0_modifier_cannot_be_used_with_1_modifier, "async", "abstract");
                  }
                  if (flags & 16384) {
                    return grammarErrorOnNode(modifier, ts3.Diagnostics._0_modifier_must_precede_1_modifier, "abstract", "override");
                  }
                }
                if (ts3.isNamedDeclaration(node) && node.name.kind === 79) {
                  return grammarErrorOnNode(modifier, ts3.Diagnostics._0_modifier_cannot_be_used_with_a_private_identifier, "abstract");
                }
                flags |= 128;
                break;
              case 129:
                if (flags & 256) {
                  return grammarErrorOnNode(modifier, ts3.Diagnostics._0_modifier_already_seen, "async");
                } else if (flags & 2 || node.parent.flags & 8388608) {
                  return grammarErrorOnNode(modifier, ts3.Diagnostics._0_modifier_cannot_be_used_in_an_ambient_context, "async");
                } else if (node.kind === 161) {
                  return grammarErrorOnNode(modifier, ts3.Diagnostics._0_modifier_cannot_appear_on_a_parameter, "async");
                }
                if (flags & 128) {
                  return grammarErrorOnNode(modifier, ts3.Diagnostics._0_modifier_cannot_be_used_with_1_modifier, "async", "abstract");
                }
                flags |= 256;
                lastAsync = modifier;
                break;
            }
          }
          if (node.kind === 167) {
            if (flags & 32) {
              return grammarErrorOnNode(lastStatic, ts3.Diagnostics._0_modifier_cannot_appear_on_a_constructor_declaration, "static");
            }
            if (flags & 128) {
              return grammarErrorOnNode(lastStatic, ts3.Diagnostics._0_modifier_cannot_appear_on_a_constructor_declaration, "abstract");
            }
            if (flags & 16384) {
              return grammarErrorOnNode(lastOverride, ts3.Diagnostics._0_modifier_cannot_appear_on_a_constructor_declaration, "override");
            } else if (flags & 256) {
              return grammarErrorOnNode(lastAsync, ts3.Diagnostics._0_modifier_cannot_appear_on_a_constructor_declaration, "async");
            } else if (flags & 64) {
              return grammarErrorOnNode(lastReadonly, ts3.Diagnostics._0_modifier_cannot_appear_on_a_constructor_declaration, "readonly");
            }
            return false;
          } else if ((node.kind === 262 || node.kind === 261) && flags & 2) {
            return grammarErrorOnNode(lastDeclare, ts3.Diagnostics.A_0_modifier_cannot_be_used_with_an_import_declaration, "declare");
          } else if (node.kind === 161 && flags & 16476 && ts3.isBindingPattern(node.name)) {
            return grammarErrorOnNode(node, ts3.Diagnostics.A_parameter_property_may_not_be_declared_using_a_binding_pattern);
          } else if (node.kind === 161 && flags & 16476 && node.dotDotDotToken) {
            return grammarErrorOnNode(node, ts3.Diagnostics.A_parameter_property_cannot_be_declared_using_a_rest_parameter);
          }
          if (flags & 256) {
            return checkGrammarAsyncModifier(node, lastAsync);
          }
          return false;
        }
        function reportObviousModifierErrors(node) {
          return !node.modifiers ? false : shouldReportBadModifier(node) ? grammarErrorOnFirstToken(node, ts3.Diagnostics.Modifiers_cannot_appear_here) : void 0;
        }
        function shouldReportBadModifier(node) {
          switch (node.kind) {
            case 168:
            case 169:
            case 167:
            case 164:
            case 163:
            case 166:
            case 165:
            case 172:
            case 257:
            case 262:
            case 261:
            case 268:
            case 267:
            case 209:
            case 210:
            case 161:
              return false;
            default:
              if (node.parent.kind === 258 || node.parent.kind === 298) {
                return false;
              }
              switch (node.kind) {
                case 252:
                  return nodeHasAnyModifiersExcept(node, 129);
                case 253:
                case 176:
                  return nodeHasAnyModifiersExcept(node, 125);
                case 254:
                case 233:
                case 255:
                  return true;
                case 256:
                  return nodeHasAnyModifiersExcept(node, 84);
                default:
                  ts3.Debug.fail();
              }
          }
        }
        function nodeHasAnyModifiersExcept(node, allowedModifier) {
          return node.modifiers.length > 1 || node.modifiers[0].kind !== allowedModifier;
        }
        function checkGrammarAsyncModifier(node, asyncModifier) {
          switch (node.kind) {
            case 166:
            case 252:
            case 209:
            case 210:
              return false;
          }
          return grammarErrorOnNode(asyncModifier, ts3.Diagnostics._0_modifier_cannot_be_used_here, "async");
        }
        function checkGrammarForDisallowedTrailingComma(list, diag) {
          if (diag === void 0) {
            diag = ts3.Diagnostics.Trailing_comma_not_allowed;
          }
          if (list && list.hasTrailingComma) {
            return grammarErrorAtPos(list[0], list.end - ",".length, ",".length, diag);
          }
          return false;
        }
        function checkGrammarTypeParameterList(typeParameters, file) {
          if (typeParameters && typeParameters.length === 0) {
            var start = typeParameters.pos - "<".length;
            var end = ts3.skipTrivia(file.text, typeParameters.end) + ">".length;
            return grammarErrorAtPos(file, start, end - start, ts3.Diagnostics.Type_parameter_list_cannot_be_empty);
          }
          return false;
        }
        function checkGrammarParameterList(parameters) {
          var seenOptionalParameter = false;
          var parameterCount = parameters.length;
          for (var i3 = 0; i3 < parameterCount; i3++) {
            var parameter = parameters[i3];
            if (parameter.dotDotDotToken) {
              if (i3 !== parameterCount - 1) {
                return grammarErrorOnNode(parameter.dotDotDotToken, ts3.Diagnostics.A_rest_parameter_must_be_last_in_a_parameter_list);
              }
              if (!(parameter.flags & 8388608)) {
                checkGrammarForDisallowedTrailingComma(parameters, ts3.Diagnostics.A_rest_parameter_or_binding_pattern_may_not_have_a_trailing_comma);
              }
              if (parameter.questionToken) {
                return grammarErrorOnNode(parameter.questionToken, ts3.Diagnostics.A_rest_parameter_cannot_be_optional);
              }
              if (parameter.initializer) {
                return grammarErrorOnNode(parameter.name, ts3.Diagnostics.A_rest_parameter_cannot_have_an_initializer);
              }
            } else if (isOptionalParameter(parameter)) {
              seenOptionalParameter = true;
              if (parameter.questionToken && parameter.initializer) {
                return grammarErrorOnNode(parameter.name, ts3.Diagnostics.Parameter_cannot_have_question_mark_and_initializer);
              }
            } else if (seenOptionalParameter && !parameter.initializer) {
              return grammarErrorOnNode(parameter.name, ts3.Diagnostics.A_required_parameter_cannot_follow_an_optional_parameter);
            }
          }
        }
        function getNonSimpleParameters(parameters) {
          return ts3.filter(parameters, function(parameter) {
            return !!parameter.initializer || ts3.isBindingPattern(parameter.name) || ts3.isRestParameter(parameter);
          });
        }
        function checkGrammarForUseStrictSimpleParameterList(node) {
          if (languageVersion >= 3) {
            var useStrictDirective_1 = node.body && ts3.isBlock(node.body) && ts3.findUseStrictPrologue(node.body.statements);
            if (useStrictDirective_1) {
              var nonSimpleParameters = getNonSimpleParameters(node.parameters);
              if (ts3.length(nonSimpleParameters)) {
                ts3.forEach(nonSimpleParameters, function(parameter) {
                  ts3.addRelatedInfo(error(parameter, ts3.Diagnostics.This_parameter_is_not_allowed_with_use_strict_directive), ts3.createDiagnosticForNode(useStrictDirective_1, ts3.Diagnostics.use_strict_directive_used_here));
                });
                var diagnostics_2 = nonSimpleParameters.map(function(parameter, index) {
                  return index === 0 ? ts3.createDiagnosticForNode(parameter, ts3.Diagnostics.Non_simple_parameter_declared_here) : ts3.createDiagnosticForNode(parameter, ts3.Diagnostics.and_here);
                });
                ts3.addRelatedInfo.apply(void 0, __spreadArray([error(useStrictDirective_1, ts3.Diagnostics.use_strict_directive_cannot_be_used_with_non_simple_parameter_list)], diagnostics_2));
                return true;
              }
            }
          }
          return false;
        }
        function checkGrammarFunctionLikeDeclaration(node) {
          var file = ts3.getSourceFileOfNode(node);
          return checkGrammarDecoratorsAndModifiers(node) || checkGrammarTypeParameterList(node.typeParameters, file) || checkGrammarParameterList(node.parameters) || checkGrammarArrowFunction(node, file) || ts3.isFunctionLikeDeclaration(node) && checkGrammarForUseStrictSimpleParameterList(node);
        }
        function checkGrammarClassLikeDeclaration(node) {
          var file = ts3.getSourceFileOfNode(node);
          return checkGrammarClassDeclarationHeritageClauses(node) || checkGrammarTypeParameterList(node.typeParameters, file);
        }
        function checkGrammarArrowFunction(node, file) {
          if (!ts3.isArrowFunction(node)) {
            return false;
          }
          var equalsGreaterThanToken = node.equalsGreaterThanToken;
          var startLine = ts3.getLineAndCharacterOfPosition(file, equalsGreaterThanToken.pos).line;
          var endLine = ts3.getLineAndCharacterOfPosition(file, equalsGreaterThanToken.end).line;
          return startLine !== endLine && grammarErrorOnNode(equalsGreaterThanToken, ts3.Diagnostics.Line_terminator_not_permitted_before_arrow);
        }
        function checkGrammarIndexSignatureParameters(node) {
          var parameter = node.parameters[0];
          if (node.parameters.length !== 1) {
            if (parameter) {
              return grammarErrorOnNode(parameter.name, ts3.Diagnostics.An_index_signature_must_have_exactly_one_parameter);
            } else {
              return grammarErrorOnNode(node, ts3.Diagnostics.An_index_signature_must_have_exactly_one_parameter);
            }
          }
          checkGrammarForDisallowedTrailingComma(node.parameters, ts3.Diagnostics.An_index_signature_cannot_have_a_trailing_comma);
          if (parameter.dotDotDotToken) {
            return grammarErrorOnNode(parameter.dotDotDotToken, ts3.Diagnostics.An_index_signature_cannot_have_a_rest_parameter);
          }
          if (ts3.hasEffectiveModifiers(parameter)) {
            return grammarErrorOnNode(parameter.name, ts3.Diagnostics.An_index_signature_parameter_cannot_have_an_accessibility_modifier);
          }
          if (parameter.questionToken) {
            return grammarErrorOnNode(parameter.questionToken, ts3.Diagnostics.An_index_signature_parameter_cannot_have_a_question_mark);
          }
          if (parameter.initializer) {
            return grammarErrorOnNode(parameter.name, ts3.Diagnostics.An_index_signature_parameter_cannot_have_an_initializer);
          }
          if (!parameter.type) {
            return grammarErrorOnNode(parameter.name, ts3.Diagnostics.An_index_signature_parameter_must_have_a_type_annotation);
          }
          if (parameter.type.kind !== 147 && parameter.type.kind !== 144) {
            var type3 = getTypeFromTypeNode(parameter.type);
            if (type3.flags & 4 || type3.flags & 8) {
              return grammarErrorOnNode(parameter.name, ts3.Diagnostics.An_index_signature_parameter_type_cannot_be_a_type_alias_Consider_writing_0_Colon_1_Colon_2_instead, ts3.getTextOfNode(parameter.name), typeToString(type3), typeToString(node.type ? getTypeFromTypeNode(node.type) : anyType));
            }
            if (type3.flags & 1048576 && allTypesAssignableToKind(type3, 384, true)) {
              return grammarErrorOnNode(parameter.name, ts3.Diagnostics.An_index_signature_parameter_type_cannot_be_a_union_type_Consider_using_a_mapped_object_type_instead);
            }
            return grammarErrorOnNode(parameter.name, ts3.Diagnostics.An_index_signature_parameter_type_must_be_either_string_or_number);
          }
          if (!node.type) {
            return grammarErrorOnNode(node, ts3.Diagnostics.An_index_signature_must_have_a_type_annotation);
          }
          return false;
        }
        function checkGrammarIndexSignature(node) {
          return checkGrammarDecoratorsAndModifiers(node) || checkGrammarIndexSignatureParameters(node);
        }
        function checkGrammarForAtLeastOneTypeArgument(node, typeArguments) {
          if (typeArguments && typeArguments.length === 0) {
            var sourceFile = ts3.getSourceFileOfNode(node);
            var start = typeArguments.pos - "<".length;
            var end = ts3.skipTrivia(sourceFile.text, typeArguments.end) + ">".length;
            return grammarErrorAtPos(sourceFile, start, end - start, ts3.Diagnostics.Type_argument_list_cannot_be_empty);
          }
          return false;
        }
        function checkGrammarTypeArguments(node, typeArguments) {
          return checkGrammarForDisallowedTrailingComma(typeArguments) || checkGrammarForAtLeastOneTypeArgument(node, typeArguments);
        }
        function checkGrammarTaggedTemplateChain(node) {
          if (node.questionDotToken || node.flags & 32) {
            return grammarErrorOnNode(node.template, ts3.Diagnostics.Tagged_template_expressions_are_not_permitted_in_an_optional_chain);
          }
          return false;
        }
        function checkGrammarForOmittedArgument(args) {
          if (args) {
            for (var _i = 0, args_4 = args; _i < args_4.length; _i++) {
              var arg2 = args_4[_i];
              if (arg2.kind === 223) {
                return grammarErrorAtPos(arg2, arg2.pos, 0, ts3.Diagnostics.Argument_expression_expected);
              }
            }
          }
          return false;
        }
        function checkGrammarArguments(args) {
          return checkGrammarForOmittedArgument(args);
        }
        function checkGrammarHeritageClause(node) {
          var types2 = node.types;
          if (checkGrammarForDisallowedTrailingComma(types2)) {
            return true;
          }
          if (types2 && types2.length === 0) {
            var listType = ts3.tokenToString(node.token);
            return grammarErrorAtPos(node, types2.pos, 0, ts3.Diagnostics._0_list_cannot_be_empty, listType);
          }
          return ts3.some(types2, checkGrammarExpressionWithTypeArguments);
        }
        function checkGrammarExpressionWithTypeArguments(node) {
          return checkGrammarTypeArguments(node, node.typeArguments);
        }
        function checkGrammarClassDeclarationHeritageClauses(node) {
          var seenExtendsClause = false;
          var seenImplementsClause = false;
          if (!checkGrammarDecoratorsAndModifiers(node) && node.heritageClauses) {
            for (var _i = 0, _a2 = node.heritageClauses; _i < _a2.length; _i++) {
              var heritageClause = _a2[_i];
              if (heritageClause.token === 93) {
                if (seenExtendsClause) {
                  return grammarErrorOnFirstToken(heritageClause, ts3.Diagnostics.extends_clause_already_seen);
                }
                if (seenImplementsClause) {
                  return grammarErrorOnFirstToken(heritageClause, ts3.Diagnostics.extends_clause_must_precede_implements_clause);
                }
                if (heritageClause.types.length > 1) {
                  return grammarErrorOnFirstToken(heritageClause.types[1], ts3.Diagnostics.Classes_can_only_extend_a_single_class);
                }
                seenExtendsClause = true;
              } else {
                ts3.Debug.assert(heritageClause.token === 116);
                if (seenImplementsClause) {
                  return grammarErrorOnFirstToken(heritageClause, ts3.Diagnostics.implements_clause_already_seen);
                }
                seenImplementsClause = true;
              }
              checkGrammarHeritageClause(heritageClause);
            }
          }
        }
        function checkGrammarInterfaceDeclaration(node) {
          var seenExtendsClause = false;
          if (node.heritageClauses) {
            for (var _i = 0, _a2 = node.heritageClauses; _i < _a2.length; _i++) {
              var heritageClause = _a2[_i];
              if (heritageClause.token === 93) {
                if (seenExtendsClause) {
                  return grammarErrorOnFirstToken(heritageClause, ts3.Diagnostics.extends_clause_already_seen);
                }
                seenExtendsClause = true;
              } else {
                ts3.Debug.assert(heritageClause.token === 116);
                return grammarErrorOnFirstToken(heritageClause, ts3.Diagnostics.Interface_declaration_cannot_have_implements_clause);
              }
              checkGrammarHeritageClause(heritageClause);
            }
          }
          return false;
        }
        function checkGrammarComputedPropertyName(node) {
          if (node.kind !== 159) {
            return false;
          }
          var computedPropertyName = node;
          if (computedPropertyName.expression.kind === 217 && computedPropertyName.expression.operatorToken.kind === 27) {
            return grammarErrorOnNode(computedPropertyName.expression, ts3.Diagnostics.A_comma_expression_is_not_allowed_in_a_computed_property_name);
          }
          return false;
        }
        function checkGrammarForGenerator(node) {
          if (node.asteriskToken) {
            ts3.Debug.assert(node.kind === 252 || node.kind === 209 || node.kind === 166);
            if (node.flags & 8388608) {
              return grammarErrorOnNode(node.asteriskToken, ts3.Diagnostics.Generators_are_not_allowed_in_an_ambient_context);
            }
            if (!node.body) {
              return grammarErrorOnNode(node.asteriskToken, ts3.Diagnostics.An_overload_signature_cannot_be_declared_as_a_generator);
            }
          }
        }
        function checkGrammarForInvalidQuestionMark(questionToken, message) {
          return !!questionToken && grammarErrorOnNode(questionToken, message);
        }
        function checkGrammarForInvalidExclamationToken(exclamationToken, message) {
          return !!exclamationToken && grammarErrorOnNode(exclamationToken, message);
        }
        function checkGrammarObjectLiteralExpression(node, inDestructuring) {
          var seen = new ts3.Map();
          for (var _i = 0, _a2 = node.properties; _i < _a2.length; _i++) {
            var prop = _a2[_i];
            if (prop.kind === 291) {
              if (inDestructuring) {
                var expression = ts3.skipParentheses(prop.expression);
                if (ts3.isArrayLiteralExpression(expression) || ts3.isObjectLiteralExpression(expression)) {
                  return grammarErrorOnNode(prop.expression, ts3.Diagnostics.A_rest_element_cannot_contain_a_binding_pattern);
                }
              }
              continue;
            }
            var name = prop.name;
            if (name.kind === 159) {
              checkGrammarComputedPropertyName(name);
            }
            if (prop.kind === 290 && !inDestructuring && prop.objectAssignmentInitializer) {
              return grammarErrorOnNode(prop.equalsToken, ts3.Diagnostics.Did_you_mean_to_use_a_Colon_An_can_only_follow_a_property_name_when_the_containing_object_literal_is_part_of_a_destructuring_pattern);
            }
            if (name.kind === 79) {
              grammarErrorOnNode(name, ts3.Diagnostics.Private_identifiers_are_not_allowed_outside_class_bodies);
            }
            if (prop.modifiers) {
              for (var _b = 0, _c = prop.modifiers; _b < _c.length; _b++) {
                var mod = _c[_b];
                if (mod.kind !== 129 || prop.kind !== 166) {
                  grammarErrorOnNode(mod, ts3.Diagnostics._0_modifier_cannot_be_used_here, ts3.getTextOfNode(mod));
                }
              }
            }
            var currentKind = void 0;
            switch (prop.kind) {
              case 290:
                checkGrammarForInvalidExclamationToken(prop.exclamationToken, ts3.Diagnostics.A_definite_assignment_assertion_is_not_permitted_in_this_context);
              case 289:
                checkGrammarForInvalidQuestionMark(prop.questionToken, ts3.Diagnostics.An_object_member_cannot_be_declared_optional);
                if (name.kind === 8) {
                  checkGrammarNumericLiteral(name);
                }
                currentKind = 4;
                break;
              case 166:
                currentKind = 8;
                break;
              case 168:
                currentKind = 1;
                break;
              case 169:
                currentKind = 2;
                break;
              default:
                throw ts3.Debug.assertNever(prop, "Unexpected syntax kind:" + prop.kind);
            }
            if (!inDestructuring) {
              var effectiveName = ts3.getPropertyNameForPropertyNameNode(name);
              if (effectiveName === void 0) {
                continue;
              }
              var existingKind = seen.get(effectiveName);
              if (!existingKind) {
                seen.set(effectiveName, currentKind);
              } else {
                if (currentKind & 12 && existingKind & 12) {
                  grammarErrorOnNode(name, ts3.Diagnostics.Duplicate_identifier_0, ts3.getTextOfNode(name));
                } else if (currentKind & 3 && existingKind & 3) {
                  if (existingKind !== 3 && currentKind !== existingKind) {
                    seen.set(effectiveName, currentKind | existingKind);
                  } else {
                    return grammarErrorOnNode(name, ts3.Diagnostics.An_object_literal_cannot_have_multiple_get_Slashset_accessors_with_the_same_name);
                  }
                } else {
                  return grammarErrorOnNode(name, ts3.Diagnostics.An_object_literal_cannot_have_property_and_accessor_with_the_same_name);
                }
              }
            }
          }
        }
        function checkGrammarJsxElement(node) {
          checkGrammarJsxName(node.tagName);
          checkGrammarTypeArguments(node, node.typeArguments);
          var seen = new ts3.Map();
          for (var _i = 0, _a2 = node.attributes.properties; _i < _a2.length; _i++) {
            var attr = _a2[_i];
            if (attr.kind === 283) {
              continue;
            }
            var name = attr.name, initializer = attr.initializer;
            if (!seen.get(name.escapedText)) {
              seen.set(name.escapedText, true);
            } else {
              return grammarErrorOnNode(name, ts3.Diagnostics.JSX_elements_cannot_have_multiple_attributes_with_the_same_name);
            }
            if (initializer && initializer.kind === 284 && !initializer.expression) {
              return grammarErrorOnNode(initializer, ts3.Diagnostics.JSX_attributes_must_only_be_assigned_a_non_empty_expression);
            }
          }
        }
        function checkGrammarJsxName(node) {
          if (ts3.isPropertyAccessExpression(node)) {
            var propName = node;
            do {
              var check_1 = checkGrammarJsxNestedIdentifier(propName.name);
              if (check_1) {
                return check_1;
              }
              propName = propName.expression;
            } while (ts3.isPropertyAccessExpression(propName));
            var check = checkGrammarJsxNestedIdentifier(propName);
            if (check) {
              return check;
            }
          }
          function checkGrammarJsxNestedIdentifier(name) {
            if (ts3.isIdentifier(name) && ts3.idText(name).indexOf(":") !== -1) {
              return grammarErrorOnNode(name, ts3.Diagnostics.JSX_property_access_expressions_cannot_include_JSX_namespace_names);
            }
          }
        }
        function checkGrammarJsxExpression(node) {
          if (node.expression && ts3.isCommaSequence(node.expression)) {
            return grammarErrorOnNode(node.expression, ts3.Diagnostics.JSX_expressions_may_not_use_the_comma_operator_Did_you_mean_to_write_an_array);
          }
        }
        function checkGrammarForInOrForOfStatement(forInOrOfStatement) {
          if (checkGrammarStatementInAmbientContext(forInOrOfStatement)) {
            return true;
          }
          if (forInOrOfStatement.kind === 240 && forInOrOfStatement.awaitModifier) {
            if (!(forInOrOfStatement.flags & 32768)) {
              var sourceFile = ts3.getSourceFileOfNode(forInOrOfStatement);
              if (ts3.isInTopLevelContext(forInOrOfStatement)) {
                if (!hasParseDiagnostics(sourceFile)) {
                  if (!ts3.isEffectiveExternalModule(sourceFile, compilerOptions)) {
                    diagnostics.add(ts3.createDiagnosticForNode(forInOrOfStatement.awaitModifier, ts3.Diagnostics.for_await_loops_are_only_allowed_at_the_top_level_of_a_file_when_that_file_is_a_module_but_this_file_has_no_imports_or_exports_Consider_adding_an_empty_export_to_make_this_file_a_module));
                  }
                  if (moduleKind !== ts3.ModuleKind.ESNext && moduleKind !== ts3.ModuleKind.System || languageVersion < 4) {
                    diagnostics.add(ts3.createDiagnosticForNode(forInOrOfStatement.awaitModifier, ts3.Diagnostics.Top_level_for_await_loops_are_only_allowed_when_the_module_option_is_set_to_esnext_or_system_and_the_target_option_is_set_to_es2017_or_higher));
                  }
                }
              } else {
                if (!hasParseDiagnostics(sourceFile)) {
                  var diagnostic = ts3.createDiagnosticForNode(forInOrOfStatement.awaitModifier, ts3.Diagnostics.for_await_loops_are_only_allowed_within_async_functions_and_at_the_top_levels_of_modules);
                  var func2 = ts3.getContainingFunction(forInOrOfStatement);
                  if (func2 && func2.kind !== 167) {
                    ts3.Debug.assert((ts3.getFunctionFlags(func2) & 2) === 0, "Enclosing function should never be an async function.");
                    var relatedInfo = ts3.createDiagnosticForNode(func2, ts3.Diagnostics.Did_you_mean_to_mark_this_function_as_async);
                    ts3.addRelatedInfo(diagnostic, relatedInfo);
                  }
                  diagnostics.add(diagnostic);
                  return true;
                }
              }
              return false;
            }
          }
          if (forInOrOfStatement.initializer.kind === 251) {
            var variableList = forInOrOfStatement.initializer;
            if (!checkGrammarVariableDeclarationList(variableList)) {
              var declarations = variableList.declarations;
              if (!declarations.length) {
                return false;
              }
              if (declarations.length > 1) {
                var diagnostic = forInOrOfStatement.kind === 239 ? ts3.Diagnostics.Only_a_single_variable_declaration_is_allowed_in_a_for_in_statement : ts3.Diagnostics.Only_a_single_variable_declaration_is_allowed_in_a_for_of_statement;
                return grammarErrorOnFirstToken(variableList.declarations[1], diagnostic);
              }
              var firstDeclaration = declarations[0];
              if (firstDeclaration.initializer) {
                var diagnostic = forInOrOfStatement.kind === 239 ? ts3.Diagnostics.The_variable_declaration_of_a_for_in_statement_cannot_have_an_initializer : ts3.Diagnostics.The_variable_declaration_of_a_for_of_statement_cannot_have_an_initializer;
                return grammarErrorOnNode(firstDeclaration.name, diagnostic);
              }
              if (firstDeclaration.type) {
                var diagnostic = forInOrOfStatement.kind === 239 ? ts3.Diagnostics.The_left_hand_side_of_a_for_in_statement_cannot_use_a_type_annotation : ts3.Diagnostics.The_left_hand_side_of_a_for_of_statement_cannot_use_a_type_annotation;
                return grammarErrorOnNode(firstDeclaration, diagnostic);
              }
            }
          }
          return false;
        }
        function checkGrammarAccessor(accessor) {
          if (!(accessor.flags & 8388608) && accessor.parent.kind !== 178 && accessor.parent.kind !== 254) {
            if (languageVersion < 1) {
              return grammarErrorOnNode(accessor.name, ts3.Diagnostics.Accessors_are_only_available_when_targeting_ECMAScript_5_and_higher);
            }
            if (languageVersion < 2 && ts3.isPrivateIdentifier(accessor.name)) {
              return grammarErrorOnNode(accessor.name, ts3.Diagnostics.Private_identifiers_are_only_available_when_targeting_ECMAScript_2015_and_higher);
            }
            if (accessor.body === void 0 && !ts3.hasSyntacticModifier(accessor, 128)) {
              return grammarErrorAtPos(accessor, accessor.end - 1, ";".length, ts3.Diagnostics._0_expected, "{");
            }
          }
          if (accessor.body) {
            if (ts3.hasSyntacticModifier(accessor, 128)) {
              return grammarErrorOnNode(accessor, ts3.Diagnostics.An_abstract_accessor_cannot_have_an_implementation);
            }
            if (accessor.parent.kind === 178 || accessor.parent.kind === 254) {
              return grammarErrorOnNode(accessor.body, ts3.Diagnostics.An_implementation_cannot_be_declared_in_ambient_contexts);
            }
          }
          if (accessor.typeParameters) {
            return grammarErrorOnNode(accessor.name, ts3.Diagnostics.An_accessor_cannot_have_type_parameters);
          }
          if (!doesAccessorHaveCorrectParameterCount(accessor)) {
            return grammarErrorOnNode(accessor.name, accessor.kind === 168 ? ts3.Diagnostics.A_get_accessor_cannot_have_parameters : ts3.Diagnostics.A_set_accessor_must_have_exactly_one_parameter);
          }
          if (accessor.kind === 169) {
            if (accessor.type) {
              return grammarErrorOnNode(accessor.name, ts3.Diagnostics.A_set_accessor_cannot_have_a_return_type_annotation);
            }
            var parameter = ts3.Debug.checkDefined(ts3.getSetAccessorValueParameter(accessor), "Return value does not match parameter count assertion.");
            if (parameter.dotDotDotToken) {
              return grammarErrorOnNode(parameter.dotDotDotToken, ts3.Diagnostics.A_set_accessor_cannot_have_rest_parameter);
            }
            if (parameter.questionToken) {
              return grammarErrorOnNode(parameter.questionToken, ts3.Diagnostics.A_set_accessor_cannot_have_an_optional_parameter);
            }
            if (parameter.initializer) {
              return grammarErrorOnNode(accessor.name, ts3.Diagnostics.A_set_accessor_parameter_cannot_have_an_initializer);
            }
          }
          return false;
        }
        function doesAccessorHaveCorrectParameterCount(accessor) {
          return getAccessorThisParameter(accessor) || accessor.parameters.length === (accessor.kind === 168 ? 0 : 1);
        }
        function getAccessorThisParameter(accessor) {
          if (accessor.parameters.length === (accessor.kind === 168 ? 1 : 2)) {
            return ts3.getThisParameter(accessor);
          }
        }
        function checkGrammarTypeOperatorNode(node) {
          if (node.operator === 151) {
            if (node.type.kind !== 148) {
              return grammarErrorOnNode(node.type, ts3.Diagnostics._0_expected, ts3.tokenToString(148));
            }
            var parent = ts3.walkUpParenthesizedTypes(node.parent);
            if (ts3.isInJSFile(parent) && ts3.isJSDocTypeExpression(parent)) {
              parent = parent.parent;
              if (ts3.isJSDocTypeTag(parent)) {
                parent = parent.parent.parent;
              }
            }
            switch (parent.kind) {
              case 250:
                var decl = parent;
                if (decl.name.kind !== 78) {
                  return grammarErrorOnNode(node, ts3.Diagnostics.unique_symbol_types_may_not_be_used_on_a_variable_declaration_with_a_binding_name);
                }
                if (!ts3.isVariableDeclarationInVariableStatement(decl)) {
                  return grammarErrorOnNode(node, ts3.Diagnostics.unique_symbol_types_are_only_allowed_on_variables_in_a_variable_statement);
                }
                if (!(decl.parent.flags & 2)) {
                  return grammarErrorOnNode(parent.name, ts3.Diagnostics.A_variable_whose_type_is_a_unique_symbol_type_must_be_const);
                }
                break;
              case 164:
                if (!ts3.hasSyntacticModifier(parent, 32) || !ts3.hasEffectiveModifier(parent, 64)) {
                  return grammarErrorOnNode(parent.name, ts3.Diagnostics.A_property_of_a_class_whose_type_is_a_unique_symbol_type_must_be_both_static_and_readonly);
                }
                break;
              case 163:
                if (!ts3.hasSyntacticModifier(parent, 64)) {
                  return grammarErrorOnNode(parent.name, ts3.Diagnostics.A_property_of_an_interface_or_type_literal_whose_type_is_a_unique_symbol_type_must_be_readonly);
                }
                break;
              default:
                return grammarErrorOnNode(node, ts3.Diagnostics.unique_symbol_types_are_not_allowed_here);
            }
          } else if (node.operator === 142) {
            if (node.type.kind !== 179 && node.type.kind !== 180) {
              return grammarErrorOnFirstToken(node, ts3.Diagnostics.readonly_type_modifier_is_only_permitted_on_array_and_tuple_literal_types, ts3.tokenToString(148));
            }
          }
        }
        function checkGrammarForInvalidDynamicName(node, message) {
          if (isNonBindableDynamicName(node)) {
            return grammarErrorOnNode(node, message);
          }
        }
        function checkGrammarMethod(node) {
          if (checkGrammarFunctionLikeDeclaration(node)) {
            return true;
          }
          if (node.kind === 166) {
            if (node.parent.kind === 201) {
              if (node.modifiers && !(node.modifiers.length === 1 && ts3.first(node.modifiers).kind === 129)) {
                return grammarErrorOnFirstToken(node, ts3.Diagnostics.Modifiers_cannot_appear_here);
              } else if (checkGrammarForInvalidQuestionMark(node.questionToken, ts3.Diagnostics.An_object_member_cannot_be_declared_optional)) {
                return true;
              } else if (checkGrammarForInvalidExclamationToken(node.exclamationToken, ts3.Diagnostics.A_definite_assignment_assertion_is_not_permitted_in_this_context)) {
                return true;
              } else if (node.body === void 0) {
                return grammarErrorAtPos(node, node.end - 1, ";".length, ts3.Diagnostics._0_expected, "{");
              }
            }
            if (checkGrammarForGenerator(node)) {
              return true;
            }
          }
          if (ts3.isClassLike(node.parent)) {
            if (languageVersion < 2 && ts3.isPrivateIdentifier(node.name)) {
              return grammarErrorOnNode(node.name, ts3.Diagnostics.Private_identifiers_are_only_available_when_targeting_ECMAScript_2015_and_higher);
            }
            if (node.flags & 8388608) {
              return checkGrammarForInvalidDynamicName(node.name, ts3.Diagnostics.A_computed_property_name_in_an_ambient_context_must_refer_to_an_expression_whose_type_is_a_literal_type_or_a_unique_symbol_type);
            } else if (node.kind === 166 && !node.body) {
              return checkGrammarForInvalidDynamicName(node.name, ts3.Diagnostics.A_computed_property_name_in_a_method_overload_must_refer_to_an_expression_whose_type_is_a_literal_type_or_a_unique_symbol_type);
            }
          } else if (node.parent.kind === 254) {
            return checkGrammarForInvalidDynamicName(node.name, ts3.Diagnostics.A_computed_property_name_in_an_interface_must_refer_to_an_expression_whose_type_is_a_literal_type_or_a_unique_symbol_type);
          } else if (node.parent.kind === 178) {
            return checkGrammarForInvalidDynamicName(node.name, ts3.Diagnostics.A_computed_property_name_in_a_type_literal_must_refer_to_an_expression_whose_type_is_a_literal_type_or_a_unique_symbol_type);
          }
        }
        function checkGrammarBreakOrContinueStatement(node) {
          var current = node;
          while (current) {
            if (ts3.isFunctionLike(current)) {
              return grammarErrorOnNode(node, ts3.Diagnostics.Jump_target_cannot_cross_function_boundary);
            }
            switch (current.kind) {
              case 246:
                if (node.label && current.label.escapedText === node.label.escapedText) {
                  var isMisplacedContinueLabel = node.kind === 241 && !ts3.isIterationStatement(current.statement, true);
                  if (isMisplacedContinueLabel) {
                    return grammarErrorOnNode(node, ts3.Diagnostics.A_continue_statement_can_only_jump_to_a_label_of_an_enclosing_iteration_statement);
                  }
                  return false;
                }
                break;
              case 245:
                if (node.kind === 242 && !node.label) {
                  return false;
                }
                break;
              default:
                if (ts3.isIterationStatement(current, false) && !node.label) {
                  return false;
                }
                break;
            }
            current = current.parent;
          }
          if (node.label) {
            var message = node.kind === 242 ? ts3.Diagnostics.A_break_statement_can_only_jump_to_a_label_of_an_enclosing_statement : ts3.Diagnostics.A_continue_statement_can_only_jump_to_a_label_of_an_enclosing_iteration_statement;
            return grammarErrorOnNode(node, message);
          } else {
            var message = node.kind === 242 ? ts3.Diagnostics.A_break_statement_can_only_be_used_within_an_enclosing_iteration_or_switch_statement : ts3.Diagnostics.A_continue_statement_can_only_be_used_within_an_enclosing_iteration_statement;
            return grammarErrorOnNode(node, message);
          }
        }
        function checkGrammarBindingElement(node) {
          if (node.dotDotDotToken) {
            var elements = node.parent.elements;
            if (node !== ts3.last(elements)) {
              return grammarErrorOnNode(node, ts3.Diagnostics.A_rest_element_must_be_last_in_a_destructuring_pattern);
            }
            checkGrammarForDisallowedTrailingComma(elements, ts3.Diagnostics.A_rest_parameter_or_binding_pattern_may_not_have_a_trailing_comma);
            if (node.propertyName) {
              return grammarErrorOnNode(node.name, ts3.Diagnostics.A_rest_element_cannot_have_a_property_name);
            }
          }
          if (node.dotDotDotToken && node.initializer) {
            return grammarErrorAtPos(node, node.initializer.pos - 1, 1, ts3.Diagnostics.A_rest_element_cannot_have_an_initializer);
          }
        }
        function isStringOrNumberLiteralExpression(expr) {
          return ts3.isStringOrNumericLiteralLike(expr) || expr.kind === 215 && expr.operator === 40 && expr.operand.kind === 8;
        }
        function isBigIntLiteralExpression(expr) {
          return expr.kind === 9 || expr.kind === 215 && expr.operator === 40 && expr.operand.kind === 9;
        }
        function isSimpleLiteralEnumReference(expr) {
          if ((ts3.isPropertyAccessExpression(expr) || ts3.isElementAccessExpression(expr) && isStringOrNumberLiteralExpression(expr.argumentExpression)) && ts3.isEntityNameExpression(expr.expression)) {
            return !!(checkExpressionCached(expr).flags & 1024);
          }
        }
        function checkAmbientInitializer(node) {
          var initializer = node.initializer;
          if (initializer) {
            var isInvalidInitializer = !(isStringOrNumberLiteralExpression(initializer) || isSimpleLiteralEnumReference(initializer) || initializer.kind === 109 || initializer.kind === 94 || isBigIntLiteralExpression(initializer));
            var isConstOrReadonly = ts3.isDeclarationReadonly(node) || ts3.isVariableDeclaration(node) && ts3.isVarConst(node);
            if (isConstOrReadonly && !node.type) {
              if (isInvalidInitializer) {
                return grammarErrorOnNode(initializer, ts3.Diagnostics.A_const_initializer_in_an_ambient_context_must_be_a_string_or_numeric_literal_or_literal_enum_reference);
              }
            } else {
              return grammarErrorOnNode(initializer, ts3.Diagnostics.Initializers_are_not_allowed_in_ambient_contexts);
            }
            if (!isConstOrReadonly || isInvalidInitializer) {
              return grammarErrorOnNode(initializer, ts3.Diagnostics.Initializers_are_not_allowed_in_ambient_contexts);
            }
          }
        }
        function checkGrammarVariableDeclaration(node) {
          if (node.parent.parent.kind !== 239 && node.parent.parent.kind !== 240) {
            if (node.flags & 8388608) {
              checkAmbientInitializer(node);
            } else if (!node.initializer) {
              if (ts3.isBindingPattern(node.name) && !ts3.isBindingPattern(node.parent)) {
                return grammarErrorOnNode(node, ts3.Diagnostics.A_destructuring_declaration_must_have_an_initializer);
              }
              if (ts3.isVarConst(node)) {
                return grammarErrorOnNode(node, ts3.Diagnostics.const_declarations_must_be_initialized);
              }
            }
          }
          if (node.exclamationToken && (node.parent.parent.kind !== 233 || !node.type || node.initializer || node.flags & 8388608)) {
            var message = node.initializer ? ts3.Diagnostics.Declarations_with_initializers_cannot_also_have_definite_assignment_assertions : !node.type ? ts3.Diagnostics.Declarations_with_definite_assignment_assertions_must_also_have_type_annotations : ts3.Diagnostics.A_definite_assignment_assertion_is_not_permitted_in_this_context;
            return grammarErrorOnNode(node.exclamationToken, message);
          }
          var moduleKind2 = ts3.getEmitModuleKind(compilerOptions);
          if (moduleKind2 < ts3.ModuleKind.ES2015 && moduleKind2 !== ts3.ModuleKind.System && !(node.parent.parent.flags & 8388608) && ts3.hasSyntacticModifier(node.parent.parent, 1)) {
            checkESModuleMarker(node.name);
          }
          var checkLetConstNames = ts3.isLet(node) || ts3.isVarConst(node);
          return checkLetConstNames && checkGrammarNameInLetOrConstDeclarations(node.name);
        }
        function checkESModuleMarker(name) {
          if (name.kind === 78) {
            if (ts3.idText(name) === "__esModule") {
              return grammarErrorOnNodeSkippedOn("noEmit", name, ts3.Diagnostics.Identifier_expected_esModule_is_reserved_as_an_exported_marker_when_transforming_ECMAScript_modules);
            }
          } else {
            var elements = name.elements;
            for (var _i = 0, elements_1 = elements; _i < elements_1.length; _i++) {
              var element = elements_1[_i];
              if (!ts3.isOmittedExpression(element)) {
                return checkESModuleMarker(element.name);
              }
            }
          }
          return false;
        }
        function checkGrammarNameInLetOrConstDeclarations(name) {
          if (name.kind === 78) {
            if (name.originalKeywordKind === 118) {
              return grammarErrorOnNode(name, ts3.Diagnostics.let_is_not_allowed_to_be_used_as_a_name_in_let_or_const_declarations);
            }
          } else {
            var elements = name.elements;
            for (var _i = 0, elements_2 = elements; _i < elements_2.length; _i++) {
              var element = elements_2[_i];
              if (!ts3.isOmittedExpression(element)) {
                checkGrammarNameInLetOrConstDeclarations(element.name);
              }
            }
          }
          return false;
        }
        function checkGrammarVariableDeclarationList(declarationList) {
          var declarations = declarationList.declarations;
          if (checkGrammarForDisallowedTrailingComma(declarationList.declarations)) {
            return true;
          }
          if (!declarationList.declarations.length) {
            return grammarErrorAtPos(declarationList, declarations.pos, declarations.end - declarations.pos, ts3.Diagnostics.Variable_declaration_list_cannot_be_empty);
          }
          return false;
        }
        function allowLetAndConstDeclarations(parent) {
          switch (parent.kind) {
            case 235:
            case 236:
            case 237:
            case 244:
            case 238:
            case 239:
            case 240:
              return false;
            case 246:
              return allowLetAndConstDeclarations(parent.parent);
          }
          return true;
        }
        function checkGrammarForDisallowedLetOrConstStatement(node) {
          if (!allowLetAndConstDeclarations(node.parent)) {
            if (ts3.isLet(node.declarationList)) {
              return grammarErrorOnNode(node, ts3.Diagnostics.let_declarations_can_only_be_declared_inside_a_block);
            } else if (ts3.isVarConst(node.declarationList)) {
              return grammarErrorOnNode(node, ts3.Diagnostics.const_declarations_can_only_be_declared_inside_a_block);
            }
          }
        }
        function checkGrammarMetaProperty(node) {
          var escapedText = node.name.escapedText;
          switch (node.keywordToken) {
            case 102:
              if (escapedText !== "target") {
                return grammarErrorOnNode(node.name, ts3.Diagnostics._0_is_not_a_valid_meta_property_for_keyword_1_Did_you_mean_2, node.name.escapedText, ts3.tokenToString(node.keywordToken), "target");
              }
              break;
            case 99:
              if (escapedText !== "meta") {
                return grammarErrorOnNode(node.name, ts3.Diagnostics._0_is_not_a_valid_meta_property_for_keyword_1_Did_you_mean_2, node.name.escapedText, ts3.tokenToString(node.keywordToken), "meta");
              }
              break;
          }
        }
        function hasParseDiagnostics(sourceFile) {
          return sourceFile.parseDiagnostics.length > 0;
        }
        function grammarErrorOnFirstToken(node, message, arg0, arg1, arg2) {
          var sourceFile = ts3.getSourceFileOfNode(node);
          if (!hasParseDiagnostics(sourceFile)) {
            var span = ts3.getSpanOfTokenAtPosition(sourceFile, node.pos);
            diagnostics.add(ts3.createFileDiagnostic(sourceFile, span.start, span.length, message, arg0, arg1, arg2));
            return true;
          }
          return false;
        }
        function grammarErrorAtPos(nodeForSourceFile, start, length, message, arg0, arg1, arg2) {
          var sourceFile = ts3.getSourceFileOfNode(nodeForSourceFile);
          if (!hasParseDiagnostics(sourceFile)) {
            diagnostics.add(ts3.createFileDiagnostic(sourceFile, start, length, message, arg0, arg1, arg2));
            return true;
          }
          return false;
        }
        function grammarErrorOnNodeSkippedOn(key2, node, message, arg0, arg1, arg2) {
          var sourceFile = ts3.getSourceFileOfNode(node);
          if (!hasParseDiagnostics(sourceFile)) {
            errorSkippedOn(key2, node, message, arg0, arg1, arg2);
            return true;
          }
          return false;
        }
        function grammarErrorOnNode(node, message, arg0, arg1, arg2) {
          var sourceFile = ts3.getSourceFileOfNode(node);
          if (!hasParseDiagnostics(sourceFile)) {
            diagnostics.add(ts3.createDiagnosticForNode(node, message, arg0, arg1, arg2));
            return true;
          }
          return false;
        }
        function checkGrammarConstructorTypeParameters(node) {
          var jsdocTypeParameters = ts3.isInJSFile(node) ? ts3.getJSDocTypeParameterDeclarations(node) : void 0;
          var range = node.typeParameters || jsdocTypeParameters && ts3.firstOrUndefined(jsdocTypeParameters);
          if (range) {
            var pos = range.pos === range.end ? range.pos : ts3.skipTrivia(ts3.getSourceFileOfNode(node).text, range.pos);
            return grammarErrorAtPos(node, pos, range.end - pos, ts3.Diagnostics.Type_parameters_cannot_appear_on_a_constructor_declaration);
          }
        }
        function checkGrammarConstructorTypeAnnotation(node) {
          var type3 = ts3.getEffectiveReturnTypeNode(node);
          if (type3) {
            return grammarErrorOnNode(type3, ts3.Diagnostics.Type_annotation_cannot_appear_on_a_constructor_declaration);
          }
        }
        function checkGrammarProperty(node) {
          if (ts3.isClassLike(node.parent)) {
            if (ts3.isStringLiteral(node.name) && node.name.text === "constructor") {
              return grammarErrorOnNode(node.name, ts3.Diagnostics.Classes_may_not_have_a_field_named_constructor);
            }
            if (checkGrammarForInvalidDynamicName(node.name, ts3.Diagnostics.A_computed_property_name_in_a_class_property_declaration_must_have_a_simple_literal_type_or_a_unique_symbol_type)) {
              return true;
            }
            if (languageVersion < 2 && ts3.isPrivateIdentifier(node.name)) {
              return grammarErrorOnNode(node.name, ts3.Diagnostics.Private_identifiers_are_only_available_when_targeting_ECMAScript_2015_and_higher);
            }
          } else if (node.parent.kind === 254) {
            if (checkGrammarForInvalidDynamicName(node.name, ts3.Diagnostics.A_computed_property_name_in_an_interface_must_refer_to_an_expression_whose_type_is_a_literal_type_or_a_unique_symbol_type)) {
              return true;
            }
            if (node.initializer) {
              return grammarErrorOnNode(node.initializer, ts3.Diagnostics.An_interface_property_cannot_have_an_initializer);
            }
          } else if (node.parent.kind === 178) {
            if (checkGrammarForInvalidDynamicName(node.name, ts3.Diagnostics.A_computed_property_name_in_a_type_literal_must_refer_to_an_expression_whose_type_is_a_literal_type_or_a_unique_symbol_type)) {
              return true;
            }
            if (node.initializer) {
              return grammarErrorOnNode(node.initializer, ts3.Diagnostics.A_type_literal_property_cannot_have_an_initializer);
            }
          }
          if (node.flags & 8388608) {
            checkAmbientInitializer(node);
          }
          if (ts3.isPropertyDeclaration(node) && node.exclamationToken && (!ts3.isClassLike(node.parent) || !node.type || node.initializer || node.flags & 8388608 || ts3.hasSyntacticModifier(node, 32 | 128))) {
            var message = node.initializer ? ts3.Diagnostics.Declarations_with_initializers_cannot_also_have_definite_assignment_assertions : !node.type ? ts3.Diagnostics.Declarations_with_definite_assignment_assertions_must_also_have_type_annotations : ts3.Diagnostics.A_definite_assignment_assertion_is_not_permitted_in_this_context;
            return grammarErrorOnNode(node.exclamationToken, message);
          }
        }
        function checkGrammarTopLevelElementForRequiredDeclareModifier(node) {
          if (node.kind === 254 || node.kind === 255 || node.kind === 262 || node.kind === 261 || node.kind === 268 || node.kind === 267 || node.kind === 260 || ts3.hasSyntacticModifier(node, 2 | 1 | 512)) {
            return false;
          }
          return grammarErrorOnFirstToken(node, ts3.Diagnostics.Top_level_declarations_in_d_ts_files_must_start_with_either_a_declare_or_export_modifier);
        }
        function checkGrammarTopLevelElementsForRequiredDeclareModifier(file) {
          for (var _i = 0, _a2 = file.statements; _i < _a2.length; _i++) {
            var decl = _a2[_i];
            if (ts3.isDeclaration(decl) || decl.kind === 233) {
              if (checkGrammarTopLevelElementForRequiredDeclareModifier(decl)) {
                return true;
              }
            }
          }
          return false;
        }
        function checkGrammarSourceFile(node) {
          return !!(node.flags & 8388608) && checkGrammarTopLevelElementsForRequiredDeclareModifier(node);
        }
        function checkGrammarStatementInAmbientContext(node) {
          if (node.flags & 8388608) {
            var links = getNodeLinks(node);
            if (!links.hasReportedStatementInAmbientContext && (ts3.isFunctionLike(node.parent) || ts3.isAccessor(node.parent))) {
              return getNodeLinks(node).hasReportedStatementInAmbientContext = grammarErrorOnFirstToken(node, ts3.Diagnostics.An_implementation_cannot_be_declared_in_ambient_contexts);
            }
            if (node.parent.kind === 231 || node.parent.kind === 258 || node.parent.kind === 298) {
              var links_2 = getNodeLinks(node.parent);
              if (!links_2.hasReportedStatementInAmbientContext) {
                return links_2.hasReportedStatementInAmbientContext = grammarErrorOnFirstToken(node, ts3.Diagnostics.Statements_are_not_allowed_in_ambient_contexts);
              }
            } else {
            }
          }
          return false;
        }
        function checkGrammarNumericLiteral(node) {
          if (node.numericLiteralFlags & 32) {
            var diagnosticMessage = void 0;
            if (languageVersion >= 1) {
              diagnosticMessage = ts3.Diagnostics.Octal_literals_are_not_available_when_targeting_ECMAScript_5_and_higher_Use_the_syntax_0;
            } else if (ts3.isChildOfNodeWithKind(node, 192)) {
              diagnosticMessage = ts3.Diagnostics.Octal_literal_types_must_use_ES2015_syntax_Use_the_syntax_0;
            } else if (ts3.isChildOfNodeWithKind(node, 292)) {
              diagnosticMessage = ts3.Diagnostics.Octal_literals_are_not_allowed_in_enums_members_initializer_Use_the_syntax_0;
            }
            if (diagnosticMessage) {
              var withMinus = ts3.isPrefixUnaryExpression(node.parent) && node.parent.operator === 40;
              var literal = (withMinus ? "-" : "") + "0o" + node.text;
              return grammarErrorOnNode(withMinus ? node.parent : node, diagnosticMessage, literal);
            }
          }
          checkNumericLiteralValueSize(node);
          return false;
        }
        function checkNumericLiteralValueSize(node) {
          if (node.numericLiteralFlags & 16 || node.text.length <= 15 || node.text.indexOf(".") !== -1) {
            return;
          }
          var apparentValue = +ts3.getTextOfNode(node);
          if (apparentValue <= Math.pow(2, 53) - 1 && apparentValue + 1 > apparentValue) {
            return;
          }
          addErrorOrSuggestion(false, ts3.createDiagnosticForNode(node, ts3.Diagnostics.Numeric_literals_with_absolute_values_equal_to_2_53_or_greater_are_too_large_to_be_represented_accurately_as_integers));
        }
        function checkGrammarBigIntLiteral(node) {
          var literalType = ts3.isLiteralTypeNode(node.parent) || ts3.isPrefixUnaryExpression(node.parent) && ts3.isLiteralTypeNode(node.parent.parent);
          if (!literalType) {
            if (languageVersion < 7) {
              if (grammarErrorOnNode(node, ts3.Diagnostics.BigInt_literals_are_not_available_when_targeting_lower_than_ES2020)) {
                return true;
              }
            }
          }
          return false;
        }
        function grammarErrorAfterFirstToken(node, message, arg0, arg1, arg2) {
          var sourceFile = ts3.getSourceFileOfNode(node);
          if (!hasParseDiagnostics(sourceFile)) {
            var span = ts3.getSpanOfTokenAtPosition(sourceFile, node.pos);
            diagnostics.add(ts3.createFileDiagnostic(sourceFile, ts3.textSpanEnd(span), 0, message, arg0, arg1, arg2));
            return true;
          }
          return false;
        }
        function getAmbientModules() {
          if (!ambientModulesCache) {
            ambientModulesCache = [];
            globals.forEach(function(global2, sym) {
              if (ambientModuleSymbolRegex.test(sym)) {
                ambientModulesCache.push(global2);
              }
            });
          }
          return ambientModulesCache;
        }
        function checkGrammarImportClause(node) {
          if (node.isTypeOnly && node.name && node.namedBindings) {
            return grammarErrorOnNode(node, ts3.Diagnostics.A_type_only_import_can_specify_a_default_import_or_named_bindings_but_not_both);
          }
          return false;
        }
        function checkGrammarImportCallExpression(node) {
          if (moduleKind === ts3.ModuleKind.ES2015) {
            return grammarErrorOnNode(node, ts3.Diagnostics.Dynamic_imports_are_only_supported_when_the_module_flag_is_set_to_es2020_esnext_commonjs_amd_system_or_umd);
          }
          if (node.typeArguments) {
            return grammarErrorOnNode(node, ts3.Diagnostics.Dynamic_import_cannot_have_type_arguments);
          }
          var nodeArguments = node.arguments;
          if (nodeArguments.length !== 1) {
            return grammarErrorOnNode(node, ts3.Diagnostics.Dynamic_import_must_have_one_specifier_as_an_argument);
          }
          checkGrammarForDisallowedTrailingComma(nodeArguments);
          if (ts3.isSpreadElement(nodeArguments[0])) {
            return grammarErrorOnNode(nodeArguments[0], ts3.Diagnostics.Specifier_of_dynamic_import_cannot_be_spread_element);
          }
          return false;
        }
        function findMatchingTypeReferenceOrTypeAliasReference(source, unionTarget) {
          var sourceObjectFlags = ts3.getObjectFlags(source);
          if (sourceObjectFlags & (4 | 16) && unionTarget.flags & 1048576) {
            return ts3.find(unionTarget.types, function(target) {
              if (target.flags & 524288) {
                var overlapObjFlags = sourceObjectFlags & ts3.getObjectFlags(target);
                if (overlapObjFlags & 4) {
                  return source.target === target.target;
                }
                if (overlapObjFlags & 16) {
                  return !!source.aliasSymbol && source.aliasSymbol === target.aliasSymbol;
                }
              }
              return false;
            });
          }
        }
        function findBestTypeForObjectLiteral(source, unionTarget) {
          if (ts3.getObjectFlags(source) & 128 && someType(unionTarget, isArrayLikeType)) {
            return ts3.find(unionTarget.types, function(t2) {
              return !isArrayLikeType(t2);
            });
          }
        }
        function findBestTypeForInvokable(source, unionTarget) {
          var signatureKind = 0;
          var hasSignatures = getSignaturesOfType(source, signatureKind).length > 0 || (signatureKind = 1, getSignaturesOfType(source, signatureKind).length > 0);
          if (hasSignatures) {
            return ts3.find(unionTarget.types, function(t2) {
              return getSignaturesOfType(t2, signatureKind).length > 0;
            });
          }
        }
        function findMostOverlappyType(source, unionTarget) {
          var bestMatch;
          var matchingCount = 0;
          for (var _i = 0, _a2 = unionTarget.types; _i < _a2.length; _i++) {
            var target = _a2[_i];
            var overlap = getIntersectionType([getIndexType(source), getIndexType(target)]);
            if (overlap.flags & 4194304) {
              bestMatch = target;
              matchingCount = Infinity;
            } else if (overlap.flags & 1048576) {
              var len = ts3.length(ts3.filter(overlap.types, isUnitType));
              if (len >= matchingCount) {
                bestMatch = target;
                matchingCount = len;
              }
            } else if (isUnitType(overlap) && 1 >= matchingCount) {
              bestMatch = target;
              matchingCount = 1;
            }
          }
          return bestMatch;
        }
        function filterPrimitivesIfContainsNonPrimitive(type3) {
          if (maybeTypeOfKind(type3, 67108864)) {
            var result2 = filterType(type3, function(t2) {
              return !(t2.flags & 131068);
            });
            if (!(result2.flags & 131072)) {
              return result2;
            }
          }
          return type3;
        }
        function findMatchingDiscriminantType(source, target, isRelatedTo, skipPartial) {
          if (target.flags & 1048576 && source.flags & (2097152 | 524288)) {
            var match = getMatchingUnionConstituentForType(target, source);
            if (match) {
              return match;
            }
            var sourceProperties = getPropertiesOfType(source);
            if (sourceProperties) {
              var sourcePropertiesFiltered = findDiscriminantProperties(sourceProperties, target);
              if (sourcePropertiesFiltered) {
                return discriminateTypeByDiscriminableItems(target, ts3.map(sourcePropertiesFiltered, function(p) {
                  return [function() {
                    return getTypeOfSymbol(p);
                  }, p.escapedName];
                }), isRelatedTo, void 0, skipPartial);
              }
            }
          }
          return void 0;
        }
      }
      ts3.createTypeChecker = createTypeChecker;
      function isNotAccessor(declaration) {
        return !ts3.isAccessor(declaration);
      }
      function isNotOverload(declaration) {
        return declaration.kind !== 252 && declaration.kind !== 166 || !!declaration.body;
      }
      function isDeclarationNameOrImportPropertyName(name) {
        switch (name.parent.kind) {
          case 266:
          case 271:
            return ts3.isIdentifier(name);
          default:
            return ts3.isDeclarationName(name);
        }
      }
      var JsxNames;
      (function(JsxNames2) {
        JsxNames2.JSX = "JSX";
        JsxNames2.IntrinsicElements = "IntrinsicElements";
        JsxNames2.ElementClass = "ElementClass";
        JsxNames2.ElementAttributesPropertyNameContainer = "ElementAttributesProperty";
        JsxNames2.ElementChildrenAttributeNameContainer = "ElementChildrenAttribute";
        JsxNames2.Element = "Element";
        JsxNames2.IntrinsicAttributes = "IntrinsicAttributes";
        JsxNames2.IntrinsicClassAttributes = "IntrinsicClassAttributes";
        JsxNames2.LibraryManagedAttributes = "LibraryManagedAttributes";
      })(JsxNames || (JsxNames = {}));
      function getIterationTypesKeyFromIterationTypeKind(typeKind) {
        switch (typeKind) {
          case 0:
            return "yieldType";
          case 1:
            return "returnType";
          case 2:
            return "nextType";
        }
      }
      function signatureHasRestParameter(s2) {
        return !!(s2.flags & 1);
      }
      ts3.signatureHasRestParameter = signatureHasRestParameter;
      function signatureHasLiteralTypes(s2) {
        return !!(s2.flags & 2);
      }
      ts3.signatureHasLiteralTypes = signatureHasLiteralTypes;
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      function visitNode(node, visitor, test, lift) {
        if (node === void 0 || visitor === void 0) {
          return node;
        }
        var visited = visitor(node);
        if (visited === node) {
          return node;
        }
        var visitedNode;
        if (visited === void 0) {
          return void 0;
        } else if (ts3.isArray(visited)) {
          visitedNode = (lift || extractSingleNode)(visited);
        } else {
          visitedNode = visited;
        }
        ts3.Debug.assertNode(visitedNode, test);
        return visitedNode;
      }
      ts3.visitNode = visitNode;
      function visitNodes(nodes, visitor, test, start, count) {
        if (nodes === void 0 || visitor === void 0) {
          return nodes;
        }
        var updated;
        var length = nodes.length;
        if (start === void 0 || start < 0) {
          start = 0;
        }
        if (count === void 0 || count > length - start) {
          count = length - start;
        }
        var hasTrailingComma;
        var pos = -1;
        var end = -1;
        if (start > 0 || count < length) {
          updated = [];
          hasTrailingComma = nodes.hasTrailingComma && start + count === length;
        }
        for (var i3 = 0; i3 < count; i3++) {
          var node = nodes[i3 + start];
          var visited = node !== void 0 ? visitor(node) : void 0;
          if (updated !== void 0 || visited === void 0 || visited !== node) {
            if (updated === void 0) {
              updated = nodes.slice(0, i3);
              hasTrailingComma = nodes.hasTrailingComma;
              pos = nodes.pos;
              end = nodes.end;
            }
            if (visited) {
              if (ts3.isArray(visited)) {
                for (var _i = 0, visited_1 = visited; _i < visited_1.length; _i++) {
                  var visitedNode = visited_1[_i];
                  void ts3.Debug.assertNode(visitedNode, test);
                  updated.push(visitedNode);
                }
              } else {
                void ts3.Debug.assertNode(visited, test);
                updated.push(visited);
              }
            }
          }
        }
        if (updated) {
          var updatedArray = ts3.factory.createNodeArray(updated, hasTrailingComma);
          ts3.setTextRangePosEnd(updatedArray, pos, end);
          return updatedArray;
        }
        return nodes;
      }
      ts3.visitNodes = visitNodes;
      function visitLexicalEnvironment(statements, visitor, context, start, ensureUseStrict, nodesVisitor) {
        if (nodesVisitor === void 0) {
          nodesVisitor = visitNodes;
        }
        context.startLexicalEnvironment();
        statements = nodesVisitor(statements, visitor, ts3.isStatement, start);
        if (ensureUseStrict)
          statements = context.factory.ensureUseStrict(statements);
        return ts3.factory.mergeLexicalEnvironment(statements, context.endLexicalEnvironment());
      }
      ts3.visitLexicalEnvironment = visitLexicalEnvironment;
      function visitParameterList(nodes, visitor, context, nodesVisitor) {
        if (nodesVisitor === void 0) {
          nodesVisitor = visitNodes;
        }
        var updated;
        context.startLexicalEnvironment();
        if (nodes) {
          context.setLexicalEnvironmentFlags(1, true);
          updated = nodesVisitor(nodes, visitor, ts3.isParameterDeclaration);
          if (context.getLexicalEnvironmentFlags() & 2 && ts3.getEmitScriptTarget(context.getCompilerOptions()) >= 2) {
            updated = addDefaultValueAssignmentsIfNeeded(updated, context);
          }
          context.setLexicalEnvironmentFlags(1, false);
        }
        context.suspendLexicalEnvironment();
        return updated;
      }
      ts3.visitParameterList = visitParameterList;
      function addDefaultValueAssignmentsIfNeeded(parameters, context) {
        var result2;
        for (var i3 = 0; i3 < parameters.length; i3++) {
          var parameter = parameters[i3];
          var updated = addDefaultValueAssignmentIfNeeded(parameter, context);
          if (result2 || updated !== parameter) {
            if (!result2)
              result2 = parameters.slice(0, i3);
            result2[i3] = updated;
          }
        }
        if (result2) {
          return ts3.setTextRange(context.factory.createNodeArray(result2, parameters.hasTrailingComma), parameters);
        }
        return parameters;
      }
      function addDefaultValueAssignmentIfNeeded(parameter, context) {
        return parameter.dotDotDotToken ? parameter : ts3.isBindingPattern(parameter.name) ? addDefaultValueAssignmentForBindingPattern(parameter, context) : parameter.initializer ? addDefaultValueAssignmentForInitializer(parameter, parameter.name, parameter.initializer, context) : parameter;
      }
      function addDefaultValueAssignmentForBindingPattern(parameter, context) {
        var factory = context.factory;
        context.addInitializationStatement(factory.createVariableStatement(void 0, factory.createVariableDeclarationList([
          factory.createVariableDeclaration(parameter.name, void 0, parameter.type, parameter.initializer ? factory.createConditionalExpression(factory.createStrictEquality(factory.getGeneratedNameForNode(parameter), factory.createVoidZero()), void 0, parameter.initializer, void 0, factory.getGeneratedNameForNode(parameter)) : factory.getGeneratedNameForNode(parameter))
        ])));
        return factory.updateParameterDeclaration(parameter, parameter.decorators, parameter.modifiers, parameter.dotDotDotToken, factory.getGeneratedNameForNode(parameter), parameter.questionToken, parameter.type, void 0);
      }
      function addDefaultValueAssignmentForInitializer(parameter, name, initializer, context) {
        var factory = context.factory;
        context.addInitializationStatement(factory.createIfStatement(factory.createTypeCheck(factory.cloneNode(name), "undefined"), ts3.setEmitFlags(ts3.setTextRange(factory.createBlock([
          factory.createExpressionStatement(ts3.setEmitFlags(ts3.setTextRange(factory.createAssignment(ts3.setEmitFlags(factory.cloneNode(name), 48), ts3.setEmitFlags(initializer, 48 | ts3.getEmitFlags(initializer) | 1536)), parameter), 1536))
        ]), parameter), 1 | 32 | 384 | 1536)));
        return factory.updateParameterDeclaration(parameter, parameter.decorators, parameter.modifiers, parameter.dotDotDotToken, parameter.name, parameter.questionToken, parameter.type, void 0);
      }
      function visitFunctionBody(node, visitor, context, nodeVisitor) {
        if (nodeVisitor === void 0) {
          nodeVisitor = visitNode;
        }
        context.resumeLexicalEnvironment();
        var updated = nodeVisitor(node, visitor, ts3.isConciseBody);
        var declarations = context.endLexicalEnvironment();
        if (ts3.some(declarations)) {
          if (!updated) {
            return context.factory.createBlock(declarations);
          }
          var block = context.factory.converters.convertToFunctionBlock(updated);
          var statements = ts3.factory.mergeLexicalEnvironment(block.statements, declarations);
          return context.factory.updateBlock(block, statements);
        }
        return updated;
      }
      ts3.visitFunctionBody = visitFunctionBody;
      function visitIterationBody(body, visitor, context) {
        context.startBlockScope();
        var updated = visitNode(body, visitor, ts3.isStatement, context.factory.liftToBlock);
        var declarations = context.endBlockScope();
        if (ts3.some(declarations)) {
          if (ts3.isBlock(updated)) {
            declarations.push.apply(declarations, updated.statements);
            return context.factory.updateBlock(updated, declarations);
          }
          declarations.push(updated);
          return context.factory.createBlock(declarations);
        }
        return updated;
      }
      ts3.visitIterationBody = visitIterationBody;
      function visitEachChild(node, visitor, context, nodesVisitor, tokenVisitor, nodeVisitor) {
        if (nodesVisitor === void 0) {
          nodesVisitor = visitNodes;
        }
        if (nodeVisitor === void 0) {
          nodeVisitor = visitNode;
        }
        if (node === void 0) {
          return void 0;
        }
        var kind = node.kind;
        if (kind > 0 && kind <= 157 || kind === 188) {
          return node;
        }
        var factory = context.factory;
        switch (kind) {
          case 78:
            ts3.Debug.type(node);
            return factory.updateIdentifier(node, nodesVisitor(node.typeArguments, visitor, ts3.isTypeNodeOrTypeParameterDeclaration));
          case 158:
            ts3.Debug.type(node);
            return factory.updateQualifiedName(node, nodeVisitor(node.left, visitor, ts3.isEntityName), nodeVisitor(node.right, visitor, ts3.isIdentifier));
          case 159:
            ts3.Debug.type(node);
            return factory.updateComputedPropertyName(node, nodeVisitor(node.expression, visitor, ts3.isExpression));
          case 160:
            ts3.Debug.type(node);
            return factory.updateTypeParameterDeclaration(node, nodeVisitor(node.name, visitor, ts3.isIdentifier), nodeVisitor(node.constraint, visitor, ts3.isTypeNode), nodeVisitor(node.default, visitor, ts3.isTypeNode));
          case 161:
            ts3.Debug.type(node);
            return factory.updateParameterDeclaration(node, nodesVisitor(node.decorators, visitor, ts3.isDecorator), nodesVisitor(node.modifiers, visitor, ts3.isModifier), nodeVisitor(node.dotDotDotToken, tokenVisitor, ts3.isDotDotDotToken), nodeVisitor(node.name, visitor, ts3.isBindingName), nodeVisitor(node.questionToken, tokenVisitor, ts3.isQuestionToken), nodeVisitor(node.type, visitor, ts3.isTypeNode), nodeVisitor(node.initializer, visitor, ts3.isExpression));
          case 162:
            ts3.Debug.type(node);
            return factory.updateDecorator(node, nodeVisitor(node.expression, visitor, ts3.isExpression));
          case 163:
            ts3.Debug.type(node);
            return factory.updatePropertySignature(node, nodesVisitor(node.modifiers, visitor, ts3.isModifier), nodeVisitor(node.name, visitor, ts3.isPropertyName), nodeVisitor(node.questionToken, tokenVisitor, ts3.isToken), nodeVisitor(node.type, visitor, ts3.isTypeNode));
          case 164:
            ts3.Debug.type(node);
            return factory.updatePropertyDeclaration(node, nodesVisitor(node.decorators, visitor, ts3.isDecorator), nodesVisitor(node.modifiers, visitor, ts3.isModifier), nodeVisitor(node.name, visitor, ts3.isPropertyName), nodeVisitor(node.questionToken || node.exclamationToken, tokenVisitor, ts3.isQuestionOrExclamationToken), nodeVisitor(node.type, visitor, ts3.isTypeNode), nodeVisitor(node.initializer, visitor, ts3.isExpression));
          case 165:
            ts3.Debug.type(node);
            return factory.updateMethodSignature(node, nodesVisitor(node.modifiers, visitor, ts3.isModifier), nodeVisitor(node.name, visitor, ts3.isPropertyName), nodeVisitor(node.questionToken, tokenVisitor, ts3.isQuestionToken), nodesVisitor(node.typeParameters, visitor, ts3.isTypeParameterDeclaration), nodesVisitor(node.parameters, visitor, ts3.isParameterDeclaration), nodeVisitor(node.type, visitor, ts3.isTypeNode));
          case 166:
            ts3.Debug.type(node);
            return factory.updateMethodDeclaration(node, nodesVisitor(node.decorators, visitor, ts3.isDecorator), nodesVisitor(node.modifiers, visitor, ts3.isModifier), nodeVisitor(node.asteriskToken, tokenVisitor, ts3.isAsteriskToken), nodeVisitor(node.name, visitor, ts3.isPropertyName), nodeVisitor(node.questionToken, tokenVisitor, ts3.isQuestionToken), nodesVisitor(node.typeParameters, visitor, ts3.isTypeParameterDeclaration), visitParameterList(node.parameters, visitor, context, nodesVisitor), nodeVisitor(node.type, visitor, ts3.isTypeNode), visitFunctionBody(node.body, visitor, context, nodeVisitor));
          case 167:
            ts3.Debug.type(node);
            return factory.updateConstructorDeclaration(node, nodesVisitor(node.decorators, visitor, ts3.isDecorator), nodesVisitor(node.modifiers, visitor, ts3.isModifier), visitParameterList(node.parameters, visitor, context, nodesVisitor), visitFunctionBody(node.body, visitor, context, nodeVisitor));
          case 168:
            ts3.Debug.type(node);
            return factory.updateGetAccessorDeclaration(node, nodesVisitor(node.decorators, visitor, ts3.isDecorator), nodesVisitor(node.modifiers, visitor, ts3.isModifier), nodeVisitor(node.name, visitor, ts3.isPropertyName), visitParameterList(node.parameters, visitor, context, nodesVisitor), nodeVisitor(node.type, visitor, ts3.isTypeNode), visitFunctionBody(node.body, visitor, context, nodeVisitor));
          case 169:
            ts3.Debug.type(node);
            return factory.updateSetAccessorDeclaration(node, nodesVisitor(node.decorators, visitor, ts3.isDecorator), nodesVisitor(node.modifiers, visitor, ts3.isModifier), nodeVisitor(node.name, visitor, ts3.isPropertyName), visitParameterList(node.parameters, visitor, context, nodesVisitor), visitFunctionBody(node.body, visitor, context, nodeVisitor));
          case 170:
            ts3.Debug.type(node);
            return factory.updateCallSignature(node, nodesVisitor(node.typeParameters, visitor, ts3.isTypeParameterDeclaration), nodesVisitor(node.parameters, visitor, ts3.isParameterDeclaration), nodeVisitor(node.type, visitor, ts3.isTypeNode));
          case 171:
            ts3.Debug.type(node);
            return factory.updateConstructSignature(node, nodesVisitor(node.typeParameters, visitor, ts3.isTypeParameterDeclaration), nodesVisitor(node.parameters, visitor, ts3.isParameterDeclaration), nodeVisitor(node.type, visitor, ts3.isTypeNode));
          case 172:
            ts3.Debug.type(node);
            return factory.updateIndexSignature(node, nodesVisitor(node.decorators, visitor, ts3.isDecorator), nodesVisitor(node.modifiers, visitor, ts3.isModifier), nodesVisitor(node.parameters, visitor, ts3.isParameterDeclaration), nodeVisitor(node.type, visitor, ts3.isTypeNode));
          case 173:
            ts3.Debug.type(node);
            return factory.updateTypePredicateNode(node, nodeVisitor(node.assertsModifier, visitor, ts3.isAssertsKeyword), nodeVisitor(node.parameterName, visitor, ts3.isIdentifierOrThisTypeNode), nodeVisitor(node.type, visitor, ts3.isTypeNode));
          case 174:
            ts3.Debug.type(node);
            return factory.updateTypeReferenceNode(node, nodeVisitor(node.typeName, visitor, ts3.isEntityName), nodesVisitor(node.typeArguments, visitor, ts3.isTypeNode));
          case 175:
            ts3.Debug.type(node);
            return factory.updateFunctionTypeNode(node, nodesVisitor(node.typeParameters, visitor, ts3.isTypeParameterDeclaration), nodesVisitor(node.parameters, visitor, ts3.isParameterDeclaration), nodeVisitor(node.type, visitor, ts3.isTypeNode));
          case 176:
            ts3.Debug.type(node);
            return factory.updateConstructorTypeNode(node, nodesVisitor(node.modifiers, visitor, ts3.isModifier), nodesVisitor(node.typeParameters, visitor, ts3.isTypeParameterDeclaration), nodesVisitor(node.parameters, visitor, ts3.isParameterDeclaration), nodeVisitor(node.type, visitor, ts3.isTypeNode));
          case 177:
            ts3.Debug.type(node);
            return factory.updateTypeQueryNode(node, nodeVisitor(node.exprName, visitor, ts3.isEntityName));
          case 178:
            ts3.Debug.type(node);
            return factory.updateTypeLiteralNode(node, nodesVisitor(node.members, visitor, ts3.isTypeElement));
          case 179:
            ts3.Debug.type(node);
            return factory.updateArrayTypeNode(node, nodeVisitor(node.elementType, visitor, ts3.isTypeNode));
          case 180:
            ts3.Debug.type(node);
            return factory.updateTupleTypeNode(node, nodesVisitor(node.elements, visitor, ts3.isTypeNode));
          case 181:
            ts3.Debug.type(node);
            return factory.updateOptionalTypeNode(node, nodeVisitor(node.type, visitor, ts3.isTypeNode));
          case 182:
            ts3.Debug.type(node);
            return factory.updateRestTypeNode(node, nodeVisitor(node.type, visitor, ts3.isTypeNode));
          case 183:
            ts3.Debug.type(node);
            return factory.updateUnionTypeNode(node, nodesVisitor(node.types, visitor, ts3.isTypeNode));
          case 184:
            ts3.Debug.type(node);
            return factory.updateIntersectionTypeNode(node, nodesVisitor(node.types, visitor, ts3.isTypeNode));
          case 185:
            ts3.Debug.type(node);
            return factory.updateConditionalTypeNode(node, nodeVisitor(node.checkType, visitor, ts3.isTypeNode), nodeVisitor(node.extendsType, visitor, ts3.isTypeNode), nodeVisitor(node.trueType, visitor, ts3.isTypeNode), nodeVisitor(node.falseType, visitor, ts3.isTypeNode));
          case 186:
            ts3.Debug.type(node);
            return factory.updateInferTypeNode(node, nodeVisitor(node.typeParameter, visitor, ts3.isTypeParameterDeclaration));
          case 196:
            ts3.Debug.type(node);
            return factory.updateImportTypeNode(node, nodeVisitor(node.argument, visitor, ts3.isTypeNode), nodeVisitor(node.qualifier, visitor, ts3.isEntityName), visitNodes(node.typeArguments, visitor, ts3.isTypeNode), node.isTypeOf);
          case 193:
            ts3.Debug.type(node);
            return factory.updateNamedTupleMember(node, visitNode(node.dotDotDotToken, visitor, ts3.isDotDotDotToken), visitNode(node.name, visitor, ts3.isIdentifier), visitNode(node.questionToken, visitor, ts3.isQuestionToken), visitNode(node.type, visitor, ts3.isTypeNode));
          case 187:
            ts3.Debug.type(node);
            return factory.updateParenthesizedType(node, nodeVisitor(node.type, visitor, ts3.isTypeNode));
          case 189:
            ts3.Debug.type(node);
            return factory.updateTypeOperatorNode(node, nodeVisitor(node.type, visitor, ts3.isTypeNode));
          case 190:
            ts3.Debug.type(node);
            return factory.updateIndexedAccessTypeNode(node, nodeVisitor(node.objectType, visitor, ts3.isTypeNode), nodeVisitor(node.indexType, visitor, ts3.isTypeNode));
          case 191:
            ts3.Debug.type(node);
            return factory.updateMappedTypeNode(node, nodeVisitor(node.readonlyToken, tokenVisitor, ts3.isReadonlyKeywordOrPlusOrMinusToken), nodeVisitor(node.typeParameter, visitor, ts3.isTypeParameterDeclaration), nodeVisitor(node.nameType, visitor, ts3.isTypeNode), nodeVisitor(node.questionToken, tokenVisitor, ts3.isQuestionOrPlusOrMinusToken), nodeVisitor(node.type, visitor, ts3.isTypeNode));
          case 192:
            ts3.Debug.type(node);
            return factory.updateLiteralTypeNode(node, nodeVisitor(node.literal, visitor, ts3.isExpression));
          case 194:
            ts3.Debug.type(node);
            return factory.updateTemplateLiteralType(node, nodeVisitor(node.head, visitor, ts3.isTemplateHead), nodesVisitor(node.templateSpans, visitor, ts3.isTemplateLiteralTypeSpan));
          case 195:
            ts3.Debug.type(node);
            return factory.updateTemplateLiteralTypeSpan(node, nodeVisitor(node.type, visitor, ts3.isTypeNode), nodeVisitor(node.literal, visitor, ts3.isTemplateMiddleOrTemplateTail));
          case 197:
            ts3.Debug.type(node);
            return factory.updateObjectBindingPattern(node, nodesVisitor(node.elements, visitor, ts3.isBindingElement));
          case 198:
            ts3.Debug.type(node);
            return factory.updateArrayBindingPattern(node, nodesVisitor(node.elements, visitor, ts3.isArrayBindingElement));
          case 199:
            ts3.Debug.type(node);
            return factory.updateBindingElement(node, nodeVisitor(node.dotDotDotToken, tokenVisitor, ts3.isDotDotDotToken), nodeVisitor(node.propertyName, visitor, ts3.isPropertyName), nodeVisitor(node.name, visitor, ts3.isBindingName), nodeVisitor(node.initializer, visitor, ts3.isExpression));
          case 200:
            ts3.Debug.type(node);
            return factory.updateArrayLiteralExpression(node, nodesVisitor(node.elements, visitor, ts3.isExpression));
          case 201:
            ts3.Debug.type(node);
            return factory.updateObjectLiteralExpression(node, nodesVisitor(node.properties, visitor, ts3.isObjectLiteralElementLike));
          case 202:
            if (node.flags & 32) {
              ts3.Debug.type(node);
              return factory.updatePropertyAccessChain(node, nodeVisitor(node.expression, visitor, ts3.isExpression), nodeVisitor(node.questionDotToken, tokenVisitor, ts3.isQuestionDotToken), nodeVisitor(node.name, visitor, ts3.isMemberName));
            }
            ts3.Debug.type(node);
            return factory.updatePropertyAccessExpression(node, nodeVisitor(node.expression, visitor, ts3.isExpression), nodeVisitor(node.name, visitor, ts3.isMemberName));
          case 203:
            if (node.flags & 32) {
              ts3.Debug.type(node);
              return factory.updateElementAccessChain(node, nodeVisitor(node.expression, visitor, ts3.isExpression), nodeVisitor(node.questionDotToken, tokenVisitor, ts3.isQuestionDotToken), nodeVisitor(node.argumentExpression, visitor, ts3.isExpression));
            }
            ts3.Debug.type(node);
            return factory.updateElementAccessExpression(node, nodeVisitor(node.expression, visitor, ts3.isExpression), nodeVisitor(node.argumentExpression, visitor, ts3.isExpression));
          case 204:
            if (node.flags & 32) {
              ts3.Debug.type(node);
              return factory.updateCallChain(node, nodeVisitor(node.expression, visitor, ts3.isExpression), nodeVisitor(node.questionDotToken, tokenVisitor, ts3.isQuestionDotToken), nodesVisitor(node.typeArguments, visitor, ts3.isTypeNode), nodesVisitor(node.arguments, visitor, ts3.isExpression));
            }
            ts3.Debug.type(node);
            return factory.updateCallExpression(node, nodeVisitor(node.expression, visitor, ts3.isExpression), nodesVisitor(node.typeArguments, visitor, ts3.isTypeNode), nodesVisitor(node.arguments, visitor, ts3.isExpression));
          case 205:
            ts3.Debug.type(node);
            return factory.updateNewExpression(node, nodeVisitor(node.expression, visitor, ts3.isExpression), nodesVisitor(node.typeArguments, visitor, ts3.isTypeNode), nodesVisitor(node.arguments, visitor, ts3.isExpression));
          case 206:
            ts3.Debug.type(node);
            return factory.updateTaggedTemplateExpression(node, nodeVisitor(node.tag, visitor, ts3.isExpression), visitNodes(node.typeArguments, visitor, ts3.isTypeNode), nodeVisitor(node.template, visitor, ts3.isTemplateLiteral));
          case 207:
            ts3.Debug.type(node);
            return factory.updateTypeAssertion(node, nodeVisitor(node.type, visitor, ts3.isTypeNode), nodeVisitor(node.expression, visitor, ts3.isExpression));
          case 208:
            ts3.Debug.type(node);
            return factory.updateParenthesizedExpression(node, nodeVisitor(node.expression, visitor, ts3.isExpression));
          case 209:
            ts3.Debug.type(node);
            return factory.updateFunctionExpression(node, nodesVisitor(node.modifiers, visitor, ts3.isModifier), nodeVisitor(node.asteriskToken, tokenVisitor, ts3.isAsteriskToken), nodeVisitor(node.name, visitor, ts3.isIdentifier), nodesVisitor(node.typeParameters, visitor, ts3.isTypeParameterDeclaration), visitParameterList(node.parameters, visitor, context, nodesVisitor), nodeVisitor(node.type, visitor, ts3.isTypeNode), visitFunctionBody(node.body, visitor, context, nodeVisitor));
          case 210:
            ts3.Debug.type(node);
            return factory.updateArrowFunction(node, nodesVisitor(node.modifiers, visitor, ts3.isModifier), nodesVisitor(node.typeParameters, visitor, ts3.isTypeParameterDeclaration), visitParameterList(node.parameters, visitor, context, nodesVisitor), nodeVisitor(node.type, visitor, ts3.isTypeNode), nodeVisitor(node.equalsGreaterThanToken, tokenVisitor, ts3.isEqualsGreaterThanToken), visitFunctionBody(node.body, visitor, context, nodeVisitor));
          case 211:
            ts3.Debug.type(node);
            return factory.updateDeleteExpression(node, nodeVisitor(node.expression, visitor, ts3.isExpression));
          case 212:
            ts3.Debug.type(node);
            return factory.updateTypeOfExpression(node, nodeVisitor(node.expression, visitor, ts3.isExpression));
          case 213:
            ts3.Debug.type(node);
            return factory.updateVoidExpression(node, nodeVisitor(node.expression, visitor, ts3.isExpression));
          case 214:
            ts3.Debug.type(node);
            return factory.updateAwaitExpression(node, nodeVisitor(node.expression, visitor, ts3.isExpression));
          case 215:
            ts3.Debug.type(node);
            return factory.updatePrefixUnaryExpression(node, nodeVisitor(node.operand, visitor, ts3.isExpression));
          case 216:
            ts3.Debug.type(node);
            return factory.updatePostfixUnaryExpression(node, nodeVisitor(node.operand, visitor, ts3.isExpression));
          case 217:
            ts3.Debug.type(node);
            return factory.updateBinaryExpression(node, nodeVisitor(node.left, visitor, ts3.isExpression), nodeVisitor(node.operatorToken, tokenVisitor, ts3.isBinaryOperatorToken), nodeVisitor(node.right, visitor, ts3.isExpression));
          case 218:
            ts3.Debug.type(node);
            return factory.updateConditionalExpression(node, nodeVisitor(node.condition, visitor, ts3.isExpression), nodeVisitor(node.questionToken, tokenVisitor, ts3.isQuestionToken), nodeVisitor(node.whenTrue, visitor, ts3.isExpression), nodeVisitor(node.colonToken, tokenVisitor, ts3.isColonToken), nodeVisitor(node.whenFalse, visitor, ts3.isExpression));
          case 219:
            ts3.Debug.type(node);
            return factory.updateTemplateExpression(node, nodeVisitor(node.head, visitor, ts3.isTemplateHead), nodesVisitor(node.templateSpans, visitor, ts3.isTemplateSpan));
          case 220:
            ts3.Debug.type(node);
            return factory.updateYieldExpression(node, nodeVisitor(node.asteriskToken, tokenVisitor, ts3.isAsteriskToken), nodeVisitor(node.expression, visitor, ts3.isExpression));
          case 221:
            ts3.Debug.type(node);
            return factory.updateSpreadElement(node, nodeVisitor(node.expression, visitor, ts3.isExpression));
          case 222:
            ts3.Debug.type(node);
            return factory.updateClassExpression(node, nodesVisitor(node.decorators, visitor, ts3.isDecorator), nodesVisitor(node.modifiers, visitor, ts3.isModifier), nodeVisitor(node.name, visitor, ts3.isIdentifier), nodesVisitor(node.typeParameters, visitor, ts3.isTypeParameterDeclaration), nodesVisitor(node.heritageClauses, visitor, ts3.isHeritageClause), nodesVisitor(node.members, visitor, ts3.isClassElement));
          case 224:
            ts3.Debug.type(node);
            return factory.updateExpressionWithTypeArguments(node, nodeVisitor(node.expression, visitor, ts3.isExpression), nodesVisitor(node.typeArguments, visitor, ts3.isTypeNode));
          case 225:
            ts3.Debug.type(node);
            return factory.updateAsExpression(node, nodeVisitor(node.expression, visitor, ts3.isExpression), nodeVisitor(node.type, visitor, ts3.isTypeNode));
          case 226:
            if (node.flags & 32) {
              ts3.Debug.type(node);
              return factory.updateNonNullChain(node, nodeVisitor(node.expression, visitor, ts3.isExpression));
            }
            ts3.Debug.type(node);
            return factory.updateNonNullExpression(node, nodeVisitor(node.expression, visitor, ts3.isExpression));
          case 227:
            ts3.Debug.type(node);
            return factory.updateMetaProperty(node, nodeVisitor(node.name, visitor, ts3.isIdentifier));
          case 229:
            ts3.Debug.type(node);
            return factory.updateTemplateSpan(node, nodeVisitor(node.expression, visitor, ts3.isExpression), nodeVisitor(node.literal, visitor, ts3.isTemplateMiddleOrTemplateTail));
          case 231:
            ts3.Debug.type(node);
            return factory.updateBlock(node, nodesVisitor(node.statements, visitor, ts3.isStatement));
          case 233:
            ts3.Debug.type(node);
            return factory.updateVariableStatement(node, nodesVisitor(node.modifiers, visitor, ts3.isModifier), nodeVisitor(node.declarationList, visitor, ts3.isVariableDeclarationList));
          case 234:
            ts3.Debug.type(node);
            return factory.updateExpressionStatement(node, nodeVisitor(node.expression, visitor, ts3.isExpression));
          case 235:
            ts3.Debug.type(node);
            return factory.updateIfStatement(node, nodeVisitor(node.expression, visitor, ts3.isExpression), nodeVisitor(node.thenStatement, visitor, ts3.isStatement, factory.liftToBlock), nodeVisitor(node.elseStatement, visitor, ts3.isStatement, factory.liftToBlock));
          case 236:
            ts3.Debug.type(node);
            return factory.updateDoStatement(node, visitIterationBody(node.statement, visitor, context), nodeVisitor(node.expression, visitor, ts3.isExpression));
          case 237:
            ts3.Debug.type(node);
            return factory.updateWhileStatement(node, nodeVisitor(node.expression, visitor, ts3.isExpression), visitIterationBody(node.statement, visitor, context));
          case 238:
            ts3.Debug.type(node);
            return factory.updateForStatement(node, nodeVisitor(node.initializer, visitor, ts3.isForInitializer), nodeVisitor(node.condition, visitor, ts3.isExpression), nodeVisitor(node.incrementor, visitor, ts3.isExpression), visitIterationBody(node.statement, visitor, context));
          case 239:
            ts3.Debug.type(node);
            return factory.updateForInStatement(node, nodeVisitor(node.initializer, visitor, ts3.isForInitializer), nodeVisitor(node.expression, visitor, ts3.isExpression), visitIterationBody(node.statement, visitor, context));
          case 240:
            ts3.Debug.type(node);
            return factory.updateForOfStatement(node, nodeVisitor(node.awaitModifier, tokenVisitor, ts3.isAwaitKeyword), nodeVisitor(node.initializer, visitor, ts3.isForInitializer), nodeVisitor(node.expression, visitor, ts3.isExpression), visitIterationBody(node.statement, visitor, context));
          case 241:
            ts3.Debug.type(node);
            return factory.updateContinueStatement(node, nodeVisitor(node.label, visitor, ts3.isIdentifier));
          case 242:
            ts3.Debug.type(node);
            return factory.updateBreakStatement(node, nodeVisitor(node.label, visitor, ts3.isIdentifier));
          case 243:
            ts3.Debug.type(node);
            return factory.updateReturnStatement(node, nodeVisitor(node.expression, visitor, ts3.isExpression));
          case 244:
            ts3.Debug.type(node);
            return factory.updateWithStatement(node, nodeVisitor(node.expression, visitor, ts3.isExpression), nodeVisitor(node.statement, visitor, ts3.isStatement, factory.liftToBlock));
          case 245:
            ts3.Debug.type(node);
            return factory.updateSwitchStatement(node, nodeVisitor(node.expression, visitor, ts3.isExpression), nodeVisitor(node.caseBlock, visitor, ts3.isCaseBlock));
          case 246:
            ts3.Debug.type(node);
            return factory.updateLabeledStatement(node, nodeVisitor(node.label, visitor, ts3.isIdentifier), nodeVisitor(node.statement, visitor, ts3.isStatement, factory.liftToBlock));
          case 247:
            ts3.Debug.type(node);
            return factory.updateThrowStatement(node, nodeVisitor(node.expression, visitor, ts3.isExpression));
          case 248:
            ts3.Debug.type(node);
            return factory.updateTryStatement(node, nodeVisitor(node.tryBlock, visitor, ts3.isBlock), nodeVisitor(node.catchClause, visitor, ts3.isCatchClause), nodeVisitor(node.finallyBlock, visitor, ts3.isBlock));
          case 250:
            ts3.Debug.type(node);
            return factory.updateVariableDeclaration(node, nodeVisitor(node.name, visitor, ts3.isBindingName), nodeVisitor(node.exclamationToken, tokenVisitor, ts3.isExclamationToken), nodeVisitor(node.type, visitor, ts3.isTypeNode), nodeVisitor(node.initializer, visitor, ts3.isExpression));
          case 251:
            ts3.Debug.type(node);
            return factory.updateVariableDeclarationList(node, nodesVisitor(node.declarations, visitor, ts3.isVariableDeclaration));
          case 252:
            ts3.Debug.type(node);
            return factory.updateFunctionDeclaration(node, nodesVisitor(node.decorators, visitor, ts3.isDecorator), nodesVisitor(node.modifiers, visitor, ts3.isModifier), nodeVisitor(node.asteriskToken, tokenVisitor, ts3.isAsteriskToken), nodeVisitor(node.name, visitor, ts3.isIdentifier), nodesVisitor(node.typeParameters, visitor, ts3.isTypeParameterDeclaration), visitParameterList(node.parameters, visitor, context, nodesVisitor), nodeVisitor(node.type, visitor, ts3.isTypeNode), visitFunctionBody(node.body, visitor, context, nodeVisitor));
          case 253:
            ts3.Debug.type(node);
            return factory.updateClassDeclaration(node, nodesVisitor(node.decorators, visitor, ts3.isDecorator), nodesVisitor(node.modifiers, visitor, ts3.isModifier), nodeVisitor(node.name, visitor, ts3.isIdentifier), nodesVisitor(node.typeParameters, visitor, ts3.isTypeParameterDeclaration), nodesVisitor(node.heritageClauses, visitor, ts3.isHeritageClause), nodesVisitor(node.members, visitor, ts3.isClassElement));
          case 254:
            ts3.Debug.type(node);
            return factory.updateInterfaceDeclaration(node, nodesVisitor(node.decorators, visitor, ts3.isDecorator), nodesVisitor(node.modifiers, visitor, ts3.isModifier), nodeVisitor(node.name, visitor, ts3.isIdentifier), nodesVisitor(node.typeParameters, visitor, ts3.isTypeParameterDeclaration), nodesVisitor(node.heritageClauses, visitor, ts3.isHeritageClause), nodesVisitor(node.members, visitor, ts3.isTypeElement));
          case 255:
            ts3.Debug.type(node);
            return factory.updateTypeAliasDeclaration(node, nodesVisitor(node.decorators, visitor, ts3.isDecorator), nodesVisitor(node.modifiers, visitor, ts3.isModifier), nodeVisitor(node.name, visitor, ts3.isIdentifier), nodesVisitor(node.typeParameters, visitor, ts3.isTypeParameterDeclaration), nodeVisitor(node.type, visitor, ts3.isTypeNode));
          case 256:
            ts3.Debug.type(node);
            return factory.updateEnumDeclaration(node, nodesVisitor(node.decorators, visitor, ts3.isDecorator), nodesVisitor(node.modifiers, visitor, ts3.isModifier), nodeVisitor(node.name, visitor, ts3.isIdentifier), nodesVisitor(node.members, visitor, ts3.isEnumMember));
          case 257:
            ts3.Debug.type(node);
            return factory.updateModuleDeclaration(node, nodesVisitor(node.decorators, visitor, ts3.isDecorator), nodesVisitor(node.modifiers, visitor, ts3.isModifier), nodeVisitor(node.name, visitor, ts3.isModuleName), nodeVisitor(node.body, visitor, ts3.isModuleBody));
          case 258:
            ts3.Debug.type(node);
            return factory.updateModuleBlock(node, nodesVisitor(node.statements, visitor, ts3.isStatement));
          case 259:
            ts3.Debug.type(node);
            return factory.updateCaseBlock(node, nodesVisitor(node.clauses, visitor, ts3.isCaseOrDefaultClause));
          case 260:
            ts3.Debug.type(node);
            return factory.updateNamespaceExportDeclaration(node, nodeVisitor(node.name, visitor, ts3.isIdentifier));
          case 261:
            ts3.Debug.type(node);
            return factory.updateImportEqualsDeclaration(node, nodesVisitor(node.decorators, visitor, ts3.isDecorator), nodesVisitor(node.modifiers, visitor, ts3.isModifier), node.isTypeOnly, nodeVisitor(node.name, visitor, ts3.isIdentifier), nodeVisitor(node.moduleReference, visitor, ts3.isModuleReference));
          case 262:
            ts3.Debug.type(node);
            return factory.updateImportDeclaration(node, nodesVisitor(node.decorators, visitor, ts3.isDecorator), nodesVisitor(node.modifiers, visitor, ts3.isModifier), nodeVisitor(node.importClause, visitor, ts3.isImportClause), nodeVisitor(node.moduleSpecifier, visitor, ts3.isExpression));
          case 263:
            ts3.Debug.type(node);
            return factory.updateImportClause(node, node.isTypeOnly, nodeVisitor(node.name, visitor, ts3.isIdentifier), nodeVisitor(node.namedBindings, visitor, ts3.isNamedImportBindings));
          case 264:
            ts3.Debug.type(node);
            return factory.updateNamespaceImport(node, nodeVisitor(node.name, visitor, ts3.isIdentifier));
          case 270:
            ts3.Debug.type(node);
            return factory.updateNamespaceExport(node, nodeVisitor(node.name, visitor, ts3.isIdentifier));
          case 265:
            ts3.Debug.type(node);
            return factory.updateNamedImports(node, nodesVisitor(node.elements, visitor, ts3.isImportSpecifier));
          case 266:
            ts3.Debug.type(node);
            return factory.updateImportSpecifier(node, nodeVisitor(node.propertyName, visitor, ts3.isIdentifier), nodeVisitor(node.name, visitor, ts3.isIdentifier));
          case 267:
            ts3.Debug.type(node);
            return factory.updateExportAssignment(node, nodesVisitor(node.decorators, visitor, ts3.isDecorator), nodesVisitor(node.modifiers, visitor, ts3.isModifier), nodeVisitor(node.expression, visitor, ts3.isExpression));
          case 268:
            ts3.Debug.type(node);
            return factory.updateExportDeclaration(node, nodesVisitor(node.decorators, visitor, ts3.isDecorator), nodesVisitor(node.modifiers, visitor, ts3.isModifier), node.isTypeOnly, nodeVisitor(node.exportClause, visitor, ts3.isNamedExportBindings), nodeVisitor(node.moduleSpecifier, visitor, ts3.isExpression));
          case 269:
            ts3.Debug.type(node);
            return factory.updateNamedExports(node, nodesVisitor(node.elements, visitor, ts3.isExportSpecifier));
          case 271:
            ts3.Debug.type(node);
            return factory.updateExportSpecifier(node, nodeVisitor(node.propertyName, visitor, ts3.isIdentifier), nodeVisitor(node.name, visitor, ts3.isIdentifier));
          case 273:
            ts3.Debug.type(node);
            return factory.updateExternalModuleReference(node, nodeVisitor(node.expression, visitor, ts3.isExpression));
          case 274:
            ts3.Debug.type(node);
            return factory.updateJsxElement(node, nodeVisitor(node.openingElement, visitor, ts3.isJsxOpeningElement), nodesVisitor(node.children, visitor, ts3.isJsxChild), nodeVisitor(node.closingElement, visitor, ts3.isJsxClosingElement));
          case 275:
            ts3.Debug.type(node);
            return factory.updateJsxSelfClosingElement(node, nodeVisitor(node.tagName, visitor, ts3.isJsxTagNameExpression), nodesVisitor(node.typeArguments, visitor, ts3.isTypeNode), nodeVisitor(node.attributes, visitor, ts3.isJsxAttributes));
          case 276:
            ts3.Debug.type(node);
            return factory.updateJsxOpeningElement(node, nodeVisitor(node.tagName, visitor, ts3.isJsxTagNameExpression), nodesVisitor(node.typeArguments, visitor, ts3.isTypeNode), nodeVisitor(node.attributes, visitor, ts3.isJsxAttributes));
          case 277:
            ts3.Debug.type(node);
            return factory.updateJsxClosingElement(node, nodeVisitor(node.tagName, visitor, ts3.isJsxTagNameExpression));
          case 278:
            ts3.Debug.type(node);
            return factory.updateJsxFragment(node, nodeVisitor(node.openingFragment, visitor, ts3.isJsxOpeningFragment), nodesVisitor(node.children, visitor, ts3.isJsxChild), nodeVisitor(node.closingFragment, visitor, ts3.isJsxClosingFragment));
          case 281:
            ts3.Debug.type(node);
            return factory.updateJsxAttribute(node, nodeVisitor(node.name, visitor, ts3.isIdentifier), nodeVisitor(node.initializer, visitor, ts3.isStringLiteralOrJsxExpression));
          case 282:
            ts3.Debug.type(node);
            return factory.updateJsxAttributes(node, nodesVisitor(node.properties, visitor, ts3.isJsxAttributeLike));
          case 283:
            ts3.Debug.type(node);
            return factory.updateJsxSpreadAttribute(node, nodeVisitor(node.expression, visitor, ts3.isExpression));
          case 284:
            ts3.Debug.type(node);
            return factory.updateJsxExpression(node, nodeVisitor(node.expression, visitor, ts3.isExpression));
          case 285:
            ts3.Debug.type(node);
            return factory.updateCaseClause(node, nodeVisitor(node.expression, visitor, ts3.isExpression), nodesVisitor(node.statements, visitor, ts3.isStatement));
          case 286:
            ts3.Debug.type(node);
            return factory.updateDefaultClause(node, nodesVisitor(node.statements, visitor, ts3.isStatement));
          case 287:
            ts3.Debug.type(node);
            return factory.updateHeritageClause(node, nodesVisitor(node.types, visitor, ts3.isExpressionWithTypeArguments));
          case 288:
            ts3.Debug.type(node);
            return factory.updateCatchClause(node, nodeVisitor(node.variableDeclaration, visitor, ts3.isVariableDeclaration), nodeVisitor(node.block, visitor, ts3.isBlock));
          case 289:
            ts3.Debug.type(node);
            return factory.updatePropertyAssignment(node, nodeVisitor(node.name, visitor, ts3.isPropertyName), nodeVisitor(node.initializer, visitor, ts3.isExpression));
          case 290:
            ts3.Debug.type(node);
            return factory.updateShorthandPropertyAssignment(node, nodeVisitor(node.name, visitor, ts3.isIdentifier), nodeVisitor(node.objectAssignmentInitializer, visitor, ts3.isExpression));
          case 291:
            ts3.Debug.type(node);
            return factory.updateSpreadAssignment(node, nodeVisitor(node.expression, visitor, ts3.isExpression));
          case 292:
            ts3.Debug.type(node);
            return factory.updateEnumMember(node, nodeVisitor(node.name, visitor, ts3.isPropertyName), nodeVisitor(node.initializer, visitor, ts3.isExpression));
          case 298:
            ts3.Debug.type(node);
            return factory.updateSourceFile(node, visitLexicalEnvironment(node.statements, visitor, context));
          case 340:
            ts3.Debug.type(node);
            return factory.updatePartiallyEmittedExpression(node, nodeVisitor(node.expression, visitor, ts3.isExpression));
          case 341:
            ts3.Debug.type(node);
            return factory.updateCommaListExpression(node, nodesVisitor(node.elements, visitor, ts3.isExpression));
          default:
            return node;
        }
      }
      ts3.visitEachChild = visitEachChild;
      function extractSingleNode(nodes) {
        ts3.Debug.assert(nodes.length <= 1, "Too many nodes written to output.");
        return ts3.singleOrUndefined(nodes);
      }
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      function createSourceMapGenerator(host, file, sourceRoot, sourcesDirectoryPath, generatorOptions) {
        var _a2 = generatorOptions.extendedDiagnostics ? ts3.performance.createTimer("Source Map", "beforeSourcemap", "afterSourcemap") : ts3.performance.nullTimer, enter = _a2.enter, exit2 = _a2.exit;
        var rawSources = [];
        var sources = [];
        var sourceToSourceIndexMap = new ts3.Map();
        var sourcesContent;
        var names = [];
        var nameToNameIndexMap;
        var mappings = "";
        var lastGeneratedLine = 0;
        var lastGeneratedCharacter = 0;
        var lastSourceIndex = 0;
        var lastSourceLine = 0;
        var lastSourceCharacter = 0;
        var lastNameIndex = 0;
        var hasLast = false;
        var pendingGeneratedLine = 0;
        var pendingGeneratedCharacter = 0;
        var pendingSourceIndex = 0;
        var pendingSourceLine = 0;
        var pendingSourceCharacter = 0;
        var pendingNameIndex = 0;
        var hasPending = false;
        var hasPendingSource = false;
        var hasPendingName = false;
        return {
          getSources: function() {
            return rawSources;
          },
          addSource,
          setSourceContent,
          addName,
          addMapping,
          appendSourceMap,
          toJSON,
          toString: function() {
            return JSON.stringify(toJSON());
          }
        };
        function addSource(fileName) {
          enter();
          var source = ts3.getRelativePathToDirectoryOrUrl(sourcesDirectoryPath, fileName, host.getCurrentDirectory(), host.getCanonicalFileName, true);
          var sourceIndex = sourceToSourceIndexMap.get(source);
          if (sourceIndex === void 0) {
            sourceIndex = sources.length;
            sources.push(source);
            rawSources.push(fileName);
            sourceToSourceIndexMap.set(source, sourceIndex);
          }
          exit2();
          return sourceIndex;
        }
        function setSourceContent(sourceIndex, content) {
          enter();
          if (content !== null) {
            if (!sourcesContent)
              sourcesContent = [];
            while (sourcesContent.length < sourceIndex) {
              sourcesContent.push(null);
            }
            sourcesContent[sourceIndex] = content;
          }
          exit2();
        }
        function addName(name) {
          enter();
          if (!nameToNameIndexMap)
            nameToNameIndexMap = new ts3.Map();
          var nameIndex = nameToNameIndexMap.get(name);
          if (nameIndex === void 0) {
            nameIndex = names.length;
            names.push(name);
            nameToNameIndexMap.set(name, nameIndex);
          }
          exit2();
          return nameIndex;
        }
        function isNewGeneratedPosition(generatedLine, generatedCharacter) {
          return !hasPending || pendingGeneratedLine !== generatedLine || pendingGeneratedCharacter !== generatedCharacter;
        }
        function isBacktrackingSourcePosition(sourceIndex, sourceLine, sourceCharacter) {
          return sourceIndex !== void 0 && sourceLine !== void 0 && sourceCharacter !== void 0 && pendingSourceIndex === sourceIndex && (pendingSourceLine > sourceLine || pendingSourceLine === sourceLine && pendingSourceCharacter > sourceCharacter);
        }
        function addMapping(generatedLine, generatedCharacter, sourceIndex, sourceLine, sourceCharacter, nameIndex) {
          ts3.Debug.assert(generatedLine >= pendingGeneratedLine, "generatedLine cannot backtrack");
          ts3.Debug.assert(generatedCharacter >= 0, "generatedCharacter cannot be negative");
          ts3.Debug.assert(sourceIndex === void 0 || sourceIndex >= 0, "sourceIndex cannot be negative");
          ts3.Debug.assert(sourceLine === void 0 || sourceLine >= 0, "sourceLine cannot be negative");
          ts3.Debug.assert(sourceCharacter === void 0 || sourceCharacter >= 0, "sourceCharacter cannot be negative");
          enter();
          if (isNewGeneratedPosition(generatedLine, generatedCharacter) || isBacktrackingSourcePosition(sourceIndex, sourceLine, sourceCharacter)) {
            commitPendingMapping();
            pendingGeneratedLine = generatedLine;
            pendingGeneratedCharacter = generatedCharacter;
            hasPendingSource = false;
            hasPendingName = false;
            hasPending = true;
          }
          if (sourceIndex !== void 0 && sourceLine !== void 0 && sourceCharacter !== void 0) {
            pendingSourceIndex = sourceIndex;
            pendingSourceLine = sourceLine;
            pendingSourceCharacter = sourceCharacter;
            hasPendingSource = true;
            if (nameIndex !== void 0) {
              pendingNameIndex = nameIndex;
              hasPendingName = true;
            }
          }
          exit2();
        }
        function appendSourceMap(generatedLine, generatedCharacter, map2, sourceMapPath, start, end) {
          ts3.Debug.assert(generatedLine >= pendingGeneratedLine, "generatedLine cannot backtrack");
          ts3.Debug.assert(generatedCharacter >= 0, "generatedCharacter cannot be negative");
          enter();
          var sourceIndexToNewSourceIndexMap = [];
          var nameIndexToNewNameIndexMap;
          var mappingIterator = decodeMappings(map2.mappings);
          for (var iterResult = mappingIterator.next(); !iterResult.done; iterResult = mappingIterator.next()) {
            var raw = iterResult.value;
            if (end && (raw.generatedLine > end.line || raw.generatedLine === end.line && raw.generatedCharacter > end.character)) {
              break;
            }
            if (start && (raw.generatedLine < start.line || start.line === raw.generatedLine && raw.generatedCharacter < start.character)) {
              continue;
            }
            var newSourceIndex = void 0;
            var newSourceLine = void 0;
            var newSourceCharacter = void 0;
            var newNameIndex = void 0;
            if (raw.sourceIndex !== void 0) {
              newSourceIndex = sourceIndexToNewSourceIndexMap[raw.sourceIndex];
              if (newSourceIndex === void 0) {
                var rawPath = map2.sources[raw.sourceIndex];
                var relativePath = map2.sourceRoot ? ts3.combinePaths(map2.sourceRoot, rawPath) : rawPath;
                var combinedPath = ts3.combinePaths(ts3.getDirectoryPath(sourceMapPath), relativePath);
                sourceIndexToNewSourceIndexMap[raw.sourceIndex] = newSourceIndex = addSource(combinedPath);
                if (map2.sourcesContent && typeof map2.sourcesContent[raw.sourceIndex] === "string") {
                  setSourceContent(newSourceIndex, map2.sourcesContent[raw.sourceIndex]);
                }
              }
              newSourceLine = raw.sourceLine;
              newSourceCharacter = raw.sourceCharacter;
              if (map2.names && raw.nameIndex !== void 0) {
                if (!nameIndexToNewNameIndexMap)
                  nameIndexToNewNameIndexMap = [];
                newNameIndex = nameIndexToNewNameIndexMap[raw.nameIndex];
                if (newNameIndex === void 0) {
                  nameIndexToNewNameIndexMap[raw.nameIndex] = newNameIndex = addName(map2.names[raw.nameIndex]);
                }
              }
            }
            var rawGeneratedLine = raw.generatedLine - (start ? start.line : 0);
            var newGeneratedLine = rawGeneratedLine + generatedLine;
            var rawGeneratedCharacter = start && start.line === raw.generatedLine ? raw.generatedCharacter - start.character : raw.generatedCharacter;
            var newGeneratedCharacter = rawGeneratedLine === 0 ? rawGeneratedCharacter + generatedCharacter : rawGeneratedCharacter;
            addMapping(newGeneratedLine, newGeneratedCharacter, newSourceIndex, newSourceLine, newSourceCharacter, newNameIndex);
          }
          exit2();
        }
        function shouldCommitMapping() {
          return !hasLast || lastGeneratedLine !== pendingGeneratedLine || lastGeneratedCharacter !== pendingGeneratedCharacter || lastSourceIndex !== pendingSourceIndex || lastSourceLine !== pendingSourceLine || lastSourceCharacter !== pendingSourceCharacter || lastNameIndex !== pendingNameIndex;
        }
        function commitPendingMapping() {
          if (!hasPending || !shouldCommitMapping()) {
            return;
          }
          enter();
          if (lastGeneratedLine < pendingGeneratedLine) {
            do {
              mappings += ";";
              lastGeneratedLine++;
              lastGeneratedCharacter = 0;
            } while (lastGeneratedLine < pendingGeneratedLine);
          } else {
            ts3.Debug.assertEqual(lastGeneratedLine, pendingGeneratedLine, "generatedLine cannot backtrack");
            if (hasLast) {
              mappings += ",";
            }
          }
          mappings += base64VLQFormatEncode(pendingGeneratedCharacter - lastGeneratedCharacter);
          lastGeneratedCharacter = pendingGeneratedCharacter;
          if (hasPendingSource) {
            mappings += base64VLQFormatEncode(pendingSourceIndex - lastSourceIndex);
            lastSourceIndex = pendingSourceIndex;
            mappings += base64VLQFormatEncode(pendingSourceLine - lastSourceLine);
            lastSourceLine = pendingSourceLine;
            mappings += base64VLQFormatEncode(pendingSourceCharacter - lastSourceCharacter);
            lastSourceCharacter = pendingSourceCharacter;
            if (hasPendingName) {
              mappings += base64VLQFormatEncode(pendingNameIndex - lastNameIndex);
              lastNameIndex = pendingNameIndex;
            }
          }
          hasLast = true;
          exit2();
        }
        function toJSON() {
          commitPendingMapping();
          return {
            version: 3,
            file,
            sourceRoot,
            sources,
            names,
            mappings,
            sourcesContent
          };
        }
      }
      ts3.createSourceMapGenerator = createSourceMapGenerator;
      var sourceMapCommentRegExp = /^\/\/[@#] source[M]appingURL=(.+)\s*$/;
      var whitespaceOrMapCommentRegExp = /^\s*(\/\/[@#] .*)?$/;
      function getLineInfo(text, lineStarts) {
        return {
          getLineCount: function() {
            return lineStarts.length;
          },
          getLineText: function(line) {
            return text.substring(lineStarts[line], lineStarts[line + 1]);
          }
        };
      }
      ts3.getLineInfo = getLineInfo;
      function tryGetSourceMappingURL(lineInfo) {
        for (var index = lineInfo.getLineCount() - 1; index >= 0; index--) {
          var line = lineInfo.getLineText(index);
          var comment = sourceMapCommentRegExp.exec(line);
          if (comment) {
            return comment[1];
          } else if (!line.match(whitespaceOrMapCommentRegExp)) {
            break;
          }
        }
      }
      ts3.tryGetSourceMappingURL = tryGetSourceMappingURL;
      function isStringOrNull(x) {
        return typeof x === "string" || x === null;
      }
      function isRawSourceMap(x) {
        return x !== null && typeof x === "object" && x.version === 3 && typeof x.file === "string" && typeof x.mappings === "string" && ts3.isArray(x.sources) && ts3.every(x.sources, ts3.isString) && (x.sourceRoot === void 0 || x.sourceRoot === null || typeof x.sourceRoot === "string") && (x.sourcesContent === void 0 || x.sourcesContent === null || ts3.isArray(x.sourcesContent) && ts3.every(x.sourcesContent, isStringOrNull)) && (x.names === void 0 || x.names === null || ts3.isArray(x.names) && ts3.every(x.names, ts3.isString));
      }
      ts3.isRawSourceMap = isRawSourceMap;
      function tryParseRawSourceMap(text) {
        try {
          var parsed = JSON.parse(text);
          if (isRawSourceMap(parsed)) {
            return parsed;
          }
        } catch (_a2) {
        }
        return void 0;
      }
      ts3.tryParseRawSourceMap = tryParseRawSourceMap;
      function decodeMappings(mappings) {
        var done = false;
        var pos = 0;
        var generatedLine = 0;
        var generatedCharacter = 0;
        var sourceIndex = 0;
        var sourceLine = 0;
        var sourceCharacter = 0;
        var nameIndex = 0;
        var error;
        return {
          get pos() {
            return pos;
          },
          get error() {
            return error;
          },
          get state() {
            return captureMapping(true, true);
          },
          next: function() {
            while (!done && pos < mappings.length) {
              var ch = mappings.charCodeAt(pos);
              if (ch === 59) {
                generatedLine++;
                generatedCharacter = 0;
                pos++;
                continue;
              }
              if (ch === 44) {
                pos++;
                continue;
              }
              var hasSource = false;
              var hasName = false;
              generatedCharacter += base64VLQFormatDecode();
              if (hasReportedError())
                return stopIterating();
              if (generatedCharacter < 0)
                return setErrorAndStopIterating("Invalid generatedCharacter found");
              if (!isSourceMappingSegmentEnd()) {
                hasSource = true;
                sourceIndex += base64VLQFormatDecode();
                if (hasReportedError())
                  return stopIterating();
                if (sourceIndex < 0)
                  return setErrorAndStopIterating("Invalid sourceIndex found");
                if (isSourceMappingSegmentEnd())
                  return setErrorAndStopIterating("Unsupported Format: No entries after sourceIndex");
                sourceLine += base64VLQFormatDecode();
                if (hasReportedError())
                  return stopIterating();
                if (sourceLine < 0)
                  return setErrorAndStopIterating("Invalid sourceLine found");
                if (isSourceMappingSegmentEnd())
                  return setErrorAndStopIterating("Unsupported Format: No entries after sourceLine");
                sourceCharacter += base64VLQFormatDecode();
                if (hasReportedError())
                  return stopIterating();
                if (sourceCharacter < 0)
                  return setErrorAndStopIterating("Invalid sourceCharacter found");
                if (!isSourceMappingSegmentEnd()) {
                  hasName = true;
                  nameIndex += base64VLQFormatDecode();
                  if (hasReportedError())
                    return stopIterating();
                  if (nameIndex < 0)
                    return setErrorAndStopIterating("Invalid nameIndex found");
                  if (!isSourceMappingSegmentEnd())
                    return setErrorAndStopIterating("Unsupported Error Format: Entries after nameIndex");
                }
              }
              return { value: captureMapping(hasSource, hasName), done };
            }
            return stopIterating();
          }
        };
        function captureMapping(hasSource, hasName) {
          return {
            generatedLine,
            generatedCharacter,
            sourceIndex: hasSource ? sourceIndex : void 0,
            sourceLine: hasSource ? sourceLine : void 0,
            sourceCharacter: hasSource ? sourceCharacter : void 0,
            nameIndex: hasName ? nameIndex : void 0
          };
        }
        function stopIterating() {
          done = true;
          return { value: void 0, done: true };
        }
        function setError(message) {
          if (error === void 0) {
            error = message;
          }
        }
        function setErrorAndStopIterating(message) {
          setError(message);
          return stopIterating();
        }
        function hasReportedError() {
          return error !== void 0;
        }
        function isSourceMappingSegmentEnd() {
          return pos === mappings.length || mappings.charCodeAt(pos) === 44 || mappings.charCodeAt(pos) === 59;
        }
        function base64VLQFormatDecode() {
          var moreDigits = true;
          var shiftCount = 0;
          var value = 0;
          for (; moreDigits; pos++) {
            if (pos >= mappings.length)
              return setError("Error in decoding base64VLQFormatDecode, past the mapping string"), -1;
            var currentByte = base64FormatDecode(mappings.charCodeAt(pos));
            if (currentByte === -1)
              return setError("Invalid character in VLQ"), -1;
            moreDigits = (currentByte & 32) !== 0;
            value = value | (currentByte & 31) << shiftCount;
            shiftCount += 5;
          }
          if ((value & 1) === 0) {
            value = value >> 1;
          } else {
            value = value >> 1;
            value = -value;
          }
          return value;
        }
      }
      ts3.decodeMappings = decodeMappings;
      function sameMapping(left, right) {
        return left === right || left.generatedLine === right.generatedLine && left.generatedCharacter === right.generatedCharacter && left.sourceIndex === right.sourceIndex && left.sourceLine === right.sourceLine && left.sourceCharacter === right.sourceCharacter && left.nameIndex === right.nameIndex;
      }
      ts3.sameMapping = sameMapping;
      function isSourceMapping(mapping) {
        return mapping.sourceIndex !== void 0 && mapping.sourceLine !== void 0 && mapping.sourceCharacter !== void 0;
      }
      ts3.isSourceMapping = isSourceMapping;
      function base64FormatEncode(value) {
        return value >= 0 && value < 26 ? 65 + value : value >= 26 && value < 52 ? 97 + value - 26 : value >= 52 && value < 62 ? 48 + value - 52 : value === 62 ? 43 : value === 63 ? 47 : ts3.Debug.fail(value + ": not a base64 value");
      }
      function base64FormatDecode(ch) {
        return ch >= 65 && ch <= 90 ? ch - 65 : ch >= 97 && ch <= 122 ? ch - 97 + 26 : ch >= 48 && ch <= 57 ? ch - 48 + 52 : ch === 43 ? 62 : ch === 47 ? 63 : -1;
      }
      function base64VLQFormatEncode(inValue) {
        if (inValue < 0) {
          inValue = (-inValue << 1) + 1;
        } else {
          inValue = inValue << 1;
        }
        var encodedStr = "";
        do {
          var currentDigit = inValue & 31;
          inValue = inValue >> 5;
          if (inValue > 0) {
            currentDigit = currentDigit | 32;
          }
          encodedStr = encodedStr + String.fromCharCode(base64FormatEncode(currentDigit));
        } while (inValue > 0);
        return encodedStr;
      }
      function isSourceMappedPosition(value) {
        return value.sourceIndex !== void 0 && value.sourcePosition !== void 0;
      }
      function sameMappedPosition(left, right) {
        return left.generatedPosition === right.generatedPosition && left.sourceIndex === right.sourceIndex && left.sourcePosition === right.sourcePosition;
      }
      function compareSourcePositions(left, right) {
        ts3.Debug.assert(left.sourceIndex === right.sourceIndex);
        return ts3.compareValues(left.sourcePosition, right.sourcePosition);
      }
      function compareGeneratedPositions(left, right) {
        return ts3.compareValues(left.generatedPosition, right.generatedPosition);
      }
      function getSourcePositionOfMapping(value) {
        return value.sourcePosition;
      }
      function getGeneratedPositionOfMapping(value) {
        return value.generatedPosition;
      }
      function createDocumentPositionMapper(host, map2, mapPath) {
        var mapDirectory = ts3.getDirectoryPath(mapPath);
        var sourceRoot = map2.sourceRoot ? ts3.getNormalizedAbsolutePath(map2.sourceRoot, mapDirectory) : mapDirectory;
        var generatedAbsoluteFilePath = ts3.getNormalizedAbsolutePath(map2.file, mapDirectory);
        var generatedFile = host.getSourceFileLike(generatedAbsoluteFilePath);
        var sourceFileAbsolutePaths = map2.sources.map(function(source) {
          return ts3.getNormalizedAbsolutePath(source, sourceRoot);
        });
        var sourceToSourceIndexMap = new ts3.Map(sourceFileAbsolutePaths.map(function(source, i3) {
          return [host.getCanonicalFileName(source), i3];
        }));
        var decodedMappings;
        var generatedMappings;
        var sourceMappings;
        return {
          getSourcePosition,
          getGeneratedPosition
        };
        function processMapping(mapping) {
          var generatedPosition = generatedFile !== void 0 ? ts3.getPositionOfLineAndCharacter(generatedFile, mapping.generatedLine, mapping.generatedCharacter, true) : -1;
          var source;
          var sourcePosition;
          if (isSourceMapping(mapping)) {
            var sourceFile = host.getSourceFileLike(sourceFileAbsolutePaths[mapping.sourceIndex]);
            source = map2.sources[mapping.sourceIndex];
            sourcePosition = sourceFile !== void 0 ? ts3.getPositionOfLineAndCharacter(sourceFile, mapping.sourceLine, mapping.sourceCharacter, true) : -1;
          }
          return {
            generatedPosition,
            source,
            sourceIndex: mapping.sourceIndex,
            sourcePosition,
            nameIndex: mapping.nameIndex
          };
        }
        function getDecodedMappings() {
          if (decodedMappings === void 0) {
            var decoder2 = decodeMappings(map2.mappings);
            var mappings = ts3.arrayFrom(decoder2, processMapping);
            if (decoder2.error !== void 0) {
              if (host.log) {
                host.log("Encountered error while decoding sourcemap: " + decoder2.error);
              }
              decodedMappings = ts3.emptyArray;
            } else {
              decodedMappings = mappings;
            }
          }
          return decodedMappings;
        }
        function getSourceMappings(sourceIndex) {
          if (sourceMappings === void 0) {
            var lists = [];
            for (var _i = 0, _a2 = getDecodedMappings(); _i < _a2.length; _i++) {
              var mapping = _a2[_i];
              if (!isSourceMappedPosition(mapping))
                continue;
              var list = lists[mapping.sourceIndex];
              if (!list)
                lists[mapping.sourceIndex] = list = [];
              list.push(mapping);
            }
            sourceMappings = lists.map(function(list2) {
              return ts3.sortAndDeduplicate(list2, compareSourcePositions, sameMappedPosition);
            });
          }
          return sourceMappings[sourceIndex];
        }
        function getGeneratedMappings() {
          if (generatedMappings === void 0) {
            var list = [];
            for (var _i = 0, _a2 = getDecodedMappings(); _i < _a2.length; _i++) {
              var mapping = _a2[_i];
              list.push(mapping);
            }
            generatedMappings = ts3.sortAndDeduplicate(list, compareGeneratedPositions, sameMappedPosition);
          }
          return generatedMappings;
        }
        function getGeneratedPosition(loc) {
          var sourceIndex = sourceToSourceIndexMap.get(host.getCanonicalFileName(loc.fileName));
          if (sourceIndex === void 0)
            return loc;
          var sourceMappings2 = getSourceMappings(sourceIndex);
          if (!ts3.some(sourceMappings2))
            return loc;
          var targetIndex = ts3.binarySearchKey(sourceMappings2, loc.pos, getSourcePositionOfMapping, ts3.compareValues);
          if (targetIndex < 0) {
            targetIndex = ~targetIndex;
          }
          var mapping = sourceMappings2[targetIndex];
          if (mapping === void 0 || mapping.sourceIndex !== sourceIndex) {
            return loc;
          }
          return { fileName: generatedAbsoluteFilePath, pos: mapping.generatedPosition };
        }
        function getSourcePosition(loc) {
          var generatedMappings2 = getGeneratedMappings();
          if (!ts3.some(generatedMappings2))
            return loc;
          var targetIndex = ts3.binarySearchKey(generatedMappings2, loc.pos, getGeneratedPositionOfMapping, ts3.compareValues);
          if (targetIndex < 0) {
            targetIndex = ~targetIndex;
          }
          var mapping = generatedMappings2[targetIndex];
          if (mapping === void 0 || !isSourceMappedPosition(mapping)) {
            return loc;
          }
          return { fileName: sourceFileAbsolutePaths[mapping.sourceIndex], pos: mapping.sourcePosition };
        }
      }
      ts3.createDocumentPositionMapper = createDocumentPositionMapper;
      ts3.identitySourceMapConsumer = {
        getSourcePosition: ts3.identity,
        getGeneratedPosition: ts3.identity
      };
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      function getOriginalNodeId(node) {
        node = ts3.getOriginalNode(node);
        return node ? ts3.getNodeId(node) : 0;
      }
      ts3.getOriginalNodeId = getOriginalNodeId;
      function containsDefaultReference(node) {
        if (!node)
          return false;
        if (!ts3.isNamedImports(node))
          return false;
        return ts3.some(node.elements, isNamedDefaultReference);
      }
      function isNamedDefaultReference(e2) {
        return e2.propertyName !== void 0 && e2.propertyName.escapedText === "default";
      }
      function chainBundle(context, transformSourceFile) {
        return transformSourceFileOrBundle;
        function transformSourceFileOrBundle(node) {
          return node.kind === 298 ? transformSourceFile(node) : transformBundle(node);
        }
        function transformBundle(node) {
          return context.factory.createBundle(ts3.map(node.sourceFiles, transformSourceFile), node.prepends);
        }
      }
      ts3.chainBundle = chainBundle;
      function getExportNeedsImportStarHelper(node) {
        return !!ts3.getNamespaceDeclarationNode(node);
      }
      ts3.getExportNeedsImportStarHelper = getExportNeedsImportStarHelper;
      function getImportNeedsImportStarHelper(node) {
        if (!!ts3.getNamespaceDeclarationNode(node)) {
          return true;
        }
        var bindings = node.importClause && node.importClause.namedBindings;
        if (!bindings) {
          return false;
        }
        if (!ts3.isNamedImports(bindings))
          return false;
        var defaultRefCount = 0;
        for (var _i = 0, _a2 = bindings.elements; _i < _a2.length; _i++) {
          var binding = _a2[_i];
          if (isNamedDefaultReference(binding)) {
            defaultRefCount++;
          }
        }
        return defaultRefCount > 0 && defaultRefCount !== bindings.elements.length || !!(bindings.elements.length - defaultRefCount) && ts3.isDefaultImport(node);
      }
      ts3.getImportNeedsImportStarHelper = getImportNeedsImportStarHelper;
      function getImportNeedsImportDefaultHelper(node) {
        return !getImportNeedsImportStarHelper(node) && (ts3.isDefaultImport(node) || !!node.importClause && ts3.isNamedImports(node.importClause.namedBindings) && containsDefaultReference(node.importClause.namedBindings));
      }
      ts3.getImportNeedsImportDefaultHelper = getImportNeedsImportDefaultHelper;
      function collectExternalModuleInfo(context, sourceFile, resolver, compilerOptions) {
        var externalImports = [];
        var exportSpecifiers = ts3.createMultiMap();
        var exportedBindings = [];
        var uniqueExports = new ts3.Map();
        var exportedNames;
        var hasExportDefault = false;
        var exportEquals;
        var hasExportStarsToExportValues = false;
        var hasImportStar = false;
        var hasImportDefault = false;
        for (var _i = 0, _a2 = sourceFile.statements; _i < _a2.length; _i++) {
          var node = _a2[_i];
          switch (node.kind) {
            case 262:
              externalImports.push(node);
              if (!hasImportStar && getImportNeedsImportStarHelper(node)) {
                hasImportStar = true;
              }
              if (!hasImportDefault && getImportNeedsImportDefaultHelper(node)) {
                hasImportDefault = true;
              }
              break;
            case 261:
              if (node.moduleReference.kind === 273) {
                externalImports.push(node);
              }
              break;
            case 268:
              if (node.moduleSpecifier) {
                if (!node.exportClause) {
                  externalImports.push(node);
                  hasExportStarsToExportValues = true;
                } else {
                  externalImports.push(node);
                  if (ts3.isNamedExports(node.exportClause)) {
                    addExportedNamesForExportDeclaration(node);
                  } else {
                    var name = node.exportClause.name;
                    if (!uniqueExports.get(ts3.idText(name))) {
                      multiMapSparseArrayAdd(exportedBindings, getOriginalNodeId(node), name);
                      uniqueExports.set(ts3.idText(name), true);
                      exportedNames = ts3.append(exportedNames, name);
                    }
                    hasImportStar = true;
                  }
                }
              } else {
                addExportedNamesForExportDeclaration(node);
              }
              break;
            case 267:
              if (node.isExportEquals && !exportEquals) {
                exportEquals = node;
              }
              break;
            case 233:
              if (ts3.hasSyntacticModifier(node, 1)) {
                for (var _b = 0, _c = node.declarationList.declarations; _b < _c.length; _b++) {
                  var decl = _c[_b];
                  exportedNames = collectExportedVariableInfo(decl, uniqueExports, exportedNames);
                }
              }
              break;
            case 252:
              if (ts3.hasSyntacticModifier(node, 1)) {
                if (ts3.hasSyntacticModifier(node, 512)) {
                  if (!hasExportDefault) {
                    multiMapSparseArrayAdd(exportedBindings, getOriginalNodeId(node), context.factory.getDeclarationName(node));
                    hasExportDefault = true;
                  }
                } else {
                  var name = node.name;
                  if (!uniqueExports.get(ts3.idText(name))) {
                    multiMapSparseArrayAdd(exportedBindings, getOriginalNodeId(node), name);
                    uniqueExports.set(ts3.idText(name), true);
                    exportedNames = ts3.append(exportedNames, name);
                  }
                }
              }
              break;
            case 253:
              if (ts3.hasSyntacticModifier(node, 1)) {
                if (ts3.hasSyntacticModifier(node, 512)) {
                  if (!hasExportDefault) {
                    multiMapSparseArrayAdd(exportedBindings, getOriginalNodeId(node), context.factory.getDeclarationName(node));
                    hasExportDefault = true;
                  }
                } else {
                  var name = node.name;
                  if (name && !uniqueExports.get(ts3.idText(name))) {
                    multiMapSparseArrayAdd(exportedBindings, getOriginalNodeId(node), name);
                    uniqueExports.set(ts3.idText(name), true);
                    exportedNames = ts3.append(exportedNames, name);
                  }
                }
              }
              break;
          }
        }
        var externalHelpersImportDeclaration = ts3.createExternalHelpersImportDeclarationIfNeeded(context.factory, context.getEmitHelperFactory(), sourceFile, compilerOptions, hasExportStarsToExportValues, hasImportStar, hasImportDefault);
        if (externalHelpersImportDeclaration) {
          externalImports.unshift(externalHelpersImportDeclaration);
        }
        return { externalImports, exportSpecifiers, exportEquals, hasExportStarsToExportValues, exportedBindings, exportedNames, externalHelpersImportDeclaration };
        function addExportedNamesForExportDeclaration(node2) {
          for (var _i2 = 0, _a3 = ts3.cast(node2.exportClause, ts3.isNamedExports).elements; _i2 < _a3.length; _i2++) {
            var specifier = _a3[_i2];
            if (!uniqueExports.get(ts3.idText(specifier.name))) {
              var name2 = specifier.propertyName || specifier.name;
              if (!node2.moduleSpecifier) {
                exportSpecifiers.add(ts3.idText(name2), specifier);
              }
              var decl2 = resolver.getReferencedImportDeclaration(name2) || resolver.getReferencedValueDeclaration(name2);
              if (decl2) {
                multiMapSparseArrayAdd(exportedBindings, getOriginalNodeId(decl2), specifier.name);
              }
              uniqueExports.set(ts3.idText(specifier.name), true);
              exportedNames = ts3.append(exportedNames, specifier.name);
            }
          }
        }
      }
      ts3.collectExternalModuleInfo = collectExternalModuleInfo;
      function collectExportedVariableInfo(decl, uniqueExports, exportedNames) {
        if (ts3.isBindingPattern(decl.name)) {
          for (var _i = 0, _a2 = decl.name.elements; _i < _a2.length; _i++) {
            var element = _a2[_i];
            if (!ts3.isOmittedExpression(element)) {
              exportedNames = collectExportedVariableInfo(element, uniqueExports, exportedNames);
            }
          }
        } else if (!ts3.isGeneratedIdentifier(decl.name)) {
          var text = ts3.idText(decl.name);
          if (!uniqueExports.get(text)) {
            uniqueExports.set(text, true);
            exportedNames = ts3.append(exportedNames, decl.name);
          }
        }
        return exportedNames;
      }
      function multiMapSparseArrayAdd(map2, key2, value) {
        var values = map2[key2];
        if (values) {
          values.push(value);
        } else {
          map2[key2] = values = [value];
        }
        return values;
      }
      function isSimpleCopiableExpression(expression) {
        return ts3.isStringLiteralLike(expression) || expression.kind === 8 || ts3.isKeyword(expression.kind) || ts3.isIdentifier(expression);
      }
      ts3.isSimpleCopiableExpression = isSimpleCopiableExpression;
      function isSimpleInlineableExpression(expression) {
        return !ts3.isIdentifier(expression) && isSimpleCopiableExpression(expression);
      }
      ts3.isSimpleInlineableExpression = isSimpleInlineableExpression;
      function isCompoundAssignment(kind) {
        return kind >= 63 && kind <= 77;
      }
      ts3.isCompoundAssignment = isCompoundAssignment;
      function getNonAssignmentOperatorForCompoundAssignment(kind) {
        switch (kind) {
          case 63:
            return 39;
          case 64:
            return 40;
          case 65:
            return 41;
          case 66:
            return 42;
          case 67:
            return 43;
          case 68:
            return 44;
          case 69:
            return 47;
          case 70:
            return 48;
          case 71:
            return 49;
          case 72:
            return 50;
          case 73:
            return 51;
          case 77:
            return 52;
          case 74:
            return 56;
          case 75:
            return 55;
          case 76:
            return 60;
        }
      }
      ts3.getNonAssignmentOperatorForCompoundAssignment = getNonAssignmentOperatorForCompoundAssignment;
      function addPrologueDirectivesAndInitialSuperCall(factory, ctor, result2, visitor) {
        if (ctor.body) {
          var statements = ctor.body.statements;
          var index = factory.copyPrologue(statements, result2, false, visitor);
          if (index === statements.length) {
            return index;
          }
          var superIndex = ts3.findIndex(statements, function(s2) {
            return ts3.isExpressionStatement(s2) && ts3.isSuperCall(s2.expression);
          }, index);
          if (superIndex > -1) {
            for (var i3 = index; i3 <= superIndex; i3++) {
              result2.push(ts3.visitNode(statements[i3], visitor, ts3.isStatement));
            }
            return superIndex + 1;
          }
          return index;
        }
        return 0;
      }
      ts3.addPrologueDirectivesAndInitialSuperCall = addPrologueDirectivesAndInitialSuperCall;
      function getProperties(node, requireInitializer, isStatic) {
        return ts3.filter(node.members, function(m) {
          return isInitializedOrStaticProperty(m, requireInitializer, isStatic);
        });
      }
      ts3.getProperties = getProperties;
      function isInitializedOrStaticProperty(member, requireInitializer, isStatic) {
        return ts3.isPropertyDeclaration(member) && (!!member.initializer || !requireInitializer) && ts3.hasStaticModifier(member) === isStatic;
      }
      function isInitializedProperty(member) {
        return member.kind === 164 && member.initializer !== void 0;
      }
      ts3.isInitializedProperty = isInitializedProperty;
      function isNonStaticMethodOrAccessorWithPrivateName(member) {
        return !ts3.hasStaticModifier(member) && ts3.isMethodOrAccessor(member) && ts3.isPrivateIdentifier(member.name);
      }
      ts3.isNonStaticMethodOrAccessorWithPrivateName = isNonStaticMethodOrAccessorWithPrivateName;
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var FlattenLevel;
      (function(FlattenLevel2) {
        FlattenLevel2[FlattenLevel2["All"] = 0] = "All";
        FlattenLevel2[FlattenLevel2["ObjectRest"] = 1] = "ObjectRest";
      })(FlattenLevel = ts3.FlattenLevel || (ts3.FlattenLevel = {}));
      function flattenDestructuringAssignment(node, visitor, context, level, needsValue, createAssignmentCallback) {
        var location = node;
        var value;
        if (ts3.isDestructuringAssignment(node)) {
          value = node.right;
          while (ts3.isEmptyArrayLiteral(node.left) || ts3.isEmptyObjectLiteral(node.left)) {
            if (ts3.isDestructuringAssignment(value)) {
              location = node = value;
              value = node.right;
            } else {
              return ts3.visitNode(value, visitor, ts3.isExpression);
            }
          }
        }
        var expressions;
        var flattenContext = {
          context,
          level,
          downlevelIteration: !!context.getCompilerOptions().downlevelIteration,
          hoistTempVariables: true,
          emitExpression,
          emitBindingOrAssignment,
          createArrayBindingOrAssignmentPattern: function(elements) {
            return makeArrayAssignmentPattern(context.factory, elements);
          },
          createObjectBindingOrAssignmentPattern: function(elements) {
            return makeObjectAssignmentPattern(context.factory, elements);
          },
          createArrayBindingOrAssignmentElement: makeAssignmentElement,
          visitor
        };
        if (value) {
          value = ts3.visitNode(value, visitor, ts3.isExpression);
          if (ts3.isIdentifier(value) && bindingOrAssignmentElementAssignsToName(node, value.escapedText) || bindingOrAssignmentElementContainsNonLiteralComputedName(node)) {
            value = ensureIdentifier(flattenContext, value, false, location);
          } else if (needsValue) {
            value = ensureIdentifier(flattenContext, value, true, location);
          } else if (ts3.nodeIsSynthesized(node)) {
            location = value;
          }
        }
        flattenBindingOrAssignmentElement(flattenContext, node, value, location, ts3.isDestructuringAssignment(node));
        if (value && needsValue) {
          if (!ts3.some(expressions)) {
            return value;
          }
          expressions.push(value);
        }
        return context.factory.inlineExpressions(expressions) || context.factory.createOmittedExpression();
        function emitExpression(expression) {
          expressions = ts3.append(expressions, expression);
        }
        function emitBindingOrAssignment(target, value2, location2, original) {
          ts3.Debug.assertNode(target, createAssignmentCallback ? ts3.isIdentifier : ts3.isExpression);
          var expression = createAssignmentCallback ? createAssignmentCallback(target, value2, location2) : ts3.setTextRange(context.factory.createAssignment(ts3.visitNode(target, visitor, ts3.isExpression), value2), location2);
          expression.original = original;
          emitExpression(expression);
        }
      }
      ts3.flattenDestructuringAssignment = flattenDestructuringAssignment;
      function bindingOrAssignmentElementAssignsToName(element, escapedName) {
        var target = ts3.getTargetOfBindingOrAssignmentElement(element);
        if (ts3.isBindingOrAssignmentPattern(target)) {
          return bindingOrAssignmentPatternAssignsToName(target, escapedName);
        } else if (ts3.isIdentifier(target)) {
          return target.escapedText === escapedName;
        }
        return false;
      }
      function bindingOrAssignmentPatternAssignsToName(pattern, escapedName) {
        var elements = ts3.getElementsOfBindingOrAssignmentPattern(pattern);
        for (var _i = 0, elements_3 = elements; _i < elements_3.length; _i++) {
          var element = elements_3[_i];
          if (bindingOrAssignmentElementAssignsToName(element, escapedName)) {
            return true;
          }
        }
        return false;
      }
      function bindingOrAssignmentElementContainsNonLiteralComputedName(element) {
        var propertyName = ts3.tryGetPropertyNameOfBindingOrAssignmentElement(element);
        if (propertyName && ts3.isComputedPropertyName(propertyName) && !ts3.isLiteralExpression(propertyName.expression)) {
          return true;
        }
        var target = ts3.getTargetOfBindingOrAssignmentElement(element);
        return !!target && ts3.isBindingOrAssignmentPattern(target) && bindingOrAssignmentPatternContainsNonLiteralComputedName(target);
      }
      function bindingOrAssignmentPatternContainsNonLiteralComputedName(pattern) {
        return !!ts3.forEach(ts3.getElementsOfBindingOrAssignmentPattern(pattern), bindingOrAssignmentElementContainsNonLiteralComputedName);
      }
      function flattenDestructuringBinding(node, visitor, context, level, rval, hoistTempVariables, skipInitializer) {
        if (hoistTempVariables === void 0) {
          hoistTempVariables = false;
        }
        var pendingExpressions;
        var pendingDeclarations = [];
        var declarations = [];
        var flattenContext = {
          context,
          level,
          downlevelIteration: !!context.getCompilerOptions().downlevelIteration,
          hoistTempVariables,
          emitExpression,
          emitBindingOrAssignment,
          createArrayBindingOrAssignmentPattern: function(elements) {
            return makeArrayBindingPattern(context.factory, elements);
          },
          createObjectBindingOrAssignmentPattern: function(elements) {
            return makeObjectBindingPattern(context.factory, elements);
          },
          createArrayBindingOrAssignmentElement: function(name2) {
            return makeBindingElement(context.factory, name2);
          },
          visitor
        };
        if (ts3.isVariableDeclaration(node)) {
          var initializer = ts3.getInitializerOfBindingOrAssignmentElement(node);
          if (initializer && (ts3.isIdentifier(initializer) && bindingOrAssignmentElementAssignsToName(node, initializer.escapedText) || bindingOrAssignmentElementContainsNonLiteralComputedName(node))) {
            initializer = ensureIdentifier(flattenContext, ts3.visitNode(initializer, flattenContext.visitor), false, initializer);
            node = context.factory.updateVariableDeclaration(node, node.name, void 0, void 0, initializer);
          }
        }
        flattenBindingOrAssignmentElement(flattenContext, node, rval, node, skipInitializer);
        if (pendingExpressions) {
          var temp = context.factory.createTempVariable(void 0);
          if (hoistTempVariables) {
            var value = context.factory.inlineExpressions(pendingExpressions);
            pendingExpressions = void 0;
            emitBindingOrAssignment(temp, value, void 0, void 0);
          } else {
            context.hoistVariableDeclaration(temp);
            var pendingDeclaration = ts3.last(pendingDeclarations);
            pendingDeclaration.pendingExpressions = ts3.append(pendingDeclaration.pendingExpressions, context.factory.createAssignment(temp, pendingDeclaration.value));
            ts3.addRange(pendingDeclaration.pendingExpressions, pendingExpressions);
            pendingDeclaration.value = temp;
          }
        }
        for (var _i = 0, pendingDeclarations_1 = pendingDeclarations; _i < pendingDeclarations_1.length; _i++) {
          var _a2 = pendingDeclarations_1[_i], pendingExpressions_1 = _a2.pendingExpressions, name = _a2.name, value = _a2.value, location = _a2.location, original = _a2.original;
          var variable = context.factory.createVariableDeclaration(name, void 0, void 0, pendingExpressions_1 ? context.factory.inlineExpressions(ts3.append(pendingExpressions_1, value)) : value);
          variable.original = original;
          ts3.setTextRange(variable, location);
          declarations.push(variable);
        }
        return declarations;
        function emitExpression(value2) {
          pendingExpressions = ts3.append(pendingExpressions, value2);
        }
        function emitBindingOrAssignment(target, value2, location2, original2) {
          ts3.Debug.assertNode(target, ts3.isBindingName);
          if (pendingExpressions) {
            value2 = context.factory.inlineExpressions(ts3.append(pendingExpressions, value2));
            pendingExpressions = void 0;
          }
          pendingDeclarations.push({ pendingExpressions, name: target, value: value2, location: location2, original: original2 });
        }
      }
      ts3.flattenDestructuringBinding = flattenDestructuringBinding;
      function flattenBindingOrAssignmentElement(flattenContext, element, value, location, skipInitializer) {
        var bindingTarget = ts3.getTargetOfBindingOrAssignmentElement(element);
        if (!skipInitializer) {
          var initializer = ts3.visitNode(ts3.getInitializerOfBindingOrAssignmentElement(element), flattenContext.visitor, ts3.isExpression);
          if (initializer) {
            if (value) {
              value = createDefaultValueCheck(flattenContext, value, initializer, location);
              if (!ts3.isSimpleInlineableExpression(initializer) && ts3.isBindingOrAssignmentPattern(bindingTarget)) {
                value = ensureIdentifier(flattenContext, value, true, location);
              }
            } else {
              value = initializer;
            }
          } else if (!value) {
            value = flattenContext.context.factory.createVoidZero();
          }
        }
        if (ts3.isObjectBindingOrAssignmentPattern(bindingTarget)) {
          flattenObjectBindingOrAssignmentPattern(flattenContext, element, bindingTarget, value, location);
        } else if (ts3.isArrayBindingOrAssignmentPattern(bindingTarget)) {
          flattenArrayBindingOrAssignmentPattern(flattenContext, element, bindingTarget, value, location);
        } else {
          flattenContext.emitBindingOrAssignment(bindingTarget, value, location, element);
        }
      }
      function flattenObjectBindingOrAssignmentPattern(flattenContext, parent, pattern, value, location) {
        var elements = ts3.getElementsOfBindingOrAssignmentPattern(pattern);
        var numElements = elements.length;
        if (numElements !== 1) {
          var reuseIdentifierExpressions = !ts3.isDeclarationBindingElement(parent) || numElements !== 0;
          value = ensureIdentifier(flattenContext, value, reuseIdentifierExpressions, location);
        }
        var bindingElements;
        var computedTempVariables;
        for (var i3 = 0; i3 < numElements; i3++) {
          var element = elements[i3];
          if (!ts3.getRestIndicatorOfBindingOrAssignmentElement(element)) {
            var propertyName = ts3.getPropertyNameOfBindingOrAssignmentElement(element);
            if (flattenContext.level >= 1 && !(element.transformFlags & (16384 | 32768)) && !(ts3.getTargetOfBindingOrAssignmentElement(element).transformFlags & (16384 | 32768)) && !ts3.isComputedPropertyName(propertyName)) {
              bindingElements = ts3.append(bindingElements, ts3.visitNode(element, flattenContext.visitor));
            } else {
              if (bindingElements) {
                flattenContext.emitBindingOrAssignment(flattenContext.createObjectBindingOrAssignmentPattern(bindingElements), value, location, pattern);
                bindingElements = void 0;
              }
              var rhsValue = createDestructuringPropertyAccess(flattenContext, value, propertyName);
              if (ts3.isComputedPropertyName(propertyName)) {
                computedTempVariables = ts3.append(computedTempVariables, rhsValue.argumentExpression);
              }
              flattenBindingOrAssignmentElement(flattenContext, element, rhsValue, element);
            }
          } else if (i3 === numElements - 1) {
            if (bindingElements) {
              flattenContext.emitBindingOrAssignment(flattenContext.createObjectBindingOrAssignmentPattern(bindingElements), value, location, pattern);
              bindingElements = void 0;
            }
            var rhsValue = flattenContext.context.getEmitHelperFactory().createRestHelper(value, elements, computedTempVariables, pattern);
            flattenBindingOrAssignmentElement(flattenContext, element, rhsValue, element);
          }
        }
        if (bindingElements) {
          flattenContext.emitBindingOrAssignment(flattenContext.createObjectBindingOrAssignmentPattern(bindingElements), value, location, pattern);
        }
      }
      function flattenArrayBindingOrAssignmentPattern(flattenContext, parent, pattern, value, location) {
        var elements = ts3.getElementsOfBindingOrAssignmentPattern(pattern);
        var numElements = elements.length;
        if (flattenContext.level < 1 && flattenContext.downlevelIteration) {
          value = ensureIdentifier(flattenContext, ts3.setTextRange(flattenContext.context.getEmitHelperFactory().createReadHelper(value, numElements > 0 && ts3.getRestIndicatorOfBindingOrAssignmentElement(elements[numElements - 1]) ? void 0 : numElements), location), false, location);
        } else if (numElements !== 1 && (flattenContext.level < 1 || numElements === 0) || ts3.every(elements, ts3.isOmittedExpression)) {
          var reuseIdentifierExpressions = !ts3.isDeclarationBindingElement(parent) || numElements !== 0;
          value = ensureIdentifier(flattenContext, value, reuseIdentifierExpressions, location);
        }
        var bindingElements;
        var restContainingElements;
        for (var i3 = 0; i3 < numElements; i3++) {
          var element = elements[i3];
          if (flattenContext.level >= 1) {
            if (element.transformFlags & 32768 || flattenContext.hasTransformedPriorElement && !isSimpleBindingOrAssignmentElement(element)) {
              flattenContext.hasTransformedPriorElement = true;
              var temp = flattenContext.context.factory.createTempVariable(void 0);
              if (flattenContext.hoistTempVariables) {
                flattenContext.context.hoistVariableDeclaration(temp);
              }
              restContainingElements = ts3.append(restContainingElements, [temp, element]);
              bindingElements = ts3.append(bindingElements, flattenContext.createArrayBindingOrAssignmentElement(temp));
            } else {
              bindingElements = ts3.append(bindingElements, element);
            }
          } else if (ts3.isOmittedExpression(element)) {
            continue;
          } else if (!ts3.getRestIndicatorOfBindingOrAssignmentElement(element)) {
            var rhsValue = flattenContext.context.factory.createElementAccessExpression(value, i3);
            flattenBindingOrAssignmentElement(flattenContext, element, rhsValue, element);
          } else if (i3 === numElements - 1) {
            var rhsValue = flattenContext.context.factory.createArraySliceCall(value, i3);
            flattenBindingOrAssignmentElement(flattenContext, element, rhsValue, element);
          }
        }
        if (bindingElements) {
          flattenContext.emitBindingOrAssignment(flattenContext.createArrayBindingOrAssignmentPattern(bindingElements), value, location, pattern);
        }
        if (restContainingElements) {
          for (var _i = 0, restContainingElements_1 = restContainingElements; _i < restContainingElements_1.length; _i++) {
            var _a2 = restContainingElements_1[_i], id = _a2[0], element = _a2[1];
            flattenBindingOrAssignmentElement(flattenContext, element, id, element);
          }
        }
      }
      function isSimpleBindingOrAssignmentElement(element) {
        var target = ts3.getTargetOfBindingOrAssignmentElement(element);
        if (!target || ts3.isOmittedExpression(target))
          return true;
        var propertyName = ts3.tryGetPropertyNameOfBindingOrAssignmentElement(element);
        if (propertyName && !ts3.isPropertyNameLiteral(propertyName))
          return false;
        var initializer = ts3.getInitializerOfBindingOrAssignmentElement(element);
        if (initializer && !ts3.isSimpleInlineableExpression(initializer))
          return false;
        if (ts3.isBindingOrAssignmentPattern(target))
          return ts3.every(ts3.getElementsOfBindingOrAssignmentPattern(target), isSimpleBindingOrAssignmentElement);
        return ts3.isIdentifier(target);
      }
      function createDefaultValueCheck(flattenContext, value, defaultValue, location) {
        value = ensureIdentifier(flattenContext, value, true, location);
        return flattenContext.context.factory.createConditionalExpression(flattenContext.context.factory.createTypeCheck(value, "undefined"), void 0, defaultValue, void 0, value);
      }
      function createDestructuringPropertyAccess(flattenContext, value, propertyName) {
        if (ts3.isComputedPropertyName(propertyName)) {
          var argumentExpression = ensureIdentifier(flattenContext, ts3.visitNode(propertyName.expression, flattenContext.visitor), false, propertyName);
          return flattenContext.context.factory.createElementAccessExpression(value, argumentExpression);
        } else if (ts3.isStringOrNumericLiteralLike(propertyName)) {
          var argumentExpression = ts3.factory.cloneNode(propertyName);
          return flattenContext.context.factory.createElementAccessExpression(value, argumentExpression);
        } else {
          var name = flattenContext.context.factory.createIdentifier(ts3.idText(propertyName));
          return flattenContext.context.factory.createPropertyAccessExpression(value, name);
        }
      }
      function ensureIdentifier(flattenContext, value, reuseIdentifierExpressions, location) {
        if (ts3.isIdentifier(value) && reuseIdentifierExpressions) {
          return value;
        } else {
          var temp = flattenContext.context.factory.createTempVariable(void 0);
          if (flattenContext.hoistTempVariables) {
            flattenContext.context.hoistVariableDeclaration(temp);
            flattenContext.emitExpression(ts3.setTextRange(flattenContext.context.factory.createAssignment(temp, value), location));
          } else {
            flattenContext.emitBindingOrAssignment(temp, value, location, void 0);
          }
          return temp;
        }
      }
      function makeArrayBindingPattern(factory, elements) {
        ts3.Debug.assertEachNode(elements, ts3.isArrayBindingElement);
        return factory.createArrayBindingPattern(elements);
      }
      function makeArrayAssignmentPattern(factory, elements) {
        return factory.createArrayLiteralExpression(ts3.map(elements, factory.converters.convertToArrayAssignmentElement));
      }
      function makeObjectBindingPattern(factory, elements) {
        ts3.Debug.assertEachNode(elements, ts3.isBindingElement);
        return factory.createObjectBindingPattern(elements);
      }
      function makeObjectAssignmentPattern(factory, elements) {
        return factory.createObjectLiteralExpression(ts3.map(elements, factory.converters.convertToObjectAssignmentElement));
      }
      function makeBindingElement(factory, name) {
        return factory.createBindingElement(void 0, void 0, name);
      }
      function makeAssignmentElement(name) {
        return name;
      }
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var ProcessLevel;
      (function(ProcessLevel2) {
        ProcessLevel2[ProcessLevel2["LiftRestriction"] = 0] = "LiftRestriction";
        ProcessLevel2[ProcessLevel2["All"] = 1] = "All";
      })(ProcessLevel = ts3.ProcessLevel || (ts3.ProcessLevel = {}));
      function processTaggedTemplateExpression(context, node, visitor, currentSourceFile, recordTaggedTemplateString, level) {
        var tag = ts3.visitNode(node.tag, visitor, ts3.isExpression);
        var templateArguments = [void 0];
        var cookedStrings = [];
        var rawStrings = [];
        var template = node.template;
        if (level === ProcessLevel.LiftRestriction && !ts3.hasInvalidEscape(template)) {
          return ts3.visitEachChild(node, visitor, context);
        }
        if (ts3.isNoSubstitutionTemplateLiteral(template)) {
          cookedStrings.push(createTemplateCooked(template));
          rawStrings.push(getRawLiteral(template, currentSourceFile));
        } else {
          cookedStrings.push(createTemplateCooked(template.head));
          rawStrings.push(getRawLiteral(template.head, currentSourceFile));
          for (var _i = 0, _a2 = template.templateSpans; _i < _a2.length; _i++) {
            var templateSpan = _a2[_i];
            cookedStrings.push(createTemplateCooked(templateSpan.literal));
            rawStrings.push(getRawLiteral(templateSpan.literal, currentSourceFile));
            templateArguments.push(ts3.visitNode(templateSpan.expression, visitor, ts3.isExpression));
          }
        }
        var helperCall = context.getEmitHelperFactory().createTemplateObjectHelper(ts3.factory.createArrayLiteralExpression(cookedStrings), ts3.factory.createArrayLiteralExpression(rawStrings));
        if (ts3.isExternalModule(currentSourceFile)) {
          var tempVar = ts3.factory.createUniqueName("templateObject");
          recordTaggedTemplateString(tempVar);
          templateArguments[0] = ts3.factory.createLogicalOr(tempVar, ts3.factory.createAssignment(tempVar, helperCall));
        } else {
          templateArguments[0] = helperCall;
        }
        return ts3.factory.createCallExpression(tag, void 0, templateArguments);
      }
      ts3.processTaggedTemplateExpression = processTaggedTemplateExpression;
      function createTemplateCooked(template) {
        return template.templateFlags ? ts3.factory.createVoidZero() : ts3.factory.createStringLiteral(template.text);
      }
      function getRawLiteral(node, currentSourceFile) {
        var text = node.rawText;
        if (text === void 0) {
          text = ts3.getSourceTextOfNodeFromSourceFile(currentSourceFile, node);
          var isLast = node.kind === 14 || node.kind === 17;
          text = text.substring(1, text.length - (isLast ? 1 : 2));
        }
        text = text.replace(/\r\n?/g, "\n");
        return ts3.setTextRange(ts3.factory.createStringLiteral(text), node);
      }
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var USE_NEW_TYPE_METADATA_FORMAT = false;
      var TypeScriptSubstitutionFlags;
      (function(TypeScriptSubstitutionFlags2) {
        TypeScriptSubstitutionFlags2[TypeScriptSubstitutionFlags2["ClassAliases"] = 1] = "ClassAliases";
        TypeScriptSubstitutionFlags2[TypeScriptSubstitutionFlags2["NamespaceExports"] = 2] = "NamespaceExports";
        TypeScriptSubstitutionFlags2[TypeScriptSubstitutionFlags2["NonQualifiedEnumMembers"] = 8] = "NonQualifiedEnumMembers";
      })(TypeScriptSubstitutionFlags || (TypeScriptSubstitutionFlags = {}));
      var ClassFacts;
      (function(ClassFacts2) {
        ClassFacts2[ClassFacts2["None"] = 0] = "None";
        ClassFacts2[ClassFacts2["HasStaticInitializedProperties"] = 1] = "HasStaticInitializedProperties";
        ClassFacts2[ClassFacts2["HasConstructorDecorators"] = 2] = "HasConstructorDecorators";
        ClassFacts2[ClassFacts2["HasMemberDecorators"] = 4] = "HasMemberDecorators";
        ClassFacts2[ClassFacts2["IsExportOfNamespace"] = 8] = "IsExportOfNamespace";
        ClassFacts2[ClassFacts2["IsNamedExternalExport"] = 16] = "IsNamedExternalExport";
        ClassFacts2[ClassFacts2["IsDefaultExternalExport"] = 32] = "IsDefaultExternalExport";
        ClassFacts2[ClassFacts2["IsDerivedClass"] = 64] = "IsDerivedClass";
        ClassFacts2[ClassFacts2["UseImmediatelyInvokedFunctionExpression"] = 128] = "UseImmediatelyInvokedFunctionExpression";
        ClassFacts2[ClassFacts2["HasAnyDecorators"] = 6] = "HasAnyDecorators";
        ClassFacts2[ClassFacts2["NeedsName"] = 5] = "NeedsName";
        ClassFacts2[ClassFacts2["MayNeedImmediatelyInvokedFunctionExpression"] = 7] = "MayNeedImmediatelyInvokedFunctionExpression";
        ClassFacts2[ClassFacts2["IsExported"] = 56] = "IsExported";
      })(ClassFacts || (ClassFacts = {}));
      function transformTypeScript(context) {
        var factory = context.factory, emitHelpers = context.getEmitHelperFactory, startLexicalEnvironment = context.startLexicalEnvironment, resumeLexicalEnvironment = context.resumeLexicalEnvironment, endLexicalEnvironment = context.endLexicalEnvironment, hoistVariableDeclaration = context.hoistVariableDeclaration;
        var resolver = context.getEmitResolver();
        var compilerOptions = context.getCompilerOptions();
        var strictNullChecks = ts3.getStrictOptionValue(compilerOptions, "strictNullChecks");
        var languageVersion = ts3.getEmitScriptTarget(compilerOptions);
        var moduleKind = ts3.getEmitModuleKind(compilerOptions);
        var previousOnEmitNode = context.onEmitNode;
        var previousOnSubstituteNode = context.onSubstituteNode;
        context.onEmitNode = onEmitNode;
        context.onSubstituteNode = onSubstituteNode;
        context.enableSubstitution(202);
        context.enableSubstitution(203);
        var currentSourceFile;
        var currentNamespace;
        var currentNamespaceContainerName;
        var currentLexicalScope;
        var currentNameScope;
        var currentScopeFirstDeclarationsOfName;
        var currentClassHasParameterProperties;
        var enabledSubstitutions;
        var classAliases;
        var applicableSubstitutions;
        return transformSourceFileOrBundle;
        function transformSourceFileOrBundle(node) {
          if (node.kind === 299) {
            return transformBundle(node);
          }
          return transformSourceFile(node);
        }
        function transformBundle(node) {
          return factory.createBundle(node.sourceFiles.map(transformSourceFile), ts3.mapDefined(node.prepends, function(prepend) {
            if (prepend.kind === 301) {
              return ts3.createUnparsedSourceFile(prepend, "js");
            }
            return prepend;
          }));
        }
        function transformSourceFile(node) {
          if (node.isDeclarationFile) {
            return node;
          }
          currentSourceFile = node;
          var visited = saveStateAndInvoke(node, visitSourceFile);
          ts3.addEmitHelpers(visited, context.readEmitHelpers());
          currentSourceFile = void 0;
          return visited;
        }
        function saveStateAndInvoke(node, f) {
          var savedCurrentScope = currentLexicalScope;
          var savedCurrentNameScope = currentNameScope;
          var savedCurrentScopeFirstDeclarationsOfName = currentScopeFirstDeclarationsOfName;
          var savedCurrentClassHasParameterProperties = currentClassHasParameterProperties;
          onBeforeVisitNode(node);
          var visited = f(node);
          if (currentLexicalScope !== savedCurrentScope) {
            currentScopeFirstDeclarationsOfName = savedCurrentScopeFirstDeclarationsOfName;
          }
          currentLexicalScope = savedCurrentScope;
          currentNameScope = savedCurrentNameScope;
          currentClassHasParameterProperties = savedCurrentClassHasParameterProperties;
          return visited;
        }
        function onBeforeVisitNode(node) {
          switch (node.kind) {
            case 298:
            case 259:
            case 258:
            case 231:
              currentLexicalScope = node;
              currentNameScope = void 0;
              currentScopeFirstDeclarationsOfName = void 0;
              break;
            case 253:
            case 252:
              if (ts3.hasSyntacticModifier(node, 2)) {
                break;
              }
              if (node.name) {
                recordEmittedDeclarationInScope(node);
              } else {
                ts3.Debug.assert(node.kind === 253 || ts3.hasSyntacticModifier(node, 512));
              }
              if (ts3.isClassDeclaration(node)) {
                currentNameScope = node;
              }
              break;
          }
        }
        function visitor(node) {
          return saveStateAndInvoke(node, visitorWorker);
        }
        function visitorWorker(node) {
          if (node.transformFlags & 1) {
            return visitTypeScript(node);
          }
          return node;
        }
        function sourceElementVisitor(node) {
          return saveStateAndInvoke(node, sourceElementVisitorWorker);
        }
        function sourceElementVisitorWorker(node) {
          switch (node.kind) {
            case 262:
            case 261:
            case 267:
            case 268:
              return visitElidableStatement(node);
            default:
              return visitorWorker(node);
          }
        }
        function visitElidableStatement(node) {
          var parsed = ts3.getParseTreeNode(node);
          if (parsed !== node) {
            if (node.transformFlags & 1) {
              return ts3.visitEachChild(node, visitor, context);
            }
            return node;
          }
          switch (node.kind) {
            case 262:
              return visitImportDeclaration(node);
            case 261:
              return visitImportEqualsDeclaration(node);
            case 267:
              return visitExportAssignment(node);
            case 268:
              return visitExportDeclaration(node);
            default:
              ts3.Debug.fail("Unhandled ellided statement");
          }
        }
        function namespaceElementVisitor(node) {
          return saveStateAndInvoke(node, namespaceElementVisitorWorker);
        }
        function namespaceElementVisitorWorker(node) {
          if (node.kind === 268 || node.kind === 262 || node.kind === 263 || node.kind === 261 && node.moduleReference.kind === 273) {
            return void 0;
          } else if (node.transformFlags & 1 || ts3.hasSyntacticModifier(node, 1)) {
            return visitTypeScript(node);
          }
          return node;
        }
        function classElementVisitor(node) {
          return saveStateAndInvoke(node, classElementVisitorWorker);
        }
        function classElementVisitorWorker(node) {
          switch (node.kind) {
            case 167:
              return visitConstructor(node);
            case 164:
              return visitPropertyDeclaration(node);
            case 172:
            case 168:
            case 169:
            case 166:
              return visitorWorker(node);
            case 230:
              return node;
            default:
              return ts3.Debug.failBadSyntaxKind(node);
          }
        }
        function modifierVisitor(node) {
          if (ts3.modifierToFlag(node.kind) & 18654) {
            return void 0;
          } else if (currentNamespace && node.kind === 92) {
            return void 0;
          }
          return node;
        }
        function visitTypeScript(node) {
          if (ts3.isStatement(node) && ts3.hasSyntacticModifier(node, 2)) {
            return factory.createNotEmittedStatement(node);
          }
          switch (node.kind) {
            case 92:
            case 87:
              return currentNamespace ? void 0 : node;
            case 122:
            case 120:
            case 121:
            case 125:
            case 156:
            case 84:
            case 133:
            case 142:
            case 179:
            case 180:
            case 181:
            case 182:
            case 178:
            case 173:
            case 160:
            case 128:
            case 152:
            case 131:
            case 147:
            case 144:
            case 141:
            case 113:
            case 148:
            case 176:
            case 175:
            case 177:
            case 174:
            case 183:
            case 184:
            case 185:
            case 187:
            case 188:
            case 189:
            case 190:
            case 191:
            case 192:
            case 172:
            case 162:
            case 255:
              return void 0;
            case 164:
              return visitPropertyDeclaration(node);
            case 260:
              return void 0;
            case 167:
              return visitConstructor(node);
            case 254:
              return factory.createNotEmittedStatement(node);
            case 253:
              return visitClassDeclaration(node);
            case 222:
              return visitClassExpression(node);
            case 287:
              return visitHeritageClause(node);
            case 224:
              return visitExpressionWithTypeArguments(node);
            case 166:
              return visitMethodDeclaration(node);
            case 168:
              return visitGetAccessor(node);
            case 169:
              return visitSetAccessor(node);
            case 252:
              return visitFunctionDeclaration(node);
            case 209:
              return visitFunctionExpression(node);
            case 210:
              return visitArrowFunction(node);
            case 161:
              return visitParameter(node);
            case 208:
              return visitParenthesizedExpression(node);
            case 207:
            case 225:
              return visitAssertionExpression(node);
            case 204:
              return visitCallExpression(node);
            case 205:
              return visitNewExpression(node);
            case 206:
              return visitTaggedTemplateExpression(node);
            case 226:
              return visitNonNullExpression(node);
            case 256:
              return visitEnumDeclaration(node);
            case 233:
              return visitVariableStatement(node);
            case 250:
              return visitVariableDeclaration(node);
            case 257:
              return visitModuleDeclaration(node);
            case 261:
              return visitImportEqualsDeclaration(node);
            case 275:
              return visitJsxSelfClosingElement(node);
            case 276:
              return visitJsxJsxOpeningElement(node);
            default:
              return ts3.visitEachChild(node, visitor, context);
          }
        }
        function visitSourceFile(node) {
          var alwaysStrict = ts3.getStrictOptionValue(compilerOptions, "alwaysStrict") && !(ts3.isExternalModule(node) && moduleKind >= ts3.ModuleKind.ES2015) && !ts3.isJsonSourceFile(node);
          return factory.updateSourceFile(node, ts3.visitLexicalEnvironment(node.statements, sourceElementVisitor, context, 0, alwaysStrict));
        }
        function shouldEmitDecorateCallForClass(node) {
          if (node.decorators && node.decorators.length > 0) {
            return true;
          }
          var constructor = ts3.getFirstConstructorWithBody(node);
          if (constructor) {
            return ts3.forEach(constructor.parameters, shouldEmitDecorateCallForParameter);
          }
          return false;
        }
        function shouldEmitDecorateCallForParameter(parameter) {
          return parameter.decorators !== void 0 && parameter.decorators.length > 0;
        }
        function getClassFacts(node, staticProperties) {
          var facts = 0;
          if (ts3.some(staticProperties))
            facts |= 1;
          var extendsClauseElement = ts3.getEffectiveBaseTypeNode(node);
          if (extendsClauseElement && ts3.skipOuterExpressions(extendsClauseElement.expression).kind !== 103)
            facts |= 64;
          if (shouldEmitDecorateCallForClass(node))
            facts |= 2;
          if (ts3.childIsDecorated(node))
            facts |= 4;
          if (isExportOfNamespace(node))
            facts |= 8;
          else if (isDefaultExternalModuleExport(node))
            facts |= 32;
          else if (isNamedExternalModuleExport(node))
            facts |= 16;
          if (languageVersion <= 1 && facts & 7)
            facts |= 128;
          return facts;
        }
        function hasTypeScriptClassSyntax(node) {
          return !!(node.transformFlags & 4096);
        }
        function isClassLikeDeclarationWithTypeScriptSyntax(node) {
          return ts3.some(node.decorators) || ts3.some(node.typeParameters) || ts3.some(node.heritageClauses, hasTypeScriptClassSyntax) || ts3.some(node.members, hasTypeScriptClassSyntax);
        }
        function visitClassDeclaration(node) {
          if (!isClassLikeDeclarationWithTypeScriptSyntax(node) && !(currentNamespace && ts3.hasSyntacticModifier(node, 1))) {
            return ts3.visitEachChild(node, visitor, context);
          }
          var staticProperties = ts3.getProperties(node, true, true);
          var facts = getClassFacts(node, staticProperties);
          if (facts & 128) {
            context.startLexicalEnvironment();
          }
          var name = node.name || (facts & 5 ? factory.getGeneratedNameForNode(node) : void 0);
          var classStatement = facts & 2 ? createClassDeclarationHeadWithDecorators(node, name) : createClassDeclarationHeadWithoutDecorators(node, name, facts);
          var statements = [classStatement];
          addClassElementDecorationStatements(statements, node, false);
          addClassElementDecorationStatements(statements, node, true);
          addConstructorDecorationStatement(statements, node);
          if (facts & 128) {
            var closingBraceLocation = ts3.createTokenRange(ts3.skipTrivia(currentSourceFile.text, node.members.end), 19);
            var localName = factory.getInternalName(node);
            var outer = factory.createPartiallyEmittedExpression(localName);
            ts3.setTextRangeEnd(outer, closingBraceLocation.end);
            ts3.setEmitFlags(outer, 1536);
            var statement = factory.createReturnStatement(outer);
            ts3.setTextRangePos(statement, closingBraceLocation.pos);
            ts3.setEmitFlags(statement, 1536 | 384);
            statements.push(statement);
            ts3.insertStatementsAfterStandardPrologue(statements, context.endLexicalEnvironment());
            var iife = factory.createImmediatelyInvokedArrowFunction(statements);
            ts3.setEmitFlags(iife, 33554432);
            var varStatement = factory.createVariableStatement(void 0, factory.createVariableDeclarationList([
              factory.createVariableDeclaration(factory.getLocalName(node, false, false), void 0, void 0, iife)
            ]));
            ts3.setOriginalNode(varStatement, node);
            ts3.setCommentRange(varStatement, node);
            ts3.setSourceMapRange(varStatement, ts3.moveRangePastDecorators(node));
            ts3.startOnNewLine(varStatement);
            statements = [varStatement];
          }
          if (facts & 8) {
            addExportMemberAssignment(statements, node);
          } else if (facts & 128 || facts & 2) {
            if (facts & 32) {
              statements.push(factory.createExportDefault(factory.getLocalName(node, false, true)));
            } else if (facts & 16) {
              statements.push(factory.createExternalModuleExport(factory.getLocalName(node, false, true)));
            }
          }
          if (statements.length > 1) {
            statements.push(factory.createEndOfDeclarationMarker(node));
            ts3.setEmitFlags(classStatement, ts3.getEmitFlags(classStatement) | 4194304);
          }
          return ts3.singleOrMany(statements);
        }
        function createClassDeclarationHeadWithoutDecorators(node, name, facts) {
          var modifiers = !(facts & 128) ? ts3.visitNodes(node.modifiers, modifierVisitor, ts3.isModifier) : void 0;
          var classDeclaration = factory.createClassDeclaration(void 0, modifiers, name, void 0, ts3.visitNodes(node.heritageClauses, visitor, ts3.isHeritageClause), transformClassMembers(node));
          var emitFlags = ts3.getEmitFlags(node);
          if (facts & 1) {
            emitFlags |= 32;
          }
          ts3.setTextRange(classDeclaration, node);
          ts3.setOriginalNode(classDeclaration, node);
          ts3.setEmitFlags(classDeclaration, emitFlags);
          return classDeclaration;
        }
        function createClassDeclarationHeadWithDecorators(node, name) {
          var location = ts3.moveRangePastDecorators(node);
          var classAlias = getClassAliasIfNeeded(node);
          var declName = factory.getLocalName(node, false, true);
          var heritageClauses = ts3.visitNodes(node.heritageClauses, visitor, ts3.isHeritageClause);
          var members = transformClassMembers(node);
          var classExpression = factory.createClassExpression(void 0, void 0, name, void 0, heritageClauses, members);
          ts3.setOriginalNode(classExpression, node);
          ts3.setTextRange(classExpression, location);
          var statement = factory.createVariableStatement(void 0, factory.createVariableDeclarationList([
            factory.createVariableDeclaration(declName, void 0, void 0, classAlias ? factory.createAssignment(classAlias, classExpression) : classExpression)
          ], 1));
          ts3.setOriginalNode(statement, node);
          ts3.setTextRange(statement, location);
          ts3.setCommentRange(statement, node);
          return statement;
        }
        function visitClassExpression(node) {
          if (!isClassLikeDeclarationWithTypeScriptSyntax(node)) {
            return ts3.visitEachChild(node, visitor, context);
          }
          var classExpression = factory.createClassExpression(void 0, void 0, node.name, void 0, ts3.visitNodes(node.heritageClauses, visitor, ts3.isHeritageClause), transformClassMembers(node));
          ts3.setOriginalNode(classExpression, node);
          ts3.setTextRange(classExpression, node);
          return classExpression;
        }
        function transformClassMembers(node) {
          var members = [];
          var constructor = ts3.getFirstConstructorWithBody(node);
          var parametersWithPropertyAssignments = constructor && ts3.filter(constructor.parameters, function(p) {
            return ts3.isParameterPropertyDeclaration(p, constructor);
          });
          if (parametersWithPropertyAssignments) {
            for (var _i = 0, parametersWithPropertyAssignments_1 = parametersWithPropertyAssignments; _i < parametersWithPropertyAssignments_1.length; _i++) {
              var parameter = parametersWithPropertyAssignments_1[_i];
              if (ts3.isIdentifier(parameter.name)) {
                members.push(ts3.setOriginalNode(factory.createPropertyDeclaration(void 0, void 0, parameter.name, void 0, void 0, void 0), parameter));
              }
            }
          }
          ts3.addRange(members, ts3.visitNodes(node.members, classElementVisitor, ts3.isClassElement));
          return ts3.setTextRange(factory.createNodeArray(members), node.members);
        }
        function getDecoratedClassElements(node, isStatic) {
          return ts3.filter(node.members, isStatic ? function(m) {
            return isStaticDecoratedClassElement(m, node);
          } : function(m) {
            return isInstanceDecoratedClassElement(m, node);
          });
        }
        function isStaticDecoratedClassElement(member, parent) {
          return isDecoratedClassElement(member, true, parent);
        }
        function isInstanceDecoratedClassElement(member, parent) {
          return isDecoratedClassElement(member, false, parent);
        }
        function isDecoratedClassElement(member, isStatic, parent) {
          return ts3.nodeOrChildIsDecorated(member, parent) && isStatic === ts3.hasSyntacticModifier(member, 32);
        }
        function getDecoratorsOfParameters(node) {
          var decorators;
          if (node) {
            var parameters = node.parameters;
            var firstParameterIsThis = parameters.length > 0 && ts3.parameterIsThisKeyword(parameters[0]);
            var firstParameterOffset = firstParameterIsThis ? 1 : 0;
            var numParameters = firstParameterIsThis ? parameters.length - 1 : parameters.length;
            for (var i3 = 0; i3 < numParameters; i3++) {
              var parameter = parameters[i3 + firstParameterOffset];
              if (decorators || parameter.decorators) {
                if (!decorators) {
                  decorators = new Array(numParameters);
                }
                decorators[i3] = parameter.decorators;
              }
            }
          }
          return decorators;
        }
        function getAllDecoratorsOfConstructor(node) {
          var decorators = node.decorators;
          var parameters = getDecoratorsOfParameters(ts3.getFirstConstructorWithBody(node));
          if (!decorators && !parameters) {
            return void 0;
          }
          return {
            decorators,
            parameters
          };
        }
        function getAllDecoratorsOfClassElement(node, member) {
          switch (member.kind) {
            case 168:
            case 169:
              return getAllDecoratorsOfAccessors(node, member);
            case 166:
              return getAllDecoratorsOfMethod(member);
            case 164:
              return getAllDecoratorsOfProperty(member);
            default:
              return void 0;
          }
        }
        function getAllDecoratorsOfAccessors(node, accessor) {
          if (!accessor.body) {
            return void 0;
          }
          var _a2 = ts3.getAllAccessorDeclarations(node.members, accessor), firstAccessor = _a2.firstAccessor, secondAccessor = _a2.secondAccessor, setAccessor = _a2.setAccessor;
          var firstAccessorWithDecorators = firstAccessor.decorators ? firstAccessor : secondAccessor && secondAccessor.decorators ? secondAccessor : void 0;
          if (!firstAccessorWithDecorators || accessor !== firstAccessorWithDecorators) {
            return void 0;
          }
          var decorators = firstAccessorWithDecorators.decorators;
          var parameters = getDecoratorsOfParameters(setAccessor);
          if (!decorators && !parameters) {
            return void 0;
          }
          return { decorators, parameters };
        }
        function getAllDecoratorsOfMethod(method) {
          if (!method.body) {
            return void 0;
          }
          var decorators = method.decorators;
          var parameters = getDecoratorsOfParameters(method);
          if (!decorators && !parameters) {
            return void 0;
          }
          return { decorators, parameters };
        }
        function getAllDecoratorsOfProperty(property) {
          var decorators = property.decorators;
          if (!decorators) {
            return void 0;
          }
          return { decorators };
        }
        function transformAllDecoratorsOfDeclaration(node, container, allDecorators) {
          if (!allDecorators) {
            return void 0;
          }
          var decoratorExpressions = [];
          ts3.addRange(decoratorExpressions, ts3.map(allDecorators.decorators, transformDecorator));
          ts3.addRange(decoratorExpressions, ts3.flatMap(allDecorators.parameters, transformDecoratorsOfParameter));
          addTypeMetadata(node, container, decoratorExpressions);
          return decoratorExpressions;
        }
        function addClassElementDecorationStatements(statements, node, isStatic) {
          ts3.addRange(statements, ts3.map(generateClassElementDecorationExpressions(node, isStatic), expressionToStatement));
        }
        function generateClassElementDecorationExpressions(node, isStatic) {
          var members = getDecoratedClassElements(node, isStatic);
          var expressions;
          for (var _i = 0, members_6 = members; _i < members_6.length; _i++) {
            var member = members_6[_i];
            var expression = generateClassElementDecorationExpression(node, member);
            if (expression) {
              if (!expressions) {
                expressions = [expression];
              } else {
                expressions.push(expression);
              }
            }
          }
          return expressions;
        }
        function generateClassElementDecorationExpression(node, member) {
          var allDecorators = getAllDecoratorsOfClassElement(node, member);
          var decoratorExpressions = transformAllDecoratorsOfDeclaration(member, node, allDecorators);
          if (!decoratorExpressions) {
            return void 0;
          }
          var prefix2 = getClassMemberPrefix(node, member);
          var memberName = getExpressionForPropertyName(member, true);
          var descriptor = languageVersion > 0 ? member.kind === 164 ? factory.createVoidZero() : factory.createNull() : void 0;
          var helper = emitHelpers().createDecorateHelper(decoratorExpressions, prefix2, memberName, descriptor);
          ts3.setTextRange(helper, ts3.moveRangePastDecorators(member));
          ts3.setEmitFlags(helper, 1536);
          return helper;
        }
        function addConstructorDecorationStatement(statements, node) {
          var expression = generateConstructorDecorationExpression(node);
          if (expression) {
            statements.push(ts3.setOriginalNode(factory.createExpressionStatement(expression), node));
          }
        }
        function generateConstructorDecorationExpression(node) {
          var allDecorators = getAllDecoratorsOfConstructor(node);
          var decoratorExpressions = transformAllDecoratorsOfDeclaration(node, node, allDecorators);
          if (!decoratorExpressions) {
            return void 0;
          }
          var classAlias = classAliases && classAliases[ts3.getOriginalNodeId(node)];
          var localName = factory.getLocalName(node, false, true);
          var decorate = emitHelpers().createDecorateHelper(decoratorExpressions, localName);
          var expression = factory.createAssignment(localName, classAlias ? factory.createAssignment(classAlias, decorate) : decorate);
          ts3.setEmitFlags(expression, 1536);
          ts3.setSourceMapRange(expression, ts3.moveRangePastDecorators(node));
          return expression;
        }
        function transformDecorator(decorator) {
          return ts3.visitNode(decorator.expression, visitor, ts3.isExpression);
        }
        function transformDecoratorsOfParameter(decorators, parameterOffset) {
          var expressions;
          if (decorators) {
            expressions = [];
            for (var _i = 0, decorators_1 = decorators; _i < decorators_1.length; _i++) {
              var decorator = decorators_1[_i];
              var helper = emitHelpers().createParamHelper(transformDecorator(decorator), parameterOffset);
              ts3.setTextRange(helper, decorator.expression);
              ts3.setEmitFlags(helper, 1536);
              expressions.push(helper);
            }
          }
          return expressions;
        }
        function addTypeMetadata(node, container, decoratorExpressions) {
          if (USE_NEW_TYPE_METADATA_FORMAT) {
            addNewTypeMetadata(node, container, decoratorExpressions);
          } else {
            addOldTypeMetadata(node, container, decoratorExpressions);
          }
        }
        function addOldTypeMetadata(node, container, decoratorExpressions) {
          if (compilerOptions.emitDecoratorMetadata) {
            if (shouldAddTypeMetadata(node)) {
              decoratorExpressions.push(emitHelpers().createMetadataHelper("design:type", serializeTypeOfNode(node)));
            }
            if (shouldAddParamTypesMetadata(node)) {
              decoratorExpressions.push(emitHelpers().createMetadataHelper("design:paramtypes", serializeParameterTypesOfNode(node, container)));
            }
            if (shouldAddReturnTypeMetadata(node)) {
              decoratorExpressions.push(emitHelpers().createMetadataHelper("design:returntype", serializeReturnTypeOfNode(node)));
            }
          }
        }
        function addNewTypeMetadata(node, container, decoratorExpressions) {
          if (compilerOptions.emitDecoratorMetadata) {
            var properties = void 0;
            if (shouldAddTypeMetadata(node)) {
              (properties || (properties = [])).push(factory.createPropertyAssignment("type", factory.createArrowFunction(void 0, void 0, [], void 0, factory.createToken(38), serializeTypeOfNode(node))));
            }
            if (shouldAddParamTypesMetadata(node)) {
              (properties || (properties = [])).push(factory.createPropertyAssignment("paramTypes", factory.createArrowFunction(void 0, void 0, [], void 0, factory.createToken(38), serializeParameterTypesOfNode(node, container))));
            }
            if (shouldAddReturnTypeMetadata(node)) {
              (properties || (properties = [])).push(factory.createPropertyAssignment("returnType", factory.createArrowFunction(void 0, void 0, [], void 0, factory.createToken(38), serializeReturnTypeOfNode(node))));
            }
            if (properties) {
              decoratorExpressions.push(emitHelpers().createMetadataHelper("design:typeinfo", factory.createObjectLiteralExpression(properties, true)));
            }
          }
        }
        function shouldAddTypeMetadata(node) {
          var kind = node.kind;
          return kind === 166 || kind === 168 || kind === 169 || kind === 164;
        }
        function shouldAddReturnTypeMetadata(node) {
          return node.kind === 166;
        }
        function shouldAddParamTypesMetadata(node) {
          switch (node.kind) {
            case 253:
            case 222:
              return ts3.getFirstConstructorWithBody(node) !== void 0;
            case 166:
            case 168:
            case 169:
              return true;
          }
          return false;
        }
        function getAccessorTypeNode(node) {
          var accessors = resolver.getAllAccessorDeclarations(node);
          return accessors.setAccessor && ts3.getSetAccessorTypeAnnotationNode(accessors.setAccessor) || accessors.getAccessor && ts3.getEffectiveReturnTypeNode(accessors.getAccessor);
        }
        function serializeTypeOfNode(node) {
          switch (node.kind) {
            case 164:
            case 161:
              return serializeTypeNode(node.type);
            case 169:
            case 168:
              return serializeTypeNode(getAccessorTypeNode(node));
            case 253:
            case 222:
            case 166:
              return factory.createIdentifier("Function");
            default:
              return factory.createVoidZero();
          }
        }
        function serializeParameterTypesOfNode(node, container) {
          var valueDeclaration = ts3.isClassLike(node) ? ts3.getFirstConstructorWithBody(node) : ts3.isFunctionLike(node) && ts3.nodeIsPresent(node.body) ? node : void 0;
          var expressions = [];
          if (valueDeclaration) {
            var parameters = getParametersOfDecoratedDeclaration(valueDeclaration, container);
            var numParameters = parameters.length;
            for (var i3 = 0; i3 < numParameters; i3++) {
              var parameter = parameters[i3];
              if (i3 === 0 && ts3.isIdentifier(parameter.name) && parameter.name.escapedText === "this") {
                continue;
              }
              if (parameter.dotDotDotToken) {
                expressions.push(serializeTypeNode(ts3.getRestParameterElementType(parameter.type)));
              } else {
                expressions.push(serializeTypeOfNode(parameter));
              }
            }
          }
          return factory.createArrayLiteralExpression(expressions);
        }
        function getParametersOfDecoratedDeclaration(node, container) {
          if (container && node.kind === 168) {
            var setAccessor = ts3.getAllAccessorDeclarations(container.members, node).setAccessor;
            if (setAccessor) {
              return setAccessor.parameters;
            }
          }
          return node.parameters;
        }
        function serializeReturnTypeOfNode(node) {
          if (ts3.isFunctionLike(node) && node.type) {
            return serializeTypeNode(node.type);
          } else if (ts3.isAsyncFunction(node)) {
            return factory.createIdentifier("Promise");
          }
          return factory.createVoidZero();
        }
        function serializeTypeNode(node) {
          if (node === void 0) {
            return factory.createIdentifier("Object");
          }
          switch (node.kind) {
            case 113:
            case 150:
            case 141:
              return factory.createVoidZero();
            case 187:
              return serializeTypeNode(node.type);
            case 175:
            case 176:
              return factory.createIdentifier("Function");
            case 179:
            case 180:
              return factory.createIdentifier("Array");
            case 173:
            case 131:
              return factory.createIdentifier("Boolean");
            case 147:
              return factory.createIdentifier("String");
            case 145:
              return factory.createIdentifier("Object");
            case 192:
              switch (node.literal.kind) {
                case 10:
                case 14:
                  return factory.createIdentifier("String");
                case 215:
                case 8:
                  return factory.createIdentifier("Number");
                case 9:
                  return getGlobalBigIntNameWithFallback();
                case 109:
                case 94:
                  return factory.createIdentifier("Boolean");
                case 103:
                  return factory.createVoidZero();
                default:
                  return ts3.Debug.failBadSyntaxKind(node.literal);
              }
            case 144:
              return factory.createIdentifier("Number");
            case 155:
              return getGlobalBigIntNameWithFallback();
            case 148:
              return languageVersion < 2 ? getGlobalSymbolNameWithFallback() : factory.createIdentifier("Symbol");
            case 174:
              return serializeTypeReferenceNode(node);
            case 184:
            case 183:
              return serializeTypeList(node.types);
            case 185:
              return serializeTypeList([node.trueType, node.falseType]);
            case 189:
              if (node.operator === 142) {
                return serializeTypeNode(node.type);
              }
              break;
            case 177:
            case 190:
            case 191:
            case 178:
            case 128:
            case 152:
            case 188:
            case 196:
              break;
            case 304:
            case 305:
            case 309:
            case 310:
            case 311:
              break;
            case 306:
            case 307:
            case 308:
              return serializeTypeNode(node.type);
            default:
              return ts3.Debug.failBadSyntaxKind(node);
          }
          return factory.createIdentifier("Object");
        }
        function serializeTypeList(types2) {
          var serializedUnion;
          for (var _i = 0, types_24 = types2; _i < types_24.length; _i++) {
            var typeNode = types_24[_i];
            while (typeNode.kind === 187) {
              typeNode = typeNode.type;
            }
            if (typeNode.kind === 141) {
              continue;
            }
            if (!strictNullChecks && (typeNode.kind === 192 && typeNode.literal.kind === 103 || typeNode.kind === 150)) {
              continue;
            }
            var serializedIndividual = serializeTypeNode(typeNode);
            if (ts3.isIdentifier(serializedIndividual) && serializedIndividual.escapedText === "Object") {
              return serializedIndividual;
            } else if (serializedUnion) {
              if (!ts3.isIdentifier(serializedUnion) || !ts3.isIdentifier(serializedIndividual) || serializedUnion.escapedText !== serializedIndividual.escapedText) {
                return factory.createIdentifier("Object");
              }
            } else {
              serializedUnion = serializedIndividual;
            }
          }
          return serializedUnion || factory.createVoidZero();
        }
        function serializeTypeReferenceNode(node) {
          var kind = resolver.getTypeReferenceSerializationKind(node.typeName, currentNameScope || currentLexicalScope);
          switch (kind) {
            case ts3.TypeReferenceSerializationKind.Unknown:
              if (ts3.findAncestor(node, function(n2) {
                return n2.parent && ts3.isConditionalTypeNode(n2.parent) && (n2.parent.trueType === n2 || n2.parent.falseType === n2);
              })) {
                return factory.createIdentifier("Object");
              }
              var serialized = serializeEntityNameAsExpressionFallback(node.typeName);
              var temp = factory.createTempVariable(hoistVariableDeclaration);
              return factory.createConditionalExpression(factory.createTypeCheck(factory.createAssignment(temp, serialized), "function"), void 0, temp, void 0, factory.createIdentifier("Object"));
            case ts3.TypeReferenceSerializationKind.TypeWithConstructSignatureAndValue:
              return serializeEntityNameAsExpression(node.typeName);
            case ts3.TypeReferenceSerializationKind.VoidNullableOrNeverType:
              return factory.createVoidZero();
            case ts3.TypeReferenceSerializationKind.BigIntLikeType:
              return getGlobalBigIntNameWithFallback();
            case ts3.TypeReferenceSerializationKind.BooleanType:
              return factory.createIdentifier("Boolean");
            case ts3.TypeReferenceSerializationKind.NumberLikeType:
              return factory.createIdentifier("Number");
            case ts3.TypeReferenceSerializationKind.StringLikeType:
              return factory.createIdentifier("String");
            case ts3.TypeReferenceSerializationKind.ArrayLikeType:
              return factory.createIdentifier("Array");
            case ts3.TypeReferenceSerializationKind.ESSymbolType:
              return languageVersion < 2 ? getGlobalSymbolNameWithFallback() : factory.createIdentifier("Symbol");
            case ts3.TypeReferenceSerializationKind.TypeWithCallSignature:
              return factory.createIdentifier("Function");
            case ts3.TypeReferenceSerializationKind.Promise:
              return factory.createIdentifier("Promise");
            case ts3.TypeReferenceSerializationKind.ObjectType:
              return factory.createIdentifier("Object");
            default:
              return ts3.Debug.assertNever(kind);
          }
        }
        function createCheckedValue(left, right) {
          return factory.createLogicalAnd(factory.createStrictInequality(factory.createTypeOfExpression(left), factory.createStringLiteral("undefined")), right);
        }
        function serializeEntityNameAsExpressionFallback(node) {
          if (node.kind === 78) {
            var copied = serializeEntityNameAsExpression(node);
            return createCheckedValue(copied, copied);
          }
          if (node.left.kind === 78) {
            return createCheckedValue(serializeEntityNameAsExpression(node.left), serializeEntityNameAsExpression(node));
          }
          var left = serializeEntityNameAsExpressionFallback(node.left);
          var temp = factory.createTempVariable(hoistVariableDeclaration);
          return factory.createLogicalAnd(factory.createLogicalAnd(left.left, factory.createStrictInequality(factory.createAssignment(temp, left.right), factory.createVoidZero())), factory.createPropertyAccessExpression(temp, node.right));
        }
        function serializeEntityNameAsExpression(node) {
          switch (node.kind) {
            case 78:
              var name = ts3.setParent(ts3.setTextRange(ts3.parseNodeFactory.cloneNode(node), node), node.parent);
              name.original = void 0;
              ts3.setParent(name, ts3.getParseTreeNode(currentLexicalScope));
              return name;
            case 158:
              return serializeQualifiedNameAsExpression(node);
          }
        }
        function serializeQualifiedNameAsExpression(node) {
          return factory.createPropertyAccessExpression(serializeEntityNameAsExpression(node.left), node.right);
        }
        function getGlobalSymbolNameWithFallback() {
          return factory.createConditionalExpression(factory.createTypeCheck(factory.createIdentifier("Symbol"), "function"), void 0, factory.createIdentifier("Symbol"), void 0, factory.createIdentifier("Object"));
        }
        function getGlobalBigIntNameWithFallback() {
          return languageVersion < 99 ? factory.createConditionalExpression(factory.createTypeCheck(factory.createIdentifier("BigInt"), "function"), void 0, factory.createIdentifier("BigInt"), void 0, factory.createIdentifier("Object")) : factory.createIdentifier("BigInt");
        }
        function getExpressionForPropertyName(member, generateNameForComputedPropertyName) {
          var name = member.name;
          if (ts3.isPrivateIdentifier(name)) {
            return factory.createIdentifier("");
          } else if (ts3.isComputedPropertyName(name)) {
            return generateNameForComputedPropertyName && !ts3.isSimpleInlineableExpression(name.expression) ? factory.getGeneratedNameForNode(name) : name.expression;
          } else if (ts3.isIdentifier(name)) {
            return factory.createStringLiteral(ts3.idText(name));
          } else {
            return factory.cloneNode(name);
          }
        }
        function visitPropertyNameOfClassElement(member) {
          var name = member.name;
          if (ts3.isComputedPropertyName(name) && (!ts3.hasStaticModifier(member) && currentClassHasParameterProperties || ts3.some(member.decorators))) {
            var expression = ts3.visitNode(name.expression, visitor, ts3.isExpression);
            var innerExpression = ts3.skipPartiallyEmittedExpressions(expression);
            if (!ts3.isSimpleInlineableExpression(innerExpression)) {
              var generatedName = factory.getGeneratedNameForNode(name);
              hoistVariableDeclaration(generatedName);
              return factory.updateComputedPropertyName(name, factory.createAssignment(generatedName, expression));
            }
          }
          return ts3.visitNode(name, visitor, ts3.isPropertyName);
        }
        function visitHeritageClause(node) {
          if (node.token === 116) {
            return void 0;
          }
          return ts3.visitEachChild(node, visitor, context);
        }
        function visitExpressionWithTypeArguments(node) {
          return factory.updateExpressionWithTypeArguments(node, ts3.visitNode(node.expression, visitor, ts3.isLeftHandSideExpression), void 0);
        }
        function shouldEmitFunctionLikeDeclaration(node) {
          return !ts3.nodeIsMissing(node.body);
        }
        function visitPropertyDeclaration(node) {
          if (node.flags & 8388608 || ts3.hasSyntacticModifier(node, 128)) {
            return void 0;
          }
          var updated = factory.updatePropertyDeclaration(node, void 0, ts3.visitNodes(node.modifiers, visitor, ts3.isModifier), visitPropertyNameOfClassElement(node), void 0, void 0, ts3.visitNode(node.initializer, visitor));
          if (updated !== node) {
            ts3.setCommentRange(updated, node);
            ts3.setSourceMapRange(updated, ts3.moveRangePastDecorators(node));
          }
          return updated;
        }
        function visitConstructor(node) {
          if (!shouldEmitFunctionLikeDeclaration(node)) {
            return void 0;
          }
          return factory.updateConstructorDeclaration(node, void 0, void 0, ts3.visitParameterList(node.parameters, visitor, context), transformConstructorBody(node.body, node));
        }
        function transformConstructorBody(body, constructor) {
          var parametersWithPropertyAssignments = constructor && ts3.filter(constructor.parameters, function(p) {
            return ts3.isParameterPropertyDeclaration(p, constructor);
          });
          if (!ts3.some(parametersWithPropertyAssignments)) {
            return ts3.visitFunctionBody(body, visitor, context);
          }
          var statements = [];
          var indexOfFirstStatement = 0;
          resumeLexicalEnvironment();
          indexOfFirstStatement = ts3.addPrologueDirectivesAndInitialSuperCall(factory, constructor, statements, visitor);
          ts3.addRange(statements, ts3.map(parametersWithPropertyAssignments, transformParameterWithPropertyAssignment));
          ts3.addRange(statements, ts3.visitNodes(body.statements, visitor, ts3.isStatement, indexOfFirstStatement));
          statements = factory.mergeLexicalEnvironment(statements, endLexicalEnvironment());
          var block = factory.createBlock(ts3.setTextRange(factory.createNodeArray(statements), body.statements), true);
          ts3.setTextRange(block, body);
          ts3.setOriginalNode(block, body);
          return block;
        }
        function transformParameterWithPropertyAssignment(node) {
          var name = node.name;
          if (!ts3.isIdentifier(name)) {
            return void 0;
          }
          var propertyName = ts3.setParent(ts3.setTextRange(factory.cloneNode(name), name), name.parent);
          ts3.setEmitFlags(propertyName, 1536 | 48);
          var localName = ts3.setParent(ts3.setTextRange(factory.cloneNode(name), name), name.parent);
          ts3.setEmitFlags(localName, 1536);
          return ts3.startOnNewLine(ts3.removeAllComments(ts3.setTextRange(ts3.setOriginalNode(factory.createExpressionStatement(factory.createAssignment(ts3.setTextRange(factory.createPropertyAccessExpression(factory.createThis(), propertyName), node.name), localName)), node), ts3.moveRangePos(node, -1))));
        }
        function visitMethodDeclaration(node) {
          if (!shouldEmitFunctionLikeDeclaration(node)) {
            return void 0;
          }
          var updated = factory.updateMethodDeclaration(node, void 0, ts3.visitNodes(node.modifiers, modifierVisitor, ts3.isModifier), node.asteriskToken, visitPropertyNameOfClassElement(node), void 0, void 0, ts3.visitParameterList(node.parameters, visitor, context), void 0, ts3.visitFunctionBody(node.body, visitor, context));
          if (updated !== node) {
            ts3.setCommentRange(updated, node);
            ts3.setSourceMapRange(updated, ts3.moveRangePastDecorators(node));
          }
          return updated;
        }
        function shouldEmitAccessorDeclaration(node) {
          return !(ts3.nodeIsMissing(node.body) && ts3.hasSyntacticModifier(node, 128));
        }
        function visitGetAccessor(node) {
          if (!shouldEmitAccessorDeclaration(node)) {
            return void 0;
          }
          var updated = factory.updateGetAccessorDeclaration(node, void 0, ts3.visitNodes(node.modifiers, modifierVisitor, ts3.isModifier), visitPropertyNameOfClassElement(node), ts3.visitParameterList(node.parameters, visitor, context), void 0, ts3.visitFunctionBody(node.body, visitor, context) || factory.createBlock([]));
          if (updated !== node) {
            ts3.setCommentRange(updated, node);
            ts3.setSourceMapRange(updated, ts3.moveRangePastDecorators(node));
          }
          return updated;
        }
        function visitSetAccessor(node) {
          if (!shouldEmitAccessorDeclaration(node)) {
            return void 0;
          }
          var updated = factory.updateSetAccessorDeclaration(node, void 0, ts3.visitNodes(node.modifiers, modifierVisitor, ts3.isModifier), visitPropertyNameOfClassElement(node), ts3.visitParameterList(node.parameters, visitor, context), ts3.visitFunctionBody(node.body, visitor, context) || factory.createBlock([]));
          if (updated !== node) {
            ts3.setCommentRange(updated, node);
            ts3.setSourceMapRange(updated, ts3.moveRangePastDecorators(node));
          }
          return updated;
        }
        function visitFunctionDeclaration(node) {
          if (!shouldEmitFunctionLikeDeclaration(node)) {
            return factory.createNotEmittedStatement(node);
          }
          var updated = factory.updateFunctionDeclaration(node, void 0, ts3.visitNodes(node.modifiers, modifierVisitor, ts3.isModifier), node.asteriskToken, node.name, void 0, ts3.visitParameterList(node.parameters, visitor, context), void 0, ts3.visitFunctionBody(node.body, visitor, context) || factory.createBlock([]));
          if (isExportOfNamespace(node)) {
            var statements = [updated];
            addExportMemberAssignment(statements, node);
            return statements;
          }
          return updated;
        }
        function visitFunctionExpression(node) {
          if (!shouldEmitFunctionLikeDeclaration(node)) {
            return factory.createOmittedExpression();
          }
          var updated = factory.updateFunctionExpression(node, ts3.visitNodes(node.modifiers, modifierVisitor, ts3.isModifier), node.asteriskToken, node.name, void 0, ts3.visitParameterList(node.parameters, visitor, context), void 0, ts3.visitFunctionBody(node.body, visitor, context) || factory.createBlock([]));
          return updated;
        }
        function visitArrowFunction(node) {
          var updated = factory.updateArrowFunction(node, ts3.visitNodes(node.modifiers, modifierVisitor, ts3.isModifier), void 0, ts3.visitParameterList(node.parameters, visitor, context), void 0, node.equalsGreaterThanToken, ts3.visitFunctionBody(node.body, visitor, context));
          return updated;
        }
        function visitParameter(node) {
          if (ts3.parameterIsThisKeyword(node)) {
            return void 0;
          }
          var updated = factory.updateParameterDeclaration(node, void 0, void 0, node.dotDotDotToken, ts3.visitNode(node.name, visitor, ts3.isBindingName), void 0, void 0, ts3.visitNode(node.initializer, visitor, ts3.isExpression));
          if (updated !== node) {
            ts3.setCommentRange(updated, node);
            ts3.setTextRange(updated, ts3.moveRangePastModifiers(node));
            ts3.setSourceMapRange(updated, ts3.moveRangePastModifiers(node));
            ts3.setEmitFlags(updated.name, 32);
          }
          return updated;
        }
        function visitVariableStatement(node) {
          if (isExportOfNamespace(node)) {
            var variables = ts3.getInitializedVariables(node.declarationList);
            if (variables.length === 0) {
              return void 0;
            }
            return ts3.setTextRange(factory.createExpressionStatement(factory.inlineExpressions(ts3.map(variables, transformInitializedVariable))), node);
          } else {
            return ts3.visitEachChild(node, visitor, context);
          }
        }
        function transformInitializedVariable(node) {
          var name = node.name;
          if (ts3.isBindingPattern(name)) {
            return ts3.flattenDestructuringAssignment(node, visitor, context, 0, false, createNamespaceExportExpression);
          } else {
            return ts3.setTextRange(factory.createAssignment(getNamespaceMemberNameWithSourceMapsAndWithoutComments(name), ts3.visitNode(node.initializer, visitor, ts3.isExpression)), node);
          }
        }
        function visitVariableDeclaration(node) {
          return factory.updateVariableDeclaration(node, ts3.visitNode(node.name, visitor, ts3.isBindingName), void 0, void 0, ts3.visitNode(node.initializer, visitor, ts3.isExpression));
        }
        function visitParenthesizedExpression(node) {
          var innerExpression = ts3.skipOuterExpressions(node.expression, ~6);
          if (ts3.isAssertionExpression(innerExpression)) {
            var expression = ts3.visitNode(node.expression, visitor, ts3.isExpression);
            if (ts3.length(ts3.getLeadingCommentRangesOfNode(expression, currentSourceFile))) {
              return factory.updateParenthesizedExpression(node, expression);
            }
            return factory.createPartiallyEmittedExpression(expression, node);
          }
          return ts3.visitEachChild(node, visitor, context);
        }
        function visitAssertionExpression(node) {
          var expression = ts3.visitNode(node.expression, visitor, ts3.isExpression);
          return factory.createPartiallyEmittedExpression(expression, node);
        }
        function visitNonNullExpression(node) {
          var expression = ts3.visitNode(node.expression, visitor, ts3.isLeftHandSideExpression);
          return factory.createPartiallyEmittedExpression(expression, node);
        }
        function visitCallExpression(node) {
          return factory.updateCallExpression(node, ts3.visitNode(node.expression, visitor, ts3.isExpression), void 0, ts3.visitNodes(node.arguments, visitor, ts3.isExpression));
        }
        function visitNewExpression(node) {
          return factory.updateNewExpression(node, ts3.visitNode(node.expression, visitor, ts3.isExpression), void 0, ts3.visitNodes(node.arguments, visitor, ts3.isExpression));
        }
        function visitTaggedTemplateExpression(node) {
          return factory.updateTaggedTemplateExpression(node, ts3.visitNode(node.tag, visitor, ts3.isExpression), void 0, ts3.visitNode(node.template, visitor, ts3.isExpression));
        }
        function visitJsxSelfClosingElement(node) {
          return factory.updateJsxSelfClosingElement(node, ts3.visitNode(node.tagName, visitor, ts3.isJsxTagNameExpression), void 0, ts3.visitNode(node.attributes, visitor, ts3.isJsxAttributes));
        }
        function visitJsxJsxOpeningElement(node) {
          return factory.updateJsxOpeningElement(node, ts3.visitNode(node.tagName, visitor, ts3.isJsxTagNameExpression), void 0, ts3.visitNode(node.attributes, visitor, ts3.isJsxAttributes));
        }
        function shouldEmitEnumDeclaration(node) {
          return !ts3.isEnumConst(node) || ts3.shouldPreserveConstEnums(compilerOptions);
        }
        function visitEnumDeclaration(node) {
          if (!shouldEmitEnumDeclaration(node)) {
            return factory.createNotEmittedStatement(node);
          }
          var statements = [];
          var emitFlags = 2;
          var varAdded = addVarForEnumOrModuleDeclaration(statements, node);
          if (varAdded) {
            if (moduleKind !== ts3.ModuleKind.System || currentLexicalScope !== currentSourceFile) {
              emitFlags |= 512;
            }
          }
          var parameterName = getNamespaceParameterName(node);
          var containerName = getNamespaceContainerName(node);
          var exportName = ts3.hasSyntacticModifier(node, 1) ? factory.getExternalModuleOrNamespaceExportName(currentNamespaceContainerName, node, false, true) : factory.getLocalName(node, false, true);
          var moduleArg = factory.createLogicalOr(exportName, factory.createAssignment(exportName, factory.createObjectLiteralExpression()));
          if (hasNamespaceQualifiedExportName(node)) {
            var localName = factory.getLocalName(node, false, true);
            moduleArg = factory.createAssignment(localName, moduleArg);
          }
          var enumStatement = factory.createExpressionStatement(factory.createCallExpression(factory.createFunctionExpression(void 0, void 0, void 0, void 0, [factory.createParameterDeclaration(void 0, void 0, void 0, parameterName)], void 0, transformEnumBody(node, containerName)), void 0, [moduleArg]));
          ts3.setOriginalNode(enumStatement, node);
          if (varAdded) {
            ts3.setSyntheticLeadingComments(enumStatement, void 0);
            ts3.setSyntheticTrailingComments(enumStatement, void 0);
          }
          ts3.setTextRange(enumStatement, node);
          ts3.addEmitFlags(enumStatement, emitFlags);
          statements.push(enumStatement);
          statements.push(factory.createEndOfDeclarationMarker(node));
          return statements;
        }
        function transformEnumBody(node, localName) {
          var savedCurrentNamespaceLocalName = currentNamespaceContainerName;
          currentNamespaceContainerName = localName;
          var statements = [];
          startLexicalEnvironment();
          var members = ts3.map(node.members, transformEnumMember);
          ts3.insertStatementsAfterStandardPrologue(statements, endLexicalEnvironment());
          ts3.addRange(statements, members);
          currentNamespaceContainerName = savedCurrentNamespaceLocalName;
          return factory.createBlock(ts3.setTextRange(factory.createNodeArray(statements), node.members), true);
        }
        function transformEnumMember(member) {
          var name = getExpressionForPropertyName(member, false);
          var valueExpression = transformEnumMemberDeclarationValue(member);
          var innerAssignment = factory.createAssignment(factory.createElementAccessExpression(currentNamespaceContainerName, name), valueExpression);
          var outerAssignment = valueExpression.kind === 10 ? innerAssignment : factory.createAssignment(factory.createElementAccessExpression(currentNamespaceContainerName, innerAssignment), name);
          return ts3.setTextRange(factory.createExpressionStatement(ts3.setTextRange(outerAssignment, member)), member);
        }
        function transformEnumMemberDeclarationValue(member) {
          var value = resolver.getConstantValue(member);
          if (value !== void 0) {
            return typeof value === "string" ? factory.createStringLiteral(value) : factory.createNumericLiteral(value);
          } else {
            enableSubstitutionForNonQualifiedEnumMembers();
            if (member.initializer) {
              return ts3.visitNode(member.initializer, visitor, ts3.isExpression);
            } else {
              return factory.createVoidZero();
            }
          }
        }
        function shouldEmitModuleDeclaration(nodeIn) {
          var node = ts3.getParseTreeNode(nodeIn, ts3.isModuleDeclaration);
          if (!node) {
            return true;
          }
          return ts3.isInstantiatedModule(node, ts3.shouldPreserveConstEnums(compilerOptions));
        }
        function hasNamespaceQualifiedExportName(node) {
          return isExportOfNamespace(node) || isExternalModuleExport(node) && moduleKind !== ts3.ModuleKind.ES2015 && moduleKind !== ts3.ModuleKind.ES2020 && moduleKind !== ts3.ModuleKind.ESNext && moduleKind !== ts3.ModuleKind.System;
        }
        function recordEmittedDeclarationInScope(node) {
          if (!currentScopeFirstDeclarationsOfName) {
            currentScopeFirstDeclarationsOfName = new ts3.Map();
          }
          var name = declaredNameInScope(node);
          if (!currentScopeFirstDeclarationsOfName.has(name)) {
            currentScopeFirstDeclarationsOfName.set(name, node);
          }
        }
        function isFirstEmittedDeclarationInScope(node) {
          if (currentScopeFirstDeclarationsOfName) {
            var name = declaredNameInScope(node);
            return currentScopeFirstDeclarationsOfName.get(name) === node;
          }
          return true;
        }
        function declaredNameInScope(node) {
          ts3.Debug.assertNode(node.name, ts3.isIdentifier);
          return node.name.escapedText;
        }
        function addVarForEnumOrModuleDeclaration(statements, node) {
          var statement = factory.createVariableStatement(ts3.visitNodes(node.modifiers, modifierVisitor, ts3.isModifier), factory.createVariableDeclarationList([
            factory.createVariableDeclaration(factory.getLocalName(node, false, true))
          ], currentLexicalScope.kind === 298 ? 0 : 1));
          ts3.setOriginalNode(statement, node);
          recordEmittedDeclarationInScope(node);
          if (isFirstEmittedDeclarationInScope(node)) {
            if (node.kind === 256) {
              ts3.setSourceMapRange(statement.declarationList, node);
            } else {
              ts3.setSourceMapRange(statement, node);
            }
            ts3.setCommentRange(statement, node);
            ts3.addEmitFlags(statement, 1024 | 4194304);
            statements.push(statement);
            return true;
          } else {
            var mergeMarker = factory.createMergeDeclarationMarker(statement);
            ts3.setEmitFlags(mergeMarker, 1536 | 4194304);
            statements.push(mergeMarker);
            return false;
          }
        }
        function visitModuleDeclaration(node) {
          if (!shouldEmitModuleDeclaration(node)) {
            return factory.createNotEmittedStatement(node);
          }
          ts3.Debug.assertNode(node.name, ts3.isIdentifier, "A TypeScript namespace should have an Identifier name.");
          enableSubstitutionForNamespaceExports();
          var statements = [];
          var emitFlags = 2;
          var varAdded = addVarForEnumOrModuleDeclaration(statements, node);
          if (varAdded) {
            if (moduleKind !== ts3.ModuleKind.System || currentLexicalScope !== currentSourceFile) {
              emitFlags |= 512;
            }
          }
          var parameterName = getNamespaceParameterName(node);
          var containerName = getNamespaceContainerName(node);
          var exportName = ts3.hasSyntacticModifier(node, 1) ? factory.getExternalModuleOrNamespaceExportName(currentNamespaceContainerName, node, false, true) : factory.getLocalName(node, false, true);
          var moduleArg = factory.createLogicalOr(exportName, factory.createAssignment(exportName, factory.createObjectLiteralExpression()));
          if (hasNamespaceQualifiedExportName(node)) {
            var localName = factory.getLocalName(node, false, true);
            moduleArg = factory.createAssignment(localName, moduleArg);
          }
          var moduleStatement = factory.createExpressionStatement(factory.createCallExpression(factory.createFunctionExpression(void 0, void 0, void 0, void 0, [factory.createParameterDeclaration(void 0, void 0, void 0, parameterName)], void 0, transformModuleBody(node, containerName)), void 0, [moduleArg]));
          ts3.setOriginalNode(moduleStatement, node);
          if (varAdded) {
            ts3.setSyntheticLeadingComments(moduleStatement, void 0);
            ts3.setSyntheticTrailingComments(moduleStatement, void 0);
          }
          ts3.setTextRange(moduleStatement, node);
          ts3.addEmitFlags(moduleStatement, emitFlags);
          statements.push(moduleStatement);
          statements.push(factory.createEndOfDeclarationMarker(node));
          return statements;
        }
        function transformModuleBody(node, namespaceLocalName) {
          var savedCurrentNamespaceContainerName = currentNamespaceContainerName;
          var savedCurrentNamespace = currentNamespace;
          var savedCurrentScopeFirstDeclarationsOfName = currentScopeFirstDeclarationsOfName;
          currentNamespaceContainerName = namespaceLocalName;
          currentNamespace = node;
          currentScopeFirstDeclarationsOfName = void 0;
          var statements = [];
          startLexicalEnvironment();
          var statementsLocation;
          var blockLocation;
          if (node.body) {
            if (node.body.kind === 258) {
              saveStateAndInvoke(node.body, function(body) {
                return ts3.addRange(statements, ts3.visitNodes(body.statements, namespaceElementVisitor, ts3.isStatement));
              });
              statementsLocation = node.body.statements;
              blockLocation = node.body;
            } else {
              var result2 = visitModuleDeclaration(node.body);
              if (result2) {
                if (ts3.isArray(result2)) {
                  ts3.addRange(statements, result2);
                } else {
                  statements.push(result2);
                }
              }
              var moduleBlock = getInnerMostModuleDeclarationFromDottedModule(node).body;
              statementsLocation = ts3.moveRangePos(moduleBlock.statements, -1);
            }
          }
          ts3.insertStatementsAfterStandardPrologue(statements, endLexicalEnvironment());
          currentNamespaceContainerName = savedCurrentNamespaceContainerName;
          currentNamespace = savedCurrentNamespace;
          currentScopeFirstDeclarationsOfName = savedCurrentScopeFirstDeclarationsOfName;
          var block = factory.createBlock(ts3.setTextRange(factory.createNodeArray(statements), statementsLocation), true);
          ts3.setTextRange(block, blockLocation);
          if (!node.body || node.body.kind !== 258) {
            ts3.setEmitFlags(block, ts3.getEmitFlags(block) | 1536);
          }
          return block;
        }
        function getInnerMostModuleDeclarationFromDottedModule(moduleDeclaration) {
          if (moduleDeclaration.body.kind === 257) {
            var recursiveInnerModule = getInnerMostModuleDeclarationFromDottedModule(moduleDeclaration.body);
            return recursiveInnerModule || moduleDeclaration.body;
          }
        }
        function visitImportDeclaration(node) {
          if (!node.importClause) {
            return node;
          }
          if (node.importClause.isTypeOnly) {
            return void 0;
          }
          var importClause = ts3.visitNode(node.importClause, visitImportClause, ts3.isImportClause);
          return importClause || compilerOptions.importsNotUsedAsValues === 1 || compilerOptions.importsNotUsedAsValues === 2 ? factory.updateImportDeclaration(node, void 0, void 0, importClause, node.moduleSpecifier) : void 0;
        }
        function visitImportClause(node) {
          if (node.isTypeOnly) {
            return void 0;
          }
          var name = resolver.isReferencedAliasDeclaration(node) ? node.name : void 0;
          var namedBindings = ts3.visitNode(node.namedBindings, visitNamedImportBindings, ts3.isNamedImportBindings);
          return name || namedBindings ? factory.updateImportClause(node, false, name, namedBindings) : void 0;
        }
        function visitNamedImportBindings(node) {
          if (node.kind === 264) {
            return resolver.isReferencedAliasDeclaration(node) ? node : void 0;
          } else {
            var elements = ts3.visitNodes(node.elements, visitImportSpecifier, ts3.isImportSpecifier);
            return ts3.some(elements) ? factory.updateNamedImports(node, elements) : void 0;
          }
        }
        function visitImportSpecifier(node) {
          return resolver.isReferencedAliasDeclaration(node) ? node : void 0;
        }
        function visitExportAssignment(node) {
          return resolver.isValueAliasDeclaration(node) ? ts3.visitEachChild(node, visitor, context) : void 0;
        }
        function visitExportDeclaration(node) {
          if (node.isTypeOnly) {
            return void 0;
          }
          if (!node.exportClause || ts3.isNamespaceExport(node.exportClause)) {
            return node;
          }
          if (!resolver.isValueAliasDeclaration(node)) {
            return void 0;
          }
          var exportClause = ts3.visitNode(node.exportClause, visitNamedExportBindings, ts3.isNamedExportBindings);
          return exportClause ? factory.updateExportDeclaration(node, void 0, void 0, node.isTypeOnly, exportClause, node.moduleSpecifier) : void 0;
        }
        function visitNamedExports(node) {
          var elements = ts3.visitNodes(node.elements, visitExportSpecifier, ts3.isExportSpecifier);
          return ts3.some(elements) ? factory.updateNamedExports(node, elements) : void 0;
        }
        function visitNamespaceExports(node) {
          return factory.updateNamespaceExport(node, ts3.visitNode(node.name, visitor, ts3.isIdentifier));
        }
        function visitNamedExportBindings(node) {
          return ts3.isNamespaceExport(node) ? visitNamespaceExports(node) : visitNamedExports(node);
        }
        function visitExportSpecifier(node) {
          return resolver.isValueAliasDeclaration(node) ? node : void 0;
        }
        function shouldEmitImportEqualsDeclaration(node) {
          return resolver.isReferencedAliasDeclaration(node) || !ts3.isExternalModule(currentSourceFile) && resolver.isTopLevelValueImportEqualsWithEntityName(node);
        }
        function visitImportEqualsDeclaration(node) {
          if (node.isTypeOnly) {
            return void 0;
          }
          if (ts3.isExternalModuleImportEqualsDeclaration(node)) {
            var isReferenced = resolver.isReferencedAliasDeclaration(node);
            if (!isReferenced && compilerOptions.importsNotUsedAsValues === 1) {
              return ts3.setOriginalNode(ts3.setTextRange(factory.createImportDeclaration(void 0, void 0, void 0, node.moduleReference.expression), node), node);
            }
            return isReferenced ? ts3.visitEachChild(node, visitor, context) : void 0;
          }
          if (!shouldEmitImportEqualsDeclaration(node)) {
            return void 0;
          }
          var moduleReference = ts3.createExpressionFromEntityName(factory, node.moduleReference);
          ts3.setEmitFlags(moduleReference, 1536 | 2048);
          if (isNamedExternalModuleExport(node) || !isExportOfNamespace(node)) {
            return ts3.setOriginalNode(ts3.setTextRange(factory.createVariableStatement(ts3.visitNodes(node.modifiers, modifierVisitor, ts3.isModifier), factory.createVariableDeclarationList([
              ts3.setOriginalNode(factory.createVariableDeclaration(node.name, void 0, void 0, moduleReference), node)
            ])), node), node);
          } else {
            return ts3.setOriginalNode(createNamespaceExport(node.name, moduleReference, node), node);
          }
        }
        function isExportOfNamespace(node) {
          return currentNamespace !== void 0 && ts3.hasSyntacticModifier(node, 1);
        }
        function isExternalModuleExport(node) {
          return currentNamespace === void 0 && ts3.hasSyntacticModifier(node, 1);
        }
        function isNamedExternalModuleExport(node) {
          return isExternalModuleExport(node) && !ts3.hasSyntacticModifier(node, 512);
        }
        function isDefaultExternalModuleExport(node) {
          return isExternalModuleExport(node) && ts3.hasSyntacticModifier(node, 512);
        }
        function expressionToStatement(expression) {
          return factory.createExpressionStatement(expression);
        }
        function addExportMemberAssignment(statements, node) {
          var expression = factory.createAssignment(factory.getExternalModuleOrNamespaceExportName(currentNamespaceContainerName, node, false, true), factory.getLocalName(node));
          ts3.setSourceMapRange(expression, ts3.createRange(node.name ? node.name.pos : node.pos, node.end));
          var statement = factory.createExpressionStatement(expression);
          ts3.setSourceMapRange(statement, ts3.createRange(-1, node.end));
          statements.push(statement);
        }
        function createNamespaceExport(exportName, exportValue, location) {
          return ts3.setTextRange(factory.createExpressionStatement(factory.createAssignment(factory.getNamespaceMemberName(currentNamespaceContainerName, exportName, false, true), exportValue)), location);
        }
        function createNamespaceExportExpression(exportName, exportValue, location) {
          return ts3.setTextRange(factory.createAssignment(getNamespaceMemberNameWithSourceMapsAndWithoutComments(exportName), exportValue), location);
        }
        function getNamespaceMemberNameWithSourceMapsAndWithoutComments(name) {
          return factory.getNamespaceMemberName(currentNamespaceContainerName, name, false, true);
        }
        function getNamespaceParameterName(node) {
          var name = factory.getGeneratedNameForNode(node);
          ts3.setSourceMapRange(name, node.name);
          return name;
        }
        function getNamespaceContainerName(node) {
          return factory.getGeneratedNameForNode(node);
        }
        function getClassAliasIfNeeded(node) {
          if (resolver.getNodeCheckFlags(node) & 16777216) {
            enableSubstitutionForClassAliases();
            var classAlias = factory.createUniqueName(node.name && !ts3.isGeneratedIdentifier(node.name) ? ts3.idText(node.name) : "default");
            classAliases[ts3.getOriginalNodeId(node)] = classAlias;
            hoistVariableDeclaration(classAlias);
            return classAlias;
          }
        }
        function getClassPrototype(node) {
          return factory.createPropertyAccessExpression(factory.getDeclarationName(node), "prototype");
        }
        function getClassMemberPrefix(node, member) {
          return ts3.hasSyntacticModifier(member, 32) ? factory.getDeclarationName(node) : getClassPrototype(node);
        }
        function enableSubstitutionForNonQualifiedEnumMembers() {
          if ((enabledSubstitutions & 8) === 0) {
            enabledSubstitutions |= 8;
            context.enableSubstitution(78);
          }
        }
        function enableSubstitutionForClassAliases() {
          if ((enabledSubstitutions & 1) === 0) {
            enabledSubstitutions |= 1;
            context.enableSubstitution(78);
            classAliases = [];
          }
        }
        function enableSubstitutionForNamespaceExports() {
          if ((enabledSubstitutions & 2) === 0) {
            enabledSubstitutions |= 2;
            context.enableSubstitution(78);
            context.enableSubstitution(290);
            context.enableEmitNotification(257);
          }
        }
        function isTransformedModuleDeclaration(node) {
          return ts3.getOriginalNode(node).kind === 257;
        }
        function isTransformedEnumDeclaration(node) {
          return ts3.getOriginalNode(node).kind === 256;
        }
        function onEmitNode(hint, node, emitCallback) {
          var savedApplicableSubstitutions = applicableSubstitutions;
          var savedCurrentSourceFile = currentSourceFile;
          if (ts3.isSourceFile(node)) {
            currentSourceFile = node;
          }
          if (enabledSubstitutions & 2 && isTransformedModuleDeclaration(node)) {
            applicableSubstitutions |= 2;
          }
          if (enabledSubstitutions & 8 && isTransformedEnumDeclaration(node)) {
            applicableSubstitutions |= 8;
          }
          previousOnEmitNode(hint, node, emitCallback);
          applicableSubstitutions = savedApplicableSubstitutions;
          currentSourceFile = savedCurrentSourceFile;
        }
        function onSubstituteNode(hint, node) {
          node = previousOnSubstituteNode(hint, node);
          if (hint === 1) {
            return substituteExpression(node);
          } else if (ts3.isShorthandPropertyAssignment(node)) {
            return substituteShorthandPropertyAssignment(node);
          }
          return node;
        }
        function substituteShorthandPropertyAssignment(node) {
          if (enabledSubstitutions & 2) {
            var name = node.name;
            var exportedName = trySubstituteNamespaceExportedName(name);
            if (exportedName) {
              if (node.objectAssignmentInitializer) {
                var initializer = factory.createAssignment(exportedName, node.objectAssignmentInitializer);
                return ts3.setTextRange(factory.createPropertyAssignment(name, initializer), node);
              }
              return ts3.setTextRange(factory.createPropertyAssignment(name, exportedName), node);
            }
          }
          return node;
        }
        function substituteExpression(node) {
          switch (node.kind) {
            case 78:
              return substituteExpressionIdentifier(node);
            case 202:
              return substitutePropertyAccessExpression(node);
            case 203:
              return substituteElementAccessExpression(node);
          }
          return node;
        }
        function substituteExpressionIdentifier(node) {
          return trySubstituteClassAlias(node) || trySubstituteNamespaceExportedName(node) || node;
        }
        function trySubstituteClassAlias(node) {
          if (enabledSubstitutions & 1) {
            if (resolver.getNodeCheckFlags(node) & 33554432) {
              var declaration = resolver.getReferencedValueDeclaration(node);
              if (declaration) {
                var classAlias = classAliases[declaration.id];
                if (classAlias) {
                  var clone_2 = factory.cloneNode(classAlias);
                  ts3.setSourceMapRange(clone_2, node);
                  ts3.setCommentRange(clone_2, node);
                  return clone_2;
                }
              }
            }
          }
          return void 0;
        }
        function trySubstituteNamespaceExportedName(node) {
          if (enabledSubstitutions & applicableSubstitutions && !ts3.isGeneratedIdentifier(node) && !ts3.isLocalName(node)) {
            var container = resolver.getReferencedExportContainer(node, false);
            if (container && container.kind !== 298) {
              var substitute = applicableSubstitutions & 2 && container.kind === 257 || applicableSubstitutions & 8 && container.kind === 256;
              if (substitute) {
                return ts3.setTextRange(factory.createPropertyAccessExpression(factory.getGeneratedNameForNode(container), node), node);
              }
            }
          }
          return void 0;
        }
        function substitutePropertyAccessExpression(node) {
          return substituteConstantValue(node);
        }
        function substituteElementAccessExpression(node) {
          return substituteConstantValue(node);
        }
        function substituteConstantValue(node) {
          var constantValue = tryGetConstEnumValue(node);
          if (constantValue !== void 0) {
            ts3.setConstantValue(node, constantValue);
            var substitute = typeof constantValue === "string" ? factory.createStringLiteral(constantValue) : factory.createNumericLiteral(constantValue);
            if (!compilerOptions.removeComments) {
              var originalNode = ts3.getOriginalNode(node, ts3.isAccessExpression);
              var propertyName = ts3.isPropertyAccessExpression(originalNode) ? ts3.declarationNameToString(originalNode.name) : ts3.getTextOfNode(originalNode.argumentExpression);
              ts3.addSyntheticTrailingComment(substitute, 3, " " + propertyName + " ");
            }
            return substitute;
          }
          return node;
        }
        function tryGetConstEnumValue(node) {
          if (compilerOptions.isolatedModules) {
            return void 0;
          }
          return ts3.isPropertyAccessExpression(node) || ts3.isElementAccessExpression(node) ? resolver.getConstantValue(node) : void 0;
        }
      }
      ts3.transformTypeScript = transformTypeScript;
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var ClassPropertySubstitutionFlags;
      (function(ClassPropertySubstitutionFlags2) {
        ClassPropertySubstitutionFlags2[ClassPropertySubstitutionFlags2["ClassAliases"] = 1] = "ClassAliases";
      })(ClassPropertySubstitutionFlags || (ClassPropertySubstitutionFlags = {}));
      var PrivateIdentifierKind;
      (function(PrivateIdentifierKind2) {
        PrivateIdentifierKind2["Field"] = "f";
        PrivateIdentifierKind2["Method"] = "m";
        PrivateIdentifierKind2["Accessor"] = "a";
      })(PrivateIdentifierKind = ts3.PrivateIdentifierKind || (ts3.PrivateIdentifierKind = {}));
      function transformClassFields(context) {
        var factory = context.factory, hoistVariableDeclaration = context.hoistVariableDeclaration, endLexicalEnvironment = context.endLexicalEnvironment, resumeLexicalEnvironment = context.resumeLexicalEnvironment, addBlockScopedVariable = context.addBlockScopedVariable;
        var resolver = context.getEmitResolver();
        var compilerOptions = context.getCompilerOptions();
        var languageVersion = ts3.getEmitScriptTarget(compilerOptions);
        var useDefineForClassFields = ts3.getUseDefineForClassFields(compilerOptions);
        var shouldTransformPrivateElements = languageVersion < 99;
        var previousOnSubstituteNode = context.onSubstituteNode;
        context.onSubstituteNode = onSubstituteNode;
        var enabledSubstitutions;
        var classAliases;
        var pendingExpressions;
        var pendingStatements;
        var privateIdentifierEnvironmentStack = [];
        var currentPrivateIdentifierEnvironment;
        return ts3.chainBundle(context, transformSourceFile);
        function transformSourceFile(node) {
          var options = context.getCompilerOptions();
          if (node.isDeclarationFile || useDefineForClassFields && options.target === 99) {
            return node;
          }
          var visited = ts3.visitEachChild(node, visitor, context);
          ts3.addEmitHelpers(visited, context.readEmitHelpers());
          return visited;
        }
        function visitor(node) {
          if (!(node.transformFlags & 8388608))
            return node;
          switch (node.kind) {
            case 222:
            case 253:
              return visitClassLike(node);
            case 164:
              return visitPropertyDeclaration(node);
            case 233:
              return visitVariableStatement(node);
            case 202:
              return visitPropertyAccessExpression(node);
            case 215:
              return visitPrefixUnaryExpression(node);
            case 216:
              return visitPostfixUnaryExpression(node, false);
            case 204:
              return visitCallExpression(node);
            case 217:
              return visitBinaryExpression(node);
            case 79:
              return visitPrivateIdentifier(node);
            case 234:
              return visitExpressionStatement(node);
            case 238:
              return visitForStatement(node);
            case 206:
              return visitTaggedTemplateExpression(node);
          }
          return ts3.visitEachChild(node, visitor, context);
        }
        function visitorDestructuringTarget(node) {
          switch (node.kind) {
            case 201:
            case 200:
              return visitAssignmentPattern(node);
            default:
              return visitor(node);
          }
        }
        function visitPrivateIdentifier(node) {
          if (!shouldTransformPrivateElements) {
            return node;
          }
          return ts3.setOriginalNode(factory.createIdentifier(""), node);
        }
        function classElementVisitor(node) {
          switch (node.kind) {
            case 167:
              return void 0;
            case 168:
            case 169:
            case 166:
              return visitMethodOrAccessorDeclaration(node);
            case 164:
              return visitPropertyDeclaration(node);
            case 159:
              return visitComputedPropertyName(node);
            case 230:
              return node;
            default:
              return visitor(node);
          }
        }
        function visitVariableStatement(node) {
          var savedPendingStatements = pendingStatements;
          pendingStatements = [];
          var visitedNode = ts3.visitEachChild(node, visitor, context);
          var statement = ts3.some(pendingStatements) ? __spreadArray([visitedNode], pendingStatements) : visitedNode;
          pendingStatements = savedPendingStatements;
          return statement;
        }
        function visitComputedPropertyName(name) {
          var node = ts3.visitEachChild(name, visitor, context);
          if (ts3.some(pendingExpressions)) {
            var expressions = pendingExpressions;
            expressions.push(node.expression);
            pendingExpressions = [];
            node = factory.updateComputedPropertyName(node, factory.inlineExpressions(expressions));
          }
          return node;
        }
        function visitMethodOrAccessorDeclaration(node) {
          ts3.Debug.assert(!ts3.some(node.decorators));
          if (!shouldTransformPrivateElements || !ts3.isPrivateIdentifier(node.name)) {
            return ts3.visitEachChild(node, classElementVisitor, context);
          }
          var info = accessPrivateIdentifier(node.name);
          ts3.Debug.assert(info, "Undeclared private name for property declaration.");
          if (!info.isValid) {
            return node;
          }
          var functionName = getHoistedFunctionName(node);
          if (functionName) {
            getPendingExpressions().push(factory.createAssignment(functionName, factory.createFunctionExpression(ts3.filter(node.modifiers, function(m) {
              return !ts3.isStaticModifier(m);
            }), node.asteriskToken, functionName, void 0, ts3.visitParameterList(node.parameters, classElementVisitor, context), void 0, ts3.visitFunctionBody(node.body, classElementVisitor, context))));
          }
          return void 0;
        }
        function getHoistedFunctionName(node) {
          ts3.Debug.assert(ts3.isPrivateIdentifier(node.name));
          var info = accessPrivateIdentifier(node.name);
          ts3.Debug.assert(info, "Undeclared private name for property declaration.");
          if (info.kind === "m") {
            return info.methodName;
          }
          if (info.kind === "a") {
            if (ts3.isGetAccessor(node)) {
              return info.getterName;
            }
            if (ts3.isSetAccessor(node)) {
              return info.setterName;
            }
          }
        }
        function visitPropertyDeclaration(node) {
          ts3.Debug.assert(!ts3.some(node.decorators));
          if (ts3.isPrivateIdentifier(node.name)) {
            if (!shouldTransformPrivateElements) {
              return factory.updatePropertyDeclaration(node, void 0, ts3.visitNodes(node.modifiers, visitor, ts3.isModifier), node.name, void 0, void 0, void 0);
            }
            var info = accessPrivateIdentifier(node.name);
            ts3.Debug.assert(info, "Undeclared private name for property declaration.");
            if (!info.isValid) {
              return node;
            }
          }
          var expr = getPropertyNameExpressionIfNeeded(node.name, !!node.initializer || useDefineForClassFields);
          if (expr && !ts3.isSimpleInlineableExpression(expr)) {
            getPendingExpressions().push(expr);
          }
          return void 0;
        }
        function createPrivateIdentifierAccess(info, receiver) {
          return createPrivateIdentifierAccessHelper(info, ts3.visitNode(receiver, visitor, ts3.isExpression));
        }
        function createPrivateIdentifierAccessHelper(info, receiver) {
          ts3.setCommentRange(receiver, ts3.moveRangePos(receiver, -1));
          switch (info.kind) {
            case "a":
              return context.getEmitHelperFactory().createClassPrivateFieldGetHelper(receiver, info.brandCheckIdentifier, info.kind, info.getterName);
            case "m":
              return context.getEmitHelperFactory().createClassPrivateFieldGetHelper(receiver, info.brandCheckIdentifier, info.kind, info.methodName);
            case "f":
              return context.getEmitHelperFactory().createClassPrivateFieldGetHelper(receiver, info.brandCheckIdentifier, info.kind, info.variableName);
            default:
              ts3.Debug.assertNever(info, "Unknown private element type");
          }
        }
        function visitPropertyAccessExpression(node) {
          if (shouldTransformPrivateElements && ts3.isPrivateIdentifier(node.name)) {
            var privateIdentifierInfo = accessPrivateIdentifier(node.name);
            if (privateIdentifierInfo) {
              return ts3.setTextRange(ts3.setOriginalNode(createPrivateIdentifierAccess(privateIdentifierInfo, node.expression), node), node);
            }
          }
          return ts3.visitEachChild(node, visitor, context);
        }
        function visitPrefixUnaryExpression(node) {
          if (shouldTransformPrivateElements && ts3.isPrivateIdentifierPropertyAccessExpression(node.operand)) {
            var operator = node.operator === 45 ? 39 : node.operator === 46 ? 40 : void 0;
            var info = void 0;
            if (operator && (info = accessPrivateIdentifier(node.operand.name))) {
              var receiver = ts3.visitNode(node.operand.expression, visitor, ts3.isExpression);
              var _a2 = createCopiableReceiverExpr(receiver), readExpression = _a2.readExpression, initializeExpression = _a2.initializeExpression;
              var existingValue = factory.createPrefixUnaryExpression(39, createPrivateIdentifierAccess(info, readExpression));
              return ts3.setOriginalNode(createPrivateIdentifierAssignment(info, initializeExpression || readExpression, factory.createBinaryExpression(existingValue, operator, factory.createNumericLiteral(1)), 62), node);
            }
          }
          return ts3.visitEachChild(node, visitor, context);
        }
        function visitPostfixUnaryExpression(node, valueIsDiscarded) {
          if (shouldTransformPrivateElements && ts3.isPrivateIdentifierPropertyAccessExpression(node.operand)) {
            var operator = node.operator === 45 ? 39 : node.operator === 46 ? 40 : void 0;
            var info = void 0;
            if (operator && (info = accessPrivateIdentifier(node.operand.name))) {
              var receiver = ts3.visitNode(node.operand.expression, visitor, ts3.isExpression);
              var _a2 = createCopiableReceiverExpr(receiver), readExpression = _a2.readExpression, initializeExpression = _a2.initializeExpression;
              var existingValue = factory.createPrefixUnaryExpression(39, createPrivateIdentifierAccess(info, readExpression));
              var returnValue = valueIsDiscarded ? void 0 : factory.createTempVariable(hoistVariableDeclaration);
              return ts3.setOriginalNode(factory.inlineExpressions(ts3.compact([
                createPrivateIdentifierAssignment(info, initializeExpression || readExpression, factory.createBinaryExpression(returnValue ? factory.createAssignment(returnValue, existingValue) : existingValue, operator, factory.createNumericLiteral(1)), 62),
                returnValue
              ])), node);
            }
          }
          return ts3.visitEachChild(node, visitor, context);
        }
        function visitForStatement(node) {
          if (node.incrementor && ts3.isPostfixUnaryExpression(node.incrementor)) {
            return factory.updateForStatement(node, ts3.visitNode(node.initializer, visitor, ts3.isForInitializer), ts3.visitNode(node.condition, visitor, ts3.isExpression), visitPostfixUnaryExpression(node.incrementor, true), ts3.visitIterationBody(node.statement, visitor, context));
          }
          return ts3.visitEachChild(node, visitor, context);
        }
        function visitExpressionStatement(node) {
          if (ts3.isPostfixUnaryExpression(node.expression)) {
            return factory.updateExpressionStatement(node, visitPostfixUnaryExpression(node.expression, true));
          }
          return ts3.visitEachChild(node, visitor, context);
        }
        function createCopiableReceiverExpr(receiver) {
          var clone = ts3.nodeIsSynthesized(receiver) ? receiver : factory.cloneNode(receiver);
          if (ts3.isSimpleInlineableExpression(receiver)) {
            return { readExpression: clone, initializeExpression: void 0 };
          }
          var readExpression = factory.createTempVariable(hoistVariableDeclaration);
          var initializeExpression = factory.createAssignment(readExpression, clone);
          return { readExpression, initializeExpression };
        }
        function visitCallExpression(node) {
          if (shouldTransformPrivateElements && ts3.isPrivateIdentifierPropertyAccessExpression(node.expression)) {
            var _a2 = factory.createCallBinding(node.expression, hoistVariableDeclaration, languageVersion), thisArg = _a2.thisArg, target = _a2.target;
            if (ts3.isCallChain(node)) {
              return factory.updateCallChain(node, factory.createPropertyAccessChain(ts3.visitNode(target, visitor), node.questionDotToken, "call"), void 0, void 0, __spreadArray([ts3.visitNode(thisArg, visitor, ts3.isExpression)], ts3.visitNodes(node.arguments, visitor, ts3.isExpression)));
            }
            return factory.updateCallExpression(node, factory.createPropertyAccessExpression(ts3.visitNode(target, visitor), "call"), void 0, __spreadArray([ts3.visitNode(thisArg, visitor, ts3.isExpression)], ts3.visitNodes(node.arguments, visitor, ts3.isExpression)));
          }
          return ts3.visitEachChild(node, visitor, context);
        }
        function visitTaggedTemplateExpression(node) {
          if (shouldTransformPrivateElements && ts3.isPrivateIdentifierPropertyAccessExpression(node.tag)) {
            var _a2 = factory.createCallBinding(node.tag, hoistVariableDeclaration, languageVersion), thisArg = _a2.thisArg, target = _a2.target;
            return factory.updateTaggedTemplateExpression(node, factory.createCallExpression(factory.createPropertyAccessExpression(ts3.visitNode(target, visitor), "bind"), void 0, [ts3.visitNode(thisArg, visitor, ts3.isExpression)]), void 0, ts3.visitNode(node.template, visitor, ts3.isTemplateLiteral));
          }
          return ts3.visitEachChild(node, visitor, context);
        }
        function visitBinaryExpression(node) {
          if (shouldTransformPrivateElements) {
            if (ts3.isDestructuringAssignment(node)) {
              var savedPendingExpressions = pendingExpressions;
              pendingExpressions = void 0;
              node = factory.updateBinaryExpression(node, ts3.visitNode(node.left, visitorDestructuringTarget), node.operatorToken, ts3.visitNode(node.right, visitor));
              var expr = ts3.some(pendingExpressions) ? factory.inlineExpressions(ts3.compact(__spreadArray(__spreadArray([], pendingExpressions), [node]))) : node;
              pendingExpressions = savedPendingExpressions;
              return expr;
            }
            if (ts3.isAssignmentExpression(node) && ts3.isPrivateIdentifierPropertyAccessExpression(node.left)) {
              var info = accessPrivateIdentifier(node.left.name);
              if (info) {
                return ts3.setTextRange(ts3.setOriginalNode(createPrivateIdentifierAssignment(info, node.left.expression, node.right, node.operatorToken.kind), node), node);
              }
            }
          }
          return ts3.visitEachChild(node, visitor, context);
        }
        function createPrivateIdentifierAssignment(info, receiver, right, operator) {
          receiver = ts3.visitNode(receiver, visitor, ts3.isExpression);
          right = ts3.visitNode(right, visitor, ts3.isExpression);
          if (ts3.isCompoundAssignment(operator)) {
            var _a2 = createCopiableReceiverExpr(receiver), readExpression = _a2.readExpression, initializeExpression = _a2.initializeExpression;
            receiver = initializeExpression || readExpression;
            right = factory.createBinaryExpression(createPrivateIdentifierAccessHelper(info, readExpression), ts3.getNonAssignmentOperatorForCompoundAssignment(operator), right);
          }
          ts3.setCommentRange(receiver, ts3.moveRangePos(receiver, -1));
          switch (info.kind) {
            case "a":
              return context.getEmitHelperFactory().createClassPrivateFieldSetHelper(receiver, info.brandCheckIdentifier, right, info.kind, info.setterName);
            case "m":
              return context.getEmitHelperFactory().createClassPrivateFieldSetHelper(receiver, info.brandCheckIdentifier, right, info.kind, void 0);
            case "f":
              return context.getEmitHelperFactory().createClassPrivateFieldSetHelper(receiver, info.brandCheckIdentifier, right, info.kind, info.variableName);
            default:
              ts3.Debug.assertNever(info, "Unknown private element type");
          }
        }
        function visitClassLike(node) {
          var savedPendingExpressions = pendingExpressions;
          pendingExpressions = void 0;
          if (shouldTransformPrivateElements) {
            startPrivateIdentifierEnvironment();
            var name = ts3.getNameOfDeclaration(node);
            if (name && ts3.isIdentifier(name)) {
              getPrivateIdentifierEnvironment().className = ts3.idText(name);
            }
            var privateInstanceMethodsAndAccessors = getPrivateInstanceMethodsAndAccessors(node);
            if (ts3.some(privateInstanceMethodsAndAccessors)) {
              getPrivateIdentifierEnvironment().weakSetName = createHoistedVariableForClass("instances", privateInstanceMethodsAndAccessors[0].name);
            }
          }
          var result2 = ts3.isClassDeclaration(node) ? visitClassDeclaration(node) : visitClassExpression(node);
          if (shouldTransformPrivateElements) {
            endPrivateIdentifierEnvironment();
          }
          pendingExpressions = savedPendingExpressions;
          return result2;
        }
        function doesClassElementNeedTransform(node) {
          return ts3.isPropertyDeclaration(node) || shouldTransformPrivateElements && node.name && ts3.isPrivateIdentifier(node.name);
        }
        function getPrivateInstanceMethodsAndAccessors(node) {
          return ts3.filter(node.members, ts3.isNonStaticMethodOrAccessorWithPrivateName);
        }
        function visitClassDeclaration(node) {
          if (!ts3.forEach(node.members, doesClassElementNeedTransform)) {
            return ts3.visitEachChild(node, visitor, context);
          }
          var staticProperties = ts3.getProperties(node, false, true);
          var pendingPrivateStateAssignment;
          if (shouldTransformPrivateElements && ts3.some(node.members, function(m) {
            return ts3.hasStaticModifier(m) && !!m.name && ts3.isPrivateIdentifier(m.name);
          })) {
            var temp = factory.createTempVariable(hoistVariableDeclaration, true);
            getPrivateIdentifierEnvironment().classConstructor = factory.cloneNode(temp);
            pendingPrivateStateAssignment = factory.createAssignment(temp, factory.getInternalName(node));
          }
          var extendsClauseElement = ts3.getEffectiveBaseTypeNode(node);
          var isDerivedClass = !!(extendsClauseElement && ts3.skipOuterExpressions(extendsClauseElement.expression).kind !== 103);
          var statements = [
            factory.updateClassDeclaration(node, void 0, node.modifiers, node.name, void 0, ts3.visitNodes(node.heritageClauses, visitor, ts3.isHeritageClause), transformClassMembers(node, isDerivedClass))
          ];
          if (pendingPrivateStateAssignment) {
            getPendingExpressions().unshift(pendingPrivateStateAssignment);
          }
          if (ts3.some(pendingExpressions)) {
            statements.push(factory.createExpressionStatement(factory.inlineExpressions(pendingExpressions)));
          }
          if (ts3.some(staticProperties)) {
            addPropertyStatements(statements, staticProperties, factory.getInternalName(node));
          }
          return statements;
        }
        function visitClassExpression(node) {
          if (!ts3.forEach(node.members, doesClassElementNeedTransform)) {
            return ts3.visitEachChild(node, visitor, context);
          }
          var isDecoratedClassDeclaration = ts3.isClassDeclaration(ts3.getOriginalNode(node));
          var staticProperties = ts3.getProperties(node, false, true);
          var extendsClauseElement = ts3.getEffectiveBaseTypeNode(node);
          var isDerivedClass = !!(extendsClauseElement && ts3.skipOuterExpressions(extendsClauseElement.expression).kind !== 103);
          var isClassWithConstructorReference = resolver.getNodeCheckFlags(node) & 16777216;
          var temp;
          function createClassTempVar() {
            var classCheckFlags = resolver.getNodeCheckFlags(node);
            var isClassWithConstructorReference2 = classCheckFlags & 16777216;
            var requiresBlockScopedVar = classCheckFlags & 524288;
            return factory.createTempVariable(requiresBlockScopedVar ? addBlockScopedVariable : hoistVariableDeclaration, !!isClassWithConstructorReference2);
          }
          if (shouldTransformPrivateElements && ts3.some(node.members, function(m) {
            return ts3.hasStaticModifier(m) && !!m.name && ts3.isPrivateIdentifier(m.name);
          })) {
            temp = createClassTempVar();
            getPrivateIdentifierEnvironment().classConstructor = factory.cloneNode(temp);
          }
          var classExpression = factory.updateClassExpression(node, ts3.visitNodes(node.decorators, visitor, ts3.isDecorator), node.modifiers, node.name, void 0, ts3.visitNodes(node.heritageClauses, visitor, ts3.isHeritageClause), transformClassMembers(node, isDerivedClass));
          var hasTransformableStatics = ts3.some(staticProperties, function(p) {
            return !!p.initializer || shouldTransformPrivateElements && ts3.isPrivateIdentifier(p.name);
          });
          if (hasTransformableStatics || ts3.some(pendingExpressions)) {
            if (isDecoratedClassDeclaration) {
              ts3.Debug.assertIsDefined(pendingStatements, "Decorated classes transformed by TypeScript are expected to be within a variable declaration.");
              if (pendingStatements && pendingExpressions && ts3.some(pendingExpressions)) {
                pendingStatements.push(factory.createExpressionStatement(factory.inlineExpressions(pendingExpressions)));
              }
              if (pendingStatements && ts3.some(staticProperties)) {
                addPropertyStatements(pendingStatements, staticProperties, factory.getInternalName(node));
              }
              if (temp) {
                return factory.inlineExpressions([factory.createAssignment(temp, classExpression), temp]);
              }
              return classExpression;
            } else {
              var expressions = [];
              temp || (temp = createClassTempVar());
              if (isClassWithConstructorReference) {
                enableSubstitutionForClassAliases();
                var alias = factory.cloneNode(temp);
                alias.autoGenerateFlags &= ~8;
                classAliases[ts3.getOriginalNodeId(node)] = alias;
              }
              ts3.setEmitFlags(classExpression, 65536 | ts3.getEmitFlags(classExpression));
              expressions.push(ts3.startOnNewLine(factory.createAssignment(temp, classExpression)));
              ts3.addRange(expressions, ts3.map(pendingExpressions, ts3.startOnNewLine));
              ts3.addRange(expressions, generateInitializedPropertyExpressions(staticProperties, temp));
              expressions.push(ts3.startOnNewLine(temp));
              return factory.inlineExpressions(expressions);
            }
          }
          return classExpression;
        }
        function transformClassMembers(node, isDerivedClass) {
          if (shouldTransformPrivateElements) {
            for (var _i = 0, _a2 = node.members; _i < _a2.length; _i++) {
              var member = _a2[_i];
              if (ts3.isPrivateIdentifierClassElementDeclaration(member)) {
                addPrivateIdentifierToEnvironment(member);
              }
            }
            if (ts3.some(getPrivateInstanceMethodsAndAccessors(node))) {
              createBrandCheckWeakSetForPrivateMethods();
            }
          }
          var members = [];
          var constructor = transformConstructor(node, isDerivedClass);
          if (constructor) {
            members.push(constructor);
          }
          ts3.addRange(members, ts3.visitNodes(node.members, classElementVisitor, ts3.isClassElement));
          return ts3.setTextRange(factory.createNodeArray(members), node.members);
        }
        function createBrandCheckWeakSetForPrivateMethods() {
          var weakSetName = getPrivateIdentifierEnvironment().weakSetName;
          ts3.Debug.assert(weakSetName, "weakSetName should be set in private identifier environment");
          getPendingExpressions().push(factory.createAssignment(weakSetName, factory.createNewExpression(factory.createIdentifier("WeakSet"), void 0, [])));
        }
        function isClassElementThatRequiresConstructorStatement(member) {
          if (ts3.hasStaticModifier(member) || ts3.hasSyntacticModifier(ts3.getOriginalNode(member), 128)) {
            return false;
          }
          if (useDefineForClassFields) {
            return languageVersion < 99;
          }
          return ts3.isInitializedProperty(member) || shouldTransformPrivateElements && ts3.isPrivateIdentifierClassElementDeclaration(member);
        }
        function transformConstructor(node, isDerivedClass) {
          var constructor = ts3.visitNode(ts3.getFirstConstructorWithBody(node), visitor, ts3.isConstructorDeclaration);
          var elements = node.members.filter(isClassElementThatRequiresConstructorStatement);
          if (!ts3.some(elements)) {
            return constructor;
          }
          var parameters = ts3.visitParameterList(constructor ? constructor.parameters : void 0, visitor, context);
          var body = transformConstructorBody(node, constructor, isDerivedClass);
          if (!body) {
            return void 0;
          }
          return ts3.startOnNewLine(ts3.setOriginalNode(ts3.setTextRange(factory.createConstructorDeclaration(void 0, void 0, parameters !== null && parameters !== void 0 ? parameters : [], body), constructor || node), constructor));
        }
        function transformConstructorBody(node, constructor, isDerivedClass) {
          var properties = ts3.getProperties(node, false, false);
          if (!useDefineForClassFields) {
            properties = ts3.filter(properties, function(property) {
              return !!property.initializer || ts3.isPrivateIdentifier(property.name);
            });
          }
          var privateMethodsAndAccessors = getPrivateInstanceMethodsAndAccessors(node);
          var needsConstructorBody = ts3.some(properties) || ts3.some(privateMethodsAndAccessors);
          if (!constructor && !needsConstructorBody) {
            return ts3.visitFunctionBody(void 0, visitor, context);
          }
          resumeLexicalEnvironment();
          var indexOfFirstStatement = 0;
          var statements = [];
          if (!constructor && isDerivedClass) {
            statements.push(factory.createExpressionStatement(factory.createCallExpression(factory.createSuper(), void 0, [factory.createSpreadElement(factory.createIdentifier("arguments"))])));
          }
          if (constructor) {
            indexOfFirstStatement = ts3.addPrologueDirectivesAndInitialSuperCall(factory, constructor, statements, visitor);
          }
          if (constructor === null || constructor === void 0 ? void 0 : constructor.body) {
            var afterParameterProperties = ts3.findIndex(constructor.body.statements, function(s2) {
              return !ts3.isParameterPropertyDeclaration(ts3.getOriginalNode(s2), constructor);
            }, indexOfFirstStatement);
            if (afterParameterProperties === -1) {
              afterParameterProperties = constructor.body.statements.length;
            }
            if (afterParameterProperties > indexOfFirstStatement) {
              if (!useDefineForClassFields) {
                ts3.addRange(statements, ts3.visitNodes(constructor.body.statements, visitor, ts3.isStatement, indexOfFirstStatement, afterParameterProperties - indexOfFirstStatement));
              }
              indexOfFirstStatement = afterParameterProperties;
            }
          }
          var receiver = factory.createThis();
          addMethodStatements(statements, privateMethodsAndAccessors, receiver);
          addPropertyStatements(statements, properties, receiver);
          if (constructor) {
            ts3.addRange(statements, ts3.visitNodes(constructor.body.statements, visitor, ts3.isStatement, indexOfFirstStatement));
          }
          statements = factory.mergeLexicalEnvironment(statements, endLexicalEnvironment());
          return ts3.setTextRange(factory.createBlock(ts3.setTextRange(factory.createNodeArray(statements), constructor ? constructor.body.statements : node.members), true), constructor ? constructor.body : void 0);
        }
        function addPropertyStatements(statements, properties, receiver) {
          for (var _i = 0, properties_7 = properties; _i < properties_7.length; _i++) {
            var property = properties_7[_i];
            var expression = transformProperty(property, receiver);
            if (!expression) {
              continue;
            }
            var statement = factory.createExpressionStatement(expression);
            ts3.setSourceMapRange(statement, ts3.moveRangePastModifiers(property));
            ts3.setCommentRange(statement, property);
            ts3.setOriginalNode(statement, property);
            statements.push(statement);
          }
        }
        function generateInitializedPropertyExpressions(properties, receiver) {
          var expressions = [];
          for (var _i = 0, properties_8 = properties; _i < properties_8.length; _i++) {
            var property = properties_8[_i];
            var expression = transformProperty(property, receiver);
            if (!expression) {
              continue;
            }
            ts3.startOnNewLine(expression);
            ts3.setSourceMapRange(expression, ts3.moveRangePastModifiers(property));
            ts3.setCommentRange(expression, property);
            ts3.setOriginalNode(expression, property);
            expressions.push(expression);
          }
          return expressions;
        }
        function transformProperty(property, receiver) {
          var _a2;
          var emitAssignment = !useDefineForClassFields;
          var propertyName = ts3.isComputedPropertyName(property.name) && !ts3.isSimpleInlineableExpression(property.name.expression) ? factory.updateComputedPropertyName(property.name, factory.getGeneratedNameForNode(property.name)) : property.name;
          if (shouldTransformPrivateElements && ts3.isPrivateIdentifier(propertyName)) {
            var privateIdentifierInfo = accessPrivateIdentifier(propertyName);
            if (privateIdentifierInfo) {
              if (privateIdentifierInfo.kind === "f") {
                if (!privateIdentifierInfo.isStatic) {
                  return createPrivateInstanceFieldInitializer(receiver, ts3.visitNode(property.initializer, visitor, ts3.isExpression), privateIdentifierInfo.brandCheckIdentifier);
                } else {
                  return createPrivateStaticFieldInitializer(privateIdentifierInfo.variableName, ts3.visitNode(property.initializer, visitor, ts3.isExpression));
                }
              } else {
                return void 0;
              }
            } else {
              ts3.Debug.fail("Undeclared private name for property declaration.");
            }
          }
          if ((ts3.isPrivateIdentifier(propertyName) || ts3.hasStaticModifier(property)) && !property.initializer) {
            return void 0;
          }
          var propertyOriginalNode = ts3.getOriginalNode(property);
          if (ts3.hasSyntacticModifier(propertyOriginalNode, 128)) {
            return void 0;
          }
          var initializer = property.initializer || emitAssignment ? (_a2 = ts3.visitNode(property.initializer, visitor, ts3.isExpression)) !== null && _a2 !== void 0 ? _a2 : factory.createVoidZero() : ts3.isParameterPropertyDeclaration(propertyOriginalNode, propertyOriginalNode.parent) && ts3.isIdentifier(propertyName) ? propertyName : factory.createVoidZero();
          if (emitAssignment || ts3.isPrivateIdentifier(propertyName)) {
            var memberAccess = ts3.createMemberAccessForPropertyName(factory, receiver, propertyName, propertyName);
            return factory.createAssignment(memberAccess, initializer);
          } else {
            var name = ts3.isComputedPropertyName(propertyName) ? propertyName.expression : ts3.isIdentifier(propertyName) ? factory.createStringLiteral(ts3.unescapeLeadingUnderscores(propertyName.escapedText)) : propertyName;
            var descriptor = factory.createPropertyDescriptor({ value: initializer, configurable: true, writable: true, enumerable: true });
            return factory.createObjectDefinePropertyCall(receiver, name, descriptor);
          }
        }
        function enableSubstitutionForClassAliases() {
          if ((enabledSubstitutions & 1) === 0) {
            enabledSubstitutions |= 1;
            context.enableSubstitution(78);
            classAliases = [];
          }
        }
        function addMethodStatements(statements, methods, receiver) {
          if (!shouldTransformPrivateElements || !ts3.some(methods)) {
            return;
          }
          var weakSetName = getPrivateIdentifierEnvironment().weakSetName;
          ts3.Debug.assert(weakSetName, "weakSetName should be set in private identifier environment");
          statements.push(factory.createExpressionStatement(createPrivateInstanceMethodInitializer(receiver, weakSetName)));
        }
        function onSubstituteNode(hint, node) {
          node = previousOnSubstituteNode(hint, node);
          if (hint === 1) {
            return substituteExpression(node);
          }
          return node;
        }
        function substituteExpression(node) {
          switch (node.kind) {
            case 78:
              return substituteExpressionIdentifier(node);
          }
          return node;
        }
        function substituteExpressionIdentifier(node) {
          return trySubstituteClassAlias(node) || node;
        }
        function trySubstituteClassAlias(node) {
          if (enabledSubstitutions & 1) {
            if (resolver.getNodeCheckFlags(node) & 33554432) {
              var declaration = resolver.getReferencedValueDeclaration(node);
              if (declaration) {
                var classAlias = classAliases[declaration.id];
                if (classAlias) {
                  var clone_3 = factory.cloneNode(classAlias);
                  ts3.setSourceMapRange(clone_3, node);
                  ts3.setCommentRange(clone_3, node);
                  return clone_3;
                }
              }
            }
          }
          return void 0;
        }
        function getPropertyNameExpressionIfNeeded(name, shouldHoist) {
          if (ts3.isComputedPropertyName(name)) {
            var expression = ts3.visitNode(name.expression, visitor, ts3.isExpression);
            var innerExpression = ts3.skipPartiallyEmittedExpressions(expression);
            var inlinable = ts3.isSimpleInlineableExpression(innerExpression);
            var alreadyTransformed = ts3.isAssignmentExpression(innerExpression) && ts3.isGeneratedIdentifier(innerExpression.left);
            if (!alreadyTransformed && !inlinable && shouldHoist) {
              var generatedName = factory.getGeneratedNameForNode(name);
              if (resolver.getNodeCheckFlags(name) & 524288) {
                addBlockScopedVariable(generatedName);
              } else {
                hoistVariableDeclaration(generatedName);
              }
              return factory.createAssignment(generatedName, expression);
            }
            return inlinable || ts3.isIdentifier(innerExpression) ? void 0 : expression;
          }
        }
        function startPrivateIdentifierEnvironment() {
          privateIdentifierEnvironmentStack.push(currentPrivateIdentifierEnvironment);
          currentPrivateIdentifierEnvironment = void 0;
        }
        function endPrivateIdentifierEnvironment() {
          currentPrivateIdentifierEnvironment = privateIdentifierEnvironmentStack.pop();
        }
        function getPrivateIdentifierEnvironment() {
          if (!currentPrivateIdentifierEnvironment) {
            currentPrivateIdentifierEnvironment = {
              className: "",
              identifiers: new ts3.Map()
            };
          }
          return currentPrivateIdentifierEnvironment;
        }
        function getPendingExpressions() {
          return pendingExpressions || (pendingExpressions = []);
        }
        function addPrivateIdentifierToEnvironment(node) {
          var _a2;
          var text = ts3.getTextOfPropertyName(node.name);
          var env = getPrivateIdentifierEnvironment();
          var weakSetName = env.weakSetName, classConstructor = env.classConstructor;
          var assignmentExpressions = [];
          var privateName = node.name.escapedText;
          var previousInfo = env.identifiers.get(privateName);
          var isValid = !isReservedPrivateName(node.name) && previousInfo === void 0;
          if (ts3.hasStaticModifier(node)) {
            ts3.Debug.assert(classConstructor, "weakSetName should be set in private identifier environment");
            if (ts3.isPropertyDeclaration(node)) {
              var variableName = createHoistedVariableForPrivateName(text, node);
              env.identifiers.set(privateName, {
                kind: "f",
                variableName,
                brandCheckIdentifier: classConstructor,
                isStatic: true,
                isValid
              });
            } else if (ts3.isMethodDeclaration(node)) {
              var functionName = createHoistedVariableForPrivateName(text, node);
              env.identifiers.set(privateName, {
                kind: "m",
                methodName: functionName,
                brandCheckIdentifier: classConstructor,
                isStatic: true,
                isValid
              });
            } else if (ts3.isGetAccessorDeclaration(node)) {
              var getterName = createHoistedVariableForPrivateName(text + "_get", node);
              if ((previousInfo === null || previousInfo === void 0 ? void 0 : previousInfo.kind) === "a" && previousInfo.isStatic && !previousInfo.getterName) {
                previousInfo.getterName = getterName;
              } else {
                env.identifiers.set(privateName, {
                  kind: "a",
                  getterName,
                  setterName: void 0,
                  brandCheckIdentifier: classConstructor,
                  isStatic: true,
                  isValid
                });
              }
            } else if (ts3.isSetAccessorDeclaration(node)) {
              var setterName = createHoistedVariableForPrivateName(text + "_set", node);
              if ((previousInfo === null || previousInfo === void 0 ? void 0 : previousInfo.kind) === "a" && previousInfo.isStatic && !previousInfo.setterName) {
                previousInfo.setterName = setterName;
              } else {
                env.identifiers.set(privateName, {
                  kind: "a",
                  getterName: void 0,
                  setterName,
                  brandCheckIdentifier: classConstructor,
                  isStatic: true,
                  isValid
                });
              }
            } else {
              ts3.Debug.assertNever(node, "Unknown class element type.");
            }
          } else if (ts3.isPropertyDeclaration(node)) {
            var weakMapName = createHoistedVariableForPrivateName(text, node);
            env.identifiers.set(privateName, {
              kind: "f",
              brandCheckIdentifier: weakMapName,
              isStatic: false,
              variableName: void 0,
              isValid
            });
            assignmentExpressions.push(factory.createAssignment(weakMapName, factory.createNewExpression(factory.createIdentifier("WeakMap"), void 0, [])));
          } else if (ts3.isMethodDeclaration(node)) {
            ts3.Debug.assert(weakSetName, "weakSetName should be set in private identifier environment");
            env.identifiers.set(privateName, {
              kind: "m",
              methodName: createHoistedVariableForPrivateName(text, node),
              brandCheckIdentifier: weakSetName,
              isStatic: false,
              isValid
            });
          } else if (ts3.isAccessor(node)) {
            ts3.Debug.assert(weakSetName, "weakSetName should be set in private identifier environment");
            if (ts3.isGetAccessor(node)) {
              var getterName = createHoistedVariableForPrivateName(text + "_get", node);
              if ((previousInfo === null || previousInfo === void 0 ? void 0 : previousInfo.kind) === "a" && !previousInfo.isStatic && !previousInfo.getterName) {
                previousInfo.getterName = getterName;
              } else {
                env.identifiers.set(privateName, {
                  kind: "a",
                  getterName,
                  setterName: void 0,
                  brandCheckIdentifier: weakSetName,
                  isStatic: false,
                  isValid
                });
              }
            } else {
              var setterName = createHoistedVariableForPrivateName(text + "_set", node);
              if ((previousInfo === null || previousInfo === void 0 ? void 0 : previousInfo.kind) === "a" && !previousInfo.isStatic && !previousInfo.setterName) {
                previousInfo.setterName = setterName;
              } else {
                env.identifiers.set(privateName, {
                  kind: "a",
                  getterName: void 0,
                  setterName,
                  brandCheckIdentifier: weakSetName,
                  isStatic: false,
                  isValid
                });
              }
            }
          } else {
            ts3.Debug.assertNever(node, "Unknown class element type.");
          }
          (_a2 = getPendingExpressions()).push.apply(_a2, assignmentExpressions);
        }
        function createHoistedVariableForClass(name, node) {
          var className = getPrivateIdentifierEnvironment().className;
          var prefix2 = className ? "_" + className : "";
          var identifier = factory.createUniqueName(prefix2 + "_" + name, 16);
          if (resolver.getNodeCheckFlags(node) & 524288) {
            addBlockScopedVariable(identifier);
          } else {
            hoistVariableDeclaration(identifier);
          }
          return identifier;
        }
        function createHoistedVariableForPrivateName(privateName, node) {
          return createHoistedVariableForClass(privateName.substring(1), node.name);
        }
        function accessPrivateIdentifier(name) {
          if (currentPrivateIdentifierEnvironment) {
            var info = currentPrivateIdentifierEnvironment.identifiers.get(name.escapedText);
            if (info) {
              return info;
            }
          }
          for (var i3 = privateIdentifierEnvironmentStack.length - 1; i3 >= 0; --i3) {
            var env = privateIdentifierEnvironmentStack[i3];
            if (!env) {
              continue;
            }
            var info = env.identifiers.get(name.escapedText);
            if (info) {
              return info;
            }
          }
          return void 0;
        }
        function wrapPrivateIdentifierForDestructuringTarget(node) {
          var parameter = factory.getGeneratedNameForNode(node);
          var info = accessPrivateIdentifier(node.name);
          if (!info) {
            return ts3.visitEachChild(node, visitor, context);
          }
          var receiver = node.expression;
          if (ts3.isThisProperty(node) || ts3.isSuperProperty(node) || !ts3.isSimpleCopiableExpression(node.expression)) {
            receiver = factory.createTempVariable(hoistVariableDeclaration, true);
            getPendingExpressions().push(factory.createBinaryExpression(receiver, 62, node.expression));
          }
          return factory.createPropertyAccessExpression(factory.createParenthesizedExpression(factory.createObjectLiteralExpression([
            factory.createSetAccessorDeclaration(void 0, void 0, "value", [factory.createParameterDeclaration(void 0, void 0, void 0, parameter, void 0, void 0, void 0)], factory.createBlock([factory.createExpressionStatement(createPrivateIdentifierAssignment(info, receiver, parameter, 62))]))
          ])), "value");
        }
        function visitArrayAssignmentTarget(node) {
          var target = ts3.getTargetOfBindingOrAssignmentElement(node);
          if (target && ts3.isPrivateIdentifierPropertyAccessExpression(target)) {
            var wrapped = wrapPrivateIdentifierForDestructuringTarget(target);
            if (ts3.isAssignmentExpression(node)) {
              return factory.updateBinaryExpression(node, wrapped, node.operatorToken, ts3.visitNode(node.right, visitor, ts3.isExpression));
            } else if (ts3.isSpreadElement(node)) {
              return factory.updateSpreadElement(node, wrapped);
            } else {
              return wrapped;
            }
          }
          return ts3.visitNode(node, visitorDestructuringTarget);
        }
        function visitObjectAssignmentTarget(node) {
          if (ts3.isPropertyAssignment(node)) {
            var target = ts3.getTargetOfBindingOrAssignmentElement(node);
            if (target && ts3.isPrivateIdentifierPropertyAccessExpression(target)) {
              var initializer = ts3.getInitializerOfBindingOrAssignmentElement(node);
              var wrapped = wrapPrivateIdentifierForDestructuringTarget(target);
              return factory.updatePropertyAssignment(node, ts3.visitNode(node.name, visitor), initializer ? factory.createAssignment(wrapped, ts3.visitNode(initializer, visitor)) : wrapped);
            }
            return factory.updatePropertyAssignment(node, ts3.visitNode(node.name, visitor), ts3.visitNode(node.initializer, visitorDestructuringTarget));
          }
          return ts3.visitNode(node, visitor);
        }
        function visitAssignmentPattern(node) {
          if (ts3.isArrayLiteralExpression(node)) {
            return factory.updateArrayLiteralExpression(node, ts3.visitNodes(node.elements, visitArrayAssignmentTarget, ts3.isExpression));
          } else {
            return factory.updateObjectLiteralExpression(node, ts3.visitNodes(node.properties, visitObjectAssignmentTarget, ts3.isObjectLiteralElementLike));
          }
        }
      }
      ts3.transformClassFields = transformClassFields;
      function createPrivateStaticFieldInitializer(variableName, initializer) {
        return ts3.factory.createAssignment(variableName, ts3.factory.createObjectLiteralExpression([
          ts3.factory.createPropertyAssignment("value", initializer || ts3.factory.createVoidZero())
        ]));
      }
      function createPrivateInstanceFieldInitializer(receiver, initializer, weakMapName) {
        return ts3.factory.createCallExpression(ts3.factory.createPropertyAccessExpression(weakMapName, "set"), void 0, [receiver, initializer || ts3.factory.createVoidZero()]);
      }
      function createPrivateInstanceMethodInitializer(receiver, weakSetName) {
        return ts3.factory.createCallExpression(ts3.factory.createPropertyAccessExpression(weakSetName, "add"), void 0, [receiver]);
      }
      function isReservedPrivateName(node) {
        return node.escapedText === "#constructor";
      }
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var ES2017SubstitutionFlags;
      (function(ES2017SubstitutionFlags2) {
        ES2017SubstitutionFlags2[ES2017SubstitutionFlags2["AsyncMethodsWithSuper"] = 1] = "AsyncMethodsWithSuper";
      })(ES2017SubstitutionFlags || (ES2017SubstitutionFlags = {}));
      var ContextFlags;
      (function(ContextFlags2) {
        ContextFlags2[ContextFlags2["NonTopLevel"] = 1] = "NonTopLevel";
        ContextFlags2[ContextFlags2["HasLexicalThis"] = 2] = "HasLexicalThis";
      })(ContextFlags || (ContextFlags = {}));
      function transformES2017(context) {
        var factory = context.factory, emitHelpers = context.getEmitHelperFactory, resumeLexicalEnvironment = context.resumeLexicalEnvironment, endLexicalEnvironment = context.endLexicalEnvironment, hoistVariableDeclaration = context.hoistVariableDeclaration;
        var resolver = context.getEmitResolver();
        var compilerOptions = context.getCompilerOptions();
        var languageVersion = ts3.getEmitScriptTarget(compilerOptions);
        var enabledSubstitutions;
        var enclosingSuperContainerFlags = 0;
        var enclosingFunctionParameterNames;
        var capturedSuperProperties;
        var hasSuperElementAccess;
        var substitutedSuperAccessors = [];
        var contextFlags = 0;
        var previousOnEmitNode = context.onEmitNode;
        var previousOnSubstituteNode = context.onSubstituteNode;
        context.onEmitNode = onEmitNode;
        context.onSubstituteNode = onSubstituteNode;
        return ts3.chainBundle(context, transformSourceFile);
        function transformSourceFile(node) {
          if (node.isDeclarationFile) {
            return node;
          }
          setContextFlag(1, false);
          setContextFlag(2, !ts3.isEffectiveStrictModeSourceFile(node, compilerOptions));
          var visited = ts3.visitEachChild(node, visitor, context);
          ts3.addEmitHelpers(visited, context.readEmitHelpers());
          return visited;
        }
        function setContextFlag(flag, val) {
          contextFlags = val ? contextFlags | flag : contextFlags & ~flag;
        }
        function inContext(flags) {
          return (contextFlags & flags) !== 0;
        }
        function inTopLevelContext() {
          return !inContext(1);
        }
        function inHasLexicalThisContext() {
          return inContext(2);
        }
        function doWithContext(flags, cb2, value) {
          var contextFlagsToSet = flags & ~contextFlags;
          if (contextFlagsToSet) {
            setContextFlag(contextFlagsToSet, true);
            var result2 = cb2(value);
            setContextFlag(contextFlagsToSet, false);
            return result2;
          }
          return cb2(value);
        }
        function visitDefault(node) {
          return ts3.visitEachChild(node, visitor, context);
        }
        function visitor(node) {
          if ((node.transformFlags & 128) === 0) {
            return node;
          }
          switch (node.kind) {
            case 129:
              return void 0;
            case 214:
              return visitAwaitExpression(node);
            case 166:
              return doWithContext(1 | 2, visitMethodDeclaration, node);
            case 252:
              return doWithContext(1 | 2, visitFunctionDeclaration, node);
            case 209:
              return doWithContext(1 | 2, visitFunctionExpression, node);
            case 210:
              return doWithContext(1, visitArrowFunction, node);
            case 202:
              if (capturedSuperProperties && ts3.isPropertyAccessExpression(node) && node.expression.kind === 105) {
                capturedSuperProperties.add(node.name.escapedText);
              }
              return ts3.visitEachChild(node, visitor, context);
            case 203:
              if (capturedSuperProperties && node.expression.kind === 105) {
                hasSuperElementAccess = true;
              }
              return ts3.visitEachChild(node, visitor, context);
            case 168:
            case 169:
            case 167:
            case 253:
            case 222:
              return doWithContext(1 | 2, visitDefault, node);
            default:
              return ts3.visitEachChild(node, visitor, context);
          }
        }
        function asyncBodyVisitor(node) {
          if (ts3.isNodeWithPossibleHoistedDeclaration(node)) {
            switch (node.kind) {
              case 233:
                return visitVariableStatementInAsyncBody(node);
              case 238:
                return visitForStatementInAsyncBody(node);
              case 239:
                return visitForInStatementInAsyncBody(node);
              case 240:
                return visitForOfStatementInAsyncBody(node);
              case 288:
                return visitCatchClauseInAsyncBody(node);
              case 231:
              case 245:
              case 259:
              case 285:
              case 286:
              case 248:
              case 236:
              case 237:
              case 235:
              case 244:
              case 246:
                return ts3.visitEachChild(node, asyncBodyVisitor, context);
              default:
                return ts3.Debug.assertNever(node, "Unhandled node.");
            }
          }
          return visitor(node);
        }
        function visitCatchClauseInAsyncBody(node) {
          var catchClauseNames = new ts3.Set();
          recordDeclarationName(node.variableDeclaration, catchClauseNames);
          var catchClauseUnshadowedNames;
          catchClauseNames.forEach(function(_, escapedName) {
            if (enclosingFunctionParameterNames.has(escapedName)) {
              if (!catchClauseUnshadowedNames) {
                catchClauseUnshadowedNames = new ts3.Set(enclosingFunctionParameterNames);
              }
              catchClauseUnshadowedNames.delete(escapedName);
            }
          });
          if (catchClauseUnshadowedNames) {
            var savedEnclosingFunctionParameterNames = enclosingFunctionParameterNames;
            enclosingFunctionParameterNames = catchClauseUnshadowedNames;
            var result2 = ts3.visitEachChild(node, asyncBodyVisitor, context);
            enclosingFunctionParameterNames = savedEnclosingFunctionParameterNames;
            return result2;
          } else {
            return ts3.visitEachChild(node, asyncBodyVisitor, context);
          }
        }
        function visitVariableStatementInAsyncBody(node) {
          if (isVariableDeclarationListWithCollidingName(node.declarationList)) {
            var expression = visitVariableDeclarationListWithCollidingNames(node.declarationList, false);
            return expression ? factory.createExpressionStatement(expression) : void 0;
          }
          return ts3.visitEachChild(node, visitor, context);
        }
        function visitForInStatementInAsyncBody(node) {
          return factory.updateForInStatement(node, isVariableDeclarationListWithCollidingName(node.initializer) ? visitVariableDeclarationListWithCollidingNames(node.initializer, true) : ts3.visitNode(node.initializer, visitor, ts3.isForInitializer), ts3.visitNode(node.expression, visitor, ts3.isExpression), ts3.visitIterationBody(node.statement, asyncBodyVisitor, context));
        }
        function visitForOfStatementInAsyncBody(node) {
          return factory.updateForOfStatement(node, ts3.visitNode(node.awaitModifier, visitor, ts3.isToken), isVariableDeclarationListWithCollidingName(node.initializer) ? visitVariableDeclarationListWithCollidingNames(node.initializer, true) : ts3.visitNode(node.initializer, visitor, ts3.isForInitializer), ts3.visitNode(node.expression, visitor, ts3.isExpression), ts3.visitIterationBody(node.statement, asyncBodyVisitor, context));
        }
        function visitForStatementInAsyncBody(node) {
          var initializer = node.initializer;
          return factory.updateForStatement(node, isVariableDeclarationListWithCollidingName(initializer) ? visitVariableDeclarationListWithCollidingNames(initializer, false) : ts3.visitNode(node.initializer, visitor, ts3.isForInitializer), ts3.visitNode(node.condition, visitor, ts3.isExpression), ts3.visitNode(node.incrementor, visitor, ts3.isExpression), ts3.visitIterationBody(node.statement, asyncBodyVisitor, context));
        }
        function visitAwaitExpression(node) {
          if (inTopLevelContext()) {
            return ts3.visitEachChild(node, visitor, context);
          }
          return ts3.setOriginalNode(ts3.setTextRange(factory.createYieldExpression(void 0, ts3.visitNode(node.expression, visitor, ts3.isExpression)), node), node);
        }
        function visitMethodDeclaration(node) {
          return factory.updateMethodDeclaration(node, void 0, ts3.visitNodes(node.modifiers, visitor, ts3.isModifier), node.asteriskToken, node.name, void 0, void 0, ts3.visitParameterList(node.parameters, visitor, context), void 0, ts3.getFunctionFlags(node) & 2 ? transformAsyncFunctionBody(node) : ts3.visitFunctionBody(node.body, visitor, context));
        }
        function visitFunctionDeclaration(node) {
          return factory.updateFunctionDeclaration(node, void 0, ts3.visitNodes(node.modifiers, visitor, ts3.isModifier), node.asteriskToken, node.name, void 0, ts3.visitParameterList(node.parameters, visitor, context), void 0, ts3.getFunctionFlags(node) & 2 ? transformAsyncFunctionBody(node) : ts3.visitFunctionBody(node.body, visitor, context));
        }
        function visitFunctionExpression(node) {
          return factory.updateFunctionExpression(node, ts3.visitNodes(node.modifiers, visitor, ts3.isModifier), node.asteriskToken, node.name, void 0, ts3.visitParameterList(node.parameters, visitor, context), void 0, ts3.getFunctionFlags(node) & 2 ? transformAsyncFunctionBody(node) : ts3.visitFunctionBody(node.body, visitor, context));
        }
        function visitArrowFunction(node) {
          return factory.updateArrowFunction(node, ts3.visitNodes(node.modifiers, visitor, ts3.isModifier), void 0, ts3.visitParameterList(node.parameters, visitor, context), void 0, node.equalsGreaterThanToken, ts3.getFunctionFlags(node) & 2 ? transformAsyncFunctionBody(node) : ts3.visitFunctionBody(node.body, visitor, context));
        }
        function recordDeclarationName(_a2, names) {
          var name = _a2.name;
          if (ts3.isIdentifier(name)) {
            names.add(name.escapedText);
          } else {
            for (var _i = 0, _b = name.elements; _i < _b.length; _i++) {
              var element = _b[_i];
              if (!ts3.isOmittedExpression(element)) {
                recordDeclarationName(element, names);
              }
            }
          }
        }
        function isVariableDeclarationListWithCollidingName(node) {
          return !!node && ts3.isVariableDeclarationList(node) && !(node.flags & 3) && node.declarations.some(collidesWithParameterName);
        }
        function visitVariableDeclarationListWithCollidingNames(node, hasReceiver) {
          hoistVariableDeclarationList(node);
          var variables = ts3.getInitializedVariables(node);
          if (variables.length === 0) {
            if (hasReceiver) {
              return ts3.visitNode(factory.converters.convertToAssignmentElementTarget(node.declarations[0].name), visitor, ts3.isExpression);
            }
            return void 0;
          }
          return factory.inlineExpressions(ts3.map(variables, transformInitializedVariable));
        }
        function hoistVariableDeclarationList(node) {
          ts3.forEach(node.declarations, hoistVariable);
        }
        function hoistVariable(_a2) {
          var name = _a2.name;
          if (ts3.isIdentifier(name)) {
            hoistVariableDeclaration(name);
          } else {
            for (var _i = 0, _b = name.elements; _i < _b.length; _i++) {
              var element = _b[_i];
              if (!ts3.isOmittedExpression(element)) {
                hoistVariable(element);
              }
            }
          }
        }
        function transformInitializedVariable(node) {
          var converted = ts3.setSourceMapRange(factory.createAssignment(factory.converters.convertToAssignmentElementTarget(node.name), node.initializer), node);
          return ts3.visitNode(converted, visitor, ts3.isExpression);
        }
        function collidesWithParameterName(_a2) {
          var name = _a2.name;
          if (ts3.isIdentifier(name)) {
            return enclosingFunctionParameterNames.has(name.escapedText);
          } else {
            for (var _i = 0, _b = name.elements; _i < _b.length; _i++) {
              var element = _b[_i];
              if (!ts3.isOmittedExpression(element) && collidesWithParameterName(element)) {
                return true;
              }
            }
          }
          return false;
        }
        function transformAsyncFunctionBody(node) {
          resumeLexicalEnvironment();
          var original = ts3.getOriginalNode(node, ts3.isFunctionLike);
          var nodeType = original.type;
          var promiseConstructor = languageVersion < 2 ? getPromiseConstructor(nodeType) : void 0;
          var isArrowFunction = node.kind === 210;
          var hasLexicalArguments = (resolver.getNodeCheckFlags(node) & 8192) !== 0;
          var savedEnclosingFunctionParameterNames = enclosingFunctionParameterNames;
          enclosingFunctionParameterNames = new ts3.Set();
          for (var _i = 0, _a2 = node.parameters; _i < _a2.length; _i++) {
            var parameter = _a2[_i];
            recordDeclarationName(parameter, enclosingFunctionParameterNames);
          }
          var savedCapturedSuperProperties = capturedSuperProperties;
          var savedHasSuperElementAccess = hasSuperElementAccess;
          if (!isArrowFunction) {
            capturedSuperProperties = new ts3.Set();
            hasSuperElementAccess = false;
          }
          var result2;
          if (!isArrowFunction) {
            var statements = [];
            var statementOffset = factory.copyPrologue(node.body.statements, statements, false, visitor);
            statements.push(factory.createReturnStatement(emitHelpers().createAwaiterHelper(inHasLexicalThisContext(), hasLexicalArguments, promiseConstructor, transformAsyncFunctionBodyWorker(node.body, statementOffset))));
            ts3.insertStatementsAfterStandardPrologue(statements, endLexicalEnvironment());
            var emitSuperHelpers = languageVersion >= 2 && resolver.getNodeCheckFlags(node) & (4096 | 2048);
            if (emitSuperHelpers) {
              enableSubstitutionForAsyncMethodsWithSuper();
              if (capturedSuperProperties.size) {
                var variableStatement = createSuperAccessVariableStatement(factory, resolver, node, capturedSuperProperties);
                substitutedSuperAccessors[ts3.getNodeId(variableStatement)] = true;
                ts3.insertStatementsAfterStandardPrologue(statements, [variableStatement]);
              }
            }
            var block = factory.createBlock(statements, true);
            ts3.setTextRange(block, node.body);
            if (emitSuperHelpers && hasSuperElementAccess) {
              if (resolver.getNodeCheckFlags(node) & 4096) {
                ts3.addEmitHelper(block, ts3.advancedAsyncSuperHelper);
              } else if (resolver.getNodeCheckFlags(node) & 2048) {
                ts3.addEmitHelper(block, ts3.asyncSuperHelper);
              }
            }
            result2 = block;
          } else {
            var expression = emitHelpers().createAwaiterHelper(inHasLexicalThisContext(), hasLexicalArguments, promiseConstructor, transformAsyncFunctionBodyWorker(node.body));
            var declarations = endLexicalEnvironment();
            if (ts3.some(declarations)) {
              var block = factory.converters.convertToFunctionBlock(expression);
              result2 = factory.updateBlock(block, ts3.setTextRange(factory.createNodeArray(ts3.concatenate(declarations, block.statements)), block.statements));
            } else {
              result2 = expression;
            }
          }
          enclosingFunctionParameterNames = savedEnclosingFunctionParameterNames;
          if (!isArrowFunction) {
            capturedSuperProperties = savedCapturedSuperProperties;
            hasSuperElementAccess = savedHasSuperElementAccess;
          }
          return result2;
        }
        function transformAsyncFunctionBodyWorker(body, start) {
          if (ts3.isBlock(body)) {
            return factory.updateBlock(body, ts3.visitNodes(body.statements, asyncBodyVisitor, ts3.isStatement, start));
          } else {
            return factory.converters.convertToFunctionBlock(ts3.visitNode(body, asyncBodyVisitor, ts3.isConciseBody));
          }
        }
        function getPromiseConstructor(type3) {
          var typeName = type3 && ts3.getEntityNameFromTypeNode(type3);
          if (typeName && ts3.isEntityName(typeName)) {
            var serializationKind = resolver.getTypeReferenceSerializationKind(typeName);
            if (serializationKind === ts3.TypeReferenceSerializationKind.TypeWithConstructSignatureAndValue || serializationKind === ts3.TypeReferenceSerializationKind.Unknown) {
              return typeName;
            }
          }
          return void 0;
        }
        function enableSubstitutionForAsyncMethodsWithSuper() {
          if ((enabledSubstitutions & 1) === 0) {
            enabledSubstitutions |= 1;
            context.enableSubstitution(204);
            context.enableSubstitution(202);
            context.enableSubstitution(203);
            context.enableEmitNotification(253);
            context.enableEmitNotification(166);
            context.enableEmitNotification(168);
            context.enableEmitNotification(169);
            context.enableEmitNotification(167);
            context.enableEmitNotification(233);
          }
        }
        function onEmitNode(hint, node, emitCallback) {
          if (enabledSubstitutions & 1 && isSuperContainer(node)) {
            var superContainerFlags = resolver.getNodeCheckFlags(node) & (2048 | 4096);
            if (superContainerFlags !== enclosingSuperContainerFlags) {
              var savedEnclosingSuperContainerFlags = enclosingSuperContainerFlags;
              enclosingSuperContainerFlags = superContainerFlags;
              previousOnEmitNode(hint, node, emitCallback);
              enclosingSuperContainerFlags = savedEnclosingSuperContainerFlags;
              return;
            }
          } else if (enabledSubstitutions && substitutedSuperAccessors[ts3.getNodeId(node)]) {
            var savedEnclosingSuperContainerFlags = enclosingSuperContainerFlags;
            enclosingSuperContainerFlags = 0;
            previousOnEmitNode(hint, node, emitCallback);
            enclosingSuperContainerFlags = savedEnclosingSuperContainerFlags;
            return;
          }
          previousOnEmitNode(hint, node, emitCallback);
        }
        function onSubstituteNode(hint, node) {
          node = previousOnSubstituteNode(hint, node);
          if (hint === 1 && enclosingSuperContainerFlags) {
            return substituteExpression(node);
          }
          return node;
        }
        function substituteExpression(node) {
          switch (node.kind) {
            case 202:
              return substitutePropertyAccessExpression(node);
            case 203:
              return substituteElementAccessExpression(node);
            case 204:
              return substituteCallExpression(node);
          }
          return node;
        }
        function substitutePropertyAccessExpression(node) {
          if (node.expression.kind === 105) {
            return ts3.setTextRange(factory.createPropertyAccessExpression(factory.createUniqueName("_super", 16 | 32), node.name), node);
          }
          return node;
        }
        function substituteElementAccessExpression(node) {
          if (node.expression.kind === 105) {
            return createSuperElementAccessInAsyncMethod(node.argumentExpression, node);
          }
          return node;
        }
        function substituteCallExpression(node) {
          var expression = node.expression;
          if (ts3.isSuperProperty(expression)) {
            var argumentExpression = ts3.isPropertyAccessExpression(expression) ? substitutePropertyAccessExpression(expression) : substituteElementAccessExpression(expression);
            return factory.createCallExpression(factory.createPropertyAccessExpression(argumentExpression, "call"), void 0, __spreadArray([
              factory.createThis()
            ], node.arguments));
          }
          return node;
        }
        function isSuperContainer(node) {
          var kind = node.kind;
          return kind === 253 || kind === 167 || kind === 166 || kind === 168 || kind === 169;
        }
        function createSuperElementAccessInAsyncMethod(argumentExpression, location) {
          if (enclosingSuperContainerFlags & 4096) {
            return ts3.setTextRange(factory.createPropertyAccessExpression(factory.createCallExpression(factory.createUniqueName("_superIndex", 16 | 32), void 0, [argumentExpression]), "value"), location);
          } else {
            return ts3.setTextRange(factory.createCallExpression(factory.createUniqueName("_superIndex", 16 | 32), void 0, [argumentExpression]), location);
          }
        }
      }
      ts3.transformES2017 = transformES2017;
      function createSuperAccessVariableStatement(factory, resolver, node, names) {
        var hasBinding = (resolver.getNodeCheckFlags(node) & 4096) !== 0;
        var accessors = [];
        names.forEach(function(_, key2) {
          var name = ts3.unescapeLeadingUnderscores(key2);
          var getterAndSetter = [];
          getterAndSetter.push(factory.createPropertyAssignment("get", factory.createArrowFunction(void 0, void 0, [], void 0, void 0, ts3.setEmitFlags(factory.createPropertyAccessExpression(ts3.setEmitFlags(factory.createSuper(), 4), name), 4))));
          if (hasBinding) {
            getterAndSetter.push(factory.createPropertyAssignment("set", factory.createArrowFunction(void 0, void 0, [
              factory.createParameterDeclaration(void 0, void 0, void 0, "v", void 0, void 0, void 0)
            ], void 0, void 0, factory.createAssignment(ts3.setEmitFlags(factory.createPropertyAccessExpression(ts3.setEmitFlags(factory.createSuper(), 4), name), 4), factory.createIdentifier("v")))));
          }
          accessors.push(factory.createPropertyAssignment(name, factory.createObjectLiteralExpression(getterAndSetter)));
        });
        return factory.createVariableStatement(void 0, factory.createVariableDeclarationList([
          factory.createVariableDeclaration(factory.createUniqueName("_super", 16 | 32), void 0, void 0, factory.createCallExpression(factory.createPropertyAccessExpression(factory.createIdentifier("Object"), "create"), void 0, [
            factory.createNull(),
            factory.createObjectLiteralExpression(accessors, true)
          ]))
        ], 2));
      }
      ts3.createSuperAccessVariableStatement = createSuperAccessVariableStatement;
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var ESNextSubstitutionFlags;
      (function(ESNextSubstitutionFlags2) {
        ESNextSubstitutionFlags2[ESNextSubstitutionFlags2["AsyncMethodsWithSuper"] = 1] = "AsyncMethodsWithSuper";
      })(ESNextSubstitutionFlags || (ESNextSubstitutionFlags = {}));
      var HierarchyFacts;
      (function(HierarchyFacts2) {
        HierarchyFacts2[HierarchyFacts2["None"] = 0] = "None";
        HierarchyFacts2[HierarchyFacts2["HasLexicalThis"] = 1] = "HasLexicalThis";
        HierarchyFacts2[HierarchyFacts2["IterationContainer"] = 2] = "IterationContainer";
        HierarchyFacts2[HierarchyFacts2["AncestorFactsMask"] = 3] = "AncestorFactsMask";
        HierarchyFacts2[HierarchyFacts2["SourceFileIncludes"] = 1] = "SourceFileIncludes";
        HierarchyFacts2[HierarchyFacts2["SourceFileExcludes"] = 2] = "SourceFileExcludes";
        HierarchyFacts2[HierarchyFacts2["StrictModeSourceFileIncludes"] = 0] = "StrictModeSourceFileIncludes";
        HierarchyFacts2[HierarchyFacts2["ClassOrFunctionIncludes"] = 1] = "ClassOrFunctionIncludes";
        HierarchyFacts2[HierarchyFacts2["ClassOrFunctionExcludes"] = 2] = "ClassOrFunctionExcludes";
        HierarchyFacts2[HierarchyFacts2["ArrowFunctionIncludes"] = 0] = "ArrowFunctionIncludes";
        HierarchyFacts2[HierarchyFacts2["ArrowFunctionExcludes"] = 2] = "ArrowFunctionExcludes";
        HierarchyFacts2[HierarchyFacts2["IterationStatementIncludes"] = 2] = "IterationStatementIncludes";
        HierarchyFacts2[HierarchyFacts2["IterationStatementExcludes"] = 0] = "IterationStatementExcludes";
      })(HierarchyFacts || (HierarchyFacts = {}));
      function transformES2018(context) {
        var factory = context.factory, emitHelpers = context.getEmitHelperFactory, resumeLexicalEnvironment = context.resumeLexicalEnvironment, endLexicalEnvironment = context.endLexicalEnvironment, hoistVariableDeclaration = context.hoistVariableDeclaration;
        var resolver = context.getEmitResolver();
        var compilerOptions = context.getCompilerOptions();
        var languageVersion = ts3.getEmitScriptTarget(compilerOptions);
        var previousOnEmitNode = context.onEmitNode;
        context.onEmitNode = onEmitNode;
        var previousOnSubstituteNode = context.onSubstituteNode;
        context.onSubstituteNode = onSubstituteNode;
        var exportedVariableStatement = false;
        var enabledSubstitutions;
        var enclosingFunctionFlags;
        var enclosingSuperContainerFlags = 0;
        var hierarchyFacts = 0;
        var currentSourceFile;
        var taggedTemplateStringDeclarations;
        var capturedSuperProperties;
        var hasSuperElementAccess;
        var substitutedSuperAccessors = [];
        return ts3.chainBundle(context, transformSourceFile);
        function affectsSubtree(excludeFacts, includeFacts) {
          return hierarchyFacts !== (hierarchyFacts & ~excludeFacts | includeFacts);
        }
        function enterSubtree(excludeFacts, includeFacts) {
          var ancestorFacts = hierarchyFacts;
          hierarchyFacts = (hierarchyFacts & ~excludeFacts | includeFacts) & 3;
          return ancestorFacts;
        }
        function exitSubtree(ancestorFacts) {
          hierarchyFacts = ancestorFacts;
        }
        function recordTaggedTemplateString(temp) {
          taggedTemplateStringDeclarations = ts3.append(taggedTemplateStringDeclarations, factory.createVariableDeclaration(temp));
        }
        function transformSourceFile(node) {
          if (node.isDeclarationFile) {
            return node;
          }
          currentSourceFile = node;
          var visited = visitSourceFile(node);
          ts3.addEmitHelpers(visited, context.readEmitHelpers());
          currentSourceFile = void 0;
          taggedTemplateStringDeclarations = void 0;
          return visited;
        }
        function visitor(node) {
          return visitorWorker(node, false);
        }
        function visitorWithUnusedExpressionResult(node) {
          return visitorWorker(node, true);
        }
        function visitorNoAsyncModifier(node) {
          if (node.kind === 129) {
            return void 0;
          }
          return node;
        }
        function doWithHierarchyFacts(cb2, value, excludeFacts, includeFacts) {
          if (affectsSubtree(excludeFacts, includeFacts)) {
            var ancestorFacts = enterSubtree(excludeFacts, includeFacts);
            var result2 = cb2(value);
            exitSubtree(ancestorFacts);
            return result2;
          }
          return cb2(value);
        }
        function visitDefault(node) {
          return ts3.visitEachChild(node, visitor, context);
        }
        function visitorWorker(node, expressionResultIsUnused) {
          if ((node.transformFlags & 64) === 0) {
            return node;
          }
          switch (node.kind) {
            case 214:
              return visitAwaitExpression(node);
            case 220:
              return visitYieldExpression(node);
            case 243:
              return visitReturnStatement(node);
            case 246:
              return visitLabeledStatement(node);
            case 201:
              return visitObjectLiteralExpression(node);
            case 217:
              return visitBinaryExpression(node, expressionResultIsUnused);
            case 341:
              return visitCommaListExpression(node, expressionResultIsUnused);
            case 288:
              return visitCatchClause(node);
            case 233:
              return visitVariableStatement(node);
            case 250:
              return visitVariableDeclaration(node);
            case 236:
            case 237:
            case 239:
              return doWithHierarchyFacts(visitDefault, node, 0, 2);
            case 240:
              return visitForOfStatement(node, void 0);
            case 238:
              return doWithHierarchyFacts(visitForStatement, node, 0, 2);
            case 213:
              return visitVoidExpression(node);
            case 167:
              return doWithHierarchyFacts(visitConstructorDeclaration, node, 2, 1);
            case 166:
              return doWithHierarchyFacts(visitMethodDeclaration, node, 2, 1);
            case 168:
              return doWithHierarchyFacts(visitGetAccessorDeclaration, node, 2, 1);
            case 169:
              return doWithHierarchyFacts(visitSetAccessorDeclaration, node, 2, 1);
            case 252:
              return doWithHierarchyFacts(visitFunctionDeclaration, node, 2, 1);
            case 209:
              return doWithHierarchyFacts(visitFunctionExpression, node, 2, 1);
            case 210:
              return doWithHierarchyFacts(visitArrowFunction, node, 2, 0);
            case 161:
              return visitParameter(node);
            case 234:
              return visitExpressionStatement(node);
            case 208:
              return visitParenthesizedExpression(node, expressionResultIsUnused);
            case 206:
              return visitTaggedTemplateExpression(node);
            case 202:
              if (capturedSuperProperties && ts3.isPropertyAccessExpression(node) && node.expression.kind === 105) {
                capturedSuperProperties.add(node.name.escapedText);
              }
              return ts3.visitEachChild(node, visitor, context);
            case 203:
              if (capturedSuperProperties && node.expression.kind === 105) {
                hasSuperElementAccess = true;
              }
              return ts3.visitEachChild(node, visitor, context);
            case 253:
            case 222:
              return doWithHierarchyFacts(visitDefault, node, 2, 1);
            default:
              return ts3.visitEachChild(node, visitor, context);
          }
        }
        function visitAwaitExpression(node) {
          if (enclosingFunctionFlags & 2 && enclosingFunctionFlags & 1) {
            return ts3.setOriginalNode(ts3.setTextRange(factory.createYieldExpression(void 0, emitHelpers().createAwaitHelper(ts3.visitNode(node.expression, visitor, ts3.isExpression))), node), node);
          }
          return ts3.visitEachChild(node, visitor, context);
        }
        function visitYieldExpression(node) {
          if (enclosingFunctionFlags & 2 && enclosingFunctionFlags & 1) {
            if (node.asteriskToken) {
              var expression = ts3.visitNode(ts3.Debug.assertDefined(node.expression), visitor, ts3.isExpression);
              return ts3.setOriginalNode(ts3.setTextRange(factory.createYieldExpression(void 0, emitHelpers().createAwaitHelper(factory.updateYieldExpression(node, node.asteriskToken, ts3.setTextRange(emitHelpers().createAsyncDelegatorHelper(ts3.setTextRange(emitHelpers().createAsyncValuesHelper(expression), expression)), expression)))), node), node);
            }
            return ts3.setOriginalNode(ts3.setTextRange(factory.createYieldExpression(void 0, createDownlevelAwait(node.expression ? ts3.visitNode(node.expression, visitor, ts3.isExpression) : factory.createVoidZero())), node), node);
          }
          return ts3.visitEachChild(node, visitor, context);
        }
        function visitReturnStatement(node) {
          if (enclosingFunctionFlags & 2 && enclosingFunctionFlags & 1) {
            return factory.updateReturnStatement(node, createDownlevelAwait(node.expression ? ts3.visitNode(node.expression, visitor, ts3.isExpression) : factory.createVoidZero()));
          }
          return ts3.visitEachChild(node, visitor, context);
        }
        function visitLabeledStatement(node) {
          if (enclosingFunctionFlags & 2) {
            var statement = ts3.unwrapInnermostStatementOfLabel(node);
            if (statement.kind === 240 && statement.awaitModifier) {
              return visitForOfStatement(statement, node);
            }
            return factory.restoreEnclosingLabel(ts3.visitNode(statement, visitor, ts3.isStatement, factory.liftToBlock), node);
          }
          return ts3.visitEachChild(node, visitor, context);
        }
        function chunkObjectLiteralElements(elements) {
          var chunkObject;
          var objects = [];
          for (var _i = 0, elements_4 = elements; _i < elements_4.length; _i++) {
            var e2 = elements_4[_i];
            if (e2.kind === 291) {
              if (chunkObject) {
                objects.push(factory.createObjectLiteralExpression(chunkObject));
                chunkObject = void 0;
              }
              var target = e2.expression;
              objects.push(ts3.visitNode(target, visitor, ts3.isExpression));
            } else {
              chunkObject = ts3.append(chunkObject, e2.kind === 289 ? factory.createPropertyAssignment(e2.name, ts3.visitNode(e2.initializer, visitor, ts3.isExpression)) : ts3.visitNode(e2, visitor, ts3.isObjectLiteralElementLike));
            }
          }
          if (chunkObject) {
            objects.push(factory.createObjectLiteralExpression(chunkObject));
          }
          return objects;
        }
        function visitObjectLiteralExpression(node) {
          if (node.transformFlags & 32768) {
            var objects = chunkObjectLiteralElements(node.properties);
            if (objects.length && objects[0].kind !== 201) {
              objects.unshift(factory.createObjectLiteralExpression());
            }
            var expression = objects[0];
            if (objects.length > 1) {
              for (var i3 = 1; i3 < objects.length; i3++) {
                expression = emitHelpers().createAssignHelper([expression, objects[i3]]);
              }
              return expression;
            } else {
              return emitHelpers().createAssignHelper(objects);
            }
          }
          return ts3.visitEachChild(node, visitor, context);
        }
        function visitExpressionStatement(node) {
          return ts3.visitEachChild(node, visitorWithUnusedExpressionResult, context);
        }
        function visitParenthesizedExpression(node, expressionResultIsUnused) {
          return ts3.visitEachChild(node, expressionResultIsUnused ? visitorWithUnusedExpressionResult : visitor, context);
        }
        function visitSourceFile(node) {
          var ancestorFacts = enterSubtree(2, ts3.isEffectiveStrictModeSourceFile(node, compilerOptions) ? 0 : 1);
          exportedVariableStatement = false;
          var visited = ts3.visitEachChild(node, visitor, context);
          var statement = ts3.concatenate(visited.statements, taggedTemplateStringDeclarations && [
            factory.createVariableStatement(void 0, factory.createVariableDeclarationList(taggedTemplateStringDeclarations))
          ]);
          var result2 = factory.updateSourceFile(visited, ts3.setTextRange(factory.createNodeArray(statement), node.statements));
          exitSubtree(ancestorFacts);
          return result2;
        }
        function visitTaggedTemplateExpression(node) {
          return ts3.processTaggedTemplateExpression(context, node, visitor, currentSourceFile, recordTaggedTemplateString, ts3.ProcessLevel.LiftRestriction);
        }
        function visitBinaryExpression(node, expressionResultIsUnused) {
          if (ts3.isDestructuringAssignment(node) && node.left.transformFlags & 32768) {
            return ts3.flattenDestructuringAssignment(node, visitor, context, 1, !expressionResultIsUnused);
          }
          if (node.operatorToken.kind === 27) {
            return factory.updateBinaryExpression(node, ts3.visitNode(node.left, visitorWithUnusedExpressionResult, ts3.isExpression), node.operatorToken, ts3.visitNode(node.right, expressionResultIsUnused ? visitorWithUnusedExpressionResult : visitor, ts3.isExpression));
          }
          return ts3.visitEachChild(node, visitor, context);
        }
        function visitCommaListExpression(node, expressionResultIsUnused) {
          if (expressionResultIsUnused) {
            return ts3.visitEachChild(node, visitorWithUnusedExpressionResult, context);
          }
          var result2;
          for (var i3 = 0; i3 < node.elements.length; i3++) {
            var element = node.elements[i3];
            var visited = ts3.visitNode(element, i3 < node.elements.length - 1 ? visitorWithUnusedExpressionResult : visitor, ts3.isExpression);
            if (result2 || visited !== element) {
              result2 || (result2 = node.elements.slice(0, i3));
              result2.push(visited);
            }
          }
          var elements = result2 ? ts3.setTextRange(factory.createNodeArray(result2), node.elements) : node.elements;
          return factory.updateCommaListExpression(node, elements);
        }
        function visitCatchClause(node) {
          if (node.variableDeclaration && ts3.isBindingPattern(node.variableDeclaration.name) && node.variableDeclaration.name.transformFlags & 32768) {
            var name = factory.getGeneratedNameForNode(node.variableDeclaration.name);
            var updatedDecl = factory.updateVariableDeclaration(node.variableDeclaration, node.variableDeclaration.name, void 0, void 0, name);
            var visitedBindings = ts3.flattenDestructuringBinding(updatedDecl, visitor, context, 1);
            var block = ts3.visitNode(node.block, visitor, ts3.isBlock);
            if (ts3.some(visitedBindings)) {
              block = factory.updateBlock(block, __spreadArray([
                factory.createVariableStatement(void 0, visitedBindings)
              ], block.statements));
            }
            return factory.updateCatchClause(node, factory.updateVariableDeclaration(node.variableDeclaration, name, void 0, void 0, void 0), block);
          }
          return ts3.visitEachChild(node, visitor, context);
        }
        function visitVariableStatement(node) {
          if (ts3.hasSyntacticModifier(node, 1)) {
            var savedExportedVariableStatement = exportedVariableStatement;
            exportedVariableStatement = true;
            var visited = ts3.visitEachChild(node, visitor, context);
            exportedVariableStatement = savedExportedVariableStatement;
            return visited;
          }
          return ts3.visitEachChild(node, visitor, context);
        }
        function visitVariableDeclaration(node) {
          if (exportedVariableStatement) {
            var savedExportedVariableStatement = exportedVariableStatement;
            exportedVariableStatement = false;
            var visited = visitVariableDeclarationWorker(node, true);
            exportedVariableStatement = savedExportedVariableStatement;
            return visited;
          }
          return visitVariableDeclarationWorker(node, false);
        }
        function visitVariableDeclarationWorker(node, exportedVariableStatement2) {
          if (ts3.isBindingPattern(node.name) && node.name.transformFlags & 32768) {
            return ts3.flattenDestructuringBinding(node, visitor, context, 1, void 0, exportedVariableStatement2);
          }
          return ts3.visitEachChild(node, visitor, context);
        }
        function visitForStatement(node) {
          return factory.updateForStatement(node, ts3.visitNode(node.initializer, visitorWithUnusedExpressionResult, ts3.isForInitializer), ts3.visitNode(node.condition, visitor, ts3.isExpression), ts3.visitNode(node.incrementor, visitorWithUnusedExpressionResult, ts3.isExpression), ts3.visitIterationBody(node.statement, visitor, context));
        }
        function visitVoidExpression(node) {
          return ts3.visitEachChild(node, visitorWithUnusedExpressionResult, context);
        }
        function visitForOfStatement(node, outermostLabeledStatement) {
          var ancestorFacts = enterSubtree(0, 2);
          if (node.initializer.transformFlags & 32768) {
            node = transformForOfStatementWithObjectRest(node);
          }
          var result2 = node.awaitModifier ? transformForAwaitOfStatement(node, outermostLabeledStatement, ancestorFacts) : factory.restoreEnclosingLabel(ts3.visitEachChild(node, visitor, context), outermostLabeledStatement);
          exitSubtree(ancestorFacts);
          return result2;
        }
        function transformForOfStatementWithObjectRest(node) {
          var initializerWithoutParens = ts3.skipParentheses(node.initializer);
          if (ts3.isVariableDeclarationList(initializerWithoutParens) || ts3.isAssignmentPattern(initializerWithoutParens)) {
            var bodyLocation = void 0;
            var statementsLocation = void 0;
            var temp = factory.createTempVariable(void 0);
            var statements = [ts3.createForOfBindingStatement(factory, initializerWithoutParens, temp)];
            if (ts3.isBlock(node.statement)) {
              ts3.addRange(statements, node.statement.statements);
              bodyLocation = node.statement;
              statementsLocation = node.statement.statements;
            } else if (node.statement) {
              ts3.append(statements, node.statement);
              bodyLocation = node.statement;
              statementsLocation = node.statement;
            }
            return factory.updateForOfStatement(node, node.awaitModifier, ts3.setTextRange(factory.createVariableDeclarationList([
              ts3.setTextRange(factory.createVariableDeclaration(temp), node.initializer)
            ], 1), node.initializer), node.expression, ts3.setTextRange(factory.createBlock(ts3.setTextRange(factory.createNodeArray(statements), statementsLocation), true), bodyLocation));
          }
          return node;
        }
        function convertForOfStatementHead(node, boundValue) {
          var binding = ts3.createForOfBindingStatement(factory, node.initializer, boundValue);
          var bodyLocation;
          var statementsLocation;
          var statements = [ts3.visitNode(binding, visitor, ts3.isStatement)];
          var statement = ts3.visitIterationBody(node.statement, visitor, context);
          if (ts3.isBlock(statement)) {
            ts3.addRange(statements, statement.statements);
            bodyLocation = statement;
            statementsLocation = statement.statements;
          } else {
            statements.push(statement);
          }
          return ts3.setEmitFlags(ts3.setTextRange(factory.createBlock(ts3.setTextRange(factory.createNodeArray(statements), statementsLocation), true), bodyLocation), 48 | 384);
        }
        function createDownlevelAwait(expression) {
          return enclosingFunctionFlags & 1 ? factory.createYieldExpression(void 0, emitHelpers().createAwaitHelper(expression)) : factory.createAwaitExpression(expression);
        }
        function transformForAwaitOfStatement(node, outermostLabeledStatement, ancestorFacts) {
          var expression = ts3.visitNode(node.expression, visitor, ts3.isExpression);
          var iterator = ts3.isIdentifier(expression) ? factory.getGeneratedNameForNode(expression) : factory.createTempVariable(void 0);
          var result2 = ts3.isIdentifier(expression) ? factory.getGeneratedNameForNode(iterator) : factory.createTempVariable(void 0);
          var errorRecord = factory.createUniqueName("e");
          var catchVariable = factory.getGeneratedNameForNode(errorRecord);
          var returnMethod = factory.createTempVariable(void 0);
          var callValues = ts3.setTextRange(emitHelpers().createAsyncValuesHelper(expression), node.expression);
          var callNext = factory.createCallExpression(factory.createPropertyAccessExpression(iterator, "next"), void 0, []);
          var getDone = factory.createPropertyAccessExpression(result2, "done");
          var getValue2 = factory.createPropertyAccessExpression(result2, "value");
          var callReturn = factory.createFunctionCallCall(returnMethod, iterator, []);
          hoistVariableDeclaration(errorRecord);
          hoistVariableDeclaration(returnMethod);
          var initializer = ancestorFacts & 2 ? factory.inlineExpressions([factory.createAssignment(errorRecord, factory.createVoidZero()), callValues]) : callValues;
          var forStatement = ts3.setEmitFlags(ts3.setTextRange(factory.createForStatement(ts3.setEmitFlags(ts3.setTextRange(factory.createVariableDeclarationList([
            ts3.setTextRange(factory.createVariableDeclaration(iterator, void 0, void 0, initializer), node.expression),
            factory.createVariableDeclaration(result2)
          ]), node.expression), 2097152), factory.createComma(factory.createAssignment(result2, createDownlevelAwait(callNext)), factory.createLogicalNot(getDone)), void 0, convertForOfStatementHead(node, getValue2)), node), 256);
          return factory.createTryStatement(factory.createBlock([
            factory.restoreEnclosingLabel(forStatement, outermostLabeledStatement)
          ]), factory.createCatchClause(factory.createVariableDeclaration(catchVariable), ts3.setEmitFlags(factory.createBlock([
            factory.createExpressionStatement(factory.createAssignment(errorRecord, factory.createObjectLiteralExpression([
              factory.createPropertyAssignment("error", catchVariable)
            ])))
          ]), 1)), factory.createBlock([
            factory.createTryStatement(factory.createBlock([
              ts3.setEmitFlags(factory.createIfStatement(factory.createLogicalAnd(factory.createLogicalAnd(result2, factory.createLogicalNot(getDone)), factory.createAssignment(returnMethod, factory.createPropertyAccessExpression(iterator, "return"))), factory.createExpressionStatement(createDownlevelAwait(callReturn))), 1)
            ]), void 0, ts3.setEmitFlags(factory.createBlock([
              ts3.setEmitFlags(factory.createIfStatement(errorRecord, factory.createThrowStatement(factory.createPropertyAccessExpression(errorRecord, "error"))), 1)
            ]), 1))
          ]));
        }
        function visitParameter(node) {
          if (node.transformFlags & 32768) {
            return factory.updateParameterDeclaration(node, void 0, void 0, node.dotDotDotToken, factory.getGeneratedNameForNode(node), void 0, void 0, ts3.visitNode(node.initializer, visitor, ts3.isExpression));
          }
          return ts3.visitEachChild(node, visitor, context);
        }
        function visitConstructorDeclaration(node) {
          var savedEnclosingFunctionFlags = enclosingFunctionFlags;
          enclosingFunctionFlags = 0;
          var updated = factory.updateConstructorDeclaration(node, void 0, node.modifiers, ts3.visitParameterList(node.parameters, visitor, context), transformFunctionBody(node));
          enclosingFunctionFlags = savedEnclosingFunctionFlags;
          return updated;
        }
        function visitGetAccessorDeclaration(node) {
          var savedEnclosingFunctionFlags = enclosingFunctionFlags;
          enclosingFunctionFlags = 0;
          var updated = factory.updateGetAccessorDeclaration(node, void 0, node.modifiers, ts3.visitNode(node.name, visitor, ts3.isPropertyName), ts3.visitParameterList(node.parameters, visitor, context), void 0, transformFunctionBody(node));
          enclosingFunctionFlags = savedEnclosingFunctionFlags;
          return updated;
        }
        function visitSetAccessorDeclaration(node) {
          var savedEnclosingFunctionFlags = enclosingFunctionFlags;
          enclosingFunctionFlags = 0;
          var updated = factory.updateSetAccessorDeclaration(node, void 0, node.modifiers, ts3.visitNode(node.name, visitor, ts3.isPropertyName), ts3.visitParameterList(node.parameters, visitor, context), transformFunctionBody(node));
          enclosingFunctionFlags = savedEnclosingFunctionFlags;
          return updated;
        }
        function visitMethodDeclaration(node) {
          var savedEnclosingFunctionFlags = enclosingFunctionFlags;
          enclosingFunctionFlags = ts3.getFunctionFlags(node);
          var updated = factory.updateMethodDeclaration(node, void 0, enclosingFunctionFlags & 1 ? ts3.visitNodes(node.modifiers, visitorNoAsyncModifier, ts3.isModifier) : node.modifiers, enclosingFunctionFlags & 2 ? void 0 : node.asteriskToken, ts3.visitNode(node.name, visitor, ts3.isPropertyName), ts3.visitNode(void 0, visitor, ts3.isToken), void 0, ts3.visitParameterList(node.parameters, visitor, context), void 0, enclosingFunctionFlags & 2 && enclosingFunctionFlags & 1 ? transformAsyncGeneratorFunctionBody(node) : transformFunctionBody(node));
          enclosingFunctionFlags = savedEnclosingFunctionFlags;
          return updated;
        }
        function visitFunctionDeclaration(node) {
          var savedEnclosingFunctionFlags = enclosingFunctionFlags;
          enclosingFunctionFlags = ts3.getFunctionFlags(node);
          var updated = factory.updateFunctionDeclaration(node, void 0, enclosingFunctionFlags & 1 ? ts3.visitNodes(node.modifiers, visitorNoAsyncModifier, ts3.isModifier) : node.modifiers, enclosingFunctionFlags & 2 ? void 0 : node.asteriskToken, node.name, void 0, ts3.visitParameterList(node.parameters, visitor, context), void 0, enclosingFunctionFlags & 2 && enclosingFunctionFlags & 1 ? transformAsyncGeneratorFunctionBody(node) : transformFunctionBody(node));
          enclosingFunctionFlags = savedEnclosingFunctionFlags;
          return updated;
        }
        function visitArrowFunction(node) {
          var savedEnclosingFunctionFlags = enclosingFunctionFlags;
          enclosingFunctionFlags = ts3.getFunctionFlags(node);
          var updated = factory.updateArrowFunction(node, node.modifiers, void 0, ts3.visitParameterList(node.parameters, visitor, context), void 0, node.equalsGreaterThanToken, transformFunctionBody(node));
          enclosingFunctionFlags = savedEnclosingFunctionFlags;
          return updated;
        }
        function visitFunctionExpression(node) {
          var savedEnclosingFunctionFlags = enclosingFunctionFlags;
          enclosingFunctionFlags = ts3.getFunctionFlags(node);
          var updated = factory.updateFunctionExpression(node, enclosingFunctionFlags & 1 ? ts3.visitNodes(node.modifiers, visitorNoAsyncModifier, ts3.isModifier) : node.modifiers, enclosingFunctionFlags & 2 ? void 0 : node.asteriskToken, node.name, void 0, ts3.visitParameterList(node.parameters, visitor, context), void 0, enclosingFunctionFlags & 2 && enclosingFunctionFlags & 1 ? transformAsyncGeneratorFunctionBody(node) : transformFunctionBody(node));
          enclosingFunctionFlags = savedEnclosingFunctionFlags;
          return updated;
        }
        function transformAsyncGeneratorFunctionBody(node) {
          resumeLexicalEnvironment();
          var statements = [];
          var statementOffset = factory.copyPrologue(node.body.statements, statements, false, visitor);
          appendObjectRestAssignmentsIfNeeded(statements, node);
          var savedCapturedSuperProperties = capturedSuperProperties;
          var savedHasSuperElementAccess = hasSuperElementAccess;
          capturedSuperProperties = new ts3.Set();
          hasSuperElementAccess = false;
          var returnStatement = factory.createReturnStatement(emitHelpers().createAsyncGeneratorHelper(factory.createFunctionExpression(void 0, factory.createToken(41), node.name && factory.getGeneratedNameForNode(node.name), void 0, [], void 0, factory.updateBlock(node.body, ts3.visitLexicalEnvironment(node.body.statements, visitor, context, statementOffset))), !!(hierarchyFacts & 1)));
          var emitSuperHelpers = languageVersion >= 2 && resolver.getNodeCheckFlags(node) & (4096 | 2048);
          if (emitSuperHelpers) {
            enableSubstitutionForAsyncMethodsWithSuper();
            var variableStatement = ts3.createSuperAccessVariableStatement(factory, resolver, node, capturedSuperProperties);
            substitutedSuperAccessors[ts3.getNodeId(variableStatement)] = true;
            ts3.insertStatementsAfterStandardPrologue(statements, [variableStatement]);
          }
          statements.push(returnStatement);
          ts3.insertStatementsAfterStandardPrologue(statements, endLexicalEnvironment());
          var block = factory.updateBlock(node.body, statements);
          if (emitSuperHelpers && hasSuperElementAccess) {
            if (resolver.getNodeCheckFlags(node) & 4096) {
              ts3.addEmitHelper(block, ts3.advancedAsyncSuperHelper);
            } else if (resolver.getNodeCheckFlags(node) & 2048) {
              ts3.addEmitHelper(block, ts3.asyncSuperHelper);
            }
          }
          capturedSuperProperties = savedCapturedSuperProperties;
          hasSuperElementAccess = savedHasSuperElementAccess;
          return block;
        }
        function transformFunctionBody(node) {
          var _a2;
          resumeLexicalEnvironment();
          var statementOffset = 0;
          var statements = [];
          var body = (_a2 = ts3.visitNode(node.body, visitor, ts3.isConciseBody)) !== null && _a2 !== void 0 ? _a2 : factory.createBlock([]);
          if (ts3.isBlock(body)) {
            statementOffset = factory.copyPrologue(body.statements, statements, false, visitor);
          }
          ts3.addRange(statements, appendObjectRestAssignmentsIfNeeded(void 0, node));
          var leadingStatements = endLexicalEnvironment();
          if (statementOffset > 0 || ts3.some(statements) || ts3.some(leadingStatements)) {
            var block = factory.converters.convertToFunctionBlock(body, true);
            ts3.insertStatementsAfterStandardPrologue(statements, leadingStatements);
            ts3.addRange(statements, block.statements.slice(statementOffset));
            return factory.updateBlock(block, ts3.setTextRange(factory.createNodeArray(statements), block.statements));
          }
          return body;
        }
        function appendObjectRestAssignmentsIfNeeded(statements, node) {
          for (var _i = 0, _a2 = node.parameters; _i < _a2.length; _i++) {
            var parameter = _a2[_i];
            if (parameter.transformFlags & 32768) {
              var temp = factory.getGeneratedNameForNode(parameter);
              var declarations = ts3.flattenDestructuringBinding(parameter, visitor, context, 1, temp, false, true);
              if (ts3.some(declarations)) {
                var statement = factory.createVariableStatement(void 0, factory.createVariableDeclarationList(declarations));
                ts3.setEmitFlags(statement, 1048576);
                statements = ts3.append(statements, statement);
              }
            }
          }
          return statements;
        }
        function enableSubstitutionForAsyncMethodsWithSuper() {
          if ((enabledSubstitutions & 1) === 0) {
            enabledSubstitutions |= 1;
            context.enableSubstitution(204);
            context.enableSubstitution(202);
            context.enableSubstitution(203);
            context.enableEmitNotification(253);
            context.enableEmitNotification(166);
            context.enableEmitNotification(168);
            context.enableEmitNotification(169);
            context.enableEmitNotification(167);
            context.enableEmitNotification(233);
          }
        }
        function onEmitNode(hint, node, emitCallback) {
          if (enabledSubstitutions & 1 && isSuperContainer(node)) {
            var superContainerFlags = resolver.getNodeCheckFlags(node) & (2048 | 4096);
            if (superContainerFlags !== enclosingSuperContainerFlags) {
              var savedEnclosingSuperContainerFlags = enclosingSuperContainerFlags;
              enclosingSuperContainerFlags = superContainerFlags;
              previousOnEmitNode(hint, node, emitCallback);
              enclosingSuperContainerFlags = savedEnclosingSuperContainerFlags;
              return;
            }
          } else if (enabledSubstitutions && substitutedSuperAccessors[ts3.getNodeId(node)]) {
            var savedEnclosingSuperContainerFlags = enclosingSuperContainerFlags;
            enclosingSuperContainerFlags = 0;
            previousOnEmitNode(hint, node, emitCallback);
            enclosingSuperContainerFlags = savedEnclosingSuperContainerFlags;
            return;
          }
          previousOnEmitNode(hint, node, emitCallback);
        }
        function onSubstituteNode(hint, node) {
          node = previousOnSubstituteNode(hint, node);
          if (hint === 1 && enclosingSuperContainerFlags) {
            return substituteExpression(node);
          }
          return node;
        }
        function substituteExpression(node) {
          switch (node.kind) {
            case 202:
              return substitutePropertyAccessExpression(node);
            case 203:
              return substituteElementAccessExpression(node);
            case 204:
              return substituteCallExpression(node);
          }
          return node;
        }
        function substitutePropertyAccessExpression(node) {
          if (node.expression.kind === 105) {
            return ts3.setTextRange(factory.createPropertyAccessExpression(factory.createUniqueName("_super", 16 | 32), node.name), node);
          }
          return node;
        }
        function substituteElementAccessExpression(node) {
          if (node.expression.kind === 105) {
            return createSuperElementAccessInAsyncMethod(node.argumentExpression, node);
          }
          return node;
        }
        function substituteCallExpression(node) {
          var expression = node.expression;
          if (ts3.isSuperProperty(expression)) {
            var argumentExpression = ts3.isPropertyAccessExpression(expression) ? substitutePropertyAccessExpression(expression) : substituteElementAccessExpression(expression);
            return factory.createCallExpression(factory.createPropertyAccessExpression(argumentExpression, "call"), void 0, __spreadArray([
              factory.createThis()
            ], node.arguments));
          }
          return node;
        }
        function isSuperContainer(node) {
          var kind = node.kind;
          return kind === 253 || kind === 167 || kind === 166 || kind === 168 || kind === 169;
        }
        function createSuperElementAccessInAsyncMethod(argumentExpression, location) {
          if (enclosingSuperContainerFlags & 4096) {
            return ts3.setTextRange(factory.createPropertyAccessExpression(factory.createCallExpression(factory.createIdentifier("_superIndex"), void 0, [argumentExpression]), "value"), location);
          } else {
            return ts3.setTextRange(factory.createCallExpression(factory.createIdentifier("_superIndex"), void 0, [argumentExpression]), location);
          }
        }
      }
      ts3.transformES2018 = transformES2018;
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      function transformES2019(context) {
        var factory = context.factory;
        return ts3.chainBundle(context, transformSourceFile);
        function transformSourceFile(node) {
          if (node.isDeclarationFile) {
            return node;
          }
          return ts3.visitEachChild(node, visitor, context);
        }
        function visitor(node) {
          if ((node.transformFlags & 32) === 0) {
            return node;
          }
          switch (node.kind) {
            case 288:
              return visitCatchClause(node);
            default:
              return ts3.visitEachChild(node, visitor, context);
          }
        }
        function visitCatchClause(node) {
          if (!node.variableDeclaration) {
            return factory.updateCatchClause(node, factory.createVariableDeclaration(factory.createTempVariable(void 0)), ts3.visitNode(node.block, visitor, ts3.isBlock));
          }
          return ts3.visitEachChild(node, visitor, context);
        }
      }
      ts3.transformES2019 = transformES2019;
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      function transformES2020(context) {
        var factory = context.factory, hoistVariableDeclaration = context.hoistVariableDeclaration;
        return ts3.chainBundle(context, transformSourceFile);
        function transformSourceFile(node) {
          if (node.isDeclarationFile) {
            return node;
          }
          return ts3.visitEachChild(node, visitor, context);
        }
        function visitor(node) {
          if ((node.transformFlags & 16) === 0) {
            return node;
          }
          switch (node.kind) {
            case 204: {
              var updated = visitNonOptionalCallExpression(node, false);
              ts3.Debug.assertNotNode(updated, ts3.isSyntheticReference);
              return updated;
            }
            case 202:
            case 203:
              if (ts3.isOptionalChain(node)) {
                var updated = visitOptionalExpression(node, false, false);
                ts3.Debug.assertNotNode(updated, ts3.isSyntheticReference);
                return updated;
              }
              return ts3.visitEachChild(node, visitor, context);
            case 217:
              if (node.operatorToken.kind === 60) {
                return transformNullishCoalescingExpression(node);
              }
              return ts3.visitEachChild(node, visitor, context);
            case 211:
              return visitDeleteExpression(node);
            default:
              return ts3.visitEachChild(node, visitor, context);
          }
        }
        function flattenChain(chain) {
          ts3.Debug.assertNotNode(chain, ts3.isNonNullChain);
          var links = [chain];
          while (!chain.questionDotToken && !ts3.isTaggedTemplateExpression(chain)) {
            chain = ts3.cast(ts3.skipPartiallyEmittedExpressions(chain.expression), ts3.isOptionalChain);
            ts3.Debug.assertNotNode(chain, ts3.isNonNullChain);
            links.unshift(chain);
          }
          return { expression: chain.expression, chain: links };
        }
        function visitNonOptionalParenthesizedExpression(node, captureThisArg, isDelete) {
          var expression = visitNonOptionalExpression(node.expression, captureThisArg, isDelete);
          if (ts3.isSyntheticReference(expression)) {
            return factory.createSyntheticReferenceExpression(factory.updateParenthesizedExpression(node, expression.expression), expression.thisArg);
          }
          return factory.updateParenthesizedExpression(node, expression);
        }
        function visitNonOptionalPropertyOrElementAccessExpression(node, captureThisArg, isDelete) {
          if (ts3.isOptionalChain(node)) {
            return visitOptionalExpression(node, captureThisArg, isDelete);
          }
          var expression = ts3.visitNode(node.expression, visitor, ts3.isExpression);
          ts3.Debug.assertNotNode(expression, ts3.isSyntheticReference);
          var thisArg;
          if (captureThisArg) {
            if (!ts3.isSimpleCopiableExpression(expression)) {
              thisArg = factory.createTempVariable(hoistVariableDeclaration);
              expression = factory.createAssignment(thisArg, expression);
            } else {
              thisArg = expression;
            }
          }
          expression = node.kind === 202 ? factory.updatePropertyAccessExpression(node, expression, ts3.visitNode(node.name, visitor, ts3.isIdentifier)) : factory.updateElementAccessExpression(node, expression, ts3.visitNode(node.argumentExpression, visitor, ts3.isExpression));
          return thisArg ? factory.createSyntheticReferenceExpression(expression, thisArg) : expression;
        }
        function visitNonOptionalCallExpression(node, captureThisArg) {
          if (ts3.isOptionalChain(node)) {
            return visitOptionalExpression(node, captureThisArg, false);
          }
          if (ts3.isParenthesizedExpression(node.expression) && ts3.isOptionalChain(ts3.skipParentheses(node.expression))) {
            var expression = visitNonOptionalParenthesizedExpression(node.expression, true, false);
            var args = ts3.visitNodes(node.arguments, visitor, ts3.isExpression);
            if (ts3.isSyntheticReference(expression)) {
              return ts3.setTextRange(factory.createFunctionCallCall(expression.expression, expression.thisArg, args), node);
            }
            return factory.updateCallExpression(node, expression, void 0, args);
          }
          return ts3.visitEachChild(node, visitor, context);
        }
        function visitNonOptionalExpression(node, captureThisArg, isDelete) {
          switch (node.kind) {
            case 208:
              return visitNonOptionalParenthesizedExpression(node, captureThisArg, isDelete);
            case 202:
            case 203:
              return visitNonOptionalPropertyOrElementAccessExpression(node, captureThisArg, isDelete);
            case 204:
              return visitNonOptionalCallExpression(node, captureThisArg);
            default:
              return ts3.visitNode(node, visitor, ts3.isExpression);
          }
        }
        function visitOptionalExpression(node, captureThisArg, isDelete) {
          var _a2 = flattenChain(node), expression = _a2.expression, chain = _a2.chain;
          var left = visitNonOptionalExpression(expression, ts3.isCallChain(chain[0]), false);
          var leftThisArg = ts3.isSyntheticReference(left) ? left.thisArg : void 0;
          var leftExpression = ts3.isSyntheticReference(left) ? left.expression : left;
          var capturedLeft = leftExpression;
          if (!ts3.isSimpleCopiableExpression(leftExpression)) {
            capturedLeft = factory.createTempVariable(hoistVariableDeclaration);
            leftExpression = factory.createAssignment(capturedLeft, leftExpression);
          }
          var rightExpression = capturedLeft;
          var thisArg;
          for (var i3 = 0; i3 < chain.length; i3++) {
            var segment = chain[i3];
            switch (segment.kind) {
              case 202:
              case 203:
                if (i3 === chain.length - 1 && captureThisArg) {
                  if (!ts3.isSimpleCopiableExpression(rightExpression)) {
                    thisArg = factory.createTempVariable(hoistVariableDeclaration);
                    rightExpression = factory.createAssignment(thisArg, rightExpression);
                  } else {
                    thisArg = rightExpression;
                  }
                }
                rightExpression = segment.kind === 202 ? factory.createPropertyAccessExpression(rightExpression, ts3.visitNode(segment.name, visitor, ts3.isIdentifier)) : factory.createElementAccessExpression(rightExpression, ts3.visitNode(segment.argumentExpression, visitor, ts3.isExpression));
                break;
              case 204:
                if (i3 === 0 && leftThisArg) {
                  rightExpression = factory.createFunctionCallCall(rightExpression, leftThisArg.kind === 105 ? factory.createThis() : leftThisArg, ts3.visitNodes(segment.arguments, visitor, ts3.isExpression));
                } else {
                  rightExpression = factory.createCallExpression(rightExpression, void 0, ts3.visitNodes(segment.arguments, visitor, ts3.isExpression));
                }
                break;
            }
            ts3.setOriginalNode(rightExpression, segment);
          }
          var target = isDelete ? factory.createConditionalExpression(createNotNullCondition(leftExpression, capturedLeft, true), void 0, factory.createTrue(), void 0, factory.createDeleteExpression(rightExpression)) : factory.createConditionalExpression(createNotNullCondition(leftExpression, capturedLeft, true), void 0, factory.createVoidZero(), void 0, rightExpression);
          ts3.setTextRange(target, node);
          return thisArg ? factory.createSyntheticReferenceExpression(target, thisArg) : target;
        }
        function createNotNullCondition(left, right, invert) {
          return factory.createBinaryExpression(factory.createBinaryExpression(left, factory.createToken(invert ? 36 : 37), factory.createNull()), factory.createToken(invert ? 56 : 55), factory.createBinaryExpression(right, factory.createToken(invert ? 36 : 37), factory.createVoidZero()));
        }
        function transformNullishCoalescingExpression(node) {
          var left = ts3.visitNode(node.left, visitor, ts3.isExpression);
          var right = left;
          if (!ts3.isSimpleCopiableExpression(left)) {
            right = factory.createTempVariable(hoistVariableDeclaration);
            left = factory.createAssignment(right, left);
          }
          return ts3.setTextRange(factory.createConditionalExpression(createNotNullCondition(left, right), void 0, right, void 0, ts3.visitNode(node.right, visitor, ts3.isExpression)), node);
        }
        function visitDeleteExpression(node) {
          return ts3.isOptionalChain(ts3.skipParentheses(node.expression)) ? ts3.setOriginalNode(visitNonOptionalExpression(node.expression, false, true), node) : factory.updateDeleteExpression(node, ts3.visitNode(node.expression, visitor, ts3.isExpression));
        }
      }
      ts3.transformES2020 = transformES2020;
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      function transformES2021(context) {
        var hoistVariableDeclaration = context.hoistVariableDeclaration, factory = context.factory;
        return ts3.chainBundle(context, transformSourceFile);
        function transformSourceFile(node) {
          if (node.isDeclarationFile) {
            return node;
          }
          return ts3.visitEachChild(node, visitor, context);
        }
        function visitor(node) {
          if ((node.transformFlags & 8) === 0) {
            return node;
          }
          switch (node.kind) {
            case 217:
              var binaryExpression = node;
              if (ts3.isLogicalOrCoalescingAssignmentExpression(binaryExpression)) {
                return transformLogicalAssignment(binaryExpression);
              }
            default:
              return ts3.visitEachChild(node, visitor, context);
          }
        }
        function transformLogicalAssignment(binaryExpression) {
          var operator = binaryExpression.operatorToken;
          var nonAssignmentOperator = ts3.getNonAssignmentOperatorForCompoundAssignment(operator.kind);
          var left = ts3.skipParentheses(ts3.visitNode(binaryExpression.left, visitor, ts3.isLeftHandSideExpression));
          var assignmentTarget = left;
          var right = ts3.skipParentheses(ts3.visitNode(binaryExpression.right, visitor, ts3.isExpression));
          if (ts3.isAccessExpression(left)) {
            var propertyAccessTargetSimpleCopiable = ts3.isSimpleCopiableExpression(left.expression);
            var propertyAccessTarget = propertyAccessTargetSimpleCopiable ? left.expression : factory.createTempVariable(hoistVariableDeclaration);
            var propertyAccessTargetAssignment = propertyAccessTargetSimpleCopiable ? left.expression : factory.createAssignment(propertyAccessTarget, left.expression);
            if (ts3.isPropertyAccessExpression(left)) {
              assignmentTarget = factory.createPropertyAccessExpression(propertyAccessTarget, left.name);
              left = factory.createPropertyAccessExpression(propertyAccessTargetAssignment, left.name);
            } else {
              var elementAccessArgumentSimpleCopiable = ts3.isSimpleCopiableExpression(left.argumentExpression);
              var elementAccessArgument = elementAccessArgumentSimpleCopiable ? left.argumentExpression : factory.createTempVariable(hoistVariableDeclaration);
              assignmentTarget = factory.createElementAccessExpression(propertyAccessTarget, elementAccessArgument);
              left = factory.createElementAccessExpression(propertyAccessTargetAssignment, elementAccessArgumentSimpleCopiable ? left.argumentExpression : factory.createAssignment(elementAccessArgument, left.argumentExpression));
            }
          }
          return factory.createBinaryExpression(left, nonAssignmentOperator, factory.createParenthesizedExpression(factory.createAssignment(assignmentTarget, right)));
        }
      }
      ts3.transformES2021 = transformES2021;
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      function transformESNext(context) {
        return ts3.chainBundle(context, transformSourceFile);
        function transformSourceFile(node) {
          if (node.isDeclarationFile) {
            return node;
          }
          return ts3.visitEachChild(node, visitor, context);
        }
        function visitor(node) {
          if ((node.transformFlags & 4) === 0) {
            return node;
          }
          switch (node.kind) {
            default:
              return ts3.visitEachChild(node, visitor, context);
          }
        }
      }
      ts3.transformESNext = transformESNext;
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      function transformJsx(context) {
        var factory = context.factory, emitHelpers = context.getEmitHelperFactory;
        var compilerOptions = context.getCompilerOptions();
        var currentSourceFile;
        var currentFileState;
        return ts3.chainBundle(context, transformSourceFile);
        function getCurrentFileNameExpression() {
          if (currentFileState.filenameDeclaration) {
            return currentFileState.filenameDeclaration.name;
          }
          var declaration = factory.createVariableDeclaration(factory.createUniqueName("_jsxFileName", 16 | 32), void 0, void 0, factory.createStringLiteral(currentSourceFile.fileName));
          currentFileState.filenameDeclaration = declaration;
          return currentFileState.filenameDeclaration.name;
        }
        function getJsxFactoryCalleePrimitive(childrenLength) {
          return compilerOptions.jsx === 5 ? "jsxDEV" : childrenLength > 1 ? "jsxs" : "jsx";
        }
        function getJsxFactoryCallee(childrenLength) {
          var type3 = getJsxFactoryCalleePrimitive(childrenLength);
          return getImplicitImportForName(type3);
        }
        function getImplicitJsxFragmentReference() {
          return getImplicitImportForName("Fragment");
        }
        function getImplicitImportForName(name) {
          var _a2, _b;
          var importSource = name === "createElement" ? currentFileState.importSpecifier : ts3.getJSXRuntimeImport(currentFileState.importSpecifier, compilerOptions);
          var existing = (_b = (_a2 = currentFileState.utilizedImplicitRuntimeImports) === null || _a2 === void 0 ? void 0 : _a2.get(importSource)) === null || _b === void 0 ? void 0 : _b.get(name);
          if (existing) {
            return existing.name;
          }
          if (!currentFileState.utilizedImplicitRuntimeImports) {
            currentFileState.utilizedImplicitRuntimeImports = ts3.createMap();
          }
          var specifierSourceImports = currentFileState.utilizedImplicitRuntimeImports.get(importSource);
          if (!specifierSourceImports) {
            specifierSourceImports = ts3.createMap();
            currentFileState.utilizedImplicitRuntimeImports.set(importSource, specifierSourceImports);
          }
          var generatedName = factory.createUniqueName("_" + name, 16 | 32 | 64);
          var specifier = factory.createImportSpecifier(factory.createIdentifier(name), generatedName);
          generatedName.generatedImportReference = specifier;
          specifierSourceImports.set(name, specifier);
          return generatedName;
        }
        function transformSourceFile(node) {
          if (node.isDeclarationFile) {
            return node;
          }
          currentSourceFile = node;
          currentFileState = {};
          currentFileState.importSpecifier = ts3.getJSXImplicitImportBase(compilerOptions, node);
          var visited = ts3.visitEachChild(node, visitor, context);
          ts3.addEmitHelpers(visited, context.readEmitHelpers());
          var statements = visited.statements;
          if (currentFileState.filenameDeclaration) {
            statements = ts3.insertStatementAfterCustomPrologue(statements.slice(), factory.createVariableStatement(void 0, factory.createVariableDeclarationList([currentFileState.filenameDeclaration], 2)));
          }
          if (currentFileState.utilizedImplicitRuntimeImports) {
            for (var _i = 0, _a2 = ts3.arrayFrom(currentFileState.utilizedImplicitRuntimeImports.entries()); _i < _a2.length; _i++) {
              var _b = _a2[_i], importSource = _b[0], importSpecifiersMap = _b[1];
              if (ts3.isExternalModule(node)) {
                var importStatement = factory.createImportDeclaration(void 0, void 0, factory.createImportClause(false, void 0, factory.createNamedImports(ts3.arrayFrom(importSpecifiersMap.values()))), factory.createStringLiteral(importSource));
                ts3.setParentRecursive(importStatement, false);
                statements = ts3.insertStatementAfterCustomPrologue(statements.slice(), importStatement);
              } else if (ts3.isExternalOrCommonJsModule(node)) {
                var requireStatement = factory.createVariableStatement(void 0, factory.createVariableDeclarationList([
                  factory.createVariableDeclaration(factory.createObjectBindingPattern(ts3.map(ts3.arrayFrom(importSpecifiersMap.values()), function(s2) {
                    return factory.createBindingElement(void 0, s2.propertyName, s2.name);
                  })), void 0, void 0, factory.createCallExpression(factory.createIdentifier("require"), void 0, [factory.createStringLiteral(importSource)]))
                ], 2));
                ts3.setParentRecursive(requireStatement, false);
                statements = ts3.insertStatementAfterCustomPrologue(statements.slice(), requireStatement);
              } else {
              }
            }
          }
          if (statements !== visited.statements) {
            visited = factory.updateSourceFile(visited, statements);
          }
          currentFileState = void 0;
          return visited;
        }
        function visitor(node) {
          if (node.transformFlags & 2) {
            return visitorWorker(node);
          } else {
            return node;
          }
        }
        function visitorWorker(node) {
          switch (node.kind) {
            case 274:
              return visitJsxElement(node, false);
            case 275:
              return visitJsxSelfClosingElement(node, false);
            case 278:
              return visitJsxFragment(node, false);
            case 284:
              return visitJsxExpression(node);
            default:
              return ts3.visitEachChild(node, visitor, context);
          }
        }
        function transformJsxChildToExpression(node) {
          switch (node.kind) {
            case 11:
              return visitJsxText(node);
            case 284:
              return visitJsxExpression(node);
            case 274:
              return visitJsxElement(node, true);
            case 275:
              return visitJsxSelfClosingElement(node, true);
            case 278:
              return visitJsxFragment(node, true);
            default:
              return ts3.Debug.failBadSyntaxKind(node);
          }
        }
        function hasKeyAfterPropsSpread(node) {
          var spread = false;
          for (var _i = 0, _a2 = node.attributes.properties; _i < _a2.length; _i++) {
            var elem = _a2[_i];
            if (ts3.isJsxSpreadAttribute(elem)) {
              spread = true;
            } else if (spread && ts3.isJsxAttribute(elem) && elem.name.escapedText === "key") {
              return true;
            }
          }
          return false;
        }
        function shouldUseCreateElement(node) {
          return currentFileState.importSpecifier === void 0 || hasKeyAfterPropsSpread(node);
        }
        function visitJsxElement(node, isChild) {
          var tagTransform = shouldUseCreateElement(node.openingElement) ? visitJsxOpeningLikeElementCreateElement : visitJsxOpeningLikeElementJSX;
          return tagTransform(node.openingElement, node.children, isChild, node);
        }
        function visitJsxSelfClosingElement(node, isChild) {
          var tagTransform = shouldUseCreateElement(node) ? visitJsxOpeningLikeElementCreateElement : visitJsxOpeningLikeElementJSX;
          return tagTransform(node, void 0, isChild, node);
        }
        function visitJsxFragment(node, isChild) {
          var tagTransform = currentFileState.importSpecifier === void 0 ? visitJsxOpeningFragmentCreateElement : visitJsxOpeningFragmentJSX;
          return tagTransform(node.openingFragment, node.children, isChild, node);
        }
        function convertJsxChildrenToChildrenPropObject(children) {
          var nonWhitespaceChildren = ts3.getSemanticJsxChildren(children);
          if (ts3.length(nonWhitespaceChildren) === 1) {
            var result_14 = transformJsxChildToExpression(nonWhitespaceChildren[0]);
            return result_14 && factory.createObjectLiteralExpression([
              factory.createPropertyAssignment("children", result_14)
            ]);
          }
          var result2 = ts3.mapDefined(children, transformJsxChildToExpression);
          return !result2.length ? void 0 : factory.createObjectLiteralExpression([
            factory.createPropertyAssignment("children", factory.createArrayLiteralExpression(result2))
          ]);
        }
        function visitJsxOpeningLikeElementJSX(node, children, isChild, location) {
          var tagName = getTagName(node);
          var objectProperties;
          var keyAttr = ts3.find(node.attributes.properties, function(p) {
            return !!p.name && ts3.isIdentifier(p.name) && p.name.escapedText === "key";
          });
          var attrs = keyAttr ? ts3.filter(node.attributes.properties, function(p) {
            return p !== keyAttr;
          }) : node.attributes.properties;
          var segments = [];
          if (attrs.length) {
            segments = ts3.flatten(ts3.spanMap(attrs, ts3.isJsxSpreadAttribute, function(attrs2, isSpread) {
              return isSpread ? ts3.map(attrs2, transformJsxSpreadAttributeToExpression) : factory.createObjectLiteralExpression(ts3.map(attrs2, transformJsxAttributeToObjectLiteralElement));
            }));
            if (ts3.isJsxSpreadAttribute(attrs[0])) {
              segments.unshift(factory.createObjectLiteralExpression());
            }
          }
          if (children && children.length) {
            var result2 = convertJsxChildrenToChildrenPropObject(children);
            if (result2) {
              segments.push(result2);
            }
          }
          if (segments.length === 0) {
            objectProperties = factory.createObjectLiteralExpression([]);
          } else {
            objectProperties = ts3.singleOrUndefined(segments) || emitHelpers().createAssignHelper(segments);
          }
          return visitJsxOpeningLikeElementOrFragmentJSX(tagName, objectProperties, keyAttr, ts3.length(ts3.getSemanticJsxChildren(children || ts3.emptyArray)), isChild, location);
        }
        function visitJsxOpeningLikeElementOrFragmentJSX(tagName, objectProperties, keyAttr, childrenLength, isChild, location) {
          var args = [tagName, objectProperties, !keyAttr ? factory.createVoidZero() : transformJsxAttributeInitializer(keyAttr.initializer)];
          if (compilerOptions.jsx === 5) {
            var originalFile = ts3.getOriginalNode(currentSourceFile);
            if (originalFile && ts3.isSourceFile(originalFile)) {
              args.push(childrenLength > 1 ? factory.createTrue() : factory.createFalse());
              var lineCol = ts3.getLineAndCharacterOfPosition(originalFile, location.pos);
              args.push(factory.createObjectLiteralExpression([
                factory.createPropertyAssignment("fileName", getCurrentFileNameExpression()),
                factory.createPropertyAssignment("lineNumber", factory.createNumericLiteral(lineCol.line + 1)),
                factory.createPropertyAssignment("columnNumber", factory.createNumericLiteral(lineCol.character + 1))
              ]));
              args.push(factory.createThis());
            }
          }
          var element = ts3.setTextRange(factory.createCallExpression(getJsxFactoryCallee(childrenLength), void 0, args), location);
          if (isChild) {
            ts3.startOnNewLine(element);
          }
          return element;
        }
        function visitJsxOpeningLikeElementCreateElement(node, children, isChild, location) {
          var tagName = getTagName(node);
          var objectProperties;
          var attrs = node.attributes.properties;
          if (attrs.length === 0) {
            objectProperties = factory.createNull();
          } else {
            var target = compilerOptions.target;
            if (target && target >= 5) {
              objectProperties = factory.createObjectLiteralExpression(ts3.flatten(ts3.spanMap(attrs, ts3.isJsxSpreadAttribute, function(attrs2, isSpread) {
                return isSpread ? ts3.map(attrs2, transformJsxSpreadAttributeToSpreadAssignment) : ts3.map(attrs2, transformJsxAttributeToObjectLiteralElement);
              })));
            } else {
              var segments = ts3.flatten(ts3.spanMap(attrs, ts3.isJsxSpreadAttribute, function(attrs2, isSpread) {
                return isSpread ? ts3.map(attrs2, transformJsxSpreadAttributeToExpression) : factory.createObjectLiteralExpression(ts3.map(attrs2, transformJsxAttributeToObjectLiteralElement));
              }));
              if (ts3.isJsxSpreadAttribute(attrs[0])) {
                segments.unshift(factory.createObjectLiteralExpression());
              }
              objectProperties = ts3.singleOrUndefined(segments);
              if (!objectProperties) {
                objectProperties = emitHelpers().createAssignHelper(segments);
              }
            }
          }
          var callee = currentFileState.importSpecifier === void 0 ? ts3.createJsxFactoryExpression(factory, context.getEmitResolver().getJsxFactoryEntity(currentSourceFile), compilerOptions.reactNamespace, node) : getImplicitImportForName("createElement");
          var element = ts3.createExpressionForJsxElement(factory, callee, tagName, objectProperties, ts3.mapDefined(children, transformJsxChildToExpression), location);
          if (isChild) {
            ts3.startOnNewLine(element);
          }
          return element;
        }
        function visitJsxOpeningFragmentJSX(_node, children, isChild, location) {
          var childrenProps;
          if (children && children.length) {
            var result2 = convertJsxChildrenToChildrenPropObject(children);
            if (result2) {
              childrenProps = result2;
            }
          }
          return visitJsxOpeningLikeElementOrFragmentJSX(getImplicitJsxFragmentReference(), childrenProps || factory.createObjectLiteralExpression([]), void 0, ts3.length(ts3.getSemanticJsxChildren(children)), isChild, location);
        }
        function visitJsxOpeningFragmentCreateElement(node, children, isChild, location) {
          var element = ts3.createExpressionForJsxFragment(factory, context.getEmitResolver().getJsxFactoryEntity(currentSourceFile), context.getEmitResolver().getJsxFragmentFactoryEntity(currentSourceFile), compilerOptions.reactNamespace, ts3.mapDefined(children, transformJsxChildToExpression), node, location);
          if (isChild) {
            ts3.startOnNewLine(element);
          }
          return element;
        }
        function transformJsxSpreadAttributeToSpreadAssignment(node) {
          return factory.createSpreadAssignment(ts3.visitNode(node.expression, visitor, ts3.isExpression));
        }
        function transformJsxSpreadAttributeToExpression(node) {
          return ts3.visitNode(node.expression, visitor, ts3.isExpression);
        }
        function transformJsxAttributeToObjectLiteralElement(node) {
          var name = getAttributeName(node);
          var expression = transformJsxAttributeInitializer(node.initializer);
          return factory.createPropertyAssignment(name, expression);
        }
        function transformJsxAttributeInitializer(node) {
          if (node === void 0) {
            return factory.createTrue();
          } else if (node.kind === 10) {
            var singleQuote = node.singleQuote !== void 0 ? node.singleQuote : !ts3.isStringDoubleQuoted(node, currentSourceFile);
            var literal = factory.createStringLiteral(tryDecodeEntities(node.text) || node.text, singleQuote);
            return ts3.setTextRange(literal, node);
          } else if (node.kind === 284) {
            if (node.expression === void 0) {
              return factory.createTrue();
            }
            return ts3.visitNode(node.expression, visitor, ts3.isExpression);
          } else {
            return ts3.Debug.failBadSyntaxKind(node);
          }
        }
        function visitJsxText(node) {
          var fixed = fixupWhitespaceAndDecodeEntities(node.text);
          return fixed === void 0 ? void 0 : factory.createStringLiteral(fixed);
        }
        function fixupWhitespaceAndDecodeEntities(text) {
          var acc;
          var firstNonWhitespace = 0;
          var lastNonWhitespace = -1;
          for (var i3 = 0; i3 < text.length; i3++) {
            var c2 = text.charCodeAt(i3);
            if (ts3.isLineBreak(c2)) {
              if (firstNonWhitespace !== -1 && lastNonWhitespace !== -1) {
                acc = addLineOfJsxText(acc, text.substr(firstNonWhitespace, lastNonWhitespace - firstNonWhitespace + 1));
              }
              firstNonWhitespace = -1;
            } else if (!ts3.isWhiteSpaceSingleLine(c2)) {
              lastNonWhitespace = i3;
              if (firstNonWhitespace === -1) {
                firstNonWhitespace = i3;
              }
            }
          }
          return firstNonWhitespace !== -1 ? addLineOfJsxText(acc, text.substr(firstNonWhitespace)) : acc;
        }
        function addLineOfJsxText(acc, trimmedLine) {
          var decoded = decodeEntities(trimmedLine);
          return acc === void 0 ? decoded : acc + " " + decoded;
        }
        function decodeEntities(text) {
          return text.replace(/&((#((\d+)|x([\da-fA-F]+)))|(\w+));/g, function(match, _all, _number, _digits, decimal, hex, word) {
            if (decimal) {
              return ts3.utf16EncodeAsString(parseInt(decimal, 10));
            } else if (hex) {
              return ts3.utf16EncodeAsString(parseInt(hex, 16));
            } else {
              var ch = entities.get(word);
              return ch ? ts3.utf16EncodeAsString(ch) : match;
            }
          });
        }
        function tryDecodeEntities(text) {
          var decoded = decodeEntities(text);
          return decoded === text ? void 0 : decoded;
        }
        function getTagName(node) {
          if (node.kind === 274) {
            return getTagName(node.openingElement);
          } else {
            var name = node.tagName;
            if (ts3.isIdentifier(name) && ts3.isIntrinsicJsxName(name.escapedText)) {
              return factory.createStringLiteral(ts3.idText(name));
            } else {
              return ts3.createExpressionFromEntityName(factory, name);
            }
          }
        }
        function getAttributeName(node) {
          var name = node.name;
          var text = ts3.idText(name);
          if (/^[A-Za-z_]\w*$/.test(text)) {
            return name;
          } else {
            return factory.createStringLiteral(text);
          }
        }
        function visitJsxExpression(node) {
          return ts3.visitNode(node.expression, visitor, ts3.isExpression);
        }
      }
      ts3.transformJsx = transformJsx;
      var entities = new ts3.Map(ts3.getEntries({
        quot: 34,
        amp: 38,
        apos: 39,
        lt: 60,
        gt: 62,
        nbsp: 160,
        iexcl: 161,
        cent: 162,
        pound: 163,
        curren: 164,
        yen: 165,
        brvbar: 166,
        sect: 167,
        uml: 168,
        copy: 169,
        ordf: 170,
        laquo: 171,
        not: 172,
        shy: 173,
        reg: 174,
        macr: 175,
        deg: 176,
        plusmn: 177,
        sup2: 178,
        sup3: 179,
        acute: 180,
        micro: 181,
        para: 182,
        middot: 183,
        cedil: 184,
        sup1: 185,
        ordm: 186,
        raquo: 187,
        frac14: 188,
        frac12: 189,
        frac34: 190,
        iquest: 191,
        Agrave: 192,
        Aacute: 193,
        Acirc: 194,
        Atilde: 195,
        Auml: 196,
        Aring: 197,
        AElig: 198,
        Ccedil: 199,
        Egrave: 200,
        Eacute: 201,
        Ecirc: 202,
        Euml: 203,
        Igrave: 204,
        Iacute: 205,
        Icirc: 206,
        Iuml: 207,
        ETH: 208,
        Ntilde: 209,
        Ograve: 210,
        Oacute: 211,
        Ocirc: 212,
        Otilde: 213,
        Ouml: 214,
        times: 215,
        Oslash: 216,
        Ugrave: 217,
        Uacute: 218,
        Ucirc: 219,
        Uuml: 220,
        Yacute: 221,
        THORN: 222,
        szlig: 223,
        agrave: 224,
        aacute: 225,
        acirc: 226,
        atilde: 227,
        auml: 228,
        aring: 229,
        aelig: 230,
        ccedil: 231,
        egrave: 232,
        eacute: 233,
        ecirc: 234,
        euml: 235,
        igrave: 236,
        iacute: 237,
        icirc: 238,
        iuml: 239,
        eth: 240,
        ntilde: 241,
        ograve: 242,
        oacute: 243,
        ocirc: 244,
        otilde: 245,
        ouml: 246,
        divide: 247,
        oslash: 248,
        ugrave: 249,
        uacute: 250,
        ucirc: 251,
        uuml: 252,
        yacute: 253,
        thorn: 254,
        yuml: 255,
        OElig: 338,
        oelig: 339,
        Scaron: 352,
        scaron: 353,
        Yuml: 376,
        fnof: 402,
        circ: 710,
        tilde: 732,
        Alpha: 913,
        Beta: 914,
        Gamma: 915,
        Delta: 916,
        Epsilon: 917,
        Zeta: 918,
        Eta: 919,
        Theta: 920,
        Iota: 921,
        Kappa: 922,
        Lambda: 923,
        Mu: 924,
        Nu: 925,
        Xi: 926,
        Omicron: 927,
        Pi: 928,
        Rho: 929,
        Sigma: 931,
        Tau: 932,
        Upsilon: 933,
        Phi: 934,
        Chi: 935,
        Psi: 936,
        Omega: 937,
        alpha: 945,
        beta: 946,
        gamma: 947,
        delta: 948,
        epsilon: 949,
        zeta: 950,
        eta: 951,
        theta: 952,
        iota: 953,
        kappa: 954,
        lambda: 955,
        mu: 956,
        nu: 957,
        xi: 958,
        omicron: 959,
        pi: 960,
        rho: 961,
        sigmaf: 962,
        sigma: 963,
        tau: 964,
        upsilon: 965,
        phi: 966,
        chi: 967,
        psi: 968,
        omega: 969,
        thetasym: 977,
        upsih: 978,
        piv: 982,
        ensp: 8194,
        emsp: 8195,
        thinsp: 8201,
        zwnj: 8204,
        zwj: 8205,
        lrm: 8206,
        rlm: 8207,
        ndash: 8211,
        mdash: 8212,
        lsquo: 8216,
        rsquo: 8217,
        sbquo: 8218,
        ldquo: 8220,
        rdquo: 8221,
        bdquo: 8222,
        dagger: 8224,
        Dagger: 8225,
        bull: 8226,
        hellip: 8230,
        permil: 8240,
        prime: 8242,
        Prime: 8243,
        lsaquo: 8249,
        rsaquo: 8250,
        oline: 8254,
        frasl: 8260,
        euro: 8364,
        image: 8465,
        weierp: 8472,
        real: 8476,
        trade: 8482,
        alefsym: 8501,
        larr: 8592,
        uarr: 8593,
        rarr: 8594,
        darr: 8595,
        harr: 8596,
        crarr: 8629,
        lArr: 8656,
        uArr: 8657,
        rArr: 8658,
        dArr: 8659,
        hArr: 8660,
        forall: 8704,
        part: 8706,
        exist: 8707,
        empty: 8709,
        nabla: 8711,
        isin: 8712,
        notin: 8713,
        ni: 8715,
        prod: 8719,
        sum: 8721,
        minus: 8722,
        lowast: 8727,
        radic: 8730,
        prop: 8733,
        infin: 8734,
        ang: 8736,
        and: 8743,
        or: 8744,
        cap: 8745,
        cup: 8746,
        int: 8747,
        there4: 8756,
        sim: 8764,
        cong: 8773,
        asymp: 8776,
        ne: 8800,
        equiv: 8801,
        le: 8804,
        ge: 8805,
        sub: 8834,
        sup: 8835,
        nsub: 8836,
        sube: 8838,
        supe: 8839,
        oplus: 8853,
        otimes: 8855,
        perp: 8869,
        sdot: 8901,
        lceil: 8968,
        rceil: 8969,
        lfloor: 8970,
        rfloor: 8971,
        lang: 9001,
        rang: 9002,
        loz: 9674,
        spades: 9824,
        clubs: 9827,
        hearts: 9829,
        diams: 9830
      }));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      function transformES2016(context) {
        var factory = context.factory, hoistVariableDeclaration = context.hoistVariableDeclaration;
        return ts3.chainBundle(context, transformSourceFile);
        function transformSourceFile(node) {
          if (node.isDeclarationFile) {
            return node;
          }
          return ts3.visitEachChild(node, visitor, context);
        }
        function visitor(node) {
          if ((node.transformFlags & 256) === 0) {
            return node;
          }
          switch (node.kind) {
            case 217:
              return visitBinaryExpression(node);
            default:
              return ts3.visitEachChild(node, visitor, context);
          }
        }
        function visitBinaryExpression(node) {
          switch (node.operatorToken.kind) {
            case 66:
              return visitExponentiationAssignmentExpression(node);
            case 42:
              return visitExponentiationExpression(node);
            default:
              return ts3.visitEachChild(node, visitor, context);
          }
        }
        function visitExponentiationAssignmentExpression(node) {
          var target;
          var value;
          var left = ts3.visitNode(node.left, visitor, ts3.isExpression);
          var right = ts3.visitNode(node.right, visitor, ts3.isExpression);
          if (ts3.isElementAccessExpression(left)) {
            var expressionTemp = factory.createTempVariable(hoistVariableDeclaration);
            var argumentExpressionTemp = factory.createTempVariable(hoistVariableDeclaration);
            target = ts3.setTextRange(factory.createElementAccessExpression(ts3.setTextRange(factory.createAssignment(expressionTemp, left.expression), left.expression), ts3.setTextRange(factory.createAssignment(argumentExpressionTemp, left.argumentExpression), left.argumentExpression)), left);
            value = ts3.setTextRange(factory.createElementAccessExpression(expressionTemp, argumentExpressionTemp), left);
          } else if (ts3.isPropertyAccessExpression(left)) {
            var expressionTemp = factory.createTempVariable(hoistVariableDeclaration);
            target = ts3.setTextRange(factory.createPropertyAccessExpression(ts3.setTextRange(factory.createAssignment(expressionTemp, left.expression), left.expression), left.name), left);
            value = ts3.setTextRange(factory.createPropertyAccessExpression(expressionTemp, left.name), left);
          } else {
            target = left;
            value = left;
          }
          return ts3.setTextRange(factory.createAssignment(target, ts3.setTextRange(factory.createGlobalMethodCall("Math", "pow", [value, right]), node)), node);
        }
        function visitExponentiationExpression(node) {
          var left = ts3.visitNode(node.left, visitor, ts3.isExpression);
          var right = ts3.visitNode(node.right, visitor, ts3.isExpression);
          return ts3.setTextRange(factory.createGlobalMethodCall("Math", "pow", [left, right]), node);
        }
      }
      ts3.transformES2016 = transformES2016;
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var ES2015SubstitutionFlags;
      (function(ES2015SubstitutionFlags2) {
        ES2015SubstitutionFlags2[ES2015SubstitutionFlags2["CapturedThis"] = 1] = "CapturedThis";
        ES2015SubstitutionFlags2[ES2015SubstitutionFlags2["BlockScopedBindings"] = 2] = "BlockScopedBindings";
      })(ES2015SubstitutionFlags || (ES2015SubstitutionFlags = {}));
      var LoopOutParameterFlags;
      (function(LoopOutParameterFlags2) {
        LoopOutParameterFlags2[LoopOutParameterFlags2["Body"] = 1] = "Body";
        LoopOutParameterFlags2[LoopOutParameterFlags2["Initializer"] = 2] = "Initializer";
      })(LoopOutParameterFlags || (LoopOutParameterFlags = {}));
      var CopyDirection;
      (function(CopyDirection2) {
        CopyDirection2[CopyDirection2["ToOriginal"] = 0] = "ToOriginal";
        CopyDirection2[CopyDirection2["ToOutParameter"] = 1] = "ToOutParameter";
      })(CopyDirection || (CopyDirection = {}));
      var Jump;
      (function(Jump2) {
        Jump2[Jump2["Break"] = 2] = "Break";
        Jump2[Jump2["Continue"] = 4] = "Continue";
        Jump2[Jump2["Return"] = 8] = "Return";
      })(Jump || (Jump = {}));
      var HierarchyFacts;
      (function(HierarchyFacts2) {
        HierarchyFacts2[HierarchyFacts2["None"] = 0] = "None";
        HierarchyFacts2[HierarchyFacts2["Function"] = 1] = "Function";
        HierarchyFacts2[HierarchyFacts2["ArrowFunction"] = 2] = "ArrowFunction";
        HierarchyFacts2[HierarchyFacts2["AsyncFunctionBody"] = 4] = "AsyncFunctionBody";
        HierarchyFacts2[HierarchyFacts2["NonStaticClassElement"] = 8] = "NonStaticClassElement";
        HierarchyFacts2[HierarchyFacts2["CapturesThis"] = 16] = "CapturesThis";
        HierarchyFacts2[HierarchyFacts2["ExportedVariableStatement"] = 32] = "ExportedVariableStatement";
        HierarchyFacts2[HierarchyFacts2["TopLevel"] = 64] = "TopLevel";
        HierarchyFacts2[HierarchyFacts2["Block"] = 128] = "Block";
        HierarchyFacts2[HierarchyFacts2["IterationStatement"] = 256] = "IterationStatement";
        HierarchyFacts2[HierarchyFacts2["IterationStatementBlock"] = 512] = "IterationStatementBlock";
        HierarchyFacts2[HierarchyFacts2["IterationContainer"] = 1024] = "IterationContainer";
        HierarchyFacts2[HierarchyFacts2["ForStatement"] = 2048] = "ForStatement";
        HierarchyFacts2[HierarchyFacts2["ForInOrForOfStatement"] = 4096] = "ForInOrForOfStatement";
        HierarchyFacts2[HierarchyFacts2["ConstructorWithCapturedSuper"] = 8192] = "ConstructorWithCapturedSuper";
        HierarchyFacts2[HierarchyFacts2["AncestorFactsMask"] = 16383] = "AncestorFactsMask";
        HierarchyFacts2[HierarchyFacts2["BlockScopeIncludes"] = 0] = "BlockScopeIncludes";
        HierarchyFacts2[HierarchyFacts2["BlockScopeExcludes"] = 7104] = "BlockScopeExcludes";
        HierarchyFacts2[HierarchyFacts2["SourceFileIncludes"] = 64] = "SourceFileIncludes";
        HierarchyFacts2[HierarchyFacts2["SourceFileExcludes"] = 8064] = "SourceFileExcludes";
        HierarchyFacts2[HierarchyFacts2["FunctionIncludes"] = 65] = "FunctionIncludes";
        HierarchyFacts2[HierarchyFacts2["FunctionExcludes"] = 16286] = "FunctionExcludes";
        HierarchyFacts2[HierarchyFacts2["AsyncFunctionBodyIncludes"] = 69] = "AsyncFunctionBodyIncludes";
        HierarchyFacts2[HierarchyFacts2["AsyncFunctionBodyExcludes"] = 16278] = "AsyncFunctionBodyExcludes";
        HierarchyFacts2[HierarchyFacts2["ArrowFunctionIncludes"] = 66] = "ArrowFunctionIncludes";
        HierarchyFacts2[HierarchyFacts2["ArrowFunctionExcludes"] = 15232] = "ArrowFunctionExcludes";
        HierarchyFacts2[HierarchyFacts2["ConstructorIncludes"] = 73] = "ConstructorIncludes";
        HierarchyFacts2[HierarchyFacts2["ConstructorExcludes"] = 16278] = "ConstructorExcludes";
        HierarchyFacts2[HierarchyFacts2["DoOrWhileStatementIncludes"] = 1280] = "DoOrWhileStatementIncludes";
        HierarchyFacts2[HierarchyFacts2["DoOrWhileStatementExcludes"] = 0] = "DoOrWhileStatementExcludes";
        HierarchyFacts2[HierarchyFacts2["ForStatementIncludes"] = 3328] = "ForStatementIncludes";
        HierarchyFacts2[HierarchyFacts2["ForStatementExcludes"] = 5056] = "ForStatementExcludes";
        HierarchyFacts2[HierarchyFacts2["ForInOrForOfStatementIncludes"] = 5376] = "ForInOrForOfStatementIncludes";
        HierarchyFacts2[HierarchyFacts2["ForInOrForOfStatementExcludes"] = 3008] = "ForInOrForOfStatementExcludes";
        HierarchyFacts2[HierarchyFacts2["BlockIncludes"] = 128] = "BlockIncludes";
        HierarchyFacts2[HierarchyFacts2["BlockExcludes"] = 6976] = "BlockExcludes";
        HierarchyFacts2[HierarchyFacts2["IterationStatementBlockIncludes"] = 512] = "IterationStatementBlockIncludes";
        HierarchyFacts2[HierarchyFacts2["IterationStatementBlockExcludes"] = 7104] = "IterationStatementBlockExcludes";
        HierarchyFacts2[HierarchyFacts2["NewTarget"] = 16384] = "NewTarget";
        HierarchyFacts2[HierarchyFacts2["CapturedLexicalThis"] = 32768] = "CapturedLexicalThis";
        HierarchyFacts2[HierarchyFacts2["SubtreeFactsMask"] = -16384] = "SubtreeFactsMask";
        HierarchyFacts2[HierarchyFacts2["ArrowFunctionSubtreeExcludes"] = 0] = "ArrowFunctionSubtreeExcludes";
        HierarchyFacts2[HierarchyFacts2["FunctionSubtreeExcludes"] = 49152] = "FunctionSubtreeExcludes";
      })(HierarchyFacts || (HierarchyFacts = {}));
      function transformES2015(context) {
        var factory = context.factory, emitHelpers = context.getEmitHelperFactory, startLexicalEnvironment = context.startLexicalEnvironment, resumeLexicalEnvironment = context.resumeLexicalEnvironment, endLexicalEnvironment = context.endLexicalEnvironment, hoistVariableDeclaration = context.hoistVariableDeclaration;
        var compilerOptions = context.getCompilerOptions();
        var resolver = context.getEmitResolver();
        var previousOnSubstituteNode = context.onSubstituteNode;
        var previousOnEmitNode = context.onEmitNode;
        context.onEmitNode = onEmitNode;
        context.onSubstituteNode = onSubstituteNode;
        var currentSourceFile;
        var currentText;
        var hierarchyFacts;
        var taggedTemplateStringDeclarations;
        function recordTaggedTemplateString(temp) {
          taggedTemplateStringDeclarations = ts3.append(taggedTemplateStringDeclarations, factory.createVariableDeclaration(temp));
        }
        var convertedLoopState;
        var enabledSubstitutions;
        return ts3.chainBundle(context, transformSourceFile);
        function transformSourceFile(node) {
          if (node.isDeclarationFile) {
            return node;
          }
          currentSourceFile = node;
          currentText = node.text;
          var visited = visitSourceFile(node);
          ts3.addEmitHelpers(visited, context.readEmitHelpers());
          currentSourceFile = void 0;
          currentText = void 0;
          taggedTemplateStringDeclarations = void 0;
          hierarchyFacts = 0;
          return visited;
        }
        function enterSubtree(excludeFacts, includeFacts) {
          var ancestorFacts = hierarchyFacts;
          hierarchyFacts = (hierarchyFacts & ~excludeFacts | includeFacts) & 16383;
          return ancestorFacts;
        }
        function exitSubtree(ancestorFacts, excludeFacts, includeFacts) {
          hierarchyFacts = (hierarchyFacts & ~excludeFacts | includeFacts) & -16384 | ancestorFacts;
        }
        function isReturnVoidStatementInConstructorWithCapturedSuper(node) {
          return (hierarchyFacts & 8192) !== 0 && node.kind === 243 && !node.expression;
        }
        function isOrMayContainReturnCompletion(node) {
          return node.transformFlags & 2097152 && (ts3.isReturnStatement(node) || ts3.isIfStatement(node) || ts3.isWithStatement(node) || ts3.isSwitchStatement(node) || ts3.isCaseBlock(node) || ts3.isCaseClause(node) || ts3.isDefaultClause(node) || ts3.isTryStatement(node) || ts3.isCatchClause(node) || ts3.isLabeledStatement(node) || ts3.isIterationStatement(node, false) || ts3.isBlock(node));
        }
        function shouldVisitNode(node) {
          return (node.transformFlags & 512) !== 0 || convertedLoopState !== void 0 || hierarchyFacts & 8192 && isOrMayContainReturnCompletion(node) || ts3.isIterationStatement(node, false) && shouldConvertIterationStatement(node) || (ts3.getEmitFlags(node) & 33554432) !== 0;
        }
        function visitor(node) {
          return shouldVisitNode(node) ? visitorWorker(node, false) : node;
        }
        function visitorWithUnusedExpressionResult(node) {
          return shouldVisitNode(node) ? visitorWorker(node, true) : node;
        }
        function callExpressionVisitor(node) {
          if (node.kind === 105) {
            return visitSuperKeyword(true);
          }
          return visitor(node);
        }
        function visitorWorker(node, expressionResultIsUnused) {
          switch (node.kind) {
            case 123:
              return void 0;
            case 253:
              return visitClassDeclaration(node);
            case 222:
              return visitClassExpression(node);
            case 161:
              return visitParameter(node);
            case 252:
              return visitFunctionDeclaration(node);
            case 210:
              return visitArrowFunction(node);
            case 209:
              return visitFunctionExpression(node);
            case 250:
              return visitVariableDeclaration(node);
            case 78:
              return visitIdentifier(node);
            case 251:
              return visitVariableDeclarationList(node);
            case 245:
              return visitSwitchStatement(node);
            case 259:
              return visitCaseBlock(node);
            case 231:
              return visitBlock(node, false);
            case 242:
            case 241:
              return visitBreakOrContinueStatement(node);
            case 246:
              return visitLabeledStatement(node);
            case 236:
            case 237:
              return visitDoOrWhileStatement(node, void 0);
            case 238:
              return visitForStatement(node, void 0);
            case 239:
              return visitForInStatement(node, void 0);
            case 240:
              return visitForOfStatement(node, void 0);
            case 234:
              return visitExpressionStatement(node);
            case 201:
              return visitObjectLiteralExpression(node);
            case 288:
              return visitCatchClause(node);
            case 290:
              return visitShorthandPropertyAssignment(node);
            case 159:
              return visitComputedPropertyName(node);
            case 200:
              return visitArrayLiteralExpression(node);
            case 204:
              return visitCallExpression(node);
            case 205:
              return visitNewExpression(node);
            case 208:
              return visitParenthesizedExpression(node, expressionResultIsUnused);
            case 217:
              return visitBinaryExpression(node, expressionResultIsUnused);
            case 341:
              return visitCommaListExpression(node, expressionResultIsUnused);
            case 14:
            case 15:
            case 16:
            case 17:
              return visitTemplateLiteral(node);
            case 10:
              return visitStringLiteral(node);
            case 8:
              return visitNumericLiteral(node);
            case 206:
              return visitTaggedTemplateExpression(node);
            case 219:
              return visitTemplateExpression(node);
            case 220:
              return visitYieldExpression(node);
            case 221:
              return visitSpreadElement(node);
            case 105:
              return visitSuperKeyword(false);
            case 107:
              return visitThisKeyword(node);
            case 227:
              return visitMetaProperty(node);
            case 166:
              return visitMethodDeclaration(node);
            case 168:
            case 169:
              return visitAccessorDeclaration(node);
            case 233:
              return visitVariableStatement(node);
            case 243:
              return visitReturnStatement(node);
            case 213:
              return visitVoidExpression(node);
            default:
              return ts3.visitEachChild(node, visitor, context);
          }
        }
        function visitSourceFile(node) {
          var ancestorFacts = enterSubtree(8064, 64);
          var prologue = [];
          var statements = [];
          startLexicalEnvironment();
          var statementOffset = factory.copyPrologue(node.statements, prologue, false, visitor);
          ts3.addRange(statements, ts3.visitNodes(node.statements, visitor, ts3.isStatement, statementOffset));
          if (taggedTemplateStringDeclarations) {
            statements.push(factory.createVariableStatement(void 0, factory.createVariableDeclarationList(taggedTemplateStringDeclarations)));
          }
          factory.mergeLexicalEnvironment(prologue, endLexicalEnvironment());
          insertCaptureThisForNodeIfNeeded(prologue, node);
          exitSubtree(ancestorFacts, 0, 0);
          return factory.updateSourceFile(node, ts3.setTextRange(factory.createNodeArray(ts3.concatenate(prologue, statements)), node.statements));
        }
        function visitSwitchStatement(node) {
          if (convertedLoopState !== void 0) {
            var savedAllowedNonLabeledJumps = convertedLoopState.allowedNonLabeledJumps;
            convertedLoopState.allowedNonLabeledJumps |= 2;
            var result2 = ts3.visitEachChild(node, visitor, context);
            convertedLoopState.allowedNonLabeledJumps = savedAllowedNonLabeledJumps;
            return result2;
          }
          return ts3.visitEachChild(node, visitor, context);
        }
        function visitCaseBlock(node) {
          var ancestorFacts = enterSubtree(7104, 0);
          var updated = ts3.visitEachChild(node, visitor, context);
          exitSubtree(ancestorFacts, 0, 0);
          return updated;
        }
        function returnCapturedThis(node) {
          return ts3.setOriginalNode(factory.createReturnStatement(factory.createUniqueName("_this", 16 | 32)), node);
        }
        function visitReturnStatement(node) {
          if (convertedLoopState) {
            convertedLoopState.nonLocalJumps |= 8;
            if (isReturnVoidStatementInConstructorWithCapturedSuper(node)) {
              node = returnCapturedThis(node);
            }
            return factory.createReturnStatement(factory.createObjectLiteralExpression([
              factory.createPropertyAssignment(factory.createIdentifier("value"), node.expression ? ts3.visitNode(node.expression, visitor, ts3.isExpression) : factory.createVoidZero())
            ]));
          } else if (isReturnVoidStatementInConstructorWithCapturedSuper(node)) {
            return returnCapturedThis(node);
          }
          return ts3.visitEachChild(node, visitor, context);
        }
        function visitThisKeyword(node) {
          if (hierarchyFacts & 2) {
            hierarchyFacts |= 32768;
          }
          if (convertedLoopState) {
            if (hierarchyFacts & 2) {
              convertedLoopState.containsLexicalThis = true;
              return node;
            }
            return convertedLoopState.thisName || (convertedLoopState.thisName = factory.createUniqueName("this"));
          }
          return node;
        }
        function visitVoidExpression(node) {
          return ts3.visitEachChild(node, visitorWithUnusedExpressionResult, context);
        }
        function visitIdentifier(node) {
          if (!convertedLoopState) {
            return node;
          }
          if (resolver.isArgumentsLocalBinding(node)) {
            return convertedLoopState.argumentsName || (convertedLoopState.argumentsName = factory.createUniqueName("arguments"));
          }
          return node;
        }
        function visitBreakOrContinueStatement(node) {
          if (convertedLoopState) {
            var jump = node.kind === 242 ? 2 : 4;
            var canUseBreakOrContinue = node.label && convertedLoopState.labels && convertedLoopState.labels.get(ts3.idText(node.label)) || !node.label && convertedLoopState.allowedNonLabeledJumps & jump;
            if (!canUseBreakOrContinue) {
              var labelMarker = void 0;
              var label = node.label;
              if (!label) {
                if (node.kind === 242) {
                  convertedLoopState.nonLocalJumps |= 2;
                  labelMarker = "break";
                } else {
                  convertedLoopState.nonLocalJumps |= 4;
                  labelMarker = "continue";
                }
              } else {
                if (node.kind === 242) {
                  labelMarker = "break-" + label.escapedText;
                  setLabeledJump(convertedLoopState, true, ts3.idText(label), labelMarker);
                } else {
                  labelMarker = "continue-" + label.escapedText;
                  setLabeledJump(convertedLoopState, false, ts3.idText(label), labelMarker);
                }
              }
              var returnExpression = factory.createStringLiteral(labelMarker);
              if (convertedLoopState.loopOutParameters.length) {
                var outParams = convertedLoopState.loopOutParameters;
                var expr = void 0;
                for (var i3 = 0; i3 < outParams.length; i3++) {
                  var copyExpr = copyOutParameter(outParams[i3], 1);
                  if (i3 === 0) {
                    expr = copyExpr;
                  } else {
                    expr = factory.createBinaryExpression(expr, 27, copyExpr);
                  }
                }
                returnExpression = factory.createBinaryExpression(expr, 27, returnExpression);
              }
              return factory.createReturnStatement(returnExpression);
            }
          }
          return ts3.visitEachChild(node, visitor, context);
        }
        function visitClassDeclaration(node) {
          var variable = factory.createVariableDeclaration(factory.getLocalName(node, true), void 0, void 0, transformClassLikeDeclarationToExpression(node));
          ts3.setOriginalNode(variable, node);
          var statements = [];
          var statement = factory.createVariableStatement(void 0, factory.createVariableDeclarationList([variable]));
          ts3.setOriginalNode(statement, node);
          ts3.setTextRange(statement, node);
          ts3.startOnNewLine(statement);
          statements.push(statement);
          if (ts3.hasSyntacticModifier(node, 1)) {
            var exportStatement = ts3.hasSyntacticModifier(node, 512) ? factory.createExportDefault(factory.getLocalName(node)) : factory.createExternalModuleExport(factory.getLocalName(node));
            ts3.setOriginalNode(exportStatement, statement);
            statements.push(exportStatement);
          }
          var emitFlags = ts3.getEmitFlags(node);
          if ((emitFlags & 4194304) === 0) {
            statements.push(factory.createEndOfDeclarationMarker(node));
            ts3.setEmitFlags(statement, emitFlags | 4194304);
          }
          return ts3.singleOrMany(statements);
        }
        function visitClassExpression(node) {
          return transformClassLikeDeclarationToExpression(node);
        }
        function transformClassLikeDeclarationToExpression(node) {
          if (node.name) {
            enableSubstitutionsForBlockScopedBindings();
          }
          var extendsClauseElement = ts3.getClassExtendsHeritageElement(node);
          var classFunction = factory.createFunctionExpression(void 0, void 0, void 0, void 0, extendsClauseElement ? [factory.createParameterDeclaration(void 0, void 0, void 0, factory.createUniqueName("_super", 16 | 32))] : [], void 0, transformClassBody(node, extendsClauseElement));
          ts3.setEmitFlags(classFunction, ts3.getEmitFlags(node) & 65536 | 524288);
          var inner = factory.createPartiallyEmittedExpression(classFunction);
          ts3.setTextRangeEnd(inner, node.end);
          ts3.setEmitFlags(inner, 1536);
          var outer = factory.createPartiallyEmittedExpression(inner);
          ts3.setTextRangeEnd(outer, ts3.skipTrivia(currentText, node.pos));
          ts3.setEmitFlags(outer, 1536);
          var result2 = factory.createParenthesizedExpression(factory.createCallExpression(outer, void 0, extendsClauseElement ? [ts3.visitNode(extendsClauseElement.expression, visitor, ts3.isExpression)] : []));
          ts3.addSyntheticLeadingComment(result2, 3, "* @class ");
          return result2;
        }
        function transformClassBody(node, extendsClauseElement) {
          var statements = [];
          var name = factory.getInternalName(node);
          var constructorLikeName = ts3.isIdentifierANonContextualKeyword(name) ? factory.getGeneratedNameForNode(name) : name;
          startLexicalEnvironment();
          addExtendsHelperIfNeeded(statements, node, extendsClauseElement);
          addConstructor(statements, node, constructorLikeName, extendsClauseElement);
          addClassMembers(statements, node);
          var closingBraceLocation = ts3.createTokenRange(ts3.skipTrivia(currentText, node.members.end), 19);
          var outer = factory.createPartiallyEmittedExpression(constructorLikeName);
          ts3.setTextRangeEnd(outer, closingBraceLocation.end);
          ts3.setEmitFlags(outer, 1536);
          var statement = factory.createReturnStatement(outer);
          ts3.setTextRangePos(statement, closingBraceLocation.pos);
          ts3.setEmitFlags(statement, 1536 | 384);
          statements.push(statement);
          ts3.insertStatementsAfterStandardPrologue(statements, endLexicalEnvironment());
          var block = factory.createBlock(ts3.setTextRange(factory.createNodeArray(statements), node.members), true);
          ts3.setEmitFlags(block, 1536);
          return block;
        }
        function addExtendsHelperIfNeeded(statements, node, extendsClauseElement) {
          if (extendsClauseElement) {
            statements.push(ts3.setTextRange(factory.createExpressionStatement(emitHelpers().createExtendsHelper(factory.getInternalName(node))), extendsClauseElement));
          }
        }
        function addConstructor(statements, node, name, extendsClauseElement) {
          var savedConvertedLoopState = convertedLoopState;
          convertedLoopState = void 0;
          var ancestorFacts = enterSubtree(16278, 73);
          var constructor = ts3.getFirstConstructorWithBody(node);
          var hasSynthesizedSuper = hasSynthesizedDefaultSuperCall(constructor, extendsClauseElement !== void 0);
          var constructorFunction = factory.createFunctionDeclaration(void 0, void 0, void 0, name, void 0, transformConstructorParameters(constructor, hasSynthesizedSuper), void 0, transformConstructorBody(constructor, node, extendsClauseElement, hasSynthesizedSuper));
          ts3.setTextRange(constructorFunction, constructor || node);
          if (extendsClauseElement) {
            ts3.setEmitFlags(constructorFunction, 8);
          }
          statements.push(constructorFunction);
          exitSubtree(ancestorFacts, 49152, 0);
          convertedLoopState = savedConvertedLoopState;
        }
        function transformConstructorParameters(constructor, hasSynthesizedSuper) {
          return ts3.visitParameterList(constructor && !hasSynthesizedSuper ? constructor.parameters : void 0, visitor, context) || [];
        }
        function createDefaultConstructorBody(node, isDerivedClass) {
          var statements = [];
          resumeLexicalEnvironment();
          factory.mergeLexicalEnvironment(statements, endLexicalEnvironment());
          if (isDerivedClass) {
            statements.push(factory.createReturnStatement(createDefaultSuperCallOrThis()));
          }
          var statementsArray = factory.createNodeArray(statements);
          ts3.setTextRange(statementsArray, node.members);
          var block = factory.createBlock(statementsArray, true);
          ts3.setTextRange(block, node);
          ts3.setEmitFlags(block, 1536);
          return block;
        }
        function transformConstructorBody(constructor, node, extendsClauseElement, hasSynthesizedSuper) {
          var isDerivedClass = !!extendsClauseElement && ts3.skipOuterExpressions(extendsClauseElement.expression).kind !== 103;
          if (!constructor)
            return createDefaultConstructorBody(node, isDerivedClass);
          var prologue = [];
          var statements = [];
          resumeLexicalEnvironment();
          var statementOffset = 0;
          if (!hasSynthesizedSuper)
            statementOffset = factory.copyStandardPrologue(constructor.body.statements, prologue, false);
          addDefaultValueAssignmentsIfNeeded(statements, constructor);
          addRestParameterIfNeeded(statements, constructor, hasSynthesizedSuper);
          if (!hasSynthesizedSuper)
            statementOffset = factory.copyCustomPrologue(constructor.body.statements, statements, statementOffset, visitor);
          var superCallExpression;
          if (hasSynthesizedSuper) {
            superCallExpression = createDefaultSuperCallOrThis();
          } else if (isDerivedClass && statementOffset < constructor.body.statements.length) {
            var firstStatement = constructor.body.statements[statementOffset];
            if (ts3.isExpressionStatement(firstStatement) && ts3.isSuperCall(firstStatement.expression)) {
              superCallExpression = visitImmediateSuperCallInBody(firstStatement.expression);
            }
          }
          if (superCallExpression) {
            hierarchyFacts |= 8192;
            statementOffset++;
          }
          ts3.addRange(statements, ts3.visitNodes(constructor.body.statements, visitor, ts3.isStatement, statementOffset));
          factory.mergeLexicalEnvironment(prologue, endLexicalEnvironment());
          insertCaptureNewTargetIfNeeded(prologue, constructor, false);
          if (isDerivedClass) {
            if (superCallExpression && statementOffset === constructor.body.statements.length && !(constructor.body.transformFlags & 8192)) {
              var superCall = ts3.cast(ts3.cast(superCallExpression, ts3.isBinaryExpression).left, ts3.isCallExpression);
              var returnStatement = factory.createReturnStatement(superCallExpression);
              ts3.setCommentRange(returnStatement, ts3.getCommentRange(superCall));
              ts3.setEmitFlags(superCall, 1536);
              statements.push(returnStatement);
            } else {
              insertCaptureThisForNode(statements, constructor, superCallExpression || createActualThis());
              if (!isSufficientlyCoveredByReturnStatements(constructor.body)) {
                statements.push(factory.createReturnStatement(factory.createUniqueName("_this", 16 | 32)));
              }
            }
          } else {
            insertCaptureThisForNodeIfNeeded(prologue, constructor);
          }
          var block = factory.createBlock(ts3.setTextRange(factory.createNodeArray(ts3.concatenate(prologue, statements)), constructor.body.statements), true);
          ts3.setTextRange(block, constructor.body);
          return block;
        }
        function isSufficientlyCoveredByReturnStatements(statement) {
          if (statement.kind === 243) {
            return true;
          } else if (statement.kind === 235) {
            var ifStatement = statement;
            if (ifStatement.elseStatement) {
              return isSufficientlyCoveredByReturnStatements(ifStatement.thenStatement) && isSufficientlyCoveredByReturnStatements(ifStatement.elseStatement);
            }
          } else if (statement.kind === 231) {
            var lastStatement = ts3.lastOrUndefined(statement.statements);
            if (lastStatement && isSufficientlyCoveredByReturnStatements(lastStatement)) {
              return true;
            }
          }
          return false;
        }
        function createActualThis() {
          return ts3.setEmitFlags(factory.createThis(), 4);
        }
        function createDefaultSuperCallOrThis() {
          return factory.createLogicalOr(factory.createLogicalAnd(factory.createStrictInequality(factory.createUniqueName("_super", 16 | 32), factory.createNull()), factory.createFunctionApplyCall(factory.createUniqueName("_super", 16 | 32), createActualThis(), factory.createIdentifier("arguments"))), createActualThis());
        }
        function visitParameter(node) {
          if (node.dotDotDotToken) {
            return void 0;
          } else if (ts3.isBindingPattern(node.name)) {
            return ts3.setOriginalNode(ts3.setTextRange(factory.createParameterDeclaration(void 0, void 0, void 0, factory.getGeneratedNameForNode(node), void 0, void 0, void 0), node), node);
          } else if (node.initializer) {
            return ts3.setOriginalNode(ts3.setTextRange(factory.createParameterDeclaration(void 0, void 0, void 0, node.name, void 0, void 0, void 0), node), node);
          } else {
            return node;
          }
        }
        function hasDefaultValueOrBindingPattern(node) {
          return node.initializer !== void 0 || ts3.isBindingPattern(node.name);
        }
        function addDefaultValueAssignmentsIfNeeded(statements, node) {
          if (!ts3.some(node.parameters, hasDefaultValueOrBindingPattern)) {
            return false;
          }
          var added = false;
          for (var _i = 0, _a2 = node.parameters; _i < _a2.length; _i++) {
            var parameter = _a2[_i];
            var name = parameter.name, initializer = parameter.initializer, dotDotDotToken = parameter.dotDotDotToken;
            if (dotDotDotToken) {
              continue;
            }
            if (ts3.isBindingPattern(name)) {
              added = insertDefaultValueAssignmentForBindingPattern(statements, parameter, name, initializer) || added;
            } else if (initializer) {
              insertDefaultValueAssignmentForInitializer(statements, parameter, name, initializer);
              added = true;
            }
          }
          return added;
        }
        function insertDefaultValueAssignmentForBindingPattern(statements, parameter, name, initializer) {
          if (name.elements.length > 0) {
            ts3.insertStatementAfterCustomPrologue(statements, ts3.setEmitFlags(factory.createVariableStatement(void 0, factory.createVariableDeclarationList(ts3.flattenDestructuringBinding(parameter, visitor, context, 0, factory.getGeneratedNameForNode(parameter)))), 1048576));
            return true;
          } else if (initializer) {
            ts3.insertStatementAfterCustomPrologue(statements, ts3.setEmitFlags(factory.createExpressionStatement(factory.createAssignment(factory.getGeneratedNameForNode(parameter), ts3.visitNode(initializer, visitor, ts3.isExpression))), 1048576));
            return true;
          }
          return false;
        }
        function insertDefaultValueAssignmentForInitializer(statements, parameter, name, initializer) {
          initializer = ts3.visitNode(initializer, visitor, ts3.isExpression);
          var statement = factory.createIfStatement(factory.createTypeCheck(factory.cloneNode(name), "undefined"), ts3.setEmitFlags(ts3.setTextRange(factory.createBlock([
            factory.createExpressionStatement(ts3.setEmitFlags(ts3.setTextRange(factory.createAssignment(ts3.setEmitFlags(ts3.setParent(ts3.setTextRange(factory.cloneNode(name), name), name.parent), 48), ts3.setEmitFlags(initializer, 48 | ts3.getEmitFlags(initializer) | 1536)), parameter), 1536))
          ]), parameter), 1 | 32 | 384 | 1536));
          ts3.startOnNewLine(statement);
          ts3.setTextRange(statement, parameter);
          ts3.setEmitFlags(statement, 384 | 32 | 1048576 | 1536);
          ts3.insertStatementAfterCustomPrologue(statements, statement);
        }
        function shouldAddRestParameter(node, inConstructorWithSynthesizedSuper) {
          return !!(node && node.dotDotDotToken && !inConstructorWithSynthesizedSuper);
        }
        function addRestParameterIfNeeded(statements, node, inConstructorWithSynthesizedSuper) {
          var prologueStatements = [];
          var parameter = ts3.lastOrUndefined(node.parameters);
          if (!shouldAddRestParameter(parameter, inConstructorWithSynthesizedSuper)) {
            return false;
          }
          var declarationName = parameter.name.kind === 78 ? ts3.setParent(ts3.setTextRange(factory.cloneNode(parameter.name), parameter.name), parameter.name.parent) : factory.createTempVariable(void 0);
          ts3.setEmitFlags(declarationName, 48);
          var expressionName = parameter.name.kind === 78 ? factory.cloneNode(parameter.name) : declarationName;
          var restIndex = node.parameters.length - 1;
          var temp = factory.createLoopVariable();
          prologueStatements.push(ts3.setEmitFlags(ts3.setTextRange(factory.createVariableStatement(void 0, factory.createVariableDeclarationList([
            factory.createVariableDeclaration(declarationName, void 0, void 0, factory.createArrayLiteralExpression([]))
          ])), parameter), 1048576));
          var forStatement = factory.createForStatement(ts3.setTextRange(factory.createVariableDeclarationList([
            factory.createVariableDeclaration(temp, void 0, void 0, factory.createNumericLiteral(restIndex))
          ]), parameter), ts3.setTextRange(factory.createLessThan(temp, factory.createPropertyAccessExpression(factory.createIdentifier("arguments"), "length")), parameter), ts3.setTextRange(factory.createPostfixIncrement(temp), parameter), factory.createBlock([
            ts3.startOnNewLine(ts3.setTextRange(factory.createExpressionStatement(factory.createAssignment(factory.createElementAccessExpression(expressionName, restIndex === 0 ? temp : factory.createSubtract(temp, factory.createNumericLiteral(restIndex))), factory.createElementAccessExpression(factory.createIdentifier("arguments"), temp))), parameter))
          ]));
          ts3.setEmitFlags(forStatement, 1048576);
          ts3.startOnNewLine(forStatement);
          prologueStatements.push(forStatement);
          if (parameter.name.kind !== 78) {
            prologueStatements.push(ts3.setEmitFlags(ts3.setTextRange(factory.createVariableStatement(void 0, factory.createVariableDeclarationList(ts3.flattenDestructuringBinding(parameter, visitor, context, 0, expressionName))), parameter), 1048576));
          }
          ts3.insertStatementsAfterCustomPrologue(statements, prologueStatements);
          return true;
        }
        function insertCaptureThisForNodeIfNeeded(statements, node) {
          if (hierarchyFacts & 32768 && node.kind !== 210) {
            insertCaptureThisForNode(statements, node, factory.createThis());
            return true;
          }
          return false;
        }
        function insertCaptureThisForNode(statements, node, initializer) {
          enableSubstitutionsForCapturedThis();
          var captureThisStatement = factory.createVariableStatement(void 0, factory.createVariableDeclarationList([
            factory.createVariableDeclaration(factory.createUniqueName("_this", 16 | 32), void 0, void 0, initializer)
          ]));
          ts3.setEmitFlags(captureThisStatement, 1536 | 1048576);
          ts3.setSourceMapRange(captureThisStatement, node);
          ts3.insertStatementAfterCustomPrologue(statements, captureThisStatement);
        }
        function insertCaptureNewTargetIfNeeded(statements, node, copyOnWrite) {
          if (hierarchyFacts & 16384) {
            var newTarget = void 0;
            switch (node.kind) {
              case 210:
                return statements;
              case 166:
              case 168:
              case 169:
                newTarget = factory.createVoidZero();
                break;
              case 167:
                newTarget = factory.createPropertyAccessExpression(ts3.setEmitFlags(factory.createThis(), 4), "constructor");
                break;
              case 252:
              case 209:
                newTarget = factory.createConditionalExpression(factory.createLogicalAnd(ts3.setEmitFlags(factory.createThis(), 4), factory.createBinaryExpression(ts3.setEmitFlags(factory.createThis(), 4), 101, factory.getLocalName(node))), void 0, factory.createPropertyAccessExpression(ts3.setEmitFlags(factory.createThis(), 4), "constructor"), void 0, factory.createVoidZero());
                break;
              default:
                return ts3.Debug.failBadSyntaxKind(node);
            }
            var captureNewTargetStatement = factory.createVariableStatement(void 0, factory.createVariableDeclarationList([
              factory.createVariableDeclaration(factory.createUniqueName("_newTarget", 16 | 32), void 0, void 0, newTarget)
            ]));
            ts3.setEmitFlags(captureNewTargetStatement, 1536 | 1048576);
            if (copyOnWrite) {
              statements = statements.slice();
            }
            ts3.insertStatementAfterCustomPrologue(statements, captureNewTargetStatement);
          }
          return statements;
        }
        function addClassMembers(statements, node) {
          for (var _i = 0, _a2 = node.members; _i < _a2.length; _i++) {
            var member = _a2[_i];
            switch (member.kind) {
              case 230:
                statements.push(transformSemicolonClassElementToStatement(member));
                break;
              case 166:
                statements.push(transformClassMethodDeclarationToStatement(getClassMemberPrefix(node, member), member, node));
                break;
              case 168:
              case 169:
                var accessors = ts3.getAllAccessorDeclarations(node.members, member);
                if (member === accessors.firstAccessor) {
                  statements.push(transformAccessorsToStatement(getClassMemberPrefix(node, member), accessors, node));
                }
                break;
              case 167:
                break;
              default:
                ts3.Debug.failBadSyntaxKind(member, currentSourceFile && currentSourceFile.fileName);
                break;
            }
          }
        }
        function transformSemicolonClassElementToStatement(member) {
          return ts3.setTextRange(factory.createEmptyStatement(), member);
        }
        function transformClassMethodDeclarationToStatement(receiver, member, container) {
          var commentRange = ts3.getCommentRange(member);
          var sourceMapRange = ts3.getSourceMapRange(member);
          var memberFunction = transformFunctionLikeToExpression(member, member, void 0, container);
          var propertyName = ts3.visitNode(member.name, visitor, ts3.isPropertyName);
          var e2;
          if (!ts3.isPrivateIdentifier(propertyName) && ts3.getUseDefineForClassFields(context.getCompilerOptions())) {
            var name = ts3.isComputedPropertyName(propertyName) ? propertyName.expression : ts3.isIdentifier(propertyName) ? factory.createStringLiteral(ts3.unescapeLeadingUnderscores(propertyName.escapedText)) : propertyName;
            e2 = factory.createObjectDefinePropertyCall(receiver, name, factory.createPropertyDescriptor({ value: memberFunction, enumerable: false, writable: true, configurable: true }));
          } else {
            var memberName = ts3.createMemberAccessForPropertyName(factory, receiver, propertyName, member.name);
            e2 = factory.createAssignment(memberName, memberFunction);
          }
          ts3.setEmitFlags(memberFunction, 1536);
          ts3.setSourceMapRange(memberFunction, sourceMapRange);
          var statement = ts3.setTextRange(factory.createExpressionStatement(e2), member);
          ts3.setOriginalNode(statement, member);
          ts3.setCommentRange(statement, commentRange);
          ts3.setEmitFlags(statement, 48);
          return statement;
        }
        function transformAccessorsToStatement(receiver, accessors, container) {
          var statement = factory.createExpressionStatement(transformAccessorsToExpression(receiver, accessors, container, false));
          ts3.setEmitFlags(statement, 1536);
          ts3.setSourceMapRange(statement, ts3.getSourceMapRange(accessors.firstAccessor));
          return statement;
        }
        function transformAccessorsToExpression(receiver, _a2, container, startsOnNewLine) {
          var firstAccessor = _a2.firstAccessor, getAccessor = _a2.getAccessor, setAccessor = _a2.setAccessor;
          var target = ts3.setParent(ts3.setTextRange(factory.cloneNode(receiver), receiver), receiver.parent);
          ts3.setEmitFlags(target, 1536 | 32);
          ts3.setSourceMapRange(target, firstAccessor.name);
          var visitedAccessorName = ts3.visitNode(firstAccessor.name, visitor, ts3.isPropertyName);
          if (ts3.isPrivateIdentifier(visitedAccessorName)) {
            return ts3.Debug.failBadSyntaxKind(visitedAccessorName, "Encountered unhandled private identifier while transforming ES2015.");
          }
          var propertyName = ts3.createExpressionForPropertyName(factory, visitedAccessorName);
          ts3.setEmitFlags(propertyName, 1536 | 16);
          ts3.setSourceMapRange(propertyName, firstAccessor.name);
          var properties = [];
          if (getAccessor) {
            var getterFunction = transformFunctionLikeToExpression(getAccessor, void 0, void 0, container);
            ts3.setSourceMapRange(getterFunction, ts3.getSourceMapRange(getAccessor));
            ts3.setEmitFlags(getterFunction, 512);
            var getter = factory.createPropertyAssignment("get", getterFunction);
            ts3.setCommentRange(getter, ts3.getCommentRange(getAccessor));
            properties.push(getter);
          }
          if (setAccessor) {
            var setterFunction = transformFunctionLikeToExpression(setAccessor, void 0, void 0, container);
            ts3.setSourceMapRange(setterFunction, ts3.getSourceMapRange(setAccessor));
            ts3.setEmitFlags(setterFunction, 512);
            var setter = factory.createPropertyAssignment("set", setterFunction);
            ts3.setCommentRange(setter, ts3.getCommentRange(setAccessor));
            properties.push(setter);
          }
          properties.push(factory.createPropertyAssignment("enumerable", getAccessor || setAccessor ? factory.createFalse() : factory.createTrue()), factory.createPropertyAssignment("configurable", factory.createTrue()));
          var call = factory.createCallExpression(factory.createPropertyAccessExpression(factory.createIdentifier("Object"), "defineProperty"), void 0, [
            target,
            propertyName,
            factory.createObjectLiteralExpression(properties, true)
          ]);
          if (startsOnNewLine) {
            ts3.startOnNewLine(call);
          }
          return call;
        }
        function visitArrowFunction(node) {
          if (node.transformFlags & 8192) {
            hierarchyFacts |= 32768;
          }
          var savedConvertedLoopState = convertedLoopState;
          convertedLoopState = void 0;
          var ancestorFacts = enterSubtree(15232, 66);
          var func2 = factory.createFunctionExpression(void 0, void 0, void 0, void 0, ts3.visitParameterList(node.parameters, visitor, context), void 0, transformFunctionBody(node));
          ts3.setTextRange(func2, node);
          ts3.setOriginalNode(func2, node);
          ts3.setEmitFlags(func2, 8);
          if (hierarchyFacts & 32768) {
            enableSubstitutionsForCapturedThis();
          }
          exitSubtree(ancestorFacts, 0, 0);
          convertedLoopState = savedConvertedLoopState;
          return func2;
        }
        function visitFunctionExpression(node) {
          var ancestorFacts = ts3.getEmitFlags(node) & 262144 ? enterSubtree(16278, 69) : enterSubtree(16286, 65);
          var savedConvertedLoopState = convertedLoopState;
          convertedLoopState = void 0;
          var parameters = ts3.visitParameterList(node.parameters, visitor, context);
          var body = transformFunctionBody(node);
          var name = hierarchyFacts & 16384 ? factory.getLocalName(node) : node.name;
          exitSubtree(ancestorFacts, 49152, 0);
          convertedLoopState = savedConvertedLoopState;
          return factory.updateFunctionExpression(node, void 0, node.asteriskToken, name, void 0, parameters, void 0, body);
        }
        function visitFunctionDeclaration(node) {
          var savedConvertedLoopState = convertedLoopState;
          convertedLoopState = void 0;
          var ancestorFacts = enterSubtree(16286, 65);
          var parameters = ts3.visitParameterList(node.parameters, visitor, context);
          var body = transformFunctionBody(node);
          var name = hierarchyFacts & 16384 ? factory.getLocalName(node) : node.name;
          exitSubtree(ancestorFacts, 49152, 0);
          convertedLoopState = savedConvertedLoopState;
          return factory.updateFunctionDeclaration(node, void 0, ts3.visitNodes(node.modifiers, visitor, ts3.isModifier), node.asteriskToken, name, void 0, parameters, void 0, body);
        }
        function transformFunctionLikeToExpression(node, location, name, container) {
          var savedConvertedLoopState = convertedLoopState;
          convertedLoopState = void 0;
          var ancestorFacts = container && ts3.isClassLike(container) && !ts3.hasSyntacticModifier(node, 32) ? enterSubtree(16286, 65 | 8) : enterSubtree(16286, 65);
          var parameters = ts3.visitParameterList(node.parameters, visitor, context);
          var body = transformFunctionBody(node);
          if (hierarchyFacts & 16384 && !name && (node.kind === 252 || node.kind === 209)) {
            name = factory.getGeneratedNameForNode(node);
          }
          exitSubtree(ancestorFacts, 49152, 0);
          convertedLoopState = savedConvertedLoopState;
          return ts3.setOriginalNode(ts3.setTextRange(factory.createFunctionExpression(void 0, node.asteriskToken, name, void 0, parameters, void 0, body), location), node);
        }
        function transformFunctionBody(node) {
          var multiLine = false;
          var singleLine = false;
          var statementsLocation;
          var closeBraceLocation;
          var prologue = [];
          var statements = [];
          var body = node.body;
          var statementOffset;
          resumeLexicalEnvironment();
          if (ts3.isBlock(body)) {
            statementOffset = factory.copyStandardPrologue(body.statements, prologue, false);
            statementOffset = factory.copyCustomPrologue(body.statements, statements, statementOffset, visitor, ts3.isHoistedFunction);
            statementOffset = factory.copyCustomPrologue(body.statements, statements, statementOffset, visitor, ts3.isHoistedVariableStatement);
          }
          multiLine = addDefaultValueAssignmentsIfNeeded(statements, node) || multiLine;
          multiLine = addRestParameterIfNeeded(statements, node, false) || multiLine;
          if (ts3.isBlock(body)) {
            statementOffset = factory.copyCustomPrologue(body.statements, statements, statementOffset, visitor);
            statementsLocation = body.statements;
            ts3.addRange(statements, ts3.visitNodes(body.statements, visitor, ts3.isStatement, statementOffset));
            if (!multiLine && body.multiLine) {
              multiLine = true;
            }
          } else {
            ts3.Debug.assert(node.kind === 210);
            statementsLocation = ts3.moveRangeEnd(body, -1);
            var equalsGreaterThanToken = node.equalsGreaterThanToken;
            if (!ts3.nodeIsSynthesized(equalsGreaterThanToken) && !ts3.nodeIsSynthesized(body)) {
              if (ts3.rangeEndIsOnSameLineAsRangeStart(equalsGreaterThanToken, body, currentSourceFile)) {
                singleLine = true;
              } else {
                multiLine = true;
              }
            }
            var expression = ts3.visitNode(body, visitor, ts3.isExpression);
            var returnStatement = factory.createReturnStatement(expression);
            ts3.setTextRange(returnStatement, body);
            ts3.moveSyntheticComments(returnStatement, body);
            ts3.setEmitFlags(returnStatement, 384 | 32 | 1024);
            statements.push(returnStatement);
            closeBraceLocation = body;
          }
          factory.mergeLexicalEnvironment(prologue, endLexicalEnvironment());
          insertCaptureNewTargetIfNeeded(prologue, node, false);
          insertCaptureThisForNodeIfNeeded(prologue, node);
          if (ts3.some(prologue)) {
            multiLine = true;
          }
          statements.unshift.apply(statements, prologue);
          if (ts3.isBlock(body) && ts3.arrayIsEqualTo(statements, body.statements)) {
            return body;
          }
          var block = factory.createBlock(ts3.setTextRange(factory.createNodeArray(statements), statementsLocation), multiLine);
          ts3.setTextRange(block, node.body);
          if (!multiLine && singleLine) {
            ts3.setEmitFlags(block, 1);
          }
          if (closeBraceLocation) {
            ts3.setTokenSourceMapRange(block, 19, closeBraceLocation);
          }
          ts3.setOriginalNode(block, node.body);
          return block;
        }
        function visitBlock(node, isFunctionBody) {
          if (isFunctionBody) {
            return ts3.visitEachChild(node, visitor, context);
          }
          var ancestorFacts = hierarchyFacts & 256 ? enterSubtree(7104, 512) : enterSubtree(6976, 128);
          var updated = ts3.visitEachChild(node, visitor, context);
          exitSubtree(ancestorFacts, 0, 0);
          return updated;
        }
        function visitExpressionStatement(node) {
          return ts3.visitEachChild(node, visitorWithUnusedExpressionResult, context);
        }
        function visitParenthesizedExpression(node, expressionResultIsUnused) {
          return ts3.visitEachChild(node, expressionResultIsUnused ? visitorWithUnusedExpressionResult : visitor, context);
        }
        function visitBinaryExpression(node, expressionResultIsUnused) {
          if (ts3.isDestructuringAssignment(node)) {
            return ts3.flattenDestructuringAssignment(node, visitor, context, 0, !expressionResultIsUnused);
          }
          if (node.operatorToken.kind === 27) {
            return factory.updateBinaryExpression(node, ts3.visitNode(node.left, visitorWithUnusedExpressionResult, ts3.isExpression), node.operatorToken, ts3.visitNode(node.right, expressionResultIsUnused ? visitorWithUnusedExpressionResult : visitor, ts3.isExpression));
          }
          return ts3.visitEachChild(node, visitor, context);
        }
        function visitCommaListExpression(node, expressionResultIsUnused) {
          if (expressionResultIsUnused) {
            return ts3.visitEachChild(node, visitorWithUnusedExpressionResult, context);
          }
          var result2;
          for (var i3 = 0; i3 < node.elements.length; i3++) {
            var element = node.elements[i3];
            var visited = ts3.visitNode(element, i3 < node.elements.length - 1 ? visitorWithUnusedExpressionResult : visitor, ts3.isExpression);
            if (result2 || visited !== element) {
              result2 || (result2 = node.elements.slice(0, i3));
              result2.push(visited);
            }
          }
          var elements = result2 ? ts3.setTextRange(factory.createNodeArray(result2), node.elements) : node.elements;
          return factory.updateCommaListExpression(node, elements);
        }
        function isVariableStatementOfTypeScriptClassWrapper(node) {
          return node.declarationList.declarations.length === 1 && !!node.declarationList.declarations[0].initializer && !!(ts3.getEmitFlags(node.declarationList.declarations[0].initializer) & 33554432);
        }
        function visitVariableStatement(node) {
          var ancestorFacts = enterSubtree(0, ts3.hasSyntacticModifier(node, 1) ? 32 : 0);
          var updated;
          if (convertedLoopState && (node.declarationList.flags & 3) === 0 && !isVariableStatementOfTypeScriptClassWrapper(node)) {
            var assignments = void 0;
            for (var _i = 0, _a2 = node.declarationList.declarations; _i < _a2.length; _i++) {
              var decl = _a2[_i];
              hoistVariableDeclarationDeclaredInConvertedLoop(convertedLoopState, decl);
              if (decl.initializer) {
                var assignment = void 0;
                if (ts3.isBindingPattern(decl.name)) {
                  assignment = ts3.flattenDestructuringAssignment(decl, visitor, context, 0);
                } else {
                  assignment = factory.createBinaryExpression(decl.name, 62, ts3.visitNode(decl.initializer, visitor, ts3.isExpression));
                  ts3.setTextRange(assignment, decl);
                }
                assignments = ts3.append(assignments, assignment);
              }
            }
            if (assignments) {
              updated = ts3.setTextRange(factory.createExpressionStatement(factory.inlineExpressions(assignments)), node);
            } else {
              updated = void 0;
            }
          } else {
            updated = ts3.visitEachChild(node, visitor, context);
          }
          exitSubtree(ancestorFacts, 0, 0);
          return updated;
        }
        function visitVariableDeclarationList(node) {
          if (node.flags & 3 || node.transformFlags & 262144) {
            if (node.flags & 3) {
              enableSubstitutionsForBlockScopedBindings();
            }
            var declarations = ts3.flatMap(node.declarations, node.flags & 1 ? visitVariableDeclarationInLetDeclarationList : visitVariableDeclaration);
            var declarationList = factory.createVariableDeclarationList(declarations);
            ts3.setOriginalNode(declarationList, node);
            ts3.setTextRange(declarationList, node);
            ts3.setCommentRange(declarationList, node);
            if (node.transformFlags & 262144 && (ts3.isBindingPattern(node.declarations[0].name) || ts3.isBindingPattern(ts3.last(node.declarations).name))) {
              ts3.setSourceMapRange(declarationList, getRangeUnion(declarations));
            }
            return declarationList;
          }
          return ts3.visitEachChild(node, visitor, context);
        }
        function getRangeUnion(declarations) {
          var pos = -1, end = -1;
          for (var _i = 0, declarations_9 = declarations; _i < declarations_9.length; _i++) {
            var node = declarations_9[_i];
            pos = pos === -1 ? node.pos : node.pos === -1 ? pos : Math.min(pos, node.pos);
            end = Math.max(end, node.end);
          }
          return ts3.createRange(pos, end);
        }
        function shouldEmitExplicitInitializerForLetDeclaration(node) {
          var flags = resolver.getNodeCheckFlags(node);
          var isCapturedInFunction = flags & 262144;
          var isDeclaredInLoop = flags & 524288;
          var emittedAsTopLevel = (hierarchyFacts & 64) !== 0 || isCapturedInFunction && isDeclaredInLoop && (hierarchyFacts & 512) !== 0;
          var emitExplicitInitializer = !emittedAsTopLevel && (hierarchyFacts & 4096) === 0 && (!resolver.isDeclarationWithCollidingName(node) || isDeclaredInLoop && !isCapturedInFunction && (hierarchyFacts & (2048 | 4096)) === 0);
          return emitExplicitInitializer;
        }
        function visitVariableDeclarationInLetDeclarationList(node) {
          var name = node.name;
          if (ts3.isBindingPattern(name)) {
            return visitVariableDeclaration(node);
          }
          if (!node.initializer && shouldEmitExplicitInitializerForLetDeclaration(node)) {
            return factory.updateVariableDeclaration(node, node.name, void 0, void 0, factory.createVoidZero());
          }
          return ts3.visitEachChild(node, visitor, context);
        }
        function visitVariableDeclaration(node) {
          var ancestorFacts = enterSubtree(32, 0);
          var updated;
          if (ts3.isBindingPattern(node.name)) {
            updated = ts3.flattenDestructuringBinding(node, visitor, context, 0, void 0, (ancestorFacts & 32) !== 0);
          } else {
            updated = ts3.visitEachChild(node, visitor, context);
          }
          exitSubtree(ancestorFacts, 0, 0);
          return updated;
        }
        function recordLabel(node) {
          convertedLoopState.labels.set(ts3.idText(node.label), true);
        }
        function resetLabel(node) {
          convertedLoopState.labels.set(ts3.idText(node.label), false);
        }
        function visitLabeledStatement(node) {
          if (convertedLoopState && !convertedLoopState.labels) {
            convertedLoopState.labels = new ts3.Map();
          }
          var statement = ts3.unwrapInnermostStatementOfLabel(node, convertedLoopState && recordLabel);
          return ts3.isIterationStatement(statement, false) ? visitIterationStatement(statement, node) : factory.restoreEnclosingLabel(ts3.visitNode(statement, visitor, ts3.isStatement, factory.liftToBlock), node, convertedLoopState && resetLabel);
        }
        function visitIterationStatement(node, outermostLabeledStatement) {
          switch (node.kind) {
            case 236:
            case 237:
              return visitDoOrWhileStatement(node, outermostLabeledStatement);
            case 238:
              return visitForStatement(node, outermostLabeledStatement);
            case 239:
              return visitForInStatement(node, outermostLabeledStatement);
            case 240:
              return visitForOfStatement(node, outermostLabeledStatement);
          }
        }
        function visitIterationStatementWithFacts(excludeFacts, includeFacts, node, outermostLabeledStatement, convert) {
          var ancestorFacts = enterSubtree(excludeFacts, includeFacts);
          var updated = convertIterationStatementBodyIfNecessary(node, outermostLabeledStatement, ancestorFacts, convert);
          exitSubtree(ancestorFacts, 0, 0);
          return updated;
        }
        function visitDoOrWhileStatement(node, outermostLabeledStatement) {
          return visitIterationStatementWithFacts(0, 1280, node, outermostLabeledStatement);
        }
        function visitForStatement(node, outermostLabeledStatement) {
          return visitIterationStatementWithFacts(5056, 3328, node, outermostLabeledStatement);
        }
        function visitEachChildOfForStatement(node) {
          return factory.updateForStatement(node, ts3.visitNode(node.initializer, visitorWithUnusedExpressionResult, ts3.isForInitializer), ts3.visitNode(node.condition, visitor, ts3.isExpression), ts3.visitNode(node.incrementor, visitorWithUnusedExpressionResult, ts3.isExpression), ts3.visitNode(node.statement, visitor, ts3.isStatement, factory.liftToBlock));
        }
        function visitForInStatement(node, outermostLabeledStatement) {
          return visitIterationStatementWithFacts(3008, 5376, node, outermostLabeledStatement);
        }
        function visitForOfStatement(node, outermostLabeledStatement) {
          return visitIterationStatementWithFacts(3008, 5376, node, outermostLabeledStatement, compilerOptions.downlevelIteration ? convertForOfStatementForIterable : convertForOfStatementForArray);
        }
        function convertForOfStatementHead(node, boundValue, convertedLoopBodyStatements) {
          var statements = [];
          var initializer = node.initializer;
          if (ts3.isVariableDeclarationList(initializer)) {
            if (node.initializer.flags & 3) {
              enableSubstitutionsForBlockScopedBindings();
            }
            var firstOriginalDeclaration = ts3.firstOrUndefined(initializer.declarations);
            if (firstOriginalDeclaration && ts3.isBindingPattern(firstOriginalDeclaration.name)) {
              var declarations = ts3.flattenDestructuringBinding(firstOriginalDeclaration, visitor, context, 0, boundValue);
              var declarationList = ts3.setTextRange(factory.createVariableDeclarationList(declarations), node.initializer);
              ts3.setOriginalNode(declarationList, node.initializer);
              ts3.setSourceMapRange(declarationList, ts3.createRange(declarations[0].pos, ts3.last(declarations).end));
              statements.push(factory.createVariableStatement(void 0, declarationList));
            } else {
              statements.push(ts3.setTextRange(factory.createVariableStatement(void 0, ts3.setOriginalNode(ts3.setTextRange(factory.createVariableDeclarationList([
                factory.createVariableDeclaration(firstOriginalDeclaration ? firstOriginalDeclaration.name : factory.createTempVariable(void 0), void 0, void 0, boundValue)
              ]), ts3.moveRangePos(initializer, -1)), initializer)), ts3.moveRangeEnd(initializer, -1)));
            }
          } else {
            var assignment = factory.createAssignment(initializer, boundValue);
            if (ts3.isDestructuringAssignment(assignment)) {
              statements.push(factory.createExpressionStatement(visitBinaryExpression(assignment, true)));
            } else {
              ts3.setTextRangeEnd(assignment, initializer.end);
              statements.push(ts3.setTextRange(factory.createExpressionStatement(ts3.visitNode(assignment, visitor, ts3.isExpression)), ts3.moveRangeEnd(initializer, -1)));
            }
          }
          if (convertedLoopBodyStatements) {
            return createSyntheticBlockForConvertedStatements(ts3.addRange(statements, convertedLoopBodyStatements));
          } else {
            var statement = ts3.visitNode(node.statement, visitor, ts3.isStatement, factory.liftToBlock);
            if (ts3.isBlock(statement)) {
              return factory.updateBlock(statement, ts3.setTextRange(factory.createNodeArray(ts3.concatenate(statements, statement.statements)), statement.statements));
            } else {
              statements.push(statement);
              return createSyntheticBlockForConvertedStatements(statements);
            }
          }
        }
        function createSyntheticBlockForConvertedStatements(statements) {
          return ts3.setEmitFlags(factory.createBlock(factory.createNodeArray(statements), true), 48 | 384);
        }
        function convertForOfStatementForArray(node, outermostLabeledStatement, convertedLoopBodyStatements) {
          var expression = ts3.visitNode(node.expression, visitor, ts3.isExpression);
          var counter = factory.createLoopVariable();
          var rhsReference = ts3.isIdentifier(expression) ? factory.getGeneratedNameForNode(expression) : factory.createTempVariable(void 0);
          ts3.setEmitFlags(expression, 48 | ts3.getEmitFlags(expression));
          var forStatement = ts3.setTextRange(factory.createForStatement(ts3.setEmitFlags(ts3.setTextRange(factory.createVariableDeclarationList([
            ts3.setTextRange(factory.createVariableDeclaration(counter, void 0, void 0, factory.createNumericLiteral(0)), ts3.moveRangePos(node.expression, -1)),
            ts3.setTextRange(factory.createVariableDeclaration(rhsReference, void 0, void 0, expression), node.expression)
          ]), node.expression), 2097152), ts3.setTextRange(factory.createLessThan(counter, factory.createPropertyAccessExpression(rhsReference, "length")), node.expression), ts3.setTextRange(factory.createPostfixIncrement(counter), node.expression), convertForOfStatementHead(node, factory.createElementAccessExpression(rhsReference, counter), convertedLoopBodyStatements)), node);
          ts3.setEmitFlags(forStatement, 256);
          ts3.setTextRange(forStatement, node);
          return factory.restoreEnclosingLabel(forStatement, outermostLabeledStatement, convertedLoopState && resetLabel);
        }
        function convertForOfStatementForIterable(node, outermostLabeledStatement, convertedLoopBodyStatements, ancestorFacts) {
          var expression = ts3.visitNode(node.expression, visitor, ts3.isExpression);
          var iterator = ts3.isIdentifier(expression) ? factory.getGeneratedNameForNode(expression) : factory.createTempVariable(void 0);
          var result2 = ts3.isIdentifier(expression) ? factory.getGeneratedNameForNode(iterator) : factory.createTempVariable(void 0);
          var errorRecord = factory.createUniqueName("e");
          var catchVariable = factory.getGeneratedNameForNode(errorRecord);
          var returnMethod = factory.createTempVariable(void 0);
          var values = ts3.setTextRange(emitHelpers().createValuesHelper(expression), node.expression);
          var next = factory.createCallExpression(factory.createPropertyAccessExpression(iterator, "next"), void 0, []);
          hoistVariableDeclaration(errorRecord);
          hoistVariableDeclaration(returnMethod);
          var initializer = ancestorFacts & 1024 ? factory.inlineExpressions([factory.createAssignment(errorRecord, factory.createVoidZero()), values]) : values;
          var forStatement = ts3.setEmitFlags(ts3.setTextRange(factory.createForStatement(ts3.setEmitFlags(ts3.setTextRange(factory.createVariableDeclarationList([
            ts3.setTextRange(factory.createVariableDeclaration(iterator, void 0, void 0, initializer), node.expression),
            factory.createVariableDeclaration(result2, void 0, void 0, next)
          ]), node.expression), 2097152), factory.createLogicalNot(factory.createPropertyAccessExpression(result2, "done")), factory.createAssignment(result2, next), convertForOfStatementHead(node, factory.createPropertyAccessExpression(result2, "value"), convertedLoopBodyStatements)), node), 256);
          return factory.createTryStatement(factory.createBlock([
            factory.restoreEnclosingLabel(forStatement, outermostLabeledStatement, convertedLoopState && resetLabel)
          ]), factory.createCatchClause(factory.createVariableDeclaration(catchVariable), ts3.setEmitFlags(factory.createBlock([
            factory.createExpressionStatement(factory.createAssignment(errorRecord, factory.createObjectLiteralExpression([
              factory.createPropertyAssignment("error", catchVariable)
            ])))
          ]), 1)), factory.createBlock([
            factory.createTryStatement(factory.createBlock([
              ts3.setEmitFlags(factory.createIfStatement(factory.createLogicalAnd(factory.createLogicalAnd(result2, factory.createLogicalNot(factory.createPropertyAccessExpression(result2, "done"))), factory.createAssignment(returnMethod, factory.createPropertyAccessExpression(iterator, "return"))), factory.createExpressionStatement(factory.createFunctionCallCall(returnMethod, iterator, []))), 1)
            ]), void 0, ts3.setEmitFlags(factory.createBlock([
              ts3.setEmitFlags(factory.createIfStatement(errorRecord, factory.createThrowStatement(factory.createPropertyAccessExpression(errorRecord, "error"))), 1)
            ]), 1))
          ]));
        }
        function visitObjectLiteralExpression(node) {
          var properties = node.properties;
          var numInitialProperties = -1, hasComputed = false;
          for (var i3 = 0; i3 < properties.length; i3++) {
            var property = properties[i3];
            if (property.transformFlags & 524288 && hierarchyFacts & 4 || (hasComputed = ts3.Debug.checkDefined(property.name).kind === 159)) {
              numInitialProperties = i3;
              break;
            }
          }
          if (numInitialProperties < 0) {
            return ts3.visitEachChild(node, visitor, context);
          }
          var temp = factory.createTempVariable(hoistVariableDeclaration);
          var expressions = [];
          var assignment = factory.createAssignment(temp, ts3.setEmitFlags(factory.createObjectLiteralExpression(ts3.visitNodes(properties, visitor, ts3.isObjectLiteralElementLike, 0, numInitialProperties), node.multiLine), hasComputed ? 65536 : 0));
          if (node.multiLine) {
            ts3.startOnNewLine(assignment);
          }
          expressions.push(assignment);
          addObjectLiteralMembers(expressions, node, temp, numInitialProperties);
          expressions.push(node.multiLine ? ts3.startOnNewLine(ts3.setParent(ts3.setTextRange(factory.cloneNode(temp), temp), temp.parent)) : temp);
          return factory.inlineExpressions(expressions);
        }
        function shouldConvertPartOfIterationStatement(node) {
          return (resolver.getNodeCheckFlags(node) & 131072) !== 0;
        }
        function shouldConvertInitializerOfForStatement(node) {
          return ts3.isForStatement(node) && !!node.initializer && shouldConvertPartOfIterationStatement(node.initializer);
        }
        function shouldConvertConditionOfForStatement(node) {
          return ts3.isForStatement(node) && !!node.condition && shouldConvertPartOfIterationStatement(node.condition);
        }
        function shouldConvertIncrementorOfForStatement(node) {
          return ts3.isForStatement(node) && !!node.incrementor && shouldConvertPartOfIterationStatement(node.incrementor);
        }
        function shouldConvertIterationStatement(node) {
          return shouldConvertBodyOfIterationStatement(node) || shouldConvertInitializerOfForStatement(node);
        }
        function shouldConvertBodyOfIterationStatement(node) {
          return (resolver.getNodeCheckFlags(node) & 65536) !== 0;
        }
        function hoistVariableDeclarationDeclaredInConvertedLoop(state, node) {
          if (!state.hoistedLocalVariables) {
            state.hoistedLocalVariables = [];
          }
          visit(node.name);
          function visit(node2) {
            if (node2.kind === 78) {
              state.hoistedLocalVariables.push(node2);
            } else {
              for (var _i = 0, _a2 = node2.elements; _i < _a2.length; _i++) {
                var element = _a2[_i];
                if (!ts3.isOmittedExpression(element)) {
                  visit(element.name);
                }
              }
            }
          }
        }
        function convertIterationStatementBodyIfNecessary(node, outermostLabeledStatement, ancestorFacts, convert) {
          if (!shouldConvertIterationStatement(node)) {
            var saveAllowedNonLabeledJumps = void 0;
            if (convertedLoopState) {
              saveAllowedNonLabeledJumps = convertedLoopState.allowedNonLabeledJumps;
              convertedLoopState.allowedNonLabeledJumps = 2 | 4;
            }
            var result2 = convert ? convert(node, outermostLabeledStatement, void 0, ancestorFacts) : factory.restoreEnclosingLabel(ts3.isForStatement(node) ? visitEachChildOfForStatement(node) : ts3.visitEachChild(node, visitor, context), outermostLabeledStatement, convertedLoopState && resetLabel);
            if (convertedLoopState) {
              convertedLoopState.allowedNonLabeledJumps = saveAllowedNonLabeledJumps;
            }
            return result2;
          }
          var currentState = createConvertedLoopState(node);
          var statements = [];
          var outerConvertedLoopState = convertedLoopState;
          convertedLoopState = currentState;
          var initializerFunction = shouldConvertInitializerOfForStatement(node) ? createFunctionForInitializerOfForStatement(node, currentState) : void 0;
          var bodyFunction = shouldConvertBodyOfIterationStatement(node) ? createFunctionForBodyOfIterationStatement(node, currentState, outerConvertedLoopState) : void 0;
          convertedLoopState = outerConvertedLoopState;
          if (initializerFunction)
            statements.push(initializerFunction.functionDeclaration);
          if (bodyFunction)
            statements.push(bodyFunction.functionDeclaration);
          addExtraDeclarationsForConvertedLoop(statements, currentState, outerConvertedLoopState);
          if (initializerFunction) {
            statements.push(generateCallToConvertedLoopInitializer(initializerFunction.functionName, initializerFunction.containsYield));
          }
          var loop;
          if (bodyFunction) {
            if (convert) {
              loop = convert(node, outermostLabeledStatement, bodyFunction.part, ancestorFacts);
            } else {
              var clone_4 = convertIterationStatementCore(node, initializerFunction, factory.createBlock(bodyFunction.part, true));
              loop = factory.restoreEnclosingLabel(clone_4, outermostLabeledStatement, convertedLoopState && resetLabel);
            }
          } else {
            var clone_5 = convertIterationStatementCore(node, initializerFunction, ts3.visitNode(node.statement, visitor, ts3.isStatement, factory.liftToBlock));
            loop = factory.restoreEnclosingLabel(clone_5, outermostLabeledStatement, convertedLoopState && resetLabel);
          }
          statements.push(loop);
          return statements;
        }
        function convertIterationStatementCore(node, initializerFunction, convertedLoopBody) {
          switch (node.kind) {
            case 238:
              return convertForStatement(node, initializerFunction, convertedLoopBody);
            case 239:
              return convertForInStatement(node, convertedLoopBody);
            case 240:
              return convertForOfStatement(node, convertedLoopBody);
            case 236:
              return convertDoStatement(node, convertedLoopBody);
            case 237:
              return convertWhileStatement(node, convertedLoopBody);
            default:
              return ts3.Debug.failBadSyntaxKind(node, "IterationStatement expected");
          }
        }
        function convertForStatement(node, initializerFunction, convertedLoopBody) {
          var shouldConvertCondition = node.condition && shouldConvertPartOfIterationStatement(node.condition);
          var shouldConvertIncrementor = shouldConvertCondition || node.incrementor && shouldConvertPartOfIterationStatement(node.incrementor);
          return factory.updateForStatement(node, ts3.visitNode(initializerFunction ? initializerFunction.part : node.initializer, visitorWithUnusedExpressionResult, ts3.isForInitializer), ts3.visitNode(shouldConvertCondition ? void 0 : node.condition, visitor, ts3.isExpression), ts3.visitNode(shouldConvertIncrementor ? void 0 : node.incrementor, visitorWithUnusedExpressionResult, ts3.isExpression), convertedLoopBody);
        }
        function convertForOfStatement(node, convertedLoopBody) {
          return factory.updateForOfStatement(node, void 0, ts3.visitNode(node.initializer, visitor, ts3.isForInitializer), ts3.visitNode(node.expression, visitor, ts3.isExpression), convertedLoopBody);
        }
        function convertForInStatement(node, convertedLoopBody) {
          return factory.updateForInStatement(node, ts3.visitNode(node.initializer, visitor, ts3.isForInitializer), ts3.visitNode(node.expression, visitor, ts3.isExpression), convertedLoopBody);
        }
        function convertDoStatement(node, convertedLoopBody) {
          return factory.updateDoStatement(node, convertedLoopBody, ts3.visitNode(node.expression, visitor, ts3.isExpression));
        }
        function convertWhileStatement(node, convertedLoopBody) {
          return factory.updateWhileStatement(node, ts3.visitNode(node.expression, visitor, ts3.isExpression), convertedLoopBody);
        }
        function createConvertedLoopState(node) {
          var loopInitializer;
          switch (node.kind) {
            case 238:
            case 239:
            case 240:
              var initializer = node.initializer;
              if (initializer && initializer.kind === 251) {
                loopInitializer = initializer;
              }
              break;
          }
          var loopParameters = [];
          var loopOutParameters = [];
          if (loopInitializer && ts3.getCombinedNodeFlags(loopInitializer) & 3) {
            var hasCapturedBindingsInForInitializer = shouldConvertInitializerOfForStatement(node);
            for (var _i = 0, _a2 = loopInitializer.declarations; _i < _a2.length; _i++) {
              var decl = _a2[_i];
              processLoopVariableDeclaration(node, decl, loopParameters, loopOutParameters, hasCapturedBindingsInForInitializer);
            }
          }
          var currentState = { loopParameters, loopOutParameters };
          if (convertedLoopState) {
            if (convertedLoopState.argumentsName) {
              currentState.argumentsName = convertedLoopState.argumentsName;
            }
            if (convertedLoopState.thisName) {
              currentState.thisName = convertedLoopState.thisName;
            }
            if (convertedLoopState.hoistedLocalVariables) {
              currentState.hoistedLocalVariables = convertedLoopState.hoistedLocalVariables;
            }
          }
          return currentState;
        }
        function addExtraDeclarationsForConvertedLoop(statements, state, outerState) {
          var extraVariableDeclarations;
          if (state.argumentsName) {
            if (outerState) {
              outerState.argumentsName = state.argumentsName;
            } else {
              (extraVariableDeclarations || (extraVariableDeclarations = [])).push(factory.createVariableDeclaration(state.argumentsName, void 0, void 0, factory.createIdentifier("arguments")));
            }
          }
          if (state.thisName) {
            if (outerState) {
              outerState.thisName = state.thisName;
            } else {
              (extraVariableDeclarations || (extraVariableDeclarations = [])).push(factory.createVariableDeclaration(state.thisName, void 0, void 0, factory.createIdentifier("this")));
            }
          }
          if (state.hoistedLocalVariables) {
            if (outerState) {
              outerState.hoistedLocalVariables = state.hoistedLocalVariables;
            } else {
              if (!extraVariableDeclarations) {
                extraVariableDeclarations = [];
              }
              for (var _i = 0, _a2 = state.hoistedLocalVariables; _i < _a2.length; _i++) {
                var identifier = _a2[_i];
                extraVariableDeclarations.push(factory.createVariableDeclaration(identifier));
              }
            }
          }
          if (state.loopOutParameters.length) {
            if (!extraVariableDeclarations) {
              extraVariableDeclarations = [];
            }
            for (var _b = 0, _c = state.loopOutParameters; _b < _c.length; _b++) {
              var outParam = _c[_b];
              extraVariableDeclarations.push(factory.createVariableDeclaration(outParam.outParamName));
            }
          }
          if (state.conditionVariable) {
            if (!extraVariableDeclarations) {
              extraVariableDeclarations = [];
            }
            extraVariableDeclarations.push(factory.createVariableDeclaration(state.conditionVariable, void 0, void 0, factory.createFalse()));
          }
          if (extraVariableDeclarations) {
            statements.push(factory.createVariableStatement(void 0, factory.createVariableDeclarationList(extraVariableDeclarations)));
          }
        }
        function createOutVariable(p) {
          return factory.createVariableDeclaration(p.originalName, void 0, void 0, p.outParamName);
        }
        function createFunctionForInitializerOfForStatement(node, currentState) {
          var functionName = factory.createUniqueName("_loop_init");
          var containsYield = (node.initializer.transformFlags & 524288) !== 0;
          var emitFlags = 0;
          if (currentState.containsLexicalThis)
            emitFlags |= 8;
          if (containsYield && hierarchyFacts & 4)
            emitFlags |= 262144;
          var statements = [];
          statements.push(factory.createVariableStatement(void 0, node.initializer));
          copyOutParameters(currentState.loopOutParameters, 2, 1, statements);
          var functionDeclaration = factory.createVariableStatement(void 0, ts3.setEmitFlags(factory.createVariableDeclarationList([
            factory.createVariableDeclaration(functionName, void 0, void 0, ts3.setEmitFlags(factory.createFunctionExpression(void 0, containsYield ? factory.createToken(41) : void 0, void 0, void 0, void 0, void 0, ts3.visitNode(factory.createBlock(statements, true), visitor, ts3.isBlock)), emitFlags))
          ]), 2097152));
          var part = factory.createVariableDeclarationList(ts3.map(currentState.loopOutParameters, createOutVariable));
          return { functionName, containsYield, functionDeclaration, part };
        }
        function createFunctionForBodyOfIterationStatement(node, currentState, outerState) {
          var functionName = factory.createUniqueName("_loop");
          startLexicalEnvironment();
          var statement = ts3.visitNode(node.statement, visitor, ts3.isStatement, factory.liftToBlock);
          var lexicalEnvironment = endLexicalEnvironment();
          var statements = [];
          if (shouldConvertConditionOfForStatement(node) || shouldConvertIncrementorOfForStatement(node)) {
            currentState.conditionVariable = factory.createUniqueName("inc");
            if (node.incrementor) {
              statements.push(factory.createIfStatement(currentState.conditionVariable, factory.createExpressionStatement(ts3.visitNode(node.incrementor, visitor, ts3.isExpression)), factory.createExpressionStatement(factory.createAssignment(currentState.conditionVariable, factory.createTrue()))));
            } else {
              statements.push(factory.createIfStatement(factory.createLogicalNot(currentState.conditionVariable), factory.createExpressionStatement(factory.createAssignment(currentState.conditionVariable, factory.createTrue()))));
            }
            if (shouldConvertConditionOfForStatement(node)) {
              statements.push(factory.createIfStatement(factory.createPrefixUnaryExpression(53, ts3.visitNode(node.condition, visitor, ts3.isExpression)), ts3.visitNode(factory.createBreakStatement(), visitor, ts3.isStatement)));
            }
          }
          if (ts3.isBlock(statement)) {
            ts3.addRange(statements, statement.statements);
          } else {
            statements.push(statement);
          }
          copyOutParameters(currentState.loopOutParameters, 1, 1, statements);
          ts3.insertStatementsAfterStandardPrologue(statements, lexicalEnvironment);
          var loopBody = factory.createBlock(statements, true);
          if (ts3.isBlock(statement))
            ts3.setOriginalNode(loopBody, statement);
          var containsYield = (node.statement.transformFlags & 524288) !== 0;
          var emitFlags = 524288;
          if (currentState.containsLexicalThis)
            emitFlags |= 8;
          if (containsYield && (hierarchyFacts & 4) !== 0)
            emitFlags |= 262144;
          var functionDeclaration = factory.createVariableStatement(void 0, ts3.setEmitFlags(factory.createVariableDeclarationList([
            factory.createVariableDeclaration(functionName, void 0, void 0, ts3.setEmitFlags(factory.createFunctionExpression(void 0, containsYield ? factory.createToken(41) : void 0, void 0, void 0, currentState.loopParameters, void 0, loopBody), emitFlags))
          ]), 2097152));
          var part = generateCallToConvertedLoop(functionName, currentState, outerState, containsYield);
          return { functionName, containsYield, functionDeclaration, part };
        }
        function copyOutParameter(outParam, copyDirection) {
          var source = copyDirection === 0 ? outParam.outParamName : outParam.originalName;
          var target = copyDirection === 0 ? outParam.originalName : outParam.outParamName;
          return factory.createBinaryExpression(target, 62, source);
        }
        function copyOutParameters(outParams, partFlags, copyDirection, statements) {
          for (var _i = 0, outParams_1 = outParams; _i < outParams_1.length; _i++) {
            var outParam = outParams_1[_i];
            if (outParam.flags & partFlags) {
              statements.push(factory.createExpressionStatement(copyOutParameter(outParam, copyDirection)));
            }
          }
        }
        function generateCallToConvertedLoopInitializer(initFunctionExpressionName, containsYield) {
          var call = factory.createCallExpression(initFunctionExpressionName, void 0, []);
          var callResult = containsYield ? factory.createYieldExpression(factory.createToken(41), ts3.setEmitFlags(call, 8388608)) : call;
          return factory.createExpressionStatement(callResult);
        }
        function generateCallToConvertedLoop(loopFunctionExpressionName, state, outerState, containsYield) {
          var statements = [];
          var isSimpleLoop = !(state.nonLocalJumps & ~4) && !state.labeledNonLocalBreaks && !state.labeledNonLocalContinues;
          var call = factory.createCallExpression(loopFunctionExpressionName, void 0, ts3.map(state.loopParameters, function(p) {
            return p.name;
          }));
          var callResult = containsYield ? factory.createYieldExpression(factory.createToken(41), ts3.setEmitFlags(call, 8388608)) : call;
          if (isSimpleLoop) {
            statements.push(factory.createExpressionStatement(callResult));
            copyOutParameters(state.loopOutParameters, 1, 0, statements);
          } else {
            var loopResultName = factory.createUniqueName("state");
            var stateVariable = factory.createVariableStatement(void 0, factory.createVariableDeclarationList([factory.createVariableDeclaration(loopResultName, void 0, void 0, callResult)]));
            statements.push(stateVariable);
            copyOutParameters(state.loopOutParameters, 1, 0, statements);
            if (state.nonLocalJumps & 8) {
              var returnStatement = void 0;
              if (outerState) {
                outerState.nonLocalJumps |= 8;
                returnStatement = factory.createReturnStatement(loopResultName);
              } else {
                returnStatement = factory.createReturnStatement(factory.createPropertyAccessExpression(loopResultName, "value"));
              }
              statements.push(factory.createIfStatement(factory.createTypeCheck(loopResultName, "object"), returnStatement));
            }
            if (state.nonLocalJumps & 2) {
              statements.push(factory.createIfStatement(factory.createStrictEquality(loopResultName, factory.createStringLiteral("break")), factory.createBreakStatement()));
            }
            if (state.labeledNonLocalBreaks || state.labeledNonLocalContinues) {
              var caseClauses = [];
              processLabeledJumps(state.labeledNonLocalBreaks, true, loopResultName, outerState, caseClauses);
              processLabeledJumps(state.labeledNonLocalContinues, false, loopResultName, outerState, caseClauses);
              statements.push(factory.createSwitchStatement(loopResultName, factory.createCaseBlock(caseClauses)));
            }
          }
          return statements;
        }
        function setLabeledJump(state, isBreak, labelText, labelMarker) {
          if (isBreak) {
            if (!state.labeledNonLocalBreaks) {
              state.labeledNonLocalBreaks = new ts3.Map();
            }
            state.labeledNonLocalBreaks.set(labelText, labelMarker);
          } else {
            if (!state.labeledNonLocalContinues) {
              state.labeledNonLocalContinues = new ts3.Map();
            }
            state.labeledNonLocalContinues.set(labelText, labelMarker);
          }
        }
        function processLabeledJumps(table, isBreak, loopResultName, outerLoop, caseClauses) {
          if (!table) {
            return;
          }
          table.forEach(function(labelMarker, labelText) {
            var statements = [];
            if (!outerLoop || outerLoop.labels && outerLoop.labels.get(labelText)) {
              var label = factory.createIdentifier(labelText);
              statements.push(isBreak ? factory.createBreakStatement(label) : factory.createContinueStatement(label));
            } else {
              setLabeledJump(outerLoop, isBreak, labelText, labelMarker);
              statements.push(factory.createReturnStatement(loopResultName));
            }
            caseClauses.push(factory.createCaseClause(factory.createStringLiteral(labelMarker), statements));
          });
        }
        function processLoopVariableDeclaration(container, decl, loopParameters, loopOutParameters, hasCapturedBindingsInForInitializer) {
          var name = decl.name;
          if (ts3.isBindingPattern(name)) {
            for (var _i = 0, _a2 = name.elements; _i < _a2.length; _i++) {
              var element = _a2[_i];
              if (!ts3.isOmittedExpression(element)) {
                processLoopVariableDeclaration(container, element, loopParameters, loopOutParameters, hasCapturedBindingsInForInitializer);
              }
            }
          } else {
            loopParameters.push(factory.createParameterDeclaration(void 0, void 0, void 0, name));
            var checkFlags = resolver.getNodeCheckFlags(decl);
            if (checkFlags & 4194304 || hasCapturedBindingsInForInitializer) {
              var outParamName = factory.createUniqueName("out_" + ts3.idText(name));
              var flags = 0;
              if (checkFlags & 4194304) {
                flags |= 1;
              }
              if (ts3.isForStatement(container) && container.initializer && resolver.isBindingCapturedByNode(container.initializer, decl)) {
                flags |= 2;
              }
              loopOutParameters.push({ flags, originalName: name, outParamName });
            }
          }
        }
        function addObjectLiteralMembers(expressions, node, receiver, start) {
          var properties = node.properties;
          var numProperties = properties.length;
          for (var i3 = start; i3 < numProperties; i3++) {
            var property = properties[i3];
            switch (property.kind) {
              case 168:
              case 169:
                var accessors = ts3.getAllAccessorDeclarations(node.properties, property);
                if (property === accessors.firstAccessor) {
                  expressions.push(transformAccessorsToExpression(receiver, accessors, node, !!node.multiLine));
                }
                break;
              case 166:
                expressions.push(transformObjectLiteralMethodDeclarationToExpression(property, receiver, node, node.multiLine));
                break;
              case 289:
                expressions.push(transformPropertyAssignmentToExpression(property, receiver, node.multiLine));
                break;
              case 290:
                expressions.push(transformShorthandPropertyAssignmentToExpression(property, receiver, node.multiLine));
                break;
              default:
                ts3.Debug.failBadSyntaxKind(node);
                break;
            }
          }
        }
        function transformPropertyAssignmentToExpression(property, receiver, startsOnNewLine) {
          var expression = factory.createAssignment(ts3.createMemberAccessForPropertyName(factory, receiver, ts3.visitNode(property.name, visitor, ts3.isPropertyName)), ts3.visitNode(property.initializer, visitor, ts3.isExpression));
          ts3.setTextRange(expression, property);
          if (startsOnNewLine) {
            ts3.startOnNewLine(expression);
          }
          return expression;
        }
        function transformShorthandPropertyAssignmentToExpression(property, receiver, startsOnNewLine) {
          var expression = factory.createAssignment(ts3.createMemberAccessForPropertyName(factory, receiver, ts3.visitNode(property.name, visitor, ts3.isPropertyName)), factory.cloneNode(property.name));
          ts3.setTextRange(expression, property);
          if (startsOnNewLine) {
            ts3.startOnNewLine(expression);
          }
          return expression;
        }
        function transformObjectLiteralMethodDeclarationToExpression(method, receiver, container, startsOnNewLine) {
          var expression = factory.createAssignment(ts3.createMemberAccessForPropertyName(factory, receiver, ts3.visitNode(method.name, visitor, ts3.isPropertyName)), transformFunctionLikeToExpression(method, method, void 0, container));
          ts3.setTextRange(expression, method);
          if (startsOnNewLine) {
            ts3.startOnNewLine(expression);
          }
          return expression;
        }
        function visitCatchClause(node) {
          var ancestorFacts = enterSubtree(7104, 0);
          var updated;
          ts3.Debug.assert(!!node.variableDeclaration, "Catch clause variable should always be present when downleveling ES2015.");
          if (ts3.isBindingPattern(node.variableDeclaration.name)) {
            var temp = factory.createTempVariable(void 0);
            var newVariableDeclaration = factory.createVariableDeclaration(temp);
            ts3.setTextRange(newVariableDeclaration, node.variableDeclaration);
            var vars = ts3.flattenDestructuringBinding(node.variableDeclaration, visitor, context, 0, temp);
            var list = factory.createVariableDeclarationList(vars);
            ts3.setTextRange(list, node.variableDeclaration);
            var destructure = factory.createVariableStatement(void 0, list);
            updated = factory.updateCatchClause(node, newVariableDeclaration, addStatementToStartOfBlock(node.block, destructure));
          } else {
            updated = ts3.visitEachChild(node, visitor, context);
          }
          exitSubtree(ancestorFacts, 0, 0);
          return updated;
        }
        function addStatementToStartOfBlock(block, statement) {
          var transformedStatements = ts3.visitNodes(block.statements, visitor, ts3.isStatement);
          return factory.updateBlock(block, __spreadArray([statement], transformedStatements));
        }
        function visitMethodDeclaration(node) {
          ts3.Debug.assert(!ts3.isComputedPropertyName(node.name));
          var functionExpression = transformFunctionLikeToExpression(node, ts3.moveRangePos(node, -1), void 0, void 0);
          ts3.setEmitFlags(functionExpression, 512 | ts3.getEmitFlags(functionExpression));
          return ts3.setTextRange(factory.createPropertyAssignment(node.name, functionExpression), node);
        }
        function visitAccessorDeclaration(node) {
          ts3.Debug.assert(!ts3.isComputedPropertyName(node.name));
          var savedConvertedLoopState = convertedLoopState;
          convertedLoopState = void 0;
          var ancestorFacts = enterSubtree(16286, 65);
          var updated;
          var parameters = ts3.visitParameterList(node.parameters, visitor, context);
          var body = transformFunctionBody(node);
          if (node.kind === 168) {
            updated = factory.updateGetAccessorDeclaration(node, node.decorators, node.modifiers, node.name, parameters, node.type, body);
          } else {
            updated = factory.updateSetAccessorDeclaration(node, node.decorators, node.modifiers, node.name, parameters, body);
          }
          exitSubtree(ancestorFacts, 49152, 0);
          convertedLoopState = savedConvertedLoopState;
          return updated;
        }
        function visitShorthandPropertyAssignment(node) {
          return ts3.setTextRange(factory.createPropertyAssignment(node.name, visitIdentifier(factory.cloneNode(node.name))), node);
        }
        function visitComputedPropertyName(node) {
          return ts3.visitEachChild(node, visitor, context);
        }
        function visitYieldExpression(node) {
          return ts3.visitEachChild(node, visitor, context);
        }
        function visitArrayLiteralExpression(node) {
          if (ts3.some(node.elements, ts3.isSpreadElement)) {
            return transformAndSpreadElements(node.elements, true, !!node.multiLine, !!node.elements.hasTrailingComma);
          }
          return ts3.visitEachChild(node, visitor, context);
        }
        function visitCallExpression(node) {
          if (ts3.getEmitFlags(node) & 33554432) {
            return visitTypeScriptClassWrapper(node);
          }
          var expression = ts3.skipOuterExpressions(node.expression);
          if (expression.kind === 105 || ts3.isSuperProperty(expression) || ts3.some(node.arguments, ts3.isSpreadElement)) {
            return visitCallExpressionWithPotentialCapturedThisAssignment(node, true);
          }
          return factory.updateCallExpression(node, ts3.visitNode(node.expression, callExpressionVisitor, ts3.isExpression), void 0, ts3.visitNodes(node.arguments, visitor, ts3.isExpression));
        }
        function visitTypeScriptClassWrapper(node) {
          var body = ts3.cast(ts3.cast(ts3.skipOuterExpressions(node.expression), ts3.isArrowFunction).body, ts3.isBlock);
          var isVariableStatementWithInitializer = function(stmt) {
            return ts3.isVariableStatement(stmt) && !!ts3.first(stmt.declarationList.declarations).initializer;
          };
          var savedConvertedLoopState = convertedLoopState;
          convertedLoopState = void 0;
          var bodyStatements = ts3.visitNodes(body.statements, visitor, ts3.isStatement);
          convertedLoopState = savedConvertedLoopState;
          var classStatements = ts3.filter(bodyStatements, isVariableStatementWithInitializer);
          var remainingStatements = ts3.filter(bodyStatements, function(stmt) {
            return !isVariableStatementWithInitializer(stmt);
          });
          var varStatement = ts3.cast(ts3.first(classStatements), ts3.isVariableStatement);
          var variable = varStatement.declarationList.declarations[0];
          var initializer = ts3.skipOuterExpressions(variable.initializer);
          var aliasAssignment = ts3.tryCast(initializer, ts3.isAssignmentExpression);
          var call = ts3.cast(aliasAssignment ? ts3.skipOuterExpressions(aliasAssignment.right) : initializer, ts3.isCallExpression);
          var func2 = ts3.cast(ts3.skipOuterExpressions(call.expression), ts3.isFunctionExpression);
          var funcStatements = func2.body.statements;
          var classBodyStart = 0;
          var classBodyEnd = -1;
          var statements = [];
          if (aliasAssignment) {
            var extendsCall = ts3.tryCast(funcStatements[classBodyStart], ts3.isExpressionStatement);
            if (extendsCall) {
              statements.push(extendsCall);
              classBodyStart++;
            }
            statements.push(funcStatements[classBodyStart]);
            classBodyStart++;
            statements.push(factory.createExpressionStatement(factory.createAssignment(aliasAssignment.left, ts3.cast(variable.name, ts3.isIdentifier))));
          }
          while (!ts3.isReturnStatement(ts3.elementAt(funcStatements, classBodyEnd))) {
            classBodyEnd--;
          }
          ts3.addRange(statements, funcStatements, classBodyStart, classBodyEnd);
          if (classBodyEnd < -1) {
            ts3.addRange(statements, funcStatements, classBodyEnd + 1);
          }
          ts3.addRange(statements, remainingStatements);
          ts3.addRange(statements, classStatements, 1);
          return factory.restoreOuterExpressions(node.expression, factory.restoreOuterExpressions(variable.initializer, factory.restoreOuterExpressions(aliasAssignment && aliasAssignment.right, factory.updateCallExpression(call, factory.restoreOuterExpressions(call.expression, factory.updateFunctionExpression(func2, void 0, void 0, void 0, void 0, func2.parameters, void 0, factory.updateBlock(func2.body, statements))), void 0, call.arguments))));
        }
        function visitImmediateSuperCallInBody(node) {
          return visitCallExpressionWithPotentialCapturedThisAssignment(node, false);
        }
        function visitCallExpressionWithPotentialCapturedThisAssignment(node, assignToCapturedThis) {
          if (node.transformFlags & 16384 || node.expression.kind === 105 || ts3.isSuperProperty(ts3.skipOuterExpressions(node.expression))) {
            var _a2 = factory.createCallBinding(node.expression, hoistVariableDeclaration), target = _a2.target, thisArg = _a2.thisArg;
            if (node.expression.kind === 105) {
              ts3.setEmitFlags(thisArg, 4);
            }
            var resultingCall = void 0;
            if (node.transformFlags & 16384) {
              resultingCall = factory.createFunctionApplyCall(ts3.visitNode(target, callExpressionVisitor, ts3.isExpression), node.expression.kind === 105 ? thisArg : ts3.visitNode(thisArg, visitor, ts3.isExpression), transformAndSpreadElements(node.arguments, false, false, false));
            } else {
              resultingCall = ts3.setTextRange(factory.createFunctionCallCall(ts3.visitNode(target, callExpressionVisitor, ts3.isExpression), node.expression.kind === 105 ? thisArg : ts3.visitNode(thisArg, visitor, ts3.isExpression), ts3.visitNodes(node.arguments, visitor, ts3.isExpression)), node);
            }
            if (node.expression.kind === 105) {
              var initializer = factory.createLogicalOr(resultingCall, createActualThis());
              resultingCall = assignToCapturedThis ? factory.createAssignment(factory.createUniqueName("_this", 16 | 32), initializer) : initializer;
            }
            return ts3.setOriginalNode(resultingCall, node);
          }
          return ts3.visitEachChild(node, visitor, context);
        }
        function visitNewExpression(node) {
          if (ts3.some(node.arguments, ts3.isSpreadElement)) {
            var _a2 = factory.createCallBinding(factory.createPropertyAccessExpression(node.expression, "bind"), hoistVariableDeclaration), target = _a2.target, thisArg = _a2.thisArg;
            return factory.createNewExpression(factory.createFunctionApplyCall(ts3.visitNode(target, visitor, ts3.isExpression), thisArg, transformAndSpreadElements(factory.createNodeArray(__spreadArray([factory.createVoidZero()], node.arguments)), false, false, false)), void 0, []);
          }
          return ts3.visitEachChild(node, visitor, context);
        }
        function transformAndSpreadElements(elements, needsUniqueCopy, multiLine, hasTrailingComma) {
          var numElements = elements.length;
          var segments = ts3.flatten(ts3.spanMap(elements, partitionSpread, function(partition, visitPartition, _start, end) {
            return visitPartition(partition, multiLine, hasTrailingComma && end === numElements);
          }));
          if (segments.length === 1) {
            var firstSegment = segments[0];
            if (!needsUniqueCopy && !compilerOptions.downlevelIteration || ts3.isPackedArrayLiteral(firstSegment) || ts3.isCallToHelper(firstSegment, "___spreadArray")) {
              return segments[0];
            }
          }
          var helpers = emitHelpers();
          var startsWithSpread = ts3.isSpreadElement(elements[0]);
          var expression = startsWithSpread ? factory.createArrayLiteralExpression() : segments[0];
          for (var i3 = startsWithSpread ? 0 : 1; i3 < segments.length; i3++) {
            expression = helpers.createSpreadArrayHelper(expression, compilerOptions.downlevelIteration && !ts3.isPackedArrayLiteral(segments[i3]) ? helpers.createReadHelper(segments[i3], void 0) : segments[i3]);
          }
          return expression;
        }
        function partitionSpread(node) {
          return ts3.isSpreadElement(node) ? visitSpanOfSpreads : visitSpanOfNonSpreads;
        }
        function visitSpanOfSpreads(chunk) {
          return ts3.map(chunk, visitExpressionOfSpread);
        }
        function visitSpanOfNonSpreads(chunk, multiLine, hasTrailingComma) {
          return factory.createArrayLiteralExpression(ts3.visitNodes(factory.createNodeArray(chunk, hasTrailingComma), visitor, ts3.isExpression), multiLine);
        }
        function visitSpreadElement(node) {
          return ts3.visitNode(node.expression, visitor, ts3.isExpression);
        }
        function visitExpressionOfSpread(node) {
          return ts3.visitNode(node.expression, visitor, ts3.isExpression);
        }
        function visitTemplateLiteral(node) {
          return ts3.setTextRange(factory.createStringLiteral(node.text), node);
        }
        function visitStringLiteral(node) {
          if (node.hasExtendedUnicodeEscape) {
            return ts3.setTextRange(factory.createStringLiteral(node.text), node);
          }
          return node;
        }
        function visitNumericLiteral(node) {
          if (node.numericLiteralFlags & 384) {
            return ts3.setTextRange(factory.createNumericLiteral(node.text), node);
          }
          return node;
        }
        function visitTaggedTemplateExpression(node) {
          return ts3.processTaggedTemplateExpression(context, node, visitor, currentSourceFile, recordTaggedTemplateString, ts3.ProcessLevel.All);
        }
        function visitTemplateExpression(node) {
          var expressions = [];
          addTemplateHead(expressions, node);
          addTemplateSpans(expressions, node);
          var expression = ts3.reduceLeft(expressions, factory.createAdd);
          if (ts3.nodeIsSynthesized(expression)) {
            ts3.setTextRange(expression, node);
          }
          return expression;
        }
        function shouldAddTemplateHead(node) {
          ts3.Debug.assert(node.templateSpans.length !== 0);
          return node.head.text.length !== 0 || node.templateSpans[0].literal.text.length === 0;
        }
        function addTemplateHead(expressions, node) {
          if (!shouldAddTemplateHead(node)) {
            return;
          }
          expressions.push(factory.createStringLiteral(node.head.text));
        }
        function addTemplateSpans(expressions, node) {
          for (var _i = 0, _a2 = node.templateSpans; _i < _a2.length; _i++) {
            var span = _a2[_i];
            expressions.push(ts3.visitNode(span.expression, visitor, ts3.isExpression));
            if (span.literal.text.length !== 0) {
              expressions.push(factory.createStringLiteral(span.literal.text));
            }
          }
        }
        function visitSuperKeyword(isExpressionOfCall) {
          return hierarchyFacts & 8 && !isExpressionOfCall ? factory.createPropertyAccessExpression(factory.createUniqueName("_super", 16 | 32), "prototype") : factory.createUniqueName("_super", 16 | 32);
        }
        function visitMetaProperty(node) {
          if (node.keywordToken === 102 && node.name.escapedText === "target") {
            hierarchyFacts |= 16384;
            return factory.createUniqueName("_newTarget", 16 | 32);
          }
          return node;
        }
        function onEmitNode(hint, node, emitCallback) {
          if (enabledSubstitutions & 1 && ts3.isFunctionLike(node)) {
            var ancestorFacts = enterSubtree(16286, ts3.getEmitFlags(node) & 8 ? 65 | 16 : 65);
            previousOnEmitNode(hint, node, emitCallback);
            exitSubtree(ancestorFacts, 0, 0);
            return;
          }
          previousOnEmitNode(hint, node, emitCallback);
        }
        function enableSubstitutionsForBlockScopedBindings() {
          if ((enabledSubstitutions & 2) === 0) {
            enabledSubstitutions |= 2;
            context.enableSubstitution(78);
          }
        }
        function enableSubstitutionsForCapturedThis() {
          if ((enabledSubstitutions & 1) === 0) {
            enabledSubstitutions |= 1;
            context.enableSubstitution(107);
            context.enableEmitNotification(167);
            context.enableEmitNotification(166);
            context.enableEmitNotification(168);
            context.enableEmitNotification(169);
            context.enableEmitNotification(210);
            context.enableEmitNotification(209);
            context.enableEmitNotification(252);
          }
        }
        function onSubstituteNode(hint, node) {
          node = previousOnSubstituteNode(hint, node);
          if (hint === 1) {
            return substituteExpression(node);
          }
          if (ts3.isIdentifier(node)) {
            return substituteIdentifier(node);
          }
          return node;
        }
        function substituteIdentifier(node) {
          if (enabledSubstitutions & 2 && !ts3.isInternalName(node)) {
            var original = ts3.getParseTreeNode(node, ts3.isIdentifier);
            if (original && isNameOfDeclarationWithCollidingName(original)) {
              return ts3.setTextRange(factory.getGeneratedNameForNode(original), node);
            }
          }
          return node;
        }
        function isNameOfDeclarationWithCollidingName(node) {
          switch (node.parent.kind) {
            case 199:
            case 253:
            case 256:
            case 250:
              return node.parent.name === node && resolver.isDeclarationWithCollidingName(node.parent);
          }
          return false;
        }
        function substituteExpression(node) {
          switch (node.kind) {
            case 78:
              return substituteExpressionIdentifier(node);
            case 107:
              return substituteThisKeyword(node);
          }
          return node;
        }
        function substituteExpressionIdentifier(node) {
          if (enabledSubstitutions & 2 && !ts3.isInternalName(node)) {
            var declaration = resolver.getReferencedDeclarationWithCollidingName(node);
            if (declaration && !(ts3.isClassLike(declaration) && isPartOfClassBody(declaration, node))) {
              return ts3.setTextRange(factory.getGeneratedNameForNode(ts3.getNameOfDeclaration(declaration)), node);
            }
          }
          return node;
        }
        function isPartOfClassBody(declaration, node) {
          var currentNode = ts3.getParseTreeNode(node);
          if (!currentNode || currentNode === declaration || currentNode.end <= declaration.pos || currentNode.pos >= declaration.end) {
            return false;
          }
          var blockScope = ts3.getEnclosingBlockScopeContainer(declaration);
          while (currentNode) {
            if (currentNode === blockScope || currentNode === declaration) {
              return false;
            }
            if (ts3.isClassElement(currentNode) && currentNode.parent === declaration) {
              return true;
            }
            currentNode = currentNode.parent;
          }
          return false;
        }
        function substituteThisKeyword(node) {
          if (enabledSubstitutions & 1 && hierarchyFacts & 16) {
            return ts3.setTextRange(factory.createUniqueName("_this", 16 | 32), node);
          }
          return node;
        }
        function getClassMemberPrefix(node, member) {
          return ts3.hasSyntacticModifier(member, 32) ? factory.getInternalName(node) : factory.createPropertyAccessExpression(factory.getInternalName(node), "prototype");
        }
        function hasSynthesizedDefaultSuperCall(constructor, hasExtendsClause) {
          if (!constructor || !hasExtendsClause) {
            return false;
          }
          if (ts3.some(constructor.parameters)) {
            return false;
          }
          var statement = ts3.firstOrUndefined(constructor.body.statements);
          if (!statement || !ts3.nodeIsSynthesized(statement) || statement.kind !== 234) {
            return false;
          }
          var statementExpression = statement.expression;
          if (!ts3.nodeIsSynthesized(statementExpression) || statementExpression.kind !== 204) {
            return false;
          }
          var callTarget = statementExpression.expression;
          if (!ts3.nodeIsSynthesized(callTarget) || callTarget.kind !== 105) {
            return false;
          }
          var callArgument = ts3.singleOrUndefined(statementExpression.arguments);
          if (!callArgument || !ts3.nodeIsSynthesized(callArgument) || callArgument.kind !== 221) {
            return false;
          }
          var expression = callArgument.expression;
          return ts3.isIdentifier(expression) && expression.escapedText === "arguments";
        }
      }
      ts3.transformES2015 = transformES2015;
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      function transformES5(context) {
        var factory = context.factory;
        var compilerOptions = context.getCompilerOptions();
        var previousOnEmitNode;
        var noSubstitution;
        if (compilerOptions.jsx === 1 || compilerOptions.jsx === 3) {
          previousOnEmitNode = context.onEmitNode;
          context.onEmitNode = onEmitNode;
          context.enableEmitNotification(276);
          context.enableEmitNotification(277);
          context.enableEmitNotification(275);
          noSubstitution = [];
        }
        var previousOnSubstituteNode = context.onSubstituteNode;
        context.onSubstituteNode = onSubstituteNode;
        context.enableSubstitution(202);
        context.enableSubstitution(289);
        return ts3.chainBundle(context, transformSourceFile);
        function transformSourceFile(node) {
          return node;
        }
        function onEmitNode(hint, node, emitCallback) {
          switch (node.kind) {
            case 276:
            case 277:
            case 275:
              var tagName = node.tagName;
              noSubstitution[ts3.getOriginalNodeId(tagName)] = true;
              break;
          }
          previousOnEmitNode(hint, node, emitCallback);
        }
        function onSubstituteNode(hint, node) {
          if (node.id && noSubstitution && noSubstitution[node.id]) {
            return previousOnSubstituteNode(hint, node);
          }
          node = previousOnSubstituteNode(hint, node);
          if (ts3.isPropertyAccessExpression(node)) {
            return substitutePropertyAccessExpression(node);
          } else if (ts3.isPropertyAssignment(node)) {
            return substitutePropertyAssignment(node);
          }
          return node;
        }
        function substitutePropertyAccessExpression(node) {
          if (ts3.isPrivateIdentifier(node.name)) {
            return node;
          }
          var literalName = trySubstituteReservedName(node.name);
          if (literalName) {
            return ts3.setTextRange(factory.createElementAccessExpression(node.expression, literalName), node);
          }
          return node;
        }
        function substitutePropertyAssignment(node) {
          var literalName = ts3.isIdentifier(node.name) && trySubstituteReservedName(node.name);
          if (literalName) {
            return factory.updatePropertyAssignment(node, literalName, node.initializer);
          }
          return node;
        }
        function trySubstituteReservedName(name) {
          var token = name.originalKeywordKind || (ts3.nodeIsSynthesized(name) ? ts3.stringToToken(ts3.idText(name)) : void 0);
          if (token !== void 0 && token >= 80 && token <= 115) {
            return ts3.setTextRange(factory.createStringLiteralFromNode(name), name);
          }
          return void 0;
        }
      }
      ts3.transformES5 = transformES5;
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var OpCode;
      (function(OpCode2) {
        OpCode2[OpCode2["Nop"] = 0] = "Nop";
        OpCode2[OpCode2["Statement"] = 1] = "Statement";
        OpCode2[OpCode2["Assign"] = 2] = "Assign";
        OpCode2[OpCode2["Break"] = 3] = "Break";
        OpCode2[OpCode2["BreakWhenTrue"] = 4] = "BreakWhenTrue";
        OpCode2[OpCode2["BreakWhenFalse"] = 5] = "BreakWhenFalse";
        OpCode2[OpCode2["Yield"] = 6] = "Yield";
        OpCode2[OpCode2["YieldStar"] = 7] = "YieldStar";
        OpCode2[OpCode2["Return"] = 8] = "Return";
        OpCode2[OpCode2["Throw"] = 9] = "Throw";
        OpCode2[OpCode2["Endfinally"] = 10] = "Endfinally";
      })(OpCode || (OpCode = {}));
      var BlockAction;
      (function(BlockAction2) {
        BlockAction2[BlockAction2["Open"] = 0] = "Open";
        BlockAction2[BlockAction2["Close"] = 1] = "Close";
      })(BlockAction || (BlockAction = {}));
      var CodeBlockKind;
      (function(CodeBlockKind2) {
        CodeBlockKind2[CodeBlockKind2["Exception"] = 0] = "Exception";
        CodeBlockKind2[CodeBlockKind2["With"] = 1] = "With";
        CodeBlockKind2[CodeBlockKind2["Switch"] = 2] = "Switch";
        CodeBlockKind2[CodeBlockKind2["Loop"] = 3] = "Loop";
        CodeBlockKind2[CodeBlockKind2["Labeled"] = 4] = "Labeled";
      })(CodeBlockKind || (CodeBlockKind = {}));
      var ExceptionBlockState;
      (function(ExceptionBlockState2) {
        ExceptionBlockState2[ExceptionBlockState2["Try"] = 0] = "Try";
        ExceptionBlockState2[ExceptionBlockState2["Catch"] = 1] = "Catch";
        ExceptionBlockState2[ExceptionBlockState2["Finally"] = 2] = "Finally";
        ExceptionBlockState2[ExceptionBlockState2["Done"] = 3] = "Done";
      })(ExceptionBlockState || (ExceptionBlockState = {}));
      var Instruction;
      (function(Instruction2) {
        Instruction2[Instruction2["Next"] = 0] = "Next";
        Instruction2[Instruction2["Throw"] = 1] = "Throw";
        Instruction2[Instruction2["Return"] = 2] = "Return";
        Instruction2[Instruction2["Break"] = 3] = "Break";
        Instruction2[Instruction2["Yield"] = 4] = "Yield";
        Instruction2[Instruction2["YieldStar"] = 5] = "YieldStar";
        Instruction2[Instruction2["Catch"] = 6] = "Catch";
        Instruction2[Instruction2["Endfinally"] = 7] = "Endfinally";
      })(Instruction || (Instruction = {}));
      function getInstructionName(instruction) {
        switch (instruction) {
          case 2:
            return "return";
          case 3:
            return "break";
          case 4:
            return "yield";
          case 5:
            return "yield*";
          case 7:
            return "endfinally";
          default:
            return void 0;
        }
      }
      function transformGenerators(context) {
        var factory = context.factory, emitHelpers = context.getEmitHelperFactory, resumeLexicalEnvironment = context.resumeLexicalEnvironment, endLexicalEnvironment = context.endLexicalEnvironment, hoistFunctionDeclaration = context.hoistFunctionDeclaration, hoistVariableDeclaration = context.hoistVariableDeclaration;
        var compilerOptions = context.getCompilerOptions();
        var languageVersion = ts3.getEmitScriptTarget(compilerOptions);
        var resolver = context.getEmitResolver();
        var previousOnSubstituteNode = context.onSubstituteNode;
        context.onSubstituteNode = onSubstituteNode;
        var renamedCatchVariables;
        var renamedCatchVariableDeclarations;
        var inGeneratorFunctionBody;
        var inStatementContainingYield;
        var blocks;
        var blockOffsets;
        var blockActions;
        var blockStack;
        var labelOffsets;
        var labelExpressions;
        var nextLabelId = 1;
        var operations;
        var operationArguments;
        var operationLocations;
        var state;
        var blockIndex = 0;
        var labelNumber = 0;
        var labelNumbers;
        var lastOperationWasAbrupt;
        var lastOperationWasCompletion;
        var clauses;
        var statements;
        var exceptionBlockStack;
        var currentExceptionBlock;
        var withBlockStack;
        return ts3.chainBundle(context, transformSourceFile);
        function transformSourceFile(node) {
          if (node.isDeclarationFile || (node.transformFlags & 1024) === 0) {
            return node;
          }
          var visited = ts3.visitEachChild(node, visitor, context);
          ts3.addEmitHelpers(visited, context.readEmitHelpers());
          return visited;
        }
        function visitor(node) {
          var transformFlags = node.transformFlags;
          if (inStatementContainingYield) {
            return visitJavaScriptInStatementContainingYield(node);
          } else if (inGeneratorFunctionBody) {
            return visitJavaScriptInGeneratorFunctionBody(node);
          } else if (ts3.isFunctionLikeDeclaration(node) && node.asteriskToken) {
            return visitGenerator(node);
          } else if (transformFlags & 1024) {
            return ts3.visitEachChild(node, visitor, context);
          } else {
            return node;
          }
        }
        function visitJavaScriptInStatementContainingYield(node) {
          switch (node.kind) {
            case 236:
              return visitDoStatement(node);
            case 237:
              return visitWhileStatement(node);
            case 245:
              return visitSwitchStatement(node);
            case 246:
              return visitLabeledStatement(node);
            default:
              return visitJavaScriptInGeneratorFunctionBody(node);
          }
        }
        function visitJavaScriptInGeneratorFunctionBody(node) {
          switch (node.kind) {
            case 252:
              return visitFunctionDeclaration(node);
            case 209:
              return visitFunctionExpression(node);
            case 168:
            case 169:
              return visitAccessorDeclaration(node);
            case 233:
              return visitVariableStatement(node);
            case 238:
              return visitForStatement(node);
            case 239:
              return visitForInStatement(node);
            case 242:
              return visitBreakStatement(node);
            case 241:
              return visitContinueStatement(node);
            case 243:
              return visitReturnStatement(node);
            default:
              if (node.transformFlags & 524288) {
                return visitJavaScriptContainingYield(node);
              } else if (node.transformFlags & (1024 | 2097152)) {
                return ts3.visitEachChild(node, visitor, context);
              } else {
                return node;
              }
          }
        }
        function visitJavaScriptContainingYield(node) {
          switch (node.kind) {
            case 217:
              return visitBinaryExpression(node);
            case 341:
              return visitCommaListExpression(node);
            case 218:
              return visitConditionalExpression(node);
            case 220:
              return visitYieldExpression(node);
            case 200:
              return visitArrayLiteralExpression(node);
            case 201:
              return visitObjectLiteralExpression(node);
            case 203:
              return visitElementAccessExpression(node);
            case 204:
              return visitCallExpression(node);
            case 205:
              return visitNewExpression(node);
            default:
              return ts3.visitEachChild(node, visitor, context);
          }
        }
        function visitGenerator(node) {
          switch (node.kind) {
            case 252:
              return visitFunctionDeclaration(node);
            case 209:
              return visitFunctionExpression(node);
            default:
              return ts3.Debug.failBadSyntaxKind(node);
          }
        }
        function visitFunctionDeclaration(node) {
          if (node.asteriskToken) {
            node = ts3.setOriginalNode(ts3.setTextRange(factory.createFunctionDeclaration(void 0, node.modifiers, void 0, node.name, void 0, ts3.visitParameterList(node.parameters, visitor, context), void 0, transformGeneratorFunctionBody(node.body)), node), node);
          } else {
            var savedInGeneratorFunctionBody = inGeneratorFunctionBody;
            var savedInStatementContainingYield = inStatementContainingYield;
            inGeneratorFunctionBody = false;
            inStatementContainingYield = false;
            node = ts3.visitEachChild(node, visitor, context);
            inGeneratorFunctionBody = savedInGeneratorFunctionBody;
            inStatementContainingYield = savedInStatementContainingYield;
          }
          if (inGeneratorFunctionBody) {
            hoistFunctionDeclaration(node);
            return void 0;
          } else {
            return node;
          }
        }
        function visitFunctionExpression(node) {
          if (node.asteriskToken) {
            node = ts3.setOriginalNode(ts3.setTextRange(factory.createFunctionExpression(void 0, void 0, node.name, void 0, ts3.visitParameterList(node.parameters, visitor, context), void 0, transformGeneratorFunctionBody(node.body)), node), node);
          } else {
            var savedInGeneratorFunctionBody = inGeneratorFunctionBody;
            var savedInStatementContainingYield = inStatementContainingYield;
            inGeneratorFunctionBody = false;
            inStatementContainingYield = false;
            node = ts3.visitEachChild(node, visitor, context);
            inGeneratorFunctionBody = savedInGeneratorFunctionBody;
            inStatementContainingYield = savedInStatementContainingYield;
          }
          return node;
        }
        function visitAccessorDeclaration(node) {
          var savedInGeneratorFunctionBody = inGeneratorFunctionBody;
          var savedInStatementContainingYield = inStatementContainingYield;
          inGeneratorFunctionBody = false;
          inStatementContainingYield = false;
          node = ts3.visitEachChild(node, visitor, context);
          inGeneratorFunctionBody = savedInGeneratorFunctionBody;
          inStatementContainingYield = savedInStatementContainingYield;
          return node;
        }
        function transformGeneratorFunctionBody(body) {
          var statements2 = [];
          var savedInGeneratorFunctionBody = inGeneratorFunctionBody;
          var savedInStatementContainingYield = inStatementContainingYield;
          var savedBlocks = blocks;
          var savedBlockOffsets = blockOffsets;
          var savedBlockActions = blockActions;
          var savedBlockStack = blockStack;
          var savedLabelOffsets = labelOffsets;
          var savedLabelExpressions = labelExpressions;
          var savedNextLabelId = nextLabelId;
          var savedOperations = operations;
          var savedOperationArguments = operationArguments;
          var savedOperationLocations = operationLocations;
          var savedState = state;
          inGeneratorFunctionBody = true;
          inStatementContainingYield = false;
          blocks = void 0;
          blockOffsets = void 0;
          blockActions = void 0;
          blockStack = void 0;
          labelOffsets = void 0;
          labelExpressions = void 0;
          nextLabelId = 1;
          operations = void 0;
          operationArguments = void 0;
          operationLocations = void 0;
          state = factory.createTempVariable(void 0);
          resumeLexicalEnvironment();
          var statementOffset = factory.copyPrologue(body.statements, statements2, false, visitor);
          transformAndEmitStatements(body.statements, statementOffset);
          var buildResult = build();
          ts3.insertStatementsAfterStandardPrologue(statements2, endLexicalEnvironment());
          statements2.push(factory.createReturnStatement(buildResult));
          inGeneratorFunctionBody = savedInGeneratorFunctionBody;
          inStatementContainingYield = savedInStatementContainingYield;
          blocks = savedBlocks;
          blockOffsets = savedBlockOffsets;
          blockActions = savedBlockActions;
          blockStack = savedBlockStack;
          labelOffsets = savedLabelOffsets;
          labelExpressions = savedLabelExpressions;
          nextLabelId = savedNextLabelId;
          operations = savedOperations;
          operationArguments = savedOperationArguments;
          operationLocations = savedOperationLocations;
          state = savedState;
          return ts3.setTextRange(factory.createBlock(statements2, body.multiLine), body);
        }
        function visitVariableStatement(node) {
          if (node.transformFlags & 524288) {
            transformAndEmitVariableDeclarationList(node.declarationList);
            return void 0;
          } else {
            if (ts3.getEmitFlags(node) & 1048576) {
              return node;
            }
            for (var _i = 0, _a2 = node.declarationList.declarations; _i < _a2.length; _i++) {
              var variable = _a2[_i];
              hoistVariableDeclaration(variable.name);
            }
            var variables = ts3.getInitializedVariables(node.declarationList);
            if (variables.length === 0) {
              return void 0;
            }
            return ts3.setSourceMapRange(factory.createExpressionStatement(factory.inlineExpressions(ts3.map(variables, transformInitializedVariable))), node);
          }
        }
        function visitBinaryExpression(node) {
          var assoc = ts3.getExpressionAssociativity(node);
          switch (assoc) {
            case 0:
              return visitLeftAssociativeBinaryExpression(node);
            case 1:
              return visitRightAssociativeBinaryExpression(node);
            default:
              return ts3.Debug.assertNever(assoc);
          }
        }
        function visitRightAssociativeBinaryExpression(node) {
          var left = node.left, right = node.right;
          if (containsYield(right)) {
            var target = void 0;
            switch (left.kind) {
              case 202:
                target = factory.updatePropertyAccessExpression(left, cacheExpression(ts3.visitNode(left.expression, visitor, ts3.isLeftHandSideExpression)), left.name);
                break;
              case 203:
                target = factory.updateElementAccessExpression(left, cacheExpression(ts3.visitNode(left.expression, visitor, ts3.isLeftHandSideExpression)), cacheExpression(ts3.visitNode(left.argumentExpression, visitor, ts3.isExpression)));
                break;
              default:
                target = ts3.visitNode(left, visitor, ts3.isExpression);
                break;
            }
            var operator = node.operatorToken.kind;
            if (ts3.isCompoundAssignment(operator)) {
              return ts3.setTextRange(factory.createAssignment(target, ts3.setTextRange(factory.createBinaryExpression(cacheExpression(target), ts3.getNonAssignmentOperatorForCompoundAssignment(operator), ts3.visitNode(right, visitor, ts3.isExpression)), node)), node);
            } else {
              return factory.updateBinaryExpression(node, target, node.operatorToken, ts3.visitNode(right, visitor, ts3.isExpression));
            }
          }
          return ts3.visitEachChild(node, visitor, context);
        }
        function visitLeftAssociativeBinaryExpression(node) {
          if (containsYield(node.right)) {
            if (ts3.isLogicalOperator(node.operatorToken.kind)) {
              return visitLogicalBinaryExpression(node);
            } else if (node.operatorToken.kind === 27) {
              return visitCommaExpression(node);
            }
            return factory.updateBinaryExpression(node, cacheExpression(ts3.visitNode(node.left, visitor, ts3.isExpression)), node.operatorToken, ts3.visitNode(node.right, visitor, ts3.isExpression));
          }
          return ts3.visitEachChild(node, visitor, context);
        }
        function visitCommaExpression(node) {
          var pendingExpressions = [];
          visit(node.left);
          visit(node.right);
          return factory.inlineExpressions(pendingExpressions);
          function visit(node2) {
            if (ts3.isBinaryExpression(node2) && node2.operatorToken.kind === 27) {
              visit(node2.left);
              visit(node2.right);
            } else {
              if (containsYield(node2) && pendingExpressions.length > 0) {
                emitWorker(1, [factory.createExpressionStatement(factory.inlineExpressions(pendingExpressions))]);
                pendingExpressions = [];
              }
              pendingExpressions.push(ts3.visitNode(node2, visitor, ts3.isExpression));
            }
          }
        }
        function visitCommaListExpression(node) {
          var pendingExpressions = [];
          for (var _i = 0, _a2 = node.elements; _i < _a2.length; _i++) {
            var elem = _a2[_i];
            if (ts3.isBinaryExpression(elem) && elem.operatorToken.kind === 27) {
              pendingExpressions.push(visitCommaExpression(elem));
            } else {
              if (containsYield(elem) && pendingExpressions.length > 0) {
                emitWorker(1, [factory.createExpressionStatement(factory.inlineExpressions(pendingExpressions))]);
                pendingExpressions = [];
              }
              pendingExpressions.push(ts3.visitNode(elem, visitor, ts3.isExpression));
            }
          }
          return factory.inlineExpressions(pendingExpressions);
        }
        function visitLogicalBinaryExpression(node) {
          var resultLabel = defineLabel();
          var resultLocal = declareLocal();
          emitAssignment(resultLocal, ts3.visitNode(node.left, visitor, ts3.isExpression), node.left);
          if (node.operatorToken.kind === 55) {
            emitBreakWhenFalse(resultLabel, resultLocal, node.left);
          } else {
            emitBreakWhenTrue(resultLabel, resultLocal, node.left);
          }
          emitAssignment(resultLocal, ts3.visitNode(node.right, visitor, ts3.isExpression), node.right);
          markLabel(resultLabel);
          return resultLocal;
        }
        function visitConditionalExpression(node) {
          if (containsYield(node.whenTrue) || containsYield(node.whenFalse)) {
            var whenFalseLabel = defineLabel();
            var resultLabel = defineLabel();
            var resultLocal = declareLocal();
            emitBreakWhenFalse(whenFalseLabel, ts3.visitNode(node.condition, visitor, ts3.isExpression), node.condition);
            emitAssignment(resultLocal, ts3.visitNode(node.whenTrue, visitor, ts3.isExpression), node.whenTrue);
            emitBreak(resultLabel);
            markLabel(whenFalseLabel);
            emitAssignment(resultLocal, ts3.visitNode(node.whenFalse, visitor, ts3.isExpression), node.whenFalse);
            markLabel(resultLabel);
            return resultLocal;
          }
          return ts3.visitEachChild(node, visitor, context);
        }
        function visitYieldExpression(node) {
          var resumeLabel = defineLabel();
          var expression = ts3.visitNode(node.expression, visitor, ts3.isExpression);
          if (node.asteriskToken) {
            var iterator = (ts3.getEmitFlags(node.expression) & 8388608) === 0 ? ts3.setTextRange(emitHelpers().createValuesHelper(expression), node) : expression;
            emitYieldStar(iterator, node);
          } else {
            emitYield(expression, node);
          }
          markLabel(resumeLabel);
          return createGeneratorResume(node);
        }
        function visitArrayLiteralExpression(node) {
          return visitElements(node.elements, void 0, void 0, node.multiLine);
        }
        function visitElements(elements, leadingElement, location, multiLine) {
          var numInitialElements = countInitialNodesWithoutYield(elements);
          var temp;
          if (numInitialElements > 0) {
            temp = declareLocal();
            var initialElements = ts3.visitNodes(elements, visitor, ts3.isExpression, 0, numInitialElements);
            emitAssignment(temp, factory.createArrayLiteralExpression(leadingElement ? __spreadArray([leadingElement], initialElements) : initialElements));
            leadingElement = void 0;
          }
          var expressions = ts3.reduceLeft(elements, reduceElement, [], numInitialElements);
          return temp ? factory.createArrayConcatCall(temp, [factory.createArrayLiteralExpression(expressions, multiLine)]) : ts3.setTextRange(factory.createArrayLiteralExpression(leadingElement ? __spreadArray([leadingElement], expressions) : expressions, multiLine), location);
          function reduceElement(expressions2, element) {
            if (containsYield(element) && expressions2.length > 0) {
              var hasAssignedTemp = temp !== void 0;
              if (!temp) {
                temp = declareLocal();
              }
              emitAssignment(temp, hasAssignedTemp ? factory.createArrayConcatCall(temp, [factory.createArrayLiteralExpression(expressions2, multiLine)]) : factory.createArrayLiteralExpression(leadingElement ? __spreadArray([leadingElement], expressions2) : expressions2, multiLine));
              leadingElement = void 0;
              expressions2 = [];
            }
            expressions2.push(ts3.visitNode(element, visitor, ts3.isExpression));
            return expressions2;
          }
        }
        function visitObjectLiteralExpression(node) {
          var properties = node.properties;
          var multiLine = node.multiLine;
          var numInitialProperties = countInitialNodesWithoutYield(properties);
          var temp = declareLocal();
          emitAssignment(temp, factory.createObjectLiteralExpression(ts3.visitNodes(properties, visitor, ts3.isObjectLiteralElementLike, 0, numInitialProperties), multiLine));
          var expressions = ts3.reduceLeft(properties, reduceProperty, [], numInitialProperties);
          expressions.push(multiLine ? ts3.startOnNewLine(ts3.setParent(ts3.setTextRange(factory.cloneNode(temp), temp), temp.parent)) : temp);
          return factory.inlineExpressions(expressions);
          function reduceProperty(expressions2, property) {
            if (containsYield(property) && expressions2.length > 0) {
              emitStatement(factory.createExpressionStatement(factory.inlineExpressions(expressions2)));
              expressions2 = [];
            }
            var expression = ts3.createExpressionForObjectLiteralElementLike(factory, node, property, temp);
            var visited = ts3.visitNode(expression, visitor, ts3.isExpression);
            if (visited) {
              if (multiLine) {
                ts3.startOnNewLine(visited);
              }
              expressions2.push(visited);
            }
            return expressions2;
          }
        }
        function visitElementAccessExpression(node) {
          if (containsYield(node.argumentExpression)) {
            return factory.updateElementAccessExpression(node, cacheExpression(ts3.visitNode(node.expression, visitor, ts3.isLeftHandSideExpression)), ts3.visitNode(node.argumentExpression, visitor, ts3.isExpression));
          }
          return ts3.visitEachChild(node, visitor, context);
        }
        function visitCallExpression(node) {
          if (!ts3.isImportCall(node) && ts3.forEach(node.arguments, containsYield)) {
            var _a2 = factory.createCallBinding(node.expression, hoistVariableDeclaration, languageVersion, true), target = _a2.target, thisArg = _a2.thisArg;
            return ts3.setOriginalNode(ts3.setTextRange(factory.createFunctionApplyCall(cacheExpression(ts3.visitNode(target, visitor, ts3.isLeftHandSideExpression)), thisArg, visitElements(node.arguments)), node), node);
          }
          return ts3.visitEachChild(node, visitor, context);
        }
        function visitNewExpression(node) {
          if (ts3.forEach(node.arguments, containsYield)) {
            var _a2 = factory.createCallBinding(factory.createPropertyAccessExpression(node.expression, "bind"), hoistVariableDeclaration), target = _a2.target, thisArg = _a2.thisArg;
            return ts3.setOriginalNode(ts3.setTextRange(factory.createNewExpression(factory.createFunctionApplyCall(cacheExpression(ts3.visitNode(target, visitor, ts3.isExpression)), thisArg, visitElements(node.arguments, factory.createVoidZero())), void 0, []), node), node);
          }
          return ts3.visitEachChild(node, visitor, context);
        }
        function transformAndEmitStatements(statements2, start) {
          if (start === void 0) {
            start = 0;
          }
          var numStatements = statements2.length;
          for (var i3 = start; i3 < numStatements; i3++) {
            transformAndEmitStatement(statements2[i3]);
          }
        }
        function transformAndEmitEmbeddedStatement(node) {
          if (ts3.isBlock(node)) {
            transformAndEmitStatements(node.statements);
          } else {
            transformAndEmitStatement(node);
          }
        }
        function transformAndEmitStatement(node) {
          var savedInStatementContainingYield = inStatementContainingYield;
          if (!inStatementContainingYield) {
            inStatementContainingYield = containsYield(node);
          }
          transformAndEmitStatementWorker(node);
          inStatementContainingYield = savedInStatementContainingYield;
        }
        function transformAndEmitStatementWorker(node) {
          switch (node.kind) {
            case 231:
              return transformAndEmitBlock(node);
            case 234:
              return transformAndEmitExpressionStatement(node);
            case 235:
              return transformAndEmitIfStatement(node);
            case 236:
              return transformAndEmitDoStatement(node);
            case 237:
              return transformAndEmitWhileStatement(node);
            case 238:
              return transformAndEmitForStatement(node);
            case 239:
              return transformAndEmitForInStatement(node);
            case 241:
              return transformAndEmitContinueStatement(node);
            case 242:
              return transformAndEmitBreakStatement(node);
            case 243:
              return transformAndEmitReturnStatement(node);
            case 244:
              return transformAndEmitWithStatement(node);
            case 245:
              return transformAndEmitSwitchStatement(node);
            case 246:
              return transformAndEmitLabeledStatement(node);
            case 247:
              return transformAndEmitThrowStatement(node);
            case 248:
              return transformAndEmitTryStatement(node);
            default:
              return emitStatement(ts3.visitNode(node, visitor, ts3.isStatement));
          }
        }
        function transformAndEmitBlock(node) {
          if (containsYield(node)) {
            transformAndEmitStatements(node.statements);
          } else {
            emitStatement(ts3.visitNode(node, visitor, ts3.isStatement));
          }
        }
        function transformAndEmitExpressionStatement(node) {
          emitStatement(ts3.visitNode(node, visitor, ts3.isStatement));
        }
        function transformAndEmitVariableDeclarationList(node) {
          for (var _i = 0, _a2 = node.declarations; _i < _a2.length; _i++) {
            var variable = _a2[_i];
            var name = factory.cloneNode(variable.name);
            ts3.setCommentRange(name, variable.name);
            hoistVariableDeclaration(name);
          }
          var variables = ts3.getInitializedVariables(node);
          var numVariables = variables.length;
          var variablesWritten = 0;
          var pendingExpressions = [];
          while (variablesWritten < numVariables) {
            for (var i3 = variablesWritten; i3 < numVariables; i3++) {
              var variable = variables[i3];
              if (containsYield(variable.initializer) && pendingExpressions.length > 0) {
                break;
              }
              pendingExpressions.push(transformInitializedVariable(variable));
            }
            if (pendingExpressions.length) {
              emitStatement(factory.createExpressionStatement(factory.inlineExpressions(pendingExpressions)));
              variablesWritten += pendingExpressions.length;
              pendingExpressions = [];
            }
          }
          return void 0;
        }
        function transformInitializedVariable(node) {
          return ts3.setSourceMapRange(factory.createAssignment(ts3.setSourceMapRange(factory.cloneNode(node.name), node.name), ts3.visitNode(node.initializer, visitor, ts3.isExpression)), node);
        }
        function transformAndEmitIfStatement(node) {
          if (containsYield(node)) {
            if (containsYield(node.thenStatement) || containsYield(node.elseStatement)) {
              var endLabel = defineLabel();
              var elseLabel = node.elseStatement ? defineLabel() : void 0;
              emitBreakWhenFalse(node.elseStatement ? elseLabel : endLabel, ts3.visitNode(node.expression, visitor, ts3.isExpression), node.expression);
              transformAndEmitEmbeddedStatement(node.thenStatement);
              if (node.elseStatement) {
                emitBreak(endLabel);
                markLabel(elseLabel);
                transformAndEmitEmbeddedStatement(node.elseStatement);
              }
              markLabel(endLabel);
            } else {
              emitStatement(ts3.visitNode(node, visitor, ts3.isStatement));
            }
          } else {
            emitStatement(ts3.visitNode(node, visitor, ts3.isStatement));
          }
        }
        function transformAndEmitDoStatement(node) {
          if (containsYield(node)) {
            var conditionLabel = defineLabel();
            var loopLabel = defineLabel();
            beginLoopBlock(conditionLabel);
            markLabel(loopLabel);
            transformAndEmitEmbeddedStatement(node.statement);
            markLabel(conditionLabel);
            emitBreakWhenTrue(loopLabel, ts3.visitNode(node.expression, visitor, ts3.isExpression));
            endLoopBlock();
          } else {
            emitStatement(ts3.visitNode(node, visitor, ts3.isStatement));
          }
        }
        function visitDoStatement(node) {
          if (inStatementContainingYield) {
            beginScriptLoopBlock();
            node = ts3.visitEachChild(node, visitor, context);
            endLoopBlock();
            return node;
          } else {
            return ts3.visitEachChild(node, visitor, context);
          }
        }
        function transformAndEmitWhileStatement(node) {
          if (containsYield(node)) {
            var loopLabel = defineLabel();
            var endLabel = beginLoopBlock(loopLabel);
            markLabel(loopLabel);
            emitBreakWhenFalse(endLabel, ts3.visitNode(node.expression, visitor, ts3.isExpression));
            transformAndEmitEmbeddedStatement(node.statement);
            emitBreak(loopLabel);
            endLoopBlock();
          } else {
            emitStatement(ts3.visitNode(node, visitor, ts3.isStatement));
          }
        }
        function visitWhileStatement(node) {
          if (inStatementContainingYield) {
            beginScriptLoopBlock();
            node = ts3.visitEachChild(node, visitor, context);
            endLoopBlock();
            return node;
          } else {
            return ts3.visitEachChild(node, visitor, context);
          }
        }
        function transformAndEmitForStatement(node) {
          if (containsYield(node)) {
            var conditionLabel = defineLabel();
            var incrementLabel = defineLabel();
            var endLabel = beginLoopBlock(incrementLabel);
            if (node.initializer) {
              var initializer = node.initializer;
              if (ts3.isVariableDeclarationList(initializer)) {
                transformAndEmitVariableDeclarationList(initializer);
              } else {
                emitStatement(ts3.setTextRange(factory.createExpressionStatement(ts3.visitNode(initializer, visitor, ts3.isExpression)), initializer));
              }
            }
            markLabel(conditionLabel);
            if (node.condition) {
              emitBreakWhenFalse(endLabel, ts3.visitNode(node.condition, visitor, ts3.isExpression));
            }
            transformAndEmitEmbeddedStatement(node.statement);
            markLabel(incrementLabel);
            if (node.incrementor) {
              emitStatement(ts3.setTextRange(factory.createExpressionStatement(ts3.visitNode(node.incrementor, visitor, ts3.isExpression)), node.incrementor));
            }
            emitBreak(conditionLabel);
            endLoopBlock();
          } else {
            emitStatement(ts3.visitNode(node, visitor, ts3.isStatement));
          }
        }
        function visitForStatement(node) {
          if (inStatementContainingYield) {
            beginScriptLoopBlock();
          }
          var initializer = node.initializer;
          if (initializer && ts3.isVariableDeclarationList(initializer)) {
            for (var _i = 0, _a2 = initializer.declarations; _i < _a2.length; _i++) {
              var variable = _a2[_i];
              hoistVariableDeclaration(variable.name);
            }
            var variables = ts3.getInitializedVariables(initializer);
            node = factory.updateForStatement(node, variables.length > 0 ? factory.inlineExpressions(ts3.map(variables, transformInitializedVariable)) : void 0, ts3.visitNode(node.condition, visitor, ts3.isExpression), ts3.visitNode(node.incrementor, visitor, ts3.isExpression), ts3.visitIterationBody(node.statement, visitor, context));
          } else {
            node = ts3.visitEachChild(node, visitor, context);
          }
          if (inStatementContainingYield) {
            endLoopBlock();
          }
          return node;
        }
        function transformAndEmitForInStatement(node) {
          if (containsYield(node)) {
            var keysArray = declareLocal();
            var key2 = declareLocal();
            var keysIndex = factory.createLoopVariable();
            var initializer = node.initializer;
            hoistVariableDeclaration(keysIndex);
            emitAssignment(keysArray, factory.createArrayLiteralExpression());
            emitStatement(factory.createForInStatement(key2, ts3.visitNode(node.expression, visitor, ts3.isExpression), factory.createExpressionStatement(factory.createCallExpression(factory.createPropertyAccessExpression(keysArray, "push"), void 0, [key2]))));
            emitAssignment(keysIndex, factory.createNumericLiteral(0));
            var conditionLabel = defineLabel();
            var incrementLabel = defineLabel();
            var endLabel = beginLoopBlock(incrementLabel);
            markLabel(conditionLabel);
            emitBreakWhenFalse(endLabel, factory.createLessThan(keysIndex, factory.createPropertyAccessExpression(keysArray, "length")));
            var variable = void 0;
            if (ts3.isVariableDeclarationList(initializer)) {
              for (var _i = 0, _a2 = initializer.declarations; _i < _a2.length; _i++) {
                var variable_1 = _a2[_i];
                hoistVariableDeclaration(variable_1.name);
              }
              variable = factory.cloneNode(initializer.declarations[0].name);
            } else {
              variable = ts3.visitNode(initializer, visitor, ts3.isExpression);
              ts3.Debug.assert(ts3.isLeftHandSideExpression(variable));
            }
            emitAssignment(variable, factory.createElementAccessExpression(keysArray, keysIndex));
            transformAndEmitEmbeddedStatement(node.statement);
            markLabel(incrementLabel);
            emitStatement(factory.createExpressionStatement(factory.createPostfixIncrement(keysIndex)));
            emitBreak(conditionLabel);
            endLoopBlock();
          } else {
            emitStatement(ts3.visitNode(node, visitor, ts3.isStatement));
          }
        }
        function visitForInStatement(node) {
          if (inStatementContainingYield) {
            beginScriptLoopBlock();
          }
          var initializer = node.initializer;
          if (ts3.isVariableDeclarationList(initializer)) {
            for (var _i = 0, _a2 = initializer.declarations; _i < _a2.length; _i++) {
              var variable = _a2[_i];
              hoistVariableDeclaration(variable.name);
            }
            node = factory.updateForInStatement(node, initializer.declarations[0].name, ts3.visitNode(node.expression, visitor, ts3.isExpression), ts3.visitNode(node.statement, visitor, ts3.isStatement, factory.liftToBlock));
          } else {
            node = ts3.visitEachChild(node, visitor, context);
          }
          if (inStatementContainingYield) {
            endLoopBlock();
          }
          return node;
        }
        function transformAndEmitContinueStatement(node) {
          var label = findContinueTarget(node.label ? ts3.idText(node.label) : void 0);
          if (label > 0) {
            emitBreak(label, node);
          } else {
            emitStatement(node);
          }
        }
        function visitContinueStatement(node) {
          if (inStatementContainingYield) {
            var label = findContinueTarget(node.label && ts3.idText(node.label));
            if (label > 0) {
              return createInlineBreak(label, node);
            }
          }
          return ts3.visitEachChild(node, visitor, context);
        }
        function transformAndEmitBreakStatement(node) {
          var label = findBreakTarget(node.label ? ts3.idText(node.label) : void 0);
          if (label > 0) {
            emitBreak(label, node);
          } else {
            emitStatement(node);
          }
        }
        function visitBreakStatement(node) {
          if (inStatementContainingYield) {
            var label = findBreakTarget(node.label && ts3.idText(node.label));
            if (label > 0) {
              return createInlineBreak(label, node);
            }
          }
          return ts3.visitEachChild(node, visitor, context);
        }
        function transformAndEmitReturnStatement(node) {
          emitReturn(ts3.visitNode(node.expression, visitor, ts3.isExpression), node);
        }
        function visitReturnStatement(node) {
          return createInlineReturn(ts3.visitNode(node.expression, visitor, ts3.isExpression), node);
        }
        function transformAndEmitWithStatement(node) {
          if (containsYield(node)) {
            beginWithBlock(cacheExpression(ts3.visitNode(node.expression, visitor, ts3.isExpression)));
            transformAndEmitEmbeddedStatement(node.statement);
            endWithBlock();
          } else {
            emitStatement(ts3.visitNode(node, visitor, ts3.isStatement));
          }
        }
        function transformAndEmitSwitchStatement(node) {
          if (containsYield(node.caseBlock)) {
            var caseBlock = node.caseBlock;
            var numClauses = caseBlock.clauses.length;
            var endLabel = beginSwitchBlock();
            var expression = cacheExpression(ts3.visitNode(node.expression, visitor, ts3.isExpression));
            var clauseLabels = [];
            var defaultClauseIndex = -1;
            for (var i3 = 0; i3 < numClauses; i3++) {
              var clause = caseBlock.clauses[i3];
              clauseLabels.push(defineLabel());
              if (clause.kind === 286 && defaultClauseIndex === -1) {
                defaultClauseIndex = i3;
              }
            }
            var clausesWritten = 0;
            var pendingClauses = [];
            while (clausesWritten < numClauses) {
              var defaultClausesSkipped = 0;
              for (var i3 = clausesWritten; i3 < numClauses; i3++) {
                var clause = caseBlock.clauses[i3];
                if (clause.kind === 285) {
                  if (containsYield(clause.expression) && pendingClauses.length > 0) {
                    break;
                  }
                  pendingClauses.push(factory.createCaseClause(ts3.visitNode(clause.expression, visitor, ts3.isExpression), [
                    createInlineBreak(clauseLabels[i3], clause.expression)
                  ]));
                } else {
                  defaultClausesSkipped++;
                }
              }
              if (pendingClauses.length) {
                emitStatement(factory.createSwitchStatement(expression, factory.createCaseBlock(pendingClauses)));
                clausesWritten += pendingClauses.length;
                pendingClauses = [];
              }
              if (defaultClausesSkipped > 0) {
                clausesWritten += defaultClausesSkipped;
                defaultClausesSkipped = 0;
              }
            }
            if (defaultClauseIndex >= 0) {
              emitBreak(clauseLabels[defaultClauseIndex]);
            } else {
              emitBreak(endLabel);
            }
            for (var i3 = 0; i3 < numClauses; i3++) {
              markLabel(clauseLabels[i3]);
              transformAndEmitStatements(caseBlock.clauses[i3].statements);
            }
            endSwitchBlock();
          } else {
            emitStatement(ts3.visitNode(node, visitor, ts3.isStatement));
          }
        }
        function visitSwitchStatement(node) {
          if (inStatementContainingYield) {
            beginScriptSwitchBlock();
          }
          node = ts3.visitEachChild(node, visitor, context);
          if (inStatementContainingYield) {
            endSwitchBlock();
          }
          return node;
        }
        function transformAndEmitLabeledStatement(node) {
          if (containsYield(node)) {
            beginLabeledBlock(ts3.idText(node.label));
            transformAndEmitEmbeddedStatement(node.statement);
            endLabeledBlock();
          } else {
            emitStatement(ts3.visitNode(node, visitor, ts3.isStatement));
          }
        }
        function visitLabeledStatement(node) {
          if (inStatementContainingYield) {
            beginScriptLabeledBlock(ts3.idText(node.label));
          }
          node = ts3.visitEachChild(node, visitor, context);
          if (inStatementContainingYield) {
            endLabeledBlock();
          }
          return node;
        }
        function transformAndEmitThrowStatement(node) {
          var _a2;
          emitThrow(ts3.visitNode((_a2 = node.expression) !== null && _a2 !== void 0 ? _a2 : factory.createVoidZero(), visitor, ts3.isExpression), node);
        }
        function transformAndEmitTryStatement(node) {
          if (containsYield(node)) {
            beginExceptionBlock();
            transformAndEmitEmbeddedStatement(node.tryBlock);
            if (node.catchClause) {
              beginCatchBlock(node.catchClause.variableDeclaration);
              transformAndEmitEmbeddedStatement(node.catchClause.block);
            }
            if (node.finallyBlock) {
              beginFinallyBlock();
              transformAndEmitEmbeddedStatement(node.finallyBlock);
            }
            endExceptionBlock();
          } else {
            emitStatement(ts3.visitEachChild(node, visitor, context));
          }
        }
        function containsYield(node) {
          return !!node && (node.transformFlags & 524288) !== 0;
        }
        function countInitialNodesWithoutYield(nodes) {
          var numNodes = nodes.length;
          for (var i3 = 0; i3 < numNodes; i3++) {
            if (containsYield(nodes[i3])) {
              return i3;
            }
          }
          return -1;
        }
        function onSubstituteNode(hint, node) {
          node = previousOnSubstituteNode(hint, node);
          if (hint === 1) {
            return substituteExpression(node);
          }
          return node;
        }
        function substituteExpression(node) {
          if (ts3.isIdentifier(node)) {
            return substituteExpressionIdentifier(node);
          }
          return node;
        }
        function substituteExpressionIdentifier(node) {
          if (!ts3.isGeneratedIdentifier(node) && renamedCatchVariables && renamedCatchVariables.has(ts3.idText(node))) {
            var original = ts3.getOriginalNode(node);
            if (ts3.isIdentifier(original) && original.parent) {
              var declaration = resolver.getReferencedValueDeclaration(original);
              if (declaration) {
                var name = renamedCatchVariableDeclarations[ts3.getOriginalNodeId(declaration)];
                if (name) {
                  var clone_6 = ts3.setParent(ts3.setTextRange(factory.cloneNode(name), name), name.parent);
                  ts3.setSourceMapRange(clone_6, node);
                  ts3.setCommentRange(clone_6, node);
                  return clone_6;
                }
              }
            }
          }
          return node;
        }
        function cacheExpression(node) {
          if (ts3.isGeneratedIdentifier(node) || ts3.getEmitFlags(node) & 4096) {
            return node;
          }
          var temp = factory.createTempVariable(hoistVariableDeclaration);
          emitAssignment(temp, node, node);
          return temp;
        }
        function declareLocal(name) {
          var temp = name ? factory.createUniqueName(name) : factory.createTempVariable(void 0);
          hoistVariableDeclaration(temp);
          return temp;
        }
        function defineLabel() {
          if (!labelOffsets) {
            labelOffsets = [];
          }
          var label = nextLabelId;
          nextLabelId++;
          labelOffsets[label] = -1;
          return label;
        }
        function markLabel(label) {
          ts3.Debug.assert(labelOffsets !== void 0, "No labels were defined.");
          labelOffsets[label] = operations ? operations.length : 0;
        }
        function beginBlock(block) {
          if (!blocks) {
            blocks = [];
            blockActions = [];
            blockOffsets = [];
            blockStack = [];
          }
          var index = blockActions.length;
          blockActions[index] = 0;
          blockOffsets[index] = operations ? operations.length : 0;
          blocks[index] = block;
          blockStack.push(block);
          return index;
        }
        function endBlock() {
          var block = peekBlock();
          if (block === void 0)
            return ts3.Debug.fail("beginBlock was never called.");
          var index = blockActions.length;
          blockActions[index] = 1;
          blockOffsets[index] = operations ? operations.length : 0;
          blocks[index] = block;
          blockStack.pop();
          return block;
        }
        function peekBlock() {
          return ts3.lastOrUndefined(blockStack);
        }
        function peekBlockKind() {
          var block = peekBlock();
          return block && block.kind;
        }
        function beginWithBlock(expression) {
          var startLabel = defineLabel();
          var endLabel = defineLabel();
          markLabel(startLabel);
          beginBlock({
            kind: 1,
            expression,
            startLabel,
            endLabel
          });
        }
        function endWithBlock() {
          ts3.Debug.assert(peekBlockKind() === 1);
          var block = endBlock();
          markLabel(block.endLabel);
        }
        function beginExceptionBlock() {
          var startLabel = defineLabel();
          var endLabel = defineLabel();
          markLabel(startLabel);
          beginBlock({
            kind: 0,
            state: 0,
            startLabel,
            endLabel
          });
          emitNop();
          return endLabel;
        }
        function beginCatchBlock(variable) {
          ts3.Debug.assert(peekBlockKind() === 0);
          var name;
          if (ts3.isGeneratedIdentifier(variable.name)) {
            name = variable.name;
            hoistVariableDeclaration(variable.name);
          } else {
            var text = ts3.idText(variable.name);
            name = declareLocal(text);
            if (!renamedCatchVariables) {
              renamedCatchVariables = new ts3.Map();
              renamedCatchVariableDeclarations = [];
              context.enableSubstitution(78);
            }
            renamedCatchVariables.set(text, true);
            renamedCatchVariableDeclarations[ts3.getOriginalNodeId(variable)] = name;
          }
          var exception2 = peekBlock();
          ts3.Debug.assert(exception2.state < 1);
          var endLabel = exception2.endLabel;
          emitBreak(endLabel);
          var catchLabel = defineLabel();
          markLabel(catchLabel);
          exception2.state = 1;
          exception2.catchVariable = name;
          exception2.catchLabel = catchLabel;
          emitAssignment(name, factory.createCallExpression(factory.createPropertyAccessExpression(state, "sent"), void 0, []));
          emitNop();
        }
        function beginFinallyBlock() {
          ts3.Debug.assert(peekBlockKind() === 0);
          var exception2 = peekBlock();
          ts3.Debug.assert(exception2.state < 2);
          var endLabel = exception2.endLabel;
          emitBreak(endLabel);
          var finallyLabel = defineLabel();
          markLabel(finallyLabel);
          exception2.state = 2;
          exception2.finallyLabel = finallyLabel;
        }
        function endExceptionBlock() {
          ts3.Debug.assert(peekBlockKind() === 0);
          var exception2 = endBlock();
          var state2 = exception2.state;
          if (state2 < 2) {
            emitBreak(exception2.endLabel);
          } else {
            emitEndfinally();
          }
          markLabel(exception2.endLabel);
          emitNop();
          exception2.state = 3;
        }
        function beginScriptLoopBlock() {
          beginBlock({
            kind: 3,
            isScript: true,
            breakLabel: -1,
            continueLabel: -1
          });
        }
        function beginLoopBlock(continueLabel) {
          var breakLabel = defineLabel();
          beginBlock({
            kind: 3,
            isScript: false,
            breakLabel,
            continueLabel
          });
          return breakLabel;
        }
        function endLoopBlock() {
          ts3.Debug.assert(peekBlockKind() === 3);
          var block = endBlock();
          var breakLabel = block.breakLabel;
          if (!block.isScript) {
            markLabel(breakLabel);
          }
        }
        function beginScriptSwitchBlock() {
          beginBlock({
            kind: 2,
            isScript: true,
            breakLabel: -1
          });
        }
        function beginSwitchBlock() {
          var breakLabel = defineLabel();
          beginBlock({
            kind: 2,
            isScript: false,
            breakLabel
          });
          return breakLabel;
        }
        function endSwitchBlock() {
          ts3.Debug.assert(peekBlockKind() === 2);
          var block = endBlock();
          var breakLabel = block.breakLabel;
          if (!block.isScript) {
            markLabel(breakLabel);
          }
        }
        function beginScriptLabeledBlock(labelText) {
          beginBlock({
            kind: 4,
            isScript: true,
            labelText,
            breakLabel: -1
          });
        }
        function beginLabeledBlock(labelText) {
          var breakLabel = defineLabel();
          beginBlock({
            kind: 4,
            isScript: false,
            labelText,
            breakLabel
          });
        }
        function endLabeledBlock() {
          ts3.Debug.assert(peekBlockKind() === 4);
          var block = endBlock();
          if (!block.isScript) {
            markLabel(block.breakLabel);
          }
        }
        function supportsUnlabeledBreak(block) {
          return block.kind === 2 || block.kind === 3;
        }
        function supportsLabeledBreakOrContinue(block) {
          return block.kind === 4;
        }
        function supportsUnlabeledContinue(block) {
          return block.kind === 3;
        }
        function hasImmediateContainingLabeledBlock(labelText, start) {
          for (var j = start; j >= 0; j--) {
            var containingBlock = blockStack[j];
            if (supportsLabeledBreakOrContinue(containingBlock)) {
              if (containingBlock.labelText === labelText) {
                return true;
              }
            } else {
              break;
            }
          }
          return false;
        }
        function findBreakTarget(labelText) {
          if (blockStack) {
            if (labelText) {
              for (var i3 = blockStack.length - 1; i3 >= 0; i3--) {
                var block = blockStack[i3];
                if (supportsLabeledBreakOrContinue(block) && block.labelText === labelText) {
                  return block.breakLabel;
                } else if (supportsUnlabeledBreak(block) && hasImmediateContainingLabeledBlock(labelText, i3 - 1)) {
                  return block.breakLabel;
                }
              }
            } else {
              for (var i3 = blockStack.length - 1; i3 >= 0; i3--) {
                var block = blockStack[i3];
                if (supportsUnlabeledBreak(block)) {
                  return block.breakLabel;
                }
              }
            }
          }
          return 0;
        }
        function findContinueTarget(labelText) {
          if (blockStack) {
            if (labelText) {
              for (var i3 = blockStack.length - 1; i3 >= 0; i3--) {
                var block = blockStack[i3];
                if (supportsUnlabeledContinue(block) && hasImmediateContainingLabeledBlock(labelText, i3 - 1)) {
                  return block.continueLabel;
                }
              }
            } else {
              for (var i3 = blockStack.length - 1; i3 >= 0; i3--) {
                var block = blockStack[i3];
                if (supportsUnlabeledContinue(block)) {
                  return block.continueLabel;
                }
              }
            }
          }
          return 0;
        }
        function createLabel(label) {
          if (label !== void 0 && label > 0) {
            if (labelExpressions === void 0) {
              labelExpressions = [];
            }
            var expression = factory.createNumericLiteral(-1);
            if (labelExpressions[label] === void 0) {
              labelExpressions[label] = [expression];
            } else {
              labelExpressions[label].push(expression);
            }
            return expression;
          }
          return factory.createOmittedExpression();
        }
        function createInstruction(instruction) {
          var literal = factory.createNumericLiteral(instruction);
          ts3.addSyntheticTrailingComment(literal, 3, getInstructionName(instruction));
          return literal;
        }
        function createInlineBreak(label, location) {
          ts3.Debug.assertLessThan(0, label, "Invalid label");
          return ts3.setTextRange(factory.createReturnStatement(factory.createArrayLiteralExpression([
            createInstruction(3),
            createLabel(label)
          ])), location);
        }
        function createInlineReturn(expression, location) {
          return ts3.setTextRange(factory.createReturnStatement(factory.createArrayLiteralExpression(expression ? [createInstruction(2), expression] : [createInstruction(2)])), location);
        }
        function createGeneratorResume(location) {
          return ts3.setTextRange(factory.createCallExpression(factory.createPropertyAccessExpression(state, "sent"), void 0, []), location);
        }
        function emitNop() {
          emitWorker(0);
        }
        function emitStatement(node) {
          if (node) {
            emitWorker(1, [node]);
          } else {
            emitNop();
          }
        }
        function emitAssignment(left, right, location) {
          emitWorker(2, [left, right], location);
        }
        function emitBreak(label, location) {
          emitWorker(3, [label], location);
        }
        function emitBreakWhenTrue(label, condition, location) {
          emitWorker(4, [label, condition], location);
        }
        function emitBreakWhenFalse(label, condition, location) {
          emitWorker(5, [label, condition], location);
        }
        function emitYieldStar(expression, location) {
          emitWorker(7, [expression], location);
        }
        function emitYield(expression, location) {
          emitWorker(6, [expression], location);
        }
        function emitReturn(expression, location) {
          emitWorker(8, [expression], location);
        }
        function emitThrow(expression, location) {
          emitWorker(9, [expression], location);
        }
        function emitEndfinally() {
          emitWorker(10);
        }
        function emitWorker(code, args, location) {
          if (operations === void 0) {
            operations = [];
            operationArguments = [];
            operationLocations = [];
          }
          if (labelOffsets === void 0) {
            markLabel(defineLabel());
          }
          var operationIndex = operations.length;
          operations[operationIndex] = code;
          operationArguments[operationIndex] = args;
          operationLocations[operationIndex] = location;
        }
        function build() {
          blockIndex = 0;
          labelNumber = 0;
          labelNumbers = void 0;
          lastOperationWasAbrupt = false;
          lastOperationWasCompletion = false;
          clauses = void 0;
          statements = void 0;
          exceptionBlockStack = void 0;
          currentExceptionBlock = void 0;
          withBlockStack = void 0;
          var buildResult = buildStatements();
          return emitHelpers().createGeneratorHelper(ts3.setEmitFlags(factory.createFunctionExpression(void 0, void 0, void 0, void 0, [factory.createParameterDeclaration(void 0, void 0, void 0, state)], void 0, factory.createBlock(buildResult, buildResult.length > 0)), 524288));
        }
        function buildStatements() {
          if (operations) {
            for (var operationIndex = 0; operationIndex < operations.length; operationIndex++) {
              writeOperation(operationIndex);
            }
            flushFinalLabel(operations.length);
          } else {
            flushFinalLabel(0);
          }
          if (clauses) {
            var labelExpression = factory.createPropertyAccessExpression(state, "label");
            var switchStatement = factory.createSwitchStatement(labelExpression, factory.createCaseBlock(clauses));
            return [ts3.startOnNewLine(switchStatement)];
          }
          if (statements) {
            return statements;
          }
          return [];
        }
        function flushLabel() {
          if (!statements) {
            return;
          }
          appendLabel(!lastOperationWasAbrupt);
          lastOperationWasAbrupt = false;
          lastOperationWasCompletion = false;
          labelNumber++;
        }
        function flushFinalLabel(operationIndex) {
          if (isFinalLabelReachable(operationIndex)) {
            tryEnterLabel(operationIndex);
            withBlockStack = void 0;
            writeReturn(void 0, void 0);
          }
          if (statements && clauses) {
            appendLabel(false);
          }
          updateLabelExpressions();
        }
        function isFinalLabelReachable(operationIndex) {
          if (!lastOperationWasCompletion) {
            return true;
          }
          if (!labelOffsets || !labelExpressions) {
            return false;
          }
          for (var label = 0; label < labelOffsets.length; label++) {
            if (labelOffsets[label] === operationIndex && labelExpressions[label]) {
              return true;
            }
          }
          return false;
        }
        function appendLabel(markLabelEnd) {
          if (!clauses) {
            clauses = [];
          }
          if (statements) {
            if (withBlockStack) {
              for (var i3 = withBlockStack.length - 1; i3 >= 0; i3--) {
                var withBlock = withBlockStack[i3];
                statements = [factory.createWithStatement(withBlock.expression, factory.createBlock(statements))];
              }
            }
            if (currentExceptionBlock) {
              var startLabel = currentExceptionBlock.startLabel, catchLabel = currentExceptionBlock.catchLabel, finallyLabel = currentExceptionBlock.finallyLabel, endLabel = currentExceptionBlock.endLabel;
              statements.unshift(factory.createExpressionStatement(factory.createCallExpression(factory.createPropertyAccessExpression(factory.createPropertyAccessExpression(state, "trys"), "push"), void 0, [
                factory.createArrayLiteralExpression([
                  createLabel(startLabel),
                  createLabel(catchLabel),
                  createLabel(finallyLabel),
                  createLabel(endLabel)
                ])
              ])));
              currentExceptionBlock = void 0;
            }
            if (markLabelEnd) {
              statements.push(factory.createExpressionStatement(factory.createAssignment(factory.createPropertyAccessExpression(state, "label"), factory.createNumericLiteral(labelNumber + 1))));
            }
          }
          clauses.push(factory.createCaseClause(factory.createNumericLiteral(labelNumber), statements || []));
          statements = void 0;
        }
        function tryEnterLabel(operationIndex) {
          if (!labelOffsets) {
            return;
          }
          for (var label = 0; label < labelOffsets.length; label++) {
            if (labelOffsets[label] === operationIndex) {
              flushLabel();
              if (labelNumbers === void 0) {
                labelNumbers = [];
              }
              if (labelNumbers[labelNumber] === void 0) {
                labelNumbers[labelNumber] = [label];
              } else {
                labelNumbers[labelNumber].push(label);
              }
            }
          }
        }
        function updateLabelExpressions() {
          if (labelExpressions !== void 0 && labelNumbers !== void 0) {
            for (var labelNumber_1 = 0; labelNumber_1 < labelNumbers.length; labelNumber_1++) {
              var labels = labelNumbers[labelNumber_1];
              if (labels !== void 0) {
                for (var _i = 0, labels_1 = labels; _i < labels_1.length; _i++) {
                  var label = labels_1[_i];
                  var expressions = labelExpressions[label];
                  if (expressions !== void 0) {
                    for (var _a2 = 0, expressions_1 = expressions; _a2 < expressions_1.length; _a2++) {
                      var expression = expressions_1[_a2];
                      expression.text = String(labelNumber_1);
                    }
                  }
                }
              }
            }
          }
        }
        function tryEnterOrLeaveBlock(operationIndex) {
          if (blocks) {
            for (; blockIndex < blockActions.length && blockOffsets[blockIndex] <= operationIndex; blockIndex++) {
              var block = blocks[blockIndex];
              var blockAction = blockActions[blockIndex];
              switch (block.kind) {
                case 0:
                  if (blockAction === 0) {
                    if (!exceptionBlockStack) {
                      exceptionBlockStack = [];
                    }
                    if (!statements) {
                      statements = [];
                    }
                    exceptionBlockStack.push(currentExceptionBlock);
                    currentExceptionBlock = block;
                  } else if (blockAction === 1) {
                    currentExceptionBlock = exceptionBlockStack.pop();
                  }
                  break;
                case 1:
                  if (blockAction === 0) {
                    if (!withBlockStack) {
                      withBlockStack = [];
                    }
                    withBlockStack.push(block);
                  } else if (blockAction === 1) {
                    withBlockStack.pop();
                  }
                  break;
              }
            }
          }
        }
        function writeOperation(operationIndex) {
          tryEnterLabel(operationIndex);
          tryEnterOrLeaveBlock(operationIndex);
          if (lastOperationWasAbrupt) {
            return;
          }
          lastOperationWasAbrupt = false;
          lastOperationWasCompletion = false;
          var opcode = operations[operationIndex];
          if (opcode === 0) {
            return;
          } else if (opcode === 10) {
            return writeEndfinally();
          }
          var args = operationArguments[operationIndex];
          if (opcode === 1) {
            return writeStatement(args[0]);
          }
          var location = operationLocations[operationIndex];
          switch (opcode) {
            case 2:
              return writeAssign(args[0], args[1], location);
            case 3:
              return writeBreak(args[0], location);
            case 4:
              return writeBreakWhenTrue(args[0], args[1], location);
            case 5:
              return writeBreakWhenFalse(args[0], args[1], location);
            case 6:
              return writeYield(args[0], location);
            case 7:
              return writeYieldStar(args[0], location);
            case 8:
              return writeReturn(args[0], location);
            case 9:
              return writeThrow(args[0], location);
          }
        }
        function writeStatement(statement) {
          if (statement) {
            if (!statements) {
              statements = [statement];
            } else {
              statements.push(statement);
            }
          }
        }
        function writeAssign(left, right, operationLocation) {
          writeStatement(ts3.setTextRange(factory.createExpressionStatement(factory.createAssignment(left, right)), operationLocation));
        }
        function writeThrow(expression, operationLocation) {
          lastOperationWasAbrupt = true;
          lastOperationWasCompletion = true;
          writeStatement(ts3.setTextRange(factory.createThrowStatement(expression), operationLocation));
        }
        function writeReturn(expression, operationLocation) {
          lastOperationWasAbrupt = true;
          lastOperationWasCompletion = true;
          writeStatement(ts3.setEmitFlags(ts3.setTextRange(factory.createReturnStatement(factory.createArrayLiteralExpression(expression ? [createInstruction(2), expression] : [createInstruction(2)])), operationLocation), 384));
        }
        function writeBreak(label, operationLocation) {
          lastOperationWasAbrupt = true;
          writeStatement(ts3.setEmitFlags(ts3.setTextRange(factory.createReturnStatement(factory.createArrayLiteralExpression([
            createInstruction(3),
            createLabel(label)
          ])), operationLocation), 384));
        }
        function writeBreakWhenTrue(label, condition, operationLocation) {
          writeStatement(ts3.setEmitFlags(factory.createIfStatement(condition, ts3.setEmitFlags(ts3.setTextRange(factory.createReturnStatement(factory.createArrayLiteralExpression([
            createInstruction(3),
            createLabel(label)
          ])), operationLocation), 384)), 1));
        }
        function writeBreakWhenFalse(label, condition, operationLocation) {
          writeStatement(ts3.setEmitFlags(factory.createIfStatement(factory.createLogicalNot(condition), ts3.setEmitFlags(ts3.setTextRange(factory.createReturnStatement(factory.createArrayLiteralExpression([
            createInstruction(3),
            createLabel(label)
          ])), operationLocation), 384)), 1));
        }
        function writeYield(expression, operationLocation) {
          lastOperationWasAbrupt = true;
          writeStatement(ts3.setEmitFlags(ts3.setTextRange(factory.createReturnStatement(factory.createArrayLiteralExpression(expression ? [createInstruction(4), expression] : [createInstruction(4)])), operationLocation), 384));
        }
        function writeYieldStar(expression, operationLocation) {
          lastOperationWasAbrupt = true;
          writeStatement(ts3.setEmitFlags(ts3.setTextRange(factory.createReturnStatement(factory.createArrayLiteralExpression([
            createInstruction(5),
            expression
          ])), operationLocation), 384));
        }
        function writeEndfinally() {
          lastOperationWasAbrupt = true;
          writeStatement(factory.createReturnStatement(factory.createArrayLiteralExpression([
            createInstruction(7)
          ])));
        }
      }
      ts3.transformGenerators = transformGenerators;
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      function transformModule(context) {
        function getTransformModuleDelegate(moduleKind2) {
          switch (moduleKind2) {
            case ts3.ModuleKind.AMD:
              return transformAMDModule;
            case ts3.ModuleKind.UMD:
              return transformUMDModule;
            default:
              return transformCommonJSModule;
          }
        }
        var factory = context.factory, emitHelpers = context.getEmitHelperFactory, startLexicalEnvironment = context.startLexicalEnvironment, endLexicalEnvironment = context.endLexicalEnvironment, hoistVariableDeclaration = context.hoistVariableDeclaration;
        var compilerOptions = context.getCompilerOptions();
        var resolver = context.getEmitResolver();
        var host = context.getEmitHost();
        var languageVersion = ts3.getEmitScriptTarget(compilerOptions);
        var moduleKind = ts3.getEmitModuleKind(compilerOptions);
        var previousOnSubstituteNode = context.onSubstituteNode;
        var previousOnEmitNode = context.onEmitNode;
        context.onSubstituteNode = onSubstituteNode;
        context.onEmitNode = onEmitNode;
        context.enableSubstitution(78);
        context.enableSubstitution(217);
        context.enableSubstitution(215);
        context.enableSubstitution(216);
        context.enableSubstitution(290);
        context.enableEmitNotification(298);
        var moduleInfoMap = [];
        var deferredExports = [];
        var currentSourceFile;
        var currentModuleInfo;
        var noSubstitution;
        var needUMDDynamicImportHelper;
        return ts3.chainBundle(context, transformSourceFile);
        function transformSourceFile(node) {
          if (node.isDeclarationFile || !(ts3.isEffectiveExternalModule(node, compilerOptions) || node.transformFlags & 4194304 || ts3.isJsonSourceFile(node) && ts3.hasJsonModuleEmitEnabled(compilerOptions) && ts3.outFile(compilerOptions))) {
            return node;
          }
          currentSourceFile = node;
          currentModuleInfo = ts3.collectExternalModuleInfo(context, node, resolver, compilerOptions);
          moduleInfoMap[ts3.getOriginalNodeId(node)] = currentModuleInfo;
          var transformModule2 = getTransformModuleDelegate(moduleKind);
          var updated = transformModule2(node);
          currentSourceFile = void 0;
          currentModuleInfo = void 0;
          needUMDDynamicImportHelper = false;
          return updated;
        }
        function shouldEmitUnderscoreUnderscoreESModule() {
          if (!currentModuleInfo.exportEquals && ts3.isExternalModule(currentSourceFile)) {
            return true;
          }
          return false;
        }
        function transformCommonJSModule(node) {
          startLexicalEnvironment();
          var statements = [];
          var ensureUseStrict = ts3.getStrictOptionValue(compilerOptions, "alwaysStrict") || !compilerOptions.noImplicitUseStrict && ts3.isExternalModule(currentSourceFile);
          var statementOffset = factory.copyPrologue(node.statements, statements, ensureUseStrict && !ts3.isJsonSourceFile(node), sourceElementVisitor);
          if (shouldEmitUnderscoreUnderscoreESModule()) {
            ts3.append(statements, createUnderscoreUnderscoreESModule());
          }
          if (ts3.length(currentModuleInfo.exportedNames)) {
            var chunkSize = 50;
            for (var i3 = 0; i3 < currentModuleInfo.exportedNames.length; i3 += chunkSize) {
              ts3.append(statements, factory.createExpressionStatement(ts3.reduceLeft(currentModuleInfo.exportedNames.slice(i3, i3 + chunkSize), function(prev, nextId) {
                return factory.createAssignment(factory.createPropertyAccessExpression(factory.createIdentifier("exports"), factory.createIdentifier(ts3.idText(nextId))), prev);
              }, factory.createVoidZero())));
            }
          }
          ts3.append(statements, ts3.visitNode(currentModuleInfo.externalHelpersImportDeclaration, sourceElementVisitor, ts3.isStatement));
          ts3.addRange(statements, ts3.visitNodes(node.statements, sourceElementVisitor, ts3.isStatement, statementOffset));
          addExportEqualsIfNeeded(statements, false);
          ts3.insertStatementsAfterStandardPrologue(statements, endLexicalEnvironment());
          var updated = factory.updateSourceFile(node, ts3.setTextRange(factory.createNodeArray(statements), node.statements));
          ts3.addEmitHelpers(updated, context.readEmitHelpers());
          return updated;
        }
        function transformAMDModule(node) {
          var define2 = factory.createIdentifier("define");
          var moduleName = ts3.tryGetModuleNameFromFile(factory, node, host, compilerOptions);
          var jsonSourceFile = ts3.isJsonSourceFile(node) && node;
          var _a2 = collectAsynchronousDependencies(node, true), aliasedModuleNames = _a2.aliasedModuleNames, unaliasedModuleNames = _a2.unaliasedModuleNames, importAliasNames = _a2.importAliasNames;
          var updated = factory.updateSourceFile(node, ts3.setTextRange(factory.createNodeArray([
            factory.createExpressionStatement(factory.createCallExpression(define2, void 0, __spreadArray(__spreadArray([], moduleName ? [moduleName] : []), [
              factory.createArrayLiteralExpression(jsonSourceFile ? ts3.emptyArray : __spreadArray(__spreadArray([
                factory.createStringLiteral("require"),
                factory.createStringLiteral("exports")
              ], aliasedModuleNames), unaliasedModuleNames)),
              jsonSourceFile ? jsonSourceFile.statements.length ? jsonSourceFile.statements[0].expression : factory.createObjectLiteralExpression() : factory.createFunctionExpression(void 0, void 0, void 0, void 0, __spreadArray([
                factory.createParameterDeclaration(void 0, void 0, void 0, "require"),
                factory.createParameterDeclaration(void 0, void 0, void 0, "exports")
              ], importAliasNames), void 0, transformAsynchronousModuleBody(node))
            ])))
          ]), node.statements));
          ts3.addEmitHelpers(updated, context.readEmitHelpers());
          return updated;
        }
        function transformUMDModule(node) {
          var _a2 = collectAsynchronousDependencies(node, false), aliasedModuleNames = _a2.aliasedModuleNames, unaliasedModuleNames = _a2.unaliasedModuleNames, importAliasNames = _a2.importAliasNames;
          var moduleName = ts3.tryGetModuleNameFromFile(factory, node, host, compilerOptions);
          var umdHeader = factory.createFunctionExpression(void 0, void 0, void 0, void 0, [factory.createParameterDeclaration(void 0, void 0, void 0, "factory")], void 0, ts3.setTextRange(factory.createBlock([
            factory.createIfStatement(factory.createLogicalAnd(factory.createTypeCheck(factory.createIdentifier("module"), "object"), factory.createTypeCheck(factory.createPropertyAccessExpression(factory.createIdentifier("module"), "exports"), "object")), factory.createBlock([
              factory.createVariableStatement(void 0, [
                factory.createVariableDeclaration("v", void 0, void 0, factory.createCallExpression(factory.createIdentifier("factory"), void 0, [
                  factory.createIdentifier("require"),
                  factory.createIdentifier("exports")
                ]))
              ]),
              ts3.setEmitFlags(factory.createIfStatement(factory.createStrictInequality(factory.createIdentifier("v"), factory.createIdentifier("undefined")), factory.createExpressionStatement(factory.createAssignment(factory.createPropertyAccessExpression(factory.createIdentifier("module"), "exports"), factory.createIdentifier("v")))), 1)
            ]), factory.createIfStatement(factory.createLogicalAnd(factory.createTypeCheck(factory.createIdentifier("define"), "function"), factory.createPropertyAccessExpression(factory.createIdentifier("define"), "amd")), factory.createBlock([
              factory.createExpressionStatement(factory.createCallExpression(factory.createIdentifier("define"), void 0, __spreadArray(__spreadArray([], moduleName ? [moduleName] : []), [
                factory.createArrayLiteralExpression(__spreadArray(__spreadArray([
                  factory.createStringLiteral("require"),
                  factory.createStringLiteral("exports")
                ], aliasedModuleNames), unaliasedModuleNames)),
                factory.createIdentifier("factory")
              ])))
            ])))
          ], true), void 0));
          var updated = factory.updateSourceFile(node, ts3.setTextRange(factory.createNodeArray([
            factory.createExpressionStatement(factory.createCallExpression(umdHeader, void 0, [
              factory.createFunctionExpression(void 0, void 0, void 0, void 0, __spreadArray([
                factory.createParameterDeclaration(void 0, void 0, void 0, "require"),
                factory.createParameterDeclaration(void 0, void 0, void 0, "exports")
              ], importAliasNames), void 0, transformAsynchronousModuleBody(node))
            ]))
          ]), node.statements));
          ts3.addEmitHelpers(updated, context.readEmitHelpers());
          return updated;
        }
        function collectAsynchronousDependencies(node, includeNonAmdDependencies) {
          var aliasedModuleNames = [];
          var unaliasedModuleNames = [];
          var importAliasNames = [];
          for (var _i = 0, _a2 = node.amdDependencies; _i < _a2.length; _i++) {
            var amdDependency = _a2[_i];
            if (amdDependency.name) {
              aliasedModuleNames.push(factory.createStringLiteral(amdDependency.path));
              importAliasNames.push(factory.createParameterDeclaration(void 0, void 0, void 0, amdDependency.name));
            } else {
              unaliasedModuleNames.push(factory.createStringLiteral(amdDependency.path));
            }
          }
          for (var _b = 0, _c = currentModuleInfo.externalImports; _b < _c.length; _b++) {
            var importNode = _c[_b];
            var externalModuleName = ts3.getExternalModuleNameLiteral(factory, importNode, currentSourceFile, host, resolver, compilerOptions);
            var importAliasName = ts3.getLocalNameForExternalImport(factory, importNode, currentSourceFile);
            if (externalModuleName) {
              if (includeNonAmdDependencies && importAliasName) {
                ts3.setEmitFlags(importAliasName, 4);
                aliasedModuleNames.push(externalModuleName);
                importAliasNames.push(factory.createParameterDeclaration(void 0, void 0, void 0, importAliasName));
              } else {
                unaliasedModuleNames.push(externalModuleName);
              }
            }
          }
          return { aliasedModuleNames, unaliasedModuleNames, importAliasNames };
        }
        function getAMDImportExpressionForImport(node) {
          if (ts3.isImportEqualsDeclaration(node) || ts3.isExportDeclaration(node) || !ts3.getExternalModuleNameLiteral(factory, node, currentSourceFile, host, resolver, compilerOptions)) {
            return void 0;
          }
          var name = ts3.getLocalNameForExternalImport(factory, node, currentSourceFile);
          var expr = getHelperExpressionForImport(node, name);
          if (expr === name) {
            return void 0;
          }
          return factory.createExpressionStatement(factory.createAssignment(name, expr));
        }
        function transformAsynchronousModuleBody(node) {
          startLexicalEnvironment();
          var statements = [];
          var statementOffset = factory.copyPrologue(node.statements, statements, !compilerOptions.noImplicitUseStrict, sourceElementVisitor);
          if (shouldEmitUnderscoreUnderscoreESModule()) {
            ts3.append(statements, createUnderscoreUnderscoreESModule());
          }
          if (ts3.length(currentModuleInfo.exportedNames)) {
            ts3.append(statements, factory.createExpressionStatement(ts3.reduceLeft(currentModuleInfo.exportedNames, function(prev, nextId) {
              return factory.createAssignment(factory.createPropertyAccessExpression(factory.createIdentifier("exports"), factory.createIdentifier(ts3.idText(nextId))), prev);
            }, factory.createVoidZero())));
          }
          ts3.append(statements, ts3.visitNode(currentModuleInfo.externalHelpersImportDeclaration, sourceElementVisitor, ts3.isStatement));
          if (moduleKind === ts3.ModuleKind.AMD) {
            ts3.addRange(statements, ts3.mapDefined(currentModuleInfo.externalImports, getAMDImportExpressionForImport));
          }
          ts3.addRange(statements, ts3.visitNodes(node.statements, sourceElementVisitor, ts3.isStatement, statementOffset));
          addExportEqualsIfNeeded(statements, true);
          ts3.insertStatementsAfterStandardPrologue(statements, endLexicalEnvironment());
          var body = factory.createBlock(statements, true);
          if (needUMDDynamicImportHelper) {
            ts3.addEmitHelper(body, dynamicImportUMDHelper);
          }
          return body;
        }
        function addExportEqualsIfNeeded(statements, emitAsReturn) {
          if (currentModuleInfo.exportEquals) {
            var expressionResult = ts3.visitNode(currentModuleInfo.exportEquals.expression, moduleExpressionElementVisitor);
            if (expressionResult) {
              if (emitAsReturn) {
                var statement = factory.createReturnStatement(expressionResult);
                ts3.setTextRange(statement, currentModuleInfo.exportEquals);
                ts3.setEmitFlags(statement, 384 | 1536);
                statements.push(statement);
              } else {
                var statement = factory.createExpressionStatement(factory.createAssignment(factory.createPropertyAccessExpression(factory.createIdentifier("module"), "exports"), expressionResult));
                ts3.setTextRange(statement, currentModuleInfo.exportEquals);
                ts3.setEmitFlags(statement, 1536);
                statements.push(statement);
              }
            }
          }
        }
        function sourceElementVisitor(node) {
          switch (node.kind) {
            case 262:
              return visitImportDeclaration(node);
            case 261:
              return visitImportEqualsDeclaration(node);
            case 268:
              return visitExportDeclaration(node);
            case 267:
              return visitExportAssignment(node);
            case 233:
              return visitVariableStatement(node);
            case 252:
              return visitFunctionDeclaration(node);
            case 253:
              return visitClassDeclaration(node);
            case 342:
              return visitMergeDeclarationMarker(node);
            case 343:
              return visitEndOfDeclarationMarker(node);
            default:
              return ts3.visitEachChild(node, moduleExpressionElementVisitor, context);
          }
        }
        function moduleExpressionElementVisitor(node) {
          if (!(node.transformFlags & 4194304) && !(node.transformFlags & 2048)) {
            return node;
          }
          if (ts3.isImportCall(node)) {
            return visitImportCallExpression(node);
          } else if (ts3.isDestructuringAssignment(node)) {
            return visitDestructuringAssignment(node);
          } else {
            return ts3.visitEachChild(node, moduleExpressionElementVisitor, context);
          }
        }
        function destructuringNeedsFlattening(node) {
          if (ts3.isObjectLiteralExpression(node)) {
            for (var _i = 0, _a2 = node.properties; _i < _a2.length; _i++) {
              var elem = _a2[_i];
              switch (elem.kind) {
                case 289:
                  if (destructuringNeedsFlattening(elem.initializer)) {
                    return true;
                  }
                  break;
                case 290:
                  if (destructuringNeedsFlattening(elem.name)) {
                    return true;
                  }
                  break;
                case 291:
                  if (destructuringNeedsFlattening(elem.expression)) {
                    return true;
                  }
                  break;
                case 166:
                case 168:
                case 169:
                  return false;
                default:
                  ts3.Debug.assertNever(elem, "Unhandled object member kind");
              }
            }
          } else if (ts3.isArrayLiteralExpression(node)) {
            for (var _b = 0, _c = node.elements; _b < _c.length; _b++) {
              var elem = _c[_b];
              if (ts3.isSpreadElement(elem)) {
                if (destructuringNeedsFlattening(elem.expression)) {
                  return true;
                }
              } else if (destructuringNeedsFlattening(elem)) {
                return true;
              }
            }
          } else if (ts3.isIdentifier(node)) {
            return ts3.length(getExports(node)) > (ts3.isExportName(node) ? 1 : 0);
          }
          return false;
        }
        function visitDestructuringAssignment(node) {
          if (destructuringNeedsFlattening(node.left)) {
            return ts3.flattenDestructuringAssignment(node, moduleExpressionElementVisitor, context, 0, false, createAllExportExpressions);
          }
          return ts3.visitEachChild(node, moduleExpressionElementVisitor, context);
        }
        function visitImportCallExpression(node) {
          var externalModuleName = ts3.getExternalModuleNameLiteral(factory, node, currentSourceFile, host, resolver, compilerOptions);
          var firstArgument = ts3.visitNode(ts3.firstOrUndefined(node.arguments), moduleExpressionElementVisitor);
          var argument = externalModuleName && (!firstArgument || !ts3.isStringLiteral(firstArgument) || firstArgument.text !== externalModuleName.text) ? externalModuleName : firstArgument;
          var containsLexicalThis = !!(node.transformFlags & 8192);
          switch (compilerOptions.module) {
            case ts3.ModuleKind.AMD:
              return createImportCallExpressionAMD(argument, containsLexicalThis);
            case ts3.ModuleKind.UMD:
              return createImportCallExpressionUMD(argument !== null && argument !== void 0 ? argument : factory.createVoidZero(), containsLexicalThis);
            case ts3.ModuleKind.CommonJS:
            default:
              return createImportCallExpressionCommonJS(argument, containsLexicalThis);
          }
        }
        function createImportCallExpressionUMD(arg2, containsLexicalThis) {
          needUMDDynamicImportHelper = true;
          if (ts3.isSimpleCopiableExpression(arg2)) {
            var argClone = ts3.isGeneratedIdentifier(arg2) ? arg2 : ts3.isStringLiteral(arg2) ? factory.createStringLiteralFromNode(arg2) : ts3.setEmitFlags(ts3.setTextRange(factory.cloneNode(arg2), arg2), 1536);
            return factory.createConditionalExpression(factory.createIdentifier("__syncRequire"), void 0, createImportCallExpressionCommonJS(arg2, containsLexicalThis), void 0, createImportCallExpressionAMD(argClone, containsLexicalThis));
          } else {
            var temp = factory.createTempVariable(hoistVariableDeclaration);
            return factory.createComma(factory.createAssignment(temp, arg2), factory.createConditionalExpression(factory.createIdentifier("__syncRequire"), void 0, createImportCallExpressionCommonJS(temp, containsLexicalThis), void 0, createImportCallExpressionAMD(temp, containsLexicalThis)));
          }
        }
        function createImportCallExpressionAMD(arg2, containsLexicalThis) {
          var resolve = factory.createUniqueName("resolve");
          var reject = factory.createUniqueName("reject");
          var parameters = [
            factory.createParameterDeclaration(void 0, void 0, void 0, resolve),
            factory.createParameterDeclaration(void 0, void 0, void 0, reject)
          ];
          var body = factory.createBlock([
            factory.createExpressionStatement(factory.createCallExpression(factory.createIdentifier("require"), void 0, [factory.createArrayLiteralExpression([arg2 || factory.createOmittedExpression()]), resolve, reject]))
          ]);
          var func2;
          if (languageVersion >= 2) {
            func2 = factory.createArrowFunction(void 0, void 0, parameters, void 0, void 0, body);
          } else {
            func2 = factory.createFunctionExpression(void 0, void 0, void 0, void 0, parameters, void 0, body);
            if (containsLexicalThis) {
              ts3.setEmitFlags(func2, 8);
            }
          }
          var promise = factory.createNewExpression(factory.createIdentifier("Promise"), void 0, [func2]);
          if (compilerOptions.esModuleInterop) {
            return factory.createCallExpression(factory.createPropertyAccessExpression(promise, factory.createIdentifier("then")), void 0, [emitHelpers().createImportStarCallbackHelper()]);
          }
          return promise;
        }
        function createImportCallExpressionCommonJS(arg2, containsLexicalThis) {
          var promiseResolveCall = factory.createCallExpression(factory.createPropertyAccessExpression(factory.createIdentifier("Promise"), "resolve"), void 0, []);
          var requireCall = factory.createCallExpression(factory.createIdentifier("require"), void 0, arg2 ? [arg2] : []);
          if (compilerOptions.esModuleInterop) {
            requireCall = emitHelpers().createImportStarHelper(requireCall);
          }
          var func2;
          if (languageVersion >= 2) {
            func2 = factory.createArrowFunction(void 0, void 0, [], void 0, void 0, requireCall);
          } else {
            func2 = factory.createFunctionExpression(void 0, void 0, void 0, void 0, [], void 0, factory.createBlock([factory.createReturnStatement(requireCall)]));
            if (containsLexicalThis) {
              ts3.setEmitFlags(func2, 8);
            }
          }
          return factory.createCallExpression(factory.createPropertyAccessExpression(promiseResolveCall, "then"), void 0, [func2]);
        }
        function getHelperExpressionForExport(node, innerExpr) {
          if (!compilerOptions.esModuleInterop || ts3.getEmitFlags(node) & 67108864) {
            return innerExpr;
          }
          if (ts3.getExportNeedsImportStarHelper(node)) {
            return emitHelpers().createImportStarHelper(innerExpr);
          }
          return innerExpr;
        }
        function getHelperExpressionForImport(node, innerExpr) {
          if (!compilerOptions.esModuleInterop || ts3.getEmitFlags(node) & 67108864) {
            return innerExpr;
          }
          if (ts3.getImportNeedsImportStarHelper(node)) {
            return emitHelpers().createImportStarHelper(innerExpr);
          }
          if (ts3.getImportNeedsImportDefaultHelper(node)) {
            return emitHelpers().createImportDefaultHelper(innerExpr);
          }
          return innerExpr;
        }
        function visitImportDeclaration(node) {
          var statements;
          var namespaceDeclaration = ts3.getNamespaceDeclarationNode(node);
          if (moduleKind !== ts3.ModuleKind.AMD) {
            if (!node.importClause) {
              return ts3.setOriginalNode(ts3.setTextRange(factory.createExpressionStatement(createRequireCall(node)), node), node);
            } else {
              var variables = [];
              if (namespaceDeclaration && !ts3.isDefaultImport(node)) {
                variables.push(factory.createVariableDeclaration(factory.cloneNode(namespaceDeclaration.name), void 0, void 0, getHelperExpressionForImport(node, createRequireCall(node))));
              } else {
                variables.push(factory.createVariableDeclaration(factory.getGeneratedNameForNode(node), void 0, void 0, getHelperExpressionForImport(node, createRequireCall(node))));
                if (namespaceDeclaration && ts3.isDefaultImport(node)) {
                  variables.push(factory.createVariableDeclaration(factory.cloneNode(namespaceDeclaration.name), void 0, void 0, factory.getGeneratedNameForNode(node)));
                }
              }
              statements = ts3.append(statements, ts3.setOriginalNode(ts3.setTextRange(factory.createVariableStatement(void 0, factory.createVariableDeclarationList(variables, languageVersion >= 2 ? 2 : 0)), node), node));
            }
          } else if (namespaceDeclaration && ts3.isDefaultImport(node)) {
            statements = ts3.append(statements, factory.createVariableStatement(void 0, factory.createVariableDeclarationList([
              ts3.setOriginalNode(ts3.setTextRange(factory.createVariableDeclaration(factory.cloneNode(namespaceDeclaration.name), void 0, void 0, factory.getGeneratedNameForNode(node)), node), node)
            ], languageVersion >= 2 ? 2 : 0)));
          }
          if (hasAssociatedEndOfDeclarationMarker(node)) {
            var id = ts3.getOriginalNodeId(node);
            deferredExports[id] = appendExportsOfImportDeclaration(deferredExports[id], node);
          } else {
            statements = appendExportsOfImportDeclaration(statements, node);
          }
          return ts3.singleOrMany(statements);
        }
        function createRequireCall(importNode) {
          var moduleName = ts3.getExternalModuleNameLiteral(factory, importNode, currentSourceFile, host, resolver, compilerOptions);
          var args = [];
          if (moduleName) {
            args.push(moduleName);
          }
          return factory.createCallExpression(factory.createIdentifier("require"), void 0, args);
        }
        function visitImportEqualsDeclaration(node) {
          ts3.Debug.assert(ts3.isExternalModuleImportEqualsDeclaration(node), "import= for internal module references should be handled in an earlier transformer.");
          var statements;
          if (moduleKind !== ts3.ModuleKind.AMD) {
            if (ts3.hasSyntacticModifier(node, 1)) {
              statements = ts3.append(statements, ts3.setOriginalNode(ts3.setTextRange(factory.createExpressionStatement(createExportExpression(node.name, createRequireCall(node))), node), node));
            } else {
              statements = ts3.append(statements, ts3.setOriginalNode(ts3.setTextRange(factory.createVariableStatement(void 0, factory.createVariableDeclarationList([
                factory.createVariableDeclaration(factory.cloneNode(node.name), void 0, void 0, createRequireCall(node))
              ], languageVersion >= 2 ? 2 : 0)), node), node));
            }
          } else {
            if (ts3.hasSyntacticModifier(node, 1)) {
              statements = ts3.append(statements, ts3.setOriginalNode(ts3.setTextRange(factory.createExpressionStatement(createExportExpression(factory.getExportName(node), factory.getLocalName(node))), node), node));
            }
          }
          if (hasAssociatedEndOfDeclarationMarker(node)) {
            var id = ts3.getOriginalNodeId(node);
            deferredExports[id] = appendExportsOfImportEqualsDeclaration(deferredExports[id], node);
          } else {
            statements = appendExportsOfImportEqualsDeclaration(statements, node);
          }
          return ts3.singleOrMany(statements);
        }
        function visitExportDeclaration(node) {
          if (!node.moduleSpecifier) {
            return void 0;
          }
          var generatedName = factory.getGeneratedNameForNode(node);
          if (node.exportClause && ts3.isNamedExports(node.exportClause)) {
            var statements = [];
            if (moduleKind !== ts3.ModuleKind.AMD) {
              statements.push(ts3.setOriginalNode(ts3.setTextRange(factory.createVariableStatement(void 0, factory.createVariableDeclarationList([
                factory.createVariableDeclaration(generatedName, void 0, void 0, createRequireCall(node))
              ])), node), node));
            }
            for (var _i = 0, _a2 = node.exportClause.elements; _i < _a2.length; _i++) {
              var specifier = _a2[_i];
              if (languageVersion === 0) {
                statements.push(ts3.setOriginalNode(ts3.setTextRange(factory.createExpressionStatement(emitHelpers().createCreateBindingHelper(generatedName, factory.createStringLiteralFromNode(specifier.propertyName || specifier.name), specifier.propertyName ? factory.createStringLiteralFromNode(specifier.name) : void 0)), specifier), specifier));
              } else {
                var exportNeedsImportDefault = !!compilerOptions.esModuleInterop && !(ts3.getEmitFlags(node) & 67108864) && ts3.idText(specifier.propertyName || specifier.name) === "default";
                var exportedValue = factory.createPropertyAccessExpression(exportNeedsImportDefault ? emitHelpers().createImportDefaultHelper(generatedName) : generatedName, specifier.propertyName || specifier.name);
                statements.push(ts3.setOriginalNode(ts3.setTextRange(factory.createExpressionStatement(createExportExpression(factory.getExportName(specifier), exportedValue, void 0, true)), specifier), specifier));
              }
            }
            return ts3.singleOrMany(statements);
          } else if (node.exportClause) {
            var statements = [];
            statements.push(ts3.setOriginalNode(ts3.setTextRange(factory.createExpressionStatement(createExportExpression(factory.cloneNode(node.exportClause.name), getHelperExpressionForExport(node, moduleKind !== ts3.ModuleKind.AMD ? createRequireCall(node) : ts3.isExportNamespaceAsDefaultDeclaration(node) ? generatedName : factory.createIdentifier(ts3.idText(node.exportClause.name))))), node), node));
            return ts3.singleOrMany(statements);
          } else {
            return ts3.setOriginalNode(ts3.setTextRange(factory.createExpressionStatement(emitHelpers().createExportStarHelper(moduleKind !== ts3.ModuleKind.AMD ? createRequireCall(node) : generatedName)), node), node);
          }
        }
        function visitExportAssignment(node) {
          if (node.isExportEquals) {
            return void 0;
          }
          var statements;
          var original = node.original;
          if (original && hasAssociatedEndOfDeclarationMarker(original)) {
            var id = ts3.getOriginalNodeId(node);
            deferredExports[id] = appendExportStatement(deferredExports[id], factory.createIdentifier("default"), ts3.visitNode(node.expression, moduleExpressionElementVisitor), node, true);
          } else {
            statements = appendExportStatement(statements, factory.createIdentifier("default"), ts3.visitNode(node.expression, moduleExpressionElementVisitor), node, true);
          }
          return ts3.singleOrMany(statements);
        }
        function visitFunctionDeclaration(node) {
          var statements;
          if (ts3.hasSyntacticModifier(node, 1)) {
            statements = ts3.append(statements, ts3.setOriginalNode(ts3.setTextRange(factory.createFunctionDeclaration(void 0, ts3.visitNodes(node.modifiers, modifierVisitor, ts3.isModifier), node.asteriskToken, factory.getDeclarationName(node, true, true), void 0, ts3.visitNodes(node.parameters, moduleExpressionElementVisitor), void 0, ts3.visitEachChild(node.body, moduleExpressionElementVisitor, context)), node), node));
          } else {
            statements = ts3.append(statements, ts3.visitEachChild(node, moduleExpressionElementVisitor, context));
          }
          if (hasAssociatedEndOfDeclarationMarker(node)) {
            var id = ts3.getOriginalNodeId(node);
            deferredExports[id] = appendExportsOfHoistedDeclaration(deferredExports[id], node);
          } else {
            statements = appendExportsOfHoistedDeclaration(statements, node);
          }
          return ts3.singleOrMany(statements);
        }
        function visitClassDeclaration(node) {
          var statements;
          if (ts3.hasSyntacticModifier(node, 1)) {
            statements = ts3.append(statements, ts3.setOriginalNode(ts3.setTextRange(factory.createClassDeclaration(void 0, ts3.visitNodes(node.modifiers, modifierVisitor, ts3.isModifier), factory.getDeclarationName(node, true, true), void 0, ts3.visitNodes(node.heritageClauses, moduleExpressionElementVisitor), ts3.visitNodes(node.members, moduleExpressionElementVisitor)), node), node));
          } else {
            statements = ts3.append(statements, ts3.visitEachChild(node, moduleExpressionElementVisitor, context));
          }
          if (hasAssociatedEndOfDeclarationMarker(node)) {
            var id = ts3.getOriginalNodeId(node);
            deferredExports[id] = appendExportsOfHoistedDeclaration(deferredExports[id], node);
          } else {
            statements = appendExportsOfHoistedDeclaration(statements, node);
          }
          return ts3.singleOrMany(statements);
        }
        function visitVariableStatement(node) {
          var statements;
          var variables;
          var expressions;
          if (ts3.hasSyntacticModifier(node, 1)) {
            var modifiers = void 0;
            var removeCommentsOnExpressions = false;
            for (var _i = 0, _a2 = node.declarationList.declarations; _i < _a2.length; _i++) {
              var variable = _a2[_i];
              if (ts3.isIdentifier(variable.name) && ts3.isLocalName(variable.name)) {
                if (!modifiers) {
                  modifiers = ts3.visitNodes(node.modifiers, modifierVisitor, ts3.isModifier);
                }
                variables = ts3.append(variables, variable);
              } else if (variable.initializer) {
                if (!ts3.isBindingPattern(variable.name) && (ts3.isArrowFunction(variable.initializer) || ts3.isFunctionExpression(variable.initializer) || ts3.isClassExpression(variable.initializer))) {
                  var expression = factory.createAssignment(ts3.setTextRange(factory.createPropertyAccessExpression(factory.createIdentifier("exports"), variable.name), variable.name), factory.createIdentifier(ts3.getTextOfIdentifierOrLiteral(variable.name)));
                  var updatedVariable = factory.createVariableDeclaration(variable.name, variable.exclamationToken, variable.type, ts3.visitNode(variable.initializer, moduleExpressionElementVisitor));
                  variables = ts3.append(variables, updatedVariable);
                  expressions = ts3.append(expressions, expression);
                  removeCommentsOnExpressions = true;
                } else {
                  expressions = ts3.append(expressions, transformInitializedVariable(variable));
                }
              }
            }
            if (variables) {
              statements = ts3.append(statements, factory.updateVariableStatement(node, modifiers, factory.updateVariableDeclarationList(node.declarationList, variables)));
            }
            if (expressions) {
              var statement = ts3.setOriginalNode(ts3.setTextRange(factory.createExpressionStatement(factory.inlineExpressions(expressions)), node), node);
              if (removeCommentsOnExpressions) {
                ts3.removeAllComments(statement);
              }
              statements = ts3.append(statements, statement);
            }
          } else {
            statements = ts3.append(statements, ts3.visitEachChild(node, moduleExpressionElementVisitor, context));
          }
          if (hasAssociatedEndOfDeclarationMarker(node)) {
            var id = ts3.getOriginalNodeId(node);
            deferredExports[id] = appendExportsOfVariableStatement(deferredExports[id], node);
          } else {
            statements = appendExportsOfVariableStatement(statements, node);
          }
          return ts3.singleOrMany(statements);
        }
        function createAllExportExpressions(name, value, location) {
          var exportedNames = getExports(name);
          if (exportedNames) {
            var expression = ts3.isExportName(name) ? value : factory.createAssignment(name, value);
            for (var _i = 0, exportedNames_1 = exportedNames; _i < exportedNames_1.length; _i++) {
              var exportName = exportedNames_1[_i];
              ts3.setEmitFlags(expression, 4);
              expression = createExportExpression(exportName, expression, location);
            }
            return expression;
          }
          return factory.createAssignment(name, value);
        }
        function transformInitializedVariable(node) {
          if (ts3.isBindingPattern(node.name)) {
            return ts3.flattenDestructuringAssignment(ts3.visitNode(node, moduleExpressionElementVisitor), void 0, context, 0, false, createAllExportExpressions);
          } else {
            return factory.createAssignment(ts3.setTextRange(factory.createPropertyAccessExpression(factory.createIdentifier("exports"), node.name), node.name), node.initializer ? ts3.visitNode(node.initializer, moduleExpressionElementVisitor) : factory.createVoidZero());
          }
        }
        function visitMergeDeclarationMarker(node) {
          if (hasAssociatedEndOfDeclarationMarker(node) && node.original.kind === 233) {
            var id = ts3.getOriginalNodeId(node);
            deferredExports[id] = appendExportsOfVariableStatement(deferredExports[id], node.original);
          }
          return node;
        }
        function hasAssociatedEndOfDeclarationMarker(node) {
          return (ts3.getEmitFlags(node) & 4194304) !== 0;
        }
        function visitEndOfDeclarationMarker(node) {
          var id = ts3.getOriginalNodeId(node);
          var statements = deferredExports[id];
          if (statements) {
            delete deferredExports[id];
            return ts3.append(statements, node);
          }
          return node;
        }
        function appendExportsOfImportDeclaration(statements, decl) {
          if (currentModuleInfo.exportEquals) {
            return statements;
          }
          var importClause = decl.importClause;
          if (!importClause) {
            return statements;
          }
          if (importClause.name) {
            statements = appendExportsOfDeclaration(statements, importClause);
          }
          var namedBindings = importClause.namedBindings;
          if (namedBindings) {
            switch (namedBindings.kind) {
              case 264:
                statements = appendExportsOfDeclaration(statements, namedBindings);
                break;
              case 265:
                for (var _i = 0, _a2 = namedBindings.elements; _i < _a2.length; _i++) {
                  var importBinding = _a2[_i];
                  statements = appendExportsOfDeclaration(statements, importBinding, true);
                }
                break;
            }
          }
          return statements;
        }
        function appendExportsOfImportEqualsDeclaration(statements, decl) {
          if (currentModuleInfo.exportEquals) {
            return statements;
          }
          return appendExportsOfDeclaration(statements, decl);
        }
        function appendExportsOfVariableStatement(statements, node) {
          if (currentModuleInfo.exportEquals) {
            return statements;
          }
          for (var _i = 0, _a2 = node.declarationList.declarations; _i < _a2.length; _i++) {
            var decl = _a2[_i];
            statements = appendExportsOfBindingElement(statements, decl);
          }
          return statements;
        }
        function appendExportsOfBindingElement(statements, decl) {
          if (currentModuleInfo.exportEquals) {
            return statements;
          }
          if (ts3.isBindingPattern(decl.name)) {
            for (var _i = 0, _a2 = decl.name.elements; _i < _a2.length; _i++) {
              var element = _a2[_i];
              if (!ts3.isOmittedExpression(element)) {
                statements = appendExportsOfBindingElement(statements, element);
              }
            }
          } else if (!ts3.isGeneratedIdentifier(decl.name)) {
            statements = appendExportsOfDeclaration(statements, decl);
          }
          return statements;
        }
        function appendExportsOfHoistedDeclaration(statements, decl) {
          if (currentModuleInfo.exportEquals) {
            return statements;
          }
          if (ts3.hasSyntacticModifier(decl, 1)) {
            var exportName = ts3.hasSyntacticModifier(decl, 512) ? factory.createIdentifier("default") : factory.getDeclarationName(decl);
            statements = appendExportStatement(statements, exportName, factory.getLocalName(decl), decl);
          }
          if (decl.name) {
            statements = appendExportsOfDeclaration(statements, decl);
          }
          return statements;
        }
        function appendExportsOfDeclaration(statements, decl, liveBinding) {
          var name = factory.getDeclarationName(decl);
          var exportSpecifiers = currentModuleInfo.exportSpecifiers.get(ts3.idText(name));
          if (exportSpecifiers) {
            for (var _i = 0, exportSpecifiers_1 = exportSpecifiers; _i < exportSpecifiers_1.length; _i++) {
              var exportSpecifier = exportSpecifiers_1[_i];
              statements = appendExportStatement(statements, exportSpecifier.name, name, exportSpecifier.name, void 0, liveBinding);
            }
          }
          return statements;
        }
        function appendExportStatement(statements, exportName, expression, location, allowComments, liveBinding) {
          statements = ts3.append(statements, createExportStatement(exportName, expression, location, allowComments, liveBinding));
          return statements;
        }
        function createUnderscoreUnderscoreESModule() {
          var statement;
          if (languageVersion === 0) {
            statement = factory.createExpressionStatement(createExportExpression(factory.createIdentifier("__esModule"), factory.createTrue()));
          } else {
            statement = factory.createExpressionStatement(factory.createCallExpression(factory.createPropertyAccessExpression(factory.createIdentifier("Object"), "defineProperty"), void 0, [
              factory.createIdentifier("exports"),
              factory.createStringLiteral("__esModule"),
              factory.createObjectLiteralExpression([
                factory.createPropertyAssignment("value", factory.createTrue())
              ])
            ]));
          }
          ts3.setEmitFlags(statement, 1048576);
          return statement;
        }
        function createExportStatement(name, value, location, allowComments, liveBinding) {
          var statement = ts3.setTextRange(factory.createExpressionStatement(createExportExpression(name, value, void 0, liveBinding)), location);
          ts3.startOnNewLine(statement);
          if (!allowComments) {
            ts3.setEmitFlags(statement, 1536);
          }
          return statement;
        }
        function createExportExpression(name, value, location, liveBinding) {
          return ts3.setTextRange(liveBinding && languageVersion !== 0 ? factory.createCallExpression(factory.createPropertyAccessExpression(factory.createIdentifier("Object"), "defineProperty"), void 0, [
            factory.createIdentifier("exports"),
            factory.createStringLiteralFromNode(name),
            factory.createObjectLiteralExpression([
              factory.createPropertyAssignment("enumerable", factory.createTrue()),
              factory.createPropertyAssignment("get", factory.createFunctionExpression(void 0, void 0, void 0, void 0, [], void 0, factory.createBlock([factory.createReturnStatement(value)])))
            ])
          ]) : factory.createAssignment(factory.createPropertyAccessExpression(factory.createIdentifier("exports"), factory.cloneNode(name)), value), location);
        }
        function modifierVisitor(node) {
          switch (node.kind) {
            case 92:
            case 87:
              return void 0;
          }
          return node;
        }
        function onEmitNode(hint, node, emitCallback) {
          if (node.kind === 298) {
            currentSourceFile = node;
            currentModuleInfo = moduleInfoMap[ts3.getOriginalNodeId(currentSourceFile)];
            noSubstitution = [];
            previousOnEmitNode(hint, node, emitCallback);
            currentSourceFile = void 0;
            currentModuleInfo = void 0;
            noSubstitution = void 0;
          } else {
            previousOnEmitNode(hint, node, emitCallback);
          }
        }
        function onSubstituteNode(hint, node) {
          node = previousOnSubstituteNode(hint, node);
          if (node.id && noSubstitution[node.id]) {
            return node;
          }
          if (hint === 1) {
            return substituteExpression(node);
          } else if (ts3.isShorthandPropertyAssignment(node)) {
            return substituteShorthandPropertyAssignment(node);
          }
          return node;
        }
        function substituteShorthandPropertyAssignment(node) {
          var name = node.name;
          var exportedOrImportedName = substituteExpressionIdentifier(name);
          if (exportedOrImportedName !== name) {
            if (node.objectAssignmentInitializer) {
              var initializer = factory.createAssignment(exportedOrImportedName, node.objectAssignmentInitializer);
              return ts3.setTextRange(factory.createPropertyAssignment(name, initializer), node);
            }
            return ts3.setTextRange(factory.createPropertyAssignment(name, exportedOrImportedName), node);
          }
          return node;
        }
        function substituteExpression(node) {
          switch (node.kind) {
            case 78:
              return substituteExpressionIdentifier(node);
            case 217:
              return substituteBinaryExpression(node);
            case 216:
            case 215:
              return substituteUnaryExpression(node);
          }
          return node;
        }
        function substituteExpressionIdentifier(node) {
          var _a2, _b;
          if (ts3.getEmitFlags(node) & 4096) {
            var externalHelpersModuleName = ts3.getExternalHelpersModuleName(currentSourceFile);
            if (externalHelpersModuleName) {
              return factory.createPropertyAccessExpression(externalHelpersModuleName, node);
            }
            return node;
          } else if (!(ts3.isGeneratedIdentifier(node) && !(node.autoGenerateFlags & 64)) && !ts3.isLocalName(node)) {
            var exportContainer = resolver.getReferencedExportContainer(node, ts3.isExportName(node));
            if (exportContainer && exportContainer.kind === 298) {
              return ts3.setTextRange(factory.createPropertyAccessExpression(factory.createIdentifier("exports"), factory.cloneNode(node)), node);
            }
            var importDeclaration = resolver.getReferencedImportDeclaration(node);
            if (importDeclaration) {
              if (ts3.isImportClause(importDeclaration)) {
                return ts3.setTextRange(factory.createPropertyAccessExpression(factory.getGeneratedNameForNode(importDeclaration.parent), factory.createIdentifier("default")), node);
              } else if (ts3.isImportSpecifier(importDeclaration)) {
                var name = importDeclaration.propertyName || importDeclaration.name;
                return ts3.setTextRange(factory.createPropertyAccessExpression(factory.getGeneratedNameForNode(((_b = (_a2 = importDeclaration.parent) === null || _a2 === void 0 ? void 0 : _a2.parent) === null || _b === void 0 ? void 0 : _b.parent) || importDeclaration), factory.cloneNode(name)), node);
              }
            }
          }
          return node;
        }
        function substituteBinaryExpression(node) {
          if (ts3.isAssignmentOperator(node.operatorToken.kind) && ts3.isIdentifier(node.left) && !ts3.isGeneratedIdentifier(node.left) && !ts3.isLocalName(node.left) && !ts3.isDeclarationNameOfEnumOrNamespace(node.left)) {
            var exportedNames = getExports(node.left);
            if (exportedNames) {
              var expression = node;
              for (var _i = 0, exportedNames_2 = exportedNames; _i < exportedNames_2.length; _i++) {
                var exportName = exportedNames_2[_i];
                noSubstitution[ts3.getNodeId(expression)] = true;
                expression = createExportExpression(exportName, expression, node);
              }
              return expression;
            }
          }
          return node;
        }
        function substituteUnaryExpression(node) {
          if ((node.operator === 45 || node.operator === 46) && ts3.isIdentifier(node.operand) && !ts3.isGeneratedIdentifier(node.operand) && !ts3.isLocalName(node.operand) && !ts3.isDeclarationNameOfEnumOrNamespace(node.operand)) {
            var exportedNames = getExports(node.operand);
            if (exportedNames) {
              var expression = node.kind === 216 ? ts3.setTextRange(factory.createPrefixUnaryExpression(node.operator, node.operand), node) : node;
              for (var _i = 0, exportedNames_3 = exportedNames; _i < exportedNames_3.length; _i++) {
                var exportName = exportedNames_3[_i];
                noSubstitution[ts3.getNodeId(expression)] = true;
                expression = createExportExpression(exportName, expression);
              }
              if (node.kind === 216) {
                noSubstitution[ts3.getNodeId(expression)] = true;
                expression = node.operator === 45 ? factory.createSubtract(expression, factory.createNumericLiteral(1)) : factory.createAdd(expression, factory.createNumericLiteral(1));
              }
              return expression;
            }
          }
          return node;
        }
        function getExports(name) {
          if (!ts3.isGeneratedIdentifier(name)) {
            var valueDeclaration = resolver.getReferencedImportDeclaration(name) || resolver.getReferencedValueDeclaration(name);
            if (valueDeclaration) {
              return currentModuleInfo && currentModuleInfo.exportedBindings[ts3.getOriginalNodeId(valueDeclaration)];
            }
          }
        }
      }
      ts3.transformModule = transformModule;
      var dynamicImportUMDHelper = {
        name: "typescript:dynamicimport-sync-require",
        scoped: true,
        text: '\n            var __syncRequire = typeof module === "object" && typeof module.exports === "object";'
      };
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      function transformSystemModule(context) {
        var factory = context.factory, startLexicalEnvironment = context.startLexicalEnvironment, endLexicalEnvironment = context.endLexicalEnvironment, hoistVariableDeclaration = context.hoistVariableDeclaration;
        var compilerOptions = context.getCompilerOptions();
        var resolver = context.getEmitResolver();
        var host = context.getEmitHost();
        var previousOnSubstituteNode = context.onSubstituteNode;
        var previousOnEmitNode = context.onEmitNode;
        context.onSubstituteNode = onSubstituteNode;
        context.onEmitNode = onEmitNode;
        context.enableSubstitution(78);
        context.enableSubstitution(290);
        context.enableSubstitution(217);
        context.enableSubstitution(215);
        context.enableSubstitution(216);
        context.enableSubstitution(227);
        context.enableEmitNotification(298);
        var moduleInfoMap = [];
        var deferredExports = [];
        var exportFunctionsMap = [];
        var noSubstitutionMap = [];
        var contextObjectMap = [];
        var currentSourceFile;
        var moduleInfo;
        var exportFunction;
        var contextObject;
        var hoistedStatements;
        var enclosingBlockScopedContainer;
        var noSubstitution;
        return ts3.chainBundle(context, transformSourceFile);
        function transformSourceFile(node) {
          if (node.isDeclarationFile || !(ts3.isEffectiveExternalModule(node, compilerOptions) || node.transformFlags & 4194304)) {
            return node;
          }
          var id = ts3.getOriginalNodeId(node);
          currentSourceFile = node;
          enclosingBlockScopedContainer = node;
          moduleInfo = moduleInfoMap[id] = ts3.collectExternalModuleInfo(context, node, resolver, compilerOptions);
          exportFunction = factory.createUniqueName("exports");
          exportFunctionsMap[id] = exportFunction;
          contextObject = contextObjectMap[id] = factory.createUniqueName("context");
          var dependencyGroups = collectDependencyGroups(moduleInfo.externalImports);
          var moduleBodyBlock = createSystemModuleBody(node, dependencyGroups);
          var moduleBodyFunction = factory.createFunctionExpression(void 0, void 0, void 0, void 0, [
            factory.createParameterDeclaration(void 0, void 0, void 0, exportFunction),
            factory.createParameterDeclaration(void 0, void 0, void 0, contextObject)
          ], void 0, moduleBodyBlock);
          var moduleName = ts3.tryGetModuleNameFromFile(factory, node, host, compilerOptions);
          var dependencies = factory.createArrayLiteralExpression(ts3.map(dependencyGroups, function(dependencyGroup) {
            return dependencyGroup.name;
          }));
          var updated = ts3.setEmitFlags(factory.updateSourceFile(node, ts3.setTextRange(factory.createNodeArray([
            factory.createExpressionStatement(factory.createCallExpression(factory.createPropertyAccessExpression(factory.createIdentifier("System"), "register"), void 0, moduleName ? [moduleName, dependencies, moduleBodyFunction] : [dependencies, moduleBodyFunction]))
          ]), node.statements)), 1024);
          if (!ts3.outFile(compilerOptions)) {
            ts3.moveEmitHelpers(updated, moduleBodyBlock, function(helper) {
              return !helper.scoped;
            });
          }
          if (noSubstitution) {
            noSubstitutionMap[id] = noSubstitution;
            noSubstitution = void 0;
          }
          currentSourceFile = void 0;
          moduleInfo = void 0;
          exportFunction = void 0;
          contextObject = void 0;
          hoistedStatements = void 0;
          enclosingBlockScopedContainer = void 0;
          return updated;
        }
        function collectDependencyGroups(externalImports) {
          var groupIndices = new ts3.Map();
          var dependencyGroups = [];
          for (var _i = 0, externalImports_1 = externalImports; _i < externalImports_1.length; _i++) {
            var externalImport = externalImports_1[_i];
            var externalModuleName = ts3.getExternalModuleNameLiteral(factory, externalImport, currentSourceFile, host, resolver, compilerOptions);
            if (externalModuleName) {
              var text = externalModuleName.text;
              var groupIndex = groupIndices.get(text);
              if (groupIndex !== void 0) {
                dependencyGroups[groupIndex].externalImports.push(externalImport);
              } else {
                groupIndices.set(text, dependencyGroups.length);
                dependencyGroups.push({
                  name: externalModuleName,
                  externalImports: [externalImport]
                });
              }
            }
          }
          return dependencyGroups;
        }
        function createSystemModuleBody(node, dependencyGroups) {
          var statements = [];
          startLexicalEnvironment();
          var ensureUseStrict = ts3.getStrictOptionValue(compilerOptions, "alwaysStrict") || !compilerOptions.noImplicitUseStrict && ts3.isExternalModule(currentSourceFile);
          var statementOffset = factory.copyPrologue(node.statements, statements, ensureUseStrict, sourceElementVisitor);
          statements.push(factory.createVariableStatement(void 0, factory.createVariableDeclarationList([
            factory.createVariableDeclaration("__moduleName", void 0, void 0, factory.createLogicalAnd(contextObject, factory.createPropertyAccessExpression(contextObject, "id")))
          ])));
          ts3.visitNode(moduleInfo.externalHelpersImportDeclaration, sourceElementVisitor, ts3.isStatement);
          var executeStatements = ts3.visitNodes(node.statements, sourceElementVisitor, ts3.isStatement, statementOffset);
          ts3.addRange(statements, hoistedStatements);
          ts3.insertStatementsAfterStandardPrologue(statements, endLexicalEnvironment());
          var exportStarFunction = addExportStarIfNeeded(statements);
          var modifiers = node.transformFlags & 1048576 ? factory.createModifiersFromModifierFlags(256) : void 0;
          var moduleObject = factory.createObjectLiteralExpression([
            factory.createPropertyAssignment("setters", createSettersArray(exportStarFunction, dependencyGroups)),
            factory.createPropertyAssignment("execute", factory.createFunctionExpression(modifiers, void 0, void 0, void 0, [], void 0, factory.createBlock(executeStatements, true)))
          ], true);
          statements.push(factory.createReturnStatement(moduleObject));
          return factory.createBlock(statements, true);
        }
        function addExportStarIfNeeded(statements) {
          if (!moduleInfo.hasExportStarsToExportValues) {
            return;
          }
          if (!moduleInfo.exportedNames && moduleInfo.exportSpecifiers.size === 0) {
            var hasExportDeclarationWithExportClause = false;
            for (var _i = 0, _a2 = moduleInfo.externalImports; _i < _a2.length; _i++) {
              var externalImport = _a2[_i];
              if (externalImport.kind === 268 && externalImport.exportClause) {
                hasExportDeclarationWithExportClause = true;
                break;
              }
            }
            if (!hasExportDeclarationWithExportClause) {
              var exportStarFunction_1 = createExportStarFunction(void 0);
              statements.push(exportStarFunction_1);
              return exportStarFunction_1.name;
            }
          }
          var exportedNames = [];
          if (moduleInfo.exportedNames) {
            for (var _b = 0, _c = moduleInfo.exportedNames; _b < _c.length; _b++) {
              var exportedLocalName = _c[_b];
              if (exportedLocalName.escapedText === "default") {
                continue;
              }
              exportedNames.push(factory.createPropertyAssignment(factory.createStringLiteralFromNode(exportedLocalName), factory.createTrue()));
            }
          }
          var exportedNamesStorageRef = factory.createUniqueName("exportedNames");
          statements.push(factory.createVariableStatement(void 0, factory.createVariableDeclarationList([
            factory.createVariableDeclaration(exportedNamesStorageRef, void 0, void 0, factory.createObjectLiteralExpression(exportedNames, true))
          ])));
          var exportStarFunction = createExportStarFunction(exportedNamesStorageRef);
          statements.push(exportStarFunction);
          return exportStarFunction.name;
        }
        function createExportStarFunction(localNames) {
          var exportStarFunction = factory.createUniqueName("exportStar");
          var m = factory.createIdentifier("m");
          var n2 = factory.createIdentifier("n");
          var exports3 = factory.createIdentifier("exports");
          var condition = factory.createStrictInequality(n2, factory.createStringLiteral("default"));
          if (localNames) {
            condition = factory.createLogicalAnd(condition, factory.createLogicalNot(factory.createCallExpression(factory.createPropertyAccessExpression(localNames, "hasOwnProperty"), void 0, [n2])));
          }
          return factory.createFunctionDeclaration(void 0, void 0, void 0, exportStarFunction, void 0, [factory.createParameterDeclaration(void 0, void 0, void 0, m)], void 0, factory.createBlock([
            factory.createVariableStatement(void 0, factory.createVariableDeclarationList([
              factory.createVariableDeclaration(exports3, void 0, void 0, factory.createObjectLiteralExpression([]))
            ])),
            factory.createForInStatement(factory.createVariableDeclarationList([
              factory.createVariableDeclaration(n2)
            ]), m, factory.createBlock([
              ts3.setEmitFlags(factory.createIfStatement(condition, factory.createExpressionStatement(factory.createAssignment(factory.createElementAccessExpression(exports3, n2), factory.createElementAccessExpression(m, n2)))), 1)
            ])),
            factory.createExpressionStatement(factory.createCallExpression(exportFunction, void 0, [exports3]))
          ], true));
        }
        function createSettersArray(exportStarFunction, dependencyGroups) {
          var setters = [];
          for (var _i = 0, dependencyGroups_1 = dependencyGroups; _i < dependencyGroups_1.length; _i++) {
            var group_2 = dependencyGroups_1[_i];
            var localName = ts3.forEach(group_2.externalImports, function(i3) {
              return ts3.getLocalNameForExternalImport(factory, i3, currentSourceFile);
            });
            var parameterName = localName ? factory.getGeneratedNameForNode(localName) : factory.createUniqueName("");
            var statements = [];
            for (var _a2 = 0, _b = group_2.externalImports; _a2 < _b.length; _a2++) {
              var entry = _b[_a2];
              var importVariableName = ts3.getLocalNameForExternalImport(factory, entry, currentSourceFile);
              switch (entry.kind) {
                case 262:
                  if (!entry.importClause) {
                    break;
                  }
                case 261:
                  ts3.Debug.assert(importVariableName !== void 0);
                  statements.push(factory.createExpressionStatement(factory.createAssignment(importVariableName, parameterName)));
                  break;
                case 268:
                  ts3.Debug.assert(importVariableName !== void 0);
                  if (entry.exportClause) {
                    if (ts3.isNamedExports(entry.exportClause)) {
                      var properties = [];
                      for (var _c = 0, _d = entry.exportClause.elements; _c < _d.length; _c++) {
                        var e2 = _d[_c];
                        properties.push(factory.createPropertyAssignment(factory.createStringLiteral(ts3.idText(e2.name)), factory.createElementAccessExpression(parameterName, factory.createStringLiteral(ts3.idText(e2.propertyName || e2.name)))));
                      }
                      statements.push(factory.createExpressionStatement(factory.createCallExpression(exportFunction, void 0, [factory.createObjectLiteralExpression(properties, true)])));
                    } else {
                      statements.push(factory.createExpressionStatement(factory.createCallExpression(exportFunction, void 0, [
                        factory.createStringLiteral(ts3.idText(entry.exportClause.name)),
                        parameterName
                      ])));
                    }
                  } else {
                    statements.push(factory.createExpressionStatement(factory.createCallExpression(exportStarFunction, void 0, [parameterName])));
                  }
                  break;
              }
            }
            setters.push(factory.createFunctionExpression(void 0, void 0, void 0, void 0, [factory.createParameterDeclaration(void 0, void 0, void 0, parameterName)], void 0, factory.createBlock(statements, true)));
          }
          return factory.createArrayLiteralExpression(setters, true);
        }
        function sourceElementVisitor(node) {
          switch (node.kind) {
            case 262:
              return visitImportDeclaration(node);
            case 261:
              return visitImportEqualsDeclaration(node);
            case 268:
              return visitExportDeclaration(node);
            case 267:
              return visitExportAssignment(node);
            default:
              return nestedElementVisitor(node);
          }
        }
        function visitImportDeclaration(node) {
          var statements;
          if (node.importClause) {
            hoistVariableDeclaration(ts3.getLocalNameForExternalImport(factory, node, currentSourceFile));
          }
          if (hasAssociatedEndOfDeclarationMarker(node)) {
            var id = ts3.getOriginalNodeId(node);
            deferredExports[id] = appendExportsOfImportDeclaration(deferredExports[id], node);
          } else {
            statements = appendExportsOfImportDeclaration(statements, node);
          }
          return ts3.singleOrMany(statements);
        }
        function visitExportDeclaration(node) {
          ts3.Debug.assertIsDefined(node);
          return void 0;
        }
        function visitImportEqualsDeclaration(node) {
          ts3.Debug.assert(ts3.isExternalModuleImportEqualsDeclaration(node), "import= for internal module references should be handled in an earlier transformer.");
          var statements;
          hoistVariableDeclaration(ts3.getLocalNameForExternalImport(factory, node, currentSourceFile));
          if (hasAssociatedEndOfDeclarationMarker(node)) {
            var id = ts3.getOriginalNodeId(node);
            deferredExports[id] = appendExportsOfImportEqualsDeclaration(deferredExports[id], node);
          } else {
            statements = appendExportsOfImportEqualsDeclaration(statements, node);
          }
          return ts3.singleOrMany(statements);
        }
        function visitExportAssignment(node) {
          if (node.isExportEquals) {
            return void 0;
          }
          var expression = ts3.visitNode(node.expression, destructuringAndImportCallVisitor, ts3.isExpression);
          var original = node.original;
          if (original && hasAssociatedEndOfDeclarationMarker(original)) {
            var id = ts3.getOriginalNodeId(node);
            deferredExports[id] = appendExportStatement(deferredExports[id], factory.createIdentifier("default"), expression, true);
          } else {
            return createExportStatement(factory.createIdentifier("default"), expression, true);
          }
        }
        function visitFunctionDeclaration(node) {
          if (ts3.hasSyntacticModifier(node, 1)) {
            hoistedStatements = ts3.append(hoistedStatements, factory.updateFunctionDeclaration(node, node.decorators, ts3.visitNodes(node.modifiers, modifierVisitor, ts3.isModifier), node.asteriskToken, factory.getDeclarationName(node, true, true), void 0, ts3.visitNodes(node.parameters, destructuringAndImportCallVisitor, ts3.isParameterDeclaration), void 0, ts3.visitNode(node.body, destructuringAndImportCallVisitor, ts3.isBlock)));
          } else {
            hoistedStatements = ts3.append(hoistedStatements, ts3.visitEachChild(node, destructuringAndImportCallVisitor, context));
          }
          if (hasAssociatedEndOfDeclarationMarker(node)) {
            var id = ts3.getOriginalNodeId(node);
            deferredExports[id] = appendExportsOfHoistedDeclaration(deferredExports[id], node);
          } else {
            hoistedStatements = appendExportsOfHoistedDeclaration(hoistedStatements, node);
          }
          return void 0;
        }
        function visitClassDeclaration(node) {
          var statements;
          var name = factory.getLocalName(node);
          hoistVariableDeclaration(name);
          statements = ts3.append(statements, ts3.setTextRange(factory.createExpressionStatement(factory.createAssignment(name, ts3.setTextRange(factory.createClassExpression(ts3.visitNodes(node.decorators, destructuringAndImportCallVisitor, ts3.isDecorator), void 0, node.name, void 0, ts3.visitNodes(node.heritageClauses, destructuringAndImportCallVisitor, ts3.isHeritageClause), ts3.visitNodes(node.members, destructuringAndImportCallVisitor, ts3.isClassElement)), node))), node));
          if (hasAssociatedEndOfDeclarationMarker(node)) {
            var id = ts3.getOriginalNodeId(node);
            deferredExports[id] = appendExportsOfHoistedDeclaration(deferredExports[id], node);
          } else {
            statements = appendExportsOfHoistedDeclaration(statements, node);
          }
          return ts3.singleOrMany(statements);
        }
        function visitVariableStatement(node) {
          if (!shouldHoistVariableDeclarationList(node.declarationList)) {
            return ts3.visitNode(node, destructuringAndImportCallVisitor, ts3.isStatement);
          }
          var expressions;
          var isExportedDeclaration = ts3.hasSyntacticModifier(node, 1);
          var isMarkedDeclaration = hasAssociatedEndOfDeclarationMarker(node);
          for (var _i = 0, _a2 = node.declarationList.declarations; _i < _a2.length; _i++) {
            var variable = _a2[_i];
            if (variable.initializer) {
              expressions = ts3.append(expressions, transformInitializedVariable(variable, isExportedDeclaration && !isMarkedDeclaration));
            } else {
              hoistBindingElement(variable);
            }
          }
          var statements;
          if (expressions) {
            statements = ts3.append(statements, ts3.setTextRange(factory.createExpressionStatement(factory.inlineExpressions(expressions)), node));
          }
          if (isMarkedDeclaration) {
            var id = ts3.getOriginalNodeId(node);
            deferredExports[id] = appendExportsOfVariableStatement(deferredExports[id], node, isExportedDeclaration);
          } else {
            statements = appendExportsOfVariableStatement(statements, node, false);
          }
          return ts3.singleOrMany(statements);
        }
        function hoistBindingElement(node) {
          if (ts3.isBindingPattern(node.name)) {
            for (var _i = 0, _a2 = node.name.elements; _i < _a2.length; _i++) {
              var element = _a2[_i];
              if (!ts3.isOmittedExpression(element)) {
                hoistBindingElement(element);
              }
            }
          } else {
            hoistVariableDeclaration(factory.cloneNode(node.name));
          }
        }
        function shouldHoistVariableDeclarationList(node) {
          return (ts3.getEmitFlags(node) & 2097152) === 0 && (enclosingBlockScopedContainer.kind === 298 || (ts3.getOriginalNode(node).flags & 3) === 0);
        }
        function transformInitializedVariable(node, isExportedDeclaration) {
          var createAssignment = isExportedDeclaration ? createExportedVariableAssignment : createNonExportedVariableAssignment;
          return ts3.isBindingPattern(node.name) ? ts3.flattenDestructuringAssignment(node, destructuringAndImportCallVisitor, context, 0, false, createAssignment) : node.initializer ? createAssignment(node.name, ts3.visitNode(node.initializer, destructuringAndImportCallVisitor, ts3.isExpression)) : node.name;
        }
        function createExportedVariableAssignment(name, value, location) {
          return createVariableAssignment(name, value, location, true);
        }
        function createNonExportedVariableAssignment(name, value, location) {
          return createVariableAssignment(name, value, location, false);
        }
        function createVariableAssignment(name, value, location, isExportedDeclaration) {
          hoistVariableDeclaration(factory.cloneNode(name));
          return isExportedDeclaration ? createExportExpression(name, preventSubstitution(ts3.setTextRange(factory.createAssignment(name, value), location))) : preventSubstitution(ts3.setTextRange(factory.createAssignment(name, value), location));
        }
        function visitMergeDeclarationMarker(node) {
          if (hasAssociatedEndOfDeclarationMarker(node) && node.original.kind === 233) {
            var id = ts3.getOriginalNodeId(node);
            var isExportedDeclaration = ts3.hasSyntacticModifier(node.original, 1);
            deferredExports[id] = appendExportsOfVariableStatement(deferredExports[id], node.original, isExportedDeclaration);
          }
          return node;
        }
        function hasAssociatedEndOfDeclarationMarker(node) {
          return (ts3.getEmitFlags(node) & 4194304) !== 0;
        }
        function visitEndOfDeclarationMarker(node) {
          var id = ts3.getOriginalNodeId(node);
          var statements = deferredExports[id];
          if (statements) {
            delete deferredExports[id];
            return ts3.append(statements, node);
          } else {
            var original = ts3.getOriginalNode(node);
            if (ts3.isModuleOrEnumDeclaration(original)) {
              return ts3.append(appendExportsOfDeclaration(statements, original), node);
            }
          }
          return node;
        }
        function appendExportsOfImportDeclaration(statements, decl) {
          if (moduleInfo.exportEquals) {
            return statements;
          }
          var importClause = decl.importClause;
          if (!importClause) {
            return statements;
          }
          if (importClause.name) {
            statements = appendExportsOfDeclaration(statements, importClause);
          }
          var namedBindings = importClause.namedBindings;
          if (namedBindings) {
            switch (namedBindings.kind) {
              case 264:
                statements = appendExportsOfDeclaration(statements, namedBindings);
                break;
              case 265:
                for (var _i = 0, _a2 = namedBindings.elements; _i < _a2.length; _i++) {
                  var importBinding = _a2[_i];
                  statements = appendExportsOfDeclaration(statements, importBinding);
                }
                break;
            }
          }
          return statements;
        }
        function appendExportsOfImportEqualsDeclaration(statements, decl) {
          if (moduleInfo.exportEquals) {
            return statements;
          }
          return appendExportsOfDeclaration(statements, decl);
        }
        function appendExportsOfVariableStatement(statements, node, exportSelf) {
          if (moduleInfo.exportEquals) {
            return statements;
          }
          for (var _i = 0, _a2 = node.declarationList.declarations; _i < _a2.length; _i++) {
            var decl = _a2[_i];
            if (decl.initializer || exportSelf) {
              statements = appendExportsOfBindingElement(statements, decl, exportSelf);
            }
          }
          return statements;
        }
        function appendExportsOfBindingElement(statements, decl, exportSelf) {
          if (moduleInfo.exportEquals) {
            return statements;
          }
          if (ts3.isBindingPattern(decl.name)) {
            for (var _i = 0, _a2 = decl.name.elements; _i < _a2.length; _i++) {
              var element = _a2[_i];
              if (!ts3.isOmittedExpression(element)) {
                statements = appendExportsOfBindingElement(statements, element, exportSelf);
              }
            }
          } else if (!ts3.isGeneratedIdentifier(decl.name)) {
            var excludeName = void 0;
            if (exportSelf) {
              statements = appendExportStatement(statements, decl.name, factory.getLocalName(decl));
              excludeName = ts3.idText(decl.name);
            }
            statements = appendExportsOfDeclaration(statements, decl, excludeName);
          }
          return statements;
        }
        function appendExportsOfHoistedDeclaration(statements, decl) {
          if (moduleInfo.exportEquals) {
            return statements;
          }
          var excludeName;
          if (ts3.hasSyntacticModifier(decl, 1)) {
            var exportName = ts3.hasSyntacticModifier(decl, 512) ? factory.createStringLiteral("default") : decl.name;
            statements = appendExportStatement(statements, exportName, factory.getLocalName(decl));
            excludeName = ts3.getTextOfIdentifierOrLiteral(exportName);
          }
          if (decl.name) {
            statements = appendExportsOfDeclaration(statements, decl, excludeName);
          }
          return statements;
        }
        function appendExportsOfDeclaration(statements, decl, excludeName) {
          if (moduleInfo.exportEquals) {
            return statements;
          }
          var name = factory.getDeclarationName(decl);
          var exportSpecifiers = moduleInfo.exportSpecifiers.get(ts3.idText(name));
          if (exportSpecifiers) {
            for (var _i = 0, exportSpecifiers_2 = exportSpecifiers; _i < exportSpecifiers_2.length; _i++) {
              var exportSpecifier = exportSpecifiers_2[_i];
              if (exportSpecifier.name.escapedText !== excludeName) {
                statements = appendExportStatement(statements, exportSpecifier.name, name);
              }
            }
          }
          return statements;
        }
        function appendExportStatement(statements, exportName, expression, allowComments) {
          statements = ts3.append(statements, createExportStatement(exportName, expression, allowComments));
          return statements;
        }
        function createExportStatement(name, value, allowComments) {
          var statement = factory.createExpressionStatement(createExportExpression(name, value));
          ts3.startOnNewLine(statement);
          if (!allowComments) {
            ts3.setEmitFlags(statement, 1536);
          }
          return statement;
        }
        function createExportExpression(name, value) {
          var exportName = ts3.isIdentifier(name) ? factory.createStringLiteralFromNode(name) : name;
          ts3.setEmitFlags(value, ts3.getEmitFlags(value) | 1536);
          return ts3.setCommentRange(factory.createCallExpression(exportFunction, void 0, [exportName, value]), value);
        }
        function nestedElementVisitor(node) {
          switch (node.kind) {
            case 233:
              return visitVariableStatement(node);
            case 252:
              return visitFunctionDeclaration(node);
            case 253:
              return visitClassDeclaration(node);
            case 238:
              return visitForStatement(node);
            case 239:
              return visitForInStatement(node);
            case 240:
              return visitForOfStatement(node);
            case 236:
              return visitDoStatement(node);
            case 237:
              return visitWhileStatement(node);
            case 246:
              return visitLabeledStatement(node);
            case 244:
              return visitWithStatement(node);
            case 245:
              return visitSwitchStatement(node);
            case 259:
              return visitCaseBlock(node);
            case 285:
              return visitCaseClause(node);
            case 286:
              return visitDefaultClause(node);
            case 248:
              return visitTryStatement(node);
            case 288:
              return visitCatchClause(node);
            case 231:
              return visitBlock(node);
            case 342:
              return visitMergeDeclarationMarker(node);
            case 343:
              return visitEndOfDeclarationMarker(node);
            default:
              return destructuringAndImportCallVisitor(node);
          }
        }
        function visitForStatement(node) {
          var savedEnclosingBlockScopedContainer = enclosingBlockScopedContainer;
          enclosingBlockScopedContainer = node;
          node = factory.updateForStatement(node, node.initializer && visitForInitializer(node.initializer), ts3.visitNode(node.condition, destructuringAndImportCallVisitor, ts3.isExpression), ts3.visitNode(node.incrementor, destructuringAndImportCallVisitor, ts3.isExpression), ts3.visitIterationBody(node.statement, nestedElementVisitor, context));
          enclosingBlockScopedContainer = savedEnclosingBlockScopedContainer;
          return node;
        }
        function visitForInStatement(node) {
          var savedEnclosingBlockScopedContainer = enclosingBlockScopedContainer;
          enclosingBlockScopedContainer = node;
          node = factory.updateForInStatement(node, visitForInitializer(node.initializer), ts3.visitNode(node.expression, destructuringAndImportCallVisitor, ts3.isExpression), ts3.visitIterationBody(node.statement, nestedElementVisitor, context));
          enclosingBlockScopedContainer = savedEnclosingBlockScopedContainer;
          return node;
        }
        function visitForOfStatement(node) {
          var savedEnclosingBlockScopedContainer = enclosingBlockScopedContainer;
          enclosingBlockScopedContainer = node;
          node = factory.updateForOfStatement(node, node.awaitModifier, visitForInitializer(node.initializer), ts3.visitNode(node.expression, destructuringAndImportCallVisitor, ts3.isExpression), ts3.visitIterationBody(node.statement, nestedElementVisitor, context));
          enclosingBlockScopedContainer = savedEnclosingBlockScopedContainer;
          return node;
        }
        function shouldHoistForInitializer(node) {
          return ts3.isVariableDeclarationList(node) && shouldHoistVariableDeclarationList(node);
        }
        function visitForInitializer(node) {
          if (shouldHoistForInitializer(node)) {
            var expressions = void 0;
            for (var _i = 0, _a2 = node.declarations; _i < _a2.length; _i++) {
              var variable = _a2[_i];
              expressions = ts3.append(expressions, transformInitializedVariable(variable, false));
              if (!variable.initializer) {
                hoistBindingElement(variable);
              }
            }
            return expressions ? factory.inlineExpressions(expressions) : factory.createOmittedExpression();
          } else {
            return ts3.visitEachChild(node, nestedElementVisitor, context);
          }
        }
        function visitDoStatement(node) {
          return factory.updateDoStatement(node, ts3.visitIterationBody(node.statement, nestedElementVisitor, context), ts3.visitNode(node.expression, destructuringAndImportCallVisitor, ts3.isExpression));
        }
        function visitWhileStatement(node) {
          return factory.updateWhileStatement(node, ts3.visitNode(node.expression, destructuringAndImportCallVisitor, ts3.isExpression), ts3.visitIterationBody(node.statement, nestedElementVisitor, context));
        }
        function visitLabeledStatement(node) {
          return factory.updateLabeledStatement(node, node.label, ts3.visitNode(node.statement, nestedElementVisitor, ts3.isStatement, factory.liftToBlock));
        }
        function visitWithStatement(node) {
          return factory.updateWithStatement(node, ts3.visitNode(node.expression, destructuringAndImportCallVisitor, ts3.isExpression), ts3.visitNode(node.statement, nestedElementVisitor, ts3.isStatement, factory.liftToBlock));
        }
        function visitSwitchStatement(node) {
          return factory.updateSwitchStatement(node, ts3.visitNode(node.expression, destructuringAndImportCallVisitor, ts3.isExpression), ts3.visitNode(node.caseBlock, nestedElementVisitor, ts3.isCaseBlock));
        }
        function visitCaseBlock(node) {
          var savedEnclosingBlockScopedContainer = enclosingBlockScopedContainer;
          enclosingBlockScopedContainer = node;
          node = factory.updateCaseBlock(node, ts3.visitNodes(node.clauses, nestedElementVisitor, ts3.isCaseOrDefaultClause));
          enclosingBlockScopedContainer = savedEnclosingBlockScopedContainer;
          return node;
        }
        function visitCaseClause(node) {
          return factory.updateCaseClause(node, ts3.visitNode(node.expression, destructuringAndImportCallVisitor, ts3.isExpression), ts3.visitNodes(node.statements, nestedElementVisitor, ts3.isStatement));
        }
        function visitDefaultClause(node) {
          return ts3.visitEachChild(node, nestedElementVisitor, context);
        }
        function visitTryStatement(node) {
          return ts3.visitEachChild(node, nestedElementVisitor, context);
        }
        function visitCatchClause(node) {
          var savedEnclosingBlockScopedContainer = enclosingBlockScopedContainer;
          enclosingBlockScopedContainer = node;
          node = factory.updateCatchClause(node, node.variableDeclaration, ts3.visitNode(node.block, nestedElementVisitor, ts3.isBlock));
          enclosingBlockScopedContainer = savedEnclosingBlockScopedContainer;
          return node;
        }
        function visitBlock(node) {
          var savedEnclosingBlockScopedContainer = enclosingBlockScopedContainer;
          enclosingBlockScopedContainer = node;
          node = ts3.visitEachChild(node, nestedElementVisitor, context);
          enclosingBlockScopedContainer = savedEnclosingBlockScopedContainer;
          return node;
        }
        function destructuringAndImportCallVisitor(node) {
          if (ts3.isDestructuringAssignment(node)) {
            return visitDestructuringAssignment(node);
          } else if (ts3.isImportCall(node)) {
            return visitImportCallExpression(node);
          } else if (node.transformFlags & 2048 || node.transformFlags & 4194304) {
            return ts3.visitEachChild(node, destructuringAndImportCallVisitor, context);
          } else {
            return node;
          }
        }
        function visitImportCallExpression(node) {
          var externalModuleName = ts3.getExternalModuleNameLiteral(factory, node, currentSourceFile, host, resolver, compilerOptions);
          var firstArgument = ts3.visitNode(ts3.firstOrUndefined(node.arguments), destructuringAndImportCallVisitor);
          var argument = externalModuleName && (!firstArgument || !ts3.isStringLiteral(firstArgument) || firstArgument.text !== externalModuleName.text) ? externalModuleName : firstArgument;
          return factory.createCallExpression(factory.createPropertyAccessExpression(contextObject, factory.createIdentifier("import")), void 0, argument ? [argument] : []);
        }
        function visitDestructuringAssignment(node) {
          if (hasExportedReferenceInDestructuringTarget(node.left)) {
            return ts3.flattenDestructuringAssignment(node, destructuringAndImportCallVisitor, context, 0, true);
          }
          return ts3.visitEachChild(node, destructuringAndImportCallVisitor, context);
        }
        function hasExportedReferenceInDestructuringTarget(node) {
          if (ts3.isAssignmentExpression(node, true)) {
            return hasExportedReferenceInDestructuringTarget(node.left);
          } else if (ts3.isSpreadElement(node)) {
            return hasExportedReferenceInDestructuringTarget(node.expression);
          } else if (ts3.isObjectLiteralExpression(node)) {
            return ts3.some(node.properties, hasExportedReferenceInDestructuringTarget);
          } else if (ts3.isArrayLiteralExpression(node)) {
            return ts3.some(node.elements, hasExportedReferenceInDestructuringTarget);
          } else if (ts3.isShorthandPropertyAssignment(node)) {
            return hasExportedReferenceInDestructuringTarget(node.name);
          } else if (ts3.isPropertyAssignment(node)) {
            return hasExportedReferenceInDestructuringTarget(node.initializer);
          } else if (ts3.isIdentifier(node)) {
            var container = resolver.getReferencedExportContainer(node);
            return container !== void 0 && container.kind === 298;
          } else {
            return false;
          }
        }
        function modifierVisitor(node) {
          switch (node.kind) {
            case 92:
            case 87:
              return void 0;
          }
          return node;
        }
        function onEmitNode(hint, node, emitCallback) {
          if (node.kind === 298) {
            var id = ts3.getOriginalNodeId(node);
            currentSourceFile = node;
            moduleInfo = moduleInfoMap[id];
            exportFunction = exportFunctionsMap[id];
            noSubstitution = noSubstitutionMap[id];
            contextObject = contextObjectMap[id];
            if (noSubstitution) {
              delete noSubstitutionMap[id];
            }
            previousOnEmitNode(hint, node, emitCallback);
            currentSourceFile = void 0;
            moduleInfo = void 0;
            exportFunction = void 0;
            contextObject = void 0;
            noSubstitution = void 0;
          } else {
            previousOnEmitNode(hint, node, emitCallback);
          }
        }
        function onSubstituteNode(hint, node) {
          node = previousOnSubstituteNode(hint, node);
          if (isSubstitutionPrevented(node)) {
            return node;
          }
          if (hint === 1) {
            return substituteExpression(node);
          } else if (hint === 4) {
            return substituteUnspecified(node);
          }
          return node;
        }
        function substituteUnspecified(node) {
          switch (node.kind) {
            case 290:
              return substituteShorthandPropertyAssignment(node);
          }
          return node;
        }
        function substituteShorthandPropertyAssignment(node) {
          var _a2, _b;
          var name = node.name;
          if (!ts3.isGeneratedIdentifier(name) && !ts3.isLocalName(name)) {
            var importDeclaration = resolver.getReferencedImportDeclaration(name);
            if (importDeclaration) {
              if (ts3.isImportClause(importDeclaration)) {
                return ts3.setTextRange(factory.createPropertyAssignment(factory.cloneNode(name), factory.createPropertyAccessExpression(factory.getGeneratedNameForNode(importDeclaration.parent), factory.createIdentifier("default"))), node);
              } else if (ts3.isImportSpecifier(importDeclaration)) {
                return ts3.setTextRange(factory.createPropertyAssignment(factory.cloneNode(name), factory.createPropertyAccessExpression(factory.getGeneratedNameForNode(((_b = (_a2 = importDeclaration.parent) === null || _a2 === void 0 ? void 0 : _a2.parent) === null || _b === void 0 ? void 0 : _b.parent) || importDeclaration), factory.cloneNode(importDeclaration.propertyName || importDeclaration.name))), node);
              }
            }
          }
          return node;
        }
        function substituteExpression(node) {
          switch (node.kind) {
            case 78:
              return substituteExpressionIdentifier(node);
            case 217:
              return substituteBinaryExpression(node);
            case 215:
            case 216:
              return substituteUnaryExpression(node);
            case 227:
              return substituteMetaProperty(node);
          }
          return node;
        }
        function substituteExpressionIdentifier(node) {
          var _a2, _b;
          if (ts3.getEmitFlags(node) & 4096) {
            var externalHelpersModuleName = ts3.getExternalHelpersModuleName(currentSourceFile);
            if (externalHelpersModuleName) {
              return factory.createPropertyAccessExpression(externalHelpersModuleName, node);
            }
            return node;
          }
          if (!ts3.isGeneratedIdentifier(node) && !ts3.isLocalName(node)) {
            var importDeclaration = resolver.getReferencedImportDeclaration(node);
            if (importDeclaration) {
              if (ts3.isImportClause(importDeclaration)) {
                return ts3.setTextRange(factory.createPropertyAccessExpression(factory.getGeneratedNameForNode(importDeclaration.parent), factory.createIdentifier("default")), node);
              } else if (ts3.isImportSpecifier(importDeclaration)) {
                return ts3.setTextRange(factory.createPropertyAccessExpression(factory.getGeneratedNameForNode(((_b = (_a2 = importDeclaration.parent) === null || _a2 === void 0 ? void 0 : _a2.parent) === null || _b === void 0 ? void 0 : _b.parent) || importDeclaration), factory.cloneNode(importDeclaration.propertyName || importDeclaration.name)), node);
              }
            }
          }
          return node;
        }
        function substituteBinaryExpression(node) {
          if (ts3.isAssignmentOperator(node.operatorToken.kind) && ts3.isIdentifier(node.left) && !ts3.isGeneratedIdentifier(node.left) && !ts3.isLocalName(node.left) && !ts3.isDeclarationNameOfEnumOrNamespace(node.left)) {
            var exportedNames = getExports(node.left);
            if (exportedNames) {
              var expression = node;
              for (var _i = 0, exportedNames_4 = exportedNames; _i < exportedNames_4.length; _i++) {
                var exportName = exportedNames_4[_i];
                expression = createExportExpression(exportName, preventSubstitution(expression));
              }
              return expression;
            }
          }
          return node;
        }
        function substituteUnaryExpression(node) {
          if ((node.operator === 45 || node.operator === 46) && ts3.isIdentifier(node.operand) && !ts3.isGeneratedIdentifier(node.operand) && !ts3.isLocalName(node.operand) && !ts3.isDeclarationNameOfEnumOrNamespace(node.operand)) {
            var exportedNames = getExports(node.operand);
            if (exportedNames) {
              var expression = node.kind === 216 ? ts3.setTextRange(factory.createPrefixUnaryExpression(node.operator, node.operand), node) : node;
              for (var _i = 0, exportedNames_5 = exportedNames; _i < exportedNames_5.length; _i++) {
                var exportName = exportedNames_5[_i];
                expression = createExportExpression(exportName, preventSubstitution(expression));
              }
              if (node.kind === 216) {
                expression = node.operator === 45 ? factory.createSubtract(preventSubstitution(expression), factory.createNumericLiteral(1)) : factory.createAdd(preventSubstitution(expression), factory.createNumericLiteral(1));
              }
              return expression;
            }
          }
          return node;
        }
        function substituteMetaProperty(node) {
          if (ts3.isImportMeta(node)) {
            return factory.createPropertyAccessExpression(contextObject, factory.createIdentifier("meta"));
          }
          return node;
        }
        function getExports(name) {
          var exportedNames;
          if (!ts3.isGeneratedIdentifier(name)) {
            var valueDeclaration = resolver.getReferencedImportDeclaration(name) || resolver.getReferencedValueDeclaration(name);
            if (valueDeclaration) {
              var exportContainer = resolver.getReferencedExportContainer(name, false);
              if (exportContainer && exportContainer.kind === 298) {
                exportedNames = ts3.append(exportedNames, factory.getDeclarationName(valueDeclaration));
              }
              exportedNames = ts3.addRange(exportedNames, moduleInfo && moduleInfo.exportedBindings[ts3.getOriginalNodeId(valueDeclaration)]);
            }
          }
          return exportedNames;
        }
        function preventSubstitution(node) {
          if (noSubstitution === void 0)
            noSubstitution = [];
          noSubstitution[ts3.getNodeId(node)] = true;
          return node;
        }
        function isSubstitutionPrevented(node) {
          return noSubstitution && node.id && noSubstitution[node.id];
        }
      }
      ts3.transformSystemModule = transformSystemModule;
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      function transformECMAScriptModule(context) {
        var factory = context.factory, emitHelpers = context.getEmitHelperFactory;
        var compilerOptions = context.getCompilerOptions();
        var previousOnEmitNode = context.onEmitNode;
        var previousOnSubstituteNode = context.onSubstituteNode;
        context.onEmitNode = onEmitNode;
        context.onSubstituteNode = onSubstituteNode;
        context.enableEmitNotification(298);
        context.enableSubstitution(78);
        var helperNameSubstitutions;
        return ts3.chainBundle(context, transformSourceFile);
        function transformSourceFile(node) {
          if (node.isDeclarationFile) {
            return node;
          }
          if (ts3.isExternalModule(node) || compilerOptions.isolatedModules) {
            var result2 = updateExternalModule(node);
            if (!ts3.isExternalModule(node) || ts3.some(result2.statements, ts3.isExternalModuleIndicator)) {
              return result2;
            }
            return factory.updateSourceFile(result2, ts3.setTextRange(factory.createNodeArray(__spreadArray(__spreadArray([], result2.statements), [ts3.createEmptyExports(factory)])), result2.statements));
          }
          return node;
        }
        function updateExternalModule(node) {
          var externalHelpersImportDeclaration = ts3.createExternalHelpersImportDeclarationIfNeeded(factory, emitHelpers(), node, compilerOptions);
          if (externalHelpersImportDeclaration) {
            var statements = [];
            var statementOffset = factory.copyPrologue(node.statements, statements);
            ts3.append(statements, externalHelpersImportDeclaration);
            ts3.addRange(statements, ts3.visitNodes(node.statements, visitor, ts3.isStatement, statementOffset));
            return factory.updateSourceFile(node, ts3.setTextRange(factory.createNodeArray(statements), node.statements));
          } else {
            return ts3.visitEachChild(node, visitor, context);
          }
        }
        function visitor(node) {
          switch (node.kind) {
            case 261:
              return void 0;
            case 267:
              return visitExportAssignment(node);
            case 268:
              var exportDecl = node;
              return visitExportDeclaration(exportDecl);
          }
          return node;
        }
        function visitExportAssignment(node) {
          return node.isExportEquals ? void 0 : node;
        }
        function visitExportDeclaration(node) {
          if (compilerOptions.module !== void 0 && compilerOptions.module > ts3.ModuleKind.ES2015) {
            return node;
          }
          if (!node.exportClause || !ts3.isNamespaceExport(node.exportClause) || !node.moduleSpecifier) {
            return node;
          }
          var oldIdentifier = node.exportClause.name;
          var synthName = factory.getGeneratedNameForNode(oldIdentifier);
          var importDecl = factory.createImportDeclaration(void 0, void 0, factory.createImportClause(false, void 0, factory.createNamespaceImport(synthName)), node.moduleSpecifier);
          ts3.setOriginalNode(importDecl, node.exportClause);
          var exportDecl = ts3.isExportNamespaceAsDefaultDeclaration(node) ? factory.createExportDefault(synthName) : factory.createExportDeclaration(void 0, void 0, false, factory.createNamedExports([factory.createExportSpecifier(synthName, oldIdentifier)]));
          ts3.setOriginalNode(exportDecl, node);
          return [importDecl, exportDecl];
        }
        function onEmitNode(hint, node, emitCallback) {
          if (ts3.isSourceFile(node)) {
            if ((ts3.isExternalModule(node) || compilerOptions.isolatedModules) && compilerOptions.importHelpers) {
              helperNameSubstitutions = new ts3.Map();
            }
            previousOnEmitNode(hint, node, emitCallback);
            helperNameSubstitutions = void 0;
          } else {
            previousOnEmitNode(hint, node, emitCallback);
          }
        }
        function onSubstituteNode(hint, node) {
          node = previousOnSubstituteNode(hint, node);
          if (helperNameSubstitutions && ts3.isIdentifier(node) && ts3.getEmitFlags(node) & 4096) {
            return substituteHelperName(node);
          }
          return node;
        }
        function substituteHelperName(node) {
          var name = ts3.idText(node);
          var substitution = helperNameSubstitutions.get(name);
          if (!substitution) {
            helperNameSubstitutions.set(name, substitution = factory.createUniqueName(name, 16 | 32));
          }
          return substitution;
        }
      }
      ts3.transformECMAScriptModule = transformECMAScriptModule;
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      function canProduceDiagnostics(node) {
        return ts3.isVariableDeclaration(node) || ts3.isPropertyDeclaration(node) || ts3.isPropertySignature(node) || ts3.isBindingElement(node) || ts3.isSetAccessor(node) || ts3.isGetAccessor(node) || ts3.isConstructSignatureDeclaration(node) || ts3.isCallSignatureDeclaration(node) || ts3.isMethodDeclaration(node) || ts3.isMethodSignature(node) || ts3.isFunctionDeclaration(node) || ts3.isParameter(node) || ts3.isTypeParameterDeclaration(node) || ts3.isExpressionWithTypeArguments(node) || ts3.isImportEqualsDeclaration(node) || ts3.isTypeAliasDeclaration(node) || ts3.isConstructorDeclaration(node) || ts3.isIndexSignatureDeclaration(node) || ts3.isPropertyAccessExpression(node) || ts3.isJSDocTypeAlias(node);
      }
      ts3.canProduceDiagnostics = canProduceDiagnostics;
      function createGetSymbolAccessibilityDiagnosticForNodeName(node) {
        if (ts3.isSetAccessor(node) || ts3.isGetAccessor(node)) {
          return getAccessorNameVisibilityError;
        } else if (ts3.isMethodSignature(node) || ts3.isMethodDeclaration(node)) {
          return getMethodNameVisibilityError;
        } else {
          return createGetSymbolAccessibilityDiagnosticForNode(node);
        }
        function getAccessorNameVisibilityError(symbolAccessibilityResult) {
          var diagnosticMessage = getAccessorNameVisibilityDiagnosticMessage(symbolAccessibilityResult);
          return diagnosticMessage !== void 0 ? {
            diagnosticMessage,
            errorNode: node,
            typeName: node.name
          } : void 0;
        }
        function getAccessorNameVisibilityDiagnosticMessage(symbolAccessibilityResult) {
          if (ts3.hasSyntacticModifier(node, 32)) {
            return symbolAccessibilityResult.errorModuleName ? symbolAccessibilityResult.accessibility === 2 ? ts3.Diagnostics.Public_static_property_0_of_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named : ts3.Diagnostics.Public_static_property_0_of_exported_class_has_or_is_using_name_1_from_private_module_2 : ts3.Diagnostics.Public_static_property_0_of_exported_class_has_or_is_using_private_name_1;
          } else if (node.parent.kind === 253) {
            return symbolAccessibilityResult.errorModuleName ? symbolAccessibilityResult.accessibility === 2 ? ts3.Diagnostics.Public_property_0_of_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named : ts3.Diagnostics.Public_property_0_of_exported_class_has_or_is_using_name_1_from_private_module_2 : ts3.Diagnostics.Public_property_0_of_exported_class_has_or_is_using_private_name_1;
          } else {
            return symbolAccessibilityResult.errorModuleName ? ts3.Diagnostics.Property_0_of_exported_interface_has_or_is_using_name_1_from_private_module_2 : ts3.Diagnostics.Property_0_of_exported_interface_has_or_is_using_private_name_1;
          }
        }
        function getMethodNameVisibilityError(symbolAccessibilityResult) {
          var diagnosticMessage = getMethodNameVisibilityDiagnosticMessage(symbolAccessibilityResult);
          return diagnosticMessage !== void 0 ? {
            diagnosticMessage,
            errorNode: node,
            typeName: node.name
          } : void 0;
        }
        function getMethodNameVisibilityDiagnosticMessage(symbolAccessibilityResult) {
          if (ts3.hasSyntacticModifier(node, 32)) {
            return symbolAccessibilityResult.errorModuleName ? symbolAccessibilityResult.accessibility === 2 ? ts3.Diagnostics.Public_static_method_0_of_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named : ts3.Diagnostics.Public_static_method_0_of_exported_class_has_or_is_using_name_1_from_private_module_2 : ts3.Diagnostics.Public_static_method_0_of_exported_class_has_or_is_using_private_name_1;
          } else if (node.parent.kind === 253) {
            return symbolAccessibilityResult.errorModuleName ? symbolAccessibilityResult.accessibility === 2 ? ts3.Diagnostics.Public_method_0_of_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named : ts3.Diagnostics.Public_method_0_of_exported_class_has_or_is_using_name_1_from_private_module_2 : ts3.Diagnostics.Public_method_0_of_exported_class_has_or_is_using_private_name_1;
          } else {
            return symbolAccessibilityResult.errorModuleName ? ts3.Diagnostics.Method_0_of_exported_interface_has_or_is_using_name_1_from_private_module_2 : ts3.Diagnostics.Method_0_of_exported_interface_has_or_is_using_private_name_1;
          }
        }
      }
      ts3.createGetSymbolAccessibilityDiagnosticForNodeName = createGetSymbolAccessibilityDiagnosticForNodeName;
      function createGetSymbolAccessibilityDiagnosticForNode(node) {
        if (ts3.isVariableDeclaration(node) || ts3.isPropertyDeclaration(node) || ts3.isPropertySignature(node) || ts3.isPropertyAccessExpression(node) || ts3.isBindingElement(node) || ts3.isConstructorDeclaration(node)) {
          return getVariableDeclarationTypeVisibilityError;
        } else if (ts3.isSetAccessor(node) || ts3.isGetAccessor(node)) {
          return getAccessorDeclarationTypeVisibilityError;
        } else if (ts3.isConstructSignatureDeclaration(node) || ts3.isCallSignatureDeclaration(node) || ts3.isMethodDeclaration(node) || ts3.isMethodSignature(node) || ts3.isFunctionDeclaration(node) || ts3.isIndexSignatureDeclaration(node)) {
          return getReturnTypeVisibilityError;
        } else if (ts3.isParameter(node)) {
          if (ts3.isParameterPropertyDeclaration(node, node.parent) && ts3.hasSyntacticModifier(node.parent, 8)) {
            return getVariableDeclarationTypeVisibilityError;
          }
          return getParameterDeclarationTypeVisibilityError;
        } else if (ts3.isTypeParameterDeclaration(node)) {
          return getTypeParameterConstraintVisibilityError;
        } else if (ts3.isExpressionWithTypeArguments(node)) {
          return getHeritageClauseVisibilityError;
        } else if (ts3.isImportEqualsDeclaration(node)) {
          return getImportEntityNameVisibilityError;
        } else if (ts3.isTypeAliasDeclaration(node) || ts3.isJSDocTypeAlias(node)) {
          return getTypeAliasDeclarationVisibilityError;
        } else {
          return ts3.Debug.assertNever(node, "Attempted to set a declaration diagnostic context for unhandled node kind: " + ts3.SyntaxKind[node.kind]);
        }
        function getVariableDeclarationTypeVisibilityDiagnosticMessage(symbolAccessibilityResult) {
          if (node.kind === 250 || node.kind === 199) {
            return symbolAccessibilityResult.errorModuleName ? symbolAccessibilityResult.accessibility === 2 ? ts3.Diagnostics.Exported_variable_0_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named : ts3.Diagnostics.Exported_variable_0_has_or_is_using_name_1_from_private_module_2 : ts3.Diagnostics.Exported_variable_0_has_or_is_using_private_name_1;
          } else if (node.kind === 164 || node.kind === 202 || node.kind === 163 || node.kind === 161 && ts3.hasSyntacticModifier(node.parent, 8)) {
            if (ts3.hasSyntacticModifier(node, 32)) {
              return symbolAccessibilityResult.errorModuleName ? symbolAccessibilityResult.accessibility === 2 ? ts3.Diagnostics.Public_static_property_0_of_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named : ts3.Diagnostics.Public_static_property_0_of_exported_class_has_or_is_using_name_1_from_private_module_2 : ts3.Diagnostics.Public_static_property_0_of_exported_class_has_or_is_using_private_name_1;
            } else if (node.parent.kind === 253 || node.kind === 161) {
              return symbolAccessibilityResult.errorModuleName ? symbolAccessibilityResult.accessibility === 2 ? ts3.Diagnostics.Public_property_0_of_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named : ts3.Diagnostics.Public_property_0_of_exported_class_has_or_is_using_name_1_from_private_module_2 : ts3.Diagnostics.Public_property_0_of_exported_class_has_or_is_using_private_name_1;
            } else {
              return symbolAccessibilityResult.errorModuleName ? ts3.Diagnostics.Property_0_of_exported_interface_has_or_is_using_name_1_from_private_module_2 : ts3.Diagnostics.Property_0_of_exported_interface_has_or_is_using_private_name_1;
            }
          }
        }
        function getVariableDeclarationTypeVisibilityError(symbolAccessibilityResult) {
          var diagnosticMessage = getVariableDeclarationTypeVisibilityDiagnosticMessage(symbolAccessibilityResult);
          return diagnosticMessage !== void 0 ? {
            diagnosticMessage,
            errorNode: node,
            typeName: node.name
          } : void 0;
        }
        function getAccessorDeclarationTypeVisibilityError(symbolAccessibilityResult) {
          var diagnosticMessage;
          if (node.kind === 169) {
            if (ts3.hasSyntacticModifier(node, 32)) {
              diagnosticMessage = symbolAccessibilityResult.errorModuleName ? ts3.Diagnostics.Parameter_type_of_public_static_setter_0_from_exported_class_has_or_is_using_name_1_from_private_module_2 : ts3.Diagnostics.Parameter_type_of_public_static_setter_0_from_exported_class_has_or_is_using_private_name_1;
            } else {
              diagnosticMessage = symbolAccessibilityResult.errorModuleName ? ts3.Diagnostics.Parameter_type_of_public_setter_0_from_exported_class_has_or_is_using_name_1_from_private_module_2 : ts3.Diagnostics.Parameter_type_of_public_setter_0_from_exported_class_has_or_is_using_private_name_1;
            }
          } else {
            if (ts3.hasSyntacticModifier(node, 32)) {
              diagnosticMessage = symbolAccessibilityResult.errorModuleName ? symbolAccessibilityResult.accessibility === 2 ? ts3.Diagnostics.Return_type_of_public_static_getter_0_from_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named : ts3.Diagnostics.Return_type_of_public_static_getter_0_from_exported_class_has_or_is_using_name_1_from_private_module_2 : ts3.Diagnostics.Return_type_of_public_static_getter_0_from_exported_class_has_or_is_using_private_name_1;
            } else {
              diagnosticMessage = symbolAccessibilityResult.errorModuleName ? symbolAccessibilityResult.accessibility === 2 ? ts3.Diagnostics.Return_type_of_public_getter_0_from_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named : ts3.Diagnostics.Return_type_of_public_getter_0_from_exported_class_has_or_is_using_name_1_from_private_module_2 : ts3.Diagnostics.Return_type_of_public_getter_0_from_exported_class_has_or_is_using_private_name_1;
            }
          }
          return {
            diagnosticMessage,
            errorNode: node.name,
            typeName: node.name
          };
        }
        function getReturnTypeVisibilityError(symbolAccessibilityResult) {
          var diagnosticMessage;
          switch (node.kind) {
            case 171:
              diagnosticMessage = symbolAccessibilityResult.errorModuleName ? ts3.Diagnostics.Return_type_of_constructor_signature_from_exported_interface_has_or_is_using_name_0_from_private_module_1 : ts3.Diagnostics.Return_type_of_constructor_signature_from_exported_interface_has_or_is_using_private_name_0;
              break;
            case 170:
              diagnosticMessage = symbolAccessibilityResult.errorModuleName ? ts3.Diagnostics.Return_type_of_call_signature_from_exported_interface_has_or_is_using_name_0_from_private_module_1 : ts3.Diagnostics.Return_type_of_call_signature_from_exported_interface_has_or_is_using_private_name_0;
              break;
            case 172:
              diagnosticMessage = symbolAccessibilityResult.errorModuleName ? ts3.Diagnostics.Return_type_of_index_signature_from_exported_interface_has_or_is_using_name_0_from_private_module_1 : ts3.Diagnostics.Return_type_of_index_signature_from_exported_interface_has_or_is_using_private_name_0;
              break;
            case 166:
            case 165:
              if (ts3.hasSyntacticModifier(node, 32)) {
                diagnosticMessage = symbolAccessibilityResult.errorModuleName ? symbolAccessibilityResult.accessibility === 2 ? ts3.Diagnostics.Return_type_of_public_static_method_from_exported_class_has_or_is_using_name_0_from_external_module_1_but_cannot_be_named : ts3.Diagnostics.Return_type_of_public_static_method_from_exported_class_has_or_is_using_name_0_from_private_module_1 : ts3.Diagnostics.Return_type_of_public_static_method_from_exported_class_has_or_is_using_private_name_0;
              } else if (node.parent.kind === 253) {
                diagnosticMessage = symbolAccessibilityResult.errorModuleName ? symbolAccessibilityResult.accessibility === 2 ? ts3.Diagnostics.Return_type_of_public_method_from_exported_class_has_or_is_using_name_0_from_external_module_1_but_cannot_be_named : ts3.Diagnostics.Return_type_of_public_method_from_exported_class_has_or_is_using_name_0_from_private_module_1 : ts3.Diagnostics.Return_type_of_public_method_from_exported_class_has_or_is_using_private_name_0;
              } else {
                diagnosticMessage = symbolAccessibilityResult.errorModuleName ? ts3.Diagnostics.Return_type_of_method_from_exported_interface_has_or_is_using_name_0_from_private_module_1 : ts3.Diagnostics.Return_type_of_method_from_exported_interface_has_or_is_using_private_name_0;
              }
              break;
            case 252:
              diagnosticMessage = symbolAccessibilityResult.errorModuleName ? symbolAccessibilityResult.accessibility === 2 ? ts3.Diagnostics.Return_type_of_exported_function_has_or_is_using_name_0_from_external_module_1_but_cannot_be_named : ts3.Diagnostics.Return_type_of_exported_function_has_or_is_using_name_0_from_private_module_1 : ts3.Diagnostics.Return_type_of_exported_function_has_or_is_using_private_name_0;
              break;
            default:
              return ts3.Debug.fail("This is unknown kind for signature: " + node.kind);
          }
          return {
            diagnosticMessage,
            errorNode: node.name || node
          };
        }
        function getParameterDeclarationTypeVisibilityError(symbolAccessibilityResult) {
          var diagnosticMessage = getParameterDeclarationTypeVisibilityDiagnosticMessage(symbolAccessibilityResult);
          return diagnosticMessage !== void 0 ? {
            diagnosticMessage,
            errorNode: node,
            typeName: node.name
          } : void 0;
        }
        function getParameterDeclarationTypeVisibilityDiagnosticMessage(symbolAccessibilityResult) {
          switch (node.parent.kind) {
            case 167:
              return symbolAccessibilityResult.errorModuleName ? symbolAccessibilityResult.accessibility === 2 ? ts3.Diagnostics.Parameter_0_of_constructor_from_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named : ts3.Diagnostics.Parameter_0_of_constructor_from_exported_class_has_or_is_using_name_1_from_private_module_2 : ts3.Diagnostics.Parameter_0_of_constructor_from_exported_class_has_or_is_using_private_name_1;
            case 171:
            case 176:
              return symbolAccessibilityResult.errorModuleName ? ts3.Diagnostics.Parameter_0_of_constructor_signature_from_exported_interface_has_or_is_using_name_1_from_private_module_2 : ts3.Diagnostics.Parameter_0_of_constructor_signature_from_exported_interface_has_or_is_using_private_name_1;
            case 170:
              return symbolAccessibilityResult.errorModuleName ? ts3.Diagnostics.Parameter_0_of_call_signature_from_exported_interface_has_or_is_using_name_1_from_private_module_2 : ts3.Diagnostics.Parameter_0_of_call_signature_from_exported_interface_has_or_is_using_private_name_1;
            case 172:
              return symbolAccessibilityResult.errorModuleName ? ts3.Diagnostics.Parameter_0_of_index_signature_from_exported_interface_has_or_is_using_name_1_from_private_module_2 : ts3.Diagnostics.Parameter_0_of_index_signature_from_exported_interface_has_or_is_using_private_name_1;
            case 166:
            case 165:
              if (ts3.hasSyntacticModifier(node.parent, 32)) {
                return symbolAccessibilityResult.errorModuleName ? symbolAccessibilityResult.accessibility === 2 ? ts3.Diagnostics.Parameter_0_of_public_static_method_from_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named : ts3.Diagnostics.Parameter_0_of_public_static_method_from_exported_class_has_or_is_using_name_1_from_private_module_2 : ts3.Diagnostics.Parameter_0_of_public_static_method_from_exported_class_has_or_is_using_private_name_1;
              } else if (node.parent.parent.kind === 253) {
                return symbolAccessibilityResult.errorModuleName ? symbolAccessibilityResult.accessibility === 2 ? ts3.Diagnostics.Parameter_0_of_public_method_from_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named : ts3.Diagnostics.Parameter_0_of_public_method_from_exported_class_has_or_is_using_name_1_from_private_module_2 : ts3.Diagnostics.Parameter_0_of_public_method_from_exported_class_has_or_is_using_private_name_1;
              } else {
                return symbolAccessibilityResult.errorModuleName ? ts3.Diagnostics.Parameter_0_of_method_from_exported_interface_has_or_is_using_name_1_from_private_module_2 : ts3.Diagnostics.Parameter_0_of_method_from_exported_interface_has_or_is_using_private_name_1;
              }
            case 252:
            case 175:
              return symbolAccessibilityResult.errorModuleName ? symbolAccessibilityResult.accessibility === 2 ? ts3.Diagnostics.Parameter_0_of_exported_function_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named : ts3.Diagnostics.Parameter_0_of_exported_function_has_or_is_using_name_1_from_private_module_2 : ts3.Diagnostics.Parameter_0_of_exported_function_has_or_is_using_private_name_1;
            case 169:
            case 168:
              return symbolAccessibilityResult.errorModuleName ? symbolAccessibilityResult.accessibility === 2 ? ts3.Diagnostics.Parameter_0_of_accessor_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named : ts3.Diagnostics.Parameter_0_of_accessor_has_or_is_using_name_1_from_private_module_2 : ts3.Diagnostics.Parameter_0_of_accessor_has_or_is_using_private_name_1;
            default:
              return ts3.Debug.fail("Unknown parent for parameter: " + ts3.SyntaxKind[node.parent.kind]);
          }
        }
        function getTypeParameterConstraintVisibilityError() {
          var diagnosticMessage;
          switch (node.parent.kind) {
            case 253:
              diagnosticMessage = ts3.Diagnostics.Type_parameter_0_of_exported_class_has_or_is_using_private_name_1;
              break;
            case 254:
              diagnosticMessage = ts3.Diagnostics.Type_parameter_0_of_exported_interface_has_or_is_using_private_name_1;
              break;
            case 191:
              diagnosticMessage = ts3.Diagnostics.Type_parameter_0_of_exported_mapped_object_type_is_using_private_name_1;
              break;
            case 176:
            case 171:
              diagnosticMessage = ts3.Diagnostics.Type_parameter_0_of_constructor_signature_from_exported_interface_has_or_is_using_private_name_1;
              break;
            case 170:
              diagnosticMessage = ts3.Diagnostics.Type_parameter_0_of_call_signature_from_exported_interface_has_or_is_using_private_name_1;
              break;
            case 166:
            case 165:
              if (ts3.hasSyntacticModifier(node.parent, 32)) {
                diagnosticMessage = ts3.Diagnostics.Type_parameter_0_of_public_static_method_from_exported_class_has_or_is_using_private_name_1;
              } else if (node.parent.parent.kind === 253) {
                diagnosticMessage = ts3.Diagnostics.Type_parameter_0_of_public_method_from_exported_class_has_or_is_using_private_name_1;
              } else {
                diagnosticMessage = ts3.Diagnostics.Type_parameter_0_of_method_from_exported_interface_has_or_is_using_private_name_1;
              }
              break;
            case 175:
            case 252:
              diagnosticMessage = ts3.Diagnostics.Type_parameter_0_of_exported_function_has_or_is_using_private_name_1;
              break;
            case 255:
              diagnosticMessage = ts3.Diagnostics.Type_parameter_0_of_exported_type_alias_has_or_is_using_private_name_1;
              break;
            default:
              return ts3.Debug.fail("This is unknown parent for type parameter: " + node.parent.kind);
          }
          return {
            diagnosticMessage,
            errorNode: node,
            typeName: node.name
          };
        }
        function getHeritageClauseVisibilityError() {
          var diagnosticMessage;
          if (ts3.isClassDeclaration(node.parent.parent)) {
            diagnosticMessage = ts3.isHeritageClause(node.parent) && node.parent.token === 116 ? ts3.Diagnostics.Implements_clause_of_exported_class_0_has_or_is_using_private_name_1 : node.parent.parent.name ? ts3.Diagnostics.extends_clause_of_exported_class_0_has_or_is_using_private_name_1 : ts3.Diagnostics.extends_clause_of_exported_class_has_or_is_using_private_name_0;
          } else {
            diagnosticMessage = ts3.Diagnostics.extends_clause_of_exported_interface_0_has_or_is_using_private_name_1;
          }
          return {
            diagnosticMessage,
            errorNode: node,
            typeName: ts3.getNameOfDeclaration(node.parent.parent)
          };
        }
        function getImportEntityNameVisibilityError() {
          return {
            diagnosticMessage: ts3.Diagnostics.Import_declaration_0_is_using_private_name_1,
            errorNode: node,
            typeName: node.name
          };
        }
        function getTypeAliasDeclarationVisibilityError(symbolAccessibilityResult) {
          return {
            diagnosticMessage: symbolAccessibilityResult.errorModuleName ? ts3.Diagnostics.Exported_type_alias_0_has_or_is_using_private_name_1_from_module_2 : ts3.Diagnostics.Exported_type_alias_0_has_or_is_using_private_name_1,
            errorNode: ts3.isJSDocTypeAlias(node) ? ts3.Debug.checkDefined(node.typeExpression) : node.type,
            typeName: ts3.isJSDocTypeAlias(node) ? ts3.getNameOfDeclaration(node) : node.name
          };
        }
      }
      ts3.createGetSymbolAccessibilityDiagnosticForNode = createGetSymbolAccessibilityDiagnosticForNode;
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      function getDeclarationDiagnostics(host, resolver, file) {
        var compilerOptions = host.getCompilerOptions();
        var result2 = ts3.transformNodes(resolver, host, ts3.factory, compilerOptions, file ? [file] : ts3.filter(host.getSourceFiles(), ts3.isSourceFileNotJson), [transformDeclarations], false);
        return result2.diagnostics;
      }
      ts3.getDeclarationDiagnostics = getDeclarationDiagnostics;
      function hasInternalAnnotation(range, currentSourceFile) {
        var comment = currentSourceFile.text.substring(range.pos, range.end);
        return ts3.stringContains(comment, "@internal");
      }
      function isInternalDeclaration(node, currentSourceFile) {
        var parseTreeNode = ts3.getParseTreeNode(node);
        if (parseTreeNode && parseTreeNode.kind === 161) {
          var paramIdx = parseTreeNode.parent.parameters.indexOf(parseTreeNode);
          var previousSibling = paramIdx > 0 ? parseTreeNode.parent.parameters[paramIdx - 1] : void 0;
          var text = currentSourceFile.text;
          var commentRanges = previousSibling ? ts3.concatenate(ts3.getTrailingCommentRanges(text, ts3.skipTrivia(text, previousSibling.end + 1, false, true)), ts3.getLeadingCommentRanges(text, node.pos)) : ts3.getTrailingCommentRanges(text, ts3.skipTrivia(text, node.pos, false, true));
          return commentRanges && commentRanges.length && hasInternalAnnotation(ts3.last(commentRanges), currentSourceFile);
        }
        var leadingCommentRanges = parseTreeNode && ts3.getLeadingCommentRangesOfNode(parseTreeNode, currentSourceFile);
        return !!ts3.forEach(leadingCommentRanges, function(range) {
          return hasInternalAnnotation(range, currentSourceFile);
        });
      }
      ts3.isInternalDeclaration = isInternalDeclaration;
      var declarationEmitNodeBuilderFlags = 1024 | 2048 | 4096 | 8 | 524288 | 4 | 1;
      function transformDeclarations(context) {
        var throwDiagnostic = function() {
          return ts3.Debug.fail("Diagnostic emitted without context");
        };
        var getSymbolAccessibilityDiagnostic = throwDiagnostic;
        var needsDeclare = true;
        var isBundledEmit = false;
        var resultHasExternalModuleIndicator = false;
        var needsScopeFixMarker = false;
        var resultHasScopeMarker = false;
        var enclosingDeclaration;
        var necessaryTypeReferences;
        var lateMarkedStatements;
        var lateStatementReplacementMap;
        var suppressNewDiagnosticContexts;
        var exportedModulesFromDeclarationEmit;
        var factory = context.factory;
        var host = context.getEmitHost();
        var symbolTracker = {
          trackSymbol,
          reportInaccessibleThisError,
          reportInaccessibleUniqueSymbolError,
          reportCyclicStructureError,
          reportPrivateInBaseOfClassExpression,
          reportLikelyUnsafeImportRequiredError,
          reportTruncationError,
          moduleResolverHost: host,
          trackReferencedAmbientModule,
          trackExternalModuleSymbolOfImportTypeNode,
          reportNonlocalAugmentation
        };
        var errorNameNode;
        var errorFallbackNode;
        var currentSourceFile;
        var refs;
        var libs;
        var emittedImports;
        var resolver = context.getEmitResolver();
        var options = context.getCompilerOptions();
        var noResolve = options.noResolve, stripInternal = options.stripInternal;
        return transformRoot;
        function recordTypeReferenceDirectivesIfNecessary(typeReferenceDirectives) {
          if (!typeReferenceDirectives) {
            return;
          }
          necessaryTypeReferences = necessaryTypeReferences || new ts3.Set();
          for (var _i = 0, typeReferenceDirectives_2 = typeReferenceDirectives; _i < typeReferenceDirectives_2.length; _i++) {
            var ref2 = typeReferenceDirectives_2[_i];
            necessaryTypeReferences.add(ref2);
          }
        }
        function trackReferencedAmbientModule(node, symbol) {
          var directives = resolver.getTypeReferenceDirectivesForSymbol(symbol, 67108863);
          if (ts3.length(directives)) {
            return recordTypeReferenceDirectivesIfNecessary(directives);
          }
          var container = ts3.getSourceFileOfNode(node);
          refs.set(ts3.getOriginalNodeId(container), container);
        }
        function handleSymbolAccessibilityError(symbolAccessibilityResult) {
          if (symbolAccessibilityResult.accessibility === 0) {
            if (symbolAccessibilityResult && symbolAccessibilityResult.aliasesToMakeVisible) {
              if (!lateMarkedStatements) {
                lateMarkedStatements = symbolAccessibilityResult.aliasesToMakeVisible;
              } else {
                for (var _i = 0, _a2 = symbolAccessibilityResult.aliasesToMakeVisible; _i < _a2.length; _i++) {
                  var ref2 = _a2[_i];
                  ts3.pushIfUnique(lateMarkedStatements, ref2);
                }
              }
            }
          } else {
            var errorInfo = getSymbolAccessibilityDiagnostic(symbolAccessibilityResult);
            if (errorInfo) {
              if (errorInfo.typeName) {
                context.addDiagnostic(ts3.createDiagnosticForNode(symbolAccessibilityResult.errorNode || errorInfo.errorNode, errorInfo.diagnosticMessage, ts3.getTextOfNode(errorInfo.typeName), symbolAccessibilityResult.errorSymbolName, symbolAccessibilityResult.errorModuleName));
              } else {
                context.addDiagnostic(ts3.createDiagnosticForNode(symbolAccessibilityResult.errorNode || errorInfo.errorNode, errorInfo.diagnosticMessage, symbolAccessibilityResult.errorSymbolName, symbolAccessibilityResult.errorModuleName));
              }
            }
          }
        }
        function trackExternalModuleSymbolOfImportTypeNode(symbol) {
          if (!isBundledEmit) {
            (exportedModulesFromDeclarationEmit || (exportedModulesFromDeclarationEmit = [])).push(symbol);
          }
        }
        function trackSymbol(symbol, enclosingDeclaration2, meaning) {
          if (symbol.flags & 262144)
            return;
          handleSymbolAccessibilityError(resolver.isSymbolAccessible(symbol, enclosingDeclaration2, meaning, true));
          recordTypeReferenceDirectivesIfNecessary(resolver.getTypeReferenceDirectivesForSymbol(symbol, meaning));
        }
        function reportPrivateInBaseOfClassExpression(propertyName) {
          if (errorNameNode || errorFallbackNode) {
            context.addDiagnostic(ts3.createDiagnosticForNode(errorNameNode || errorFallbackNode, ts3.Diagnostics.Property_0_of_exported_class_expression_may_not_be_private_or_protected, propertyName));
          }
        }
        function reportInaccessibleUniqueSymbolError() {
          if (errorNameNode) {
            context.addDiagnostic(ts3.createDiagnosticForNode(errorNameNode, ts3.Diagnostics.The_inferred_type_of_0_references_an_inaccessible_1_type_A_type_annotation_is_necessary, ts3.declarationNameToString(errorNameNode), "unique symbol"));
          }
        }
        function reportCyclicStructureError() {
          if (errorNameNode) {
            context.addDiagnostic(ts3.createDiagnosticForNode(errorNameNode, ts3.Diagnostics.The_inferred_type_of_0_references_a_type_with_a_cyclic_structure_which_cannot_be_trivially_serialized_A_type_annotation_is_necessary, ts3.declarationNameToString(errorNameNode)));
          }
        }
        function reportInaccessibleThisError() {
          if (errorNameNode) {
            context.addDiagnostic(ts3.createDiagnosticForNode(errorNameNode, ts3.Diagnostics.The_inferred_type_of_0_references_an_inaccessible_1_type_A_type_annotation_is_necessary, ts3.declarationNameToString(errorNameNode), "this"));
          }
        }
        function reportLikelyUnsafeImportRequiredError(specifier) {
          if (errorNameNode) {
            context.addDiagnostic(ts3.createDiagnosticForNode(errorNameNode, ts3.Diagnostics.The_inferred_type_of_0_cannot_be_named_without_a_reference_to_1_This_is_likely_not_portable_A_type_annotation_is_necessary, ts3.declarationNameToString(errorNameNode), specifier));
          }
        }
        function reportTruncationError() {
          if (errorNameNode || errorFallbackNode) {
            context.addDiagnostic(ts3.createDiagnosticForNode(errorNameNode || errorFallbackNode, ts3.Diagnostics.The_inferred_type_of_this_node_exceeds_the_maximum_length_the_compiler_will_serialize_An_explicit_type_annotation_is_needed));
          }
        }
        function reportNonlocalAugmentation(containingFile, parentSymbol, symbol) {
          var _a2;
          var primaryDeclaration = (_a2 = parentSymbol.declarations) === null || _a2 === void 0 ? void 0 : _a2.find(function(d) {
            return ts3.getSourceFileOfNode(d) === containingFile;
          });
          var augmentingDeclarations = ts3.filter(symbol.declarations, function(d) {
            return ts3.getSourceFileOfNode(d) !== containingFile;
          });
          if (augmentingDeclarations) {
            for (var _i = 0, augmentingDeclarations_1 = augmentingDeclarations; _i < augmentingDeclarations_1.length; _i++) {
              var augmentations = augmentingDeclarations_1[_i];
              context.addDiagnostic(ts3.addRelatedInfo(ts3.createDiagnosticForNode(augmentations, ts3.Diagnostics.Declaration_augments_declaration_in_another_file_This_cannot_be_serialized), ts3.createDiagnosticForNode(primaryDeclaration, ts3.Diagnostics.This_is_the_declaration_being_augmented_Consider_moving_the_augmenting_declaration_into_the_same_file)));
            }
          }
        }
        function transformDeclarationsForJS(sourceFile, bundled) {
          var oldDiag = getSymbolAccessibilityDiagnostic;
          getSymbolAccessibilityDiagnostic = function(s2) {
            return s2.errorNode && ts3.canProduceDiagnostics(s2.errorNode) ? ts3.createGetSymbolAccessibilityDiagnosticForNode(s2.errorNode)(s2) : {
              diagnosticMessage: s2.errorModuleName ? ts3.Diagnostics.Declaration_emit_for_this_file_requires_using_private_name_0_from_module_1_An_explicit_type_annotation_may_unblock_declaration_emit : ts3.Diagnostics.Declaration_emit_for_this_file_requires_using_private_name_0_An_explicit_type_annotation_may_unblock_declaration_emit,
              errorNode: s2.errorNode || sourceFile
            };
          };
          var result2 = resolver.getDeclarationStatementsForSourceFile(sourceFile, declarationEmitNodeBuilderFlags, symbolTracker, bundled);
          getSymbolAccessibilityDiagnostic = oldDiag;
          return result2;
        }
        function transformRoot(node) {
          if (node.kind === 298 && node.isDeclarationFile) {
            return node;
          }
          if (node.kind === 299) {
            isBundledEmit = true;
            refs = new ts3.Map();
            libs = new ts3.Map();
            var hasNoDefaultLib_1 = false;
            var bundle = factory.createBundle(ts3.map(node.sourceFiles, function(sourceFile) {
              if (sourceFile.isDeclarationFile)
                return void 0;
              hasNoDefaultLib_1 = hasNoDefaultLib_1 || sourceFile.hasNoDefaultLib;
              currentSourceFile = sourceFile;
              enclosingDeclaration = sourceFile;
              lateMarkedStatements = void 0;
              suppressNewDiagnosticContexts = false;
              lateStatementReplacementMap = new ts3.Map();
              getSymbolAccessibilityDiagnostic = throwDiagnostic;
              needsScopeFixMarker = false;
              resultHasScopeMarker = false;
              collectReferences(sourceFile, refs);
              collectLibs(sourceFile, libs);
              if (ts3.isExternalOrCommonJsModule(sourceFile) || ts3.isJsonSourceFile(sourceFile)) {
                resultHasExternalModuleIndicator = false;
                needsDeclare = false;
                var statements2 = ts3.isSourceFileJS(sourceFile) ? factory.createNodeArray(transformDeclarationsForJS(sourceFile, true)) : ts3.visitNodes(sourceFile.statements, visitDeclarationStatements);
                var newFile = factory.updateSourceFile(sourceFile, [factory.createModuleDeclaration([], [factory.createModifier(133)], factory.createStringLiteral(ts3.getResolvedExternalModuleName(context.getEmitHost(), sourceFile)), factory.createModuleBlock(ts3.setTextRange(factory.createNodeArray(transformAndReplaceLatePaintedStatements(statements2)), sourceFile.statements)))], true, [], [], false, []);
                return newFile;
              }
              needsDeclare = true;
              var updated2 = ts3.isSourceFileJS(sourceFile) ? factory.createNodeArray(transformDeclarationsForJS(sourceFile)) : ts3.visitNodes(sourceFile.statements, visitDeclarationStatements);
              return factory.updateSourceFile(sourceFile, transformAndReplaceLatePaintedStatements(updated2), true, [], [], false, []);
            }), ts3.mapDefined(node.prepends, function(prepend) {
              if (prepend.kind === 301) {
                var sourceFile = ts3.createUnparsedSourceFile(prepend, "dts", stripInternal);
                hasNoDefaultLib_1 = hasNoDefaultLib_1 || !!sourceFile.hasNoDefaultLib;
                collectReferences(sourceFile, refs);
                recordTypeReferenceDirectivesIfNecessary(sourceFile.typeReferenceDirectives);
                collectLibs(sourceFile, libs);
                return sourceFile;
              }
              return prepend;
            }));
            bundle.syntheticFileReferences = [];
            bundle.syntheticTypeReferences = getFileReferencesForUsedTypeReferences();
            bundle.syntheticLibReferences = getLibReferences();
            bundle.hasNoDefaultLib = hasNoDefaultLib_1;
            var outputFilePath_1 = ts3.getDirectoryPath(ts3.normalizeSlashes(ts3.getOutputPathsFor(node, host, true).declarationFilePath));
            var referenceVisitor_1 = mapReferencesIntoArray(bundle.syntheticFileReferences, outputFilePath_1);
            refs.forEach(referenceVisitor_1);
            return bundle;
          }
          needsDeclare = true;
          needsScopeFixMarker = false;
          resultHasScopeMarker = false;
          enclosingDeclaration = node;
          currentSourceFile = node;
          getSymbolAccessibilityDiagnostic = throwDiagnostic;
          isBundledEmit = false;
          resultHasExternalModuleIndicator = false;
          suppressNewDiagnosticContexts = false;
          lateMarkedStatements = void 0;
          lateStatementReplacementMap = new ts3.Map();
          necessaryTypeReferences = void 0;
          refs = collectReferences(currentSourceFile, new ts3.Map());
          libs = collectLibs(currentSourceFile, new ts3.Map());
          var references = [];
          var outputFilePath = ts3.getDirectoryPath(ts3.normalizeSlashes(ts3.getOutputPathsFor(node, host, true).declarationFilePath));
          var referenceVisitor = mapReferencesIntoArray(references, outputFilePath);
          var combinedStatements;
          if (ts3.isSourceFileJS(currentSourceFile)) {
            combinedStatements = factory.createNodeArray(transformDeclarationsForJS(node));
            refs.forEach(referenceVisitor);
            emittedImports = ts3.filter(combinedStatements, ts3.isAnyImportSyntax);
          } else {
            var statements = ts3.visitNodes(node.statements, visitDeclarationStatements);
            combinedStatements = ts3.setTextRange(factory.createNodeArray(transformAndReplaceLatePaintedStatements(statements)), node.statements);
            refs.forEach(referenceVisitor);
            emittedImports = ts3.filter(combinedStatements, ts3.isAnyImportSyntax);
            if (ts3.isExternalModule(node) && (!resultHasExternalModuleIndicator || needsScopeFixMarker && !resultHasScopeMarker)) {
              combinedStatements = ts3.setTextRange(factory.createNodeArray(__spreadArray(__spreadArray([], combinedStatements), [ts3.createEmptyExports(factory)])), combinedStatements);
            }
          }
          var updated = factory.updateSourceFile(node, combinedStatements, true, references, getFileReferencesForUsedTypeReferences(), node.hasNoDefaultLib, getLibReferences());
          updated.exportedModulesFromDeclarationEmit = exportedModulesFromDeclarationEmit;
          return updated;
          function getLibReferences() {
            return ts3.map(ts3.arrayFrom(libs.keys()), function(lib) {
              return { fileName: lib, pos: -1, end: -1 };
            });
          }
          function getFileReferencesForUsedTypeReferences() {
            return necessaryTypeReferences ? ts3.mapDefined(ts3.arrayFrom(necessaryTypeReferences.keys()), getFileReferenceForTypeName) : [];
          }
          function getFileReferenceForTypeName(typeName) {
            if (emittedImports) {
              for (var _i = 0, emittedImports_1 = emittedImports; _i < emittedImports_1.length; _i++) {
                var importStatement = emittedImports_1[_i];
                if (ts3.isImportEqualsDeclaration(importStatement) && ts3.isExternalModuleReference(importStatement.moduleReference)) {
                  var expr = importStatement.moduleReference.expression;
                  if (ts3.isStringLiteralLike(expr) && expr.text === typeName) {
                    return void 0;
                  }
                } else if (ts3.isImportDeclaration(importStatement) && ts3.isStringLiteral(importStatement.moduleSpecifier) && importStatement.moduleSpecifier.text === typeName) {
                  return void 0;
                }
              }
            }
            return { fileName: typeName, pos: -1, end: -1 };
          }
          function mapReferencesIntoArray(references2, outputFilePath2) {
            return function(file) {
              var declFileName;
              if (file.isDeclarationFile) {
                declFileName = file.fileName;
              } else {
                if (isBundledEmit && ts3.contains(node.sourceFiles, file))
                  return;
                var paths = ts3.getOutputPathsFor(file, host, true);
                declFileName = paths.declarationFilePath || paths.jsFilePath || file.fileName;
              }
              if (declFileName) {
                var specifier = ts3.moduleSpecifiers.getModuleSpecifier(options, currentSourceFile, ts3.toPath(outputFilePath2, host.getCurrentDirectory(), host.getCanonicalFileName), ts3.toPath(declFileName, host.getCurrentDirectory(), host.getCanonicalFileName), host, void 0);
                if (!ts3.pathIsRelative(specifier)) {
                  recordTypeReferenceDirectivesIfNecessary([specifier]);
                  return;
                }
                var fileName = ts3.getRelativePathToDirectoryOrUrl(outputFilePath2, declFileName, host.getCurrentDirectory(), host.getCanonicalFileName, false);
                if (ts3.startsWith(fileName, "./") && ts3.hasExtension(fileName)) {
                  fileName = fileName.substring(2);
                }
                if (ts3.startsWith(fileName, "node_modules/") || ts3.pathContainsNodeModules(fileName)) {
                  return;
                }
                references2.push({ pos: -1, end: -1, fileName });
              }
            };
          }
        }
        function collectReferences(sourceFile, ret) {
          if (noResolve || !ts3.isUnparsedSource(sourceFile) && ts3.isSourceFileJS(sourceFile))
            return ret;
          ts3.forEach(sourceFile.referencedFiles, function(f) {
            var elem = host.getSourceFileFromReference(sourceFile, f);
            if (elem) {
              ret.set(ts3.getOriginalNodeId(elem), elem);
            }
          });
          return ret;
        }
        function collectLibs(sourceFile, ret) {
          ts3.forEach(sourceFile.libReferenceDirectives, function(ref2) {
            var lib = host.getLibFileFromReference(ref2);
            if (lib) {
              ret.set(ts3.toFileNameLowerCase(ref2.fileName), true);
            }
          });
          return ret;
        }
        function filterBindingPatternInitializers(name) {
          if (name.kind === 78) {
            return name;
          } else {
            if (name.kind === 198) {
              return factory.updateArrayBindingPattern(name, ts3.visitNodes(name.elements, visitBindingElement));
            } else {
              return factory.updateObjectBindingPattern(name, ts3.visitNodes(name.elements, visitBindingElement));
            }
          }
          function visitBindingElement(elem) {
            if (elem.kind === 223) {
              return elem;
            }
            return factory.updateBindingElement(elem, elem.dotDotDotToken, elem.propertyName, filterBindingPatternInitializers(elem.name), shouldPrintWithInitializer(elem) ? elem.initializer : void 0);
          }
        }
        function ensureParameter(p, modifierMask, type3) {
          var oldDiag;
          if (!suppressNewDiagnosticContexts) {
            oldDiag = getSymbolAccessibilityDiagnostic;
            getSymbolAccessibilityDiagnostic = ts3.createGetSymbolAccessibilityDiagnosticForNode(p);
          }
          var newParam = factory.updateParameterDeclaration(p, void 0, maskModifiers(p, modifierMask), p.dotDotDotToken, filterBindingPatternInitializers(p.name), resolver.isOptionalParameter(p) ? p.questionToken || factory.createToken(57) : void 0, ensureType(p, type3 || p.type, true), ensureNoInitializer(p));
          if (!suppressNewDiagnosticContexts) {
            getSymbolAccessibilityDiagnostic = oldDiag;
          }
          return newParam;
        }
        function shouldPrintWithInitializer(node) {
          return canHaveLiteralInitializer(node) && resolver.isLiteralConstDeclaration(ts3.getParseTreeNode(node));
        }
        function ensureNoInitializer(node) {
          if (shouldPrintWithInitializer(node)) {
            return resolver.createLiteralConstValue(ts3.getParseTreeNode(node), symbolTracker);
          }
          return void 0;
        }
        function ensureType(node, type3, ignorePrivate) {
          if (!ignorePrivate && ts3.hasEffectiveModifier(node, 8)) {
            return;
          }
          if (shouldPrintWithInitializer(node)) {
            return;
          }
          var shouldUseResolverType = node.kind === 161 && (resolver.isRequiredInitializedParameter(node) || resolver.isOptionalUninitializedParameterProperty(node));
          if (type3 && !shouldUseResolverType) {
            return ts3.visitNode(type3, visitDeclarationSubtree);
          }
          if (!ts3.getParseTreeNode(node)) {
            return type3 ? ts3.visitNode(type3, visitDeclarationSubtree) : factory.createKeywordTypeNode(128);
          }
          if (node.kind === 169) {
            return factory.createKeywordTypeNode(128);
          }
          errorNameNode = node.name;
          var oldDiag;
          if (!suppressNewDiagnosticContexts) {
            oldDiag = getSymbolAccessibilityDiagnostic;
            getSymbolAccessibilityDiagnostic = ts3.createGetSymbolAccessibilityDiagnosticForNode(node);
          }
          if (node.kind === 250 || node.kind === 199) {
            return cleanup(resolver.createTypeOfDeclaration(node, enclosingDeclaration, declarationEmitNodeBuilderFlags, symbolTracker));
          }
          if (node.kind === 161 || node.kind === 164 || node.kind === 163) {
            if (!node.initializer)
              return cleanup(resolver.createTypeOfDeclaration(node, enclosingDeclaration, declarationEmitNodeBuilderFlags, symbolTracker, shouldUseResolverType));
            return cleanup(resolver.createTypeOfDeclaration(node, enclosingDeclaration, declarationEmitNodeBuilderFlags, symbolTracker, shouldUseResolverType) || resolver.createTypeOfExpression(node.initializer, enclosingDeclaration, declarationEmitNodeBuilderFlags, symbolTracker));
          }
          return cleanup(resolver.createReturnTypeOfSignatureDeclaration(node, enclosingDeclaration, declarationEmitNodeBuilderFlags, symbolTracker));
          function cleanup(returnValue) {
            errorNameNode = void 0;
            if (!suppressNewDiagnosticContexts) {
              getSymbolAccessibilityDiagnostic = oldDiag;
            }
            return returnValue || factory.createKeywordTypeNode(128);
          }
        }
        function isDeclarationAndNotVisible(node) {
          node = ts3.getParseTreeNode(node);
          switch (node.kind) {
            case 252:
            case 257:
            case 254:
            case 253:
            case 255:
            case 256:
              return !resolver.isDeclarationVisible(node);
            case 250:
              return !getBindingNameVisible(node);
            case 261:
            case 262:
            case 268:
            case 267:
              return false;
          }
          return false;
        }
        function getBindingNameVisible(elem) {
          if (ts3.isOmittedExpression(elem)) {
            return false;
          }
          if (ts3.isBindingPattern(elem.name)) {
            return ts3.some(elem.name.elements, getBindingNameVisible);
          } else {
            return resolver.isDeclarationVisible(elem);
          }
        }
        function updateParamsList(node, params, modifierMask) {
          if (ts3.hasEffectiveModifier(node, 8)) {
            return void 0;
          }
          var newParams = ts3.map(params, function(p) {
            return ensureParameter(p, modifierMask);
          });
          if (!newParams) {
            return void 0;
          }
          return factory.createNodeArray(newParams, params.hasTrailingComma);
        }
        function updateAccessorParamsList(input, isPrivate) {
          var newParams;
          if (!isPrivate) {
            var thisParameter = ts3.getThisParameter(input);
            if (thisParameter) {
              newParams = [ensureParameter(thisParameter)];
            }
          }
          if (ts3.isSetAccessorDeclaration(input)) {
            var newValueParameter = void 0;
            if (!isPrivate) {
              var valueParameter = ts3.getSetAccessorValueParameter(input);
              if (valueParameter) {
                var accessorType = getTypeAnnotationFromAllAccessorDeclarations(input, resolver.getAllAccessorDeclarations(input));
                newValueParameter = ensureParameter(valueParameter, void 0, accessorType);
              }
            }
            if (!newValueParameter) {
              newValueParameter = factory.createParameterDeclaration(void 0, void 0, void 0, "value");
            }
            newParams = ts3.append(newParams, newValueParameter);
          }
          return factory.createNodeArray(newParams || ts3.emptyArray);
        }
        function ensureTypeParams(node, params) {
          return ts3.hasEffectiveModifier(node, 8) ? void 0 : ts3.visitNodes(params, visitDeclarationSubtree);
        }
        function isEnclosingDeclaration(node) {
          return ts3.isSourceFile(node) || ts3.isTypeAliasDeclaration(node) || ts3.isModuleDeclaration(node) || ts3.isClassDeclaration(node) || ts3.isInterfaceDeclaration(node) || ts3.isFunctionLike(node) || ts3.isIndexSignatureDeclaration(node) || ts3.isMappedTypeNode(node);
        }
        function checkEntityNameVisibility(entityName, enclosingDeclaration2) {
          var visibilityResult = resolver.isEntityNameVisible(entityName, enclosingDeclaration2);
          handleSymbolAccessibilityError(visibilityResult);
          recordTypeReferenceDirectivesIfNecessary(resolver.getTypeReferenceDirectivesForEntityName(entityName));
        }
        function preserveJsDoc(updated, original) {
          if (ts3.hasJSDocNodes(updated) && ts3.hasJSDocNodes(original)) {
            updated.jsDoc = original.jsDoc;
          }
          return ts3.setCommentRange(updated, ts3.getCommentRange(original));
        }
        function rewriteModuleSpecifier(parent, input) {
          if (!input)
            return void 0;
          resultHasExternalModuleIndicator = resultHasExternalModuleIndicator || parent.kind !== 257 && parent.kind !== 196;
          if (ts3.isStringLiteralLike(input)) {
            if (isBundledEmit) {
              var newName = ts3.getExternalModuleNameFromDeclaration(context.getEmitHost(), resolver, parent);
              if (newName) {
                return factory.createStringLiteral(newName);
              }
            } else {
              var symbol = resolver.getSymbolOfExternalModuleSpecifier(input);
              if (symbol) {
                (exportedModulesFromDeclarationEmit || (exportedModulesFromDeclarationEmit = [])).push(symbol);
              }
            }
          }
          return input;
        }
        function transformImportEqualsDeclaration(decl) {
          if (!resolver.isDeclarationVisible(decl))
            return;
          if (decl.moduleReference.kind === 273) {
            var specifier = ts3.getExternalModuleImportEqualsDeclarationExpression(decl);
            return factory.updateImportEqualsDeclaration(decl, void 0, decl.modifiers, decl.isTypeOnly, decl.name, factory.updateExternalModuleReference(decl.moduleReference, rewriteModuleSpecifier(decl, specifier)));
          } else {
            var oldDiag = getSymbolAccessibilityDiagnostic;
            getSymbolAccessibilityDiagnostic = ts3.createGetSymbolAccessibilityDiagnosticForNode(decl);
            checkEntityNameVisibility(decl.moduleReference, enclosingDeclaration);
            getSymbolAccessibilityDiagnostic = oldDiag;
            return decl;
          }
        }
        function transformImportDeclaration(decl) {
          if (!decl.importClause) {
            return factory.updateImportDeclaration(decl, void 0, decl.modifiers, decl.importClause, rewriteModuleSpecifier(decl, decl.moduleSpecifier));
          }
          var visibleDefaultBinding = decl.importClause && decl.importClause.name && resolver.isDeclarationVisible(decl.importClause) ? decl.importClause.name : void 0;
          if (!decl.importClause.namedBindings) {
            return visibleDefaultBinding && factory.updateImportDeclaration(decl, void 0, decl.modifiers, factory.updateImportClause(decl.importClause, decl.importClause.isTypeOnly, visibleDefaultBinding, void 0), rewriteModuleSpecifier(decl, decl.moduleSpecifier));
          }
          if (decl.importClause.namedBindings.kind === 264) {
            var namedBindings = resolver.isDeclarationVisible(decl.importClause.namedBindings) ? decl.importClause.namedBindings : void 0;
            return visibleDefaultBinding || namedBindings ? factory.updateImportDeclaration(decl, void 0, decl.modifiers, factory.updateImportClause(decl.importClause, decl.importClause.isTypeOnly, visibleDefaultBinding, namedBindings), rewriteModuleSpecifier(decl, decl.moduleSpecifier)) : void 0;
          }
          var bindingList = ts3.mapDefined(decl.importClause.namedBindings.elements, function(b2) {
            return resolver.isDeclarationVisible(b2) ? b2 : void 0;
          });
          if (bindingList && bindingList.length || visibleDefaultBinding) {
            return factory.updateImportDeclaration(decl, void 0, decl.modifiers, factory.updateImportClause(decl.importClause, decl.importClause.isTypeOnly, visibleDefaultBinding, bindingList && bindingList.length ? factory.updateNamedImports(decl.importClause.namedBindings, bindingList) : void 0), rewriteModuleSpecifier(decl, decl.moduleSpecifier));
          }
          if (resolver.isImportRequiredByAugmentation(decl)) {
            return factory.updateImportDeclaration(decl, void 0, decl.modifiers, void 0, rewriteModuleSpecifier(decl, decl.moduleSpecifier));
          }
        }
        function transformAndReplaceLatePaintedStatements(statements) {
          while (ts3.length(lateMarkedStatements)) {
            var i3 = lateMarkedStatements.shift();
            if (!ts3.isLateVisibilityPaintedStatement(i3)) {
              return ts3.Debug.fail("Late replaced statement was found which is not handled by the declaration transformer!: " + (ts3.SyntaxKind ? ts3.SyntaxKind[i3.kind] : i3.kind));
            }
            var priorNeedsDeclare = needsDeclare;
            needsDeclare = i3.parent && ts3.isSourceFile(i3.parent) && !(ts3.isExternalModule(i3.parent) && isBundledEmit);
            var result2 = transformTopLevelDeclaration(i3);
            needsDeclare = priorNeedsDeclare;
            lateStatementReplacementMap.set(ts3.getOriginalNodeId(i3), result2);
          }
          return ts3.visitNodes(statements, visitLateVisibilityMarkedStatements);
          function visitLateVisibilityMarkedStatements(statement) {
            if (ts3.isLateVisibilityPaintedStatement(statement)) {
              var key2 = ts3.getOriginalNodeId(statement);
              if (lateStatementReplacementMap.has(key2)) {
                var result3 = lateStatementReplacementMap.get(key2);
                lateStatementReplacementMap.delete(key2);
                if (result3) {
                  if (ts3.isArray(result3) ? ts3.some(result3, ts3.needsScopeMarker) : ts3.needsScopeMarker(result3)) {
                    needsScopeFixMarker = true;
                  }
                  if (ts3.isSourceFile(statement.parent) && (ts3.isArray(result3) ? ts3.some(result3, ts3.isExternalModuleIndicator) : ts3.isExternalModuleIndicator(result3))) {
                    resultHasExternalModuleIndicator = true;
                  }
                }
                return result3;
              }
            }
            return statement;
          }
        }
        function visitDeclarationSubtree(input) {
          if (shouldStripInternal(input))
            return;
          if (ts3.isDeclaration(input)) {
            if (isDeclarationAndNotVisible(input))
              return;
            if (ts3.hasDynamicName(input) && !resolver.isLateBound(ts3.getParseTreeNode(input))) {
              return;
            }
          }
          if (ts3.isFunctionLike(input) && resolver.isImplementationOfOverload(input))
            return;
          if (ts3.isSemicolonClassElement(input))
            return;
          var previousEnclosingDeclaration;
          if (isEnclosingDeclaration(input)) {
            previousEnclosingDeclaration = enclosingDeclaration;
            enclosingDeclaration = input;
          }
          var oldDiag = getSymbolAccessibilityDiagnostic;
          var canProduceDiagnostic = ts3.canProduceDiagnostics(input);
          var oldWithinObjectLiteralType = suppressNewDiagnosticContexts;
          var shouldEnterSuppressNewDiagnosticsContextContext = (input.kind === 178 || input.kind === 191) && input.parent.kind !== 255;
          if (ts3.isMethodDeclaration(input) || ts3.isMethodSignature(input)) {
            if (ts3.hasEffectiveModifier(input, 8)) {
              if (input.symbol && input.symbol.declarations && input.symbol.declarations[0] !== input)
                return;
              return cleanup(factory.createPropertyDeclaration(void 0, ensureModifiers(input), input.name, void 0, void 0, void 0));
            }
          }
          if (canProduceDiagnostic && !suppressNewDiagnosticContexts) {
            getSymbolAccessibilityDiagnostic = ts3.createGetSymbolAccessibilityDiagnosticForNode(input);
          }
          if (ts3.isTypeQueryNode(input)) {
            checkEntityNameVisibility(input.exprName, enclosingDeclaration);
          }
          if (shouldEnterSuppressNewDiagnosticsContextContext) {
            suppressNewDiagnosticContexts = true;
          }
          if (isProcessedComponent(input)) {
            switch (input.kind) {
              case 224: {
                if (ts3.isEntityName(input.expression) || ts3.isEntityNameExpression(input.expression)) {
                  checkEntityNameVisibility(input.expression, enclosingDeclaration);
                }
                var node = ts3.visitEachChild(input, visitDeclarationSubtree, context);
                return cleanup(factory.updateExpressionWithTypeArguments(node, node.expression, node.typeArguments));
              }
              case 174: {
                checkEntityNameVisibility(input.typeName, enclosingDeclaration);
                var node = ts3.visitEachChild(input, visitDeclarationSubtree, context);
                return cleanup(factory.updateTypeReferenceNode(node, node.typeName, node.typeArguments));
              }
              case 171:
                return cleanup(factory.updateConstructSignature(input, ensureTypeParams(input, input.typeParameters), updateParamsList(input, input.parameters), ensureType(input, input.type)));
              case 167: {
                var ctor = factory.createConstructorDeclaration(void 0, ensureModifiers(input), updateParamsList(input, input.parameters, 0), void 0);
                return cleanup(ctor);
              }
              case 166: {
                if (ts3.isPrivateIdentifier(input.name)) {
                  return cleanup(void 0);
                }
                var sig = factory.createMethodDeclaration(void 0, ensureModifiers(input), void 0, input.name, input.questionToken, ensureTypeParams(input, input.typeParameters), updateParamsList(input, input.parameters), ensureType(input, input.type), void 0);
                return cleanup(sig);
              }
              case 168: {
                if (ts3.isPrivateIdentifier(input.name)) {
                  return cleanup(void 0);
                }
                var accessorType = getTypeAnnotationFromAllAccessorDeclarations(input, resolver.getAllAccessorDeclarations(input));
                return cleanup(factory.updateGetAccessorDeclaration(input, void 0, ensureModifiers(input), input.name, updateAccessorParamsList(input, ts3.hasEffectiveModifier(input, 8)), ensureType(input, accessorType), void 0));
              }
              case 169: {
                if (ts3.isPrivateIdentifier(input.name)) {
                  return cleanup(void 0);
                }
                return cleanup(factory.updateSetAccessorDeclaration(input, void 0, ensureModifiers(input), input.name, updateAccessorParamsList(input, ts3.hasEffectiveModifier(input, 8)), void 0));
              }
              case 164:
                if (ts3.isPrivateIdentifier(input.name)) {
                  return cleanup(void 0);
                }
                return cleanup(factory.updatePropertyDeclaration(input, void 0, ensureModifiers(input), input.name, input.questionToken, ensureType(input, input.type), ensureNoInitializer(input)));
              case 163:
                if (ts3.isPrivateIdentifier(input.name)) {
                  return cleanup(void 0);
                }
                return cleanup(factory.updatePropertySignature(input, ensureModifiers(input), input.name, input.questionToken, ensureType(input, input.type)));
              case 165: {
                if (ts3.isPrivateIdentifier(input.name)) {
                  return cleanup(void 0);
                }
                return cleanup(factory.updateMethodSignature(input, ensureModifiers(input), input.name, input.questionToken, ensureTypeParams(input, input.typeParameters), updateParamsList(input, input.parameters), ensureType(input, input.type)));
              }
              case 170: {
                return cleanup(factory.updateCallSignature(input, ensureTypeParams(input, input.typeParameters), updateParamsList(input, input.parameters), ensureType(input, input.type)));
              }
              case 172: {
                return cleanup(factory.updateIndexSignature(input, void 0, ensureModifiers(input), updateParamsList(input, input.parameters), ts3.visitNode(input.type, visitDeclarationSubtree) || factory.createKeywordTypeNode(128)));
              }
              case 250: {
                if (ts3.isBindingPattern(input.name)) {
                  return recreateBindingPattern(input.name);
                }
                shouldEnterSuppressNewDiagnosticsContextContext = true;
                suppressNewDiagnosticContexts = true;
                return cleanup(factory.updateVariableDeclaration(input, input.name, void 0, ensureType(input, input.type), ensureNoInitializer(input)));
              }
              case 160: {
                if (isPrivateMethodTypeParameter(input) && (input.default || input.constraint)) {
                  return cleanup(factory.updateTypeParameterDeclaration(input, input.name, void 0, void 0));
                }
                return cleanup(ts3.visitEachChild(input, visitDeclarationSubtree, context));
              }
              case 185: {
                var checkType = ts3.visitNode(input.checkType, visitDeclarationSubtree);
                var extendsType = ts3.visitNode(input.extendsType, visitDeclarationSubtree);
                var oldEnclosingDecl = enclosingDeclaration;
                enclosingDeclaration = input.trueType;
                var trueType = ts3.visitNode(input.trueType, visitDeclarationSubtree);
                enclosingDeclaration = oldEnclosingDecl;
                var falseType = ts3.visitNode(input.falseType, visitDeclarationSubtree);
                return cleanup(factory.updateConditionalTypeNode(input, checkType, extendsType, trueType, falseType));
              }
              case 175: {
                return cleanup(factory.updateFunctionTypeNode(input, ts3.visitNodes(input.typeParameters, visitDeclarationSubtree), updateParamsList(input, input.parameters), ts3.visitNode(input.type, visitDeclarationSubtree)));
              }
              case 176: {
                return cleanup(factory.updateConstructorTypeNode(input, ensureModifiers(input), ts3.visitNodes(input.typeParameters, visitDeclarationSubtree), updateParamsList(input, input.parameters), ts3.visitNode(input.type, visitDeclarationSubtree)));
              }
              case 196: {
                if (!ts3.isLiteralImportTypeNode(input))
                  return cleanup(input);
                return cleanup(factory.updateImportTypeNode(input, factory.updateLiteralTypeNode(input.argument, rewriteModuleSpecifier(input, input.argument.literal)), input.qualifier, ts3.visitNodes(input.typeArguments, visitDeclarationSubtree, ts3.isTypeNode), input.isTypeOf));
              }
              default:
                ts3.Debug.assertNever(input, "Attempted to process unhandled node kind: " + ts3.SyntaxKind[input.kind]);
            }
          }
          if (ts3.isTupleTypeNode(input) && ts3.getLineAndCharacterOfPosition(currentSourceFile, input.pos).line === ts3.getLineAndCharacterOfPosition(currentSourceFile, input.end).line) {
            ts3.setEmitFlags(input, 1);
          }
          return cleanup(ts3.visitEachChild(input, visitDeclarationSubtree, context));
          function cleanup(returnValue) {
            if (returnValue && canProduceDiagnostic && ts3.hasDynamicName(input)) {
              checkName(input);
            }
            if (isEnclosingDeclaration(input)) {
              enclosingDeclaration = previousEnclosingDeclaration;
            }
            if (canProduceDiagnostic && !suppressNewDiagnosticContexts) {
              getSymbolAccessibilityDiagnostic = oldDiag;
            }
            if (shouldEnterSuppressNewDiagnosticsContextContext) {
              suppressNewDiagnosticContexts = oldWithinObjectLiteralType;
            }
            if (returnValue === input) {
              return returnValue;
            }
            return returnValue && ts3.setOriginalNode(preserveJsDoc(returnValue, input), input);
          }
        }
        function isPrivateMethodTypeParameter(node) {
          return node.parent.kind === 166 && ts3.hasEffectiveModifier(node.parent, 8);
        }
        function visitDeclarationStatements(input) {
          if (!isPreservedDeclarationStatement(input)) {
            return;
          }
          if (shouldStripInternal(input))
            return;
          switch (input.kind) {
            case 268: {
              if (ts3.isSourceFile(input.parent)) {
                resultHasExternalModuleIndicator = true;
              }
              resultHasScopeMarker = true;
              return factory.updateExportDeclaration(input, void 0, input.modifiers, input.isTypeOnly, input.exportClause, rewriteModuleSpecifier(input, input.moduleSpecifier));
            }
            case 267: {
              if (ts3.isSourceFile(input.parent)) {
                resultHasExternalModuleIndicator = true;
              }
              resultHasScopeMarker = true;
              if (input.expression.kind === 78) {
                return input;
              } else {
                var newId = factory.createUniqueName("_default", 16);
                getSymbolAccessibilityDiagnostic = function() {
                  return {
                    diagnosticMessage: ts3.Diagnostics.Default_export_of_the_module_has_or_is_using_private_name_0,
                    errorNode: input
                  };
                };
                errorFallbackNode = input;
                var varDecl = factory.createVariableDeclaration(newId, void 0, resolver.createTypeOfExpression(input.expression, input, declarationEmitNodeBuilderFlags, symbolTracker), void 0);
                errorFallbackNode = void 0;
                var statement = factory.createVariableStatement(needsDeclare ? [factory.createModifier(133)] : [], factory.createVariableDeclarationList([varDecl], 2));
                return [statement, factory.updateExportAssignment(input, input.decorators, input.modifiers, newId)];
              }
            }
          }
          var result2 = transformTopLevelDeclaration(input);
          lateStatementReplacementMap.set(ts3.getOriginalNodeId(input), result2);
          return input;
        }
        function stripExportModifiers(statement) {
          if (ts3.isImportEqualsDeclaration(statement) || ts3.hasEffectiveModifier(statement, 512) || !ts3.canHaveModifiers(statement)) {
            return statement;
          }
          var modifiers = factory.createModifiersFromModifierFlags(ts3.getEffectiveModifierFlags(statement) & (27647 ^ 1));
          return factory.updateModifiers(statement, modifiers);
        }
        function transformTopLevelDeclaration(input) {
          if (shouldStripInternal(input))
            return;
          switch (input.kind) {
            case 261: {
              return transformImportEqualsDeclaration(input);
            }
            case 262: {
              return transformImportDeclaration(input);
            }
          }
          if (ts3.isDeclaration(input) && isDeclarationAndNotVisible(input))
            return;
          if (ts3.isFunctionLike(input) && resolver.isImplementationOfOverload(input))
            return;
          var previousEnclosingDeclaration;
          if (isEnclosingDeclaration(input)) {
            previousEnclosingDeclaration = enclosingDeclaration;
            enclosingDeclaration = input;
          }
          var canProdiceDiagnostic = ts3.canProduceDiagnostics(input);
          var oldDiag = getSymbolAccessibilityDiagnostic;
          if (canProdiceDiagnostic) {
            getSymbolAccessibilityDiagnostic = ts3.createGetSymbolAccessibilityDiagnosticForNode(input);
          }
          var previousNeedsDeclare = needsDeclare;
          switch (input.kind) {
            case 255:
              return cleanup(factory.updateTypeAliasDeclaration(input, void 0, ensureModifiers(input), input.name, ts3.visitNodes(input.typeParameters, visitDeclarationSubtree, ts3.isTypeParameterDeclaration), ts3.visitNode(input.type, visitDeclarationSubtree, ts3.isTypeNode)));
            case 254: {
              return cleanup(factory.updateInterfaceDeclaration(input, void 0, ensureModifiers(input), input.name, ensureTypeParams(input, input.typeParameters), transformHeritageClauses(input.heritageClauses), ts3.visitNodes(input.members, visitDeclarationSubtree)));
            }
            case 252: {
              var clean = cleanup(factory.updateFunctionDeclaration(input, void 0, ensureModifiers(input), void 0, input.name, ensureTypeParams(input, input.typeParameters), updateParamsList(input, input.parameters), ensureType(input, input.type), void 0));
              if (clean && resolver.isExpandoFunctionDeclaration(input)) {
                var props = resolver.getPropertiesOfContainerFunction(input);
                var fakespace_1 = ts3.parseNodeFactory.createModuleDeclaration(void 0, void 0, clean.name || factory.createIdentifier("_default"), factory.createModuleBlock([]), 16);
                ts3.setParent(fakespace_1, enclosingDeclaration);
                fakespace_1.locals = ts3.createSymbolTable(props);
                fakespace_1.symbol = props[0].parent;
                var exportMappings_1 = [];
                var declarations = ts3.mapDefined(props, function(p) {
                  if (!p.valueDeclaration || !ts3.isPropertyAccessExpression(p.valueDeclaration)) {
                    return void 0;
                  }
                  getSymbolAccessibilityDiagnostic = ts3.createGetSymbolAccessibilityDiagnosticForNode(p.valueDeclaration);
                  var type3 = resolver.createTypeOfDeclaration(p.valueDeclaration, fakespace_1, declarationEmitNodeBuilderFlags, symbolTracker);
                  getSymbolAccessibilityDiagnostic = oldDiag;
                  var nameStr = ts3.unescapeLeadingUnderscores(p.escapedName);
                  var isNonContextualKeywordName = ts3.isStringANonContextualKeyword(nameStr);
                  var name = isNonContextualKeywordName ? factory.getGeneratedNameForNode(p.valueDeclaration) : factory.createIdentifier(nameStr);
                  if (isNonContextualKeywordName) {
                    exportMappings_1.push([name, nameStr]);
                  }
                  var varDecl2 = factory.createVariableDeclaration(name, void 0, type3, void 0);
                  return factory.createVariableStatement(isNonContextualKeywordName ? void 0 : [factory.createToken(92)], factory.createVariableDeclarationList([varDecl2]));
                });
                if (!exportMappings_1.length) {
                  declarations = ts3.mapDefined(declarations, function(declaration) {
                    return factory.updateModifiers(declaration, 0);
                  });
                } else {
                  declarations.push(factory.createExportDeclaration(void 0, void 0, false, factory.createNamedExports(ts3.map(exportMappings_1, function(_a2) {
                    var gen = _a2[0], exp = _a2[1];
                    return factory.createExportSpecifier(gen, exp);
                  }))));
                }
                var namespaceDecl = factory.createModuleDeclaration(void 0, ensureModifiers(input), input.name, factory.createModuleBlock(declarations), 16);
                if (!ts3.hasEffectiveModifier(clean, 512)) {
                  return [clean, namespaceDecl];
                }
                var modifiers = factory.createModifiersFromModifierFlags(ts3.getEffectiveModifierFlags(clean) & ~513 | 2);
                var cleanDeclaration = factory.updateFunctionDeclaration(clean, void 0, modifiers, void 0, clean.name, clean.typeParameters, clean.parameters, clean.type, void 0);
                var namespaceDeclaration = factory.updateModuleDeclaration(namespaceDecl, void 0, modifiers, namespaceDecl.name, namespaceDecl.body);
                var exportDefaultDeclaration = factory.createExportAssignment(void 0, void 0, false, namespaceDecl.name);
                if (ts3.isSourceFile(input.parent)) {
                  resultHasExternalModuleIndicator = true;
                }
                resultHasScopeMarker = true;
                return [cleanDeclaration, namespaceDeclaration, exportDefaultDeclaration];
              } else {
                return clean;
              }
            }
            case 257: {
              needsDeclare = false;
              var inner = input.body;
              if (inner && inner.kind === 258) {
                var oldNeedsScopeFix = needsScopeFixMarker;
                var oldHasScopeFix = resultHasScopeMarker;
                resultHasScopeMarker = false;
                needsScopeFixMarker = false;
                var statements = ts3.visitNodes(inner.statements, visitDeclarationStatements);
                var lateStatements = transformAndReplaceLatePaintedStatements(statements);
                if (input.flags & 8388608) {
                  needsScopeFixMarker = false;
                }
                if (!ts3.isGlobalScopeAugmentation(input) && !hasScopeMarker(lateStatements) && !resultHasScopeMarker) {
                  if (needsScopeFixMarker) {
                    lateStatements = factory.createNodeArray(__spreadArray(__spreadArray([], lateStatements), [ts3.createEmptyExports(factory)]));
                  } else {
                    lateStatements = ts3.visitNodes(lateStatements, stripExportModifiers);
                  }
                }
                var body = factory.updateModuleBlock(inner, lateStatements);
                needsDeclare = previousNeedsDeclare;
                needsScopeFixMarker = oldNeedsScopeFix;
                resultHasScopeMarker = oldHasScopeFix;
                var mods = ensureModifiers(input);
                return cleanup(factory.updateModuleDeclaration(input, void 0, mods, ts3.isExternalModuleAugmentation(input) ? rewriteModuleSpecifier(input, input.name) : input.name, body));
              } else {
                needsDeclare = previousNeedsDeclare;
                var mods = ensureModifiers(input);
                needsDeclare = false;
                ts3.visitNode(inner, visitDeclarationStatements);
                var id = ts3.getOriginalNodeId(inner);
                var body = lateStatementReplacementMap.get(id);
                lateStatementReplacementMap.delete(id);
                return cleanup(factory.updateModuleDeclaration(input, void 0, mods, input.name, body));
              }
            }
            case 253: {
              errorNameNode = input.name;
              errorFallbackNode = input;
              var modifiers = factory.createNodeArray(ensureModifiers(input));
              var typeParameters = ensureTypeParams(input, input.typeParameters);
              var ctor = ts3.getFirstConstructorWithBody(input);
              var parameterProperties = void 0;
              if (ctor) {
                var oldDiag_1 = getSymbolAccessibilityDiagnostic;
                parameterProperties = ts3.compact(ts3.flatMap(ctor.parameters, function(param) {
                  if (!ts3.hasSyntacticModifier(param, 16476) || shouldStripInternal(param))
                    return;
                  getSymbolAccessibilityDiagnostic = ts3.createGetSymbolAccessibilityDiagnosticForNode(param);
                  if (param.name.kind === 78) {
                    return preserveJsDoc(factory.createPropertyDeclaration(void 0, ensureModifiers(param), param.name, param.questionToken, ensureType(param, param.type), ensureNoInitializer(param)), param);
                  } else {
                    return walkBindingPattern(param.name);
                  }
                  function walkBindingPattern(pattern) {
                    var elems;
                    for (var _i = 0, _a2 = pattern.elements; _i < _a2.length; _i++) {
                      var elem = _a2[_i];
                      if (ts3.isOmittedExpression(elem))
                        continue;
                      if (ts3.isBindingPattern(elem.name)) {
                        elems = ts3.concatenate(elems, walkBindingPattern(elem.name));
                      }
                      elems = elems || [];
                      elems.push(factory.createPropertyDeclaration(void 0, ensureModifiers(param), elem.name, void 0, ensureType(elem, void 0), void 0));
                    }
                    return elems;
                  }
                }));
                getSymbolAccessibilityDiagnostic = oldDiag_1;
              }
              var hasPrivateIdentifier = ts3.some(input.members, function(member) {
                return !!member.name && ts3.isPrivateIdentifier(member.name);
              });
              var privateIdentifier = hasPrivateIdentifier ? [
                factory.createPropertyDeclaration(void 0, void 0, factory.createPrivateIdentifier("#private"), void 0, void 0, void 0)
              ] : void 0;
              var memberNodes = ts3.concatenate(ts3.concatenate(privateIdentifier, parameterProperties), ts3.visitNodes(input.members, visitDeclarationSubtree));
              var members = factory.createNodeArray(memberNodes);
              var extendsClause_1 = ts3.getEffectiveBaseTypeNode(input);
              if (extendsClause_1 && !ts3.isEntityNameExpression(extendsClause_1.expression) && extendsClause_1.expression.kind !== 103) {
                var oldId = input.name ? ts3.unescapeLeadingUnderscores(input.name.escapedText) : "default";
                var newId_1 = factory.createUniqueName(oldId + "_base", 16);
                getSymbolAccessibilityDiagnostic = function() {
                  return {
                    diagnosticMessage: ts3.Diagnostics.extends_clause_of_exported_class_0_has_or_is_using_private_name_1,
                    errorNode: extendsClause_1,
                    typeName: input.name
                  };
                };
                var varDecl = factory.createVariableDeclaration(newId_1, void 0, resolver.createTypeOfExpression(extendsClause_1.expression, input, declarationEmitNodeBuilderFlags, symbolTracker), void 0);
                var statement = factory.createVariableStatement(needsDeclare ? [factory.createModifier(133)] : [], factory.createVariableDeclarationList([varDecl], 2));
                var heritageClauses = factory.createNodeArray(ts3.map(input.heritageClauses, function(clause) {
                  if (clause.token === 93) {
                    var oldDiag_2 = getSymbolAccessibilityDiagnostic;
                    getSymbolAccessibilityDiagnostic = ts3.createGetSymbolAccessibilityDiagnosticForNode(clause.types[0]);
                    var newClause = factory.updateHeritageClause(clause, ts3.map(clause.types, function(t2) {
                      return factory.updateExpressionWithTypeArguments(t2, newId_1, ts3.visitNodes(t2.typeArguments, visitDeclarationSubtree));
                    }));
                    getSymbolAccessibilityDiagnostic = oldDiag_2;
                    return newClause;
                  }
                  return factory.updateHeritageClause(clause, ts3.visitNodes(factory.createNodeArray(ts3.filter(clause.types, function(t2) {
                    return ts3.isEntityNameExpression(t2.expression) || t2.expression.kind === 103;
                  })), visitDeclarationSubtree));
                }));
                return [statement, cleanup(factory.updateClassDeclaration(input, void 0, modifiers, input.name, typeParameters, heritageClauses, members))];
              } else {
                var heritageClauses = transformHeritageClauses(input.heritageClauses);
                return cleanup(factory.updateClassDeclaration(input, void 0, modifiers, input.name, typeParameters, heritageClauses, members));
              }
            }
            case 233: {
              return cleanup(transformVariableStatement(input));
            }
            case 256: {
              return cleanup(factory.updateEnumDeclaration(input, void 0, factory.createNodeArray(ensureModifiers(input)), input.name, factory.createNodeArray(ts3.mapDefined(input.members, function(m) {
                if (shouldStripInternal(m))
                  return;
                var constValue = resolver.getConstantValue(m);
                return preserveJsDoc(factory.updateEnumMember(m, m.name, constValue !== void 0 ? typeof constValue === "string" ? factory.createStringLiteral(constValue) : factory.createNumericLiteral(constValue) : void 0), m);
              }))));
            }
          }
          return ts3.Debug.assertNever(input, "Unhandled top-level node in declaration emit: " + ts3.SyntaxKind[input.kind]);
          function cleanup(node) {
            if (isEnclosingDeclaration(input)) {
              enclosingDeclaration = previousEnclosingDeclaration;
            }
            if (canProdiceDiagnostic) {
              getSymbolAccessibilityDiagnostic = oldDiag;
            }
            if (input.kind === 257) {
              needsDeclare = previousNeedsDeclare;
            }
            if (node === input) {
              return node;
            }
            errorFallbackNode = void 0;
            errorNameNode = void 0;
            return node && ts3.setOriginalNode(preserveJsDoc(node, input), input);
          }
        }
        function transformVariableStatement(input) {
          if (!ts3.forEach(input.declarationList.declarations, getBindingNameVisible))
            return;
          var nodes = ts3.visitNodes(input.declarationList.declarations, visitDeclarationSubtree);
          if (!ts3.length(nodes))
            return;
          return factory.updateVariableStatement(input, factory.createNodeArray(ensureModifiers(input)), factory.updateVariableDeclarationList(input.declarationList, nodes));
        }
        function recreateBindingPattern(d) {
          return ts3.flatten(ts3.mapDefined(d.elements, function(e2) {
            return recreateBindingElement(e2);
          }));
        }
        function recreateBindingElement(e2) {
          if (e2.kind === 223) {
            return;
          }
          if (e2.name) {
            if (!getBindingNameVisible(e2))
              return;
            if (ts3.isBindingPattern(e2.name)) {
              return recreateBindingPattern(e2.name);
            } else {
              return factory.createVariableDeclaration(e2.name, void 0, ensureType(e2, void 0), void 0);
            }
          }
        }
        function checkName(node) {
          var oldDiag;
          if (!suppressNewDiagnosticContexts) {
            oldDiag = getSymbolAccessibilityDiagnostic;
            getSymbolAccessibilityDiagnostic = ts3.createGetSymbolAccessibilityDiagnosticForNodeName(node);
          }
          errorNameNode = node.name;
          ts3.Debug.assert(resolver.isLateBound(ts3.getParseTreeNode(node)));
          var decl = node;
          var entityName = decl.name.expression;
          checkEntityNameVisibility(entityName, enclosingDeclaration);
          if (!suppressNewDiagnosticContexts) {
            getSymbolAccessibilityDiagnostic = oldDiag;
          }
          errorNameNode = void 0;
        }
        function shouldStripInternal(node) {
          return !!stripInternal && !!node && isInternalDeclaration(node, currentSourceFile);
        }
        function isScopeMarker(node) {
          return ts3.isExportAssignment(node) || ts3.isExportDeclaration(node);
        }
        function hasScopeMarker(statements) {
          return ts3.some(statements, isScopeMarker);
        }
        function ensureModifiers(node) {
          var currentFlags = ts3.getEffectiveModifierFlags(node);
          var newFlags = ensureModifierFlags(node);
          if (currentFlags === newFlags) {
            return node.modifiers;
          }
          return factory.createModifiersFromModifierFlags(newFlags);
        }
        function ensureModifierFlags(node) {
          var mask2 = 27647 ^ (4 | 256 | 16384);
          var additions = needsDeclare && !isAlwaysType(node) ? 2 : 0;
          var parentIsFile = node.parent.kind === 298;
          if (!parentIsFile || isBundledEmit && parentIsFile && ts3.isExternalModule(node.parent)) {
            mask2 ^= 2;
            additions = 0;
          }
          return maskModifierFlags(node, mask2, additions);
        }
        function getTypeAnnotationFromAllAccessorDeclarations(node, accessors) {
          var accessorType = getTypeAnnotationFromAccessor(node);
          if (!accessorType && node !== accessors.firstAccessor) {
            accessorType = getTypeAnnotationFromAccessor(accessors.firstAccessor);
            getSymbolAccessibilityDiagnostic = ts3.createGetSymbolAccessibilityDiagnosticForNode(accessors.firstAccessor);
          }
          if (!accessorType && accessors.secondAccessor && node !== accessors.secondAccessor) {
            accessorType = getTypeAnnotationFromAccessor(accessors.secondAccessor);
            getSymbolAccessibilityDiagnostic = ts3.createGetSymbolAccessibilityDiagnosticForNode(accessors.secondAccessor);
          }
          return accessorType;
        }
        function transformHeritageClauses(nodes) {
          return factory.createNodeArray(ts3.filter(ts3.map(nodes, function(clause) {
            return factory.updateHeritageClause(clause, ts3.visitNodes(factory.createNodeArray(ts3.filter(clause.types, function(t2) {
              return ts3.isEntityNameExpression(t2.expression) || clause.token === 93 && t2.expression.kind === 103;
            })), visitDeclarationSubtree));
          }), function(clause) {
            return clause.types && !!clause.types.length;
          }));
        }
      }
      ts3.transformDeclarations = transformDeclarations;
      function isAlwaysType(node) {
        if (node.kind === 254) {
          return true;
        }
        return false;
      }
      function maskModifiers(node, modifierMask, modifierAdditions) {
        return ts3.factory.createModifiersFromModifierFlags(maskModifierFlags(node, modifierMask, modifierAdditions));
      }
      function maskModifierFlags(node, modifierMask, modifierAdditions) {
        if (modifierMask === void 0) {
          modifierMask = 27647 ^ 4;
        }
        if (modifierAdditions === void 0) {
          modifierAdditions = 0;
        }
        var flags = ts3.getEffectiveModifierFlags(node) & modifierMask | modifierAdditions;
        if (flags & 512 && !(flags & 1)) {
          flags ^= 1;
        }
        if (flags & 512 && flags & 2) {
          flags ^= 2;
        }
        return flags;
      }
      function getTypeAnnotationFromAccessor(accessor) {
        if (accessor) {
          return accessor.kind === 168 ? accessor.type : accessor.parameters.length > 0 ? accessor.parameters[0].type : void 0;
        }
      }
      function canHaveLiteralInitializer(node) {
        switch (node.kind) {
          case 164:
          case 163:
            return !ts3.hasEffectiveModifier(node, 8);
          case 161:
          case 250:
            return true;
        }
        return false;
      }
      function isPreservedDeclarationStatement(node) {
        switch (node.kind) {
          case 252:
          case 257:
          case 261:
          case 254:
          case 253:
          case 255:
          case 256:
          case 233:
          case 262:
          case 268:
          case 267:
            return true;
        }
        return false;
      }
      function isProcessedComponent(node) {
        switch (node.kind) {
          case 171:
          case 167:
          case 166:
          case 168:
          case 169:
          case 164:
          case 163:
          case 165:
          case 170:
          case 172:
          case 250:
          case 160:
          case 224:
          case 174:
          case 185:
          case 175:
          case 176:
          case 196:
            return true;
        }
        return false;
      }
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      function getModuleTransformer(moduleKind) {
        switch (moduleKind) {
          case ts3.ModuleKind.ESNext:
          case ts3.ModuleKind.ES2020:
          case ts3.ModuleKind.ES2015:
            return ts3.transformECMAScriptModule;
          case ts3.ModuleKind.System:
            return ts3.transformSystemModule;
          default:
            return ts3.transformModule;
        }
      }
      var TransformationState;
      (function(TransformationState2) {
        TransformationState2[TransformationState2["Uninitialized"] = 0] = "Uninitialized";
        TransformationState2[TransformationState2["Initialized"] = 1] = "Initialized";
        TransformationState2[TransformationState2["Completed"] = 2] = "Completed";
        TransformationState2[TransformationState2["Disposed"] = 3] = "Disposed";
      })(TransformationState || (TransformationState = {}));
      var SyntaxKindFeatureFlags;
      (function(SyntaxKindFeatureFlags2) {
        SyntaxKindFeatureFlags2[SyntaxKindFeatureFlags2["Substitution"] = 1] = "Substitution";
        SyntaxKindFeatureFlags2[SyntaxKindFeatureFlags2["EmitNotifications"] = 2] = "EmitNotifications";
      })(SyntaxKindFeatureFlags || (SyntaxKindFeatureFlags = {}));
      ts3.noTransformers = { scriptTransformers: ts3.emptyArray, declarationTransformers: ts3.emptyArray };
      function getTransformers(compilerOptions, customTransformers, emitOnlyDtsFiles) {
        return {
          scriptTransformers: getScriptTransformers(compilerOptions, customTransformers, emitOnlyDtsFiles),
          declarationTransformers: getDeclarationTransformers(customTransformers)
        };
      }
      ts3.getTransformers = getTransformers;
      function getScriptTransformers(compilerOptions, customTransformers, emitOnlyDtsFiles) {
        if (emitOnlyDtsFiles)
          return ts3.emptyArray;
        var languageVersion = ts3.getEmitScriptTarget(compilerOptions);
        var moduleKind = ts3.getEmitModuleKind(compilerOptions);
        var transformers = [];
        ts3.addRange(transformers, customTransformers && ts3.map(customTransformers.before, wrapScriptTransformerFactory));
        transformers.push(ts3.transformTypeScript);
        transformers.push(ts3.transformClassFields);
        if (ts3.getJSXTransformEnabled(compilerOptions)) {
          transformers.push(ts3.transformJsx);
        }
        if (languageVersion < 99) {
          transformers.push(ts3.transformESNext);
        }
        if (languageVersion < 8) {
          transformers.push(ts3.transformES2021);
        }
        if (languageVersion < 7) {
          transformers.push(ts3.transformES2020);
        }
        if (languageVersion < 6) {
          transformers.push(ts3.transformES2019);
        }
        if (languageVersion < 5) {
          transformers.push(ts3.transformES2018);
        }
        if (languageVersion < 4) {
          transformers.push(ts3.transformES2017);
        }
        if (languageVersion < 3) {
          transformers.push(ts3.transformES2016);
        }
        if (languageVersion < 2) {
          transformers.push(ts3.transformES2015);
          transformers.push(ts3.transformGenerators);
        }
        transformers.push(getModuleTransformer(moduleKind));
        if (languageVersion < 1) {
          transformers.push(ts3.transformES5);
        }
        ts3.addRange(transformers, customTransformers && ts3.map(customTransformers.after, wrapScriptTransformerFactory));
        return transformers;
      }
      function getDeclarationTransformers(customTransformers) {
        var transformers = [];
        transformers.push(ts3.transformDeclarations);
        ts3.addRange(transformers, customTransformers && ts3.map(customTransformers.afterDeclarations, wrapDeclarationTransformerFactory));
        return transformers;
      }
      function wrapCustomTransformer(transformer) {
        return function(node) {
          return ts3.isBundle(node) ? transformer.transformBundle(node) : transformer.transformSourceFile(node);
        };
      }
      function wrapCustomTransformerFactory(transformer, handleDefault) {
        return function(context) {
          var customTransformer = transformer(context);
          return typeof customTransformer === "function" ? handleDefault(context, customTransformer) : wrapCustomTransformer(customTransformer);
        };
      }
      function wrapScriptTransformerFactory(transformer) {
        return wrapCustomTransformerFactory(transformer, ts3.chainBundle);
      }
      function wrapDeclarationTransformerFactory(transformer) {
        return wrapCustomTransformerFactory(transformer, function(_, node) {
          return node;
        });
      }
      function noEmitSubstitution(_hint, node) {
        return node;
      }
      ts3.noEmitSubstitution = noEmitSubstitution;
      function noEmitNotification(hint, node, callback) {
        callback(hint, node);
      }
      ts3.noEmitNotification = noEmitNotification;
      function transformNodes(resolver, host, factory, options, nodes, transformers, allowDtsFiles) {
        var enabledSyntaxKindFeatures = new Array(345);
        var lexicalEnvironmentVariableDeclarations;
        var lexicalEnvironmentFunctionDeclarations;
        var lexicalEnvironmentStatements;
        var lexicalEnvironmentFlags = 0;
        var lexicalEnvironmentVariableDeclarationsStack = [];
        var lexicalEnvironmentFunctionDeclarationsStack = [];
        var lexicalEnvironmentStatementsStack = [];
        var lexicalEnvironmentFlagsStack = [];
        var lexicalEnvironmentStackOffset = 0;
        var lexicalEnvironmentSuspended = false;
        var blockScopedVariableDeclarationsStack = [];
        var blockScopeStackOffset = 0;
        var blockScopedVariableDeclarations;
        var emitHelpers;
        var onSubstituteNode = noEmitSubstitution;
        var onEmitNode = noEmitNotification;
        var state = 0;
        var diagnostics = [];
        var context = {
          factory,
          getCompilerOptions: function() {
            return options;
          },
          getEmitResolver: function() {
            return resolver;
          },
          getEmitHost: function() {
            return host;
          },
          getEmitHelperFactory: ts3.memoize(function() {
            return ts3.createEmitHelperFactory(context);
          }),
          startLexicalEnvironment,
          suspendLexicalEnvironment,
          resumeLexicalEnvironment,
          endLexicalEnvironment,
          setLexicalEnvironmentFlags,
          getLexicalEnvironmentFlags,
          hoistVariableDeclaration,
          hoistFunctionDeclaration,
          addInitializationStatement,
          startBlockScope,
          endBlockScope,
          addBlockScopedVariable,
          requestEmitHelper,
          readEmitHelpers,
          enableSubstitution,
          enableEmitNotification,
          isSubstitutionEnabled,
          isEmitNotificationEnabled,
          get onSubstituteNode() {
            return onSubstituteNode;
          },
          set onSubstituteNode(value) {
            ts3.Debug.assert(state < 1, "Cannot modify transformation hooks after initialization has completed.");
            ts3.Debug.assert(value !== void 0, "Value must not be 'undefined'");
            onSubstituteNode = value;
          },
          get onEmitNode() {
            return onEmitNode;
          },
          set onEmitNode(value) {
            ts3.Debug.assert(state < 1, "Cannot modify transformation hooks after initialization has completed.");
            ts3.Debug.assert(value !== void 0, "Value must not be 'undefined'");
            onEmitNode = value;
          },
          addDiagnostic: function(diag) {
            diagnostics.push(diag);
          }
        };
        for (var _i = 0, nodes_2 = nodes; _i < nodes_2.length; _i++) {
          var node = nodes_2[_i];
          ts3.disposeEmitNodes(ts3.getSourceFileOfNode(ts3.getParseTreeNode(node)));
        }
        ts3.performance.mark("beforeTransform");
        var transformersWithContext = transformers.map(function(t2) {
          return t2(context);
        });
        var transformation = function(node2) {
          for (var _i2 = 0, transformersWithContext_1 = transformersWithContext; _i2 < transformersWithContext_1.length; _i2++) {
            var transform = transformersWithContext_1[_i2];
            node2 = transform(node2);
          }
          return node2;
        };
        state = 1;
        var transformed = [];
        for (var _a2 = 0, nodes_3 = nodes; _a2 < nodes_3.length; _a2++) {
          var node = nodes_3[_a2];
          ts3.tracing === null || ts3.tracing === void 0 ? void 0 : ts3.tracing.push("emit", "transformNodes", node.kind === 298 ? { path: node.path } : { kind: node.kind, pos: node.pos, end: node.end });
          transformed.push((allowDtsFiles ? transformation : transformRoot)(node));
          ts3.tracing === null || ts3.tracing === void 0 ? void 0 : ts3.tracing.pop();
        }
        state = 2;
        ts3.performance.mark("afterTransform");
        ts3.performance.measure("transformTime", "beforeTransform", "afterTransform");
        return {
          transformed,
          substituteNode,
          emitNodeWithNotification,
          isEmitNotificationEnabled,
          dispose,
          diagnostics
        };
        function transformRoot(node2) {
          return node2 && (!ts3.isSourceFile(node2) || !node2.isDeclarationFile) ? transformation(node2) : node2;
        }
        function enableSubstitution(kind) {
          ts3.Debug.assert(state < 2, "Cannot modify the transformation context after transformation has completed.");
          enabledSyntaxKindFeatures[kind] |= 1;
        }
        function isSubstitutionEnabled(node2) {
          return (enabledSyntaxKindFeatures[node2.kind] & 1) !== 0 && (ts3.getEmitFlags(node2) & 4) === 0;
        }
        function substituteNode(hint, node2) {
          ts3.Debug.assert(state < 3, "Cannot substitute a node after the result is disposed.");
          return node2 && isSubstitutionEnabled(node2) && onSubstituteNode(hint, node2) || node2;
        }
        function enableEmitNotification(kind) {
          ts3.Debug.assert(state < 2, "Cannot modify the transformation context after transformation has completed.");
          enabledSyntaxKindFeatures[kind] |= 2;
        }
        function isEmitNotificationEnabled(node2) {
          return (enabledSyntaxKindFeatures[node2.kind] & 2) !== 0 || (ts3.getEmitFlags(node2) & 2) !== 0;
        }
        function emitNodeWithNotification(hint, node2, emitCallback) {
          ts3.Debug.assert(state < 3, "Cannot invoke TransformationResult callbacks after the result is disposed.");
          if (node2) {
            if (isEmitNotificationEnabled(node2)) {
              onEmitNode(hint, node2, emitCallback);
            } else {
              emitCallback(hint, node2);
            }
          }
        }
        function hoistVariableDeclaration(name) {
          ts3.Debug.assert(state > 0, "Cannot modify the lexical environment during initialization.");
          ts3.Debug.assert(state < 2, "Cannot modify the lexical environment after transformation has completed.");
          var decl = ts3.setEmitFlags(factory.createVariableDeclaration(name), 64);
          if (!lexicalEnvironmentVariableDeclarations) {
            lexicalEnvironmentVariableDeclarations = [decl];
          } else {
            lexicalEnvironmentVariableDeclarations.push(decl);
          }
          if (lexicalEnvironmentFlags & 1) {
            lexicalEnvironmentFlags |= 2;
          }
        }
        function hoistFunctionDeclaration(func2) {
          ts3.Debug.assert(state > 0, "Cannot modify the lexical environment during initialization.");
          ts3.Debug.assert(state < 2, "Cannot modify the lexical environment after transformation has completed.");
          ts3.setEmitFlags(func2, 1048576);
          if (!lexicalEnvironmentFunctionDeclarations) {
            lexicalEnvironmentFunctionDeclarations = [func2];
          } else {
            lexicalEnvironmentFunctionDeclarations.push(func2);
          }
        }
        function addInitializationStatement(node2) {
          ts3.Debug.assert(state > 0, "Cannot modify the lexical environment during initialization.");
          ts3.Debug.assert(state < 2, "Cannot modify the lexical environment after transformation has completed.");
          ts3.setEmitFlags(node2, 1048576);
          if (!lexicalEnvironmentStatements) {
            lexicalEnvironmentStatements = [node2];
          } else {
            lexicalEnvironmentStatements.push(node2);
          }
        }
        function startLexicalEnvironment() {
          ts3.Debug.assert(state > 0, "Cannot modify the lexical environment during initialization.");
          ts3.Debug.assert(state < 2, "Cannot modify the lexical environment after transformation has completed.");
          ts3.Debug.assert(!lexicalEnvironmentSuspended, "Lexical environment is suspended.");
          lexicalEnvironmentVariableDeclarationsStack[lexicalEnvironmentStackOffset] = lexicalEnvironmentVariableDeclarations;
          lexicalEnvironmentFunctionDeclarationsStack[lexicalEnvironmentStackOffset] = lexicalEnvironmentFunctionDeclarations;
          lexicalEnvironmentStatementsStack[lexicalEnvironmentStackOffset] = lexicalEnvironmentStatements;
          lexicalEnvironmentFlagsStack[lexicalEnvironmentStackOffset] = lexicalEnvironmentFlags;
          lexicalEnvironmentStackOffset++;
          lexicalEnvironmentVariableDeclarations = void 0;
          lexicalEnvironmentFunctionDeclarations = void 0;
          lexicalEnvironmentStatements = void 0;
          lexicalEnvironmentFlags = 0;
        }
        function suspendLexicalEnvironment() {
          ts3.Debug.assert(state > 0, "Cannot modify the lexical environment during initialization.");
          ts3.Debug.assert(state < 2, "Cannot modify the lexical environment after transformation has completed.");
          ts3.Debug.assert(!lexicalEnvironmentSuspended, "Lexical environment is already suspended.");
          lexicalEnvironmentSuspended = true;
        }
        function resumeLexicalEnvironment() {
          ts3.Debug.assert(state > 0, "Cannot modify the lexical environment during initialization.");
          ts3.Debug.assert(state < 2, "Cannot modify the lexical environment after transformation has completed.");
          ts3.Debug.assert(lexicalEnvironmentSuspended, "Lexical environment is not suspended.");
          lexicalEnvironmentSuspended = false;
        }
        function endLexicalEnvironment() {
          ts3.Debug.assert(state > 0, "Cannot modify the lexical environment during initialization.");
          ts3.Debug.assert(state < 2, "Cannot modify the lexical environment after transformation has completed.");
          ts3.Debug.assert(!lexicalEnvironmentSuspended, "Lexical environment is suspended.");
          var statements;
          if (lexicalEnvironmentVariableDeclarations || lexicalEnvironmentFunctionDeclarations || lexicalEnvironmentStatements) {
            if (lexicalEnvironmentFunctionDeclarations) {
              statements = __spreadArray([], lexicalEnvironmentFunctionDeclarations);
            }
            if (lexicalEnvironmentVariableDeclarations) {
              var statement = factory.createVariableStatement(void 0, factory.createVariableDeclarationList(lexicalEnvironmentVariableDeclarations));
              ts3.setEmitFlags(statement, 1048576);
              if (!statements) {
                statements = [statement];
              } else {
                statements.push(statement);
              }
            }
            if (lexicalEnvironmentStatements) {
              if (!statements) {
                statements = __spreadArray([], lexicalEnvironmentStatements);
              } else {
                statements = __spreadArray(__spreadArray([], statements), lexicalEnvironmentStatements);
              }
            }
          }
          lexicalEnvironmentStackOffset--;
          lexicalEnvironmentVariableDeclarations = lexicalEnvironmentVariableDeclarationsStack[lexicalEnvironmentStackOffset];
          lexicalEnvironmentFunctionDeclarations = lexicalEnvironmentFunctionDeclarationsStack[lexicalEnvironmentStackOffset];
          lexicalEnvironmentStatements = lexicalEnvironmentStatementsStack[lexicalEnvironmentStackOffset];
          lexicalEnvironmentFlags = lexicalEnvironmentFlagsStack[lexicalEnvironmentStackOffset];
          if (lexicalEnvironmentStackOffset === 0) {
            lexicalEnvironmentVariableDeclarationsStack = [];
            lexicalEnvironmentFunctionDeclarationsStack = [];
            lexicalEnvironmentStatementsStack = [];
            lexicalEnvironmentFlagsStack = [];
          }
          return statements;
        }
        function setLexicalEnvironmentFlags(flags, value) {
          lexicalEnvironmentFlags = value ? lexicalEnvironmentFlags | flags : lexicalEnvironmentFlags & ~flags;
        }
        function getLexicalEnvironmentFlags() {
          return lexicalEnvironmentFlags;
        }
        function startBlockScope() {
          ts3.Debug.assert(state > 0, "Cannot start a block scope during initialization.");
          ts3.Debug.assert(state < 2, "Cannot start a block scope after transformation has completed.");
          blockScopedVariableDeclarationsStack[blockScopeStackOffset] = blockScopedVariableDeclarations;
          blockScopeStackOffset++;
          blockScopedVariableDeclarations = void 0;
        }
        function endBlockScope() {
          ts3.Debug.assert(state > 0, "Cannot end a block scope during initialization.");
          ts3.Debug.assert(state < 2, "Cannot end a block scope after transformation has completed.");
          var statements = ts3.some(blockScopedVariableDeclarations) ? [
            factory.createVariableStatement(void 0, factory.createVariableDeclarationList(blockScopedVariableDeclarations.map(function(identifier) {
              return factory.createVariableDeclaration(identifier);
            }), 1))
          ] : void 0;
          blockScopeStackOffset--;
          blockScopedVariableDeclarations = blockScopedVariableDeclarationsStack[blockScopeStackOffset];
          if (blockScopeStackOffset === 0) {
            blockScopedVariableDeclarationsStack = [];
          }
          return statements;
        }
        function addBlockScopedVariable(name) {
          ts3.Debug.assert(blockScopeStackOffset > 0, "Cannot add a block scoped variable outside of an iteration body.");
          (blockScopedVariableDeclarations || (blockScopedVariableDeclarations = [])).push(name);
        }
        function requestEmitHelper(helper) {
          ts3.Debug.assert(state > 0, "Cannot modify the transformation context during initialization.");
          ts3.Debug.assert(state < 2, "Cannot modify the transformation context after transformation has completed.");
          ts3.Debug.assert(!helper.scoped, "Cannot request a scoped emit helper.");
          if (helper.dependencies) {
            for (var _i2 = 0, _a3 = helper.dependencies; _i2 < _a3.length; _i2++) {
              var h = _a3[_i2];
              requestEmitHelper(h);
            }
          }
          emitHelpers = ts3.append(emitHelpers, helper);
        }
        function readEmitHelpers() {
          ts3.Debug.assert(state > 0, "Cannot modify the transformation context during initialization.");
          ts3.Debug.assert(state < 2, "Cannot modify the transformation context after transformation has completed.");
          var helpers = emitHelpers;
          emitHelpers = void 0;
          return helpers;
        }
        function dispose() {
          if (state < 3) {
            for (var _i2 = 0, nodes_4 = nodes; _i2 < nodes_4.length; _i2++) {
              var node2 = nodes_4[_i2];
              ts3.disposeEmitNodes(ts3.getSourceFileOfNode(ts3.getParseTreeNode(node2)));
            }
            lexicalEnvironmentVariableDeclarations = void 0;
            lexicalEnvironmentVariableDeclarationsStack = void 0;
            lexicalEnvironmentFunctionDeclarations = void 0;
            lexicalEnvironmentFunctionDeclarationsStack = void 0;
            onSubstituteNode = void 0;
            onEmitNode = void 0;
            emitHelpers = void 0;
            state = 3;
          }
        }
      }
      ts3.transformNodes = transformNodes;
      ts3.nullTransformationContext = {
        factory: ts3.factory,
        getCompilerOptions: function() {
          return {};
        },
        getEmitResolver: ts3.notImplemented,
        getEmitHost: ts3.notImplemented,
        getEmitHelperFactory: ts3.notImplemented,
        startLexicalEnvironment: ts3.noop,
        resumeLexicalEnvironment: ts3.noop,
        suspendLexicalEnvironment: ts3.noop,
        endLexicalEnvironment: ts3.returnUndefined,
        setLexicalEnvironmentFlags: ts3.noop,
        getLexicalEnvironmentFlags: function() {
          return 0;
        },
        hoistVariableDeclaration: ts3.noop,
        hoistFunctionDeclaration: ts3.noop,
        addInitializationStatement: ts3.noop,
        startBlockScope: ts3.noop,
        endBlockScope: ts3.returnUndefined,
        addBlockScopedVariable: ts3.noop,
        requestEmitHelper: ts3.noop,
        readEmitHelpers: ts3.notImplemented,
        enableSubstitution: ts3.noop,
        enableEmitNotification: ts3.noop,
        isSubstitutionEnabled: ts3.notImplemented,
        isEmitNotificationEnabled: ts3.notImplemented,
        onSubstituteNode: noEmitSubstitution,
        onEmitNode: noEmitNotification,
        addDiagnostic: ts3.noop
      };
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var brackets = createBracketsMap();
      function isBuildInfoFile(file) {
        return ts3.fileExtensionIs(file, ".tsbuildinfo");
      }
      ts3.isBuildInfoFile = isBuildInfoFile;
      function forEachEmittedFile(host, action, sourceFilesOrTargetSourceFile, forceDtsEmit, onlyBuildInfo, includeBuildInfo) {
        if (forceDtsEmit === void 0) {
          forceDtsEmit = false;
        }
        var sourceFiles = ts3.isArray(sourceFilesOrTargetSourceFile) ? sourceFilesOrTargetSourceFile : ts3.getSourceFilesToEmit(host, sourceFilesOrTargetSourceFile, forceDtsEmit);
        var options = host.getCompilerOptions();
        if (ts3.outFile(options)) {
          var prepends = host.getPrependNodes();
          if (sourceFiles.length || prepends.length) {
            var bundle = ts3.factory.createBundle(sourceFiles, prepends);
            var result2 = action(getOutputPathsFor(bundle, host, forceDtsEmit), bundle);
            if (result2) {
              return result2;
            }
          }
        } else {
          if (!onlyBuildInfo) {
            for (var _a2 = 0, sourceFiles_1 = sourceFiles; _a2 < sourceFiles_1.length; _a2++) {
              var sourceFile = sourceFiles_1[_a2];
              var result2 = action(getOutputPathsFor(sourceFile, host, forceDtsEmit), sourceFile);
              if (result2) {
                return result2;
              }
            }
          }
          if (includeBuildInfo) {
            var buildInfoPath = getTsBuildInfoEmitOutputFilePath(options);
            if (buildInfoPath)
              return action({ buildInfoPath }, void 0);
          }
        }
      }
      ts3.forEachEmittedFile = forEachEmittedFile;
      function getTsBuildInfoEmitOutputFilePath(options) {
        var configFile = options.configFilePath;
        if (!ts3.isIncrementalCompilation(options))
          return void 0;
        if (options.tsBuildInfoFile)
          return options.tsBuildInfoFile;
        var outPath = ts3.outFile(options);
        var buildInfoExtensionLess;
        if (outPath) {
          buildInfoExtensionLess = ts3.removeFileExtension(outPath);
        } else {
          if (!configFile)
            return void 0;
          var configFileExtensionLess = ts3.removeFileExtension(configFile);
          buildInfoExtensionLess = options.outDir ? options.rootDir ? ts3.resolvePath(options.outDir, ts3.getRelativePathFromDirectory(options.rootDir, configFileExtensionLess, true)) : ts3.combinePaths(options.outDir, ts3.getBaseFileName(configFileExtensionLess)) : configFileExtensionLess;
        }
        return buildInfoExtensionLess + ".tsbuildinfo";
      }
      ts3.getTsBuildInfoEmitOutputFilePath = getTsBuildInfoEmitOutputFilePath;
      function getOutputPathsForBundle(options, forceDtsPaths) {
        var outPath = ts3.outFile(options);
        var jsFilePath = options.emitDeclarationOnly ? void 0 : outPath;
        var sourceMapFilePath = jsFilePath && getSourceMapFilePath(jsFilePath, options);
        var declarationFilePath = forceDtsPaths || ts3.getEmitDeclarations(options) ? ts3.removeFileExtension(outPath) + ".d.ts" : void 0;
        var declarationMapPath = declarationFilePath && ts3.getAreDeclarationMapsEnabled(options) ? declarationFilePath + ".map" : void 0;
        var buildInfoPath = getTsBuildInfoEmitOutputFilePath(options);
        return { jsFilePath, sourceMapFilePath, declarationFilePath, declarationMapPath, buildInfoPath };
      }
      ts3.getOutputPathsForBundle = getOutputPathsForBundle;
      function getOutputPathsFor(sourceFile, host, forceDtsPaths) {
        var options = host.getCompilerOptions();
        if (sourceFile.kind === 299) {
          return getOutputPathsForBundle(options, forceDtsPaths);
        } else {
          var ownOutputFilePath = ts3.getOwnEmitOutputFilePath(sourceFile.fileName, host, getOutputExtension(sourceFile, options));
          var isJsonFile = ts3.isJsonSourceFile(sourceFile);
          var isJsonEmittedToSameLocation = isJsonFile && ts3.comparePaths(sourceFile.fileName, ownOutputFilePath, host.getCurrentDirectory(), !host.useCaseSensitiveFileNames()) === 0;
          var jsFilePath = options.emitDeclarationOnly || isJsonEmittedToSameLocation ? void 0 : ownOutputFilePath;
          var sourceMapFilePath = !jsFilePath || ts3.isJsonSourceFile(sourceFile) ? void 0 : getSourceMapFilePath(jsFilePath, options);
          var declarationFilePath = forceDtsPaths || ts3.getEmitDeclarations(options) && !isJsonFile ? ts3.getDeclarationEmitOutputFilePath(sourceFile.fileName, host) : void 0;
          var declarationMapPath = declarationFilePath && ts3.getAreDeclarationMapsEnabled(options) ? declarationFilePath + ".map" : void 0;
          return { jsFilePath, sourceMapFilePath, declarationFilePath, declarationMapPath, buildInfoPath: void 0 };
        }
      }
      ts3.getOutputPathsFor = getOutputPathsFor;
      function getSourceMapFilePath(jsFilePath, options) {
        return options.sourceMap && !options.inlineSourceMap ? jsFilePath + ".map" : void 0;
      }
      function getOutputExtension(sourceFile, options) {
        if (ts3.isJsonSourceFile(sourceFile)) {
          return ".json";
        }
        if (options.jsx === 1) {
          if (ts3.isSourceFileJS(sourceFile)) {
            if (ts3.fileExtensionIs(sourceFile.fileName, ".jsx")) {
              return ".jsx";
            }
          } else if (sourceFile.languageVariant === 1) {
            return ".jsx";
          }
        }
        return ".js";
      }
      ts3.getOutputExtension = getOutputExtension;
      function getOutputPathWithoutChangingExt(inputFileName, configFile, ignoreCase, outputDir, getCommonSourceDirectory2) {
        return outputDir ? ts3.resolvePath(outputDir, ts3.getRelativePathFromDirectory(getCommonSourceDirectory2 ? getCommonSourceDirectory2() : getCommonSourceDirectoryOfConfig(configFile, ignoreCase), inputFileName, ignoreCase)) : inputFileName;
      }
      function getOutputDeclarationFileName(inputFileName, configFile, ignoreCase, getCommonSourceDirectory2) {
        ts3.Debug.assert(!ts3.fileExtensionIs(inputFileName, ".d.ts") && !ts3.fileExtensionIs(inputFileName, ".json"));
        return ts3.changeExtension(getOutputPathWithoutChangingExt(inputFileName, configFile, ignoreCase, configFile.options.declarationDir || configFile.options.outDir, getCommonSourceDirectory2), ".d.ts");
      }
      ts3.getOutputDeclarationFileName = getOutputDeclarationFileName;
      function getOutputJSFileName(inputFileName, configFile, ignoreCase, getCommonSourceDirectory2) {
        if (configFile.options.emitDeclarationOnly)
          return void 0;
        var isJsonFile = ts3.fileExtensionIs(inputFileName, ".json");
        var outputFileName = ts3.changeExtension(getOutputPathWithoutChangingExt(inputFileName, configFile, ignoreCase, configFile.options.outDir, getCommonSourceDirectory2), isJsonFile ? ".json" : configFile.options.jsx === 1 && (ts3.fileExtensionIs(inputFileName, ".tsx") || ts3.fileExtensionIs(inputFileName, ".jsx")) ? ".jsx" : ".js");
        return !isJsonFile || ts3.comparePaths(inputFileName, outputFileName, ts3.Debug.checkDefined(configFile.options.configFilePath), ignoreCase) !== 0 ? outputFileName : void 0;
      }
      function createAddOutput() {
        var outputs;
        return { addOutput, getOutputs };
        function addOutput(path2) {
          if (path2) {
            (outputs || (outputs = [])).push(path2);
          }
        }
        function getOutputs() {
          return outputs || ts3.emptyArray;
        }
      }
      function getSingleOutputFileNames(configFile, addOutput) {
        var _a2 = getOutputPathsForBundle(configFile.options, false), jsFilePath = _a2.jsFilePath, sourceMapFilePath = _a2.sourceMapFilePath, declarationFilePath = _a2.declarationFilePath, declarationMapPath = _a2.declarationMapPath, buildInfoPath = _a2.buildInfoPath;
        addOutput(jsFilePath);
        addOutput(sourceMapFilePath);
        addOutput(declarationFilePath);
        addOutput(declarationMapPath);
        addOutput(buildInfoPath);
      }
      function getOwnOutputFileNames(configFile, inputFileName, ignoreCase, addOutput, getCommonSourceDirectory2) {
        if (ts3.fileExtensionIs(inputFileName, ".d.ts"))
          return;
        var js = getOutputJSFileName(inputFileName, configFile, ignoreCase, getCommonSourceDirectory2);
        addOutput(js);
        if (ts3.fileExtensionIs(inputFileName, ".json"))
          return;
        if (js && configFile.options.sourceMap) {
          addOutput(js + ".map");
        }
        if (ts3.getEmitDeclarations(configFile.options)) {
          var dts = getOutputDeclarationFileName(inputFileName, configFile, ignoreCase, getCommonSourceDirectory2);
          addOutput(dts);
          if (configFile.options.declarationMap) {
            addOutput(dts + ".map");
          }
        }
      }
      function getCommonSourceDirectory(options, emittedFiles, currentDirectory, getCanonicalFileName, checkSourceFilesBelongToPath) {
        var commonSourceDirectory;
        if (options.rootDir) {
          commonSourceDirectory = ts3.getNormalizedAbsolutePath(options.rootDir, currentDirectory);
          checkSourceFilesBelongToPath === null || checkSourceFilesBelongToPath === void 0 ? void 0 : checkSourceFilesBelongToPath(options.rootDir);
        } else if (options.composite && options.configFilePath) {
          commonSourceDirectory = ts3.getDirectoryPath(ts3.normalizeSlashes(options.configFilePath));
          checkSourceFilesBelongToPath === null || checkSourceFilesBelongToPath === void 0 ? void 0 : checkSourceFilesBelongToPath(commonSourceDirectory);
        } else {
          commonSourceDirectory = ts3.computeCommonSourceDirectoryOfFilenames(emittedFiles(), currentDirectory, getCanonicalFileName);
        }
        if (commonSourceDirectory && commonSourceDirectory[commonSourceDirectory.length - 1] !== ts3.directorySeparator) {
          commonSourceDirectory += ts3.directorySeparator;
        }
        return commonSourceDirectory;
      }
      ts3.getCommonSourceDirectory = getCommonSourceDirectory;
      function getCommonSourceDirectoryOfConfig(_a2, ignoreCase) {
        var options = _a2.options, fileNames = _a2.fileNames;
        return getCommonSourceDirectory(options, function() {
          return ts3.filter(fileNames, function(file) {
            return !(options.noEmitForJsFiles && ts3.fileExtensionIsOneOf(file, ts3.supportedJSExtensions)) && !ts3.fileExtensionIs(file, ".d.ts");
          });
        }, ts3.getDirectoryPath(ts3.normalizeSlashes(ts3.Debug.checkDefined(options.configFilePath))), ts3.createGetCanonicalFileName(!ignoreCase));
      }
      ts3.getCommonSourceDirectoryOfConfig = getCommonSourceDirectoryOfConfig;
      function getAllProjectOutputs(configFile, ignoreCase) {
        var _a2 = createAddOutput(), addOutput = _a2.addOutput, getOutputs = _a2.getOutputs;
        if (ts3.outFile(configFile.options)) {
          getSingleOutputFileNames(configFile, addOutput);
        } else {
          var getCommonSourceDirectory_1 = ts3.memoize(function() {
            return getCommonSourceDirectoryOfConfig(configFile, ignoreCase);
          });
          for (var _b = 0, _c = configFile.fileNames; _b < _c.length; _b++) {
            var inputFileName = _c[_b];
            getOwnOutputFileNames(configFile, inputFileName, ignoreCase, addOutput, getCommonSourceDirectory_1);
          }
          addOutput(getTsBuildInfoEmitOutputFilePath(configFile.options));
        }
        return getOutputs();
      }
      ts3.getAllProjectOutputs = getAllProjectOutputs;
      function getOutputFileNames(commandLine, inputFileName, ignoreCase) {
        inputFileName = ts3.normalizePath(inputFileName);
        ts3.Debug.assert(ts3.contains(commandLine.fileNames, inputFileName), "Expected fileName to be present in command line");
        var _a2 = createAddOutput(), addOutput = _a2.addOutput, getOutputs = _a2.getOutputs;
        if (ts3.outFile(commandLine.options)) {
          getSingleOutputFileNames(commandLine, addOutput);
        } else {
          getOwnOutputFileNames(commandLine, inputFileName, ignoreCase, addOutput);
        }
        return getOutputs();
      }
      ts3.getOutputFileNames = getOutputFileNames;
      function getFirstProjectOutput(configFile, ignoreCase) {
        if (ts3.outFile(configFile.options)) {
          var jsFilePath = getOutputPathsForBundle(configFile.options, false).jsFilePath;
          return ts3.Debug.checkDefined(jsFilePath, "project " + configFile.options.configFilePath + " expected to have at least one output");
        }
        var getCommonSourceDirectory2 = ts3.memoize(function() {
          return getCommonSourceDirectoryOfConfig(configFile, ignoreCase);
        });
        for (var _a2 = 0, _b = configFile.fileNames; _a2 < _b.length; _a2++) {
          var inputFileName = _b[_a2];
          if (ts3.fileExtensionIs(inputFileName, ".d.ts"))
            continue;
          var jsFilePath = getOutputJSFileName(inputFileName, configFile, ignoreCase, getCommonSourceDirectory2);
          if (jsFilePath)
            return jsFilePath;
          if (ts3.fileExtensionIs(inputFileName, ".json"))
            continue;
          if (ts3.getEmitDeclarations(configFile.options)) {
            return getOutputDeclarationFileName(inputFileName, configFile, ignoreCase, getCommonSourceDirectory2);
          }
        }
        var buildInfoPath = getTsBuildInfoEmitOutputFilePath(configFile.options);
        if (buildInfoPath)
          return buildInfoPath;
        return ts3.Debug.fail("project " + configFile.options.configFilePath + " expected to have at least one output");
      }
      ts3.getFirstProjectOutput = getFirstProjectOutput;
      function emitFiles(resolver, host, targetSourceFile, _a2, emitOnlyDtsFiles, onlyBuildInfo, forceDtsEmit) {
        var scriptTransformers = _a2.scriptTransformers, declarationTransformers = _a2.declarationTransformers;
        var compilerOptions = host.getCompilerOptions();
        var sourceMapDataList = compilerOptions.sourceMap || compilerOptions.inlineSourceMap || ts3.getAreDeclarationMapsEnabled(compilerOptions) ? [] : void 0;
        var emittedFilesList = compilerOptions.listEmittedFiles ? [] : void 0;
        var emitterDiagnostics = ts3.createDiagnosticCollection();
        var newLine = ts3.getNewLineCharacter(compilerOptions, function() {
          return host.getNewLine();
        });
        var writer = ts3.createTextWriter(newLine);
        var _b = ts3.performance.createTimer("printTime", "beforePrint", "afterPrint"), enter = _b.enter, exit2 = _b.exit;
        var bundleBuildInfo;
        var emitSkipped = false;
        var exportedModulesFromDeclarationEmit;
        enter();
        forEachEmittedFile(host, emitSourceFileOrBundle, ts3.getSourceFilesToEmit(host, targetSourceFile, forceDtsEmit), forceDtsEmit, onlyBuildInfo, !targetSourceFile);
        exit2();
        return {
          emitSkipped,
          diagnostics: emitterDiagnostics.getDiagnostics(),
          emittedFiles: emittedFilesList,
          sourceMaps: sourceMapDataList,
          exportedModulesFromDeclarationEmit
        };
        function emitSourceFileOrBundle(_a3, sourceFileOrBundle) {
          var jsFilePath = _a3.jsFilePath, sourceMapFilePath = _a3.sourceMapFilePath, declarationFilePath = _a3.declarationFilePath, declarationMapPath = _a3.declarationMapPath, buildInfoPath = _a3.buildInfoPath;
          var buildInfoDirectory;
          if (buildInfoPath && sourceFileOrBundle && ts3.isBundle(sourceFileOrBundle)) {
            buildInfoDirectory = ts3.getDirectoryPath(ts3.getNormalizedAbsolutePath(buildInfoPath, host.getCurrentDirectory()));
            bundleBuildInfo = {
              commonSourceDirectory: relativeToBuildInfo(host.getCommonSourceDirectory()),
              sourceFiles: sourceFileOrBundle.sourceFiles.map(function(file) {
                return relativeToBuildInfo(ts3.getNormalizedAbsolutePath(file.fileName, host.getCurrentDirectory()));
              })
            };
          }
          ts3.tracing === null || ts3.tracing === void 0 ? void 0 : ts3.tracing.push("emit", "emitJsFileOrBundle", { jsFilePath });
          emitJsFileOrBundle(sourceFileOrBundle, jsFilePath, sourceMapFilePath, relativeToBuildInfo);
          ts3.tracing === null || ts3.tracing === void 0 ? void 0 : ts3.tracing.pop();
          ts3.tracing === null || ts3.tracing === void 0 ? void 0 : ts3.tracing.push("emit", "emitDeclarationFileOrBundle", { declarationFilePath });
          emitDeclarationFileOrBundle(sourceFileOrBundle, declarationFilePath, declarationMapPath, relativeToBuildInfo);
          ts3.tracing === null || ts3.tracing === void 0 ? void 0 : ts3.tracing.pop();
          ts3.tracing === null || ts3.tracing === void 0 ? void 0 : ts3.tracing.push("emit", "emitBuildInfo", { buildInfoPath });
          emitBuildInfo(bundleBuildInfo, buildInfoPath);
          ts3.tracing === null || ts3.tracing === void 0 ? void 0 : ts3.tracing.pop();
          if (!emitSkipped && emittedFilesList) {
            if (!emitOnlyDtsFiles) {
              if (jsFilePath) {
                emittedFilesList.push(jsFilePath);
              }
              if (sourceMapFilePath) {
                emittedFilesList.push(sourceMapFilePath);
              }
              if (buildInfoPath) {
                emittedFilesList.push(buildInfoPath);
              }
            }
            if (declarationFilePath) {
              emittedFilesList.push(declarationFilePath);
            }
            if (declarationMapPath) {
              emittedFilesList.push(declarationMapPath);
            }
          }
          function relativeToBuildInfo(path2) {
            return ts3.ensurePathIsNonModuleName(ts3.getRelativePathFromDirectory(buildInfoDirectory, path2, host.getCanonicalFileName));
          }
        }
        function emitBuildInfo(bundle, buildInfoPath) {
          if (!buildInfoPath || targetSourceFile || emitSkipped)
            return;
          var program2 = host.getProgramBuildInfo();
          if (host.isEmitBlocked(buildInfoPath)) {
            emitSkipped = true;
            return;
          }
          var version = ts3.version;
          ts3.writeFile(host, emitterDiagnostics, buildInfoPath, getBuildInfoText({ bundle, program: program2, version }), false);
        }
        function emitJsFileOrBundle(sourceFileOrBundle, jsFilePath, sourceMapFilePath, relativeToBuildInfo) {
          if (!sourceFileOrBundle || emitOnlyDtsFiles || !jsFilePath) {
            return;
          }
          if (jsFilePath && host.isEmitBlocked(jsFilePath) || compilerOptions.noEmit) {
            emitSkipped = true;
            return;
          }
          var transform = ts3.transformNodes(resolver, host, ts3.factory, compilerOptions, [sourceFileOrBundle], scriptTransformers, false);
          var printerOptions = {
            removeComments: compilerOptions.removeComments,
            newLine: compilerOptions.newLine,
            noEmitHelpers: compilerOptions.noEmitHelpers,
            module: compilerOptions.module,
            target: compilerOptions.target,
            sourceMap: compilerOptions.sourceMap,
            inlineSourceMap: compilerOptions.inlineSourceMap,
            inlineSources: compilerOptions.inlineSources,
            extendedDiagnostics: compilerOptions.extendedDiagnostics,
            writeBundleFileInfo: !!bundleBuildInfo,
            relativeToBuildInfo
          };
          var printer2 = createPrinter(printerOptions, {
            hasGlobalName: resolver.hasGlobalName,
            onEmitNode: transform.emitNodeWithNotification,
            isEmitNotificationEnabled: transform.isEmitNotificationEnabled,
            substituteNode: transform.substituteNode
          });
          ts3.Debug.assert(transform.transformed.length === 1, "Should only see one output from the transform");
          printSourceFileOrBundle(jsFilePath, sourceMapFilePath, transform.transformed[0], printer2, compilerOptions);
          transform.dispose();
          if (bundleBuildInfo)
            bundleBuildInfo.js = printer2.bundleFileInfo;
        }
        function emitDeclarationFileOrBundle(sourceFileOrBundle, declarationFilePath, declarationMapPath, relativeToBuildInfo) {
          if (!sourceFileOrBundle)
            return;
          if (!declarationFilePath) {
            if (emitOnlyDtsFiles || compilerOptions.emitDeclarationOnly)
              emitSkipped = true;
            return;
          }
          var sourceFiles = ts3.isSourceFile(sourceFileOrBundle) ? [sourceFileOrBundle] : sourceFileOrBundle.sourceFiles;
          var filesForEmit = forceDtsEmit ? sourceFiles : ts3.filter(sourceFiles, ts3.isSourceFileNotJson);
          var inputListOrBundle = ts3.outFile(compilerOptions) ? [ts3.factory.createBundle(filesForEmit, !ts3.isSourceFile(sourceFileOrBundle) ? sourceFileOrBundle.prepends : void 0)] : filesForEmit;
          if (emitOnlyDtsFiles && !ts3.getEmitDeclarations(compilerOptions)) {
            filesForEmit.forEach(collectLinkedAliases);
          }
          var declarationTransform = ts3.transformNodes(resolver, host, ts3.factory, compilerOptions, inputListOrBundle, declarationTransformers, false);
          if (ts3.length(declarationTransform.diagnostics)) {
            for (var _a3 = 0, _b2 = declarationTransform.diagnostics; _a3 < _b2.length; _a3++) {
              var diagnostic = _b2[_a3];
              emitterDiagnostics.add(diagnostic);
            }
          }
          var printerOptions = {
            removeComments: compilerOptions.removeComments,
            newLine: compilerOptions.newLine,
            noEmitHelpers: true,
            module: compilerOptions.module,
            target: compilerOptions.target,
            sourceMap: compilerOptions.sourceMap,
            inlineSourceMap: compilerOptions.inlineSourceMap,
            extendedDiagnostics: compilerOptions.extendedDiagnostics,
            onlyPrintJsDocStyle: true,
            writeBundleFileInfo: !!bundleBuildInfo,
            recordInternalSection: !!bundleBuildInfo,
            relativeToBuildInfo
          };
          var declarationPrinter = createPrinter(printerOptions, {
            hasGlobalName: resolver.hasGlobalName,
            onEmitNode: declarationTransform.emitNodeWithNotification,
            isEmitNotificationEnabled: declarationTransform.isEmitNotificationEnabled,
            substituteNode: declarationTransform.substituteNode
          });
          var declBlocked = !!declarationTransform.diagnostics && !!declarationTransform.diagnostics.length || !!host.isEmitBlocked(declarationFilePath) || !!compilerOptions.noEmit;
          emitSkipped = emitSkipped || declBlocked;
          if (!declBlocked || forceDtsEmit) {
            ts3.Debug.assert(declarationTransform.transformed.length === 1, "Should only see one output from the decl transform");
            printSourceFileOrBundle(declarationFilePath, declarationMapPath, declarationTransform.transformed[0], declarationPrinter, {
              sourceMap: !forceDtsEmit && compilerOptions.declarationMap,
              sourceRoot: compilerOptions.sourceRoot,
              mapRoot: compilerOptions.mapRoot,
              extendedDiagnostics: compilerOptions.extendedDiagnostics
            });
            if (forceDtsEmit && declarationTransform.transformed[0].kind === 298) {
              var sourceFile = declarationTransform.transformed[0];
              exportedModulesFromDeclarationEmit = sourceFile.exportedModulesFromDeclarationEmit;
            }
          }
          declarationTransform.dispose();
          if (bundleBuildInfo)
            bundleBuildInfo.dts = declarationPrinter.bundleFileInfo;
        }
        function collectLinkedAliases(node) {
          if (ts3.isExportAssignment(node)) {
            if (node.expression.kind === 78) {
              resolver.collectLinkedAliases(node.expression, true);
            }
            return;
          } else if (ts3.isExportSpecifier(node)) {
            resolver.collectLinkedAliases(node.propertyName || node.name, true);
            return;
          }
          ts3.forEachChild(node, collectLinkedAliases);
        }
        function printSourceFileOrBundle(jsFilePath, sourceMapFilePath, sourceFileOrBundle, printer2, mapOptions) {
          var bundle = sourceFileOrBundle.kind === 299 ? sourceFileOrBundle : void 0;
          var sourceFile = sourceFileOrBundle.kind === 298 ? sourceFileOrBundle : void 0;
          var sourceFiles = bundle ? bundle.sourceFiles : [sourceFile];
          var sourceMapGenerator;
          if (shouldEmitSourceMaps(mapOptions, sourceFileOrBundle)) {
            sourceMapGenerator = ts3.createSourceMapGenerator(host, ts3.getBaseFileName(ts3.normalizeSlashes(jsFilePath)), getSourceRoot(mapOptions), getSourceMapDirectory(mapOptions, jsFilePath, sourceFile), mapOptions);
          }
          if (bundle) {
            printer2.writeBundle(bundle, writer, sourceMapGenerator);
          } else {
            printer2.writeFile(sourceFile, writer, sourceMapGenerator);
          }
          if (sourceMapGenerator) {
            if (sourceMapDataList) {
              sourceMapDataList.push({
                inputSourceFileNames: sourceMapGenerator.getSources(),
                sourceMap: sourceMapGenerator.toJSON()
              });
            }
            var sourceMappingURL = getSourceMappingURL(mapOptions, sourceMapGenerator, jsFilePath, sourceMapFilePath, sourceFile);
            if (sourceMappingURL) {
              if (!writer.isAtStartOfLine())
                writer.rawWrite(newLine);
              writer.writeComment("//# sourceMappingURL=" + sourceMappingURL);
            }
            if (sourceMapFilePath) {
              var sourceMap = sourceMapGenerator.toString();
              ts3.writeFile(host, emitterDiagnostics, sourceMapFilePath, sourceMap, false, sourceFiles);
            }
          } else {
            writer.writeLine();
          }
          ts3.writeFile(host, emitterDiagnostics, jsFilePath, writer.getText(), !!compilerOptions.emitBOM, sourceFiles);
          writer.clear();
        }
        function shouldEmitSourceMaps(mapOptions, sourceFileOrBundle) {
          return (mapOptions.sourceMap || mapOptions.inlineSourceMap) && (sourceFileOrBundle.kind !== 298 || !ts3.fileExtensionIs(sourceFileOrBundle.fileName, ".json"));
        }
        function getSourceRoot(mapOptions) {
          var sourceRoot = ts3.normalizeSlashes(mapOptions.sourceRoot || "");
          return sourceRoot ? ts3.ensureTrailingDirectorySeparator(sourceRoot) : sourceRoot;
        }
        function getSourceMapDirectory(mapOptions, filePath, sourceFile) {
          if (mapOptions.sourceRoot)
            return host.getCommonSourceDirectory();
          if (mapOptions.mapRoot) {
            var sourceMapDir = ts3.normalizeSlashes(mapOptions.mapRoot);
            if (sourceFile) {
              sourceMapDir = ts3.getDirectoryPath(ts3.getSourceFilePathInNewDir(sourceFile.fileName, host, sourceMapDir));
            }
            if (ts3.getRootLength(sourceMapDir) === 0) {
              sourceMapDir = ts3.combinePaths(host.getCommonSourceDirectory(), sourceMapDir);
            }
            return sourceMapDir;
          }
          return ts3.getDirectoryPath(ts3.normalizePath(filePath));
        }
        function getSourceMappingURL(mapOptions, sourceMapGenerator, filePath, sourceMapFilePath, sourceFile) {
          if (mapOptions.inlineSourceMap) {
            var sourceMapText = sourceMapGenerator.toString();
            var base64SourceMapText = ts3.base64encode(ts3.sys, sourceMapText);
            return "data:application/json;base64," + base64SourceMapText;
          }
          var sourceMapFile = ts3.getBaseFileName(ts3.normalizeSlashes(ts3.Debug.checkDefined(sourceMapFilePath)));
          if (mapOptions.mapRoot) {
            var sourceMapDir = ts3.normalizeSlashes(mapOptions.mapRoot);
            if (sourceFile) {
              sourceMapDir = ts3.getDirectoryPath(ts3.getSourceFilePathInNewDir(sourceFile.fileName, host, sourceMapDir));
            }
            if (ts3.getRootLength(sourceMapDir) === 0) {
              sourceMapDir = ts3.combinePaths(host.getCommonSourceDirectory(), sourceMapDir);
              return encodeURI(ts3.getRelativePathToDirectoryOrUrl(ts3.getDirectoryPath(ts3.normalizePath(filePath)), ts3.combinePaths(sourceMapDir, sourceMapFile), host.getCurrentDirectory(), host.getCanonicalFileName, true));
            } else {
              return encodeURI(ts3.combinePaths(sourceMapDir, sourceMapFile));
            }
          }
          return encodeURI(sourceMapFile);
        }
      }
      ts3.emitFiles = emitFiles;
      function getBuildInfoText(buildInfo) {
        return JSON.stringify(buildInfo);
      }
      ts3.getBuildInfoText = getBuildInfoText;
      function getBuildInfo(buildInfoText) {
        return JSON.parse(buildInfoText);
      }
      ts3.getBuildInfo = getBuildInfo;
      ts3.notImplementedResolver = {
        hasGlobalName: ts3.notImplemented,
        getReferencedExportContainer: ts3.notImplemented,
        getReferencedImportDeclaration: ts3.notImplemented,
        getReferencedDeclarationWithCollidingName: ts3.notImplemented,
        isDeclarationWithCollidingName: ts3.notImplemented,
        isValueAliasDeclaration: ts3.notImplemented,
        isReferencedAliasDeclaration: ts3.notImplemented,
        isTopLevelValueImportEqualsWithEntityName: ts3.notImplemented,
        getNodeCheckFlags: ts3.notImplemented,
        isDeclarationVisible: ts3.notImplemented,
        isLateBound: function(_node) {
          return false;
        },
        collectLinkedAliases: ts3.notImplemented,
        isImplementationOfOverload: ts3.notImplemented,
        isRequiredInitializedParameter: ts3.notImplemented,
        isOptionalUninitializedParameterProperty: ts3.notImplemented,
        isExpandoFunctionDeclaration: ts3.notImplemented,
        getPropertiesOfContainerFunction: ts3.notImplemented,
        createTypeOfDeclaration: ts3.notImplemented,
        createReturnTypeOfSignatureDeclaration: ts3.notImplemented,
        createTypeOfExpression: ts3.notImplemented,
        createLiteralConstValue: ts3.notImplemented,
        isSymbolAccessible: ts3.notImplemented,
        isEntityNameVisible: ts3.notImplemented,
        getConstantValue: ts3.notImplemented,
        getReferencedValueDeclaration: ts3.notImplemented,
        getTypeReferenceSerializationKind: ts3.notImplemented,
        isOptionalParameter: ts3.notImplemented,
        moduleExportsSomeValue: ts3.notImplemented,
        isArgumentsLocalBinding: ts3.notImplemented,
        getExternalModuleFileFromDeclaration: ts3.notImplemented,
        getTypeReferenceDirectivesForEntityName: ts3.notImplemented,
        getTypeReferenceDirectivesForSymbol: ts3.notImplemented,
        isLiteralConstDeclaration: ts3.notImplemented,
        getJsxFactoryEntity: ts3.notImplemented,
        getJsxFragmentFactoryEntity: ts3.notImplemented,
        getAllAccessorDeclarations: ts3.notImplemented,
        getSymbolOfExternalModuleSpecifier: ts3.notImplemented,
        isBindingCapturedByNode: ts3.notImplemented,
        getDeclarationStatementsForSourceFile: ts3.notImplemented,
        isImportRequiredByAugmentation: ts3.notImplemented
      };
      function createSourceFilesFromBundleBuildInfo(bundle, buildInfoDirectory, host) {
        var _a2;
        var jsBundle = ts3.Debug.checkDefined(bundle.js);
        var prologueMap = ((_a2 = jsBundle.sources) === null || _a2 === void 0 ? void 0 : _a2.prologues) && ts3.arrayToMap(jsBundle.sources.prologues, function(prologueInfo) {
          return prologueInfo.file;
        });
        return bundle.sourceFiles.map(function(fileName, index) {
          var _a3, _b;
          var prologueInfo = prologueMap === null || prologueMap === void 0 ? void 0 : prologueMap.get(index);
          var statements = prologueInfo === null || prologueInfo === void 0 ? void 0 : prologueInfo.directives.map(function(directive) {
            var literal = ts3.setTextRange(ts3.factory.createStringLiteral(directive.expression.text), directive.expression);
            var statement = ts3.setTextRange(ts3.factory.createExpressionStatement(literal), directive);
            ts3.setParent(literal, statement);
            return statement;
          });
          var eofToken = ts3.factory.createToken(1);
          var sourceFile = ts3.factory.createSourceFile(statements !== null && statements !== void 0 ? statements : [], eofToken, 0);
          sourceFile.fileName = ts3.getRelativePathFromDirectory(host.getCurrentDirectory(), ts3.getNormalizedAbsolutePath(fileName, buildInfoDirectory), !host.useCaseSensitiveFileNames());
          sourceFile.text = (_a3 = prologueInfo === null || prologueInfo === void 0 ? void 0 : prologueInfo.text) !== null && _a3 !== void 0 ? _a3 : "";
          ts3.setTextRangePosWidth(sourceFile, 0, (_b = prologueInfo === null || prologueInfo === void 0 ? void 0 : prologueInfo.text.length) !== null && _b !== void 0 ? _b : 0);
          ts3.setEachParent(sourceFile.statements, sourceFile);
          ts3.setTextRangePosWidth(eofToken, sourceFile.end, 0);
          ts3.setParent(eofToken, sourceFile);
          return sourceFile;
        });
      }
      function emitUsingBuildInfo(config, host, getCommandLine, customTransformers) {
        var _a2 = getOutputPathsForBundle(config.options, false), buildInfoPath = _a2.buildInfoPath, jsFilePath = _a2.jsFilePath, sourceMapFilePath = _a2.sourceMapFilePath, declarationFilePath = _a2.declarationFilePath, declarationMapPath = _a2.declarationMapPath;
        var buildInfoText = host.readFile(ts3.Debug.checkDefined(buildInfoPath));
        if (!buildInfoText)
          return buildInfoPath;
        var jsFileText = host.readFile(ts3.Debug.checkDefined(jsFilePath));
        if (!jsFileText)
          return jsFilePath;
        var sourceMapText = sourceMapFilePath && host.readFile(sourceMapFilePath);
        if (sourceMapFilePath && !sourceMapText || config.options.inlineSourceMap)
          return sourceMapFilePath || "inline sourcemap decoding";
        var declarationText = declarationFilePath && host.readFile(declarationFilePath);
        if (declarationFilePath && !declarationText)
          return declarationFilePath;
        var declarationMapText = declarationMapPath && host.readFile(declarationMapPath);
        if (declarationMapPath && !declarationMapText || config.options.inlineSourceMap)
          return declarationMapPath || "inline sourcemap decoding";
        var buildInfo = getBuildInfo(buildInfoText);
        if (!buildInfo.bundle || !buildInfo.bundle.js || declarationText && !buildInfo.bundle.dts)
          return buildInfoPath;
        var buildInfoDirectory = ts3.getDirectoryPath(ts3.getNormalizedAbsolutePath(buildInfoPath, host.getCurrentDirectory()));
        var ownPrependInput = ts3.createInputFiles(jsFileText, declarationText, sourceMapFilePath, sourceMapText, declarationMapPath, declarationMapText, jsFilePath, declarationFilePath, buildInfoPath, buildInfo, true);
        var outputFiles = [];
        var prependNodes = ts3.createPrependNodes(config.projectReferences, getCommandLine, function(f) {
          return host.readFile(f);
        });
        var sourceFilesForJsEmit = createSourceFilesFromBundleBuildInfo(buildInfo.bundle, buildInfoDirectory, host);
        var emitHost = {
          getPrependNodes: ts3.memoize(function() {
            return __spreadArray(__spreadArray([], prependNodes), [ownPrependInput]);
          }),
          getCanonicalFileName: host.getCanonicalFileName,
          getCommonSourceDirectory: function() {
            return ts3.getNormalizedAbsolutePath(buildInfo.bundle.commonSourceDirectory, buildInfoDirectory);
          },
          getCompilerOptions: function() {
            return config.options;
          },
          getCurrentDirectory: function() {
            return host.getCurrentDirectory();
          },
          getNewLine: function() {
            return host.getNewLine();
          },
          getSourceFile: ts3.returnUndefined,
          getSourceFileByPath: ts3.returnUndefined,
          getSourceFiles: function() {
            return sourceFilesForJsEmit;
          },
          getLibFileFromReference: ts3.notImplemented,
          isSourceFileFromExternalLibrary: ts3.returnFalse,
          getResolvedProjectReferenceToRedirect: ts3.returnUndefined,
          getProjectReferenceRedirect: ts3.returnUndefined,
          isSourceOfProjectReferenceRedirect: ts3.returnFalse,
          writeFile: function(name, text, writeByteOrderMark) {
            switch (name) {
              case jsFilePath:
                if (jsFileText === text)
                  return;
                break;
              case sourceMapFilePath:
                if (sourceMapText === text)
                  return;
                break;
              case buildInfoPath:
                var newBuildInfo = getBuildInfo(text);
                newBuildInfo.program = buildInfo.program;
                var _a3 = buildInfo.bundle, js = _a3.js, dts = _a3.dts, sourceFiles = _a3.sourceFiles;
                newBuildInfo.bundle.js.sources = js.sources;
                if (dts) {
                  newBuildInfo.bundle.dts.sources = dts.sources;
                }
                newBuildInfo.bundle.sourceFiles = sourceFiles;
                outputFiles.push({ name, text: getBuildInfoText(newBuildInfo), writeByteOrderMark });
                return;
              case declarationFilePath:
                if (declarationText === text)
                  return;
                break;
              case declarationMapPath:
                if (declarationMapText === text)
                  return;
                break;
              default:
                ts3.Debug.fail("Unexpected path: " + name);
            }
            outputFiles.push({ name, text, writeByteOrderMark });
          },
          isEmitBlocked: ts3.returnFalse,
          readFile: function(f) {
            return host.readFile(f);
          },
          fileExists: function(f) {
            return host.fileExists(f);
          },
          useCaseSensitiveFileNames: function() {
            return host.useCaseSensitiveFileNames();
          },
          getProgramBuildInfo: ts3.returnUndefined,
          getSourceFileFromReference: ts3.returnUndefined,
          redirectTargetsMap: ts3.createMultiMap(),
          getFileIncludeReasons: ts3.notImplemented
        };
        emitFiles(ts3.notImplementedResolver, emitHost, void 0, ts3.getTransformers(config.options, customTransformers));
        return outputFiles;
      }
      ts3.emitUsingBuildInfo = emitUsingBuildInfo;
      var PipelinePhase;
      (function(PipelinePhase2) {
        PipelinePhase2[PipelinePhase2["Notification"] = 0] = "Notification";
        PipelinePhase2[PipelinePhase2["Substitution"] = 1] = "Substitution";
        PipelinePhase2[PipelinePhase2["Comments"] = 2] = "Comments";
        PipelinePhase2[PipelinePhase2["SourceMaps"] = 3] = "SourceMaps";
        PipelinePhase2[PipelinePhase2["Emit"] = 4] = "Emit";
      })(PipelinePhase || (PipelinePhase = {}));
      function createPrinter(printerOptions, handlers) {
        if (printerOptions === void 0) {
          printerOptions = {};
        }
        if (handlers === void 0) {
          handlers = {};
        }
        var hasGlobalName = handlers.hasGlobalName, _a2 = handlers.onEmitNode, onEmitNode = _a2 === void 0 ? ts3.noEmitNotification : _a2, isEmitNotificationEnabled = handlers.isEmitNotificationEnabled, _b = handlers.substituteNode, substituteNode = _b === void 0 ? ts3.noEmitSubstitution : _b, onBeforeEmitNode = handlers.onBeforeEmitNode, onAfterEmitNode = handlers.onAfterEmitNode, onBeforeEmitNodeArray = handlers.onBeforeEmitNodeArray, onAfterEmitNodeArray = handlers.onAfterEmitNodeArray, onBeforeEmitToken = handlers.onBeforeEmitToken, onAfterEmitToken = handlers.onAfterEmitToken;
        var extendedDiagnostics = !!printerOptions.extendedDiagnostics;
        var newLine = ts3.getNewLineCharacter(printerOptions);
        var moduleKind = ts3.getEmitModuleKind(printerOptions);
        var bundledHelpers = new ts3.Map();
        var currentSourceFile;
        var nodeIdToGeneratedName;
        var autoGeneratedIdToGeneratedName;
        var generatedNames;
        var tempFlagsStack;
        var tempFlags;
        var reservedNamesStack;
        var reservedNames;
        var preserveSourceNewlines = printerOptions.preserveSourceNewlines;
        var nextListElementPos;
        var writer;
        var ownWriter;
        var write = writeBase;
        var isOwnFileEmit;
        var bundleFileInfo = printerOptions.writeBundleFileInfo ? { sections: [] } : void 0;
        var relativeToBuildInfo = bundleFileInfo ? ts3.Debug.checkDefined(printerOptions.relativeToBuildInfo) : void 0;
        var recordInternalSection = printerOptions.recordInternalSection;
        var sourceFileTextPos = 0;
        var sourceFileTextKind = "text";
        var sourceMapsDisabled = true;
        var sourceMapGenerator;
        var sourceMapSource;
        var sourceMapSourceIndex = -1;
        var mostRecentlyAddedSourceMapSource;
        var mostRecentlyAddedSourceMapSourceIndex = -1;
        var containerPos = -1;
        var containerEnd = -1;
        var declarationListContainerEnd = -1;
        var currentLineMap;
        var detachedCommentsInfo;
        var hasWrittenComment = false;
        var commentsDisabled = !!printerOptions.removeComments;
        var lastSubstitution;
        var currentParenthesizerRule;
        var _c = ts3.performance.createTimerIf(extendedDiagnostics, "commentTime", "beforeComment", "afterComment"), enterComment = _c.enter, exitComment = _c.exit;
        var parenthesizer = ts3.factory.parenthesizer;
        var emitBinaryExpression = createEmitBinaryExpression();
        reset();
        return {
          printNode,
          printList,
          printFile,
          printBundle,
          writeNode: writeNode2,
          writeList,
          writeFile,
          writeBundle,
          bundleFileInfo
        };
        function printNode(hint, node, sourceFile) {
          switch (hint) {
            case 0:
              ts3.Debug.assert(ts3.isSourceFile(node), "Expected a SourceFile node.");
              break;
            case 2:
              ts3.Debug.assert(ts3.isIdentifier(node), "Expected an Identifier node.");
              break;
            case 1:
              ts3.Debug.assert(ts3.isExpression(node), "Expected an Expression node.");
              break;
          }
          switch (node.kind) {
            case 298:
              return printFile(node);
            case 299:
              return printBundle(node);
            case 300:
              return printUnparsedSource(node);
          }
          writeNode2(hint, node, sourceFile, beginPrint());
          return endPrint();
        }
        function printList(format, nodes, sourceFile) {
          writeList(format, nodes, sourceFile, beginPrint());
          return endPrint();
        }
        function printBundle(bundle) {
          writeBundle(bundle, beginPrint(), void 0);
          return endPrint();
        }
        function printFile(sourceFile) {
          writeFile(sourceFile, beginPrint(), void 0);
          return endPrint();
        }
        function printUnparsedSource(unparsed) {
          writeUnparsedSource(unparsed, beginPrint());
          return endPrint();
        }
        function writeNode2(hint, node, sourceFile, output) {
          var previousWriter = writer;
          setWriter(output, void 0);
          print2(hint, node, sourceFile);
          reset();
          writer = previousWriter;
        }
        function writeList(format, nodes, sourceFile, output) {
          var previousWriter = writer;
          setWriter(output, void 0);
          if (sourceFile) {
            setSourceFile(sourceFile);
          }
          emitList(void 0, nodes, format);
          reset();
          writer = previousWriter;
        }
        function getTextPosWithWriteLine() {
          return writer.getTextPosWithWriteLine ? writer.getTextPosWithWriteLine() : writer.getTextPos();
        }
        function updateOrPushBundleFileTextLike(pos, end, kind) {
          var last = ts3.lastOrUndefined(bundleFileInfo.sections);
          if (last && last.kind === kind) {
            last.end = end;
          } else {
            bundleFileInfo.sections.push({ pos, end, kind });
          }
        }
        function recordBundleFileInternalSectionStart(node) {
          if (recordInternalSection && bundleFileInfo && currentSourceFile && (ts3.isDeclaration(node) || ts3.isVariableStatement(node)) && ts3.isInternalDeclaration(node, currentSourceFile) && sourceFileTextKind !== "internal") {
            var prevSourceFileTextKind = sourceFileTextKind;
            recordBundleFileTextLikeSection(writer.getTextPos());
            sourceFileTextPos = getTextPosWithWriteLine();
            sourceFileTextKind = "internal";
            return prevSourceFileTextKind;
          }
          return void 0;
        }
        function recordBundleFileInternalSectionEnd(prevSourceFileTextKind) {
          if (prevSourceFileTextKind) {
            recordBundleFileTextLikeSection(writer.getTextPos());
            sourceFileTextPos = getTextPosWithWriteLine();
            sourceFileTextKind = prevSourceFileTextKind;
          }
        }
        function recordBundleFileTextLikeSection(end) {
          if (sourceFileTextPos < end) {
            updateOrPushBundleFileTextLike(sourceFileTextPos, end, sourceFileTextKind);
            return true;
          }
          return false;
        }
        function writeBundle(bundle, output, sourceMapGenerator2) {
          var _a3;
          isOwnFileEmit = false;
          var previousWriter = writer;
          setWriter(output, sourceMapGenerator2);
          emitShebangIfNeeded(bundle);
          emitPrologueDirectivesIfNeeded(bundle);
          emitHelpers(bundle);
          emitSyntheticTripleSlashReferencesIfNeeded(bundle);
          for (var _b2 = 0, _c2 = bundle.prepends; _b2 < _c2.length; _b2++) {
            var prepend = _c2[_b2];
            writeLine();
            var pos = writer.getTextPos();
            var savedSections = bundleFileInfo && bundleFileInfo.sections;
            if (savedSections)
              bundleFileInfo.sections = [];
            print2(4, prepend, void 0);
            if (bundleFileInfo) {
              var newSections = bundleFileInfo.sections;
              bundleFileInfo.sections = savedSections;
              if (prepend.oldFileOfCurrentEmit)
                (_a3 = bundleFileInfo.sections).push.apply(_a3, newSections);
              else {
                newSections.forEach(function(section) {
                  return ts3.Debug.assert(ts3.isBundleFileTextLike(section));
                });
                bundleFileInfo.sections.push({
                  pos,
                  end: writer.getTextPos(),
                  kind: "prepend",
                  data: relativeToBuildInfo(prepend.fileName),
                  texts: newSections
                });
              }
            }
          }
          sourceFileTextPos = getTextPosWithWriteLine();
          for (var _d = 0, _e = bundle.sourceFiles; _d < _e.length; _d++) {
            var sourceFile = _e[_d];
            print2(0, sourceFile, sourceFile);
          }
          if (bundleFileInfo && bundle.sourceFiles.length) {
            var end = writer.getTextPos();
            if (recordBundleFileTextLikeSection(end)) {
              var prologues = getPrologueDirectivesFromBundledSourceFiles(bundle);
              if (prologues) {
                if (!bundleFileInfo.sources)
                  bundleFileInfo.sources = {};
                bundleFileInfo.sources.prologues = prologues;
              }
              var helpers = getHelpersFromBundledSourceFiles(bundle);
              if (helpers) {
                if (!bundleFileInfo.sources)
                  bundleFileInfo.sources = {};
                bundleFileInfo.sources.helpers = helpers;
              }
            }
          }
          reset();
          writer = previousWriter;
        }
        function writeUnparsedSource(unparsed, output) {
          var previousWriter = writer;
          setWriter(output, void 0);
          print2(4, unparsed, void 0);
          reset();
          writer = previousWriter;
        }
        function writeFile(sourceFile, output, sourceMapGenerator2) {
          isOwnFileEmit = true;
          var previousWriter = writer;
          setWriter(output, sourceMapGenerator2);
          emitShebangIfNeeded(sourceFile);
          emitPrologueDirectivesIfNeeded(sourceFile);
          print2(0, sourceFile, sourceFile);
          reset();
          writer = previousWriter;
        }
        function beginPrint() {
          return ownWriter || (ownWriter = ts3.createTextWriter(newLine));
        }
        function endPrint() {
          var text = ownWriter.getText();
          ownWriter.clear();
          return text;
        }
        function print2(hint, node, sourceFile) {
          if (sourceFile) {
            setSourceFile(sourceFile);
          }
          pipelineEmit(hint, node, void 0);
        }
        function setSourceFile(sourceFile) {
          currentSourceFile = sourceFile;
          currentLineMap = void 0;
          detachedCommentsInfo = void 0;
          if (sourceFile) {
            setSourceMapSource(sourceFile);
          }
        }
        function setWriter(_writer, _sourceMapGenerator) {
          if (_writer && printerOptions.omitTrailingSemicolon) {
            _writer = ts3.getTrailingSemicolonDeferringWriter(_writer);
          }
          writer = _writer;
          sourceMapGenerator = _sourceMapGenerator;
          sourceMapsDisabled = !writer || !sourceMapGenerator;
        }
        function reset() {
          nodeIdToGeneratedName = [];
          autoGeneratedIdToGeneratedName = [];
          generatedNames = new ts3.Set();
          tempFlagsStack = [];
          tempFlags = 0;
          reservedNamesStack = [];
          currentSourceFile = void 0;
          currentLineMap = void 0;
          detachedCommentsInfo = void 0;
          setWriter(void 0, void 0);
        }
        function getCurrentLineMap() {
          return currentLineMap || (currentLineMap = ts3.getLineStarts(currentSourceFile));
        }
        function emit(node, parenthesizerRule) {
          if (node === void 0)
            return;
          var prevSourceFileTextKind = recordBundleFileInternalSectionStart(node);
          pipelineEmit(4, node, parenthesizerRule);
          recordBundleFileInternalSectionEnd(prevSourceFileTextKind);
        }
        function emitIdentifierName(node) {
          if (node === void 0)
            return;
          pipelineEmit(2, node, void 0);
        }
        function emitExpression(node, parenthesizerRule) {
          if (node === void 0)
            return;
          pipelineEmit(1, node, parenthesizerRule);
        }
        function emitJsxAttributeValue(node) {
          pipelineEmit(ts3.isStringLiteral(node) ? 6 : 4, node);
        }
        function beforeEmitNode(node) {
          if (preserveSourceNewlines && ts3.getEmitFlags(node) & 134217728) {
            preserveSourceNewlines = false;
          }
        }
        function afterEmitNode(savedPreserveSourceNewlines) {
          preserveSourceNewlines = savedPreserveSourceNewlines;
        }
        function pipelineEmit(emitHint, node, parenthesizerRule) {
          currentParenthesizerRule = parenthesizerRule;
          var pipelinePhase = getPipelinePhase(0, emitHint, node);
          pipelinePhase(emitHint, node);
          currentParenthesizerRule = void 0;
        }
        function shouldEmitComments(node) {
          return !commentsDisabled && !ts3.isSourceFile(node);
        }
        function shouldEmitSourceMaps(node) {
          return !sourceMapsDisabled && !ts3.isSourceFile(node) && !ts3.isInJsonFile(node) && !ts3.isUnparsedSource(node) && !ts3.isUnparsedPrepend(node);
        }
        function getPipelinePhase(phase, emitHint, node) {
          switch (phase) {
            case 0:
              if (onEmitNode !== ts3.noEmitNotification && (!isEmitNotificationEnabled || isEmitNotificationEnabled(node))) {
                return pipelineEmitWithNotification;
              }
            case 1:
              if (substituteNode !== ts3.noEmitSubstitution && (lastSubstitution = substituteNode(emitHint, node) || node) !== node) {
                if (currentParenthesizerRule) {
                  lastSubstitution = currentParenthesizerRule(lastSubstitution);
                }
                return pipelineEmitWithSubstitution;
              }
            case 2:
              if (shouldEmitComments(node)) {
                return pipelineEmitWithComments;
              }
            case 3:
              if (shouldEmitSourceMaps(node)) {
                return pipelineEmitWithSourceMaps;
              }
            case 4:
              return pipelineEmitWithHint;
            default:
              return ts3.Debug.assertNever(phase);
          }
        }
        function getNextPipelinePhase(currentPhase, emitHint, node) {
          return getPipelinePhase(currentPhase + 1, emitHint, node);
        }
        function pipelineEmitWithNotification(hint, node) {
          var pipelinePhase = getNextPipelinePhase(0, hint, node);
          onEmitNode(hint, node, pipelinePhase);
        }
        function pipelineEmitWithHint(hint, node) {
          onBeforeEmitNode === null || onBeforeEmitNode === void 0 ? void 0 : onBeforeEmitNode(node);
          if (preserveSourceNewlines) {
            var savedPreserveSourceNewlines = preserveSourceNewlines;
            beforeEmitNode(node);
            pipelineEmitWithHintWorker(hint, node);
            afterEmitNode(savedPreserveSourceNewlines);
          } else {
            pipelineEmitWithHintWorker(hint, node);
          }
          onAfterEmitNode === null || onAfterEmitNode === void 0 ? void 0 : onAfterEmitNode(node);
          currentParenthesizerRule = void 0;
        }
        function pipelineEmitWithHintWorker(hint, node) {
          if (hint === 0)
            return emitSourceFile(ts3.cast(node, ts3.isSourceFile));
          if (hint === 2)
            return emitIdentifier(ts3.cast(node, ts3.isIdentifier));
          if (hint === 6)
            return emitLiteral(ts3.cast(node, ts3.isStringLiteral), true);
          if (hint === 3)
            return emitMappedTypeParameter(ts3.cast(node, ts3.isTypeParameterDeclaration));
          if (hint === 5) {
            ts3.Debug.assertNode(node, ts3.isEmptyStatement);
            return emitEmptyStatement(true);
          }
          if (hint === 4) {
            switch (node.kind) {
              case 15:
              case 16:
              case 17:
                return emitLiteral(node, false);
              case 78:
                return emitIdentifier(node);
              case 79:
                return emitPrivateIdentifier(node);
              case 158:
                return emitQualifiedName(node);
              case 159:
                return emitComputedPropertyName(node);
              case 160:
                return emitTypeParameter(node);
              case 161:
                return emitParameter(node);
              case 162:
                return emitDecorator(node);
              case 163:
                return emitPropertySignature(node);
              case 164:
                return emitPropertyDeclaration(node);
              case 165:
                return emitMethodSignature(node);
              case 166:
                return emitMethodDeclaration(node);
              case 167:
                return emitConstructor(node);
              case 168:
              case 169:
                return emitAccessorDeclaration(node);
              case 170:
                return emitCallSignature(node);
              case 171:
                return emitConstructSignature(node);
              case 172:
                return emitIndexSignature(node);
              case 173:
                return emitTypePredicate(node);
              case 174:
                return emitTypeReference(node);
              case 175:
                return emitFunctionType(node);
              case 176:
                return emitConstructorType(node);
              case 177:
                return emitTypeQuery(node);
              case 178:
                return emitTypeLiteral(node);
              case 179:
                return emitArrayType(node);
              case 180:
                return emitTupleType(node);
              case 181:
                return emitOptionalType(node);
              case 183:
                return emitUnionType(node);
              case 184:
                return emitIntersectionType(node);
              case 185:
                return emitConditionalType(node);
              case 186:
                return emitInferType(node);
              case 187:
                return emitParenthesizedType(node);
              case 224:
                return emitExpressionWithTypeArguments(node);
              case 188:
                return emitThisType();
              case 189:
                return emitTypeOperator(node);
              case 190:
                return emitIndexedAccessType(node);
              case 191:
                return emitMappedType(node);
              case 192:
                return emitLiteralType(node);
              case 193:
                return emitNamedTupleMember(node);
              case 194:
                return emitTemplateType(node);
              case 195:
                return emitTemplateTypeSpan(node);
              case 196:
                return emitImportTypeNode(node);
              case 197:
                return emitObjectBindingPattern(node);
              case 198:
                return emitArrayBindingPattern(node);
              case 199:
                return emitBindingElement(node);
              case 229:
                return emitTemplateSpan(node);
              case 230:
                return emitSemicolonClassElement();
              case 231:
                return emitBlock(node);
              case 233:
                return emitVariableStatement(node);
              case 232:
                return emitEmptyStatement(false);
              case 234:
                return emitExpressionStatement(node);
              case 235:
                return emitIfStatement(node);
              case 236:
                return emitDoStatement(node);
              case 237:
                return emitWhileStatement(node);
              case 238:
                return emitForStatement(node);
              case 239:
                return emitForInStatement(node);
              case 240:
                return emitForOfStatement(node);
              case 241:
                return emitContinueStatement(node);
              case 242:
                return emitBreakStatement(node);
              case 243:
                return emitReturnStatement(node);
              case 244:
                return emitWithStatement(node);
              case 245:
                return emitSwitchStatement(node);
              case 246:
                return emitLabeledStatement(node);
              case 247:
                return emitThrowStatement(node);
              case 248:
                return emitTryStatement(node);
              case 249:
                return emitDebuggerStatement(node);
              case 250:
                return emitVariableDeclaration(node);
              case 251:
                return emitVariableDeclarationList(node);
              case 252:
                return emitFunctionDeclaration(node);
              case 253:
                return emitClassDeclaration(node);
              case 254:
                return emitInterfaceDeclaration(node);
              case 255:
                return emitTypeAliasDeclaration(node);
              case 256:
                return emitEnumDeclaration(node);
              case 257:
                return emitModuleDeclaration(node);
              case 258:
                return emitModuleBlock(node);
              case 259:
                return emitCaseBlock(node);
              case 260:
                return emitNamespaceExportDeclaration(node);
              case 261:
                return emitImportEqualsDeclaration(node);
              case 262:
                return emitImportDeclaration(node);
              case 263:
                return emitImportClause(node);
              case 264:
                return emitNamespaceImport(node);
              case 270:
                return emitNamespaceExport(node);
              case 265:
                return emitNamedImports(node);
              case 266:
                return emitImportSpecifier(node);
              case 267:
                return emitExportAssignment(node);
              case 268:
                return emitExportDeclaration(node);
              case 269:
                return emitNamedExports(node);
              case 271:
                return emitExportSpecifier(node);
              case 272:
                return;
              case 273:
                return emitExternalModuleReference(node);
              case 11:
                return emitJsxText(node);
              case 276:
              case 279:
                return emitJsxOpeningElementOrFragment(node);
              case 277:
              case 280:
                return emitJsxClosingElementOrFragment(node);
              case 281:
                return emitJsxAttribute(node);
              case 282:
                return emitJsxAttributes(node);
              case 283:
                return emitJsxSpreadAttribute(node);
              case 284:
                return emitJsxExpression(node);
              case 285:
                return emitCaseClause(node);
              case 286:
                return emitDefaultClause(node);
              case 287:
                return emitHeritageClause(node);
              case 288:
                return emitCatchClause(node);
              case 289:
                return emitPropertyAssignment(node);
              case 290:
                return emitShorthandPropertyAssignment(node);
              case 291:
                return emitSpreadAssignment(node);
              case 292:
                return emitEnumMember(node);
              case 293:
                return writeUnparsedNode(node);
              case 300:
              case 294:
                return emitUnparsedSourceOrPrepend(node);
              case 295:
              case 296:
                return emitUnparsedTextLike(node);
              case 297:
                return emitUnparsedSyntheticReference(node);
              case 298:
                return emitSourceFile(node);
              case 299:
                return ts3.Debug.fail("Bundles should be printed using printBundle");
              case 301:
                return ts3.Debug.fail("InputFiles should not be printed");
              case 302:
                return emitJSDocTypeExpression(node);
              case 303:
                return emitJSDocNameReference(node);
              case 304:
                return writePunctuation("*");
              case 305:
                return writePunctuation("?");
              case 306:
                return emitJSDocNullableType(node);
              case 307:
                return emitJSDocNonNullableType(node);
              case 308:
                return emitJSDocOptionalType(node);
              case 309:
                return emitJSDocFunctionType(node);
              case 182:
              case 310:
                return emitRestOrJSDocVariadicType(node);
              case 311:
                return;
              case 312:
                return emitJSDoc(node);
              case 314:
                return emitJSDocTypeLiteral(node);
              case 315:
                return emitJSDocSignature(node);
              case 317:
              case 322:
                return emitJSDocSimpleTag(node);
              case 318:
              case 319:
                return emitJSDocHeritageTag(node);
              case 320:
              case 321:
                return;
              case 323:
              case 324:
              case 325:
              case 326:
              case 327:
                return;
              case 328:
                return emitJSDocCallbackTag(node);
              case 330:
              case 337:
                return emitJSDocPropertyLikeTag(node);
              case 329:
              case 331:
              case 332:
              case 333:
                return emitJSDocSimpleTypedTag(node);
              case 334:
                return emitJSDocTemplateTag(node);
              case 335:
                return emitJSDocTypedefTag(node);
              case 336:
                return emitJSDocSeeTag(node);
              case 339:
              case 343:
              case 342:
                return;
            }
            if (ts3.isExpression(node)) {
              hint = 1;
              if (substituteNode !== ts3.noEmitSubstitution) {
                var substitute = substituteNode(hint, node) || node;
                if (substitute !== node) {
                  node = substitute;
                  if (currentParenthesizerRule) {
                    node = currentParenthesizerRule(node);
                  }
                }
              }
            }
          }
          if (hint === 1) {
            switch (node.kind) {
              case 8:
              case 9:
                return emitNumericOrBigIntLiteral(node);
              case 10:
              case 13:
              case 14:
                return emitLiteral(node, false);
              case 78:
                return emitIdentifier(node);
              case 200:
                return emitArrayLiteralExpression(node);
              case 201:
                return emitObjectLiteralExpression(node);
              case 202:
                return emitPropertyAccessExpression(node);
              case 203:
                return emitElementAccessExpression(node);
              case 204:
                return emitCallExpression(node);
              case 205:
                return emitNewExpression(node);
              case 206:
                return emitTaggedTemplateExpression(node);
              case 207:
                return emitTypeAssertionExpression(node);
              case 208:
                return emitParenthesizedExpression(node);
              case 209:
                return emitFunctionExpression(node);
              case 210:
                return emitArrowFunction(node);
              case 211:
                return emitDeleteExpression(node);
              case 212:
                return emitTypeOfExpression(node);
              case 213:
                return emitVoidExpression(node);
              case 214:
                return emitAwaitExpression(node);
              case 215:
                return emitPrefixUnaryExpression(node);
              case 216:
                return emitPostfixUnaryExpression(node);
              case 217:
                return emitBinaryExpression(node);
              case 218:
                return emitConditionalExpression(node);
              case 219:
                return emitTemplateExpression(node);
              case 220:
                return emitYieldExpression(node);
              case 221:
                return emitSpreadElement(node);
              case 222:
                return emitClassExpression(node);
              case 223:
                return;
              case 225:
                return emitAsExpression(node);
              case 226:
                return emitNonNullExpression(node);
              case 227:
                return emitMetaProperty(node);
              case 228:
                return ts3.Debug.fail("SyntheticExpression should never be printed.");
              case 274:
                return emitJsxElement(node);
              case 275:
                return emitJsxSelfClosingElement(node);
              case 278:
                return emitJsxFragment(node);
              case 338:
                return ts3.Debug.fail("SyntaxList should not be printed");
              case 339:
                return;
              case 340:
                return emitPartiallyEmittedExpression(node);
              case 341:
                return emitCommaList(node);
              case 342:
              case 343:
                return;
              case 344:
                return ts3.Debug.fail("SyntheticReferenceExpression should not be printed");
            }
          }
          if (ts3.isKeyword(node.kind))
            return writeTokenNode(node, writeKeyword);
          if (ts3.isTokenKind(node.kind))
            return writeTokenNode(node, writePunctuation);
          ts3.Debug.fail("Unhandled SyntaxKind: " + ts3.Debug.formatSyntaxKind(node.kind) + ".");
        }
        function emitMappedTypeParameter(node) {
          emit(node.name);
          writeSpace();
          writeKeyword("in");
          writeSpace();
          emit(node.constraint);
        }
        function pipelineEmitWithSubstitution(hint, node) {
          var pipelinePhase = getNextPipelinePhase(1, hint, node);
          ts3.Debug.assertIsDefined(lastSubstitution);
          node = lastSubstitution;
          lastSubstitution = void 0;
          pipelinePhase(hint, node);
        }
        function getHelpersFromBundledSourceFiles(bundle) {
          var result2;
          if (moduleKind === ts3.ModuleKind.None || printerOptions.noEmitHelpers) {
            return void 0;
          }
          var bundledHelpers2 = new ts3.Map();
          for (var _a3 = 0, _b2 = bundle.sourceFiles; _a3 < _b2.length; _a3++) {
            var sourceFile = _b2[_a3];
            var shouldSkip = ts3.getExternalHelpersModuleName(sourceFile) !== void 0;
            var helpers = getSortedEmitHelpers(sourceFile);
            if (!helpers)
              continue;
            for (var _c2 = 0, helpers_5 = helpers; _c2 < helpers_5.length; _c2++) {
              var helper = helpers_5[_c2];
              if (!helper.scoped && !shouldSkip && !bundledHelpers2.get(helper.name)) {
                bundledHelpers2.set(helper.name, true);
                (result2 || (result2 = [])).push(helper.name);
              }
            }
          }
          return result2;
        }
        function emitHelpers(node) {
          var helpersEmitted = false;
          var bundle = node.kind === 299 ? node : void 0;
          if (bundle && moduleKind === ts3.ModuleKind.None) {
            return;
          }
          var numPrepends = bundle ? bundle.prepends.length : 0;
          var numNodes = bundle ? bundle.sourceFiles.length + numPrepends : 1;
          for (var i3 = 0; i3 < numNodes; i3++) {
            var currentNode = bundle ? i3 < numPrepends ? bundle.prepends[i3] : bundle.sourceFiles[i3 - numPrepends] : node;
            var sourceFile = ts3.isSourceFile(currentNode) ? currentNode : ts3.isUnparsedSource(currentNode) ? void 0 : currentSourceFile;
            var shouldSkip = printerOptions.noEmitHelpers || !!sourceFile && ts3.hasRecordedExternalHelpers(sourceFile);
            var shouldBundle = (ts3.isSourceFile(currentNode) || ts3.isUnparsedSource(currentNode)) && !isOwnFileEmit;
            var helpers = ts3.isUnparsedSource(currentNode) ? currentNode.helpers : getSortedEmitHelpers(currentNode);
            if (helpers) {
              for (var _a3 = 0, helpers_6 = helpers; _a3 < helpers_6.length; _a3++) {
                var helper = helpers_6[_a3];
                if (!helper.scoped) {
                  if (shouldSkip)
                    continue;
                  if (shouldBundle) {
                    if (bundledHelpers.get(helper.name)) {
                      continue;
                    }
                    bundledHelpers.set(helper.name, true);
                  }
                } else if (bundle) {
                  continue;
                }
                var pos = getTextPosWithWriteLine();
                if (typeof helper.text === "string") {
                  writeLines(helper.text);
                } else {
                  writeLines(helper.text(makeFileLevelOptimisticUniqueName));
                }
                if (bundleFileInfo)
                  bundleFileInfo.sections.push({ pos, end: writer.getTextPos(), kind: "emitHelpers", data: helper.name });
                helpersEmitted = true;
              }
            }
          }
          return helpersEmitted;
        }
        function getSortedEmitHelpers(node) {
          var helpers = ts3.getEmitHelpers(node);
          return helpers && ts3.stableSort(helpers, ts3.compareEmitHelpers);
        }
        function emitNumericOrBigIntLiteral(node) {
          emitLiteral(node, false);
        }
        function emitLiteral(node, jsxAttributeEscape) {
          var text = getLiteralTextOfNode(node, printerOptions.neverAsciiEscape, jsxAttributeEscape);
          if ((printerOptions.sourceMap || printerOptions.inlineSourceMap) && (node.kind === 10 || ts3.isTemplateLiteralKind(node.kind))) {
            writeLiteral(text);
          } else {
            writeStringLiteral(text);
          }
        }
        function emitUnparsedSourceOrPrepend(unparsed) {
          for (var _a3 = 0, _b2 = unparsed.texts; _a3 < _b2.length; _a3++) {
            var text = _b2[_a3];
            writeLine();
            emit(text);
          }
        }
        function writeUnparsedNode(unparsed) {
          writer.rawWrite(unparsed.parent.text.substring(unparsed.pos, unparsed.end));
        }
        function emitUnparsedTextLike(unparsed) {
          var pos = getTextPosWithWriteLine();
          writeUnparsedNode(unparsed);
          if (bundleFileInfo) {
            updateOrPushBundleFileTextLike(pos, writer.getTextPos(), unparsed.kind === 295 ? "text" : "internal");
          }
        }
        function emitUnparsedSyntheticReference(unparsed) {
          var pos = getTextPosWithWriteLine();
          writeUnparsedNode(unparsed);
          if (bundleFileInfo) {
            var section = ts3.clone(unparsed.section);
            section.pos = pos;
            section.end = writer.getTextPos();
            bundleFileInfo.sections.push(section);
          }
        }
        function emitIdentifier(node) {
          var writeText = node.symbol ? writeSymbol : write;
          writeText(getTextOfNode(node, false), node.symbol);
          emitList(node, node.typeArguments, 53776);
        }
        function emitPrivateIdentifier(node) {
          var writeText = node.symbol ? writeSymbol : write;
          writeText(getTextOfNode(node, false), node.symbol);
        }
        function emitQualifiedName(node) {
          emitEntityName(node.left);
          writePunctuation(".");
          emit(node.right);
        }
        function emitEntityName(node) {
          if (node.kind === 78) {
            emitExpression(node);
          } else {
            emit(node);
          }
        }
        function emitComputedPropertyName(node) {
          writePunctuation("[");
          emitExpression(node.expression, parenthesizer.parenthesizeExpressionOfComputedPropertyName);
          writePunctuation("]");
        }
        function emitTypeParameter(node) {
          emit(node.name);
          if (node.constraint) {
            writeSpace();
            writeKeyword("extends");
            writeSpace();
            emit(node.constraint);
          }
          if (node.default) {
            writeSpace();
            writeOperator("=");
            writeSpace();
            emit(node.default);
          }
        }
        function emitParameter(node) {
          emitDecorators(node, node.decorators);
          emitModifiers(node, node.modifiers);
          emit(node.dotDotDotToken);
          emitNodeWithWriter(node.name, writeParameter);
          emit(node.questionToken);
          if (node.parent && node.parent.kind === 309 && !node.name) {
            emit(node.type);
          } else {
            emitTypeAnnotation(node.type);
          }
          emitInitializer(node.initializer, node.type ? node.type.end : node.questionToken ? node.questionToken.end : node.name ? node.name.end : node.modifiers ? node.modifiers.end : node.decorators ? node.decorators.end : node.pos, node, parenthesizer.parenthesizeExpressionForDisallowedComma);
        }
        function emitDecorator(decorator) {
          writePunctuation("@");
          emitExpression(decorator.expression, parenthesizer.parenthesizeLeftSideOfAccess);
        }
        function emitPropertySignature(node) {
          emitDecorators(node, node.decorators);
          emitModifiers(node, node.modifiers);
          emitNodeWithWriter(node.name, writeProperty);
          emit(node.questionToken);
          emitTypeAnnotation(node.type);
          writeTrailingSemicolon();
        }
        function emitPropertyDeclaration(node) {
          emitDecorators(node, node.decorators);
          emitModifiers(node, node.modifiers);
          emit(node.name);
          emit(node.questionToken);
          emit(node.exclamationToken);
          emitTypeAnnotation(node.type);
          emitInitializer(node.initializer, node.type ? node.type.end : node.questionToken ? node.questionToken.end : node.name.end, node);
          writeTrailingSemicolon();
        }
        function emitMethodSignature(node) {
          pushNameGenerationScope(node);
          emitDecorators(node, node.decorators);
          emitModifiers(node, node.modifiers);
          emit(node.name);
          emit(node.questionToken);
          emitTypeParameters(node, node.typeParameters);
          emitParameters(node, node.parameters);
          emitTypeAnnotation(node.type);
          writeTrailingSemicolon();
          popNameGenerationScope(node);
        }
        function emitMethodDeclaration(node) {
          emitDecorators(node, node.decorators);
          emitModifiers(node, node.modifiers);
          emit(node.asteriskToken);
          emit(node.name);
          emit(node.questionToken);
          emitSignatureAndBody(node, emitSignatureHead);
        }
        function emitConstructor(node) {
          emitModifiers(node, node.modifiers);
          writeKeyword("constructor");
          emitSignatureAndBody(node, emitSignatureHead);
        }
        function emitAccessorDeclaration(node) {
          emitDecorators(node, node.decorators);
          emitModifiers(node, node.modifiers);
          writeKeyword(node.kind === 168 ? "get" : "set");
          writeSpace();
          emit(node.name);
          emitSignatureAndBody(node, emitSignatureHead);
        }
        function emitCallSignature(node) {
          pushNameGenerationScope(node);
          emitDecorators(node, node.decorators);
          emitModifiers(node, node.modifiers);
          emitTypeParameters(node, node.typeParameters);
          emitParameters(node, node.parameters);
          emitTypeAnnotation(node.type);
          writeTrailingSemicolon();
          popNameGenerationScope(node);
        }
        function emitConstructSignature(node) {
          pushNameGenerationScope(node);
          emitDecorators(node, node.decorators);
          emitModifiers(node, node.modifiers);
          writeKeyword("new");
          writeSpace();
          emitTypeParameters(node, node.typeParameters);
          emitParameters(node, node.parameters);
          emitTypeAnnotation(node.type);
          writeTrailingSemicolon();
          popNameGenerationScope(node);
        }
        function emitIndexSignature(node) {
          emitDecorators(node, node.decorators);
          emitModifiers(node, node.modifiers);
          emitParametersForIndexSignature(node, node.parameters);
          emitTypeAnnotation(node.type);
          writeTrailingSemicolon();
        }
        function emitTemplateTypeSpan(node) {
          emit(node.type);
          emit(node.literal);
        }
        function emitSemicolonClassElement() {
          writeTrailingSemicolon();
        }
        function emitTypePredicate(node) {
          if (node.assertsModifier) {
            emit(node.assertsModifier);
            writeSpace();
          }
          emit(node.parameterName);
          if (node.type) {
            writeSpace();
            writeKeyword("is");
            writeSpace();
            emit(node.type);
          }
        }
        function emitTypeReference(node) {
          emit(node.typeName);
          emitTypeArguments(node, node.typeArguments);
        }
        function emitFunctionType(node) {
          pushNameGenerationScope(node);
          emitTypeParameters(node, node.typeParameters);
          emitParametersForArrow(node, node.parameters);
          writeSpace();
          writePunctuation("=>");
          writeSpace();
          emit(node.type);
          popNameGenerationScope(node);
        }
        function emitJSDocFunctionType(node) {
          writeKeyword("function");
          emitParameters(node, node.parameters);
          writePunctuation(":");
          emit(node.type);
        }
        function emitJSDocNullableType(node) {
          writePunctuation("?");
          emit(node.type);
        }
        function emitJSDocNonNullableType(node) {
          writePunctuation("!");
          emit(node.type);
        }
        function emitJSDocOptionalType(node) {
          emit(node.type);
          writePunctuation("=");
        }
        function emitConstructorType(node) {
          pushNameGenerationScope(node);
          emitModifiers(node, node.modifiers);
          writeKeyword("new");
          writeSpace();
          emitTypeParameters(node, node.typeParameters);
          emitParameters(node, node.parameters);
          writeSpace();
          writePunctuation("=>");
          writeSpace();
          emit(node.type);
          popNameGenerationScope(node);
        }
        function emitTypeQuery(node) {
          writeKeyword("typeof");
          writeSpace();
          emit(node.exprName);
        }
        function emitTypeLiteral(node) {
          writePunctuation("{");
          var flags = ts3.getEmitFlags(node) & 1 ? 768 : 32897;
          emitList(node, node.members, flags | 524288);
          writePunctuation("}");
        }
        function emitArrayType(node) {
          emit(node.elementType, parenthesizer.parenthesizeElementTypeOfArrayType);
          writePunctuation("[");
          writePunctuation("]");
        }
        function emitRestOrJSDocVariadicType(node) {
          writePunctuation("...");
          emit(node.type);
        }
        function emitTupleType(node) {
          emitTokenWithComment(22, node.pos, writePunctuation, node);
          var flags = ts3.getEmitFlags(node) & 1 ? 528 : 657;
          emitList(node, node.elements, flags | 524288);
          emitTokenWithComment(23, node.elements.end, writePunctuation, node);
        }
        function emitNamedTupleMember(node) {
          emit(node.dotDotDotToken);
          emit(node.name);
          emit(node.questionToken);
          emitTokenWithComment(58, node.name.end, writePunctuation, node);
          writeSpace();
          emit(node.type);
        }
        function emitOptionalType(node) {
          emit(node.type, parenthesizer.parenthesizeElementTypeOfArrayType);
          writePunctuation("?");
        }
        function emitUnionType(node) {
          emitList(node, node.types, 516, parenthesizer.parenthesizeMemberOfElementType);
        }
        function emitIntersectionType(node) {
          emitList(node, node.types, 520, parenthesizer.parenthesizeMemberOfElementType);
        }
        function emitConditionalType(node) {
          emit(node.checkType, parenthesizer.parenthesizeMemberOfConditionalType);
          writeSpace();
          writeKeyword("extends");
          writeSpace();
          emit(node.extendsType, parenthesizer.parenthesizeMemberOfConditionalType);
          writeSpace();
          writePunctuation("?");
          writeSpace();
          emit(node.trueType);
          writeSpace();
          writePunctuation(":");
          writeSpace();
          emit(node.falseType);
        }
        function emitInferType(node) {
          writeKeyword("infer");
          writeSpace();
          emit(node.typeParameter);
        }
        function emitParenthesizedType(node) {
          writePunctuation("(");
          emit(node.type);
          writePunctuation(")");
        }
        function emitThisType() {
          writeKeyword("this");
        }
        function emitTypeOperator(node) {
          writeTokenText(node.operator, writeKeyword);
          writeSpace();
          emit(node.type, parenthesizer.parenthesizeMemberOfElementType);
        }
        function emitIndexedAccessType(node) {
          emit(node.objectType, parenthesizer.parenthesizeMemberOfElementType);
          writePunctuation("[");
          emit(node.indexType);
          writePunctuation("]");
        }
        function emitMappedType(node) {
          var emitFlags = ts3.getEmitFlags(node);
          writePunctuation("{");
          if (emitFlags & 1) {
            writeSpace();
          } else {
            writeLine();
            increaseIndent();
          }
          if (node.readonlyToken) {
            emit(node.readonlyToken);
            if (node.readonlyToken.kind !== 142) {
              writeKeyword("readonly");
            }
            writeSpace();
          }
          writePunctuation("[");
          pipelineEmit(3, node.typeParameter);
          if (node.nameType) {
            writeSpace();
            writeKeyword("as");
            writeSpace();
            emit(node.nameType);
          }
          writePunctuation("]");
          if (node.questionToken) {
            emit(node.questionToken);
            if (node.questionToken.kind !== 57) {
              writePunctuation("?");
            }
          }
          writePunctuation(":");
          writeSpace();
          emit(node.type);
          writeTrailingSemicolon();
          if (emitFlags & 1) {
            writeSpace();
          } else {
            writeLine();
            decreaseIndent();
          }
          writePunctuation("}");
        }
        function emitLiteralType(node) {
          emitExpression(node.literal);
        }
        function emitTemplateType(node) {
          emit(node.head);
          emitList(node, node.templateSpans, 262144);
        }
        function emitImportTypeNode(node) {
          if (node.isTypeOf) {
            writeKeyword("typeof");
            writeSpace();
          }
          writeKeyword("import");
          writePunctuation("(");
          emit(node.argument);
          writePunctuation(")");
          if (node.qualifier) {
            writePunctuation(".");
            emit(node.qualifier);
          }
          emitTypeArguments(node, node.typeArguments);
        }
        function emitObjectBindingPattern(node) {
          writePunctuation("{");
          emitList(node, node.elements, 525136);
          writePunctuation("}");
        }
        function emitArrayBindingPattern(node) {
          writePunctuation("[");
          emitList(node, node.elements, 524880);
          writePunctuation("]");
        }
        function emitBindingElement(node) {
          emit(node.dotDotDotToken);
          if (node.propertyName) {
            emit(node.propertyName);
            writePunctuation(":");
            writeSpace();
          }
          emit(node.name);
          emitInitializer(node.initializer, node.name.end, node, parenthesizer.parenthesizeExpressionForDisallowedComma);
        }
        function emitArrayLiteralExpression(node) {
          var elements = node.elements;
          var preferNewLine = node.multiLine ? 65536 : 0;
          emitExpressionList(node, elements, 8914 | preferNewLine, parenthesizer.parenthesizeExpressionForDisallowedComma);
        }
        function emitObjectLiteralExpression(node) {
          ts3.forEach(node.properties, generateMemberNames);
          var indentedFlag = ts3.getEmitFlags(node) & 65536;
          if (indentedFlag) {
            increaseIndent();
          }
          var preferNewLine = node.multiLine ? 65536 : 0;
          var allowTrailingComma = currentSourceFile.languageVersion >= 1 && !ts3.isJsonSourceFile(currentSourceFile) ? 64 : 0;
          emitList(node, node.properties, 526226 | allowTrailingComma | preferNewLine);
          if (indentedFlag) {
            decreaseIndent();
          }
        }
        function emitPropertyAccessExpression(node) {
          emitExpression(node.expression, parenthesizer.parenthesizeLeftSideOfAccess);
          var token = node.questionDotToken || ts3.setTextRangePosEnd(ts3.factory.createToken(24), node.expression.end, node.name.pos);
          var linesBeforeDot = getLinesBetweenNodes(node, node.expression, token);
          var linesAfterDot = getLinesBetweenNodes(node, token, node.name);
          writeLinesAndIndent(linesBeforeDot, false);
          var shouldEmitDotDot = token.kind !== 28 && mayNeedDotDotForPropertyAccess(node.expression) && !writer.hasTrailingComment() && !writer.hasTrailingWhitespace();
          if (shouldEmitDotDot) {
            writePunctuation(".");
          }
          if (node.questionDotToken) {
            emit(token);
          } else {
            emitTokenWithComment(token.kind, node.expression.end, writePunctuation, node);
          }
          writeLinesAndIndent(linesAfterDot, false);
          emit(node.name);
          decreaseIndentIf(linesBeforeDot, linesAfterDot);
        }
        function mayNeedDotDotForPropertyAccess(expression) {
          expression = ts3.skipPartiallyEmittedExpressions(expression);
          if (ts3.isNumericLiteral(expression)) {
            var text = getLiteralTextOfNode(expression, true, false);
            return !expression.numericLiteralFlags && !ts3.stringContains(text, ts3.tokenToString(24));
          } else if (ts3.isAccessExpression(expression)) {
            var constantValue = ts3.getConstantValue(expression);
            return typeof constantValue === "number" && isFinite(constantValue) && Math.floor(constantValue) === constantValue;
          }
        }
        function emitElementAccessExpression(node) {
          emitExpression(node.expression, parenthesizer.parenthesizeLeftSideOfAccess);
          emit(node.questionDotToken);
          emitTokenWithComment(22, node.expression.end, writePunctuation, node);
          emitExpression(node.argumentExpression);
          emitTokenWithComment(23, node.argumentExpression.end, writePunctuation, node);
        }
        function emitCallExpression(node) {
          emitExpression(node.expression, parenthesizer.parenthesizeLeftSideOfAccess);
          emit(node.questionDotToken);
          emitTypeArguments(node, node.typeArguments);
          emitExpressionList(node, node.arguments, 2576, parenthesizer.parenthesizeExpressionForDisallowedComma);
        }
        function emitNewExpression(node) {
          emitTokenWithComment(102, node.pos, writeKeyword, node);
          writeSpace();
          emitExpression(node.expression, parenthesizer.parenthesizeExpressionOfNew);
          emitTypeArguments(node, node.typeArguments);
          emitExpressionList(node, node.arguments, 18960, parenthesizer.parenthesizeExpressionForDisallowedComma);
        }
        function emitTaggedTemplateExpression(node) {
          emitExpression(node.tag, parenthesizer.parenthesizeLeftSideOfAccess);
          emitTypeArguments(node, node.typeArguments);
          writeSpace();
          emitExpression(node.template);
        }
        function emitTypeAssertionExpression(node) {
          writePunctuation("<");
          emit(node.type);
          writePunctuation(">");
          emitExpression(node.expression, parenthesizer.parenthesizeOperandOfPrefixUnary);
        }
        function emitParenthesizedExpression(node) {
          var openParenPos = emitTokenWithComment(20, node.pos, writePunctuation, node);
          var indented = writeLineSeparatorsAndIndentBefore(node.expression, node);
          emitExpression(node.expression, void 0);
          writeLineSeparatorsAfter(node.expression, node);
          decreaseIndentIf(indented);
          emitTokenWithComment(21, node.expression ? node.expression.end : openParenPos, writePunctuation, node);
        }
        function emitFunctionExpression(node) {
          generateNameIfNeeded(node.name);
          emitFunctionDeclarationOrExpression(node);
        }
        function emitArrowFunction(node) {
          emitDecorators(node, node.decorators);
          emitModifiers(node, node.modifiers);
          emitSignatureAndBody(node, emitArrowFunctionHead);
        }
        function emitArrowFunctionHead(node) {
          emitTypeParameters(node, node.typeParameters);
          emitParametersForArrow(node, node.parameters);
          emitTypeAnnotation(node.type);
          writeSpace();
          emit(node.equalsGreaterThanToken);
        }
        function emitDeleteExpression(node) {
          emitTokenWithComment(88, node.pos, writeKeyword, node);
          writeSpace();
          emitExpression(node.expression, parenthesizer.parenthesizeOperandOfPrefixUnary);
        }
        function emitTypeOfExpression(node) {
          emitTokenWithComment(111, node.pos, writeKeyword, node);
          writeSpace();
          emitExpression(node.expression, parenthesizer.parenthesizeOperandOfPrefixUnary);
        }
        function emitVoidExpression(node) {
          emitTokenWithComment(113, node.pos, writeKeyword, node);
          writeSpace();
          emitExpression(node.expression, parenthesizer.parenthesizeOperandOfPrefixUnary);
        }
        function emitAwaitExpression(node) {
          emitTokenWithComment(130, node.pos, writeKeyword, node);
          writeSpace();
          emitExpression(node.expression, parenthesizer.parenthesizeOperandOfPrefixUnary);
        }
        function emitPrefixUnaryExpression(node) {
          writeTokenText(node.operator, writeOperator);
          if (shouldEmitWhitespaceBeforeOperand(node)) {
            writeSpace();
          }
          emitExpression(node.operand, parenthesizer.parenthesizeOperandOfPrefixUnary);
        }
        function shouldEmitWhitespaceBeforeOperand(node) {
          var operand = node.operand;
          return operand.kind === 215 && (node.operator === 39 && (operand.operator === 39 || operand.operator === 45) || node.operator === 40 && (operand.operator === 40 || operand.operator === 46));
        }
        function emitPostfixUnaryExpression(node) {
          emitExpression(node.operand, parenthesizer.parenthesizeOperandOfPostfixUnary);
          writeTokenText(node.operator, writeOperator);
        }
        function createEmitBinaryExpression() {
          return ts3.createBinaryExpressionTrampoline(onEnter, onLeft, onOperator, onRight, onExit, void 0);
          function onEnter(node, state) {
            if (state) {
              state.stackIndex++;
              state.preserveSourceNewlinesStack[state.stackIndex] = preserveSourceNewlines;
              state.containerPosStack[state.stackIndex] = containerPos;
              state.containerEndStack[state.stackIndex] = containerEnd;
              state.declarationListContainerEndStack[state.stackIndex] = declarationListContainerEnd;
              var emitComments_1 = state.shouldEmitCommentsStack[state.stackIndex] = shouldEmitComments(node);
              var emitSourceMaps = state.shouldEmitSourceMapsStack[state.stackIndex] = shouldEmitSourceMaps(node);
              onBeforeEmitNode === null || onBeforeEmitNode === void 0 ? void 0 : onBeforeEmitNode(node);
              if (emitComments_1)
                emitCommentsBeforeNode(node);
              if (emitSourceMaps)
                emitSourceMapsBeforeNode(node);
              beforeEmitNode(node);
            } else {
              state = {
                stackIndex: 0,
                preserveSourceNewlinesStack: [void 0],
                containerPosStack: [-1],
                containerEndStack: [-1],
                declarationListContainerEndStack: [-1],
                shouldEmitCommentsStack: [false],
                shouldEmitSourceMapsStack: [false]
              };
            }
            return state;
          }
          function onLeft(next, _workArea, parent) {
            return maybeEmitExpression(next, parent, "left");
          }
          function onOperator(operatorToken, _state, node) {
            var isCommaOperator = operatorToken.kind !== 27;
            var linesBeforeOperator = getLinesBetweenNodes(node, node.left, operatorToken);
            var linesAfterOperator = getLinesBetweenNodes(node, operatorToken, node.right);
            writeLinesAndIndent(linesBeforeOperator, isCommaOperator);
            emitLeadingCommentsOfPosition(operatorToken.pos);
            writeTokenNode(operatorToken, operatorToken.kind === 100 ? writeKeyword : writeOperator);
            emitTrailingCommentsOfPosition(operatorToken.end, true);
            writeLinesAndIndent(linesAfterOperator, true);
          }
          function onRight(next, _workArea, parent) {
            return maybeEmitExpression(next, parent, "right");
          }
          function onExit(node, state) {
            var linesBeforeOperator = getLinesBetweenNodes(node, node.left, node.operatorToken);
            var linesAfterOperator = getLinesBetweenNodes(node, node.operatorToken, node.right);
            decreaseIndentIf(linesBeforeOperator, linesAfterOperator);
            if (state.stackIndex > 0) {
              var savedPreserveSourceNewlines = state.preserveSourceNewlinesStack[state.stackIndex];
              var savedContainerPos = state.containerPosStack[state.stackIndex];
              var savedContainerEnd = state.containerEndStack[state.stackIndex];
              var savedDeclarationListContainerEnd = state.declarationListContainerEndStack[state.stackIndex];
              var shouldEmitComments_1 = state.shouldEmitCommentsStack[state.stackIndex];
              var shouldEmitSourceMaps_1 = state.shouldEmitSourceMapsStack[state.stackIndex];
              afterEmitNode(savedPreserveSourceNewlines);
              if (shouldEmitSourceMaps_1)
                emitSourceMapsAfterNode(node);
              if (shouldEmitComments_1)
                emitCommentsAfterNode(node, savedContainerPos, savedContainerEnd, savedDeclarationListContainerEnd);
              onAfterEmitNode === null || onAfterEmitNode === void 0 ? void 0 : onAfterEmitNode(node);
              state.stackIndex--;
            }
          }
          function maybeEmitExpression(next, parent, side) {
            var parenthesizerRule = side === "left" ? parenthesizer.getParenthesizeLeftSideOfBinaryForOperator(parent.operatorToken.kind) : parenthesizer.getParenthesizeRightSideOfBinaryForOperator(parent.operatorToken.kind);
            var pipelinePhase = getPipelinePhase(0, 1, next);
            if (pipelinePhase === pipelineEmitWithSubstitution) {
              ts3.Debug.assertIsDefined(lastSubstitution);
              next = parenthesizerRule(ts3.cast(lastSubstitution, ts3.isExpression));
              pipelinePhase = getNextPipelinePhase(1, 1, next);
              lastSubstitution = void 0;
            }
            if (pipelinePhase === pipelineEmitWithComments || pipelinePhase === pipelineEmitWithSourceMaps || pipelinePhase === pipelineEmitWithHint) {
              if (ts3.isBinaryExpression(next)) {
                return next;
              }
            }
            currentParenthesizerRule = parenthesizerRule;
            pipelinePhase(1, next);
          }
        }
        function emitConditionalExpression(node) {
          var linesBeforeQuestion = getLinesBetweenNodes(node, node.condition, node.questionToken);
          var linesAfterQuestion = getLinesBetweenNodes(node, node.questionToken, node.whenTrue);
          var linesBeforeColon = getLinesBetweenNodes(node, node.whenTrue, node.colonToken);
          var linesAfterColon = getLinesBetweenNodes(node, node.colonToken, node.whenFalse);
          emitExpression(node.condition, parenthesizer.parenthesizeConditionOfConditionalExpression);
          writeLinesAndIndent(linesBeforeQuestion, true);
          emit(node.questionToken);
          writeLinesAndIndent(linesAfterQuestion, true);
          emitExpression(node.whenTrue, parenthesizer.parenthesizeBranchOfConditionalExpression);
          decreaseIndentIf(linesBeforeQuestion, linesAfterQuestion);
          writeLinesAndIndent(linesBeforeColon, true);
          emit(node.colonToken);
          writeLinesAndIndent(linesAfterColon, true);
          emitExpression(node.whenFalse, parenthesizer.parenthesizeBranchOfConditionalExpression);
          decreaseIndentIf(linesBeforeColon, linesAfterColon);
        }
        function emitTemplateExpression(node) {
          emit(node.head);
          emitList(node, node.templateSpans, 262144);
        }
        function emitYieldExpression(node) {
          emitTokenWithComment(124, node.pos, writeKeyword, node);
          emit(node.asteriskToken);
          emitExpressionWithLeadingSpace(node.expression, parenthesizer.parenthesizeExpressionForDisallowedComma);
        }
        function emitSpreadElement(node) {
          emitTokenWithComment(25, node.pos, writePunctuation, node);
          emitExpression(node.expression, parenthesizer.parenthesizeExpressionForDisallowedComma);
        }
        function emitClassExpression(node) {
          generateNameIfNeeded(node.name);
          emitClassDeclarationOrExpression(node);
        }
        function emitExpressionWithTypeArguments(node) {
          emitExpression(node.expression, parenthesizer.parenthesizeLeftSideOfAccess);
          emitTypeArguments(node, node.typeArguments);
        }
        function emitAsExpression(node) {
          emitExpression(node.expression, void 0);
          if (node.type) {
            writeSpace();
            writeKeyword("as");
            writeSpace();
            emit(node.type);
          }
        }
        function emitNonNullExpression(node) {
          emitExpression(node.expression, parenthesizer.parenthesizeLeftSideOfAccess);
          writeOperator("!");
        }
        function emitMetaProperty(node) {
          writeToken(node.keywordToken, node.pos, writePunctuation);
          writePunctuation(".");
          emit(node.name);
        }
        function emitTemplateSpan(node) {
          emitExpression(node.expression);
          emit(node.literal);
        }
        function emitBlock(node) {
          emitBlockStatements(node, !node.multiLine && isEmptyBlock(node));
        }
        function emitBlockStatements(node, forceSingleLine) {
          emitTokenWithComment(18, node.pos, writePunctuation, node);
          var format = forceSingleLine || ts3.getEmitFlags(node) & 1 ? 768 : 129;
          emitList(node, node.statements, format);
          emitTokenWithComment(19, node.statements.end, writePunctuation, node, !!(format & 1));
        }
        function emitVariableStatement(node) {
          emitModifiers(node, node.modifiers);
          emit(node.declarationList);
          writeTrailingSemicolon();
        }
        function emitEmptyStatement(isEmbeddedStatement) {
          if (isEmbeddedStatement) {
            writePunctuation(";");
          } else {
            writeTrailingSemicolon();
          }
        }
        function emitExpressionStatement(node) {
          emitExpression(node.expression, parenthesizer.parenthesizeExpressionOfExpressionStatement);
          if (!ts3.isJsonSourceFile(currentSourceFile) || ts3.nodeIsSynthesized(node.expression)) {
            writeTrailingSemicolon();
          }
        }
        function emitIfStatement(node) {
          var openParenPos = emitTokenWithComment(98, node.pos, writeKeyword, node);
          writeSpace();
          emitTokenWithComment(20, openParenPos, writePunctuation, node);
          emitExpression(node.expression);
          emitTokenWithComment(21, node.expression.end, writePunctuation, node);
          emitEmbeddedStatement(node, node.thenStatement);
          if (node.elseStatement) {
            writeLineOrSpace(node, node.thenStatement, node.elseStatement);
            emitTokenWithComment(90, node.thenStatement.end, writeKeyword, node);
            if (node.elseStatement.kind === 235) {
              writeSpace();
              emit(node.elseStatement);
            } else {
              emitEmbeddedStatement(node, node.elseStatement);
            }
          }
        }
        function emitWhileClause(node, startPos) {
          var openParenPos = emitTokenWithComment(114, startPos, writeKeyword, node);
          writeSpace();
          emitTokenWithComment(20, openParenPos, writePunctuation, node);
          emitExpression(node.expression);
          emitTokenWithComment(21, node.expression.end, writePunctuation, node);
        }
        function emitDoStatement(node) {
          emitTokenWithComment(89, node.pos, writeKeyword, node);
          emitEmbeddedStatement(node, node.statement);
          if (ts3.isBlock(node.statement) && !preserveSourceNewlines) {
            writeSpace();
          } else {
            writeLineOrSpace(node, node.statement, node.expression);
          }
          emitWhileClause(node, node.statement.end);
          writeTrailingSemicolon();
        }
        function emitWhileStatement(node) {
          emitWhileClause(node, node.pos);
          emitEmbeddedStatement(node, node.statement);
        }
        function emitForStatement(node) {
          var openParenPos = emitTokenWithComment(96, node.pos, writeKeyword, node);
          writeSpace();
          var pos = emitTokenWithComment(20, openParenPos, writePunctuation, node);
          emitForBinding(node.initializer);
          pos = emitTokenWithComment(26, node.initializer ? node.initializer.end : pos, writePunctuation, node);
          emitExpressionWithLeadingSpace(node.condition);
          pos = emitTokenWithComment(26, node.condition ? node.condition.end : pos, writePunctuation, node);
          emitExpressionWithLeadingSpace(node.incrementor);
          emitTokenWithComment(21, node.incrementor ? node.incrementor.end : pos, writePunctuation, node);
          emitEmbeddedStatement(node, node.statement);
        }
        function emitForInStatement(node) {
          var openParenPos = emitTokenWithComment(96, node.pos, writeKeyword, node);
          writeSpace();
          emitTokenWithComment(20, openParenPos, writePunctuation, node);
          emitForBinding(node.initializer);
          writeSpace();
          emitTokenWithComment(100, node.initializer.end, writeKeyword, node);
          writeSpace();
          emitExpression(node.expression);
          emitTokenWithComment(21, node.expression.end, writePunctuation, node);
          emitEmbeddedStatement(node, node.statement);
        }
        function emitForOfStatement(node) {
          var openParenPos = emitTokenWithComment(96, node.pos, writeKeyword, node);
          writeSpace();
          emitWithTrailingSpace(node.awaitModifier);
          emitTokenWithComment(20, openParenPos, writePunctuation, node);
          emitForBinding(node.initializer);
          writeSpace();
          emitTokenWithComment(157, node.initializer.end, writeKeyword, node);
          writeSpace();
          emitExpression(node.expression);
          emitTokenWithComment(21, node.expression.end, writePunctuation, node);
          emitEmbeddedStatement(node, node.statement);
        }
        function emitForBinding(node) {
          if (node !== void 0) {
            if (node.kind === 251) {
              emit(node);
            } else {
              emitExpression(node);
            }
          }
        }
        function emitContinueStatement(node) {
          emitTokenWithComment(85, node.pos, writeKeyword, node);
          emitWithLeadingSpace(node.label);
          writeTrailingSemicolon();
        }
        function emitBreakStatement(node) {
          emitTokenWithComment(80, node.pos, writeKeyword, node);
          emitWithLeadingSpace(node.label);
          writeTrailingSemicolon();
        }
        function emitTokenWithComment(token, pos, writer2, contextNode, indentLeading) {
          var node = ts3.getParseTreeNode(contextNode);
          var isSimilarNode = node && node.kind === contextNode.kind;
          var startPos = pos;
          if (isSimilarNode && currentSourceFile) {
            pos = ts3.skipTrivia(currentSourceFile.text, pos);
          }
          if (isSimilarNode && contextNode.pos !== startPos) {
            var needsIndent = indentLeading && currentSourceFile && !ts3.positionsAreOnSameLine(startPos, pos, currentSourceFile);
            if (needsIndent) {
              increaseIndent();
            }
            emitLeadingCommentsOfPosition(startPos);
            if (needsIndent) {
              decreaseIndent();
            }
          }
          pos = writeTokenText(token, writer2, pos);
          if (isSimilarNode && contextNode.end !== pos) {
            var isJsxExprContext = contextNode.kind === 284;
            emitTrailingCommentsOfPosition(pos, !isJsxExprContext, isJsxExprContext);
          }
          return pos;
        }
        function emitReturnStatement(node) {
          emitTokenWithComment(104, node.pos, writeKeyword, node);
          emitExpressionWithLeadingSpace(node.expression);
          writeTrailingSemicolon();
        }
        function emitWithStatement(node) {
          var openParenPos = emitTokenWithComment(115, node.pos, writeKeyword, node);
          writeSpace();
          emitTokenWithComment(20, openParenPos, writePunctuation, node);
          emitExpression(node.expression);
          emitTokenWithComment(21, node.expression.end, writePunctuation, node);
          emitEmbeddedStatement(node, node.statement);
        }
        function emitSwitchStatement(node) {
          var openParenPos = emitTokenWithComment(106, node.pos, writeKeyword, node);
          writeSpace();
          emitTokenWithComment(20, openParenPos, writePunctuation, node);
          emitExpression(node.expression);
          emitTokenWithComment(21, node.expression.end, writePunctuation, node);
          writeSpace();
          emit(node.caseBlock);
        }
        function emitLabeledStatement(node) {
          emit(node.label);
          emitTokenWithComment(58, node.label.end, writePunctuation, node);
          writeSpace();
          emit(node.statement);
        }
        function emitThrowStatement(node) {
          emitTokenWithComment(108, node.pos, writeKeyword, node);
          emitExpressionWithLeadingSpace(node.expression);
          writeTrailingSemicolon();
        }
        function emitTryStatement(node) {
          emitTokenWithComment(110, node.pos, writeKeyword, node);
          writeSpace();
          emit(node.tryBlock);
          if (node.catchClause) {
            writeLineOrSpace(node, node.tryBlock, node.catchClause);
            emit(node.catchClause);
          }
          if (node.finallyBlock) {
            writeLineOrSpace(node, node.catchClause || node.tryBlock, node.finallyBlock);
            emitTokenWithComment(95, (node.catchClause || node.tryBlock).end, writeKeyword, node);
            writeSpace();
            emit(node.finallyBlock);
          }
        }
        function emitDebuggerStatement(node) {
          writeToken(86, node.pos, writeKeyword);
          writeTrailingSemicolon();
        }
        function emitVariableDeclaration(node) {
          emit(node.name);
          emit(node.exclamationToken);
          emitTypeAnnotation(node.type);
          emitInitializer(node.initializer, node.type ? node.type.end : node.name.end, node, parenthesizer.parenthesizeExpressionForDisallowedComma);
        }
        function emitVariableDeclarationList(node) {
          writeKeyword(ts3.isLet(node) ? "let" : ts3.isVarConst(node) ? "const" : "var");
          writeSpace();
          emitList(node, node.declarations, 528);
        }
        function emitFunctionDeclaration(node) {
          emitFunctionDeclarationOrExpression(node);
        }
        function emitFunctionDeclarationOrExpression(node) {
          emitDecorators(node, node.decorators);
          emitModifiers(node, node.modifiers);
          writeKeyword("function");
          emit(node.asteriskToken);
          writeSpace();
          emitIdentifierName(node.name);
          emitSignatureAndBody(node, emitSignatureHead);
        }
        function emitSignatureAndBody(node, emitSignatureHead2) {
          var body = node.body;
          if (body) {
            if (ts3.isBlock(body)) {
              var indentedFlag = ts3.getEmitFlags(node) & 65536;
              if (indentedFlag) {
                increaseIndent();
              }
              pushNameGenerationScope(node);
              ts3.forEach(node.parameters, generateNames);
              generateNames(node.body);
              emitSignatureHead2(node);
              emitBlockFunctionBody(body);
              popNameGenerationScope(node);
              if (indentedFlag) {
                decreaseIndent();
              }
            } else {
              emitSignatureHead2(node);
              writeSpace();
              emitExpression(body, parenthesizer.parenthesizeConciseBodyOfArrowFunction);
            }
          } else {
            emitSignatureHead2(node);
            writeTrailingSemicolon();
          }
        }
        function emitSignatureHead(node) {
          emitTypeParameters(node, node.typeParameters);
          emitParameters(node, node.parameters);
          emitTypeAnnotation(node.type);
        }
        function shouldEmitBlockFunctionBodyOnSingleLine(body) {
          if (ts3.getEmitFlags(body) & 1) {
            return true;
          }
          if (body.multiLine) {
            return false;
          }
          if (!ts3.nodeIsSynthesized(body) && !ts3.rangeIsOnSingleLine(body, currentSourceFile)) {
            return false;
          }
          if (getLeadingLineTerminatorCount(body, body.statements, 2) || getClosingLineTerminatorCount(body, body.statements, 2)) {
            return false;
          }
          var previousStatement;
          for (var _a3 = 0, _b2 = body.statements; _a3 < _b2.length; _a3++) {
            var statement = _b2[_a3];
            if (getSeparatingLineTerminatorCount(previousStatement, statement, 2) > 0) {
              return false;
            }
            previousStatement = statement;
          }
          return true;
        }
        function emitBlockFunctionBody(body) {
          onBeforeEmitNode === null || onBeforeEmitNode === void 0 ? void 0 : onBeforeEmitNode(body);
          writeSpace();
          writePunctuation("{");
          increaseIndent();
          var emitBlockFunctionBody2 = shouldEmitBlockFunctionBodyOnSingleLine(body) ? emitBlockFunctionBodyOnSingleLine : emitBlockFunctionBodyWorker;
          if (emitBodyWithDetachedComments) {
            emitBodyWithDetachedComments(body, body.statements, emitBlockFunctionBody2);
          } else {
            emitBlockFunctionBody2(body);
          }
          decreaseIndent();
          writeToken(19, body.statements.end, writePunctuation, body);
          onAfterEmitNode === null || onAfterEmitNode === void 0 ? void 0 : onAfterEmitNode(body);
        }
        function emitBlockFunctionBodyOnSingleLine(body) {
          emitBlockFunctionBodyWorker(body, true);
        }
        function emitBlockFunctionBodyWorker(body, emitBlockFunctionBodyOnSingleLine2) {
          var statementOffset = emitPrologueDirectives(body.statements);
          var pos = writer.getTextPos();
          emitHelpers(body);
          if (statementOffset === 0 && pos === writer.getTextPos() && emitBlockFunctionBodyOnSingleLine2) {
            decreaseIndent();
            emitList(body, body.statements, 768);
            increaseIndent();
          } else {
            emitList(body, body.statements, 1, void 0, statementOffset);
          }
        }
        function emitClassDeclaration(node) {
          emitClassDeclarationOrExpression(node);
        }
        function emitClassDeclarationOrExpression(node) {
          ts3.forEach(node.members, generateMemberNames);
          emitDecorators(node, node.decorators);
          emitModifiers(node, node.modifiers);
          writeKeyword("class");
          if (node.name) {
            writeSpace();
            emitIdentifierName(node.name);
          }
          var indentedFlag = ts3.getEmitFlags(node) & 65536;
          if (indentedFlag) {
            increaseIndent();
          }
          emitTypeParameters(node, node.typeParameters);
          emitList(node, node.heritageClauses, 0);
          writeSpace();
          writePunctuation("{");
          emitList(node, node.members, 129);
          writePunctuation("}");
          if (indentedFlag) {
            decreaseIndent();
          }
        }
        function emitInterfaceDeclaration(node) {
          emitDecorators(node, node.decorators);
          emitModifiers(node, node.modifiers);
          writeKeyword("interface");
          writeSpace();
          emit(node.name);
          emitTypeParameters(node, node.typeParameters);
          emitList(node, node.heritageClauses, 512);
          writeSpace();
          writePunctuation("{");
          emitList(node, node.members, 129);
          writePunctuation("}");
        }
        function emitTypeAliasDeclaration(node) {
          emitDecorators(node, node.decorators);
          emitModifiers(node, node.modifiers);
          writeKeyword("type");
          writeSpace();
          emit(node.name);
          emitTypeParameters(node, node.typeParameters);
          writeSpace();
          writePunctuation("=");
          writeSpace();
          emit(node.type);
          writeTrailingSemicolon();
        }
        function emitEnumDeclaration(node) {
          emitModifiers(node, node.modifiers);
          writeKeyword("enum");
          writeSpace();
          emit(node.name);
          writeSpace();
          writePunctuation("{");
          emitList(node, node.members, 145);
          writePunctuation("}");
        }
        function emitModuleDeclaration(node) {
          emitModifiers(node, node.modifiers);
          if (~node.flags & 1024) {
            writeKeyword(node.flags & 16 ? "namespace" : "module");
            writeSpace();
          }
          emit(node.name);
          var body = node.body;
          if (!body)
            return writeTrailingSemicolon();
          while (body && ts3.isModuleDeclaration(body)) {
            writePunctuation(".");
            emit(body.name);
            body = body.body;
          }
          writeSpace();
          emit(body);
        }
        function emitModuleBlock(node) {
          pushNameGenerationScope(node);
          ts3.forEach(node.statements, generateNames);
          emitBlockStatements(node, isEmptyBlock(node));
          popNameGenerationScope(node);
        }
        function emitCaseBlock(node) {
          emitTokenWithComment(18, node.pos, writePunctuation, node);
          emitList(node, node.clauses, 129);
          emitTokenWithComment(19, node.clauses.end, writePunctuation, node, true);
        }
        function emitImportEqualsDeclaration(node) {
          emitModifiers(node, node.modifiers);
          emitTokenWithComment(99, node.modifiers ? node.modifiers.end : node.pos, writeKeyword, node);
          writeSpace();
          if (node.isTypeOnly) {
            emitTokenWithComment(149, node.pos, writeKeyword, node);
            writeSpace();
          }
          emit(node.name);
          writeSpace();
          emitTokenWithComment(62, node.name.end, writePunctuation, node);
          writeSpace();
          emitModuleReference(node.moduleReference);
          writeTrailingSemicolon();
        }
        function emitModuleReference(node) {
          if (node.kind === 78) {
            emitExpression(node);
          } else {
            emit(node);
          }
        }
        function emitImportDeclaration(node) {
          emitModifiers(node, node.modifiers);
          emitTokenWithComment(99, node.modifiers ? node.modifiers.end : node.pos, writeKeyword, node);
          writeSpace();
          if (node.importClause) {
            emit(node.importClause);
            writeSpace();
            emitTokenWithComment(153, node.importClause.end, writeKeyword, node);
            writeSpace();
          }
          emitExpression(node.moduleSpecifier);
          writeTrailingSemicolon();
        }
        function emitImportClause(node) {
          if (node.isTypeOnly) {
            emitTokenWithComment(149, node.pos, writeKeyword, node);
            writeSpace();
          }
          emit(node.name);
          if (node.name && node.namedBindings) {
            emitTokenWithComment(27, node.name.end, writePunctuation, node);
            writeSpace();
          }
          emit(node.namedBindings);
        }
        function emitNamespaceImport(node) {
          var asPos = emitTokenWithComment(41, node.pos, writePunctuation, node);
          writeSpace();
          emitTokenWithComment(126, asPos, writeKeyword, node);
          writeSpace();
          emit(node.name);
        }
        function emitNamedImports(node) {
          emitNamedImportsOrExports(node);
        }
        function emitImportSpecifier(node) {
          emitImportOrExportSpecifier(node);
        }
        function emitExportAssignment(node) {
          var nextPos = emitTokenWithComment(92, node.pos, writeKeyword, node);
          writeSpace();
          if (node.isExportEquals) {
            emitTokenWithComment(62, nextPos, writeOperator, node);
          } else {
            emitTokenWithComment(87, nextPos, writeKeyword, node);
          }
          writeSpace();
          emitExpression(node.expression, node.isExportEquals ? parenthesizer.getParenthesizeRightSideOfBinaryForOperator(62) : parenthesizer.parenthesizeExpressionOfExportDefault);
          writeTrailingSemicolon();
        }
        function emitExportDeclaration(node) {
          var nextPos = emitTokenWithComment(92, node.pos, writeKeyword, node);
          writeSpace();
          if (node.isTypeOnly) {
            nextPos = emitTokenWithComment(149, nextPos, writeKeyword, node);
            writeSpace();
          }
          if (node.exportClause) {
            emit(node.exportClause);
          } else {
            nextPos = emitTokenWithComment(41, nextPos, writePunctuation, node);
          }
          if (node.moduleSpecifier) {
            writeSpace();
            var fromPos = node.exportClause ? node.exportClause.end : nextPos;
            emitTokenWithComment(153, fromPos, writeKeyword, node);
            writeSpace();
            emitExpression(node.moduleSpecifier);
          }
          writeTrailingSemicolon();
        }
        function emitNamespaceExportDeclaration(node) {
          var nextPos = emitTokenWithComment(92, node.pos, writeKeyword, node);
          writeSpace();
          nextPos = emitTokenWithComment(126, nextPos, writeKeyword, node);
          writeSpace();
          nextPos = emitTokenWithComment(140, nextPos, writeKeyword, node);
          writeSpace();
          emit(node.name);
          writeTrailingSemicolon();
        }
        function emitNamespaceExport(node) {
          var asPos = emitTokenWithComment(41, node.pos, writePunctuation, node);
          writeSpace();
          emitTokenWithComment(126, asPos, writeKeyword, node);
          writeSpace();
          emit(node.name);
        }
        function emitNamedExports(node) {
          emitNamedImportsOrExports(node);
        }
        function emitExportSpecifier(node) {
          emitImportOrExportSpecifier(node);
        }
        function emitNamedImportsOrExports(node) {
          writePunctuation("{");
          emitList(node, node.elements, 525136);
          writePunctuation("}");
        }
        function emitImportOrExportSpecifier(node) {
          if (node.propertyName) {
            emit(node.propertyName);
            writeSpace();
            emitTokenWithComment(126, node.propertyName.end, writeKeyword, node);
            writeSpace();
          }
          emit(node.name);
        }
        function emitExternalModuleReference(node) {
          writeKeyword("require");
          writePunctuation("(");
          emitExpression(node.expression);
          writePunctuation(")");
        }
        function emitJsxElement(node) {
          emit(node.openingElement);
          emitList(node, node.children, 262144);
          emit(node.closingElement);
        }
        function emitJsxSelfClosingElement(node) {
          writePunctuation("<");
          emitJsxTagName(node.tagName);
          emitTypeArguments(node, node.typeArguments);
          writeSpace();
          emit(node.attributes);
          writePunctuation("/>");
        }
        function emitJsxFragment(node) {
          emit(node.openingFragment);
          emitList(node, node.children, 262144);
          emit(node.closingFragment);
        }
        function emitJsxOpeningElementOrFragment(node) {
          writePunctuation("<");
          if (ts3.isJsxOpeningElement(node)) {
            var indented = writeLineSeparatorsAndIndentBefore(node.tagName, node);
            emitJsxTagName(node.tagName);
            emitTypeArguments(node, node.typeArguments);
            if (node.attributes.properties && node.attributes.properties.length > 0) {
              writeSpace();
            }
            emit(node.attributes);
            writeLineSeparatorsAfter(node.attributes, node);
            decreaseIndentIf(indented);
          }
          writePunctuation(">");
        }
        function emitJsxText(node) {
          writer.writeLiteral(node.text);
        }
        function emitJsxClosingElementOrFragment(node) {
          writePunctuation("</");
          if (ts3.isJsxClosingElement(node)) {
            emitJsxTagName(node.tagName);
          }
          writePunctuation(">");
        }
        function emitJsxAttributes(node) {
          emitList(node, node.properties, 262656);
        }
        function emitJsxAttribute(node) {
          emit(node.name);
          emitNodeWithPrefix("=", writePunctuation, node.initializer, emitJsxAttributeValue);
        }
        function emitJsxSpreadAttribute(node) {
          writePunctuation("{...");
          emitExpression(node.expression);
          writePunctuation("}");
        }
        function hasTrailingCommentsAtPosition(pos) {
          var result2 = false;
          ts3.forEachTrailingCommentRange((currentSourceFile === null || currentSourceFile === void 0 ? void 0 : currentSourceFile.text) || "", pos + 1, function() {
            return result2 = true;
          });
          return result2;
        }
        function hasLeadingCommentsAtPosition(pos) {
          var result2 = false;
          ts3.forEachLeadingCommentRange((currentSourceFile === null || currentSourceFile === void 0 ? void 0 : currentSourceFile.text) || "", pos + 1, function() {
            return result2 = true;
          });
          return result2;
        }
        function hasCommentsAtPosition(pos) {
          return hasTrailingCommentsAtPosition(pos) || hasLeadingCommentsAtPosition(pos);
        }
        function emitJsxExpression(node) {
          var _a3;
          if (node.expression || !commentsDisabled && !ts3.nodeIsSynthesized(node) && hasCommentsAtPosition(node.pos)) {
            var isMultiline = currentSourceFile && !ts3.nodeIsSynthesized(node) && ts3.getLineAndCharacterOfPosition(currentSourceFile, node.pos).line !== ts3.getLineAndCharacterOfPosition(currentSourceFile, node.end).line;
            if (isMultiline) {
              writer.increaseIndent();
            }
            var end = emitTokenWithComment(18, node.pos, writePunctuation, node);
            emit(node.dotDotDotToken);
            emitExpression(node.expression);
            emitTokenWithComment(19, ((_a3 = node.expression) === null || _a3 === void 0 ? void 0 : _a3.end) || end, writePunctuation, node);
            if (isMultiline) {
              writer.decreaseIndent();
            }
          }
        }
        function emitJsxTagName(node) {
          if (node.kind === 78) {
            emitExpression(node);
          } else {
            emit(node);
          }
        }
        function emitCaseClause(node) {
          emitTokenWithComment(81, node.pos, writeKeyword, node);
          writeSpace();
          emitExpression(node.expression, parenthesizer.parenthesizeExpressionForDisallowedComma);
          emitCaseOrDefaultClauseRest(node, node.statements, node.expression.end);
        }
        function emitDefaultClause(node) {
          var pos = emitTokenWithComment(87, node.pos, writeKeyword, node);
          emitCaseOrDefaultClauseRest(node, node.statements, pos);
        }
        function emitCaseOrDefaultClauseRest(parentNode, statements, colonPos) {
          var emitAsSingleStatement = statements.length === 1 && (ts3.nodeIsSynthesized(parentNode) || ts3.nodeIsSynthesized(statements[0]) || ts3.rangeStartPositionsAreOnSameLine(parentNode, statements[0], currentSourceFile));
          var format = 163969;
          if (emitAsSingleStatement) {
            writeToken(58, colonPos, writePunctuation, parentNode);
            writeSpace();
            format &= ~(1 | 128);
          } else {
            emitTokenWithComment(58, colonPos, writePunctuation, parentNode);
          }
          emitList(parentNode, statements, format);
        }
        function emitHeritageClause(node) {
          writeSpace();
          writeTokenText(node.token, writeKeyword);
          writeSpace();
          emitList(node, node.types, 528);
        }
        function emitCatchClause(node) {
          var openParenPos = emitTokenWithComment(82, node.pos, writeKeyword, node);
          writeSpace();
          if (node.variableDeclaration) {
            emitTokenWithComment(20, openParenPos, writePunctuation, node);
            emit(node.variableDeclaration);
            emitTokenWithComment(21, node.variableDeclaration.end, writePunctuation, node);
            writeSpace();
          }
          emit(node.block);
        }
        function emitPropertyAssignment(node) {
          emit(node.name);
          writePunctuation(":");
          writeSpace();
          var initializer = node.initializer;
          if ((ts3.getEmitFlags(initializer) & 512) === 0) {
            var commentRange = ts3.getCommentRange(initializer);
            emitTrailingCommentsOfPosition(commentRange.pos);
          }
          emitExpression(initializer, parenthesizer.parenthesizeExpressionForDisallowedComma);
        }
        function emitShorthandPropertyAssignment(node) {
          emit(node.name);
          if (node.objectAssignmentInitializer) {
            writeSpace();
            writePunctuation("=");
            writeSpace();
            emitExpression(node.objectAssignmentInitializer, parenthesizer.parenthesizeExpressionForDisallowedComma);
          }
        }
        function emitSpreadAssignment(node) {
          if (node.expression) {
            emitTokenWithComment(25, node.pos, writePunctuation, node);
            emitExpression(node.expression, parenthesizer.parenthesizeExpressionForDisallowedComma);
          }
        }
        function emitEnumMember(node) {
          emit(node.name);
          emitInitializer(node.initializer, node.name.end, node, parenthesizer.parenthesizeExpressionForDisallowedComma);
        }
        function emitJSDoc(node) {
          write("/**");
          if (node.comment) {
            var text = ts3.getTextOfJSDocComment(node.comment);
            if (text) {
              var lines = text.split(/\r\n?|\n/g);
              for (var _a3 = 0, lines_2 = lines; _a3 < lines_2.length; _a3++) {
                var line = lines_2[_a3];
                writeLine();
                writeSpace();
                writePunctuation("*");
                writeSpace();
                write(line);
              }
            }
          }
          if (node.tags) {
            if (node.tags.length === 1 && node.tags[0].kind === 333 && !node.comment) {
              writeSpace();
              emit(node.tags[0]);
            } else {
              emitList(node, node.tags, 33);
            }
          }
          writeSpace();
          write("*/");
        }
        function emitJSDocSimpleTypedTag(tag) {
          emitJSDocTagName(tag.tagName);
          emitJSDocTypeExpression(tag.typeExpression);
          emitJSDocComment(tag.comment);
        }
        function emitJSDocSeeTag(tag) {
          emitJSDocTagName(tag.tagName);
          emit(tag.name);
          emitJSDocComment(tag.comment);
        }
        function emitJSDocNameReference(node) {
          writeSpace();
          writePunctuation("{");
          emit(node.name);
          writePunctuation("}");
        }
        function emitJSDocHeritageTag(tag) {
          emitJSDocTagName(tag.tagName);
          writeSpace();
          writePunctuation("{");
          emit(tag.class);
          writePunctuation("}");
          emitJSDocComment(tag.comment);
        }
        function emitJSDocTemplateTag(tag) {
          emitJSDocTagName(tag.tagName);
          emitJSDocTypeExpression(tag.constraint);
          writeSpace();
          emitList(tag, tag.typeParameters, 528);
          emitJSDocComment(tag.comment);
        }
        function emitJSDocTypedefTag(tag) {
          emitJSDocTagName(tag.tagName);
          if (tag.typeExpression) {
            if (tag.typeExpression.kind === 302) {
              emitJSDocTypeExpression(tag.typeExpression);
            } else {
              writeSpace();
              writePunctuation("{");
              write("Object");
              if (tag.typeExpression.isArrayType) {
                writePunctuation("[");
                writePunctuation("]");
              }
              writePunctuation("}");
            }
          }
          if (tag.fullName) {
            writeSpace();
            emit(tag.fullName);
          }
          emitJSDocComment(tag.comment);
          if (tag.typeExpression && tag.typeExpression.kind === 314) {
            emitJSDocTypeLiteral(tag.typeExpression);
          }
        }
        function emitJSDocCallbackTag(tag) {
          emitJSDocTagName(tag.tagName);
          if (tag.name) {
            writeSpace();
            emit(tag.name);
          }
          emitJSDocComment(tag.comment);
          emitJSDocSignature(tag.typeExpression);
        }
        function emitJSDocSimpleTag(tag) {
          emitJSDocTagName(tag.tagName);
          emitJSDocComment(tag.comment);
        }
        function emitJSDocTypeLiteral(lit) {
          emitList(lit, ts3.factory.createNodeArray(lit.jsDocPropertyTags), 33);
        }
        function emitJSDocSignature(sig) {
          if (sig.typeParameters) {
            emitList(sig, ts3.factory.createNodeArray(sig.typeParameters), 33);
          }
          if (sig.parameters) {
            emitList(sig, ts3.factory.createNodeArray(sig.parameters), 33);
          }
          if (sig.type) {
            writeLine();
            writeSpace();
            writePunctuation("*");
            writeSpace();
            emit(sig.type);
          }
        }
        function emitJSDocPropertyLikeTag(param) {
          emitJSDocTagName(param.tagName);
          emitJSDocTypeExpression(param.typeExpression);
          writeSpace();
          if (param.isBracketed) {
            writePunctuation("[");
          }
          emit(param.name);
          if (param.isBracketed) {
            writePunctuation("]");
          }
          emitJSDocComment(param.comment);
        }
        function emitJSDocTagName(tagName) {
          writePunctuation("@");
          emit(tagName);
        }
        function emitJSDocComment(comment) {
          var text = ts3.getTextOfJSDocComment(comment);
          if (text) {
            writeSpace();
            write(text);
          }
        }
        function emitJSDocTypeExpression(typeExpression) {
          if (typeExpression) {
            writeSpace();
            writePunctuation("{");
            emit(typeExpression.type);
            writePunctuation("}");
          }
        }
        function emitSourceFile(node) {
          writeLine();
          var statements = node.statements;
          if (emitBodyWithDetachedComments) {
            var shouldEmitDetachedComment = statements.length === 0 || !ts3.isPrologueDirective(statements[0]) || ts3.nodeIsSynthesized(statements[0]);
            if (shouldEmitDetachedComment) {
              emitBodyWithDetachedComments(node, statements, emitSourceFileWorker);
              return;
            }
          }
          emitSourceFileWorker(node);
        }
        function emitSyntheticTripleSlashReferencesIfNeeded(node) {
          emitTripleSlashDirectives(!!node.hasNoDefaultLib, node.syntheticFileReferences || [], node.syntheticTypeReferences || [], node.syntheticLibReferences || []);
          for (var _a3 = 0, _b2 = node.prepends; _a3 < _b2.length; _a3++) {
            var prepend = _b2[_a3];
            if (ts3.isUnparsedSource(prepend) && prepend.syntheticReferences) {
              for (var _c2 = 0, _d = prepend.syntheticReferences; _c2 < _d.length; _c2++) {
                var ref2 = _d[_c2];
                emit(ref2);
                writeLine();
              }
            }
          }
        }
        function emitTripleSlashDirectivesIfNeeded(node) {
          if (node.isDeclarationFile)
            emitTripleSlashDirectives(node.hasNoDefaultLib, node.referencedFiles, node.typeReferenceDirectives, node.libReferenceDirectives);
        }
        function emitTripleSlashDirectives(hasNoDefaultLib, files, types2, libs) {
          if (hasNoDefaultLib) {
            var pos = writer.getTextPos();
            writeComment('/// <reference no-default-lib="true"/>');
            if (bundleFileInfo)
              bundleFileInfo.sections.push({ pos, end: writer.getTextPos(), kind: "no-default-lib" });
            writeLine();
          }
          if (currentSourceFile && currentSourceFile.moduleName) {
            writeComment('/// <amd-module name="' + currentSourceFile.moduleName + '" />');
            writeLine();
          }
          if (currentSourceFile && currentSourceFile.amdDependencies) {
            for (var _a3 = 0, _b2 = currentSourceFile.amdDependencies; _a3 < _b2.length; _a3++) {
              var dep = _b2[_a3];
              if (dep.name) {
                writeComment('/// <amd-dependency name="' + dep.name + '" path="' + dep.path + '" />');
              } else {
                writeComment('/// <amd-dependency path="' + dep.path + '" />');
              }
              writeLine();
            }
          }
          for (var _c2 = 0, files_1 = files; _c2 < files_1.length; _c2++) {
            var directive = files_1[_c2];
            var pos = writer.getTextPos();
            writeComment('/// <reference path="' + directive.fileName + '" />');
            if (bundleFileInfo)
              bundleFileInfo.sections.push({ pos, end: writer.getTextPos(), kind: "reference", data: directive.fileName });
            writeLine();
          }
          for (var _d = 0, types_25 = types2; _d < types_25.length; _d++) {
            var directive = types_25[_d];
            var pos = writer.getTextPos();
            writeComment('/// <reference types="' + directive.fileName + '" />');
            if (bundleFileInfo)
              bundleFileInfo.sections.push({ pos, end: writer.getTextPos(), kind: "type", data: directive.fileName });
            writeLine();
          }
          for (var _e = 0, libs_1 = libs; _e < libs_1.length; _e++) {
            var directive = libs_1[_e];
            var pos = writer.getTextPos();
            writeComment('/// <reference lib="' + directive.fileName + '" />');
            if (bundleFileInfo)
              bundleFileInfo.sections.push({ pos, end: writer.getTextPos(), kind: "lib", data: directive.fileName });
            writeLine();
          }
        }
        function emitSourceFileWorker(node) {
          var statements = node.statements;
          pushNameGenerationScope(node);
          ts3.forEach(node.statements, generateNames);
          emitHelpers(node);
          var index = ts3.findIndex(statements, function(statement) {
            return !ts3.isPrologueDirective(statement);
          });
          emitTripleSlashDirectivesIfNeeded(node);
          emitList(node, statements, 1, void 0, index === -1 ? statements.length : index);
          popNameGenerationScope(node);
        }
        function emitPartiallyEmittedExpression(node) {
          emitExpression(node.expression);
        }
        function emitCommaList(node) {
          emitExpressionList(node, node.elements, 528, void 0);
        }
        function emitPrologueDirectives(statements, sourceFile, seenPrologueDirectives, recordBundleFileSection) {
          var needsToSetSourceFile = !!sourceFile;
          for (var i3 = 0; i3 < statements.length; i3++) {
            var statement = statements[i3];
            if (ts3.isPrologueDirective(statement)) {
              var shouldEmitPrologueDirective = seenPrologueDirectives ? !seenPrologueDirectives.has(statement.expression.text) : true;
              if (shouldEmitPrologueDirective) {
                if (needsToSetSourceFile) {
                  needsToSetSourceFile = false;
                  setSourceFile(sourceFile);
                }
                writeLine();
                var pos = writer.getTextPos();
                emit(statement);
                if (recordBundleFileSection && bundleFileInfo)
                  bundleFileInfo.sections.push({ pos, end: writer.getTextPos(), kind: "prologue", data: statement.expression.text });
                if (seenPrologueDirectives) {
                  seenPrologueDirectives.add(statement.expression.text);
                }
              }
            } else {
              return i3;
            }
          }
          return statements.length;
        }
        function emitUnparsedPrologues(prologues, seenPrologueDirectives) {
          for (var _a3 = 0, prologues_1 = prologues; _a3 < prologues_1.length; _a3++) {
            var prologue = prologues_1[_a3];
            if (!seenPrologueDirectives.has(prologue.data)) {
              writeLine();
              var pos = writer.getTextPos();
              emit(prologue);
              if (bundleFileInfo)
                bundleFileInfo.sections.push({ pos, end: writer.getTextPos(), kind: "prologue", data: prologue.data });
              if (seenPrologueDirectives) {
                seenPrologueDirectives.add(prologue.data);
              }
            }
          }
        }
        function emitPrologueDirectivesIfNeeded(sourceFileOrBundle) {
          if (ts3.isSourceFile(sourceFileOrBundle)) {
            emitPrologueDirectives(sourceFileOrBundle.statements, sourceFileOrBundle);
          } else {
            var seenPrologueDirectives = new ts3.Set();
            for (var _a3 = 0, _b2 = sourceFileOrBundle.prepends; _a3 < _b2.length; _a3++) {
              var prepend = _b2[_a3];
              emitUnparsedPrologues(prepend.prologues, seenPrologueDirectives);
            }
            for (var _c2 = 0, _d = sourceFileOrBundle.sourceFiles; _c2 < _d.length; _c2++) {
              var sourceFile = _d[_c2];
              emitPrologueDirectives(sourceFile.statements, sourceFile, seenPrologueDirectives, true);
            }
            setSourceFile(void 0);
          }
        }
        function getPrologueDirectivesFromBundledSourceFiles(bundle) {
          var seenPrologueDirectives = new ts3.Set();
          var prologues;
          for (var index = 0; index < bundle.sourceFiles.length; index++) {
            var sourceFile = bundle.sourceFiles[index];
            var directives = void 0;
            var end = 0;
            for (var _a3 = 0, _b2 = sourceFile.statements; _a3 < _b2.length; _a3++) {
              var statement = _b2[_a3];
              if (!ts3.isPrologueDirective(statement))
                break;
              if (seenPrologueDirectives.has(statement.expression.text))
                continue;
              seenPrologueDirectives.add(statement.expression.text);
              (directives || (directives = [])).push({
                pos: statement.pos,
                end: statement.end,
                expression: {
                  pos: statement.expression.pos,
                  end: statement.expression.end,
                  text: statement.expression.text
                }
              });
              end = end < statement.end ? statement.end : end;
            }
            if (directives)
              (prologues || (prologues = [])).push({ file: index, text: sourceFile.text.substring(0, end), directives });
          }
          return prologues;
        }
        function emitShebangIfNeeded(sourceFileOrBundle) {
          if (ts3.isSourceFile(sourceFileOrBundle) || ts3.isUnparsedSource(sourceFileOrBundle)) {
            var shebang = ts3.getShebang(sourceFileOrBundle.text);
            if (shebang) {
              writeComment(shebang);
              writeLine();
              return true;
            }
          } else {
            for (var _a3 = 0, _b2 = sourceFileOrBundle.prepends; _a3 < _b2.length; _a3++) {
              var prepend = _b2[_a3];
              ts3.Debug.assertNode(prepend, ts3.isUnparsedSource);
              if (emitShebangIfNeeded(prepend)) {
                return true;
              }
            }
            for (var _c2 = 0, _d = sourceFileOrBundle.sourceFiles; _c2 < _d.length; _c2++) {
              var sourceFile = _d[_c2];
              if (emitShebangIfNeeded(sourceFile)) {
                return true;
              }
            }
          }
        }
        function emitNodeWithWriter(node, writer2) {
          if (!node)
            return;
          var savedWrite = write;
          write = writer2;
          emit(node);
          write = savedWrite;
        }
        function emitModifiers(node, modifiers) {
          if (modifiers && modifiers.length) {
            emitList(node, modifiers, 262656);
            writeSpace();
          }
        }
        function emitTypeAnnotation(node) {
          if (node) {
            writePunctuation(":");
            writeSpace();
            emit(node);
          }
        }
        function emitInitializer(node, equalCommentStartPos, container, parenthesizerRule) {
          if (node) {
            writeSpace();
            emitTokenWithComment(62, equalCommentStartPos, writeOperator, container);
            writeSpace();
            emitExpression(node, parenthesizerRule);
          }
        }
        function emitNodeWithPrefix(prefix2, prefixWriter, node, emit2) {
          if (node) {
            prefixWriter(prefix2);
            emit2(node);
          }
        }
        function emitWithLeadingSpace(node) {
          if (node) {
            writeSpace();
            emit(node);
          }
        }
        function emitExpressionWithLeadingSpace(node, parenthesizerRule) {
          if (node) {
            writeSpace();
            emitExpression(node, parenthesizerRule);
          }
        }
        function emitWithTrailingSpace(node) {
          if (node) {
            emit(node);
            writeSpace();
          }
        }
        function emitEmbeddedStatement(parent, node) {
          if (ts3.isBlock(node) || ts3.getEmitFlags(parent) & 1) {
            writeSpace();
            emit(node);
          } else {
            writeLine();
            increaseIndent();
            if (ts3.isEmptyStatement(node)) {
              pipelineEmit(5, node);
            } else {
              emit(node);
            }
            decreaseIndent();
          }
        }
        function emitDecorators(parentNode, decorators) {
          emitList(parentNode, decorators, 2146305);
        }
        function emitTypeArguments(parentNode, typeArguments) {
          emitList(parentNode, typeArguments, 53776, parenthesizer.parenthesizeMemberOfElementType);
        }
        function emitTypeParameters(parentNode, typeParameters) {
          if (ts3.isFunctionLike(parentNode) && parentNode.typeArguments) {
            return emitTypeArguments(parentNode, parentNode.typeArguments);
          }
          emitList(parentNode, typeParameters, 53776);
        }
        function emitParameters(parentNode, parameters) {
          emitList(parentNode, parameters, 2576);
        }
        function canEmitSimpleArrowHead(parentNode, parameters) {
          var parameter = ts3.singleOrUndefined(parameters);
          return parameter && parameter.pos === parentNode.pos && ts3.isArrowFunction(parentNode) && !parentNode.type && !ts3.some(parentNode.decorators) && !ts3.some(parentNode.modifiers) && !ts3.some(parentNode.typeParameters) && !ts3.some(parameter.decorators) && !ts3.some(parameter.modifiers) && !parameter.dotDotDotToken && !parameter.questionToken && !parameter.type && !parameter.initializer && ts3.isIdentifier(parameter.name);
        }
        function emitParametersForArrow(parentNode, parameters) {
          if (canEmitSimpleArrowHead(parentNode, parameters)) {
            emitList(parentNode, parameters, 2576 & ~2048);
          } else {
            emitParameters(parentNode, parameters);
          }
        }
        function emitParametersForIndexSignature(parentNode, parameters) {
          emitList(parentNode, parameters, 8848);
        }
        function writeDelimiter(format) {
          switch (format & 60) {
            case 0:
              break;
            case 16:
              writePunctuation(",");
              break;
            case 4:
              writeSpace();
              writePunctuation("|");
              break;
            case 32:
              writeSpace();
              writePunctuation("*");
              writeSpace();
              break;
            case 8:
              writeSpace();
              writePunctuation("&");
              break;
          }
        }
        function emitList(parentNode, children, format, parenthesizerRule, start, count) {
          emitNodeList(emit, parentNode, children, format, parenthesizerRule, start, count);
        }
        function emitExpressionList(parentNode, children, format, parenthesizerRule, start, count) {
          emitNodeList(emitExpression, parentNode, children, format, parenthesizerRule, start, count);
        }
        function emitNodeList(emit2, parentNode, children, format, parenthesizerRule, start, count) {
          if (start === void 0) {
            start = 0;
          }
          if (count === void 0) {
            count = children ? children.length - start : 0;
          }
          var isUndefined = children === void 0;
          if (isUndefined && format & 16384) {
            return;
          }
          var isEmpty = children === void 0 || start >= children.length || count === 0;
          if (isEmpty && format & 32768) {
            if (onBeforeEmitNodeArray) {
              onBeforeEmitNodeArray(children);
            }
            if (onAfterEmitNodeArray) {
              onAfterEmitNodeArray(children);
            }
            return;
          }
          if (format & 15360) {
            writePunctuation(getOpeningBracket(format));
            if (isEmpty && children) {
              emitTrailingCommentsOfPosition(children.pos, true);
            }
          }
          if (onBeforeEmitNodeArray) {
            onBeforeEmitNodeArray(children);
          }
          if (isEmpty) {
            if (format & 1 && !(preserveSourceNewlines && (!parentNode || ts3.rangeIsOnSingleLine(parentNode, currentSourceFile)))) {
              writeLine();
            } else if (format & 256 && !(format & 524288)) {
              writeSpace();
            }
          } else {
            ts3.Debug.type(children);
            var mayEmitInterveningComments = (format & 262144) === 0;
            var shouldEmitInterveningComments = mayEmitInterveningComments;
            var leadingLineTerminatorCount = getLeadingLineTerminatorCount(parentNode, children, format);
            if (leadingLineTerminatorCount) {
              writeLine(leadingLineTerminatorCount);
              shouldEmitInterveningComments = false;
            } else if (format & 256) {
              writeSpace();
            }
            if (format & 128) {
              increaseIndent();
            }
            var previousSibling = void 0;
            var previousSourceFileTextKind = void 0;
            var shouldDecreaseIndentAfterEmit = false;
            for (var i3 = 0; i3 < count; i3++) {
              var child = children[start + i3];
              if (format & 32) {
                writeLine();
                writeDelimiter(format);
              } else if (previousSibling) {
                if (format & 60 && previousSibling.end !== (parentNode ? parentNode.end : -1)) {
                  emitLeadingCommentsOfPosition(previousSibling.end);
                }
                writeDelimiter(format);
                recordBundleFileInternalSectionEnd(previousSourceFileTextKind);
                var separatingLineTerminatorCount = getSeparatingLineTerminatorCount(previousSibling, child, format);
                if (separatingLineTerminatorCount > 0) {
                  if ((format & (3 | 128)) === 0) {
                    increaseIndent();
                    shouldDecreaseIndentAfterEmit = true;
                  }
                  writeLine(separatingLineTerminatorCount);
                  shouldEmitInterveningComments = false;
                } else if (previousSibling && format & 512) {
                  writeSpace();
                }
              }
              previousSourceFileTextKind = recordBundleFileInternalSectionStart(child);
              if (shouldEmitInterveningComments) {
                if (emitTrailingCommentsOfPosition) {
                  var commentRange = ts3.getCommentRange(child);
                  emitTrailingCommentsOfPosition(commentRange.pos);
                }
              } else {
                shouldEmitInterveningComments = mayEmitInterveningComments;
              }
              nextListElementPos = child.pos;
              if (emit2.length === 1) {
                emit2(child);
              } else {
                emit2(child, parenthesizerRule);
              }
              if (shouldDecreaseIndentAfterEmit) {
                decreaseIndent();
                shouldDecreaseIndentAfterEmit = false;
              }
              previousSibling = child;
            }
            var emitFlags = previousSibling ? ts3.getEmitFlags(previousSibling) : 0;
            var skipTrailingComments = commentsDisabled || !!(emitFlags & 1024);
            var hasTrailingComma = (children === null || children === void 0 ? void 0 : children.hasTrailingComma) && format & 64 && format & 16;
            if (hasTrailingComma) {
              if (previousSibling && !skipTrailingComments) {
                emitTokenWithComment(27, previousSibling.end, writePunctuation, previousSibling);
              } else {
                writePunctuation(",");
              }
            }
            if (previousSibling && (parentNode ? parentNode.end : -1) !== previousSibling.end && format & 60 && !skipTrailingComments) {
              emitLeadingCommentsOfPosition(hasTrailingComma && (children === null || children === void 0 ? void 0 : children.end) ? children.end : previousSibling.end);
            }
            if (format & 128) {
              decreaseIndent();
            }
            recordBundleFileInternalSectionEnd(previousSourceFileTextKind);
            var closingLineTerminatorCount = getClosingLineTerminatorCount(parentNode, children, format);
            if (closingLineTerminatorCount) {
              writeLine(closingLineTerminatorCount);
            } else if (format & (2097152 | 256)) {
              writeSpace();
            }
          }
          if (onAfterEmitNodeArray) {
            onAfterEmitNodeArray(children);
          }
          if (format & 15360) {
            if (isEmpty && children) {
              emitLeadingCommentsOfPosition(children.end);
            }
            writePunctuation(getClosingBracket(format));
          }
        }
        function writeLiteral(s2) {
          writer.writeLiteral(s2);
        }
        function writeStringLiteral(s2) {
          writer.writeStringLiteral(s2);
        }
        function writeBase(s2) {
          writer.write(s2);
        }
        function writeSymbol(s2, sym) {
          writer.writeSymbol(s2, sym);
        }
        function writePunctuation(s2) {
          writer.writePunctuation(s2);
        }
        function writeTrailingSemicolon() {
          writer.writeTrailingSemicolon(";");
        }
        function writeKeyword(s2) {
          writer.writeKeyword(s2);
        }
        function writeOperator(s2) {
          writer.writeOperator(s2);
        }
        function writeParameter(s2) {
          writer.writeParameter(s2);
        }
        function writeComment(s2) {
          writer.writeComment(s2);
        }
        function writeSpace() {
          writer.writeSpace(" ");
        }
        function writeProperty(s2) {
          writer.writeProperty(s2);
        }
        function writeLine(count) {
          if (count === void 0) {
            count = 1;
          }
          for (var i3 = 0; i3 < count; i3++) {
            writer.writeLine(i3 > 0);
          }
        }
        function increaseIndent() {
          writer.increaseIndent();
        }
        function decreaseIndent() {
          writer.decreaseIndent();
        }
        function writeToken(token, pos, writer2, contextNode) {
          return !sourceMapsDisabled ? emitTokenWithSourceMap(contextNode, token, writer2, pos, writeTokenText) : writeTokenText(token, writer2, pos);
        }
        function writeTokenNode(node, writer2) {
          if (onBeforeEmitToken) {
            onBeforeEmitToken(node);
          }
          writer2(ts3.tokenToString(node.kind));
          if (onAfterEmitToken) {
            onAfterEmitToken(node);
          }
        }
        function writeTokenText(token, writer2, pos) {
          var tokenString = ts3.tokenToString(token);
          writer2(tokenString);
          return pos < 0 ? pos : pos + tokenString.length;
        }
        function writeLineOrSpace(parentNode, prevChildNode, nextChildNode) {
          if (ts3.getEmitFlags(parentNode) & 1) {
            writeSpace();
          } else if (preserveSourceNewlines) {
            var lines = getLinesBetweenNodes(parentNode, prevChildNode, nextChildNode);
            if (lines) {
              writeLine(lines);
            } else {
              writeSpace();
            }
          } else {
            writeLine();
          }
        }
        function writeLines(text) {
          var lines = text.split(/\r\n?|\n/g);
          var indentation = ts3.guessIndentation(lines);
          for (var _a3 = 0, lines_3 = lines; _a3 < lines_3.length; _a3++) {
            var lineText = lines_3[_a3];
            var line = indentation ? lineText.slice(indentation) : lineText;
            if (line.length) {
              writeLine();
              write(line);
            }
          }
        }
        function writeLinesAndIndent(lineCount, writeSpaceIfNotIndenting) {
          if (lineCount) {
            increaseIndent();
            writeLine(lineCount);
          } else if (writeSpaceIfNotIndenting) {
            writeSpace();
          }
        }
        function decreaseIndentIf(value1, value2) {
          if (value1) {
            decreaseIndent();
          }
          if (value2) {
            decreaseIndent();
          }
        }
        function getLeadingLineTerminatorCount(parentNode, children, format) {
          if (format & 2 || preserveSourceNewlines) {
            if (format & 65536) {
              return 1;
            }
            var firstChild_1 = children[0];
            if (firstChild_1 === void 0) {
              return !parentNode || ts3.rangeIsOnSingleLine(parentNode, currentSourceFile) ? 0 : 1;
            }
            if (firstChild_1.pos === nextListElementPos) {
              return 0;
            }
            if (firstChild_1.kind === 11) {
              return 0;
            }
            if (parentNode && !ts3.positionIsSynthesized(parentNode.pos) && !ts3.nodeIsSynthesized(firstChild_1) && (!firstChild_1.parent || ts3.getOriginalNode(firstChild_1.parent) === ts3.getOriginalNode(parentNode))) {
              if (preserveSourceNewlines) {
                return getEffectiveLines(function(includeComments) {
                  return ts3.getLinesBetweenPositionAndPrecedingNonWhitespaceCharacter(firstChild_1.pos, parentNode.pos, currentSourceFile, includeComments);
                });
              }
              return ts3.rangeStartPositionsAreOnSameLine(parentNode, firstChild_1, currentSourceFile) ? 0 : 1;
            }
            if (synthesizedNodeStartsOnNewLine(firstChild_1, format)) {
              return 1;
            }
          }
          return format & 1 ? 1 : 0;
        }
        function getSeparatingLineTerminatorCount(previousNode, nextNode, format) {
          if (format & 2 || preserveSourceNewlines) {
            if (previousNode === void 0 || nextNode === void 0) {
              return 0;
            }
            if (nextNode.kind === 11) {
              return 0;
            } else if (!ts3.nodeIsSynthesized(previousNode) && !ts3.nodeIsSynthesized(nextNode)) {
              if (preserveSourceNewlines && siblingNodePositionsAreComparable(previousNode, nextNode)) {
                return getEffectiveLines(function(includeComments) {
                  return ts3.getLinesBetweenRangeEndAndRangeStart(previousNode, nextNode, currentSourceFile, includeComments);
                });
              } else if (!preserveSourceNewlines && originalNodesHaveSameParent(previousNode, nextNode)) {
                return ts3.rangeEndIsOnSameLineAsRangeStart(previousNode, nextNode, currentSourceFile) ? 0 : 1;
              }
              return format & 65536 ? 1 : 0;
            } else if (synthesizedNodeStartsOnNewLine(previousNode, format) || synthesizedNodeStartsOnNewLine(nextNode, format)) {
              return 1;
            }
          } else if (ts3.getStartsOnNewLine(nextNode)) {
            return 1;
          }
          return format & 1 ? 1 : 0;
        }
        function getClosingLineTerminatorCount(parentNode, children, format) {
          if (format & 2 || preserveSourceNewlines) {
            if (format & 65536) {
              return 1;
            }
            var lastChild = ts3.lastOrUndefined(children);
            if (lastChild === void 0) {
              return !parentNode || ts3.rangeIsOnSingleLine(parentNode, currentSourceFile) ? 0 : 1;
            }
            if (parentNode && !ts3.positionIsSynthesized(parentNode.pos) && !ts3.nodeIsSynthesized(lastChild) && (!lastChild.parent || lastChild.parent === parentNode)) {
              if (preserveSourceNewlines) {
                var end_1 = ts3.isNodeArray(children) && !ts3.positionIsSynthesized(children.end) ? children.end : lastChild.end;
                return getEffectiveLines(function(includeComments) {
                  return ts3.getLinesBetweenPositionAndNextNonWhitespaceCharacter(end_1, parentNode.end, currentSourceFile, includeComments);
                });
              }
              return ts3.rangeEndPositionsAreOnSameLine(parentNode, lastChild, currentSourceFile) ? 0 : 1;
            }
            if (synthesizedNodeStartsOnNewLine(lastChild, format)) {
              return 1;
            }
          }
          if (format & 1 && !(format & 131072)) {
            return 1;
          }
          return 0;
        }
        function getEffectiveLines(getLineDifference) {
          ts3.Debug.assert(!!preserveSourceNewlines);
          var lines = getLineDifference(true);
          if (lines === 0) {
            return getLineDifference(false);
          }
          return lines;
        }
        function writeLineSeparatorsAndIndentBefore(node, parent) {
          var leadingNewlines = preserveSourceNewlines && getLeadingLineTerminatorCount(parent, [node], 0);
          if (leadingNewlines) {
            writeLinesAndIndent(leadingNewlines, false);
          }
          return !!leadingNewlines;
        }
        function writeLineSeparatorsAfter(node, parent) {
          var trailingNewlines = preserveSourceNewlines && getClosingLineTerminatorCount(parent, [node], 0);
          if (trailingNewlines) {
            writeLine(trailingNewlines);
          }
        }
        function synthesizedNodeStartsOnNewLine(node, format) {
          if (ts3.nodeIsSynthesized(node)) {
            var startsOnNewLine = ts3.getStartsOnNewLine(node);
            if (startsOnNewLine === void 0) {
              return (format & 65536) !== 0;
            }
            return startsOnNewLine;
          }
          return (format & 65536) !== 0;
        }
        function getLinesBetweenNodes(parent, node1, node2) {
          if (ts3.getEmitFlags(parent) & 131072) {
            return 0;
          }
          parent = skipSynthesizedParentheses(parent);
          node1 = skipSynthesizedParentheses(node1);
          node2 = skipSynthesizedParentheses(node2);
          if (ts3.getStartsOnNewLine(node2)) {
            return 1;
          }
          if (!ts3.nodeIsSynthesized(parent) && !ts3.nodeIsSynthesized(node1) && !ts3.nodeIsSynthesized(node2)) {
            if (preserveSourceNewlines) {
              return getEffectiveLines(function(includeComments) {
                return ts3.getLinesBetweenRangeEndAndRangeStart(node1, node2, currentSourceFile, includeComments);
              });
            }
            return ts3.rangeEndIsOnSameLineAsRangeStart(node1, node2, currentSourceFile) ? 0 : 1;
          }
          return 0;
        }
        function isEmptyBlock(block) {
          return block.statements.length === 0 && ts3.rangeEndIsOnSameLineAsRangeStart(block, block, currentSourceFile);
        }
        function skipSynthesizedParentheses(node) {
          while (node.kind === 208 && ts3.nodeIsSynthesized(node)) {
            node = node.expression;
          }
          return node;
        }
        function getTextOfNode(node, includeTrivia) {
          if (ts3.isGeneratedIdentifier(node)) {
            return generateName(node);
          } else if ((ts3.isIdentifier(node) || ts3.isPrivateIdentifier(node)) && (ts3.nodeIsSynthesized(node) || !node.parent || !currentSourceFile || node.parent && currentSourceFile && ts3.getSourceFileOfNode(node) !== ts3.getOriginalNode(currentSourceFile))) {
            return ts3.idText(node);
          } else if (node.kind === 10 && node.textSourceNode) {
            return getTextOfNode(node.textSourceNode, includeTrivia);
          } else if (ts3.isLiteralExpression(node) && (ts3.nodeIsSynthesized(node) || !node.parent)) {
            return node.text;
          }
          return ts3.getSourceTextOfNodeFromSourceFile(currentSourceFile, node, includeTrivia);
        }
        function getLiteralTextOfNode(node, neverAsciiEscape, jsxAttributeEscape) {
          if (node.kind === 10 && node.textSourceNode) {
            var textSourceNode = node.textSourceNode;
            if (ts3.isIdentifier(textSourceNode) || ts3.isNumericLiteral(textSourceNode)) {
              var text = ts3.isNumericLiteral(textSourceNode) ? textSourceNode.text : getTextOfNode(textSourceNode);
              return jsxAttributeEscape ? '"' + ts3.escapeJsxAttributeString(text) + '"' : neverAsciiEscape || ts3.getEmitFlags(node) & 16777216 ? '"' + ts3.escapeString(text) + '"' : '"' + ts3.escapeNonAsciiString(text) + '"';
            } else {
              return getLiteralTextOfNode(textSourceNode, neverAsciiEscape, jsxAttributeEscape);
            }
          }
          var flags = (neverAsciiEscape ? 1 : 0) | (jsxAttributeEscape ? 2 : 0) | (printerOptions.terminateUnterminatedLiterals ? 4 : 0) | (printerOptions.target && printerOptions.target === 99 ? 8 : 0);
          return ts3.getLiteralText(node, currentSourceFile, flags);
        }
        function pushNameGenerationScope(node) {
          if (node && ts3.getEmitFlags(node) & 524288) {
            return;
          }
          tempFlagsStack.push(tempFlags);
          tempFlags = 0;
          reservedNamesStack.push(reservedNames);
        }
        function popNameGenerationScope(node) {
          if (node && ts3.getEmitFlags(node) & 524288) {
            return;
          }
          tempFlags = tempFlagsStack.pop();
          reservedNames = reservedNamesStack.pop();
        }
        function reserveNameInNestedScopes(name) {
          if (!reservedNames || reservedNames === ts3.lastOrUndefined(reservedNamesStack)) {
            reservedNames = new ts3.Set();
          }
          reservedNames.add(name);
        }
        function generateNames(node) {
          if (!node)
            return;
          switch (node.kind) {
            case 231:
              ts3.forEach(node.statements, generateNames);
              break;
            case 246:
            case 244:
            case 236:
            case 237:
              generateNames(node.statement);
              break;
            case 235:
              generateNames(node.thenStatement);
              generateNames(node.elseStatement);
              break;
            case 238:
            case 240:
            case 239:
              generateNames(node.initializer);
              generateNames(node.statement);
              break;
            case 245:
              generateNames(node.caseBlock);
              break;
            case 259:
              ts3.forEach(node.clauses, generateNames);
              break;
            case 285:
            case 286:
              ts3.forEach(node.statements, generateNames);
              break;
            case 248:
              generateNames(node.tryBlock);
              generateNames(node.catchClause);
              generateNames(node.finallyBlock);
              break;
            case 288:
              generateNames(node.variableDeclaration);
              generateNames(node.block);
              break;
            case 233:
              generateNames(node.declarationList);
              break;
            case 251:
              ts3.forEach(node.declarations, generateNames);
              break;
            case 250:
            case 161:
            case 199:
            case 253:
              generateNameIfNeeded(node.name);
              break;
            case 252:
              generateNameIfNeeded(node.name);
              if (ts3.getEmitFlags(node) & 524288) {
                ts3.forEach(node.parameters, generateNames);
                generateNames(node.body);
              }
              break;
            case 197:
            case 198:
              ts3.forEach(node.elements, generateNames);
              break;
            case 262:
              generateNames(node.importClause);
              break;
            case 263:
              generateNameIfNeeded(node.name);
              generateNames(node.namedBindings);
              break;
            case 264:
              generateNameIfNeeded(node.name);
              break;
            case 270:
              generateNameIfNeeded(node.name);
              break;
            case 265:
              ts3.forEach(node.elements, generateNames);
              break;
            case 266:
              generateNameIfNeeded(node.propertyName || node.name);
              break;
          }
        }
        function generateMemberNames(node) {
          if (!node)
            return;
          switch (node.kind) {
            case 289:
            case 290:
            case 164:
            case 166:
            case 168:
            case 169:
              generateNameIfNeeded(node.name);
              break;
          }
        }
        function generateNameIfNeeded(name) {
          if (name) {
            if (ts3.isGeneratedIdentifier(name)) {
              generateName(name);
            } else if (ts3.isBindingPattern(name)) {
              generateNames(name);
            }
          }
        }
        function generateName(name) {
          if ((name.autoGenerateFlags & 7) === 4) {
            return generateNameCached(getNodeForGeneratedName(name), name.autoGenerateFlags);
          } else {
            var autoGenerateId = name.autoGenerateId;
            return autoGeneratedIdToGeneratedName[autoGenerateId] || (autoGeneratedIdToGeneratedName[autoGenerateId] = makeName(name));
          }
        }
        function generateNameCached(node, flags) {
          var nodeId = ts3.getNodeId(node);
          return nodeIdToGeneratedName[nodeId] || (nodeIdToGeneratedName[nodeId] = generateNameForNode(node, flags));
        }
        function isUniqueName(name) {
          return isFileLevelUniqueName(name) && !generatedNames.has(name) && !(reservedNames && reservedNames.has(name));
        }
        function isFileLevelUniqueName(name) {
          return currentSourceFile ? ts3.isFileLevelUniqueName(currentSourceFile, name, hasGlobalName) : true;
        }
        function isUniqueLocalName(name, container) {
          for (var node = container; ts3.isNodeDescendantOf(node, container); node = node.nextContainer) {
            if (node.locals) {
              var local = node.locals.get(ts3.escapeLeadingUnderscores(name));
              if (local && local.flags & (111551 | 1048576 | 2097152)) {
                return false;
              }
            }
          }
          return true;
        }
        function makeTempVariableName(flags, reservedInNestedScopes) {
          if (flags && !(tempFlags & flags)) {
            var name = flags === 268435456 ? "_i" : "_n";
            if (isUniqueName(name)) {
              tempFlags |= flags;
              if (reservedInNestedScopes) {
                reserveNameInNestedScopes(name);
              }
              return name;
            }
          }
          while (true) {
            var count = tempFlags & 268435455;
            tempFlags++;
            if (count !== 8 && count !== 13) {
              var name = count < 26 ? "_" + String.fromCharCode(97 + count) : "_" + (count - 26);
              if (isUniqueName(name)) {
                if (reservedInNestedScopes) {
                  reserveNameInNestedScopes(name);
                }
                return name;
              }
            }
          }
        }
        function makeUniqueName(baseName, checkFn, optimistic, scoped) {
          if (checkFn === void 0) {
            checkFn = isUniqueName;
          }
          if (optimistic) {
            if (checkFn(baseName)) {
              if (scoped) {
                reserveNameInNestedScopes(baseName);
              } else {
                generatedNames.add(baseName);
              }
              return baseName;
            }
          }
          if (baseName.charCodeAt(baseName.length - 1) !== 95) {
            baseName += "_";
          }
          var i3 = 1;
          while (true) {
            var generatedName = baseName + i3;
            if (checkFn(generatedName)) {
              if (scoped) {
                reserveNameInNestedScopes(generatedName);
              } else {
                generatedNames.add(generatedName);
              }
              return generatedName;
            }
            i3++;
          }
        }
        function makeFileLevelOptimisticUniqueName(name) {
          return makeUniqueName(name, isFileLevelUniqueName, true);
        }
        function generateNameForModuleOrEnum(node) {
          var name = getTextOfNode(node.name);
          return isUniqueLocalName(name, node) ? name : makeUniqueName(name);
        }
        function generateNameForImportOrExportDeclaration(node) {
          var expr = ts3.getExternalModuleName(node);
          var baseName = ts3.isStringLiteral(expr) ? ts3.makeIdentifierFromModuleName(expr.text) : "module";
          return makeUniqueName(baseName);
        }
        function generateNameForExportDefault() {
          return makeUniqueName("default");
        }
        function generateNameForClassExpression() {
          return makeUniqueName("class");
        }
        function generateNameForMethodOrAccessor(node) {
          if (ts3.isIdentifier(node.name)) {
            return generateNameCached(node.name);
          }
          return makeTempVariableName(0);
        }
        function generateNameForNode(node, flags) {
          switch (node.kind) {
            case 78:
              return makeUniqueName(getTextOfNode(node), isUniqueName, !!(flags & 16), !!(flags & 8));
            case 257:
            case 256:
              return generateNameForModuleOrEnum(node);
            case 262:
            case 268:
              return generateNameForImportOrExportDeclaration(node);
            case 252:
            case 253:
            case 267:
              return generateNameForExportDefault();
            case 222:
              return generateNameForClassExpression();
            case 166:
            case 168:
            case 169:
              return generateNameForMethodOrAccessor(node);
            case 159:
              return makeTempVariableName(0, true);
            default:
              return makeTempVariableName(0);
          }
        }
        function makeName(name) {
          switch (name.autoGenerateFlags & 7) {
            case 1:
              return makeTempVariableName(0, !!(name.autoGenerateFlags & 8));
            case 2:
              return makeTempVariableName(268435456, !!(name.autoGenerateFlags & 8));
            case 3:
              return makeUniqueName(ts3.idText(name), name.autoGenerateFlags & 32 ? isFileLevelUniqueName : isUniqueName, !!(name.autoGenerateFlags & 16), !!(name.autoGenerateFlags & 8));
          }
          return ts3.Debug.fail("Unsupported GeneratedIdentifierKind.");
        }
        function getNodeForGeneratedName(name) {
          var autoGenerateId = name.autoGenerateId;
          var node = name;
          var original = node.original;
          while (original) {
            node = original;
            if (ts3.isIdentifier(node) && !!(node.autoGenerateFlags & 4) && node.autoGenerateId !== autoGenerateId) {
              break;
            }
            original = node.original;
          }
          return node;
        }
        function pipelineEmitWithComments(hint, node) {
          var pipelinePhase = getNextPipelinePhase(2, hint, node);
          var savedContainerPos = containerPos;
          var savedContainerEnd = containerEnd;
          var savedDeclarationListContainerEnd = declarationListContainerEnd;
          emitCommentsBeforeNode(node);
          pipelinePhase(hint, node);
          emitCommentsAfterNode(node, savedContainerPos, savedContainerEnd, savedDeclarationListContainerEnd);
        }
        function emitCommentsBeforeNode(node) {
          var emitFlags = ts3.getEmitFlags(node);
          var commentRange = ts3.getCommentRange(node);
          emitLeadingCommentsOfNode(node, emitFlags, commentRange.pos, commentRange.end);
          if (emitFlags & 2048) {
            commentsDisabled = true;
          }
        }
        function emitCommentsAfterNode(node, savedContainerPos, savedContainerEnd, savedDeclarationListContainerEnd) {
          var emitFlags = ts3.getEmitFlags(node);
          var commentRange = ts3.getCommentRange(node);
          if (emitFlags & 2048) {
            commentsDisabled = false;
          }
          emitTrailingCommentsOfNode(node, emitFlags, commentRange.pos, commentRange.end, savedContainerPos, savedContainerEnd, savedDeclarationListContainerEnd);
        }
        function emitLeadingCommentsOfNode(node, emitFlags, pos, end) {
          enterComment();
          hasWrittenComment = false;
          var skipLeadingComments = pos < 0 || (emitFlags & 512) !== 0 || node.kind === 11;
          var skipTrailingComments = end < 0 || (emitFlags & 1024) !== 0 || node.kind === 11;
          if ((pos > 0 || end > 0) && pos !== end) {
            if (!skipLeadingComments) {
              emitLeadingComments(pos, node.kind !== 339);
            }
            if (!skipLeadingComments || pos >= 0 && (emitFlags & 512) !== 0) {
              containerPos = pos;
            }
            if (!skipTrailingComments || end >= 0 && (emitFlags & 1024) !== 0) {
              containerEnd = end;
              if (node.kind === 251) {
                declarationListContainerEnd = end;
              }
            }
          }
          ts3.forEach(ts3.getSyntheticLeadingComments(node), emitLeadingSynthesizedComment);
          exitComment();
        }
        function emitTrailingCommentsOfNode(node, emitFlags, pos, end, savedContainerPos, savedContainerEnd, savedDeclarationListContainerEnd) {
          enterComment();
          var skipTrailingComments = end < 0 || (emitFlags & 1024) !== 0 || node.kind === 11;
          ts3.forEach(ts3.getSyntheticTrailingComments(node), emitTrailingSynthesizedComment);
          if ((pos > 0 || end > 0) && pos !== end) {
            containerPos = savedContainerPos;
            containerEnd = savedContainerEnd;
            declarationListContainerEnd = savedDeclarationListContainerEnd;
            if (!skipTrailingComments && node.kind !== 339) {
              emitTrailingComments(end);
            }
          }
          exitComment();
        }
        function emitLeadingSynthesizedComment(comment) {
          if (comment.hasLeadingNewline || comment.kind === 2) {
            writer.writeLine();
          }
          writeSynthesizedComment(comment);
          if (comment.hasTrailingNewLine || comment.kind === 2) {
            writer.writeLine();
          } else {
            writer.writeSpace(" ");
          }
        }
        function emitTrailingSynthesizedComment(comment) {
          if (!writer.isAtStartOfLine()) {
            writer.writeSpace(" ");
          }
          writeSynthesizedComment(comment);
          if (comment.hasTrailingNewLine) {
            writer.writeLine();
          }
        }
        function writeSynthesizedComment(comment) {
          var text = formatSynthesizedComment(comment);
          var lineMap = comment.kind === 3 ? ts3.computeLineStarts(text) : void 0;
          ts3.writeCommentRange(text, lineMap, writer, 0, text.length, newLine);
        }
        function formatSynthesizedComment(comment) {
          return comment.kind === 3 ? "/*" + comment.text + "*/" : "//" + comment.text;
        }
        function emitBodyWithDetachedComments(node, detachedRange, emitCallback) {
          enterComment();
          var pos = detachedRange.pos, end = detachedRange.end;
          var emitFlags = ts3.getEmitFlags(node);
          var skipLeadingComments = pos < 0 || (emitFlags & 512) !== 0;
          var skipTrailingComments = commentsDisabled || end < 0 || (emitFlags & 1024) !== 0;
          if (!skipLeadingComments) {
            emitDetachedCommentsAndUpdateCommentsInfo(detachedRange);
          }
          exitComment();
          if (emitFlags & 2048 && !commentsDisabled) {
            commentsDisabled = true;
            emitCallback(node);
            commentsDisabled = false;
          } else {
            emitCallback(node);
          }
          enterComment();
          if (!skipTrailingComments) {
            emitLeadingComments(detachedRange.end, true);
            if (hasWrittenComment && !writer.isAtStartOfLine()) {
              writer.writeLine();
            }
          }
          exitComment();
        }
        function originalNodesHaveSameParent(nodeA, nodeB) {
          nodeA = ts3.getOriginalNode(nodeA);
          return nodeA.parent && nodeA.parent === ts3.getOriginalNode(nodeB).parent;
        }
        function siblingNodePositionsAreComparable(previousNode, nextNode) {
          if (nextNode.pos < previousNode.end) {
            return false;
          }
          previousNode = ts3.getOriginalNode(previousNode);
          nextNode = ts3.getOriginalNode(nextNode);
          var parent = previousNode.parent;
          if (!parent || parent !== nextNode.parent) {
            return false;
          }
          var parentNodeArray = ts3.getContainingNodeArray(previousNode);
          var prevNodeIndex = parentNodeArray === null || parentNodeArray === void 0 ? void 0 : parentNodeArray.indexOf(previousNode);
          return prevNodeIndex !== void 0 && prevNodeIndex > -1 && parentNodeArray.indexOf(nextNode) === prevNodeIndex + 1;
        }
        function emitLeadingComments(pos, isEmittedNode) {
          hasWrittenComment = false;
          if (isEmittedNode) {
            if (pos === 0 && (currentSourceFile === null || currentSourceFile === void 0 ? void 0 : currentSourceFile.isDeclarationFile)) {
              forEachLeadingCommentToEmit(pos, emitNonTripleSlashLeadingComment);
            } else {
              forEachLeadingCommentToEmit(pos, emitLeadingComment);
            }
          } else if (pos === 0) {
            forEachLeadingCommentToEmit(pos, emitTripleSlashLeadingComment);
          }
        }
        function emitTripleSlashLeadingComment(commentPos, commentEnd, kind, hasTrailingNewLine, rangePos) {
          if (isTripleSlashComment(commentPos, commentEnd)) {
            emitLeadingComment(commentPos, commentEnd, kind, hasTrailingNewLine, rangePos);
          }
        }
        function emitNonTripleSlashLeadingComment(commentPos, commentEnd, kind, hasTrailingNewLine, rangePos) {
          if (!isTripleSlashComment(commentPos, commentEnd)) {
            emitLeadingComment(commentPos, commentEnd, kind, hasTrailingNewLine, rangePos);
          }
        }
        function shouldWriteComment(text, pos) {
          if (printerOptions.onlyPrintJsDocStyle) {
            return ts3.isJSDocLikeText(text, pos) || ts3.isPinnedComment(text, pos);
          }
          return true;
        }
        function emitLeadingComment(commentPos, commentEnd, kind, hasTrailingNewLine, rangePos) {
          if (!shouldWriteComment(currentSourceFile.text, commentPos))
            return;
          if (!hasWrittenComment) {
            ts3.emitNewLineBeforeLeadingCommentOfPosition(getCurrentLineMap(), writer, rangePos, commentPos);
            hasWrittenComment = true;
          }
          emitPos(commentPos);
          ts3.writeCommentRange(currentSourceFile.text, getCurrentLineMap(), writer, commentPos, commentEnd, newLine);
          emitPos(commentEnd);
          if (hasTrailingNewLine) {
            writer.writeLine();
          } else if (kind === 3) {
            writer.writeSpace(" ");
          }
        }
        function emitLeadingCommentsOfPosition(pos) {
          if (commentsDisabled || pos === -1) {
            return;
          }
          emitLeadingComments(pos, true);
        }
        function emitTrailingComments(pos) {
          forEachTrailingCommentToEmit(pos, emitTrailingComment);
        }
        function emitTrailingComment(commentPos, commentEnd, _kind, hasTrailingNewLine) {
          if (!shouldWriteComment(currentSourceFile.text, commentPos))
            return;
          if (!writer.isAtStartOfLine()) {
            writer.writeSpace(" ");
          }
          emitPos(commentPos);
          ts3.writeCommentRange(currentSourceFile.text, getCurrentLineMap(), writer, commentPos, commentEnd, newLine);
          emitPos(commentEnd);
          if (hasTrailingNewLine) {
            writer.writeLine();
          }
        }
        function emitTrailingCommentsOfPosition(pos, prefixSpace, forceNoNewline) {
          if (commentsDisabled) {
            return;
          }
          enterComment();
          forEachTrailingCommentToEmit(pos, prefixSpace ? emitTrailingComment : forceNoNewline ? emitTrailingCommentOfPositionNoNewline : emitTrailingCommentOfPosition);
          exitComment();
        }
        function emitTrailingCommentOfPositionNoNewline(commentPos, commentEnd, kind) {
          emitPos(commentPos);
          ts3.writeCommentRange(currentSourceFile.text, getCurrentLineMap(), writer, commentPos, commentEnd, newLine);
          emitPos(commentEnd);
          if (kind === 2) {
            writer.writeLine();
          }
        }
        function emitTrailingCommentOfPosition(commentPos, commentEnd, _kind, hasTrailingNewLine) {
          emitPos(commentPos);
          ts3.writeCommentRange(currentSourceFile.text, getCurrentLineMap(), writer, commentPos, commentEnd, newLine);
          emitPos(commentEnd);
          if (hasTrailingNewLine) {
            writer.writeLine();
          } else {
            writer.writeSpace(" ");
          }
        }
        function forEachLeadingCommentToEmit(pos, cb2) {
          if (currentSourceFile && (containerPos === -1 || pos !== containerPos)) {
            if (hasDetachedComments(pos)) {
              forEachLeadingCommentWithoutDetachedComments(cb2);
            } else {
              ts3.forEachLeadingCommentRange(currentSourceFile.text, pos, cb2, pos);
            }
          }
        }
        function forEachTrailingCommentToEmit(end, cb2) {
          if (currentSourceFile && (containerEnd === -1 || end !== containerEnd && end !== declarationListContainerEnd)) {
            ts3.forEachTrailingCommentRange(currentSourceFile.text, end, cb2);
          }
        }
        function hasDetachedComments(pos) {
          return detachedCommentsInfo !== void 0 && ts3.last(detachedCommentsInfo).nodePos === pos;
        }
        function forEachLeadingCommentWithoutDetachedComments(cb2) {
          var pos = ts3.last(detachedCommentsInfo).detachedCommentEndPos;
          if (detachedCommentsInfo.length - 1) {
            detachedCommentsInfo.pop();
          } else {
            detachedCommentsInfo = void 0;
          }
          ts3.forEachLeadingCommentRange(currentSourceFile.text, pos, cb2, pos);
        }
        function emitDetachedCommentsAndUpdateCommentsInfo(range) {
          var currentDetachedCommentInfo = ts3.emitDetachedComments(currentSourceFile.text, getCurrentLineMap(), writer, emitComment, range, newLine, commentsDisabled);
          if (currentDetachedCommentInfo) {
            if (detachedCommentsInfo) {
              detachedCommentsInfo.push(currentDetachedCommentInfo);
            } else {
              detachedCommentsInfo = [currentDetachedCommentInfo];
            }
          }
        }
        function emitComment(text, lineMap, writer2, commentPos, commentEnd, newLine2) {
          if (!shouldWriteComment(currentSourceFile.text, commentPos))
            return;
          emitPos(commentPos);
          ts3.writeCommentRange(text, lineMap, writer2, commentPos, commentEnd, newLine2);
          emitPos(commentEnd);
        }
        function isTripleSlashComment(commentPos, commentEnd) {
          return ts3.isRecognizedTripleSlashComment(currentSourceFile.text, commentPos, commentEnd);
        }
        function getParsedSourceMap(node) {
          if (node.parsedSourceMap === void 0 && node.sourceMapText !== void 0) {
            node.parsedSourceMap = ts3.tryParseRawSourceMap(node.sourceMapText) || false;
          }
          return node.parsedSourceMap || void 0;
        }
        function pipelineEmitWithSourceMaps(hint, node) {
          var pipelinePhase = getNextPipelinePhase(3, hint, node);
          emitSourceMapsBeforeNode(node);
          pipelinePhase(hint, node);
          emitSourceMapsAfterNode(node);
        }
        function emitSourceMapsBeforeNode(node) {
          var emitFlags = ts3.getEmitFlags(node);
          var sourceMapRange = ts3.getSourceMapRange(node);
          if (ts3.isUnparsedNode(node)) {
            ts3.Debug.assertIsDefined(node.parent, "UnparsedNodes must have parent pointers");
            var parsed = getParsedSourceMap(node.parent);
            if (parsed && sourceMapGenerator) {
              sourceMapGenerator.appendSourceMap(writer.getLine(), writer.getColumn(), parsed, node.parent.sourceMapPath, node.parent.getLineAndCharacterOfPosition(node.pos), node.parent.getLineAndCharacterOfPosition(node.end));
            }
          } else {
            var source = sourceMapRange.source || sourceMapSource;
            if (node.kind !== 339 && (emitFlags & 16) === 0 && sourceMapRange.pos >= 0) {
              emitSourcePos(sourceMapRange.source || sourceMapSource, skipSourceTrivia(source, sourceMapRange.pos));
            }
            if (emitFlags & 64) {
              sourceMapsDisabled = true;
            }
          }
        }
        function emitSourceMapsAfterNode(node) {
          var emitFlags = ts3.getEmitFlags(node);
          var sourceMapRange = ts3.getSourceMapRange(node);
          if (!ts3.isUnparsedNode(node)) {
            if (emitFlags & 64) {
              sourceMapsDisabled = false;
            }
            if (node.kind !== 339 && (emitFlags & 32) === 0 && sourceMapRange.end >= 0) {
              emitSourcePos(sourceMapRange.source || sourceMapSource, sourceMapRange.end);
            }
          }
        }
        function skipSourceTrivia(source, pos) {
          return source.skipTrivia ? source.skipTrivia(pos) : ts3.skipTrivia(source.text, pos);
        }
        function emitPos(pos) {
          if (sourceMapsDisabled || ts3.positionIsSynthesized(pos) || isJsonSourceMapSource(sourceMapSource)) {
            return;
          }
          var _a3 = ts3.getLineAndCharacterOfPosition(sourceMapSource, pos), sourceLine = _a3.line, sourceCharacter = _a3.character;
          sourceMapGenerator.addMapping(writer.getLine(), writer.getColumn(), sourceMapSourceIndex, sourceLine, sourceCharacter, void 0);
        }
        function emitSourcePos(source, pos) {
          if (source !== sourceMapSource) {
            var savedSourceMapSource = sourceMapSource;
            var savedSourceMapSourceIndex = sourceMapSourceIndex;
            setSourceMapSource(source);
            emitPos(pos);
            resetSourceMapSource(savedSourceMapSource, savedSourceMapSourceIndex);
          } else {
            emitPos(pos);
          }
        }
        function emitTokenWithSourceMap(node, token, writer2, tokenPos, emitCallback) {
          if (sourceMapsDisabled || node && ts3.isInJsonFile(node)) {
            return emitCallback(token, writer2, tokenPos);
          }
          var emitNode = node && node.emitNode;
          var emitFlags = emitNode && emitNode.flags || 0;
          var range = emitNode && emitNode.tokenSourceMapRanges && emitNode.tokenSourceMapRanges[token];
          var source = range && range.source || sourceMapSource;
          tokenPos = skipSourceTrivia(source, range ? range.pos : tokenPos);
          if ((emitFlags & 128) === 0 && tokenPos >= 0) {
            emitSourcePos(source, tokenPos);
          }
          tokenPos = emitCallback(token, writer2, tokenPos);
          if (range)
            tokenPos = range.end;
          if ((emitFlags & 256) === 0 && tokenPos >= 0) {
            emitSourcePos(source, tokenPos);
          }
          return tokenPos;
        }
        function setSourceMapSource(source) {
          if (sourceMapsDisabled) {
            return;
          }
          sourceMapSource = source;
          if (source === mostRecentlyAddedSourceMapSource) {
            sourceMapSourceIndex = mostRecentlyAddedSourceMapSourceIndex;
            return;
          }
          if (isJsonSourceMapSource(source)) {
            return;
          }
          sourceMapSourceIndex = sourceMapGenerator.addSource(source.fileName);
          if (printerOptions.inlineSources) {
            sourceMapGenerator.setSourceContent(sourceMapSourceIndex, source.text);
          }
          mostRecentlyAddedSourceMapSource = source;
          mostRecentlyAddedSourceMapSourceIndex = sourceMapSourceIndex;
        }
        function resetSourceMapSource(source, sourceIndex) {
          sourceMapSource = source;
          sourceMapSourceIndex = sourceIndex;
        }
        function isJsonSourceMapSource(sourceFile) {
          return ts3.fileExtensionIs(sourceFile.fileName, ".json");
        }
      }
      ts3.createPrinter = createPrinter;
      function createBracketsMap() {
        var brackets2 = [];
        brackets2[1024] = ["{", "}"];
        brackets2[2048] = ["(", ")"];
        brackets2[4096] = ["<", ">"];
        brackets2[8192] = ["[", "]"];
        return brackets2;
      }
      function getOpeningBracket(format) {
        return brackets[format & 15360][0];
      }
      function getClosingBracket(format) {
        return brackets[format & 15360][1];
      }
      var TempFlags;
      (function(TempFlags2) {
        TempFlags2[TempFlags2["Auto"] = 0] = "Auto";
        TempFlags2[TempFlags2["CountMask"] = 268435455] = "CountMask";
        TempFlags2[TempFlags2["_i"] = 268435456] = "_i";
      })(TempFlags || (TempFlags = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      function createCachedDirectoryStructureHost(host, currentDirectory, useCaseSensitiveFileNames) {
        if (!host.getDirectories || !host.readDirectory) {
          return void 0;
        }
        var cachedReadDirectoryResult = new ts3.Map();
        var getCanonicalFileName = ts3.createGetCanonicalFileName(useCaseSensitiveFileNames);
        return {
          useCaseSensitiveFileNames,
          fileExists,
          readFile: function(path2, encoding) {
            return host.readFile(path2, encoding);
          },
          directoryExists: host.directoryExists && directoryExists,
          getDirectories,
          readDirectory,
          createDirectory: host.createDirectory && createDirectory,
          writeFile: host.writeFile && writeFile,
          addOrDeleteFileOrDirectory,
          addOrDeleteFile,
          clearCache,
          realpath: host.realpath && realpath
        };
        function toPath(fileName) {
          return ts3.toPath(fileName, currentDirectory, getCanonicalFileName);
        }
        function getCachedFileSystemEntries(rootDirPath) {
          return cachedReadDirectoryResult.get(ts3.ensureTrailingDirectorySeparator(rootDirPath));
        }
        function getCachedFileSystemEntriesForBaseDir(path2) {
          return getCachedFileSystemEntries(ts3.getDirectoryPath(path2));
        }
        function getBaseNameOfFileName(fileName) {
          return ts3.getBaseFileName(ts3.normalizePath(fileName));
        }
        function createCachedFileSystemEntries(rootDir, rootDirPath) {
          var _a2;
          if (!host.realpath || ts3.ensureTrailingDirectorySeparator(toPath(host.realpath(rootDir))) === rootDirPath) {
            var resultFromHost = {
              files: ts3.map(host.readDirectory(rootDir, void 0, void 0, ["*.*"]), getBaseNameOfFileName) || [],
              directories: host.getDirectories(rootDir) || []
            };
            cachedReadDirectoryResult.set(ts3.ensureTrailingDirectorySeparator(rootDirPath), resultFromHost);
            return resultFromHost;
          }
          if ((_a2 = host.directoryExists) === null || _a2 === void 0 ? void 0 : _a2.call(host, rootDir)) {
            cachedReadDirectoryResult.set(rootDirPath, false);
            return false;
          }
          return void 0;
        }
        function tryReadDirectory(rootDir, rootDirPath) {
          rootDirPath = ts3.ensureTrailingDirectorySeparator(rootDirPath);
          var cachedResult = getCachedFileSystemEntries(rootDirPath);
          if (cachedResult) {
            return cachedResult;
          }
          try {
            return createCachedFileSystemEntries(rootDir, rootDirPath);
          } catch (_e) {
            ts3.Debug.assert(!cachedReadDirectoryResult.has(ts3.ensureTrailingDirectorySeparator(rootDirPath)));
            return void 0;
          }
        }
        function fileNameEqual(name1, name2) {
          return getCanonicalFileName(name1) === getCanonicalFileName(name2);
        }
        function hasEntry(entries, name) {
          return ts3.some(entries, function(file) {
            return fileNameEqual(file, name);
          });
        }
        function updateFileSystemEntry(entries, baseName, isValid) {
          if (hasEntry(entries, baseName)) {
            if (!isValid) {
              return ts3.filterMutate(entries, function(entry) {
                return !fileNameEqual(entry, baseName);
              });
            }
          } else if (isValid) {
            return entries.push(baseName);
          }
        }
        function writeFile(fileName, data, writeByteOrderMark) {
          var path2 = toPath(fileName);
          var result2 = getCachedFileSystemEntriesForBaseDir(path2);
          if (result2) {
            updateFilesOfFileSystemEntry(result2, getBaseNameOfFileName(fileName), true);
          }
          return host.writeFile(fileName, data, writeByteOrderMark);
        }
        function fileExists(fileName) {
          var path2 = toPath(fileName);
          var result2 = getCachedFileSystemEntriesForBaseDir(path2);
          return result2 && hasEntry(result2.files, getBaseNameOfFileName(fileName)) || host.fileExists(fileName);
        }
        function directoryExists(dirPath) {
          var path2 = toPath(dirPath);
          return cachedReadDirectoryResult.has(ts3.ensureTrailingDirectorySeparator(path2)) || host.directoryExists(dirPath);
        }
        function createDirectory(dirPath) {
          var path2 = toPath(dirPath);
          var result2 = getCachedFileSystemEntriesForBaseDir(path2);
          var baseFileName = getBaseNameOfFileName(dirPath);
          if (result2) {
            updateFileSystemEntry(result2.directories, baseFileName, true);
          }
          host.createDirectory(dirPath);
        }
        function getDirectories(rootDir) {
          var rootDirPath = toPath(rootDir);
          var result2 = tryReadDirectory(rootDir, rootDirPath);
          if (result2) {
            return result2.directories.slice();
          }
          return host.getDirectories(rootDir);
        }
        function readDirectory(rootDir, extensions, excludes, includes, depth) {
          var rootDirPath = toPath(rootDir);
          var rootResult = tryReadDirectory(rootDir, rootDirPath);
          var rootSymLinkResult;
          if (rootResult !== void 0) {
            return ts3.matchFiles(rootDir, extensions, excludes, includes, useCaseSensitiveFileNames, currentDirectory, depth, getFileSystemEntries, realpath);
          }
          return host.readDirectory(rootDir, extensions, excludes, includes, depth);
          function getFileSystemEntries(dir) {
            var path2 = toPath(dir);
            if (path2 === rootDirPath) {
              return rootResult || getFileSystemEntriesFromHost(dir, path2);
            }
            var result2 = tryReadDirectory(dir, path2);
            return result2 !== void 0 ? result2 || getFileSystemEntriesFromHost(dir, path2) : ts3.emptyFileSystemEntries;
          }
          function getFileSystemEntriesFromHost(dir, path2) {
            if (rootSymLinkResult && path2 === rootDirPath)
              return rootSymLinkResult;
            var result2 = {
              files: ts3.map(host.readDirectory(dir, void 0, void 0, ["*.*"]), getBaseNameOfFileName) || ts3.emptyArray,
              directories: host.getDirectories(dir) || ts3.emptyArray
            };
            if (path2 === rootDirPath)
              rootSymLinkResult = result2;
            return result2;
          }
        }
        function realpath(s2) {
          return host.realpath ? host.realpath(s2) : s2;
        }
        function addOrDeleteFileOrDirectory(fileOrDirectory, fileOrDirectoryPath) {
          var existingResult = getCachedFileSystemEntries(fileOrDirectoryPath);
          if (existingResult !== void 0) {
            clearCache();
            return void 0;
          }
          var parentResult = getCachedFileSystemEntriesForBaseDir(fileOrDirectoryPath);
          if (!parentResult) {
            return void 0;
          }
          if (!host.directoryExists) {
            clearCache();
            return void 0;
          }
          var baseName = getBaseNameOfFileName(fileOrDirectory);
          var fsQueryResult = {
            fileExists: host.fileExists(fileOrDirectoryPath),
            directoryExists: host.directoryExists(fileOrDirectoryPath)
          };
          if (fsQueryResult.directoryExists || hasEntry(parentResult.directories, baseName)) {
            clearCache();
          } else {
            updateFilesOfFileSystemEntry(parentResult, baseName, fsQueryResult.fileExists);
          }
          return fsQueryResult;
        }
        function addOrDeleteFile(fileName, filePath, eventKind) {
          if (eventKind === ts3.FileWatcherEventKind.Changed) {
            return;
          }
          var parentResult = getCachedFileSystemEntriesForBaseDir(filePath);
          if (parentResult) {
            updateFilesOfFileSystemEntry(parentResult, getBaseNameOfFileName(fileName), eventKind === ts3.FileWatcherEventKind.Created);
          }
        }
        function updateFilesOfFileSystemEntry(parentResult, baseName, fileExists2) {
          updateFileSystemEntry(parentResult.files, baseName, fileExists2);
        }
        function clearCache() {
          cachedReadDirectoryResult.clear();
        }
      }
      ts3.createCachedDirectoryStructureHost = createCachedDirectoryStructureHost;
      var ConfigFileProgramReloadLevel;
      (function(ConfigFileProgramReloadLevel2) {
        ConfigFileProgramReloadLevel2[ConfigFileProgramReloadLevel2["None"] = 0] = "None";
        ConfigFileProgramReloadLevel2[ConfigFileProgramReloadLevel2["Partial"] = 1] = "Partial";
        ConfigFileProgramReloadLevel2[ConfigFileProgramReloadLevel2["Full"] = 2] = "Full";
      })(ConfigFileProgramReloadLevel = ts3.ConfigFileProgramReloadLevel || (ts3.ConfigFileProgramReloadLevel = {}));
      function updateSharedExtendedConfigFileWatcher(projectPath, options, extendedConfigFilesMap, createExtendedConfigFileWatch, toPath) {
        var _a2;
        var extendedConfigs = ts3.arrayToMap(((_a2 = options === null || options === void 0 ? void 0 : options.configFile) === null || _a2 === void 0 ? void 0 : _a2.extendedSourceFiles) || ts3.emptyArray, toPath);
        extendedConfigFilesMap.forEach(function(watcher, extendedConfigFilePath) {
          if (!extendedConfigs.has(extendedConfigFilePath)) {
            watcher.projects.delete(projectPath);
            watcher.close();
          }
        });
        extendedConfigs.forEach(function(extendedConfigFileName, extendedConfigFilePath) {
          var existing = extendedConfigFilesMap.get(extendedConfigFilePath);
          if (existing) {
            existing.projects.add(projectPath);
          } else {
            extendedConfigFilesMap.set(extendedConfigFilePath, {
              projects: new ts3.Set([projectPath]),
              watcher: createExtendedConfigFileWatch(extendedConfigFileName, extendedConfigFilePath),
              close: function() {
                var existing2 = extendedConfigFilesMap.get(extendedConfigFilePath);
                if (!existing2 || existing2.projects.size !== 0)
                  return;
                existing2.watcher.close();
                extendedConfigFilesMap.delete(extendedConfigFilePath);
              }
            });
          }
        });
      }
      ts3.updateSharedExtendedConfigFileWatcher = updateSharedExtendedConfigFileWatcher;
      function clearSharedExtendedConfigFileWatcher(projectPath, extendedConfigFilesMap) {
        extendedConfigFilesMap.forEach(function(watcher) {
          if (watcher.projects.delete(projectPath))
            watcher.close();
        });
      }
      ts3.clearSharedExtendedConfigFileWatcher = clearSharedExtendedConfigFileWatcher;
      function cleanExtendedConfigCache(extendedConfigCache, extendedConfigFilePath, toPath) {
        if (!extendedConfigCache.delete(extendedConfigFilePath))
          return;
        extendedConfigCache.forEach(function(_a2, key2) {
          var _b;
          var extendedResult = _a2.extendedResult;
          if ((_b = extendedResult.extendedSourceFiles) === null || _b === void 0 ? void 0 : _b.some(function(extendedFile) {
            return toPath(extendedFile) === extendedConfigFilePath;
          })) {
            cleanExtendedConfigCache(extendedConfigCache, key2, toPath);
          }
        });
      }
      ts3.cleanExtendedConfigCache = cleanExtendedConfigCache;
      function updateMissingFilePathsWatch(program2, missingFileWatches, createMissingFileWatch) {
        var missingFilePaths = program2.getMissingFilePaths();
        var newMissingFilePathMap = ts3.arrayToMap(missingFilePaths, ts3.identity, ts3.returnTrue);
        ts3.mutateMap(missingFileWatches, newMissingFilePathMap, {
          createNewValue: createMissingFileWatch,
          onDeleteValue: ts3.closeFileWatcher
        });
      }
      ts3.updateMissingFilePathsWatch = updateMissingFilePathsWatch;
      function updateWatchingWildcardDirectories(existingWatchedForWildcards, wildcardDirectories, watchDirectory) {
        ts3.mutateMap(existingWatchedForWildcards, wildcardDirectories, {
          createNewValue: createWildcardDirectoryWatcher,
          onDeleteValue: closeFileWatcherOf,
          onExistingValue: updateWildcardDirectoryWatcher
        });
        function createWildcardDirectoryWatcher(directory, flags) {
          return {
            watcher: watchDirectory(directory, flags),
            flags
          };
        }
        function updateWildcardDirectoryWatcher(existingWatcher, flags, directory) {
          if (existingWatcher.flags === flags) {
            return;
          }
          existingWatcher.watcher.close();
          existingWatchedForWildcards.set(directory, createWildcardDirectoryWatcher(directory, flags));
        }
      }
      ts3.updateWatchingWildcardDirectories = updateWatchingWildcardDirectories;
      function isIgnoredFileFromWildCardWatching(_a2) {
        var watchedDirPath = _a2.watchedDirPath, fileOrDirectory = _a2.fileOrDirectory, fileOrDirectoryPath = _a2.fileOrDirectoryPath, configFileName = _a2.configFileName, options = _a2.options, program2 = _a2.program, extraFileExtensions = _a2.extraFileExtensions, currentDirectory = _a2.currentDirectory, useCaseSensitiveFileNames = _a2.useCaseSensitiveFileNames, writeLog = _a2.writeLog, toPath = _a2.toPath;
        var newPath = ts3.removeIgnoredPath(fileOrDirectoryPath);
        if (!newPath) {
          writeLog("Project: " + configFileName + " Detected ignored path: " + fileOrDirectory);
          return true;
        }
        fileOrDirectoryPath = newPath;
        if (fileOrDirectoryPath === watchedDirPath)
          return false;
        if (ts3.hasExtension(fileOrDirectoryPath) && !ts3.isSupportedSourceFileName(fileOrDirectory, options, extraFileExtensions)) {
          writeLog("Project: " + configFileName + " Detected file add/remove of non supported extension: " + fileOrDirectory);
          return true;
        }
        if (ts3.isExcludedFile(fileOrDirectory, options.configFile.configFileSpecs, ts3.getNormalizedAbsolutePath(ts3.getDirectoryPath(configFileName), currentDirectory), useCaseSensitiveFileNames, currentDirectory)) {
          writeLog("Project: " + configFileName + " Detected excluded file: " + fileOrDirectory);
          return true;
        }
        if (!program2)
          return false;
        if (options.outFile || options.outDir)
          return false;
        if (ts3.fileExtensionIs(fileOrDirectoryPath, ".d.ts")) {
          if (options.declarationDir)
            return false;
        } else if (!ts3.fileExtensionIsOneOf(fileOrDirectoryPath, ts3.supportedJSExtensions)) {
          return false;
        }
        var filePathWithoutExtension = ts3.removeFileExtension(fileOrDirectoryPath);
        var realProgram = ts3.isArray(program2) ? void 0 : isBuilderProgram(program2) ? program2.getProgramOrUndefined() : program2;
        var builderProgram = !realProgram && !ts3.isArray(program2) ? program2 : void 0;
        if (hasSourceFile(filePathWithoutExtension + ".ts") || hasSourceFile(filePathWithoutExtension + ".tsx")) {
          writeLog("Project: " + configFileName + " Detected output file: " + fileOrDirectory);
          return true;
        }
        return false;
        function hasSourceFile(file) {
          return realProgram ? !!realProgram.getSourceFileByPath(file) : builderProgram ? builderProgram.getState().fileInfos.has(file) : !!ts3.find(program2, function(rootFile) {
            return toPath(rootFile) === file;
          });
        }
      }
      ts3.isIgnoredFileFromWildCardWatching = isIgnoredFileFromWildCardWatching;
      function isBuilderProgram(program2) {
        return !!program2.getState;
      }
      function isEmittedFileOfProgram(program2, file) {
        if (!program2) {
          return false;
        }
        return program2.isEmittedFile(file);
      }
      ts3.isEmittedFileOfProgram = isEmittedFileOfProgram;
      var WatchLogLevel;
      (function(WatchLogLevel2) {
        WatchLogLevel2[WatchLogLevel2["None"] = 0] = "None";
        WatchLogLevel2[WatchLogLevel2["TriggerOnly"] = 1] = "TriggerOnly";
        WatchLogLevel2[WatchLogLevel2["Verbose"] = 2] = "Verbose";
      })(WatchLogLevel = ts3.WatchLogLevel || (ts3.WatchLogLevel = {}));
      function getWatchFactory(host, watchLogLevel, log, getDetailWatchInfo) {
        ts3.setSysLog(watchLogLevel === WatchLogLevel.Verbose ? log : ts3.noop);
        var plainInvokeFactory = {
          watchFile: function(file, callback, pollingInterval, options) {
            return host.watchFile(file, callback, pollingInterval, options);
          },
          watchDirectory: function(directory, callback, flags, options) {
            return host.watchDirectory(directory, callback, (flags & 1) !== 0, options);
          }
        };
        var triggerInvokingFactory = watchLogLevel !== WatchLogLevel.None ? {
          watchFile: createTriggerLoggingAddWatch("watchFile"),
          watchDirectory: createTriggerLoggingAddWatch("watchDirectory")
        } : void 0;
        var factory = watchLogLevel === WatchLogLevel.Verbose ? {
          watchFile: createFileWatcherWithLogging,
          watchDirectory: createDirectoryWatcherWithLogging
        } : triggerInvokingFactory || plainInvokeFactory;
        var excludeWatcherFactory = watchLogLevel === WatchLogLevel.Verbose ? createExcludeWatcherWithLogging : ts3.returnNoopFileWatcher;
        return {
          watchFile: createExcludeHandlingAddWatch("watchFile"),
          watchDirectory: createExcludeHandlingAddWatch("watchDirectory")
        };
        function createExcludeHandlingAddWatch(key2) {
          return function(file, cb2, flags, options, detailInfo1, detailInfo2) {
            var _a2;
            return !ts3.matchesExclude(file, key2 === "watchFile" ? options === null || options === void 0 ? void 0 : options.excludeFiles : options === null || options === void 0 ? void 0 : options.excludeDirectories, useCaseSensitiveFileNames(), ((_a2 = host.getCurrentDirectory) === null || _a2 === void 0 ? void 0 : _a2.call(host)) || "") ? factory[key2].call(void 0, file, cb2, flags, options, detailInfo1, detailInfo2) : excludeWatcherFactory(file, flags, options, detailInfo1, detailInfo2);
          };
        }
        function useCaseSensitiveFileNames() {
          return typeof host.useCaseSensitiveFileNames === "boolean" ? host.useCaseSensitiveFileNames : host.useCaseSensitiveFileNames();
        }
        function createExcludeWatcherWithLogging(file, flags, options, detailInfo1, detailInfo2) {
          log("ExcludeWatcher:: Added:: " + getWatchInfo(file, flags, options, detailInfo1, detailInfo2, getDetailWatchInfo));
          return {
            close: function() {
              return log("ExcludeWatcher:: Close:: " + getWatchInfo(file, flags, options, detailInfo1, detailInfo2, getDetailWatchInfo));
            }
          };
        }
        function createFileWatcherWithLogging(file, cb2, flags, options, detailInfo1, detailInfo2) {
          log("FileWatcher:: Added:: " + getWatchInfo(file, flags, options, detailInfo1, detailInfo2, getDetailWatchInfo));
          var watcher = triggerInvokingFactory.watchFile(file, cb2, flags, options, detailInfo1, detailInfo2);
          return {
            close: function() {
              log("FileWatcher:: Close:: " + getWatchInfo(file, flags, options, detailInfo1, detailInfo2, getDetailWatchInfo));
              watcher.close();
            }
          };
        }
        function createDirectoryWatcherWithLogging(file, cb2, flags, options, detailInfo1, detailInfo2) {
          var watchInfo = "DirectoryWatcher:: Added:: " + getWatchInfo(file, flags, options, detailInfo1, detailInfo2, getDetailWatchInfo);
          log(watchInfo);
          var start = ts3.timestamp();
          var watcher = triggerInvokingFactory.watchDirectory(file, cb2, flags, options, detailInfo1, detailInfo2);
          var elapsed = ts3.timestamp() - start;
          log("Elapsed:: " + elapsed + "ms " + watchInfo);
          return {
            close: function() {
              var watchInfo2 = "DirectoryWatcher:: Close:: " + getWatchInfo(file, flags, options, detailInfo1, detailInfo2, getDetailWatchInfo);
              log(watchInfo2);
              var start2 = ts3.timestamp();
              watcher.close();
              var elapsed2 = ts3.timestamp() - start2;
              log("Elapsed:: " + elapsed2 + "ms " + watchInfo2);
            }
          };
        }
        function createTriggerLoggingAddWatch(key2) {
          return function(file, cb2, flags, options, detailInfo1, detailInfo2) {
            return plainInvokeFactory[key2].call(void 0, file, function() {
              var args = [];
              for (var _i = 0; _i < arguments.length; _i++) {
                args[_i] = arguments[_i];
              }
              var triggerredInfo = (key2 === "watchFile" ? "FileWatcher" : "DirectoryWatcher") + ":: Triggered with " + args[0] + " " + (args[1] !== void 0 ? args[1] : "") + ":: " + getWatchInfo(file, flags, options, detailInfo1, detailInfo2, getDetailWatchInfo);
              log(triggerredInfo);
              var start = ts3.timestamp();
              cb2.call.apply(cb2, __spreadArray([void 0], args));
              var elapsed = ts3.timestamp() - start;
              log("Elapsed:: " + elapsed + "ms " + triggerredInfo);
            }, flags, options, detailInfo1, detailInfo2);
          };
        }
        function getWatchInfo(file, flags, options, detailInfo1, detailInfo2, getDetailWatchInfo2) {
          return "WatchInfo: " + file + " " + flags + " " + JSON.stringify(options) + " " + (getDetailWatchInfo2 ? getDetailWatchInfo2(detailInfo1, detailInfo2) : detailInfo2 === void 0 ? detailInfo1 : detailInfo1 + " " + detailInfo2);
        }
      }
      ts3.getWatchFactory = getWatchFactory;
      function getFallbackOptions(options) {
        var fallbackPolling = options === null || options === void 0 ? void 0 : options.fallbackPolling;
        return {
          watchFile: fallbackPolling !== void 0 ? fallbackPolling : ts3.WatchFileKind.PriorityPollingInterval
        };
      }
      ts3.getFallbackOptions = getFallbackOptions;
      function closeFileWatcherOf(objWithWatcher) {
        objWithWatcher.watcher.close();
      }
      ts3.closeFileWatcherOf = closeFileWatcherOf;
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      function findConfigFile(searchPath, fileExists, configName) {
        if (configName === void 0) {
          configName = "tsconfig.json";
        }
        return ts3.forEachAncestorDirectory(searchPath, function(ancestor) {
          var fileName = ts3.combinePaths(ancestor, configName);
          return fileExists(fileName) ? fileName : void 0;
        });
      }
      ts3.findConfigFile = findConfigFile;
      function resolveTripleslashReference(moduleName, containingFile) {
        var basePath = ts3.getDirectoryPath(containingFile);
        var referencedFileName = ts3.isRootedDiskPath(moduleName) ? moduleName : ts3.combinePaths(basePath, moduleName);
        return ts3.normalizePath(referencedFileName);
      }
      ts3.resolveTripleslashReference = resolveTripleslashReference;
      function computeCommonSourceDirectoryOfFilenames(fileNames, currentDirectory, getCanonicalFileName) {
        var commonPathComponents;
        var failed = ts3.forEach(fileNames, function(sourceFile) {
          var sourcePathComponents = ts3.getNormalizedPathComponents(sourceFile, currentDirectory);
          sourcePathComponents.pop();
          if (!commonPathComponents) {
            commonPathComponents = sourcePathComponents;
            return;
          }
          var n2 = Math.min(commonPathComponents.length, sourcePathComponents.length);
          for (var i3 = 0; i3 < n2; i3++) {
            if (getCanonicalFileName(commonPathComponents[i3]) !== getCanonicalFileName(sourcePathComponents[i3])) {
              if (i3 === 0) {
                return true;
              }
              commonPathComponents.length = i3;
              break;
            }
          }
          if (sourcePathComponents.length < commonPathComponents.length) {
            commonPathComponents.length = sourcePathComponents.length;
          }
        });
        if (failed) {
          return "";
        }
        if (!commonPathComponents) {
          return currentDirectory;
        }
        return ts3.getPathFromPathComponents(commonPathComponents);
      }
      ts3.computeCommonSourceDirectoryOfFilenames = computeCommonSourceDirectoryOfFilenames;
      function createCompilerHost(options, setParentNodes) {
        return createCompilerHostWorker(options, setParentNodes);
      }
      ts3.createCompilerHost = createCompilerHost;
      function createCompilerHostWorker(options, setParentNodes, system) {
        if (system === void 0) {
          system = ts3.sys;
        }
        var existingDirectories = new ts3.Map();
        var getCanonicalFileName = ts3.createGetCanonicalFileName(system.useCaseSensitiveFileNames);
        var computeHash = ts3.maybeBind(system, system.createHash) || ts3.generateDjb2Hash;
        function getSourceFile(fileName, languageVersion, onError) {
          var text;
          try {
            ts3.performance.mark("beforeIORead");
            text = compilerHost.readFile(fileName);
            ts3.performance.mark("afterIORead");
            ts3.performance.measure("I/O Read", "beforeIORead", "afterIORead");
          } catch (e2) {
            if (onError) {
              onError(e2.message);
            }
            text = "";
          }
          return text !== void 0 ? ts3.createSourceFile(fileName, text, languageVersion, setParentNodes) : void 0;
        }
        function directoryExists(directoryPath) {
          if (existingDirectories.has(directoryPath)) {
            return true;
          }
          if ((compilerHost.directoryExists || system.directoryExists)(directoryPath)) {
            existingDirectories.set(directoryPath, true);
            return true;
          }
          return false;
        }
        function writeFile(fileName, data, writeByteOrderMark, onError) {
          try {
            ts3.performance.mark("beforeIOWrite");
            ts3.writeFileEnsuringDirectories(fileName, data, writeByteOrderMark, function(path2, data2, writeByteOrderMark2) {
              return writeFileWorker(path2, data2, writeByteOrderMark2);
            }, function(path2) {
              return (compilerHost.createDirectory || system.createDirectory)(path2);
            }, function(path2) {
              return directoryExists(path2);
            });
            ts3.performance.mark("afterIOWrite");
            ts3.performance.measure("I/O Write", "beforeIOWrite", "afterIOWrite");
          } catch (e2) {
            if (onError) {
              onError(e2.message);
            }
          }
        }
        var outputFingerprints;
        function writeFileWorker(fileName, data, writeByteOrderMark) {
          if (!ts3.isWatchSet(options) || !system.getModifiedTime) {
            system.writeFile(fileName, data, writeByteOrderMark);
            return;
          }
          if (!outputFingerprints) {
            outputFingerprints = new ts3.Map();
          }
          var hash = computeHash(data);
          var mtimeBefore = system.getModifiedTime(fileName);
          if (mtimeBefore) {
            var fingerprint = outputFingerprints.get(fileName);
            if (fingerprint && fingerprint.byteOrderMark === writeByteOrderMark && fingerprint.hash === hash && fingerprint.mtime.getTime() === mtimeBefore.getTime()) {
              return;
            }
          }
          system.writeFile(fileName, data, writeByteOrderMark);
          var mtimeAfter = system.getModifiedTime(fileName) || ts3.missingFileModifiedTime;
          outputFingerprints.set(fileName, {
            hash,
            byteOrderMark: writeByteOrderMark,
            mtime: mtimeAfter
          });
        }
        function getDefaultLibLocation() {
          return ts3.getDirectoryPath(ts3.normalizePath(system.getExecutingFilePath()));
        }
        var newLine = ts3.getNewLineCharacter(options, function() {
          return system.newLine;
        });
        var realpath = system.realpath && function(path2) {
          return system.realpath(path2);
        };
        var compilerHost = {
          getSourceFile,
          getDefaultLibLocation,
          getDefaultLibFileName: function(options2) {
            return ts3.combinePaths(getDefaultLibLocation(), ts3.getDefaultLibFileName(options2));
          },
          writeFile,
          getCurrentDirectory: ts3.memoize(function() {
            return system.getCurrentDirectory();
          }),
          useCaseSensitiveFileNames: function() {
            return system.useCaseSensitiveFileNames;
          },
          getCanonicalFileName,
          getNewLine: function() {
            return newLine;
          },
          fileExists: function(fileName) {
            return system.fileExists(fileName);
          },
          readFile: function(fileName) {
            return system.readFile(fileName);
          },
          trace: function(s2) {
            return system.write(s2 + newLine);
          },
          directoryExists: function(directoryName) {
            return system.directoryExists(directoryName);
          },
          getEnvironmentVariable: function(name) {
            return system.getEnvironmentVariable ? system.getEnvironmentVariable(name) : "";
          },
          getDirectories: function(path2) {
            return system.getDirectories(path2);
          },
          realpath,
          readDirectory: function(path2, extensions, include, exclude, depth) {
            return system.readDirectory(path2, extensions, include, exclude, depth);
          },
          createDirectory: function(d) {
            return system.createDirectory(d);
          },
          createHash: ts3.maybeBind(system, system.createHash)
        };
        return compilerHost;
      }
      ts3.createCompilerHostWorker = createCompilerHostWorker;
      function changeCompilerHostLikeToUseCache(host, toPath, getSourceFile) {
        var originalReadFile = host.readFile;
        var originalFileExists = host.fileExists;
        var originalDirectoryExists = host.directoryExists;
        var originalCreateDirectory = host.createDirectory;
        var originalWriteFile = host.writeFile;
        var readFileCache = new ts3.Map();
        var fileExistsCache = new ts3.Map();
        var directoryExistsCache = new ts3.Map();
        var sourceFileCache = new ts3.Map();
        var readFileWithCache = function(fileName) {
          var key2 = toPath(fileName);
          var value = readFileCache.get(key2);
          if (value !== void 0)
            return value !== false ? value : void 0;
          return setReadFileCache(key2, fileName);
        };
        var setReadFileCache = function(key2, fileName) {
          var newValue = originalReadFile.call(host, fileName);
          readFileCache.set(key2, newValue !== void 0 ? newValue : false);
          return newValue;
        };
        host.readFile = function(fileName) {
          var key2 = toPath(fileName);
          var value = readFileCache.get(key2);
          if (value !== void 0)
            return value !== false ? value : void 0;
          if (!ts3.fileExtensionIs(fileName, ".json") && !ts3.isBuildInfoFile(fileName)) {
            return originalReadFile.call(host, fileName);
          }
          return setReadFileCache(key2, fileName);
        };
        var getSourceFileWithCache = getSourceFile ? function(fileName, languageVersion, onError, shouldCreateNewSourceFile) {
          var key2 = toPath(fileName);
          var value = sourceFileCache.get(key2);
          if (value)
            return value;
          var sourceFile = getSourceFile(fileName, languageVersion, onError, shouldCreateNewSourceFile);
          if (sourceFile && (ts3.isDeclarationFileName(fileName) || ts3.fileExtensionIs(fileName, ".json"))) {
            sourceFileCache.set(key2, sourceFile);
          }
          return sourceFile;
        } : void 0;
        host.fileExists = function(fileName) {
          var key2 = toPath(fileName);
          var value = fileExistsCache.get(key2);
          if (value !== void 0)
            return value;
          var newValue = originalFileExists.call(host, fileName);
          fileExistsCache.set(key2, !!newValue);
          return newValue;
        };
        if (originalWriteFile) {
          host.writeFile = function(fileName, data, writeByteOrderMark, onError, sourceFiles) {
            var key2 = toPath(fileName);
            fileExistsCache.delete(key2);
            var value = readFileCache.get(key2);
            if (value !== void 0 && value !== data) {
              readFileCache.delete(key2);
              sourceFileCache.delete(key2);
            } else if (getSourceFileWithCache) {
              var sourceFile = sourceFileCache.get(key2);
              if (sourceFile && sourceFile.text !== data) {
                sourceFileCache.delete(key2);
              }
            }
            originalWriteFile.call(host, fileName, data, writeByteOrderMark, onError, sourceFiles);
          };
        }
        if (originalDirectoryExists && originalCreateDirectory) {
          host.directoryExists = function(directory) {
            var key2 = toPath(directory);
            var value = directoryExistsCache.get(key2);
            if (value !== void 0)
              return value;
            var newValue = originalDirectoryExists.call(host, directory);
            directoryExistsCache.set(key2, !!newValue);
            return newValue;
          };
          host.createDirectory = function(directory) {
            var key2 = toPath(directory);
            directoryExistsCache.delete(key2);
            originalCreateDirectory.call(host, directory);
          };
        }
        return {
          originalReadFile,
          originalFileExists,
          originalDirectoryExists,
          originalCreateDirectory,
          originalWriteFile,
          getSourceFileWithCache,
          readFileWithCache
        };
      }
      ts3.changeCompilerHostLikeToUseCache = changeCompilerHostLikeToUseCache;
      function getPreEmitDiagnostics(program2, sourceFile, cancellationToken) {
        var diagnostics;
        diagnostics = ts3.addRange(diagnostics, program2.getConfigFileParsingDiagnostics());
        diagnostics = ts3.addRange(diagnostics, program2.getOptionsDiagnostics(cancellationToken));
        diagnostics = ts3.addRange(diagnostics, program2.getSyntacticDiagnostics(sourceFile, cancellationToken));
        diagnostics = ts3.addRange(diagnostics, program2.getGlobalDiagnostics(cancellationToken));
        diagnostics = ts3.addRange(diagnostics, program2.getSemanticDiagnostics(sourceFile, cancellationToken));
        if (ts3.getEmitDeclarations(program2.getCompilerOptions())) {
          diagnostics = ts3.addRange(diagnostics, program2.getDeclarationDiagnostics(sourceFile, cancellationToken));
        }
        return ts3.sortAndDeduplicateDiagnostics(diagnostics || ts3.emptyArray);
      }
      ts3.getPreEmitDiagnostics = getPreEmitDiagnostics;
      function formatDiagnostics(diagnostics, host) {
        var output = "";
        for (var _i = 0, diagnostics_3 = diagnostics; _i < diagnostics_3.length; _i++) {
          var diagnostic = diagnostics_3[_i];
          output += formatDiagnostic(diagnostic, host);
        }
        return output;
      }
      ts3.formatDiagnostics = formatDiagnostics;
      function formatDiagnostic(diagnostic, host) {
        var errorMessage = ts3.diagnosticCategoryName(diagnostic) + " TS" + diagnostic.code + ": " + flattenDiagnosticMessageText(diagnostic.messageText, host.getNewLine()) + host.getNewLine();
        if (diagnostic.file) {
          var _a2 = ts3.getLineAndCharacterOfPosition(diagnostic.file, diagnostic.start), line = _a2.line, character = _a2.character;
          var fileName = diagnostic.file.fileName;
          var relativeFileName = ts3.convertToRelativePath(fileName, host.getCurrentDirectory(), function(fileName2) {
            return host.getCanonicalFileName(fileName2);
          });
          return relativeFileName + "(" + (line + 1) + "," + (character + 1) + "): " + errorMessage;
        }
        return errorMessage;
      }
      ts3.formatDiagnostic = formatDiagnostic;
      var ForegroundColorEscapeSequences;
      (function(ForegroundColorEscapeSequences2) {
        ForegroundColorEscapeSequences2["Grey"] = "[90m";
        ForegroundColorEscapeSequences2["Red"] = "[91m";
        ForegroundColorEscapeSequences2["Yellow"] = "[93m";
        ForegroundColorEscapeSequences2["Blue"] = "[94m";
        ForegroundColorEscapeSequences2["Cyan"] = "[96m";
      })(ForegroundColorEscapeSequences = ts3.ForegroundColorEscapeSequences || (ts3.ForegroundColorEscapeSequences = {}));
      var gutterStyleSequence = "[7m";
      var gutterSeparator = " ";
      var resetEscapeSequence = "[0m";
      var ellipsis = "...";
      var halfIndent = "  ";
      var indent = "    ";
      function getCategoryFormat(category) {
        switch (category) {
          case ts3.DiagnosticCategory.Error:
            return ForegroundColorEscapeSequences.Red;
          case ts3.DiagnosticCategory.Warning:
            return ForegroundColorEscapeSequences.Yellow;
          case ts3.DiagnosticCategory.Suggestion:
            return ts3.Debug.fail("Should never get an Info diagnostic on the command line.");
          case ts3.DiagnosticCategory.Message:
            return ForegroundColorEscapeSequences.Blue;
        }
      }
      function formatColorAndReset(text, formatStyle) {
        return formatStyle + text + resetEscapeSequence;
      }
      ts3.formatColorAndReset = formatColorAndReset;
      function formatCodeSpan(file, start, length, indent2, squiggleColor, host) {
        var _a2 = ts3.getLineAndCharacterOfPosition(file, start), firstLine = _a2.line, firstLineChar = _a2.character;
        var _b = ts3.getLineAndCharacterOfPosition(file, start + length), lastLine = _b.line, lastLineChar = _b.character;
        var lastLineInFile = ts3.getLineAndCharacterOfPosition(file, file.text.length).line;
        var hasMoreThanFiveLines = lastLine - firstLine >= 4;
        var gutterWidth = (lastLine + 1 + "").length;
        if (hasMoreThanFiveLines) {
          gutterWidth = Math.max(ellipsis.length, gutterWidth);
        }
        var context = "";
        for (var i3 = firstLine; i3 <= lastLine; i3++) {
          context += host.getNewLine();
          if (hasMoreThanFiveLines && firstLine + 1 < i3 && i3 < lastLine - 1) {
            context += indent2 + formatColorAndReset(ts3.padLeft(ellipsis, gutterWidth), gutterStyleSequence) + gutterSeparator + host.getNewLine();
            i3 = lastLine - 1;
          }
          var lineStart = ts3.getPositionOfLineAndCharacter(file, i3, 0);
          var lineEnd = i3 < lastLineInFile ? ts3.getPositionOfLineAndCharacter(file, i3 + 1, 0) : file.text.length;
          var lineContent = file.text.slice(lineStart, lineEnd);
          lineContent = lineContent.replace(/\s+$/g, "");
          lineContent = lineContent.replace(/\t/g, " ");
          context += indent2 + formatColorAndReset(ts3.padLeft(i3 + 1 + "", gutterWidth), gutterStyleSequence) + gutterSeparator;
          context += lineContent + host.getNewLine();
          context += indent2 + formatColorAndReset(ts3.padLeft("", gutterWidth), gutterStyleSequence) + gutterSeparator;
          context += squiggleColor;
          if (i3 === firstLine) {
            var lastCharForLine = i3 === lastLine ? lastLineChar : void 0;
            context += lineContent.slice(0, firstLineChar).replace(/\S/g, " ");
            context += lineContent.slice(firstLineChar, lastCharForLine).replace(/./g, "~");
          } else if (i3 === lastLine) {
            context += lineContent.slice(0, lastLineChar).replace(/./g, "~");
          } else {
            context += lineContent.replace(/./g, "~");
          }
          context += resetEscapeSequence;
        }
        return context;
      }
      function formatLocation(file, start, host, color) {
        if (color === void 0) {
          color = formatColorAndReset;
        }
        var _a2 = ts3.getLineAndCharacterOfPosition(file, start), firstLine = _a2.line, firstLineChar = _a2.character;
        var relativeFileName = host ? ts3.convertToRelativePath(file.fileName, host.getCurrentDirectory(), function(fileName) {
          return host.getCanonicalFileName(fileName);
        }) : file.fileName;
        var output = "";
        output += color(relativeFileName, ForegroundColorEscapeSequences.Cyan);
        output += ":";
        output += color("" + (firstLine + 1), ForegroundColorEscapeSequences.Yellow);
        output += ":";
        output += color("" + (firstLineChar + 1), ForegroundColorEscapeSequences.Yellow);
        return output;
      }
      ts3.formatLocation = formatLocation;
      function formatDiagnosticsWithColorAndContext(diagnostics, host) {
        var output = "";
        for (var _i = 0, diagnostics_4 = diagnostics; _i < diagnostics_4.length; _i++) {
          var diagnostic = diagnostics_4[_i];
          if (diagnostic.file) {
            var file = diagnostic.file, start = diagnostic.start;
            output += formatLocation(file, start, host);
            output += " - ";
          }
          output += formatColorAndReset(ts3.diagnosticCategoryName(diagnostic), getCategoryFormat(diagnostic.category));
          output += formatColorAndReset(" TS" + diagnostic.code + ": ", ForegroundColorEscapeSequences.Grey);
          output += flattenDiagnosticMessageText(diagnostic.messageText, host.getNewLine());
          if (diagnostic.file) {
            output += host.getNewLine();
            output += formatCodeSpan(diagnostic.file, diagnostic.start, diagnostic.length, "", getCategoryFormat(diagnostic.category), host);
          }
          if (diagnostic.relatedInformation) {
            output += host.getNewLine();
            for (var _a2 = 0, _b = diagnostic.relatedInformation; _a2 < _b.length; _a2++) {
              var _c = _b[_a2], file = _c.file, start = _c.start, length_9 = _c.length, messageText = _c.messageText;
              if (file) {
                output += host.getNewLine();
                output += halfIndent + formatLocation(file, start, host);
                output += formatCodeSpan(file, start, length_9, indent, ForegroundColorEscapeSequences.Cyan, host);
              }
              output += host.getNewLine();
              output += indent + flattenDiagnosticMessageText(messageText, host.getNewLine());
            }
          }
          output += host.getNewLine();
        }
        return output;
      }
      ts3.formatDiagnosticsWithColorAndContext = formatDiagnosticsWithColorAndContext;
      function flattenDiagnosticMessageText(diag, newLine, indent2) {
        if (indent2 === void 0) {
          indent2 = 0;
        }
        if (ts3.isString(diag)) {
          return diag;
        } else if (diag === void 0) {
          return "";
        }
        var result2 = "";
        if (indent2) {
          result2 += newLine;
          for (var i3 = 0; i3 < indent2; i3++) {
            result2 += "  ";
          }
        }
        result2 += diag.messageText;
        indent2++;
        if (diag.next) {
          for (var _i = 0, _a2 = diag.next; _i < _a2.length; _i++) {
            var kid = _a2[_i];
            result2 += flattenDiagnosticMessageText(kid, newLine, indent2);
          }
        }
        return result2;
      }
      ts3.flattenDiagnosticMessageText = flattenDiagnosticMessageText;
      function loadWithLocalCache(names, containingFile, redirectedReference, loader2) {
        if (names.length === 0) {
          return [];
        }
        var resolutions = [];
        var cache = new ts3.Map();
        for (var _i = 0, names_2 = names; _i < names_2.length; _i++) {
          var name = names_2[_i];
          var result2 = void 0;
          if (cache.has(name)) {
            result2 = cache.get(name);
          } else {
            cache.set(name, result2 = loader2(name, containingFile, redirectedReference));
          }
          resolutions.push(result2);
        }
        return resolutions;
      }
      ts3.loadWithLocalCache = loadWithLocalCache;
      function forEachResolvedProjectReference(resolvedProjectReferences, cb2) {
        return forEachProjectReference(void 0, resolvedProjectReferences, function(resolvedRef, parent) {
          return resolvedRef && cb2(resolvedRef, parent);
        });
      }
      ts3.forEachResolvedProjectReference = forEachResolvedProjectReference;
      function forEachProjectReference(projectReferences, resolvedProjectReferences, cbResolvedRef, cbRef) {
        var seenResolvedRefs;
        return worker(projectReferences, resolvedProjectReferences, void 0);
        function worker(projectReferences2, resolvedProjectReferences2, parent) {
          if (cbRef) {
            var result2 = cbRef(projectReferences2, parent);
            if (result2) {
              return result2;
            }
          }
          return ts3.forEach(resolvedProjectReferences2, function(resolvedRef, index) {
            if (resolvedRef && (seenResolvedRefs === null || seenResolvedRefs === void 0 ? void 0 : seenResolvedRefs.has(resolvedRef.sourceFile.path))) {
              return void 0;
            }
            var result3 = cbResolvedRef(resolvedRef, parent, index);
            if (result3 || !resolvedRef)
              return result3;
            (seenResolvedRefs || (seenResolvedRefs = new ts3.Set())).add(resolvedRef.sourceFile.path);
            return worker(resolvedRef.commandLine.projectReferences, resolvedRef.references, resolvedRef);
          });
        }
      }
      ts3.inferredTypesContainingFile = "__inferred type names__.ts";
      function isReferencedFile(reason) {
        switch (reason === null || reason === void 0 ? void 0 : reason.kind) {
          case ts3.FileIncludeKind.Import:
          case ts3.FileIncludeKind.ReferenceFile:
          case ts3.FileIncludeKind.TypeReferenceDirective:
          case ts3.FileIncludeKind.LibReferenceDirective:
            return true;
          default:
            return false;
        }
      }
      ts3.isReferencedFile = isReferencedFile;
      function isReferenceFileLocation(location) {
        return location.pos !== void 0;
      }
      ts3.isReferenceFileLocation = isReferenceFileLocation;
      function getReferencedFileLocation(getSourceFileByPath, ref2) {
        var _a2, _b, _c;
        var _d, _e, _f, _g;
        var file = ts3.Debug.checkDefined(getSourceFileByPath(ref2.file));
        var kind = ref2.kind, index = ref2.index;
        var pos, end, packageId;
        switch (kind) {
          case ts3.FileIncludeKind.Import:
            var importLiteral = getModuleNameStringLiteralAt(file, index);
            packageId = (_e = (_d = file.resolvedModules) === null || _d === void 0 ? void 0 : _d.get(importLiteral.text)) === null || _e === void 0 ? void 0 : _e.packageId;
            if (importLiteral.pos === -1)
              return { file, packageId, text: importLiteral.text };
            pos = ts3.skipTrivia(file.text, importLiteral.pos);
            end = importLiteral.end;
            break;
          case ts3.FileIncludeKind.ReferenceFile:
            _a2 = file.referencedFiles[index], pos = _a2.pos, end = _a2.end;
            break;
          case ts3.FileIncludeKind.TypeReferenceDirective:
            _b = file.typeReferenceDirectives[index], pos = _b.pos, end = _b.end;
            packageId = (_g = (_f = file.resolvedTypeReferenceDirectiveNames) === null || _f === void 0 ? void 0 : _f.get(ts3.toFileNameLowerCase(file.typeReferenceDirectives[index].fileName))) === null || _g === void 0 ? void 0 : _g.packageId;
            break;
          case ts3.FileIncludeKind.LibReferenceDirective:
            _c = file.libReferenceDirectives[index], pos = _c.pos, end = _c.end;
            break;
          default:
            return ts3.Debug.assertNever(kind);
        }
        return { file, pos, end, packageId };
      }
      ts3.getReferencedFileLocation = getReferencedFileLocation;
      function isProgramUptoDate(program2, rootFileNames, newOptions, getSourceVersion, fileExists, hasInvalidatedResolution, hasChangedAutomaticTypeDirectiveNames, getParsedCommandLine, projectReferences) {
        if (!program2 || (hasChangedAutomaticTypeDirectiveNames === null || hasChangedAutomaticTypeDirectiveNames === void 0 ? void 0 : hasChangedAutomaticTypeDirectiveNames()))
          return false;
        if (!ts3.arrayIsEqualTo(program2.getRootFileNames(), rootFileNames))
          return false;
        var seenResolvedRefs;
        if (!ts3.arrayIsEqualTo(program2.getProjectReferences(), projectReferences, projectReferenceUptoDate))
          return false;
        if (program2.getSourceFiles().some(sourceFileNotUptoDate))
          return false;
        if (program2.getMissingFilePaths().some(fileExists))
          return false;
        var currentOptions = program2.getCompilerOptions();
        if (!ts3.compareDataObjects(currentOptions, newOptions))
          return false;
        if (currentOptions.configFile && newOptions.configFile)
          return currentOptions.configFile.text === newOptions.configFile.text;
        return true;
        function sourceFileNotUptoDate(sourceFile) {
          return !sourceFileVersionUptoDate(sourceFile) || hasInvalidatedResolution(sourceFile.path);
        }
        function sourceFileVersionUptoDate(sourceFile) {
          return sourceFile.version === getSourceVersion(sourceFile.resolvedPath, sourceFile.fileName);
        }
        function projectReferenceUptoDate(oldRef, newRef, index) {
          return ts3.projectReferenceIsEqualTo(oldRef, newRef) && resolvedProjectReferenceUptoDate(program2.getResolvedProjectReferences()[index], oldRef);
        }
        function resolvedProjectReferenceUptoDate(oldResolvedRef, oldRef) {
          if (oldResolvedRef) {
            if (ts3.contains(seenResolvedRefs, oldResolvedRef))
              return true;
            var refPath_1 = resolveProjectReferencePath(oldRef);
            var newParsedCommandLine = getParsedCommandLine(refPath_1);
            if (!newParsedCommandLine)
              return false;
            if (oldResolvedRef.commandLine.options.configFile !== newParsedCommandLine.options.configFile)
              return false;
            if (!ts3.arrayIsEqualTo(oldResolvedRef.commandLine.fileNames, newParsedCommandLine.fileNames))
              return false;
            (seenResolvedRefs || (seenResolvedRefs = [])).push(oldResolvedRef);
            return !ts3.forEach(oldResolvedRef.references, function(childResolvedRef, index) {
              return !resolvedProjectReferenceUptoDate(childResolvedRef, oldResolvedRef.commandLine.projectReferences[index]);
            });
          }
          var refPath = resolveProjectReferencePath(oldRef);
          return !getParsedCommandLine(refPath);
        }
      }
      ts3.isProgramUptoDate = isProgramUptoDate;
      function getConfigFileParsingDiagnostics(configFileParseResult) {
        return configFileParseResult.options.configFile ? __spreadArray(__spreadArray([], configFileParseResult.options.configFile.parseDiagnostics), configFileParseResult.errors) : configFileParseResult.errors;
      }
      ts3.getConfigFileParsingDiagnostics = getConfigFileParsingDiagnostics;
      function shouldProgramCreateNewSourceFiles(program2, newOptions) {
        if (!program2)
          return false;
        var oldOptions = program2.getCompilerOptions();
        return !!ts3.sourceFileAffectingCompilerOptions.some(function(option) {
          return !ts3.isJsonEqual(ts3.getCompilerOptionValue(oldOptions, option), ts3.getCompilerOptionValue(newOptions, option));
        });
      }
      function createCreateProgramOptions(rootNames, options, host, oldProgram, configFileParsingDiagnostics) {
        return {
          rootNames,
          options,
          host,
          oldProgram,
          configFileParsingDiagnostics
        };
      }
      function createProgram(rootNamesOrOptions, _options, _host, _oldProgram, _configFileParsingDiagnostics) {
        var _a2, _b, _c;
        var createProgramOptions = ts3.isArray(rootNamesOrOptions) ? createCreateProgramOptions(rootNamesOrOptions, _options, _host, _oldProgram, _configFileParsingDiagnostics) : rootNamesOrOptions;
        var rootNames = createProgramOptions.rootNames, options = createProgramOptions.options, configFileParsingDiagnostics = createProgramOptions.configFileParsingDiagnostics, projectReferences = createProgramOptions.projectReferences;
        var oldProgram = createProgramOptions.oldProgram;
        var processingDefaultLibFiles;
        var processingOtherFiles;
        var files;
        var symlinks;
        var commonSourceDirectory;
        var diagnosticsProducingTypeChecker;
        var noDiagnosticsTypeChecker;
        var classifiableNames;
        var ambientModuleNameToUnmodifiedFileName = new ts3.Map();
        var fileReasons = ts3.createMultiMap();
        var cachedBindAndCheckDiagnosticsForFile = {};
        var cachedDeclarationDiagnosticsForFile = {};
        var resolvedTypeReferenceDirectives = new ts3.Map();
        var fileProcessingDiagnostics;
        var maxNodeModuleJsDepth = typeof options.maxNodeModuleJsDepth === "number" ? options.maxNodeModuleJsDepth : 0;
        var currentNodeModulesDepth = 0;
        var modulesWithElidedImports = new ts3.Map();
        var sourceFilesFoundSearchingNodeModules = new ts3.Map();
        ts3.tracing === null || ts3.tracing === void 0 ? void 0 : ts3.tracing.push("program", "createProgram", { configFilePath: options.configFilePath, rootDir: options.rootDir }, true);
        ts3.performance.mark("beforeProgram");
        var host = createProgramOptions.host || createCompilerHost(options);
        var configParsingHost = parseConfigHostFromCompilerHostLike(host);
        var skipDefaultLib = options.noLib;
        var getDefaultLibraryFileName = ts3.memoize(function() {
          return host.getDefaultLibFileName(options);
        });
        var defaultLibraryPath = host.getDefaultLibLocation ? host.getDefaultLibLocation() : ts3.getDirectoryPath(getDefaultLibraryFileName());
        var programDiagnostics = ts3.createDiagnosticCollection();
        var currentDirectory = host.getCurrentDirectory();
        var supportedExtensions = ts3.getSupportedExtensions(options);
        var supportedExtensionsWithJsonIfResolveJsonModule = ts3.getSuppoertedExtensionsWithJsonIfResolveJsonModule(options, supportedExtensions);
        var hasEmitBlockingDiagnostics = new ts3.Map();
        var _compilerOptionsObjectLiteralSyntax;
        var moduleResolutionCache;
        var typeReferenceDirectiveResolutionCache;
        var actualResolveModuleNamesWorker;
        var hasInvalidatedResolution = host.hasInvalidatedResolution || ts3.returnFalse;
        if (host.resolveModuleNames) {
          actualResolveModuleNamesWorker = function(moduleNames, containingFile, reusedNames, redirectedReference) {
            return host.resolveModuleNames(ts3.Debug.checkEachDefined(moduleNames), containingFile, reusedNames, redirectedReference, options).map(function(resolved) {
              if (!resolved || resolved.extension !== void 0) {
                return resolved;
              }
              var withExtension = ts3.clone(resolved);
              withExtension.extension = ts3.extensionFromPath(resolved.resolvedFileName);
              return withExtension;
            });
          };
        } else {
          moduleResolutionCache = ts3.createModuleResolutionCache(currentDirectory, getCanonicalFileName, options);
          var loader_1 = function(moduleName, containingFile, redirectedReference) {
            return ts3.resolveModuleName(moduleName, containingFile, options, host, moduleResolutionCache, redirectedReference).resolvedModule;
          };
          actualResolveModuleNamesWorker = function(moduleNames, containingFile, _reusedNames, redirectedReference) {
            return loadWithLocalCache(ts3.Debug.checkEachDefined(moduleNames), containingFile, redirectedReference, loader_1);
          };
        }
        var actualResolveTypeReferenceDirectiveNamesWorker;
        if (host.resolveTypeReferenceDirectives) {
          actualResolveTypeReferenceDirectiveNamesWorker = function(typeDirectiveNames, containingFile, redirectedReference) {
            return host.resolveTypeReferenceDirectives(ts3.Debug.checkEachDefined(typeDirectiveNames), containingFile, redirectedReference, options);
          };
        } else {
          typeReferenceDirectiveResolutionCache = ts3.createTypeReferenceDirectiveResolutionCache(currentDirectory, getCanonicalFileName, void 0, moduleResolutionCache === null || moduleResolutionCache === void 0 ? void 0 : moduleResolutionCache.getPackageJsonInfoCache());
          var loader_2 = function(typesRef, containingFile, redirectedReference) {
            return ts3.resolveTypeReferenceDirective(typesRef, containingFile, options, host, redirectedReference, typeReferenceDirectiveResolutionCache).resolvedTypeReferenceDirective;
          };
          actualResolveTypeReferenceDirectiveNamesWorker = function(typeReferenceDirectiveNames, containingFile, redirectedReference) {
            return loadWithLocalCache(ts3.Debug.checkEachDefined(typeReferenceDirectiveNames), containingFile, redirectedReference, loader_2);
          };
        }
        var packageIdToSourceFile = new ts3.Map();
        var sourceFileToPackageName = new ts3.Map();
        var redirectTargetsMap = ts3.createMultiMap();
        var filesByName = new ts3.Map();
        var missingFilePaths;
        var filesByNameIgnoreCase = host.useCaseSensitiveFileNames() ? new ts3.Map() : void 0;
        var resolvedProjectReferences;
        var projectReferenceRedirects;
        var mapFromFileToProjectReferenceRedirects;
        var mapFromToProjectReferenceRedirectSource;
        var useSourceOfProjectReferenceRedirect = !!((_a2 = host.useSourceOfProjectReferenceRedirect) === null || _a2 === void 0 ? void 0 : _a2.call(host)) && !options.disableSourceOfProjectReferenceRedirect;
        var _d = updateHostForUseSourceOfProjectReferenceRedirect({
          compilerHost: host,
          getSymlinkCache,
          useSourceOfProjectReferenceRedirect,
          toPath,
          getResolvedProjectReferences,
          getSourceOfProjectReferenceRedirect,
          forEachResolvedProjectReference: forEachResolvedProjectReference2
        }), onProgramCreateComplete = _d.onProgramCreateComplete, fileExists = _d.fileExists, directoryExists = _d.directoryExists;
        ts3.tracing === null || ts3.tracing === void 0 ? void 0 : ts3.tracing.push("program", "shouldProgramCreateNewSourceFiles", { hasOldProgram: !!oldProgram });
        var shouldCreateNewSourceFile = shouldProgramCreateNewSourceFiles(oldProgram, options);
        ts3.tracing === null || ts3.tracing === void 0 ? void 0 : ts3.tracing.pop();
        var structureIsReused;
        ts3.tracing === null || ts3.tracing === void 0 ? void 0 : ts3.tracing.push("program", "tryReuseStructureFromOldProgram", {});
        structureIsReused = tryReuseStructureFromOldProgram();
        ts3.tracing === null || ts3.tracing === void 0 ? void 0 : ts3.tracing.pop();
        if (structureIsReused !== 2) {
          processingDefaultLibFiles = [];
          processingOtherFiles = [];
          if (projectReferences) {
            if (!resolvedProjectReferences) {
              resolvedProjectReferences = projectReferences.map(parseProjectReferenceConfigFile);
            }
            if (rootNames.length) {
              resolvedProjectReferences === null || resolvedProjectReferences === void 0 ? void 0 : resolvedProjectReferences.forEach(function(parsedRef, index) {
                if (!parsedRef)
                  return;
                var out = ts3.outFile(parsedRef.commandLine.options);
                if (useSourceOfProjectReferenceRedirect) {
                  if (out || ts3.getEmitModuleKind(parsedRef.commandLine.options) === ts3.ModuleKind.None) {
                    for (var _i2 = 0, _a3 = parsedRef.commandLine.fileNames; _i2 < _a3.length; _i2++) {
                      var fileName = _a3[_i2];
                      processProjectReferenceFile(fileName, { kind: ts3.FileIncludeKind.SourceFromProjectReference, index });
                    }
                  }
                } else {
                  if (out) {
                    processProjectReferenceFile(ts3.changeExtension(out, ".d.ts"), { kind: ts3.FileIncludeKind.OutputFromProjectReference, index });
                  } else if (ts3.getEmitModuleKind(parsedRef.commandLine.options) === ts3.ModuleKind.None) {
                    var getCommonSourceDirectory_2 = ts3.memoize(function() {
                      return ts3.getCommonSourceDirectoryOfConfig(parsedRef.commandLine, !host.useCaseSensitiveFileNames());
                    });
                    for (var _b2 = 0, _c2 = parsedRef.commandLine.fileNames; _b2 < _c2.length; _b2++) {
                      var fileName = _c2[_b2];
                      if (!ts3.fileExtensionIs(fileName, ".d.ts") && !ts3.fileExtensionIs(fileName, ".json")) {
                        processProjectReferenceFile(ts3.getOutputDeclarationFileName(fileName, parsedRef.commandLine, !host.useCaseSensitiveFileNames(), getCommonSourceDirectory_2), { kind: ts3.FileIncludeKind.OutputFromProjectReference, index });
                      }
                    }
                  }
                }
              });
            }
          }
          ts3.tracing === null || ts3.tracing === void 0 ? void 0 : ts3.tracing.push("program", "processRootFiles", { count: rootNames.length });
          ts3.forEach(rootNames, function(name, index) {
            return processRootFile(name, false, false, { kind: ts3.FileIncludeKind.RootFile, index });
          });
          ts3.tracing === null || ts3.tracing === void 0 ? void 0 : ts3.tracing.pop();
          var typeReferences = rootNames.length ? ts3.getAutomaticTypeDirectiveNames(options, host) : ts3.emptyArray;
          if (typeReferences.length) {
            ts3.tracing === null || ts3.tracing === void 0 ? void 0 : ts3.tracing.push("program", "processTypeReferences", { count: typeReferences.length });
            var containingDirectory = options.configFilePath ? ts3.getDirectoryPath(options.configFilePath) : host.getCurrentDirectory();
            var containingFilename = ts3.combinePaths(containingDirectory, ts3.inferredTypesContainingFile);
            var resolutions = resolveTypeReferenceDirectiveNamesWorker(typeReferences, containingFilename);
            for (var i3 = 0; i3 < typeReferences.length; i3++) {
              processTypeReferenceDirective(typeReferences[i3], resolutions[i3], { kind: ts3.FileIncludeKind.AutomaticTypeDirectiveFile, typeReference: typeReferences[i3], packageId: (_b = resolutions[i3]) === null || _b === void 0 ? void 0 : _b.packageId });
            }
            ts3.tracing === null || ts3.tracing === void 0 ? void 0 : ts3.tracing.pop();
          }
          if (rootNames.length && !skipDefaultLib) {
            var defaultLibraryFileName = getDefaultLibraryFileName();
            if (!options.lib && defaultLibraryFileName) {
              processRootFile(defaultLibraryFileName, true, false, { kind: ts3.FileIncludeKind.LibFile });
            } else {
              ts3.forEach(options.lib, function(libFileName, index) {
                processRootFile(ts3.combinePaths(defaultLibraryPath, libFileName), true, false, { kind: ts3.FileIncludeKind.LibFile, index });
              });
            }
          }
          missingFilePaths = ts3.arrayFrom(ts3.mapDefinedIterator(filesByName.entries(), function(_a3) {
            var path2 = _a3[0], file = _a3[1];
            return file === void 0 ? path2 : void 0;
          }));
          files = ts3.stableSort(processingDefaultLibFiles, compareDefaultLibFiles).concat(processingOtherFiles);
          processingDefaultLibFiles = void 0;
          processingOtherFiles = void 0;
        }
        ts3.Debug.assert(!!missingFilePaths);
        if (oldProgram && host.onReleaseOldSourceFile) {
          var oldSourceFiles = oldProgram.getSourceFiles();
          for (var _i = 0, oldSourceFiles_1 = oldSourceFiles; _i < oldSourceFiles_1.length; _i++) {
            var oldSourceFile = oldSourceFiles_1[_i];
            var newFile = getSourceFileByPath(oldSourceFile.resolvedPath);
            if (shouldCreateNewSourceFile || !newFile || oldSourceFile.resolvedPath === oldSourceFile.path && newFile.resolvedPath !== oldSourceFile.path) {
              host.onReleaseOldSourceFile(oldSourceFile, oldProgram.getCompilerOptions(), !!getSourceFileByPath(oldSourceFile.path));
            }
          }
          if (!host.getParsedCommandLine) {
            oldProgram.forEachResolvedProjectReference(function(resolvedProjectReference) {
              if (!getResolvedProjectReferenceByPath(resolvedProjectReference.sourceFile.path)) {
                host.onReleaseOldSourceFile(resolvedProjectReference.sourceFile, oldProgram.getCompilerOptions(), false);
              }
            });
          }
        }
        if (oldProgram && host.onReleaseParsedCommandLine) {
          forEachProjectReference(oldProgram.getProjectReferences(), oldProgram.getResolvedProjectReferences(), function(oldResolvedRef, parent, index) {
            var oldReference = (parent === null || parent === void 0 ? void 0 : parent.commandLine.projectReferences[index]) || oldProgram.getProjectReferences()[index];
            var oldRefPath = resolveProjectReferencePath(oldReference);
            if (!(projectReferenceRedirects === null || projectReferenceRedirects === void 0 ? void 0 : projectReferenceRedirects.has(toPath(oldRefPath)))) {
              host.onReleaseParsedCommandLine(oldRefPath, oldResolvedRef, oldProgram.getCompilerOptions());
            }
          });
        }
        typeReferenceDirectiveResolutionCache = void 0;
        oldProgram = void 0;
        var program2 = {
          getRootFileNames: function() {
            return rootNames;
          },
          getSourceFile,
          getSourceFileByPath,
          getSourceFiles: function() {
            return files;
          },
          getMissingFilePaths: function() {
            return missingFilePaths;
          },
          getFilesByNameMap: function() {
            return filesByName;
          },
          getCompilerOptions: function() {
            return options;
          },
          getSyntacticDiagnostics,
          getOptionsDiagnostics,
          getGlobalDiagnostics,
          getSemanticDiagnostics,
          getCachedSemanticDiagnostics,
          getSuggestionDiagnostics,
          getDeclarationDiagnostics,
          getBindAndCheckDiagnostics,
          getProgramDiagnostics,
          getTypeChecker,
          getClassifiableNames,
          getDiagnosticsProducingTypeChecker,
          getCommonSourceDirectory,
          emit,
          getCurrentDirectory: function() {
            return currentDirectory;
          },
          getNodeCount: function() {
            return getDiagnosticsProducingTypeChecker().getNodeCount();
          },
          getIdentifierCount: function() {
            return getDiagnosticsProducingTypeChecker().getIdentifierCount();
          },
          getSymbolCount: function() {
            return getDiagnosticsProducingTypeChecker().getSymbolCount();
          },
          getTypeCount: function() {
            return getDiagnosticsProducingTypeChecker().getTypeCount();
          },
          getInstantiationCount: function() {
            return getDiagnosticsProducingTypeChecker().getInstantiationCount();
          },
          getRelationCacheSizes: function() {
            return getDiagnosticsProducingTypeChecker().getRelationCacheSizes();
          },
          getFileProcessingDiagnostics: function() {
            return fileProcessingDiagnostics;
          },
          getResolvedTypeReferenceDirectives: function() {
            return resolvedTypeReferenceDirectives;
          },
          isSourceFileFromExternalLibrary,
          isSourceFileDefaultLibrary,
          dropDiagnosticsProducingTypeChecker,
          getSourceFileFromReference,
          getLibFileFromReference,
          sourceFileToPackageName,
          redirectTargetsMap,
          isEmittedFile,
          getConfigFileParsingDiagnostics: getConfigFileParsingDiagnostics2,
          getResolvedModuleWithFailedLookupLocationsFromCache,
          getProjectReferences,
          getResolvedProjectReferences,
          getProjectReferenceRedirect,
          getResolvedProjectReferenceToRedirect,
          getResolvedProjectReferenceByPath,
          forEachResolvedProjectReference: forEachResolvedProjectReference2,
          isSourceOfProjectReferenceRedirect,
          emitBuildInfo,
          fileExists,
          directoryExists,
          getSymlinkCache,
          realpath: (_c = host.realpath) === null || _c === void 0 ? void 0 : _c.bind(host),
          useCaseSensitiveFileNames: function() {
            return host.useCaseSensitiveFileNames();
          },
          getFileIncludeReasons: function() {
            return fileReasons;
          },
          structureIsReused
        };
        onProgramCreateComplete();
        fileProcessingDiagnostics === null || fileProcessingDiagnostics === void 0 ? void 0 : fileProcessingDiagnostics.forEach(function(diagnostic) {
          switch (diagnostic.kind) {
            case 1:
              return programDiagnostics.add(createDiagnosticExplainingFile(diagnostic.file && getSourceFileByPath(diagnostic.file), diagnostic.fileProcessingReason, diagnostic.diagnostic, diagnostic.args || ts3.emptyArray));
            case 0:
              var _a3 = getReferencedFileLocation(getSourceFileByPath, diagnostic.reason), file = _a3.file, pos = _a3.pos, end = _a3.end;
              return programDiagnostics.add(ts3.createFileDiagnostic.apply(void 0, __spreadArray([file, ts3.Debug.checkDefined(pos), ts3.Debug.checkDefined(end) - pos, diagnostic.diagnostic], diagnostic.args || ts3.emptyArray)));
            default:
              ts3.Debug.assertNever(diagnostic);
          }
        });
        verifyCompilerOptions();
        ts3.performance.mark("afterProgram");
        ts3.performance.measure("Program", "beforeProgram", "afterProgram");
        ts3.tracing === null || ts3.tracing === void 0 ? void 0 : ts3.tracing.pop();
        return program2;
        function resolveModuleNamesWorker(moduleNames, containingFile, reusedNames) {
          if (!moduleNames.length)
            return ts3.emptyArray;
          var containingFileName = ts3.getNormalizedAbsolutePath(containingFile.originalFileName, currentDirectory);
          var redirectedReference = getRedirectReferenceForResolution(containingFile);
          ts3.tracing === null || ts3.tracing === void 0 ? void 0 : ts3.tracing.push("program", "resolveModuleNamesWorker", { containingFileName });
          ts3.performance.mark("beforeResolveModule");
          var result2 = actualResolveModuleNamesWorker(moduleNames, containingFileName, reusedNames, redirectedReference);
          ts3.performance.mark("afterResolveModule");
          ts3.performance.measure("ResolveModule", "beforeResolveModule", "afterResolveModule");
          ts3.tracing === null || ts3.tracing === void 0 ? void 0 : ts3.tracing.pop();
          return result2;
        }
        function resolveTypeReferenceDirectiveNamesWorker(typeDirectiveNames, containingFile) {
          if (!typeDirectiveNames.length)
            return [];
          var containingFileName = !ts3.isString(containingFile) ? ts3.getNormalizedAbsolutePath(containingFile.originalFileName, currentDirectory) : containingFile;
          var redirectedReference = !ts3.isString(containingFile) ? getRedirectReferenceForResolution(containingFile) : void 0;
          ts3.tracing === null || ts3.tracing === void 0 ? void 0 : ts3.tracing.push("program", "resolveTypeReferenceDirectiveNamesWorker", { containingFileName });
          ts3.performance.mark("beforeResolveTypeReference");
          var result2 = actualResolveTypeReferenceDirectiveNamesWorker(typeDirectiveNames, containingFileName, redirectedReference);
          ts3.performance.mark("afterResolveTypeReference");
          ts3.performance.measure("ResolveTypeReference", "beforeResolveTypeReference", "afterResolveTypeReference");
          ts3.tracing === null || ts3.tracing === void 0 ? void 0 : ts3.tracing.pop();
          return result2;
        }
        function getRedirectReferenceForResolution(file) {
          var redirect = getResolvedProjectReferenceToRedirect(file.originalFileName);
          if (redirect || !ts3.fileExtensionIs(file.originalFileName, ".d.ts"))
            return redirect;
          var resultFromDts = getRedirectReferenceForResolutionFromSourceOfProject(file.originalFileName, file.path);
          if (resultFromDts)
            return resultFromDts;
          if (!host.realpath || !options.preserveSymlinks || !ts3.stringContains(file.originalFileName, ts3.nodeModulesPathPart))
            return void 0;
          var realDeclarationFileName = host.realpath(file.originalFileName);
          var realDeclarationPath = toPath(realDeclarationFileName);
          return realDeclarationPath === file.path ? void 0 : getRedirectReferenceForResolutionFromSourceOfProject(realDeclarationFileName, realDeclarationPath);
        }
        function getRedirectReferenceForResolutionFromSourceOfProject(fileName, filePath) {
          var source = getSourceOfProjectReferenceRedirect(fileName);
          if (ts3.isString(source))
            return getResolvedProjectReferenceToRedirect(source);
          if (!source)
            return void 0;
          return forEachResolvedProjectReference2(function(resolvedRef) {
            var out = ts3.outFile(resolvedRef.commandLine.options);
            if (!out)
              return void 0;
            return toPath(out) === filePath ? resolvedRef : void 0;
          });
        }
        function compareDefaultLibFiles(a2, b2) {
          return ts3.compareValues(getDefaultLibFilePriority(a2), getDefaultLibFilePriority(b2));
        }
        function getDefaultLibFilePriority(a2) {
          if (ts3.containsPath(defaultLibraryPath, a2.fileName, false)) {
            var basename = ts3.getBaseFileName(a2.fileName);
            if (basename === "lib.d.ts" || basename === "lib.es6.d.ts")
              return 0;
            var name = ts3.removeSuffix(ts3.removePrefix(basename, "lib."), ".d.ts");
            var index = ts3.libs.indexOf(name);
            if (index !== -1)
              return index + 1;
          }
          return ts3.libs.length + 2;
        }
        function getResolvedModuleWithFailedLookupLocationsFromCache(moduleName, containingFile) {
          return moduleResolutionCache && ts3.resolveModuleNameFromCache(moduleName, containingFile, moduleResolutionCache);
        }
        function toPath(fileName) {
          return ts3.toPath(fileName, currentDirectory, getCanonicalFileName);
        }
        function getCommonSourceDirectory() {
          if (commonSourceDirectory === void 0) {
            var emittedFiles_1 = ts3.filter(files, function(file) {
              return ts3.sourceFileMayBeEmitted(file, program2);
            });
            commonSourceDirectory = ts3.getCommonSourceDirectory(options, function() {
              return ts3.mapDefined(emittedFiles_1, function(file) {
                return file.isDeclarationFile ? void 0 : file.fileName;
              });
            }, currentDirectory, getCanonicalFileName, function(commonSourceDirectory2) {
              return checkSourceFilesBelongToPath(emittedFiles_1, commonSourceDirectory2);
            });
          }
          return commonSourceDirectory;
        }
        function getClassifiableNames() {
          var _a3;
          if (!classifiableNames) {
            getTypeChecker();
            classifiableNames = new ts3.Set();
            for (var _i2 = 0, files_2 = files; _i2 < files_2.length; _i2++) {
              var sourceFile = files_2[_i2];
              (_a3 = sourceFile.classifiableNames) === null || _a3 === void 0 ? void 0 : _a3.forEach(function(value) {
                return classifiableNames.add(value);
              });
            }
          }
          return classifiableNames;
        }
        function resolveModuleNamesReusingOldState(moduleNames, file) {
          if (structureIsReused === 0 && !file.ambientModuleNames.length) {
            return resolveModuleNamesWorker(moduleNames, file, void 0);
          }
          var oldSourceFile2 = oldProgram && oldProgram.getSourceFile(file.fileName);
          if (oldSourceFile2 !== file && file.resolvedModules) {
            var result_15 = [];
            for (var _i2 = 0, moduleNames_1 = moduleNames; _i2 < moduleNames_1.length; _i2++) {
              var moduleName = moduleNames_1[_i2];
              var resolvedModule = file.resolvedModules.get(moduleName);
              result_15.push(resolvedModule);
            }
            return result_15;
          }
          var unknownModuleNames;
          var result2;
          var reusedNames;
          var predictedToResolveToAmbientModuleMarker = {};
          for (var i4 = 0; i4 < moduleNames.length; i4++) {
            var moduleName = moduleNames[i4];
            if (file === oldSourceFile2 && !hasInvalidatedResolution(oldSourceFile2.path)) {
              var oldResolvedModule = ts3.getResolvedModule(oldSourceFile2, moduleName);
              if (oldResolvedModule) {
                if (ts3.isTraceEnabled(options, host)) {
                  ts3.trace(host, ts3.Diagnostics.Reusing_resolution_of_module_0_to_file_1_from_old_program, moduleName, ts3.getNormalizedAbsolutePath(file.originalFileName, currentDirectory));
                }
                (result2 || (result2 = new Array(moduleNames.length)))[i4] = oldResolvedModule;
                (reusedNames || (reusedNames = [])).push(moduleName);
                continue;
              }
            }
            var resolvesToAmbientModuleInNonModifiedFile = false;
            if (ts3.contains(file.ambientModuleNames, moduleName)) {
              resolvesToAmbientModuleInNonModifiedFile = true;
              if (ts3.isTraceEnabled(options, host)) {
                ts3.trace(host, ts3.Diagnostics.Module_0_was_resolved_as_locally_declared_ambient_module_in_file_1, moduleName, ts3.getNormalizedAbsolutePath(file.originalFileName, currentDirectory));
              }
            } else {
              resolvesToAmbientModuleInNonModifiedFile = moduleNameResolvesToAmbientModuleInNonModifiedFile(moduleName);
            }
            if (resolvesToAmbientModuleInNonModifiedFile) {
              (result2 || (result2 = new Array(moduleNames.length)))[i4] = predictedToResolveToAmbientModuleMarker;
            } else {
              (unknownModuleNames || (unknownModuleNames = [])).push(moduleName);
            }
          }
          var resolutions2 = unknownModuleNames && unknownModuleNames.length ? resolveModuleNamesWorker(unknownModuleNames, file, reusedNames) : ts3.emptyArray;
          if (!result2) {
            ts3.Debug.assert(resolutions2.length === moduleNames.length);
            return resolutions2;
          }
          var j = 0;
          for (var i4 = 0; i4 < result2.length; i4++) {
            if (result2[i4]) {
              if (result2[i4] === predictedToResolveToAmbientModuleMarker) {
                result2[i4] = void 0;
              }
            } else {
              result2[i4] = resolutions2[j];
              j++;
            }
          }
          ts3.Debug.assert(j === resolutions2.length);
          return result2;
          function moduleNameResolvesToAmbientModuleInNonModifiedFile(moduleName2) {
            var resolutionToFile = ts3.getResolvedModule(oldSourceFile2, moduleName2);
            var resolvedFile = resolutionToFile && oldProgram.getSourceFile(resolutionToFile.resolvedFileName);
            if (resolutionToFile && resolvedFile) {
              return false;
            }
            var unmodifiedFile = ambientModuleNameToUnmodifiedFileName.get(moduleName2);
            if (!unmodifiedFile) {
              return false;
            }
            if (ts3.isTraceEnabled(options, host)) {
              ts3.trace(host, ts3.Diagnostics.Module_0_was_resolved_as_ambient_module_declared_in_1_since_this_file_was_not_modified, moduleName2, unmodifiedFile);
            }
            return true;
          }
        }
        function canReuseProjectReferences() {
          return !forEachProjectReference(oldProgram.getProjectReferences(), oldProgram.getResolvedProjectReferences(), function(oldResolvedRef, parent, index) {
            var newRef = (parent ? parent.commandLine.projectReferences : projectReferences)[index];
            var newResolvedRef = parseProjectReferenceConfigFile(newRef);
            if (oldResolvedRef) {
              return !newResolvedRef || newResolvedRef.sourceFile !== oldResolvedRef.sourceFile || !ts3.arrayIsEqualTo(oldResolvedRef.commandLine.fileNames, newResolvedRef.commandLine.fileNames);
            } else {
              return newResolvedRef !== void 0;
            }
          }, function(oldProjectReferences, parent) {
            var newReferences = parent ? getResolvedProjectReferenceByPath(parent.sourceFile.path).commandLine.projectReferences : projectReferences;
            return !ts3.arrayIsEqualTo(oldProjectReferences, newReferences, ts3.projectReferenceIsEqualTo);
          });
        }
        function tryReuseStructureFromOldProgram() {
          var _a3;
          if (!oldProgram) {
            return 0;
          }
          var oldOptions = oldProgram.getCompilerOptions();
          if (ts3.changesAffectModuleResolution(oldOptions, options)) {
            return 0;
          }
          var oldRootNames = oldProgram.getRootFileNames();
          if (!ts3.arrayIsEqualTo(oldRootNames, rootNames)) {
            return 0;
          }
          if (!ts3.arrayIsEqualTo(options.types, oldOptions.types)) {
            return 0;
          }
          if (!canReuseProjectReferences()) {
            return 0;
          }
          if (projectReferences) {
            resolvedProjectReferences = projectReferences.map(parseProjectReferenceConfigFile);
          }
          var newSourceFiles = [];
          var modifiedSourceFiles = [];
          structureIsReused = 2;
          if (oldProgram.getMissingFilePaths().some(function(missingFilePath) {
            return host.fileExists(missingFilePath);
          })) {
            return 0;
          }
          var oldSourceFiles2 = oldProgram.getSourceFiles();
          var SeenPackageName;
          (function(SeenPackageName2) {
            SeenPackageName2[SeenPackageName2["Exists"] = 0] = "Exists";
            SeenPackageName2[SeenPackageName2["Modified"] = 1] = "Modified";
          })(SeenPackageName || (SeenPackageName = {}));
          var seenPackageNames = new ts3.Map();
          for (var _i2 = 0, oldSourceFiles_2 = oldSourceFiles2; _i2 < oldSourceFiles_2.length; _i2++) {
            var oldSourceFile2 = oldSourceFiles_2[_i2];
            var newSourceFile = host.getSourceFileByPath ? host.getSourceFileByPath(oldSourceFile2.fileName, oldSourceFile2.resolvedPath, options.target, void 0, shouldCreateNewSourceFile) : host.getSourceFile(oldSourceFile2.fileName, options.target, void 0, shouldCreateNewSourceFile);
            if (!newSourceFile) {
              return 0;
            }
            ts3.Debug.assert(!newSourceFile.redirectInfo, "Host should not return a redirect source file from `getSourceFile`");
            var fileChanged = void 0;
            if (oldSourceFile2.redirectInfo) {
              if (newSourceFile !== oldSourceFile2.redirectInfo.unredirected) {
                return 0;
              }
              fileChanged = false;
              newSourceFile = oldSourceFile2;
            } else if (oldProgram.redirectTargetsMap.has(oldSourceFile2.path)) {
              if (newSourceFile !== oldSourceFile2) {
                return 0;
              }
              fileChanged = false;
            } else {
              fileChanged = newSourceFile !== oldSourceFile2;
            }
            newSourceFile.path = oldSourceFile2.path;
            newSourceFile.originalFileName = oldSourceFile2.originalFileName;
            newSourceFile.resolvedPath = oldSourceFile2.resolvedPath;
            newSourceFile.fileName = oldSourceFile2.fileName;
            var packageName = oldProgram.sourceFileToPackageName.get(oldSourceFile2.path);
            if (packageName !== void 0) {
              var prevKind = seenPackageNames.get(packageName);
              var newKind = fileChanged ? 1 : 0;
              if (prevKind !== void 0 && newKind === 1 || prevKind === 1) {
                return 0;
              }
              seenPackageNames.set(packageName, newKind);
            }
            if (fileChanged) {
              if (!ts3.arrayIsEqualTo(oldSourceFile2.libReferenceDirectives, newSourceFile.libReferenceDirectives, fileReferenceIsEqualTo)) {
                return 0;
              }
              if (oldSourceFile2.hasNoDefaultLib !== newSourceFile.hasNoDefaultLib) {
                structureIsReused = 1;
              }
              if (!ts3.arrayIsEqualTo(oldSourceFile2.referencedFiles, newSourceFile.referencedFiles, fileReferenceIsEqualTo)) {
                structureIsReused = 1;
              }
              collectExternalModuleReferences(newSourceFile);
              if (!ts3.arrayIsEqualTo(oldSourceFile2.imports, newSourceFile.imports, moduleNameIsEqualTo)) {
                structureIsReused = 1;
              }
              if (!ts3.arrayIsEqualTo(oldSourceFile2.moduleAugmentations, newSourceFile.moduleAugmentations, moduleNameIsEqualTo)) {
                structureIsReused = 1;
              }
              if ((oldSourceFile2.flags & 3145728) !== (newSourceFile.flags & 3145728)) {
                structureIsReused = 1;
              }
              if (!ts3.arrayIsEqualTo(oldSourceFile2.typeReferenceDirectives, newSourceFile.typeReferenceDirectives, fileReferenceIsEqualTo)) {
                structureIsReused = 1;
              }
              modifiedSourceFiles.push({ oldFile: oldSourceFile2, newFile: newSourceFile });
            } else if (hasInvalidatedResolution(oldSourceFile2.path)) {
              structureIsReused = 1;
              modifiedSourceFiles.push({ oldFile: oldSourceFile2, newFile: newSourceFile });
            }
            newSourceFiles.push(newSourceFile);
          }
          if (structureIsReused !== 2) {
            return structureIsReused;
          }
          var modifiedFiles = modifiedSourceFiles.map(function(f) {
            return f.oldFile;
          });
          for (var _b2 = 0, oldSourceFiles_3 = oldSourceFiles2; _b2 < oldSourceFiles_3.length; _b2++) {
            var oldFile = oldSourceFiles_3[_b2];
            if (!ts3.contains(modifiedFiles, oldFile)) {
              for (var _c2 = 0, _d2 = oldFile.ambientModuleNames; _c2 < _d2.length; _c2++) {
                var moduleName = _d2[_c2];
                ambientModuleNameToUnmodifiedFileName.set(moduleName, oldFile.fileName);
              }
            }
          }
          for (var _e = 0, modifiedSourceFiles_1 = modifiedSourceFiles; _e < modifiedSourceFiles_1.length; _e++) {
            var _f = modifiedSourceFiles_1[_e], oldSourceFile2 = _f.oldFile, newSourceFile = _f.newFile;
            var moduleNames = getModuleNames(newSourceFile);
            var resolutions2 = resolveModuleNamesReusingOldState(moduleNames, newSourceFile);
            var resolutionsChanged = ts3.hasChangesInResolutions(moduleNames, resolutions2, oldSourceFile2.resolvedModules, ts3.moduleResolutionIsEqualTo);
            if (resolutionsChanged) {
              structureIsReused = 1;
              newSourceFile.resolvedModules = ts3.zipToMap(moduleNames, resolutions2);
            } else {
              newSourceFile.resolvedModules = oldSourceFile2.resolvedModules;
            }
            var typesReferenceDirectives = ts3.map(newSourceFile.typeReferenceDirectives, function(ref2) {
              return ts3.toFileNameLowerCase(ref2.fileName);
            });
            var typeReferenceResolutions = resolveTypeReferenceDirectiveNamesWorker(typesReferenceDirectives, newSourceFile);
            var typeReferenceEesolutionsChanged = ts3.hasChangesInResolutions(typesReferenceDirectives, typeReferenceResolutions, oldSourceFile2.resolvedTypeReferenceDirectiveNames, ts3.typeDirectiveIsEqualTo);
            if (typeReferenceEesolutionsChanged) {
              structureIsReused = 1;
              newSourceFile.resolvedTypeReferenceDirectiveNames = ts3.zipToMap(typesReferenceDirectives, typeReferenceResolutions);
            } else {
              newSourceFile.resolvedTypeReferenceDirectiveNames = oldSourceFile2.resolvedTypeReferenceDirectiveNames;
            }
          }
          if (structureIsReused !== 2) {
            return structureIsReused;
          }
          if ((_a3 = host.hasChangedAutomaticTypeDirectiveNames) === null || _a3 === void 0 ? void 0 : _a3.call(host)) {
            return 1;
          }
          missingFilePaths = oldProgram.getMissingFilePaths();
          ts3.Debug.assert(newSourceFiles.length === oldProgram.getSourceFiles().length);
          for (var _g = 0, newSourceFiles_1 = newSourceFiles; _g < newSourceFiles_1.length; _g++) {
            var newSourceFile = newSourceFiles_1[_g];
            filesByName.set(newSourceFile.path, newSourceFile);
          }
          var oldFilesByNameMap = oldProgram.getFilesByNameMap();
          oldFilesByNameMap.forEach(function(oldFile2, path2) {
            if (!oldFile2) {
              filesByName.set(path2, oldFile2);
              return;
            }
            if (oldFile2.path === path2) {
              if (oldProgram.isSourceFileFromExternalLibrary(oldFile2)) {
                sourceFilesFoundSearchingNodeModules.set(oldFile2.path, true);
              }
              return;
            }
            filesByName.set(path2, filesByName.get(oldFile2.path));
          });
          files = newSourceFiles;
          fileReasons = oldProgram.getFileIncludeReasons();
          fileProcessingDiagnostics = oldProgram.getFileProcessingDiagnostics();
          resolvedTypeReferenceDirectives = oldProgram.getResolvedTypeReferenceDirectives();
          sourceFileToPackageName = oldProgram.sourceFileToPackageName;
          redirectTargetsMap = oldProgram.redirectTargetsMap;
          return 2;
        }
        function getEmitHost(writeFileCallback) {
          return {
            getPrependNodes,
            getCanonicalFileName,
            getCommonSourceDirectory: program2.getCommonSourceDirectory,
            getCompilerOptions: program2.getCompilerOptions,
            getCurrentDirectory: function() {
              return currentDirectory;
            },
            getNewLine: function() {
              return host.getNewLine();
            },
            getSourceFile: program2.getSourceFile,
            getSourceFileByPath: program2.getSourceFileByPath,
            getSourceFiles: program2.getSourceFiles,
            getLibFileFromReference: program2.getLibFileFromReference,
            isSourceFileFromExternalLibrary,
            getResolvedProjectReferenceToRedirect,
            getProjectReferenceRedirect,
            isSourceOfProjectReferenceRedirect,
            getSymlinkCache,
            writeFile: writeFileCallback || function(fileName, data, writeByteOrderMark, onError, sourceFiles) {
              return host.writeFile(fileName, data, writeByteOrderMark, onError, sourceFiles);
            },
            isEmitBlocked,
            readFile: function(f) {
              return host.readFile(f);
            },
            fileExists: function(f) {
              var path2 = toPath(f);
              if (getSourceFileByPath(path2))
                return true;
              if (ts3.contains(missingFilePaths, path2))
                return false;
              return host.fileExists(f);
            },
            useCaseSensitiveFileNames: function() {
              return host.useCaseSensitiveFileNames();
            },
            getProgramBuildInfo: function() {
              return program2.getProgramBuildInfo && program2.getProgramBuildInfo();
            },
            getSourceFileFromReference: function(file, ref2) {
              return program2.getSourceFileFromReference(file, ref2);
            },
            redirectTargetsMap,
            getFileIncludeReasons: program2.getFileIncludeReasons
          };
        }
        function emitBuildInfo(writeFileCallback) {
          ts3.Debug.assert(!ts3.outFile(options));
          ts3.tracing === null || ts3.tracing === void 0 ? void 0 : ts3.tracing.push("emit", "emitBuildInfo", {}, true);
          ts3.performance.mark("beforeEmit");
          var emitResult = ts3.emitFiles(ts3.notImplementedResolver, getEmitHost(writeFileCallback), void 0, ts3.noTransformers, false, true);
          ts3.performance.mark("afterEmit");
          ts3.performance.measure("Emit", "beforeEmit", "afterEmit");
          ts3.tracing === null || ts3.tracing === void 0 ? void 0 : ts3.tracing.pop();
          return emitResult;
        }
        function getResolvedProjectReferences() {
          return resolvedProjectReferences;
        }
        function getProjectReferences() {
          return projectReferences;
        }
        function getPrependNodes() {
          return createPrependNodes(projectReferences, function(_ref, index) {
            var _a3;
            return (_a3 = resolvedProjectReferences[index]) === null || _a3 === void 0 ? void 0 : _a3.commandLine;
          }, function(fileName) {
            var path2 = toPath(fileName);
            var sourceFile = getSourceFileByPath(path2);
            return sourceFile ? sourceFile.text : filesByName.has(path2) ? void 0 : host.readFile(path2);
          });
        }
        function isSourceFileFromExternalLibrary(file) {
          return !!sourceFilesFoundSearchingNodeModules.get(file.path);
        }
        function isSourceFileDefaultLibrary(file) {
          if (file.hasNoDefaultLib) {
            return true;
          }
          if (!options.noLib) {
            return false;
          }
          var equalityComparer = host.useCaseSensitiveFileNames() ? ts3.equateStringsCaseSensitive : ts3.equateStringsCaseInsensitive;
          if (!options.lib) {
            return equalityComparer(file.fileName, getDefaultLibraryFileName());
          } else {
            return ts3.some(options.lib, function(libFileName) {
              return equalityComparer(file.fileName, ts3.combinePaths(defaultLibraryPath, libFileName));
            });
          }
        }
        function getDiagnosticsProducingTypeChecker() {
          return diagnosticsProducingTypeChecker || (diagnosticsProducingTypeChecker = ts3.createTypeChecker(program2, true));
        }
        function dropDiagnosticsProducingTypeChecker() {
          diagnosticsProducingTypeChecker = void 0;
        }
        function getTypeChecker() {
          return noDiagnosticsTypeChecker || (noDiagnosticsTypeChecker = ts3.createTypeChecker(program2, false));
        }
        function emit(sourceFile, writeFileCallback, cancellationToken, emitOnlyDtsFiles, transformers, forceDtsEmit) {
          ts3.tracing === null || ts3.tracing === void 0 ? void 0 : ts3.tracing.push("emit", "emit", { path: sourceFile === null || sourceFile === void 0 ? void 0 : sourceFile.path }, true);
          var result2 = runWithCancellationToken(function() {
            return emitWorker(program2, sourceFile, writeFileCallback, cancellationToken, emitOnlyDtsFiles, transformers, forceDtsEmit);
          });
          ts3.tracing === null || ts3.tracing === void 0 ? void 0 : ts3.tracing.pop();
          return result2;
        }
        function isEmitBlocked(emitFileName) {
          return hasEmitBlockingDiagnostics.has(toPath(emitFileName));
        }
        function emitWorker(program3, sourceFile, writeFileCallback, cancellationToken, emitOnlyDtsFiles, customTransformers, forceDtsEmit) {
          if (!forceDtsEmit) {
            var result2 = handleNoEmitOptions(program3, sourceFile, writeFileCallback, cancellationToken);
            if (result2)
              return result2;
          }
          var emitResolver = getDiagnosticsProducingTypeChecker().getEmitResolver(ts3.outFile(options) ? void 0 : sourceFile, cancellationToken);
          ts3.performance.mark("beforeEmit");
          var emitResult = ts3.emitFiles(emitResolver, getEmitHost(writeFileCallback), sourceFile, ts3.getTransformers(options, customTransformers, emitOnlyDtsFiles), emitOnlyDtsFiles, false, forceDtsEmit);
          ts3.performance.mark("afterEmit");
          ts3.performance.measure("Emit", "beforeEmit", "afterEmit");
          return emitResult;
        }
        function getSourceFile(fileName) {
          return getSourceFileByPath(toPath(fileName));
        }
        function getSourceFileByPath(path2) {
          return filesByName.get(path2) || void 0;
        }
        function getDiagnosticsHelper(sourceFile, getDiagnostics, cancellationToken) {
          if (sourceFile) {
            return getDiagnostics(sourceFile, cancellationToken);
          }
          return ts3.sortAndDeduplicateDiagnostics(ts3.flatMap(program2.getSourceFiles(), function(sourceFile2) {
            if (cancellationToken) {
              cancellationToken.throwIfCancellationRequested();
            }
            return getDiagnostics(sourceFile2, cancellationToken);
          }));
        }
        function getSyntacticDiagnostics(sourceFile, cancellationToken) {
          return getDiagnosticsHelper(sourceFile, getSyntacticDiagnosticsForFile, cancellationToken);
        }
        function getSemanticDiagnostics(sourceFile, cancellationToken) {
          return getDiagnosticsHelper(sourceFile, getSemanticDiagnosticsForFile, cancellationToken);
        }
        function getCachedSemanticDiagnostics(sourceFile) {
          var _a3;
          return sourceFile ? (_a3 = cachedBindAndCheckDiagnosticsForFile.perFile) === null || _a3 === void 0 ? void 0 : _a3.get(sourceFile.path) : cachedBindAndCheckDiagnosticsForFile.allDiagnostics;
        }
        function getBindAndCheckDiagnostics(sourceFile, cancellationToken) {
          return getBindAndCheckDiagnosticsForFile(sourceFile, cancellationToken);
        }
        function getProgramDiagnostics(sourceFile) {
          var _a3;
          if (ts3.skipTypeChecking(sourceFile, options, program2)) {
            return ts3.emptyArray;
          }
          var programDiagnosticsInFile = programDiagnostics.getDiagnostics(sourceFile.fileName);
          if (!((_a3 = sourceFile.commentDirectives) === null || _a3 === void 0 ? void 0 : _a3.length)) {
            return programDiagnosticsInFile;
          }
          return getDiagnosticsWithPrecedingDirectives(sourceFile, sourceFile.commentDirectives, programDiagnosticsInFile).diagnostics;
        }
        function getDeclarationDiagnostics(sourceFile, cancellationToken) {
          var options2 = program2.getCompilerOptions();
          if (!sourceFile || ts3.outFile(options2)) {
            return getDeclarationDiagnosticsWorker(sourceFile, cancellationToken);
          } else {
            return getDiagnosticsHelper(sourceFile, getDeclarationDiagnosticsForFile, cancellationToken);
          }
        }
        function getSyntacticDiagnosticsForFile(sourceFile) {
          if (ts3.isSourceFileJS(sourceFile)) {
            if (!sourceFile.additionalSyntacticDiagnostics) {
              sourceFile.additionalSyntacticDiagnostics = getJSSyntacticDiagnosticsForFile(sourceFile);
            }
            return ts3.concatenate(sourceFile.additionalSyntacticDiagnostics, sourceFile.parseDiagnostics);
          }
          return sourceFile.parseDiagnostics;
        }
        function runWithCancellationToken(func2) {
          try {
            return func2();
          } catch (e2) {
            if (e2 instanceof ts3.OperationCanceledException) {
              noDiagnosticsTypeChecker = void 0;
              diagnosticsProducingTypeChecker = void 0;
            }
            throw e2;
          }
        }
        function getSemanticDiagnosticsForFile(sourceFile, cancellationToken) {
          return ts3.concatenate(filterSemanticDiagnotics(getBindAndCheckDiagnosticsForFile(sourceFile, cancellationToken), options), getProgramDiagnostics(sourceFile));
        }
        function getBindAndCheckDiagnosticsForFile(sourceFile, cancellationToken) {
          return getAndCacheDiagnostics(sourceFile, cancellationToken, cachedBindAndCheckDiagnosticsForFile, getBindAndCheckDiagnosticsForFileNoCache);
        }
        function getBindAndCheckDiagnosticsForFileNoCache(sourceFile, cancellationToken) {
          return runWithCancellationToken(function() {
            if (ts3.skipTypeChecking(sourceFile, options, program2)) {
              return ts3.emptyArray;
            }
            var typeChecker = getDiagnosticsProducingTypeChecker();
            ts3.Debug.assert(!!sourceFile.bindDiagnostics);
            var isCheckJs = ts3.isCheckJsEnabledForFile(sourceFile, options);
            var isTsNoCheck = !!sourceFile.checkJsDirective && sourceFile.checkJsDirective.enabled === false;
            var includeBindAndCheckDiagnostics = !isTsNoCheck && (sourceFile.scriptKind === 3 || sourceFile.scriptKind === 4 || sourceFile.scriptKind === 5 || isCheckJs || sourceFile.scriptKind === 7);
            var bindDiagnostics = includeBindAndCheckDiagnostics ? sourceFile.bindDiagnostics : ts3.emptyArray;
            var checkDiagnostics = includeBindAndCheckDiagnostics ? typeChecker.getDiagnostics(sourceFile, cancellationToken) : ts3.emptyArray;
            return getMergedBindAndCheckDiagnostics(sourceFile, includeBindAndCheckDiagnostics, bindDiagnostics, checkDiagnostics, isCheckJs ? sourceFile.jsDocDiagnostics : void 0);
          });
        }
        function getMergedBindAndCheckDiagnostics(sourceFile, includeBindAndCheckDiagnostics) {
          var _a3;
          var allDiagnostics = [];
          for (var _i2 = 2; _i2 < arguments.length; _i2++) {
            allDiagnostics[_i2 - 2] = arguments[_i2];
          }
          var flatDiagnostics = ts3.flatten(allDiagnostics);
          if (!includeBindAndCheckDiagnostics || !((_a3 = sourceFile.commentDirectives) === null || _a3 === void 0 ? void 0 : _a3.length)) {
            return flatDiagnostics;
          }
          var _b2 = getDiagnosticsWithPrecedingDirectives(sourceFile, sourceFile.commentDirectives, flatDiagnostics), diagnostics = _b2.diagnostics, directives = _b2.directives;
          for (var _c2 = 0, _d2 = directives.getUnusedExpectations(); _c2 < _d2.length; _c2++) {
            var errorExpectation = _d2[_c2];
            diagnostics.push(ts3.createDiagnosticForRange(sourceFile, errorExpectation.range, ts3.Diagnostics.Unused_ts_expect_error_directive));
          }
          return diagnostics;
        }
        function getDiagnosticsWithPrecedingDirectives(sourceFile, commentDirectives, flatDiagnostics) {
          var directives = ts3.createCommentDirectivesMap(sourceFile, commentDirectives);
          var diagnostics = flatDiagnostics.filter(function(diagnostic) {
            return markPrecedingCommentDirectiveLine(diagnostic, directives) === -1;
          });
          return { diagnostics, directives };
        }
        function getSuggestionDiagnostics(sourceFile, cancellationToken) {
          return runWithCancellationToken(function() {
            return getDiagnosticsProducingTypeChecker().getSuggestionDiagnostics(sourceFile, cancellationToken);
          });
        }
        function markPrecedingCommentDirectiveLine(diagnostic, directives) {
          var file = diagnostic.file, start = diagnostic.start;
          if (!file) {
            return -1;
          }
          var lineStarts = ts3.getLineStarts(file);
          var line = ts3.computeLineAndCharacterOfPosition(lineStarts, start).line - 1;
          while (line >= 0) {
            if (directives.markUsed(line)) {
              return line;
            }
            var lineText = file.text.slice(lineStarts[line], lineStarts[line + 1]).trim();
            if (lineText !== "" && !/^(\s*)\/\/(.*)$/.test(lineText)) {
              return -1;
            }
            line--;
          }
          return -1;
        }
        function getJSSyntacticDiagnosticsForFile(sourceFile) {
          return runWithCancellationToken(function() {
            var diagnostics = [];
            walk(sourceFile, sourceFile);
            ts3.forEachChildRecursively(sourceFile, walk, walkArray);
            return diagnostics;
            function walk(node, parent) {
              switch (parent.kind) {
                case 161:
                case 164:
                case 166:
                  if (parent.questionToken === node) {
                    diagnostics.push(createDiagnosticForNode(node, ts3.Diagnostics.The_0_modifier_can_only_be_used_in_TypeScript_files, "?"));
                    return "skip";
                  }
                case 165:
                case 167:
                case 168:
                case 169:
                case 209:
                case 252:
                case 210:
                case 250:
                  if (parent.type === node) {
                    diagnostics.push(createDiagnosticForNode(node, ts3.Diagnostics.Type_annotations_can_only_be_used_in_TypeScript_files));
                    return "skip";
                  }
              }
              switch (node.kind) {
                case 263:
                  if (node.isTypeOnly) {
                    diagnostics.push(createDiagnosticForNode(parent, ts3.Diagnostics._0_declarations_can_only_be_used_in_TypeScript_files, "import type"));
                    return "skip";
                  }
                  break;
                case 268:
                  if (node.isTypeOnly) {
                    diagnostics.push(createDiagnosticForNode(node, ts3.Diagnostics._0_declarations_can_only_be_used_in_TypeScript_files, "export type"));
                    return "skip";
                  }
                  break;
                case 261:
                  diagnostics.push(createDiagnosticForNode(node, ts3.Diagnostics.import_can_only_be_used_in_TypeScript_files));
                  return "skip";
                case 267:
                  if (node.isExportEquals) {
                    diagnostics.push(createDiagnosticForNode(node, ts3.Diagnostics.export_can_only_be_used_in_TypeScript_files));
                    return "skip";
                  }
                  break;
                case 287:
                  var heritageClause = node;
                  if (heritageClause.token === 116) {
                    diagnostics.push(createDiagnosticForNode(node, ts3.Diagnostics.implements_clauses_can_only_be_used_in_TypeScript_files));
                    return "skip";
                  }
                  break;
                case 254:
                  var interfaceKeyword = ts3.tokenToString(117);
                  ts3.Debug.assertIsDefined(interfaceKeyword);
                  diagnostics.push(createDiagnosticForNode(node, ts3.Diagnostics._0_declarations_can_only_be_used_in_TypeScript_files, interfaceKeyword));
                  return "skip";
                case 257:
                  var moduleKeyword = node.flags & 16 ? ts3.tokenToString(140) : ts3.tokenToString(139);
                  ts3.Debug.assertIsDefined(moduleKeyword);
                  diagnostics.push(createDiagnosticForNode(node, ts3.Diagnostics._0_declarations_can_only_be_used_in_TypeScript_files, moduleKeyword));
                  return "skip";
                case 255:
                  diagnostics.push(createDiagnosticForNode(node, ts3.Diagnostics.Type_aliases_can_only_be_used_in_TypeScript_files));
                  return "skip";
                case 256:
                  var enumKeyword = ts3.Debug.checkDefined(ts3.tokenToString(91));
                  diagnostics.push(createDiagnosticForNode(node, ts3.Diagnostics._0_declarations_can_only_be_used_in_TypeScript_files, enumKeyword));
                  return "skip";
                case 226:
                  diagnostics.push(createDiagnosticForNode(node, ts3.Diagnostics.Non_null_assertions_can_only_be_used_in_TypeScript_files));
                  return "skip";
                case 225:
                  diagnostics.push(createDiagnosticForNode(node.type, ts3.Diagnostics.Type_assertion_expressions_can_only_be_used_in_TypeScript_files));
                  return "skip";
                case 207:
                  ts3.Debug.fail();
              }
            }
            function walkArray(nodes, parent) {
              if (parent.decorators === nodes && !options.experimentalDecorators) {
                diagnostics.push(createDiagnosticForNode(parent, ts3.Diagnostics.Experimental_support_for_decorators_is_a_feature_that_is_subject_to_change_in_a_future_release_Set_the_experimentalDecorators_option_in_your_tsconfig_or_jsconfig_to_remove_this_warning));
              }
              switch (parent.kind) {
                case 253:
                case 222:
                case 166:
                case 167:
                case 168:
                case 169:
                case 209:
                case 252:
                case 210:
                  if (nodes === parent.typeParameters) {
                    diagnostics.push(createDiagnosticForNodeArray(nodes, ts3.Diagnostics.Type_parameter_declarations_can_only_be_used_in_TypeScript_files));
                    return "skip";
                  }
                case 233:
                  if (nodes === parent.modifiers) {
                    checkModifiers(parent.modifiers, parent.kind === 233);
                    return "skip";
                  }
                  break;
                case 164:
                  if (nodes === parent.modifiers) {
                    for (var _i2 = 0, _a3 = nodes; _i2 < _a3.length; _i2++) {
                      var modifier = _a3[_i2];
                      if (modifier.kind !== 123) {
                        diagnostics.push(createDiagnosticForNode(modifier, ts3.Diagnostics.The_0_modifier_can_only_be_used_in_TypeScript_files, ts3.tokenToString(modifier.kind)));
                      }
                    }
                    return "skip";
                  }
                  break;
                case 161:
                  if (nodes === parent.modifiers) {
                    diagnostics.push(createDiagnosticForNodeArray(nodes, ts3.Diagnostics.Parameter_modifiers_can_only_be_used_in_TypeScript_files));
                    return "skip";
                  }
                  break;
                case 204:
                case 205:
                case 224:
                case 275:
                case 276:
                case 206:
                  if (nodes === parent.typeArguments) {
                    diagnostics.push(createDiagnosticForNodeArray(nodes, ts3.Diagnostics.Type_arguments_can_only_be_used_in_TypeScript_files));
                    return "skip";
                  }
                  break;
              }
            }
            function checkModifiers(modifiers, isConstValid) {
              for (var _i2 = 0, modifiers_2 = modifiers; _i2 < modifiers_2.length; _i2++) {
                var modifier = modifiers_2[_i2];
                switch (modifier.kind) {
                  case 84:
                    if (isConstValid) {
                      continue;
                    }
                  case 122:
                  case 120:
                  case 121:
                  case 142:
                  case 133:
                  case 125:
                  case 156:
                    diagnostics.push(createDiagnosticForNode(modifier, ts3.Diagnostics.The_0_modifier_can_only_be_used_in_TypeScript_files, ts3.tokenToString(modifier.kind)));
                    break;
                  case 123:
                  case 92:
                  case 87:
                }
              }
            }
            function createDiagnosticForNodeArray(nodes, message, arg0, arg1, arg2) {
              var start = nodes.pos;
              return ts3.createFileDiagnostic(sourceFile, start, nodes.end - start, message, arg0, arg1, arg2);
            }
            function createDiagnosticForNode(node, message, arg0, arg1, arg2) {
              return ts3.createDiagnosticForNodeInSourceFile(sourceFile, node, message, arg0, arg1, arg2);
            }
          });
        }
        function getDeclarationDiagnosticsWorker(sourceFile, cancellationToken) {
          return getAndCacheDiagnostics(sourceFile, cancellationToken, cachedDeclarationDiagnosticsForFile, getDeclarationDiagnosticsForFileNoCache);
        }
        function getDeclarationDiagnosticsForFileNoCache(sourceFile, cancellationToken) {
          return runWithCancellationToken(function() {
            var resolver = getDiagnosticsProducingTypeChecker().getEmitResolver(sourceFile, cancellationToken);
            return ts3.getDeclarationDiagnostics(getEmitHost(ts3.noop), resolver, sourceFile) || ts3.emptyArray;
          });
        }
        function getAndCacheDiagnostics(sourceFile, cancellationToken, cache, getDiagnostics) {
          var _a3;
          var cachedResult = sourceFile ? (_a3 = cache.perFile) === null || _a3 === void 0 ? void 0 : _a3.get(sourceFile.path) : cache.allDiagnostics;
          if (cachedResult) {
            return cachedResult;
          }
          var result2 = getDiagnostics(sourceFile, cancellationToken);
          if (sourceFile) {
            (cache.perFile || (cache.perFile = new ts3.Map())).set(sourceFile.path, result2);
          } else {
            cache.allDiagnostics = result2;
          }
          return result2;
        }
        function getDeclarationDiagnosticsForFile(sourceFile, cancellationToken) {
          return sourceFile.isDeclarationFile ? [] : getDeclarationDiagnosticsWorker(sourceFile, cancellationToken);
        }
        function getOptionsDiagnostics() {
          return ts3.sortAndDeduplicateDiagnostics(ts3.concatenate(programDiagnostics.getGlobalDiagnostics(), getOptionsDiagnosticsOfConfigFile()));
        }
        function getOptionsDiagnosticsOfConfigFile() {
          if (!options.configFile) {
            return ts3.emptyArray;
          }
          var diagnostics = programDiagnostics.getDiagnostics(options.configFile.fileName);
          forEachResolvedProjectReference2(function(resolvedRef) {
            diagnostics = ts3.concatenate(diagnostics, programDiagnostics.getDiagnostics(resolvedRef.sourceFile.fileName));
          });
          return diagnostics;
        }
        function getGlobalDiagnostics() {
          return rootNames.length ? ts3.sortAndDeduplicateDiagnostics(getDiagnosticsProducingTypeChecker().getGlobalDiagnostics().slice()) : ts3.emptyArray;
        }
        function getConfigFileParsingDiagnostics2() {
          return configFileParsingDiagnostics || ts3.emptyArray;
        }
        function processRootFile(fileName, isDefaultLib, ignoreNoDefaultLib, reason) {
          processSourceFile(ts3.normalizePath(fileName), isDefaultLib, ignoreNoDefaultLib, void 0, reason);
        }
        function fileReferenceIsEqualTo(a2, b2) {
          return a2.fileName === b2.fileName;
        }
        function moduleNameIsEqualTo(a2, b2) {
          return a2.kind === 78 ? b2.kind === 78 && a2.escapedText === b2.escapedText : b2.kind === 10 && a2.text === b2.text;
        }
        function createSyntheticImport(text, file) {
          var externalHelpersModuleReference = ts3.factory.createStringLiteral(text);
          var importDecl = ts3.factory.createImportDeclaration(void 0, void 0, void 0, externalHelpersModuleReference);
          ts3.addEmitFlags(importDecl, 67108864);
          ts3.setParent(externalHelpersModuleReference, importDecl);
          ts3.setParent(importDecl, file);
          externalHelpersModuleReference.flags &= ~8;
          importDecl.flags &= ~8;
          return externalHelpersModuleReference;
        }
        function collectExternalModuleReferences(file) {
          if (file.imports) {
            return;
          }
          var isJavaScriptFile = ts3.isSourceFileJS(file);
          var isExternalModuleFile = ts3.isExternalModule(file);
          var imports;
          var moduleAugmentations;
          var ambientModules;
          if ((options.isolatedModules || isExternalModuleFile) && !file.isDeclarationFile) {
            if (options.importHelpers) {
              imports = [createSyntheticImport(ts3.externalHelpersModuleNameText, file)];
            }
            var jsxImport = ts3.getJSXRuntimeImport(ts3.getJSXImplicitImportBase(options, file), options);
            if (jsxImport) {
              (imports || (imports = [])).push(createSyntheticImport(jsxImport, file));
            }
          }
          for (var _i2 = 0, _a3 = file.statements; _i2 < _a3.length; _i2++) {
            var node = _a3[_i2];
            collectModuleReferences(node, false);
          }
          if (file.flags & 1048576 || isJavaScriptFile) {
            collectDynamicImportOrRequireCalls(file);
          }
          file.imports = imports || ts3.emptyArray;
          file.moduleAugmentations = moduleAugmentations || ts3.emptyArray;
          file.ambientModuleNames = ambientModules || ts3.emptyArray;
          return;
          function collectModuleReferences(node2, inAmbientModule) {
            if (ts3.isAnyImportOrReExport(node2)) {
              var moduleNameExpr = ts3.getExternalModuleName(node2);
              if (moduleNameExpr && ts3.isStringLiteral(moduleNameExpr) && moduleNameExpr.text && (!inAmbientModule || !ts3.isExternalModuleNameRelative(moduleNameExpr.text))) {
                imports = ts3.append(imports, moduleNameExpr);
              }
            } else if (ts3.isModuleDeclaration(node2)) {
              if (ts3.isAmbientModule(node2) && (inAmbientModule || ts3.hasSyntacticModifier(node2, 2) || file.isDeclarationFile)) {
                var nameText = ts3.getTextOfIdentifierOrLiteral(node2.name);
                if (isExternalModuleFile || inAmbientModule && !ts3.isExternalModuleNameRelative(nameText)) {
                  (moduleAugmentations || (moduleAugmentations = [])).push(node2.name);
                } else if (!inAmbientModule) {
                  if (file.isDeclarationFile) {
                    (ambientModules || (ambientModules = [])).push(nameText);
                  }
                  var body = node2.body;
                  if (body) {
                    for (var _i3 = 0, _a4 = body.statements; _i3 < _a4.length; _i3++) {
                      var statement = _a4[_i3];
                      collectModuleReferences(statement, true);
                    }
                  }
                }
              }
            }
          }
          function collectDynamicImportOrRequireCalls(file2) {
            var r2 = /import|require/g;
            while (r2.exec(file2.text) !== null) {
              var node2 = getNodeAtPosition(file2, r2.lastIndex);
              if (isJavaScriptFile && ts3.isRequireCall(node2, true)) {
                imports = ts3.append(imports, node2.arguments[0]);
              } else if (ts3.isImportCall(node2) && node2.arguments.length === 1 && ts3.isStringLiteralLike(node2.arguments[0])) {
                imports = ts3.append(imports, node2.arguments[0]);
              } else if (ts3.isLiteralImportTypeNode(node2)) {
                imports = ts3.append(imports, node2.argument.literal);
              }
            }
          }
          function getNodeAtPosition(sourceFile, position) {
            var current = sourceFile;
            var getContainingChild = function(child2) {
              if (child2.pos <= position && (position < child2.end || position === child2.end && child2.kind === 1)) {
                return child2;
              }
            };
            while (true) {
              var child = isJavaScriptFile && ts3.hasJSDocNodes(current) && ts3.forEach(current.jsDoc, getContainingChild) || ts3.forEachChild(current, getContainingChild);
              if (!child) {
                return current;
              }
              current = child;
            }
          }
        }
        function getLibFileFromReference(ref2) {
          var libName = ts3.toFileNameLowerCase(ref2.fileName);
          var libFileName = ts3.libMap.get(libName);
          if (libFileName) {
            return getSourceFile(ts3.combinePaths(defaultLibraryPath, libFileName));
          }
        }
        function getSourceFileFromReference(referencingFile, ref2) {
          return getSourceFileFromReferenceWorker(resolveTripleslashReference(ref2.fileName, referencingFile.fileName), getSourceFile);
        }
        function getSourceFileFromReferenceWorker(fileName, getSourceFile2, fail, reason) {
          if (ts3.hasExtension(fileName)) {
            var canonicalFileName_1 = host.getCanonicalFileName(fileName);
            if (!options.allowNonTsExtensions && !ts3.forEach(supportedExtensionsWithJsonIfResolveJsonModule, function(extension) {
              return ts3.fileExtensionIs(canonicalFileName_1, extension);
            })) {
              if (fail) {
                if (ts3.hasJSFileExtension(canonicalFileName_1)) {
                  fail(ts3.Diagnostics.File_0_is_a_JavaScript_file_Did_you_mean_to_enable_the_allowJs_option, fileName);
                } else {
                  fail(ts3.Diagnostics.File_0_has_an_unsupported_extension_The_only_supported_extensions_are_1, fileName, "'" + supportedExtensions.join("', '") + "'");
                }
              }
              return void 0;
            }
            var sourceFile = getSourceFile2(fileName);
            if (fail) {
              if (!sourceFile) {
                var redirect = getProjectReferenceRedirect(fileName);
                if (redirect) {
                  fail(ts3.Diagnostics.Output_file_0_has_not_been_built_from_source_file_1, redirect, fileName);
                } else {
                  fail(ts3.Diagnostics.File_0_not_found, fileName);
                }
              } else if (isReferencedFile(reason) && canonicalFileName_1 === host.getCanonicalFileName(getSourceFileByPath(reason.file).fileName)) {
                fail(ts3.Diagnostics.A_file_cannot_have_a_reference_to_itself);
              }
            }
            return sourceFile;
          } else {
            var sourceFileNoExtension = options.allowNonTsExtensions && getSourceFile2(fileName);
            if (sourceFileNoExtension)
              return sourceFileNoExtension;
            if (fail && options.allowNonTsExtensions) {
              fail(ts3.Diagnostics.File_0_not_found, fileName);
              return void 0;
            }
            var sourceFileWithAddedExtension = ts3.forEach(supportedExtensions, function(extension) {
              return getSourceFile2(fileName + extension);
            });
            if (fail && !sourceFileWithAddedExtension)
              fail(ts3.Diagnostics.Could_not_resolve_the_path_0_with_the_extensions_Colon_1, fileName, "'" + supportedExtensions.join("', '") + "'");
            return sourceFileWithAddedExtension;
          }
        }
        function processSourceFile(fileName, isDefaultLib, ignoreNoDefaultLib, packageId, reason) {
          getSourceFileFromReferenceWorker(fileName, function(fileName2) {
            return findSourceFile(fileName2, toPath(fileName2), isDefaultLib, ignoreNoDefaultLib, reason, packageId);
          }, function(diagnostic) {
            var args = [];
            for (var _i2 = 1; _i2 < arguments.length; _i2++) {
              args[_i2 - 1] = arguments[_i2];
            }
            return addFilePreprocessingFileExplainingDiagnostic(void 0, reason, diagnostic, args);
          }, reason);
        }
        function processProjectReferenceFile(fileName, reason) {
          return processSourceFile(fileName, false, false, void 0, reason);
        }
        function reportFileNamesDifferOnlyInCasingError(fileName, existingFile, reason) {
          var hasExistingReasonToReportErrorOn = !isReferencedFile(reason) && ts3.some(fileReasons.get(existingFile.path), isReferencedFile);
          if (hasExistingReasonToReportErrorOn) {
            addFilePreprocessingFileExplainingDiagnostic(existingFile, reason, ts3.Diagnostics.Already_included_file_name_0_differs_from_file_name_1_only_in_casing, [existingFile.fileName, fileName]);
          } else {
            addFilePreprocessingFileExplainingDiagnostic(existingFile, reason, ts3.Diagnostics.File_name_0_differs_from_already_included_file_name_1_only_in_casing, [fileName, existingFile.fileName]);
          }
        }
        function createRedirectSourceFile(redirectTarget, unredirected, fileName, path2, resolvedPath, originalFileName) {
          var redirect = Object.create(redirectTarget);
          redirect.fileName = fileName;
          redirect.path = path2;
          redirect.resolvedPath = resolvedPath;
          redirect.originalFileName = originalFileName;
          redirect.redirectInfo = { redirectTarget, unredirected };
          sourceFilesFoundSearchingNodeModules.set(path2, currentNodeModulesDepth > 0);
          Object.defineProperties(redirect, {
            id: {
              get: function() {
                return this.redirectInfo.redirectTarget.id;
              },
              set: function(value) {
                this.redirectInfo.redirectTarget.id = value;
              }
            },
            symbol: {
              get: function() {
                return this.redirectInfo.redirectTarget.symbol;
              },
              set: function(value) {
                this.redirectInfo.redirectTarget.symbol = value;
              }
            }
          });
          return redirect;
        }
        function findSourceFile(fileName, path2, isDefaultLib, ignoreNoDefaultLib, reason, packageId) {
          ts3.tracing === null || ts3.tracing === void 0 ? void 0 : ts3.tracing.push("program", "findSourceFile", {
            fileName,
            isDefaultLib: isDefaultLib || void 0,
            fileIncludeKind: ts3.FileIncludeKind[reason.kind]
          });
          var result2 = findSourceFileWorker(fileName, path2, isDefaultLib, ignoreNoDefaultLib, reason, packageId);
          ts3.tracing === null || ts3.tracing === void 0 ? void 0 : ts3.tracing.pop();
          return result2;
        }
        function findSourceFileWorker(fileName, path2, isDefaultLib, ignoreNoDefaultLib, reason, packageId) {
          if (useSourceOfProjectReferenceRedirect) {
            var source = getSourceOfProjectReferenceRedirect(fileName);
            if (!source && host.realpath && options.preserveSymlinks && ts3.isDeclarationFileName(fileName) && ts3.stringContains(fileName, ts3.nodeModulesPathPart)) {
              var realPath = host.realpath(fileName);
              if (realPath !== fileName)
                source = getSourceOfProjectReferenceRedirect(realPath);
            }
            if (source) {
              var file_1 = ts3.isString(source) ? findSourceFile(source, toPath(source), isDefaultLib, ignoreNoDefaultLib, reason, packageId) : void 0;
              if (file_1)
                addFileToFilesByName(file_1, path2, void 0);
              return file_1;
            }
          }
          var originalFileName = fileName;
          if (filesByName.has(path2)) {
            var file_2 = filesByName.get(path2);
            addFileIncludeReason(file_2 || void 0, reason);
            if (file_2 && options.forceConsistentCasingInFileNames) {
              var checkedName = file_2.fileName;
              var isRedirect = toPath(checkedName) !== toPath(fileName);
              if (isRedirect) {
                fileName = getProjectReferenceRedirect(fileName) || fileName;
              }
              var checkedAbsolutePath = ts3.getNormalizedAbsolutePathWithoutRoot(checkedName, currentDirectory);
              var inputAbsolutePath = ts3.getNormalizedAbsolutePathWithoutRoot(fileName, currentDirectory);
              if (checkedAbsolutePath !== inputAbsolutePath) {
                reportFileNamesDifferOnlyInCasingError(fileName, file_2, reason);
              }
            }
            if (file_2 && sourceFilesFoundSearchingNodeModules.get(file_2.path) && currentNodeModulesDepth === 0) {
              sourceFilesFoundSearchingNodeModules.set(file_2.path, false);
              if (!options.noResolve) {
                processReferencedFiles(file_2, isDefaultLib);
                processTypeReferenceDirectives(file_2);
              }
              if (!options.noLib) {
                processLibReferenceDirectives(file_2);
              }
              modulesWithElidedImports.set(file_2.path, false);
              processImportedModules(file_2);
            } else if (file_2 && modulesWithElidedImports.get(file_2.path)) {
              if (currentNodeModulesDepth < maxNodeModuleJsDepth) {
                modulesWithElidedImports.set(file_2.path, false);
                processImportedModules(file_2);
              }
            }
            return file_2 || void 0;
          }
          var redirectedPath;
          if (isReferencedFile(reason) && !useSourceOfProjectReferenceRedirect) {
            var redirectProject = getProjectReferenceRedirectProject(fileName);
            if (redirectProject) {
              if (ts3.outFile(redirectProject.commandLine.options)) {
                return void 0;
              }
              var redirect = getProjectReferenceOutputName(redirectProject, fileName);
              fileName = redirect;
              redirectedPath = toPath(redirect);
            }
          }
          var file = host.getSourceFile(fileName, options.target, function(hostErrorMessage) {
            return addFilePreprocessingFileExplainingDiagnostic(void 0, reason, ts3.Diagnostics.Cannot_read_file_0_Colon_1, [fileName, hostErrorMessage]);
          }, shouldCreateNewSourceFile);
          if (packageId) {
            var packageIdKey = ts3.packageIdToString(packageId);
            var fileFromPackageId = packageIdToSourceFile.get(packageIdKey);
            if (fileFromPackageId) {
              var dupFile = createRedirectSourceFile(fileFromPackageId, file, fileName, path2, toPath(fileName), originalFileName);
              redirectTargetsMap.add(fileFromPackageId.path, fileName);
              addFileToFilesByName(dupFile, path2, redirectedPath);
              addFileIncludeReason(dupFile, reason);
              sourceFileToPackageName.set(path2, packageId.name);
              processingOtherFiles.push(dupFile);
              return dupFile;
            } else if (file) {
              packageIdToSourceFile.set(packageIdKey, file);
              sourceFileToPackageName.set(path2, packageId.name);
            }
          }
          addFileToFilesByName(file, path2, redirectedPath);
          if (file) {
            sourceFilesFoundSearchingNodeModules.set(path2, currentNodeModulesDepth > 0);
            file.fileName = fileName;
            file.path = path2;
            file.resolvedPath = toPath(fileName);
            file.originalFileName = originalFileName;
            addFileIncludeReason(file, reason);
            if (host.useCaseSensitiveFileNames()) {
              var pathLowerCase = ts3.toFileNameLowerCase(path2);
              var existingFile = filesByNameIgnoreCase.get(pathLowerCase);
              if (existingFile) {
                reportFileNamesDifferOnlyInCasingError(fileName, existingFile, reason);
              } else {
                filesByNameIgnoreCase.set(pathLowerCase, file);
              }
            }
            skipDefaultLib = skipDefaultLib || file.hasNoDefaultLib && !ignoreNoDefaultLib;
            if (!options.noResolve) {
              processReferencedFiles(file, isDefaultLib);
              processTypeReferenceDirectives(file);
            }
            if (!options.noLib) {
              processLibReferenceDirectives(file);
            }
            processImportedModules(file);
            if (isDefaultLib) {
              processingDefaultLibFiles.push(file);
            } else {
              processingOtherFiles.push(file);
            }
          }
          return file;
        }
        function addFileIncludeReason(file, reason) {
          if (file)
            fileReasons.add(file.path, reason);
        }
        function addFileToFilesByName(file, path2, redirectedPath) {
          if (redirectedPath) {
            filesByName.set(redirectedPath, file);
            filesByName.set(path2, file || false);
          } else {
            filesByName.set(path2, file);
          }
        }
        function getProjectReferenceRedirect(fileName) {
          var referencedProject = getProjectReferenceRedirectProject(fileName);
          return referencedProject && getProjectReferenceOutputName(referencedProject, fileName);
        }
        function getProjectReferenceRedirectProject(fileName) {
          if (!resolvedProjectReferences || !resolvedProjectReferences.length || ts3.fileExtensionIs(fileName, ".d.ts") || ts3.fileExtensionIs(fileName, ".json")) {
            return void 0;
          }
          return getResolvedProjectReferenceToRedirect(fileName);
        }
        function getProjectReferenceOutputName(referencedProject, fileName) {
          var out = ts3.outFile(referencedProject.commandLine.options);
          return out ? ts3.changeExtension(out, ".d.ts") : ts3.getOutputDeclarationFileName(fileName, referencedProject.commandLine, !host.useCaseSensitiveFileNames());
        }
        function getResolvedProjectReferenceToRedirect(fileName) {
          if (mapFromFileToProjectReferenceRedirects === void 0) {
            mapFromFileToProjectReferenceRedirects = new ts3.Map();
            forEachResolvedProjectReference2(function(referencedProject) {
              if (toPath(options.configFilePath) !== referencedProject.sourceFile.path) {
                referencedProject.commandLine.fileNames.forEach(function(f) {
                  return mapFromFileToProjectReferenceRedirects.set(toPath(f), referencedProject.sourceFile.path);
                });
              }
            });
          }
          var referencedProjectPath = mapFromFileToProjectReferenceRedirects.get(toPath(fileName));
          return referencedProjectPath && getResolvedProjectReferenceByPath(referencedProjectPath);
        }
        function forEachResolvedProjectReference2(cb2) {
          return ts3.forEachResolvedProjectReference(resolvedProjectReferences, cb2);
        }
        function getSourceOfProjectReferenceRedirect(file) {
          if (!ts3.isDeclarationFileName(file))
            return void 0;
          if (mapFromToProjectReferenceRedirectSource === void 0) {
            mapFromToProjectReferenceRedirectSource = new ts3.Map();
            forEachResolvedProjectReference2(function(resolvedRef) {
              var out = ts3.outFile(resolvedRef.commandLine.options);
              if (out) {
                var outputDts = ts3.changeExtension(out, ".d.ts");
                mapFromToProjectReferenceRedirectSource.set(toPath(outputDts), true);
              } else {
                var getCommonSourceDirectory_3 = ts3.memoize(function() {
                  return ts3.getCommonSourceDirectoryOfConfig(resolvedRef.commandLine, !host.useCaseSensitiveFileNames());
                });
                ts3.forEach(resolvedRef.commandLine.fileNames, function(fileName) {
                  if (!ts3.fileExtensionIs(fileName, ".d.ts") && !ts3.fileExtensionIs(fileName, ".json")) {
                    var outputDts2 = ts3.getOutputDeclarationFileName(fileName, resolvedRef.commandLine, !host.useCaseSensitiveFileNames(), getCommonSourceDirectory_3);
                    mapFromToProjectReferenceRedirectSource.set(toPath(outputDts2), fileName);
                  }
                });
              }
            });
          }
          return mapFromToProjectReferenceRedirectSource.get(toPath(file));
        }
        function isSourceOfProjectReferenceRedirect(fileName) {
          return useSourceOfProjectReferenceRedirect && !!getResolvedProjectReferenceToRedirect(fileName);
        }
        function getResolvedProjectReferenceByPath(projectReferencePath) {
          if (!projectReferenceRedirects) {
            return void 0;
          }
          return projectReferenceRedirects.get(projectReferencePath) || void 0;
        }
        function processReferencedFiles(file, isDefaultLib) {
          ts3.forEach(file.referencedFiles, function(ref2, index) {
            processSourceFile(resolveTripleslashReference(ref2.fileName, file.fileName), isDefaultLib, false, void 0, { kind: ts3.FileIncludeKind.ReferenceFile, file: file.path, index });
          });
        }
        function processTypeReferenceDirectives(file) {
          var typeDirectives = ts3.map(file.typeReferenceDirectives, function(ref3) {
            return ts3.toFileNameLowerCase(ref3.fileName);
          });
          if (!typeDirectives) {
            return;
          }
          var resolutions2 = resolveTypeReferenceDirectiveNamesWorker(typeDirectives, file);
          for (var index = 0; index < typeDirectives.length; index++) {
            var ref2 = file.typeReferenceDirectives[index];
            var resolvedTypeReferenceDirective = resolutions2[index];
            var fileName = ts3.toFileNameLowerCase(ref2.fileName);
            ts3.setResolvedTypeReferenceDirective(file, fileName, resolvedTypeReferenceDirective);
            processTypeReferenceDirective(fileName, resolvedTypeReferenceDirective, { kind: ts3.FileIncludeKind.TypeReferenceDirective, file: file.path, index });
          }
        }
        function processTypeReferenceDirective(typeReferenceDirective, resolvedTypeReferenceDirective, reason) {
          ts3.tracing === null || ts3.tracing === void 0 ? void 0 : ts3.tracing.push("program", "processTypeReferenceDirective", { directive: typeReferenceDirective, hasResolved: !!resolveModuleNamesReusingOldState, refKind: reason.kind, refPath: isReferencedFile(reason) ? reason.file : void 0 });
          processTypeReferenceDirectiveWorker(typeReferenceDirective, resolvedTypeReferenceDirective, reason);
          ts3.tracing === null || ts3.tracing === void 0 ? void 0 : ts3.tracing.pop();
        }
        function processTypeReferenceDirectiveWorker(typeReferenceDirective, resolvedTypeReferenceDirective, reason) {
          var previousResolution = resolvedTypeReferenceDirectives.get(typeReferenceDirective);
          if (previousResolution && previousResolution.primary) {
            return;
          }
          var saveResolution = true;
          if (resolvedTypeReferenceDirective) {
            if (resolvedTypeReferenceDirective.isExternalLibraryImport)
              currentNodeModulesDepth++;
            if (resolvedTypeReferenceDirective.primary) {
              processSourceFile(resolvedTypeReferenceDirective.resolvedFileName, false, false, resolvedTypeReferenceDirective.packageId, reason);
            } else {
              if (previousResolution) {
                if (resolvedTypeReferenceDirective.resolvedFileName !== previousResolution.resolvedFileName) {
                  var otherFileText = host.readFile(resolvedTypeReferenceDirective.resolvedFileName);
                  var existingFile = getSourceFile(previousResolution.resolvedFileName);
                  if (otherFileText !== existingFile.text) {
                    addFilePreprocessingFileExplainingDiagnostic(existingFile, reason, ts3.Diagnostics.Conflicting_definitions_for_0_found_at_1_and_2_Consider_installing_a_specific_version_of_this_library_to_resolve_the_conflict, [typeReferenceDirective, resolvedTypeReferenceDirective.resolvedFileName, previousResolution.resolvedFileName]);
                  }
                }
                saveResolution = false;
              } else {
                processSourceFile(resolvedTypeReferenceDirective.resolvedFileName, false, false, resolvedTypeReferenceDirective.packageId, reason);
              }
            }
            if (resolvedTypeReferenceDirective.isExternalLibraryImport)
              currentNodeModulesDepth--;
          } else {
            addFilePreprocessingFileExplainingDiagnostic(void 0, reason, ts3.Diagnostics.Cannot_find_type_definition_file_for_0, [typeReferenceDirective]);
          }
          if (saveResolution) {
            resolvedTypeReferenceDirectives.set(typeReferenceDirective, resolvedTypeReferenceDirective);
          }
        }
        function processLibReferenceDirectives(file) {
          ts3.forEach(file.libReferenceDirectives, function(libReference, index) {
            var libName = ts3.toFileNameLowerCase(libReference.fileName);
            var libFileName = ts3.libMap.get(libName);
            if (libFileName) {
              processRootFile(ts3.combinePaths(defaultLibraryPath, libFileName), true, true, { kind: ts3.FileIncludeKind.LibReferenceDirective, file: file.path, index });
            } else {
              var unqualifiedLibName = ts3.removeSuffix(ts3.removePrefix(libName, "lib."), ".d.ts");
              var suggestion = ts3.getSpellingSuggestion(unqualifiedLibName, ts3.libs, ts3.identity);
              var diagnostic = suggestion ? ts3.Diagnostics.Cannot_find_lib_definition_for_0_Did_you_mean_1 : ts3.Diagnostics.Cannot_find_lib_definition_for_0;
              (fileProcessingDiagnostics || (fileProcessingDiagnostics = [])).push({
                kind: 0,
                reason: { kind: ts3.FileIncludeKind.LibReferenceDirective, file: file.path, index },
                diagnostic,
                args: [libName, suggestion]
              });
            }
          });
        }
        function getCanonicalFileName(fileName) {
          return host.getCanonicalFileName(fileName);
        }
        function processImportedModules(file) {
          var _a3;
          collectExternalModuleReferences(file);
          if (file.imports.length || file.moduleAugmentations.length) {
            var moduleNames = getModuleNames(file);
            var resolutions2 = resolveModuleNamesReusingOldState(moduleNames, file);
            ts3.Debug.assert(resolutions2.length === moduleNames.length);
            var optionsForFile = (useSourceOfProjectReferenceRedirect ? (_a3 = getRedirectReferenceForResolution(file)) === null || _a3 === void 0 ? void 0 : _a3.commandLine.options : void 0) || options;
            for (var index = 0; index < moduleNames.length; index++) {
              var resolution = resolutions2[index];
              ts3.setResolvedModule(file, moduleNames[index], resolution);
              if (!resolution) {
                continue;
              }
              var isFromNodeModulesSearch = resolution.isExternalLibraryImport;
              var isJsFile = !ts3.resolutionExtensionIsTSOrJson(resolution.extension);
              var isJsFileFromNodeModules = isFromNodeModulesSearch && isJsFile;
              var resolvedFileName = resolution.resolvedFileName;
              if (isFromNodeModulesSearch) {
                currentNodeModulesDepth++;
              }
              var elideImport = isJsFileFromNodeModules && currentNodeModulesDepth > maxNodeModuleJsDepth;
              var shouldAddFile = resolvedFileName && !getResolutionDiagnostic(optionsForFile, resolution) && !optionsForFile.noResolve && index < file.imports.length && !elideImport && !(isJsFile && !ts3.getAllowJSCompilerOption(optionsForFile)) && (ts3.isInJSFile(file.imports[index]) || !(file.imports[index].flags & 4194304));
              if (elideImport) {
                modulesWithElidedImports.set(file.path, true);
              } else if (shouldAddFile) {
                var path2 = toPath(resolvedFileName);
                findSourceFile(resolvedFileName, path2, false, false, { kind: ts3.FileIncludeKind.Import, file: file.path, index }, resolution.packageId);
              }
              if (isFromNodeModulesSearch) {
                currentNodeModulesDepth--;
              }
            }
          } else {
            file.resolvedModules = void 0;
          }
        }
        function checkSourceFilesBelongToPath(sourceFiles, rootDirectory) {
          var allFilesBelongToPath = true;
          var absoluteRootDirectoryPath = host.getCanonicalFileName(ts3.getNormalizedAbsolutePath(rootDirectory, currentDirectory));
          for (var _i2 = 0, sourceFiles_2 = sourceFiles; _i2 < sourceFiles_2.length; _i2++) {
            var sourceFile = sourceFiles_2[_i2];
            if (!sourceFile.isDeclarationFile) {
              var absoluteSourceFilePath = host.getCanonicalFileName(ts3.getNormalizedAbsolutePath(sourceFile.fileName, currentDirectory));
              if (absoluteSourceFilePath.indexOf(absoluteRootDirectoryPath) !== 0) {
                addProgramDiagnosticExplainingFile(sourceFile, ts3.Diagnostics.File_0_is_not_under_rootDir_1_rootDir_is_expected_to_contain_all_source_files, [sourceFile.fileName, rootDirectory]);
                allFilesBelongToPath = false;
              }
            }
          }
          return allFilesBelongToPath;
        }
        function parseProjectReferenceConfigFile(ref2) {
          if (!projectReferenceRedirects) {
            projectReferenceRedirects = new ts3.Map();
          }
          var refPath = resolveProjectReferencePath(ref2);
          var sourceFilePath = toPath(refPath);
          var fromCache = projectReferenceRedirects.get(sourceFilePath);
          if (fromCache !== void 0) {
            return fromCache || void 0;
          }
          var commandLine;
          var sourceFile;
          if (host.getParsedCommandLine) {
            commandLine = host.getParsedCommandLine(refPath);
            if (!commandLine) {
              addFileToFilesByName(void 0, sourceFilePath, void 0);
              projectReferenceRedirects.set(sourceFilePath, false);
              return void 0;
            }
            sourceFile = ts3.Debug.checkDefined(commandLine.options.configFile);
            ts3.Debug.assert(!sourceFile.path || sourceFile.path === sourceFilePath);
            addFileToFilesByName(sourceFile, sourceFilePath, void 0);
          } else {
            var basePath = ts3.getNormalizedAbsolutePath(ts3.getDirectoryPath(refPath), host.getCurrentDirectory());
            sourceFile = host.getSourceFile(refPath, 100);
            addFileToFilesByName(sourceFile, sourceFilePath, void 0);
            if (sourceFile === void 0) {
              projectReferenceRedirects.set(sourceFilePath, false);
              return void 0;
            }
            commandLine = ts3.parseJsonSourceFileConfigFileContent(sourceFile, configParsingHost, basePath, void 0, refPath);
          }
          sourceFile.fileName = refPath;
          sourceFile.path = sourceFilePath;
          sourceFile.resolvedPath = sourceFilePath;
          sourceFile.originalFileName = refPath;
          var resolvedRef = { commandLine, sourceFile };
          projectReferenceRedirects.set(sourceFilePath, resolvedRef);
          if (commandLine.projectReferences) {
            resolvedRef.references = commandLine.projectReferences.map(parseProjectReferenceConfigFile);
          }
          return resolvedRef;
        }
        function verifyCompilerOptions() {
          if (options.strictPropertyInitialization && !ts3.getStrictOptionValue(options, "strictNullChecks")) {
            createDiagnosticForOptionName(ts3.Diagnostics.Option_0_cannot_be_specified_without_specifying_option_1, "strictPropertyInitialization", "strictNullChecks");
          }
          if (options.isolatedModules) {
            if (options.out) {
              createDiagnosticForOptionName(ts3.Diagnostics.Option_0_cannot_be_specified_with_option_1, "out", "isolatedModules");
            }
            if (options.outFile) {
              createDiagnosticForOptionName(ts3.Diagnostics.Option_0_cannot_be_specified_with_option_1, "outFile", "isolatedModules");
            }
          }
          if (options.inlineSourceMap) {
            if (options.sourceMap) {
              createDiagnosticForOptionName(ts3.Diagnostics.Option_0_cannot_be_specified_with_option_1, "sourceMap", "inlineSourceMap");
            }
            if (options.mapRoot) {
              createDiagnosticForOptionName(ts3.Diagnostics.Option_0_cannot_be_specified_with_option_1, "mapRoot", "inlineSourceMap");
            }
          }
          if (options.composite) {
            if (options.declaration === false) {
              createDiagnosticForOptionName(ts3.Diagnostics.Composite_projects_may_not_disable_declaration_emit, "declaration");
            }
            if (options.incremental === false) {
              createDiagnosticForOptionName(ts3.Diagnostics.Composite_projects_may_not_disable_incremental_compilation, "declaration");
            }
          }
          var outputFile = ts3.outFile(options);
          if (options.tsBuildInfoFile) {
            if (!ts3.isIncrementalCompilation(options)) {
              createDiagnosticForOptionName(ts3.Diagnostics.Option_0_cannot_be_specified_without_specifying_option_1_or_option_2, "tsBuildInfoFile", "incremental", "composite");
            }
          } else if (options.incremental && !outputFile && !options.configFilePath) {
            programDiagnostics.add(ts3.createCompilerDiagnostic(ts3.Diagnostics.Option_incremental_can_only_be_specified_using_tsconfig_emitting_to_single_file_or_when_option_tsBuildInfoFile_is_specified));
          }
          verifyProjectReferences();
          if (options.composite) {
            var rootPaths = new ts3.Set(rootNames.map(toPath));
            for (var _i2 = 0, files_3 = files; _i2 < files_3.length; _i2++) {
              var file = files_3[_i2];
              if (ts3.sourceFileMayBeEmitted(file, program2) && !rootPaths.has(file.path)) {
                addProgramDiagnosticExplainingFile(file, ts3.Diagnostics.File_0_is_not_listed_within_the_file_list_of_project_1_Projects_must_list_all_files_or_use_an_include_pattern, [file.fileName, options.configFilePath || ""]);
              }
            }
          }
          if (options.paths) {
            for (var key2 in options.paths) {
              if (!ts3.hasProperty(options.paths, key2)) {
                continue;
              }
              if (!ts3.hasZeroOrOneAsteriskCharacter(key2)) {
                createDiagnosticForOptionPaths(true, key2, ts3.Diagnostics.Pattern_0_can_have_at_most_one_Asterisk_character, key2);
              }
              if (ts3.isArray(options.paths[key2])) {
                var len = options.paths[key2].length;
                if (len === 0) {
                  createDiagnosticForOptionPaths(false, key2, ts3.Diagnostics.Substitutions_for_pattern_0_shouldn_t_be_an_empty_array, key2);
                }
                for (var i4 = 0; i4 < len; i4++) {
                  var subst = options.paths[key2][i4];
                  var typeOfSubst = typeof subst;
                  if (typeOfSubst === "string") {
                    if (!ts3.hasZeroOrOneAsteriskCharacter(subst)) {
                      createDiagnosticForOptionPathKeyValue(key2, i4, ts3.Diagnostics.Substitution_0_in_pattern_1_can_have_at_most_one_Asterisk_character, subst, key2);
                    }
                    if (!options.baseUrl && !ts3.pathIsRelative(subst) && !ts3.pathIsAbsolute(subst)) {
                      createDiagnosticForOptionPathKeyValue(key2, i4, ts3.Diagnostics.Non_relative_paths_are_not_allowed_when_baseUrl_is_not_set_Did_you_forget_a_leading_Slash);
                    }
                  } else {
                    createDiagnosticForOptionPathKeyValue(key2, i4, ts3.Diagnostics.Substitution_0_for_pattern_1_has_incorrect_type_expected_string_got_2, subst, key2, typeOfSubst);
                  }
                }
              } else {
                createDiagnosticForOptionPaths(false, key2, ts3.Diagnostics.Substitutions_for_pattern_0_should_be_an_array, key2);
              }
            }
          }
          if (!options.sourceMap && !options.inlineSourceMap) {
            if (options.inlineSources) {
              createDiagnosticForOptionName(ts3.Diagnostics.Option_0_can_only_be_used_when_either_option_inlineSourceMap_or_option_sourceMap_is_provided, "inlineSources");
            }
            if (options.sourceRoot) {
              createDiagnosticForOptionName(ts3.Diagnostics.Option_0_can_only_be_used_when_either_option_inlineSourceMap_or_option_sourceMap_is_provided, "sourceRoot");
            }
          }
          if (options.out && options.outFile) {
            createDiagnosticForOptionName(ts3.Diagnostics.Option_0_cannot_be_specified_with_option_1, "out", "outFile");
          }
          if (options.mapRoot && !(options.sourceMap || options.declarationMap)) {
            createDiagnosticForOptionName(ts3.Diagnostics.Option_0_cannot_be_specified_without_specifying_option_1_or_option_2, "mapRoot", "sourceMap", "declarationMap");
          }
          if (options.declarationDir) {
            if (!ts3.getEmitDeclarations(options)) {
              createDiagnosticForOptionName(ts3.Diagnostics.Option_0_cannot_be_specified_without_specifying_option_1_or_option_2, "declarationDir", "declaration", "composite");
            }
            if (outputFile) {
              createDiagnosticForOptionName(ts3.Diagnostics.Option_0_cannot_be_specified_with_option_1, "declarationDir", options.out ? "out" : "outFile");
            }
          }
          if (options.declarationMap && !ts3.getEmitDeclarations(options)) {
            createDiagnosticForOptionName(ts3.Diagnostics.Option_0_cannot_be_specified_without_specifying_option_1_or_option_2, "declarationMap", "declaration", "composite");
          }
          if (options.lib && options.noLib) {
            createDiagnosticForOptionName(ts3.Diagnostics.Option_0_cannot_be_specified_with_option_1, "lib", "noLib");
          }
          if (options.noImplicitUseStrict && ts3.getStrictOptionValue(options, "alwaysStrict")) {
            createDiagnosticForOptionName(ts3.Diagnostics.Option_0_cannot_be_specified_with_option_1, "noImplicitUseStrict", "alwaysStrict");
          }
          var languageVersion = options.target || 0;
          var firstNonAmbientExternalModuleSourceFile = ts3.find(files, function(f) {
            return ts3.isExternalModule(f) && !f.isDeclarationFile;
          });
          if (options.isolatedModules) {
            if (options.module === ts3.ModuleKind.None && languageVersion < 2) {
              createDiagnosticForOptionName(ts3.Diagnostics.Option_isolatedModules_can_only_be_used_when_either_option_module_is_provided_or_option_target_is_ES2015_or_higher, "isolatedModules", "target");
            }
            if (options.preserveConstEnums === false) {
              createDiagnosticForOptionName(ts3.Diagnostics.Option_preserveConstEnums_cannot_be_disabled_when_isolatedModules_is_enabled, "preserveConstEnums", "isolatedModules");
            }
            var firstNonExternalModuleSourceFile = ts3.find(files, function(f) {
              return !ts3.isExternalModule(f) && !ts3.isSourceFileJS(f) && !f.isDeclarationFile && f.scriptKind !== 6;
            });
            if (firstNonExternalModuleSourceFile) {
              var span = ts3.getErrorSpanForNode(firstNonExternalModuleSourceFile, firstNonExternalModuleSourceFile);
              programDiagnostics.add(ts3.createFileDiagnostic(firstNonExternalModuleSourceFile, span.start, span.length, ts3.Diagnostics._0_cannot_be_compiled_under_isolatedModules_because_it_is_considered_a_global_script_file_Add_an_import_export_or_an_empty_export_statement_to_make_it_a_module, ts3.getBaseFileName(firstNonExternalModuleSourceFile.fileName)));
            }
          } else if (firstNonAmbientExternalModuleSourceFile && languageVersion < 2 && options.module === ts3.ModuleKind.None) {
            var span = ts3.getErrorSpanForNode(firstNonAmbientExternalModuleSourceFile, firstNonAmbientExternalModuleSourceFile.externalModuleIndicator);
            programDiagnostics.add(ts3.createFileDiagnostic(firstNonAmbientExternalModuleSourceFile, span.start, span.length, ts3.Diagnostics.Cannot_use_imports_exports_or_module_augmentations_when_module_is_none));
          }
          if (outputFile && !options.emitDeclarationOnly) {
            if (options.module && !(options.module === ts3.ModuleKind.AMD || options.module === ts3.ModuleKind.System)) {
              createDiagnosticForOptionName(ts3.Diagnostics.Only_amd_and_system_modules_are_supported_alongside_0, options.out ? "out" : "outFile", "module");
            } else if (options.module === void 0 && firstNonAmbientExternalModuleSourceFile) {
              var span = ts3.getErrorSpanForNode(firstNonAmbientExternalModuleSourceFile, firstNonAmbientExternalModuleSourceFile.externalModuleIndicator);
              programDiagnostics.add(ts3.createFileDiagnostic(firstNonAmbientExternalModuleSourceFile, span.start, span.length, ts3.Diagnostics.Cannot_compile_modules_using_option_0_unless_the_module_flag_is_amd_or_system, options.out ? "out" : "outFile"));
            }
          }
          if (options.resolveJsonModule) {
            if (ts3.getEmitModuleResolutionKind(options) !== ts3.ModuleResolutionKind.NodeJs) {
              createDiagnosticForOptionName(ts3.Diagnostics.Option_resolveJsonModule_cannot_be_specified_without_node_module_resolution_strategy, "resolveJsonModule");
            } else if (!ts3.hasJsonModuleEmitEnabled(options)) {
              createDiagnosticForOptionName(ts3.Diagnostics.Option_resolveJsonModule_can_only_be_specified_when_module_code_generation_is_commonjs_amd_es2015_or_esNext, "resolveJsonModule", "module");
            }
          }
          if (options.outDir || options.rootDir || options.sourceRoot || options.mapRoot) {
            var dir = getCommonSourceDirectory();
            if (options.outDir && dir === "" && files.some(function(file2) {
              return ts3.getRootLength(file2.fileName) > 1;
            })) {
              createDiagnosticForOptionName(ts3.Diagnostics.Cannot_find_the_common_subdirectory_path_for_the_input_files, "outDir");
            }
          }
          if (options.useDefineForClassFields && languageVersion === 0) {
            createDiagnosticForOptionName(ts3.Diagnostics.Option_0_cannot_be_specified_when_option_target_is_ES3, "useDefineForClassFields");
          }
          if (options.checkJs && !ts3.getAllowJSCompilerOption(options)) {
            programDiagnostics.add(ts3.createCompilerDiagnostic(ts3.Diagnostics.Option_0_cannot_be_specified_without_specifying_option_1, "checkJs", "allowJs"));
          }
          if (options.emitDeclarationOnly) {
            if (!ts3.getEmitDeclarations(options)) {
              createDiagnosticForOptionName(ts3.Diagnostics.Option_0_cannot_be_specified_without_specifying_option_1_or_option_2, "emitDeclarationOnly", "declaration", "composite");
            }
            if (options.noEmit) {
              createDiagnosticForOptionName(ts3.Diagnostics.Option_0_cannot_be_specified_with_option_1, "emitDeclarationOnly", "noEmit");
            }
          }
          if (options.emitDecoratorMetadata && !options.experimentalDecorators) {
            createDiagnosticForOptionName(ts3.Diagnostics.Option_0_cannot_be_specified_without_specifying_option_1, "emitDecoratorMetadata", "experimentalDecorators");
          }
          if (options.jsxFactory) {
            if (options.reactNamespace) {
              createDiagnosticForOptionName(ts3.Diagnostics.Option_0_cannot_be_specified_with_option_1, "reactNamespace", "jsxFactory");
            }
            if (options.jsx === 4 || options.jsx === 5) {
              createDiagnosticForOptionName(ts3.Diagnostics.Option_0_cannot_be_specified_when_option_jsx_is_1, "jsxFactory", ts3.inverseJsxOptionMap.get("" + options.jsx));
            }
            if (!ts3.parseIsolatedEntityName(options.jsxFactory, languageVersion)) {
              createOptionValueDiagnostic("jsxFactory", ts3.Diagnostics.Invalid_value_for_jsxFactory_0_is_not_a_valid_identifier_or_qualified_name, options.jsxFactory);
            }
          } else if (options.reactNamespace && !ts3.isIdentifierText(options.reactNamespace, languageVersion)) {
            createOptionValueDiagnostic("reactNamespace", ts3.Diagnostics.Invalid_value_for_reactNamespace_0_is_not_a_valid_identifier, options.reactNamespace);
          }
          if (options.jsxFragmentFactory) {
            if (!options.jsxFactory) {
              createDiagnosticForOptionName(ts3.Diagnostics.Option_0_cannot_be_specified_without_specifying_option_1, "jsxFragmentFactory", "jsxFactory");
            }
            if (options.jsx === 4 || options.jsx === 5) {
              createDiagnosticForOptionName(ts3.Diagnostics.Option_0_cannot_be_specified_when_option_jsx_is_1, "jsxFragmentFactory", ts3.inverseJsxOptionMap.get("" + options.jsx));
            }
            if (!ts3.parseIsolatedEntityName(options.jsxFragmentFactory, languageVersion)) {
              createOptionValueDiagnostic("jsxFragmentFactory", ts3.Diagnostics.Invalid_value_for_jsxFragmentFactory_0_is_not_a_valid_identifier_or_qualified_name, options.jsxFragmentFactory);
            }
          }
          if (options.reactNamespace) {
            if (options.jsx === 4 || options.jsx === 5) {
              createDiagnosticForOptionName(ts3.Diagnostics.Option_0_cannot_be_specified_when_option_jsx_is_1, "reactNamespace", ts3.inverseJsxOptionMap.get("" + options.jsx));
            }
          }
          if (options.jsxImportSource) {
            if (options.jsx === 2) {
              createDiagnosticForOptionName(ts3.Diagnostics.Option_0_cannot_be_specified_when_option_jsx_is_1, "jsxImportSource", ts3.inverseJsxOptionMap.get("" + options.jsx));
            }
          }
          if (!options.noEmit && !options.suppressOutputPathCheck) {
            var emitHost = getEmitHost();
            var emitFilesSeen_1 = new ts3.Set();
            ts3.forEachEmittedFile(emitHost, function(emitFileNames) {
              if (!options.emitDeclarationOnly) {
                verifyEmitFilePath(emitFileNames.jsFilePath, emitFilesSeen_1);
              }
              verifyEmitFilePath(emitFileNames.declarationFilePath, emitFilesSeen_1);
            });
          }
          function verifyEmitFilePath(emitFileName, emitFilesSeen) {
            if (emitFileName) {
              var emitFilePath = toPath(emitFileName);
              if (filesByName.has(emitFilePath)) {
                var chain = void 0;
                if (!options.configFilePath) {
                  chain = ts3.chainDiagnosticMessages(void 0, ts3.Diagnostics.Adding_a_tsconfig_json_file_will_help_organize_projects_that_contain_both_TypeScript_and_JavaScript_files_Learn_more_at_https_Colon_Slash_Slashaka_ms_Slashtsconfig);
                }
                chain = ts3.chainDiagnosticMessages(chain, ts3.Diagnostics.Cannot_write_file_0_because_it_would_overwrite_input_file, emitFileName);
                blockEmittingOfFile(emitFileName, ts3.createCompilerDiagnosticFromMessageChain(chain));
              }
              var emitFileKey = !host.useCaseSensitiveFileNames() ? ts3.toFileNameLowerCase(emitFilePath) : emitFilePath;
              if (emitFilesSeen.has(emitFileKey)) {
                blockEmittingOfFile(emitFileName, ts3.createCompilerDiagnostic(ts3.Diagnostics.Cannot_write_file_0_because_it_would_be_overwritten_by_multiple_input_files, emitFileName));
              } else {
                emitFilesSeen.add(emitFileKey);
              }
            }
          }
        }
        function createDiagnosticExplainingFile(file, fileProcessingReason, diagnostic, args) {
          var _a3;
          var fileIncludeReasons;
          var relatedInfo;
          var locationReason = isReferencedFile(fileProcessingReason) ? fileProcessingReason : void 0;
          if (file)
            (_a3 = fileReasons.get(file.path)) === null || _a3 === void 0 ? void 0 : _a3.forEach(processReason);
          if (fileProcessingReason)
            processReason(fileProcessingReason);
          if (locationReason && (fileIncludeReasons === null || fileIncludeReasons === void 0 ? void 0 : fileIncludeReasons.length) === 1)
            fileIncludeReasons = void 0;
          var location = locationReason && getReferencedFileLocation(getSourceFileByPath, locationReason);
          var fileIncludeReasonDetails = fileIncludeReasons && ts3.chainDiagnosticMessages(fileIncludeReasons, ts3.Diagnostics.The_file_is_in_the_program_because_Colon);
          var redirectInfo = file && ts3.explainIfFileIsRedirect(file);
          var chain = ts3.chainDiagnosticMessages.apply(void 0, __spreadArray([redirectInfo ? fileIncludeReasonDetails ? __spreadArray([fileIncludeReasonDetails], redirectInfo) : redirectInfo : fileIncludeReasonDetails, diagnostic], args || ts3.emptyArray));
          return location && isReferenceFileLocation(location) ? ts3.createFileDiagnosticFromMessageChain(location.file, location.pos, location.end - location.pos, chain, relatedInfo) : ts3.createCompilerDiagnosticFromMessageChain(chain, relatedInfo);
          function processReason(reason) {
            (fileIncludeReasons || (fileIncludeReasons = [])).push(ts3.fileIncludeReasonToDiagnostics(program2, reason));
            if (!locationReason && isReferencedFile(reason)) {
              locationReason = reason;
            } else if (locationReason !== reason) {
              relatedInfo = ts3.append(relatedInfo, fileIncludeReasonToRelatedInformation(reason));
            }
            if (reason === fileProcessingReason)
              fileProcessingReason = void 0;
          }
        }
        function addFilePreprocessingFileExplainingDiagnostic(file, fileProcessingReason, diagnostic, args) {
          (fileProcessingDiagnostics || (fileProcessingDiagnostics = [])).push({
            kind: 1,
            file: file && file.path,
            fileProcessingReason,
            diagnostic,
            args
          });
        }
        function addProgramDiagnosticExplainingFile(file, diagnostic, args) {
          programDiagnostics.add(createDiagnosticExplainingFile(file, void 0, diagnostic, args));
        }
        function fileIncludeReasonToRelatedInformation(reason) {
          if (isReferencedFile(reason)) {
            var referenceLocation = getReferencedFileLocation(getSourceFileByPath, reason);
            var message_2;
            switch (reason.kind) {
              case ts3.FileIncludeKind.Import:
                message_2 = ts3.Diagnostics.File_is_included_via_import_here;
                break;
              case ts3.FileIncludeKind.ReferenceFile:
                message_2 = ts3.Diagnostics.File_is_included_via_reference_here;
                break;
              case ts3.FileIncludeKind.TypeReferenceDirective:
                message_2 = ts3.Diagnostics.File_is_included_via_type_library_reference_here;
                break;
              case ts3.FileIncludeKind.LibReferenceDirective:
                message_2 = ts3.Diagnostics.File_is_included_via_library_reference_here;
                break;
              default:
                ts3.Debug.assertNever(reason);
            }
            return isReferenceFileLocation(referenceLocation) ? ts3.createFileDiagnostic(referenceLocation.file, referenceLocation.pos, referenceLocation.end - referenceLocation.pos, message_2) : void 0;
          }
          if (!options.configFile)
            return void 0;
          var configFileNode;
          var message;
          switch (reason.kind) {
            case ts3.FileIncludeKind.RootFile:
              if (!options.configFile.configFileSpecs)
                return void 0;
              var fileName = ts3.getNormalizedAbsolutePath(rootNames[reason.index], currentDirectory);
              var matchedByFiles = ts3.getMatchedFileSpec(program2, fileName);
              if (matchedByFiles) {
                configFileNode = ts3.getTsConfigPropArrayElementValue(options.configFile, "files", matchedByFiles);
                message = ts3.Diagnostics.File_is_matched_by_files_list_specified_here;
                break;
              }
              var matchedByInclude = ts3.getMatchedIncludeSpec(program2, fileName);
              if (!matchedByInclude)
                return void 0;
              configFileNode = ts3.getTsConfigPropArrayElementValue(options.configFile, "include", matchedByInclude);
              message = ts3.Diagnostics.File_is_matched_by_include_pattern_specified_here;
              break;
            case ts3.FileIncludeKind.SourceFromProjectReference:
            case ts3.FileIncludeKind.OutputFromProjectReference:
              var referencedResolvedRef_1 = ts3.Debug.checkDefined(resolvedProjectReferences === null || resolvedProjectReferences === void 0 ? void 0 : resolvedProjectReferences[reason.index]);
              var referenceInfo = forEachProjectReference(projectReferences, resolvedProjectReferences, function(resolvedRef, parent, index2) {
                return resolvedRef === referencedResolvedRef_1 ? { sourceFile: (parent === null || parent === void 0 ? void 0 : parent.sourceFile) || options.configFile, index: index2 } : void 0;
              });
              if (!referenceInfo)
                return void 0;
              var sourceFile = referenceInfo.sourceFile, index = referenceInfo.index;
              var referencesSyntax = ts3.firstDefined(ts3.getTsConfigPropArray(sourceFile, "references"), function(property) {
                return ts3.isArrayLiteralExpression(property.initializer) ? property.initializer : void 0;
              });
              return referencesSyntax && referencesSyntax.elements.length > index ? ts3.createDiagnosticForNodeInSourceFile(sourceFile, referencesSyntax.elements[index], reason.kind === ts3.FileIncludeKind.OutputFromProjectReference ? ts3.Diagnostics.File_is_output_from_referenced_project_specified_here : ts3.Diagnostics.File_is_source_from_referenced_project_specified_here) : void 0;
            case ts3.FileIncludeKind.AutomaticTypeDirectiveFile:
              if (!options.types)
                return void 0;
              configFileNode = getOptionsSyntaxByArrayElementValue("types", reason.typeReference);
              message = ts3.Diagnostics.File_is_entry_point_of_type_library_specified_here;
              break;
            case ts3.FileIncludeKind.LibFile:
              if (reason.index !== void 0) {
                configFileNode = getOptionsSyntaxByArrayElementValue("lib", options.lib[reason.index]);
                message = ts3.Diagnostics.File_is_library_specified_here;
                break;
              }
              var target = ts3.forEachEntry(ts3.targetOptionDeclaration.type, function(value, key2) {
                return value === options.target ? key2 : void 0;
              });
              configFileNode = target ? getOptionsSyntaxByValue("target", target) : void 0;
              message = ts3.Diagnostics.File_is_default_library_for_target_specified_here;
              break;
            default:
              ts3.Debug.assertNever(reason);
          }
          return configFileNode && ts3.createDiagnosticForNodeInSourceFile(options.configFile, configFileNode, message);
        }
        function verifyProjectReferences() {
          var buildInfoPath = !options.suppressOutputPathCheck ? ts3.getTsBuildInfoEmitOutputFilePath(options) : void 0;
          forEachProjectReference(projectReferences, resolvedProjectReferences, function(resolvedRef, parent, index) {
            var ref2 = (parent ? parent.commandLine.projectReferences : projectReferences)[index];
            var parentFile = parent && parent.sourceFile;
            if (!resolvedRef) {
              createDiagnosticForReference(parentFile, index, ts3.Diagnostics.File_0_not_found, ref2.path);
              return;
            }
            var options2 = resolvedRef.commandLine.options;
            if (!options2.composite || options2.noEmit) {
              var inputs = parent ? parent.commandLine.fileNames : rootNames;
              if (inputs.length) {
                if (!options2.composite)
                  createDiagnosticForReference(parentFile, index, ts3.Diagnostics.Referenced_project_0_must_have_setting_composite_Colon_true, ref2.path);
                if (options2.noEmit)
                  createDiagnosticForReference(parentFile, index, ts3.Diagnostics.Referenced_project_0_may_not_disable_emit, ref2.path);
              }
            }
            if (ref2.prepend) {
              var out = ts3.outFile(options2);
              if (out) {
                if (!host.fileExists(out)) {
                  createDiagnosticForReference(parentFile, index, ts3.Diagnostics.Output_file_0_from_project_1_does_not_exist, out, ref2.path);
                }
              } else {
                createDiagnosticForReference(parentFile, index, ts3.Diagnostics.Cannot_prepend_project_0_because_it_does_not_have_outFile_set, ref2.path);
              }
            }
            if (!parent && buildInfoPath && buildInfoPath === ts3.getTsBuildInfoEmitOutputFilePath(options2)) {
              createDiagnosticForReference(parentFile, index, ts3.Diagnostics.Cannot_write_file_0_because_it_will_overwrite_tsbuildinfo_file_generated_by_referenced_project_1, buildInfoPath, ref2.path);
              hasEmitBlockingDiagnostics.set(toPath(buildInfoPath), true);
            }
          });
        }
        function createDiagnosticForOptionPathKeyValue(key2, valueIndex, message, arg0, arg1, arg2) {
          var needCompilerDiagnostic = true;
          var pathsSyntax = getOptionPathsSyntax();
          for (var _i2 = 0, pathsSyntax_1 = pathsSyntax; _i2 < pathsSyntax_1.length; _i2++) {
            var pathProp = pathsSyntax_1[_i2];
            if (ts3.isObjectLiteralExpression(pathProp.initializer)) {
              for (var _a3 = 0, _b2 = ts3.getPropertyAssignment(pathProp.initializer, key2); _a3 < _b2.length; _a3++) {
                var keyProps = _b2[_a3];
                var initializer = keyProps.initializer;
                if (ts3.isArrayLiteralExpression(initializer) && initializer.elements.length > valueIndex) {
                  programDiagnostics.add(ts3.createDiagnosticForNodeInSourceFile(options.configFile, initializer.elements[valueIndex], message, arg0, arg1, arg2));
                  needCompilerDiagnostic = false;
                }
              }
            }
          }
          if (needCompilerDiagnostic) {
            programDiagnostics.add(ts3.createCompilerDiagnostic(message, arg0, arg1, arg2));
          }
        }
        function createDiagnosticForOptionPaths(onKey, key2, message, arg0) {
          var needCompilerDiagnostic = true;
          var pathsSyntax = getOptionPathsSyntax();
          for (var _i2 = 0, pathsSyntax_2 = pathsSyntax; _i2 < pathsSyntax_2.length; _i2++) {
            var pathProp = pathsSyntax_2[_i2];
            if (ts3.isObjectLiteralExpression(pathProp.initializer) && createOptionDiagnosticInObjectLiteralSyntax(pathProp.initializer, onKey, key2, void 0, message, arg0)) {
              needCompilerDiagnostic = false;
            }
          }
          if (needCompilerDiagnostic) {
            programDiagnostics.add(ts3.createCompilerDiagnostic(message, arg0));
          }
        }
        function getOptionsSyntaxByName(name) {
          var compilerOptionsObjectLiteralSyntax = getCompilerOptionsObjectLiteralSyntax();
          return compilerOptionsObjectLiteralSyntax && ts3.getPropertyAssignment(compilerOptionsObjectLiteralSyntax, name);
        }
        function getOptionPathsSyntax() {
          return getOptionsSyntaxByName("paths") || ts3.emptyArray;
        }
        function getOptionsSyntaxByValue(name, value) {
          var syntaxByName = getOptionsSyntaxByName(name);
          return syntaxByName && ts3.firstDefined(syntaxByName, function(property) {
            return ts3.isStringLiteral(property.initializer) && property.initializer.text === value ? property.initializer : void 0;
          });
        }
        function getOptionsSyntaxByArrayElementValue(name, value) {
          var compilerOptionsObjectLiteralSyntax = getCompilerOptionsObjectLiteralSyntax();
          return compilerOptionsObjectLiteralSyntax && ts3.getPropertyArrayElementValue(compilerOptionsObjectLiteralSyntax, name, value);
        }
        function createDiagnosticForOptionName(message, option1, option2, option3) {
          createDiagnosticForOption(true, option1, option2, message, option1, option2, option3);
        }
        function createOptionValueDiagnostic(option1, message, arg0) {
          createDiagnosticForOption(false, option1, void 0, message, arg0);
        }
        function createDiagnosticForReference(sourceFile, index, message, arg0, arg1) {
          var referencesSyntax = ts3.firstDefined(ts3.getTsConfigPropArray(sourceFile || options.configFile, "references"), function(property) {
            return ts3.isArrayLiteralExpression(property.initializer) ? property.initializer : void 0;
          });
          if (referencesSyntax && referencesSyntax.elements.length > index) {
            programDiagnostics.add(ts3.createDiagnosticForNodeInSourceFile(sourceFile || options.configFile, referencesSyntax.elements[index], message, arg0, arg1));
          } else {
            programDiagnostics.add(ts3.createCompilerDiagnostic(message, arg0, arg1));
          }
        }
        function createDiagnosticForOption(onKey, option1, option2, message, arg0, arg1, arg2) {
          var compilerOptionsObjectLiteralSyntax = getCompilerOptionsObjectLiteralSyntax();
          var needCompilerDiagnostic = !compilerOptionsObjectLiteralSyntax || !createOptionDiagnosticInObjectLiteralSyntax(compilerOptionsObjectLiteralSyntax, onKey, option1, option2, message, arg0, arg1, arg2);
          if (needCompilerDiagnostic) {
            programDiagnostics.add(ts3.createCompilerDiagnostic(message, arg0, arg1, arg2));
          }
        }
        function getCompilerOptionsObjectLiteralSyntax() {
          if (_compilerOptionsObjectLiteralSyntax === void 0) {
            _compilerOptionsObjectLiteralSyntax = false;
            var jsonObjectLiteral = ts3.getTsConfigObjectLiteralExpression(options.configFile);
            if (jsonObjectLiteral) {
              for (var _i2 = 0, _a3 = ts3.getPropertyAssignment(jsonObjectLiteral, "compilerOptions"); _i2 < _a3.length; _i2++) {
                var prop = _a3[_i2];
                if (ts3.isObjectLiteralExpression(prop.initializer)) {
                  _compilerOptionsObjectLiteralSyntax = prop.initializer;
                  break;
                }
              }
            }
          }
          return _compilerOptionsObjectLiteralSyntax || void 0;
        }
        function createOptionDiagnosticInObjectLiteralSyntax(objectLiteral, onKey, key1, key2, message, arg0, arg1, arg2) {
          var props = ts3.getPropertyAssignment(objectLiteral, key1, key2);
          for (var _i2 = 0, props_3 = props; _i2 < props_3.length; _i2++) {
            var prop = props_3[_i2];
            programDiagnostics.add(ts3.createDiagnosticForNodeInSourceFile(options.configFile, onKey ? prop.name : prop.initializer, message, arg0, arg1, arg2));
          }
          return !!props.length;
        }
        function blockEmittingOfFile(emitFileName, diag) {
          hasEmitBlockingDiagnostics.set(toPath(emitFileName), true);
          programDiagnostics.add(diag);
        }
        function isEmittedFile(file) {
          if (options.noEmit) {
            return false;
          }
          var filePath = toPath(file);
          if (getSourceFileByPath(filePath)) {
            return false;
          }
          var out = ts3.outFile(options);
          if (out) {
            return isSameFile(filePath, out) || isSameFile(filePath, ts3.removeFileExtension(out) + ".d.ts");
          }
          if (options.declarationDir && ts3.containsPath(options.declarationDir, filePath, currentDirectory, !host.useCaseSensitiveFileNames())) {
            return true;
          }
          if (options.outDir) {
            return ts3.containsPath(options.outDir, filePath, currentDirectory, !host.useCaseSensitiveFileNames());
          }
          if (ts3.fileExtensionIsOneOf(filePath, ts3.supportedJSExtensions) || ts3.fileExtensionIs(filePath, ".d.ts")) {
            var filePathWithoutExtension = ts3.removeFileExtension(filePath);
            return !!getSourceFileByPath(filePathWithoutExtension + ".ts") || !!getSourceFileByPath(filePathWithoutExtension + ".tsx");
          }
          return false;
        }
        function isSameFile(file1, file2) {
          return ts3.comparePaths(file1, file2, currentDirectory, !host.useCaseSensitiveFileNames()) === 0;
        }
        function getSymlinkCache() {
          if (host.getSymlinkCache) {
            return host.getSymlinkCache();
          }
          return symlinks || (symlinks = ts3.discoverProbableSymlinks(files, getCanonicalFileName, host.getCurrentDirectory()));
        }
      }
      ts3.createProgram = createProgram;
      function updateHostForUseSourceOfProjectReferenceRedirect(host) {
        var setOfDeclarationDirectories;
        var originalFileExists = host.compilerHost.fileExists;
        var originalDirectoryExists = host.compilerHost.directoryExists;
        var originalGetDirectories = host.compilerHost.getDirectories;
        var originalRealpath = host.compilerHost.realpath;
        if (!host.useSourceOfProjectReferenceRedirect)
          return { onProgramCreateComplete: ts3.noop, fileExists };
        host.compilerHost.fileExists = fileExists;
        var directoryExists;
        if (originalDirectoryExists) {
          directoryExists = host.compilerHost.directoryExists = function(path2) {
            if (originalDirectoryExists.call(host.compilerHost, path2)) {
              handleDirectoryCouldBeSymlink(path2);
              return true;
            }
            if (!host.getResolvedProjectReferences())
              return false;
            if (!setOfDeclarationDirectories) {
              setOfDeclarationDirectories = new ts3.Set();
              host.forEachResolvedProjectReference(function(ref2) {
                var out = ts3.outFile(ref2.commandLine.options);
                if (out) {
                  setOfDeclarationDirectories.add(ts3.getDirectoryPath(host.toPath(out)));
                } else {
                  var declarationDir = ref2.commandLine.options.declarationDir || ref2.commandLine.options.outDir;
                  if (declarationDir) {
                    setOfDeclarationDirectories.add(host.toPath(declarationDir));
                  }
                }
              });
            }
            return fileOrDirectoryExistsUsingSource(path2, false);
          };
        }
        if (originalGetDirectories) {
          host.compilerHost.getDirectories = function(path2) {
            return !host.getResolvedProjectReferences() || originalDirectoryExists && originalDirectoryExists.call(host.compilerHost, path2) ? originalGetDirectories.call(host.compilerHost, path2) : [];
          };
        }
        if (originalRealpath) {
          host.compilerHost.realpath = function(s2) {
            var _a2;
            return ((_a2 = host.getSymlinkCache().getSymlinkedFiles()) === null || _a2 === void 0 ? void 0 : _a2.get(host.toPath(s2))) || originalRealpath.call(host.compilerHost, s2);
          };
        }
        return { onProgramCreateComplete, fileExists, directoryExists };
        function onProgramCreateComplete() {
          host.compilerHost.fileExists = originalFileExists;
          host.compilerHost.directoryExists = originalDirectoryExists;
          host.compilerHost.getDirectories = originalGetDirectories;
        }
        function fileExists(file) {
          if (originalFileExists.call(host.compilerHost, file))
            return true;
          if (!host.getResolvedProjectReferences())
            return false;
          if (!ts3.isDeclarationFileName(file))
            return false;
          return fileOrDirectoryExistsUsingSource(file, true);
        }
        function fileExistsIfProjectReferenceDts(file) {
          var source = host.getSourceOfProjectReferenceRedirect(file);
          return source !== void 0 ? ts3.isString(source) ? originalFileExists.call(host.compilerHost, source) : true : void 0;
        }
        function directoryExistsIfProjectReferenceDeclDir(dir) {
          var dirPath = host.toPath(dir);
          var dirPathWithTrailingDirectorySeparator = "" + dirPath + ts3.directorySeparator;
          return ts3.forEachKey(setOfDeclarationDirectories, function(declDirPath) {
            return dirPath === declDirPath || ts3.startsWith(declDirPath, dirPathWithTrailingDirectorySeparator) || ts3.startsWith(dirPath, declDirPath + "/");
          });
        }
        function handleDirectoryCouldBeSymlink(directory) {
          var _a2;
          if (!host.getResolvedProjectReferences() || ts3.containsIgnoredPath(directory))
            return;
          if (!originalRealpath || !ts3.stringContains(directory, ts3.nodeModulesPathPart))
            return;
          var symlinkCache = host.getSymlinkCache();
          var directoryPath = ts3.ensureTrailingDirectorySeparator(host.toPath(directory));
          if ((_a2 = symlinkCache.getSymlinkedDirectories()) === null || _a2 === void 0 ? void 0 : _a2.has(directoryPath))
            return;
          var real = ts3.normalizePath(originalRealpath.call(host.compilerHost, directory));
          var realPath;
          if (real === directory || (realPath = ts3.ensureTrailingDirectorySeparator(host.toPath(real))) === directoryPath) {
            symlinkCache.setSymlinkedDirectory(directoryPath, false);
            return;
          }
          symlinkCache.setSymlinkedDirectory(directory, {
            real: ts3.ensureTrailingDirectorySeparator(real),
            realPath
          });
        }
        function fileOrDirectoryExistsUsingSource(fileOrDirectory, isFile) {
          var _a2;
          var fileOrDirectoryExistsUsingSource2 = isFile ? function(file) {
            return fileExistsIfProjectReferenceDts(file);
          } : function(dir) {
            return directoryExistsIfProjectReferenceDeclDir(dir);
          };
          var result2 = fileOrDirectoryExistsUsingSource2(fileOrDirectory);
          if (result2 !== void 0)
            return result2;
          var symlinkCache = host.getSymlinkCache();
          var symlinkedDirectories = symlinkCache.getSymlinkedDirectories();
          if (!symlinkedDirectories)
            return false;
          var fileOrDirectoryPath = host.toPath(fileOrDirectory);
          if (!ts3.stringContains(fileOrDirectoryPath, ts3.nodeModulesPathPart))
            return false;
          if (isFile && ((_a2 = symlinkCache.getSymlinkedFiles()) === null || _a2 === void 0 ? void 0 : _a2.has(fileOrDirectoryPath)))
            return true;
          return ts3.firstDefinedIterator(symlinkedDirectories.entries(), function(_a3) {
            var directoryPath = _a3[0], symlinkedDirectory = _a3[1];
            if (!symlinkedDirectory || !ts3.startsWith(fileOrDirectoryPath, directoryPath))
              return void 0;
            var result3 = fileOrDirectoryExistsUsingSource2(fileOrDirectoryPath.replace(directoryPath, symlinkedDirectory.realPath));
            if (isFile && result3) {
              var absolutePath = ts3.getNormalizedAbsolutePath(fileOrDirectory, host.compilerHost.getCurrentDirectory());
              symlinkCache.setSymlinkedFile(fileOrDirectoryPath, "" + symlinkedDirectory.real + absolutePath.replace(new RegExp(directoryPath, "i"), ""));
            }
            return result3;
          }) || false;
        }
      }
      ts3.emitSkippedWithNoDiagnostics = { diagnostics: ts3.emptyArray, sourceMaps: void 0, emittedFiles: void 0, emitSkipped: true };
      function handleNoEmitOptions(program2, sourceFile, writeFile, cancellationToken) {
        var options = program2.getCompilerOptions();
        if (options.noEmit) {
          program2.getSemanticDiagnostics(sourceFile, cancellationToken);
          return sourceFile || ts3.outFile(options) ? ts3.emitSkippedWithNoDiagnostics : program2.emitBuildInfo(writeFile, cancellationToken);
        }
        if (!options.noEmitOnError)
          return void 0;
        var diagnostics = __spreadArray(__spreadArray(__spreadArray(__spreadArray([], program2.getOptionsDiagnostics(cancellationToken)), program2.getSyntacticDiagnostics(sourceFile, cancellationToken)), program2.getGlobalDiagnostics(cancellationToken)), program2.getSemanticDiagnostics(sourceFile, cancellationToken));
        if (diagnostics.length === 0 && ts3.getEmitDeclarations(program2.getCompilerOptions())) {
          diagnostics = program2.getDeclarationDiagnostics(void 0, cancellationToken);
        }
        if (!diagnostics.length)
          return void 0;
        var emittedFiles;
        if (!sourceFile && !ts3.outFile(options)) {
          var emitResult = program2.emitBuildInfo(writeFile, cancellationToken);
          if (emitResult.diagnostics)
            diagnostics = __spreadArray(__spreadArray([], diagnostics), emitResult.diagnostics);
          emittedFiles = emitResult.emittedFiles;
        }
        return { diagnostics, sourceMaps: void 0, emittedFiles, emitSkipped: true };
      }
      ts3.handleNoEmitOptions = handleNoEmitOptions;
      function filterSemanticDiagnotics(diagnostic, option) {
        return ts3.filter(diagnostic, function(d) {
          return !d.skippedOn || !option[d.skippedOn];
        });
      }
      ts3.filterSemanticDiagnotics = filterSemanticDiagnotics;
      function parseConfigHostFromCompilerHostLike(host, directoryStructureHost) {
        if (directoryStructureHost === void 0) {
          directoryStructureHost = host;
        }
        return {
          fileExists: function(f) {
            return directoryStructureHost.fileExists(f);
          },
          readDirectory: function(root, extensions, excludes, includes, depth) {
            ts3.Debug.assertIsDefined(directoryStructureHost.readDirectory, "'CompilerHost.readDirectory' must be implemented to correctly process 'projectReferences'");
            return directoryStructureHost.readDirectory(root, extensions, excludes, includes, depth);
          },
          readFile: function(f) {
            return directoryStructureHost.readFile(f);
          },
          useCaseSensitiveFileNames: host.useCaseSensitiveFileNames(),
          getCurrentDirectory: function() {
            return host.getCurrentDirectory();
          },
          onUnRecoverableConfigFileDiagnostic: host.onUnRecoverableConfigFileDiagnostic || ts3.returnUndefined,
          trace: host.trace ? function(s2) {
            return host.trace(s2);
          } : void 0
        };
      }
      ts3.parseConfigHostFromCompilerHostLike = parseConfigHostFromCompilerHostLike;
      function createPrependNodes(projectReferences, getCommandLine, readFile) {
        if (!projectReferences)
          return ts3.emptyArray;
        var nodes;
        for (var i3 = 0; i3 < projectReferences.length; i3++) {
          var ref2 = projectReferences[i3];
          var resolvedRefOpts = getCommandLine(ref2, i3);
          if (ref2.prepend && resolvedRefOpts && resolvedRefOpts.options) {
            var out = ts3.outFile(resolvedRefOpts.options);
            if (!out)
              continue;
            var _a2 = ts3.getOutputPathsForBundle(resolvedRefOpts.options, true), jsFilePath = _a2.jsFilePath, sourceMapFilePath = _a2.sourceMapFilePath, declarationFilePath = _a2.declarationFilePath, declarationMapPath = _a2.declarationMapPath, buildInfoPath = _a2.buildInfoPath;
            var node = ts3.createInputFiles(readFile, jsFilePath, sourceMapFilePath, declarationFilePath, declarationMapPath, buildInfoPath);
            (nodes || (nodes = [])).push(node);
          }
        }
        return nodes || ts3.emptyArray;
      }
      ts3.createPrependNodes = createPrependNodes;
      function resolveProjectReferencePath(hostOrRef, ref2) {
        var passedInRef = ref2 ? ref2 : hostOrRef;
        return ts3.resolveConfigFileProjectName(passedInRef.path);
      }
      ts3.resolveProjectReferencePath = resolveProjectReferencePath;
      function getResolutionDiagnostic(options, _a2) {
        var extension = _a2.extension;
        switch (extension) {
          case ".ts":
          case ".d.ts":
            return void 0;
          case ".tsx":
            return needJsx();
          case ".jsx":
            return needJsx() || needAllowJs();
          case ".js":
            return needAllowJs();
          case ".json":
            return needResolveJsonModule();
        }
        function needJsx() {
          return options.jsx ? void 0 : ts3.Diagnostics.Module_0_was_resolved_to_1_but_jsx_is_not_set;
        }
        function needAllowJs() {
          return ts3.getAllowJSCompilerOption(options) || !ts3.getStrictOptionValue(options, "noImplicitAny") ? void 0 : ts3.Diagnostics.Could_not_find_a_declaration_file_for_module_0_1_implicitly_has_an_any_type;
        }
        function needResolveJsonModule() {
          return options.resolveJsonModule ? void 0 : ts3.Diagnostics.Module_0_was_resolved_to_1_but_resolveJsonModule_is_not_used;
        }
      }
      ts3.getResolutionDiagnostic = getResolutionDiagnostic;
      function getModuleNames(_a2) {
        var imports = _a2.imports, moduleAugmentations = _a2.moduleAugmentations;
        var res = imports.map(function(i3) {
          return i3.text;
        });
        for (var _i = 0, moduleAugmentations_1 = moduleAugmentations; _i < moduleAugmentations_1.length; _i++) {
          var aug = moduleAugmentations_1[_i];
          if (aug.kind === 10) {
            res.push(aug.text);
          }
        }
        return res;
      }
      function getModuleNameStringLiteralAt(_a2, index) {
        var imports = _a2.imports, moduleAugmentations = _a2.moduleAugmentations;
        if (index < imports.length)
          return imports[index];
        var augIndex = imports.length;
        for (var _i = 0, moduleAugmentations_2 = moduleAugmentations; _i < moduleAugmentations_2.length; _i++) {
          var aug = moduleAugmentations_2[_i];
          if (aug.kind === 10) {
            if (index === augIndex)
              return aug;
            augIndex++;
          }
        }
        ts3.Debug.fail("should never ask for module name at index higher than possible module name");
      }
      ts3.getModuleNameStringLiteralAt = getModuleNameStringLiteralAt;
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      function getFileEmitOutput(program2, sourceFile, emitOnlyDtsFiles, cancellationToken, customTransformers, forceDtsEmit) {
        var outputFiles = [];
        var _a2 = program2.emit(sourceFile, writeFile, cancellationToken, emitOnlyDtsFiles, customTransformers, forceDtsEmit), emitSkipped = _a2.emitSkipped, diagnostics = _a2.diagnostics, exportedModulesFromDeclarationEmit = _a2.exportedModulesFromDeclarationEmit;
        return { outputFiles, emitSkipped, diagnostics, exportedModulesFromDeclarationEmit };
        function writeFile(fileName, text, writeByteOrderMark) {
          outputFiles.push({ name: fileName, writeByteOrderMark, text });
        }
      }
      ts3.getFileEmitOutput = getFileEmitOutput;
      var BuilderState;
      (function(BuilderState2) {
        function getReferencedFileFromImportedModuleSymbol(symbol) {
          if (symbol.declarations && symbol.declarations[0]) {
            var declarationSourceFile = ts3.getSourceFileOfNode(symbol.declarations[0]);
            return declarationSourceFile && declarationSourceFile.resolvedPath;
          }
        }
        function getReferencedFileFromImportLiteral(checker, importName) {
          var symbol = checker.getSymbolAtLocation(importName);
          return symbol && getReferencedFileFromImportedModuleSymbol(symbol);
        }
        function getReferencedFileFromFileName(program2, fileName, sourceFileDirectory, getCanonicalFileName) {
          return ts3.toPath(program2.getProjectReferenceRedirect(fileName) || fileName, sourceFileDirectory, getCanonicalFileName);
        }
        function getReferencedFiles(program2, sourceFile, getCanonicalFileName) {
          var referencedFiles;
          if (sourceFile.imports && sourceFile.imports.length > 0) {
            var checker = program2.getTypeChecker();
            for (var _i = 0, _a2 = sourceFile.imports; _i < _a2.length; _i++) {
              var importName = _a2[_i];
              var declarationSourceFilePath = getReferencedFileFromImportLiteral(checker, importName);
              if (declarationSourceFilePath) {
                addReferencedFile(declarationSourceFilePath);
              }
            }
          }
          var sourceFileDirectory = ts3.getDirectoryPath(sourceFile.resolvedPath);
          if (sourceFile.referencedFiles && sourceFile.referencedFiles.length > 0) {
            for (var _b = 0, _c = sourceFile.referencedFiles; _b < _c.length; _b++) {
              var referencedFile = _c[_b];
              var referencedPath = getReferencedFileFromFileName(program2, referencedFile.fileName, sourceFileDirectory, getCanonicalFileName);
              addReferencedFile(referencedPath);
            }
          }
          if (sourceFile.resolvedTypeReferenceDirectiveNames) {
            sourceFile.resolvedTypeReferenceDirectiveNames.forEach(function(resolvedTypeReferenceDirective) {
              if (!resolvedTypeReferenceDirective) {
                return;
              }
              var fileName = resolvedTypeReferenceDirective.resolvedFileName;
              var typeFilePath = getReferencedFileFromFileName(program2, fileName, sourceFileDirectory, getCanonicalFileName);
              addReferencedFile(typeFilePath);
            });
          }
          if (sourceFile.moduleAugmentations.length) {
            var checker = program2.getTypeChecker();
            for (var _d = 0, _e = sourceFile.moduleAugmentations; _d < _e.length; _d++) {
              var moduleName = _e[_d];
              if (!ts3.isStringLiteral(moduleName)) {
                continue;
              }
              var symbol = checker.getSymbolAtLocation(moduleName);
              if (!symbol) {
                continue;
              }
              addReferenceFromAmbientModule(symbol);
            }
          }
          for (var _f = 0, _g = program2.getTypeChecker().getAmbientModules(); _f < _g.length; _f++) {
            var ambientModule = _g[_f];
            if (ambientModule.declarations && ambientModule.declarations.length > 1) {
              addReferenceFromAmbientModule(ambientModule);
            }
          }
          return referencedFiles;
          function addReferenceFromAmbientModule(symbol2) {
            if (!symbol2.declarations) {
              return;
            }
            for (var _i2 = 0, _a3 = symbol2.declarations; _i2 < _a3.length; _i2++) {
              var declaration = _a3[_i2];
              var declarationSourceFile = ts3.getSourceFileOfNode(declaration);
              if (declarationSourceFile && declarationSourceFile !== sourceFile) {
                addReferencedFile(declarationSourceFile.resolvedPath);
              }
            }
          }
          function addReferencedFile(referencedPath2) {
            (referencedFiles || (referencedFiles = new ts3.Set())).add(referencedPath2);
          }
        }
        function canReuseOldState(newReferencedMap, oldState) {
          return oldState && !oldState.referencedMap === !newReferencedMap;
        }
        BuilderState2.canReuseOldState = canReuseOldState;
        function create(newProgram, getCanonicalFileName, oldState, disableUseFileVersionAsSignature) {
          var fileInfos = new ts3.Map();
          var referencedMap = newProgram.getCompilerOptions().module !== ts3.ModuleKind.None ? new ts3.Map() : void 0;
          var exportedModulesMap = referencedMap ? new ts3.Map() : void 0;
          var hasCalledUpdateShapeSignature = new ts3.Set();
          var useOldState = canReuseOldState(referencedMap, oldState);
          newProgram.getTypeChecker();
          for (var _i = 0, _a2 = newProgram.getSourceFiles(); _i < _a2.length; _i++) {
            var sourceFile = _a2[_i];
            var version_2 = ts3.Debug.checkDefined(sourceFile.version, "Program intended to be used with Builder should have source files with versions set");
            var oldInfo = useOldState ? oldState.fileInfos.get(sourceFile.resolvedPath) : void 0;
            if (referencedMap) {
              var newReferences = getReferencedFiles(newProgram, sourceFile, getCanonicalFileName);
              if (newReferences) {
                referencedMap.set(sourceFile.resolvedPath, newReferences);
              }
              if (useOldState) {
                var exportedModules = oldState.exportedModulesMap.get(sourceFile.resolvedPath);
                if (exportedModules) {
                  exportedModulesMap.set(sourceFile.resolvedPath, exportedModules);
                }
              }
            }
            fileInfos.set(sourceFile.resolvedPath, { version: version_2, signature: oldInfo && oldInfo.signature, affectsGlobalScope: isFileAffectingGlobalScope(sourceFile) || void 0 });
          }
          return {
            fileInfos,
            referencedMap,
            exportedModulesMap,
            hasCalledUpdateShapeSignature,
            useFileVersionAsSignature: !disableUseFileVersionAsSignature && !useOldState
          };
        }
        BuilderState2.create = create;
        function releaseCache(state) {
          state.allFilesExcludingDefaultLibraryFile = void 0;
          state.allFileNames = void 0;
        }
        BuilderState2.releaseCache = releaseCache;
        function clone(state) {
          return {
            fileInfos: new ts3.Map(state.fileInfos),
            referencedMap: state.referencedMap && new ts3.Map(state.referencedMap),
            exportedModulesMap: state.exportedModulesMap && new ts3.Map(state.exportedModulesMap),
            hasCalledUpdateShapeSignature: new ts3.Set(state.hasCalledUpdateShapeSignature),
            useFileVersionAsSignature: state.useFileVersionAsSignature
          };
        }
        BuilderState2.clone = clone;
        function getFilesAffectedBy(state, programOfThisState, path2, cancellationToken, computeHash, cacheToUpdateSignature, exportedModulesMapCache) {
          var signatureCache = cacheToUpdateSignature || new ts3.Map();
          var sourceFile = programOfThisState.getSourceFileByPath(path2);
          if (!sourceFile) {
            return ts3.emptyArray;
          }
          if (!updateShapeSignature(state, programOfThisState, sourceFile, signatureCache, cancellationToken, computeHash, exportedModulesMapCache)) {
            return [sourceFile];
          }
          var result2 = (state.referencedMap ? getFilesAffectedByUpdatedShapeWhenModuleEmit : getFilesAffectedByUpdatedShapeWhenNonModuleEmit)(state, programOfThisState, sourceFile, signatureCache, cancellationToken, computeHash, exportedModulesMapCache);
          if (!cacheToUpdateSignature) {
            updateSignaturesFromCache(state, signatureCache);
          }
          return result2;
        }
        BuilderState2.getFilesAffectedBy = getFilesAffectedBy;
        function updateSignaturesFromCache(state, signatureCache) {
          signatureCache.forEach(function(signature, path2) {
            return updateSignatureOfFile(state, signature, path2);
          });
        }
        BuilderState2.updateSignaturesFromCache = updateSignaturesFromCache;
        function updateSignatureOfFile(state, signature, path2) {
          state.fileInfos.get(path2).signature = signature;
          state.hasCalledUpdateShapeSignature.add(path2);
        }
        BuilderState2.updateSignatureOfFile = updateSignatureOfFile;
        function updateShapeSignature(state, programOfThisState, sourceFile, cacheToUpdateSignature, cancellationToken, computeHash, exportedModulesMapCache) {
          ts3.Debug.assert(!!sourceFile);
          ts3.Debug.assert(!exportedModulesMapCache || !!state.exportedModulesMap, "Compute visible to outside map only if visibleToOutsideReferencedMap present in the state");
          if (state.hasCalledUpdateShapeSignature.has(sourceFile.resolvedPath) || cacheToUpdateSignature.has(sourceFile.resolvedPath)) {
            return false;
          }
          var info = state.fileInfos.get(sourceFile.resolvedPath);
          if (!info)
            return ts3.Debug.fail();
          var prevSignature = info.signature;
          var latestSignature;
          if (!sourceFile.isDeclarationFile && !state.useFileVersionAsSignature) {
            var emitOutput_1 = getFileEmitOutput(programOfThisState, sourceFile, true, cancellationToken, void 0, true);
            var firstDts_1 = ts3.firstOrUndefined(emitOutput_1.outputFiles);
            if (firstDts_1) {
              ts3.Debug.assert(ts3.fileExtensionIs(firstDts_1.name, ".d.ts"), "File extension for signature expected to be dts", function() {
                return "Found: " + ts3.getAnyExtensionFromPath(firstDts_1.name) + " for " + firstDts_1.name + ":: All output files: " + JSON.stringify(emitOutput_1.outputFiles.map(function(f) {
                  return f.name;
                }));
              });
              latestSignature = (computeHash || ts3.generateDjb2Hash)(firstDts_1.text);
              if (exportedModulesMapCache && latestSignature !== prevSignature) {
                updateExportedModules(sourceFile, emitOutput_1.exportedModulesFromDeclarationEmit, exportedModulesMapCache);
              }
            }
          }
          if (latestSignature === void 0) {
            latestSignature = sourceFile.version;
            if (exportedModulesMapCache && latestSignature !== prevSignature) {
              var references = state.referencedMap ? state.referencedMap.get(sourceFile.resolvedPath) : void 0;
              exportedModulesMapCache.set(sourceFile.resolvedPath, references || false);
            }
          }
          cacheToUpdateSignature.set(sourceFile.resolvedPath, latestSignature);
          return latestSignature !== prevSignature;
        }
        BuilderState2.updateShapeSignature = updateShapeSignature;
        function updateExportedModules(sourceFile, exportedModulesFromDeclarationEmit, exportedModulesMapCache) {
          if (!exportedModulesFromDeclarationEmit) {
            exportedModulesMapCache.set(sourceFile.resolvedPath, false);
            return;
          }
          var exportedModules;
          exportedModulesFromDeclarationEmit.forEach(function(symbol) {
            return addExportedModule(getReferencedFileFromImportedModuleSymbol(symbol));
          });
          exportedModulesMapCache.set(sourceFile.resolvedPath, exportedModules || false);
          function addExportedModule(exportedModulePath) {
            if (exportedModulePath) {
              if (!exportedModules) {
                exportedModules = new ts3.Set();
              }
              exportedModules.add(exportedModulePath);
            }
          }
        }
        function updateExportedFilesMapFromCache(state, exportedModulesMapCache) {
          if (exportedModulesMapCache) {
            ts3.Debug.assert(!!state.exportedModulesMap);
            exportedModulesMapCache.forEach(function(exportedModules, path2) {
              if (exportedModules) {
                state.exportedModulesMap.set(path2, exportedModules);
              } else {
                state.exportedModulesMap.delete(path2);
              }
            });
          }
        }
        BuilderState2.updateExportedFilesMapFromCache = updateExportedFilesMapFromCache;
        function getAllDependencies(state, programOfThisState, sourceFile) {
          var compilerOptions = programOfThisState.getCompilerOptions();
          if (ts3.outFile(compilerOptions)) {
            return getAllFileNames(state, programOfThisState);
          }
          if (!state.referencedMap || isFileAffectingGlobalScope(sourceFile)) {
            return getAllFileNames(state, programOfThisState);
          }
          var seenMap = new ts3.Set();
          var queue = [sourceFile.resolvedPath];
          while (queue.length) {
            var path2 = queue.pop();
            if (!seenMap.has(path2)) {
              seenMap.add(path2);
              var references = state.referencedMap.get(path2);
              if (references) {
                var iterator = references.keys();
                for (var iterResult = iterator.next(); !iterResult.done; iterResult = iterator.next()) {
                  queue.push(iterResult.value);
                }
              }
            }
          }
          return ts3.arrayFrom(ts3.mapDefinedIterator(seenMap.keys(), function(path3) {
            var _a2, _b;
            return (_b = (_a2 = programOfThisState.getSourceFileByPath(path3)) === null || _a2 === void 0 ? void 0 : _a2.fileName) !== null && _b !== void 0 ? _b : path3;
          }));
        }
        BuilderState2.getAllDependencies = getAllDependencies;
        function getAllFileNames(state, programOfThisState) {
          if (!state.allFileNames) {
            var sourceFiles = programOfThisState.getSourceFiles();
            state.allFileNames = sourceFiles === ts3.emptyArray ? ts3.emptyArray : sourceFiles.map(function(file) {
              return file.fileName;
            });
          }
          return state.allFileNames;
        }
        function getReferencedByPaths(state, referencedFilePath) {
          return ts3.arrayFrom(ts3.mapDefinedIterator(state.referencedMap.entries(), function(_a2) {
            var filePath = _a2[0], referencesInFile = _a2[1];
            return referencesInFile.has(referencedFilePath) ? filePath : void 0;
          }));
        }
        BuilderState2.getReferencedByPaths = getReferencedByPaths;
        function containsOnlyAmbientModules(sourceFile) {
          for (var _i = 0, _a2 = sourceFile.statements; _i < _a2.length; _i++) {
            var statement = _a2[_i];
            if (!ts3.isModuleWithStringLiteralName(statement)) {
              return false;
            }
          }
          return true;
        }
        function containsGlobalScopeAugmentation(sourceFile) {
          return ts3.some(sourceFile.moduleAugmentations, function(augmentation) {
            return ts3.isGlobalScopeAugmentation(augmentation.parent);
          });
        }
        function isFileAffectingGlobalScope(sourceFile) {
          return containsGlobalScopeAugmentation(sourceFile) || !ts3.isExternalOrCommonJsModule(sourceFile) && !containsOnlyAmbientModules(sourceFile);
        }
        function getAllFilesExcludingDefaultLibraryFile(state, programOfThisState, firstSourceFile) {
          if (state.allFilesExcludingDefaultLibraryFile) {
            return state.allFilesExcludingDefaultLibraryFile;
          }
          var result2;
          if (firstSourceFile)
            addSourceFile(firstSourceFile);
          for (var _i = 0, _a2 = programOfThisState.getSourceFiles(); _i < _a2.length; _i++) {
            var sourceFile = _a2[_i];
            if (sourceFile !== firstSourceFile) {
              addSourceFile(sourceFile);
            }
          }
          state.allFilesExcludingDefaultLibraryFile = result2 || ts3.emptyArray;
          return state.allFilesExcludingDefaultLibraryFile;
          function addSourceFile(sourceFile2) {
            if (!programOfThisState.isSourceFileDefaultLibrary(sourceFile2)) {
              (result2 || (result2 = [])).push(sourceFile2);
            }
          }
        }
        BuilderState2.getAllFilesExcludingDefaultLibraryFile = getAllFilesExcludingDefaultLibraryFile;
        function getFilesAffectedByUpdatedShapeWhenNonModuleEmit(state, programOfThisState, sourceFileWithUpdatedShape) {
          var compilerOptions = programOfThisState.getCompilerOptions();
          if (compilerOptions && ts3.outFile(compilerOptions)) {
            return [sourceFileWithUpdatedShape];
          }
          return getAllFilesExcludingDefaultLibraryFile(state, programOfThisState, sourceFileWithUpdatedShape);
        }
        function getFilesAffectedByUpdatedShapeWhenModuleEmit(state, programOfThisState, sourceFileWithUpdatedShape, cacheToUpdateSignature, cancellationToken, computeHash, exportedModulesMapCache) {
          if (isFileAffectingGlobalScope(sourceFileWithUpdatedShape)) {
            return getAllFilesExcludingDefaultLibraryFile(state, programOfThisState, sourceFileWithUpdatedShape);
          }
          var compilerOptions = programOfThisState.getCompilerOptions();
          if (compilerOptions && (compilerOptions.isolatedModules || ts3.outFile(compilerOptions))) {
            return [sourceFileWithUpdatedShape];
          }
          var seenFileNamesMap = new ts3.Map();
          seenFileNamesMap.set(sourceFileWithUpdatedShape.resolvedPath, sourceFileWithUpdatedShape);
          var queue = getReferencedByPaths(state, sourceFileWithUpdatedShape.resolvedPath);
          while (queue.length > 0) {
            var currentPath = queue.pop();
            if (!seenFileNamesMap.has(currentPath)) {
              var currentSourceFile = programOfThisState.getSourceFileByPath(currentPath);
              seenFileNamesMap.set(currentPath, currentSourceFile);
              if (currentSourceFile && updateShapeSignature(state, programOfThisState, currentSourceFile, cacheToUpdateSignature, cancellationToken, computeHash, exportedModulesMapCache)) {
                queue.push.apply(queue, getReferencedByPaths(state, currentSourceFile.resolvedPath));
              }
            }
          }
          return ts3.arrayFrom(ts3.mapDefinedIterator(seenFileNamesMap.values(), function(value) {
            return value;
          }));
        }
      })(BuilderState = ts3.BuilderState || (ts3.BuilderState = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var BuilderFileEmit;
      (function(BuilderFileEmit2) {
        BuilderFileEmit2[BuilderFileEmit2["DtsOnly"] = 0] = "DtsOnly";
        BuilderFileEmit2[BuilderFileEmit2["Full"] = 1] = "Full";
      })(BuilderFileEmit = ts3.BuilderFileEmit || (ts3.BuilderFileEmit = {}));
      function hasSameKeys(map1, map2) {
        return map1 === map2 || map1 !== void 0 && map2 !== void 0 && map1.size === map2.size && !ts3.forEachKey(map1, function(key2) {
          return !map2.has(key2);
        });
      }
      function createBuilderProgramState(newProgram, getCanonicalFileName, oldState, disableUseFileVersionAsSignature) {
        var state = ts3.BuilderState.create(newProgram, getCanonicalFileName, oldState, disableUseFileVersionAsSignature);
        state.program = newProgram;
        var compilerOptions = newProgram.getCompilerOptions();
        state.compilerOptions = compilerOptions;
        if (!ts3.outFile(compilerOptions)) {
          state.semanticDiagnosticsPerFile = new ts3.Map();
        }
        state.changedFilesSet = new ts3.Set();
        var useOldState = ts3.BuilderState.canReuseOldState(state.referencedMap, oldState);
        var oldCompilerOptions = useOldState ? oldState.compilerOptions : void 0;
        var canCopySemanticDiagnostics = useOldState && oldState.semanticDiagnosticsPerFile && !!state.semanticDiagnosticsPerFile && !ts3.compilerOptionsAffectSemanticDiagnostics(compilerOptions, oldCompilerOptions);
        if (useOldState) {
          if (!oldState.currentChangedFilePath) {
            var affectedSignatures = oldState.currentAffectedFilesSignatures;
            ts3.Debug.assert(!oldState.affectedFiles && (!affectedSignatures || !affectedSignatures.size), "Cannot reuse if only few affected files of currentChangedFile were iterated");
          }
          var changedFilesSet = oldState.changedFilesSet;
          if (canCopySemanticDiagnostics) {
            ts3.Debug.assert(!changedFilesSet || !ts3.forEachKey(changedFilesSet, function(path2) {
              return oldState.semanticDiagnosticsPerFile.has(path2);
            }), "Semantic diagnostics shouldnt be available for changed files");
          }
          changedFilesSet === null || changedFilesSet === void 0 ? void 0 : changedFilesSet.forEach(function(value) {
            return state.changedFilesSet.add(value);
          });
          if (!ts3.outFile(compilerOptions) && oldState.affectedFilesPendingEmit) {
            state.affectedFilesPendingEmit = oldState.affectedFilesPendingEmit.slice();
            state.affectedFilesPendingEmitKind = oldState.affectedFilesPendingEmitKind && new ts3.Map(oldState.affectedFilesPendingEmitKind);
            state.affectedFilesPendingEmitIndex = oldState.affectedFilesPendingEmitIndex;
            state.seenAffectedFiles = new ts3.Set();
          }
        }
        var referencedMap = state.referencedMap;
        var oldReferencedMap = useOldState ? oldState.referencedMap : void 0;
        var copyDeclarationFileDiagnostics = canCopySemanticDiagnostics && !compilerOptions.skipLibCheck === !oldCompilerOptions.skipLibCheck;
        var copyLibFileDiagnostics = copyDeclarationFileDiagnostics && !compilerOptions.skipDefaultLibCheck === !oldCompilerOptions.skipDefaultLibCheck;
        state.fileInfos.forEach(function(info, sourceFilePath) {
          var oldInfo;
          var newReferences;
          if (!useOldState || !(oldInfo = oldState.fileInfos.get(sourceFilePath)) || oldInfo.version !== info.version || !hasSameKeys(newReferences = referencedMap && referencedMap.get(sourceFilePath), oldReferencedMap && oldReferencedMap.get(sourceFilePath)) || newReferences && ts3.forEachKey(newReferences, function(path2) {
            return !state.fileInfos.has(path2) && oldState.fileInfos.has(path2);
          })) {
            state.changedFilesSet.add(sourceFilePath);
          } else if (canCopySemanticDiagnostics) {
            var sourceFile = newProgram.getSourceFileByPath(sourceFilePath);
            if (sourceFile.isDeclarationFile && !copyDeclarationFileDiagnostics) {
              return;
            }
            if (sourceFile.hasNoDefaultLib && !copyLibFileDiagnostics) {
              return;
            }
            var diagnostics = oldState.semanticDiagnosticsPerFile.get(sourceFilePath);
            if (diagnostics) {
              state.semanticDiagnosticsPerFile.set(sourceFilePath, oldState.hasReusableDiagnostic ? convertToDiagnostics(diagnostics, newProgram, getCanonicalFileName) : diagnostics);
              if (!state.semanticDiagnosticsFromOldState) {
                state.semanticDiagnosticsFromOldState = new ts3.Set();
              }
              state.semanticDiagnosticsFromOldState.add(sourceFilePath);
            }
          }
        });
        if (useOldState && ts3.forEachEntry(oldState.fileInfos, function(info, sourceFilePath) {
          return info.affectsGlobalScope && !state.fileInfos.has(sourceFilePath);
        })) {
          ts3.BuilderState.getAllFilesExcludingDefaultLibraryFile(state, newProgram, void 0).forEach(function(file) {
            return state.changedFilesSet.add(file.resolvedPath);
          });
        } else if (oldCompilerOptions && !ts3.outFile(compilerOptions) && ts3.compilerOptionsAffectEmit(compilerOptions, oldCompilerOptions)) {
          newProgram.getSourceFiles().forEach(function(f) {
            return addToAffectedFilesPendingEmit(state, f.resolvedPath, 1);
          });
          ts3.Debug.assert(!state.seenAffectedFiles || !state.seenAffectedFiles.size);
          state.seenAffectedFiles = state.seenAffectedFiles || new ts3.Set();
        }
        state.buildInfoEmitPending = !!state.changedFilesSet.size;
        return state;
      }
      function convertToDiagnostics(diagnostics, newProgram, getCanonicalFileName) {
        if (!diagnostics.length)
          return ts3.emptyArray;
        var buildInfoDirectory = ts3.getDirectoryPath(ts3.getNormalizedAbsolutePath(ts3.getTsBuildInfoEmitOutputFilePath(newProgram.getCompilerOptions()), newProgram.getCurrentDirectory()));
        return diagnostics.map(function(diagnostic) {
          var result2 = convertToDiagnosticRelatedInformation(diagnostic, newProgram, toPath);
          result2.reportsUnnecessary = diagnostic.reportsUnnecessary;
          result2.reportsDeprecated = diagnostic.reportDeprecated;
          result2.source = diagnostic.source;
          result2.skippedOn = diagnostic.skippedOn;
          var relatedInformation = diagnostic.relatedInformation;
          result2.relatedInformation = relatedInformation ? relatedInformation.length ? relatedInformation.map(function(r2) {
            return convertToDiagnosticRelatedInformation(r2, newProgram, toPath);
          }) : [] : void 0;
          return result2;
        });
        function toPath(path2) {
          return ts3.toPath(path2, buildInfoDirectory, getCanonicalFileName);
        }
      }
      function convertToDiagnosticRelatedInformation(diagnostic, newProgram, toPath) {
        var file = diagnostic.file;
        return __assign(__assign({}, diagnostic), { file: file ? newProgram.getSourceFileByPath(toPath(file)) : void 0 });
      }
      function releaseCache(state) {
        ts3.BuilderState.releaseCache(state);
        state.program = void 0;
      }
      function cloneBuilderProgramState(state) {
        var newState = ts3.BuilderState.clone(state);
        newState.semanticDiagnosticsPerFile = state.semanticDiagnosticsPerFile && new ts3.Map(state.semanticDiagnosticsPerFile);
        newState.changedFilesSet = new ts3.Set(state.changedFilesSet);
        newState.affectedFiles = state.affectedFiles;
        newState.affectedFilesIndex = state.affectedFilesIndex;
        newState.currentChangedFilePath = state.currentChangedFilePath;
        newState.currentAffectedFilesSignatures = state.currentAffectedFilesSignatures && new ts3.Map(state.currentAffectedFilesSignatures);
        newState.currentAffectedFilesExportedModulesMap = state.currentAffectedFilesExportedModulesMap && new ts3.Map(state.currentAffectedFilesExportedModulesMap);
        newState.seenAffectedFiles = state.seenAffectedFiles && new ts3.Set(state.seenAffectedFiles);
        newState.cleanedDiagnosticsOfLibFiles = state.cleanedDiagnosticsOfLibFiles;
        newState.semanticDiagnosticsFromOldState = state.semanticDiagnosticsFromOldState && new ts3.Set(state.semanticDiagnosticsFromOldState);
        newState.program = state.program;
        newState.compilerOptions = state.compilerOptions;
        newState.affectedFilesPendingEmit = state.affectedFilesPendingEmit && state.affectedFilesPendingEmit.slice();
        newState.affectedFilesPendingEmitKind = state.affectedFilesPendingEmitKind && new ts3.Map(state.affectedFilesPendingEmitKind);
        newState.affectedFilesPendingEmitIndex = state.affectedFilesPendingEmitIndex;
        newState.seenEmittedFiles = state.seenEmittedFiles && new ts3.Map(state.seenEmittedFiles);
        newState.programEmitComplete = state.programEmitComplete;
        return newState;
      }
      function assertSourceFileOkWithoutNextAffectedCall(state, sourceFile) {
        ts3.Debug.assert(!sourceFile || !state.affectedFiles || state.affectedFiles[state.affectedFilesIndex - 1] !== sourceFile || !state.semanticDiagnosticsPerFile.has(sourceFile.resolvedPath));
      }
      function getNextAffectedFile(state, cancellationToken, computeHash) {
        while (true) {
          var affectedFiles = state.affectedFiles;
          if (affectedFiles) {
            var seenAffectedFiles = state.seenAffectedFiles;
            var affectedFilesIndex = state.affectedFilesIndex;
            while (affectedFilesIndex < affectedFiles.length) {
              var affectedFile = affectedFiles[affectedFilesIndex];
              if (!seenAffectedFiles.has(affectedFile.resolvedPath)) {
                state.affectedFilesIndex = affectedFilesIndex;
                handleDtsMayChangeOfAffectedFile(state, affectedFile, cancellationToken, computeHash);
                return affectedFile;
              }
              affectedFilesIndex++;
            }
            state.changedFilesSet.delete(state.currentChangedFilePath);
            state.currentChangedFilePath = void 0;
            ts3.BuilderState.updateSignaturesFromCache(state, state.currentAffectedFilesSignatures);
            state.currentAffectedFilesSignatures.clear();
            ts3.BuilderState.updateExportedFilesMapFromCache(state, state.currentAffectedFilesExportedModulesMap);
            state.affectedFiles = void 0;
          }
          var nextKey = state.changedFilesSet.keys().next();
          if (nextKey.done) {
            return void 0;
          }
          var program2 = ts3.Debug.checkDefined(state.program);
          var compilerOptions = program2.getCompilerOptions();
          if (ts3.outFile(compilerOptions)) {
            ts3.Debug.assert(!state.semanticDiagnosticsPerFile);
            return program2;
          }
          if (!state.currentAffectedFilesSignatures)
            state.currentAffectedFilesSignatures = new ts3.Map();
          if (state.exportedModulesMap) {
            if (!state.currentAffectedFilesExportedModulesMap)
              state.currentAffectedFilesExportedModulesMap = new ts3.Map();
          }
          state.affectedFiles = ts3.BuilderState.getFilesAffectedBy(state, program2, nextKey.value, cancellationToken, computeHash, state.currentAffectedFilesSignatures, state.currentAffectedFilesExportedModulesMap);
          state.currentChangedFilePath = nextKey.value;
          state.affectedFilesIndex = 0;
          if (!state.seenAffectedFiles)
            state.seenAffectedFiles = new ts3.Set();
        }
      }
      function getNextAffectedFilePendingEmit(state) {
        var affectedFilesPendingEmit = state.affectedFilesPendingEmit;
        if (affectedFilesPendingEmit) {
          var seenEmittedFiles = state.seenEmittedFiles || (state.seenEmittedFiles = new ts3.Map());
          for (var i3 = state.affectedFilesPendingEmitIndex; i3 < affectedFilesPendingEmit.length; i3++) {
            var affectedFile = ts3.Debug.checkDefined(state.program).getSourceFileByPath(affectedFilesPendingEmit[i3]);
            if (affectedFile) {
              var seenKind = seenEmittedFiles.get(affectedFile.resolvedPath);
              var emitKind = ts3.Debug.checkDefined(ts3.Debug.checkDefined(state.affectedFilesPendingEmitKind).get(affectedFile.resolvedPath));
              if (seenKind === void 0 || seenKind < emitKind) {
                state.affectedFilesPendingEmitIndex = i3;
                return { affectedFile, emitKind };
              }
            }
          }
          state.affectedFilesPendingEmit = void 0;
          state.affectedFilesPendingEmitKind = void 0;
          state.affectedFilesPendingEmitIndex = void 0;
        }
        return void 0;
      }
      function handleDtsMayChangeOfAffectedFile(state, affectedFile, cancellationToken, computeHash) {
        var _a2;
        removeSemanticDiagnosticsOf(state, affectedFile.resolvedPath);
        if (state.allFilesExcludingDefaultLibraryFile === state.affectedFiles) {
          if (!state.cleanedDiagnosticsOfLibFiles) {
            state.cleanedDiagnosticsOfLibFiles = true;
            var program_1 = ts3.Debug.checkDefined(state.program);
            var options_2 = program_1.getCompilerOptions();
            ts3.forEach(program_1.getSourceFiles(), function(f) {
              return program_1.isSourceFileDefaultLibrary(f) && !ts3.skipTypeChecking(f, options_2, program_1) && removeSemanticDiagnosticsOf(state, f.resolvedPath);
            });
          }
          ts3.BuilderState.updateShapeSignature(state, ts3.Debug.checkDefined(state.program), affectedFile, ts3.Debug.checkDefined(state.currentAffectedFilesSignatures), cancellationToken, computeHash, state.currentAffectedFilesExportedModulesMap);
          return;
        } else {
          ts3.Debug.assert(state.hasCalledUpdateShapeSignature.has(affectedFile.resolvedPath) || ((_a2 = state.currentAffectedFilesSignatures) === null || _a2 === void 0 ? void 0 : _a2.has(affectedFile.resolvedPath)), "Signature not updated for affected file: " + affectedFile.fileName);
        }
        if (!state.compilerOptions.assumeChangesOnlyAffectDirectDependencies) {
          forEachReferencingModulesOfExportOfAffectedFile(state, affectedFile, function(state2, path2) {
            return handleDtsMayChangeOf(state2, path2, cancellationToken, computeHash);
          });
        }
      }
      function handleDtsMayChangeOf(state, path2, cancellationToken, computeHash) {
        removeSemanticDiagnosticsOf(state, path2);
        if (!state.changedFilesSet.has(path2)) {
          var program2 = ts3.Debug.checkDefined(state.program);
          var sourceFile = program2.getSourceFileByPath(path2);
          if (sourceFile) {
            ts3.BuilderState.updateShapeSignature(state, program2, sourceFile, ts3.Debug.checkDefined(state.currentAffectedFilesSignatures), cancellationToken, computeHash, state.currentAffectedFilesExportedModulesMap);
            if (ts3.getEmitDeclarations(state.compilerOptions)) {
              addToAffectedFilesPendingEmit(state, path2, 0);
            }
          }
        }
        return false;
      }
      function removeSemanticDiagnosticsOf(state, path2) {
        if (!state.semanticDiagnosticsFromOldState) {
          return true;
        }
        state.semanticDiagnosticsFromOldState.delete(path2);
        state.semanticDiagnosticsPerFile.delete(path2);
        return !state.semanticDiagnosticsFromOldState.size;
      }
      function isChangedSignature(state, path2) {
        var newSignature = ts3.Debug.checkDefined(state.currentAffectedFilesSignatures).get(path2);
        var oldSignature = ts3.Debug.checkDefined(state.fileInfos.get(path2)).signature;
        return newSignature !== oldSignature;
      }
      function forEachReferencingModulesOfExportOfAffectedFile(state, affectedFile, fn) {
        if (!state.exportedModulesMap || !state.changedFilesSet.has(affectedFile.resolvedPath)) {
          return;
        }
        if (!isChangedSignature(state, affectedFile.resolvedPath))
          return;
        if (state.compilerOptions.isolatedModules) {
          var seenFileNamesMap = new ts3.Map();
          seenFileNamesMap.set(affectedFile.resolvedPath, true);
          var queue = ts3.BuilderState.getReferencedByPaths(state, affectedFile.resolvedPath);
          while (queue.length > 0) {
            var currentPath = queue.pop();
            if (!seenFileNamesMap.has(currentPath)) {
              seenFileNamesMap.set(currentPath, true);
              var result2 = fn(state, currentPath);
              if (result2 && isChangedSignature(state, currentPath)) {
                var currentSourceFile = ts3.Debug.checkDefined(state.program).getSourceFileByPath(currentPath);
                queue.push.apply(queue, ts3.BuilderState.getReferencedByPaths(state, currentSourceFile.resolvedPath));
              }
            }
          }
        }
        ts3.Debug.assert(!!state.currentAffectedFilesExportedModulesMap);
        var seenFileAndExportsOfFile = new ts3.Set();
        if (ts3.forEachEntry(state.currentAffectedFilesExportedModulesMap, function(exportedModules, exportedFromPath) {
          return exportedModules && exportedModules.has(affectedFile.resolvedPath) && forEachFilesReferencingPath(state, exportedFromPath, seenFileAndExportsOfFile, fn);
        })) {
          return;
        }
        ts3.forEachEntry(state.exportedModulesMap, function(exportedModules, exportedFromPath) {
          return !state.currentAffectedFilesExportedModulesMap.has(exportedFromPath) && exportedModules.has(affectedFile.resolvedPath) && forEachFilesReferencingPath(state, exportedFromPath, seenFileAndExportsOfFile, fn);
        });
      }
      function forEachFilesReferencingPath(state, referencedPath, seenFileAndExportsOfFile, fn) {
        return ts3.forEachEntry(state.referencedMap, function(referencesInFile, filePath) {
          return referencesInFile.has(referencedPath) && forEachFileAndExportsOfFile(state, filePath, seenFileAndExportsOfFile, fn);
        });
      }
      function forEachFileAndExportsOfFile(state, filePath, seenFileAndExportsOfFile, fn) {
        if (!ts3.tryAddToSet(seenFileAndExportsOfFile, filePath)) {
          return false;
        }
        if (fn(state, filePath)) {
          return true;
        }
        ts3.Debug.assert(!!state.currentAffectedFilesExportedModulesMap);
        if (ts3.forEachEntry(state.currentAffectedFilesExportedModulesMap, function(exportedModules, exportedFromPath) {
          return exportedModules && exportedModules.has(filePath) && forEachFileAndExportsOfFile(state, exportedFromPath, seenFileAndExportsOfFile, fn);
        })) {
          return true;
        }
        if (ts3.forEachEntry(state.exportedModulesMap, function(exportedModules, exportedFromPath) {
          return !state.currentAffectedFilesExportedModulesMap.has(exportedFromPath) && exportedModules.has(filePath) && forEachFileAndExportsOfFile(state, exportedFromPath, seenFileAndExportsOfFile, fn);
        })) {
          return true;
        }
        return !!ts3.forEachEntry(state.referencedMap, function(referencesInFile, referencingFilePath) {
          return referencesInFile.has(filePath) && !seenFileAndExportsOfFile.has(referencingFilePath) && fn(state, referencingFilePath);
        });
      }
      function doneWithAffectedFile(state, affected, emitKind, isPendingEmit, isBuildInfoEmit) {
        if (isBuildInfoEmit) {
          state.buildInfoEmitPending = false;
        } else if (affected === state.program) {
          state.changedFilesSet.clear();
          state.programEmitComplete = true;
        } else {
          state.seenAffectedFiles.add(affected.resolvedPath);
          if (emitKind !== void 0) {
            (state.seenEmittedFiles || (state.seenEmittedFiles = new ts3.Map())).set(affected.resolvedPath, emitKind);
          }
          if (isPendingEmit) {
            state.affectedFilesPendingEmitIndex++;
            state.buildInfoEmitPending = true;
          } else {
            state.affectedFilesIndex++;
          }
        }
      }
      function toAffectedFileResult(state, result2, affected) {
        doneWithAffectedFile(state, affected);
        return { result: result2, affected };
      }
      function toAffectedFileEmitResult(state, result2, affected, emitKind, isPendingEmit, isBuildInfoEmit) {
        doneWithAffectedFile(state, affected, emitKind, isPendingEmit, isBuildInfoEmit);
        return { result: result2, affected };
      }
      function getSemanticDiagnosticsOfFile(state, sourceFile, cancellationToken) {
        return ts3.concatenate(getBinderAndCheckerDiagnosticsOfFile(state, sourceFile, cancellationToken), ts3.Debug.checkDefined(state.program).getProgramDiagnostics(sourceFile));
      }
      function getBinderAndCheckerDiagnosticsOfFile(state, sourceFile, cancellationToken) {
        var path2 = sourceFile.resolvedPath;
        if (state.semanticDiagnosticsPerFile) {
          var cachedDiagnostics = state.semanticDiagnosticsPerFile.get(path2);
          if (cachedDiagnostics) {
            return ts3.filterSemanticDiagnotics(cachedDiagnostics, state.compilerOptions);
          }
        }
        var diagnostics = ts3.Debug.checkDefined(state.program).getBindAndCheckDiagnostics(sourceFile, cancellationToken);
        if (state.semanticDiagnosticsPerFile) {
          state.semanticDiagnosticsPerFile.set(path2, diagnostics);
        }
        return ts3.filterSemanticDiagnotics(diagnostics, state.compilerOptions);
      }
      function getProgramBuildInfo(state, getCanonicalFileName) {
        if (ts3.outFile(state.compilerOptions))
          return void 0;
        var currentDirectory = ts3.Debug.checkDefined(state.program).getCurrentDirectory();
        var buildInfoDirectory = ts3.getDirectoryPath(ts3.getNormalizedAbsolutePath(ts3.getTsBuildInfoEmitOutputFilePath(state.compilerOptions), currentDirectory));
        var fileNames = [];
        var fileNameToFileId = new ts3.Map();
        var fileIdsList;
        var fileNamesToFileIdListId;
        var fileInfos = ts3.arrayFrom(state.fileInfos.entries(), function(_a3) {
          var key3 = _a3[0], value2 = _a3[1];
          var fileId = toFileId(key3);
          ts3.Debug.assert(fileNames[fileId - 1] === relativeToBuildInfo(key3));
          var signature = state.currentAffectedFilesSignatures && state.currentAffectedFilesSignatures.get(key3);
          var actualSignature = signature !== null && signature !== void 0 ? signature : value2.signature;
          return value2.version === actualSignature ? value2.affectsGlobalScope ? { version: value2.version, signature: void 0, affectsGlobalScope: true } : value2.version : actualSignature !== void 0 ? signature === void 0 ? value2 : { version: value2.version, signature, affectsGlobalScope: value2.affectsGlobalScope } : { version: value2.version, signature: false, affectsGlobalScope: value2.affectsGlobalScope };
        });
        var referencedMap;
        if (state.referencedMap) {
          referencedMap = ts3.arrayFrom(state.referencedMap.keys()).sort(ts3.compareStringsCaseSensitive).map(function(key3) {
            return [
              toFileId(key3),
              toFileIdListId(state.referencedMap.get(key3))
            ];
          });
        }
        var exportedModulesMap;
        if (state.exportedModulesMap) {
          exportedModulesMap = ts3.mapDefined(ts3.arrayFrom(state.exportedModulesMap.keys()).sort(ts3.compareStringsCaseSensitive), function(key3) {
            var newValue = state.currentAffectedFilesExportedModulesMap && state.currentAffectedFilesExportedModulesMap.get(key3);
            if (newValue === void 0)
              return [toFileId(key3), toFileIdListId(state.exportedModulesMap.get(key3))];
            else if (newValue)
              return [toFileId(key3), toFileIdListId(newValue)];
          });
        }
        var semanticDiagnosticsPerFile;
        if (state.semanticDiagnosticsPerFile) {
          for (var _i = 0, _a2 = ts3.arrayFrom(state.semanticDiagnosticsPerFile.keys()).sort(ts3.compareStringsCaseSensitive); _i < _a2.length; _i++) {
            var key2 = _a2[_i];
            var value = state.semanticDiagnosticsPerFile.get(key2);
            (semanticDiagnosticsPerFile || (semanticDiagnosticsPerFile = [])).push(value.length ? [
              toFileId(key2),
              state.hasReusableDiagnostic ? value : convertToReusableDiagnostics(value, relativeToBuildInfo)
            ] : toFileId(key2));
          }
        }
        var affectedFilesPendingEmit;
        if (state.affectedFilesPendingEmit) {
          var seenFiles = new ts3.Set();
          for (var _b = 0, _c = state.affectedFilesPendingEmit.slice(state.affectedFilesPendingEmitIndex).sort(ts3.compareStringsCaseSensitive); _b < _c.length; _b++) {
            var path2 = _c[_b];
            if (ts3.tryAddToSet(seenFiles, path2)) {
              (affectedFilesPendingEmit || (affectedFilesPendingEmit = [])).push([toFileId(path2), state.affectedFilesPendingEmitKind.get(path2)]);
            }
          }
        }
        return {
          fileNames,
          fileInfos,
          options: convertToProgramBuildInfoCompilerOptions(state.compilerOptions, relativeToBuildInfoEnsuringAbsolutePath),
          fileIdsList,
          referencedMap,
          exportedModulesMap,
          semanticDiagnosticsPerFile,
          affectedFilesPendingEmit
        };
        function relativeToBuildInfoEnsuringAbsolutePath(path3) {
          return relativeToBuildInfo(ts3.getNormalizedAbsolutePath(path3, currentDirectory));
        }
        function relativeToBuildInfo(path3) {
          return ts3.ensurePathIsNonModuleName(ts3.getRelativePathFromDirectory(buildInfoDirectory, path3, getCanonicalFileName));
        }
        function toFileId(path3) {
          var fileId = fileNameToFileId.get(path3);
          if (fileId === void 0) {
            fileNames.push(relativeToBuildInfo(path3));
            fileNameToFileId.set(path3, fileId = fileNames.length);
          }
          return fileId;
        }
        function toFileIdListId(set2) {
          var fileIds = ts3.arrayFrom(set2.keys(), toFileId).sort(ts3.compareValues);
          var key3 = fileIds.join();
          var fileIdListId = fileNamesToFileIdListId === null || fileNamesToFileIdListId === void 0 ? void 0 : fileNamesToFileIdListId.get(key3);
          if (fileIdListId === void 0) {
            (fileIdsList || (fileIdsList = [])).push(fileIds);
            (fileNamesToFileIdListId || (fileNamesToFileIdListId = new ts3.Map())).set(key3, fileIdListId = fileIdsList.length);
          }
          return fileIdListId;
        }
      }
      function convertToProgramBuildInfoCompilerOptions(options, relativeToBuildInfo) {
        var result2;
        var optionsNameMap = ts3.getOptionsNameMap().optionsNameMap;
        for (var _i = 0, _a2 = ts3.getOwnKeys(options).sort(ts3.compareStringsCaseSensitive); _i < _a2.length; _i++) {
          var name = _a2[_i];
          var optionKey = name.toLowerCase();
          var optionInfo = optionsNameMap.get(optionKey);
          if ((optionInfo === null || optionInfo === void 0 ? void 0 : optionInfo.affectsEmit) || (optionInfo === null || optionInfo === void 0 ? void 0 : optionInfo.affectsSemanticDiagnostics) || optionKey === "strict" || optionKey === "skiplibcheck" || optionKey === "skipdefaultlibcheck") {
            (result2 || (result2 = {}))[name] = convertToReusableCompilerOptionValue(optionInfo, options[name], relativeToBuildInfo);
          }
        }
        return result2;
      }
      function convertToReusableCompilerOptionValue(option, value, relativeToBuildInfo) {
        if (option) {
          if (option.type === "list") {
            var values = value;
            if (option.element.isFilePath && values.length) {
              return values.map(relativeToBuildInfo);
            }
          } else if (option.isFilePath) {
            return relativeToBuildInfo(value);
          }
        }
        return value;
      }
      function convertToReusableDiagnostics(diagnostics, relativeToBuildInfo) {
        ts3.Debug.assert(!!diagnostics.length);
        return diagnostics.map(function(diagnostic) {
          var result2 = convertToReusableDiagnosticRelatedInformation(diagnostic, relativeToBuildInfo);
          result2.reportsUnnecessary = diagnostic.reportsUnnecessary;
          result2.reportDeprecated = diagnostic.reportsDeprecated;
          result2.source = diagnostic.source;
          result2.skippedOn = diagnostic.skippedOn;
          var relatedInformation = diagnostic.relatedInformation;
          result2.relatedInformation = relatedInformation ? relatedInformation.length ? relatedInformation.map(function(r2) {
            return convertToReusableDiagnosticRelatedInformation(r2, relativeToBuildInfo);
          }) : [] : void 0;
          return result2;
        });
      }
      function convertToReusableDiagnosticRelatedInformation(diagnostic, relativeToBuildInfo) {
        var file = diagnostic.file;
        return __assign(__assign({}, diagnostic), { file: file ? relativeToBuildInfo(file.resolvedPath) : void 0 });
      }
      var BuilderProgramKind;
      (function(BuilderProgramKind2) {
        BuilderProgramKind2[BuilderProgramKind2["SemanticDiagnosticsBuilderProgram"] = 0] = "SemanticDiagnosticsBuilderProgram";
        BuilderProgramKind2[BuilderProgramKind2["EmitAndSemanticDiagnosticsBuilderProgram"] = 1] = "EmitAndSemanticDiagnosticsBuilderProgram";
      })(BuilderProgramKind = ts3.BuilderProgramKind || (ts3.BuilderProgramKind = {}));
      function getBuilderCreationParameters(newProgramOrRootNames, hostOrOptions, oldProgramOrHost, configFileParsingDiagnosticsOrOldProgram, configFileParsingDiagnostics, projectReferences) {
        var host;
        var newProgram;
        var oldProgram;
        if (newProgramOrRootNames === void 0) {
          ts3.Debug.assert(hostOrOptions === void 0);
          host = oldProgramOrHost;
          oldProgram = configFileParsingDiagnosticsOrOldProgram;
          ts3.Debug.assert(!!oldProgram);
          newProgram = oldProgram.getProgram();
        } else if (ts3.isArray(newProgramOrRootNames)) {
          oldProgram = configFileParsingDiagnosticsOrOldProgram;
          newProgram = ts3.createProgram({
            rootNames: newProgramOrRootNames,
            options: hostOrOptions,
            host: oldProgramOrHost,
            oldProgram: oldProgram && oldProgram.getProgramOrUndefined(),
            configFileParsingDiagnostics,
            projectReferences
          });
          host = oldProgramOrHost;
        } else {
          newProgram = newProgramOrRootNames;
          host = hostOrOptions;
          oldProgram = oldProgramOrHost;
          configFileParsingDiagnostics = configFileParsingDiagnosticsOrOldProgram;
        }
        return { host, newProgram, oldProgram, configFileParsingDiagnostics: configFileParsingDiagnostics || ts3.emptyArray };
      }
      ts3.getBuilderCreationParameters = getBuilderCreationParameters;
      function createBuilderProgram(kind, _a2) {
        var newProgram = _a2.newProgram, host = _a2.host, oldProgram = _a2.oldProgram, configFileParsingDiagnostics = _a2.configFileParsingDiagnostics;
        var oldState = oldProgram && oldProgram.getState();
        if (oldState && newProgram === oldState.program && configFileParsingDiagnostics === newProgram.getConfigFileParsingDiagnostics()) {
          newProgram = void 0;
          oldState = void 0;
          return oldProgram;
        }
        var getCanonicalFileName = ts3.createGetCanonicalFileName(host.useCaseSensitiveFileNames());
        var computeHash = ts3.maybeBind(host, host.createHash);
        var state = createBuilderProgramState(newProgram, getCanonicalFileName, oldState, host.disableUseFileVersionAsSignature);
        var backupState;
        newProgram.getProgramBuildInfo = function() {
          return getProgramBuildInfo(state, getCanonicalFileName);
        };
        newProgram = void 0;
        oldProgram = void 0;
        oldState = void 0;
        var builderProgram = createRedirectedBuilderProgram(state, configFileParsingDiagnostics);
        builderProgram.getState = function() {
          return state;
        };
        builderProgram.backupState = function() {
          ts3.Debug.assert(backupState === void 0);
          backupState = cloneBuilderProgramState(state);
        };
        builderProgram.restoreState = function() {
          state = ts3.Debug.checkDefined(backupState);
          backupState = void 0;
        };
        builderProgram.getAllDependencies = function(sourceFile) {
          return ts3.BuilderState.getAllDependencies(state, ts3.Debug.checkDefined(state.program), sourceFile);
        };
        builderProgram.getSemanticDiagnostics = getSemanticDiagnostics;
        builderProgram.emit = emit;
        builderProgram.releaseProgram = function() {
          releaseCache(state);
          backupState = void 0;
        };
        if (kind === BuilderProgramKind.SemanticDiagnosticsBuilderProgram) {
          builderProgram.getSemanticDiagnosticsOfNextAffectedFile = getSemanticDiagnosticsOfNextAffectedFile;
        } else if (kind === BuilderProgramKind.EmitAndSemanticDiagnosticsBuilderProgram) {
          builderProgram.getSemanticDiagnosticsOfNextAffectedFile = getSemanticDiagnosticsOfNextAffectedFile;
          builderProgram.emitNextAffectedFile = emitNextAffectedFile;
          builderProgram.emitBuildInfo = emitBuildInfo;
        } else {
          ts3.notImplemented();
        }
        return builderProgram;
        function emitBuildInfo(writeFile, cancellationToken) {
          if (state.buildInfoEmitPending) {
            var result2 = ts3.Debug.checkDefined(state.program).emitBuildInfo(writeFile || ts3.maybeBind(host, host.writeFile), cancellationToken);
            state.buildInfoEmitPending = false;
            return result2;
          }
          return ts3.emitSkippedWithNoDiagnostics;
        }
        function emitNextAffectedFile(writeFile, cancellationToken, emitOnlyDtsFiles, customTransformers) {
          var affected = getNextAffectedFile(state, cancellationToken, computeHash);
          var emitKind = 1;
          var isPendingEmitFile = false;
          if (!affected) {
            if (!ts3.outFile(state.compilerOptions)) {
              var pendingAffectedFile = getNextAffectedFilePendingEmit(state);
              if (!pendingAffectedFile) {
                if (!state.buildInfoEmitPending) {
                  return void 0;
                }
                var affected_1 = ts3.Debug.checkDefined(state.program);
                return toAffectedFileEmitResult(state, affected_1.emitBuildInfo(writeFile || ts3.maybeBind(host, host.writeFile), cancellationToken), affected_1, 1, false, true);
              }
              affected = pendingAffectedFile.affectedFile, emitKind = pendingAffectedFile.emitKind;
              isPendingEmitFile = true;
            } else {
              var program2 = ts3.Debug.checkDefined(state.program);
              if (state.programEmitComplete)
                return void 0;
              affected = program2;
            }
          }
          return toAffectedFileEmitResult(state, ts3.Debug.checkDefined(state.program).emit(affected === state.program ? void 0 : affected, writeFile || ts3.maybeBind(host, host.writeFile), cancellationToken, emitOnlyDtsFiles || emitKind === 0, customTransformers), affected, emitKind, isPendingEmitFile);
        }
        function emit(targetSourceFile, writeFile, cancellationToken, emitOnlyDtsFiles, customTransformers) {
          var restorePendingEmitOnHandlingNoEmitSuccess = false;
          var savedAffectedFilesPendingEmit;
          var savedAffectedFilesPendingEmitKind;
          var savedAffectedFilesPendingEmitIndex;
          if (kind !== BuilderProgramKind.EmitAndSemanticDiagnosticsBuilderProgram && !targetSourceFile && !ts3.outFile(state.compilerOptions) && !state.compilerOptions.noEmit && state.compilerOptions.noEmitOnError) {
            restorePendingEmitOnHandlingNoEmitSuccess = true;
            savedAffectedFilesPendingEmit = state.affectedFilesPendingEmit && state.affectedFilesPendingEmit.slice();
            savedAffectedFilesPendingEmitKind = state.affectedFilesPendingEmitKind && new ts3.Map(state.affectedFilesPendingEmitKind);
            savedAffectedFilesPendingEmitIndex = state.affectedFilesPendingEmitIndex;
          }
          if (kind === BuilderProgramKind.EmitAndSemanticDiagnosticsBuilderProgram) {
            assertSourceFileOkWithoutNextAffectedCall(state, targetSourceFile);
          }
          var result2 = ts3.handleNoEmitOptions(builderProgram, targetSourceFile, writeFile, cancellationToken);
          if (result2)
            return result2;
          if (restorePendingEmitOnHandlingNoEmitSuccess) {
            state.affectedFilesPendingEmit = savedAffectedFilesPendingEmit;
            state.affectedFilesPendingEmitKind = savedAffectedFilesPendingEmitKind;
            state.affectedFilesPendingEmitIndex = savedAffectedFilesPendingEmitIndex;
          }
          if (!targetSourceFile && kind === BuilderProgramKind.EmitAndSemanticDiagnosticsBuilderProgram) {
            var sourceMaps = [];
            var emitSkipped = false;
            var diagnostics = void 0;
            var emittedFiles = [];
            var affectedEmitResult = void 0;
            while (affectedEmitResult = emitNextAffectedFile(writeFile, cancellationToken, emitOnlyDtsFiles, customTransformers)) {
              emitSkipped = emitSkipped || affectedEmitResult.result.emitSkipped;
              diagnostics = ts3.addRange(diagnostics, affectedEmitResult.result.diagnostics);
              emittedFiles = ts3.addRange(emittedFiles, affectedEmitResult.result.emittedFiles);
              sourceMaps = ts3.addRange(sourceMaps, affectedEmitResult.result.sourceMaps);
            }
            return {
              emitSkipped,
              diagnostics: diagnostics || ts3.emptyArray,
              emittedFiles,
              sourceMaps
            };
          }
          return ts3.Debug.checkDefined(state.program).emit(targetSourceFile, writeFile || ts3.maybeBind(host, host.writeFile), cancellationToken, emitOnlyDtsFiles, customTransformers);
        }
        function getSemanticDiagnosticsOfNextAffectedFile(cancellationToken, ignoreSourceFile) {
          while (true) {
            var affected = getNextAffectedFile(state, cancellationToken, computeHash);
            if (!affected) {
              return void 0;
            } else if (affected === state.program) {
              return toAffectedFileResult(state, state.program.getSemanticDiagnostics(void 0, cancellationToken), affected);
            }
            if (kind === BuilderProgramKind.EmitAndSemanticDiagnosticsBuilderProgram || state.compilerOptions.noEmit || state.compilerOptions.noEmitOnError) {
              addToAffectedFilesPendingEmit(state, affected.resolvedPath, 1);
            }
            if (ignoreSourceFile && ignoreSourceFile(affected)) {
              doneWithAffectedFile(state, affected);
              continue;
            }
            return toAffectedFileResult(state, getSemanticDiagnosticsOfFile(state, affected, cancellationToken), affected);
          }
        }
        function getSemanticDiagnostics(sourceFile, cancellationToken) {
          assertSourceFileOkWithoutNextAffectedCall(state, sourceFile);
          var compilerOptions = ts3.Debug.checkDefined(state.program).getCompilerOptions();
          if (ts3.outFile(compilerOptions)) {
            ts3.Debug.assert(!state.semanticDiagnosticsPerFile);
            return ts3.Debug.checkDefined(state.program).getSemanticDiagnostics(sourceFile, cancellationToken);
          }
          if (sourceFile) {
            return getSemanticDiagnosticsOfFile(state, sourceFile, cancellationToken);
          }
          while (getSemanticDiagnosticsOfNextAffectedFile(cancellationToken)) {
          }
          var diagnostics;
          for (var _i = 0, _a3 = ts3.Debug.checkDefined(state.program).getSourceFiles(); _i < _a3.length; _i++) {
            var sourceFile_1 = _a3[_i];
            diagnostics = ts3.addRange(diagnostics, getSemanticDiagnosticsOfFile(state, sourceFile_1, cancellationToken));
          }
          return diagnostics || ts3.emptyArray;
        }
      }
      ts3.createBuilderProgram = createBuilderProgram;
      function addToAffectedFilesPendingEmit(state, affectedFilePendingEmit, kind) {
        if (!state.affectedFilesPendingEmit)
          state.affectedFilesPendingEmit = [];
        if (!state.affectedFilesPendingEmitKind)
          state.affectedFilesPendingEmitKind = new ts3.Map();
        var existingKind = state.affectedFilesPendingEmitKind.get(affectedFilePendingEmit);
        state.affectedFilesPendingEmit.push(affectedFilePendingEmit);
        state.affectedFilesPendingEmitKind.set(affectedFilePendingEmit, existingKind || kind);
        if (state.affectedFilesPendingEmitIndex === void 0) {
          state.affectedFilesPendingEmitIndex = 0;
        }
      }
      function toBuilderStateFileInfo(fileInfo) {
        return ts3.isString(fileInfo) ? { version: fileInfo, signature: fileInfo, affectsGlobalScope: void 0 } : ts3.isString(fileInfo.signature) ? fileInfo : { version: fileInfo.version, signature: fileInfo.signature === false ? void 0 : fileInfo.version, affectsGlobalScope: fileInfo.affectsGlobalScope };
      }
      ts3.toBuilderStateFileInfo = toBuilderStateFileInfo;
      function createBuildProgramUsingProgramBuildInfo(program2, buildInfoPath, host) {
        var _a2;
        var buildInfoDirectory = ts3.getDirectoryPath(ts3.getNormalizedAbsolutePath(buildInfoPath, host.getCurrentDirectory()));
        var getCanonicalFileName = ts3.createGetCanonicalFileName(host.useCaseSensitiveFileNames());
        var filePaths = program2.fileNames.map(toPath);
        var filePathsSetList = (_a2 = program2.fileIdsList) === null || _a2 === void 0 ? void 0 : _a2.map(function(fileIds) {
          return new ts3.Set(fileIds.map(toFilePath));
        });
        var fileInfos = new ts3.Map();
        program2.fileInfos.forEach(function(fileInfo, index) {
          return fileInfos.set(toFilePath(index + 1), toBuilderStateFileInfo(fileInfo));
        });
        var state = {
          fileInfos,
          compilerOptions: program2.options ? ts3.convertToOptionsWithAbsolutePaths(program2.options, toAbsolutePath) : {},
          referencedMap: toMapOfReferencedSet(program2.referencedMap),
          exportedModulesMap: toMapOfReferencedSet(program2.exportedModulesMap),
          semanticDiagnosticsPerFile: program2.semanticDiagnosticsPerFile && ts3.arrayToMap(program2.semanticDiagnosticsPerFile, function(value) {
            return toFilePath(ts3.isNumber(value) ? value : value[0]);
          }, function(value) {
            return ts3.isNumber(value) ? ts3.emptyArray : value[1];
          }),
          hasReusableDiagnostic: true,
          affectedFilesPendingEmit: ts3.map(program2.affectedFilesPendingEmit, function(value) {
            return toFilePath(value[0]);
          }),
          affectedFilesPendingEmitKind: program2.affectedFilesPendingEmit && ts3.arrayToMap(program2.affectedFilesPendingEmit, function(value) {
            return toFilePath(value[0]);
          }, function(value) {
            return value[1];
          }),
          affectedFilesPendingEmitIndex: program2.affectedFilesPendingEmit && 0
        };
        return {
          getState: function() {
            return state;
          },
          backupState: ts3.noop,
          restoreState: ts3.noop,
          getProgram: ts3.notImplemented,
          getProgramOrUndefined: ts3.returnUndefined,
          releaseProgram: ts3.noop,
          getCompilerOptions: function() {
            return state.compilerOptions;
          },
          getSourceFile: ts3.notImplemented,
          getSourceFiles: ts3.notImplemented,
          getOptionsDiagnostics: ts3.notImplemented,
          getGlobalDiagnostics: ts3.notImplemented,
          getConfigFileParsingDiagnostics: ts3.notImplemented,
          getSyntacticDiagnostics: ts3.notImplemented,
          getDeclarationDiagnostics: ts3.notImplemented,
          getSemanticDiagnostics: ts3.notImplemented,
          emit: ts3.notImplemented,
          getAllDependencies: ts3.notImplemented,
          getCurrentDirectory: ts3.notImplemented,
          emitNextAffectedFile: ts3.notImplemented,
          getSemanticDiagnosticsOfNextAffectedFile: ts3.notImplemented,
          emitBuildInfo: ts3.notImplemented,
          close: ts3.noop
        };
        function toPath(path2) {
          return ts3.toPath(path2, buildInfoDirectory, getCanonicalFileName);
        }
        function toAbsolutePath(path2) {
          return ts3.getNormalizedAbsolutePath(path2, buildInfoDirectory);
        }
        function toFilePath(fileId) {
          return filePaths[fileId - 1];
        }
        function toFilePathsSet(fileIdsListId) {
          return filePathsSetList[fileIdsListId - 1];
        }
        function toMapOfReferencedSet(referenceMap) {
          return referenceMap && ts3.arrayToMap(referenceMap, function(value) {
            return toFilePath(value[0]);
          }, function(value) {
            return toFilePathsSet(value[1]);
          });
        }
      }
      ts3.createBuildProgramUsingProgramBuildInfo = createBuildProgramUsingProgramBuildInfo;
      function createRedirectedBuilderProgram(state, configFileParsingDiagnostics) {
        return {
          getState: ts3.notImplemented,
          backupState: ts3.noop,
          restoreState: ts3.noop,
          getProgram,
          getProgramOrUndefined: function() {
            return state.program;
          },
          releaseProgram: function() {
            return state.program = void 0;
          },
          getCompilerOptions: function() {
            return state.compilerOptions;
          },
          getSourceFile: function(fileName) {
            return getProgram().getSourceFile(fileName);
          },
          getSourceFiles: function() {
            return getProgram().getSourceFiles();
          },
          getOptionsDiagnostics: function(cancellationToken) {
            return getProgram().getOptionsDiagnostics(cancellationToken);
          },
          getGlobalDiagnostics: function(cancellationToken) {
            return getProgram().getGlobalDiagnostics(cancellationToken);
          },
          getConfigFileParsingDiagnostics: function() {
            return configFileParsingDiagnostics;
          },
          getSyntacticDiagnostics: function(sourceFile, cancellationToken) {
            return getProgram().getSyntacticDiagnostics(sourceFile, cancellationToken);
          },
          getDeclarationDiagnostics: function(sourceFile, cancellationToken) {
            return getProgram().getDeclarationDiagnostics(sourceFile, cancellationToken);
          },
          getSemanticDiagnostics: function(sourceFile, cancellationToken) {
            return getProgram().getSemanticDiagnostics(sourceFile, cancellationToken);
          },
          emit: function(sourceFile, writeFile, cancellationToken, emitOnlyDts, customTransformers) {
            return getProgram().emit(sourceFile, writeFile, cancellationToken, emitOnlyDts, customTransformers);
          },
          emitBuildInfo: function(writeFile, cancellationToken) {
            return getProgram().emitBuildInfo(writeFile, cancellationToken);
          },
          getAllDependencies: ts3.notImplemented,
          getCurrentDirectory: function() {
            return getProgram().getCurrentDirectory();
          },
          close: ts3.noop
        };
        function getProgram() {
          return ts3.Debug.checkDefined(state.program);
        }
      }
      ts3.createRedirectedBuilderProgram = createRedirectedBuilderProgram;
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      function createSemanticDiagnosticsBuilderProgram(newProgramOrRootNames, hostOrOptions, oldProgramOrHost, configFileParsingDiagnosticsOrOldProgram, configFileParsingDiagnostics, projectReferences) {
        return ts3.createBuilderProgram(ts3.BuilderProgramKind.SemanticDiagnosticsBuilderProgram, ts3.getBuilderCreationParameters(newProgramOrRootNames, hostOrOptions, oldProgramOrHost, configFileParsingDiagnosticsOrOldProgram, configFileParsingDiagnostics, projectReferences));
      }
      ts3.createSemanticDiagnosticsBuilderProgram = createSemanticDiagnosticsBuilderProgram;
      function createEmitAndSemanticDiagnosticsBuilderProgram(newProgramOrRootNames, hostOrOptions, oldProgramOrHost, configFileParsingDiagnosticsOrOldProgram, configFileParsingDiagnostics, projectReferences) {
        return ts3.createBuilderProgram(ts3.BuilderProgramKind.EmitAndSemanticDiagnosticsBuilderProgram, ts3.getBuilderCreationParameters(newProgramOrRootNames, hostOrOptions, oldProgramOrHost, configFileParsingDiagnosticsOrOldProgram, configFileParsingDiagnostics, projectReferences));
      }
      ts3.createEmitAndSemanticDiagnosticsBuilderProgram = createEmitAndSemanticDiagnosticsBuilderProgram;
      function createAbstractBuilder(newProgramOrRootNames, hostOrOptions, oldProgramOrHost, configFileParsingDiagnosticsOrOldProgram, configFileParsingDiagnostics, projectReferences) {
        var _a2 = ts3.getBuilderCreationParameters(newProgramOrRootNames, hostOrOptions, oldProgramOrHost, configFileParsingDiagnosticsOrOldProgram, configFileParsingDiagnostics, projectReferences), newProgram = _a2.newProgram, newConfigFileParsingDiagnostics = _a2.configFileParsingDiagnostics;
        return ts3.createRedirectedBuilderProgram({ program: newProgram, compilerOptions: newProgram.getCompilerOptions() }, newConfigFileParsingDiagnostics);
      }
      ts3.createAbstractBuilder = createAbstractBuilder;
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      function removeIgnoredPath(path2) {
        if (ts3.endsWith(path2, "/node_modules/.staging")) {
          return ts3.removeSuffix(path2, "/.staging");
        }
        return ts3.some(ts3.ignoredPaths, function(searchPath) {
          return ts3.stringContains(path2, searchPath);
        }) ? void 0 : path2;
      }
      ts3.removeIgnoredPath = removeIgnoredPath;
      function canWatchDirectory(dirPath) {
        var rootLength = ts3.getRootLength(dirPath);
        if (dirPath.length === rootLength) {
          return false;
        }
        var nextDirectorySeparator = dirPath.indexOf(ts3.directorySeparator, rootLength);
        if (nextDirectorySeparator === -1) {
          return false;
        }
        var pathPartForUserCheck = dirPath.substring(rootLength, nextDirectorySeparator + 1);
        var isNonDirectorySeparatorRoot = rootLength > 1 || dirPath.charCodeAt(0) !== 47;
        if (isNonDirectorySeparatorRoot && dirPath.search(/[a-zA-Z]:/) !== 0 && pathPartForUserCheck.search(/[a-zA-z]\$\//) === 0) {
          nextDirectorySeparator = dirPath.indexOf(ts3.directorySeparator, nextDirectorySeparator + 1);
          if (nextDirectorySeparator === -1) {
            return false;
          }
          pathPartForUserCheck = dirPath.substring(rootLength + pathPartForUserCheck.length, nextDirectorySeparator + 1);
        }
        if (isNonDirectorySeparatorRoot && pathPartForUserCheck.search(/users\//i) !== 0) {
          return true;
        }
        for (var searchIndex = nextDirectorySeparator + 1, searchLevels = 2; searchLevels > 0; searchLevels--) {
          searchIndex = dirPath.indexOf(ts3.directorySeparator, searchIndex) + 1;
          if (searchIndex === 0) {
            return false;
          }
        }
        return true;
      }
      ts3.canWatchDirectory = canWatchDirectory;
      function createResolutionCache(resolutionHost, rootDirForResolution, logChangesWhenResolvingModule) {
        var filesWithChangedSetOfUnresolvedImports;
        var filesWithInvalidatedResolutions;
        var filesWithInvalidatedNonRelativeUnresolvedImports;
        var nonRelativeExternalModuleResolutions = ts3.createMultiMap();
        var resolutionsWithFailedLookups = [];
        var resolvedFileToResolution = ts3.createMultiMap();
        var hasChangedAutomaticTypeDirectiveNames = false;
        var failedLookupChecks;
        var startsWithPathChecks;
        var isInDirectoryChecks;
        var getCurrentDirectory = ts3.memoize(function() {
          return resolutionHost.getCurrentDirectory();
        });
        var cachedDirectoryStructureHost = resolutionHost.getCachedDirectoryStructureHost();
        var resolvedModuleNames = new ts3.Map();
        var perDirectoryResolvedModuleNames = ts3.createCacheWithRedirects();
        var nonRelativeModuleNameCache = ts3.createCacheWithRedirects();
        var moduleResolutionCache = ts3.createModuleResolutionCache(getCurrentDirectory(), resolutionHost.getCanonicalFileName, void 0, perDirectoryResolvedModuleNames, nonRelativeModuleNameCache);
        var resolvedTypeReferenceDirectives = new ts3.Map();
        var perDirectoryResolvedTypeReferenceDirectives = ts3.createCacheWithRedirects();
        var typeReferenceDirectiveResolutionCache = ts3.createTypeReferenceDirectiveResolutionCache(getCurrentDirectory(), resolutionHost.getCanonicalFileName, void 0, moduleResolutionCache.getPackageJsonInfoCache(), perDirectoryResolvedTypeReferenceDirectives);
        var failedLookupDefaultExtensions = [".ts", ".tsx", ".js", ".jsx", ".json"];
        var customFailedLookupPaths = new ts3.Map();
        var directoryWatchesOfFailedLookups = new ts3.Map();
        var rootDir = rootDirForResolution && ts3.removeTrailingDirectorySeparator(ts3.getNormalizedAbsolutePath(rootDirForResolution, getCurrentDirectory()));
        var rootPath = rootDir && resolutionHost.toPath(rootDir);
        var rootSplitLength = rootPath !== void 0 ? rootPath.split(ts3.directorySeparator).length : 0;
        var typeRootsWatches = new ts3.Map();
        return {
          startRecordingFilesWithChangedResolutions,
          finishRecordingFilesWithChangedResolutions,
          startCachingPerDirectoryResolution: clearPerDirectoryResolutions,
          finishCachingPerDirectoryResolution,
          resolveModuleNames,
          getResolvedModuleWithFailedLookupLocationsFromCache,
          resolveTypeReferenceDirectives,
          removeResolutionsFromProjectReferenceRedirects,
          removeResolutionsOfFile,
          hasChangedAutomaticTypeDirectiveNames: function() {
            return hasChangedAutomaticTypeDirectiveNames;
          },
          invalidateResolutionOfFile,
          invalidateResolutionsOfFailedLookupLocations,
          setFilesWithInvalidatedNonRelativeUnresolvedImports,
          createHasInvalidatedResolution,
          isFileWithInvalidatedNonRelativeUnresolvedImports,
          updateTypeRootsWatch,
          closeTypeRootsWatch,
          clear
        };
        function getResolvedModule(resolution) {
          return resolution.resolvedModule;
        }
        function getResolvedTypeReferenceDirective(resolution) {
          return resolution.resolvedTypeReferenceDirective;
        }
        function isInDirectoryPath(dir, file) {
          if (dir === void 0 || file.length <= dir.length) {
            return false;
          }
          return ts3.startsWith(file, dir) && file[dir.length] === ts3.directorySeparator;
        }
        function clear() {
          ts3.clearMap(directoryWatchesOfFailedLookups, ts3.closeFileWatcherOf);
          customFailedLookupPaths.clear();
          nonRelativeExternalModuleResolutions.clear();
          closeTypeRootsWatch();
          resolvedModuleNames.clear();
          resolvedTypeReferenceDirectives.clear();
          resolvedFileToResolution.clear();
          resolutionsWithFailedLookups.length = 0;
          failedLookupChecks = void 0;
          startsWithPathChecks = void 0;
          isInDirectoryChecks = void 0;
          clearPerDirectoryResolutions();
          hasChangedAutomaticTypeDirectiveNames = false;
        }
        function startRecordingFilesWithChangedResolutions() {
          filesWithChangedSetOfUnresolvedImports = [];
        }
        function finishRecordingFilesWithChangedResolutions() {
          var collected = filesWithChangedSetOfUnresolvedImports;
          filesWithChangedSetOfUnresolvedImports = void 0;
          return collected;
        }
        function isFileWithInvalidatedNonRelativeUnresolvedImports(path2) {
          if (!filesWithInvalidatedNonRelativeUnresolvedImports) {
            return false;
          }
          var value = filesWithInvalidatedNonRelativeUnresolvedImports.get(path2);
          return !!value && !!value.length;
        }
        function createHasInvalidatedResolution(forceAllFilesAsInvalidated) {
          invalidateResolutionsOfFailedLookupLocations();
          if (forceAllFilesAsInvalidated) {
            filesWithInvalidatedResolutions = void 0;
            return ts3.returnTrue;
          }
          var collected = filesWithInvalidatedResolutions;
          filesWithInvalidatedResolutions = void 0;
          return function(path2) {
            return !!collected && collected.has(path2) || isFileWithInvalidatedNonRelativeUnresolvedImports(path2);
          };
        }
        function clearPerDirectoryResolutions() {
          moduleResolutionCache.clear();
          typeReferenceDirectiveResolutionCache.clear();
          nonRelativeExternalModuleResolutions.forEach(watchFailedLookupLocationOfNonRelativeModuleResolutions);
          nonRelativeExternalModuleResolutions.clear();
        }
        function finishCachingPerDirectoryResolution() {
          filesWithInvalidatedNonRelativeUnresolvedImports = void 0;
          clearPerDirectoryResolutions();
          directoryWatchesOfFailedLookups.forEach(function(watcher, path2) {
            if (watcher.refCount === 0) {
              directoryWatchesOfFailedLookups.delete(path2);
              watcher.watcher.close();
            }
          });
          hasChangedAutomaticTypeDirectiveNames = false;
        }
        function resolveModuleName(moduleName, containingFile, compilerOptions, host, redirectedReference) {
          var _a2;
          var primaryResult = ts3.resolveModuleName(moduleName, containingFile, compilerOptions, host, moduleResolutionCache, redirectedReference);
          if (!resolutionHost.getGlobalCache) {
            return primaryResult;
          }
          var globalCache = resolutionHost.getGlobalCache();
          if (globalCache !== void 0 && !ts3.isExternalModuleNameRelative(moduleName) && !(primaryResult.resolvedModule && ts3.extensionIsTS(primaryResult.resolvedModule.extension))) {
            var _b = ts3.loadModuleFromGlobalCache(ts3.Debug.checkDefined(resolutionHost.globalCacheResolutionModuleName)(moduleName), resolutionHost.projectName, compilerOptions, host, globalCache, moduleResolutionCache), resolvedModule = _b.resolvedModule, failedLookupLocations = _b.failedLookupLocations;
            if (resolvedModule) {
              primaryResult.resolvedModule = resolvedModule;
              (_a2 = primaryResult.failedLookupLocations).push.apply(_a2, failedLookupLocations);
              return primaryResult;
            }
          }
          return primaryResult;
        }
        function resolveTypeReferenceDirective(typeReferenceDirectiveName, containingFile, options, host, redirectedReference) {
          return ts3.resolveTypeReferenceDirective(typeReferenceDirectiveName, containingFile, options, host, redirectedReference, typeReferenceDirectiveResolutionCache);
        }
        function resolveNamesWithLocalCache(_a2) {
          var _b;
          var names = _a2.names, containingFile = _a2.containingFile, redirectedReference = _a2.redirectedReference, cache = _a2.cache, perDirectoryCacheWithRedirects = _a2.perDirectoryCacheWithRedirects, loader2 = _a2.loader, getResolutionWithResolvedFileName = _a2.getResolutionWithResolvedFileName, shouldRetryResolution = _a2.shouldRetryResolution, reusedNames = _a2.reusedNames, logChanges = _a2.logChanges;
          var path2 = resolutionHost.toPath(containingFile);
          var resolutionsInFile = cache.get(path2) || cache.set(path2, new ts3.Map()).get(path2);
          var dirPath = ts3.getDirectoryPath(path2);
          var perDirectoryCache = perDirectoryCacheWithRedirects.getOrCreateMapOfCacheRedirects(redirectedReference);
          var perDirectoryResolution = perDirectoryCache.get(dirPath);
          if (!perDirectoryResolution) {
            perDirectoryResolution = new ts3.Map();
            perDirectoryCache.set(dirPath, perDirectoryResolution);
          }
          var resolvedModules = [];
          var compilerOptions = resolutionHost.getCompilationSettings();
          var hasInvalidatedNonRelativeUnresolvedImport = logChanges && isFileWithInvalidatedNonRelativeUnresolvedImports(path2);
          var program2 = resolutionHost.getCurrentProgram();
          var oldRedirect = program2 && program2.getResolvedProjectReferenceToRedirect(containingFile);
          var unmatchedRedirects = oldRedirect ? !redirectedReference || redirectedReference.sourceFile.path !== oldRedirect.sourceFile.path : !!redirectedReference;
          var seenNamesInFile = new ts3.Map();
          for (var _i = 0, names_3 = names; _i < names_3.length; _i++) {
            var name = names_3[_i];
            var resolution = resolutionsInFile.get(name);
            if (!seenNamesInFile.has(name) && unmatchedRedirects || !resolution || resolution.isInvalidated || hasInvalidatedNonRelativeUnresolvedImport && !ts3.isExternalModuleNameRelative(name) && shouldRetryResolution(resolution)) {
              var existingResolution = resolution;
              var resolutionInDirectory = perDirectoryResolution.get(name);
              if (resolutionInDirectory) {
                resolution = resolutionInDirectory;
              } else {
                resolution = loader2(name, containingFile, compilerOptions, ((_b = resolutionHost.getCompilerHost) === null || _b === void 0 ? void 0 : _b.call(resolutionHost)) || resolutionHost, redirectedReference);
                perDirectoryResolution.set(name, resolution);
              }
              resolutionsInFile.set(name, resolution);
              watchFailedLookupLocationsOfExternalModuleResolutions(name, resolution, path2, getResolutionWithResolvedFileName);
              if (existingResolution) {
                stopWatchFailedLookupLocationOfResolution(existingResolution, path2, getResolutionWithResolvedFileName);
              }
              if (logChanges && filesWithChangedSetOfUnresolvedImports && !resolutionIsEqualTo(existingResolution, resolution)) {
                filesWithChangedSetOfUnresolvedImports.push(path2);
                logChanges = false;
              }
            }
            ts3.Debug.assert(resolution !== void 0 && !resolution.isInvalidated);
            seenNamesInFile.set(name, true);
            resolvedModules.push(getResolutionWithResolvedFileName(resolution));
          }
          resolutionsInFile.forEach(function(resolution2, name2) {
            if (!seenNamesInFile.has(name2) && !ts3.contains(reusedNames, name2)) {
              stopWatchFailedLookupLocationOfResolution(resolution2, path2, getResolutionWithResolvedFileName);
              resolutionsInFile.delete(name2);
            }
          });
          return resolvedModules;
          function resolutionIsEqualTo(oldResolution, newResolution) {
            if (oldResolution === newResolution) {
              return true;
            }
            if (!oldResolution || !newResolution) {
              return false;
            }
            var oldResult = getResolutionWithResolvedFileName(oldResolution);
            var newResult = getResolutionWithResolvedFileName(newResolution);
            if (oldResult === newResult) {
              return true;
            }
            if (!oldResult || !newResult) {
              return false;
            }
            return oldResult.resolvedFileName === newResult.resolvedFileName;
          }
        }
        function resolveTypeReferenceDirectives(typeDirectiveNames, containingFile, redirectedReference) {
          return resolveNamesWithLocalCache({
            names: typeDirectiveNames,
            containingFile,
            redirectedReference,
            cache: resolvedTypeReferenceDirectives,
            perDirectoryCacheWithRedirects: perDirectoryResolvedTypeReferenceDirectives,
            loader: resolveTypeReferenceDirective,
            getResolutionWithResolvedFileName: getResolvedTypeReferenceDirective,
            shouldRetryResolution: function(resolution) {
              return resolution.resolvedTypeReferenceDirective === void 0;
            }
          });
        }
        function resolveModuleNames(moduleNames, containingFile, reusedNames, redirectedReference) {
          return resolveNamesWithLocalCache({
            names: moduleNames,
            containingFile,
            redirectedReference,
            cache: resolvedModuleNames,
            perDirectoryCacheWithRedirects: perDirectoryResolvedModuleNames,
            loader: resolveModuleName,
            getResolutionWithResolvedFileName: getResolvedModule,
            shouldRetryResolution: function(resolution) {
              return !resolution.resolvedModule || !ts3.resolutionExtensionIsTSOrJson(resolution.resolvedModule.extension);
            },
            reusedNames,
            logChanges: logChangesWhenResolvingModule
          });
        }
        function getResolvedModuleWithFailedLookupLocationsFromCache(moduleName, containingFile) {
          var cache = resolvedModuleNames.get(resolutionHost.toPath(containingFile));
          return cache && cache.get(moduleName);
        }
        function isNodeModulesAtTypesDirectory(dirPath) {
          return ts3.endsWith(dirPath, "/node_modules/@types");
        }
        function getDirectoryToWatchFailedLookupLocation(failedLookupLocation, failedLookupLocationPath) {
          if (isInDirectoryPath(rootPath, failedLookupLocationPath)) {
            failedLookupLocation = ts3.isRootedDiskPath(failedLookupLocation) ? ts3.normalizePath(failedLookupLocation) : ts3.getNormalizedAbsolutePath(failedLookupLocation, getCurrentDirectory());
            var failedLookupPathSplit = failedLookupLocationPath.split(ts3.directorySeparator);
            var failedLookupSplit = failedLookupLocation.split(ts3.directorySeparator);
            ts3.Debug.assert(failedLookupSplit.length === failedLookupPathSplit.length, "FailedLookup: " + failedLookupLocation + " failedLookupLocationPath: " + failedLookupLocationPath);
            if (failedLookupPathSplit.length > rootSplitLength + 1) {
              return {
                dir: failedLookupSplit.slice(0, rootSplitLength + 1).join(ts3.directorySeparator),
                dirPath: failedLookupPathSplit.slice(0, rootSplitLength + 1).join(ts3.directorySeparator)
              };
            } else {
              return {
                dir: rootDir,
                dirPath: rootPath,
                nonRecursive: false
              };
            }
          }
          return getDirectoryToWatchFromFailedLookupLocationDirectory(ts3.getDirectoryPath(ts3.getNormalizedAbsolutePath(failedLookupLocation, getCurrentDirectory())), ts3.getDirectoryPath(failedLookupLocationPath));
        }
        function getDirectoryToWatchFromFailedLookupLocationDirectory(dir, dirPath) {
          while (ts3.pathContainsNodeModules(dirPath)) {
            dir = ts3.getDirectoryPath(dir);
            dirPath = ts3.getDirectoryPath(dirPath);
          }
          if (ts3.isNodeModulesDirectory(dirPath)) {
            return canWatchDirectory(ts3.getDirectoryPath(dirPath)) ? { dir, dirPath } : void 0;
          }
          var nonRecursive = true;
          var subDirectoryPath, subDirectory;
          if (rootPath !== void 0) {
            while (!isInDirectoryPath(dirPath, rootPath)) {
              var parentPath = ts3.getDirectoryPath(dirPath);
              if (parentPath === dirPath) {
                break;
              }
              nonRecursive = false;
              subDirectoryPath = dirPath;
              subDirectory = dir;
              dirPath = parentPath;
              dir = ts3.getDirectoryPath(dir);
            }
          }
          return canWatchDirectory(dirPath) ? { dir: subDirectory || dir, dirPath: subDirectoryPath || dirPath, nonRecursive } : void 0;
        }
        function isPathWithDefaultFailedLookupExtension(path2) {
          return ts3.fileExtensionIsOneOf(path2, failedLookupDefaultExtensions);
        }
        function watchFailedLookupLocationsOfExternalModuleResolutions(name, resolution, filePath, getResolutionWithResolvedFileName) {
          if (resolution.refCount) {
            resolution.refCount++;
            ts3.Debug.assertDefined(resolution.files);
          } else {
            resolution.refCount = 1;
            ts3.Debug.assert(ts3.length(resolution.files) === 0);
            if (ts3.isExternalModuleNameRelative(name)) {
              watchFailedLookupLocationOfResolution(resolution);
            } else {
              nonRelativeExternalModuleResolutions.add(name, resolution);
            }
            var resolved = getResolutionWithResolvedFileName(resolution);
            if (resolved && resolved.resolvedFileName) {
              resolvedFileToResolution.add(resolutionHost.toPath(resolved.resolvedFileName), resolution);
            }
          }
          (resolution.files || (resolution.files = [])).push(filePath);
        }
        function watchFailedLookupLocationOfResolution(resolution) {
          ts3.Debug.assert(!!resolution.refCount);
          var failedLookupLocations = resolution.failedLookupLocations;
          if (!failedLookupLocations.length)
            return;
          resolutionsWithFailedLookups.push(resolution);
          var setAtRoot = false;
          for (var _i = 0, failedLookupLocations_1 = failedLookupLocations; _i < failedLookupLocations_1.length; _i++) {
            var failedLookupLocation = failedLookupLocations_1[_i];
            var failedLookupLocationPath = resolutionHost.toPath(failedLookupLocation);
            var toWatch = getDirectoryToWatchFailedLookupLocation(failedLookupLocation, failedLookupLocationPath);
            if (toWatch) {
              var dir = toWatch.dir, dirPath = toWatch.dirPath, nonRecursive = toWatch.nonRecursive;
              if (!isPathWithDefaultFailedLookupExtension(failedLookupLocationPath)) {
                var refCount = customFailedLookupPaths.get(failedLookupLocationPath) || 0;
                customFailedLookupPaths.set(failedLookupLocationPath, refCount + 1);
              }
              if (dirPath === rootPath) {
                ts3.Debug.assert(!nonRecursive);
                setAtRoot = true;
              } else {
                setDirectoryWatcher(dir, dirPath, nonRecursive);
              }
            }
          }
          if (setAtRoot) {
            setDirectoryWatcher(rootDir, rootPath, true);
          }
        }
        function watchFailedLookupLocationOfNonRelativeModuleResolutions(resolutions, name) {
          var program2 = resolutionHost.getCurrentProgram();
          if (!program2 || !program2.getTypeChecker().tryFindAmbientModuleWithoutAugmentations(name)) {
            resolutions.forEach(watchFailedLookupLocationOfResolution);
          }
        }
        function setDirectoryWatcher(dir, dirPath, nonRecursive) {
          var dirWatcher = directoryWatchesOfFailedLookups.get(dirPath);
          if (dirWatcher) {
            ts3.Debug.assert(!!nonRecursive === !!dirWatcher.nonRecursive);
            dirWatcher.refCount++;
          } else {
            directoryWatchesOfFailedLookups.set(dirPath, { watcher: createDirectoryWatcher(dir, dirPath, nonRecursive), refCount: 1, nonRecursive });
          }
        }
        function stopWatchFailedLookupLocationOfResolution(resolution, filePath, getResolutionWithResolvedFileName) {
          ts3.unorderedRemoveItem(ts3.Debug.assertDefined(resolution.files), filePath);
          resolution.refCount--;
          if (resolution.refCount) {
            return;
          }
          var resolved = getResolutionWithResolvedFileName(resolution);
          if (resolved && resolved.resolvedFileName) {
            resolvedFileToResolution.remove(resolutionHost.toPath(resolved.resolvedFileName), resolution);
          }
          if (!ts3.unorderedRemoveItem(resolutionsWithFailedLookups, resolution)) {
            return;
          }
          var failedLookupLocations = resolution.failedLookupLocations;
          var removeAtRoot = false;
          for (var _i = 0, failedLookupLocations_2 = failedLookupLocations; _i < failedLookupLocations_2.length; _i++) {
            var failedLookupLocation = failedLookupLocations_2[_i];
            var failedLookupLocationPath = resolutionHost.toPath(failedLookupLocation);
            var toWatch = getDirectoryToWatchFailedLookupLocation(failedLookupLocation, failedLookupLocationPath);
            if (toWatch) {
              var dirPath = toWatch.dirPath;
              var refCount = customFailedLookupPaths.get(failedLookupLocationPath);
              if (refCount) {
                if (refCount === 1) {
                  customFailedLookupPaths.delete(failedLookupLocationPath);
                } else {
                  ts3.Debug.assert(refCount > 1);
                  customFailedLookupPaths.set(failedLookupLocationPath, refCount - 1);
                }
              }
              if (dirPath === rootPath) {
                removeAtRoot = true;
              } else {
                removeDirectoryWatcher(dirPath);
              }
            }
          }
          if (removeAtRoot) {
            removeDirectoryWatcher(rootPath);
          }
        }
        function removeDirectoryWatcher(dirPath) {
          var dirWatcher = directoryWatchesOfFailedLookups.get(dirPath);
          dirWatcher.refCount--;
        }
        function createDirectoryWatcher(directory, dirPath, nonRecursive) {
          return resolutionHost.watchDirectoryOfFailedLookupLocation(directory, function(fileOrDirectory) {
            var fileOrDirectoryPath = resolutionHost.toPath(fileOrDirectory);
            if (cachedDirectoryStructureHost) {
              cachedDirectoryStructureHost.addOrDeleteFileOrDirectory(fileOrDirectory, fileOrDirectoryPath);
            }
            scheduleInvalidateResolutionOfFailedLookupLocation(fileOrDirectoryPath, dirPath === fileOrDirectoryPath);
          }, nonRecursive ? 0 : 1);
        }
        function removeResolutionsOfFileFromCache(cache, filePath, getResolutionWithResolvedFileName) {
          var resolutions = cache.get(filePath);
          if (resolutions) {
            resolutions.forEach(function(resolution) {
              return stopWatchFailedLookupLocationOfResolution(resolution, filePath, getResolutionWithResolvedFileName);
            });
            cache.delete(filePath);
          }
        }
        function removeResolutionsFromProjectReferenceRedirects(filePath) {
          if (!ts3.fileExtensionIs(filePath, ".json")) {
            return;
          }
          var program2 = resolutionHost.getCurrentProgram();
          if (!program2) {
            return;
          }
          var resolvedProjectReference = program2.getResolvedProjectReferenceByPath(filePath);
          if (!resolvedProjectReference) {
            return;
          }
          resolvedProjectReference.commandLine.fileNames.forEach(function(f) {
            return removeResolutionsOfFile(resolutionHost.toPath(f));
          });
        }
        function removeResolutionsOfFile(filePath) {
          removeResolutionsOfFileFromCache(resolvedModuleNames, filePath, getResolvedModule);
          removeResolutionsOfFileFromCache(resolvedTypeReferenceDirectives, filePath, getResolvedTypeReferenceDirective);
        }
        function invalidateResolutions(resolutions, canInvalidate) {
          if (!resolutions)
            return false;
          var invalidated = false;
          for (var _i = 0, resolutions_1 = resolutions; _i < resolutions_1.length; _i++) {
            var resolution = resolutions_1[_i];
            if (resolution.isInvalidated || !canInvalidate(resolution))
              continue;
            resolution.isInvalidated = invalidated = true;
            for (var _a2 = 0, _b = ts3.Debug.assertDefined(resolution.files); _a2 < _b.length; _a2++) {
              var containingFilePath = _b[_a2];
              (filesWithInvalidatedResolutions || (filesWithInvalidatedResolutions = new ts3.Set())).add(containingFilePath);
              hasChangedAutomaticTypeDirectiveNames = hasChangedAutomaticTypeDirectiveNames || ts3.endsWith(containingFilePath, ts3.inferredTypesContainingFile);
            }
          }
          return invalidated;
        }
        function invalidateResolutionOfFile(filePath) {
          removeResolutionsOfFile(filePath);
          var prevHasChangedAutomaticTypeDirectiveNames = hasChangedAutomaticTypeDirectiveNames;
          if (invalidateResolutions(resolvedFileToResolution.get(filePath), ts3.returnTrue) && hasChangedAutomaticTypeDirectiveNames && !prevHasChangedAutomaticTypeDirectiveNames) {
            resolutionHost.onChangedAutomaticTypeDirectiveNames();
          }
        }
        function setFilesWithInvalidatedNonRelativeUnresolvedImports(filesMap) {
          ts3.Debug.assert(filesWithInvalidatedNonRelativeUnresolvedImports === filesMap || filesWithInvalidatedNonRelativeUnresolvedImports === void 0);
          filesWithInvalidatedNonRelativeUnresolvedImports = filesMap;
        }
        function scheduleInvalidateResolutionOfFailedLookupLocation(fileOrDirectoryPath, isCreatingWatchedDirectory) {
          if (isCreatingWatchedDirectory) {
            (isInDirectoryChecks || (isInDirectoryChecks = [])).push(fileOrDirectoryPath);
          } else {
            var updatedPath = removeIgnoredPath(fileOrDirectoryPath);
            if (!updatedPath)
              return false;
            fileOrDirectoryPath = updatedPath;
            if (resolutionHost.fileIsOpen(fileOrDirectoryPath)) {
              return false;
            }
            var dirOfFileOrDirectory = ts3.getDirectoryPath(fileOrDirectoryPath);
            if (isNodeModulesAtTypesDirectory(fileOrDirectoryPath) || ts3.isNodeModulesDirectory(fileOrDirectoryPath) || isNodeModulesAtTypesDirectory(dirOfFileOrDirectory) || ts3.isNodeModulesDirectory(dirOfFileOrDirectory)) {
              (failedLookupChecks || (failedLookupChecks = [])).push(fileOrDirectoryPath);
              (startsWithPathChecks || (startsWithPathChecks = new ts3.Set())).add(fileOrDirectoryPath);
            } else {
              if (!isPathWithDefaultFailedLookupExtension(fileOrDirectoryPath) && !customFailedLookupPaths.has(fileOrDirectoryPath)) {
                return false;
              }
              if (ts3.isEmittedFileOfProgram(resolutionHost.getCurrentProgram(), fileOrDirectoryPath)) {
                return false;
              }
              (failedLookupChecks || (failedLookupChecks = [])).push(fileOrDirectoryPath);
              var packagePath = ts3.parseNodeModuleFromPath(fileOrDirectoryPath);
              if (packagePath)
                (startsWithPathChecks || (startsWithPathChecks = new ts3.Set())).add(packagePath);
            }
          }
          resolutionHost.scheduleInvalidateResolutionsOfFailedLookupLocations();
        }
        function invalidateResolutionsOfFailedLookupLocations() {
          if (!failedLookupChecks && !startsWithPathChecks && !isInDirectoryChecks) {
            return false;
          }
          var invalidated = invalidateResolutions(resolutionsWithFailedLookups, canInvalidateFailedLookupResolution);
          failedLookupChecks = void 0;
          startsWithPathChecks = void 0;
          isInDirectoryChecks = void 0;
          return invalidated;
        }
        function canInvalidateFailedLookupResolution(resolution) {
          return resolution.failedLookupLocations.some(function(location) {
            var locationPath = resolutionHost.toPath(location);
            return ts3.contains(failedLookupChecks, locationPath) || ts3.firstDefinedIterator((startsWithPathChecks === null || startsWithPathChecks === void 0 ? void 0 : startsWithPathChecks.keys()) || ts3.emptyIterator, function(fileOrDirectoryPath) {
              return ts3.startsWith(locationPath, fileOrDirectoryPath) ? true : void 0;
            }) || (isInDirectoryChecks === null || isInDirectoryChecks === void 0 ? void 0 : isInDirectoryChecks.some(function(fileOrDirectoryPath) {
              return isInDirectoryPath(fileOrDirectoryPath, locationPath);
            }));
          });
        }
        function closeTypeRootsWatch() {
          ts3.clearMap(typeRootsWatches, ts3.closeFileWatcher);
        }
        function getDirectoryToWatchFailedLookupLocationFromTypeRoot(typeRoot, typeRootPath) {
          if (isInDirectoryPath(rootPath, typeRootPath)) {
            return rootPath;
          }
          var toWatch = getDirectoryToWatchFromFailedLookupLocationDirectory(typeRoot, typeRootPath);
          return toWatch && directoryWatchesOfFailedLookups.has(toWatch.dirPath) ? toWatch.dirPath : void 0;
        }
        function createTypeRootsWatch(typeRootPath, typeRoot) {
          return resolutionHost.watchTypeRootsDirectory(typeRoot, function(fileOrDirectory) {
            var fileOrDirectoryPath = resolutionHost.toPath(fileOrDirectory);
            if (cachedDirectoryStructureHost) {
              cachedDirectoryStructureHost.addOrDeleteFileOrDirectory(fileOrDirectory, fileOrDirectoryPath);
            }
            hasChangedAutomaticTypeDirectiveNames = true;
            resolutionHost.onChangedAutomaticTypeDirectiveNames();
            var dirPath = getDirectoryToWatchFailedLookupLocationFromTypeRoot(typeRoot, typeRootPath);
            if (dirPath) {
              scheduleInvalidateResolutionOfFailedLookupLocation(fileOrDirectoryPath, dirPath === fileOrDirectoryPath);
            }
          }, 1);
        }
        function updateTypeRootsWatch() {
          var options = resolutionHost.getCompilationSettings();
          if (options.types) {
            closeTypeRootsWatch();
            return;
          }
          var typeRoots = ts3.getEffectiveTypeRoots(options, { directoryExists: directoryExistsForTypeRootWatch, getCurrentDirectory });
          if (typeRoots) {
            ts3.mutateMap(typeRootsWatches, ts3.arrayToMap(typeRoots, function(tr) {
              return resolutionHost.toPath(tr);
            }), {
              createNewValue: createTypeRootsWatch,
              onDeleteValue: ts3.closeFileWatcher
            });
          } else {
            closeTypeRootsWatch();
          }
        }
        function directoryExistsForTypeRootWatch(nodeTypesDirectory) {
          var dir = ts3.getDirectoryPath(ts3.getDirectoryPath(nodeTypesDirectory));
          var dirPath = resolutionHost.toPath(dir);
          return dirPath === rootPath || canWatchDirectory(dirPath);
        }
      }
      ts3.createResolutionCache = createResolutionCache;
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var moduleSpecifiers;
      (function(moduleSpecifiers2) {
        var RelativePreference;
        (function(RelativePreference2) {
          RelativePreference2[RelativePreference2["Relative"] = 0] = "Relative";
          RelativePreference2[RelativePreference2["NonRelative"] = 1] = "NonRelative";
          RelativePreference2[RelativePreference2["Shortest"] = 2] = "Shortest";
          RelativePreference2[RelativePreference2["ExternalNonRelative"] = 3] = "ExternalNonRelative";
        })(RelativePreference || (RelativePreference = {}));
        var Ending;
        (function(Ending2) {
          Ending2[Ending2["Minimal"] = 0] = "Minimal";
          Ending2[Ending2["Index"] = 1] = "Index";
          Ending2[Ending2["JsExtension"] = 2] = "JsExtension";
        })(Ending || (Ending = {}));
        function getPreferences(_a2, compilerOptions, importingSourceFile) {
          var importModuleSpecifierPreference = _a2.importModuleSpecifierPreference, importModuleSpecifierEnding = _a2.importModuleSpecifierEnding;
          return {
            relativePreference: importModuleSpecifierPreference === "relative" ? 0 : importModuleSpecifierPreference === "non-relative" ? 1 : importModuleSpecifierPreference === "project-relative" ? 3 : 2,
            ending: getEnding()
          };
          function getEnding() {
            switch (importModuleSpecifierEnding) {
              case "minimal":
                return 0;
              case "index":
                return 1;
              case "js":
                return 2;
              default:
                return usesJsExtensionOnImports(importingSourceFile) ? 2 : ts3.getEmitModuleResolutionKind(compilerOptions) !== ts3.ModuleResolutionKind.NodeJs ? 1 : 0;
            }
          }
        }
        function getPreferencesForUpdate(compilerOptions, oldImportSpecifier) {
          return {
            relativePreference: ts3.isExternalModuleNameRelative(oldImportSpecifier) ? 0 : 1,
            ending: ts3.hasJSFileExtension(oldImportSpecifier) ? 2 : ts3.getEmitModuleResolutionKind(compilerOptions) !== ts3.ModuleResolutionKind.NodeJs || ts3.endsWith(oldImportSpecifier, "index") ? 1 : 0
          };
        }
        function updateModuleSpecifier(compilerOptions, importingSourceFileName, toFileName, host, oldImportSpecifier) {
          var res = getModuleSpecifierWorker(compilerOptions, importingSourceFileName, toFileName, host, getPreferencesForUpdate(compilerOptions, oldImportSpecifier));
          if (res === oldImportSpecifier)
            return void 0;
          return res;
        }
        moduleSpecifiers2.updateModuleSpecifier = updateModuleSpecifier;
        function getModuleSpecifier(compilerOptions, importingSourceFile, importingSourceFileName, toFileName, host, preferences) {
          if (preferences === void 0) {
            preferences = {};
          }
          return getModuleSpecifierWorker(compilerOptions, importingSourceFileName, toFileName, host, getPreferences(preferences, compilerOptions, importingSourceFile));
        }
        moduleSpecifiers2.getModuleSpecifier = getModuleSpecifier;
        function getNodeModulesPackageName(compilerOptions, importingSourceFileName, nodeModulesFileName, host) {
          var info = getInfo(importingSourceFileName, host);
          var modulePaths = getAllModulePaths(importingSourceFileName, nodeModulesFileName, host);
          return ts3.firstDefined(modulePaths, function(modulePath) {
            return tryGetModuleNameAsNodeModule(modulePath, info, host, compilerOptions, true);
          });
        }
        moduleSpecifiers2.getNodeModulesPackageName = getNodeModulesPackageName;
        function getModuleSpecifierWorker(compilerOptions, importingSourceFileName, toFileName, host, preferences) {
          var info = getInfo(importingSourceFileName, host);
          var modulePaths = getAllModulePaths(importingSourceFileName, toFileName, host);
          return ts3.firstDefined(modulePaths, function(modulePath) {
            return tryGetModuleNameAsNodeModule(modulePath, info, host, compilerOptions);
          }) || getLocalModuleSpecifier(toFileName, info, compilerOptions, host, preferences);
        }
        function getModuleSpecifiers(moduleSymbol, checker, compilerOptions, importingSourceFile, host, userPreferences) {
          var ambient = tryGetModuleNameFromAmbientModule(moduleSymbol, checker);
          if (ambient)
            return [ambient];
          var info = getInfo(importingSourceFile.path, host);
          var moduleSourceFile = ts3.getSourceFileOfNode(moduleSymbol.valueDeclaration || ts3.getNonAugmentationDeclaration(moduleSymbol));
          if (!moduleSourceFile) {
            return [];
          }
          var modulePaths = getAllModulePaths(importingSourceFile.path, moduleSourceFile.originalFileName, host);
          var preferences = getPreferences(userPreferences, compilerOptions, importingSourceFile);
          var existingSpecifier = ts3.forEach(modulePaths, function(modulePath2) {
            return ts3.forEach(host.getFileIncludeReasons().get(ts3.toPath(modulePath2.path, host.getCurrentDirectory(), info.getCanonicalFileName)), function(reason) {
              if (reason.kind !== ts3.FileIncludeKind.Import || reason.file !== importingSourceFile.path)
                return void 0;
              var specifier2 = ts3.getModuleNameStringLiteralAt(importingSourceFile, reason.index).text;
              return preferences.relativePreference !== 1 || !ts3.pathIsRelative(specifier2) ? specifier2 : void 0;
            });
          });
          if (existingSpecifier)
            return [existingSpecifier];
          var importedFileIsInNodeModules = ts3.some(modulePaths, function(p) {
            return p.isInNodeModules;
          });
          var nodeModulesSpecifiers;
          var pathsSpecifiers;
          var relativeSpecifiers;
          for (var _i = 0, modulePaths_1 = modulePaths; _i < modulePaths_1.length; _i++) {
            var modulePath = modulePaths_1[_i];
            var specifier = tryGetModuleNameAsNodeModule(modulePath, info, host, compilerOptions);
            nodeModulesSpecifiers = ts3.append(nodeModulesSpecifiers, specifier);
            if (specifier && modulePath.isRedirect) {
              return nodeModulesSpecifiers;
            }
            if (!specifier && !modulePath.isRedirect) {
              var local = getLocalModuleSpecifier(modulePath.path, info, compilerOptions, host, preferences);
              if (ts3.pathIsBareSpecifier(local)) {
                pathsSpecifiers = ts3.append(pathsSpecifiers, local);
              } else if (!importedFileIsInNodeModules || modulePath.isInNodeModules) {
                relativeSpecifiers = ts3.append(relativeSpecifiers, local);
              }
            }
          }
          return (pathsSpecifiers === null || pathsSpecifiers === void 0 ? void 0 : pathsSpecifiers.length) ? pathsSpecifiers : (nodeModulesSpecifiers === null || nodeModulesSpecifiers === void 0 ? void 0 : nodeModulesSpecifiers.length) ? nodeModulesSpecifiers : ts3.Debug.checkDefined(relativeSpecifiers);
        }
        moduleSpecifiers2.getModuleSpecifiers = getModuleSpecifiers;
        function getInfo(importingSourceFileName, host) {
          var getCanonicalFileName = ts3.createGetCanonicalFileName(host.useCaseSensitiveFileNames ? host.useCaseSensitiveFileNames() : true);
          var sourceDirectory = ts3.getDirectoryPath(importingSourceFileName);
          return { getCanonicalFileName, importingSourceFileName, sourceDirectory };
        }
        function getLocalModuleSpecifier(moduleFileName, info, compilerOptions, host, _a2) {
          var ending = _a2.ending, relativePreference = _a2.relativePreference;
          var baseUrl = compilerOptions.baseUrl, paths = compilerOptions.paths, rootDirs = compilerOptions.rootDirs;
          var sourceDirectory = info.sourceDirectory, getCanonicalFileName = info.getCanonicalFileName;
          var relativePath = rootDirs && tryGetModuleNameFromRootDirs(rootDirs, moduleFileName, sourceDirectory, getCanonicalFileName, ending, compilerOptions) || removeExtensionAndIndexPostFix(ts3.ensurePathIsNonModuleName(ts3.getRelativePathFromDirectory(sourceDirectory, moduleFileName, getCanonicalFileName)), ending, compilerOptions);
          if (!baseUrl && !paths || relativePreference === 0) {
            return relativePath;
          }
          var baseDirectory = ts3.getNormalizedAbsolutePath(ts3.getPathsBasePath(compilerOptions, host) || baseUrl, host.getCurrentDirectory());
          var relativeToBaseUrl = getRelativePathIfInDirectory(moduleFileName, baseDirectory, getCanonicalFileName);
          if (!relativeToBaseUrl) {
            return relativePath;
          }
          var importRelativeToBaseUrl = removeExtensionAndIndexPostFix(relativeToBaseUrl, ending, compilerOptions);
          var fromPaths = paths && tryGetModuleNameFromPaths(ts3.removeFileExtension(relativeToBaseUrl), importRelativeToBaseUrl, paths);
          var nonRelative = fromPaths === void 0 && baseUrl !== void 0 ? importRelativeToBaseUrl : fromPaths;
          if (!nonRelative) {
            return relativePath;
          }
          if (relativePreference === 1) {
            return nonRelative;
          }
          if (relativePreference === 3) {
            var projectDirectory = compilerOptions.configFilePath ? ts3.toPath(ts3.getDirectoryPath(compilerOptions.configFilePath), host.getCurrentDirectory(), info.getCanonicalFileName) : info.getCanonicalFileName(host.getCurrentDirectory());
            var modulePath = ts3.toPath(moduleFileName, projectDirectory, getCanonicalFileName);
            var sourceIsInternal = ts3.startsWith(sourceDirectory, projectDirectory);
            var targetIsInternal = ts3.startsWith(modulePath, projectDirectory);
            if (sourceIsInternal && !targetIsInternal || !sourceIsInternal && targetIsInternal) {
              return nonRelative;
            }
            var nearestTargetPackageJson = getNearestAncestorDirectoryWithPackageJson(host, ts3.getDirectoryPath(modulePath));
            var nearestSourcePackageJson = getNearestAncestorDirectoryWithPackageJson(host, sourceDirectory);
            if (nearestSourcePackageJson !== nearestTargetPackageJson) {
              return nonRelative;
            }
            return relativePath;
          }
          if (relativePreference !== 2)
            ts3.Debug.assertNever(relativePreference);
          return isPathRelativeToParent(nonRelative) || countPathComponents(relativePath) < countPathComponents(nonRelative) ? relativePath : nonRelative;
        }
        function countPathComponents(path2) {
          var count = 0;
          for (var i3 = ts3.startsWith(path2, "./") ? 2 : 0; i3 < path2.length; i3++) {
            if (path2.charCodeAt(i3) === 47)
              count++;
          }
          return count;
        }
        moduleSpecifiers2.countPathComponents = countPathComponents;
        function usesJsExtensionOnImports(_a2) {
          var imports = _a2.imports;
          return ts3.firstDefined(imports, function(_a3) {
            var text = _a3.text;
            return ts3.pathIsRelative(text) ? ts3.hasJSFileExtension(text) : void 0;
          }) || false;
        }
        function comparePathsByRedirectAndNumberOfDirectorySeparators(a2, b2) {
          return ts3.compareBooleans(b2.isRedirect, a2.isRedirect) || ts3.compareNumberOfDirectorySeparators(a2.path, b2.path);
        }
        function getNearestAncestorDirectoryWithPackageJson(host, fileName) {
          if (host.getNearestAncestorDirectoryWithPackageJson) {
            return host.getNearestAncestorDirectoryWithPackageJson(fileName);
          }
          return !!ts3.forEachAncestorDirectory(fileName, function(directory) {
            return host.fileExists(ts3.combinePaths(directory, "package.json")) ? true : void 0;
          });
        }
        function forEachFileNameOfModule(importingFileName, importedFileName, host, preferSymlinks, cb2) {
          var getCanonicalFileName = ts3.hostGetCanonicalFileName(host);
          var cwd = host.getCurrentDirectory();
          var referenceRedirect = host.isSourceOfProjectReferenceRedirect(importedFileName) ? host.getProjectReferenceRedirect(importedFileName) : void 0;
          var importedPath = ts3.toPath(importedFileName, cwd, getCanonicalFileName);
          var redirects = host.redirectTargetsMap.get(importedPath) || ts3.emptyArray;
          var importedFileNames = __spreadArray(__spreadArray(__spreadArray([], referenceRedirect ? [referenceRedirect] : ts3.emptyArray), [importedFileName]), redirects);
          var targets = importedFileNames.map(function(f) {
            return ts3.getNormalizedAbsolutePath(f, cwd);
          });
          var shouldFilterIgnoredPaths = !ts3.every(targets, ts3.containsIgnoredPath);
          if (!preferSymlinks) {
            var result_16 = ts3.forEach(targets, function(p) {
              return !(shouldFilterIgnoredPaths && ts3.containsIgnoredPath(p)) && cb2(p, referenceRedirect === p);
            });
            if (result_16)
              return result_16;
          }
          var links = host.getSymlinkCache ? host.getSymlinkCache() : ts3.discoverProbableSymlinks(host.getSourceFiles(), getCanonicalFileName, cwd);
          var symlinkedDirectories = links.getSymlinkedDirectoriesByRealpath();
          var fullImportedFileName = ts3.getNormalizedAbsolutePath(importedFileName, cwd);
          var result2 = symlinkedDirectories && ts3.forEachAncestorDirectory(ts3.getDirectoryPath(fullImportedFileName), function(realPathDirectory) {
            var symlinkDirectories = symlinkedDirectories.get(ts3.ensureTrailingDirectorySeparator(ts3.toPath(realPathDirectory, cwd, getCanonicalFileName)));
            if (!symlinkDirectories)
              return void 0;
            if (ts3.startsWithDirectory(importingFileName, realPathDirectory, getCanonicalFileName)) {
              return false;
            }
            return ts3.forEach(targets, function(target) {
              if (!ts3.startsWithDirectory(target, realPathDirectory, getCanonicalFileName)) {
                return;
              }
              var relative = ts3.getRelativePathFromDirectory(realPathDirectory, target, getCanonicalFileName);
              for (var _i = 0, symlinkDirectories_1 = symlinkDirectories; _i < symlinkDirectories_1.length; _i++) {
                var symlinkDirectory = symlinkDirectories_1[_i];
                var option = ts3.resolvePath(symlinkDirectory, relative);
                var result_17 = cb2(option, target === referenceRedirect);
                shouldFilterIgnoredPaths = true;
                if (result_17)
                  return result_17;
              }
            });
          });
          return result2 || (preferSymlinks ? ts3.forEach(targets, function(p) {
            return shouldFilterIgnoredPaths && ts3.containsIgnoredPath(p) ? void 0 : cb2(p, p === referenceRedirect);
          }) : void 0);
        }
        moduleSpecifiers2.forEachFileNameOfModule = forEachFileNameOfModule;
        function getAllModulePaths(importingFileName, importedFileName, host) {
          var _a2;
          var cache = (_a2 = host.getModuleSpecifierCache) === null || _a2 === void 0 ? void 0 : _a2.call(host);
          var getCanonicalFileName = ts3.hostGetCanonicalFileName(host);
          if (cache) {
            var cached = cache.get(importingFileName, ts3.toPath(importedFileName, host.getCurrentDirectory(), getCanonicalFileName));
            if (typeof cached === "object")
              return cached;
          }
          var allFileNames = new ts3.Map();
          var importedFileFromNodeModules = false;
          forEachFileNameOfModule(importingFileName, importedFileName, host, true, function(path2, isRedirect) {
            var isInNodeModules = ts3.pathContainsNodeModules(path2);
            allFileNames.set(path2, { path: getCanonicalFileName(path2), isRedirect, isInNodeModules });
            importedFileFromNodeModules = importedFileFromNodeModules || isInNodeModules;
          });
          var sortedPaths = [];
          var _loop_26 = function(directory2) {
            var directoryStart = ts3.ensureTrailingDirectorySeparator(directory2);
            var pathsInDirectory;
            allFileNames.forEach(function(_a3, fileName) {
              var path2 = _a3.path, isRedirect = _a3.isRedirect, isInNodeModules = _a3.isInNodeModules;
              if (ts3.startsWith(path2, directoryStart)) {
                (pathsInDirectory || (pathsInDirectory = [])).push({ path: fileName, isRedirect, isInNodeModules });
                allFileNames.delete(fileName);
              }
            });
            if (pathsInDirectory) {
              if (pathsInDirectory.length > 1) {
                pathsInDirectory.sort(comparePathsByRedirectAndNumberOfDirectorySeparators);
              }
              sortedPaths.push.apply(sortedPaths, pathsInDirectory);
            }
            var newDirectory = ts3.getDirectoryPath(directory2);
            if (newDirectory === directory2)
              return out_directory_1 = directory2, "break";
            directory2 = newDirectory;
            out_directory_1 = directory2;
          };
          var out_directory_1;
          for (var directory = ts3.getDirectoryPath(importingFileName); allFileNames.size !== 0; ) {
            var state_9 = _loop_26(directory);
            directory = out_directory_1;
            if (state_9 === "break")
              break;
          }
          if (allFileNames.size) {
            var remainingPaths = ts3.arrayFrom(allFileNames.values());
            if (remainingPaths.length > 1)
              remainingPaths.sort(comparePathsByRedirectAndNumberOfDirectorySeparators);
            sortedPaths.push.apply(sortedPaths, remainingPaths);
          }
          if (cache) {
            cache.set(importingFileName, ts3.toPath(importedFileName, host.getCurrentDirectory(), getCanonicalFileName), sortedPaths);
          }
          return sortedPaths;
        }
        function tryGetModuleNameFromAmbientModule(moduleSymbol, checker) {
          var _a2;
          var decl = (_a2 = moduleSymbol.declarations) === null || _a2 === void 0 ? void 0 : _a2.find(function(d) {
            return ts3.isNonGlobalAmbientModule(d) && (!ts3.isExternalModuleAugmentation(d) || !ts3.isExternalModuleNameRelative(ts3.getTextOfIdentifierOrLiteral(d.name)));
          });
          if (decl) {
            return decl.name.text;
          }
          var ambientModuleDeclareCandidates = ts3.mapDefined(moduleSymbol.declarations, function(d) {
            var _a3, _b, _c, _d;
            if (!ts3.isModuleDeclaration(d))
              return;
            var topNamespace = getTopNamespace(d);
            if (!(((_a3 = topNamespace === null || topNamespace === void 0 ? void 0 : topNamespace.parent) === null || _a3 === void 0 ? void 0 : _a3.parent) && ts3.isModuleBlock(topNamespace.parent) && ts3.isAmbientModule(topNamespace.parent.parent) && ts3.isSourceFile(topNamespace.parent.parent.parent)))
              return;
            var exportAssignment = (_d = (_c = (_b = topNamespace.parent.parent.symbol.exports) === null || _b === void 0 ? void 0 : _b.get("export=")) === null || _c === void 0 ? void 0 : _c.valueDeclaration) === null || _d === void 0 ? void 0 : _d.expression;
            if (!exportAssignment)
              return;
            var exportSymbol = checker.getSymbolAtLocation(exportAssignment);
            if (!exportSymbol)
              return;
            var originalExportSymbol = (exportSymbol === null || exportSymbol === void 0 ? void 0 : exportSymbol.flags) & 2097152 ? checker.getAliasedSymbol(exportSymbol) : exportSymbol;
            if (originalExportSymbol === d.symbol)
              return topNamespace.parent.parent;
            function getTopNamespace(namespaceDeclaration) {
              while (namespaceDeclaration.flags & 4) {
                namespaceDeclaration = namespaceDeclaration.parent;
              }
              return namespaceDeclaration;
            }
          });
          var ambientModuleDeclare = ambientModuleDeclareCandidates[0];
          if (ambientModuleDeclare) {
            return ambientModuleDeclare.name.text;
          }
        }
        function tryGetModuleNameFromPaths(relativeToBaseUrlWithIndex, relativeToBaseUrl, paths) {
          for (var key2 in paths) {
            for (var _i = 0, _a2 = paths[key2]; _i < _a2.length; _i++) {
              var patternText_1 = _a2[_i];
              var pattern = ts3.removeFileExtension(ts3.normalizePath(patternText_1));
              var indexOfStar = pattern.indexOf("*");
              if (indexOfStar !== -1) {
                var prefix2 = pattern.substr(0, indexOfStar);
                var suffix = pattern.substr(indexOfStar + 1);
                if (relativeToBaseUrl.length >= prefix2.length + suffix.length && ts3.startsWith(relativeToBaseUrl, prefix2) && ts3.endsWith(relativeToBaseUrl, suffix) || !suffix && relativeToBaseUrl === ts3.removeTrailingDirectorySeparator(prefix2)) {
                  var matchedStar = relativeToBaseUrl.substr(prefix2.length, relativeToBaseUrl.length - suffix.length - prefix2.length);
                  return key2.replace("*", matchedStar);
                }
              } else if (pattern === relativeToBaseUrl || pattern === relativeToBaseUrlWithIndex) {
                return key2;
              }
            }
          }
        }
        function tryGetModuleNameFromRootDirs(rootDirs, moduleFileName, sourceDirectory, getCanonicalFileName, ending, compilerOptions) {
          var normalizedTargetPath = getPathRelativeToRootDirs(moduleFileName, rootDirs, getCanonicalFileName);
          if (normalizedTargetPath === void 0) {
            return void 0;
          }
          var normalizedSourcePath = getPathRelativeToRootDirs(sourceDirectory, rootDirs, getCanonicalFileName);
          var relativePath = normalizedSourcePath !== void 0 ? ts3.ensurePathIsNonModuleName(ts3.getRelativePathFromDirectory(normalizedSourcePath, normalizedTargetPath, getCanonicalFileName)) : normalizedTargetPath;
          return ts3.getEmitModuleResolutionKind(compilerOptions) === ts3.ModuleResolutionKind.NodeJs ? removeExtensionAndIndexPostFix(relativePath, ending, compilerOptions) : ts3.removeFileExtension(relativePath);
        }
        function tryGetModuleNameAsNodeModule(_a2, _b, host, options, packageNameOnly) {
          var path2 = _a2.path, isRedirect = _a2.isRedirect;
          var getCanonicalFileName = _b.getCanonicalFileName, sourceDirectory = _b.sourceDirectory;
          if (!host.fileExists || !host.readFile) {
            return void 0;
          }
          var parts = getNodeModulePathParts(path2);
          if (!parts) {
            return void 0;
          }
          var moduleSpecifier = path2;
          var isPackageRootPath = false;
          if (!packageNameOnly) {
            var packageRootIndex = parts.packageRootIndex;
            var moduleFileNameForExtensionless = void 0;
            while (true) {
              var _c = tryDirectoryWithPackageJson(packageRootIndex), moduleFileToTry = _c.moduleFileToTry, packageRootPath = _c.packageRootPath;
              if (packageRootPath) {
                moduleSpecifier = packageRootPath;
                isPackageRootPath = true;
                break;
              }
              if (!moduleFileNameForExtensionless)
                moduleFileNameForExtensionless = moduleFileToTry;
              packageRootIndex = path2.indexOf(ts3.directorySeparator, packageRootIndex + 1);
              if (packageRootIndex === -1) {
                moduleSpecifier = getExtensionlessFileName(moduleFileNameForExtensionless);
                break;
              }
            }
          }
          if (isRedirect && !isPackageRootPath) {
            return void 0;
          }
          var globalTypingsCacheLocation = host.getGlobalTypingsCacheLocation && host.getGlobalTypingsCacheLocation();
          var pathToTopLevelNodeModules = getCanonicalFileName(moduleSpecifier.substring(0, parts.topLevelNodeModulesIndex));
          if (!(ts3.startsWith(sourceDirectory, pathToTopLevelNodeModules) || globalTypingsCacheLocation && ts3.startsWith(getCanonicalFileName(globalTypingsCacheLocation), pathToTopLevelNodeModules))) {
            return void 0;
          }
          var nodeModulesDirectoryName = moduleSpecifier.substring(parts.topLevelPackageNameIndex + 1);
          var packageName = ts3.getPackageNameFromTypesPackageName(nodeModulesDirectoryName);
          return ts3.getEmitModuleResolutionKind(options) !== ts3.ModuleResolutionKind.NodeJs && packageName === nodeModulesDirectoryName ? void 0 : packageName;
          function tryDirectoryWithPackageJson(packageRootIndex2) {
            var packageRootPath2 = path2.substring(0, packageRootIndex2);
            var packageJsonPath = ts3.combinePaths(packageRootPath2, "package.json");
            var moduleFileToTry2 = path2;
            if (host.fileExists(packageJsonPath)) {
              var packageJsonContent = JSON.parse(host.readFile(packageJsonPath));
              var versionPaths = packageJsonContent.typesVersions ? ts3.getPackageJsonTypesVersionsPaths(packageJsonContent.typesVersions) : void 0;
              if (versionPaths) {
                var subModuleName = path2.slice(packageRootPath2.length + 1);
                var fromPaths = tryGetModuleNameFromPaths(ts3.removeFileExtension(subModuleName), removeExtensionAndIndexPostFix(subModuleName, 0, options), versionPaths.paths);
                if (fromPaths !== void 0) {
                  moduleFileToTry2 = ts3.combinePaths(packageRootPath2, fromPaths);
                }
              }
              var mainFileRelative = packageJsonContent.typings || packageJsonContent.types || packageJsonContent.main;
              if (ts3.isString(mainFileRelative)) {
                var mainExportFile = ts3.toPath(mainFileRelative, packageRootPath2, getCanonicalFileName);
                if (ts3.removeFileExtension(mainExportFile) === ts3.removeFileExtension(getCanonicalFileName(moduleFileToTry2))) {
                  return { packageRootPath: packageRootPath2, moduleFileToTry: moduleFileToTry2 };
                }
              }
            }
            return { moduleFileToTry: moduleFileToTry2 };
          }
          function getExtensionlessFileName(path3) {
            var fullModulePathWithoutExtension = ts3.removeFileExtension(path3);
            if (getCanonicalFileName(fullModulePathWithoutExtension.substring(parts.fileNameIndex)) === "/index" && !tryGetAnyFileFromPath(host, fullModulePathWithoutExtension.substring(0, parts.fileNameIndex))) {
              return fullModulePathWithoutExtension.substring(0, parts.fileNameIndex);
            }
            return fullModulePathWithoutExtension;
          }
        }
        function tryGetAnyFileFromPath(host, path2) {
          if (!host.fileExists)
            return;
          var extensions = ts3.getSupportedExtensions({ allowJs: true }, [{ extension: "node", isMixedContent: false }, { extension: "json", isMixedContent: false, scriptKind: 6 }]);
          for (var _i = 0, extensions_3 = extensions; _i < extensions_3.length; _i++) {
            var e2 = extensions_3[_i];
            var fullPath = path2 + e2;
            if (host.fileExists(fullPath)) {
              return fullPath;
            }
          }
        }
        function getNodeModulePathParts(fullPath) {
          var topLevelNodeModulesIndex = 0;
          var topLevelPackageNameIndex = 0;
          var packageRootIndex = 0;
          var fileNameIndex = 0;
          var States;
          (function(States2) {
            States2[States2["BeforeNodeModules"] = 0] = "BeforeNodeModules";
            States2[States2["NodeModules"] = 1] = "NodeModules";
            States2[States2["Scope"] = 2] = "Scope";
            States2[States2["PackageContent"] = 3] = "PackageContent";
          })(States || (States = {}));
          var partStart = 0;
          var partEnd = 0;
          var state = 0;
          while (partEnd >= 0) {
            partStart = partEnd;
            partEnd = fullPath.indexOf("/", partStart + 1);
            switch (state) {
              case 0:
                if (fullPath.indexOf(ts3.nodeModulesPathPart, partStart) === partStart) {
                  topLevelNodeModulesIndex = partStart;
                  topLevelPackageNameIndex = partEnd;
                  state = 1;
                }
                break;
              case 1:
              case 2:
                if (state === 1 && fullPath.charAt(partStart + 1) === "@") {
                  state = 2;
                } else {
                  packageRootIndex = partEnd;
                  state = 3;
                }
                break;
              case 3:
                if (fullPath.indexOf(ts3.nodeModulesPathPart, partStart) === partStart) {
                  state = 1;
                } else {
                  state = 3;
                }
                break;
            }
          }
          fileNameIndex = partStart;
          return state > 1 ? { topLevelNodeModulesIndex, topLevelPackageNameIndex, packageRootIndex, fileNameIndex } : void 0;
        }
        function getPathRelativeToRootDirs(path2, rootDirs, getCanonicalFileName) {
          return ts3.firstDefined(rootDirs, function(rootDir) {
            var relativePath = getRelativePathIfInDirectory(path2, rootDir, getCanonicalFileName);
            return isPathRelativeToParent(relativePath) ? void 0 : relativePath;
          });
        }
        function removeExtensionAndIndexPostFix(fileName, ending, options) {
          if (ts3.fileExtensionIs(fileName, ".json"))
            return fileName;
          var noExtension = ts3.removeFileExtension(fileName);
          switch (ending) {
            case 0:
              return ts3.removeSuffix(noExtension, "/index");
            case 1:
              return noExtension;
            case 2:
              return noExtension + getJSExtensionForFile(fileName, options);
            default:
              return ts3.Debug.assertNever(ending);
          }
        }
        function getJSExtensionForFile(fileName, options) {
          var ext = ts3.extensionFromPath(fileName);
          switch (ext) {
            case ".ts":
            case ".d.ts":
              return ".js";
            case ".tsx":
              return options.jsx === 1 ? ".jsx" : ".js";
            case ".js":
            case ".jsx":
            case ".json":
              return ext;
            case ".tsbuildinfo":
              return ts3.Debug.fail("Extension .tsbuildinfo is unsupported:: FileName:: " + fileName);
            default:
              return ts3.Debug.assertNever(ext);
          }
        }
        function getRelativePathIfInDirectory(path2, directoryPath, getCanonicalFileName) {
          var relativePath = ts3.getRelativePathToDirectoryOrUrl(directoryPath, path2, directoryPath, getCanonicalFileName, false);
          return ts3.isRootedDiskPath(relativePath) ? void 0 : relativePath;
        }
        function isPathRelativeToParent(path2) {
          return ts3.startsWith(path2, "..");
        }
      })(moduleSpecifiers = ts3.moduleSpecifiers || (ts3.moduleSpecifiers = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var sysFormatDiagnosticsHost = ts3.sys ? {
        getCurrentDirectory: function() {
          return ts3.sys.getCurrentDirectory();
        },
        getNewLine: function() {
          return ts3.sys.newLine;
        },
        getCanonicalFileName: ts3.createGetCanonicalFileName(ts3.sys.useCaseSensitiveFileNames)
      } : void 0;
      function createDiagnosticReporter(system, pretty) {
        var host = system === ts3.sys ? sysFormatDiagnosticsHost : {
          getCurrentDirectory: function() {
            return system.getCurrentDirectory();
          },
          getNewLine: function() {
            return system.newLine;
          },
          getCanonicalFileName: ts3.createGetCanonicalFileName(system.useCaseSensitiveFileNames)
        };
        if (!pretty) {
          return function(diagnostic) {
            return system.write(ts3.formatDiagnostic(diagnostic, host));
          };
        }
        var diagnostics = new Array(1);
        return function(diagnostic) {
          diagnostics[0] = diagnostic;
          system.write(ts3.formatDiagnosticsWithColorAndContext(diagnostics, host) + host.getNewLine());
          diagnostics[0] = void 0;
        };
      }
      ts3.createDiagnosticReporter = createDiagnosticReporter;
      function clearScreenIfNotWatchingForFileChanges(system, diagnostic, options) {
        if (system.clearScreen && !options.preserveWatchOutput && !options.extendedDiagnostics && !options.diagnostics && ts3.contains(ts3.screenStartingMessageCodes, diagnostic.code)) {
          system.clearScreen();
          return true;
        }
        return false;
      }
      ts3.screenStartingMessageCodes = [
        ts3.Diagnostics.Starting_compilation_in_watch_mode.code,
        ts3.Diagnostics.File_change_detected_Starting_incremental_compilation.code
      ];
      function getPlainDiagnosticFollowingNewLines(diagnostic, newLine) {
        return ts3.contains(ts3.screenStartingMessageCodes, diagnostic.code) ? newLine + newLine : newLine;
      }
      function getLocaleTimeString(system) {
        return !system.now ? new Date().toLocaleTimeString() : system.now().toLocaleTimeString("en-US", { timeZone: "UTC" });
      }
      ts3.getLocaleTimeString = getLocaleTimeString;
      function createWatchStatusReporter(system, pretty) {
        return pretty ? function(diagnostic, newLine, options) {
          clearScreenIfNotWatchingForFileChanges(system, diagnostic, options);
          var output = "[" + ts3.formatColorAndReset(getLocaleTimeString(system), ts3.ForegroundColorEscapeSequences.Grey) + "] ";
          output += "" + ts3.flattenDiagnosticMessageText(diagnostic.messageText, system.newLine) + (newLine + newLine);
          system.write(output);
        } : function(diagnostic, newLine, options) {
          var output = "";
          if (!clearScreenIfNotWatchingForFileChanges(system, diagnostic, options)) {
            output += newLine;
          }
          output += getLocaleTimeString(system) + " - ";
          output += "" + ts3.flattenDiagnosticMessageText(diagnostic.messageText, system.newLine) + getPlainDiagnosticFollowingNewLines(diagnostic, newLine);
          system.write(output);
        };
      }
      ts3.createWatchStatusReporter = createWatchStatusReporter;
      function parseConfigFileWithSystem(configFileName, optionsToExtend, extendedConfigCache, watchOptionsToExtend, system, reportDiagnostic) {
        var host = system;
        host.onUnRecoverableConfigFileDiagnostic = function(diagnostic) {
          return reportUnrecoverableDiagnostic(system, reportDiagnostic, diagnostic);
        };
        var result2 = ts3.getParsedCommandLineOfConfigFile(configFileName, optionsToExtend, host, extendedConfigCache, watchOptionsToExtend);
        host.onUnRecoverableConfigFileDiagnostic = void 0;
        return result2;
      }
      ts3.parseConfigFileWithSystem = parseConfigFileWithSystem;
      function getErrorCountForSummary(diagnostics) {
        return ts3.countWhere(diagnostics, function(diagnostic) {
          return diagnostic.category === ts3.DiagnosticCategory.Error;
        });
      }
      ts3.getErrorCountForSummary = getErrorCountForSummary;
      function getWatchErrorSummaryDiagnosticMessage(errorCount) {
        return errorCount === 1 ? ts3.Diagnostics.Found_1_error_Watching_for_file_changes : ts3.Diagnostics.Found_0_errors_Watching_for_file_changes;
      }
      ts3.getWatchErrorSummaryDiagnosticMessage = getWatchErrorSummaryDiagnosticMessage;
      function getErrorSummaryText(errorCount, newLine) {
        if (errorCount === 0)
          return "";
        var d = ts3.createCompilerDiagnostic(errorCount === 1 ? ts3.Diagnostics.Found_1_error : ts3.Diagnostics.Found_0_errors, errorCount);
        return "" + newLine + ts3.flattenDiagnosticMessageText(d.messageText, newLine) + newLine + newLine;
      }
      ts3.getErrorSummaryText = getErrorSummaryText;
      function isBuilderProgram(program2) {
        return !!program2.getState;
      }
      ts3.isBuilderProgram = isBuilderProgram;
      function listFiles(program2, write) {
        var options = program2.getCompilerOptions();
        if (options.explainFiles) {
          explainFiles(isBuilderProgram(program2) ? program2.getProgram() : program2, write);
        } else if (options.listFiles || options.listFilesOnly) {
          ts3.forEach(program2.getSourceFiles(), function(file) {
            write(file.fileName);
          });
        }
      }
      ts3.listFiles = listFiles;
      function explainFiles(program2, write) {
        var _a2, _b;
        var reasons = program2.getFileIncludeReasons();
        var getCanonicalFileName = ts3.createGetCanonicalFileName(program2.useCaseSensitiveFileNames());
        var relativeFileName = function(fileName) {
          return ts3.convertToRelativePath(fileName, program2.getCurrentDirectory(), getCanonicalFileName);
        };
        for (var _i = 0, _c = program2.getSourceFiles(); _i < _c.length; _i++) {
          var file = _c[_i];
          write("" + toFileName(file, relativeFileName));
          (_a2 = reasons.get(file.path)) === null || _a2 === void 0 ? void 0 : _a2.forEach(function(reason) {
            return write("  " + fileIncludeReasonToDiagnostics(program2, reason, relativeFileName).messageText);
          });
          (_b = explainIfFileIsRedirect(file, relativeFileName)) === null || _b === void 0 ? void 0 : _b.forEach(function(d) {
            return write("  " + d.messageText);
          });
        }
      }
      ts3.explainFiles = explainFiles;
      function explainIfFileIsRedirect(file, fileNameConvertor) {
        var result2;
        if (file.path !== file.resolvedPath) {
          (result2 || (result2 = [])).push(ts3.chainDiagnosticMessages(void 0, ts3.Diagnostics.File_is_output_of_project_reference_source_0, toFileName(file.originalFileName, fileNameConvertor)));
        }
        if (file.redirectInfo) {
          (result2 || (result2 = [])).push(ts3.chainDiagnosticMessages(void 0, ts3.Diagnostics.File_redirects_to_file_0, toFileName(file.redirectInfo.redirectTarget, fileNameConvertor)));
        }
        return result2;
      }
      ts3.explainIfFileIsRedirect = explainIfFileIsRedirect;
      function getMatchedFileSpec(program2, fileName) {
        var _a2;
        var configFile = program2.getCompilerOptions().configFile;
        if (!((_a2 = configFile === null || configFile === void 0 ? void 0 : configFile.configFileSpecs) === null || _a2 === void 0 ? void 0 : _a2.validatedFilesSpec))
          return void 0;
        var getCanonicalFileName = ts3.createGetCanonicalFileName(program2.useCaseSensitiveFileNames());
        var filePath = getCanonicalFileName(fileName);
        var basePath = ts3.getDirectoryPath(ts3.getNormalizedAbsolutePath(configFile.fileName, program2.getCurrentDirectory()));
        return ts3.find(configFile.configFileSpecs.validatedFilesSpec, function(fileSpec) {
          return getCanonicalFileName(ts3.getNormalizedAbsolutePath(fileSpec, basePath)) === filePath;
        });
      }
      ts3.getMatchedFileSpec = getMatchedFileSpec;
      function getMatchedIncludeSpec(program2, fileName) {
        var _a2, _b;
        var configFile = program2.getCompilerOptions().configFile;
        if (!((_a2 = configFile === null || configFile === void 0 ? void 0 : configFile.configFileSpecs) === null || _a2 === void 0 ? void 0 : _a2.validatedIncludeSpecs))
          return void 0;
        var isJsonFile = ts3.fileExtensionIs(fileName, ".json");
        var basePath = ts3.getDirectoryPath(ts3.getNormalizedAbsolutePath(configFile.fileName, program2.getCurrentDirectory()));
        var useCaseSensitiveFileNames = program2.useCaseSensitiveFileNames();
        return ts3.find((_b = configFile === null || configFile === void 0 ? void 0 : configFile.configFileSpecs) === null || _b === void 0 ? void 0 : _b.validatedIncludeSpecs, function(includeSpec) {
          if (isJsonFile && !ts3.endsWith(includeSpec, ".json"))
            return false;
          var pattern = ts3.getPatternFromSpec(includeSpec, basePath, "files");
          return !!pattern && ts3.getRegexFromPattern("(" + pattern + ")$", useCaseSensitiveFileNames).test(fileName);
        });
      }
      ts3.getMatchedIncludeSpec = getMatchedIncludeSpec;
      function fileIncludeReasonToDiagnostics(program2, reason, fileNameConvertor) {
        var _a2, _b;
        var options = program2.getCompilerOptions();
        if (ts3.isReferencedFile(reason)) {
          var referenceLocation = ts3.getReferencedFileLocation(function(path2) {
            return program2.getSourceFileByPath(path2);
          }, reason);
          var referenceText = ts3.isReferenceFileLocation(referenceLocation) ? referenceLocation.file.text.substring(referenceLocation.pos, referenceLocation.end) : '"' + referenceLocation.text + '"';
          var message = void 0;
          ts3.Debug.assert(ts3.isReferenceFileLocation(referenceLocation) || reason.kind === ts3.FileIncludeKind.Import, "Only synthetic references are imports");
          switch (reason.kind) {
            case ts3.FileIncludeKind.Import:
              if (ts3.isReferenceFileLocation(referenceLocation)) {
                message = referenceLocation.packageId ? ts3.Diagnostics.Imported_via_0_from_file_1_with_packageId_2 : ts3.Diagnostics.Imported_via_0_from_file_1;
              } else if (referenceLocation.text === ts3.externalHelpersModuleNameText) {
                message = referenceLocation.packageId ? ts3.Diagnostics.Imported_via_0_from_file_1_with_packageId_2_to_import_importHelpers_as_specified_in_compilerOptions : ts3.Diagnostics.Imported_via_0_from_file_1_to_import_importHelpers_as_specified_in_compilerOptions;
              } else {
                message = referenceLocation.packageId ? ts3.Diagnostics.Imported_via_0_from_file_1_with_packageId_2_to_import_jsx_and_jsxs_factory_functions : ts3.Diagnostics.Imported_via_0_from_file_1_to_import_jsx_and_jsxs_factory_functions;
              }
              break;
            case ts3.FileIncludeKind.ReferenceFile:
              ts3.Debug.assert(!referenceLocation.packageId);
              message = ts3.Diagnostics.Referenced_via_0_from_file_1;
              break;
            case ts3.FileIncludeKind.TypeReferenceDirective:
              message = referenceLocation.packageId ? ts3.Diagnostics.Type_library_referenced_via_0_from_file_1_with_packageId_2 : ts3.Diagnostics.Type_library_referenced_via_0_from_file_1;
              break;
            case ts3.FileIncludeKind.LibReferenceDirective:
              ts3.Debug.assert(!referenceLocation.packageId);
              message = ts3.Diagnostics.Library_referenced_via_0_from_file_1;
              break;
            default:
              ts3.Debug.assertNever(reason);
          }
          return ts3.chainDiagnosticMessages(void 0, message, referenceText, toFileName(referenceLocation.file, fileNameConvertor), referenceLocation.packageId && ts3.packageIdToString(referenceLocation.packageId));
        }
        switch (reason.kind) {
          case ts3.FileIncludeKind.RootFile:
            if (!((_a2 = options.configFile) === null || _a2 === void 0 ? void 0 : _a2.configFileSpecs))
              return ts3.chainDiagnosticMessages(void 0, ts3.Diagnostics.Root_file_specified_for_compilation);
            var fileName = ts3.getNormalizedAbsolutePath(program2.getRootFileNames()[reason.index], program2.getCurrentDirectory());
            var matchedByFiles = getMatchedFileSpec(program2, fileName);
            if (matchedByFiles)
              return ts3.chainDiagnosticMessages(void 0, ts3.Diagnostics.Part_of_files_list_in_tsconfig_json);
            var matchedByInclude = getMatchedIncludeSpec(program2, fileName);
            return matchedByInclude ? ts3.chainDiagnosticMessages(void 0, ts3.Diagnostics.Matched_by_include_pattern_0_in_1, matchedByInclude, toFileName(options.configFile, fileNameConvertor)) : ts3.chainDiagnosticMessages(void 0, ts3.Diagnostics.Root_file_specified_for_compilation);
          case ts3.FileIncludeKind.SourceFromProjectReference:
          case ts3.FileIncludeKind.OutputFromProjectReference:
            var isOutput = reason.kind === ts3.FileIncludeKind.OutputFromProjectReference;
            var referencedResolvedRef = ts3.Debug.checkDefined((_b = program2.getResolvedProjectReferences()) === null || _b === void 0 ? void 0 : _b[reason.index]);
            return ts3.chainDiagnosticMessages(void 0, ts3.outFile(options) ? isOutput ? ts3.Diagnostics.Output_from_referenced_project_0_included_because_1_specified : ts3.Diagnostics.Source_from_referenced_project_0_included_because_1_specified : isOutput ? ts3.Diagnostics.Output_from_referenced_project_0_included_because_module_is_specified_as_none : ts3.Diagnostics.Source_from_referenced_project_0_included_because_module_is_specified_as_none, toFileName(referencedResolvedRef.sourceFile.fileName, fileNameConvertor), options.outFile ? "--outFile" : "--out");
          case ts3.FileIncludeKind.AutomaticTypeDirectiveFile:
            return ts3.chainDiagnosticMessages(void 0, options.types ? reason.packageId ? ts3.Diagnostics.Entry_point_of_type_library_0_specified_in_compilerOptions_with_packageId_1 : ts3.Diagnostics.Entry_point_of_type_library_0_specified_in_compilerOptions : reason.packageId ? ts3.Diagnostics.Entry_point_for_implicit_type_library_0_with_packageId_1 : ts3.Diagnostics.Entry_point_for_implicit_type_library_0, reason.typeReference, reason.packageId && ts3.packageIdToString(reason.packageId));
          case ts3.FileIncludeKind.LibFile:
            if (reason.index !== void 0)
              return ts3.chainDiagnosticMessages(void 0, ts3.Diagnostics.Library_0_specified_in_compilerOptions, options.lib[reason.index]);
            var target = ts3.forEachEntry(ts3.targetOptionDeclaration.type, function(value, key2) {
              return value === options.target ? key2 : void 0;
            });
            return ts3.chainDiagnosticMessages(void 0, target ? ts3.Diagnostics.Default_library_for_target_0 : ts3.Diagnostics.Default_library, target);
          default:
            ts3.Debug.assertNever(reason);
        }
      }
      ts3.fileIncludeReasonToDiagnostics = fileIncludeReasonToDiagnostics;
      function toFileName(file, fileNameConvertor) {
        var fileName = ts3.isString(file) ? file : file.fileName;
        return fileNameConvertor ? fileNameConvertor(fileName) : fileName;
      }
      function emitFilesAndReportErrors(program2, reportDiagnostic, write, reportSummary, writeFile, cancellationToken, emitOnlyDtsFiles, customTransformers) {
        var isListFilesOnly = !!program2.getCompilerOptions().listFilesOnly;
        var allDiagnostics = program2.getConfigFileParsingDiagnostics().slice();
        var configFileParsingDiagnosticsLength = allDiagnostics.length;
        ts3.addRange(allDiagnostics, program2.getSyntacticDiagnostics(void 0, cancellationToken));
        if (allDiagnostics.length === configFileParsingDiagnosticsLength) {
          ts3.addRange(allDiagnostics, program2.getOptionsDiagnostics(cancellationToken));
          if (!isListFilesOnly) {
            ts3.addRange(allDiagnostics, program2.getGlobalDiagnostics(cancellationToken));
            if (allDiagnostics.length === configFileParsingDiagnosticsLength) {
              ts3.addRange(allDiagnostics, program2.getSemanticDiagnostics(void 0, cancellationToken));
            }
          }
        }
        var emitResult = isListFilesOnly ? { emitSkipped: true, diagnostics: ts3.emptyArray } : program2.emit(void 0, writeFile, cancellationToken, emitOnlyDtsFiles, customTransformers);
        var emittedFiles = emitResult.emittedFiles, emitDiagnostics = emitResult.diagnostics;
        ts3.addRange(allDiagnostics, emitDiagnostics);
        var diagnostics = ts3.sortAndDeduplicateDiagnostics(allDiagnostics);
        diagnostics.forEach(reportDiagnostic);
        if (write) {
          var currentDir_1 = program2.getCurrentDirectory();
          ts3.forEach(emittedFiles, function(file) {
            var filepath = ts3.getNormalizedAbsolutePath(file, currentDir_1);
            write("TSFILE: " + filepath);
          });
          listFiles(program2, write);
        }
        if (reportSummary) {
          reportSummary(getErrorCountForSummary(diagnostics));
        }
        return {
          emitResult,
          diagnostics
        };
      }
      ts3.emitFilesAndReportErrors = emitFilesAndReportErrors;
      function emitFilesAndReportErrorsAndGetExitStatus(program2, reportDiagnostic, write, reportSummary, writeFile, cancellationToken, emitOnlyDtsFiles, customTransformers) {
        var _a2 = emitFilesAndReportErrors(program2, reportDiagnostic, write, reportSummary, writeFile, cancellationToken, emitOnlyDtsFiles, customTransformers), emitResult = _a2.emitResult, diagnostics = _a2.diagnostics;
        if (emitResult.emitSkipped && diagnostics.length > 0) {
          return ts3.ExitStatus.DiagnosticsPresent_OutputsSkipped;
        } else if (diagnostics.length > 0) {
          return ts3.ExitStatus.DiagnosticsPresent_OutputsGenerated;
        }
        return ts3.ExitStatus.Success;
      }
      ts3.emitFilesAndReportErrorsAndGetExitStatus = emitFilesAndReportErrorsAndGetExitStatus;
      ts3.noopFileWatcher = { close: ts3.noop };
      ts3.returnNoopFileWatcher = function() {
        return ts3.noopFileWatcher;
      };
      function createWatchHost(system, reportWatchStatus) {
        if (system === void 0) {
          system = ts3.sys;
        }
        var onWatchStatusChange = reportWatchStatus || createWatchStatusReporter(system);
        return {
          onWatchStatusChange,
          watchFile: ts3.maybeBind(system, system.watchFile) || ts3.returnNoopFileWatcher,
          watchDirectory: ts3.maybeBind(system, system.watchDirectory) || ts3.returnNoopFileWatcher,
          setTimeout: ts3.maybeBind(system, system.setTimeout) || ts3.noop,
          clearTimeout: ts3.maybeBind(system, system.clearTimeout) || ts3.noop
        };
      }
      ts3.createWatchHost = createWatchHost;
      ts3.WatchType = {
        ConfigFile: "Config file",
        ExtendedConfigFile: "Extended config file",
        SourceFile: "Source file",
        MissingFile: "Missing file",
        WildcardDirectory: "Wild card directory",
        FailedLookupLocations: "Failed Lookup Locations",
        TypeRoots: "Type roots",
        ConfigFileOfReferencedProject: "Config file of referened project",
        ExtendedConfigOfReferencedProject: "Extended config file of referenced project",
        WildcardDirectoryOfReferencedProject: "Wild card directory of referenced project"
      };
      function createWatchFactory(host, options) {
        var watchLogLevel = host.trace ? options.extendedDiagnostics ? ts3.WatchLogLevel.Verbose : options.diagnostics ? ts3.WatchLogLevel.TriggerOnly : ts3.WatchLogLevel.None : ts3.WatchLogLevel.None;
        var writeLog = watchLogLevel !== ts3.WatchLogLevel.None ? function(s2) {
          return host.trace(s2);
        } : ts3.noop;
        var result2 = ts3.getWatchFactory(host, watchLogLevel, writeLog);
        result2.writeLog = writeLog;
        return result2;
      }
      ts3.createWatchFactory = createWatchFactory;
      function createCompilerHostFromProgramHost(host, getCompilerOptions, directoryStructureHost) {
        if (directoryStructureHost === void 0) {
          directoryStructureHost = host;
        }
        var useCaseSensitiveFileNames = host.useCaseSensitiveFileNames();
        var hostGetNewLine = ts3.memoize(function() {
          return host.getNewLine();
        });
        return {
          getSourceFile: function(fileName, languageVersion, onError) {
            var text;
            try {
              ts3.performance.mark("beforeIORead");
              text = host.readFile(fileName, getCompilerOptions().charset);
              ts3.performance.mark("afterIORead");
              ts3.performance.measure("I/O Read", "beforeIORead", "afterIORead");
            } catch (e2) {
              if (onError) {
                onError(e2.message);
              }
              text = "";
            }
            return text !== void 0 ? ts3.createSourceFile(fileName, text, languageVersion) : void 0;
          },
          getDefaultLibLocation: ts3.maybeBind(host, host.getDefaultLibLocation),
          getDefaultLibFileName: function(options) {
            return host.getDefaultLibFileName(options);
          },
          writeFile,
          getCurrentDirectory: ts3.memoize(function() {
            return host.getCurrentDirectory();
          }),
          useCaseSensitiveFileNames: function() {
            return useCaseSensitiveFileNames;
          },
          getCanonicalFileName: ts3.createGetCanonicalFileName(useCaseSensitiveFileNames),
          getNewLine: function() {
            return ts3.getNewLineCharacter(getCompilerOptions(), hostGetNewLine);
          },
          fileExists: function(f) {
            return host.fileExists(f);
          },
          readFile: function(f) {
            return host.readFile(f);
          },
          trace: ts3.maybeBind(host, host.trace),
          directoryExists: ts3.maybeBind(directoryStructureHost, directoryStructureHost.directoryExists),
          getDirectories: ts3.maybeBind(directoryStructureHost, directoryStructureHost.getDirectories),
          realpath: ts3.maybeBind(host, host.realpath),
          getEnvironmentVariable: ts3.maybeBind(host, host.getEnvironmentVariable) || function() {
            return "";
          },
          createHash: ts3.maybeBind(host, host.createHash),
          readDirectory: ts3.maybeBind(host, host.readDirectory),
          disableUseFileVersionAsSignature: host.disableUseFileVersionAsSignature
        };
        function writeFile(fileName, text, writeByteOrderMark, onError) {
          try {
            ts3.performance.mark("beforeIOWrite");
            ts3.writeFileEnsuringDirectories(fileName, text, writeByteOrderMark, function(path2, data, writeByteOrderMark2) {
              return host.writeFile(path2, data, writeByteOrderMark2);
            }, function(path2) {
              return host.createDirectory(path2);
            }, function(path2) {
              return host.directoryExists(path2);
            });
            ts3.performance.mark("afterIOWrite");
            ts3.performance.measure("I/O Write", "beforeIOWrite", "afterIOWrite");
          } catch (e2) {
            if (onError) {
              onError(e2.message);
            }
          }
        }
      }
      ts3.createCompilerHostFromProgramHost = createCompilerHostFromProgramHost;
      function setGetSourceFileAsHashVersioned(compilerHost, host) {
        var originalGetSourceFile = compilerHost.getSourceFile;
        var computeHash = ts3.maybeBind(host, host.createHash) || ts3.generateDjb2Hash;
        compilerHost.getSourceFile = function() {
          var args = [];
          for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
          }
          var result2 = originalGetSourceFile.call.apply(originalGetSourceFile, __spreadArray([compilerHost], args));
          if (result2) {
            result2.version = computeHash(result2.text);
          }
          return result2;
        };
      }
      ts3.setGetSourceFileAsHashVersioned = setGetSourceFileAsHashVersioned;
      function createProgramHost(system, createProgram) {
        var getDefaultLibLocation = ts3.memoize(function() {
          return ts3.getDirectoryPath(ts3.normalizePath(system.getExecutingFilePath()));
        });
        return {
          useCaseSensitiveFileNames: function() {
            return system.useCaseSensitiveFileNames;
          },
          getNewLine: function() {
            return system.newLine;
          },
          getCurrentDirectory: ts3.memoize(function() {
            return system.getCurrentDirectory();
          }),
          getDefaultLibLocation,
          getDefaultLibFileName: function(options) {
            return ts3.combinePaths(getDefaultLibLocation(), ts3.getDefaultLibFileName(options));
          },
          fileExists: function(path2) {
            return system.fileExists(path2);
          },
          readFile: function(path2, encoding) {
            return system.readFile(path2, encoding);
          },
          directoryExists: function(path2) {
            return system.directoryExists(path2);
          },
          getDirectories: function(path2) {
            return system.getDirectories(path2);
          },
          readDirectory: function(path2, extensions, exclude, include, depth) {
            return system.readDirectory(path2, extensions, exclude, include, depth);
          },
          realpath: ts3.maybeBind(system, system.realpath),
          getEnvironmentVariable: ts3.maybeBind(system, system.getEnvironmentVariable),
          trace: function(s2) {
            return system.write(s2 + system.newLine);
          },
          createDirectory: function(path2) {
            return system.createDirectory(path2);
          },
          writeFile: function(path2, data, writeByteOrderMark) {
            return system.writeFile(path2, data, writeByteOrderMark);
          },
          createHash: ts3.maybeBind(system, system.createHash),
          createProgram: createProgram || ts3.createEmitAndSemanticDiagnosticsBuilderProgram,
          disableUseFileVersionAsSignature: system.disableUseFileVersionAsSignature
        };
      }
      ts3.createProgramHost = createProgramHost;
      function createWatchCompilerHost(system, createProgram, reportDiagnostic, reportWatchStatus) {
        if (system === void 0) {
          system = ts3.sys;
        }
        var write = function(s2) {
          return system.write(s2 + system.newLine);
        };
        var result2 = createProgramHost(system, createProgram);
        ts3.copyProperties(result2, createWatchHost(system, reportWatchStatus));
        result2.afterProgramCreate = function(builderProgram) {
          var compilerOptions = builderProgram.getCompilerOptions();
          var newLine = ts3.getNewLineCharacter(compilerOptions, function() {
            return system.newLine;
          });
          emitFilesAndReportErrors(builderProgram, reportDiagnostic, write, function(errorCount) {
            return result2.onWatchStatusChange(ts3.createCompilerDiagnostic(getWatchErrorSummaryDiagnosticMessage(errorCount), errorCount), newLine, compilerOptions, errorCount);
          });
        };
        return result2;
      }
      function reportUnrecoverableDiagnostic(system, reportDiagnostic, diagnostic) {
        reportDiagnostic(diagnostic);
        system.exit(ts3.ExitStatus.DiagnosticsPresent_OutputsSkipped);
      }
      function createWatchCompilerHostOfConfigFile(_a2) {
        var configFileName = _a2.configFileName, optionsToExtend = _a2.optionsToExtend, watchOptionsToExtend = _a2.watchOptionsToExtend, extraFileExtensions = _a2.extraFileExtensions, system = _a2.system, createProgram = _a2.createProgram, reportDiagnostic = _a2.reportDiagnostic, reportWatchStatus = _a2.reportWatchStatus;
        var diagnosticReporter = reportDiagnostic || createDiagnosticReporter(system);
        var host = createWatchCompilerHost(system, createProgram, diagnosticReporter, reportWatchStatus);
        host.onUnRecoverableConfigFileDiagnostic = function(diagnostic) {
          return reportUnrecoverableDiagnostic(system, diagnosticReporter, diagnostic);
        };
        host.configFileName = configFileName;
        host.optionsToExtend = optionsToExtend;
        host.watchOptionsToExtend = watchOptionsToExtend;
        host.extraFileExtensions = extraFileExtensions;
        return host;
      }
      ts3.createWatchCompilerHostOfConfigFile = createWatchCompilerHostOfConfigFile;
      function createWatchCompilerHostOfFilesAndCompilerOptions(_a2) {
        var rootFiles = _a2.rootFiles, options = _a2.options, watchOptions = _a2.watchOptions, projectReferences = _a2.projectReferences, system = _a2.system, createProgram = _a2.createProgram, reportDiagnostic = _a2.reportDiagnostic, reportWatchStatus = _a2.reportWatchStatus;
        var host = createWatchCompilerHost(system, createProgram, reportDiagnostic || createDiagnosticReporter(system), reportWatchStatus);
        host.rootFiles = rootFiles;
        host.options = options;
        host.watchOptions = watchOptions;
        host.projectReferences = projectReferences;
        return host;
      }
      ts3.createWatchCompilerHostOfFilesAndCompilerOptions = createWatchCompilerHostOfFilesAndCompilerOptions;
      function performIncrementalCompilation(input) {
        var system = input.system || ts3.sys;
        var host = input.host || (input.host = ts3.createIncrementalCompilerHost(input.options, system));
        var builderProgram = ts3.createIncrementalProgram(input);
        var exitStatus = emitFilesAndReportErrorsAndGetExitStatus(builderProgram, input.reportDiagnostic || createDiagnosticReporter(system), function(s2) {
          return host.trace && host.trace(s2);
        }, input.reportErrorSummary || input.options.pretty ? function(errorCount) {
          return system.write(getErrorSummaryText(errorCount, system.newLine));
        } : void 0);
        if (input.afterProgramEmitAndDiagnostics)
          input.afterProgramEmitAndDiagnostics(builderProgram);
        return exitStatus;
      }
      ts3.performIncrementalCompilation = performIncrementalCompilation;
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      function readBuilderProgram(compilerOptions, host) {
        if (ts3.outFile(compilerOptions))
          return void 0;
        var buildInfoPath = ts3.getTsBuildInfoEmitOutputFilePath(compilerOptions);
        if (!buildInfoPath)
          return void 0;
        var content = host.readFile(buildInfoPath);
        if (!content)
          return void 0;
        var buildInfo = ts3.getBuildInfo(content);
        if (buildInfo.version !== ts3.version)
          return void 0;
        if (!buildInfo.program)
          return void 0;
        return ts3.createBuildProgramUsingProgramBuildInfo(buildInfo.program, buildInfoPath, host);
      }
      ts3.readBuilderProgram = readBuilderProgram;
      function createIncrementalCompilerHost(options, system) {
        if (system === void 0) {
          system = ts3.sys;
        }
        var host = ts3.createCompilerHostWorker(options, void 0, system);
        host.createHash = ts3.maybeBind(system, system.createHash);
        host.disableUseFileVersionAsSignature = system.disableUseFileVersionAsSignature;
        ts3.setGetSourceFileAsHashVersioned(host, system);
        ts3.changeCompilerHostLikeToUseCache(host, function(fileName) {
          return ts3.toPath(fileName, host.getCurrentDirectory(), host.getCanonicalFileName);
        });
        return host;
      }
      ts3.createIncrementalCompilerHost = createIncrementalCompilerHost;
      function createIncrementalProgram(_a2) {
        var rootNames = _a2.rootNames, options = _a2.options, configFileParsingDiagnostics = _a2.configFileParsingDiagnostics, projectReferences = _a2.projectReferences, host = _a2.host, createProgram = _a2.createProgram;
        host = host || createIncrementalCompilerHost(options);
        createProgram = createProgram || ts3.createEmitAndSemanticDiagnosticsBuilderProgram;
        var oldProgram = readBuilderProgram(options, host);
        return createProgram(rootNames, options, host, oldProgram, configFileParsingDiagnostics, projectReferences);
      }
      ts3.createIncrementalProgram = createIncrementalProgram;
      function createWatchCompilerHost(rootFilesOrConfigFileName, options, system, createProgram, reportDiagnostic, reportWatchStatus, projectReferencesOrWatchOptionsToExtend, watchOptionsOrExtraFileExtensions) {
        if (ts3.isArray(rootFilesOrConfigFileName)) {
          return ts3.createWatchCompilerHostOfFilesAndCompilerOptions({
            rootFiles: rootFilesOrConfigFileName,
            options,
            watchOptions: watchOptionsOrExtraFileExtensions,
            projectReferences: projectReferencesOrWatchOptionsToExtend,
            system,
            createProgram,
            reportDiagnostic,
            reportWatchStatus
          });
        } else {
          return ts3.createWatchCompilerHostOfConfigFile({
            configFileName: rootFilesOrConfigFileName,
            optionsToExtend: options,
            watchOptionsToExtend: projectReferencesOrWatchOptionsToExtend,
            extraFileExtensions: watchOptionsOrExtraFileExtensions,
            system,
            createProgram,
            reportDiagnostic,
            reportWatchStatus
          });
        }
      }
      ts3.createWatchCompilerHost = createWatchCompilerHost;
      function createWatchProgram(host) {
        var builderProgram;
        var reloadLevel;
        var missingFilesMap;
        var watchedWildcardDirectories;
        var timerToUpdateProgram;
        var timerToInvalidateFailedLookupResolutions;
        var parsedConfigs;
        var sharedExtendedConfigFileWatchers;
        var extendedConfigCache = host.extendedConfigCache;
        var sourceFilesCache = new ts3.Map();
        var missingFilePathsRequestedForRelease;
        var hasChangedCompilerOptions = false;
        var useCaseSensitiveFileNames = host.useCaseSensitiveFileNames();
        var currentDirectory = host.getCurrentDirectory();
        var configFileName = host.configFileName, _a2 = host.optionsToExtend, optionsToExtendForConfigFile = _a2 === void 0 ? {} : _a2, watchOptionsToExtend = host.watchOptionsToExtend, extraFileExtensions = host.extraFileExtensions, createProgram = host.createProgram;
        var rootFileNames = host.rootFiles, compilerOptions = host.options, watchOptions = host.watchOptions, projectReferences = host.projectReferences;
        var wildcardDirectories;
        var configFileParsingDiagnostics;
        var canConfigFileJsonReportNoInputFiles = false;
        var hasChangedConfigFileParsingErrors = false;
        var cachedDirectoryStructureHost = configFileName === void 0 ? void 0 : ts3.createCachedDirectoryStructureHost(host, currentDirectory, useCaseSensitiveFileNames);
        var directoryStructureHost = cachedDirectoryStructureHost || host;
        var parseConfigFileHost = ts3.parseConfigHostFromCompilerHostLike(host, directoryStructureHost);
        var newLine = updateNewLine();
        if (configFileName && host.configFileParsingResult) {
          setConfigFileParsingResult(host.configFileParsingResult);
          newLine = updateNewLine();
        }
        reportWatchDiagnostic(ts3.Diagnostics.Starting_compilation_in_watch_mode);
        if (configFileName && !host.configFileParsingResult) {
          newLine = ts3.getNewLineCharacter(optionsToExtendForConfigFile, function() {
            return host.getNewLine();
          });
          ts3.Debug.assert(!rootFileNames);
          parseConfigFile();
          newLine = updateNewLine();
        }
        var _b = ts3.createWatchFactory(host, compilerOptions), watchFile = _b.watchFile, watchDirectory = _b.watchDirectory, writeLog = _b.writeLog;
        var getCanonicalFileName = ts3.createGetCanonicalFileName(useCaseSensitiveFileNames);
        writeLog("Current directory: " + currentDirectory + " CaseSensitiveFileNames: " + useCaseSensitiveFileNames);
        var configFileWatcher;
        if (configFileName) {
          configFileWatcher = watchFile(configFileName, scheduleProgramReload, ts3.PollingInterval.High, watchOptions, ts3.WatchType.ConfigFile);
        }
        var compilerHost = ts3.createCompilerHostFromProgramHost(host, function() {
          return compilerOptions;
        }, directoryStructureHost);
        ts3.setGetSourceFileAsHashVersioned(compilerHost, host);
        var getNewSourceFile = compilerHost.getSourceFile;
        compilerHost.getSourceFile = function(fileName) {
          var args = [];
          for (var _i = 1; _i < arguments.length; _i++) {
            args[_i - 1] = arguments[_i];
          }
          return getVersionedSourceFileByPath.apply(void 0, __spreadArray([fileName, toPath(fileName)], args));
        };
        compilerHost.getSourceFileByPath = getVersionedSourceFileByPath;
        compilerHost.getNewLine = function() {
          return newLine;
        };
        compilerHost.fileExists = fileExists;
        compilerHost.onReleaseOldSourceFile = onReleaseOldSourceFile;
        compilerHost.onReleaseParsedCommandLine = onReleaseParsedCommandLine;
        compilerHost.toPath = toPath;
        compilerHost.getCompilationSettings = function() {
          return compilerOptions;
        };
        compilerHost.useSourceOfProjectReferenceRedirect = ts3.maybeBind(host, host.useSourceOfProjectReferenceRedirect);
        compilerHost.watchDirectoryOfFailedLookupLocation = function(dir, cb2, flags) {
          return watchDirectory(dir, cb2, flags, watchOptions, ts3.WatchType.FailedLookupLocations);
        };
        compilerHost.watchTypeRootsDirectory = function(dir, cb2, flags) {
          return watchDirectory(dir, cb2, flags, watchOptions, ts3.WatchType.TypeRoots);
        };
        compilerHost.getCachedDirectoryStructureHost = function() {
          return cachedDirectoryStructureHost;
        };
        compilerHost.scheduleInvalidateResolutionsOfFailedLookupLocations = scheduleInvalidateResolutionsOfFailedLookupLocations;
        compilerHost.onInvalidatedResolution = scheduleProgramUpdate;
        compilerHost.onChangedAutomaticTypeDirectiveNames = scheduleProgramUpdate;
        compilerHost.fileIsOpen = ts3.returnFalse;
        compilerHost.getCurrentProgram = getCurrentProgram;
        compilerHost.writeLog = writeLog;
        compilerHost.getParsedCommandLine = getParsedCommandLine;
        var resolutionCache = ts3.createResolutionCache(compilerHost, configFileName ? ts3.getDirectoryPath(ts3.getNormalizedAbsolutePath(configFileName, currentDirectory)) : currentDirectory, false);
        compilerHost.resolveModuleNames = host.resolveModuleNames ? function() {
          var args = [];
          for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
          }
          return host.resolveModuleNames.apply(host, args);
        } : function(moduleNames, containingFile, reusedNames, redirectedReference) {
          return resolutionCache.resolveModuleNames(moduleNames, containingFile, reusedNames, redirectedReference);
        };
        compilerHost.resolveTypeReferenceDirectives = host.resolveTypeReferenceDirectives ? function() {
          var args = [];
          for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
          }
          return host.resolveTypeReferenceDirectives.apply(host, args);
        } : function(typeDirectiveNames, containingFile, redirectedReference) {
          return resolutionCache.resolveTypeReferenceDirectives(typeDirectiveNames, containingFile, redirectedReference);
        };
        var userProvidedResolution = !!host.resolveModuleNames || !!host.resolveTypeReferenceDirectives;
        builderProgram = readBuilderProgram(compilerOptions, compilerHost);
        synchronizeProgram();
        watchConfigFileWildCardDirectories();
        if (configFileName)
          updateExtendedConfigFilesWatches(toPath(configFileName), compilerOptions, watchOptions, ts3.WatchType.ExtendedConfigFile);
        return configFileName ? { getCurrentProgram: getCurrentBuilderProgram, getProgram: updateProgram, close } : { getCurrentProgram: getCurrentBuilderProgram, getProgram: updateProgram, updateRootFileNames, close };
        function close() {
          clearInvalidateResolutionsOfFailedLookupLocations();
          resolutionCache.clear();
          ts3.clearMap(sourceFilesCache, function(value) {
            if (value && value.fileWatcher) {
              value.fileWatcher.close();
              value.fileWatcher = void 0;
            }
          });
          if (configFileWatcher) {
            configFileWatcher.close();
            configFileWatcher = void 0;
          }
          extendedConfigCache === null || extendedConfigCache === void 0 ? void 0 : extendedConfigCache.clear();
          extendedConfigCache = void 0;
          if (sharedExtendedConfigFileWatchers) {
            ts3.clearMap(sharedExtendedConfigFileWatchers, ts3.closeFileWatcherOf);
            sharedExtendedConfigFileWatchers = void 0;
          }
          if (watchedWildcardDirectories) {
            ts3.clearMap(watchedWildcardDirectories, ts3.closeFileWatcherOf);
            watchedWildcardDirectories = void 0;
          }
          if (missingFilesMap) {
            ts3.clearMap(missingFilesMap, ts3.closeFileWatcher);
            missingFilesMap = void 0;
          }
          if (parsedConfigs) {
            ts3.clearMap(parsedConfigs, function(config) {
              var _a3;
              (_a3 = config.watcher) === null || _a3 === void 0 ? void 0 : _a3.close();
              config.watcher = void 0;
              if (config.watchedDirectories)
                ts3.clearMap(config.watchedDirectories, ts3.closeFileWatcherOf);
              config.watchedDirectories = void 0;
            });
            parsedConfigs = void 0;
          }
        }
        function getCurrentBuilderProgram() {
          return builderProgram;
        }
        function getCurrentProgram() {
          return builderProgram && builderProgram.getProgramOrUndefined();
        }
        function synchronizeProgram() {
          writeLog("Synchronizing program");
          clearInvalidateResolutionsOfFailedLookupLocations();
          var program2 = getCurrentBuilderProgram();
          if (hasChangedCompilerOptions) {
            newLine = updateNewLine();
            if (program2 && ts3.changesAffectModuleResolution(program2.getCompilerOptions(), compilerOptions)) {
              resolutionCache.clear();
            }
          }
          var hasInvalidatedResolution = resolutionCache.createHasInvalidatedResolution(userProvidedResolution);
          if (ts3.isProgramUptoDate(getCurrentProgram(), rootFileNames, compilerOptions, getSourceVersion, fileExists, hasInvalidatedResolution, hasChangedAutomaticTypeDirectiveNames, getParsedCommandLine, projectReferences)) {
            if (hasChangedConfigFileParsingErrors) {
              builderProgram = createProgram(void 0, void 0, compilerHost, builderProgram, configFileParsingDiagnostics, projectReferences);
              hasChangedConfigFileParsingErrors = false;
            }
          } else {
            createNewProgram(hasInvalidatedResolution);
          }
          if (host.afterProgramCreate && program2 !== builderProgram) {
            host.afterProgramCreate(builderProgram);
          }
          return builderProgram;
        }
        function createNewProgram(hasInvalidatedResolution) {
          writeLog("CreatingProgramWith::");
          writeLog("  roots: " + JSON.stringify(rootFileNames));
          writeLog("  options: " + JSON.stringify(compilerOptions));
          if (projectReferences)
            writeLog("  projectReferences: " + JSON.stringify(projectReferences));
          var needsUpdateInTypeRootWatch = hasChangedCompilerOptions || !getCurrentProgram();
          hasChangedCompilerOptions = false;
          hasChangedConfigFileParsingErrors = false;
          resolutionCache.startCachingPerDirectoryResolution();
          compilerHost.hasInvalidatedResolution = hasInvalidatedResolution;
          compilerHost.hasChangedAutomaticTypeDirectiveNames = hasChangedAutomaticTypeDirectiveNames;
          builderProgram = createProgram(rootFileNames, compilerOptions, compilerHost, builderProgram, configFileParsingDiagnostics, projectReferences);
          resolutionCache.finishCachingPerDirectoryResolution();
          ts3.updateMissingFilePathsWatch(builderProgram.getProgram(), missingFilesMap || (missingFilesMap = new ts3.Map()), watchMissingFilePath);
          if (needsUpdateInTypeRootWatch) {
            resolutionCache.updateTypeRootsWatch();
          }
          if (missingFilePathsRequestedForRelease) {
            for (var _i = 0, missingFilePathsRequestedForRelease_1 = missingFilePathsRequestedForRelease; _i < missingFilePathsRequestedForRelease_1.length; _i++) {
              var missingFilePath = missingFilePathsRequestedForRelease_1[_i];
              if (!missingFilesMap.has(missingFilePath)) {
                sourceFilesCache.delete(missingFilePath);
              }
            }
            missingFilePathsRequestedForRelease = void 0;
          }
        }
        function updateRootFileNames(files) {
          ts3.Debug.assert(!configFileName, "Cannot update root file names with config file watch mode");
          rootFileNames = files;
          scheduleProgramUpdate();
        }
        function updateNewLine() {
          return ts3.getNewLineCharacter(compilerOptions || optionsToExtendForConfigFile, function() {
            return host.getNewLine();
          });
        }
        function toPath(fileName) {
          return ts3.toPath(fileName, currentDirectory, getCanonicalFileName);
        }
        function isFileMissingOnHost(hostSourceFile) {
          return typeof hostSourceFile === "boolean";
        }
        function isFilePresenceUnknownOnHost(hostSourceFile) {
          return typeof hostSourceFile.version === "boolean";
        }
        function fileExists(fileName) {
          var path2 = toPath(fileName);
          if (isFileMissingOnHost(sourceFilesCache.get(path2))) {
            return false;
          }
          return directoryStructureHost.fileExists(fileName);
        }
        function getVersionedSourceFileByPath(fileName, path2, languageVersion, onError, shouldCreateNewSourceFile) {
          var hostSourceFile = sourceFilesCache.get(path2);
          if (isFileMissingOnHost(hostSourceFile)) {
            return void 0;
          }
          if (hostSourceFile === void 0 || shouldCreateNewSourceFile || isFilePresenceUnknownOnHost(hostSourceFile)) {
            var sourceFile = getNewSourceFile(fileName, languageVersion, onError);
            if (hostSourceFile) {
              if (sourceFile) {
                hostSourceFile.sourceFile = sourceFile;
                hostSourceFile.version = sourceFile.version;
                if (!hostSourceFile.fileWatcher) {
                  hostSourceFile.fileWatcher = watchFilePath(path2, fileName, onSourceFileChange, ts3.PollingInterval.Low, watchOptions, ts3.WatchType.SourceFile);
                }
              } else {
                if (hostSourceFile.fileWatcher) {
                  hostSourceFile.fileWatcher.close();
                }
                sourceFilesCache.set(path2, false);
              }
            } else {
              if (sourceFile) {
                var fileWatcher = watchFilePath(path2, fileName, onSourceFileChange, ts3.PollingInterval.Low, watchOptions, ts3.WatchType.SourceFile);
                sourceFilesCache.set(path2, { sourceFile, version: sourceFile.version, fileWatcher });
              } else {
                sourceFilesCache.set(path2, false);
              }
            }
            return sourceFile;
          }
          return hostSourceFile.sourceFile;
        }
        function nextSourceFileVersion(path2) {
          var hostSourceFile = sourceFilesCache.get(path2);
          if (hostSourceFile !== void 0) {
            if (isFileMissingOnHost(hostSourceFile)) {
              sourceFilesCache.set(path2, { version: false });
            } else {
              hostSourceFile.version = false;
            }
          }
        }
        function getSourceVersion(path2) {
          var hostSourceFile = sourceFilesCache.get(path2);
          return !hostSourceFile || !hostSourceFile.version ? void 0 : hostSourceFile.version;
        }
        function onReleaseOldSourceFile(oldSourceFile, _oldOptions, hasSourceFileByPath) {
          var hostSourceFileInfo = sourceFilesCache.get(oldSourceFile.resolvedPath);
          if (hostSourceFileInfo !== void 0) {
            if (isFileMissingOnHost(hostSourceFileInfo)) {
              (missingFilePathsRequestedForRelease || (missingFilePathsRequestedForRelease = [])).push(oldSourceFile.path);
            } else if (hostSourceFileInfo.sourceFile === oldSourceFile) {
              if (hostSourceFileInfo.fileWatcher) {
                hostSourceFileInfo.fileWatcher.close();
              }
              sourceFilesCache.delete(oldSourceFile.resolvedPath);
              if (!hasSourceFileByPath) {
                resolutionCache.removeResolutionsOfFile(oldSourceFile.path);
              }
            }
          }
        }
        function reportWatchDiagnostic(message) {
          if (host.onWatchStatusChange) {
            host.onWatchStatusChange(ts3.createCompilerDiagnostic(message), newLine, compilerOptions || optionsToExtendForConfigFile);
          }
        }
        function hasChangedAutomaticTypeDirectiveNames() {
          return resolutionCache.hasChangedAutomaticTypeDirectiveNames();
        }
        function clearInvalidateResolutionsOfFailedLookupLocations() {
          if (!timerToInvalidateFailedLookupResolutions)
            return false;
          host.clearTimeout(timerToInvalidateFailedLookupResolutions);
          timerToInvalidateFailedLookupResolutions = void 0;
          return true;
        }
        function scheduleInvalidateResolutionsOfFailedLookupLocations() {
          if (!host.setTimeout || !host.clearTimeout) {
            return resolutionCache.invalidateResolutionsOfFailedLookupLocations();
          }
          var pending = clearInvalidateResolutionsOfFailedLookupLocations();
          writeLog("Scheduling invalidateFailedLookup" + (pending ? ", Cancelled earlier one" : ""));
          timerToInvalidateFailedLookupResolutions = host.setTimeout(invalidateResolutionsOfFailedLookup, 250);
        }
        function invalidateResolutionsOfFailedLookup() {
          timerToInvalidateFailedLookupResolutions = void 0;
          if (resolutionCache.invalidateResolutionsOfFailedLookupLocations()) {
            scheduleProgramUpdate();
          }
        }
        function scheduleProgramUpdate() {
          if (!host.setTimeout || !host.clearTimeout) {
            return;
          }
          if (timerToUpdateProgram) {
            host.clearTimeout(timerToUpdateProgram);
          }
          writeLog("Scheduling update");
          timerToUpdateProgram = host.setTimeout(updateProgramWithWatchStatus, 250);
        }
        function scheduleProgramReload() {
          ts3.Debug.assert(!!configFileName);
          reloadLevel = ts3.ConfigFileProgramReloadLevel.Full;
          scheduleProgramUpdate();
        }
        function updateProgramWithWatchStatus() {
          timerToUpdateProgram = void 0;
          reportWatchDiagnostic(ts3.Diagnostics.File_change_detected_Starting_incremental_compilation);
          updateProgram();
        }
        function updateProgram() {
          switch (reloadLevel) {
            case ts3.ConfigFileProgramReloadLevel.Partial:
              ts3.perfLogger.logStartUpdateProgram("PartialConfigReload");
              reloadFileNamesFromConfigFile();
              break;
            case ts3.ConfigFileProgramReloadLevel.Full:
              ts3.perfLogger.logStartUpdateProgram("FullConfigReload");
              reloadConfigFile();
              break;
            default:
              ts3.perfLogger.logStartUpdateProgram("SynchronizeProgram");
              synchronizeProgram();
              break;
          }
          ts3.perfLogger.logStopUpdateProgram("Done");
          return getCurrentBuilderProgram();
        }
        function reloadFileNamesFromConfigFile() {
          writeLog("Reloading new file names and options");
          rootFileNames = ts3.getFileNamesFromConfigSpecs(compilerOptions.configFile.configFileSpecs, ts3.getNormalizedAbsolutePath(ts3.getDirectoryPath(configFileName), currentDirectory), compilerOptions, parseConfigFileHost, extraFileExtensions);
          if (ts3.updateErrorForNoInputFiles(rootFileNames, ts3.getNormalizedAbsolutePath(configFileName, currentDirectory), compilerOptions.configFile.configFileSpecs, configFileParsingDiagnostics, canConfigFileJsonReportNoInputFiles)) {
            hasChangedConfigFileParsingErrors = true;
          }
          synchronizeProgram();
        }
        function reloadConfigFile() {
          writeLog("Reloading config file: " + configFileName);
          reloadLevel = ts3.ConfigFileProgramReloadLevel.None;
          if (cachedDirectoryStructureHost) {
            cachedDirectoryStructureHost.clearCache();
          }
          parseConfigFile();
          hasChangedCompilerOptions = true;
          synchronizeProgram();
          watchConfigFileWildCardDirectories();
          updateExtendedConfigFilesWatches(toPath(configFileName), compilerOptions, watchOptions, ts3.WatchType.ExtendedConfigFile);
        }
        function parseConfigFile() {
          setConfigFileParsingResult(ts3.getParsedCommandLineOfConfigFile(configFileName, optionsToExtendForConfigFile, parseConfigFileHost, extendedConfigCache || (extendedConfigCache = new ts3.Map()), watchOptionsToExtend, extraFileExtensions));
        }
        function setConfigFileParsingResult(configFileParseResult) {
          rootFileNames = configFileParseResult.fileNames;
          compilerOptions = configFileParseResult.options;
          watchOptions = configFileParseResult.watchOptions;
          projectReferences = configFileParseResult.projectReferences;
          wildcardDirectories = configFileParseResult.wildcardDirectories;
          configFileParsingDiagnostics = ts3.getConfigFileParsingDiagnostics(configFileParseResult).slice();
          canConfigFileJsonReportNoInputFiles = ts3.canJsonReportNoInputFiles(configFileParseResult.raw);
          hasChangedConfigFileParsingErrors = true;
        }
        function getParsedCommandLine(configFileName2) {
          var configPath = toPath(configFileName2);
          var config = parsedConfigs === null || parsedConfigs === void 0 ? void 0 : parsedConfigs.get(configPath);
          if (config) {
            if (!config.reloadLevel)
              return config.parsedCommandLine;
            if (config.parsedCommandLine && config.reloadLevel === ts3.ConfigFileProgramReloadLevel.Partial && !host.getParsedCommandLine) {
              writeLog("Reloading new file names and options");
              var fileNames = ts3.getFileNamesFromConfigSpecs(config.parsedCommandLine.options.configFile.configFileSpecs, ts3.getNormalizedAbsolutePath(ts3.getDirectoryPath(configFileName2), currentDirectory), compilerOptions, parseConfigFileHost);
              config.parsedCommandLine = __assign(__assign({}, config.parsedCommandLine), { fileNames });
              config.reloadLevel = void 0;
              return config.parsedCommandLine;
            }
          }
          writeLog("Loading config file: " + configFileName2);
          var parsedCommandLine = host.getParsedCommandLine ? host.getParsedCommandLine(configFileName2) : getParsedCommandLineFromConfigFileHost(configFileName2);
          if (config) {
            config.parsedCommandLine = parsedCommandLine;
            config.reloadLevel = void 0;
          } else {
            (parsedConfigs || (parsedConfigs = new ts3.Map())).set(configPath, config = { parsedCommandLine });
          }
          watchReferencedProject(configFileName2, configPath, config);
          return parsedCommandLine;
        }
        function getParsedCommandLineFromConfigFileHost(configFileName2) {
          var onUnRecoverableConfigFileDiagnostic = parseConfigFileHost.onUnRecoverableConfigFileDiagnostic;
          parseConfigFileHost.onUnRecoverableConfigFileDiagnostic = ts3.noop;
          var parsedCommandLine = ts3.getParsedCommandLineOfConfigFile(configFileName2, void 0, parseConfigFileHost, extendedConfigCache || (extendedConfigCache = new ts3.Map()), watchOptionsToExtend);
          parseConfigFileHost.onUnRecoverableConfigFileDiagnostic = onUnRecoverableConfigFileDiagnostic;
          return parsedCommandLine;
        }
        function onReleaseParsedCommandLine(fileName) {
          var _a3;
          var path2 = toPath(fileName);
          var config = parsedConfigs === null || parsedConfigs === void 0 ? void 0 : parsedConfigs.get(path2);
          if (!config)
            return;
          parsedConfigs.delete(path2);
          if (config.watchedDirectories)
            ts3.clearMap(config.watchedDirectories, ts3.closeFileWatcherOf);
          (_a3 = config.watcher) === null || _a3 === void 0 ? void 0 : _a3.close();
          ts3.clearSharedExtendedConfigFileWatcher(path2, sharedExtendedConfigFileWatchers);
        }
        function watchFilePath(path2, file, callback, pollingInterval, options, watchType) {
          return watchFile(file, function(fileName, eventKind) {
            return callback(fileName, eventKind, path2);
          }, pollingInterval, options, watchType);
        }
        function onSourceFileChange(fileName, eventKind, path2) {
          updateCachedSystemWithFile(fileName, path2, eventKind);
          if (eventKind === ts3.FileWatcherEventKind.Deleted && sourceFilesCache.has(path2)) {
            resolutionCache.invalidateResolutionOfFile(path2);
          }
          nextSourceFileVersion(path2);
          scheduleProgramUpdate();
        }
        function updateCachedSystemWithFile(fileName, path2, eventKind) {
          if (cachedDirectoryStructureHost) {
            cachedDirectoryStructureHost.addOrDeleteFile(fileName, path2, eventKind);
          }
        }
        function watchMissingFilePath(missingFilePath) {
          return (parsedConfigs === null || parsedConfigs === void 0 ? void 0 : parsedConfigs.has(missingFilePath)) ? ts3.noopFileWatcher : watchFilePath(missingFilePath, missingFilePath, onMissingFileChange, ts3.PollingInterval.Medium, watchOptions, ts3.WatchType.MissingFile);
        }
        function onMissingFileChange(fileName, eventKind, missingFilePath) {
          updateCachedSystemWithFile(fileName, missingFilePath, eventKind);
          if (eventKind === ts3.FileWatcherEventKind.Created && missingFilesMap.has(missingFilePath)) {
            missingFilesMap.get(missingFilePath).close();
            missingFilesMap.delete(missingFilePath);
            nextSourceFileVersion(missingFilePath);
            scheduleProgramUpdate();
          }
        }
        function watchConfigFileWildCardDirectories() {
          if (wildcardDirectories) {
            ts3.updateWatchingWildcardDirectories(watchedWildcardDirectories || (watchedWildcardDirectories = new ts3.Map()), new ts3.Map(ts3.getEntries(wildcardDirectories)), watchWildcardDirectory);
          } else if (watchedWildcardDirectories) {
            ts3.clearMap(watchedWildcardDirectories, ts3.closeFileWatcherOf);
          }
        }
        function watchWildcardDirectory(directory, flags) {
          return watchDirectory(directory, function(fileOrDirectory) {
            ts3.Debug.assert(!!configFileName);
            var fileOrDirectoryPath = toPath(fileOrDirectory);
            if (cachedDirectoryStructureHost) {
              cachedDirectoryStructureHost.addOrDeleteFileOrDirectory(fileOrDirectory, fileOrDirectoryPath);
            }
            nextSourceFileVersion(fileOrDirectoryPath);
            if (ts3.isIgnoredFileFromWildCardWatching({
              watchedDirPath: toPath(directory),
              fileOrDirectory,
              fileOrDirectoryPath,
              configFileName,
              extraFileExtensions,
              options: compilerOptions,
              program: getCurrentBuilderProgram() || rootFileNames,
              currentDirectory,
              useCaseSensitiveFileNames,
              writeLog,
              toPath
            }))
              return;
            if (reloadLevel !== ts3.ConfigFileProgramReloadLevel.Full) {
              reloadLevel = ts3.ConfigFileProgramReloadLevel.Partial;
              scheduleProgramUpdate();
            }
          }, flags, watchOptions, ts3.WatchType.WildcardDirectory);
        }
        function updateExtendedConfigFilesWatches(forProjectPath, options, watchOptions2, watchType) {
          ts3.updateSharedExtendedConfigFileWatcher(forProjectPath, options, sharedExtendedConfigFileWatchers || (sharedExtendedConfigFileWatchers = new ts3.Map()), function(extendedConfigFileName, extendedConfigFilePath) {
            return watchFile(extendedConfigFileName, function(_fileName, eventKind) {
              var _a3;
              updateCachedSystemWithFile(extendedConfigFileName, extendedConfigFilePath, eventKind);
              if (extendedConfigCache)
                ts3.cleanExtendedConfigCache(extendedConfigCache, extendedConfigFilePath, toPath);
              var projects = (_a3 = sharedExtendedConfigFileWatchers.get(extendedConfigFilePath)) === null || _a3 === void 0 ? void 0 : _a3.projects;
              if (!(projects === null || projects === void 0 ? void 0 : projects.size))
                return;
              projects.forEach(function(projectPath) {
                if (toPath(configFileName) === projectPath) {
                  reloadLevel = ts3.ConfigFileProgramReloadLevel.Full;
                } else {
                  var config = parsedConfigs === null || parsedConfigs === void 0 ? void 0 : parsedConfigs.get(projectPath);
                  if (config)
                    config.reloadLevel = ts3.ConfigFileProgramReloadLevel.Full;
                  resolutionCache.removeResolutionsFromProjectReferenceRedirects(projectPath);
                }
                scheduleProgramUpdate();
              });
            }, ts3.PollingInterval.High, watchOptions2, watchType);
          }, toPath);
        }
        function watchReferencedProject(configFileName2, configPath, commandLine) {
          var _a3, _b2, _c, _d, _e;
          commandLine.watcher || (commandLine.watcher = watchFile(configFileName2, function(_fileName, eventKind) {
            updateCachedSystemWithFile(configFileName2, configPath, eventKind);
            var config = parsedConfigs === null || parsedConfigs === void 0 ? void 0 : parsedConfigs.get(configPath);
            if (config)
              config.reloadLevel = ts3.ConfigFileProgramReloadLevel.Full;
            resolutionCache.removeResolutionsFromProjectReferenceRedirects(configPath);
            scheduleProgramUpdate();
          }, ts3.PollingInterval.High, ((_a3 = commandLine.parsedCommandLine) === null || _a3 === void 0 ? void 0 : _a3.watchOptions) || watchOptions, ts3.WatchType.ConfigFileOfReferencedProject));
          if ((_b2 = commandLine.parsedCommandLine) === null || _b2 === void 0 ? void 0 : _b2.wildcardDirectories) {
            ts3.updateWatchingWildcardDirectories(commandLine.watchedDirectories || (commandLine.watchedDirectories = new ts3.Map()), new ts3.Map(ts3.getEntries((_c = commandLine.parsedCommandLine) === null || _c === void 0 ? void 0 : _c.wildcardDirectories)), function(directory, flags) {
              var _a4;
              return watchDirectory(directory, function(fileOrDirectory) {
                var fileOrDirectoryPath = toPath(fileOrDirectory);
                if (cachedDirectoryStructureHost) {
                  cachedDirectoryStructureHost.addOrDeleteFileOrDirectory(fileOrDirectory, fileOrDirectoryPath);
                }
                nextSourceFileVersion(fileOrDirectoryPath);
                var config = parsedConfigs === null || parsedConfigs === void 0 ? void 0 : parsedConfigs.get(configPath);
                if (!(config === null || config === void 0 ? void 0 : config.parsedCommandLine))
                  return;
                if (ts3.isIgnoredFileFromWildCardWatching({
                  watchedDirPath: toPath(directory),
                  fileOrDirectory,
                  fileOrDirectoryPath,
                  configFileName: configFileName2,
                  options: config.parsedCommandLine.options,
                  program: config.parsedCommandLine.fileNames,
                  currentDirectory,
                  useCaseSensitiveFileNames,
                  writeLog,
                  toPath
                }))
                  return;
                if (config.reloadLevel !== ts3.ConfigFileProgramReloadLevel.Full) {
                  config.reloadLevel = ts3.ConfigFileProgramReloadLevel.Partial;
                  scheduleProgramUpdate();
                }
              }, flags, ((_a4 = commandLine.parsedCommandLine) === null || _a4 === void 0 ? void 0 : _a4.watchOptions) || watchOptions, ts3.WatchType.WildcardDirectoryOfReferencedProject);
            });
          } else if (commandLine.watchedDirectories) {
            ts3.clearMap(commandLine.watchedDirectories, ts3.closeFileWatcherOf);
            commandLine.watchedDirectories = void 0;
          }
          updateExtendedConfigFilesWatches(configPath, (_d = commandLine.parsedCommandLine) === null || _d === void 0 ? void 0 : _d.options, ((_e = commandLine.parsedCommandLine) === null || _e === void 0 ? void 0 : _e.watchOptions) || watchOptions, ts3.WatchType.ExtendedConfigOfReferencedProject);
        }
      }
      ts3.createWatchProgram = createWatchProgram;
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var UpToDateStatusType;
      (function(UpToDateStatusType2) {
        UpToDateStatusType2[UpToDateStatusType2["Unbuildable"] = 0] = "Unbuildable";
        UpToDateStatusType2[UpToDateStatusType2["UpToDate"] = 1] = "UpToDate";
        UpToDateStatusType2[UpToDateStatusType2["UpToDateWithUpstreamTypes"] = 2] = "UpToDateWithUpstreamTypes";
        UpToDateStatusType2[UpToDateStatusType2["OutOfDateWithPrepend"] = 3] = "OutOfDateWithPrepend";
        UpToDateStatusType2[UpToDateStatusType2["OutputMissing"] = 4] = "OutputMissing";
        UpToDateStatusType2[UpToDateStatusType2["OutOfDateWithSelf"] = 5] = "OutOfDateWithSelf";
        UpToDateStatusType2[UpToDateStatusType2["OutOfDateWithUpstream"] = 6] = "OutOfDateWithUpstream";
        UpToDateStatusType2[UpToDateStatusType2["UpstreamOutOfDate"] = 7] = "UpstreamOutOfDate";
        UpToDateStatusType2[UpToDateStatusType2["UpstreamBlocked"] = 8] = "UpstreamBlocked";
        UpToDateStatusType2[UpToDateStatusType2["ComputingUpstream"] = 9] = "ComputingUpstream";
        UpToDateStatusType2[UpToDateStatusType2["TsVersionOutputOfDate"] = 10] = "TsVersionOutputOfDate";
        UpToDateStatusType2[UpToDateStatusType2["ContainerOnly"] = 11] = "ContainerOnly";
      })(UpToDateStatusType = ts3.UpToDateStatusType || (ts3.UpToDateStatusType = {}));
      function resolveConfigFileProjectName(project) {
        if (ts3.fileExtensionIs(project, ".json")) {
          return project;
        }
        return ts3.combinePaths(project, "tsconfig.json");
      }
      ts3.resolveConfigFileProjectName = resolveConfigFileProjectName;
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var minimumDate = new Date(-864e13);
      var maximumDate = new Date(864e13);
      var BuildResultFlags;
      (function(BuildResultFlags2) {
        BuildResultFlags2[BuildResultFlags2["None"] = 0] = "None";
        BuildResultFlags2[BuildResultFlags2["Success"] = 1] = "Success";
        BuildResultFlags2[BuildResultFlags2["DeclarationOutputUnchanged"] = 2] = "DeclarationOutputUnchanged";
        BuildResultFlags2[BuildResultFlags2["ConfigFileErrors"] = 4] = "ConfigFileErrors";
        BuildResultFlags2[BuildResultFlags2["SyntaxErrors"] = 8] = "SyntaxErrors";
        BuildResultFlags2[BuildResultFlags2["TypeErrors"] = 16] = "TypeErrors";
        BuildResultFlags2[BuildResultFlags2["DeclarationEmitErrors"] = 32] = "DeclarationEmitErrors";
        BuildResultFlags2[BuildResultFlags2["EmitErrors"] = 64] = "EmitErrors";
        BuildResultFlags2[BuildResultFlags2["AnyErrors"] = 124] = "AnyErrors";
      })(BuildResultFlags || (BuildResultFlags = {}));
      function getOrCreateValueFromConfigFileMap(configFileMap, resolved, createT) {
        var existingValue = configFileMap.get(resolved);
        var newValue;
        if (!existingValue) {
          newValue = createT();
          configFileMap.set(resolved, newValue);
        }
        return existingValue || newValue;
      }
      function getOrCreateValueMapFromConfigFileMap(configFileMap, resolved) {
        return getOrCreateValueFromConfigFileMap(configFileMap, resolved, function() {
          return new ts3.Map();
        });
      }
      function newer(date1, date2) {
        return date2 > date1 ? date2 : date1;
      }
      function isDeclarationFile(fileName) {
        return ts3.fileExtensionIs(fileName, ".d.ts");
      }
      function isCircularBuildOrder(buildOrder) {
        return !!buildOrder && !!buildOrder.buildOrder;
      }
      ts3.isCircularBuildOrder = isCircularBuildOrder;
      function getBuildOrderFromAnyBuildOrder(anyBuildOrder) {
        return isCircularBuildOrder(anyBuildOrder) ? anyBuildOrder.buildOrder : anyBuildOrder;
      }
      ts3.getBuildOrderFromAnyBuildOrder = getBuildOrderFromAnyBuildOrder;
      function createBuilderStatusReporter(system, pretty) {
        return function(diagnostic) {
          var output = pretty ? "[" + ts3.formatColorAndReset(ts3.getLocaleTimeString(system), ts3.ForegroundColorEscapeSequences.Grey) + "] " : ts3.getLocaleTimeString(system) + " - ";
          output += "" + ts3.flattenDiagnosticMessageText(diagnostic.messageText, system.newLine) + (system.newLine + system.newLine);
          system.write(output);
        };
      }
      ts3.createBuilderStatusReporter = createBuilderStatusReporter;
      function createSolutionBuilderHostBase(system, createProgram, reportDiagnostic, reportSolutionBuilderStatus) {
        var host = ts3.createProgramHost(system, createProgram);
        host.getModifiedTime = system.getModifiedTime ? function(path2) {
          return system.getModifiedTime(path2);
        } : ts3.returnUndefined;
        host.setModifiedTime = system.setModifiedTime ? function(path2, date) {
          return system.setModifiedTime(path2, date);
        } : ts3.noop;
        host.deleteFile = system.deleteFile ? function(path2) {
          return system.deleteFile(path2);
        } : ts3.noop;
        host.reportDiagnostic = reportDiagnostic || ts3.createDiagnosticReporter(system);
        host.reportSolutionBuilderStatus = reportSolutionBuilderStatus || createBuilderStatusReporter(system);
        host.now = ts3.maybeBind(system, system.now);
        return host;
      }
      function createSolutionBuilderHost(system, createProgram, reportDiagnostic, reportSolutionBuilderStatus, reportErrorSummary2) {
        if (system === void 0) {
          system = ts3.sys;
        }
        var host = createSolutionBuilderHostBase(system, createProgram, reportDiagnostic, reportSolutionBuilderStatus);
        host.reportErrorSummary = reportErrorSummary2;
        return host;
      }
      ts3.createSolutionBuilderHost = createSolutionBuilderHost;
      function createSolutionBuilderWithWatchHost(system, createProgram, reportDiagnostic, reportSolutionBuilderStatus, reportWatchStatus2) {
        if (system === void 0) {
          system = ts3.sys;
        }
        var host = createSolutionBuilderHostBase(system, createProgram, reportDiagnostic, reportSolutionBuilderStatus);
        var watchHost = ts3.createWatchHost(system, reportWatchStatus2);
        ts3.copyProperties(host, watchHost);
        return host;
      }
      ts3.createSolutionBuilderWithWatchHost = createSolutionBuilderWithWatchHost;
      function getCompilerOptionsOfBuildOptions(buildOptions) {
        var result2 = {};
        ts3.commonOptionsWithBuild.forEach(function(option) {
          if (ts3.hasProperty(buildOptions, option.name))
            result2[option.name] = buildOptions[option.name];
        });
        return result2;
      }
      function createSolutionBuilder(host, rootNames, defaultOptions) {
        return createSolutionBuilderWorker(false, host, rootNames, defaultOptions);
      }
      ts3.createSolutionBuilder = createSolutionBuilder;
      function createSolutionBuilderWithWatch(host, rootNames, defaultOptions, baseWatchOptions) {
        return createSolutionBuilderWorker(true, host, rootNames, defaultOptions, baseWatchOptions);
      }
      ts3.createSolutionBuilderWithWatch = createSolutionBuilderWithWatch;
      function createSolutionBuilderState(watch, hostOrHostWithWatch, rootNames, options, baseWatchOptions) {
        var host = hostOrHostWithWatch;
        var hostWithWatch = hostOrHostWithWatch;
        var currentDirectory = host.getCurrentDirectory();
        var getCanonicalFileName = ts3.createGetCanonicalFileName(host.useCaseSensitiveFileNames());
        var baseCompilerOptions = getCompilerOptionsOfBuildOptions(options);
        var compilerHost = ts3.createCompilerHostFromProgramHost(host, function() {
          return state.projectCompilerOptions;
        });
        ts3.setGetSourceFileAsHashVersioned(compilerHost, host);
        compilerHost.getParsedCommandLine = function(fileName) {
          return parseConfigFile(state, fileName, toResolvedConfigFilePath(state, fileName));
        };
        compilerHost.resolveModuleNames = ts3.maybeBind(host, host.resolveModuleNames);
        compilerHost.resolveTypeReferenceDirectives = ts3.maybeBind(host, host.resolveTypeReferenceDirectives);
        var moduleResolutionCache = !compilerHost.resolveModuleNames ? ts3.createModuleResolutionCache(currentDirectory, getCanonicalFileName) : void 0;
        var typeReferenceDirectiveResolutionCache = !compilerHost.resolveTypeReferenceDirectives ? ts3.createTypeReferenceDirectiveResolutionCache(currentDirectory, getCanonicalFileName, void 0, moduleResolutionCache === null || moduleResolutionCache === void 0 ? void 0 : moduleResolutionCache.getPackageJsonInfoCache()) : void 0;
        if (!compilerHost.resolveModuleNames) {
          var loader_3 = function(moduleName, containingFile, redirectedReference) {
            return ts3.resolveModuleName(moduleName, containingFile, state.projectCompilerOptions, compilerHost, moduleResolutionCache, redirectedReference).resolvedModule;
          };
          compilerHost.resolveModuleNames = function(moduleNames, containingFile, _reusedNames, redirectedReference) {
            return ts3.loadWithLocalCache(ts3.Debug.checkEachDefined(moduleNames), containingFile, redirectedReference, loader_3);
          };
        }
        if (!compilerHost.resolveTypeReferenceDirectives) {
          var loader_4 = function(moduleName, containingFile, redirectedReference) {
            return ts3.resolveTypeReferenceDirective(moduleName, containingFile, state.projectCompilerOptions, compilerHost, redirectedReference, state.typeReferenceDirectiveResolutionCache).resolvedTypeReferenceDirective;
          };
          compilerHost.resolveTypeReferenceDirectives = function(typeReferenceDirectiveNames, containingFile, redirectedReference) {
            return ts3.loadWithLocalCache(ts3.Debug.checkEachDefined(typeReferenceDirectiveNames), containingFile, redirectedReference, loader_4);
          };
        }
        var _a2 = ts3.createWatchFactory(hostWithWatch, options), watchFile = _a2.watchFile, watchDirectory = _a2.watchDirectory, writeLog = _a2.writeLog;
        var state = {
          host,
          hostWithWatch,
          currentDirectory,
          getCanonicalFileName,
          parseConfigFileHost: ts3.parseConfigHostFromCompilerHostLike(host),
          write: ts3.maybeBind(host, host.trace),
          options,
          baseCompilerOptions,
          rootNames,
          baseWatchOptions,
          resolvedConfigFilePaths: new ts3.Map(),
          configFileCache: new ts3.Map(),
          projectStatus: new ts3.Map(),
          buildInfoChecked: new ts3.Map(),
          extendedConfigCache: new ts3.Map(),
          builderPrograms: new ts3.Map(),
          diagnostics: new ts3.Map(),
          projectPendingBuild: new ts3.Map(),
          projectErrorsReported: new ts3.Map(),
          compilerHost,
          moduleResolutionCache,
          typeReferenceDirectiveResolutionCache,
          buildOrder: void 0,
          readFileWithCache: function(f) {
            return host.readFile(f);
          },
          projectCompilerOptions: baseCompilerOptions,
          cache: void 0,
          allProjectBuildPending: true,
          needsSummary: true,
          watchAllProjectsPending: watch,
          currentInvalidatedProject: void 0,
          watch,
          allWatchedWildcardDirectories: new ts3.Map(),
          allWatchedInputFiles: new ts3.Map(),
          allWatchedConfigFiles: new ts3.Map(),
          allWatchedExtendedConfigFiles: new ts3.Map(),
          timerToBuildInvalidatedProject: void 0,
          reportFileChangeDetected: false,
          watchFile,
          watchDirectory,
          writeLog
        };
        return state;
      }
      function toPath(state, fileName) {
        return ts3.toPath(fileName, state.currentDirectory, state.getCanonicalFileName);
      }
      function toResolvedConfigFilePath(state, fileName) {
        var resolvedConfigFilePaths = state.resolvedConfigFilePaths;
        var path2 = resolvedConfigFilePaths.get(fileName);
        if (path2 !== void 0)
          return path2;
        var resolvedPath = toPath(state, fileName);
        resolvedConfigFilePaths.set(fileName, resolvedPath);
        return resolvedPath;
      }
      function isParsedCommandLine(entry) {
        return !!entry.options;
      }
      function getCachedParsedConfigFile(state, configFilePath) {
        var value = state.configFileCache.get(configFilePath);
        return value && isParsedCommandLine(value) ? value : void 0;
      }
      function parseConfigFile(state, configFileName, configFilePath) {
        var configFileCache = state.configFileCache;
        var value = configFileCache.get(configFilePath);
        if (value) {
          return isParsedCommandLine(value) ? value : void 0;
        }
        var diagnostic;
        var parseConfigFileHost = state.parseConfigFileHost, baseCompilerOptions = state.baseCompilerOptions, baseWatchOptions = state.baseWatchOptions, extendedConfigCache = state.extendedConfigCache, host = state.host;
        var parsed;
        if (host.getParsedCommandLine) {
          parsed = host.getParsedCommandLine(configFileName);
          if (!parsed)
            diagnostic = ts3.createCompilerDiagnostic(ts3.Diagnostics.File_0_not_found, configFileName);
        } else {
          parseConfigFileHost.onUnRecoverableConfigFileDiagnostic = function(d) {
            return diagnostic = d;
          };
          parsed = ts3.getParsedCommandLineOfConfigFile(configFileName, baseCompilerOptions, parseConfigFileHost, extendedConfigCache, baseWatchOptions);
          parseConfigFileHost.onUnRecoverableConfigFileDiagnostic = ts3.noop;
        }
        configFileCache.set(configFilePath, parsed || diagnostic);
        return parsed;
      }
      function resolveProjectName(state, name) {
        return ts3.resolveConfigFileProjectName(ts3.resolvePath(state.currentDirectory, name));
      }
      function createBuildOrder(state, roots) {
        var temporaryMarks = new ts3.Map();
        var permanentMarks = new ts3.Map();
        var circularityReportStack = [];
        var buildOrder;
        var circularDiagnostics;
        for (var _i = 0, roots_1 = roots; _i < roots_1.length; _i++) {
          var root = roots_1[_i];
          visit(root);
        }
        return circularDiagnostics ? { buildOrder: buildOrder || ts3.emptyArray, circularDiagnostics } : buildOrder || ts3.emptyArray;
        function visit(configFileName, inCircularContext) {
          var projPath = toResolvedConfigFilePath(state, configFileName);
          if (permanentMarks.has(projPath))
            return;
          if (temporaryMarks.has(projPath)) {
            if (!inCircularContext) {
              (circularDiagnostics || (circularDiagnostics = [])).push(ts3.createCompilerDiagnostic(ts3.Diagnostics.Project_references_may_not_form_a_circular_graph_Cycle_detected_Colon_0, circularityReportStack.join("\r\n")));
            }
            return;
          }
          temporaryMarks.set(projPath, true);
          circularityReportStack.push(configFileName);
          var parsed = parseConfigFile(state, configFileName, projPath);
          if (parsed && parsed.projectReferences) {
            for (var _i2 = 0, _a2 = parsed.projectReferences; _i2 < _a2.length; _i2++) {
              var ref2 = _a2[_i2];
              var resolvedRefPath = resolveProjectName(state, ref2.path);
              visit(resolvedRefPath, inCircularContext || ref2.circular);
            }
          }
          circularityReportStack.pop();
          permanentMarks.set(projPath, true);
          (buildOrder || (buildOrder = [])).push(configFileName);
        }
      }
      function getBuildOrder(state) {
        return state.buildOrder || createStateBuildOrder(state);
      }
      function createStateBuildOrder(state) {
        var buildOrder = createBuildOrder(state, state.rootNames.map(function(f) {
          return resolveProjectName(state, f);
        }));
        state.resolvedConfigFilePaths.clear();
        var currentProjects = new ts3.Map(getBuildOrderFromAnyBuildOrder(buildOrder).map(function(resolved) {
          return [toResolvedConfigFilePath(state, resolved), true];
        }));
        var noopOnDelete = { onDeleteValue: ts3.noop };
        ts3.mutateMapSkippingNewValues(state.configFileCache, currentProjects, noopOnDelete);
        ts3.mutateMapSkippingNewValues(state.projectStatus, currentProjects, noopOnDelete);
        ts3.mutateMapSkippingNewValues(state.buildInfoChecked, currentProjects, noopOnDelete);
        ts3.mutateMapSkippingNewValues(state.builderPrograms, currentProjects, noopOnDelete);
        ts3.mutateMapSkippingNewValues(state.diagnostics, currentProjects, noopOnDelete);
        ts3.mutateMapSkippingNewValues(state.projectPendingBuild, currentProjects, noopOnDelete);
        ts3.mutateMapSkippingNewValues(state.projectErrorsReported, currentProjects, noopOnDelete);
        if (state.watch) {
          ts3.mutateMapSkippingNewValues(state.allWatchedConfigFiles, currentProjects, { onDeleteValue: ts3.closeFileWatcher });
          state.allWatchedExtendedConfigFiles.forEach(function(watcher) {
            watcher.projects.forEach(function(project) {
              if (!currentProjects.has(project)) {
                watcher.projects.delete(project);
              }
            });
            watcher.close();
          });
          ts3.mutateMapSkippingNewValues(state.allWatchedWildcardDirectories, currentProjects, { onDeleteValue: function(existingMap) {
            return existingMap.forEach(ts3.closeFileWatcherOf);
          } });
          ts3.mutateMapSkippingNewValues(state.allWatchedInputFiles, currentProjects, { onDeleteValue: function(existingMap) {
            return existingMap.forEach(ts3.closeFileWatcher);
          } });
        }
        return state.buildOrder = buildOrder;
      }
      function getBuildOrderFor(state, project, onlyReferences) {
        var resolvedProject = project && resolveProjectName(state, project);
        var buildOrderFromState = getBuildOrder(state);
        if (isCircularBuildOrder(buildOrderFromState))
          return buildOrderFromState;
        if (resolvedProject) {
          var projectPath_1 = toResolvedConfigFilePath(state, resolvedProject);
          var projectIndex = ts3.findIndex(buildOrderFromState, function(configFileName) {
            return toResolvedConfigFilePath(state, configFileName) === projectPath_1;
          });
          if (projectIndex === -1)
            return void 0;
        }
        var buildOrder = resolvedProject ? createBuildOrder(state, [resolvedProject]) : buildOrderFromState;
        ts3.Debug.assert(!isCircularBuildOrder(buildOrder));
        ts3.Debug.assert(!onlyReferences || resolvedProject !== void 0);
        ts3.Debug.assert(!onlyReferences || buildOrder[buildOrder.length - 1] === resolvedProject);
        return onlyReferences ? buildOrder.slice(0, buildOrder.length - 1) : buildOrder;
      }
      function enableCache(state) {
        if (state.cache) {
          disableCache(state);
        }
        var compilerHost = state.compilerHost, host = state.host;
        var originalReadFileWithCache = state.readFileWithCache;
        var originalGetSourceFile = compilerHost.getSourceFile;
        var _a2 = ts3.changeCompilerHostLikeToUseCache(host, function(fileName) {
          return toPath(state, fileName);
        }, function() {
          var args = [];
          for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
          }
          return originalGetSourceFile.call.apply(originalGetSourceFile, __spreadArray([compilerHost], args));
        }), originalReadFile = _a2.originalReadFile, originalFileExists = _a2.originalFileExists, originalDirectoryExists = _a2.originalDirectoryExists, originalCreateDirectory = _a2.originalCreateDirectory, originalWriteFile = _a2.originalWriteFile, getSourceFileWithCache = _a2.getSourceFileWithCache, readFileWithCache = _a2.readFileWithCache;
        state.readFileWithCache = readFileWithCache;
        compilerHost.getSourceFile = getSourceFileWithCache;
        state.cache = {
          originalReadFile,
          originalFileExists,
          originalDirectoryExists,
          originalCreateDirectory,
          originalWriteFile,
          originalReadFileWithCache,
          originalGetSourceFile
        };
      }
      function disableCache(state) {
        if (!state.cache)
          return;
        var cache = state.cache, host = state.host, compilerHost = state.compilerHost, extendedConfigCache = state.extendedConfigCache, moduleResolutionCache = state.moduleResolutionCache, typeReferenceDirectiveResolutionCache = state.typeReferenceDirectiveResolutionCache;
        host.readFile = cache.originalReadFile;
        host.fileExists = cache.originalFileExists;
        host.directoryExists = cache.originalDirectoryExists;
        host.createDirectory = cache.originalCreateDirectory;
        host.writeFile = cache.originalWriteFile;
        compilerHost.getSourceFile = cache.originalGetSourceFile;
        state.readFileWithCache = cache.originalReadFileWithCache;
        extendedConfigCache.clear();
        moduleResolutionCache === null || moduleResolutionCache === void 0 ? void 0 : moduleResolutionCache.clear();
        typeReferenceDirectiveResolutionCache === null || typeReferenceDirectiveResolutionCache === void 0 ? void 0 : typeReferenceDirectiveResolutionCache.clear();
        state.cache = void 0;
      }
      function clearProjectStatus(state, resolved) {
        state.projectStatus.delete(resolved);
        state.diagnostics.delete(resolved);
      }
      function addProjToQueue(_a2, proj, reloadLevel) {
        var projectPendingBuild = _a2.projectPendingBuild;
        var value = projectPendingBuild.get(proj);
        if (value === void 0) {
          projectPendingBuild.set(proj, reloadLevel);
        } else if (value < reloadLevel) {
          projectPendingBuild.set(proj, reloadLevel);
        }
      }
      function setupInitialBuild(state, cancellationToken) {
        if (!state.allProjectBuildPending)
          return;
        state.allProjectBuildPending = false;
        if (state.options.watch) {
          reportWatchStatus(state, ts3.Diagnostics.Starting_compilation_in_watch_mode);
        }
        enableCache(state);
        var buildOrder = getBuildOrderFromAnyBuildOrder(getBuildOrder(state));
        buildOrder.forEach(function(configFileName) {
          return state.projectPendingBuild.set(toResolvedConfigFilePath(state, configFileName), ts3.ConfigFileProgramReloadLevel.None);
        });
        if (cancellationToken) {
          cancellationToken.throwIfCancellationRequested();
        }
      }
      var InvalidatedProjectKind;
      (function(InvalidatedProjectKind2) {
        InvalidatedProjectKind2[InvalidatedProjectKind2["Build"] = 0] = "Build";
        InvalidatedProjectKind2[InvalidatedProjectKind2["UpdateBundle"] = 1] = "UpdateBundle";
        InvalidatedProjectKind2[InvalidatedProjectKind2["UpdateOutputFileStamps"] = 2] = "UpdateOutputFileStamps";
      })(InvalidatedProjectKind = ts3.InvalidatedProjectKind || (ts3.InvalidatedProjectKind = {}));
      function doneInvalidatedProject(state, projectPath) {
        state.projectPendingBuild.delete(projectPath);
        state.currentInvalidatedProject = void 0;
        return state.diagnostics.has(projectPath) ? ts3.ExitStatus.DiagnosticsPresent_OutputsSkipped : ts3.ExitStatus.Success;
      }
      function createUpdateOutputFileStampsProject(state, project, projectPath, config, buildOrder) {
        var updateOutputFileStampsPending = true;
        return {
          kind: InvalidatedProjectKind.UpdateOutputFileStamps,
          project,
          projectPath,
          buildOrder,
          getCompilerOptions: function() {
            return config.options;
          },
          getCurrentDirectory: function() {
            return state.currentDirectory;
          },
          updateOutputFileStatmps: function() {
            updateOutputTimestamps(state, config, projectPath);
            updateOutputFileStampsPending = false;
          },
          done: function() {
            if (updateOutputFileStampsPending) {
              updateOutputTimestamps(state, config, projectPath);
            }
            return doneInvalidatedProject(state, projectPath);
          }
        };
      }
      var BuildStep;
      (function(BuildStep2) {
        BuildStep2[BuildStep2["CreateProgram"] = 0] = "CreateProgram";
        BuildStep2[BuildStep2["SyntaxDiagnostics"] = 1] = "SyntaxDiagnostics";
        BuildStep2[BuildStep2["SemanticDiagnostics"] = 2] = "SemanticDiagnostics";
        BuildStep2[BuildStep2["Emit"] = 3] = "Emit";
        BuildStep2[BuildStep2["EmitBundle"] = 4] = "EmitBundle";
        BuildStep2[BuildStep2["EmitBuildInfo"] = 5] = "EmitBuildInfo";
        BuildStep2[BuildStep2["BuildInvalidatedProjectOfBundle"] = 6] = "BuildInvalidatedProjectOfBundle";
        BuildStep2[BuildStep2["QueueReferencingProjects"] = 7] = "QueueReferencingProjects";
        BuildStep2[BuildStep2["Done"] = 8] = "Done";
      })(BuildStep || (BuildStep = {}));
      function createBuildOrUpdateInvalidedProject(kind, state, project, projectPath, projectIndex, config, buildOrder) {
        var step = kind === InvalidatedProjectKind.Build ? BuildStep.CreateProgram : BuildStep.EmitBundle;
        var program2;
        var buildResult;
        var invalidatedProjectOfBundle;
        return kind === InvalidatedProjectKind.Build ? {
          kind,
          project,
          projectPath,
          buildOrder,
          getCompilerOptions: function() {
            return config.options;
          },
          getCurrentDirectory: function() {
            return state.currentDirectory;
          },
          getBuilderProgram: function() {
            return withProgramOrUndefined(ts3.identity);
          },
          getProgram: function() {
            return withProgramOrUndefined(function(program3) {
              return program3.getProgramOrUndefined();
            });
          },
          getSourceFile: function(fileName) {
            return withProgramOrUndefined(function(program3) {
              return program3.getSourceFile(fileName);
            });
          },
          getSourceFiles: function() {
            return withProgramOrEmptyArray(function(program3) {
              return program3.getSourceFiles();
            });
          },
          getOptionsDiagnostics: function(cancellationToken) {
            return withProgramOrEmptyArray(function(program3) {
              return program3.getOptionsDiagnostics(cancellationToken);
            });
          },
          getGlobalDiagnostics: function(cancellationToken) {
            return withProgramOrEmptyArray(function(program3) {
              return program3.getGlobalDiagnostics(cancellationToken);
            });
          },
          getConfigFileParsingDiagnostics: function() {
            return withProgramOrEmptyArray(function(program3) {
              return program3.getConfigFileParsingDiagnostics();
            });
          },
          getSyntacticDiagnostics: function(sourceFile, cancellationToken) {
            return withProgramOrEmptyArray(function(program3) {
              return program3.getSyntacticDiagnostics(sourceFile, cancellationToken);
            });
          },
          getAllDependencies: function(sourceFile) {
            return withProgramOrEmptyArray(function(program3) {
              return program3.getAllDependencies(sourceFile);
            });
          },
          getSemanticDiagnostics: function(sourceFile, cancellationToken) {
            return withProgramOrEmptyArray(function(program3) {
              return program3.getSemanticDiagnostics(sourceFile, cancellationToken);
            });
          },
          getSemanticDiagnosticsOfNextAffectedFile: function(cancellationToken, ignoreSourceFile) {
            return withProgramOrUndefined(function(program3) {
              return program3.getSemanticDiagnosticsOfNextAffectedFile && program3.getSemanticDiagnosticsOfNextAffectedFile(cancellationToken, ignoreSourceFile);
            });
          },
          emit: function(targetSourceFile, writeFile, cancellationToken, emitOnlyDtsFiles, customTransformers) {
            if (targetSourceFile || emitOnlyDtsFiles) {
              return withProgramOrUndefined(function(program3) {
                var _a2, _b;
                return program3.emit(targetSourceFile, writeFile, cancellationToken, emitOnlyDtsFiles, customTransformers || ((_b = (_a2 = state.host).getCustomTransformers) === null || _b === void 0 ? void 0 : _b.call(_a2, project)));
              });
            }
            executeSteps(BuildStep.SemanticDiagnostics, cancellationToken);
            if (step === BuildStep.EmitBuildInfo) {
              return emitBuildInfo(writeFile, cancellationToken);
            }
            if (step !== BuildStep.Emit)
              return void 0;
            return emit(writeFile, cancellationToken, customTransformers);
          },
          done
        } : {
          kind,
          project,
          projectPath,
          buildOrder,
          getCompilerOptions: function() {
            return config.options;
          },
          getCurrentDirectory: function() {
            return state.currentDirectory;
          },
          emit: function(writeFile, customTransformers) {
            if (step !== BuildStep.EmitBundle)
              return invalidatedProjectOfBundle;
            return emitBundle(writeFile, customTransformers);
          },
          done
        };
        function done(cancellationToken, writeFile, customTransformers) {
          executeSteps(BuildStep.Done, cancellationToken, writeFile, customTransformers);
          return doneInvalidatedProject(state, projectPath);
        }
        function withProgramOrUndefined(action) {
          executeSteps(BuildStep.CreateProgram);
          return program2 && action(program2);
        }
        function withProgramOrEmptyArray(action) {
          return withProgramOrUndefined(action) || ts3.emptyArray;
        }
        function createProgram() {
          var _a2, _b;
          ts3.Debug.assert(program2 === void 0);
          if (state.options.dry) {
            reportStatus(state, ts3.Diagnostics.A_non_dry_build_would_build_project_0, project);
            buildResult = BuildResultFlags.Success;
            step = BuildStep.QueueReferencingProjects;
            return;
          }
          if (state.options.verbose)
            reportStatus(state, ts3.Diagnostics.Building_project_0, project);
          if (config.fileNames.length === 0) {
            reportAndStoreErrors(state, projectPath, ts3.getConfigFileParsingDiagnostics(config));
            buildResult = BuildResultFlags.None;
            step = BuildStep.QueueReferencingProjects;
            return;
          }
          var host = state.host, compilerHost = state.compilerHost;
          state.projectCompilerOptions = config.options;
          (_a2 = state.moduleResolutionCache) === null || _a2 === void 0 ? void 0 : _a2.update(config.options);
          (_b = state.typeReferenceDirectiveResolutionCache) === null || _b === void 0 ? void 0 : _b.update(config.options);
          program2 = host.createProgram(config.fileNames, config.options, compilerHost, getOldProgram(state, projectPath, config), ts3.getConfigFileParsingDiagnostics(config), config.projectReferences);
          if (state.watch) {
            state.builderPrograms.set(projectPath, program2);
          }
          step++;
        }
        function handleDiagnostics(diagnostics, errorFlags, errorType) {
          var _a2;
          if (diagnostics.length) {
            _a2 = buildErrors(state, projectPath, program2, config, diagnostics, errorFlags, errorType), buildResult = _a2.buildResult, step = _a2.step;
          } else {
            step++;
          }
        }
        function getSyntaxDiagnostics(cancellationToken) {
          ts3.Debug.assertIsDefined(program2);
          handleDiagnostics(__spreadArray(__spreadArray(__spreadArray(__spreadArray([], program2.getConfigFileParsingDiagnostics()), program2.getOptionsDiagnostics(cancellationToken)), program2.getGlobalDiagnostics(cancellationToken)), program2.getSyntacticDiagnostics(void 0, cancellationToken)), BuildResultFlags.SyntaxErrors, "Syntactic");
        }
        function getSemanticDiagnostics(cancellationToken) {
          handleDiagnostics(ts3.Debug.checkDefined(program2).getSemanticDiagnostics(void 0, cancellationToken), BuildResultFlags.TypeErrors, "Semantic");
        }
        function emit(writeFileCallback, cancellationToken, customTransformers) {
          var _a2;
          var _b, _c;
          ts3.Debug.assertIsDefined(program2);
          ts3.Debug.assert(step === BuildStep.Emit);
          program2.backupState();
          var declDiagnostics;
          var reportDeclarationDiagnostics = function(d) {
            return (declDiagnostics || (declDiagnostics = [])).push(d);
          };
          var outputFiles = [];
          var emitResult = ts3.emitFilesAndReportErrors(program2, reportDeclarationDiagnostics, void 0, void 0, function(name, text, writeByteOrderMark) {
            return outputFiles.push({ name, text, writeByteOrderMark });
          }, cancellationToken, false, customTransformers || ((_c = (_b = state.host).getCustomTransformers) === null || _c === void 0 ? void 0 : _c.call(_b, project))).emitResult;
          if (declDiagnostics) {
            program2.restoreState();
            _a2 = buildErrors(state, projectPath, program2, config, declDiagnostics, BuildResultFlags.DeclarationEmitErrors, "Declaration file"), buildResult = _a2.buildResult, step = _a2.step;
            return {
              emitSkipped: true,
              diagnostics: emitResult.diagnostics
            };
          }
          var host = state.host, compilerHost = state.compilerHost;
          var resultFlags = BuildResultFlags.DeclarationOutputUnchanged;
          var newestDeclarationFileContentChangedTime = minimumDate;
          var anyDtsChanged = false;
          var emitterDiagnostics = ts3.createDiagnosticCollection();
          var emittedOutputs = new ts3.Map();
          outputFiles.forEach(function(_a3) {
            var name = _a3.name, text = _a3.text, writeByteOrderMark = _a3.writeByteOrderMark;
            var priorChangeTime;
            if (!anyDtsChanged && isDeclarationFile(name)) {
              if (host.fileExists(name) && state.readFileWithCache(name) === text) {
                priorChangeTime = host.getModifiedTime(name);
              } else {
                resultFlags &= ~BuildResultFlags.DeclarationOutputUnchanged;
                anyDtsChanged = true;
              }
            }
            emittedOutputs.set(toPath(state, name), name);
            ts3.writeFile(writeFileCallback ? { writeFile: writeFileCallback } : compilerHost, emitterDiagnostics, name, text, writeByteOrderMark);
            if (priorChangeTime !== void 0) {
              newestDeclarationFileContentChangedTime = newer(priorChangeTime, newestDeclarationFileContentChangedTime);
            }
          });
          finishEmit(emitterDiagnostics, emittedOutputs, newestDeclarationFileContentChangedTime, anyDtsChanged, outputFiles.length ? outputFiles[0].name : ts3.getFirstProjectOutput(config, !host.useCaseSensitiveFileNames()), resultFlags);
          return emitResult;
        }
        function emitBuildInfo(writeFileCallback, cancellationToken) {
          ts3.Debug.assertIsDefined(program2);
          ts3.Debug.assert(step === BuildStep.EmitBuildInfo);
          var emitResult = program2.emitBuildInfo(writeFileCallback, cancellationToken);
          if (emitResult.diagnostics.length) {
            reportErrors(state, emitResult.diagnostics);
            state.diagnostics.set(projectPath, __spreadArray(__spreadArray([], state.diagnostics.get(projectPath)), emitResult.diagnostics));
            buildResult = BuildResultFlags.EmitErrors & buildResult;
          }
          if (emitResult.emittedFiles && state.write) {
            emitResult.emittedFiles.forEach(function(name) {
              return listEmittedFile(state, config, name);
            });
          }
          afterProgramDone(state, program2, config);
          step = BuildStep.QueueReferencingProjects;
          return emitResult;
        }
        function finishEmit(emitterDiagnostics, emittedOutputs, priorNewestUpdateTime, newestDeclarationFileContentChangedTimeIsMaximumDate, oldestOutputFileName, resultFlags) {
          var _a2;
          var emitDiagnostics = emitterDiagnostics.getDiagnostics();
          if (emitDiagnostics.length) {
            _a2 = buildErrors(state, projectPath, program2, config, emitDiagnostics, BuildResultFlags.EmitErrors, "Emit"), buildResult = _a2.buildResult, step = _a2.step;
            return emitDiagnostics;
          }
          if (state.write) {
            emittedOutputs.forEach(function(name) {
              return listEmittedFile(state, config, name);
            });
          }
          var newestDeclarationFileContentChangedTime = updateOutputTimestampsWorker(state, config, priorNewestUpdateTime, ts3.Diagnostics.Updating_unchanged_output_timestamps_of_project_0, emittedOutputs);
          state.diagnostics.delete(projectPath);
          state.projectStatus.set(projectPath, {
            type: ts3.UpToDateStatusType.UpToDate,
            newestDeclarationFileContentChangedTime: newestDeclarationFileContentChangedTimeIsMaximumDate ? maximumDate : newestDeclarationFileContentChangedTime,
            oldestOutputFileName
          });
          afterProgramDone(state, program2, config);
          step = BuildStep.QueueReferencingProjects;
          buildResult = resultFlags;
          return emitDiagnostics;
        }
        function emitBundle(writeFileCallback, customTransformers) {
          var _a2, _b;
          ts3.Debug.assert(kind === InvalidatedProjectKind.UpdateBundle);
          if (state.options.dry) {
            reportStatus(state, ts3.Diagnostics.A_non_dry_build_would_update_output_of_project_0, project);
            buildResult = BuildResultFlags.Success;
            step = BuildStep.QueueReferencingProjects;
            return void 0;
          }
          if (state.options.verbose)
            reportStatus(state, ts3.Diagnostics.Updating_output_of_project_0, project);
          var compilerHost = state.compilerHost;
          state.projectCompilerOptions = config.options;
          var outputFiles = ts3.emitUsingBuildInfo(config, compilerHost, function(ref2) {
            var refName = resolveProjectName(state, ref2.path);
            return parseConfigFile(state, refName, toResolvedConfigFilePath(state, refName));
          }, customTransformers || ((_b = (_a2 = state.host).getCustomTransformers) === null || _b === void 0 ? void 0 : _b.call(_a2, project)));
          if (ts3.isString(outputFiles)) {
            reportStatus(state, ts3.Diagnostics.Cannot_update_output_of_project_0_because_there_was_error_reading_file_1, project, relName(state, outputFiles));
            step = BuildStep.BuildInvalidatedProjectOfBundle;
            return invalidatedProjectOfBundle = createBuildOrUpdateInvalidedProject(InvalidatedProjectKind.Build, state, project, projectPath, projectIndex, config, buildOrder);
          }
          ts3.Debug.assert(!!outputFiles.length);
          var emitterDiagnostics = ts3.createDiagnosticCollection();
          var emittedOutputs = new ts3.Map();
          outputFiles.forEach(function(_a3) {
            var name = _a3.name, text = _a3.text, writeByteOrderMark = _a3.writeByteOrderMark;
            emittedOutputs.set(toPath(state, name), name);
            ts3.writeFile(writeFileCallback ? { writeFile: writeFileCallback } : compilerHost, emitterDiagnostics, name, text, writeByteOrderMark);
          });
          var emitDiagnostics = finishEmit(emitterDiagnostics, emittedOutputs, minimumDate, false, outputFiles[0].name, BuildResultFlags.DeclarationOutputUnchanged);
          return { emitSkipped: false, diagnostics: emitDiagnostics };
        }
        function executeSteps(till, cancellationToken, writeFile, customTransformers) {
          while (step <= till && step < BuildStep.Done) {
            var currentStep = step;
            switch (step) {
              case BuildStep.CreateProgram:
                createProgram();
                break;
              case BuildStep.SyntaxDiagnostics:
                getSyntaxDiagnostics(cancellationToken);
                break;
              case BuildStep.SemanticDiagnostics:
                getSemanticDiagnostics(cancellationToken);
                break;
              case BuildStep.Emit:
                emit(writeFile, cancellationToken, customTransformers);
                break;
              case BuildStep.EmitBuildInfo:
                emitBuildInfo(writeFile, cancellationToken);
                break;
              case BuildStep.EmitBundle:
                emitBundle(writeFile, customTransformers);
                break;
              case BuildStep.BuildInvalidatedProjectOfBundle:
                ts3.Debug.checkDefined(invalidatedProjectOfBundle).done(cancellationToken, writeFile, customTransformers);
                step = BuildStep.Done;
                break;
              case BuildStep.QueueReferencingProjects:
                queueReferencingProjects(state, project, projectPath, projectIndex, config, buildOrder, ts3.Debug.checkDefined(buildResult));
                step++;
                break;
              case BuildStep.Done:
              default:
                ts3.assertType(step);
            }
            ts3.Debug.assert(step > currentStep);
          }
        }
      }
      function needsBuild(_a2, status, config) {
        var options = _a2.options;
        if (status.type !== ts3.UpToDateStatusType.OutOfDateWithPrepend || options.force)
          return true;
        return config.fileNames.length === 0 || !!ts3.getConfigFileParsingDiagnostics(config).length || !ts3.isIncrementalCompilation(config.options);
      }
      function getNextInvalidatedProject(state, buildOrder, reportQueue) {
        if (!state.projectPendingBuild.size)
          return void 0;
        if (isCircularBuildOrder(buildOrder))
          return void 0;
        if (state.currentInvalidatedProject) {
          return ts3.arrayIsEqualTo(state.currentInvalidatedProject.buildOrder, buildOrder) ? state.currentInvalidatedProject : void 0;
        }
        var options = state.options, projectPendingBuild = state.projectPendingBuild;
        for (var projectIndex = 0; projectIndex < buildOrder.length; projectIndex++) {
          var project = buildOrder[projectIndex];
          var projectPath = toResolvedConfigFilePath(state, project);
          var reloadLevel = state.projectPendingBuild.get(projectPath);
          if (reloadLevel === void 0)
            continue;
          if (reportQueue) {
            reportQueue = false;
            reportBuildQueue(state, buildOrder);
          }
          var config = parseConfigFile(state, project, projectPath);
          if (!config) {
            reportParseConfigFileDiagnostic(state, projectPath);
            projectPendingBuild.delete(projectPath);
            continue;
          }
          if (reloadLevel === ts3.ConfigFileProgramReloadLevel.Full) {
            watchConfigFile(state, project, projectPath, config);
            watchExtendedConfigFiles(state, projectPath, config);
            watchWildCardDirectories(state, project, projectPath, config);
            watchInputFiles(state, project, projectPath, config);
          } else if (reloadLevel === ts3.ConfigFileProgramReloadLevel.Partial) {
            config.fileNames = ts3.getFileNamesFromConfigSpecs(config.options.configFile.configFileSpecs, ts3.getDirectoryPath(project), config.options, state.parseConfigFileHost);
            ts3.updateErrorForNoInputFiles(config.fileNames, project, config.options.configFile.configFileSpecs, config.errors, ts3.canJsonReportNoInputFiles(config.raw));
            watchInputFiles(state, project, projectPath, config);
          }
          var status = getUpToDateStatus(state, config, projectPath);
          verboseReportProjectStatus(state, project, status);
          if (!options.force) {
            if (status.type === ts3.UpToDateStatusType.UpToDate) {
              reportAndStoreErrors(state, projectPath, ts3.getConfigFileParsingDiagnostics(config));
              projectPendingBuild.delete(projectPath);
              if (options.dry) {
                reportStatus(state, ts3.Diagnostics.Project_0_is_up_to_date, project);
              }
              continue;
            }
            if (status.type === ts3.UpToDateStatusType.UpToDateWithUpstreamTypes) {
              reportAndStoreErrors(state, projectPath, ts3.getConfigFileParsingDiagnostics(config));
              return createUpdateOutputFileStampsProject(state, project, projectPath, config, buildOrder);
            }
          }
          if (status.type === ts3.UpToDateStatusType.UpstreamBlocked) {
            reportAndStoreErrors(state, projectPath, ts3.getConfigFileParsingDiagnostics(config));
            projectPendingBuild.delete(projectPath);
            if (options.verbose) {
              reportStatus(state, status.upstreamProjectBlocked ? ts3.Diagnostics.Skipping_build_of_project_0_because_its_dependency_1_was_not_built : ts3.Diagnostics.Skipping_build_of_project_0_because_its_dependency_1_has_errors, project, status.upstreamProjectName);
            }
            continue;
          }
          if (status.type === ts3.UpToDateStatusType.ContainerOnly) {
            reportAndStoreErrors(state, projectPath, ts3.getConfigFileParsingDiagnostics(config));
            projectPendingBuild.delete(projectPath);
            continue;
          }
          return createBuildOrUpdateInvalidedProject(needsBuild(state, status, config) ? InvalidatedProjectKind.Build : InvalidatedProjectKind.UpdateBundle, state, project, projectPath, projectIndex, config, buildOrder);
        }
        return void 0;
      }
      function listEmittedFile(_a2, proj, file) {
        var write = _a2.write;
        if (write && proj.options.listEmittedFiles) {
          write("TSFILE: " + file);
        }
      }
      function getOldProgram(_a2, proj, parsed) {
        var options = _a2.options, builderPrograms = _a2.builderPrograms, compilerHost = _a2.compilerHost;
        if (options.force)
          return void 0;
        var value = builderPrograms.get(proj);
        if (value)
          return value;
        return ts3.readBuilderProgram(parsed.options, compilerHost);
      }
      function afterProgramDone(state, program2, config) {
        if (program2) {
          if (program2 && state.write)
            ts3.listFiles(program2, state.write);
          if (state.host.afterProgramEmitAndDiagnostics) {
            state.host.afterProgramEmitAndDiagnostics(program2);
          }
          program2.releaseProgram();
        } else if (state.host.afterEmitBundle) {
          state.host.afterEmitBundle(config);
        }
        state.projectCompilerOptions = state.baseCompilerOptions;
      }
      function buildErrors(state, resolvedPath, program2, config, diagnostics, buildResult, errorType) {
        var canEmitBuildInfo = !(buildResult & BuildResultFlags.SyntaxErrors) && program2 && !ts3.outFile(program2.getCompilerOptions());
        reportAndStoreErrors(state, resolvedPath, diagnostics);
        state.projectStatus.set(resolvedPath, { type: ts3.UpToDateStatusType.Unbuildable, reason: errorType + " errors" });
        if (canEmitBuildInfo)
          return { buildResult, step: BuildStep.EmitBuildInfo };
        afterProgramDone(state, program2, config);
        return { buildResult, step: BuildStep.QueueReferencingProjects };
      }
      function checkConfigFileUpToDateStatus(state, configFile, oldestOutputFileTime, oldestOutputFileName) {
        var tsconfigTime = ts3.getModifiedTime(state.host, configFile);
        if (oldestOutputFileTime < tsconfigTime) {
          return {
            type: ts3.UpToDateStatusType.OutOfDateWithSelf,
            outOfDateOutputFileName: oldestOutputFileName,
            newerInputFileName: configFile
          };
        }
      }
      function getUpToDateStatusWorker(state, project, resolvedPath) {
        var force = !!state.options.force;
        var newestInputFileName = void 0;
        var newestInputFileTime = minimumDate;
        var host = state.host;
        for (var _i = 0, _a2 = project.fileNames; _i < _a2.length; _i++) {
          var inputFile = _a2[_i];
          if (!host.fileExists(inputFile)) {
            return {
              type: ts3.UpToDateStatusType.Unbuildable,
              reason: inputFile + " does not exist"
            };
          }
          if (!force) {
            var inputTime = ts3.getModifiedTime(host, inputFile);
            host.getModifiedTime(inputFile);
            if (inputTime > newestInputFileTime) {
              newestInputFileName = inputFile;
              newestInputFileTime = inputTime;
            }
          }
        }
        if (!project.fileNames.length && !ts3.canJsonReportNoInputFiles(project.raw)) {
          return {
            type: ts3.UpToDateStatusType.ContainerOnly
          };
        }
        var outputs = ts3.getAllProjectOutputs(project, !host.useCaseSensitiveFileNames());
        var oldestOutputFileName = "(none)";
        var oldestOutputFileTime = maximumDate;
        var newestOutputFileName = "(none)";
        var newestOutputFileTime = minimumDate;
        var missingOutputFileName;
        var newestDeclarationFileContentChangedTime = minimumDate;
        var isOutOfDateWithInputs = false;
        if (!force) {
          for (var _b = 0, outputs_1 = outputs; _b < outputs_1.length; _b++) {
            var output = outputs_1[_b];
            if (!host.fileExists(output)) {
              missingOutputFileName = output;
              break;
            }
            var outputTime = ts3.getModifiedTime(host, output);
            if (outputTime < oldestOutputFileTime) {
              oldestOutputFileTime = outputTime;
              oldestOutputFileName = output;
            }
            if (outputTime < newestInputFileTime) {
              isOutOfDateWithInputs = true;
              break;
            }
            if (outputTime > newestOutputFileTime) {
              newestOutputFileTime = outputTime;
              newestOutputFileName = output;
            }
            if (isDeclarationFile(output)) {
              var outputModifiedTime = ts3.getModifiedTime(host, output);
              newestDeclarationFileContentChangedTime = newer(newestDeclarationFileContentChangedTime, outputModifiedTime);
            }
          }
        }
        var pseudoUpToDate = false;
        var usesPrepend = false;
        var upstreamChangedProject;
        if (project.projectReferences) {
          state.projectStatus.set(resolvedPath, { type: ts3.UpToDateStatusType.ComputingUpstream });
          for (var _c = 0, _d = project.projectReferences; _c < _d.length; _c++) {
            var ref2 = _d[_c];
            usesPrepend = usesPrepend || !!ref2.prepend;
            var resolvedRef = ts3.resolveProjectReferencePath(ref2);
            var resolvedRefPath = toResolvedConfigFilePath(state, resolvedRef);
            var refStatus = getUpToDateStatus(state, parseConfigFile(state, resolvedRef, resolvedRefPath), resolvedRefPath);
            if (refStatus.type === ts3.UpToDateStatusType.ComputingUpstream || refStatus.type === ts3.UpToDateStatusType.ContainerOnly) {
              continue;
            }
            if (refStatus.type === ts3.UpToDateStatusType.Unbuildable || refStatus.type === ts3.UpToDateStatusType.UpstreamBlocked) {
              return {
                type: ts3.UpToDateStatusType.UpstreamBlocked,
                upstreamProjectName: ref2.path,
                upstreamProjectBlocked: refStatus.type === ts3.UpToDateStatusType.UpstreamBlocked
              };
            }
            if (refStatus.type !== ts3.UpToDateStatusType.UpToDate) {
              return {
                type: ts3.UpToDateStatusType.UpstreamOutOfDate,
                upstreamProjectName: ref2.path
              };
            }
            if (!force && !missingOutputFileName) {
              if (refStatus.newestInputFileTime && refStatus.newestInputFileTime <= oldestOutputFileTime) {
                continue;
              }
              if (refStatus.newestDeclarationFileContentChangedTime && refStatus.newestDeclarationFileContentChangedTime <= oldestOutputFileTime) {
                pseudoUpToDate = true;
                upstreamChangedProject = ref2.path;
                continue;
              }
              ts3.Debug.assert(oldestOutputFileName !== void 0, "Should have an oldest output filename here");
              return {
                type: ts3.UpToDateStatusType.OutOfDateWithUpstream,
                outOfDateOutputFileName: oldestOutputFileName,
                newerProjectName: ref2.path
              };
            }
          }
        }
        if (missingOutputFileName !== void 0) {
          return {
            type: ts3.UpToDateStatusType.OutputMissing,
            missingOutputFileName
          };
        }
        if (isOutOfDateWithInputs) {
          return {
            type: ts3.UpToDateStatusType.OutOfDateWithSelf,
            outOfDateOutputFileName: oldestOutputFileName,
            newerInputFileName: newestInputFileName
          };
        } else {
          var configStatus = checkConfigFileUpToDateStatus(state, project.options.configFilePath, oldestOutputFileTime, oldestOutputFileName);
          if (configStatus)
            return configStatus;
          var extendedConfigStatus = ts3.forEach(project.options.configFile.extendedSourceFiles || ts3.emptyArray, function(configFile) {
            return checkConfigFileUpToDateStatus(state, configFile, oldestOutputFileTime, oldestOutputFileName);
          });
          if (extendedConfigStatus)
            return extendedConfigStatus;
        }
        if (!force && !state.buildInfoChecked.has(resolvedPath)) {
          state.buildInfoChecked.set(resolvedPath, true);
          var buildInfoPath = ts3.getTsBuildInfoEmitOutputFilePath(project.options);
          if (buildInfoPath) {
            var value = state.readFileWithCache(buildInfoPath);
            var buildInfo = value && ts3.getBuildInfo(value);
            if (buildInfo && (buildInfo.bundle || buildInfo.program) && buildInfo.version !== ts3.version) {
              return {
                type: ts3.UpToDateStatusType.TsVersionOutputOfDate,
                version: buildInfo.version
              };
            }
          }
        }
        if (usesPrepend && pseudoUpToDate) {
          return {
            type: ts3.UpToDateStatusType.OutOfDateWithPrepend,
            outOfDateOutputFileName: oldestOutputFileName,
            newerProjectName: upstreamChangedProject
          };
        }
        return {
          type: pseudoUpToDate ? ts3.UpToDateStatusType.UpToDateWithUpstreamTypes : ts3.UpToDateStatusType.UpToDate,
          newestDeclarationFileContentChangedTime,
          newestInputFileTime,
          newestOutputFileTime,
          newestInputFileName,
          newestOutputFileName,
          oldestOutputFileName
        };
      }
      function getUpToDateStatus(state, project, resolvedPath) {
        if (project === void 0) {
          return { type: ts3.UpToDateStatusType.Unbuildable, reason: "File deleted mid-build" };
        }
        var prior = state.projectStatus.get(resolvedPath);
        if (prior !== void 0) {
          return prior;
        }
        var actual = getUpToDateStatusWorker(state, project, resolvedPath);
        state.projectStatus.set(resolvedPath, actual);
        return actual;
      }
      function updateOutputTimestampsWorker(state, proj, priorNewestUpdateTime, verboseMessage, skipOutputs) {
        var host = state.host;
        var outputs = ts3.getAllProjectOutputs(proj, !host.useCaseSensitiveFileNames());
        if (!skipOutputs || outputs.length !== skipOutputs.size) {
          var reportVerbose = !!state.options.verbose;
          var now = host.now ? host.now() : new Date();
          for (var _i = 0, outputs_2 = outputs; _i < outputs_2.length; _i++) {
            var file = outputs_2[_i];
            if (skipOutputs && skipOutputs.has(toPath(state, file))) {
              continue;
            }
            if (reportVerbose) {
              reportVerbose = false;
              reportStatus(state, verboseMessage, proj.options.configFilePath);
            }
            if (isDeclarationFile(file)) {
              priorNewestUpdateTime = newer(priorNewestUpdateTime, ts3.getModifiedTime(host, file));
            }
            host.setModifiedTime(file, now);
          }
        }
        return priorNewestUpdateTime;
      }
      function updateOutputTimestamps(state, proj, resolvedPath) {
        if (state.options.dry) {
          return reportStatus(state, ts3.Diagnostics.A_non_dry_build_would_update_timestamps_for_output_of_project_0, proj.options.configFilePath);
        }
        var priorNewestUpdateTime = updateOutputTimestampsWorker(state, proj, minimumDate, ts3.Diagnostics.Updating_output_timestamps_of_project_0);
        state.projectStatus.set(resolvedPath, {
          type: ts3.UpToDateStatusType.UpToDate,
          newestDeclarationFileContentChangedTime: priorNewestUpdateTime,
          oldestOutputFileName: ts3.getFirstProjectOutput(proj, !state.host.useCaseSensitiveFileNames())
        });
      }
      function queueReferencingProjects(state, project, projectPath, projectIndex, config, buildOrder, buildResult) {
        if (buildResult & BuildResultFlags.AnyErrors)
          return;
        if (!config.options.composite)
          return;
        for (var index = projectIndex + 1; index < buildOrder.length; index++) {
          var nextProject = buildOrder[index];
          var nextProjectPath = toResolvedConfigFilePath(state, nextProject);
          if (state.projectPendingBuild.has(nextProjectPath))
            continue;
          var nextProjectConfig = parseConfigFile(state, nextProject, nextProjectPath);
          if (!nextProjectConfig || !nextProjectConfig.projectReferences)
            continue;
          for (var _i = 0, _a2 = nextProjectConfig.projectReferences; _i < _a2.length; _i++) {
            var ref2 = _a2[_i];
            var resolvedRefPath = resolveProjectName(state, ref2.path);
            if (toResolvedConfigFilePath(state, resolvedRefPath) !== projectPath)
              continue;
            var status = state.projectStatus.get(nextProjectPath);
            if (status) {
              switch (status.type) {
                case ts3.UpToDateStatusType.UpToDate:
                  if (buildResult & BuildResultFlags.DeclarationOutputUnchanged) {
                    if (ref2.prepend) {
                      state.projectStatus.set(nextProjectPath, {
                        type: ts3.UpToDateStatusType.OutOfDateWithPrepend,
                        outOfDateOutputFileName: status.oldestOutputFileName,
                        newerProjectName: project
                      });
                    } else {
                      status.type = ts3.UpToDateStatusType.UpToDateWithUpstreamTypes;
                    }
                    break;
                  }
                case ts3.UpToDateStatusType.UpToDateWithUpstreamTypes:
                case ts3.UpToDateStatusType.OutOfDateWithPrepend:
                  if (!(buildResult & BuildResultFlags.DeclarationOutputUnchanged)) {
                    state.projectStatus.set(nextProjectPath, {
                      type: ts3.UpToDateStatusType.OutOfDateWithUpstream,
                      outOfDateOutputFileName: status.type === ts3.UpToDateStatusType.OutOfDateWithPrepend ? status.outOfDateOutputFileName : status.oldestOutputFileName,
                      newerProjectName: project
                    });
                  }
                  break;
                case ts3.UpToDateStatusType.UpstreamBlocked:
                  if (toResolvedConfigFilePath(state, resolveProjectName(state, status.upstreamProjectName)) === projectPath) {
                    clearProjectStatus(state, nextProjectPath);
                  }
                  break;
              }
            }
            addProjToQueue(state, nextProjectPath, ts3.ConfigFileProgramReloadLevel.None);
            break;
          }
        }
      }
      function build(state, project, cancellationToken, writeFile, getCustomTransformers, onlyReferences) {
        var buildOrder = getBuildOrderFor(state, project, onlyReferences);
        if (!buildOrder)
          return ts3.ExitStatus.InvalidProject_OutputsSkipped;
        setupInitialBuild(state, cancellationToken);
        var reportQueue = true;
        var successfulProjects = 0;
        while (true) {
          var invalidatedProject = getNextInvalidatedProject(state, buildOrder, reportQueue);
          if (!invalidatedProject)
            break;
          reportQueue = false;
          invalidatedProject.done(cancellationToken, writeFile, getCustomTransformers === null || getCustomTransformers === void 0 ? void 0 : getCustomTransformers(invalidatedProject.project));
          if (!state.diagnostics.has(invalidatedProject.projectPath))
            successfulProjects++;
        }
        disableCache(state);
        reportErrorSummary(state, buildOrder);
        startWatching(state, buildOrder);
        return isCircularBuildOrder(buildOrder) ? ts3.ExitStatus.ProjectReferenceCycle_OutputsSkipped : !buildOrder.some(function(p) {
          return state.diagnostics.has(toResolvedConfigFilePath(state, p));
        }) ? ts3.ExitStatus.Success : successfulProjects ? ts3.ExitStatus.DiagnosticsPresent_OutputsGenerated : ts3.ExitStatus.DiagnosticsPresent_OutputsSkipped;
      }
      function clean(state, project, onlyReferences) {
        var buildOrder = getBuildOrderFor(state, project, onlyReferences);
        if (!buildOrder)
          return ts3.ExitStatus.InvalidProject_OutputsSkipped;
        if (isCircularBuildOrder(buildOrder)) {
          reportErrors(state, buildOrder.circularDiagnostics);
          return ts3.ExitStatus.ProjectReferenceCycle_OutputsSkipped;
        }
        var options = state.options, host = state.host;
        var filesToDelete = options.dry ? [] : void 0;
        for (var _i = 0, buildOrder_1 = buildOrder; _i < buildOrder_1.length; _i++) {
          var proj = buildOrder_1[_i];
          var resolvedPath = toResolvedConfigFilePath(state, proj);
          var parsed = parseConfigFile(state, proj, resolvedPath);
          if (parsed === void 0) {
            reportParseConfigFileDiagnostic(state, resolvedPath);
            continue;
          }
          var outputs = ts3.getAllProjectOutputs(parsed, !host.useCaseSensitiveFileNames());
          if (!outputs.length)
            continue;
          var inputFileNames = new ts3.Set(parsed.fileNames.map(function(f) {
            return toPath(state, f);
          }));
          for (var _a2 = 0, outputs_3 = outputs; _a2 < outputs_3.length; _a2++) {
            var output = outputs_3[_a2];
            if (inputFileNames.has(toPath(state, output)))
              continue;
            if (host.fileExists(output)) {
              if (filesToDelete) {
                filesToDelete.push(output);
              } else {
                host.deleteFile(output);
                invalidateProject(state, resolvedPath, ts3.ConfigFileProgramReloadLevel.None);
              }
            }
          }
        }
        if (filesToDelete) {
          reportStatus(state, ts3.Diagnostics.A_non_dry_build_would_delete_the_following_files_Colon_0, filesToDelete.map(function(f) {
            return "\r\n * " + f;
          }).join(""));
        }
        return ts3.ExitStatus.Success;
      }
      function invalidateProject(state, resolved, reloadLevel) {
        if (state.host.getParsedCommandLine && reloadLevel === ts3.ConfigFileProgramReloadLevel.Partial) {
          reloadLevel = ts3.ConfigFileProgramReloadLevel.Full;
        }
        if (reloadLevel === ts3.ConfigFileProgramReloadLevel.Full) {
          state.configFileCache.delete(resolved);
          state.buildOrder = void 0;
        }
        state.needsSummary = true;
        clearProjectStatus(state, resolved);
        addProjToQueue(state, resolved, reloadLevel);
        enableCache(state);
      }
      function invalidateProjectAndScheduleBuilds(state, resolvedPath, reloadLevel) {
        state.reportFileChangeDetected = true;
        invalidateProject(state, resolvedPath, reloadLevel);
        scheduleBuildInvalidatedProject(state);
      }
      function scheduleBuildInvalidatedProject(state) {
        var hostWithWatch = state.hostWithWatch;
        if (!hostWithWatch.setTimeout || !hostWithWatch.clearTimeout) {
          return;
        }
        if (state.timerToBuildInvalidatedProject) {
          hostWithWatch.clearTimeout(state.timerToBuildInvalidatedProject);
        }
        state.timerToBuildInvalidatedProject = hostWithWatch.setTimeout(buildNextInvalidatedProject, 250, state);
      }
      function buildNextInvalidatedProject(state) {
        state.timerToBuildInvalidatedProject = void 0;
        if (state.reportFileChangeDetected) {
          state.reportFileChangeDetected = false;
          state.projectErrorsReported.clear();
          reportWatchStatus(state, ts3.Diagnostics.File_change_detected_Starting_incremental_compilation);
        }
        var buildOrder = getBuildOrder(state);
        var invalidatedProject = getNextInvalidatedProject(state, buildOrder, false);
        if (invalidatedProject) {
          invalidatedProject.done();
          if (state.projectPendingBuild.size) {
            if (state.watch && !state.timerToBuildInvalidatedProject) {
              scheduleBuildInvalidatedProject(state);
            }
            return;
          }
        }
        disableCache(state);
        reportErrorSummary(state, buildOrder);
      }
      function watchConfigFile(state, resolved, resolvedPath, parsed) {
        if (!state.watch || state.allWatchedConfigFiles.has(resolvedPath))
          return;
        state.allWatchedConfigFiles.set(resolvedPath, state.watchFile(resolved, function() {
          invalidateProjectAndScheduleBuilds(state, resolvedPath, ts3.ConfigFileProgramReloadLevel.Full);
        }, ts3.PollingInterval.High, parsed === null || parsed === void 0 ? void 0 : parsed.watchOptions, ts3.WatchType.ConfigFile, resolved));
      }
      function watchExtendedConfigFiles(state, resolvedPath, parsed) {
        ts3.updateSharedExtendedConfigFileWatcher(resolvedPath, parsed === null || parsed === void 0 ? void 0 : parsed.options, state.allWatchedExtendedConfigFiles, function(extendedConfigFileName, extendedConfigFilePath) {
          return state.watchFile(extendedConfigFileName, function() {
            var _a2;
            return (_a2 = state.allWatchedExtendedConfigFiles.get(extendedConfigFilePath)) === null || _a2 === void 0 ? void 0 : _a2.projects.forEach(function(projectConfigFilePath) {
              return invalidateProjectAndScheduleBuilds(state, projectConfigFilePath, ts3.ConfigFileProgramReloadLevel.Full);
            });
          }, ts3.PollingInterval.High, parsed === null || parsed === void 0 ? void 0 : parsed.watchOptions, ts3.WatchType.ExtendedConfigFile);
        }, function(fileName) {
          return toPath(state, fileName);
        });
      }
      function watchWildCardDirectories(state, resolved, resolvedPath, parsed) {
        if (!state.watch)
          return;
        ts3.updateWatchingWildcardDirectories(getOrCreateValueMapFromConfigFileMap(state.allWatchedWildcardDirectories, resolvedPath), new ts3.Map(ts3.getEntries(parsed.wildcardDirectories)), function(dir, flags) {
          return state.watchDirectory(dir, function(fileOrDirectory) {
            var _a2;
            if (ts3.isIgnoredFileFromWildCardWatching({
              watchedDirPath: toPath(state, dir),
              fileOrDirectory,
              fileOrDirectoryPath: toPath(state, fileOrDirectory),
              configFileName: resolved,
              currentDirectory: state.currentDirectory,
              options: parsed.options,
              program: state.builderPrograms.get(resolvedPath) || ((_a2 = getCachedParsedConfigFile(state, resolvedPath)) === null || _a2 === void 0 ? void 0 : _a2.fileNames),
              useCaseSensitiveFileNames: state.parseConfigFileHost.useCaseSensitiveFileNames,
              writeLog: function(s2) {
                return state.writeLog(s2);
              },
              toPath: function(fileName) {
                return toPath(state, fileName);
              }
            }))
              return;
            invalidateProjectAndScheduleBuilds(state, resolvedPath, ts3.ConfigFileProgramReloadLevel.Partial);
          }, flags, parsed === null || parsed === void 0 ? void 0 : parsed.watchOptions, ts3.WatchType.WildcardDirectory, resolved);
        });
      }
      function watchInputFiles(state, resolved, resolvedPath, parsed) {
        if (!state.watch)
          return;
        ts3.mutateMap(getOrCreateValueMapFromConfigFileMap(state.allWatchedInputFiles, resolvedPath), ts3.arrayToMap(parsed.fileNames, function(fileName) {
          return toPath(state, fileName);
        }), {
          createNewValue: function(_path, input) {
            return state.watchFile(input, function() {
              return invalidateProjectAndScheduleBuilds(state, resolvedPath, ts3.ConfigFileProgramReloadLevel.None);
            }, ts3.PollingInterval.Low, parsed === null || parsed === void 0 ? void 0 : parsed.watchOptions, ts3.WatchType.SourceFile, resolved);
          },
          onDeleteValue: ts3.closeFileWatcher
        });
      }
      function startWatching(state, buildOrder) {
        if (!state.watchAllProjectsPending)
          return;
        state.watchAllProjectsPending = false;
        for (var _i = 0, _a2 = getBuildOrderFromAnyBuildOrder(buildOrder); _i < _a2.length; _i++) {
          var resolved = _a2[_i];
          var resolvedPath = toResolvedConfigFilePath(state, resolved);
          var cfg = parseConfigFile(state, resolved, resolvedPath);
          watchConfigFile(state, resolved, resolvedPath, cfg);
          watchExtendedConfigFiles(state, resolvedPath, cfg);
          if (cfg) {
            watchWildCardDirectories(state, resolved, resolvedPath, cfg);
            watchInputFiles(state, resolved, resolvedPath, cfg);
          }
        }
      }
      function stopWatching(state) {
        ts3.clearMap(state.allWatchedConfigFiles, ts3.closeFileWatcher);
        ts3.clearMap(state.allWatchedExtendedConfigFiles, ts3.closeFileWatcherOf);
        ts3.clearMap(state.allWatchedWildcardDirectories, function(watchedWildcardDirectories) {
          return ts3.clearMap(watchedWildcardDirectories, ts3.closeFileWatcherOf);
        });
        ts3.clearMap(state.allWatchedInputFiles, function(watchedWildcardDirectories) {
          return ts3.clearMap(watchedWildcardDirectories, ts3.closeFileWatcher);
        });
      }
      function createSolutionBuilderWorker(watch, hostOrHostWithWatch, rootNames, options, baseWatchOptions) {
        var state = createSolutionBuilderState(watch, hostOrHostWithWatch, rootNames, options, baseWatchOptions);
        return {
          build: function(project, cancellationToken, writeFile, getCustomTransformers) {
            return build(state, project, cancellationToken, writeFile, getCustomTransformers);
          },
          clean: function(project) {
            return clean(state, project);
          },
          buildReferences: function(project, cancellationToken, writeFile, getCustomTransformers) {
            return build(state, project, cancellationToken, writeFile, getCustomTransformers, true);
          },
          cleanReferences: function(project) {
            return clean(state, project, true);
          },
          getNextInvalidatedProject: function(cancellationToken) {
            setupInitialBuild(state, cancellationToken);
            return getNextInvalidatedProject(state, getBuildOrder(state), false);
          },
          getBuildOrder: function() {
            return getBuildOrder(state);
          },
          getUpToDateStatusOfProject: function(project) {
            var configFileName = resolveProjectName(state, project);
            var configFilePath = toResolvedConfigFilePath(state, configFileName);
            return getUpToDateStatus(state, parseConfigFile(state, configFileName, configFilePath), configFilePath);
          },
          invalidateProject: function(configFilePath, reloadLevel) {
            return invalidateProject(state, configFilePath, reloadLevel || ts3.ConfigFileProgramReloadLevel.None);
          },
          buildNextInvalidatedProject: function() {
            return buildNextInvalidatedProject(state);
          },
          getAllParsedConfigs: function() {
            return ts3.arrayFrom(ts3.mapDefinedIterator(state.configFileCache.values(), function(config) {
              return isParsedCommandLine(config) ? config : void 0;
            }));
          },
          close: function() {
            return stopWatching(state);
          }
        };
      }
      function relName(state, path2) {
        return ts3.convertToRelativePath(path2, state.currentDirectory, function(f) {
          return state.getCanonicalFileName(f);
        });
      }
      function reportStatus(state, message) {
        var args = [];
        for (var _i = 2; _i < arguments.length; _i++) {
          args[_i - 2] = arguments[_i];
        }
        state.host.reportSolutionBuilderStatus(ts3.createCompilerDiagnostic.apply(void 0, __spreadArray([message], args)));
      }
      function reportWatchStatus(state, message) {
        var _a2, _b;
        var args = [];
        for (var _i = 2; _i < arguments.length; _i++) {
          args[_i - 2] = arguments[_i];
        }
        (_b = (_a2 = state.hostWithWatch).onWatchStatusChange) === null || _b === void 0 ? void 0 : _b.call(_a2, ts3.createCompilerDiagnostic.apply(void 0, __spreadArray([message], args)), state.host.getNewLine(), state.baseCompilerOptions);
      }
      function reportErrors(_a2, errors) {
        var host = _a2.host;
        errors.forEach(function(err2) {
          return host.reportDiagnostic(err2);
        });
      }
      function reportAndStoreErrors(state, proj, errors) {
        reportErrors(state, errors);
        state.projectErrorsReported.set(proj, true);
        if (errors.length) {
          state.diagnostics.set(proj, errors);
        }
      }
      function reportParseConfigFileDiagnostic(state, proj) {
        reportAndStoreErrors(state, proj, [state.configFileCache.get(proj)]);
      }
      function reportErrorSummary(state, buildOrder) {
        if (!state.needsSummary)
          return;
        state.needsSummary = false;
        var canReportSummary = state.watch || !!state.host.reportErrorSummary;
        var diagnostics = state.diagnostics;
        var totalErrors = 0;
        if (isCircularBuildOrder(buildOrder)) {
          reportBuildQueue(state, buildOrder.buildOrder);
          reportErrors(state, buildOrder.circularDiagnostics);
          if (canReportSummary)
            totalErrors += ts3.getErrorCountForSummary(buildOrder.circularDiagnostics);
        } else {
          buildOrder.forEach(function(project) {
            var projectPath = toResolvedConfigFilePath(state, project);
            if (!state.projectErrorsReported.has(projectPath)) {
              reportErrors(state, diagnostics.get(projectPath) || ts3.emptyArray);
            }
          });
          if (canReportSummary)
            diagnostics.forEach(function(singleProjectErrors) {
              return totalErrors += ts3.getErrorCountForSummary(singleProjectErrors);
            });
        }
        if (state.watch) {
          reportWatchStatus(state, ts3.getWatchErrorSummaryDiagnosticMessage(totalErrors), totalErrors);
        } else if (state.host.reportErrorSummary) {
          state.host.reportErrorSummary(totalErrors);
        }
      }
      function reportBuildQueue(state, buildQueue) {
        if (state.options.verbose) {
          reportStatus(state, ts3.Diagnostics.Projects_in_this_build_Colon_0, buildQueue.map(function(s2) {
            return "\r\n    * " + relName(state, s2);
          }).join(""));
        }
      }
      function reportUpToDateStatus(state, configFileName, status) {
        if (state.options.force && (status.type === ts3.UpToDateStatusType.UpToDate || status.type === ts3.UpToDateStatusType.UpToDateWithUpstreamTypes)) {
          return reportStatus(state, ts3.Diagnostics.Project_0_is_being_forcibly_rebuilt, relName(state, configFileName));
        }
        switch (status.type) {
          case ts3.UpToDateStatusType.OutOfDateWithSelf:
            return reportStatus(state, ts3.Diagnostics.Project_0_is_out_of_date_because_oldest_output_1_is_older_than_newest_input_2, relName(state, configFileName), relName(state, status.outOfDateOutputFileName), relName(state, status.newerInputFileName));
          case ts3.UpToDateStatusType.OutOfDateWithUpstream:
            return reportStatus(state, ts3.Diagnostics.Project_0_is_out_of_date_because_oldest_output_1_is_older_than_newest_input_2, relName(state, configFileName), relName(state, status.outOfDateOutputFileName), relName(state, status.newerProjectName));
          case ts3.UpToDateStatusType.OutputMissing:
            return reportStatus(state, ts3.Diagnostics.Project_0_is_out_of_date_because_output_file_1_does_not_exist, relName(state, configFileName), relName(state, status.missingOutputFileName));
          case ts3.UpToDateStatusType.UpToDate:
            if (status.newestInputFileTime !== void 0) {
              return reportStatus(state, ts3.Diagnostics.Project_0_is_up_to_date_because_newest_input_1_is_older_than_oldest_output_2, relName(state, configFileName), relName(state, status.newestInputFileName || ""), relName(state, status.oldestOutputFileName || ""));
            }
            break;
          case ts3.UpToDateStatusType.OutOfDateWithPrepend:
            return reportStatus(state, ts3.Diagnostics.Project_0_is_out_of_date_because_output_of_its_dependency_1_has_changed, relName(state, configFileName), relName(state, status.newerProjectName));
          case ts3.UpToDateStatusType.UpToDateWithUpstreamTypes:
            return reportStatus(state, ts3.Diagnostics.Project_0_is_up_to_date_with_d_ts_files_from_its_dependencies, relName(state, configFileName));
          case ts3.UpToDateStatusType.UpstreamOutOfDate:
            return reportStatus(state, ts3.Diagnostics.Project_0_is_out_of_date_because_its_dependency_1_is_out_of_date, relName(state, configFileName), relName(state, status.upstreamProjectName));
          case ts3.UpToDateStatusType.UpstreamBlocked:
            return reportStatus(state, status.upstreamProjectBlocked ? ts3.Diagnostics.Project_0_can_t_be_built_because_its_dependency_1_was_not_built : ts3.Diagnostics.Project_0_can_t_be_built_because_its_dependency_1_has_errors, relName(state, configFileName), relName(state, status.upstreamProjectName));
          case ts3.UpToDateStatusType.Unbuildable:
            return reportStatus(state, ts3.Diagnostics.Failed_to_parse_file_0_Colon_1, relName(state, configFileName), status.reason);
          case ts3.UpToDateStatusType.TsVersionOutputOfDate:
            return reportStatus(state, ts3.Diagnostics.Project_0_is_out_of_date_because_output_for_it_was_generated_with_version_1_that_differs_with_current_version_2, relName(state, configFileName), status.version, ts3.version);
          case ts3.UpToDateStatusType.ContainerOnly:
          case ts3.UpToDateStatusType.ComputingUpstream:
            break;
          default:
            ts3.assertType(status);
        }
      }
      function verboseReportProjectStatus(state, configFileName, status) {
        if (state.options.verbose) {
          reportUpToDateStatus(state, configFileName, status);
        }
      }
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var server;
      (function(server2) {
        server2.ActionSet = "action::set";
        server2.ActionInvalidate = "action::invalidate";
        server2.ActionPackageInstalled = "action::packageInstalled";
        server2.EventTypesRegistry = "event::typesRegistry";
        server2.EventBeginInstallTypes = "event::beginInstallTypes";
        server2.EventEndInstallTypes = "event::endInstallTypes";
        server2.EventInitializationFailed = "event::initializationFailed";
        var Arguments;
        (function(Arguments2) {
          Arguments2.GlobalCacheLocation = "--globalTypingsCacheLocation";
          Arguments2.LogFile = "--logFile";
          Arguments2.EnableTelemetry = "--enableTelemetry";
          Arguments2.TypingSafeListLocation = "--typingSafeListLocation";
          Arguments2.TypesMapLocation = "--typesMapLocation";
          Arguments2.NpmLocation = "--npmLocation";
          Arguments2.ValidateDefaultNpmLocation = "--validateDefaultNpmLocation";
        })(Arguments = server2.Arguments || (server2.Arguments = {}));
        function hasArgument(argumentName) {
          return ts3.sys.args.indexOf(argumentName) >= 0;
        }
        server2.hasArgument = hasArgument;
        function findArgument(argumentName) {
          var index = ts3.sys.args.indexOf(argumentName);
          return index >= 0 && index < ts3.sys.args.length - 1 ? ts3.sys.args[index + 1] : void 0;
        }
        server2.findArgument = findArgument;
        function nowString() {
          var d = new Date();
          return ts3.padLeft(d.getHours().toString(), 2, "0") + ":" + ts3.padLeft(d.getMinutes().toString(), 2, "0") + ":" + ts3.padLeft(d.getSeconds().toString(), 2, "0") + "." + ts3.padLeft(d.getMilliseconds().toString(), 3, "0");
        }
        server2.nowString = nowString;
      })(server = ts3.server || (ts3.server = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var JsTyping;
      (function(JsTyping2) {
        function isTypingUpToDate(cachedTyping, availableTypingVersions) {
          var availableVersion = new ts3.Version(ts3.getProperty(availableTypingVersions, "ts" + ts3.versionMajorMinor) || ts3.getProperty(availableTypingVersions, "latest"));
          return availableVersion.compareTo(cachedTyping.version) <= 0;
        }
        JsTyping2.isTypingUpToDate = isTypingUpToDate;
        JsTyping2.nodeCoreModuleList = [
          "assert",
          "async_hooks",
          "buffer",
          "child_process",
          "cluster",
          "console",
          "constants",
          "crypto",
          "dgram",
          "dns",
          "domain",
          "events",
          "fs",
          "http",
          "https",
          "http2",
          "inspector",
          "net",
          "os",
          "path",
          "perf_hooks",
          "process",
          "punycode",
          "querystring",
          "readline",
          "repl",
          "stream",
          "string_decoder",
          "timers",
          "tls",
          "tty",
          "url",
          "util",
          "v8",
          "vm",
          "zlib"
        ];
        JsTyping2.nodeCoreModules = new ts3.Set(JsTyping2.nodeCoreModuleList);
        function nonRelativeModuleNameForTypingCache(moduleName) {
          return JsTyping2.nodeCoreModules.has(moduleName) ? "node" : moduleName;
        }
        JsTyping2.nonRelativeModuleNameForTypingCache = nonRelativeModuleNameForTypingCache;
        function loadSafeList(host, safeListPath) {
          var result2 = ts3.readConfigFile(safeListPath, function(path2) {
            return host.readFile(path2);
          });
          return new ts3.Map(ts3.getEntries(result2.config));
        }
        JsTyping2.loadSafeList = loadSafeList;
        function loadTypesMap(host, typesMapPath) {
          var result2 = ts3.readConfigFile(typesMapPath, function(path2) {
            return host.readFile(path2);
          });
          if (result2.config) {
            return new ts3.Map(ts3.getEntries(result2.config.simpleMap));
          }
          return void 0;
        }
        JsTyping2.loadTypesMap = loadTypesMap;
        function discoverTypings(host, log, fileNames, projectRootPath, safeList, packageNameToTypingLocation, typeAcquisition, unresolvedImports, typesRegistry) {
          if (!typeAcquisition || !typeAcquisition.enable) {
            return { cachedTypingPaths: [], newTypingNames: [], filesToWatch: [] };
          }
          var inferredTypings = new ts3.Map();
          fileNames = ts3.mapDefined(fileNames, function(fileName) {
            var path2 = ts3.normalizePath(fileName);
            if (ts3.hasJSFileExtension(path2)) {
              return path2;
            }
          });
          var filesToWatch = [];
          if (typeAcquisition.include)
            addInferredTypings(typeAcquisition.include, "Explicitly included types");
          var exclude = typeAcquisition.exclude || [];
          var possibleSearchDirs = new ts3.Set(fileNames.map(ts3.getDirectoryPath));
          possibleSearchDirs.add(projectRootPath);
          possibleSearchDirs.forEach(function(searchDir) {
            var packageJsonPath = ts3.combinePaths(searchDir, "package.json");
            getTypingNamesFromJson(packageJsonPath, filesToWatch);
            var bowerJsonPath = ts3.combinePaths(searchDir, "bower.json");
            getTypingNamesFromJson(bowerJsonPath, filesToWatch);
            var bowerComponentsPath = ts3.combinePaths(searchDir, "bower_components");
            getTypingNamesFromPackagesFolder(bowerComponentsPath, filesToWatch);
            var nodeModulesPath = ts3.combinePaths(searchDir, "node_modules");
            getTypingNamesFromPackagesFolder(nodeModulesPath, filesToWatch);
          });
          if (!typeAcquisition.disableFilenameBasedTypeAcquisition) {
            getTypingNamesFromSourceFileNames(fileNames);
          }
          if (unresolvedImports) {
            var module_1 = ts3.deduplicate(unresolvedImports.map(nonRelativeModuleNameForTypingCache), ts3.equateStringsCaseSensitive, ts3.compareStringsCaseSensitive);
            addInferredTypings(module_1, "Inferred typings from unresolved imports");
          }
          packageNameToTypingLocation.forEach(function(typing, name) {
            var registryEntry = typesRegistry.get(name);
            if (inferredTypings.has(name) && inferredTypings.get(name) === void 0 && registryEntry !== void 0 && isTypingUpToDate(typing, registryEntry)) {
              inferredTypings.set(name, typing.typingLocation);
            }
          });
          for (var _i = 0, exclude_1 = exclude; _i < exclude_1.length; _i++) {
            var excludeTypingName = exclude_1[_i];
            var didDelete = inferredTypings.delete(excludeTypingName);
            if (didDelete && log)
              log("Typing for " + excludeTypingName + " is in exclude list, will be ignored.");
          }
          var newTypingNames = [];
          var cachedTypingPaths = [];
          inferredTypings.forEach(function(inferred, typing) {
            if (inferred !== void 0) {
              cachedTypingPaths.push(inferred);
            } else {
              newTypingNames.push(typing);
            }
          });
          var result2 = { cachedTypingPaths, newTypingNames, filesToWatch };
          if (log)
            log("Result: " + JSON.stringify(result2));
          return result2;
          function addInferredTyping(typingName) {
            if (!inferredTypings.has(typingName)) {
              inferredTypings.set(typingName, void 0);
            }
          }
          function addInferredTypings(typingNames, message) {
            if (log)
              log(message + ": " + JSON.stringify(typingNames));
            ts3.forEach(typingNames, addInferredTyping);
          }
          function getTypingNamesFromJson(jsonPath, filesToWatch2) {
            if (!host.fileExists(jsonPath)) {
              return;
            }
            filesToWatch2.push(jsonPath);
            var jsonConfig = ts3.readConfigFile(jsonPath, function(path2) {
              return host.readFile(path2);
            }).config;
            var jsonTypingNames = ts3.flatMap([jsonConfig.dependencies, jsonConfig.devDependencies, jsonConfig.optionalDependencies, jsonConfig.peerDependencies], ts3.getOwnKeys);
            addInferredTypings(jsonTypingNames, "Typing names in '" + jsonPath + "' dependencies");
          }
          function getTypingNamesFromSourceFileNames(fileNames2) {
            var fromFileNames = ts3.mapDefined(fileNames2, function(j) {
              if (!ts3.hasJSFileExtension(j))
                return void 0;
              var inferredTypingName = ts3.removeFileExtension(ts3.getBaseFileName(j.toLowerCase()));
              var cleanedTypingName = ts3.removeMinAndVersionNumbers(inferredTypingName);
              return safeList.get(cleanedTypingName);
            });
            if (fromFileNames.length) {
              addInferredTypings(fromFileNames, "Inferred typings from file names");
            }
            var hasJsxFile = ts3.some(fileNames2, function(f) {
              return ts3.fileExtensionIs(f, ".jsx");
            });
            if (hasJsxFile) {
              if (log)
                log("Inferred 'react' typings due to presence of '.jsx' extension");
              addInferredTyping("react");
            }
          }
          function getTypingNamesFromPackagesFolder(packagesFolderPath, filesToWatch2) {
            filesToWatch2.push(packagesFolderPath);
            if (!host.directoryExists(packagesFolderPath)) {
              return;
            }
            var fileNames2 = host.readDirectory(packagesFolderPath, [".json"], void 0, void 0, 2);
            if (log)
              log("Searching for typing names in " + packagesFolderPath + "; all files: " + JSON.stringify(fileNames2));
            var packageNames = [];
            for (var _i2 = 0, fileNames_1 = fileNames2; _i2 < fileNames_1.length; _i2++) {
              var fileName = fileNames_1[_i2];
              var normalizedFileName = ts3.normalizePath(fileName);
              var baseFileName = ts3.getBaseFileName(normalizedFileName);
              if (baseFileName !== "package.json" && baseFileName !== "bower.json") {
                continue;
              }
              var result_1 = ts3.readConfigFile(normalizedFileName, function(path2) {
                return host.readFile(path2);
              });
              var packageJson = result_1.config;
              if (baseFileName === "package.json" && packageJson._requiredBy && ts3.filter(packageJson._requiredBy, function(r2) {
                return r2[0] === "#" || r2 === "/";
              }).length === 0) {
                continue;
              }
              if (!packageJson.name) {
                continue;
              }
              var ownTypes = packageJson.types || packageJson.typings;
              if (ownTypes) {
                var absolutePath = ts3.getNormalizedAbsolutePath(ownTypes, ts3.getDirectoryPath(normalizedFileName));
                if (log)
                  log("    Package '" + packageJson.name + "' provides its own types.");
                inferredTypings.set(packageJson.name, absolutePath);
              } else {
                packageNames.push(packageJson.name);
              }
            }
            addInferredTypings(packageNames, "    Found package names");
          }
        }
        JsTyping2.discoverTypings = discoverTypings;
        var NameValidationResult;
        (function(NameValidationResult2) {
          NameValidationResult2[NameValidationResult2["Ok"] = 0] = "Ok";
          NameValidationResult2[NameValidationResult2["EmptyName"] = 1] = "EmptyName";
          NameValidationResult2[NameValidationResult2["NameTooLong"] = 2] = "NameTooLong";
          NameValidationResult2[NameValidationResult2["NameStartsWithDot"] = 3] = "NameStartsWithDot";
          NameValidationResult2[NameValidationResult2["NameStartsWithUnderscore"] = 4] = "NameStartsWithUnderscore";
          NameValidationResult2[NameValidationResult2["NameContainsNonURISafeCharacters"] = 5] = "NameContainsNonURISafeCharacters";
        })(NameValidationResult = JsTyping2.NameValidationResult || (JsTyping2.NameValidationResult = {}));
        var maxPackageNameLength = 214;
        function validatePackageName(packageName) {
          return validatePackageNameWorker(packageName, true);
        }
        JsTyping2.validatePackageName = validatePackageName;
        function validatePackageNameWorker(packageName, supportScopedPackage) {
          if (!packageName) {
            return 1;
          }
          if (packageName.length > maxPackageNameLength) {
            return 2;
          }
          if (packageName.charCodeAt(0) === 46) {
            return 3;
          }
          if (packageName.charCodeAt(0) === 95) {
            return 4;
          }
          if (supportScopedPackage) {
            var matches = /^@([^/]+)\/([^/]+)$/.exec(packageName);
            if (matches) {
              var scopeResult = validatePackageNameWorker(matches[1], false);
              if (scopeResult !== 0) {
                return { name: matches[1], isScopeName: true, result: scopeResult };
              }
              var packageResult = validatePackageNameWorker(matches[2], false);
              if (packageResult !== 0) {
                return { name: matches[2], isScopeName: false, result: packageResult };
              }
              return 0;
            }
          }
          if (encodeURIComponent(packageName) !== packageName) {
            return 5;
          }
          return 0;
        }
        function renderPackageNameValidationFailure(result2, typing) {
          return typeof result2 === "object" ? renderPackageNameValidationFailureWorker(typing, result2.result, result2.name, result2.isScopeName) : renderPackageNameValidationFailureWorker(typing, result2, typing, false);
        }
        JsTyping2.renderPackageNameValidationFailure = renderPackageNameValidationFailure;
        function renderPackageNameValidationFailureWorker(typing, result2, name, isScopeName) {
          var kind = isScopeName ? "Scope" : "Package";
          switch (result2) {
            case 1:
              return "'" + typing + "':: " + kind + " name '" + name + "' cannot be empty";
            case 2:
              return "'" + typing + "':: " + kind + " name '" + name + "' should be less than " + maxPackageNameLength + " characters";
            case 3:
              return "'" + typing + "':: " + kind + " name '" + name + "' cannot start with '.'";
            case 4:
              return "'" + typing + "':: " + kind + " name '" + name + "' cannot start with '_'";
            case 5:
              return "'" + typing + "':: " + kind + " name '" + name + "' contains non URI safe characters";
            case 0:
              return ts3.Debug.fail();
            default:
              throw ts3.Debug.assertNever(result2);
          }
        }
      })(JsTyping = ts3.JsTyping || (ts3.JsTyping = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var ScriptSnapshot;
      (function(ScriptSnapshot2) {
        var StringScriptSnapshot = function() {
          function StringScriptSnapshot2(text) {
            this.text = text;
          }
          StringScriptSnapshot2.prototype.getText = function(start, end) {
            return start === 0 && end === this.text.length ? this.text : this.text.substring(start, end);
          };
          StringScriptSnapshot2.prototype.getLength = function() {
            return this.text.length;
          };
          StringScriptSnapshot2.prototype.getChangeRange = function() {
            return void 0;
          };
          return StringScriptSnapshot2;
        }();
        function fromString(text) {
          return new StringScriptSnapshot(text);
        }
        ScriptSnapshot2.fromString = fromString;
      })(ScriptSnapshot = ts3.ScriptSnapshot || (ts3.ScriptSnapshot = {}));
      var PackageJsonDependencyGroup;
      (function(PackageJsonDependencyGroup2) {
        PackageJsonDependencyGroup2[PackageJsonDependencyGroup2["Dependencies"] = 1] = "Dependencies";
        PackageJsonDependencyGroup2[PackageJsonDependencyGroup2["DevDependencies"] = 2] = "DevDependencies";
        PackageJsonDependencyGroup2[PackageJsonDependencyGroup2["PeerDependencies"] = 4] = "PeerDependencies";
        PackageJsonDependencyGroup2[PackageJsonDependencyGroup2["OptionalDependencies"] = 8] = "OptionalDependencies";
        PackageJsonDependencyGroup2[PackageJsonDependencyGroup2["All"] = 15] = "All";
      })(PackageJsonDependencyGroup = ts3.PackageJsonDependencyGroup || (ts3.PackageJsonDependencyGroup = {}));
      var PackageJsonAutoImportPreference;
      (function(PackageJsonAutoImportPreference2) {
        PackageJsonAutoImportPreference2[PackageJsonAutoImportPreference2["Off"] = 0] = "Off";
        PackageJsonAutoImportPreference2[PackageJsonAutoImportPreference2["On"] = 1] = "On";
        PackageJsonAutoImportPreference2[PackageJsonAutoImportPreference2["Auto"] = 2] = "Auto";
      })(PackageJsonAutoImportPreference = ts3.PackageJsonAutoImportPreference || (ts3.PackageJsonAutoImportPreference = {}));
      var LanguageServiceMode;
      (function(LanguageServiceMode2) {
        LanguageServiceMode2[LanguageServiceMode2["Semantic"] = 0] = "Semantic";
        LanguageServiceMode2[LanguageServiceMode2["PartialSemantic"] = 1] = "PartialSemantic";
        LanguageServiceMode2[LanguageServiceMode2["Syntactic"] = 2] = "Syntactic";
      })(LanguageServiceMode = ts3.LanguageServiceMode || (ts3.LanguageServiceMode = {}));
      ts3.emptyOptions = {};
      var SemanticClassificationFormat;
      (function(SemanticClassificationFormat2) {
        SemanticClassificationFormat2["Original"] = "original";
        SemanticClassificationFormat2["TwentyTwenty"] = "2020";
      })(SemanticClassificationFormat = ts3.SemanticClassificationFormat || (ts3.SemanticClassificationFormat = {}));
      var HighlightSpanKind;
      (function(HighlightSpanKind2) {
        HighlightSpanKind2["none"] = "none";
        HighlightSpanKind2["definition"] = "definition";
        HighlightSpanKind2["reference"] = "reference";
        HighlightSpanKind2["writtenReference"] = "writtenReference";
      })(HighlightSpanKind = ts3.HighlightSpanKind || (ts3.HighlightSpanKind = {}));
      var IndentStyle;
      (function(IndentStyle2) {
        IndentStyle2[IndentStyle2["None"] = 0] = "None";
        IndentStyle2[IndentStyle2["Block"] = 1] = "Block";
        IndentStyle2[IndentStyle2["Smart"] = 2] = "Smart";
      })(IndentStyle = ts3.IndentStyle || (ts3.IndentStyle = {}));
      var SemicolonPreference;
      (function(SemicolonPreference2) {
        SemicolonPreference2["Ignore"] = "ignore";
        SemicolonPreference2["Insert"] = "insert";
        SemicolonPreference2["Remove"] = "remove";
      })(SemicolonPreference = ts3.SemicolonPreference || (ts3.SemicolonPreference = {}));
      function getDefaultFormatCodeSettings(newLineCharacter) {
        return {
          indentSize: 4,
          tabSize: 4,
          newLineCharacter: newLineCharacter || "\n",
          convertTabsToSpaces: true,
          indentStyle: IndentStyle.Smart,
          insertSpaceAfterConstructor: false,
          insertSpaceAfterCommaDelimiter: true,
          insertSpaceAfterSemicolonInForStatements: true,
          insertSpaceBeforeAndAfterBinaryOperators: true,
          insertSpaceAfterKeywordsInControlFlowStatements: true,
          insertSpaceAfterFunctionKeywordForAnonymousFunctions: false,
          insertSpaceAfterOpeningAndBeforeClosingNonemptyParenthesis: false,
          insertSpaceAfterOpeningAndBeforeClosingNonemptyBrackets: false,
          insertSpaceAfterOpeningAndBeforeClosingNonemptyBraces: true,
          insertSpaceAfterOpeningAndBeforeClosingTemplateStringBraces: false,
          insertSpaceAfterOpeningAndBeforeClosingJsxExpressionBraces: false,
          insertSpaceBeforeFunctionParenthesis: false,
          placeOpenBraceOnNewLineForFunctions: false,
          placeOpenBraceOnNewLineForControlBlocks: false,
          semicolons: SemicolonPreference.Ignore,
          trimTrailingWhitespace: true
        };
      }
      ts3.getDefaultFormatCodeSettings = getDefaultFormatCodeSettings;
      ts3.testFormatSettings = getDefaultFormatCodeSettings("\n");
      var SymbolDisplayPartKind;
      (function(SymbolDisplayPartKind2) {
        SymbolDisplayPartKind2[SymbolDisplayPartKind2["aliasName"] = 0] = "aliasName";
        SymbolDisplayPartKind2[SymbolDisplayPartKind2["className"] = 1] = "className";
        SymbolDisplayPartKind2[SymbolDisplayPartKind2["enumName"] = 2] = "enumName";
        SymbolDisplayPartKind2[SymbolDisplayPartKind2["fieldName"] = 3] = "fieldName";
        SymbolDisplayPartKind2[SymbolDisplayPartKind2["interfaceName"] = 4] = "interfaceName";
        SymbolDisplayPartKind2[SymbolDisplayPartKind2["keyword"] = 5] = "keyword";
        SymbolDisplayPartKind2[SymbolDisplayPartKind2["lineBreak"] = 6] = "lineBreak";
        SymbolDisplayPartKind2[SymbolDisplayPartKind2["numericLiteral"] = 7] = "numericLiteral";
        SymbolDisplayPartKind2[SymbolDisplayPartKind2["stringLiteral"] = 8] = "stringLiteral";
        SymbolDisplayPartKind2[SymbolDisplayPartKind2["localName"] = 9] = "localName";
        SymbolDisplayPartKind2[SymbolDisplayPartKind2["methodName"] = 10] = "methodName";
        SymbolDisplayPartKind2[SymbolDisplayPartKind2["moduleName"] = 11] = "moduleName";
        SymbolDisplayPartKind2[SymbolDisplayPartKind2["operator"] = 12] = "operator";
        SymbolDisplayPartKind2[SymbolDisplayPartKind2["parameterName"] = 13] = "parameterName";
        SymbolDisplayPartKind2[SymbolDisplayPartKind2["propertyName"] = 14] = "propertyName";
        SymbolDisplayPartKind2[SymbolDisplayPartKind2["punctuation"] = 15] = "punctuation";
        SymbolDisplayPartKind2[SymbolDisplayPartKind2["space"] = 16] = "space";
        SymbolDisplayPartKind2[SymbolDisplayPartKind2["text"] = 17] = "text";
        SymbolDisplayPartKind2[SymbolDisplayPartKind2["typeParameterName"] = 18] = "typeParameterName";
        SymbolDisplayPartKind2[SymbolDisplayPartKind2["enumMemberName"] = 19] = "enumMemberName";
        SymbolDisplayPartKind2[SymbolDisplayPartKind2["functionName"] = 20] = "functionName";
        SymbolDisplayPartKind2[SymbolDisplayPartKind2["regularExpressionLiteral"] = 21] = "regularExpressionLiteral";
        SymbolDisplayPartKind2[SymbolDisplayPartKind2["link"] = 22] = "link";
        SymbolDisplayPartKind2[SymbolDisplayPartKind2["linkName"] = 23] = "linkName";
        SymbolDisplayPartKind2[SymbolDisplayPartKind2["linkText"] = 24] = "linkText";
      })(SymbolDisplayPartKind = ts3.SymbolDisplayPartKind || (ts3.SymbolDisplayPartKind = {}));
      var OutliningSpanKind;
      (function(OutliningSpanKind2) {
        OutliningSpanKind2["Comment"] = "comment";
        OutliningSpanKind2["Region"] = "region";
        OutliningSpanKind2["Code"] = "code";
        OutliningSpanKind2["Imports"] = "imports";
      })(OutliningSpanKind = ts3.OutliningSpanKind || (ts3.OutliningSpanKind = {}));
      var OutputFileType;
      (function(OutputFileType2) {
        OutputFileType2[OutputFileType2["JavaScript"] = 0] = "JavaScript";
        OutputFileType2[OutputFileType2["SourceMap"] = 1] = "SourceMap";
        OutputFileType2[OutputFileType2["Declaration"] = 2] = "Declaration";
      })(OutputFileType = ts3.OutputFileType || (ts3.OutputFileType = {}));
      var EndOfLineState;
      (function(EndOfLineState2) {
        EndOfLineState2[EndOfLineState2["None"] = 0] = "None";
        EndOfLineState2[EndOfLineState2["InMultiLineCommentTrivia"] = 1] = "InMultiLineCommentTrivia";
        EndOfLineState2[EndOfLineState2["InSingleQuoteStringLiteral"] = 2] = "InSingleQuoteStringLiteral";
        EndOfLineState2[EndOfLineState2["InDoubleQuoteStringLiteral"] = 3] = "InDoubleQuoteStringLiteral";
        EndOfLineState2[EndOfLineState2["InTemplateHeadOrNoSubstitutionTemplate"] = 4] = "InTemplateHeadOrNoSubstitutionTemplate";
        EndOfLineState2[EndOfLineState2["InTemplateMiddleOrTail"] = 5] = "InTemplateMiddleOrTail";
        EndOfLineState2[EndOfLineState2["InTemplateSubstitutionPosition"] = 6] = "InTemplateSubstitutionPosition";
      })(EndOfLineState = ts3.EndOfLineState || (ts3.EndOfLineState = {}));
      var TokenClass;
      (function(TokenClass2) {
        TokenClass2[TokenClass2["Punctuation"] = 0] = "Punctuation";
        TokenClass2[TokenClass2["Keyword"] = 1] = "Keyword";
        TokenClass2[TokenClass2["Operator"] = 2] = "Operator";
        TokenClass2[TokenClass2["Comment"] = 3] = "Comment";
        TokenClass2[TokenClass2["Whitespace"] = 4] = "Whitespace";
        TokenClass2[TokenClass2["Identifier"] = 5] = "Identifier";
        TokenClass2[TokenClass2["NumberLiteral"] = 6] = "NumberLiteral";
        TokenClass2[TokenClass2["BigIntLiteral"] = 7] = "BigIntLiteral";
        TokenClass2[TokenClass2["StringLiteral"] = 8] = "StringLiteral";
        TokenClass2[TokenClass2["RegExpLiteral"] = 9] = "RegExpLiteral";
      })(TokenClass = ts3.TokenClass || (ts3.TokenClass = {}));
      var ScriptElementKind;
      (function(ScriptElementKind2) {
        ScriptElementKind2["unknown"] = "";
        ScriptElementKind2["warning"] = "warning";
        ScriptElementKind2["keyword"] = "keyword";
        ScriptElementKind2["scriptElement"] = "script";
        ScriptElementKind2["moduleElement"] = "module";
        ScriptElementKind2["classElement"] = "class";
        ScriptElementKind2["localClassElement"] = "local class";
        ScriptElementKind2["interfaceElement"] = "interface";
        ScriptElementKind2["typeElement"] = "type";
        ScriptElementKind2["enumElement"] = "enum";
        ScriptElementKind2["enumMemberElement"] = "enum member";
        ScriptElementKind2["variableElement"] = "var";
        ScriptElementKind2["localVariableElement"] = "local var";
        ScriptElementKind2["functionElement"] = "function";
        ScriptElementKind2["localFunctionElement"] = "local function";
        ScriptElementKind2["memberFunctionElement"] = "method";
        ScriptElementKind2["memberGetAccessorElement"] = "getter";
        ScriptElementKind2["memberSetAccessorElement"] = "setter";
        ScriptElementKind2["memberVariableElement"] = "property";
        ScriptElementKind2["constructorImplementationElement"] = "constructor";
        ScriptElementKind2["callSignatureElement"] = "call";
        ScriptElementKind2["indexSignatureElement"] = "index";
        ScriptElementKind2["constructSignatureElement"] = "construct";
        ScriptElementKind2["parameterElement"] = "parameter";
        ScriptElementKind2["typeParameterElement"] = "type parameter";
        ScriptElementKind2["primitiveType"] = "primitive type";
        ScriptElementKind2["label"] = "label";
        ScriptElementKind2["alias"] = "alias";
        ScriptElementKind2["constElement"] = "const";
        ScriptElementKind2["letElement"] = "let";
        ScriptElementKind2["directory"] = "directory";
        ScriptElementKind2["externalModuleName"] = "external module name";
        ScriptElementKind2["jsxAttribute"] = "JSX attribute";
        ScriptElementKind2["string"] = "string";
        ScriptElementKind2["link"] = "link";
        ScriptElementKind2["linkName"] = "link name";
        ScriptElementKind2["linkText"] = "link text";
      })(ScriptElementKind = ts3.ScriptElementKind || (ts3.ScriptElementKind = {}));
      var ScriptElementKindModifier;
      (function(ScriptElementKindModifier2) {
        ScriptElementKindModifier2["none"] = "";
        ScriptElementKindModifier2["publicMemberModifier"] = "public";
        ScriptElementKindModifier2["privateMemberModifier"] = "private";
        ScriptElementKindModifier2["protectedMemberModifier"] = "protected";
        ScriptElementKindModifier2["exportedModifier"] = "export";
        ScriptElementKindModifier2["ambientModifier"] = "declare";
        ScriptElementKindModifier2["staticModifier"] = "static";
        ScriptElementKindModifier2["abstractModifier"] = "abstract";
        ScriptElementKindModifier2["optionalModifier"] = "optional";
        ScriptElementKindModifier2["deprecatedModifier"] = "deprecated";
        ScriptElementKindModifier2["dtsModifier"] = ".d.ts";
        ScriptElementKindModifier2["tsModifier"] = ".ts";
        ScriptElementKindModifier2["tsxModifier"] = ".tsx";
        ScriptElementKindModifier2["jsModifier"] = ".js";
        ScriptElementKindModifier2["jsxModifier"] = ".jsx";
        ScriptElementKindModifier2["jsonModifier"] = ".json";
      })(ScriptElementKindModifier = ts3.ScriptElementKindModifier || (ts3.ScriptElementKindModifier = {}));
      var ClassificationTypeNames;
      (function(ClassificationTypeNames2) {
        ClassificationTypeNames2["comment"] = "comment";
        ClassificationTypeNames2["identifier"] = "identifier";
        ClassificationTypeNames2["keyword"] = "keyword";
        ClassificationTypeNames2["numericLiteral"] = "number";
        ClassificationTypeNames2["bigintLiteral"] = "bigint";
        ClassificationTypeNames2["operator"] = "operator";
        ClassificationTypeNames2["stringLiteral"] = "string";
        ClassificationTypeNames2["whiteSpace"] = "whitespace";
        ClassificationTypeNames2["text"] = "text";
        ClassificationTypeNames2["punctuation"] = "punctuation";
        ClassificationTypeNames2["className"] = "class name";
        ClassificationTypeNames2["enumName"] = "enum name";
        ClassificationTypeNames2["interfaceName"] = "interface name";
        ClassificationTypeNames2["moduleName"] = "module name";
        ClassificationTypeNames2["typeParameterName"] = "type parameter name";
        ClassificationTypeNames2["typeAliasName"] = "type alias name";
        ClassificationTypeNames2["parameterName"] = "parameter name";
        ClassificationTypeNames2["docCommentTagName"] = "doc comment tag name";
        ClassificationTypeNames2["jsxOpenTagName"] = "jsx open tag name";
        ClassificationTypeNames2["jsxCloseTagName"] = "jsx close tag name";
        ClassificationTypeNames2["jsxSelfClosingTagName"] = "jsx self closing tag name";
        ClassificationTypeNames2["jsxAttribute"] = "jsx attribute";
        ClassificationTypeNames2["jsxText"] = "jsx text";
        ClassificationTypeNames2["jsxAttributeStringLiteralValue"] = "jsx attribute string literal value";
      })(ClassificationTypeNames = ts3.ClassificationTypeNames || (ts3.ClassificationTypeNames = {}));
      var ClassificationType;
      (function(ClassificationType2) {
        ClassificationType2[ClassificationType2["comment"] = 1] = "comment";
        ClassificationType2[ClassificationType2["identifier"] = 2] = "identifier";
        ClassificationType2[ClassificationType2["keyword"] = 3] = "keyword";
        ClassificationType2[ClassificationType2["numericLiteral"] = 4] = "numericLiteral";
        ClassificationType2[ClassificationType2["operator"] = 5] = "operator";
        ClassificationType2[ClassificationType2["stringLiteral"] = 6] = "stringLiteral";
        ClassificationType2[ClassificationType2["regularExpressionLiteral"] = 7] = "regularExpressionLiteral";
        ClassificationType2[ClassificationType2["whiteSpace"] = 8] = "whiteSpace";
        ClassificationType2[ClassificationType2["text"] = 9] = "text";
        ClassificationType2[ClassificationType2["punctuation"] = 10] = "punctuation";
        ClassificationType2[ClassificationType2["className"] = 11] = "className";
        ClassificationType2[ClassificationType2["enumName"] = 12] = "enumName";
        ClassificationType2[ClassificationType2["interfaceName"] = 13] = "interfaceName";
        ClassificationType2[ClassificationType2["moduleName"] = 14] = "moduleName";
        ClassificationType2[ClassificationType2["typeParameterName"] = 15] = "typeParameterName";
        ClassificationType2[ClassificationType2["typeAliasName"] = 16] = "typeAliasName";
        ClassificationType2[ClassificationType2["parameterName"] = 17] = "parameterName";
        ClassificationType2[ClassificationType2["docCommentTagName"] = 18] = "docCommentTagName";
        ClassificationType2[ClassificationType2["jsxOpenTagName"] = 19] = "jsxOpenTagName";
        ClassificationType2[ClassificationType2["jsxCloseTagName"] = 20] = "jsxCloseTagName";
        ClassificationType2[ClassificationType2["jsxSelfClosingTagName"] = 21] = "jsxSelfClosingTagName";
        ClassificationType2[ClassificationType2["jsxAttribute"] = 22] = "jsxAttribute";
        ClassificationType2[ClassificationType2["jsxText"] = 23] = "jsxText";
        ClassificationType2[ClassificationType2["jsxAttributeStringLiteralValue"] = 24] = "jsxAttributeStringLiteralValue";
        ClassificationType2[ClassificationType2["bigintLiteral"] = 25] = "bigintLiteral";
      })(ClassificationType = ts3.ClassificationType || (ts3.ClassificationType = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      ts3.scanner = ts3.createScanner(99, true);
      var SemanticMeaning;
      (function(SemanticMeaning2) {
        SemanticMeaning2[SemanticMeaning2["None"] = 0] = "None";
        SemanticMeaning2[SemanticMeaning2["Value"] = 1] = "Value";
        SemanticMeaning2[SemanticMeaning2["Type"] = 2] = "Type";
        SemanticMeaning2[SemanticMeaning2["Namespace"] = 4] = "Namespace";
        SemanticMeaning2[SemanticMeaning2["All"] = 7] = "All";
      })(SemanticMeaning = ts3.SemanticMeaning || (ts3.SemanticMeaning = {}));
      function getMeaningFromDeclaration(node) {
        switch (node.kind) {
          case 250:
            return ts3.isInJSFile(node) && ts3.getJSDocEnumTag(node) ? 7 : 1;
          case 161:
          case 199:
          case 164:
          case 163:
          case 289:
          case 290:
          case 166:
          case 165:
          case 167:
          case 168:
          case 169:
          case 252:
          case 209:
          case 210:
          case 288:
          case 281:
            return 1;
          case 160:
          case 254:
          case 255:
          case 178:
            return 2;
          case 335:
            return node.name === void 0 ? 1 | 2 : 2;
          case 292:
          case 253:
            return 1 | 2;
          case 257:
            if (ts3.isAmbientModule(node)) {
              return 4 | 1;
            } else if (ts3.getModuleInstanceState(node) === 1) {
              return 4 | 1;
            } else {
              return 4;
            }
          case 256:
          case 265:
          case 266:
          case 261:
          case 262:
          case 267:
          case 268:
            return 7;
          case 298:
            return 4 | 1;
        }
        return 7;
      }
      ts3.getMeaningFromDeclaration = getMeaningFromDeclaration;
      function getMeaningFromLocation(node) {
        node = getAdjustedReferenceLocation(node);
        if (node.kind === 298) {
          return 1;
        } else if (node.parent.kind === 267 || node.parent.kind === 273 || node.parent.kind === 266 || node.parent.kind === 263 || ts3.isImportEqualsDeclaration(node.parent) && node === node.parent.name) {
          return 7;
        } else if (isInRightSideOfInternalImportEqualsDeclaration(node)) {
          return getMeaningFromRightHandSideOfImportEquals(node);
        } else if (ts3.isDeclarationName(node)) {
          return getMeaningFromDeclaration(node.parent);
        } else if (ts3.isEntityName(node) && (ts3.isJSDocNameReference(node.parent) || ts3.isJSDocLink(node.parent))) {
          return 7;
        } else if (isTypeReference(node)) {
          return 2;
        } else if (isNamespaceReference(node)) {
          return 4;
        } else if (ts3.isTypeParameterDeclaration(node.parent)) {
          ts3.Debug.assert(ts3.isJSDocTemplateTag(node.parent.parent));
          return 2;
        } else if (ts3.isLiteralTypeNode(node.parent)) {
          return 2 | 1;
        } else {
          return 1;
        }
      }
      ts3.getMeaningFromLocation = getMeaningFromLocation;
      function getMeaningFromRightHandSideOfImportEquals(node) {
        var name = node.kind === 158 ? node : ts3.isQualifiedName(node.parent) && node.parent.right === node ? node.parent : void 0;
        return name && name.parent.kind === 261 ? 7 : 4;
      }
      function isInRightSideOfInternalImportEqualsDeclaration(node) {
        while (node.parent.kind === 158) {
          node = node.parent;
        }
        return ts3.isInternalModuleImportEqualsDeclaration(node.parent) && node.parent.moduleReference === node;
      }
      ts3.isInRightSideOfInternalImportEqualsDeclaration = isInRightSideOfInternalImportEqualsDeclaration;
      function isNamespaceReference(node) {
        return isQualifiedNameNamespaceReference(node) || isPropertyAccessNamespaceReference(node);
      }
      function isQualifiedNameNamespaceReference(node) {
        var root = node;
        var isLastClause = true;
        if (root.parent.kind === 158) {
          while (root.parent && root.parent.kind === 158) {
            root = root.parent;
          }
          isLastClause = root.right === node;
        }
        return root.parent.kind === 174 && !isLastClause;
      }
      function isPropertyAccessNamespaceReference(node) {
        var root = node;
        var isLastClause = true;
        if (root.parent.kind === 202) {
          while (root.parent && root.parent.kind === 202) {
            root = root.parent;
          }
          isLastClause = root.name === node;
        }
        if (!isLastClause && root.parent.kind === 224 && root.parent.parent.kind === 287) {
          var decl = root.parent.parent.parent;
          return decl.kind === 253 && root.parent.parent.token === 116 || decl.kind === 254 && root.parent.parent.token === 93;
        }
        return false;
      }
      function isTypeReference(node) {
        if (ts3.isRightSideOfQualifiedNameOrPropertyAccess(node)) {
          node = node.parent;
        }
        switch (node.kind) {
          case 107:
            return !ts3.isExpressionNode(node);
          case 188:
            return true;
        }
        switch (node.parent.kind) {
          case 174:
            return true;
          case 196:
            return !node.parent.isTypeOf;
          case 224:
            return !ts3.isExpressionWithTypeArgumentsInClassExtendsClause(node.parent);
        }
        return false;
      }
      function isCallExpressionTarget(node, includeElementAccess, skipPastOuterExpressions) {
        if (includeElementAccess === void 0) {
          includeElementAccess = false;
        }
        if (skipPastOuterExpressions === void 0) {
          skipPastOuterExpressions = false;
        }
        return isCalleeWorker(node, ts3.isCallExpression, selectExpressionOfCallOrNewExpressionOrDecorator, includeElementAccess, skipPastOuterExpressions);
      }
      ts3.isCallExpressionTarget = isCallExpressionTarget;
      function isNewExpressionTarget(node, includeElementAccess, skipPastOuterExpressions) {
        if (includeElementAccess === void 0) {
          includeElementAccess = false;
        }
        if (skipPastOuterExpressions === void 0) {
          skipPastOuterExpressions = false;
        }
        return isCalleeWorker(node, ts3.isNewExpression, selectExpressionOfCallOrNewExpressionOrDecorator, includeElementAccess, skipPastOuterExpressions);
      }
      ts3.isNewExpressionTarget = isNewExpressionTarget;
      function isCallOrNewExpressionTarget(node, includeElementAccess, skipPastOuterExpressions) {
        if (includeElementAccess === void 0) {
          includeElementAccess = false;
        }
        if (skipPastOuterExpressions === void 0) {
          skipPastOuterExpressions = false;
        }
        return isCalleeWorker(node, ts3.isCallOrNewExpression, selectExpressionOfCallOrNewExpressionOrDecorator, includeElementAccess, skipPastOuterExpressions);
      }
      ts3.isCallOrNewExpressionTarget = isCallOrNewExpressionTarget;
      function isTaggedTemplateTag(node, includeElementAccess, skipPastOuterExpressions) {
        if (includeElementAccess === void 0) {
          includeElementAccess = false;
        }
        if (skipPastOuterExpressions === void 0) {
          skipPastOuterExpressions = false;
        }
        return isCalleeWorker(node, ts3.isTaggedTemplateExpression, selectTagOfTaggedTemplateExpression, includeElementAccess, skipPastOuterExpressions);
      }
      ts3.isTaggedTemplateTag = isTaggedTemplateTag;
      function isDecoratorTarget(node, includeElementAccess, skipPastOuterExpressions) {
        if (includeElementAccess === void 0) {
          includeElementAccess = false;
        }
        if (skipPastOuterExpressions === void 0) {
          skipPastOuterExpressions = false;
        }
        return isCalleeWorker(node, ts3.isDecorator, selectExpressionOfCallOrNewExpressionOrDecorator, includeElementAccess, skipPastOuterExpressions);
      }
      ts3.isDecoratorTarget = isDecoratorTarget;
      function isJsxOpeningLikeElementTagName(node, includeElementAccess, skipPastOuterExpressions) {
        if (includeElementAccess === void 0) {
          includeElementAccess = false;
        }
        if (skipPastOuterExpressions === void 0) {
          skipPastOuterExpressions = false;
        }
        return isCalleeWorker(node, ts3.isJsxOpeningLikeElement, selectTagNameOfJsxOpeningLikeElement, includeElementAccess, skipPastOuterExpressions);
      }
      ts3.isJsxOpeningLikeElementTagName = isJsxOpeningLikeElementTagName;
      function selectExpressionOfCallOrNewExpressionOrDecorator(node) {
        return node.expression;
      }
      function selectTagOfTaggedTemplateExpression(node) {
        return node.tag;
      }
      function selectTagNameOfJsxOpeningLikeElement(node) {
        return node.tagName;
      }
      function isCalleeWorker(node, pred, calleeSelector, includeElementAccess, skipPastOuterExpressions) {
        var target = includeElementAccess ? climbPastPropertyOrElementAccess(node) : climbPastPropertyAccess(node);
        if (skipPastOuterExpressions) {
          target = ts3.skipOuterExpressions(target);
        }
        return !!target && !!target.parent && pred(target.parent) && calleeSelector(target.parent) === target;
      }
      function climbPastPropertyAccess(node) {
        return isRightSideOfPropertyAccess(node) ? node.parent : node;
      }
      ts3.climbPastPropertyAccess = climbPastPropertyAccess;
      function climbPastPropertyOrElementAccess(node) {
        return isRightSideOfPropertyAccess(node) || isArgumentExpressionOfElementAccess(node) ? node.parent : node;
      }
      ts3.climbPastPropertyOrElementAccess = climbPastPropertyOrElementAccess;
      function getTargetLabel(referenceNode, labelName) {
        while (referenceNode) {
          if (referenceNode.kind === 246 && referenceNode.label.escapedText === labelName) {
            return referenceNode.label;
          }
          referenceNode = referenceNode.parent;
        }
        return void 0;
      }
      ts3.getTargetLabel = getTargetLabel;
      function hasPropertyAccessExpressionWithName(node, funcName) {
        if (!ts3.isPropertyAccessExpression(node.expression)) {
          return false;
        }
        return node.expression.name.text === funcName;
      }
      ts3.hasPropertyAccessExpressionWithName = hasPropertyAccessExpressionWithName;
      function isJumpStatementTarget(node) {
        var _a2;
        return ts3.isIdentifier(node) && ((_a2 = ts3.tryCast(node.parent, ts3.isBreakOrContinueStatement)) === null || _a2 === void 0 ? void 0 : _a2.label) === node;
      }
      ts3.isJumpStatementTarget = isJumpStatementTarget;
      function isLabelOfLabeledStatement(node) {
        var _a2;
        return ts3.isIdentifier(node) && ((_a2 = ts3.tryCast(node.parent, ts3.isLabeledStatement)) === null || _a2 === void 0 ? void 0 : _a2.label) === node;
      }
      ts3.isLabelOfLabeledStatement = isLabelOfLabeledStatement;
      function isLabelName(node) {
        return isLabelOfLabeledStatement(node) || isJumpStatementTarget(node);
      }
      ts3.isLabelName = isLabelName;
      function isTagName(node) {
        var _a2;
        return ((_a2 = ts3.tryCast(node.parent, ts3.isJSDocTag)) === null || _a2 === void 0 ? void 0 : _a2.tagName) === node;
      }
      ts3.isTagName = isTagName;
      function isRightSideOfQualifiedName(node) {
        var _a2;
        return ((_a2 = ts3.tryCast(node.parent, ts3.isQualifiedName)) === null || _a2 === void 0 ? void 0 : _a2.right) === node;
      }
      ts3.isRightSideOfQualifiedName = isRightSideOfQualifiedName;
      function isRightSideOfPropertyAccess(node) {
        var _a2;
        return ((_a2 = ts3.tryCast(node.parent, ts3.isPropertyAccessExpression)) === null || _a2 === void 0 ? void 0 : _a2.name) === node;
      }
      ts3.isRightSideOfPropertyAccess = isRightSideOfPropertyAccess;
      function isArgumentExpressionOfElementAccess(node) {
        var _a2;
        return ((_a2 = ts3.tryCast(node.parent, ts3.isElementAccessExpression)) === null || _a2 === void 0 ? void 0 : _a2.argumentExpression) === node;
      }
      ts3.isArgumentExpressionOfElementAccess = isArgumentExpressionOfElementAccess;
      function isNameOfModuleDeclaration(node) {
        var _a2;
        return ((_a2 = ts3.tryCast(node.parent, ts3.isModuleDeclaration)) === null || _a2 === void 0 ? void 0 : _a2.name) === node;
      }
      ts3.isNameOfModuleDeclaration = isNameOfModuleDeclaration;
      function isNameOfFunctionDeclaration(node) {
        var _a2;
        return ts3.isIdentifier(node) && ((_a2 = ts3.tryCast(node.parent, ts3.isFunctionLike)) === null || _a2 === void 0 ? void 0 : _a2.name) === node;
      }
      ts3.isNameOfFunctionDeclaration = isNameOfFunctionDeclaration;
      function isLiteralNameOfPropertyDeclarationOrIndexAccess(node) {
        switch (node.parent.kind) {
          case 164:
          case 163:
          case 289:
          case 292:
          case 166:
          case 165:
          case 168:
          case 169:
          case 257:
            return ts3.getNameOfDeclaration(node.parent) === node;
          case 203:
            return node.parent.argumentExpression === node;
          case 159:
            return true;
          case 192:
            return node.parent.parent.kind === 190;
          default:
            return false;
        }
      }
      ts3.isLiteralNameOfPropertyDeclarationOrIndexAccess = isLiteralNameOfPropertyDeclarationOrIndexAccess;
      function isExpressionOfExternalModuleImportEqualsDeclaration(node) {
        return ts3.isExternalModuleImportEqualsDeclaration(node.parent.parent) && ts3.getExternalModuleImportEqualsDeclarationExpression(node.parent.parent) === node;
      }
      ts3.isExpressionOfExternalModuleImportEqualsDeclaration = isExpressionOfExternalModuleImportEqualsDeclaration;
      function getContainerNode(node) {
        if (ts3.isJSDocTypeAlias(node)) {
          node = node.parent.parent;
        }
        while (true) {
          node = node.parent;
          if (!node) {
            return void 0;
          }
          switch (node.kind) {
            case 298:
            case 166:
            case 165:
            case 252:
            case 209:
            case 168:
            case 169:
            case 253:
            case 254:
            case 256:
            case 257:
              return node;
          }
        }
      }
      ts3.getContainerNode = getContainerNode;
      function getNodeKind(node) {
        switch (node.kind) {
          case 298:
            return ts3.isExternalModule(node) ? "module" : "script";
          case 257:
            return "module";
          case 253:
          case 222:
            return "class";
          case 254:
            return "interface";
          case 255:
          case 328:
          case 335:
            return "type";
          case 256:
            return "enum";
          case 250:
            return getKindOfVariableDeclaration(node);
          case 199:
            return getKindOfVariableDeclaration(ts3.getRootDeclaration(node));
          case 210:
          case 252:
          case 209:
            return "function";
          case 168:
            return "getter";
          case 169:
            return "setter";
          case 166:
          case 165:
            return "method";
          case 289:
            var initializer = node.initializer;
            return ts3.isFunctionLike(initializer) ? "method" : "property";
          case 164:
          case 163:
          case 290:
          case 291:
            return "property";
          case 172:
            return "index";
          case 171:
            return "construct";
          case 170:
            return "call";
          case 167:
            return "constructor";
          case 160:
            return "type parameter";
          case 292:
            return "enum member";
          case 161:
            return ts3.hasSyntacticModifier(node, 16476) ? "property" : "parameter";
          case 261:
          case 266:
          case 271:
          case 264:
          case 270:
            return "alias";
          case 217:
            var kind = ts3.getAssignmentDeclarationKind(node);
            var right = node.right;
            switch (kind) {
              case 7:
              case 8:
              case 9:
              case 0:
                return "";
              case 1:
              case 2:
                var rightKind = getNodeKind(right);
                return rightKind === "" ? "const" : rightKind;
              case 3:
                return ts3.isFunctionExpression(right) ? "method" : "property";
              case 4:
                return "property";
              case 5:
                return ts3.isFunctionExpression(right) ? "method" : "property";
              case 6:
                return "local class";
              default: {
                ts3.assertType(kind);
                return "";
              }
            }
          case 78:
            return ts3.isImportClause(node.parent) ? "alias" : "";
          case 267:
            var scriptKind = getNodeKind(node.expression);
            return scriptKind === "" ? "const" : scriptKind;
          default:
            return "";
        }
        function getKindOfVariableDeclaration(v) {
          return ts3.isVarConst(v) ? "const" : ts3.isLet(v) ? "let" : "var";
        }
      }
      ts3.getNodeKind = getNodeKind;
      function isThis(node) {
        switch (node.kind) {
          case 107:
            return true;
          case 78:
            return ts3.identifierIsThisKeyword(node) && node.parent.kind === 161;
          default:
            return false;
        }
      }
      ts3.isThis = isThis;
      var tripleSlashDirectivePrefixRegex = /^\/\/\/\s*</;
      function getLineStartPositionForPosition(position, sourceFile) {
        var lineStarts = ts3.getLineStarts(sourceFile);
        var line = sourceFile.getLineAndCharacterOfPosition(position).line;
        return lineStarts[line];
      }
      ts3.getLineStartPositionForPosition = getLineStartPositionForPosition;
      function rangeContainsRange(r1, r2) {
        return startEndContainsRange(r1.pos, r1.end, r2);
      }
      ts3.rangeContainsRange = rangeContainsRange;
      function rangeContainsRangeExclusive(r1, r2) {
        return rangeContainsPositionExclusive(r1, r2.pos) && rangeContainsPositionExclusive(r1, r2.end);
      }
      ts3.rangeContainsRangeExclusive = rangeContainsRangeExclusive;
      function rangeContainsPosition(r2, pos) {
        return r2.pos <= pos && pos <= r2.end;
      }
      ts3.rangeContainsPosition = rangeContainsPosition;
      function rangeContainsPositionExclusive(r2, pos) {
        return r2.pos < pos && pos < r2.end;
      }
      ts3.rangeContainsPositionExclusive = rangeContainsPositionExclusive;
      function startEndContainsRange(start, end, range) {
        return start <= range.pos && end >= range.end;
      }
      ts3.startEndContainsRange = startEndContainsRange;
      function rangeContainsStartEnd(range, start, end) {
        return range.pos <= start && range.end >= end;
      }
      ts3.rangeContainsStartEnd = rangeContainsStartEnd;
      function rangeOverlapsWithStartEnd(r1, start, end) {
        return startEndOverlapsWithStartEnd(r1.pos, r1.end, start, end);
      }
      ts3.rangeOverlapsWithStartEnd = rangeOverlapsWithStartEnd;
      function nodeOverlapsWithStartEnd(node, sourceFile, start, end) {
        return startEndOverlapsWithStartEnd(node.getStart(sourceFile), node.end, start, end);
      }
      ts3.nodeOverlapsWithStartEnd = nodeOverlapsWithStartEnd;
      function startEndOverlapsWithStartEnd(start1, end1, start2, end2) {
        var start = Math.max(start1, start2);
        var end = Math.min(end1, end2);
        return start < end;
      }
      ts3.startEndOverlapsWithStartEnd = startEndOverlapsWithStartEnd;
      function positionBelongsToNode(candidate, position, sourceFile) {
        ts3.Debug.assert(candidate.pos <= position);
        return position < candidate.end || !isCompletedNode(candidate, sourceFile);
      }
      ts3.positionBelongsToNode = positionBelongsToNode;
      function isCompletedNode(n2, sourceFile) {
        if (n2 === void 0 || ts3.nodeIsMissing(n2)) {
          return false;
        }
        switch (n2.kind) {
          case 253:
          case 254:
          case 256:
          case 201:
          case 197:
          case 178:
          case 231:
          case 258:
          case 259:
          case 265:
          case 269:
            return nodeEndsWith(n2, 19, sourceFile);
          case 288:
            return isCompletedNode(n2.block, sourceFile);
          case 205:
            if (!n2.arguments) {
              return true;
            }
          case 204:
          case 208:
          case 187:
            return nodeEndsWith(n2, 21, sourceFile);
          case 175:
          case 176:
            return isCompletedNode(n2.type, sourceFile);
          case 167:
          case 168:
          case 169:
          case 252:
          case 209:
          case 166:
          case 165:
          case 171:
          case 170:
          case 210:
            if (n2.body) {
              return isCompletedNode(n2.body, sourceFile);
            }
            if (n2.type) {
              return isCompletedNode(n2.type, sourceFile);
            }
            return hasChildOfKind(n2, 21, sourceFile);
          case 257:
            return !!n2.body && isCompletedNode(n2.body, sourceFile);
          case 235:
            if (n2.elseStatement) {
              return isCompletedNode(n2.elseStatement, sourceFile);
            }
            return isCompletedNode(n2.thenStatement, sourceFile);
          case 234:
            return isCompletedNode(n2.expression, sourceFile) || hasChildOfKind(n2, 26, sourceFile);
          case 200:
          case 198:
          case 203:
          case 159:
          case 180:
            return nodeEndsWith(n2, 23, sourceFile);
          case 172:
            if (n2.type) {
              return isCompletedNode(n2.type, sourceFile);
            }
            return hasChildOfKind(n2, 23, sourceFile);
          case 285:
          case 286:
            return false;
          case 238:
          case 239:
          case 240:
          case 237:
            return isCompletedNode(n2.statement, sourceFile);
          case 236:
            return hasChildOfKind(n2, 114, sourceFile) ? nodeEndsWith(n2, 21, sourceFile) : isCompletedNode(n2.statement, sourceFile);
          case 177:
            return isCompletedNode(n2.exprName, sourceFile);
          case 212:
          case 211:
          case 213:
          case 220:
          case 221:
            var unaryWordExpression = n2;
            return isCompletedNode(unaryWordExpression.expression, sourceFile);
          case 206:
            return isCompletedNode(n2.template, sourceFile);
          case 219:
            var lastSpan = ts3.lastOrUndefined(n2.templateSpans);
            return isCompletedNode(lastSpan, sourceFile);
          case 229:
            return ts3.nodeIsPresent(n2.literal);
          case 268:
          case 262:
            return ts3.nodeIsPresent(n2.moduleSpecifier);
          case 215:
            return isCompletedNode(n2.operand, sourceFile);
          case 217:
            return isCompletedNode(n2.right, sourceFile);
          case 218:
            return isCompletedNode(n2.whenFalse, sourceFile);
          default:
            return true;
        }
      }
      function nodeEndsWith(n2, expectedLastToken, sourceFile) {
        var children = n2.getChildren(sourceFile);
        if (children.length) {
          var lastChild = ts3.last(children);
          if (lastChild.kind === expectedLastToken) {
            return true;
          } else if (lastChild.kind === 26 && children.length !== 1) {
            return children[children.length - 2].kind === expectedLastToken;
          }
        }
        return false;
      }
      function findListItemInfo(node) {
        var list = findContainingList(node);
        if (!list) {
          return void 0;
        }
        var children = list.getChildren();
        var listItemIndex = ts3.indexOfNode(children, node);
        return {
          listItemIndex,
          list
        };
      }
      ts3.findListItemInfo = findListItemInfo;
      function hasChildOfKind(n2, kind, sourceFile) {
        return !!findChildOfKind(n2, kind, sourceFile);
      }
      ts3.hasChildOfKind = hasChildOfKind;
      function findChildOfKind(n2, kind, sourceFile) {
        return ts3.find(n2.getChildren(sourceFile), function(c2) {
          return c2.kind === kind;
        });
      }
      ts3.findChildOfKind = findChildOfKind;
      function findContainingList(node) {
        var syntaxList = ts3.find(node.parent.getChildren(), function(c2) {
          return ts3.isSyntaxList(c2) && rangeContainsRange(c2, node);
        });
        ts3.Debug.assert(!syntaxList || ts3.contains(syntaxList.getChildren(), node));
        return syntaxList;
      }
      ts3.findContainingList = findContainingList;
      function isDefaultModifier(node) {
        return node.kind === 87;
      }
      function isClassKeyword(node) {
        return node.kind === 83;
      }
      function isFunctionKeyword(node) {
        return node.kind === 97;
      }
      function getAdjustedLocationForClass(node) {
        if (ts3.isNamedDeclaration(node)) {
          return node.name;
        }
        if (ts3.isClassDeclaration(node)) {
          var defaultModifier = ts3.find(node.modifiers, isDefaultModifier);
          if (defaultModifier)
            return defaultModifier;
        }
        if (ts3.isClassExpression(node)) {
          var classKeyword = ts3.find(node.getChildren(), isClassKeyword);
          if (classKeyword)
            return classKeyword;
        }
      }
      function getAdjustedLocationForFunction(node) {
        if (ts3.isNamedDeclaration(node)) {
          return node.name;
        }
        if (ts3.isFunctionDeclaration(node)) {
          var defaultModifier = ts3.find(node.modifiers, isDefaultModifier);
          if (defaultModifier)
            return defaultModifier;
        }
        if (ts3.isFunctionExpression(node)) {
          var functionKeyword = ts3.find(node.getChildren(), isFunctionKeyword);
          if (functionKeyword)
            return functionKeyword;
        }
      }
      function getAncestorTypeNode(node) {
        var lastTypeNode;
        ts3.findAncestor(node, function(a2) {
          if (ts3.isTypeNode(a2)) {
            lastTypeNode = a2;
          }
          return !ts3.isQualifiedName(a2.parent) && !ts3.isTypeNode(a2.parent) && !ts3.isTypeElement(a2.parent);
        });
        return lastTypeNode;
      }
      function getContextualTypeOrAncestorTypeNodeType(node, checker) {
        var contextualType = checker.getContextualType(node);
        if (contextualType) {
          return contextualType;
        }
        var ancestorTypeNode = getAncestorTypeNode(node);
        return ancestorTypeNode && checker.getTypeAtLocation(ancestorTypeNode);
      }
      ts3.getContextualTypeOrAncestorTypeNodeType = getContextualTypeOrAncestorTypeNodeType;
      function getAdjustedLocationForDeclaration(node, forRename) {
        if (!forRename) {
          switch (node.kind) {
            case 253:
            case 222:
              return getAdjustedLocationForClass(node);
            case 252:
            case 209:
              return getAdjustedLocationForFunction(node);
          }
        }
        if (ts3.isNamedDeclaration(node)) {
          return node.name;
        }
      }
      function getAdjustedLocationForImportDeclaration(node, forRename) {
        if (node.importClause) {
          if (node.importClause.name && node.importClause.namedBindings) {
            return;
          }
          if (node.importClause.name) {
            return node.importClause.name;
          }
          if (node.importClause.namedBindings) {
            if (ts3.isNamedImports(node.importClause.namedBindings)) {
              var onlyBinding = ts3.singleOrUndefined(node.importClause.namedBindings.elements);
              if (!onlyBinding) {
                return;
              }
              return onlyBinding.name;
            } else if (ts3.isNamespaceImport(node.importClause.namedBindings)) {
              return node.importClause.namedBindings.name;
            }
          }
        }
        if (!forRename) {
          return node.moduleSpecifier;
        }
      }
      function getAdjustedLocationForExportDeclaration(node, forRename) {
        if (node.exportClause) {
          if (ts3.isNamedExports(node.exportClause)) {
            var onlyBinding = ts3.singleOrUndefined(node.exportClause.elements);
            if (!onlyBinding) {
              return;
            }
            return node.exportClause.elements[0].name;
          } else if (ts3.isNamespaceExport(node.exportClause)) {
            return node.exportClause.name;
          }
        }
        if (!forRename) {
          return node.moduleSpecifier;
        }
      }
      function getAdjustedLocationForHeritageClause(node) {
        if (node.types.length === 1) {
          return node.types[0].expression;
        }
      }
      function getAdjustedLocation(node, forRename) {
        var parent = node.parent;
        if (ts3.isModifier(node) && (forRename || node.kind !== 87) ? ts3.contains(parent.modifiers, node) : node.kind === 83 ? ts3.isClassDeclaration(parent) || ts3.isClassExpression(node) : node.kind === 97 ? ts3.isFunctionDeclaration(parent) || ts3.isFunctionExpression(node) : node.kind === 117 ? ts3.isInterfaceDeclaration(parent) : node.kind === 91 ? ts3.isEnumDeclaration(parent) : node.kind === 149 ? ts3.isTypeAliasDeclaration(parent) : node.kind === 140 || node.kind === 139 ? ts3.isModuleDeclaration(parent) : node.kind === 99 ? ts3.isImportEqualsDeclaration(parent) : node.kind === 134 ? ts3.isGetAccessorDeclaration(parent) : node.kind === 146 && ts3.isSetAccessorDeclaration(parent)) {
          var location = getAdjustedLocationForDeclaration(parent, forRename);
          if (location) {
            return location;
          }
        }
        if ((node.kind === 112 || node.kind === 84 || node.kind === 118) && ts3.isVariableDeclarationList(parent) && parent.declarations.length === 1) {
          var decl = parent.declarations[0];
          if (ts3.isIdentifier(decl.name)) {
            return decl.name;
          }
        }
        if (node.kind === 149) {
          if (ts3.isImportClause(parent) && parent.isTypeOnly) {
            var location = getAdjustedLocationForImportDeclaration(parent.parent, forRename);
            if (location) {
              return location;
            }
          }
          if (ts3.isExportDeclaration(parent) && parent.isTypeOnly) {
            var location = getAdjustedLocationForExportDeclaration(parent, forRename);
            if (location) {
              return location;
            }
          }
        }
        if (node.kind === 126) {
          if (ts3.isImportSpecifier(parent) && parent.propertyName || ts3.isExportSpecifier(parent) && parent.propertyName || ts3.isNamespaceImport(parent) || ts3.isNamespaceExport(parent)) {
            return parent.name;
          }
          if (ts3.isExportDeclaration(parent) && parent.exportClause && ts3.isNamespaceExport(parent.exportClause)) {
            return parent.exportClause.name;
          }
        }
        if (node.kind === 99 && ts3.isImportDeclaration(parent)) {
          var location = getAdjustedLocationForImportDeclaration(parent, forRename);
          if (location) {
            return location;
          }
        }
        if (node.kind === 92) {
          if (ts3.isExportDeclaration(parent)) {
            var location = getAdjustedLocationForExportDeclaration(parent, forRename);
            if (location) {
              return location;
            }
          }
          if (ts3.isExportAssignment(parent)) {
            return ts3.skipOuterExpressions(parent.expression);
          }
        }
        if (node.kind === 143 && ts3.isExternalModuleReference(parent)) {
          return parent.expression;
        }
        if (node.kind === 153 && (ts3.isImportDeclaration(parent) || ts3.isExportDeclaration(parent)) && parent.moduleSpecifier) {
          return parent.moduleSpecifier;
        }
        if ((node.kind === 93 || node.kind === 116) && ts3.isHeritageClause(parent) && parent.token === node.kind) {
          var location = getAdjustedLocationForHeritageClause(parent);
          if (location) {
            return location;
          }
        }
        if (node.kind === 93) {
          if (ts3.isTypeParameterDeclaration(parent) && parent.constraint && ts3.isTypeReferenceNode(parent.constraint)) {
            return parent.constraint.typeName;
          }
          if (ts3.isConditionalTypeNode(parent) && ts3.isTypeReferenceNode(parent.extendsType)) {
            return parent.extendsType.typeName;
          }
        }
        if (node.kind === 135 && ts3.isInferTypeNode(parent)) {
          return parent.typeParameter.name;
        }
        if (node.kind === 100 && ts3.isTypeParameterDeclaration(parent) && ts3.isMappedTypeNode(parent.parent)) {
          return parent.name;
        }
        if (node.kind === 138 && ts3.isTypeOperatorNode(parent) && parent.operator === 138 && ts3.isTypeReferenceNode(parent.type)) {
          return parent.type.typeName;
        }
        if (node.kind === 142 && ts3.isTypeOperatorNode(parent) && parent.operator === 142 && ts3.isArrayTypeNode(parent.type) && ts3.isTypeReferenceNode(parent.type.elementType)) {
          return parent.type.elementType.typeName;
        }
        if (!forRename) {
          if (node.kind === 102 && ts3.isNewExpression(parent) || node.kind === 113 && ts3.isVoidExpression(parent) || node.kind === 111 && ts3.isTypeOfExpression(parent) || node.kind === 130 && ts3.isAwaitExpression(parent) || node.kind === 124 && ts3.isYieldExpression(parent) || node.kind === 88 && ts3.isDeleteExpression(parent)) {
            if (parent.expression) {
              return ts3.skipOuterExpressions(parent.expression);
            }
          }
          if ((node.kind === 100 || node.kind === 101) && ts3.isBinaryExpression(parent) && parent.operatorToken === node) {
            return ts3.skipOuterExpressions(parent.right);
          }
          if (node.kind === 126 && ts3.isAsExpression(parent) && ts3.isTypeReferenceNode(parent.type)) {
            return parent.type.typeName;
          }
          if (node.kind === 100 && ts3.isForInStatement(parent) || node.kind === 157 && ts3.isForOfStatement(parent)) {
            return ts3.skipOuterExpressions(parent.expression);
          }
        }
        return node;
      }
      function getAdjustedReferenceLocation(node) {
        return getAdjustedLocation(node, false);
      }
      ts3.getAdjustedReferenceLocation = getAdjustedReferenceLocation;
      function getAdjustedRenameLocation(node) {
        return getAdjustedLocation(node, true);
      }
      ts3.getAdjustedRenameLocation = getAdjustedRenameLocation;
      function getTouchingPropertyName(sourceFile, position) {
        return getTouchingToken(sourceFile, position, function(n2) {
          return ts3.isPropertyNameLiteral(n2) || ts3.isKeyword(n2.kind) || ts3.isPrivateIdentifier(n2);
        });
      }
      ts3.getTouchingPropertyName = getTouchingPropertyName;
      function getTouchingToken(sourceFile, position, includePrecedingTokenAtEndPosition) {
        return getTokenAtPositionWorker(sourceFile, position, false, includePrecedingTokenAtEndPosition, false);
      }
      ts3.getTouchingToken = getTouchingToken;
      function getTokenAtPosition(sourceFile, position) {
        return getTokenAtPositionWorker(sourceFile, position, true, void 0, false);
      }
      ts3.getTokenAtPosition = getTokenAtPosition;
      function getTokenAtPositionWorker(sourceFile, position, allowPositionInLeadingTrivia, includePrecedingTokenAtEndPosition, includeEndPosition) {
        var current = sourceFile;
        outer:
          while (true) {
            for (var _i = 0, _a2 = current.getChildren(sourceFile); _i < _a2.length; _i++) {
              var child = _a2[_i];
              var start = allowPositionInLeadingTrivia ? child.getFullStart() : child.getStart(sourceFile, true);
              if (start > position) {
                break;
              }
              var end = child.getEnd();
              if (position < end || position === end && (child.kind === 1 || includeEndPosition)) {
                current = child;
                continue outer;
              } else if (includePrecedingTokenAtEndPosition && end === position) {
                var previousToken = findPrecedingToken(position, sourceFile, child);
                if (previousToken && includePrecedingTokenAtEndPosition(previousToken)) {
                  return previousToken;
                }
              }
            }
            return current;
          }
      }
      function findFirstNonJsxWhitespaceToken(sourceFile, position) {
        var tokenAtPosition = getTokenAtPosition(sourceFile, position);
        while (isWhiteSpaceOnlyJsxText(tokenAtPosition)) {
          var nextToken = findNextToken(tokenAtPosition, tokenAtPosition.parent, sourceFile);
          if (!nextToken)
            return;
          tokenAtPosition = nextToken;
        }
        return tokenAtPosition;
      }
      ts3.findFirstNonJsxWhitespaceToken = findFirstNonJsxWhitespaceToken;
      function findTokenOnLeftOfPosition(file, position) {
        var tokenAtPosition = getTokenAtPosition(file, position);
        if (ts3.isToken(tokenAtPosition) && position > tokenAtPosition.getStart(file) && position < tokenAtPosition.getEnd()) {
          return tokenAtPosition;
        }
        return findPrecedingToken(position, file);
      }
      ts3.findTokenOnLeftOfPosition = findTokenOnLeftOfPosition;
      function findNextToken(previousToken, parent, sourceFile) {
        return find(parent);
        function find(n2) {
          if (ts3.isToken(n2) && n2.pos === previousToken.end) {
            return n2;
          }
          return ts3.firstDefined(n2.getChildren(sourceFile), function(child) {
            var shouldDiveInChildNode = child.pos <= previousToken.pos && child.end > previousToken.end || child.pos === previousToken.end;
            return shouldDiveInChildNode && nodeHasTokens(child, sourceFile) ? find(child) : void 0;
          });
        }
      }
      ts3.findNextToken = findNextToken;
      function findPrecedingToken(position, sourceFile, startNode, excludeJsdoc) {
        var result2 = find(startNode || sourceFile);
        ts3.Debug.assert(!(result2 && isWhiteSpaceOnlyJsxText(result2)));
        return result2;
        function find(n2) {
          if (isNonWhitespaceToken(n2) && n2.kind !== 1) {
            return n2;
          }
          var children = n2.getChildren(sourceFile);
          var i3 = ts3.binarySearchKey(children, position, function(_, i4) {
            return i4;
          }, function(middle, _) {
            if (position < children[middle].end) {
              if (!children[middle - 1] || position >= children[middle - 1].end) {
                return 0;
              }
              return 1;
            }
            return -1;
          });
          if (i3 >= 0 && children[i3]) {
            var child = children[i3];
            if (position < child.end) {
              var start = child.getStart(sourceFile, !excludeJsdoc);
              var lookInPreviousChild = start >= position || !nodeHasTokens(child, sourceFile) || isWhiteSpaceOnlyJsxText(child);
              if (lookInPreviousChild) {
                var candidate_1 = findRightmostChildNodeWithTokens(children, i3, sourceFile);
                return candidate_1 && findRightmostToken(candidate_1, sourceFile);
              } else {
                return find(child);
              }
            }
          }
          ts3.Debug.assert(startNode !== void 0 || n2.kind === 298 || n2.kind === 1 || ts3.isJSDocCommentContainingNode(n2));
          var candidate = findRightmostChildNodeWithTokens(children, children.length, sourceFile);
          return candidate && findRightmostToken(candidate, sourceFile);
        }
      }
      ts3.findPrecedingToken = findPrecedingToken;
      function isNonWhitespaceToken(n2) {
        return ts3.isToken(n2) && !isWhiteSpaceOnlyJsxText(n2);
      }
      function findRightmostToken(n2, sourceFile) {
        if (isNonWhitespaceToken(n2)) {
          return n2;
        }
        var children = n2.getChildren(sourceFile);
        if (children.length === 0) {
          return n2;
        }
        var candidate = findRightmostChildNodeWithTokens(children, children.length, sourceFile);
        return candidate && findRightmostToken(candidate, sourceFile);
      }
      function findRightmostChildNodeWithTokens(children, exclusiveStartPosition, sourceFile) {
        for (var i3 = exclusiveStartPosition - 1; i3 >= 0; i3--) {
          var child = children[i3];
          if (isWhiteSpaceOnlyJsxText(child)) {
            ts3.Debug.assert(i3 > 0, "`JsxText` tokens should not be the first child of `JsxElement | JsxSelfClosingElement`");
          } else if (nodeHasTokens(children[i3], sourceFile)) {
            return children[i3];
          }
        }
      }
      function isInString(sourceFile, position, previousToken) {
        if (previousToken === void 0) {
          previousToken = findPrecedingToken(position, sourceFile);
        }
        if (previousToken && ts3.isStringTextContainingNode(previousToken)) {
          var start = previousToken.getStart(sourceFile);
          var end = previousToken.getEnd();
          if (start < position && position < end) {
            return true;
          }
          if (position === end) {
            return !!previousToken.isUnterminated;
          }
        }
        return false;
      }
      ts3.isInString = isInString;
      function isInsideJsxElementOrAttribute(sourceFile, position) {
        var token = getTokenAtPosition(sourceFile, position);
        if (!token) {
          return false;
        }
        if (token.kind === 11) {
          return true;
        }
        if (token.kind === 29 && token.parent.kind === 11) {
          return true;
        }
        if (token.kind === 29 && token.parent.kind === 284) {
          return true;
        }
        if (token && token.kind === 19 && token.parent.kind === 284) {
          return true;
        }
        if (token.kind === 29 && token.parent.kind === 277) {
          return true;
        }
        return false;
      }
      ts3.isInsideJsxElementOrAttribute = isInsideJsxElementOrAttribute;
      function isWhiteSpaceOnlyJsxText(node) {
        return ts3.isJsxText(node) && node.containsOnlyTriviaWhiteSpaces;
      }
      function isInTemplateString(sourceFile, position) {
        var token = getTokenAtPosition(sourceFile, position);
        return ts3.isTemplateLiteralKind(token.kind) && position > token.getStart(sourceFile);
      }
      ts3.isInTemplateString = isInTemplateString;
      function isInJSXText(sourceFile, position) {
        var token = getTokenAtPosition(sourceFile, position);
        if (ts3.isJsxText(token)) {
          return true;
        }
        if (token.kind === 18 && ts3.isJsxExpression(token.parent) && ts3.isJsxElement(token.parent.parent)) {
          return true;
        }
        if (token.kind === 29 && ts3.isJsxOpeningLikeElement(token.parent) && ts3.isJsxElement(token.parent.parent)) {
          return true;
        }
        return false;
      }
      ts3.isInJSXText = isInJSXText;
      function isInsideJsxElement(sourceFile, position) {
        function isInsideJsxElementTraversal(node) {
          while (node) {
            if (node.kind >= 275 && node.kind <= 284 || node.kind === 11 || node.kind === 29 || node.kind === 31 || node.kind === 78 || node.kind === 19 || node.kind === 18 || node.kind === 43) {
              node = node.parent;
            } else if (node.kind === 274) {
              if (position > node.getStart(sourceFile))
                return true;
              node = node.parent;
            } else {
              return false;
            }
          }
          return false;
        }
        return isInsideJsxElementTraversal(getTokenAtPosition(sourceFile, position));
      }
      ts3.isInsideJsxElement = isInsideJsxElement;
      function findPrecedingMatchingToken(token, matchingTokenKind, sourceFile) {
        var closeTokenText = ts3.tokenToString(token.kind);
        var matchingTokenText = ts3.tokenToString(matchingTokenKind);
        var tokenFullStart = token.getFullStart();
        var bestGuessIndex = sourceFile.text.lastIndexOf(matchingTokenText, tokenFullStart);
        if (bestGuessIndex === -1) {
          return void 0;
        }
        if (sourceFile.text.lastIndexOf(closeTokenText, tokenFullStart - 1) < bestGuessIndex) {
          var nodeAtGuess = findPrecedingToken(bestGuessIndex + 1, sourceFile);
          if (nodeAtGuess && nodeAtGuess.kind === matchingTokenKind) {
            return nodeAtGuess;
          }
        }
        var tokenKind = token.kind;
        var remainingMatchingTokens = 0;
        while (true) {
          var preceding = findPrecedingToken(token.getFullStart(), sourceFile);
          if (!preceding) {
            return void 0;
          }
          token = preceding;
          if (token.kind === matchingTokenKind) {
            if (remainingMatchingTokens === 0) {
              return token;
            }
            remainingMatchingTokens--;
          } else if (token.kind === tokenKind) {
            remainingMatchingTokens++;
          }
        }
      }
      ts3.findPrecedingMatchingToken = findPrecedingMatchingToken;
      function removeOptionality(type3, isOptionalExpression, isOptionalChain) {
        return isOptionalExpression ? type3.getNonNullableType() : isOptionalChain ? type3.getNonOptionalType() : type3;
      }
      ts3.removeOptionality = removeOptionality;
      function isPossiblyTypeArgumentPosition(token, sourceFile, checker) {
        var info = getPossibleTypeArgumentsInfo(token, sourceFile);
        return info !== void 0 && (ts3.isPartOfTypeNode(info.called) || getPossibleGenericSignatures(info.called, info.nTypeArguments, checker).length !== 0 || isPossiblyTypeArgumentPosition(info.called, sourceFile, checker));
      }
      ts3.isPossiblyTypeArgumentPosition = isPossiblyTypeArgumentPosition;
      function getPossibleGenericSignatures(called, typeArgumentCount, checker) {
        var type3 = checker.getTypeAtLocation(called);
        if (ts3.isOptionalChain(called.parent)) {
          type3 = removeOptionality(type3, ts3.isOptionalChainRoot(called.parent), true);
        }
        var signatures = ts3.isNewExpression(called.parent) ? type3.getConstructSignatures() : type3.getCallSignatures();
        return signatures.filter(function(candidate) {
          return !!candidate.typeParameters && candidate.typeParameters.length >= typeArgumentCount;
        });
      }
      ts3.getPossibleGenericSignatures = getPossibleGenericSignatures;
      function getPossibleTypeArgumentsInfo(tokenIn, sourceFile) {
        if (sourceFile.text.lastIndexOf("<", tokenIn ? tokenIn.pos : sourceFile.text.length) === -1) {
          return void 0;
        }
        var token = tokenIn;
        var remainingLessThanTokens = 0;
        var nTypeArguments = 0;
        while (token) {
          switch (token.kind) {
            case 29:
              token = findPrecedingToken(token.getFullStart(), sourceFile);
              if (token && token.kind === 28) {
                token = findPrecedingToken(token.getFullStart(), sourceFile);
              }
              if (!token || !ts3.isIdentifier(token))
                return void 0;
              if (!remainingLessThanTokens) {
                return ts3.isDeclarationName(token) ? void 0 : { called: token, nTypeArguments };
              }
              remainingLessThanTokens--;
              break;
            case 49:
              remainingLessThanTokens = 3;
              break;
            case 48:
              remainingLessThanTokens = 2;
              break;
            case 31:
              remainingLessThanTokens++;
              break;
            case 19:
              token = findPrecedingMatchingToken(token, 18, sourceFile);
              if (!token)
                return void 0;
              break;
            case 21:
              token = findPrecedingMatchingToken(token, 20, sourceFile);
              if (!token)
                return void 0;
              break;
            case 23:
              token = findPrecedingMatchingToken(token, 22, sourceFile);
              if (!token)
                return void 0;
              break;
            case 27:
              nTypeArguments++;
              break;
            case 38:
            case 78:
            case 10:
            case 8:
            case 9:
            case 109:
            case 94:
            case 111:
            case 93:
            case 138:
            case 24:
            case 51:
            case 57:
            case 58:
              break;
            default:
              if (ts3.isTypeNode(token)) {
                break;
              }
              return void 0;
          }
          token = findPrecedingToken(token.getFullStart(), sourceFile);
        }
        return void 0;
      }
      ts3.getPossibleTypeArgumentsInfo = getPossibleTypeArgumentsInfo;
      function isInComment(sourceFile, position, tokenAtPosition) {
        return ts3.formatting.getRangeOfEnclosingComment(sourceFile, position, void 0, tokenAtPosition);
      }
      ts3.isInComment = isInComment;
      function hasDocComment(sourceFile, position) {
        var token = getTokenAtPosition(sourceFile, position);
        return !!ts3.findAncestor(token, ts3.isJSDoc);
      }
      ts3.hasDocComment = hasDocComment;
      function nodeHasTokens(n2, sourceFile) {
        return n2.kind === 1 ? !!n2.jsDoc : n2.getWidth(sourceFile) !== 0;
      }
      function getNodeModifiers(node, excludeFlags) {
        if (excludeFlags === void 0) {
          excludeFlags = 0;
        }
        var result2 = [];
        var flags = ts3.isDeclaration(node) ? ts3.getCombinedNodeFlagsAlwaysIncludeJSDoc(node) & ~excludeFlags : 0;
        if (flags & 8)
          result2.push("private");
        if (flags & 16)
          result2.push("protected");
        if (flags & 4)
          result2.push("public");
        if (flags & 32)
          result2.push("static");
        if (flags & 128)
          result2.push("abstract");
        if (flags & 1)
          result2.push("export");
        if (flags & 8192)
          result2.push("deprecated");
        if (node.flags & 8388608)
          result2.push("declare");
        if (node.kind === 267)
          result2.push("export");
        return result2.length > 0 ? result2.join(",") : "";
      }
      ts3.getNodeModifiers = getNodeModifiers;
      function getTypeArgumentOrTypeParameterList(node) {
        if (node.kind === 174 || node.kind === 204) {
          return node.typeArguments;
        }
        if (ts3.isFunctionLike(node) || node.kind === 253 || node.kind === 254) {
          return node.typeParameters;
        }
        return void 0;
      }
      ts3.getTypeArgumentOrTypeParameterList = getTypeArgumentOrTypeParameterList;
      function isComment(kind) {
        return kind === 2 || kind === 3;
      }
      ts3.isComment = isComment;
      function isStringOrRegularExpressionOrTemplateLiteral(kind) {
        if (kind === 10 || kind === 13 || ts3.isTemplateLiteralKind(kind)) {
          return true;
        }
        return false;
      }
      ts3.isStringOrRegularExpressionOrTemplateLiteral = isStringOrRegularExpressionOrTemplateLiteral;
      function isPunctuation(kind) {
        return 18 <= kind && kind <= 77;
      }
      ts3.isPunctuation = isPunctuation;
      function isInsideTemplateLiteral(node, position, sourceFile) {
        return ts3.isTemplateLiteralKind(node.kind) && (node.getStart(sourceFile) < position && position < node.end) || !!node.isUnterminated && position === node.end;
      }
      ts3.isInsideTemplateLiteral = isInsideTemplateLiteral;
      function isAccessibilityModifier(kind) {
        switch (kind) {
          case 122:
          case 120:
          case 121:
            return true;
        }
        return false;
      }
      ts3.isAccessibilityModifier = isAccessibilityModifier;
      function cloneCompilerOptions(options) {
        var result2 = ts3.clone(options);
        ts3.setConfigFileInOptions(result2, options && options.configFile);
        return result2;
      }
      ts3.cloneCompilerOptions = cloneCompilerOptions;
      function isArrayLiteralOrObjectLiteralDestructuringPattern(node) {
        if (node.kind === 200 || node.kind === 201) {
          if (node.parent.kind === 217 && node.parent.left === node && node.parent.operatorToken.kind === 62) {
            return true;
          }
          if (node.parent.kind === 240 && node.parent.initializer === node) {
            return true;
          }
          if (isArrayLiteralOrObjectLiteralDestructuringPattern(node.parent.kind === 289 ? node.parent.parent : node.parent)) {
            return true;
          }
        }
        return false;
      }
      ts3.isArrayLiteralOrObjectLiteralDestructuringPattern = isArrayLiteralOrObjectLiteralDestructuringPattern;
      function isInReferenceComment(sourceFile, position) {
        return isInReferenceCommentWorker(sourceFile, position, true);
      }
      ts3.isInReferenceComment = isInReferenceComment;
      function isInNonReferenceComment(sourceFile, position) {
        return isInReferenceCommentWorker(sourceFile, position, false);
      }
      ts3.isInNonReferenceComment = isInNonReferenceComment;
      function isInReferenceCommentWorker(sourceFile, position, shouldBeReference) {
        var range = isInComment(sourceFile, position, void 0);
        return !!range && shouldBeReference === tripleSlashDirectivePrefixRegex.test(sourceFile.text.substring(range.pos, range.end));
      }
      function getReplacementSpanForContextToken(contextToken) {
        if (!contextToken)
          return void 0;
        switch (contextToken.kind) {
          case 10:
          case 14:
            return createTextSpanFromStringLiteralLikeContent(contextToken);
          default:
            return createTextSpanFromNode(contextToken);
        }
      }
      ts3.getReplacementSpanForContextToken = getReplacementSpanForContextToken;
      function createTextSpanFromNode(node, sourceFile, endNode) {
        return ts3.createTextSpanFromBounds(node.getStart(sourceFile), (endNode || node).getEnd());
      }
      ts3.createTextSpanFromNode = createTextSpanFromNode;
      function createTextSpanFromStringLiteralLikeContent(node) {
        if (node.isUnterminated)
          return void 0;
        return ts3.createTextSpanFromBounds(node.getStart() + 1, node.getEnd() - 1);
      }
      ts3.createTextSpanFromStringLiteralLikeContent = createTextSpanFromStringLiteralLikeContent;
      function createTextRangeFromNode(node, sourceFile) {
        return ts3.createRange(node.getStart(sourceFile), node.end);
      }
      ts3.createTextRangeFromNode = createTextRangeFromNode;
      function createTextSpanFromRange(range) {
        return ts3.createTextSpanFromBounds(range.pos, range.end);
      }
      ts3.createTextSpanFromRange = createTextSpanFromRange;
      function createTextRangeFromSpan(span) {
        return ts3.createRange(span.start, span.start + span.length);
      }
      ts3.createTextRangeFromSpan = createTextRangeFromSpan;
      function createTextChangeFromStartLength(start, length, newText) {
        return createTextChange(ts3.createTextSpan(start, length), newText);
      }
      ts3.createTextChangeFromStartLength = createTextChangeFromStartLength;
      function createTextChange(span, newText) {
        return { span, newText };
      }
      ts3.createTextChange = createTextChange;
      ts3.typeKeywords = [
        128,
        127,
        155,
        131,
        94,
        135,
        138,
        141,
        103,
        144,
        145,
        142,
        147,
        148,
        109,
        113,
        150,
        151,
        152
      ];
      function isTypeKeyword(kind) {
        return ts3.contains(ts3.typeKeywords, kind);
      }
      ts3.isTypeKeyword = isTypeKeyword;
      function isTypeKeywordToken(node) {
        return node.kind === 149;
      }
      ts3.isTypeKeywordToken = isTypeKeywordToken;
      function isExternalModuleSymbol(moduleSymbol) {
        return !!(moduleSymbol.flags & 1536) && moduleSymbol.name.charCodeAt(0) === 34;
      }
      ts3.isExternalModuleSymbol = isExternalModuleSymbol;
      function nodeSeenTracker() {
        var seen = [];
        return function(node) {
          var id = ts3.getNodeId(node);
          return !seen[id] && (seen[id] = true);
        };
      }
      ts3.nodeSeenTracker = nodeSeenTracker;
      function getSnapshotText(snap) {
        return snap.getText(0, snap.getLength());
      }
      ts3.getSnapshotText = getSnapshotText;
      function repeatString(str2, count) {
        var result2 = "";
        for (var i3 = 0; i3 < count; i3++) {
          result2 += str2;
        }
        return result2;
      }
      ts3.repeatString = repeatString;
      function skipConstraint(type3) {
        return type3.isTypeParameter() ? type3.getConstraint() || type3 : type3;
      }
      ts3.skipConstraint = skipConstraint;
      function getNameFromPropertyName(name) {
        return name.kind === 159 ? ts3.isStringOrNumericLiteralLike(name.expression) ? name.expression.text : void 0 : ts3.isPrivateIdentifier(name) ? ts3.idText(name) : ts3.getTextOfIdentifierOrLiteral(name);
      }
      ts3.getNameFromPropertyName = getNameFromPropertyName;
      function programContainsModules(program2) {
        return program2.getSourceFiles().some(function(s2) {
          return !s2.isDeclarationFile && !program2.isSourceFileFromExternalLibrary(s2) && !!(s2.externalModuleIndicator || s2.commonJsModuleIndicator);
        });
      }
      ts3.programContainsModules = programContainsModules;
      function programContainsEs6Modules(program2) {
        return program2.getSourceFiles().some(function(s2) {
          return !s2.isDeclarationFile && !program2.isSourceFileFromExternalLibrary(s2) && !!s2.externalModuleIndicator;
        });
      }
      ts3.programContainsEs6Modules = programContainsEs6Modules;
      function compilerOptionsIndicateEs6Modules(compilerOptions) {
        return !!compilerOptions.module || compilerOptions.target >= 2 || !!compilerOptions.noEmit;
      }
      ts3.compilerOptionsIndicateEs6Modules = compilerOptionsIndicateEs6Modules;
      function createModuleSpecifierResolutionHost(program2, host) {
        return {
          fileExists: function(fileName) {
            return program2.fileExists(fileName);
          },
          getCurrentDirectory: function() {
            return host.getCurrentDirectory();
          },
          readFile: ts3.maybeBind(host, host.readFile),
          useCaseSensitiveFileNames: ts3.maybeBind(host, host.useCaseSensitiveFileNames),
          getSymlinkCache: ts3.maybeBind(host, host.getSymlinkCache) || program2.getSymlinkCache,
          getModuleSpecifierCache: ts3.maybeBind(host, host.getModuleSpecifierCache),
          getGlobalTypingsCacheLocation: ts3.maybeBind(host, host.getGlobalTypingsCacheLocation),
          getSourceFiles: function() {
            return program2.getSourceFiles();
          },
          redirectTargetsMap: program2.redirectTargetsMap,
          getProjectReferenceRedirect: function(fileName) {
            return program2.getProjectReferenceRedirect(fileName);
          },
          isSourceOfProjectReferenceRedirect: function(fileName) {
            return program2.isSourceOfProjectReferenceRedirect(fileName);
          },
          getNearestAncestorDirectoryWithPackageJson: ts3.maybeBind(host, host.getNearestAncestorDirectoryWithPackageJson),
          getFileIncludeReasons: function() {
            return program2.getFileIncludeReasons();
          }
        };
      }
      ts3.createModuleSpecifierResolutionHost = createModuleSpecifierResolutionHost;
      function getModuleSpecifierResolverHost(program2, host) {
        return __assign(__assign({}, createModuleSpecifierResolutionHost(program2, host)), { getCommonSourceDirectory: function() {
          return program2.getCommonSourceDirectory();
        } });
      }
      ts3.getModuleSpecifierResolverHost = getModuleSpecifierResolverHost;
      function makeImportIfNecessary(defaultImport, namedImports, moduleSpecifier, quotePreference) {
        return defaultImport || namedImports && namedImports.length ? makeImport(defaultImport, namedImports, moduleSpecifier, quotePreference) : void 0;
      }
      ts3.makeImportIfNecessary = makeImportIfNecessary;
      function makeImport(defaultImport, namedImports, moduleSpecifier, quotePreference, isTypeOnly) {
        return ts3.factory.createImportDeclaration(void 0, void 0, defaultImport || namedImports ? ts3.factory.createImportClause(!!isTypeOnly, defaultImport, namedImports && namedImports.length ? ts3.factory.createNamedImports(namedImports) : void 0) : void 0, typeof moduleSpecifier === "string" ? makeStringLiteral(moduleSpecifier, quotePreference) : moduleSpecifier);
      }
      ts3.makeImport = makeImport;
      function makeStringLiteral(text, quotePreference) {
        return ts3.factory.createStringLiteral(text, quotePreference === 0);
      }
      ts3.makeStringLiteral = makeStringLiteral;
      var QuotePreference;
      (function(QuotePreference2) {
        QuotePreference2[QuotePreference2["Single"] = 0] = "Single";
        QuotePreference2[QuotePreference2["Double"] = 1] = "Double";
      })(QuotePreference = ts3.QuotePreference || (ts3.QuotePreference = {}));
      function quotePreferenceFromString(str2, sourceFile) {
        return ts3.isStringDoubleQuoted(str2, sourceFile) ? 1 : 0;
      }
      ts3.quotePreferenceFromString = quotePreferenceFromString;
      function getQuotePreference(sourceFile, preferences) {
        if (preferences.quotePreference && preferences.quotePreference !== "auto") {
          return preferences.quotePreference === "single" ? 0 : 1;
        } else {
          var firstModuleSpecifier = sourceFile.imports && ts3.find(sourceFile.imports, function(n2) {
            return ts3.isStringLiteral(n2) && !ts3.nodeIsSynthesized(n2.parent);
          });
          return firstModuleSpecifier ? quotePreferenceFromString(firstModuleSpecifier, sourceFile) : 1;
        }
      }
      ts3.getQuotePreference = getQuotePreference;
      function getQuoteFromPreference(qp) {
        switch (qp) {
          case 0:
            return "'";
          case 1:
            return '"';
          default:
            return ts3.Debug.assertNever(qp);
        }
      }
      ts3.getQuoteFromPreference = getQuoteFromPreference;
      function symbolNameNoDefault(symbol) {
        var escaped = symbolEscapedNameNoDefault(symbol);
        return escaped === void 0 ? void 0 : ts3.unescapeLeadingUnderscores(escaped);
      }
      ts3.symbolNameNoDefault = symbolNameNoDefault;
      function symbolEscapedNameNoDefault(symbol) {
        if (symbol.escapedName !== "default") {
          return symbol.escapedName;
        }
        return ts3.firstDefined(symbol.declarations, function(decl) {
          var name = ts3.getNameOfDeclaration(decl);
          return name && name.kind === 78 ? name.escapedText : void 0;
        });
      }
      ts3.symbolEscapedNameNoDefault = symbolEscapedNameNoDefault;
      function isModuleSpecifierLike(node) {
        return ts3.isStringLiteralLike(node) && (ts3.isExternalModuleReference(node.parent) || ts3.isImportDeclaration(node.parent) || ts3.isRequireCall(node.parent, false) && node.parent.arguments[0] === node || ts3.isImportCall(node.parent) && node.parent.arguments[0] === node);
      }
      ts3.isModuleSpecifierLike = isModuleSpecifierLike;
      function isObjectBindingElementWithoutPropertyName(bindingElement) {
        return ts3.isBindingElement(bindingElement) && ts3.isObjectBindingPattern(bindingElement.parent) && ts3.isIdentifier(bindingElement.name) && !bindingElement.propertyName;
      }
      ts3.isObjectBindingElementWithoutPropertyName = isObjectBindingElementWithoutPropertyName;
      function getPropertySymbolFromBindingElement(checker, bindingElement) {
        var typeOfPattern = checker.getTypeAtLocation(bindingElement.parent);
        return typeOfPattern && checker.getPropertyOfType(typeOfPattern, bindingElement.name.text);
      }
      ts3.getPropertySymbolFromBindingElement = getPropertySymbolFromBindingElement;
      function getParentNodeInSpan(node, file, span) {
        if (!node)
          return void 0;
        while (node.parent) {
          if (ts3.isSourceFile(node.parent) || !spanContainsNode(span, node.parent, file)) {
            return node;
          }
          node = node.parent;
        }
      }
      ts3.getParentNodeInSpan = getParentNodeInSpan;
      function spanContainsNode(span, node, file) {
        return ts3.textSpanContainsPosition(span, node.getStart(file)) && node.getEnd() <= ts3.textSpanEnd(span);
      }
      function findModifier(node, kind) {
        return node.modifiers && ts3.find(node.modifiers, function(m) {
          return m.kind === kind;
        });
      }
      ts3.findModifier = findModifier;
      function insertImports(changes, sourceFile, imports, blankLineBetween) {
        var decl = ts3.isArray(imports) ? imports[0] : imports;
        var importKindPredicate = decl.kind === 233 ? ts3.isRequireVariableStatement : ts3.isAnyImportSyntax;
        var existingImportStatements = ts3.filter(sourceFile.statements, importKindPredicate);
        var sortedNewImports = ts3.isArray(imports) ? ts3.stableSort(imports, ts3.OrganizeImports.compareImportsOrRequireStatements) : [imports];
        if (!existingImportStatements.length) {
          changes.insertNodesAtTopOfFile(sourceFile, sortedNewImports, blankLineBetween);
        } else if (existingImportStatements && ts3.OrganizeImports.importsAreSorted(existingImportStatements)) {
          for (var _i = 0, sortedNewImports_1 = sortedNewImports; _i < sortedNewImports_1.length; _i++) {
            var newImport = sortedNewImports_1[_i];
            var insertionIndex = ts3.OrganizeImports.getImportDeclarationInsertionIndex(existingImportStatements, newImport);
            if (insertionIndex === 0) {
              var options = existingImportStatements[0] === sourceFile.statements[0] ? { leadingTriviaOption: ts3.textChanges.LeadingTriviaOption.Exclude } : {};
              changes.insertNodeBefore(sourceFile, existingImportStatements[0], newImport, false, options);
            } else {
              var prevImport = existingImportStatements[insertionIndex - 1];
              changes.insertNodeAfter(sourceFile, prevImport, newImport);
            }
          }
        } else {
          var lastExistingImport = ts3.lastOrUndefined(existingImportStatements);
          if (lastExistingImport) {
            changes.insertNodesAfter(sourceFile, lastExistingImport, sortedNewImports);
          } else {
            changes.insertNodesAtTopOfFile(sourceFile, sortedNewImports, blankLineBetween);
          }
        }
      }
      ts3.insertImports = insertImports;
      function getTypeKeywordOfTypeOnlyImport(importClause, sourceFile) {
        ts3.Debug.assert(importClause.isTypeOnly);
        return ts3.cast(importClause.getChildAt(0, sourceFile), isTypeKeywordToken);
      }
      ts3.getTypeKeywordOfTypeOnlyImport = getTypeKeywordOfTypeOnlyImport;
      function textSpansEqual(a2, b2) {
        return !!a2 && !!b2 && a2.start === b2.start && a2.length === b2.length;
      }
      ts3.textSpansEqual = textSpansEqual;
      function documentSpansEqual(a2, b2) {
        return a2.fileName === b2.fileName && textSpansEqual(a2.textSpan, b2.textSpan);
      }
      ts3.documentSpansEqual = documentSpansEqual;
      function forEachUnique(array, callback) {
        if (array) {
          for (var i3 = 0; i3 < array.length; i3++) {
            if (array.indexOf(array[i3]) === i3) {
              var result2 = callback(array[i3], i3);
              if (result2) {
                return result2;
              }
            }
          }
        }
        return void 0;
      }
      ts3.forEachUnique = forEachUnique;
      function isTextWhiteSpaceLike(text, startPos, endPos) {
        for (var i3 = startPos; i3 < endPos; i3++) {
          if (!ts3.isWhiteSpaceLike(text.charCodeAt(i3))) {
            return false;
          }
        }
        return true;
      }
      ts3.isTextWhiteSpaceLike = isTextWhiteSpaceLike;
      function isFirstDeclarationOfSymbolParameter(symbol) {
        return symbol.declarations && symbol.declarations.length > 0 && symbol.declarations[0].kind === 161;
      }
      ts3.isFirstDeclarationOfSymbolParameter = isFirstDeclarationOfSymbolParameter;
      var displayPartWriter = getDisplayPartWriter();
      function getDisplayPartWriter() {
        var absoluteMaximumLength = ts3.defaultMaximumTruncationLength * 10;
        var displayParts;
        var lineStart;
        var indent;
        var length;
        resetWriter();
        var unknownWrite = function(text) {
          return writeKind(text, ts3.SymbolDisplayPartKind.text);
        };
        return {
          displayParts: function() {
            var finalText = displayParts.length && displayParts[displayParts.length - 1].text;
            if (length > absoluteMaximumLength && finalText && finalText !== "...") {
              if (!ts3.isWhiteSpaceLike(finalText.charCodeAt(finalText.length - 1))) {
                displayParts.push(displayPart(" ", ts3.SymbolDisplayPartKind.space));
              }
              displayParts.push(displayPart("...", ts3.SymbolDisplayPartKind.punctuation));
            }
            return displayParts;
          },
          writeKeyword: function(text) {
            return writeKind(text, ts3.SymbolDisplayPartKind.keyword);
          },
          writeOperator: function(text) {
            return writeKind(text, ts3.SymbolDisplayPartKind.operator);
          },
          writePunctuation: function(text) {
            return writeKind(text, ts3.SymbolDisplayPartKind.punctuation);
          },
          writeTrailingSemicolon: function(text) {
            return writeKind(text, ts3.SymbolDisplayPartKind.punctuation);
          },
          writeSpace: function(text) {
            return writeKind(text, ts3.SymbolDisplayPartKind.space);
          },
          writeStringLiteral: function(text) {
            return writeKind(text, ts3.SymbolDisplayPartKind.stringLiteral);
          },
          writeParameter: function(text) {
            return writeKind(text, ts3.SymbolDisplayPartKind.parameterName);
          },
          writeProperty: function(text) {
            return writeKind(text, ts3.SymbolDisplayPartKind.propertyName);
          },
          writeLiteral: function(text) {
            return writeKind(text, ts3.SymbolDisplayPartKind.stringLiteral);
          },
          writeSymbol,
          writeLine,
          write: unknownWrite,
          writeComment: unknownWrite,
          getText: function() {
            return "";
          },
          getTextPos: function() {
            return 0;
          },
          getColumn: function() {
            return 0;
          },
          getLine: function() {
            return 0;
          },
          isAtStartOfLine: function() {
            return false;
          },
          hasTrailingWhitespace: function() {
            return false;
          },
          hasTrailingComment: function() {
            return false;
          },
          rawWrite: ts3.notImplemented,
          getIndent: function() {
            return indent;
          },
          increaseIndent: function() {
            indent++;
          },
          decreaseIndent: function() {
            indent--;
          },
          clear: resetWriter,
          trackSymbol: ts3.noop,
          reportInaccessibleThisError: ts3.noop,
          reportInaccessibleUniqueSymbolError: ts3.noop,
          reportPrivateInBaseOfClassExpression: ts3.noop
        };
        function writeIndent() {
          if (length > absoluteMaximumLength)
            return;
          if (lineStart) {
            var indentString2 = ts3.getIndentString(indent);
            if (indentString2) {
              length += indentString2.length;
              displayParts.push(displayPart(indentString2, ts3.SymbolDisplayPartKind.space));
            }
            lineStart = false;
          }
        }
        function writeKind(text, kind) {
          if (length > absoluteMaximumLength)
            return;
          writeIndent();
          length += text.length;
          displayParts.push(displayPart(text, kind));
        }
        function writeSymbol(text, symbol) {
          if (length > absoluteMaximumLength)
            return;
          writeIndent();
          length += text.length;
          displayParts.push(symbolPart(text, symbol));
        }
        function writeLine() {
          if (length > absoluteMaximumLength)
            return;
          length += 1;
          displayParts.push(lineBreakPart());
          lineStart = true;
        }
        function resetWriter() {
          displayParts = [];
          lineStart = true;
          indent = 0;
          length = 0;
        }
      }
      function symbolPart(text, symbol) {
        return displayPart(text, displayPartKind(symbol));
        function displayPartKind(symbol2) {
          var flags = symbol2.flags;
          if (flags & 3) {
            return isFirstDeclarationOfSymbolParameter(symbol2) ? ts3.SymbolDisplayPartKind.parameterName : ts3.SymbolDisplayPartKind.localName;
          } else if (flags & 4) {
            return ts3.SymbolDisplayPartKind.propertyName;
          } else if (flags & 32768) {
            return ts3.SymbolDisplayPartKind.propertyName;
          } else if (flags & 65536) {
            return ts3.SymbolDisplayPartKind.propertyName;
          } else if (flags & 8) {
            return ts3.SymbolDisplayPartKind.enumMemberName;
          } else if (flags & 16) {
            return ts3.SymbolDisplayPartKind.functionName;
          } else if (flags & 32) {
            return ts3.SymbolDisplayPartKind.className;
          } else if (flags & 64) {
            return ts3.SymbolDisplayPartKind.interfaceName;
          } else if (flags & 384) {
            return ts3.SymbolDisplayPartKind.enumName;
          } else if (flags & 1536) {
            return ts3.SymbolDisplayPartKind.moduleName;
          } else if (flags & 8192) {
            return ts3.SymbolDisplayPartKind.methodName;
          } else if (flags & 262144) {
            return ts3.SymbolDisplayPartKind.typeParameterName;
          } else if (flags & 524288) {
            return ts3.SymbolDisplayPartKind.aliasName;
          } else if (flags & 2097152) {
            return ts3.SymbolDisplayPartKind.aliasName;
          }
          return ts3.SymbolDisplayPartKind.text;
        }
      }
      ts3.symbolPart = symbolPart;
      function displayPart(text, kind) {
        return { text, kind: ts3.SymbolDisplayPartKind[kind] };
      }
      ts3.displayPart = displayPart;
      function spacePart() {
        return displayPart(" ", ts3.SymbolDisplayPartKind.space);
      }
      ts3.spacePart = spacePart;
      function keywordPart(kind) {
        return displayPart(ts3.tokenToString(kind), ts3.SymbolDisplayPartKind.keyword);
      }
      ts3.keywordPart = keywordPart;
      function punctuationPart(kind) {
        return displayPart(ts3.tokenToString(kind), ts3.SymbolDisplayPartKind.punctuation);
      }
      ts3.punctuationPart = punctuationPart;
      function operatorPart(kind) {
        return displayPart(ts3.tokenToString(kind), ts3.SymbolDisplayPartKind.operator);
      }
      ts3.operatorPart = operatorPart;
      function parameterNamePart(text) {
        return displayPart(text, ts3.SymbolDisplayPartKind.parameterName);
      }
      ts3.parameterNamePart = parameterNamePart;
      function propertyNamePart(text) {
        return displayPart(text, ts3.SymbolDisplayPartKind.propertyName);
      }
      ts3.propertyNamePart = propertyNamePart;
      function textOrKeywordPart(text) {
        var kind = ts3.stringToToken(text);
        return kind === void 0 ? textPart(text) : keywordPart(kind);
      }
      ts3.textOrKeywordPart = textOrKeywordPart;
      function textPart(text) {
        return displayPart(text, ts3.SymbolDisplayPartKind.text);
      }
      ts3.textPart = textPart;
      function typeAliasNamePart(text) {
        return displayPart(text, ts3.SymbolDisplayPartKind.aliasName);
      }
      ts3.typeAliasNamePart = typeAliasNamePart;
      function typeParameterNamePart(text) {
        return displayPart(text, ts3.SymbolDisplayPartKind.typeParameterName);
      }
      ts3.typeParameterNamePart = typeParameterNamePart;
      function linkTextPart(text) {
        return displayPart(text, ts3.SymbolDisplayPartKind.linkText);
      }
      ts3.linkTextPart = linkTextPart;
      function linkNamePart(name, target) {
        return {
          text: ts3.getTextOfNode(name),
          kind: ts3.SymbolDisplayPartKind[ts3.SymbolDisplayPartKind.linkName],
          target: {
            fileName: ts3.getSourceFileOfNode(target).fileName,
            textSpan: createTextSpanFromNode(target)
          }
        };
      }
      ts3.linkNamePart = linkNamePart;
      function linkPart(text) {
        return displayPart(text, ts3.SymbolDisplayPartKind.link);
      }
      ts3.linkPart = linkPart;
      function buildLinkParts(link, checker) {
        var _a2;
        var parts = [linkPart("{@link ")];
        if (!link.name) {
          if (link.text) {
            parts.push(linkTextPart(link.text));
          }
        } else {
          var symbol = checker === null || checker === void 0 ? void 0 : checker.getSymbolAtLocation(link.name);
          var decl = (symbol === null || symbol === void 0 ? void 0 : symbol.valueDeclaration) || ((_a2 = symbol === null || symbol === void 0 ? void 0 : symbol.declarations) === null || _a2 === void 0 ? void 0 : _a2[0]);
          if (decl) {
            parts.push(linkNamePart(link.name, decl));
            if (link.text) {
              parts.push(linkTextPart(link.text));
            }
          } else {
            parts.push(linkTextPart(ts3.getTextOfNode(link.name) + link.text));
          }
        }
        parts.push(linkPart("}"));
        return parts;
      }
      ts3.buildLinkParts = buildLinkParts;
      var carriageReturnLineFeed = "\r\n";
      function getNewLineOrDefaultFromHost(host, formatSettings) {
        var _a2;
        return (formatSettings === null || formatSettings === void 0 ? void 0 : formatSettings.newLineCharacter) || ((_a2 = host.getNewLine) === null || _a2 === void 0 ? void 0 : _a2.call(host)) || carriageReturnLineFeed;
      }
      ts3.getNewLineOrDefaultFromHost = getNewLineOrDefaultFromHost;
      function lineBreakPart() {
        return displayPart("\n", ts3.SymbolDisplayPartKind.lineBreak);
      }
      ts3.lineBreakPart = lineBreakPart;
      function mapToDisplayParts(writeDisplayParts) {
        try {
          writeDisplayParts(displayPartWriter);
          return displayPartWriter.displayParts();
        } finally {
          displayPartWriter.clear();
        }
      }
      ts3.mapToDisplayParts = mapToDisplayParts;
      function typeToDisplayParts(typechecker, type3, enclosingDeclaration, flags) {
        if (flags === void 0) {
          flags = 0;
        }
        return mapToDisplayParts(function(writer) {
          typechecker.writeType(type3, enclosingDeclaration, flags | 1024 | 16384, writer);
        });
      }
      ts3.typeToDisplayParts = typeToDisplayParts;
      function symbolToDisplayParts(typeChecker, symbol, enclosingDeclaration, meaning, flags) {
        if (flags === void 0) {
          flags = 0;
        }
        return mapToDisplayParts(function(writer) {
          typeChecker.writeSymbol(symbol, enclosingDeclaration, meaning, flags | 8, writer);
        });
      }
      ts3.symbolToDisplayParts = symbolToDisplayParts;
      function signatureToDisplayParts(typechecker, signature, enclosingDeclaration, flags) {
        if (flags === void 0) {
          flags = 0;
        }
        flags |= 16384 | 1024 | 32 | 8192;
        return mapToDisplayParts(function(writer) {
          typechecker.writeSignature(signature, enclosingDeclaration, flags, void 0, writer);
        });
      }
      ts3.signatureToDisplayParts = signatureToDisplayParts;
      function isImportOrExportSpecifierName(location) {
        return !!location.parent && ts3.isImportOrExportSpecifier(location.parent) && location.parent.propertyName === location;
      }
      ts3.isImportOrExportSpecifierName = isImportOrExportSpecifierName;
      function getScriptKind(fileName, host) {
        return ts3.ensureScriptKind(fileName, host.getScriptKind && host.getScriptKind(fileName));
      }
      ts3.getScriptKind = getScriptKind;
      function getSymbolTarget(symbol, checker) {
        var next = symbol;
        while (isAliasSymbol(next) || isTransientSymbol(next) && next.target) {
          if (isTransientSymbol(next) && next.target) {
            next = next.target;
          } else {
            next = ts3.skipAlias(next, checker);
          }
        }
        return next;
      }
      ts3.getSymbolTarget = getSymbolTarget;
      function isTransientSymbol(symbol) {
        return (symbol.flags & 33554432) !== 0;
      }
      function isAliasSymbol(symbol) {
        return (symbol.flags & 2097152) !== 0;
      }
      function getUniqueSymbolId(symbol, checker) {
        return ts3.getSymbolId(ts3.skipAlias(symbol, checker));
      }
      ts3.getUniqueSymbolId = getUniqueSymbolId;
      function getFirstNonSpaceCharacterPosition(text, position) {
        while (ts3.isWhiteSpaceLike(text.charCodeAt(position))) {
          position += 1;
        }
        return position;
      }
      ts3.getFirstNonSpaceCharacterPosition = getFirstNonSpaceCharacterPosition;
      function getPrecedingNonSpaceCharacterPosition(text, position) {
        while (position > -1 && ts3.isWhiteSpaceSingleLine(text.charCodeAt(position))) {
          position -= 1;
        }
        return position + 1;
      }
      ts3.getPrecedingNonSpaceCharacterPosition = getPrecedingNonSpaceCharacterPosition;
      function getSynthesizedDeepClone(node, includeTrivia) {
        if (includeTrivia === void 0) {
          includeTrivia = true;
        }
        var clone = node && getSynthesizedDeepCloneWorker(node);
        if (clone && !includeTrivia)
          suppressLeadingAndTrailingTrivia(clone);
        return clone;
      }
      ts3.getSynthesizedDeepClone = getSynthesizedDeepClone;
      function getSynthesizedDeepCloneWithReplacements(node, includeTrivia, replaceNode) {
        var clone = replaceNode(node);
        if (clone) {
          ts3.setOriginalNode(clone, node);
        } else {
          clone = getSynthesizedDeepCloneWorker(node, replaceNode);
        }
        if (clone && !includeTrivia)
          suppressLeadingAndTrailingTrivia(clone);
        return clone;
      }
      ts3.getSynthesizedDeepCloneWithReplacements = getSynthesizedDeepCloneWithReplacements;
      function getSynthesizedDeepCloneWorker(node, replaceNode) {
        var visited = replaceNode ? ts3.visitEachChild(node, function(n2) {
          return getSynthesizedDeepCloneWithReplacements(n2, true, replaceNode);
        }, ts3.nullTransformationContext) : ts3.visitEachChild(node, getSynthesizedDeepClone, ts3.nullTransformationContext);
        if (visited === node) {
          var clone_1 = ts3.isStringLiteral(node) ? ts3.setOriginalNode(ts3.factory.createStringLiteralFromNode(node), node) : ts3.isNumericLiteral(node) ? ts3.setOriginalNode(ts3.factory.createNumericLiteral(node.text, node.numericLiteralFlags), node) : ts3.factory.cloneNode(node);
          return ts3.setTextRange(clone_1, node);
        }
        visited.parent = void 0;
        return visited;
      }
      function getSynthesizedDeepClones(nodes, includeTrivia) {
        if (includeTrivia === void 0) {
          includeTrivia = true;
        }
        return nodes && ts3.factory.createNodeArray(nodes.map(function(n2) {
          return getSynthesizedDeepClone(n2, includeTrivia);
        }), nodes.hasTrailingComma);
      }
      ts3.getSynthesizedDeepClones = getSynthesizedDeepClones;
      function getSynthesizedDeepClonesWithReplacements(nodes, includeTrivia, replaceNode) {
        return ts3.factory.createNodeArray(nodes.map(function(n2) {
          return getSynthesizedDeepCloneWithReplacements(n2, includeTrivia, replaceNode);
        }), nodes.hasTrailingComma);
      }
      ts3.getSynthesizedDeepClonesWithReplacements = getSynthesizedDeepClonesWithReplacements;
      function suppressLeadingAndTrailingTrivia(node) {
        suppressLeadingTrivia(node);
        suppressTrailingTrivia(node);
      }
      ts3.suppressLeadingAndTrailingTrivia = suppressLeadingAndTrailingTrivia;
      function suppressLeadingTrivia(node) {
        addEmitFlagsRecursively(node, 512, getFirstChild);
      }
      ts3.suppressLeadingTrivia = suppressLeadingTrivia;
      function suppressTrailingTrivia(node) {
        addEmitFlagsRecursively(node, 1024, ts3.getLastChild);
      }
      ts3.suppressTrailingTrivia = suppressTrailingTrivia;
      function copyComments(sourceNode, targetNode) {
        var sourceFile = sourceNode.getSourceFile();
        var text = sourceFile.text;
        if (hasLeadingLineBreak(sourceNode, text)) {
          copyLeadingComments(sourceNode, targetNode, sourceFile);
        } else {
          copyTrailingAsLeadingComments(sourceNode, targetNode, sourceFile);
        }
        copyTrailingComments(sourceNode, targetNode, sourceFile);
      }
      ts3.copyComments = copyComments;
      function hasLeadingLineBreak(node, text) {
        var start = node.getFullStart();
        var end = node.getStart();
        for (var i3 = start; i3 < end; i3++) {
          if (text.charCodeAt(i3) === 10)
            return true;
        }
        return false;
      }
      function addEmitFlagsRecursively(node, flag, getChild) {
        ts3.addEmitFlags(node, flag);
        var child = getChild(node);
        if (child)
          addEmitFlagsRecursively(child, flag, getChild);
      }
      function getFirstChild(node) {
        return node.forEachChild(function(child) {
          return child;
        });
      }
      function getUniqueName(baseName, sourceFile) {
        var nameText = baseName;
        for (var i3 = 1; !ts3.isFileLevelUniqueName(sourceFile, nameText); i3++) {
          nameText = baseName + "_" + i3;
        }
        return nameText;
      }
      ts3.getUniqueName = getUniqueName;
      function getRenameLocation(edits, renameFilename, name, preferLastLocation) {
        var delta = 0;
        var lastPos = -1;
        for (var _i = 0, edits_1 = edits; _i < edits_1.length; _i++) {
          var _a2 = edits_1[_i], fileName = _a2.fileName, textChanges_2 = _a2.textChanges;
          ts3.Debug.assert(fileName === renameFilename);
          for (var _b = 0, textChanges_1 = textChanges_2; _b < textChanges_1.length; _b++) {
            var change = textChanges_1[_b];
            var span = change.span, newText = change.newText;
            var index = indexInTextChange(newText, name);
            if (index !== -1) {
              lastPos = span.start + delta + index;
              if (!preferLastLocation) {
                return lastPos;
              }
            }
            delta += newText.length - span.length;
          }
        }
        ts3.Debug.assert(preferLastLocation);
        ts3.Debug.assert(lastPos >= 0);
        return lastPos;
      }
      ts3.getRenameLocation = getRenameLocation;
      function copyLeadingComments(sourceNode, targetNode, sourceFile, commentKind, hasTrailingNewLine) {
        ts3.forEachLeadingCommentRange(sourceFile.text, sourceNode.pos, getAddCommentsFunction(targetNode, sourceFile, commentKind, hasTrailingNewLine, ts3.addSyntheticLeadingComment));
      }
      ts3.copyLeadingComments = copyLeadingComments;
      function copyTrailingComments(sourceNode, targetNode, sourceFile, commentKind, hasTrailingNewLine) {
        ts3.forEachTrailingCommentRange(sourceFile.text, sourceNode.end, getAddCommentsFunction(targetNode, sourceFile, commentKind, hasTrailingNewLine, ts3.addSyntheticTrailingComment));
      }
      ts3.copyTrailingComments = copyTrailingComments;
      function copyTrailingAsLeadingComments(sourceNode, targetNode, sourceFile, commentKind, hasTrailingNewLine) {
        ts3.forEachTrailingCommentRange(sourceFile.text, sourceNode.pos, getAddCommentsFunction(targetNode, sourceFile, commentKind, hasTrailingNewLine, ts3.addSyntheticLeadingComment));
      }
      ts3.copyTrailingAsLeadingComments = copyTrailingAsLeadingComments;
      function getAddCommentsFunction(targetNode, sourceFile, commentKind, hasTrailingNewLine, cb2) {
        return function(pos, end, kind, htnl) {
          if (kind === 3) {
            pos += 2;
            end -= 2;
          } else {
            pos += 2;
          }
          cb2(targetNode, commentKind || kind, sourceFile.text.slice(pos, end), hasTrailingNewLine !== void 0 ? hasTrailingNewLine : htnl);
        };
      }
      function indexInTextChange(change, name) {
        if (ts3.startsWith(change, name))
          return 0;
        var idx = change.indexOf(" " + name);
        if (idx === -1)
          idx = change.indexOf("." + name);
        if (idx === -1)
          idx = change.indexOf('"' + name);
        return idx === -1 ? -1 : idx + 1;
      }
      function needsParentheses(expression) {
        return ts3.isBinaryExpression(expression) && expression.operatorToken.kind === 27 || ts3.isObjectLiteralExpression(expression) || ts3.isAsExpression(expression) && ts3.isObjectLiteralExpression(expression.expression);
      }
      ts3.needsParentheses = needsParentheses;
      function getContextualTypeFromParent(node, checker) {
        var parent = node.parent;
        switch (parent.kind) {
          case 205:
            return checker.getContextualType(parent);
          case 217: {
            var _a2 = parent, left = _a2.left, operatorToken = _a2.operatorToken, right = _a2.right;
            return isEqualityOperatorKind(operatorToken.kind) ? checker.getTypeAtLocation(node === right ? left : right) : checker.getContextualType(node);
          }
          case 285:
            return parent.expression === node ? getSwitchedType(parent, checker) : void 0;
          default:
            return checker.getContextualType(node);
        }
      }
      ts3.getContextualTypeFromParent = getContextualTypeFromParent;
      function quote(sourceFile, preferences, text) {
        var quotePreference = getQuotePreference(sourceFile, preferences);
        var quoted = JSON.stringify(text);
        return quotePreference === 0 ? "'" + ts3.stripQuotes(quoted).replace(/'/g, "\\'").replace(/\\"/g, '"') + "'" : quoted;
      }
      ts3.quote = quote;
      function isEqualityOperatorKind(kind) {
        switch (kind) {
          case 36:
          case 34:
          case 37:
          case 35:
            return true;
          default:
            return false;
        }
      }
      ts3.isEqualityOperatorKind = isEqualityOperatorKind;
      function isStringLiteralOrTemplate(node) {
        switch (node.kind) {
          case 10:
          case 14:
          case 219:
          case 206:
            return true;
          default:
            return false;
        }
      }
      ts3.isStringLiteralOrTemplate = isStringLiteralOrTemplate;
      function hasIndexSignature(type3) {
        return !!type3.getStringIndexType() || !!type3.getNumberIndexType();
      }
      ts3.hasIndexSignature = hasIndexSignature;
      function getSwitchedType(caseClause, checker) {
        return checker.getTypeAtLocation(caseClause.parent.parent.expression);
      }
      ts3.getSwitchedType = getSwitchedType;
      ts3.ANONYMOUS = "anonymous function";
      function getTypeNodeIfAccessible(type3, enclosingScope, program2, host) {
        var checker = program2.getTypeChecker();
        var typeIsAccessible = true;
        var notAccessible = function() {
          typeIsAccessible = false;
        };
        var res = checker.typeToTypeNode(type3, enclosingScope, 1, {
          trackSymbol: function(symbol, declaration, meaning) {
            typeIsAccessible = typeIsAccessible && checker.isSymbolAccessible(symbol, declaration, meaning, false).accessibility === 0;
          },
          reportInaccessibleThisError: notAccessible,
          reportPrivateInBaseOfClassExpression: notAccessible,
          reportInaccessibleUniqueSymbolError: notAccessible,
          moduleResolverHost: getModuleSpecifierResolverHost(program2, host)
        });
        return typeIsAccessible ? res : void 0;
      }
      ts3.getTypeNodeIfAccessible = getTypeNodeIfAccessible;
      function syntaxRequiresTrailingCommaOrSemicolonOrASI(kind) {
        return kind === 170 || kind === 171 || kind === 172 || kind === 163 || kind === 165;
      }
      ts3.syntaxRequiresTrailingCommaOrSemicolonOrASI = syntaxRequiresTrailingCommaOrSemicolonOrASI;
      function syntaxRequiresTrailingFunctionBlockOrSemicolonOrASI(kind) {
        return kind === 252 || kind === 167 || kind === 166 || kind === 168 || kind === 169;
      }
      ts3.syntaxRequiresTrailingFunctionBlockOrSemicolonOrASI = syntaxRequiresTrailingFunctionBlockOrSemicolonOrASI;
      function syntaxRequiresTrailingModuleBlockOrSemicolonOrASI(kind) {
        return kind === 257;
      }
      ts3.syntaxRequiresTrailingModuleBlockOrSemicolonOrASI = syntaxRequiresTrailingModuleBlockOrSemicolonOrASI;
      function syntaxRequiresTrailingSemicolonOrASI(kind) {
        return kind === 233 || kind === 234 || kind === 236 || kind === 241 || kind === 242 || kind === 243 || kind === 247 || kind === 249 || kind === 164 || kind === 255 || kind === 262 || kind === 261 || kind === 268 || kind === 260 || kind === 267;
      }
      ts3.syntaxRequiresTrailingSemicolonOrASI = syntaxRequiresTrailingSemicolonOrASI;
      ts3.syntaxMayBeASICandidate = ts3.or(syntaxRequiresTrailingCommaOrSemicolonOrASI, syntaxRequiresTrailingFunctionBlockOrSemicolonOrASI, syntaxRequiresTrailingModuleBlockOrSemicolonOrASI, syntaxRequiresTrailingSemicolonOrASI);
      function nodeIsASICandidate(node, sourceFile) {
        var lastToken = node.getLastToken(sourceFile);
        if (lastToken && lastToken.kind === 26) {
          return false;
        }
        if (syntaxRequiresTrailingCommaOrSemicolonOrASI(node.kind)) {
          if (lastToken && lastToken.kind === 27) {
            return false;
          }
        } else if (syntaxRequiresTrailingModuleBlockOrSemicolonOrASI(node.kind)) {
          var lastChild = ts3.last(node.getChildren(sourceFile));
          if (lastChild && ts3.isModuleBlock(lastChild)) {
            return false;
          }
        } else if (syntaxRequiresTrailingFunctionBlockOrSemicolonOrASI(node.kind)) {
          var lastChild = ts3.last(node.getChildren(sourceFile));
          if (lastChild && ts3.isFunctionBlock(lastChild)) {
            return false;
          }
        } else if (!syntaxRequiresTrailingSemicolonOrASI(node.kind)) {
          return false;
        }
        if (node.kind === 236) {
          return true;
        }
        var topNode = ts3.findAncestor(node, function(ancestor) {
          return !ancestor.parent;
        });
        var nextToken = findNextToken(node, topNode, sourceFile);
        if (!nextToken || nextToken.kind === 19) {
          return true;
        }
        var startLine = sourceFile.getLineAndCharacterOfPosition(node.getEnd()).line;
        var endLine = sourceFile.getLineAndCharacterOfPosition(nextToken.getStart(sourceFile)).line;
        return startLine !== endLine;
      }
      function positionIsASICandidate(pos, context, sourceFile) {
        var contextAncestor = ts3.findAncestor(context, function(ancestor) {
          if (ancestor.end !== pos) {
            return "quit";
          }
          return ts3.syntaxMayBeASICandidate(ancestor.kind);
        });
        return !!contextAncestor && nodeIsASICandidate(contextAncestor, sourceFile);
      }
      ts3.positionIsASICandidate = positionIsASICandidate;
      function probablyUsesSemicolons(sourceFile) {
        var withSemicolon = 0;
        var withoutSemicolon = 0;
        var nStatementsToObserve = 5;
        ts3.forEachChild(sourceFile, function visit(node) {
          if (syntaxRequiresTrailingSemicolonOrASI(node.kind)) {
            var lastToken = node.getLastToken(sourceFile);
            if (lastToken && lastToken.kind === 26) {
              withSemicolon++;
            } else {
              withoutSemicolon++;
            }
          }
          if (withSemicolon + withoutSemicolon >= nStatementsToObserve) {
            return true;
          }
          return ts3.forEachChild(node, visit);
        });
        if (withSemicolon === 0 && withoutSemicolon <= 1) {
          return true;
        }
        return withSemicolon / withoutSemicolon > 1 / nStatementsToObserve;
      }
      ts3.probablyUsesSemicolons = probablyUsesSemicolons;
      function tryGetDirectories(host, directoryName) {
        return tryIOAndConsumeErrors(host, host.getDirectories, directoryName) || [];
      }
      ts3.tryGetDirectories = tryGetDirectories;
      function tryReadDirectory(host, path2, extensions, exclude, include) {
        return tryIOAndConsumeErrors(host, host.readDirectory, path2, extensions, exclude, include) || ts3.emptyArray;
      }
      ts3.tryReadDirectory = tryReadDirectory;
      function tryFileExists(host, path2) {
        return tryIOAndConsumeErrors(host, host.fileExists, path2);
      }
      ts3.tryFileExists = tryFileExists;
      function tryDirectoryExists(host, path2) {
        return tryAndIgnoreErrors(function() {
          return ts3.directoryProbablyExists(path2, host);
        }) || false;
      }
      ts3.tryDirectoryExists = tryDirectoryExists;
      function tryAndIgnoreErrors(cb2) {
        try {
          return cb2();
        } catch (_a2) {
          return void 0;
        }
      }
      ts3.tryAndIgnoreErrors = tryAndIgnoreErrors;
      function tryIOAndConsumeErrors(host, toApply) {
        var args = [];
        for (var _i = 2; _i < arguments.length; _i++) {
          args[_i - 2] = arguments[_i];
        }
        return tryAndIgnoreErrors(function() {
          return toApply && toApply.apply(host, args);
        });
      }
      ts3.tryIOAndConsumeErrors = tryIOAndConsumeErrors;
      function findPackageJsons(startDirectory, host, stopDirectory) {
        var paths = [];
        ts3.forEachAncestorDirectory(startDirectory, function(ancestor) {
          if (ancestor === stopDirectory) {
            return true;
          }
          var currentConfigPath = ts3.combinePaths(ancestor, "package.json");
          if (tryFileExists(host, currentConfigPath)) {
            paths.push(currentConfigPath);
          }
        });
        return paths;
      }
      ts3.findPackageJsons = findPackageJsons;
      function findPackageJson(directory, host) {
        var packageJson;
        ts3.forEachAncestorDirectory(directory, function(ancestor) {
          if (ancestor === "node_modules")
            return true;
          packageJson = ts3.findConfigFile(ancestor, function(f) {
            return tryFileExists(host, f);
          }, "package.json");
          if (packageJson) {
            return true;
          }
        });
        return packageJson;
      }
      ts3.findPackageJson = findPackageJson;
      function getPackageJsonsVisibleToFile(fileName, host) {
        if (!host.fileExists) {
          return [];
        }
        var packageJsons = [];
        ts3.forEachAncestorDirectory(ts3.getDirectoryPath(fileName), function(ancestor) {
          var packageJsonFileName = ts3.combinePaths(ancestor, "package.json");
          if (host.fileExists(packageJsonFileName)) {
            var info = createPackageJsonInfo(packageJsonFileName, host);
            if (info) {
              packageJsons.push(info);
            }
          }
        });
        return packageJsons;
      }
      ts3.getPackageJsonsVisibleToFile = getPackageJsonsVisibleToFile;
      function createPackageJsonInfo(fileName, host) {
        if (!host.readFile) {
          return void 0;
        }
        var dependencyKeys = ["dependencies", "devDependencies", "optionalDependencies", "peerDependencies"];
        var stringContent = host.readFile(fileName) || "";
        var content = tryParseJson(stringContent);
        var info = {};
        if (content) {
          for (var _i = 0, dependencyKeys_1 = dependencyKeys; _i < dependencyKeys_1.length; _i++) {
            var key2 = dependencyKeys_1[_i];
            var dependencies = content[key2];
            if (!dependencies) {
              continue;
            }
            var dependencyMap = new ts3.Map();
            for (var packageName in dependencies) {
              dependencyMap.set(packageName, dependencies[packageName]);
            }
            info[key2] = dependencyMap;
          }
        }
        var dependencyGroups = [
          [1, info.dependencies],
          [2, info.devDependencies],
          [8, info.optionalDependencies],
          [4, info.peerDependencies]
        ];
        return __assign(__assign({}, info), { parseable: !!content, fileName, get, has: function(dependencyName, inGroups) {
          return !!get(dependencyName, inGroups);
        } });
        function get(dependencyName, inGroups) {
          if (inGroups === void 0) {
            inGroups = 15;
          }
          for (var _i2 = 0, dependencyGroups_1 = dependencyGroups; _i2 < dependencyGroups_1.length; _i2++) {
            var _a2 = dependencyGroups_1[_i2], group_1 = _a2[0], deps = _a2[1];
            if (deps && inGroups & group_1) {
              var dep = deps.get(dependencyName);
              if (dep !== void 0) {
                return dep;
              }
            }
          }
        }
      }
      ts3.createPackageJsonInfo = createPackageJsonInfo;
      function createPackageJsonImportFilter(fromFile, host) {
        var packageJsons = (host.getPackageJsonsVisibleToFile && host.getPackageJsonsVisibleToFile(fromFile.fileName) || getPackageJsonsVisibleToFile(fromFile.fileName, host)).filter(function(p) {
          return p.parseable;
        });
        var usesNodeCoreModules;
        return { allowsImportingAmbientModule, allowsImportingSourceFile, allowsImportingSpecifier };
        function moduleSpecifierIsCoveredByPackageJson(specifier) {
          var packageName = getNodeModuleRootSpecifier(specifier);
          for (var _i = 0, packageJsons_1 = packageJsons; _i < packageJsons_1.length; _i++) {
            var packageJson = packageJsons_1[_i];
            if (packageJson.has(packageName) || packageJson.has(ts3.getTypesPackageName(packageName))) {
              return true;
            }
          }
          return false;
        }
        function allowsImportingAmbientModule(moduleSymbol, moduleSpecifierResolutionHost) {
          if (!packageJsons.length || !moduleSymbol.valueDeclaration) {
            return true;
          }
          var declaringSourceFile = moduleSymbol.valueDeclaration.getSourceFile();
          var declaringNodeModuleName = getNodeModulesPackageNameFromFileName(declaringSourceFile.fileName, moduleSpecifierResolutionHost);
          if (typeof declaringNodeModuleName === "undefined") {
            return true;
          }
          var declaredModuleSpecifier = ts3.stripQuotes(moduleSymbol.getName());
          if (isAllowedCoreNodeModulesImport(declaredModuleSpecifier)) {
            return true;
          }
          return moduleSpecifierIsCoveredByPackageJson(declaringNodeModuleName) || moduleSpecifierIsCoveredByPackageJson(declaredModuleSpecifier);
        }
        function allowsImportingSourceFile(sourceFile, moduleSpecifierResolutionHost) {
          if (!packageJsons.length) {
            return true;
          }
          var moduleSpecifier = getNodeModulesPackageNameFromFileName(sourceFile.fileName, moduleSpecifierResolutionHost);
          if (!moduleSpecifier) {
            return true;
          }
          return moduleSpecifierIsCoveredByPackageJson(moduleSpecifier);
        }
        function allowsImportingSpecifier(moduleSpecifier) {
          if (!packageJsons.length || isAllowedCoreNodeModulesImport(moduleSpecifier)) {
            return true;
          }
          if (ts3.pathIsRelative(moduleSpecifier) || ts3.isRootedDiskPath(moduleSpecifier)) {
            return true;
          }
          return moduleSpecifierIsCoveredByPackageJson(moduleSpecifier);
        }
        function isAllowedCoreNodeModulesImport(moduleSpecifier) {
          if (ts3.isSourceFileJS(fromFile) && ts3.JsTyping.nodeCoreModules.has(moduleSpecifier)) {
            if (usesNodeCoreModules === void 0) {
              usesNodeCoreModules = consumesNodeCoreModules(fromFile);
            }
            if (usesNodeCoreModules) {
              return true;
            }
          }
          return false;
        }
        function getNodeModulesPackageNameFromFileName(importedFileName, moduleSpecifierResolutionHost) {
          if (!ts3.stringContains(importedFileName, "node_modules")) {
            return void 0;
          }
          var specifier = ts3.moduleSpecifiers.getNodeModulesPackageName(host.getCompilationSettings(), fromFile.path, importedFileName, moduleSpecifierResolutionHost);
          if (!specifier) {
            return void 0;
          }
          if (!ts3.pathIsRelative(specifier) && !ts3.isRootedDiskPath(specifier)) {
            return getNodeModuleRootSpecifier(specifier);
          }
        }
        function getNodeModuleRootSpecifier(fullSpecifier) {
          var components = ts3.getPathComponents(ts3.getPackageNameFromTypesPackageName(fullSpecifier)).slice(1);
          if (ts3.startsWith(components[0], "@")) {
            return components[0] + "/" + components[1];
          }
          return components[0];
        }
      }
      ts3.createPackageJsonImportFilter = createPackageJsonImportFilter;
      function tryParseJson(text) {
        try {
          return JSON.parse(text);
        } catch (_a2) {
          return void 0;
        }
      }
      function consumesNodeCoreModules(sourceFile) {
        return ts3.some(sourceFile.imports, function(_a2) {
          var text = _a2.text;
          return ts3.JsTyping.nodeCoreModules.has(text);
        });
      }
      ts3.consumesNodeCoreModules = consumesNodeCoreModules;
      function isInsideNodeModules(fileOrDirectory) {
        return ts3.contains(ts3.getPathComponents(fileOrDirectory), "node_modules");
      }
      ts3.isInsideNodeModules = isInsideNodeModules;
      function isDiagnosticWithLocation(diagnostic) {
        return diagnostic.file !== void 0 && diagnostic.start !== void 0 && diagnostic.length !== void 0;
      }
      ts3.isDiagnosticWithLocation = isDiagnosticWithLocation;
      function findDiagnosticForNode(node, sortedFileDiagnostics) {
        var span = createTextSpanFromNode(node);
        var index = ts3.binarySearchKey(sortedFileDiagnostics, span, ts3.identity, ts3.compareTextSpans);
        if (index >= 0) {
          var diagnostic = sortedFileDiagnostics[index];
          ts3.Debug.assertEqual(diagnostic.file, node.getSourceFile(), "Diagnostics proided to 'findDiagnosticForNode' must be from a single SourceFile");
          return ts3.cast(diagnostic, isDiagnosticWithLocation);
        }
      }
      ts3.findDiagnosticForNode = findDiagnosticForNode;
      function getDiagnosticsWithinSpan(span, sortedFileDiagnostics) {
        var _a2;
        var index = ts3.binarySearchKey(sortedFileDiagnostics, span.start, function(diag) {
          return diag.start;
        }, ts3.compareValues);
        if (index < 0) {
          index = ~index;
        }
        while (((_a2 = sortedFileDiagnostics[index - 1]) === null || _a2 === void 0 ? void 0 : _a2.start) === span.start) {
          index--;
        }
        var result2 = [];
        var end = ts3.textSpanEnd(span);
        while (true) {
          var diagnostic = ts3.tryCast(sortedFileDiagnostics[index], isDiagnosticWithLocation);
          if (!diagnostic || diagnostic.start > end) {
            break;
          }
          if (ts3.textSpanContainsTextSpan(span, diagnostic)) {
            result2.push(diagnostic);
          }
          index++;
        }
        return result2;
      }
      ts3.getDiagnosticsWithinSpan = getDiagnosticsWithinSpan;
      function getRefactorContextSpan(_a2) {
        var startPosition = _a2.startPosition, endPosition = _a2.endPosition;
        return ts3.createTextSpanFromBounds(startPosition, endPosition === void 0 ? startPosition : endPosition);
      }
      ts3.getRefactorContextSpan = getRefactorContextSpan;
      function mapOneOrMany(valueOrArray, f, resultSelector) {
        if (resultSelector === void 0) {
          resultSelector = ts3.identity;
        }
        return valueOrArray ? ts3.isArray(valueOrArray) ? resultSelector(ts3.map(valueOrArray, f)) : f(valueOrArray, 0) : void 0;
      }
      ts3.mapOneOrMany = mapOneOrMany;
      function firstOrOnly(valueOrArray) {
        return ts3.isArray(valueOrArray) ? ts3.first(valueOrArray) : valueOrArray;
      }
      ts3.firstOrOnly = firstOrOnly;
      function getNameForExportedSymbol(symbol, scriptTarget) {
        if (!(symbol.flags & 33554432) && (symbol.escapedName === "export=" || symbol.escapedName === "default")) {
          return ts3.firstDefined(symbol.declarations, function(d) {
            var _a2;
            return ts3.isExportAssignment(d) ? (_a2 = ts3.tryCast(ts3.skipOuterExpressions(d.expression), ts3.isIdentifier)) === null || _a2 === void 0 ? void 0 : _a2.text : void 0;
          }) || ts3.codefix.moduleSymbolToValidIdentifier(getSymbolParentOrFail(symbol), scriptTarget);
        }
        return symbol.name;
      }
      ts3.getNameForExportedSymbol = getNameForExportedSymbol;
      function getSymbolParentOrFail(symbol) {
        var _a2;
        return ts3.Debug.checkDefined(symbol.parent, "Symbol parent was undefined. Flags: " + ts3.Debug.formatSymbolFlags(symbol.flags) + ". " + ("Declarations: " + ((_a2 = symbol.declarations) === null || _a2 === void 0 ? void 0 : _a2.map(function(d) {
          var kind = ts3.Debug.formatSyntaxKind(d.kind);
          var inJS = ts3.isInJSFile(d);
          var expression = d.expression;
          return (inJS ? "[JS]" : "") + kind + (expression ? " (expression: " + ts3.Debug.formatSyntaxKind(expression.kind) + ")" : "");
        }).join(", ")) + "."));
      }
      function stringContainsAt(haystack, needle, startIndex) {
        var needleLength = needle.length;
        if (needleLength + startIndex > haystack.length) {
          return false;
        }
        for (var i3 = 0; i3 < needleLength; i3++) {
          if (needle.charCodeAt(i3) !== haystack.charCodeAt(i3 + startIndex))
            return false;
        }
        return true;
      }
      ts3.stringContainsAt = stringContainsAt;
      function startsWithUnderscore(name) {
        return name.charCodeAt(0) === 95;
      }
      ts3.startsWithUnderscore = startsWithUnderscore;
      function isGlobalDeclaration(declaration) {
        return !isNonGlobalDeclaration(declaration);
      }
      ts3.isGlobalDeclaration = isGlobalDeclaration;
      function isNonGlobalDeclaration(declaration) {
        var sourceFile = declaration.getSourceFile();
        if (!sourceFile.externalModuleIndicator && !sourceFile.commonJsModuleIndicator) {
          return false;
        }
        return ts3.isInJSFile(declaration) || !ts3.findAncestor(declaration, ts3.isGlobalScopeAugmentation);
      }
      ts3.isNonGlobalDeclaration = isNonGlobalDeclaration;
      var ImportKind;
      (function(ImportKind2) {
        ImportKind2[ImportKind2["Named"] = 0] = "Named";
        ImportKind2[ImportKind2["Default"] = 1] = "Default";
        ImportKind2[ImportKind2["Namespace"] = 2] = "Namespace";
        ImportKind2[ImportKind2["CommonJS"] = 3] = "CommonJS";
      })(ImportKind = ts3.ImportKind || (ts3.ImportKind = {}));
      var ExportKind;
      (function(ExportKind2) {
        ExportKind2[ExportKind2["Named"] = 0] = "Named";
        ExportKind2[ExportKind2["Default"] = 1] = "Default";
        ExportKind2[ExportKind2["ExportEquals"] = 2] = "ExportEquals";
        ExportKind2[ExportKind2["UMD"] = 3] = "UMD";
      })(ExportKind = ts3.ExportKind || (ts3.ExportKind = {}));
      function createExportMapCache() {
        var cache;
        var projectVersion;
        var usableByFileName;
        var wrapped = {
          isEmpty: function() {
            return !cache;
          },
          clear: function() {
            cache = void 0;
            projectVersion = void 0;
          },
          set: function(suggestions, version) {
            cache = suggestions;
            if (version) {
              projectVersion = version;
            }
          },
          get: function(file, checker, version) {
            if (usableByFileName && file !== usableByFileName) {
              return void 0;
            }
            if (version && projectVersion === version) {
              return cache;
            }
            cache === null || cache === void 0 ? void 0 : cache.forEach(function(infos) {
              var _a2, _b, _c;
              for (var _i = 0, infos_1 = infos; _i < infos_1.length; _i++) {
                var info = infos_1[_i];
                if ((_a2 = info.symbol.declarations) === null || _a2 === void 0 ? void 0 : _a2.length) {
                  info.symbol = checker.getMergedSymbol(info.exportKind === 1 ? (_b = info.symbol.declarations[0].localSymbol) !== null && _b !== void 0 ? _b : info.symbol.declarations[0].symbol : info.symbol.declarations[0].symbol);
                }
                if ((_c = info.moduleSymbol.declarations) === null || _c === void 0 ? void 0 : _c.length) {
                  info.moduleSymbol = checker.getMergedSymbol(info.moduleSymbol.declarations[0].symbol);
                }
              }
            });
            return cache;
          },
          onFileChanged: function(oldSourceFile, newSourceFile, typeAcquisitionEnabled) {
            if (fileIsGlobalOnly(oldSourceFile) && fileIsGlobalOnly(newSourceFile)) {
              return false;
            }
            if (usableByFileName && usableByFileName !== newSourceFile.path || typeAcquisitionEnabled && consumesNodeCoreModules(oldSourceFile) !== consumesNodeCoreModules(newSourceFile) || !ts3.arrayIsEqualTo(oldSourceFile.moduleAugmentations, newSourceFile.moduleAugmentations) || !ambientModuleDeclarationsAreEqual(oldSourceFile, newSourceFile)) {
              this.clear();
              return true;
            }
            usableByFileName = newSourceFile.path;
            return false;
          }
        };
        if (ts3.Debug.isDebugging) {
          Object.defineProperty(wrapped, "__cache", { get: function() {
            return cache;
          } });
        }
        return wrapped;
        function fileIsGlobalOnly(file) {
          return !file.commonJsModuleIndicator && !file.externalModuleIndicator && !file.moduleAugmentations && !file.ambientModuleNames;
        }
        function ambientModuleDeclarationsAreEqual(oldSourceFile, newSourceFile) {
          if (!ts3.arrayIsEqualTo(oldSourceFile.ambientModuleNames, newSourceFile.ambientModuleNames)) {
            return false;
          }
          var oldFileStatementIndex = -1;
          var newFileStatementIndex = -1;
          var _loop_1 = function(ambientModuleName2) {
            var isMatchingModuleDeclaration = function(node) {
              return ts3.isNonGlobalAmbientModule(node) && node.name.text === ambientModuleName2;
            };
            oldFileStatementIndex = ts3.findIndex(oldSourceFile.statements, isMatchingModuleDeclaration, oldFileStatementIndex + 1);
            newFileStatementIndex = ts3.findIndex(newSourceFile.statements, isMatchingModuleDeclaration, newFileStatementIndex + 1);
            if (oldSourceFile.statements[oldFileStatementIndex] !== newSourceFile.statements[newFileStatementIndex]) {
              return { value: false };
            }
          };
          for (var _i = 0, _a2 = newSourceFile.ambientModuleNames; _i < _a2.length; _i++) {
            var ambientModuleName = _a2[_i];
            var state_1 = _loop_1(ambientModuleName);
            if (typeof state_1 === "object")
              return state_1.value;
          }
          return true;
        }
      }
      ts3.createExportMapCache = createExportMapCache;
      function createModuleSpecifierCache() {
        var cache;
        var importingFileName;
        var wrapped = {
          get: function(fromFileName, toFileName) {
            if (!cache || fromFileName !== importingFileName)
              return void 0;
            return cache.get(toFileName);
          },
          set: function(fromFileName, toFileName, moduleSpecifiers) {
            if (cache && fromFileName !== importingFileName) {
              cache.clear();
            }
            importingFileName = fromFileName;
            (cache || (cache = new ts3.Map())).set(toFileName, moduleSpecifiers);
          },
          clear: function() {
            cache = void 0;
            importingFileName = void 0;
          },
          count: function() {
            return cache ? cache.size : 0;
          }
        };
        if (ts3.Debug.isDebugging) {
          Object.defineProperty(wrapped, "__cache", { get: function() {
            return cache;
          } });
        }
        return wrapped;
      }
      ts3.createModuleSpecifierCache = createModuleSpecifierCache;
      function isImportableFile(program2, from, to, packageJsonFilter, moduleSpecifierResolutionHost, moduleSpecifierCache) {
        var _a2;
        if (from === to)
          return false;
        var cachedResult = moduleSpecifierCache === null || moduleSpecifierCache === void 0 ? void 0 : moduleSpecifierCache.get(from.path, to.path);
        if (cachedResult !== void 0) {
          return !!cachedResult;
        }
        var getCanonicalFileName = ts3.hostGetCanonicalFileName(moduleSpecifierResolutionHost);
        var globalTypingsCache = (_a2 = moduleSpecifierResolutionHost.getGlobalTypingsCacheLocation) === null || _a2 === void 0 ? void 0 : _a2.call(moduleSpecifierResolutionHost);
        var hasImportablePath = !!ts3.moduleSpecifiers.forEachFileNameOfModule(from.fileName, to.fileName, moduleSpecifierResolutionHost, false, function(toPath) {
          var toFile = program2.getSourceFile(toPath);
          return (toFile === to || !toFile) && isImportablePath(from.fileName, toPath, getCanonicalFileName, globalTypingsCache);
        });
        if (packageJsonFilter) {
          var isImportable = hasImportablePath && packageJsonFilter.allowsImportingSourceFile(to, moduleSpecifierResolutionHost);
          moduleSpecifierCache === null || moduleSpecifierCache === void 0 ? void 0 : moduleSpecifierCache.set(from.path, to.path, isImportable);
          return isImportable;
        }
        return hasImportablePath;
      }
      ts3.isImportableFile = isImportableFile;
      function isImportablePath(fromPath, toPath, getCanonicalFileName, globalCachePath) {
        var toNodeModules = ts3.forEachAncestorDirectory(toPath, function(ancestor) {
          return ts3.getBaseFileName(ancestor) === "node_modules" ? ancestor : void 0;
        });
        var toNodeModulesParent = toNodeModules && ts3.getDirectoryPath(getCanonicalFileName(toNodeModules));
        return toNodeModulesParent === void 0 || ts3.startsWith(getCanonicalFileName(fromPath), toNodeModulesParent) || !!globalCachePath && ts3.startsWith(getCanonicalFileName(globalCachePath), toNodeModulesParent);
      }
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      function createClassifier() {
        var scanner = ts3.createScanner(99, false);
        function getClassificationsForLine(text, lexState, syntacticClassifierAbsent) {
          return convertClassificationsToResult(getEncodedLexicalClassifications(text, lexState, syntacticClassifierAbsent), text);
        }
        function getEncodedLexicalClassifications(text, lexState, syntacticClassifierAbsent) {
          var token = 0;
          var lastNonTriviaToken = 0;
          var templateStack = [];
          var _a2 = getPrefixFromLexState(lexState), prefix2 = _a2.prefix, pushTemplate = _a2.pushTemplate;
          text = prefix2 + text;
          var offset = prefix2.length;
          if (pushTemplate) {
            templateStack.push(15);
          }
          scanner.setText(text);
          var endOfLineState = 0;
          var spans = [];
          var angleBracketStack = 0;
          do {
            token = scanner.scan();
            if (!ts3.isTrivia(token)) {
              handleToken();
              lastNonTriviaToken = token;
            }
            var end = scanner.getTextPos();
            pushEncodedClassification(scanner.getTokenPos(), end, offset, classFromKind(token), spans);
            if (end >= text.length) {
              var end_1 = getNewEndOfLineState(scanner, token, ts3.lastOrUndefined(templateStack));
              if (end_1 !== void 0) {
                endOfLineState = end_1;
              }
            }
          } while (token !== 1);
          function handleToken() {
            switch (token) {
              case 43:
              case 67:
                if (!noRegexTable[lastNonTriviaToken] && scanner.reScanSlashToken() === 13) {
                  token = 13;
                }
                break;
              case 29:
                if (lastNonTriviaToken === 78) {
                  angleBracketStack++;
                }
                break;
              case 31:
                if (angleBracketStack > 0) {
                  angleBracketStack--;
                }
                break;
              case 128:
              case 147:
              case 144:
              case 131:
              case 148:
                if (angleBracketStack > 0 && !syntacticClassifierAbsent) {
                  token = 78;
                }
                break;
              case 15:
                templateStack.push(token);
                break;
              case 18:
                if (templateStack.length > 0) {
                  templateStack.push(token);
                }
                break;
              case 19:
                if (templateStack.length > 0) {
                  var lastTemplateStackToken = ts3.lastOrUndefined(templateStack);
                  if (lastTemplateStackToken === 15) {
                    token = scanner.reScanTemplateToken(false);
                    if (token === 17) {
                      templateStack.pop();
                    } else {
                      ts3.Debug.assertEqual(token, 16, "Should have been a template middle.");
                    }
                  } else {
                    ts3.Debug.assertEqual(lastTemplateStackToken, 18, "Should have been an open brace");
                    templateStack.pop();
                  }
                }
                break;
              default:
                if (!ts3.isKeyword(token)) {
                  break;
                }
                if (lastNonTriviaToken === 24) {
                  token = 78;
                } else if (ts3.isKeyword(lastNonTriviaToken) && ts3.isKeyword(token) && !canFollow(lastNonTriviaToken, token)) {
                  token = 78;
                }
            }
          }
          return { endOfLineState, spans };
        }
        return { getClassificationsForLine, getEncodedLexicalClassifications };
      }
      ts3.createClassifier = createClassifier;
      var noRegexTable = ts3.arrayToNumericMap([
        78,
        10,
        8,
        9,
        13,
        107,
        45,
        46,
        21,
        23,
        19,
        109,
        94
      ], function(token) {
        return token;
      }, function() {
        return true;
      });
      function getNewEndOfLineState(scanner, token, lastOnTemplateStack) {
        switch (token) {
          case 10: {
            if (!scanner.isUnterminated())
              return void 0;
            var tokenText = scanner.getTokenText();
            var lastCharIndex = tokenText.length - 1;
            var numBackslashes = 0;
            while (tokenText.charCodeAt(lastCharIndex - numBackslashes) === 92) {
              numBackslashes++;
            }
            if ((numBackslashes & 1) === 0)
              return void 0;
            return tokenText.charCodeAt(0) === 34 ? 3 : 2;
          }
          case 3:
            return scanner.isUnterminated() ? 1 : void 0;
          default:
            if (ts3.isTemplateLiteralKind(token)) {
              if (!scanner.isUnterminated()) {
                return void 0;
              }
              switch (token) {
                case 17:
                  return 5;
                case 14:
                  return 4;
                default:
                  return ts3.Debug.fail("Only 'NoSubstitutionTemplateLiteral's and 'TemplateTail's can be unterminated; got SyntaxKind #" + token);
              }
            }
            return lastOnTemplateStack === 15 ? 6 : void 0;
        }
      }
      function pushEncodedClassification(start, end, offset, classification, result2) {
        if (classification === 8) {
          return;
        }
        if (start === 0 && offset > 0) {
          start += offset;
        }
        var length = end - start;
        if (length > 0) {
          result2.push(start - offset, length, classification);
        }
      }
      function convertClassificationsToResult(classifications, text) {
        var entries = [];
        var dense = classifications.spans;
        var lastEnd = 0;
        for (var i3 = 0; i3 < dense.length; i3 += 3) {
          var start = dense[i3];
          var length_1 = dense[i3 + 1];
          var type3 = dense[i3 + 2];
          if (lastEnd >= 0) {
            var whitespaceLength_1 = start - lastEnd;
            if (whitespaceLength_1 > 0) {
              entries.push({ length: whitespaceLength_1, classification: ts3.TokenClass.Whitespace });
            }
          }
          entries.push({ length: length_1, classification: convertClassification(type3) });
          lastEnd = start + length_1;
        }
        var whitespaceLength = text.length - lastEnd;
        if (whitespaceLength > 0) {
          entries.push({ length: whitespaceLength, classification: ts3.TokenClass.Whitespace });
        }
        return { entries, finalLexState: classifications.endOfLineState };
      }
      function convertClassification(type3) {
        switch (type3) {
          case 1:
            return ts3.TokenClass.Comment;
          case 3:
            return ts3.TokenClass.Keyword;
          case 4:
            return ts3.TokenClass.NumberLiteral;
          case 25:
            return ts3.TokenClass.BigIntLiteral;
          case 5:
            return ts3.TokenClass.Operator;
          case 6:
            return ts3.TokenClass.StringLiteral;
          case 8:
            return ts3.TokenClass.Whitespace;
          case 10:
            return ts3.TokenClass.Punctuation;
          case 2:
          case 11:
          case 12:
          case 13:
          case 14:
          case 15:
          case 16:
          case 9:
          case 17:
            return ts3.TokenClass.Identifier;
          default:
            return void 0;
        }
      }
      function canFollow(keyword1, keyword2) {
        if (!ts3.isAccessibilityModifier(keyword1)) {
          return true;
        }
        switch (keyword2) {
          case 134:
          case 146:
          case 132:
          case 123:
            return true;
          default:
            return false;
        }
      }
      function getPrefixFromLexState(lexState) {
        switch (lexState) {
          case 3:
            return { prefix: '"\\\n' };
          case 2:
            return { prefix: "'\\\n" };
          case 1:
            return { prefix: "/*\n" };
          case 4:
            return { prefix: "`\n" };
          case 5:
            return { prefix: "}\n", pushTemplate: true };
          case 6:
            return { prefix: "", pushTemplate: true };
          case 0:
            return { prefix: "" };
          default:
            return ts3.Debug.assertNever(lexState);
        }
      }
      function isBinaryExpressionOperatorToken(token) {
        switch (token) {
          case 41:
          case 43:
          case 44:
          case 39:
          case 40:
          case 47:
          case 48:
          case 49:
          case 29:
          case 31:
          case 32:
          case 33:
          case 101:
          case 100:
          case 126:
          case 34:
          case 35:
          case 36:
          case 37:
          case 50:
          case 52:
          case 51:
          case 55:
          case 56:
          case 73:
          case 72:
          case 77:
          case 69:
          case 70:
          case 71:
          case 63:
          case 64:
          case 65:
          case 67:
          case 68:
          case 62:
          case 27:
          case 60:
          case 74:
          case 75:
          case 76:
            return true;
          default:
            return false;
        }
      }
      function isPrefixUnaryExpressionOperatorToken(token) {
        switch (token) {
          case 39:
          case 40:
          case 54:
          case 53:
          case 45:
          case 46:
            return true;
          default:
            return false;
        }
      }
      function classFromKind(token) {
        if (ts3.isKeyword(token)) {
          return 3;
        } else if (isBinaryExpressionOperatorToken(token) || isPrefixUnaryExpressionOperatorToken(token)) {
          return 5;
        } else if (token >= 18 && token <= 77) {
          return 10;
        }
        switch (token) {
          case 8:
            return 4;
          case 9:
            return 25;
          case 10:
            return 6;
          case 13:
            return 7;
          case 7:
          case 3:
          case 2:
            return 1;
          case 5:
          case 4:
            return 8;
          case 78:
          default:
            if (ts3.isTemplateLiteralKind(token)) {
              return 6;
            }
            return 2;
        }
      }
      function getSemanticClassifications(typeChecker, cancellationToken, sourceFile, classifiableNames, span) {
        return convertClassificationsToSpans(getEncodedSemanticClassifications(typeChecker, cancellationToken, sourceFile, classifiableNames, span));
      }
      ts3.getSemanticClassifications = getSemanticClassifications;
      function checkForClassificationCancellation(cancellationToken, kind) {
        switch (kind) {
          case 257:
          case 253:
          case 254:
          case 252:
          case 222:
          case 209:
          case 210:
            cancellationToken.throwIfCancellationRequested();
        }
      }
      function getEncodedSemanticClassifications(typeChecker, cancellationToken, sourceFile, classifiableNames, span) {
        var spans = [];
        sourceFile.forEachChild(function cb2(node) {
          if (!node || !ts3.textSpanIntersectsWith(span, node.pos, node.getFullWidth())) {
            return;
          }
          checkForClassificationCancellation(cancellationToken, node.kind);
          if (ts3.isIdentifier(node) && !ts3.nodeIsMissing(node) && classifiableNames.has(node.escapedText)) {
            var symbol = typeChecker.getSymbolAtLocation(node);
            var type3 = symbol && classifySymbol(symbol, ts3.getMeaningFromLocation(node), typeChecker);
            if (type3) {
              pushClassification(node.getStart(sourceFile), node.getEnd(), type3);
            }
          }
          node.forEachChild(cb2);
        });
        return { spans, endOfLineState: 0 };
        function pushClassification(start, end, type3) {
          var length = end - start;
          ts3.Debug.assert(length > 0, "Classification had non-positive length of " + length);
          spans.push(start);
          spans.push(length);
          spans.push(type3);
        }
      }
      ts3.getEncodedSemanticClassifications = getEncodedSemanticClassifications;
      function classifySymbol(symbol, meaningAtPosition, checker) {
        var flags = symbol.getFlags();
        if ((flags & 2885600) === 0) {
          return void 0;
        } else if (flags & 32) {
          return 11;
        } else if (flags & 384) {
          return 12;
        } else if (flags & 524288) {
          return 16;
        } else if (flags & 1536) {
          return meaningAtPosition & 4 || meaningAtPosition & 1 && hasValueSideModule(symbol) ? 14 : void 0;
        } else if (flags & 2097152) {
          return classifySymbol(checker.getAliasedSymbol(symbol), meaningAtPosition, checker);
        } else if (meaningAtPosition & 2) {
          return flags & 64 ? 13 : flags & 262144 ? 15 : void 0;
        } else {
          return void 0;
        }
      }
      function hasValueSideModule(symbol) {
        return ts3.some(symbol.declarations, function(declaration) {
          return ts3.isModuleDeclaration(declaration) && ts3.getModuleInstanceState(declaration) === 1;
        });
      }
      function getClassificationTypeName(type3) {
        switch (type3) {
          case 1:
            return "comment";
          case 2:
            return "identifier";
          case 3:
            return "keyword";
          case 4:
            return "number";
          case 25:
            return "bigint";
          case 5:
            return "operator";
          case 6:
            return "string";
          case 8:
            return "whitespace";
          case 9:
            return "text";
          case 10:
            return "punctuation";
          case 11:
            return "class name";
          case 12:
            return "enum name";
          case 13:
            return "interface name";
          case 14:
            return "module name";
          case 15:
            return "type parameter name";
          case 16:
            return "type alias name";
          case 17:
            return "parameter name";
          case 18:
            return "doc comment tag name";
          case 19:
            return "jsx open tag name";
          case 20:
            return "jsx close tag name";
          case 21:
            return "jsx self closing tag name";
          case 22:
            return "jsx attribute";
          case 23:
            return "jsx text";
          case 24:
            return "jsx attribute string literal value";
          default:
            return void 0;
        }
      }
      function convertClassificationsToSpans(classifications) {
        ts3.Debug.assert(classifications.spans.length % 3 === 0);
        var dense = classifications.spans;
        var result2 = [];
        for (var i3 = 0; i3 < dense.length; i3 += 3) {
          result2.push({
            textSpan: ts3.createTextSpan(dense[i3], dense[i3 + 1]),
            classificationType: getClassificationTypeName(dense[i3 + 2])
          });
        }
        return result2;
      }
      function getSyntacticClassifications(cancellationToken, sourceFile, span) {
        return convertClassificationsToSpans(getEncodedSyntacticClassifications(cancellationToken, sourceFile, span));
      }
      ts3.getSyntacticClassifications = getSyntacticClassifications;
      function getEncodedSyntacticClassifications(cancellationToken, sourceFile, span) {
        var spanStart = span.start;
        var spanLength = span.length;
        var triviaScanner = ts3.createScanner(99, false, sourceFile.languageVariant, sourceFile.text);
        var mergeConflictScanner = ts3.createScanner(99, false, sourceFile.languageVariant, sourceFile.text);
        var result2 = [];
        processElement(sourceFile);
        return { spans: result2, endOfLineState: 0 };
        function pushClassification(start, length, type3) {
          result2.push(start);
          result2.push(length);
          result2.push(type3);
        }
        function classifyLeadingTriviaAndGetTokenStart(token) {
          triviaScanner.setTextPos(token.pos);
          while (true) {
            var start = triviaScanner.getTextPos();
            if (!ts3.couldStartTrivia(sourceFile.text, start)) {
              return start;
            }
            var kind = triviaScanner.scan();
            var end = triviaScanner.getTextPos();
            var width = end - start;
            if (!ts3.isTrivia(kind)) {
              return start;
            }
            switch (kind) {
              case 4:
              case 5:
                continue;
              case 2:
              case 3:
                classifyComment(token, kind, start, width);
                triviaScanner.setTextPos(end);
                continue;
              case 7:
                var text = sourceFile.text;
                var ch = text.charCodeAt(start);
                if (ch === 60 || ch === 62) {
                  pushClassification(start, width, 1);
                  continue;
                }
                ts3.Debug.assert(ch === 124 || ch === 61);
                classifyDisabledMergeCode(text, start, end);
                break;
              case 6:
                break;
              default:
                ts3.Debug.assertNever(kind);
            }
          }
        }
        function classifyComment(token, kind, start, width) {
          if (kind === 3) {
            var docCommentAndDiagnostics = ts3.parseIsolatedJSDocComment(sourceFile.text, start, width);
            if (docCommentAndDiagnostics && docCommentAndDiagnostics.jsDoc) {
              ts3.setParent(docCommentAndDiagnostics.jsDoc, token);
              classifyJSDocComment(docCommentAndDiagnostics.jsDoc);
              return;
            }
          } else if (kind === 2) {
            if (tryClassifyTripleSlashComment(start, width)) {
              return;
            }
          }
          pushCommentRange(start, width);
        }
        function pushCommentRange(start, width) {
          pushClassification(start, width, 1);
        }
        function classifyJSDocComment(docComment) {
          var _a2, _b, _c, _d, _e, _f, _g;
          var pos = docComment.pos;
          if (docComment.tags) {
            for (var _i = 0, _h = docComment.tags; _i < _h.length; _i++) {
              var tag = _h[_i];
              if (tag.pos !== pos) {
                pushCommentRange(pos, tag.pos - pos);
              }
              pushClassification(tag.pos, 1, 10);
              pushClassification(tag.tagName.pos, tag.tagName.end - tag.tagName.pos, 18);
              pos = tag.tagName.end;
              var commentStart = tag.tagName.end;
              switch (tag.kind) {
                case 330:
                  var param = tag;
                  processJSDocParameterTag(param);
                  commentStart = param.isNameFirst && ((_a2 = param.typeExpression) === null || _a2 === void 0 ? void 0 : _a2.end) || param.name.end;
                  break;
                case 337:
                  var prop = tag;
                  commentStart = prop.isNameFirst && ((_b = prop.typeExpression) === null || _b === void 0 ? void 0 : _b.end) || prop.name.end;
                  break;
                case 334:
                  processJSDocTemplateTag(tag);
                  pos = tag.end;
                  commentStart = tag.typeParameters.end;
                  break;
                case 335:
                  var type3 = tag;
                  commentStart = ((_c = type3.typeExpression) === null || _c === void 0 ? void 0 : _c.kind) === 302 && ((_d = type3.fullName) === null || _d === void 0 ? void 0 : _d.end) || ((_e = type3.typeExpression) === null || _e === void 0 ? void 0 : _e.end) || commentStart;
                  break;
                case 328:
                  commentStart = tag.typeExpression.end;
                  break;
                case 333:
                  processElement(tag.typeExpression);
                  pos = tag.end;
                  commentStart = tag.typeExpression.end;
                  break;
                case 332:
                case 329:
                  commentStart = tag.typeExpression.end;
                  break;
                case 331:
                  processElement(tag.typeExpression);
                  pos = tag.end;
                  commentStart = ((_f = tag.typeExpression) === null || _f === void 0 ? void 0 : _f.end) || commentStart;
                  break;
                case 336:
                  commentStart = ((_g = tag.name) === null || _g === void 0 ? void 0 : _g.end) || commentStart;
                  break;
                case 318:
                case 319:
                  commentStart = tag.class.end;
                  break;
              }
              if (typeof tag.comment === "object") {
                pushCommentRange(tag.comment.pos, tag.comment.end - tag.comment.pos);
              } else if (typeof tag.comment === "string") {
                pushCommentRange(commentStart, tag.end - commentStart);
              }
            }
          }
          if (pos !== docComment.end) {
            pushCommentRange(pos, docComment.end - pos);
          }
          return;
          function processJSDocParameterTag(tag2) {
            if (tag2.isNameFirst) {
              pushCommentRange(pos, tag2.name.pos - pos);
              pushClassification(tag2.name.pos, tag2.name.end - tag2.name.pos, 17);
              pos = tag2.name.end;
            }
            if (tag2.typeExpression) {
              pushCommentRange(pos, tag2.typeExpression.pos - pos);
              processElement(tag2.typeExpression);
              pos = tag2.typeExpression.end;
            }
            if (!tag2.isNameFirst) {
              pushCommentRange(pos, tag2.name.pos - pos);
              pushClassification(tag2.name.pos, tag2.name.end - tag2.name.pos, 17);
              pos = tag2.name.end;
            }
          }
        }
        function tryClassifyTripleSlashComment(start, width) {
          var tripleSlashXMLCommentRegEx = /^(\/\/\/\s*)(<)(?:(\S+)((?:[^/]|\/[^>])*)(\/>)?)?/im;
          var attributeRegex = /(\S+)(\s*)(=)(\s*)('[^']+'|"[^"]+")/img;
          var text = sourceFile.text.substr(start, width);
          var match = tripleSlashXMLCommentRegEx.exec(text);
          if (!match) {
            return false;
          }
          if (!match[3] || !(match[3] in ts3.commentPragmas)) {
            return false;
          }
          var pos = start;
          pushCommentRange(pos, match[1].length);
          pos += match[1].length;
          pushClassification(pos, match[2].length, 10);
          pos += match[2].length;
          pushClassification(pos, match[3].length, 21);
          pos += match[3].length;
          var attrText = match[4];
          var attrPos = pos;
          while (true) {
            var attrMatch = attributeRegex.exec(attrText);
            if (!attrMatch) {
              break;
            }
            var newAttrPos = pos + attrMatch.index;
            if (newAttrPos > attrPos) {
              pushCommentRange(attrPos, newAttrPos - attrPos);
              attrPos = newAttrPos;
            }
            pushClassification(attrPos, attrMatch[1].length, 22);
            attrPos += attrMatch[1].length;
            if (attrMatch[2].length) {
              pushCommentRange(attrPos, attrMatch[2].length);
              attrPos += attrMatch[2].length;
            }
            pushClassification(attrPos, attrMatch[3].length, 5);
            attrPos += attrMatch[3].length;
            if (attrMatch[4].length) {
              pushCommentRange(attrPos, attrMatch[4].length);
              attrPos += attrMatch[4].length;
            }
            pushClassification(attrPos, attrMatch[5].length, 24);
            attrPos += attrMatch[5].length;
          }
          pos += match[4].length;
          if (pos > attrPos) {
            pushCommentRange(attrPos, pos - attrPos);
          }
          if (match[5]) {
            pushClassification(pos, match[5].length, 10);
            pos += match[5].length;
          }
          var end = start + width;
          if (pos < end) {
            pushCommentRange(pos, end - pos);
          }
          return true;
        }
        function processJSDocTemplateTag(tag) {
          for (var _i = 0, _a2 = tag.getChildren(); _i < _a2.length; _i++) {
            var child = _a2[_i];
            processElement(child);
          }
        }
        function classifyDisabledMergeCode(text, start, end) {
          var i3;
          for (i3 = start; i3 < end; i3++) {
            if (ts3.isLineBreak(text.charCodeAt(i3))) {
              break;
            }
          }
          pushClassification(start, i3 - start, 1);
          mergeConflictScanner.setTextPos(i3);
          while (mergeConflictScanner.getTextPos() < end) {
            classifyDisabledCodeToken();
          }
        }
        function classifyDisabledCodeToken() {
          var start = mergeConflictScanner.getTextPos();
          var tokenKind = mergeConflictScanner.scan();
          var end = mergeConflictScanner.getTextPos();
          var type3 = classifyTokenType(tokenKind);
          if (type3) {
            pushClassification(start, end - start, type3);
          }
        }
        function tryClassifyNode(node) {
          if (ts3.isJSDoc(node)) {
            return true;
          }
          if (ts3.nodeIsMissing(node)) {
            return true;
          }
          var classifiedElementName = tryClassifyJsxElementName(node);
          if (!ts3.isToken(node) && node.kind !== 11 && classifiedElementName === void 0) {
            return false;
          }
          var tokenStart = node.kind === 11 ? node.pos : classifyLeadingTriviaAndGetTokenStart(node);
          var tokenWidth = node.end - tokenStart;
          ts3.Debug.assert(tokenWidth >= 0);
          if (tokenWidth > 0) {
            var type3 = classifiedElementName || classifyTokenType(node.kind, node);
            if (type3) {
              pushClassification(tokenStart, tokenWidth, type3);
            }
          }
          return true;
        }
        function tryClassifyJsxElementName(token) {
          switch (token.parent && token.parent.kind) {
            case 276:
              if (token.parent.tagName === token) {
                return 19;
              }
              break;
            case 277:
              if (token.parent.tagName === token) {
                return 20;
              }
              break;
            case 275:
              if (token.parent.tagName === token) {
                return 21;
              }
              break;
            case 281:
              if (token.parent.name === token) {
                return 22;
              }
              break;
          }
          return void 0;
        }
        function classifyTokenType(tokenKind, token) {
          if (ts3.isKeyword(tokenKind)) {
            return 3;
          }
          if (tokenKind === 29 || tokenKind === 31) {
            if (token && ts3.getTypeArgumentOrTypeParameterList(token.parent)) {
              return 10;
            }
          }
          if (ts3.isPunctuation(tokenKind)) {
            if (token) {
              var parent = token.parent;
              if (tokenKind === 62) {
                if (parent.kind === 250 || parent.kind === 164 || parent.kind === 161 || parent.kind === 281) {
                  return 5;
                }
              }
              if (parent.kind === 217 || parent.kind === 215 || parent.kind === 216 || parent.kind === 218) {
                return 5;
              }
            }
            return 10;
          } else if (tokenKind === 8) {
            return 4;
          } else if (tokenKind === 9) {
            return 25;
          } else if (tokenKind === 10) {
            return token && token.parent.kind === 281 ? 24 : 6;
          } else if (tokenKind === 13) {
            return 6;
          } else if (ts3.isTemplateLiteralKind(tokenKind)) {
            return 6;
          } else if (tokenKind === 11) {
            return 23;
          } else if (tokenKind === 78) {
            if (token) {
              switch (token.parent.kind) {
                case 253:
                  if (token.parent.name === token) {
                    return 11;
                  }
                  return;
                case 160:
                  if (token.parent.name === token) {
                    return 15;
                  }
                  return;
                case 254:
                  if (token.parent.name === token) {
                    return 13;
                  }
                  return;
                case 256:
                  if (token.parent.name === token) {
                    return 12;
                  }
                  return;
                case 257:
                  if (token.parent.name === token) {
                    return 14;
                  }
                  return;
                case 161:
                  if (token.parent.name === token) {
                    return ts3.isThisIdentifier(token) ? 3 : 17;
                  }
                  return;
              }
            }
            return 2;
          }
        }
        function processElement(element) {
          if (!element) {
            return;
          }
          if (ts3.decodedTextSpanIntersectsWith(spanStart, spanLength, element.pos, element.getFullWidth())) {
            checkForClassificationCancellation(cancellationToken, element.kind);
            for (var _i = 0, _a2 = element.getChildren(sourceFile); _i < _a2.length; _i++) {
              var child = _a2[_i];
              if (!tryClassifyNode(child)) {
                processElement(child);
              }
            }
          }
        }
      }
      ts3.getEncodedSyntacticClassifications = getEncodedSyntacticClassifications;
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var classifier;
      (function(classifier2) {
        var v2020;
        (function(v20202) {
          var TokenEncodingConsts;
          (function(TokenEncodingConsts2) {
            TokenEncodingConsts2[TokenEncodingConsts2["typeOffset"] = 8] = "typeOffset";
            TokenEncodingConsts2[TokenEncodingConsts2["modifierMask"] = 255] = "modifierMask";
          })(TokenEncodingConsts = v20202.TokenEncodingConsts || (v20202.TokenEncodingConsts = {}));
          var TokenType;
          (function(TokenType2) {
            TokenType2[TokenType2["class"] = 0] = "class";
            TokenType2[TokenType2["enum"] = 1] = "enum";
            TokenType2[TokenType2["interface"] = 2] = "interface";
            TokenType2[TokenType2["namespace"] = 3] = "namespace";
            TokenType2[TokenType2["typeParameter"] = 4] = "typeParameter";
            TokenType2[TokenType2["type"] = 5] = "type";
            TokenType2[TokenType2["parameter"] = 6] = "parameter";
            TokenType2[TokenType2["variable"] = 7] = "variable";
            TokenType2[TokenType2["enumMember"] = 8] = "enumMember";
            TokenType2[TokenType2["property"] = 9] = "property";
            TokenType2[TokenType2["function"] = 10] = "function";
            TokenType2[TokenType2["member"] = 11] = "member";
          })(TokenType = v20202.TokenType || (v20202.TokenType = {}));
          var TokenModifier;
          (function(TokenModifier2) {
            TokenModifier2[TokenModifier2["declaration"] = 0] = "declaration";
            TokenModifier2[TokenModifier2["static"] = 1] = "static";
            TokenModifier2[TokenModifier2["async"] = 2] = "async";
            TokenModifier2[TokenModifier2["readonly"] = 3] = "readonly";
            TokenModifier2[TokenModifier2["defaultLibrary"] = 4] = "defaultLibrary";
            TokenModifier2[TokenModifier2["local"] = 5] = "local";
          })(TokenModifier = v20202.TokenModifier || (v20202.TokenModifier = {}));
          function getSemanticClassifications(program2, cancellationToken, sourceFile, span) {
            var classifications = getEncodedSemanticClassifications(program2, cancellationToken, sourceFile, span);
            ts3.Debug.assert(classifications.spans.length % 3 === 0);
            var dense = classifications.spans;
            var result2 = [];
            for (var i3 = 0; i3 < dense.length; i3 += 3) {
              result2.push({
                textSpan: ts3.createTextSpan(dense[i3], dense[i3 + 1]),
                classificationType: dense[i3 + 2]
              });
            }
            return result2;
          }
          v20202.getSemanticClassifications = getSemanticClassifications;
          function getEncodedSemanticClassifications(program2, cancellationToken, sourceFile, span) {
            return {
              spans: getSemanticTokens(program2, sourceFile, span, cancellationToken),
              endOfLineState: 0
            };
          }
          v20202.getEncodedSemanticClassifications = getEncodedSemanticClassifications;
          function getSemanticTokens(program2, sourceFile, span, cancellationToken) {
            var resultTokens = [];
            var collector = function(node, typeIdx, modifierSet) {
              resultTokens.push(node.getStart(sourceFile), node.getWidth(sourceFile), (typeIdx + 1 << 8) + modifierSet);
            };
            if (program2 && sourceFile) {
              collectTokens(program2, sourceFile, span, collector, cancellationToken);
            }
            return resultTokens;
          }
          function collectTokens(program2, sourceFile, span, collector, cancellationToken) {
            var typeChecker = program2.getTypeChecker();
            var inJSXElement = false;
            function visit(node) {
              switch (node.kind) {
                case 257:
                case 253:
                case 254:
                case 252:
                case 222:
                case 209:
                case 210:
                  cancellationToken.throwIfCancellationRequested();
              }
              if (!node || !ts3.textSpanIntersectsWith(span, node.pos, node.getFullWidth()) || node.getFullWidth() === 0) {
                return;
              }
              var prevInJSXElement = inJSXElement;
              if (ts3.isJsxElement(node) || ts3.isJsxSelfClosingElement(node)) {
                inJSXElement = true;
              }
              if (ts3.isJsxExpression(node)) {
                inJSXElement = false;
              }
              if (ts3.isIdentifier(node) && !inJSXElement && !inImportClause(node)) {
                var symbol = typeChecker.getSymbolAtLocation(node);
                if (symbol) {
                  if (symbol.flags & 2097152) {
                    symbol = typeChecker.getAliasedSymbol(symbol);
                  }
                  var typeIdx = classifySymbol(symbol, ts3.getMeaningFromLocation(node));
                  if (typeIdx !== void 0) {
                    var modifierSet = 0;
                    if (node.parent) {
                      var parentIsDeclaration = ts3.isBindingElement(node.parent) || tokenFromDeclarationMapping.get(node.parent.kind) === typeIdx;
                      if (parentIsDeclaration && node.parent.name === node) {
                        modifierSet = 1 << 0;
                      }
                    }
                    if (typeIdx === 6 && isRightSideOfQualifiedNameOrPropertyAccess(node)) {
                      typeIdx = 9;
                    }
                    typeIdx = reclassifyByType(typeChecker, node, typeIdx);
                    var decl = symbol.valueDeclaration;
                    if (decl) {
                      var modifiers = ts3.getCombinedModifierFlags(decl);
                      var nodeFlags = ts3.getCombinedNodeFlags(decl);
                      if (modifiers & 32) {
                        modifierSet |= 1 << 1;
                      }
                      if (modifiers & 256) {
                        modifierSet |= 1 << 2;
                      }
                      if (typeIdx !== 0 && typeIdx !== 2) {
                        if (modifiers & 64 || nodeFlags & 2 || symbol.getFlags() & 8) {
                          modifierSet |= 1 << 3;
                        }
                      }
                      if ((typeIdx === 7 || typeIdx === 10) && isLocalDeclaration(decl, sourceFile)) {
                        modifierSet |= 1 << 5;
                      }
                      if (program2.isSourceFileDefaultLibrary(decl.getSourceFile())) {
                        modifierSet |= 1 << 4;
                      }
                    } else if (symbol.declarations && symbol.declarations.some(function(d) {
                      return program2.isSourceFileDefaultLibrary(d.getSourceFile());
                    })) {
                      modifierSet |= 1 << 4;
                    }
                    collector(node, typeIdx, modifierSet);
                  }
                }
              }
              ts3.forEachChild(node, visit);
              inJSXElement = prevInJSXElement;
            }
            visit(sourceFile);
          }
          function classifySymbol(symbol, meaning) {
            var flags = symbol.getFlags();
            if (flags & 32) {
              return 0;
            } else if (flags & 384) {
              return 1;
            } else if (flags & 524288) {
              return 5;
            } else if (flags & 64) {
              if (meaning & 2) {
                return 2;
              }
            } else if (flags & 262144) {
              return 4;
            }
            var decl = symbol.valueDeclaration || symbol.declarations && symbol.declarations[0];
            if (decl && ts3.isBindingElement(decl)) {
              decl = getDeclarationForBindingElement(decl);
            }
            return decl && tokenFromDeclarationMapping.get(decl.kind);
          }
          function reclassifyByType(typeChecker, node, typeIdx) {
            if (typeIdx === 7 || typeIdx === 9 || typeIdx === 6) {
              var type_1 = typeChecker.getTypeAtLocation(node);
              if (type_1) {
                var test = function(condition) {
                  return condition(type_1) || type_1.isUnion() && type_1.types.some(condition);
                };
                if (typeIdx !== 6 && test(function(t2) {
                  return t2.getConstructSignatures().length > 0;
                })) {
                  return 0;
                }
                if (test(function(t2) {
                  return t2.getCallSignatures().length > 0;
                }) && !test(function(t2) {
                  return t2.getProperties().length > 0;
                }) || isExpressionInCallExpression(node)) {
                  return typeIdx === 9 ? 11 : 10;
                }
              }
            }
            return typeIdx;
          }
          function isLocalDeclaration(decl, sourceFile) {
            if (ts3.isBindingElement(decl)) {
              decl = getDeclarationForBindingElement(decl);
            }
            if (ts3.isVariableDeclaration(decl)) {
              return (!ts3.isSourceFile(decl.parent.parent.parent) || ts3.isCatchClause(decl.parent)) && decl.getSourceFile() === sourceFile;
            } else if (ts3.isFunctionDeclaration(decl)) {
              return !ts3.isSourceFile(decl.parent) && decl.getSourceFile() === sourceFile;
            }
            return false;
          }
          function getDeclarationForBindingElement(element) {
            while (true) {
              if (ts3.isBindingElement(element.parent.parent)) {
                element = element.parent.parent;
              } else {
                return element.parent.parent;
              }
            }
          }
          function inImportClause(node) {
            var parent = node.parent;
            return parent && (ts3.isImportClause(parent) || ts3.isImportSpecifier(parent) || ts3.isNamespaceImport(parent));
          }
          function isExpressionInCallExpression(node) {
            while (isRightSideOfQualifiedNameOrPropertyAccess(node)) {
              node = node.parent;
            }
            return ts3.isCallExpression(node.parent) && node.parent.expression === node;
          }
          function isRightSideOfQualifiedNameOrPropertyAccess(node) {
            return ts3.isQualifiedName(node.parent) && node.parent.right === node || ts3.isPropertyAccessExpression(node.parent) && node.parent.name === node;
          }
          var tokenFromDeclarationMapping = new ts3.Map([
            [250, 7],
            [161, 6],
            [164, 9],
            [257, 3],
            [256, 1],
            [292, 8],
            [253, 0],
            [166, 11],
            [252, 10],
            [209, 10],
            [165, 11],
            [168, 9],
            [169, 9],
            [163, 9],
            [254, 2],
            [255, 5],
            [160, 4],
            [289, 9],
            [290, 9]
          ]);
        })(v2020 = classifier2.v2020 || (classifier2.v2020 = {}));
      })(classifier = ts3.classifier || (ts3.classifier = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var Completions;
      (function(Completions2) {
        var StringCompletions;
        (function(StringCompletions2) {
          function getStringLiteralCompletions(sourceFile, position, contextToken, checker, options, host, log, preferences) {
            if (ts3.isInReferenceComment(sourceFile, position)) {
              var entries = getTripleSlashReferenceCompletion(sourceFile, position, options, host);
              return entries && convertPathCompletions(entries);
            }
            if (ts3.isInString(sourceFile, position, contextToken)) {
              if (!contextToken || !ts3.isStringLiteralLike(contextToken))
                return void 0;
              var entries = getStringLiteralCompletionEntries(sourceFile, contextToken, position, checker, options, host, preferences);
              return convertStringLiteralCompletions(entries, contextToken, sourceFile, checker, log, options, preferences);
            }
          }
          StringCompletions2.getStringLiteralCompletions = getStringLiteralCompletions;
          function convertStringLiteralCompletions(completion, contextToken, sourceFile, checker, log, options, preferences) {
            if (completion === void 0) {
              return void 0;
            }
            var optionalReplacementSpan = ts3.createTextSpanFromStringLiteralLikeContent(contextToken);
            switch (completion.kind) {
              case 0:
                return convertPathCompletions(completion.paths);
              case 1: {
                var entries = [];
                Completions2.getCompletionEntriesFromSymbols(completion.symbols, entries, contextToken, sourceFile, sourceFile, checker, 99, log, 4, preferences, options);
                return { isGlobalCompletion: false, isMemberCompletion: true, isNewIdentifierLocation: completion.hasIndexSignature, optionalReplacementSpan, entries };
              }
              case 2: {
                var entries = completion.types.map(function(type3) {
                  return {
                    name: type3.value,
                    kindModifiers: "",
                    kind: "string",
                    sortText: Completions2.SortText.LocationPriority,
                    replacementSpan: ts3.getReplacementSpanForContextToken(contextToken)
                  };
                });
                return { isGlobalCompletion: false, isMemberCompletion: false, isNewIdentifierLocation: completion.isNewIdentifier, optionalReplacementSpan, entries };
              }
              default:
                return ts3.Debug.assertNever(completion);
            }
          }
          function getStringLiteralCompletionDetails(name, sourceFile, position, contextToken, checker, options, host, cancellationToken, preferences) {
            if (!contextToken || !ts3.isStringLiteralLike(contextToken))
              return void 0;
            var completions = getStringLiteralCompletionEntries(sourceFile, contextToken, position, checker, options, host, preferences);
            return completions && stringLiteralCompletionDetails(name, contextToken, completions, sourceFile, checker, cancellationToken);
          }
          StringCompletions2.getStringLiteralCompletionDetails = getStringLiteralCompletionDetails;
          function stringLiteralCompletionDetails(name, location, completion, sourceFile, checker, cancellationToken) {
            switch (completion.kind) {
              case 0: {
                var match = ts3.find(completion.paths, function(p) {
                  return p.name === name;
                });
                return match && Completions2.createCompletionDetails(name, kindModifiersFromExtension(match.extension), match.kind, [ts3.textPart(name)]);
              }
              case 1: {
                var match = ts3.find(completion.symbols, function(s2) {
                  return s2.name === name;
                });
                return match && Completions2.createCompletionDetailsForSymbol(match, checker, sourceFile, location, cancellationToken);
              }
              case 2:
                return ts3.find(completion.types, function(t2) {
                  return t2.value === name;
                }) ? Completions2.createCompletionDetails(name, "", "type", [ts3.textPart(name)]) : void 0;
              default:
                return ts3.Debug.assertNever(completion);
            }
          }
          function convertPathCompletions(pathCompletions) {
            var isGlobalCompletion = false;
            var isNewIdentifierLocation = true;
            var entries = pathCompletions.map(function(_a2) {
              var name = _a2.name, kind = _a2.kind, span = _a2.span, extension = _a2.extension;
              return { name, kind, kindModifiers: kindModifiersFromExtension(extension), sortText: Completions2.SortText.LocationPriority, replacementSpan: span };
            });
            return { isGlobalCompletion, isMemberCompletion: false, isNewIdentifierLocation, entries };
          }
          function kindModifiersFromExtension(extension) {
            switch (extension) {
              case ".d.ts":
                return ".d.ts";
              case ".js":
                return ".js";
              case ".json":
                return ".json";
              case ".jsx":
                return ".jsx";
              case ".ts":
                return ".ts";
              case ".tsx":
                return ".tsx";
              case ".tsbuildinfo":
                return ts3.Debug.fail("Extension .tsbuildinfo is unsupported.");
              case void 0:
                return "";
              default:
                return ts3.Debug.assertNever(extension);
            }
          }
          var StringLiteralCompletionKind;
          (function(StringLiteralCompletionKind2) {
            StringLiteralCompletionKind2[StringLiteralCompletionKind2["Paths"] = 0] = "Paths";
            StringLiteralCompletionKind2[StringLiteralCompletionKind2["Properties"] = 1] = "Properties";
            StringLiteralCompletionKind2[StringLiteralCompletionKind2["Types"] = 2] = "Types";
          })(StringLiteralCompletionKind || (StringLiteralCompletionKind = {}));
          function getStringLiteralCompletionEntries(sourceFile, node, position, typeChecker, compilerOptions, host, preferences) {
            var parent = walkUpParentheses(node.parent);
            switch (parent.kind) {
              case 192: {
                var grandParent = walkUpParentheses(parent.parent);
                switch (grandParent.kind) {
                  case 174: {
                    var typeReference_1 = grandParent;
                    var typeArgument = ts3.findAncestor(parent, function(n2) {
                      return n2.parent === typeReference_1;
                    });
                    if (typeArgument) {
                      return { kind: 2, types: getStringLiteralTypes(typeChecker.getTypeArgumentConstraint(typeArgument)), isNewIdentifier: false };
                    }
                    return void 0;
                  }
                  case 190:
                    var _a2 = grandParent, indexType = _a2.indexType, objectType = _a2.objectType;
                    if (!ts3.rangeContainsPosition(indexType, position)) {
                      return void 0;
                    }
                    return stringLiteralCompletionsFromProperties(typeChecker.getTypeFromTypeNode(objectType));
                  case 196:
                    return { kind: 0, paths: getStringLiteralCompletionsFromModuleNames(sourceFile, node, compilerOptions, host, typeChecker, preferences) };
                  case 183: {
                    if (!ts3.isTypeReferenceNode(grandParent.parent)) {
                      return void 0;
                    }
                    var alreadyUsedTypes_1 = getAlreadyUsedTypesInStringLiteralUnion(grandParent, parent);
                    var types2 = getStringLiteralTypes(typeChecker.getTypeArgumentConstraint(grandParent)).filter(function(t2) {
                      return !ts3.contains(alreadyUsedTypes_1, t2.value);
                    });
                    return { kind: 2, types: types2, isNewIdentifier: false };
                  }
                  default:
                    return void 0;
                }
              }
              case 289:
                if (ts3.isObjectLiteralExpression(parent.parent) && parent.name === node) {
                  return stringLiteralCompletionsForObjectLiteral(typeChecker, parent.parent);
                }
                return fromContextualType();
              case 203: {
                var _b = parent, expression = _b.expression, argumentExpression = _b.argumentExpression;
                if (node === ts3.skipParentheses(argumentExpression)) {
                  return stringLiteralCompletionsFromProperties(typeChecker.getTypeAtLocation(expression));
                }
                return void 0;
              }
              case 204:
              case 205:
                if (!ts3.isRequireCall(parent, false) && !ts3.isImportCall(parent)) {
                  var argumentInfo = ts3.SignatureHelp.getArgumentInfoForCompletions(node, position, sourceFile);
                  return argumentInfo ? getStringLiteralCompletionsFromSignature(argumentInfo, typeChecker) : fromContextualType();
                }
              case 262:
              case 268:
              case 273:
                return { kind: 0, paths: getStringLiteralCompletionsFromModuleNames(sourceFile, node, compilerOptions, host, typeChecker, preferences) };
              default:
                return fromContextualType();
            }
            function fromContextualType() {
              return { kind: 2, types: getStringLiteralTypes(ts3.getContextualTypeFromParent(node, typeChecker)), isNewIdentifier: false };
            }
          }
          function walkUpParentheses(node) {
            switch (node.kind) {
              case 187:
                return ts3.walkUpParenthesizedTypes(node);
              case 208:
                return ts3.walkUpParenthesizedExpressions(node);
              default:
                return node;
            }
          }
          function getAlreadyUsedTypesInStringLiteralUnion(union, current) {
            return ts3.mapDefined(union.types, function(type3) {
              return type3 !== current && ts3.isLiteralTypeNode(type3) && ts3.isStringLiteral(type3.literal) ? type3.literal.text : void 0;
            });
          }
          function getStringLiteralCompletionsFromSignature(argumentInfo, checker) {
            var isNewIdentifier = false;
            var uniques = new ts3.Map();
            var candidates = [];
            checker.getResolvedSignature(argumentInfo.invocation, candidates, argumentInfo.argumentCount);
            var types2 = ts3.flatMap(candidates, function(candidate) {
              if (!ts3.signatureHasRestParameter(candidate) && argumentInfo.argumentCount > candidate.parameters.length)
                return;
              var type3 = checker.getParameterType(candidate, argumentInfo.argumentIndex);
              isNewIdentifier = isNewIdentifier || !!(type3.flags & 4);
              return getStringLiteralTypes(type3, uniques);
            });
            return { kind: 2, types: types2, isNewIdentifier };
          }
          function stringLiteralCompletionsFromProperties(type3) {
            return type3 && {
              kind: 1,
              symbols: ts3.filter(type3.getApparentProperties(), function(prop) {
                return !(prop.valueDeclaration && ts3.isPrivateIdentifierClassElementDeclaration(prop.valueDeclaration));
              }),
              hasIndexSignature: ts3.hasIndexSignature(type3)
            };
          }
          function stringLiteralCompletionsForObjectLiteral(checker, objectLiteralExpression) {
            var contextualType = checker.getContextualType(objectLiteralExpression);
            if (!contextualType)
              return void 0;
            var completionsType = checker.getContextualType(objectLiteralExpression, 4);
            var symbols = Completions2.getPropertiesForObjectExpression(contextualType, completionsType, objectLiteralExpression, checker);
            return {
              kind: 1,
              symbols,
              hasIndexSignature: ts3.hasIndexSignature(contextualType)
            };
          }
          function getStringLiteralTypes(type3, uniques) {
            if (uniques === void 0) {
              uniques = new ts3.Map();
            }
            if (!type3)
              return ts3.emptyArray;
            type3 = ts3.skipConstraint(type3);
            return type3.isUnion() ? ts3.flatMap(type3.types, function(t2) {
              return getStringLiteralTypes(t2, uniques);
            }) : type3.isStringLiteral() && !(type3.flags & 1024) && ts3.addToSeen(uniques, type3.value) ? [type3] : ts3.emptyArray;
          }
          function nameAndKind(name, kind, extension) {
            return { name, kind, extension };
          }
          function directoryResult(name) {
            return nameAndKind(name, "directory", void 0);
          }
          function addReplacementSpans(text, textStart, names) {
            var span = getDirectoryFragmentTextSpan(text, textStart);
            var wholeSpan = text.length === 0 ? void 0 : ts3.createTextSpan(textStart, text.length);
            return names.map(function(_a2) {
              var name = _a2.name, kind = _a2.kind, extension = _a2.extension;
              return Math.max(name.indexOf(ts3.directorySeparator), name.indexOf(ts3.altDirectorySeparator)) !== -1 ? { name, kind, extension, span: wholeSpan } : { name, kind, extension, span };
            });
          }
          function getStringLiteralCompletionsFromModuleNames(sourceFile, node, compilerOptions, host, typeChecker, preferences) {
            return addReplacementSpans(node.text, node.getStart(sourceFile) + 1, getStringLiteralCompletionsFromModuleNamesWorker(sourceFile, node, compilerOptions, host, typeChecker, preferences));
          }
          function getStringLiteralCompletionsFromModuleNamesWorker(sourceFile, node, compilerOptions, host, typeChecker, preferences) {
            var literalValue = ts3.normalizeSlashes(node.text);
            var scriptPath = sourceFile.path;
            var scriptDirectory = ts3.getDirectoryPath(scriptPath);
            return isPathRelativeToScript(literalValue) || !compilerOptions.baseUrl && (ts3.isRootedDiskPath(literalValue) || ts3.isUrl(literalValue)) ? getCompletionEntriesForRelativeModules(literalValue, scriptDirectory, compilerOptions, host, scriptPath, preferences) : getCompletionEntriesForNonRelativeModules(literalValue, scriptDirectory, compilerOptions, host, typeChecker);
          }
          function getExtensionOptions(compilerOptions, includeExtensions) {
            if (includeExtensions === void 0) {
              includeExtensions = false;
            }
            return { extensions: getSupportedExtensionsForModuleResolution(compilerOptions), includeExtensions };
          }
          function getCompletionEntriesForRelativeModules(literalValue, scriptDirectory, compilerOptions, host, scriptPath, preferences) {
            var extensionOptions = getExtensionOptions(compilerOptions, preferences.importModuleSpecifierEnding === "js");
            if (compilerOptions.rootDirs) {
              return getCompletionEntriesForDirectoryFragmentWithRootDirs(compilerOptions.rootDirs, literalValue, scriptDirectory, extensionOptions, compilerOptions, host, scriptPath);
            } else {
              return getCompletionEntriesForDirectoryFragment(literalValue, scriptDirectory, extensionOptions, host, scriptPath);
            }
          }
          function getSupportedExtensionsForModuleResolution(compilerOptions) {
            var extensions = ts3.getSupportedExtensions(compilerOptions);
            return compilerOptions.resolveJsonModule && ts3.getEmitModuleResolutionKind(compilerOptions) === ts3.ModuleResolutionKind.NodeJs ? extensions.concat(".json") : extensions;
          }
          function getBaseDirectoriesFromRootDirs(rootDirs, basePath, scriptDirectory, ignoreCase) {
            rootDirs = rootDirs.map(function(rootDirectory) {
              return ts3.normalizePath(ts3.isRootedDiskPath(rootDirectory) ? rootDirectory : ts3.combinePaths(basePath, rootDirectory));
            });
            var relativeDirectory = ts3.firstDefined(rootDirs, function(rootDirectory) {
              return ts3.containsPath(rootDirectory, scriptDirectory, basePath, ignoreCase) ? scriptDirectory.substr(rootDirectory.length) : void 0;
            });
            return ts3.deduplicate(__spreadArray(__spreadArray([], rootDirs.map(function(rootDirectory) {
              return ts3.combinePaths(rootDirectory, relativeDirectory);
            })), [scriptDirectory]), ts3.equateStringsCaseSensitive, ts3.compareStringsCaseSensitive);
          }
          function getCompletionEntriesForDirectoryFragmentWithRootDirs(rootDirs, fragment, scriptDirectory, extensionOptions, compilerOptions, host, exclude) {
            var basePath = compilerOptions.project || host.getCurrentDirectory();
            var ignoreCase = !(host.useCaseSensitiveFileNames && host.useCaseSensitiveFileNames());
            var baseDirectories = getBaseDirectoriesFromRootDirs(rootDirs, basePath, scriptDirectory, ignoreCase);
            return ts3.flatMap(baseDirectories, function(baseDirectory) {
              return getCompletionEntriesForDirectoryFragment(fragment, baseDirectory, extensionOptions, host, exclude);
            });
          }
          function getCompletionEntriesForDirectoryFragment(fragment, scriptPath, _a2, host, exclude, result2) {
            var extensions = _a2.extensions, includeExtensions = _a2.includeExtensions;
            if (result2 === void 0) {
              result2 = [];
            }
            if (fragment === void 0) {
              fragment = "";
            }
            fragment = ts3.normalizeSlashes(fragment);
            if (!ts3.hasTrailingDirectorySeparator(fragment)) {
              fragment = ts3.getDirectoryPath(fragment);
            }
            if (fragment === "") {
              fragment = "." + ts3.directorySeparator;
            }
            fragment = ts3.ensureTrailingDirectorySeparator(fragment);
            var absolutePath = ts3.resolvePath(scriptPath, fragment);
            var baseDirectory = ts3.hasTrailingDirectorySeparator(absolutePath) ? absolutePath : ts3.getDirectoryPath(absolutePath);
            var ignoreCase = !(host.useCaseSensitiveFileNames && host.useCaseSensitiveFileNames());
            if (!ts3.tryDirectoryExists(host, baseDirectory))
              return result2;
            var files = ts3.tryReadDirectory(host, baseDirectory, extensions, void 0, ["./*"]);
            if (files) {
              var foundFiles = new ts3.Map();
              for (var _i = 0, files_1 = files; _i < files_1.length; _i++) {
                var filePath = files_1[_i];
                filePath = ts3.normalizePath(filePath);
                if (exclude && ts3.comparePaths(filePath, exclude, scriptPath, ignoreCase) === 0) {
                  continue;
                }
                var foundFileName = includeExtensions || ts3.fileExtensionIs(filePath, ".json") ? ts3.getBaseFileName(filePath) : ts3.removeFileExtension(ts3.getBaseFileName(filePath));
                foundFiles.set(foundFileName, ts3.tryGetExtensionFromPath(filePath));
              }
              foundFiles.forEach(function(ext, foundFile) {
                result2.push(nameAndKind(foundFile, "script", ext));
              });
            }
            var directories = ts3.tryGetDirectories(host, baseDirectory);
            if (directories) {
              for (var _b = 0, directories_1 = directories; _b < directories_1.length; _b++) {
                var directory = directories_1[_b];
                var directoryName = ts3.getBaseFileName(ts3.normalizePath(directory));
                if (directoryName !== "@types") {
                  result2.push(directoryResult(directoryName));
                }
              }
            }
            var packageJsonPath = ts3.findPackageJson(baseDirectory, host);
            if (packageJsonPath) {
              var packageJson = ts3.readJson(packageJsonPath, host);
              var typesVersions = packageJson.typesVersions;
              if (typeof typesVersions === "object") {
                var versionResult = ts3.getPackageJsonTypesVersionsPaths(typesVersions);
                var versionPaths = versionResult && versionResult.paths;
                var rest = absolutePath.slice(ts3.ensureTrailingDirectorySeparator(baseDirectory).length);
                if (versionPaths) {
                  addCompletionEntriesFromPaths(result2, rest, baseDirectory, extensions, versionPaths, host);
                }
              }
            }
            return result2;
          }
          function addCompletionEntriesFromPaths(result2, fragment, baseDirectory, fileExtensions, paths, host) {
            for (var path2 in paths) {
              if (!ts3.hasProperty(paths, path2))
                continue;
              var patterns = paths[path2];
              if (patterns) {
                var _loop_2 = function(name2, kind2, extension2) {
                  if (!result2.some(function(entry) {
                    return entry.name === name2;
                  })) {
                    result2.push(nameAndKind(name2, kind2, extension2));
                  }
                };
                for (var _i = 0, _a2 = getCompletionsForPathMapping(path2, patterns, fragment, baseDirectory, fileExtensions, host); _i < _a2.length; _i++) {
                  var _b = _a2[_i], name = _b.name, kind = _b.kind, extension = _b.extension;
                  _loop_2(name, kind, extension);
                }
              }
            }
          }
          function getCompletionEntriesForNonRelativeModules(fragment, scriptPath, compilerOptions, host, typeChecker) {
            var baseUrl = compilerOptions.baseUrl, paths = compilerOptions.paths;
            var result2 = [];
            var extensionOptions = getExtensionOptions(compilerOptions);
            if (baseUrl) {
              var projectDir = compilerOptions.project || host.getCurrentDirectory();
              var absolute = ts3.normalizePath(ts3.combinePaths(projectDir, baseUrl));
              getCompletionEntriesForDirectoryFragment(fragment, absolute, extensionOptions, host, void 0, result2);
              if (paths) {
                addCompletionEntriesFromPaths(result2, fragment, absolute, extensionOptions.extensions, paths, host);
              }
            }
            var fragmentDirectory = getFragmentDirectory(fragment);
            for (var _i = 0, _a2 = getAmbientModuleCompletions(fragment, fragmentDirectory, typeChecker); _i < _a2.length; _i++) {
              var ambientName = _a2[_i];
              result2.push(nameAndKind(ambientName, "external module name", void 0));
            }
            getCompletionEntriesFromTypings(host, compilerOptions, scriptPath, fragmentDirectory, extensionOptions, result2);
            if (ts3.getEmitModuleResolutionKind(compilerOptions) === ts3.ModuleResolutionKind.NodeJs) {
              var foundGlobal = false;
              if (fragmentDirectory === void 0) {
                var _loop_3 = function(moduleName2) {
                  if (!result2.some(function(entry) {
                    return entry.name === moduleName2;
                  })) {
                    foundGlobal = true;
                    result2.push(nameAndKind(moduleName2, "external module name", void 0));
                  }
                };
                for (var _b = 0, _c = enumerateNodeModulesVisibleToScript(host, scriptPath); _b < _c.length; _b++) {
                  var moduleName = _c[_b];
                  _loop_3(moduleName);
                }
              }
              if (!foundGlobal) {
                ts3.forEachAncestorDirectory(scriptPath, function(ancestor) {
                  var nodeModules = ts3.combinePaths(ancestor, "node_modules");
                  if (ts3.tryDirectoryExists(host, nodeModules)) {
                    getCompletionEntriesForDirectoryFragment(fragment, nodeModules, extensionOptions, host, void 0, result2);
                  }
                });
              }
            }
            return result2;
          }
          function getFragmentDirectory(fragment) {
            return containsSlash(fragment) ? ts3.hasTrailingDirectorySeparator(fragment) ? fragment : ts3.getDirectoryPath(fragment) : void 0;
          }
          function getCompletionsForPathMapping(path2, patterns, fragment, baseUrl, fileExtensions, host) {
            if (!ts3.endsWith(path2, "*")) {
              return !ts3.stringContains(path2, "*") ? justPathMappingName(path2) : ts3.emptyArray;
            }
            var pathPrefix = path2.slice(0, path2.length - 1);
            var remainingFragment = ts3.tryRemovePrefix(fragment, pathPrefix);
            return remainingFragment === void 0 ? justPathMappingName(pathPrefix) : ts3.flatMap(patterns, function(pattern) {
              return getModulesForPathsPattern(remainingFragment, baseUrl, pattern, fileExtensions, host);
            });
            function justPathMappingName(name) {
              return ts3.startsWith(name, fragment) ? [directoryResult(name)] : ts3.emptyArray;
            }
          }
          function getModulesForPathsPattern(fragment, baseUrl, pattern, fileExtensions, host) {
            if (!host.readDirectory) {
              return void 0;
            }
            var parsed = ts3.hasZeroOrOneAsteriskCharacter(pattern) ? ts3.tryParsePattern(pattern) : void 0;
            if (!parsed) {
              return void 0;
            }
            var normalizedPrefix = ts3.resolvePath(parsed.prefix);
            var normalizedPrefixDirectory = ts3.hasTrailingDirectorySeparator(parsed.prefix) ? normalizedPrefix : ts3.getDirectoryPath(normalizedPrefix);
            var normalizedPrefixBase = ts3.hasTrailingDirectorySeparator(parsed.prefix) ? "" : ts3.getBaseFileName(normalizedPrefix);
            var fragmentHasPath = containsSlash(fragment);
            var fragmentDirectory = fragmentHasPath ? ts3.hasTrailingDirectorySeparator(fragment) ? fragment : ts3.getDirectoryPath(fragment) : void 0;
            var expandedPrefixDirectory = fragmentHasPath ? ts3.combinePaths(normalizedPrefixDirectory, normalizedPrefixBase + fragmentDirectory) : normalizedPrefixDirectory;
            var normalizedSuffix = ts3.normalizePath(parsed.suffix);
            var baseDirectory = ts3.normalizePath(ts3.combinePaths(baseUrl, expandedPrefixDirectory));
            var completePrefix = fragmentHasPath ? baseDirectory : ts3.ensureTrailingDirectorySeparator(baseDirectory) + normalizedPrefixBase;
            var includeGlob = normalizedSuffix ? "**/*" : "./*";
            var matches = ts3.mapDefined(ts3.tryReadDirectory(host, baseDirectory, fileExtensions, void 0, [includeGlob]), function(match) {
              var extension = ts3.tryGetExtensionFromPath(match);
              var name = trimPrefixAndSuffix(match);
              return name === void 0 ? void 0 : nameAndKind(ts3.removeFileExtension(name), "script", extension);
            });
            var directories = ts3.mapDefined(ts3.tryGetDirectories(host, baseDirectory).map(function(d) {
              return ts3.combinePaths(baseDirectory, d);
            }), function(dir) {
              var name = trimPrefixAndSuffix(dir);
              return name === void 0 ? void 0 : directoryResult(name);
            });
            return __spreadArray(__spreadArray([], matches), directories);
            function trimPrefixAndSuffix(path2) {
              var inner = withoutStartAndEnd(ts3.normalizePath(path2), completePrefix, normalizedSuffix);
              return inner === void 0 ? void 0 : removeLeadingDirectorySeparator(inner);
            }
          }
          function withoutStartAndEnd(s2, start, end) {
            return ts3.startsWith(s2, start) && ts3.endsWith(s2, end) ? s2.slice(start.length, s2.length - end.length) : void 0;
          }
          function removeLeadingDirectorySeparator(path2) {
            return path2[0] === ts3.directorySeparator ? path2.slice(1) : path2;
          }
          function getAmbientModuleCompletions(fragment, fragmentDirectory, checker) {
            var ambientModules = checker.getAmbientModules().map(function(sym) {
              return ts3.stripQuotes(sym.name);
            });
            var nonRelativeModuleNames = ambientModules.filter(function(moduleName) {
              return ts3.startsWith(moduleName, fragment);
            });
            if (fragmentDirectory !== void 0) {
              var moduleNameWithSeparator_1 = ts3.ensureTrailingDirectorySeparator(fragmentDirectory);
              return nonRelativeModuleNames.map(function(nonRelativeModuleName) {
                return ts3.removePrefix(nonRelativeModuleName, moduleNameWithSeparator_1);
              });
            }
            return nonRelativeModuleNames;
          }
          function getTripleSlashReferenceCompletion(sourceFile, position, compilerOptions, host) {
            var token = ts3.getTokenAtPosition(sourceFile, position);
            var commentRanges = ts3.getLeadingCommentRanges(sourceFile.text, token.pos);
            var range = commentRanges && ts3.find(commentRanges, function(commentRange) {
              return position >= commentRange.pos && position <= commentRange.end;
            });
            if (!range) {
              return void 0;
            }
            var text = sourceFile.text.slice(range.pos, position);
            var match = tripleSlashDirectiveFragmentRegex.exec(text);
            if (!match) {
              return void 0;
            }
            var prefix2 = match[1], kind = match[2], toComplete = match[3];
            var scriptPath = ts3.getDirectoryPath(sourceFile.path);
            var names = kind === "path" ? getCompletionEntriesForDirectoryFragment(toComplete, scriptPath, getExtensionOptions(compilerOptions, true), host, sourceFile.path) : kind === "types" ? getCompletionEntriesFromTypings(host, compilerOptions, scriptPath, getFragmentDirectory(toComplete), getExtensionOptions(compilerOptions)) : ts3.Debug.fail();
            return addReplacementSpans(toComplete, range.pos + prefix2.length, names);
          }
          function getCompletionEntriesFromTypings(host, options, scriptPath, fragmentDirectory, extensionOptions, result2) {
            if (result2 === void 0) {
              result2 = [];
            }
            var seen = new ts3.Map();
            var typeRoots = ts3.tryAndIgnoreErrors(function() {
              return ts3.getEffectiveTypeRoots(options, host);
            }) || ts3.emptyArray;
            for (var _i = 0, typeRoots_1 = typeRoots; _i < typeRoots_1.length; _i++) {
              var root = typeRoots_1[_i];
              getCompletionEntriesFromDirectories(root);
            }
            for (var _a2 = 0, _b = ts3.findPackageJsons(scriptPath, host); _a2 < _b.length; _a2++) {
              var packageJson = _b[_a2];
              var typesDir = ts3.combinePaths(ts3.getDirectoryPath(packageJson), "node_modules/@types");
              getCompletionEntriesFromDirectories(typesDir);
            }
            return result2;
            function getCompletionEntriesFromDirectories(directory) {
              if (!ts3.tryDirectoryExists(host, directory))
                return;
              for (var _i2 = 0, _a3 = ts3.tryGetDirectories(host, directory); _i2 < _a3.length; _i2++) {
                var typeDirectoryName = _a3[_i2];
                var packageName = ts3.unmangleScopedPackageName(typeDirectoryName);
                if (options.types && !ts3.contains(options.types, packageName))
                  continue;
                if (fragmentDirectory === void 0) {
                  if (!seen.has(packageName)) {
                    result2.push(nameAndKind(packageName, "external module name", void 0));
                    seen.set(packageName, true);
                  }
                } else {
                  var baseDirectory = ts3.combinePaths(directory, typeDirectoryName);
                  var remainingFragment = ts3.tryRemoveDirectoryPrefix(fragmentDirectory, packageName, ts3.hostGetCanonicalFileName(host));
                  if (remainingFragment !== void 0) {
                    getCompletionEntriesForDirectoryFragment(remainingFragment, baseDirectory, extensionOptions, host, void 0, result2);
                  }
                }
              }
            }
          }
          function enumerateNodeModulesVisibleToScript(host, scriptPath) {
            if (!host.readFile || !host.fileExists)
              return ts3.emptyArray;
            var result2 = [];
            for (var _i = 0, _a2 = ts3.findPackageJsons(scriptPath, host); _i < _a2.length; _i++) {
              var packageJson = _a2[_i];
              var contents = ts3.readJson(packageJson, host);
              for (var _b = 0, nodeModulesDependencyKeys_1 = nodeModulesDependencyKeys; _b < nodeModulesDependencyKeys_1.length; _b++) {
                var key2 = nodeModulesDependencyKeys_1[_b];
                var dependencies = contents[key2];
                if (!dependencies)
                  continue;
                for (var dep in dependencies) {
                  if (dependencies.hasOwnProperty(dep) && !ts3.startsWith(dep, "@types/")) {
                    result2.push(dep);
                  }
                }
              }
            }
            return result2;
          }
          function getDirectoryFragmentTextSpan(text, textStart) {
            var index = Math.max(text.lastIndexOf(ts3.directorySeparator), text.lastIndexOf(ts3.altDirectorySeparator));
            var offset = index !== -1 ? index + 1 : 0;
            var length = text.length - offset;
            return length === 0 || ts3.isIdentifierText(text.substr(offset, length), 99) ? void 0 : ts3.createTextSpan(textStart + offset, length);
          }
          function isPathRelativeToScript(path2) {
            if (path2 && path2.length >= 2 && path2.charCodeAt(0) === 46) {
              var slashIndex = path2.length >= 3 && path2.charCodeAt(1) === 46 ? 2 : 1;
              var slashCharCode = path2.charCodeAt(slashIndex);
              return slashCharCode === 47 || slashCharCode === 92;
            }
            return false;
          }
          var tripleSlashDirectiveFragmentRegex = /^(\/\/\/\s*<reference\s+(path|types)\s*=\s*(?:'|"))([^\3"]*)$/;
          var nodeModulesDependencyKeys = ["dependencies", "devDependencies", "peerDependencies", "optionalDependencies"];
          function containsSlash(fragment) {
            return ts3.stringContains(fragment, ts3.directorySeparator);
          }
        })(StringCompletions = Completions2.StringCompletions || (Completions2.StringCompletions = {}));
      })(Completions = ts3.Completions || (ts3.Completions = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var Completions;
      (function(Completions2) {
        var SortText;
        (function(SortText2) {
          SortText2["LocalDeclarationPriority"] = "0";
          SortText2["LocationPriority"] = "1";
          SortText2["OptionalMember"] = "2";
          SortText2["MemberDeclaredBySpreadAssignment"] = "3";
          SortText2["SuggestedClassMembers"] = "4";
          SortText2["GlobalsOrKeywords"] = "5";
          SortText2["AutoImportSuggestions"] = "6";
          SortText2["JavascriptIdentifiers"] = "7";
        })(SortText = Completions2.SortText || (Completions2.SortText = {}));
        var CompletionSource;
        (function(CompletionSource2) {
          CompletionSource2["ThisProperty"] = "ThisProperty/";
        })(CompletionSource = Completions2.CompletionSource || (Completions2.CompletionSource = {}));
        var SymbolOriginInfoKind;
        (function(SymbolOriginInfoKind2) {
          SymbolOriginInfoKind2[SymbolOriginInfoKind2["ThisType"] = 1] = "ThisType";
          SymbolOriginInfoKind2[SymbolOriginInfoKind2["SymbolMember"] = 2] = "SymbolMember";
          SymbolOriginInfoKind2[SymbolOriginInfoKind2["Export"] = 4] = "Export";
          SymbolOriginInfoKind2[SymbolOriginInfoKind2["Promise"] = 8] = "Promise";
          SymbolOriginInfoKind2[SymbolOriginInfoKind2["Nullable"] = 16] = "Nullable";
          SymbolOriginInfoKind2[SymbolOriginInfoKind2["ResolvedExport"] = 32] = "ResolvedExport";
          SymbolOriginInfoKind2[SymbolOriginInfoKind2["SymbolMemberNoExport"] = 2] = "SymbolMemberNoExport";
          SymbolOriginInfoKind2[SymbolOriginInfoKind2["SymbolMemberExport"] = 6] = "SymbolMemberExport";
        })(SymbolOriginInfoKind || (SymbolOriginInfoKind = {}));
        function originIsThisType(origin) {
          return !!(origin.kind & 1);
        }
        function originIsSymbolMember(origin) {
          return !!(origin.kind & 2);
        }
        function originIsExport(origin) {
          return !!(origin && origin.kind & 4);
        }
        function originIsResolvedExport(origin) {
          return !!(origin && origin.kind === 32);
        }
        function originIncludesSymbolName(origin) {
          return originIsExport(origin) || originIsResolvedExport(origin);
        }
        function originIsPackageJsonImport(origin) {
          return (originIsExport(origin) || originIsResolvedExport(origin)) && !!origin.isFromPackageJson;
        }
        function originIsPromise(origin) {
          return !!(origin.kind & 8);
        }
        function originIsNullableMember(origin) {
          return !!(origin.kind & 16);
        }
        var KeywordCompletionFilters;
        (function(KeywordCompletionFilters2) {
          KeywordCompletionFilters2[KeywordCompletionFilters2["None"] = 0] = "None";
          KeywordCompletionFilters2[KeywordCompletionFilters2["All"] = 1] = "All";
          KeywordCompletionFilters2[KeywordCompletionFilters2["ClassElementKeywords"] = 2] = "ClassElementKeywords";
          KeywordCompletionFilters2[KeywordCompletionFilters2["InterfaceElementKeywords"] = 3] = "InterfaceElementKeywords";
          KeywordCompletionFilters2[KeywordCompletionFilters2["ConstructorParameterKeywords"] = 4] = "ConstructorParameterKeywords";
          KeywordCompletionFilters2[KeywordCompletionFilters2["FunctionLikeBodyKeywords"] = 5] = "FunctionLikeBodyKeywords";
          KeywordCompletionFilters2[KeywordCompletionFilters2["TypeAssertionKeywords"] = 6] = "TypeAssertionKeywords";
          KeywordCompletionFilters2[KeywordCompletionFilters2["TypeKeywords"] = 7] = "TypeKeywords";
          KeywordCompletionFilters2[KeywordCompletionFilters2["Last"] = 7] = "Last";
        })(KeywordCompletionFilters || (KeywordCompletionFilters = {}));
        var GlobalsSearch;
        (function(GlobalsSearch2) {
          GlobalsSearch2[GlobalsSearch2["Continue"] = 0] = "Continue";
          GlobalsSearch2[GlobalsSearch2["Success"] = 1] = "Success";
          GlobalsSearch2[GlobalsSearch2["Fail"] = 2] = "Fail";
        })(GlobalsSearch || (GlobalsSearch = {}));
        function getCompletionsAtPosition(host, program2, log, sourceFile, position, preferences, triggerCharacter) {
          var typeChecker = program2.getTypeChecker();
          var compilerOptions = program2.getCompilerOptions();
          var contextToken = ts3.findPrecedingToken(position, sourceFile);
          if (triggerCharacter && !ts3.isInString(sourceFile, position, contextToken) && !isValidTrigger(sourceFile, triggerCharacter, contextToken, position)) {
            return void 0;
          }
          if (triggerCharacter === " ") {
            if (preferences.includeCompletionsForImportStatements && preferences.includeCompletionsWithInsertText) {
              return { isGlobalCompletion: true, isMemberCompletion: false, isNewIdentifierLocation: true, isIncomplete: true, entries: [] };
            }
            return void 0;
          }
          var stringCompletions = Completions2.StringCompletions.getStringLiteralCompletions(sourceFile, position, contextToken, typeChecker, compilerOptions, host, log, preferences);
          if (stringCompletions) {
            return stringCompletions;
          }
          if (contextToken && ts3.isBreakOrContinueStatement(contextToken.parent) && (contextToken.kind === 80 || contextToken.kind === 85 || contextToken.kind === 78)) {
            return getLabelCompletionAtPosition(contextToken.parent);
          }
          var completionData = getCompletionData(program2, log, sourceFile, isUncheckedFile(sourceFile, compilerOptions), position, preferences, void 0, host);
          if (!completionData) {
            return void 0;
          }
          switch (completionData.kind) {
            case 0:
              return completionInfoFromData(sourceFile, typeChecker, compilerOptions, log, completionData, preferences);
            case 1:
              return jsdocCompletionInfo(ts3.JsDoc.getJSDocTagNameCompletions());
            case 2:
              return jsdocCompletionInfo(ts3.JsDoc.getJSDocTagCompletions());
            case 3:
              return jsdocCompletionInfo(ts3.JsDoc.getJSDocParameterNameCompletions(completionData.tag));
            case 4:
              return specificKeywordCompletionInfo(completionData.keywords);
            default:
              return ts3.Debug.assertNever(completionData);
          }
        }
        Completions2.getCompletionsAtPosition = getCompletionsAtPosition;
        function jsdocCompletionInfo(entries) {
          return { isGlobalCompletion: false, isMemberCompletion: false, isNewIdentifierLocation: false, entries };
        }
        function specificKeywordCompletionInfo(keywords) {
          return {
            isGlobalCompletion: false,
            isMemberCompletion: false,
            isNewIdentifierLocation: false,
            entries: keywords.map(function(k) {
              return {
                name: ts3.tokenToString(k),
                kind: "keyword",
                kindModifiers: "",
                sortText: SortText.GlobalsOrKeywords
              };
            })
          };
        }
        function getOptionalReplacementSpan(location) {
          return (location === null || location === void 0 ? void 0 : location.kind) === 78 ? ts3.createTextSpanFromNode(location) : void 0;
        }
        function completionInfoFromData(sourceFile, typeChecker, compilerOptions, log, completionData, preferences) {
          var symbols = completionData.symbols, completionKind = completionData.completionKind, isInSnippetScope = completionData.isInSnippetScope, isNewIdentifierLocation = completionData.isNewIdentifierLocation, location = completionData.location, propertyAccessToConvert = completionData.propertyAccessToConvert, keywordFilters = completionData.keywordFilters, literals = completionData.literals, symbolToOriginInfoMap = completionData.symbolToOriginInfoMap, recommendedCompletion = completionData.recommendedCompletion, isJsxInitializer = completionData.isJsxInitializer, isTypeOnlyLocation = completionData.isTypeOnlyLocation, isJsxIdentifierExpected = completionData.isJsxIdentifierExpected, importCompletionNode = completionData.importCompletionNode, insideJsDocTagTypeExpression = completionData.insideJsDocTagTypeExpression, symbolToSortTextMap = completionData.symbolToSortTextMap;
          if (ts3.getLanguageVariant(sourceFile.scriptKind) === 1) {
            var completionInfo = getJsxClosingTagCompletion(location, sourceFile);
            if (completionInfo) {
              return completionInfo;
            }
          }
          var entries = [];
          if (isUncheckedFile(sourceFile, compilerOptions)) {
            var uniqueNames = getCompletionEntriesFromSymbols(symbols, entries, void 0, location, sourceFile, typeChecker, compilerOptions.target, log, completionKind, preferences, compilerOptions, isTypeOnlyLocation, propertyAccessToConvert, isJsxIdentifierExpected, isJsxInitializer, importCompletionNode, recommendedCompletion, symbolToOriginInfoMap, symbolToSortTextMap);
            getJSCompletionEntries(sourceFile, location.pos, uniqueNames, compilerOptions.target, entries);
          } else {
            if (!isNewIdentifierLocation && (!symbols || symbols.length === 0) && keywordFilters === 0) {
              return void 0;
            }
            getCompletionEntriesFromSymbols(symbols, entries, void 0, location, sourceFile, typeChecker, compilerOptions.target, log, completionKind, preferences, compilerOptions, isTypeOnlyLocation, propertyAccessToConvert, isJsxIdentifierExpected, isJsxInitializer, importCompletionNode, recommendedCompletion, symbolToOriginInfoMap, symbolToSortTextMap);
          }
          if (keywordFilters !== 0) {
            var entryNames = new ts3.Set(entries.map(function(e2) {
              return e2.name;
            }));
            for (var _i = 0, _a2 = getKeywordCompletions(keywordFilters, !insideJsDocTagTypeExpression && ts3.isSourceFileJS(sourceFile)); _i < _a2.length; _i++) {
              var keywordEntry = _a2[_i];
              if (!entryNames.has(keywordEntry.name)) {
                entries.push(keywordEntry);
              }
            }
          }
          for (var _b = 0, literals_1 = literals; _b < literals_1.length; _b++) {
            var literal = literals_1[_b];
            entries.push(createCompletionEntryForLiteral(sourceFile, preferences, literal));
          }
          return {
            isGlobalCompletion: isInSnippetScope,
            isMemberCompletion: isMemberCompletionKind(completionKind),
            isNewIdentifierLocation,
            optionalReplacementSpan: getOptionalReplacementSpan(location),
            entries
          };
        }
        function isUncheckedFile(sourceFile, compilerOptions) {
          return ts3.isSourceFileJS(sourceFile) && !ts3.isCheckJsEnabledForFile(sourceFile, compilerOptions);
        }
        function isMemberCompletionKind(kind) {
          switch (kind) {
            case 0:
            case 3:
            case 2:
              return true;
            default:
              return false;
          }
        }
        function getJsxClosingTagCompletion(location, sourceFile) {
          var jsxClosingElement = ts3.findAncestor(location, function(node) {
            switch (node.kind) {
              case 277:
                return true;
              case 43:
              case 31:
              case 78:
              case 202:
                return false;
              default:
                return "quit";
            }
          });
          if (jsxClosingElement) {
            var hasClosingAngleBracket = !!ts3.findChildOfKind(jsxClosingElement, 31, sourceFile);
            var tagName = jsxClosingElement.parent.openingElement.tagName;
            var closingTag = tagName.getText(sourceFile);
            var fullClosingTag = closingTag + (hasClosingAngleBracket ? "" : ">");
            var replacementSpan = ts3.createTextSpanFromNode(jsxClosingElement.tagName);
            var entry = {
              name: fullClosingTag,
              kind: "class",
              kindModifiers: void 0,
              sortText: SortText.LocationPriority
            };
            return { isGlobalCompletion: false, isMemberCompletion: true, isNewIdentifierLocation: false, optionalReplacementSpan: replacementSpan, entries: [entry] };
          }
          return;
        }
        function getJSCompletionEntries(sourceFile, position, uniqueNames, target, entries) {
          ts3.getNameTable(sourceFile).forEach(function(pos, name) {
            if (pos === position) {
              return;
            }
            var realName = ts3.unescapeLeadingUnderscores(name);
            if (!uniqueNames.has(realName) && ts3.isIdentifierText(realName, target)) {
              uniqueNames.add(realName);
              entries.push({
                name: realName,
                kind: "warning",
                kindModifiers: "",
                sortText: SortText.JavascriptIdentifiers,
                isFromUncheckedFile: true
              });
            }
          });
        }
        function completionNameForLiteral(sourceFile, preferences, literal) {
          return typeof literal === "object" ? ts3.pseudoBigIntToString(literal) + "n" : ts3.isString(literal) ? ts3.quote(sourceFile, preferences, literal) : JSON.stringify(literal);
        }
        function createCompletionEntryForLiteral(sourceFile, preferences, literal) {
          return { name: completionNameForLiteral(sourceFile, preferences, literal), kind: "string", kindModifiers: "", sortText: SortText.LocationPriority };
        }
        function createCompletionEntry(symbol, sortText, contextToken, location, sourceFile, typeChecker, name, needsConvertPropertyAccess, origin, recommendedCompletion, propertyAccessToConvert, isJsxInitializer, importCompletionNode, useSemicolons, options, preferences) {
          var _a2;
          var insertText;
          var replacementSpan = ts3.getReplacementSpanForContextToken(contextToken);
          var data;
          var isSnippet;
          var sourceDisplay;
          var insertQuestionDot = origin && originIsNullableMember(origin);
          var useBraces = origin && originIsSymbolMember(origin) || needsConvertPropertyAccess;
          if (origin && originIsThisType(origin)) {
            insertText = needsConvertPropertyAccess ? "this" + (insertQuestionDot ? "?." : "") + "[" + quotePropertyName(sourceFile, preferences, name) + "]" : "this" + (insertQuestionDot ? "?." : ".") + name;
          } else if ((useBraces || insertQuestionDot) && propertyAccessToConvert) {
            insertText = useBraces ? needsConvertPropertyAccess ? "[" + quotePropertyName(sourceFile, preferences, name) + "]" : "[" + name + "]" : name;
            if (insertQuestionDot || propertyAccessToConvert.questionDotToken) {
              insertText = "?." + insertText;
            }
            var dot = ts3.findChildOfKind(propertyAccessToConvert, 24, sourceFile) || ts3.findChildOfKind(propertyAccessToConvert, 28, sourceFile);
            if (!dot) {
              return void 0;
            }
            var end = ts3.startsWith(name, propertyAccessToConvert.name.text) ? propertyAccessToConvert.name.end : dot.end;
            replacementSpan = ts3.createTextSpanFromBounds(dot.getStart(sourceFile), end);
          }
          if (isJsxInitializer) {
            if (insertText === void 0)
              insertText = name;
            insertText = "{" + insertText + "}";
            if (typeof isJsxInitializer !== "boolean") {
              replacementSpan = ts3.createTextSpanFromNode(isJsxInitializer, sourceFile);
            }
          }
          if (origin && originIsPromise(origin) && propertyAccessToConvert) {
            if (insertText === void 0)
              insertText = name;
            var precedingToken = ts3.findPrecedingToken(propertyAccessToConvert.pos, sourceFile);
            var awaitText = "";
            if (precedingToken && ts3.positionIsASICandidate(precedingToken.end, precedingToken.parent, sourceFile)) {
              awaitText = ";";
            }
            awaitText += "(await " + propertyAccessToConvert.expression.getText() + ")";
            insertText = needsConvertPropertyAccess ? "" + awaitText + insertText : "" + awaitText + (insertQuestionDot ? "?." : ".") + insertText;
            replacementSpan = ts3.createTextSpanFromBounds(propertyAccessToConvert.getStart(sourceFile), propertyAccessToConvert.end);
          }
          if (originIsResolvedExport(origin)) {
            ts3.Debug.assertIsDefined(importCompletionNode);
            _a2 = getInsertTextAndReplacementSpanForImportCompletion(name, importCompletionNode, origin, useSemicolons, options, preferences), insertText = _a2.insertText, replacementSpan = _a2.replacementSpan;
            sourceDisplay = [ts3.textPart(origin.moduleSpecifier)];
            isSnippet = preferences.includeCompletionsWithSnippetText ? true : void 0;
          }
          if (insertText !== void 0 && !preferences.includeCompletionsWithInsertText) {
            return void 0;
          }
          if (originIsExport(origin) || originIsResolvedExport(origin)) {
            data = {
              exportName: origin.exportName,
              fileName: origin.fileName,
              ambientModuleName: origin.fileName ? void 0 : ts3.stripQuotes(origin.moduleSymbol.name),
              isPackageJsonImport: origin.isFromPackageJson ? true : void 0,
              moduleSpecifier: originIsResolvedExport(origin) ? origin.moduleSpecifier : void 0
            };
          }
          return {
            name,
            kind: ts3.SymbolDisplay.getSymbolKind(typeChecker, symbol, location),
            kindModifiers: ts3.SymbolDisplay.getSymbolModifiers(typeChecker, symbol),
            sortText,
            source: getSourceFromOrigin(origin),
            hasAction: origin && originIsExport(origin) || void 0,
            isRecommended: isRecommendedCompletionMatch(symbol, recommendedCompletion, typeChecker) || void 0,
            insertText,
            replacementSpan,
            sourceDisplay,
            isSnippet,
            isPackageJsonImport: originIsPackageJsonImport(origin) || void 0,
            isImportStatementCompletion: originIsResolvedExport(origin) || void 0,
            data
          };
        }
        function getInsertTextAndReplacementSpanForImportCompletion(name, importCompletionNode, origin, useSemicolons, options, preferences) {
          var sourceFile = importCompletionNode.getSourceFile();
          var replacementSpan = ts3.createTextSpanFromNode(importCompletionNode, sourceFile);
          var quotedModuleSpecifier = ts3.quote(sourceFile, preferences, origin.moduleSpecifier);
          var exportKind = origin.isDefaultExport ? 1 : origin.exportName === "export=" ? 2 : 0;
          var tabStop = preferences.includeCompletionsWithSnippetText ? "$1" : "";
          var importKind = ts3.codefix.getImportKind(sourceFile, exportKind, options);
          var suffix = useSemicolons ? ";" : "";
          switch (importKind) {
            case 3:
              return { replacementSpan, insertText: "import " + name + tabStop + " = require(" + quotedModuleSpecifier + ")" + suffix };
            case 1:
              return { replacementSpan, insertText: "import " + name + tabStop + " from " + quotedModuleSpecifier + suffix };
            case 2:
              return { replacementSpan, insertText: "import * as " + name + tabStop + " from " + quotedModuleSpecifier + suffix };
            case 0:
              return { replacementSpan, insertText: "import { " + name + tabStop + " } from " + quotedModuleSpecifier + suffix };
          }
        }
        function quotePropertyName(sourceFile, preferences, name) {
          if (/^\d+$/.test(name)) {
            return name;
          }
          return ts3.quote(sourceFile, preferences, name);
        }
        function isRecommendedCompletionMatch(localSymbol, recommendedCompletion, checker) {
          return localSymbol === recommendedCompletion || !!(localSymbol.flags & 1048576) && checker.getExportSymbolOfSymbol(localSymbol) === recommendedCompletion;
        }
        function getSourceFromOrigin(origin) {
          if (originIsExport(origin)) {
            return ts3.stripQuotes(origin.moduleSymbol.name);
          }
          if (originIsResolvedExport(origin)) {
            return origin.moduleSpecifier;
          }
          if ((origin === null || origin === void 0 ? void 0 : origin.kind) === 1) {
            return CompletionSource.ThisProperty;
          }
        }
        function getCompletionEntriesFromSymbols(symbols, entries, contextToken, location, sourceFile, typeChecker, target, log, kind, preferences, compilerOptions, isTypeOnlyLocation, propertyAccessToConvert, jsxIdentifierExpected, isJsxInitializer, importCompletionNode, recommendedCompletion, symbolToOriginInfoMap, symbolToSortTextMap) {
          var start = ts3.timestamp();
          var variableDeclaration = getVariableDeclaration(location);
          var useSemicolons = ts3.probablyUsesSemicolons(sourceFile);
          var uniques = new ts3.Map();
          for (var i3 = 0; i3 < symbols.length; i3++) {
            var symbol = symbols[i3];
            var origin = symbolToOriginInfoMap === null || symbolToOriginInfoMap === void 0 ? void 0 : symbolToOriginInfoMap[i3];
            var info = getCompletionEntryDisplayNameForSymbol(symbol, target, origin, kind, !!jsxIdentifierExpected);
            if (!info || uniques.get(info.name) || kind === 1 && symbolToSortTextMap && !shouldIncludeSymbol(symbol, symbolToSortTextMap)) {
              continue;
            }
            var name = info.name, needsConvertPropertyAccess = info.needsConvertPropertyAccess;
            var entry = createCompletionEntry(symbol, symbolToSortTextMap && symbolToSortTextMap[ts3.getSymbolId(symbol)] || SortText.LocationPriority, contextToken, location, sourceFile, typeChecker, name, needsConvertPropertyAccess, origin, recommendedCompletion, propertyAccessToConvert, isJsxInitializer, importCompletionNode, useSemicolons, compilerOptions, preferences);
            if (!entry) {
              continue;
            }
            var shouldShadowLaterSymbols = !origin && !(symbol.parent === void 0 && !ts3.some(symbol.declarations, function(d) {
              return d.getSourceFile() === location.getSourceFile();
            }));
            uniques.set(name, shouldShadowLaterSymbols);
            entries.push(entry);
          }
          log("getCompletionsAtPosition: getCompletionEntriesFromSymbols: " + (ts3.timestamp() - start));
          return {
            has: function(name2) {
              return uniques.has(name2);
            },
            add: function(name2) {
              return uniques.set(name2, true);
            }
          };
          function shouldIncludeSymbol(symbol2, symbolToSortTextMap2) {
            if (!ts3.isSourceFile(location)) {
              if (ts3.isExportAssignment(location.parent)) {
                return true;
              }
              if (variableDeclaration && symbol2.valueDeclaration === variableDeclaration) {
                return false;
              }
              var symbolOrigin = ts3.skipAlias(symbol2, typeChecker);
              if (!!sourceFile.externalModuleIndicator && !compilerOptions.allowUmdGlobalAccess && symbolToSortTextMap2[ts3.getSymbolId(symbol2)] === SortText.GlobalsOrKeywords && (symbolToSortTextMap2[ts3.getSymbolId(symbolOrigin)] === SortText.AutoImportSuggestions || symbolToSortTextMap2[ts3.getSymbolId(symbolOrigin)] === SortText.LocationPriority)) {
                return false;
              }
              symbol2 = symbolOrigin;
              if (ts3.isInRightSideOfInternalImportEqualsDeclaration(location)) {
                return !!(symbol2.flags & 1920);
              }
              if (isTypeOnlyLocation) {
                return symbolCanBeReferencedAtTypeLocation(symbol2, typeChecker);
              }
            }
            return !!(ts3.getCombinedLocalAndExportSymbolFlags(symbol2) & 111551);
          }
        }
        Completions2.getCompletionEntriesFromSymbols = getCompletionEntriesFromSymbols;
        function getLabelCompletionAtPosition(node) {
          var entries = getLabelStatementCompletions(node);
          if (entries.length) {
            return { isGlobalCompletion: false, isMemberCompletion: false, isNewIdentifierLocation: false, entries };
          }
        }
        function getLabelStatementCompletions(node) {
          var entries = [];
          var uniques = new ts3.Map();
          var current = node;
          while (current) {
            if (ts3.isFunctionLike(current)) {
              break;
            }
            if (ts3.isLabeledStatement(current)) {
              var name = current.label.text;
              if (!uniques.has(name)) {
                uniques.set(name, true);
                entries.push({
                  name,
                  kindModifiers: "",
                  kind: "label",
                  sortText: SortText.LocationPriority
                });
              }
            }
            current = current.parent;
          }
          return entries;
        }
        function getSymbolCompletionFromEntryId(program2, log, sourceFile, position, entryId, host, preferences) {
          if (entryId.data) {
            var autoImport = getAutoImportSymbolFromCompletionEntryData(entryId.name, entryId.data, program2, host);
            if (autoImport) {
              return {
                type: "symbol",
                symbol: autoImport.symbol,
                location: ts3.getTouchingPropertyName(sourceFile, position),
                previousToken: ts3.findPrecedingToken(position, sourceFile, void 0),
                isJsxInitializer: false,
                isTypeOnlyLocation: false,
                origin: autoImport.origin
              };
            }
          }
          var compilerOptions = program2.getCompilerOptions();
          var completionData = getCompletionData(program2, log, sourceFile, isUncheckedFile(sourceFile, compilerOptions), position, { includeCompletionsForModuleExports: true, includeCompletionsWithInsertText: true }, entryId, host);
          if (!completionData) {
            return { type: "none" };
          }
          if (completionData.kind !== 0) {
            return { type: "request", request: completionData };
          }
          var symbols = completionData.symbols, literals = completionData.literals, location = completionData.location, completionKind = completionData.completionKind, symbolToOriginInfoMap = completionData.symbolToOriginInfoMap, previousToken = completionData.previousToken, isJsxInitializer = completionData.isJsxInitializer, isTypeOnlyLocation = completionData.isTypeOnlyLocation;
          var literal = ts3.find(literals, function(l2) {
            return completionNameForLiteral(sourceFile, preferences, l2) === entryId.name;
          });
          if (literal !== void 0)
            return { type: "literal", literal };
          return ts3.firstDefined(symbols, function(symbol, index) {
            var origin = symbolToOriginInfoMap[index];
            var info = getCompletionEntryDisplayNameForSymbol(symbol, compilerOptions.target, origin, completionKind, completionData.isJsxIdentifierExpected);
            return info && info.name === entryId.name && getSourceFromOrigin(origin) === entryId.source ? { type: "symbol", symbol, location, origin, previousToken, isJsxInitializer, isTypeOnlyLocation } : void 0;
          }) || { type: "none" };
        }
        function getCompletionEntryDetails(program2, log, sourceFile, position, entryId, host, formatContext, preferences, cancellationToken) {
          var typeChecker = program2.getTypeChecker();
          var compilerOptions = program2.getCompilerOptions();
          var name = entryId.name;
          var contextToken = ts3.findPrecedingToken(position, sourceFile);
          if (ts3.isInString(sourceFile, position, contextToken)) {
            return Completions2.StringCompletions.getStringLiteralCompletionDetails(name, sourceFile, position, contextToken, typeChecker, compilerOptions, host, cancellationToken, preferences);
          }
          var symbolCompletion = getSymbolCompletionFromEntryId(program2, log, sourceFile, position, entryId, host, preferences);
          switch (symbolCompletion.type) {
            case "request": {
              var request = symbolCompletion.request;
              switch (request.kind) {
                case 1:
                  return ts3.JsDoc.getJSDocTagNameCompletionDetails(name);
                case 2:
                  return ts3.JsDoc.getJSDocTagCompletionDetails(name);
                case 3:
                  return ts3.JsDoc.getJSDocParameterNameCompletionDetails(name);
                case 4:
                  return request.keywords.indexOf(ts3.stringToToken(name)) > -1 ? createSimpleDetails(name, "keyword", ts3.SymbolDisplayPartKind.keyword) : void 0;
                default:
                  return ts3.Debug.assertNever(request);
              }
            }
            case "symbol": {
              var symbol = symbolCompletion.symbol, location = symbolCompletion.location, origin = symbolCompletion.origin, previousToken = symbolCompletion.previousToken;
              var _a2 = getCompletionEntryCodeActionsAndSourceDisplay(origin, symbol, program2, typeChecker, host, compilerOptions, sourceFile, position, previousToken, formatContext, preferences, entryId.data), codeActions = _a2.codeActions, sourceDisplay = _a2.sourceDisplay;
              return createCompletionDetailsForSymbol(symbol, typeChecker, sourceFile, location, cancellationToken, codeActions, sourceDisplay);
            }
            case "literal": {
              var literal = symbolCompletion.literal;
              return createSimpleDetails(completionNameForLiteral(sourceFile, preferences, literal), "string", typeof literal === "string" ? ts3.SymbolDisplayPartKind.stringLiteral : ts3.SymbolDisplayPartKind.numericLiteral);
            }
            case "none":
              return allKeywordsCompletions().some(function(c2) {
                return c2.name === name;
              }) ? createSimpleDetails(name, "keyword", ts3.SymbolDisplayPartKind.keyword) : void 0;
            default:
              ts3.Debug.assertNever(symbolCompletion);
          }
        }
        Completions2.getCompletionEntryDetails = getCompletionEntryDetails;
        function createSimpleDetails(name, kind, kind2) {
          return createCompletionDetails(name, "", kind, [ts3.displayPart(name, kind2)]);
        }
        function createCompletionDetailsForSymbol(symbol, checker, sourceFile, location, cancellationToken, codeActions, sourceDisplay) {
          var _a2 = checker.runWithCancellationToken(cancellationToken, function(checker2) {
            return ts3.SymbolDisplay.getSymbolDisplayPartsDocumentationAndSymbolKind(checker2, symbol, sourceFile, location, location, 7);
          }), displayParts = _a2.displayParts, documentation = _a2.documentation, symbolKind = _a2.symbolKind, tags = _a2.tags;
          return createCompletionDetails(symbol.name, ts3.SymbolDisplay.getSymbolModifiers(checker, symbol), symbolKind, displayParts, documentation, tags, codeActions, sourceDisplay);
        }
        Completions2.createCompletionDetailsForSymbol = createCompletionDetailsForSymbol;
        function createCompletionDetails(name, kindModifiers, kind, displayParts, documentation, tags, codeActions, source) {
          return { name, kindModifiers, kind, displayParts, documentation, tags, codeActions, source, sourceDisplay: source };
        }
        Completions2.createCompletionDetails = createCompletionDetails;
        function getCompletionEntryCodeActionsAndSourceDisplay(origin, symbol, program2, checker, host, compilerOptions, sourceFile, position, previousToken, formatContext, preferences, data) {
          if (data === null || data === void 0 ? void 0 : data.moduleSpecifier) {
            return { codeActions: void 0, sourceDisplay: [ts3.textPart(data.moduleSpecifier)] };
          }
          if (!origin || !originIsExport(origin)) {
            return { codeActions: void 0, sourceDisplay: void 0 };
          }
          var moduleSymbol = origin.moduleSymbol;
          var exportedSymbol = checker.getMergedSymbol(ts3.skipAlias(symbol.exportSymbol || symbol, checker));
          var _a2 = ts3.codefix.getImportCompletionAction(exportedSymbol, moduleSymbol, sourceFile, ts3.getNameForExportedSymbol(symbol, compilerOptions.target), host, program2, formatContext, previousToken && ts3.isIdentifier(previousToken) ? previousToken.getStart(sourceFile) : position, preferences), moduleSpecifier = _a2.moduleSpecifier, codeAction = _a2.codeAction;
          return { sourceDisplay: [ts3.textPart(moduleSpecifier)], codeActions: [codeAction] };
        }
        function getCompletionEntrySymbol(program2, log, sourceFile, position, entryId, host, preferences) {
          var completion = getSymbolCompletionFromEntryId(program2, log, sourceFile, position, entryId, host, preferences);
          return completion.type === "symbol" ? completion.symbol : void 0;
        }
        Completions2.getCompletionEntrySymbol = getCompletionEntrySymbol;
        var CompletionDataKind;
        (function(CompletionDataKind2) {
          CompletionDataKind2[CompletionDataKind2["Data"] = 0] = "Data";
          CompletionDataKind2[CompletionDataKind2["JsDocTagName"] = 1] = "JsDocTagName";
          CompletionDataKind2[CompletionDataKind2["JsDocTag"] = 2] = "JsDocTag";
          CompletionDataKind2[CompletionDataKind2["JsDocParameterName"] = 3] = "JsDocParameterName";
          CompletionDataKind2[CompletionDataKind2["Keywords"] = 4] = "Keywords";
        })(CompletionDataKind || (CompletionDataKind = {}));
        var CompletionKind;
        (function(CompletionKind2) {
          CompletionKind2[CompletionKind2["ObjectPropertyDeclaration"] = 0] = "ObjectPropertyDeclaration";
          CompletionKind2[CompletionKind2["Global"] = 1] = "Global";
          CompletionKind2[CompletionKind2["PropertyAccess"] = 2] = "PropertyAccess";
          CompletionKind2[CompletionKind2["MemberLike"] = 3] = "MemberLike";
          CompletionKind2[CompletionKind2["String"] = 4] = "String";
          CompletionKind2[CompletionKind2["None"] = 5] = "None";
        })(CompletionKind = Completions2.CompletionKind || (Completions2.CompletionKind = {}));
        function getRecommendedCompletion(previousToken, contextualType, checker) {
          return ts3.firstDefined(contextualType && (contextualType.isUnion() ? contextualType.types : [contextualType]), function(type3) {
            var symbol = type3 && type3.symbol;
            return symbol && (symbol.flags & (8 | 384 | 32) && !ts3.isAbstractConstructorSymbol(symbol)) ? getFirstSymbolInChain(symbol, previousToken, checker) : void 0;
          });
        }
        function getContextualType(previousToken, position, sourceFile, checker) {
          var parent = previousToken.parent;
          switch (previousToken.kind) {
            case 78:
              return ts3.getContextualTypeFromParent(previousToken, checker);
            case 62:
              switch (parent.kind) {
                case 250:
                  return checker.getContextualType(parent.initializer);
                case 217:
                  return checker.getTypeAtLocation(parent.left);
                case 281:
                  return checker.getContextualTypeForJsxAttribute(parent);
                default:
                  return void 0;
              }
            case 102:
              return checker.getContextualType(parent);
            case 81:
              return ts3.getSwitchedType(ts3.cast(parent, ts3.isCaseClause), checker);
            case 18:
              return ts3.isJsxExpression(parent) && parent.parent.kind !== 274 ? checker.getContextualTypeForJsxAttribute(parent.parent) : void 0;
            default:
              var argInfo = ts3.SignatureHelp.getArgumentInfoForCompletions(previousToken, position, sourceFile);
              return argInfo ? checker.getContextualTypeForArgumentAtIndex(argInfo.invocation, argInfo.argumentIndex + (previousToken.kind === 27 ? 1 : 0)) : ts3.isEqualityOperatorKind(previousToken.kind) && ts3.isBinaryExpression(parent) && ts3.isEqualityOperatorKind(parent.operatorToken.kind) ? checker.getTypeAtLocation(parent.left) : checker.getContextualType(previousToken);
          }
        }
        function getFirstSymbolInChain(symbol, enclosingDeclaration, checker) {
          var chain = checker.getAccessibleSymbolChain(symbol, enclosingDeclaration, 67108863, false);
          if (chain)
            return ts3.first(chain);
          return symbol.parent && (isModuleSymbol(symbol.parent) ? symbol : getFirstSymbolInChain(symbol.parent, enclosingDeclaration, checker));
        }
        function isModuleSymbol(symbol) {
          var _a2;
          return !!((_a2 = symbol.declarations) === null || _a2 === void 0 ? void 0 : _a2.some(function(d) {
            return d.kind === 298;
          }));
        }
        function getCompletionData(program2, log, sourceFile, isUncheckedFile2, position, preferences, detailsEntryId, host) {
          var typeChecker = program2.getTypeChecker();
          var start = ts3.timestamp();
          var currentToken = ts3.getTokenAtPosition(sourceFile, position);
          log("getCompletionData: Get current token: " + (ts3.timestamp() - start));
          start = ts3.timestamp();
          var insideComment = ts3.isInComment(sourceFile, position, currentToken);
          log("getCompletionData: Is inside comment: " + (ts3.timestamp() - start));
          var insideJsDocTagTypeExpression = false;
          var isInSnippetScope = false;
          if (insideComment) {
            if (ts3.hasDocComment(sourceFile, position)) {
              if (sourceFile.text.charCodeAt(position - 1) === 64) {
                return { kind: 1 };
              } else {
                var lineStart = ts3.getLineStartPositionForPosition(position, sourceFile);
                if (!/[^\*|\s(/)]/.test(sourceFile.text.substring(lineStart, position))) {
                  return { kind: 2 };
                }
              }
            }
            var tag = getJsDocTagAtPosition(currentToken, position);
            if (tag) {
              if (tag.tagName.pos <= position && position <= tag.tagName.end) {
                return { kind: 1 };
              }
              if (isTagWithTypeExpression(tag) && tag.typeExpression && tag.typeExpression.kind === 302) {
                currentToken = ts3.getTokenAtPosition(sourceFile, position);
                if (!currentToken || !ts3.isDeclarationName(currentToken) && (currentToken.parent.kind !== 337 || currentToken.parent.name !== currentToken)) {
                  insideJsDocTagTypeExpression = isCurrentlyEditingNode(tag.typeExpression);
                }
              }
              if (!insideJsDocTagTypeExpression && ts3.isJSDocParameterTag(tag) && (ts3.nodeIsMissing(tag.name) || tag.name.pos <= position && position <= tag.name.end)) {
                return { kind: 3, tag };
              }
            }
            if (!insideJsDocTagTypeExpression) {
              log("Returning an empty list because completion was inside a regular comment or plain text part of a JsDoc comment.");
              return void 0;
            }
          }
          start = ts3.timestamp();
          var previousToken = ts3.findPrecedingToken(position, sourceFile, void 0);
          log("getCompletionData: Get previous token 1: " + (ts3.timestamp() - start));
          var contextToken = previousToken;
          if (contextToken && position <= contextToken.end && (ts3.isMemberName(contextToken) || ts3.isKeyword(contextToken.kind))) {
            var start_1 = ts3.timestamp();
            contextToken = ts3.findPrecedingToken(contextToken.getFullStart(), sourceFile, void 0);
            log("getCompletionData: Get previous token 2: " + (ts3.timestamp() - start_1));
          }
          var node = currentToken;
          var propertyAccessToConvert;
          var isRightOfDot = false;
          var isRightOfQuestionDot = false;
          var isRightOfOpenTag = false;
          var isStartingCloseTag = false;
          var isJsxInitializer = false;
          var isJsxIdentifierExpected = false;
          var importCompletionNode;
          var location = ts3.getTouchingPropertyName(sourceFile, position);
          if (contextToken) {
            var importCompletionCandidate = getImportCompletionNode(contextToken);
            if (importCompletionCandidate === 153) {
              return { kind: 4, keywords: [153] };
            }
            if (importCompletionCandidate && preferences.includeCompletionsForImportStatements && preferences.includeCompletionsWithInsertText) {
              importCompletionNode = importCompletionCandidate;
            }
            if (!importCompletionNode && isCompletionListBlocker(contextToken)) {
              log("Returning an empty list because completion was requested in an invalid position.");
              return void 0;
            }
            var parent = contextToken.parent;
            if (contextToken.kind === 24 || contextToken.kind === 28) {
              isRightOfDot = contextToken.kind === 24;
              isRightOfQuestionDot = contextToken.kind === 28;
              switch (parent.kind) {
                case 202:
                  propertyAccessToConvert = parent;
                  node = propertyAccessToConvert.expression;
                  if ((ts3.isCallExpression(node) || ts3.isFunctionLike(node)) && node.end === contextToken.pos && node.getChildCount(sourceFile) && ts3.last(node.getChildren(sourceFile)).kind !== 21) {
                    return void 0;
                  }
                  break;
                case 158:
                  node = parent.left;
                  break;
                case 257:
                  node = parent.name;
                  break;
                case 196:
                case 227:
                  node = parent;
                  break;
                default:
                  return void 0;
              }
            } else if (!importCompletionNode && sourceFile.languageVariant === 1) {
              if (parent && parent.kind === 202) {
                contextToken = parent;
                parent = parent.parent;
              }
              if (currentToken.parent === location) {
                switch (currentToken.kind) {
                  case 31:
                    if (currentToken.parent.kind === 274 || currentToken.parent.kind === 276) {
                      location = currentToken;
                    }
                    break;
                  case 43:
                    if (currentToken.parent.kind === 275) {
                      location = currentToken;
                    }
                    break;
                }
              }
              switch (parent.kind) {
                case 277:
                  if (contextToken.kind === 43) {
                    isStartingCloseTag = true;
                    location = contextToken;
                  }
                  break;
                case 217:
                  if (!binaryExpressionMayBeOpenTag(parent)) {
                    break;
                  }
                case 275:
                case 274:
                case 276:
                  isJsxIdentifierExpected = true;
                  if (contextToken.kind === 29) {
                    isRightOfOpenTag = true;
                    location = contextToken;
                  }
                  break;
                case 284:
                  if (previousToken.kind === 19 && currentToken.kind === 31) {
                    isJsxIdentifierExpected = true;
                  }
                  break;
                case 281:
                  if (parent.initializer === previousToken && previousToken.end < position) {
                    isJsxIdentifierExpected = true;
                    break;
                  }
                  switch (previousToken.kind) {
                    case 62:
                      isJsxInitializer = true;
                      break;
                    case 78:
                      isJsxIdentifierExpected = true;
                      if (parent !== previousToken.parent && !parent.initializer && ts3.findChildOfKind(parent, 62, sourceFile)) {
                        isJsxInitializer = previousToken;
                      }
                  }
                  break;
              }
            }
          }
          var semanticStart = ts3.timestamp();
          var completionKind = 5;
          var isNewIdentifierLocation = false;
          var isNonContextualObjectLiteral = false;
          var keywordFilters = 0;
          var symbols = [];
          var symbolToOriginInfoMap = [];
          var symbolToSortTextMap = [];
          var seenPropertySymbols = new ts3.Map();
          var isTypeOnly = isTypeOnlyCompletion();
          var getModuleSpecifierResolutionHost = ts3.memoizeOne(function(isFromPackageJson) {
            return ts3.createModuleSpecifierResolutionHost(isFromPackageJson ? host.getPackageJsonAutoImportProvider() : program2, host);
          });
          if (isRightOfDot || isRightOfQuestionDot) {
            getTypeScriptMemberSymbols();
          } else if (isRightOfOpenTag) {
            symbols = typeChecker.getJsxIntrinsicTagNamesAt(location);
            ts3.Debug.assertEachIsDefined(symbols, "getJsxIntrinsicTagNames() should all be defined");
            tryGetGlobalSymbols();
            completionKind = 1;
            keywordFilters = 0;
          } else if (isStartingCloseTag) {
            var tagName = contextToken.parent.parent.openingElement.tagName;
            var tagSymbol = typeChecker.getSymbolAtLocation(tagName);
            if (tagSymbol) {
              symbols = [tagSymbol];
            }
            completionKind = 1;
            keywordFilters = 0;
          } else {
            if (!tryGetGlobalSymbols()) {
              return void 0;
            }
          }
          log("getCompletionData: Semantic work: " + (ts3.timestamp() - semanticStart));
          var contextualType = previousToken && getContextualType(previousToken, position, sourceFile, typeChecker);
          var literals = ts3.mapDefined(contextualType && (contextualType.isUnion() ? contextualType.types : [contextualType]), function(t2) {
            return t2.isLiteral() ? t2.value : void 0;
          });
          var recommendedCompletion = previousToken && contextualType && getRecommendedCompletion(previousToken, contextualType, typeChecker);
          return {
            kind: 0,
            symbols,
            completionKind,
            isInSnippetScope,
            propertyAccessToConvert,
            isNewIdentifierLocation,
            location,
            keywordFilters,
            literals,
            symbolToOriginInfoMap,
            recommendedCompletion,
            previousToken,
            isJsxInitializer,
            insideJsDocTagTypeExpression,
            symbolToSortTextMap,
            isTypeOnlyLocation: isTypeOnly,
            isJsxIdentifierExpected,
            importCompletionNode
          };
          function isTagWithTypeExpression(tag2) {
            switch (tag2.kind) {
              case 330:
              case 337:
              case 331:
              case 333:
              case 335:
                return true;
              default:
                return false;
            }
          }
          function getTypeScriptMemberSymbols() {
            completionKind = 2;
            var isImportType = ts3.isLiteralImportTypeNode(node);
            var isTypeLocation = insideJsDocTagTypeExpression || isImportType && !node.isTypeOf || ts3.isPartOfTypeNode(node.parent) || ts3.isPossiblyTypeArgumentPosition(contextToken, sourceFile, typeChecker);
            var isRhsOfImportDeclaration = ts3.isInRightSideOfInternalImportEqualsDeclaration(node);
            if (ts3.isEntityName(node) || isImportType || ts3.isPropertyAccessExpression(node)) {
              var isNamespaceName = ts3.isModuleDeclaration(node.parent);
              if (isNamespaceName)
                isNewIdentifierLocation = true;
              var symbol = typeChecker.getSymbolAtLocation(node);
              if (symbol) {
                symbol = ts3.skipAlias(symbol, typeChecker);
                if (symbol.flags & (1536 | 384)) {
                  var exportedSymbols = typeChecker.getExportsOfModule(symbol);
                  ts3.Debug.assertEachIsDefined(exportedSymbols, "getExportsOfModule() should all be defined");
                  var isValidValueAccess_1 = function(symbol2) {
                    return typeChecker.isValidPropertyAccess(isImportType ? node : node.parent, symbol2.name);
                  };
                  var isValidTypeAccess_1 = function(symbol2) {
                    return symbolCanBeReferencedAtTypeLocation(symbol2, typeChecker);
                  };
                  var isValidAccess = isNamespaceName ? function(symbol2) {
                    var _a2;
                    return !!(symbol2.flags & 1920) && !((_a2 = symbol2.declarations) === null || _a2 === void 0 ? void 0 : _a2.every(function(d) {
                      return d.parent === node.parent;
                    }));
                  } : isRhsOfImportDeclaration ? function(symbol2) {
                    return isValidTypeAccess_1(symbol2) || isValidValueAccess_1(symbol2);
                  } : isTypeLocation ? isValidTypeAccess_1 : isValidValueAccess_1;
                  for (var _i = 0, exportedSymbols_1 = exportedSymbols; _i < exportedSymbols_1.length; _i++) {
                    var exportedSymbol = exportedSymbols_1[_i];
                    if (isValidAccess(exportedSymbol)) {
                      symbols.push(exportedSymbol);
                    }
                  }
                  if (!isTypeLocation && symbol.declarations && symbol.declarations.some(function(d) {
                    return d.kind !== 298 && d.kind !== 257 && d.kind !== 256;
                  })) {
                    var type3 = typeChecker.getTypeOfSymbolAtLocation(symbol, node).getNonOptionalType();
                    var insertQuestionDot = false;
                    if (type3.isNullableType()) {
                      var canCorrectToQuestionDot = isRightOfDot && !isRightOfQuestionDot && preferences.includeAutomaticOptionalChainCompletions !== false;
                      if (canCorrectToQuestionDot || isRightOfQuestionDot) {
                        type3 = type3.getNonNullableType();
                        if (canCorrectToQuestionDot) {
                          insertQuestionDot = true;
                        }
                      }
                    }
                    addTypeProperties(type3, !!(node.flags & 32768), insertQuestionDot);
                  }
                  return;
                }
              }
            }
            if (ts3.isMetaProperty(node) && (node.keywordToken === 102 || node.keywordToken === 99) && contextToken === node.getChildAt(1)) {
              var completion = node.keywordToken === 102 ? "target" : "meta";
              symbols.push(typeChecker.createSymbol(4, ts3.escapeLeadingUnderscores(completion)));
              return;
            }
            if (!isTypeLocation) {
              var type3 = typeChecker.getTypeAtLocation(node).getNonOptionalType();
              var insertQuestionDot = false;
              if (type3.isNullableType()) {
                var canCorrectToQuestionDot = isRightOfDot && !isRightOfQuestionDot && preferences.includeAutomaticOptionalChainCompletions !== false;
                if (canCorrectToQuestionDot || isRightOfQuestionDot) {
                  type3 = type3.getNonNullableType();
                  if (canCorrectToQuestionDot) {
                    insertQuestionDot = true;
                  }
                }
              }
              addTypeProperties(type3, !!(node.flags & 32768), insertQuestionDot);
            }
          }
          function addTypeProperties(type3, insertAwait, insertQuestionDot) {
            isNewIdentifierLocation = !!type3.getStringIndexType();
            if (isRightOfQuestionDot && ts3.some(type3.getCallSignatures())) {
              isNewIdentifierLocation = true;
            }
            var propertyAccess = node.kind === 196 ? node : node.parent;
            if (isUncheckedFile2) {
              symbols.push.apply(symbols, ts3.filter(getPropertiesForCompletion(type3, typeChecker), function(s2) {
                return typeChecker.isValidPropertyAccessForCompletions(propertyAccess, type3, s2);
              }));
            } else {
              for (var _i = 0, _a2 = type3.getApparentProperties(); _i < _a2.length; _i++) {
                var symbol = _a2[_i];
                if (typeChecker.isValidPropertyAccessForCompletions(propertyAccess, type3, symbol)) {
                  addPropertySymbol(symbol, false, insertQuestionDot);
                }
              }
            }
            if (insertAwait && preferences.includeCompletionsWithInsertText) {
              var promiseType = typeChecker.getPromisedTypeOfPromise(type3);
              if (promiseType) {
                for (var _b = 0, _c = promiseType.getApparentProperties(); _b < _c.length; _b++) {
                  var symbol = _c[_b];
                  if (typeChecker.isValidPropertyAccessForCompletions(propertyAccess, promiseType, symbol)) {
                    addPropertySymbol(symbol, true, insertQuestionDot);
                  }
                }
              }
            }
          }
          function addPropertySymbol(symbol, insertAwait, insertQuestionDot) {
            var computedPropertyName = ts3.firstDefined(symbol.declarations, function(decl) {
              return ts3.tryCast(ts3.getNameOfDeclaration(decl), ts3.isComputedPropertyName);
            });
            if (computedPropertyName) {
              var leftMostName = getLeftMostName(computedPropertyName.expression);
              var nameSymbol = leftMostName && typeChecker.getSymbolAtLocation(leftMostName);
              var firstAccessibleSymbol = nameSymbol && getFirstSymbolInChain(nameSymbol, contextToken, typeChecker);
              if (firstAccessibleSymbol && ts3.addToSeen(seenPropertySymbols, ts3.getSymbolId(firstAccessibleSymbol))) {
                var index = symbols.length;
                symbols.push(firstAccessibleSymbol);
                var moduleSymbol = firstAccessibleSymbol.parent;
                if (!moduleSymbol || !ts3.isExternalModuleSymbol(moduleSymbol)) {
                  symbolToOriginInfoMap[index] = { kind: getNullableSymbolOriginInfoKind(2) };
                } else {
                  var origin = {
                    kind: getNullableSymbolOriginInfoKind(6),
                    moduleSymbol,
                    isDefaultExport: false,
                    symbolName: firstAccessibleSymbol.name,
                    exportName: firstAccessibleSymbol.name,
                    fileName: ts3.isExternalModuleNameRelative(ts3.stripQuotes(moduleSymbol.name)) ? ts3.cast(moduleSymbol.valueDeclaration, ts3.isSourceFile).fileName : void 0
                  };
                  symbolToOriginInfoMap[index] = origin;
                }
              } else if (preferences.includeCompletionsWithInsertText) {
                addSymbolOriginInfo(symbol);
                addSymbolSortInfo(symbol);
                symbols.push(symbol);
              }
            } else {
              addSymbolOriginInfo(symbol);
              addSymbolSortInfo(symbol);
              symbols.push(symbol);
            }
            function addSymbolSortInfo(symbol2) {
              if (isStaticProperty(symbol2)) {
                symbolToSortTextMap[ts3.getSymbolId(symbol2)] = SortText.LocalDeclarationPriority;
              }
            }
            function addSymbolOriginInfo(symbol2) {
              if (preferences.includeCompletionsWithInsertText) {
                if (insertAwait && ts3.addToSeen(seenPropertySymbols, ts3.getSymbolId(symbol2))) {
                  symbolToOriginInfoMap[symbols.length] = { kind: getNullableSymbolOriginInfoKind(8) };
                } else if (insertQuestionDot) {
                  symbolToOriginInfoMap[symbols.length] = { kind: 16 };
                }
              }
            }
            function getNullableSymbolOriginInfoKind(kind) {
              return insertQuestionDot ? kind | 16 : kind;
            }
          }
          function getLeftMostName(e2) {
            return ts3.isIdentifier(e2) ? e2 : ts3.isPropertyAccessExpression(e2) ? getLeftMostName(e2.expression) : void 0;
          }
          function tryGetGlobalSymbols() {
            var result2 = tryGetObjectTypeLiteralInTypeArgumentCompletionSymbols() || tryGetObjectLikeCompletionSymbols() || tryGetImportCompletionSymbols() || tryGetImportOrExportClauseCompletionSymbols() || tryGetLocalNamedExportCompletionSymbols() || tryGetConstructorCompletion() || tryGetClassLikeCompletionSymbols() || tryGetJsxCompletionSymbols() || (getGlobalCompletions(), 1);
            return result2 === 1;
          }
          function tryGetConstructorCompletion() {
            if (!tryGetConstructorLikeCompletionContainer(contextToken))
              return 0;
            completionKind = 5;
            isNewIdentifierLocation = true;
            keywordFilters = 4;
            return 1;
          }
          function tryGetJsxCompletionSymbols() {
            var jsxContainer = tryGetContainingJsxElement(contextToken);
            var attrsType = jsxContainer && typeChecker.getContextualType(jsxContainer.attributes);
            if (!attrsType)
              return 0;
            var completionsType = jsxContainer && typeChecker.getContextualType(jsxContainer.attributes, 4);
            symbols = ts3.concatenate(symbols, filterJsxAttributes(getPropertiesForObjectExpression(attrsType, completionsType, jsxContainer.attributes, typeChecker), jsxContainer.attributes.properties));
            setSortTextToOptionalMember();
            completionKind = 3;
            isNewIdentifierLocation = false;
            return 1;
          }
          function tryGetImportCompletionSymbols() {
            if (!importCompletionNode)
              return 0;
            collectAutoImports(true);
            return 1;
          }
          function getGlobalCompletions() {
            keywordFilters = tryGetFunctionLikeBodyCompletionContainer(contextToken) ? 5 : 1;
            completionKind = 1;
            isNewIdentifierLocation = isNewIdentifierDefinitionLocation();
            if (previousToken !== contextToken) {
              ts3.Debug.assert(!!previousToken, "Expected 'contextToken' to be defined when different from 'previousToken'.");
            }
            var adjustedPosition = previousToken !== contextToken ? previousToken.getStart() : position;
            var scopeNode = getScopeNode(contextToken, adjustedPosition, sourceFile) || sourceFile;
            isInSnippetScope = isSnippetScope(scopeNode);
            var symbolMeanings = (isTypeOnly ? 0 : 111551) | 788968 | 1920 | 2097152;
            symbols = ts3.concatenate(symbols, typeChecker.getSymbolsInScope(scopeNode, symbolMeanings));
            ts3.Debug.assertEachIsDefined(symbols, "getSymbolsInScope() should all be defined");
            for (var _i = 0, symbols_1 = symbols; _i < symbols_1.length; _i++) {
              var symbol = symbols_1[_i];
              if (!typeChecker.isArgumentsSymbol(symbol) && !ts3.some(symbol.declarations, function(d) {
                return d.getSourceFile() === sourceFile;
              })) {
                symbolToSortTextMap[ts3.getSymbolId(symbol)] = SortText.GlobalsOrKeywords;
              }
            }
            if (preferences.includeCompletionsWithInsertText && scopeNode.kind !== 298) {
              var thisType = typeChecker.tryGetThisTypeAt(scopeNode, false);
              if (thisType && !isProbablyGlobalType(thisType, sourceFile, typeChecker)) {
                for (var _a2 = 0, _b = getPropertiesForCompletion(thisType, typeChecker); _a2 < _b.length; _a2++) {
                  var symbol = _b[_a2];
                  symbolToOriginInfoMap[symbols.length] = { kind: 1 };
                  symbols.push(symbol);
                  symbolToSortTextMap[ts3.getSymbolId(symbol)] = SortText.SuggestedClassMembers;
                }
              }
            }
            collectAutoImports(false);
            if (isTypeOnly) {
              keywordFilters = contextToken && ts3.isAssertionExpression(contextToken.parent) ? 6 : 7;
            }
          }
          function shouldOfferImportCompletions() {
            if (importCompletionNode)
              return true;
            if (isNonContextualObjectLiteral)
              return false;
            if (!preferences.includeCompletionsForModuleExports)
              return false;
            if (sourceFile.externalModuleIndicator || sourceFile.commonJsModuleIndicator)
              return true;
            if (ts3.compilerOptionsIndicateEs6Modules(program2.getCompilerOptions()))
              return true;
            return ts3.programContainsModules(program2);
          }
          function isSnippetScope(scopeNode) {
            switch (scopeNode.kind) {
              case 298:
              case 219:
              case 284:
              case 231:
                return true;
              default:
                return ts3.isStatement(scopeNode);
            }
          }
          function isTypeOnlyCompletion() {
            return insideJsDocTagTypeExpression || !isContextTokenValueLocation(contextToken) && (ts3.isPossiblyTypeArgumentPosition(contextToken, sourceFile, typeChecker) || ts3.isPartOfTypeNode(location) || isContextTokenTypeLocation(contextToken));
          }
          function isContextTokenValueLocation(contextToken2) {
            return contextToken2 && (contextToken2.kind === 111 && (contextToken2.parent.kind === 177 || ts3.isTypeOfExpression(contextToken2.parent)) || contextToken2.kind === 127 && contextToken2.parent.kind === 173);
          }
          function isContextTokenTypeLocation(contextToken2) {
            if (contextToken2) {
              var parentKind = contextToken2.parent.kind;
              switch (contextToken2.kind) {
                case 58:
                  return parentKind === 164 || parentKind === 163 || parentKind === 161 || parentKind === 250 || ts3.isFunctionLikeKind(parentKind);
                case 62:
                  return parentKind === 255;
                case 126:
                  return parentKind === 225;
                case 29:
                  return parentKind === 174 || parentKind === 207;
                case 93:
                  return parentKind === 160;
              }
            }
            return false;
          }
          function collectAutoImports(resolveModuleSpecifiers) {
            var _a2, _b, _c, _d, _e;
            if (!shouldOfferImportCompletions())
              return;
            ts3.Debug.assert(!(detailsEntryId === null || detailsEntryId === void 0 ? void 0 : detailsEntryId.data));
            var start2 = ts3.timestamp();
            var moduleSpecifierCache = (_a2 = host.getModuleSpecifierCache) === null || _a2 === void 0 ? void 0 : _a2.call(host);
            (_b = host.log) === null || _b === void 0 ? void 0 : _b.call(host, "collectAutoImports: starting, " + (resolveModuleSpecifiers ? "" : "not ") + "resolving module specifiers");
            if (moduleSpecifierCache) {
              (_c = host.log) === null || _c === void 0 ? void 0 : _c.call(host, "collectAutoImports: module specifier cache size: " + moduleSpecifierCache.count());
            }
            var lowerCaseTokenText = previousToken && ts3.isIdentifier(previousToken) ? previousToken.text.toLowerCase() : "";
            var exportInfo = ts3.codefix.getSymbolToExportInfoMap(sourceFile, host, program2);
            var packageJsonAutoImportProvider = (_d = host.getPackageJsonAutoImportProvider) === null || _d === void 0 ? void 0 : _d.call(host);
            var packageJsonFilter = detailsEntryId ? void 0 : ts3.createPackageJsonImportFilter(sourceFile, host);
            exportInfo.forEach(function(info, key2) {
              var symbolName = key2.substring(0, key2.indexOf("|"));
              if (!detailsEntryId && ts3.isStringANonContextualKeyword(symbolName))
                return;
              var isCompletionDetailsMatch = detailsEntryId && ts3.some(info, function(i3) {
                return detailsEntryId.source === ts3.stripQuotes(i3.moduleSymbol.name);
              });
              if (isCompletionDetailsMatch || isNameMatch(symbolName)) {
                var _a3 = resolveModuleSpecifiers ? ts3.codefix.getModuleSpecifierForBestExportInfo(info, sourceFile, program2, host, preferences) : { moduleSpecifier: void 0, exportInfo: ts3.find(info, isImportableExportInfo) }, moduleSpecifier = _a3.moduleSpecifier, exportInfo_1 = _a3.exportInfo;
                if (!exportInfo_1)
                  return;
                var moduleFile = ts3.tryCast(exportInfo_1.moduleSymbol.valueDeclaration, ts3.isSourceFile);
                var isDefaultExport = exportInfo_1.exportKind === 1;
                var symbol = isDefaultExport && ts3.getLocalSymbolForExportDefault(exportInfo_1.symbol) || exportInfo_1.symbol;
                pushAutoImportSymbol(symbol, {
                  kind: resolveModuleSpecifiers ? 32 : 4,
                  moduleSpecifier,
                  symbolName,
                  exportName: exportInfo_1.exportKind === 2 ? "export=" : exportInfo_1.symbol.name,
                  fileName: moduleFile === null || moduleFile === void 0 ? void 0 : moduleFile.fileName,
                  isDefaultExport,
                  moduleSymbol: exportInfo_1.moduleSymbol,
                  isFromPackageJson: exportInfo_1.isFromPackageJson
                });
              }
            });
            (_e = host.log) === null || _e === void 0 ? void 0 : _e.call(host, "collectAutoImports: done in " + (ts3.timestamp() - start2) + " ms");
            function isNameMatch(symbolName) {
              var lowerCaseSymbolName = symbolName.toLowerCase();
              if (resolveModuleSpecifiers && lowerCaseTokenText) {
                return lowerCaseTokenText[0] === lowerCaseSymbolName[0] && stringContainsCharactersInOrder(lowerCaseSymbolName, lowerCaseTokenText);
              }
              return stringContainsCharactersInOrder(lowerCaseSymbolName, lowerCaseTokenText);
            }
            function isImportableExportInfo(info) {
              var moduleFile = ts3.tryCast(info.moduleSymbol.valueDeclaration, ts3.isSourceFile);
              if (!moduleFile) {
                return packageJsonFilter ? packageJsonFilter.allowsImportingAmbientModule(info.moduleSymbol, getModuleSpecifierResolutionHost(info.isFromPackageJson)) : true;
              }
              return ts3.isImportableFile(info.isFromPackageJson ? packageJsonAutoImportProvider : program2, sourceFile, moduleFile, packageJsonFilter, getModuleSpecifierResolutionHost(info.isFromPackageJson), moduleSpecifierCache);
            }
          }
          function pushAutoImportSymbol(symbol, origin) {
            var symbolId = ts3.getSymbolId(symbol);
            if (symbolToSortTextMap[symbolId] === SortText.GlobalsOrKeywords) {
              return;
            }
            symbolToOriginInfoMap[symbols.length] = origin;
            symbolToSortTextMap[symbolId] = importCompletionNode ? SortText.LocationPriority : SortText.AutoImportSuggestions;
            symbols.push(symbol);
          }
          function stringContainsCharactersInOrder(str2, characters) {
            if (characters.length === 0) {
              return true;
            }
            var characterIndex = 0;
            var len = str2.length;
            for (var strIndex = 0; strIndex < len; strIndex++) {
              if (str2.charCodeAt(strIndex) === characters.charCodeAt(characterIndex)) {
                characterIndex++;
                if (characterIndex === characters.length) {
                  return true;
                }
              }
            }
            return false;
          }
          function getScopeNode(initialToken, position2, sourceFile2) {
            var scope = initialToken;
            while (scope && !ts3.positionBelongsToNode(scope, position2, sourceFile2)) {
              scope = scope.parent;
            }
            return scope;
          }
          function isCompletionListBlocker(contextToken2) {
            var start2 = ts3.timestamp();
            var result2 = isInStringOrRegularExpressionOrTemplateLiteral(contextToken2) || isSolelyIdentifierDefinitionLocation(contextToken2) || isDotOfNumericLiteral(contextToken2) || isInJsxText(contextToken2);
            log("getCompletionsAtPosition: isCompletionListBlocker: " + (ts3.timestamp() - start2));
            return result2;
          }
          function isInJsxText(contextToken2) {
            if (contextToken2.kind === 11) {
              return true;
            }
            if (contextToken2.kind === 31 && contextToken2.parent) {
              if (contextToken2.parent.kind === 276) {
                return location.parent.kind !== 276;
              }
              if (contextToken2.parent.kind === 277 || contextToken2.parent.kind === 275) {
                return !!contextToken2.parent.parent && contextToken2.parent.parent.kind === 274;
              }
            }
            return false;
          }
          function isNewIdentifierDefinitionLocation() {
            if (contextToken) {
              var containingNodeKind = contextToken.parent.kind;
              switch (keywordForNode(contextToken)) {
                case 27:
                  return containingNodeKind === 204 || containingNodeKind === 167 || containingNodeKind === 205 || containingNodeKind === 200 || containingNodeKind === 217 || containingNodeKind === 175 || containingNodeKind === 201;
                case 20:
                  return containingNodeKind === 204 || containingNodeKind === 167 || containingNodeKind === 205 || containingNodeKind === 208 || containingNodeKind === 187;
                case 22:
                  return containingNodeKind === 200 || containingNodeKind === 172 || containingNodeKind === 159;
                case 139:
                case 140:
                  return true;
                case 24:
                  return containingNodeKind === 257;
                case 18:
                  return containingNodeKind === 253 || containingNodeKind === 201;
                case 62:
                  return containingNodeKind === 250 || containingNodeKind === 217;
                case 15:
                  return containingNodeKind === 219;
                case 16:
                  return containingNodeKind === 229;
                case 122:
                case 120:
                case 121:
                  return containingNodeKind === 164;
              }
            }
            return false;
          }
          function isInStringOrRegularExpressionOrTemplateLiteral(contextToken2) {
            return (ts3.isRegularExpressionLiteral(contextToken2) || ts3.isStringTextContainingNode(contextToken2)) && (ts3.rangeContainsPositionExclusive(ts3.createTextRangeFromSpan(ts3.createTextSpanFromNode(contextToken2)), position) || position === contextToken2.end && (!!contextToken2.isUnterminated || ts3.isRegularExpressionLiteral(contextToken2)));
          }
          function tryGetObjectTypeLiteralInTypeArgumentCompletionSymbols() {
            var typeLiteralNode = tryGetTypeLiteralNode(contextToken);
            if (!typeLiteralNode)
              return 0;
            var intersectionTypeNode = ts3.isIntersectionTypeNode(typeLiteralNode.parent) ? typeLiteralNode.parent : void 0;
            var containerTypeNode = intersectionTypeNode || typeLiteralNode;
            var containerExpectedType = getConstraintOfTypeArgumentProperty(containerTypeNode, typeChecker);
            if (!containerExpectedType)
              return 0;
            var containerActualType = typeChecker.getTypeFromTypeNode(containerTypeNode);
            var members = getPropertiesForCompletion(containerExpectedType, typeChecker);
            var existingMembers = getPropertiesForCompletion(containerActualType, typeChecker);
            var existingMemberEscapedNames = new ts3.Set();
            existingMembers.forEach(function(s2) {
              return existingMemberEscapedNames.add(s2.escapedName);
            });
            symbols = ts3.concatenate(symbols, ts3.filter(members, function(s2) {
              return !existingMemberEscapedNames.has(s2.escapedName);
            }));
            completionKind = 0;
            isNewIdentifierLocation = true;
            return 1;
          }
          function tryGetObjectLikeCompletionSymbols() {
            var objectLikeContainer = tryGetObjectLikeCompletionContainer(contextToken);
            if (!objectLikeContainer)
              return 0;
            completionKind = 0;
            var typeMembers;
            var existingMembers;
            if (objectLikeContainer.kind === 201) {
              var instantiatedType = tryGetObjectLiteralContextualType(objectLikeContainer, typeChecker);
              if (instantiatedType === void 0) {
                if (objectLikeContainer.flags & 16777216) {
                  return 2;
                }
                isNonContextualObjectLiteral = true;
                return 0;
              }
              var completionsType = typeChecker.getContextualType(objectLikeContainer, 4);
              var hasStringIndexType = (completionsType || instantiatedType).getStringIndexType();
              var hasNumberIndextype = (completionsType || instantiatedType).getNumberIndexType();
              isNewIdentifierLocation = !!hasStringIndexType || !!hasNumberIndextype;
              typeMembers = getPropertiesForObjectExpression(instantiatedType, completionsType, objectLikeContainer, typeChecker);
              existingMembers = objectLikeContainer.properties;
              if (typeMembers.length === 0) {
                if (!hasNumberIndextype) {
                  isNonContextualObjectLiteral = true;
                  return 0;
                }
              }
            } else {
              ts3.Debug.assert(objectLikeContainer.kind === 197);
              isNewIdentifierLocation = false;
              var rootDeclaration = ts3.getRootDeclaration(objectLikeContainer.parent);
              if (!ts3.isVariableLike(rootDeclaration))
                return ts3.Debug.fail("Root declaration is not variable-like.");
              var canGetType = ts3.hasInitializer(rootDeclaration) || ts3.hasType(rootDeclaration) || rootDeclaration.parent.parent.kind === 240;
              if (!canGetType && rootDeclaration.kind === 161) {
                if (ts3.isExpression(rootDeclaration.parent)) {
                  canGetType = !!typeChecker.getContextualType(rootDeclaration.parent);
                } else if (rootDeclaration.parent.kind === 166 || rootDeclaration.parent.kind === 169) {
                  canGetType = ts3.isExpression(rootDeclaration.parent.parent) && !!typeChecker.getContextualType(rootDeclaration.parent.parent);
                }
              }
              if (canGetType) {
                var typeForObject_1 = typeChecker.getTypeAtLocation(objectLikeContainer);
                if (!typeForObject_1)
                  return 2;
                var containerClass_1 = ts3.getContainingClass(objectLikeContainer);
                typeMembers = typeChecker.getPropertiesOfType(typeForObject_1).filter(function(symbol) {
                  return !(ts3.getDeclarationModifierFlagsFromSymbol(symbol) & 24) || containerClass_1 && ts3.contains(typeForObject_1.symbol.declarations, containerClass_1);
                });
                existingMembers = objectLikeContainer.elements;
              }
            }
            if (typeMembers && typeMembers.length > 0) {
              symbols = ts3.concatenate(symbols, filterObjectMembersList(typeMembers, ts3.Debug.checkDefined(existingMembers)));
            }
            setSortTextToOptionalMember();
            return 1;
          }
          function tryGetImportOrExportClauseCompletionSymbols() {
            var namedImportsOrExports = contextToken && (contextToken.kind === 18 || contextToken.kind === 27) ? ts3.tryCast(contextToken.parent, ts3.isNamedImportsOrExports) : void 0;
            if (!namedImportsOrExports)
              return 0;
            var moduleSpecifier = (namedImportsOrExports.kind === 265 ? namedImportsOrExports.parent.parent : namedImportsOrExports.parent).moduleSpecifier;
            if (!moduleSpecifier)
              return namedImportsOrExports.kind === 265 ? 2 : 0;
            var moduleSpecifierSymbol = typeChecker.getSymbolAtLocation(moduleSpecifier);
            if (!moduleSpecifierSymbol)
              return 2;
            completionKind = 3;
            isNewIdentifierLocation = false;
            var exports3 = typeChecker.getExportsAndPropertiesOfModule(moduleSpecifierSymbol);
            var existing = new ts3.Set(namedImportsOrExports.elements.filter(function(n2) {
              return !isCurrentlyEditingNode(n2);
            }).map(function(n2) {
              return (n2.propertyName || n2.name).escapedText;
            }));
            symbols = ts3.concatenate(symbols, exports3.filter(function(e2) {
              return e2.escapedName !== "default" && !existing.has(e2.escapedName);
            }));
            return 1;
          }
          function tryGetLocalNamedExportCompletionSymbols() {
            var _a2;
            var namedExports = contextToken && (contextToken.kind === 18 || contextToken.kind === 27) ? ts3.tryCast(contextToken.parent, ts3.isNamedExports) : void 0;
            if (!namedExports) {
              return 0;
            }
            var localsContainer = ts3.findAncestor(namedExports, ts3.or(ts3.isSourceFile, ts3.isModuleDeclaration));
            completionKind = 5;
            isNewIdentifierLocation = false;
            (_a2 = localsContainer.locals) === null || _a2 === void 0 ? void 0 : _a2.forEach(function(symbol, name) {
              var _a3, _b;
              symbols.push(symbol);
              if ((_b = (_a3 = localsContainer.symbol) === null || _a3 === void 0 ? void 0 : _a3.exports) === null || _b === void 0 ? void 0 : _b.has(name)) {
                symbolToSortTextMap[ts3.getSymbolId(symbol)] = SortText.OptionalMember;
              }
            });
            return 1;
          }
          function tryGetClassLikeCompletionSymbols() {
            var decl = tryGetObjectTypeDeclarationCompletionContainer(sourceFile, contextToken, location, position);
            if (!decl)
              return 0;
            completionKind = 3;
            isNewIdentifierLocation = true;
            keywordFilters = contextToken.kind === 41 ? 0 : ts3.isClassLike(decl) ? 2 : 3;
            if (!ts3.isClassLike(decl))
              return 1;
            var classElement = contextToken.kind === 26 ? contextToken.parent.parent : contextToken.parent;
            var classElementModifierFlags = ts3.isClassElement(classElement) ? ts3.getEffectiveModifierFlags(classElement) : 0;
            if (contextToken.kind === 78 && !isCurrentlyEditingNode(contextToken)) {
              switch (contextToken.getText()) {
                case "private":
                  classElementModifierFlags = classElementModifierFlags | 8;
                  break;
                case "static":
                  classElementModifierFlags = classElementModifierFlags | 32;
                  break;
                case "override":
                  classElementModifierFlags = classElementModifierFlags | 16384;
                  break;
              }
            }
            if (!(classElementModifierFlags & 8)) {
              var baseTypeNodes = ts3.isClassLike(decl) && classElementModifierFlags & 16384 ? ts3.singleElementArray(ts3.getEffectiveBaseTypeNode(decl)) : ts3.getAllSuperTypeNodes(decl);
              var baseSymbols = ts3.flatMap(baseTypeNodes, function(baseTypeNode) {
                var type3 = typeChecker.getTypeAtLocation(baseTypeNode);
                return classElementModifierFlags & 32 ? (type3 === null || type3 === void 0 ? void 0 : type3.symbol) && typeChecker.getPropertiesOfType(typeChecker.getTypeOfSymbolAtLocation(type3.symbol, decl)) : type3 && typeChecker.getPropertiesOfType(type3);
              });
              symbols = ts3.concatenate(symbols, filterClassMembersList(baseSymbols, decl.members, classElementModifierFlags));
            }
            return 1;
          }
          function tryGetObjectLikeCompletionContainer(contextToken2) {
            if (contextToken2) {
              var parent2 = contextToken2.parent;
              switch (contextToken2.kind) {
                case 18:
                case 27:
                  if (ts3.isObjectLiteralExpression(parent2) || ts3.isObjectBindingPattern(parent2)) {
                    return parent2;
                  }
                  break;
                case 41:
                  return ts3.isMethodDeclaration(parent2) ? ts3.tryCast(parent2.parent, ts3.isObjectLiteralExpression) : void 0;
                case 78:
                  return contextToken2.text === "async" && ts3.isShorthandPropertyAssignment(contextToken2.parent) ? contextToken2.parent.parent : void 0;
              }
            }
            return void 0;
          }
          function isConstructorParameterCompletion(node2) {
            return !!node2.parent && ts3.isParameter(node2.parent) && ts3.isConstructorDeclaration(node2.parent.parent) && (ts3.isParameterPropertyModifier(node2.kind) || ts3.isDeclarationName(node2));
          }
          function tryGetConstructorLikeCompletionContainer(contextToken2) {
            if (contextToken2) {
              var parent2 = contextToken2.parent;
              switch (contextToken2.kind) {
                case 20:
                case 27:
                  return ts3.isConstructorDeclaration(contextToken2.parent) ? contextToken2.parent : void 0;
                default:
                  if (isConstructorParameterCompletion(contextToken2)) {
                    return parent2.parent;
                  }
              }
            }
            return void 0;
          }
          function tryGetFunctionLikeBodyCompletionContainer(contextToken2) {
            if (contextToken2) {
              var prev_1;
              var container = ts3.findAncestor(contextToken2.parent, function(node2) {
                if (ts3.isClassLike(node2)) {
                  return "quit";
                }
                if (ts3.isFunctionLikeDeclaration(node2) && prev_1 === node2.body) {
                  return true;
                }
                prev_1 = node2;
                return false;
              });
              return container && container;
            }
          }
          function tryGetContainingJsxElement(contextToken2) {
            if (contextToken2) {
              var parent2 = contextToken2.parent;
              switch (contextToken2.kind) {
                case 31:
                case 30:
                case 43:
                case 78:
                case 202:
                case 282:
                case 281:
                case 283:
                  if (parent2 && (parent2.kind === 275 || parent2.kind === 276)) {
                    if (contextToken2.kind === 31) {
                      var precedingToken = ts3.findPrecedingToken(contextToken2.pos, sourceFile, void 0);
                      if (!parent2.typeArguments || precedingToken && precedingToken.kind === 43)
                        break;
                    }
                    return parent2;
                  } else if (parent2.kind === 281) {
                    return parent2.parent.parent;
                  }
                  break;
                case 10:
                  if (parent2 && (parent2.kind === 281 || parent2.kind === 283)) {
                    return parent2.parent.parent;
                  }
                  break;
                case 19:
                  if (parent2 && parent2.kind === 284 && parent2.parent && parent2.parent.kind === 281) {
                    return parent2.parent.parent.parent;
                  }
                  if (parent2 && parent2.kind === 283) {
                    return parent2.parent.parent;
                  }
                  break;
              }
            }
            return void 0;
          }
          function isSolelyIdentifierDefinitionLocation(contextToken2) {
            var parent2 = contextToken2.parent;
            var containingNodeKind = parent2.kind;
            switch (contextToken2.kind) {
              case 27:
                return containingNodeKind === 250 || isVariableDeclarationListButNotTypeArgument(contextToken2) || containingNodeKind === 233 || containingNodeKind === 256 || isFunctionLikeButNotConstructor(containingNodeKind) || containingNodeKind === 254 || containingNodeKind === 198 || containingNodeKind === 255 || ts3.isClassLike(parent2) && !!parent2.typeParameters && parent2.typeParameters.end >= contextToken2.pos;
              case 24:
                return containingNodeKind === 198;
              case 58:
                return containingNodeKind === 199;
              case 22:
                return containingNodeKind === 198;
              case 20:
                return containingNodeKind === 288 || isFunctionLikeButNotConstructor(containingNodeKind);
              case 18:
                return containingNodeKind === 256;
              case 29:
                return containingNodeKind === 253 || containingNodeKind === 222 || containingNodeKind === 254 || containingNodeKind === 255 || ts3.isFunctionLikeKind(containingNodeKind);
              case 123:
                return containingNodeKind === 164 && !ts3.isClassLike(parent2.parent);
              case 25:
                return containingNodeKind === 161 || !!parent2.parent && parent2.parent.kind === 198;
              case 122:
              case 120:
              case 121:
                return containingNodeKind === 161 && !ts3.isConstructorDeclaration(parent2.parent);
              case 126:
                return containingNodeKind === 266 || containingNodeKind === 271 || containingNodeKind === 264;
              case 134:
              case 146:
                return !isFromObjectTypeDeclaration(contextToken2);
              case 83:
              case 91:
              case 117:
              case 97:
              case 112:
              case 99:
              case 118:
              case 84:
              case 135:
              case 149:
                return true;
              case 41:
                return ts3.isFunctionLike(contextToken2.parent) && !ts3.isMethodDeclaration(contextToken2.parent);
            }
            if (isClassMemberCompletionKeyword(keywordForNode(contextToken2)) && isFromObjectTypeDeclaration(contextToken2)) {
              return false;
            }
            if (isConstructorParameterCompletion(contextToken2)) {
              if (!ts3.isIdentifier(contextToken2) || ts3.isParameterPropertyModifier(keywordForNode(contextToken2)) || isCurrentlyEditingNode(contextToken2)) {
                return false;
              }
            }
            switch (keywordForNode(contextToken2)) {
              case 125:
              case 83:
              case 84:
              case 133:
              case 91:
              case 97:
              case 117:
              case 118:
              case 120:
              case 121:
              case 122:
              case 123:
              case 112:
                return true;
              case 129:
                return ts3.isPropertyDeclaration(contextToken2.parent);
            }
            var ancestorClassLike = ts3.findAncestor(contextToken2.parent, ts3.isClassLike);
            if (ancestorClassLike && contextToken2 === previousToken && isPreviousPropertyDeclarationTerminated(contextToken2, position)) {
              return false;
            }
            var ancestorPropertyDeclaraion = ts3.getAncestor(contextToken2.parent, 164);
            if (ancestorPropertyDeclaraion && contextToken2 !== previousToken && ts3.isClassLike(previousToken.parent.parent) && position <= previousToken.end) {
              if (isPreviousPropertyDeclarationTerminated(contextToken2, previousToken.end)) {
                return false;
              } else if (contextToken2.kind !== 62 && (ts3.isInitializedProperty(ancestorPropertyDeclaraion) || ts3.hasType(ancestorPropertyDeclaraion))) {
                return true;
              }
            }
            return ts3.isDeclarationName(contextToken2) && !ts3.isShorthandPropertyAssignment(contextToken2.parent) && !ts3.isJsxAttribute(contextToken2.parent) && !(ts3.isClassLike(contextToken2.parent) && (contextToken2 !== previousToken || position > previousToken.end));
          }
          function isPreviousPropertyDeclarationTerminated(contextToken2, position2) {
            return contextToken2.kind !== 62 && (contextToken2.kind === 26 || !ts3.positionsAreOnSameLine(contextToken2.end, position2, sourceFile));
          }
          function isFunctionLikeButNotConstructor(kind) {
            return ts3.isFunctionLikeKind(kind) && kind !== 167;
          }
          function isDotOfNumericLiteral(contextToken2) {
            if (contextToken2.kind === 8) {
              var text = contextToken2.getFullText();
              return text.charAt(text.length - 1) === ".";
            }
            return false;
          }
          function isVariableDeclarationListButNotTypeArgument(node2) {
            return node2.parent.kind === 251 && !ts3.isPossiblyTypeArgumentPosition(node2, sourceFile, typeChecker);
          }
          function filterObjectMembersList(contextualMemberSymbols, existingMembers) {
            if (existingMembers.length === 0) {
              return contextualMemberSymbols;
            }
            var membersDeclaredBySpreadAssignment = new ts3.Set();
            var existingMemberNames = new ts3.Set();
            for (var _i = 0, existingMembers_1 = existingMembers; _i < existingMembers_1.length; _i++) {
              var m = existingMembers_1[_i];
              if (m.kind !== 289 && m.kind !== 290 && m.kind !== 199 && m.kind !== 166 && m.kind !== 168 && m.kind !== 169 && m.kind !== 291) {
                continue;
              }
              if (isCurrentlyEditingNode(m)) {
                continue;
              }
              var existingName = void 0;
              if (ts3.isSpreadAssignment(m)) {
                setMembersDeclaredBySpreadAssignment(m, membersDeclaredBySpreadAssignment);
              } else if (ts3.isBindingElement(m) && m.propertyName) {
                if (m.propertyName.kind === 78) {
                  existingName = m.propertyName.escapedText;
                }
              } else {
                var name = ts3.getNameOfDeclaration(m);
                existingName = name && ts3.isPropertyNameLiteral(name) ? ts3.getEscapedTextOfIdentifierOrLiteral(name) : void 0;
              }
              if (existingName !== void 0) {
                existingMemberNames.add(existingName);
              }
            }
            var filteredSymbols = contextualMemberSymbols.filter(function(m2) {
              return !existingMemberNames.has(m2.escapedName);
            });
            setSortTextToMemberDeclaredBySpreadAssignment(membersDeclaredBySpreadAssignment, filteredSymbols);
            return filteredSymbols;
          }
          function setMembersDeclaredBySpreadAssignment(declaration, membersDeclaredBySpreadAssignment) {
            var expression = declaration.expression;
            var symbol = typeChecker.getSymbolAtLocation(expression);
            var type3 = symbol && typeChecker.getTypeOfSymbolAtLocation(symbol, expression);
            var properties = type3 && type3.properties;
            if (properties) {
              properties.forEach(function(property) {
                membersDeclaredBySpreadAssignment.add(property.name);
              });
            }
          }
          function setSortTextToOptionalMember() {
            symbols.forEach(function(m) {
              if (m.flags & 16777216) {
                symbolToSortTextMap[ts3.getSymbolId(m)] = symbolToSortTextMap[ts3.getSymbolId(m)] || SortText.OptionalMember;
              }
            });
          }
          function setSortTextToMemberDeclaredBySpreadAssignment(membersDeclaredBySpreadAssignment, contextualMemberSymbols) {
            if (membersDeclaredBySpreadAssignment.size === 0) {
              return;
            }
            for (var _i = 0, contextualMemberSymbols_1 = contextualMemberSymbols; _i < contextualMemberSymbols_1.length; _i++) {
              var contextualMemberSymbol = contextualMemberSymbols_1[_i];
              if (membersDeclaredBySpreadAssignment.has(contextualMemberSymbol.name)) {
                symbolToSortTextMap[ts3.getSymbolId(contextualMemberSymbol)] = SortText.MemberDeclaredBySpreadAssignment;
              }
            }
          }
          function filterClassMembersList(baseSymbols, existingMembers, currentClassElementModifierFlags) {
            var existingMemberNames = new ts3.Set();
            for (var _i = 0, existingMembers_2 = existingMembers; _i < existingMembers_2.length; _i++) {
              var m = existingMembers_2[_i];
              if (m.kind !== 164 && m.kind !== 166 && m.kind !== 168 && m.kind !== 169) {
                continue;
              }
              if (isCurrentlyEditingNode(m)) {
                continue;
              }
              if (ts3.hasEffectiveModifier(m, 8)) {
                continue;
              }
              if (ts3.hasEffectiveModifier(m, 32) !== !!(currentClassElementModifierFlags & 32)) {
                continue;
              }
              var existingName = ts3.getPropertyNameForPropertyNameNode(m.name);
              if (existingName) {
                existingMemberNames.add(existingName);
              }
            }
            return baseSymbols.filter(function(propertySymbol) {
              return !existingMemberNames.has(propertySymbol.escapedName) && !!propertySymbol.declarations && !(ts3.getDeclarationModifierFlagsFromSymbol(propertySymbol) & 8) && !(propertySymbol.valueDeclaration && ts3.isPrivateIdentifierClassElementDeclaration(propertySymbol.valueDeclaration));
            });
          }
          function filterJsxAttributes(symbols2, attributes) {
            var seenNames = new ts3.Set();
            var membersDeclaredBySpreadAssignment = new ts3.Set();
            for (var _i = 0, attributes_1 = attributes; _i < attributes_1.length; _i++) {
              var attr = attributes_1[_i];
              if (isCurrentlyEditingNode(attr)) {
                continue;
              }
              if (attr.kind === 281) {
                seenNames.add(attr.name.escapedText);
              } else if (ts3.isJsxSpreadAttribute(attr)) {
                setMembersDeclaredBySpreadAssignment(attr, membersDeclaredBySpreadAssignment);
              }
            }
            var filteredSymbols = symbols2.filter(function(a2) {
              return !seenNames.has(a2.escapedName);
            });
            setSortTextToMemberDeclaredBySpreadAssignment(membersDeclaredBySpreadAssignment, filteredSymbols);
            return filteredSymbols;
          }
          function isCurrentlyEditingNode(node2) {
            return node2.getStart(sourceFile) <= position && position <= node2.getEnd();
          }
        }
        function getAutoImportSymbolFromCompletionEntryData(name, data, program2, host) {
          var containingProgram = data.isPackageJsonImport ? host.getPackageJsonAutoImportProvider() : program2;
          var checker = containingProgram.getTypeChecker();
          var moduleSymbol = data.ambientModuleName ? checker.tryFindAmbientModule(data.ambientModuleName) : data.fileName ? checker.getMergedSymbol(ts3.Debug.checkDefined(containingProgram.getSourceFile(data.fileName)).symbol) : void 0;
          if (!moduleSymbol)
            return void 0;
          var symbol = data.exportName === "export=" ? checker.resolveExternalModuleSymbol(moduleSymbol) : checker.tryGetMemberInModuleExportsAndProperties(data.exportName, moduleSymbol);
          if (!symbol)
            return void 0;
          var isDefaultExport = data.exportName === "default";
          symbol = isDefaultExport && ts3.getLocalSymbolForExportDefault(symbol) || symbol;
          return {
            symbol,
            origin: {
              kind: data.moduleSpecifier ? 32 : 4,
              moduleSymbol,
              symbolName: name,
              isDefaultExport,
              exportName: data.exportName,
              fileName: data.fileName
            }
          };
        }
        function getCompletionEntryDisplayNameForSymbol(symbol, target, origin, kind, jsxIdentifierExpected) {
          var name = originIncludesSymbolName(origin) ? origin.symbolName : symbol.name;
          if (name === void 0 || symbol.flags & 1536 && ts3.isSingleOrDoubleQuote(name.charCodeAt(0)) || ts3.isKnownSymbol(symbol)) {
            return void 0;
          }
          var validNameResult = { name, needsConvertPropertyAccess: false };
          if (ts3.isIdentifierText(name, target, jsxIdentifierExpected ? 1 : 0) || symbol.valueDeclaration && ts3.isPrivateIdentifierClassElementDeclaration(symbol.valueDeclaration)) {
            return validNameResult;
          }
          switch (kind) {
            case 3:
              return void 0;
            case 0:
              return { name: JSON.stringify(name), needsConvertPropertyAccess: false };
            case 2:
            case 1:
              return name.charCodeAt(0) === 32 ? void 0 : { name, needsConvertPropertyAccess: true };
            case 5:
            case 4:
              return validNameResult;
            default:
              ts3.Debug.assertNever(kind);
          }
        }
        var _keywordCompletions = [];
        var allKeywordsCompletions = ts3.memoize(function() {
          var res = [];
          for (var i3 = 80; i3 <= 157; i3++) {
            res.push({
              name: ts3.tokenToString(i3),
              kind: "keyword",
              kindModifiers: "",
              sortText: SortText.GlobalsOrKeywords
            });
          }
          return res;
        });
        function getKeywordCompletions(keywordFilter, filterOutTsOnlyKeywords) {
          if (!filterOutTsOnlyKeywords)
            return getTypescriptKeywordCompletions(keywordFilter);
          var index = keywordFilter + 7 + 1;
          return _keywordCompletions[index] || (_keywordCompletions[index] = getTypescriptKeywordCompletions(keywordFilter).filter(function(entry) {
            return !isTypeScriptOnlyKeyword(ts3.stringToToken(entry.name));
          }));
        }
        function getTypescriptKeywordCompletions(keywordFilter) {
          return _keywordCompletions[keywordFilter] || (_keywordCompletions[keywordFilter] = allKeywordsCompletions().filter(function(entry) {
            var kind = ts3.stringToToken(entry.name);
            switch (keywordFilter) {
              case 0:
                return false;
              case 1:
                return isFunctionLikeBodyKeyword(kind) || kind === 133 || kind === 139 || kind === 149 || kind === 140 || ts3.isTypeKeyword(kind) && kind !== 150;
              case 5:
                return isFunctionLikeBodyKeyword(kind);
              case 2:
                return isClassMemberCompletionKeyword(kind);
              case 3:
                return isInterfaceOrTypeLiteralCompletionKeyword(kind);
              case 4:
                return ts3.isParameterPropertyModifier(kind);
              case 6:
                return ts3.isTypeKeyword(kind) || kind === 84;
              case 7:
                return ts3.isTypeKeyword(kind);
              default:
                return ts3.Debug.assertNever(keywordFilter);
            }
          }));
        }
        function isTypeScriptOnlyKeyword(kind) {
          switch (kind) {
            case 125:
            case 128:
            case 155:
            case 131:
            case 133:
            case 91:
            case 154:
            case 116:
            case 135:
            case 117:
            case 137:
            case 138:
            case 139:
            case 140:
            case 141:
            case 144:
            case 145:
            case 156:
            case 120:
            case 121:
            case 122:
            case 142:
            case 147:
            case 148:
            case 149:
            case 151:
            case 152:
              return true;
            default:
              return false;
          }
        }
        function isInterfaceOrTypeLiteralCompletionKeyword(kind) {
          return kind === 142;
        }
        function isClassMemberCompletionKeyword(kind) {
          switch (kind) {
            case 125:
            case 132:
            case 134:
            case 146:
            case 129:
            case 133:
            case 156:
              return true;
            default:
              return ts3.isClassMemberModifier(kind);
          }
        }
        function isFunctionLikeBodyKeyword(kind) {
          return kind === 129 || kind === 130 || kind === 126 || !ts3.isContextualKeyword(kind) && !isClassMemberCompletionKeyword(kind);
        }
        function keywordForNode(node) {
          return ts3.isIdentifier(node) ? node.originalKeywordKind || 0 : node.kind;
        }
        function getJsDocTagAtPosition(node, position) {
          var jsdoc = ts3.findAncestor(node, ts3.isJSDoc);
          return jsdoc && jsdoc.tags && (ts3.rangeContainsPosition(jsdoc, position) ? ts3.findLast(jsdoc.tags, function(tag) {
            return tag.pos < position;
          }) : void 0);
        }
        function getPropertiesForObjectExpression(contextualType, completionsType, obj, checker) {
          var hasCompletionsType = completionsType && completionsType !== contextualType;
          var type3 = hasCompletionsType && !(completionsType.flags & 3) ? checker.getUnionType([contextualType, completionsType]) : contextualType;
          var properties = type3.isUnion() ? checker.getAllPossiblePropertiesOfTypes(type3.types.filter(function(memberType) {
            return !(memberType.flags & 131068 || checker.isArrayLikeType(memberType) || ts3.typeHasCallOrConstructSignatures(memberType, checker) || checker.isTypeInvalidDueToUnionDiscriminant(memberType, obj));
          })) : type3.getApparentProperties();
          return hasCompletionsType ? properties.filter(hasDeclarationOtherThanSelf) : properties;
          function hasDeclarationOtherThanSelf(member) {
            return ts3.some(member.declarations, function(decl) {
              return decl.parent !== obj;
            });
          }
        }
        Completions2.getPropertiesForObjectExpression = getPropertiesForObjectExpression;
        function getPropertiesForCompletion(type3, checker) {
          return type3.isUnion() ? ts3.Debug.checkEachDefined(checker.getAllPossiblePropertiesOfTypes(type3.types), "getAllPossiblePropertiesOfTypes() should all be defined") : ts3.Debug.checkEachDefined(type3.getApparentProperties(), "getApparentProperties() should all be defined");
        }
        function tryGetObjectTypeDeclarationCompletionContainer(sourceFile, contextToken, location, position) {
          switch (location.kind) {
            case 338:
              return ts3.tryCast(location.parent, ts3.isObjectTypeDeclaration);
            case 1:
              var cls = ts3.tryCast(ts3.lastOrUndefined(ts3.cast(location.parent, ts3.isSourceFile).statements), ts3.isObjectTypeDeclaration);
              if (cls && !ts3.findChildOfKind(cls, 19, sourceFile)) {
                return cls;
              }
              break;
            case 78: {
              if (ts3.isPropertyDeclaration(location.parent) && location.parent.initializer === location) {
                return void 0;
              }
              if (isFromObjectTypeDeclaration(location)) {
                return ts3.findAncestor(location, ts3.isObjectTypeDeclaration);
              }
            }
          }
          if (!contextToken)
            return void 0;
          if (location.kind === 132 || ts3.isIdentifier(contextToken) && ts3.isPropertyDeclaration(contextToken.parent) && ts3.isClassLike(location)) {
            return ts3.findAncestor(contextToken, ts3.isClassLike);
          }
          switch (contextToken.kind) {
            case 62:
              return void 0;
            case 26:
            case 19:
              return isFromObjectTypeDeclaration(location) && location.parent.name === location ? location.parent.parent : ts3.tryCast(location, ts3.isObjectTypeDeclaration);
            case 18:
            case 27:
              return ts3.tryCast(contextToken.parent, ts3.isObjectTypeDeclaration);
            default:
              if (!isFromObjectTypeDeclaration(contextToken)) {
                if (ts3.getLineAndCharacterOfPosition(sourceFile, contextToken.getEnd()).line !== ts3.getLineAndCharacterOfPosition(sourceFile, position).line && ts3.isObjectTypeDeclaration(location)) {
                  return location;
                }
                return void 0;
              }
              var isValidKeyword = ts3.isClassLike(contextToken.parent.parent) ? isClassMemberCompletionKeyword : isInterfaceOrTypeLiteralCompletionKeyword;
              return isValidKeyword(contextToken.kind) || contextToken.kind === 41 || ts3.isIdentifier(contextToken) && isValidKeyword(ts3.stringToToken(contextToken.text)) ? contextToken.parent.parent : void 0;
          }
        }
        function tryGetTypeLiteralNode(node) {
          if (!node)
            return void 0;
          var parent = node.parent;
          switch (node.kind) {
            case 18:
              if (ts3.isTypeLiteralNode(parent)) {
                return parent;
              }
              break;
            case 26:
            case 27:
            case 78:
              if (parent.kind === 163 && ts3.isTypeLiteralNode(parent.parent)) {
                return parent.parent;
              }
              break;
          }
          return void 0;
        }
        function getConstraintOfTypeArgumentProperty(node, checker) {
          if (!node)
            return void 0;
          if (ts3.isTypeNode(node) && ts3.isTypeReferenceType(node.parent)) {
            return checker.getTypeArgumentConstraint(node);
          }
          var t2 = getConstraintOfTypeArgumentProperty(node.parent, checker);
          if (!t2)
            return void 0;
          switch (node.kind) {
            case 163:
              return checker.getTypeOfPropertyOfContextualType(t2, node.symbol.escapedName);
            case 184:
            case 178:
            case 183:
              return t2;
          }
        }
        function isFromObjectTypeDeclaration(node) {
          return node.parent && ts3.isClassOrTypeElement(node.parent) && ts3.isObjectTypeDeclaration(node.parent.parent);
        }
        function isValidTrigger(sourceFile, triggerCharacter, contextToken, position) {
          switch (triggerCharacter) {
            case ".":
            case "@":
              return true;
            case '"':
            case "'":
            case "`":
              return !!contextToken && ts3.isStringLiteralOrTemplate(contextToken) && position === contextToken.getStart(sourceFile) + 1;
            case "#":
              return !!contextToken && ts3.isPrivateIdentifier(contextToken) && !!ts3.getContainingClass(contextToken);
            case "<":
              return !!contextToken && contextToken.kind === 29 && (!ts3.isBinaryExpression(contextToken.parent) || binaryExpressionMayBeOpenTag(contextToken.parent));
            case "/":
              return !!contextToken && (ts3.isStringLiteralLike(contextToken) ? !!ts3.tryGetImportFromModuleSpecifier(contextToken) : contextToken.kind === 43 && ts3.isJsxClosingElement(contextToken.parent));
            case " ":
              return !!contextToken && ts3.isImportKeyword(contextToken) && contextToken.parent.kind === 298;
            default:
              return ts3.Debug.assertNever(triggerCharacter);
          }
        }
        function binaryExpressionMayBeOpenTag(_a2) {
          var left = _a2.left;
          return ts3.nodeIsMissing(left);
        }
        function isProbablyGlobalType(type3, sourceFile, checker) {
          var selfSymbol = checker.resolveName("self", void 0, 111551, false);
          if (selfSymbol && checker.getTypeOfSymbolAtLocation(selfSymbol, sourceFile) === type3) {
            return true;
          }
          var globalSymbol = checker.resolveName("global", void 0, 111551, false);
          if (globalSymbol && checker.getTypeOfSymbolAtLocation(globalSymbol, sourceFile) === type3) {
            return true;
          }
          var globalThisSymbol = checker.resolveName("globalThis", void 0, 111551, false);
          if (globalThisSymbol && checker.getTypeOfSymbolAtLocation(globalThisSymbol, sourceFile) === type3) {
            return true;
          }
          return false;
        }
        function isStaticProperty(symbol) {
          return !!(symbol.valueDeclaration && ts3.getEffectiveModifierFlags(symbol.valueDeclaration) & 32 && ts3.isClassLike(symbol.valueDeclaration.parent));
        }
        function tryGetObjectLiteralContextualType(node, typeChecker) {
          var type3 = typeChecker.getContextualType(node);
          if (type3) {
            return type3;
          }
          if (ts3.isBinaryExpression(node.parent) && node.parent.operatorToken.kind === 62 && node === node.parent.left) {
            return typeChecker.getTypeAtLocation(node.parent);
          }
          return void 0;
        }
        function getImportCompletionNode(contextToken) {
          var candidate = getCandidate();
          return candidate === 153 || candidate && ts3.rangeIsOnSingleLine(candidate, candidate.getSourceFile()) ? candidate : void 0;
          function getCandidate() {
            var parent = contextToken.parent;
            if (ts3.isImportEqualsDeclaration(parent)) {
              return isModuleSpecifierMissingOrEmpty(parent.moduleReference) ? parent : void 0;
            }
            if (ts3.isNamedImports(parent) || ts3.isNamespaceImport(parent)) {
              if (isModuleSpecifierMissingOrEmpty(parent.parent.parent.moduleSpecifier) && (ts3.isNamespaceImport(parent) || parent.elements.length < 2) && !parent.parent.name) {
                return contextToken.kind === 19 || contextToken.kind === 78 ? 153 : parent.parent.parent;
              }
              return void 0;
            }
            if (ts3.isImportKeyword(contextToken) && ts3.isSourceFile(parent)) {
              return contextToken;
            }
            if (ts3.isImportKeyword(contextToken) && ts3.isImportDeclaration(parent)) {
              return isModuleSpecifierMissingOrEmpty(parent.moduleSpecifier) ? parent : void 0;
            }
            return void 0;
          }
        }
        function isModuleSpecifierMissingOrEmpty(specifier) {
          var _a2;
          if (ts3.nodeIsMissing(specifier))
            return true;
          return !((_a2 = ts3.tryCast(ts3.isExternalModuleReference(specifier) ? specifier.expression : specifier, ts3.isStringLiteralLike)) === null || _a2 === void 0 ? void 0 : _a2.text);
        }
        function getVariableDeclaration(property) {
          var variableDeclaration = ts3.findAncestor(property, function(node) {
            return ts3.isFunctionBlock(node) || isArrowFunctionBody(node) || ts3.isBindingPattern(node) ? "quit" : ts3.isVariableDeclaration(node);
          });
          return variableDeclaration;
        }
        function isArrowFunctionBody(node) {
          return node.parent && ts3.isArrowFunction(node.parent) && node.parent.body === node;
        }
        ;
        function symbolCanBeReferencedAtTypeLocation(symbol, checker, seenModules) {
          if (seenModules === void 0) {
            seenModules = new ts3.Map();
          }
          var sym = ts3.skipAlias(symbol.exportSymbol || symbol, checker);
          return !!(sym.flags & 788968) || !!(sym.flags & 1536) && ts3.addToSeen(seenModules, ts3.getSymbolId(sym)) && checker.getExportsOfModule(sym).some(function(e2) {
            return symbolCanBeReferencedAtTypeLocation(e2, checker, seenModules);
          });
        }
      })(Completions = ts3.Completions || (ts3.Completions = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var DocumentHighlights;
      (function(DocumentHighlights2) {
        function getDocumentHighlights(program2, cancellationToken, sourceFile, position, sourceFilesToSearch) {
          var node = ts3.getTouchingPropertyName(sourceFile, position);
          if (node.parent && (ts3.isJsxOpeningElement(node.parent) && node.parent.tagName === node || ts3.isJsxClosingElement(node.parent))) {
            var _a2 = node.parent.parent, openingElement = _a2.openingElement, closingElement = _a2.closingElement;
            var highlightSpans = [openingElement, closingElement].map(function(_a3) {
              var tagName = _a3.tagName;
              return getHighlightSpanForNode(tagName, sourceFile);
            });
            return [{ fileName: sourceFile.fileName, highlightSpans }];
          }
          return getSemanticDocumentHighlights(position, node, program2, cancellationToken, sourceFilesToSearch) || getSyntacticDocumentHighlights(node, sourceFile);
        }
        DocumentHighlights2.getDocumentHighlights = getDocumentHighlights;
        function getHighlightSpanForNode(node, sourceFile) {
          return {
            fileName: sourceFile.fileName,
            textSpan: ts3.createTextSpanFromNode(node, sourceFile),
            kind: "none"
          };
        }
        function getSemanticDocumentHighlights(position, node, program2, cancellationToken, sourceFilesToSearch) {
          var sourceFilesSet = new ts3.Set(sourceFilesToSearch.map(function(f) {
            return f.fileName;
          }));
          var referenceEntries = ts3.FindAllReferences.getReferenceEntriesForNode(position, node, program2, sourceFilesToSearch, cancellationToken, void 0, sourceFilesSet);
          if (!referenceEntries)
            return void 0;
          var map2 = ts3.arrayToMultiMap(referenceEntries.map(ts3.FindAllReferences.toHighlightSpan), function(e2) {
            return e2.fileName;
          }, function(e2) {
            return e2.span;
          });
          return ts3.mapDefined(ts3.arrayFrom(map2.entries()), function(_a2) {
            var fileName = _a2[0], highlightSpans = _a2[1];
            if (!sourceFilesSet.has(fileName)) {
              if (!program2.redirectTargetsMap.has(fileName)) {
                return void 0;
              }
              var redirectTarget_1 = program2.getSourceFile(fileName);
              var redirect = ts3.find(sourceFilesToSearch, function(f) {
                return !!f.redirectInfo && f.redirectInfo.redirectTarget === redirectTarget_1;
              });
              fileName = redirect.fileName;
              ts3.Debug.assert(sourceFilesSet.has(fileName));
            }
            return { fileName, highlightSpans };
          });
        }
        function getSyntacticDocumentHighlights(node, sourceFile) {
          var highlightSpans = getHighlightSpans(node, sourceFile);
          return highlightSpans && [{ fileName: sourceFile.fileName, highlightSpans }];
        }
        function getHighlightSpans(node, sourceFile) {
          switch (node.kind) {
            case 98:
            case 90:
              return ts3.isIfStatement(node.parent) ? getIfElseOccurrences(node.parent, sourceFile) : void 0;
            case 104:
              return useParent(node.parent, ts3.isReturnStatement, getReturnOccurrences);
            case 108:
              return useParent(node.parent, ts3.isThrowStatement, getThrowOccurrences);
            case 110:
            case 82:
            case 95:
              var tryStatement = node.kind === 82 ? node.parent.parent : node.parent;
              return useParent(tryStatement, ts3.isTryStatement, getTryCatchFinallyOccurrences);
            case 106:
              return useParent(node.parent, ts3.isSwitchStatement, getSwitchCaseDefaultOccurrences);
            case 81:
            case 87: {
              if (ts3.isDefaultClause(node.parent) || ts3.isCaseClause(node.parent)) {
                return useParent(node.parent.parent.parent, ts3.isSwitchStatement, getSwitchCaseDefaultOccurrences);
              }
              return void 0;
            }
            case 80:
            case 85:
              return useParent(node.parent, ts3.isBreakOrContinueStatement, getBreakOrContinueStatementOccurrences);
            case 96:
            case 114:
            case 89:
              return useParent(node.parent, function(n2) {
                return ts3.isIterationStatement(n2, true);
              }, getLoopBreakContinueOccurrences);
            case 132:
              return getFromAllDeclarations(ts3.isConstructorDeclaration, [132]);
            case 134:
            case 146:
              return getFromAllDeclarations(ts3.isAccessor, [134, 146]);
            case 130:
              return useParent(node.parent, ts3.isAwaitExpression, getAsyncAndAwaitOccurrences);
            case 129:
              return highlightSpans(getAsyncAndAwaitOccurrences(node));
            case 124:
              return highlightSpans(getYieldOccurrences(node));
            default:
              return ts3.isModifierKind(node.kind) && (ts3.isDeclaration(node.parent) || ts3.isVariableStatement(node.parent)) ? highlightSpans(getModifierOccurrences(node.kind, node.parent)) : void 0;
          }
          function getFromAllDeclarations(nodeTest, keywords) {
            return useParent(node.parent, nodeTest, function(decl) {
              return ts3.mapDefined(decl.symbol.declarations, function(d) {
                return nodeTest(d) ? ts3.find(d.getChildren(sourceFile), function(c2) {
                  return ts3.contains(keywords, c2.kind);
                }) : void 0;
              });
            });
          }
          function useParent(node2, nodeTest, getNodes) {
            return nodeTest(node2) ? highlightSpans(getNodes(node2, sourceFile)) : void 0;
          }
          function highlightSpans(nodes) {
            return nodes && nodes.map(function(node2) {
              return getHighlightSpanForNode(node2, sourceFile);
            });
          }
        }
        function aggregateOwnedThrowStatements(node) {
          if (ts3.isThrowStatement(node)) {
            return [node];
          } else if (ts3.isTryStatement(node)) {
            return ts3.concatenate(node.catchClause ? aggregateOwnedThrowStatements(node.catchClause) : node.tryBlock && aggregateOwnedThrowStatements(node.tryBlock), node.finallyBlock && aggregateOwnedThrowStatements(node.finallyBlock));
          }
          return ts3.isFunctionLike(node) ? void 0 : flatMapChildren(node, aggregateOwnedThrowStatements);
        }
        function getThrowStatementOwner(throwStatement) {
          var child = throwStatement;
          while (child.parent) {
            var parent = child.parent;
            if (ts3.isFunctionBlock(parent) || parent.kind === 298) {
              return parent;
            }
            if (ts3.isTryStatement(parent) && parent.tryBlock === child && parent.catchClause) {
              return child;
            }
            child = parent;
          }
          return void 0;
        }
        function aggregateAllBreakAndContinueStatements(node) {
          return ts3.isBreakOrContinueStatement(node) ? [node] : ts3.isFunctionLike(node) ? void 0 : flatMapChildren(node, aggregateAllBreakAndContinueStatements);
        }
        function flatMapChildren(node, cb2) {
          var result2 = [];
          node.forEachChild(function(child) {
            var value = cb2(child);
            if (value !== void 0) {
              result2.push.apply(result2, ts3.toArray(value));
            }
          });
          return result2;
        }
        function ownsBreakOrContinueStatement(owner, statement) {
          var actualOwner = getBreakOrContinueOwner(statement);
          return !!actualOwner && actualOwner === owner;
        }
        function getBreakOrContinueOwner(statement) {
          return ts3.findAncestor(statement, function(node) {
            switch (node.kind) {
              case 245:
                if (statement.kind === 241) {
                  return false;
                }
              case 238:
              case 239:
              case 240:
              case 237:
              case 236:
                return !statement.label || isLabeledBy(node, statement.label.escapedText);
              default:
                return ts3.isFunctionLike(node) && "quit";
            }
          });
        }
        function getModifierOccurrences(modifier, declaration) {
          return ts3.mapDefined(getNodesToSearchForModifier(declaration, ts3.modifierToFlag(modifier)), function(node) {
            return ts3.findModifier(node, modifier);
          });
        }
        function getNodesToSearchForModifier(declaration, modifierFlag) {
          var container = declaration.parent;
          switch (container.kind) {
            case 258:
            case 298:
            case 231:
            case 285:
            case 286:
              if (modifierFlag & 128 && ts3.isClassDeclaration(declaration)) {
                return __spreadArray(__spreadArray([], declaration.members), [declaration]);
              } else {
                return container.statements;
              }
            case 167:
            case 166:
            case 252:
              return __spreadArray(__spreadArray([], container.parameters), ts3.isClassLike(container.parent) ? container.parent.members : []);
            case 253:
            case 222:
            case 254:
            case 178:
              var nodes = container.members;
              if (modifierFlag & (28 | 64)) {
                var constructor = ts3.find(container.members, ts3.isConstructorDeclaration);
                if (constructor) {
                  return __spreadArray(__spreadArray([], nodes), constructor.parameters);
                }
              } else if (modifierFlag & 128) {
                return __spreadArray(__spreadArray([], nodes), [container]);
              }
              return nodes;
            case 201:
              return void 0;
            default:
              ts3.Debug.assertNever(container, "Invalid container kind.");
          }
        }
        function pushKeywordIf(keywordList, token) {
          var expected = [];
          for (var _i = 2; _i < arguments.length; _i++) {
            expected[_i - 2] = arguments[_i];
          }
          if (token && ts3.contains(expected, token.kind)) {
            keywordList.push(token);
            return true;
          }
          return false;
        }
        function getLoopBreakContinueOccurrences(loopNode) {
          var keywords = [];
          if (pushKeywordIf(keywords, loopNode.getFirstToken(), 96, 114, 89)) {
            if (loopNode.kind === 236) {
              var loopTokens = loopNode.getChildren();
              for (var i3 = loopTokens.length - 1; i3 >= 0; i3--) {
                if (pushKeywordIf(keywords, loopTokens[i3], 114)) {
                  break;
                }
              }
            }
          }
          ts3.forEach(aggregateAllBreakAndContinueStatements(loopNode.statement), function(statement) {
            if (ownsBreakOrContinueStatement(loopNode, statement)) {
              pushKeywordIf(keywords, statement.getFirstToken(), 80, 85);
            }
          });
          return keywords;
        }
        function getBreakOrContinueStatementOccurrences(breakOrContinueStatement) {
          var owner = getBreakOrContinueOwner(breakOrContinueStatement);
          if (owner) {
            switch (owner.kind) {
              case 238:
              case 239:
              case 240:
              case 236:
              case 237:
                return getLoopBreakContinueOccurrences(owner);
              case 245:
                return getSwitchCaseDefaultOccurrences(owner);
            }
          }
          return void 0;
        }
        function getSwitchCaseDefaultOccurrences(switchStatement) {
          var keywords = [];
          pushKeywordIf(keywords, switchStatement.getFirstToken(), 106);
          ts3.forEach(switchStatement.caseBlock.clauses, function(clause) {
            pushKeywordIf(keywords, clause.getFirstToken(), 81, 87);
            ts3.forEach(aggregateAllBreakAndContinueStatements(clause), function(statement) {
              if (ownsBreakOrContinueStatement(switchStatement, statement)) {
                pushKeywordIf(keywords, statement.getFirstToken(), 80);
              }
            });
          });
          return keywords;
        }
        function getTryCatchFinallyOccurrences(tryStatement, sourceFile) {
          var keywords = [];
          pushKeywordIf(keywords, tryStatement.getFirstToken(), 110);
          if (tryStatement.catchClause) {
            pushKeywordIf(keywords, tryStatement.catchClause.getFirstToken(), 82);
          }
          if (tryStatement.finallyBlock) {
            var finallyKeyword = ts3.findChildOfKind(tryStatement, 95, sourceFile);
            pushKeywordIf(keywords, finallyKeyword, 95);
          }
          return keywords;
        }
        function getThrowOccurrences(throwStatement, sourceFile) {
          var owner = getThrowStatementOwner(throwStatement);
          if (!owner) {
            return void 0;
          }
          var keywords = [];
          ts3.forEach(aggregateOwnedThrowStatements(owner), function(throwStatement2) {
            keywords.push(ts3.findChildOfKind(throwStatement2, 108, sourceFile));
          });
          if (ts3.isFunctionBlock(owner)) {
            ts3.forEachReturnStatement(owner, function(returnStatement) {
              keywords.push(ts3.findChildOfKind(returnStatement, 104, sourceFile));
            });
          }
          return keywords;
        }
        function getReturnOccurrences(returnStatement, sourceFile) {
          var func2 = ts3.getContainingFunction(returnStatement);
          if (!func2) {
            return void 0;
          }
          var keywords = [];
          ts3.forEachReturnStatement(ts3.cast(func2.body, ts3.isBlock), function(returnStatement2) {
            keywords.push(ts3.findChildOfKind(returnStatement2, 104, sourceFile));
          });
          ts3.forEach(aggregateOwnedThrowStatements(func2.body), function(throwStatement) {
            keywords.push(ts3.findChildOfKind(throwStatement, 108, sourceFile));
          });
          return keywords;
        }
        function getAsyncAndAwaitOccurrences(node) {
          var func2 = ts3.getContainingFunction(node);
          if (!func2) {
            return void 0;
          }
          var keywords = [];
          if (func2.modifiers) {
            func2.modifiers.forEach(function(modifier) {
              pushKeywordIf(keywords, modifier, 129);
            });
          }
          ts3.forEachChild(func2, function(child) {
            traverseWithoutCrossingFunction(child, function(node2) {
              if (ts3.isAwaitExpression(node2)) {
                pushKeywordIf(keywords, node2.getFirstToken(), 130);
              }
            });
          });
          return keywords;
        }
        function getYieldOccurrences(node) {
          var func2 = ts3.getContainingFunction(node);
          if (!func2) {
            return void 0;
          }
          var keywords = [];
          ts3.forEachChild(func2, function(child) {
            traverseWithoutCrossingFunction(child, function(node2) {
              if (ts3.isYieldExpression(node2)) {
                pushKeywordIf(keywords, node2.getFirstToken(), 124);
              }
            });
          });
          return keywords;
        }
        function traverseWithoutCrossingFunction(node, cb2) {
          cb2(node);
          if (!ts3.isFunctionLike(node) && !ts3.isClassLike(node) && !ts3.isInterfaceDeclaration(node) && !ts3.isModuleDeclaration(node) && !ts3.isTypeAliasDeclaration(node) && !ts3.isTypeNode(node)) {
            ts3.forEachChild(node, function(child) {
              return traverseWithoutCrossingFunction(child, cb2);
            });
          }
        }
        function getIfElseOccurrences(ifStatement, sourceFile) {
          var keywords = getIfElseKeywords(ifStatement, sourceFile);
          var result2 = [];
          for (var i3 = 0; i3 < keywords.length; i3++) {
            if (keywords[i3].kind === 90 && i3 < keywords.length - 1) {
              var elseKeyword = keywords[i3];
              var ifKeyword = keywords[i3 + 1];
              var shouldCombineElseAndIf = true;
              for (var j = ifKeyword.getStart(sourceFile) - 1; j >= elseKeyword.end; j--) {
                if (!ts3.isWhiteSpaceSingleLine(sourceFile.text.charCodeAt(j))) {
                  shouldCombineElseAndIf = false;
                  break;
                }
              }
              if (shouldCombineElseAndIf) {
                result2.push({
                  fileName: sourceFile.fileName,
                  textSpan: ts3.createTextSpanFromBounds(elseKeyword.getStart(), ifKeyword.end),
                  kind: "reference"
                });
                i3++;
                continue;
              }
            }
            result2.push(getHighlightSpanForNode(keywords[i3], sourceFile));
          }
          return result2;
        }
        function getIfElseKeywords(ifStatement, sourceFile) {
          var keywords = [];
          while (ts3.isIfStatement(ifStatement.parent) && ifStatement.parent.elseStatement === ifStatement) {
            ifStatement = ifStatement.parent;
          }
          while (true) {
            var children = ifStatement.getChildren(sourceFile);
            pushKeywordIf(keywords, children[0], 98);
            for (var i3 = children.length - 1; i3 >= 0; i3--) {
              if (pushKeywordIf(keywords, children[i3], 90)) {
                break;
              }
            }
            if (!ifStatement.elseStatement || !ts3.isIfStatement(ifStatement.elseStatement)) {
              break;
            }
            ifStatement = ifStatement.elseStatement;
          }
          return keywords;
        }
        function isLabeledBy(node, labelName) {
          return !!ts3.findAncestor(node.parent, function(owner) {
            return !ts3.isLabeledStatement(owner) ? "quit" : owner.label.escapedText === labelName;
          });
        }
      })(DocumentHighlights = ts3.DocumentHighlights || (ts3.DocumentHighlights = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      function isDocumentRegistryEntry(entry) {
        return !!entry.sourceFile;
      }
      function createDocumentRegistry(useCaseSensitiveFileNames, currentDirectory) {
        return createDocumentRegistryInternal(useCaseSensitiveFileNames, currentDirectory);
      }
      ts3.createDocumentRegistry = createDocumentRegistry;
      function createDocumentRegistryInternal(useCaseSensitiveFileNames, currentDirectory, externalCache) {
        if (currentDirectory === void 0) {
          currentDirectory = "";
        }
        var buckets = new ts3.Map();
        var getCanonicalFileName = ts3.createGetCanonicalFileName(!!useCaseSensitiveFileNames);
        function reportStats() {
          var bucketInfoArray = ts3.arrayFrom(buckets.keys()).filter(function(name) {
            return name && name.charAt(0) === "_";
          }).map(function(name) {
            var entries = buckets.get(name);
            var sourceFiles = [];
            entries.forEach(function(entry, name2) {
              if (isDocumentRegistryEntry(entry)) {
                sourceFiles.push({
                  name: name2,
                  scriptKind: entry.sourceFile.scriptKind,
                  refCount: entry.languageServiceRefCount
                });
              } else {
                entry.forEach(function(value, scriptKind) {
                  return sourceFiles.push({ name: name2, scriptKind, refCount: value.languageServiceRefCount });
                });
              }
            });
            sourceFiles.sort(function(x, y2) {
              return y2.refCount - x.refCount;
            });
            return {
              bucket: name,
              sourceFiles
            };
          });
          return JSON.stringify(bucketInfoArray, void 0, 2);
        }
        function acquireDocument(fileName, compilationSettings, scriptSnapshot, version, scriptKind) {
          var path2 = ts3.toPath(fileName, currentDirectory, getCanonicalFileName);
          var key2 = getKeyForCompilationSettings(compilationSettings);
          return acquireDocumentWithKey(fileName, path2, compilationSettings, key2, scriptSnapshot, version, scriptKind);
        }
        function acquireDocumentWithKey(fileName, path2, compilationSettings, key2, scriptSnapshot, version, scriptKind) {
          return acquireOrUpdateDocument(fileName, path2, compilationSettings, key2, scriptSnapshot, version, true, scriptKind);
        }
        function updateDocument(fileName, compilationSettings, scriptSnapshot, version, scriptKind) {
          var path2 = ts3.toPath(fileName, currentDirectory, getCanonicalFileName);
          var key2 = getKeyForCompilationSettings(compilationSettings);
          return updateDocumentWithKey(fileName, path2, compilationSettings, key2, scriptSnapshot, version, scriptKind);
        }
        function updateDocumentWithKey(fileName, path2, compilationSettings, key2, scriptSnapshot, version, scriptKind) {
          return acquireOrUpdateDocument(fileName, path2, compilationSettings, key2, scriptSnapshot, version, false, scriptKind);
        }
        function getDocumentRegistryEntry(bucketEntry, scriptKind) {
          var entry = isDocumentRegistryEntry(bucketEntry) ? bucketEntry : bucketEntry.get(ts3.Debug.checkDefined(scriptKind, "If there are more than one scriptKind's for same document the scriptKind should be provided"));
          ts3.Debug.assert(scriptKind === void 0 || !entry || entry.sourceFile.scriptKind === scriptKind, "Script kind should match provided ScriptKind:" + scriptKind + " and sourceFile.scriptKind: " + (entry === null || entry === void 0 ? void 0 : entry.sourceFile.scriptKind) + ", !entry: " + !entry);
          return entry;
        }
        function acquireOrUpdateDocument(fileName, path2, compilationSettings, key2, scriptSnapshot, version, acquiring, scriptKind) {
          scriptKind = ts3.ensureScriptKind(fileName, scriptKind);
          var scriptTarget = scriptKind === 6 ? 100 : compilationSettings.target || 1;
          var bucket = ts3.getOrUpdate(buckets, key2, function() {
            return new ts3.Map();
          });
          var bucketEntry = bucket.get(path2);
          var entry = bucketEntry && getDocumentRegistryEntry(bucketEntry, scriptKind);
          if (!entry && externalCache) {
            var sourceFile = externalCache.getDocument(key2, path2);
            if (sourceFile) {
              ts3.Debug.assert(acquiring);
              entry = {
                sourceFile,
                languageServiceRefCount: 0
              };
              setBucketEntry();
            }
          }
          if (!entry) {
            var sourceFile = ts3.createLanguageServiceSourceFile(fileName, scriptSnapshot, scriptTarget, version, false, scriptKind);
            if (externalCache) {
              externalCache.setDocument(key2, path2, sourceFile);
            }
            entry = {
              sourceFile,
              languageServiceRefCount: 1
            };
            setBucketEntry();
          } else {
            if (entry.sourceFile.version !== version) {
              entry.sourceFile = ts3.updateLanguageServiceSourceFile(entry.sourceFile, scriptSnapshot, version, scriptSnapshot.getChangeRange(entry.sourceFile.scriptSnapshot));
              if (externalCache) {
                externalCache.setDocument(key2, path2, entry.sourceFile);
              }
            }
            if (acquiring) {
              entry.languageServiceRefCount++;
            }
          }
          ts3.Debug.assert(entry.languageServiceRefCount !== 0);
          return entry.sourceFile;
          function setBucketEntry() {
            if (!bucketEntry) {
              bucket.set(path2, entry);
            } else if (isDocumentRegistryEntry(bucketEntry)) {
              var scriptKindMap = new ts3.Map();
              scriptKindMap.set(bucketEntry.sourceFile.scriptKind, bucketEntry);
              scriptKindMap.set(scriptKind, entry);
              bucket.set(path2, scriptKindMap);
            } else {
              bucketEntry.set(scriptKind, entry);
            }
          }
        }
        function releaseDocument(fileName, compilationSettings, scriptKind) {
          var path2 = ts3.toPath(fileName, currentDirectory, getCanonicalFileName);
          var key2 = getKeyForCompilationSettings(compilationSettings);
          return releaseDocumentWithKey(path2, key2, scriptKind);
        }
        function releaseDocumentWithKey(path2, key2, scriptKind) {
          var bucket = ts3.Debug.checkDefined(buckets.get(key2));
          var bucketEntry = bucket.get(path2);
          var entry = getDocumentRegistryEntry(bucketEntry, scriptKind);
          entry.languageServiceRefCount--;
          ts3.Debug.assert(entry.languageServiceRefCount >= 0);
          if (entry.languageServiceRefCount === 0) {
            if (isDocumentRegistryEntry(bucketEntry)) {
              bucket.delete(path2);
            } else {
              bucketEntry.delete(scriptKind);
              if (bucketEntry.size === 1) {
                bucket.set(path2, ts3.firstDefinedIterator(bucketEntry.values(), ts3.identity));
              }
            }
          }
        }
        function getLanguageServiceRefCounts(path2, scriptKind) {
          return ts3.arrayFrom(buckets.entries(), function(_a2) {
            var key2 = _a2[0], bucket = _a2[1];
            var bucketEntry = bucket.get(path2);
            var entry = bucketEntry && getDocumentRegistryEntry(bucketEntry, scriptKind);
            return [key2, entry && entry.languageServiceRefCount];
          });
        }
        return {
          acquireDocument,
          acquireDocumentWithKey,
          updateDocument,
          updateDocumentWithKey,
          releaseDocument,
          releaseDocumentWithKey,
          getLanguageServiceRefCounts,
          reportStats,
          getKeyForCompilationSettings
        };
      }
      ts3.createDocumentRegistryInternal = createDocumentRegistryInternal;
      function getKeyForCompilationSettings(settings) {
        return ts3.sourceFileAffectingCompilerOptions.map(function(option) {
          return ts3.getCompilerOptionValue(settings, option);
        }).join("|");
      }
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var FindAllReferences;
      (function(FindAllReferences2) {
        function createImportTracker(sourceFiles, sourceFilesSet, checker, cancellationToken) {
          var allDirectImports = getDirectImportsMap(sourceFiles, checker, cancellationToken);
          return function(exportSymbol, exportInfo, isForRename) {
            var _a2 = getImportersForExport(sourceFiles, sourceFilesSet, allDirectImports, exportInfo, checker, cancellationToken), directImports = _a2.directImports, indirectUsers = _a2.indirectUsers;
            return __assign({ indirectUsers }, getSearchesFromDirectImports(directImports, exportSymbol, exportInfo.exportKind, checker, isForRename));
          };
        }
        FindAllReferences2.createImportTracker = createImportTracker;
        var ExportKind;
        (function(ExportKind2) {
          ExportKind2[ExportKind2["Named"] = 0] = "Named";
          ExportKind2[ExportKind2["Default"] = 1] = "Default";
          ExportKind2[ExportKind2["ExportEquals"] = 2] = "ExportEquals";
        })(ExportKind = FindAllReferences2.ExportKind || (FindAllReferences2.ExportKind = {}));
        var ImportExport;
        (function(ImportExport2) {
          ImportExport2[ImportExport2["Import"] = 0] = "Import";
          ImportExport2[ImportExport2["Export"] = 1] = "Export";
        })(ImportExport = FindAllReferences2.ImportExport || (FindAllReferences2.ImportExport = {}));
        function getImportersForExport(sourceFiles, sourceFilesSet, allDirectImports, _a2, checker, cancellationToken) {
          var exportingModuleSymbol = _a2.exportingModuleSymbol, exportKind = _a2.exportKind;
          var markSeenDirectImport = ts3.nodeSeenTracker();
          var markSeenIndirectUser = ts3.nodeSeenTracker();
          var directImports = [];
          var isAvailableThroughGlobal = !!exportingModuleSymbol.globalExports;
          var indirectUserDeclarations = isAvailableThroughGlobal ? void 0 : [];
          handleDirectImports(exportingModuleSymbol);
          return { directImports, indirectUsers: getIndirectUsers() };
          function getIndirectUsers() {
            if (isAvailableThroughGlobal) {
              return sourceFiles;
            }
            if (exportingModuleSymbol.declarations) {
              for (var _i = 0, _a3 = exportingModuleSymbol.declarations; _i < _a3.length; _i++) {
                var decl = _a3[_i];
                if (ts3.isExternalModuleAugmentation(decl) && sourceFilesSet.has(decl.getSourceFile().fileName)) {
                  addIndirectUser(decl);
                }
              }
            }
            return indirectUserDeclarations.map(ts3.getSourceFileOfNode);
          }
          function handleDirectImports(exportingModuleSymbol2) {
            var theseDirectImports = getDirectImports(exportingModuleSymbol2);
            if (theseDirectImports) {
              for (var _i = 0, theseDirectImports_1 = theseDirectImports; _i < theseDirectImports_1.length; _i++) {
                var direct = theseDirectImports_1[_i];
                if (!markSeenDirectImport(direct)) {
                  continue;
                }
                if (cancellationToken)
                  cancellationToken.throwIfCancellationRequested();
                switch (direct.kind) {
                  case 204:
                    if (ts3.isImportCall(direct)) {
                      handleImportCall(direct);
                      break;
                    }
                    if (!isAvailableThroughGlobal) {
                      var parent = direct.parent;
                      if (exportKind === 2 && parent.kind === 250) {
                        var name = parent.name;
                        if (name.kind === 78) {
                          directImports.push(name);
                          break;
                        }
                      }
                    }
                    break;
                  case 78:
                    break;
                  case 261:
                    handleNamespaceImport(direct, direct.name, ts3.hasSyntacticModifier(direct, 1), false);
                    break;
                  case 262:
                    directImports.push(direct);
                    var namedBindings = direct.importClause && direct.importClause.namedBindings;
                    if (namedBindings && namedBindings.kind === 264) {
                      handleNamespaceImport(direct, namedBindings.name, false, true);
                    } else if (!isAvailableThroughGlobal && ts3.isDefaultImport(direct)) {
                      addIndirectUser(getSourceFileLikeForImportDeclaration(direct));
                    }
                    break;
                  case 268:
                    if (!direct.exportClause) {
                      handleDirectImports(getContainingModuleSymbol(direct, checker));
                    } else if (direct.exportClause.kind === 270) {
                      addIndirectUser(getSourceFileLikeForImportDeclaration(direct), true);
                    } else {
                      directImports.push(direct);
                    }
                    break;
                  case 196:
                    if (direct.isTypeOf && !direct.qualifier && isExported(direct)) {
                      addIndirectUser(direct.getSourceFile(), true);
                    }
                    directImports.push(direct);
                    break;
                  default:
                    ts3.Debug.failBadSyntaxKind(direct, "Unexpected import kind.");
                }
              }
            }
          }
          function handleImportCall(importCall) {
            var top = ts3.findAncestor(importCall, isAmbientModuleDeclaration) || importCall.getSourceFile();
            addIndirectUser(top, !!isExported(importCall, true));
          }
          function isExported(node, stopAtAmbientModule) {
            if (stopAtAmbientModule === void 0) {
              stopAtAmbientModule = false;
            }
            return ts3.findAncestor(node, function(node2) {
              if (stopAtAmbientModule && isAmbientModuleDeclaration(node2))
                return "quit";
              return ts3.some(node2.modifiers, function(mod) {
                return mod.kind === 92;
              });
            });
          }
          function handleNamespaceImport(importDeclaration, name, isReExport, alreadyAddedDirect) {
            if (exportKind === 2) {
              if (!alreadyAddedDirect)
                directImports.push(importDeclaration);
            } else if (!isAvailableThroughGlobal) {
              var sourceFileLike = getSourceFileLikeForImportDeclaration(importDeclaration);
              ts3.Debug.assert(sourceFileLike.kind === 298 || sourceFileLike.kind === 257);
              if (isReExport || findNamespaceReExports(sourceFileLike, name, checker)) {
                addIndirectUser(sourceFileLike, true);
              } else {
                addIndirectUser(sourceFileLike);
              }
            }
          }
          function addIndirectUser(sourceFileLike, addTransitiveDependencies) {
            if (addTransitiveDependencies === void 0) {
              addTransitiveDependencies = false;
            }
            ts3.Debug.assert(!isAvailableThroughGlobal);
            var isNew = markSeenIndirectUser(sourceFileLike);
            if (!isNew)
              return;
            indirectUserDeclarations.push(sourceFileLike);
            if (!addTransitiveDependencies)
              return;
            var moduleSymbol = checker.getMergedSymbol(sourceFileLike.symbol);
            if (!moduleSymbol)
              return;
            ts3.Debug.assert(!!(moduleSymbol.flags & 1536));
            var directImports2 = getDirectImports(moduleSymbol);
            if (directImports2) {
              for (var _i = 0, directImports_1 = directImports2; _i < directImports_1.length; _i++) {
                var directImport = directImports_1[_i];
                if (!ts3.isImportTypeNode(directImport)) {
                  addIndirectUser(getSourceFileLikeForImportDeclaration(directImport), true);
                }
              }
            }
          }
          function getDirectImports(moduleSymbol) {
            return allDirectImports.get(ts3.getSymbolId(moduleSymbol).toString());
          }
        }
        function getSearchesFromDirectImports(directImports, exportSymbol, exportKind, checker, isForRename) {
          var importSearches = [];
          var singleReferences = [];
          function addSearch(location, symbol) {
            importSearches.push([location, symbol]);
          }
          if (directImports) {
            for (var _i = 0, directImports_2 = directImports; _i < directImports_2.length; _i++) {
              var decl = directImports_2[_i];
              handleImport(decl);
            }
          }
          return { importSearches, singleReferences };
          function handleImport(decl2) {
            if (decl2.kind === 261) {
              if (isExternalModuleImportEquals(decl2)) {
                handleNamespaceImportLike(decl2.name);
              }
              return;
            }
            if (decl2.kind === 78) {
              handleNamespaceImportLike(decl2);
              return;
            }
            if (decl2.kind === 196) {
              if (decl2.qualifier) {
                var firstIdentifier = ts3.getFirstIdentifier(decl2.qualifier);
                if (firstIdentifier.escapedText === ts3.symbolName(exportSymbol)) {
                  singleReferences.push(firstIdentifier);
                }
              } else if (exportKind === 2) {
                singleReferences.push(decl2.argument.literal);
              }
              return;
            }
            if (decl2.moduleSpecifier.kind !== 10) {
              return;
            }
            if (decl2.kind === 268) {
              if (decl2.exportClause && ts3.isNamedExports(decl2.exportClause)) {
                searchForNamedImport(decl2.exportClause);
              }
              return;
            }
            var _a2 = decl2.importClause || { name: void 0, namedBindings: void 0 }, name = _a2.name, namedBindings = _a2.namedBindings;
            if (namedBindings) {
              switch (namedBindings.kind) {
                case 264:
                  handleNamespaceImportLike(namedBindings.name);
                  break;
                case 265:
                  if (exportKind === 0 || exportKind === 1) {
                    searchForNamedImport(namedBindings);
                  }
                  break;
                default:
                  ts3.Debug.assertNever(namedBindings);
              }
            }
            if (name && (exportKind === 1 || exportKind === 2) && (!isForRename || name.escapedText === ts3.symbolEscapedNameNoDefault(exportSymbol))) {
              var defaultImportAlias = checker.getSymbolAtLocation(name);
              addSearch(name, defaultImportAlias);
            }
          }
          function handleNamespaceImportLike(importName) {
            if (exportKind === 2 && (!isForRename || isNameMatch(importName.escapedText))) {
              addSearch(importName, checker.getSymbolAtLocation(importName));
            }
          }
          function searchForNamedImport(namedBindings) {
            if (!namedBindings) {
              return;
            }
            for (var _i2 = 0, _a2 = namedBindings.elements; _i2 < _a2.length; _i2++) {
              var element = _a2[_i2];
              var name = element.name, propertyName = element.propertyName;
              if (!isNameMatch((propertyName || name).escapedText)) {
                continue;
              }
              if (propertyName) {
                singleReferences.push(propertyName);
                if (!isForRename || name.escapedText === exportSymbol.escapedName) {
                  addSearch(name, checker.getSymbolAtLocation(name));
                }
              } else {
                var localSymbol = element.kind === 271 && element.propertyName ? checker.getExportSpecifierLocalTargetSymbol(element) : checker.getSymbolAtLocation(name);
                addSearch(name, localSymbol);
              }
            }
          }
          function isNameMatch(name) {
            return name === exportSymbol.escapedName || exportKind !== 0 && name === "default";
          }
        }
        function findNamespaceReExports(sourceFileLike, name, checker) {
          var namespaceImportSymbol = checker.getSymbolAtLocation(name);
          return !!forEachPossibleImportOrExportStatement(sourceFileLike, function(statement) {
            if (!ts3.isExportDeclaration(statement))
              return;
            var exportClause = statement.exportClause, moduleSpecifier = statement.moduleSpecifier;
            return !moduleSpecifier && exportClause && ts3.isNamedExports(exportClause) && exportClause.elements.some(function(element) {
              return checker.getExportSpecifierLocalTargetSymbol(element) === namespaceImportSymbol;
            });
          });
        }
        function findModuleReferences(program2, sourceFiles, searchModuleSymbol) {
          var refs = [];
          var checker = program2.getTypeChecker();
          for (var _i = 0, sourceFiles_1 = sourceFiles; _i < sourceFiles_1.length; _i++) {
            var referencingFile = sourceFiles_1[_i];
            var searchSourceFile = searchModuleSymbol.valueDeclaration;
            if ((searchSourceFile === null || searchSourceFile === void 0 ? void 0 : searchSourceFile.kind) === 298) {
              for (var _a2 = 0, _b = referencingFile.referencedFiles; _a2 < _b.length; _a2++) {
                var ref2 = _b[_a2];
                if (program2.getSourceFileFromReference(referencingFile, ref2) === searchSourceFile) {
                  refs.push({ kind: "reference", referencingFile, ref: ref2 });
                }
              }
              for (var _c = 0, _d = referencingFile.typeReferenceDirectives; _c < _d.length; _c++) {
                var ref2 = _d[_c];
                var referenced = program2.getResolvedTypeReferenceDirectives().get(ref2.fileName);
                if (referenced !== void 0 && referenced.resolvedFileName === searchSourceFile.fileName) {
                  refs.push({ kind: "reference", referencingFile, ref: ref2 });
                }
              }
            }
            forEachImport(referencingFile, function(_importDecl, moduleSpecifier) {
              var moduleSymbol = checker.getSymbolAtLocation(moduleSpecifier);
              if (moduleSymbol === searchModuleSymbol) {
                refs.push({ kind: "import", literal: moduleSpecifier });
              }
            });
          }
          return refs;
        }
        FindAllReferences2.findModuleReferences = findModuleReferences;
        function getDirectImportsMap(sourceFiles, checker, cancellationToken) {
          var map2 = new ts3.Map();
          for (var _i = 0, sourceFiles_2 = sourceFiles; _i < sourceFiles_2.length; _i++) {
            var sourceFile = sourceFiles_2[_i];
            if (cancellationToken)
              cancellationToken.throwIfCancellationRequested();
            forEachImport(sourceFile, function(importDecl, moduleSpecifier) {
              var moduleSymbol = checker.getSymbolAtLocation(moduleSpecifier);
              if (moduleSymbol) {
                var id = ts3.getSymbolId(moduleSymbol).toString();
                var imports = map2.get(id);
                if (!imports) {
                  map2.set(id, imports = []);
                }
                imports.push(importDecl);
              }
            });
          }
          return map2;
        }
        function forEachPossibleImportOrExportStatement(sourceFileLike, action) {
          return ts3.forEach(sourceFileLike.kind === 298 ? sourceFileLike.statements : sourceFileLike.body.statements, function(statement) {
            return action(statement) || isAmbientModuleDeclaration(statement) && ts3.forEach(statement.body && statement.body.statements, action);
          });
        }
        function forEachImport(sourceFile, action) {
          if (sourceFile.externalModuleIndicator || sourceFile.imports !== void 0) {
            for (var _i = 0, _a2 = sourceFile.imports; _i < _a2.length; _i++) {
              var i3 = _a2[_i];
              action(ts3.importFromModuleSpecifier(i3), i3);
            }
          } else {
            forEachPossibleImportOrExportStatement(sourceFile, function(statement) {
              switch (statement.kind) {
                case 268:
                case 262: {
                  var decl = statement;
                  if (decl.moduleSpecifier && ts3.isStringLiteral(decl.moduleSpecifier)) {
                    action(decl, decl.moduleSpecifier);
                  }
                  break;
                }
                case 261: {
                  var decl = statement;
                  if (isExternalModuleImportEquals(decl)) {
                    action(decl, decl.moduleReference.expression);
                  }
                  break;
                }
              }
            });
          }
        }
        function getImportOrExportSymbol(node, symbol, checker, comingFromExport) {
          return comingFromExport ? getExport() : getExport() || getImport();
          function getExport() {
            var _a2;
            var parent = node.parent;
            var grandparent = parent.parent;
            if (symbol.exportSymbol) {
              if (parent.kind === 202) {
                return ((_a2 = symbol.declarations) === null || _a2 === void 0 ? void 0 : _a2.some(function(d) {
                  return d === parent;
                })) && ts3.isBinaryExpression(grandparent) ? getSpecialPropertyExport(grandparent, false) : void 0;
              } else {
                return exportInfo(symbol.exportSymbol, getExportKindForDeclaration(parent));
              }
            } else {
              var exportNode = getExportNode(parent, node);
              if (exportNode && ts3.hasSyntacticModifier(exportNode, 1)) {
                if (ts3.isImportEqualsDeclaration(exportNode) && exportNode.moduleReference === node) {
                  if (comingFromExport) {
                    return void 0;
                  }
                  var lhsSymbol = checker.getSymbolAtLocation(exportNode.name);
                  return { kind: 0, symbol: lhsSymbol };
                } else {
                  return exportInfo(symbol, getExportKindForDeclaration(exportNode));
                }
              } else if (ts3.isNamespaceExport(parent)) {
                return exportInfo(symbol, 0);
              } else if (ts3.isExportAssignment(parent)) {
                return getExportAssignmentExport(parent);
              } else if (ts3.isExportAssignment(grandparent)) {
                return getExportAssignmentExport(grandparent);
              } else if (ts3.isBinaryExpression(parent)) {
                return getSpecialPropertyExport(parent, true);
              } else if (ts3.isBinaryExpression(grandparent)) {
                return getSpecialPropertyExport(grandparent, true);
              } else if (ts3.isJSDocTypedefTag(parent)) {
                return exportInfo(symbol, 0);
              }
            }
            function getExportAssignmentExport(ex) {
              if (!ex.symbol.parent)
                return void 0;
              var exportKind = ex.isExportEquals ? 2 : 1;
              return { kind: 1, symbol, exportInfo: { exportingModuleSymbol: ex.symbol.parent, exportKind } };
            }
            function getSpecialPropertyExport(node2, useLhsSymbol) {
              var kind;
              switch (ts3.getAssignmentDeclarationKind(node2)) {
                case 1:
                  kind = 0;
                  break;
                case 2:
                  kind = 2;
                  break;
                default:
                  return void 0;
              }
              var sym = useLhsSymbol ? checker.getSymbolAtLocation(ts3.getNameOfAccessExpression(ts3.cast(node2.left, ts3.isAccessExpression))) : symbol;
              return sym && exportInfo(sym, kind);
            }
          }
          function getImport() {
            var isImport = isNodeImport(node);
            if (!isImport)
              return void 0;
            var importedSymbol = checker.getImmediateAliasedSymbol(symbol);
            if (!importedSymbol)
              return void 0;
            importedSymbol = skipExportSpecifierSymbol(importedSymbol, checker);
            if (importedSymbol.escapedName === "export=") {
              importedSymbol = getExportEqualsLocalSymbol(importedSymbol, checker);
            }
            var importedName = ts3.symbolEscapedNameNoDefault(importedSymbol);
            if (importedName === void 0 || importedName === "default" || importedName === symbol.escapedName) {
              return { kind: 0, symbol: importedSymbol };
            }
          }
          function exportInfo(symbol2, kind) {
            var exportInfo2 = getExportInfo(symbol2, kind, checker);
            return exportInfo2 && { kind: 1, symbol: symbol2, exportInfo: exportInfo2 };
          }
          function getExportKindForDeclaration(node2) {
            return ts3.hasSyntacticModifier(node2, 512) ? 1 : 0;
          }
        }
        FindAllReferences2.getImportOrExportSymbol = getImportOrExportSymbol;
        function getExportEqualsLocalSymbol(importedSymbol, checker) {
          if (importedSymbol.flags & 2097152) {
            return ts3.Debug.checkDefined(checker.getImmediateAliasedSymbol(importedSymbol));
          }
          var decl = ts3.Debug.checkDefined(importedSymbol.valueDeclaration);
          if (ts3.isExportAssignment(decl)) {
            return ts3.Debug.checkDefined(decl.expression.symbol);
          } else if (ts3.isBinaryExpression(decl)) {
            return ts3.Debug.checkDefined(decl.right.symbol);
          } else if (ts3.isSourceFile(decl)) {
            return ts3.Debug.checkDefined(decl.symbol);
          }
          return ts3.Debug.fail();
        }
        function getExportNode(parent, node) {
          var declaration = ts3.isVariableDeclaration(parent) ? parent : ts3.isBindingElement(parent) ? ts3.walkUpBindingElementsAndPatterns(parent) : void 0;
          if (declaration) {
            return parent.name !== node ? void 0 : ts3.isCatchClause(declaration.parent) ? void 0 : ts3.isVariableStatement(declaration.parent.parent) ? declaration.parent.parent : void 0;
          } else {
            return parent;
          }
        }
        function isNodeImport(node) {
          var parent = node.parent;
          switch (parent.kind) {
            case 261:
              return parent.name === node && isExternalModuleImportEquals(parent);
            case 266:
              return !parent.propertyName;
            case 263:
            case 264:
              ts3.Debug.assert(parent.name === node);
              return true;
            case 199:
              return ts3.isInJSFile(node) && ts3.isRequireVariableDeclaration(parent);
            default:
              return false;
          }
        }
        function getExportInfo(exportSymbol, exportKind, checker) {
          var moduleSymbol = exportSymbol.parent;
          if (!moduleSymbol)
            return void 0;
          var exportingModuleSymbol = checker.getMergedSymbol(moduleSymbol);
          return ts3.isExternalModuleSymbol(exportingModuleSymbol) ? { exportingModuleSymbol, exportKind } : void 0;
        }
        FindAllReferences2.getExportInfo = getExportInfo;
        function skipExportSpecifierSymbol(symbol, checker) {
          if (symbol.declarations) {
            for (var _i = 0, _a2 = symbol.declarations; _i < _a2.length; _i++) {
              var declaration = _a2[_i];
              if (ts3.isExportSpecifier(declaration) && !declaration.propertyName && !declaration.parent.parent.moduleSpecifier) {
                return checker.getExportSpecifierLocalTargetSymbol(declaration);
              } else if (ts3.isPropertyAccessExpression(declaration) && ts3.isModuleExportsAccessExpression(declaration.expression) && !ts3.isPrivateIdentifier(declaration.name)) {
                return checker.getSymbolAtLocation(declaration);
              } else if (ts3.isShorthandPropertyAssignment(declaration) && ts3.isBinaryExpression(declaration.parent.parent) && ts3.getAssignmentDeclarationKind(declaration.parent.parent) === 2) {
                return checker.getExportSpecifierLocalTargetSymbol(declaration.name);
              }
            }
          }
          return symbol;
        }
        function getContainingModuleSymbol(importer, checker) {
          return checker.getMergedSymbol(getSourceFileLikeForImportDeclaration(importer).symbol);
        }
        function getSourceFileLikeForImportDeclaration(node) {
          if (node.kind === 204) {
            return node.getSourceFile();
          }
          var parent = node.parent;
          if (parent.kind === 298) {
            return parent;
          }
          ts3.Debug.assert(parent.kind === 258);
          return ts3.cast(parent.parent, isAmbientModuleDeclaration);
        }
        function isAmbientModuleDeclaration(node) {
          return node.kind === 257 && node.name.kind === 10;
        }
        function isExternalModuleImportEquals(eq) {
          return eq.moduleReference.kind === 273 && eq.moduleReference.expression.kind === 10;
        }
      })(FindAllReferences = ts3.FindAllReferences || (ts3.FindAllReferences = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var FindAllReferences;
      (function(FindAllReferences2) {
        var DefinitionKind;
        (function(DefinitionKind2) {
          DefinitionKind2[DefinitionKind2["Symbol"] = 0] = "Symbol";
          DefinitionKind2[DefinitionKind2["Label"] = 1] = "Label";
          DefinitionKind2[DefinitionKind2["Keyword"] = 2] = "Keyword";
          DefinitionKind2[DefinitionKind2["This"] = 3] = "This";
          DefinitionKind2[DefinitionKind2["String"] = 4] = "String";
          DefinitionKind2[DefinitionKind2["TripleSlashReference"] = 5] = "TripleSlashReference";
        })(DefinitionKind = FindAllReferences2.DefinitionKind || (FindAllReferences2.DefinitionKind = {}));
        var EntryKind;
        (function(EntryKind2) {
          EntryKind2[EntryKind2["Span"] = 0] = "Span";
          EntryKind2[EntryKind2["Node"] = 1] = "Node";
          EntryKind2[EntryKind2["StringLiteral"] = 2] = "StringLiteral";
          EntryKind2[EntryKind2["SearchedLocalFoundProperty"] = 3] = "SearchedLocalFoundProperty";
          EntryKind2[EntryKind2["SearchedPropertyFoundLocal"] = 4] = "SearchedPropertyFoundLocal";
        })(EntryKind = FindAllReferences2.EntryKind || (FindAllReferences2.EntryKind = {}));
        function nodeEntry(node, kind) {
          if (kind === void 0) {
            kind = 1;
          }
          return {
            kind,
            node: node.name || node,
            context: getContextNodeForNodeEntry(node)
          };
        }
        FindAllReferences2.nodeEntry = nodeEntry;
        function isContextWithStartAndEndNode(node) {
          return node && node.kind === void 0;
        }
        FindAllReferences2.isContextWithStartAndEndNode = isContextWithStartAndEndNode;
        function getContextNodeForNodeEntry(node) {
          if (ts3.isDeclaration(node)) {
            return getContextNode(node);
          }
          if (!node.parent)
            return void 0;
          if (!ts3.isDeclaration(node.parent) && !ts3.isExportAssignment(node.parent)) {
            if (ts3.isInJSFile(node)) {
              var binaryExpression = ts3.isBinaryExpression(node.parent) ? node.parent : ts3.isAccessExpression(node.parent) && ts3.isBinaryExpression(node.parent.parent) && node.parent.parent.left === node.parent ? node.parent.parent : void 0;
              if (binaryExpression && ts3.getAssignmentDeclarationKind(binaryExpression) !== 0) {
                return getContextNode(binaryExpression);
              }
            }
            if (ts3.isJsxOpeningElement(node.parent) || ts3.isJsxClosingElement(node.parent)) {
              return node.parent.parent;
            } else if (ts3.isJsxSelfClosingElement(node.parent) || ts3.isLabeledStatement(node.parent) || ts3.isBreakOrContinueStatement(node.parent)) {
              return node.parent;
            } else if (ts3.isStringLiteralLike(node)) {
              var validImport = ts3.tryGetImportFromModuleSpecifier(node);
              if (validImport) {
                var declOrStatement = ts3.findAncestor(validImport, function(node2) {
                  return ts3.isDeclaration(node2) || ts3.isStatement(node2) || ts3.isJSDocTag(node2);
                });
                return ts3.isDeclaration(declOrStatement) ? getContextNode(declOrStatement) : declOrStatement;
              }
            }
            var propertyName = ts3.findAncestor(node, ts3.isComputedPropertyName);
            return propertyName ? getContextNode(propertyName.parent) : void 0;
          }
          if (node.parent.name === node || ts3.isConstructorDeclaration(node.parent) || ts3.isExportAssignment(node.parent) || (ts3.isImportOrExportSpecifier(node.parent) || ts3.isBindingElement(node.parent)) && node.parent.propertyName === node || node.kind === 87 && ts3.hasSyntacticModifier(node.parent, 513)) {
            return getContextNode(node.parent);
          }
          return void 0;
        }
        function getContextNode(node) {
          if (!node)
            return void 0;
          switch (node.kind) {
            case 250:
              return !ts3.isVariableDeclarationList(node.parent) || node.parent.declarations.length !== 1 ? node : ts3.isVariableStatement(node.parent.parent) ? node.parent.parent : ts3.isForInOrOfStatement(node.parent.parent) ? getContextNode(node.parent.parent) : node.parent;
            case 199:
              return getContextNode(node.parent.parent);
            case 266:
              return node.parent.parent.parent;
            case 271:
            case 264:
              return node.parent.parent;
            case 263:
            case 270:
              return node.parent;
            case 217:
              return ts3.isExpressionStatement(node.parent) ? node.parent : node;
            case 240:
            case 239:
              return {
                start: node.initializer,
                end: node.expression
              };
            case 289:
            case 290:
              return ts3.isArrayLiteralOrObjectLiteralDestructuringPattern(node.parent) ? getContextNode(ts3.findAncestor(node.parent, function(node2) {
                return ts3.isBinaryExpression(node2) || ts3.isForInOrOfStatement(node2);
              })) : node;
            default:
              return node;
          }
        }
        FindAllReferences2.getContextNode = getContextNode;
        function toContextSpan(textSpan, sourceFile, context) {
          if (!context)
            return void 0;
          var contextSpan = isContextWithStartAndEndNode(context) ? getTextSpan(context.start, sourceFile, context.end) : getTextSpan(context, sourceFile);
          return contextSpan.start !== textSpan.start || contextSpan.length !== textSpan.length ? { contextSpan } : void 0;
        }
        FindAllReferences2.toContextSpan = toContextSpan;
        var FindReferencesUse;
        (function(FindReferencesUse2) {
          FindReferencesUse2[FindReferencesUse2["Other"] = 0] = "Other";
          FindReferencesUse2[FindReferencesUse2["References"] = 1] = "References";
          FindReferencesUse2[FindReferencesUse2["Rename"] = 2] = "Rename";
        })(FindReferencesUse = FindAllReferences2.FindReferencesUse || (FindAllReferences2.FindReferencesUse = {}));
        function findReferencedSymbols(program2, cancellationToken, sourceFiles, sourceFile, position) {
          var node = ts3.getTouchingPropertyName(sourceFile, position);
          var referencedSymbols = Core.getReferencedSymbolsForNode(position, node, program2, sourceFiles, cancellationToken, { use: 1 });
          var checker = program2.getTypeChecker();
          return !referencedSymbols || !referencedSymbols.length ? void 0 : ts3.mapDefined(referencedSymbols, function(_a2) {
            var definition = _a2.definition, references = _a2.references;
            return definition && {
              definition: checker.runWithCancellationToken(cancellationToken, function(checker2) {
                return definitionToReferencedSymbolDefinitionInfo(definition, checker2, node);
              }),
              references: references.map(toReferenceEntry)
            };
          });
        }
        FindAllReferences2.findReferencedSymbols = findReferencedSymbols;
        function getImplementationsAtPosition(program2, cancellationToken, sourceFiles, sourceFile, position) {
          var node = ts3.getTouchingPropertyName(sourceFile, position);
          var referenceEntries;
          var entries = getImplementationReferenceEntries(program2, cancellationToken, sourceFiles, node, position);
          if (node.parent.kind === 202 || node.parent.kind === 199 || node.parent.kind === 203 || node.kind === 105) {
            referenceEntries = entries && __spreadArray([], entries);
          } else {
            var queue = entries && __spreadArray([], entries);
            var seenNodes = new ts3.Map();
            while (queue && queue.length) {
              var entry = queue.shift();
              if (!ts3.addToSeen(seenNodes, ts3.getNodeId(entry.node))) {
                continue;
              }
              referenceEntries = ts3.append(referenceEntries, entry);
              var entries_1 = getImplementationReferenceEntries(program2, cancellationToken, sourceFiles, entry.node, entry.node.pos);
              if (entries_1) {
                queue.push.apply(queue, entries_1);
              }
            }
          }
          var checker = program2.getTypeChecker();
          return ts3.map(referenceEntries, function(entry2) {
            return toImplementationLocation(entry2, checker);
          });
        }
        FindAllReferences2.getImplementationsAtPosition = getImplementationsAtPosition;
        function getImplementationReferenceEntries(program2, cancellationToken, sourceFiles, node, position) {
          if (node.kind === 298) {
            return void 0;
          }
          var checker = program2.getTypeChecker();
          if (node.parent.kind === 290) {
            var result_1 = [];
            Core.getReferenceEntriesForShorthandPropertyAssignment(node, checker, function(node2) {
              return result_1.push(nodeEntry(node2));
            });
            return result_1;
          } else if (node.kind === 105 || ts3.isSuperProperty(node.parent)) {
            var symbol = checker.getSymbolAtLocation(node);
            return symbol.valueDeclaration && [nodeEntry(symbol.valueDeclaration)];
          } else {
            return getReferenceEntriesForNode(position, node, program2, sourceFiles, cancellationToken, { implementations: true, use: 1 });
          }
        }
        function findReferenceOrRenameEntries(program2, cancellationToken, sourceFiles, node, position, options, convertEntry) {
          return ts3.map(flattenEntries(Core.getReferencedSymbolsForNode(position, node, program2, sourceFiles, cancellationToken, options)), function(entry) {
            return convertEntry(entry, node, program2.getTypeChecker());
          });
        }
        FindAllReferences2.findReferenceOrRenameEntries = findReferenceOrRenameEntries;
        function getReferenceEntriesForNode(position, node, program2, sourceFiles, cancellationToken, options, sourceFilesSet) {
          if (options === void 0) {
            options = {};
          }
          if (sourceFilesSet === void 0) {
            sourceFilesSet = new ts3.Set(sourceFiles.map(function(f) {
              return f.fileName;
            }));
          }
          return flattenEntries(Core.getReferencedSymbolsForNode(position, node, program2, sourceFiles, cancellationToken, options, sourceFilesSet));
        }
        FindAllReferences2.getReferenceEntriesForNode = getReferenceEntriesForNode;
        function flattenEntries(referenceSymbols) {
          return referenceSymbols && ts3.flatMap(referenceSymbols, function(r2) {
            return r2.references;
          });
        }
        function definitionToReferencedSymbolDefinitionInfo(def, checker, originalNode) {
          var info = function() {
            switch (def.type) {
              case 0: {
                var symbol = def.symbol;
                var _a2 = getDefinitionKindAndDisplayParts(symbol, checker, originalNode), displayParts_1 = _a2.displayParts, kind_1 = _a2.kind;
                var name_1 = displayParts_1.map(function(p) {
                  return p.text;
                }).join("");
                var declaration = symbol.declarations && ts3.firstOrUndefined(symbol.declarations);
                var node = declaration ? ts3.getNameOfDeclaration(declaration) || declaration : originalNode;
                return __assign(__assign({}, getFileAndTextSpanFromNode(node)), { name: name_1, kind: kind_1, displayParts: displayParts_1, context: getContextNode(declaration) });
              }
              case 1: {
                var node = def.node;
                return __assign(__assign({}, getFileAndTextSpanFromNode(node)), { name: node.text, kind: "label", displayParts: [ts3.displayPart(node.text, ts3.SymbolDisplayPartKind.text)] });
              }
              case 2: {
                var node = def.node;
                var name_2 = ts3.tokenToString(node.kind);
                return __assign(__assign({}, getFileAndTextSpanFromNode(node)), { name: name_2, kind: "keyword", displayParts: [{ text: name_2, kind: "keyword" }] });
              }
              case 3: {
                var node = def.node;
                var symbol = checker.getSymbolAtLocation(node);
                var displayParts_2 = symbol && ts3.SymbolDisplay.getSymbolDisplayPartsDocumentationAndSymbolKind(checker, symbol, node.getSourceFile(), ts3.getContainerNode(node), node).displayParts || [ts3.textPart("this")];
                return __assign(__assign({}, getFileAndTextSpanFromNode(node)), { name: "this", kind: "var", displayParts: displayParts_2 });
              }
              case 4: {
                var node = def.node;
                return __assign(__assign({}, getFileAndTextSpanFromNode(node)), { name: node.text, kind: "var", displayParts: [ts3.displayPart(ts3.getTextOfNode(node), ts3.SymbolDisplayPartKind.stringLiteral)] });
              }
              case 5: {
                return {
                  textSpan: ts3.createTextSpanFromRange(def.reference),
                  sourceFile: def.file,
                  name: def.reference.fileName,
                  kind: "string",
                  displayParts: [ts3.displayPart('"' + def.reference.fileName + '"', ts3.SymbolDisplayPartKind.stringLiteral)]
                };
              }
              default:
                return ts3.Debug.assertNever(def);
            }
          }();
          var sourceFile = info.sourceFile, textSpan = info.textSpan, name = info.name, kind = info.kind, displayParts = info.displayParts, context = info.context;
          return __assign({ containerKind: "", containerName: "", fileName: sourceFile.fileName, kind, name, textSpan, displayParts }, toContextSpan(textSpan, sourceFile, context));
        }
        function getFileAndTextSpanFromNode(node) {
          var sourceFile = node.getSourceFile();
          return {
            sourceFile,
            textSpan: getTextSpan(ts3.isComputedPropertyName(node) ? node.expression : node, sourceFile)
          };
        }
        function getDefinitionKindAndDisplayParts(symbol, checker, node) {
          var meaning = Core.getIntersectingMeaningFromDeclarations(node, symbol);
          var enclosingDeclaration = symbol.declarations && ts3.firstOrUndefined(symbol.declarations) || node;
          var _a2 = ts3.SymbolDisplay.getSymbolDisplayPartsDocumentationAndSymbolKind(checker, symbol, enclosingDeclaration.getSourceFile(), enclosingDeclaration, enclosingDeclaration, meaning), displayParts = _a2.displayParts, symbolKind = _a2.symbolKind;
          return { displayParts, kind: symbolKind };
        }
        function toRenameLocation(entry, originalNode, checker, providePrefixAndSuffixText) {
          return __assign(__assign({}, entryToDocumentSpan(entry)), providePrefixAndSuffixText && getPrefixAndSuffixText(entry, originalNode, checker));
        }
        FindAllReferences2.toRenameLocation = toRenameLocation;
        function toReferenceEntry(entry) {
          var documentSpan = entryToDocumentSpan(entry);
          if (entry.kind === 0) {
            return __assign(__assign({}, documentSpan), { isWriteAccess: false, isDefinition: false });
          }
          var kind = entry.kind, node = entry.node;
          return __assign(__assign({}, documentSpan), { isWriteAccess: isWriteAccessForReference(node), isDefinition: isDefinitionForReference(node), isInString: kind === 2 ? true : void 0 });
        }
        FindAllReferences2.toReferenceEntry = toReferenceEntry;
        function entryToDocumentSpan(entry) {
          if (entry.kind === 0) {
            return { textSpan: entry.textSpan, fileName: entry.fileName };
          } else {
            var sourceFile = entry.node.getSourceFile();
            var textSpan = getTextSpan(entry.node, sourceFile);
            return __assign({ textSpan, fileName: sourceFile.fileName }, toContextSpan(textSpan, sourceFile, entry.context));
          }
        }
        function getPrefixAndSuffixText(entry, originalNode, checker) {
          if (entry.kind !== 0 && ts3.isIdentifier(originalNode)) {
            var node = entry.node, kind = entry.kind;
            var parent = node.parent;
            var name = originalNode.text;
            var isShorthandAssignment = ts3.isShorthandPropertyAssignment(parent);
            if (isShorthandAssignment || ts3.isObjectBindingElementWithoutPropertyName(parent) && parent.name === node && parent.dotDotDotToken === void 0) {
              var prefixColon = { prefixText: name + ": " };
              var suffixColon = { suffixText: ": " + name };
              if (kind === 3) {
                return prefixColon;
              }
              if (kind === 4) {
                return suffixColon;
              }
              if (isShorthandAssignment) {
                var grandParent = parent.parent;
                if (ts3.isObjectLiteralExpression(grandParent) && ts3.isBinaryExpression(grandParent.parent) && ts3.isModuleExportsAccessExpression(grandParent.parent.left)) {
                  return prefixColon;
                }
                return suffixColon;
              } else {
                return prefixColon;
              }
            } else if (ts3.isImportSpecifier(parent) && !parent.propertyName) {
              var originalSymbol = ts3.isExportSpecifier(originalNode.parent) ? checker.getExportSpecifierLocalTargetSymbol(originalNode.parent) : checker.getSymbolAtLocation(originalNode);
              return ts3.contains(originalSymbol.declarations, parent) ? { prefixText: name + " as " } : ts3.emptyOptions;
            } else if (ts3.isExportSpecifier(parent) && !parent.propertyName) {
              return originalNode === entry.node || checker.getSymbolAtLocation(originalNode) === checker.getSymbolAtLocation(entry.node) ? { prefixText: name + " as " } : { suffixText: " as " + name };
            }
          }
          return ts3.emptyOptions;
        }
        function toImplementationLocation(entry, checker) {
          var documentSpan = entryToDocumentSpan(entry);
          if (entry.kind !== 0) {
            var node = entry.node;
            return __assign(__assign({}, documentSpan), implementationKindDisplayParts(node, checker));
          } else {
            return __assign(__assign({}, documentSpan), { kind: "", displayParts: [] });
          }
        }
        function implementationKindDisplayParts(node, checker) {
          var symbol = checker.getSymbolAtLocation(ts3.isDeclaration(node) && node.name ? node.name : node);
          if (symbol) {
            return getDefinitionKindAndDisplayParts(symbol, checker, node);
          } else if (node.kind === 201) {
            return {
              kind: "interface",
              displayParts: [ts3.punctuationPart(20), ts3.textPart("object literal"), ts3.punctuationPart(21)]
            };
          } else if (node.kind === 222) {
            return {
              kind: "local class",
              displayParts: [ts3.punctuationPart(20), ts3.textPart("anonymous local class"), ts3.punctuationPart(21)]
            };
          } else {
            return { kind: ts3.getNodeKind(node), displayParts: [] };
          }
        }
        function toHighlightSpan(entry) {
          var documentSpan = entryToDocumentSpan(entry);
          if (entry.kind === 0) {
            return {
              fileName: documentSpan.fileName,
              span: {
                textSpan: documentSpan.textSpan,
                kind: "reference"
              }
            };
          }
          var writeAccess = isWriteAccessForReference(entry.node);
          var span = __assign({ textSpan: documentSpan.textSpan, kind: writeAccess ? "writtenReference" : "reference", isInString: entry.kind === 2 ? true : void 0 }, documentSpan.contextSpan && { contextSpan: documentSpan.contextSpan });
          return { fileName: documentSpan.fileName, span };
        }
        FindAllReferences2.toHighlightSpan = toHighlightSpan;
        function getTextSpan(node, sourceFile, endNode) {
          var start = node.getStart(sourceFile);
          var end = (endNode || node).getEnd();
          if (ts3.isStringLiteralLike(node)) {
            ts3.Debug.assert(endNode === void 0);
            start += 1;
            end -= 1;
          }
          return ts3.createTextSpanFromBounds(start, end);
        }
        function getTextSpanOfEntry(entry) {
          return entry.kind === 0 ? entry.textSpan : getTextSpan(entry.node, entry.node.getSourceFile());
        }
        FindAllReferences2.getTextSpanOfEntry = getTextSpanOfEntry;
        function isWriteAccessForReference(node) {
          var decl = ts3.getDeclarationFromName(node);
          return !!decl && declarationIsWriteAccess(decl) || node.kind === 87 || ts3.isWriteAccess(node);
        }
        function isDefinitionForReference(node) {
          return node.kind === 87 || !!ts3.getDeclarationFromName(node) || ts3.isLiteralComputedPropertyDeclarationName(node) || node.kind === 132 && ts3.isConstructorDeclaration(node.parent);
        }
        function declarationIsWriteAccess(decl) {
          if (!!(decl.flags & 8388608))
            return true;
          switch (decl.kind) {
            case 217:
            case 199:
            case 253:
            case 222:
            case 87:
            case 256:
            case 292:
            case 271:
            case 263:
            case 261:
            case 266:
            case 254:
            case 328:
            case 335:
            case 281:
            case 257:
            case 260:
            case 264:
            case 270:
            case 161:
            case 290:
            case 255:
            case 160:
              return true;
            case 289:
              return !ts3.isArrayLiteralOrObjectLiteralDestructuringPattern(decl.parent);
            case 252:
            case 209:
            case 167:
            case 166:
            case 168:
            case 169:
              return !!decl.body;
            case 250:
            case 164:
              return !!decl.initializer || ts3.isCatchClause(decl.parent);
            case 165:
            case 163:
            case 337:
            case 330:
              return false;
            default:
              return ts3.Debug.failBadSyntaxKind(decl);
          }
        }
        var Core;
        (function(Core2) {
          function getReferencedSymbolsForNode(position, node, program2, sourceFiles, cancellationToken, options, sourceFilesSet) {
            var _a2, _b;
            if (options === void 0) {
              options = {};
            }
            if (sourceFilesSet === void 0) {
              sourceFilesSet = new ts3.Set(sourceFiles.map(function(f) {
                return f.fileName;
              }));
            }
            if (options.use === 1) {
              node = ts3.getAdjustedReferenceLocation(node);
            } else if (options.use === 2) {
              node = ts3.getAdjustedRenameLocation(node);
            }
            if (ts3.isSourceFile(node)) {
              var resolvedRef = ts3.GoToDefinition.getReferenceAtPosition(node, position, program2);
              if (!(resolvedRef === null || resolvedRef === void 0 ? void 0 : resolvedRef.file)) {
                return void 0;
              }
              var moduleSymbol = program2.getTypeChecker().getMergedSymbol(resolvedRef.file.symbol);
              if (moduleSymbol) {
                return getReferencedSymbolsForModule(program2, moduleSymbol, false, sourceFiles, sourceFilesSet);
              }
              var fileIncludeReasons = program2.getFileIncludeReasons();
              if (!fileIncludeReasons) {
                return void 0;
              }
              return [{
                definition: { type: 5, reference: resolvedRef.reference, file: node },
                references: getReferencesForNonModule(resolvedRef.file, fileIncludeReasons, program2) || ts3.emptyArray
              }];
            }
            if (!options.implementations) {
              var special = getReferencedSymbolsSpecial(node, sourceFiles, cancellationToken);
              if (special) {
                return special;
              }
            }
            var checker = program2.getTypeChecker();
            var symbol = checker.getSymbolAtLocation(ts3.isConstructorDeclaration(node) && node.parent.name || node);
            if (!symbol) {
              if (!options.implementations && ts3.isStringLiteralLike(node)) {
                if (ts3.isModuleSpecifierLike(node)) {
                  var fileIncludeReasons = program2.getFileIncludeReasons();
                  var referencedFileName = (_b = (_a2 = node.getSourceFile().resolvedModules) === null || _a2 === void 0 ? void 0 : _a2.get(node.text)) === null || _b === void 0 ? void 0 : _b.resolvedFileName;
                  var referencedFile = referencedFileName ? program2.getSourceFile(referencedFileName) : void 0;
                  if (referencedFile) {
                    return [{ definition: { type: 4, node }, references: getReferencesForNonModule(referencedFile, fileIncludeReasons, program2) || ts3.emptyArray }];
                  }
                }
                return getReferencesForStringLiteral(node, sourceFiles, checker, cancellationToken);
              }
              return void 0;
            }
            if (symbol.escapedName === "export=") {
              return getReferencedSymbolsForModule(program2, symbol.parent, false, sourceFiles, sourceFilesSet);
            }
            var moduleReferences = getReferencedSymbolsForModuleIfDeclaredBySourceFile(symbol, program2, sourceFiles, cancellationToken, options, sourceFilesSet);
            if (moduleReferences && !(symbol.flags & 33554432)) {
              return moduleReferences;
            }
            var aliasedSymbol = getMergedAliasedSymbolOfNamespaceExportDeclaration(node, symbol, checker);
            var moduleReferencesOfExportTarget = aliasedSymbol && getReferencedSymbolsForModuleIfDeclaredBySourceFile(aliasedSymbol, program2, sourceFiles, cancellationToken, options, sourceFilesSet);
            var references = getReferencedSymbolsForSymbol(symbol, node, sourceFiles, sourceFilesSet, checker, cancellationToken, options);
            return mergeReferences(program2, moduleReferences, references, moduleReferencesOfExportTarget);
          }
          Core2.getReferencedSymbolsForNode = getReferencedSymbolsForNode;
          function getReferencesForFileName(fileName, program2, sourceFiles, sourceFilesSet) {
            var _a2, _b;
            if (sourceFilesSet === void 0) {
              sourceFilesSet = new ts3.Set(sourceFiles.map(function(f) {
                return f.fileName;
              }));
            }
            var moduleSymbol = (_a2 = program2.getSourceFile(fileName)) === null || _a2 === void 0 ? void 0 : _a2.symbol;
            if (moduleSymbol) {
              return ((_b = getReferencedSymbolsForModule(program2, moduleSymbol, false, sourceFiles, sourceFilesSet)[0]) === null || _b === void 0 ? void 0 : _b.references) || ts3.emptyArray;
            }
            var fileIncludeReasons = program2.getFileIncludeReasons();
            var referencedFile = program2.getSourceFile(fileName);
            return referencedFile && fileIncludeReasons && getReferencesForNonModule(referencedFile, fileIncludeReasons, program2) || ts3.emptyArray;
          }
          Core2.getReferencesForFileName = getReferencesForFileName;
          function getReferencesForNonModule(referencedFile, refFileMap, program2) {
            var entries;
            var references = refFileMap.get(referencedFile.path) || ts3.emptyArray;
            for (var _i = 0, references_1 = references; _i < references_1.length; _i++) {
              var ref2 = references_1[_i];
              if (ts3.isReferencedFile(ref2)) {
                var referencingFile = program2.getSourceFileByPath(ref2.file);
                var location = ts3.getReferencedFileLocation(program2.getSourceFileByPath, ref2);
                if (ts3.isReferenceFileLocation(location)) {
                  entries = ts3.append(entries, {
                    kind: 0,
                    fileName: referencingFile.fileName,
                    textSpan: ts3.createTextSpanFromRange(location)
                  });
                }
              }
            }
            return entries;
          }
          function getMergedAliasedSymbolOfNamespaceExportDeclaration(node, symbol, checker) {
            if (node.parent && ts3.isNamespaceExportDeclaration(node.parent)) {
              var aliasedSymbol = checker.getAliasedSymbol(symbol);
              var targetSymbol = checker.getMergedSymbol(aliasedSymbol);
              if (aliasedSymbol !== targetSymbol) {
                return targetSymbol;
              }
            }
            return void 0;
          }
          function getReferencedSymbolsForModuleIfDeclaredBySourceFile(symbol, program2, sourceFiles, cancellationToken, options, sourceFilesSet) {
            var moduleSourceFile = symbol.flags & 1536 && symbol.declarations && ts3.find(symbol.declarations, ts3.isSourceFile);
            if (!moduleSourceFile)
              return void 0;
            var exportEquals = symbol.exports.get("export=");
            var moduleReferences = getReferencedSymbolsForModule(program2, symbol, !!exportEquals, sourceFiles, sourceFilesSet);
            if (!exportEquals || !sourceFilesSet.has(moduleSourceFile.fileName))
              return moduleReferences;
            var checker = program2.getTypeChecker();
            symbol = ts3.skipAlias(exportEquals, checker);
            return mergeReferences(program2, moduleReferences, getReferencedSymbolsForSymbol(symbol, void 0, sourceFiles, sourceFilesSet, checker, cancellationToken, options));
          }
          function mergeReferences(program2) {
            var referencesToMerge = [];
            for (var _i = 1; _i < arguments.length; _i++) {
              referencesToMerge[_i - 1] = arguments[_i];
            }
            var result2;
            for (var _a2 = 0, referencesToMerge_1 = referencesToMerge; _a2 < referencesToMerge_1.length; _a2++) {
              var references = referencesToMerge_1[_a2];
              if (!references || !references.length)
                continue;
              if (!result2) {
                result2 = references;
                continue;
              }
              var _loop_4 = function(entry2) {
                if (!entry2.definition || entry2.definition.type !== 0) {
                  result2.push(entry2);
                  return "continue";
                }
                var symbol = entry2.definition.symbol;
                var refIndex = ts3.findIndex(result2, function(ref2) {
                  return !!ref2.definition && ref2.definition.type === 0 && ref2.definition.symbol === symbol;
                });
                if (refIndex === -1) {
                  result2.push(entry2);
                  return "continue";
                }
                var reference = result2[refIndex];
                result2[refIndex] = {
                  definition: reference.definition,
                  references: reference.references.concat(entry2.references).sort(function(entry1, entry22) {
                    var entry1File = getSourceFileIndexOfEntry(program2, entry1);
                    var entry2File = getSourceFileIndexOfEntry(program2, entry22);
                    if (entry1File !== entry2File) {
                      return ts3.compareValues(entry1File, entry2File);
                    }
                    var entry1Span = getTextSpanOfEntry(entry1);
                    var entry2Span = getTextSpanOfEntry(entry22);
                    return entry1Span.start !== entry2Span.start ? ts3.compareValues(entry1Span.start, entry2Span.start) : ts3.compareValues(entry1Span.length, entry2Span.length);
                  })
                };
              };
              for (var _b = 0, references_2 = references; _b < references_2.length; _b++) {
                var entry = references_2[_b];
                _loop_4(entry);
              }
            }
            return result2;
          }
          function getSourceFileIndexOfEntry(program2, entry) {
            var sourceFile = entry.kind === 0 ? program2.getSourceFile(entry.fileName) : entry.node.getSourceFile();
            return program2.getSourceFiles().indexOf(sourceFile);
          }
          function getReferencedSymbolsForModule(program2, symbol, excludeImportTypeOfExportEquals, sourceFiles, sourceFilesSet) {
            ts3.Debug.assert(!!symbol.valueDeclaration);
            var references = ts3.mapDefined(FindAllReferences2.findModuleReferences(program2, sourceFiles, symbol), function(reference) {
              if (reference.kind === "import") {
                var parent = reference.literal.parent;
                if (ts3.isLiteralTypeNode(parent)) {
                  var importType = ts3.cast(parent.parent, ts3.isImportTypeNode);
                  if (excludeImportTypeOfExportEquals && !importType.qualifier) {
                    return void 0;
                  }
                }
                return nodeEntry(reference.literal);
              } else {
                return {
                  kind: 0,
                  fileName: reference.referencingFile.fileName,
                  textSpan: ts3.createTextSpanFromRange(reference.ref)
                };
              }
            });
            if (symbol.declarations) {
              for (var _i = 0, _a2 = symbol.declarations; _i < _a2.length; _i++) {
                var decl = _a2[_i];
                switch (decl.kind) {
                  case 298:
                    break;
                  case 257:
                    if (sourceFilesSet.has(decl.getSourceFile().fileName)) {
                      references.push(nodeEntry(decl.name));
                    }
                    break;
                  default:
                    ts3.Debug.assert(!!(symbol.flags & 33554432), "Expected a module symbol to be declared by a SourceFile or ModuleDeclaration.");
                }
              }
            }
            var exported = symbol.exports.get("export=");
            if (exported === null || exported === void 0 ? void 0 : exported.declarations) {
              for (var _b = 0, _c = exported.declarations; _b < _c.length; _b++) {
                var decl = _c[_b];
                var sourceFile = decl.getSourceFile();
                if (sourceFilesSet.has(sourceFile.fileName)) {
                  var node = ts3.isBinaryExpression(decl) && ts3.isPropertyAccessExpression(decl.left) ? decl.left.expression : ts3.isExportAssignment(decl) ? ts3.Debug.checkDefined(ts3.findChildOfKind(decl, 92, sourceFile)) : ts3.getNameOfDeclaration(decl) || decl;
                  references.push(nodeEntry(node));
                }
              }
            }
            return references.length ? [{ definition: { type: 0, symbol }, references }] : ts3.emptyArray;
          }
          function isReadonlyTypeOperator(node) {
            return node.kind === 142 && ts3.isTypeOperatorNode(node.parent) && node.parent.operator === 142;
          }
          function getReferencedSymbolsSpecial(node, sourceFiles, cancellationToken) {
            if (ts3.isTypeKeyword(node.kind)) {
              if (node.kind === 113 && ts3.isVoidExpression(node.parent)) {
                return void 0;
              }
              if (node.kind === 142 && !isReadonlyTypeOperator(node)) {
                return void 0;
              }
              return getAllReferencesForKeyword(sourceFiles, node.kind, cancellationToken, node.kind === 142 ? isReadonlyTypeOperator : void 0);
            }
            if (ts3.isJumpStatementTarget(node)) {
              var labelDefinition = ts3.getTargetLabel(node.parent, node.text);
              return labelDefinition && getLabelReferencesInNode(labelDefinition.parent, labelDefinition);
            } else if (ts3.isLabelOfLabeledStatement(node)) {
              return getLabelReferencesInNode(node.parent, node);
            }
            if (ts3.isThis(node)) {
              return getReferencesForThisKeyword(node, sourceFiles, cancellationToken);
            }
            if (node.kind === 105) {
              return getReferencesForSuperKeyword(node);
            }
            return void 0;
          }
          function getReferencedSymbolsForSymbol(originalSymbol, node, sourceFiles, sourceFilesSet, checker, cancellationToken, options) {
            var symbol = node && skipPastExportOrImportSpecifierOrUnion(originalSymbol, node, checker, !isForRenameWithPrefixAndSuffixText(options)) || originalSymbol;
            var searchMeaning = node ? getIntersectingMeaningFromDeclarations(node, symbol) : 7;
            var result2 = [];
            var state = new State2(sourceFiles, sourceFilesSet, node ? getSpecialSearchKind(node) : 0, checker, cancellationToken, searchMeaning, options, result2);
            var exportSpecifier = !isForRenameWithPrefixAndSuffixText(options) || !symbol.declarations ? void 0 : ts3.find(symbol.declarations, ts3.isExportSpecifier);
            if (exportSpecifier) {
              getReferencesAtExportSpecifier(exportSpecifier.name, symbol, exportSpecifier, state.createSearch(node, originalSymbol, void 0), state, true, true);
            } else if (node && node.kind === 87 && symbol.escapedName === "default" && symbol.parent) {
              addReference(node, symbol, state);
              searchForImportsOfExport(node, symbol, { exportingModuleSymbol: symbol.parent, exportKind: 1 }, state);
            } else {
              var search = state.createSearch(node, symbol, void 0, { allSearchSymbols: node ? populateSearchSymbolSet(symbol, node, checker, options.use === 2, !!options.providePrefixAndSuffixTextForRename, !!options.implementations) : [symbol] });
              getReferencesInContainerOrFiles(symbol, state, search);
            }
            return result2;
          }
          function getReferencesInContainerOrFiles(symbol, state, search) {
            var scope = getSymbolScope(symbol);
            if (scope) {
              getReferencesInContainer(scope, scope.getSourceFile(), search, state, !(ts3.isSourceFile(scope) && !ts3.contains(state.sourceFiles, scope)));
            } else {
              for (var _i = 0, _a2 = state.sourceFiles; _i < _a2.length; _i++) {
                var sourceFile = _a2[_i];
                state.cancellationToken.throwIfCancellationRequested();
                searchForName(sourceFile, search, state);
              }
            }
          }
          function getSpecialSearchKind(node) {
            switch (node.kind) {
              case 167:
              case 132:
                return 1;
              case 78:
                if (ts3.isClassLike(node.parent)) {
                  ts3.Debug.assert(node.parent.name === node);
                  return 2;
                }
              default:
                return 0;
            }
          }
          function skipPastExportOrImportSpecifierOrUnion(symbol, node, checker, useLocalSymbolForExportSpecifier) {
            var parent = node.parent;
            if (ts3.isExportSpecifier(parent) && useLocalSymbolForExportSpecifier) {
              return getLocalSymbolForExportSpecifier(node, symbol, parent, checker);
            }
            return ts3.firstDefined(symbol.declarations, function(decl) {
              if (!decl.parent) {
                if (symbol.flags & 33554432)
                  return void 0;
                ts3.Debug.fail("Unexpected symbol at " + ts3.Debug.formatSyntaxKind(node.kind) + ": " + ts3.Debug.formatSymbol(symbol));
              }
              return ts3.isTypeLiteralNode(decl.parent) && ts3.isUnionTypeNode(decl.parent.parent) ? checker.getPropertyOfType(checker.getTypeFromTypeNode(decl.parent.parent), symbol.name) : void 0;
            });
          }
          var SpecialSearchKind;
          (function(SpecialSearchKind2) {
            SpecialSearchKind2[SpecialSearchKind2["None"] = 0] = "None";
            SpecialSearchKind2[SpecialSearchKind2["Constructor"] = 1] = "Constructor";
            SpecialSearchKind2[SpecialSearchKind2["Class"] = 2] = "Class";
          })(SpecialSearchKind || (SpecialSearchKind = {}));
          function getNonModuleSymbolOfMergedModuleSymbol(symbol) {
            if (!(symbol.flags & (1536 | 33554432)))
              return void 0;
            var decl = symbol.declarations && ts3.find(symbol.declarations, function(d) {
              return !ts3.isSourceFile(d) && !ts3.isModuleDeclaration(d);
            });
            return decl && decl.symbol;
          }
          var State2 = function() {
            function State3(sourceFiles, sourceFilesSet, specialSearchKind, checker, cancellationToken, searchMeaning, options, result2) {
              this.sourceFiles = sourceFiles;
              this.sourceFilesSet = sourceFilesSet;
              this.specialSearchKind = specialSearchKind;
              this.checker = checker;
              this.cancellationToken = cancellationToken;
              this.searchMeaning = searchMeaning;
              this.options = options;
              this.result = result2;
              this.inheritsFromCache = new ts3.Map();
              this.markSeenContainingTypeReference = ts3.nodeSeenTracker();
              this.markSeenReExportRHS = ts3.nodeSeenTracker();
              this.symbolIdToReferences = [];
              this.sourceFileToSeenSymbols = [];
            }
            State3.prototype.includesSourceFile = function(sourceFile) {
              return this.sourceFilesSet.has(sourceFile.fileName);
            };
            State3.prototype.getImportSearches = function(exportSymbol, exportInfo) {
              if (!this.importTracker)
                this.importTracker = FindAllReferences2.createImportTracker(this.sourceFiles, this.sourceFilesSet, this.checker, this.cancellationToken);
              return this.importTracker(exportSymbol, exportInfo, this.options.use === 2);
            };
            State3.prototype.createSearch = function(location, symbol, comingFrom, searchOptions) {
              if (searchOptions === void 0) {
                searchOptions = {};
              }
              var _a2 = searchOptions.text, text = _a2 === void 0 ? ts3.stripQuotes(ts3.symbolName(ts3.getLocalSymbolForExportDefault(symbol) || getNonModuleSymbolOfMergedModuleSymbol(symbol) || symbol)) : _a2, _b = searchOptions.allSearchSymbols, allSearchSymbols = _b === void 0 ? [symbol] : _b;
              var escapedText = ts3.escapeLeadingUnderscores(text);
              var parents = this.options.implementations && location ? getParentSymbolsOfPropertyAccess(location, symbol, this.checker) : void 0;
              return { symbol, comingFrom, text, escapedText, parents, allSearchSymbols, includes: function(sym) {
                return ts3.contains(allSearchSymbols, sym);
              } };
            };
            State3.prototype.referenceAdder = function(searchSymbol) {
              var symbolId = ts3.getSymbolId(searchSymbol);
              var references = this.symbolIdToReferences[symbolId];
              if (!references) {
                references = this.symbolIdToReferences[symbolId] = [];
                this.result.push({ definition: { type: 0, symbol: searchSymbol }, references });
              }
              return function(node, kind) {
                return references.push(nodeEntry(node, kind));
              };
            };
            State3.prototype.addStringOrCommentReference = function(fileName, textSpan) {
              this.result.push({
                definition: void 0,
                references: [{ kind: 0, fileName, textSpan }]
              });
            };
            State3.prototype.markSearchedSymbols = function(sourceFile, symbols) {
              var sourceId = ts3.getNodeId(sourceFile);
              var seenSymbols = this.sourceFileToSeenSymbols[sourceId] || (this.sourceFileToSeenSymbols[sourceId] = new ts3.Set());
              var anyNewSymbols = false;
              for (var _i = 0, symbols_2 = symbols; _i < symbols_2.length; _i++) {
                var sym = symbols_2[_i];
                anyNewSymbols = ts3.tryAddToSet(seenSymbols, ts3.getSymbolId(sym)) || anyNewSymbols;
              }
              return anyNewSymbols;
            };
            return State3;
          }();
          function searchForImportsOfExport(exportLocation, exportSymbol, exportInfo, state) {
            var _a2 = state.getImportSearches(exportSymbol, exportInfo), importSearches = _a2.importSearches, singleReferences = _a2.singleReferences, indirectUsers = _a2.indirectUsers;
            if (singleReferences.length) {
              var addRef = state.referenceAdder(exportSymbol);
              for (var _i = 0, singleReferences_1 = singleReferences; _i < singleReferences_1.length; _i++) {
                var singleRef = singleReferences_1[_i];
                if (shouldAddSingleReference(singleRef, state))
                  addRef(singleRef);
              }
            }
            for (var _b = 0, importSearches_1 = importSearches; _b < importSearches_1.length; _b++) {
              var _c = importSearches_1[_b], importLocation = _c[0], importSymbol = _c[1];
              getReferencesInSourceFile(importLocation.getSourceFile(), state.createSearch(importLocation, importSymbol, 1), state);
            }
            if (indirectUsers.length) {
              var indirectSearch = void 0;
              switch (exportInfo.exportKind) {
                case 0:
                  indirectSearch = state.createSearch(exportLocation, exportSymbol, 1);
                  break;
                case 1:
                  indirectSearch = state.options.use === 2 ? void 0 : state.createSearch(exportLocation, exportSymbol, 1, { text: "default" });
                  break;
                case 2:
                  break;
              }
              if (indirectSearch) {
                for (var _d = 0, indirectUsers_1 = indirectUsers; _d < indirectUsers_1.length; _d++) {
                  var indirectUser = indirectUsers_1[_d];
                  searchForName(indirectUser, indirectSearch, state);
                }
              }
            }
          }
          function eachExportReference(sourceFiles, checker, cancellationToken, exportSymbol, exportingModuleSymbol, exportName, isDefaultExport, cb2) {
            var importTracker = FindAllReferences2.createImportTracker(sourceFiles, new ts3.Set(sourceFiles.map(function(f) {
              return f.fileName;
            })), checker, cancellationToken);
            var _a2 = importTracker(exportSymbol, { exportKind: isDefaultExport ? 1 : 0, exportingModuleSymbol }, false), importSearches = _a2.importSearches, indirectUsers = _a2.indirectUsers;
            for (var _i = 0, importSearches_2 = importSearches; _i < importSearches_2.length; _i++) {
              var importLocation = importSearches_2[_i][0];
              cb2(importLocation);
            }
            for (var _b = 0, indirectUsers_2 = indirectUsers; _b < indirectUsers_2.length; _b++) {
              var indirectUser = indirectUsers_2[_b];
              for (var _c = 0, _d = getPossibleSymbolReferenceNodes(indirectUser, isDefaultExport ? "default" : exportName); _c < _d.length; _c++) {
                var node = _d[_c];
                var symbol = checker.getSymbolAtLocation(node);
                var hasExportAssignmentDeclaration = ts3.some(symbol === null || symbol === void 0 ? void 0 : symbol.declarations, function(d) {
                  return ts3.tryCast(d, ts3.isExportAssignment) ? true : false;
                });
                if (ts3.isIdentifier(node) && !ts3.isImportOrExportSpecifier(node.parent) && (symbol === exportSymbol || hasExportAssignmentDeclaration)) {
                  cb2(node);
                }
              }
            }
          }
          Core2.eachExportReference = eachExportReference;
          function shouldAddSingleReference(singleRef, state) {
            if (!hasMatchingMeaning(singleRef, state))
              return false;
            if (state.options.use !== 2)
              return true;
            if (!ts3.isIdentifier(singleRef))
              return false;
            return !(ts3.isImportOrExportSpecifier(singleRef.parent) && singleRef.escapedText === "default");
          }
          function searchForImportedSymbol(symbol, state) {
            if (!symbol.declarations)
              return;
            for (var _i = 0, _a2 = symbol.declarations; _i < _a2.length; _i++) {
              var declaration = _a2[_i];
              var exportingFile = declaration.getSourceFile();
              getReferencesInSourceFile(exportingFile, state.createSearch(declaration, symbol, 0), state, state.includesSourceFile(exportingFile));
            }
          }
          function searchForName(sourceFile, search, state) {
            if (ts3.getNameTable(sourceFile).get(search.escapedText) !== void 0) {
              getReferencesInSourceFile(sourceFile, search, state);
            }
          }
          function getPropertySymbolOfDestructuringAssignment(location, checker) {
            return ts3.isArrayLiteralOrObjectLiteralDestructuringPattern(location.parent.parent) ? checker.getPropertySymbolOfDestructuringAssignment(location) : void 0;
          }
          function getSymbolScope(symbol) {
            var declarations = symbol.declarations, flags = symbol.flags, parent = symbol.parent, valueDeclaration = symbol.valueDeclaration;
            if (valueDeclaration && (valueDeclaration.kind === 209 || valueDeclaration.kind === 222)) {
              return valueDeclaration;
            }
            if (!declarations) {
              return void 0;
            }
            if (flags & (4 | 8192)) {
              var privateDeclaration = ts3.find(declarations, function(d) {
                return ts3.hasEffectiveModifier(d, 8) || ts3.isPrivateIdentifierClassElementDeclaration(d);
              });
              if (privateDeclaration) {
                return ts3.getAncestor(privateDeclaration, 253);
              }
              return void 0;
            }
            if (declarations.some(ts3.isObjectBindingElementWithoutPropertyName)) {
              return void 0;
            }
            var exposedByParent = parent && !(symbol.flags & 262144);
            if (exposedByParent && !(ts3.isExternalModuleSymbol(parent) && !parent.globalExports)) {
              return void 0;
            }
            var scope;
            for (var _i = 0, declarations_1 = declarations; _i < declarations_1.length; _i++) {
              var declaration = declarations_1[_i];
              var container = ts3.getContainerNode(declaration);
              if (scope && scope !== container) {
                return void 0;
              }
              if (!container || container.kind === 298 && !ts3.isExternalOrCommonJsModule(container)) {
                return void 0;
              }
              scope = container;
              if (ts3.isFunctionExpression(scope)) {
                var next = void 0;
                while (next = ts3.getNextJSDocCommentLocation(scope)) {
                  scope = next;
                }
              }
            }
            return exposedByParent ? scope.getSourceFile() : scope;
          }
          function isSymbolReferencedInFile(definition, checker, sourceFile, searchContainer) {
            if (searchContainer === void 0) {
              searchContainer = sourceFile;
            }
            return eachSymbolReferenceInFile(definition, checker, sourceFile, function() {
              return true;
            }, searchContainer) || false;
          }
          Core2.isSymbolReferencedInFile = isSymbolReferencedInFile;
          function eachSymbolReferenceInFile(definition, checker, sourceFile, cb2, searchContainer) {
            if (searchContainer === void 0) {
              searchContainer = sourceFile;
            }
            var symbol = ts3.isParameterPropertyDeclaration(definition.parent, definition.parent.parent) ? ts3.first(checker.getSymbolsOfParameterPropertyDeclaration(definition.parent, definition.text)) : checker.getSymbolAtLocation(definition);
            if (!symbol)
              return void 0;
            for (var _i = 0, _a2 = getPossibleSymbolReferenceNodes(sourceFile, symbol.name, searchContainer); _i < _a2.length; _i++) {
              var token = _a2[_i];
              if (!ts3.isIdentifier(token) || token === definition || token.escapedText !== definition.escapedText)
                continue;
              var referenceSymbol = checker.getSymbolAtLocation(token);
              if (referenceSymbol === symbol || checker.getShorthandAssignmentValueSymbol(token.parent) === symbol || ts3.isExportSpecifier(token.parent) && getLocalSymbolForExportSpecifier(token, referenceSymbol, token.parent, checker) === symbol) {
                var res = cb2(token);
                if (res)
                  return res;
              }
            }
          }
          Core2.eachSymbolReferenceInFile = eachSymbolReferenceInFile;
          function someSignatureUsage(signature, sourceFiles, checker, cb2) {
            if (!signature.name || !ts3.isIdentifier(signature.name))
              return false;
            var symbol = ts3.Debug.checkDefined(checker.getSymbolAtLocation(signature.name));
            for (var _i = 0, sourceFiles_3 = sourceFiles; _i < sourceFiles_3.length; _i++) {
              var sourceFile = sourceFiles_3[_i];
              for (var _a2 = 0, _b = getPossibleSymbolReferenceNodes(sourceFile, symbol.name); _a2 < _b.length; _a2++) {
                var name = _b[_a2];
                if (!ts3.isIdentifier(name) || name === signature.name || name.escapedText !== signature.name.escapedText)
                  continue;
                var called = ts3.climbPastPropertyAccess(name);
                var call = ts3.isCallExpression(called.parent) && called.parent.expression === called ? called.parent : void 0;
                var referenceSymbol = checker.getSymbolAtLocation(name);
                if (referenceSymbol && checker.getRootSymbols(referenceSymbol).some(function(s2) {
                  return s2 === symbol;
                })) {
                  if (cb2(name, call)) {
                    return true;
                  }
                }
              }
            }
            return false;
          }
          Core2.someSignatureUsage = someSignatureUsage;
          function getPossibleSymbolReferenceNodes(sourceFile, symbolName, container) {
            if (container === void 0) {
              container = sourceFile;
            }
            return getPossibleSymbolReferencePositions(sourceFile, symbolName, container).map(function(pos) {
              return ts3.getTouchingPropertyName(sourceFile, pos);
            });
          }
          function getPossibleSymbolReferencePositions(sourceFile, symbolName, container) {
            if (container === void 0) {
              container = sourceFile;
            }
            var positions = [];
            if (!symbolName || !symbolName.length) {
              return positions;
            }
            var text = sourceFile.text;
            var sourceLength = text.length;
            var symbolNameLength = symbolName.length;
            var position = text.indexOf(symbolName, container.pos);
            while (position >= 0) {
              if (position > container.end)
                break;
              var endPosition = position + symbolNameLength;
              if ((position === 0 || !ts3.isIdentifierPart(text.charCodeAt(position - 1), 99)) && (endPosition === sourceLength || !ts3.isIdentifierPart(text.charCodeAt(endPosition), 99))) {
                positions.push(position);
              }
              position = text.indexOf(symbolName, position + symbolNameLength + 1);
            }
            return positions;
          }
          function getLabelReferencesInNode(container, targetLabel) {
            var sourceFile = container.getSourceFile();
            var labelName = targetLabel.text;
            var references = ts3.mapDefined(getPossibleSymbolReferenceNodes(sourceFile, labelName, container), function(node) {
              return node === targetLabel || ts3.isJumpStatementTarget(node) && ts3.getTargetLabel(node, labelName) === targetLabel ? nodeEntry(node) : void 0;
            });
            return [{ definition: { type: 1, node: targetLabel }, references }];
          }
          function isValidReferencePosition(node, searchSymbolName) {
            switch (node.kind) {
              case 79:
              case 78:
                return node.text.length === searchSymbolName.length;
              case 14:
              case 10: {
                var str2 = node;
                return (ts3.isLiteralNameOfPropertyDeclarationOrIndexAccess(str2) || ts3.isNameOfModuleDeclaration(node) || ts3.isExpressionOfExternalModuleImportEqualsDeclaration(node) || ts3.isCallExpression(node.parent) && ts3.isBindableObjectDefinePropertyCall(node.parent) && node.parent.arguments[1] === node) && str2.text.length === searchSymbolName.length;
              }
              case 8:
                return ts3.isLiteralNameOfPropertyDeclarationOrIndexAccess(node) && node.text.length === searchSymbolName.length;
              case 87:
                return "default".length === searchSymbolName.length;
              default:
                return false;
            }
          }
          function getAllReferencesForKeyword(sourceFiles, keywordKind, cancellationToken, filter) {
            var references = ts3.flatMap(sourceFiles, function(sourceFile) {
              cancellationToken.throwIfCancellationRequested();
              return ts3.mapDefined(getPossibleSymbolReferenceNodes(sourceFile, ts3.tokenToString(keywordKind), sourceFile), function(referenceLocation) {
                if (referenceLocation.kind === keywordKind && (!filter || filter(referenceLocation))) {
                  return nodeEntry(referenceLocation);
                }
              });
            });
            return references.length ? [{ definition: { type: 2, node: references[0].node }, references }] : void 0;
          }
          function getReferencesInSourceFile(sourceFile, search, state, addReferencesHere) {
            if (addReferencesHere === void 0) {
              addReferencesHere = true;
            }
            state.cancellationToken.throwIfCancellationRequested();
            return getReferencesInContainer(sourceFile, sourceFile, search, state, addReferencesHere);
          }
          function getReferencesInContainer(container, sourceFile, search, state, addReferencesHere) {
            if (!state.markSearchedSymbols(sourceFile, search.allSearchSymbols)) {
              return;
            }
            for (var _i = 0, _a2 = getPossibleSymbolReferencePositions(sourceFile, search.text, container); _i < _a2.length; _i++) {
              var position = _a2[_i];
              getReferencesAtLocation(sourceFile, position, search, state, addReferencesHere);
            }
          }
          function hasMatchingMeaning(referenceLocation, state) {
            return !!(ts3.getMeaningFromLocation(referenceLocation) & state.searchMeaning);
          }
          function getReferencesAtLocation(sourceFile, position, search, state, addReferencesHere) {
            var referenceLocation = ts3.getTouchingPropertyName(sourceFile, position);
            if (!isValidReferencePosition(referenceLocation, search.text)) {
              if (!state.options.implementations && (state.options.findInStrings && ts3.isInString(sourceFile, position) || state.options.findInComments && ts3.isInNonReferenceComment(sourceFile, position))) {
                state.addStringOrCommentReference(sourceFile.fileName, ts3.createTextSpan(position, search.text.length));
              }
              return;
            }
            if (!hasMatchingMeaning(referenceLocation, state))
              return;
            var referenceSymbol = state.checker.getSymbolAtLocation(referenceLocation);
            if (!referenceSymbol) {
              return;
            }
            var parent = referenceLocation.parent;
            if (ts3.isImportSpecifier(parent) && parent.propertyName === referenceLocation) {
              return;
            }
            if (ts3.isExportSpecifier(parent)) {
              ts3.Debug.assert(referenceLocation.kind === 78);
              getReferencesAtExportSpecifier(referenceLocation, referenceSymbol, parent, search, state, addReferencesHere);
              return;
            }
            var relatedSymbol = getRelatedSymbol(search, referenceSymbol, referenceLocation, state);
            if (!relatedSymbol) {
              getReferenceForShorthandProperty(referenceSymbol, search, state);
              return;
            }
            switch (state.specialSearchKind) {
              case 0:
                if (addReferencesHere)
                  addReference(referenceLocation, relatedSymbol, state);
                break;
              case 1:
                addConstructorReferences(referenceLocation, sourceFile, search, state);
                break;
              case 2:
                addClassStaticThisReferences(referenceLocation, search, state);
                break;
              default:
                ts3.Debug.assertNever(state.specialSearchKind);
            }
            referenceSymbol = ts3.isInJSFile(referenceLocation) && referenceLocation.parent.kind === 199 && ts3.isRequireVariableDeclaration(referenceLocation.parent) ? referenceLocation.parent.symbol : referenceSymbol;
            getImportOrExportReferences(referenceLocation, referenceSymbol, search, state);
          }
          function getReferencesAtExportSpecifier(referenceLocation, referenceSymbol, exportSpecifier, search, state, addReferencesHere, alwaysGetReferences) {
            ts3.Debug.assert(!alwaysGetReferences || !!state.options.providePrefixAndSuffixTextForRename, "If alwaysGetReferences is true, then prefix/suffix text must be enabled");
            var parent = exportSpecifier.parent, propertyName = exportSpecifier.propertyName, name = exportSpecifier.name;
            var exportDeclaration = parent.parent;
            var localSymbol = getLocalSymbolForExportSpecifier(referenceLocation, referenceSymbol, exportSpecifier, state.checker);
            if (!alwaysGetReferences && !search.includes(localSymbol)) {
              return;
            }
            if (!propertyName) {
              if (!(state.options.use === 2 && name.escapedText === "default")) {
                addRef();
              }
            } else if (referenceLocation === propertyName) {
              if (!exportDeclaration.moduleSpecifier) {
                addRef();
              }
              if (addReferencesHere && state.options.use !== 2 && state.markSeenReExportRHS(name)) {
                addReference(name, ts3.Debug.checkDefined(exportSpecifier.symbol), state);
              }
            } else {
              if (state.markSeenReExportRHS(referenceLocation)) {
                addRef();
              }
            }
            if (!isForRenameWithPrefixAndSuffixText(state.options) || alwaysGetReferences) {
              var isDefaultExport = referenceLocation.originalKeywordKind === 87 || exportSpecifier.name.originalKeywordKind === 87;
              var exportKind = isDefaultExport ? 1 : 0;
              var exportSymbol = ts3.Debug.checkDefined(exportSpecifier.symbol);
              var exportInfo = FindAllReferences2.getExportInfo(exportSymbol, exportKind, state.checker);
              if (exportInfo) {
                searchForImportsOfExport(referenceLocation, exportSymbol, exportInfo, state);
              }
            }
            if (search.comingFrom !== 1 && exportDeclaration.moduleSpecifier && !propertyName && !isForRenameWithPrefixAndSuffixText(state.options)) {
              var imported = state.checker.getExportSpecifierLocalTargetSymbol(exportSpecifier);
              if (imported)
                searchForImportedSymbol(imported, state);
            }
            function addRef() {
              if (addReferencesHere)
                addReference(referenceLocation, localSymbol, state);
            }
          }
          function getLocalSymbolForExportSpecifier(referenceLocation, referenceSymbol, exportSpecifier, checker) {
            return isExportSpecifierAlias(referenceLocation, exportSpecifier) && checker.getExportSpecifierLocalTargetSymbol(exportSpecifier) || referenceSymbol;
          }
          function isExportSpecifierAlias(referenceLocation, exportSpecifier) {
            var parent = exportSpecifier.parent, propertyName = exportSpecifier.propertyName, name = exportSpecifier.name;
            ts3.Debug.assert(propertyName === referenceLocation || name === referenceLocation);
            if (propertyName) {
              return propertyName === referenceLocation;
            } else {
              return !parent.parent.moduleSpecifier;
            }
          }
          function getImportOrExportReferences(referenceLocation, referenceSymbol, search, state) {
            var importOrExport = FindAllReferences2.getImportOrExportSymbol(referenceLocation, referenceSymbol, state.checker, search.comingFrom === 1);
            if (!importOrExport)
              return;
            var symbol = importOrExport.symbol;
            if (importOrExport.kind === 0) {
              if (!isForRenameWithPrefixAndSuffixText(state.options)) {
                searchForImportedSymbol(symbol, state);
              }
            } else {
              searchForImportsOfExport(referenceLocation, symbol, importOrExport.exportInfo, state);
            }
          }
          function getReferenceForShorthandProperty(_a2, search, state) {
            var flags = _a2.flags, valueDeclaration = _a2.valueDeclaration;
            var shorthandValueSymbol = state.checker.getShorthandAssignmentValueSymbol(valueDeclaration);
            var name = valueDeclaration && ts3.getNameOfDeclaration(valueDeclaration);
            if (!(flags & 33554432) && name && search.includes(shorthandValueSymbol)) {
              addReference(name, shorthandValueSymbol, state);
            }
          }
          function addReference(referenceLocation, relatedSymbol, state) {
            var _a2 = "kind" in relatedSymbol ? relatedSymbol : { kind: void 0, symbol: relatedSymbol }, kind = _a2.kind, symbol = _a2.symbol;
            var addRef = state.referenceAdder(symbol);
            if (state.options.implementations) {
              addImplementationReferences(referenceLocation, addRef, state);
            } else {
              addRef(referenceLocation, kind);
            }
          }
          function addConstructorReferences(referenceLocation, sourceFile, search, state) {
            if (ts3.isNewExpressionTarget(referenceLocation)) {
              addReference(referenceLocation, search.symbol, state);
            }
            var pusher = function() {
              return state.referenceAdder(search.symbol);
            };
            if (ts3.isClassLike(referenceLocation.parent)) {
              ts3.Debug.assert(referenceLocation.kind === 87 || referenceLocation.parent.name === referenceLocation);
              findOwnConstructorReferences(search.symbol, sourceFile, pusher());
            } else {
              var classExtending = tryGetClassByExtendingIdentifier(referenceLocation);
              if (classExtending) {
                findSuperConstructorAccesses(classExtending, pusher());
                findInheritedConstructorReferences(classExtending, state);
              }
            }
          }
          function addClassStaticThisReferences(referenceLocation, search, state) {
            addReference(referenceLocation, search.symbol, state);
            var classLike = referenceLocation.parent;
            if (state.options.use === 2 || !ts3.isClassLike(classLike))
              return;
            ts3.Debug.assert(classLike.name === referenceLocation);
            var addRef = state.referenceAdder(search.symbol);
            for (var _i = 0, _a2 = classLike.members; _i < _a2.length; _i++) {
              var member = _a2[_i];
              if (!(ts3.isMethodOrAccessor(member) && ts3.hasSyntacticModifier(member, 32))) {
                continue;
              }
              if (member.body) {
                member.body.forEachChild(function cb2(node) {
                  if (node.kind === 107) {
                    addRef(node);
                  } else if (!ts3.isFunctionLike(node) && !ts3.isClassLike(node)) {
                    node.forEachChild(cb2);
                  }
                });
              }
            }
          }
          function findOwnConstructorReferences(classSymbol, sourceFile, addNode) {
            var constructorSymbol = getClassConstructorSymbol(classSymbol);
            if (constructorSymbol && constructorSymbol.declarations) {
              for (var _i = 0, _a2 = constructorSymbol.declarations; _i < _a2.length; _i++) {
                var decl = _a2[_i];
                var ctrKeyword = ts3.findChildOfKind(decl, 132, sourceFile);
                ts3.Debug.assert(decl.kind === 167 && !!ctrKeyword);
                addNode(ctrKeyword);
              }
            }
            if (classSymbol.exports) {
              classSymbol.exports.forEach(function(member) {
                var decl2 = member.valueDeclaration;
                if (decl2 && decl2.kind === 166) {
                  var body = decl2.body;
                  if (body) {
                    forEachDescendantOfKind(body, 107, function(thisKeyword) {
                      if (ts3.isNewExpressionTarget(thisKeyword)) {
                        addNode(thisKeyword);
                      }
                    });
                  }
                }
              });
            }
          }
          function getClassConstructorSymbol(classSymbol) {
            return classSymbol.members && classSymbol.members.get("__constructor");
          }
          function findSuperConstructorAccesses(classDeclaration, addNode) {
            var constructor = getClassConstructorSymbol(classDeclaration.symbol);
            if (!(constructor && constructor.declarations)) {
              return;
            }
            for (var _i = 0, _a2 = constructor.declarations; _i < _a2.length; _i++) {
              var decl = _a2[_i];
              ts3.Debug.assert(decl.kind === 167);
              var body = decl.body;
              if (body) {
                forEachDescendantOfKind(body, 105, function(node) {
                  if (ts3.isCallExpressionTarget(node)) {
                    addNode(node);
                  }
                });
              }
            }
          }
          function hasOwnConstructor(classDeclaration) {
            return !!getClassConstructorSymbol(classDeclaration.symbol);
          }
          function findInheritedConstructorReferences(classDeclaration, state) {
            if (hasOwnConstructor(classDeclaration))
              return;
            var classSymbol = classDeclaration.symbol;
            var search = state.createSearch(void 0, classSymbol, void 0);
            getReferencesInContainerOrFiles(classSymbol, state, search);
          }
          function addImplementationReferences(refNode, addReference2, state) {
            if (ts3.isDeclarationName(refNode) && isImplementation(refNode.parent)) {
              addReference2(refNode);
              return;
            }
            if (refNode.kind !== 78) {
              return;
            }
            if (refNode.parent.kind === 290) {
              getReferenceEntriesForShorthandPropertyAssignment(refNode, state.checker, addReference2);
            }
            var containingClass = getContainingClassIfInHeritageClause(refNode);
            if (containingClass) {
              addReference2(containingClass);
              return;
            }
            var typeNode = ts3.findAncestor(refNode, function(a2) {
              return !ts3.isQualifiedName(a2.parent) && !ts3.isTypeNode(a2.parent) && !ts3.isTypeElement(a2.parent);
            });
            var typeHavingNode = typeNode.parent;
            if (ts3.hasType(typeHavingNode) && typeHavingNode.type === typeNode && state.markSeenContainingTypeReference(typeHavingNode)) {
              if (ts3.hasInitializer(typeHavingNode)) {
                addIfImplementation(typeHavingNode.initializer);
              } else if (ts3.isFunctionLike(typeHavingNode) && typeHavingNode.body) {
                var body = typeHavingNode.body;
                if (body.kind === 231) {
                  ts3.forEachReturnStatement(body, function(returnStatement) {
                    if (returnStatement.expression)
                      addIfImplementation(returnStatement.expression);
                  });
                } else {
                  addIfImplementation(body);
                }
              } else if (ts3.isAssertionExpression(typeHavingNode)) {
                addIfImplementation(typeHavingNode.expression);
              }
            }
            function addIfImplementation(e2) {
              if (isImplementationExpression(e2))
                addReference2(e2);
            }
          }
          function getContainingClassIfInHeritageClause(node) {
            return ts3.isIdentifier(node) || ts3.isPropertyAccessExpression(node) ? getContainingClassIfInHeritageClause(node.parent) : ts3.isExpressionWithTypeArguments(node) ? ts3.tryCast(node.parent.parent, ts3.isClassLike) : void 0;
          }
          function isImplementationExpression(node) {
            switch (node.kind) {
              case 208:
                return isImplementationExpression(node.expression);
              case 210:
              case 209:
              case 201:
              case 222:
              case 200:
                return true;
              default:
                return false;
            }
          }
          function explicitlyInheritsFrom(symbol, parent, cachedResults, checker) {
            if (symbol === parent) {
              return true;
            }
            var key2 = ts3.getSymbolId(symbol) + "," + ts3.getSymbolId(parent);
            var cached = cachedResults.get(key2);
            if (cached !== void 0) {
              return cached;
            }
            cachedResults.set(key2, false);
            var inherits = !!symbol.declarations && symbol.declarations.some(function(declaration) {
              return ts3.getAllSuperTypeNodes(declaration).some(function(typeReference) {
                var type3 = checker.getTypeAtLocation(typeReference);
                return !!type3 && !!type3.symbol && explicitlyInheritsFrom(type3.symbol, parent, cachedResults, checker);
              });
            });
            cachedResults.set(key2, inherits);
            return inherits;
          }
          function getReferencesForSuperKeyword(superKeyword) {
            var searchSpaceNode = ts3.getSuperContainer(superKeyword, false);
            if (!searchSpaceNode) {
              return void 0;
            }
            var staticFlag = 32;
            switch (searchSpaceNode.kind) {
              case 164:
              case 163:
              case 166:
              case 165:
              case 167:
              case 168:
              case 169:
                staticFlag &= ts3.getSyntacticModifierFlags(searchSpaceNode);
                searchSpaceNode = searchSpaceNode.parent;
                break;
              default:
                return void 0;
            }
            var sourceFile = searchSpaceNode.getSourceFile();
            var references = ts3.mapDefined(getPossibleSymbolReferenceNodes(sourceFile, "super", searchSpaceNode), function(node) {
              if (node.kind !== 105) {
                return;
              }
              var container = ts3.getSuperContainer(node, false);
              return container && (32 & ts3.getSyntacticModifierFlags(container)) === staticFlag && container.parent.symbol === searchSpaceNode.symbol ? nodeEntry(node) : void 0;
            });
            return [{ definition: { type: 0, symbol: searchSpaceNode.symbol }, references }];
          }
          function isParameterName(node) {
            return node.kind === 78 && node.parent.kind === 161 && node.parent.name === node;
          }
          function getReferencesForThisKeyword(thisOrSuperKeyword, sourceFiles, cancellationToken) {
            var searchSpaceNode = ts3.getThisContainer(thisOrSuperKeyword, false);
            var staticFlag = 32;
            switch (searchSpaceNode.kind) {
              case 166:
              case 165:
                if (ts3.isObjectLiteralMethod(searchSpaceNode)) {
                  staticFlag &= ts3.getSyntacticModifierFlags(searchSpaceNode);
                  searchSpaceNode = searchSpaceNode.parent;
                  break;
                }
              case 164:
              case 163:
              case 167:
              case 168:
              case 169:
                staticFlag &= ts3.getSyntacticModifierFlags(searchSpaceNode);
                searchSpaceNode = searchSpaceNode.parent;
                break;
              case 298:
                if (ts3.isExternalModule(searchSpaceNode) || isParameterName(thisOrSuperKeyword)) {
                  return void 0;
                }
              case 252:
              case 209:
                break;
              default:
                return void 0;
            }
            var references = ts3.flatMap(searchSpaceNode.kind === 298 ? sourceFiles : [searchSpaceNode.getSourceFile()], function(sourceFile) {
              cancellationToken.throwIfCancellationRequested();
              return getPossibleSymbolReferenceNodes(sourceFile, "this", ts3.isSourceFile(searchSpaceNode) ? sourceFile : searchSpaceNode).filter(function(node) {
                if (!ts3.isThis(node)) {
                  return false;
                }
                var container = ts3.getThisContainer(node, false);
                switch (searchSpaceNode.kind) {
                  case 209:
                  case 252:
                    return searchSpaceNode.symbol === container.symbol;
                  case 166:
                  case 165:
                    return ts3.isObjectLiteralMethod(searchSpaceNode) && searchSpaceNode.symbol === container.symbol;
                  case 222:
                  case 253:
                  case 201:
                    return container.parent && searchSpaceNode.symbol === container.parent.symbol && (ts3.getSyntacticModifierFlags(container) & 32) === staticFlag;
                  case 298:
                    return container.kind === 298 && !ts3.isExternalModule(container) && !isParameterName(node);
                }
              });
            }).map(function(n2) {
              return nodeEntry(n2);
            });
            var thisParameter = ts3.firstDefined(references, function(r2) {
              return ts3.isParameter(r2.node.parent) ? r2.node : void 0;
            });
            return [{
              definition: { type: 3, node: thisParameter || thisOrSuperKeyword },
              references
            }];
          }
          function getReferencesForStringLiteral(node, sourceFiles, checker, cancellationToken) {
            var type3 = ts3.getContextualTypeOrAncestorTypeNodeType(node, checker);
            var references = ts3.flatMap(sourceFiles, function(sourceFile) {
              cancellationToken.throwIfCancellationRequested();
              return ts3.mapDefined(getPossibleSymbolReferenceNodes(sourceFile, node.text), function(ref2) {
                if (ts3.isStringLiteralLike(ref2) && ref2.text === node.text) {
                  if (type3) {
                    var refType = ts3.getContextualTypeOrAncestorTypeNodeType(ref2, checker);
                    if (type3 !== checker.getStringType() && type3 === refType) {
                      return nodeEntry(ref2, 2);
                    }
                  } else {
                    return nodeEntry(ref2, 2);
                  }
                }
              });
            });
            return [{
              definition: { type: 4, node },
              references
            }];
          }
          function populateSearchSymbolSet(symbol, location, checker, isForRename, providePrefixAndSuffixText, implementations) {
            var result2 = [];
            forEachRelatedSymbol(symbol, location, checker, isForRename, !(isForRename && providePrefixAndSuffixText), function(sym, root, base) {
              if (base) {
                if (isStatic(symbol) !== isStatic(base)) {
                  base = void 0;
                }
              }
              result2.push(base || root || sym);
            }, function() {
              return !implementations;
            });
            return result2;
          }
          function forEachRelatedSymbol(symbol, location, checker, isForRenamePopulateSearchSymbolSet, onlyIncludeBindingElementAtReferenceLocation, cbSymbol, allowBaseTypes) {
            var containingObjectLiteralElement = ts3.getContainingObjectLiteralElement(location);
            if (containingObjectLiteralElement) {
              var shorthandValueSymbol = checker.getShorthandAssignmentValueSymbol(location.parent);
              if (shorthandValueSymbol && isForRenamePopulateSearchSymbolSet) {
                return cbSymbol(shorthandValueSymbol, void 0, void 0, 3);
              }
              var contextualType = checker.getContextualType(containingObjectLiteralElement.parent);
              var res_1 = contextualType && ts3.firstDefined(ts3.getPropertySymbolsFromContextualType(containingObjectLiteralElement, checker, contextualType, true), function(sym) {
                return fromRoot(sym, 4);
              });
              if (res_1)
                return res_1;
              var propertySymbol = getPropertySymbolOfDestructuringAssignment(location, checker);
              var res1 = propertySymbol && cbSymbol(propertySymbol, void 0, void 0, 4);
              if (res1)
                return res1;
              var res2 = shorthandValueSymbol && cbSymbol(shorthandValueSymbol, void 0, void 0, 3);
              if (res2)
                return res2;
            }
            var aliasedSymbol = getMergedAliasedSymbolOfNamespaceExportDeclaration(location, symbol, checker);
            if (aliasedSymbol) {
              var res_2 = cbSymbol(aliasedSymbol, void 0, void 0, 1);
              if (res_2)
                return res_2;
            }
            var res = fromRoot(symbol);
            if (res)
              return res;
            if (symbol.valueDeclaration && ts3.isParameterPropertyDeclaration(symbol.valueDeclaration, symbol.valueDeclaration.parent)) {
              var paramProps = checker.getSymbolsOfParameterPropertyDeclaration(ts3.cast(symbol.valueDeclaration, ts3.isParameter), symbol.name);
              ts3.Debug.assert(paramProps.length === 2 && !!(paramProps[0].flags & 1) && !!(paramProps[1].flags & 4));
              return fromRoot(symbol.flags & 1 ? paramProps[1] : paramProps[0]);
            }
            var exportSpecifier = ts3.getDeclarationOfKind(symbol, 271);
            if (!isForRenamePopulateSearchSymbolSet || exportSpecifier && !exportSpecifier.propertyName) {
              var localSymbol = exportSpecifier && checker.getExportSpecifierLocalTargetSymbol(exportSpecifier);
              if (localSymbol) {
                var res_3 = cbSymbol(localSymbol, void 0, void 0, 1);
                if (res_3)
                  return res_3;
              }
            }
            if (!isForRenamePopulateSearchSymbolSet) {
              var bindingElementPropertySymbol = void 0;
              if (onlyIncludeBindingElementAtReferenceLocation) {
                bindingElementPropertySymbol = ts3.isObjectBindingElementWithoutPropertyName(location.parent) ? ts3.getPropertySymbolFromBindingElement(checker, location.parent) : void 0;
              } else {
                bindingElementPropertySymbol = getPropertySymbolOfObjectBindingPatternWithoutPropertyName(symbol, checker);
              }
              return bindingElementPropertySymbol && fromRoot(bindingElementPropertySymbol, 4);
            }
            ts3.Debug.assert(isForRenamePopulateSearchSymbolSet);
            var includeOriginalSymbolOfBindingElement = onlyIncludeBindingElementAtReferenceLocation;
            if (includeOriginalSymbolOfBindingElement) {
              var bindingElementPropertySymbol = getPropertySymbolOfObjectBindingPatternWithoutPropertyName(symbol, checker);
              return bindingElementPropertySymbol && fromRoot(bindingElementPropertySymbol, 4);
            }
            function fromRoot(sym, kind) {
              return ts3.firstDefined(checker.getRootSymbols(sym), function(rootSymbol) {
                return cbSymbol(sym, rootSymbol, void 0, kind) || (rootSymbol.parent && rootSymbol.parent.flags & (32 | 64) && allowBaseTypes(rootSymbol) ? getPropertySymbolsFromBaseTypes(rootSymbol.parent, rootSymbol.name, checker, function(base) {
                  return cbSymbol(sym, rootSymbol, base, kind);
                }) : void 0);
              });
            }
            function getPropertySymbolOfObjectBindingPatternWithoutPropertyName(symbol2, checker2) {
              var bindingElement = ts3.getDeclarationOfKind(symbol2, 199);
              if (bindingElement && ts3.isObjectBindingElementWithoutPropertyName(bindingElement)) {
                return ts3.getPropertySymbolFromBindingElement(checker2, bindingElement);
              }
            }
          }
          function getPropertySymbolsFromBaseTypes(symbol, propertyName, checker, cb2) {
            var seen = new ts3.Map();
            return recur(symbol);
            function recur(symbol2) {
              if (!(symbol2.flags & (32 | 64)) || !ts3.addToSeen(seen, ts3.getSymbolId(symbol2)))
                return;
              return ts3.firstDefined(symbol2.declarations, function(declaration) {
                return ts3.firstDefined(ts3.getAllSuperTypeNodes(declaration), function(typeReference) {
                  var type3 = checker.getTypeAtLocation(typeReference);
                  var propertySymbol = type3 && type3.symbol && checker.getPropertyOfType(type3, propertyName);
                  return type3 && propertySymbol && (ts3.firstDefined(checker.getRootSymbols(propertySymbol), cb2) || recur(type3.symbol));
                });
              });
            }
          }
          function isStatic(symbol) {
            if (!symbol.valueDeclaration) {
              return false;
            }
            var modifierFlags = ts3.getEffectiveModifierFlags(symbol.valueDeclaration);
            return !!(modifierFlags & 32);
          }
          function getRelatedSymbol(search, referenceSymbol, referenceLocation, state) {
            var checker = state.checker;
            return forEachRelatedSymbol(referenceSymbol, referenceLocation, checker, false, state.options.use !== 2 || !!state.options.providePrefixAndSuffixTextForRename, function(sym, rootSymbol, baseSymbol, kind) {
              if (baseSymbol) {
                if (isStatic(referenceSymbol) !== isStatic(baseSymbol)) {
                  baseSymbol = void 0;
                }
              }
              return search.includes(baseSymbol || rootSymbol || sym) ? { symbol: rootSymbol && !(ts3.getCheckFlags(sym) & 6) ? rootSymbol : sym, kind } : void 0;
            }, function(rootSymbol) {
              return !(search.parents && !search.parents.some(function(parent) {
                return explicitlyInheritsFrom(rootSymbol.parent, parent, state.inheritsFromCache, checker);
              }));
            });
          }
          function getIntersectingMeaningFromDeclarations(node, symbol) {
            var meaning = ts3.getMeaningFromLocation(node);
            var declarations = symbol.declarations;
            if (declarations) {
              var lastIterationMeaning = void 0;
              do {
                lastIterationMeaning = meaning;
                for (var _i = 0, declarations_2 = declarations; _i < declarations_2.length; _i++) {
                  var declaration = declarations_2[_i];
                  var declarationMeaning = ts3.getMeaningFromDeclaration(declaration);
                  if (declarationMeaning & meaning) {
                    meaning |= declarationMeaning;
                  }
                }
              } while (meaning !== lastIterationMeaning);
            }
            return meaning;
          }
          Core2.getIntersectingMeaningFromDeclarations = getIntersectingMeaningFromDeclarations;
          function isImplementation(node) {
            return !!(node.flags & 8388608) ? !(ts3.isInterfaceDeclaration(node) || ts3.isTypeAliasDeclaration(node)) : ts3.isVariableLike(node) ? ts3.hasInitializer(node) : ts3.isFunctionLikeDeclaration(node) ? !!node.body : ts3.isClassLike(node) || ts3.isModuleOrEnumDeclaration(node);
          }
          function getReferenceEntriesForShorthandPropertyAssignment(node, checker, addReference2) {
            var refSymbol = checker.getSymbolAtLocation(node);
            var shorthandSymbol = checker.getShorthandAssignmentValueSymbol(refSymbol.valueDeclaration);
            if (shorthandSymbol) {
              for (var _i = 0, _a2 = shorthandSymbol.getDeclarations(); _i < _a2.length; _i++) {
                var declaration = _a2[_i];
                if (ts3.getMeaningFromDeclaration(declaration) & 1) {
                  addReference2(declaration);
                }
              }
            }
          }
          Core2.getReferenceEntriesForShorthandPropertyAssignment = getReferenceEntriesForShorthandPropertyAssignment;
          function forEachDescendantOfKind(node, kind, action) {
            ts3.forEachChild(node, function(child) {
              if (child.kind === kind) {
                action(child);
              }
              forEachDescendantOfKind(child, kind, action);
            });
          }
          function tryGetClassByExtendingIdentifier(node) {
            return ts3.tryGetClassExtendingExpressionWithTypeArguments(ts3.climbPastPropertyAccess(node).parent);
          }
          function getParentSymbolsOfPropertyAccess(location, symbol, checker) {
            var propertyAccessExpression = ts3.isRightSideOfPropertyAccess(location) ? location.parent : void 0;
            var lhsType = propertyAccessExpression && checker.getTypeAtLocation(propertyAccessExpression.expression);
            var res = ts3.mapDefined(lhsType && (lhsType.isUnionOrIntersection() ? lhsType.types : lhsType.symbol === symbol.parent ? void 0 : [lhsType]), function(t2) {
              return t2.symbol && t2.symbol.flags & (32 | 64) ? t2.symbol : void 0;
            });
            return res.length === 0 ? void 0 : res;
          }
          function isForRenameWithPrefixAndSuffixText(options) {
            return options.use === 2 && options.providePrefixAndSuffixTextForRename;
          }
        })(Core = FindAllReferences2.Core || (FindAllReferences2.Core = {}));
      })(FindAllReferences = ts3.FindAllReferences || (ts3.FindAllReferences = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var CallHierarchy;
      (function(CallHierarchy2) {
        function isNamedExpression(node) {
          return (ts3.isFunctionExpression(node) || ts3.isClassExpression(node)) && ts3.isNamedDeclaration(node);
        }
        function isConstNamedExpression(node) {
          return (ts3.isFunctionExpression(node) || ts3.isArrowFunction(node) || ts3.isClassExpression(node)) && ts3.isVariableDeclaration(node.parent) && node === node.parent.initializer && ts3.isIdentifier(node.parent.name) && !!(ts3.getCombinedNodeFlags(node.parent) & 2);
        }
        function isPossibleCallHierarchyDeclaration(node) {
          return ts3.isSourceFile(node) || ts3.isModuleDeclaration(node) || ts3.isFunctionDeclaration(node) || ts3.isFunctionExpression(node) || ts3.isClassDeclaration(node) || ts3.isClassExpression(node) || ts3.isMethodDeclaration(node) || ts3.isMethodSignature(node) || ts3.isGetAccessorDeclaration(node) || ts3.isSetAccessorDeclaration(node);
        }
        function isValidCallHierarchyDeclaration(node) {
          return ts3.isSourceFile(node) || ts3.isModuleDeclaration(node) && ts3.isIdentifier(node.name) || ts3.isFunctionDeclaration(node) || ts3.isClassDeclaration(node) || ts3.isMethodDeclaration(node) || ts3.isMethodSignature(node) || ts3.isGetAccessorDeclaration(node) || ts3.isSetAccessorDeclaration(node) || isNamedExpression(node) || isConstNamedExpression(node);
        }
        function getCallHierarchyDeclarationReferenceNode(node) {
          if (ts3.isSourceFile(node))
            return node;
          if (ts3.isNamedDeclaration(node))
            return node.name;
          if (isConstNamedExpression(node))
            return node.parent.name;
          return ts3.Debug.checkDefined(node.modifiers && ts3.find(node.modifiers, isDefaultModifier));
        }
        function isDefaultModifier(node) {
          return node.kind === 87;
        }
        function getSymbolOfCallHierarchyDeclaration(typeChecker, node) {
          var location = getCallHierarchyDeclarationReferenceNode(node);
          return location && typeChecker.getSymbolAtLocation(location);
        }
        function getCallHierarchyItemName(program2, node) {
          if (ts3.isSourceFile(node)) {
            return { text: node.fileName, pos: 0, end: 0 };
          }
          if ((ts3.isFunctionDeclaration(node) || ts3.isClassDeclaration(node)) && !ts3.isNamedDeclaration(node)) {
            var defaultModifier = node.modifiers && ts3.find(node.modifiers, isDefaultModifier);
            if (defaultModifier) {
              return { text: "default", pos: defaultModifier.getStart(), end: defaultModifier.getEnd() };
            }
          }
          var declName = isConstNamedExpression(node) ? node.parent.name : ts3.Debug.checkDefined(ts3.getNameOfDeclaration(node), "Expected call hierarchy item to have a name");
          var text = ts3.isIdentifier(declName) ? ts3.idText(declName) : ts3.isStringOrNumericLiteralLike(declName) ? declName.text : ts3.isComputedPropertyName(declName) ? ts3.isStringOrNumericLiteralLike(declName.expression) ? declName.expression.text : void 0 : void 0;
          if (text === void 0) {
            var typeChecker = program2.getTypeChecker();
            var symbol = typeChecker.getSymbolAtLocation(declName);
            if (symbol) {
              text = typeChecker.symbolToString(symbol, node);
            }
          }
          if (text === void 0) {
            var printer_1 = ts3.createPrinter({ removeComments: true, omitTrailingSemicolon: true });
            text = ts3.usingSingleLineStringWriter(function(writer) {
              return printer_1.writeNode(4, node, node.getSourceFile(), writer);
            });
          }
          return { text, pos: declName.getStart(), end: declName.getEnd() };
        }
        function getCallHierarchItemContainerName(node) {
          var _a2, _b;
          if (isConstNamedExpression(node)) {
            if (ts3.isModuleBlock(node.parent.parent.parent.parent) && ts3.isIdentifier(node.parent.parent.parent.parent.parent.name)) {
              return node.parent.parent.parent.parent.parent.name.getText();
            }
            return;
          }
          switch (node.kind) {
            case 168:
            case 169:
            case 166:
              if (node.parent.kind === 201) {
                return (_a2 = ts3.getAssignedName(node.parent)) === null || _a2 === void 0 ? void 0 : _a2.getText();
              }
              return (_b = ts3.getNameOfDeclaration(node.parent)) === null || _b === void 0 ? void 0 : _b.getText();
            case 252:
            case 253:
            case 257:
              if (ts3.isModuleBlock(node.parent) && ts3.isIdentifier(node.parent.parent.name)) {
                return node.parent.parent.name.getText();
              }
          }
        }
        function findImplementation(typeChecker, node) {
          if (node.body) {
            return node;
          }
          if (ts3.isConstructorDeclaration(node)) {
            return ts3.getFirstConstructorWithBody(node.parent);
          }
          if (ts3.isFunctionDeclaration(node) || ts3.isMethodDeclaration(node)) {
            var symbol = getSymbolOfCallHierarchyDeclaration(typeChecker, node);
            if (symbol && symbol.valueDeclaration && ts3.isFunctionLikeDeclaration(symbol.valueDeclaration) && symbol.valueDeclaration.body) {
              return symbol.valueDeclaration;
            }
            return void 0;
          }
          return node;
        }
        function findAllInitialDeclarations(typeChecker, node) {
          var symbol = getSymbolOfCallHierarchyDeclaration(typeChecker, node);
          var declarations;
          if (symbol && symbol.declarations) {
            var indices = ts3.indicesOf(symbol.declarations);
            var keys_1 = ts3.map(symbol.declarations, function(decl2) {
              return { file: decl2.getSourceFile().fileName, pos: decl2.pos };
            });
            indices.sort(function(a2, b2) {
              return ts3.compareStringsCaseSensitive(keys_1[a2].file, keys_1[b2].file) || keys_1[a2].pos - keys_1[b2].pos;
            });
            var sortedDeclarations = ts3.map(indices, function(i3) {
              return symbol.declarations[i3];
            });
            var lastDecl = void 0;
            for (var _i = 0, sortedDeclarations_1 = sortedDeclarations; _i < sortedDeclarations_1.length; _i++) {
              var decl = sortedDeclarations_1[_i];
              if (isValidCallHierarchyDeclaration(decl)) {
                if (!lastDecl || lastDecl.parent !== decl.parent || lastDecl.end !== decl.pos) {
                  declarations = ts3.append(declarations, decl);
                }
                lastDecl = decl;
              }
            }
          }
          return declarations;
        }
        function findImplementationOrAllInitialDeclarations(typeChecker, node) {
          var _a2, _b, _c;
          if (ts3.isFunctionLikeDeclaration(node)) {
            return (_b = (_a2 = findImplementation(typeChecker, node)) !== null && _a2 !== void 0 ? _a2 : findAllInitialDeclarations(typeChecker, node)) !== null && _b !== void 0 ? _b : node;
          }
          return (_c = findAllInitialDeclarations(typeChecker, node)) !== null && _c !== void 0 ? _c : node;
        }
        function resolveCallHierarchyDeclaration(program2, location) {
          var typeChecker = program2.getTypeChecker();
          var followingSymbol = false;
          while (true) {
            if (isValidCallHierarchyDeclaration(location)) {
              return findImplementationOrAllInitialDeclarations(typeChecker, location);
            }
            if (isPossibleCallHierarchyDeclaration(location)) {
              var ancestor = ts3.findAncestor(location, isValidCallHierarchyDeclaration);
              return ancestor && findImplementationOrAllInitialDeclarations(typeChecker, ancestor);
            }
            if (ts3.isDeclarationName(location)) {
              if (isValidCallHierarchyDeclaration(location.parent)) {
                return findImplementationOrAllInitialDeclarations(typeChecker, location.parent);
              }
              if (isPossibleCallHierarchyDeclaration(location.parent)) {
                var ancestor = ts3.findAncestor(location.parent, isValidCallHierarchyDeclaration);
                return ancestor && findImplementationOrAllInitialDeclarations(typeChecker, ancestor);
              }
              if (ts3.isVariableDeclaration(location.parent) && location.parent.initializer && isConstNamedExpression(location.parent.initializer)) {
                return location.parent.initializer;
              }
              return void 0;
            }
            if (ts3.isConstructorDeclaration(location)) {
              if (isValidCallHierarchyDeclaration(location.parent)) {
                return location.parent;
              }
              return void 0;
            }
            if (ts3.isVariableDeclaration(location) && location.initializer && isConstNamedExpression(location.initializer)) {
              return location.initializer;
            }
            if (!followingSymbol) {
              var symbol = typeChecker.getSymbolAtLocation(location);
              if (symbol) {
                if (symbol.flags & 2097152) {
                  symbol = typeChecker.getAliasedSymbol(symbol);
                }
                if (symbol.valueDeclaration) {
                  followingSymbol = true;
                  location = symbol.valueDeclaration;
                  continue;
                }
              }
            }
            return void 0;
          }
        }
        CallHierarchy2.resolveCallHierarchyDeclaration = resolveCallHierarchyDeclaration;
        function createCallHierarchyItem(program2, node) {
          var sourceFile = node.getSourceFile();
          var name = getCallHierarchyItemName(program2, node);
          var containerName = getCallHierarchItemContainerName(node);
          var kind = ts3.getNodeKind(node);
          var kindModifiers = ts3.getNodeModifiers(node);
          var span = ts3.createTextSpanFromBounds(ts3.skipTrivia(sourceFile.text, node.getFullStart(), false, true), node.getEnd());
          var selectionSpan = ts3.createTextSpanFromBounds(name.pos, name.end);
          return { file: sourceFile.fileName, kind, kindModifiers, name: name.text, containerName, span, selectionSpan };
        }
        CallHierarchy2.createCallHierarchyItem = createCallHierarchyItem;
        function isDefined(x) {
          return x !== void 0;
        }
        function convertEntryToCallSite(entry) {
          if (entry.kind === 1) {
            var node = entry.node;
            if (ts3.isCallOrNewExpressionTarget(node, true, true) || ts3.isTaggedTemplateTag(node, true, true) || ts3.isDecoratorTarget(node, true, true) || ts3.isJsxOpeningLikeElementTagName(node, true, true) || ts3.isRightSideOfPropertyAccess(node) || ts3.isArgumentExpressionOfElementAccess(node)) {
              var sourceFile = node.getSourceFile();
              var ancestor = ts3.findAncestor(node, isValidCallHierarchyDeclaration) || sourceFile;
              return { declaration: ancestor, range: ts3.createTextRangeFromNode(node, sourceFile) };
            }
          }
        }
        function getCallSiteGroupKey(entry) {
          return ts3.getNodeId(entry.declaration);
        }
        function createCallHierarchyIncomingCall(from, fromSpans) {
          return { from, fromSpans };
        }
        function convertCallSiteGroupToIncomingCall(program2, entries) {
          return createCallHierarchyIncomingCall(createCallHierarchyItem(program2, entries[0].declaration), ts3.map(entries, function(entry) {
            return ts3.createTextSpanFromRange(entry.range);
          }));
        }
        function getIncomingCalls(program2, declaration, cancellationToken) {
          if (ts3.isSourceFile(declaration) || ts3.isModuleDeclaration(declaration)) {
            return [];
          }
          var location = getCallHierarchyDeclarationReferenceNode(declaration);
          var calls = ts3.filter(ts3.FindAllReferences.findReferenceOrRenameEntries(program2, cancellationToken, program2.getSourceFiles(), location, 0, { use: 1 }, convertEntryToCallSite), isDefined);
          return calls ? ts3.group(calls, getCallSiteGroupKey, function(entries) {
            return convertCallSiteGroupToIncomingCall(program2, entries);
          }) : [];
        }
        CallHierarchy2.getIncomingCalls = getIncomingCalls;
        function createCallSiteCollector(program2, callSites) {
          function recordCallSite(node) {
            var target = ts3.isTaggedTemplateExpression(node) ? node.tag : ts3.isJsxOpeningLikeElement(node) ? node.tagName : ts3.isAccessExpression(node) ? node : node.expression;
            var declaration = resolveCallHierarchyDeclaration(program2, target);
            if (declaration) {
              var range = ts3.createTextRangeFromNode(target, node.getSourceFile());
              if (ts3.isArray(declaration)) {
                for (var _i = 0, declaration_1 = declaration; _i < declaration_1.length; _i++) {
                  var decl = declaration_1[_i];
                  callSites.push({ declaration: decl, range });
                }
              } else {
                callSites.push({ declaration, range });
              }
            }
          }
          function collect(node) {
            if (!node)
              return;
            if (node.flags & 8388608) {
              return;
            }
            if (isValidCallHierarchyDeclaration(node)) {
              if (ts3.isClassLike(node)) {
                for (var _i = 0, _a2 = node.members; _i < _a2.length; _i++) {
                  var member = _a2[_i];
                  if (member.name && ts3.isComputedPropertyName(member.name)) {
                    collect(member.name.expression);
                  }
                }
              }
              return;
            }
            switch (node.kind) {
              case 78:
              case 261:
              case 262:
              case 268:
              case 254:
              case 255:
                return;
              case 207:
              case 225:
                collect(node.expression);
                return;
              case 250:
              case 161:
                collect(node.name);
                collect(node.initializer);
                return;
              case 204:
                recordCallSite(node);
                collect(node.expression);
                ts3.forEach(node.arguments, collect);
                return;
              case 205:
                recordCallSite(node);
                collect(node.expression);
                ts3.forEach(node.arguments, collect);
                return;
              case 206:
                recordCallSite(node);
                collect(node.tag);
                collect(node.template);
                return;
              case 276:
              case 275:
                recordCallSite(node);
                collect(node.tagName);
                collect(node.attributes);
                return;
              case 162:
                recordCallSite(node);
                collect(node.expression);
                return;
              case 202:
              case 203:
                recordCallSite(node);
                ts3.forEachChild(node, collect);
                break;
            }
            if (ts3.isPartOfTypeNode(node)) {
              return;
            }
            ts3.forEachChild(node, collect);
          }
          return collect;
        }
        function collectCallSitesOfSourceFile(node, collect) {
          ts3.forEach(node.statements, collect);
        }
        function collectCallSitesOfModuleDeclaration(node, collect) {
          if (!ts3.hasSyntacticModifier(node, 2) && node.body && ts3.isModuleBlock(node.body)) {
            ts3.forEach(node.body.statements, collect);
          }
        }
        function collectCallSitesOfFunctionLikeDeclaration(typeChecker, node, collect) {
          var implementation = findImplementation(typeChecker, node);
          if (implementation) {
            ts3.forEach(implementation.parameters, collect);
            collect(implementation.body);
          }
        }
        function collectCallSitesOfClassLikeDeclaration(node, collect) {
          ts3.forEach(node.decorators, collect);
          var heritage = ts3.getClassExtendsHeritageElement(node);
          if (heritage) {
            collect(heritage.expression);
          }
          for (var _i = 0, _a2 = node.members; _i < _a2.length; _i++) {
            var member = _a2[_i];
            ts3.forEach(member.decorators, collect);
            if (ts3.isPropertyDeclaration(member)) {
              collect(member.initializer);
            } else if (ts3.isConstructorDeclaration(member) && member.body) {
              ts3.forEach(member.parameters, collect);
              collect(member.body);
            }
          }
        }
        function collectCallSites(program2, node) {
          var callSites = [];
          var collect = createCallSiteCollector(program2, callSites);
          switch (node.kind) {
            case 298:
              collectCallSitesOfSourceFile(node, collect);
              break;
            case 257:
              collectCallSitesOfModuleDeclaration(node, collect);
              break;
            case 252:
            case 209:
            case 210:
            case 166:
            case 168:
            case 169:
              collectCallSitesOfFunctionLikeDeclaration(program2.getTypeChecker(), node, collect);
              break;
            case 253:
            case 222:
              collectCallSitesOfClassLikeDeclaration(node, collect);
              break;
            default:
              ts3.Debug.assertNever(node);
          }
          return callSites;
        }
        function createCallHierarchyOutgoingCall(to, fromSpans) {
          return { to, fromSpans };
        }
        function convertCallSiteGroupToOutgoingCall(program2, entries) {
          return createCallHierarchyOutgoingCall(createCallHierarchyItem(program2, entries[0].declaration), ts3.map(entries, function(entry) {
            return ts3.createTextSpanFromRange(entry.range);
          }));
        }
        function getOutgoingCalls(program2, declaration) {
          if (declaration.flags & 8388608 || ts3.isMethodSignature(declaration)) {
            return [];
          }
          return ts3.group(collectCallSites(program2, declaration), getCallSiteGroupKey, function(entries) {
            return convertCallSiteGroupToOutgoingCall(program2, entries);
          });
        }
        CallHierarchy2.getOutgoingCalls = getOutgoingCalls;
      })(CallHierarchy = ts3.CallHierarchy || (ts3.CallHierarchy = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      function getEditsForFileRename(program2, oldFileOrDirPath, newFileOrDirPath, host, formatContext, preferences, sourceMapper) {
        var useCaseSensitiveFileNames = ts3.hostUsesCaseSensitiveFileNames(host);
        var getCanonicalFileName = ts3.createGetCanonicalFileName(useCaseSensitiveFileNames);
        var oldToNew = getPathUpdater(oldFileOrDirPath, newFileOrDirPath, getCanonicalFileName, sourceMapper);
        var newToOld = getPathUpdater(newFileOrDirPath, oldFileOrDirPath, getCanonicalFileName, sourceMapper);
        return ts3.textChanges.ChangeTracker.with({ host, formatContext, preferences }, function(changeTracker) {
          updateTsconfigFiles(program2, changeTracker, oldToNew, oldFileOrDirPath, newFileOrDirPath, host.getCurrentDirectory(), useCaseSensitiveFileNames);
          updateImports(program2, changeTracker, oldToNew, newToOld, host, getCanonicalFileName);
        });
      }
      ts3.getEditsForFileRename = getEditsForFileRename;
      function getPathUpdater(oldFileOrDirPath, newFileOrDirPath, getCanonicalFileName, sourceMapper) {
        var canonicalOldPath = getCanonicalFileName(oldFileOrDirPath);
        return function(path2) {
          var originalPath = sourceMapper && sourceMapper.tryGetSourcePosition({ fileName: path2, pos: 0 });
          var updatedPath = getUpdatedPath(originalPath ? originalPath.fileName : path2);
          return originalPath ? updatedPath === void 0 ? void 0 : makeCorrespondingRelativeChange(originalPath.fileName, updatedPath, path2, getCanonicalFileName) : updatedPath;
        };
        function getUpdatedPath(pathToUpdate) {
          if (getCanonicalFileName(pathToUpdate) === canonicalOldPath)
            return newFileOrDirPath;
          var suffix = ts3.tryRemoveDirectoryPrefix(pathToUpdate, canonicalOldPath, getCanonicalFileName);
          return suffix === void 0 ? void 0 : newFileOrDirPath + "/" + suffix;
        }
      }
      ts3.getPathUpdater = getPathUpdater;
      function makeCorrespondingRelativeChange(a0, b0, a1, getCanonicalFileName) {
        var rel = ts3.getRelativePathFromFile(a0, b0, getCanonicalFileName);
        return combinePathsSafe(ts3.getDirectoryPath(a1), rel);
      }
      function updateTsconfigFiles(program2, changeTracker, oldToNew, oldFileOrDirPath, newFileOrDirPath, currentDirectory, useCaseSensitiveFileNames) {
        var configFile = program2.getCompilerOptions().configFile;
        if (!configFile)
          return;
        var configDir = ts3.getDirectoryPath(configFile.fileName);
        var jsonObjectLiteral = ts3.getTsConfigObjectLiteralExpression(configFile);
        if (!jsonObjectLiteral)
          return;
        forEachProperty(jsonObjectLiteral, function(property, propertyName) {
          switch (propertyName) {
            case "files":
            case "include":
            case "exclude": {
              var foundExactMatch = updatePaths(property);
              if (!foundExactMatch && propertyName === "include" && ts3.isArrayLiteralExpression(property.initializer)) {
                var includes = ts3.mapDefined(property.initializer.elements, function(e2) {
                  return ts3.isStringLiteral(e2) ? e2.text : void 0;
                });
                var matchers = ts3.getFileMatcherPatterns(configDir, [], includes, useCaseSensitiveFileNames, currentDirectory);
                if (ts3.getRegexFromPattern(ts3.Debug.checkDefined(matchers.includeFilePattern), useCaseSensitiveFileNames).test(oldFileOrDirPath) && !ts3.getRegexFromPattern(ts3.Debug.checkDefined(matchers.includeFilePattern), useCaseSensitiveFileNames).test(newFileOrDirPath)) {
                  changeTracker.insertNodeAfter(configFile, ts3.last(property.initializer.elements), ts3.factory.createStringLiteral(relativePath(newFileOrDirPath)));
                }
              }
              break;
            }
            case "compilerOptions":
              forEachProperty(property.initializer, function(property2, propertyName2) {
                var option = ts3.getOptionFromName(propertyName2);
                if (option && (option.isFilePath || option.type === "list" && option.element.isFilePath)) {
                  updatePaths(property2);
                } else if (propertyName2 === "paths") {
                  forEachProperty(property2.initializer, function(pathsProperty) {
                    if (!ts3.isArrayLiteralExpression(pathsProperty.initializer))
                      return;
                    for (var _i = 0, _a2 = pathsProperty.initializer.elements; _i < _a2.length; _i++) {
                      var e2 = _a2[_i];
                      tryUpdateString(e2);
                    }
                  });
                }
              });
              break;
          }
        });
        function updatePaths(property) {
          var elements = ts3.isArrayLiteralExpression(property.initializer) ? property.initializer.elements : [property.initializer];
          var foundExactMatch = false;
          for (var _i = 0, elements_1 = elements; _i < elements_1.length; _i++) {
            var element = elements_1[_i];
            foundExactMatch = tryUpdateString(element) || foundExactMatch;
          }
          return foundExactMatch;
        }
        function tryUpdateString(element) {
          if (!ts3.isStringLiteral(element))
            return false;
          var elementFileName = combinePathsSafe(configDir, element.text);
          var updated = oldToNew(elementFileName);
          if (updated !== void 0) {
            changeTracker.replaceRangeWithText(configFile, createStringRange(element, configFile), relativePath(updated));
            return true;
          }
          return false;
        }
        function relativePath(path2) {
          return ts3.getRelativePathFromDirectory(configDir, path2, !useCaseSensitiveFileNames);
        }
      }
      function updateImports(program2, changeTracker, oldToNew, newToOld, host, getCanonicalFileName) {
        var allFiles = program2.getSourceFiles();
        var _loop_5 = function(sourceFile2) {
          var newFromOld = oldToNew(sourceFile2.fileName);
          var newImportFromPath = newFromOld !== null && newFromOld !== void 0 ? newFromOld : sourceFile2.fileName;
          var newImportFromDirectory = ts3.getDirectoryPath(newImportFromPath);
          var oldFromNew = newToOld(sourceFile2.fileName);
          var oldImportFromPath = oldFromNew || sourceFile2.fileName;
          var oldImportFromDirectory = ts3.getDirectoryPath(oldImportFromPath);
          var importingSourceFileMoved = newFromOld !== void 0 || oldFromNew !== void 0;
          updateImportsWorker(sourceFile2, changeTracker, function(referenceText) {
            if (!ts3.pathIsRelative(referenceText))
              return void 0;
            var oldAbsolute = combinePathsSafe(oldImportFromDirectory, referenceText);
            var newAbsolute = oldToNew(oldAbsolute);
            return newAbsolute === void 0 ? void 0 : ts3.ensurePathIsNonModuleName(ts3.getRelativePathFromDirectory(newImportFromDirectory, newAbsolute, getCanonicalFileName));
          }, function(importLiteral) {
            var importedModuleSymbol = program2.getTypeChecker().getSymbolAtLocation(importLiteral);
            if ((importedModuleSymbol === null || importedModuleSymbol === void 0 ? void 0 : importedModuleSymbol.declarations) && importedModuleSymbol.declarations.some(function(d) {
              return ts3.isAmbientModule(d);
            }))
              return void 0;
            var toImport = oldFromNew !== void 0 ? getSourceFileToImportFromResolved(importLiteral, ts3.resolveModuleName(importLiteral.text, oldImportFromPath, program2.getCompilerOptions(), host), oldToNew, allFiles) : getSourceFileToImport(importedModuleSymbol, importLiteral, sourceFile2, program2, host, oldToNew);
            return toImport !== void 0 && (toImport.updated || importingSourceFileMoved && ts3.pathIsRelative(importLiteral.text)) ? ts3.moduleSpecifiers.updateModuleSpecifier(program2.getCompilerOptions(), getCanonicalFileName(newImportFromPath), toImport.newFileName, ts3.createModuleSpecifierResolutionHost(program2, host), importLiteral.text) : void 0;
          });
        };
        for (var _i = 0, allFiles_1 = allFiles; _i < allFiles_1.length; _i++) {
          var sourceFile = allFiles_1[_i];
          _loop_5(sourceFile);
        }
      }
      function combineNormal(pathA, pathB) {
        return ts3.normalizePath(ts3.combinePaths(pathA, pathB));
      }
      function combinePathsSafe(pathA, pathB) {
        return ts3.ensurePathIsNonModuleName(combineNormal(pathA, pathB));
      }
      function getSourceFileToImport(importedModuleSymbol, importLiteral, importingSourceFile, program2, host, oldToNew) {
        if (importedModuleSymbol) {
          var oldFileName = ts3.find(importedModuleSymbol.declarations, ts3.isSourceFile).fileName;
          var newFileName = oldToNew(oldFileName);
          return newFileName === void 0 ? { newFileName: oldFileName, updated: false } : { newFileName, updated: true };
        } else {
          var resolved = host.resolveModuleNames ? host.getResolvedModuleWithFailedLookupLocationsFromCache && host.getResolvedModuleWithFailedLookupLocationsFromCache(importLiteral.text, importingSourceFile.fileName) : program2.getResolvedModuleWithFailedLookupLocationsFromCache(importLiteral.text, importingSourceFile.fileName);
          return getSourceFileToImportFromResolved(importLiteral, resolved, oldToNew, program2.getSourceFiles());
        }
      }
      function getSourceFileToImportFromResolved(importLiteral, resolved, oldToNew, sourceFiles) {
        if (!resolved)
          return void 0;
        if (resolved.resolvedModule) {
          var result_2 = tryChange(resolved.resolvedModule.resolvedFileName);
          if (result_2)
            return result_2;
        }
        var result2 = ts3.forEach(resolved.failedLookupLocations, tryChangeWithIgnoringPackageJsonExisting) || ts3.pathIsRelative(importLiteral.text) && ts3.forEach(resolved.failedLookupLocations, tryChangeWithIgnoringPackageJson);
        if (result2)
          return result2;
        return resolved.resolvedModule && { newFileName: resolved.resolvedModule.resolvedFileName, updated: false };
        function tryChangeWithIgnoringPackageJsonExisting(oldFileName) {
          var newFileName = oldToNew(oldFileName);
          return newFileName && ts3.find(sourceFiles, function(src) {
            return src.fileName === newFileName;
          }) ? tryChangeWithIgnoringPackageJson(oldFileName) : void 0;
        }
        function tryChangeWithIgnoringPackageJson(oldFileName) {
          return !ts3.endsWith(oldFileName, "/package.json") ? tryChange(oldFileName) : void 0;
        }
        function tryChange(oldFileName) {
          var newFileName = oldToNew(oldFileName);
          return newFileName && { newFileName, updated: true };
        }
      }
      function updateImportsWorker(sourceFile, changeTracker, updateRef, updateImport) {
        for (var _i = 0, _a2 = sourceFile.referencedFiles || ts3.emptyArray; _i < _a2.length; _i++) {
          var ref2 = _a2[_i];
          var updated = updateRef(ref2.fileName);
          if (updated !== void 0 && updated !== sourceFile.text.slice(ref2.pos, ref2.end))
            changeTracker.replaceRangeWithText(sourceFile, ref2, updated);
        }
        for (var _b = 0, _c = sourceFile.imports; _b < _c.length; _b++) {
          var importStringLiteral = _c[_b];
          var updated = updateImport(importStringLiteral);
          if (updated !== void 0 && updated !== importStringLiteral.text)
            changeTracker.replaceRangeWithText(sourceFile, createStringRange(importStringLiteral, sourceFile), updated);
        }
      }
      function createStringRange(node, sourceFile) {
        return ts3.createRange(node.getStart(sourceFile) + 1, node.end - 1);
      }
      function forEachProperty(objectLiteral, cb2) {
        if (!ts3.isObjectLiteralExpression(objectLiteral))
          return;
        for (var _i = 0, _a2 = objectLiteral.properties; _i < _a2.length; _i++) {
          var property = _a2[_i];
          if (ts3.isPropertyAssignment(property) && ts3.isStringLiteral(property.name)) {
            cb2(property, property.name.text);
          }
        }
      }
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var GoToDefinition;
      (function(GoToDefinition2) {
        function getDefinitionAtPosition(program2, sourceFile, position) {
          var resolvedRef = getReferenceAtPosition(sourceFile, position, program2);
          var fileReferenceDefinition = resolvedRef && [getDefinitionInfoForFileReference(resolvedRef.reference.fileName, resolvedRef.fileName, resolvedRef.unverified)] || ts3.emptyArray;
          if (resolvedRef === null || resolvedRef === void 0 ? void 0 : resolvedRef.file) {
            return fileReferenceDefinition;
          }
          var node = ts3.getTouchingPropertyName(sourceFile, position);
          if (node === sourceFile) {
            return void 0;
          }
          var parent = node.parent;
          var typeChecker = program2.getTypeChecker();
          if (ts3.isJumpStatementTarget(node)) {
            var label = ts3.getTargetLabel(node.parent, node.text);
            return label ? [createDefinitionInfoFromName(typeChecker, label, "label", node.text, void 0)] : void 0;
          }
          var symbol = getSymbol(node, typeChecker);
          if (!symbol) {
            return ts3.concatenate(fileReferenceDefinition, getDefinitionInfoForIndexSignatures(node, typeChecker));
          }
          var calledDeclaration = tryGetSignatureDeclaration(typeChecker, node);
          if (calledDeclaration && !(ts3.isJsxOpeningLikeElement(node.parent) && isConstructorLike(calledDeclaration))) {
            var sigInfo = createDefinitionFromSignatureDeclaration(typeChecker, calledDeclaration);
            if (typeChecker.getRootSymbols(symbol).some(function(s2) {
              return symbolMatchesSignature(s2, calledDeclaration);
            })) {
              return [sigInfo];
            } else {
              var defs = getDefinitionFromSymbol(typeChecker, symbol, node, calledDeclaration) || ts3.emptyArray;
              return node.kind === 105 ? __spreadArray([sigInfo], defs) : __spreadArray(__spreadArray([], defs), [sigInfo]);
            }
          }
          if (node.parent.kind === 290) {
            var shorthandSymbol_1 = typeChecker.getShorthandAssignmentValueSymbol(symbol.valueDeclaration);
            var definitions = (shorthandSymbol_1 === null || shorthandSymbol_1 === void 0 ? void 0 : shorthandSymbol_1.declarations) ? shorthandSymbol_1.declarations.map(function(decl) {
              return createDefinitionInfo(decl, typeChecker, shorthandSymbol_1, node);
            }) : ts3.emptyArray;
            return ts3.concatenate(definitions, getDefinitionFromObjectLiteralElement(typeChecker, node) || ts3.emptyArray);
          }
          if (ts3.isPropertyName(node) && ts3.isBindingElement(parent) && ts3.isObjectBindingPattern(parent.parent) && node === (parent.propertyName || parent.name)) {
            var name_3 = ts3.getNameFromPropertyName(node);
            var type3 = typeChecker.getTypeAtLocation(parent.parent);
            return name_3 === void 0 ? ts3.emptyArray : ts3.flatMap(type3.isUnion() ? type3.types : [type3], function(t2) {
              var prop = t2.getProperty(name_3);
              return prop && getDefinitionFromSymbol(typeChecker, prop, node);
            });
          }
          return ts3.concatenate(fileReferenceDefinition, getDefinitionFromObjectLiteralElement(typeChecker, node) || getDefinitionFromSymbol(typeChecker, symbol, node));
        }
        GoToDefinition2.getDefinitionAtPosition = getDefinitionAtPosition;
        function symbolMatchesSignature(s2, calledDeclaration) {
          return s2 === calledDeclaration.symbol || s2 === calledDeclaration.symbol.parent || ts3.isAssignmentExpression(calledDeclaration.parent) || !ts3.isCallLikeExpression(calledDeclaration.parent) && s2 === calledDeclaration.parent.symbol;
        }
        function getDefinitionFromObjectLiteralElement(typeChecker, node) {
          var element = ts3.getContainingObjectLiteralElement(node);
          if (element) {
            var contextualType = element && typeChecker.getContextualType(element.parent);
            if (contextualType) {
              return ts3.flatMap(ts3.getPropertySymbolsFromContextualType(element, typeChecker, contextualType, false), function(propertySymbol) {
                return getDefinitionFromSymbol(typeChecker, propertySymbol, node);
              });
            }
          }
        }
        function getReferenceAtPosition(sourceFile, position, program2) {
          var _a2, _b;
          var referencePath = findReferenceInPosition(sourceFile.referencedFiles, position);
          if (referencePath) {
            var file = program2.getSourceFileFromReference(sourceFile, referencePath);
            return file && { reference: referencePath, fileName: file.fileName, file, unverified: false };
          }
          var typeReferenceDirective = findReferenceInPosition(sourceFile.typeReferenceDirectives, position);
          if (typeReferenceDirective) {
            var reference = program2.getResolvedTypeReferenceDirectives().get(typeReferenceDirective.fileName);
            var file = reference && program2.getSourceFile(reference.resolvedFileName);
            return file && { reference: typeReferenceDirective, fileName: file.fileName, file, unverified: false };
          }
          var libReferenceDirective = findReferenceInPosition(sourceFile.libReferenceDirectives, position);
          if (libReferenceDirective) {
            var file = program2.getLibFileFromReference(libReferenceDirective);
            return file && { reference: libReferenceDirective, fileName: file.fileName, file, unverified: false };
          }
          if ((_a2 = sourceFile.resolvedModules) === null || _a2 === void 0 ? void 0 : _a2.size) {
            var node = ts3.getTokenAtPosition(sourceFile, position);
            if (ts3.isModuleSpecifierLike(node) && ts3.isExternalModuleNameRelative(node.text) && sourceFile.resolvedModules.has(node.text)) {
              var verifiedFileName = (_b = sourceFile.resolvedModules.get(node.text)) === null || _b === void 0 ? void 0 : _b.resolvedFileName;
              var fileName = verifiedFileName || ts3.resolvePath(ts3.getDirectoryPath(sourceFile.fileName), node.text);
              return {
                file: program2.getSourceFile(fileName),
                fileName,
                reference: {
                  pos: node.getStart(),
                  end: node.getEnd(),
                  fileName: node.text
                },
                unverified: !verifiedFileName
              };
            }
          }
          return void 0;
        }
        GoToDefinition2.getReferenceAtPosition = getReferenceAtPosition;
        function getTypeDefinitionAtPosition(typeChecker, sourceFile, position) {
          var node = ts3.getTouchingPropertyName(sourceFile, position);
          if (node === sourceFile) {
            return void 0;
          }
          var symbol = typeChecker.getSymbolAtLocation(node);
          if (!symbol)
            return void 0;
          var typeAtLocation = typeChecker.getTypeOfSymbolAtLocation(symbol, node);
          var returnType2 = tryGetReturnTypeOfFunction(symbol, typeAtLocation, typeChecker);
          var fromReturnType = returnType2 && definitionFromType(returnType2, typeChecker, node);
          return fromReturnType && fromReturnType.length !== 0 ? fromReturnType : definitionFromType(typeAtLocation, typeChecker, node);
        }
        GoToDefinition2.getTypeDefinitionAtPosition = getTypeDefinitionAtPosition;
        function definitionFromType(type3, checker, node) {
          return ts3.flatMap(type3.isUnion() && !(type3.flags & 32) ? type3.types : [type3], function(t2) {
            return t2.symbol && getDefinitionFromSymbol(checker, t2.symbol, node);
          });
        }
        function tryGetReturnTypeOfFunction(symbol, type3, checker) {
          if (type3.symbol === symbol || symbol.valueDeclaration && type3.symbol && ts3.isVariableDeclaration(symbol.valueDeclaration) && symbol.valueDeclaration.initializer === type3.symbol.valueDeclaration) {
            var sigs = type3.getCallSignatures();
            if (sigs.length === 1)
              return checker.getReturnTypeOfSignature(ts3.first(sigs));
          }
          return void 0;
        }
        function getDefinitionAndBoundSpan(program2, sourceFile, position) {
          var definitions = getDefinitionAtPosition(program2, sourceFile, position);
          if (!definitions || definitions.length === 0) {
            return void 0;
          }
          var comment = findReferenceInPosition(sourceFile.referencedFiles, position) || findReferenceInPosition(sourceFile.typeReferenceDirectives, position) || findReferenceInPosition(sourceFile.libReferenceDirectives, position);
          if (comment) {
            return { definitions, textSpan: ts3.createTextSpanFromRange(comment) };
          }
          var node = ts3.getTouchingPropertyName(sourceFile, position);
          var textSpan = ts3.createTextSpan(node.getStart(), node.getWidth());
          return { definitions, textSpan };
        }
        GoToDefinition2.getDefinitionAndBoundSpan = getDefinitionAndBoundSpan;
        function getDefinitionInfoForIndexSignatures(node, checker) {
          if (!ts3.isPropertyAccessExpression(node.parent) || node.parent.name !== node)
            return;
          var type3 = checker.getTypeAtLocation(node.parent.expression);
          return ts3.mapDefined(type3.isUnionOrIntersection() ? type3.types : [type3], function(nonUnionType) {
            var info = checker.getIndexInfoOfType(nonUnionType, 0);
            return info && info.declaration && createDefinitionFromSignatureDeclaration(checker, info.declaration);
          });
        }
        function getSymbol(node, checker) {
          var symbol = checker.getSymbolAtLocation(node);
          if ((symbol === null || symbol === void 0 ? void 0 : symbol.declarations) && symbol.flags & 2097152 && shouldSkipAlias(node, symbol.declarations[0])) {
            var aliased = checker.getAliasedSymbol(symbol);
            if (aliased.declarations) {
              return aliased;
            }
          }
          return symbol;
        }
        function shouldSkipAlias(node, declaration) {
          if (node.kind !== 78) {
            return false;
          }
          if (node.parent === declaration) {
            return true;
          }
          switch (declaration.kind) {
            case 263:
            case 261:
              return true;
            case 266:
              return declaration.parent.kind === 265;
            case 199:
            case 250:
              return ts3.isInJSFile(declaration) && ts3.isRequireVariableDeclaration(declaration);
            default:
              return false;
          }
        }
        function getDefinitionFromSymbol(typeChecker, symbol, node, declarationNode) {
          var filteredDeclarations = ts3.filter(symbol.declarations, function(d) {
            return d !== declarationNode && (!ts3.isAssignmentDeclaration(d) || d === symbol.valueDeclaration);
          }) || void 0;
          return getConstructSignatureDefinition() || getCallSignatureDefinition() || ts3.map(filteredDeclarations, function(declaration) {
            return createDefinitionInfo(declaration, typeChecker, symbol, node);
          });
          function getConstructSignatureDefinition() {
            if (symbol.flags & 32 && !(symbol.flags & (16 | 3)) && (ts3.isNewExpressionTarget(node) || node.kind === 132)) {
              var cls = ts3.find(filteredDeclarations, ts3.isClassLike) || ts3.Debug.fail("Expected declaration to have at least one class-like declaration");
              return getSignatureDefinition(cls.members, true);
            }
          }
          function getCallSignatureDefinition() {
            return ts3.isCallOrNewExpressionTarget(node) || ts3.isNameOfFunctionDeclaration(node) ? getSignatureDefinition(filteredDeclarations, false) : void 0;
          }
          function getSignatureDefinition(signatureDeclarations, selectConstructors) {
            if (!signatureDeclarations) {
              return void 0;
            }
            var declarations = signatureDeclarations.filter(selectConstructors ? ts3.isConstructorDeclaration : ts3.isFunctionLike);
            var declarationsWithBody = declarations.filter(function(d) {
              return !!d.body;
            });
            return declarations.length ? declarationsWithBody.length !== 0 ? declarationsWithBody.map(function(x) {
              return createDefinitionInfo(x, typeChecker, symbol, node);
            }) : [createDefinitionInfo(ts3.last(declarations), typeChecker, symbol, node)] : void 0;
          }
        }
        function createDefinitionInfo(declaration, checker, symbol, node) {
          var symbolName = checker.symbolToString(symbol);
          var symbolKind = ts3.SymbolDisplay.getSymbolKind(checker, symbol, node);
          var containerName = symbol.parent ? checker.symbolToString(symbol.parent, node) : "";
          return createDefinitionInfoFromName(checker, declaration, symbolKind, symbolName, containerName);
        }
        function createDefinitionInfoFromName(checker, declaration, symbolKind, symbolName, containerName) {
          var name = ts3.getNameOfDeclaration(declaration) || declaration;
          var sourceFile = name.getSourceFile();
          var textSpan = ts3.createTextSpanFromNode(name, sourceFile);
          return __assign(__assign({
            fileName: sourceFile.fileName,
            textSpan,
            kind: symbolKind,
            name: symbolName,
            containerKind: void 0,
            containerName
          }, ts3.FindAllReferences.toContextSpan(textSpan, sourceFile, ts3.FindAllReferences.getContextNode(declaration))), { isLocal: !isDefinitionVisible(checker, declaration) });
        }
        function isDefinitionVisible(checker, declaration) {
          if (checker.isDeclarationVisible(declaration))
            return true;
          if (!declaration.parent)
            return false;
          if (ts3.hasInitializer(declaration.parent) && declaration.parent.initializer === declaration)
            return isDefinitionVisible(checker, declaration.parent);
          switch (declaration.kind) {
            case 164:
            case 168:
            case 169:
            case 166:
              if (ts3.hasEffectiveModifier(declaration, 8))
                return false;
            case 167:
            case 289:
            case 290:
            case 201:
            case 222:
            case 210:
            case 209:
              return isDefinitionVisible(checker, declaration.parent);
            default:
              return false;
          }
        }
        function createDefinitionFromSignatureDeclaration(typeChecker, decl) {
          return createDefinitionInfo(decl, typeChecker, decl.symbol, decl);
        }
        function findReferenceInPosition(refs, pos) {
          return ts3.find(refs, function(ref2) {
            return ts3.textRangeContainsPositionInclusive(ref2, pos);
          });
        }
        GoToDefinition2.findReferenceInPosition = findReferenceInPosition;
        function getDefinitionInfoForFileReference(name, targetFileName, unverified) {
          return {
            fileName: targetFileName,
            textSpan: ts3.createTextSpanFromBounds(0, 0),
            kind: "script",
            name,
            containerName: void 0,
            containerKind: void 0,
            unverified
          };
        }
        function getAncestorCallLikeExpression(node) {
          var target = ts3.findAncestor(node, function(n2) {
            return !ts3.isRightSideOfPropertyAccess(n2);
          });
          var callLike = target === null || target === void 0 ? void 0 : target.parent;
          return callLike && ts3.isCallLikeExpression(callLike) && ts3.getInvokedExpression(callLike) === target ? callLike : void 0;
        }
        function tryGetSignatureDeclaration(typeChecker, node) {
          var callLike = getAncestorCallLikeExpression(node);
          var signature = callLike && typeChecker.getResolvedSignature(callLike);
          return ts3.tryCast(signature && signature.declaration, function(d) {
            return ts3.isFunctionLike(d) && !ts3.isFunctionTypeNode(d);
          });
        }
        function isConstructorLike(node) {
          switch (node.kind) {
            case 167:
            case 176:
            case 171:
              return true;
            default:
              return false;
          }
        }
      })(GoToDefinition = ts3.GoToDefinition || (ts3.GoToDefinition = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var JsDoc;
      (function(JsDoc2) {
        var jsDocTagNames = [
          "abstract",
          "access",
          "alias",
          "argument",
          "async",
          "augments",
          "author",
          "borrows",
          "callback",
          "class",
          "classdesc",
          "constant",
          "constructor",
          "constructs",
          "copyright",
          "default",
          "deprecated",
          "description",
          "emits",
          "enum",
          "event",
          "example",
          "exports",
          "extends",
          "external",
          "field",
          "file",
          "fileoverview",
          "fires",
          "function",
          "generator",
          "global",
          "hideconstructor",
          "host",
          "ignore",
          "implements",
          "inheritdoc",
          "inner",
          "instance",
          "interface",
          "kind",
          "lends",
          "license",
          "link",
          "listens",
          "member",
          "memberof",
          "method",
          "mixes",
          "module",
          "name",
          "namespace",
          "override",
          "package",
          "param",
          "private",
          "property",
          "protected",
          "public",
          "readonly",
          "requires",
          "returns",
          "see",
          "since",
          "static",
          "summary",
          "template",
          "this",
          "throws",
          "todo",
          "tutorial",
          "type",
          "typedef",
          "var",
          "variation",
          "version",
          "virtual",
          "yields"
        ];
        var jsDocTagNameCompletionEntries;
        var jsDocTagCompletionEntries;
        function getJsDocCommentsFromDeclarations(declarations, checker) {
          var parts = [];
          ts3.forEachUnique(declarations, function(declaration) {
            for (var _i = 0, _a2 = getCommentHavingNodes(declaration); _i < _a2.length; _i++) {
              var comment = _a2[_i].comment;
              if (comment === void 0)
                continue;
              var newparts = getDisplayPartsFromComment(comment, checker);
              if (!ts3.contains(parts, newparts, isIdenticalListOfDisplayParts)) {
                parts.push(newparts);
              }
            }
          });
          return ts3.flatten(ts3.intersperse(parts, [ts3.lineBreakPart()]));
        }
        JsDoc2.getJsDocCommentsFromDeclarations = getJsDocCommentsFromDeclarations;
        function isIdenticalListOfDisplayParts(parts1, parts2) {
          return ts3.arraysEqual(parts1, parts2, function(p1, p2) {
            return p1.kind === p2.kind && p1.text === p2.text;
          });
        }
        function getCommentHavingNodes(declaration) {
          switch (declaration.kind) {
            case 330:
            case 337:
              return [declaration];
            case 328:
            case 335:
              return [declaration, declaration.parent];
            default:
              return ts3.getJSDocCommentsAndTags(declaration);
          }
        }
        function getJsDocTagsFromDeclarations(declarations, checker) {
          var tags = [];
          ts3.forEachUnique(declarations, function(declaration) {
            for (var _i = 0, _a2 = ts3.getJSDocTags(declaration); _i < _a2.length; _i++) {
              var tag = _a2[_i];
              tags.push({ name: tag.tagName.text, text: getCommentDisplayParts(tag, checker) });
            }
          });
          return tags;
        }
        JsDoc2.getJsDocTagsFromDeclarations = getJsDocTagsFromDeclarations;
        function getDisplayPartsFromComment(comment, checker) {
          if (typeof comment === "string") {
            return [ts3.textPart(comment)];
          }
          return ts3.flatMap(comment, function(node) {
            return node.kind === 313 ? [ts3.textPart(node.text)] : ts3.buildLinkParts(node, checker);
          });
        }
        function getCommentDisplayParts(tag, checker) {
          var comment = tag.comment, kind = tag.kind;
          var namePart = getTagNameDisplayPart(kind);
          switch (kind) {
            case 319:
              return withNode(tag.class);
            case 318:
              return withNode(tag.class);
            case 334:
              return addComment(tag.typeParameters.map(function(tp) {
                return tp.getText();
              }).join(", "));
            case 333:
              return withNode(tag.typeExpression);
            case 335:
            case 328:
            case 337:
            case 330:
            case 336:
              var name = tag.name;
              return name ? withNode(name) : comment === void 0 ? void 0 : getDisplayPartsFromComment(comment, checker);
            default:
              return comment === void 0 ? void 0 : getDisplayPartsFromComment(comment, checker);
          }
          function withNode(node) {
            return addComment(node.getText());
          }
          function addComment(s2) {
            if (comment) {
              if (s2.match(/^https?$/)) {
                return __spreadArray([ts3.textPart(s2)], getDisplayPartsFromComment(comment, checker));
              } else {
                return __spreadArray([namePart(s2), ts3.spacePart()], getDisplayPartsFromComment(comment, checker));
              }
            } else {
              return [ts3.textPart(s2)];
            }
          }
        }
        function getTagNameDisplayPart(kind) {
          switch (kind) {
            case 330:
              return ts3.parameterNamePart;
            case 337:
              return ts3.propertyNamePart;
            case 334:
              return ts3.typeParameterNamePart;
            case 335:
            case 328:
              return ts3.typeAliasNamePart;
            default:
              return ts3.textPart;
          }
        }
        function getJSDocTagNameCompletions() {
          return jsDocTagNameCompletionEntries || (jsDocTagNameCompletionEntries = ts3.map(jsDocTagNames, function(tagName) {
            return {
              name: tagName,
              kind: "keyword",
              kindModifiers: "",
              sortText: ts3.Completions.SortText.LocationPriority
            };
          }));
        }
        JsDoc2.getJSDocTagNameCompletions = getJSDocTagNameCompletions;
        JsDoc2.getJSDocTagNameCompletionDetails = getJSDocTagCompletionDetails;
        function getJSDocTagCompletions() {
          return jsDocTagCompletionEntries || (jsDocTagCompletionEntries = ts3.map(jsDocTagNames, function(tagName) {
            return {
              name: "@" + tagName,
              kind: "keyword",
              kindModifiers: "",
              sortText: ts3.Completions.SortText.LocationPriority
            };
          }));
        }
        JsDoc2.getJSDocTagCompletions = getJSDocTagCompletions;
        function getJSDocTagCompletionDetails(name) {
          return {
            name,
            kind: "",
            kindModifiers: "",
            displayParts: [ts3.textPart(name)],
            documentation: ts3.emptyArray,
            tags: void 0,
            codeActions: void 0
          };
        }
        JsDoc2.getJSDocTagCompletionDetails = getJSDocTagCompletionDetails;
        function getJSDocParameterNameCompletions(tag) {
          if (!ts3.isIdentifier(tag.name)) {
            return ts3.emptyArray;
          }
          var nameThusFar = tag.name.text;
          var jsdoc = tag.parent;
          var fn = jsdoc.parent;
          if (!ts3.isFunctionLike(fn))
            return [];
          return ts3.mapDefined(fn.parameters, function(param) {
            if (!ts3.isIdentifier(param.name))
              return void 0;
            var name = param.name.text;
            if (jsdoc.tags.some(function(t2) {
              return t2 !== tag && ts3.isJSDocParameterTag(t2) && ts3.isIdentifier(t2.name) && t2.name.escapedText === name;
            }) || nameThusFar !== void 0 && !ts3.startsWith(name, nameThusFar)) {
              return void 0;
            }
            return { name, kind: "parameter", kindModifiers: "", sortText: ts3.Completions.SortText.LocationPriority };
          });
        }
        JsDoc2.getJSDocParameterNameCompletions = getJSDocParameterNameCompletions;
        function getJSDocParameterNameCompletionDetails(name) {
          return {
            name,
            kind: "parameter",
            kindModifiers: "",
            displayParts: [ts3.textPart(name)],
            documentation: ts3.emptyArray,
            tags: void 0,
            codeActions: void 0
          };
        }
        JsDoc2.getJSDocParameterNameCompletionDetails = getJSDocParameterNameCompletionDetails;
        function getDocCommentTemplateAtPosition(newLine, sourceFile, position, options) {
          var tokenAtPos = ts3.getTokenAtPosition(sourceFile, position);
          var existingDocComment = ts3.findAncestor(tokenAtPos, ts3.isJSDoc);
          if (existingDocComment && (existingDocComment.comment !== void 0 || ts3.length(existingDocComment.tags))) {
            return void 0;
          }
          var tokenStart = tokenAtPos.getStart(sourceFile);
          if (!existingDocComment && tokenStart < position) {
            return void 0;
          }
          var commentOwnerInfo = getCommentOwnerInfo(tokenAtPos, options);
          if (!commentOwnerInfo) {
            return void 0;
          }
          var commentOwner = commentOwnerInfo.commentOwner, parameters = commentOwnerInfo.parameters, hasReturn2 = commentOwnerInfo.hasReturn;
          if (commentOwner.getStart(sourceFile) < position) {
            return void 0;
          }
          var indentationStr = getIndentationStringAtPosition(sourceFile, position);
          var isJavaScriptFile = ts3.hasJSFileExtension(sourceFile.fileName);
          var tags = (parameters ? parameterDocComments(parameters || [], isJavaScriptFile, indentationStr, newLine) : "") + (hasReturn2 ? returnsDocComment(indentationStr, newLine) : "");
          var openComment = "/**";
          var closeComment = " */";
          if (tags) {
            var preamble = openComment + newLine + indentationStr + " * ";
            var endLine = tokenStart === position ? newLine + indentationStr : "";
            var result2 = preamble + newLine + tags + indentationStr + closeComment + endLine;
            return { newText: result2, caretOffset: preamble.length };
          }
          return { newText: openComment + closeComment, caretOffset: 3 };
        }
        JsDoc2.getDocCommentTemplateAtPosition = getDocCommentTemplateAtPosition;
        function getIndentationStringAtPosition(sourceFile, position) {
          var text = sourceFile.text;
          var lineStart = ts3.getLineStartPositionForPosition(position, sourceFile);
          var pos = lineStart;
          for (; pos <= position && ts3.isWhiteSpaceSingleLine(text.charCodeAt(pos)); pos++)
            ;
          return text.slice(lineStart, pos);
        }
        function parameterDocComments(parameters, isJavaScriptFile, indentationStr, newLine) {
          return parameters.map(function(_a2, i3) {
            var name = _a2.name, dotDotDotToken = _a2.dotDotDotToken;
            var paramName = name.kind === 78 ? name.text : "param" + i3;
            var type3 = isJavaScriptFile ? dotDotDotToken ? "{...any} " : "{any} " : "";
            return indentationStr + " * @param " + type3 + paramName + newLine;
          }).join("");
        }
        function returnsDocComment(indentationStr, newLine) {
          return indentationStr + " * @returns" + newLine;
        }
        function getCommentOwnerInfo(tokenAtPos, options) {
          return ts3.forEachAncestor(tokenAtPos, function(n2) {
            return getCommentOwnerInfoWorker(n2, options);
          });
        }
        function getCommentOwnerInfoWorker(commentOwner, options) {
          switch (commentOwner.kind) {
            case 252:
            case 209:
            case 166:
            case 167:
            case 165:
            case 210:
              var host = commentOwner;
              return { commentOwner, parameters: host.parameters, hasReturn: hasReturn(host, options) };
            case 289:
              return getCommentOwnerInfoWorker(commentOwner.initializer, options);
            case 253:
            case 254:
            case 163:
            case 256:
            case 292:
            case 255:
              return { commentOwner };
            case 233: {
              var varStatement = commentOwner;
              var varDeclarations = varStatement.declarationList.declarations;
              var host_1 = varDeclarations.length === 1 && varDeclarations[0].initializer ? getRightHandSideOfAssignment(varDeclarations[0].initializer) : void 0;
              return host_1 ? { commentOwner, parameters: host_1.parameters, hasReturn: hasReturn(host_1, options) } : { commentOwner };
            }
            case 298:
              return "quit";
            case 257:
              return commentOwner.parent.kind === 257 ? void 0 : { commentOwner };
            case 234:
              return getCommentOwnerInfoWorker(commentOwner.expression, options);
            case 217: {
              var be = commentOwner;
              if (ts3.getAssignmentDeclarationKind(be) === 0) {
                return "quit";
              }
              return ts3.isFunctionLike(be.right) ? { commentOwner, parameters: be.right.parameters, hasReturn: hasReturn(be.right, options) } : { commentOwner };
            }
            case 164:
              var init = commentOwner.initializer;
              if (init && (ts3.isFunctionExpression(init) || ts3.isArrowFunction(init))) {
                return { commentOwner, parameters: init.parameters, hasReturn: hasReturn(init, options) };
              }
          }
        }
        function hasReturn(node, options) {
          return !!(options === null || options === void 0 ? void 0 : options.generateReturnInDocTemplate) && (ts3.isArrowFunction(node) && ts3.isExpression(node.body) || ts3.isFunctionLikeDeclaration(node) && node.body && ts3.isBlock(node.body) && !!ts3.forEachReturnStatement(node.body, function(n2) {
            return n2;
          }));
        }
        function getRightHandSideOfAssignment(rightHandSide) {
          while (rightHandSide.kind === 208) {
            rightHandSide = rightHandSide.expression;
          }
          switch (rightHandSide.kind) {
            case 209:
            case 210:
              return rightHandSide;
            case 222:
              return ts3.find(rightHandSide.members, ts3.isConstructorDeclaration);
          }
        }
      })(JsDoc = ts3.JsDoc || (ts3.JsDoc = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var NavigateTo;
      (function(NavigateTo2) {
        function getNavigateToItems(sourceFiles, checker, cancellationToken, searchValue, maxResultCount, excludeDtsFiles) {
          var patternMatcher = ts3.createPatternMatcher(searchValue);
          if (!patternMatcher)
            return ts3.emptyArray;
          var rawItems = [];
          var _loop_6 = function(sourceFile2) {
            cancellationToken.throwIfCancellationRequested();
            if (excludeDtsFiles && sourceFile2.isDeclarationFile) {
              return "continue";
            }
            sourceFile2.getNamedDeclarations().forEach(function(declarations, name) {
              getItemsFromNamedDeclaration(patternMatcher, name, declarations, checker, sourceFile2.fileName, rawItems);
            });
          };
          for (var _i = 0, sourceFiles_4 = sourceFiles; _i < sourceFiles_4.length; _i++) {
            var sourceFile = sourceFiles_4[_i];
            _loop_6(sourceFile);
          }
          rawItems.sort(compareNavigateToItems);
          return (maxResultCount === void 0 ? rawItems : rawItems.slice(0, maxResultCount)).map(createNavigateToItem);
        }
        NavigateTo2.getNavigateToItems = getNavigateToItems;
        function getItemsFromNamedDeclaration(patternMatcher, name, declarations, checker, fileName, rawItems) {
          var match = patternMatcher.getMatchForLastSegmentOfPattern(name);
          if (!match) {
            return;
          }
          for (var _i = 0, declarations_3 = declarations; _i < declarations_3.length; _i++) {
            var declaration = declarations_3[_i];
            if (!shouldKeepItem(declaration, checker))
              continue;
            if (patternMatcher.patternContainsDots) {
              var fullMatch = patternMatcher.getFullMatch(getContainers(declaration), name);
              if (fullMatch) {
                rawItems.push({ name, fileName, matchKind: fullMatch.kind, isCaseSensitive: fullMatch.isCaseSensitive, declaration });
              }
            } else {
              rawItems.push({ name, fileName, matchKind: match.kind, isCaseSensitive: match.isCaseSensitive, declaration });
            }
          }
        }
        function shouldKeepItem(declaration, checker) {
          switch (declaration.kind) {
            case 263:
            case 266:
            case 261:
              var importer = checker.getSymbolAtLocation(declaration.name);
              var imported = checker.getAliasedSymbol(importer);
              return importer.escapedName !== imported.escapedName;
            default:
              return true;
          }
        }
        function tryAddSingleDeclarationName(declaration, containers) {
          var name = ts3.getNameOfDeclaration(declaration);
          return !!name && (pushLiteral(name, containers) || name.kind === 159 && tryAddComputedPropertyName(name.expression, containers));
        }
        function tryAddComputedPropertyName(expression, containers) {
          return pushLiteral(expression, containers) || ts3.isPropertyAccessExpression(expression) && (containers.push(expression.name.text), true) && tryAddComputedPropertyName(expression.expression, containers);
        }
        function pushLiteral(node, containers) {
          return ts3.isPropertyNameLiteral(node) && (containers.push(ts3.getTextOfIdentifierOrLiteral(node)), true);
        }
        function getContainers(declaration) {
          var containers = [];
          var name = ts3.getNameOfDeclaration(declaration);
          if (name && name.kind === 159 && !tryAddComputedPropertyName(name.expression, containers)) {
            return ts3.emptyArray;
          }
          containers.shift();
          var container = ts3.getContainerNode(declaration);
          while (container) {
            if (!tryAddSingleDeclarationName(container, containers)) {
              return ts3.emptyArray;
            }
            container = ts3.getContainerNode(container);
          }
          return containers.reverse();
        }
        function compareNavigateToItems(i1, i22) {
          return ts3.compareValues(i1.matchKind, i22.matchKind) || ts3.compareStringsCaseSensitiveUI(i1.name, i22.name);
        }
        function createNavigateToItem(rawItem) {
          var declaration = rawItem.declaration;
          var container = ts3.getContainerNode(declaration);
          var containerName = container && ts3.getNameOfDeclaration(container);
          return {
            name: rawItem.name,
            kind: ts3.getNodeKind(declaration),
            kindModifiers: ts3.getNodeModifiers(declaration),
            matchKind: ts3.PatternMatchKind[rawItem.matchKind],
            isCaseSensitive: rawItem.isCaseSensitive,
            fileName: rawItem.fileName,
            textSpan: ts3.createTextSpanFromNode(declaration),
            containerName: containerName ? containerName.text : "",
            containerKind: containerName ? ts3.getNodeKind(container) : ""
          };
        }
      })(NavigateTo = ts3.NavigateTo || (ts3.NavigateTo = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var NavigationBar;
      (function(NavigationBar2) {
        var _a2;
        var whiteSpaceRegex = /\s+/g;
        var maxLength = 150;
        var curCancellationToken;
        var curSourceFile;
        var parentsStack = [];
        var parent;
        var trackedEs5ClassesStack = [];
        var trackedEs5Classes;
        var emptyChildItemArray = [];
        function getNavigationBarItems(sourceFile, cancellationToken) {
          curCancellationToken = cancellationToken;
          curSourceFile = sourceFile;
          try {
            return ts3.map(primaryNavBarMenuItems(rootNavigationBarNode(sourceFile)), convertToPrimaryNavBarMenuItem);
          } finally {
            reset();
          }
        }
        NavigationBar2.getNavigationBarItems = getNavigationBarItems;
        function getNavigationTree(sourceFile, cancellationToken) {
          curCancellationToken = cancellationToken;
          curSourceFile = sourceFile;
          try {
            return convertToTree(rootNavigationBarNode(sourceFile));
          } finally {
            reset();
          }
        }
        NavigationBar2.getNavigationTree = getNavigationTree;
        function reset() {
          curSourceFile = void 0;
          curCancellationToken = void 0;
          parentsStack = [];
          parent = void 0;
          emptyChildItemArray = [];
        }
        function nodeText(node) {
          return cleanText(node.getText(curSourceFile));
        }
        function navigationBarNodeKind(n2) {
          return n2.node.kind;
        }
        function pushChild(parent2, child) {
          if (parent2.children) {
            parent2.children.push(child);
          } else {
            parent2.children = [child];
          }
        }
        function rootNavigationBarNode(sourceFile) {
          ts3.Debug.assert(!parentsStack.length);
          var root = { node: sourceFile, name: void 0, additionalNodes: void 0, parent: void 0, children: void 0, indent: 0 };
          parent = root;
          for (var _i = 0, _a3 = sourceFile.statements; _i < _a3.length; _i++) {
            var statement = _a3[_i];
            addChildrenRecursively(statement);
          }
          endNode();
          ts3.Debug.assert(!parent && !parentsStack.length);
          return root;
        }
        function addLeafNode(node, name) {
          pushChild(parent, emptyNavigationBarNode(node, name));
        }
        function emptyNavigationBarNode(node, name) {
          return {
            node,
            name: name || (ts3.isDeclaration(node) || ts3.isExpression(node) ? ts3.getNameOfDeclaration(node) : void 0),
            additionalNodes: void 0,
            parent,
            children: void 0,
            indent: parent.indent + 1
          };
        }
        function addTrackedEs5Class(name) {
          if (!trackedEs5Classes) {
            trackedEs5Classes = new ts3.Map();
          }
          trackedEs5Classes.set(name, true);
        }
        function endNestedNodes(depth) {
          for (var i3 = 0; i3 < depth; i3++)
            endNode();
        }
        function startNestedNodes(targetNode, entityName) {
          var names = [];
          while (!ts3.isPropertyNameLiteral(entityName)) {
            var name = ts3.getNameOrArgument(entityName);
            var nameText = ts3.getElementOrPropertyAccessName(entityName);
            entityName = entityName.expression;
            if (nameText === "prototype" || ts3.isPrivateIdentifier(name))
              continue;
            names.push(name);
          }
          names.push(entityName);
          for (var i3 = names.length - 1; i3 > 0; i3--) {
            var name = names[i3];
            startNode(targetNode, name);
          }
          return [names.length - 1, names[0]];
        }
        function startNode(node, name) {
          var navNode = emptyNavigationBarNode(node, name);
          pushChild(parent, navNode);
          parentsStack.push(parent);
          trackedEs5ClassesStack.push(trackedEs5Classes);
          trackedEs5Classes = void 0;
          parent = navNode;
        }
        function endNode() {
          if (parent.children) {
            mergeChildren(parent.children, parent);
            sortChildren(parent.children);
          }
          parent = parentsStack.pop();
          trackedEs5Classes = trackedEs5ClassesStack.pop();
        }
        function addNodeWithRecursiveChild(node, child, name) {
          startNode(node, name);
          addChildrenRecursively(child);
          endNode();
        }
        function addNodeWithRecursiveInitializer(node) {
          if (node.initializer && isFunctionOrClassExpression(node.initializer)) {
            startNode(node);
            ts3.forEachChild(node.initializer, addChildrenRecursively);
            endNode();
          } else {
            addNodeWithRecursiveChild(node, node.initializer);
          }
        }
        function hasNavigationBarName(node) {
          return !ts3.hasDynamicName(node) || node.kind !== 217 && ts3.isPropertyAccessExpression(node.name.expression) && ts3.isIdentifier(node.name.expression.expression) && ts3.idText(node.name.expression.expression) === "Symbol";
        }
        function addChildrenRecursively(node) {
          var _a3;
          curCancellationToken.throwIfCancellationRequested();
          if (!node || ts3.isToken(node)) {
            return;
          }
          switch (node.kind) {
            case 167:
              var ctr = node;
              addNodeWithRecursiveChild(ctr, ctr.body);
              for (var _i = 0, _b = ctr.parameters; _i < _b.length; _i++) {
                var param = _b[_i];
                if (ts3.isParameterPropertyDeclaration(param, ctr)) {
                  addLeafNode(param);
                }
              }
              break;
            case 166:
            case 168:
            case 169:
            case 165:
              if (hasNavigationBarName(node)) {
                addNodeWithRecursiveChild(node, node.body);
              }
              break;
            case 164:
              if (hasNavigationBarName(node)) {
                addNodeWithRecursiveInitializer(node);
              }
              break;
            case 163:
              if (hasNavigationBarName(node)) {
                addLeafNode(node);
              }
              break;
            case 263:
              var importClause = node;
              if (importClause.name) {
                addLeafNode(importClause.name);
              }
              var namedBindings = importClause.namedBindings;
              if (namedBindings) {
                if (namedBindings.kind === 264) {
                  addLeafNode(namedBindings);
                } else {
                  for (var _c = 0, _d = namedBindings.elements; _c < _d.length; _c++) {
                    var element = _d[_c];
                    addLeafNode(element);
                  }
                }
              }
              break;
            case 290:
              addNodeWithRecursiveChild(node, node.name);
              break;
            case 291:
              var expression = node.expression;
              ts3.isIdentifier(expression) ? addLeafNode(node, expression) : addLeafNode(node);
              break;
            case 199:
            case 289:
            case 250: {
              var child = node;
              if (ts3.isBindingPattern(child.name)) {
                addChildrenRecursively(child.name);
              } else {
                addNodeWithRecursiveInitializer(child);
              }
              break;
            }
            case 252:
              var nameNode = node.name;
              if (nameNode && ts3.isIdentifier(nameNode)) {
                addTrackedEs5Class(nameNode.text);
              }
              addNodeWithRecursiveChild(node, node.body);
              break;
            case 210:
            case 209:
              addNodeWithRecursiveChild(node, node.body);
              break;
            case 256:
              startNode(node);
              for (var _e = 0, _f = node.members; _e < _f.length; _e++) {
                var member = _f[_e];
                if (!isComputedProperty(member)) {
                  addLeafNode(member);
                }
              }
              endNode();
              break;
            case 253:
            case 222:
            case 254:
              startNode(node);
              for (var _g = 0, _h = node.members; _g < _h.length; _g++) {
                var member = _h[_g];
                addChildrenRecursively(member);
              }
              endNode();
              break;
            case 257:
              addNodeWithRecursiveChild(node, getInteriorModule(node).body);
              break;
            case 267: {
              var expression_1 = node.expression;
              var child = ts3.isObjectLiteralExpression(expression_1) || ts3.isCallExpression(expression_1) ? expression_1 : ts3.isArrowFunction(expression_1) || ts3.isFunctionExpression(expression_1) ? expression_1.body : void 0;
              if (child) {
                startNode(node);
                addChildrenRecursively(child);
                endNode();
              } else {
                addLeafNode(node);
              }
              break;
            }
            case 271:
            case 261:
            case 172:
            case 170:
            case 171:
            case 255:
              addLeafNode(node);
              break;
            case 204:
            case 217: {
              var special = ts3.getAssignmentDeclarationKind(node);
              switch (special) {
                case 1:
                case 2:
                  addNodeWithRecursiveChild(node, node.right);
                  return;
                case 6:
                case 3: {
                  var binaryExpression = node;
                  var assignmentTarget = binaryExpression.left;
                  var prototypeAccess = special === 3 ? assignmentTarget.expression : assignmentTarget;
                  var depth = 0;
                  var className = void 0;
                  if (ts3.isIdentifier(prototypeAccess.expression)) {
                    addTrackedEs5Class(prototypeAccess.expression.text);
                    className = prototypeAccess.expression;
                  } else {
                    _a3 = startNestedNodes(binaryExpression, prototypeAccess.expression), depth = _a3[0], className = _a3[1];
                  }
                  if (special === 6) {
                    if (ts3.isObjectLiteralExpression(binaryExpression.right)) {
                      if (binaryExpression.right.properties.length > 0) {
                        startNode(binaryExpression, className);
                        ts3.forEachChild(binaryExpression.right, addChildrenRecursively);
                        endNode();
                      }
                    }
                  } else if (ts3.isFunctionExpression(binaryExpression.right) || ts3.isArrowFunction(binaryExpression.right)) {
                    addNodeWithRecursiveChild(node, binaryExpression.right, className);
                  } else {
                    startNode(binaryExpression, className);
                    addNodeWithRecursiveChild(node, binaryExpression.right, assignmentTarget.name);
                    endNode();
                  }
                  endNestedNodes(depth);
                  return;
                }
                case 7:
                case 9: {
                  var defineCall = node;
                  var className = special === 7 ? defineCall.arguments[0] : defineCall.arguments[0].expression;
                  var memberName = defineCall.arguments[1];
                  var _j = startNestedNodes(node, className), depth = _j[0], classNameIdentifier = _j[1];
                  startNode(node, classNameIdentifier);
                  startNode(node, ts3.setTextRange(ts3.factory.createIdentifier(memberName.text), memberName));
                  addChildrenRecursively(node.arguments[2]);
                  endNode();
                  endNode();
                  endNestedNodes(depth);
                  return;
                }
                case 5: {
                  var binaryExpression = node;
                  var assignmentTarget = binaryExpression.left;
                  var targetFunction = assignmentTarget.expression;
                  if (ts3.isIdentifier(targetFunction) && ts3.getElementOrPropertyAccessName(assignmentTarget) !== "prototype" && trackedEs5Classes && trackedEs5Classes.has(targetFunction.text)) {
                    if (ts3.isFunctionExpression(binaryExpression.right) || ts3.isArrowFunction(binaryExpression.right)) {
                      addNodeWithRecursiveChild(node, binaryExpression.right, targetFunction);
                    } else if (ts3.isBindableStaticAccessExpression(assignmentTarget)) {
                      startNode(binaryExpression, targetFunction);
                      addNodeWithRecursiveChild(binaryExpression.left, binaryExpression.right, ts3.getNameOrArgument(assignmentTarget));
                      endNode();
                    }
                    return;
                  }
                  break;
                }
                case 4:
                case 0:
                case 8:
                  break;
                default:
                  ts3.Debug.assertNever(special);
              }
            }
            default:
              if (ts3.hasJSDocNodes(node)) {
                ts3.forEach(node.jsDoc, function(jsDoc) {
                  ts3.forEach(jsDoc.tags, function(tag) {
                    if (ts3.isJSDocTypeAlias(tag)) {
                      addLeafNode(tag);
                    }
                  });
                });
              }
              ts3.forEachChild(node, addChildrenRecursively);
          }
        }
        function mergeChildren(children, node) {
          var nameToItems = new ts3.Map();
          ts3.filterMutate(children, function(child, index) {
            var declName = child.name || ts3.getNameOfDeclaration(child.node);
            var name = declName && nodeText(declName);
            if (!name) {
              return true;
            }
            var itemsWithSameName = nameToItems.get(name);
            if (!itemsWithSameName) {
              nameToItems.set(name, child);
              return true;
            }
            if (itemsWithSameName instanceof Array) {
              for (var _i = 0, itemsWithSameName_1 = itemsWithSameName; _i < itemsWithSameName_1.length; _i++) {
                var itemWithSameName = itemsWithSameName_1[_i];
                if (tryMerge(itemWithSameName, child, index, node)) {
                  return false;
                }
              }
              itemsWithSameName.push(child);
              return true;
            } else {
              var itemWithSameName = itemsWithSameName;
              if (tryMerge(itemWithSameName, child, index, node)) {
                return false;
              }
              nameToItems.set(name, [itemWithSameName, child]);
              return true;
            }
          });
        }
        var isEs5ClassMember = (_a2 = {}, _a2[5] = true, _a2[3] = true, _a2[7] = true, _a2[9] = true, _a2[0] = false, _a2[1] = false, _a2[2] = false, _a2[8] = false, _a2[6] = true, _a2[4] = false, _a2);
        function tryMergeEs5Class(a2, b2, bIndex, parent2) {
          function isPossibleConstructor(node) {
            return ts3.isFunctionExpression(node) || ts3.isFunctionDeclaration(node) || ts3.isVariableDeclaration(node);
          }
          var bAssignmentDeclarationKind = ts3.isBinaryExpression(b2.node) || ts3.isCallExpression(b2.node) ? ts3.getAssignmentDeclarationKind(b2.node) : 0;
          var aAssignmentDeclarationKind = ts3.isBinaryExpression(a2.node) || ts3.isCallExpression(a2.node) ? ts3.getAssignmentDeclarationKind(a2.node) : 0;
          if (isEs5ClassMember[bAssignmentDeclarationKind] && isEs5ClassMember[aAssignmentDeclarationKind] || isPossibleConstructor(a2.node) && isEs5ClassMember[bAssignmentDeclarationKind] || isPossibleConstructor(b2.node) && isEs5ClassMember[aAssignmentDeclarationKind] || ts3.isClassDeclaration(a2.node) && isSynthesized(a2.node) && isEs5ClassMember[bAssignmentDeclarationKind] || ts3.isClassDeclaration(b2.node) && isEs5ClassMember[aAssignmentDeclarationKind] || ts3.isClassDeclaration(a2.node) && isSynthesized(a2.node) && isPossibleConstructor(b2.node) || ts3.isClassDeclaration(b2.node) && isPossibleConstructor(a2.node) && isSynthesized(a2.node)) {
            var lastANode = a2.additionalNodes && ts3.lastOrUndefined(a2.additionalNodes) || a2.node;
            if (!ts3.isClassDeclaration(a2.node) && !ts3.isClassDeclaration(b2.node) || isPossibleConstructor(a2.node) || isPossibleConstructor(b2.node)) {
              var ctorFunction = isPossibleConstructor(a2.node) ? a2.node : isPossibleConstructor(b2.node) ? b2.node : void 0;
              if (ctorFunction !== void 0) {
                var ctorNode = ts3.setTextRange(ts3.factory.createConstructorDeclaration(void 0, void 0, [], void 0), ctorFunction);
                var ctor = emptyNavigationBarNode(ctorNode);
                ctor.indent = a2.indent + 1;
                ctor.children = a2.node === ctorFunction ? a2.children : b2.children;
                a2.children = a2.node === ctorFunction ? ts3.concatenate([ctor], b2.children || [b2]) : ts3.concatenate(a2.children || [__assign({}, a2)], [ctor]);
              } else {
                if (a2.children || b2.children) {
                  a2.children = ts3.concatenate(a2.children || [__assign({}, a2)], b2.children || [b2]);
                  if (a2.children) {
                    mergeChildren(a2.children, a2);
                    sortChildren(a2.children);
                  }
                }
              }
              lastANode = a2.node = ts3.setTextRange(ts3.factory.createClassDeclaration(void 0, void 0, a2.name || ts3.factory.createIdentifier("__class__"), void 0, void 0, []), a2.node);
            } else {
              a2.children = ts3.concatenate(a2.children, b2.children);
              if (a2.children) {
                mergeChildren(a2.children, a2);
              }
            }
            var bNode = b2.node;
            if (parent2.children[bIndex - 1].node.end === lastANode.end) {
              ts3.setTextRange(lastANode, { pos: lastANode.pos, end: bNode.end });
            } else {
              if (!a2.additionalNodes)
                a2.additionalNodes = [];
              a2.additionalNodes.push(ts3.setTextRange(ts3.factory.createClassDeclaration(void 0, void 0, a2.name || ts3.factory.createIdentifier("__class__"), void 0, void 0, []), b2.node));
            }
            return true;
          }
          return bAssignmentDeclarationKind === 0 ? false : true;
        }
        function tryMerge(a2, b2, bIndex, parent2) {
          if (tryMergeEs5Class(a2, b2, bIndex, parent2)) {
            return true;
          }
          if (shouldReallyMerge(a2.node, b2.node, parent2)) {
            merge2(a2, b2);
            return true;
          }
          return false;
        }
        function shouldReallyMerge(a2, b2, parent2) {
          if (a2.kind !== b2.kind || a2.parent !== b2.parent && !(isOwnChild(a2, parent2) && isOwnChild(b2, parent2))) {
            return false;
          }
          switch (a2.kind) {
            case 164:
            case 166:
            case 168:
            case 169:
              return ts3.hasSyntacticModifier(a2, 32) === ts3.hasSyntacticModifier(b2, 32);
            case 257:
              return areSameModule(a2, b2) && getFullyQualifiedModuleName(a2) === getFullyQualifiedModuleName(b2);
            default:
              return true;
          }
        }
        function isSynthesized(node) {
          return !!(node.flags & 8);
        }
        function isOwnChild(n2, parent2) {
          var par = ts3.isModuleBlock(n2.parent) ? n2.parent.parent : n2.parent;
          return par === parent2.node || ts3.contains(parent2.additionalNodes, par);
        }
        function areSameModule(a2, b2) {
          return a2.body.kind === b2.body.kind && (a2.body.kind !== 257 || areSameModule(a2.body, b2.body));
        }
        function merge2(target, source) {
          var _a3;
          target.additionalNodes = target.additionalNodes || [];
          target.additionalNodes.push(source.node);
          if (source.additionalNodes) {
            (_a3 = target.additionalNodes).push.apply(_a3, source.additionalNodes);
          }
          target.children = ts3.concatenate(target.children, source.children);
          if (target.children) {
            mergeChildren(target.children, target);
            sortChildren(target.children);
          }
        }
        function sortChildren(children) {
          children.sort(compareChildren);
        }
        function compareChildren(child1, child2) {
          return ts3.compareStringsCaseSensitiveUI(tryGetName(child1.node), tryGetName(child2.node)) || ts3.compareValues(navigationBarNodeKind(child1), navigationBarNodeKind(child2));
        }
        function tryGetName(node) {
          if (node.kind === 257) {
            return getModuleName(node);
          }
          var declName = ts3.getNameOfDeclaration(node);
          if (declName && ts3.isPropertyName(declName)) {
            var propertyName = ts3.getPropertyNameForPropertyNameNode(declName);
            return propertyName && ts3.unescapeLeadingUnderscores(propertyName);
          }
          switch (node.kind) {
            case 209:
            case 210:
            case 222:
              return getFunctionOrClassName(node);
            default:
              return void 0;
          }
        }
        function getItemName(node, name) {
          if (node.kind === 257) {
            return cleanText(getModuleName(node));
          }
          if (name) {
            var text = ts3.isIdentifier(name) ? name.text : ts3.isElementAccessExpression(name) ? "[" + nodeText(name.argumentExpression) + "]" : nodeText(name);
            if (text.length > 0) {
              return cleanText(text);
            }
          }
          switch (node.kind) {
            case 298:
              var sourceFile = node;
              return ts3.isExternalModule(sourceFile) ? '"' + ts3.escapeString(ts3.getBaseFileName(ts3.removeFileExtension(ts3.normalizePath(sourceFile.fileName)))) + '"' : "<global>";
            case 267:
              return ts3.isExportAssignment(node) && node.isExportEquals ? "export=" : "default";
            case 210:
            case 252:
            case 209:
            case 253:
            case 222:
              if (ts3.getSyntacticModifierFlags(node) & 512) {
                return "default";
              }
              return getFunctionOrClassName(node);
            case 167:
              return "constructor";
            case 171:
              return "new()";
            case 170:
              return "()";
            case 172:
              return "[]";
            default:
              return "<unknown>";
          }
        }
        function primaryNavBarMenuItems(root) {
          var primaryNavBarMenuItems2 = [];
          function recur(item) {
            if (shouldAppearInPrimaryNavBarMenu(item)) {
              primaryNavBarMenuItems2.push(item);
              if (item.children) {
                for (var _i = 0, _a3 = item.children; _i < _a3.length; _i++) {
                  var child = _a3[_i];
                  recur(child);
                }
              }
            }
          }
          recur(root);
          return primaryNavBarMenuItems2;
          function shouldAppearInPrimaryNavBarMenu(item) {
            if (item.children) {
              return true;
            }
            switch (navigationBarNodeKind(item)) {
              case 253:
              case 222:
              case 256:
              case 254:
              case 257:
              case 298:
              case 255:
              case 335:
              case 328:
                return true;
              case 210:
              case 252:
              case 209:
                return isTopLevelFunctionDeclaration(item);
              default:
                return false;
            }
            function isTopLevelFunctionDeclaration(item2) {
              if (!item2.node.body) {
                return false;
              }
              switch (navigationBarNodeKind(item2.parent)) {
                case 258:
                case 298:
                case 166:
                case 167:
                  return true;
                default:
                  return false;
              }
            }
          }
        }
        function convertToTree(n2) {
          return {
            text: getItemName(n2.node, n2.name),
            kind: ts3.getNodeKind(n2.node),
            kindModifiers: getModifiers(n2.node),
            spans: getSpans(n2),
            nameSpan: n2.name && getNodeSpan(n2.name),
            childItems: ts3.map(n2.children, convertToTree)
          };
        }
        function convertToPrimaryNavBarMenuItem(n2) {
          return {
            text: getItemName(n2.node, n2.name),
            kind: ts3.getNodeKind(n2.node),
            kindModifiers: getModifiers(n2.node),
            spans: getSpans(n2),
            childItems: ts3.map(n2.children, convertToSecondaryNavBarMenuItem) || emptyChildItemArray,
            indent: n2.indent,
            bolded: false,
            grayed: false
          };
          function convertToSecondaryNavBarMenuItem(n3) {
            return {
              text: getItemName(n3.node, n3.name),
              kind: ts3.getNodeKind(n3.node),
              kindModifiers: ts3.getNodeModifiers(n3.node),
              spans: getSpans(n3),
              childItems: emptyChildItemArray,
              indent: 0,
              bolded: false,
              grayed: false
            };
          }
        }
        function getSpans(n2) {
          var spans = [getNodeSpan(n2.node)];
          if (n2.additionalNodes) {
            for (var _i = 0, _a3 = n2.additionalNodes; _i < _a3.length; _i++) {
              var node = _a3[_i];
              spans.push(getNodeSpan(node));
            }
          }
          return spans;
        }
        function getModuleName(moduleDeclaration) {
          if (ts3.isAmbientModule(moduleDeclaration)) {
            return ts3.getTextOfNode(moduleDeclaration.name);
          }
          return getFullyQualifiedModuleName(moduleDeclaration);
        }
        function getFullyQualifiedModuleName(moduleDeclaration) {
          var result2 = [ts3.getTextOfIdentifierOrLiteral(moduleDeclaration.name)];
          while (moduleDeclaration.body && moduleDeclaration.body.kind === 257) {
            moduleDeclaration = moduleDeclaration.body;
            result2.push(ts3.getTextOfIdentifierOrLiteral(moduleDeclaration.name));
          }
          return result2.join(".");
        }
        function getInteriorModule(decl) {
          return decl.body && ts3.isModuleDeclaration(decl.body) ? getInteriorModule(decl.body) : decl;
        }
        function isComputedProperty(member) {
          return !member.name || member.name.kind === 159;
        }
        function getNodeSpan(node) {
          return node.kind === 298 ? ts3.createTextSpanFromRange(node) : ts3.createTextSpanFromNode(node, curSourceFile);
        }
        function getModifiers(node) {
          if (node.parent && node.parent.kind === 250) {
            node = node.parent;
          }
          return ts3.getNodeModifiers(node);
        }
        function getFunctionOrClassName(node) {
          var parent2 = node.parent;
          if (node.name && ts3.getFullWidth(node.name) > 0) {
            return cleanText(ts3.declarationNameToString(node.name));
          } else if (ts3.isVariableDeclaration(parent2)) {
            return cleanText(ts3.declarationNameToString(parent2.name));
          } else if (ts3.isBinaryExpression(parent2) && parent2.operatorToken.kind === 62) {
            return nodeText(parent2.left).replace(whiteSpaceRegex, "");
          } else if (ts3.isPropertyAssignment(parent2)) {
            return nodeText(parent2.name);
          } else if (ts3.getSyntacticModifierFlags(node) & 512) {
            return "default";
          } else if (ts3.isClassLike(node)) {
            return "<class>";
          } else if (ts3.isCallExpression(parent2)) {
            var name = getCalledExpressionName(parent2.expression);
            if (name !== void 0) {
              name = cleanText(name);
              if (name.length > maxLength) {
                return name + " callback";
              }
              var args = cleanText(ts3.mapDefined(parent2.arguments, function(a2) {
                return ts3.isStringLiteralLike(a2) ? a2.getText(curSourceFile) : void 0;
              }).join(", "));
              return name + "(" + args + ") callback";
            }
          }
          return "<function>";
        }
        function getCalledExpressionName(expr) {
          if (ts3.isIdentifier(expr)) {
            return expr.text;
          } else if (ts3.isPropertyAccessExpression(expr)) {
            var left = getCalledExpressionName(expr.expression);
            var right = expr.name.text;
            return left === void 0 ? right : left + "." + right;
          } else {
            return void 0;
          }
        }
        function isFunctionOrClassExpression(node) {
          switch (node.kind) {
            case 210:
            case 209:
            case 222:
              return true;
            default:
              return false;
          }
        }
        function cleanText(text) {
          text = text.length > maxLength ? text.substring(0, maxLength) + "..." : text;
          return text.replace(/\\?(\r?\n|\r|\u2028|\u2029)/g, "");
        }
      })(NavigationBar = ts3.NavigationBar || (ts3.NavigationBar = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var OrganizeImports;
      (function(OrganizeImports2) {
        function organizeImports(sourceFile, formatContext, host, program2, preferences, skipDestructiveCodeActions) {
          var changeTracker = ts3.textChanges.ChangeTracker.fromContext({ host, formatContext, preferences });
          var coalesceAndOrganizeImports = function(importGroup) {
            return ts3.stableSort(coalesceImports(removeUnusedImports(importGroup, sourceFile, program2, skipDestructiveCodeActions)), function(s1, s2) {
              return compareImportsOrRequireStatements(s1, s2);
            });
          };
          var topLevelImportDecls = sourceFile.statements.filter(ts3.isImportDeclaration);
          organizeImportsWorker(topLevelImportDecls, coalesceAndOrganizeImports);
          var topLevelExportDecls = sourceFile.statements.filter(ts3.isExportDeclaration);
          organizeImportsWorker(topLevelExportDecls, coalesceExports);
          for (var _i = 0, _a2 = sourceFile.statements.filter(ts3.isAmbientModule); _i < _a2.length; _i++) {
            var ambientModule = _a2[_i];
            if (!ambientModule.body) {
              continue;
            }
            var ambientModuleImportDecls = ambientModule.body.statements.filter(ts3.isImportDeclaration);
            organizeImportsWorker(ambientModuleImportDecls, coalesceAndOrganizeImports);
            var ambientModuleExportDecls = ambientModule.body.statements.filter(ts3.isExportDeclaration);
            organizeImportsWorker(ambientModuleExportDecls, coalesceExports);
          }
          return changeTracker.getChanges();
          function organizeImportsWorker(oldImportDecls, coalesce) {
            if (ts3.length(oldImportDecls) === 0) {
              return;
            }
            ts3.suppressLeadingTrivia(oldImportDecls[0]);
            var oldImportGroups = ts3.group(oldImportDecls, function(importDecl) {
              return getExternalModuleName(importDecl.moduleSpecifier);
            });
            var sortedImportGroups = ts3.stableSort(oldImportGroups, function(group1, group2) {
              return compareModuleSpecifiers(group1[0].moduleSpecifier, group2[0].moduleSpecifier);
            });
            var newImportDecls = ts3.flatMap(sortedImportGroups, function(importGroup) {
              return getExternalModuleName(importGroup[0].moduleSpecifier) ? coalesce(importGroup) : importGroup;
            });
            if (newImportDecls.length === 0) {
              changeTracker.deleteNodes(sourceFile, oldImportDecls, {
                trailingTriviaOption: ts3.textChanges.TrailingTriviaOption.Include
              }, true);
            } else {
              var replaceOptions = {
                leadingTriviaOption: ts3.textChanges.LeadingTriviaOption.Exclude,
                trailingTriviaOption: ts3.textChanges.TrailingTriviaOption.Include,
                suffix: ts3.getNewLineOrDefaultFromHost(host, formatContext.options)
              };
              changeTracker.replaceNodeWithNodes(sourceFile, oldImportDecls[0], newImportDecls, replaceOptions);
              var hasTrailingComment = changeTracker.nodeHasTrailingComment(sourceFile, oldImportDecls[0], replaceOptions);
              changeTracker.deleteNodes(sourceFile, oldImportDecls.slice(1), {
                trailingTriviaOption: ts3.textChanges.TrailingTriviaOption.Include
              }, hasTrailingComment);
            }
          }
        }
        OrganizeImports2.organizeImports = organizeImports;
        function removeUnusedImports(oldImports, sourceFile, program2, skipDestructiveCodeActions) {
          if (skipDestructiveCodeActions) {
            return oldImports;
          }
          var typeChecker = program2.getTypeChecker();
          var jsxNamespace = typeChecker.getJsxNamespace(sourceFile);
          var jsxFragmentFactory = typeChecker.getJsxFragmentFactory(sourceFile);
          var jsxElementsPresent = !!(sourceFile.transformFlags & 2);
          var usedImports = [];
          for (var _i = 0, oldImports_1 = oldImports; _i < oldImports_1.length; _i++) {
            var importDecl = oldImports_1[_i];
            var importClause = importDecl.importClause, moduleSpecifier = importDecl.moduleSpecifier;
            if (!importClause) {
              usedImports.push(importDecl);
              continue;
            }
            var name = importClause.name, namedBindings = importClause.namedBindings;
            if (name && !isDeclarationUsed(name)) {
              name = void 0;
            }
            if (namedBindings) {
              if (ts3.isNamespaceImport(namedBindings)) {
                if (!isDeclarationUsed(namedBindings.name)) {
                  namedBindings = void 0;
                }
              } else {
                var newElements = namedBindings.elements.filter(function(e2) {
                  return isDeclarationUsed(e2.name);
                });
                if (newElements.length < namedBindings.elements.length) {
                  namedBindings = newElements.length ? ts3.factory.updateNamedImports(namedBindings, newElements) : void 0;
                }
              }
            }
            if (name || namedBindings) {
              usedImports.push(updateImportDeclarationAndClause(importDecl, name, namedBindings));
            } else if (hasModuleDeclarationMatchingSpecifier(sourceFile, moduleSpecifier)) {
              if (sourceFile.isDeclarationFile) {
                usedImports.push(ts3.factory.createImportDeclaration(importDecl.decorators, importDecl.modifiers, void 0, moduleSpecifier));
              } else {
                usedImports.push(importDecl);
              }
            }
          }
          return usedImports;
          function isDeclarationUsed(identifier) {
            return jsxElementsPresent && (identifier.text === jsxNamespace || jsxFragmentFactory && identifier.text === jsxFragmentFactory) || ts3.FindAllReferences.Core.isSymbolReferencedInFile(identifier, typeChecker, sourceFile);
          }
        }
        function hasModuleDeclarationMatchingSpecifier(sourceFile, moduleSpecifier) {
          var moduleSpecifierText = ts3.isStringLiteral(moduleSpecifier) && moduleSpecifier.text;
          return ts3.isString(moduleSpecifierText) && ts3.some(sourceFile.moduleAugmentations, function(moduleName) {
            return ts3.isStringLiteral(moduleName) && moduleName.text === moduleSpecifierText;
          });
        }
        function getExternalModuleName(specifier) {
          return specifier !== void 0 && ts3.isStringLiteralLike(specifier) ? specifier.text : void 0;
        }
        function coalesceImports(importGroup) {
          var _a2;
          if (importGroup.length === 0) {
            return importGroup;
          }
          var _b = getCategorizedImports(importGroup), importWithoutClause = _b.importWithoutClause, typeOnlyImports = _b.typeOnlyImports, regularImports = _b.regularImports;
          var coalescedImports = [];
          if (importWithoutClause) {
            coalescedImports.push(importWithoutClause);
          }
          for (var _i = 0, _c = [regularImports, typeOnlyImports]; _i < _c.length; _i++) {
            var group_2 = _c[_i];
            var isTypeOnly = group_2 === typeOnlyImports;
            var defaultImports = group_2.defaultImports, namespaceImports = group_2.namespaceImports, namedImports = group_2.namedImports;
            if (!isTypeOnly && defaultImports.length === 1 && namespaceImports.length === 1 && namedImports.length === 0) {
              var defaultImport = defaultImports[0];
              coalescedImports.push(updateImportDeclarationAndClause(defaultImport, defaultImport.importClause.name, namespaceImports[0].importClause.namedBindings));
              continue;
            }
            var sortedNamespaceImports = ts3.stableSort(namespaceImports, function(i1, i22) {
              return compareIdentifiers(i1.importClause.namedBindings.name, i22.importClause.namedBindings.name);
            });
            for (var _d = 0, sortedNamespaceImports_1 = sortedNamespaceImports; _d < sortedNamespaceImports_1.length; _d++) {
              var namespaceImport = sortedNamespaceImports_1[_d];
              coalescedImports.push(updateImportDeclarationAndClause(namespaceImport, void 0, namespaceImport.importClause.namedBindings));
            }
            if (defaultImports.length === 0 && namedImports.length === 0) {
              continue;
            }
            var newDefaultImport = void 0;
            var newImportSpecifiers = [];
            if (defaultImports.length === 1) {
              newDefaultImport = defaultImports[0].importClause.name;
            } else {
              for (var _e = 0, defaultImports_1 = defaultImports; _e < defaultImports_1.length; _e++) {
                var defaultImport = defaultImports_1[_e];
                newImportSpecifiers.push(ts3.factory.createImportSpecifier(ts3.factory.createIdentifier("default"), defaultImport.importClause.name));
              }
            }
            newImportSpecifiers.push.apply(newImportSpecifiers, ts3.flatMap(namedImports, function(i3) {
              return i3.importClause.namedBindings.elements;
            }));
            var sortedImportSpecifiers = sortSpecifiers(newImportSpecifiers);
            var importDecl = defaultImports.length > 0 ? defaultImports[0] : namedImports[0];
            var newNamedImports = sortedImportSpecifiers.length === 0 ? newDefaultImport ? void 0 : ts3.factory.createNamedImports(ts3.emptyArray) : namedImports.length === 0 ? ts3.factory.createNamedImports(sortedImportSpecifiers) : ts3.factory.updateNamedImports(namedImports[0].importClause.namedBindings, sortedImportSpecifiers);
            if (isTypeOnly && newDefaultImport && newNamedImports) {
              coalescedImports.push(updateImportDeclarationAndClause(importDecl, newDefaultImport, void 0));
              coalescedImports.push(updateImportDeclarationAndClause((_a2 = namedImports[0]) !== null && _a2 !== void 0 ? _a2 : importDecl, void 0, newNamedImports));
            } else {
              coalescedImports.push(updateImportDeclarationAndClause(importDecl, newDefaultImport, newNamedImports));
            }
          }
          return coalescedImports;
        }
        OrganizeImports2.coalesceImports = coalesceImports;
        function getCategorizedImports(importGroup) {
          var importWithoutClause;
          var typeOnlyImports = { defaultImports: [], namespaceImports: [], namedImports: [] };
          var regularImports = { defaultImports: [], namespaceImports: [], namedImports: [] };
          for (var _i = 0, importGroup_1 = importGroup; _i < importGroup_1.length; _i++) {
            var importDeclaration = importGroup_1[_i];
            if (importDeclaration.importClause === void 0) {
              importWithoutClause = importWithoutClause || importDeclaration;
              continue;
            }
            var group_3 = importDeclaration.importClause.isTypeOnly ? typeOnlyImports : regularImports;
            var _a2 = importDeclaration.importClause, name = _a2.name, namedBindings = _a2.namedBindings;
            if (name) {
              group_3.defaultImports.push(importDeclaration);
            }
            if (namedBindings) {
              if (ts3.isNamespaceImport(namedBindings)) {
                group_3.namespaceImports.push(importDeclaration);
              } else {
                group_3.namedImports.push(importDeclaration);
              }
            }
          }
          return {
            importWithoutClause,
            typeOnlyImports,
            regularImports
          };
        }
        function coalesceExports(exportGroup) {
          if (exportGroup.length === 0) {
            return exportGroup;
          }
          var _a2 = getCategorizedExports(exportGroup), exportWithoutClause = _a2.exportWithoutClause, namedExports = _a2.namedExports, typeOnlyExports = _a2.typeOnlyExports;
          var coalescedExports = [];
          if (exportWithoutClause) {
            coalescedExports.push(exportWithoutClause);
          }
          for (var _i = 0, _b = [namedExports, typeOnlyExports]; _i < _b.length; _i++) {
            var exportGroup_1 = _b[_i];
            if (exportGroup_1.length === 0) {
              continue;
            }
            var newExportSpecifiers = [];
            newExportSpecifiers.push.apply(newExportSpecifiers, ts3.flatMap(exportGroup_1, function(i3) {
              return i3.exportClause && ts3.isNamedExports(i3.exportClause) ? i3.exportClause.elements : ts3.emptyArray;
            }));
            var sortedExportSpecifiers = sortSpecifiers(newExportSpecifiers);
            var exportDecl = exportGroup_1[0];
            coalescedExports.push(ts3.factory.updateExportDeclaration(exportDecl, exportDecl.decorators, exportDecl.modifiers, exportDecl.isTypeOnly, exportDecl.exportClause && (ts3.isNamedExports(exportDecl.exportClause) ? ts3.factory.updateNamedExports(exportDecl.exportClause, sortedExportSpecifiers) : ts3.factory.updateNamespaceExport(exportDecl.exportClause, exportDecl.exportClause.name)), exportDecl.moduleSpecifier));
          }
          return coalescedExports;
          function getCategorizedExports(exportGroup2) {
            var exportWithoutClause2;
            var namedExports2 = [];
            var typeOnlyExports2 = [];
            for (var _i2 = 0, exportGroup_2 = exportGroup2; _i2 < exportGroup_2.length; _i2++) {
              var exportDeclaration = exportGroup_2[_i2];
              if (exportDeclaration.exportClause === void 0) {
                exportWithoutClause2 = exportWithoutClause2 || exportDeclaration;
              } else if (exportDeclaration.isTypeOnly) {
                typeOnlyExports2.push(exportDeclaration);
              } else {
                namedExports2.push(exportDeclaration);
              }
            }
            return {
              exportWithoutClause: exportWithoutClause2,
              namedExports: namedExports2,
              typeOnlyExports: typeOnlyExports2
            };
          }
        }
        OrganizeImports2.coalesceExports = coalesceExports;
        function updateImportDeclarationAndClause(importDeclaration, name, namedBindings) {
          return ts3.factory.updateImportDeclaration(importDeclaration, importDeclaration.decorators, importDeclaration.modifiers, ts3.factory.updateImportClause(importDeclaration.importClause, importDeclaration.importClause.isTypeOnly, name, namedBindings), importDeclaration.moduleSpecifier);
        }
        function sortSpecifiers(specifiers) {
          return ts3.stableSort(specifiers, compareImportOrExportSpecifiers);
        }
        function compareImportOrExportSpecifiers(s1, s2) {
          return compareIdentifiers(s1.propertyName || s1.name, s2.propertyName || s2.name) || compareIdentifiers(s1.name, s2.name);
        }
        OrganizeImports2.compareImportOrExportSpecifiers = compareImportOrExportSpecifiers;
        function compareModuleSpecifiers(m1, m2) {
          var name1 = m1 === void 0 ? void 0 : getExternalModuleName(m1);
          var name2 = m2 === void 0 ? void 0 : getExternalModuleName(m2);
          return ts3.compareBooleans(name1 === void 0, name2 === void 0) || ts3.compareBooleans(ts3.isExternalModuleNameRelative(name1), ts3.isExternalModuleNameRelative(name2)) || ts3.compareStringsCaseInsensitive(name1, name2);
        }
        OrganizeImports2.compareModuleSpecifiers = compareModuleSpecifiers;
        function compareIdentifiers(s1, s2) {
          return ts3.compareStringsCaseInsensitive(s1.text, s2.text);
        }
        function getModuleSpecifierExpression(declaration) {
          var _a2;
          switch (declaration.kind) {
            case 261:
              return (_a2 = ts3.tryCast(declaration.moduleReference, ts3.isExternalModuleReference)) === null || _a2 === void 0 ? void 0 : _a2.expression;
            case 262:
              return declaration.moduleSpecifier;
            case 233:
              return declaration.declarationList.declarations[0].initializer.arguments[0];
          }
        }
        function importsAreSorted(imports) {
          return ts3.arrayIsSorted(imports, compareImportsOrRequireStatements);
        }
        OrganizeImports2.importsAreSorted = importsAreSorted;
        function importSpecifiersAreSorted(imports) {
          return ts3.arrayIsSorted(imports, compareImportOrExportSpecifiers);
        }
        OrganizeImports2.importSpecifiersAreSorted = importSpecifiersAreSorted;
        function getImportDeclarationInsertionIndex(sortedImports, newImport) {
          var index = ts3.binarySearch(sortedImports, newImport, ts3.identity, compareImportsOrRequireStatements);
          return index < 0 ? ~index : index;
        }
        OrganizeImports2.getImportDeclarationInsertionIndex = getImportDeclarationInsertionIndex;
        function getImportSpecifierInsertionIndex(sortedImports, newImport) {
          var index = ts3.binarySearch(sortedImports, newImport, ts3.identity, compareImportOrExportSpecifiers);
          return index < 0 ? ~index : index;
        }
        OrganizeImports2.getImportSpecifierInsertionIndex = getImportSpecifierInsertionIndex;
        function compareImportsOrRequireStatements(s1, s2) {
          return compareModuleSpecifiers(getModuleSpecifierExpression(s1), getModuleSpecifierExpression(s2)) || compareImportKind(s1, s2);
        }
        OrganizeImports2.compareImportsOrRequireStatements = compareImportsOrRequireStatements;
        function compareImportKind(s1, s2) {
          return ts3.compareValues(getImportKindOrder(s1), getImportKindOrder(s2));
        }
        function getImportKindOrder(s1) {
          var _a2;
          switch (s1.kind) {
            case 262:
              if (!s1.importClause)
                return 0;
              if (s1.importClause.isTypeOnly)
                return 1;
              if (((_a2 = s1.importClause.namedBindings) === null || _a2 === void 0 ? void 0 : _a2.kind) === 264)
                return 2;
              if (s1.importClause.name)
                return 3;
              return 4;
            case 261:
              return 5;
            case 233:
              return 6;
          }
        }
      })(OrganizeImports = ts3.OrganizeImports || (ts3.OrganizeImports = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var OutliningElementsCollector;
      (function(OutliningElementsCollector2) {
        function collectElements(sourceFile, cancellationToken) {
          var res = [];
          addNodeOutliningSpans(sourceFile, cancellationToken, res);
          addRegionOutliningSpans(sourceFile, res);
          return res.sort(function(span1, span2) {
            return span1.textSpan.start - span2.textSpan.start;
          });
        }
        OutliningElementsCollector2.collectElements = collectElements;
        function addNodeOutliningSpans(sourceFile, cancellationToken, out) {
          var depthRemaining = 40;
          var current = 0;
          var statements = __spreadArray(__spreadArray([], sourceFile.statements), [sourceFile.endOfFileToken]);
          var n2 = statements.length;
          while (current < n2) {
            while (current < n2 && !ts3.isAnyImportSyntax(statements[current])) {
              visitNonImportNode(statements[current]);
              current++;
            }
            if (current === n2)
              break;
            var firstImport = current;
            while (current < n2 && ts3.isAnyImportSyntax(statements[current])) {
              addOutliningForLeadingCommentsForNode(statements[current], sourceFile, cancellationToken, out);
              current++;
            }
            var lastImport = current - 1;
            if (lastImport !== firstImport) {
              out.push(createOutliningSpanFromBounds(ts3.findChildOfKind(statements[firstImport], 99, sourceFile).getStart(sourceFile), statements[lastImport].getEnd(), "imports"));
            }
          }
          function visitNonImportNode(n3) {
            var _a2;
            if (depthRemaining === 0)
              return;
            cancellationToken.throwIfCancellationRequested();
            if (ts3.isDeclaration(n3) || ts3.isVariableStatement(n3) || n3.kind === 1) {
              addOutliningForLeadingCommentsForNode(n3, sourceFile, cancellationToken, out);
            }
            if (ts3.isFunctionLike(n3) && ts3.isBinaryExpression(n3.parent) && ts3.isPropertyAccessExpression(n3.parent.left)) {
              addOutliningForLeadingCommentsForNode(n3.parent.left, sourceFile, cancellationToken, out);
            }
            var span = getOutliningSpanForNode(n3, sourceFile);
            if (span)
              out.push(span);
            depthRemaining--;
            if (ts3.isCallExpression(n3)) {
              depthRemaining++;
              visitNonImportNode(n3.expression);
              depthRemaining--;
              n3.arguments.forEach(visitNonImportNode);
              (_a2 = n3.typeArguments) === null || _a2 === void 0 ? void 0 : _a2.forEach(visitNonImportNode);
            } else if (ts3.isIfStatement(n3) && n3.elseStatement && ts3.isIfStatement(n3.elseStatement)) {
              visitNonImportNode(n3.expression);
              visitNonImportNode(n3.thenStatement);
              depthRemaining++;
              visitNonImportNode(n3.elseStatement);
              depthRemaining--;
            } else {
              n3.forEachChild(visitNonImportNode);
            }
            depthRemaining++;
          }
        }
        function addRegionOutliningSpans(sourceFile, out) {
          var regions = [];
          var lineStarts = sourceFile.getLineStarts();
          for (var _i = 0, lineStarts_1 = lineStarts; _i < lineStarts_1.length; _i++) {
            var currentLineStart = lineStarts_1[_i];
            var lineEnd = sourceFile.getLineEndOfPosition(currentLineStart);
            var lineText = sourceFile.text.substring(currentLineStart, lineEnd);
            var result2 = isRegionDelimiter(lineText);
            if (!result2 || ts3.isInComment(sourceFile, currentLineStart)) {
              continue;
            }
            if (!result2[1]) {
              var span = ts3.createTextSpanFromBounds(sourceFile.text.indexOf("//", currentLineStart), lineEnd);
              regions.push(createOutliningSpan(span, "region", span, false, result2[2] || "#region"));
            } else {
              var region = regions.pop();
              if (region) {
                region.textSpan.length = lineEnd - region.textSpan.start;
                region.hintSpan.length = lineEnd - region.textSpan.start;
                out.push(region);
              }
            }
          }
        }
        var regionDelimiterRegExp = /^\s*\/\/\s*#(end)?region(?:\s+(.*))?(?:\r)?$/;
        function isRegionDelimiter(lineText) {
          return regionDelimiterRegExp.exec(lineText);
        }
        function addOutliningForLeadingCommentsForNode(n2, sourceFile, cancellationToken, out) {
          var comments = ts3.getLeadingCommentRangesOfNode(n2, sourceFile);
          if (!comments)
            return;
          var firstSingleLineCommentStart = -1;
          var lastSingleLineCommentEnd = -1;
          var singleLineCommentCount = 0;
          var sourceText = sourceFile.getFullText();
          for (var _i = 0, comments_1 = comments; _i < comments_1.length; _i++) {
            var _a2 = comments_1[_i], kind = _a2.kind, pos = _a2.pos, end = _a2.end;
            cancellationToken.throwIfCancellationRequested();
            switch (kind) {
              case 2:
                var commentText = sourceText.slice(pos, end);
                if (isRegionDelimiter(commentText)) {
                  combineAndAddMultipleSingleLineComments();
                  singleLineCommentCount = 0;
                  break;
                }
                if (singleLineCommentCount === 0) {
                  firstSingleLineCommentStart = pos;
                }
                lastSingleLineCommentEnd = end;
                singleLineCommentCount++;
                break;
              case 3:
                combineAndAddMultipleSingleLineComments();
                out.push(createOutliningSpanFromBounds(pos, end, "comment"));
                singleLineCommentCount = 0;
                break;
              default:
                ts3.Debug.assertNever(kind);
            }
          }
          combineAndAddMultipleSingleLineComments();
          function combineAndAddMultipleSingleLineComments() {
            if (singleLineCommentCount > 1) {
              out.push(createOutliningSpanFromBounds(firstSingleLineCommentStart, lastSingleLineCommentEnd, "comment"));
            }
          }
        }
        function createOutliningSpanFromBounds(pos, end, kind) {
          return createOutliningSpan(ts3.createTextSpanFromBounds(pos, end), kind);
        }
        function getOutliningSpanForNode(n2, sourceFile) {
          switch (n2.kind) {
            case 231:
              if (ts3.isFunctionLike(n2.parent)) {
                return functionSpan(n2.parent, n2, sourceFile);
              }
              switch (n2.parent.kind) {
                case 236:
                case 239:
                case 240:
                case 238:
                case 235:
                case 237:
                case 244:
                case 288:
                  return spanForNode(n2.parent);
                case 248:
                  var tryStatement = n2.parent;
                  if (tryStatement.tryBlock === n2) {
                    return spanForNode(n2.parent);
                  } else if (tryStatement.finallyBlock === n2) {
                    var node = ts3.findChildOfKind(tryStatement, 95, sourceFile);
                    if (node)
                      return spanForNode(node);
                  }
                default:
                  return createOutliningSpan(ts3.createTextSpanFromNode(n2, sourceFile), "code");
              }
            case 258:
              return spanForNode(n2.parent);
            case 253:
            case 222:
            case 254:
            case 256:
            case 259:
            case 178:
            case 197:
              return spanForNode(n2);
            case 180:
              return spanForNode(n2, false, !ts3.isTupleTypeNode(n2.parent), 22);
            case 285:
            case 286:
              return spanForNodeArray(n2.statements);
            case 201:
              return spanForObjectOrArrayLiteral(n2);
            case 200:
              return spanForObjectOrArrayLiteral(n2, 22);
            case 274:
              return spanForJSXElement(n2);
            case 278:
              return spanForJSXFragment(n2);
            case 275:
            case 276:
              return spanForJSXAttributes(n2.attributes);
            case 219:
            case 14:
              return spanForTemplateLiteral(n2);
            case 198:
              return spanForNode(n2, false, !ts3.isBindingElement(n2.parent), 22);
            case 210:
              return spanForArrowFunction(n2);
            case 204:
              return spanForCallExpression(n2);
          }
          function spanForCallExpression(node2) {
            if (!node2.arguments.length) {
              return void 0;
            }
            var openToken = ts3.findChildOfKind(node2, 20, sourceFile);
            var closeToken = ts3.findChildOfKind(node2, 21, sourceFile);
            if (!openToken || !closeToken || ts3.positionsAreOnSameLine(openToken.pos, closeToken.pos, sourceFile)) {
              return void 0;
            }
            return spanBetweenTokens(openToken, closeToken, node2, sourceFile, false, true);
          }
          function spanForArrowFunction(node2) {
            if (ts3.isBlock(node2.body) || ts3.positionsAreOnSameLine(node2.body.getFullStart(), node2.body.getEnd(), sourceFile)) {
              return void 0;
            }
            var textSpan = ts3.createTextSpanFromBounds(node2.body.getFullStart(), node2.body.getEnd());
            return createOutliningSpan(textSpan, "code", ts3.createTextSpanFromNode(node2));
          }
          function spanForJSXElement(node2) {
            var textSpan = ts3.createTextSpanFromBounds(node2.openingElement.getStart(sourceFile), node2.closingElement.getEnd());
            var tagName = node2.openingElement.tagName.getText(sourceFile);
            var bannerText = "<" + tagName + ">...</" + tagName + ">";
            return createOutliningSpan(textSpan, "code", textSpan, false, bannerText);
          }
          function spanForJSXFragment(node2) {
            var textSpan = ts3.createTextSpanFromBounds(node2.openingFragment.getStart(sourceFile), node2.closingFragment.getEnd());
            var bannerText = "<>...</>";
            return createOutliningSpan(textSpan, "code", textSpan, false, bannerText);
          }
          function spanForJSXAttributes(node2) {
            if (node2.properties.length === 0) {
              return void 0;
            }
            return createOutliningSpanFromBounds(node2.getStart(sourceFile), node2.getEnd(), "code");
          }
          function spanForTemplateLiteral(node2) {
            if (node2.kind === 14 && node2.text.length === 0) {
              return void 0;
            }
            return createOutliningSpanFromBounds(node2.getStart(sourceFile), node2.getEnd(), "code");
          }
          function spanForObjectOrArrayLiteral(node2, open) {
            if (open === void 0) {
              open = 18;
            }
            return spanForNode(node2, false, !ts3.isArrayLiteralExpression(node2.parent) && !ts3.isCallExpression(node2.parent), open);
          }
          function spanForNode(hintSpanNode, autoCollapse, useFullStart, open, close) {
            if (autoCollapse === void 0) {
              autoCollapse = false;
            }
            if (useFullStart === void 0) {
              useFullStart = true;
            }
            if (open === void 0) {
              open = 18;
            }
            if (close === void 0) {
              close = open === 18 ? 19 : 23;
            }
            var openToken = ts3.findChildOfKind(n2, open, sourceFile);
            var closeToken = ts3.findChildOfKind(n2, close, sourceFile);
            return openToken && closeToken && spanBetweenTokens(openToken, closeToken, hintSpanNode, sourceFile, autoCollapse, useFullStart);
          }
          function spanForNodeArray(nodeArray) {
            return nodeArray.length ? createOutliningSpan(ts3.createTextSpanFromRange(nodeArray), "code") : void 0;
          }
        }
        function functionSpan(node, body, sourceFile) {
          var openToken = tryGetFunctionOpenToken(node, body, sourceFile);
          var closeToken = ts3.findChildOfKind(body, 19, sourceFile);
          return openToken && closeToken && spanBetweenTokens(openToken, closeToken, node, sourceFile, node.kind !== 210);
        }
        function spanBetweenTokens(openToken, closeToken, hintSpanNode, sourceFile, autoCollapse, useFullStart) {
          if (autoCollapse === void 0) {
            autoCollapse = false;
          }
          if (useFullStart === void 0) {
            useFullStart = true;
          }
          var textSpan = ts3.createTextSpanFromBounds(useFullStart ? openToken.getFullStart() : openToken.getStart(sourceFile), closeToken.getEnd());
          return createOutliningSpan(textSpan, "code", ts3.createTextSpanFromNode(hintSpanNode, sourceFile), autoCollapse);
        }
        function createOutliningSpan(textSpan, kind, hintSpan, autoCollapse, bannerText) {
          if (hintSpan === void 0) {
            hintSpan = textSpan;
          }
          if (autoCollapse === void 0) {
            autoCollapse = false;
          }
          if (bannerText === void 0) {
            bannerText = "...";
          }
          return { textSpan, kind, hintSpan, bannerText, autoCollapse };
        }
        function tryGetFunctionOpenToken(node, body, sourceFile) {
          if (ts3.isNodeArrayMultiLine(node.parameters, sourceFile)) {
            var openParenToken = ts3.findChildOfKind(node, 20, sourceFile);
            if (openParenToken) {
              return openParenToken;
            }
          }
          return ts3.findChildOfKind(body, 18, sourceFile);
        }
      })(OutliningElementsCollector = ts3.OutliningElementsCollector || (ts3.OutliningElementsCollector = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var PatternMatchKind;
      (function(PatternMatchKind2) {
        PatternMatchKind2[PatternMatchKind2["exact"] = 0] = "exact";
        PatternMatchKind2[PatternMatchKind2["prefix"] = 1] = "prefix";
        PatternMatchKind2[PatternMatchKind2["substring"] = 2] = "substring";
        PatternMatchKind2[PatternMatchKind2["camelCase"] = 3] = "camelCase";
      })(PatternMatchKind = ts3.PatternMatchKind || (ts3.PatternMatchKind = {}));
      function createPatternMatch(kind, isCaseSensitive) {
        return {
          kind,
          isCaseSensitive
        };
      }
      function createPatternMatcher(pattern) {
        var stringToWordSpans = new ts3.Map();
        var dotSeparatedSegments = pattern.trim().split(".").map(function(p) {
          return createSegment(p.trim());
        });
        if (dotSeparatedSegments.some(function(segment) {
          return !segment.subWordTextChunks.length;
        }))
          return void 0;
        return {
          getFullMatch: function(containers, candidate) {
            return getFullMatch(containers, candidate, dotSeparatedSegments, stringToWordSpans);
          },
          getMatchForLastSegmentOfPattern: function(candidate) {
            return matchSegment(candidate, ts3.last(dotSeparatedSegments), stringToWordSpans);
          },
          patternContainsDots: dotSeparatedSegments.length > 1
        };
      }
      ts3.createPatternMatcher = createPatternMatcher;
      function getFullMatch(candidateContainers, candidate, dotSeparatedSegments, stringToWordSpans) {
        var candidateMatch = matchSegment(candidate, ts3.last(dotSeparatedSegments), stringToWordSpans);
        if (!candidateMatch) {
          return void 0;
        }
        if (dotSeparatedSegments.length - 1 > candidateContainers.length) {
          return void 0;
        }
        var bestMatch;
        for (var i3 = dotSeparatedSegments.length - 2, j = candidateContainers.length - 1; i3 >= 0; i3 -= 1, j -= 1) {
          bestMatch = betterMatch(bestMatch, matchSegment(candidateContainers[j], dotSeparatedSegments[i3], stringToWordSpans));
        }
        return bestMatch;
      }
      function getWordSpans(word, stringToWordSpans) {
        var spans = stringToWordSpans.get(word);
        if (!spans) {
          stringToWordSpans.set(word, spans = breakIntoWordSpans(word));
        }
        return spans;
      }
      function matchTextChunk(candidate, chunk, stringToWordSpans) {
        var index = indexOfIgnoringCase(candidate, chunk.textLowerCase);
        if (index === 0) {
          return createPatternMatch(chunk.text.length === candidate.length ? PatternMatchKind.exact : PatternMatchKind.prefix, ts3.startsWith(candidate, chunk.text));
        }
        if (chunk.isLowerCase) {
          if (index === -1)
            return void 0;
          var wordSpans = getWordSpans(candidate, stringToWordSpans);
          for (var _i = 0, wordSpans_1 = wordSpans; _i < wordSpans_1.length; _i++) {
            var span = wordSpans_1[_i];
            if (partStartsWith(candidate, span, chunk.text, true)) {
              return createPatternMatch(PatternMatchKind.substring, partStartsWith(candidate, span, chunk.text, false));
            }
          }
          if (chunk.text.length < candidate.length && isUpperCaseLetter(candidate.charCodeAt(index))) {
            return createPatternMatch(PatternMatchKind.substring, false);
          }
        } else {
          if (candidate.indexOf(chunk.text) > 0) {
            return createPatternMatch(PatternMatchKind.substring, true);
          }
          if (chunk.characterSpans.length > 0) {
            var candidateParts = getWordSpans(candidate, stringToWordSpans);
            var isCaseSensitive = tryCamelCaseMatch(candidate, candidateParts, chunk, false) ? true : tryCamelCaseMatch(candidate, candidateParts, chunk, true) ? false : void 0;
            if (isCaseSensitive !== void 0) {
              return createPatternMatch(PatternMatchKind.camelCase, isCaseSensitive);
            }
          }
        }
      }
      function matchSegment(candidate, segment, stringToWordSpans) {
        if (every(segment.totalTextChunk.text, function(ch) {
          return ch !== 32 && ch !== 42;
        })) {
          var match = matchTextChunk(candidate, segment.totalTextChunk, stringToWordSpans);
          if (match)
            return match;
        }
        var subWordTextChunks = segment.subWordTextChunks;
        var bestMatch;
        for (var _i = 0, subWordTextChunks_1 = subWordTextChunks; _i < subWordTextChunks_1.length; _i++) {
          var subWordTextChunk = subWordTextChunks_1[_i];
          bestMatch = betterMatch(bestMatch, matchTextChunk(candidate, subWordTextChunk, stringToWordSpans));
        }
        return bestMatch;
      }
      function betterMatch(a2, b2) {
        return ts3.min(a2, b2, compareMatches);
      }
      function compareMatches(a2, b2) {
        return a2 === void 0 ? 1 : b2 === void 0 ? -1 : ts3.compareValues(a2.kind, b2.kind) || ts3.compareBooleans(!a2.isCaseSensitive, !b2.isCaseSensitive);
      }
      function partStartsWith(candidate, candidateSpan, pattern, ignoreCase, patternSpan) {
        if (patternSpan === void 0) {
          patternSpan = { start: 0, length: pattern.length };
        }
        return patternSpan.length <= candidateSpan.length && everyInRange(0, patternSpan.length, function(i3) {
          return equalChars(pattern.charCodeAt(patternSpan.start + i3), candidate.charCodeAt(candidateSpan.start + i3), ignoreCase);
        });
      }
      function equalChars(ch1, ch2, ignoreCase) {
        return ignoreCase ? toLowerCase(ch1) === toLowerCase(ch2) : ch1 === ch2;
      }
      function tryCamelCaseMatch(candidate, candidateParts, chunk, ignoreCase) {
        var chunkCharacterSpans = chunk.characterSpans;
        var currentCandidate = 0;
        var currentChunkSpan = 0;
        var firstMatch;
        var contiguous;
        while (true) {
          if (currentChunkSpan === chunkCharacterSpans.length) {
            return true;
          } else if (currentCandidate === candidateParts.length) {
            return false;
          }
          var candidatePart = candidateParts[currentCandidate];
          var gotOneMatchThisCandidate = false;
          for (; currentChunkSpan < chunkCharacterSpans.length; currentChunkSpan++) {
            var chunkCharacterSpan = chunkCharacterSpans[currentChunkSpan];
            if (gotOneMatchThisCandidate) {
              if (!isUpperCaseLetter(chunk.text.charCodeAt(chunkCharacterSpans[currentChunkSpan - 1].start)) || !isUpperCaseLetter(chunk.text.charCodeAt(chunkCharacterSpans[currentChunkSpan].start))) {
                break;
              }
            }
            if (!partStartsWith(candidate, candidatePart, chunk.text, ignoreCase, chunkCharacterSpan)) {
              break;
            }
            gotOneMatchThisCandidate = true;
            firstMatch = firstMatch === void 0 ? currentCandidate : firstMatch;
            contiguous = contiguous === void 0 ? true : contiguous;
            candidatePart = ts3.createTextSpan(candidatePart.start + chunkCharacterSpan.length, candidatePart.length - chunkCharacterSpan.length);
          }
          if (!gotOneMatchThisCandidate && contiguous !== void 0) {
            contiguous = false;
          }
          currentCandidate++;
        }
      }
      function createSegment(text) {
        return {
          totalTextChunk: createTextChunk(text),
          subWordTextChunks: breakPatternIntoTextChunks(text)
        };
      }
      function isUpperCaseLetter(ch) {
        if (ch >= 65 && ch <= 90) {
          return true;
        }
        if (ch < 127 || !ts3.isUnicodeIdentifierStart(ch, 99)) {
          return false;
        }
        var str2 = String.fromCharCode(ch);
        return str2 === str2.toUpperCase();
      }
      function isLowerCaseLetter(ch) {
        if (ch >= 97 && ch <= 122) {
          return true;
        }
        if (ch < 127 || !ts3.isUnicodeIdentifierStart(ch, 99)) {
          return false;
        }
        var str2 = String.fromCharCode(ch);
        return str2 === str2.toLowerCase();
      }
      function indexOfIgnoringCase(str2, value) {
        var n2 = str2.length - value.length;
        var _loop_7 = function(start2) {
          if (every(value, function(valueChar, i3) {
            return toLowerCase(str2.charCodeAt(i3 + start2)) === valueChar;
          })) {
            return { value: start2 };
          }
        };
        for (var start = 0; start <= n2; start++) {
          var state_2 = _loop_7(start);
          if (typeof state_2 === "object")
            return state_2.value;
        }
        return -1;
      }
      function toLowerCase(ch) {
        if (ch >= 65 && ch <= 90) {
          return 97 + (ch - 65);
        }
        if (ch < 127) {
          return ch;
        }
        return String.fromCharCode(ch).toLowerCase().charCodeAt(0);
      }
      function isDigit(ch) {
        return ch >= 48 && ch <= 57;
      }
      function isWordChar(ch) {
        return isUpperCaseLetter(ch) || isLowerCaseLetter(ch) || isDigit(ch) || ch === 95 || ch === 36;
      }
      function breakPatternIntoTextChunks(pattern) {
        var result2 = [];
        var wordStart = 0;
        var wordLength = 0;
        for (var i3 = 0; i3 < pattern.length; i3++) {
          var ch = pattern.charCodeAt(i3);
          if (isWordChar(ch)) {
            if (wordLength === 0) {
              wordStart = i3;
            }
            wordLength++;
          } else {
            if (wordLength > 0) {
              result2.push(createTextChunk(pattern.substr(wordStart, wordLength)));
              wordLength = 0;
            }
          }
        }
        if (wordLength > 0) {
          result2.push(createTextChunk(pattern.substr(wordStart, wordLength)));
        }
        return result2;
      }
      function createTextChunk(text) {
        var textLowerCase = text.toLowerCase();
        return {
          text,
          textLowerCase,
          isLowerCase: text === textLowerCase,
          characterSpans: breakIntoCharacterSpans(text)
        };
      }
      function breakIntoCharacterSpans(identifier) {
        return breakIntoSpans(identifier, false);
      }
      ts3.breakIntoCharacterSpans = breakIntoCharacterSpans;
      function breakIntoWordSpans(identifier) {
        return breakIntoSpans(identifier, true);
      }
      ts3.breakIntoWordSpans = breakIntoWordSpans;
      function breakIntoSpans(identifier, word) {
        var result2 = [];
        var wordStart = 0;
        for (var i3 = 1; i3 < identifier.length; i3++) {
          var lastIsDigit = isDigit(identifier.charCodeAt(i3 - 1));
          var currentIsDigit = isDigit(identifier.charCodeAt(i3));
          var hasTransitionFromLowerToUpper = transitionFromLowerToUpper(identifier, word, i3);
          var hasTransitionFromUpperToLower = word && transitionFromUpperToLower(identifier, i3, wordStart);
          if (charIsPunctuation(identifier.charCodeAt(i3 - 1)) || charIsPunctuation(identifier.charCodeAt(i3)) || lastIsDigit !== currentIsDigit || hasTransitionFromLowerToUpper || hasTransitionFromUpperToLower) {
            if (!isAllPunctuation(identifier, wordStart, i3)) {
              result2.push(ts3.createTextSpan(wordStart, i3 - wordStart));
            }
            wordStart = i3;
          }
        }
        if (!isAllPunctuation(identifier, wordStart, identifier.length)) {
          result2.push(ts3.createTextSpan(wordStart, identifier.length - wordStart));
        }
        return result2;
      }
      function charIsPunctuation(ch) {
        switch (ch) {
          case 33:
          case 34:
          case 35:
          case 37:
          case 38:
          case 39:
          case 40:
          case 41:
          case 42:
          case 44:
          case 45:
          case 46:
          case 47:
          case 58:
          case 59:
          case 63:
          case 64:
          case 91:
          case 92:
          case 93:
          case 95:
          case 123:
          case 125:
            return true;
        }
        return false;
      }
      function isAllPunctuation(identifier, start, end) {
        return every(identifier, function(ch) {
          return charIsPunctuation(ch) && ch !== 95;
        }, start, end);
      }
      function transitionFromUpperToLower(identifier, index, wordStart) {
        return index !== wordStart && index + 1 < identifier.length && isUpperCaseLetter(identifier.charCodeAt(index)) && isLowerCaseLetter(identifier.charCodeAt(index + 1)) && every(identifier, isUpperCaseLetter, wordStart, index);
      }
      function transitionFromLowerToUpper(identifier, word, index) {
        var lastIsUpper = isUpperCaseLetter(identifier.charCodeAt(index - 1));
        var currentIsUpper = isUpperCaseLetter(identifier.charCodeAt(index));
        return currentIsUpper && (!word || !lastIsUpper);
      }
      function everyInRange(start, end, pred) {
        for (var i3 = start; i3 < end; i3++) {
          if (!pred(i3)) {
            return false;
          }
        }
        return true;
      }
      function every(s2, pred, start, end) {
        if (start === void 0) {
          start = 0;
        }
        if (end === void 0) {
          end = s2.length;
        }
        return everyInRange(start, end, function(i3) {
          return pred(s2.charCodeAt(i3), i3);
        });
      }
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      function preProcessFile(sourceText, readImportFiles, detectJavaScriptImports) {
        if (readImportFiles === void 0) {
          readImportFiles = true;
        }
        if (detectJavaScriptImports === void 0) {
          detectJavaScriptImports = false;
        }
        var pragmaContext = {
          languageVersion: 1,
          pragmas: void 0,
          checkJsDirective: void 0,
          referencedFiles: [],
          typeReferenceDirectives: [],
          libReferenceDirectives: [],
          amdDependencies: [],
          hasNoDefaultLib: void 0,
          moduleName: void 0
        };
        var importedFiles = [];
        var ambientExternalModules;
        var lastToken;
        var currentToken;
        var braceNesting = 0;
        var externalModule = false;
        function nextToken() {
          lastToken = currentToken;
          currentToken = ts3.scanner.scan();
          if (currentToken === 18) {
            braceNesting++;
          } else if (currentToken === 19) {
            braceNesting--;
          }
          return currentToken;
        }
        function getFileReference() {
          var fileName = ts3.scanner.getTokenValue();
          var pos = ts3.scanner.getTokenPos();
          return { fileName, pos, end: pos + fileName.length };
        }
        function recordAmbientExternalModule() {
          if (!ambientExternalModules) {
            ambientExternalModules = [];
          }
          ambientExternalModules.push({ ref: getFileReference(), depth: braceNesting });
        }
        function recordModuleName() {
          importedFiles.push(getFileReference());
          markAsExternalModuleIfTopLevel();
        }
        function markAsExternalModuleIfTopLevel() {
          if (braceNesting === 0) {
            externalModule = true;
          }
        }
        function tryConsumeDeclare() {
          var token = ts3.scanner.getToken();
          if (token === 133) {
            token = nextToken();
            if (token === 139) {
              token = nextToken();
              if (token === 10) {
                recordAmbientExternalModule();
              }
            }
            return true;
          }
          return false;
        }
        function tryConsumeImport() {
          if (lastToken === 24) {
            return false;
          }
          var token = ts3.scanner.getToken();
          if (token === 99) {
            token = nextToken();
            if (token === 20) {
              token = nextToken();
              if (token === 10 || token === 14) {
                recordModuleName();
                return true;
              }
            } else if (token === 10) {
              recordModuleName();
              return true;
            } else {
              if (token === 149) {
                var skipTypeKeyword = ts3.scanner.lookAhead(function() {
                  var token2 = ts3.scanner.scan();
                  return token2 !== 153 && (token2 === 41 || token2 === 18 || token2 === 78 || ts3.isKeyword(token2));
                });
                if (skipTypeKeyword) {
                  token = nextToken();
                }
              }
              if (token === 78 || ts3.isKeyword(token)) {
                token = nextToken();
                if (token === 153) {
                  token = nextToken();
                  if (token === 10) {
                    recordModuleName();
                    return true;
                  }
                } else if (token === 62) {
                  if (tryConsumeRequireCall(true)) {
                    return true;
                  }
                } else if (token === 27) {
                  token = nextToken();
                } else {
                  return true;
                }
              }
              if (token === 18) {
                token = nextToken();
                while (token !== 19 && token !== 1) {
                  token = nextToken();
                }
                if (token === 19) {
                  token = nextToken();
                  if (token === 153) {
                    token = nextToken();
                    if (token === 10) {
                      recordModuleName();
                    }
                  }
                }
              } else if (token === 41) {
                token = nextToken();
                if (token === 126) {
                  token = nextToken();
                  if (token === 78 || ts3.isKeyword(token)) {
                    token = nextToken();
                    if (token === 153) {
                      token = nextToken();
                      if (token === 10) {
                        recordModuleName();
                      }
                    }
                  }
                }
              }
            }
            return true;
          }
          return false;
        }
        function tryConsumeExport() {
          var token = ts3.scanner.getToken();
          if (token === 92) {
            markAsExternalModuleIfTopLevel();
            token = nextToken();
            if (token === 149) {
              var skipTypeKeyword = ts3.scanner.lookAhead(function() {
                var token2 = ts3.scanner.scan();
                return token2 === 41 || token2 === 18;
              });
              if (skipTypeKeyword) {
                token = nextToken();
              }
            }
            if (token === 18) {
              token = nextToken();
              while (token !== 19 && token !== 1) {
                token = nextToken();
              }
              if (token === 19) {
                token = nextToken();
                if (token === 153) {
                  token = nextToken();
                  if (token === 10) {
                    recordModuleName();
                  }
                }
              }
            } else if (token === 41) {
              token = nextToken();
              if (token === 153) {
                token = nextToken();
                if (token === 10) {
                  recordModuleName();
                }
              }
            } else if (token === 99) {
              token = nextToken();
              if (token === 149) {
                var skipTypeKeyword = ts3.scanner.lookAhead(function() {
                  var token2 = ts3.scanner.scan();
                  return token2 === 78 || ts3.isKeyword(token2);
                });
                if (skipTypeKeyword) {
                  token = nextToken();
                }
              }
              if (token === 78 || ts3.isKeyword(token)) {
                token = nextToken();
                if (token === 62) {
                  if (tryConsumeRequireCall(true)) {
                    return true;
                  }
                }
              }
            }
            return true;
          }
          return false;
        }
        function tryConsumeRequireCall(skipCurrentToken, allowTemplateLiterals) {
          if (allowTemplateLiterals === void 0) {
            allowTemplateLiterals = false;
          }
          var token = skipCurrentToken ? nextToken() : ts3.scanner.getToken();
          if (token === 143) {
            token = nextToken();
            if (token === 20) {
              token = nextToken();
              if (token === 10 || allowTemplateLiterals && token === 14) {
                recordModuleName();
              }
            }
            return true;
          }
          return false;
        }
        function tryConsumeDefine() {
          var token = ts3.scanner.getToken();
          if (token === 78 && ts3.scanner.getTokenValue() === "define") {
            token = nextToken();
            if (token !== 20) {
              return true;
            }
            token = nextToken();
            if (token === 10 || token === 14) {
              token = nextToken();
              if (token === 27) {
                token = nextToken();
              } else {
                return true;
              }
            }
            if (token !== 22) {
              return true;
            }
            token = nextToken();
            while (token !== 23 && token !== 1) {
              if (token === 10 || token === 14) {
                recordModuleName();
              }
              token = nextToken();
            }
            return true;
          }
          return false;
        }
        function processImports() {
          ts3.scanner.setText(sourceText);
          nextToken();
          while (true) {
            if (ts3.scanner.getToken() === 1) {
              break;
            }
            if (tryConsumeDeclare() || tryConsumeImport() || tryConsumeExport() || detectJavaScriptImports && (tryConsumeRequireCall(false, true) || tryConsumeDefine())) {
              continue;
            } else {
              nextToken();
            }
          }
          ts3.scanner.setText(void 0);
        }
        if (readImportFiles) {
          processImports();
        }
        ts3.processCommentPragmas(pragmaContext, sourceText);
        ts3.processPragmasIntoFields(pragmaContext, ts3.noop);
        if (externalModule) {
          if (ambientExternalModules) {
            for (var _i = 0, ambientExternalModules_1 = ambientExternalModules; _i < ambientExternalModules_1.length; _i++) {
              var decl = ambientExternalModules_1[_i];
              importedFiles.push(decl.ref);
            }
          }
          return { referencedFiles: pragmaContext.referencedFiles, typeReferenceDirectives: pragmaContext.typeReferenceDirectives, libReferenceDirectives: pragmaContext.libReferenceDirectives, importedFiles, isLibFile: !!pragmaContext.hasNoDefaultLib, ambientExternalModules: void 0 };
        } else {
          var ambientModuleNames = void 0;
          if (ambientExternalModules) {
            for (var _a2 = 0, ambientExternalModules_2 = ambientExternalModules; _a2 < ambientExternalModules_2.length; _a2++) {
              var decl = ambientExternalModules_2[_a2];
              if (decl.depth === 0) {
                if (!ambientModuleNames) {
                  ambientModuleNames = [];
                }
                ambientModuleNames.push(decl.ref.fileName);
              } else {
                importedFiles.push(decl.ref);
              }
            }
          }
          return { referencedFiles: pragmaContext.referencedFiles, typeReferenceDirectives: pragmaContext.typeReferenceDirectives, libReferenceDirectives: pragmaContext.libReferenceDirectives, importedFiles, isLibFile: !!pragmaContext.hasNoDefaultLib, ambientExternalModules: ambientModuleNames };
        }
      }
      ts3.preProcessFile = preProcessFile;
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var Rename;
      (function(Rename2) {
        function getRenameInfo(program2, sourceFile, position, options) {
          var node = ts3.getAdjustedRenameLocation(ts3.getTouchingPropertyName(sourceFile, position));
          if (nodeIsEligibleForRename(node)) {
            var renameInfo = getRenameInfoForNode(node, program2.getTypeChecker(), sourceFile, program2, options);
            if (renameInfo) {
              return renameInfo;
            }
          }
          return getRenameInfoError(ts3.Diagnostics.You_cannot_rename_this_element);
        }
        Rename2.getRenameInfo = getRenameInfo;
        function getRenameInfoForNode(node, typeChecker, sourceFile, program2, options) {
          var symbol = typeChecker.getSymbolAtLocation(node);
          if (!symbol) {
            if (ts3.isStringLiteralLike(node)) {
              var type3 = ts3.getContextualTypeOrAncestorTypeNodeType(node, typeChecker);
              if (type3 && (type3.flags & 128 || type3.flags & 1048576 && ts3.every(type3.types, function(type4) {
                return !!(type4.flags & 128);
              }))) {
                return getRenameInfoSuccess(node.text, node.text, "string", "", node, sourceFile);
              }
            } else if (ts3.isLabelName(node)) {
              var name = ts3.getTextOfNode(node);
              return getRenameInfoSuccess(name, name, "label", "", node, sourceFile);
            }
            return void 0;
          }
          var declarations = symbol.declarations;
          if (!declarations || declarations.length === 0)
            return;
          if (declarations.some(function(declaration) {
            return isDefinedInLibraryFile(program2, declaration);
          })) {
            return getRenameInfoError(ts3.Diagnostics.You_cannot_rename_elements_that_are_defined_in_the_standard_TypeScript_library);
          }
          if (ts3.isIdentifier(node) && node.originalKeywordKind === 87 && symbol.parent && symbol.parent.flags & 1536) {
            return void 0;
          }
          if (ts3.isStringLiteralLike(node) && ts3.tryGetImportFromModuleSpecifier(node)) {
            return options && options.allowRenameOfImportPath ? getRenameInfoForModule(node, sourceFile, symbol) : void 0;
          }
          var kind = ts3.SymbolDisplay.getSymbolKind(typeChecker, symbol, node);
          var specifierName = ts3.isImportOrExportSpecifierName(node) || ts3.isStringOrNumericLiteralLike(node) && node.parent.kind === 159 ? ts3.stripQuotes(ts3.getTextOfIdentifierOrLiteral(node)) : void 0;
          var displayName = specifierName || typeChecker.symbolToString(symbol);
          var fullDisplayName = specifierName || typeChecker.getFullyQualifiedName(symbol);
          return getRenameInfoSuccess(displayName, fullDisplayName, kind, ts3.SymbolDisplay.getSymbolModifiers(typeChecker, symbol), node, sourceFile);
        }
        function isDefinedInLibraryFile(program2, declaration) {
          var sourceFile = declaration.getSourceFile();
          return program2.isSourceFileDefaultLibrary(sourceFile) && ts3.fileExtensionIs(sourceFile.fileName, ".d.ts");
        }
        function getRenameInfoForModule(node, sourceFile, moduleSymbol) {
          if (!ts3.isExternalModuleNameRelative(node.text)) {
            return getRenameInfoError(ts3.Diagnostics.You_cannot_rename_a_module_via_a_global_import);
          }
          var moduleSourceFile = moduleSymbol.declarations && ts3.find(moduleSymbol.declarations, ts3.isSourceFile);
          if (!moduleSourceFile)
            return void 0;
          var withoutIndex = ts3.endsWith(node.text, "/index") || ts3.endsWith(node.text, "/index.js") ? void 0 : ts3.tryRemoveSuffix(ts3.removeFileExtension(moduleSourceFile.fileName), "/index");
          var name = withoutIndex === void 0 ? moduleSourceFile.fileName : withoutIndex;
          var kind = withoutIndex === void 0 ? "module" : "directory";
          var indexAfterLastSlash = node.text.lastIndexOf("/") + 1;
          var triggerSpan = ts3.createTextSpan(node.getStart(sourceFile) + 1 + indexAfterLastSlash, node.text.length - indexAfterLastSlash);
          return {
            canRename: true,
            fileToRename: name,
            kind,
            displayName: name,
            fullDisplayName: name,
            kindModifiers: "",
            triggerSpan
          };
        }
        function getRenameInfoSuccess(displayName, fullDisplayName, kind, kindModifiers, node, sourceFile) {
          return {
            canRename: true,
            fileToRename: void 0,
            kind,
            displayName,
            fullDisplayName,
            kindModifiers,
            triggerSpan: createTriggerSpanForNode(node, sourceFile)
          };
        }
        function getRenameInfoError(diagnostic) {
          return { canRename: false, localizedErrorMessage: ts3.getLocaleSpecificMessage(diagnostic) };
        }
        function createTriggerSpanForNode(node, sourceFile) {
          var start = node.getStart(sourceFile);
          var width = node.getWidth(sourceFile);
          if (ts3.isStringLiteralLike(node)) {
            start += 1;
            width -= 2;
          }
          return ts3.createTextSpan(start, width);
        }
        function nodeIsEligibleForRename(node) {
          switch (node.kind) {
            case 78:
            case 79:
            case 10:
            case 14:
            case 107:
              return true;
            case 8:
              return ts3.isLiteralNameOfPropertyDeclarationOrIndexAccess(node);
            default:
              return false;
          }
        }
      })(Rename = ts3.Rename || (ts3.Rename = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var SmartSelectionRange;
      (function(SmartSelectionRange2) {
        function getSmartSelectionRange(pos, sourceFile) {
          var _a2;
          var selectionRange = {
            textSpan: ts3.createTextSpanFromBounds(sourceFile.getFullStart(), sourceFile.getEnd())
          };
          var parentNode = sourceFile;
          outer:
            while (true) {
              var children = getSelectionChildren(parentNode);
              if (!children.length)
                break;
              for (var i3 = 0; i3 < children.length; i3++) {
                var prevNode = children[i3 - 1];
                var node = children[i3];
                var nextNode = children[i3 + 1];
                if (ts3.getTokenPosOfNode(node, sourceFile, true) > pos) {
                  break outer;
                }
                var comment = ts3.singleOrUndefined(ts3.getTrailingCommentRanges(sourceFile.text, node.end));
                if (comment && comment.kind === 2) {
                  pushSelectionCommentRange(comment.pos, comment.end);
                }
                if (positionShouldSnapToNode(sourceFile, pos, node)) {
                  if (ts3.isBlock(node) || ts3.isTemplateSpan(node) || ts3.isTemplateHead(node) || ts3.isTemplateTail(node) || prevNode && ts3.isTemplateHead(prevNode) || ts3.isVariableDeclarationList(node) && ts3.isVariableStatement(parentNode) || ts3.isSyntaxList(node) && ts3.isVariableDeclarationList(parentNode) || ts3.isVariableDeclaration(node) && ts3.isSyntaxList(parentNode) && children.length === 1 || ts3.isJSDocTypeExpression(node) || ts3.isJSDocSignature(node) || ts3.isJSDocTypeLiteral(node)) {
                    parentNode = node;
                    break;
                  }
                  if (ts3.isTemplateSpan(parentNode) && nextNode && ts3.isTemplateMiddleOrTemplateTail(nextNode)) {
                    var start_2 = node.getFullStart() - "${".length;
                    var end_2 = nextNode.getStart() + "}".length;
                    pushSelectionRange(start_2, end_2);
                  }
                  var isBetweenMultiLineBookends = ts3.isSyntaxList(node) && isListOpener(prevNode) && isListCloser(nextNode) && !ts3.positionsAreOnSameLine(prevNode.getStart(), nextNode.getStart(), sourceFile);
                  var start = isBetweenMultiLineBookends ? prevNode.getEnd() : node.getStart();
                  var end = isBetweenMultiLineBookends ? nextNode.getStart() : getEndPos(sourceFile, node);
                  if (ts3.hasJSDocNodes(node) && ((_a2 = node.jsDoc) === null || _a2 === void 0 ? void 0 : _a2.length)) {
                    pushSelectionRange(ts3.first(node.jsDoc).getStart(), end);
                  }
                  pushSelectionRange(start, end);
                  if (ts3.isStringLiteral(node) || ts3.isTemplateLiteral(node)) {
                    pushSelectionRange(start + 1, end - 1);
                  }
                  parentNode = node;
                  break;
                }
                if (i3 === children.length - 1) {
                  break outer;
                }
              }
            }
          return selectionRange;
          function pushSelectionRange(start2, end2) {
            if (start2 !== end2) {
              var textSpan = ts3.createTextSpanFromBounds(start2, end2);
              if (!selectionRange || !ts3.textSpansEqual(textSpan, selectionRange.textSpan) && ts3.textSpanIntersectsWithPosition(textSpan, pos)) {
                selectionRange = __assign({ textSpan }, selectionRange && { parent: selectionRange });
              }
            }
          }
          function pushSelectionCommentRange(start2, end2) {
            pushSelectionRange(start2, end2);
            var pos2 = start2;
            while (sourceFile.text.charCodeAt(pos2) === 47) {
              pos2++;
            }
            pushSelectionRange(pos2, end2);
          }
        }
        SmartSelectionRange2.getSmartSelectionRange = getSmartSelectionRange;
        function positionShouldSnapToNode(sourceFile, pos, node) {
          ts3.Debug.assert(node.pos <= pos);
          if (pos < node.end) {
            return true;
          }
          var nodeEnd = node.getEnd();
          if (nodeEnd === pos) {
            return ts3.getTouchingPropertyName(sourceFile, pos).pos < node.end;
          }
          return false;
        }
        var isImport = ts3.or(ts3.isImportDeclaration, ts3.isImportEqualsDeclaration);
        function getSelectionChildren(node) {
          if (ts3.isSourceFile(node)) {
            return groupChildren(node.getChildAt(0).getChildren(), isImport);
          }
          if (ts3.isMappedTypeNode(node)) {
            var _a2 = node.getChildren(), openBraceToken = _a2[0], children = _a2.slice(1);
            var closeBraceToken = ts3.Debug.checkDefined(children.pop());
            ts3.Debug.assertEqual(openBraceToken.kind, 18);
            ts3.Debug.assertEqual(closeBraceToken.kind, 19);
            var groupedWithPlusMinusTokens = groupChildren(children, function(child) {
              return child === node.readonlyToken || child.kind === 142 || child === node.questionToken || child.kind === 57;
            });
            var groupedWithBrackets = groupChildren(groupedWithPlusMinusTokens, function(_a3) {
              var kind = _a3.kind;
              return kind === 22 || kind === 160 || kind === 23;
            });
            return [
              openBraceToken,
              createSyntaxList(splitChildren(groupedWithBrackets, function(_a3) {
                var kind = _a3.kind;
                return kind === 58;
              })),
              closeBraceToken
            ];
          }
          if (ts3.isPropertySignature(node)) {
            var children = groupChildren(node.getChildren(), function(child) {
              return child === node.name || ts3.contains(node.modifiers, child);
            });
            return splitChildren(children, function(_a3) {
              var kind = _a3.kind;
              return kind === 58;
            });
          }
          if (ts3.isParameter(node)) {
            var groupedDotDotDotAndName_1 = groupChildren(node.getChildren(), function(child) {
              return child === node.dotDotDotToken || child === node.name;
            });
            var groupedWithQuestionToken = groupChildren(groupedDotDotDotAndName_1, function(child) {
              return child === groupedDotDotDotAndName_1[0] || child === node.questionToken;
            });
            return splitChildren(groupedWithQuestionToken, function(_a3) {
              var kind = _a3.kind;
              return kind === 62;
            });
          }
          if (ts3.isBindingElement(node)) {
            return splitChildren(node.getChildren(), function(_a3) {
              var kind = _a3.kind;
              return kind === 62;
            });
          }
          return node.getChildren();
        }
        function groupChildren(children, groupOn) {
          var result2 = [];
          var group;
          for (var _i = 0, children_1 = children; _i < children_1.length; _i++) {
            var child = children_1[_i];
            if (groupOn(child)) {
              group = group || [];
              group.push(child);
            } else {
              if (group) {
                result2.push(createSyntaxList(group));
                group = void 0;
              }
              result2.push(child);
            }
          }
          if (group) {
            result2.push(createSyntaxList(group));
          }
          return result2;
        }
        function splitChildren(children, pivotOn, separateTrailingSemicolon) {
          if (separateTrailingSemicolon === void 0) {
            separateTrailingSemicolon = true;
          }
          if (children.length < 2) {
            return children;
          }
          var splitTokenIndex = ts3.findIndex(children, pivotOn);
          if (splitTokenIndex === -1) {
            return children;
          }
          var leftChildren = children.slice(0, splitTokenIndex);
          var splitToken = children[splitTokenIndex];
          var lastToken = ts3.last(children);
          var separateLastToken = separateTrailingSemicolon && lastToken.kind === 26;
          var rightChildren = children.slice(splitTokenIndex + 1, separateLastToken ? children.length - 1 : void 0);
          var result2 = ts3.compact([
            leftChildren.length ? createSyntaxList(leftChildren) : void 0,
            splitToken,
            rightChildren.length ? createSyntaxList(rightChildren) : void 0
          ]);
          return separateLastToken ? result2.concat(lastToken) : result2;
        }
        function createSyntaxList(children) {
          ts3.Debug.assertGreaterThanOrEqual(children.length, 1);
          return ts3.setTextRangePosEnd(ts3.parseNodeFactory.createSyntaxList(children), children[0].pos, ts3.last(children).end);
        }
        function isListOpener(token) {
          var kind = token && token.kind;
          return kind === 18 || kind === 22 || kind === 20 || kind === 276;
        }
        function isListCloser(token) {
          var kind = token && token.kind;
          return kind === 19 || kind === 23 || kind === 21 || kind === 277;
        }
        function getEndPos(sourceFile, node) {
          switch (node.kind) {
            case 330:
            case 328:
            case 337:
            case 335:
            case 332:
              return sourceFile.getLineEndOfPosition(node.getStart());
            default:
              return node.getEnd();
          }
        }
      })(SmartSelectionRange = ts3.SmartSelectionRange || (ts3.SmartSelectionRange = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var SignatureHelp;
      (function(SignatureHelp2) {
        var InvocationKind;
        (function(InvocationKind2) {
          InvocationKind2[InvocationKind2["Call"] = 0] = "Call";
          InvocationKind2[InvocationKind2["TypeArgs"] = 1] = "TypeArgs";
          InvocationKind2[InvocationKind2["Contextual"] = 2] = "Contextual";
        })(InvocationKind || (InvocationKind = {}));
        function getSignatureHelpItems(program2, sourceFile, position, triggerReason, cancellationToken) {
          var typeChecker = program2.getTypeChecker();
          var startingToken = ts3.findTokenOnLeftOfPosition(sourceFile, position);
          if (!startingToken) {
            return void 0;
          }
          var onlyUseSyntacticOwners = !!triggerReason && triggerReason.kind === "characterTyped";
          if (onlyUseSyntacticOwners && (ts3.isInString(sourceFile, position, startingToken) || ts3.isInComment(sourceFile, position))) {
            return void 0;
          }
          var isManuallyInvoked = !!triggerReason && triggerReason.kind === "invoked";
          var argumentInfo = getContainingArgumentInfo(startingToken, position, sourceFile, typeChecker, isManuallyInvoked);
          if (!argumentInfo)
            return void 0;
          cancellationToken.throwIfCancellationRequested();
          var candidateInfo = getCandidateOrTypeInfo(argumentInfo, typeChecker, sourceFile, startingToken, onlyUseSyntacticOwners);
          cancellationToken.throwIfCancellationRequested();
          if (!candidateInfo) {
            return ts3.isSourceFileJS(sourceFile) ? createJSSignatureHelpItems(argumentInfo, program2, cancellationToken) : void 0;
          }
          return typeChecker.runWithCancellationToken(cancellationToken, function(typeChecker2) {
            return candidateInfo.kind === 0 ? createSignatureHelpItems(candidateInfo.candidates, candidateInfo.resolvedSignature, argumentInfo, sourceFile, typeChecker2) : createTypeHelpItems(candidateInfo.symbol, argumentInfo, sourceFile, typeChecker2);
          });
        }
        SignatureHelp2.getSignatureHelpItems = getSignatureHelpItems;
        var CandidateOrTypeKind;
        (function(CandidateOrTypeKind2) {
          CandidateOrTypeKind2[CandidateOrTypeKind2["Candidate"] = 0] = "Candidate";
          CandidateOrTypeKind2[CandidateOrTypeKind2["Type"] = 1] = "Type";
        })(CandidateOrTypeKind || (CandidateOrTypeKind = {}));
        function getCandidateOrTypeInfo(_a2, checker, sourceFile, startingToken, onlyUseSyntacticOwners) {
          var invocation = _a2.invocation, argumentCount = _a2.argumentCount;
          switch (invocation.kind) {
            case 0: {
              if (onlyUseSyntacticOwners && !isSyntacticOwner(startingToken, invocation.node, sourceFile)) {
                return void 0;
              }
              var candidates = [];
              var resolvedSignature = checker.getResolvedSignatureForSignatureHelp(invocation.node, candidates, argumentCount);
              return candidates.length === 0 ? void 0 : { kind: 0, candidates, resolvedSignature };
            }
            case 1: {
              var called = invocation.called;
              if (onlyUseSyntacticOwners && !containsPrecedingToken(startingToken, sourceFile, ts3.isIdentifier(called) ? called.parent : called)) {
                return void 0;
              }
              var candidates = ts3.getPossibleGenericSignatures(called, argumentCount, checker);
              if (candidates.length !== 0)
                return { kind: 0, candidates, resolvedSignature: ts3.first(candidates) };
              var symbol = checker.getSymbolAtLocation(called);
              return symbol && { kind: 1, symbol };
            }
            case 2:
              return { kind: 0, candidates: [invocation.signature], resolvedSignature: invocation.signature };
            default:
              return ts3.Debug.assertNever(invocation);
          }
        }
        function isSyntacticOwner(startingToken, node, sourceFile) {
          if (!ts3.isCallOrNewExpression(node))
            return false;
          var invocationChildren = node.getChildren(sourceFile);
          switch (startingToken.kind) {
            case 20:
              return ts3.contains(invocationChildren, startingToken);
            case 27: {
              var containingList = ts3.findContainingList(startingToken);
              return !!containingList && ts3.contains(invocationChildren, containingList);
            }
            case 29:
              return containsPrecedingToken(startingToken, sourceFile, node.expression);
            default:
              return false;
          }
        }
        function createJSSignatureHelpItems(argumentInfo, program2, cancellationToken) {
          if (argumentInfo.invocation.kind === 2)
            return void 0;
          var expression = getExpressionFromInvocation(argumentInfo.invocation);
          var name = ts3.isPropertyAccessExpression(expression) ? expression.name.text : void 0;
          var typeChecker = program2.getTypeChecker();
          return name === void 0 ? void 0 : ts3.firstDefined(program2.getSourceFiles(), function(sourceFile) {
            return ts3.firstDefined(sourceFile.getNamedDeclarations().get(name), function(declaration) {
              var type3 = declaration.symbol && typeChecker.getTypeOfSymbolAtLocation(declaration.symbol, declaration);
              var callSignatures = type3 && type3.getCallSignatures();
              if (callSignatures && callSignatures.length) {
                return typeChecker.runWithCancellationToken(cancellationToken, function(typeChecker2) {
                  return createSignatureHelpItems(callSignatures, callSignatures[0], argumentInfo, sourceFile, typeChecker2, true);
                });
              }
            });
          });
        }
        function containsPrecedingToken(startingToken, sourceFile, container) {
          var pos = startingToken.getFullStart();
          var currentParent = startingToken.parent;
          while (currentParent) {
            var precedingToken = ts3.findPrecedingToken(pos, sourceFile, currentParent, true);
            if (precedingToken) {
              return ts3.rangeContainsRange(container, precedingToken);
            }
            currentParent = currentParent.parent;
          }
          return ts3.Debug.fail("Could not find preceding token");
        }
        function getArgumentInfoForCompletions(node, position, sourceFile) {
          var info = getImmediatelyContainingArgumentInfo(node, position, sourceFile);
          return !info || info.isTypeParameterList || info.invocation.kind !== 0 ? void 0 : { invocation: info.invocation.node, argumentCount: info.argumentCount, argumentIndex: info.argumentIndex };
        }
        SignatureHelp2.getArgumentInfoForCompletions = getArgumentInfoForCompletions;
        function getArgumentOrParameterListInfo(node, sourceFile) {
          var info = getArgumentOrParameterListAndIndex(node, sourceFile);
          if (!info)
            return void 0;
          var list = info.list, argumentIndex = info.argumentIndex;
          var argumentCount = getArgumentCount(list);
          if (argumentIndex !== 0) {
            ts3.Debug.assertLessThan(argumentIndex, argumentCount);
          }
          var argumentsSpan = getApplicableSpanForArguments(list, sourceFile);
          return { list, argumentIndex, argumentCount, argumentsSpan };
        }
        function getArgumentOrParameterListAndIndex(node, sourceFile) {
          if (node.kind === 29 || node.kind === 20) {
            return { list: getChildListThatStartsWithOpenerToken(node.parent, node, sourceFile), argumentIndex: 0 };
          } else {
            var list = ts3.findContainingList(node);
            return list && { list, argumentIndex: getArgumentIndex(list, node) };
          }
        }
        function getImmediatelyContainingArgumentInfo(node, position, sourceFile) {
          var parent = node.parent;
          if (ts3.isCallOrNewExpression(parent)) {
            var invocation = parent;
            var info = getArgumentOrParameterListInfo(node, sourceFile);
            if (!info)
              return void 0;
            var list = info.list, argumentIndex = info.argumentIndex, argumentCount = info.argumentCount, argumentsSpan = info.argumentsSpan;
            var isTypeParameterList = !!parent.typeArguments && parent.typeArguments.pos === list.pos;
            return { isTypeParameterList, invocation: { kind: 0, node: invocation }, argumentsSpan, argumentIndex, argumentCount };
          } else if (ts3.isNoSubstitutionTemplateLiteral(node) && ts3.isTaggedTemplateExpression(parent)) {
            if (ts3.isInsideTemplateLiteral(node, position, sourceFile)) {
              return getArgumentListInfoForTemplate(parent, 0, sourceFile);
            }
            return void 0;
          } else if (ts3.isTemplateHead(node) && parent.parent.kind === 206) {
            var templateExpression = parent;
            var tagExpression = templateExpression.parent;
            ts3.Debug.assert(templateExpression.kind === 219);
            var argumentIndex = ts3.isInsideTemplateLiteral(node, position, sourceFile) ? 0 : 1;
            return getArgumentListInfoForTemplate(tagExpression, argumentIndex, sourceFile);
          } else if (ts3.isTemplateSpan(parent) && ts3.isTaggedTemplateExpression(parent.parent.parent)) {
            var templateSpan = parent;
            var tagExpression = parent.parent.parent;
            if (ts3.isTemplateTail(node) && !ts3.isInsideTemplateLiteral(node, position, sourceFile)) {
              return void 0;
            }
            var spanIndex = templateSpan.parent.templateSpans.indexOf(templateSpan);
            var argumentIndex = getArgumentIndexForTemplatePiece(spanIndex, node, position, sourceFile);
            return getArgumentListInfoForTemplate(tagExpression, argumentIndex, sourceFile);
          } else if (ts3.isJsxOpeningLikeElement(parent)) {
            var attributeSpanStart = parent.attributes.pos;
            var attributeSpanEnd = ts3.skipTrivia(sourceFile.text, parent.attributes.end, false);
            return {
              isTypeParameterList: false,
              invocation: { kind: 0, node: parent },
              argumentsSpan: ts3.createTextSpan(attributeSpanStart, attributeSpanEnd - attributeSpanStart),
              argumentIndex: 0,
              argumentCount: 1
            };
          } else {
            var typeArgInfo = ts3.getPossibleTypeArgumentsInfo(node, sourceFile);
            if (typeArgInfo) {
              var called = typeArgInfo.called, nTypeArguments = typeArgInfo.nTypeArguments;
              var invocation = { kind: 1, called };
              var argumentsSpan = ts3.createTextSpanFromBounds(called.getStart(sourceFile), node.end);
              return { isTypeParameterList: true, invocation, argumentsSpan, argumentIndex: nTypeArguments, argumentCount: nTypeArguments + 1 };
            }
            return void 0;
          }
        }
        function getImmediatelyContainingArgumentOrContextualParameterInfo(node, position, sourceFile, checker) {
          return tryGetParameterInfo(node, position, sourceFile, checker) || getImmediatelyContainingArgumentInfo(node, position, sourceFile);
        }
        function getHighestBinary(b2) {
          return ts3.isBinaryExpression(b2.parent) ? getHighestBinary(b2.parent) : b2;
        }
        function countBinaryExpressionParameters(b2) {
          return ts3.isBinaryExpression(b2.left) ? countBinaryExpressionParameters(b2.left) + 1 : 2;
        }
        function tryGetParameterInfo(startingToken, _position, sourceFile, checker) {
          var info = getContextualSignatureLocationInfo(startingToken, sourceFile, checker);
          if (!info)
            return void 0;
          var contextualType = info.contextualType, argumentIndex = info.argumentIndex, argumentCount = info.argumentCount, argumentsSpan = info.argumentsSpan;
          var nonNullableContextualType = contextualType.getNonNullableType();
          var signatures = nonNullableContextualType.getCallSignatures();
          if (signatures.length !== 1)
            return void 0;
          var invocation = { kind: 2, signature: ts3.first(signatures), node: startingToken, symbol: chooseBetterSymbol(nonNullableContextualType.symbol) };
          return { isTypeParameterList: false, invocation, argumentsSpan, argumentIndex, argumentCount };
        }
        function getContextualSignatureLocationInfo(startingToken, sourceFile, checker) {
          if (startingToken.kind !== 20 && startingToken.kind !== 27)
            return void 0;
          var parent = startingToken.parent;
          switch (parent.kind) {
            case 208:
            case 166:
            case 209:
            case 210:
              var info = getArgumentOrParameterListInfo(startingToken, sourceFile);
              if (!info)
                return void 0;
              var argumentIndex = info.argumentIndex, argumentCount = info.argumentCount, argumentsSpan = info.argumentsSpan;
              var contextualType = ts3.isMethodDeclaration(parent) ? checker.getContextualTypeForObjectLiteralElement(parent) : checker.getContextualType(parent);
              return contextualType && { contextualType, argumentIndex, argumentCount, argumentsSpan };
            case 217: {
              var highestBinary = getHighestBinary(parent);
              var contextualType_1 = checker.getContextualType(highestBinary);
              var argumentIndex_1 = startingToken.kind === 20 ? 0 : countBinaryExpressionParameters(parent) - 1;
              var argumentCount_1 = countBinaryExpressionParameters(highestBinary);
              return contextualType_1 && { contextualType: contextualType_1, argumentIndex: argumentIndex_1, argumentCount: argumentCount_1, argumentsSpan: ts3.createTextSpanFromNode(parent) };
            }
            default:
              return void 0;
          }
        }
        function chooseBetterSymbol(s2) {
          return s2.name === "__type" ? ts3.firstDefined(s2.declarations, function(d) {
            return ts3.isFunctionTypeNode(d) ? d.parent.symbol : void 0;
          }) || s2 : s2;
        }
        function getArgumentIndex(argumentsList, node) {
          var argumentIndex = 0;
          for (var _i = 0, _a2 = argumentsList.getChildren(); _i < _a2.length; _i++) {
            var child = _a2[_i];
            if (child === node) {
              break;
            }
            if (child.kind !== 27) {
              argumentIndex++;
            }
          }
          return argumentIndex;
        }
        function getArgumentCount(argumentsList) {
          var listChildren = argumentsList.getChildren();
          var argumentCount = ts3.countWhere(listChildren, function(arg2) {
            return arg2.kind !== 27;
          });
          if (listChildren.length > 0 && ts3.last(listChildren).kind === 27) {
            argumentCount++;
          }
          return argumentCount;
        }
        function getArgumentIndexForTemplatePiece(spanIndex, node, position, sourceFile) {
          ts3.Debug.assert(position >= node.getStart(), "Assumed 'position' could not occur before node.");
          if (ts3.isTemplateLiteralToken(node)) {
            if (ts3.isInsideTemplateLiteral(node, position, sourceFile)) {
              return 0;
            }
            return spanIndex + 2;
          }
          return spanIndex + 1;
        }
        function getArgumentListInfoForTemplate(tagExpression, argumentIndex, sourceFile) {
          var argumentCount = ts3.isNoSubstitutionTemplateLiteral(tagExpression.template) ? 1 : tagExpression.template.templateSpans.length + 1;
          if (argumentIndex !== 0) {
            ts3.Debug.assertLessThan(argumentIndex, argumentCount);
          }
          return {
            isTypeParameterList: false,
            invocation: { kind: 0, node: tagExpression },
            argumentsSpan: getApplicableSpanForTaggedTemplate(tagExpression, sourceFile),
            argumentIndex,
            argumentCount
          };
        }
        function getApplicableSpanForArguments(argumentsList, sourceFile) {
          var applicableSpanStart = argumentsList.getFullStart();
          var applicableSpanEnd = ts3.skipTrivia(sourceFile.text, argumentsList.getEnd(), false);
          return ts3.createTextSpan(applicableSpanStart, applicableSpanEnd - applicableSpanStart);
        }
        function getApplicableSpanForTaggedTemplate(taggedTemplate, sourceFile) {
          var template = taggedTemplate.template;
          var applicableSpanStart = template.getStart();
          var applicableSpanEnd = template.getEnd();
          if (template.kind === 219) {
            var lastSpan = ts3.last(template.templateSpans);
            if (lastSpan.literal.getFullWidth() === 0) {
              applicableSpanEnd = ts3.skipTrivia(sourceFile.text, applicableSpanEnd, false);
            }
          }
          return ts3.createTextSpan(applicableSpanStart, applicableSpanEnd - applicableSpanStart);
        }
        function getContainingArgumentInfo(node, position, sourceFile, checker, isManuallyInvoked) {
          var _loop_8 = function(n3) {
            ts3.Debug.assert(ts3.rangeContainsRange(n3.parent, n3), "Not a subspan", function() {
              return "Child: " + ts3.Debug.formatSyntaxKind(n3.kind) + ", parent: " + ts3.Debug.formatSyntaxKind(n3.parent.kind);
            });
            var argumentInfo = getImmediatelyContainingArgumentOrContextualParameterInfo(n3, position, sourceFile, checker);
            if (argumentInfo) {
              return { value: argumentInfo };
            }
          };
          for (var n2 = node; !ts3.isSourceFile(n2) && (isManuallyInvoked || !ts3.isBlock(n2)); n2 = n2.parent) {
            var state_3 = _loop_8(n2);
            if (typeof state_3 === "object")
              return state_3.value;
          }
          return void 0;
        }
        function getChildListThatStartsWithOpenerToken(parent, openerToken, sourceFile) {
          var children = parent.getChildren(sourceFile);
          var indexOfOpenerToken = children.indexOf(openerToken);
          ts3.Debug.assert(indexOfOpenerToken >= 0 && children.length > indexOfOpenerToken + 1);
          return children[indexOfOpenerToken + 1];
        }
        function getExpressionFromInvocation(invocation) {
          return invocation.kind === 0 ? ts3.getInvokedExpression(invocation.node) : invocation.called;
        }
        function getEnclosingDeclarationFromInvocation(invocation) {
          return invocation.kind === 0 ? invocation.node : invocation.kind === 1 ? invocation.called : invocation.node;
        }
        var signatureHelpNodeBuilderFlags = 8192 | 70221824 | 16384;
        function createSignatureHelpItems(candidates, resolvedSignature, _a2, sourceFile, typeChecker, useFullPrefix) {
          var _b;
          var isTypeParameterList = _a2.isTypeParameterList, argumentCount = _a2.argumentCount, applicableSpan = _a2.argumentsSpan, invocation = _a2.invocation, argumentIndex = _a2.argumentIndex;
          var enclosingDeclaration = getEnclosingDeclarationFromInvocation(invocation);
          var callTargetSymbol = invocation.kind === 2 ? invocation.symbol : typeChecker.getSymbolAtLocation(getExpressionFromInvocation(invocation)) || useFullPrefix && ((_b = resolvedSignature.declaration) === null || _b === void 0 ? void 0 : _b.symbol);
          var callTargetDisplayParts = callTargetSymbol ? ts3.symbolToDisplayParts(typeChecker, callTargetSymbol, useFullPrefix ? sourceFile : void 0, void 0) : ts3.emptyArray;
          var items = ts3.map(candidates, function(candidateSignature) {
            return getSignatureHelpItem(candidateSignature, callTargetDisplayParts, isTypeParameterList, typeChecker, enclosingDeclaration, sourceFile);
          });
          if (argumentIndex !== 0) {
            ts3.Debug.assertLessThan(argumentIndex, argumentCount);
          }
          var selectedItemIndex = 0;
          var itemsSeen = 0;
          for (var i3 = 0; i3 < items.length; i3++) {
            var item = items[i3];
            if (candidates[i3] === resolvedSignature) {
              selectedItemIndex = itemsSeen;
              if (item.length > 1) {
                var count = 0;
                for (var _i = 0, item_1 = item; _i < item_1.length; _i++) {
                  var i_1 = item_1[_i];
                  if (i_1.isVariadic || i_1.parameters.length >= argumentCount) {
                    selectedItemIndex = itemsSeen + count;
                    break;
                  }
                  count++;
                }
              }
            }
            itemsSeen += item.length;
          }
          ts3.Debug.assert(selectedItemIndex !== -1);
          var help = { items: ts3.flatMapToMutable(items, ts3.identity), applicableSpan, selectedItemIndex, argumentIndex, argumentCount };
          var selected = help.items[selectedItemIndex];
          if (selected.isVariadic) {
            var firstRest = ts3.findIndex(selected.parameters, function(p) {
              return !!p.isRest;
            });
            if (-1 < firstRest && firstRest < selected.parameters.length - 1) {
              help.argumentIndex = selected.parameters.length;
            } else {
              help.argumentIndex = Math.min(help.argumentIndex, selected.parameters.length - 1);
            }
          }
          return help;
        }
        function createTypeHelpItems(symbol, _a2, sourceFile, checker) {
          var argumentCount = _a2.argumentCount, applicableSpan = _a2.argumentsSpan, invocation = _a2.invocation, argumentIndex = _a2.argumentIndex;
          var typeParameters = checker.getLocalTypeParametersOfClassOrInterfaceOrTypeAlias(symbol);
          if (!typeParameters)
            return void 0;
          var items = [getTypeHelpItem(symbol, typeParameters, checker, getEnclosingDeclarationFromInvocation(invocation), sourceFile)];
          return { items, applicableSpan, selectedItemIndex: 0, argumentIndex, argumentCount };
        }
        function getTypeHelpItem(symbol, typeParameters, checker, enclosingDeclaration, sourceFile) {
          var typeSymbolDisplay = ts3.symbolToDisplayParts(checker, symbol);
          var printer2 = ts3.createPrinter({ removeComments: true });
          var parameters = typeParameters.map(function(t2) {
            return createSignatureHelpParameterForTypeParameter(t2, checker, enclosingDeclaration, sourceFile, printer2);
          });
          var documentation = symbol.getDocumentationComment(checker);
          var tags = symbol.getJsDocTags(checker);
          var prefixDisplayParts = __spreadArray(__spreadArray([], typeSymbolDisplay), [ts3.punctuationPart(29)]);
          return { isVariadic: false, prefixDisplayParts, suffixDisplayParts: [ts3.punctuationPart(31)], separatorDisplayParts, parameters, documentation, tags };
        }
        var separatorDisplayParts = [ts3.punctuationPart(27), ts3.spacePart()];
        function getSignatureHelpItem(candidateSignature, callTargetDisplayParts, isTypeParameterList, checker, enclosingDeclaration, sourceFile) {
          var infos = (isTypeParameterList ? itemInfoForTypeParameters : itemInfoForParameters)(candidateSignature, checker, enclosingDeclaration, sourceFile);
          return ts3.map(infos, function(_a2) {
            var isVariadic = _a2.isVariadic, parameters = _a2.parameters, prefix2 = _a2.prefix, suffix = _a2.suffix;
            var prefixDisplayParts = __spreadArray(__spreadArray([], callTargetDisplayParts), prefix2);
            var suffixDisplayParts = __spreadArray(__spreadArray([], suffix), returnTypeToDisplayParts(candidateSignature, enclosingDeclaration, checker));
            var documentation = candidateSignature.getDocumentationComment(checker);
            var tags = candidateSignature.getJsDocTags();
            return { isVariadic, prefixDisplayParts, suffixDisplayParts, separatorDisplayParts, parameters, documentation, tags };
          });
        }
        function returnTypeToDisplayParts(candidateSignature, enclosingDeclaration, checker) {
          return ts3.mapToDisplayParts(function(writer) {
            writer.writePunctuation(":");
            writer.writeSpace(" ");
            var predicate = checker.getTypePredicateOfSignature(candidateSignature);
            if (predicate) {
              checker.writeTypePredicate(predicate, enclosingDeclaration, void 0, writer);
            } else {
              checker.writeType(checker.getReturnTypeOfSignature(candidateSignature), enclosingDeclaration, void 0, writer);
            }
          });
        }
        function itemInfoForTypeParameters(candidateSignature, checker, enclosingDeclaration, sourceFile) {
          var typeParameters = (candidateSignature.target || candidateSignature).typeParameters;
          var printer2 = ts3.createPrinter({ removeComments: true });
          var parameters = (typeParameters || ts3.emptyArray).map(function(t2) {
            return createSignatureHelpParameterForTypeParameter(t2, checker, enclosingDeclaration, sourceFile, printer2);
          });
          var thisParameter = candidateSignature.thisParameter ? [checker.symbolToParameterDeclaration(candidateSignature.thisParameter, enclosingDeclaration, signatureHelpNodeBuilderFlags)] : [];
          return checker.getExpandedParameters(candidateSignature).map(function(paramList) {
            var params = ts3.factory.createNodeArray(__spreadArray(__spreadArray([], thisParameter), ts3.map(paramList, function(param) {
              return checker.symbolToParameterDeclaration(param, enclosingDeclaration, signatureHelpNodeBuilderFlags);
            })));
            var parameterParts = ts3.mapToDisplayParts(function(writer) {
              printer2.writeList(2576, params, sourceFile, writer);
            });
            return { isVariadic: false, parameters, prefix: [ts3.punctuationPart(29)], suffix: __spreadArray([ts3.punctuationPart(31)], parameterParts) };
          });
        }
        function itemInfoForParameters(candidateSignature, checker, enclosingDeclaration, sourceFile) {
          var isVariadic = checker.hasEffectiveRestParameter(candidateSignature);
          var printer2 = ts3.createPrinter({ removeComments: true });
          var typeParameterParts = ts3.mapToDisplayParts(function(writer) {
            if (candidateSignature.typeParameters && candidateSignature.typeParameters.length) {
              var args = ts3.factory.createNodeArray(candidateSignature.typeParameters.map(function(p) {
                return checker.typeParameterToDeclaration(p, enclosingDeclaration, signatureHelpNodeBuilderFlags);
              }));
              printer2.writeList(53776, args, sourceFile, writer);
            }
          });
          var lists = checker.getExpandedParameters(candidateSignature);
          return lists.map(function(parameterList) {
            return {
              isVariadic: isVariadic && (lists.length === 1 || !!(parameterList[parameterList.length - 1].checkFlags & 32768)),
              parameters: parameterList.map(function(p) {
                return createSignatureHelpParameterForParameter(p, checker, enclosingDeclaration, sourceFile, printer2);
              }),
              prefix: __spreadArray(__spreadArray([], typeParameterParts), [ts3.punctuationPart(20)]),
              suffix: [ts3.punctuationPart(21)]
            };
          });
        }
        function createSignatureHelpParameterForParameter(parameter, checker, enclosingDeclaration, sourceFile, printer2) {
          var displayParts = ts3.mapToDisplayParts(function(writer) {
            var param = checker.symbolToParameterDeclaration(parameter, enclosingDeclaration, signatureHelpNodeBuilderFlags);
            printer2.writeNode(4, param, sourceFile, writer);
          });
          var isOptional = checker.isOptionalParameter(parameter.valueDeclaration);
          var isRest = !!(parameter.checkFlags & 32768);
          return { name: parameter.name, documentation: parameter.getDocumentationComment(checker), displayParts, isOptional, isRest };
        }
        function createSignatureHelpParameterForTypeParameter(typeParameter, checker, enclosingDeclaration, sourceFile, printer2) {
          var displayParts = ts3.mapToDisplayParts(function(writer) {
            var param = checker.typeParameterToDeclaration(typeParameter, enclosingDeclaration, signatureHelpNodeBuilderFlags);
            printer2.writeNode(4, param, sourceFile, writer);
          });
          return { name: typeParameter.symbol.name, documentation: typeParameter.symbol.getDocumentationComment(checker), displayParts, isOptional: false, isRest: false };
        }
      })(SignatureHelp = ts3.SignatureHelp || (ts3.SignatureHelp = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var base64UrlRegExp = /^data:(?:application\/json(?:;charset=[uU][tT][fF]-8);base64,([A-Za-z0-9+\/=]+)$)?/;
      function getSourceMapper(host) {
        var getCanonicalFileName = ts3.createGetCanonicalFileName(host.useCaseSensitiveFileNames());
        var currentDirectory = host.getCurrentDirectory();
        var sourceFileLike = new ts3.Map();
        var documentPositionMappers = new ts3.Map();
        return { tryGetSourcePosition, tryGetGeneratedPosition, toLineColumnOffset, clearCache };
        function toPath(fileName) {
          return ts3.toPath(fileName, currentDirectory, getCanonicalFileName);
        }
        function getDocumentPositionMapper2(generatedFileName, sourceFileName) {
          var path2 = toPath(generatedFileName);
          var value = documentPositionMappers.get(path2);
          if (value)
            return value;
          var mapper;
          if (host.getDocumentPositionMapper) {
            mapper = host.getDocumentPositionMapper(generatedFileName, sourceFileName);
          } else if (host.readFile) {
            var file = getSourceFileLike(generatedFileName);
            mapper = file && ts3.getDocumentPositionMapper({ getSourceFileLike, getCanonicalFileName, log: function(s2) {
              return host.log(s2);
            } }, generatedFileName, ts3.getLineInfo(file.text, ts3.getLineStarts(file)), function(f) {
              return !host.fileExists || host.fileExists(f) ? host.readFile(f) : void 0;
            });
          }
          documentPositionMappers.set(path2, mapper || ts3.identitySourceMapConsumer);
          return mapper || ts3.identitySourceMapConsumer;
        }
        function tryGetSourcePosition(info) {
          if (!ts3.isDeclarationFileName(info.fileName))
            return void 0;
          var file = getSourceFile(info.fileName);
          if (!file)
            return void 0;
          var newLoc = getDocumentPositionMapper2(info.fileName).getSourcePosition(info);
          return !newLoc || newLoc === info ? void 0 : tryGetSourcePosition(newLoc) || newLoc;
        }
        function tryGetGeneratedPosition(info) {
          if (ts3.isDeclarationFileName(info.fileName))
            return void 0;
          var sourceFile = getSourceFile(info.fileName);
          if (!sourceFile)
            return void 0;
          var program2 = host.getProgram();
          if (program2.isSourceOfProjectReferenceRedirect(sourceFile.fileName)) {
            return void 0;
          }
          var options = program2.getCompilerOptions();
          var outPath = ts3.outFile(options);
          var declarationPath = outPath ? ts3.removeFileExtension(outPath) + ".d.ts" : ts3.getDeclarationEmitOutputFilePathWorker(info.fileName, program2.getCompilerOptions(), currentDirectory, program2.getCommonSourceDirectory(), getCanonicalFileName);
          if (declarationPath === void 0)
            return void 0;
          var newLoc = getDocumentPositionMapper2(declarationPath, info.fileName).getGeneratedPosition(info);
          return newLoc === info ? void 0 : newLoc;
        }
        function getSourceFile(fileName) {
          var program2 = host.getProgram();
          if (!program2)
            return void 0;
          var path2 = toPath(fileName);
          var file = program2.getSourceFileByPath(path2);
          return file && file.resolvedPath === path2 ? file : void 0;
        }
        function getOrCreateSourceFileLike(fileName) {
          var path2 = toPath(fileName);
          var fileFromCache = sourceFileLike.get(path2);
          if (fileFromCache !== void 0)
            return fileFromCache ? fileFromCache : void 0;
          if (!host.readFile || host.fileExists && !host.fileExists(path2)) {
            sourceFileLike.set(path2, false);
            return void 0;
          }
          var text = host.readFile(path2);
          var file = text ? createSourceFileLike(text) : false;
          sourceFileLike.set(path2, file);
          return file ? file : void 0;
        }
        function getSourceFileLike(fileName) {
          return !host.getSourceFileLike ? getSourceFile(fileName) || getOrCreateSourceFileLike(fileName) : host.getSourceFileLike(fileName);
        }
        function toLineColumnOffset(fileName, position) {
          var file = getSourceFileLike(fileName);
          return file.getLineAndCharacterOfPosition(position);
        }
        function clearCache() {
          sourceFileLike.clear();
          documentPositionMappers.clear();
        }
      }
      ts3.getSourceMapper = getSourceMapper;
      function getDocumentPositionMapper(host, generatedFileName, generatedFileLineInfo, readMapFile) {
        var mapFileName = ts3.tryGetSourceMappingURL(generatedFileLineInfo);
        if (mapFileName) {
          var match = base64UrlRegExp.exec(mapFileName);
          if (match) {
            if (match[1]) {
              var base64Object = match[1];
              return convertDocumentToSourceMapper(host, ts3.base64decode(ts3.sys, base64Object), generatedFileName);
            }
            mapFileName = void 0;
          }
        }
        var possibleMapLocations = [];
        if (mapFileName) {
          possibleMapLocations.push(mapFileName);
        }
        possibleMapLocations.push(generatedFileName + ".map");
        var originalMapFileName = mapFileName && ts3.getNormalizedAbsolutePath(mapFileName, ts3.getDirectoryPath(generatedFileName));
        for (var _i = 0, possibleMapLocations_1 = possibleMapLocations; _i < possibleMapLocations_1.length; _i++) {
          var location = possibleMapLocations_1[_i];
          var mapFileName_1 = ts3.getNormalizedAbsolutePath(location, ts3.getDirectoryPath(generatedFileName));
          var mapFileContents = readMapFile(mapFileName_1, originalMapFileName);
          if (ts3.isString(mapFileContents)) {
            return convertDocumentToSourceMapper(host, mapFileContents, mapFileName_1);
          }
          if (mapFileContents !== void 0) {
            return mapFileContents || void 0;
          }
        }
        return void 0;
      }
      ts3.getDocumentPositionMapper = getDocumentPositionMapper;
      function convertDocumentToSourceMapper(host, contents, mapFileName) {
        var map2 = ts3.tryParseRawSourceMap(contents);
        if (!map2 || !map2.sources || !map2.file || !map2.mappings) {
          return void 0;
        }
        if (map2.sourcesContent && map2.sourcesContent.some(ts3.isString))
          return void 0;
        return ts3.createDocumentPositionMapper(host, map2, mapFileName);
      }
      function createSourceFileLike(text, lineMap) {
        return {
          text,
          lineMap,
          getLineAndCharacterOfPosition: function(pos) {
            return ts3.computeLineAndCharacterOfPosition(ts3.getLineStarts(this), pos);
          }
        };
      }
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var visitedNestedConvertibleFunctions = new ts3.Map();
      function computeSuggestionDiagnostics(sourceFile, program2, cancellationToken) {
        program2.getSemanticDiagnostics(sourceFile, cancellationToken);
        var diags = [];
        var checker = program2.getTypeChecker();
        if (sourceFile.commonJsModuleIndicator && (ts3.programContainsEs6Modules(program2) || ts3.compilerOptionsIndicateEs6Modules(program2.getCompilerOptions())) && containsTopLevelCommonjs(sourceFile)) {
          diags.push(ts3.createDiagnosticForNode(getErrorNodeFromCommonJsIndicator(sourceFile.commonJsModuleIndicator), ts3.Diagnostics.File_is_a_CommonJS_module_it_may_be_converted_to_an_ES6_module));
        }
        var isJsFile = ts3.isSourceFileJS(sourceFile);
        visitedNestedConvertibleFunctions.clear();
        check(sourceFile);
        if (ts3.getAllowSyntheticDefaultImports(program2.getCompilerOptions())) {
          for (var _i = 0, _a2 = sourceFile.imports; _i < _a2.length; _i++) {
            var moduleSpecifier = _a2[_i];
            var importNode = ts3.importFromModuleSpecifier(moduleSpecifier);
            var name = importNameForConvertToDefaultImport(importNode);
            if (!name)
              continue;
            var module_1 = ts3.getResolvedModule(sourceFile, moduleSpecifier.text);
            var resolvedFile = module_1 && program2.getSourceFile(module_1.resolvedFileName);
            if (resolvedFile && resolvedFile.externalModuleIndicator && ts3.isExportAssignment(resolvedFile.externalModuleIndicator) && resolvedFile.externalModuleIndicator.isExportEquals) {
              diags.push(ts3.createDiagnosticForNode(name, ts3.Diagnostics.Import_may_be_converted_to_a_default_import));
            }
          }
        }
        ts3.addRange(diags, sourceFile.bindSuggestionDiagnostics);
        ts3.addRange(diags, program2.getSuggestionDiagnostics(sourceFile, cancellationToken));
        return diags.sort(function(d1, d2) {
          return d1.start - d2.start;
        });
        function check(node) {
          if (isJsFile) {
            if (canBeConvertedToClass(node, checker)) {
              diags.push(ts3.createDiagnosticForNode(ts3.isVariableDeclaration(node.parent) ? node.parent.name : node, ts3.Diagnostics.This_constructor_function_may_be_converted_to_a_class_declaration));
            }
          } else {
            if (ts3.isVariableStatement(node) && node.parent === sourceFile && node.declarationList.flags & 2 && node.declarationList.declarations.length === 1) {
              var init = node.declarationList.declarations[0].initializer;
              if (init && ts3.isRequireCall(init, true)) {
                diags.push(ts3.createDiagnosticForNode(init, ts3.Diagnostics.require_call_may_be_converted_to_an_import));
              }
            }
            if (ts3.codefix.parameterShouldGetTypeFromJSDoc(node)) {
              diags.push(ts3.createDiagnosticForNode(node.name || node, ts3.Diagnostics.JSDoc_types_may_be_moved_to_TypeScript_types));
            }
          }
          if (canBeConvertedToAsync(node)) {
            addConvertToAsyncFunctionDiagnostics(node, checker, diags);
          }
          node.forEachChild(check);
        }
      }
      ts3.computeSuggestionDiagnostics = computeSuggestionDiagnostics;
      function containsTopLevelCommonjs(sourceFile) {
        return sourceFile.statements.some(function(statement) {
          switch (statement.kind) {
            case 233:
              return statement.declarationList.declarations.some(function(decl) {
                return !!decl.initializer && ts3.isRequireCall(propertyAccessLeftHandSide(decl.initializer), true);
              });
            case 234: {
              var expression = statement.expression;
              if (!ts3.isBinaryExpression(expression))
                return ts3.isRequireCall(expression, true);
              var kind = ts3.getAssignmentDeclarationKind(expression);
              return kind === 1 || kind === 2;
            }
            default:
              return false;
          }
        });
      }
      function propertyAccessLeftHandSide(node) {
        return ts3.isPropertyAccessExpression(node) ? propertyAccessLeftHandSide(node.expression) : node;
      }
      function importNameForConvertToDefaultImport(node) {
        switch (node.kind) {
          case 262:
            var importClause = node.importClause, moduleSpecifier = node.moduleSpecifier;
            return importClause && !importClause.name && importClause.namedBindings && importClause.namedBindings.kind === 264 && ts3.isStringLiteral(moduleSpecifier) ? importClause.namedBindings.name : void 0;
          case 261:
            return node.name;
          default:
            return void 0;
        }
      }
      function addConvertToAsyncFunctionDiagnostics(node, checker, diags) {
        if (isConvertibleFunction(node, checker) && !visitedNestedConvertibleFunctions.has(getKeyFromNode(node))) {
          diags.push(ts3.createDiagnosticForNode(!node.name && ts3.isVariableDeclaration(node.parent) && ts3.isIdentifier(node.parent.name) ? node.parent.name : node, ts3.Diagnostics.This_may_be_converted_to_an_async_function));
        }
      }
      function isConvertibleFunction(node, checker) {
        return !ts3.isAsyncFunction(node) && node.body && ts3.isBlock(node.body) && hasReturnStatementWithPromiseHandler(node.body, checker) && returnsPromise(node, checker);
      }
      function returnsPromise(node, checker) {
        var signature = checker.getSignatureFromDeclaration(node);
        var returnType2 = signature ? checker.getReturnTypeOfSignature(signature) : void 0;
        return !!returnType2 && !!checker.getPromisedTypeOfPromise(returnType2);
      }
      ts3.returnsPromise = returnsPromise;
      function getErrorNodeFromCommonJsIndicator(commonJsModuleIndicator) {
        return ts3.isBinaryExpression(commonJsModuleIndicator) ? commonJsModuleIndicator.left : commonJsModuleIndicator;
      }
      function hasReturnStatementWithPromiseHandler(body, checker) {
        return !!ts3.forEachReturnStatement(body, function(statement) {
          return isReturnStatementWithFixablePromiseHandler(statement, checker);
        });
      }
      function isReturnStatementWithFixablePromiseHandler(node, checker) {
        return ts3.isReturnStatement(node) && !!node.expression && isFixablePromiseHandler(node.expression, checker);
      }
      ts3.isReturnStatementWithFixablePromiseHandler = isReturnStatementWithFixablePromiseHandler;
      function isFixablePromiseHandler(node, checker) {
        if (!isPromiseHandler(node) || !node.arguments.every(function(arg2) {
          return isFixablePromiseArgument(arg2, checker);
        })) {
          return false;
        }
        var currentNode = node.expression;
        while (isPromiseHandler(currentNode) || ts3.isPropertyAccessExpression(currentNode)) {
          if (ts3.isCallExpression(currentNode) && !currentNode.arguments.every(function(arg2) {
            return isFixablePromiseArgument(arg2, checker);
          })) {
            return false;
          }
          currentNode = currentNode.expression;
        }
        return true;
      }
      ts3.isFixablePromiseHandler = isFixablePromiseHandler;
      function isPromiseHandler(node) {
        return ts3.isCallExpression(node) && (ts3.hasPropertyAccessExpressionWithName(node, "then") && hasSupportedNumberOfArguments(node) || ts3.hasPropertyAccessExpressionWithName(node, "catch"));
      }
      function hasSupportedNumberOfArguments(node) {
        if (node.arguments.length > 2)
          return false;
        if (node.arguments.length < 2)
          return true;
        return ts3.some(node.arguments, function(arg2) {
          return arg2.kind === 103 || ts3.isIdentifier(arg2) && arg2.text === "undefined";
        });
      }
      function isFixablePromiseArgument(arg2, checker) {
        switch (arg2.kind) {
          case 252:
          case 209:
          case 210:
            visitedNestedConvertibleFunctions.set(getKeyFromNode(arg2), true);
          case 103:
            return true;
          case 78:
          case 202: {
            var symbol = checker.getSymbolAtLocation(arg2);
            if (!symbol) {
              return false;
            }
            return checker.isUndefinedSymbol(symbol) || ts3.some(ts3.skipAlias(symbol, checker).declarations, function(d) {
              return ts3.isFunctionLike(d) || ts3.hasInitializer(d) && !!d.initializer && ts3.isFunctionLike(d.initializer);
            });
          }
          default:
            return false;
        }
      }
      function getKeyFromNode(exp) {
        return exp.pos.toString() + ":" + exp.end.toString();
      }
      function canBeConvertedToClass(node, checker) {
        var _a2, _b, _c, _d;
        if (node.kind === 209) {
          if (ts3.isVariableDeclaration(node.parent) && ((_a2 = node.symbol.members) === null || _a2 === void 0 ? void 0 : _a2.size)) {
            return true;
          }
          var symbol = checker.getSymbolOfExpando(node, false);
          return !!(symbol && (((_b = symbol.exports) === null || _b === void 0 ? void 0 : _b.size) || ((_c = symbol.members) === null || _c === void 0 ? void 0 : _c.size)));
        }
        if (node.kind === 252) {
          return !!((_d = node.symbol.members) === null || _d === void 0 ? void 0 : _d.size);
        }
        return false;
      }
      function canBeConvertedToAsync(node) {
        switch (node.kind) {
          case 252:
          case 166:
          case 209:
          case 210:
            return true;
          default:
            return false;
        }
      }
      ts3.canBeConvertedToAsync = canBeConvertedToAsync;
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var SymbolDisplay;
      (function(SymbolDisplay2) {
        var symbolDisplayNodeBuilderFlags = 8192 | 70221824 | 16384;
        function getSymbolKind(typeChecker, symbol, location) {
          var result2 = getSymbolKindOfConstructorPropertyMethodAccessorFunctionOrVar(typeChecker, symbol, location);
          if (result2 !== "") {
            return result2;
          }
          var flags = ts3.getCombinedLocalAndExportSymbolFlags(symbol);
          if (flags & 32) {
            return ts3.getDeclarationOfKind(symbol, 222) ? "local class" : "class";
          }
          if (flags & 384)
            return "enum";
          if (flags & 524288)
            return "type";
          if (flags & 64)
            return "interface";
          if (flags & 262144)
            return "type parameter";
          if (flags & 8)
            return "enum member";
          if (flags & 2097152)
            return "alias";
          if (flags & 1536)
            return "module";
          return result2;
        }
        SymbolDisplay2.getSymbolKind = getSymbolKind;
        function getSymbolKindOfConstructorPropertyMethodAccessorFunctionOrVar(typeChecker, symbol, location) {
          var roots = typeChecker.getRootSymbols(symbol);
          if (roots.length === 1 && ts3.first(roots).flags & 8192 && typeChecker.getTypeOfSymbolAtLocation(symbol, location).getNonNullableType().getCallSignatures().length !== 0) {
            return "method";
          }
          if (typeChecker.isUndefinedSymbol(symbol)) {
            return "var";
          }
          if (typeChecker.isArgumentsSymbol(symbol)) {
            return "local var";
          }
          if (location.kind === 107 && ts3.isExpression(location)) {
            return "parameter";
          }
          var flags = ts3.getCombinedLocalAndExportSymbolFlags(symbol);
          if (flags & 3) {
            if (ts3.isFirstDeclarationOfSymbolParameter(symbol)) {
              return "parameter";
            } else if (symbol.valueDeclaration && ts3.isVarConst(symbol.valueDeclaration)) {
              return "const";
            } else if (ts3.forEach(symbol.declarations, ts3.isLet)) {
              return "let";
            }
            return isLocalVariableOrFunction(symbol) ? "local var" : "var";
          }
          if (flags & 16)
            return isLocalVariableOrFunction(symbol) ? "local function" : "function";
          if (flags & 32768)
            return "getter";
          if (flags & 65536)
            return "setter";
          if (flags & 8192)
            return "method";
          if (flags & 16384)
            return "constructor";
          if (flags & 4) {
            if (flags & 33554432 && symbol.checkFlags & 6) {
              var unionPropertyKind = ts3.forEach(typeChecker.getRootSymbols(symbol), function(rootSymbol) {
                var rootSymbolFlags = rootSymbol.getFlags();
                if (rootSymbolFlags & (98308 | 3)) {
                  return "property";
                }
              });
              if (!unionPropertyKind) {
                var typeOfUnionProperty = typeChecker.getTypeOfSymbolAtLocation(symbol, location);
                if (typeOfUnionProperty.getCallSignatures().length) {
                  return "method";
                }
                return "property";
              }
              return unionPropertyKind;
            }
            switch (location.parent && location.parent.kind) {
              case 276:
              case 274:
              case 275:
                return location.kind === 78 ? "property" : "JSX attribute";
              case 281:
                return "JSX attribute";
              default:
                return "property";
            }
          }
          return "";
        }
        function isDeprecatedDeclaration(decl) {
          return !!(ts3.getCombinedNodeFlagsAlwaysIncludeJSDoc(decl) & 8192);
        }
        function getNormalizedSymbolModifiers(symbol) {
          if (symbol.declarations && symbol.declarations.length) {
            var _a2 = symbol.declarations, declaration = _a2[0], declarations = _a2.slice(1);
            var excludeFlags = ts3.length(declarations) && isDeprecatedDeclaration(declaration) && ts3.some(declarations, function(d) {
              return !isDeprecatedDeclaration(d);
            }) ? 8192 : 0;
            var modifiers = ts3.getNodeModifiers(declaration, excludeFlags);
            if (modifiers) {
              return modifiers.split(",");
            }
          }
          return [];
        }
        function getSymbolModifiers(typeChecker, symbol) {
          if (!symbol) {
            return "";
          }
          var modifiers = new ts3.Set(getNormalizedSymbolModifiers(symbol));
          if (symbol.flags & 2097152) {
            var resolvedSymbol = typeChecker.getAliasedSymbol(symbol);
            if (resolvedSymbol !== symbol) {
              ts3.forEach(getNormalizedSymbolModifiers(resolvedSymbol), function(modifier) {
                modifiers.add(modifier);
              });
            }
          }
          if (symbol.flags & 16777216) {
            modifiers.add("optional");
          }
          return modifiers.size > 0 ? ts3.arrayFrom(modifiers.values()).join(",") : "";
        }
        SymbolDisplay2.getSymbolModifiers = getSymbolModifiers;
        function getSymbolDisplayPartsDocumentationAndSymbolKind(typeChecker, symbol, sourceFile, enclosingDeclaration, location, semanticMeaning, alias) {
          var _a2;
          if (semanticMeaning === void 0) {
            semanticMeaning = ts3.getMeaningFromLocation(location);
          }
          var displayParts = [];
          var documentation = [];
          var tags = [];
          var symbolFlags = ts3.getCombinedLocalAndExportSymbolFlags(symbol);
          var symbolKind = semanticMeaning & 1 ? getSymbolKindOfConstructorPropertyMethodAccessorFunctionOrVar(typeChecker, symbol, location) : "";
          var hasAddedSymbolInfo = false;
          var isThisExpression = location.kind === 107 && ts3.isInExpressionContext(location);
          var type3;
          var printer2;
          var documentationFromAlias;
          var tagsFromAlias;
          var hasMultipleSignatures = false;
          if (location.kind === 107 && !isThisExpression) {
            return { displayParts: [ts3.keywordPart(107)], documentation: [], symbolKind: "primitive type", tags: void 0 };
          }
          if (symbolKind !== "" || symbolFlags & 32 || symbolFlags & 2097152) {
            if (symbolKind === "getter" || symbolKind === "setter") {
              symbolKind = "property";
            }
            var signature = void 0;
            type3 = isThisExpression ? typeChecker.getTypeAtLocation(location) : typeChecker.getTypeOfSymbolAtLocation(symbol, location);
            if (location.parent && location.parent.kind === 202) {
              var right = location.parent.name;
              if (right === location || right && right.getFullWidth() === 0) {
                location = location.parent;
              }
            }
            var callExpressionLike = void 0;
            if (ts3.isCallOrNewExpression(location)) {
              callExpressionLike = location;
            } else if (ts3.isCallExpressionTarget(location) || ts3.isNewExpressionTarget(location)) {
              callExpressionLike = location.parent;
            } else if (location.parent && (ts3.isJsxOpeningLikeElement(location.parent) || ts3.isTaggedTemplateExpression(location.parent)) && ts3.isFunctionLike(symbol.valueDeclaration)) {
              callExpressionLike = location.parent;
            }
            if (callExpressionLike) {
              signature = typeChecker.getResolvedSignature(callExpressionLike);
              var useConstructSignatures = callExpressionLike.kind === 205 || ts3.isCallExpression(callExpressionLike) && callExpressionLike.expression.kind === 105;
              var allSignatures = useConstructSignatures ? type3.getConstructSignatures() : type3.getCallSignatures();
              if (signature && !ts3.contains(allSignatures, signature.target) && !ts3.contains(allSignatures, signature)) {
                signature = allSignatures.length ? allSignatures[0] : void 0;
              }
              if (signature) {
                if (useConstructSignatures && symbolFlags & 32) {
                  symbolKind = "constructor";
                  addPrefixForAnyFunctionOrVar(type3.symbol, symbolKind);
                } else if (symbolFlags & 2097152) {
                  symbolKind = "alias";
                  pushSymbolKind(symbolKind);
                  displayParts.push(ts3.spacePart());
                  if (useConstructSignatures) {
                    if (signature.flags & 4) {
                      displayParts.push(ts3.keywordPart(125));
                      displayParts.push(ts3.spacePart());
                    }
                    displayParts.push(ts3.keywordPart(102));
                    displayParts.push(ts3.spacePart());
                  }
                  addFullSymbolName(symbol);
                } else {
                  addPrefixForAnyFunctionOrVar(symbol, symbolKind);
                }
                switch (symbolKind) {
                  case "JSX attribute":
                  case "property":
                  case "var":
                  case "const":
                  case "let":
                  case "parameter":
                  case "local var":
                    displayParts.push(ts3.punctuationPart(58));
                    displayParts.push(ts3.spacePart());
                    if (!(ts3.getObjectFlags(type3) & 16) && type3.symbol) {
                      ts3.addRange(displayParts, ts3.symbolToDisplayParts(typeChecker, type3.symbol, enclosingDeclaration, void 0, 4 | 1));
                      displayParts.push(ts3.lineBreakPart());
                    }
                    if (useConstructSignatures) {
                      if (signature.flags & 4) {
                        displayParts.push(ts3.keywordPart(125));
                        displayParts.push(ts3.spacePart());
                      }
                      displayParts.push(ts3.keywordPart(102));
                      displayParts.push(ts3.spacePart());
                    }
                    addSignatureDisplayParts(signature, allSignatures, 262144);
                    break;
                  default:
                    addSignatureDisplayParts(signature, allSignatures);
                }
                hasAddedSymbolInfo = true;
                hasMultipleSignatures = allSignatures.length > 1;
              }
            } else if (ts3.isNameOfFunctionDeclaration(location) && !(symbolFlags & 98304) || location.kind === 132 && location.parent.kind === 167) {
              var functionDeclaration_1 = location.parent;
              var locationIsSymbolDeclaration = symbol.declarations && ts3.find(symbol.declarations, function(declaration2) {
                return declaration2 === (location.kind === 132 ? functionDeclaration_1.parent : functionDeclaration_1);
              });
              if (locationIsSymbolDeclaration) {
                var allSignatures = functionDeclaration_1.kind === 167 ? type3.getNonNullableType().getConstructSignatures() : type3.getNonNullableType().getCallSignatures();
                if (!typeChecker.isImplementationOfOverload(functionDeclaration_1)) {
                  signature = typeChecker.getSignatureFromDeclaration(functionDeclaration_1);
                } else {
                  signature = allSignatures[0];
                }
                if (functionDeclaration_1.kind === 167) {
                  symbolKind = "constructor";
                  addPrefixForAnyFunctionOrVar(type3.symbol, symbolKind);
                } else {
                  addPrefixForAnyFunctionOrVar(functionDeclaration_1.kind === 170 && !(type3.symbol.flags & 2048 || type3.symbol.flags & 4096) ? type3.symbol : symbol, symbolKind);
                }
                if (signature) {
                  addSignatureDisplayParts(signature, allSignatures);
                }
                hasAddedSymbolInfo = true;
                hasMultipleSignatures = allSignatures.length > 1;
              }
            }
          }
          if (symbolFlags & 32 && !hasAddedSymbolInfo && !isThisExpression) {
            addAliasPrefixIfNecessary();
            if (ts3.getDeclarationOfKind(symbol, 222)) {
              pushSymbolKind("local class");
            } else {
              displayParts.push(ts3.keywordPart(83));
            }
            displayParts.push(ts3.spacePart());
            addFullSymbolName(symbol);
            writeTypeParametersOfSymbol(symbol, sourceFile);
          }
          if (symbolFlags & 64 && semanticMeaning & 2) {
            prefixNextMeaning();
            displayParts.push(ts3.keywordPart(117));
            displayParts.push(ts3.spacePart());
            addFullSymbolName(symbol);
            writeTypeParametersOfSymbol(symbol, sourceFile);
          }
          if (symbolFlags & 524288 && semanticMeaning & 2) {
            prefixNextMeaning();
            displayParts.push(ts3.keywordPart(149));
            displayParts.push(ts3.spacePart());
            addFullSymbolName(symbol);
            writeTypeParametersOfSymbol(symbol, sourceFile);
            displayParts.push(ts3.spacePart());
            displayParts.push(ts3.operatorPart(62));
            displayParts.push(ts3.spacePart());
            ts3.addRange(displayParts, ts3.typeToDisplayParts(typeChecker, typeChecker.getDeclaredTypeOfSymbol(symbol), enclosingDeclaration, 8388608));
          }
          if (symbolFlags & 384) {
            prefixNextMeaning();
            if (ts3.some(symbol.declarations, function(d) {
              return ts3.isEnumDeclaration(d) && ts3.isEnumConst(d);
            })) {
              displayParts.push(ts3.keywordPart(84));
              displayParts.push(ts3.spacePart());
            }
            displayParts.push(ts3.keywordPart(91));
            displayParts.push(ts3.spacePart());
            addFullSymbolName(symbol);
          }
          if (symbolFlags & 1536 && !isThisExpression) {
            prefixNextMeaning();
            var declaration = ts3.getDeclarationOfKind(symbol, 257);
            var isNamespace = declaration && declaration.name && declaration.name.kind === 78;
            displayParts.push(ts3.keywordPart(isNamespace ? 140 : 139));
            displayParts.push(ts3.spacePart());
            addFullSymbolName(symbol);
          }
          if (symbolFlags & 262144 && semanticMeaning & 2) {
            prefixNextMeaning();
            displayParts.push(ts3.punctuationPart(20));
            displayParts.push(ts3.textPart("type parameter"));
            displayParts.push(ts3.punctuationPart(21));
            displayParts.push(ts3.spacePart());
            addFullSymbolName(symbol);
            if (symbol.parent) {
              addInPrefix();
              addFullSymbolName(symbol.parent, enclosingDeclaration);
              writeTypeParametersOfSymbol(symbol.parent, enclosingDeclaration);
            } else {
              var decl = ts3.getDeclarationOfKind(symbol, 160);
              if (decl === void 0)
                return ts3.Debug.fail();
              var declaration = decl.parent;
              if (declaration) {
                if (ts3.isFunctionLikeKind(declaration.kind)) {
                  addInPrefix();
                  var signature = typeChecker.getSignatureFromDeclaration(declaration);
                  if (declaration.kind === 171) {
                    displayParts.push(ts3.keywordPart(102));
                    displayParts.push(ts3.spacePart());
                  } else if (declaration.kind !== 170 && declaration.name) {
                    addFullSymbolName(declaration.symbol);
                  }
                  ts3.addRange(displayParts, ts3.signatureToDisplayParts(typeChecker, signature, sourceFile, 32));
                } else if (declaration.kind === 255) {
                  addInPrefix();
                  displayParts.push(ts3.keywordPart(149));
                  displayParts.push(ts3.spacePart());
                  addFullSymbolName(declaration.symbol);
                  writeTypeParametersOfSymbol(declaration.symbol, sourceFile);
                }
              }
            }
          }
          if (symbolFlags & 8) {
            symbolKind = "enum member";
            addPrefixForAnyFunctionOrVar(symbol, "enum member");
            var declaration = (_a2 = symbol.declarations) === null || _a2 === void 0 ? void 0 : _a2[0];
            if ((declaration === null || declaration === void 0 ? void 0 : declaration.kind) === 292) {
              var constantValue = typeChecker.getConstantValue(declaration);
              if (constantValue !== void 0) {
                displayParts.push(ts3.spacePart());
                displayParts.push(ts3.operatorPart(62));
                displayParts.push(ts3.spacePart());
                displayParts.push(ts3.displayPart(ts3.getTextOfConstantValue(constantValue), typeof constantValue === "number" ? ts3.SymbolDisplayPartKind.numericLiteral : ts3.SymbolDisplayPartKind.stringLiteral));
              }
            }
          }
          if (symbol.flags & 2097152) {
            prefixNextMeaning();
            if (!hasAddedSymbolInfo) {
              var resolvedSymbol = typeChecker.getAliasedSymbol(symbol);
              if (resolvedSymbol !== symbol && resolvedSymbol.declarations && resolvedSymbol.declarations.length > 0) {
                var resolvedNode = resolvedSymbol.declarations[0];
                var declarationName = ts3.getNameOfDeclaration(resolvedNode);
                if (declarationName) {
                  var isExternalModuleDeclaration = ts3.isModuleWithStringLiteralName(resolvedNode) && ts3.hasSyntacticModifier(resolvedNode, 2);
                  var shouldUseAliasName = symbol.name !== "default" && !isExternalModuleDeclaration;
                  var resolvedInfo = getSymbolDisplayPartsDocumentationAndSymbolKind(typeChecker, resolvedSymbol, ts3.getSourceFileOfNode(resolvedNode), resolvedNode, declarationName, semanticMeaning, shouldUseAliasName ? symbol : resolvedSymbol);
                  displayParts.push.apply(displayParts, resolvedInfo.displayParts);
                  displayParts.push(ts3.lineBreakPart());
                  documentationFromAlias = resolvedInfo.documentation;
                  tagsFromAlias = resolvedInfo.tags;
                } else {
                  documentationFromAlias = resolvedSymbol.getContextualDocumentationComment(resolvedNode, typeChecker);
                  tagsFromAlias = resolvedSymbol.getJsDocTags(typeChecker);
                }
              }
            }
            if (symbol.declarations) {
              switch (symbol.declarations[0].kind) {
                case 260:
                  displayParts.push(ts3.keywordPart(92));
                  displayParts.push(ts3.spacePart());
                  displayParts.push(ts3.keywordPart(140));
                  break;
                case 267:
                  displayParts.push(ts3.keywordPart(92));
                  displayParts.push(ts3.spacePart());
                  displayParts.push(ts3.keywordPart(symbol.declarations[0].isExportEquals ? 62 : 87));
                  break;
                case 271:
                  displayParts.push(ts3.keywordPart(92));
                  break;
                default:
                  displayParts.push(ts3.keywordPart(99));
              }
            }
            displayParts.push(ts3.spacePart());
            addFullSymbolName(symbol);
            ts3.forEach(symbol.declarations, function(declaration2) {
              if (declaration2.kind === 261) {
                var importEqualsDeclaration = declaration2;
                if (ts3.isExternalModuleImportEqualsDeclaration(importEqualsDeclaration)) {
                  displayParts.push(ts3.spacePart());
                  displayParts.push(ts3.operatorPart(62));
                  displayParts.push(ts3.spacePart());
                  displayParts.push(ts3.keywordPart(143));
                  displayParts.push(ts3.punctuationPart(20));
                  displayParts.push(ts3.displayPart(ts3.getTextOfNode(ts3.getExternalModuleImportEqualsDeclarationExpression(importEqualsDeclaration)), ts3.SymbolDisplayPartKind.stringLiteral));
                  displayParts.push(ts3.punctuationPart(21));
                } else {
                  var internalAliasSymbol = typeChecker.getSymbolAtLocation(importEqualsDeclaration.moduleReference);
                  if (internalAliasSymbol) {
                    displayParts.push(ts3.spacePart());
                    displayParts.push(ts3.operatorPart(62));
                    displayParts.push(ts3.spacePart());
                    addFullSymbolName(internalAliasSymbol, enclosingDeclaration);
                  }
                }
                return true;
              }
            });
          }
          if (!hasAddedSymbolInfo) {
            if (symbolKind !== "") {
              if (type3) {
                if (isThisExpression) {
                  prefixNextMeaning();
                  displayParts.push(ts3.keywordPart(107));
                } else {
                  addPrefixForAnyFunctionOrVar(symbol, symbolKind);
                }
                if (symbolKind === "property" || symbolKind === "JSX attribute" || symbolFlags & 3 || symbolKind === "local var" || isThisExpression) {
                  displayParts.push(ts3.punctuationPart(58));
                  displayParts.push(ts3.spacePart());
                  if (type3.symbol && type3.symbol.flags & 262144) {
                    var typeParameterParts = ts3.mapToDisplayParts(function(writer) {
                      var param = typeChecker.typeParameterToDeclaration(type3, enclosingDeclaration, symbolDisplayNodeBuilderFlags);
                      getPrinter().writeNode(4, param, ts3.getSourceFileOfNode(ts3.getParseTreeNode(enclosingDeclaration)), writer);
                    });
                    ts3.addRange(displayParts, typeParameterParts);
                  } else {
                    ts3.addRange(displayParts, ts3.typeToDisplayParts(typeChecker, type3, enclosingDeclaration));
                  }
                  if (symbol.target && symbol.target.tupleLabelDeclaration) {
                    var labelDecl = symbol.target.tupleLabelDeclaration;
                    ts3.Debug.assertNode(labelDecl.name, ts3.isIdentifier);
                    displayParts.push(ts3.spacePart());
                    displayParts.push(ts3.punctuationPart(20));
                    displayParts.push(ts3.textPart(ts3.idText(labelDecl.name)));
                    displayParts.push(ts3.punctuationPart(21));
                  }
                } else if (symbolFlags & 16 || symbolFlags & 8192 || symbolFlags & 16384 || symbolFlags & 131072 || symbolFlags & 98304 || symbolKind === "method") {
                  var allSignatures = type3.getNonNullableType().getCallSignatures();
                  if (allSignatures.length) {
                    addSignatureDisplayParts(allSignatures[0], allSignatures);
                    hasMultipleSignatures = allSignatures.length > 1;
                  }
                }
              }
            } else {
              symbolKind = getSymbolKind(typeChecker, symbol, location);
            }
          }
          if (documentation.length === 0 && !hasMultipleSignatures) {
            documentation = symbol.getContextualDocumentationComment(enclosingDeclaration, typeChecker);
          }
          if (documentation.length === 0 && symbolFlags & 4) {
            if (symbol.parent && symbol.declarations && ts3.forEach(symbol.parent.declarations, function(declaration2) {
              return declaration2.kind === 298;
            })) {
              for (var _i = 0, _b = symbol.declarations; _i < _b.length; _i++) {
                var declaration = _b[_i];
                if (!declaration.parent || declaration.parent.kind !== 217) {
                  continue;
                }
                var rhsSymbol = typeChecker.getSymbolAtLocation(declaration.parent.right);
                if (!rhsSymbol) {
                  continue;
                }
                documentation = rhsSymbol.getDocumentationComment(typeChecker);
                tags = rhsSymbol.getJsDocTags(typeChecker);
                if (documentation.length > 0) {
                  break;
                }
              }
            }
          }
          if (tags.length === 0 && !hasMultipleSignatures) {
            tags = symbol.getJsDocTags(typeChecker);
          }
          if (documentation.length === 0 && documentationFromAlias) {
            documentation = documentationFromAlias;
          }
          if (tags.length === 0 && tagsFromAlias) {
            tags = tagsFromAlias;
          }
          return { displayParts, documentation, symbolKind, tags: tags.length === 0 ? void 0 : tags };
          function getPrinter() {
            if (!printer2) {
              printer2 = ts3.createPrinter({ removeComments: true });
            }
            return printer2;
          }
          function prefixNextMeaning() {
            if (displayParts.length) {
              displayParts.push(ts3.lineBreakPart());
            }
            addAliasPrefixIfNecessary();
          }
          function addAliasPrefixIfNecessary() {
            if (alias) {
              pushSymbolKind("alias");
              displayParts.push(ts3.spacePart());
            }
          }
          function addInPrefix() {
            displayParts.push(ts3.spacePart());
            displayParts.push(ts3.keywordPart(100));
            displayParts.push(ts3.spacePart());
          }
          function addFullSymbolName(symbolToDisplay, enclosingDeclaration2) {
            if (alias && symbolToDisplay === symbol) {
              symbolToDisplay = alias;
            }
            var fullSymbolDisplayParts = ts3.symbolToDisplayParts(typeChecker, symbolToDisplay, enclosingDeclaration2 || sourceFile, void 0, 1 | 2 | 4);
            ts3.addRange(displayParts, fullSymbolDisplayParts);
            if (symbol.flags & 16777216) {
              displayParts.push(ts3.punctuationPart(57));
            }
          }
          function addPrefixForAnyFunctionOrVar(symbol2, symbolKind2) {
            prefixNextMeaning();
            if (symbolKind2) {
              pushSymbolKind(symbolKind2);
              if (symbol2 && !ts3.some(symbol2.declarations, function(d) {
                return ts3.isArrowFunction(d) || (ts3.isFunctionExpression(d) || ts3.isClassExpression(d)) && !d.name;
              })) {
                displayParts.push(ts3.spacePart());
                addFullSymbolName(symbol2);
              }
            }
          }
          function pushSymbolKind(symbolKind2) {
            switch (symbolKind2) {
              case "var":
              case "function":
              case "let":
              case "const":
              case "constructor":
                displayParts.push(ts3.textOrKeywordPart(symbolKind2));
                return;
              default:
                displayParts.push(ts3.punctuationPart(20));
                displayParts.push(ts3.textOrKeywordPart(symbolKind2));
                displayParts.push(ts3.punctuationPart(21));
                return;
            }
          }
          function addSignatureDisplayParts(signature2, allSignatures2, flags) {
            if (flags === void 0) {
              flags = 0;
            }
            ts3.addRange(displayParts, ts3.signatureToDisplayParts(typeChecker, signature2, enclosingDeclaration, flags | 32));
            if (allSignatures2.length > 1) {
              displayParts.push(ts3.spacePart());
              displayParts.push(ts3.punctuationPart(20));
              displayParts.push(ts3.operatorPart(39));
              displayParts.push(ts3.displayPart((allSignatures2.length - 1).toString(), ts3.SymbolDisplayPartKind.numericLiteral));
              displayParts.push(ts3.spacePart());
              displayParts.push(ts3.textPart(allSignatures2.length === 2 ? "overload" : "overloads"));
              displayParts.push(ts3.punctuationPart(21));
            }
            documentation = signature2.getDocumentationComment(typeChecker);
            tags = signature2.getJsDocTags();
            if (allSignatures2.length > 1 && documentation.length === 0 && tags.length === 0) {
              documentation = allSignatures2[0].getDocumentationComment(typeChecker);
              tags = allSignatures2[0].getJsDocTags();
            }
          }
          function writeTypeParametersOfSymbol(symbol2, enclosingDeclaration2) {
            var typeParameterParts2 = ts3.mapToDisplayParts(function(writer) {
              var params = typeChecker.symbolToTypeParameterDeclarations(symbol2, enclosingDeclaration2, symbolDisplayNodeBuilderFlags);
              getPrinter().writeList(53776, params, ts3.getSourceFileOfNode(ts3.getParseTreeNode(enclosingDeclaration2)), writer);
            });
            ts3.addRange(displayParts, typeParameterParts2);
          }
        }
        SymbolDisplay2.getSymbolDisplayPartsDocumentationAndSymbolKind = getSymbolDisplayPartsDocumentationAndSymbolKind;
        function isLocalVariableOrFunction(symbol) {
          if (symbol.parent) {
            return false;
          }
          return ts3.forEach(symbol.declarations, function(declaration) {
            if (declaration.kind === 209) {
              return true;
            }
            if (declaration.kind !== 250 && declaration.kind !== 252) {
              return false;
            }
            for (var parent = declaration.parent; !ts3.isFunctionBlock(parent); parent = parent.parent) {
              if (parent.kind === 298 || parent.kind === 258) {
                return false;
              }
            }
            return true;
          });
        }
      })(SymbolDisplay = ts3.SymbolDisplay || (ts3.SymbolDisplay = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      function transpileModule(input, transpileOptions) {
        var diagnostics = [];
        var options = transpileOptions.compilerOptions ? fixupCompilerOptions(transpileOptions.compilerOptions, diagnostics) : {};
        var defaultOptions = ts3.getDefaultCompilerOptions();
        for (var key2 in defaultOptions) {
          if (ts3.hasProperty(defaultOptions, key2) && options[key2] === void 0) {
            options[key2] = defaultOptions[key2];
          }
        }
        for (var _i = 0, transpileOptionValueCompilerOptions_1 = ts3.transpileOptionValueCompilerOptions; _i < transpileOptionValueCompilerOptions_1.length; _i++) {
          var option = transpileOptionValueCompilerOptions_1[_i];
          options[option.name] = option.transpileOptionValue;
        }
        options.suppressOutputPathCheck = true;
        options.allowNonTsExtensions = true;
        var inputFileName = transpileOptions.fileName || (transpileOptions.compilerOptions && transpileOptions.compilerOptions.jsx ? "module.tsx" : "module.ts");
        var sourceFile = ts3.createSourceFile(inputFileName, input, options.target);
        if (transpileOptions.moduleName) {
          sourceFile.moduleName = transpileOptions.moduleName;
        }
        if (transpileOptions.renamedDependencies) {
          sourceFile.renamedDependencies = new ts3.Map(ts3.getEntries(transpileOptions.renamedDependencies));
        }
        var newLine = ts3.getNewLineCharacter(options);
        var outputText;
        var sourceMapText;
        var compilerHost = {
          getSourceFile: function(fileName) {
            return fileName === ts3.normalizePath(inputFileName) ? sourceFile : void 0;
          },
          writeFile: function(name, text) {
            if (ts3.fileExtensionIs(name, ".map")) {
              ts3.Debug.assertEqual(sourceMapText, void 0, "Unexpected multiple source map outputs, file:", name);
              sourceMapText = text;
            } else {
              ts3.Debug.assertEqual(outputText, void 0, "Unexpected multiple outputs, file:", name);
              outputText = text;
            }
          },
          getDefaultLibFileName: function() {
            return "lib.d.ts";
          },
          useCaseSensitiveFileNames: function() {
            return false;
          },
          getCanonicalFileName: function(fileName) {
            return fileName;
          },
          getCurrentDirectory: function() {
            return "";
          },
          getNewLine: function() {
            return newLine;
          },
          fileExists: function(fileName) {
            return fileName === inputFileName;
          },
          readFile: function() {
            return "";
          },
          directoryExists: function() {
            return true;
          },
          getDirectories: function() {
            return [];
          }
        };
        var program2 = ts3.createProgram([inputFileName], options, compilerHost);
        if (transpileOptions.reportDiagnostics) {
          ts3.addRange(diagnostics, program2.getSyntacticDiagnostics(sourceFile));
          ts3.addRange(diagnostics, program2.getOptionsDiagnostics());
        }
        program2.emit(void 0, void 0, void 0, void 0, transpileOptions.transformers);
        if (outputText === void 0)
          return ts3.Debug.fail("Output generation failed");
        return { outputText, diagnostics, sourceMapText };
      }
      ts3.transpileModule = transpileModule;
      function transpile(input, compilerOptions, fileName, diagnostics, moduleName) {
        var output = transpileModule(input, { compilerOptions, fileName, reportDiagnostics: !!diagnostics, moduleName });
        ts3.addRange(diagnostics, output.diagnostics);
        return output.outputText;
      }
      ts3.transpile = transpile;
      var commandLineOptionsStringToEnum;
      function fixupCompilerOptions(options, diagnostics) {
        commandLineOptionsStringToEnum = commandLineOptionsStringToEnum || ts3.filter(ts3.optionDeclarations, function(o2) {
          return typeof o2.type === "object" && !ts3.forEachEntry(o2.type, function(v) {
            return typeof v !== "number";
          });
        });
        options = ts3.cloneCompilerOptions(options);
        var _loop_9 = function(opt2) {
          if (!ts3.hasProperty(options, opt2.name)) {
            return "continue";
          }
          var value = options[opt2.name];
          if (ts3.isString(value)) {
            options[opt2.name] = ts3.parseCustomTypeOption(opt2, value, diagnostics);
          } else {
            if (!ts3.forEachEntry(opt2.type, function(v) {
              return v === value;
            })) {
              diagnostics.push(ts3.createCompilerDiagnosticForInvalidCustomType(opt2));
            }
          }
        };
        for (var _i = 0, commandLineOptionsStringToEnum_1 = commandLineOptionsStringToEnum; _i < commandLineOptionsStringToEnum_1.length; _i++) {
          var opt = commandLineOptionsStringToEnum_1[_i];
          _loop_9(opt);
        }
        return options;
      }
      ts3.fixupCompilerOptions = fixupCompilerOptions;
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var formatting;
      (function(formatting2) {
        var FormattingRequestKind;
        (function(FormattingRequestKind2) {
          FormattingRequestKind2[FormattingRequestKind2["FormatDocument"] = 0] = "FormatDocument";
          FormattingRequestKind2[FormattingRequestKind2["FormatSelection"] = 1] = "FormatSelection";
          FormattingRequestKind2[FormattingRequestKind2["FormatOnEnter"] = 2] = "FormatOnEnter";
          FormattingRequestKind2[FormattingRequestKind2["FormatOnSemicolon"] = 3] = "FormatOnSemicolon";
          FormattingRequestKind2[FormattingRequestKind2["FormatOnOpeningCurlyBrace"] = 4] = "FormatOnOpeningCurlyBrace";
          FormattingRequestKind2[FormattingRequestKind2["FormatOnClosingCurlyBrace"] = 5] = "FormatOnClosingCurlyBrace";
        })(FormattingRequestKind = formatting2.FormattingRequestKind || (formatting2.FormattingRequestKind = {}));
        var FormattingContext = function() {
          function FormattingContext2(sourceFile, formattingRequestKind, options) {
            this.sourceFile = sourceFile;
            this.formattingRequestKind = formattingRequestKind;
            this.options = options;
          }
          FormattingContext2.prototype.updateContext = function(currentRange, currentTokenParent, nextRange, nextTokenParent, commonParent) {
            this.currentTokenSpan = ts3.Debug.checkDefined(currentRange);
            this.currentTokenParent = ts3.Debug.checkDefined(currentTokenParent);
            this.nextTokenSpan = ts3.Debug.checkDefined(nextRange);
            this.nextTokenParent = ts3.Debug.checkDefined(nextTokenParent);
            this.contextNode = ts3.Debug.checkDefined(commonParent);
            this.contextNodeAllOnSameLine = void 0;
            this.nextNodeAllOnSameLine = void 0;
            this.tokensAreOnSameLine = void 0;
            this.contextNodeBlockIsOnOneLine = void 0;
            this.nextNodeBlockIsOnOneLine = void 0;
          };
          FormattingContext2.prototype.ContextNodeAllOnSameLine = function() {
            if (this.contextNodeAllOnSameLine === void 0) {
              this.contextNodeAllOnSameLine = this.NodeIsOnOneLine(this.contextNode);
            }
            return this.contextNodeAllOnSameLine;
          };
          FormattingContext2.prototype.NextNodeAllOnSameLine = function() {
            if (this.nextNodeAllOnSameLine === void 0) {
              this.nextNodeAllOnSameLine = this.NodeIsOnOneLine(this.nextTokenParent);
            }
            return this.nextNodeAllOnSameLine;
          };
          FormattingContext2.prototype.TokensAreOnSameLine = function() {
            if (this.tokensAreOnSameLine === void 0) {
              var startLine = this.sourceFile.getLineAndCharacterOfPosition(this.currentTokenSpan.pos).line;
              var endLine = this.sourceFile.getLineAndCharacterOfPosition(this.nextTokenSpan.pos).line;
              this.tokensAreOnSameLine = startLine === endLine;
            }
            return this.tokensAreOnSameLine;
          };
          FormattingContext2.prototype.ContextNodeBlockIsOnOneLine = function() {
            if (this.contextNodeBlockIsOnOneLine === void 0) {
              this.contextNodeBlockIsOnOneLine = this.BlockIsOnOneLine(this.contextNode);
            }
            return this.contextNodeBlockIsOnOneLine;
          };
          FormattingContext2.prototype.NextNodeBlockIsOnOneLine = function() {
            if (this.nextNodeBlockIsOnOneLine === void 0) {
              this.nextNodeBlockIsOnOneLine = this.BlockIsOnOneLine(this.nextTokenParent);
            }
            return this.nextNodeBlockIsOnOneLine;
          };
          FormattingContext2.prototype.NodeIsOnOneLine = function(node) {
            var startLine = this.sourceFile.getLineAndCharacterOfPosition(node.getStart(this.sourceFile)).line;
            var endLine = this.sourceFile.getLineAndCharacterOfPosition(node.getEnd()).line;
            return startLine === endLine;
          };
          FormattingContext2.prototype.BlockIsOnOneLine = function(node) {
            var openBrace = ts3.findChildOfKind(node, 18, this.sourceFile);
            var closeBrace = ts3.findChildOfKind(node, 19, this.sourceFile);
            if (openBrace && closeBrace) {
              var startLine = this.sourceFile.getLineAndCharacterOfPosition(openBrace.getEnd()).line;
              var endLine = this.sourceFile.getLineAndCharacterOfPosition(closeBrace.getStart(this.sourceFile)).line;
              return startLine === endLine;
            }
            return false;
          };
          return FormattingContext2;
        }();
        formatting2.FormattingContext = FormattingContext;
      })(formatting = ts3.formatting || (ts3.formatting = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var formatting;
      (function(formatting2) {
        var standardScanner = ts3.createScanner(99, false, 0);
        var jsxScanner = ts3.createScanner(99, false, 1);
        var ScanAction;
        (function(ScanAction2) {
          ScanAction2[ScanAction2["Scan"] = 0] = "Scan";
          ScanAction2[ScanAction2["RescanGreaterThanToken"] = 1] = "RescanGreaterThanToken";
          ScanAction2[ScanAction2["RescanSlashToken"] = 2] = "RescanSlashToken";
          ScanAction2[ScanAction2["RescanTemplateToken"] = 3] = "RescanTemplateToken";
          ScanAction2[ScanAction2["RescanJsxIdentifier"] = 4] = "RescanJsxIdentifier";
          ScanAction2[ScanAction2["RescanJsxText"] = 5] = "RescanJsxText";
          ScanAction2[ScanAction2["RescanJsxAttributeValue"] = 6] = "RescanJsxAttributeValue";
        })(ScanAction || (ScanAction = {}));
        function getFormattingScanner(text, languageVariant, startPos, endPos, cb2) {
          var scanner = languageVariant === 1 ? jsxScanner : standardScanner;
          scanner.setText(text);
          scanner.setTextPos(startPos);
          var wasNewLine = true;
          var leadingTrivia;
          var trailingTrivia;
          var savedPos;
          var lastScanAction;
          var lastTokenInfo;
          var res = cb2({
            advance,
            readTokenInfo,
            readEOFTokenRange,
            isOnToken,
            isOnEOF,
            getCurrentLeadingTrivia: function() {
              return leadingTrivia;
            },
            lastTrailingTriviaWasNewLine: function() {
              return wasNewLine;
            },
            skipToEndOf,
            skipToStartOf
          });
          lastTokenInfo = void 0;
          scanner.setText(void 0);
          return res;
          function advance() {
            lastTokenInfo = void 0;
            var isStarted = scanner.getStartPos() !== startPos;
            if (isStarted) {
              wasNewLine = !!trailingTrivia && ts3.last(trailingTrivia).kind === 4;
            } else {
              scanner.scan();
            }
            leadingTrivia = void 0;
            trailingTrivia = void 0;
            var pos = scanner.getStartPos();
            while (pos < endPos) {
              var t2 = scanner.getToken();
              if (!ts3.isTrivia(t2)) {
                break;
              }
              scanner.scan();
              var item = {
                pos,
                end: scanner.getStartPos(),
                kind: t2
              };
              pos = scanner.getStartPos();
              leadingTrivia = ts3.append(leadingTrivia, item);
            }
            savedPos = scanner.getStartPos();
          }
          function shouldRescanGreaterThanToken(node) {
            switch (node.kind) {
              case 33:
              case 70:
              case 71:
              case 49:
              case 48:
                return true;
            }
            return false;
          }
          function shouldRescanJsxIdentifier(node) {
            if (node.parent) {
              switch (node.parent.kind) {
                case 281:
                case 276:
                case 277:
                case 275:
                  return ts3.isKeyword(node.kind) || node.kind === 78;
              }
            }
            return false;
          }
          function shouldRescanJsxText(node) {
            return ts3.isJsxText(node);
          }
          function shouldRescanSlashToken(container) {
            return container.kind === 13;
          }
          function shouldRescanTemplateToken(container) {
            return container.kind === 16 || container.kind === 17;
          }
          function shouldRescanJsxAttributeValue(node) {
            return node.parent && ts3.isJsxAttribute(node.parent) && node.parent.initializer === node;
          }
          function startsWithSlashToken(t2) {
            return t2 === 43 || t2 === 67;
          }
          function readTokenInfo(n2) {
            ts3.Debug.assert(isOnToken());
            var expectedScanAction = shouldRescanGreaterThanToken(n2) ? 1 : shouldRescanSlashToken(n2) ? 2 : shouldRescanTemplateToken(n2) ? 3 : shouldRescanJsxIdentifier(n2) ? 4 : shouldRescanJsxText(n2) ? 5 : shouldRescanJsxAttributeValue(n2) ? 6 : 0;
            if (lastTokenInfo && expectedScanAction === lastScanAction) {
              return fixTokenKind(lastTokenInfo, n2);
            }
            if (scanner.getStartPos() !== savedPos) {
              ts3.Debug.assert(lastTokenInfo !== void 0);
              scanner.setTextPos(savedPos);
              scanner.scan();
            }
            var currentToken = getNextToken(n2, expectedScanAction);
            var token = formatting2.createTextRangeWithKind(scanner.getStartPos(), scanner.getTextPos(), currentToken);
            if (trailingTrivia) {
              trailingTrivia = void 0;
            }
            while (scanner.getStartPos() < endPos) {
              currentToken = scanner.scan();
              if (!ts3.isTrivia(currentToken)) {
                break;
              }
              var trivia = formatting2.createTextRangeWithKind(scanner.getStartPos(), scanner.getTextPos(), currentToken);
              if (!trailingTrivia) {
                trailingTrivia = [];
              }
              trailingTrivia.push(trivia);
              if (currentToken === 4) {
                scanner.scan();
                break;
              }
            }
            lastTokenInfo = { leadingTrivia, trailingTrivia, token };
            return fixTokenKind(lastTokenInfo, n2);
          }
          function getNextToken(n2, expectedScanAction) {
            var token = scanner.getToken();
            lastScanAction = 0;
            switch (expectedScanAction) {
              case 1:
                if (token === 31) {
                  lastScanAction = 1;
                  var newToken = scanner.reScanGreaterToken();
                  ts3.Debug.assert(n2.kind === newToken);
                  return newToken;
                }
                break;
              case 2:
                if (startsWithSlashToken(token)) {
                  lastScanAction = 2;
                  var newToken = scanner.reScanSlashToken();
                  ts3.Debug.assert(n2.kind === newToken);
                  return newToken;
                }
                break;
              case 3:
                if (token === 19) {
                  lastScanAction = 3;
                  return scanner.reScanTemplateToken(false);
                }
                break;
              case 4:
                lastScanAction = 4;
                return scanner.scanJsxIdentifier();
              case 5:
                lastScanAction = 5;
                return scanner.reScanJsxToken(false);
              case 6:
                lastScanAction = 6;
                return scanner.reScanJsxAttributeValue();
              case 0:
                break;
              default:
                ts3.Debug.assertNever(expectedScanAction);
            }
            return token;
          }
          function readEOFTokenRange() {
            ts3.Debug.assert(isOnEOF());
            return formatting2.createTextRangeWithKind(scanner.getStartPos(), scanner.getTextPos(), 1);
          }
          function isOnToken() {
            var current = lastTokenInfo ? lastTokenInfo.token.kind : scanner.getToken();
            var startPos2 = lastTokenInfo ? lastTokenInfo.token.pos : scanner.getStartPos();
            return startPos2 < endPos && current !== 1 && !ts3.isTrivia(current);
          }
          function isOnEOF() {
            var current = lastTokenInfo ? lastTokenInfo.token.kind : scanner.getToken();
            return current === 1;
          }
          function fixTokenKind(tokenInfo, container) {
            if (ts3.isToken(container) && tokenInfo.token.kind !== container.kind) {
              tokenInfo.token.kind = container.kind;
            }
            return tokenInfo;
          }
          function skipToEndOf(node) {
            scanner.setTextPos(node.end);
            savedPos = scanner.getStartPos();
            lastScanAction = void 0;
            lastTokenInfo = void 0;
            wasNewLine = false;
            leadingTrivia = void 0;
            trailingTrivia = void 0;
          }
          function skipToStartOf(node) {
            scanner.setTextPos(node.pos);
            savedPos = scanner.getStartPos();
            lastScanAction = void 0;
            lastTokenInfo = void 0;
            wasNewLine = false;
            leadingTrivia = void 0;
            trailingTrivia = void 0;
          }
        }
        formatting2.getFormattingScanner = getFormattingScanner;
      })(formatting = ts3.formatting || (ts3.formatting = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var formatting;
      (function(formatting2) {
        formatting2.anyContext = ts3.emptyArray;
        var RuleAction;
        (function(RuleAction2) {
          RuleAction2[RuleAction2["StopProcessingSpaceActions"] = 1] = "StopProcessingSpaceActions";
          RuleAction2[RuleAction2["StopProcessingTokenActions"] = 2] = "StopProcessingTokenActions";
          RuleAction2[RuleAction2["InsertSpace"] = 4] = "InsertSpace";
          RuleAction2[RuleAction2["InsertNewLine"] = 8] = "InsertNewLine";
          RuleAction2[RuleAction2["DeleteSpace"] = 16] = "DeleteSpace";
          RuleAction2[RuleAction2["DeleteToken"] = 32] = "DeleteToken";
          RuleAction2[RuleAction2["InsertTrailingSemicolon"] = 64] = "InsertTrailingSemicolon";
          RuleAction2[RuleAction2["StopAction"] = 3] = "StopAction";
          RuleAction2[RuleAction2["ModifySpaceAction"] = 28] = "ModifySpaceAction";
          RuleAction2[RuleAction2["ModifyTokenAction"] = 96] = "ModifyTokenAction";
        })(RuleAction = formatting2.RuleAction || (formatting2.RuleAction = {}));
        var RuleFlags;
        (function(RuleFlags2) {
          RuleFlags2[RuleFlags2["None"] = 0] = "None";
          RuleFlags2[RuleFlags2["CanDeleteNewLines"] = 1] = "CanDeleteNewLines";
        })(RuleFlags = formatting2.RuleFlags || (formatting2.RuleFlags = {}));
      })(formatting = ts3.formatting || (ts3.formatting = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var formatting;
      (function(formatting2) {
        function getAllRules() {
          var allTokens = [];
          for (var token = 0; token <= 157; token++) {
            if (token !== 1) {
              allTokens.push(token);
            }
          }
          function anyTokenExcept() {
            var tokens = [];
            for (var _i = 0; _i < arguments.length; _i++) {
              tokens[_i] = arguments[_i];
            }
            return { tokens: allTokens.filter(function(t2) {
              return !tokens.some(function(t22) {
                return t22 === t2;
              });
            }), isSpecific: false };
          }
          var anyToken = { tokens: allTokens, isSpecific: false };
          var anyTokenIncludingMultilineComments = tokenRangeFrom(__spreadArray(__spreadArray([], allTokens), [3]));
          var anyTokenIncludingEOF = tokenRangeFrom(__spreadArray(__spreadArray([], allTokens), [1]));
          var keywords = tokenRangeFromRange(80, 157);
          var binaryOperators = tokenRangeFromRange(29, 77);
          var binaryKeywordOperators = [100, 101, 157, 126, 137];
          var unaryPrefixOperators = [45, 46, 54, 53];
          var unaryPrefixExpressions = [
            8,
            9,
            78,
            20,
            22,
            18,
            107,
            102
          ];
          var unaryPreincrementExpressions = [78, 20, 107, 102];
          var unaryPostincrementExpressions = [78, 21, 23, 102];
          var unaryPredecrementExpressions = [78, 20, 107, 102];
          var unaryPostdecrementExpressions = [78, 21, 23, 102];
          var comments = [2, 3];
          var typeNames = __spreadArray([78], ts3.typeKeywords);
          var functionOpenBraceLeftTokenRange = anyTokenIncludingMultilineComments;
          var typeScriptOpenBraceLeftTokenRange = tokenRangeFrom([78, 3, 83, 92, 99]);
          var controlOpenBraceLeftTokenRange = tokenRangeFrom([21, 3, 89, 110, 95, 90]);
          var highPriorityCommonRules = [
            rule("IgnoreBeforeComment", anyToken, comments, formatting2.anyContext, 1),
            rule("IgnoreAfterLineComment", 2, anyToken, formatting2.anyContext, 1),
            rule("NotSpaceBeforeColon", anyToken, 58, [isNonJsxSameLineTokenContext, isNotBinaryOpContext, isNotTypeAnnotationContext], 16),
            rule("SpaceAfterColon", 58, anyToken, [isNonJsxSameLineTokenContext, isNotBinaryOpContext], 4),
            rule("NoSpaceBeforeQuestionMark", anyToken, 57, [isNonJsxSameLineTokenContext, isNotBinaryOpContext, isNotTypeAnnotationContext], 16),
            rule("SpaceAfterQuestionMarkInConditionalOperator", 57, anyToken, [isNonJsxSameLineTokenContext, isConditionalOperatorContext], 4),
            rule("NoSpaceAfterQuestionMark", 57, anyToken, [isNonJsxSameLineTokenContext], 16),
            rule("NoSpaceBeforeDot", anyToken, [24, 28], [isNonJsxSameLineTokenContext], 16),
            rule("NoSpaceAfterDot", [24, 28], anyToken, [isNonJsxSameLineTokenContext], 16),
            rule("NoSpaceBetweenImportParenInImportType", 99, 20, [isNonJsxSameLineTokenContext, isImportTypeContext], 16),
            rule("NoSpaceAfterUnaryPrefixOperator", unaryPrefixOperators, unaryPrefixExpressions, [isNonJsxSameLineTokenContext, isNotBinaryOpContext], 16),
            rule("NoSpaceAfterUnaryPreincrementOperator", 45, unaryPreincrementExpressions, [isNonJsxSameLineTokenContext], 16),
            rule("NoSpaceAfterUnaryPredecrementOperator", 46, unaryPredecrementExpressions, [isNonJsxSameLineTokenContext], 16),
            rule("NoSpaceBeforeUnaryPostincrementOperator", unaryPostincrementExpressions, 45, [isNonJsxSameLineTokenContext, isNotStatementConditionContext], 16),
            rule("NoSpaceBeforeUnaryPostdecrementOperator", unaryPostdecrementExpressions, 46, [isNonJsxSameLineTokenContext, isNotStatementConditionContext], 16),
            rule("SpaceAfterPostincrementWhenFollowedByAdd", 45, 39, [isNonJsxSameLineTokenContext, isBinaryOpContext], 4),
            rule("SpaceAfterAddWhenFollowedByUnaryPlus", 39, 39, [isNonJsxSameLineTokenContext, isBinaryOpContext], 4),
            rule("SpaceAfterAddWhenFollowedByPreincrement", 39, 45, [isNonJsxSameLineTokenContext, isBinaryOpContext], 4),
            rule("SpaceAfterPostdecrementWhenFollowedBySubtract", 46, 40, [isNonJsxSameLineTokenContext, isBinaryOpContext], 4),
            rule("SpaceAfterSubtractWhenFollowedByUnaryMinus", 40, 40, [isNonJsxSameLineTokenContext, isBinaryOpContext], 4),
            rule("SpaceAfterSubtractWhenFollowedByPredecrement", 40, 46, [isNonJsxSameLineTokenContext, isBinaryOpContext], 4),
            rule("NoSpaceAfterCloseBrace", 19, [27, 26], [isNonJsxSameLineTokenContext], 16),
            rule("NewLineBeforeCloseBraceInBlockContext", anyTokenIncludingMultilineComments, 19, [isMultilineBlockContext], 8),
            rule("SpaceAfterCloseBrace", 19, anyTokenExcept(21), [isNonJsxSameLineTokenContext, isAfterCodeBlockContext], 4),
            rule("SpaceBetweenCloseBraceAndElse", 19, 90, [isNonJsxSameLineTokenContext], 4),
            rule("SpaceBetweenCloseBraceAndWhile", 19, 114, [isNonJsxSameLineTokenContext], 4),
            rule("NoSpaceBetweenEmptyBraceBrackets", 18, 19, [isNonJsxSameLineTokenContext, isObjectContext], 16),
            rule("SpaceAfterConditionalClosingParen", 21, 22, [isControlDeclContext], 4),
            rule("NoSpaceBetweenFunctionKeywordAndStar", 97, 41, [isFunctionDeclarationOrFunctionExpressionContext], 16),
            rule("SpaceAfterStarInGeneratorDeclaration", 41, 78, [isFunctionDeclarationOrFunctionExpressionContext], 4),
            rule("SpaceAfterFunctionInFuncDecl", 97, anyToken, [isFunctionDeclContext], 4),
            rule("NewLineAfterOpenBraceInBlockContext", 18, anyToken, [isMultilineBlockContext], 8),
            rule("SpaceAfterGetSetInMember", [134, 146], 78, [isFunctionDeclContext], 4),
            rule("NoSpaceBetweenYieldKeywordAndStar", 124, 41, [isNonJsxSameLineTokenContext, isYieldOrYieldStarWithOperand], 16),
            rule("SpaceBetweenYieldOrYieldStarAndOperand", [124, 41], anyToken, [isNonJsxSameLineTokenContext, isYieldOrYieldStarWithOperand], 4),
            rule("NoSpaceBetweenReturnAndSemicolon", 104, 26, [isNonJsxSameLineTokenContext], 16),
            rule("SpaceAfterCertainKeywords", [112, 108, 102, 88, 104, 111, 130], anyToken, [isNonJsxSameLineTokenContext], 4),
            rule("SpaceAfterLetConstInVariableDeclaration", [118, 84], anyToken, [isNonJsxSameLineTokenContext, isStartOfVariableDeclarationList], 4),
            rule("NoSpaceBeforeOpenParenInFuncCall", anyToken, 20, [isNonJsxSameLineTokenContext, isFunctionCallOrNewContext, isPreviousTokenNotComma], 16),
            rule("SpaceBeforeBinaryKeywordOperator", anyToken, binaryKeywordOperators, [isNonJsxSameLineTokenContext, isBinaryOpContext], 4),
            rule("SpaceAfterBinaryKeywordOperator", binaryKeywordOperators, anyToken, [isNonJsxSameLineTokenContext, isBinaryOpContext], 4),
            rule("SpaceAfterVoidOperator", 113, anyToken, [isNonJsxSameLineTokenContext, isVoidOpContext], 4),
            rule("SpaceBetweenAsyncAndOpenParen", 129, 20, [isArrowFunctionContext, isNonJsxSameLineTokenContext], 4),
            rule("SpaceBetweenAsyncAndFunctionKeyword", 129, [97, 78], [isNonJsxSameLineTokenContext], 4),
            rule("NoSpaceBetweenTagAndTemplateString", [78, 21], [14, 15], [isNonJsxSameLineTokenContext], 16),
            rule("SpaceBeforeJsxAttribute", anyToken, 78, [isNextTokenParentJsxAttribute, isNonJsxSameLineTokenContext], 4),
            rule("SpaceBeforeSlashInJsxOpeningElement", anyToken, 43, [isJsxSelfClosingElementContext, isNonJsxSameLineTokenContext], 4),
            rule("NoSpaceBeforeGreaterThanTokenInJsxOpeningElement", 43, 31, [isJsxSelfClosingElementContext, isNonJsxSameLineTokenContext], 16),
            rule("NoSpaceBeforeEqualInJsxAttribute", anyToken, 62, [isJsxAttributeContext, isNonJsxSameLineTokenContext], 16),
            rule("NoSpaceAfterEqualInJsxAttribute", 62, anyToken, [isJsxAttributeContext, isNonJsxSameLineTokenContext], 16),
            rule("NoSpaceAfterModuleImport", [139, 143], 20, [isNonJsxSameLineTokenContext], 16),
            rule("SpaceAfterCertainTypeScriptKeywords", [
              125,
              83,
              133,
              87,
              91,
              92,
              93,
              134,
              116,
              99,
              117,
              139,
              140,
              120,
              122,
              121,
              142,
              146,
              123,
              149,
              153,
              138,
              135
            ], anyToken, [isNonJsxSameLineTokenContext], 4),
            rule("SpaceBeforeCertainTypeScriptKeywords", anyToken, [93, 116, 153], [isNonJsxSameLineTokenContext], 4),
            rule("SpaceAfterModuleName", 10, 18, [isModuleDeclContext], 4),
            rule("SpaceBeforeArrow", anyToken, 38, [isNonJsxSameLineTokenContext], 4),
            rule("SpaceAfterArrow", 38, anyToken, [isNonJsxSameLineTokenContext], 4),
            rule("NoSpaceAfterEllipsis", 25, 78, [isNonJsxSameLineTokenContext], 16),
            rule("NoSpaceAfterOptionalParameters", 57, [21, 27], [isNonJsxSameLineTokenContext, isNotBinaryOpContext], 16),
            rule("NoSpaceBetweenEmptyInterfaceBraceBrackets", 18, 19, [isNonJsxSameLineTokenContext, isObjectTypeContext], 16),
            rule("NoSpaceBeforeOpenAngularBracket", typeNames, 29, [isNonJsxSameLineTokenContext, isTypeArgumentOrParameterOrAssertionContext], 16),
            rule("NoSpaceBetweenCloseParenAndAngularBracket", 21, 29, [isNonJsxSameLineTokenContext, isTypeArgumentOrParameterOrAssertionContext], 16),
            rule("NoSpaceAfterOpenAngularBracket", 29, anyToken, [isNonJsxSameLineTokenContext, isTypeArgumentOrParameterOrAssertionContext], 16),
            rule("NoSpaceBeforeCloseAngularBracket", anyToken, 31, [isNonJsxSameLineTokenContext, isTypeArgumentOrParameterOrAssertionContext], 16),
            rule("NoSpaceAfterCloseAngularBracket", 31, [20, 22, 31, 27], [isNonJsxSameLineTokenContext, isTypeArgumentOrParameterOrAssertionContext, isNotFunctionDeclContext], 16),
            rule("SpaceBeforeAt", [21, 78], 59, [isNonJsxSameLineTokenContext], 4),
            rule("NoSpaceAfterAt", 59, anyToken, [isNonJsxSameLineTokenContext], 16),
            rule("SpaceAfterDecorator", anyToken, [
              125,
              78,
              92,
              87,
              83,
              123,
              122,
              120,
              121,
              134,
              146,
              22,
              41
            ], [isEndOfDecoratorContextOnSameLine], 4),
            rule("NoSpaceBeforeNonNullAssertionOperator", anyToken, 53, [isNonJsxSameLineTokenContext, isNonNullAssertionContext], 16),
            rule("NoSpaceAfterNewKeywordOnConstructorSignature", 102, 20, [isNonJsxSameLineTokenContext, isConstructorSignatureContext], 16),
            rule("SpaceLessThanAndNonJSXTypeAnnotation", 29, 29, [isNonJsxSameLineTokenContext], 4)
          ];
          var userConfigurableRules = [
            rule("SpaceAfterConstructor", 132, 20, [isOptionEnabled("insertSpaceAfterConstructor"), isNonJsxSameLineTokenContext], 4),
            rule("NoSpaceAfterConstructor", 132, 20, [isOptionDisabledOrUndefined("insertSpaceAfterConstructor"), isNonJsxSameLineTokenContext], 16),
            rule("SpaceAfterComma", 27, anyToken, [isOptionEnabled("insertSpaceAfterCommaDelimiter"), isNonJsxSameLineTokenContext, isNonJsxElementOrFragmentContext, isNextTokenNotCloseBracket, isNextTokenNotCloseParen], 4),
            rule("NoSpaceAfterComma", 27, anyToken, [isOptionDisabledOrUndefined("insertSpaceAfterCommaDelimiter"), isNonJsxSameLineTokenContext, isNonJsxElementOrFragmentContext], 16),
            rule("SpaceAfterAnonymousFunctionKeyword", [97, 41], 20, [isOptionEnabled("insertSpaceAfterFunctionKeywordForAnonymousFunctions"), isFunctionDeclContext], 4),
            rule("NoSpaceAfterAnonymousFunctionKeyword", [97, 41], 20, [isOptionDisabledOrUndefined("insertSpaceAfterFunctionKeywordForAnonymousFunctions"), isFunctionDeclContext], 16),
            rule("SpaceAfterKeywordInControl", keywords, 20, [isOptionEnabled("insertSpaceAfterKeywordsInControlFlowStatements"), isControlDeclContext], 4),
            rule("NoSpaceAfterKeywordInControl", keywords, 20, [isOptionDisabledOrUndefined("insertSpaceAfterKeywordsInControlFlowStatements"), isControlDeclContext], 16),
            rule("SpaceAfterOpenParen", 20, anyToken, [isOptionEnabled("insertSpaceAfterOpeningAndBeforeClosingNonemptyParenthesis"), isNonJsxSameLineTokenContext], 4),
            rule("SpaceBeforeCloseParen", anyToken, 21, [isOptionEnabled("insertSpaceAfterOpeningAndBeforeClosingNonemptyParenthesis"), isNonJsxSameLineTokenContext], 4),
            rule("SpaceBetweenOpenParens", 20, 20, [isOptionEnabled("insertSpaceAfterOpeningAndBeforeClosingNonemptyParenthesis"), isNonJsxSameLineTokenContext], 4),
            rule("NoSpaceBetweenParens", 20, 21, [isNonJsxSameLineTokenContext], 16),
            rule("NoSpaceAfterOpenParen", 20, anyToken, [isOptionDisabledOrUndefined("insertSpaceAfterOpeningAndBeforeClosingNonemptyParenthesis"), isNonJsxSameLineTokenContext], 16),
            rule("NoSpaceBeforeCloseParen", anyToken, 21, [isOptionDisabledOrUndefined("insertSpaceAfterOpeningAndBeforeClosingNonemptyParenthesis"), isNonJsxSameLineTokenContext], 16),
            rule("SpaceAfterOpenBracket", 22, anyToken, [isOptionEnabled("insertSpaceAfterOpeningAndBeforeClosingNonemptyBrackets"), isNonJsxSameLineTokenContext], 4),
            rule("SpaceBeforeCloseBracket", anyToken, 23, [isOptionEnabled("insertSpaceAfterOpeningAndBeforeClosingNonemptyBrackets"), isNonJsxSameLineTokenContext], 4),
            rule("NoSpaceBetweenBrackets", 22, 23, [isNonJsxSameLineTokenContext], 16),
            rule("NoSpaceAfterOpenBracket", 22, anyToken, [isOptionDisabledOrUndefined("insertSpaceAfterOpeningAndBeforeClosingNonemptyBrackets"), isNonJsxSameLineTokenContext], 16),
            rule("NoSpaceBeforeCloseBracket", anyToken, 23, [isOptionDisabledOrUndefined("insertSpaceAfterOpeningAndBeforeClosingNonemptyBrackets"), isNonJsxSameLineTokenContext], 16),
            rule("SpaceAfterOpenBrace", 18, anyToken, [isOptionEnabledOrUndefined("insertSpaceAfterOpeningAndBeforeClosingNonemptyBraces"), isBraceWrappedContext], 4),
            rule("SpaceBeforeCloseBrace", anyToken, 19, [isOptionEnabledOrUndefined("insertSpaceAfterOpeningAndBeforeClosingNonemptyBraces"), isBraceWrappedContext], 4),
            rule("NoSpaceBetweenEmptyBraceBrackets", 18, 19, [isNonJsxSameLineTokenContext, isObjectContext], 16),
            rule("NoSpaceAfterOpenBrace", 18, anyToken, [isOptionDisabled("insertSpaceAfterOpeningAndBeforeClosingNonemptyBraces"), isNonJsxSameLineTokenContext], 16),
            rule("NoSpaceBeforeCloseBrace", anyToken, 19, [isOptionDisabled("insertSpaceAfterOpeningAndBeforeClosingNonemptyBraces"), isNonJsxSameLineTokenContext], 16),
            rule("SpaceBetweenEmptyBraceBrackets", 18, 19, [isOptionEnabled("insertSpaceAfterOpeningAndBeforeClosingEmptyBraces")], 4),
            rule("NoSpaceBetweenEmptyBraceBrackets", 18, 19, [isOptionDisabled("insertSpaceAfterOpeningAndBeforeClosingEmptyBraces"), isNonJsxSameLineTokenContext], 16),
            rule("SpaceAfterTemplateHeadAndMiddle", [15, 16], anyToken, [isOptionEnabled("insertSpaceAfterOpeningAndBeforeClosingTemplateStringBraces"), isNonJsxTextContext], 4, 1),
            rule("SpaceBeforeTemplateMiddleAndTail", anyToken, [16, 17], [isOptionEnabled("insertSpaceAfterOpeningAndBeforeClosingTemplateStringBraces"), isNonJsxSameLineTokenContext], 4),
            rule("NoSpaceAfterTemplateHeadAndMiddle", [15, 16], anyToken, [isOptionDisabledOrUndefined("insertSpaceAfterOpeningAndBeforeClosingTemplateStringBraces"), isNonJsxTextContext], 16, 1),
            rule("NoSpaceBeforeTemplateMiddleAndTail", anyToken, [16, 17], [isOptionDisabledOrUndefined("insertSpaceAfterOpeningAndBeforeClosingTemplateStringBraces"), isNonJsxSameLineTokenContext], 16),
            rule("SpaceAfterOpenBraceInJsxExpression", 18, anyToken, [isOptionEnabled("insertSpaceAfterOpeningAndBeforeClosingJsxExpressionBraces"), isNonJsxSameLineTokenContext, isJsxExpressionContext], 4),
            rule("SpaceBeforeCloseBraceInJsxExpression", anyToken, 19, [isOptionEnabled("insertSpaceAfterOpeningAndBeforeClosingJsxExpressionBraces"), isNonJsxSameLineTokenContext, isJsxExpressionContext], 4),
            rule("NoSpaceAfterOpenBraceInJsxExpression", 18, anyToken, [isOptionDisabledOrUndefined("insertSpaceAfterOpeningAndBeforeClosingJsxExpressionBraces"), isNonJsxSameLineTokenContext, isJsxExpressionContext], 16),
            rule("NoSpaceBeforeCloseBraceInJsxExpression", anyToken, 19, [isOptionDisabledOrUndefined("insertSpaceAfterOpeningAndBeforeClosingJsxExpressionBraces"), isNonJsxSameLineTokenContext, isJsxExpressionContext], 16),
            rule("SpaceAfterSemicolonInFor", 26, anyToken, [isOptionEnabled("insertSpaceAfterSemicolonInForStatements"), isNonJsxSameLineTokenContext, isForContext], 4),
            rule("NoSpaceAfterSemicolonInFor", 26, anyToken, [isOptionDisabledOrUndefined("insertSpaceAfterSemicolonInForStatements"), isNonJsxSameLineTokenContext, isForContext], 16),
            rule("SpaceBeforeBinaryOperator", anyToken, binaryOperators, [isOptionEnabled("insertSpaceBeforeAndAfterBinaryOperators"), isNonJsxSameLineTokenContext, isBinaryOpContext], 4),
            rule("SpaceAfterBinaryOperator", binaryOperators, anyToken, [isOptionEnabled("insertSpaceBeforeAndAfterBinaryOperators"), isNonJsxSameLineTokenContext, isBinaryOpContext], 4),
            rule("NoSpaceBeforeBinaryOperator", anyToken, binaryOperators, [isOptionDisabledOrUndefined("insertSpaceBeforeAndAfterBinaryOperators"), isNonJsxSameLineTokenContext, isBinaryOpContext], 16),
            rule("NoSpaceAfterBinaryOperator", binaryOperators, anyToken, [isOptionDisabledOrUndefined("insertSpaceBeforeAndAfterBinaryOperators"), isNonJsxSameLineTokenContext, isBinaryOpContext], 16),
            rule("SpaceBeforeOpenParenInFuncDecl", anyToken, 20, [isOptionEnabled("insertSpaceBeforeFunctionParenthesis"), isNonJsxSameLineTokenContext, isFunctionDeclContext], 4),
            rule("NoSpaceBeforeOpenParenInFuncDecl", anyToken, 20, [isOptionDisabledOrUndefined("insertSpaceBeforeFunctionParenthesis"), isNonJsxSameLineTokenContext, isFunctionDeclContext], 16),
            rule("NewLineBeforeOpenBraceInControl", controlOpenBraceLeftTokenRange, 18, [isOptionEnabled("placeOpenBraceOnNewLineForControlBlocks"), isControlDeclContext, isBeforeMultilineBlockContext], 8, 1),
            rule("NewLineBeforeOpenBraceInFunction", functionOpenBraceLeftTokenRange, 18, [isOptionEnabled("placeOpenBraceOnNewLineForFunctions"), isFunctionDeclContext, isBeforeMultilineBlockContext], 8, 1),
            rule("NewLineBeforeOpenBraceInTypeScriptDeclWithBlock", typeScriptOpenBraceLeftTokenRange, 18, [isOptionEnabled("placeOpenBraceOnNewLineForFunctions"), isTypeScriptDeclWithBlockContext, isBeforeMultilineBlockContext], 8, 1),
            rule("SpaceAfterTypeAssertion", 31, anyToken, [isOptionEnabled("insertSpaceAfterTypeAssertion"), isNonJsxSameLineTokenContext, isTypeAssertionContext], 4),
            rule("NoSpaceAfterTypeAssertion", 31, anyToken, [isOptionDisabledOrUndefined("insertSpaceAfterTypeAssertion"), isNonJsxSameLineTokenContext, isTypeAssertionContext], 16),
            rule("SpaceBeforeTypeAnnotation", anyToken, [57, 58], [isOptionEnabled("insertSpaceBeforeTypeAnnotation"), isNonJsxSameLineTokenContext, isTypeAnnotationContext], 4),
            rule("NoSpaceBeforeTypeAnnotation", anyToken, [57, 58], [isOptionDisabledOrUndefined("insertSpaceBeforeTypeAnnotation"), isNonJsxSameLineTokenContext, isTypeAnnotationContext], 16),
            rule("NoOptionalSemicolon", 26, anyTokenIncludingEOF, [optionEquals("semicolons", ts3.SemicolonPreference.Remove), isSemicolonDeletionContext], 32),
            rule("OptionalSemicolon", anyToken, anyTokenIncludingEOF, [optionEquals("semicolons", ts3.SemicolonPreference.Insert), isSemicolonInsertionContext], 64)
          ];
          var lowPriorityCommonRules = [
            rule("NoSpaceBeforeSemicolon", anyToken, 26, [isNonJsxSameLineTokenContext], 16),
            rule("SpaceBeforeOpenBraceInControl", controlOpenBraceLeftTokenRange, 18, [isOptionDisabledOrUndefinedOrTokensOnSameLine("placeOpenBraceOnNewLineForControlBlocks"), isControlDeclContext, isNotFormatOnEnter, isSameLineTokenOrBeforeBlockContext], 4, 1),
            rule("SpaceBeforeOpenBraceInFunction", functionOpenBraceLeftTokenRange, 18, [isOptionDisabledOrUndefinedOrTokensOnSameLine("placeOpenBraceOnNewLineForFunctions"), isFunctionDeclContext, isBeforeBlockContext, isNotFormatOnEnter, isSameLineTokenOrBeforeBlockContext], 4, 1),
            rule("SpaceBeforeOpenBraceInTypeScriptDeclWithBlock", typeScriptOpenBraceLeftTokenRange, 18, [isOptionDisabledOrUndefinedOrTokensOnSameLine("placeOpenBraceOnNewLineForFunctions"), isTypeScriptDeclWithBlockContext, isNotFormatOnEnter, isSameLineTokenOrBeforeBlockContext], 4, 1),
            rule("NoSpaceBeforeComma", anyToken, 27, [isNonJsxSameLineTokenContext], 16),
            rule("NoSpaceBeforeOpenBracket", anyTokenExcept(129, 81), 22, [isNonJsxSameLineTokenContext], 16),
            rule("NoSpaceAfterCloseBracket", 23, anyToken, [isNonJsxSameLineTokenContext, isNotBeforeBlockInFunctionDeclarationContext], 16),
            rule("SpaceAfterSemicolon", 26, anyToken, [isNonJsxSameLineTokenContext], 4),
            rule("SpaceBetweenForAndAwaitKeyword", 96, 130, [isNonJsxSameLineTokenContext], 4),
            rule("SpaceBetweenStatements", [21, 89, 90, 81], anyToken, [isNonJsxSameLineTokenContext, isNonJsxElementOrFragmentContext, isNotForContext], 4),
            rule("SpaceAfterTryCatchFinally", [110, 82, 95], 18, [isNonJsxSameLineTokenContext], 4)
          ];
          return __spreadArray(__spreadArray(__spreadArray([], highPriorityCommonRules), userConfigurableRules), lowPriorityCommonRules);
        }
        formatting2.getAllRules = getAllRules;
        function rule(debugName, left, right, context, action, flags) {
          if (flags === void 0) {
            flags = 0;
          }
          return { leftTokenRange: toTokenRange(left), rightTokenRange: toTokenRange(right), rule: { debugName, context, action, flags } };
        }
        function tokenRangeFrom(tokens) {
          return { tokens, isSpecific: true };
        }
        function toTokenRange(arg2) {
          return typeof arg2 === "number" ? tokenRangeFrom([arg2]) : ts3.isArray(arg2) ? tokenRangeFrom(arg2) : arg2;
        }
        function tokenRangeFromRange(from, to, except) {
          if (except === void 0) {
            except = [];
          }
          var tokens = [];
          for (var token = from; token <= to; token++) {
            if (!ts3.contains(except, token)) {
              tokens.push(token);
            }
          }
          return tokenRangeFrom(tokens);
        }
        function optionEquals(optionName, optionValue) {
          return function(context) {
            return context.options && context.options[optionName] === optionValue;
          };
        }
        function isOptionEnabled(optionName) {
          return function(context) {
            return context.options && context.options.hasOwnProperty(optionName) && !!context.options[optionName];
          };
        }
        function isOptionDisabled(optionName) {
          return function(context) {
            return context.options && context.options.hasOwnProperty(optionName) && !context.options[optionName];
          };
        }
        function isOptionDisabledOrUndefined(optionName) {
          return function(context) {
            return !context.options || !context.options.hasOwnProperty(optionName) || !context.options[optionName];
          };
        }
        function isOptionDisabledOrUndefinedOrTokensOnSameLine(optionName) {
          return function(context) {
            return !context.options || !context.options.hasOwnProperty(optionName) || !context.options[optionName] || context.TokensAreOnSameLine();
          };
        }
        function isOptionEnabledOrUndefined(optionName) {
          return function(context) {
            return !context.options || !context.options.hasOwnProperty(optionName) || !!context.options[optionName];
          };
        }
        function isForContext(context) {
          return context.contextNode.kind === 238;
        }
        function isNotForContext(context) {
          return !isForContext(context);
        }
        function isBinaryOpContext(context) {
          switch (context.contextNode.kind) {
            case 217:
              return context.contextNode.operatorToken.kind !== 27;
            case 218:
            case 185:
            case 225:
            case 271:
            case 266:
            case 173:
            case 183:
            case 184:
              return true;
            case 199:
            case 255:
            case 261:
            case 250:
            case 161:
            case 292:
            case 164:
            case 163:
              return context.currentTokenSpan.kind === 62 || context.nextTokenSpan.kind === 62;
            case 239:
            case 160:
              return context.currentTokenSpan.kind === 100 || context.nextTokenSpan.kind === 100 || context.currentTokenSpan.kind === 62 || context.nextTokenSpan.kind === 62;
            case 240:
              return context.currentTokenSpan.kind === 157 || context.nextTokenSpan.kind === 157;
          }
          return false;
        }
        function isNotBinaryOpContext(context) {
          return !isBinaryOpContext(context);
        }
        function isNotTypeAnnotationContext(context) {
          return !isTypeAnnotationContext(context);
        }
        function isTypeAnnotationContext(context) {
          var contextKind = context.contextNode.kind;
          return contextKind === 164 || contextKind === 163 || contextKind === 161 || contextKind === 250 || ts3.isFunctionLikeKind(contextKind);
        }
        function isConditionalOperatorContext(context) {
          return context.contextNode.kind === 218 || context.contextNode.kind === 185;
        }
        function isSameLineTokenOrBeforeBlockContext(context) {
          return context.TokensAreOnSameLine() || isBeforeBlockContext(context);
        }
        function isBraceWrappedContext(context) {
          return context.contextNode.kind === 197 || context.contextNode.kind === 191 || isSingleLineBlockContext(context);
        }
        function isBeforeMultilineBlockContext(context) {
          return isBeforeBlockContext(context) && !(context.NextNodeAllOnSameLine() || context.NextNodeBlockIsOnOneLine());
        }
        function isMultilineBlockContext(context) {
          return isBlockContext(context) && !(context.ContextNodeAllOnSameLine() || context.ContextNodeBlockIsOnOneLine());
        }
        function isSingleLineBlockContext(context) {
          return isBlockContext(context) && (context.ContextNodeAllOnSameLine() || context.ContextNodeBlockIsOnOneLine());
        }
        function isBlockContext(context) {
          return nodeIsBlockContext(context.contextNode);
        }
        function isBeforeBlockContext(context) {
          return nodeIsBlockContext(context.nextTokenParent);
        }
        function nodeIsBlockContext(node) {
          if (nodeIsTypeScriptDeclWithBlockContext(node)) {
            return true;
          }
          switch (node.kind) {
            case 231:
            case 259:
            case 201:
            case 258:
              return true;
          }
          return false;
        }
        function isFunctionDeclContext(context) {
          switch (context.contextNode.kind) {
            case 252:
            case 166:
            case 165:
            case 168:
            case 169:
            case 170:
            case 209:
            case 167:
            case 210:
            case 254:
              return true;
          }
          return false;
        }
        function isNotFunctionDeclContext(context) {
          return !isFunctionDeclContext(context);
        }
        function isFunctionDeclarationOrFunctionExpressionContext(context) {
          return context.contextNode.kind === 252 || context.contextNode.kind === 209;
        }
        function isTypeScriptDeclWithBlockContext(context) {
          return nodeIsTypeScriptDeclWithBlockContext(context.contextNode);
        }
        function nodeIsTypeScriptDeclWithBlockContext(node) {
          switch (node.kind) {
            case 253:
            case 222:
            case 254:
            case 256:
            case 178:
            case 257:
            case 268:
            case 269:
            case 262:
            case 265:
              return true;
          }
          return false;
        }
        function isAfterCodeBlockContext(context) {
          switch (context.currentTokenParent.kind) {
            case 253:
            case 257:
            case 256:
            case 288:
            case 258:
            case 245:
              return true;
            case 231: {
              var blockParent = context.currentTokenParent.parent;
              if (!blockParent || blockParent.kind !== 210 && blockParent.kind !== 209) {
                return true;
              }
            }
          }
          return false;
        }
        function isControlDeclContext(context) {
          switch (context.contextNode.kind) {
            case 235:
            case 245:
            case 238:
            case 239:
            case 240:
            case 237:
            case 248:
            case 236:
            case 244:
            case 288:
              return true;
            default:
              return false;
          }
        }
        function isObjectContext(context) {
          return context.contextNode.kind === 201;
        }
        function isFunctionCallContext(context) {
          return context.contextNode.kind === 204;
        }
        function isNewContext(context) {
          return context.contextNode.kind === 205;
        }
        function isFunctionCallOrNewContext(context) {
          return isFunctionCallContext(context) || isNewContext(context);
        }
        function isPreviousTokenNotComma(context) {
          return context.currentTokenSpan.kind !== 27;
        }
        function isNextTokenNotCloseBracket(context) {
          return context.nextTokenSpan.kind !== 23;
        }
        function isNextTokenNotCloseParen(context) {
          return context.nextTokenSpan.kind !== 21;
        }
        function isArrowFunctionContext(context) {
          return context.contextNode.kind === 210;
        }
        function isImportTypeContext(context) {
          return context.contextNode.kind === 196;
        }
        function isNonJsxSameLineTokenContext(context) {
          return context.TokensAreOnSameLine() && context.contextNode.kind !== 11;
        }
        function isNonJsxTextContext(context) {
          return context.contextNode.kind !== 11;
        }
        function isNonJsxElementOrFragmentContext(context) {
          return context.contextNode.kind !== 274 && context.contextNode.kind !== 278;
        }
        function isJsxExpressionContext(context) {
          return context.contextNode.kind === 284 || context.contextNode.kind === 283;
        }
        function isNextTokenParentJsxAttribute(context) {
          return context.nextTokenParent.kind === 281;
        }
        function isJsxAttributeContext(context) {
          return context.contextNode.kind === 281;
        }
        function isJsxSelfClosingElementContext(context) {
          return context.contextNode.kind === 275;
        }
        function isNotBeforeBlockInFunctionDeclarationContext(context) {
          return !isFunctionDeclContext(context) && !isBeforeBlockContext(context);
        }
        function isEndOfDecoratorContextOnSameLine(context) {
          return context.TokensAreOnSameLine() && !!context.contextNode.decorators && nodeIsInDecoratorContext(context.currentTokenParent) && !nodeIsInDecoratorContext(context.nextTokenParent);
        }
        function nodeIsInDecoratorContext(node) {
          while (ts3.isExpressionNode(node)) {
            node = node.parent;
          }
          return node.kind === 162;
        }
        function isStartOfVariableDeclarationList(context) {
          return context.currentTokenParent.kind === 251 && context.currentTokenParent.getStart(context.sourceFile) === context.currentTokenSpan.pos;
        }
        function isNotFormatOnEnter(context) {
          return context.formattingRequestKind !== 2;
        }
        function isModuleDeclContext(context) {
          return context.contextNode.kind === 257;
        }
        function isObjectTypeContext(context) {
          return context.contextNode.kind === 178;
        }
        function isConstructorSignatureContext(context) {
          return context.contextNode.kind === 171;
        }
        function isTypeArgumentOrParameterOrAssertion(token, parent) {
          if (token.kind !== 29 && token.kind !== 31) {
            return false;
          }
          switch (parent.kind) {
            case 174:
            case 207:
            case 255:
            case 253:
            case 222:
            case 254:
            case 252:
            case 209:
            case 210:
            case 166:
            case 165:
            case 170:
            case 171:
            case 204:
            case 205:
            case 224:
              return true;
            default:
              return false;
          }
        }
        function isTypeArgumentOrParameterOrAssertionContext(context) {
          return isTypeArgumentOrParameterOrAssertion(context.currentTokenSpan, context.currentTokenParent) || isTypeArgumentOrParameterOrAssertion(context.nextTokenSpan, context.nextTokenParent);
        }
        function isTypeAssertionContext(context) {
          return context.contextNode.kind === 207;
        }
        function isVoidOpContext(context) {
          return context.currentTokenSpan.kind === 113 && context.currentTokenParent.kind === 213;
        }
        function isYieldOrYieldStarWithOperand(context) {
          return context.contextNode.kind === 220 && context.contextNode.expression !== void 0;
        }
        function isNonNullAssertionContext(context) {
          return context.contextNode.kind === 226;
        }
        function isNotStatementConditionContext(context) {
          return !isStatementConditionContext(context);
        }
        function isStatementConditionContext(context) {
          switch (context.contextNode.kind) {
            case 235:
            case 238:
            case 239:
            case 240:
            case 236:
            case 237:
              return true;
            default:
              return false;
          }
        }
        function isSemicolonDeletionContext(context) {
          var nextTokenKind = context.nextTokenSpan.kind;
          var nextTokenStart = context.nextTokenSpan.pos;
          if (ts3.isTrivia(nextTokenKind)) {
            var nextRealToken = context.nextTokenParent === context.currentTokenParent ? ts3.findNextToken(context.currentTokenParent, ts3.findAncestor(context.currentTokenParent, function(a2) {
              return !a2.parent;
            }), context.sourceFile) : context.nextTokenParent.getFirstToken(context.sourceFile);
            if (!nextRealToken) {
              return true;
            }
            nextTokenKind = nextRealToken.kind;
            nextTokenStart = nextRealToken.getStart(context.sourceFile);
          }
          var startLine = context.sourceFile.getLineAndCharacterOfPosition(context.currentTokenSpan.pos).line;
          var endLine = context.sourceFile.getLineAndCharacterOfPosition(nextTokenStart).line;
          if (startLine === endLine) {
            return nextTokenKind === 19 || nextTokenKind === 1;
          }
          if (nextTokenKind === 230 || nextTokenKind === 26) {
            return false;
          }
          if (context.contextNode.kind === 254 || context.contextNode.kind === 255) {
            return !ts3.isPropertySignature(context.currentTokenParent) || !!context.currentTokenParent.type || nextTokenKind !== 20;
          }
          if (ts3.isPropertyDeclaration(context.currentTokenParent)) {
            return !context.currentTokenParent.initializer;
          }
          return context.currentTokenParent.kind !== 238 && context.currentTokenParent.kind !== 232 && context.currentTokenParent.kind !== 230 && nextTokenKind !== 22 && nextTokenKind !== 20 && nextTokenKind !== 39 && nextTokenKind !== 40 && nextTokenKind !== 43 && nextTokenKind !== 13 && nextTokenKind !== 27 && nextTokenKind !== 219 && nextTokenKind !== 15 && nextTokenKind !== 14 && nextTokenKind !== 24;
        }
        function isSemicolonInsertionContext(context) {
          return ts3.positionIsASICandidate(context.currentTokenSpan.end, context.currentTokenParent, context.sourceFile);
        }
      })(formatting = ts3.formatting || (ts3.formatting = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var formatting;
      (function(formatting2) {
        function getFormatContext(options, host) {
          return { options, getRules: getRulesMap(), host };
        }
        formatting2.getFormatContext = getFormatContext;
        var rulesMapCache;
        function getRulesMap() {
          if (rulesMapCache === void 0) {
            rulesMapCache = createRulesMap(formatting2.getAllRules());
          }
          return rulesMapCache;
        }
        function getRuleActionExclusion(ruleAction) {
          var mask3 = 0;
          if (ruleAction & 1) {
            mask3 |= 28;
          }
          if (ruleAction & 2) {
            mask3 |= 96;
          }
          if (ruleAction & 28) {
            mask3 |= 28;
          }
          if (ruleAction & 96) {
            mask3 |= 96;
          }
          return mask3;
        }
        function createRulesMap(rules) {
          var map2 = buildMap(rules);
          return function(context) {
            var bucket = map2[getRuleBucketIndex(context.currentTokenSpan.kind, context.nextTokenSpan.kind)];
            if (bucket) {
              var rules_1 = [];
              var ruleActionMask = 0;
              for (var _i = 0, bucket_1 = bucket; _i < bucket_1.length; _i++) {
                var rule = bucket_1[_i];
                var acceptRuleActions = ~getRuleActionExclusion(ruleActionMask);
                if (rule.action & acceptRuleActions && ts3.every(rule.context, function(c2) {
                  return c2(context);
                })) {
                  rules_1.push(rule);
                  ruleActionMask |= rule.action;
                }
              }
              if (rules_1.length) {
                return rules_1;
              }
            }
          };
        }
        function buildMap(rules) {
          var map2 = new Array(mapRowLength * mapRowLength);
          var rulesBucketConstructionStateList = new Array(map2.length);
          for (var _i = 0, rules_2 = rules; _i < rules_2.length; _i++) {
            var rule = rules_2[_i];
            var specificRule = rule.leftTokenRange.isSpecific && rule.rightTokenRange.isSpecific;
            for (var _a2 = 0, _b = rule.leftTokenRange.tokens; _a2 < _b.length; _a2++) {
              var left = _b[_a2];
              for (var _c = 0, _d = rule.rightTokenRange.tokens; _c < _d.length; _c++) {
                var right = _d[_c];
                var index = getRuleBucketIndex(left, right);
                var rulesBucket = map2[index];
                if (rulesBucket === void 0) {
                  rulesBucket = map2[index] = [];
                }
                addRule(rulesBucket, rule.rule, specificRule, rulesBucketConstructionStateList, index);
              }
            }
          }
          return map2;
        }
        function getRuleBucketIndex(row, column) {
          ts3.Debug.assert(row <= 157 && column <= 157, "Must compute formatting context from tokens");
          return row * mapRowLength + column;
        }
        var maskBitSize = 5;
        var mask2 = 31;
        var mapRowLength = 157 + 1;
        var RulesPosition;
        (function(RulesPosition2) {
          RulesPosition2[RulesPosition2["StopRulesSpecific"] = 0] = "StopRulesSpecific";
          RulesPosition2[RulesPosition2["StopRulesAny"] = maskBitSize * 1] = "StopRulesAny";
          RulesPosition2[RulesPosition2["ContextRulesSpecific"] = maskBitSize * 2] = "ContextRulesSpecific";
          RulesPosition2[RulesPosition2["ContextRulesAny"] = maskBitSize * 3] = "ContextRulesAny";
          RulesPosition2[RulesPosition2["NoContextRulesSpecific"] = maskBitSize * 4] = "NoContextRulesSpecific";
          RulesPosition2[RulesPosition2["NoContextRulesAny"] = maskBitSize * 5] = "NoContextRulesAny";
        })(RulesPosition || (RulesPosition = {}));
        function addRule(rules, rule, specificTokens, constructionState, rulesBucketIndex) {
          var position = rule.action & 3 ? specificTokens ? RulesPosition.StopRulesSpecific : RulesPosition.StopRulesAny : rule.context !== formatting2.anyContext ? specificTokens ? RulesPosition.ContextRulesSpecific : RulesPosition.ContextRulesAny : specificTokens ? RulesPosition.NoContextRulesSpecific : RulesPosition.NoContextRulesAny;
          var state = constructionState[rulesBucketIndex] || 0;
          rules.splice(getInsertionIndex(state, position), 0, rule);
          constructionState[rulesBucketIndex] = increaseInsertionIndex(state, position);
        }
        function getInsertionIndex(indexBitmap, maskPosition) {
          var index = 0;
          for (var pos = 0; pos <= maskPosition; pos += maskBitSize) {
            index += indexBitmap & mask2;
            indexBitmap >>= maskBitSize;
          }
          return index;
        }
        function increaseInsertionIndex(indexBitmap, maskPosition) {
          var value = (indexBitmap >> maskPosition & mask2) + 1;
          ts3.Debug.assert((value & mask2) === value, "Adding more rules into the sub-bucket than allowed. Maximum allowed is 32 rules.");
          return indexBitmap & ~(mask2 << maskPosition) | value << maskPosition;
        }
      })(formatting = ts3.formatting || (ts3.formatting = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var formatting;
      (function(formatting2) {
        function createTextRangeWithKind(pos, end, kind) {
          var textRangeWithKind = { pos, end, kind };
          if (ts3.Debug.isDebugging) {
            Object.defineProperty(textRangeWithKind, "__debugKind", {
              get: function() {
                return ts3.Debug.formatSyntaxKind(kind);
              }
            });
          }
          return textRangeWithKind;
        }
        formatting2.createTextRangeWithKind = createTextRangeWithKind;
        var Constants;
        (function(Constants2) {
          Constants2[Constants2["Unknown"] = -1] = "Unknown";
        })(Constants || (Constants = {}));
        function formatOnEnter(position, sourceFile, formatContext) {
          var line = sourceFile.getLineAndCharacterOfPosition(position).line;
          if (line === 0) {
            return [];
          }
          var endOfFormatSpan = ts3.getEndLinePosition(line, sourceFile);
          while (ts3.isWhiteSpaceSingleLine(sourceFile.text.charCodeAt(endOfFormatSpan))) {
            endOfFormatSpan--;
          }
          if (ts3.isLineBreak(sourceFile.text.charCodeAt(endOfFormatSpan))) {
            endOfFormatSpan--;
          }
          var span = {
            pos: ts3.getStartPositionOfLine(line - 1, sourceFile),
            end: endOfFormatSpan + 1
          };
          return formatSpan(span, sourceFile, formatContext, 2);
        }
        formatting2.formatOnEnter = formatOnEnter;
        function formatOnSemicolon(position, sourceFile, formatContext) {
          var semicolon = findImmediatelyPrecedingTokenOfKind(position, 26, sourceFile);
          return formatNodeLines(findOutermostNodeWithinListLevel(semicolon), sourceFile, formatContext, 3);
        }
        formatting2.formatOnSemicolon = formatOnSemicolon;
        function formatOnOpeningCurly(position, sourceFile, formatContext) {
          var openingCurly = findImmediatelyPrecedingTokenOfKind(position, 18, sourceFile);
          if (!openingCurly) {
            return [];
          }
          var curlyBraceRange = openingCurly.parent;
          var outermostNode = findOutermostNodeWithinListLevel(curlyBraceRange);
          var textRange = {
            pos: ts3.getLineStartPositionForPosition(outermostNode.getStart(sourceFile), sourceFile),
            end: position
          };
          return formatSpan(textRange, sourceFile, formatContext, 4);
        }
        formatting2.formatOnOpeningCurly = formatOnOpeningCurly;
        function formatOnClosingCurly(position, sourceFile, formatContext) {
          var precedingToken = findImmediatelyPrecedingTokenOfKind(position, 19, sourceFile);
          return formatNodeLines(findOutermostNodeWithinListLevel(precedingToken), sourceFile, formatContext, 5);
        }
        formatting2.formatOnClosingCurly = formatOnClosingCurly;
        function formatDocument(sourceFile, formatContext) {
          var span = {
            pos: 0,
            end: sourceFile.text.length
          };
          return formatSpan(span, sourceFile, formatContext, 0);
        }
        formatting2.formatDocument = formatDocument;
        function formatSelection(start, end, sourceFile, formatContext) {
          var span = {
            pos: ts3.getLineStartPositionForPosition(start, sourceFile),
            end
          };
          return formatSpan(span, sourceFile, formatContext, 1);
        }
        formatting2.formatSelection = formatSelection;
        function findImmediatelyPrecedingTokenOfKind(end, expectedTokenKind, sourceFile) {
          var precedingToken = ts3.findPrecedingToken(end, sourceFile);
          return precedingToken && precedingToken.kind === expectedTokenKind && end === precedingToken.getEnd() ? precedingToken : void 0;
        }
        function findOutermostNodeWithinListLevel(node) {
          var current = node;
          while (current && current.parent && current.parent.end === node.end && !isListElement(current.parent, current)) {
            current = current.parent;
          }
          return current;
        }
        function isListElement(parent, node) {
          switch (parent.kind) {
            case 253:
            case 254:
              return ts3.rangeContainsRange(parent.members, node);
            case 257:
              var body = parent.body;
              return !!body && body.kind === 258 && ts3.rangeContainsRange(body.statements, node);
            case 298:
            case 231:
            case 258:
              return ts3.rangeContainsRange(parent.statements, node);
            case 288:
              return ts3.rangeContainsRange(parent.block.statements, node);
          }
          return false;
        }
        function findEnclosingNode(range, sourceFile) {
          return find(sourceFile);
          function find(n2) {
            var candidate = ts3.forEachChild(n2, function(c2) {
              return ts3.startEndContainsRange(c2.getStart(sourceFile), c2.end, range) && c2;
            });
            if (candidate) {
              var result2 = find(candidate);
              if (result2) {
                return result2;
              }
            }
            return n2;
          }
        }
        function prepareRangeContainsErrorFunction(errors, originalRange) {
          if (!errors.length) {
            return rangeHasNoErrors;
          }
          var sorted = errors.filter(function(d) {
            return ts3.rangeOverlapsWithStartEnd(originalRange, d.start, d.start + d.length);
          }).sort(function(e1, e2) {
            return e1.start - e2.start;
          });
          if (!sorted.length) {
            return rangeHasNoErrors;
          }
          var index = 0;
          return function(r2) {
            while (true) {
              if (index >= sorted.length) {
                return false;
              }
              var error = sorted[index];
              if (r2.end <= error.start) {
                return false;
              }
              if (ts3.startEndOverlapsWithStartEnd(r2.pos, r2.end, error.start, error.start + error.length)) {
                return true;
              }
              index++;
            }
          };
          function rangeHasNoErrors() {
            return false;
          }
        }
        function getScanStartPosition(enclosingNode, originalRange, sourceFile) {
          var start = enclosingNode.getStart(sourceFile);
          if (start === originalRange.pos && enclosingNode.end === originalRange.end) {
            return start;
          }
          var precedingToken = ts3.findPrecedingToken(originalRange.pos, sourceFile);
          if (!precedingToken) {
            return enclosingNode.pos;
          }
          if (precedingToken.end >= originalRange.pos) {
            return enclosingNode.pos;
          }
          return precedingToken.end;
        }
        function getOwnOrInheritedDelta(n2, options, sourceFile) {
          var previousLine = -1;
          var child;
          while (n2) {
            var line = sourceFile.getLineAndCharacterOfPosition(n2.getStart(sourceFile)).line;
            if (previousLine !== -1 && line !== previousLine) {
              break;
            }
            if (formatting2.SmartIndenter.shouldIndentChildNode(options, n2, child, sourceFile)) {
              return options.indentSize;
            }
            previousLine = line;
            child = n2;
            n2 = n2.parent;
          }
          return 0;
        }
        function formatNodeGivenIndentation(node, sourceFileLike, languageVariant, initialIndentation, delta, formatContext) {
          var range = { pos: 0, end: sourceFileLike.text.length };
          return formatting2.getFormattingScanner(sourceFileLike.text, languageVariant, range.pos, range.end, function(scanner) {
            return formatSpanWorker(range, node, initialIndentation, delta, scanner, formatContext, 1, function(_) {
              return false;
            }, sourceFileLike);
          });
        }
        formatting2.formatNodeGivenIndentation = formatNodeGivenIndentation;
        function formatNodeLines(node, sourceFile, formatContext, requestKind) {
          if (!node) {
            return [];
          }
          var span = {
            pos: ts3.getLineStartPositionForPosition(node.getStart(sourceFile), sourceFile),
            end: node.end
          };
          return formatSpan(span, sourceFile, formatContext, requestKind);
        }
        function formatSpan(originalRange, sourceFile, formatContext, requestKind) {
          var enclosingNode = findEnclosingNode(originalRange, sourceFile);
          return formatting2.getFormattingScanner(sourceFile.text, sourceFile.languageVariant, getScanStartPosition(enclosingNode, originalRange, sourceFile), originalRange.end, function(scanner) {
            return formatSpanWorker(originalRange, enclosingNode, formatting2.SmartIndenter.getIndentationForNode(enclosingNode, originalRange, sourceFile, formatContext.options), getOwnOrInheritedDelta(enclosingNode, formatContext.options, sourceFile), scanner, formatContext, requestKind, prepareRangeContainsErrorFunction(sourceFile.parseDiagnostics, originalRange), sourceFile);
          });
        }
        function formatSpanWorker(originalRange, enclosingNode, initialIndentation, delta, formattingScanner, _a2, requestKind, rangeContainsError, sourceFile) {
          var options = _a2.options, getRules = _a2.getRules, host = _a2.host;
          var formattingContext = new formatting2.FormattingContext(sourceFile, requestKind, options);
          var previousRange;
          var previousParent;
          var previousRangeStartLine;
          var lastIndentedLine;
          var indentationOnLastIndentedLine = -1;
          var edits = [];
          formattingScanner.advance();
          if (formattingScanner.isOnToken()) {
            var startLine = sourceFile.getLineAndCharacterOfPosition(enclosingNode.getStart(sourceFile)).line;
            var undecoratedStartLine = startLine;
            if (enclosingNode.decorators) {
              undecoratedStartLine = sourceFile.getLineAndCharacterOfPosition(ts3.getNonDecoratorTokenPosOfNode(enclosingNode, sourceFile)).line;
            }
            processNode(enclosingNode, enclosingNode, startLine, undecoratedStartLine, initialIndentation, delta);
          }
          if (!formattingScanner.isOnToken()) {
            var indentation = formatting2.SmartIndenter.nodeWillIndentChild(options, enclosingNode, void 0, sourceFile, false) ? initialIndentation + options.indentSize : initialIndentation;
            var leadingTrivia = formattingScanner.getCurrentLeadingTrivia();
            if (leadingTrivia) {
              indentTriviaItems(leadingTrivia, indentation, false, function(item) {
                return processRange(item, sourceFile.getLineAndCharacterOfPosition(item.pos), enclosingNode, enclosingNode, void 0);
              });
            }
          }
          if (options.trimTrailingWhitespace !== false) {
            trimTrailingWhitespacesForRemainingRange();
          }
          return edits;
          function tryComputeIndentationForListItem(startPos, endPos, parentStartLine, range, inheritedIndentation) {
            if (ts3.rangeOverlapsWithStartEnd(range, startPos, endPos) || ts3.rangeContainsStartEnd(range, startPos, endPos)) {
              if (inheritedIndentation !== -1) {
                return inheritedIndentation;
              }
            } else {
              var startLine2 = sourceFile.getLineAndCharacterOfPosition(startPos).line;
              var startLinePosition = ts3.getLineStartPositionForPosition(startPos, sourceFile);
              var column = formatting2.SmartIndenter.findFirstNonWhitespaceColumn(startLinePosition, startPos, sourceFile, options);
              if (startLine2 !== parentStartLine || startPos === column) {
                var baseIndentSize = formatting2.SmartIndenter.getBaseIndentation(options);
                return baseIndentSize > column ? baseIndentSize : column;
              }
            }
            return -1;
          }
          function computeIndentation(node, startLine2, inheritedIndentation, parent, parentDynamicIndentation, effectiveParentStartLine) {
            var delta2 = formatting2.SmartIndenter.shouldIndentChildNode(options, node) ? options.indentSize : 0;
            if (effectiveParentStartLine === startLine2) {
              return {
                indentation: startLine2 === lastIndentedLine ? indentationOnLastIndentedLine : parentDynamicIndentation.getIndentation(),
                delta: Math.min(options.indentSize, parentDynamicIndentation.getDelta(node) + delta2)
              };
            } else if (inheritedIndentation === -1) {
              if (node.kind === 20 && startLine2 === lastIndentedLine) {
                return { indentation: indentationOnLastIndentedLine, delta: parentDynamicIndentation.getDelta(node) };
              } else if (formatting2.SmartIndenter.childStartsOnTheSameLineWithElseInIfStatement(parent, node, startLine2, sourceFile) || formatting2.SmartIndenter.childIsUnindentedBranchOfConditionalExpression(parent, node, startLine2, sourceFile) || formatting2.SmartIndenter.argumentStartsOnSameLineAsPreviousArgument(parent, node, startLine2, sourceFile)) {
                return { indentation: parentDynamicIndentation.getIndentation(), delta: delta2 };
              } else {
                return { indentation: parentDynamicIndentation.getIndentation() + parentDynamicIndentation.getDelta(node), delta: delta2 };
              }
            } else {
              return { indentation: inheritedIndentation, delta: delta2 };
            }
          }
          function getFirstNonDecoratorTokenOfNode(node) {
            if (node.modifiers && node.modifiers.length) {
              return node.modifiers[0].kind;
            }
            switch (node.kind) {
              case 253:
                return 83;
              case 254:
                return 117;
              case 252:
                return 97;
              case 256:
                return 256;
              case 168:
                return 134;
              case 169:
                return 146;
              case 166:
                if (node.asteriskToken) {
                  return 41;
                }
              case 164:
              case 161:
                var name = ts3.getNameOfDeclaration(node);
                if (name) {
                  return name.kind;
                }
            }
          }
          function getDynamicIndentation(node, nodeStartLine, indentation2, delta2) {
            return {
              getIndentationForComment: function(kind, tokenIndentation, container) {
                switch (kind) {
                  case 19:
                  case 23:
                  case 21:
                    return indentation2 + getDelta(container);
                }
                return tokenIndentation !== -1 ? tokenIndentation : indentation2;
              },
              getIndentationForToken: function(line, kind, container, suppressDelta) {
                return !suppressDelta && shouldAddDelta(line, kind, container) ? indentation2 + getDelta(container) : indentation2;
              },
              getIndentation: function() {
                return indentation2;
              },
              getDelta,
              recomputeIndentation: function(lineAdded, parent) {
                if (formatting2.SmartIndenter.shouldIndentChildNode(options, parent, node, sourceFile)) {
                  indentation2 += lineAdded ? options.indentSize : -options.indentSize;
                  delta2 = formatting2.SmartIndenter.shouldIndentChildNode(options, node) ? options.indentSize : 0;
                }
              }
            };
            function shouldAddDelta(line, kind, container) {
              switch (kind) {
                case 18:
                case 19:
                case 21:
                case 90:
                case 114:
                case 59:
                  return false;
                case 43:
                case 31:
                  switch (container.kind) {
                    case 276:
                    case 277:
                    case 275:
                    case 224:
                      return false;
                  }
                  break;
                case 22:
                case 23:
                  if (container.kind !== 191) {
                    return false;
                  }
                  break;
              }
              return nodeStartLine !== line && !(node.decorators && kind === getFirstNonDecoratorTokenOfNode(node));
            }
            function getDelta(child) {
              return formatting2.SmartIndenter.nodeWillIndentChild(options, node, child, sourceFile, true) ? delta2 : 0;
            }
          }
          function processNode(node, contextNode, nodeStartLine, undecoratedNodeStartLine, indentation2, delta2) {
            if (!ts3.rangeOverlapsWithStartEnd(originalRange, node.getStart(sourceFile), node.getEnd())) {
              return;
            }
            var nodeDynamicIndentation = getDynamicIndentation(node, nodeStartLine, indentation2, delta2);
            var childContextNode = contextNode;
            ts3.forEachChild(node, function(child) {
              processChildNode(child, -1, node, nodeDynamicIndentation, nodeStartLine, undecoratedNodeStartLine, false);
            }, function(nodes) {
              processChildNodes(nodes, node, nodeStartLine, nodeDynamicIndentation);
            });
            while (formattingScanner.isOnToken()) {
              var tokenInfo = formattingScanner.readTokenInfo(node);
              if (tokenInfo.token.end > node.end) {
                break;
              }
              consumeTokenAndAdvanceScanner(tokenInfo, node, nodeDynamicIndentation, node);
            }
            if (!node.parent && formattingScanner.isOnEOF()) {
              var token = formattingScanner.readEOFTokenRange();
              if (token.end <= node.end && previousRange) {
                processPair(token, sourceFile.getLineAndCharacterOfPosition(token.pos).line, node, previousRange, previousRangeStartLine, previousParent, contextNode, nodeDynamicIndentation);
              }
            }
            function processChildNode(child, inheritedIndentation, parent, parentDynamicIndentation, parentStartLine, undecoratedParentStartLine, isListItem, isFirstListItem) {
              var childStartPos = child.getStart(sourceFile);
              var childStartLine = sourceFile.getLineAndCharacterOfPosition(childStartPos).line;
              var undecoratedChildStartLine = childStartLine;
              if (child.decorators) {
                undecoratedChildStartLine = sourceFile.getLineAndCharacterOfPosition(ts3.getNonDecoratorTokenPosOfNode(child, sourceFile)).line;
              }
              var childIndentationAmount = -1;
              if (isListItem && ts3.rangeContainsRange(originalRange, parent)) {
                childIndentationAmount = tryComputeIndentationForListItem(childStartPos, child.end, parentStartLine, originalRange, inheritedIndentation);
                if (childIndentationAmount !== -1) {
                  inheritedIndentation = childIndentationAmount;
                }
              }
              if (!ts3.rangeOverlapsWithStartEnd(originalRange, child.pos, child.end)) {
                if (child.end < originalRange.pos) {
                  formattingScanner.skipToEndOf(child);
                }
                return inheritedIndentation;
              }
              if (child.getFullWidth() === 0) {
                return inheritedIndentation;
              }
              while (formattingScanner.isOnToken()) {
                var tokenInfo2 = formattingScanner.readTokenInfo(node);
                if (tokenInfo2.token.end > childStartPos) {
                  if (tokenInfo2.token.pos > childStartPos) {
                    formattingScanner.skipToStartOf(child);
                  }
                  break;
                }
                consumeTokenAndAdvanceScanner(tokenInfo2, node, parentDynamicIndentation, node);
              }
              if (!formattingScanner.isOnToken()) {
                return inheritedIndentation;
              }
              if (ts3.isToken(child)) {
                var tokenInfo2 = formattingScanner.readTokenInfo(child);
                if (child.kind !== 11) {
                  ts3.Debug.assert(tokenInfo2.token.end === child.end, "Token end is child end");
                  consumeTokenAndAdvanceScanner(tokenInfo2, node, parentDynamicIndentation, child);
                  return inheritedIndentation;
                }
              }
              var effectiveParentStartLine = child.kind === 162 ? childStartLine : undecoratedParentStartLine;
              var childIndentation = computeIndentation(child, childStartLine, childIndentationAmount, node, parentDynamicIndentation, effectiveParentStartLine);
              processNode(child, childContextNode, childStartLine, undecoratedChildStartLine, childIndentation.indentation, childIndentation.delta);
              childContextNode = node;
              if (isFirstListItem && parent.kind === 200 && inheritedIndentation === -1) {
                inheritedIndentation = childIndentation.indentation;
              }
              return inheritedIndentation;
            }
            function processChildNodes(nodes, parent, parentStartLine, parentDynamicIndentation) {
              ts3.Debug.assert(ts3.isNodeArray(nodes));
              var listStartToken = getOpenTokenForList(parent, nodes);
              var listDynamicIndentation = parentDynamicIndentation;
              var startLine2 = parentStartLine;
              if (listStartToken !== 0) {
                while (formattingScanner.isOnToken()) {
                  var tokenInfo2 = formattingScanner.readTokenInfo(parent);
                  if (tokenInfo2.token.end > nodes.pos) {
                    break;
                  } else if (tokenInfo2.token.kind === listStartToken) {
                    startLine2 = sourceFile.getLineAndCharacterOfPosition(tokenInfo2.token.pos).line;
                    consumeTokenAndAdvanceScanner(tokenInfo2, parent, parentDynamicIndentation, parent);
                    var indentationOnListStartToken = void 0;
                    if (indentationOnLastIndentedLine !== -1) {
                      indentationOnListStartToken = indentationOnLastIndentedLine;
                    } else {
                      var startLinePosition = ts3.getLineStartPositionForPosition(tokenInfo2.token.pos, sourceFile);
                      indentationOnListStartToken = formatting2.SmartIndenter.findFirstNonWhitespaceColumn(startLinePosition, tokenInfo2.token.pos, sourceFile, options);
                    }
                    listDynamicIndentation = getDynamicIndentation(parent, parentStartLine, indentationOnListStartToken, options.indentSize);
                  } else {
                    consumeTokenAndAdvanceScanner(tokenInfo2, parent, parentDynamicIndentation, parent);
                  }
                }
              }
              var inheritedIndentation = -1;
              for (var i3 = 0; i3 < nodes.length; i3++) {
                var child = nodes[i3];
                inheritedIndentation = processChildNode(child, inheritedIndentation, node, listDynamicIndentation, startLine2, startLine2, true, i3 === 0);
              }
              var listEndToken = getCloseTokenForOpenToken(listStartToken);
              if (listEndToken !== 0 && formattingScanner.isOnToken()) {
                var tokenInfo2 = formattingScanner.readTokenInfo(parent);
                if (tokenInfo2.token.kind === 27 && ts3.isCallLikeExpression(parent)) {
                  var commaTokenLine = sourceFile.getLineAndCharacterOfPosition(tokenInfo2.token.pos).line;
                  if (startLine2 !== commaTokenLine) {
                    formattingScanner.advance();
                    tokenInfo2 = formattingScanner.isOnToken() ? formattingScanner.readTokenInfo(parent) : void 0;
                  }
                }
                if (tokenInfo2 && tokenInfo2.token.kind === listEndToken && ts3.rangeContainsRange(parent, tokenInfo2.token)) {
                  consumeTokenAndAdvanceScanner(tokenInfo2, parent, listDynamicIndentation, parent, true);
                }
              }
            }
            function consumeTokenAndAdvanceScanner(currentTokenInfo, parent, dynamicIndentation, container, isListEndToken) {
              ts3.Debug.assert(ts3.rangeContainsRange(parent, currentTokenInfo.token));
              var lastTriviaWasNewLine = formattingScanner.lastTrailingTriviaWasNewLine();
              var indentToken = false;
              if (currentTokenInfo.leadingTrivia) {
                processTrivia(currentTokenInfo.leadingTrivia, parent, childContextNode, dynamicIndentation);
              }
              var lineAction = 0;
              var isTokenInRange = ts3.rangeContainsRange(originalRange, currentTokenInfo.token);
              var tokenStart = sourceFile.getLineAndCharacterOfPosition(currentTokenInfo.token.pos);
              if (isTokenInRange) {
                var rangeHasError = rangeContainsError(currentTokenInfo.token);
                var savePreviousRange = previousRange;
                lineAction = processRange(currentTokenInfo.token, tokenStart, parent, childContextNode, dynamicIndentation);
                if (!rangeHasError) {
                  if (lineAction === 0) {
                    var prevEndLine = savePreviousRange && sourceFile.getLineAndCharacterOfPosition(savePreviousRange.end).line;
                    indentToken = lastTriviaWasNewLine && tokenStart.line !== prevEndLine;
                  } else {
                    indentToken = lineAction === 1;
                  }
                }
              }
              if (currentTokenInfo.trailingTrivia) {
                processTrivia(currentTokenInfo.trailingTrivia, parent, childContextNode, dynamicIndentation);
              }
              if (indentToken) {
                var tokenIndentation = isTokenInRange && !rangeContainsError(currentTokenInfo.token) ? dynamicIndentation.getIndentationForToken(tokenStart.line, currentTokenInfo.token.kind, container, !!isListEndToken) : -1;
                var indentNextTokenOrTrivia = true;
                if (currentTokenInfo.leadingTrivia) {
                  var commentIndentation_1 = dynamicIndentation.getIndentationForComment(currentTokenInfo.token.kind, tokenIndentation, container);
                  indentNextTokenOrTrivia = indentTriviaItems(currentTokenInfo.leadingTrivia, commentIndentation_1, indentNextTokenOrTrivia, function(item) {
                    return insertIndentation(item.pos, commentIndentation_1, false);
                  });
                }
                if (tokenIndentation !== -1 && indentNextTokenOrTrivia) {
                  insertIndentation(currentTokenInfo.token.pos, tokenIndentation, lineAction === 1);
                  lastIndentedLine = tokenStart.line;
                  indentationOnLastIndentedLine = tokenIndentation;
                }
              }
              formattingScanner.advance();
              childContextNode = parent;
            }
          }
          function indentTriviaItems(trivia, commentIndentation, indentNextTokenOrTrivia, indentSingleLine) {
            for (var _i = 0, trivia_1 = trivia; _i < trivia_1.length; _i++) {
              var triviaItem = trivia_1[_i];
              var triviaInRange = ts3.rangeContainsRange(originalRange, triviaItem);
              switch (triviaItem.kind) {
                case 3:
                  if (triviaInRange) {
                    indentMultilineComment(triviaItem, commentIndentation, !indentNextTokenOrTrivia);
                  }
                  indentNextTokenOrTrivia = false;
                  break;
                case 2:
                  if (indentNextTokenOrTrivia && triviaInRange) {
                    indentSingleLine(triviaItem);
                  }
                  indentNextTokenOrTrivia = false;
                  break;
                case 4:
                  indentNextTokenOrTrivia = true;
                  break;
              }
            }
            return indentNextTokenOrTrivia;
          }
          function processTrivia(trivia, parent, contextNode, dynamicIndentation) {
            for (var _i = 0, trivia_2 = trivia; _i < trivia_2.length; _i++) {
              var triviaItem = trivia_2[_i];
              if (ts3.isComment(triviaItem.kind) && ts3.rangeContainsRange(originalRange, triviaItem)) {
                var triviaItemStart = sourceFile.getLineAndCharacterOfPosition(triviaItem.pos);
                processRange(triviaItem, triviaItemStart, parent, contextNode, dynamicIndentation);
              }
            }
          }
          function processRange(range, rangeStart, parent, contextNode, dynamicIndentation) {
            var rangeHasError = rangeContainsError(range);
            var lineAction = 0;
            if (!rangeHasError) {
              if (!previousRange) {
                var originalStart = sourceFile.getLineAndCharacterOfPosition(originalRange.pos);
                trimTrailingWhitespacesForLines(originalStart.line, rangeStart.line);
              } else {
                lineAction = processPair(range, rangeStart.line, parent, previousRange, previousRangeStartLine, previousParent, contextNode, dynamicIndentation);
              }
            }
            previousRange = range;
            previousParent = parent;
            previousRangeStartLine = rangeStart.line;
            return lineAction;
          }
          function processPair(currentItem, currentStartLine, currentParent, previousItem, previousStartLine, previousParent2, contextNode, dynamicIndentation) {
            formattingContext.updateContext(previousItem, previousParent2, currentItem, currentParent, contextNode);
            var rules = getRules(formattingContext);
            var trimTrailingWhitespaces = formattingContext.options.trimTrailingWhitespace !== false;
            var lineAction = 0;
            if (rules) {
              ts3.forEachRight(rules, function(rule) {
                lineAction = applyRuleEdits(rule, previousItem, previousStartLine, currentItem, currentStartLine);
                switch (lineAction) {
                  case 2:
                    if (currentParent.getStart(sourceFile) === currentItem.pos) {
                      dynamicIndentation.recomputeIndentation(false, contextNode);
                    }
                    break;
                  case 1:
                    if (currentParent.getStart(sourceFile) === currentItem.pos) {
                      dynamicIndentation.recomputeIndentation(true, contextNode);
                    }
                    break;
                  default:
                    ts3.Debug.assert(lineAction === 0);
                }
                trimTrailingWhitespaces = trimTrailingWhitespaces && !(rule.action & 16) && rule.flags !== 1;
              });
            } else {
              trimTrailingWhitespaces = trimTrailingWhitespaces && currentItem.kind !== 1;
            }
            if (currentStartLine !== previousStartLine && trimTrailingWhitespaces) {
              trimTrailingWhitespacesForLines(previousStartLine, currentStartLine, previousItem);
            }
            return lineAction;
          }
          function insertIndentation(pos, indentation2, lineAdded) {
            var indentationString = getIndentationString(indentation2, options);
            if (lineAdded) {
              recordReplace(pos, 0, indentationString);
            } else {
              var tokenStart = sourceFile.getLineAndCharacterOfPosition(pos);
              var startLinePosition = ts3.getStartPositionOfLine(tokenStart.line, sourceFile);
              if (indentation2 !== characterToColumn(startLinePosition, tokenStart.character) || indentationIsDifferent(indentationString, startLinePosition)) {
                recordReplace(startLinePosition, tokenStart.character, indentationString);
              }
            }
          }
          function characterToColumn(startLinePosition, characterInLine) {
            var column = 0;
            for (var i3 = 0; i3 < characterInLine; i3++) {
              if (sourceFile.text.charCodeAt(startLinePosition + i3) === 9) {
                column += options.tabSize - column % options.tabSize;
              } else {
                column++;
              }
            }
            return column;
          }
          function indentationIsDifferent(indentationString, startLinePosition) {
            return indentationString !== sourceFile.text.substr(startLinePosition, indentationString.length);
          }
          function indentMultilineComment(commentRange, indentation2, firstLineIsIndented, indentFinalLine) {
            if (indentFinalLine === void 0) {
              indentFinalLine = true;
            }
            var startLine2 = sourceFile.getLineAndCharacterOfPosition(commentRange.pos).line;
            var endLine = sourceFile.getLineAndCharacterOfPosition(commentRange.end).line;
            if (startLine2 === endLine) {
              if (!firstLineIsIndented) {
                insertIndentation(commentRange.pos, indentation2, false);
              }
              return;
            }
            var parts = [];
            var startPos = commentRange.pos;
            for (var line = startLine2; line < endLine; line++) {
              var endOfLine = ts3.getEndLinePosition(line, sourceFile);
              parts.push({ pos: startPos, end: endOfLine });
              startPos = ts3.getStartPositionOfLine(line + 1, sourceFile);
            }
            if (indentFinalLine) {
              parts.push({ pos: startPos, end: commentRange.end });
            }
            if (parts.length === 0)
              return;
            var startLinePos = ts3.getStartPositionOfLine(startLine2, sourceFile);
            var nonWhitespaceColumnInFirstPart = formatting2.SmartIndenter.findFirstNonWhitespaceCharacterAndColumn(startLinePos, parts[0].pos, sourceFile, options);
            var startIndex = 0;
            if (firstLineIsIndented) {
              startIndex = 1;
              startLine2++;
            }
            var delta2 = indentation2 - nonWhitespaceColumnInFirstPart.column;
            for (var i3 = startIndex; i3 < parts.length; i3++, startLine2++) {
              var startLinePos_1 = ts3.getStartPositionOfLine(startLine2, sourceFile);
              var nonWhitespaceCharacterAndColumn = i3 === 0 ? nonWhitespaceColumnInFirstPart : formatting2.SmartIndenter.findFirstNonWhitespaceCharacterAndColumn(parts[i3].pos, parts[i3].end, sourceFile, options);
              var newIndentation = nonWhitespaceCharacterAndColumn.column + delta2;
              if (newIndentation > 0) {
                var indentationString = getIndentationString(newIndentation, options);
                recordReplace(startLinePos_1, nonWhitespaceCharacterAndColumn.character, indentationString);
              } else {
                recordDelete(startLinePos_1, nonWhitespaceCharacterAndColumn.character);
              }
            }
          }
          function trimTrailingWhitespacesForLines(line1, line2, range) {
            for (var line = line1; line < line2; line++) {
              var lineStartPosition = ts3.getStartPositionOfLine(line, sourceFile);
              var lineEndPosition = ts3.getEndLinePosition(line, sourceFile);
              if (range && (ts3.isComment(range.kind) || ts3.isStringOrRegularExpressionOrTemplateLiteral(range.kind)) && range.pos <= lineEndPosition && range.end > lineEndPosition) {
                continue;
              }
              var whitespaceStart = getTrailingWhitespaceStartPosition(lineStartPosition, lineEndPosition);
              if (whitespaceStart !== -1) {
                ts3.Debug.assert(whitespaceStart === lineStartPosition || !ts3.isWhiteSpaceSingleLine(sourceFile.text.charCodeAt(whitespaceStart - 1)));
                recordDelete(whitespaceStart, lineEndPosition + 1 - whitespaceStart);
              }
            }
          }
          function getTrailingWhitespaceStartPosition(start, end) {
            var pos = end;
            while (pos >= start && ts3.isWhiteSpaceSingleLine(sourceFile.text.charCodeAt(pos))) {
              pos--;
            }
            if (pos !== end) {
              return pos + 1;
            }
            return -1;
          }
          function trimTrailingWhitespacesForRemainingRange() {
            var startPosition = previousRange ? previousRange.end : originalRange.pos;
            var startLine2 = sourceFile.getLineAndCharacterOfPosition(startPosition).line;
            var endLine = sourceFile.getLineAndCharacterOfPosition(originalRange.end).line;
            trimTrailingWhitespacesForLines(startLine2, endLine + 1, previousRange);
          }
          function recordDelete(start, len) {
            if (len) {
              edits.push(ts3.createTextChangeFromStartLength(start, len, ""));
            }
          }
          function recordReplace(start, len, newText) {
            if (len || newText) {
              edits.push(ts3.createTextChangeFromStartLength(start, len, newText));
            }
          }
          function recordInsert(start, text) {
            if (text) {
              edits.push(ts3.createTextChangeFromStartLength(start, 0, text));
            }
          }
          function applyRuleEdits(rule, previousRange2, previousStartLine, currentRange, currentStartLine) {
            var onLaterLine = currentStartLine !== previousStartLine;
            switch (rule.action) {
              case 1:
                return 0;
              case 16:
                if (previousRange2.end !== currentRange.pos) {
                  recordDelete(previousRange2.end, currentRange.pos - previousRange2.end);
                  return onLaterLine ? 2 : 0;
                }
                break;
              case 32:
                recordDelete(previousRange2.pos, previousRange2.end - previousRange2.pos);
                break;
              case 8:
                if (rule.flags !== 1 && previousStartLine !== currentStartLine) {
                  return 0;
                }
                var lineDelta = currentStartLine - previousStartLine;
                if (lineDelta !== 1) {
                  recordReplace(previousRange2.end, currentRange.pos - previousRange2.end, ts3.getNewLineOrDefaultFromHost(host, options));
                  return onLaterLine ? 0 : 1;
                }
                break;
              case 4:
                if (rule.flags !== 1 && previousStartLine !== currentStartLine) {
                  return 0;
                }
                var posDelta = currentRange.pos - previousRange2.end;
                if (posDelta !== 1 || sourceFile.text.charCodeAt(previousRange2.end) !== 32) {
                  recordReplace(previousRange2.end, currentRange.pos - previousRange2.end, " ");
                  return onLaterLine ? 2 : 0;
                }
                break;
              case 64:
                recordInsert(previousRange2.end, ";");
            }
            return 0;
          }
        }
        var LineAction;
        (function(LineAction2) {
          LineAction2[LineAction2["None"] = 0] = "None";
          LineAction2[LineAction2["LineAdded"] = 1] = "LineAdded";
          LineAction2[LineAction2["LineRemoved"] = 2] = "LineRemoved";
        })(LineAction || (LineAction = {}));
        function getRangeOfEnclosingComment(sourceFile, position, precedingToken, tokenAtPosition) {
          if (tokenAtPosition === void 0) {
            tokenAtPosition = ts3.getTokenAtPosition(sourceFile, position);
          }
          var jsdoc = ts3.findAncestor(tokenAtPosition, ts3.isJSDoc);
          if (jsdoc)
            tokenAtPosition = jsdoc.parent;
          var tokenStart = tokenAtPosition.getStart(sourceFile);
          if (tokenStart <= position && position < tokenAtPosition.getEnd()) {
            return void 0;
          }
          precedingToken = precedingToken === null ? void 0 : precedingToken === void 0 ? ts3.findPrecedingToken(position, sourceFile) : precedingToken;
          var trailingRangesOfPreviousToken = precedingToken && ts3.getTrailingCommentRanges(sourceFile.text, precedingToken.end);
          var leadingCommentRangesOfNextToken = ts3.getLeadingCommentRangesOfNode(tokenAtPosition, sourceFile);
          var commentRanges = ts3.concatenate(trailingRangesOfPreviousToken, leadingCommentRangesOfNextToken);
          return commentRanges && ts3.find(commentRanges, function(range) {
            return ts3.rangeContainsPositionExclusive(range, position) || position === range.end && (range.kind === 2 || position === sourceFile.getFullWidth());
          });
        }
        formatting2.getRangeOfEnclosingComment = getRangeOfEnclosingComment;
        function getOpenTokenForList(node, list) {
          switch (node.kind) {
            case 167:
            case 252:
            case 209:
            case 166:
            case 165:
            case 210:
              if (node.typeParameters === list) {
                return 29;
              } else if (node.parameters === list) {
                return 20;
              }
              break;
            case 204:
            case 205:
              if (node.typeArguments === list) {
                return 29;
              } else if (node.arguments === list) {
                return 20;
              }
              break;
            case 174:
              if (node.typeArguments === list) {
                return 29;
              }
              break;
            case 178:
              return 18;
          }
          return 0;
        }
        function getCloseTokenForOpenToken(kind) {
          switch (kind) {
            case 20:
              return 21;
            case 29:
              return 31;
            case 18:
              return 19;
          }
          return 0;
        }
        var internedSizes;
        var internedTabsIndentation;
        var internedSpacesIndentation;
        function getIndentationString(indentation, options) {
          var resetInternedStrings = !internedSizes || (internedSizes.tabSize !== options.tabSize || internedSizes.indentSize !== options.indentSize);
          if (resetInternedStrings) {
            internedSizes = { tabSize: options.tabSize, indentSize: options.indentSize };
            internedTabsIndentation = internedSpacesIndentation = void 0;
          }
          if (!options.convertTabsToSpaces) {
            var tabs = Math.floor(indentation / options.tabSize);
            var spaces = indentation - tabs * options.tabSize;
            var tabString = void 0;
            if (!internedTabsIndentation) {
              internedTabsIndentation = [];
            }
            if (internedTabsIndentation[tabs] === void 0) {
              internedTabsIndentation[tabs] = tabString = ts3.repeatString("	", tabs);
            } else {
              tabString = internedTabsIndentation[tabs];
            }
            return spaces ? tabString + ts3.repeatString(" ", spaces) : tabString;
          } else {
            var spacesString = void 0;
            var quotient = Math.floor(indentation / options.indentSize);
            var remainder = indentation % options.indentSize;
            if (!internedSpacesIndentation) {
              internedSpacesIndentation = [];
            }
            if (internedSpacesIndentation[quotient] === void 0) {
              spacesString = ts3.repeatString(" ", options.indentSize * quotient);
              internedSpacesIndentation[quotient] = spacesString;
            } else {
              spacesString = internedSpacesIndentation[quotient];
            }
            return remainder ? spacesString + ts3.repeatString(" ", remainder) : spacesString;
          }
        }
        formatting2.getIndentationString = getIndentationString;
      })(formatting = ts3.formatting || (ts3.formatting = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var formatting;
      (function(formatting2) {
        var SmartIndenter;
        (function(SmartIndenter2) {
          var Value;
          (function(Value2) {
            Value2[Value2["Unknown"] = -1] = "Unknown";
          })(Value || (Value = {}));
          function getIndentation(position, sourceFile, options, assumeNewLineBeforeCloseBrace) {
            if (assumeNewLineBeforeCloseBrace === void 0) {
              assumeNewLineBeforeCloseBrace = false;
            }
            if (position > sourceFile.text.length) {
              return getBaseIndentation(options);
            }
            if (options.indentStyle === ts3.IndentStyle.None) {
              return 0;
            }
            var precedingToken = ts3.findPrecedingToken(position, sourceFile, void 0, true);
            var enclosingCommentRange = formatting2.getRangeOfEnclosingComment(sourceFile, position, precedingToken || null);
            if (enclosingCommentRange && enclosingCommentRange.kind === 3) {
              return getCommentIndent(sourceFile, position, options, enclosingCommentRange);
            }
            if (!precedingToken) {
              return getBaseIndentation(options);
            }
            var precedingTokenIsLiteral = ts3.isStringOrRegularExpressionOrTemplateLiteral(precedingToken.kind);
            if (precedingTokenIsLiteral && precedingToken.getStart(sourceFile) <= position && position < precedingToken.end) {
              return 0;
            }
            var lineAtPosition = sourceFile.getLineAndCharacterOfPosition(position).line;
            if (options.indentStyle === ts3.IndentStyle.Block) {
              return getBlockIndent(sourceFile, position, options);
            }
            if (precedingToken.kind === 27 && precedingToken.parent.kind !== 217) {
              var actualIndentation = getActualIndentationForListItemBeforeComma(precedingToken, sourceFile, options);
              if (actualIndentation !== -1) {
                return actualIndentation;
              }
            }
            var containerList = getListByPosition(position, precedingToken.parent, sourceFile);
            if (containerList && !ts3.rangeContainsRange(containerList, precedingToken)) {
              return getActualIndentationForListStartLine(containerList, sourceFile, options) + options.indentSize;
            }
            return getSmartIndent(sourceFile, position, precedingToken, lineAtPosition, assumeNewLineBeforeCloseBrace, options);
          }
          SmartIndenter2.getIndentation = getIndentation;
          function getCommentIndent(sourceFile, position, options, enclosingCommentRange) {
            var previousLine = ts3.getLineAndCharacterOfPosition(sourceFile, position).line - 1;
            var commentStartLine = ts3.getLineAndCharacterOfPosition(sourceFile, enclosingCommentRange.pos).line;
            ts3.Debug.assert(commentStartLine >= 0);
            if (previousLine <= commentStartLine) {
              return findFirstNonWhitespaceColumn(ts3.getStartPositionOfLine(commentStartLine, sourceFile), position, sourceFile, options);
            }
            var startPositionOfLine = ts3.getStartPositionOfLine(previousLine, sourceFile);
            var _a2 = findFirstNonWhitespaceCharacterAndColumn(startPositionOfLine, position, sourceFile, options), column = _a2.column, character = _a2.character;
            if (column === 0) {
              return column;
            }
            var firstNonWhitespaceCharacterCode = sourceFile.text.charCodeAt(startPositionOfLine + character);
            return firstNonWhitespaceCharacterCode === 42 ? column - 1 : column;
          }
          function getBlockIndent(sourceFile, position, options) {
            var current = position;
            while (current > 0) {
              var char = sourceFile.text.charCodeAt(current);
              if (!ts3.isWhiteSpaceLike(char)) {
                break;
              }
              current--;
            }
            var lineStart = ts3.getLineStartPositionForPosition(current, sourceFile);
            return findFirstNonWhitespaceColumn(lineStart, current, sourceFile, options);
          }
          function getSmartIndent(sourceFile, position, precedingToken, lineAtPosition, assumeNewLineBeforeCloseBrace, options) {
            var previous;
            var current = precedingToken;
            while (current) {
              if (ts3.positionBelongsToNode(current, position, sourceFile) && shouldIndentChildNode(options, current, previous, sourceFile, true)) {
                var currentStart = getStartLineAndCharacterForNode(current, sourceFile);
                var nextTokenKind = nextTokenIsCurlyBraceOnSameLineAsCursor(precedingToken, current, lineAtPosition, sourceFile);
                var indentationDelta = nextTokenKind !== 0 ? assumeNewLineBeforeCloseBrace && nextTokenKind === 2 ? options.indentSize : 0 : lineAtPosition !== currentStart.line ? options.indentSize : 0;
                return getIndentationForNodeWorker(current, currentStart, void 0, indentationDelta, sourceFile, true, options);
              }
              var actualIndentation = getActualIndentationForListItem(current, sourceFile, options, true);
              if (actualIndentation !== -1) {
                return actualIndentation;
              }
              previous = current;
              current = current.parent;
            }
            return getBaseIndentation(options);
          }
          function getIndentationForNode(n2, ignoreActualIndentationRange, sourceFile, options) {
            var start = sourceFile.getLineAndCharacterOfPosition(n2.getStart(sourceFile));
            return getIndentationForNodeWorker(n2, start, ignoreActualIndentationRange, 0, sourceFile, false, options);
          }
          SmartIndenter2.getIndentationForNode = getIndentationForNode;
          function getBaseIndentation(options) {
            return options.baseIndentSize || 0;
          }
          SmartIndenter2.getBaseIndentation = getBaseIndentation;
          function getIndentationForNodeWorker(current, currentStart, ignoreActualIndentationRange, indentationDelta, sourceFile, isNextChild, options) {
            var _a2;
            var parent = current.parent;
            while (parent) {
              var useActualIndentation = true;
              if (ignoreActualIndentationRange) {
                var start = current.getStart(sourceFile);
                useActualIndentation = start < ignoreActualIndentationRange.pos || start > ignoreActualIndentationRange.end;
              }
              var containingListOrParentStart = getContainingListOrParentStart(parent, current, sourceFile);
              var parentAndChildShareLine = containingListOrParentStart.line === currentStart.line || childStartsOnTheSameLineWithElseInIfStatement(parent, current, currentStart.line, sourceFile);
              if (useActualIndentation) {
                var firstListChild = (_a2 = getContainingList(current, sourceFile)) === null || _a2 === void 0 ? void 0 : _a2[0];
                var listIndentsChild = !!firstListChild && getStartLineAndCharacterForNode(firstListChild, sourceFile).line > containingListOrParentStart.line;
                var actualIndentation = getActualIndentationForListItem(current, sourceFile, options, listIndentsChild);
                if (actualIndentation !== -1) {
                  return actualIndentation + indentationDelta;
                }
                actualIndentation = getActualIndentationForNode(current, parent, currentStart, parentAndChildShareLine, sourceFile, options);
                if (actualIndentation !== -1) {
                  return actualIndentation + indentationDelta;
                }
              }
              if (shouldIndentChildNode(options, parent, current, sourceFile, isNextChild) && !parentAndChildShareLine) {
                indentationDelta += options.indentSize;
              }
              var useTrueStart = isArgumentAndStartLineOverlapsExpressionBeingCalled(parent, current, currentStart.line, sourceFile);
              current = parent;
              parent = current.parent;
              currentStart = useTrueStart ? sourceFile.getLineAndCharacterOfPosition(current.getStart(sourceFile)) : containingListOrParentStart;
            }
            return indentationDelta + getBaseIndentation(options);
          }
          function getContainingListOrParentStart(parent, child, sourceFile) {
            var containingList = getContainingList(child, sourceFile);
            var startPos = containingList ? containingList.pos : parent.getStart(sourceFile);
            return sourceFile.getLineAndCharacterOfPosition(startPos);
          }
          function getActualIndentationForListItemBeforeComma(commaToken, sourceFile, options) {
            var commaItemInfo = ts3.findListItemInfo(commaToken);
            if (commaItemInfo && commaItemInfo.listItemIndex > 0) {
              return deriveActualIndentationFromList(commaItemInfo.list.getChildren(), commaItemInfo.listItemIndex - 1, sourceFile, options);
            } else {
              return -1;
            }
          }
          function getActualIndentationForNode(current, parent, currentLineAndChar, parentAndChildShareLine, sourceFile, options) {
            var useActualIndentation = (ts3.isDeclaration(current) || ts3.isStatementButNotDeclaration(current)) && (parent.kind === 298 || !parentAndChildShareLine);
            if (!useActualIndentation) {
              return -1;
            }
            return findColumnForFirstNonWhitespaceCharacterInLine(currentLineAndChar, sourceFile, options);
          }
          var NextTokenKind;
          (function(NextTokenKind2) {
            NextTokenKind2[NextTokenKind2["Unknown"] = 0] = "Unknown";
            NextTokenKind2[NextTokenKind2["OpenBrace"] = 1] = "OpenBrace";
            NextTokenKind2[NextTokenKind2["CloseBrace"] = 2] = "CloseBrace";
          })(NextTokenKind || (NextTokenKind = {}));
          function nextTokenIsCurlyBraceOnSameLineAsCursor(precedingToken, current, lineAtPosition, sourceFile) {
            var nextToken = ts3.findNextToken(precedingToken, current, sourceFile);
            if (!nextToken) {
              return 0;
            }
            if (nextToken.kind === 18) {
              return 1;
            } else if (nextToken.kind === 19) {
              var nextTokenStartLine = getStartLineAndCharacterForNode(nextToken, sourceFile).line;
              return lineAtPosition === nextTokenStartLine ? 2 : 0;
            }
            return 0;
          }
          function getStartLineAndCharacterForNode(n2, sourceFile) {
            return sourceFile.getLineAndCharacterOfPosition(n2.getStart(sourceFile));
          }
          function isArgumentAndStartLineOverlapsExpressionBeingCalled(parent, child, childStartLine, sourceFile) {
            if (!(ts3.isCallExpression(parent) && ts3.contains(parent.arguments, child))) {
              return false;
            }
            var expressionOfCallExpressionEnd = parent.expression.getEnd();
            var expressionOfCallExpressionEndLine = ts3.getLineAndCharacterOfPosition(sourceFile, expressionOfCallExpressionEnd).line;
            return expressionOfCallExpressionEndLine === childStartLine;
          }
          SmartIndenter2.isArgumentAndStartLineOverlapsExpressionBeingCalled = isArgumentAndStartLineOverlapsExpressionBeingCalled;
          function childStartsOnTheSameLineWithElseInIfStatement(parent, child, childStartLine, sourceFile) {
            if (parent.kind === 235 && parent.elseStatement === child) {
              var elseKeyword = ts3.findChildOfKind(parent, 90, sourceFile);
              ts3.Debug.assert(elseKeyword !== void 0);
              var elseKeywordStartLine = getStartLineAndCharacterForNode(elseKeyword, sourceFile).line;
              return elseKeywordStartLine === childStartLine;
            }
            return false;
          }
          SmartIndenter2.childStartsOnTheSameLineWithElseInIfStatement = childStartsOnTheSameLineWithElseInIfStatement;
          function childIsUnindentedBranchOfConditionalExpression(parent, child, childStartLine, sourceFile) {
            if (ts3.isConditionalExpression(parent) && (child === parent.whenTrue || child === parent.whenFalse)) {
              var conditionEndLine = ts3.getLineAndCharacterOfPosition(sourceFile, parent.condition.end).line;
              if (child === parent.whenTrue) {
                return childStartLine === conditionEndLine;
              } else {
                var trueStartLine = getStartLineAndCharacterForNode(parent.whenTrue, sourceFile).line;
                var trueEndLine = ts3.getLineAndCharacterOfPosition(sourceFile, parent.whenTrue.end).line;
                return conditionEndLine === trueStartLine && trueEndLine === childStartLine;
              }
            }
            return false;
          }
          SmartIndenter2.childIsUnindentedBranchOfConditionalExpression = childIsUnindentedBranchOfConditionalExpression;
          function argumentStartsOnSameLineAsPreviousArgument(parent, child, childStartLine, sourceFile) {
            if (ts3.isCallOrNewExpression(parent)) {
              if (!parent.arguments)
                return false;
              var currentNode = ts3.find(parent.arguments, function(arg2) {
                return arg2.pos === child.pos;
              });
              if (!currentNode)
                return false;
              var currentIndex = parent.arguments.indexOf(currentNode);
              if (currentIndex === 0)
                return false;
              var previousNode = parent.arguments[currentIndex - 1];
              var lineOfPreviousNode = ts3.getLineAndCharacterOfPosition(sourceFile, previousNode.getEnd()).line;
              if (childStartLine === lineOfPreviousNode) {
                return true;
              }
            }
            return false;
          }
          SmartIndenter2.argumentStartsOnSameLineAsPreviousArgument = argumentStartsOnSameLineAsPreviousArgument;
          function getContainingList(node, sourceFile) {
            return node.parent && getListByRange(node.getStart(sourceFile), node.getEnd(), node.parent, sourceFile);
          }
          SmartIndenter2.getContainingList = getContainingList;
          function getListByPosition(pos, node, sourceFile) {
            return node && getListByRange(pos, pos, node, sourceFile);
          }
          function getListByRange(start, end, node, sourceFile) {
            switch (node.kind) {
              case 174:
                return getList(node.typeArguments);
              case 201:
                return getList(node.properties);
              case 200:
                return getList(node.elements);
              case 178:
                return getList(node.members);
              case 252:
              case 209:
              case 210:
              case 166:
              case 165:
              case 170:
              case 167:
              case 176:
              case 171:
                return getList(node.typeParameters) || getList(node.parameters);
              case 253:
              case 222:
              case 254:
              case 255:
              case 334:
                return getList(node.typeParameters);
              case 205:
              case 204:
                return getList(node.typeArguments) || getList(node.arguments);
              case 251:
                return getList(node.declarations);
              case 265:
              case 269:
                return getList(node.elements);
              case 197:
              case 198:
                return getList(node.elements);
            }
            function getList(list) {
              return list && ts3.rangeContainsStartEnd(getVisualListRange(node, list, sourceFile), start, end) ? list : void 0;
            }
          }
          function getVisualListRange(node, list, sourceFile) {
            var children = node.getChildren(sourceFile);
            for (var i3 = 1; i3 < children.length - 1; i3++) {
              if (children[i3].pos === list.pos && children[i3].end === list.end) {
                return { pos: children[i3 - 1].end, end: children[i3 + 1].getStart(sourceFile) };
              }
            }
            return list;
          }
          function getActualIndentationForListStartLine(list, sourceFile, options) {
            if (!list) {
              return -1;
            }
            return findColumnForFirstNonWhitespaceCharacterInLine(sourceFile.getLineAndCharacterOfPosition(list.pos), sourceFile, options);
          }
          function getActualIndentationForListItem(node, sourceFile, options, listIndentsChild) {
            if (node.parent && node.parent.kind === 251) {
              return -1;
            }
            var containingList = getContainingList(node, sourceFile);
            if (containingList) {
              var index = containingList.indexOf(node);
              if (index !== -1) {
                var result2 = deriveActualIndentationFromList(containingList, index, sourceFile, options);
                if (result2 !== -1) {
                  return result2;
                }
              }
              return getActualIndentationForListStartLine(containingList, sourceFile, options) + (listIndentsChild ? options.indentSize : 0);
            }
            return -1;
          }
          function deriveActualIndentationFromList(list, index, sourceFile, options) {
            ts3.Debug.assert(index >= 0 && index < list.length);
            var node = list[index];
            var lineAndCharacter = getStartLineAndCharacterForNode(node, sourceFile);
            for (var i3 = index - 1; i3 >= 0; i3--) {
              if (list[i3].kind === 27) {
                continue;
              }
              var prevEndLine = sourceFile.getLineAndCharacterOfPosition(list[i3].end).line;
              if (prevEndLine !== lineAndCharacter.line) {
                return findColumnForFirstNonWhitespaceCharacterInLine(lineAndCharacter, sourceFile, options);
              }
              lineAndCharacter = getStartLineAndCharacterForNode(list[i3], sourceFile);
            }
            return -1;
          }
          function findColumnForFirstNonWhitespaceCharacterInLine(lineAndCharacter, sourceFile, options) {
            var lineStart = sourceFile.getPositionOfLineAndCharacter(lineAndCharacter.line, 0);
            return findFirstNonWhitespaceColumn(lineStart, lineStart + lineAndCharacter.character, sourceFile, options);
          }
          function findFirstNonWhitespaceCharacterAndColumn(startPos, endPos, sourceFile, options) {
            var character = 0;
            var column = 0;
            for (var pos = startPos; pos < endPos; pos++) {
              var ch = sourceFile.text.charCodeAt(pos);
              if (!ts3.isWhiteSpaceSingleLine(ch)) {
                break;
              }
              if (ch === 9) {
                column += options.tabSize + column % options.tabSize;
              } else {
                column++;
              }
              character++;
            }
            return { column, character };
          }
          SmartIndenter2.findFirstNonWhitespaceCharacterAndColumn = findFirstNonWhitespaceCharacterAndColumn;
          function findFirstNonWhitespaceColumn(startPos, endPos, sourceFile, options) {
            return findFirstNonWhitespaceCharacterAndColumn(startPos, endPos, sourceFile, options).column;
          }
          SmartIndenter2.findFirstNonWhitespaceColumn = findFirstNonWhitespaceColumn;
          function nodeWillIndentChild(settings, parent, child, sourceFile, indentByDefault) {
            var childKind = child ? child.kind : 0;
            switch (parent.kind) {
              case 234:
              case 253:
              case 222:
              case 254:
              case 256:
              case 255:
              case 200:
              case 231:
              case 258:
              case 201:
              case 178:
              case 191:
              case 180:
              case 259:
              case 286:
              case 285:
              case 208:
              case 202:
              case 204:
              case 205:
              case 233:
              case 267:
              case 243:
              case 218:
              case 198:
              case 197:
              case 276:
              case 279:
              case 275:
              case 284:
              case 165:
              case 170:
              case 171:
              case 161:
              case 175:
              case 176:
              case 187:
              case 206:
              case 214:
              case 269:
              case 265:
              case 271:
              case 266:
              case 164:
                return true;
              case 250:
              case 289:
              case 217:
                if (!settings.indentMultiLineObjectLiteralBeginningOnBlankLine && sourceFile && childKind === 201) {
                  return rangeIsOnOneLine(sourceFile, child);
                }
                if (parent.kind !== 217) {
                  return true;
                }
                break;
              case 236:
              case 237:
              case 239:
              case 240:
              case 238:
              case 235:
              case 252:
              case 209:
              case 166:
              case 167:
              case 168:
              case 169:
                return childKind !== 231;
              case 210:
                if (sourceFile && childKind === 208) {
                  return rangeIsOnOneLine(sourceFile, child);
                }
                return childKind !== 231;
              case 268:
                return childKind !== 269;
              case 262:
                return childKind !== 263 || !!child.namedBindings && child.namedBindings.kind !== 265;
              case 274:
                return childKind !== 277;
              case 278:
                return childKind !== 280;
              case 184:
              case 183:
                if (childKind === 178 || childKind === 180) {
                  return false;
                }
                break;
            }
            return indentByDefault;
          }
          SmartIndenter2.nodeWillIndentChild = nodeWillIndentChild;
          function isControlFlowEndingStatement(kind, parent) {
            switch (kind) {
              case 243:
              case 247:
              case 241:
              case 242:
                return parent.kind !== 231;
              default:
                return false;
            }
          }
          function shouldIndentChildNode(settings, parent, child, sourceFile, isNextChild) {
            if (isNextChild === void 0) {
              isNextChild = false;
            }
            return nodeWillIndentChild(settings, parent, child, sourceFile, false) && !(isNextChild && child && isControlFlowEndingStatement(child.kind, parent));
          }
          SmartIndenter2.shouldIndentChildNode = shouldIndentChildNode;
          function rangeIsOnOneLine(sourceFile, range) {
            var rangeStart = ts3.skipTrivia(sourceFile.text, range.pos);
            var startLine = sourceFile.getLineAndCharacterOfPosition(rangeStart).line;
            var endLine = sourceFile.getLineAndCharacterOfPosition(range.end).line;
            return startLine === endLine;
          }
        })(SmartIndenter = formatting2.SmartIndenter || (formatting2.SmartIndenter = {}));
      })(formatting = ts3.formatting || (ts3.formatting = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var textChanges;
      (function(textChanges_3) {
        function getPos(n2) {
          var result2 = n2.__pos;
          ts3.Debug.assert(typeof result2 === "number");
          return result2;
        }
        function setPos(n2, pos) {
          ts3.Debug.assert(typeof pos === "number");
          n2.__pos = pos;
        }
        function getEnd(n2) {
          var result2 = n2.__end;
          ts3.Debug.assert(typeof result2 === "number");
          return result2;
        }
        function setEnd(n2, end) {
          ts3.Debug.assert(typeof end === "number");
          n2.__end = end;
        }
        var LeadingTriviaOption;
        (function(LeadingTriviaOption2) {
          LeadingTriviaOption2[LeadingTriviaOption2["Exclude"] = 0] = "Exclude";
          LeadingTriviaOption2[LeadingTriviaOption2["IncludeAll"] = 1] = "IncludeAll";
          LeadingTriviaOption2[LeadingTriviaOption2["JSDoc"] = 2] = "JSDoc";
          LeadingTriviaOption2[LeadingTriviaOption2["StartLine"] = 3] = "StartLine";
        })(LeadingTriviaOption = textChanges_3.LeadingTriviaOption || (textChanges_3.LeadingTriviaOption = {}));
        var TrailingTriviaOption;
        (function(TrailingTriviaOption2) {
          TrailingTriviaOption2[TrailingTriviaOption2["Exclude"] = 0] = "Exclude";
          TrailingTriviaOption2[TrailingTriviaOption2["ExcludeWhitespace"] = 1] = "ExcludeWhitespace";
          TrailingTriviaOption2[TrailingTriviaOption2["Include"] = 2] = "Include";
        })(TrailingTriviaOption = textChanges_3.TrailingTriviaOption || (textChanges_3.TrailingTriviaOption = {}));
        function skipWhitespacesAndLineBreaks(text, start) {
          return ts3.skipTrivia(text, start, false, true);
        }
        function hasCommentsBeforeLineBreak(text, start) {
          var i3 = start;
          while (i3 < text.length) {
            var ch = text.charCodeAt(i3);
            if (ts3.isWhiteSpaceSingleLine(ch)) {
              i3++;
              continue;
            }
            return ch === 47;
          }
          return false;
        }
        var useNonAdjustedPositions = {
          leadingTriviaOption: LeadingTriviaOption.Exclude,
          trailingTriviaOption: TrailingTriviaOption.Exclude
        };
        var ChangeKind;
        (function(ChangeKind2) {
          ChangeKind2[ChangeKind2["Remove"] = 0] = "Remove";
          ChangeKind2[ChangeKind2["ReplaceWithSingleNode"] = 1] = "ReplaceWithSingleNode";
          ChangeKind2[ChangeKind2["ReplaceWithMultipleNodes"] = 2] = "ReplaceWithMultipleNodes";
          ChangeKind2[ChangeKind2["Text"] = 3] = "Text";
        })(ChangeKind || (ChangeKind = {}));
        function getAdjustedRange(sourceFile, startNode, endNode, options) {
          return { pos: getAdjustedStartPosition(sourceFile, startNode, options), end: getAdjustedEndPosition(sourceFile, endNode, options) };
        }
        function getAdjustedStartPosition(sourceFile, node, options, hasTrailingComment) {
          var _a2, _b;
          if (hasTrailingComment === void 0) {
            hasTrailingComment = false;
          }
          var leadingTriviaOption = options.leadingTriviaOption;
          if (leadingTriviaOption === LeadingTriviaOption.Exclude) {
            return node.getStart(sourceFile);
          }
          if (leadingTriviaOption === LeadingTriviaOption.StartLine) {
            return ts3.getLineStartPositionForPosition(node.getStart(sourceFile), sourceFile);
          }
          if (leadingTriviaOption === LeadingTriviaOption.JSDoc) {
            var JSDocComments = ts3.getJSDocCommentRanges(node, sourceFile.text);
            if (JSDocComments === null || JSDocComments === void 0 ? void 0 : JSDocComments.length) {
              return ts3.getLineStartPositionForPosition(JSDocComments[0].pos, sourceFile);
            }
          }
          var fullStart = node.getFullStart();
          var start = node.getStart(sourceFile);
          if (fullStart === start) {
            return start;
          }
          var fullStartLine = ts3.getLineStartPositionForPosition(fullStart, sourceFile);
          var startLine = ts3.getLineStartPositionForPosition(start, sourceFile);
          if (startLine === fullStartLine) {
            return leadingTriviaOption === LeadingTriviaOption.IncludeAll ? fullStart : start;
          }
          if (hasTrailingComment) {
            var comment = ((_a2 = ts3.getLeadingCommentRanges(sourceFile.text, fullStart)) === null || _a2 === void 0 ? void 0 : _a2[0]) || ((_b = ts3.getTrailingCommentRanges(sourceFile.text, fullStart)) === null || _b === void 0 ? void 0 : _b[0]);
            if (comment) {
              return ts3.skipTrivia(sourceFile.text, comment.end, true, true);
            }
          }
          var nextLineStart = fullStart > 0 ? 1 : 0;
          var adjustedStartPosition = ts3.getStartPositionOfLine(ts3.getLineOfLocalPosition(sourceFile, fullStartLine) + nextLineStart, sourceFile);
          adjustedStartPosition = skipWhitespacesAndLineBreaks(sourceFile.text, adjustedStartPosition);
          return ts3.getStartPositionOfLine(ts3.getLineOfLocalPosition(sourceFile, adjustedStartPosition), sourceFile);
        }
        function getEndPositionOfMultilineTrailingComment(sourceFile, node, options) {
          var end = node.end;
          var trailingTriviaOption = options.trailingTriviaOption;
          if (trailingTriviaOption === TrailingTriviaOption.Include) {
            var comments = ts3.getTrailingCommentRanges(sourceFile.text, end);
            if (comments) {
              var nodeEndLine = ts3.getLineOfLocalPosition(sourceFile, node.end);
              for (var _i = 0, comments_2 = comments; _i < comments_2.length; _i++) {
                var comment = comments_2[_i];
                if (comment.kind === 2 || ts3.getLineOfLocalPosition(sourceFile, comment.pos) > nodeEndLine) {
                  break;
                }
                var commentEndLine = ts3.getLineOfLocalPosition(sourceFile, comment.end);
                if (commentEndLine > nodeEndLine) {
                  return ts3.skipTrivia(sourceFile.text, comment.end, true, true);
                }
              }
            }
          }
          return void 0;
        }
        function getAdjustedEndPosition(sourceFile, node, options) {
          var _a2;
          var end = node.end;
          var trailingTriviaOption = options.trailingTriviaOption;
          if (trailingTriviaOption === TrailingTriviaOption.Exclude) {
            return end;
          }
          if (trailingTriviaOption === TrailingTriviaOption.ExcludeWhitespace) {
            var comments = ts3.concatenate(ts3.getTrailingCommentRanges(sourceFile.text, end), ts3.getLeadingCommentRanges(sourceFile.text, end));
            var realEnd = (_a2 = comments === null || comments === void 0 ? void 0 : comments[comments.length - 1]) === null || _a2 === void 0 ? void 0 : _a2.end;
            if (realEnd) {
              return realEnd;
            }
            return end;
          }
          var multilineEndPosition = getEndPositionOfMultilineTrailingComment(sourceFile, node, options);
          if (multilineEndPosition) {
            return multilineEndPosition;
          }
          var newEnd = ts3.skipTrivia(sourceFile.text, end, true);
          return newEnd !== end && (trailingTriviaOption === TrailingTriviaOption.Include || ts3.isLineBreak(sourceFile.text.charCodeAt(newEnd - 1))) ? newEnd : end;
        }
        function isSeparator(node, candidate) {
          return !!candidate && !!node.parent && (candidate.kind === 27 || candidate.kind === 26 && node.parent.kind === 201);
        }
        function isThisTypeAnnotatable(containingFunction) {
          return ts3.isFunctionExpression(containingFunction) || ts3.isFunctionDeclaration(containingFunction);
        }
        textChanges_3.isThisTypeAnnotatable = isThisTypeAnnotatable;
        var ChangeTracker = function() {
          function ChangeTracker2(newLineCharacter, formatContext) {
            this.newLineCharacter = newLineCharacter;
            this.formatContext = formatContext;
            this.changes = [];
            this.newFiles = [];
            this.classesWithNodesInsertedAtStart = new ts3.Map();
            this.deletedNodes = [];
          }
          ChangeTracker2.fromContext = function(context) {
            return new ChangeTracker2(ts3.getNewLineOrDefaultFromHost(context.host, context.formatContext.options), context.formatContext);
          };
          ChangeTracker2.with = function(context, cb2) {
            var tracker = ChangeTracker2.fromContext(context);
            cb2(tracker);
            return tracker.getChanges();
          };
          ChangeTracker2.prototype.pushRaw = function(sourceFile, change) {
            ts3.Debug.assertEqual(sourceFile.fileName, change.fileName);
            for (var _i = 0, _a2 = change.textChanges; _i < _a2.length; _i++) {
              var c2 = _a2[_i];
              this.changes.push({
                kind: ChangeKind.Text,
                sourceFile,
                text: c2.newText,
                range: ts3.createTextRangeFromSpan(c2.span)
              });
            }
          };
          ChangeTracker2.prototype.deleteRange = function(sourceFile, range) {
            this.changes.push({ kind: ChangeKind.Remove, sourceFile, range });
          };
          ChangeTracker2.prototype.delete = function(sourceFile, node) {
            this.deletedNodes.push({ sourceFile, node });
          };
          ChangeTracker2.prototype.deleteNode = function(sourceFile, node, options) {
            if (options === void 0) {
              options = { leadingTriviaOption: LeadingTriviaOption.IncludeAll };
            }
            this.deleteRange(sourceFile, getAdjustedRange(sourceFile, node, node, options));
          };
          ChangeTracker2.prototype.deleteNodes = function(sourceFile, nodes, options, hasTrailingComment) {
            if (options === void 0) {
              options = { leadingTriviaOption: LeadingTriviaOption.IncludeAll };
            }
            for (var _i = 0, nodes_1 = nodes; _i < nodes_1.length; _i++) {
              var node = nodes_1[_i];
              var pos = getAdjustedStartPosition(sourceFile, node, options, hasTrailingComment);
              var end = getAdjustedEndPosition(sourceFile, node, options);
              this.deleteRange(sourceFile, { pos, end });
              hasTrailingComment = !!getEndPositionOfMultilineTrailingComment(sourceFile, node, options);
            }
          };
          ChangeTracker2.prototype.deleteModifier = function(sourceFile, modifier) {
            this.deleteRange(sourceFile, { pos: modifier.getStart(sourceFile), end: ts3.skipTrivia(sourceFile.text, modifier.end, true) });
          };
          ChangeTracker2.prototype.deleteNodeRange = function(sourceFile, startNode, endNode, options) {
            if (options === void 0) {
              options = { leadingTriviaOption: LeadingTriviaOption.IncludeAll };
            }
            var startPosition = getAdjustedStartPosition(sourceFile, startNode, options);
            var endPosition = getAdjustedEndPosition(sourceFile, endNode, options);
            this.deleteRange(sourceFile, { pos: startPosition, end: endPosition });
          };
          ChangeTracker2.prototype.deleteNodeRangeExcludingEnd = function(sourceFile, startNode, afterEndNode, options) {
            if (options === void 0) {
              options = { leadingTriviaOption: LeadingTriviaOption.IncludeAll };
            }
            var startPosition = getAdjustedStartPosition(sourceFile, startNode, options);
            var endPosition = afterEndNode === void 0 ? sourceFile.text.length : getAdjustedStartPosition(sourceFile, afterEndNode, options);
            this.deleteRange(sourceFile, { pos: startPosition, end: endPosition });
          };
          ChangeTracker2.prototype.replaceRange = function(sourceFile, range, newNode, options) {
            if (options === void 0) {
              options = {};
            }
            this.changes.push({ kind: ChangeKind.ReplaceWithSingleNode, sourceFile, range, options, node: newNode });
          };
          ChangeTracker2.prototype.replaceNode = function(sourceFile, oldNode, newNode, options) {
            if (options === void 0) {
              options = useNonAdjustedPositions;
            }
            this.replaceRange(sourceFile, getAdjustedRange(sourceFile, oldNode, oldNode, options), newNode, options);
          };
          ChangeTracker2.prototype.replaceNodeRange = function(sourceFile, startNode, endNode, newNode, options) {
            if (options === void 0) {
              options = useNonAdjustedPositions;
            }
            this.replaceRange(sourceFile, getAdjustedRange(sourceFile, startNode, endNode, options), newNode, options);
          };
          ChangeTracker2.prototype.replaceRangeWithNodes = function(sourceFile, range, newNodes, options) {
            if (options === void 0) {
              options = {};
            }
            this.changes.push({ kind: ChangeKind.ReplaceWithMultipleNodes, sourceFile, range, options, nodes: newNodes });
          };
          ChangeTracker2.prototype.replaceNodeWithNodes = function(sourceFile, oldNode, newNodes, options) {
            if (options === void 0) {
              options = useNonAdjustedPositions;
            }
            this.replaceRangeWithNodes(sourceFile, getAdjustedRange(sourceFile, oldNode, oldNode, options), newNodes, options);
          };
          ChangeTracker2.prototype.replaceNodeWithText = function(sourceFile, oldNode, text) {
            this.replaceRangeWithText(sourceFile, getAdjustedRange(sourceFile, oldNode, oldNode, useNonAdjustedPositions), text);
          };
          ChangeTracker2.prototype.replaceNodeRangeWithNodes = function(sourceFile, startNode, endNode, newNodes, options) {
            if (options === void 0) {
              options = useNonAdjustedPositions;
            }
            this.replaceRangeWithNodes(sourceFile, getAdjustedRange(sourceFile, startNode, endNode, options), newNodes, options);
          };
          ChangeTracker2.prototype.nodeHasTrailingComment = function(sourceFile, oldNode, configurableEnd) {
            if (configurableEnd === void 0) {
              configurableEnd = useNonAdjustedPositions;
            }
            return !!getEndPositionOfMultilineTrailingComment(sourceFile, oldNode, configurableEnd);
          };
          ChangeTracker2.prototype.nextCommaToken = function(sourceFile, node) {
            var next = ts3.findNextToken(node, node.parent, sourceFile);
            return next && next.kind === 27 ? next : void 0;
          };
          ChangeTracker2.prototype.replacePropertyAssignment = function(sourceFile, oldNode, newNode) {
            var suffix = this.nextCommaToken(sourceFile, oldNode) ? "" : "," + this.newLineCharacter;
            this.replaceNode(sourceFile, oldNode, newNode, { suffix });
          };
          ChangeTracker2.prototype.insertNodeAt = function(sourceFile, pos, newNode, options) {
            if (options === void 0) {
              options = {};
            }
            this.replaceRange(sourceFile, ts3.createRange(pos), newNode, options);
          };
          ChangeTracker2.prototype.insertNodesAt = function(sourceFile, pos, newNodes, options) {
            if (options === void 0) {
              options = {};
            }
            this.replaceRangeWithNodes(sourceFile, ts3.createRange(pos), newNodes, options);
          };
          ChangeTracker2.prototype.insertNodeAtTopOfFile = function(sourceFile, newNode, blankLineBetween) {
            this.insertAtTopOfFile(sourceFile, newNode, blankLineBetween);
          };
          ChangeTracker2.prototype.insertNodesAtTopOfFile = function(sourceFile, newNodes, blankLineBetween) {
            this.insertAtTopOfFile(sourceFile, newNodes, blankLineBetween);
          };
          ChangeTracker2.prototype.insertAtTopOfFile = function(sourceFile, insert, blankLineBetween) {
            var pos = getInsertionPositionAtSourceFileTop(sourceFile);
            var options = {
              prefix: pos === 0 ? void 0 : this.newLineCharacter,
              suffix: (ts3.isLineBreak(sourceFile.text.charCodeAt(pos)) ? "" : this.newLineCharacter) + (blankLineBetween ? this.newLineCharacter : "")
            };
            if (ts3.isArray(insert)) {
              this.insertNodesAt(sourceFile, pos, insert, options);
            } else {
              this.insertNodeAt(sourceFile, pos, insert, options);
            }
          };
          ChangeTracker2.prototype.insertFirstParameter = function(sourceFile, parameters, newParam) {
            var p0 = ts3.firstOrUndefined(parameters);
            if (p0) {
              this.insertNodeBefore(sourceFile, p0, newParam);
            } else {
              this.insertNodeAt(sourceFile, parameters.pos, newParam);
            }
          };
          ChangeTracker2.prototype.insertNodeBefore = function(sourceFile, before, newNode, blankLineBetween, options) {
            if (blankLineBetween === void 0) {
              blankLineBetween = false;
            }
            if (options === void 0) {
              options = {};
            }
            this.insertNodeAt(sourceFile, getAdjustedStartPosition(sourceFile, before, options), newNode, this.getOptionsForInsertNodeBefore(before, newNode, blankLineBetween));
          };
          ChangeTracker2.prototype.insertModifierAt = function(sourceFile, pos, modifier, options) {
            if (options === void 0) {
              options = {};
            }
            this.insertNodeAt(sourceFile, pos, ts3.factory.createToken(modifier), options);
          };
          ChangeTracker2.prototype.insertModifierBefore = function(sourceFile, modifier, before) {
            return this.insertModifierAt(sourceFile, before.getStart(sourceFile), modifier, { suffix: " " });
          };
          ChangeTracker2.prototype.insertCommentBeforeLine = function(sourceFile, lineNumber, position, commentText) {
            var lineStartPosition = ts3.getStartPositionOfLine(lineNumber, sourceFile);
            var startPosition = ts3.getFirstNonSpaceCharacterPosition(sourceFile.text, lineStartPosition);
            var insertAtLineStart = isValidLocationToAddComment(sourceFile, startPosition);
            var token = ts3.getTouchingToken(sourceFile, insertAtLineStart ? startPosition : position);
            var indent = sourceFile.text.slice(lineStartPosition, startPosition);
            var text = (insertAtLineStart ? "" : this.newLineCharacter) + "//" + commentText + this.newLineCharacter + indent;
            this.insertText(sourceFile, token.getStart(sourceFile), text);
          };
          ChangeTracker2.prototype.insertJsdocCommentBefore = function(sourceFile, node, tag) {
            var fnStart = node.getStart(sourceFile);
            if (node.jsDoc) {
              for (var _i = 0, _a2 = node.jsDoc; _i < _a2.length; _i++) {
                var jsdoc = _a2[_i];
                this.deleteRange(sourceFile, {
                  pos: ts3.getLineStartPositionForPosition(jsdoc.getStart(sourceFile), sourceFile),
                  end: getAdjustedEndPosition(sourceFile, jsdoc, {})
                });
              }
            }
            var startPosition = ts3.getPrecedingNonSpaceCharacterPosition(sourceFile.text, fnStart - 1);
            var indent = sourceFile.text.slice(startPosition, fnStart);
            this.insertNodeAt(sourceFile, fnStart, tag, { preserveLeadingWhitespace: false, suffix: this.newLineCharacter + indent });
          };
          ChangeTracker2.prototype.replaceRangeWithText = function(sourceFile, range, text) {
            this.changes.push({ kind: ChangeKind.Text, sourceFile, range, text });
          };
          ChangeTracker2.prototype.insertText = function(sourceFile, pos, text) {
            this.replaceRangeWithText(sourceFile, ts3.createRange(pos), text);
          };
          ChangeTracker2.prototype.tryInsertTypeAnnotation = function(sourceFile, node, type3) {
            var _a2;
            var endNode;
            if (ts3.isFunctionLike(node)) {
              endNode = ts3.findChildOfKind(node, 21, sourceFile);
              if (!endNode) {
                if (!ts3.isArrowFunction(node))
                  return false;
                endNode = ts3.first(node.parameters);
              }
            } else {
              endNode = (_a2 = node.kind === 250 ? node.exclamationToken : node.questionToken) !== null && _a2 !== void 0 ? _a2 : node.name;
            }
            this.insertNodeAt(sourceFile, endNode.end, type3, { prefix: ": " });
            return true;
          };
          ChangeTracker2.prototype.tryInsertThisTypeAnnotation = function(sourceFile, node, type3) {
            var start = ts3.findChildOfKind(node, 20, sourceFile).getStart(sourceFile) + 1;
            var suffix = node.parameters.length ? ", " : "";
            this.insertNodeAt(sourceFile, start, type3, { prefix: "this: ", suffix });
          };
          ChangeTracker2.prototype.insertTypeParameters = function(sourceFile, node, typeParameters) {
            var start = (ts3.findChildOfKind(node, 20, sourceFile) || ts3.first(node.parameters)).getStart(sourceFile);
            this.insertNodesAt(sourceFile, start, typeParameters, { prefix: "<", suffix: ">", joiner: ", " });
          };
          ChangeTracker2.prototype.getOptionsForInsertNodeBefore = function(before, inserted, blankLineBetween) {
            if (ts3.isStatement(before) || ts3.isClassElement(before)) {
              return { suffix: blankLineBetween ? this.newLineCharacter + this.newLineCharacter : this.newLineCharacter };
            } else if (ts3.isVariableDeclaration(before)) {
              return { suffix: ", " };
            } else if (ts3.isParameter(before)) {
              return ts3.isParameter(inserted) ? { suffix: ", " } : {};
            } else if (ts3.isStringLiteral(before) && ts3.isImportDeclaration(before.parent) || ts3.isNamedImports(before)) {
              return { suffix: ", " };
            } else if (ts3.isImportSpecifier(before)) {
              return { suffix: "," + (blankLineBetween ? this.newLineCharacter : " ") };
            }
            return ts3.Debug.failBadSyntaxKind(before);
          };
          ChangeTracker2.prototype.insertNodeAtConstructorStart = function(sourceFile, ctr, newStatement) {
            var firstStatement = ts3.firstOrUndefined(ctr.body.statements);
            if (!firstStatement || !ctr.body.multiLine) {
              this.replaceConstructorBody(sourceFile, ctr, __spreadArray([newStatement], ctr.body.statements));
            } else {
              this.insertNodeBefore(sourceFile, firstStatement, newStatement);
            }
          };
          ChangeTracker2.prototype.insertNodeAtConstructorStartAfterSuperCall = function(sourceFile, ctr, newStatement) {
            var superCallStatement = ts3.find(ctr.body.statements, function(stmt) {
              return ts3.isExpressionStatement(stmt) && ts3.isSuperCall(stmt.expression);
            });
            if (!superCallStatement || !ctr.body.multiLine) {
              this.replaceConstructorBody(sourceFile, ctr, __spreadArray(__spreadArray([], ctr.body.statements), [newStatement]));
            } else {
              this.insertNodeAfter(sourceFile, superCallStatement, newStatement);
            }
          };
          ChangeTracker2.prototype.insertNodeAtConstructorEnd = function(sourceFile, ctr, newStatement) {
            var lastStatement = ts3.lastOrUndefined(ctr.body.statements);
            if (!lastStatement || !ctr.body.multiLine) {
              this.replaceConstructorBody(sourceFile, ctr, __spreadArray(__spreadArray([], ctr.body.statements), [newStatement]));
            } else {
              this.insertNodeAfter(sourceFile, lastStatement, newStatement);
            }
          };
          ChangeTracker2.prototype.replaceConstructorBody = function(sourceFile, ctr, statements) {
            this.replaceNode(sourceFile, ctr.body, ts3.factory.createBlock(statements, true));
          };
          ChangeTracker2.prototype.insertNodeAtEndOfScope = function(sourceFile, scope, newNode) {
            var pos = getAdjustedStartPosition(sourceFile, scope.getLastToken(), {});
            this.insertNodeAt(sourceFile, pos, newNode, {
              prefix: ts3.isLineBreak(sourceFile.text.charCodeAt(scope.getLastToken().pos)) ? this.newLineCharacter : this.newLineCharacter + this.newLineCharacter,
              suffix: this.newLineCharacter
            });
          };
          ChangeTracker2.prototype.insertNodeAtClassStart = function(sourceFile, cls, newElement) {
            this.insertNodeAtStartWorker(sourceFile, cls, newElement);
          };
          ChangeTracker2.prototype.insertNodeAtObjectStart = function(sourceFile, obj, newElement) {
            this.insertNodeAtStartWorker(sourceFile, obj, newElement);
          };
          ChangeTracker2.prototype.insertNodeAtStartWorker = function(sourceFile, cls, newElement) {
            var _a2;
            var indentation = (_a2 = this.guessIndentationFromExistingMembers(sourceFile, cls)) !== null && _a2 !== void 0 ? _a2 : this.computeIndentationForNewMember(sourceFile, cls);
            this.insertNodeAt(sourceFile, getMembersOrProperties(cls).pos, newElement, this.getInsertNodeAtStartInsertOptions(sourceFile, cls, indentation));
          };
          ChangeTracker2.prototype.guessIndentationFromExistingMembers = function(sourceFile, cls) {
            var indentation;
            var lastRange = cls;
            for (var _i = 0, _a2 = getMembersOrProperties(cls); _i < _a2.length; _i++) {
              var member = _a2[_i];
              if (ts3.rangeStartPositionsAreOnSameLine(lastRange, member, sourceFile)) {
                return void 0;
              }
              var memberStart = member.getStart(sourceFile);
              var memberIndentation = ts3.formatting.SmartIndenter.findFirstNonWhitespaceColumn(ts3.getLineStartPositionForPosition(memberStart, sourceFile), memberStart, sourceFile, this.formatContext.options);
              if (indentation === void 0) {
                indentation = memberIndentation;
              } else if (memberIndentation !== indentation) {
                return void 0;
              }
              lastRange = member;
            }
            return indentation;
          };
          ChangeTracker2.prototype.computeIndentationForNewMember = function(sourceFile, cls) {
            var _a2;
            var clsStart = cls.getStart(sourceFile);
            return ts3.formatting.SmartIndenter.findFirstNonWhitespaceColumn(ts3.getLineStartPositionForPosition(clsStart, sourceFile), clsStart, sourceFile, this.formatContext.options) + ((_a2 = this.formatContext.options.indentSize) !== null && _a2 !== void 0 ? _a2 : 4);
          };
          ChangeTracker2.prototype.getInsertNodeAtStartInsertOptions = function(sourceFile, cls, indentation) {
            var members = getMembersOrProperties(cls);
            var isEmpty = members.length === 0;
            var isFirstInsertion = ts3.addToSeen(this.classesWithNodesInsertedAtStart, ts3.getNodeId(cls), { node: cls, sourceFile });
            var insertTrailingComma = ts3.isObjectLiteralExpression(cls) && (!ts3.isJsonSourceFile(sourceFile) || !isEmpty);
            var insertLeadingComma = ts3.isObjectLiteralExpression(cls) && ts3.isJsonSourceFile(sourceFile) && isEmpty && !isFirstInsertion;
            return {
              indentation,
              prefix: (insertLeadingComma ? "," : "") + this.newLineCharacter,
              suffix: insertTrailingComma ? "," : ""
            };
          };
          ChangeTracker2.prototype.insertNodeAfterComma = function(sourceFile, after, newNode) {
            var endPosition = this.insertNodeAfterWorker(sourceFile, this.nextCommaToken(sourceFile, after) || after, newNode);
            this.insertNodeAt(sourceFile, endPosition, newNode, this.getInsertNodeAfterOptions(sourceFile, after));
          };
          ChangeTracker2.prototype.insertNodeAfter = function(sourceFile, after, newNode) {
            var endPosition = this.insertNodeAfterWorker(sourceFile, after, newNode);
            this.insertNodeAt(sourceFile, endPosition, newNode, this.getInsertNodeAfterOptions(sourceFile, after));
          };
          ChangeTracker2.prototype.insertNodeAtEndOfList = function(sourceFile, list, newNode) {
            this.insertNodeAt(sourceFile, list.end, newNode, { prefix: ", " });
          };
          ChangeTracker2.prototype.insertNodesAfter = function(sourceFile, after, newNodes) {
            var endPosition = this.insertNodeAfterWorker(sourceFile, after, ts3.first(newNodes));
            this.insertNodesAt(sourceFile, endPosition, newNodes, this.getInsertNodeAfterOptions(sourceFile, after));
          };
          ChangeTracker2.prototype.insertNodeAfterWorker = function(sourceFile, after, newNode) {
            if (needSemicolonBetween(after, newNode)) {
              if (sourceFile.text.charCodeAt(after.end - 1) !== 59) {
                this.replaceRange(sourceFile, ts3.createRange(after.end), ts3.factory.createToken(26));
              }
            }
            var endPosition = getAdjustedEndPosition(sourceFile, after, {});
            return endPosition;
          };
          ChangeTracker2.prototype.getInsertNodeAfterOptions = function(sourceFile, after) {
            var options = this.getInsertNodeAfterOptionsWorker(after);
            return __assign(__assign({}, options), { prefix: after.end === sourceFile.end && ts3.isStatement(after) ? options.prefix ? "\n" + options.prefix : "\n" : options.prefix });
          };
          ChangeTracker2.prototype.getInsertNodeAfterOptionsWorker = function(node) {
            switch (node.kind) {
              case 253:
              case 257:
                return { prefix: this.newLineCharacter, suffix: this.newLineCharacter };
              case 250:
              case 10:
              case 78:
                return { prefix: ", " };
              case 289:
                return { suffix: "," + this.newLineCharacter };
              case 92:
                return { prefix: " " };
              case 161:
                return {};
              default:
                ts3.Debug.assert(ts3.isStatement(node) || ts3.isClassOrTypeElement(node));
                return { suffix: this.newLineCharacter };
            }
          };
          ChangeTracker2.prototype.insertName = function(sourceFile, node, name) {
            ts3.Debug.assert(!node.name);
            if (node.kind === 210) {
              var arrow = ts3.findChildOfKind(node, 38, sourceFile);
              var lparen = ts3.findChildOfKind(node, 20, sourceFile);
              if (lparen) {
                this.insertNodesAt(sourceFile, lparen.getStart(sourceFile), [ts3.factory.createToken(97), ts3.factory.createIdentifier(name)], { joiner: " " });
                deleteNode(this, sourceFile, arrow);
              } else {
                this.insertText(sourceFile, ts3.first(node.parameters).getStart(sourceFile), "function " + name + "(");
                this.replaceRange(sourceFile, arrow, ts3.factory.createToken(21));
              }
              if (node.body.kind !== 231) {
                this.insertNodesAt(sourceFile, node.body.getStart(sourceFile), [ts3.factory.createToken(18), ts3.factory.createToken(104)], { joiner: " ", suffix: " " });
                this.insertNodesAt(sourceFile, node.body.end, [ts3.factory.createToken(26), ts3.factory.createToken(19)], { joiner: " " });
              }
            } else {
              var pos = ts3.findChildOfKind(node, node.kind === 209 ? 97 : 83, sourceFile).end;
              this.insertNodeAt(sourceFile, pos, ts3.factory.createIdentifier(name), { prefix: " " });
            }
          };
          ChangeTracker2.prototype.insertExportModifier = function(sourceFile, node) {
            this.insertText(sourceFile, node.getStart(sourceFile), "export ");
          };
          ChangeTracker2.prototype.insertNodeInListAfter = function(sourceFile, after, newNode, containingList) {
            if (containingList === void 0) {
              containingList = ts3.formatting.SmartIndenter.getContainingList(after, sourceFile);
            }
            if (!containingList) {
              ts3.Debug.fail("node is not a list element");
              return;
            }
            var index = ts3.indexOfNode(containingList, after);
            if (index < 0) {
              return;
            }
            var end = after.getEnd();
            if (index !== containingList.length - 1) {
              var nextToken = ts3.getTokenAtPosition(sourceFile, after.end);
              if (nextToken && isSeparator(after, nextToken)) {
                var nextNode = containingList[index + 1];
                var startPos = skipWhitespacesAndLineBreaks(sourceFile.text, nextNode.getFullStart());
                var suffix = "" + ts3.tokenToString(nextToken.kind) + sourceFile.text.substring(nextToken.end, startPos);
                this.insertNodesAt(sourceFile, startPos, [newNode], { suffix });
              }
            } else {
              var afterStart = after.getStart(sourceFile);
              var afterStartLinePosition = ts3.getLineStartPositionForPosition(afterStart, sourceFile);
              var separator = void 0;
              var multilineList = false;
              if (containingList.length === 1) {
                separator = 27;
              } else {
                var tokenBeforeInsertPosition = ts3.findPrecedingToken(after.pos, sourceFile);
                separator = isSeparator(after, tokenBeforeInsertPosition) ? tokenBeforeInsertPosition.kind : 27;
                var afterMinusOneStartLinePosition = ts3.getLineStartPositionForPosition(containingList[index - 1].getStart(sourceFile), sourceFile);
                multilineList = afterMinusOneStartLinePosition !== afterStartLinePosition;
              }
              if (hasCommentsBeforeLineBreak(sourceFile.text, after.end)) {
                multilineList = true;
              }
              if (multilineList) {
                this.replaceRange(sourceFile, ts3.createRange(end), ts3.factory.createToken(separator));
                var indentation = ts3.formatting.SmartIndenter.findFirstNonWhitespaceColumn(afterStartLinePosition, afterStart, sourceFile, this.formatContext.options);
                var insertPos = ts3.skipTrivia(sourceFile.text, end, true, false);
                while (insertPos !== end && ts3.isLineBreak(sourceFile.text.charCodeAt(insertPos - 1))) {
                  insertPos--;
                }
                this.replaceRange(sourceFile, ts3.createRange(insertPos), newNode, { indentation, prefix: this.newLineCharacter });
              } else {
                this.replaceRange(sourceFile, ts3.createRange(end), newNode, { prefix: ts3.tokenToString(separator) + " " });
              }
            }
          };
          ChangeTracker2.prototype.parenthesizeExpression = function(sourceFile, expression) {
            this.replaceRange(sourceFile, ts3.rangeOfNode(expression), ts3.factory.createParenthesizedExpression(expression));
          };
          ChangeTracker2.prototype.finishClassesWithNodesInsertedAtStart = function() {
            var _this = this;
            this.classesWithNodesInsertedAtStart.forEach(function(_a2) {
              var node = _a2.node, sourceFile = _a2.sourceFile;
              var _b = getClassOrObjectBraceEnds(node, sourceFile), openBraceEnd = _b[0], closeBraceEnd = _b[1];
              if (openBraceEnd !== void 0 && closeBraceEnd !== void 0) {
                var isEmpty = getMembersOrProperties(node).length === 0;
                var isSingleLine = ts3.positionsAreOnSameLine(openBraceEnd, closeBraceEnd, sourceFile);
                if (isEmpty && isSingleLine && openBraceEnd !== closeBraceEnd - 1) {
                  _this.deleteRange(sourceFile, ts3.createRange(openBraceEnd, closeBraceEnd - 1));
                }
                if (isSingleLine) {
                  _this.insertText(sourceFile, closeBraceEnd - 1, _this.newLineCharacter);
                }
              }
            });
          };
          ChangeTracker2.prototype.finishDeleteDeclarations = function() {
            var _this = this;
            var deletedNodesInLists = new ts3.Set();
            var _loop_10 = function(sourceFile2, node2) {
              if (!this_1.deletedNodes.some(function(d) {
                return d.sourceFile === sourceFile2 && ts3.rangeContainsRangeExclusive(d.node, node2);
              })) {
                if (ts3.isArray(node2)) {
                  this_1.deleteRange(sourceFile2, ts3.rangeOfTypeParameters(sourceFile2, node2));
                } else {
                  deleteDeclaration.deleteDeclaration(this_1, deletedNodesInLists, sourceFile2, node2);
                }
              }
            };
            var this_1 = this;
            for (var _i = 0, _a2 = this.deletedNodes; _i < _a2.length; _i++) {
              var _b = _a2[_i], sourceFile = _b.sourceFile, node = _b.node;
              _loop_10(sourceFile, node);
            }
            deletedNodesInLists.forEach(function(node2) {
              var sourceFile2 = node2.getSourceFile();
              var list = ts3.formatting.SmartIndenter.getContainingList(node2, sourceFile2);
              if (node2 !== ts3.last(list))
                return;
              var lastNonDeletedIndex = ts3.findLastIndex(list, function(n2) {
                return !deletedNodesInLists.has(n2);
              }, list.length - 2);
              if (lastNonDeletedIndex !== -1) {
                _this.deleteRange(sourceFile2, { pos: list[lastNonDeletedIndex].end, end: startPositionToDeleteNodeInList(sourceFile2, list[lastNonDeletedIndex + 1]) });
              }
            });
          };
          ChangeTracker2.prototype.getChanges = function(validate) {
            this.finishDeleteDeclarations();
            this.finishClassesWithNodesInsertedAtStart();
            var changes = changesToText.getTextChangesFromChanges(this.changes, this.newLineCharacter, this.formatContext, validate);
            for (var _i = 0, _a2 = this.newFiles; _i < _a2.length; _i++) {
              var _b = _a2[_i], oldFile = _b.oldFile, fileName = _b.fileName, statements = _b.statements;
              changes.push(changesToText.newFileChanges(oldFile, fileName, statements, this.newLineCharacter, this.formatContext));
            }
            return changes;
          };
          ChangeTracker2.prototype.createNewFile = function(oldFile, fileName, statements) {
            this.newFiles.push({ oldFile, fileName, statements });
          };
          return ChangeTracker2;
        }();
        textChanges_3.ChangeTracker = ChangeTracker;
        function startPositionToDeleteNodeInList(sourceFile, node) {
          return ts3.skipTrivia(sourceFile.text, getAdjustedStartPosition(sourceFile, node, { leadingTriviaOption: LeadingTriviaOption.IncludeAll }), false, true);
        }
        function getClassOrObjectBraceEnds(cls, sourceFile) {
          var open = ts3.findChildOfKind(cls, 18, sourceFile);
          var close = ts3.findChildOfKind(cls, 19, sourceFile);
          return [open === null || open === void 0 ? void 0 : open.end, close === null || close === void 0 ? void 0 : close.end];
        }
        function getMembersOrProperties(cls) {
          return ts3.isObjectLiteralExpression(cls) ? cls.properties : cls.members;
        }
        function getNewFileText(statements, scriptKind, newLineCharacter, formatContext) {
          return changesToText.newFileChangesWorker(void 0, scriptKind, statements, newLineCharacter, formatContext);
        }
        textChanges_3.getNewFileText = getNewFileText;
        var changesToText;
        (function(changesToText2) {
          function getTextChangesFromChanges(changes, newLineCharacter, formatContext, validate) {
            return ts3.mapDefined(ts3.group(changes, function(c2) {
              return c2.sourceFile.path;
            }), function(changesInFile) {
              var sourceFile = changesInFile[0].sourceFile;
              var normalized = ts3.stableSort(changesInFile, function(a2, b2) {
                return a2.range.pos - b2.range.pos || a2.range.end - b2.range.end;
              });
              var _loop_11 = function(i4) {
                ts3.Debug.assert(normalized[i4].range.end <= normalized[i4 + 1].range.pos, "Changes overlap", function() {
                  return JSON.stringify(normalized[i4].range) + " and " + JSON.stringify(normalized[i4 + 1].range);
                });
              };
              for (var i3 = 0; i3 < normalized.length - 1; i3++) {
                _loop_11(i3);
              }
              var textChanges2 = ts3.mapDefined(normalized, function(c2) {
                var span = ts3.createTextSpanFromRange(c2.range);
                var newText = computeNewText(c2, sourceFile, newLineCharacter, formatContext, validate);
                if (span.length === newText.length && ts3.stringContainsAt(sourceFile.text, newText, span.start)) {
                  return void 0;
                }
                return ts3.createTextChange(span, newText);
              });
              return textChanges2.length > 0 ? { fileName: sourceFile.fileName, textChanges: textChanges2 } : void 0;
            });
          }
          changesToText2.getTextChangesFromChanges = getTextChangesFromChanges;
          function newFileChanges(oldFile, fileName, statements, newLineCharacter, formatContext) {
            var text = newFileChangesWorker(oldFile, ts3.getScriptKindFromFileName(fileName), statements, newLineCharacter, formatContext);
            return { fileName, textChanges: [ts3.createTextChange(ts3.createTextSpan(0, 0), text)], isNewFile: true };
          }
          changesToText2.newFileChanges = newFileChanges;
          function newFileChangesWorker(oldFile, scriptKind, statements, newLineCharacter, formatContext) {
            var nonFormattedText = statements.map(function(s2) {
              return s2 === 4 ? "" : getNonformattedText(s2, oldFile, newLineCharacter).text;
            }).join(newLineCharacter);
            var sourceFile = ts3.createSourceFile("any file name", nonFormattedText, 99, true, scriptKind);
            var changes = ts3.formatting.formatDocument(sourceFile, formatContext);
            return applyChanges(nonFormattedText, changes) + newLineCharacter;
          }
          changesToText2.newFileChangesWorker = newFileChangesWorker;
          function computeNewText(change, sourceFile, newLineCharacter, formatContext, validate) {
            if (change.kind === ChangeKind.Remove) {
              return "";
            }
            if (change.kind === ChangeKind.Text) {
              return change.text;
            }
            var _a2 = change.options, options = _a2 === void 0 ? {} : _a2, pos = change.range.pos;
            var format = function(n2) {
              return getFormattedTextOfNode(n2, sourceFile, pos, options, newLineCharacter, formatContext, validate);
            };
            var text = change.kind === ChangeKind.ReplaceWithMultipleNodes ? change.nodes.map(function(n2) {
              return ts3.removeSuffix(format(n2), newLineCharacter);
            }).join(change.options.joiner || newLineCharacter) : format(change.node);
            var noIndent = options.preserveLeadingWhitespace || options.indentation !== void 0 || ts3.getLineStartPositionForPosition(pos, sourceFile) === pos ? text : text.replace(/^\s+/, "");
            return (options.prefix || "") + noIndent + (!options.suffix || ts3.endsWith(noIndent, options.suffix) ? "" : options.suffix);
          }
          function getFormatCodeSettingsForWriting(_a2, sourceFile) {
            var options = _a2.options;
            var shouldAutoDetectSemicolonPreference = !options.semicolons || options.semicolons === ts3.SemicolonPreference.Ignore;
            var shouldRemoveSemicolons = options.semicolons === ts3.SemicolonPreference.Remove || shouldAutoDetectSemicolonPreference && !ts3.probablyUsesSemicolons(sourceFile);
            return __assign(__assign({}, options), { semicolons: shouldRemoveSemicolons ? ts3.SemicolonPreference.Remove : ts3.SemicolonPreference.Ignore });
          }
          function getFormattedTextOfNode(nodeIn, sourceFile, pos, _a2, newLineCharacter, formatContext, validate) {
            var indentation = _a2.indentation, prefix2 = _a2.prefix, delta = _a2.delta;
            var _b = getNonformattedText(nodeIn, sourceFile, newLineCharacter), node = _b.node, text = _b.text;
            if (validate)
              validate(node, text);
            var formatOptions = getFormatCodeSettingsForWriting(formatContext, sourceFile);
            var initialIndentation = indentation !== void 0 ? indentation : ts3.formatting.SmartIndenter.getIndentation(pos, sourceFile, formatOptions, prefix2 === newLineCharacter || ts3.getLineStartPositionForPosition(pos, sourceFile) === pos);
            if (delta === void 0) {
              delta = ts3.formatting.SmartIndenter.shouldIndentChildNode(formatOptions, nodeIn) ? formatOptions.indentSize || 0 : 0;
            }
            var file = { text, getLineAndCharacterOfPosition: function(pos2) {
              return ts3.getLineAndCharacterOfPosition(this, pos2);
            } };
            var changes = ts3.formatting.formatNodeGivenIndentation(node, file, sourceFile.languageVariant, initialIndentation, delta, __assign(__assign({}, formatContext), { options: formatOptions }));
            return applyChanges(text, changes);
          }
          function getNonformattedText(node, sourceFile, newLineCharacter) {
            var writer = createWriter(newLineCharacter);
            var newLine = newLineCharacter === "\n" ? 1 : 0;
            ts3.createPrinter({
              newLine,
              neverAsciiEscape: true,
              preserveSourceNewlines: true,
              terminateUnterminatedLiterals: true
            }, writer).writeNode(4, node, sourceFile, writer);
            return { text: writer.getText(), node: assignPositionsToNode(node) };
          }
          changesToText2.getNonformattedText = getNonformattedText;
        })(changesToText || (changesToText = {}));
        function applyChanges(text, changes) {
          for (var i3 = changes.length - 1; i3 >= 0; i3--) {
            var _a2 = changes[i3], span = _a2.span, newText = _a2.newText;
            text = "" + text.substring(0, span.start) + newText + text.substring(ts3.textSpanEnd(span));
          }
          return text;
        }
        textChanges_3.applyChanges = applyChanges;
        function isTrivia(s2) {
          return ts3.skipTrivia(s2, 0) === s2.length;
        }
        function assignPositionsToNode(node) {
          var visited = ts3.visitEachChild(node, assignPositionsToNode, ts3.nullTransformationContext, assignPositionsToNodeArray, assignPositionsToNode);
          var newNode = ts3.nodeIsSynthesized(visited) ? visited : Object.create(visited);
          ts3.setTextRangePosEnd(newNode, getPos(node), getEnd(node));
          return newNode;
        }
        function assignPositionsToNodeArray(nodes, visitor, test, start, count) {
          var visited = ts3.visitNodes(nodes, visitor, test, start, count);
          if (!visited) {
            return visited;
          }
          var nodeArray = visited === nodes ? ts3.factory.createNodeArray(visited.slice(0)) : visited;
          ts3.setTextRangePosEnd(nodeArray, getPos(nodes), getEnd(nodes));
          return nodeArray;
        }
        function createWriter(newLine) {
          var lastNonTriviaPosition = 0;
          var writer = ts3.createTextWriter(newLine);
          var onBeforeEmitNode = function(node) {
            if (node) {
              setPos(node, lastNonTriviaPosition);
            }
          };
          var onAfterEmitNode = function(node) {
            if (node) {
              setEnd(node, lastNonTriviaPosition);
            }
          };
          var onBeforeEmitNodeArray = function(nodes) {
            if (nodes) {
              setPos(nodes, lastNonTriviaPosition);
            }
          };
          var onAfterEmitNodeArray = function(nodes) {
            if (nodes) {
              setEnd(nodes, lastNonTriviaPosition);
            }
          };
          var onBeforeEmitToken = function(node) {
            if (node) {
              setPos(node, lastNonTriviaPosition);
            }
          };
          var onAfterEmitToken = function(node) {
            if (node) {
              setEnd(node, lastNonTriviaPosition);
            }
          };
          function setLastNonTriviaPosition(s2, force) {
            if (force || !isTrivia(s2)) {
              lastNonTriviaPosition = writer.getTextPos();
              var i3 = 0;
              while (ts3.isWhiteSpaceLike(s2.charCodeAt(s2.length - i3 - 1))) {
                i3++;
              }
              lastNonTriviaPosition -= i3;
            }
          }
          function write(s2) {
            writer.write(s2);
            setLastNonTriviaPosition(s2, false);
          }
          function writeComment(s2) {
            writer.writeComment(s2);
          }
          function writeKeyword(s2) {
            writer.writeKeyword(s2);
            setLastNonTriviaPosition(s2, false);
          }
          function writeOperator(s2) {
            writer.writeOperator(s2);
            setLastNonTriviaPosition(s2, false);
          }
          function writePunctuation(s2) {
            writer.writePunctuation(s2);
            setLastNonTriviaPosition(s2, false);
          }
          function writeTrailingSemicolon(s2) {
            writer.writeTrailingSemicolon(s2);
            setLastNonTriviaPosition(s2, false);
          }
          function writeParameter(s2) {
            writer.writeParameter(s2);
            setLastNonTriviaPosition(s2, false);
          }
          function writeProperty(s2) {
            writer.writeProperty(s2);
            setLastNonTriviaPosition(s2, false);
          }
          function writeSpace(s2) {
            writer.writeSpace(s2);
            setLastNonTriviaPosition(s2, false);
          }
          function writeStringLiteral(s2) {
            writer.writeStringLiteral(s2);
            setLastNonTriviaPosition(s2, false);
          }
          function writeSymbol(s2, sym) {
            writer.writeSymbol(s2, sym);
            setLastNonTriviaPosition(s2, false);
          }
          function writeLine(force) {
            writer.writeLine(force);
          }
          function increaseIndent() {
            writer.increaseIndent();
          }
          function decreaseIndent() {
            writer.decreaseIndent();
          }
          function getText() {
            return writer.getText();
          }
          function rawWrite(s2) {
            writer.rawWrite(s2);
            setLastNonTriviaPosition(s2, false);
          }
          function writeLiteral(s2) {
            writer.writeLiteral(s2);
            setLastNonTriviaPosition(s2, true);
          }
          function getTextPos() {
            return writer.getTextPos();
          }
          function getLine2() {
            return writer.getLine();
          }
          function getColumn() {
            return writer.getColumn();
          }
          function getIndent() {
            return writer.getIndent();
          }
          function isAtStartOfLine() {
            return writer.isAtStartOfLine();
          }
          function clear() {
            writer.clear();
            lastNonTriviaPosition = 0;
          }
          return {
            onBeforeEmitNode,
            onAfterEmitNode,
            onBeforeEmitNodeArray,
            onAfterEmitNodeArray,
            onBeforeEmitToken,
            onAfterEmitToken,
            write,
            writeComment,
            writeKeyword,
            writeOperator,
            writePunctuation,
            writeTrailingSemicolon,
            writeParameter,
            writeProperty,
            writeSpace,
            writeStringLiteral,
            writeSymbol,
            writeLine,
            increaseIndent,
            decreaseIndent,
            getText,
            rawWrite,
            writeLiteral,
            getTextPos,
            getLine: getLine2,
            getColumn,
            getIndent,
            isAtStartOfLine,
            hasTrailingComment: function() {
              return writer.hasTrailingComment();
            },
            hasTrailingWhitespace: function() {
              return writer.hasTrailingWhitespace();
            },
            clear
          };
        }
        function getInsertionPositionAtSourceFileTop(sourceFile) {
          var lastPrologue;
          for (var _i = 0, _a2 = sourceFile.statements; _i < _a2.length; _i++) {
            var node = _a2[_i];
            if (ts3.isPrologueDirective(node)) {
              lastPrologue = node;
            } else {
              break;
            }
          }
          var position = 0;
          var text = sourceFile.text;
          if (lastPrologue) {
            position = lastPrologue.end;
            advancePastLineBreak();
            return position;
          }
          var shebang = ts3.getShebang(text);
          if (shebang !== void 0) {
            position = shebang.length;
            advancePastLineBreak();
          }
          var ranges = ts3.getLeadingCommentRanges(text, position);
          if (!ranges)
            return position;
          var lastComment;
          var firstNodeLine;
          for (var _b = 0, ranges_1 = ranges; _b < ranges_1.length; _b++) {
            var range = ranges_1[_b];
            if (range.kind === 3) {
              if (ts3.isPinnedComment(text, range.pos)) {
                lastComment = { range, pinnedOrTripleSlash: true };
                continue;
              }
            } else if (ts3.isRecognizedTripleSlashComment(text, range.pos, range.end)) {
              lastComment = { range, pinnedOrTripleSlash: true };
              continue;
            }
            if (lastComment) {
              if (lastComment.pinnedOrTripleSlash)
                break;
              var commentLine = sourceFile.getLineAndCharacterOfPosition(range.pos).line;
              var lastCommentEndLine = sourceFile.getLineAndCharacterOfPosition(lastComment.range.end).line;
              if (commentLine >= lastCommentEndLine + 2)
                break;
            }
            if (sourceFile.statements.length) {
              if (firstNodeLine === void 0)
                firstNodeLine = sourceFile.getLineAndCharacterOfPosition(sourceFile.statements[0].getStart()).line;
              var commentEndLine = sourceFile.getLineAndCharacterOfPosition(range.end).line;
              if (firstNodeLine < commentEndLine + 2)
                break;
            }
            lastComment = { range, pinnedOrTripleSlash: false };
          }
          if (lastComment) {
            position = lastComment.range.end;
            advancePastLineBreak();
          }
          return position;
          function advancePastLineBreak() {
            if (position < text.length) {
              var charCode = text.charCodeAt(position);
              if (ts3.isLineBreak(charCode)) {
                position++;
                if (position < text.length && charCode === 13 && text.charCodeAt(position) === 10) {
                  position++;
                }
              }
            }
          }
        }
        function isValidLocationToAddComment(sourceFile, position) {
          return !ts3.isInComment(sourceFile, position) && !ts3.isInString(sourceFile, position) && !ts3.isInTemplateString(sourceFile, position) && !ts3.isInJSXText(sourceFile, position);
        }
        textChanges_3.isValidLocationToAddComment = isValidLocationToAddComment;
        function needSemicolonBetween(a2, b2) {
          return (ts3.isPropertySignature(a2) || ts3.isPropertyDeclaration(a2)) && ts3.isClassOrTypeElement(b2) && b2.name.kind === 159 || ts3.isStatementButNotDeclaration(a2) && ts3.isStatementButNotDeclaration(b2);
        }
        var deleteDeclaration;
        (function(deleteDeclaration_1) {
          function deleteDeclaration2(changes, deletedNodesInLists, sourceFile, node) {
            switch (node.kind) {
              case 161: {
                var oldFunction = node.parent;
                if (ts3.isArrowFunction(oldFunction) && oldFunction.parameters.length === 1 && !ts3.findChildOfKind(oldFunction, 20, sourceFile)) {
                  changes.replaceNodeWithText(sourceFile, node, "()");
                } else {
                  deleteNodeInList(changes, deletedNodesInLists, sourceFile, node);
                }
                break;
              }
              case 262:
              case 261:
                var isFirstImport = sourceFile.imports.length && node === ts3.first(sourceFile.imports).parent || node === ts3.find(sourceFile.statements, ts3.isAnyImportSyntax);
                deleteNode(changes, sourceFile, node, {
                  leadingTriviaOption: isFirstImport ? LeadingTriviaOption.Exclude : ts3.hasJSDocNodes(node) ? LeadingTriviaOption.JSDoc : LeadingTriviaOption.StartLine
                });
                break;
              case 199:
                var pattern = node.parent;
                var preserveComma = pattern.kind === 198 && node !== ts3.last(pattern.elements);
                if (preserveComma) {
                  deleteNode(changes, sourceFile, node);
                } else {
                  deleteNodeInList(changes, deletedNodesInLists, sourceFile, node);
                }
                break;
              case 250:
                deleteVariableDeclaration(changes, deletedNodesInLists, sourceFile, node);
                break;
              case 160:
                deleteNodeInList(changes, deletedNodesInLists, sourceFile, node);
                break;
              case 266:
                var namedImports = node.parent;
                if (namedImports.elements.length === 1) {
                  deleteImportBinding(changes, sourceFile, namedImports);
                } else {
                  deleteNodeInList(changes, deletedNodesInLists, sourceFile, node);
                }
                break;
              case 264:
                deleteImportBinding(changes, sourceFile, node);
                break;
              case 26:
                deleteNode(changes, sourceFile, node, { trailingTriviaOption: TrailingTriviaOption.Exclude });
                break;
              case 97:
                deleteNode(changes, sourceFile, node, { leadingTriviaOption: LeadingTriviaOption.Exclude });
                break;
              case 253:
              case 252:
                deleteNode(changes, sourceFile, node, { leadingTriviaOption: ts3.hasJSDocNodes(node) ? LeadingTriviaOption.JSDoc : LeadingTriviaOption.StartLine });
                break;
              default:
                if (!node.parent) {
                  deleteNode(changes, sourceFile, node);
                } else if (ts3.isImportClause(node.parent) && node.parent.name === node) {
                  deleteDefaultImport(changes, sourceFile, node.parent);
                } else if (ts3.isCallExpression(node.parent) && ts3.contains(node.parent.arguments, node)) {
                  deleteNodeInList(changes, deletedNodesInLists, sourceFile, node);
                } else {
                  deleteNode(changes, sourceFile, node);
                }
            }
          }
          deleteDeclaration_1.deleteDeclaration = deleteDeclaration2;
          function deleteDefaultImport(changes, sourceFile, importClause) {
            if (!importClause.namedBindings) {
              deleteNode(changes, sourceFile, importClause.parent);
            } else {
              var start = importClause.name.getStart(sourceFile);
              var nextToken = ts3.getTokenAtPosition(sourceFile, importClause.name.end);
              if (nextToken && nextToken.kind === 27) {
                var end = ts3.skipTrivia(sourceFile.text, nextToken.end, false, true);
                changes.deleteRange(sourceFile, { pos: start, end });
              } else {
                deleteNode(changes, sourceFile, importClause.name);
              }
            }
          }
          function deleteImportBinding(changes, sourceFile, node) {
            if (node.parent.name) {
              var previousToken = ts3.Debug.checkDefined(ts3.getTokenAtPosition(sourceFile, node.pos - 1));
              changes.deleteRange(sourceFile, { pos: previousToken.getStart(sourceFile), end: node.end });
            } else {
              var importDecl = ts3.getAncestor(node, 262);
              deleteNode(changes, sourceFile, importDecl);
            }
          }
          function deleteVariableDeclaration(changes, deletedNodesInLists, sourceFile, node) {
            var parent = node.parent;
            if (parent.kind === 288) {
              changes.deleteNodeRange(sourceFile, ts3.findChildOfKind(parent, 20, sourceFile), ts3.findChildOfKind(parent, 21, sourceFile));
              return;
            }
            if (parent.declarations.length !== 1) {
              deleteNodeInList(changes, deletedNodesInLists, sourceFile, node);
              return;
            }
            var gp = parent.parent;
            switch (gp.kind) {
              case 240:
              case 239:
                changes.replaceNode(sourceFile, node, ts3.factory.createObjectLiteralExpression());
                break;
              case 238:
                deleteNode(changes, sourceFile, parent);
                break;
              case 233:
                deleteNode(changes, sourceFile, gp, { leadingTriviaOption: ts3.hasJSDocNodes(gp) ? LeadingTriviaOption.JSDoc : LeadingTriviaOption.StartLine });
                break;
              default:
                ts3.Debug.assertNever(gp);
            }
          }
        })(deleteDeclaration || (deleteDeclaration = {}));
        function deleteNode(changes, sourceFile, node, options) {
          if (options === void 0) {
            options = { leadingTriviaOption: LeadingTriviaOption.IncludeAll };
          }
          var startPosition = getAdjustedStartPosition(sourceFile, node, options);
          var endPosition = getAdjustedEndPosition(sourceFile, node, options);
          changes.deleteRange(sourceFile, { pos: startPosition, end: endPosition });
        }
        textChanges_3.deleteNode = deleteNode;
        function deleteNodeInList(changes, deletedNodesInLists, sourceFile, node) {
          var containingList = ts3.Debug.checkDefined(ts3.formatting.SmartIndenter.getContainingList(node, sourceFile));
          var index = ts3.indexOfNode(containingList, node);
          ts3.Debug.assert(index !== -1);
          if (containingList.length === 1) {
            deleteNode(changes, sourceFile, node);
            return;
          }
          ts3.Debug.assert(!deletedNodesInLists.has(node), "Deleting a node twice");
          deletedNodesInLists.add(node);
          changes.deleteRange(sourceFile, {
            pos: startPositionToDeleteNodeInList(sourceFile, node),
            end: index === containingList.length - 1 ? getAdjustedEndPosition(sourceFile, node, {}) : startPositionToDeleteNodeInList(sourceFile, containingList[index + 1])
          });
        }
      })(textChanges = ts3.textChanges || (ts3.textChanges = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var codefix;
      (function(codefix2) {
        var errorCodeToFixes = ts3.createMultiMap();
        var fixIdToRegistration = new ts3.Map();
        function diagnosticToString(diag) {
          return ts3.isArray(diag) ? ts3.formatStringFromArgs(ts3.getLocaleSpecificMessage(diag[0]), diag.slice(1)) : ts3.getLocaleSpecificMessage(diag);
        }
        function createCodeFixActionWithoutFixAll(fixName, changes, description) {
          return createCodeFixActionWorker(fixName, diagnosticToString(description), changes, void 0, void 0);
        }
        codefix2.createCodeFixActionWithoutFixAll = createCodeFixActionWithoutFixAll;
        function createCodeFixAction(fixName, changes, description, fixId, fixAllDescription, command) {
          return createCodeFixActionWorker(fixName, diagnosticToString(description), changes, fixId, diagnosticToString(fixAllDescription), command);
        }
        codefix2.createCodeFixAction = createCodeFixAction;
        function createCodeFixActionMaybeFixAll(fixName, changes, description, fixId, fixAllDescription, command) {
          return createCodeFixActionWorker(fixName, diagnosticToString(description), changes, fixId, fixAllDescription && diagnosticToString(fixAllDescription), command);
        }
        codefix2.createCodeFixActionMaybeFixAll = createCodeFixActionMaybeFixAll;
        function createCodeFixActionWorker(fixName, description, changes, fixId, fixAllDescription, command) {
          return { fixName, description, changes, fixId, fixAllDescription, commands: command ? [command] : void 0 };
        }
        function registerCodeFix(reg) {
          for (var _i = 0, _a2 = reg.errorCodes; _i < _a2.length; _i++) {
            var error = _a2[_i];
            errorCodeToFixes.add(String(error), reg);
          }
          if (reg.fixIds) {
            for (var _b = 0, _c = reg.fixIds; _b < _c.length; _b++) {
              var fixId = _c[_b];
              ts3.Debug.assert(!fixIdToRegistration.has(fixId));
              fixIdToRegistration.set(fixId, reg);
            }
          }
        }
        codefix2.registerCodeFix = registerCodeFix;
        function getSupportedErrorCodes() {
          return ts3.arrayFrom(errorCodeToFixes.keys());
        }
        codefix2.getSupportedErrorCodes = getSupportedErrorCodes;
        function removeFixIdIfFixAllUnavailable(registration, diagnostics) {
          var errorCodes = registration.errorCodes;
          var maybeFixableDiagnostics = 0;
          for (var _i = 0, diagnostics_1 = diagnostics; _i < diagnostics_1.length; _i++) {
            var diag = diagnostics_1[_i];
            if (ts3.contains(errorCodes, diag.code))
              maybeFixableDiagnostics++;
            if (maybeFixableDiagnostics > 1)
              break;
          }
          var fixAllUnavailable = maybeFixableDiagnostics < 2;
          return function(_a2) {
            var fixId = _a2.fixId, fixAllDescription = _a2.fixAllDescription, action = __rest(_a2, ["fixId", "fixAllDescription"]);
            return fixAllUnavailable ? action : __assign(__assign({}, action), { fixId, fixAllDescription });
          };
        }
        function getFixes(context) {
          var diagnostics = getDiagnostics(context);
          var registrations = errorCodeToFixes.get(String(context.errorCode));
          return ts3.flatMap(registrations, function(f) {
            return ts3.map(f.getCodeActions(context), removeFixIdIfFixAllUnavailable(f, diagnostics));
          });
        }
        codefix2.getFixes = getFixes;
        function getAllFixes(context) {
          return fixIdToRegistration.get(ts3.cast(context.fixId, ts3.isString)).getAllCodeActions(context);
        }
        codefix2.getAllFixes = getAllFixes;
        function createCombinedCodeActions(changes, commands) {
          return { changes, commands };
        }
        codefix2.createCombinedCodeActions = createCombinedCodeActions;
        function createFileTextChanges(fileName, textChanges) {
          return { fileName, textChanges };
        }
        codefix2.createFileTextChanges = createFileTextChanges;
        function codeFixAll(context, errorCodes, use) {
          var commands = [];
          var changes = ts3.textChanges.ChangeTracker.with(context, function(t2) {
            return eachDiagnostic(context, errorCodes, function(diag) {
              return use(t2, diag, commands);
            });
          });
          return createCombinedCodeActions(changes, commands.length === 0 ? void 0 : commands);
        }
        codefix2.codeFixAll = codeFixAll;
        function eachDiagnostic(context, errorCodes, cb2) {
          for (var _i = 0, _a2 = getDiagnostics(context); _i < _a2.length; _i++) {
            var diag = _a2[_i];
            if (ts3.contains(errorCodes, diag.code)) {
              cb2(diag);
            }
          }
        }
        codefix2.eachDiagnostic = eachDiagnostic;
        function getDiagnostics(_a2) {
          var program2 = _a2.program, sourceFile = _a2.sourceFile, cancellationToken = _a2.cancellationToken;
          return __spreadArray(__spreadArray(__spreadArray([], program2.getSemanticDiagnostics(sourceFile, cancellationToken)), program2.getSyntacticDiagnostics(sourceFile, cancellationToken)), ts3.computeSuggestionDiagnostics(sourceFile, program2, cancellationToken));
        }
      })(codefix = ts3.codefix || (ts3.codefix = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var refactor;
      (function(refactor_1) {
        var refactors = new ts3.Map();
        function registerRefactor(name, refactor2) {
          refactors.set(name, refactor2);
        }
        refactor_1.registerRefactor = registerRefactor;
        function getApplicableRefactors(context) {
          return ts3.arrayFrom(ts3.flatMapIterator(refactors.values(), function(refactor2) {
            var _a2;
            return context.cancellationToken && context.cancellationToken.isCancellationRequested() || !((_a2 = refactor2.kinds) === null || _a2 === void 0 ? void 0 : _a2.some(function(kind) {
              return refactor_1.refactorKindBeginsWith(kind, context.kind);
            })) ? void 0 : refactor2.getAvailableActions(context);
          }));
        }
        refactor_1.getApplicableRefactors = getApplicableRefactors;
        function getEditsForRefactor(context, refactorName, actionName) {
          var refactor2 = refactors.get(refactorName);
          return refactor2 && refactor2.getEditsForAction(context, actionName);
        }
        refactor_1.getEditsForRefactor = getEditsForRefactor;
      })(refactor = ts3.refactor || (ts3.refactor = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var codefix;
      (function(codefix2) {
        var fixId = "addConvertToUnknownForNonOverlappingTypes";
        var errorCodes = [ts3.Diagnostics.Conversion_of_type_0_to_type_1_may_be_a_mistake_because_neither_type_sufficiently_overlaps_with_the_other_If_this_was_intentional_convert_the_expression_to_unknown_first.code];
        codefix2.registerCodeFix({
          errorCodes,
          getCodeActions: function(context) {
            var changes = ts3.textChanges.ChangeTracker.with(context, function(t2) {
              return makeChange(t2, context.sourceFile, context.span.start);
            });
            return [codefix2.createCodeFixAction(fixId, changes, ts3.Diagnostics.Add_unknown_conversion_for_non_overlapping_types, fixId, ts3.Diagnostics.Add_unknown_to_all_conversions_of_non_overlapping_types)];
          },
          fixIds: [fixId],
          getAllCodeActions: function(context) {
            return codefix2.codeFixAll(context, errorCodes, function(changes, diag) {
              return makeChange(changes, diag.file, diag.start);
            });
          }
        });
        function makeChange(changeTracker, sourceFile, pos) {
          var token = ts3.getTokenAtPosition(sourceFile, pos);
          var assertion = ts3.Debug.checkDefined(ts3.findAncestor(token, function(n2) {
            return ts3.isAsExpression(n2) || ts3.isTypeAssertionExpression(n2);
          }), "Expected to find an assertion expression");
          var replacement = ts3.isAsExpression(assertion) ? ts3.factory.createAsExpression(assertion.expression, ts3.factory.createKeywordTypeNode(152)) : ts3.factory.createTypeAssertion(ts3.factory.createKeywordTypeNode(152), assertion.expression);
          changeTracker.replaceNode(sourceFile, assertion.expression, replacement);
        }
      })(codefix = ts3.codefix || (ts3.codefix = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var codefix;
      (function(codefix2) {
        codefix2.registerCodeFix({
          errorCodes: [
            ts3.Diagnostics.await_expressions_are_only_allowed_at_the_top_level_of_a_file_when_that_file_is_a_module_but_this_file_has_no_imports_or_exports_Consider_adding_an_empty_export_to_make_this_file_a_module.code,
            ts3.Diagnostics.for_await_loops_are_only_allowed_at_the_top_level_of_a_file_when_that_file_is_a_module_but_this_file_has_no_imports_or_exports_Consider_adding_an_empty_export_to_make_this_file_a_module.code
          ],
          getCodeActions: function(context) {
            var sourceFile = context.sourceFile;
            var changes = ts3.textChanges.ChangeTracker.with(context, function(changes2) {
              var exportDeclaration = ts3.factory.createExportDeclaration(void 0, void 0, false, ts3.factory.createNamedExports([]), void 0);
              changes2.insertNodeAtEndOfScope(sourceFile, sourceFile, exportDeclaration);
            });
            return [codefix2.createCodeFixActionWithoutFixAll("addEmptyExportDeclaration", changes, ts3.Diagnostics.Add_export_to_make_this_file_into_a_module)];
          }
        });
      })(codefix = ts3.codefix || (ts3.codefix = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var codefix;
      (function(codefix2) {
        var fixId = "addMissingAsync";
        var errorCodes = [
          ts3.Diagnostics.Argument_of_type_0_is_not_assignable_to_parameter_of_type_1.code,
          ts3.Diagnostics.Type_0_is_not_assignable_to_type_1.code,
          ts3.Diagnostics.Type_0_is_not_comparable_to_type_1.code
        ];
        codefix2.registerCodeFix({
          fixIds: [fixId],
          errorCodes,
          getCodeActions: function(context) {
            var sourceFile = context.sourceFile, errorCode = context.errorCode, cancellationToken = context.cancellationToken, program2 = context.program, span = context.span;
            var diagnostic = ts3.find(program2.getDiagnosticsProducingTypeChecker().getDiagnostics(sourceFile, cancellationToken), getIsMatchingAsyncError(span, errorCode));
            var directSpan = diagnostic && diagnostic.relatedInformation && ts3.find(diagnostic.relatedInformation, function(r2) {
              return r2.code === ts3.Diagnostics.Did_you_mean_to_mark_this_function_as_async.code;
            });
            var decl = getFixableErrorSpanDeclaration(sourceFile, directSpan);
            if (!decl) {
              return;
            }
            var trackChanges = function(cb2) {
              return ts3.textChanges.ChangeTracker.with(context, cb2);
            };
            return [getFix(context, decl, trackChanges)];
          },
          getAllCodeActions: function(context) {
            var sourceFile = context.sourceFile;
            var fixedDeclarations = new ts3.Set();
            return codefix2.codeFixAll(context, errorCodes, function(t2, diagnostic) {
              var span = diagnostic.relatedInformation && ts3.find(diagnostic.relatedInformation, function(r2) {
                return r2.code === ts3.Diagnostics.Did_you_mean_to_mark_this_function_as_async.code;
              });
              var decl = getFixableErrorSpanDeclaration(sourceFile, span);
              if (!decl) {
                return;
              }
              var trackChanges = function(cb2) {
                return cb2(t2), [];
              };
              return getFix(context, decl, trackChanges, fixedDeclarations);
            });
          }
        });
        function getFix(context, decl, trackChanges, fixedDeclarations) {
          var changes = trackChanges(function(t2) {
            return makeChange(t2, context.sourceFile, decl, fixedDeclarations);
          });
          return codefix2.createCodeFixAction(fixId, changes, ts3.Diagnostics.Add_async_modifier_to_containing_function, fixId, ts3.Diagnostics.Add_all_missing_async_modifiers);
        }
        function makeChange(changeTracker, sourceFile, insertionSite, fixedDeclarations) {
          if (fixedDeclarations) {
            if (fixedDeclarations.has(ts3.getNodeId(insertionSite))) {
              return;
            }
          }
          fixedDeclarations === null || fixedDeclarations === void 0 ? void 0 : fixedDeclarations.add(ts3.getNodeId(insertionSite));
          var cloneWithModifier = ts3.factory.updateModifiers(ts3.getSynthesizedDeepClone(insertionSite, true), ts3.factory.createNodeArray(ts3.factory.createModifiersFromModifierFlags(ts3.getSyntacticModifierFlags(insertionSite) | 256)));
          changeTracker.replaceNode(sourceFile, insertionSite, cloneWithModifier);
        }
        function getFixableErrorSpanDeclaration(sourceFile, span) {
          if (!span)
            return void 0;
          var token = ts3.getTokenAtPosition(sourceFile, span.start);
          var decl = ts3.findAncestor(token, function(node) {
            if (node.getStart(sourceFile) < span.start || node.getEnd() > ts3.textSpanEnd(span)) {
              return "quit";
            }
            return (ts3.isArrowFunction(node) || ts3.isMethodDeclaration(node) || ts3.isFunctionExpression(node) || ts3.isFunctionDeclaration(node)) && ts3.textSpansEqual(span, ts3.createTextSpanFromNode(node, sourceFile));
          });
          return decl;
        }
        function getIsMatchingAsyncError(span, errorCode) {
          return function(_a2) {
            var start = _a2.start, length = _a2.length, relatedInformation = _a2.relatedInformation, code = _a2.code;
            return ts3.isNumber(start) && ts3.isNumber(length) && ts3.textSpansEqual({ start, length }, span) && code === errorCode && !!relatedInformation && ts3.some(relatedInformation, function(related) {
              return related.code === ts3.Diagnostics.Did_you_mean_to_mark_this_function_as_async.code;
            });
          };
        }
      })(codefix = ts3.codefix || (ts3.codefix = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var codefix;
      (function(codefix2) {
        var fixId = "addMissingAwait";
        var propertyAccessCode = ts3.Diagnostics.Property_0_does_not_exist_on_type_1.code;
        var callableConstructableErrorCodes = [
          ts3.Diagnostics.This_expression_is_not_callable.code,
          ts3.Diagnostics.This_expression_is_not_constructable.code
        ];
        var errorCodes = __spreadArray([
          ts3.Diagnostics.An_arithmetic_operand_must_be_of_type_any_number_bigint_or_an_enum_type.code,
          ts3.Diagnostics.The_left_hand_side_of_an_arithmetic_operation_must_be_of_type_any_number_bigint_or_an_enum_type.code,
          ts3.Diagnostics.The_right_hand_side_of_an_arithmetic_operation_must_be_of_type_any_number_bigint_or_an_enum_type.code,
          ts3.Diagnostics.Operator_0_cannot_be_applied_to_type_1.code,
          ts3.Diagnostics.Operator_0_cannot_be_applied_to_types_1_and_2.code,
          ts3.Diagnostics.This_condition_will_always_return_0_since_the_types_1_and_2_have_no_overlap.code,
          ts3.Diagnostics.This_condition_will_always_return_true_since_this_0_is_always_defined.code,
          ts3.Diagnostics.Type_0_is_not_an_array_type.code,
          ts3.Diagnostics.Type_0_is_not_an_array_type_or_a_string_type.code,
          ts3.Diagnostics.Type_0_is_not_an_array_type_or_a_string_type_Use_compiler_option_downlevelIteration_to_allow_iterating_of_iterators.code,
          ts3.Diagnostics.Type_0_is_not_an_array_type_or_a_string_type_or_does_not_have_a_Symbol_iterator_method_that_returns_an_iterator.code,
          ts3.Diagnostics.Type_0_is_not_an_array_type_or_does_not_have_a_Symbol_iterator_method_that_returns_an_iterator.code,
          ts3.Diagnostics.Type_0_must_have_a_Symbol_iterator_method_that_returns_an_iterator.code,
          ts3.Diagnostics.Type_0_must_have_a_Symbol_asyncIterator_method_that_returns_an_async_iterator.code,
          ts3.Diagnostics.Argument_of_type_0_is_not_assignable_to_parameter_of_type_1.code,
          propertyAccessCode
        ], callableConstructableErrorCodes);
        codefix2.registerCodeFix({
          fixIds: [fixId],
          errorCodes,
          getCodeActions: function(context) {
            var sourceFile = context.sourceFile, errorCode = context.errorCode, span = context.span, cancellationToken = context.cancellationToken, program2 = context.program;
            var expression = getFixableErrorSpanExpression(sourceFile, errorCode, span, cancellationToken, program2);
            if (!expression) {
              return;
            }
            var checker = context.program.getTypeChecker();
            var trackChanges = function(cb2) {
              return ts3.textChanges.ChangeTracker.with(context, cb2);
            };
            return ts3.compact([
              getDeclarationSiteFix(context, expression, errorCode, checker, trackChanges),
              getUseSiteFix(context, expression, errorCode, checker, trackChanges)
            ]);
          },
          getAllCodeActions: function(context) {
            var sourceFile = context.sourceFile, program2 = context.program, cancellationToken = context.cancellationToken;
            var checker = context.program.getTypeChecker();
            var fixedDeclarations = new ts3.Set();
            return codefix2.codeFixAll(context, errorCodes, function(t2, diagnostic) {
              var expression = getFixableErrorSpanExpression(sourceFile, diagnostic.code, diagnostic, cancellationToken, program2);
              if (!expression) {
                return;
              }
              var trackChanges = function(cb2) {
                return cb2(t2), [];
              };
              return getDeclarationSiteFix(context, expression, diagnostic.code, checker, trackChanges, fixedDeclarations) || getUseSiteFix(context, expression, diagnostic.code, checker, trackChanges, fixedDeclarations);
            });
          }
        });
        function getDeclarationSiteFix(context, expression, errorCode, checker, trackChanges, fixedDeclarations) {
          var sourceFile = context.sourceFile, program2 = context.program, cancellationToken = context.cancellationToken;
          var awaitableInitializers = findAwaitableInitializers(expression, sourceFile, cancellationToken, program2, checker);
          if (awaitableInitializers) {
            var initializerChanges = trackChanges(function(t2) {
              ts3.forEach(awaitableInitializers.initializers, function(_a2) {
                var expression2 = _a2.expression;
                return makeChange(t2, errorCode, sourceFile, checker, expression2, fixedDeclarations);
              });
              if (fixedDeclarations && awaitableInitializers.needsSecondPassForFixAll) {
                makeChange(t2, errorCode, sourceFile, checker, expression, fixedDeclarations);
              }
            });
            return codefix2.createCodeFixActionWithoutFixAll("addMissingAwaitToInitializer", initializerChanges, awaitableInitializers.initializers.length === 1 ? [ts3.Diagnostics.Add_await_to_initializer_for_0, awaitableInitializers.initializers[0].declarationSymbol.name] : ts3.Diagnostics.Add_await_to_initializers);
          }
        }
        function getUseSiteFix(context, expression, errorCode, checker, trackChanges, fixedDeclarations) {
          var changes = trackChanges(function(t2) {
            return makeChange(t2, errorCode, context.sourceFile, checker, expression, fixedDeclarations);
          });
          return codefix2.createCodeFixAction(fixId, changes, ts3.Diagnostics.Add_await, fixId, ts3.Diagnostics.Fix_all_expressions_possibly_missing_await);
        }
        function isMissingAwaitError(sourceFile, errorCode, span, cancellationToken, program2) {
          var checker = program2.getDiagnosticsProducingTypeChecker();
          var diagnostics = checker.getDiagnostics(sourceFile, cancellationToken);
          return ts3.some(diagnostics, function(_a2) {
            var start = _a2.start, length = _a2.length, relatedInformation = _a2.relatedInformation, code = _a2.code;
            return ts3.isNumber(start) && ts3.isNumber(length) && ts3.textSpansEqual({ start, length }, span) && code === errorCode && !!relatedInformation && ts3.some(relatedInformation, function(related) {
              return related.code === ts3.Diagnostics.Did_you_forget_to_use_await.code;
            });
          });
        }
        function getFixableErrorSpanExpression(sourceFile, errorCode, span, cancellationToken, program2) {
          var token = ts3.getTokenAtPosition(sourceFile, span.start);
          var expression = ts3.findAncestor(token, function(node) {
            if (node.getStart(sourceFile) < span.start || node.getEnd() > ts3.textSpanEnd(span)) {
              return "quit";
            }
            return ts3.isExpression(node) && ts3.textSpansEqual(span, ts3.createTextSpanFromNode(node, sourceFile));
          });
          return expression && isMissingAwaitError(sourceFile, errorCode, span, cancellationToken, program2) && isInsideAwaitableBody(expression) ? expression : void 0;
        }
        function findAwaitableInitializers(expression, sourceFile, cancellationToken, program2, checker) {
          var identifiers = getIdentifiersFromErrorSpanExpression(expression, checker);
          if (!identifiers) {
            return;
          }
          var isCompleteFix = identifiers.isCompleteFix;
          var initializers;
          var _loop_12 = function(identifier2) {
            var symbol = checker.getSymbolAtLocation(identifier2);
            if (!symbol) {
              return "continue";
            }
            var declaration = ts3.tryCast(symbol.valueDeclaration, ts3.isVariableDeclaration);
            var variableName = declaration && ts3.tryCast(declaration.name, ts3.isIdentifier);
            var variableStatement = ts3.getAncestor(declaration, 233);
            if (!declaration || !variableStatement || declaration.type || !declaration.initializer || variableStatement.getSourceFile() !== sourceFile || ts3.hasSyntacticModifier(variableStatement, 1) || !variableName || !isInsideAwaitableBody(declaration.initializer)) {
              isCompleteFix = false;
              return "continue";
            }
            var diagnostics = program2.getSemanticDiagnostics(sourceFile, cancellationToken);
            var isUsedElsewhere = ts3.FindAllReferences.Core.eachSymbolReferenceInFile(variableName, checker, sourceFile, function(reference) {
              return identifier2 !== reference && !symbolReferenceIsAlsoMissingAwait(reference, diagnostics, sourceFile, checker);
            });
            if (isUsedElsewhere) {
              isCompleteFix = false;
              return "continue";
            }
            (initializers || (initializers = [])).push({
              expression: declaration.initializer,
              declarationSymbol: symbol
            });
          };
          for (var _i = 0, _a2 = identifiers.identifiers; _i < _a2.length; _i++) {
            var identifier = _a2[_i];
            _loop_12(identifier);
          }
          return initializers && {
            initializers,
            needsSecondPassForFixAll: !isCompleteFix
          };
        }
        function getIdentifiersFromErrorSpanExpression(expression, checker) {
          if (ts3.isPropertyAccessExpression(expression.parent) && ts3.isIdentifier(expression.parent.expression)) {
            return { identifiers: [expression.parent.expression], isCompleteFix: true };
          }
          if (ts3.isIdentifier(expression)) {
            return { identifiers: [expression], isCompleteFix: true };
          }
          if (ts3.isBinaryExpression(expression)) {
            var sides = void 0;
            var isCompleteFix = true;
            for (var _i = 0, _a2 = [expression.left, expression.right]; _i < _a2.length; _i++) {
              var side = _a2[_i];
              var type3 = checker.getTypeAtLocation(side);
              if (checker.getPromisedTypeOfPromise(type3)) {
                if (!ts3.isIdentifier(side)) {
                  isCompleteFix = false;
                  continue;
                }
                (sides || (sides = [])).push(side);
              }
            }
            return sides && { identifiers: sides, isCompleteFix };
          }
        }
        function symbolReferenceIsAlsoMissingAwait(reference, diagnostics, sourceFile, checker) {
          var errorNode = ts3.isPropertyAccessExpression(reference.parent) ? reference.parent.name : ts3.isBinaryExpression(reference.parent) ? reference.parent : reference;
          var diagnostic = ts3.find(diagnostics, function(diagnostic2) {
            return diagnostic2.start === errorNode.getStart(sourceFile) && diagnostic2.start + diagnostic2.length === errorNode.getEnd();
          });
          return diagnostic && ts3.contains(errorCodes, diagnostic.code) || checker.getTypeAtLocation(errorNode).flags & 1;
        }
        function isInsideAwaitableBody(node) {
          return node.kind & 32768 || !!ts3.findAncestor(node, function(ancestor) {
            return ancestor.parent && ts3.isArrowFunction(ancestor.parent) && ancestor.parent.body === ancestor || ts3.isBlock(ancestor) && (ancestor.parent.kind === 252 || ancestor.parent.kind === 209 || ancestor.parent.kind === 210 || ancestor.parent.kind === 166);
          });
        }
        function makeChange(changeTracker, errorCode, sourceFile, checker, insertionSite, fixedDeclarations) {
          if (ts3.isBinaryExpression(insertionSite)) {
            for (var _i = 0, _a2 = [insertionSite.left, insertionSite.right]; _i < _a2.length; _i++) {
              var side = _a2[_i];
              if (fixedDeclarations && ts3.isIdentifier(side)) {
                var symbol = checker.getSymbolAtLocation(side);
                if (symbol && fixedDeclarations.has(ts3.getSymbolId(symbol))) {
                  continue;
                }
              }
              var type3 = checker.getTypeAtLocation(side);
              var newNode = checker.getPromisedTypeOfPromise(type3) ? ts3.factory.createAwaitExpression(side) : side;
              changeTracker.replaceNode(sourceFile, side, newNode);
            }
          } else if (errorCode === propertyAccessCode && ts3.isPropertyAccessExpression(insertionSite.parent)) {
            if (fixedDeclarations && ts3.isIdentifier(insertionSite.parent.expression)) {
              var symbol = checker.getSymbolAtLocation(insertionSite.parent.expression);
              if (symbol && fixedDeclarations.has(ts3.getSymbolId(symbol))) {
                return;
              }
            }
            changeTracker.replaceNode(sourceFile, insertionSite.parent.expression, ts3.factory.createParenthesizedExpression(ts3.factory.createAwaitExpression(insertionSite.parent.expression)));
            insertLeadingSemicolonIfNeeded(changeTracker, insertionSite.parent.expression, sourceFile);
          } else if (ts3.contains(callableConstructableErrorCodes, errorCode) && ts3.isCallOrNewExpression(insertionSite.parent)) {
            if (fixedDeclarations && ts3.isIdentifier(insertionSite)) {
              var symbol = checker.getSymbolAtLocation(insertionSite);
              if (symbol && fixedDeclarations.has(ts3.getSymbolId(symbol))) {
                return;
              }
            }
            changeTracker.replaceNode(sourceFile, insertionSite, ts3.factory.createParenthesizedExpression(ts3.factory.createAwaitExpression(insertionSite)));
            insertLeadingSemicolonIfNeeded(changeTracker, insertionSite, sourceFile);
          } else {
            if (fixedDeclarations && ts3.isVariableDeclaration(insertionSite.parent) && ts3.isIdentifier(insertionSite.parent.name)) {
              var symbol = checker.getSymbolAtLocation(insertionSite.parent.name);
              if (symbol && !ts3.tryAddToSet(fixedDeclarations, ts3.getSymbolId(symbol))) {
                return;
              }
            }
            changeTracker.replaceNode(sourceFile, insertionSite, ts3.factory.createAwaitExpression(insertionSite));
          }
        }
        function insertLeadingSemicolonIfNeeded(changeTracker, beforeNode, sourceFile) {
          var precedingToken = ts3.findPrecedingToken(beforeNode.pos, sourceFile);
          if (precedingToken && ts3.positionIsASICandidate(precedingToken.end, precedingToken.parent, sourceFile)) {
            changeTracker.insertText(sourceFile, beforeNode.getStart(sourceFile), ";");
          }
        }
      })(codefix = ts3.codefix || (ts3.codefix = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var codefix;
      (function(codefix2) {
        var fixId = "addMissingConst";
        var errorCodes = [
          ts3.Diagnostics.Cannot_find_name_0.code,
          ts3.Diagnostics.No_value_exists_in_scope_for_the_shorthand_property_0_Either_declare_one_or_provide_an_initializer.code
        ];
        codefix2.registerCodeFix({
          errorCodes,
          getCodeActions: function(context) {
            var changes = ts3.textChanges.ChangeTracker.with(context, function(t2) {
              return makeChange(t2, context.sourceFile, context.span.start, context.program);
            });
            if (changes.length > 0) {
              return [codefix2.createCodeFixAction(fixId, changes, ts3.Diagnostics.Add_const_to_unresolved_variable, fixId, ts3.Diagnostics.Add_const_to_all_unresolved_variables)];
            }
          },
          fixIds: [fixId],
          getAllCodeActions: function(context) {
            var fixedNodes = new ts3.Set();
            return codefix2.codeFixAll(context, errorCodes, function(changes, diag) {
              return makeChange(changes, diag.file, diag.start, context.program, fixedNodes);
            });
          }
        });
        function makeChange(changeTracker, sourceFile, pos, program2, fixedNodes) {
          var token = ts3.getTokenAtPosition(sourceFile, pos);
          var forInitializer = ts3.findAncestor(token, function(node) {
            return ts3.isForInOrOfStatement(node.parent) ? node.parent.initializer === node : isPossiblyPartOfDestructuring(node) ? false : "quit";
          });
          if (forInitializer)
            return applyChange(changeTracker, forInitializer, sourceFile, fixedNodes);
          var parent = token.parent;
          if (ts3.isBinaryExpression(parent) && parent.operatorToken.kind === 62 && ts3.isExpressionStatement(parent.parent)) {
            return applyChange(changeTracker, token, sourceFile, fixedNodes);
          }
          if (ts3.isArrayLiteralExpression(parent)) {
            var checker_1 = program2.getTypeChecker();
            if (!ts3.every(parent.elements, function(element) {
              return arrayElementCouldBeVariableDeclaration(element, checker_1);
            })) {
              return;
            }
            return applyChange(changeTracker, parent, sourceFile, fixedNodes);
          }
          var commaExpression = ts3.findAncestor(token, function(node) {
            return ts3.isExpressionStatement(node.parent) ? true : isPossiblyPartOfCommaSeperatedInitializer(node) ? false : "quit";
          });
          if (commaExpression) {
            var checker = program2.getTypeChecker();
            if (!expressionCouldBeVariableDeclaration(commaExpression, checker)) {
              return;
            }
            return applyChange(changeTracker, commaExpression, sourceFile, fixedNodes);
          }
        }
        function applyChange(changeTracker, initializer, sourceFile, fixedNodes) {
          if (!fixedNodes || ts3.tryAddToSet(fixedNodes, initializer)) {
            changeTracker.insertModifierBefore(sourceFile, 84, initializer);
          }
        }
        function isPossiblyPartOfDestructuring(node) {
          switch (node.kind) {
            case 78:
            case 200:
            case 201:
            case 289:
            case 290:
              return true;
            default:
              return false;
          }
        }
        function arrayElementCouldBeVariableDeclaration(expression, checker) {
          var identifier = ts3.isIdentifier(expression) ? expression : ts3.isAssignmentExpression(expression, true) && ts3.isIdentifier(expression.left) ? expression.left : void 0;
          return !!identifier && !checker.getSymbolAtLocation(identifier);
        }
        function isPossiblyPartOfCommaSeperatedInitializer(node) {
          switch (node.kind) {
            case 78:
            case 217:
            case 27:
              return true;
            default:
              return false;
          }
        }
        function expressionCouldBeVariableDeclaration(expression, checker) {
          if (!ts3.isBinaryExpression(expression)) {
            return false;
          }
          if (expression.operatorToken.kind === 27) {
            return ts3.every([expression.left, expression.right], function(expression2) {
              return expressionCouldBeVariableDeclaration(expression2, checker);
            });
          }
          return expression.operatorToken.kind === 62 && ts3.isIdentifier(expression.left) && !checker.getSymbolAtLocation(expression.left);
        }
      })(codefix = ts3.codefix || (ts3.codefix = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var codefix;
      (function(codefix2) {
        var fixId = "addMissingDeclareProperty";
        var errorCodes = [
          ts3.Diagnostics.Property_0_will_overwrite_the_base_property_in_1_If_this_is_intentional_add_an_initializer_Otherwise_add_a_declare_modifier_or_remove_the_redundant_declaration.code
        ];
        codefix2.registerCodeFix({
          errorCodes,
          getCodeActions: function(context) {
            var changes = ts3.textChanges.ChangeTracker.with(context, function(t2) {
              return makeChange(t2, context.sourceFile, context.span.start);
            });
            if (changes.length > 0) {
              return [codefix2.createCodeFixAction(fixId, changes, ts3.Diagnostics.Prefix_with_declare, fixId, ts3.Diagnostics.Prefix_all_incorrect_property_declarations_with_declare)];
            }
          },
          fixIds: [fixId],
          getAllCodeActions: function(context) {
            var fixedNodes = new ts3.Set();
            return codefix2.codeFixAll(context, errorCodes, function(changes, diag) {
              return makeChange(changes, diag.file, diag.start, fixedNodes);
            });
          }
        });
        function makeChange(changeTracker, sourceFile, pos, fixedNodes) {
          var token = ts3.getTokenAtPosition(sourceFile, pos);
          if (!ts3.isIdentifier(token)) {
            return;
          }
          var declaration = token.parent;
          if (declaration.kind === 164 && (!fixedNodes || ts3.tryAddToSet(fixedNodes, declaration))) {
            changeTracker.insertModifierBefore(sourceFile, 133, declaration);
          }
        }
      })(codefix = ts3.codefix || (ts3.codefix = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var codefix;
      (function(codefix2) {
        var fixId = "addMissingInvocationForDecorator";
        var errorCodes = [ts3.Diagnostics._0_accepts_too_few_arguments_to_be_used_as_a_decorator_here_Did_you_mean_to_call_it_first_and_write_0.code];
        codefix2.registerCodeFix({
          errorCodes,
          getCodeActions: function(context) {
            var changes = ts3.textChanges.ChangeTracker.with(context, function(t2) {
              return makeChange(t2, context.sourceFile, context.span.start);
            });
            return [codefix2.createCodeFixAction(fixId, changes, ts3.Diagnostics.Call_decorator_expression, fixId, ts3.Diagnostics.Add_to_all_uncalled_decorators)];
          },
          fixIds: [fixId],
          getAllCodeActions: function(context) {
            return codefix2.codeFixAll(context, errorCodes, function(changes, diag) {
              return makeChange(changes, diag.file, diag.start);
            });
          }
        });
        function makeChange(changeTracker, sourceFile, pos) {
          var token = ts3.getTokenAtPosition(sourceFile, pos);
          var decorator = ts3.findAncestor(token, ts3.isDecorator);
          ts3.Debug.assert(!!decorator, "Expected position to be owned by a decorator.");
          var replacement = ts3.factory.createCallExpression(decorator.expression, void 0, void 0);
          changeTracker.replaceNode(sourceFile, decorator.expression, replacement);
        }
      })(codefix = ts3.codefix || (ts3.codefix = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var codefix;
      (function(codefix2) {
        var fixId = "addNameToNamelessParameter";
        var errorCodes = [ts3.Diagnostics.Parameter_has_a_name_but_no_type_Did_you_mean_0_Colon_1.code];
        codefix2.registerCodeFix({
          errorCodes,
          getCodeActions: function(context) {
            var changes = ts3.textChanges.ChangeTracker.with(context, function(t2) {
              return makeChange(t2, context.sourceFile, context.span.start);
            });
            return [codefix2.createCodeFixAction(fixId, changes, ts3.Diagnostics.Add_parameter_name, fixId, ts3.Diagnostics.Add_names_to_all_parameters_without_names)];
          },
          fixIds: [fixId],
          getAllCodeActions: function(context) {
            return codefix2.codeFixAll(context, errorCodes, function(changes, diag) {
              return makeChange(changes, diag.file, diag.start);
            });
          }
        });
        function makeChange(changeTracker, sourceFile, pos) {
          var token = ts3.getTokenAtPosition(sourceFile, pos);
          if (!ts3.isIdentifier(token)) {
            return ts3.Debug.fail("add-name-to-nameless-parameter operates on identifiers, but got a " + ts3.Debug.formatSyntaxKind(token.kind));
          }
          var param = token.parent;
          if (!ts3.isParameter(param)) {
            return ts3.Debug.fail("Tried to add a parameter name to a non-parameter: " + ts3.Debug.formatSyntaxKind(token.kind));
          }
          var i3 = param.parent.parameters.indexOf(param);
          ts3.Debug.assert(!param.type, "Tried to add a parameter name to a parameter that already had one.");
          ts3.Debug.assert(i3 > -1, "Parameter not found in parent parameter list.");
          var replacement = ts3.factory.createParameterDeclaration(void 0, param.modifiers, param.dotDotDotToken, "arg" + i3, param.questionToken, ts3.factory.createTypeReferenceNode(token, void 0), param.initializer);
          changeTracker.replaceNode(sourceFile, token, replacement);
        }
      })(codefix = ts3.codefix || (ts3.codefix = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var codefix;
      (function(codefix2) {
        var fixId = "annotateWithTypeFromJSDoc";
        var errorCodes = [ts3.Diagnostics.JSDoc_types_may_be_moved_to_TypeScript_types.code];
        codefix2.registerCodeFix({
          errorCodes,
          getCodeActions: function(context) {
            var decl = getDeclaration(context.sourceFile, context.span.start);
            if (!decl)
              return;
            var changes = ts3.textChanges.ChangeTracker.with(context, function(t2) {
              return doChange(t2, context.sourceFile, decl);
            });
            return [codefix2.createCodeFixAction(fixId, changes, ts3.Diagnostics.Annotate_with_type_from_JSDoc, fixId, ts3.Diagnostics.Annotate_everything_with_types_from_JSDoc)];
          },
          fixIds: [fixId],
          getAllCodeActions: function(context) {
            return codefix2.codeFixAll(context, errorCodes, function(changes, diag) {
              var decl = getDeclaration(diag.file, diag.start);
              if (decl)
                doChange(changes, diag.file, decl);
            });
          }
        });
        function getDeclaration(file, pos) {
          var name = ts3.getTokenAtPosition(file, pos);
          return ts3.tryCast(ts3.isParameter(name.parent) ? name.parent.parent : name.parent, parameterShouldGetTypeFromJSDoc);
        }
        function parameterShouldGetTypeFromJSDoc(node) {
          return isDeclarationWithType(node) && hasUsableJSDoc(node);
        }
        codefix2.parameterShouldGetTypeFromJSDoc = parameterShouldGetTypeFromJSDoc;
        function hasUsableJSDoc(decl) {
          return ts3.isFunctionLikeDeclaration(decl) ? decl.parameters.some(hasUsableJSDoc) || !decl.type && !!ts3.getJSDocReturnType(decl) : !decl.type && !!ts3.getJSDocType(decl);
        }
        function doChange(changes, sourceFile, decl) {
          if (ts3.isFunctionLikeDeclaration(decl) && (ts3.getJSDocReturnType(decl) || decl.parameters.some(function(p) {
            return !!ts3.getJSDocType(p);
          }))) {
            if (!decl.typeParameters) {
              var typeParameters = ts3.getJSDocTypeParameterDeclarations(decl);
              if (typeParameters.length)
                changes.insertTypeParameters(sourceFile, decl, typeParameters);
            }
            var needParens = ts3.isArrowFunction(decl) && !ts3.findChildOfKind(decl, 20, sourceFile);
            if (needParens)
              changes.insertNodeBefore(sourceFile, ts3.first(decl.parameters), ts3.factory.createToken(20));
            for (var _i = 0, _a2 = decl.parameters; _i < _a2.length; _i++) {
              var param = _a2[_i];
              if (!param.type) {
                var paramType = ts3.getJSDocType(param);
                if (paramType)
                  changes.tryInsertTypeAnnotation(sourceFile, param, transformJSDocType(paramType));
              }
            }
            if (needParens)
              changes.insertNodeAfter(sourceFile, ts3.last(decl.parameters), ts3.factory.createToken(21));
            if (!decl.type) {
              var returnType2 = ts3.getJSDocReturnType(decl);
              if (returnType2)
                changes.tryInsertTypeAnnotation(sourceFile, decl, transformJSDocType(returnType2));
            }
          } else {
            var jsdocType = ts3.Debug.checkDefined(ts3.getJSDocType(decl), "A JSDocType for this declaration should exist");
            ts3.Debug.assert(!decl.type, "The JSDocType decl should have a type");
            changes.tryInsertTypeAnnotation(sourceFile, decl, transformJSDocType(jsdocType));
          }
        }
        function isDeclarationWithType(node) {
          return ts3.isFunctionLikeDeclaration(node) || node.kind === 250 || node.kind === 163 || node.kind === 164;
        }
        function transformJSDocType(node) {
          switch (node.kind) {
            case 304:
            case 305:
              return ts3.factory.createTypeReferenceNode("any", ts3.emptyArray);
            case 308:
              return transformJSDocOptionalType(node);
            case 307:
              return transformJSDocType(node.type);
            case 306:
              return transformJSDocNullableType(node);
            case 310:
              return transformJSDocVariadicType(node);
            case 309:
              return transformJSDocFunctionType(node);
            case 174:
              return transformJSDocTypeReference(node);
            default:
              var visited = ts3.visitEachChild(node, transformJSDocType, ts3.nullTransformationContext);
              ts3.setEmitFlags(visited, 1);
              return visited;
          }
        }
        function transformJSDocOptionalType(node) {
          return ts3.factory.createUnionTypeNode([ts3.visitNode(node.type, transformJSDocType), ts3.factory.createTypeReferenceNode("undefined", ts3.emptyArray)]);
        }
        function transformJSDocNullableType(node) {
          return ts3.factory.createUnionTypeNode([ts3.visitNode(node.type, transformJSDocType), ts3.factory.createTypeReferenceNode("null", ts3.emptyArray)]);
        }
        function transformJSDocVariadicType(node) {
          return ts3.factory.createArrayTypeNode(ts3.visitNode(node.type, transformJSDocType));
        }
        function transformJSDocFunctionType(node) {
          var _a2;
          return ts3.factory.createFunctionTypeNode(ts3.emptyArray, node.parameters.map(transformJSDocParameter), (_a2 = node.type) !== null && _a2 !== void 0 ? _a2 : ts3.factory.createKeywordTypeNode(128));
        }
        function transformJSDocParameter(node) {
          var index = node.parent.parameters.indexOf(node);
          var isRest = node.type.kind === 310 && index === node.parent.parameters.length - 1;
          var name = node.name || (isRest ? "rest" : "arg" + index);
          var dotdotdot = isRest ? ts3.factory.createToken(25) : node.dotDotDotToken;
          return ts3.factory.createParameterDeclaration(node.decorators, node.modifiers, dotdotdot, name, node.questionToken, ts3.visitNode(node.type, transformJSDocType), node.initializer);
        }
        function transformJSDocTypeReference(node) {
          var name = node.typeName;
          var args = node.typeArguments;
          if (ts3.isIdentifier(node.typeName)) {
            if (ts3.isJSDocIndexSignature(node)) {
              return transformJSDocIndexSignature(node);
            }
            var text = node.typeName.text;
            switch (node.typeName.text) {
              case "String":
              case "Boolean":
              case "Object":
              case "Number":
                text = text.toLowerCase();
                break;
              case "array":
              case "date":
              case "promise":
                text = text[0].toUpperCase() + text.slice(1);
                break;
            }
            name = ts3.factory.createIdentifier(text);
            if ((text === "Array" || text === "Promise") && !node.typeArguments) {
              args = ts3.factory.createNodeArray([ts3.factory.createTypeReferenceNode("any", ts3.emptyArray)]);
            } else {
              args = ts3.visitNodes(node.typeArguments, transformJSDocType);
            }
          }
          return ts3.factory.createTypeReferenceNode(name, args);
        }
        function transformJSDocIndexSignature(node) {
          var index = ts3.factory.createParameterDeclaration(void 0, void 0, void 0, node.typeArguments[0].kind === 144 ? "n" : "s", void 0, ts3.factory.createTypeReferenceNode(node.typeArguments[0].kind === 144 ? "number" : "string", []), void 0);
          var indexSignature = ts3.factory.createTypeLiteralNode([ts3.factory.createIndexSignature(void 0, void 0, [index], node.typeArguments[1])]);
          ts3.setEmitFlags(indexSignature, 1);
          return indexSignature;
        }
      })(codefix = ts3.codefix || (ts3.codefix = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var codefix;
      (function(codefix2) {
        var fixId = "convertFunctionToEs6Class";
        var errorCodes = [ts3.Diagnostics.This_constructor_function_may_be_converted_to_a_class_declaration.code];
        codefix2.registerCodeFix({
          errorCodes,
          getCodeActions: function(context) {
            var changes = ts3.textChanges.ChangeTracker.with(context, function(t2) {
              return doChange(t2, context.sourceFile, context.span.start, context.program.getTypeChecker(), context.preferences, context.program.getCompilerOptions());
            });
            return [codefix2.createCodeFixAction(fixId, changes, ts3.Diagnostics.Convert_function_to_an_ES2015_class, fixId, ts3.Diagnostics.Convert_all_constructor_functions_to_classes)];
          },
          fixIds: [fixId],
          getAllCodeActions: function(context) {
            return codefix2.codeFixAll(context, errorCodes, function(changes, err2) {
              return doChange(changes, err2.file, err2.start, context.program.getTypeChecker(), context.preferences, context.program.getCompilerOptions());
            });
          }
        });
        function doChange(changes, sourceFile, position, checker, preferences, compilerOptions) {
          var ctorSymbol = checker.getSymbolAtLocation(ts3.getTokenAtPosition(sourceFile, position));
          if (!ctorSymbol || !ctorSymbol.valueDeclaration || !(ctorSymbol.flags & (16 | 3))) {
            return void 0;
          }
          var ctorDeclaration = ctorSymbol.valueDeclaration;
          if (ts3.isFunctionDeclaration(ctorDeclaration)) {
            changes.replaceNode(sourceFile, ctorDeclaration, createClassFromFunctionDeclaration(ctorDeclaration));
          } else if (ts3.isVariableDeclaration(ctorDeclaration)) {
            var classDeclaration = createClassFromVariableDeclaration(ctorDeclaration);
            if (!classDeclaration) {
              return void 0;
            }
            var ancestor = ctorDeclaration.parent.parent;
            if (ts3.isVariableDeclarationList(ctorDeclaration.parent) && ctorDeclaration.parent.declarations.length > 1) {
              changes.delete(sourceFile, ctorDeclaration);
              changes.insertNodeAfter(sourceFile, ancestor, classDeclaration);
            } else {
              changes.replaceNode(sourceFile, ancestor, classDeclaration);
            }
          }
          function createClassElementsFromSymbol(symbol) {
            var memberElements = [];
            if (symbol.members) {
              symbol.members.forEach(function(member, key2) {
                if (key2 === "constructor" && member.valueDeclaration) {
                  changes.delete(sourceFile, member.valueDeclaration.parent);
                  return;
                }
                var memberElement = createClassElement(member, void 0);
                if (memberElement) {
                  memberElements.push.apply(memberElements, memberElement);
                }
              });
            }
            if (symbol.exports) {
              symbol.exports.forEach(function(member) {
                if (member.name === "prototype" && member.declarations) {
                  var firstDeclaration = member.declarations[0];
                  if (member.declarations.length === 1 && ts3.isPropertyAccessExpression(firstDeclaration) && ts3.isBinaryExpression(firstDeclaration.parent) && firstDeclaration.parent.operatorToken.kind === 62 && ts3.isObjectLiteralExpression(firstDeclaration.parent.right)) {
                    var prototypes = firstDeclaration.parent.right;
                    var memberElement = createClassElement(prototypes.symbol, void 0);
                    if (memberElement) {
                      memberElements.push.apply(memberElements, memberElement);
                    }
                  }
                } else {
                  var memberElement = createClassElement(member, [ts3.factory.createToken(123)]);
                  if (memberElement) {
                    memberElements.push.apply(memberElements, memberElement);
                  }
                }
              });
            }
            return memberElements;
            function shouldConvertDeclaration(_target, source) {
              if (ts3.isAccessExpression(_target)) {
                if (ts3.isPropertyAccessExpression(_target) && isConstructorAssignment(_target))
                  return true;
                return ts3.isFunctionLike(source);
              } else {
                return ts3.every(_target.properties, function(property) {
                  if (ts3.isMethodDeclaration(property) || ts3.isGetOrSetAccessorDeclaration(property))
                    return true;
                  if (ts3.isPropertyAssignment(property) && ts3.isFunctionExpression(property.initializer) && !!property.name)
                    return true;
                  if (isConstructorAssignment(property))
                    return true;
                  return false;
                });
              }
            }
            function createClassElement(symbol2, modifiers) {
              var members = [];
              if (!(symbol2.flags & 8192) && !(symbol2.flags & 4096)) {
                return members;
              }
              var memberDeclaration = symbol2.valueDeclaration;
              var assignmentBinaryExpression = memberDeclaration.parent;
              var assignmentExpr = assignmentBinaryExpression.right;
              if (!shouldConvertDeclaration(memberDeclaration, assignmentExpr)) {
                return members;
              }
              var nodeToDelete = assignmentBinaryExpression.parent && assignmentBinaryExpression.parent.kind === 234 ? assignmentBinaryExpression.parent : assignmentBinaryExpression;
              changes.delete(sourceFile, nodeToDelete);
              if (!assignmentExpr) {
                members.push(ts3.factory.createPropertyDeclaration([], modifiers, symbol2.name, void 0, void 0, void 0));
                return members;
              }
              if (ts3.isAccessExpression(memberDeclaration) && (ts3.isFunctionExpression(assignmentExpr) || ts3.isArrowFunction(assignmentExpr))) {
                var quotePreference = ts3.getQuotePreference(sourceFile, preferences);
                var name = tryGetPropertyName(memberDeclaration, compilerOptions, quotePreference);
                if (name) {
                  return createFunctionLikeExpressionMember(members, assignmentExpr, name);
                }
                return members;
              } else if (ts3.isObjectLiteralExpression(assignmentExpr)) {
                return ts3.flatMap(assignmentExpr.properties, function(property) {
                  if (ts3.isMethodDeclaration(property) || ts3.isGetOrSetAccessorDeclaration(property)) {
                    return members.concat(property);
                  }
                  if (ts3.isPropertyAssignment(property) && ts3.isFunctionExpression(property.initializer)) {
                    return createFunctionLikeExpressionMember(members, property.initializer, property.name);
                  }
                  if (isConstructorAssignment(property))
                    return members;
                  return [];
                });
              } else {
                if (ts3.isSourceFileJS(sourceFile))
                  return members;
                if (!ts3.isPropertyAccessExpression(memberDeclaration))
                  return members;
                var prop = ts3.factory.createPropertyDeclaration(void 0, modifiers, memberDeclaration.name, void 0, void 0, assignmentExpr);
                ts3.copyLeadingComments(assignmentBinaryExpression.parent, prop, sourceFile);
                members.push(prop);
                return members;
              }
              function createFunctionLikeExpressionMember(members2, expression, name2) {
                if (ts3.isFunctionExpression(expression))
                  return createFunctionExpressionMember(members2, expression, name2);
                else
                  return createArrowFunctionExpressionMember(members2, expression, name2);
              }
              function createFunctionExpressionMember(members2, functionExpression, name2) {
                var fullModifiers = ts3.concatenate(modifiers, getModifierKindFromSource(functionExpression, 129));
                var method = ts3.factory.createMethodDeclaration(void 0, fullModifiers, void 0, name2, void 0, void 0, functionExpression.parameters, void 0, functionExpression.body);
                ts3.copyLeadingComments(assignmentBinaryExpression, method, sourceFile);
                return members2.concat(method);
              }
              function createArrowFunctionExpressionMember(members2, arrowFunction, name2) {
                var arrowFunctionBody = arrowFunction.body;
                var bodyBlock;
                if (arrowFunctionBody.kind === 231) {
                  bodyBlock = arrowFunctionBody;
                } else {
                  bodyBlock = ts3.factory.createBlock([ts3.factory.createReturnStatement(arrowFunctionBody)]);
                }
                var fullModifiers = ts3.concatenate(modifiers, getModifierKindFromSource(arrowFunction, 129));
                var method = ts3.factory.createMethodDeclaration(void 0, fullModifiers, void 0, name2, void 0, void 0, arrowFunction.parameters, void 0, bodyBlock);
                ts3.copyLeadingComments(assignmentBinaryExpression, method, sourceFile);
                return members2.concat(method);
              }
            }
          }
          function createClassFromVariableDeclaration(node) {
            var initializer = node.initializer;
            if (!initializer || !ts3.isFunctionExpression(initializer) || !ts3.isIdentifier(node.name)) {
              return void 0;
            }
            var memberElements = createClassElementsFromSymbol(node.symbol);
            if (initializer.body) {
              memberElements.unshift(ts3.factory.createConstructorDeclaration(void 0, void 0, initializer.parameters, initializer.body));
            }
            var modifiers = getModifierKindFromSource(node.parent.parent, 92);
            var cls = ts3.factory.createClassDeclaration(void 0, modifiers, node.name, void 0, void 0, memberElements);
            return cls;
          }
          function createClassFromFunctionDeclaration(node) {
            var memberElements = createClassElementsFromSymbol(ctorSymbol);
            if (node.body) {
              memberElements.unshift(ts3.factory.createConstructorDeclaration(void 0, void 0, node.parameters, node.body));
            }
            var modifiers = getModifierKindFromSource(node, 92);
            var cls = ts3.factory.createClassDeclaration(void 0, modifiers, node.name, void 0, void 0, memberElements);
            return cls;
          }
        }
        function getModifierKindFromSource(source, kind) {
          return ts3.filter(source.modifiers, function(modifier) {
            return modifier.kind === kind;
          });
        }
        function isConstructorAssignment(x) {
          if (!x.name)
            return false;
          if (ts3.isIdentifier(x.name) && x.name.text === "constructor")
            return true;
          return false;
        }
        function tryGetPropertyName(node, compilerOptions, quotePreference) {
          if (ts3.isPropertyAccessExpression(node)) {
            return node.name;
          }
          var propName = node.argumentExpression;
          if (ts3.isNumericLiteral(propName)) {
            return propName;
          }
          if (ts3.isStringLiteralLike(propName)) {
            return ts3.isIdentifierText(propName.text, compilerOptions.target) ? ts3.factory.createIdentifier(propName.text) : ts3.isNoSubstitutionTemplateLiteral(propName) ? ts3.factory.createStringLiteral(propName.text, quotePreference === 0) : propName;
          }
          return void 0;
        }
      })(codefix = ts3.codefix || (ts3.codefix = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var codefix;
      (function(codefix2) {
        var fixId = "convertToAsyncFunction";
        var errorCodes = [ts3.Diagnostics.This_may_be_converted_to_an_async_function.code];
        var codeActionSucceeded = true;
        codefix2.registerCodeFix({
          errorCodes,
          getCodeActions: function(context) {
            codeActionSucceeded = true;
            var changes = ts3.textChanges.ChangeTracker.with(context, function(t2) {
              return convertToAsyncFunction(t2, context.sourceFile, context.span.start, context.program.getTypeChecker());
            });
            return codeActionSucceeded ? [codefix2.createCodeFixAction(fixId, changes, ts3.Diagnostics.Convert_to_async_function, fixId, ts3.Diagnostics.Convert_all_to_async_functions)] : [];
          },
          fixIds: [fixId],
          getAllCodeActions: function(context) {
            return codefix2.codeFixAll(context, errorCodes, function(changes, err2) {
              return convertToAsyncFunction(changes, err2.file, err2.start, context.program.getTypeChecker());
            });
          }
        });
        var SynthBindingNameKind;
        (function(SynthBindingNameKind2) {
          SynthBindingNameKind2[SynthBindingNameKind2["Identifier"] = 0] = "Identifier";
          SynthBindingNameKind2[SynthBindingNameKind2["BindingPattern"] = 1] = "BindingPattern";
        })(SynthBindingNameKind || (SynthBindingNameKind = {}));
        function convertToAsyncFunction(changes, sourceFile, position, checker) {
          var tokenAtPosition = ts3.getTokenAtPosition(sourceFile, position);
          var functionToConvert;
          if (ts3.isIdentifier(tokenAtPosition) && ts3.isVariableDeclaration(tokenAtPosition.parent) && tokenAtPosition.parent.initializer && ts3.isFunctionLikeDeclaration(tokenAtPosition.parent.initializer)) {
            functionToConvert = tokenAtPosition.parent.initializer;
          } else {
            functionToConvert = ts3.tryCast(ts3.getContainingFunction(ts3.getTokenAtPosition(sourceFile, position)), ts3.canBeConvertedToAsync);
          }
          if (!functionToConvert) {
            return;
          }
          var synthNamesMap = new ts3.Map();
          var isInJavascript = ts3.isInJSFile(functionToConvert);
          var setOfExpressionsToReturn = getAllPromiseExpressionsToReturn(functionToConvert, checker);
          var functionToConvertRenamed = renameCollidingVarNames(functionToConvert, checker, synthNamesMap);
          if (!ts3.returnsPromise(functionToConvertRenamed, checker)) {
            return;
          }
          var returnStatements = functionToConvertRenamed.body && ts3.isBlock(functionToConvertRenamed.body) ? getReturnStatementsWithPromiseHandlers(functionToConvertRenamed.body, checker) : ts3.emptyArray;
          var transformer = { checker, synthNamesMap, setOfExpressionsToReturn, isInJSFile: isInJavascript };
          if (!returnStatements.length) {
            return;
          }
          var pos = functionToConvert.modifiers ? functionToConvert.modifiers.end : functionToConvert.decorators ? ts3.skipTrivia(sourceFile.text, functionToConvert.decorators.end) : functionToConvert.getStart(sourceFile);
          var options = functionToConvert.modifiers ? { prefix: " " } : { suffix: " " };
          changes.insertModifierAt(sourceFile, pos, 129, options);
          var _loop_13 = function(returnStatement2) {
            ts3.forEachChild(returnStatement2, function visit(node) {
              if (ts3.isCallExpression(node)) {
                var newNodes = transformExpression(node, transformer);
                changes.replaceNodeWithNodes(sourceFile, returnStatement2, newNodes);
              } else if (!ts3.isFunctionLike(node)) {
                ts3.forEachChild(node, visit);
              }
            });
          };
          for (var _i = 0, returnStatements_1 = returnStatements; _i < returnStatements_1.length; _i++) {
            var returnStatement = returnStatements_1[_i];
            _loop_13(returnStatement);
          }
        }
        function getReturnStatementsWithPromiseHandlers(body, checker) {
          var res = [];
          ts3.forEachReturnStatement(body, function(ret) {
            if (ts3.isReturnStatementWithFixablePromiseHandler(ret, checker))
              res.push(ret);
          });
          return res;
        }
        function getAllPromiseExpressionsToReturn(func2, checker) {
          if (!func2.body) {
            return new ts3.Set();
          }
          var setOfExpressionsToReturn = new ts3.Set();
          ts3.forEachChild(func2.body, function visit(node) {
            if (isPromiseReturningCallExpression(node, checker, "then")) {
              setOfExpressionsToReturn.add(ts3.getNodeId(node));
              ts3.forEach(node.arguments, visit);
            } else if (isPromiseReturningCallExpression(node, checker, "catch")) {
              setOfExpressionsToReturn.add(ts3.getNodeId(node));
              ts3.forEachChild(node, visit);
            } else if (isPromiseTypedExpression(node, checker)) {
              setOfExpressionsToReturn.add(ts3.getNodeId(node));
            } else {
              ts3.forEachChild(node, visit);
            }
          });
          return setOfExpressionsToReturn;
        }
        function isPromiseReturningCallExpression(node, checker, name) {
          if (!ts3.isCallExpression(node))
            return false;
          var isExpressionOfName = ts3.hasPropertyAccessExpressionWithName(node, name);
          var nodeType = isExpressionOfName && checker.getTypeAtLocation(node);
          return !!(nodeType && checker.getPromisedTypeOfPromise(nodeType));
        }
        function isPromiseTypedExpression(node, checker) {
          if (!ts3.isExpression(node))
            return false;
          return !!checker.getPromisedTypeOfPromise(checker.getTypeAtLocation(node));
        }
        function renameCollidingVarNames(nodeToRename, checker, synthNamesMap) {
          var identsToRenameMap = new ts3.Map();
          var collidingSymbolMap = ts3.createMultiMap();
          ts3.forEachChild(nodeToRename, function visit(node) {
            if (!ts3.isIdentifier(node)) {
              ts3.forEachChild(node, visit);
              return;
            }
            var symbol = checker.getSymbolAtLocation(node);
            if (symbol) {
              var type3 = checker.getTypeAtLocation(node);
              var lastCallSignature = getLastCallSignature(type3, checker);
              var symbolIdString = ts3.getSymbolId(symbol).toString();
              if (lastCallSignature && !ts3.isParameter(node.parent) && !ts3.isFunctionLikeDeclaration(node.parent) && !synthNamesMap.has(symbolIdString)) {
                var firstParameter = ts3.firstOrUndefined(lastCallSignature.parameters);
                var ident2 = (firstParameter === null || firstParameter === void 0 ? void 0 : firstParameter.valueDeclaration) && ts3.isParameter(firstParameter.valueDeclaration) && ts3.tryCast(firstParameter.valueDeclaration.name, ts3.isIdentifier) || ts3.factory.createUniqueName("result", 16);
                var synthName = getNewNameIfConflict(ident2, collidingSymbolMap);
                synthNamesMap.set(symbolIdString, synthName);
                collidingSymbolMap.add(ident2.text, symbol);
              } else if (node.parent && (ts3.isParameter(node.parent) || ts3.isVariableDeclaration(node.parent) || ts3.isBindingElement(node.parent))) {
                var originalName = node.text;
                var collidingSymbols = collidingSymbolMap.get(originalName);
                if (collidingSymbols && collidingSymbols.some(function(prevSymbol) {
                  return prevSymbol !== symbol;
                })) {
                  var newName = getNewNameIfConflict(node, collidingSymbolMap);
                  identsToRenameMap.set(symbolIdString, newName.identifier);
                  synthNamesMap.set(symbolIdString, newName);
                  collidingSymbolMap.add(originalName, symbol);
                } else {
                  var identifier = ts3.getSynthesizedDeepClone(node);
                  synthNamesMap.set(symbolIdString, createSynthIdentifier(identifier));
                  collidingSymbolMap.add(originalName, symbol);
                }
              }
            }
          });
          return ts3.getSynthesizedDeepCloneWithReplacements(nodeToRename, true, function(original) {
            if (ts3.isBindingElement(original) && ts3.isIdentifier(original.name) && ts3.isObjectBindingPattern(original.parent)) {
              var symbol = checker.getSymbolAtLocation(original.name);
              var renameInfo = symbol && identsToRenameMap.get(String(ts3.getSymbolId(symbol)));
              if (renameInfo && renameInfo.text !== (original.name || original.propertyName).getText()) {
                return ts3.factory.createBindingElement(original.dotDotDotToken, original.propertyName || original.name, renameInfo, original.initializer);
              }
            } else if (ts3.isIdentifier(original)) {
              var symbol = checker.getSymbolAtLocation(original);
              var renameInfo = symbol && identsToRenameMap.get(String(ts3.getSymbolId(symbol)));
              if (renameInfo) {
                return ts3.factory.createIdentifier(renameInfo.text);
              }
            }
          });
        }
        function getNewNameIfConflict(name, originalNames) {
          var numVarsSameName = (originalNames.get(name.text) || ts3.emptyArray).length;
          var identifier = numVarsSameName === 0 ? name : ts3.factory.createIdentifier(name.text + "_" + numVarsSameName);
          return createSynthIdentifier(identifier);
        }
        function silentFail() {
          codeActionSucceeded = false;
          return ts3.emptyArray;
        }
        function transformExpression(node, transformer, prevArgName) {
          if (isPromiseReturningCallExpression(node, transformer.checker, "then")) {
            if (node.arguments.length === 0)
              return silentFail();
            return transformThen(node, transformer, prevArgName);
          }
          if (isPromiseReturningCallExpression(node, transformer.checker, "catch")) {
            return transformCatch(node, transformer, prevArgName);
          }
          if (ts3.isPropertyAccessExpression(node)) {
            return transformExpression(node.expression, transformer, prevArgName);
          }
          var nodeType = transformer.checker.getTypeAtLocation(node);
          if (nodeType && transformer.checker.getPromisedTypeOfPromise(nodeType)) {
            ts3.Debug.assertNode(node.original.parent, ts3.isPropertyAccessExpression);
            return transformPromiseExpressionOfPropertyAccess(node, transformer, prevArgName);
          }
          return silentFail();
        }
        function transformCatch(node, transformer, prevArgName) {
          var func2 = ts3.singleOrUndefined(node.arguments);
          var argName = func2 ? getArgBindingName(func2, transformer) : void 0;
          var possibleNameForVarDecl;
          if (prevArgName && !shouldReturn(node, transformer)) {
            if (isSynthIdentifier(prevArgName)) {
              possibleNameForVarDecl = prevArgName;
              transformer.synthNamesMap.forEach(function(val, key2) {
                if (val.identifier.text === prevArgName.identifier.text) {
                  var newSynthName = createUniqueSynthName(prevArgName);
                  transformer.synthNamesMap.set(key2, newSynthName);
                }
              });
            } else {
              possibleNameForVarDecl = createSynthIdentifier(ts3.factory.createUniqueName("result", 16), prevArgName.types);
            }
            possibleNameForVarDecl.hasBeenDeclared = true;
          }
          var tryBlock = ts3.factory.createBlock(transformExpression(node.expression, transformer, possibleNameForVarDecl));
          var transformationBody = func2 ? getTransformationBody(func2, possibleNameForVarDecl, argName, node, transformer) : ts3.emptyArray;
          var catchArg = argName ? isSynthIdentifier(argName) ? argName.identifier.text : argName.bindingPattern : "e";
          var catchVariableDeclaration = ts3.factory.createVariableDeclaration(catchArg);
          var catchClause = ts3.factory.createCatchClause(catchVariableDeclaration, ts3.factory.createBlock(transformationBody));
          var varDeclList;
          var varDeclIdentifier;
          if (possibleNameForVarDecl && !shouldReturn(node, transformer)) {
            varDeclIdentifier = ts3.getSynthesizedDeepClone(possibleNameForVarDecl.identifier);
            var typeArray = possibleNameForVarDecl.types;
            var unionType = transformer.checker.getUnionType(typeArray, 2);
            var unionTypeNode = transformer.isInJSFile ? void 0 : transformer.checker.typeToTypeNode(unionType, void 0, void 0);
            var varDecl = [ts3.factory.createVariableDeclaration(varDeclIdentifier, void 0, unionTypeNode)];
            varDeclList = ts3.factory.createVariableStatement(void 0, ts3.factory.createVariableDeclarationList(varDecl, 1));
          }
          var tryStatement = ts3.factory.createTryStatement(tryBlock, catchClause, void 0);
          var destructuredResult = prevArgName && varDeclIdentifier && isSynthBindingPattern(prevArgName) && ts3.factory.createVariableStatement(void 0, ts3.factory.createVariableDeclarationList([ts3.factory.createVariableDeclaration(ts3.getSynthesizedDeepClone(prevArgName.bindingPattern), void 0, void 0, varDeclIdentifier)], 2));
          return ts3.compact([varDeclList, tryStatement, destructuredResult]);
        }
        function createUniqueSynthName(prevArgName) {
          var renamedPrevArg = ts3.factory.createUniqueName(prevArgName.identifier.text, 16);
          return createSynthIdentifier(renamedPrevArg);
        }
        function transformThen(node, transformer, prevArgName) {
          var _a2 = node.arguments, onFulfilled = _a2[0], onRejected = _a2[1];
          var onFulfilledArgumentName = getArgBindingName(onFulfilled, transformer);
          var transformationBody = getTransformationBody(onFulfilled, prevArgName, onFulfilledArgumentName, node, transformer);
          if (onRejected) {
            var onRejectedArgumentName = getArgBindingName(onRejected, transformer);
            var tryBlock = ts3.factory.createBlock(transformExpression(node.expression, transformer, onFulfilledArgumentName).concat(transformationBody));
            var transformationBody2 = getTransformationBody(onRejected, prevArgName, onRejectedArgumentName, node, transformer);
            var catchArg = onRejectedArgumentName ? isSynthIdentifier(onRejectedArgumentName) ? onRejectedArgumentName.identifier.text : onRejectedArgumentName.bindingPattern : "e";
            var catchVariableDeclaration = ts3.factory.createVariableDeclaration(catchArg);
            var catchClause = ts3.factory.createCatchClause(catchVariableDeclaration, ts3.factory.createBlock(transformationBody2));
            return [ts3.factory.createTryStatement(tryBlock, catchClause, void 0)];
          }
          return transformExpression(node.expression, transformer, onFulfilledArgumentName).concat(transformationBody);
        }
        function transformPromiseExpressionOfPropertyAccess(node, transformer, prevArgName) {
          if (shouldReturn(node, transformer)) {
            return [ts3.factory.createReturnStatement(ts3.getSynthesizedDeepClone(node))];
          }
          return createVariableOrAssignmentOrExpressionStatement(prevArgName, ts3.factory.createAwaitExpression(node), void 0);
        }
        function createVariableOrAssignmentOrExpressionStatement(variableName, rightHandSide, typeAnnotation) {
          if (!variableName || isEmptyBindingName(variableName)) {
            return [ts3.factory.createExpressionStatement(rightHandSide)];
          }
          if (isSynthIdentifier(variableName) && variableName.hasBeenDeclared) {
            return [ts3.factory.createExpressionStatement(ts3.factory.createAssignment(ts3.getSynthesizedDeepClone(variableName.identifier), rightHandSide))];
          }
          return [
            ts3.factory.createVariableStatement(void 0, ts3.factory.createVariableDeclarationList([
              ts3.factory.createVariableDeclaration(ts3.getSynthesizedDeepClone(getNode(variableName)), void 0, typeAnnotation, rightHandSide)
            ], 2))
          ];
        }
        function maybeAnnotateAndReturn(expressionToReturn, typeAnnotation) {
          if (typeAnnotation && expressionToReturn) {
            var name = ts3.factory.createUniqueName("result", 16);
            return __spreadArray(__spreadArray([], createVariableOrAssignmentOrExpressionStatement(createSynthIdentifier(name), expressionToReturn, typeAnnotation)), [
              ts3.factory.createReturnStatement(name)
            ]);
          }
          return [ts3.factory.createReturnStatement(expressionToReturn)];
        }
        function getTransformationBody(func2, prevArgName, argName, parent, transformer) {
          var _a2, _b, _c, _d, _e;
          switch (func2.kind) {
            case 103:
              break;
            case 202:
            case 78:
              if (!argName) {
                break;
              }
              var synthCall = ts3.factory.createCallExpression(ts3.getSynthesizedDeepClone(func2), void 0, isSynthIdentifier(argName) ? [argName.identifier] : []);
              if (shouldReturn(parent, transformer)) {
                return maybeAnnotateAndReturn(synthCall, (_a2 = parent.typeArguments) === null || _a2 === void 0 ? void 0 : _a2[0]);
              }
              var type3 = transformer.checker.getTypeAtLocation(func2);
              var callSignatures = transformer.checker.getSignaturesOfType(type3, 0);
              if (!callSignatures.length) {
                return silentFail();
              }
              var returnType2 = callSignatures[0].getReturnType();
              var varDeclOrAssignment = createVariableOrAssignmentOrExpressionStatement(prevArgName, ts3.factory.createAwaitExpression(synthCall), (_b = parent.typeArguments) === null || _b === void 0 ? void 0 : _b[0]);
              if (prevArgName) {
                prevArgName.types.push(returnType2);
              }
              return varDeclOrAssignment;
            case 209:
            case 210: {
              var funcBody = func2.body;
              var returnType_1 = (_c = getLastCallSignature(transformer.checker.getTypeAtLocation(func2), transformer.checker)) === null || _c === void 0 ? void 0 : _c.getReturnType();
              if (ts3.isBlock(funcBody)) {
                var refactoredStmts = [];
                var seenReturnStatement = false;
                for (var _i = 0, _f = funcBody.statements; _i < _f.length; _i++) {
                  var statement = _f[_i];
                  if (ts3.isReturnStatement(statement)) {
                    seenReturnStatement = true;
                    if (ts3.isReturnStatementWithFixablePromiseHandler(statement, transformer.checker)) {
                      refactoredStmts = refactoredStmts.concat(getInnerTransformationBody(transformer, [statement], prevArgName));
                    } else {
                      var possiblyAwaitedRightHandSide = returnType_1 && statement.expression ? getPossiblyAwaitedRightHandSide(transformer.checker, returnType_1, statement.expression) : statement.expression;
                      refactoredStmts.push.apply(refactoredStmts, maybeAnnotateAndReturn(possiblyAwaitedRightHandSide, (_d = parent.typeArguments) === null || _d === void 0 ? void 0 : _d[0]));
                    }
                  } else {
                    refactoredStmts.push(statement);
                  }
                }
                return shouldReturn(parent, transformer) ? refactoredStmts.map(function(s2) {
                  return ts3.getSynthesizedDeepClone(s2);
                }) : removeReturns(refactoredStmts, prevArgName, transformer, seenReturnStatement);
              } else {
                var innerRetStmts = ts3.isFixablePromiseHandler(funcBody, transformer.checker) ? [ts3.factory.createReturnStatement(funcBody)] : ts3.emptyArray;
                var innerCbBody = getInnerTransformationBody(transformer, innerRetStmts, prevArgName);
                if (innerCbBody.length > 0) {
                  return innerCbBody;
                }
                if (returnType_1) {
                  var possiblyAwaitedRightHandSide = getPossiblyAwaitedRightHandSide(transformer.checker, returnType_1, funcBody);
                  if (!shouldReturn(parent, transformer)) {
                    var transformedStatement = createVariableOrAssignmentOrExpressionStatement(prevArgName, possiblyAwaitedRightHandSide, void 0);
                    if (prevArgName) {
                      prevArgName.types.push(returnType_1);
                    }
                    return transformedStatement;
                  } else {
                    return maybeAnnotateAndReturn(possiblyAwaitedRightHandSide, (_e = parent.typeArguments) === null || _e === void 0 ? void 0 : _e[0]);
                  }
                } else {
                  return silentFail();
                }
              }
            }
            default:
              return silentFail();
          }
          return ts3.emptyArray;
        }
        function getPossiblyAwaitedRightHandSide(checker, type3, expr) {
          var rightHandSide = ts3.getSynthesizedDeepClone(expr);
          return !!checker.getPromisedTypeOfPromise(type3) ? ts3.factory.createAwaitExpression(rightHandSide) : rightHandSide;
        }
        function getLastCallSignature(type3, checker) {
          var callSignatures = checker.getSignaturesOfType(type3, 0);
          return ts3.lastOrUndefined(callSignatures);
        }
        function removeReturns(stmts, prevArgName, transformer, seenReturnStatement) {
          var ret = [];
          for (var _i = 0, stmts_1 = stmts; _i < stmts_1.length; _i++) {
            var stmt = stmts_1[_i];
            if (ts3.isReturnStatement(stmt)) {
              if (stmt.expression) {
                var possiblyAwaitedExpression = isPromiseTypedExpression(stmt.expression, transformer.checker) ? ts3.factory.createAwaitExpression(stmt.expression) : stmt.expression;
                if (prevArgName === void 0) {
                  ret.push(ts3.factory.createExpressionStatement(possiblyAwaitedExpression));
                } else {
                  ret.push(ts3.factory.createVariableStatement(void 0, ts3.factory.createVariableDeclarationList([ts3.factory.createVariableDeclaration(getNode(prevArgName), void 0, void 0, possiblyAwaitedExpression)], 2)));
                }
              }
            } else {
              ret.push(ts3.getSynthesizedDeepClone(stmt));
            }
          }
          if (!seenReturnStatement && prevArgName !== void 0) {
            ret.push(ts3.factory.createVariableStatement(void 0, ts3.factory.createVariableDeclarationList([ts3.factory.createVariableDeclaration(getNode(prevArgName), void 0, void 0, ts3.factory.createIdentifier("undefined"))], 2)));
          }
          return ret;
        }
        function getInnerTransformationBody(transformer, innerRetStmts, prevArgName) {
          var innerCbBody = [];
          for (var _i = 0, innerRetStmts_1 = innerRetStmts; _i < innerRetStmts_1.length; _i++) {
            var stmt = innerRetStmts_1[_i];
            ts3.forEachChild(stmt, function visit(node) {
              if (ts3.isCallExpression(node)) {
                var temp = transformExpression(node, transformer, prevArgName);
                innerCbBody = innerCbBody.concat(temp);
                if (innerCbBody.length > 0) {
                  return;
                }
              } else if (!ts3.isFunctionLike(node)) {
                ts3.forEachChild(node, visit);
              }
            });
          }
          return innerCbBody;
        }
        function getArgBindingName(funcNode, transformer) {
          var types2 = [];
          var name;
          if (ts3.isFunctionLikeDeclaration(funcNode)) {
            if (funcNode.parameters.length > 0) {
              var param = funcNode.parameters[0].name;
              name = getMappedBindingNameOrDefault(param);
            }
          } else if (ts3.isIdentifier(funcNode)) {
            name = getMapEntryOrDefault(funcNode);
          } else if (ts3.isPropertyAccessExpression(funcNode) && ts3.isIdentifier(funcNode.name)) {
            name = getMapEntryOrDefault(funcNode.name);
          }
          if (!name || "identifier" in name && name.identifier.text === "undefined") {
            return void 0;
          }
          return name;
          function getMappedBindingNameOrDefault(bindingName) {
            if (ts3.isIdentifier(bindingName))
              return getMapEntryOrDefault(bindingName);
            var elements = ts3.flatMap(bindingName.elements, function(element) {
              if (ts3.isOmittedExpression(element))
                return [];
              return [getMappedBindingNameOrDefault(element.name)];
            });
            return createSynthBindingPattern(bindingName, elements);
          }
          function getMapEntryOrDefault(identifier) {
            var originalNode = getOriginalNode(identifier);
            var symbol = getSymbol(originalNode);
            if (!symbol) {
              return createSynthIdentifier(identifier, types2);
            }
            var mapEntry = transformer.synthNamesMap.get(ts3.getSymbolId(symbol).toString());
            return mapEntry || createSynthIdentifier(identifier, types2);
          }
          function getSymbol(node) {
            return node.symbol ? node.symbol : transformer.checker.getSymbolAtLocation(node);
          }
          function getOriginalNode(node) {
            return node.original ? node.original : node;
          }
        }
        function isEmptyBindingName(bindingName) {
          if (!bindingName) {
            return true;
          }
          if (isSynthIdentifier(bindingName)) {
            return !bindingName.identifier.text;
          }
          return ts3.every(bindingName.elements, isEmptyBindingName);
        }
        function getNode(bindingName) {
          return isSynthIdentifier(bindingName) ? bindingName.identifier : bindingName.bindingPattern;
        }
        function createSynthIdentifier(identifier, types2) {
          if (types2 === void 0) {
            types2 = [];
          }
          return { kind: 0, identifier, types: types2, hasBeenDeclared: false };
        }
        function createSynthBindingPattern(bindingPattern, elements, types2) {
          if (elements === void 0) {
            elements = ts3.emptyArray;
          }
          if (types2 === void 0) {
            types2 = [];
          }
          return { kind: 1, bindingPattern, elements, types: types2 };
        }
        function isSynthIdentifier(bindingName) {
          return bindingName.kind === 0;
        }
        function isSynthBindingPattern(bindingName) {
          return bindingName.kind === 1;
        }
        function shouldReturn(expression, transformer) {
          return !!expression.original && transformer.setOfExpressionsToReturn.has(ts3.getNodeId(expression.original));
        }
      })(codefix = ts3.codefix || (ts3.codefix = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var codefix;
      (function(codefix2) {
        codefix2.registerCodeFix({
          errorCodes: [ts3.Diagnostics.File_is_a_CommonJS_module_it_may_be_converted_to_an_ES6_module.code],
          getCodeActions: function(context) {
            var sourceFile = context.sourceFile, program2 = context.program, preferences = context.preferences;
            var changes = ts3.textChanges.ChangeTracker.with(context, function(changes2) {
              var moduleExportsChangedToDefault = convertFileToEs6Module(sourceFile, program2.getTypeChecker(), changes2, program2.getCompilerOptions().target, ts3.getQuotePreference(sourceFile, preferences));
              if (moduleExportsChangedToDefault) {
                for (var _i = 0, _a2 = program2.getSourceFiles(); _i < _a2.length; _i++) {
                  var importingFile = _a2[_i];
                  fixImportOfModuleExports(importingFile, sourceFile, changes2, ts3.getQuotePreference(importingFile, preferences));
                }
              }
            });
            return [codefix2.createCodeFixActionWithoutFixAll("convertToEs6Module", changes, ts3.Diagnostics.Convert_to_ES6_module)];
          }
        });
        function fixImportOfModuleExports(importingFile, exportingFile, changes, quotePreference) {
          for (var _i = 0, _a2 = importingFile.imports; _i < _a2.length; _i++) {
            var moduleSpecifier = _a2[_i];
            var imported = ts3.getResolvedModule(importingFile, moduleSpecifier.text);
            if (!imported || imported.resolvedFileName !== exportingFile.fileName) {
              continue;
            }
            var importNode = ts3.importFromModuleSpecifier(moduleSpecifier);
            switch (importNode.kind) {
              case 261:
                changes.replaceNode(importingFile, importNode, ts3.makeImport(importNode.name, void 0, moduleSpecifier, quotePreference));
                break;
              case 204:
                if (ts3.isRequireCall(importNode, false)) {
                  changes.replaceNode(importingFile, importNode, ts3.factory.createPropertyAccessExpression(ts3.getSynthesizedDeepClone(importNode), "default"));
                }
                break;
            }
          }
        }
        function convertFileToEs6Module(sourceFile, checker, changes, target, quotePreference) {
          var identifiers = { original: collectFreeIdentifiers(sourceFile), additional: new ts3.Set() };
          var exports3 = collectExportRenames(sourceFile, checker, identifiers);
          convertExportsAccesses(sourceFile, exports3, changes);
          var moduleExportsChangedToDefault = false;
          var useSitesToUnqualify;
          for (var _i = 0, _a2 = ts3.filter(sourceFile.statements, ts3.isVariableStatement); _i < _a2.length; _i++) {
            var statement = _a2[_i];
            var newUseSites = convertVariableStatement(sourceFile, statement, changes, checker, identifiers, target, quotePreference);
            if (newUseSites) {
              ts3.copyEntries(newUseSites, useSitesToUnqualify !== null && useSitesToUnqualify !== void 0 ? useSitesToUnqualify : useSitesToUnqualify = new ts3.Map());
            }
          }
          for (var _b = 0, _c = ts3.filter(sourceFile.statements, function(s2) {
            return !ts3.isVariableStatement(s2);
          }); _b < _c.length; _b++) {
            var statement = _c[_b];
            var moduleExportsChanged = convertStatement(sourceFile, statement, checker, changes, identifiers, target, exports3, useSitesToUnqualify, quotePreference);
            moduleExportsChangedToDefault = moduleExportsChangedToDefault || moduleExportsChanged;
          }
          useSitesToUnqualify === null || useSitesToUnqualify === void 0 ? void 0 : useSitesToUnqualify.forEach(function(replacement, original) {
            changes.replaceNode(sourceFile, original, replacement);
          });
          return moduleExportsChangedToDefault;
        }
        function collectExportRenames(sourceFile, checker, identifiers) {
          var res = new ts3.Map();
          forEachExportReference(sourceFile, function(node) {
            var _a2 = node.name, text = _a2.text, originalKeywordKind = _a2.originalKeywordKind;
            if (!res.has(text) && (originalKeywordKind !== void 0 && ts3.isNonContextualKeyword(originalKeywordKind) || checker.resolveName(text, node, 111551, true))) {
              res.set(text, makeUniqueName("_" + text, identifiers));
            }
          });
          return res;
        }
        function convertExportsAccesses(sourceFile, exports3, changes) {
          forEachExportReference(sourceFile, function(node, isAssignmentLhs) {
            if (isAssignmentLhs) {
              return;
            }
            var text = node.name.text;
            changes.replaceNode(sourceFile, node, ts3.factory.createIdentifier(exports3.get(text) || text));
          });
        }
        function forEachExportReference(sourceFile, cb2) {
          sourceFile.forEachChild(function recur(node) {
            if (ts3.isPropertyAccessExpression(node) && ts3.isExportsOrModuleExportsOrAlias(sourceFile, node.expression) && ts3.isIdentifier(node.name)) {
              var parent = node.parent;
              cb2(node, ts3.isBinaryExpression(parent) && parent.left === node && parent.operatorToken.kind === 62);
            }
            node.forEachChild(recur);
          });
        }
        function convertStatement(sourceFile, statement, checker, changes, identifiers, target, exports3, useSitesToUnqualify, quotePreference) {
          switch (statement.kind) {
            case 233:
              convertVariableStatement(sourceFile, statement, changes, checker, identifiers, target, quotePreference);
              return false;
            case 234: {
              var expression = statement.expression;
              switch (expression.kind) {
                case 204: {
                  if (ts3.isRequireCall(expression, true)) {
                    changes.replaceNode(sourceFile, statement, ts3.makeImport(void 0, void 0, expression.arguments[0], quotePreference));
                  }
                  return false;
                }
                case 217: {
                  var operatorToken = expression.operatorToken;
                  return operatorToken.kind === 62 && convertAssignment(sourceFile, checker, expression, changes, exports3, useSitesToUnqualify);
                }
              }
            }
            default:
              return false;
          }
        }
        function convertVariableStatement(sourceFile, statement, changes, checker, identifiers, target, quotePreference) {
          var declarationList = statement.declarationList;
          var foundImport = false;
          var converted = ts3.map(declarationList.declarations, function(decl) {
            var name = decl.name, initializer = decl.initializer;
            if (initializer) {
              if (ts3.isExportsOrModuleExportsOrAlias(sourceFile, initializer)) {
                foundImport = true;
                return convertedImports([]);
              } else if (ts3.isRequireCall(initializer, true)) {
                foundImport = true;
                return convertSingleImport(name, initializer.arguments[0], checker, identifiers, target, quotePreference);
              } else if (ts3.isPropertyAccessExpression(initializer) && ts3.isRequireCall(initializer.expression, true)) {
                foundImport = true;
                return convertPropertyAccessImport(name, initializer.name.text, initializer.expression.arguments[0], identifiers, quotePreference);
              }
            }
            return convertedImports([ts3.factory.createVariableStatement(void 0, ts3.factory.createVariableDeclarationList([decl], declarationList.flags))]);
          });
          if (foundImport) {
            changes.replaceNodeWithNodes(sourceFile, statement, ts3.flatMap(converted, function(c2) {
              return c2.newImports;
            }));
            var combinedUseSites_1;
            ts3.forEach(converted, function(c2) {
              if (c2.useSitesToUnqualify) {
                ts3.copyEntries(c2.useSitesToUnqualify, combinedUseSites_1 !== null && combinedUseSites_1 !== void 0 ? combinedUseSites_1 : combinedUseSites_1 = new ts3.Map());
              }
            });
            return combinedUseSites_1;
          }
        }
        function convertPropertyAccessImport(name, propertyName, moduleSpecifier, identifiers, quotePreference) {
          switch (name.kind) {
            case 197:
            case 198: {
              var tmp = makeUniqueName(propertyName, identifiers);
              return convertedImports([
                makeSingleImport(tmp, propertyName, moduleSpecifier, quotePreference),
                makeConst(void 0, name, ts3.factory.createIdentifier(tmp))
              ]);
            }
            case 78:
              return convertedImports([makeSingleImport(name.text, propertyName, moduleSpecifier, quotePreference)]);
            default:
              return ts3.Debug.assertNever(name, "Convert to ES6 module got invalid syntax form " + name.kind);
          }
        }
        function convertAssignment(sourceFile, checker, assignment, changes, exports3, useSitesToUnqualify) {
          var left = assignment.left, right = assignment.right;
          if (!ts3.isPropertyAccessExpression(left)) {
            return false;
          }
          if (ts3.isExportsOrModuleExportsOrAlias(sourceFile, left)) {
            if (ts3.isExportsOrModuleExportsOrAlias(sourceFile, right)) {
              changes.delete(sourceFile, assignment.parent);
            } else {
              var replacement = ts3.isObjectLiteralExpression(right) ? tryChangeModuleExportsObject(right, useSitesToUnqualify) : ts3.isRequireCall(right, true) ? convertReExportAll(right.arguments[0], checker) : void 0;
              if (replacement) {
                changes.replaceNodeWithNodes(sourceFile, assignment.parent, replacement[0]);
                return replacement[1];
              } else {
                changes.replaceRangeWithText(sourceFile, ts3.createRange(left.getStart(sourceFile), right.pos), "export default");
                return true;
              }
            }
          } else if (ts3.isExportsOrModuleExportsOrAlias(sourceFile, left.expression)) {
            convertNamedExport(sourceFile, assignment, changes, exports3);
          }
          return false;
        }
        function tryChangeModuleExportsObject(object, useSitesToUnqualify) {
          var statements = ts3.mapAllOrFail(object.properties, function(prop) {
            switch (prop.kind) {
              case 168:
              case 169:
              case 290:
              case 291:
                return void 0;
              case 289:
                return !ts3.isIdentifier(prop.name) ? void 0 : convertExportsDotXEquals_replaceNode(prop.name.text, prop.initializer, useSitesToUnqualify);
              case 166:
                return !ts3.isIdentifier(prop.name) ? void 0 : functionExpressionToDeclaration(prop.name.text, [ts3.factory.createToken(92)], prop, useSitesToUnqualify);
              default:
                ts3.Debug.assertNever(prop, "Convert to ES6 got invalid prop kind " + prop.kind);
            }
          });
          return statements && [statements, false];
        }
        function convertNamedExport(sourceFile, assignment, changes, exports3) {
          var text = assignment.left.name.text;
          var rename = exports3.get(text);
          if (rename !== void 0) {
            var newNodes = [
              makeConst(void 0, rename, assignment.right),
              makeExportDeclaration([ts3.factory.createExportSpecifier(rename, text)])
            ];
            changes.replaceNodeWithNodes(sourceFile, assignment.parent, newNodes);
          } else {
            convertExportsPropertyAssignment(assignment, sourceFile, changes);
          }
        }
        function convertReExportAll(reExported, checker) {
          var moduleSpecifier = reExported.text;
          var moduleSymbol = checker.getSymbolAtLocation(reExported);
          var exports3 = moduleSymbol ? moduleSymbol.exports : ts3.emptyMap;
          return exports3.has("export=") ? [[reExportDefault(moduleSpecifier)], true] : !exports3.has("default") ? [[reExportStar(moduleSpecifier)], false] : exports3.size > 1 ? [[reExportStar(moduleSpecifier), reExportDefault(moduleSpecifier)], true] : [[reExportDefault(moduleSpecifier)], true];
        }
        function reExportStar(moduleSpecifier) {
          return makeExportDeclaration(void 0, moduleSpecifier);
        }
        function reExportDefault(moduleSpecifier) {
          return makeExportDeclaration([ts3.factory.createExportSpecifier(void 0, "default")], moduleSpecifier);
        }
        function convertExportsPropertyAssignment(_a2, sourceFile, changes) {
          var left = _a2.left, right = _a2.right, parent = _a2.parent;
          var name = left.name.text;
          if ((ts3.isFunctionExpression(right) || ts3.isArrowFunction(right) || ts3.isClassExpression(right)) && (!right.name || right.name.text === name)) {
            changes.replaceRange(sourceFile, { pos: left.getStart(sourceFile), end: right.getStart(sourceFile) }, ts3.factory.createToken(92), { suffix: " " });
            if (!right.name)
              changes.insertName(sourceFile, right, name);
            var semi = ts3.findChildOfKind(parent, 26, sourceFile);
            if (semi)
              changes.delete(sourceFile, semi);
          } else {
            changes.replaceNodeRangeWithNodes(sourceFile, left.expression, ts3.findChildOfKind(left, 24, sourceFile), [ts3.factory.createToken(92), ts3.factory.createToken(84)], { joiner: " ", suffix: " " });
          }
        }
        function convertExportsDotXEquals_replaceNode(name, exported, useSitesToUnqualify) {
          var modifiers = [ts3.factory.createToken(92)];
          switch (exported.kind) {
            case 209: {
              var expressionName = exported.name;
              if (expressionName && expressionName.text !== name) {
                return exportConst();
              }
            }
            case 210:
              return functionExpressionToDeclaration(name, modifiers, exported, useSitesToUnqualify);
            case 222:
              return classExpressionToDeclaration(name, modifiers, exported, useSitesToUnqualify);
            default:
              return exportConst();
          }
          function exportConst() {
            return makeConst(modifiers, ts3.factory.createIdentifier(name), replaceImportUseSites(exported, useSitesToUnqualify));
          }
        }
        function replaceImportUseSites(nodeOrNodes, useSitesToUnqualify) {
          if (!useSitesToUnqualify || !ts3.some(ts3.arrayFrom(useSitesToUnqualify.keys()), function(original) {
            return ts3.rangeContainsRange(nodeOrNodes, original);
          })) {
            return nodeOrNodes;
          }
          return ts3.isArray(nodeOrNodes) ? ts3.getSynthesizedDeepClonesWithReplacements(nodeOrNodes, true, replaceNode) : ts3.getSynthesizedDeepCloneWithReplacements(nodeOrNodes, true, replaceNode);
          function replaceNode(original) {
            if (original.kind === 202) {
              var replacement = useSitesToUnqualify.get(original);
              useSitesToUnqualify.delete(original);
              return replacement;
            }
          }
        }
        function convertSingleImport(name, moduleSpecifier, checker, identifiers, target, quotePreference) {
          switch (name.kind) {
            case 197: {
              var importSpecifiers = ts3.mapAllOrFail(name.elements, function(e2) {
                return e2.dotDotDotToken || e2.initializer || e2.propertyName && !ts3.isIdentifier(e2.propertyName) || !ts3.isIdentifier(e2.name) ? void 0 : makeImportSpecifier(e2.propertyName && e2.propertyName.text, e2.name.text);
              });
              if (importSpecifiers) {
                return convertedImports([ts3.makeImport(void 0, importSpecifiers, moduleSpecifier, quotePreference)]);
              }
            }
            case 198: {
              var tmp = makeUniqueName(codefix2.moduleSpecifierToValidIdentifier(moduleSpecifier.text, target), identifiers);
              return convertedImports([
                ts3.makeImport(ts3.factory.createIdentifier(tmp), void 0, moduleSpecifier, quotePreference),
                makeConst(void 0, ts3.getSynthesizedDeepClone(name), ts3.factory.createIdentifier(tmp))
              ]);
            }
            case 78:
              return convertSingleIdentifierImport(name, moduleSpecifier, checker, identifiers, quotePreference);
            default:
              return ts3.Debug.assertNever(name, "Convert to ES6 module got invalid name kind " + name.kind);
          }
        }
        function convertSingleIdentifierImport(name, moduleSpecifier, checker, identifiers, quotePreference) {
          var nameSymbol = checker.getSymbolAtLocation(name);
          var namedBindingsNames = new ts3.Map();
          var needDefaultImport = false;
          var useSitesToUnqualify;
          for (var _i = 0, _a2 = identifiers.original.get(name.text); _i < _a2.length; _i++) {
            var use = _a2[_i];
            if (checker.getSymbolAtLocation(use) !== nameSymbol || use === name) {
              continue;
            }
            var parent = use.parent;
            if (ts3.isPropertyAccessExpression(parent)) {
              var propertyName = parent.name.text;
              if (propertyName === "default") {
                needDefaultImport = true;
                var importDefaultName = use.getText();
                (useSitesToUnqualify !== null && useSitesToUnqualify !== void 0 ? useSitesToUnqualify : useSitesToUnqualify = new ts3.Map()).set(parent, ts3.factory.createIdentifier(importDefaultName));
              } else {
                ts3.Debug.assert(parent.expression === use, "Didn't expect expression === use");
                var idName = namedBindingsNames.get(propertyName);
                if (idName === void 0) {
                  idName = makeUniqueName(propertyName, identifiers);
                  namedBindingsNames.set(propertyName, idName);
                }
                (useSitesToUnqualify !== null && useSitesToUnqualify !== void 0 ? useSitesToUnqualify : useSitesToUnqualify = new ts3.Map()).set(parent, ts3.factory.createIdentifier(idName));
              }
            } else {
              needDefaultImport = true;
            }
          }
          var namedBindings = namedBindingsNames.size === 0 ? void 0 : ts3.arrayFrom(ts3.mapIterator(namedBindingsNames.entries(), function(_a3) {
            var propertyName2 = _a3[0], idName2 = _a3[1];
            return ts3.factory.createImportSpecifier(propertyName2 === idName2 ? void 0 : ts3.factory.createIdentifier(propertyName2), ts3.factory.createIdentifier(idName2));
          }));
          if (!namedBindings) {
            needDefaultImport = true;
          }
          return convertedImports([ts3.makeImport(needDefaultImport ? ts3.getSynthesizedDeepClone(name) : void 0, namedBindings, moduleSpecifier, quotePreference)], useSitesToUnqualify);
        }
        function makeUniqueName(name, identifiers) {
          while (identifiers.original.has(name) || identifiers.additional.has(name)) {
            name = "_" + name;
          }
          identifiers.additional.add(name);
          return name;
        }
        function collectFreeIdentifiers(file) {
          var map2 = ts3.createMultiMap();
          forEachFreeIdentifier(file, function(id) {
            return map2.add(id.text, id);
          });
          return map2;
        }
        function forEachFreeIdentifier(node, cb2) {
          if (ts3.isIdentifier(node) && isFreeIdentifier(node))
            cb2(node);
          node.forEachChild(function(child) {
            return forEachFreeIdentifier(child, cb2);
          });
        }
        function isFreeIdentifier(node) {
          var parent = node.parent;
          switch (parent.kind) {
            case 202:
              return parent.name !== node;
            case 199:
              return parent.propertyName !== node;
            case 266:
              return parent.propertyName !== node;
            default:
              return true;
          }
        }
        function functionExpressionToDeclaration(name, additionalModifiers, fn, useSitesToUnqualify) {
          return ts3.factory.createFunctionDeclaration(ts3.getSynthesizedDeepClones(fn.decorators), ts3.concatenate(additionalModifiers, ts3.getSynthesizedDeepClones(fn.modifiers)), ts3.getSynthesizedDeepClone(fn.asteriskToken), name, ts3.getSynthesizedDeepClones(fn.typeParameters), ts3.getSynthesizedDeepClones(fn.parameters), ts3.getSynthesizedDeepClone(fn.type), ts3.factory.converters.convertToFunctionBlock(replaceImportUseSites(fn.body, useSitesToUnqualify)));
        }
        function classExpressionToDeclaration(name, additionalModifiers, cls, useSitesToUnqualify) {
          return ts3.factory.createClassDeclaration(ts3.getSynthesizedDeepClones(cls.decorators), ts3.concatenate(additionalModifiers, ts3.getSynthesizedDeepClones(cls.modifiers)), name, ts3.getSynthesizedDeepClones(cls.typeParameters), ts3.getSynthesizedDeepClones(cls.heritageClauses), replaceImportUseSites(cls.members, useSitesToUnqualify));
        }
        function makeSingleImport(localName, propertyName, moduleSpecifier, quotePreference) {
          return propertyName === "default" ? ts3.makeImport(ts3.factory.createIdentifier(localName), void 0, moduleSpecifier, quotePreference) : ts3.makeImport(void 0, [makeImportSpecifier(propertyName, localName)], moduleSpecifier, quotePreference);
        }
        function makeImportSpecifier(propertyName, name) {
          return ts3.factory.createImportSpecifier(propertyName !== void 0 && propertyName !== name ? ts3.factory.createIdentifier(propertyName) : void 0, ts3.factory.createIdentifier(name));
        }
        function makeConst(modifiers, name, init) {
          return ts3.factory.createVariableStatement(modifiers, ts3.factory.createVariableDeclarationList([ts3.factory.createVariableDeclaration(name, void 0, void 0, init)], 2));
        }
        function makeExportDeclaration(exportSpecifiers, moduleSpecifier) {
          return ts3.factory.createExportDeclaration(void 0, void 0, false, exportSpecifiers && ts3.factory.createNamedExports(exportSpecifiers), moduleSpecifier === void 0 ? void 0 : ts3.factory.createStringLiteral(moduleSpecifier));
        }
        function convertedImports(newImports, useSitesToUnqualify) {
          return {
            newImports,
            useSitesToUnqualify
          };
        }
      })(codefix = ts3.codefix || (ts3.codefix = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var codefix;
      (function(codefix2) {
        var fixId = "correctQualifiedNameToIndexedAccessType";
        var errorCodes = [ts3.Diagnostics.Cannot_access_0_1_because_0_is_a_type_but_not_a_namespace_Did_you_mean_to_retrieve_the_type_of_the_property_1_in_0_with_0_1.code];
        codefix2.registerCodeFix({
          errorCodes,
          getCodeActions: function(context) {
            var qualifiedName = getQualifiedName(context.sourceFile, context.span.start);
            if (!qualifiedName)
              return void 0;
            var changes = ts3.textChanges.ChangeTracker.with(context, function(t2) {
              return doChange(t2, context.sourceFile, qualifiedName);
            });
            var newText = qualifiedName.left.text + '["' + qualifiedName.right.text + '"]';
            return [codefix2.createCodeFixAction(fixId, changes, [ts3.Diagnostics.Rewrite_as_the_indexed_access_type_0, newText], fixId, ts3.Diagnostics.Rewrite_all_as_indexed_access_types)];
          },
          fixIds: [fixId],
          getAllCodeActions: function(context) {
            return codefix2.codeFixAll(context, errorCodes, function(changes, diag) {
              var q = getQualifiedName(diag.file, diag.start);
              if (q) {
                doChange(changes, diag.file, q);
              }
            });
          }
        });
        function getQualifiedName(sourceFile, pos) {
          var qualifiedName = ts3.findAncestor(ts3.getTokenAtPosition(sourceFile, pos), ts3.isQualifiedName);
          ts3.Debug.assert(!!qualifiedName, "Expected position to be owned by a qualified name.");
          return ts3.isIdentifier(qualifiedName.left) ? qualifiedName : void 0;
        }
        function doChange(changeTracker, sourceFile, qualifiedName) {
          var rightText = qualifiedName.right.text;
          var replacement = ts3.factory.createIndexedAccessTypeNode(ts3.factory.createTypeReferenceNode(qualifiedName.left, void 0), ts3.factory.createLiteralTypeNode(ts3.factory.createStringLiteral(rightText)));
          changeTracker.replaceNode(sourceFile, qualifiedName, replacement);
        }
      })(codefix = ts3.codefix || (ts3.codefix = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var codefix;
      (function(codefix2) {
        var errorCodes = [ts3.Diagnostics.Re_exporting_a_type_when_the_isolatedModules_flag_is_provided_requires_using_export_type.code];
        var fixId = "convertToTypeOnlyExport";
        codefix2.registerCodeFix({
          errorCodes,
          getCodeActions: function(context) {
            var changes = ts3.textChanges.ChangeTracker.with(context, function(t2) {
              return fixSingleExportDeclaration(t2, getExportSpecifierForDiagnosticSpan(context.span, context.sourceFile), context);
            });
            if (changes.length) {
              return [codefix2.createCodeFixAction(fixId, changes, ts3.Diagnostics.Convert_to_type_only_export, fixId, ts3.Diagnostics.Convert_all_re_exported_types_to_type_only_exports)];
            }
          },
          fixIds: [fixId],
          getAllCodeActions: function(context) {
            var fixedExportDeclarations = new ts3.Map();
            return codefix2.codeFixAll(context, errorCodes, function(changes, diag) {
              var exportSpecifier = getExportSpecifierForDiagnosticSpan(diag, context.sourceFile);
              if (exportSpecifier && ts3.addToSeen(fixedExportDeclarations, ts3.getNodeId(exportSpecifier.parent.parent))) {
                fixSingleExportDeclaration(changes, exportSpecifier, context);
              }
            });
          }
        });
        function getExportSpecifierForDiagnosticSpan(span, sourceFile) {
          return ts3.tryCast(ts3.getTokenAtPosition(sourceFile, span.start).parent, ts3.isExportSpecifier);
        }
        function fixSingleExportDeclaration(changes, exportSpecifier, context) {
          if (!exportSpecifier) {
            return;
          }
          var exportClause = exportSpecifier.parent;
          var exportDeclaration = exportClause.parent;
          var typeExportSpecifiers = getTypeExportSpecifiers(exportSpecifier, context);
          if (typeExportSpecifiers.length === exportClause.elements.length) {
            changes.insertModifierBefore(context.sourceFile, 149, exportClause);
          } else {
            var valueExportDeclaration = ts3.factory.updateExportDeclaration(exportDeclaration, exportDeclaration.decorators, exportDeclaration.modifiers, false, ts3.factory.updateNamedExports(exportClause, ts3.filter(exportClause.elements, function(e2) {
              return !ts3.contains(typeExportSpecifiers, e2);
            })), exportDeclaration.moduleSpecifier);
            var typeExportDeclaration = ts3.factory.createExportDeclaration(void 0, void 0, true, ts3.factory.createNamedExports(typeExportSpecifiers), exportDeclaration.moduleSpecifier);
            changes.replaceNode(context.sourceFile, exportDeclaration, valueExportDeclaration, {
              leadingTriviaOption: ts3.textChanges.LeadingTriviaOption.IncludeAll,
              trailingTriviaOption: ts3.textChanges.TrailingTriviaOption.Exclude
            });
            changes.insertNodeAfter(context.sourceFile, exportDeclaration, typeExportDeclaration);
          }
        }
        function getTypeExportSpecifiers(originExportSpecifier, context) {
          var exportClause = originExportSpecifier.parent;
          if (exportClause.elements.length === 1) {
            return exportClause.elements;
          }
          var diagnostics = ts3.getDiagnosticsWithinSpan(ts3.createTextSpanFromNode(exportClause), context.program.getSemanticDiagnostics(context.sourceFile, context.cancellationToken));
          return ts3.filter(exportClause.elements, function(element) {
            var _a2;
            return element === originExportSpecifier || ((_a2 = ts3.findDiagnosticForNode(element, diagnostics)) === null || _a2 === void 0 ? void 0 : _a2.code) === errorCodes[0];
          });
        }
      })(codefix = ts3.codefix || (ts3.codefix = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var codefix;
      (function(codefix2) {
        var errorCodes = [ts3.Diagnostics.This_import_is_never_used_as_a_value_and_must_use_import_type_because_importsNotUsedAsValues_is_set_to_error.code];
        var fixId = "convertToTypeOnlyImport";
        codefix2.registerCodeFix({
          errorCodes,
          getCodeActions: function(context) {
            var changes = ts3.textChanges.ChangeTracker.with(context, function(t2) {
              var importDeclaration = getImportDeclarationForDiagnosticSpan(context.span, context.sourceFile);
              fixSingleImportDeclaration(t2, importDeclaration, context);
            });
            if (changes.length) {
              return [codefix2.createCodeFixAction(fixId, changes, ts3.Diagnostics.Convert_to_type_only_import, fixId, ts3.Diagnostics.Convert_all_imports_not_used_as_a_value_to_type_only_imports)];
            }
          },
          fixIds: [fixId],
          getAllCodeActions: function(context) {
            return codefix2.codeFixAll(context, errorCodes, function(changes, diag) {
              var importDeclaration = getImportDeclarationForDiagnosticSpan(diag, context.sourceFile);
              fixSingleImportDeclaration(changes, importDeclaration, context);
            });
          }
        });
        function getImportDeclarationForDiagnosticSpan(span, sourceFile) {
          return ts3.tryCast(ts3.getTokenAtPosition(sourceFile, span.start).parent, ts3.isImportDeclaration);
        }
        function fixSingleImportDeclaration(changes, importDeclaration, context) {
          if (!(importDeclaration === null || importDeclaration === void 0 ? void 0 : importDeclaration.importClause)) {
            return;
          }
          var importClause = importDeclaration.importClause;
          changes.insertText(context.sourceFile, importDeclaration.getStart() + "import".length, " type");
          if (importClause.name && importClause.namedBindings) {
            changes.deleteNodeRangeExcludingEnd(context.sourceFile, importClause.name, importDeclaration.importClause.namedBindings);
            changes.insertNodeBefore(context.sourceFile, importDeclaration, ts3.factory.updateImportDeclaration(importDeclaration, void 0, void 0, ts3.factory.createImportClause(true, importClause.name, void 0), importDeclaration.moduleSpecifier));
          }
        }
      })(codefix = ts3.codefix || (ts3.codefix = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var codefix;
      (function(codefix2) {
        var fixId = "convertLiteralTypeToMappedType";
        var errorCodes = [ts3.Diagnostics._0_only_refers_to_a_type_but_is_being_used_as_a_value_here_Did_you_mean_to_use_1_in_0.code];
        codefix2.registerCodeFix({
          errorCodes,
          getCodeActions: function(context) {
            var sourceFile = context.sourceFile, span = context.span;
            var info = getInfo(sourceFile, span.start);
            if (!info) {
              return void 0;
            }
            var name = info.name, constraint = info.constraint;
            var changes = ts3.textChanges.ChangeTracker.with(context, function(t2) {
              return doChange(t2, sourceFile, info);
            });
            return [codefix2.createCodeFixAction(fixId, changes, [ts3.Diagnostics.Convert_0_to_1_in_0, constraint, name], fixId, ts3.Diagnostics.Convert_all_type_literals_to_mapped_type)];
          },
          fixIds: [fixId],
          getAllCodeActions: function(context) {
            return codefix2.codeFixAll(context, errorCodes, function(changes, diag) {
              var info = getInfo(diag.file, diag.start);
              if (info) {
                doChange(changes, diag.file, info);
              }
            });
          }
        });
        function getInfo(sourceFile, pos) {
          var token = ts3.getTokenAtPosition(sourceFile, pos);
          if (ts3.isIdentifier(token)) {
            var propertySignature = ts3.cast(token.parent.parent, ts3.isPropertySignature);
            var propertyName = token.getText(sourceFile);
            return {
              container: ts3.cast(propertySignature.parent, ts3.isTypeLiteralNode),
              typeNode: propertySignature.type,
              constraint: propertyName,
              name: propertyName === "K" ? "P" : "K"
            };
          }
          return void 0;
        }
        function doChange(changes, sourceFile, _a2) {
          var container = _a2.container, typeNode = _a2.typeNode, constraint = _a2.constraint, name = _a2.name;
          changes.replaceNode(sourceFile, container, ts3.factory.createMappedTypeNode(void 0, ts3.factory.createTypeParameterDeclaration(name, ts3.factory.createTypeReferenceNode(constraint)), void 0, void 0, typeNode));
        }
      })(codefix = ts3.codefix || (ts3.codefix = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var codefix;
      (function(codefix2) {
        var errorCodes = [
          ts3.Diagnostics.Class_0_incorrectly_implements_interface_1.code,
          ts3.Diagnostics.Class_0_incorrectly_implements_class_1_Did_you_mean_to_extend_1_and_inherit_its_members_as_a_subclass.code
        ];
        var fixId = "fixClassIncorrectlyImplementsInterface";
        codefix2.registerCodeFix({
          errorCodes,
          getCodeActions: function(context) {
            var sourceFile = context.sourceFile, span = context.span;
            var classDeclaration = getClass(sourceFile, span.start);
            return ts3.mapDefined(ts3.getEffectiveImplementsTypeNodes(classDeclaration), function(implementedTypeNode) {
              var changes = ts3.textChanges.ChangeTracker.with(context, function(t2) {
                return addMissingDeclarations(context, implementedTypeNode, sourceFile, classDeclaration, t2, context.preferences);
              });
              return changes.length === 0 ? void 0 : codefix2.createCodeFixAction(fixId, changes, [ts3.Diagnostics.Implement_interface_0, implementedTypeNode.getText(sourceFile)], fixId, ts3.Diagnostics.Implement_all_unimplemented_interfaces);
            });
          },
          fixIds: [fixId],
          getAllCodeActions: function(context) {
            var seenClassDeclarations = new ts3.Map();
            return codefix2.codeFixAll(context, errorCodes, function(changes, diag) {
              var classDeclaration = getClass(diag.file, diag.start);
              if (ts3.addToSeen(seenClassDeclarations, ts3.getNodeId(classDeclaration))) {
                for (var _i = 0, _a2 = ts3.getEffectiveImplementsTypeNodes(classDeclaration); _i < _a2.length; _i++) {
                  var implementedTypeNode = _a2[_i];
                  addMissingDeclarations(context, implementedTypeNode, diag.file, classDeclaration, changes, context.preferences);
                }
              }
            });
          }
        });
        function getClass(sourceFile, pos) {
          return ts3.Debug.checkDefined(ts3.getContainingClass(ts3.getTokenAtPosition(sourceFile, pos)), "There should be a containing class");
        }
        function symbolPointsToNonPrivateMember(symbol) {
          return !symbol.valueDeclaration || !(ts3.getEffectiveModifierFlags(symbol.valueDeclaration) & 8);
        }
        function addMissingDeclarations(context, implementedTypeNode, sourceFile, classDeclaration, changeTracker, preferences) {
          var checker = context.program.getTypeChecker();
          var maybeHeritageClauseSymbol = getHeritageClauseSymbolTable(classDeclaration, checker);
          var implementedType = checker.getTypeAtLocation(implementedTypeNode);
          var implementedTypeSymbols = checker.getPropertiesOfType(implementedType);
          var nonPrivateAndNotExistedInHeritageClauseMembers = implementedTypeSymbols.filter(ts3.and(symbolPointsToNonPrivateMember, function(symbol) {
            return !maybeHeritageClauseSymbol.has(symbol.escapedName);
          }));
          var classType = checker.getTypeAtLocation(classDeclaration);
          var constructor = ts3.find(classDeclaration.members, function(m) {
            return ts3.isConstructorDeclaration(m);
          });
          if (!classType.getNumberIndexType()) {
            createMissingIndexSignatureDeclaration(implementedType, 1);
          }
          if (!classType.getStringIndexType()) {
            createMissingIndexSignatureDeclaration(implementedType, 0);
          }
          var importAdder = codefix2.createImportAdder(sourceFile, context.program, preferences, context.host);
          codefix2.createMissingMemberNodes(classDeclaration, nonPrivateAndNotExistedInHeritageClauseMembers, sourceFile, context, preferences, importAdder, function(member) {
            return insertInterfaceMemberNode(sourceFile, classDeclaration, member);
          });
          importAdder.writeFixes(changeTracker);
          function createMissingIndexSignatureDeclaration(type3, kind) {
            var indexInfoOfKind = checker.getIndexInfoOfType(type3, kind);
            if (indexInfoOfKind) {
              insertInterfaceMemberNode(sourceFile, classDeclaration, checker.indexInfoToIndexSignatureDeclaration(indexInfoOfKind, kind, classDeclaration, void 0, codefix2.getNoopSymbolTrackerWithResolver(context)));
            }
          }
          function insertInterfaceMemberNode(sourceFile2, cls, newElement) {
            if (constructor) {
              changeTracker.insertNodeAfter(sourceFile2, constructor, newElement);
            } else {
              changeTracker.insertNodeAtClassStart(sourceFile2, cls, newElement);
            }
          }
        }
        function getHeritageClauseSymbolTable(classDeclaration, checker) {
          var heritageClauseNode = ts3.getEffectiveBaseTypeNode(classDeclaration);
          if (!heritageClauseNode)
            return ts3.createSymbolTable();
          var heritageClauseType = checker.getTypeAtLocation(heritageClauseNode);
          var heritageClauseTypeSymbols = checker.getPropertiesOfType(heritageClauseType);
          return ts3.createSymbolTable(heritageClauseTypeSymbols.filter(symbolPointsToNonPrivateMember));
        }
      })(codefix = ts3.codefix || (ts3.codefix = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var codefix;
      (function(codefix2) {
        codefix2.importFixName = "import";
        var importFixId = "fixMissingImport";
        var errorCodes = [
          ts3.Diagnostics.Cannot_find_name_0.code,
          ts3.Diagnostics.Cannot_find_name_0_Did_you_mean_1.code,
          ts3.Diagnostics.Cannot_find_name_0_Did_you_mean_the_instance_member_this_0.code,
          ts3.Diagnostics.Cannot_find_name_0_Did_you_mean_the_static_member_1_0.code,
          ts3.Diagnostics.Cannot_find_namespace_0.code,
          ts3.Diagnostics._0_refers_to_a_UMD_global_but_the_current_file_is_a_module_Consider_adding_an_import_instead.code,
          ts3.Diagnostics._0_only_refers_to_a_type_but_is_being_used_as_a_value_here.code
        ];
        codefix2.registerCodeFix({
          errorCodes,
          getCodeActions: function(context) {
            var errorCode = context.errorCode, preferences = context.preferences, sourceFile = context.sourceFile, span = context.span;
            var info = getFixesInfo(context, errorCode, span.start, true);
            if (!info)
              return void 0;
            var fixes = info.fixes, symbolName = info.symbolName;
            var quotePreference = ts3.getQuotePreference(sourceFile, preferences);
            return fixes.map(function(fix) {
              return codeActionForFix(context, sourceFile, symbolName, fix, quotePreference);
            });
          },
          fixIds: [importFixId],
          getAllCodeActions: function(context) {
            var sourceFile = context.sourceFile, program2 = context.program, preferences = context.preferences, host = context.host;
            var importAdder = createImportAdderWorker(sourceFile, program2, true, preferences, host);
            codefix2.eachDiagnostic(context, errorCodes, function(diag) {
              return importAdder.addImportFromDiagnostic(diag, context);
            });
            return codefix2.createCombinedCodeActions(ts3.textChanges.ChangeTracker.with(context, importAdder.writeFixes));
          }
        });
        function createImportAdder(sourceFile, program2, preferences, host) {
          return createImportAdderWorker(sourceFile, program2, false, preferences, host);
        }
        codefix2.createImportAdder = createImportAdder;
        function createImportAdderWorker(sourceFile, program2, useAutoImportProvider, preferences, host) {
          var compilerOptions = program2.getCompilerOptions();
          var addToNamespace = [];
          var importType = [];
          var addToExisting = new ts3.Map();
          var newImports = new ts3.Map();
          return { addImportFromDiagnostic, addImportFromExportedSymbol, writeFixes };
          function addImportFromDiagnostic(diagnostic, context) {
            var info = getFixesInfo(context, diagnostic.code, diagnostic.start, useAutoImportProvider);
            if (!info || !info.fixes.length)
              return;
            addImport(info);
          }
          function addImportFromExportedSymbol(exportedSymbol, usageIsTypeOnly) {
            var moduleSymbol = ts3.Debug.checkDefined(exportedSymbol.parent);
            var symbolName = ts3.getNameForExportedSymbol(exportedSymbol, ts3.getEmitScriptTarget(compilerOptions));
            var checker = program2.getTypeChecker();
            var symbol = checker.getMergedSymbol(ts3.skipAlias(exportedSymbol, checker));
            var exportInfos = getAllReExportingModules(sourceFile, symbol, moduleSymbol, symbolName, host, program2, useAutoImportProvider);
            var preferTypeOnlyImport = !!usageIsTypeOnly && compilerOptions.importsNotUsedAsValues === 2;
            var useRequire = shouldUseRequire(sourceFile, program2);
            var fix = getImportFixForSymbol(sourceFile, exportInfos, moduleSymbol, symbolName, program2, void 0, preferTypeOnlyImport, useRequire, host, preferences);
            addImport({ fixes: [fix], symbolName });
          }
          function addImport(info) {
            var fixes = info.fixes, symbolName = info.symbolName;
            var fix = ts3.first(fixes);
            switch (fix.kind) {
              case 0:
                addToNamespace.push(fix);
                break;
              case 1:
                importType.push(fix);
                break;
              case 2: {
                var importClauseOrBindingPattern = fix.importClauseOrBindingPattern, importKind = fix.importKind, canUseTypeOnlyImport = fix.canUseTypeOnlyImport;
                var key2 = String(ts3.getNodeId(importClauseOrBindingPattern));
                var entry = addToExisting.get(key2);
                if (!entry) {
                  addToExisting.set(key2, entry = { importClauseOrBindingPattern, defaultImport: void 0, namedImports: [], canUseTypeOnlyImport });
                }
                if (importKind === 0) {
                  ts3.pushIfUnique(entry.namedImports, symbolName);
                } else {
                  ts3.Debug.assert(entry.defaultImport === void 0 || entry.defaultImport === symbolName, "(Add to Existing) Default import should be missing or match symbolName");
                  entry.defaultImport = symbolName;
                }
                break;
              }
              case 3: {
                var moduleSpecifier = fix.moduleSpecifier, importKind = fix.importKind, useRequire = fix.useRequire, typeOnly = fix.typeOnly;
                var entry = newImports.get(moduleSpecifier);
                if (!entry) {
                  newImports.set(moduleSpecifier, entry = { namedImports: [], namespaceLikeImport: void 0, typeOnly, useRequire });
                } else {
                  entry.typeOnly = entry.typeOnly && typeOnly;
                }
                switch (importKind) {
                  case 1:
                    ts3.Debug.assert(entry.defaultImport === void 0 || entry.defaultImport === symbolName, "(Add new) Default import should be missing or match symbolName");
                    entry.defaultImport = symbolName;
                    break;
                  case 0:
                    ts3.pushIfUnique(entry.namedImports || (entry.namedImports = []), symbolName);
                    break;
                  case 3:
                  case 2:
                    ts3.Debug.assert(entry.namespaceLikeImport === void 0 || entry.namespaceLikeImport.name === symbolName, "Namespacelike import shoudl be missing or match symbolName");
                    entry.namespaceLikeImport = { importKind, name: symbolName };
                    break;
                }
                break;
              }
              default:
                ts3.Debug.assertNever(fix, "fix wasn't never - got kind " + fix.kind);
            }
          }
          function writeFixes(changeTracker) {
            var quotePreference = ts3.getQuotePreference(sourceFile, preferences);
            for (var _i = 0, addToNamespace_1 = addToNamespace; _i < addToNamespace_1.length; _i++) {
              var fix = addToNamespace_1[_i];
              addNamespaceQualifier(changeTracker, sourceFile, fix);
            }
            for (var _a2 = 0, importType_1 = importType; _a2 < importType_1.length; _a2++) {
              var fix = importType_1[_a2];
              addImportType(changeTracker, sourceFile, fix, quotePreference);
            }
            addToExisting.forEach(function(_a3) {
              var importClauseOrBindingPattern = _a3.importClauseOrBindingPattern, defaultImport = _a3.defaultImport, namedImports = _a3.namedImports, canUseTypeOnlyImport = _a3.canUseTypeOnlyImport;
              doAddExistingFix(changeTracker, sourceFile, importClauseOrBindingPattern, defaultImport, namedImports, canUseTypeOnlyImport);
            });
            var newDeclarations;
            newImports.forEach(function(_a3, moduleSpecifier) {
              var useRequire = _a3.useRequire, imports = __rest(_a3, ["useRequire"]);
              var getDeclarations = useRequire ? getNewRequires : getNewImports;
              newDeclarations = ts3.combine(newDeclarations, getDeclarations(moduleSpecifier, quotePreference, imports));
            });
            if (newDeclarations) {
              ts3.insertImports(changeTracker, sourceFile, newDeclarations, true);
            }
          }
        }
        var ImportFixKind;
        (function(ImportFixKind2) {
          ImportFixKind2[ImportFixKind2["UseNamespace"] = 0] = "UseNamespace";
          ImportFixKind2[ImportFixKind2["ImportType"] = 1] = "ImportType";
          ImportFixKind2[ImportFixKind2["AddToExisting"] = 2] = "AddToExisting";
          ImportFixKind2[ImportFixKind2["AddNew"] = 3] = "AddNew";
        })(ImportFixKind || (ImportFixKind = {}));
        function getImportCompletionAction(exportedSymbol, moduleSymbol, sourceFile, symbolName, host, program2, formatContext, position, preferences) {
          var compilerOptions = program2.getCompilerOptions();
          var exportInfos = ts3.pathIsBareSpecifier(ts3.stripQuotes(moduleSymbol.name)) ? [getSymbolExportInfoForSymbol(exportedSymbol, moduleSymbol, program2, host)] : getAllReExportingModules(sourceFile, exportedSymbol, moduleSymbol, symbolName, host, program2, true);
          var useRequire = shouldUseRequire(sourceFile, program2);
          var preferTypeOnlyImport = compilerOptions.importsNotUsedAsValues === 2 && !ts3.isSourceFileJS(sourceFile) && ts3.isValidTypeOnlyAliasUseSite(ts3.getTokenAtPosition(sourceFile, position));
          var fix = getImportFixForSymbol(sourceFile, exportInfos, moduleSymbol, symbolName, program2, position, preferTypeOnlyImport, useRequire, host, preferences);
          return { moduleSpecifier: fix.moduleSpecifier, codeAction: codeFixActionToCodeAction(codeActionForFix({ host, formatContext, preferences }, sourceFile, symbolName, fix, ts3.getQuotePreference(sourceFile, preferences))) };
        }
        codefix2.getImportCompletionAction = getImportCompletionAction;
        function getImportFixForSymbol(sourceFile, exportInfos, moduleSymbol, symbolName, program2, position, preferTypeOnlyImport, useRequire, host, preferences) {
          ts3.Debug.assert(exportInfos.some(function(info) {
            return info.moduleSymbol === moduleSymbol;
          }), "Some exportInfo should match the specified moduleSymbol");
          return getBestFix(getImportFixes(exportInfos, symbolName, position, preferTypeOnlyImport, useRequire, program2, sourceFile, host, preferences), sourceFile, host);
        }
        function codeFixActionToCodeAction(_a2) {
          var description = _a2.description, changes = _a2.changes, commands = _a2.commands;
          return { description, changes, commands };
        }
        function getSymbolExportInfoForSymbol(symbol, moduleSymbol, program2, host) {
          var _a2, _b;
          var compilerOptions = program2.getCompilerOptions();
          var mainProgramInfo = getInfoWithChecker(program2.getTypeChecker(), false);
          if (mainProgramInfo) {
            return mainProgramInfo;
          }
          var autoImportProvider = (_b = (_a2 = host.getPackageJsonAutoImportProvider) === null || _a2 === void 0 ? void 0 : _a2.call(host)) === null || _b === void 0 ? void 0 : _b.getTypeChecker();
          return ts3.Debug.checkDefined(autoImportProvider && getInfoWithChecker(autoImportProvider, true), "Could not find symbol in specified module for code actions");
          function getInfoWithChecker(checker, isFromPackageJson) {
            var defaultInfo = getDefaultLikeExportInfo(moduleSymbol, checker, compilerOptions);
            if (defaultInfo && ts3.skipAlias(defaultInfo.symbol, checker) === symbol) {
              return { symbol: defaultInfo.symbol, moduleSymbol, exportKind: defaultInfo.exportKind, exportedSymbolIsTypeOnly: isTypeOnlySymbol(symbol, checker), isFromPackageJson };
            }
            var named = checker.tryGetMemberInModuleExportsAndProperties(symbol.name, moduleSymbol);
            if (named && ts3.skipAlias(named, checker) === symbol) {
              return { symbol: named, moduleSymbol, exportKind: 0, exportedSymbolIsTypeOnly: isTypeOnlySymbol(symbol, checker), isFromPackageJson };
            }
          }
        }
        function getAllReExportingModules(importingFile, exportedSymbol, exportingModuleSymbol, symbolName, host, program2, useAutoImportProvider) {
          var result2 = [];
          var compilerOptions = program2.getCompilerOptions();
          var getModuleSpecifierResolutionHost = ts3.memoizeOne(function(isFromPackageJson) {
            return ts3.createModuleSpecifierResolutionHost(isFromPackageJson ? host.getPackageJsonAutoImportProvider() : program2, host);
          });
          forEachExternalModuleToImportFrom(program2, host, useAutoImportProvider, function(moduleSymbol, moduleFile, program3, isFromPackageJson) {
            var checker = program3.getTypeChecker();
            if (moduleFile && moduleSymbol !== exportingModuleSymbol && ts3.startsWith(importingFile.fileName, ts3.getDirectoryPath(moduleFile.fileName))) {
              return;
            }
            var defaultInfo = getDefaultLikeExportInfo(moduleSymbol, checker, compilerOptions);
            if (defaultInfo && (defaultInfo.name === symbolName || moduleSymbolToValidIdentifier(moduleSymbol, compilerOptions.target) === symbolName) && ts3.skipAlias(defaultInfo.symbol, checker) === exportedSymbol && isImportable(program3, moduleFile, isFromPackageJson)) {
              result2.push({ symbol: defaultInfo.symbol, moduleSymbol, exportKind: defaultInfo.exportKind, exportedSymbolIsTypeOnly: isTypeOnlySymbol(defaultInfo.symbol, checker), isFromPackageJson });
            }
            for (var _i = 0, _a2 = checker.getExportsAndPropertiesOfModule(moduleSymbol); _i < _a2.length; _i++) {
              var exported = _a2[_i];
              if (exported.name === symbolName && ts3.skipAlias(exported, checker) === exportedSymbol && isImportable(program3, moduleFile, isFromPackageJson)) {
                result2.push({ symbol: exported, moduleSymbol, exportKind: 0, exportedSymbolIsTypeOnly: isTypeOnlySymbol(exported, checker), isFromPackageJson });
              }
            }
          });
          return result2;
          function isImportable(program3, moduleFile, isFromPackageJson) {
            var _a2;
            return !moduleFile || ts3.isImportableFile(program3, importingFile, moduleFile, void 0, getModuleSpecifierResolutionHost(isFromPackageJson), (_a2 = host.getModuleSpecifierCache) === null || _a2 === void 0 ? void 0 : _a2.call(host));
          }
        }
        function getModuleSpecifierForBestExportInfo(exportInfo, importingFile, program2, host, preferences) {
          return getBestFix(getNewImportFixes(program2, importingFile, void 0, false, false, exportInfo, host, preferences), importingFile, host);
        }
        codefix2.getModuleSpecifierForBestExportInfo = getModuleSpecifierForBestExportInfo;
        function getSymbolToExportInfoMap(importingFile, host, program2) {
          var _a2, _b, _c, _d, _e, _f, _g, _h;
          var start = ts3.timestamp();
          (_a2 = host.getPackageJsonAutoImportProvider) === null || _a2 === void 0 ? void 0 : _a2.call(host);
          var cache = (_b = host.getExportMapCache) === null || _b === void 0 ? void 0 : _b.call(host);
          if (cache) {
            var cached = cache.get(importingFile.path, program2.getTypeChecker(), (_c = host.getProjectVersion) === null || _c === void 0 ? void 0 : _c.call(host));
            if (cached) {
              (_d = host.log) === null || _d === void 0 ? void 0 : _d.call(host, "getSymbolToExportInfoMap: cache hit");
              return cached;
            } else {
              (_e = host.log) === null || _e === void 0 ? void 0 : _e.call(host, "getSymbolToExportInfoMap: cache miss or empty; calculating new results");
            }
          }
          var result2 = ts3.createMultiMap();
          var compilerOptions = program2.getCompilerOptions();
          var target = ts3.getEmitScriptTarget(compilerOptions);
          forEachExternalModuleToImportFrom(program2, host, true, function(moduleSymbol, _moduleFile, program3, isFromPackageJson) {
            var checker = program3.getTypeChecker();
            var defaultInfo = getDefaultLikeExportInfo(moduleSymbol, checker, compilerOptions);
            if (defaultInfo) {
              var name = ts3.getNameForExportedSymbol(ts3.getLocalSymbolForExportDefault(defaultInfo.symbol) || defaultInfo.symbol, target);
              result2.add(key2(name, defaultInfo.symbol, moduleSymbol, checker), { symbol: defaultInfo.symbol, moduleSymbol, exportKind: defaultInfo.exportKind, exportedSymbolIsTypeOnly: isTypeOnlySymbol(defaultInfo.symbol, checker), isFromPackageJson });
            }
            var seenExports = new ts3.Map();
            for (var _i = 0, _a3 = checker.getExportsAndPropertiesOfModule(moduleSymbol); _i < _a3.length; _i++) {
              var exported = _a3[_i];
              if (exported !== (defaultInfo === null || defaultInfo === void 0 ? void 0 : defaultInfo.symbol) && ts3.addToSeen(seenExports, exported)) {
                result2.add(key2(ts3.getNameForExportedSymbol(exported, target), exported, moduleSymbol, checker), { symbol: exported, moduleSymbol, exportKind: 0, exportedSymbolIsTypeOnly: isTypeOnlySymbol(exported, checker), isFromPackageJson });
              }
            }
          });
          if (cache) {
            (_f = host.log) === null || _f === void 0 ? void 0 : _f.call(host, "getSymbolToExportInfoMap: caching results");
            cache.set(result2, (_g = host.getProjectVersion) === null || _g === void 0 ? void 0 : _g.call(host));
          }
          (_h = host.log) === null || _h === void 0 ? void 0 : _h.call(host, "getSymbolToExportInfoMap: done in " + (ts3.timestamp() - start) + " ms");
          return result2;
          function key2(name, alias, moduleSymbol, checker) {
            var moduleName = ts3.stripQuotes(moduleSymbol.name);
            var moduleKey = ts3.isExternalModuleNameRelative(moduleName) ? "/" : moduleName;
            return name + "|" + ts3.getSymbolId(ts3.skipAlias(alias, checker)) + "|" + moduleKey;
          }
        }
        codefix2.getSymbolToExportInfoMap = getSymbolToExportInfoMap;
        function isTypeOnlySymbol(s2, checker) {
          return !(ts3.skipAlias(s2, checker).flags & 111551);
        }
        function isTypeOnlyPosition(sourceFile, position) {
          return ts3.isValidTypeOnlyAliasUseSite(ts3.getTokenAtPosition(sourceFile, position));
        }
        function getImportFixes(exportInfos, symbolName, position, preferTypeOnlyImport, useRequire, program2, sourceFile, host, preferences) {
          var checker = program2.getTypeChecker();
          var existingImports = ts3.flatMap(exportInfos, function(info) {
            return getExistingImportDeclarations(info, checker, sourceFile, program2.getCompilerOptions());
          });
          var useNamespace = position === void 0 ? void 0 : tryUseExistingNamespaceImport(existingImports, symbolName, position, checker);
          var addToExisting = tryAddToExistingImport(existingImports, position !== void 0 && isTypeOnlyPosition(sourceFile, position));
          var addImport = addToExisting ? [addToExisting] : getFixesForAddImport(exportInfos, existingImports, program2, sourceFile, position, preferTypeOnlyImport, useRequire, host, preferences);
          return __spreadArray(__spreadArray([], useNamespace ? [useNamespace] : ts3.emptyArray), addImport);
        }
        function tryUseExistingNamespaceImport(existingImports, symbolName, position, checker) {
          return ts3.firstDefined(existingImports, function(_a2) {
            var declaration = _a2.declaration;
            var namespacePrefix = getNamespaceLikeImportText(declaration);
            var moduleSpecifier = ts3.tryGetModuleSpecifierFromDeclaration(declaration);
            if (namespacePrefix && moduleSpecifier) {
              var moduleSymbol = getTargetModuleFromNamespaceLikeImport(declaration, checker);
              if (moduleSymbol && moduleSymbol.exports.has(ts3.escapeLeadingUnderscores(symbolName))) {
                return { kind: 0, namespacePrefix, position, moduleSpecifier };
              }
            }
          });
        }
        function getTargetModuleFromNamespaceLikeImport(declaration, checker) {
          var _a2;
          switch (declaration.kind) {
            case 250:
              return checker.resolveExternalModuleName(declaration.initializer.arguments[0]);
            case 261:
              return checker.getAliasedSymbol(declaration.symbol);
            case 262:
              var namespaceImport = ts3.tryCast((_a2 = declaration.importClause) === null || _a2 === void 0 ? void 0 : _a2.namedBindings, ts3.isNamespaceImport);
              return namespaceImport && checker.getAliasedSymbol(namespaceImport.symbol);
            default:
              return ts3.Debug.assertNever(declaration);
          }
        }
        function getNamespaceLikeImportText(declaration) {
          var _a2, _b, _c;
          switch (declaration.kind) {
            case 250:
              return (_a2 = ts3.tryCast(declaration.name, ts3.isIdentifier)) === null || _a2 === void 0 ? void 0 : _a2.text;
            case 261:
              return declaration.name.text;
            case 262:
              return (_c = ts3.tryCast((_b = declaration.importClause) === null || _b === void 0 ? void 0 : _b.namedBindings, ts3.isNamespaceImport)) === null || _c === void 0 ? void 0 : _c.name.text;
            default:
              return ts3.Debug.assertNever(declaration);
          }
        }
        function tryAddToExistingImport(existingImports, canUseTypeOnlyImport) {
          return ts3.firstDefined(existingImports, function(_a2) {
            var declaration = _a2.declaration, importKind = _a2.importKind;
            if (declaration.kind === 261)
              return void 0;
            if (declaration.kind === 250) {
              return (importKind === 0 || importKind === 1) && declaration.name.kind === 197 ? { kind: 2, importClauseOrBindingPattern: declaration.name, importKind, moduleSpecifier: declaration.initializer.arguments[0].text, canUseTypeOnlyImport: false } : void 0;
            }
            var importClause = declaration.importClause;
            if (!importClause || !ts3.isStringLiteralLike(declaration.moduleSpecifier))
              return void 0;
            var name = importClause.name, namedBindings = importClause.namedBindings;
            if (importClause.isTypeOnly && !(importKind === 0 && namedBindings))
              return void 0;
            return importKind === 1 && !name || importKind === 0 && (!namedBindings || namedBindings.kind === 265) ? { kind: 2, importClauseOrBindingPattern: importClause, importKind, moduleSpecifier: declaration.moduleSpecifier.text, canUseTypeOnlyImport } : void 0;
          });
        }
        function getExistingImportDeclarations(_a2, checker, importingFile, compilerOptions) {
          var moduleSymbol = _a2.moduleSymbol, exportKind = _a2.exportKind, exportedSymbolIsTypeOnly = _a2.exportedSymbolIsTypeOnly;
          if (exportedSymbolIsTypeOnly && ts3.isSourceFileJS(importingFile))
            return ts3.emptyArray;
          var importKind = getImportKind(importingFile, exportKind, compilerOptions);
          return ts3.mapDefined(importingFile.imports, function(moduleSpecifier) {
            var i3 = ts3.importFromModuleSpecifier(moduleSpecifier);
            if (ts3.isRequireVariableDeclaration(i3.parent)) {
              return checker.resolveExternalModuleName(moduleSpecifier) === moduleSymbol ? { declaration: i3.parent, importKind } : void 0;
            }
            if (i3.kind === 262 || i3.kind === 261) {
              return checker.getSymbolAtLocation(moduleSpecifier) === moduleSymbol ? { declaration: i3, importKind } : void 0;
            }
          });
        }
        function shouldUseRequire(sourceFile, program2) {
          if (!ts3.isSourceFileJS(sourceFile)) {
            return false;
          }
          if (sourceFile.commonJsModuleIndicator && !sourceFile.externalModuleIndicator)
            return true;
          if (sourceFile.externalModuleIndicator && !sourceFile.commonJsModuleIndicator)
            return false;
          var compilerOptions = program2.getCompilerOptions();
          if (compilerOptions.configFile) {
            return ts3.getEmitModuleKind(compilerOptions) < ts3.ModuleKind.ES2015;
          }
          for (var _i = 0, _a2 = program2.getSourceFiles(); _i < _a2.length; _i++) {
            var otherFile = _a2[_i];
            if (otherFile === sourceFile || !ts3.isSourceFileJS(otherFile) || program2.isSourceFileFromExternalLibrary(otherFile))
              continue;
            if (otherFile.commonJsModuleIndicator && !otherFile.externalModuleIndicator)
              return true;
            if (otherFile.externalModuleIndicator && !otherFile.commonJsModuleIndicator)
              return false;
          }
          return true;
        }
        function getNewImportFixes(program2, sourceFile, position, preferTypeOnlyImport, useRequire, moduleSymbols, host, preferences) {
          var isJs = ts3.isSourceFileJS(sourceFile);
          var compilerOptions = program2.getCompilerOptions();
          var moduleSpecifierResolutionHost = ts3.createModuleSpecifierResolutionHost(program2, host);
          return ts3.flatMap(moduleSymbols, function(exportInfo) {
            return ts3.moduleSpecifiers.getModuleSpecifiers(exportInfo.moduleSymbol, program2.getTypeChecker(), compilerOptions, sourceFile, moduleSpecifierResolutionHost, preferences).map(function(moduleSpecifier) {
              return exportInfo.exportedSymbolIsTypeOnly && isJs && position !== void 0 ? { kind: 1, moduleSpecifier, position, exportInfo } : { kind: 3, moduleSpecifier, importKind: getImportKind(sourceFile, exportInfo.exportKind, compilerOptions), useRequire, typeOnly: preferTypeOnlyImport, exportInfo };
            });
          });
        }
        function getFixesForAddImport(exportInfos, existingImports, program2, sourceFile, position, preferTypeOnlyImport, useRequire, host, preferences) {
          var existingDeclaration = ts3.firstDefined(existingImports, function(info) {
            return newImportInfoFromExistingSpecifier(info, preferTypeOnlyImport, useRequire);
          });
          return existingDeclaration ? [existingDeclaration] : getNewImportFixes(program2, sourceFile, position, preferTypeOnlyImport, useRequire, exportInfos, host, preferences);
        }
        function newImportInfoFromExistingSpecifier(_a2, preferTypeOnlyImport, useRequire) {
          var declaration = _a2.declaration, importKind = _a2.importKind;
          var moduleSpecifier = ts3.tryGetModuleSpecifierFromDeclaration(declaration);
          return moduleSpecifier ? { kind: 3, moduleSpecifier, importKind, typeOnly: preferTypeOnlyImport, useRequire } : void 0;
        }
        function getFixesInfo(context, errorCode, pos, useAutoImportProvider) {
          var symbolToken = ts3.getTokenAtPosition(context.sourceFile, pos);
          var info = errorCode === ts3.Diagnostics._0_refers_to_a_UMD_global_but_the_current_file_is_a_module_Consider_adding_an_import_instead.code ? getFixesInfoForUMDImport(context, symbolToken) : ts3.isIdentifier(symbolToken) ? getFixesInfoForNonUMDImport(context, symbolToken, useAutoImportProvider) : void 0;
          return info && __assign(__assign({}, info), { fixes: sortFixes(info.fixes, context.sourceFile, context.host) });
        }
        function sortFixes(fixes, sourceFile, host) {
          var allowsImportingSpecifier = ts3.createPackageJsonImportFilter(sourceFile, host).allowsImportingSpecifier;
          return ts3.sort(fixes, function(a2, b2) {
            return ts3.compareValues(a2.kind, b2.kind) || compareModuleSpecifiers(a2, b2, allowsImportingSpecifier);
          });
        }
        function getBestFix(fixes, sourceFile, host) {
          if (fixes[0].kind === 0 || fixes[0].kind === 2) {
            return fixes[0];
          }
          var allowsImportingSpecifier = ts3.createPackageJsonImportFilter(sourceFile, host).allowsImportingSpecifier;
          return fixes.reduce(function(best, fix) {
            return compareModuleSpecifiers(fix, best, allowsImportingSpecifier) === -1 ? fix : best;
          });
        }
        function compareModuleSpecifiers(a2, b2, allowsImportingSpecifier) {
          if (a2.kind !== 0 && b2.kind !== 0) {
            return ts3.compareBooleans(allowsImportingSpecifier(a2.moduleSpecifier), allowsImportingSpecifier(b2.moduleSpecifier)) || ts3.compareNumberOfDirectorySeparators(a2.moduleSpecifier, b2.moduleSpecifier);
          }
          return 0;
        }
        function getFixesInfoForUMDImport(_a2, token) {
          var sourceFile = _a2.sourceFile, program2 = _a2.program, host = _a2.host, preferences = _a2.preferences;
          var checker = program2.getTypeChecker();
          var umdSymbol = getUmdSymbol(token, checker);
          if (!umdSymbol)
            return void 0;
          var symbol = checker.getAliasedSymbol(umdSymbol);
          var symbolName = umdSymbol.name;
          var exportInfos = [{ symbol: umdSymbol, moduleSymbol: symbol, exportKind: 3, exportedSymbolIsTypeOnly: false, isFromPackageJson: false }];
          var useRequire = shouldUseRequire(sourceFile, program2);
          var fixes = getImportFixes(exportInfos, symbolName, ts3.isIdentifier(token) ? token.getStart(sourceFile) : void 0, false, useRequire, program2, sourceFile, host, preferences);
          return { fixes, symbolName };
        }
        function getUmdSymbol(token, checker) {
          var umdSymbol = ts3.isIdentifier(token) ? checker.getSymbolAtLocation(token) : void 0;
          if (ts3.isUMDExportSymbol(umdSymbol))
            return umdSymbol;
          var parent = token.parent;
          return ts3.isJsxOpeningLikeElement(parent) && parent.tagName === token || ts3.isJsxOpeningFragment(parent) ? ts3.tryCast(checker.resolveName(checker.getJsxNamespace(parent), ts3.isJsxOpeningLikeElement(parent) ? token : parent, 111551, false), ts3.isUMDExportSymbol) : void 0;
        }
        function getImportKind(importingFile, exportKind, compilerOptions) {
          switch (exportKind) {
            case 0:
              return 0;
            case 1:
              return 1;
            case 2:
              return getExportEqualsImportKind(importingFile, compilerOptions);
            case 3:
              return getUmdImportKind(importingFile, compilerOptions);
            default:
              return ts3.Debug.assertNever(exportKind);
          }
        }
        codefix2.getImportKind = getImportKind;
        function getUmdImportKind(importingFile, compilerOptions) {
          if (ts3.getAllowSyntheticDefaultImports(compilerOptions)) {
            return 1;
          }
          var moduleKind = ts3.getEmitModuleKind(compilerOptions);
          switch (moduleKind) {
            case ts3.ModuleKind.AMD:
            case ts3.ModuleKind.CommonJS:
            case ts3.ModuleKind.UMD:
              if (ts3.isInJSFile(importingFile)) {
                return ts3.isExternalModule(importingFile) ? 2 : 3;
              }
              return 3;
            case ts3.ModuleKind.System:
            case ts3.ModuleKind.ES2015:
            case ts3.ModuleKind.ES2020:
            case ts3.ModuleKind.ESNext:
            case ts3.ModuleKind.None:
              return 2;
            default:
              return ts3.Debug.assertNever(moduleKind, "Unexpected moduleKind " + moduleKind);
          }
        }
        function getFixesInfoForNonUMDImport(_a2, symbolToken, useAutoImportProvider) {
          var sourceFile = _a2.sourceFile, program2 = _a2.program, cancellationToken = _a2.cancellationToken, host = _a2.host, preferences = _a2.preferences;
          var checker = program2.getTypeChecker();
          var compilerOptions = program2.getCompilerOptions();
          var symbolName = getSymbolName(sourceFile, checker, symbolToken, compilerOptions);
          ts3.Debug.assert(symbolName !== "default", "'default' isn't a legal identifier and couldn't occur here");
          var preferTypeOnlyImport = compilerOptions.importsNotUsedAsValues === 2 && ts3.isValidTypeOnlyAliasUseSite(symbolToken);
          var useRequire = shouldUseRequire(sourceFile, program2);
          var exportInfos = getExportInfos(symbolName, ts3.getMeaningFromLocation(symbolToken), cancellationToken, sourceFile, program2, useAutoImportProvider, host);
          var fixes = ts3.arrayFrom(ts3.flatMapIterator(exportInfos.entries(), function(_a3) {
            var _ = _a3[0], exportInfos2 = _a3[1];
            return getImportFixes(exportInfos2, symbolName, symbolToken.getStart(sourceFile), preferTypeOnlyImport, useRequire, program2, sourceFile, host, preferences);
          }));
          return { fixes, symbolName };
        }
        function getSymbolName(sourceFile, checker, symbolToken, compilerOptions) {
          var parent = symbolToken.parent;
          if ((ts3.isJsxOpeningLikeElement(parent) || ts3.isJsxClosingElement(parent)) && parent.tagName === symbolToken && compilerOptions.jsx !== 4 && compilerOptions.jsx !== 5) {
            var jsxNamespace = checker.getJsxNamespace(sourceFile);
            if (ts3.isIntrinsicJsxName(symbolToken.text) || !checker.resolveName(jsxNamespace, parent, 111551, true)) {
              return jsxNamespace;
            }
          }
          return symbolToken.text;
        }
        function getExportInfos(symbolName, currentTokenMeaning, cancellationToken, fromFile, program2, useAutoImportProvider, host) {
          var _a2;
          var originalSymbolToExportInfos = ts3.createMultiMap();
          var packageJsonFilter = ts3.createPackageJsonImportFilter(fromFile, host);
          var moduleSpecifierCache = (_a2 = host.getModuleSpecifierCache) === null || _a2 === void 0 ? void 0 : _a2.call(host);
          var getModuleSpecifierResolutionHost = ts3.memoizeOne(function(isFromPackageJson) {
            return ts3.createModuleSpecifierResolutionHost(isFromPackageJson ? host.getPackageJsonAutoImportProvider() : program2, host);
          });
          function addSymbol(moduleSymbol, toFile, exportedSymbol, exportKind, program3, isFromPackageJson) {
            var moduleSpecifierResolutionHost = getModuleSpecifierResolutionHost(isFromPackageJson);
            if (toFile && ts3.isImportableFile(program3, fromFile, toFile, packageJsonFilter, moduleSpecifierResolutionHost, moduleSpecifierCache) || !toFile && packageJsonFilter.allowsImportingAmbientModule(moduleSymbol, moduleSpecifierResolutionHost)) {
              var checker = program3.getTypeChecker();
              originalSymbolToExportInfos.add(ts3.getUniqueSymbolId(exportedSymbol, checker).toString(), { symbol: exportedSymbol, moduleSymbol, exportKind, exportedSymbolIsTypeOnly: isTypeOnlySymbol(exportedSymbol, checker), isFromPackageJson });
            }
          }
          forEachExternalModuleToImportFrom(program2, host, useAutoImportProvider, function(moduleSymbol, sourceFile, program3, isFromPackageJson) {
            var checker = program3.getTypeChecker();
            cancellationToken.throwIfCancellationRequested();
            var compilerOptions = program3.getCompilerOptions();
            var defaultInfo = getDefaultLikeExportInfo(moduleSymbol, checker, compilerOptions);
            if (defaultInfo && (defaultInfo.name === symbolName || moduleSymbolToValidIdentifier(moduleSymbol, compilerOptions.target) === symbolName) && symbolHasMeaning(defaultInfo.symbolForMeaning, currentTokenMeaning)) {
              addSymbol(moduleSymbol, sourceFile, defaultInfo.symbol, defaultInfo.exportKind, program3, isFromPackageJson);
            }
            var exportSymbolWithIdenticalName = checker.tryGetMemberInModuleExportsAndProperties(symbolName, moduleSymbol);
            if (exportSymbolWithIdenticalName && symbolHasMeaning(exportSymbolWithIdenticalName, currentTokenMeaning)) {
              addSymbol(moduleSymbol, sourceFile, exportSymbolWithIdenticalName, 0, program3, isFromPackageJson);
            }
          });
          return originalSymbolToExportInfos;
        }
        function getDefaultLikeExportInfo(moduleSymbol, checker, compilerOptions) {
          var exported = getDefaultLikeExportWorker(moduleSymbol, checker);
          if (!exported)
            return void 0;
          var symbol = exported.symbol, exportKind = exported.exportKind;
          var info = getDefaultExportInfoWorker(symbol, checker, compilerOptions);
          return info && __assign({ symbol, exportKind }, info);
        }
        function getDefaultLikeExportWorker(moduleSymbol, checker) {
          var exportEquals = checker.resolveExternalModuleSymbol(moduleSymbol);
          if (exportEquals !== moduleSymbol)
            return { symbol: exportEquals, exportKind: 2 };
          var defaultExport = checker.tryGetMemberInModuleExports("default", moduleSymbol);
          if (defaultExport)
            return { symbol: defaultExport, exportKind: 1 };
        }
        function getExportEqualsImportKind(importingFile, compilerOptions) {
          var allowSyntheticDefaults = ts3.getAllowSyntheticDefaultImports(compilerOptions);
          if (ts3.getEmitModuleKind(compilerOptions) >= ts3.ModuleKind.ES2015) {
            return allowSyntheticDefaults ? 1 : 2;
          }
          if (ts3.isInJSFile(importingFile)) {
            return ts3.isExternalModule(importingFile) ? 1 : 3;
          }
          for (var _i = 0, _a2 = importingFile.statements; _i < _a2.length; _i++) {
            var statement = _a2[_i];
            if (ts3.isImportEqualsDeclaration(statement) && !ts3.nodeIsMissing(statement.moduleReference)) {
              return 3;
            }
          }
          return allowSyntheticDefaults ? 1 : 3;
        }
        function getDefaultExportInfoWorker(defaultExport, checker, compilerOptions) {
          var localSymbol = ts3.getLocalSymbolForExportDefault(defaultExport);
          if (localSymbol)
            return { symbolForMeaning: localSymbol, name: localSymbol.name };
          var name = getNameForExportDefault(defaultExport);
          if (name !== void 0)
            return { symbolForMeaning: defaultExport, name };
          if (defaultExport.flags & 2097152) {
            var aliased = checker.getImmediateAliasedSymbol(defaultExport);
            if (aliased && aliased.parent) {
              return getDefaultExportInfoWorker(aliased, checker, compilerOptions);
            }
          }
          if (defaultExport.escapedName !== "default" && defaultExport.escapedName !== "export=") {
            return { symbolForMeaning: defaultExport, name: defaultExport.getName() };
          }
          return { symbolForMeaning: defaultExport, name: ts3.getNameForExportedSymbol(defaultExport, compilerOptions.target) };
        }
        function getNameForExportDefault(symbol) {
          return symbol.declarations && ts3.firstDefined(symbol.declarations, function(declaration) {
            var _a2;
            if (ts3.isExportAssignment(declaration)) {
              return (_a2 = ts3.tryCast(ts3.skipOuterExpressions(declaration.expression), ts3.isIdentifier)) === null || _a2 === void 0 ? void 0 : _a2.text;
            } else if (ts3.isExportSpecifier(declaration)) {
              ts3.Debug.assert(declaration.name.text === "default", "Expected the specifier to be a default export");
              return declaration.propertyName && declaration.propertyName.text;
            }
          });
        }
        function codeActionForFix(context, sourceFile, symbolName, fix, quotePreference) {
          var diag;
          var changes = ts3.textChanges.ChangeTracker.with(context, function(tracker) {
            diag = codeActionForFixWorker(tracker, sourceFile, symbolName, fix, quotePreference);
          });
          return codefix2.createCodeFixAction(codefix2.importFixName, changes, diag, importFixId, ts3.Diagnostics.Add_all_missing_imports);
        }
        function codeActionForFixWorker(changes, sourceFile, symbolName, fix, quotePreference) {
          switch (fix.kind) {
            case 0:
              addNamespaceQualifier(changes, sourceFile, fix);
              return [ts3.Diagnostics.Change_0_to_1, symbolName, fix.namespacePrefix + "." + symbolName];
            case 1:
              addImportType(changes, sourceFile, fix, quotePreference);
              return [ts3.Diagnostics.Change_0_to_1, symbolName, getImportTypePrefix(fix.moduleSpecifier, quotePreference) + symbolName];
            case 2: {
              var importClauseOrBindingPattern = fix.importClauseOrBindingPattern, importKind = fix.importKind, canUseTypeOnlyImport = fix.canUseTypeOnlyImport, moduleSpecifier = fix.moduleSpecifier;
              doAddExistingFix(changes, sourceFile, importClauseOrBindingPattern, importKind === 1 ? symbolName : void 0, importKind === 0 ? [symbolName] : ts3.emptyArray, canUseTypeOnlyImport);
              var moduleSpecifierWithoutQuotes = ts3.stripQuotes(moduleSpecifier);
              return [importKind === 1 ? ts3.Diagnostics.Add_default_import_0_to_existing_import_declaration_from_1 : ts3.Diagnostics.Add_0_to_existing_import_declaration_from_1, symbolName, moduleSpecifierWithoutQuotes];
            }
            case 3: {
              var importKind = fix.importKind, moduleSpecifier = fix.moduleSpecifier, typeOnly = fix.typeOnly, useRequire = fix.useRequire;
              var getDeclarations = useRequire ? getNewRequires : getNewImports;
              var importsCollection = importKind === 1 ? { defaultImport: symbolName, typeOnly } : importKind === 0 ? { namedImports: [symbolName], typeOnly } : { namespaceLikeImport: { importKind, name: symbolName }, typeOnly };
              ts3.insertImports(changes, sourceFile, getDeclarations(moduleSpecifier, quotePreference, importsCollection), true);
              return [importKind === 1 ? ts3.Diagnostics.Import_default_0_from_module_1 : ts3.Diagnostics.Import_0_from_module_1, symbolName, moduleSpecifier];
            }
            default:
              return ts3.Debug.assertNever(fix, "Unexpected fix kind " + fix.kind);
          }
        }
        function doAddExistingFix(changes, sourceFile, clause, defaultImport, namedImports, canUseTypeOnlyImport) {
          if (clause.kind === 197) {
            if (defaultImport) {
              addElementToBindingPattern(clause, defaultImport, "default");
            }
            for (var _i = 0, namedImports_1 = namedImports; _i < namedImports_1.length; _i++) {
              var specifier = namedImports_1[_i];
              addElementToBindingPattern(clause, specifier, void 0);
            }
            return;
          }
          var convertTypeOnlyToRegular = !canUseTypeOnlyImport && clause.isTypeOnly;
          if (defaultImport) {
            ts3.Debug.assert(!clause.name, "Cannot add a default import to an import clause that already has one");
            changes.insertNodeAt(sourceFile, clause.getStart(sourceFile), ts3.factory.createIdentifier(defaultImport), { suffix: ", " });
          }
          if (namedImports.length) {
            var existingSpecifiers = clause.namedBindings && ts3.cast(clause.namedBindings, ts3.isNamedImports).elements;
            var newSpecifiers = ts3.stableSort(namedImports.map(function(name) {
              return ts3.factory.createImportSpecifier(void 0, ts3.factory.createIdentifier(name));
            }), ts3.OrganizeImports.compareImportOrExportSpecifiers);
            if ((existingSpecifiers === null || existingSpecifiers === void 0 ? void 0 : existingSpecifiers.length) && ts3.OrganizeImports.importSpecifiersAreSorted(existingSpecifiers)) {
              for (var _a2 = 0, newSpecifiers_1 = newSpecifiers; _a2 < newSpecifiers_1.length; _a2++) {
                var spec = newSpecifiers_1[_a2];
                var insertionIndex = ts3.OrganizeImports.getImportSpecifierInsertionIndex(existingSpecifiers, spec);
                var prevSpecifier = clause.namedBindings.elements[insertionIndex - 1];
                if (prevSpecifier) {
                  changes.insertNodeInListAfter(sourceFile, prevSpecifier, spec);
                } else {
                  changes.insertNodeBefore(sourceFile, existingSpecifiers[0], spec, !ts3.positionsAreOnSameLine(existingSpecifiers[0].getStart(), clause.parent.getStart(), sourceFile));
                }
              }
            } else if (existingSpecifiers === null || existingSpecifiers === void 0 ? void 0 : existingSpecifiers.length) {
              for (var _b = 0, newSpecifiers_2 = newSpecifiers; _b < newSpecifiers_2.length; _b++) {
                var spec = newSpecifiers_2[_b];
                changes.insertNodeInListAfter(sourceFile, ts3.last(existingSpecifiers), spec, existingSpecifiers);
              }
            } else {
              if (newSpecifiers.length) {
                var namedImports_2 = ts3.factory.createNamedImports(newSpecifiers);
                if (clause.namedBindings) {
                  changes.replaceNode(sourceFile, clause.namedBindings, namedImports_2);
                } else {
                  changes.insertNodeAfter(sourceFile, ts3.Debug.checkDefined(clause.name, "Import clause must have either named imports or a default import"), namedImports_2);
                }
              }
            }
          }
          if (convertTypeOnlyToRegular) {
            changes.delete(sourceFile, ts3.getTypeKeywordOfTypeOnlyImport(clause, sourceFile));
          }
          function addElementToBindingPattern(bindingPattern, name, propertyName) {
            var element = ts3.factory.createBindingElement(void 0, propertyName, name);
            if (bindingPattern.elements.length) {
              changes.insertNodeInListAfter(sourceFile, ts3.last(bindingPattern.elements), element);
            } else {
              changes.replaceNode(sourceFile, bindingPattern, ts3.factory.createObjectBindingPattern([element]));
            }
          }
        }
        function addNamespaceQualifier(changes, sourceFile, _a2) {
          var namespacePrefix = _a2.namespacePrefix, position = _a2.position;
          changes.insertText(sourceFile, position, namespacePrefix + ".");
        }
        function addImportType(changes, sourceFile, _a2, quotePreference) {
          var moduleSpecifier = _a2.moduleSpecifier, position = _a2.position;
          changes.insertText(sourceFile, position, getImportTypePrefix(moduleSpecifier, quotePreference));
        }
        function getImportTypePrefix(moduleSpecifier, quotePreference) {
          var quote = ts3.getQuoteFromPreference(quotePreference);
          return "import(" + quote + moduleSpecifier + quote + ").";
        }
        function getNewImports(moduleSpecifier, quotePreference, imports) {
          var _a2, _b;
          var quotedModuleSpecifier = ts3.makeStringLiteral(moduleSpecifier, quotePreference);
          var statements;
          if (imports.defaultImport !== void 0 || ((_a2 = imports.namedImports) === null || _a2 === void 0 ? void 0 : _a2.length)) {
            statements = ts3.combine(statements, ts3.makeImport(imports.defaultImport === void 0 ? void 0 : ts3.factory.createIdentifier(imports.defaultImport), (_b = imports.namedImports) === null || _b === void 0 ? void 0 : _b.map(function(n2) {
              return ts3.factory.createImportSpecifier(void 0, ts3.factory.createIdentifier(n2));
            }), moduleSpecifier, quotePreference, imports.typeOnly));
          }
          var namespaceLikeImport = imports.namespaceLikeImport, typeOnly = imports.typeOnly;
          if (namespaceLikeImport) {
            var declaration = namespaceLikeImport.importKind === 3 ? ts3.factory.createImportEqualsDeclaration(void 0, void 0, typeOnly, ts3.factory.createIdentifier(namespaceLikeImport.name), ts3.factory.createExternalModuleReference(quotedModuleSpecifier)) : ts3.factory.createImportDeclaration(void 0, void 0, ts3.factory.createImportClause(typeOnly, void 0, ts3.factory.createNamespaceImport(ts3.factory.createIdentifier(namespaceLikeImport.name))), quotedModuleSpecifier);
            statements = ts3.combine(statements, declaration);
          }
          return ts3.Debug.checkDefined(statements);
        }
        function getNewRequires(moduleSpecifier, quotePreference, imports) {
          var _a2, _b;
          var quotedModuleSpecifier = ts3.makeStringLiteral(moduleSpecifier, quotePreference);
          var statements;
          if (imports.defaultImport || ((_a2 = imports.namedImports) === null || _a2 === void 0 ? void 0 : _a2.length)) {
            var bindingElements = ((_b = imports.namedImports) === null || _b === void 0 ? void 0 : _b.map(function(name) {
              return ts3.factory.createBindingElement(void 0, void 0, name);
            })) || [];
            if (imports.defaultImport) {
              bindingElements.unshift(ts3.factory.createBindingElement(void 0, "default", imports.defaultImport));
            }
            var declaration = createConstEqualsRequireDeclaration(ts3.factory.createObjectBindingPattern(bindingElements), quotedModuleSpecifier);
            statements = ts3.combine(statements, declaration);
          }
          if (imports.namespaceLikeImport) {
            var declaration = createConstEqualsRequireDeclaration(imports.namespaceLikeImport.name, quotedModuleSpecifier);
            statements = ts3.combine(statements, declaration);
          }
          return ts3.Debug.checkDefined(statements);
        }
        function createConstEqualsRequireDeclaration(name, quotedModuleSpecifier) {
          return ts3.factory.createVariableStatement(void 0, ts3.factory.createVariableDeclarationList([
            ts3.factory.createVariableDeclaration(typeof name === "string" ? ts3.factory.createIdentifier(name) : name, void 0, void 0, ts3.factory.createCallExpression(ts3.factory.createIdentifier("require"), void 0, [quotedModuleSpecifier]))
          ], 2));
        }
        function symbolHasMeaning(_a2, meaning) {
          var declarations = _a2.declarations;
          return ts3.some(declarations, function(decl) {
            return !!(ts3.getMeaningFromDeclaration(decl) & meaning);
          });
        }
        function forEachExternalModuleToImportFrom(program2, host, useAutoImportProvider, cb2) {
          var _a2, _b;
          forEachExternalModule(program2.getTypeChecker(), program2.getSourceFiles(), function(module3, file) {
            return cb2(module3, file, program2, false);
          });
          var autoImportProvider = useAutoImportProvider && ((_a2 = host.getPackageJsonAutoImportProvider) === null || _a2 === void 0 ? void 0 : _a2.call(host));
          if (autoImportProvider) {
            var start = ts3.timestamp();
            forEachExternalModule(autoImportProvider.getTypeChecker(), autoImportProvider.getSourceFiles(), function(module3, file) {
              return cb2(module3, file, autoImportProvider, true);
            });
            (_b = host.log) === null || _b === void 0 ? void 0 : _b.call(host, "forEachExternalModuleToImportFrom autoImportProvider: " + (ts3.timestamp() - start));
          }
        }
        codefix2.forEachExternalModuleToImportFrom = forEachExternalModuleToImportFrom;
        function forEachExternalModule(checker, allSourceFiles, cb2) {
          for (var _i = 0, _a2 = checker.getAmbientModules(); _i < _a2.length; _i++) {
            var ambient = _a2[_i];
            if (!ts3.stringContains(ambient.name, "*")) {
              cb2(ambient, void 0);
            }
          }
          for (var _b = 0, allSourceFiles_1 = allSourceFiles; _b < allSourceFiles_1.length; _b++) {
            var sourceFile = allSourceFiles_1[_b];
            if (ts3.isExternalOrCommonJsModule(sourceFile)) {
              cb2(checker.getMergedSymbol(sourceFile.symbol), sourceFile);
            }
          }
        }
        function moduleSymbolToValidIdentifier(moduleSymbol, target) {
          return moduleSpecifierToValidIdentifier(ts3.removeFileExtension(ts3.stripQuotes(moduleSymbol.name)), target);
        }
        codefix2.moduleSymbolToValidIdentifier = moduleSymbolToValidIdentifier;
        function moduleSpecifierToValidIdentifier(moduleSpecifier, target) {
          var baseName = ts3.getBaseFileName(ts3.removeSuffix(moduleSpecifier, "/index"));
          var res = "";
          var lastCharWasValid = true;
          var firstCharCode = baseName.charCodeAt(0);
          if (ts3.isIdentifierStart(firstCharCode, target)) {
            res += String.fromCharCode(firstCharCode);
          } else {
            lastCharWasValid = false;
          }
          for (var i3 = 1; i3 < baseName.length; i3++) {
            var ch = baseName.charCodeAt(i3);
            var isValid = ts3.isIdentifierPart(ch, target);
            if (isValid) {
              var char = String.fromCharCode(ch);
              if (!lastCharWasValid) {
                char = char.toUpperCase();
              }
              res += char;
            }
            lastCharWasValid = isValid;
          }
          return !ts3.isStringANonContextualKeyword(res) ? res || "_" : "_" + res;
        }
        codefix2.moduleSpecifierToValidIdentifier = moduleSpecifierToValidIdentifier;
      })(codefix = ts3.codefix || (ts3.codefix = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var codefix;
      (function(codefix2) {
        var _a2;
        var fixName = "fixOverrideModifier";
        var fixAddOverrideId = "fixAddOverrideModifier";
        var fixRemoveOverrideId = "fixRemoveOverrideModifier";
        var errorCodes = [
          ts3.Diagnostics.This_member_cannot_have_an_override_modifier_because_it_is_not_declared_in_the_base_class_0.code,
          ts3.Diagnostics.This_member_cannot_have_an_override_modifier_because_its_containing_class_0_does_not_extend_another_class.code,
          ts3.Diagnostics.This_member_must_have_an_override_modifier_because_it_overrides_an_abstract_method_that_is_declared_in_the_base_class_0.code,
          ts3.Diagnostics.This_member_must_have_an_override_modifier_because_it_overrides_a_member_in_the_base_class_0.code,
          ts3.Diagnostics.This_parameter_property_must_have_an_override_modifier_because_it_overrides_a_member_in_base_class_0.code
        ];
        var errorCodeFixIdMap = (_a2 = {}, _a2[ts3.Diagnostics.This_member_must_have_an_override_modifier_because_it_overrides_a_member_in_the_base_class_0.code] = [
          ts3.Diagnostics.Add_override_modifier,
          fixAddOverrideId,
          ts3.Diagnostics.Add_all_missing_override_modifiers
        ], _a2[ts3.Diagnostics.This_member_cannot_have_an_override_modifier_because_its_containing_class_0_does_not_extend_another_class.code] = [
          ts3.Diagnostics.Remove_override_modifier,
          fixRemoveOverrideId,
          ts3.Diagnostics.Remove_all_unnecessary_override_modifiers
        ], _a2[ts3.Diagnostics.This_parameter_property_must_have_an_override_modifier_because_it_overrides_a_member_in_base_class_0.code] = [
          ts3.Diagnostics.Add_override_modifier,
          fixAddOverrideId,
          ts3.Diagnostics.Add_all_missing_override_modifiers
        ], _a2[ts3.Diagnostics.This_member_must_have_an_override_modifier_because_it_overrides_an_abstract_method_that_is_declared_in_the_base_class_0.code] = [
          ts3.Diagnostics.Add_override_modifier,
          fixAddOverrideId,
          ts3.Diagnostics.Remove_all_unnecessary_override_modifiers
        ], _a2[ts3.Diagnostics.This_member_cannot_have_an_override_modifier_because_it_is_not_declared_in_the_base_class_0.code] = [
          ts3.Diagnostics.Remove_override_modifier,
          fixRemoveOverrideId,
          ts3.Diagnostics.Remove_all_unnecessary_override_modifiers
        ], _a2);
        codefix2.registerCodeFix({
          errorCodes,
          getCodeActions: function(context) {
            var errorCode = context.errorCode, span = context.span, sourceFile = context.sourceFile;
            var info = errorCodeFixIdMap[errorCode];
            if (!info)
              return ts3.emptyArray;
            var descriptions = info[0], fixId = info[1], fixAllDescriptions = info[2];
            if (ts3.isSourceFileJS(sourceFile))
              return ts3.emptyArray;
            var changes = ts3.textChanges.ChangeTracker.with(context, function(changes2) {
              return dispatchChanges(changes2, context, errorCode, span.start);
            });
            return [
              codefix2.createCodeFixActionMaybeFixAll(fixName, changes, descriptions, fixId, fixAllDescriptions)
            ];
          },
          fixIds: [fixName, fixAddOverrideId, fixRemoveOverrideId],
          getAllCodeActions: function(context) {
            return codefix2.codeFixAll(context, errorCodes, function(changes, diag) {
              var code = diag.code, start = diag.start, file = diag.file;
              var info = errorCodeFixIdMap[code];
              if (!info || info[1] !== context.fixId || ts3.isSourceFileJS(file)) {
                return;
              }
              dispatchChanges(changes, context, code, start);
            });
          }
        });
        function dispatchChanges(changeTracker, context, errorCode, pos) {
          switch (errorCode) {
            case ts3.Diagnostics.This_member_must_have_an_override_modifier_because_it_overrides_a_member_in_the_base_class_0.code:
            case ts3.Diagnostics.This_member_must_have_an_override_modifier_because_it_overrides_an_abstract_method_that_is_declared_in_the_base_class_0.code:
            case ts3.Diagnostics.This_parameter_property_must_have_an_override_modifier_because_it_overrides_a_member_in_base_class_0.code:
              return doAddOverrideModifierChange(changeTracker, context.sourceFile, pos);
            case ts3.Diagnostics.This_member_cannot_have_an_override_modifier_because_it_is_not_declared_in_the_base_class_0.code:
            case ts3.Diagnostics.This_member_cannot_have_an_override_modifier_because_its_containing_class_0_does_not_extend_another_class.code:
              return doRemoveOverrideModifierChange(changeTracker, context.sourceFile, pos);
            default:
              ts3.Debug.fail("Unexpected error code: " + errorCode);
          }
        }
        function doAddOverrideModifierChange(changeTracker, sourceFile, pos) {
          var classElement = findContainerClassElementLike(sourceFile, pos);
          var modifiers = classElement.modifiers || ts3.emptyArray;
          var staticModifier = ts3.find(modifiers, ts3.isStaticModifier);
          var accessibilityModifier = ts3.find(modifiers, function(m) {
            return ts3.isAccessibilityModifier(m.kind);
          });
          var modifierPos = staticModifier ? staticModifier.end : accessibilityModifier ? accessibilityModifier.end : classElement.decorators ? ts3.skipTrivia(sourceFile.text, classElement.decorators.end) : classElement.getStart(sourceFile);
          var options = accessibilityModifier || staticModifier ? { prefix: " " } : { suffix: " " };
          changeTracker.insertModifierAt(sourceFile, modifierPos, 156, options);
        }
        function doRemoveOverrideModifierChange(changeTracker, sourceFile, pos) {
          var classElement = findContainerClassElementLike(sourceFile, pos);
          var overrideModifier = classElement.modifiers && ts3.find(classElement.modifiers, function(modifier) {
            return modifier.kind === 156;
          });
          ts3.Debug.assertIsDefined(overrideModifier);
          changeTracker.deleteModifier(sourceFile, overrideModifier);
        }
        function isClassElementLikeHasJSDoc(node) {
          switch (node.kind) {
            case 167:
            case 164:
            case 166:
            case 168:
            case 169:
              return true;
            case 161:
              return ts3.isParameterPropertyDeclaration(node, node.parent);
            default:
              return false;
          }
        }
        function findContainerClassElementLike(sourceFile, pos) {
          var token = ts3.getTokenAtPosition(sourceFile, pos);
          var classElement = ts3.findAncestor(token, function(node) {
            if (ts3.isClassLike(node))
              return "quit";
            return isClassElementLikeHasJSDoc(node);
          });
          ts3.Debug.assert(classElement && isClassElementLikeHasJSDoc(classElement));
          return classElement;
        }
      })(codefix = ts3.codefix || (ts3.codefix = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var codefix;
      (function(codefix2) {
        var fixId = "fixNoPropertyAccessFromIndexSignature";
        var errorCodes = [
          ts3.Diagnostics.Property_0_comes_from_an_index_signature_so_it_must_be_accessed_with_0.code
        ];
        codefix2.registerCodeFix({
          errorCodes,
          fixIds: [fixId],
          getCodeActions: function(context) {
            var sourceFile = context.sourceFile, span = context.span, preferences = context.preferences;
            var property = getPropertyAccessExpression(sourceFile, span.start);
            var changes = ts3.textChanges.ChangeTracker.with(context, function(t2) {
              return doChange(t2, context.sourceFile, property, preferences);
            });
            return [codefix2.createCodeFixAction(fixId, changes, [ts3.Diagnostics.Use_element_access_for_0, property.name.text], fixId, ts3.Diagnostics.Use_element_access_for_all_undeclared_properties)];
          },
          getAllCodeActions: function(context) {
            return codefix2.codeFixAll(context, errorCodes, function(changes, diag) {
              return doChange(changes, diag.file, getPropertyAccessExpression(diag.file, diag.start), context.preferences);
            });
          }
        });
        function doChange(changes, sourceFile, node, preferences) {
          var quotePreference = ts3.getQuotePreference(sourceFile, preferences);
          var argumentsExpression = ts3.factory.createStringLiteral(node.name.text, quotePreference === 0);
          changes.replaceNode(sourceFile, node, ts3.isPropertyAccessChain(node) ? ts3.factory.createElementAccessChain(node.expression, node.questionDotToken, argumentsExpression) : ts3.factory.createElementAccessExpression(node.expression, argumentsExpression));
        }
        function getPropertyAccessExpression(sourceFile, pos) {
          return ts3.cast(ts3.getTokenAtPosition(sourceFile, pos).parent, ts3.isPropertyAccessExpression);
        }
      })(codefix = ts3.codefix || (ts3.codefix = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var codefix;
      (function(codefix2) {
        var fixId = "fixImplicitThis";
        var errorCodes = [ts3.Diagnostics.this_implicitly_has_type_any_because_it_does_not_have_a_type_annotation.code];
        codefix2.registerCodeFix({
          errorCodes,
          getCodeActions: function(context) {
            var sourceFile = context.sourceFile, program2 = context.program, span = context.span;
            var diagnostic;
            var changes = ts3.textChanges.ChangeTracker.with(context, function(t2) {
              diagnostic = doChange(t2, sourceFile, span.start, program2.getTypeChecker());
            });
            return diagnostic ? [codefix2.createCodeFixAction(fixId, changes, diagnostic, fixId, ts3.Diagnostics.Fix_all_implicit_this_errors)] : ts3.emptyArray;
          },
          fixIds: [fixId],
          getAllCodeActions: function(context) {
            return codefix2.codeFixAll(context, errorCodes, function(changes, diag) {
              doChange(changes, diag.file, diag.start, context.program.getTypeChecker());
            });
          }
        });
        function doChange(changes, sourceFile, pos, checker) {
          var token = ts3.getTokenAtPosition(sourceFile, pos);
          ts3.Debug.assert(token.kind === 107);
          var fn = ts3.getThisContainer(token, false);
          if (!ts3.isFunctionDeclaration(fn) && !ts3.isFunctionExpression(fn))
            return void 0;
          if (!ts3.isSourceFile(ts3.getThisContainer(fn, false))) {
            var fnKeyword = ts3.Debug.assertDefined(ts3.findChildOfKind(fn, 97, sourceFile));
            var name = fn.name;
            var body = ts3.Debug.assertDefined(fn.body);
            if (ts3.isFunctionExpression(fn)) {
              if (name && ts3.FindAllReferences.Core.isSymbolReferencedInFile(name, checker, sourceFile, body)) {
                return void 0;
              }
              changes.delete(sourceFile, fnKeyword);
              if (name) {
                changes.delete(sourceFile, name);
              }
              changes.insertText(sourceFile, body.pos, " =>");
              return [ts3.Diagnostics.Convert_function_expression_0_to_arrow_function, name ? name.text : ts3.ANONYMOUS];
            } else {
              changes.replaceNode(sourceFile, fnKeyword, ts3.factory.createToken(84));
              changes.insertText(sourceFile, name.end, " = ");
              changes.insertText(sourceFile, body.pos, " =>");
              return [ts3.Diagnostics.Convert_function_declaration_0_to_arrow_function, name.text];
            }
          }
        }
      })(codefix = ts3.codefix || (ts3.codefix = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var codefix;
      (function(codefix2) {
        var fixId = "fixIncorrectNamedTupleSyntax";
        var errorCodes = [
          ts3.Diagnostics.A_labeled_tuple_element_is_declared_as_optional_with_a_question_mark_after_the_name_and_before_the_colon_rather_than_after_the_type.code,
          ts3.Diagnostics.A_labeled_tuple_element_is_declared_as_rest_with_a_before_the_name_rather_than_before_the_type.code
        ];
        codefix2.registerCodeFix({
          errorCodes,
          getCodeActions: function(context) {
            var sourceFile = context.sourceFile, span = context.span;
            var namedTupleMember = getNamedTupleMember(sourceFile, span.start);
            var changes = ts3.textChanges.ChangeTracker.with(context, function(t2) {
              return doChange(t2, sourceFile, namedTupleMember);
            });
            return [codefix2.createCodeFixAction(fixId, changes, ts3.Diagnostics.Move_labeled_tuple_element_modifiers_to_labels, fixId, ts3.Diagnostics.Move_labeled_tuple_element_modifiers_to_labels)];
          },
          fixIds: [fixId]
        });
        function getNamedTupleMember(sourceFile, pos) {
          var token = ts3.getTokenAtPosition(sourceFile, pos);
          return ts3.findAncestor(token, function(t2) {
            return t2.kind === 193;
          });
        }
        function doChange(changes, sourceFile, namedTupleMember) {
          if (!namedTupleMember) {
            return;
          }
          var unwrappedType = namedTupleMember.type;
          var sawOptional = false;
          var sawRest = false;
          while (unwrappedType.kind === 181 || unwrappedType.kind === 182 || unwrappedType.kind === 187) {
            if (unwrappedType.kind === 181) {
              sawOptional = true;
            } else if (unwrappedType.kind === 182) {
              sawRest = true;
            }
            unwrappedType = unwrappedType.type;
          }
          var updated = ts3.factory.updateNamedTupleMember(namedTupleMember, namedTupleMember.dotDotDotToken || (sawRest ? ts3.factory.createToken(25) : void 0), namedTupleMember.name, namedTupleMember.questionToken || (sawOptional ? ts3.factory.createToken(57) : void 0), unwrappedType);
          if (updated === namedTupleMember) {
            return;
          }
          changes.replaceNode(sourceFile, namedTupleMember, updated);
        }
      })(codefix = ts3.codefix || (ts3.codefix = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var codefix;
      (function(codefix2) {
        var fixId = "fixSpelling";
        var errorCodes = [
          ts3.Diagnostics.Property_0_does_not_exist_on_type_1_Did_you_mean_2.code,
          ts3.Diagnostics.Cannot_find_name_0_Did_you_mean_1.code,
          ts3.Diagnostics.Cannot_find_name_0_Did_you_mean_the_instance_member_this_0.code,
          ts3.Diagnostics.Cannot_find_name_0_Did_you_mean_the_static_member_1_0.code,
          ts3.Diagnostics._0_has_no_exported_member_named_1_Did_you_mean_2.code,
          ts3.Diagnostics.No_overload_matches_this_call.code,
          ts3.Diagnostics.Type_0_is_not_assignable_to_type_1.code
        ];
        codefix2.registerCodeFix({
          errorCodes,
          getCodeActions: function(context) {
            var sourceFile = context.sourceFile, errorCode = context.errorCode;
            var info = getInfo(sourceFile, context.span.start, context, errorCode);
            if (!info)
              return void 0;
            var node = info.node, suggestedSymbol = info.suggestedSymbol;
            var target = context.host.getCompilationSettings().target;
            var changes = ts3.textChanges.ChangeTracker.with(context, function(t2) {
              return doChange(t2, sourceFile, node, suggestedSymbol, target);
            });
            return [codefix2.createCodeFixAction("spelling", changes, [ts3.Diagnostics.Change_spelling_to_0, ts3.symbolName(suggestedSymbol)], fixId, ts3.Diagnostics.Fix_all_detected_spelling_errors)];
          },
          fixIds: [fixId],
          getAllCodeActions: function(context) {
            return codefix2.codeFixAll(context, errorCodes, function(changes, diag) {
              var info = getInfo(diag.file, diag.start, context, diag.code);
              var target = context.host.getCompilationSettings().target;
              if (info)
                doChange(changes, context.sourceFile, info.node, info.suggestedSymbol, target);
            });
          }
        });
        function getInfo(sourceFile, pos, context, errorCode) {
          var node = ts3.getTokenAtPosition(sourceFile, pos);
          var parent = node.parent;
          if ((errorCode === ts3.Diagnostics.No_overload_matches_this_call.code || errorCode === ts3.Diagnostics.Type_0_is_not_assignable_to_type_1.code) && !ts3.isJsxAttribute(parent))
            return void 0;
          var checker = context.program.getTypeChecker();
          var suggestedSymbol;
          if (ts3.isPropertyAccessExpression(parent) && parent.name === node) {
            ts3.Debug.assert(ts3.isMemberName(node), "Expected an identifier for spelling (property access)");
            var containingType = checker.getTypeAtLocation(parent.expression);
            if (parent.flags & 32) {
              containingType = checker.getNonNullableType(containingType);
            }
            suggestedSymbol = checker.getSuggestedSymbolForNonexistentProperty(node, containingType);
          } else if (ts3.isQualifiedName(parent) && parent.right === node) {
            var symbol = checker.getSymbolAtLocation(parent.left);
            if (symbol && symbol.flags & 1536) {
              suggestedSymbol = checker.getSuggestedSymbolForNonexistentModule(parent.right, symbol);
            }
          } else if (ts3.isImportSpecifier(parent) && parent.name === node) {
            ts3.Debug.assertNode(node, ts3.isIdentifier, "Expected an identifier for spelling (import)");
            var importDeclaration = ts3.findAncestor(node, ts3.isImportDeclaration);
            var resolvedSourceFile = getResolvedSourceFileFromImportDeclaration(sourceFile, context, importDeclaration);
            if (resolvedSourceFile && resolvedSourceFile.symbol) {
              suggestedSymbol = checker.getSuggestedSymbolForNonexistentModule(node, resolvedSourceFile.symbol);
            }
          } else if (ts3.isJsxAttribute(parent) && parent.name === node) {
            ts3.Debug.assertNode(node, ts3.isIdentifier, "Expected an identifier for JSX attribute");
            var tag = ts3.findAncestor(node, ts3.isJsxOpeningLikeElement);
            var props = checker.getContextualTypeForArgumentAtIndex(tag, 0);
            suggestedSymbol = checker.getSuggestedSymbolForNonexistentJSXAttribute(node, props);
          } else {
            var meaning = ts3.getMeaningFromLocation(node);
            var name = ts3.getTextOfNode(node);
            ts3.Debug.assert(name !== void 0, "name should be defined");
            suggestedSymbol = checker.getSuggestedSymbolForNonexistentSymbol(node, name, convertSemanticMeaningToSymbolFlags(meaning));
          }
          return suggestedSymbol === void 0 ? void 0 : { node, suggestedSymbol };
        }
        function doChange(changes, sourceFile, node, suggestedSymbol, target) {
          var suggestion = ts3.symbolName(suggestedSymbol);
          if (!ts3.isIdentifierText(suggestion, target) && ts3.isPropertyAccessExpression(node.parent)) {
            var valDecl = suggestedSymbol.valueDeclaration;
            if (valDecl && ts3.isNamedDeclaration(valDecl) && ts3.isPrivateIdentifier(valDecl.name)) {
              changes.replaceNode(sourceFile, node, ts3.factory.createIdentifier(suggestion));
            } else {
              changes.replaceNode(sourceFile, node.parent, ts3.factory.createElementAccessExpression(node.parent.expression, ts3.factory.createStringLiteral(suggestion)));
            }
          } else {
            changes.replaceNode(sourceFile, node, ts3.factory.createIdentifier(suggestion));
          }
        }
        function convertSemanticMeaningToSymbolFlags(meaning) {
          var flags = 0;
          if (meaning & 4) {
            flags |= 1920;
          }
          if (meaning & 2) {
            flags |= 788968;
          }
          if (meaning & 1) {
            flags |= 111551;
          }
          return flags;
        }
        function getResolvedSourceFileFromImportDeclaration(sourceFile, context, importDeclaration) {
          if (!importDeclaration || !ts3.isStringLiteralLike(importDeclaration.moduleSpecifier))
            return void 0;
          var resolvedModule = ts3.getResolvedModule(sourceFile, importDeclaration.moduleSpecifier.text);
          if (!resolvedModule)
            return void 0;
          return context.program.getSourceFile(resolvedModule.resolvedFileName);
        }
      })(codefix = ts3.codefix || (ts3.codefix = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var codefix;
      (function(codefix2) {
        var fixId = "returnValueCorrect";
        var fixIdAddReturnStatement = "fixAddReturnStatement";
        var fixRemoveBracesFromArrowFunctionBody = "fixRemoveBracesFromArrowFunctionBody";
        var fixIdWrapTheBlockWithParen = "fixWrapTheBlockWithParen";
        var errorCodes = [
          ts3.Diagnostics.A_function_whose_declared_type_is_neither_void_nor_any_must_return_a_value.code,
          ts3.Diagnostics.Type_0_is_not_assignable_to_type_1.code,
          ts3.Diagnostics.Argument_of_type_0_is_not_assignable_to_parameter_of_type_1.code
        ];
        var ProblemKind;
        (function(ProblemKind2) {
          ProblemKind2[ProblemKind2["MissingReturnStatement"] = 0] = "MissingReturnStatement";
          ProblemKind2[ProblemKind2["MissingParentheses"] = 1] = "MissingParentheses";
        })(ProblemKind || (ProblemKind = {}));
        codefix2.registerCodeFix({
          errorCodes,
          fixIds: [fixIdAddReturnStatement, fixRemoveBracesFromArrowFunctionBody, fixIdWrapTheBlockWithParen],
          getCodeActions: function(context) {
            var program2 = context.program, sourceFile = context.sourceFile, start = context.span.start, errorCode = context.errorCode;
            var info = getInfo(program2.getTypeChecker(), sourceFile, start, errorCode);
            if (!info)
              return void 0;
            if (info.kind === ProblemKind.MissingReturnStatement) {
              return ts3.append([getActionForfixAddReturnStatement(context, info.expression, info.statement)], ts3.isArrowFunction(info.declaration) ? getActionForFixRemoveBracesFromArrowFunctionBody(context, info.declaration, info.expression, info.commentSource) : void 0);
            } else {
              return [getActionForfixWrapTheBlockWithParen(context, info.declaration, info.expression)];
            }
          },
          getAllCodeActions: function(context) {
            return codefix2.codeFixAll(context, errorCodes, function(changes, diag) {
              var info = getInfo(context.program.getTypeChecker(), diag.file, diag.start, diag.code);
              if (!info)
                return void 0;
              switch (context.fixId) {
                case fixIdAddReturnStatement:
                  addReturnStatement(changes, diag.file, info.expression, info.statement);
                  break;
                case fixRemoveBracesFromArrowFunctionBody:
                  if (!ts3.isArrowFunction(info.declaration))
                    return void 0;
                  removeBlockBodyBrace(changes, diag.file, info.declaration, info.expression, info.commentSource, false);
                  break;
                case fixIdWrapTheBlockWithParen:
                  if (!ts3.isArrowFunction(info.declaration))
                    return void 0;
                  wrapBlockWithParen(changes, diag.file, info.declaration, info.expression);
                  break;
                default:
                  ts3.Debug.fail(JSON.stringify(context.fixId));
              }
            });
          }
        });
        function createObjectTypeFromLabeledExpression(checker, label, expression) {
          var member = checker.createSymbol(4, label.escapedText);
          member.type = checker.getTypeAtLocation(expression);
          var members = ts3.createSymbolTable([member]);
          return checker.createAnonymousType(void 0, members, [], [], void 0, void 0);
        }
        function getFixInfo(checker, declaration, expectType, isFunctionType) {
          if (!declaration.body || !ts3.isBlock(declaration.body) || ts3.length(declaration.body.statements) !== 1)
            return void 0;
          var firstStatement = ts3.first(declaration.body.statements);
          if (ts3.isExpressionStatement(firstStatement) && checkFixedAssignableTo(checker, declaration, checker.getTypeAtLocation(firstStatement.expression), expectType, isFunctionType)) {
            return {
              declaration,
              kind: ProblemKind.MissingReturnStatement,
              expression: firstStatement.expression,
              statement: firstStatement,
              commentSource: firstStatement.expression
            };
          } else if (ts3.isLabeledStatement(firstStatement) && ts3.isExpressionStatement(firstStatement.statement)) {
            var node = ts3.factory.createObjectLiteralExpression([ts3.factory.createPropertyAssignment(firstStatement.label, firstStatement.statement.expression)]);
            var nodeType = createObjectTypeFromLabeledExpression(checker, firstStatement.label, firstStatement.statement.expression);
            if (checkFixedAssignableTo(checker, declaration, nodeType, expectType, isFunctionType)) {
              return ts3.isArrowFunction(declaration) ? {
                declaration,
                kind: ProblemKind.MissingParentheses,
                expression: node,
                statement: firstStatement,
                commentSource: firstStatement.statement.expression
              } : {
                declaration,
                kind: ProblemKind.MissingReturnStatement,
                expression: node,
                statement: firstStatement,
                commentSource: firstStatement.statement.expression
              };
            }
          } else if (ts3.isBlock(firstStatement) && ts3.length(firstStatement.statements) === 1) {
            var firstBlockStatement = ts3.first(firstStatement.statements);
            if (ts3.isLabeledStatement(firstBlockStatement) && ts3.isExpressionStatement(firstBlockStatement.statement)) {
              var node = ts3.factory.createObjectLiteralExpression([ts3.factory.createPropertyAssignment(firstBlockStatement.label, firstBlockStatement.statement.expression)]);
              var nodeType = createObjectTypeFromLabeledExpression(checker, firstBlockStatement.label, firstBlockStatement.statement.expression);
              if (checkFixedAssignableTo(checker, declaration, nodeType, expectType, isFunctionType)) {
                return {
                  declaration,
                  kind: ProblemKind.MissingReturnStatement,
                  expression: node,
                  statement: firstStatement,
                  commentSource: firstBlockStatement
                };
              }
            }
          }
          return void 0;
        }
        function checkFixedAssignableTo(checker, declaration, exprType, type3, isFunctionType) {
          if (isFunctionType) {
            var sig = checker.getSignatureFromDeclaration(declaration);
            if (sig) {
              if (ts3.hasSyntacticModifier(declaration, 256)) {
                exprType = checker.createPromiseType(exprType);
              }
              var newSig = checker.createSignature(declaration, sig.typeParameters, sig.thisParameter, sig.parameters, exprType, void 0, sig.minArgumentCount, sig.flags);
              exprType = checker.createAnonymousType(void 0, ts3.createSymbolTable(), [newSig], [], void 0, void 0);
            } else {
              exprType = checker.getAnyType();
            }
          }
          return checker.isTypeAssignableTo(exprType, type3);
        }
        function getInfo(checker, sourceFile, position, errorCode) {
          var node = ts3.getTokenAtPosition(sourceFile, position);
          if (!node.parent)
            return void 0;
          var declaration = ts3.findAncestor(node.parent, ts3.isFunctionLikeDeclaration);
          switch (errorCode) {
            case ts3.Diagnostics.A_function_whose_declared_type_is_neither_void_nor_any_must_return_a_value.code:
              if (!declaration || !declaration.body || !declaration.type || !ts3.rangeContainsRange(declaration.type, node))
                return void 0;
              return getFixInfo(checker, declaration, checker.getTypeFromTypeNode(declaration.type), false);
            case ts3.Diagnostics.Argument_of_type_0_is_not_assignable_to_parameter_of_type_1.code:
              if (!declaration || !ts3.isCallExpression(declaration.parent) || !declaration.body)
                return void 0;
              var pos = declaration.parent.arguments.indexOf(declaration);
              var type3 = checker.getContextualTypeForArgumentAtIndex(declaration.parent, pos);
              if (!type3)
                return void 0;
              return getFixInfo(checker, declaration, type3, true);
            case ts3.Diagnostics.Type_0_is_not_assignable_to_type_1.code:
              if (!ts3.isDeclarationName(node) || !ts3.isVariableLike(node.parent) && !ts3.isJsxAttribute(node.parent))
                return void 0;
              var initializer = getVariableLikeInitializer(node.parent);
              if (!initializer || !ts3.isFunctionLikeDeclaration(initializer) || !initializer.body)
                return void 0;
              return getFixInfo(checker, initializer, checker.getTypeAtLocation(node.parent), true);
          }
          return void 0;
        }
        function getVariableLikeInitializer(declaration) {
          switch (declaration.kind) {
            case 250:
            case 161:
            case 199:
            case 164:
            case 289:
              return declaration.initializer;
            case 281:
              return declaration.initializer && (ts3.isJsxExpression(declaration.initializer) ? declaration.initializer.expression : void 0);
            case 290:
            case 163:
            case 292:
            case 337:
            case 330:
              return void 0;
          }
        }
        function addReturnStatement(changes, sourceFile, expression, statement) {
          ts3.suppressLeadingAndTrailingTrivia(expression);
          var probablyNeedSemi = ts3.probablyUsesSemicolons(sourceFile);
          changes.replaceNode(sourceFile, statement, ts3.factory.createReturnStatement(expression), {
            leadingTriviaOption: ts3.textChanges.LeadingTriviaOption.Exclude,
            trailingTriviaOption: ts3.textChanges.TrailingTriviaOption.Exclude,
            suffix: probablyNeedSemi ? ";" : void 0
          });
        }
        function removeBlockBodyBrace(changes, sourceFile, declaration, expression, commentSource, withParen) {
          var newBody = withParen || ts3.needsParentheses(expression) ? ts3.factory.createParenthesizedExpression(expression) : expression;
          ts3.suppressLeadingAndTrailingTrivia(commentSource);
          ts3.copyComments(commentSource, newBody);
          changes.replaceNode(sourceFile, declaration.body, newBody);
        }
        function wrapBlockWithParen(changes, sourceFile, declaration, expression) {
          changes.replaceNode(sourceFile, declaration.body, ts3.factory.createParenthesizedExpression(expression));
        }
        function getActionForfixAddReturnStatement(context, expression, statement) {
          var changes = ts3.textChanges.ChangeTracker.with(context, function(t2) {
            return addReturnStatement(t2, context.sourceFile, expression, statement);
          });
          return codefix2.createCodeFixAction(fixId, changes, ts3.Diagnostics.Add_a_return_statement, fixIdAddReturnStatement, ts3.Diagnostics.Add_all_missing_return_statement);
        }
        function getActionForFixRemoveBracesFromArrowFunctionBody(context, declaration, expression, commentSource) {
          var changes = ts3.textChanges.ChangeTracker.with(context, function(t2) {
            return removeBlockBodyBrace(t2, context.sourceFile, declaration, expression, commentSource, false);
          });
          return codefix2.createCodeFixAction(fixId, changes, ts3.Diagnostics.Remove_braces_from_arrow_function_body, fixRemoveBracesFromArrowFunctionBody, ts3.Diagnostics.Remove_braces_from_all_arrow_function_bodies_with_relevant_issues);
        }
        function getActionForfixWrapTheBlockWithParen(context, declaration, expression) {
          var changes = ts3.textChanges.ChangeTracker.with(context, function(t2) {
            return wrapBlockWithParen(t2, context.sourceFile, declaration, expression);
          });
          return codefix2.createCodeFixAction(fixId, changes, ts3.Diagnostics.Wrap_the_following_body_with_parentheses_which_should_be_an_object_literal, fixIdWrapTheBlockWithParen, ts3.Diagnostics.Wrap_all_object_literal_with_parentheses);
        }
      })(codefix = ts3.codefix || (ts3.codefix = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var codefix;
      (function(codefix2) {
        var fixMissingMember = "fixMissingMember";
        var fixMissingFunctionDeclaration = "fixMissingFunctionDeclaration";
        var errorCodes = [
          ts3.Diagnostics.Property_0_does_not_exist_on_type_1.code,
          ts3.Diagnostics.Property_0_does_not_exist_on_type_1_Did_you_mean_2.code,
          ts3.Diagnostics.Property_0_is_missing_in_type_1_but_required_in_type_2.code,
          ts3.Diagnostics.Type_0_is_missing_the_following_properties_from_type_1_Colon_2.code,
          ts3.Diagnostics.Type_0_is_missing_the_following_properties_from_type_1_Colon_2_and_3_more.code,
          ts3.Diagnostics.Cannot_find_name_0.code
        ];
        codefix2.registerCodeFix({
          errorCodes,
          getCodeActions: function(context) {
            var typeChecker = context.program.getTypeChecker();
            var info = getInfo(context.sourceFile, context.span.start, typeChecker, context.program);
            if (!info) {
              return void 0;
            }
            if (info.kind === 2) {
              var changes = ts3.textChanges.ChangeTracker.with(context, function(t2) {
                return addFunctionDeclaration(t2, context, info);
              });
              return [codefix2.createCodeFixAction(fixMissingFunctionDeclaration, changes, [ts3.Diagnostics.Add_missing_function_declaration_0, info.token.text], fixMissingFunctionDeclaration, ts3.Diagnostics.Add_all_missing_function_declarations)];
            }
            if (info.kind === 0) {
              var changes = ts3.textChanges.ChangeTracker.with(context, function(t2) {
                return addEnumMemberDeclaration(t2, context.program.getTypeChecker(), info);
              });
              return [codefix2.createCodeFixAction(fixMissingMember, changes, [ts3.Diagnostics.Add_missing_enum_member_0, info.token.text], fixMissingMember, ts3.Diagnostics.Add_all_missing_members)];
            }
            return ts3.concatenate(getActionsForMissingMethodDeclaration(context, info), getActionsForMissingMemberDeclaration(context, info));
          },
          fixIds: [fixMissingMember, fixMissingFunctionDeclaration],
          getAllCodeActions: function(context) {
            var program2 = context.program, fixId = context.fixId;
            var checker = program2.getTypeChecker();
            var seen = new ts3.Map();
            var typeDeclToMembers = new ts3.Map();
            return codefix2.createCombinedCodeActions(ts3.textChanges.ChangeTracker.with(context, function(changes) {
              codefix2.eachDiagnostic(context, errorCodes, function(diag) {
                var info = getInfo(diag.file, diag.start, checker, context.program);
                if (!info || !ts3.addToSeen(seen, ts3.getNodeId(info.parentDeclaration) + "#" + info.token.text)) {
                  return;
                }
                if (fixId === fixMissingFunctionDeclaration) {
                  if (info.kind === 2) {
                    addFunctionDeclaration(changes, context, info);
                  }
                } else {
                  if (info.kind === 0) {
                    addEnumMemberDeclaration(changes, checker, info);
                  }
                  if (info.kind === 1) {
                    var parentDeclaration = info.parentDeclaration, token_1 = info.token;
                    var infos = ts3.getOrUpdate(typeDeclToMembers, parentDeclaration, function() {
                      return [];
                    });
                    if (!infos.some(function(i3) {
                      return i3.token.text === token_1.text;
                    })) {
                      infos.push(info);
                    }
                  }
                }
              });
              typeDeclToMembers.forEach(function(infos, classDeclaration) {
                var supers = codefix2.getAllSupers(classDeclaration, checker);
                var _loop_14 = function(info2) {
                  if (supers.some(function(superClassOrInterface) {
                    var superInfos = typeDeclToMembers.get(superClassOrInterface);
                    return !!superInfos && superInfos.some(function(_a2) {
                      var token2 = _a2.token;
                      return token2.text === info2.token.text;
                    });
                  }))
                    return "continue";
                  var parentDeclaration = info2.parentDeclaration, declSourceFile = info2.declSourceFile, modifierFlags = info2.modifierFlags, token = info2.token, call = info2.call, isJSFile = info2.isJSFile;
                  if (call && !ts3.isPrivateIdentifier(token)) {
                    addMethodDeclaration(context, changes, call, token, modifierFlags & 32, parentDeclaration, declSourceFile);
                  } else {
                    if (isJSFile && !ts3.isInterfaceDeclaration(parentDeclaration)) {
                      addMissingMemberInJs(changes, declSourceFile, parentDeclaration, token, !!(modifierFlags & 32));
                    } else {
                      var typeNode = getTypeNode(program2.getTypeChecker(), parentDeclaration, token);
                      addPropertyDeclaration(changes, declSourceFile, parentDeclaration, token.text, typeNode, modifierFlags & 32);
                    }
                  }
                };
                for (var _i = 0, infos_2 = infos; _i < infos_2.length; _i++) {
                  var info = infos_2[_i];
                  _loop_14(info);
                }
              });
            }));
          }
        });
        var InfoKind;
        (function(InfoKind2) {
          InfoKind2[InfoKind2["Enum"] = 0] = "Enum";
          InfoKind2[InfoKind2["ClassOrInterface"] = 1] = "ClassOrInterface";
          InfoKind2[InfoKind2["Function"] = 2] = "Function";
        })(InfoKind || (InfoKind = {}));
        function getInfo(sourceFile, tokenPos, checker, program2) {
          var token = ts3.getTokenAtPosition(sourceFile, tokenPos);
          if (!ts3.isIdentifier(token) && !ts3.isPrivateIdentifier(token)) {
            return void 0;
          }
          var parent = token.parent;
          if (ts3.isIdentifier(token) && ts3.isCallExpression(parent)) {
            return { kind: 2, token, call: parent, sourceFile, modifierFlags: 0, parentDeclaration: sourceFile };
          }
          if (!ts3.isPropertyAccessExpression(parent)) {
            return void 0;
          }
          var leftExpressionType = ts3.skipConstraint(checker.getTypeAtLocation(parent.expression));
          var symbol = leftExpressionType.symbol;
          if (!symbol || !symbol.declarations) {
            return void 0;
          }
          if (ts3.isIdentifier(token) && ts3.isCallExpression(parent.parent)) {
            var moduleDeclaration = ts3.find(symbol.declarations, ts3.isModuleDeclaration);
            var moduleDeclarationSourceFile = moduleDeclaration === null || moduleDeclaration === void 0 ? void 0 : moduleDeclaration.getSourceFile();
            if (moduleDeclaration && moduleDeclarationSourceFile && !program2.isSourceFileFromExternalLibrary(moduleDeclarationSourceFile)) {
              return { kind: 2, token, call: parent.parent, sourceFile, modifierFlags: 1, parentDeclaration: moduleDeclaration };
            }
            var moduleSourceFile = ts3.find(symbol.declarations, ts3.isSourceFile);
            if (sourceFile.commonJsModuleIndicator) {
              return;
            }
            if (moduleSourceFile && !program2.isSourceFileFromExternalLibrary(moduleSourceFile)) {
              return { kind: 2, token, call: parent.parent, sourceFile: moduleSourceFile, modifierFlags: 1, parentDeclaration: moduleSourceFile };
            }
          }
          var classDeclaration = ts3.find(symbol.declarations, ts3.isClassLike);
          if (!classDeclaration && ts3.isPrivateIdentifier(token)) {
            return void 0;
          }
          var classOrInterface = classDeclaration || ts3.find(symbol.declarations, ts3.isInterfaceDeclaration);
          if (classOrInterface && !program2.isSourceFileFromExternalLibrary(classOrInterface.getSourceFile())) {
            var makeStatic = (leftExpressionType.target || leftExpressionType) !== checker.getDeclaredTypeOfSymbol(symbol);
            if (makeStatic && (ts3.isPrivateIdentifier(token) || ts3.isInterfaceDeclaration(classOrInterface))) {
              return void 0;
            }
            var declSourceFile = classOrInterface.getSourceFile();
            var modifierFlags = (makeStatic ? 32 : 0) | (ts3.startsWithUnderscore(token.text) ? 8 : 0);
            var isJSFile = ts3.isSourceFileJS(declSourceFile);
            var call = ts3.tryCast(parent.parent, ts3.isCallExpression);
            return { kind: 1, token, call, modifierFlags, parentDeclaration: classOrInterface, declSourceFile, isJSFile };
          }
          var enumDeclaration = ts3.find(symbol.declarations, ts3.isEnumDeclaration);
          if (enumDeclaration && !ts3.isPrivateIdentifier(token) && !program2.isSourceFileFromExternalLibrary(enumDeclaration.getSourceFile())) {
            return { kind: 0, token, parentDeclaration: enumDeclaration };
          }
          return void 0;
        }
        function getActionsForMissingMemberDeclaration(context, info) {
          return info.isJSFile ? ts3.singleElementArray(createActionForAddMissingMemberInJavascriptFile(context, info)) : createActionsForAddMissingMemberInTypeScriptFile(context, info);
        }
        function createActionForAddMissingMemberInJavascriptFile(context, _a2) {
          var parentDeclaration = _a2.parentDeclaration, declSourceFile = _a2.declSourceFile, modifierFlags = _a2.modifierFlags, token = _a2.token;
          if (ts3.isInterfaceDeclaration(parentDeclaration)) {
            return void 0;
          }
          var changes = ts3.textChanges.ChangeTracker.with(context, function(t2) {
            return addMissingMemberInJs(t2, declSourceFile, parentDeclaration, token, !!(modifierFlags & 32));
          });
          if (changes.length === 0) {
            return void 0;
          }
          var diagnostic = modifierFlags & 32 ? ts3.Diagnostics.Initialize_static_property_0 : ts3.isPrivateIdentifier(token) ? ts3.Diagnostics.Declare_a_private_field_named_0 : ts3.Diagnostics.Initialize_property_0_in_the_constructor;
          return codefix2.createCodeFixAction(fixMissingMember, changes, [diagnostic, token.text], fixMissingMember, ts3.Diagnostics.Add_all_missing_members);
        }
        function addMissingMemberInJs(changeTracker, declSourceFile, classDeclaration, token, makeStatic) {
          var tokenName = token.text;
          if (makeStatic) {
            if (classDeclaration.kind === 222) {
              return;
            }
            var className = classDeclaration.name.getText();
            var staticInitialization = initializePropertyToUndefined(ts3.factory.createIdentifier(className), tokenName);
            changeTracker.insertNodeAfter(declSourceFile, classDeclaration, staticInitialization);
          } else if (ts3.isPrivateIdentifier(token)) {
            var property = ts3.factory.createPropertyDeclaration(void 0, void 0, tokenName, void 0, void 0, void 0);
            var lastProp = getNodeToInsertPropertyAfter(classDeclaration);
            if (lastProp) {
              changeTracker.insertNodeAfter(declSourceFile, lastProp, property);
            } else {
              changeTracker.insertNodeAtClassStart(declSourceFile, classDeclaration, property);
            }
          } else {
            var classConstructor = ts3.getFirstConstructorWithBody(classDeclaration);
            if (!classConstructor) {
              return;
            }
            var propertyInitialization = initializePropertyToUndefined(ts3.factory.createThis(), tokenName);
            changeTracker.insertNodeAtConstructorEnd(declSourceFile, classConstructor, propertyInitialization);
          }
        }
        function initializePropertyToUndefined(obj, propertyName) {
          return ts3.factory.createExpressionStatement(ts3.factory.createAssignment(ts3.factory.createPropertyAccessExpression(obj, propertyName), ts3.factory.createIdentifier("undefined")));
        }
        function createActionsForAddMissingMemberInTypeScriptFile(context, _a2) {
          var parentDeclaration = _a2.parentDeclaration, declSourceFile = _a2.declSourceFile, modifierFlags = _a2.modifierFlags, token = _a2.token;
          var memberName = token.text;
          var isStatic = modifierFlags & 32;
          var typeNode = getTypeNode(context.program.getTypeChecker(), parentDeclaration, token);
          var addPropertyDeclarationChanges = function(modifierFlags2) {
            return ts3.textChanges.ChangeTracker.with(context, function(t2) {
              return addPropertyDeclaration(t2, declSourceFile, parentDeclaration, memberName, typeNode, modifierFlags2);
            });
          };
          var actions2 = [codefix2.createCodeFixAction(fixMissingMember, addPropertyDeclarationChanges(modifierFlags & 32), [isStatic ? ts3.Diagnostics.Declare_static_property_0 : ts3.Diagnostics.Declare_property_0, memberName], fixMissingMember, ts3.Diagnostics.Add_all_missing_members)];
          if (isStatic || ts3.isPrivateIdentifier(token)) {
            return actions2;
          }
          if (modifierFlags & 8) {
            actions2.unshift(codefix2.createCodeFixActionWithoutFixAll(fixMissingMember, addPropertyDeclarationChanges(8), [ts3.Diagnostics.Declare_private_property_0, memberName]));
          }
          actions2.push(createAddIndexSignatureAction(context, declSourceFile, parentDeclaration, token.text, typeNode));
          return actions2;
        }
        function getTypeNode(checker, classDeclaration, token) {
          var typeNode;
          if (token.parent.parent.kind === 217) {
            var binaryExpression = token.parent.parent;
            var otherExpression = token.parent === binaryExpression.left ? binaryExpression.right : binaryExpression.left;
            var widenedType = checker.getWidenedType(checker.getBaseTypeOfLiteralType(checker.getTypeAtLocation(otherExpression)));
            typeNode = checker.typeToTypeNode(widenedType, classDeclaration, 1);
          } else {
            var contextualType = checker.getContextualType(token.parent);
            typeNode = contextualType ? checker.typeToTypeNode(contextualType, void 0, 1) : void 0;
          }
          return typeNode || ts3.factory.createKeywordTypeNode(128);
        }
        function addPropertyDeclaration(changeTracker, declSourceFile, classDeclaration, tokenName, typeNode, modifierFlags) {
          var property = ts3.factory.createPropertyDeclaration(void 0, modifierFlags ? ts3.factory.createNodeArray(ts3.factory.createModifiersFromModifierFlags(modifierFlags)) : void 0, tokenName, void 0, typeNode, void 0);
          var lastProp = getNodeToInsertPropertyAfter(classDeclaration);
          if (lastProp) {
            changeTracker.insertNodeAfter(declSourceFile, lastProp, property);
          } else {
            changeTracker.insertNodeAtClassStart(declSourceFile, classDeclaration, property);
          }
        }
        function getNodeToInsertPropertyAfter(cls) {
          var res;
          for (var _i = 0, _a2 = cls.members; _i < _a2.length; _i++) {
            var member = _a2[_i];
            if (!ts3.isPropertyDeclaration(member))
              break;
            res = member;
          }
          return res;
        }
        function createAddIndexSignatureAction(context, declSourceFile, classDeclaration, tokenName, typeNode) {
          var stringTypeNode = ts3.factory.createKeywordTypeNode(147);
          var indexingParameter = ts3.factory.createParameterDeclaration(void 0, void 0, void 0, "x", void 0, stringTypeNode, void 0);
          var indexSignature = ts3.factory.createIndexSignature(void 0, void 0, [indexingParameter], typeNode);
          var changes = ts3.textChanges.ChangeTracker.with(context, function(t2) {
            return t2.insertNodeAtClassStart(declSourceFile, classDeclaration, indexSignature);
          });
          return codefix2.createCodeFixActionWithoutFixAll(fixMissingMember, changes, [ts3.Diagnostics.Add_index_signature_for_property_0, tokenName]);
        }
        function getActionsForMissingMethodDeclaration(context, info) {
          var parentDeclaration = info.parentDeclaration, declSourceFile = info.declSourceFile, modifierFlags = info.modifierFlags, token = info.token, call = info.call;
          if (call === void 0) {
            return void 0;
          }
          if (ts3.isPrivateIdentifier(token)) {
            return void 0;
          }
          var methodName = token.text;
          var addMethodDeclarationChanges = function(modifierFlags2) {
            return ts3.textChanges.ChangeTracker.with(context, function(t2) {
              return addMethodDeclaration(context, t2, call, token, modifierFlags2, parentDeclaration, declSourceFile);
            });
          };
          var actions2 = [codefix2.createCodeFixAction(fixMissingMember, addMethodDeclarationChanges(modifierFlags & 32), [modifierFlags & 32 ? ts3.Diagnostics.Declare_static_method_0 : ts3.Diagnostics.Declare_method_0, methodName], fixMissingMember, ts3.Diagnostics.Add_all_missing_members)];
          if (modifierFlags & 8) {
            actions2.unshift(codefix2.createCodeFixActionWithoutFixAll(fixMissingMember, addMethodDeclarationChanges(8), [ts3.Diagnostics.Declare_private_method_0, methodName]));
          }
          return actions2;
        }
        function addMethodDeclaration(context, changes, callExpression2, name, modifierFlags, parentDeclaration, sourceFile) {
          var importAdder = codefix2.createImportAdder(sourceFile, context.program, context.preferences, context.host);
          var methodDeclaration = codefix2.createSignatureDeclarationFromCallExpression(166, context, importAdder, callExpression2, name, modifierFlags, parentDeclaration);
          var containingMethodDeclaration = ts3.findAncestor(callExpression2, function(n2) {
            return ts3.isMethodDeclaration(n2) || ts3.isConstructorDeclaration(n2);
          });
          if (containingMethodDeclaration && containingMethodDeclaration.parent === parentDeclaration) {
            changes.insertNodeAfter(sourceFile, containingMethodDeclaration, methodDeclaration);
          } else {
            changes.insertNodeAtClassStart(sourceFile, parentDeclaration, methodDeclaration);
          }
          importAdder.writeFixes(changes);
        }
        function addEnumMemberDeclaration(changes, checker, _a2) {
          var token = _a2.token, parentDeclaration = _a2.parentDeclaration;
          var hasStringInitializer = ts3.some(parentDeclaration.members, function(member) {
            var type3 = checker.getTypeAtLocation(member);
            return !!(type3 && type3.flags & 402653316);
          });
          var enumMember = ts3.factory.createEnumMember(token, hasStringInitializer ? ts3.factory.createStringLiteral(token.text) : void 0);
          changes.replaceNode(parentDeclaration.getSourceFile(), parentDeclaration, ts3.factory.updateEnumDeclaration(parentDeclaration, parentDeclaration.decorators, parentDeclaration.modifiers, parentDeclaration.name, ts3.concatenate(parentDeclaration.members, ts3.singleElementArray(enumMember))), {
            leadingTriviaOption: ts3.textChanges.LeadingTriviaOption.IncludeAll,
            trailingTriviaOption: ts3.textChanges.TrailingTriviaOption.Exclude
          });
        }
        function addFunctionDeclaration(changes, context, info) {
          var importAdder = codefix2.createImportAdder(context.sourceFile, context.program, context.preferences, context.host);
          var functionDeclaration = codefix2.createSignatureDeclarationFromCallExpression(252, context, importAdder, info.call, ts3.idText(info.token), info.modifierFlags, info.parentDeclaration);
          changes.insertNodeAtEndOfScope(info.sourceFile, info.parentDeclaration, functionDeclaration);
        }
      })(codefix = ts3.codefix || (ts3.codefix = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var codefix;
      (function(codefix2) {
        var fixId = "addMissingNewOperator";
        var errorCodes = [ts3.Diagnostics.Value_of_type_0_is_not_callable_Did_you_mean_to_include_new.code];
        codefix2.registerCodeFix({
          errorCodes,
          getCodeActions: function(context) {
            var sourceFile = context.sourceFile, span = context.span;
            var changes = ts3.textChanges.ChangeTracker.with(context, function(t2) {
              return addMissingNewOperator(t2, sourceFile, span);
            });
            return [codefix2.createCodeFixAction(fixId, changes, ts3.Diagnostics.Add_missing_new_operator_to_call, fixId, ts3.Diagnostics.Add_missing_new_operator_to_all_calls)];
          },
          fixIds: [fixId],
          getAllCodeActions: function(context) {
            return codefix2.codeFixAll(context, errorCodes, function(changes, diag) {
              return addMissingNewOperator(changes, context.sourceFile, diag);
            });
          }
        });
        function addMissingNewOperator(changes, sourceFile, span) {
          var call = ts3.cast(findAncestorMatchingSpan(sourceFile, span), ts3.isCallExpression);
          var newExpression = ts3.factory.createNewExpression(call.expression, call.typeArguments, call.arguments);
          changes.replaceNode(sourceFile, call, newExpression);
        }
        function findAncestorMatchingSpan(sourceFile, span) {
          var token = ts3.getTokenAtPosition(sourceFile, span.start);
          var end = ts3.textSpanEnd(span);
          while (token.end < end) {
            token = token.parent;
          }
          return token;
        }
      })(codefix = ts3.codefix || (ts3.codefix = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var codefix;
      (function(codefix2) {
        var fixName = "fixCannotFindModule";
        var fixIdInstallTypesPackage = "installTypesPackage";
        var errorCodeCannotFindModule = ts3.Diagnostics.Cannot_find_module_0_or_its_corresponding_type_declarations.code;
        var errorCodes = [
          errorCodeCannotFindModule,
          ts3.Diagnostics.Could_not_find_a_declaration_file_for_module_0_1_implicitly_has_an_any_type.code
        ];
        codefix2.registerCodeFix({
          errorCodes,
          getCodeActions: function(context) {
            var host = context.host, sourceFile = context.sourceFile, start = context.span.start;
            var packageName = tryGetImportedPackageName(sourceFile, start);
            if (packageName === void 0)
              return void 0;
            var typesPackageName = getTypesPackageNameToInstall(packageName, host, context.errorCode);
            return typesPackageName === void 0 ? [] : [codefix2.createCodeFixAction(fixName, [], [ts3.Diagnostics.Install_0, typesPackageName], fixIdInstallTypesPackage, ts3.Diagnostics.Install_all_missing_types_packages, getInstallCommand(sourceFile.fileName, typesPackageName))];
          },
          fixIds: [fixIdInstallTypesPackage],
          getAllCodeActions: function(context) {
            return codefix2.codeFixAll(context, errorCodes, function(_changes, diag, commands) {
              var packageName = tryGetImportedPackageName(diag.file, diag.start);
              if (packageName === void 0)
                return void 0;
              switch (context.fixId) {
                case fixIdInstallTypesPackage: {
                  var pkg = getTypesPackageNameToInstall(packageName, context.host, diag.code);
                  if (pkg) {
                    commands.push(getInstallCommand(diag.file.fileName, pkg));
                  }
                  break;
                }
                default:
                  ts3.Debug.fail("Bad fixId: " + context.fixId);
              }
            });
          }
        });
        function getInstallCommand(fileName, packageName) {
          return { type: "install package", file: fileName, packageName };
        }
        function tryGetImportedPackageName(sourceFile, pos) {
          var moduleSpecifierText = ts3.tryCast(ts3.getTokenAtPosition(sourceFile, pos), ts3.isStringLiteral);
          if (!moduleSpecifierText)
            return void 0;
          var moduleName = moduleSpecifierText.text;
          var packageName = ts3.parsePackageName(moduleName).packageName;
          return ts3.isExternalModuleNameRelative(packageName) ? void 0 : packageName;
        }
        function getTypesPackageNameToInstall(packageName, host, diagCode) {
          var _a2;
          return diagCode === errorCodeCannotFindModule ? ts3.JsTyping.nodeCoreModules.has(packageName) ? "@types/node" : void 0 : ((_a2 = host.isKnownTypesPackageName) === null || _a2 === void 0 ? void 0 : _a2.call(host, packageName)) ? ts3.getTypesPackageName(packageName) : void 0;
        }
      })(codefix = ts3.codefix || (ts3.codefix = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var codefix;
      (function(codefix2) {
        var errorCodes = [
          ts3.Diagnostics.Non_abstract_class_0_does_not_implement_inherited_abstract_member_1_from_class_2.code,
          ts3.Diagnostics.Non_abstract_class_expression_does_not_implement_inherited_abstract_member_0_from_class_1.code
        ];
        var fixId = "fixClassDoesntImplementInheritedAbstractMember";
        codefix2.registerCodeFix({
          errorCodes,
          getCodeActions: function(context) {
            var sourceFile = context.sourceFile, span = context.span;
            var changes = ts3.textChanges.ChangeTracker.with(context, function(t2) {
              return addMissingMembers(getClass(sourceFile, span.start), sourceFile, context, t2, context.preferences);
            });
            return changes.length === 0 ? void 0 : [codefix2.createCodeFixAction(fixId, changes, ts3.Diagnostics.Implement_inherited_abstract_class, fixId, ts3.Diagnostics.Implement_all_inherited_abstract_classes)];
          },
          fixIds: [fixId],
          getAllCodeActions: function(context) {
            var seenClassDeclarations = new ts3.Map();
            return codefix2.codeFixAll(context, errorCodes, function(changes, diag) {
              var classDeclaration = getClass(diag.file, diag.start);
              if (ts3.addToSeen(seenClassDeclarations, ts3.getNodeId(classDeclaration))) {
                addMissingMembers(classDeclaration, context.sourceFile, context, changes, context.preferences);
              }
            });
          }
        });
        function getClass(sourceFile, pos) {
          var token = ts3.getTokenAtPosition(sourceFile, pos);
          return ts3.cast(token.parent, ts3.isClassLike);
        }
        function addMissingMembers(classDeclaration, sourceFile, context, changeTracker, preferences) {
          var extendsNode = ts3.getEffectiveBaseTypeNode(classDeclaration);
          var checker = context.program.getTypeChecker();
          var instantiatedExtendsType = checker.getTypeAtLocation(extendsNode);
          var abstractAndNonPrivateExtendsSymbols = checker.getPropertiesOfType(instantiatedExtendsType).filter(symbolPointsToNonPrivateAndAbstractMember);
          var importAdder = codefix2.createImportAdder(sourceFile, context.program, preferences, context.host);
          codefix2.createMissingMemberNodes(classDeclaration, abstractAndNonPrivateExtendsSymbols, sourceFile, context, preferences, importAdder, function(member) {
            return changeTracker.insertNodeAtClassStart(sourceFile, classDeclaration, member);
          });
          importAdder.writeFixes(changeTracker);
        }
        function symbolPointsToNonPrivateAndAbstractMember(symbol) {
          var flags = ts3.getSyntacticModifierFlags(ts3.first(symbol.getDeclarations()));
          return !(flags & 8) && !!(flags & 128);
        }
      })(codefix = ts3.codefix || (ts3.codefix = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var codefix;
      (function(codefix2) {
        var fixId = "classSuperMustPrecedeThisAccess";
        var errorCodes = [ts3.Diagnostics.super_must_be_called_before_accessing_this_in_the_constructor_of_a_derived_class.code];
        codefix2.registerCodeFix({
          errorCodes,
          getCodeActions: function(context) {
            var sourceFile = context.sourceFile, span = context.span;
            var nodes = getNodes(sourceFile, span.start);
            if (!nodes)
              return void 0;
            var constructor = nodes.constructor, superCall = nodes.superCall;
            var changes = ts3.textChanges.ChangeTracker.with(context, function(t2) {
              return doChange(t2, sourceFile, constructor, superCall);
            });
            return [codefix2.createCodeFixAction(fixId, changes, ts3.Diagnostics.Make_super_call_the_first_statement_in_the_constructor, fixId, ts3.Diagnostics.Make_all_super_calls_the_first_statement_in_their_constructor)];
          },
          fixIds: [fixId],
          getAllCodeActions: function(context) {
            var sourceFile = context.sourceFile;
            var seenClasses = new ts3.Map();
            return codefix2.codeFixAll(context, errorCodes, function(changes, diag) {
              var nodes = getNodes(diag.file, diag.start);
              if (!nodes)
                return;
              var constructor = nodes.constructor, superCall = nodes.superCall;
              if (ts3.addToSeen(seenClasses, ts3.getNodeId(constructor.parent))) {
                doChange(changes, sourceFile, constructor, superCall);
              }
            });
          }
        });
        function doChange(changes, sourceFile, constructor, superCall) {
          changes.insertNodeAtConstructorStart(sourceFile, constructor, superCall);
          changes.delete(sourceFile, superCall);
        }
        function getNodes(sourceFile, pos) {
          var token = ts3.getTokenAtPosition(sourceFile, pos);
          if (token.kind !== 107)
            return void 0;
          var constructor = ts3.getContainingFunction(token);
          var superCall = findSuperCall(constructor.body);
          return superCall && !superCall.expression.arguments.some(function(arg2) {
            return ts3.isPropertyAccessExpression(arg2) && arg2.expression === token;
          }) ? { constructor, superCall } : void 0;
        }
        function findSuperCall(n2) {
          return ts3.isExpressionStatement(n2) && ts3.isSuperCall(n2.expression) ? n2 : ts3.isFunctionLike(n2) ? void 0 : ts3.forEachChild(n2, findSuperCall);
        }
      })(codefix = ts3.codefix || (ts3.codefix = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var codefix;
      (function(codefix2) {
        var fixId = "constructorForDerivedNeedSuperCall";
        var errorCodes = [ts3.Diagnostics.Constructors_for_derived_classes_must_contain_a_super_call.code];
        codefix2.registerCodeFix({
          errorCodes,
          getCodeActions: function(context) {
            var sourceFile = context.sourceFile, span = context.span;
            var ctr = getNode(sourceFile, span.start);
            var changes = ts3.textChanges.ChangeTracker.with(context, function(t2) {
              return doChange(t2, sourceFile, ctr);
            });
            return [codefix2.createCodeFixAction(fixId, changes, ts3.Diagnostics.Add_missing_super_call, fixId, ts3.Diagnostics.Add_all_missing_super_calls)];
          },
          fixIds: [fixId],
          getAllCodeActions: function(context) {
            return codefix2.codeFixAll(context, errorCodes, function(changes, diag) {
              return doChange(changes, context.sourceFile, getNode(diag.file, diag.start));
            });
          }
        });
        function getNode(sourceFile, pos) {
          var token = ts3.getTokenAtPosition(sourceFile, pos);
          ts3.Debug.assert(ts3.isConstructorDeclaration(token.parent), "token should be at the constructor declaration");
          return token.parent;
        }
        function doChange(changes, sourceFile, ctr) {
          var superCall = ts3.factory.createExpressionStatement(ts3.factory.createCallExpression(ts3.factory.createSuper(), void 0, ts3.emptyArray));
          changes.insertNodeAtConstructorStart(sourceFile, ctr, superCall);
        }
      })(codefix = ts3.codefix || (ts3.codefix = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var codefix;
      (function(codefix2) {
        var fixId = "enableExperimentalDecorators";
        var errorCodes = [
          ts3.Diagnostics.Experimental_support_for_decorators_is_a_feature_that_is_subject_to_change_in_a_future_release_Set_the_experimentalDecorators_option_in_your_tsconfig_or_jsconfig_to_remove_this_warning.code
        ];
        codefix2.registerCodeFix({
          errorCodes,
          getCodeActions: function(context) {
            var configFile = context.program.getCompilerOptions().configFile;
            if (configFile === void 0) {
              return void 0;
            }
            var changes = ts3.textChanges.ChangeTracker.with(context, function(changeTracker) {
              return doChange(changeTracker, configFile);
            });
            return [codefix2.createCodeFixActionWithoutFixAll(fixId, changes, ts3.Diagnostics.Enable_the_experimentalDecorators_option_in_your_configuration_file)];
          },
          fixIds: [fixId],
          getAllCodeActions: function(context) {
            return codefix2.codeFixAll(context, errorCodes, function(changes) {
              var configFile = context.program.getCompilerOptions().configFile;
              if (configFile === void 0) {
                return void 0;
              }
              doChange(changes, configFile);
            });
          }
        });
        function doChange(changeTracker, configFile) {
          codefix2.setJsonCompilerOptionValue(changeTracker, configFile, "experimentalDecorators", ts3.factory.createTrue());
        }
      })(codefix = ts3.codefix || (ts3.codefix = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var codefix;
      (function(codefix2) {
        var fixID = "fixEnableJsxFlag";
        var errorCodes = [ts3.Diagnostics.Cannot_use_JSX_unless_the_jsx_flag_is_provided.code];
        codefix2.registerCodeFix({
          errorCodes,
          getCodeActions: function(context) {
            var configFile = context.program.getCompilerOptions().configFile;
            if (configFile === void 0) {
              return void 0;
            }
            var changes = ts3.textChanges.ChangeTracker.with(context, function(changeTracker) {
              return doChange(changeTracker, configFile);
            });
            return [
              codefix2.createCodeFixActionWithoutFixAll(fixID, changes, ts3.Diagnostics.Enable_the_jsx_flag_in_your_configuration_file)
            ];
          },
          fixIds: [fixID],
          getAllCodeActions: function(context) {
            return codefix2.codeFixAll(context, errorCodes, function(changes) {
              var configFile = context.program.getCompilerOptions().configFile;
              if (configFile === void 0) {
                return void 0;
              }
              doChange(changes, configFile);
            });
          }
        });
        function doChange(changeTracker, configFile) {
          codefix2.setJsonCompilerOptionValue(changeTracker, configFile, "jsx", ts3.factory.createStringLiteral("react"));
        }
      })(codefix = ts3.codefix || (ts3.codefix = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var codefix;
      (function(codefix2) {
        codefix2.registerCodeFix({
          errorCodes: [
            ts3.Diagnostics.Top_level_await_expressions_are_only_allowed_when_the_module_option_is_set_to_esnext_or_system_and_the_target_option_is_set_to_es2017_or_higher.code,
            ts3.Diagnostics.Top_level_for_await_loops_are_only_allowed_when_the_module_option_is_set_to_esnext_or_system_and_the_target_option_is_set_to_es2017_or_higher.code
          ],
          getCodeActions: function(context) {
            var compilerOptions = context.program.getCompilerOptions();
            var configFile = compilerOptions.configFile;
            if (configFile === void 0) {
              return void 0;
            }
            var codeFixes = [];
            var moduleKind = ts3.getEmitModuleKind(compilerOptions);
            var moduleOutOfRange = moduleKind >= ts3.ModuleKind.ES2015 && moduleKind < ts3.ModuleKind.ESNext;
            if (moduleOutOfRange) {
              var changes = ts3.textChanges.ChangeTracker.with(context, function(changes2) {
                codefix2.setJsonCompilerOptionValue(changes2, configFile, "module", ts3.factory.createStringLiteral("esnext"));
              });
              codeFixes.push(codefix2.createCodeFixActionWithoutFixAll("fixModuleOption", changes, [ts3.Diagnostics.Set_the_module_option_in_your_configuration_file_to_0, "esnext"]));
            }
            var target = ts3.getEmitScriptTarget(compilerOptions);
            var targetOutOfRange = target < 4 || target > 99;
            if (targetOutOfRange) {
              var changes = ts3.textChanges.ChangeTracker.with(context, function(tracker) {
                var configObject = ts3.getTsConfigObjectLiteralExpression(configFile);
                if (!configObject)
                  return;
                var options = [["target", ts3.factory.createStringLiteral("es2017")]];
                if (moduleKind === ts3.ModuleKind.CommonJS) {
                  options.push(["module", ts3.factory.createStringLiteral("commonjs")]);
                }
                codefix2.setJsonCompilerOptionValues(tracker, configFile, options);
              });
              codeFixes.push(codefix2.createCodeFixActionWithoutFixAll("fixTargetOption", changes, [ts3.Diagnostics.Set_the_target_option_in_your_configuration_file_to_0, "es2017"]));
            }
            return codeFixes.length ? codeFixes : void 0;
          }
        });
      })(codefix = ts3.codefix || (ts3.codefix = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var codefix;
      (function(codefix2) {
        var fixId = "fixPropertyAssignment";
        var errorCodes = [
          ts3.Diagnostics.Did_you_mean_to_use_a_Colon_An_can_only_follow_a_property_name_when_the_containing_object_literal_is_part_of_a_destructuring_pattern.code
        ];
        codefix2.registerCodeFix({
          errorCodes,
          fixIds: [fixId],
          getCodeActions: function(context) {
            var sourceFile = context.sourceFile, span = context.span;
            var property = getProperty(sourceFile, span.start);
            var changes = ts3.textChanges.ChangeTracker.with(context, function(t2) {
              return doChange(t2, context.sourceFile, property);
            });
            return [codefix2.createCodeFixAction(fixId, changes, [ts3.Diagnostics.Change_0_to_1, "=", ":"], fixId, [ts3.Diagnostics.Switch_each_misused_0_to_1, "=", ":"])];
          },
          getAllCodeActions: function(context) {
            return codefix2.codeFixAll(context, errorCodes, function(changes, diag) {
              return doChange(changes, diag.file, getProperty(diag.file, diag.start));
            });
          }
        });
        function doChange(changes, sourceFile, node) {
          changes.replaceNode(sourceFile, node, ts3.factory.createPropertyAssignment(node.name, node.objectAssignmentInitializer));
        }
        function getProperty(sourceFile, pos) {
          return ts3.cast(ts3.getTokenAtPosition(sourceFile, pos).parent, ts3.isShorthandPropertyAssignment);
        }
      })(codefix = ts3.codefix || (ts3.codefix = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var codefix;
      (function(codefix2) {
        var fixId = "extendsInterfaceBecomesImplements";
        var errorCodes = [ts3.Diagnostics.Cannot_extend_an_interface_0_Did_you_mean_implements.code];
        codefix2.registerCodeFix({
          errorCodes,
          getCodeActions: function(context) {
            var sourceFile = context.sourceFile;
            var nodes = getNodes(sourceFile, context.span.start);
            if (!nodes)
              return void 0;
            var extendsToken = nodes.extendsToken, heritageClauses = nodes.heritageClauses;
            var changes = ts3.textChanges.ChangeTracker.with(context, function(t2) {
              return doChanges(t2, sourceFile, extendsToken, heritageClauses);
            });
            return [codefix2.createCodeFixAction(fixId, changes, ts3.Diagnostics.Change_extends_to_implements, fixId, ts3.Diagnostics.Change_all_extended_interfaces_to_implements)];
          },
          fixIds: [fixId],
          getAllCodeActions: function(context) {
            return codefix2.codeFixAll(context, errorCodes, function(changes, diag) {
              var nodes = getNodes(diag.file, diag.start);
              if (nodes)
                doChanges(changes, diag.file, nodes.extendsToken, nodes.heritageClauses);
            });
          }
        });
        function getNodes(sourceFile, pos) {
          var token = ts3.getTokenAtPosition(sourceFile, pos);
          var heritageClauses = ts3.getContainingClass(token).heritageClauses;
          var extendsToken = heritageClauses[0].getFirstToken();
          return extendsToken.kind === 93 ? { extendsToken, heritageClauses } : void 0;
        }
        function doChanges(changes, sourceFile, extendsToken, heritageClauses) {
          changes.replaceNode(sourceFile, extendsToken, ts3.factory.createToken(116));
          if (heritageClauses.length === 2 && heritageClauses[0].token === 93 && heritageClauses[1].token === 116) {
            var implementsToken = heritageClauses[1].getFirstToken();
            var implementsFullStart = implementsToken.getFullStart();
            changes.replaceRange(sourceFile, { pos: implementsFullStart, end: implementsFullStart }, ts3.factory.createToken(27));
            var text = sourceFile.text;
            var end = implementsToken.end;
            while (end < text.length && ts3.isWhiteSpaceSingleLine(text.charCodeAt(end))) {
              end++;
            }
            changes.deleteRange(sourceFile, { pos: implementsToken.getStart(), end });
          }
        }
      })(codefix = ts3.codefix || (ts3.codefix = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var codefix;
      (function(codefix2) {
        var fixId = "forgottenThisPropertyAccess";
        var didYouMeanStaticMemberCode = ts3.Diagnostics.Cannot_find_name_0_Did_you_mean_the_static_member_1_0.code;
        var errorCodes = [
          ts3.Diagnostics.Cannot_find_name_0_Did_you_mean_the_instance_member_this_0.code,
          ts3.Diagnostics.Private_identifiers_are_not_allowed_outside_class_bodies.code,
          didYouMeanStaticMemberCode
        ];
        codefix2.registerCodeFix({
          errorCodes,
          getCodeActions: function(context) {
            var sourceFile = context.sourceFile;
            var info = getInfo(sourceFile, context.span.start, context.errorCode);
            if (!info) {
              return void 0;
            }
            var changes = ts3.textChanges.ChangeTracker.with(context, function(t2) {
              return doChange(t2, sourceFile, info);
            });
            return [codefix2.createCodeFixAction(fixId, changes, [ts3.Diagnostics.Add_0_to_unresolved_variable, info.className || "this"], fixId, ts3.Diagnostics.Add_qualifier_to_all_unresolved_variables_matching_a_member_name)];
          },
          fixIds: [fixId],
          getAllCodeActions: function(context) {
            return codefix2.codeFixAll(context, errorCodes, function(changes, diag) {
              var info = getInfo(diag.file, diag.start, diag.code);
              if (info)
                doChange(changes, context.sourceFile, info);
            });
          }
        });
        function getInfo(sourceFile, pos, diagCode) {
          var node = ts3.getTokenAtPosition(sourceFile, pos);
          if (ts3.isIdentifier(node)) {
            return { node, className: diagCode === didYouMeanStaticMemberCode ? ts3.getContainingClass(node).name.text : void 0 };
          }
        }
        function doChange(changes, sourceFile, _a2) {
          var node = _a2.node, className = _a2.className;
          ts3.suppressLeadingAndTrailingTrivia(node);
          changes.replaceNode(sourceFile, node, ts3.factory.createPropertyAccessExpression(className ? ts3.factory.createIdentifier(className) : ts3.factory.createThis(), node));
        }
      })(codefix = ts3.codefix || (ts3.codefix = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var codefix;
      (function(codefix2) {
        var fixIdExpression = "fixInvalidJsxCharacters_expression";
        var fixIdHtmlEntity = "fixInvalidJsxCharacters_htmlEntity";
        var errorCodes = [
          ts3.Diagnostics.Unexpected_token_Did_you_mean_or_gt.code,
          ts3.Diagnostics.Unexpected_token_Did_you_mean_or_rbrace.code
        ];
        codefix2.registerCodeFix({
          errorCodes,
          fixIds: [fixIdExpression, fixIdHtmlEntity],
          getCodeActions: function(context) {
            var sourceFile = context.sourceFile, preferences = context.preferences, span = context.span;
            var changeToExpression = ts3.textChanges.ChangeTracker.with(context, function(t2) {
              return doChange(t2, preferences, sourceFile, span.start, false);
            });
            var changeToHtmlEntity = ts3.textChanges.ChangeTracker.with(context, function(t2) {
              return doChange(t2, preferences, sourceFile, span.start, true);
            });
            return [
              codefix2.createCodeFixAction(fixIdExpression, changeToExpression, ts3.Diagnostics.Wrap_invalid_character_in_an_expression_container, fixIdExpression, ts3.Diagnostics.Wrap_all_invalid_characters_in_an_expression_container),
              codefix2.createCodeFixAction(fixIdHtmlEntity, changeToHtmlEntity, ts3.Diagnostics.Convert_invalid_character_to_its_html_entity_code, fixIdHtmlEntity, ts3.Diagnostics.Convert_all_invalid_characters_to_HTML_entity_code)
            ];
          },
          getAllCodeActions: function(context) {
            return codefix2.codeFixAll(context, errorCodes, function(changes, diagnostic) {
              return doChange(changes, context.preferences, diagnostic.file, diagnostic.start, context.fixId === fixIdHtmlEntity);
            });
          }
        });
        var htmlEntity = {
          ">": "&gt;",
          "}": "&rbrace;"
        };
        function isValidCharacter(character) {
          return ts3.hasProperty(htmlEntity, character);
        }
        function doChange(changes, preferences, sourceFile, start, useHtmlEntity) {
          var character = sourceFile.getText()[start];
          if (!isValidCharacter(character)) {
            return;
          }
          var replacement = useHtmlEntity ? htmlEntity[character] : "{" + ts3.quote(sourceFile, preferences, character) + "}";
          changes.replaceRangeWithText(sourceFile, { pos: start, end: start + 1 }, replacement);
        }
      })(codefix = ts3.codefix || (ts3.codefix = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var codefix;
      (function(codefix2) {
        var fixName = "unusedIdentifier";
        var fixIdPrefix = "unusedIdentifier_prefix";
        var fixIdDelete = "unusedIdentifier_delete";
        var fixIdDeleteImports = "unusedIdentifier_deleteImports";
        var fixIdInfer = "unusedIdentifier_infer";
        var errorCodes = [
          ts3.Diagnostics._0_is_declared_but_its_value_is_never_read.code,
          ts3.Diagnostics._0_is_declared_but_never_used.code,
          ts3.Diagnostics.Property_0_is_declared_but_its_value_is_never_read.code,
          ts3.Diagnostics.All_imports_in_import_declaration_are_unused.code,
          ts3.Diagnostics.All_destructured_elements_are_unused.code,
          ts3.Diagnostics.All_variables_are_unused.code,
          ts3.Diagnostics.All_type_parameters_are_unused.code
        ];
        codefix2.registerCodeFix({
          errorCodes,
          getCodeActions: function(context) {
            var errorCode = context.errorCode, sourceFile = context.sourceFile, program2 = context.program, cancellationToken = context.cancellationToken;
            var checker = program2.getTypeChecker();
            var sourceFiles = program2.getSourceFiles();
            var token = ts3.getTokenAtPosition(sourceFile, context.span.start);
            if (ts3.isJSDocTemplateTag(token)) {
              return [createDeleteFix(ts3.textChanges.ChangeTracker.with(context, function(t2) {
                return t2.delete(sourceFile, token);
              }), ts3.Diagnostics.Remove_template_tag)];
            }
            if (token.kind === 29) {
              var changes = ts3.textChanges.ChangeTracker.with(context, function(t2) {
                return deleteTypeParameters(t2, sourceFile, token);
              });
              return [createDeleteFix(changes, ts3.Diagnostics.Remove_type_parameters)];
            }
            var importDecl = tryGetFullImport(token);
            if (importDecl) {
              var changes = ts3.textChanges.ChangeTracker.with(context, function(t2) {
                return t2.delete(sourceFile, importDecl);
              });
              return [codefix2.createCodeFixAction(fixName, changes, [ts3.Diagnostics.Remove_import_from_0, ts3.showModuleSpecifier(importDecl)], fixIdDeleteImports, ts3.Diagnostics.Delete_all_unused_imports)];
            } else if (isImport(token)) {
              var deletion = ts3.textChanges.ChangeTracker.with(context, function(t2) {
                return tryDeleteDeclaration(sourceFile, token, t2, checker, sourceFiles, program2, cancellationToken, false);
              });
              if (deletion.length) {
                return [codefix2.createCodeFixAction(fixName, deletion, [ts3.Diagnostics.Remove_unused_declaration_for_Colon_0, token.getText(sourceFile)], fixIdDeleteImports, ts3.Diagnostics.Delete_all_unused_imports)];
              }
            }
            if (ts3.isObjectBindingPattern(token.parent) || ts3.isArrayBindingPattern(token.parent)) {
              if (ts3.isParameter(token.parent.parent)) {
                var elements = token.parent.elements;
                var diagnostic = [
                  elements.length > 1 ? ts3.Diagnostics.Remove_unused_declarations_for_Colon_0 : ts3.Diagnostics.Remove_unused_declaration_for_Colon_0,
                  ts3.map(elements, function(e2) {
                    return e2.getText(sourceFile);
                  }).join(", ")
                ];
                return [
                  createDeleteFix(ts3.textChanges.ChangeTracker.with(context, function(t2) {
                    return deleteDestructuringElements(t2, sourceFile, token.parent);
                  }), diagnostic)
                ];
              }
              return [
                createDeleteFix(ts3.textChanges.ChangeTracker.with(context, function(t2) {
                  return t2.delete(sourceFile, token.parent.parent);
                }), ts3.Diagnostics.Remove_unused_destructuring_declaration)
              ];
            }
            if (canDeleteEntireVariableStatement(sourceFile, token)) {
              return [
                createDeleteFix(ts3.textChanges.ChangeTracker.with(context, function(t2) {
                  return deleteEntireVariableStatement(t2, sourceFile, token.parent);
                }), ts3.Diagnostics.Remove_variable_statement)
              ];
            }
            var result2 = [];
            if (token.kind === 135) {
              var changes = ts3.textChanges.ChangeTracker.with(context, function(t2) {
                return changeInferToUnknown(t2, sourceFile, token);
              });
              var name = ts3.cast(token.parent, ts3.isInferTypeNode).typeParameter.name.text;
              result2.push(codefix2.createCodeFixAction(fixName, changes, [ts3.Diagnostics.Replace_infer_0_with_unknown, name], fixIdInfer, ts3.Diagnostics.Replace_all_unused_infer_with_unknown));
            } else {
              var deletion = ts3.textChanges.ChangeTracker.with(context, function(t2) {
                return tryDeleteDeclaration(sourceFile, token, t2, checker, sourceFiles, program2, cancellationToken, false);
              });
              if (deletion.length) {
                var name = ts3.isComputedPropertyName(token.parent) ? token.parent : token;
                result2.push(createDeleteFix(deletion, [ts3.Diagnostics.Remove_unused_declaration_for_Colon_0, name.getText(sourceFile)]));
              }
            }
            var prefix2 = ts3.textChanges.ChangeTracker.with(context, function(t2) {
              return tryPrefixDeclaration(t2, errorCode, sourceFile, token);
            });
            if (prefix2.length) {
              result2.push(codefix2.createCodeFixAction(fixName, prefix2, [ts3.Diagnostics.Prefix_0_with_an_underscore, token.getText(sourceFile)], fixIdPrefix, ts3.Diagnostics.Prefix_all_unused_declarations_with_where_possible));
            }
            return result2;
          },
          fixIds: [fixIdPrefix, fixIdDelete, fixIdDeleteImports, fixIdInfer],
          getAllCodeActions: function(context) {
            var sourceFile = context.sourceFile, program2 = context.program, cancellationToken = context.cancellationToken;
            var checker = program2.getTypeChecker();
            var sourceFiles = program2.getSourceFiles();
            return codefix2.codeFixAll(context, errorCodes, function(changes, diag) {
              var token = ts3.getTokenAtPosition(sourceFile, diag.start);
              switch (context.fixId) {
                case fixIdPrefix:
                  tryPrefixDeclaration(changes, diag.code, sourceFile, token);
                  break;
                case fixIdDeleteImports: {
                  var importDecl = tryGetFullImport(token);
                  if (importDecl) {
                    changes.delete(sourceFile, importDecl);
                  } else if (isImport(token)) {
                    tryDeleteDeclaration(sourceFile, token, changes, checker, sourceFiles, program2, cancellationToken, true);
                  }
                  break;
                }
                case fixIdDelete: {
                  if (token.kind === 135 || isImport(token)) {
                    break;
                  } else if (ts3.isJSDocTemplateTag(token)) {
                    changes.delete(sourceFile, token);
                  } else if (token.kind === 29) {
                    deleteTypeParameters(changes, sourceFile, token);
                  } else if (ts3.isObjectBindingPattern(token.parent)) {
                    if (token.parent.parent.initializer) {
                      break;
                    } else if (!ts3.isParameter(token.parent.parent) || isNotProvidedArguments(token.parent.parent, checker, sourceFiles)) {
                      changes.delete(sourceFile, token.parent.parent);
                    }
                  } else if (ts3.isArrayBindingPattern(token.parent.parent) && token.parent.parent.parent.initializer) {
                    break;
                  } else if (canDeleteEntireVariableStatement(sourceFile, token)) {
                    deleteEntireVariableStatement(changes, sourceFile, token.parent);
                  } else {
                    tryDeleteDeclaration(sourceFile, token, changes, checker, sourceFiles, program2, cancellationToken, true);
                  }
                  break;
                }
                case fixIdInfer:
                  if (token.kind === 135) {
                    changeInferToUnknown(changes, sourceFile, token);
                  }
                  break;
                default:
                  ts3.Debug.fail(JSON.stringify(context.fixId));
              }
            });
          }
        });
        function changeInferToUnknown(changes, sourceFile, token) {
          changes.replaceNode(sourceFile, token.parent, ts3.factory.createKeywordTypeNode(152));
        }
        function createDeleteFix(changes, diag) {
          return codefix2.createCodeFixAction(fixName, changes, diag, fixIdDelete, ts3.Diagnostics.Delete_all_unused_declarations);
        }
        function deleteTypeParameters(changes, sourceFile, token) {
          changes.delete(sourceFile, ts3.Debug.checkDefined(ts3.cast(token.parent, ts3.isDeclarationWithTypeParameterChildren).typeParameters, "The type parameter to delete should exist"));
        }
        function isImport(token) {
          return token.kind === 99 || token.kind === 78 && (token.parent.kind === 266 || token.parent.kind === 263);
        }
        function tryGetFullImport(token) {
          return token.kind === 99 ? ts3.tryCast(token.parent, ts3.isImportDeclaration) : void 0;
        }
        function canDeleteEntireVariableStatement(sourceFile, token) {
          return ts3.isVariableDeclarationList(token.parent) && ts3.first(token.parent.getChildren(sourceFile)) === token;
        }
        function deleteEntireVariableStatement(changes, sourceFile, node) {
          changes.delete(sourceFile, node.parent.kind === 233 ? node.parent : node);
        }
        function deleteDestructuringElements(changes, sourceFile, node) {
          ts3.forEach(node.elements, function(n2) {
            return changes.delete(sourceFile, n2);
          });
        }
        function tryPrefixDeclaration(changes, errorCode, sourceFile, token) {
          if (errorCode === ts3.Diagnostics.Property_0_is_declared_but_its_value_is_never_read.code)
            return;
          if (token.kind === 135) {
            token = ts3.cast(token.parent, ts3.isInferTypeNode).typeParameter.name;
          }
          if (ts3.isIdentifier(token) && canPrefix(token)) {
            changes.replaceNode(sourceFile, token, ts3.factory.createIdentifier("_" + token.text));
            if (ts3.isParameter(token.parent)) {
              ts3.getJSDocParameterTags(token.parent).forEach(function(tag) {
                if (ts3.isIdentifier(tag.name)) {
                  changes.replaceNode(sourceFile, tag.name, ts3.factory.createIdentifier("_" + tag.name.text));
                }
              });
            }
          }
        }
        function canPrefix(token) {
          switch (token.parent.kind) {
            case 161:
            case 160:
              return true;
            case 250: {
              var varDecl = token.parent;
              switch (varDecl.parent.parent.kind) {
                case 240:
                case 239:
                  return true;
              }
            }
          }
          return false;
        }
        function tryDeleteDeclaration(sourceFile, token, changes, checker, sourceFiles, program2, cancellationToken, isFixAll) {
          tryDeleteDeclarationWorker(token, changes, sourceFile, checker, sourceFiles, program2, cancellationToken, isFixAll);
          if (ts3.isIdentifier(token)) {
            ts3.FindAllReferences.Core.eachSymbolReferenceInFile(token, checker, sourceFile, function(ref2) {
              if (ts3.isPropertyAccessExpression(ref2.parent) && ref2.parent.name === ref2)
                ref2 = ref2.parent;
              if (!isFixAll && mayDeleteExpression(ref2)) {
                changes.delete(sourceFile, ref2.parent.parent);
              }
            });
          }
        }
        function tryDeleteDeclarationWorker(token, changes, sourceFile, checker, sourceFiles, program2, cancellationToken, isFixAll) {
          var parent = token.parent;
          if (ts3.isParameter(parent)) {
            tryDeleteParameter(changes, sourceFile, parent, checker, sourceFiles, program2, cancellationToken, isFixAll);
          } else if (!(isFixAll && ts3.isIdentifier(token) && ts3.FindAllReferences.Core.isSymbolReferencedInFile(token, checker, sourceFile))) {
            var node = ts3.isImportClause(parent) ? token : ts3.isComputedPropertyName(parent) ? parent.parent : parent;
            ts3.Debug.assert(node !== sourceFile, "should not delete whole source file");
            changes.delete(sourceFile, node);
          }
        }
        function tryDeleteParameter(changes, sourceFile, parameter, checker, sourceFiles, program2, cancellationToken, isFixAll) {
          if (isFixAll === void 0) {
            isFixAll = false;
          }
          if (mayDeleteParameter(checker, sourceFile, parameter, sourceFiles, program2, cancellationToken, isFixAll)) {
            if (parameter.modifiers && parameter.modifiers.length > 0 && (!ts3.isIdentifier(parameter.name) || ts3.FindAllReferences.Core.isSymbolReferencedInFile(parameter.name, checker, sourceFile))) {
              parameter.modifiers.forEach(function(modifier) {
                return changes.deleteModifier(sourceFile, modifier);
              });
            } else if (!parameter.initializer && isNotProvidedArguments(parameter, checker, sourceFiles)) {
              changes.delete(sourceFile, parameter);
            }
          }
        }
        function isNotProvidedArguments(parameter, checker, sourceFiles) {
          var index = parameter.parent.parameters.indexOf(parameter);
          return !ts3.FindAllReferences.Core.someSignatureUsage(parameter.parent, sourceFiles, checker, function(_, call) {
            return !call || call.arguments.length > index;
          });
        }
        function mayDeleteParameter(checker, sourceFile, parameter, sourceFiles, program2, cancellationToken, isFixAll) {
          var parent = parameter.parent;
          switch (parent.kind) {
            case 166:
            case 167:
              var index = parent.parameters.indexOf(parameter);
              var referent = ts3.isMethodDeclaration(parent) ? parent.name : parent;
              var entries = ts3.FindAllReferences.Core.getReferencedSymbolsForNode(parent.pos, referent, program2, sourceFiles, cancellationToken);
              if (entries) {
                for (var _i = 0, entries_2 = entries; _i < entries_2.length; _i++) {
                  var entry = entries_2[_i];
                  for (var _a2 = 0, _b = entry.references; _a2 < _b.length; _a2++) {
                    var reference = _b[_a2];
                    if (reference.kind === 1) {
                      var isSuperCall_1 = ts3.isSuperKeyword(reference.node) && ts3.isCallExpression(reference.node.parent) && reference.node.parent.arguments.length > index;
                      var isSuperMethodCall = ts3.isPropertyAccessExpression(reference.node.parent) && ts3.isSuperKeyword(reference.node.parent.expression) && ts3.isCallExpression(reference.node.parent.parent) && reference.node.parent.parent.arguments.length > index;
                      var isOverriddenMethod = (ts3.isMethodDeclaration(reference.node.parent) || ts3.isMethodSignature(reference.node.parent)) && reference.node.parent !== parameter.parent && reference.node.parent.parameters.length > index;
                      if (isSuperCall_1 || isSuperMethodCall || isOverriddenMethod)
                        return false;
                    }
                  }
                }
              }
              return true;
            case 252: {
              if (parent.name && isCallbackLike(checker, sourceFile, parent.name)) {
                return isLastParameter(parent, parameter, isFixAll);
              }
              return true;
            }
            case 209:
            case 210:
              return isLastParameter(parent, parameter, isFixAll);
            case 169:
              return false;
            default:
              return ts3.Debug.failBadSyntaxKind(parent);
          }
        }
        function isCallbackLike(checker, sourceFile, name) {
          return !!ts3.FindAllReferences.Core.eachSymbolReferenceInFile(name, checker, sourceFile, function(reference) {
            return ts3.isIdentifier(reference) && ts3.isCallExpression(reference.parent) && reference.parent.arguments.indexOf(reference) >= 0;
          });
        }
        function isLastParameter(func2, parameter, isFixAll) {
          var parameters = func2.parameters;
          var index = parameters.indexOf(parameter);
          ts3.Debug.assert(index !== -1, "The parameter should already be in the list");
          return isFixAll ? parameters.slice(index + 1).every(function(p) {
            return ts3.isIdentifier(p.name) && !p.symbol.isReferenced;
          }) : index === parameters.length - 1;
        }
        function mayDeleteExpression(node) {
          return (ts3.isBinaryExpression(node.parent) && node.parent.left === node || (ts3.isPostfixUnaryExpression(node.parent) || ts3.isPrefixUnaryExpression(node.parent)) && node.parent.operand === node) && ts3.isExpressionStatement(node.parent.parent);
        }
      })(codefix = ts3.codefix || (ts3.codefix = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var codefix;
      (function(codefix2) {
        var fixId = "fixUnreachableCode";
        var errorCodes = [ts3.Diagnostics.Unreachable_code_detected.code];
        codefix2.registerCodeFix({
          errorCodes,
          getCodeActions: function(context) {
            var changes = ts3.textChanges.ChangeTracker.with(context, function(t2) {
              return doChange(t2, context.sourceFile, context.span.start, context.span.length, context.errorCode);
            });
            return [codefix2.createCodeFixAction(fixId, changes, ts3.Diagnostics.Remove_unreachable_code, fixId, ts3.Diagnostics.Remove_all_unreachable_code)];
          },
          fixIds: [fixId],
          getAllCodeActions: function(context) {
            return codefix2.codeFixAll(context, errorCodes, function(changes, diag) {
              return doChange(changes, diag.file, diag.start, diag.length, diag.code);
            });
          }
        });
        function doChange(changes, sourceFile, start, length, errorCode) {
          var token = ts3.getTokenAtPosition(sourceFile, start);
          var statement = ts3.findAncestor(token, ts3.isStatement);
          if (statement.getStart(sourceFile) !== token.getStart(sourceFile)) {
            var logData = JSON.stringify({
              statementKind: ts3.Debug.formatSyntaxKind(statement.kind),
              tokenKind: ts3.Debug.formatSyntaxKind(token.kind),
              errorCode,
              start,
              length
            });
            ts3.Debug.fail("Token and statement should start at the same point. " + logData);
          }
          var container = (ts3.isBlock(statement.parent) ? statement.parent : statement).parent;
          if (!ts3.isBlock(statement.parent) || statement === ts3.first(statement.parent.statements)) {
            switch (container.kind) {
              case 235:
                if (container.elseStatement) {
                  if (ts3.isBlock(statement.parent)) {
                    break;
                  } else {
                    changes.replaceNode(sourceFile, statement, ts3.factory.createBlock(ts3.emptyArray));
                  }
                  return;
                }
              case 237:
              case 238:
                changes.delete(sourceFile, container);
                return;
            }
          }
          if (ts3.isBlock(statement.parent)) {
            var end_3 = start + length;
            var lastStatement = ts3.Debug.checkDefined(lastWhere(ts3.sliceAfter(statement.parent.statements, statement), function(s2) {
              return s2.pos < end_3;
            }), "Some statement should be last");
            changes.deleteNodeRange(sourceFile, statement, lastStatement);
          } else {
            changes.delete(sourceFile, statement);
          }
        }
        function lastWhere(a2, pred) {
          var last;
          for (var _i = 0, a_1 = a2; _i < a_1.length; _i++) {
            var value = a_1[_i];
            if (!pred(value))
              break;
            last = value;
          }
          return last;
        }
      })(codefix = ts3.codefix || (ts3.codefix = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var codefix;
      (function(codefix2) {
        var fixId = "fixUnusedLabel";
        var errorCodes = [ts3.Diagnostics.Unused_label.code];
        codefix2.registerCodeFix({
          errorCodes,
          getCodeActions: function(context) {
            var changes = ts3.textChanges.ChangeTracker.with(context, function(t2) {
              return doChange(t2, context.sourceFile, context.span.start);
            });
            return [codefix2.createCodeFixAction(fixId, changes, ts3.Diagnostics.Remove_unused_label, fixId, ts3.Diagnostics.Remove_all_unused_labels)];
          },
          fixIds: [fixId],
          getAllCodeActions: function(context) {
            return codefix2.codeFixAll(context, errorCodes, function(changes, diag) {
              return doChange(changes, diag.file, diag.start);
            });
          }
        });
        function doChange(changes, sourceFile, start) {
          var token = ts3.getTokenAtPosition(sourceFile, start);
          var labeledStatement = ts3.cast(token.parent, ts3.isLabeledStatement);
          var pos = token.getStart(sourceFile);
          var statementPos = labeledStatement.statement.getStart(sourceFile);
          var end = ts3.positionsAreOnSameLine(pos, statementPos, sourceFile) ? statementPos : ts3.skipTrivia(sourceFile.text, ts3.findChildOfKind(labeledStatement, 58, sourceFile).end, true);
          changes.deleteRange(sourceFile, { pos, end });
        }
      })(codefix = ts3.codefix || (ts3.codefix = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var codefix;
      (function(codefix2) {
        var fixIdPlain = "fixJSDocTypes_plain";
        var fixIdNullable = "fixJSDocTypes_nullable";
        var errorCodes = [ts3.Diagnostics.JSDoc_types_can_only_be_used_inside_documentation_comments.code];
        codefix2.registerCodeFix({
          errorCodes,
          getCodeActions: function(context) {
            var sourceFile = context.sourceFile;
            var checker = context.program.getTypeChecker();
            var info = getInfo(sourceFile, context.span.start, checker);
            if (!info)
              return void 0;
            var typeNode = info.typeNode, type3 = info.type;
            var original = typeNode.getText(sourceFile);
            var actions2 = [fix(type3, fixIdPlain, ts3.Diagnostics.Change_all_jsdoc_style_types_to_TypeScript)];
            if (typeNode.kind === 306) {
              actions2.push(fix(checker.getNullableType(type3, 32768), fixIdNullable, ts3.Diagnostics.Change_all_jsdoc_style_types_to_TypeScript_and_add_undefined_to_nullable_types));
            }
            return actions2;
            function fix(type4, fixId, fixAllDescription) {
              var changes = ts3.textChanges.ChangeTracker.with(context, function(t2) {
                return doChange(t2, sourceFile, typeNode, type4, checker);
              });
              return codefix2.createCodeFixAction("jdocTypes", changes, [ts3.Diagnostics.Change_0_to_1, original, checker.typeToString(type4)], fixId, fixAllDescription);
            }
          },
          fixIds: [fixIdPlain, fixIdNullable],
          getAllCodeActions: function(context) {
            var fixId = context.fixId, program2 = context.program, sourceFile = context.sourceFile;
            var checker = program2.getTypeChecker();
            return codefix2.codeFixAll(context, errorCodes, function(changes, err2) {
              var info = getInfo(err2.file, err2.start, checker);
              if (!info)
                return;
              var typeNode = info.typeNode, type3 = info.type;
              var fixedType = typeNode.kind === 306 && fixId === fixIdNullable ? checker.getNullableType(type3, 32768) : type3;
              doChange(changes, sourceFile, typeNode, fixedType, checker);
            });
          }
        });
        function doChange(changes, sourceFile, oldTypeNode, newType, checker) {
          changes.replaceNode(sourceFile, oldTypeNode, checker.typeToTypeNode(newType, oldTypeNode, void 0));
        }
        function getInfo(sourceFile, pos, checker) {
          var decl = ts3.findAncestor(ts3.getTokenAtPosition(sourceFile, pos), isTypeContainer);
          var typeNode = decl && decl.type;
          return typeNode && { typeNode, type: checker.getTypeFromTypeNode(typeNode) };
        }
        function isTypeContainer(node) {
          switch (node.kind) {
            case 225:
            case 170:
            case 171:
            case 252:
            case 168:
            case 172:
            case 191:
            case 166:
            case 165:
            case 161:
            case 164:
            case 163:
            case 169:
            case 255:
            case 207:
            case 250:
              return true;
            default:
              return false;
          }
        }
      })(codefix = ts3.codefix || (ts3.codefix = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var codefix;
      (function(codefix2) {
        var fixId = "fixMissingCallParentheses";
        var errorCodes = [
          ts3.Diagnostics.This_condition_will_always_return_true_since_this_function_is_always_defined_Did_you_mean_to_call_it_instead.code
        ];
        codefix2.registerCodeFix({
          errorCodes,
          fixIds: [fixId],
          getCodeActions: function(context) {
            var sourceFile = context.sourceFile, span = context.span;
            var callName = getCallName(sourceFile, span.start);
            if (!callName)
              return;
            var changes = ts3.textChanges.ChangeTracker.with(context, function(t2) {
              return doChange(t2, context.sourceFile, callName);
            });
            return [codefix2.createCodeFixAction(fixId, changes, ts3.Diagnostics.Add_missing_call_parentheses, fixId, ts3.Diagnostics.Add_all_missing_call_parentheses)];
          },
          getAllCodeActions: function(context) {
            return codefix2.codeFixAll(context, errorCodes, function(changes, diag) {
              var callName = getCallName(diag.file, diag.start);
              if (callName)
                doChange(changes, diag.file, callName);
            });
          }
        });
        function doChange(changes, sourceFile, name) {
          changes.replaceNodeWithText(sourceFile, name, name.text + "()");
        }
        function getCallName(sourceFile, start) {
          var token = ts3.getTokenAtPosition(sourceFile, start);
          if (ts3.isPropertyAccessExpression(token.parent)) {
            var current = token.parent;
            while (ts3.isPropertyAccessExpression(current.parent)) {
              current = current.parent;
            }
            return current.name;
          }
          if (ts3.isIdentifier(token)) {
            return token;
          }
          return void 0;
        }
      })(codefix = ts3.codefix || (ts3.codefix = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var codefix;
      (function(codefix2) {
        var fixId = "fixAwaitInSyncFunction";
        var errorCodes = [
          ts3.Diagnostics.await_expressions_are_only_allowed_within_async_functions_and_at_the_top_levels_of_modules.code,
          ts3.Diagnostics.for_await_loops_are_only_allowed_within_async_functions_and_at_the_top_levels_of_modules.code
        ];
        codefix2.registerCodeFix({
          errorCodes,
          getCodeActions: function(context) {
            var sourceFile = context.sourceFile, span = context.span;
            var nodes = getNodes(sourceFile, span.start);
            if (!nodes)
              return void 0;
            var changes = ts3.textChanges.ChangeTracker.with(context, function(t2) {
              return doChange(t2, sourceFile, nodes);
            });
            return [codefix2.createCodeFixAction(fixId, changes, ts3.Diagnostics.Add_async_modifier_to_containing_function, fixId, ts3.Diagnostics.Add_all_missing_async_modifiers)];
          },
          fixIds: [fixId],
          getAllCodeActions: function(context) {
            var seen = new ts3.Map();
            return codefix2.codeFixAll(context, errorCodes, function(changes, diag) {
              var nodes = getNodes(diag.file, diag.start);
              if (!nodes || !ts3.addToSeen(seen, ts3.getNodeId(nodes.insertBefore)))
                return;
              doChange(changes, context.sourceFile, nodes);
            });
          }
        });
        function getReturnType(expr) {
          if (expr.type) {
            return expr.type;
          }
          if (ts3.isVariableDeclaration(expr.parent) && expr.parent.type && ts3.isFunctionTypeNode(expr.parent.type)) {
            return expr.parent.type.type;
          }
        }
        function getNodes(sourceFile, start) {
          var token = ts3.getTokenAtPosition(sourceFile, start);
          var containingFunction = ts3.getContainingFunction(token);
          if (!containingFunction) {
            return;
          }
          var insertBefore;
          switch (containingFunction.kind) {
            case 166:
              insertBefore = containingFunction.name;
              break;
            case 252:
            case 209:
              insertBefore = ts3.findChildOfKind(containingFunction, 97, sourceFile);
              break;
            case 210:
              insertBefore = ts3.findChildOfKind(containingFunction, 20, sourceFile) || ts3.first(containingFunction.parameters);
              break;
            default:
              return;
          }
          return insertBefore && {
            insertBefore,
            returnType: getReturnType(containingFunction)
          };
        }
        function doChange(changes, sourceFile, _a2) {
          var insertBefore = _a2.insertBefore, returnType2 = _a2.returnType;
          if (returnType2) {
            var entityName = ts3.getEntityNameFromTypeNode(returnType2);
            if (!entityName || entityName.kind !== 78 || entityName.text !== "Promise") {
              changes.replaceNode(sourceFile, returnType2, ts3.factory.createTypeReferenceNode("Promise", ts3.factory.createNodeArray([returnType2])));
            }
          }
          changes.insertModifierBefore(sourceFile, 129, insertBefore);
        }
      })(codefix = ts3.codefix || (ts3.codefix = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var codefix;
      (function(codefix2) {
        var errorCodes = [
          ts3.Diagnostics._0_is_defined_as_an_accessor_in_class_1_but_is_overridden_here_in_2_as_an_instance_property.code,
          ts3.Diagnostics._0_is_defined_as_a_property_in_class_1_but_is_overridden_here_in_2_as_an_accessor.code
        ];
        var fixId = "fixPropertyOverrideAccessor";
        codefix2.registerCodeFix({
          errorCodes,
          getCodeActions: function(context) {
            var edits = doChange(context.sourceFile, context.span.start, context.span.length, context.errorCode, context);
            if (edits) {
              return [codefix2.createCodeFixAction(fixId, edits, ts3.Diagnostics.Generate_get_and_set_accessors, fixId, ts3.Diagnostics.Generate_get_and_set_accessors_for_all_overriding_properties)];
            }
          },
          fixIds: [fixId],
          getAllCodeActions: function(context) {
            return codefix2.codeFixAll(context, errorCodes, function(changes, diag) {
              var edits = doChange(diag.file, diag.start, diag.length, diag.code, context);
              if (edits) {
                for (var _i = 0, edits_2 = edits; _i < edits_2.length; _i++) {
                  var edit = edits_2[_i];
                  changes.pushRaw(context.sourceFile, edit);
                }
              }
            });
          }
        });
        function doChange(file, start, length, code, context) {
          var startPosition;
          var endPosition;
          if (code === ts3.Diagnostics._0_is_defined_as_an_accessor_in_class_1_but_is_overridden_here_in_2_as_an_instance_property.code) {
            startPosition = start;
            endPosition = start + length;
          } else if (code === ts3.Diagnostics._0_is_defined_as_a_property_in_class_1_but_is_overridden_here_in_2_as_an_accessor.code) {
            var checker = context.program.getTypeChecker();
            var node = ts3.getTokenAtPosition(file, start).parent;
            ts3.Debug.assert(ts3.isAccessor(node), "error span of fixPropertyOverrideAccessor should only be on an accessor");
            var containingClass = node.parent;
            ts3.Debug.assert(ts3.isClassLike(containingClass), "erroneous accessors should only be inside classes");
            var base = ts3.singleOrUndefined(codefix2.getAllSupers(containingClass, checker));
            if (!base)
              return [];
            var name = ts3.unescapeLeadingUnderscores(ts3.getTextOfPropertyName(node.name));
            var baseProp = checker.getPropertyOfType(checker.getTypeAtLocation(base), name);
            if (!baseProp || !baseProp.valueDeclaration)
              return [];
            startPosition = baseProp.valueDeclaration.pos;
            endPosition = baseProp.valueDeclaration.end;
            file = ts3.getSourceFileOfNode(baseProp.valueDeclaration);
          } else {
            ts3.Debug.fail("fixPropertyOverrideAccessor codefix got unexpected error code " + code);
          }
          return codefix2.generateAccessorFromProperty(file, context.program, startPosition, endPosition, context, ts3.Diagnostics.Generate_get_and_set_accessors.message);
        }
      })(codefix = ts3.codefix || (ts3.codefix = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var codefix;
      (function(codefix2) {
        var fixId = "inferFromUsage";
        var errorCodes = [
          ts3.Diagnostics.Variable_0_implicitly_has_type_1_in_some_locations_where_its_type_cannot_be_determined.code,
          ts3.Diagnostics.Variable_0_implicitly_has_an_1_type.code,
          ts3.Diagnostics.Parameter_0_implicitly_has_an_1_type.code,
          ts3.Diagnostics.Rest_parameter_0_implicitly_has_an_any_type.code,
          ts3.Diagnostics.Property_0_implicitly_has_type_any_because_its_get_accessor_lacks_a_return_type_annotation.code,
          ts3.Diagnostics._0_which_lacks_return_type_annotation_implicitly_has_an_1_return_type.code,
          ts3.Diagnostics.Property_0_implicitly_has_type_any_because_its_set_accessor_lacks_a_parameter_type_annotation.code,
          ts3.Diagnostics.Member_0_implicitly_has_an_1_type.code,
          ts3.Diagnostics.Variable_0_implicitly_has_type_1_in_some_locations_but_a_better_type_may_be_inferred_from_usage.code,
          ts3.Diagnostics.Variable_0_implicitly_has_an_1_type_but_a_better_type_may_be_inferred_from_usage.code,
          ts3.Diagnostics.Parameter_0_implicitly_has_an_1_type_but_a_better_type_may_be_inferred_from_usage.code,
          ts3.Diagnostics.Rest_parameter_0_implicitly_has_an_any_type_but_a_better_type_may_be_inferred_from_usage.code,
          ts3.Diagnostics.Property_0_implicitly_has_type_any_but_a_better_type_for_its_get_accessor_may_be_inferred_from_usage.code,
          ts3.Diagnostics._0_implicitly_has_an_1_return_type_but_a_better_type_may_be_inferred_from_usage.code,
          ts3.Diagnostics.Property_0_implicitly_has_type_any_but_a_better_type_for_its_set_accessor_may_be_inferred_from_usage.code,
          ts3.Diagnostics.Member_0_implicitly_has_an_1_type_but_a_better_type_may_be_inferred_from_usage.code,
          ts3.Diagnostics.this_implicitly_has_type_any_because_it_does_not_have_a_type_annotation.code
        ];
        codefix2.registerCodeFix({
          errorCodes,
          getCodeActions: function(context) {
            var sourceFile = context.sourceFile, program2 = context.program, start = context.span.start, errorCode = context.errorCode, cancellationToken = context.cancellationToken, host = context.host, preferences = context.preferences;
            var token = ts3.getTokenAtPosition(sourceFile, start);
            var declaration;
            var changes = ts3.textChanges.ChangeTracker.with(context, function(changes2) {
              declaration = doChange(changes2, sourceFile, token, errorCode, program2, cancellationToken, ts3.returnTrue, host, preferences);
            });
            var name = declaration && ts3.getNameOfDeclaration(declaration);
            return !name || changes.length === 0 ? void 0 : [codefix2.createCodeFixAction(fixId, changes, [getDiagnostic(errorCode, token), name.getText(sourceFile)], fixId, ts3.Diagnostics.Infer_all_types_from_usage)];
          },
          fixIds: [fixId],
          getAllCodeActions: function(context) {
            var sourceFile = context.sourceFile, program2 = context.program, cancellationToken = context.cancellationToken, host = context.host, preferences = context.preferences;
            var markSeen = ts3.nodeSeenTracker();
            return codefix2.codeFixAll(context, errorCodes, function(changes, err2) {
              doChange(changes, sourceFile, ts3.getTokenAtPosition(err2.file, err2.start), err2.code, program2, cancellationToken, markSeen, host, preferences);
            });
          }
        });
        function getDiagnostic(errorCode, token) {
          switch (errorCode) {
            case ts3.Diagnostics.Parameter_0_implicitly_has_an_1_type.code:
            case ts3.Diagnostics.Parameter_0_implicitly_has_an_1_type_but_a_better_type_may_be_inferred_from_usage.code:
              return ts3.isSetAccessorDeclaration(ts3.getContainingFunction(token)) ? ts3.Diagnostics.Infer_type_of_0_from_usage : ts3.Diagnostics.Infer_parameter_types_from_usage;
            case ts3.Diagnostics.Rest_parameter_0_implicitly_has_an_any_type.code:
            case ts3.Diagnostics.Rest_parameter_0_implicitly_has_an_any_type_but_a_better_type_may_be_inferred_from_usage.code:
              return ts3.Diagnostics.Infer_parameter_types_from_usage;
            case ts3.Diagnostics.this_implicitly_has_type_any_because_it_does_not_have_a_type_annotation.code:
              return ts3.Diagnostics.Infer_this_type_of_0_from_usage;
            default:
              return ts3.Diagnostics.Infer_type_of_0_from_usage;
          }
        }
        function mapSuggestionDiagnostic(errorCode) {
          switch (errorCode) {
            case ts3.Diagnostics.Variable_0_implicitly_has_type_1_in_some_locations_but_a_better_type_may_be_inferred_from_usage.code:
              return ts3.Diagnostics.Variable_0_implicitly_has_type_1_in_some_locations_where_its_type_cannot_be_determined.code;
            case ts3.Diagnostics.Variable_0_implicitly_has_an_1_type_but_a_better_type_may_be_inferred_from_usage.code:
              return ts3.Diagnostics.Variable_0_implicitly_has_an_1_type.code;
            case ts3.Diagnostics.Parameter_0_implicitly_has_an_1_type_but_a_better_type_may_be_inferred_from_usage.code:
              return ts3.Diagnostics.Parameter_0_implicitly_has_an_1_type.code;
            case ts3.Diagnostics.Rest_parameter_0_implicitly_has_an_any_type_but_a_better_type_may_be_inferred_from_usage.code:
              return ts3.Diagnostics.Rest_parameter_0_implicitly_has_an_any_type.code;
            case ts3.Diagnostics.Property_0_implicitly_has_type_any_but_a_better_type_for_its_get_accessor_may_be_inferred_from_usage.code:
              return ts3.Diagnostics.Property_0_implicitly_has_type_any_because_its_get_accessor_lacks_a_return_type_annotation.code;
            case ts3.Diagnostics._0_implicitly_has_an_1_return_type_but_a_better_type_may_be_inferred_from_usage.code:
              return ts3.Diagnostics._0_which_lacks_return_type_annotation_implicitly_has_an_1_return_type.code;
            case ts3.Diagnostics.Property_0_implicitly_has_type_any_but_a_better_type_for_its_set_accessor_may_be_inferred_from_usage.code:
              return ts3.Diagnostics.Property_0_implicitly_has_type_any_because_its_set_accessor_lacks_a_parameter_type_annotation.code;
            case ts3.Diagnostics.Member_0_implicitly_has_an_1_type_but_a_better_type_may_be_inferred_from_usage.code:
              return ts3.Diagnostics.Member_0_implicitly_has_an_1_type.code;
          }
          return errorCode;
        }
        function doChange(changes, sourceFile, token, errorCode, program2, cancellationToken, markSeen, host, preferences) {
          if (!ts3.isParameterPropertyModifier(token.kind) && token.kind !== 78 && token.kind !== 25 && token.kind !== 107) {
            return void 0;
          }
          var parent = token.parent;
          var importAdder = codefix2.createImportAdder(sourceFile, program2, preferences, host);
          errorCode = mapSuggestionDiagnostic(errorCode);
          switch (errorCode) {
            case ts3.Diagnostics.Member_0_implicitly_has_an_1_type.code:
            case ts3.Diagnostics.Variable_0_implicitly_has_type_1_in_some_locations_where_its_type_cannot_be_determined.code:
              if (ts3.isVariableDeclaration(parent) && markSeen(parent) || ts3.isPropertyDeclaration(parent) || ts3.isPropertySignature(parent)) {
                annotateVariableDeclaration(changes, importAdder, sourceFile, parent, program2, host, cancellationToken);
                importAdder.writeFixes(changes);
                return parent;
              }
              if (ts3.isPropertyAccessExpression(parent)) {
                var type3 = inferTypeForVariableFromUsage(parent.name, program2, cancellationToken);
                var typeNode = ts3.getTypeNodeIfAccessible(type3, parent, program2, host);
                if (typeNode) {
                  var typeTag = ts3.factory.createJSDocTypeTag(void 0, ts3.factory.createJSDocTypeExpression(typeNode), void 0);
                  addJSDocTags(changes, sourceFile, ts3.cast(parent.parent.parent, ts3.isExpressionStatement), [typeTag]);
                }
                importAdder.writeFixes(changes);
                return parent;
              }
              return void 0;
            case ts3.Diagnostics.Variable_0_implicitly_has_an_1_type.code: {
              var symbol = program2.getTypeChecker().getSymbolAtLocation(token);
              if (symbol && symbol.valueDeclaration && ts3.isVariableDeclaration(symbol.valueDeclaration) && markSeen(symbol.valueDeclaration)) {
                annotateVariableDeclaration(changes, importAdder, sourceFile, symbol.valueDeclaration, program2, host, cancellationToken);
                importAdder.writeFixes(changes);
                return symbol.valueDeclaration;
              }
              return void 0;
            }
          }
          var containingFunction = ts3.getContainingFunction(token);
          if (containingFunction === void 0) {
            return void 0;
          }
          var declaration;
          switch (errorCode) {
            case ts3.Diagnostics.Parameter_0_implicitly_has_an_1_type.code:
              if (ts3.isSetAccessorDeclaration(containingFunction)) {
                annotateSetAccessor(changes, importAdder, sourceFile, containingFunction, program2, host, cancellationToken);
                declaration = containingFunction;
                break;
              }
            case ts3.Diagnostics.Rest_parameter_0_implicitly_has_an_any_type.code:
              if (markSeen(containingFunction)) {
                var param = ts3.cast(parent, ts3.isParameter);
                annotateParameters(changes, importAdder, sourceFile, param, containingFunction, program2, host, cancellationToken);
                declaration = param;
              }
              break;
            case ts3.Diagnostics.Property_0_implicitly_has_type_any_because_its_get_accessor_lacks_a_return_type_annotation.code:
            case ts3.Diagnostics._0_which_lacks_return_type_annotation_implicitly_has_an_1_return_type.code:
              if (ts3.isGetAccessorDeclaration(containingFunction) && ts3.isIdentifier(containingFunction.name)) {
                annotate(changes, importAdder, sourceFile, containingFunction, inferTypeForVariableFromUsage(containingFunction.name, program2, cancellationToken), program2, host);
                declaration = containingFunction;
              }
              break;
            case ts3.Diagnostics.Property_0_implicitly_has_type_any_because_its_set_accessor_lacks_a_parameter_type_annotation.code:
              if (ts3.isSetAccessorDeclaration(containingFunction)) {
                annotateSetAccessor(changes, importAdder, sourceFile, containingFunction, program2, host, cancellationToken);
                declaration = containingFunction;
              }
              break;
            case ts3.Diagnostics.this_implicitly_has_type_any_because_it_does_not_have_a_type_annotation.code:
              if (ts3.textChanges.isThisTypeAnnotatable(containingFunction) && markSeen(containingFunction)) {
                annotateThis(changes, sourceFile, containingFunction, program2, host, cancellationToken);
                declaration = containingFunction;
              }
              break;
            default:
              return ts3.Debug.fail(String(errorCode));
          }
          importAdder.writeFixes(changes);
          return declaration;
        }
        function annotateVariableDeclaration(changes, importAdder, sourceFile, declaration, program2, host, cancellationToken) {
          if (ts3.isIdentifier(declaration.name)) {
            annotate(changes, importAdder, sourceFile, declaration, inferTypeForVariableFromUsage(declaration.name, program2, cancellationToken), program2, host);
          }
        }
        function annotateParameters(changes, importAdder, sourceFile, parameterDeclaration, containingFunction, program2, host, cancellationToken) {
          if (!ts3.isIdentifier(parameterDeclaration.name)) {
            return;
          }
          var parameterInferences = inferTypeForParametersFromUsage(containingFunction, sourceFile, program2, cancellationToken);
          ts3.Debug.assert(containingFunction.parameters.length === parameterInferences.length, "Parameter count and inference count should match");
          if (ts3.isInJSFile(containingFunction)) {
            annotateJSDocParameters(changes, sourceFile, parameterInferences, program2, host);
          } else {
            var needParens = ts3.isArrowFunction(containingFunction) && !ts3.findChildOfKind(containingFunction, 20, sourceFile);
            if (needParens)
              changes.insertNodeBefore(sourceFile, ts3.first(containingFunction.parameters), ts3.factory.createToken(20));
            for (var _i = 0, parameterInferences_1 = parameterInferences; _i < parameterInferences_1.length; _i++) {
              var _a2 = parameterInferences_1[_i], declaration = _a2.declaration, type3 = _a2.type;
              if (declaration && !declaration.type && !declaration.initializer) {
                annotate(changes, importAdder, sourceFile, declaration, type3, program2, host);
              }
            }
            if (needParens)
              changes.insertNodeAfter(sourceFile, ts3.last(containingFunction.parameters), ts3.factory.createToken(21));
          }
        }
        function annotateThis(changes, sourceFile, containingFunction, program2, host, cancellationToken) {
          var references = getFunctionReferences(containingFunction, sourceFile, program2, cancellationToken);
          if (!references || !references.length) {
            return;
          }
          var thisInference = inferTypeFromReferences(program2, references, cancellationToken).thisParameter();
          var typeNode = ts3.getTypeNodeIfAccessible(thisInference, containingFunction, program2, host);
          if (!typeNode) {
            return;
          }
          if (ts3.isInJSFile(containingFunction)) {
            annotateJSDocThis(changes, sourceFile, containingFunction, typeNode);
          } else {
            changes.tryInsertThisTypeAnnotation(sourceFile, containingFunction, typeNode);
          }
        }
        function annotateJSDocThis(changes, sourceFile, containingFunction, typeNode) {
          addJSDocTags(changes, sourceFile, containingFunction, [
            ts3.factory.createJSDocThisTag(void 0, ts3.factory.createJSDocTypeExpression(typeNode))
          ]);
        }
        function annotateSetAccessor(changes, importAdder, sourceFile, setAccessorDeclaration, program2, host, cancellationToken) {
          var param = ts3.firstOrUndefined(setAccessorDeclaration.parameters);
          if (param && ts3.isIdentifier(setAccessorDeclaration.name) && ts3.isIdentifier(param.name)) {
            var type3 = inferTypeForVariableFromUsage(setAccessorDeclaration.name, program2, cancellationToken);
            if (type3 === program2.getTypeChecker().getAnyType()) {
              type3 = inferTypeForVariableFromUsage(param.name, program2, cancellationToken);
            }
            if (ts3.isInJSFile(setAccessorDeclaration)) {
              annotateJSDocParameters(changes, sourceFile, [{ declaration: param, type: type3 }], program2, host);
            } else {
              annotate(changes, importAdder, sourceFile, param, type3, program2, host);
            }
          }
        }
        function annotate(changes, importAdder, sourceFile, declaration, type3, program2, host) {
          var typeNode = ts3.getTypeNodeIfAccessible(type3, declaration, program2, host);
          if (typeNode) {
            if (ts3.isInJSFile(sourceFile) && declaration.kind !== 163) {
              var parent = ts3.isVariableDeclaration(declaration) ? ts3.tryCast(declaration.parent.parent, ts3.isVariableStatement) : declaration;
              if (!parent) {
                return;
              }
              var typeExpression = ts3.factory.createJSDocTypeExpression(typeNode);
              var typeTag = ts3.isGetAccessorDeclaration(declaration) ? ts3.factory.createJSDocReturnTag(void 0, typeExpression, void 0) : ts3.factory.createJSDocTypeTag(void 0, typeExpression, void 0);
              addJSDocTags(changes, sourceFile, parent, [typeTag]);
            } else if (!tryReplaceImportTypeNodeWithAutoImport(typeNode, declaration, sourceFile, changes, importAdder, ts3.getEmitScriptTarget(program2.getCompilerOptions()))) {
              changes.tryInsertTypeAnnotation(sourceFile, declaration, typeNode);
            }
          }
        }
        function tryReplaceImportTypeNodeWithAutoImport(typeNode, declaration, sourceFile, changes, importAdder, scriptTarget) {
          var importableReference = codefix2.tryGetAutoImportableReferenceFromTypeNode(typeNode, scriptTarget);
          if (importableReference && changes.tryInsertTypeAnnotation(sourceFile, declaration, importableReference.typeNode)) {
            ts3.forEach(importableReference.symbols, function(s2) {
              return importAdder.addImportFromExportedSymbol(s2, true);
            });
            return true;
          }
          return false;
        }
        function annotateJSDocParameters(changes, sourceFile, parameterInferences, program2, host) {
          var signature = parameterInferences.length && parameterInferences[0].declaration.parent;
          if (!signature) {
            return;
          }
          var inferences = ts3.mapDefined(parameterInferences, function(inference) {
            var param = inference.declaration;
            if (param.initializer || ts3.getJSDocType(param) || !ts3.isIdentifier(param.name)) {
              return;
            }
            var typeNode = inference.type && ts3.getTypeNodeIfAccessible(inference.type, param, program2, host);
            if (typeNode) {
              var name = ts3.factory.cloneNode(param.name);
              ts3.setEmitFlags(name, 1536 | 2048);
              return { name: ts3.factory.cloneNode(param.name), param, isOptional: !!inference.isOptional, typeNode };
            }
          });
          if (!inferences.length) {
            return;
          }
          if (ts3.isArrowFunction(signature) || ts3.isFunctionExpression(signature)) {
            var needParens = ts3.isArrowFunction(signature) && !ts3.findChildOfKind(signature, 20, sourceFile);
            if (needParens) {
              changes.insertNodeBefore(sourceFile, ts3.first(signature.parameters), ts3.factory.createToken(20));
            }
            ts3.forEach(inferences, function(_a2) {
              var typeNode = _a2.typeNode, param = _a2.param;
              var typeTag = ts3.factory.createJSDocTypeTag(void 0, ts3.factory.createJSDocTypeExpression(typeNode));
              var jsDoc = ts3.factory.createJSDocComment(void 0, [typeTag]);
              changes.insertNodeAt(sourceFile, param.getStart(sourceFile), jsDoc, { suffix: " " });
            });
            if (needParens) {
              changes.insertNodeAfter(sourceFile, ts3.last(signature.parameters), ts3.factory.createToken(21));
            }
          } else {
            var paramTags = ts3.map(inferences, function(_a2) {
              var name = _a2.name, typeNode = _a2.typeNode, isOptional = _a2.isOptional;
              return ts3.factory.createJSDocParameterTag(void 0, name, !!isOptional, ts3.factory.createJSDocTypeExpression(typeNode), false, void 0);
            });
            addJSDocTags(changes, sourceFile, signature, paramTags);
          }
        }
        function addJSDocTags(changes, sourceFile, parent, newTags) {
          var comments = ts3.flatMap(parent.jsDoc, function(j) {
            return typeof j.comment === "string" ? ts3.factory.createJSDocText(j.comment) : j.comment;
          });
          var oldTags = ts3.flatMapToMutable(parent.jsDoc, function(j) {
            return j.tags;
          });
          var unmergedNewTags = newTags.filter(function(newTag) {
            return !oldTags || !oldTags.some(function(tag2, i3) {
              var merged = tryMergeJsdocTags(tag2, newTag);
              if (merged)
                oldTags[i3] = merged;
              return !!merged;
            });
          });
          var tag = ts3.factory.createJSDocComment(ts3.factory.createNodeArray(ts3.intersperse(comments, ts3.factory.createJSDocText("\n"))), ts3.factory.createNodeArray(__spreadArray(__spreadArray([], oldTags || ts3.emptyArray), unmergedNewTags)));
          var jsDocNode = parent.kind === 210 ? getJsDocNodeForArrowFunction(parent) : parent;
          jsDocNode.jsDoc = parent.jsDoc;
          jsDocNode.jsDocCache = parent.jsDocCache;
          changes.insertJsdocCommentBefore(sourceFile, jsDocNode, tag);
        }
        codefix2.addJSDocTags = addJSDocTags;
        function getJsDocNodeForArrowFunction(signature) {
          if (signature.parent.kind === 164) {
            return signature.parent;
          }
          return signature.parent.parent;
        }
        function tryMergeJsdocTags(oldTag, newTag) {
          if (oldTag.kind !== newTag.kind) {
            return void 0;
          }
          switch (oldTag.kind) {
            case 330: {
              var oldParam = oldTag;
              var newParam = newTag;
              return ts3.isIdentifier(oldParam.name) && ts3.isIdentifier(newParam.name) && oldParam.name.escapedText === newParam.name.escapedText ? ts3.factory.createJSDocParameterTag(void 0, newParam.name, false, newParam.typeExpression, newParam.isNameFirst, oldParam.comment) : void 0;
            }
            case 331:
              return ts3.factory.createJSDocReturnTag(void 0, newTag.typeExpression, oldTag.comment);
          }
        }
        function getReferences(token, program2, cancellationToken) {
          return ts3.mapDefined(ts3.FindAllReferences.getReferenceEntriesForNode(-1, token, program2, program2.getSourceFiles(), cancellationToken), function(entry) {
            return entry.kind !== 0 ? ts3.tryCast(entry.node, ts3.isIdentifier) : void 0;
          });
        }
        function inferTypeForVariableFromUsage(token, program2, cancellationToken) {
          var references = getReferences(token, program2, cancellationToken);
          return inferTypeFromReferences(program2, references, cancellationToken).single();
        }
        function inferTypeForParametersFromUsage(func2, sourceFile, program2, cancellationToken) {
          var references = getFunctionReferences(func2, sourceFile, program2, cancellationToken);
          return references && inferTypeFromReferences(program2, references, cancellationToken).parameters(func2) || func2.parameters.map(function(p) {
            return {
              declaration: p,
              type: ts3.isIdentifier(p.name) ? inferTypeForVariableFromUsage(p.name, program2, cancellationToken) : program2.getTypeChecker().getAnyType()
            };
          });
        }
        function getFunctionReferences(containingFunction, sourceFile, program2, cancellationToken) {
          var searchToken;
          switch (containingFunction.kind) {
            case 167:
              searchToken = ts3.findChildOfKind(containingFunction, 132, sourceFile);
              break;
            case 210:
            case 209:
              var parent = containingFunction.parent;
              searchToken = (ts3.isVariableDeclaration(parent) || ts3.isPropertyDeclaration(parent)) && ts3.isIdentifier(parent.name) ? parent.name : containingFunction.name;
              break;
            case 252:
            case 166:
            case 165:
              searchToken = containingFunction.name;
              break;
          }
          if (!searchToken) {
            return void 0;
          }
          return getReferences(searchToken, program2, cancellationToken);
        }
        function inferTypeFromReferences(program2, references, cancellationToken) {
          var checker = program2.getTypeChecker();
          var builtinConstructors = {
            string: function() {
              return checker.getStringType();
            },
            number: function() {
              return checker.getNumberType();
            },
            Array: function(t2) {
              return checker.createArrayType(t2);
            },
            Promise: function(t2) {
              return checker.createPromiseType(t2);
            }
          };
          var builtins = [
            checker.getStringType(),
            checker.getNumberType(),
            checker.createArrayType(checker.getAnyType()),
            checker.createPromiseType(checker.getAnyType())
          ];
          return {
            single,
            parameters,
            thisParameter
          };
          function createEmptyUsage() {
            return {
              isNumber: void 0,
              isString: void 0,
              isNumberOrString: void 0,
              candidateTypes: void 0,
              properties: void 0,
              calls: void 0,
              constructs: void 0,
              numberIndex: void 0,
              stringIndex: void 0,
              candidateThisTypes: void 0,
              inferredTypes: void 0
            };
          }
          function combineUsages(usages) {
            var combinedProperties = new ts3.Map();
            for (var _i = 0, usages_1 = usages; _i < usages_1.length; _i++) {
              var u2 = usages_1[_i];
              if (u2.properties) {
                u2.properties.forEach(function(p, name) {
                  if (!combinedProperties.has(name)) {
                    combinedProperties.set(name, []);
                  }
                  combinedProperties.get(name).push(p);
                });
              }
            }
            var properties = new ts3.Map();
            combinedProperties.forEach(function(ps, name) {
              properties.set(name, combineUsages(ps));
            });
            return {
              isNumber: usages.some(function(u3) {
                return u3.isNumber;
              }),
              isString: usages.some(function(u3) {
                return u3.isString;
              }),
              isNumberOrString: usages.some(function(u3) {
                return u3.isNumberOrString;
              }),
              candidateTypes: ts3.flatMap(usages, function(u3) {
                return u3.candidateTypes;
              }),
              properties,
              calls: ts3.flatMap(usages, function(u3) {
                return u3.calls;
              }),
              constructs: ts3.flatMap(usages, function(u3) {
                return u3.constructs;
              }),
              numberIndex: ts3.forEach(usages, function(u3) {
                return u3.numberIndex;
              }),
              stringIndex: ts3.forEach(usages, function(u3) {
                return u3.stringIndex;
              }),
              candidateThisTypes: ts3.flatMap(usages, function(u3) {
                return u3.candidateThisTypes;
              }),
              inferredTypes: void 0
            };
          }
          function single() {
            return combineTypes(inferTypesFromReferencesSingle(references));
          }
          function parameters(declaration) {
            if (references.length === 0 || !declaration.parameters) {
              return void 0;
            }
            var usage = createEmptyUsage();
            for (var _i = 0, references_3 = references; _i < references_3.length; _i++) {
              var reference = references_3[_i];
              cancellationToken.throwIfCancellationRequested();
              calculateUsageOfNode(reference, usage);
            }
            var calls = __spreadArray(__spreadArray([], usage.constructs || []), usage.calls || []);
            return declaration.parameters.map(function(parameter, parameterIndex) {
              var types2 = [];
              var isRest = ts3.isRestParameter(parameter);
              var isOptional = false;
              for (var _i2 = 0, calls_1 = calls; _i2 < calls_1.length; _i2++) {
                var call = calls_1[_i2];
                if (call.argumentTypes.length <= parameterIndex) {
                  isOptional = ts3.isInJSFile(declaration);
                  types2.push(checker.getUndefinedType());
                } else if (isRest) {
                  for (var i3 = parameterIndex; i3 < call.argumentTypes.length; i3++) {
                    types2.push(checker.getBaseTypeOfLiteralType(call.argumentTypes[i3]));
                  }
                } else {
                  types2.push(checker.getBaseTypeOfLiteralType(call.argumentTypes[parameterIndex]));
                }
              }
              if (ts3.isIdentifier(parameter.name)) {
                var inferred = inferTypesFromReferencesSingle(getReferences(parameter.name, program2, cancellationToken));
                types2.push.apply(types2, isRest ? ts3.mapDefined(inferred, checker.getElementTypeOfArrayType) : inferred);
              }
              var type3 = combineTypes(types2);
              return {
                type: isRest ? checker.createArrayType(type3) : type3,
                isOptional: isOptional && !isRest,
                declaration: parameter
              };
            });
          }
          function thisParameter() {
            var usage = createEmptyUsage();
            for (var _i = 0, references_4 = references; _i < references_4.length; _i++) {
              var reference = references_4[_i];
              cancellationToken.throwIfCancellationRequested();
              calculateUsageOfNode(reference, usage);
            }
            return combineTypes(usage.candidateThisTypes || ts3.emptyArray);
          }
          function inferTypesFromReferencesSingle(references2) {
            var usage = createEmptyUsage();
            for (var _i = 0, references_5 = references2; _i < references_5.length; _i++) {
              var reference = references_5[_i];
              cancellationToken.throwIfCancellationRequested();
              calculateUsageOfNode(reference, usage);
            }
            return inferTypes(usage);
          }
          function calculateUsageOfNode(node, usage) {
            while (ts3.isRightSideOfQualifiedNameOrPropertyAccess(node)) {
              node = node.parent;
            }
            switch (node.parent.kind) {
              case 234:
                inferTypeFromExpressionStatement(node, usage);
                break;
              case 216:
                usage.isNumber = true;
                break;
              case 215:
                inferTypeFromPrefixUnaryExpression(node.parent, usage);
                break;
              case 217:
                inferTypeFromBinaryExpression(node, node.parent, usage);
                break;
              case 285:
              case 286:
                inferTypeFromSwitchStatementLabel(node.parent, usage);
                break;
              case 204:
              case 205:
                if (node.parent.expression === node) {
                  inferTypeFromCallExpression(node.parent, usage);
                } else {
                  inferTypeFromContextualType(node, usage);
                }
                break;
              case 202:
                inferTypeFromPropertyAccessExpression(node.parent, usage);
                break;
              case 203:
                inferTypeFromPropertyElementExpression(node.parent, node, usage);
                break;
              case 289:
              case 290:
                inferTypeFromPropertyAssignment(node.parent, usage);
                break;
              case 164:
                inferTypeFromPropertyDeclaration(node.parent, usage);
                break;
              case 250: {
                var _a2 = node.parent, name = _a2.name, initializer = _a2.initializer;
                if (node === name) {
                  if (initializer) {
                    addCandidateType(usage, checker.getTypeAtLocation(initializer));
                  }
                  break;
                }
              }
              default:
                return inferTypeFromContextualType(node, usage);
            }
          }
          function inferTypeFromContextualType(node, usage) {
            if (ts3.isExpressionNode(node)) {
              addCandidateType(usage, checker.getContextualType(node));
            }
          }
          function inferTypeFromExpressionStatement(node, usage) {
            addCandidateType(usage, ts3.isCallExpression(node) ? checker.getVoidType() : checker.getAnyType());
          }
          function inferTypeFromPrefixUnaryExpression(node, usage) {
            switch (node.operator) {
              case 45:
              case 46:
              case 40:
              case 54:
                usage.isNumber = true;
                break;
              case 39:
                usage.isNumberOrString = true;
                break;
            }
          }
          function inferTypeFromBinaryExpression(node, parent, usage) {
            switch (parent.operatorToken.kind) {
              case 42:
              case 41:
              case 43:
              case 44:
              case 47:
              case 48:
              case 49:
              case 50:
              case 51:
              case 52:
              case 64:
              case 66:
              case 65:
              case 67:
              case 68:
              case 72:
              case 73:
              case 77:
              case 69:
              case 71:
              case 70:
              case 40:
              case 29:
              case 32:
              case 31:
              case 33:
                var operandType = checker.getTypeAtLocation(parent.left === node ? parent.right : parent.left);
                if (operandType.flags & 1056) {
                  addCandidateType(usage, operandType);
                } else {
                  usage.isNumber = true;
                }
                break;
              case 63:
              case 39:
                var otherOperandType = checker.getTypeAtLocation(parent.left === node ? parent.right : parent.left);
                if (otherOperandType.flags & 1056) {
                  addCandidateType(usage, otherOperandType);
                } else if (otherOperandType.flags & 296) {
                  usage.isNumber = true;
                } else if (otherOperandType.flags & 402653316) {
                  usage.isString = true;
                } else if (otherOperandType.flags & 1) {
                } else {
                  usage.isNumberOrString = true;
                }
                break;
              case 62:
              case 34:
              case 36:
              case 37:
              case 35:
                addCandidateType(usage, checker.getTypeAtLocation(parent.left === node ? parent.right : parent.left));
                break;
              case 100:
                if (node === parent.left) {
                  usage.isString = true;
                }
                break;
              case 56:
              case 60:
                if (node === parent.left && (node.parent.parent.kind === 250 || ts3.isAssignmentExpression(node.parent.parent, true))) {
                  addCandidateType(usage, checker.getTypeAtLocation(parent.right));
                }
                break;
              case 55:
              case 27:
              case 101:
                break;
            }
          }
          function inferTypeFromSwitchStatementLabel(parent, usage) {
            addCandidateType(usage, checker.getTypeAtLocation(parent.parent.parent.expression));
          }
          function inferTypeFromCallExpression(parent, usage) {
            var call = {
              argumentTypes: [],
              return_: createEmptyUsage()
            };
            if (parent.arguments) {
              for (var _i = 0, _a2 = parent.arguments; _i < _a2.length; _i++) {
                var argument = _a2[_i];
                call.argumentTypes.push(checker.getTypeAtLocation(argument));
              }
            }
            calculateUsageOfNode(parent, call.return_);
            if (parent.kind === 204) {
              (usage.calls || (usage.calls = [])).push(call);
            } else {
              (usage.constructs || (usage.constructs = [])).push(call);
            }
          }
          function inferTypeFromPropertyAccessExpression(parent, usage) {
            var name = ts3.escapeLeadingUnderscores(parent.name.text);
            if (!usage.properties) {
              usage.properties = new ts3.Map();
            }
            var propertyUsage = usage.properties.get(name) || createEmptyUsage();
            calculateUsageOfNode(parent, propertyUsage);
            usage.properties.set(name, propertyUsage);
          }
          function inferTypeFromPropertyElementExpression(parent, node, usage) {
            if (node === parent.argumentExpression) {
              usage.isNumberOrString = true;
              return;
            } else {
              var indexType = checker.getTypeAtLocation(parent.argumentExpression);
              var indexUsage = createEmptyUsage();
              calculateUsageOfNode(parent, indexUsage);
              if (indexType.flags & 296) {
                usage.numberIndex = indexUsage;
              } else {
                usage.stringIndex = indexUsage;
              }
            }
          }
          function inferTypeFromPropertyAssignment(assignment, usage) {
            var nodeWithRealType = ts3.isVariableDeclaration(assignment.parent.parent) ? assignment.parent.parent : assignment.parent;
            addCandidateThisType(usage, checker.getTypeAtLocation(nodeWithRealType));
          }
          function inferTypeFromPropertyDeclaration(declaration, usage) {
            addCandidateThisType(usage, checker.getTypeAtLocation(declaration.parent));
          }
          function removeLowPriorityInferences(inferences, priorities) {
            var toRemove = [];
            for (var _i = 0, inferences_1 = inferences; _i < inferences_1.length; _i++) {
              var i3 = inferences_1[_i];
              for (var _a2 = 0, priorities_1 = priorities; _a2 < priorities_1.length; _a2++) {
                var _b = priorities_1[_a2], high = _b.high, low = _b.low;
                if (high(i3)) {
                  ts3.Debug.assert(!low(i3), "Priority can't have both low and high");
                  toRemove.push(low);
                }
              }
            }
            return inferences.filter(function(i4) {
              return toRemove.every(function(f) {
                return !f(i4);
              });
            });
          }
          function combineFromUsage(usage) {
            return combineTypes(inferTypes(usage));
          }
          function combineTypes(inferences) {
            if (!inferences.length)
              return checker.getAnyType();
            var stringNumber = checker.getUnionType([checker.getStringType(), checker.getNumberType()]);
            var priorities = [
              {
                high: function(t2) {
                  return t2 === checker.getStringType() || t2 === checker.getNumberType();
                },
                low: function(t2) {
                  return t2 === stringNumber;
                }
              },
              {
                high: function(t2) {
                  return !(t2.flags & (1 | 16384));
                },
                low: function(t2) {
                  return !!(t2.flags & (1 | 16384));
                }
              },
              {
                high: function(t2) {
                  return !(t2.flags & (98304 | 1 | 16384)) && !(ts3.getObjectFlags(t2) & 16);
                },
                low: function(t2) {
                  return !!(ts3.getObjectFlags(t2) & 16);
                }
              }
            ];
            var good = removeLowPriorityInferences(inferences, priorities);
            var anons = good.filter(function(i3) {
              return ts3.getObjectFlags(i3) & 16;
            });
            if (anons.length) {
              good = good.filter(function(i3) {
                return !(ts3.getObjectFlags(i3) & 16);
              });
              good.push(combineAnonymousTypes(anons));
            }
            return checker.getWidenedType(checker.getUnionType(good.map(checker.getBaseTypeOfLiteralType), 2));
          }
          function combineAnonymousTypes(anons) {
            if (anons.length === 1) {
              return anons[0];
            }
            var calls = [];
            var constructs = [];
            var stringIndices = [];
            var numberIndices = [];
            var stringIndexReadonly = false;
            var numberIndexReadonly = false;
            var props = ts3.createMultiMap();
            for (var _i = 0, anons_1 = anons; _i < anons_1.length; _i++) {
              var anon = anons_1[_i];
              for (var _a2 = 0, _b = checker.getPropertiesOfType(anon); _a2 < _b.length; _a2++) {
                var p = _b[_a2];
                props.add(p.name, p.valueDeclaration ? checker.getTypeOfSymbolAtLocation(p, p.valueDeclaration) : checker.getAnyType());
              }
              calls.push.apply(calls, checker.getSignaturesOfType(anon, 0));
              constructs.push.apply(constructs, checker.getSignaturesOfType(anon, 1));
              if (anon.stringIndexInfo) {
                stringIndices.push(anon.stringIndexInfo.type);
                stringIndexReadonly = stringIndexReadonly || anon.stringIndexInfo.isReadonly;
              }
              if (anon.numberIndexInfo) {
                numberIndices.push(anon.numberIndexInfo.type);
                numberIndexReadonly = numberIndexReadonly || anon.numberIndexInfo.isReadonly;
              }
            }
            var members = ts3.mapEntries(props, function(name, types2) {
              var isOptional = types2.length < anons.length ? 16777216 : 0;
              var s2 = checker.createSymbol(4 | isOptional, name);
              s2.type = checker.getUnionType(types2);
              return [name, s2];
            });
            return checker.createAnonymousType(anons[0].symbol, members, calls, constructs, stringIndices.length ? checker.createIndexInfo(checker.getUnionType(stringIndices), stringIndexReadonly) : void 0, numberIndices.length ? checker.createIndexInfo(checker.getUnionType(numberIndices), numberIndexReadonly) : void 0);
          }
          function inferTypes(usage) {
            var _a2, _b, _c;
            var types2 = [];
            if (usage.isNumber) {
              types2.push(checker.getNumberType());
            }
            if (usage.isString) {
              types2.push(checker.getStringType());
            }
            if (usage.isNumberOrString) {
              types2.push(checker.getUnionType([checker.getStringType(), checker.getNumberType()]));
            }
            if (usage.numberIndex) {
              types2.push(checker.createArrayType(combineFromUsage(usage.numberIndex)));
            }
            if (((_a2 = usage.properties) === null || _a2 === void 0 ? void 0 : _a2.size) || ((_b = usage.calls) === null || _b === void 0 ? void 0 : _b.length) || ((_c = usage.constructs) === null || _c === void 0 ? void 0 : _c.length) || usage.stringIndex) {
              types2.push(inferStructuralType(usage));
            }
            types2.push.apply(types2, (usage.candidateTypes || []).map(function(t2) {
              return checker.getBaseTypeOfLiteralType(t2);
            }));
            types2.push.apply(types2, inferNamedTypesFromProperties(usage));
            return types2;
          }
          function inferStructuralType(usage) {
            var members = new ts3.Map();
            if (usage.properties) {
              usage.properties.forEach(function(u2, name) {
                var symbol = checker.createSymbol(4, name);
                symbol.type = combineFromUsage(u2);
                members.set(name, symbol);
              });
            }
            var callSignatures = usage.calls ? [getSignatureFromCalls(usage.calls)] : [];
            var constructSignatures = usage.constructs ? [getSignatureFromCalls(usage.constructs)] : [];
            var stringIndexInfo = usage.stringIndex && checker.createIndexInfo(combineFromUsage(usage.stringIndex), false);
            return checker.createAnonymousType(void 0, members, callSignatures, constructSignatures, stringIndexInfo, void 0);
          }
          function inferNamedTypesFromProperties(usage) {
            if (!usage.properties || !usage.properties.size)
              return [];
            var types2 = builtins.filter(function(t2) {
              return allPropertiesAreAssignableToUsage(t2, usage);
            });
            if (0 < types2.length && types2.length < 3) {
              return types2.map(function(t2) {
                return inferInstantiationFromUsage(t2, usage);
              });
            }
            return [];
          }
          function allPropertiesAreAssignableToUsage(type3, usage) {
            if (!usage.properties)
              return false;
            return !ts3.forEachEntry(usage.properties, function(propUsage, name) {
              var source = checker.getTypeOfPropertyOfType(type3, name);
              if (!source) {
                return true;
              }
              if (propUsage.calls) {
                var sigs = checker.getSignaturesOfType(source, 0);
                return !sigs.length || !checker.isTypeAssignableTo(source, getFunctionFromCalls(propUsage.calls));
              } else {
                return !checker.isTypeAssignableTo(source, combineFromUsage(propUsage));
              }
            });
          }
          function inferInstantiationFromUsage(type3, usage) {
            if (!(ts3.getObjectFlags(type3) & 4) || !usage.properties) {
              return type3;
            }
            var generic = type3.target;
            var singleTypeParameter = ts3.singleOrUndefined(generic.typeParameters);
            if (!singleTypeParameter)
              return type3;
            var types2 = [];
            usage.properties.forEach(function(propUsage, name) {
              var genericPropertyType = checker.getTypeOfPropertyOfType(generic, name);
              ts3.Debug.assert(!!genericPropertyType, "generic should have all the properties of its reference.");
              types2.push.apply(types2, inferTypeParameters(genericPropertyType, combineFromUsage(propUsage), singleTypeParameter));
            });
            return builtinConstructors[type3.symbol.escapedName](combineTypes(types2));
          }
          function inferTypeParameters(genericType, usageType, typeParameter) {
            if (genericType === typeParameter) {
              return [usageType];
            } else if (genericType.flags & 3145728) {
              return ts3.flatMap(genericType.types, function(t2) {
                return inferTypeParameters(t2, usageType, typeParameter);
              });
            } else if (ts3.getObjectFlags(genericType) & 4 && ts3.getObjectFlags(usageType) & 4) {
              var genericArgs = checker.getTypeArguments(genericType);
              var usageArgs = checker.getTypeArguments(usageType);
              var types2 = [];
              if (genericArgs && usageArgs) {
                for (var i3 = 0; i3 < genericArgs.length; i3++) {
                  if (usageArgs[i3]) {
                    types2.push.apply(types2, inferTypeParameters(genericArgs[i3], usageArgs[i3], typeParameter));
                  }
                }
              }
              return types2;
            }
            var genericSigs = checker.getSignaturesOfType(genericType, 0);
            var usageSigs = checker.getSignaturesOfType(usageType, 0);
            if (genericSigs.length === 1 && usageSigs.length === 1) {
              return inferFromSignatures(genericSigs[0], usageSigs[0], typeParameter);
            }
            return [];
          }
          function inferFromSignatures(genericSig, usageSig, typeParameter) {
            var types2 = [];
            for (var i3 = 0; i3 < genericSig.parameters.length; i3++) {
              var genericParam = genericSig.parameters[i3];
              var usageParam = usageSig.parameters[i3];
              var isRest = genericSig.declaration && ts3.isRestParameter(genericSig.declaration.parameters[i3]);
              if (!usageParam) {
                break;
              }
              var genericParamType = genericParam.valueDeclaration ? checker.getTypeOfSymbolAtLocation(genericParam, genericParam.valueDeclaration) : checker.getAnyType();
              var elementType = isRest && checker.getElementTypeOfArrayType(genericParamType);
              if (elementType) {
                genericParamType = elementType;
              }
              var targetType = usageParam.type || (usageParam.valueDeclaration ? checker.getTypeOfSymbolAtLocation(usageParam, usageParam.valueDeclaration) : checker.getAnyType());
              types2.push.apply(types2, inferTypeParameters(genericParamType, targetType, typeParameter));
            }
            var genericReturn = checker.getReturnTypeOfSignature(genericSig);
            var usageReturn = checker.getReturnTypeOfSignature(usageSig);
            types2.push.apply(types2, inferTypeParameters(genericReturn, usageReturn, typeParameter));
            return types2;
          }
          function getFunctionFromCalls(calls) {
            return checker.createAnonymousType(void 0, ts3.createSymbolTable(), [getSignatureFromCalls(calls)], ts3.emptyArray, void 0, void 0);
          }
          function getSignatureFromCalls(calls) {
            var parameters2 = [];
            var length = Math.max.apply(Math, calls.map(function(c2) {
              return c2.argumentTypes.length;
            }));
            var _loop_15 = function(i4) {
              var symbol = checker.createSymbol(1, ts3.escapeLeadingUnderscores("arg" + i4));
              symbol.type = combineTypes(calls.map(function(call) {
                return call.argumentTypes[i4] || checker.getUndefinedType();
              }));
              if (calls.some(function(call) {
                return call.argumentTypes[i4] === void 0;
              })) {
                symbol.flags |= 16777216;
              }
              parameters2.push(symbol);
            };
            for (var i3 = 0; i3 < length; i3++) {
              _loop_15(i3);
            }
            var returnType2 = combineFromUsage(combineUsages(calls.map(function(call) {
              return call.return_;
            })));
            return checker.createSignature(void 0, void 0, void 0, parameters2, returnType2, void 0, length, 0);
          }
          function addCandidateType(usage, type3) {
            if (type3 && !(type3.flags & 1) && !(type3.flags & 131072)) {
              (usage.candidateTypes || (usage.candidateTypes = [])).push(type3);
            }
          }
          function addCandidateThisType(usage, type3) {
            if (type3 && !(type3.flags & 1) && !(type3.flags & 131072)) {
              (usage.candidateThisTypes || (usage.candidateThisTypes = [])).push(type3);
            }
          }
        }
      })(codefix = ts3.codefix || (ts3.codefix = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var codefix;
      (function(codefix2) {
        var fixId = "fixReturnTypeInAsyncFunction";
        var errorCodes = [
          ts3.Diagnostics.The_return_type_of_an_async_function_or_method_must_be_the_global_Promise_T_type_Did_you_mean_to_write_Promise_0.code
        ];
        codefix2.registerCodeFix({
          errorCodes,
          fixIds: [fixId],
          getCodeActions: function(context) {
            var sourceFile = context.sourceFile, program2 = context.program, span = context.span;
            var checker = program2.getTypeChecker();
            var info = getInfo(sourceFile, program2.getTypeChecker(), span.start);
            if (!info) {
              return void 0;
            }
            var returnTypeNode = info.returnTypeNode, returnType2 = info.returnType, promisedTypeNode = info.promisedTypeNode, promisedType = info.promisedType;
            var changes = ts3.textChanges.ChangeTracker.with(context, function(t2) {
              return doChange(t2, sourceFile, returnTypeNode, promisedTypeNode);
            });
            return [codefix2.createCodeFixAction(fixId, changes, [
              ts3.Diagnostics.Replace_0_with_Promise_1,
              checker.typeToString(returnType2),
              checker.typeToString(promisedType)
            ], fixId, ts3.Diagnostics.Fix_all_incorrect_return_type_of_an_async_functions)];
          },
          getAllCodeActions: function(context) {
            return codefix2.codeFixAll(context, errorCodes, function(changes, diag) {
              var info = getInfo(diag.file, context.program.getTypeChecker(), diag.start);
              if (info) {
                doChange(changes, diag.file, info.returnTypeNode, info.promisedTypeNode);
              }
            });
          }
        });
        function getInfo(sourceFile, checker, pos) {
          if (ts3.isInJSFile(sourceFile)) {
            return void 0;
          }
          var token = ts3.getTokenAtPosition(sourceFile, pos);
          var func2 = ts3.findAncestor(token, ts3.isFunctionLikeDeclaration);
          var returnTypeNode = func2 === null || func2 === void 0 ? void 0 : func2.type;
          if (!returnTypeNode) {
            return void 0;
          }
          var returnType2 = checker.getTypeFromTypeNode(returnTypeNode);
          var promisedType = checker.getAwaitedType(returnType2) || checker.getVoidType();
          var promisedTypeNode = checker.typeToTypeNode(promisedType, returnTypeNode, void 0);
          if (promisedTypeNode) {
            return { returnTypeNode, returnType: returnType2, promisedTypeNode, promisedType };
          }
        }
        function doChange(changes, sourceFile, returnTypeNode, promisedTypeNode) {
          changes.replaceNode(sourceFile, returnTypeNode, ts3.factory.createTypeReferenceNode("Promise", [promisedTypeNode]));
        }
      })(codefix = ts3.codefix || (ts3.codefix = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var codefix;
      (function(codefix2) {
        var fixName = "disableJsDiagnostics";
        var fixId = "disableJsDiagnostics";
        var errorCodes = ts3.mapDefined(Object.keys(ts3.Diagnostics), function(key2) {
          var diag = ts3.Diagnostics[key2];
          return diag.category === ts3.DiagnosticCategory.Error ? diag.code : void 0;
        });
        codefix2.registerCodeFix({
          errorCodes,
          getCodeActions: function(context) {
            var sourceFile = context.sourceFile, program2 = context.program, span = context.span, host = context.host, formatContext = context.formatContext;
            if (!ts3.isInJSFile(sourceFile) || !ts3.isCheckJsEnabledForFile(sourceFile, program2.getCompilerOptions())) {
              return void 0;
            }
            var newLineCharacter = sourceFile.checkJsDirective ? "" : ts3.getNewLineOrDefaultFromHost(host, formatContext.options);
            var fixes = [
              codefix2.createCodeFixActionWithoutFixAll(fixName, [codefix2.createFileTextChanges(sourceFile.fileName, [
                ts3.createTextChange(sourceFile.checkJsDirective ? ts3.createTextSpanFromBounds(sourceFile.checkJsDirective.pos, sourceFile.checkJsDirective.end) : ts3.createTextSpan(0, 0), "// @ts-nocheck" + newLineCharacter)
              ])], ts3.Diagnostics.Disable_checking_for_this_file)
            ];
            if (ts3.textChanges.isValidLocationToAddComment(sourceFile, span.start)) {
              fixes.unshift(codefix2.createCodeFixAction(fixName, ts3.textChanges.ChangeTracker.with(context, function(t2) {
                return makeChange(t2, sourceFile, span.start);
              }), ts3.Diagnostics.Ignore_this_error_message, fixId, ts3.Diagnostics.Add_ts_ignore_to_all_error_messages));
            }
            return fixes;
          },
          fixIds: [fixId],
          getAllCodeActions: function(context) {
            var seenLines = new ts3.Set();
            return codefix2.codeFixAll(context, errorCodes, function(changes, diag) {
              if (ts3.textChanges.isValidLocationToAddComment(diag.file, diag.start)) {
                makeChange(changes, diag.file, diag.start, seenLines);
              }
            });
          }
        });
        function makeChange(changes, sourceFile, position, seenLines) {
          var lineNumber = ts3.getLineAndCharacterOfPosition(sourceFile, position).line;
          if (!seenLines || ts3.tryAddToSet(seenLines, lineNumber)) {
            changes.insertCommentBeforeLine(sourceFile, lineNumber, position, " @ts-ignore");
          }
        }
      })(codefix = ts3.codefix || (ts3.codefix = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var codefix;
      (function(codefix2) {
        function createMissingMemberNodes(classDeclaration, possiblyMissingSymbols, sourceFile, context, preferences, importAdder, addClassElement) {
          var classMembers = classDeclaration.symbol.members;
          for (var _i = 0, possiblyMissingSymbols_1 = possiblyMissingSymbols; _i < possiblyMissingSymbols_1.length; _i++) {
            var symbol = possiblyMissingSymbols_1[_i];
            if (!classMembers.has(symbol.escapedName)) {
              addNewNodeForMemberSymbol(symbol, classDeclaration, sourceFile, context, preferences, importAdder, addClassElement);
            }
          }
        }
        codefix2.createMissingMemberNodes = createMissingMemberNodes;
        function getNoopSymbolTrackerWithResolver(context) {
          return {
            trackSymbol: ts3.noop,
            moduleResolverHost: ts3.getModuleSpecifierResolverHost(context.program, context.host)
          };
        }
        codefix2.getNoopSymbolTrackerWithResolver = getNoopSymbolTrackerWithResolver;
        function addNewNodeForMemberSymbol(symbol, enclosingDeclaration, sourceFile, context, preferences, importAdder, addClassElement) {
          var declarations = symbol.getDeclarations();
          if (!(declarations && declarations.length)) {
            return void 0;
          }
          var checker = context.program.getTypeChecker();
          var scriptTarget = ts3.getEmitScriptTarget(context.program.getCompilerOptions());
          var declaration = declarations[0];
          var name = ts3.getSynthesizedDeepClone(ts3.getNameOfDeclaration(declaration), false);
          var visibilityModifier = createVisibilityModifier(ts3.getEffectiveModifierFlags(declaration));
          var modifiers = visibilityModifier ? ts3.factory.createNodeArray([visibilityModifier]) : void 0;
          var type3 = checker.getWidenedType(checker.getTypeOfSymbolAtLocation(symbol, enclosingDeclaration));
          var optional = !!(symbol.flags & 16777216);
          var ambient = !!(enclosingDeclaration.flags & 8388608);
          var quotePreference = ts3.getQuotePreference(sourceFile, preferences);
          switch (declaration.kind) {
            case 163:
            case 164:
              var flags = quotePreference === 0 ? 268435456 : void 0;
              var typeNode = checker.typeToTypeNode(type3, enclosingDeclaration, flags, getNoopSymbolTrackerWithResolver(context));
              if (importAdder) {
                var importableReference = tryGetAutoImportableReferenceFromTypeNode(typeNode, scriptTarget);
                if (importableReference) {
                  typeNode = importableReference.typeNode;
                  importSymbols(importAdder, importableReference.symbols);
                }
              }
              addClassElement(ts3.factory.createPropertyDeclaration(void 0, modifiers, name, optional ? ts3.factory.createToken(57) : void 0, typeNode, void 0));
              break;
            case 168:
            case 169: {
              var typeNode_1 = checker.typeToTypeNode(type3, enclosingDeclaration, void 0, getNoopSymbolTrackerWithResolver(context));
              var allAccessors = ts3.getAllAccessorDeclarations(declarations, declaration);
              var orderedAccessors = allAccessors.secondAccessor ? [allAccessors.firstAccessor, allAccessors.secondAccessor] : [allAccessors.firstAccessor];
              if (importAdder) {
                var importableReference = tryGetAutoImportableReferenceFromTypeNode(typeNode_1, scriptTarget);
                if (importableReference) {
                  typeNode_1 = importableReference.typeNode;
                  importSymbols(importAdder, importableReference.symbols);
                }
              }
              for (var _i = 0, orderedAccessors_1 = orderedAccessors; _i < orderedAccessors_1.length; _i++) {
                var accessor = orderedAccessors_1[_i];
                if (ts3.isGetAccessorDeclaration(accessor)) {
                  addClassElement(ts3.factory.createGetAccessorDeclaration(void 0, modifiers, name, ts3.emptyArray, typeNode_1, ambient ? void 0 : createStubbedMethodBody(quotePreference)));
                } else {
                  ts3.Debug.assertNode(accessor, ts3.isSetAccessorDeclaration, "The counterpart to a getter should be a setter");
                  var parameter = ts3.getSetAccessorValueParameter(accessor);
                  var parameterName = parameter && ts3.isIdentifier(parameter.name) ? ts3.idText(parameter.name) : void 0;
                  addClassElement(ts3.factory.createSetAccessorDeclaration(void 0, modifiers, name, createDummyParameters(1, [parameterName], [typeNode_1], 1, false), ambient ? void 0 : createStubbedMethodBody(quotePreference)));
                }
              }
              break;
            }
            case 165:
            case 166:
              var signatures = checker.getSignaturesOfType(type3, 0);
              if (!ts3.some(signatures)) {
                break;
              }
              if (declarations.length === 1) {
                ts3.Debug.assert(signatures.length === 1, "One declaration implies one signature");
                var signature = signatures[0];
                outputMethod(quotePreference, signature, modifiers, name, ambient ? void 0 : createStubbedMethodBody(quotePreference));
                break;
              }
              for (var _a2 = 0, signatures_1 = signatures; _a2 < signatures_1.length; _a2++) {
                var signature = signatures_1[_a2];
                outputMethod(quotePreference, signature, ts3.getSynthesizedDeepClones(modifiers, false), ts3.getSynthesizedDeepClone(name, false));
              }
              if (!ambient) {
                if (declarations.length > signatures.length) {
                  var signature = checker.getSignatureFromDeclaration(declarations[declarations.length - 1]);
                  outputMethod(quotePreference, signature, modifiers, name, createStubbedMethodBody(quotePreference));
                } else {
                  ts3.Debug.assert(declarations.length === signatures.length, "Declarations and signatures should match count");
                  addClassElement(createMethodImplementingSignatures(checker, context, enclosingDeclaration, signatures, name, optional, modifiers, quotePreference));
                }
              }
              break;
          }
          function outputMethod(quotePreference2, signature2, modifiers2, name2, body) {
            var method = signatureToMethodDeclaration(context, quotePreference2, signature2, enclosingDeclaration, modifiers2, name2, optional, body, importAdder);
            if (method)
              addClassElement(method);
          }
        }
        function signatureToMethodDeclaration(context, quotePreference, signature, enclosingDeclaration, modifiers, name, optional, body, importAdder) {
          var program2 = context.program;
          var checker = program2.getTypeChecker();
          var scriptTarget = ts3.getEmitScriptTarget(program2.getCompilerOptions());
          var flags = 1 | 1073741824 | 256 | (quotePreference === 0 ? 268435456 : 0);
          var signatureDeclaration = checker.signatureToSignatureDeclaration(signature, 166, enclosingDeclaration, flags, getNoopSymbolTrackerWithResolver(context));
          if (!signatureDeclaration) {
            return void 0;
          }
          var typeParameters = signatureDeclaration.typeParameters;
          var parameters = signatureDeclaration.parameters;
          var type3 = signatureDeclaration.type;
          if (importAdder) {
            if (typeParameters) {
              var newTypeParameters = ts3.sameMap(typeParameters, function(typeParameterDecl) {
                var constraint = typeParameterDecl.constraint;
                var defaultType = typeParameterDecl.default;
                if (constraint) {
                  var importableReference2 = tryGetAutoImportableReferenceFromTypeNode(constraint, scriptTarget);
                  if (importableReference2) {
                    constraint = importableReference2.typeNode;
                    importSymbols(importAdder, importableReference2.symbols);
                  }
                }
                if (defaultType) {
                  var importableReference2 = tryGetAutoImportableReferenceFromTypeNode(defaultType, scriptTarget);
                  if (importableReference2) {
                    defaultType = importableReference2.typeNode;
                    importSymbols(importAdder, importableReference2.symbols);
                  }
                }
                return ts3.factory.updateTypeParameterDeclaration(typeParameterDecl, typeParameterDecl.name, constraint, defaultType);
              });
              if (typeParameters !== newTypeParameters) {
                typeParameters = ts3.setTextRange(ts3.factory.createNodeArray(newTypeParameters, typeParameters.hasTrailingComma), typeParameters);
              }
            }
            var newParameters = ts3.sameMap(parameters, function(parameterDecl) {
              var importableReference2 = tryGetAutoImportableReferenceFromTypeNode(parameterDecl.type, scriptTarget);
              var type4 = parameterDecl.type;
              if (importableReference2) {
                type4 = importableReference2.typeNode;
                importSymbols(importAdder, importableReference2.symbols);
              }
              return ts3.factory.updateParameterDeclaration(parameterDecl, parameterDecl.decorators, parameterDecl.modifiers, parameterDecl.dotDotDotToken, parameterDecl.name, parameterDecl.questionToken, type4, parameterDecl.initializer);
            });
            if (parameters !== newParameters) {
              parameters = ts3.setTextRange(ts3.factory.createNodeArray(newParameters, parameters.hasTrailingComma), parameters);
            }
            if (type3) {
              var importableReference = tryGetAutoImportableReferenceFromTypeNode(type3, scriptTarget);
              if (importableReference) {
                type3 = importableReference.typeNode;
                importSymbols(importAdder, importableReference.symbols);
              }
            }
          }
          return ts3.factory.updateMethodDeclaration(signatureDeclaration, void 0, modifiers, signatureDeclaration.asteriskToken, name, optional ? ts3.factory.createToken(57) : void 0, typeParameters, parameters, type3, body);
        }
        function createSignatureDeclarationFromCallExpression(kind, context, importAdder, call, name, modifierFlags, contextNode) {
          var quotePreference = ts3.getQuotePreference(context.sourceFile, context.preferences);
          var scriptTarget = ts3.getEmitScriptTarget(context.program.getCompilerOptions());
          var tracker = getNoopSymbolTrackerWithResolver(context);
          var checker = context.program.getTypeChecker();
          var isJs = ts3.isInJSFile(contextNode);
          var typeArguments = call.typeArguments, args = call.arguments, parent = call.parent;
          var contextualType = isJs ? void 0 : checker.getContextualType(call);
          var names = ts3.map(args, function(arg2) {
            return ts3.isIdentifier(arg2) ? arg2.text : ts3.isPropertyAccessExpression(arg2) && ts3.isIdentifier(arg2.name) ? arg2.name.text : void 0;
          });
          var types2 = isJs ? [] : ts3.map(args, function(arg2) {
            return typeToAutoImportableTypeNode(checker, importAdder, checker.getBaseTypeOfLiteralType(checker.getTypeAtLocation(arg2)), contextNode, scriptTarget, void 0, tracker);
          });
          var modifiers = modifierFlags ? ts3.factory.createNodeArray(ts3.factory.createModifiersFromModifierFlags(modifierFlags)) : void 0;
          var asteriskToken = ts3.isYieldExpression(parent) ? ts3.factory.createToken(41) : void 0;
          var typeParameters = isJs || typeArguments === void 0 ? void 0 : ts3.map(typeArguments, function(_, i3) {
            return ts3.factory.createTypeParameterDeclaration(84 + typeArguments.length - 1 <= 90 ? String.fromCharCode(84 + i3) : "T" + i3);
          });
          var parameters = createDummyParameters(args.length, names, types2, void 0, isJs);
          var type3 = isJs || contextualType === void 0 ? void 0 : checker.typeToTypeNode(contextualType, contextNode, void 0, tracker);
          if (kind === 166) {
            return ts3.factory.createMethodDeclaration(void 0, modifiers, asteriskToken, name, void 0, typeParameters, parameters, type3, ts3.isInterfaceDeclaration(contextNode) ? void 0 : createStubbedMethodBody(quotePreference));
          }
          return ts3.factory.createFunctionDeclaration(void 0, modifiers, asteriskToken, name, typeParameters, parameters, type3, createStubbedBody(ts3.Diagnostics.Function_not_implemented.message, quotePreference));
        }
        codefix2.createSignatureDeclarationFromCallExpression = createSignatureDeclarationFromCallExpression;
        function typeToAutoImportableTypeNode(checker, importAdder, type3, contextNode, scriptTarget, flags, tracker) {
          var typeNode = checker.typeToTypeNode(type3, contextNode, flags, tracker);
          if (typeNode && ts3.isImportTypeNode(typeNode)) {
            var importableReference = tryGetAutoImportableReferenceFromTypeNode(typeNode, scriptTarget);
            if (importableReference) {
              importSymbols(importAdder, importableReference.symbols);
              return importableReference.typeNode;
            }
          }
          return typeNode;
        }
        codefix2.typeToAutoImportableTypeNode = typeToAutoImportableTypeNode;
        function createDummyParameters(argCount, names, types2, minArgumentCount, inJs) {
          var parameters = [];
          for (var i3 = 0; i3 < argCount; i3++) {
            var newParameter = ts3.factory.createParameterDeclaration(void 0, void 0, void 0, names && names[i3] || "arg" + i3, minArgumentCount !== void 0 && i3 >= minArgumentCount ? ts3.factory.createToken(57) : void 0, inJs ? void 0 : types2 && types2[i3] || ts3.factory.createKeywordTypeNode(128), void 0);
            parameters.push(newParameter);
          }
          return parameters;
        }
        function createMethodImplementingSignatures(checker, context, enclosingDeclaration, signatures, name, optional, modifiers, quotePreference) {
          var maxArgsSignature = signatures[0];
          var minArgumentCount = signatures[0].minArgumentCount;
          var someSigHasRestParameter = false;
          for (var _i = 0, signatures_2 = signatures; _i < signatures_2.length; _i++) {
            var sig = signatures_2[_i];
            minArgumentCount = Math.min(sig.minArgumentCount, minArgumentCount);
            if (ts3.signatureHasRestParameter(sig)) {
              someSigHasRestParameter = true;
            }
            if (sig.parameters.length >= maxArgsSignature.parameters.length && (!ts3.signatureHasRestParameter(sig) || ts3.signatureHasRestParameter(maxArgsSignature))) {
              maxArgsSignature = sig;
            }
          }
          var maxNonRestArgs = maxArgsSignature.parameters.length - (ts3.signatureHasRestParameter(maxArgsSignature) ? 1 : 0);
          var maxArgsParameterSymbolNames = maxArgsSignature.parameters.map(function(symbol) {
            return symbol.name;
          });
          var parameters = createDummyParameters(maxNonRestArgs, maxArgsParameterSymbolNames, void 0, minArgumentCount, false);
          if (someSigHasRestParameter) {
            var anyArrayType = ts3.factory.createArrayTypeNode(ts3.factory.createKeywordTypeNode(128));
            var restParameter = ts3.factory.createParameterDeclaration(void 0, void 0, ts3.factory.createToken(25), maxArgsParameterSymbolNames[maxNonRestArgs] || "rest", maxNonRestArgs >= minArgumentCount ? ts3.factory.createToken(57) : void 0, anyArrayType, void 0);
            parameters.push(restParameter);
          }
          return createStubbedMethod(modifiers, name, optional, void 0, parameters, getReturnTypeFromSignatures(signatures, checker, context, enclosingDeclaration), quotePreference);
        }
        function getReturnTypeFromSignatures(signatures, checker, context, enclosingDeclaration) {
          if (ts3.length(signatures)) {
            var type3 = checker.getUnionType(ts3.map(signatures, checker.getReturnTypeOfSignature));
            return checker.typeToTypeNode(type3, enclosingDeclaration, void 0, getNoopSymbolTrackerWithResolver(context));
          }
        }
        function createStubbedMethod(modifiers, name, optional, typeParameters, parameters, returnType2, quotePreference) {
          return ts3.factory.createMethodDeclaration(void 0, modifiers, void 0, name, optional ? ts3.factory.createToken(57) : void 0, typeParameters, parameters, returnType2, createStubbedMethodBody(quotePreference));
        }
        function createStubbedMethodBody(quotePreference) {
          return createStubbedBody(ts3.Diagnostics.Method_not_implemented.message, quotePreference);
        }
        function createStubbedBody(text, quotePreference) {
          return ts3.factory.createBlock([ts3.factory.createThrowStatement(ts3.factory.createNewExpression(ts3.factory.createIdentifier("Error"), void 0, [ts3.factory.createStringLiteral(text, quotePreference === 0)]))], true);
        }
        codefix2.createStubbedBody = createStubbedBody;
        function createVisibilityModifier(flags) {
          if (flags & 4) {
            return ts3.factory.createToken(122);
          } else if (flags & 16) {
            return ts3.factory.createToken(121);
          }
          return void 0;
        }
        function setJsonCompilerOptionValues(changeTracker, configFile, options) {
          var tsconfigObjectLiteral = ts3.getTsConfigObjectLiteralExpression(configFile);
          if (!tsconfigObjectLiteral)
            return void 0;
          var compilerOptionsProperty = findJsonProperty(tsconfigObjectLiteral, "compilerOptions");
          if (compilerOptionsProperty === void 0) {
            changeTracker.insertNodeAtObjectStart(configFile, tsconfigObjectLiteral, createJsonPropertyAssignment("compilerOptions", ts3.factory.createObjectLiteralExpression(options.map(function(_a3) {
              var optionName2 = _a3[0], optionValue2 = _a3[1];
              return createJsonPropertyAssignment(optionName2, optionValue2);
            }), true)));
            return;
          }
          var compilerOptions = compilerOptionsProperty.initializer;
          if (!ts3.isObjectLiteralExpression(compilerOptions)) {
            return;
          }
          for (var _i = 0, options_1 = options; _i < options_1.length; _i++) {
            var _a2 = options_1[_i], optionName = _a2[0], optionValue = _a2[1];
            var optionProperty = findJsonProperty(compilerOptions, optionName);
            if (optionProperty === void 0) {
              changeTracker.insertNodeAtObjectStart(configFile, compilerOptions, createJsonPropertyAssignment(optionName, optionValue));
            } else {
              changeTracker.replaceNode(configFile, optionProperty.initializer, optionValue);
            }
          }
        }
        codefix2.setJsonCompilerOptionValues = setJsonCompilerOptionValues;
        function setJsonCompilerOptionValue(changeTracker, configFile, optionName, optionValue) {
          setJsonCompilerOptionValues(changeTracker, configFile, [[optionName, optionValue]]);
        }
        codefix2.setJsonCompilerOptionValue = setJsonCompilerOptionValue;
        function createJsonPropertyAssignment(name, initializer) {
          return ts3.factory.createPropertyAssignment(ts3.factory.createStringLiteral(name), initializer);
        }
        codefix2.createJsonPropertyAssignment = createJsonPropertyAssignment;
        function findJsonProperty(obj, name) {
          return ts3.find(obj.properties, function(p) {
            return ts3.isPropertyAssignment(p) && !!p.name && ts3.isStringLiteral(p.name) && p.name.text === name;
          });
        }
        codefix2.findJsonProperty = findJsonProperty;
        function tryGetAutoImportableReferenceFromTypeNode(importTypeNode, scriptTarget) {
          var symbols;
          var typeNode = ts3.visitNode(importTypeNode, visit);
          if (symbols && typeNode) {
            return { typeNode, symbols };
          }
          function visit(node) {
            var _a2;
            if (ts3.isLiteralImportTypeNode(node) && node.qualifier) {
              var firstIdentifier = ts3.getFirstIdentifier(node.qualifier);
              var name = ts3.getNameForExportedSymbol(firstIdentifier.symbol, scriptTarget);
              var qualifier = name !== firstIdentifier.text ? replaceFirstIdentifierOfEntityName(node.qualifier, ts3.factory.createIdentifier(name)) : node.qualifier;
              symbols = ts3.append(symbols, firstIdentifier.symbol);
              var typeArguments = (_a2 = node.typeArguments) === null || _a2 === void 0 ? void 0 : _a2.map(visit);
              return ts3.factory.createTypeReferenceNode(qualifier, typeArguments);
            }
            return ts3.visitEachChild(node, visit, ts3.nullTransformationContext);
          }
        }
        codefix2.tryGetAutoImportableReferenceFromTypeNode = tryGetAutoImportableReferenceFromTypeNode;
        function replaceFirstIdentifierOfEntityName(name, newIdentifier) {
          if (name.kind === 78) {
            return newIdentifier;
          }
          return ts3.factory.createQualifiedName(replaceFirstIdentifierOfEntityName(name.left, newIdentifier), name.right);
        }
        function importSymbols(importAdder, symbols) {
          symbols.forEach(function(s2) {
            return importAdder.addImportFromExportedSymbol(s2, true);
          });
        }
        codefix2.importSymbols = importSymbols;
      })(codefix = ts3.codefix || (ts3.codefix = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var codefix;
      (function(codefix2) {
        function generateAccessorFromProperty(file, program2, start, end, context, _actionName) {
          var fieldInfo = getAccessorConvertiblePropertyAtPosition(file, program2, start, end);
          if (!fieldInfo || ts3.refactor.isRefactorErrorInfo(fieldInfo))
            return void 0;
          var changeTracker = ts3.textChanges.ChangeTracker.fromContext(context);
          var isStatic = fieldInfo.isStatic, isReadonly = fieldInfo.isReadonly, fieldName = fieldInfo.fieldName, accessorName = fieldInfo.accessorName, originalName = fieldInfo.originalName, type3 = fieldInfo.type, container = fieldInfo.container, declaration = fieldInfo.declaration;
          ts3.suppressLeadingAndTrailingTrivia(fieldName);
          ts3.suppressLeadingAndTrailingTrivia(accessorName);
          ts3.suppressLeadingAndTrailingTrivia(declaration);
          ts3.suppressLeadingAndTrailingTrivia(container);
          var accessorModifiers;
          var fieldModifiers;
          if (ts3.isClassLike(container)) {
            var modifierFlags = ts3.getEffectiveModifierFlags(declaration);
            if (ts3.isSourceFileJS(file)) {
              var modifiers = ts3.createModifiers(modifierFlags);
              accessorModifiers = modifiers;
              fieldModifiers = modifiers;
            } else {
              accessorModifiers = ts3.createModifiers(prepareModifierFlagsForAccessor(modifierFlags));
              fieldModifiers = ts3.createModifiers(prepareModifierFlagsForField(modifierFlags));
            }
          }
          updateFieldDeclaration(changeTracker, file, declaration, type3, fieldName, fieldModifiers);
          var getAccessor = generateGetAccessor(fieldName, accessorName, type3, accessorModifiers, isStatic, container);
          ts3.suppressLeadingAndTrailingTrivia(getAccessor);
          insertAccessor(changeTracker, file, getAccessor, declaration, container);
          if (isReadonly) {
            var constructor = ts3.getFirstConstructorWithBody(container);
            if (constructor) {
              updateReadonlyPropertyInitializerStatementConstructor(changeTracker, file, constructor, fieldName.text, originalName);
            }
          } else {
            var setAccessor = generateSetAccessor(fieldName, accessorName, type3, accessorModifiers, isStatic, container);
            ts3.suppressLeadingAndTrailingTrivia(setAccessor);
            insertAccessor(changeTracker, file, setAccessor, declaration, container);
          }
          return changeTracker.getChanges();
        }
        codefix2.generateAccessorFromProperty = generateAccessorFromProperty;
        function isConvertibleName(name) {
          return ts3.isIdentifier(name) || ts3.isStringLiteral(name);
        }
        function isAcceptedDeclaration(node) {
          return ts3.isParameterPropertyDeclaration(node, node.parent) || ts3.isPropertyDeclaration(node) || ts3.isPropertyAssignment(node);
        }
        function createPropertyName(name, originalName) {
          return ts3.isIdentifier(originalName) ? ts3.factory.createIdentifier(name) : ts3.factory.createStringLiteral(name);
        }
        function createAccessorAccessExpression(fieldName, isStatic, container) {
          var leftHead = isStatic ? container.name : ts3.factory.createThis();
          return ts3.isIdentifier(fieldName) ? ts3.factory.createPropertyAccessExpression(leftHead, fieldName) : ts3.factory.createElementAccessExpression(leftHead, ts3.factory.createStringLiteralFromNode(fieldName));
        }
        function prepareModifierFlagsForAccessor(modifierFlags) {
          modifierFlags &= ~64;
          modifierFlags &= ~8;
          if (!(modifierFlags & 16)) {
            modifierFlags |= 4;
          }
          return modifierFlags;
        }
        function prepareModifierFlagsForField(modifierFlags) {
          modifierFlags &= ~4;
          modifierFlags &= ~16;
          modifierFlags |= 8;
          return modifierFlags;
        }
        function getAccessorConvertiblePropertyAtPosition(file, program2, start, end, considerEmptySpans) {
          if (considerEmptySpans === void 0) {
            considerEmptySpans = true;
          }
          var node = ts3.getTokenAtPosition(file, start);
          var cursorRequest = start === end && considerEmptySpans;
          var declaration = ts3.findAncestor(node.parent, isAcceptedDeclaration);
          var meaning = 28 | 32 | 64;
          if (!declaration || !(ts3.nodeOverlapsWithStartEnd(declaration.name, file, start, end) || cursorRequest)) {
            return {
              error: ts3.getLocaleSpecificMessage(ts3.Diagnostics.Could_not_find_property_for_which_to_generate_accessor)
            };
          }
          if (!isConvertibleName(declaration.name)) {
            return {
              error: ts3.getLocaleSpecificMessage(ts3.Diagnostics.Name_is_not_valid)
            };
          }
          if ((ts3.getEffectiveModifierFlags(declaration) | meaning) !== meaning) {
            return {
              error: ts3.getLocaleSpecificMessage(ts3.Diagnostics.Can_only_convert_property_with_modifier)
            };
          }
          var name = declaration.name.text;
          var startWithUnderscore = ts3.startsWithUnderscore(name);
          var fieldName = createPropertyName(startWithUnderscore ? name : ts3.getUniqueName("_" + name, file), declaration.name);
          var accessorName = createPropertyName(startWithUnderscore ? ts3.getUniqueName(name.substring(1), file) : name, declaration.name);
          return {
            isStatic: ts3.hasStaticModifier(declaration),
            isReadonly: ts3.hasEffectiveReadonlyModifier(declaration),
            type: getDeclarationType(declaration, program2),
            container: declaration.kind === 161 ? declaration.parent.parent : declaration.parent,
            originalName: declaration.name.text,
            declaration,
            fieldName,
            accessorName,
            renameAccessor: startWithUnderscore
          };
        }
        codefix2.getAccessorConvertiblePropertyAtPosition = getAccessorConvertiblePropertyAtPosition;
        function generateGetAccessor(fieldName, accessorName, type3, modifiers, isStatic, container) {
          return ts3.factory.createGetAccessorDeclaration(void 0, modifiers, accessorName, void 0, type3, ts3.factory.createBlock([
            ts3.factory.createReturnStatement(createAccessorAccessExpression(fieldName, isStatic, container))
          ], true));
        }
        function generateSetAccessor(fieldName, accessorName, type3, modifiers, isStatic, container) {
          return ts3.factory.createSetAccessorDeclaration(void 0, modifiers, accessorName, [ts3.factory.createParameterDeclaration(void 0, void 0, void 0, ts3.factory.createIdentifier("value"), void 0, type3)], ts3.factory.createBlock([
            ts3.factory.createExpressionStatement(ts3.factory.createAssignment(createAccessorAccessExpression(fieldName, isStatic, container), ts3.factory.createIdentifier("value")))
          ], true));
        }
        function updatePropertyDeclaration(changeTracker, file, declaration, type3, fieldName, modifiers) {
          var property = ts3.factory.updatePropertyDeclaration(declaration, declaration.decorators, modifiers, fieldName, declaration.questionToken || declaration.exclamationToken, type3, declaration.initializer);
          changeTracker.replaceNode(file, declaration, property);
        }
        function updatePropertyAssignmentDeclaration(changeTracker, file, declaration, fieldName) {
          var assignment = ts3.factory.updatePropertyAssignment(declaration, fieldName, declaration.initializer);
          changeTracker.replacePropertyAssignment(file, declaration, assignment);
        }
        function updateFieldDeclaration(changeTracker, file, declaration, type3, fieldName, modifiers) {
          if (ts3.isPropertyDeclaration(declaration)) {
            updatePropertyDeclaration(changeTracker, file, declaration, type3, fieldName, modifiers);
          } else if (ts3.isPropertyAssignment(declaration)) {
            updatePropertyAssignmentDeclaration(changeTracker, file, declaration, fieldName);
          } else {
            changeTracker.replaceNode(file, declaration, ts3.factory.updateParameterDeclaration(declaration, declaration.decorators, modifiers, declaration.dotDotDotToken, ts3.cast(fieldName, ts3.isIdentifier), declaration.questionToken, declaration.type, declaration.initializer));
          }
        }
        function insertAccessor(changeTracker, file, accessor, declaration, container) {
          ts3.isParameterPropertyDeclaration(declaration, declaration.parent) ? changeTracker.insertNodeAtClassStart(file, container, accessor) : ts3.isPropertyAssignment(declaration) ? changeTracker.insertNodeAfterComma(file, declaration, accessor) : changeTracker.insertNodeAfter(file, declaration, accessor);
        }
        function updateReadonlyPropertyInitializerStatementConstructor(changeTracker, file, constructor, fieldName, originalName) {
          if (!constructor.body)
            return;
          constructor.body.forEachChild(function recur(node) {
            if (ts3.isElementAccessExpression(node) && node.expression.kind === 107 && ts3.isStringLiteral(node.argumentExpression) && node.argumentExpression.text === originalName && ts3.isWriteAccess(node)) {
              changeTracker.replaceNode(file, node.argumentExpression, ts3.factory.createStringLiteral(fieldName));
            }
            if (ts3.isPropertyAccessExpression(node) && node.expression.kind === 107 && node.name.text === originalName && ts3.isWriteAccess(node)) {
              changeTracker.replaceNode(file, node.name, ts3.factory.createIdentifier(fieldName));
            }
            if (!ts3.isFunctionLike(node) && !ts3.isClassLike(node)) {
              node.forEachChild(recur);
            }
          });
        }
        function getDeclarationType(declaration, program2) {
          var typeNode = ts3.getTypeAnnotationNode(declaration);
          if (ts3.isPropertyDeclaration(declaration) && typeNode && declaration.questionToken) {
            var typeChecker = program2.getTypeChecker();
            var type3 = typeChecker.getTypeFromTypeNode(typeNode);
            if (!typeChecker.isTypeAssignableTo(typeChecker.getUndefinedType(), type3)) {
              var types2 = ts3.isUnionTypeNode(typeNode) ? typeNode.types : [typeNode];
              return ts3.factory.createUnionTypeNode(__spreadArray(__spreadArray([], types2), [ts3.factory.createKeywordTypeNode(150)]));
            }
          }
          return typeNode;
        }
        function getAllSupers(decl, checker) {
          var res = [];
          while (decl) {
            var superElement = ts3.getClassExtendsHeritageElement(decl);
            var superSymbol = superElement && checker.getSymbolAtLocation(superElement.expression);
            if (!superSymbol)
              break;
            var symbol = superSymbol.flags & 2097152 ? checker.getAliasedSymbol(superSymbol) : superSymbol;
            var superDecl = symbol.declarations && ts3.find(symbol.declarations, ts3.isClassLike);
            if (!superDecl)
              break;
            res.push(superDecl);
            decl = superDecl;
          }
          return res;
        }
        codefix2.getAllSupers = getAllSupers;
      })(codefix = ts3.codefix || (ts3.codefix = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var codefix;
      (function(codefix2) {
        var fixName = "invalidImportSyntax";
        function getCodeFixesForImportDeclaration(context, node) {
          var sourceFile = ts3.getSourceFileOfNode(node);
          var namespace = ts3.getNamespaceDeclarationNode(node);
          var opts = context.program.getCompilerOptions();
          var variations = [];
          variations.push(createAction(context, sourceFile, node, ts3.makeImport(namespace.name, void 0, node.moduleSpecifier, ts3.getQuotePreference(sourceFile, context.preferences))));
          if (ts3.getEmitModuleKind(opts) === ts3.ModuleKind.CommonJS) {
            variations.push(createAction(context, sourceFile, node, ts3.factory.createImportEqualsDeclaration(void 0, void 0, false, namespace.name, ts3.factory.createExternalModuleReference(node.moduleSpecifier))));
          }
          return variations;
        }
        function createAction(context, sourceFile, node, replacement) {
          var changes = ts3.textChanges.ChangeTracker.with(context, function(t2) {
            return t2.replaceNode(sourceFile, node, replacement);
          });
          return codefix2.createCodeFixActionWithoutFixAll(fixName, changes, [ts3.Diagnostics.Replace_import_with_0, changes[0].textChanges[0].newText]);
        }
        codefix2.registerCodeFix({
          errorCodes: [
            ts3.Diagnostics.This_expression_is_not_callable.code,
            ts3.Diagnostics.This_expression_is_not_constructable.code
          ],
          getCodeActions: getActionsForUsageOfInvalidImport
        });
        function getActionsForUsageOfInvalidImport(context) {
          var sourceFile = context.sourceFile;
          var targetKind = ts3.Diagnostics.This_expression_is_not_callable.code === context.errorCode ? 204 : 205;
          var node = ts3.findAncestor(ts3.getTokenAtPosition(sourceFile, context.span.start), function(a2) {
            return a2.kind === targetKind;
          });
          if (!node) {
            return [];
          }
          var expr = node.expression;
          return getImportCodeFixesForExpression(context, expr);
        }
        codefix2.registerCodeFix({
          errorCodes: [
            ts3.Diagnostics.Argument_of_type_0_is_not_assignable_to_parameter_of_type_1.code,
            ts3.Diagnostics.Type_0_does_not_satisfy_the_constraint_1.code,
            ts3.Diagnostics.Type_0_is_not_assignable_to_type_1.code,
            ts3.Diagnostics.Type_0_is_not_assignable_to_type_1_Two_different_types_with_this_name_exist_but_they_are_unrelated.code,
            ts3.Diagnostics.Type_predicate_0_is_not_assignable_to_1.code,
            ts3.Diagnostics.Property_0_of_type_1_is_not_assignable_to_string_index_type_2.code,
            ts3.Diagnostics.Property_0_of_type_1_is_not_assignable_to_numeric_index_type_2.code,
            ts3.Diagnostics.Numeric_index_type_0_is_not_assignable_to_string_index_type_1.code,
            ts3.Diagnostics.Property_0_in_type_1_is_not_assignable_to_the_same_property_in_base_type_2.code,
            ts3.Diagnostics.Property_0_in_type_1_is_not_assignable_to_type_2.code,
            ts3.Diagnostics.Property_0_of_JSX_spread_attribute_is_not_assignable_to_target_property.code,
            ts3.Diagnostics.The_this_context_of_type_0_is_not_assignable_to_method_s_this_of_type_1.code
          ],
          getCodeActions: getActionsForInvalidImportLocation
        });
        function getActionsForInvalidImportLocation(context) {
          var sourceFile = context.sourceFile;
          var node = ts3.findAncestor(ts3.getTokenAtPosition(sourceFile, context.span.start), function(a2) {
            return a2.getStart() === context.span.start && a2.getEnd() === context.span.start + context.span.length;
          });
          if (!node) {
            return [];
          }
          return getImportCodeFixesForExpression(context, node);
        }
        function getImportCodeFixesForExpression(context, expr) {
          var type3 = context.program.getTypeChecker().getTypeAtLocation(expr);
          if (!(type3.symbol && type3.symbol.originatingImport)) {
            return [];
          }
          var fixes = [];
          var relatedImport = type3.symbol.originatingImport;
          if (!ts3.isImportCall(relatedImport)) {
            ts3.addRange(fixes, getCodeFixesForImportDeclaration(context, relatedImport));
          }
          if (ts3.isExpression(expr) && !(ts3.isNamedDeclaration(expr.parent) && expr.parent.name === expr)) {
            var sourceFile_1 = context.sourceFile;
            var changes = ts3.textChanges.ChangeTracker.with(context, function(t2) {
              return t2.replaceNode(sourceFile_1, expr, ts3.factory.createPropertyAccessExpression(expr, "default"), {});
            });
            fixes.push(codefix2.createCodeFixActionWithoutFixAll(fixName, changes, ts3.Diagnostics.Use_synthetic_default_member));
          }
          return fixes;
        }
      })(codefix = ts3.codefix || (ts3.codefix = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var codefix;
      (function(codefix2) {
        var fixName = "strictClassInitialization";
        var fixIdAddDefiniteAssignmentAssertions = "addMissingPropertyDefiniteAssignmentAssertions";
        var fixIdAddUndefinedType = "addMissingPropertyUndefinedType";
        var fixIdAddInitializer = "addMissingPropertyInitializer";
        var errorCodes = [ts3.Diagnostics.Property_0_has_no_initializer_and_is_not_definitely_assigned_in_the_constructor.code];
        codefix2.registerCodeFix({
          errorCodes,
          getCodeActions: function(context) {
            var propertyDeclaration = getPropertyDeclaration(context.sourceFile, context.span.start);
            if (!propertyDeclaration)
              return;
            var result2 = [
              getActionForAddMissingUndefinedType(context, propertyDeclaration),
              getActionForAddMissingDefiniteAssignmentAssertion(context, propertyDeclaration)
            ];
            ts3.append(result2, getActionForAddMissingInitializer(context, propertyDeclaration));
            return result2;
          },
          fixIds: [fixIdAddDefiniteAssignmentAssertions, fixIdAddUndefinedType, fixIdAddInitializer],
          getAllCodeActions: function(context) {
            return codefix2.codeFixAll(context, errorCodes, function(changes, diag) {
              var propertyDeclaration = getPropertyDeclaration(diag.file, diag.start);
              if (!propertyDeclaration)
                return;
              switch (context.fixId) {
                case fixIdAddDefiniteAssignmentAssertions:
                  addDefiniteAssignmentAssertion(changes, diag.file, propertyDeclaration);
                  break;
                case fixIdAddUndefinedType:
                  addUndefinedType(changes, diag.file, propertyDeclaration);
                  break;
                case fixIdAddInitializer:
                  var checker = context.program.getTypeChecker();
                  var initializer = getInitializer(checker, propertyDeclaration);
                  if (!initializer)
                    return;
                  addInitializer(changes, diag.file, propertyDeclaration, initializer);
                  break;
                default:
                  ts3.Debug.fail(JSON.stringify(context.fixId));
              }
            });
          }
        });
        function getPropertyDeclaration(sourceFile, pos) {
          var token = ts3.getTokenAtPosition(sourceFile, pos);
          return ts3.isIdentifier(token) ? ts3.cast(token.parent, ts3.isPropertyDeclaration) : void 0;
        }
        function getActionForAddMissingDefiniteAssignmentAssertion(context, propertyDeclaration) {
          var changes = ts3.textChanges.ChangeTracker.with(context, function(t2) {
            return addDefiniteAssignmentAssertion(t2, context.sourceFile, propertyDeclaration);
          });
          return codefix2.createCodeFixAction(fixName, changes, [ts3.Diagnostics.Add_definite_assignment_assertion_to_property_0, propertyDeclaration.getText()], fixIdAddDefiniteAssignmentAssertions, ts3.Diagnostics.Add_definite_assignment_assertions_to_all_uninitialized_properties);
        }
        function addDefiniteAssignmentAssertion(changeTracker, propertyDeclarationSourceFile, propertyDeclaration) {
          var property = ts3.factory.updatePropertyDeclaration(propertyDeclaration, propertyDeclaration.decorators, propertyDeclaration.modifiers, propertyDeclaration.name, ts3.factory.createToken(53), propertyDeclaration.type, propertyDeclaration.initializer);
          changeTracker.replaceNode(propertyDeclarationSourceFile, propertyDeclaration, property);
        }
        function getActionForAddMissingUndefinedType(context, propertyDeclaration) {
          var changes = ts3.textChanges.ChangeTracker.with(context, function(t2) {
            return addUndefinedType(t2, context.sourceFile, propertyDeclaration);
          });
          return codefix2.createCodeFixAction(fixName, changes, [ts3.Diagnostics.Add_undefined_type_to_property_0, propertyDeclaration.name.getText()], fixIdAddUndefinedType, ts3.Diagnostics.Add_undefined_type_to_all_uninitialized_properties);
        }
        function addUndefinedType(changeTracker, propertyDeclarationSourceFile, propertyDeclaration) {
          var undefinedTypeNode = ts3.factory.createKeywordTypeNode(150);
          var type3 = propertyDeclaration.type;
          var types2 = ts3.isUnionTypeNode(type3) ? type3.types.concat(undefinedTypeNode) : [type3, undefinedTypeNode];
          changeTracker.replaceNode(propertyDeclarationSourceFile, type3, ts3.factory.createUnionTypeNode(types2));
        }
        function getActionForAddMissingInitializer(context, propertyDeclaration) {
          var checker = context.program.getTypeChecker();
          var initializer = getInitializer(checker, propertyDeclaration);
          if (!initializer)
            return void 0;
          var changes = ts3.textChanges.ChangeTracker.with(context, function(t2) {
            return addInitializer(t2, context.sourceFile, propertyDeclaration, initializer);
          });
          return codefix2.createCodeFixAction(fixName, changes, [ts3.Diagnostics.Add_initializer_to_property_0, propertyDeclaration.name.getText()], fixIdAddInitializer, ts3.Diagnostics.Add_initializers_to_all_uninitialized_properties);
        }
        function addInitializer(changeTracker, propertyDeclarationSourceFile, propertyDeclaration, initializer) {
          var property = ts3.factory.updatePropertyDeclaration(propertyDeclaration, propertyDeclaration.decorators, propertyDeclaration.modifiers, propertyDeclaration.name, propertyDeclaration.questionToken, propertyDeclaration.type, initializer);
          changeTracker.replaceNode(propertyDeclarationSourceFile, propertyDeclaration, property);
        }
        function getInitializer(checker, propertyDeclaration) {
          return getDefaultValueFromType(checker, checker.getTypeFromTypeNode(propertyDeclaration.type));
        }
        function getDefaultValueFromType(checker, type3) {
          if (type3.flags & 512) {
            return type3 === checker.getFalseType() || type3 === checker.getFalseType(true) ? ts3.factory.createFalse() : ts3.factory.createTrue();
          } else if (type3.isStringLiteral()) {
            return ts3.factory.createStringLiteral(type3.value);
          } else if (type3.isNumberLiteral()) {
            return ts3.factory.createNumericLiteral(type3.value);
          } else if (type3.flags & 2048) {
            return ts3.factory.createBigIntLiteral(type3.value);
          } else if (type3.isUnion()) {
            return ts3.firstDefined(type3.types, function(t2) {
              return getDefaultValueFromType(checker, t2);
            });
          } else if (type3.isClass()) {
            var classDeclaration = ts3.getClassLikeDeclarationOfSymbol(type3.symbol);
            if (!classDeclaration || ts3.hasSyntacticModifier(classDeclaration, 128))
              return void 0;
            var constructorDeclaration = ts3.getFirstConstructorWithBody(classDeclaration);
            if (constructorDeclaration && constructorDeclaration.parameters.length)
              return void 0;
            return ts3.factory.createNewExpression(ts3.factory.createIdentifier(type3.symbol.name), void 0, void 0);
          } else if (checker.isArrayLikeType(type3)) {
            return ts3.factory.createArrayLiteralExpression();
          }
          return void 0;
        }
      })(codefix = ts3.codefix || (ts3.codefix = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var codefix;
      (function(codefix2) {
        var fixId = "requireInTs";
        var errorCodes = [ts3.Diagnostics.require_call_may_be_converted_to_an_import.code];
        codefix2.registerCodeFix({
          errorCodes,
          getCodeActions: function(context) {
            var info = getInfo(context.sourceFile, context.program, context.span.start);
            if (!info) {
              return void 0;
            }
            var changes = ts3.textChanges.ChangeTracker.with(context, function(t2) {
              return doChange(t2, context.sourceFile, info);
            });
            return [codefix2.createCodeFixAction(fixId, changes, ts3.Diagnostics.Convert_require_to_import, fixId, ts3.Diagnostics.Convert_all_require_to_import)];
          },
          fixIds: [fixId],
          getAllCodeActions: function(context) {
            return codefix2.codeFixAll(context, errorCodes, function(changes, diag) {
              var info = getInfo(diag.file, context.program, diag.start);
              if (info) {
                doChange(changes, context.sourceFile, info);
              }
            });
          }
        });
        function doChange(changes, sourceFile, info) {
          var allowSyntheticDefaults = info.allowSyntheticDefaults, defaultImportName = info.defaultImportName, namedImports = info.namedImports, statement = info.statement, required = info.required;
          changes.replaceNode(sourceFile, statement, defaultImportName && !allowSyntheticDefaults ? ts3.factory.createImportEqualsDeclaration(void 0, void 0, false, defaultImportName, ts3.factory.createExternalModuleReference(required)) : ts3.factory.createImportDeclaration(void 0, void 0, ts3.factory.createImportClause(false, defaultImportName, namedImports), required));
        }
        function getInfo(sourceFile, program2, pos) {
          var parent = ts3.getTokenAtPosition(sourceFile, pos).parent;
          if (!ts3.isRequireCall(parent, true)) {
            throw ts3.Debug.failBadSyntaxKind(parent);
          }
          var decl = ts3.cast(parent.parent, ts3.isVariableDeclaration);
          var defaultImportName = ts3.tryCast(decl.name, ts3.isIdentifier);
          var namedImports = ts3.isObjectBindingPattern(decl.name) ? tryCreateNamedImportsFromObjectBindingPattern(decl.name) : void 0;
          if (defaultImportName || namedImports) {
            return {
              allowSyntheticDefaults: ts3.getAllowSyntheticDefaultImports(program2.getCompilerOptions()),
              defaultImportName,
              namedImports,
              statement: ts3.cast(decl.parent.parent, ts3.isVariableStatement),
              required: ts3.first(parent.arguments)
            };
          }
        }
        function tryCreateNamedImportsFromObjectBindingPattern(node) {
          var importSpecifiers = [];
          for (var _i = 0, _a2 = node.elements; _i < _a2.length; _i++) {
            var element = _a2[_i];
            if (!ts3.isIdentifier(element.name) || element.initializer) {
              return void 0;
            }
            importSpecifiers.push(ts3.factory.createImportSpecifier(ts3.tryCast(element.propertyName, ts3.isIdentifier), element.name));
          }
          if (importSpecifiers.length) {
            return ts3.factory.createNamedImports(importSpecifiers);
          }
        }
      })(codefix = ts3.codefix || (ts3.codefix = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var codefix;
      (function(codefix2) {
        var fixId = "useDefaultImport";
        var errorCodes = [ts3.Diagnostics.Import_may_be_converted_to_a_default_import.code];
        codefix2.registerCodeFix({
          errorCodes,
          getCodeActions: function(context) {
            var sourceFile = context.sourceFile, start = context.span.start;
            var info = getInfo(sourceFile, start);
            if (!info)
              return void 0;
            var changes = ts3.textChanges.ChangeTracker.with(context, function(t2) {
              return doChange(t2, sourceFile, info, context.preferences);
            });
            return [codefix2.createCodeFixAction(fixId, changes, ts3.Diagnostics.Convert_to_default_import, fixId, ts3.Diagnostics.Convert_all_to_default_imports)];
          },
          fixIds: [fixId],
          getAllCodeActions: function(context) {
            return codefix2.codeFixAll(context, errorCodes, function(changes, diag) {
              var info = getInfo(diag.file, diag.start);
              if (info)
                doChange(changes, diag.file, info, context.preferences);
            });
          }
        });
        function getInfo(sourceFile, pos) {
          var name = ts3.getTokenAtPosition(sourceFile, pos);
          if (!ts3.isIdentifier(name))
            return void 0;
          var parent = name.parent;
          if (ts3.isImportEqualsDeclaration(parent) && ts3.isExternalModuleReference(parent.moduleReference)) {
            return { importNode: parent, name, moduleSpecifier: parent.moduleReference.expression };
          } else if (ts3.isNamespaceImport(parent)) {
            var importNode = parent.parent.parent;
            return { importNode, name, moduleSpecifier: importNode.moduleSpecifier };
          }
        }
        function doChange(changes, sourceFile, info, preferences) {
          changes.replaceNode(sourceFile, info.importNode, ts3.makeImport(info.name, void 0, info.moduleSpecifier, ts3.getQuotePreference(sourceFile, preferences)));
        }
      })(codefix = ts3.codefix || (ts3.codefix = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var codefix;
      (function(codefix2) {
        var fixId = "useBigintLiteral";
        var errorCodes = [
          ts3.Diagnostics.Numeric_literals_with_absolute_values_equal_to_2_53_or_greater_are_too_large_to_be_represented_accurately_as_integers.code
        ];
        codefix2.registerCodeFix({
          errorCodes,
          getCodeActions: function(context) {
            var changes = ts3.textChanges.ChangeTracker.with(context, function(t2) {
              return makeChange(t2, context.sourceFile, context.span);
            });
            if (changes.length > 0) {
              return [codefix2.createCodeFixAction(fixId, changes, ts3.Diagnostics.Convert_to_a_bigint_numeric_literal, fixId, ts3.Diagnostics.Convert_all_to_bigint_numeric_literals)];
            }
          },
          fixIds: [fixId],
          getAllCodeActions: function(context) {
            return codefix2.codeFixAll(context, errorCodes, function(changes, diag) {
              return makeChange(changes, diag.file, diag);
            });
          }
        });
        function makeChange(changeTracker, sourceFile, span) {
          var numericLiteral = ts3.tryCast(ts3.getTokenAtPosition(sourceFile, span.start), ts3.isNumericLiteral);
          if (!numericLiteral) {
            return;
          }
          var newText = numericLiteral.getText(sourceFile) + "n";
          changeTracker.replaceNode(sourceFile, numericLiteral, ts3.factory.createBigIntLiteral(newText));
        }
      })(codefix = ts3.codefix || (ts3.codefix = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var codefix;
      (function(codefix2) {
        var fixIdAddMissingTypeof = "fixAddModuleReferTypeMissingTypeof";
        var fixId = fixIdAddMissingTypeof;
        var errorCodes = [ts3.Diagnostics.Module_0_does_not_refer_to_a_type_but_is_used_as_a_type_here_Did_you_mean_typeof_import_0.code];
        codefix2.registerCodeFix({
          errorCodes,
          getCodeActions: function(context) {
            var sourceFile = context.sourceFile, span = context.span;
            var importType = getImportTypeNode(sourceFile, span.start);
            var changes = ts3.textChanges.ChangeTracker.with(context, function(t2) {
              return doChange(t2, sourceFile, importType);
            });
            return [codefix2.createCodeFixAction(fixId, changes, ts3.Diagnostics.Add_missing_typeof, fixId, ts3.Diagnostics.Add_missing_typeof)];
          },
          fixIds: [fixId],
          getAllCodeActions: function(context) {
            return codefix2.codeFixAll(context, errorCodes, function(changes, diag) {
              return doChange(changes, context.sourceFile, getImportTypeNode(diag.file, diag.start));
            });
          }
        });
        function getImportTypeNode(sourceFile, pos) {
          var token = ts3.getTokenAtPosition(sourceFile, pos);
          ts3.Debug.assert(token.kind === 99, "This token should be an ImportKeyword");
          ts3.Debug.assert(token.parent.kind === 196, "Token parent should be an ImportType");
          return token.parent;
        }
        function doChange(changes, sourceFile, importType) {
          var newTypeNode = ts3.factory.updateImportTypeNode(importType, importType.argument, importType.qualifier, importType.typeArguments, true);
          changes.replaceNode(sourceFile, importType, newTypeNode);
        }
      })(codefix = ts3.codefix || (ts3.codefix = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var codefix;
      (function(codefix2) {
        var fixID = "wrapJsxInFragment";
        var errorCodes = [ts3.Diagnostics.JSX_expressions_must_have_one_parent_element.code];
        codefix2.registerCodeFix({
          errorCodes,
          getCodeActions: function(context) {
            var jsx = context.program.getCompilerOptions().jsx;
            if (jsx !== 2 && jsx !== 3) {
              return void 0;
            }
            var sourceFile = context.sourceFile, span = context.span;
            var node = findNodeToFix(sourceFile, span.start);
            if (!node)
              return void 0;
            var changes = ts3.textChanges.ChangeTracker.with(context, function(t2) {
              return doChange(t2, sourceFile, node);
            });
            return [codefix2.createCodeFixAction(fixID, changes, ts3.Diagnostics.Wrap_in_JSX_fragment, fixID, ts3.Diagnostics.Wrap_all_unparented_JSX_in_JSX_fragment)];
          },
          fixIds: [fixID],
          getAllCodeActions: function(context) {
            return codefix2.codeFixAll(context, errorCodes, function(changes, diag) {
              var node = findNodeToFix(context.sourceFile, diag.start);
              if (!node)
                return void 0;
              doChange(changes, context.sourceFile, node);
            });
          }
        });
        function findNodeToFix(sourceFile, pos) {
          var lessThanToken = ts3.getTokenAtPosition(sourceFile, pos);
          var firstJsxElementOrOpenElement = lessThanToken.parent;
          var binaryExpr = firstJsxElementOrOpenElement.parent;
          if (!ts3.isBinaryExpression(binaryExpr)) {
            binaryExpr = binaryExpr.parent;
            if (!ts3.isBinaryExpression(binaryExpr))
              return void 0;
          }
          if (!ts3.nodeIsMissing(binaryExpr.operatorToken))
            return void 0;
          return binaryExpr;
        }
        function doChange(changeTracker, sf, node) {
          var jsx = flattenInvalidBinaryExpr(node);
          if (jsx)
            changeTracker.replaceNode(sf, node, ts3.factory.createJsxFragment(ts3.factory.createJsxOpeningFragment(), jsx, ts3.factory.createJsxJsxClosingFragment()));
        }
        function flattenInvalidBinaryExpr(node) {
          var children = [];
          var current = node;
          while (true) {
            if (ts3.isBinaryExpression(current) && ts3.nodeIsMissing(current.operatorToken) && current.operatorToken.kind === 27) {
              children.push(current.left);
              if (ts3.isJsxChild(current.right)) {
                children.push(current.right);
                return children;
              } else if (ts3.isBinaryExpression(current.right)) {
                current = current.right;
                continue;
              } else
                return void 0;
            } else
              return void 0;
          }
        }
      })(codefix = ts3.codefix || (ts3.codefix = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var codefix;
      (function(codefix2) {
        var fixIdAddMissingTypeof = "fixConvertToMappedObjectType";
        var fixId = fixIdAddMissingTypeof;
        var errorCodes = [ts3.Diagnostics.An_index_signature_parameter_type_cannot_be_a_union_type_Consider_using_a_mapped_object_type_instead.code];
        codefix2.registerCodeFix({
          errorCodes,
          getCodeActions: function(context) {
            var sourceFile = context.sourceFile, span = context.span;
            var info = getInfo(sourceFile, span.start);
            if (!info)
              return void 0;
            var changes = ts3.textChanges.ChangeTracker.with(context, function(t2) {
              return doChange(t2, sourceFile, info);
            });
            var name = ts3.idText(info.container.name);
            return [codefix2.createCodeFixAction(fixId, changes, [ts3.Diagnostics.Convert_0_to_mapped_object_type, name], fixId, [ts3.Diagnostics.Convert_0_to_mapped_object_type, name])];
          },
          fixIds: [fixId],
          getAllCodeActions: function(context) {
            return codefix2.codeFixAll(context, errorCodes, function(changes, diag) {
              var info = getInfo(diag.file, diag.start);
              if (info)
                doChange(changes, diag.file, info);
            });
          }
        });
        function getInfo(sourceFile, pos) {
          var token = ts3.getTokenAtPosition(sourceFile, pos);
          var indexSignature = ts3.cast(token.parent.parent, ts3.isIndexSignatureDeclaration);
          if (ts3.isClassDeclaration(indexSignature.parent))
            return void 0;
          var container = ts3.isInterfaceDeclaration(indexSignature.parent) ? indexSignature.parent : ts3.cast(indexSignature.parent.parent, ts3.isTypeAliasDeclaration);
          return { indexSignature, container };
        }
        function createTypeAliasFromInterface(declaration, type3) {
          return ts3.factory.createTypeAliasDeclaration(declaration.decorators, declaration.modifiers, declaration.name, declaration.typeParameters, type3);
        }
        function doChange(changes, sourceFile, _a2) {
          var indexSignature = _a2.indexSignature, container = _a2.container;
          var members = ts3.isInterfaceDeclaration(container) ? container.members : container.type.members;
          var otherMembers = members.filter(function(member) {
            return !ts3.isIndexSignatureDeclaration(member);
          });
          var parameter = ts3.first(indexSignature.parameters);
          var mappedTypeParameter = ts3.factory.createTypeParameterDeclaration(ts3.cast(parameter.name, ts3.isIdentifier), parameter.type);
          var mappedIntersectionType = ts3.factory.createMappedTypeNode(ts3.hasEffectiveReadonlyModifier(indexSignature) ? ts3.factory.createModifier(142) : void 0, mappedTypeParameter, void 0, indexSignature.questionToken, indexSignature.type);
          var intersectionType = ts3.factory.createIntersectionTypeNode(__spreadArray(__spreadArray(__spreadArray([], ts3.getAllSuperTypeNodes(container)), [
            mappedIntersectionType
          ]), otherMembers.length ? [ts3.factory.createTypeLiteralNode(otherMembers)] : ts3.emptyArray));
          changes.replaceNode(sourceFile, container, createTypeAliasFromInterface(container, intersectionType));
        }
      })(codefix = ts3.codefix || (ts3.codefix = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var codefix;
      (function(codefix2) {
        var fixId = "removeAccidentalCallParentheses";
        var errorCodes = [
          ts3.Diagnostics.This_expression_is_not_callable_because_it_is_a_get_accessor_Did_you_mean_to_use_it_without.code
        ];
        codefix2.registerCodeFix({
          errorCodes,
          getCodeActions: function(context) {
            var callExpression2 = ts3.findAncestor(ts3.getTokenAtPosition(context.sourceFile, context.span.start), ts3.isCallExpression);
            if (!callExpression2) {
              return void 0;
            }
            var changes = ts3.textChanges.ChangeTracker.with(context, function(t2) {
              t2.deleteRange(context.sourceFile, { pos: callExpression2.expression.end, end: callExpression2.end });
            });
            return [codefix2.createCodeFixActionWithoutFixAll(fixId, changes, ts3.Diagnostics.Remove_parentheses)];
          },
          fixIds: [fixId]
        });
      })(codefix = ts3.codefix || (ts3.codefix = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var codefix;
      (function(codefix2) {
        var fixId = "removeUnnecessaryAwait";
        var errorCodes = [
          ts3.Diagnostics.await_has_no_effect_on_the_type_of_this_expression.code
        ];
        codefix2.registerCodeFix({
          errorCodes,
          getCodeActions: function(context) {
            var changes = ts3.textChanges.ChangeTracker.with(context, function(t2) {
              return makeChange(t2, context.sourceFile, context.span);
            });
            if (changes.length > 0) {
              return [codefix2.createCodeFixAction(fixId, changes, ts3.Diagnostics.Remove_unnecessary_await, fixId, ts3.Diagnostics.Remove_all_unnecessary_uses_of_await)];
            }
          },
          fixIds: [fixId],
          getAllCodeActions: function(context) {
            return codefix2.codeFixAll(context, errorCodes, function(changes, diag) {
              return makeChange(changes, diag.file, diag);
            });
          }
        });
        function makeChange(changeTracker, sourceFile, span) {
          var awaitKeyword = ts3.tryCast(ts3.getTokenAtPosition(sourceFile, span.start), function(node) {
            return node.kind === 130;
          });
          var awaitExpression = awaitKeyword && ts3.tryCast(awaitKeyword.parent, ts3.isAwaitExpression);
          if (!awaitExpression) {
            return;
          }
          var expressionToReplace = awaitExpression;
          var hasSurroundingParens = ts3.isParenthesizedExpression(awaitExpression.parent);
          if (hasSurroundingParens) {
            var leftMostExpression = ts3.getLeftmostExpression(awaitExpression.expression, false);
            if (ts3.isIdentifier(leftMostExpression)) {
              var precedingToken = ts3.findPrecedingToken(awaitExpression.parent.pos, sourceFile);
              if (precedingToken && precedingToken.kind !== 102) {
                expressionToReplace = awaitExpression.parent;
              }
            }
          }
          changeTracker.replaceNode(sourceFile, expressionToReplace, awaitExpression.expression);
        }
      })(codefix = ts3.codefix || (ts3.codefix = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var codefix;
      (function(codefix2) {
        var errorCodes = [ts3.Diagnostics.A_type_only_import_can_specify_a_default_import_or_named_bindings_but_not_both.code];
        var fixId = "splitTypeOnlyImport";
        codefix2.registerCodeFix({
          errorCodes,
          fixIds: [fixId],
          getCodeActions: function(context) {
            var changes = ts3.textChanges.ChangeTracker.with(context, function(t2) {
              return splitTypeOnlyImport(t2, getImportDeclaration(context.sourceFile, context.span), context);
            });
            if (changes.length) {
              return [codefix2.createCodeFixAction(fixId, changes, ts3.Diagnostics.Split_into_two_separate_import_declarations, fixId, ts3.Diagnostics.Split_all_invalid_type_only_imports)];
            }
          },
          getAllCodeActions: function(context) {
            return codefix2.codeFixAll(context, errorCodes, function(changes, error) {
              splitTypeOnlyImport(changes, getImportDeclaration(context.sourceFile, error), context);
            });
          }
        });
        function getImportDeclaration(sourceFile, span) {
          return ts3.findAncestor(ts3.getTokenAtPosition(sourceFile, span.start), ts3.isImportDeclaration);
        }
        function splitTypeOnlyImport(changes, importDeclaration, context) {
          if (!importDeclaration) {
            return;
          }
          var importClause = ts3.Debug.checkDefined(importDeclaration.importClause);
          changes.replaceNode(context.sourceFile, importDeclaration, ts3.factory.updateImportDeclaration(importDeclaration, importDeclaration.decorators, importDeclaration.modifiers, ts3.factory.updateImportClause(importClause, importClause.isTypeOnly, importClause.name, void 0), importDeclaration.moduleSpecifier));
          changes.insertNodeAfter(context.sourceFile, importDeclaration, ts3.factory.createImportDeclaration(void 0, void 0, ts3.factory.updateImportClause(importClause, importClause.isTypeOnly, void 0, importClause.namedBindings), importDeclaration.moduleSpecifier));
        }
      })(codefix = ts3.codefix || (ts3.codefix = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var codefix;
      (function(codefix2) {
        var fixId = "fixConvertConstToLet";
        var errorCodes = [ts3.Diagnostics.Cannot_assign_to_0_because_it_is_a_constant.code];
        codefix2.registerCodeFix({
          errorCodes,
          getCodeActions: function(context) {
            var sourceFile = context.sourceFile, span = context.span, program2 = context.program;
            var variableStatement = getVariableStatement(sourceFile, span.start, program2);
            var changes = ts3.textChanges.ChangeTracker.with(context, function(t2) {
              return doChange(t2, sourceFile, variableStatement);
            });
            return [codefix2.createCodeFixAction(fixId, changes, ts3.Diagnostics.Convert_const_to_let, fixId, ts3.Diagnostics.Convert_const_to_let)];
          },
          fixIds: [fixId]
        });
        function getVariableStatement(sourceFile, pos, program2) {
          var token = ts3.getTokenAtPosition(sourceFile, pos);
          var checker = program2.getTypeChecker();
          var symbol = checker.getSymbolAtLocation(token);
          if (symbol === null || symbol === void 0 ? void 0 : symbol.valueDeclaration) {
            return symbol.valueDeclaration.parent.parent;
          }
        }
        function doChange(changes, sourceFile, variableStatement) {
          if (!variableStatement) {
            return;
          }
          var start = variableStatement.getStart();
          changes.replaceRangeWithText(sourceFile, { pos: start, end: start + 5 }, "let");
        }
      })(codefix = ts3.codefix || (ts3.codefix = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var codefix;
      (function(codefix2) {
        var fixId = "fixExpectedComma";
        var expectedErrorCode = ts3.Diagnostics._0_expected.code;
        var errorCodes = [expectedErrorCode];
        codefix2.registerCodeFix({
          errorCodes,
          getCodeActions: function(context) {
            var sourceFile = context.sourceFile;
            var info = getInfo(sourceFile, context.span.start, context.errorCode);
            if (!info) {
              return void 0;
            }
            var changes = ts3.textChanges.ChangeTracker.with(context, function(t2) {
              return doChange(t2, sourceFile, info);
            });
            return [codefix2.createCodeFixAction(fixId, changes, [ts3.Diagnostics.Change_0_to_1, ";", ","], fixId, [ts3.Diagnostics.Change_0_to_1, ";", ","])];
          },
          fixIds: [fixId],
          getAllCodeActions: function(context) {
            return codefix2.codeFixAll(context, errorCodes, function(changes, diag) {
              var info = getInfo(diag.file, diag.start, diag.code);
              if (info)
                doChange(changes, context.sourceFile, info);
            });
          }
        });
        function getInfo(sourceFile, pos, _) {
          var node = ts3.getTokenAtPosition(sourceFile, pos);
          return node.kind === 26 && node.parent && (ts3.isObjectLiteralExpression(node.parent) || ts3.isArrayLiteralExpression(node.parent)) ? { node } : void 0;
        }
        function doChange(changes, sourceFile, _a2) {
          var node = _a2.node;
          var newNode = ts3.factory.createToken(27);
          changes.replaceNode(sourceFile, node, newNode);
        }
      })(codefix = ts3.codefix || (ts3.codefix = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var codefix;
      (function(codefix2) {
        var fixName = "addVoidToPromise";
        var fixId = "addVoidToPromise";
        var errorCodes = [
          ts3.Diagnostics.Expected_0_arguments_but_got_1_Did_you_forget_to_include_void_in_your_type_argument_to_Promise.code
        ];
        codefix2.registerCodeFix({
          errorCodes,
          fixIds: [fixId],
          getCodeActions: function(context) {
            var changes = ts3.textChanges.ChangeTracker.with(context, function(t2) {
              return makeChange(t2, context.sourceFile, context.span, context.program);
            });
            if (changes.length > 0) {
              return [codefix2.createCodeFixAction(fixName, changes, ts3.Diagnostics.Add_void_to_Promise_resolved_without_a_value, fixId, ts3.Diagnostics.Add_void_to_all_Promises_resolved_without_a_value)];
            }
          },
          getAllCodeActions: function(context) {
            return codefix2.codeFixAll(context, errorCodes, function(changes, diag) {
              return makeChange(changes, diag.file, diag, context.program, new ts3.Set());
            });
          }
        });
        function makeChange(changes, sourceFile, span, program2, seen) {
          var node = ts3.getTokenAtPosition(sourceFile, span.start);
          if (!ts3.isIdentifier(node) || !ts3.isCallExpression(node.parent) || node.parent.expression !== node || node.parent.arguments.length !== 0)
            return;
          var checker = program2.getTypeChecker();
          var symbol = checker.getSymbolAtLocation(node);
          var decl = symbol === null || symbol === void 0 ? void 0 : symbol.valueDeclaration;
          if (!decl || !ts3.isParameter(decl) || !ts3.isNewExpression(decl.parent.parent))
            return;
          if (seen === null || seen === void 0 ? void 0 : seen.has(decl))
            return;
          seen === null || seen === void 0 ? void 0 : seen.add(decl);
          var typeArguments = getEffectiveTypeArguments(decl.parent.parent);
          if (ts3.some(typeArguments)) {
            var typeArgument = typeArguments[0];
            var needsParens = !ts3.isUnionTypeNode(typeArgument) && !ts3.isParenthesizedTypeNode(typeArgument) && ts3.isParenthesizedTypeNode(ts3.factory.createUnionTypeNode([typeArgument, ts3.factory.createKeywordTypeNode(113)]).types[0]);
            if (needsParens) {
              changes.insertText(sourceFile, typeArgument.pos, "(");
            }
            changes.insertText(sourceFile, typeArgument.end, needsParens ? ") | void" : " | void");
          } else {
            var signature = checker.getResolvedSignature(node.parent);
            var parameter = signature === null || signature === void 0 ? void 0 : signature.parameters[0];
            var parameterType = parameter && checker.getTypeOfSymbolAtLocation(parameter, decl.parent.parent);
            if (ts3.isInJSFile(decl)) {
              if (!parameterType || parameterType.flags & 3) {
                changes.insertText(sourceFile, decl.parent.parent.end, ")");
                changes.insertText(sourceFile, ts3.skipTrivia(sourceFile.text, decl.parent.parent.pos), "/** @type {Promise<void>} */(");
              }
            } else {
              if (!parameterType || parameterType.flags & 2) {
                changes.insertText(sourceFile, decl.parent.parent.expression.end, "<void>");
              }
            }
          }
        }
        function getEffectiveTypeArguments(node) {
          var _a2;
          if (ts3.isInJSFile(node)) {
            if (ts3.isParenthesizedExpression(node.parent)) {
              var jsDocType = (_a2 = ts3.getJSDocTypeTag(node.parent)) === null || _a2 === void 0 ? void 0 : _a2.typeExpression.type;
              if (jsDocType && ts3.isTypeReferenceNode(jsDocType) && ts3.isIdentifier(jsDocType.typeName) && ts3.idText(jsDocType.typeName) === "Promise") {
                return jsDocType.typeArguments;
              }
            }
          } else {
            return node.typeArguments;
          }
        }
      })(codefix = ts3.codefix || (ts3.codefix = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var refactor;
      (function(refactor2) {
        var refactorName = "Convert export";
        var defaultToNamedAction = {
          name: "Convert default export to named export",
          description: ts3.Diagnostics.Convert_default_export_to_named_export.message,
          kind: "refactor.rewrite.export.named"
        };
        var namedToDefaultAction = {
          name: "Convert named export to default export",
          description: ts3.Diagnostics.Convert_named_export_to_default_export.message,
          kind: "refactor.rewrite.export.default"
        };
        refactor2.registerRefactor(refactorName, {
          kinds: [
            defaultToNamedAction.kind,
            namedToDefaultAction.kind
          ],
          getAvailableActions: function(context) {
            var info = getInfo(context, context.triggerReason === "invoked");
            if (!info)
              return ts3.emptyArray;
            if (!refactor2.isRefactorErrorInfo(info)) {
              var action = info.wasDefault ? defaultToNamedAction : namedToDefaultAction;
              return [{ name: refactorName, description: action.description, actions: [action] }];
            }
            if (context.preferences.provideRefactorNotApplicableReason) {
              return [
                { name: refactorName, description: ts3.Diagnostics.Convert_default_export_to_named_export.message, actions: [
                  __assign(__assign({}, defaultToNamedAction), { notApplicableReason: info.error }),
                  __assign(__assign({}, namedToDefaultAction), { notApplicableReason: info.error })
                ] }
              ];
            }
            return ts3.emptyArray;
          },
          getEditsForAction: function(context, actionName) {
            ts3.Debug.assert(actionName === defaultToNamedAction.name || actionName === namedToDefaultAction.name, "Unexpected action name");
            var info = getInfo(context);
            ts3.Debug.assert(info && !refactor2.isRefactorErrorInfo(info), "Expected applicable refactor info");
            var edits = ts3.textChanges.ChangeTracker.with(context, function(t2) {
              return doChange(context.file, context.program, info, t2, context.cancellationToken);
            });
            return { edits, renameFilename: void 0, renameLocation: void 0 };
          }
        });
        ;
        function getInfo(context, considerPartialSpans) {
          if (considerPartialSpans === void 0) {
            considerPartialSpans = true;
          }
          var file = context.file;
          var span = ts3.getRefactorContextSpan(context);
          var token = ts3.getTokenAtPosition(file, span.start);
          var exportNode = !!(token.parent && ts3.getSyntacticModifierFlags(token.parent) & 1) && considerPartialSpans ? token.parent : ts3.getParentNodeInSpan(token, file, span);
          if (!exportNode || !ts3.isSourceFile(exportNode.parent) && !(ts3.isModuleBlock(exportNode.parent) && ts3.isAmbientModule(exportNode.parent.parent))) {
            return { error: ts3.getLocaleSpecificMessage(ts3.Diagnostics.Could_not_find_export_statement) };
          }
          var exportingModuleSymbol = ts3.isSourceFile(exportNode.parent) ? exportNode.parent.symbol : exportNode.parent.parent.symbol;
          var flags = ts3.getSyntacticModifierFlags(exportNode) || (ts3.isExportAssignment(exportNode) && !exportNode.isExportEquals ? 513 : 0);
          var wasDefault = !!(flags & 512);
          if (!(flags & 1) || !wasDefault && exportingModuleSymbol.exports.has("default")) {
            return { error: ts3.getLocaleSpecificMessage(ts3.Diagnostics.This_file_already_has_a_default_export) };
          }
          switch (exportNode.kind) {
            case 252:
            case 253:
            case 254:
            case 256:
            case 255:
            case 257: {
              var node = exportNode;
              return node.name && ts3.isIdentifier(node.name) ? { exportNode: node, exportName: node.name, wasDefault, exportingModuleSymbol } : void 0;
            }
            case 233: {
              var vs = exportNode;
              if (!(vs.declarationList.flags & 2) || vs.declarationList.declarations.length !== 1) {
                return void 0;
              }
              var decl = ts3.first(vs.declarationList.declarations);
              if (!decl.initializer)
                return void 0;
              ts3.Debug.assert(!wasDefault, "Can't have a default flag here");
              return ts3.isIdentifier(decl.name) ? { exportNode: vs, exportName: decl.name, wasDefault, exportingModuleSymbol } : void 0;
            }
            case 267: {
              var node = exportNode;
              var exp = node.expression;
              return node.isExportEquals ? void 0 : { exportNode: node, exportName: exp, wasDefault, exportingModuleSymbol };
            }
            default:
              return void 0;
          }
        }
        function doChange(exportingSourceFile, program2, info, changes, cancellationToken) {
          changeExport(exportingSourceFile, info, changes, program2.getTypeChecker());
          changeImports(program2, info, changes, cancellationToken);
        }
        function changeExport(exportingSourceFile, _a2, changes, checker) {
          var wasDefault = _a2.wasDefault, exportNode = _a2.exportNode, exportName = _a2.exportName;
          if (wasDefault) {
            if (ts3.isExportAssignment(exportNode) && !exportNode.isExportEquals) {
              var exp = exportNode.expression;
              var spec = makeExportSpecifier(exp.text, exp.text);
              changes.replaceNode(exportingSourceFile, exportNode, ts3.factory.createExportDeclaration(void 0, void 0, false, ts3.factory.createNamedExports([spec])));
            } else {
              changes.delete(exportingSourceFile, ts3.Debug.checkDefined(ts3.findModifier(exportNode, 87), "Should find a default keyword in modifier list"));
            }
          } else {
            var exportKeyword = ts3.Debug.checkDefined(ts3.findModifier(exportNode, 92), "Should find an export keyword in modifier list");
            switch (exportNode.kind) {
              case 252:
              case 253:
              case 254:
                changes.insertNodeAfter(exportingSourceFile, exportKeyword, ts3.factory.createToken(87));
                break;
              case 233:
                var decl = ts3.first(exportNode.declarationList.declarations);
                if (!ts3.FindAllReferences.Core.isSymbolReferencedInFile(exportName, checker, exportingSourceFile) && !decl.type) {
                  changes.replaceNode(exportingSourceFile, exportNode, ts3.factory.createExportDefault(ts3.Debug.checkDefined(decl.initializer, "Initializer was previously known to be present")));
                  break;
                }
              case 256:
              case 255:
              case 257:
                changes.deleteModifier(exportingSourceFile, exportKeyword);
                changes.insertNodeAfter(exportingSourceFile, exportNode, ts3.factory.createExportDefault(ts3.factory.createIdentifier(exportName.text)));
                break;
              default:
                ts3.Debug.fail("Unexpected exportNode kind " + exportNode.kind);
            }
          }
        }
        function changeImports(program2, _a2, changes, cancellationToken) {
          var wasDefault = _a2.wasDefault, exportName = _a2.exportName, exportingModuleSymbol = _a2.exportingModuleSymbol;
          var checker = program2.getTypeChecker();
          var exportSymbol = ts3.Debug.checkDefined(checker.getSymbolAtLocation(exportName), "Export name should resolve to a symbol");
          ts3.FindAllReferences.Core.eachExportReference(program2.getSourceFiles(), checker, cancellationToken, exportSymbol, exportingModuleSymbol, exportName.text, wasDefault, function(ref2) {
            var importingSourceFile = ref2.getSourceFile();
            if (wasDefault) {
              changeDefaultToNamedImport(importingSourceFile, ref2, changes, exportName.text);
            } else {
              changeNamedToDefaultImport(importingSourceFile, ref2, changes);
            }
          });
        }
        function changeDefaultToNamedImport(importingSourceFile, ref2, changes, exportName) {
          var parent = ref2.parent;
          switch (parent.kind) {
            case 202:
              changes.replaceNode(importingSourceFile, ref2, ts3.factory.createIdentifier(exportName));
              break;
            case 266:
            case 271: {
              var spec = parent;
              changes.replaceNode(importingSourceFile, spec, makeImportSpecifier(exportName, spec.name.text));
              break;
            }
            case 263: {
              var clause = parent;
              ts3.Debug.assert(clause.name === ref2, "Import clause name should match provided ref");
              var spec = makeImportSpecifier(exportName, ref2.text);
              var namedBindings = clause.namedBindings;
              if (!namedBindings) {
                changes.replaceNode(importingSourceFile, ref2, ts3.factory.createNamedImports([spec]));
              } else if (namedBindings.kind === 264) {
                changes.deleteRange(importingSourceFile, { pos: ref2.getStart(importingSourceFile), end: namedBindings.getStart(importingSourceFile) });
                var quotePreference = ts3.isStringLiteral(clause.parent.moduleSpecifier) ? ts3.quotePreferenceFromString(clause.parent.moduleSpecifier, importingSourceFile) : 1;
                var newImport = ts3.makeImport(void 0, [makeImportSpecifier(exportName, ref2.text)], clause.parent.moduleSpecifier, quotePreference);
                changes.insertNodeAfter(importingSourceFile, clause.parent, newImport);
              } else {
                changes.delete(importingSourceFile, ref2);
                changes.insertNodeAtEndOfList(importingSourceFile, namedBindings.elements, spec);
              }
              break;
            }
            default:
              ts3.Debug.failBadSyntaxKind(parent);
          }
        }
        function changeNamedToDefaultImport(importingSourceFile, ref2, changes) {
          var parent = ref2.parent;
          switch (parent.kind) {
            case 202:
              changes.replaceNode(importingSourceFile, ref2, ts3.factory.createIdentifier("default"));
              break;
            case 266: {
              var defaultImport = ts3.factory.createIdentifier(parent.name.text);
              if (parent.parent.elements.length === 1) {
                changes.replaceNode(importingSourceFile, parent.parent, defaultImport);
              } else {
                changes.delete(importingSourceFile, parent);
                changes.insertNodeBefore(importingSourceFile, parent.parent, defaultImport);
              }
              break;
            }
            case 271: {
              changes.replaceNode(importingSourceFile, parent, makeExportSpecifier("default", parent.name.text));
              break;
            }
            default:
              ts3.Debug.assertNever(parent, "Unexpected parent kind " + parent.kind);
          }
        }
        function makeImportSpecifier(propertyName, name) {
          return ts3.factory.createImportSpecifier(propertyName === name ? void 0 : ts3.factory.createIdentifier(propertyName), ts3.factory.createIdentifier(name));
        }
        function makeExportSpecifier(propertyName, name) {
          return ts3.factory.createExportSpecifier(propertyName === name ? void 0 : ts3.factory.createIdentifier(propertyName), ts3.factory.createIdentifier(name));
        }
      })(refactor = ts3.refactor || (ts3.refactor = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var refactor;
      (function(refactor2) {
        var refactorName = "Convert import";
        var namespaceToNamedAction = {
          name: "Convert namespace import to named imports",
          description: ts3.Diagnostics.Convert_namespace_import_to_named_imports.message,
          kind: "refactor.rewrite.import.named"
        };
        var namedToNamespaceAction = {
          name: "Convert named imports to namespace import",
          description: ts3.Diagnostics.Convert_named_imports_to_namespace_import.message,
          kind: "refactor.rewrite.import.namespace"
        };
        refactor2.registerRefactor(refactorName, {
          kinds: [
            namespaceToNamedAction.kind,
            namedToNamespaceAction.kind
          ],
          getAvailableActions: function(context) {
            var info = getImportToConvert(context, context.triggerReason === "invoked");
            if (!info)
              return ts3.emptyArray;
            if (!refactor2.isRefactorErrorInfo(info)) {
              var namespaceImport = info.kind === 264;
              var action = namespaceImport ? namespaceToNamedAction : namedToNamespaceAction;
              return [{ name: refactorName, description: action.description, actions: [action] }];
            }
            if (context.preferences.provideRefactorNotApplicableReason) {
              return [
                {
                  name: refactorName,
                  description: namespaceToNamedAction.description,
                  actions: [__assign(__assign({}, namespaceToNamedAction), { notApplicableReason: info.error })]
                },
                {
                  name: refactorName,
                  description: namedToNamespaceAction.description,
                  actions: [__assign(__assign({}, namedToNamespaceAction), { notApplicableReason: info.error })]
                }
              ];
            }
            return ts3.emptyArray;
          },
          getEditsForAction: function(context, actionName) {
            ts3.Debug.assert(actionName === namespaceToNamedAction.name || actionName === namedToNamespaceAction.name, "Unexpected action name");
            var info = getImportToConvert(context);
            ts3.Debug.assert(info && !refactor2.isRefactorErrorInfo(info), "Expected applicable refactor info");
            var edits = ts3.textChanges.ChangeTracker.with(context, function(t2) {
              return doChange(context.file, context.program, t2, info);
            });
            return { edits, renameFilename: void 0, renameLocation: void 0 };
          }
        });
        function getImportToConvert(context, considerPartialSpans) {
          if (considerPartialSpans === void 0) {
            considerPartialSpans = true;
          }
          var file = context.file;
          var span = ts3.getRefactorContextSpan(context);
          var token = ts3.getTokenAtPosition(file, span.start);
          var importDecl = considerPartialSpans ? ts3.findAncestor(token, ts3.isImportDeclaration) : ts3.getParentNodeInSpan(token, file, span);
          if (!importDecl || !ts3.isImportDeclaration(importDecl))
            return { error: "Selection is not an import declaration." };
          if (importDecl.getEnd() < span.start + span.length)
            return void 0;
          var importClause = importDecl.importClause;
          if (!importClause) {
            return { error: ts3.getLocaleSpecificMessage(ts3.Diagnostics.Could_not_find_import_clause) };
          }
          if (!importClause.namedBindings) {
            return { error: ts3.getLocaleSpecificMessage(ts3.Diagnostics.Could_not_find_namespace_import_or_named_imports) };
          }
          return importClause.namedBindings;
        }
        function doChange(sourceFile, program2, changes, toConvert) {
          var checker = program2.getTypeChecker();
          if (toConvert.kind === 264) {
            doChangeNamespaceToNamed(sourceFile, checker, changes, toConvert, ts3.getAllowSyntheticDefaultImports(program2.getCompilerOptions()));
          } else {
            doChangeNamedToNamespace(sourceFile, checker, changes, toConvert);
          }
        }
        function doChangeNamespaceToNamed(sourceFile, checker, changes, toConvert, allowSyntheticDefaultImports) {
          var usedAsNamespaceOrDefault = false;
          var nodesToReplace = [];
          var conflictingNames = new ts3.Map();
          ts3.FindAllReferences.Core.eachSymbolReferenceInFile(toConvert.name, checker, sourceFile, function(id) {
            if (!ts3.isPropertyAccessOrQualifiedName(id.parent)) {
              usedAsNamespaceOrDefault = true;
            } else {
              var exportName2 = getRightOfPropertyAccessOrQualifiedName(id.parent).text;
              if (checker.resolveName(exportName2, id, 67108863, true)) {
                conflictingNames.set(exportName2, true);
              }
              ts3.Debug.assert(getLeftOfPropertyAccessOrQualifiedName(id.parent) === id, "Parent expression should match id");
              nodesToReplace.push(id.parent);
            }
          });
          var exportNameToImportName = new ts3.Map();
          for (var _i = 0, nodesToReplace_1 = nodesToReplace; _i < nodesToReplace_1.length; _i++) {
            var propertyAccessOrQualifiedName = nodesToReplace_1[_i];
            var exportName = getRightOfPropertyAccessOrQualifiedName(propertyAccessOrQualifiedName).text;
            var importName = exportNameToImportName.get(exportName);
            if (importName === void 0) {
              exportNameToImportName.set(exportName, importName = conflictingNames.has(exportName) ? ts3.getUniqueName(exportName, sourceFile) : exportName);
            }
            changes.replaceNode(sourceFile, propertyAccessOrQualifiedName, ts3.factory.createIdentifier(importName));
          }
          var importSpecifiers = [];
          exportNameToImportName.forEach(function(name, propertyName) {
            importSpecifiers.push(ts3.factory.createImportSpecifier(name === propertyName ? void 0 : ts3.factory.createIdentifier(propertyName), ts3.factory.createIdentifier(name)));
          });
          var importDecl = toConvert.parent.parent;
          if (usedAsNamespaceOrDefault && !allowSyntheticDefaultImports) {
            changes.insertNodeAfter(sourceFile, importDecl, updateImport(importDecl, void 0, importSpecifiers));
          } else {
            changes.replaceNode(sourceFile, importDecl, updateImport(importDecl, usedAsNamespaceOrDefault ? ts3.factory.createIdentifier(toConvert.name.text) : void 0, importSpecifiers));
          }
        }
        function getRightOfPropertyAccessOrQualifiedName(propertyAccessOrQualifiedName) {
          return ts3.isPropertyAccessExpression(propertyAccessOrQualifiedName) ? propertyAccessOrQualifiedName.name : propertyAccessOrQualifiedName.right;
        }
        function getLeftOfPropertyAccessOrQualifiedName(propertyAccessOrQualifiedName) {
          return ts3.isPropertyAccessExpression(propertyAccessOrQualifiedName) ? propertyAccessOrQualifiedName.expression : propertyAccessOrQualifiedName.left;
        }
        function doChangeNamedToNamespace(sourceFile, checker, changes, toConvert) {
          var importDecl = toConvert.parent.parent;
          var moduleSpecifier = importDecl.moduleSpecifier;
          var preferredName = moduleSpecifier && ts3.isStringLiteral(moduleSpecifier) ? ts3.codefix.moduleSpecifierToValidIdentifier(moduleSpecifier.text, 99) : "module";
          var namespaceNameConflicts = toConvert.elements.some(function(element2) {
            return ts3.FindAllReferences.Core.eachSymbolReferenceInFile(element2.name, checker, sourceFile, function(id) {
              return !!checker.resolveName(preferredName, id, 67108863, true);
            }) || false;
          });
          var namespaceImportName = namespaceNameConflicts ? ts3.getUniqueName(preferredName, sourceFile) : preferredName;
          var neededNamedImports = [];
          var _loop_16 = function(element2) {
            var propertyName = (element2.propertyName || element2.name).text;
            ts3.FindAllReferences.Core.eachSymbolReferenceInFile(element2.name, checker, sourceFile, function(id) {
              var access = ts3.factory.createPropertyAccessExpression(ts3.factory.createIdentifier(namespaceImportName), propertyName);
              if (ts3.isShorthandPropertyAssignment(id.parent)) {
                changes.replaceNode(sourceFile, id.parent, ts3.factory.createPropertyAssignment(id.text, access));
              } else if (ts3.isExportSpecifier(id.parent) && !id.parent.propertyName) {
                if (!neededNamedImports.some(function(n2) {
                  return n2.name === element2.name;
                })) {
                  neededNamedImports.push(ts3.factory.createImportSpecifier(element2.propertyName && ts3.factory.createIdentifier(element2.propertyName.text), ts3.factory.createIdentifier(element2.name.text)));
                }
              } else {
                changes.replaceNode(sourceFile, id, access);
              }
            });
          };
          for (var _i = 0, _a2 = toConvert.elements; _i < _a2.length; _i++) {
            var element = _a2[_i];
            _loop_16(element);
          }
          changes.replaceNode(sourceFile, toConvert, ts3.factory.createNamespaceImport(ts3.factory.createIdentifier(namespaceImportName)));
          if (neededNamedImports.length) {
            changes.insertNodeAfter(sourceFile, toConvert.parent.parent, updateImport(importDecl, void 0, neededNamedImports));
          }
        }
        function updateImport(old, defaultImportName, elements) {
          return ts3.factory.createImportDeclaration(void 0, void 0, ts3.factory.createImportClause(false, defaultImportName, elements && elements.length ? ts3.factory.createNamedImports(elements) : void 0), old.moduleSpecifier);
        }
      })(refactor = ts3.refactor || (ts3.refactor = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var refactor;
      (function(refactor2) {
        var convertToOptionalChainExpression;
        (function(convertToOptionalChainExpression2) {
          var refactorName = "Convert to optional chain expression";
          var convertToOptionalChainExpressionMessage = ts3.getLocaleSpecificMessage(ts3.Diagnostics.Convert_to_optional_chain_expression);
          var toOptionalChainAction = {
            name: refactorName,
            description: convertToOptionalChainExpressionMessage,
            kind: "refactor.rewrite.expression.optionalChain"
          };
          refactor2.registerRefactor(refactorName, {
            kinds: [toOptionalChainAction.kind],
            getAvailableActions,
            getEditsForAction
          });
          function getAvailableActions(context) {
            var info = getInfo(context, context.triggerReason === "invoked");
            if (!info)
              return ts3.emptyArray;
            if (!refactor2.isRefactorErrorInfo(info)) {
              return [{
                name: refactorName,
                description: convertToOptionalChainExpressionMessage,
                actions: [toOptionalChainAction]
              }];
            }
            if (context.preferences.provideRefactorNotApplicableReason) {
              return [{
                name: refactorName,
                description: convertToOptionalChainExpressionMessage,
                actions: [__assign(__assign({}, toOptionalChainAction), { notApplicableReason: info.error })]
              }];
            }
            return ts3.emptyArray;
          }
          function getEditsForAction(context, actionName) {
            var info = getInfo(context);
            ts3.Debug.assert(info && !refactor2.isRefactorErrorInfo(info), "Expected applicable refactor info");
            var edits = ts3.textChanges.ChangeTracker.with(context, function(t2) {
              return doChange(context.file, context.program.getTypeChecker(), t2, info, actionName);
            });
            return { edits, renameFilename: void 0, renameLocation: void 0 };
          }
          ;
          function isValidExpression(node) {
            return ts3.isBinaryExpression(node) || ts3.isConditionalExpression(node);
          }
          function isValidStatement(node) {
            return ts3.isExpressionStatement(node) || ts3.isReturnStatement(node) || ts3.isVariableStatement(node);
          }
          function isValidExpressionOrStatement(node) {
            return isValidExpression(node) || isValidStatement(node);
          }
          function getInfo(context, considerEmptySpans) {
            if (considerEmptySpans === void 0) {
              considerEmptySpans = true;
            }
            var file = context.file, program2 = context.program;
            var span = ts3.getRefactorContextSpan(context);
            var forEmptySpan = span.length === 0;
            if (forEmptySpan && !considerEmptySpans)
              return void 0;
            var startToken = ts3.getTokenAtPosition(file, span.start);
            var endToken = ts3.findTokenOnLeftOfPosition(file, span.start + span.length);
            var adjustedSpan = ts3.createTextSpanFromBounds(startToken.pos, endToken && endToken.end >= startToken.pos ? endToken.getEnd() : startToken.getEnd());
            var parent = forEmptySpan ? getValidParentNodeOfEmptySpan(startToken) : getValidParentNodeContainingSpan(startToken, adjustedSpan);
            var expression = parent && isValidExpressionOrStatement(parent) ? getExpression(parent) : void 0;
            if (!expression)
              return { error: ts3.getLocaleSpecificMessage(ts3.Diagnostics.Could_not_find_convertible_access_expression) };
            var checker = program2.getTypeChecker();
            return ts3.isConditionalExpression(expression) ? getConditionalInfo(expression, checker) : getBinaryInfo(expression);
          }
          function getConditionalInfo(expression, checker) {
            var condition = expression.condition;
            var finalExpression = getFinalExpressionInChain(expression.whenTrue);
            if (!finalExpression || checker.isNullableType(checker.getTypeAtLocation(finalExpression))) {
              return { error: ts3.getLocaleSpecificMessage(ts3.Diagnostics.Could_not_find_convertible_access_expression) };
            }
            if ((ts3.isPropertyAccessExpression(condition) || ts3.isIdentifier(condition)) && getMatchingStart(condition, finalExpression.expression)) {
              return { finalExpression, occurrences: [condition], expression };
            } else if (ts3.isBinaryExpression(condition)) {
              var occurrences = getOccurrencesInExpression(finalExpression.expression, condition);
              return occurrences ? { finalExpression, occurrences, expression } : { error: ts3.getLocaleSpecificMessage(ts3.Diagnostics.Could_not_find_matching_access_expressions) };
            }
          }
          function getBinaryInfo(expression) {
            if (expression.operatorToken.kind !== 55) {
              return { error: ts3.getLocaleSpecificMessage(ts3.Diagnostics.Can_only_convert_logical_AND_access_chains) };
            }
            ;
            var finalExpression = getFinalExpressionInChain(expression.right);
            if (!finalExpression)
              return { error: ts3.getLocaleSpecificMessage(ts3.Diagnostics.Could_not_find_convertible_access_expression) };
            var occurrences = getOccurrencesInExpression(finalExpression.expression, expression.left);
            return occurrences ? { finalExpression, occurrences, expression } : { error: ts3.getLocaleSpecificMessage(ts3.Diagnostics.Could_not_find_matching_access_expressions) };
          }
          function getOccurrencesInExpression(matchTo, expression) {
            var occurrences = [];
            while (ts3.isBinaryExpression(expression) && expression.operatorToken.kind === 55) {
              var match = getMatchingStart(ts3.skipParentheses(matchTo), ts3.skipParentheses(expression.right));
              if (!match) {
                break;
              }
              occurrences.push(match);
              matchTo = match;
              expression = expression.left;
            }
            var finalMatch = getMatchingStart(matchTo, expression);
            if (finalMatch) {
              occurrences.push(finalMatch);
            }
            return occurrences.length > 0 ? occurrences : void 0;
          }
          function getMatchingStart(chain, subchain) {
            if (!ts3.isIdentifier(subchain) && !ts3.isPropertyAccessExpression(subchain) && !ts3.isElementAccessExpression(subchain)) {
              return void 0;
            }
            return chainStartsWith(chain, subchain) ? subchain : void 0;
          }
          function chainStartsWith(chain, subchain) {
            while (ts3.isCallExpression(chain) || ts3.isPropertyAccessExpression(chain) || ts3.isElementAccessExpression(chain)) {
              if (getTextOfChainNode(chain) === getTextOfChainNode(subchain))
                break;
              chain = chain.expression;
            }
            while (ts3.isPropertyAccessExpression(chain) && ts3.isPropertyAccessExpression(subchain) || ts3.isElementAccessExpression(chain) && ts3.isElementAccessExpression(subchain)) {
              if (getTextOfChainNode(chain) !== getTextOfChainNode(subchain))
                return false;
              chain = chain.expression;
              subchain = subchain.expression;
            }
            return ts3.isIdentifier(chain) && ts3.isIdentifier(subchain) && chain.getText() === subchain.getText();
          }
          function getTextOfChainNode(node) {
            if (ts3.isIdentifier(node) || ts3.isStringOrNumericLiteralLike(node)) {
              return node.getText();
            }
            if (ts3.isPropertyAccessExpression(node)) {
              return getTextOfChainNode(node.name);
            }
            if (ts3.isElementAccessExpression(node)) {
              return getTextOfChainNode(node.argumentExpression);
            }
            return void 0;
          }
          function getValidParentNodeContainingSpan(node, span) {
            while (node.parent) {
              if (isValidExpressionOrStatement(node) && span.length !== 0 && node.end >= span.start + span.length) {
                return node;
              }
              node = node.parent;
            }
            return void 0;
          }
          function getValidParentNodeOfEmptySpan(node) {
            while (node.parent) {
              if (isValidExpressionOrStatement(node) && !isValidExpressionOrStatement(node.parent)) {
                return node;
              }
              node = node.parent;
            }
            return void 0;
          }
          function getExpression(node) {
            if (isValidExpression(node)) {
              return node;
            }
            if (ts3.isVariableStatement(node)) {
              var variable = ts3.getSingleVariableOfVariableStatement(node);
              var initializer = variable === null || variable === void 0 ? void 0 : variable.initializer;
              return initializer && isValidExpression(initializer) ? initializer : void 0;
            }
            return node.expression && isValidExpression(node.expression) ? node.expression : void 0;
          }
          function getFinalExpressionInChain(node) {
            node = ts3.skipParentheses(node);
            if (ts3.isBinaryExpression(node)) {
              return getFinalExpressionInChain(node.left);
            } else if ((ts3.isPropertyAccessExpression(node) || ts3.isElementAccessExpression(node) || ts3.isCallExpression(node)) && !ts3.isOptionalChain(node)) {
              return node;
            }
            return void 0;
          }
          function convertOccurrences(checker, toConvert, occurrences) {
            if (ts3.isPropertyAccessExpression(toConvert) || ts3.isElementAccessExpression(toConvert) || ts3.isCallExpression(toConvert)) {
              var chain = convertOccurrences(checker, toConvert.expression, occurrences);
              var lastOccurrence = occurrences.length > 0 ? occurrences[occurrences.length - 1] : void 0;
              var isOccurrence = (lastOccurrence === null || lastOccurrence === void 0 ? void 0 : lastOccurrence.getText()) === toConvert.expression.getText();
              if (isOccurrence)
                occurrences.pop();
              if (ts3.isCallExpression(toConvert)) {
                return isOccurrence ? ts3.factory.createCallChain(chain, ts3.factory.createToken(28), toConvert.typeArguments, toConvert.arguments) : ts3.factory.createCallChain(chain, toConvert.questionDotToken, toConvert.typeArguments, toConvert.arguments);
              } else if (ts3.isPropertyAccessExpression(toConvert)) {
                return isOccurrence ? ts3.factory.createPropertyAccessChain(chain, ts3.factory.createToken(28), toConvert.name) : ts3.factory.createPropertyAccessChain(chain, toConvert.questionDotToken, toConvert.name);
              } else if (ts3.isElementAccessExpression(toConvert)) {
                return isOccurrence ? ts3.factory.createElementAccessChain(chain, ts3.factory.createToken(28), toConvert.argumentExpression) : ts3.factory.createElementAccessChain(chain, toConvert.questionDotToken, toConvert.argumentExpression);
              }
            }
            return toConvert;
          }
          function doChange(sourceFile, checker, changes, info, _actionName) {
            var finalExpression = info.finalExpression, occurrences = info.occurrences, expression = info.expression;
            var firstOccurrence = occurrences[occurrences.length - 1];
            var convertedChain = convertOccurrences(checker, finalExpression, occurrences);
            if (convertedChain && (ts3.isPropertyAccessExpression(convertedChain) || ts3.isElementAccessExpression(convertedChain) || ts3.isCallExpression(convertedChain))) {
              if (ts3.isBinaryExpression(expression)) {
                changes.replaceNodeRange(sourceFile, firstOccurrence, finalExpression, convertedChain);
              } else if (ts3.isConditionalExpression(expression)) {
                changes.replaceNode(sourceFile, expression, ts3.factory.createBinaryExpression(convertedChain, ts3.factory.createToken(60), expression.whenFalse));
              }
            }
          }
        })(convertToOptionalChainExpression = refactor2.convertToOptionalChainExpression || (refactor2.convertToOptionalChainExpression = {}));
      })(refactor = ts3.refactor || (ts3.refactor = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var refactor;
      (function(refactor2) {
        var addOrRemoveBracesToArrowFunction;
        (function(addOrRemoveBracesToArrowFunction2) {
          var refactorName = "Convert overload list to single signature";
          var refactorDescription = ts3.Diagnostics.Convert_overload_list_to_single_signature.message;
          var functionOverloadAction = {
            name: refactorName,
            description: refactorDescription,
            kind: "refactor.rewrite.function.overloadList"
          };
          refactor2.registerRefactor(refactorName, {
            kinds: [functionOverloadAction.kind],
            getEditsForAction,
            getAvailableActions
          });
          function getAvailableActions(context) {
            var file = context.file, startPosition = context.startPosition, program2 = context.program;
            var info = getConvertableOverloadListAtPosition(file, startPosition, program2);
            if (!info)
              return ts3.emptyArray;
            return [{
              name: refactorName,
              description: refactorDescription,
              actions: [functionOverloadAction]
            }];
          }
          function getEditsForAction(context) {
            var file = context.file, startPosition = context.startPosition, program2 = context.program;
            var signatureDecls = getConvertableOverloadListAtPosition(file, startPosition, program2);
            if (!signatureDecls)
              return void 0;
            var checker = program2.getTypeChecker();
            var lastDeclaration = signatureDecls[signatureDecls.length - 1];
            var updated = lastDeclaration;
            switch (lastDeclaration.kind) {
              case 165: {
                updated = ts3.factory.updateMethodSignature(lastDeclaration, lastDeclaration.modifiers, lastDeclaration.name, lastDeclaration.questionToken, lastDeclaration.typeParameters, getNewParametersForCombinedSignature(signatureDecls), lastDeclaration.type);
                break;
              }
              case 166: {
                updated = ts3.factory.updateMethodDeclaration(lastDeclaration, lastDeclaration.decorators, lastDeclaration.modifiers, lastDeclaration.asteriskToken, lastDeclaration.name, lastDeclaration.questionToken, lastDeclaration.typeParameters, getNewParametersForCombinedSignature(signatureDecls), lastDeclaration.type, lastDeclaration.body);
                break;
              }
              case 170: {
                updated = ts3.factory.updateCallSignature(lastDeclaration, lastDeclaration.typeParameters, getNewParametersForCombinedSignature(signatureDecls), lastDeclaration.type);
                break;
              }
              case 167: {
                updated = ts3.factory.updateConstructorDeclaration(lastDeclaration, lastDeclaration.decorators, lastDeclaration.modifiers, getNewParametersForCombinedSignature(signatureDecls), lastDeclaration.body);
                break;
              }
              case 171: {
                updated = ts3.factory.updateConstructSignature(lastDeclaration, lastDeclaration.typeParameters, getNewParametersForCombinedSignature(signatureDecls), lastDeclaration.type);
                break;
              }
              case 252: {
                updated = ts3.factory.updateFunctionDeclaration(lastDeclaration, lastDeclaration.decorators, lastDeclaration.modifiers, lastDeclaration.asteriskToken, lastDeclaration.name, lastDeclaration.typeParameters, getNewParametersForCombinedSignature(signatureDecls), lastDeclaration.type, lastDeclaration.body);
                break;
              }
              default:
                return ts3.Debug.failBadSyntaxKind(lastDeclaration, "Unhandled signature kind in overload list conversion refactoring");
            }
            if (updated === lastDeclaration) {
              return;
            }
            var edits = ts3.textChanges.ChangeTracker.with(context, function(t2) {
              t2.replaceNodeRange(file, signatureDecls[0], signatureDecls[signatureDecls.length - 1], updated);
            });
            return { renameFilename: void 0, renameLocation: void 0, edits };
            function getNewParametersForCombinedSignature(signatureDeclarations) {
              var lastSig = signatureDeclarations[signatureDeclarations.length - 1];
              if (ts3.isFunctionLikeDeclaration(lastSig) && lastSig.body) {
                signatureDeclarations = signatureDeclarations.slice(0, signatureDeclarations.length - 1);
              }
              return ts3.factory.createNodeArray([
                ts3.factory.createParameterDeclaration(void 0, void 0, ts3.factory.createToken(25), "args", void 0, ts3.factory.createUnionTypeNode(ts3.map(signatureDeclarations, convertSignatureParametersToTuple)))
              ]);
            }
            function convertSignatureParametersToTuple(decl) {
              var members = ts3.map(decl.parameters, convertParameterToNamedTupleMember);
              return ts3.setEmitFlags(ts3.factory.createTupleTypeNode(members), ts3.some(members, function(m) {
                return !!ts3.length(ts3.getSyntheticLeadingComments(m));
              }) ? 0 : 1);
            }
            function convertParameterToNamedTupleMember(p) {
              ts3.Debug.assert(ts3.isIdentifier(p.name));
              var result2 = ts3.setTextRange(ts3.factory.createNamedTupleMember(p.dotDotDotToken, p.name, p.questionToken, p.type || ts3.factory.createKeywordTypeNode(128)), p);
              var parameterDocComment = p.symbol && p.symbol.getDocumentationComment(checker);
              if (parameterDocComment) {
                var newComment = ts3.displayPartsToString(parameterDocComment);
                if (newComment.length) {
                  ts3.setSyntheticLeadingComments(result2, [{
                    text: "*\n" + newComment.split("\n").map(function(c2) {
                      return " * " + c2;
                    }).join("\n") + "\n ",
                    kind: 3,
                    pos: -1,
                    end: -1,
                    hasTrailingNewLine: true,
                    hasLeadingNewline: true
                  }]);
                }
              }
              return result2;
            }
          }
          function isConvertableSignatureDeclaration(d) {
            switch (d.kind) {
              case 165:
              case 166:
              case 170:
              case 167:
              case 171:
              case 252:
                return true;
            }
            return false;
          }
          function getConvertableOverloadListAtPosition(file, startPosition, program2) {
            var node = ts3.getTokenAtPosition(file, startPosition);
            var containingDecl = ts3.findAncestor(node, isConvertableSignatureDeclaration);
            if (!containingDecl) {
              return;
            }
            var checker = program2.getTypeChecker();
            var signatureSymbol = containingDecl.symbol;
            if (!signatureSymbol) {
              return;
            }
            var decls = signatureSymbol.declarations;
            if (ts3.length(decls) <= 1) {
              return;
            }
            if (!ts3.every(decls, function(d) {
              return ts3.getSourceFileOfNode(d) === file;
            })) {
              return;
            }
            if (!isConvertableSignatureDeclaration(decls[0])) {
              return;
            }
            var kindOne = decls[0].kind;
            if (!ts3.every(decls, function(d) {
              return d.kind === kindOne;
            })) {
              return;
            }
            var signatureDecls = decls;
            if (ts3.some(signatureDecls, function(d) {
              return !!d.typeParameters || ts3.some(d.parameters, function(p) {
                return !!p.decorators || !!p.modifiers || !ts3.isIdentifier(p.name);
              });
            })) {
              return;
            }
            var signatures = ts3.mapDefined(signatureDecls, function(d) {
              return checker.getSignatureFromDeclaration(d);
            });
            if (ts3.length(signatures) !== ts3.length(decls)) {
              return;
            }
            var returnOne = checker.getReturnTypeOfSignature(signatures[0]);
            if (!ts3.every(signatures, function(s2) {
              return checker.getReturnTypeOfSignature(s2) === returnOne;
            })) {
              return;
            }
            return signatureDecls;
          }
        })(addOrRemoveBracesToArrowFunction = refactor2.addOrRemoveBracesToArrowFunction || (refactor2.addOrRemoveBracesToArrowFunction = {}));
      })(refactor = ts3.refactor || (ts3.refactor = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var refactor;
      (function(refactor2) {
        var extractSymbol;
        (function(extractSymbol2) {
          var refactorName = "Extract Symbol";
          var extractConstantAction = {
            name: "Extract Constant",
            description: ts3.getLocaleSpecificMessage(ts3.Diagnostics.Extract_constant),
            kind: "refactor.extract.constant"
          };
          var extractFunctionAction = {
            name: "Extract Function",
            description: ts3.getLocaleSpecificMessage(ts3.Diagnostics.Extract_function),
            kind: "refactor.extract.function"
          };
          refactor2.registerRefactor(refactorName, {
            kinds: [
              extractConstantAction.kind,
              extractFunctionAction.kind
            ],
            getAvailableActions,
            getEditsForAction
          });
          function getAvailableActions(context) {
            var requestedRefactor = context.kind;
            var rangeToExtract = getRangeToExtract(context.file, ts3.getRefactorContextSpan(context), context.triggerReason === "invoked");
            var targetRange = rangeToExtract.targetRange;
            if (targetRange === void 0) {
              if (!rangeToExtract.errors || rangeToExtract.errors.length === 0 || !context.preferences.provideRefactorNotApplicableReason) {
                return ts3.emptyArray;
              }
              var errors = [];
              if (refactor2.refactorKindBeginsWith(extractFunctionAction.kind, requestedRefactor)) {
                errors.push({
                  name: refactorName,
                  description: extractFunctionAction.description,
                  actions: [__assign(__assign({}, extractFunctionAction), { notApplicableReason: getStringError(rangeToExtract.errors) })]
                });
              }
              if (refactor2.refactorKindBeginsWith(extractConstantAction.kind, requestedRefactor)) {
                errors.push({
                  name: refactorName,
                  description: extractConstantAction.description,
                  actions: [__assign(__assign({}, extractConstantAction), { notApplicableReason: getStringError(rangeToExtract.errors) })]
                });
              }
              return errors;
            }
            var extractions = getPossibleExtractions(targetRange, context);
            if (extractions === void 0) {
              return ts3.emptyArray;
            }
            var functionActions = [];
            var usedFunctionNames = new ts3.Map();
            var innermostErrorFunctionAction;
            var constantActions = [];
            var usedConstantNames = new ts3.Map();
            var innermostErrorConstantAction;
            var i3 = 0;
            for (var _i = 0, extractions_1 = extractions; _i < extractions_1.length; _i++) {
              var _a2 = extractions_1[_i], functionExtraction = _a2.functionExtraction, constantExtraction = _a2.constantExtraction;
              var description = functionExtraction.description;
              if (refactor2.refactorKindBeginsWith(extractFunctionAction.kind, requestedRefactor)) {
                if (functionExtraction.errors.length === 0) {
                  if (!usedFunctionNames.has(description)) {
                    usedFunctionNames.set(description, true);
                    functionActions.push({
                      description,
                      name: "function_scope_" + i3,
                      kind: extractFunctionAction.kind
                    });
                  }
                } else if (!innermostErrorFunctionAction) {
                  innermostErrorFunctionAction = {
                    description,
                    name: "function_scope_" + i3,
                    notApplicableReason: getStringError(functionExtraction.errors),
                    kind: extractFunctionAction.kind
                  };
                }
              }
              if (refactor2.refactorKindBeginsWith(extractConstantAction.kind, requestedRefactor)) {
                if (constantExtraction.errors.length === 0) {
                  var description_1 = constantExtraction.description;
                  if (!usedConstantNames.has(description_1)) {
                    usedConstantNames.set(description_1, true);
                    constantActions.push({
                      description: description_1,
                      name: "constant_scope_" + i3,
                      kind: extractConstantAction.kind
                    });
                  }
                } else if (!innermostErrorConstantAction) {
                  innermostErrorConstantAction = {
                    description,
                    name: "constant_scope_" + i3,
                    notApplicableReason: getStringError(constantExtraction.errors),
                    kind: extractConstantAction.kind
                  };
                }
              }
              i3++;
            }
            var infos = [];
            if (functionActions.length) {
              infos.push({
                name: refactorName,
                description: ts3.getLocaleSpecificMessage(ts3.Diagnostics.Extract_function),
                actions: functionActions
              });
            } else if (context.preferences.provideRefactorNotApplicableReason && innermostErrorFunctionAction) {
              infos.push({
                name: refactorName,
                description: ts3.getLocaleSpecificMessage(ts3.Diagnostics.Extract_function),
                actions: [innermostErrorFunctionAction]
              });
            }
            if (constantActions.length) {
              infos.push({
                name: refactorName,
                description: ts3.getLocaleSpecificMessage(ts3.Diagnostics.Extract_constant),
                actions: constantActions
              });
            } else if (context.preferences.provideRefactorNotApplicableReason && innermostErrorConstantAction) {
              infos.push({
                name: refactorName,
                description: ts3.getLocaleSpecificMessage(ts3.Diagnostics.Extract_constant),
                actions: [innermostErrorConstantAction]
              });
            }
            return infos.length ? infos : ts3.emptyArray;
            function getStringError(errors2) {
              var error = errors2[0].messageText;
              if (typeof error !== "string") {
                error = error.messageText;
              }
              return error;
            }
          }
          extractSymbol2.getAvailableActions = getAvailableActions;
          function getEditsForAction(context, actionName) {
            var rangeToExtract = getRangeToExtract(context.file, ts3.getRefactorContextSpan(context));
            var targetRange = rangeToExtract.targetRange;
            var parsedFunctionIndexMatch = /^function_scope_(\d+)$/.exec(actionName);
            if (parsedFunctionIndexMatch) {
              var index = +parsedFunctionIndexMatch[1];
              ts3.Debug.assert(isFinite(index), "Expected to parse a finite number from the function scope index");
              return getFunctionExtractionAtIndex(targetRange, context, index);
            }
            var parsedConstantIndexMatch = /^constant_scope_(\d+)$/.exec(actionName);
            if (parsedConstantIndexMatch) {
              var index = +parsedConstantIndexMatch[1];
              ts3.Debug.assert(isFinite(index), "Expected to parse a finite number from the constant scope index");
              return getConstantExtractionAtIndex(targetRange, context, index);
            }
            ts3.Debug.fail("Unrecognized action name");
          }
          extractSymbol2.getEditsForAction = getEditsForAction;
          var Messages;
          (function(Messages2) {
            function createMessage(message) {
              return { message, code: 0, category: ts3.DiagnosticCategory.Message, key: message };
            }
            Messages2.cannotExtractRange = createMessage("Cannot extract range.");
            Messages2.cannotExtractImport = createMessage("Cannot extract import statement.");
            Messages2.cannotExtractSuper = createMessage("Cannot extract super call.");
            Messages2.cannotExtractJSDoc = createMessage("Cannot extract JSDoc.");
            Messages2.cannotExtractEmpty = createMessage("Cannot extract empty range.");
            Messages2.expressionExpected = createMessage("expression expected.");
            Messages2.uselessConstantType = createMessage("No reason to extract constant of type.");
            Messages2.statementOrExpressionExpected = createMessage("Statement or expression expected.");
            Messages2.cannotExtractRangeContainingConditionalBreakOrContinueStatements = createMessage("Cannot extract range containing conditional break or continue statements.");
            Messages2.cannotExtractRangeContainingConditionalReturnStatement = createMessage("Cannot extract range containing conditional return statement.");
            Messages2.cannotExtractRangeContainingLabeledBreakOrContinueStatementWithTargetOutsideOfTheRange = createMessage("Cannot extract range containing labeled break or continue with target outside of the range.");
            Messages2.cannotExtractRangeThatContainsWritesToReferencesLocatedOutsideOfTheTargetRangeInGenerators = createMessage("Cannot extract range containing writes to references located outside of the target range in generators.");
            Messages2.typeWillNotBeVisibleInTheNewScope = createMessage("Type will not visible in the new scope.");
            Messages2.functionWillNotBeVisibleInTheNewScope = createMessage("Function will not visible in the new scope.");
            Messages2.cannotExtractIdentifier = createMessage("Select more than a single identifier.");
            Messages2.cannotExtractExportedEntity = createMessage("Cannot extract exported declaration");
            Messages2.cannotWriteInExpression = createMessage("Cannot write back side-effects when extracting an expression");
            Messages2.cannotExtractReadonlyPropertyInitializerOutsideConstructor = createMessage("Cannot move initialization of read-only class property outside of the constructor");
            Messages2.cannotExtractAmbientBlock = createMessage("Cannot extract code from ambient contexts");
            Messages2.cannotAccessVariablesFromNestedScopes = createMessage("Cannot access variables from nested scopes");
            Messages2.cannotExtractToOtherFunctionLike = createMessage("Cannot extract method to a function-like scope that is not a function");
            Messages2.cannotExtractToJSClass = createMessage("Cannot extract constant to a class scope in JS");
            Messages2.cannotExtractToExpressionArrowFunction = createMessage("Cannot extract constant to an arrow function without a block");
          })(Messages = extractSymbol2.Messages || (extractSymbol2.Messages = {}));
          var RangeFacts;
          (function(RangeFacts2) {
            RangeFacts2[RangeFacts2["None"] = 0] = "None";
            RangeFacts2[RangeFacts2["HasReturn"] = 1] = "HasReturn";
            RangeFacts2[RangeFacts2["IsGenerator"] = 2] = "IsGenerator";
            RangeFacts2[RangeFacts2["IsAsyncFunction"] = 4] = "IsAsyncFunction";
            RangeFacts2[RangeFacts2["UsesThis"] = 8] = "UsesThis";
            RangeFacts2[RangeFacts2["InStaticRegion"] = 16] = "InStaticRegion";
          })(RangeFacts || (RangeFacts = {}));
          function getRangeToExtract(sourceFile, span, invoked) {
            if (invoked === void 0) {
              invoked = true;
            }
            var length = span.length;
            if (length === 0 && !invoked) {
              return { errors: [ts3.createFileDiagnostic(sourceFile, span.start, length, Messages.cannotExtractEmpty)] };
            }
            var cursorRequest = length === 0 && invoked;
            var startToken = ts3.findFirstNonJsxWhitespaceToken(sourceFile, span.start);
            var endToken = ts3.findTokenOnLeftOfPosition(sourceFile, ts3.textSpanEnd(span));
            var adjustedSpan = startToken && endToken && invoked ? getAdjustedSpanFromNodes(startToken, endToken, sourceFile) : span;
            var start = cursorRequest ? getExtractableParent(startToken) : ts3.getParentNodeInSpan(startToken, sourceFile, adjustedSpan);
            var end = cursorRequest ? start : ts3.getParentNodeInSpan(endToken, sourceFile, adjustedSpan);
            var declarations = [];
            var rangeFacts = RangeFacts.None;
            if (!start || !end) {
              return { errors: [ts3.createFileDiagnostic(sourceFile, span.start, length, Messages.cannotExtractRange)] };
            }
            if (ts3.isJSDoc(start)) {
              return { errors: [ts3.createFileDiagnostic(sourceFile, span.start, length, Messages.cannotExtractJSDoc)] };
            }
            if (start.parent !== end.parent) {
              return { errors: [ts3.createFileDiagnostic(sourceFile, span.start, length, Messages.cannotExtractRange)] };
            }
            if (start !== end) {
              if (!isBlockLike(start.parent)) {
                return { errors: [ts3.createFileDiagnostic(sourceFile, span.start, length, Messages.cannotExtractRange)] };
              }
              var statements = [];
              var start2 = start;
              for (var _i = 0, _a2 = start2.parent.statements; _i < _a2.length; _i++) {
                var statement = _a2[_i];
                if (statement === start || statements.length) {
                  var errors_1 = checkNode(statement);
                  if (errors_1) {
                    return { errors: errors_1 };
                  }
                  statements.push(statement);
                }
                if (statement === end) {
                  break;
                }
              }
              if (!statements.length) {
                return { errors: [ts3.createFileDiagnostic(sourceFile, span.start, length, Messages.cannotExtractRange)] };
              }
              return { targetRange: { range: statements, facts: rangeFacts, declarations } };
            }
            if (ts3.isReturnStatement(start) && !start.expression) {
              return { errors: [ts3.createFileDiagnostic(sourceFile, span.start, length, Messages.cannotExtractRange)] };
            }
            var node = refineNode(start);
            var errors = checkRootNode(node) || checkNode(node);
            if (errors) {
              return { errors };
            }
            return { targetRange: { range: getStatementOrExpressionRange(node), facts: rangeFacts, declarations } };
            function refineNode(node2) {
              if (ts3.isReturnStatement(node2)) {
                if (node2.expression) {
                  return node2.expression;
                }
              } else if (ts3.isVariableStatement(node2)) {
                var numInitializers = 0;
                var lastInitializer = void 0;
                for (var _i2 = 0, _a3 = node2.declarationList.declarations; _i2 < _a3.length; _i2++) {
                  var declaration = _a3[_i2];
                  if (declaration.initializer) {
                    numInitializers++;
                    lastInitializer = declaration.initializer;
                  }
                }
                if (numInitializers === 1) {
                  return lastInitializer;
                }
              } else if (ts3.isVariableDeclaration(node2)) {
                if (node2.initializer) {
                  return node2.initializer;
                }
              }
              return node2;
            }
            function checkRootNode(node2) {
              if (ts3.isIdentifier(ts3.isExpressionStatement(node2) ? node2.expression : node2)) {
                return [ts3.createDiagnosticForNode(node2, Messages.cannotExtractIdentifier)];
              }
              return void 0;
            }
            function checkForStaticContext(nodeToCheck, containingClass) {
              var current = nodeToCheck;
              while (current !== containingClass) {
                if (current.kind === 164) {
                  if (ts3.hasSyntacticModifier(current, 32)) {
                    rangeFacts |= RangeFacts.InStaticRegion;
                  }
                  break;
                } else if (current.kind === 161) {
                  var ctorOrMethod = ts3.getContainingFunction(current);
                  if (ctorOrMethod.kind === 167) {
                    rangeFacts |= RangeFacts.InStaticRegion;
                  }
                  break;
                } else if (current.kind === 166) {
                  if (ts3.hasSyntacticModifier(current, 32)) {
                    rangeFacts |= RangeFacts.InStaticRegion;
                  }
                }
                current = current.parent;
              }
            }
            function checkNode(nodeToCheck) {
              var PermittedJumps;
              (function(PermittedJumps2) {
                PermittedJumps2[PermittedJumps2["None"] = 0] = "None";
                PermittedJumps2[PermittedJumps2["Break"] = 1] = "Break";
                PermittedJumps2[PermittedJumps2["Continue"] = 2] = "Continue";
                PermittedJumps2[PermittedJumps2["Return"] = 4] = "Return";
              })(PermittedJumps || (PermittedJumps = {}));
              ts3.Debug.assert(nodeToCheck.pos <= nodeToCheck.end, "This failure could trigger https://github.com/Microsoft/TypeScript/issues/20809 (1)");
              ts3.Debug.assert(!ts3.positionIsSynthesized(nodeToCheck.pos), "This failure could trigger https://github.com/Microsoft/TypeScript/issues/20809 (2)");
              if (!ts3.isStatement(nodeToCheck) && !(ts3.isExpressionNode(nodeToCheck) && isExtractableExpression(nodeToCheck))) {
                return [ts3.createDiagnosticForNode(nodeToCheck, Messages.statementOrExpressionExpected)];
              }
              if (nodeToCheck.flags & 8388608) {
                return [ts3.createDiagnosticForNode(nodeToCheck, Messages.cannotExtractAmbientBlock)];
              }
              var containingClass = ts3.getContainingClass(nodeToCheck);
              if (containingClass) {
                checkForStaticContext(nodeToCheck, containingClass);
              }
              var errors2;
              var permittedJumps = 4;
              var seenLabels;
              visit(nodeToCheck);
              return errors2;
              function visit(node2) {
                if (errors2) {
                  return true;
                }
                if (ts3.isDeclaration(node2)) {
                  var declaringNode = node2.kind === 250 ? node2.parent.parent : node2;
                  if (ts3.hasSyntacticModifier(declaringNode, 1)) {
                    (errors2 || (errors2 = [])).push(ts3.createDiagnosticForNode(node2, Messages.cannotExtractExportedEntity));
                    return true;
                  }
                  declarations.push(node2.symbol);
                }
                switch (node2.kind) {
                  case 262:
                    (errors2 || (errors2 = [])).push(ts3.createDiagnosticForNode(node2, Messages.cannotExtractImport));
                    return true;
                  case 267:
                    (errors2 || (errors2 = [])).push(ts3.createDiagnosticForNode(node2, Messages.cannotExtractExportedEntity));
                    return true;
                  case 105:
                    if (node2.parent.kind === 204) {
                      var containingClass_1 = ts3.getContainingClass(node2);
                      if (containingClass_1.pos < span.start || containingClass_1.end >= span.start + span.length) {
                        (errors2 || (errors2 = [])).push(ts3.createDiagnosticForNode(node2, Messages.cannotExtractSuper));
                        return true;
                      }
                    } else {
                      rangeFacts |= RangeFacts.UsesThis;
                    }
                    break;
                  case 210:
                    ts3.forEachChild(node2, function check(n2) {
                      if (ts3.isThis(n2)) {
                        rangeFacts |= RangeFacts.UsesThis;
                      } else if (ts3.isClassLike(n2) || ts3.isFunctionLike(n2) && !ts3.isArrowFunction(n2)) {
                        return false;
                      } else {
                        ts3.forEachChild(n2, check);
                      }
                    });
                  case 253:
                  case 252:
                    if (ts3.isSourceFile(node2.parent) && node2.parent.externalModuleIndicator === void 0) {
                      (errors2 || (errors2 = [])).push(ts3.createDiagnosticForNode(node2, Messages.functionWillNotBeVisibleInTheNewScope));
                    }
                  case 222:
                  case 209:
                  case 166:
                  case 167:
                  case 168:
                  case 169:
                    return false;
                }
                var savedPermittedJumps = permittedJumps;
                switch (node2.kind) {
                  case 235:
                    permittedJumps = 0;
                    break;
                  case 248:
                    permittedJumps = 0;
                    break;
                  case 231:
                    if (node2.parent && node2.parent.kind === 248 && node2.parent.finallyBlock === node2) {
                      permittedJumps = 4;
                    }
                    break;
                  case 286:
                  case 285:
                    permittedJumps |= 1;
                    break;
                  default:
                    if (ts3.isIterationStatement(node2, false)) {
                      permittedJumps |= 1 | 2;
                    }
                    break;
                }
                switch (node2.kind) {
                  case 188:
                  case 107:
                    rangeFacts |= RangeFacts.UsesThis;
                    break;
                  case 246: {
                    var label = node2.label;
                    (seenLabels || (seenLabels = [])).push(label.escapedText);
                    ts3.forEachChild(node2, visit);
                    seenLabels.pop();
                    break;
                  }
                  case 242:
                  case 241: {
                    var label = node2.label;
                    if (label) {
                      if (!ts3.contains(seenLabels, label.escapedText)) {
                        (errors2 || (errors2 = [])).push(ts3.createDiagnosticForNode(node2, Messages.cannotExtractRangeContainingLabeledBreakOrContinueStatementWithTargetOutsideOfTheRange));
                      }
                    } else {
                      if (!(permittedJumps & (node2.kind === 242 ? 1 : 2))) {
                        (errors2 || (errors2 = [])).push(ts3.createDiagnosticForNode(node2, Messages.cannotExtractRangeContainingConditionalBreakOrContinueStatements));
                      }
                    }
                    break;
                  }
                  case 214:
                    rangeFacts |= RangeFacts.IsAsyncFunction;
                    break;
                  case 220:
                    rangeFacts |= RangeFacts.IsGenerator;
                    break;
                  case 243:
                    if (permittedJumps & 4) {
                      rangeFacts |= RangeFacts.HasReturn;
                    } else {
                      (errors2 || (errors2 = [])).push(ts3.createDiagnosticForNode(node2, Messages.cannotExtractRangeContainingConditionalReturnStatement));
                    }
                    break;
                  default:
                    ts3.forEachChild(node2, visit);
                    break;
                }
                permittedJumps = savedPermittedJumps;
              }
            }
          }
          extractSymbol2.getRangeToExtract = getRangeToExtract;
          function getAdjustedSpanFromNodes(startNode, endNode, sourceFile) {
            var start = startNode.getStart(sourceFile);
            var end = endNode.getEnd();
            if (sourceFile.text.charCodeAt(end) === 59) {
              end++;
            }
            return { start, length: end - start };
          }
          function getStatementOrExpressionRange(node) {
            if (ts3.isStatement(node)) {
              return [node];
            } else if (ts3.isExpressionNode(node)) {
              return ts3.isExpressionStatement(node.parent) ? [node.parent] : node;
            }
            return void 0;
          }
          function isScope(node) {
            return ts3.isFunctionLikeDeclaration(node) || ts3.isSourceFile(node) || ts3.isModuleBlock(node) || ts3.isClassLike(node);
          }
          function collectEnclosingScopes(range) {
            var current = isReadonlyArray(range.range) ? ts3.first(range.range) : range.range;
            if (range.facts & RangeFacts.UsesThis) {
              var containingClass = ts3.getContainingClass(current);
              if (containingClass) {
                var containingFunction = ts3.findAncestor(current, ts3.isFunctionLikeDeclaration);
                return containingFunction ? [containingFunction, containingClass] : [containingClass];
              }
            }
            var scopes = [];
            while (true) {
              current = current.parent;
              if (current.kind === 161) {
                current = ts3.findAncestor(current, function(parent) {
                  return ts3.isFunctionLikeDeclaration(parent);
                }).parent;
              }
              if (isScope(current)) {
                scopes.push(current);
                if (current.kind === 298) {
                  return scopes;
                }
              }
            }
          }
          function getFunctionExtractionAtIndex(targetRange, context, requestedChangesIndex) {
            var _a2 = getPossibleExtractionsWorker(targetRange, context), scopes = _a2.scopes, _b = _a2.readsAndWrites, target = _b.target, usagesPerScope = _b.usagesPerScope, functionErrorsPerScope = _b.functionErrorsPerScope, exposedVariableDeclarations = _b.exposedVariableDeclarations;
            ts3.Debug.assert(!functionErrorsPerScope[requestedChangesIndex].length, "The extraction went missing? How?");
            context.cancellationToken.throwIfCancellationRequested();
            return extractFunctionInScope(target, scopes[requestedChangesIndex], usagesPerScope[requestedChangesIndex], exposedVariableDeclarations, targetRange, context);
          }
          function getConstantExtractionAtIndex(targetRange, context, requestedChangesIndex) {
            var _a2 = getPossibleExtractionsWorker(targetRange, context), scopes = _a2.scopes, _b = _a2.readsAndWrites, target = _b.target, usagesPerScope = _b.usagesPerScope, constantErrorsPerScope = _b.constantErrorsPerScope, exposedVariableDeclarations = _b.exposedVariableDeclarations;
            ts3.Debug.assert(!constantErrorsPerScope[requestedChangesIndex].length, "The extraction went missing? How?");
            ts3.Debug.assert(exposedVariableDeclarations.length === 0, "Extract constant accepted a range containing a variable declaration?");
            context.cancellationToken.throwIfCancellationRequested();
            var expression = ts3.isExpression(target) ? target : target.statements[0].expression;
            return extractConstantInScope(expression, scopes[requestedChangesIndex], usagesPerScope[requestedChangesIndex], targetRange.facts, context);
          }
          function getPossibleExtractions(targetRange, context) {
            var _a2 = getPossibleExtractionsWorker(targetRange, context), scopes = _a2.scopes, _b = _a2.readsAndWrites, functionErrorsPerScope = _b.functionErrorsPerScope, constantErrorsPerScope = _b.constantErrorsPerScope;
            var extractions = scopes.map(function(scope, i3) {
              var functionDescriptionPart = getDescriptionForFunctionInScope(scope);
              var constantDescriptionPart = getDescriptionForConstantInScope(scope);
              var scopeDescription = ts3.isFunctionLikeDeclaration(scope) ? getDescriptionForFunctionLikeDeclaration(scope) : ts3.isClassLike(scope) ? getDescriptionForClassLikeDeclaration(scope) : getDescriptionForModuleLikeDeclaration(scope);
              var functionDescription;
              var constantDescription;
              if (scopeDescription === 1) {
                functionDescription = ts3.formatStringFromArgs(ts3.getLocaleSpecificMessage(ts3.Diagnostics.Extract_to_0_in_1_scope), [functionDescriptionPart, "global"]);
                constantDescription = ts3.formatStringFromArgs(ts3.getLocaleSpecificMessage(ts3.Diagnostics.Extract_to_0_in_1_scope), [constantDescriptionPart, "global"]);
              } else if (scopeDescription === 0) {
                functionDescription = ts3.formatStringFromArgs(ts3.getLocaleSpecificMessage(ts3.Diagnostics.Extract_to_0_in_1_scope), [functionDescriptionPart, "module"]);
                constantDescription = ts3.formatStringFromArgs(ts3.getLocaleSpecificMessage(ts3.Diagnostics.Extract_to_0_in_1_scope), [constantDescriptionPart, "module"]);
              } else {
                functionDescription = ts3.formatStringFromArgs(ts3.getLocaleSpecificMessage(ts3.Diagnostics.Extract_to_0_in_1), [functionDescriptionPart, scopeDescription]);
                constantDescription = ts3.formatStringFromArgs(ts3.getLocaleSpecificMessage(ts3.Diagnostics.Extract_to_0_in_1), [constantDescriptionPart, scopeDescription]);
              }
              if (i3 === 0 && !ts3.isClassLike(scope)) {
                constantDescription = ts3.formatStringFromArgs(ts3.getLocaleSpecificMessage(ts3.Diagnostics.Extract_to_0_in_enclosing_scope), [constantDescriptionPart]);
              }
              return {
                functionExtraction: {
                  description: functionDescription,
                  errors: functionErrorsPerScope[i3]
                },
                constantExtraction: {
                  description: constantDescription,
                  errors: constantErrorsPerScope[i3]
                }
              };
            });
            return extractions;
          }
          function getPossibleExtractionsWorker(targetRange, context) {
            var sourceFile = context.file;
            var scopes = collectEnclosingScopes(targetRange);
            var enclosingTextRange = getEnclosingTextRange(targetRange, sourceFile);
            var readsAndWrites = collectReadsAndWrites(targetRange, scopes, enclosingTextRange, sourceFile, context.program.getTypeChecker(), context.cancellationToken);
            return { scopes, readsAndWrites };
          }
          function getDescriptionForFunctionInScope(scope) {
            return ts3.isFunctionLikeDeclaration(scope) ? "inner function" : ts3.isClassLike(scope) ? "method" : "function";
          }
          function getDescriptionForConstantInScope(scope) {
            return ts3.isClassLike(scope) ? "readonly field" : "constant";
          }
          function getDescriptionForFunctionLikeDeclaration(scope) {
            switch (scope.kind) {
              case 167:
                return "constructor";
              case 209:
              case 252:
                return scope.name ? "function '" + scope.name.text + "'" : ts3.ANONYMOUS;
              case 210:
                return "arrow function";
              case 166:
                return "method '" + scope.name.getText() + "'";
              case 168:
                return "'get " + scope.name.getText() + "'";
              case 169:
                return "'set " + scope.name.getText() + "'";
              default:
                throw ts3.Debug.assertNever(scope, "Unexpected scope kind " + scope.kind);
            }
          }
          function getDescriptionForClassLikeDeclaration(scope) {
            return scope.kind === 253 ? scope.name ? "class '" + scope.name.text + "'" : "anonymous class declaration" : scope.name ? "class expression '" + scope.name.text + "'" : "anonymous class expression";
          }
          function getDescriptionForModuleLikeDeclaration(scope) {
            return scope.kind === 258 ? "namespace '" + scope.parent.name.getText() + "'" : scope.externalModuleIndicator ? 0 : 1;
          }
          var SpecialScope;
          (function(SpecialScope2) {
            SpecialScope2[SpecialScope2["Module"] = 0] = "Module";
            SpecialScope2[SpecialScope2["Global"] = 1] = "Global";
          })(SpecialScope || (SpecialScope = {}));
          function extractFunctionInScope(node, scope, _a2, exposedVariableDeclarations, range, context) {
            var usagesInScope = _a2.usages, typeParameterUsages = _a2.typeParameterUsages, substitutions = _a2.substitutions;
            var checker = context.program.getTypeChecker();
            var scriptTarget = ts3.getEmitScriptTarget(context.program.getCompilerOptions());
            var importAdder = ts3.codefix.createImportAdder(context.file, context.program, context.preferences, context.host);
            var file = scope.getSourceFile();
            var functionNameText = ts3.getUniqueName(ts3.isClassLike(scope) ? "newMethod" : "newFunction", file);
            var isJS = ts3.isInJSFile(scope);
            var functionName = ts3.factory.createIdentifier(functionNameText);
            var returnType2;
            var parameters = [];
            var callArguments = [];
            var writes;
            usagesInScope.forEach(function(usage, name) {
              var typeNode;
              if (!isJS) {
                var type3 = checker.getTypeOfSymbolAtLocation(usage.symbol, usage.node);
                type3 = checker.getBaseTypeOfLiteralType(type3);
                typeNode = ts3.codefix.typeToAutoImportableTypeNode(checker, importAdder, type3, scope, scriptTarget, 1);
              }
              var paramDecl = ts3.factory.createParameterDeclaration(void 0, void 0, void 0, name, void 0, typeNode);
              parameters.push(paramDecl);
              if (usage.usage === 2) {
                (writes || (writes = [])).push(usage);
              }
              callArguments.push(ts3.factory.createIdentifier(name));
            });
            var typeParametersAndDeclarations = ts3.arrayFrom(typeParameterUsages.values()).map(function(type3) {
              return { type: type3, declaration: getFirstDeclaration(type3) };
            });
            var sortedTypeParametersAndDeclarations = typeParametersAndDeclarations.sort(compareTypesByDeclarationOrder);
            var typeParameters = sortedTypeParametersAndDeclarations.length === 0 ? void 0 : sortedTypeParametersAndDeclarations.map(function(t2) {
              return t2.declaration;
            });
            var callTypeArguments = typeParameters !== void 0 ? typeParameters.map(function(decl) {
              return ts3.factory.createTypeReferenceNode(decl.name, void 0);
            }) : void 0;
            if (ts3.isExpression(node) && !isJS) {
              var contextualType = checker.getContextualType(node);
              returnType2 = checker.typeToTypeNode(contextualType, scope, 1);
            }
            var _b = transformFunctionBody(node, exposedVariableDeclarations, writes, substitutions, !!(range.facts & RangeFacts.HasReturn)), body = _b.body, returnValueProperty = _b.returnValueProperty;
            ts3.suppressLeadingAndTrailingTrivia(body);
            var newFunction;
            if (ts3.isClassLike(scope)) {
              var modifiers = isJS ? [] : [ts3.factory.createModifier(120)];
              if (range.facts & RangeFacts.InStaticRegion) {
                modifiers.push(ts3.factory.createModifier(123));
              }
              if (range.facts & RangeFacts.IsAsyncFunction) {
                modifiers.push(ts3.factory.createModifier(129));
              }
              newFunction = ts3.factory.createMethodDeclaration(void 0, modifiers.length ? modifiers : void 0, range.facts & RangeFacts.IsGenerator ? ts3.factory.createToken(41) : void 0, functionName, void 0, typeParameters, parameters, returnType2, body);
            } else {
              newFunction = ts3.factory.createFunctionDeclaration(void 0, range.facts & RangeFacts.IsAsyncFunction ? [ts3.factory.createToken(129)] : void 0, range.facts & RangeFacts.IsGenerator ? ts3.factory.createToken(41) : void 0, functionName, typeParameters, parameters, returnType2, body);
            }
            var changeTracker = ts3.textChanges.ChangeTracker.fromContext(context);
            var minInsertionPos = (isReadonlyArray(range.range) ? ts3.last(range.range) : range.range).end;
            var nodeToInsertBefore = getNodeToInsertFunctionBefore(minInsertionPos, scope);
            if (nodeToInsertBefore) {
              changeTracker.insertNodeBefore(context.file, nodeToInsertBefore, newFunction, true);
            } else {
              changeTracker.insertNodeAtEndOfScope(context.file, scope, newFunction);
            }
            importAdder.writeFixes(changeTracker);
            var newNodes = [];
            var called = getCalledExpression(scope, range, functionNameText);
            var call = ts3.factory.createCallExpression(called, callTypeArguments, callArguments);
            if (range.facts & RangeFacts.IsGenerator) {
              call = ts3.factory.createYieldExpression(ts3.factory.createToken(41), call);
            }
            if (range.facts & RangeFacts.IsAsyncFunction) {
              call = ts3.factory.createAwaitExpression(call);
            }
            if (isInJSXContent(node)) {
              call = ts3.factory.createJsxExpression(void 0, call);
            }
            if (exposedVariableDeclarations.length && !writes) {
              ts3.Debug.assert(!returnValueProperty, "Expected no returnValueProperty");
              ts3.Debug.assert(!(range.facts & RangeFacts.HasReturn), "Expected RangeFacts.HasReturn flag to be unset");
              if (exposedVariableDeclarations.length === 1) {
                var variableDeclaration = exposedVariableDeclarations[0];
                newNodes.push(ts3.factory.createVariableStatement(void 0, ts3.factory.createVariableDeclarationList([ts3.factory.createVariableDeclaration(ts3.getSynthesizedDeepClone(variableDeclaration.name), void 0, ts3.getSynthesizedDeepClone(variableDeclaration.type), call)], variableDeclaration.parent.flags)));
              } else {
                var bindingElements = [];
                var typeElements = [];
                var commonNodeFlags = exposedVariableDeclarations[0].parent.flags;
                var sawExplicitType = false;
                for (var _i = 0, exposedVariableDeclarations_1 = exposedVariableDeclarations; _i < exposedVariableDeclarations_1.length; _i++) {
                  var variableDeclaration = exposedVariableDeclarations_1[_i];
                  bindingElements.push(ts3.factory.createBindingElement(void 0, void 0, ts3.getSynthesizedDeepClone(variableDeclaration.name)));
                  var variableType = checker.typeToTypeNode(checker.getBaseTypeOfLiteralType(checker.getTypeAtLocation(variableDeclaration)), scope, 1);
                  typeElements.push(ts3.factory.createPropertySignature(void 0, variableDeclaration.symbol.name, void 0, variableType));
                  sawExplicitType = sawExplicitType || variableDeclaration.type !== void 0;
                  commonNodeFlags = commonNodeFlags & variableDeclaration.parent.flags;
                }
                var typeLiteral = sawExplicitType ? ts3.factory.createTypeLiteralNode(typeElements) : void 0;
                if (typeLiteral) {
                  ts3.setEmitFlags(typeLiteral, 1);
                }
                newNodes.push(ts3.factory.createVariableStatement(void 0, ts3.factory.createVariableDeclarationList([ts3.factory.createVariableDeclaration(ts3.factory.createObjectBindingPattern(bindingElements), void 0, typeLiteral, call)], commonNodeFlags)));
              }
            } else if (exposedVariableDeclarations.length || writes) {
              if (exposedVariableDeclarations.length) {
                for (var _c = 0, exposedVariableDeclarations_2 = exposedVariableDeclarations; _c < exposedVariableDeclarations_2.length; _c++) {
                  var variableDeclaration = exposedVariableDeclarations_2[_c];
                  var flags = variableDeclaration.parent.flags;
                  if (flags & 2) {
                    flags = flags & ~2 | 1;
                  }
                  newNodes.push(ts3.factory.createVariableStatement(void 0, ts3.factory.createVariableDeclarationList([ts3.factory.createVariableDeclaration(variableDeclaration.symbol.name, void 0, getTypeDeepCloneUnionUndefined(variableDeclaration.type))], flags)));
                }
              }
              if (returnValueProperty) {
                newNodes.push(ts3.factory.createVariableStatement(void 0, ts3.factory.createVariableDeclarationList([ts3.factory.createVariableDeclaration(returnValueProperty, void 0, getTypeDeepCloneUnionUndefined(returnType2))], 1)));
              }
              var assignments = getPropertyAssignmentsForWritesAndVariableDeclarations(exposedVariableDeclarations, writes);
              if (returnValueProperty) {
                assignments.unshift(ts3.factory.createShorthandPropertyAssignment(returnValueProperty));
              }
              if (assignments.length === 1) {
                ts3.Debug.assert(!returnValueProperty, "Shouldn't have returnValueProperty here");
                newNodes.push(ts3.factory.createExpressionStatement(ts3.factory.createAssignment(assignments[0].name, call)));
                if (range.facts & RangeFacts.HasReturn) {
                  newNodes.push(ts3.factory.createReturnStatement());
                }
              } else {
                newNodes.push(ts3.factory.createExpressionStatement(ts3.factory.createAssignment(ts3.factory.createObjectLiteralExpression(assignments), call)));
                if (returnValueProperty) {
                  newNodes.push(ts3.factory.createReturnStatement(ts3.factory.createIdentifier(returnValueProperty)));
                }
              }
            } else {
              if (range.facts & RangeFacts.HasReturn) {
                newNodes.push(ts3.factory.createReturnStatement(call));
              } else if (isReadonlyArray(range.range)) {
                newNodes.push(ts3.factory.createExpressionStatement(call));
              } else {
                newNodes.push(call);
              }
            }
            if (isReadonlyArray(range.range)) {
              changeTracker.replaceNodeRangeWithNodes(context.file, ts3.first(range.range), ts3.last(range.range), newNodes);
            } else {
              changeTracker.replaceNodeWithNodes(context.file, range.range, newNodes);
            }
            var edits = changeTracker.getChanges();
            var renameRange = isReadonlyArray(range.range) ? ts3.first(range.range) : range.range;
            var renameFilename = renameRange.getSourceFile().fileName;
            var renameLocation = ts3.getRenameLocation(edits, renameFilename, functionNameText, false);
            return { renameFilename, renameLocation, edits };
            function getTypeDeepCloneUnionUndefined(typeNode) {
              if (typeNode === void 0) {
                return void 0;
              }
              var clone = ts3.getSynthesizedDeepClone(typeNode);
              var withoutParens = clone;
              while (ts3.isParenthesizedTypeNode(withoutParens)) {
                withoutParens = withoutParens.type;
              }
              return ts3.isUnionTypeNode(withoutParens) && ts3.find(withoutParens.types, function(t2) {
                return t2.kind === 150;
              }) ? clone : ts3.factory.createUnionTypeNode([clone, ts3.factory.createKeywordTypeNode(150)]);
            }
          }
          function extractConstantInScope(node, scope, _a2, rangeFacts, context) {
            var _b;
            var substitutions = _a2.substitutions;
            var checker = context.program.getTypeChecker();
            var file = scope.getSourceFile();
            var localNameText = ts3.getUniqueName(ts3.isClassLike(scope) ? "newProperty" : "newLocal", file);
            var isJS = ts3.isInJSFile(scope);
            var variableType = isJS || !checker.isContextSensitive(node) ? void 0 : checker.typeToTypeNode(checker.getContextualType(node), scope, 1);
            var initializer = transformConstantInitializer(node, substitutions);
            _b = transformFunctionInitializerAndType(variableType, initializer), variableType = _b.variableType, initializer = _b.initializer;
            ts3.suppressLeadingAndTrailingTrivia(initializer);
            var changeTracker = ts3.textChanges.ChangeTracker.fromContext(context);
            if (ts3.isClassLike(scope)) {
              ts3.Debug.assert(!isJS, "Cannot extract to a JS class");
              var modifiers = [];
              modifiers.push(ts3.factory.createModifier(120));
              if (rangeFacts & RangeFacts.InStaticRegion) {
                modifiers.push(ts3.factory.createModifier(123));
              }
              modifiers.push(ts3.factory.createModifier(142));
              var newVariable = ts3.factory.createPropertyDeclaration(void 0, modifiers, localNameText, void 0, variableType, initializer);
              var localReference = ts3.factory.createPropertyAccessExpression(rangeFacts & RangeFacts.InStaticRegion ? ts3.factory.createIdentifier(scope.name.getText()) : ts3.factory.createThis(), ts3.factory.createIdentifier(localNameText));
              if (isInJSXContent(node)) {
                localReference = ts3.factory.createJsxExpression(void 0, localReference);
              }
              var maxInsertionPos = node.pos;
              var nodeToInsertBefore = getNodeToInsertPropertyBefore(maxInsertionPos, scope);
              changeTracker.insertNodeBefore(context.file, nodeToInsertBefore, newVariable, true);
              changeTracker.replaceNode(context.file, node, localReference);
            } else {
              var newVariableDeclaration = ts3.factory.createVariableDeclaration(localNameText, void 0, variableType, initializer);
              var oldVariableDeclaration = getContainingVariableDeclarationIfInList(node, scope);
              if (oldVariableDeclaration) {
                changeTracker.insertNodeBefore(context.file, oldVariableDeclaration, newVariableDeclaration);
                var localReference = ts3.factory.createIdentifier(localNameText);
                changeTracker.replaceNode(context.file, node, localReference);
              } else if (node.parent.kind === 234 && scope === ts3.findAncestor(node, isScope)) {
                var newVariableStatement = ts3.factory.createVariableStatement(void 0, ts3.factory.createVariableDeclarationList([newVariableDeclaration], 2));
                changeTracker.replaceNode(context.file, node.parent, newVariableStatement);
              } else {
                var newVariableStatement = ts3.factory.createVariableStatement(void 0, ts3.factory.createVariableDeclarationList([newVariableDeclaration], 2));
                var nodeToInsertBefore = getNodeToInsertConstantBefore(node, scope);
                if (nodeToInsertBefore.pos === 0) {
                  changeTracker.insertNodeAtTopOfFile(context.file, newVariableStatement, false);
                } else {
                  changeTracker.insertNodeBefore(context.file, nodeToInsertBefore, newVariableStatement, false);
                }
                if (node.parent.kind === 234) {
                  changeTracker.delete(context.file, node.parent);
                } else {
                  var localReference = ts3.factory.createIdentifier(localNameText);
                  if (isInJSXContent(node)) {
                    localReference = ts3.factory.createJsxExpression(void 0, localReference);
                  }
                  changeTracker.replaceNode(context.file, node, localReference);
                }
              }
            }
            var edits = changeTracker.getChanges();
            var renameFilename = node.getSourceFile().fileName;
            var renameLocation = ts3.getRenameLocation(edits, renameFilename, localNameText, true);
            return { renameFilename, renameLocation, edits };
            function transformFunctionInitializerAndType(variableType2, initializer2) {
              if (variableType2 === void 0)
                return { variableType: variableType2, initializer: initializer2 };
              if (!ts3.isFunctionExpression(initializer2) && !ts3.isArrowFunction(initializer2) || !!initializer2.typeParameters)
                return { variableType: variableType2, initializer: initializer2 };
              var functionType = checker.getTypeAtLocation(node);
              var functionSignature = ts3.singleOrUndefined(checker.getSignaturesOfType(functionType, 0));
              if (!functionSignature)
                return { variableType: variableType2, initializer: initializer2 };
              if (!!functionSignature.getTypeParameters())
                return { variableType: variableType2, initializer: initializer2 };
              var parameters = [];
              var hasAny = false;
              for (var _i = 0, _a3 = initializer2.parameters; _i < _a3.length; _i++) {
                var p = _a3[_i];
                if (p.type) {
                  parameters.push(p);
                } else {
                  var paramType = checker.getTypeAtLocation(p);
                  if (paramType === checker.getAnyType())
                    hasAny = true;
                  parameters.push(ts3.factory.updateParameterDeclaration(p, p.decorators, p.modifiers, p.dotDotDotToken, p.name, p.questionToken, p.type || checker.typeToTypeNode(paramType, scope, 1), p.initializer));
                }
              }
              if (hasAny)
                return { variableType: variableType2, initializer: initializer2 };
              variableType2 = void 0;
              if (ts3.isArrowFunction(initializer2)) {
                initializer2 = ts3.factory.updateArrowFunction(initializer2, node.modifiers, initializer2.typeParameters, parameters, initializer2.type || checker.typeToTypeNode(functionSignature.getReturnType(), scope, 1), initializer2.equalsGreaterThanToken, initializer2.body);
              } else {
                if (functionSignature && !!functionSignature.thisParameter) {
                  var firstParameter = ts3.firstOrUndefined(parameters);
                  if (!firstParameter || ts3.isIdentifier(firstParameter.name) && firstParameter.name.escapedText !== "this") {
                    var thisType = checker.getTypeOfSymbolAtLocation(functionSignature.thisParameter, node);
                    parameters.splice(0, 0, ts3.factory.createParameterDeclaration(void 0, void 0, void 0, "this", void 0, checker.typeToTypeNode(thisType, scope, 1)));
                  }
                }
                initializer2 = ts3.factory.updateFunctionExpression(initializer2, node.modifiers, initializer2.asteriskToken, initializer2.name, initializer2.typeParameters, parameters, initializer2.type || checker.typeToTypeNode(functionSignature.getReturnType(), scope, 1), initializer2.body);
              }
              return { variableType: variableType2, initializer: initializer2 };
            }
          }
          function getContainingVariableDeclarationIfInList(node, scope) {
            var prevNode;
            while (node !== void 0 && node !== scope) {
              if (ts3.isVariableDeclaration(node) && node.initializer === prevNode && ts3.isVariableDeclarationList(node.parent) && node.parent.declarations.length > 1) {
                return node;
              }
              prevNode = node;
              node = node.parent;
            }
          }
          function getFirstDeclaration(type3) {
            var firstDeclaration;
            var symbol = type3.symbol;
            if (symbol && symbol.declarations) {
              for (var _i = 0, _a2 = symbol.declarations; _i < _a2.length; _i++) {
                var declaration = _a2[_i];
                if (firstDeclaration === void 0 || declaration.pos < firstDeclaration.pos) {
                  firstDeclaration = declaration;
                }
              }
            }
            return firstDeclaration;
          }
          function compareTypesByDeclarationOrder(_a2, _b) {
            var type1 = _a2.type, declaration1 = _a2.declaration;
            var type22 = _b.type, declaration2 = _b.declaration;
            return ts3.compareProperties(declaration1, declaration2, "pos", ts3.compareValues) || ts3.compareStringsCaseSensitive(type1.symbol ? type1.symbol.getName() : "", type22.symbol ? type22.symbol.getName() : "") || ts3.compareValues(type1.id, type22.id);
          }
          function getCalledExpression(scope, range, functionNameText) {
            var functionReference = ts3.factory.createIdentifier(functionNameText);
            if (ts3.isClassLike(scope)) {
              var lhs = range.facts & RangeFacts.InStaticRegion ? ts3.factory.createIdentifier(scope.name.text) : ts3.factory.createThis();
              return ts3.factory.createPropertyAccessExpression(lhs, functionReference);
            } else {
              return functionReference;
            }
          }
          function transformFunctionBody(body, exposedVariableDeclarations, writes, substitutions, hasReturn) {
            var hasWritesOrVariableDeclarations = writes !== void 0 || exposedVariableDeclarations.length > 0;
            if (ts3.isBlock(body) && !hasWritesOrVariableDeclarations && substitutions.size === 0) {
              return { body: ts3.factory.createBlock(body.statements, true), returnValueProperty: void 0 };
            }
            var returnValueProperty;
            var ignoreReturns = false;
            var statements = ts3.factory.createNodeArray(ts3.isBlock(body) ? body.statements.slice(0) : [ts3.isStatement(body) ? body : ts3.factory.createReturnStatement(body)]);
            if (hasWritesOrVariableDeclarations || substitutions.size) {
              var rewrittenStatements = ts3.visitNodes(statements, visitor).slice();
              if (hasWritesOrVariableDeclarations && !hasReturn && ts3.isStatement(body)) {
                var assignments = getPropertyAssignmentsForWritesAndVariableDeclarations(exposedVariableDeclarations, writes);
                if (assignments.length === 1) {
                  rewrittenStatements.push(ts3.factory.createReturnStatement(assignments[0].name));
                } else {
                  rewrittenStatements.push(ts3.factory.createReturnStatement(ts3.factory.createObjectLiteralExpression(assignments)));
                }
              }
              return { body: ts3.factory.createBlock(rewrittenStatements, true), returnValueProperty };
            } else {
              return { body: ts3.factory.createBlock(statements, true), returnValueProperty: void 0 };
            }
            function visitor(node) {
              if (!ignoreReturns && ts3.isReturnStatement(node) && hasWritesOrVariableDeclarations) {
                var assignments2 = getPropertyAssignmentsForWritesAndVariableDeclarations(exposedVariableDeclarations, writes);
                if (node.expression) {
                  if (!returnValueProperty) {
                    returnValueProperty = "__return";
                  }
                  assignments2.unshift(ts3.factory.createPropertyAssignment(returnValueProperty, ts3.visitNode(node.expression, visitor)));
                }
                if (assignments2.length === 1) {
                  return ts3.factory.createReturnStatement(assignments2[0].name);
                } else {
                  return ts3.factory.createReturnStatement(ts3.factory.createObjectLiteralExpression(assignments2));
                }
              } else {
                var oldIgnoreReturns = ignoreReturns;
                ignoreReturns = ignoreReturns || ts3.isFunctionLikeDeclaration(node) || ts3.isClassLike(node);
                var substitution = substitutions.get(ts3.getNodeId(node).toString());
                var result2 = substitution ? ts3.getSynthesizedDeepClone(substitution) : ts3.visitEachChild(node, visitor, ts3.nullTransformationContext);
                ignoreReturns = oldIgnoreReturns;
                return result2;
              }
            }
          }
          function transformConstantInitializer(initializer, substitutions) {
            return substitutions.size ? visitor(initializer) : initializer;
            function visitor(node) {
              var substitution = substitutions.get(ts3.getNodeId(node).toString());
              return substitution ? ts3.getSynthesizedDeepClone(substitution) : ts3.visitEachChild(node, visitor, ts3.nullTransformationContext);
            }
          }
          function getStatementsOrClassElements(scope) {
            if (ts3.isFunctionLikeDeclaration(scope)) {
              var body = scope.body;
              if (ts3.isBlock(body)) {
                return body.statements;
              }
            } else if (ts3.isModuleBlock(scope) || ts3.isSourceFile(scope)) {
              return scope.statements;
            } else if (ts3.isClassLike(scope)) {
              return scope.members;
            } else {
              ts3.assertType(scope);
            }
            return ts3.emptyArray;
          }
          function getNodeToInsertFunctionBefore(minPos, scope) {
            return ts3.find(getStatementsOrClassElements(scope), function(child) {
              return child.pos >= minPos && ts3.isFunctionLikeDeclaration(child) && !ts3.isConstructorDeclaration(child);
            });
          }
          function getNodeToInsertPropertyBefore(maxPos, scope) {
            var members = scope.members;
            ts3.Debug.assert(members.length > 0, "Found no members");
            var prevMember;
            var allProperties = true;
            for (var _i = 0, members_1 = members; _i < members_1.length; _i++) {
              var member = members_1[_i];
              if (member.pos > maxPos) {
                return prevMember || members[0];
              }
              if (allProperties && !ts3.isPropertyDeclaration(member)) {
                if (prevMember !== void 0) {
                  return member;
                }
                allProperties = false;
              }
              prevMember = member;
            }
            if (prevMember === void 0)
              return ts3.Debug.fail();
            return prevMember;
          }
          function getNodeToInsertConstantBefore(node, scope) {
            ts3.Debug.assert(!ts3.isClassLike(scope));
            var prevScope;
            for (var curr = node; curr !== scope; curr = curr.parent) {
              if (isScope(curr)) {
                prevScope = curr;
              }
            }
            for (var curr = (prevScope || node).parent; ; curr = curr.parent) {
              if (isBlockLike(curr)) {
                var prevStatement = void 0;
                for (var _i = 0, _a2 = curr.statements; _i < _a2.length; _i++) {
                  var statement = _a2[_i];
                  if (statement.pos > node.pos) {
                    break;
                  }
                  prevStatement = statement;
                }
                if (!prevStatement && ts3.isCaseClause(curr)) {
                  ts3.Debug.assert(ts3.isSwitchStatement(curr.parent.parent), "Grandparent isn't a switch statement");
                  return curr.parent.parent;
                }
                return ts3.Debug.checkDefined(prevStatement, "prevStatement failed to get set");
              }
              ts3.Debug.assert(curr !== scope, "Didn't encounter a block-like before encountering scope");
            }
          }
          function getPropertyAssignmentsForWritesAndVariableDeclarations(exposedVariableDeclarations, writes) {
            var variableAssignments = ts3.map(exposedVariableDeclarations, function(v) {
              return ts3.factory.createShorthandPropertyAssignment(v.symbol.name);
            });
            var writeAssignments = ts3.map(writes, function(w) {
              return ts3.factory.createShorthandPropertyAssignment(w.symbol.name);
            });
            return variableAssignments === void 0 ? writeAssignments : writeAssignments === void 0 ? variableAssignments : variableAssignments.concat(writeAssignments);
          }
          function isReadonlyArray(v) {
            return ts3.isArray(v);
          }
          function getEnclosingTextRange(targetRange, sourceFile) {
            return isReadonlyArray(targetRange.range) ? { pos: ts3.first(targetRange.range).getStart(sourceFile), end: ts3.last(targetRange.range).getEnd() } : targetRange.range;
          }
          var Usage;
          (function(Usage2) {
            Usage2[Usage2["Read"] = 1] = "Read";
            Usage2[Usage2["Write"] = 2] = "Write";
          })(Usage || (Usage = {}));
          function collectReadsAndWrites(targetRange, scopes, enclosingTextRange, sourceFile, checker, cancellationToken) {
            var allTypeParameterUsages = new ts3.Map();
            var usagesPerScope = [];
            var substitutionsPerScope = [];
            var functionErrorsPerScope = [];
            var constantErrorsPerScope = [];
            var visibleDeclarationsInExtractedRange = [];
            var exposedVariableSymbolSet = new ts3.Map();
            var exposedVariableDeclarations = [];
            var firstExposedNonVariableDeclaration;
            var expression = !isReadonlyArray(targetRange.range) ? targetRange.range : targetRange.range.length === 1 && ts3.isExpressionStatement(targetRange.range[0]) ? targetRange.range[0].expression : void 0;
            var expressionDiagnostic;
            if (expression === void 0) {
              var statements = targetRange.range;
              var start = ts3.first(statements).getStart();
              var end = ts3.last(statements).end;
              expressionDiagnostic = ts3.createFileDiagnostic(sourceFile, start, end - start, Messages.expressionExpected);
            } else if (checker.getTypeAtLocation(expression).flags & (16384 | 131072)) {
              expressionDiagnostic = ts3.createDiagnosticForNode(expression, Messages.uselessConstantType);
            }
            for (var _i = 0, scopes_1 = scopes; _i < scopes_1.length; _i++) {
              var scope = scopes_1[_i];
              usagesPerScope.push({ usages: new ts3.Map(), typeParameterUsages: new ts3.Map(), substitutions: new ts3.Map() });
              substitutionsPerScope.push(new ts3.Map());
              functionErrorsPerScope.push(ts3.isFunctionLikeDeclaration(scope) && scope.kind !== 252 ? [ts3.createDiagnosticForNode(scope, Messages.cannotExtractToOtherFunctionLike)] : []);
              var constantErrors = [];
              if (expressionDiagnostic) {
                constantErrors.push(expressionDiagnostic);
              }
              if (ts3.isClassLike(scope) && ts3.isInJSFile(scope)) {
                constantErrors.push(ts3.createDiagnosticForNode(scope, Messages.cannotExtractToJSClass));
              }
              if (ts3.isArrowFunction(scope) && !ts3.isBlock(scope.body)) {
                constantErrors.push(ts3.createDiagnosticForNode(scope, Messages.cannotExtractToExpressionArrowFunction));
              }
              constantErrorsPerScope.push(constantErrors);
            }
            var seenUsages = new ts3.Map();
            var target = isReadonlyArray(targetRange.range) ? ts3.factory.createBlock(targetRange.range) : targetRange.range;
            var unmodifiedNode = isReadonlyArray(targetRange.range) ? ts3.first(targetRange.range) : targetRange.range;
            var inGenericContext = isInGenericContext(unmodifiedNode);
            collectUsages(target);
            if (inGenericContext && !isReadonlyArray(targetRange.range)) {
              var contextualType = checker.getContextualType(targetRange.range);
              recordTypeParameterUsages(contextualType);
            }
            if (allTypeParameterUsages.size > 0) {
              var seenTypeParameterUsages = new ts3.Map();
              var i_2 = 0;
              for (var curr = unmodifiedNode; curr !== void 0 && i_2 < scopes.length; curr = curr.parent) {
                if (curr === scopes[i_2]) {
                  seenTypeParameterUsages.forEach(function(typeParameter2, id) {
                    usagesPerScope[i_2].typeParameterUsages.set(id, typeParameter2);
                  });
                  i_2++;
                }
                if (ts3.isDeclarationWithTypeParameters(curr)) {
                  for (var _a2 = 0, _b = ts3.getEffectiveTypeParameterDeclarations(curr); _a2 < _b.length; _a2++) {
                    var typeParameterDecl = _b[_a2];
                    var typeParameter = checker.getTypeAtLocation(typeParameterDecl);
                    if (allTypeParameterUsages.has(typeParameter.id.toString())) {
                      seenTypeParameterUsages.set(typeParameter.id.toString(), typeParameter);
                    }
                  }
                }
              }
              ts3.Debug.assert(i_2 === scopes.length, "Should have iterated all scopes");
            }
            if (visibleDeclarationsInExtractedRange.length) {
              var containingLexicalScopeOfExtraction = ts3.isBlockScope(scopes[0], scopes[0].parent) ? scopes[0] : ts3.getEnclosingBlockScopeContainer(scopes[0]);
              ts3.forEachChild(containingLexicalScopeOfExtraction, checkForUsedDeclarations);
            }
            var _loop_17 = function(i4) {
              var scopeUsages = usagesPerScope[i4];
              if (i4 > 0 && (scopeUsages.usages.size > 0 || scopeUsages.typeParameterUsages.size > 0)) {
                var errorNode = isReadonlyArray(targetRange.range) ? targetRange.range[0] : targetRange.range;
                constantErrorsPerScope[i4].push(ts3.createDiagnosticForNode(errorNode, Messages.cannotAccessVariablesFromNestedScopes));
              }
              var hasWrite = false;
              var readonlyClassPropertyWrite;
              usagesPerScope[i4].usages.forEach(function(value) {
                if (value.usage === 2) {
                  hasWrite = true;
                  if (value.symbol.flags & 106500 && value.symbol.valueDeclaration && ts3.hasEffectiveModifier(value.symbol.valueDeclaration, 64)) {
                    readonlyClassPropertyWrite = value.symbol.valueDeclaration;
                  }
                }
              });
              ts3.Debug.assert(isReadonlyArray(targetRange.range) || exposedVariableDeclarations.length === 0, "No variable declarations expected if something was extracted");
              if (hasWrite && !isReadonlyArray(targetRange.range)) {
                var diag = ts3.createDiagnosticForNode(targetRange.range, Messages.cannotWriteInExpression);
                functionErrorsPerScope[i4].push(diag);
                constantErrorsPerScope[i4].push(diag);
              } else if (readonlyClassPropertyWrite && i4 > 0) {
                var diag = ts3.createDiagnosticForNode(readonlyClassPropertyWrite, Messages.cannotExtractReadonlyPropertyInitializerOutsideConstructor);
                functionErrorsPerScope[i4].push(diag);
                constantErrorsPerScope[i4].push(diag);
              } else if (firstExposedNonVariableDeclaration) {
                var diag = ts3.createDiagnosticForNode(firstExposedNonVariableDeclaration, Messages.cannotExtractExportedEntity);
                functionErrorsPerScope[i4].push(diag);
                constantErrorsPerScope[i4].push(diag);
              }
            };
            for (var i3 = 0; i3 < scopes.length; i3++) {
              _loop_17(i3);
            }
            return { target, usagesPerScope, functionErrorsPerScope, constantErrorsPerScope, exposedVariableDeclarations };
            function isInGenericContext(node) {
              return !!ts3.findAncestor(node, function(n2) {
                return ts3.isDeclarationWithTypeParameters(n2) && ts3.getEffectiveTypeParameterDeclarations(n2).length !== 0;
              });
            }
            function recordTypeParameterUsages(type3) {
              var symbolWalker = checker.getSymbolWalker(function() {
                return cancellationToken.throwIfCancellationRequested(), true;
              });
              var visitedTypes = symbolWalker.walkType(type3).visitedTypes;
              for (var _i2 = 0, visitedTypes_1 = visitedTypes; _i2 < visitedTypes_1.length; _i2++) {
                var visitedType = visitedTypes_1[_i2];
                if (visitedType.isTypeParameter()) {
                  allTypeParameterUsages.set(visitedType.id.toString(), visitedType);
                }
              }
            }
            function collectUsages(node, valueUsage) {
              if (valueUsage === void 0) {
                valueUsage = 1;
              }
              if (inGenericContext) {
                var type3 = checker.getTypeAtLocation(node);
                recordTypeParameterUsages(type3);
              }
              if (ts3.isDeclaration(node) && node.symbol) {
                visibleDeclarationsInExtractedRange.push(node);
              }
              if (ts3.isAssignmentExpression(node)) {
                collectUsages(node.left, 2);
                collectUsages(node.right);
              } else if (ts3.isUnaryExpressionWithWrite(node)) {
                collectUsages(node.operand, 2);
              } else if (ts3.isPropertyAccessExpression(node) || ts3.isElementAccessExpression(node)) {
                ts3.forEachChild(node, collectUsages);
              } else if (ts3.isIdentifier(node)) {
                if (!node.parent) {
                  return;
                }
                if (ts3.isQualifiedName(node.parent) && node !== node.parent.left) {
                  return;
                }
                if (ts3.isPropertyAccessExpression(node.parent) && node !== node.parent.expression) {
                  return;
                }
                recordUsage(node, valueUsage, ts3.isPartOfTypeNode(node));
              } else {
                ts3.forEachChild(node, collectUsages);
              }
            }
            function recordUsage(n2, usage, isTypeNode) {
              var symbolId = recordUsagebySymbol(n2, usage, isTypeNode);
              if (symbolId) {
                for (var i4 = 0; i4 < scopes.length; i4++) {
                  var substitution = substitutionsPerScope[i4].get(symbolId);
                  if (substitution) {
                    usagesPerScope[i4].substitutions.set(ts3.getNodeId(n2).toString(), substitution);
                  }
                }
              }
            }
            function recordUsagebySymbol(identifier, usage, isTypeName) {
              var symbol = getSymbolReferencedByIdentifier(identifier);
              if (!symbol) {
                return void 0;
              }
              var symbolId = ts3.getSymbolId(symbol).toString();
              var lastUsage = seenUsages.get(symbolId);
              if (lastUsage && lastUsage >= usage) {
                return symbolId;
              }
              seenUsages.set(symbolId, usage);
              if (lastUsage) {
                for (var _i2 = 0, usagesPerScope_1 = usagesPerScope; _i2 < usagesPerScope_1.length; _i2++) {
                  var perScope = usagesPerScope_1[_i2];
                  var prevEntry = perScope.usages.get(identifier.text);
                  if (prevEntry) {
                    perScope.usages.set(identifier.text, { usage, symbol, node: identifier });
                  }
                }
                return symbolId;
              }
              var decls = symbol.getDeclarations();
              var declInFile = decls && ts3.find(decls, function(d) {
                return d.getSourceFile() === sourceFile;
              });
              if (!declInFile) {
                return void 0;
              }
              if (ts3.rangeContainsStartEnd(enclosingTextRange, declInFile.getStart(), declInFile.end)) {
                return void 0;
              }
              if (targetRange.facts & RangeFacts.IsGenerator && usage === 2) {
                var diag = ts3.createDiagnosticForNode(identifier, Messages.cannotExtractRangeThatContainsWritesToReferencesLocatedOutsideOfTheTargetRangeInGenerators);
                for (var _a3 = 0, functionErrorsPerScope_1 = functionErrorsPerScope; _a3 < functionErrorsPerScope_1.length; _a3++) {
                  var errors = functionErrorsPerScope_1[_a3];
                  errors.push(diag);
                }
                for (var _b2 = 0, constantErrorsPerScope_1 = constantErrorsPerScope; _b2 < constantErrorsPerScope_1.length; _b2++) {
                  var errors = constantErrorsPerScope_1[_b2];
                  errors.push(diag);
                }
              }
              for (var i4 = 0; i4 < scopes.length; i4++) {
                var scope2 = scopes[i4];
                var resolvedSymbol = checker.resolveName(symbol.name, scope2, symbol.flags, false);
                if (resolvedSymbol === symbol) {
                  continue;
                }
                if (!substitutionsPerScope[i4].has(symbolId)) {
                  var substitution = tryReplaceWithQualifiedNameOrPropertyAccess(symbol.exportSymbol || symbol, scope2, isTypeName);
                  if (substitution) {
                    substitutionsPerScope[i4].set(symbolId, substitution);
                  } else if (isTypeName) {
                    if (!(symbol.flags & 262144)) {
                      var diag = ts3.createDiagnosticForNode(identifier, Messages.typeWillNotBeVisibleInTheNewScope);
                      functionErrorsPerScope[i4].push(diag);
                      constantErrorsPerScope[i4].push(diag);
                    }
                  } else {
                    usagesPerScope[i4].usages.set(identifier.text, { usage, symbol, node: identifier });
                  }
                }
              }
              return symbolId;
            }
            function checkForUsedDeclarations(node) {
              if (node === targetRange.range || isReadonlyArray(targetRange.range) && targetRange.range.indexOf(node) >= 0) {
                return;
              }
              var sym = ts3.isIdentifier(node) ? getSymbolReferencedByIdentifier(node) : checker.getSymbolAtLocation(node);
              if (sym) {
                var decl = ts3.find(visibleDeclarationsInExtractedRange, function(d) {
                  return d.symbol === sym;
                });
                if (decl) {
                  if (ts3.isVariableDeclaration(decl)) {
                    var idString = decl.symbol.id.toString();
                    if (!exposedVariableSymbolSet.has(idString)) {
                      exposedVariableDeclarations.push(decl);
                      exposedVariableSymbolSet.set(idString, true);
                    }
                  } else {
                    firstExposedNonVariableDeclaration = firstExposedNonVariableDeclaration || decl;
                  }
                }
              }
              ts3.forEachChild(node, checkForUsedDeclarations);
            }
            function getSymbolReferencedByIdentifier(identifier) {
              return identifier.parent && ts3.isShorthandPropertyAssignment(identifier.parent) && identifier.parent.name === identifier ? checker.getShorthandAssignmentValueSymbol(identifier.parent) : checker.getSymbolAtLocation(identifier);
            }
            function tryReplaceWithQualifiedNameOrPropertyAccess(symbol, scopeDecl, isTypeNode) {
              if (!symbol) {
                return void 0;
              }
              var decls = symbol.getDeclarations();
              if (decls && decls.some(function(d) {
                return d.parent === scopeDecl;
              })) {
                return ts3.factory.createIdentifier(symbol.name);
              }
              var prefix2 = tryReplaceWithQualifiedNameOrPropertyAccess(symbol.parent, scopeDecl, isTypeNode);
              if (prefix2 === void 0) {
                return void 0;
              }
              return isTypeNode ? ts3.factory.createQualifiedName(prefix2, ts3.factory.createIdentifier(symbol.name)) : ts3.factory.createPropertyAccessExpression(prefix2, symbol.name);
            }
          }
          function getExtractableParent(node) {
            return ts3.findAncestor(node, function(node2) {
              return node2.parent && isExtractableExpression(node2) && !ts3.isBinaryExpression(node2.parent);
            });
          }
          function isExtractableExpression(node) {
            var parent = node.parent;
            switch (parent.kind) {
              case 292:
                return false;
            }
            switch (node.kind) {
              case 10:
                return parent.kind !== 262 && parent.kind !== 266;
              case 221:
              case 197:
              case 199:
                return false;
              case 78:
                return parent.kind !== 199 && parent.kind !== 266 && parent.kind !== 271;
            }
            return true;
          }
          function isBlockLike(node) {
            switch (node.kind) {
              case 231:
              case 298:
              case 258:
              case 285:
                return true;
              default:
                return false;
            }
          }
          function isInJSXContent(node) {
            return (ts3.isJsxElement(node) || ts3.isJsxSelfClosingElement(node) || ts3.isJsxFragment(node)) && ts3.isJsxElement(node.parent);
          }
        })(extractSymbol = refactor2.extractSymbol || (refactor2.extractSymbol = {}));
      })(refactor = ts3.refactor || (ts3.refactor = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var refactor;
      (function(refactor2) {
        var refactorName = "Extract type";
        var extractToTypeAliasAction = {
          name: "Extract to type alias",
          description: ts3.getLocaleSpecificMessage(ts3.Diagnostics.Extract_to_type_alias),
          kind: "refactor.extract.type"
        };
        var extractToInterfaceAction = {
          name: "Extract to interface",
          description: ts3.getLocaleSpecificMessage(ts3.Diagnostics.Extract_to_interface),
          kind: "refactor.extract.interface"
        };
        var extractToTypeDefAction = {
          name: "Extract to typedef",
          description: ts3.getLocaleSpecificMessage(ts3.Diagnostics.Extract_to_typedef),
          kind: "refactor.extract.typedef"
        };
        refactor2.registerRefactor(refactorName, {
          kinds: [
            extractToTypeAliasAction.kind,
            extractToInterfaceAction.kind,
            extractToTypeDefAction.kind
          ],
          getAvailableActions: function(context) {
            var info = getRangeToExtract(context, context.triggerReason === "invoked");
            if (!info)
              return ts3.emptyArray;
            if (!refactor2.isRefactorErrorInfo(info)) {
              return [{
                name: refactorName,
                description: ts3.getLocaleSpecificMessage(ts3.Diagnostics.Extract_type),
                actions: info.isJS ? [extractToTypeDefAction] : ts3.append([extractToTypeAliasAction], info.typeElements && extractToInterfaceAction)
              }];
            }
            if (context.preferences.provideRefactorNotApplicableReason) {
              return [{
                name: refactorName,
                description: ts3.getLocaleSpecificMessage(ts3.Diagnostics.Extract_type),
                actions: [
                  __assign(__assign({}, extractToTypeDefAction), { notApplicableReason: info.error }),
                  __assign(__assign({}, extractToTypeAliasAction), { notApplicableReason: info.error }),
                  __assign(__assign({}, extractToInterfaceAction), { notApplicableReason: info.error })
                ]
              }];
            }
            return ts3.emptyArray;
          },
          getEditsForAction: function(context, actionName) {
            var file = context.file;
            var info = getRangeToExtract(context);
            ts3.Debug.assert(info && !refactor2.isRefactorErrorInfo(info), "Expected to find a range to extract");
            var name = ts3.getUniqueName("NewType", file);
            var edits = ts3.textChanges.ChangeTracker.with(context, function(changes) {
              switch (actionName) {
                case extractToTypeAliasAction.name:
                  ts3.Debug.assert(!info.isJS, "Invalid actionName/JS combo");
                  return doTypeAliasChange(changes, file, name, info);
                case extractToTypeDefAction.name:
                  ts3.Debug.assert(info.isJS, "Invalid actionName/JS combo");
                  return doTypedefChange(changes, file, name, info);
                case extractToInterfaceAction.name:
                  ts3.Debug.assert(!info.isJS && !!info.typeElements, "Invalid actionName/JS combo");
                  return doInterfaceChange(changes, file, name, info);
                default:
                  ts3.Debug.fail("Unexpected action name");
              }
            });
            var renameFilename = file.fileName;
            var renameLocation = ts3.getRenameLocation(edits, renameFilename, name, false);
            return { edits, renameFilename, renameLocation };
          }
        });
        function getRangeToExtract(context, considerEmptySpans) {
          if (considerEmptySpans === void 0) {
            considerEmptySpans = true;
          }
          var file = context.file, startPosition = context.startPosition;
          var isJS = ts3.isSourceFileJS(file);
          var current = ts3.getTokenAtPosition(file, startPosition);
          var range = ts3.createTextRangeFromSpan(ts3.getRefactorContextSpan(context));
          var cursorRequest = range.pos === range.end && considerEmptySpans;
          var selection = ts3.findAncestor(current, function(node) {
            return node.parent && ts3.isTypeNode(node) && !rangeContainsSkipTrivia(range, node.parent, file) && (cursorRequest || ts3.nodeOverlapsWithStartEnd(current, file, range.pos, range.end));
          });
          if (!selection || !ts3.isTypeNode(selection))
            return { error: ts3.getLocaleSpecificMessage(ts3.Diagnostics.Selection_is_not_a_valid_type_node) };
          var checker = context.program.getTypeChecker();
          var firstStatement = ts3.Debug.checkDefined(ts3.findAncestor(selection, ts3.isStatement), "Should find a statement");
          var typeParameters = collectTypeParameters(checker, selection, firstStatement, file);
          if (!typeParameters)
            return { error: ts3.getLocaleSpecificMessage(ts3.Diagnostics.No_type_could_be_extracted_from_this_type_node) };
          var typeElements = flattenTypeLiteralNodeReference(checker, selection);
          return { isJS, selection, firstStatement, typeParameters, typeElements };
        }
        function flattenTypeLiteralNodeReference(checker, node) {
          if (!node)
            return void 0;
          if (ts3.isIntersectionTypeNode(node)) {
            var result2 = [];
            var seen_1 = new ts3.Map();
            for (var _i = 0, _a2 = node.types; _i < _a2.length; _i++) {
              var type3 = _a2[_i];
              var flattenedTypeMembers = flattenTypeLiteralNodeReference(checker, type3);
              if (!flattenedTypeMembers || !flattenedTypeMembers.every(function(type4) {
                return type4.name && ts3.addToSeen(seen_1, ts3.getNameFromPropertyName(type4.name));
              })) {
                return void 0;
              }
              ts3.addRange(result2, flattenedTypeMembers);
            }
            return result2;
          } else if (ts3.isParenthesizedTypeNode(node)) {
            return flattenTypeLiteralNodeReference(checker, node.type);
          } else if (ts3.isTypeLiteralNode(node)) {
            return node.members;
          }
          return void 0;
        }
        function rangeContainsSkipTrivia(r1, node, file) {
          return ts3.rangeContainsStartEnd(r1, ts3.skipTrivia(file.text, node.pos), node.end);
        }
        function collectTypeParameters(checker, selection, statement, file) {
          var result2 = [];
          return visitor(selection) ? void 0 : result2;
          function visitor(node) {
            if (ts3.isTypeReferenceNode(node)) {
              if (ts3.isIdentifier(node.typeName)) {
                var symbol = checker.resolveName(node.typeName.text, node.typeName, 262144, true);
                if (symbol === null || symbol === void 0 ? void 0 : symbol.declarations) {
                  var declaration = ts3.cast(ts3.first(symbol.declarations), ts3.isTypeParameterDeclaration);
                  if (rangeContainsSkipTrivia(statement, declaration, file) && !rangeContainsSkipTrivia(selection, declaration, file)) {
                    ts3.pushIfUnique(result2, declaration);
                  }
                }
              }
            } else if (ts3.isInferTypeNode(node)) {
              var conditionalTypeNode = ts3.findAncestor(node, function(n2) {
                return ts3.isConditionalTypeNode(n2) && rangeContainsSkipTrivia(n2.extendsType, node, file);
              });
              if (!conditionalTypeNode || !rangeContainsSkipTrivia(selection, conditionalTypeNode, file)) {
                return true;
              }
            } else if (ts3.isTypePredicateNode(node) || ts3.isThisTypeNode(node)) {
              var functionLikeNode = ts3.findAncestor(node.parent, ts3.isFunctionLike);
              if (functionLikeNode && functionLikeNode.type && rangeContainsSkipTrivia(functionLikeNode.type, node, file) && !rangeContainsSkipTrivia(selection, functionLikeNode, file)) {
                return true;
              }
            } else if (ts3.isTypeQueryNode(node)) {
              if (ts3.isIdentifier(node.exprName)) {
                var symbol = checker.resolveName(node.exprName.text, node.exprName, 111551, false);
                if ((symbol === null || symbol === void 0 ? void 0 : symbol.valueDeclaration) && rangeContainsSkipTrivia(statement, symbol.valueDeclaration, file) && !rangeContainsSkipTrivia(selection, symbol.valueDeclaration, file)) {
                  return true;
                }
              } else {
                if (ts3.isThisIdentifier(node.exprName.left) && !rangeContainsSkipTrivia(selection, node.parent, file)) {
                  return true;
                }
              }
            }
            if (file && ts3.isTupleTypeNode(node) && ts3.getLineAndCharacterOfPosition(file, node.pos).line === ts3.getLineAndCharacterOfPosition(file, node.end).line) {
              ts3.setEmitFlags(node, 1);
            }
            return ts3.forEachChild(node, visitor);
          }
        }
        function doTypeAliasChange(changes, file, name, info) {
          var firstStatement = info.firstStatement, selection = info.selection, typeParameters = info.typeParameters;
          var newTypeNode = ts3.factory.createTypeAliasDeclaration(void 0, void 0, name, typeParameters.map(function(id) {
            return ts3.factory.updateTypeParameterDeclaration(id, id.name, id.constraint, void 0);
          }), selection);
          changes.insertNodeBefore(file, firstStatement, ts3.ignoreSourceNewlines(newTypeNode), true);
          changes.replaceNode(file, selection, ts3.factory.createTypeReferenceNode(name, typeParameters.map(function(id) {
            return ts3.factory.createTypeReferenceNode(id.name, void 0);
          })), { leadingTriviaOption: ts3.textChanges.LeadingTriviaOption.Exclude, trailingTriviaOption: ts3.textChanges.TrailingTriviaOption.ExcludeWhitespace });
        }
        function doInterfaceChange(changes, file, name, info) {
          var _a2;
          var firstStatement = info.firstStatement, selection = info.selection, typeParameters = info.typeParameters, typeElements = info.typeElements;
          var newTypeNode = ts3.factory.createInterfaceDeclaration(void 0, void 0, name, typeParameters, void 0, typeElements);
          ts3.setTextRange(newTypeNode, (_a2 = typeElements[0]) === null || _a2 === void 0 ? void 0 : _a2.parent);
          changes.insertNodeBefore(file, firstStatement, ts3.ignoreSourceNewlines(newTypeNode), true);
          changes.replaceNode(file, selection, ts3.factory.createTypeReferenceNode(name, typeParameters.map(function(id) {
            return ts3.factory.createTypeReferenceNode(id.name, void 0);
          })), { leadingTriviaOption: ts3.textChanges.LeadingTriviaOption.Exclude, trailingTriviaOption: ts3.textChanges.TrailingTriviaOption.ExcludeWhitespace });
        }
        function doTypedefChange(changes, file, name, info) {
          var firstStatement = info.firstStatement, selection = info.selection, typeParameters = info.typeParameters;
          var node = ts3.factory.createJSDocTypedefTag(ts3.factory.createIdentifier("typedef"), ts3.factory.createJSDocTypeExpression(selection), ts3.factory.createIdentifier(name));
          var templates = [];
          ts3.forEach(typeParameters, function(typeParameter) {
            var constraint = ts3.getEffectiveConstraintOfTypeParameter(typeParameter);
            var parameter = ts3.factory.createTypeParameterDeclaration(typeParameter.name);
            var template = ts3.factory.createJSDocTemplateTag(ts3.factory.createIdentifier("template"), constraint && ts3.cast(constraint, ts3.isJSDocTypeExpression), [parameter]);
            templates.push(template);
          });
          changes.insertNodeBefore(file, firstStatement, ts3.factory.createJSDocComment(void 0, ts3.factory.createNodeArray(ts3.concatenate(templates, [node]))), true);
          changes.replaceNode(file, selection, ts3.factory.createTypeReferenceNode(name, typeParameters.map(function(id) {
            return ts3.factory.createTypeReferenceNode(id.name, void 0);
          })));
        }
      })(refactor = ts3.refactor || (ts3.refactor = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var refactor;
      (function(refactor2) {
        var generateGetAccessorAndSetAccessor;
        (function(generateGetAccessorAndSetAccessor2) {
          var actionName = "Generate 'get' and 'set' accessors";
          var actionDescription = ts3.Diagnostics.Generate_get_and_set_accessors.message;
          var generateGetSetAction = {
            name: actionName,
            description: actionDescription,
            kind: "refactor.rewrite.property.generateAccessors"
          };
          refactor2.registerRefactor(actionName, {
            kinds: [generateGetSetAction.kind],
            getEditsForAction: function(context, actionName2) {
              if (!context.endPosition)
                return void 0;
              var info = ts3.codefix.getAccessorConvertiblePropertyAtPosition(context.file, context.program, context.startPosition, context.endPosition);
              ts3.Debug.assert(info && !refactor2.isRefactorErrorInfo(info), "Expected applicable refactor info");
              var edits = ts3.codefix.generateAccessorFromProperty(context.file, context.program, context.startPosition, context.endPosition, context, actionName2);
              if (!edits)
                return void 0;
              var renameFilename = context.file.fileName;
              var nameNeedRename = info.renameAccessor ? info.accessorName : info.fieldName;
              var renameLocationOffset = ts3.isIdentifier(nameNeedRename) ? 0 : -1;
              var renameLocation = renameLocationOffset + ts3.getRenameLocation(edits, renameFilename, nameNeedRename.text, ts3.isParameter(info.declaration));
              return { renameFilename, renameLocation, edits };
            },
            getAvailableActions: function(context) {
              if (!context.endPosition)
                return ts3.emptyArray;
              var info = ts3.codefix.getAccessorConvertiblePropertyAtPosition(context.file, context.program, context.startPosition, context.endPosition, context.triggerReason === "invoked");
              if (!info)
                return ts3.emptyArray;
              if (!refactor2.isRefactorErrorInfo(info)) {
                return [{
                  name: actionName,
                  description: actionDescription,
                  actions: [generateGetSetAction]
                }];
              }
              if (context.preferences.provideRefactorNotApplicableReason) {
                return [{
                  name: actionName,
                  description: actionDescription,
                  actions: [__assign(__assign({}, generateGetSetAction), { notApplicableReason: info.error })]
                }];
              }
              return ts3.emptyArray;
            }
          });
        })(generateGetAccessorAndSetAccessor = refactor2.generateGetAccessorAndSetAccessor || (refactor2.generateGetAccessorAndSetAccessor = {}));
      })(refactor = ts3.refactor || (ts3.refactor = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var refactor;
      (function(refactor2) {
        ;
        function isRefactorErrorInfo(info) {
          return info.error !== void 0;
        }
        refactor2.isRefactorErrorInfo = isRefactorErrorInfo;
        function refactorKindBeginsWith(known, requested) {
          if (!requested)
            return true;
          return known.substr(0, requested.length) === requested;
        }
        refactor2.refactorKindBeginsWith = refactorKindBeginsWith;
      })(refactor = ts3.refactor || (ts3.refactor = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var refactor;
      (function(refactor2) {
        var refactorName = "Move to a new file";
        var description = ts3.getLocaleSpecificMessage(ts3.Diagnostics.Move_to_a_new_file);
        var moveToNewFileAction = {
          name: refactorName,
          description,
          kind: "refactor.move.newFile"
        };
        refactor2.registerRefactor(refactorName, {
          kinds: [moveToNewFileAction.kind],
          getAvailableActions: function(context) {
            var statements = getStatementsToMove(context);
            if (context.preferences.allowTextChangesInNewFiles && statements) {
              return [{ name: refactorName, description, actions: [moveToNewFileAction] }];
            }
            if (context.preferences.provideRefactorNotApplicableReason) {
              return [{
                name: refactorName,
                description,
                actions: [__assign(__assign({}, moveToNewFileAction), { notApplicableReason: ts3.getLocaleSpecificMessage(ts3.Diagnostics.Selection_is_not_a_valid_statement_or_statements) })]
              }];
            }
            return ts3.emptyArray;
          },
          getEditsForAction: function(context, actionName) {
            ts3.Debug.assert(actionName === refactorName, "Wrong refactor invoked");
            var statements = ts3.Debug.checkDefined(getStatementsToMove(context));
            var edits = ts3.textChanges.ChangeTracker.with(context, function(t2) {
              return doChange(context.file, context.program, statements, t2, context.host, context.preferences);
            });
            return { edits, renameFilename: void 0, renameLocation: void 0 };
          }
        });
        function getRangeToMove(context) {
          var file = context.file;
          var range = ts3.createTextRangeFromSpan(ts3.getRefactorContextSpan(context));
          var statements = file.statements;
          var startNodeIndex = ts3.findIndex(statements, function(s2) {
            return s2.end > range.pos;
          });
          if (startNodeIndex === -1)
            return void 0;
          var startStatement = statements[startNodeIndex];
          if (ts3.isNamedDeclaration(startStatement) && startStatement.name && ts3.rangeContainsRange(startStatement.name, range)) {
            return { toMove: [statements[startNodeIndex]], afterLast: statements[startNodeIndex + 1] };
          }
          if (range.pos > startStatement.getStart(file))
            return void 0;
          var afterEndNodeIndex = ts3.findIndex(statements, function(s2) {
            return s2.end > range.end;
          }, startNodeIndex);
          if (afterEndNodeIndex !== -1 && (afterEndNodeIndex === 0 || statements[afterEndNodeIndex].getStart(file) < range.end))
            return void 0;
          return {
            toMove: statements.slice(startNodeIndex, afterEndNodeIndex === -1 ? statements.length : afterEndNodeIndex),
            afterLast: afterEndNodeIndex === -1 ? void 0 : statements[afterEndNodeIndex]
          };
        }
        function doChange(oldFile, program2, toMove, changes, host, preferences) {
          var checker = program2.getTypeChecker();
          var usage = getUsageInfo(oldFile, toMove.all, checker);
          var currentDirectory = ts3.getDirectoryPath(oldFile.fileName);
          var extension = ts3.extensionFromPath(oldFile.fileName);
          var newModuleName = makeUniqueModuleName(getNewModuleName(usage.movedSymbols), extension, currentDirectory, host);
          var newFileNameWithExtension = newModuleName + extension;
          changes.createNewFile(oldFile, ts3.combinePaths(currentDirectory, newFileNameWithExtension), getNewStatementsAndRemoveFromOldFile(oldFile, usage, changes, toMove, program2, newModuleName, preferences));
          addNewFileToTsconfig(program2, changes, oldFile.fileName, newFileNameWithExtension, ts3.hostGetCanonicalFileName(host));
        }
        function getStatementsToMove(context) {
          var rangeToMove = getRangeToMove(context);
          if (rangeToMove === void 0)
            return void 0;
          var all = [];
          var ranges = [];
          var toMove = rangeToMove.toMove, afterLast = rangeToMove.afterLast;
          ts3.getRangesWhere(toMove, isAllowedStatementToMove, function(start, afterEndIndex) {
            for (var i3 = start; i3 < afterEndIndex; i3++)
              all.push(toMove[i3]);
            ranges.push({ first: toMove[start], afterLast });
          });
          return all.length === 0 ? void 0 : { all, ranges };
        }
        function isAllowedStatementToMove(statement) {
          return !isPureImport(statement) && !ts3.isPrologueDirective(statement);
          ;
        }
        function isPureImport(node) {
          switch (node.kind) {
            case 262:
              return true;
            case 261:
              return !ts3.hasSyntacticModifier(node, 1);
            case 233:
              return node.declarationList.declarations.every(function(d) {
                return !!d.initializer && ts3.isRequireCall(d.initializer, true);
              });
            default:
              return false;
          }
        }
        function addNewFileToTsconfig(program2, changes, oldFileName, newFileNameWithExtension, getCanonicalFileName) {
          var cfg = program2.getCompilerOptions().configFile;
          if (!cfg)
            return;
          var newFileAbsolutePath = ts3.normalizePath(ts3.combinePaths(oldFileName, "..", newFileNameWithExtension));
          var newFilePath = ts3.getRelativePathFromFile(cfg.fileName, newFileAbsolutePath, getCanonicalFileName);
          var cfgObject = cfg.statements[0] && ts3.tryCast(cfg.statements[0].expression, ts3.isObjectLiteralExpression);
          var filesProp = cfgObject && ts3.find(cfgObject.properties, function(prop) {
            return ts3.isPropertyAssignment(prop) && ts3.isStringLiteral(prop.name) && prop.name.text === "files";
          });
          if (filesProp && ts3.isArrayLiteralExpression(filesProp.initializer)) {
            changes.insertNodeInListAfter(cfg, ts3.last(filesProp.initializer.elements), ts3.factory.createStringLiteral(newFilePath), filesProp.initializer.elements);
          }
        }
        function getNewStatementsAndRemoveFromOldFile(oldFile, usage, changes, toMove, program2, newModuleName, preferences) {
          var checker = program2.getTypeChecker();
          var prologueDirectives = ts3.takeWhile(oldFile.statements, ts3.isPrologueDirective);
          if (!oldFile.externalModuleIndicator && !oldFile.commonJsModuleIndicator) {
            deleteMovedStatements(oldFile, toMove.ranges, changes);
            return __spreadArray(__spreadArray([], prologueDirectives), toMove.all);
          }
          var useEs6ModuleSyntax = !!oldFile.externalModuleIndicator;
          var quotePreference = ts3.getQuotePreference(oldFile, preferences);
          var importsFromNewFile = createOldFileImportsFromNewFile(usage.oldFileImportsFromNewFile, newModuleName, useEs6ModuleSyntax, quotePreference);
          if (importsFromNewFile) {
            ts3.insertImports(changes, oldFile, importsFromNewFile, true);
          }
          deleteUnusedOldImports(oldFile, toMove.all, changes, usage.unusedImportsFromOldFile, checker);
          deleteMovedStatements(oldFile, toMove.ranges, changes);
          updateImportsInOtherFiles(changes, program2, oldFile, usage.movedSymbols, newModuleName);
          var imports = getNewFileImportsAndAddExportInOldFile(oldFile, usage.oldImportsNeededByNewFile, usage.newFileImportsFromOldFile, changes, checker, useEs6ModuleSyntax, quotePreference);
          var body = addExports(oldFile, toMove.all, usage.oldFileImportsFromNewFile, useEs6ModuleSyntax);
          if (imports.length && body.length) {
            return __spreadArray(__spreadArray(__spreadArray(__spreadArray([], prologueDirectives), imports), [
              4
            ]), body);
          }
          return __spreadArray(__spreadArray(__spreadArray([], prologueDirectives), imports), body);
        }
        function deleteMovedStatements(sourceFile, moved, changes) {
          for (var _i = 0, moved_1 = moved; _i < moved_1.length; _i++) {
            var _a2 = moved_1[_i], first_1 = _a2.first, afterLast = _a2.afterLast;
            changes.deleteNodeRangeExcludingEnd(sourceFile, first_1, afterLast);
          }
        }
        function deleteUnusedOldImports(oldFile, toMove, changes, toDelete, checker) {
          for (var _i = 0, _a2 = oldFile.statements; _i < _a2.length; _i++) {
            var statement = _a2[_i];
            if (ts3.contains(toMove, statement))
              continue;
            forEachImportInStatement(statement, function(i3) {
              return deleteUnusedImports(oldFile, i3, changes, function(name) {
                return toDelete.has(checker.getSymbolAtLocation(name));
              });
            });
          }
        }
        function updateImportsInOtherFiles(changes, program2, oldFile, movedSymbols, newModuleName) {
          var checker = program2.getTypeChecker();
          var _loop_18 = function(sourceFile2) {
            if (sourceFile2 === oldFile)
              return "continue";
            var _loop_19 = function(statement2) {
              forEachImportInStatement(statement2, function(importNode) {
                if (checker.getSymbolAtLocation(moduleSpecifierFromImport(importNode)) !== oldFile.symbol)
                  return;
                var shouldMove = function(name) {
                  var symbol = ts3.isBindingElement(name.parent) ? ts3.getPropertySymbolFromBindingElement(checker, name.parent) : ts3.skipAlias(checker.getSymbolAtLocation(name), checker);
                  return !!symbol && movedSymbols.has(symbol);
                };
                deleteUnusedImports(sourceFile2, importNode, changes, shouldMove);
                var newModuleSpecifier = ts3.combinePaths(ts3.getDirectoryPath(moduleSpecifierFromImport(importNode).text), newModuleName);
                var newImportDeclaration = filterImport(importNode, ts3.factory.createStringLiteral(newModuleSpecifier), shouldMove);
                if (newImportDeclaration)
                  changes.insertNodeAfter(sourceFile2, statement2, newImportDeclaration);
                var ns = getNamespaceLikeImport(importNode);
                if (ns)
                  updateNamespaceLikeImport(changes, sourceFile2, checker, movedSymbols, newModuleName, newModuleSpecifier, ns, importNode);
              });
            };
            for (var _b = 0, _c = sourceFile2.statements; _b < _c.length; _b++) {
              var statement = _c[_b];
              _loop_19(statement);
            }
          };
          for (var _i = 0, _a2 = program2.getSourceFiles(); _i < _a2.length; _i++) {
            var sourceFile = _a2[_i];
            _loop_18(sourceFile);
          }
        }
        function getNamespaceLikeImport(node) {
          switch (node.kind) {
            case 262:
              return node.importClause && node.importClause.namedBindings && node.importClause.namedBindings.kind === 264 ? node.importClause.namedBindings.name : void 0;
            case 261:
              return node.name;
            case 250:
              return ts3.tryCast(node.name, ts3.isIdentifier);
            default:
              return ts3.Debug.assertNever(node, "Unexpected node kind " + node.kind);
          }
        }
        function updateNamespaceLikeImport(changes, sourceFile, checker, movedSymbols, newModuleName, newModuleSpecifier, oldImportId, oldImportNode) {
          var preferredNewNamespaceName = ts3.codefix.moduleSpecifierToValidIdentifier(newModuleName, 99);
          var needUniqueName = false;
          var toChange = [];
          ts3.FindAllReferences.Core.eachSymbolReferenceInFile(oldImportId, checker, sourceFile, function(ref3) {
            if (!ts3.isPropertyAccessExpression(ref3.parent))
              return;
            needUniqueName = needUniqueName || !!checker.resolveName(preferredNewNamespaceName, ref3, 67108863, true);
            if (movedSymbols.has(checker.getSymbolAtLocation(ref3.parent.name))) {
              toChange.push(ref3);
            }
          });
          if (toChange.length) {
            var newNamespaceName = needUniqueName ? ts3.getUniqueName(preferredNewNamespaceName, sourceFile) : preferredNewNamespaceName;
            for (var _i = 0, toChange_1 = toChange; _i < toChange_1.length; _i++) {
              var ref2 = toChange_1[_i];
              changes.replaceNode(sourceFile, ref2, ts3.factory.createIdentifier(newNamespaceName));
            }
            changes.insertNodeAfter(sourceFile, oldImportNode, updateNamespaceLikeImportNode(oldImportNode, newModuleName, newModuleSpecifier));
          }
        }
        function updateNamespaceLikeImportNode(node, newNamespaceName, newModuleSpecifier) {
          var newNamespaceId = ts3.factory.createIdentifier(newNamespaceName);
          var newModuleString = ts3.factory.createStringLiteral(newModuleSpecifier);
          switch (node.kind) {
            case 262:
              return ts3.factory.createImportDeclaration(void 0, void 0, ts3.factory.createImportClause(false, void 0, ts3.factory.createNamespaceImport(newNamespaceId)), newModuleString);
            case 261:
              return ts3.factory.createImportEqualsDeclaration(void 0, void 0, false, newNamespaceId, ts3.factory.createExternalModuleReference(newModuleString));
            case 250:
              return ts3.factory.createVariableDeclaration(newNamespaceId, void 0, void 0, createRequireCall(newModuleString));
            default:
              return ts3.Debug.assertNever(node, "Unexpected node kind " + node.kind);
          }
        }
        function moduleSpecifierFromImport(i3) {
          return i3.kind === 262 ? i3.moduleSpecifier : i3.kind === 261 ? i3.moduleReference.expression : i3.initializer.arguments[0];
        }
        function forEachImportInStatement(statement, cb2) {
          if (ts3.isImportDeclaration(statement)) {
            if (ts3.isStringLiteral(statement.moduleSpecifier))
              cb2(statement);
          } else if (ts3.isImportEqualsDeclaration(statement)) {
            if (ts3.isExternalModuleReference(statement.moduleReference) && ts3.isStringLiteralLike(statement.moduleReference.expression)) {
              cb2(statement);
            }
          } else if (ts3.isVariableStatement(statement)) {
            for (var _i = 0, _a2 = statement.declarationList.declarations; _i < _a2.length; _i++) {
              var decl = _a2[_i];
              if (decl.initializer && ts3.isRequireCall(decl.initializer, true)) {
                cb2(decl);
              }
            }
          }
        }
        function createOldFileImportsFromNewFile(newFileNeedExport, newFileNameWithExtension, useEs6Imports, quotePreference) {
          var defaultImport;
          var imports = [];
          newFileNeedExport.forEach(function(symbol) {
            if (symbol.escapedName === "default") {
              defaultImport = ts3.factory.createIdentifier(ts3.symbolNameNoDefault(symbol));
            } else {
              imports.push(symbol.name);
            }
          });
          return makeImportOrRequire(defaultImport, imports, newFileNameWithExtension, useEs6Imports, quotePreference);
        }
        function makeImportOrRequire(defaultImport, imports, path2, useEs6Imports, quotePreference) {
          path2 = ts3.ensurePathIsNonModuleName(path2);
          if (useEs6Imports) {
            var specifiers = imports.map(function(i3) {
              return ts3.factory.createImportSpecifier(void 0, ts3.factory.createIdentifier(i3));
            });
            return ts3.makeImportIfNecessary(defaultImport, specifiers, path2, quotePreference);
          } else {
            ts3.Debug.assert(!defaultImport, "No default import should exist");
            var bindingElements = imports.map(function(i3) {
              return ts3.factory.createBindingElement(void 0, void 0, i3);
            });
            return bindingElements.length ? makeVariableStatement(ts3.factory.createObjectBindingPattern(bindingElements), void 0, createRequireCall(ts3.factory.createStringLiteral(path2))) : void 0;
          }
        }
        function makeVariableStatement(name, type3, initializer, flags) {
          if (flags === void 0) {
            flags = 2;
          }
          return ts3.factory.createVariableStatement(void 0, ts3.factory.createVariableDeclarationList([ts3.factory.createVariableDeclaration(name, void 0, type3, initializer)], flags));
        }
        function createRequireCall(moduleSpecifier) {
          return ts3.factory.createCallExpression(ts3.factory.createIdentifier("require"), void 0, [moduleSpecifier]);
        }
        function addExports(sourceFile, toMove, needExport, useEs6Exports) {
          return ts3.flatMap(toMove, function(statement) {
            if (isTopLevelDeclarationStatement(statement) && !isExported(sourceFile, statement, useEs6Exports) && forEachTopLevelDeclaration(statement, function(d) {
              return needExport.has(ts3.Debug.checkDefined(d.symbol));
            })) {
              var exports3 = addExport(statement, useEs6Exports);
              if (exports3)
                return exports3;
            }
            return statement;
          });
        }
        function deleteUnusedImports(sourceFile, importDecl, changes, isUnused) {
          switch (importDecl.kind) {
            case 262:
              deleteUnusedImportsInDeclaration(sourceFile, importDecl, changes, isUnused);
              break;
            case 261:
              if (isUnused(importDecl.name)) {
                changes.delete(sourceFile, importDecl);
              }
              break;
            case 250:
              deleteUnusedImportsInVariableDeclaration(sourceFile, importDecl, changes, isUnused);
              break;
            default:
              ts3.Debug.assertNever(importDecl, "Unexpected import decl kind " + importDecl.kind);
          }
        }
        function deleteUnusedImportsInDeclaration(sourceFile, importDecl, changes, isUnused) {
          if (!importDecl.importClause)
            return;
          var _a2 = importDecl.importClause, name = _a2.name, namedBindings = _a2.namedBindings;
          var defaultUnused = !name || isUnused(name);
          var namedBindingsUnused = !namedBindings || (namedBindings.kind === 264 ? isUnused(namedBindings.name) : namedBindings.elements.length !== 0 && namedBindings.elements.every(function(e2) {
            return isUnused(e2.name);
          }));
          if (defaultUnused && namedBindingsUnused) {
            changes.delete(sourceFile, importDecl);
          } else {
            if (name && defaultUnused) {
              changes.delete(sourceFile, name);
            }
            if (namedBindings) {
              if (namedBindingsUnused) {
                changes.replaceNode(sourceFile, importDecl.importClause, ts3.factory.updateImportClause(importDecl.importClause, importDecl.importClause.isTypeOnly, name, void 0));
              } else if (namedBindings.kind === 265) {
                for (var _i = 0, _b = namedBindings.elements; _i < _b.length; _i++) {
                  var element = _b[_i];
                  if (isUnused(element.name))
                    changes.delete(sourceFile, element);
                }
              }
            }
          }
        }
        function deleteUnusedImportsInVariableDeclaration(sourceFile, varDecl, changes, isUnused) {
          var name = varDecl.name;
          switch (name.kind) {
            case 78:
              if (isUnused(name)) {
                changes.delete(sourceFile, name);
              }
              break;
            case 198:
              break;
            case 197:
              if (name.elements.every(function(e2) {
                return ts3.isIdentifier(e2.name) && isUnused(e2.name);
              })) {
                changes.delete(sourceFile, ts3.isVariableDeclarationList(varDecl.parent) && varDecl.parent.declarations.length === 1 ? varDecl.parent.parent : varDecl);
              } else {
                for (var _i = 0, _a2 = name.elements; _i < _a2.length; _i++) {
                  var element = _a2[_i];
                  if (ts3.isIdentifier(element.name) && isUnused(element.name)) {
                    changes.delete(sourceFile, element.name);
                  }
                }
              }
              break;
          }
        }
        function getNewFileImportsAndAddExportInOldFile(oldFile, importsToCopy, newFileImportsFromOldFile, changes, checker, useEs6ModuleSyntax, quotePreference) {
          var copiedOldImports = [];
          for (var _i = 0, _a2 = oldFile.statements; _i < _a2.length; _i++) {
            var oldStatement = _a2[_i];
            forEachImportInStatement(oldStatement, function(i3) {
              ts3.append(copiedOldImports, filterImport(i3, moduleSpecifierFromImport(i3), function(name) {
                return importsToCopy.has(checker.getSymbolAtLocation(name));
              }));
            });
          }
          var oldFileDefault;
          var oldFileNamedImports = [];
          var markSeenTop = ts3.nodeSeenTracker();
          newFileImportsFromOldFile.forEach(function(symbol) {
            if (!symbol.declarations) {
              return;
            }
            for (var _i2 = 0, _a3 = symbol.declarations; _i2 < _a3.length; _i2++) {
              var decl = _a3[_i2];
              if (!isTopLevelDeclaration(decl))
                continue;
              var name = nameOfTopLevelDeclaration(decl);
              if (!name)
                continue;
              var top = getTopLevelDeclarationStatement(decl);
              if (markSeenTop(top)) {
                addExportToChanges(oldFile, top, changes, useEs6ModuleSyntax);
              }
              if (ts3.hasSyntacticModifier(decl, 512)) {
                oldFileDefault = name;
              } else {
                oldFileNamedImports.push(name.text);
              }
            }
          });
          ts3.append(copiedOldImports, makeImportOrRequire(oldFileDefault, oldFileNamedImports, ts3.removeFileExtension(ts3.getBaseFileName(oldFile.fileName)), useEs6ModuleSyntax, quotePreference));
          return copiedOldImports;
        }
        function makeUniqueModuleName(moduleName, extension, inDirectory, host) {
          var newModuleName = moduleName;
          for (var i3 = 1; ; i3++) {
            var name = ts3.combinePaths(inDirectory, newModuleName + extension);
            if (!host.fileExists(name))
              return newModuleName;
            newModuleName = moduleName + "." + i3;
          }
        }
        function getNewModuleName(movedSymbols) {
          return movedSymbols.forEachEntry(ts3.symbolNameNoDefault) || "newFile";
        }
        function getUsageInfo(oldFile, toMove, checker) {
          var movedSymbols = new SymbolSet();
          var oldImportsNeededByNewFile = new SymbolSet();
          var newFileImportsFromOldFile = new SymbolSet();
          var containsJsx = ts3.find(toMove, function(statement2) {
            return !!(statement2.transformFlags & 2);
          });
          var jsxNamespaceSymbol = getJsxNamespaceSymbol(containsJsx);
          if (jsxNamespaceSymbol) {
            oldImportsNeededByNewFile.add(jsxNamespaceSymbol);
          }
          for (var _i = 0, toMove_1 = toMove; _i < toMove_1.length; _i++) {
            var statement = toMove_1[_i];
            forEachTopLevelDeclaration(statement, function(decl) {
              movedSymbols.add(ts3.Debug.checkDefined(ts3.isExpressionStatement(decl) ? checker.getSymbolAtLocation(decl.expression.left) : decl.symbol, "Need a symbol here"));
            });
          }
          for (var _a2 = 0, toMove_2 = toMove; _a2 < toMove_2.length; _a2++) {
            var statement = toMove_2[_a2];
            forEachReference(statement, checker, function(symbol) {
              if (!symbol.declarations)
                return;
              for (var _i2 = 0, _a3 = symbol.declarations; _i2 < _a3.length; _i2++) {
                var decl = _a3[_i2];
                if (isInImport(decl)) {
                  oldImportsNeededByNewFile.add(symbol);
                } else if (isTopLevelDeclaration(decl) && sourceFileOfTopLevelDeclaration(decl) === oldFile && !movedSymbols.has(symbol)) {
                  newFileImportsFromOldFile.add(symbol);
                }
              }
            });
          }
          var unusedImportsFromOldFile = oldImportsNeededByNewFile.clone();
          var oldFileImportsFromNewFile = new SymbolSet();
          for (var _b = 0, _c = oldFile.statements; _b < _c.length; _b++) {
            var statement = _c[_b];
            if (ts3.contains(toMove, statement))
              continue;
            if (jsxNamespaceSymbol && !!(statement.transformFlags & 2)) {
              unusedImportsFromOldFile.delete(jsxNamespaceSymbol);
            }
            forEachReference(statement, checker, function(symbol) {
              if (movedSymbols.has(symbol))
                oldFileImportsFromNewFile.add(symbol);
              unusedImportsFromOldFile.delete(symbol);
            });
          }
          return { movedSymbols, newFileImportsFromOldFile, oldFileImportsFromNewFile, oldImportsNeededByNewFile, unusedImportsFromOldFile };
          function getJsxNamespaceSymbol(containsJsx2) {
            if (containsJsx2 === void 0) {
              return void 0;
            }
            var jsxNamespace = checker.getJsxNamespace(containsJsx2);
            var jsxNamespaceSymbol2 = checker.resolveName(jsxNamespace, containsJsx2, 1920, true);
            return !!jsxNamespaceSymbol2 && ts3.some(jsxNamespaceSymbol2.declarations, isInImport) ? jsxNamespaceSymbol2 : void 0;
          }
        }
        function isInImport(decl) {
          switch (decl.kind) {
            case 261:
            case 266:
            case 263:
            case 264:
              return true;
            case 250:
              return isVariableDeclarationInImport(decl);
            case 199:
              return ts3.isVariableDeclaration(decl.parent.parent) && isVariableDeclarationInImport(decl.parent.parent);
            default:
              return false;
          }
        }
        function isVariableDeclarationInImport(decl) {
          return ts3.isSourceFile(decl.parent.parent.parent) && !!decl.initializer && ts3.isRequireCall(decl.initializer, true);
        }
        function filterImport(i3, moduleSpecifier, keep) {
          switch (i3.kind) {
            case 262: {
              var clause = i3.importClause;
              if (!clause)
                return void 0;
              var defaultImport = clause.name && keep(clause.name) ? clause.name : void 0;
              var namedBindings = clause.namedBindings && filterNamedBindings(clause.namedBindings, keep);
              return defaultImport || namedBindings ? ts3.factory.createImportDeclaration(void 0, void 0, ts3.factory.createImportClause(false, defaultImport, namedBindings), moduleSpecifier) : void 0;
            }
            case 261:
              return keep(i3.name) ? i3 : void 0;
            case 250: {
              var name = filterBindingName(i3.name, keep);
              return name ? makeVariableStatement(name, i3.type, createRequireCall(moduleSpecifier), i3.parent.flags) : void 0;
            }
            default:
              return ts3.Debug.assertNever(i3, "Unexpected import kind " + i3.kind);
          }
        }
        function filterNamedBindings(namedBindings, keep) {
          if (namedBindings.kind === 264) {
            return keep(namedBindings.name) ? namedBindings : void 0;
          } else {
            var newElements = namedBindings.elements.filter(function(e2) {
              return keep(e2.name);
            });
            return newElements.length ? ts3.factory.createNamedImports(newElements) : void 0;
          }
        }
        function filterBindingName(name, keep) {
          switch (name.kind) {
            case 78:
              return keep(name) ? name : void 0;
            case 198:
              return name;
            case 197: {
              var newElements = name.elements.filter(function(prop) {
                return prop.propertyName || !ts3.isIdentifier(prop.name) || keep(prop.name);
              });
              return newElements.length ? ts3.factory.createObjectBindingPattern(newElements) : void 0;
            }
          }
        }
        function forEachReference(node, checker, onReference) {
          node.forEachChild(function cb2(node2) {
            if (ts3.isIdentifier(node2) && !ts3.isDeclarationName(node2)) {
              var sym = checker.getSymbolAtLocation(node2);
              if (sym)
                onReference(sym);
            } else {
              node2.forEachChild(cb2);
            }
          });
        }
        var SymbolSet = function() {
          function SymbolSet2() {
            this.map = new ts3.Map();
          }
          SymbolSet2.prototype.add = function(symbol) {
            this.map.set(String(ts3.getSymbolId(symbol)), symbol);
          };
          SymbolSet2.prototype.has = function(symbol) {
            return this.map.has(String(ts3.getSymbolId(symbol)));
          };
          SymbolSet2.prototype.delete = function(symbol) {
            this.map.delete(String(ts3.getSymbolId(symbol)));
          };
          SymbolSet2.prototype.forEach = function(cb2) {
            this.map.forEach(cb2);
          };
          SymbolSet2.prototype.forEachEntry = function(cb2) {
            return ts3.forEachEntry(this.map, cb2);
          };
          SymbolSet2.prototype.clone = function() {
            var clone = new SymbolSet2();
            ts3.copyEntries(this.map, clone.map);
            return clone;
          };
          return SymbolSet2;
        }();
        function isTopLevelDeclaration(node) {
          return isNonVariableTopLevelDeclaration(node) && ts3.isSourceFile(node.parent) || ts3.isVariableDeclaration(node) && ts3.isSourceFile(node.parent.parent.parent);
        }
        function sourceFileOfTopLevelDeclaration(node) {
          return ts3.isVariableDeclaration(node) ? node.parent.parent.parent : node.parent;
        }
        function isTopLevelDeclarationStatement(node) {
          ts3.Debug.assert(ts3.isSourceFile(node.parent), "Node parent should be a SourceFile");
          return isNonVariableTopLevelDeclaration(node) || ts3.isVariableStatement(node);
        }
        function isNonVariableTopLevelDeclaration(node) {
          switch (node.kind) {
            case 252:
            case 253:
            case 257:
            case 256:
            case 255:
            case 254:
            case 261:
              return true;
            default:
              return false;
          }
        }
        function forEachTopLevelDeclaration(statement, cb2) {
          switch (statement.kind) {
            case 252:
            case 253:
            case 257:
            case 256:
            case 255:
            case 254:
            case 261:
              return cb2(statement);
            case 233:
              return ts3.firstDefined(statement.declarationList.declarations, function(decl) {
                return forEachTopLevelDeclarationInBindingName(decl.name, cb2);
              });
            case 234: {
              var expression = statement.expression;
              return ts3.isBinaryExpression(expression) && ts3.getAssignmentDeclarationKind(expression) === 1 ? cb2(statement) : void 0;
            }
          }
        }
        function forEachTopLevelDeclarationInBindingName(name, cb2) {
          switch (name.kind) {
            case 78:
              return cb2(ts3.cast(name.parent, function(x) {
                return ts3.isVariableDeclaration(x) || ts3.isBindingElement(x);
              }));
            case 198:
            case 197:
              return ts3.firstDefined(name.elements, function(em) {
                return ts3.isOmittedExpression(em) ? void 0 : forEachTopLevelDeclarationInBindingName(em.name, cb2);
              });
            default:
              return ts3.Debug.assertNever(name, "Unexpected name kind " + name.kind);
          }
        }
        function nameOfTopLevelDeclaration(d) {
          return ts3.isExpressionStatement(d) ? ts3.tryCast(d.expression.left.name, ts3.isIdentifier) : ts3.tryCast(d.name, ts3.isIdentifier);
        }
        function getTopLevelDeclarationStatement(d) {
          switch (d.kind) {
            case 250:
              return d.parent.parent;
            case 199:
              return getTopLevelDeclarationStatement(ts3.cast(d.parent.parent, function(p) {
                return ts3.isVariableDeclaration(p) || ts3.isBindingElement(p);
              }));
            default:
              return d;
          }
        }
        function addExportToChanges(sourceFile, decl, changes, useEs6Exports) {
          if (isExported(sourceFile, decl, useEs6Exports))
            return;
          if (useEs6Exports) {
            if (!ts3.isExpressionStatement(decl))
              changes.insertExportModifier(sourceFile, decl);
          } else {
            var names = getNamesToExportInCommonJS(decl);
            if (names.length !== 0)
              changes.insertNodesAfter(sourceFile, decl, names.map(createExportAssignment));
          }
        }
        function isExported(sourceFile, decl, useEs6Exports) {
          if (useEs6Exports) {
            return !ts3.isExpressionStatement(decl) && ts3.hasSyntacticModifier(decl, 1);
          } else {
            return getNamesToExportInCommonJS(decl).some(function(name) {
              return sourceFile.symbol.exports.has(ts3.escapeLeadingUnderscores(name));
            });
          }
        }
        function addExport(decl, useEs6Exports) {
          return useEs6Exports ? [addEs6Export(decl)] : addCommonjsExport(decl);
        }
        function addEs6Export(d) {
          var modifiers = ts3.concatenate([ts3.factory.createModifier(92)], d.modifiers);
          switch (d.kind) {
            case 252:
              return ts3.factory.updateFunctionDeclaration(d, d.decorators, modifiers, d.asteriskToken, d.name, d.typeParameters, d.parameters, d.type, d.body);
            case 253:
              return ts3.factory.updateClassDeclaration(d, d.decorators, modifiers, d.name, d.typeParameters, d.heritageClauses, d.members);
            case 233:
              return ts3.factory.updateVariableStatement(d, modifiers, d.declarationList);
            case 257:
              return ts3.factory.updateModuleDeclaration(d, d.decorators, modifiers, d.name, d.body);
            case 256:
              return ts3.factory.updateEnumDeclaration(d, d.decorators, modifiers, d.name, d.members);
            case 255:
              return ts3.factory.updateTypeAliasDeclaration(d, d.decorators, modifiers, d.name, d.typeParameters, d.type);
            case 254:
              return ts3.factory.updateInterfaceDeclaration(d, d.decorators, modifiers, d.name, d.typeParameters, d.heritageClauses, d.members);
            case 261:
              return ts3.factory.updateImportEqualsDeclaration(d, d.decorators, modifiers, d.isTypeOnly, d.name, d.moduleReference);
            case 234:
              return ts3.Debug.fail();
            default:
              return ts3.Debug.assertNever(d, "Unexpected declaration kind " + d.kind);
          }
        }
        function addCommonjsExport(decl) {
          return __spreadArray([decl], getNamesToExportInCommonJS(decl).map(createExportAssignment));
        }
        function getNamesToExportInCommonJS(decl) {
          switch (decl.kind) {
            case 252:
            case 253:
              return [decl.name.text];
            case 233:
              return ts3.mapDefined(decl.declarationList.declarations, function(d) {
                return ts3.isIdentifier(d.name) ? d.name.text : void 0;
              });
            case 257:
            case 256:
            case 255:
            case 254:
            case 261:
              return ts3.emptyArray;
            case 234:
              return ts3.Debug.fail("Can't export an ExpressionStatement");
            default:
              return ts3.Debug.assertNever(decl, "Unexpected decl kind " + decl.kind);
          }
        }
        function createExportAssignment(name) {
          return ts3.factory.createExpressionStatement(ts3.factory.createBinaryExpression(ts3.factory.createPropertyAccessExpression(ts3.factory.createIdentifier("exports"), ts3.factory.createIdentifier(name)), 62, ts3.factory.createIdentifier(name)));
        }
      })(refactor = ts3.refactor || (ts3.refactor = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var refactor;
      (function(refactor2) {
        var addOrRemoveBracesToArrowFunction;
        (function(addOrRemoveBracesToArrowFunction2) {
          var refactorName = "Add or remove braces in an arrow function";
          var refactorDescription = ts3.Diagnostics.Add_or_remove_braces_in_an_arrow_function.message;
          var addBracesAction = {
            name: "Add braces to arrow function",
            description: ts3.Diagnostics.Add_braces_to_arrow_function.message,
            kind: "refactor.rewrite.arrow.braces.add"
          };
          var removeBracesAction = {
            name: "Remove braces from arrow function",
            description: ts3.Diagnostics.Remove_braces_from_arrow_function.message,
            kind: "refactor.rewrite.arrow.braces.remove"
          };
          refactor2.registerRefactor(refactorName, {
            kinds: [removeBracesAction.kind],
            getEditsForAction,
            getAvailableActions
          });
          function getAvailableActions(context) {
            var file = context.file, startPosition = context.startPosition, triggerReason = context.triggerReason;
            var info = getConvertibleArrowFunctionAtPosition(file, startPosition, triggerReason === "invoked");
            if (!info)
              return ts3.emptyArray;
            if (!refactor2.isRefactorErrorInfo(info)) {
              return [{
                name: refactorName,
                description: refactorDescription,
                actions: [
                  info.addBraces ? addBracesAction : removeBracesAction
                ]
              }];
            }
            if (context.preferences.provideRefactorNotApplicableReason) {
              return [{
                name: refactorName,
                description: refactorDescription,
                actions: [
                  __assign(__assign({}, addBracesAction), { notApplicableReason: info.error }),
                  __assign(__assign({}, removeBracesAction), { notApplicableReason: info.error })
                ]
              }];
            }
            return ts3.emptyArray;
          }
          function getEditsForAction(context, actionName) {
            var file = context.file, startPosition = context.startPosition;
            var info = getConvertibleArrowFunctionAtPosition(file, startPosition);
            ts3.Debug.assert(info && !refactor2.isRefactorErrorInfo(info), "Expected applicable refactor info");
            var expression = info.expression, returnStatement = info.returnStatement, func2 = info.func;
            var body;
            if (actionName === addBracesAction.name) {
              var returnStatement_1 = ts3.factory.createReturnStatement(expression);
              body = ts3.factory.createBlock([returnStatement_1], true);
              ts3.suppressLeadingAndTrailingTrivia(body);
              ts3.copyLeadingComments(expression, returnStatement_1, file, 3, true);
            } else if (actionName === removeBracesAction.name && returnStatement) {
              var actualExpression = expression || ts3.factory.createVoidZero();
              body = ts3.needsParentheses(actualExpression) ? ts3.factory.createParenthesizedExpression(actualExpression) : actualExpression;
              ts3.suppressLeadingAndTrailingTrivia(body);
              ts3.copyTrailingAsLeadingComments(returnStatement, body, file, 3, false);
              ts3.copyLeadingComments(returnStatement, body, file, 3, false);
              ts3.copyTrailingComments(returnStatement, body, file, 3, false);
            } else {
              ts3.Debug.fail("invalid action");
            }
            var edits = ts3.textChanges.ChangeTracker.with(context, function(t2) {
              t2.replaceNode(file, func2.body, body);
            });
            return { renameFilename: void 0, renameLocation: void 0, edits };
          }
          function getConvertibleArrowFunctionAtPosition(file, startPosition, considerFunctionBodies, kind) {
            if (considerFunctionBodies === void 0) {
              considerFunctionBodies = true;
            }
            var node = ts3.getTokenAtPosition(file, startPosition);
            var func2 = ts3.getContainingFunction(node);
            if (!func2) {
              return {
                error: ts3.getLocaleSpecificMessage(ts3.Diagnostics.Could_not_find_a_containing_arrow_function)
              };
            }
            if (!ts3.isArrowFunction(func2)) {
              return {
                error: ts3.getLocaleSpecificMessage(ts3.Diagnostics.Containing_function_is_not_an_arrow_function)
              };
            }
            if (!ts3.rangeContainsRange(func2, node) || ts3.rangeContainsRange(func2.body, node) && !considerFunctionBodies) {
              return void 0;
            }
            if (refactor2.refactorKindBeginsWith(addBracesAction.kind, kind) && ts3.isExpression(func2.body)) {
              return { func: func2, addBraces: true, expression: func2.body };
            } else if (refactor2.refactorKindBeginsWith(removeBracesAction.kind, kind) && ts3.isBlock(func2.body) && func2.body.statements.length === 1) {
              var firstStatement = ts3.first(func2.body.statements);
              if (ts3.isReturnStatement(firstStatement)) {
                return { func: func2, addBraces: false, expression: firstStatement.expression, returnStatement: firstStatement };
              }
            }
            return void 0;
          }
        })(addOrRemoveBracesToArrowFunction = refactor2.addOrRemoveBracesToArrowFunction || (refactor2.addOrRemoveBracesToArrowFunction = {}));
      })(refactor = ts3.refactor || (ts3.refactor = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var refactor;
      (function(refactor2) {
        var convertParamsToDestructuredObject;
        (function(convertParamsToDestructuredObject2) {
          var refactorName = "Convert parameters to destructured object";
          var minimumParameterLength = 2;
          var refactorDescription = ts3.getLocaleSpecificMessage(ts3.Diagnostics.Convert_parameters_to_destructured_object);
          var toDestructuredAction = {
            name: refactorName,
            description: refactorDescription,
            kind: "refactor.rewrite.parameters.toDestructured"
          };
          refactor2.registerRefactor(refactorName, {
            kinds: [toDestructuredAction.kind],
            getEditsForAction,
            getAvailableActions
          });
          function getAvailableActions(context) {
            var file = context.file, startPosition = context.startPosition;
            var isJSFile = ts3.isSourceFileJS(file);
            if (isJSFile)
              return ts3.emptyArray;
            var functionDeclaration = getFunctionDeclarationAtPosition(file, startPosition, context.program.getTypeChecker());
            if (!functionDeclaration)
              return ts3.emptyArray;
            return [{
              name: refactorName,
              description: refactorDescription,
              actions: [toDestructuredAction]
            }];
          }
          function getEditsForAction(context, actionName) {
            ts3.Debug.assert(actionName === refactorName, "Unexpected action name");
            var file = context.file, startPosition = context.startPosition, program2 = context.program, cancellationToken = context.cancellationToken, host = context.host;
            var functionDeclaration = getFunctionDeclarationAtPosition(file, startPosition, program2.getTypeChecker());
            if (!functionDeclaration || !cancellationToken)
              return void 0;
            var groupedReferences = getGroupedReferences(functionDeclaration, program2, cancellationToken);
            if (groupedReferences.valid) {
              var edits = ts3.textChanges.ChangeTracker.with(context, function(t2) {
                return doChange(file, program2, host, t2, functionDeclaration, groupedReferences);
              });
              return { renameFilename: void 0, renameLocation: void 0, edits };
            }
            return { edits: [] };
          }
          function doChange(sourceFile, program2, host, changes, functionDeclaration, groupedReferences) {
            var signature = groupedReferences.signature;
            var newFunctionDeclarationParams = ts3.map(createNewParameters(functionDeclaration, program2, host), function(param) {
              return ts3.getSynthesizedDeepClone(param);
            });
            if (signature) {
              var newSignatureParams = ts3.map(createNewParameters(signature, program2, host), function(param) {
                return ts3.getSynthesizedDeepClone(param);
              });
              replaceParameters(signature, newSignatureParams);
            }
            replaceParameters(functionDeclaration, newFunctionDeclarationParams);
            var functionCalls = ts3.sortAndDeduplicate(groupedReferences.functionCalls, function(a2, b2) {
              return ts3.compareValues(a2.pos, b2.pos);
            });
            for (var _i = 0, functionCalls_1 = functionCalls; _i < functionCalls_1.length; _i++) {
              var call = functionCalls_1[_i];
              if (call.arguments && call.arguments.length) {
                var newArgument = ts3.getSynthesizedDeepClone(createNewArgument(functionDeclaration, call.arguments), true);
                changes.replaceNodeRange(ts3.getSourceFileOfNode(call), ts3.first(call.arguments), ts3.last(call.arguments), newArgument, { leadingTriviaOption: ts3.textChanges.LeadingTriviaOption.IncludeAll, trailingTriviaOption: ts3.textChanges.TrailingTriviaOption.Include });
              }
            }
            function replaceParameters(declarationOrSignature, parameterDeclarations) {
              changes.replaceNodeRangeWithNodes(sourceFile, ts3.first(declarationOrSignature.parameters), ts3.last(declarationOrSignature.parameters), parameterDeclarations, {
                joiner: ", ",
                indentation: 0,
                leadingTriviaOption: ts3.textChanges.LeadingTriviaOption.IncludeAll,
                trailingTriviaOption: ts3.textChanges.TrailingTriviaOption.Include
              });
            }
          }
          function getGroupedReferences(functionDeclaration, program2, cancellationToken) {
            var functionNames = getFunctionNames(functionDeclaration);
            var classNames = ts3.isConstructorDeclaration(functionDeclaration) ? getClassNames(functionDeclaration) : [];
            var names = ts3.deduplicate(__spreadArray(__spreadArray([], functionNames), classNames), ts3.equateValues);
            var checker = program2.getTypeChecker();
            var references = ts3.flatMap(names, function(name) {
              return ts3.FindAllReferences.getReferenceEntriesForNode(-1, name, program2, program2.getSourceFiles(), cancellationToken);
            });
            var groupedReferences = groupReferences(references);
            if (!ts3.every(groupedReferences.declarations, function(decl) {
              return ts3.contains(names, decl);
            })) {
              groupedReferences.valid = false;
            }
            return groupedReferences;
            function groupReferences(referenceEntries) {
              var classReferences = { accessExpressions: [], typeUsages: [] };
              var groupedReferences2 = { functionCalls: [], declarations: [], classReferences, valid: true };
              var functionSymbols = ts3.map(functionNames, getSymbolTargetAtLocation);
              var classSymbols = ts3.map(classNames, getSymbolTargetAtLocation);
              var isConstructor = ts3.isConstructorDeclaration(functionDeclaration);
              var contextualSymbols = ts3.map(functionNames, function(name) {
                return getSymbolForContextualType(name, checker);
              });
              for (var _i = 0, referenceEntries_1 = referenceEntries; _i < referenceEntries_1.length; _i++) {
                var entry = referenceEntries_1[_i];
                if (entry.kind === 0) {
                  groupedReferences2.valid = false;
                  continue;
                }
                if (ts3.contains(contextualSymbols, getSymbolTargetAtLocation(entry.node))) {
                  if (isValidMethodSignature(entry.node.parent)) {
                    groupedReferences2.signature = entry.node.parent;
                    continue;
                  }
                  var call = entryToFunctionCall(entry);
                  if (call) {
                    groupedReferences2.functionCalls.push(call);
                    continue;
                  }
                }
                var contextualSymbol = getSymbolForContextualType(entry.node, checker);
                if (contextualSymbol && ts3.contains(contextualSymbols, contextualSymbol)) {
                  var decl = entryToDeclaration(entry);
                  if (decl) {
                    groupedReferences2.declarations.push(decl);
                    continue;
                  }
                }
                if (ts3.contains(functionSymbols, getSymbolTargetAtLocation(entry.node)) || ts3.isNewExpressionTarget(entry.node)) {
                  var importOrExportReference = entryToImportOrExport(entry);
                  if (importOrExportReference) {
                    continue;
                  }
                  var decl = entryToDeclaration(entry);
                  if (decl) {
                    groupedReferences2.declarations.push(decl);
                    continue;
                  }
                  var call = entryToFunctionCall(entry);
                  if (call) {
                    groupedReferences2.functionCalls.push(call);
                    continue;
                  }
                }
                if (isConstructor && ts3.contains(classSymbols, getSymbolTargetAtLocation(entry.node))) {
                  var importOrExportReference = entryToImportOrExport(entry);
                  if (importOrExportReference) {
                    continue;
                  }
                  var decl = entryToDeclaration(entry);
                  if (decl) {
                    groupedReferences2.declarations.push(decl);
                    continue;
                  }
                  var accessExpression = entryToAccessExpression(entry);
                  if (accessExpression) {
                    classReferences.accessExpressions.push(accessExpression);
                    continue;
                  }
                  if (ts3.isClassDeclaration(functionDeclaration.parent)) {
                    var type3 = entryToType(entry);
                    if (type3) {
                      classReferences.typeUsages.push(type3);
                      continue;
                    }
                  }
                }
                groupedReferences2.valid = false;
              }
              return groupedReferences2;
            }
            function getSymbolTargetAtLocation(node) {
              var symbol = checker.getSymbolAtLocation(node);
              return symbol && ts3.getSymbolTarget(symbol, checker);
            }
          }
          function getSymbolForContextualType(node, checker) {
            var element = ts3.getContainingObjectLiteralElement(node);
            if (element) {
              var contextualType = checker.getContextualTypeForObjectLiteralElement(element);
              var symbol = contextualType === null || contextualType === void 0 ? void 0 : contextualType.getSymbol();
              if (symbol && !(ts3.getCheckFlags(symbol) & 6)) {
                return symbol;
              }
            }
          }
          function entryToImportOrExport(entry) {
            var node = entry.node;
            if (ts3.isImportSpecifier(node.parent) || ts3.isImportClause(node.parent) || ts3.isImportEqualsDeclaration(node.parent) || ts3.isNamespaceImport(node.parent)) {
              return node;
            }
            if (ts3.isExportSpecifier(node.parent) || ts3.isExportAssignment(node.parent)) {
              return node;
            }
            return void 0;
          }
          function entryToDeclaration(entry) {
            if (ts3.isDeclaration(entry.node.parent)) {
              return entry.node;
            }
            return void 0;
          }
          function entryToFunctionCall(entry) {
            if (entry.node.parent) {
              var functionReference = entry.node;
              var parent = functionReference.parent;
              switch (parent.kind) {
                case 204:
                case 205:
                  var callOrNewExpression = ts3.tryCast(parent, ts3.isCallOrNewExpression);
                  if (callOrNewExpression && callOrNewExpression.expression === functionReference) {
                    return callOrNewExpression;
                  }
                  break;
                case 202:
                  var propertyAccessExpression = ts3.tryCast(parent, ts3.isPropertyAccessExpression);
                  if (propertyAccessExpression && propertyAccessExpression.parent && propertyAccessExpression.name === functionReference) {
                    var callOrNewExpression_1 = ts3.tryCast(propertyAccessExpression.parent, ts3.isCallOrNewExpression);
                    if (callOrNewExpression_1 && callOrNewExpression_1.expression === propertyAccessExpression) {
                      return callOrNewExpression_1;
                    }
                  }
                  break;
                case 203:
                  var elementAccessExpression = ts3.tryCast(parent, ts3.isElementAccessExpression);
                  if (elementAccessExpression && elementAccessExpression.parent && elementAccessExpression.argumentExpression === functionReference) {
                    var callOrNewExpression_2 = ts3.tryCast(elementAccessExpression.parent, ts3.isCallOrNewExpression);
                    if (callOrNewExpression_2 && callOrNewExpression_2.expression === elementAccessExpression) {
                      return callOrNewExpression_2;
                    }
                  }
                  break;
              }
            }
            return void 0;
          }
          function entryToAccessExpression(entry) {
            if (entry.node.parent) {
              var reference = entry.node;
              var parent = reference.parent;
              switch (parent.kind) {
                case 202:
                  var propertyAccessExpression = ts3.tryCast(parent, ts3.isPropertyAccessExpression);
                  if (propertyAccessExpression && propertyAccessExpression.expression === reference) {
                    return propertyAccessExpression;
                  }
                  break;
                case 203:
                  var elementAccessExpression = ts3.tryCast(parent, ts3.isElementAccessExpression);
                  if (elementAccessExpression && elementAccessExpression.expression === reference) {
                    return elementAccessExpression;
                  }
                  break;
              }
            }
            return void 0;
          }
          function entryToType(entry) {
            var reference = entry.node;
            if (ts3.getMeaningFromLocation(reference) === 2 || ts3.isExpressionWithTypeArgumentsInClassExtendsClause(reference.parent)) {
              return reference;
            }
            return void 0;
          }
          function getFunctionDeclarationAtPosition(file, startPosition, checker) {
            var node = ts3.getTouchingToken(file, startPosition);
            var functionDeclaration = ts3.getContainingFunctionDeclaration(node);
            if (isTopLevelJSDoc(node))
              return void 0;
            if (functionDeclaration && isValidFunctionDeclaration(functionDeclaration, checker) && ts3.rangeContainsRange(functionDeclaration, node) && !(functionDeclaration.body && ts3.rangeContainsRange(functionDeclaration.body, node)))
              return functionDeclaration;
            return void 0;
          }
          function isTopLevelJSDoc(node) {
            var containingJSDoc = ts3.findAncestor(node, ts3.isJSDocNode);
            if (containingJSDoc) {
              var containingNonJSDoc = ts3.findAncestor(containingJSDoc, function(n2) {
                return !ts3.isJSDocNode(n2);
              });
              return !!containingNonJSDoc && ts3.isFunctionLikeDeclaration(containingNonJSDoc);
            }
            return false;
          }
          function isValidMethodSignature(node) {
            return ts3.isMethodSignature(node) && (ts3.isInterfaceDeclaration(node.parent) || ts3.isTypeLiteralNode(node.parent));
          }
          function isValidFunctionDeclaration(functionDeclaration, checker) {
            var _a2;
            if (!isValidParameterNodeArray(functionDeclaration.parameters, checker))
              return false;
            switch (functionDeclaration.kind) {
              case 252:
                return hasNameOrDefault(functionDeclaration) && isSingleImplementation(functionDeclaration, checker);
              case 166:
                if (ts3.isObjectLiteralExpression(functionDeclaration.parent)) {
                  var contextualSymbol = getSymbolForContextualType(functionDeclaration.name, checker);
                  return ((_a2 = contextualSymbol === null || contextualSymbol === void 0 ? void 0 : contextualSymbol.declarations) === null || _a2 === void 0 ? void 0 : _a2.length) === 1 && isSingleImplementation(functionDeclaration, checker);
                }
                return isSingleImplementation(functionDeclaration, checker);
              case 167:
                if (ts3.isClassDeclaration(functionDeclaration.parent)) {
                  return hasNameOrDefault(functionDeclaration.parent) && isSingleImplementation(functionDeclaration, checker);
                } else {
                  return isValidVariableDeclaration(functionDeclaration.parent.parent) && isSingleImplementation(functionDeclaration, checker);
                }
              case 209:
              case 210:
                return isValidVariableDeclaration(functionDeclaration.parent);
            }
            return false;
          }
          function isSingleImplementation(functionDeclaration, checker) {
            return !!functionDeclaration.body && !checker.isImplementationOfOverload(functionDeclaration);
          }
          function hasNameOrDefault(functionOrClassDeclaration) {
            if (!functionOrClassDeclaration.name) {
              var defaultKeyword = ts3.findModifier(functionOrClassDeclaration, 87);
              return !!defaultKeyword;
            }
            return true;
          }
          function isValidParameterNodeArray(parameters, checker) {
            return getRefactorableParametersLength(parameters) >= minimumParameterLength && ts3.every(parameters, function(paramDecl) {
              return isValidParameterDeclaration(paramDecl, checker);
            });
          }
          function isValidParameterDeclaration(parameterDeclaration, checker) {
            if (ts3.isRestParameter(parameterDeclaration)) {
              var type3 = checker.getTypeAtLocation(parameterDeclaration);
              if (!checker.isArrayType(type3) && !checker.isTupleType(type3))
                return false;
            }
            return !parameterDeclaration.modifiers && !parameterDeclaration.decorators && ts3.isIdentifier(parameterDeclaration.name);
          }
          function isValidVariableDeclaration(node) {
            return ts3.isVariableDeclaration(node) && ts3.isVarConst(node) && ts3.isIdentifier(node.name) && !node.type;
          }
          function hasThisParameter(parameters) {
            return parameters.length > 0 && ts3.isThis(parameters[0].name);
          }
          function getRefactorableParametersLength(parameters) {
            if (hasThisParameter(parameters)) {
              return parameters.length - 1;
            }
            return parameters.length;
          }
          function getRefactorableParameters(parameters) {
            if (hasThisParameter(parameters)) {
              parameters = ts3.factory.createNodeArray(parameters.slice(1), parameters.hasTrailingComma);
            }
            return parameters;
          }
          function createPropertyOrShorthandAssignment(name, initializer) {
            if (ts3.isIdentifier(initializer) && ts3.getTextOfIdentifierOrLiteral(initializer) === name) {
              return ts3.factory.createShorthandPropertyAssignment(name);
            }
            return ts3.factory.createPropertyAssignment(name, initializer);
          }
          function createNewArgument(functionDeclaration, functionArguments) {
            var parameters = getRefactorableParameters(functionDeclaration.parameters);
            var hasRestParameter = ts3.isRestParameter(ts3.last(parameters));
            var nonRestArguments = hasRestParameter ? functionArguments.slice(0, parameters.length - 1) : functionArguments;
            var properties = ts3.map(nonRestArguments, function(arg2, i3) {
              var parameterName = getParameterName(parameters[i3]);
              var property = createPropertyOrShorthandAssignment(parameterName, arg2);
              ts3.suppressLeadingAndTrailingTrivia(property.name);
              if (ts3.isPropertyAssignment(property))
                ts3.suppressLeadingAndTrailingTrivia(property.initializer);
              ts3.copyComments(arg2, property);
              return property;
            });
            if (hasRestParameter && functionArguments.length >= parameters.length) {
              var restArguments = functionArguments.slice(parameters.length - 1);
              var restProperty = ts3.factory.createPropertyAssignment(getParameterName(ts3.last(parameters)), ts3.factory.createArrayLiteralExpression(restArguments));
              properties.push(restProperty);
            }
            var objectLiteral = ts3.factory.createObjectLiteralExpression(properties, false);
            return objectLiteral;
          }
          function createNewParameters(functionDeclaration, program2, host) {
            var checker = program2.getTypeChecker();
            var refactorableParameters = getRefactorableParameters(functionDeclaration.parameters);
            var bindingElements = ts3.map(refactorableParameters, createBindingElementFromParameterDeclaration);
            var objectParameterName = ts3.factory.createObjectBindingPattern(bindingElements);
            var objectParameterType = createParameterTypeNode(refactorableParameters);
            var objectInitializer;
            if (ts3.every(refactorableParameters, isOptionalParameter)) {
              objectInitializer = ts3.factory.createObjectLiteralExpression();
            }
            var objectParameter = ts3.factory.createParameterDeclaration(void 0, void 0, void 0, objectParameterName, void 0, objectParameterType, objectInitializer);
            if (hasThisParameter(functionDeclaration.parameters)) {
              var thisParameter = functionDeclaration.parameters[0];
              var newThisParameter = ts3.factory.createParameterDeclaration(void 0, void 0, void 0, thisParameter.name, void 0, thisParameter.type);
              ts3.suppressLeadingAndTrailingTrivia(newThisParameter.name);
              ts3.copyComments(thisParameter.name, newThisParameter.name);
              if (thisParameter.type) {
                ts3.suppressLeadingAndTrailingTrivia(newThisParameter.type);
                ts3.copyComments(thisParameter.type, newThisParameter.type);
              }
              return ts3.factory.createNodeArray([newThisParameter, objectParameter]);
            }
            return ts3.factory.createNodeArray([objectParameter]);
            function createBindingElementFromParameterDeclaration(parameterDeclaration) {
              var element = ts3.factory.createBindingElement(void 0, void 0, getParameterName(parameterDeclaration), ts3.isRestParameter(parameterDeclaration) && isOptionalParameter(parameterDeclaration) ? ts3.factory.createArrayLiteralExpression() : parameterDeclaration.initializer);
              ts3.suppressLeadingAndTrailingTrivia(element);
              if (parameterDeclaration.initializer && element.initializer) {
                ts3.copyComments(parameterDeclaration.initializer, element.initializer);
              }
              return element;
            }
            function createParameterTypeNode(parameters) {
              var members = ts3.map(parameters, createPropertySignatureFromParameterDeclaration);
              var typeNode = ts3.addEmitFlags(ts3.factory.createTypeLiteralNode(members), 1);
              return typeNode;
            }
            function createPropertySignatureFromParameterDeclaration(parameterDeclaration) {
              var parameterType = parameterDeclaration.type;
              if (!parameterType && (parameterDeclaration.initializer || ts3.isRestParameter(parameterDeclaration))) {
                parameterType = getTypeNode(parameterDeclaration);
              }
              var propertySignature = ts3.factory.createPropertySignature(void 0, getParameterName(parameterDeclaration), isOptionalParameter(parameterDeclaration) ? ts3.factory.createToken(57) : parameterDeclaration.questionToken, parameterType);
              ts3.suppressLeadingAndTrailingTrivia(propertySignature);
              ts3.copyComments(parameterDeclaration.name, propertySignature.name);
              if (parameterDeclaration.type && propertySignature.type) {
                ts3.copyComments(parameterDeclaration.type, propertySignature.type);
              }
              return propertySignature;
            }
            function getTypeNode(node) {
              var type3 = checker.getTypeAtLocation(node);
              return ts3.getTypeNodeIfAccessible(type3, node, program2, host);
            }
            function isOptionalParameter(parameterDeclaration) {
              if (ts3.isRestParameter(parameterDeclaration)) {
                var type3 = checker.getTypeAtLocation(parameterDeclaration);
                return !checker.isTupleType(type3);
              }
              return checker.isOptionalParameter(parameterDeclaration);
            }
          }
          function getParameterName(paramDeclaration) {
            return ts3.getTextOfIdentifierOrLiteral(paramDeclaration.name);
          }
          function getClassNames(constructorDeclaration) {
            switch (constructorDeclaration.parent.kind) {
              case 253:
                var classDeclaration = constructorDeclaration.parent;
                if (classDeclaration.name)
                  return [classDeclaration.name];
                var defaultModifier = ts3.Debug.checkDefined(ts3.findModifier(classDeclaration, 87), "Nameless class declaration should be a default export");
                return [defaultModifier];
              case 222:
                var classExpression = constructorDeclaration.parent;
                var variableDeclaration = constructorDeclaration.parent.parent;
                var className = classExpression.name;
                if (className)
                  return [className, variableDeclaration.name];
                return [variableDeclaration.name];
            }
          }
          function getFunctionNames(functionDeclaration) {
            switch (functionDeclaration.kind) {
              case 252:
                if (functionDeclaration.name)
                  return [functionDeclaration.name];
                var defaultModifier = ts3.Debug.checkDefined(ts3.findModifier(functionDeclaration, 87), "Nameless function declaration should be a default export");
                return [defaultModifier];
              case 166:
                return [functionDeclaration.name];
              case 167:
                var ctrKeyword = ts3.Debug.checkDefined(ts3.findChildOfKind(functionDeclaration, 132, functionDeclaration.getSourceFile()), "Constructor declaration should have constructor keyword");
                if (functionDeclaration.parent.kind === 222) {
                  var variableDeclaration = functionDeclaration.parent.parent;
                  return [variableDeclaration.name, ctrKeyword];
                }
                return [ctrKeyword];
              case 210:
                return [functionDeclaration.parent.name];
              case 209:
                if (functionDeclaration.name)
                  return [functionDeclaration.name, functionDeclaration.parent.name];
                return [functionDeclaration.parent.name];
              default:
                return ts3.Debug.assertNever(functionDeclaration, "Unexpected function declaration kind " + functionDeclaration.kind);
            }
          }
        })(convertParamsToDestructuredObject = refactor2.convertParamsToDestructuredObject || (refactor2.convertParamsToDestructuredObject = {}));
      })(refactor = ts3.refactor || (ts3.refactor = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var refactor;
      (function(refactor2) {
        var convertStringOrTemplateLiteral;
        (function(convertStringOrTemplateLiteral2) {
          var refactorName = "Convert to template string";
          var refactorDescription = ts3.getLocaleSpecificMessage(ts3.Diagnostics.Convert_to_template_string);
          var convertStringAction = {
            name: refactorName,
            description: refactorDescription,
            kind: "refactor.rewrite.string"
          };
          refactor2.registerRefactor(refactorName, {
            kinds: [convertStringAction.kind],
            getEditsForAction,
            getAvailableActions
          });
          function getAvailableActions(context) {
            var file = context.file, startPosition = context.startPosition;
            var node = getNodeOrParentOfParentheses(file, startPosition);
            var maybeBinary = getParentBinaryExpression(node);
            var refactorInfo = { name: refactorName, description: refactorDescription, actions: [] };
            if (ts3.isBinaryExpression(maybeBinary) && isStringConcatenationValid(maybeBinary)) {
              refactorInfo.actions.push(convertStringAction);
              return [refactorInfo];
            } else if (context.preferences.provideRefactorNotApplicableReason) {
              refactorInfo.actions.push(__assign(__assign({}, convertStringAction), { notApplicableReason: ts3.getLocaleSpecificMessage(ts3.Diagnostics.Can_only_convert_string_concatenation) }));
              return [refactorInfo];
            }
            return ts3.emptyArray;
          }
          function getNodeOrParentOfParentheses(file, startPosition) {
            var node = ts3.getTokenAtPosition(file, startPosition);
            var nestedBinary = getParentBinaryExpression(node);
            var isNonStringBinary = !isStringConcatenationValid(nestedBinary);
            if (isNonStringBinary && ts3.isParenthesizedExpression(nestedBinary.parent) && ts3.isBinaryExpression(nestedBinary.parent.parent)) {
              return nestedBinary.parent.parent;
            }
            return node;
          }
          function getEditsForAction(context, actionName) {
            var file = context.file, startPosition = context.startPosition;
            var node = getNodeOrParentOfParentheses(file, startPosition);
            switch (actionName) {
              case refactorDescription:
                return { edits: getEditsForToTemplateLiteral(context, node) };
              default:
                return ts3.Debug.fail("invalid action");
            }
          }
          function getEditsForToTemplateLiteral(context, node) {
            var maybeBinary = getParentBinaryExpression(node);
            var file = context.file;
            var templateLiteral = nodesToTemplate(treeToArray(maybeBinary), file);
            var trailingCommentRanges = ts3.getTrailingCommentRanges(file.text, maybeBinary.end);
            if (trailingCommentRanges) {
              var lastComment = trailingCommentRanges[trailingCommentRanges.length - 1];
              var trailingRange_1 = { pos: trailingCommentRanges[0].pos, end: lastComment.end };
              return ts3.textChanges.ChangeTracker.with(context, function(t2) {
                t2.deleteRange(file, trailingRange_1);
                t2.replaceNode(file, maybeBinary, templateLiteral);
              });
            } else {
              return ts3.textChanges.ChangeTracker.with(context, function(t2) {
                return t2.replaceNode(file, maybeBinary, templateLiteral);
              });
            }
          }
          function isNotEqualsOperator(node) {
            return node.operatorToken.kind !== 62;
          }
          function getParentBinaryExpression(expr) {
            var container = ts3.findAncestor(expr.parent, function(n2) {
              switch (n2.kind) {
                case 202:
                case 203:
                  return false;
                case 219:
                case 217:
                  return !(ts3.isBinaryExpression(n2.parent) && isNotEqualsOperator(n2.parent));
                default:
                  return "quit";
              }
            });
            return container || expr;
          }
          function isStringConcatenationValid(node) {
            var _a2 = treeToArray(node), containsString = _a2.containsString, areOperatorsValid = _a2.areOperatorsValid;
            return containsString && areOperatorsValid;
          }
          function treeToArray(current) {
            if (ts3.isBinaryExpression(current)) {
              var _a2 = treeToArray(current.left), nodes = _a2.nodes, operators = _a2.operators, leftHasString = _a2.containsString, leftOperatorValid = _a2.areOperatorsValid;
              if (!leftHasString && !ts3.isStringLiteral(current.right) && !ts3.isTemplateExpression(current.right)) {
                return { nodes: [current], operators: [], containsString: false, areOperatorsValid: true };
              }
              var currentOperatorValid = current.operatorToken.kind === 39;
              var areOperatorsValid = leftOperatorValid && currentOperatorValid;
              nodes.push(current.right);
              operators.push(current.operatorToken);
              return { nodes, operators, containsString: true, areOperatorsValid };
            }
            return { nodes: [current], operators: [], containsString: ts3.isStringLiteral(current), areOperatorsValid: true };
          }
          var copyTrailingOperatorComments = function(operators, file) {
            return function(index, targetNode) {
              if (index < operators.length) {
                ts3.copyTrailingComments(operators[index], targetNode, file, 3, false);
              }
            };
          };
          var copyCommentFromMultiNode = function(nodes, file, copyOperatorComments) {
            return function(indexes, targetNode) {
              while (indexes.length > 0) {
                var index = indexes.shift();
                ts3.copyTrailingComments(nodes[index], targetNode, file, 3, false);
                copyOperatorComments(index, targetNode);
              }
            };
          };
          function concatConsecutiveString(index, nodes) {
            var indexes = [];
            var text = "";
            while (index < nodes.length) {
              var node = nodes[index];
              if (ts3.isStringLiteralLike(node)) {
                text = text + node.text;
                indexes.push(index);
                index++;
              } else if (ts3.isTemplateExpression(node)) {
                text = text + node.head.text;
                break;
              } else {
                break;
              }
            }
            return [index, text, indexes];
          }
          function nodesToTemplate(_a2, file) {
            var nodes = _a2.nodes, operators = _a2.operators;
            var copyOperatorComments = copyTrailingOperatorComments(operators, file);
            var copyCommentFromStringLiterals = copyCommentFromMultiNode(nodes, file, copyOperatorComments);
            var _b = concatConsecutiveString(0, nodes), begin = _b[0], headText = _b[1], headIndexes = _b[2];
            if (begin === nodes.length) {
              var noSubstitutionTemplateLiteral = ts3.factory.createNoSubstitutionTemplateLiteral(headText);
              copyCommentFromStringLiterals(headIndexes, noSubstitutionTemplateLiteral);
              return noSubstitutionTemplateLiteral;
            }
            var templateSpans = [];
            var templateHead = ts3.factory.createTemplateHead(headText);
            copyCommentFromStringLiterals(headIndexes, templateHead);
            var _loop_20 = function(i4) {
              var currentNode = getExpressionFromParenthesesOrExpression(nodes[i4]);
              copyOperatorComments(i4, currentNode);
              var _c = concatConsecutiveString(i4 + 1, nodes), newIndex = _c[0], subsequentText = _c[1], stringIndexes = _c[2];
              i4 = newIndex - 1;
              var isLast = i4 === nodes.length - 1;
              if (ts3.isTemplateExpression(currentNode)) {
                var spans = ts3.map(currentNode.templateSpans, function(span, index) {
                  copyExpressionComments(span);
                  var nextSpan = currentNode.templateSpans[index + 1];
                  var text = span.literal.text + (nextSpan ? "" : subsequentText);
                  return ts3.factory.createTemplateSpan(span.expression, isLast ? ts3.factory.createTemplateTail(text) : ts3.factory.createTemplateMiddle(text));
                });
                templateSpans.push.apply(templateSpans, spans);
              } else {
                var templatePart = isLast ? ts3.factory.createTemplateTail(subsequentText) : ts3.factory.createTemplateMiddle(subsequentText);
                copyCommentFromStringLiterals(stringIndexes, templatePart);
                templateSpans.push(ts3.factory.createTemplateSpan(currentNode, templatePart));
              }
              out_i_1 = i4;
            };
            var out_i_1;
            for (var i3 = begin; i3 < nodes.length; i3++) {
              _loop_20(i3);
              i3 = out_i_1;
            }
            return ts3.factory.createTemplateExpression(templateHead, templateSpans);
          }
          function copyExpressionComments(node) {
            var file = node.getSourceFile();
            ts3.copyTrailingComments(node, node.expression, file, 3, false);
            ts3.copyTrailingAsLeadingComments(node.expression, node.expression, file, 3, false);
          }
          function getExpressionFromParenthesesOrExpression(node) {
            if (ts3.isParenthesizedExpression(node)) {
              copyExpressionComments(node);
              node = node.expression;
            }
            return node;
          }
        })(convertStringOrTemplateLiteral = refactor2.convertStringOrTemplateLiteral || (refactor2.convertStringOrTemplateLiteral = {}));
      })(refactor = ts3.refactor || (ts3.refactor = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var refactor;
      (function(refactor2) {
        var convertArrowFunctionOrFunctionExpression;
        (function(convertArrowFunctionOrFunctionExpression2) {
          var refactorName = "Convert arrow function or function expression";
          var refactorDescription = ts3.getLocaleSpecificMessage(ts3.Diagnostics.Convert_arrow_function_or_function_expression);
          var toAnonymousFunctionAction = {
            name: "Convert to anonymous function",
            description: ts3.getLocaleSpecificMessage(ts3.Diagnostics.Convert_to_anonymous_function),
            kind: "refactor.rewrite.function.anonymous"
          };
          var toNamedFunctionAction = {
            name: "Convert to named function",
            description: ts3.getLocaleSpecificMessage(ts3.Diagnostics.Convert_to_named_function),
            kind: "refactor.rewrite.function.named"
          };
          var toArrowFunctionAction = {
            name: "Convert to arrow function",
            description: ts3.getLocaleSpecificMessage(ts3.Diagnostics.Convert_to_arrow_function),
            kind: "refactor.rewrite.function.arrow"
          };
          refactor2.registerRefactor(refactorName, {
            kinds: [
              toAnonymousFunctionAction.kind,
              toNamedFunctionAction.kind,
              toArrowFunctionAction.kind
            ],
            getEditsForAction,
            getAvailableActions
          });
          function getAvailableActions(context) {
            var file = context.file, startPosition = context.startPosition, program2 = context.program, kind = context.kind;
            var info = getFunctionInfo(file, startPosition, program2);
            if (!info)
              return ts3.emptyArray;
            var selectedVariableDeclaration = info.selectedVariableDeclaration, func2 = info.func;
            var possibleActions = [];
            var errors = [];
            if (refactor2.refactorKindBeginsWith(toNamedFunctionAction.kind, kind)) {
              var error = selectedVariableDeclaration || ts3.isArrowFunction(func2) && ts3.isVariableDeclaration(func2.parent) ? void 0 : ts3.getLocaleSpecificMessage(ts3.Diagnostics.Could_not_convert_to_named_function);
              if (error) {
                errors.push(__assign(__assign({}, toNamedFunctionAction), { notApplicableReason: error }));
              } else {
                possibleActions.push(toNamedFunctionAction);
              }
            }
            if (refactor2.refactorKindBeginsWith(toAnonymousFunctionAction.kind, kind)) {
              var error = !selectedVariableDeclaration && ts3.isArrowFunction(func2) ? void 0 : ts3.getLocaleSpecificMessage(ts3.Diagnostics.Could_not_convert_to_anonymous_function);
              if (error) {
                errors.push(__assign(__assign({}, toAnonymousFunctionAction), { notApplicableReason: error }));
              } else {
                possibleActions.push(toAnonymousFunctionAction);
              }
            }
            if (refactor2.refactorKindBeginsWith(toArrowFunctionAction.kind, kind)) {
              var error = ts3.isFunctionExpression(func2) ? void 0 : ts3.getLocaleSpecificMessage(ts3.Diagnostics.Could_not_convert_to_arrow_function);
              if (error) {
                errors.push(__assign(__assign({}, toArrowFunctionAction), { notApplicableReason: error }));
              } else {
                possibleActions.push(toArrowFunctionAction);
              }
            }
            return [{
              name: refactorName,
              description: refactorDescription,
              actions: possibleActions.length === 0 && context.preferences.provideRefactorNotApplicableReason ? errors : possibleActions
            }];
          }
          function getEditsForAction(context, actionName) {
            var file = context.file, startPosition = context.startPosition, program2 = context.program;
            var info = getFunctionInfo(file, startPosition, program2);
            if (!info)
              return void 0;
            var func2 = info.func;
            var edits = [];
            switch (actionName) {
              case toAnonymousFunctionAction.name:
                edits.push.apply(edits, getEditInfoForConvertToAnonymousFunction(context, func2));
                break;
              case toNamedFunctionAction.name:
                var variableInfo = getVariableInfo(func2);
                if (!variableInfo)
                  return void 0;
                edits.push.apply(edits, getEditInfoForConvertToNamedFunction(context, func2, variableInfo));
                break;
              case toArrowFunctionAction.name:
                if (!ts3.isFunctionExpression(func2))
                  return void 0;
                edits.push.apply(edits, getEditInfoForConvertToArrowFunction(context, func2));
                break;
              default:
                return ts3.Debug.fail("invalid action");
            }
            return { renameFilename: void 0, renameLocation: void 0, edits };
          }
          function containingThis(node) {
            var containsThis = false;
            node.forEachChild(function checkThis(child) {
              if (ts3.isThis(child)) {
                containsThis = true;
                return;
              }
              if (!ts3.isClassLike(child) && !ts3.isFunctionDeclaration(child) && !ts3.isFunctionExpression(child)) {
                ts3.forEachChild(child, checkThis);
              }
            });
            return containsThis;
          }
          function getFunctionInfo(file, startPosition, program2) {
            var token = ts3.getTokenAtPosition(file, startPosition);
            var typeChecker = program2.getTypeChecker();
            var func2 = tryGetFunctionFromVariableDeclaration(file, typeChecker, token.parent);
            if (func2 && !containingThis(func2.body)) {
              return { selectedVariableDeclaration: true, func: func2 };
            }
            var maybeFunc = ts3.getContainingFunction(token);
            if (maybeFunc && (ts3.isFunctionExpression(maybeFunc) || ts3.isArrowFunction(maybeFunc)) && !ts3.rangeContainsRange(maybeFunc.body, token) && !containingThis(maybeFunc.body)) {
              if (ts3.isFunctionExpression(maybeFunc) && isFunctionReferencedInFile(file, typeChecker, maybeFunc))
                return void 0;
              return { selectedVariableDeclaration: false, func: maybeFunc };
            }
            return void 0;
          }
          function isSingleVariableDeclaration(parent) {
            return ts3.isVariableDeclaration(parent) || ts3.isVariableDeclarationList(parent) && parent.declarations.length === 1;
          }
          function tryGetFunctionFromVariableDeclaration(sourceFile, typeChecker, parent) {
            if (!isSingleVariableDeclaration(parent)) {
              return void 0;
            }
            var variableDeclaration = ts3.isVariableDeclaration(parent) ? parent : ts3.first(parent.declarations);
            var initializer = variableDeclaration.initializer;
            if (initializer && (ts3.isArrowFunction(initializer) || ts3.isFunctionExpression(initializer) && !isFunctionReferencedInFile(sourceFile, typeChecker, initializer))) {
              return initializer;
            }
            return void 0;
          }
          function convertToBlock(body) {
            if (ts3.isExpression(body)) {
              return ts3.factory.createBlock([ts3.factory.createReturnStatement(body)], true);
            } else {
              return body;
            }
          }
          function getVariableInfo(func2) {
            var variableDeclaration = func2.parent;
            if (!ts3.isVariableDeclaration(variableDeclaration) || !ts3.isVariableDeclarationInVariableStatement(variableDeclaration))
              return void 0;
            var variableDeclarationList = variableDeclaration.parent;
            var statement = variableDeclarationList.parent;
            if (!ts3.isVariableDeclarationList(variableDeclarationList) || !ts3.isVariableStatement(statement) || !ts3.isIdentifier(variableDeclaration.name))
              return void 0;
            return { variableDeclaration, variableDeclarationList, statement, name: variableDeclaration.name };
          }
          function getEditInfoForConvertToAnonymousFunction(context, func2) {
            var file = context.file;
            var body = convertToBlock(func2.body);
            var newNode = ts3.factory.createFunctionExpression(func2.modifiers, func2.asteriskToken, void 0, func2.typeParameters, func2.parameters, func2.type, body);
            return ts3.textChanges.ChangeTracker.with(context, function(t2) {
              return t2.replaceNode(file, func2, newNode);
            });
          }
          function getEditInfoForConvertToNamedFunction(context, func2, variableInfo) {
            var file = context.file;
            var body = convertToBlock(func2.body);
            var variableDeclaration = variableInfo.variableDeclaration, variableDeclarationList = variableInfo.variableDeclarationList, statement = variableInfo.statement, name = variableInfo.name;
            ts3.suppressLeadingTrivia(statement);
            var modifiersFlags = ts3.getCombinedModifierFlags(variableDeclaration) & 1 | ts3.getEffectiveModifierFlags(func2);
            var modifiers = ts3.factory.createModifiersFromModifierFlags(modifiersFlags);
            var newNode = ts3.factory.createFunctionDeclaration(func2.decorators, ts3.length(modifiers) ? modifiers : void 0, func2.asteriskToken, name, func2.typeParameters, func2.parameters, func2.type, body);
            if (variableDeclarationList.declarations.length === 1) {
              return ts3.textChanges.ChangeTracker.with(context, function(t2) {
                return t2.replaceNode(file, statement, newNode);
              });
            } else {
              return ts3.textChanges.ChangeTracker.with(context, function(t2) {
                t2.delete(file, variableDeclaration);
                t2.insertNodeAfter(file, statement, newNode);
              });
            }
          }
          function getEditInfoForConvertToArrowFunction(context, func2) {
            var file = context.file;
            var statements = func2.body.statements;
            var head = statements[0];
            var body;
            if (canBeConvertedToExpression(func2.body, head)) {
              body = head.expression;
              ts3.suppressLeadingAndTrailingTrivia(body);
              ts3.copyComments(head, body);
            } else {
              body = func2.body;
            }
            var newNode = ts3.factory.createArrowFunction(func2.modifiers, func2.typeParameters, func2.parameters, func2.type, ts3.factory.createToken(38), body);
            return ts3.textChanges.ChangeTracker.with(context, function(t2) {
              return t2.replaceNode(file, func2, newNode);
            });
          }
          function canBeConvertedToExpression(body, head) {
            return body.statements.length === 1 && (ts3.isReturnStatement(head) && !!head.expression);
          }
          function isFunctionReferencedInFile(sourceFile, typeChecker, node) {
            return !!node.name && ts3.FindAllReferences.Core.isSymbolReferencedInFile(node.name, typeChecker, sourceFile);
          }
        })(convertArrowFunctionOrFunctionExpression = refactor2.convertArrowFunctionOrFunctionExpression || (refactor2.convertArrowFunctionOrFunctionExpression = {}));
      })(refactor = ts3.refactor || (ts3.refactor = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var refactor;
      (function(refactor2) {
        var inferFunctionReturnType;
        (function(inferFunctionReturnType2) {
          var refactorName = "Infer function return type";
          var refactorDescription = ts3.Diagnostics.Infer_function_return_type.message;
          var inferReturnTypeAction = {
            name: refactorName,
            description: refactorDescription,
            kind: "refactor.rewrite.function.returnType"
          };
          refactor2.registerRefactor(refactorName, {
            kinds: [inferReturnTypeAction.kind],
            getEditsForAction,
            getAvailableActions
          });
          function getEditsForAction(context) {
            var info = getInfo(context);
            if (info && !refactor2.isRefactorErrorInfo(info)) {
              var edits = ts3.textChanges.ChangeTracker.with(context, function(t2) {
                return doChange(context.file, t2, info.declaration, info.returnTypeNode);
              });
              return { renameFilename: void 0, renameLocation: void 0, edits };
            }
            return void 0;
          }
          function getAvailableActions(context) {
            var info = getInfo(context);
            if (!info)
              return ts3.emptyArray;
            if (!refactor2.isRefactorErrorInfo(info)) {
              return [{
                name: refactorName,
                description: refactorDescription,
                actions: [inferReturnTypeAction]
              }];
            }
            if (context.preferences.provideRefactorNotApplicableReason) {
              return [{
                name: refactorName,
                description: refactorDescription,
                actions: [__assign(__assign({}, inferReturnTypeAction), { notApplicableReason: info.error })]
              }];
            }
            return ts3.emptyArray;
          }
          function doChange(sourceFile, changes, declaration, typeNode) {
            var closeParen = ts3.findChildOfKind(declaration, 21, sourceFile);
            var needParens = ts3.isArrowFunction(declaration) && closeParen === void 0;
            var endNode = needParens ? ts3.first(declaration.parameters) : closeParen;
            if (endNode) {
              if (needParens) {
                changes.insertNodeBefore(sourceFile, endNode, ts3.factory.createToken(20));
                changes.insertNodeAfter(sourceFile, endNode, ts3.factory.createToken(21));
              }
              changes.insertNodeAt(sourceFile, endNode.end, typeNode, { prefix: ": " });
            }
          }
          function getInfo(context) {
            if (ts3.isInJSFile(context.file) || !refactor2.refactorKindBeginsWith(inferReturnTypeAction.kind, context.kind))
              return;
            var token = ts3.getTokenAtPosition(context.file, context.startPosition);
            var declaration = ts3.findAncestor(token, function(n2) {
              return ts3.isBlock(n2) || n2.parent && ts3.isArrowFunction(n2.parent) && (n2.kind === 38 || n2.parent.body === n2) ? "quit" : isConvertibleDeclaration(n2);
            });
            if (!declaration || !declaration.body || declaration.type) {
              return { error: ts3.getLocaleSpecificMessage(ts3.Diagnostics.Return_type_must_be_inferred_from_a_function) };
            }
            var typeChecker = context.program.getTypeChecker();
            var returnType2 = tryGetReturnType(typeChecker, declaration);
            if (!returnType2) {
              return { error: ts3.getLocaleSpecificMessage(ts3.Diagnostics.Could_not_determine_function_return_type) };
            }
            var returnTypeNode = typeChecker.typeToTypeNode(returnType2, declaration, 1);
            if (returnTypeNode) {
              return { declaration, returnTypeNode };
            }
          }
          function isConvertibleDeclaration(node) {
            switch (node.kind) {
              case 252:
              case 209:
              case 210:
              case 166:
                return true;
              default:
                return false;
            }
          }
          function tryGetReturnType(typeChecker, node) {
            if (typeChecker.isImplementationOfOverload(node)) {
              var signatures = typeChecker.getTypeAtLocation(node).getCallSignatures();
              if (signatures.length > 1) {
                return typeChecker.getUnionType(ts3.mapDefined(signatures, function(s2) {
                  return s2.getReturnType();
                }));
              }
            }
            var signature = typeChecker.getSignatureFromDeclaration(node);
            if (signature) {
              return typeChecker.getReturnTypeOfSignature(signature);
            }
          }
        })(inferFunctionReturnType = refactor2.inferFunctionReturnType || (refactor2.inferFunctionReturnType = {}));
      })(refactor = ts3.refactor || (ts3.refactor = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      ts3.servicesVersion = "0.8";
      function createNode(kind, pos, end, parent) {
        var node = ts3.isNodeKind(kind) ? new NodeObject(kind, pos, end) : kind === 78 ? new IdentifierObject(78, pos, end) : kind === 79 ? new PrivateIdentifierObject(79, pos, end) : new TokenObject(kind, pos, end);
        node.parent = parent;
        node.flags = parent.flags & 25358336;
        return node;
      }
      var NodeObject = function() {
        function NodeObject2(kind, pos, end) {
          this.pos = pos;
          this.end = end;
          this.flags = 0;
          this.modifierFlagsCache = 0;
          this.transformFlags = 0;
          this.parent = void 0;
          this.kind = kind;
        }
        NodeObject2.prototype.assertHasRealPosition = function(message) {
          ts3.Debug.assert(!ts3.positionIsSynthesized(this.pos) && !ts3.positionIsSynthesized(this.end), message || "Node must have a real position for this operation");
        };
        NodeObject2.prototype.getSourceFile = function() {
          return ts3.getSourceFileOfNode(this);
        };
        NodeObject2.prototype.getStart = function(sourceFile, includeJsDocComment) {
          this.assertHasRealPosition();
          return ts3.getTokenPosOfNode(this, sourceFile, includeJsDocComment);
        };
        NodeObject2.prototype.getFullStart = function() {
          this.assertHasRealPosition();
          return this.pos;
        };
        NodeObject2.prototype.getEnd = function() {
          this.assertHasRealPosition();
          return this.end;
        };
        NodeObject2.prototype.getWidth = function(sourceFile) {
          this.assertHasRealPosition();
          return this.getEnd() - this.getStart(sourceFile);
        };
        NodeObject2.prototype.getFullWidth = function() {
          this.assertHasRealPosition();
          return this.end - this.pos;
        };
        NodeObject2.prototype.getLeadingTriviaWidth = function(sourceFile) {
          this.assertHasRealPosition();
          return this.getStart(sourceFile) - this.pos;
        };
        NodeObject2.prototype.getFullText = function(sourceFile) {
          this.assertHasRealPosition();
          return (sourceFile || this.getSourceFile()).text.substring(this.pos, this.end);
        };
        NodeObject2.prototype.getText = function(sourceFile) {
          this.assertHasRealPosition();
          if (!sourceFile) {
            sourceFile = this.getSourceFile();
          }
          return sourceFile.text.substring(this.getStart(sourceFile), this.getEnd());
        };
        NodeObject2.prototype.getChildCount = function(sourceFile) {
          return this.getChildren(sourceFile).length;
        };
        NodeObject2.prototype.getChildAt = function(index, sourceFile) {
          return this.getChildren(sourceFile)[index];
        };
        NodeObject2.prototype.getChildren = function(sourceFile) {
          this.assertHasRealPosition("Node without a real position cannot be scanned and thus has no token nodes - use forEachChild and collect the result if that's fine");
          return this._children || (this._children = createChildren(this, sourceFile));
        };
        NodeObject2.prototype.getFirstToken = function(sourceFile) {
          this.assertHasRealPosition();
          var children = this.getChildren(sourceFile);
          if (!children.length) {
            return void 0;
          }
          var child = ts3.find(children, function(kid) {
            return kid.kind < 302 || kid.kind > 337;
          });
          return child.kind < 158 ? child : child.getFirstToken(sourceFile);
        };
        NodeObject2.prototype.getLastToken = function(sourceFile) {
          this.assertHasRealPosition();
          var children = this.getChildren(sourceFile);
          var child = ts3.lastOrUndefined(children);
          if (!child) {
            return void 0;
          }
          return child.kind < 158 ? child : child.getLastToken(sourceFile);
        };
        NodeObject2.prototype.forEachChild = function(cbNode, cbNodeArray) {
          return ts3.forEachChild(this, cbNode, cbNodeArray);
        };
        return NodeObject2;
      }();
      function createChildren(node, sourceFile) {
        if (!ts3.isNodeKind(node.kind)) {
          return ts3.emptyArray;
        }
        var children = [];
        if (ts3.isJSDocCommentContainingNode(node)) {
          node.forEachChild(function(child) {
            children.push(child);
          });
          return children;
        }
        ts3.scanner.setText((sourceFile || node.getSourceFile()).text);
        var pos = node.pos;
        var processNode = function(child) {
          addSyntheticNodes(children, pos, child.pos, node);
          children.push(child);
          pos = child.end;
        };
        var processNodes = function(nodes) {
          addSyntheticNodes(children, pos, nodes.pos, node);
          children.push(createSyntaxList(nodes, node));
          pos = nodes.end;
        };
        ts3.forEach(node.jsDoc, processNode);
        pos = node.pos;
        node.forEachChild(processNode, processNodes);
        addSyntheticNodes(children, pos, node.end, node);
        ts3.scanner.setText(void 0);
        return children;
      }
      function addSyntheticNodes(nodes, pos, end, parent) {
        ts3.scanner.setTextPos(pos);
        while (pos < end) {
          var token = ts3.scanner.scan();
          var textPos = ts3.scanner.getTextPos();
          if (textPos <= end) {
            if (token === 78) {
              ts3.Debug.fail("Did not expect " + ts3.Debug.formatSyntaxKind(parent.kind) + " to have an Identifier in its trivia");
            }
            nodes.push(createNode(token, pos, textPos, parent));
          }
          pos = textPos;
          if (token === 1) {
            break;
          }
        }
      }
      function createSyntaxList(nodes, parent) {
        var list = createNode(338, nodes.pos, nodes.end, parent);
        list._children = [];
        var pos = nodes.pos;
        for (var _i = 0, nodes_2 = nodes; _i < nodes_2.length; _i++) {
          var node = nodes_2[_i];
          addSyntheticNodes(list._children, pos, node.pos, parent);
          list._children.push(node);
          pos = node.end;
        }
        addSyntheticNodes(list._children, pos, nodes.end, parent);
        return list;
      }
      var TokenOrIdentifierObject = function() {
        function TokenOrIdentifierObject2(pos, end) {
          this.pos = pos;
          this.end = end;
          this.flags = 0;
          this.modifierFlagsCache = 0;
          this.transformFlags = 0;
          this.parent = void 0;
        }
        TokenOrIdentifierObject2.prototype.getSourceFile = function() {
          return ts3.getSourceFileOfNode(this);
        };
        TokenOrIdentifierObject2.prototype.getStart = function(sourceFile, includeJsDocComment) {
          return ts3.getTokenPosOfNode(this, sourceFile, includeJsDocComment);
        };
        TokenOrIdentifierObject2.prototype.getFullStart = function() {
          return this.pos;
        };
        TokenOrIdentifierObject2.prototype.getEnd = function() {
          return this.end;
        };
        TokenOrIdentifierObject2.prototype.getWidth = function(sourceFile) {
          return this.getEnd() - this.getStart(sourceFile);
        };
        TokenOrIdentifierObject2.prototype.getFullWidth = function() {
          return this.end - this.pos;
        };
        TokenOrIdentifierObject2.prototype.getLeadingTriviaWidth = function(sourceFile) {
          return this.getStart(sourceFile) - this.pos;
        };
        TokenOrIdentifierObject2.prototype.getFullText = function(sourceFile) {
          return (sourceFile || this.getSourceFile()).text.substring(this.pos, this.end);
        };
        TokenOrIdentifierObject2.prototype.getText = function(sourceFile) {
          if (!sourceFile) {
            sourceFile = this.getSourceFile();
          }
          return sourceFile.text.substring(this.getStart(sourceFile), this.getEnd());
        };
        TokenOrIdentifierObject2.prototype.getChildCount = function() {
          return 0;
        };
        TokenOrIdentifierObject2.prototype.getChildAt = function() {
          return void 0;
        };
        TokenOrIdentifierObject2.prototype.getChildren = function() {
          return this.kind === 1 ? this.jsDoc || ts3.emptyArray : ts3.emptyArray;
        };
        TokenOrIdentifierObject2.prototype.getFirstToken = function() {
          return void 0;
        };
        TokenOrIdentifierObject2.prototype.getLastToken = function() {
          return void 0;
        };
        TokenOrIdentifierObject2.prototype.forEachChild = function() {
          return void 0;
        };
        return TokenOrIdentifierObject2;
      }();
      var SymbolObject = function() {
        function SymbolObject2(flags, name) {
          this.flags = flags;
          this.escapedName = name;
        }
        SymbolObject2.prototype.getFlags = function() {
          return this.flags;
        };
        Object.defineProperty(SymbolObject2.prototype, "name", {
          get: function() {
            return ts3.symbolName(this);
          },
          enumerable: false,
          configurable: true
        });
        SymbolObject2.prototype.getEscapedName = function() {
          return this.escapedName;
        };
        SymbolObject2.prototype.getName = function() {
          return this.name;
        };
        SymbolObject2.prototype.getDeclarations = function() {
          return this.declarations;
        };
        SymbolObject2.prototype.getDocumentationComment = function(checker) {
          if (!this.documentationComment) {
            this.documentationComment = ts3.emptyArray;
            if (!this.declarations && this.target && this.target.tupleLabelDeclaration) {
              var labelDecl = this.target.tupleLabelDeclaration;
              this.documentationComment = getDocumentationComment([labelDecl], checker);
            } else {
              this.documentationComment = getDocumentationComment(this.declarations, checker);
            }
          }
          return this.documentationComment;
        };
        SymbolObject2.prototype.getContextualDocumentationComment = function(context, checker) {
          switch (context === null || context === void 0 ? void 0 : context.kind) {
            case 168:
              if (!this.contextualGetAccessorDocumentationComment) {
                this.contextualGetAccessorDocumentationComment = ts3.emptyArray;
                this.contextualGetAccessorDocumentationComment = getDocumentationComment(ts3.filter(this.declarations, ts3.isGetAccessor), checker);
              }
              return this.contextualGetAccessorDocumentationComment;
            case 169:
              if (!this.contextualSetAccessorDocumentationComment) {
                this.contextualSetAccessorDocumentationComment = ts3.emptyArray;
                this.contextualSetAccessorDocumentationComment = getDocumentationComment(ts3.filter(this.declarations, ts3.isSetAccessor), checker);
              }
              return this.contextualSetAccessorDocumentationComment;
            default:
              return this.getDocumentationComment(checker);
          }
        };
        SymbolObject2.prototype.getJsDocTags = function(checker) {
          if (this.tags === void 0) {
            this.tags = ts3.JsDoc.getJsDocTagsFromDeclarations(this.declarations, checker);
          }
          return this.tags;
        };
        return SymbolObject2;
      }();
      var TokenObject = function(_super) {
        __extends2(TokenObject2, _super);
        function TokenObject2(kind, pos, end) {
          var _this = _super.call(this, pos, end) || this;
          _this.kind = kind;
          return _this;
        }
        return TokenObject2;
      }(TokenOrIdentifierObject);
      var IdentifierObject = function(_super) {
        __extends2(IdentifierObject2, _super);
        function IdentifierObject2(_kind, pos, end) {
          var _this = _super.call(this, pos, end) || this;
          _this.kind = 78;
          return _this;
        }
        Object.defineProperty(IdentifierObject2.prototype, "text", {
          get: function() {
            return ts3.idText(this);
          },
          enumerable: false,
          configurable: true
        });
        return IdentifierObject2;
      }(TokenOrIdentifierObject);
      IdentifierObject.prototype.kind = 78;
      var PrivateIdentifierObject = function(_super) {
        __extends2(PrivateIdentifierObject2, _super);
        function PrivateIdentifierObject2(_kind, pos, end) {
          return _super.call(this, pos, end) || this;
        }
        Object.defineProperty(PrivateIdentifierObject2.prototype, "text", {
          get: function() {
            return ts3.idText(this);
          },
          enumerable: false,
          configurable: true
        });
        return PrivateIdentifierObject2;
      }(TokenOrIdentifierObject);
      PrivateIdentifierObject.prototype.kind = 79;
      var TypeObject = function() {
        function TypeObject2(checker, flags) {
          this.checker = checker;
          this.flags = flags;
        }
        TypeObject2.prototype.getFlags = function() {
          return this.flags;
        };
        TypeObject2.prototype.getSymbol = function() {
          return this.symbol;
        };
        TypeObject2.prototype.getProperties = function() {
          return this.checker.getPropertiesOfType(this);
        };
        TypeObject2.prototype.getProperty = function(propertyName) {
          return this.checker.getPropertyOfType(this, propertyName);
        };
        TypeObject2.prototype.getApparentProperties = function() {
          return this.checker.getAugmentedPropertiesOfType(this);
        };
        TypeObject2.prototype.getCallSignatures = function() {
          return this.checker.getSignaturesOfType(this, 0);
        };
        TypeObject2.prototype.getConstructSignatures = function() {
          return this.checker.getSignaturesOfType(this, 1);
        };
        TypeObject2.prototype.getStringIndexType = function() {
          return this.checker.getIndexTypeOfType(this, 0);
        };
        TypeObject2.prototype.getNumberIndexType = function() {
          return this.checker.getIndexTypeOfType(this, 1);
        };
        TypeObject2.prototype.getBaseTypes = function() {
          return this.isClassOrInterface() ? this.checker.getBaseTypes(this) : void 0;
        };
        TypeObject2.prototype.isNullableType = function() {
          return this.checker.isNullableType(this);
        };
        TypeObject2.prototype.getNonNullableType = function() {
          return this.checker.getNonNullableType(this);
        };
        TypeObject2.prototype.getNonOptionalType = function() {
          return this.checker.getNonOptionalType(this);
        };
        TypeObject2.prototype.getConstraint = function() {
          return this.checker.getBaseConstraintOfType(this);
        };
        TypeObject2.prototype.getDefault = function() {
          return this.checker.getDefaultFromTypeParameter(this);
        };
        TypeObject2.prototype.isUnion = function() {
          return !!(this.flags & 1048576);
        };
        TypeObject2.prototype.isIntersection = function() {
          return !!(this.flags & 2097152);
        };
        TypeObject2.prototype.isUnionOrIntersection = function() {
          return !!(this.flags & 3145728);
        };
        TypeObject2.prototype.isLiteral = function() {
          return !!(this.flags & 384);
        };
        TypeObject2.prototype.isStringLiteral = function() {
          return !!(this.flags & 128);
        };
        TypeObject2.prototype.isNumberLiteral = function() {
          return !!(this.flags & 256);
        };
        TypeObject2.prototype.isTypeParameter = function() {
          return !!(this.flags & 262144);
        };
        TypeObject2.prototype.isClassOrInterface = function() {
          return !!(ts3.getObjectFlags(this) & 3);
        };
        TypeObject2.prototype.isClass = function() {
          return !!(ts3.getObjectFlags(this) & 1);
        };
        Object.defineProperty(TypeObject2.prototype, "typeArguments", {
          get: function() {
            if (ts3.getObjectFlags(this) & 4) {
              return this.checker.getTypeArguments(this);
            }
            return void 0;
          },
          enumerable: false,
          configurable: true
        });
        return TypeObject2;
      }();
      var SignatureObject = function() {
        function SignatureObject2(checker, flags) {
          this.checker = checker;
          this.flags = flags;
        }
        SignatureObject2.prototype.getDeclaration = function() {
          return this.declaration;
        };
        SignatureObject2.prototype.getTypeParameters = function() {
          return this.typeParameters;
        };
        SignatureObject2.prototype.getParameters = function() {
          return this.parameters;
        };
        SignatureObject2.prototype.getReturnType = function() {
          return this.checker.getReturnTypeOfSignature(this);
        };
        SignatureObject2.prototype.getDocumentationComment = function() {
          return this.documentationComment || (this.documentationComment = getDocumentationComment(ts3.singleElementArray(this.declaration), this.checker));
        };
        SignatureObject2.prototype.getJsDocTags = function() {
          if (this.jsDocTags === void 0) {
            this.jsDocTags = this.declaration ? getJsDocTagsOfSignature(this.declaration, this.checker) : [];
          }
          return this.jsDocTags;
        };
        return SignatureObject2;
      }();
      function hasJSDocInheritDocTag(node) {
        return ts3.getJSDocTags(node).some(function(tag) {
          return tag.tagName.text === "inheritDoc";
        });
      }
      function getJsDocTagsOfSignature(declaration, checker) {
        var tags = ts3.JsDoc.getJsDocTagsFromDeclarations([declaration], checker);
        if (tags.length === 0 || hasJSDocInheritDocTag(declaration)) {
          var inheritedTags = findBaseOfDeclaration(checker, declaration, function(symbol) {
            var _a2;
            return ((_a2 = symbol.declarations) === null || _a2 === void 0 ? void 0 : _a2.length) === 1 ? symbol.getJsDocTags() : void 0;
          });
          if (inheritedTags) {
            tags = __spreadArray(__spreadArray([], inheritedTags), tags);
          }
        }
        return tags;
      }
      function getDocumentationComment(declarations, checker) {
        if (!declarations)
          return ts3.emptyArray;
        var doc = ts3.JsDoc.getJsDocCommentsFromDeclarations(declarations, checker);
        if (checker && (doc.length === 0 || declarations.some(hasJSDocInheritDocTag))) {
          var seenSymbols_1 = new ts3.Set();
          for (var _i = 0, declarations_4 = declarations; _i < declarations_4.length; _i++) {
            var declaration = declarations_4[_i];
            var inheritedDocs = findBaseOfDeclaration(checker, declaration, function(symbol) {
              if (!seenSymbols_1.has(symbol)) {
                seenSymbols_1.add(symbol);
                return symbol.getDocumentationComment(checker);
              }
            });
            if (inheritedDocs)
              doc = doc.length === 0 ? inheritedDocs.slice() : inheritedDocs.concat(ts3.lineBreakPart(), doc);
          }
        }
        return doc;
      }
      function findBaseOfDeclaration(checker, declaration, cb2) {
        return ts3.firstDefined(declaration.parent ? ts3.getAllSuperTypeNodes(declaration.parent) : ts3.emptyArray, function(superTypeNode) {
          var symbol = checker.getPropertyOfType(checker.getTypeAtLocation(superTypeNode), declaration.symbol.name);
          return symbol ? cb2(symbol) : void 0;
        });
      }
      var SourceFileObject = function(_super) {
        __extends2(SourceFileObject2, _super);
        function SourceFileObject2(kind, pos, end) {
          var _this = _super.call(this, kind, pos, end) || this;
          _this.kind = 298;
          return _this;
        }
        SourceFileObject2.prototype.update = function(newText, textChangeRange) {
          return ts3.updateSourceFile(this, newText, textChangeRange);
        };
        SourceFileObject2.prototype.getLineAndCharacterOfPosition = function(position) {
          return ts3.getLineAndCharacterOfPosition(this, position);
        };
        SourceFileObject2.prototype.getLineStarts = function() {
          return ts3.getLineStarts(this);
        };
        SourceFileObject2.prototype.getPositionOfLineAndCharacter = function(line, character, allowEdits) {
          return ts3.computePositionOfLineAndCharacter(ts3.getLineStarts(this), line, character, this.text, allowEdits);
        };
        SourceFileObject2.prototype.getLineEndOfPosition = function(pos) {
          var line = this.getLineAndCharacterOfPosition(pos).line;
          var lineStarts = this.getLineStarts();
          var lastCharPos;
          if (line + 1 >= lineStarts.length) {
            lastCharPos = this.getEnd();
          }
          if (!lastCharPos) {
            lastCharPos = lineStarts[line + 1] - 1;
          }
          var fullText = this.getFullText();
          return fullText[lastCharPos] === "\n" && fullText[lastCharPos - 1] === "\r" ? lastCharPos - 1 : lastCharPos;
        };
        SourceFileObject2.prototype.getNamedDeclarations = function() {
          if (!this.namedDeclarations) {
            this.namedDeclarations = this.computeNamedDeclarations();
          }
          return this.namedDeclarations;
        };
        SourceFileObject2.prototype.computeNamedDeclarations = function() {
          var result2 = ts3.createMultiMap();
          this.forEachChild(visit);
          return result2;
          function addDeclaration(declaration) {
            var name = getDeclarationName(declaration);
            if (name) {
              result2.add(name, declaration);
            }
          }
          function getDeclarations(name) {
            var declarations = result2.get(name);
            if (!declarations) {
              result2.set(name, declarations = []);
            }
            return declarations;
          }
          function getDeclarationName(declaration) {
            var name = ts3.getNonAssignedNameOfDeclaration(declaration);
            return name && (ts3.isComputedPropertyName(name) && ts3.isPropertyAccessExpression(name.expression) ? name.expression.name.text : ts3.isPropertyName(name) ? ts3.getNameFromPropertyName(name) : void 0);
          }
          function visit(node) {
            switch (node.kind) {
              case 252:
              case 209:
              case 166:
              case 165:
                var functionDeclaration = node;
                var declarationName = getDeclarationName(functionDeclaration);
                if (declarationName) {
                  var declarations = getDeclarations(declarationName);
                  var lastDeclaration = ts3.lastOrUndefined(declarations);
                  if (lastDeclaration && functionDeclaration.parent === lastDeclaration.parent && functionDeclaration.symbol === lastDeclaration.symbol) {
                    if (functionDeclaration.body && !lastDeclaration.body) {
                      declarations[declarations.length - 1] = functionDeclaration;
                    }
                  } else {
                    declarations.push(functionDeclaration);
                  }
                }
                ts3.forEachChild(node, visit);
                break;
              case 253:
              case 222:
              case 254:
              case 255:
              case 256:
              case 257:
              case 261:
              case 271:
              case 266:
              case 263:
              case 264:
              case 168:
              case 169:
              case 178:
                addDeclaration(node);
                ts3.forEachChild(node, visit);
                break;
              case 161:
                if (!ts3.hasSyntacticModifier(node, 16476)) {
                  break;
                }
              case 250:
              case 199: {
                var decl = node;
                if (ts3.isBindingPattern(decl.name)) {
                  ts3.forEachChild(decl.name, visit);
                  break;
                }
                if (decl.initializer) {
                  visit(decl.initializer);
                }
              }
              case 292:
              case 164:
              case 163:
                addDeclaration(node);
                break;
              case 268:
                var exportDeclaration = node;
                if (exportDeclaration.exportClause) {
                  if (ts3.isNamedExports(exportDeclaration.exportClause)) {
                    ts3.forEach(exportDeclaration.exportClause.elements, visit);
                  } else {
                    visit(exportDeclaration.exportClause.name);
                  }
                }
                break;
              case 262:
                var importClause = node.importClause;
                if (importClause) {
                  if (importClause.name) {
                    addDeclaration(importClause.name);
                  }
                  if (importClause.namedBindings) {
                    if (importClause.namedBindings.kind === 264) {
                      addDeclaration(importClause.namedBindings);
                    } else {
                      ts3.forEach(importClause.namedBindings.elements, visit);
                    }
                  }
                }
                break;
              case 217:
                if (ts3.getAssignmentDeclarationKind(node) !== 0) {
                  addDeclaration(node);
                }
              default:
                ts3.forEachChild(node, visit);
            }
          }
        };
        return SourceFileObject2;
      }(NodeObject);
      var SourceMapSourceObject = function() {
        function SourceMapSourceObject2(fileName, text, skipTrivia) {
          this.fileName = fileName;
          this.text = text;
          this.skipTrivia = skipTrivia;
        }
        SourceMapSourceObject2.prototype.getLineAndCharacterOfPosition = function(pos) {
          return ts3.getLineAndCharacterOfPosition(this, pos);
        };
        return SourceMapSourceObject2;
      }();
      function getServicesObjectAllocator() {
        return {
          getNodeConstructor: function() {
            return NodeObject;
          },
          getTokenConstructor: function() {
            return TokenObject;
          },
          getIdentifierConstructor: function() {
            return IdentifierObject;
          },
          getPrivateIdentifierConstructor: function() {
            return PrivateIdentifierObject;
          },
          getSourceFileConstructor: function() {
            return SourceFileObject;
          },
          getSymbolConstructor: function() {
            return SymbolObject;
          },
          getTypeConstructor: function() {
            return TypeObject;
          },
          getSignatureConstructor: function() {
            return SignatureObject;
          },
          getSourceMapSourceConstructor: function() {
            return SourceMapSourceObject;
          }
        };
      }
      function toEditorSettings(optionsAsMap) {
        var allPropertiesAreCamelCased = true;
        for (var key2 in optionsAsMap) {
          if (ts3.hasProperty(optionsAsMap, key2) && !isCamelCase(key2)) {
            allPropertiesAreCamelCased = false;
            break;
          }
        }
        if (allPropertiesAreCamelCased) {
          return optionsAsMap;
        }
        var settings = {};
        for (var key2 in optionsAsMap) {
          if (ts3.hasProperty(optionsAsMap, key2)) {
            var newKey = isCamelCase(key2) ? key2 : key2.charAt(0).toLowerCase() + key2.substr(1);
            settings[newKey] = optionsAsMap[key2];
          }
        }
        return settings;
      }
      ts3.toEditorSettings = toEditorSettings;
      function isCamelCase(s2) {
        return !s2.length || s2.charAt(0) === s2.charAt(0).toLowerCase();
      }
      function displayPartsToString(displayParts) {
        if (displayParts) {
          return ts3.map(displayParts, function(displayPart) {
            return displayPart.text;
          }).join("");
        }
        return "";
      }
      ts3.displayPartsToString = displayPartsToString;
      function getDefaultCompilerOptions() {
        return {
          target: 1,
          jsx: 1
        };
      }
      ts3.getDefaultCompilerOptions = getDefaultCompilerOptions;
      function getSupportedCodeFixes() {
        return ts3.codefix.getSupportedErrorCodes();
      }
      ts3.getSupportedCodeFixes = getSupportedCodeFixes;
      var HostCache = function() {
        function HostCache2(host, getCanonicalFileName) {
          this.host = host;
          this.currentDirectory = host.getCurrentDirectory();
          this.fileNameToEntry = new ts3.Map();
          var rootFileNames = host.getScriptFileNames();
          for (var _i = 0, rootFileNames_1 = rootFileNames; _i < rootFileNames_1.length; _i++) {
            var fileName = rootFileNames_1[_i];
            this.createEntry(fileName, ts3.toPath(fileName, this.currentDirectory, getCanonicalFileName));
          }
        }
        HostCache2.prototype.createEntry = function(fileName, path2) {
          var entry;
          var scriptSnapshot = this.host.getScriptSnapshot(fileName);
          if (scriptSnapshot) {
            entry = {
              hostFileName: fileName,
              version: this.host.getScriptVersion(fileName),
              scriptSnapshot,
              scriptKind: ts3.getScriptKind(fileName, this.host)
            };
          } else {
            entry = fileName;
          }
          this.fileNameToEntry.set(path2, entry);
          return entry;
        };
        HostCache2.prototype.getEntryByPath = function(path2) {
          return this.fileNameToEntry.get(path2);
        };
        HostCache2.prototype.getHostFileInformation = function(path2) {
          var entry = this.fileNameToEntry.get(path2);
          return !ts3.isString(entry) ? entry : void 0;
        };
        HostCache2.prototype.getOrCreateEntryByPath = function(fileName, path2) {
          var info = this.getEntryByPath(path2) || this.createEntry(fileName, path2);
          return ts3.isString(info) ? void 0 : info;
        };
        HostCache2.prototype.getRootFileNames = function() {
          var names = [];
          this.fileNameToEntry.forEach(function(entry) {
            if (ts3.isString(entry)) {
              names.push(entry);
            } else {
              names.push(entry.hostFileName);
            }
          });
          return names;
        };
        HostCache2.prototype.getScriptSnapshot = function(path2) {
          var file = this.getHostFileInformation(path2);
          return file && file.scriptSnapshot;
        };
        return HostCache2;
      }();
      var SyntaxTreeCache = function() {
        function SyntaxTreeCache2(host) {
          this.host = host;
        }
        SyntaxTreeCache2.prototype.getCurrentSourceFile = function(fileName) {
          var scriptSnapshot = this.host.getScriptSnapshot(fileName);
          if (!scriptSnapshot) {
            throw new Error("Could not find file: '" + fileName + "'.");
          }
          var scriptKind = ts3.getScriptKind(fileName, this.host);
          var version = this.host.getScriptVersion(fileName);
          var sourceFile;
          if (this.currentFileName !== fileName) {
            sourceFile = createLanguageServiceSourceFile(fileName, scriptSnapshot, 99, version, true, scriptKind);
          } else if (this.currentFileVersion !== version) {
            var editRange = scriptSnapshot.getChangeRange(this.currentFileScriptSnapshot);
            sourceFile = updateLanguageServiceSourceFile(this.currentSourceFile, scriptSnapshot, version, editRange);
          }
          if (sourceFile) {
            this.currentFileVersion = version;
            this.currentFileName = fileName;
            this.currentFileScriptSnapshot = scriptSnapshot;
            this.currentSourceFile = sourceFile;
          }
          return this.currentSourceFile;
        };
        return SyntaxTreeCache2;
      }();
      function setSourceFileFields(sourceFile, scriptSnapshot, version) {
        sourceFile.version = version;
        sourceFile.scriptSnapshot = scriptSnapshot;
      }
      function createLanguageServiceSourceFile(fileName, scriptSnapshot, scriptTarget, version, setNodeParents, scriptKind) {
        var sourceFile = ts3.createSourceFile(fileName, ts3.getSnapshotText(scriptSnapshot), scriptTarget, setNodeParents, scriptKind);
        setSourceFileFields(sourceFile, scriptSnapshot, version);
        return sourceFile;
      }
      ts3.createLanguageServiceSourceFile = createLanguageServiceSourceFile;
      function updateLanguageServiceSourceFile(sourceFile, scriptSnapshot, version, textChangeRange, aggressiveChecks) {
        if (textChangeRange) {
          if (version !== sourceFile.version) {
            var newText = void 0;
            var prefix2 = textChangeRange.span.start !== 0 ? sourceFile.text.substr(0, textChangeRange.span.start) : "";
            var suffix = ts3.textSpanEnd(textChangeRange.span) !== sourceFile.text.length ? sourceFile.text.substr(ts3.textSpanEnd(textChangeRange.span)) : "";
            if (textChangeRange.newLength === 0) {
              newText = prefix2 && suffix ? prefix2 + suffix : prefix2 || suffix;
            } else {
              var changedText = scriptSnapshot.getText(textChangeRange.span.start, textChangeRange.span.start + textChangeRange.newLength);
              newText = prefix2 && suffix ? prefix2 + changedText + suffix : prefix2 ? prefix2 + changedText : changedText + suffix;
            }
            var newSourceFile = ts3.updateSourceFile(sourceFile, newText, textChangeRange, aggressiveChecks);
            setSourceFileFields(newSourceFile, scriptSnapshot, version);
            newSourceFile.nameTable = void 0;
            if (sourceFile !== newSourceFile && sourceFile.scriptSnapshot) {
              if (sourceFile.scriptSnapshot.dispose) {
                sourceFile.scriptSnapshot.dispose();
              }
              sourceFile.scriptSnapshot = void 0;
            }
            return newSourceFile;
          }
        }
        return createLanguageServiceSourceFile(sourceFile.fileName, scriptSnapshot, sourceFile.languageVersion, version, true, sourceFile.scriptKind);
      }
      ts3.updateLanguageServiceSourceFile = updateLanguageServiceSourceFile;
      var NoopCancellationToken = {
        isCancellationRequested: ts3.returnFalse,
        throwIfCancellationRequested: ts3.noop
      };
      var CancellationTokenObject = function() {
        function CancellationTokenObject2(cancellationToken) {
          this.cancellationToken = cancellationToken;
        }
        CancellationTokenObject2.prototype.isCancellationRequested = function() {
          return this.cancellationToken.isCancellationRequested();
        };
        CancellationTokenObject2.prototype.throwIfCancellationRequested = function() {
          if (this.isCancellationRequested()) {
            ts3.tracing === null || ts3.tracing === void 0 ? void 0 : ts3.tracing.instant("session", "cancellationThrown", { kind: "CancellationTokenObject" });
            throw new ts3.OperationCanceledException();
          }
        };
        return CancellationTokenObject2;
      }();
      var ThrottledCancellationToken = function() {
        function ThrottledCancellationToken2(hostCancellationToken, throttleWaitMilliseconds) {
          if (throttleWaitMilliseconds === void 0) {
            throttleWaitMilliseconds = 20;
          }
          this.hostCancellationToken = hostCancellationToken;
          this.throttleWaitMilliseconds = throttleWaitMilliseconds;
          this.lastCancellationCheckTime = 0;
        }
        ThrottledCancellationToken2.prototype.isCancellationRequested = function() {
          var time = ts3.timestamp();
          var duration = Math.abs(time - this.lastCancellationCheckTime);
          if (duration >= this.throttleWaitMilliseconds) {
            this.lastCancellationCheckTime = time;
            return this.hostCancellationToken.isCancellationRequested();
          }
          return false;
        };
        ThrottledCancellationToken2.prototype.throwIfCancellationRequested = function() {
          if (this.isCancellationRequested()) {
            ts3.tracing === null || ts3.tracing === void 0 ? void 0 : ts3.tracing.instant("session", "cancellationThrown", { kind: "ThrottledCancellationToken" });
            throw new ts3.OperationCanceledException();
          }
        };
        return ThrottledCancellationToken2;
      }();
      ts3.ThrottledCancellationToken = ThrottledCancellationToken;
      var invalidOperationsInPartialSemanticMode = [
        "getSyntacticDiagnostics",
        "getSemanticDiagnostics",
        "getSuggestionDiagnostics",
        "getCompilerOptionsDiagnostics",
        "getSemanticClassifications",
        "getEncodedSemanticClassifications",
        "getCodeFixesAtPosition",
        "getCombinedCodeFix",
        "applyCodeActionCommand",
        "organizeImports",
        "getEditsForFileRename",
        "getEmitOutput",
        "getApplicableRefactors",
        "getEditsForRefactor",
        "prepareCallHierarchy",
        "provideCallHierarchyIncomingCalls",
        "provideCallHierarchyOutgoingCalls"
      ];
      var invalidOperationsInSyntacticMode = __spreadArray(__spreadArray([], invalidOperationsInPartialSemanticMode), [
        "getCompletionsAtPosition",
        "getCompletionEntryDetails",
        "getCompletionEntrySymbol",
        "getSignatureHelpItems",
        "getQuickInfoAtPosition",
        "getDefinitionAtPosition",
        "getDefinitionAndBoundSpan",
        "getImplementationAtPosition",
        "getTypeDefinitionAtPosition",
        "getReferencesAtPosition",
        "findReferences",
        "getOccurrencesAtPosition",
        "getDocumentHighlights",
        "getNavigateToItems",
        "getRenameInfo",
        "findRenameLocations",
        "getApplicableRefactors"
      ]);
      function createLanguageService(host, documentRegistry, syntaxOnlyOrLanguageServiceMode) {
        var _a2;
        if (documentRegistry === void 0) {
          documentRegistry = ts3.createDocumentRegistry(host.useCaseSensitiveFileNames && host.useCaseSensitiveFileNames(), host.getCurrentDirectory());
        }
        var languageServiceMode;
        if (syntaxOnlyOrLanguageServiceMode === void 0) {
          languageServiceMode = ts3.LanguageServiceMode.Semantic;
        } else if (typeof syntaxOnlyOrLanguageServiceMode === "boolean") {
          languageServiceMode = syntaxOnlyOrLanguageServiceMode ? ts3.LanguageServiceMode.Syntactic : ts3.LanguageServiceMode.Semantic;
        } else {
          languageServiceMode = syntaxOnlyOrLanguageServiceMode;
        }
        var syntaxTreeCache = new SyntaxTreeCache(host);
        var program2;
        var lastProjectVersion;
        var lastTypesRootVersion = 0;
        var cancellationToken = host.getCancellationToken ? new CancellationTokenObject(host.getCancellationToken()) : NoopCancellationToken;
        var currentDirectory = host.getCurrentDirectory();
        if (!ts3.localizedDiagnosticMessages && host.getLocalizedDiagnosticMessages) {
          ts3.setLocalizedDiagnosticMessages(host.getLocalizedDiagnosticMessages());
        }
        function log(message) {
          if (host.log) {
            host.log(message);
          }
        }
        var useCaseSensitiveFileNames = ts3.hostUsesCaseSensitiveFileNames(host);
        var getCanonicalFileName = ts3.createGetCanonicalFileName(useCaseSensitiveFileNames);
        var sourceMapper = ts3.getSourceMapper({
          useCaseSensitiveFileNames: function() {
            return useCaseSensitiveFileNames;
          },
          getCurrentDirectory: function() {
            return currentDirectory;
          },
          getProgram,
          fileExists: ts3.maybeBind(host, host.fileExists),
          readFile: ts3.maybeBind(host, host.readFile),
          getDocumentPositionMapper: ts3.maybeBind(host, host.getDocumentPositionMapper),
          getSourceFileLike: ts3.maybeBind(host, host.getSourceFileLike),
          log
        });
        function getValidSourceFile(fileName) {
          var sourceFile = program2.getSourceFile(fileName);
          if (!sourceFile) {
            var error = new Error("Could not find source file: '" + fileName + "'.");
            error.ProgramFiles = program2.getSourceFiles().map(function(f) {
              return f.fileName;
            });
            throw error;
          }
          return sourceFile;
        }
        function synchronizeHostData() {
          var _a3, _b, _c;
          ts3.Debug.assert(languageServiceMode !== ts3.LanguageServiceMode.Syntactic);
          if (host.getProjectVersion) {
            var hostProjectVersion = host.getProjectVersion();
            if (hostProjectVersion) {
              if (lastProjectVersion === hostProjectVersion && !((_a3 = host.hasChangedAutomaticTypeDirectiveNames) === null || _a3 === void 0 ? void 0 : _a3.call(host))) {
                return;
              }
              lastProjectVersion = hostProjectVersion;
            }
          }
          var typeRootsVersion = host.getTypeRootsVersion ? host.getTypeRootsVersion() : 0;
          if (lastTypesRootVersion !== typeRootsVersion) {
            log("TypeRoots version has changed; provide new program");
            program2 = void 0;
            lastTypesRootVersion = typeRootsVersion;
          }
          var hostCache = new HostCache(host, getCanonicalFileName);
          var rootFileNames = hostCache.getRootFileNames();
          var newSettings = host.getCompilationSettings() || getDefaultCompilerOptions();
          var hasInvalidatedResolution = host.hasInvalidatedResolution || ts3.returnFalse;
          var hasChangedAutomaticTypeDirectiveNames = ts3.maybeBind(host, host.hasChangedAutomaticTypeDirectiveNames);
          var projectReferences = (_b = host.getProjectReferences) === null || _b === void 0 ? void 0 : _b.call(host);
          var parsedCommandLines;
          var parseConfigHost = {
            useCaseSensitiveFileNames,
            fileExists,
            readFile,
            readDirectory,
            trace: ts3.maybeBind(host, host.trace),
            getCurrentDirectory: function() {
              return currentDirectory;
            },
            onUnRecoverableConfigFileDiagnostic: ts3.noop
          };
          if (ts3.isProgramUptoDate(program2, rootFileNames, newSettings, function(_path, fileName) {
            return host.getScriptVersion(fileName);
          }, fileExists, hasInvalidatedResolution, hasChangedAutomaticTypeDirectiveNames, getParsedCommandLine, projectReferences)) {
            return;
          }
          var compilerHost = {
            getSourceFile: getOrCreateSourceFile,
            getSourceFileByPath: getOrCreateSourceFileByPath,
            getCancellationToken: function() {
              return cancellationToken;
            },
            getCanonicalFileName,
            useCaseSensitiveFileNames: function() {
              return useCaseSensitiveFileNames;
            },
            getNewLine: function() {
              return ts3.getNewLineCharacter(newSettings, function() {
                return ts3.getNewLineOrDefaultFromHost(host);
              });
            },
            getDefaultLibFileName: function(options2) {
              return host.getDefaultLibFileName(options2);
            },
            writeFile: ts3.noop,
            getCurrentDirectory: function() {
              return currentDirectory;
            },
            fileExists,
            readFile,
            getSymlinkCache: ts3.maybeBind(host, host.getSymlinkCache),
            realpath: ts3.maybeBind(host, host.realpath),
            directoryExists: function(directoryName) {
              return ts3.directoryProbablyExists(directoryName, host);
            },
            getDirectories: function(path2) {
              return host.getDirectories ? host.getDirectories(path2) : [];
            },
            readDirectory,
            onReleaseOldSourceFile,
            onReleaseParsedCommandLine,
            hasInvalidatedResolution,
            hasChangedAutomaticTypeDirectiveNames,
            trace: parseConfigHost.trace,
            resolveModuleNames: ts3.maybeBind(host, host.resolveModuleNames),
            resolveTypeReferenceDirectives: ts3.maybeBind(host, host.resolveTypeReferenceDirectives),
            useSourceOfProjectReferenceRedirect: ts3.maybeBind(host, host.useSourceOfProjectReferenceRedirect),
            getParsedCommandLine
          };
          (_c = host.setCompilerHost) === null || _c === void 0 ? void 0 : _c.call(host, compilerHost);
          var documentRegistryBucketKey = documentRegistry.getKeyForCompilationSettings(newSettings);
          var options = {
            rootNames: rootFileNames,
            options: newSettings,
            host: compilerHost,
            oldProgram: program2,
            projectReferences
          };
          program2 = ts3.createProgram(options);
          hostCache = void 0;
          parsedCommandLines = void 0;
          sourceMapper.clearCache();
          program2.getTypeChecker();
          return;
          function getParsedCommandLine(fileName) {
            var path2 = ts3.toPath(fileName, currentDirectory, getCanonicalFileName);
            var existing = parsedCommandLines === null || parsedCommandLines === void 0 ? void 0 : parsedCommandLines.get(path2);
            if (existing !== void 0)
              return existing || void 0;
            var result2 = host.getParsedCommandLine ? host.getParsedCommandLine(fileName) : getParsedCommandLineOfConfigFileUsingSourceFile(fileName);
            (parsedCommandLines || (parsedCommandLines = new ts3.Map())).set(path2, result2 || false);
            return result2;
          }
          function getParsedCommandLineOfConfigFileUsingSourceFile(configFileName) {
            var result2 = getOrCreateSourceFile(configFileName, 100);
            if (!result2)
              return void 0;
            result2.path = ts3.toPath(configFileName, currentDirectory, getCanonicalFileName);
            result2.resolvedPath = result2.path;
            result2.originalFileName = result2.fileName;
            return ts3.parseJsonSourceFileConfigFileContent(result2, parseConfigHost, ts3.getNormalizedAbsolutePath(ts3.getDirectoryPath(configFileName), currentDirectory), void 0, ts3.getNormalizedAbsolutePath(configFileName, currentDirectory));
          }
          function onReleaseParsedCommandLine(configFileName, oldResolvedRef, oldOptions) {
            var _a4;
            if (host.getParsedCommandLine) {
              (_a4 = host.onReleaseParsedCommandLine) === null || _a4 === void 0 ? void 0 : _a4.call(host, configFileName, oldResolvedRef, oldOptions);
            } else if (oldResolvedRef) {
              onReleaseOldSourceFile(oldResolvedRef.sourceFile, oldOptions);
            }
          }
          function fileExists(fileName) {
            var path2 = ts3.toPath(fileName, currentDirectory, getCanonicalFileName);
            var entry = hostCache && hostCache.getEntryByPath(path2);
            return entry ? !ts3.isString(entry) : !!host.fileExists && host.fileExists(fileName);
          }
          function readFile(fileName) {
            var path2 = ts3.toPath(fileName, currentDirectory, getCanonicalFileName);
            var entry = hostCache && hostCache.getEntryByPath(path2);
            if (entry) {
              return ts3.isString(entry) ? void 0 : ts3.getSnapshotText(entry.scriptSnapshot);
            }
            return host.readFile && host.readFile(fileName);
          }
          function readDirectory(path2, extensions, exclude, include, depth) {
            ts3.Debug.checkDefined(host.readDirectory, "'LanguageServiceHost.readDirectory' must be implemented to correctly process 'projectReferences'");
            return host.readDirectory(path2, extensions, exclude, include, depth);
          }
          function onReleaseOldSourceFile(oldSourceFile, oldOptions) {
            var oldSettingsKey = documentRegistry.getKeyForCompilationSettings(oldOptions);
            documentRegistry.releaseDocumentWithKey(oldSourceFile.resolvedPath, oldSettingsKey, oldSourceFile.scriptKind);
          }
          function getOrCreateSourceFile(fileName, languageVersion, onError, shouldCreateNewSourceFile) {
            return getOrCreateSourceFileByPath(fileName, ts3.toPath(fileName, currentDirectory, getCanonicalFileName), languageVersion, onError, shouldCreateNewSourceFile);
          }
          function getOrCreateSourceFileByPath(fileName, path2, _languageVersion, _onError, shouldCreateNewSourceFile) {
            ts3.Debug.assert(hostCache !== void 0, "getOrCreateSourceFileByPath called after typical CompilerHost lifetime, check the callstack something with a reference to an old host.");
            var hostFileInformation = hostCache && hostCache.getOrCreateEntryByPath(fileName, path2);
            if (!hostFileInformation) {
              return void 0;
            }
            if (!shouldCreateNewSourceFile) {
              var oldSourceFile = program2 && program2.getSourceFileByPath(path2);
              if (oldSourceFile) {
                if (hostFileInformation.scriptKind === oldSourceFile.scriptKind) {
                  return documentRegistry.updateDocumentWithKey(fileName, path2, newSettings, documentRegistryBucketKey, hostFileInformation.scriptSnapshot, hostFileInformation.version, hostFileInformation.scriptKind);
                } else {
                  documentRegistry.releaseDocumentWithKey(oldSourceFile.resolvedPath, documentRegistry.getKeyForCompilationSettings(program2.getCompilerOptions()), oldSourceFile.scriptKind);
                }
              }
            }
            return documentRegistry.acquireDocumentWithKey(fileName, path2, newSettings, documentRegistryBucketKey, hostFileInformation.scriptSnapshot, hostFileInformation.version, hostFileInformation.scriptKind);
          }
        }
        function getProgram() {
          if (languageServiceMode === ts3.LanguageServiceMode.Syntactic) {
            ts3.Debug.assert(program2 === void 0);
            return void 0;
          }
          synchronizeHostData();
          return program2;
        }
        function getAutoImportProvider() {
          var _a3;
          return (_a3 = host.getPackageJsonAutoImportProvider) === null || _a3 === void 0 ? void 0 : _a3.call(host);
        }
        function cleanupSemanticCache() {
          program2 = void 0;
        }
        function dispose() {
          if (program2) {
            var key_1 = documentRegistry.getKeyForCompilationSettings(program2.getCompilerOptions());
            ts3.forEach(program2.getSourceFiles(), function(f) {
              return documentRegistry.releaseDocumentWithKey(f.resolvedPath, key_1, f.scriptKind);
            });
            program2 = void 0;
          }
          host = void 0;
        }
        function getSyntacticDiagnostics(fileName) {
          synchronizeHostData();
          return program2.getSyntacticDiagnostics(getValidSourceFile(fileName), cancellationToken).slice();
        }
        function getSemanticDiagnostics(fileName) {
          synchronizeHostData();
          var targetSourceFile = getValidSourceFile(fileName);
          var semanticDiagnostics = program2.getSemanticDiagnostics(targetSourceFile, cancellationToken);
          if (!ts3.getEmitDeclarations(program2.getCompilerOptions())) {
            return semanticDiagnostics.slice();
          }
          var declarationDiagnostics = program2.getDeclarationDiagnostics(targetSourceFile, cancellationToken);
          return __spreadArray(__spreadArray([], semanticDiagnostics), declarationDiagnostics);
        }
        function getSuggestionDiagnostics(fileName) {
          synchronizeHostData();
          return ts3.computeSuggestionDiagnostics(getValidSourceFile(fileName), program2, cancellationToken);
        }
        function getCompilerOptionsDiagnostics() {
          synchronizeHostData();
          return __spreadArray(__spreadArray([], program2.getOptionsDiagnostics(cancellationToken)), program2.getGlobalDiagnostics(cancellationToken));
        }
        function getCompletionsAtPosition(fileName, position, options) {
          if (options === void 0) {
            options = ts3.emptyOptions;
          }
          var fullPreferences = __assign(__assign({}, ts3.identity(options)), { includeCompletionsForModuleExports: options.includeCompletionsForModuleExports || options.includeExternalModuleExports, includeCompletionsWithInsertText: options.includeCompletionsWithInsertText || options.includeInsertTextCompletions });
          synchronizeHostData();
          return ts3.Completions.getCompletionsAtPosition(host, program2, log, getValidSourceFile(fileName), position, fullPreferences, options.triggerCharacter);
        }
        function getCompletionEntryDetails(fileName, position, name, formattingOptions, source, preferences, data) {
          if (preferences === void 0) {
            preferences = ts3.emptyOptions;
          }
          synchronizeHostData();
          return ts3.Completions.getCompletionEntryDetails(program2, log, getValidSourceFile(fileName), position, { name, source, data }, host, formattingOptions && ts3.formatting.getFormatContext(formattingOptions, host), preferences, cancellationToken);
        }
        function getCompletionEntrySymbol(fileName, position, name, source, preferences) {
          if (preferences === void 0) {
            preferences = ts3.emptyOptions;
          }
          synchronizeHostData();
          return ts3.Completions.getCompletionEntrySymbol(program2, log, getValidSourceFile(fileName), position, { name, source }, host, preferences);
        }
        function getQuickInfoAtPosition(fileName, position) {
          synchronizeHostData();
          var sourceFile = getValidSourceFile(fileName);
          var node = ts3.getTouchingPropertyName(sourceFile, position);
          if (node === sourceFile) {
            return void 0;
          }
          var typeChecker = program2.getTypeChecker();
          var nodeForQuickInfo = getNodeForQuickInfo(node);
          var symbol = getSymbolAtLocationForQuickInfo(nodeForQuickInfo, typeChecker);
          if (!symbol || typeChecker.isUnknownSymbol(symbol)) {
            var type_2 = shouldGetType(sourceFile, nodeForQuickInfo, position) ? typeChecker.getTypeAtLocation(nodeForQuickInfo) : void 0;
            return type_2 && {
              kind: "",
              kindModifiers: "",
              textSpan: ts3.createTextSpanFromNode(nodeForQuickInfo, sourceFile),
              displayParts: typeChecker.runWithCancellationToken(cancellationToken, function(typeChecker2) {
                return ts3.typeToDisplayParts(typeChecker2, type_2, ts3.getContainerNode(nodeForQuickInfo));
              }),
              documentation: type_2.symbol ? type_2.symbol.getDocumentationComment(typeChecker) : void 0,
              tags: type_2.symbol ? type_2.symbol.getJsDocTags(typeChecker) : void 0
            };
          }
          var _a3 = typeChecker.runWithCancellationToken(cancellationToken, function(typeChecker2) {
            return ts3.SymbolDisplay.getSymbolDisplayPartsDocumentationAndSymbolKind(typeChecker2, symbol, sourceFile, ts3.getContainerNode(nodeForQuickInfo), nodeForQuickInfo);
          }), symbolKind = _a3.symbolKind, displayParts = _a3.displayParts, documentation = _a3.documentation, tags = _a3.tags;
          return {
            kind: symbolKind,
            kindModifiers: ts3.SymbolDisplay.getSymbolModifiers(typeChecker, symbol),
            textSpan: ts3.createTextSpanFromNode(nodeForQuickInfo, sourceFile),
            displayParts,
            documentation,
            tags
          };
        }
        function getNodeForQuickInfo(node) {
          if (ts3.isNewExpression(node.parent) && node.pos === node.parent.pos) {
            return node.parent.expression;
          }
          if (ts3.isNamedTupleMember(node.parent) && node.pos === node.parent.pos) {
            return node.parent;
          }
          return node;
        }
        function shouldGetType(sourceFile, node, position) {
          switch (node.kind) {
            case 78:
              return !ts3.isLabelName(node) && !ts3.isTagName(node) && !ts3.isConstTypeReference(node.parent);
            case 202:
            case 158:
              return !ts3.isInComment(sourceFile, position);
            case 107:
            case 188:
            case 105:
            case 193:
              return true;
            default:
              return false;
          }
        }
        function getDefinitionAtPosition(fileName, position) {
          synchronizeHostData();
          return ts3.GoToDefinition.getDefinitionAtPosition(program2, getValidSourceFile(fileName), position);
        }
        function getDefinitionAndBoundSpan(fileName, position) {
          synchronizeHostData();
          return ts3.GoToDefinition.getDefinitionAndBoundSpan(program2, getValidSourceFile(fileName), position);
        }
        function getTypeDefinitionAtPosition(fileName, position) {
          synchronizeHostData();
          return ts3.GoToDefinition.getTypeDefinitionAtPosition(program2.getTypeChecker(), getValidSourceFile(fileName), position);
        }
        function getImplementationAtPosition(fileName, position) {
          synchronizeHostData();
          return ts3.FindAllReferences.getImplementationsAtPosition(program2, cancellationToken, program2.getSourceFiles(), getValidSourceFile(fileName), position);
        }
        function getOccurrencesAtPosition(fileName, position) {
          return ts3.flatMap(getDocumentHighlights(fileName, position, [fileName]), function(entry) {
            return entry.highlightSpans.map(function(highlightSpan) {
              return __assign(__assign({ fileName: entry.fileName, textSpan: highlightSpan.textSpan, isWriteAccess: highlightSpan.kind === "writtenReference", isDefinition: false }, highlightSpan.isInString && { isInString: true }), highlightSpan.contextSpan && { contextSpan: highlightSpan.contextSpan });
            });
          });
        }
        function getDocumentHighlights(fileName, position, filesToSearch) {
          var normalizedFileName = ts3.normalizePath(fileName);
          ts3.Debug.assert(filesToSearch.some(function(f) {
            return ts3.normalizePath(f) === normalizedFileName;
          }));
          synchronizeHostData();
          var sourceFilesToSearch = ts3.mapDefined(filesToSearch, function(fileName2) {
            return program2.getSourceFile(fileName2);
          });
          var sourceFile = getValidSourceFile(fileName);
          return ts3.DocumentHighlights.getDocumentHighlights(program2, cancellationToken, sourceFile, position, sourceFilesToSearch);
        }
        function findRenameLocations(fileName, position, findInStrings, findInComments, providePrefixAndSuffixTextForRename) {
          synchronizeHostData();
          var sourceFile = getValidSourceFile(fileName);
          var node = ts3.getAdjustedRenameLocation(ts3.getTouchingPropertyName(sourceFile, position));
          if (ts3.isIdentifier(node) && (ts3.isJsxOpeningElement(node.parent) || ts3.isJsxClosingElement(node.parent)) && ts3.isIntrinsicJsxName(node.escapedText)) {
            var _a3 = node.parent.parent, openingElement = _a3.openingElement, closingElement = _a3.closingElement;
            return [openingElement, closingElement].map(function(node2) {
              var textSpan = ts3.createTextSpanFromNode(node2.tagName, sourceFile);
              return __assign({ fileName: sourceFile.fileName, textSpan }, ts3.FindAllReferences.toContextSpan(textSpan, sourceFile, node2.parent));
            });
          } else {
            return getReferencesWorker(node, position, { findInStrings, findInComments, providePrefixAndSuffixTextForRename, use: 2 }, function(entry, originalNode, checker) {
              return ts3.FindAllReferences.toRenameLocation(entry, originalNode, checker, providePrefixAndSuffixTextForRename || false);
            });
          }
        }
        function getReferencesAtPosition(fileName, position) {
          synchronizeHostData();
          return getReferencesWorker(ts3.getTouchingPropertyName(getValidSourceFile(fileName), position), position, { use: 1 }, ts3.FindAllReferences.toReferenceEntry);
        }
        function getReferencesWorker(node, position, options, cb2) {
          synchronizeHostData();
          var sourceFiles = options && options.use === 2 ? program2.getSourceFiles().filter(function(sourceFile) {
            return !program2.isSourceFileDefaultLibrary(sourceFile);
          }) : program2.getSourceFiles();
          return ts3.FindAllReferences.findReferenceOrRenameEntries(program2, cancellationToken, sourceFiles, node, position, options, cb2);
        }
        function findReferences(fileName, position) {
          synchronizeHostData();
          return ts3.FindAllReferences.findReferencedSymbols(program2, cancellationToken, program2.getSourceFiles(), getValidSourceFile(fileName), position);
        }
        function getFileReferences(fileName) {
          synchronizeHostData();
          return ts3.FindAllReferences.Core.getReferencesForFileName(fileName, program2, program2.getSourceFiles()).map(ts3.FindAllReferences.toReferenceEntry);
        }
        function getNavigateToItems(searchValue, maxResultCount, fileName, excludeDtsFiles) {
          if (excludeDtsFiles === void 0) {
            excludeDtsFiles = false;
          }
          synchronizeHostData();
          var sourceFiles = fileName ? [getValidSourceFile(fileName)] : program2.getSourceFiles();
          return ts3.NavigateTo.getNavigateToItems(sourceFiles, program2.getTypeChecker(), cancellationToken, searchValue, maxResultCount, excludeDtsFiles);
        }
        function getEmitOutput(fileName, emitOnlyDtsFiles, forceDtsEmit) {
          synchronizeHostData();
          var sourceFile = getValidSourceFile(fileName);
          var customTransformers = host.getCustomTransformers && host.getCustomTransformers();
          return ts3.getFileEmitOutput(program2, sourceFile, !!emitOnlyDtsFiles, cancellationToken, customTransformers, forceDtsEmit);
        }
        function getSignatureHelpItems(fileName, position, _a3) {
          var _b = _a3 === void 0 ? ts3.emptyOptions : _a3, triggerReason = _b.triggerReason;
          synchronizeHostData();
          var sourceFile = getValidSourceFile(fileName);
          return ts3.SignatureHelp.getSignatureHelpItems(program2, sourceFile, position, triggerReason, cancellationToken);
        }
        function getNonBoundSourceFile(fileName) {
          return syntaxTreeCache.getCurrentSourceFile(fileName);
        }
        function getNameOrDottedNameSpan(fileName, startPos, _endPos) {
          var sourceFile = syntaxTreeCache.getCurrentSourceFile(fileName);
          var node = ts3.getTouchingPropertyName(sourceFile, startPos);
          if (node === sourceFile) {
            return void 0;
          }
          switch (node.kind) {
            case 202:
            case 158:
            case 10:
            case 94:
            case 109:
            case 103:
            case 105:
            case 107:
            case 188:
            case 78:
              break;
            default:
              return void 0;
          }
          var nodeForStartPos = node;
          while (true) {
            if (ts3.isRightSideOfPropertyAccess(nodeForStartPos) || ts3.isRightSideOfQualifiedName(nodeForStartPos)) {
              nodeForStartPos = nodeForStartPos.parent;
            } else if (ts3.isNameOfModuleDeclaration(nodeForStartPos)) {
              if (nodeForStartPos.parent.parent.kind === 257 && nodeForStartPos.parent.parent.body === nodeForStartPos.parent) {
                nodeForStartPos = nodeForStartPos.parent.parent.name;
              } else {
                break;
              }
            } else {
              break;
            }
          }
          return ts3.createTextSpanFromBounds(nodeForStartPos.getStart(), node.getEnd());
        }
        function getBreakpointStatementAtPosition(fileName, position) {
          var sourceFile = syntaxTreeCache.getCurrentSourceFile(fileName);
          return ts3.BreakpointResolver.spanInSourceFileAtLocation(sourceFile, position);
        }
        function getNavigationBarItems(fileName) {
          return ts3.NavigationBar.getNavigationBarItems(syntaxTreeCache.getCurrentSourceFile(fileName), cancellationToken);
        }
        function getNavigationTree(fileName) {
          return ts3.NavigationBar.getNavigationTree(syntaxTreeCache.getCurrentSourceFile(fileName), cancellationToken);
        }
        function getSemanticClassifications(fileName, span, format) {
          synchronizeHostData();
          var responseFormat = format || "original";
          if (responseFormat === "2020") {
            return ts3.classifier.v2020.getSemanticClassifications(program2, cancellationToken, getValidSourceFile(fileName), span);
          } else {
            return ts3.getSemanticClassifications(program2.getTypeChecker(), cancellationToken, getValidSourceFile(fileName), program2.getClassifiableNames(), span);
          }
        }
        function getEncodedSemanticClassifications(fileName, span, format) {
          synchronizeHostData();
          var responseFormat = format || "original";
          if (responseFormat === "original") {
            return ts3.getEncodedSemanticClassifications(program2.getTypeChecker(), cancellationToken, getValidSourceFile(fileName), program2.getClassifiableNames(), span);
          } else {
            return ts3.classifier.v2020.getEncodedSemanticClassifications(program2, cancellationToken, getValidSourceFile(fileName), span);
          }
        }
        function getSyntacticClassifications(fileName, span) {
          return ts3.getSyntacticClassifications(cancellationToken, syntaxTreeCache.getCurrentSourceFile(fileName), span);
        }
        function getEncodedSyntacticClassifications(fileName, span) {
          return ts3.getEncodedSyntacticClassifications(cancellationToken, syntaxTreeCache.getCurrentSourceFile(fileName), span);
        }
        function getOutliningSpans(fileName) {
          var sourceFile = syntaxTreeCache.getCurrentSourceFile(fileName);
          return ts3.OutliningElementsCollector.collectElements(sourceFile, cancellationToken);
        }
        var braceMatching = new ts3.Map(ts3.getEntries((_a2 = {}, _a2[18] = 19, _a2[20] = 21, _a2[22] = 23, _a2[31] = 29, _a2)));
        braceMatching.forEach(function(value, key2) {
          return braceMatching.set(value.toString(), Number(key2));
        });
        function getBraceMatchingAtPosition(fileName, position) {
          var sourceFile = syntaxTreeCache.getCurrentSourceFile(fileName);
          var token = ts3.getTouchingToken(sourceFile, position);
          var matchKind = token.getStart(sourceFile) === position ? braceMatching.get(token.kind.toString()) : void 0;
          var match = matchKind && ts3.findChildOfKind(token.parent, matchKind, sourceFile);
          return match ? [ts3.createTextSpanFromNode(token, sourceFile), ts3.createTextSpanFromNode(match, sourceFile)].sort(function(a2, b2) {
            return a2.start - b2.start;
          }) : ts3.emptyArray;
        }
        function getIndentationAtPosition(fileName, position, editorOptions) {
          var start = ts3.timestamp();
          var settings = toEditorSettings(editorOptions);
          var sourceFile = syntaxTreeCache.getCurrentSourceFile(fileName);
          log("getIndentationAtPosition: getCurrentSourceFile: " + (ts3.timestamp() - start));
          start = ts3.timestamp();
          var result2 = ts3.formatting.SmartIndenter.getIndentation(position, sourceFile, settings);
          log("getIndentationAtPosition: computeIndentation  : " + (ts3.timestamp() - start));
          return result2;
        }
        function getFormattingEditsForRange(fileName, start, end, options) {
          var sourceFile = syntaxTreeCache.getCurrentSourceFile(fileName);
          return ts3.formatting.formatSelection(start, end, sourceFile, ts3.formatting.getFormatContext(toEditorSettings(options), host));
        }
        function getFormattingEditsForDocument(fileName, options) {
          return ts3.formatting.formatDocument(syntaxTreeCache.getCurrentSourceFile(fileName), ts3.formatting.getFormatContext(toEditorSettings(options), host));
        }
        function getFormattingEditsAfterKeystroke(fileName, position, key2, options) {
          var sourceFile = syntaxTreeCache.getCurrentSourceFile(fileName);
          var formatContext = ts3.formatting.getFormatContext(toEditorSettings(options), host);
          if (!ts3.isInComment(sourceFile, position)) {
            switch (key2) {
              case "{":
                return ts3.formatting.formatOnOpeningCurly(position, sourceFile, formatContext);
              case "}":
                return ts3.formatting.formatOnClosingCurly(position, sourceFile, formatContext);
              case ";":
                return ts3.formatting.formatOnSemicolon(position, sourceFile, formatContext);
              case "\n":
                return ts3.formatting.formatOnEnter(position, sourceFile, formatContext);
            }
          }
          return [];
        }
        function getCodeFixesAtPosition(fileName, start, end, errorCodes, formatOptions, preferences) {
          if (preferences === void 0) {
            preferences = ts3.emptyOptions;
          }
          synchronizeHostData();
          var sourceFile = getValidSourceFile(fileName);
          var span = ts3.createTextSpanFromBounds(start, end);
          var formatContext = ts3.formatting.getFormatContext(formatOptions, host);
          return ts3.flatMap(ts3.deduplicate(errorCodes, ts3.equateValues, ts3.compareValues), function(errorCode) {
            cancellationToken.throwIfCancellationRequested();
            return ts3.codefix.getFixes({ errorCode, sourceFile, span, program: program2, host, cancellationToken, formatContext, preferences });
          });
        }
        function getCombinedCodeFix(scope, fixId, formatOptions, preferences) {
          if (preferences === void 0) {
            preferences = ts3.emptyOptions;
          }
          synchronizeHostData();
          ts3.Debug.assert(scope.type === "file");
          var sourceFile = getValidSourceFile(scope.fileName);
          var formatContext = ts3.formatting.getFormatContext(formatOptions, host);
          return ts3.codefix.getAllFixes({ fixId, sourceFile, program: program2, host, cancellationToken, formatContext, preferences });
        }
        function organizeImports(args, formatOptions, preferences) {
          if (preferences === void 0) {
            preferences = ts3.emptyOptions;
          }
          synchronizeHostData();
          ts3.Debug.assert(args.type === "file");
          var sourceFile = getValidSourceFile(args.fileName);
          var formatContext = ts3.formatting.getFormatContext(formatOptions, host);
          return ts3.OrganizeImports.organizeImports(sourceFile, formatContext, host, program2, preferences, args.skipDestructiveCodeActions);
        }
        function getEditsForFileRename(oldFilePath, newFilePath, formatOptions, preferences) {
          if (preferences === void 0) {
            preferences = ts3.emptyOptions;
          }
          return ts3.getEditsForFileRename(getProgram(), oldFilePath, newFilePath, host, ts3.formatting.getFormatContext(formatOptions, host), preferences, sourceMapper);
        }
        function applyCodeActionCommand(fileName, actionOrFormatSettingsOrUndefined) {
          var action = typeof fileName === "string" ? actionOrFormatSettingsOrUndefined : fileName;
          return ts3.isArray(action) ? Promise.all(action.map(function(a2) {
            return applySingleCodeActionCommand(a2);
          })) : applySingleCodeActionCommand(action);
        }
        function applySingleCodeActionCommand(action) {
          var getPath = function(path2) {
            return ts3.toPath(path2, currentDirectory, getCanonicalFileName);
          };
          ts3.Debug.assertEqual(action.type, "install package");
          return host.installPackage ? host.installPackage({ fileName: getPath(action.file), packageName: action.packageName }) : Promise.reject("Host does not implement `installPackage`");
        }
        function getDocCommentTemplateAtPosition(fileName, position, options) {
          return ts3.JsDoc.getDocCommentTemplateAtPosition(ts3.getNewLineOrDefaultFromHost(host), syntaxTreeCache.getCurrentSourceFile(fileName), position, options);
        }
        function isValidBraceCompletionAtPosition(fileName, position, openingBrace) {
          if (openingBrace === 60) {
            return false;
          }
          var sourceFile = syntaxTreeCache.getCurrentSourceFile(fileName);
          if (ts3.isInString(sourceFile, position)) {
            return false;
          }
          if (ts3.isInsideJsxElementOrAttribute(sourceFile, position)) {
            return openingBrace === 123;
          }
          if (ts3.isInTemplateString(sourceFile, position)) {
            return false;
          }
          switch (openingBrace) {
            case 39:
            case 34:
            case 96:
              return !ts3.isInComment(sourceFile, position);
          }
          return true;
        }
        function getJsxClosingTagAtPosition(fileName, position) {
          var sourceFile = syntaxTreeCache.getCurrentSourceFile(fileName);
          var token = ts3.findPrecedingToken(position, sourceFile);
          if (!token)
            return void 0;
          var element = token.kind === 31 && ts3.isJsxOpeningElement(token.parent) ? token.parent.parent : ts3.isJsxText(token) ? token.parent : void 0;
          if (element && isUnclosedTag(element)) {
            return { newText: "</" + element.openingElement.tagName.getText(sourceFile) + ">" };
          }
        }
        function getLinesForRange(sourceFile, textRange) {
          return {
            lineStarts: sourceFile.getLineStarts(),
            firstLine: sourceFile.getLineAndCharacterOfPosition(textRange.pos).line,
            lastLine: sourceFile.getLineAndCharacterOfPosition(textRange.end).line
          };
        }
        function toggleLineComment(fileName, textRange, insertComment) {
          var sourceFile = syntaxTreeCache.getCurrentSourceFile(fileName);
          var textChanges = [];
          var _a3 = getLinesForRange(sourceFile, textRange), lineStarts = _a3.lineStarts, firstLine = _a3.firstLine, lastLine = _a3.lastLine;
          var isCommenting = insertComment || false;
          var leftMostPosition = Number.MAX_VALUE;
          var lineTextStarts = new ts3.Map();
          var firstNonWhitespaceCharacterRegex = new RegExp(/\S/);
          var isJsx = ts3.isInsideJsxElement(sourceFile, lineStarts[firstLine]);
          var openComment = isJsx ? "{/*" : "//";
          for (var i3 = firstLine; i3 <= lastLine; i3++) {
            var lineText = sourceFile.text.substring(lineStarts[i3], sourceFile.getLineEndOfPosition(lineStarts[i3]));
            var regExec = firstNonWhitespaceCharacterRegex.exec(lineText);
            if (regExec) {
              leftMostPosition = Math.min(leftMostPosition, regExec.index);
              lineTextStarts.set(i3.toString(), regExec.index);
              if (lineText.substr(regExec.index, openComment.length) !== openComment) {
                isCommenting = insertComment === void 0 || insertComment;
              }
            }
          }
          for (var i3 = firstLine; i3 <= lastLine; i3++) {
            if (firstLine !== lastLine && lineStarts[i3] === textRange.end) {
              continue;
            }
            var lineTextStart = lineTextStarts.get(i3.toString());
            if (lineTextStart !== void 0) {
              if (isJsx) {
                textChanges.push.apply(textChanges, toggleMultilineComment(fileName, { pos: lineStarts[i3] + leftMostPosition, end: sourceFile.getLineEndOfPosition(lineStarts[i3]) }, isCommenting, isJsx));
              } else if (isCommenting) {
                textChanges.push({
                  newText: openComment,
                  span: {
                    length: 0,
                    start: lineStarts[i3] + leftMostPosition
                  }
                });
              } else if (sourceFile.text.substr(lineStarts[i3] + lineTextStart, openComment.length) === openComment) {
                textChanges.push({
                  newText: "",
                  span: {
                    length: openComment.length,
                    start: lineStarts[i3] + lineTextStart
                  }
                });
              }
            }
          }
          return textChanges;
        }
        function toggleMultilineComment(fileName, textRange, insertComment, isInsideJsx) {
          var _a3;
          var sourceFile = syntaxTreeCache.getCurrentSourceFile(fileName);
          var textChanges = [];
          var text = sourceFile.text;
          var hasComment = false;
          var isCommenting = insertComment || false;
          var positions = [];
          var pos = textRange.pos;
          var isJsx = isInsideJsx !== void 0 ? isInsideJsx : ts3.isInsideJsxElement(sourceFile, pos);
          var openMultiline = isJsx ? "{/*" : "/*";
          var closeMultiline = isJsx ? "*/}" : "*/";
          var openMultilineRegex = isJsx ? "\\{\\/\\*" : "\\/\\*";
          var closeMultilineRegex = isJsx ? "\\*\\/\\}" : "\\*\\/";
          while (pos <= textRange.end) {
            var offset = text.substr(pos, openMultiline.length) === openMultiline ? openMultiline.length : 0;
            var commentRange = ts3.isInComment(sourceFile, pos + offset);
            if (commentRange) {
              if (isJsx) {
                commentRange.pos--;
                commentRange.end++;
              }
              positions.push(commentRange.pos);
              if (commentRange.kind === 3) {
                positions.push(commentRange.end);
              }
              hasComment = true;
              pos = commentRange.end + 1;
            } else {
              var newPos = text.substring(pos, textRange.end).search("(" + openMultilineRegex + ")|(" + closeMultilineRegex + ")");
              isCommenting = insertComment !== void 0 ? insertComment : isCommenting || !ts3.isTextWhiteSpaceLike(text, pos, newPos === -1 ? textRange.end : pos + newPos);
              pos = newPos === -1 ? textRange.end + 1 : pos + newPos + closeMultiline.length;
            }
          }
          if (isCommenting || !hasComment) {
            if (((_a3 = ts3.isInComment(sourceFile, textRange.pos)) === null || _a3 === void 0 ? void 0 : _a3.kind) !== 2) {
              ts3.insertSorted(positions, textRange.pos, ts3.compareValues);
            }
            ts3.insertSorted(positions, textRange.end, ts3.compareValues);
            var firstPos = positions[0];
            if (text.substr(firstPos, openMultiline.length) !== openMultiline) {
              textChanges.push({
                newText: openMultiline,
                span: {
                  length: 0,
                  start: firstPos
                }
              });
            }
            for (var i3 = 1; i3 < positions.length - 1; i3++) {
              if (text.substr(positions[i3] - closeMultiline.length, closeMultiline.length) !== closeMultiline) {
                textChanges.push({
                  newText: closeMultiline,
                  span: {
                    length: 0,
                    start: positions[i3]
                  }
                });
              }
              if (text.substr(positions[i3], openMultiline.length) !== openMultiline) {
                textChanges.push({
                  newText: openMultiline,
                  span: {
                    length: 0,
                    start: positions[i3]
                  }
                });
              }
            }
            if (textChanges.length % 2 !== 0) {
              textChanges.push({
                newText: closeMultiline,
                span: {
                  length: 0,
                  start: positions[positions.length - 1]
                }
              });
            }
          } else {
            for (var _i = 0, positions_1 = positions; _i < positions_1.length; _i++) {
              var pos_1 = positions_1[_i];
              var from = pos_1 - closeMultiline.length > 0 ? pos_1 - closeMultiline.length : 0;
              var offset = text.substr(from, closeMultiline.length) === closeMultiline ? closeMultiline.length : 0;
              textChanges.push({
                newText: "",
                span: {
                  length: openMultiline.length,
                  start: pos_1 - offset
                }
              });
            }
          }
          return textChanges;
        }
        function commentSelection(fileName, textRange) {
          var sourceFile = syntaxTreeCache.getCurrentSourceFile(fileName);
          var _a3 = getLinesForRange(sourceFile, textRange), firstLine = _a3.firstLine, lastLine = _a3.lastLine;
          return firstLine === lastLine && textRange.pos !== textRange.end ? toggleMultilineComment(fileName, textRange, true) : toggleLineComment(fileName, textRange, true);
        }
        function uncommentSelection(fileName, textRange) {
          var sourceFile = syntaxTreeCache.getCurrentSourceFile(fileName);
          var textChanges = [];
          var pos = textRange.pos;
          var end = textRange.end;
          if (pos === end) {
            end += ts3.isInsideJsxElement(sourceFile, pos) ? 2 : 1;
          }
          for (var i3 = pos; i3 <= end; i3++) {
            var commentRange = ts3.isInComment(sourceFile, i3);
            if (commentRange) {
              switch (commentRange.kind) {
                case 2:
                  textChanges.push.apply(textChanges, toggleLineComment(fileName, { end: commentRange.end, pos: commentRange.pos + 1 }, false));
                  break;
                case 3:
                  textChanges.push.apply(textChanges, toggleMultilineComment(fileName, { end: commentRange.end, pos: commentRange.pos + 1 }, false));
              }
              i3 = commentRange.end + 1;
            }
          }
          return textChanges;
        }
        function isUnclosedTag(_a3) {
          var openingElement = _a3.openingElement, closingElement = _a3.closingElement, parent = _a3.parent;
          return !ts3.tagNamesAreEquivalent(openingElement.tagName, closingElement.tagName) || ts3.isJsxElement(parent) && ts3.tagNamesAreEquivalent(openingElement.tagName, parent.openingElement.tagName) && isUnclosedTag(parent);
        }
        function getSpanOfEnclosingComment(fileName, position, onlyMultiLine) {
          var sourceFile = syntaxTreeCache.getCurrentSourceFile(fileName);
          var range = ts3.formatting.getRangeOfEnclosingComment(sourceFile, position);
          return range && (!onlyMultiLine || range.kind === 3) ? ts3.createTextSpanFromRange(range) : void 0;
        }
        function getTodoComments(fileName, descriptors) {
          synchronizeHostData();
          var sourceFile = getValidSourceFile(fileName);
          cancellationToken.throwIfCancellationRequested();
          var fileContents = sourceFile.text;
          var result2 = [];
          if (descriptors.length > 0 && !isNodeModulesFile(sourceFile.fileName)) {
            var regExp = getTodoCommentsRegExp();
            var matchArray = void 0;
            while (matchArray = regExp.exec(fileContents)) {
              cancellationToken.throwIfCancellationRequested();
              var firstDescriptorCaptureIndex = 3;
              ts3.Debug.assert(matchArray.length === descriptors.length + firstDescriptorCaptureIndex);
              var preamble = matchArray[1];
              var matchPosition = matchArray.index + preamble.length;
              if (!ts3.isInComment(sourceFile, matchPosition)) {
                continue;
              }
              var descriptor = void 0;
              for (var i3 = 0; i3 < descriptors.length; i3++) {
                if (matchArray[i3 + firstDescriptorCaptureIndex]) {
                  descriptor = descriptors[i3];
                }
              }
              if (descriptor === void 0)
                return ts3.Debug.fail();
              if (isLetterOrDigit(fileContents.charCodeAt(matchPosition + descriptor.text.length))) {
                continue;
              }
              var message = matchArray[2];
              result2.push({ descriptor, message, position: matchPosition });
            }
          }
          return result2;
          function escapeRegExp(str2) {
            return str2.replace(/[\-\[\]\/\{\}\(\)\*\+\?\.\\\^\$\|]/g, "\\$&");
          }
          function getTodoCommentsRegExp() {
            var singleLineCommentStart = /(?:\/\/+\s*)/.source;
            var multiLineCommentStart = /(?:\/\*+\s*)/.source;
            var anyNumberOfSpacesAndAsterisksAtStartOfLine = /(?:^(?:\s|\*)*)/.source;
            var preamble2 = "(" + anyNumberOfSpacesAndAsterisksAtStartOfLine + "|" + singleLineCommentStart + "|" + multiLineCommentStart + ")";
            var literals = "(?:" + ts3.map(descriptors, function(d) {
              return "(" + escapeRegExp(d.text) + ")";
            }).join("|") + ")";
            var endOfLineOrEndOfComment = /(?:$|\*\/)/.source;
            var messageRemainder = /(?:.*?)/.source;
            var messagePortion = "(" + literals + messageRemainder + ")";
            var regExpString = preamble2 + messagePortion + endOfLineOrEndOfComment;
            return new RegExp(regExpString, "gim");
          }
          function isLetterOrDigit(char) {
            return char >= 97 && char <= 122 || char >= 65 && char <= 90 || char >= 48 && char <= 57;
          }
          function isNodeModulesFile(path2) {
            return ts3.stringContains(path2, "/node_modules/");
          }
        }
        function getRenameInfo(fileName, position, options) {
          synchronizeHostData();
          return ts3.Rename.getRenameInfo(program2, getValidSourceFile(fileName), position, options);
        }
        function getRefactorContext(file, positionOrRange, preferences, formatOptions, triggerReason, kind) {
          var _a3 = typeof positionOrRange === "number" ? [positionOrRange, void 0] : [positionOrRange.pos, positionOrRange.end], startPosition = _a3[0], endPosition = _a3[1];
          return {
            file,
            startPosition,
            endPosition,
            program: getProgram(),
            host,
            formatContext: ts3.formatting.getFormatContext(formatOptions, host),
            cancellationToken,
            preferences,
            triggerReason,
            kind
          };
        }
        function getSmartSelectionRange(fileName, position) {
          return ts3.SmartSelectionRange.getSmartSelectionRange(position, syntaxTreeCache.getCurrentSourceFile(fileName));
        }
        function getApplicableRefactors(fileName, positionOrRange, preferences, triggerReason, kind) {
          if (preferences === void 0) {
            preferences = ts3.emptyOptions;
          }
          synchronizeHostData();
          var file = getValidSourceFile(fileName);
          return ts3.refactor.getApplicableRefactors(getRefactorContext(file, positionOrRange, preferences, ts3.emptyOptions, triggerReason, kind));
        }
        function getEditsForRefactor(fileName, formatOptions, positionOrRange, refactorName, actionName, preferences) {
          if (preferences === void 0) {
            preferences = ts3.emptyOptions;
          }
          synchronizeHostData();
          var file = getValidSourceFile(fileName);
          return ts3.refactor.getEditsForRefactor(getRefactorContext(file, positionOrRange, preferences, formatOptions), refactorName, actionName);
        }
        function toLineColumnOffset(fileName, position) {
          if (position === 0) {
            return { line: 0, character: 0 };
          }
          return sourceMapper.toLineColumnOffset(fileName, position);
        }
        function prepareCallHierarchy(fileName, position) {
          synchronizeHostData();
          var declarations = ts3.CallHierarchy.resolveCallHierarchyDeclaration(program2, ts3.getTouchingPropertyName(getValidSourceFile(fileName), position));
          return declarations && ts3.mapOneOrMany(declarations, function(declaration) {
            return ts3.CallHierarchy.createCallHierarchyItem(program2, declaration);
          });
        }
        function provideCallHierarchyIncomingCalls(fileName, position) {
          synchronizeHostData();
          var sourceFile = getValidSourceFile(fileName);
          var declaration = ts3.firstOrOnly(ts3.CallHierarchy.resolveCallHierarchyDeclaration(program2, position === 0 ? sourceFile : ts3.getTouchingPropertyName(sourceFile, position)));
          return declaration ? ts3.CallHierarchy.getIncomingCalls(program2, declaration, cancellationToken) : [];
        }
        function provideCallHierarchyOutgoingCalls(fileName, position) {
          synchronizeHostData();
          var sourceFile = getValidSourceFile(fileName);
          var declaration = ts3.firstOrOnly(ts3.CallHierarchy.resolveCallHierarchyDeclaration(program2, position === 0 ? sourceFile : ts3.getTouchingPropertyName(sourceFile, position)));
          return declaration ? ts3.CallHierarchy.getOutgoingCalls(program2, declaration) : [];
        }
        var ls = {
          dispose,
          cleanupSemanticCache,
          getSyntacticDiagnostics,
          getSemanticDiagnostics,
          getSuggestionDiagnostics,
          getCompilerOptionsDiagnostics,
          getSyntacticClassifications,
          getSemanticClassifications,
          getEncodedSyntacticClassifications,
          getEncodedSemanticClassifications,
          getCompletionsAtPosition,
          getCompletionEntryDetails,
          getCompletionEntrySymbol,
          getSignatureHelpItems,
          getQuickInfoAtPosition,
          getDefinitionAtPosition,
          getDefinitionAndBoundSpan,
          getImplementationAtPosition,
          getTypeDefinitionAtPosition,
          getReferencesAtPosition,
          findReferences,
          getFileReferences,
          getOccurrencesAtPosition,
          getDocumentHighlights,
          getNameOrDottedNameSpan,
          getBreakpointStatementAtPosition,
          getNavigateToItems,
          getRenameInfo,
          getSmartSelectionRange,
          findRenameLocations,
          getNavigationBarItems,
          getNavigationTree,
          getOutliningSpans,
          getTodoComments,
          getBraceMatchingAtPosition,
          getIndentationAtPosition,
          getFormattingEditsForRange,
          getFormattingEditsForDocument,
          getFormattingEditsAfterKeystroke,
          getDocCommentTemplateAtPosition,
          isValidBraceCompletionAtPosition,
          getJsxClosingTagAtPosition,
          getSpanOfEnclosingComment,
          getCodeFixesAtPosition,
          getCombinedCodeFix,
          applyCodeActionCommand,
          organizeImports,
          getEditsForFileRename,
          getEmitOutput,
          getNonBoundSourceFile,
          getProgram,
          getAutoImportProvider,
          getApplicableRefactors,
          getEditsForRefactor,
          toLineColumnOffset,
          getSourceMapper: function() {
            return sourceMapper;
          },
          clearSourceMapperCache: function() {
            return sourceMapper.clearCache();
          },
          prepareCallHierarchy,
          provideCallHierarchyIncomingCalls,
          provideCallHierarchyOutgoingCalls,
          toggleLineComment,
          toggleMultilineComment,
          commentSelection,
          uncommentSelection
        };
        switch (languageServiceMode) {
          case ts3.LanguageServiceMode.Semantic:
            break;
          case ts3.LanguageServiceMode.PartialSemantic:
            invalidOperationsInPartialSemanticMode.forEach(function(key2) {
              return ls[key2] = function() {
                throw new Error("LanguageService Operation: " + key2 + " not allowed in LanguageServiceMode.PartialSemantic");
              };
            });
            break;
          case ts3.LanguageServiceMode.Syntactic:
            invalidOperationsInSyntacticMode.forEach(function(key2) {
              return ls[key2] = function() {
                throw new Error("LanguageService Operation: " + key2 + " not allowed in LanguageServiceMode.Syntactic");
              };
            });
            break;
          default:
            ts3.Debug.assertNever(languageServiceMode);
        }
        return ls;
      }
      ts3.createLanguageService = createLanguageService;
      function getNameTable(sourceFile) {
        if (!sourceFile.nameTable) {
          initializeNameTable(sourceFile);
        }
        return sourceFile.nameTable;
      }
      ts3.getNameTable = getNameTable;
      function initializeNameTable(sourceFile) {
        var nameTable = sourceFile.nameTable = new ts3.Map();
        sourceFile.forEachChild(function walk(node) {
          if (ts3.isIdentifier(node) && !ts3.isTagName(node) && node.escapedText || ts3.isStringOrNumericLiteralLike(node) && literalIsName(node)) {
            var text = ts3.getEscapedTextOfIdentifierOrLiteral(node);
            nameTable.set(text, nameTable.get(text) === void 0 ? node.pos : -1);
          } else if (ts3.isPrivateIdentifier(node)) {
            var text = node.escapedText;
            nameTable.set(text, nameTable.get(text) === void 0 ? node.pos : -1);
          }
          ts3.forEachChild(node, walk);
          if (ts3.hasJSDocNodes(node)) {
            for (var _i = 0, _a2 = node.jsDoc; _i < _a2.length; _i++) {
              var jsDoc = _a2[_i];
              ts3.forEachChild(jsDoc, walk);
            }
          }
        });
      }
      function literalIsName(node) {
        return ts3.isDeclarationName(node) || node.parent.kind === 273 || isArgumentOfElementAccessExpression(node) || ts3.isLiteralComputedPropertyDeclarationName(node);
      }
      function getContainingObjectLiteralElement(node) {
        var element = getContainingObjectLiteralElementWorker(node);
        return element && (ts3.isObjectLiteralExpression(element.parent) || ts3.isJsxAttributes(element.parent)) ? element : void 0;
      }
      ts3.getContainingObjectLiteralElement = getContainingObjectLiteralElement;
      function getContainingObjectLiteralElementWorker(node) {
        switch (node.kind) {
          case 10:
          case 14:
          case 8:
            if (node.parent.kind === 159) {
              return ts3.isObjectLiteralElement(node.parent.parent) ? node.parent.parent : void 0;
            }
          case 78:
            return ts3.isObjectLiteralElement(node.parent) && (node.parent.parent.kind === 201 || node.parent.parent.kind === 282) && node.parent.name === node ? node.parent : void 0;
        }
        return void 0;
      }
      function getSymbolAtLocationForQuickInfo(node, checker) {
        var object = getContainingObjectLiteralElement(node);
        if (object) {
          var contextualType = checker.getContextualType(object.parent);
          var properties = contextualType && getPropertySymbolsFromContextualType(object, checker, contextualType, false);
          if (properties && properties.length === 1) {
            return ts3.first(properties);
          }
        }
        return checker.getSymbolAtLocation(node);
      }
      function getPropertySymbolsFromContextualType(node, checker, contextualType, unionSymbolOk) {
        var name = ts3.getNameFromPropertyName(node.name);
        if (!name)
          return ts3.emptyArray;
        if (!contextualType.isUnion()) {
          var symbol = contextualType.getProperty(name);
          return symbol ? [symbol] : ts3.emptyArray;
        }
        var discriminatedPropertySymbols = ts3.mapDefined(contextualType.types, function(t2) {
          return (ts3.isObjectLiteralExpression(node.parent) || ts3.isJsxAttributes(node.parent)) && checker.isTypeInvalidDueToUnionDiscriminant(t2, node.parent) ? void 0 : t2.getProperty(name);
        });
        if (unionSymbolOk && (discriminatedPropertySymbols.length === 0 || discriminatedPropertySymbols.length === contextualType.types.length)) {
          var symbol = contextualType.getProperty(name);
          if (symbol)
            return [symbol];
        }
        if (discriminatedPropertySymbols.length === 0) {
          return ts3.mapDefined(contextualType.types, function(t2) {
            return t2.getProperty(name);
          });
        }
        return discriminatedPropertySymbols;
      }
      ts3.getPropertySymbolsFromContextualType = getPropertySymbolsFromContextualType;
      function isArgumentOfElementAccessExpression(node) {
        return node && node.parent && node.parent.kind === 203 && node.parent.argumentExpression === node;
      }
      function getDefaultLibFilePath(options) {
        if (typeof __dirname !== "undefined") {
          return __dirname + ts3.directorySeparator + ts3.getDefaultLibFileName(options);
        }
        throw new Error("getDefaultLibFilePath is only supported when consumed as a node module. ");
      }
      ts3.getDefaultLibFilePath = getDefaultLibFilePath;
      ts3.setObjectAllocator(getServicesObjectAllocator());
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      var BreakpointResolver;
      (function(BreakpointResolver2) {
        function spanInSourceFileAtLocation(sourceFile, position) {
          if (sourceFile.isDeclarationFile) {
            return void 0;
          }
          var tokenAtLocation = ts3.getTokenAtPosition(sourceFile, position);
          var lineOfPosition = sourceFile.getLineAndCharacterOfPosition(position).line;
          if (sourceFile.getLineAndCharacterOfPosition(tokenAtLocation.getStart(sourceFile)).line > lineOfPosition) {
            var preceding = ts3.findPrecedingToken(tokenAtLocation.pos, sourceFile);
            if (!preceding || sourceFile.getLineAndCharacterOfPosition(preceding.getEnd()).line !== lineOfPosition) {
              return void 0;
            }
            tokenAtLocation = preceding;
          }
          if (tokenAtLocation.flags & 8388608) {
            return void 0;
          }
          return spanInNode(tokenAtLocation);
          function textSpan(startNode, endNode) {
            var start = startNode.decorators ? ts3.skipTrivia(sourceFile.text, startNode.decorators.end) : startNode.getStart(sourceFile);
            return ts3.createTextSpanFromBounds(start, (endNode || startNode).getEnd());
          }
          function textSpanEndingAtNextToken(startNode, previousTokenToFindNextEndToken) {
            return textSpan(startNode, ts3.findNextToken(previousTokenToFindNextEndToken, previousTokenToFindNextEndToken.parent, sourceFile));
          }
          function spanInNodeIfStartsOnSameLine(node, otherwiseOnNode) {
            if (node && lineOfPosition === sourceFile.getLineAndCharacterOfPosition(node.getStart(sourceFile)).line) {
              return spanInNode(node);
            }
            return spanInNode(otherwiseOnNode);
          }
          function spanInNodeArray(nodeArray) {
            return ts3.createTextSpanFromBounds(ts3.skipTrivia(sourceFile.text, nodeArray.pos), nodeArray.end);
          }
          function spanInPreviousNode(node) {
            return spanInNode(ts3.findPrecedingToken(node.pos, sourceFile));
          }
          function spanInNextNode(node) {
            return spanInNode(ts3.findNextToken(node, node.parent, sourceFile));
          }
          function spanInNode(node) {
            if (node) {
              var parent = node.parent;
              switch (node.kind) {
                case 233:
                  return spanInVariableDeclaration(node.declarationList.declarations[0]);
                case 250:
                case 164:
                case 163:
                  return spanInVariableDeclaration(node);
                case 161:
                  return spanInParameterDeclaration(node);
                case 252:
                case 166:
                case 165:
                case 168:
                case 169:
                case 167:
                case 209:
                case 210:
                  return spanInFunctionDeclaration(node);
                case 231:
                  if (ts3.isFunctionBlock(node)) {
                    return spanInFunctionBlock(node);
                  }
                case 258:
                  return spanInBlock(node);
                case 288:
                  return spanInBlock(node.block);
                case 234:
                  return textSpan(node.expression);
                case 243:
                  return textSpan(node.getChildAt(0), node.expression);
                case 237:
                  return textSpanEndingAtNextToken(node, node.expression);
                case 236:
                  return spanInNode(node.statement);
                case 249:
                  return textSpan(node.getChildAt(0));
                case 235:
                  return textSpanEndingAtNextToken(node, node.expression);
                case 246:
                  return spanInNode(node.statement);
                case 242:
                case 241:
                  return textSpan(node.getChildAt(0), node.label);
                case 238:
                  return spanInForStatement(node);
                case 239:
                  return textSpanEndingAtNextToken(node, node.expression);
                case 240:
                  return spanInInitializerOfForLike(node);
                case 245:
                  return textSpanEndingAtNextToken(node, node.expression);
                case 285:
                case 286:
                  return spanInNode(node.statements[0]);
                case 248:
                  return spanInBlock(node.tryBlock);
                case 247:
                  return textSpan(node, node.expression);
                case 267:
                  return textSpan(node, node.expression);
                case 261:
                  return textSpan(node, node.moduleReference);
                case 262:
                  return textSpan(node, node.moduleSpecifier);
                case 268:
                  return textSpan(node, node.moduleSpecifier);
                case 257:
                  if (ts3.getModuleInstanceState(node) !== 1) {
                    return void 0;
                  }
                case 253:
                case 256:
                case 292:
                case 199:
                  return textSpan(node);
                case 244:
                  return spanInNode(node.statement);
                case 162:
                  return spanInNodeArray(parent.decorators);
                case 197:
                case 198:
                  return spanInBindingPattern(node);
                case 254:
                case 255:
                  return void 0;
                case 26:
                case 1:
                  return spanInNodeIfStartsOnSameLine(ts3.findPrecedingToken(node.pos, sourceFile));
                case 27:
                  return spanInPreviousNode(node);
                case 18:
                  return spanInOpenBraceToken(node);
                case 19:
                  return spanInCloseBraceToken(node);
                case 23:
                  return spanInCloseBracketToken(node);
                case 20:
                  return spanInOpenParenToken(node);
                case 21:
                  return spanInCloseParenToken(node);
                case 58:
                  return spanInColonToken(node);
                case 31:
                case 29:
                  return spanInGreaterThanOrLessThanToken(node);
                case 114:
                  return spanInWhileKeyword(node);
                case 90:
                case 82:
                case 95:
                  return spanInNextNode(node);
                case 157:
                  return spanInOfKeyword(node);
                default:
                  if (ts3.isArrayLiteralOrObjectLiteralDestructuringPattern(node)) {
                    return spanInArrayLiteralOrObjectLiteralDestructuringPattern(node);
                  }
                  if ((node.kind === 78 || node.kind === 221 || node.kind === 289 || node.kind === 290) && ts3.isArrayLiteralOrObjectLiteralDestructuringPattern(parent)) {
                    return textSpan(node);
                  }
                  if (node.kind === 217) {
                    var _a2 = node, left = _a2.left, operatorToken = _a2.operatorToken;
                    if (ts3.isArrayLiteralOrObjectLiteralDestructuringPattern(left)) {
                      return spanInArrayLiteralOrObjectLiteralDestructuringPattern(left);
                    }
                    if (operatorToken.kind === 62 && ts3.isArrayLiteralOrObjectLiteralDestructuringPattern(node.parent)) {
                      return textSpan(node);
                    }
                    if (operatorToken.kind === 27) {
                      return spanInNode(left);
                    }
                  }
                  if (ts3.isExpressionNode(node)) {
                    switch (parent.kind) {
                      case 236:
                        return spanInPreviousNode(node);
                      case 162:
                        return spanInNode(node.parent);
                      case 238:
                      case 240:
                        return textSpan(node);
                      case 217:
                        if (node.parent.operatorToken.kind === 27) {
                          return textSpan(node);
                        }
                        break;
                      case 210:
                        if (node.parent.body === node) {
                          return textSpan(node);
                        }
                        break;
                    }
                  }
                  switch (node.parent.kind) {
                    case 289:
                      if (node.parent.name === node && !ts3.isArrayLiteralOrObjectLiteralDestructuringPattern(node.parent.parent)) {
                        return spanInNode(node.parent.initializer);
                      }
                      break;
                    case 207:
                      if (node.parent.type === node) {
                        return spanInNextNode(node.parent.type);
                      }
                      break;
                    case 250:
                    case 161: {
                      var _b = node.parent, initializer = _b.initializer, type3 = _b.type;
                      if (initializer === node || type3 === node || ts3.isAssignmentOperator(node.kind)) {
                        return spanInPreviousNode(node);
                      }
                      break;
                    }
                    case 217: {
                      var left = node.parent.left;
                      if (ts3.isArrayLiteralOrObjectLiteralDestructuringPattern(left) && node !== left) {
                        return spanInPreviousNode(node);
                      }
                      break;
                    }
                    default:
                      if (ts3.isFunctionLike(node.parent) && node.parent.type === node) {
                        return spanInPreviousNode(node);
                      }
                  }
                  return spanInNode(node.parent);
              }
            }
            function textSpanFromVariableDeclaration(variableDeclaration) {
              if (ts3.isVariableDeclarationList(variableDeclaration.parent) && variableDeclaration.parent.declarations[0] === variableDeclaration) {
                return textSpan(ts3.findPrecedingToken(variableDeclaration.pos, sourceFile, variableDeclaration.parent), variableDeclaration);
              } else {
                return textSpan(variableDeclaration);
              }
            }
            function spanInVariableDeclaration(variableDeclaration) {
              if (variableDeclaration.parent.parent.kind === 239) {
                return spanInNode(variableDeclaration.parent.parent);
              }
              var parent2 = variableDeclaration.parent;
              if (ts3.isBindingPattern(variableDeclaration.name)) {
                return spanInBindingPattern(variableDeclaration.name);
              }
              if (variableDeclaration.initializer || ts3.hasSyntacticModifier(variableDeclaration, 1) || parent2.parent.kind === 240) {
                return textSpanFromVariableDeclaration(variableDeclaration);
              }
              if (ts3.isVariableDeclarationList(variableDeclaration.parent) && variableDeclaration.parent.declarations[0] !== variableDeclaration) {
                return spanInNode(ts3.findPrecedingToken(variableDeclaration.pos, sourceFile, variableDeclaration.parent));
              }
            }
            function canHaveSpanInParameterDeclaration(parameter) {
              return !!parameter.initializer || parameter.dotDotDotToken !== void 0 || ts3.hasSyntacticModifier(parameter, 4 | 8);
            }
            function spanInParameterDeclaration(parameter) {
              if (ts3.isBindingPattern(parameter.name)) {
                return spanInBindingPattern(parameter.name);
              } else if (canHaveSpanInParameterDeclaration(parameter)) {
                return textSpan(parameter);
              } else {
                var functionDeclaration = parameter.parent;
                var indexOfParameter = functionDeclaration.parameters.indexOf(parameter);
                ts3.Debug.assert(indexOfParameter !== -1);
                if (indexOfParameter !== 0) {
                  return spanInParameterDeclaration(functionDeclaration.parameters[indexOfParameter - 1]);
                } else {
                  return spanInNode(functionDeclaration.body);
                }
              }
            }
            function canFunctionHaveSpanInWholeDeclaration(functionDeclaration) {
              return ts3.hasSyntacticModifier(functionDeclaration, 1) || functionDeclaration.parent.kind === 253 && functionDeclaration.kind !== 167;
            }
            function spanInFunctionDeclaration(functionDeclaration) {
              if (!functionDeclaration.body) {
                return void 0;
              }
              if (canFunctionHaveSpanInWholeDeclaration(functionDeclaration)) {
                return textSpan(functionDeclaration);
              }
              return spanInNode(functionDeclaration.body);
            }
            function spanInFunctionBlock(block) {
              var nodeForSpanInBlock = block.statements.length ? block.statements[0] : block.getLastToken();
              if (canFunctionHaveSpanInWholeDeclaration(block.parent)) {
                return spanInNodeIfStartsOnSameLine(block.parent, nodeForSpanInBlock);
              }
              return spanInNode(nodeForSpanInBlock);
            }
            function spanInBlock(block) {
              switch (block.parent.kind) {
                case 257:
                  if (ts3.getModuleInstanceState(block.parent) !== 1) {
                    return void 0;
                  }
                case 237:
                case 235:
                case 239:
                  return spanInNodeIfStartsOnSameLine(block.parent, block.statements[0]);
                case 238:
                case 240:
                  return spanInNodeIfStartsOnSameLine(ts3.findPrecedingToken(block.pos, sourceFile, block.parent), block.statements[0]);
              }
              return spanInNode(block.statements[0]);
            }
            function spanInInitializerOfForLike(forLikeStatement) {
              if (forLikeStatement.initializer.kind === 251) {
                var variableDeclarationList = forLikeStatement.initializer;
                if (variableDeclarationList.declarations.length > 0) {
                  return spanInNode(variableDeclarationList.declarations[0]);
                }
              } else {
                return spanInNode(forLikeStatement.initializer);
              }
            }
            function spanInForStatement(forStatement) {
              if (forStatement.initializer) {
                return spanInInitializerOfForLike(forStatement);
              }
              if (forStatement.condition) {
                return textSpan(forStatement.condition);
              }
              if (forStatement.incrementor) {
                return textSpan(forStatement.incrementor);
              }
            }
            function spanInBindingPattern(bindingPattern) {
              var firstBindingElement = ts3.forEach(bindingPattern.elements, function(element) {
                return element.kind !== 223 ? element : void 0;
              });
              if (firstBindingElement) {
                return spanInNode(firstBindingElement);
              }
              if (bindingPattern.parent.kind === 199) {
                return textSpan(bindingPattern.parent);
              }
              return textSpanFromVariableDeclaration(bindingPattern.parent);
            }
            function spanInArrayLiteralOrObjectLiteralDestructuringPattern(node2) {
              ts3.Debug.assert(node2.kind !== 198 && node2.kind !== 197);
              var elements = node2.kind === 200 ? node2.elements : node2.properties;
              var firstBindingElement = ts3.forEach(elements, function(element) {
                return element.kind !== 223 ? element : void 0;
              });
              if (firstBindingElement) {
                return spanInNode(firstBindingElement);
              }
              return textSpan(node2.parent.kind === 217 ? node2.parent : node2);
            }
            function spanInOpenBraceToken(node2) {
              switch (node2.parent.kind) {
                case 256:
                  var enumDeclaration = node2.parent;
                  return spanInNodeIfStartsOnSameLine(ts3.findPrecedingToken(node2.pos, sourceFile, node2.parent), enumDeclaration.members.length ? enumDeclaration.members[0] : enumDeclaration.getLastToken(sourceFile));
                case 253:
                  var classDeclaration = node2.parent;
                  return spanInNodeIfStartsOnSameLine(ts3.findPrecedingToken(node2.pos, sourceFile, node2.parent), classDeclaration.members.length ? classDeclaration.members[0] : classDeclaration.getLastToken(sourceFile));
                case 259:
                  return spanInNodeIfStartsOnSameLine(node2.parent.parent, node2.parent.clauses[0]);
              }
              return spanInNode(node2.parent);
            }
            function spanInCloseBraceToken(node2) {
              switch (node2.parent.kind) {
                case 258:
                  if (ts3.getModuleInstanceState(node2.parent.parent) !== 1) {
                    return void 0;
                  }
                case 256:
                case 253:
                  return textSpan(node2);
                case 231:
                  if (ts3.isFunctionBlock(node2.parent)) {
                    return textSpan(node2);
                  }
                case 288:
                  return spanInNode(ts3.lastOrUndefined(node2.parent.statements));
                case 259:
                  var caseBlock = node2.parent;
                  var lastClause = ts3.lastOrUndefined(caseBlock.clauses);
                  if (lastClause) {
                    return spanInNode(ts3.lastOrUndefined(lastClause.statements));
                  }
                  return void 0;
                case 197:
                  var bindingPattern = node2.parent;
                  return spanInNode(ts3.lastOrUndefined(bindingPattern.elements) || bindingPattern);
                default:
                  if (ts3.isArrayLiteralOrObjectLiteralDestructuringPattern(node2.parent)) {
                    var objectLiteral = node2.parent;
                    return textSpan(ts3.lastOrUndefined(objectLiteral.properties) || objectLiteral);
                  }
                  return spanInNode(node2.parent);
              }
            }
            function spanInCloseBracketToken(node2) {
              switch (node2.parent.kind) {
                case 198:
                  var bindingPattern = node2.parent;
                  return textSpan(ts3.lastOrUndefined(bindingPattern.elements) || bindingPattern);
                default:
                  if (ts3.isArrayLiteralOrObjectLiteralDestructuringPattern(node2.parent)) {
                    var arrayLiteral = node2.parent;
                    return textSpan(ts3.lastOrUndefined(arrayLiteral.elements) || arrayLiteral);
                  }
                  return spanInNode(node2.parent);
              }
            }
            function spanInOpenParenToken(node2) {
              if (node2.parent.kind === 236 || node2.parent.kind === 204 || node2.parent.kind === 205) {
                return spanInPreviousNode(node2);
              }
              if (node2.parent.kind === 208) {
                return spanInNextNode(node2);
              }
              return spanInNode(node2.parent);
            }
            function spanInCloseParenToken(node2) {
              switch (node2.parent.kind) {
                case 209:
                case 252:
                case 210:
                case 166:
                case 165:
                case 168:
                case 169:
                case 167:
                case 237:
                case 236:
                case 238:
                case 240:
                case 204:
                case 205:
                case 208:
                  return spanInPreviousNode(node2);
                default:
                  return spanInNode(node2.parent);
              }
            }
            function spanInColonToken(node2) {
              if (ts3.isFunctionLike(node2.parent) || node2.parent.kind === 289 || node2.parent.kind === 161) {
                return spanInPreviousNode(node2);
              }
              return spanInNode(node2.parent);
            }
            function spanInGreaterThanOrLessThanToken(node2) {
              if (node2.parent.kind === 207) {
                return spanInNextNode(node2);
              }
              return spanInNode(node2.parent);
            }
            function spanInWhileKeyword(node2) {
              if (node2.parent.kind === 236) {
                return textSpanEndingAtNextToken(node2, node2.parent.expression);
              }
              return spanInNode(node2.parent);
            }
            function spanInOfKeyword(node2) {
              if (node2.parent.kind === 240) {
                return spanInNextNode(node2);
              }
              return spanInNode(node2.parent);
            }
          }
        }
        BreakpointResolver2.spanInSourceFileAtLocation = spanInSourceFileAtLocation;
      })(BreakpointResolver = ts3.BreakpointResolver || (ts3.BreakpointResolver = {}));
    })(ts2 || (ts2 = {}));
    var ts2;
    (function(ts3) {
      function transform(source, transformers, compilerOptions) {
        var diagnostics = [];
        compilerOptions = ts3.fixupCompilerOptions(compilerOptions, diagnostics);
        var nodes = ts3.isArray(source) ? source : [source];
        var result2 = ts3.transformNodes(void 0, void 0, ts3.factory, compilerOptions, nodes, transformers, true);
        result2.diagnostics = ts3.concatenate(result2.diagnostics, diagnostics);
        return result2;
      }
      ts3.transform = transform;
    })(ts2 || (ts2 = {}));
    var debugObjectHost = function() {
      return this;
    }();
    var ts2;
    (function(ts3) {
      function logInternalError(logger, err2) {
        if (logger) {
          logger.log("*INTERNAL ERROR* - Exception in typescript services: " + err2.message);
        }
      }
      var ScriptSnapshotShimAdapter = function() {
        function ScriptSnapshotShimAdapter2(scriptSnapshotShim) {
          this.scriptSnapshotShim = scriptSnapshotShim;
        }
        ScriptSnapshotShimAdapter2.prototype.getText = function(start, end) {
          return this.scriptSnapshotShim.getText(start, end);
        };
        ScriptSnapshotShimAdapter2.prototype.getLength = function() {
          return this.scriptSnapshotShim.getLength();
        };
        ScriptSnapshotShimAdapter2.prototype.getChangeRange = function(oldSnapshot) {
          var oldSnapshotShim = oldSnapshot;
          var encoded = this.scriptSnapshotShim.getChangeRange(oldSnapshotShim.scriptSnapshotShim);
          if (encoded === null) {
            return null;
          }
          var decoded = JSON.parse(encoded);
          return ts3.createTextChangeRange(ts3.createTextSpan(decoded.span.start, decoded.span.length), decoded.newLength);
        };
        ScriptSnapshotShimAdapter2.prototype.dispose = function() {
          if ("dispose" in this.scriptSnapshotShim) {
            this.scriptSnapshotShim.dispose();
          }
        };
        return ScriptSnapshotShimAdapter2;
      }();
      var LanguageServiceShimHostAdapter = function() {
        function LanguageServiceShimHostAdapter2(shimHost) {
          var _this = this;
          this.shimHost = shimHost;
          this.loggingEnabled = false;
          this.tracingEnabled = false;
          if ("getModuleResolutionsForFile" in this.shimHost) {
            this.resolveModuleNames = function(moduleNames, containingFile) {
              var resolutionsInFile = JSON.parse(_this.shimHost.getModuleResolutionsForFile(containingFile));
              return ts3.map(moduleNames, function(name) {
                var result2 = ts3.getProperty(resolutionsInFile, name);
                return result2 ? { resolvedFileName: result2, extension: ts3.extensionFromPath(result2), isExternalLibraryImport: false } : void 0;
              });
            };
          }
          if ("directoryExists" in this.shimHost) {
            this.directoryExists = function(directoryName) {
              return _this.shimHost.directoryExists(directoryName);
            };
          }
          if ("getTypeReferenceDirectiveResolutionsForFile" in this.shimHost) {
            this.resolveTypeReferenceDirectives = function(typeDirectiveNames, containingFile) {
              var typeDirectivesForFile = JSON.parse(_this.shimHost.getTypeReferenceDirectiveResolutionsForFile(containingFile));
              return ts3.map(typeDirectiveNames, function(name) {
                return ts3.getProperty(typeDirectivesForFile, name);
              });
            };
          }
        }
        LanguageServiceShimHostAdapter2.prototype.log = function(s2) {
          if (this.loggingEnabled) {
            this.shimHost.log(s2);
          }
        };
        LanguageServiceShimHostAdapter2.prototype.trace = function(s2) {
          if (this.tracingEnabled) {
            this.shimHost.trace(s2);
          }
        };
        LanguageServiceShimHostAdapter2.prototype.error = function(s2) {
          this.shimHost.error(s2);
        };
        LanguageServiceShimHostAdapter2.prototype.getProjectVersion = function() {
          if (!this.shimHost.getProjectVersion) {
            return void 0;
          }
          return this.shimHost.getProjectVersion();
        };
        LanguageServiceShimHostAdapter2.prototype.getTypeRootsVersion = function() {
          if (!this.shimHost.getTypeRootsVersion) {
            return 0;
          }
          return this.shimHost.getTypeRootsVersion();
        };
        LanguageServiceShimHostAdapter2.prototype.useCaseSensitiveFileNames = function() {
          return this.shimHost.useCaseSensitiveFileNames ? this.shimHost.useCaseSensitiveFileNames() : false;
        };
        LanguageServiceShimHostAdapter2.prototype.getCompilationSettings = function() {
          var settingsJson = this.shimHost.getCompilationSettings();
          if (settingsJson === null || settingsJson === "") {
            throw Error("LanguageServiceShimHostAdapter.getCompilationSettings: empty compilationSettings");
          }
          var compilerOptions = JSON.parse(settingsJson);
          compilerOptions.allowNonTsExtensions = true;
          return compilerOptions;
        };
        LanguageServiceShimHostAdapter2.prototype.getScriptFileNames = function() {
          var encoded = this.shimHost.getScriptFileNames();
          return JSON.parse(encoded);
        };
        LanguageServiceShimHostAdapter2.prototype.getScriptSnapshot = function(fileName) {
          var scriptSnapshot = this.shimHost.getScriptSnapshot(fileName);
          return scriptSnapshot && new ScriptSnapshotShimAdapter(scriptSnapshot);
        };
        LanguageServiceShimHostAdapter2.prototype.getScriptKind = function(fileName) {
          if ("getScriptKind" in this.shimHost) {
            return this.shimHost.getScriptKind(fileName);
          } else {
            return 0;
          }
        };
        LanguageServiceShimHostAdapter2.prototype.getScriptVersion = function(fileName) {
          return this.shimHost.getScriptVersion(fileName);
        };
        LanguageServiceShimHostAdapter2.prototype.getLocalizedDiagnosticMessages = function() {
          var diagnosticMessagesJson = this.shimHost.getLocalizedDiagnosticMessages();
          if (diagnosticMessagesJson === null || diagnosticMessagesJson === "") {
            return null;
          }
          try {
            return JSON.parse(diagnosticMessagesJson);
          } catch (e2) {
            this.log(e2.description || "diagnosticMessages.generated.json has invalid JSON format");
            return null;
          }
        };
        LanguageServiceShimHostAdapter2.prototype.getCancellationToken = function() {
          var hostCancellationToken = this.shimHost.getCancellationToken();
          return new ts3.ThrottledCancellationToken(hostCancellationToken);
        };
        LanguageServiceShimHostAdapter2.prototype.getCurrentDirectory = function() {
          return this.shimHost.getCurrentDirectory();
        };
        LanguageServiceShimHostAdapter2.prototype.getDirectories = function(path2) {
          return JSON.parse(this.shimHost.getDirectories(path2));
        };
        LanguageServiceShimHostAdapter2.prototype.getDefaultLibFileName = function(options) {
          return this.shimHost.getDefaultLibFileName(JSON.stringify(options));
        };
        LanguageServiceShimHostAdapter2.prototype.readDirectory = function(path2, extensions, exclude, include, depth) {
          var pattern = ts3.getFileMatcherPatterns(path2, exclude, include, this.shimHost.useCaseSensitiveFileNames(), this.shimHost.getCurrentDirectory());
          return JSON.parse(this.shimHost.readDirectory(path2, JSON.stringify(extensions), JSON.stringify(pattern.basePaths), pattern.excludePattern, pattern.includeFilePattern, pattern.includeDirectoryPattern, depth));
        };
        LanguageServiceShimHostAdapter2.prototype.readFile = function(path2, encoding) {
          return this.shimHost.readFile(path2, encoding);
        };
        LanguageServiceShimHostAdapter2.prototype.fileExists = function(path2) {
          return this.shimHost.fileExists(path2);
        };
        return LanguageServiceShimHostAdapter2;
      }();
      ts3.LanguageServiceShimHostAdapter = LanguageServiceShimHostAdapter;
      var CoreServicesShimHostAdapter = function() {
        function CoreServicesShimHostAdapter2(shimHost) {
          var _this = this;
          this.shimHost = shimHost;
          this.useCaseSensitiveFileNames = this.shimHost.useCaseSensitiveFileNames ? this.shimHost.useCaseSensitiveFileNames() : false;
          if ("directoryExists" in this.shimHost) {
            this.directoryExists = function(directoryName) {
              return _this.shimHost.directoryExists(directoryName);
            };
          } else {
            this.directoryExists = void 0;
          }
          if ("realpath" in this.shimHost) {
            this.realpath = function(path2) {
              return _this.shimHost.realpath(path2);
            };
          } else {
            this.realpath = void 0;
          }
        }
        CoreServicesShimHostAdapter2.prototype.readDirectory = function(rootDir, extensions, exclude, include, depth) {
          var pattern = ts3.getFileMatcherPatterns(rootDir, exclude, include, this.shimHost.useCaseSensitiveFileNames(), this.shimHost.getCurrentDirectory());
          return JSON.parse(this.shimHost.readDirectory(rootDir, JSON.stringify(extensions), JSON.stringify(pattern.basePaths), pattern.excludePattern, pattern.includeFilePattern, pattern.includeDirectoryPattern, depth));
        };
        CoreServicesShimHostAdapter2.prototype.fileExists = function(fileName) {
          return this.shimHost.fileExists(fileName);
        };
        CoreServicesShimHostAdapter2.prototype.readFile = function(fileName) {
          return this.shimHost.readFile(fileName);
        };
        CoreServicesShimHostAdapter2.prototype.getDirectories = function(path2) {
          return JSON.parse(this.shimHost.getDirectories(path2));
        };
        return CoreServicesShimHostAdapter2;
      }();
      ts3.CoreServicesShimHostAdapter = CoreServicesShimHostAdapter;
      function simpleForwardCall(logger, actionDescription, action, logPerformance) {
        var start;
        if (logPerformance) {
          logger.log(actionDescription);
          start = ts3.timestamp();
        }
        var result2 = action();
        if (logPerformance) {
          var end = ts3.timestamp();
          logger.log(actionDescription + " completed in " + (end - start) + " msec");
          if (ts3.isString(result2)) {
            var str2 = result2;
            if (str2.length > 128) {
              str2 = str2.substring(0, 128) + "...";
            }
            logger.log("  result.length=" + str2.length + ", result='" + JSON.stringify(str2) + "'");
          }
        }
        return result2;
      }
      function forwardJSONCall(logger, actionDescription, action, logPerformance) {
        return forwardCall(logger, actionDescription, true, action, logPerformance);
      }
      function forwardCall(logger, actionDescription, returnJson, action, logPerformance) {
        try {
          var result2 = simpleForwardCall(logger, actionDescription, action, logPerformance);
          return returnJson ? JSON.stringify({ result: result2 }) : result2;
        } catch (err2) {
          if (err2 instanceof ts3.OperationCanceledException) {
            return JSON.stringify({ canceled: true });
          }
          logInternalError(logger, err2);
          err2.description = actionDescription;
          return JSON.stringify({ error: err2 });
        }
      }
      var ShimBase = function() {
        function ShimBase2(factory) {
          this.factory = factory;
          factory.registerShim(this);
        }
        ShimBase2.prototype.dispose = function(_dummy) {
          this.factory.unregisterShim(this);
        };
        return ShimBase2;
      }();
      function realizeDiagnostics(diagnostics, newLine) {
        return diagnostics.map(function(d) {
          return realizeDiagnostic(d, newLine);
        });
      }
      ts3.realizeDiagnostics = realizeDiagnostics;
      function realizeDiagnostic(diagnostic, newLine) {
        return {
          message: ts3.flattenDiagnosticMessageText(diagnostic.messageText, newLine),
          start: diagnostic.start,
          length: diagnostic.length,
          category: ts3.diagnosticCategoryName(diagnostic),
          code: diagnostic.code,
          reportsUnnecessary: diagnostic.reportsUnnecessary,
          reportsDeprecated: diagnostic.reportsDeprecated
        };
      }
      var LanguageServiceShimObject = function(_super) {
        __extends2(LanguageServiceShimObject2, _super);
        function LanguageServiceShimObject2(factory, host, languageService) {
          var _this = _super.call(this, factory) || this;
          _this.host = host;
          _this.languageService = languageService;
          _this.logPerformance = false;
          _this.logger = _this.host;
          return _this;
        }
        LanguageServiceShimObject2.prototype.forwardJSONCall = function(actionDescription, action) {
          return forwardJSONCall(this.logger, actionDescription, action, this.logPerformance);
        };
        LanguageServiceShimObject2.prototype.dispose = function(dummy) {
          this.logger.log("dispose()");
          this.languageService.dispose();
          this.languageService = null;
          if (debugObjectHost && debugObjectHost.CollectGarbage) {
            debugObjectHost.CollectGarbage();
            this.logger.log("CollectGarbage()");
          }
          this.logger = null;
          _super.prototype.dispose.call(this, dummy);
        };
        LanguageServiceShimObject2.prototype.refresh = function(throwOnError) {
          this.forwardJSONCall("refresh(" + throwOnError + ")", function() {
            return null;
          });
        };
        LanguageServiceShimObject2.prototype.cleanupSemanticCache = function() {
          var _this = this;
          this.forwardJSONCall("cleanupSemanticCache()", function() {
            _this.languageService.cleanupSemanticCache();
            return null;
          });
        };
        LanguageServiceShimObject2.prototype.realizeDiagnostics = function(diagnostics) {
          var newLine = ts3.getNewLineOrDefaultFromHost(this.host);
          return realizeDiagnostics(diagnostics, newLine);
        };
        LanguageServiceShimObject2.prototype.getSyntacticClassifications = function(fileName, start, length) {
          var _this = this;
          return this.forwardJSONCall("getSyntacticClassifications('" + fileName + "', " + start + ", " + length + ")", function() {
            return _this.languageService.getSyntacticClassifications(fileName, ts3.createTextSpan(start, length));
          });
        };
        LanguageServiceShimObject2.prototype.getSemanticClassifications = function(fileName, start, length) {
          var _this = this;
          return this.forwardJSONCall("getSemanticClassifications('" + fileName + "', " + start + ", " + length + ")", function() {
            return _this.languageService.getSemanticClassifications(fileName, ts3.createTextSpan(start, length));
          });
        };
        LanguageServiceShimObject2.prototype.getEncodedSyntacticClassifications = function(fileName, start, length) {
          var _this = this;
          return this.forwardJSONCall("getEncodedSyntacticClassifications('" + fileName + "', " + start + ", " + length + ")", function() {
            return convertClassifications(_this.languageService.getEncodedSyntacticClassifications(fileName, ts3.createTextSpan(start, length)));
          });
        };
        LanguageServiceShimObject2.prototype.getEncodedSemanticClassifications = function(fileName, start, length) {
          var _this = this;
          return this.forwardJSONCall("getEncodedSemanticClassifications('" + fileName + "', " + start + ", " + length + ")", function() {
            return convertClassifications(_this.languageService.getEncodedSemanticClassifications(fileName, ts3.createTextSpan(start, length)));
          });
        };
        LanguageServiceShimObject2.prototype.getSyntacticDiagnostics = function(fileName) {
          var _this = this;
          return this.forwardJSONCall("getSyntacticDiagnostics('" + fileName + "')", function() {
            var diagnostics = _this.languageService.getSyntacticDiagnostics(fileName);
            return _this.realizeDiagnostics(diagnostics);
          });
        };
        LanguageServiceShimObject2.prototype.getSemanticDiagnostics = function(fileName) {
          var _this = this;
          return this.forwardJSONCall("getSemanticDiagnostics('" + fileName + "')", function() {
            var diagnostics = _this.languageService.getSemanticDiagnostics(fileName);
            return _this.realizeDiagnostics(diagnostics);
          });
        };
        LanguageServiceShimObject2.prototype.getSuggestionDiagnostics = function(fileName) {
          var _this = this;
          return this.forwardJSONCall("getSuggestionDiagnostics('" + fileName + "')", function() {
            return _this.realizeDiagnostics(_this.languageService.getSuggestionDiagnostics(fileName));
          });
        };
        LanguageServiceShimObject2.prototype.getCompilerOptionsDiagnostics = function() {
          var _this = this;
          return this.forwardJSONCall("getCompilerOptionsDiagnostics()", function() {
            var diagnostics = _this.languageService.getCompilerOptionsDiagnostics();
            return _this.realizeDiagnostics(diagnostics);
          });
        };
        LanguageServiceShimObject2.prototype.getQuickInfoAtPosition = function(fileName, position) {
          var _this = this;
          return this.forwardJSONCall("getQuickInfoAtPosition('" + fileName + "', " + position + ")", function() {
            return _this.languageService.getQuickInfoAtPosition(fileName, position);
          });
        };
        LanguageServiceShimObject2.prototype.getNameOrDottedNameSpan = function(fileName, startPos, endPos) {
          var _this = this;
          return this.forwardJSONCall("getNameOrDottedNameSpan('" + fileName + "', " + startPos + ", " + endPos + ")", function() {
            return _this.languageService.getNameOrDottedNameSpan(fileName, startPos, endPos);
          });
        };
        LanguageServiceShimObject2.prototype.getBreakpointStatementAtPosition = function(fileName, position) {
          var _this = this;
          return this.forwardJSONCall("getBreakpointStatementAtPosition('" + fileName + "', " + position + ")", function() {
            return _this.languageService.getBreakpointStatementAtPosition(fileName, position);
          });
        };
        LanguageServiceShimObject2.prototype.getSignatureHelpItems = function(fileName, position, options) {
          var _this = this;
          return this.forwardJSONCall("getSignatureHelpItems('" + fileName + "', " + position + ")", function() {
            return _this.languageService.getSignatureHelpItems(fileName, position, options);
          });
        };
        LanguageServiceShimObject2.prototype.getDefinitionAtPosition = function(fileName, position) {
          var _this = this;
          return this.forwardJSONCall("getDefinitionAtPosition('" + fileName + "', " + position + ")", function() {
            return _this.languageService.getDefinitionAtPosition(fileName, position);
          });
        };
        LanguageServiceShimObject2.prototype.getDefinitionAndBoundSpan = function(fileName, position) {
          var _this = this;
          return this.forwardJSONCall("getDefinitionAndBoundSpan('" + fileName + "', " + position + ")", function() {
            return _this.languageService.getDefinitionAndBoundSpan(fileName, position);
          });
        };
        LanguageServiceShimObject2.prototype.getTypeDefinitionAtPosition = function(fileName, position) {
          var _this = this;
          return this.forwardJSONCall("getTypeDefinitionAtPosition('" + fileName + "', " + position + ")", function() {
            return _this.languageService.getTypeDefinitionAtPosition(fileName, position);
          });
        };
        LanguageServiceShimObject2.prototype.getImplementationAtPosition = function(fileName, position) {
          var _this = this;
          return this.forwardJSONCall("getImplementationAtPosition('" + fileName + "', " + position + ")", function() {
            return _this.languageService.getImplementationAtPosition(fileName, position);
          });
        };
        LanguageServiceShimObject2.prototype.getRenameInfo = function(fileName, position, options) {
          var _this = this;
          return this.forwardJSONCall("getRenameInfo('" + fileName + "', " + position + ")", function() {
            return _this.languageService.getRenameInfo(fileName, position, options);
          });
        };
        LanguageServiceShimObject2.prototype.getSmartSelectionRange = function(fileName, position) {
          var _this = this;
          return this.forwardJSONCall("getSmartSelectionRange('" + fileName + "', " + position + ")", function() {
            return _this.languageService.getSmartSelectionRange(fileName, position);
          });
        };
        LanguageServiceShimObject2.prototype.findRenameLocations = function(fileName, position, findInStrings, findInComments, providePrefixAndSuffixTextForRename) {
          var _this = this;
          return this.forwardJSONCall("findRenameLocations('" + fileName + "', " + position + ", " + findInStrings + ", " + findInComments + ", " + providePrefixAndSuffixTextForRename + ")", function() {
            return _this.languageService.findRenameLocations(fileName, position, findInStrings, findInComments, providePrefixAndSuffixTextForRename);
          });
        };
        LanguageServiceShimObject2.prototype.getBraceMatchingAtPosition = function(fileName, position) {
          var _this = this;
          return this.forwardJSONCall("getBraceMatchingAtPosition('" + fileName + "', " + position + ")", function() {
            return _this.languageService.getBraceMatchingAtPosition(fileName, position);
          });
        };
        LanguageServiceShimObject2.prototype.isValidBraceCompletionAtPosition = function(fileName, position, openingBrace) {
          var _this = this;
          return this.forwardJSONCall("isValidBraceCompletionAtPosition('" + fileName + "', " + position + ", " + openingBrace + ")", function() {
            return _this.languageService.isValidBraceCompletionAtPosition(fileName, position, openingBrace);
          });
        };
        LanguageServiceShimObject2.prototype.getSpanOfEnclosingComment = function(fileName, position, onlyMultiLine) {
          var _this = this;
          return this.forwardJSONCall("getSpanOfEnclosingComment('" + fileName + "', " + position + ")", function() {
            return _this.languageService.getSpanOfEnclosingComment(fileName, position, onlyMultiLine);
          });
        };
        LanguageServiceShimObject2.prototype.getIndentationAtPosition = function(fileName, position, options) {
          var _this = this;
          return this.forwardJSONCall("getIndentationAtPosition('" + fileName + "', " + position + ")", function() {
            var localOptions = JSON.parse(options);
            return _this.languageService.getIndentationAtPosition(fileName, position, localOptions);
          });
        };
        LanguageServiceShimObject2.prototype.getReferencesAtPosition = function(fileName, position) {
          var _this = this;
          return this.forwardJSONCall("getReferencesAtPosition('" + fileName + "', " + position + ")", function() {
            return _this.languageService.getReferencesAtPosition(fileName, position);
          });
        };
        LanguageServiceShimObject2.prototype.findReferences = function(fileName, position) {
          var _this = this;
          return this.forwardJSONCall("findReferences('" + fileName + "', " + position + ")", function() {
            return _this.languageService.findReferences(fileName, position);
          });
        };
        LanguageServiceShimObject2.prototype.getFileReferences = function(fileName) {
          var _this = this;
          return this.forwardJSONCall("getFileReferences('" + fileName + ")", function() {
            return _this.languageService.getFileReferences(fileName);
          });
        };
        LanguageServiceShimObject2.prototype.getOccurrencesAtPosition = function(fileName, position) {
          var _this = this;
          return this.forwardJSONCall("getOccurrencesAtPosition('" + fileName + "', " + position + ")", function() {
            return _this.languageService.getOccurrencesAtPosition(fileName, position);
          });
        };
        LanguageServiceShimObject2.prototype.getDocumentHighlights = function(fileName, position, filesToSearch) {
          var _this = this;
          return this.forwardJSONCall("getDocumentHighlights('" + fileName + "', " + position + ")", function() {
            var results = _this.languageService.getDocumentHighlights(fileName, position, JSON.parse(filesToSearch));
            var normalizedName = ts3.toFileNameLowerCase(ts3.normalizeSlashes(fileName));
            return ts3.filter(results, function(r2) {
              return ts3.toFileNameLowerCase(ts3.normalizeSlashes(r2.fileName)) === normalizedName;
            });
          });
        };
        LanguageServiceShimObject2.prototype.getCompletionsAtPosition = function(fileName, position, preferences) {
          var _this = this;
          return this.forwardJSONCall("getCompletionsAtPosition('" + fileName + "', " + position + ", " + preferences + ")", function() {
            return _this.languageService.getCompletionsAtPosition(fileName, position, preferences);
          });
        };
        LanguageServiceShimObject2.prototype.getCompletionEntryDetails = function(fileName, position, entryName, formatOptions, source, preferences, data) {
          var _this = this;
          return this.forwardJSONCall("getCompletionEntryDetails('" + fileName + "', " + position + ", '" + entryName + "')", function() {
            var localOptions = formatOptions === void 0 ? void 0 : JSON.parse(formatOptions);
            return _this.languageService.getCompletionEntryDetails(fileName, position, entryName, localOptions, source, preferences, data);
          });
        };
        LanguageServiceShimObject2.prototype.getFormattingEditsForRange = function(fileName, start, end, options) {
          var _this = this;
          return this.forwardJSONCall("getFormattingEditsForRange('" + fileName + "', " + start + ", " + end + ")", function() {
            var localOptions = JSON.parse(options);
            return _this.languageService.getFormattingEditsForRange(fileName, start, end, localOptions);
          });
        };
        LanguageServiceShimObject2.prototype.getFormattingEditsForDocument = function(fileName, options) {
          var _this = this;
          return this.forwardJSONCall("getFormattingEditsForDocument('" + fileName + "')", function() {
            var localOptions = JSON.parse(options);
            return _this.languageService.getFormattingEditsForDocument(fileName, localOptions);
          });
        };
        LanguageServiceShimObject2.prototype.getFormattingEditsAfterKeystroke = function(fileName, position, key2, options) {
          var _this = this;
          return this.forwardJSONCall("getFormattingEditsAfterKeystroke('" + fileName + "', " + position + ", '" + key2 + "')", function() {
            var localOptions = JSON.parse(options);
            return _this.languageService.getFormattingEditsAfterKeystroke(fileName, position, key2, localOptions);
          });
        };
        LanguageServiceShimObject2.prototype.getDocCommentTemplateAtPosition = function(fileName, position, options) {
          var _this = this;
          return this.forwardJSONCall("getDocCommentTemplateAtPosition('" + fileName + "', " + position + ")", function() {
            return _this.languageService.getDocCommentTemplateAtPosition(fileName, position, options);
          });
        };
        LanguageServiceShimObject2.prototype.getNavigateToItems = function(searchValue, maxResultCount, fileName) {
          var _this = this;
          return this.forwardJSONCall("getNavigateToItems('" + searchValue + "', " + maxResultCount + ", " + fileName + ")", function() {
            return _this.languageService.getNavigateToItems(searchValue, maxResultCount, fileName);
          });
        };
        LanguageServiceShimObject2.prototype.getNavigationBarItems = function(fileName) {
          var _this = this;
          return this.forwardJSONCall("getNavigationBarItems('" + fileName + "')", function() {
            return _this.languageService.getNavigationBarItems(fileName);
          });
        };
        LanguageServiceShimObject2.prototype.getNavigationTree = function(fileName) {
          var _this = this;
          return this.forwardJSONCall("getNavigationTree('" + fileName + "')", function() {
            return _this.languageService.getNavigationTree(fileName);
          });
        };
        LanguageServiceShimObject2.prototype.getOutliningSpans = function(fileName) {
          var _this = this;
          return this.forwardJSONCall("getOutliningSpans('" + fileName + "')", function() {
            return _this.languageService.getOutliningSpans(fileName);
          });
        };
        LanguageServiceShimObject2.prototype.getTodoComments = function(fileName, descriptors) {
          var _this = this;
          return this.forwardJSONCall("getTodoComments('" + fileName + "')", function() {
            return _this.languageService.getTodoComments(fileName, JSON.parse(descriptors));
          });
        };
        LanguageServiceShimObject2.prototype.prepareCallHierarchy = function(fileName, position) {
          var _this = this;
          return this.forwardJSONCall("prepareCallHierarchy('" + fileName + "', " + position + ")", function() {
            return _this.languageService.prepareCallHierarchy(fileName, position);
          });
        };
        LanguageServiceShimObject2.prototype.provideCallHierarchyIncomingCalls = function(fileName, position) {
          var _this = this;
          return this.forwardJSONCall("provideCallHierarchyIncomingCalls('" + fileName + "', " + position + ")", function() {
            return _this.languageService.provideCallHierarchyIncomingCalls(fileName, position);
          });
        };
        LanguageServiceShimObject2.prototype.provideCallHierarchyOutgoingCalls = function(fileName, position) {
          var _this = this;
          return this.forwardJSONCall("provideCallHierarchyOutgoingCalls('" + fileName + "', " + position + ")", function() {
            return _this.languageService.provideCallHierarchyOutgoingCalls(fileName, position);
          });
        };
        LanguageServiceShimObject2.prototype.getEmitOutput = function(fileName) {
          var _this = this;
          return this.forwardJSONCall("getEmitOutput('" + fileName + "')", function() {
            var _a2 = _this.languageService.getEmitOutput(fileName), diagnostics = _a2.diagnostics, rest = __rest(_a2, ["diagnostics"]);
            return __assign(__assign({}, rest), { diagnostics: _this.realizeDiagnostics(diagnostics) });
          });
        };
        LanguageServiceShimObject2.prototype.getEmitOutputObject = function(fileName) {
          var _this = this;
          return forwardCall(this.logger, "getEmitOutput('" + fileName + "')", false, function() {
            return _this.languageService.getEmitOutput(fileName);
          }, this.logPerformance);
        };
        LanguageServiceShimObject2.prototype.toggleLineComment = function(fileName, textRange) {
          var _this = this;
          return this.forwardJSONCall("toggleLineComment('" + fileName + "', '" + JSON.stringify(textRange) + "')", function() {
            return _this.languageService.toggleLineComment(fileName, textRange);
          });
        };
        LanguageServiceShimObject2.prototype.toggleMultilineComment = function(fileName, textRange) {
          var _this = this;
          return this.forwardJSONCall("toggleMultilineComment('" + fileName + "', '" + JSON.stringify(textRange) + "')", function() {
            return _this.languageService.toggleMultilineComment(fileName, textRange);
          });
        };
        LanguageServiceShimObject2.prototype.commentSelection = function(fileName, textRange) {
          var _this = this;
          return this.forwardJSONCall("commentSelection('" + fileName + "', '" + JSON.stringify(textRange) + "')", function() {
            return _this.languageService.commentSelection(fileName, textRange);
          });
        };
        LanguageServiceShimObject2.prototype.uncommentSelection = function(fileName, textRange) {
          var _this = this;
          return this.forwardJSONCall("uncommentSelection('" + fileName + "', '" + JSON.stringify(textRange) + "')", function() {
            return _this.languageService.uncommentSelection(fileName, textRange);
          });
        };
        return LanguageServiceShimObject2;
      }(ShimBase);
      function convertClassifications(classifications) {
        return { spans: classifications.spans.join(","), endOfLineState: classifications.endOfLineState };
      }
      var ClassifierShimObject = function(_super) {
        __extends2(ClassifierShimObject2, _super);
        function ClassifierShimObject2(factory, logger) {
          var _this = _super.call(this, factory) || this;
          _this.logger = logger;
          _this.logPerformance = false;
          _this.classifier = ts3.createClassifier();
          return _this;
        }
        ClassifierShimObject2.prototype.getEncodedLexicalClassifications = function(text, lexState, syntacticClassifierAbsent) {
          var _this = this;
          if (syntacticClassifierAbsent === void 0) {
            syntacticClassifierAbsent = false;
          }
          return forwardJSONCall(this.logger, "getEncodedLexicalClassifications", function() {
            return convertClassifications(_this.classifier.getEncodedLexicalClassifications(text, lexState, syntacticClassifierAbsent));
          }, this.logPerformance);
        };
        ClassifierShimObject2.prototype.getClassificationsForLine = function(text, lexState, classifyKeywordsInGenerics) {
          if (classifyKeywordsInGenerics === void 0) {
            classifyKeywordsInGenerics = false;
          }
          var classification = this.classifier.getClassificationsForLine(text, lexState, classifyKeywordsInGenerics);
          var result2 = "";
          for (var _i = 0, _a2 = classification.entries; _i < _a2.length; _i++) {
            var item = _a2[_i];
            result2 += item.length + "\n";
            result2 += item.classification + "\n";
          }
          result2 += classification.finalLexState;
          return result2;
        };
        return ClassifierShimObject2;
      }(ShimBase);
      var CoreServicesShimObject = function(_super) {
        __extends2(CoreServicesShimObject2, _super);
        function CoreServicesShimObject2(factory, logger, host) {
          var _this = _super.call(this, factory) || this;
          _this.logger = logger;
          _this.host = host;
          _this.logPerformance = false;
          return _this;
        }
        CoreServicesShimObject2.prototype.forwardJSONCall = function(actionDescription, action) {
          return forwardJSONCall(this.logger, actionDescription, action, this.logPerformance);
        };
        CoreServicesShimObject2.prototype.resolveModuleName = function(fileName, moduleName, compilerOptionsJson) {
          var _this = this;
          return this.forwardJSONCall("resolveModuleName('" + fileName + "')", function() {
            var compilerOptions = JSON.parse(compilerOptionsJson);
            var result2 = ts3.resolveModuleName(moduleName, ts3.normalizeSlashes(fileName), compilerOptions, _this.host);
            var resolvedFileName = result2.resolvedModule ? result2.resolvedModule.resolvedFileName : void 0;
            if (result2.resolvedModule && result2.resolvedModule.extension !== ".ts" && result2.resolvedModule.extension !== ".tsx" && result2.resolvedModule.extension !== ".d.ts") {
              resolvedFileName = void 0;
            }
            return {
              resolvedFileName,
              failedLookupLocations: result2.failedLookupLocations
            };
          });
        };
        CoreServicesShimObject2.prototype.resolveTypeReferenceDirective = function(fileName, typeReferenceDirective, compilerOptionsJson) {
          var _this = this;
          return this.forwardJSONCall("resolveTypeReferenceDirective(" + fileName + ")", function() {
            var compilerOptions = JSON.parse(compilerOptionsJson);
            var result2 = ts3.resolveTypeReferenceDirective(typeReferenceDirective, ts3.normalizeSlashes(fileName), compilerOptions, _this.host);
            return {
              resolvedFileName: result2.resolvedTypeReferenceDirective ? result2.resolvedTypeReferenceDirective.resolvedFileName : void 0,
              primary: result2.resolvedTypeReferenceDirective ? result2.resolvedTypeReferenceDirective.primary : true,
              failedLookupLocations: result2.failedLookupLocations
            };
          });
        };
        CoreServicesShimObject2.prototype.getPreProcessedFileInfo = function(fileName, sourceTextSnapshot) {
          var _this = this;
          return this.forwardJSONCall("getPreProcessedFileInfo('" + fileName + "')", function() {
            var result2 = ts3.preProcessFile(ts3.getSnapshotText(sourceTextSnapshot), true, true);
            return {
              referencedFiles: _this.convertFileReferences(result2.referencedFiles),
              importedFiles: _this.convertFileReferences(result2.importedFiles),
              ambientExternalModules: result2.ambientExternalModules,
              isLibFile: result2.isLibFile,
              typeReferenceDirectives: _this.convertFileReferences(result2.typeReferenceDirectives),
              libReferenceDirectives: _this.convertFileReferences(result2.libReferenceDirectives)
            };
          });
        };
        CoreServicesShimObject2.prototype.getAutomaticTypeDirectiveNames = function(compilerOptionsJson) {
          var _this = this;
          return this.forwardJSONCall("getAutomaticTypeDirectiveNames('" + compilerOptionsJson + "')", function() {
            var compilerOptions = JSON.parse(compilerOptionsJson);
            return ts3.getAutomaticTypeDirectiveNames(compilerOptions, _this.host);
          });
        };
        CoreServicesShimObject2.prototype.convertFileReferences = function(refs) {
          if (!refs) {
            return void 0;
          }
          var result2 = [];
          for (var _i = 0, refs_1 = refs; _i < refs_1.length; _i++) {
            var ref2 = refs_1[_i];
            result2.push({
              path: ts3.normalizeSlashes(ref2.fileName),
              position: ref2.pos,
              length: ref2.end - ref2.pos
            });
          }
          return result2;
        };
        CoreServicesShimObject2.prototype.getTSConfigFileInfo = function(fileName, sourceTextSnapshot) {
          var _this = this;
          return this.forwardJSONCall("getTSConfigFileInfo('" + fileName + "')", function() {
            var result2 = ts3.parseJsonText(fileName, ts3.getSnapshotText(sourceTextSnapshot));
            var normalizedFileName = ts3.normalizeSlashes(fileName);
            var configFile = ts3.parseJsonSourceFileConfigFileContent(result2, _this.host, ts3.getDirectoryPath(normalizedFileName), {}, normalizedFileName);
            return {
              options: configFile.options,
              typeAcquisition: configFile.typeAcquisition,
              files: configFile.fileNames,
              raw: configFile.raw,
              errors: realizeDiagnostics(__spreadArray(__spreadArray([], result2.parseDiagnostics), configFile.errors), "\r\n")
            };
          });
        };
        CoreServicesShimObject2.prototype.getDefaultCompilationSettings = function() {
          return this.forwardJSONCall("getDefaultCompilationSettings()", function() {
            return ts3.getDefaultCompilerOptions();
          });
        };
        CoreServicesShimObject2.prototype.discoverTypings = function(discoverTypingsJson) {
          var _this = this;
          var getCanonicalFileName = ts3.createGetCanonicalFileName(false);
          return this.forwardJSONCall("discoverTypings()", function() {
            var info = JSON.parse(discoverTypingsJson);
            if (_this.safeList === void 0) {
              _this.safeList = ts3.JsTyping.loadSafeList(_this.host, ts3.toPath(info.safeListPath, info.safeListPath, getCanonicalFileName));
            }
            return ts3.JsTyping.discoverTypings(_this.host, function(msg) {
              return _this.logger.log(msg);
            }, info.fileNames, ts3.toPath(info.projectRootPath, info.projectRootPath, getCanonicalFileName), _this.safeList, info.packageNameToTypingLocation, info.typeAcquisition, info.unresolvedImports, info.typesRegistry);
          });
        };
        return CoreServicesShimObject2;
      }(ShimBase);
      var TypeScriptServicesFactory = function() {
        function TypeScriptServicesFactory2() {
          this._shims = [];
        }
        TypeScriptServicesFactory2.prototype.getServicesVersion = function() {
          return ts3.servicesVersion;
        };
        TypeScriptServicesFactory2.prototype.createLanguageServiceShim = function(host) {
          try {
            if (this.documentRegistry === void 0) {
              this.documentRegistry = ts3.createDocumentRegistry(host.useCaseSensitiveFileNames && host.useCaseSensitiveFileNames(), host.getCurrentDirectory());
            }
            var hostAdapter = new LanguageServiceShimHostAdapter(host);
            var languageService = ts3.createLanguageService(hostAdapter, this.documentRegistry, false);
            return new LanguageServiceShimObject(this, host, languageService);
          } catch (err2) {
            logInternalError(host, err2);
            throw err2;
          }
        };
        TypeScriptServicesFactory2.prototype.createClassifierShim = function(logger) {
          try {
            return new ClassifierShimObject(this, logger);
          } catch (err2) {
            logInternalError(logger, err2);
            throw err2;
          }
        };
        TypeScriptServicesFactory2.prototype.createCoreServicesShim = function(host) {
          try {
            var adapter = new CoreServicesShimHostAdapter(host);
            return new CoreServicesShimObject(this, host, adapter);
          } catch (err2) {
            logInternalError(host, err2);
            throw err2;
          }
        };
        TypeScriptServicesFactory2.prototype.close = function() {
          ts3.clear(this._shims);
          this.documentRegistry = void 0;
        };
        TypeScriptServicesFactory2.prototype.registerShim = function(shim) {
          this._shims.push(shim);
        };
        TypeScriptServicesFactory2.prototype.unregisterShim = function(shim) {
          for (var i3 = 0; i3 < this._shims.length; i3++) {
            if (this._shims[i3] === shim) {
              delete this._shims[i3];
              return;
            }
          }
          throw new Error("Invalid operation");
        };
        return TypeScriptServicesFactory2;
      }();
      ts3.TypeScriptServicesFactory = TypeScriptServicesFactory;
    })(ts2 || (ts2 = {}));
    (function() {
      if (typeof globalThis === "object")
        return;
      try {
        Object.defineProperty(Object.prototype, "__magic__", {
          get: function() {
            return this;
          },
          configurable: true
        });
        __magic__.globalThis = __magic__;
        if (typeof globalThis === "undefined") {
          window.globalThis = window;
        }
        delete Object.prototype.__magic__;
      } catch (error) {
        window.globalThis = window;
      }
    })();
    if (typeof process === "undefined" || process.browser) {
      globalThis.TypeScript = globalThis.TypeScript || {};
      globalThis.TypeScript.Services = globalThis.TypeScript.Services || {};
      globalThis.TypeScript.Services.TypeScriptServicesFactory = ts2.TypeScriptServicesFactory;
      globalThis.toolsVersion = ts2.versionMajorMinor;
    }
    if (typeof module2 !== "undefined" && module2.exports) {
      module2.exports = ts2;
    }
    var ts2;
    (function(ts3) {
      var factoryDeprecation = { since: "4.0", warnAfter: "4.1", message: "Use the appropriate method on 'ts.factory' or the 'factory' supplied by your transformation context instead." };
      ts3.createNodeArray = ts3.Debug.deprecate(ts3.factory.createNodeArray, factoryDeprecation);
      ts3.createNumericLiteral = ts3.Debug.deprecate(ts3.factory.createNumericLiteral, factoryDeprecation);
      ts3.createBigIntLiteral = ts3.Debug.deprecate(ts3.factory.createBigIntLiteral, factoryDeprecation);
      ts3.createStringLiteral = ts3.Debug.deprecate(ts3.factory.createStringLiteral, factoryDeprecation);
      ts3.createStringLiteralFromNode = ts3.Debug.deprecate(ts3.factory.createStringLiteralFromNode, factoryDeprecation);
      ts3.createRegularExpressionLiteral = ts3.Debug.deprecate(ts3.factory.createRegularExpressionLiteral, factoryDeprecation);
      ts3.createLoopVariable = ts3.Debug.deprecate(ts3.factory.createLoopVariable, factoryDeprecation);
      ts3.createUniqueName = ts3.Debug.deprecate(ts3.factory.createUniqueName, factoryDeprecation);
      ts3.createPrivateIdentifier = ts3.Debug.deprecate(ts3.factory.createPrivateIdentifier, factoryDeprecation);
      ts3.createSuper = ts3.Debug.deprecate(ts3.factory.createSuper, factoryDeprecation);
      ts3.createThis = ts3.Debug.deprecate(ts3.factory.createThis, factoryDeprecation);
      ts3.createNull = ts3.Debug.deprecate(ts3.factory.createNull, factoryDeprecation);
      ts3.createTrue = ts3.Debug.deprecate(ts3.factory.createTrue, factoryDeprecation);
      ts3.createFalse = ts3.Debug.deprecate(ts3.factory.createFalse, factoryDeprecation);
      ts3.createModifier = ts3.Debug.deprecate(ts3.factory.createModifier, factoryDeprecation);
      ts3.createModifiersFromModifierFlags = ts3.Debug.deprecate(ts3.factory.createModifiersFromModifierFlags, factoryDeprecation);
      ts3.createQualifiedName = ts3.Debug.deprecate(ts3.factory.createQualifiedName, factoryDeprecation);
      ts3.updateQualifiedName = ts3.Debug.deprecate(ts3.factory.updateQualifiedName, factoryDeprecation);
      ts3.createComputedPropertyName = ts3.Debug.deprecate(ts3.factory.createComputedPropertyName, factoryDeprecation);
      ts3.updateComputedPropertyName = ts3.Debug.deprecate(ts3.factory.updateComputedPropertyName, factoryDeprecation);
      ts3.createTypeParameterDeclaration = ts3.Debug.deprecate(ts3.factory.createTypeParameterDeclaration, factoryDeprecation);
      ts3.updateTypeParameterDeclaration = ts3.Debug.deprecate(ts3.factory.updateTypeParameterDeclaration, factoryDeprecation);
      ts3.createParameter = ts3.Debug.deprecate(ts3.factory.createParameterDeclaration, factoryDeprecation);
      ts3.updateParameter = ts3.Debug.deprecate(ts3.factory.updateParameterDeclaration, factoryDeprecation);
      ts3.createDecorator = ts3.Debug.deprecate(ts3.factory.createDecorator, factoryDeprecation);
      ts3.updateDecorator = ts3.Debug.deprecate(ts3.factory.updateDecorator, factoryDeprecation);
      ts3.createProperty = ts3.Debug.deprecate(ts3.factory.createPropertyDeclaration, factoryDeprecation);
      ts3.updateProperty = ts3.Debug.deprecate(ts3.factory.updatePropertyDeclaration, factoryDeprecation);
      ts3.createMethod = ts3.Debug.deprecate(ts3.factory.createMethodDeclaration, factoryDeprecation);
      ts3.updateMethod = ts3.Debug.deprecate(ts3.factory.updateMethodDeclaration, factoryDeprecation);
      ts3.createConstructor = ts3.Debug.deprecate(ts3.factory.createConstructorDeclaration, factoryDeprecation);
      ts3.updateConstructor = ts3.Debug.deprecate(ts3.factory.updateConstructorDeclaration, factoryDeprecation);
      ts3.createGetAccessor = ts3.Debug.deprecate(ts3.factory.createGetAccessorDeclaration, factoryDeprecation);
      ts3.updateGetAccessor = ts3.Debug.deprecate(ts3.factory.updateGetAccessorDeclaration, factoryDeprecation);
      ts3.createSetAccessor = ts3.Debug.deprecate(ts3.factory.createSetAccessorDeclaration, factoryDeprecation);
      ts3.updateSetAccessor = ts3.Debug.deprecate(ts3.factory.updateSetAccessorDeclaration, factoryDeprecation);
      ts3.createCallSignature = ts3.Debug.deprecate(ts3.factory.createCallSignature, factoryDeprecation);
      ts3.updateCallSignature = ts3.Debug.deprecate(ts3.factory.updateCallSignature, factoryDeprecation);
      ts3.createConstructSignature = ts3.Debug.deprecate(ts3.factory.createConstructSignature, factoryDeprecation);
      ts3.updateConstructSignature = ts3.Debug.deprecate(ts3.factory.updateConstructSignature, factoryDeprecation);
      ts3.updateIndexSignature = ts3.Debug.deprecate(ts3.factory.updateIndexSignature, factoryDeprecation);
      ts3.createKeywordTypeNode = ts3.Debug.deprecate(ts3.factory.createKeywordTypeNode, factoryDeprecation);
      ts3.createTypePredicateNodeWithModifier = ts3.Debug.deprecate(ts3.factory.createTypePredicateNode, factoryDeprecation);
      ts3.updateTypePredicateNodeWithModifier = ts3.Debug.deprecate(ts3.factory.updateTypePredicateNode, factoryDeprecation);
      ts3.createTypeReferenceNode = ts3.Debug.deprecate(ts3.factory.createTypeReferenceNode, factoryDeprecation);
      ts3.updateTypeReferenceNode = ts3.Debug.deprecate(ts3.factory.updateTypeReferenceNode, factoryDeprecation);
      ts3.createFunctionTypeNode = ts3.Debug.deprecate(ts3.factory.createFunctionTypeNode, factoryDeprecation);
      ts3.updateFunctionTypeNode = ts3.Debug.deprecate(ts3.factory.updateFunctionTypeNode, factoryDeprecation);
      ts3.createConstructorTypeNode = ts3.Debug.deprecate(function(typeParameters, parameters, type3) {
        return ts3.factory.createConstructorTypeNode(void 0, typeParameters, parameters, type3);
      }, factoryDeprecation);
      ts3.updateConstructorTypeNode = ts3.Debug.deprecate(function(node, typeParameters, parameters, type3) {
        return ts3.factory.updateConstructorTypeNode(node, node.modifiers, typeParameters, parameters, type3);
      }, factoryDeprecation);
      ts3.createTypeQueryNode = ts3.Debug.deprecate(ts3.factory.createTypeQueryNode, factoryDeprecation);
      ts3.updateTypeQueryNode = ts3.Debug.deprecate(ts3.factory.updateTypeQueryNode, factoryDeprecation);
      ts3.createTypeLiteralNode = ts3.Debug.deprecate(ts3.factory.createTypeLiteralNode, factoryDeprecation);
      ts3.updateTypeLiteralNode = ts3.Debug.deprecate(ts3.factory.updateTypeLiteralNode, factoryDeprecation);
      ts3.createArrayTypeNode = ts3.Debug.deprecate(ts3.factory.createArrayTypeNode, factoryDeprecation);
      ts3.updateArrayTypeNode = ts3.Debug.deprecate(ts3.factory.updateArrayTypeNode, factoryDeprecation);
      ts3.createTupleTypeNode = ts3.Debug.deprecate(ts3.factory.createTupleTypeNode, factoryDeprecation);
      ts3.updateTupleTypeNode = ts3.Debug.deprecate(ts3.factory.updateTupleTypeNode, factoryDeprecation);
      ts3.createOptionalTypeNode = ts3.Debug.deprecate(ts3.factory.createOptionalTypeNode, factoryDeprecation);
      ts3.updateOptionalTypeNode = ts3.Debug.deprecate(ts3.factory.updateOptionalTypeNode, factoryDeprecation);
      ts3.createRestTypeNode = ts3.Debug.deprecate(ts3.factory.createRestTypeNode, factoryDeprecation);
      ts3.updateRestTypeNode = ts3.Debug.deprecate(ts3.factory.updateRestTypeNode, factoryDeprecation);
      ts3.createUnionTypeNode = ts3.Debug.deprecate(ts3.factory.createUnionTypeNode, factoryDeprecation);
      ts3.updateUnionTypeNode = ts3.Debug.deprecate(ts3.factory.updateUnionTypeNode, factoryDeprecation);
      ts3.createIntersectionTypeNode = ts3.Debug.deprecate(ts3.factory.createIntersectionTypeNode, factoryDeprecation);
      ts3.updateIntersectionTypeNode = ts3.Debug.deprecate(ts3.factory.updateIntersectionTypeNode, factoryDeprecation);
      ts3.createConditionalTypeNode = ts3.Debug.deprecate(ts3.factory.createConditionalTypeNode, factoryDeprecation);
      ts3.updateConditionalTypeNode = ts3.Debug.deprecate(ts3.factory.updateConditionalTypeNode, factoryDeprecation);
      ts3.createInferTypeNode = ts3.Debug.deprecate(ts3.factory.createInferTypeNode, factoryDeprecation);
      ts3.updateInferTypeNode = ts3.Debug.deprecate(ts3.factory.updateInferTypeNode, factoryDeprecation);
      ts3.createImportTypeNode = ts3.Debug.deprecate(ts3.factory.createImportTypeNode, factoryDeprecation);
      ts3.updateImportTypeNode = ts3.Debug.deprecate(ts3.factory.updateImportTypeNode, factoryDeprecation);
      ts3.createParenthesizedType = ts3.Debug.deprecate(ts3.factory.createParenthesizedType, factoryDeprecation);
      ts3.updateParenthesizedType = ts3.Debug.deprecate(ts3.factory.updateParenthesizedType, factoryDeprecation);
      ts3.createThisTypeNode = ts3.Debug.deprecate(ts3.factory.createThisTypeNode, factoryDeprecation);
      ts3.updateTypeOperatorNode = ts3.Debug.deprecate(ts3.factory.updateTypeOperatorNode, factoryDeprecation);
      ts3.createIndexedAccessTypeNode = ts3.Debug.deprecate(ts3.factory.createIndexedAccessTypeNode, factoryDeprecation);
      ts3.updateIndexedAccessTypeNode = ts3.Debug.deprecate(ts3.factory.updateIndexedAccessTypeNode, factoryDeprecation);
      ts3.createMappedTypeNode = ts3.Debug.deprecate(ts3.factory.createMappedTypeNode, factoryDeprecation);
      ts3.updateMappedTypeNode = ts3.Debug.deprecate(ts3.factory.updateMappedTypeNode, factoryDeprecation);
      ts3.createLiteralTypeNode = ts3.Debug.deprecate(ts3.factory.createLiteralTypeNode, factoryDeprecation);
      ts3.updateLiteralTypeNode = ts3.Debug.deprecate(ts3.factory.updateLiteralTypeNode, factoryDeprecation);
      ts3.createObjectBindingPattern = ts3.Debug.deprecate(ts3.factory.createObjectBindingPattern, factoryDeprecation);
      ts3.updateObjectBindingPattern = ts3.Debug.deprecate(ts3.factory.updateObjectBindingPattern, factoryDeprecation);
      ts3.createArrayBindingPattern = ts3.Debug.deprecate(ts3.factory.createArrayBindingPattern, factoryDeprecation);
      ts3.updateArrayBindingPattern = ts3.Debug.deprecate(ts3.factory.updateArrayBindingPattern, factoryDeprecation);
      ts3.createBindingElement = ts3.Debug.deprecate(ts3.factory.createBindingElement, factoryDeprecation);
      ts3.updateBindingElement = ts3.Debug.deprecate(ts3.factory.updateBindingElement, factoryDeprecation);
      ts3.createArrayLiteral = ts3.Debug.deprecate(ts3.factory.createArrayLiteralExpression, factoryDeprecation);
      ts3.updateArrayLiteral = ts3.Debug.deprecate(ts3.factory.updateArrayLiteralExpression, factoryDeprecation);
      ts3.createObjectLiteral = ts3.Debug.deprecate(ts3.factory.createObjectLiteralExpression, factoryDeprecation);
      ts3.updateObjectLiteral = ts3.Debug.deprecate(ts3.factory.updateObjectLiteralExpression, factoryDeprecation);
      ts3.createPropertyAccess = ts3.Debug.deprecate(ts3.factory.createPropertyAccessExpression, factoryDeprecation);
      ts3.updatePropertyAccess = ts3.Debug.deprecate(ts3.factory.updatePropertyAccessExpression, factoryDeprecation);
      ts3.createPropertyAccessChain = ts3.Debug.deprecate(ts3.factory.createPropertyAccessChain, factoryDeprecation);
      ts3.updatePropertyAccessChain = ts3.Debug.deprecate(ts3.factory.updatePropertyAccessChain, factoryDeprecation);
      ts3.createElementAccess = ts3.Debug.deprecate(ts3.factory.createElementAccessExpression, factoryDeprecation);
      ts3.updateElementAccess = ts3.Debug.deprecate(ts3.factory.updateElementAccessExpression, factoryDeprecation);
      ts3.createElementAccessChain = ts3.Debug.deprecate(ts3.factory.createElementAccessChain, factoryDeprecation);
      ts3.updateElementAccessChain = ts3.Debug.deprecate(ts3.factory.updateElementAccessChain, factoryDeprecation);
      ts3.createCall = ts3.Debug.deprecate(ts3.factory.createCallExpression, factoryDeprecation);
      ts3.updateCall = ts3.Debug.deprecate(ts3.factory.updateCallExpression, factoryDeprecation);
      ts3.createCallChain = ts3.Debug.deprecate(ts3.factory.createCallChain, factoryDeprecation);
      ts3.updateCallChain = ts3.Debug.deprecate(ts3.factory.updateCallChain, factoryDeprecation);
      ts3.createNew = ts3.Debug.deprecate(ts3.factory.createNewExpression, factoryDeprecation);
      ts3.updateNew = ts3.Debug.deprecate(ts3.factory.updateNewExpression, factoryDeprecation);
      ts3.createTypeAssertion = ts3.Debug.deprecate(ts3.factory.createTypeAssertion, factoryDeprecation);
      ts3.updateTypeAssertion = ts3.Debug.deprecate(ts3.factory.updateTypeAssertion, factoryDeprecation);
      ts3.createParen = ts3.Debug.deprecate(ts3.factory.createParenthesizedExpression, factoryDeprecation);
      ts3.updateParen = ts3.Debug.deprecate(ts3.factory.updateParenthesizedExpression, factoryDeprecation);
      ts3.createFunctionExpression = ts3.Debug.deprecate(ts3.factory.createFunctionExpression, factoryDeprecation);
      ts3.updateFunctionExpression = ts3.Debug.deprecate(ts3.factory.updateFunctionExpression, factoryDeprecation);
      ts3.createDelete = ts3.Debug.deprecate(ts3.factory.createDeleteExpression, factoryDeprecation);
      ts3.updateDelete = ts3.Debug.deprecate(ts3.factory.updateDeleteExpression, factoryDeprecation);
      ts3.createTypeOf = ts3.Debug.deprecate(ts3.factory.createTypeOfExpression, factoryDeprecation);
      ts3.updateTypeOf = ts3.Debug.deprecate(ts3.factory.updateTypeOfExpression, factoryDeprecation);
      ts3.createVoid = ts3.Debug.deprecate(ts3.factory.createVoidExpression, factoryDeprecation);
      ts3.updateVoid = ts3.Debug.deprecate(ts3.factory.updateVoidExpression, factoryDeprecation);
      ts3.createAwait = ts3.Debug.deprecate(ts3.factory.createAwaitExpression, factoryDeprecation);
      ts3.updateAwait = ts3.Debug.deprecate(ts3.factory.updateAwaitExpression, factoryDeprecation);
      ts3.createPrefix = ts3.Debug.deprecate(ts3.factory.createPrefixUnaryExpression, factoryDeprecation);
      ts3.updatePrefix = ts3.Debug.deprecate(ts3.factory.updatePrefixUnaryExpression, factoryDeprecation);
      ts3.createPostfix = ts3.Debug.deprecate(ts3.factory.createPostfixUnaryExpression, factoryDeprecation);
      ts3.updatePostfix = ts3.Debug.deprecate(ts3.factory.updatePostfixUnaryExpression, factoryDeprecation);
      ts3.createBinary = ts3.Debug.deprecate(ts3.factory.createBinaryExpression, factoryDeprecation);
      ts3.updateConditional = ts3.Debug.deprecate(ts3.factory.updateConditionalExpression, factoryDeprecation);
      ts3.createTemplateExpression = ts3.Debug.deprecate(ts3.factory.createTemplateExpression, factoryDeprecation);
      ts3.updateTemplateExpression = ts3.Debug.deprecate(ts3.factory.updateTemplateExpression, factoryDeprecation);
      ts3.createTemplateHead = ts3.Debug.deprecate(ts3.factory.createTemplateHead, factoryDeprecation);
      ts3.createTemplateMiddle = ts3.Debug.deprecate(ts3.factory.createTemplateMiddle, factoryDeprecation);
      ts3.createTemplateTail = ts3.Debug.deprecate(ts3.factory.createTemplateTail, factoryDeprecation);
      ts3.createNoSubstitutionTemplateLiteral = ts3.Debug.deprecate(ts3.factory.createNoSubstitutionTemplateLiteral, factoryDeprecation);
      ts3.updateYield = ts3.Debug.deprecate(ts3.factory.updateYieldExpression, factoryDeprecation);
      ts3.createSpread = ts3.Debug.deprecate(ts3.factory.createSpreadElement, factoryDeprecation);
      ts3.updateSpread = ts3.Debug.deprecate(ts3.factory.updateSpreadElement, factoryDeprecation);
      ts3.createOmittedExpression = ts3.Debug.deprecate(ts3.factory.createOmittedExpression, factoryDeprecation);
      ts3.createAsExpression = ts3.Debug.deprecate(ts3.factory.createAsExpression, factoryDeprecation);
      ts3.updateAsExpression = ts3.Debug.deprecate(ts3.factory.updateAsExpression, factoryDeprecation);
      ts3.createNonNullExpression = ts3.Debug.deprecate(ts3.factory.createNonNullExpression, factoryDeprecation);
      ts3.updateNonNullExpression = ts3.Debug.deprecate(ts3.factory.updateNonNullExpression, factoryDeprecation);
      ts3.createNonNullChain = ts3.Debug.deprecate(ts3.factory.createNonNullChain, factoryDeprecation);
      ts3.updateNonNullChain = ts3.Debug.deprecate(ts3.factory.updateNonNullChain, factoryDeprecation);
      ts3.createMetaProperty = ts3.Debug.deprecate(ts3.factory.createMetaProperty, factoryDeprecation);
      ts3.updateMetaProperty = ts3.Debug.deprecate(ts3.factory.updateMetaProperty, factoryDeprecation);
      ts3.createTemplateSpan = ts3.Debug.deprecate(ts3.factory.createTemplateSpan, factoryDeprecation);
      ts3.updateTemplateSpan = ts3.Debug.deprecate(ts3.factory.updateTemplateSpan, factoryDeprecation);
      ts3.createSemicolonClassElement = ts3.Debug.deprecate(ts3.factory.createSemicolonClassElement, factoryDeprecation);
      ts3.createBlock = ts3.Debug.deprecate(ts3.factory.createBlock, factoryDeprecation);
      ts3.updateBlock = ts3.Debug.deprecate(ts3.factory.updateBlock, factoryDeprecation);
      ts3.createVariableStatement = ts3.Debug.deprecate(ts3.factory.createVariableStatement, factoryDeprecation);
      ts3.updateVariableStatement = ts3.Debug.deprecate(ts3.factory.updateVariableStatement, factoryDeprecation);
      ts3.createEmptyStatement = ts3.Debug.deprecate(ts3.factory.createEmptyStatement, factoryDeprecation);
      ts3.createExpressionStatement = ts3.Debug.deprecate(ts3.factory.createExpressionStatement, factoryDeprecation);
      ts3.updateExpressionStatement = ts3.Debug.deprecate(ts3.factory.updateExpressionStatement, factoryDeprecation);
      ts3.createStatement = ts3.Debug.deprecate(ts3.factory.createExpressionStatement, factoryDeprecation);
      ts3.updateStatement = ts3.Debug.deprecate(ts3.factory.updateExpressionStatement, factoryDeprecation);
      ts3.createIf = ts3.Debug.deprecate(ts3.factory.createIfStatement, factoryDeprecation);
      ts3.updateIf = ts3.Debug.deprecate(ts3.factory.updateIfStatement, factoryDeprecation);
      ts3.createDo = ts3.Debug.deprecate(ts3.factory.createDoStatement, factoryDeprecation);
      ts3.updateDo = ts3.Debug.deprecate(ts3.factory.updateDoStatement, factoryDeprecation);
      ts3.createWhile = ts3.Debug.deprecate(ts3.factory.createWhileStatement, factoryDeprecation);
      ts3.updateWhile = ts3.Debug.deprecate(ts3.factory.updateWhileStatement, factoryDeprecation);
      ts3.createFor = ts3.Debug.deprecate(ts3.factory.createForStatement, factoryDeprecation);
      ts3.updateFor = ts3.Debug.deprecate(ts3.factory.updateForStatement, factoryDeprecation);
      ts3.createForIn = ts3.Debug.deprecate(ts3.factory.createForInStatement, factoryDeprecation);
      ts3.updateForIn = ts3.Debug.deprecate(ts3.factory.updateForInStatement, factoryDeprecation);
      ts3.createForOf = ts3.Debug.deprecate(ts3.factory.createForOfStatement, factoryDeprecation);
      ts3.updateForOf = ts3.Debug.deprecate(ts3.factory.updateForOfStatement, factoryDeprecation);
      ts3.createContinue = ts3.Debug.deprecate(ts3.factory.createContinueStatement, factoryDeprecation);
      ts3.updateContinue = ts3.Debug.deprecate(ts3.factory.updateContinueStatement, factoryDeprecation);
      ts3.createBreak = ts3.Debug.deprecate(ts3.factory.createBreakStatement, factoryDeprecation);
      ts3.updateBreak = ts3.Debug.deprecate(ts3.factory.updateBreakStatement, factoryDeprecation);
      ts3.createReturn = ts3.Debug.deprecate(ts3.factory.createReturnStatement, factoryDeprecation);
      ts3.updateReturn = ts3.Debug.deprecate(ts3.factory.updateReturnStatement, factoryDeprecation);
      ts3.createWith = ts3.Debug.deprecate(ts3.factory.createWithStatement, factoryDeprecation);
      ts3.updateWith = ts3.Debug.deprecate(ts3.factory.updateWithStatement, factoryDeprecation);
      ts3.createSwitch = ts3.Debug.deprecate(ts3.factory.createSwitchStatement, factoryDeprecation);
      ts3.updateSwitch = ts3.Debug.deprecate(ts3.factory.updateSwitchStatement, factoryDeprecation);
      ts3.createLabel = ts3.Debug.deprecate(ts3.factory.createLabeledStatement, factoryDeprecation);
      ts3.updateLabel = ts3.Debug.deprecate(ts3.factory.updateLabeledStatement, factoryDeprecation);
      ts3.createThrow = ts3.Debug.deprecate(ts3.factory.createThrowStatement, factoryDeprecation);
      ts3.updateThrow = ts3.Debug.deprecate(ts3.factory.updateThrowStatement, factoryDeprecation);
      ts3.createTry = ts3.Debug.deprecate(ts3.factory.createTryStatement, factoryDeprecation);
      ts3.updateTry = ts3.Debug.deprecate(ts3.factory.updateTryStatement, factoryDeprecation);
      ts3.createDebuggerStatement = ts3.Debug.deprecate(ts3.factory.createDebuggerStatement, factoryDeprecation);
      ts3.createVariableDeclarationList = ts3.Debug.deprecate(ts3.factory.createVariableDeclarationList, factoryDeprecation);
      ts3.updateVariableDeclarationList = ts3.Debug.deprecate(ts3.factory.updateVariableDeclarationList, factoryDeprecation);
      ts3.createFunctionDeclaration = ts3.Debug.deprecate(ts3.factory.createFunctionDeclaration, factoryDeprecation);
      ts3.updateFunctionDeclaration = ts3.Debug.deprecate(ts3.factory.updateFunctionDeclaration, factoryDeprecation);
      ts3.createClassDeclaration = ts3.Debug.deprecate(ts3.factory.createClassDeclaration, factoryDeprecation);
      ts3.updateClassDeclaration = ts3.Debug.deprecate(ts3.factory.updateClassDeclaration, factoryDeprecation);
      ts3.createInterfaceDeclaration = ts3.Debug.deprecate(ts3.factory.createInterfaceDeclaration, factoryDeprecation);
      ts3.updateInterfaceDeclaration = ts3.Debug.deprecate(ts3.factory.updateInterfaceDeclaration, factoryDeprecation);
      ts3.createTypeAliasDeclaration = ts3.Debug.deprecate(ts3.factory.createTypeAliasDeclaration, factoryDeprecation);
      ts3.updateTypeAliasDeclaration = ts3.Debug.deprecate(ts3.factory.updateTypeAliasDeclaration, factoryDeprecation);
      ts3.createEnumDeclaration = ts3.Debug.deprecate(ts3.factory.createEnumDeclaration, factoryDeprecation);
      ts3.updateEnumDeclaration = ts3.Debug.deprecate(ts3.factory.updateEnumDeclaration, factoryDeprecation);
      ts3.createModuleDeclaration = ts3.Debug.deprecate(ts3.factory.createModuleDeclaration, factoryDeprecation);
      ts3.updateModuleDeclaration = ts3.Debug.deprecate(ts3.factory.updateModuleDeclaration, factoryDeprecation);
      ts3.createModuleBlock = ts3.Debug.deprecate(ts3.factory.createModuleBlock, factoryDeprecation);
      ts3.updateModuleBlock = ts3.Debug.deprecate(ts3.factory.updateModuleBlock, factoryDeprecation);
      ts3.createCaseBlock = ts3.Debug.deprecate(ts3.factory.createCaseBlock, factoryDeprecation);
      ts3.updateCaseBlock = ts3.Debug.deprecate(ts3.factory.updateCaseBlock, factoryDeprecation);
      ts3.createNamespaceExportDeclaration = ts3.Debug.deprecate(ts3.factory.createNamespaceExportDeclaration, factoryDeprecation);
      ts3.updateNamespaceExportDeclaration = ts3.Debug.deprecate(ts3.factory.updateNamespaceExportDeclaration, factoryDeprecation);
      ts3.createImportEqualsDeclaration = ts3.Debug.deprecate(ts3.factory.createImportEqualsDeclaration, factoryDeprecation);
      ts3.updateImportEqualsDeclaration = ts3.Debug.deprecate(ts3.factory.updateImportEqualsDeclaration, factoryDeprecation);
      ts3.createImportDeclaration = ts3.Debug.deprecate(ts3.factory.createImportDeclaration, factoryDeprecation);
      ts3.updateImportDeclaration = ts3.Debug.deprecate(ts3.factory.updateImportDeclaration, factoryDeprecation);
      ts3.createNamespaceImport = ts3.Debug.deprecate(ts3.factory.createNamespaceImport, factoryDeprecation);
      ts3.updateNamespaceImport = ts3.Debug.deprecate(ts3.factory.updateNamespaceImport, factoryDeprecation);
      ts3.createNamedImports = ts3.Debug.deprecate(ts3.factory.createNamedImports, factoryDeprecation);
      ts3.updateNamedImports = ts3.Debug.deprecate(ts3.factory.updateNamedImports, factoryDeprecation);
      ts3.createImportSpecifier = ts3.Debug.deprecate(ts3.factory.createImportSpecifier, factoryDeprecation);
      ts3.updateImportSpecifier = ts3.Debug.deprecate(ts3.factory.updateImportSpecifier, factoryDeprecation);
      ts3.createExportAssignment = ts3.Debug.deprecate(ts3.factory.createExportAssignment, factoryDeprecation);
      ts3.updateExportAssignment = ts3.Debug.deprecate(ts3.factory.updateExportAssignment, factoryDeprecation);
      ts3.createNamedExports = ts3.Debug.deprecate(ts3.factory.createNamedExports, factoryDeprecation);
      ts3.updateNamedExports = ts3.Debug.deprecate(ts3.factory.updateNamedExports, factoryDeprecation);
      ts3.createExportSpecifier = ts3.Debug.deprecate(ts3.factory.createExportSpecifier, factoryDeprecation);
      ts3.updateExportSpecifier = ts3.Debug.deprecate(ts3.factory.updateExportSpecifier, factoryDeprecation);
      ts3.createExternalModuleReference = ts3.Debug.deprecate(ts3.factory.createExternalModuleReference, factoryDeprecation);
      ts3.updateExternalModuleReference = ts3.Debug.deprecate(ts3.factory.updateExternalModuleReference, factoryDeprecation);
      ts3.createJSDocTypeExpression = ts3.Debug.deprecate(ts3.factory.createJSDocTypeExpression, factoryDeprecation);
      ts3.createJSDocTypeTag = ts3.Debug.deprecate(ts3.factory.createJSDocTypeTag, factoryDeprecation);
      ts3.createJSDocReturnTag = ts3.Debug.deprecate(ts3.factory.createJSDocReturnTag, factoryDeprecation);
      ts3.createJSDocThisTag = ts3.Debug.deprecate(ts3.factory.createJSDocThisTag, factoryDeprecation);
      ts3.createJSDocComment = ts3.Debug.deprecate(ts3.factory.createJSDocComment, factoryDeprecation);
      ts3.createJSDocParameterTag = ts3.Debug.deprecate(ts3.factory.createJSDocParameterTag, factoryDeprecation);
      ts3.createJSDocClassTag = ts3.Debug.deprecate(ts3.factory.createJSDocClassTag, factoryDeprecation);
      ts3.createJSDocAugmentsTag = ts3.Debug.deprecate(ts3.factory.createJSDocAugmentsTag, factoryDeprecation);
      ts3.createJSDocEnumTag = ts3.Debug.deprecate(ts3.factory.createJSDocEnumTag, factoryDeprecation);
      ts3.createJSDocTemplateTag = ts3.Debug.deprecate(ts3.factory.createJSDocTemplateTag, factoryDeprecation);
      ts3.createJSDocTypedefTag = ts3.Debug.deprecate(ts3.factory.createJSDocTypedefTag, factoryDeprecation);
      ts3.createJSDocCallbackTag = ts3.Debug.deprecate(ts3.factory.createJSDocCallbackTag, factoryDeprecation);
      ts3.createJSDocSignature = ts3.Debug.deprecate(ts3.factory.createJSDocSignature, factoryDeprecation);
      ts3.createJSDocPropertyTag = ts3.Debug.deprecate(ts3.factory.createJSDocPropertyTag, factoryDeprecation);
      ts3.createJSDocTypeLiteral = ts3.Debug.deprecate(ts3.factory.createJSDocTypeLiteral, factoryDeprecation);
      ts3.createJSDocImplementsTag = ts3.Debug.deprecate(ts3.factory.createJSDocImplementsTag, factoryDeprecation);
      ts3.createJSDocAuthorTag = ts3.Debug.deprecate(ts3.factory.createJSDocAuthorTag, factoryDeprecation);
      ts3.createJSDocPublicTag = ts3.Debug.deprecate(ts3.factory.createJSDocPublicTag, factoryDeprecation);
      ts3.createJSDocPrivateTag = ts3.Debug.deprecate(ts3.factory.createJSDocPrivateTag, factoryDeprecation);
      ts3.createJSDocProtectedTag = ts3.Debug.deprecate(ts3.factory.createJSDocProtectedTag, factoryDeprecation);
      ts3.createJSDocReadonlyTag = ts3.Debug.deprecate(ts3.factory.createJSDocReadonlyTag, factoryDeprecation);
      ts3.createJSDocTag = ts3.Debug.deprecate(ts3.factory.createJSDocUnknownTag, factoryDeprecation);
      ts3.createJsxElement = ts3.Debug.deprecate(ts3.factory.createJsxElement, factoryDeprecation);
      ts3.updateJsxElement = ts3.Debug.deprecate(ts3.factory.updateJsxElement, factoryDeprecation);
      ts3.createJsxSelfClosingElement = ts3.Debug.deprecate(ts3.factory.createJsxSelfClosingElement, factoryDeprecation);
      ts3.updateJsxSelfClosingElement = ts3.Debug.deprecate(ts3.factory.updateJsxSelfClosingElement, factoryDeprecation);
      ts3.createJsxOpeningElement = ts3.Debug.deprecate(ts3.factory.createJsxOpeningElement, factoryDeprecation);
      ts3.updateJsxOpeningElement = ts3.Debug.deprecate(ts3.factory.updateJsxOpeningElement, factoryDeprecation);
      ts3.createJsxClosingElement = ts3.Debug.deprecate(ts3.factory.createJsxClosingElement, factoryDeprecation);
      ts3.updateJsxClosingElement = ts3.Debug.deprecate(ts3.factory.updateJsxClosingElement, factoryDeprecation);
      ts3.createJsxFragment = ts3.Debug.deprecate(ts3.factory.createJsxFragment, factoryDeprecation);
      ts3.createJsxText = ts3.Debug.deprecate(ts3.factory.createJsxText, factoryDeprecation);
      ts3.updateJsxText = ts3.Debug.deprecate(ts3.factory.updateJsxText, factoryDeprecation);
      ts3.createJsxOpeningFragment = ts3.Debug.deprecate(ts3.factory.createJsxOpeningFragment, factoryDeprecation);
      ts3.createJsxJsxClosingFragment = ts3.Debug.deprecate(ts3.factory.createJsxJsxClosingFragment, factoryDeprecation);
      ts3.updateJsxFragment = ts3.Debug.deprecate(ts3.factory.updateJsxFragment, factoryDeprecation);
      ts3.createJsxAttribute = ts3.Debug.deprecate(ts3.factory.createJsxAttribute, factoryDeprecation);
      ts3.updateJsxAttribute = ts3.Debug.deprecate(ts3.factory.updateJsxAttribute, factoryDeprecation);
      ts3.createJsxAttributes = ts3.Debug.deprecate(ts3.factory.createJsxAttributes, factoryDeprecation);
      ts3.updateJsxAttributes = ts3.Debug.deprecate(ts3.factory.updateJsxAttributes, factoryDeprecation);
      ts3.createJsxSpreadAttribute = ts3.Debug.deprecate(ts3.factory.createJsxSpreadAttribute, factoryDeprecation);
      ts3.updateJsxSpreadAttribute = ts3.Debug.deprecate(ts3.factory.updateJsxSpreadAttribute, factoryDeprecation);
      ts3.createJsxExpression = ts3.Debug.deprecate(ts3.factory.createJsxExpression, factoryDeprecation);
      ts3.updateJsxExpression = ts3.Debug.deprecate(ts3.factory.updateJsxExpression, factoryDeprecation);
      ts3.createCaseClause = ts3.Debug.deprecate(ts3.factory.createCaseClause, factoryDeprecation);
      ts3.updateCaseClause = ts3.Debug.deprecate(ts3.factory.updateCaseClause, factoryDeprecation);
      ts3.createDefaultClause = ts3.Debug.deprecate(ts3.factory.createDefaultClause, factoryDeprecation);
      ts3.updateDefaultClause = ts3.Debug.deprecate(ts3.factory.updateDefaultClause, factoryDeprecation);
      ts3.createHeritageClause = ts3.Debug.deprecate(ts3.factory.createHeritageClause, factoryDeprecation);
      ts3.updateHeritageClause = ts3.Debug.deprecate(ts3.factory.updateHeritageClause, factoryDeprecation);
      ts3.createCatchClause = ts3.Debug.deprecate(ts3.factory.createCatchClause, factoryDeprecation);
      ts3.updateCatchClause = ts3.Debug.deprecate(ts3.factory.updateCatchClause, factoryDeprecation);
      ts3.createPropertyAssignment = ts3.Debug.deprecate(ts3.factory.createPropertyAssignment, factoryDeprecation);
      ts3.updatePropertyAssignment = ts3.Debug.deprecate(ts3.factory.updatePropertyAssignment, factoryDeprecation);
      ts3.createShorthandPropertyAssignment = ts3.Debug.deprecate(ts3.factory.createShorthandPropertyAssignment, factoryDeprecation);
      ts3.updateShorthandPropertyAssignment = ts3.Debug.deprecate(ts3.factory.updateShorthandPropertyAssignment, factoryDeprecation);
      ts3.createSpreadAssignment = ts3.Debug.deprecate(ts3.factory.createSpreadAssignment, factoryDeprecation);
      ts3.updateSpreadAssignment = ts3.Debug.deprecate(ts3.factory.updateSpreadAssignment, factoryDeprecation);
      ts3.createEnumMember = ts3.Debug.deprecate(ts3.factory.createEnumMember, factoryDeprecation);
      ts3.updateEnumMember = ts3.Debug.deprecate(ts3.factory.updateEnumMember, factoryDeprecation);
      ts3.updateSourceFileNode = ts3.Debug.deprecate(ts3.factory.updateSourceFile, factoryDeprecation);
      ts3.createNotEmittedStatement = ts3.Debug.deprecate(ts3.factory.createNotEmittedStatement, factoryDeprecation);
      ts3.createPartiallyEmittedExpression = ts3.Debug.deprecate(ts3.factory.createPartiallyEmittedExpression, factoryDeprecation);
      ts3.updatePartiallyEmittedExpression = ts3.Debug.deprecate(ts3.factory.updatePartiallyEmittedExpression, factoryDeprecation);
      ts3.createCommaList = ts3.Debug.deprecate(ts3.factory.createCommaListExpression, factoryDeprecation);
      ts3.updateCommaList = ts3.Debug.deprecate(ts3.factory.updateCommaListExpression, factoryDeprecation);
      ts3.createBundle = ts3.Debug.deprecate(ts3.factory.createBundle, factoryDeprecation);
      ts3.updateBundle = ts3.Debug.deprecate(ts3.factory.updateBundle, factoryDeprecation);
      ts3.createImmediatelyInvokedFunctionExpression = ts3.Debug.deprecate(ts3.factory.createImmediatelyInvokedFunctionExpression, factoryDeprecation);
      ts3.createImmediatelyInvokedArrowFunction = ts3.Debug.deprecate(ts3.factory.createImmediatelyInvokedArrowFunction, factoryDeprecation);
      ts3.createVoidZero = ts3.Debug.deprecate(ts3.factory.createVoidZero, factoryDeprecation);
      ts3.createExportDefault = ts3.Debug.deprecate(ts3.factory.createExportDefault, factoryDeprecation);
      ts3.createExternalModuleExport = ts3.Debug.deprecate(ts3.factory.createExternalModuleExport, factoryDeprecation);
      ts3.createNamespaceExport = ts3.Debug.deprecate(ts3.factory.createNamespaceExport, factoryDeprecation);
      ts3.updateNamespaceExport = ts3.Debug.deprecate(ts3.factory.updateNamespaceExport, factoryDeprecation);
      ts3.createToken = ts3.Debug.deprecate(function createToken(kind) {
        return ts3.factory.createToken(kind);
      }, factoryDeprecation);
      ts3.createIdentifier = ts3.Debug.deprecate(function createIdentifier(text) {
        return ts3.factory.createIdentifier(text, void 0, void 0);
      }, factoryDeprecation);
      ts3.createTempVariable = ts3.Debug.deprecate(function createTempVariable(recordTempVariable) {
        return ts3.factory.createTempVariable(recordTempVariable, void 0);
      }, factoryDeprecation);
      ts3.getGeneratedNameForNode = ts3.Debug.deprecate(function getGeneratedNameForNode(node) {
        return ts3.factory.getGeneratedNameForNode(node, void 0);
      }, factoryDeprecation);
      ts3.createOptimisticUniqueName = ts3.Debug.deprecate(function createOptimisticUniqueName(text) {
        return ts3.factory.createUniqueName(text, 16);
      }, factoryDeprecation);
      ts3.createFileLevelUniqueName = ts3.Debug.deprecate(function createFileLevelUniqueName(text) {
        return ts3.factory.createUniqueName(text, 16 | 32);
      }, factoryDeprecation);
      ts3.createIndexSignature = ts3.Debug.deprecate(function createIndexSignature(decorators, modifiers, parameters, type3) {
        return ts3.factory.createIndexSignature(decorators, modifiers, parameters, type3);
      }, factoryDeprecation);
      ts3.createTypePredicateNode = ts3.Debug.deprecate(function createTypePredicateNode(parameterName, type3) {
        return ts3.factory.createTypePredicateNode(void 0, parameterName, type3);
      }, factoryDeprecation);
      ts3.updateTypePredicateNode = ts3.Debug.deprecate(function updateTypePredicateNode(node, parameterName, type3) {
        return ts3.factory.updateTypePredicateNode(node, void 0, parameterName, type3);
      }, factoryDeprecation);
      ts3.createLiteral = ts3.Debug.deprecate(function createLiteral(value) {
        if (typeof value === "number") {
          return ts3.factory.createNumericLiteral(value);
        }
        if (typeof value === "object" && "base10Value" in value) {
          return ts3.factory.createBigIntLiteral(value);
        }
        if (typeof value === "boolean") {
          return value ? ts3.factory.createTrue() : ts3.factory.createFalse();
        }
        if (typeof value === "string") {
          return ts3.factory.createStringLiteral(value, void 0);
        }
        return ts3.factory.createStringLiteralFromNode(value);
      }, { since: "4.0", warnAfter: "4.1", message: "Use `factory.createStringLiteral`, `factory.createStringLiteralFromNode`, `factory.createNumericLiteral`, `factory.createBigIntLiteral`, `factory.createTrue`, `factory.createFalse`, or the factory supplied by your transformation context instead." });
      ts3.createMethodSignature = ts3.Debug.deprecate(function createMethodSignature(typeParameters, parameters, type3, name, questionToken) {
        return ts3.factory.createMethodSignature(void 0, name, questionToken, typeParameters, parameters, type3);
      }, factoryDeprecation);
      ts3.updateMethodSignature = ts3.Debug.deprecate(function updateMethodSignature(node, typeParameters, parameters, type3, name, questionToken) {
        return ts3.factory.updateMethodSignature(node, node.modifiers, name, questionToken, typeParameters, parameters, type3);
      }, factoryDeprecation);
      ts3.createTypeOperatorNode = ts3.Debug.deprecate(function createTypeOperatorNode(operatorOrType, type3) {
        var operator;
        if (type3) {
          operator = operatorOrType;
        } else {
          type3 = operatorOrType;
          operator = 138;
        }
        return ts3.factory.createTypeOperatorNode(operator, type3);
      }, factoryDeprecation);
      ts3.createTaggedTemplate = ts3.Debug.deprecate(function createTaggedTemplate(tag, typeArgumentsOrTemplate, template) {
        var typeArguments;
        if (template) {
          typeArguments = typeArgumentsOrTemplate;
        } else {
          template = typeArgumentsOrTemplate;
        }
        return ts3.factory.createTaggedTemplateExpression(tag, typeArguments, template);
      }, factoryDeprecation);
      ts3.updateTaggedTemplate = ts3.Debug.deprecate(function updateTaggedTemplate(node, tag, typeArgumentsOrTemplate, template) {
        var typeArguments;
        if (template) {
          typeArguments = typeArgumentsOrTemplate;
        } else {
          template = typeArgumentsOrTemplate;
        }
        return ts3.factory.updateTaggedTemplateExpression(node, tag, typeArguments, template);
      }, factoryDeprecation);
      ts3.updateBinary = ts3.Debug.deprecate(function updateBinary(node, left, right, operator) {
        if (operator === void 0) {
          operator = node.operatorToken;
        }
        if (typeof operator === "number") {
          operator = operator === node.operatorToken.kind ? node.operatorToken : ts3.factory.createToken(operator);
        }
        return ts3.factory.updateBinaryExpression(node, left, operator, right);
      }, factoryDeprecation);
      ts3.createConditional = ts3.Debug.deprecate(function createConditional(condition, questionTokenOrWhenTrue, whenTrueOrWhenFalse, colonToken, whenFalse) {
        return arguments.length === 5 ? ts3.factory.createConditionalExpression(condition, questionTokenOrWhenTrue, whenTrueOrWhenFalse, colonToken, whenFalse) : arguments.length === 3 ? ts3.factory.createConditionalExpression(condition, ts3.factory.createToken(57), questionTokenOrWhenTrue, ts3.factory.createToken(58), whenTrueOrWhenFalse) : ts3.Debug.fail("Argument count mismatch");
      }, factoryDeprecation);
      ts3.createYield = ts3.Debug.deprecate(function createYield(asteriskTokenOrExpression, expression) {
        var asteriskToken;
        if (expression) {
          asteriskToken = asteriskTokenOrExpression;
        } else {
          expression = asteriskTokenOrExpression;
        }
        return ts3.factory.createYieldExpression(asteriskToken, expression);
      }, factoryDeprecation);
      ts3.createClassExpression = ts3.Debug.deprecate(function createClassExpression(modifiers, name, typeParameters, heritageClauses, members) {
        return ts3.factory.createClassExpression(void 0, modifiers, name, typeParameters, heritageClauses, members);
      }, factoryDeprecation);
      ts3.updateClassExpression = ts3.Debug.deprecate(function updateClassExpression(node, modifiers, name, typeParameters, heritageClauses, members) {
        return ts3.factory.updateClassExpression(node, void 0, modifiers, name, typeParameters, heritageClauses, members);
      }, factoryDeprecation);
      ts3.createPropertySignature = ts3.Debug.deprecate(function createPropertySignature(modifiers, name, questionToken, type3, initializer) {
        var node = ts3.factory.createPropertySignature(modifiers, name, questionToken, type3);
        node.initializer = initializer;
        return node;
      }, factoryDeprecation);
      ts3.updatePropertySignature = ts3.Debug.deprecate(function updatePropertySignature(node, modifiers, name, questionToken, type3, initializer) {
        var updated = ts3.factory.updatePropertySignature(node, modifiers, name, questionToken, type3);
        if (node.initializer !== initializer) {
          if (updated === node) {
            updated = ts3.factory.cloneNode(node);
          }
          updated.initializer = initializer;
        }
        return updated;
      }, factoryDeprecation);
      ts3.createExpressionWithTypeArguments = ts3.Debug.deprecate(function createExpressionWithTypeArguments(typeArguments, expression) {
        return ts3.factory.createExpressionWithTypeArguments(expression, typeArguments);
      }, factoryDeprecation);
      ts3.updateExpressionWithTypeArguments = ts3.Debug.deprecate(function updateExpressionWithTypeArguments(node, typeArguments, expression) {
        return ts3.factory.updateExpressionWithTypeArguments(node, expression, typeArguments);
      }, factoryDeprecation);
      ts3.createArrowFunction = ts3.Debug.deprecate(function createArrowFunction(modifiers, typeParameters, parameters, type3, equalsGreaterThanTokenOrBody, body) {
        return arguments.length === 6 ? ts3.factory.createArrowFunction(modifiers, typeParameters, parameters, type3, equalsGreaterThanTokenOrBody, body) : arguments.length === 5 ? ts3.factory.createArrowFunction(modifiers, typeParameters, parameters, type3, void 0, equalsGreaterThanTokenOrBody) : ts3.Debug.fail("Argument count mismatch");
      }, factoryDeprecation);
      ts3.updateArrowFunction = ts3.Debug.deprecate(function updateArrowFunction(node, modifiers, typeParameters, parameters, type3, equalsGreaterThanTokenOrBody, body) {
        return arguments.length === 7 ? ts3.factory.updateArrowFunction(node, modifiers, typeParameters, parameters, type3, equalsGreaterThanTokenOrBody, body) : arguments.length === 6 ? ts3.factory.updateArrowFunction(node, modifiers, typeParameters, parameters, type3, node.equalsGreaterThanToken, equalsGreaterThanTokenOrBody) : ts3.Debug.fail("Argument count mismatch");
      }, factoryDeprecation);
      ts3.createVariableDeclaration = ts3.Debug.deprecate(function createVariableDeclaration(name, exclamationTokenOrType, typeOrInitializer, initializer) {
        return arguments.length === 4 ? ts3.factory.createVariableDeclaration(name, exclamationTokenOrType, typeOrInitializer, initializer) : arguments.length >= 1 && arguments.length <= 3 ? ts3.factory.createVariableDeclaration(name, void 0, exclamationTokenOrType, typeOrInitializer) : ts3.Debug.fail("Argument count mismatch");
      }, factoryDeprecation);
      ts3.updateVariableDeclaration = ts3.Debug.deprecate(function updateVariableDeclaration(node, name, exclamationTokenOrType, typeOrInitializer, initializer) {
        return arguments.length === 5 ? ts3.factory.updateVariableDeclaration(node, name, exclamationTokenOrType, typeOrInitializer, initializer) : arguments.length === 4 ? ts3.factory.updateVariableDeclaration(node, name, node.exclamationToken, exclamationTokenOrType, typeOrInitializer) : ts3.Debug.fail("Argument count mismatch");
      }, factoryDeprecation);
      ts3.createImportClause = ts3.Debug.deprecate(function createImportClause(name, namedBindings, isTypeOnly) {
        if (isTypeOnly === void 0) {
          isTypeOnly = false;
        }
        return ts3.factory.createImportClause(isTypeOnly, name, namedBindings);
      }, factoryDeprecation);
      ts3.updateImportClause = ts3.Debug.deprecate(function updateImportClause(node, name, namedBindings, isTypeOnly) {
        return ts3.factory.updateImportClause(node, isTypeOnly, name, namedBindings);
      }, factoryDeprecation);
      ts3.createExportDeclaration = ts3.Debug.deprecate(function createExportDeclaration(decorators, modifiers, exportClause, moduleSpecifier, isTypeOnly) {
        if (isTypeOnly === void 0) {
          isTypeOnly = false;
        }
        return ts3.factory.createExportDeclaration(decorators, modifiers, isTypeOnly, exportClause, moduleSpecifier);
      }, factoryDeprecation);
      ts3.updateExportDeclaration = ts3.Debug.deprecate(function updateExportDeclaration(node, decorators, modifiers, exportClause, moduleSpecifier, isTypeOnly) {
        return ts3.factory.updateExportDeclaration(node, decorators, modifiers, isTypeOnly, exportClause, moduleSpecifier);
      }, factoryDeprecation);
      ts3.createJSDocParamTag = ts3.Debug.deprecate(function createJSDocParamTag(name, isBracketed, typeExpression, comment) {
        return ts3.factory.createJSDocParameterTag(void 0, name, isBracketed, typeExpression, false, comment ? ts3.factory.createNodeArray([ts3.factory.createJSDocText(comment)]) : void 0);
      }, factoryDeprecation);
      ts3.createComma = ts3.Debug.deprecate(function createComma(left, right) {
        return ts3.factory.createComma(left, right);
      }, factoryDeprecation);
      ts3.createLessThan = ts3.Debug.deprecate(function createLessThan(left, right) {
        return ts3.factory.createLessThan(left, right);
      }, factoryDeprecation);
      ts3.createAssignment = ts3.Debug.deprecate(function createAssignment(left, right) {
        return ts3.factory.createAssignment(left, right);
      }, factoryDeprecation);
      ts3.createStrictEquality = ts3.Debug.deprecate(function createStrictEquality(left, right) {
        return ts3.factory.createStrictEquality(left, right);
      }, factoryDeprecation);
      ts3.createStrictInequality = ts3.Debug.deprecate(function createStrictInequality(left, right) {
        return ts3.factory.createStrictInequality(left, right);
      }, factoryDeprecation);
      ts3.createAdd = ts3.Debug.deprecate(function createAdd(left, right) {
        return ts3.factory.createAdd(left, right);
      }, factoryDeprecation);
      ts3.createSubtract = ts3.Debug.deprecate(function createSubtract(left, right) {
        return ts3.factory.createSubtract(left, right);
      }, factoryDeprecation);
      ts3.createLogicalAnd = ts3.Debug.deprecate(function createLogicalAnd(left, right) {
        return ts3.factory.createLogicalAnd(left, right);
      }, factoryDeprecation);
      ts3.createLogicalOr = ts3.Debug.deprecate(function createLogicalOr(left, right) {
        return ts3.factory.createLogicalOr(left, right);
      }, factoryDeprecation);
      ts3.createPostfixIncrement = ts3.Debug.deprecate(function createPostfixIncrement(operand) {
        return ts3.factory.createPostfixIncrement(operand);
      }, factoryDeprecation);
      ts3.createLogicalNot = ts3.Debug.deprecate(function createLogicalNot(operand) {
        return ts3.factory.createLogicalNot(operand);
      }, factoryDeprecation);
      ts3.createNode = ts3.Debug.deprecate(function createNode(kind, pos, end) {
        if (pos === void 0) {
          pos = 0;
        }
        if (end === void 0) {
          end = 0;
        }
        return ts3.setTextRangePosEnd(kind === 298 ? ts3.parseBaseNodeFactory.createBaseSourceFileNode(kind) : kind === 78 ? ts3.parseBaseNodeFactory.createBaseIdentifierNode(kind) : kind === 79 ? ts3.parseBaseNodeFactory.createBasePrivateIdentifierNode(kind) : !ts3.isNodeKind(kind) ? ts3.parseBaseNodeFactory.createBaseTokenNode(kind) : ts3.parseBaseNodeFactory.createBaseNode(kind), pos, end);
      }, { since: "4.0", warnAfter: "4.1", message: "Use an appropriate `factory` method instead." });
      ts3.getMutableClone = ts3.Debug.deprecate(function getMutableClone(node) {
        var clone = ts3.factory.cloneNode(node);
        ts3.setTextRange(clone, node);
        ts3.setParent(clone, node.parent);
        return clone;
      }, { since: "4.0", warnAfter: "4.1", message: "Use an appropriate `factory.update...` method instead, use `setCommentRange` or `setSourceMapRange`, and avoid setting `parent`." });
      ts3.isTypeAssertion = ts3.Debug.deprecate(function isTypeAssertion(node) {
        return node.kind === 207;
      }, {
        since: "4.0",
        warnAfter: "4.1",
        message: "Use `isTypeAssertionExpression` instead."
      });
      ts3.isIdentifierOrPrivateIdentifier = ts3.Debug.deprecate(function isIdentifierOrPrivateIdentifier(node) {
        return ts3.isMemberName(node);
      }, {
        since: "4.2",
        warnAfter: "4.3",
        message: "Use `isMemberName` instead."
      });
    })(ts2 || (ts2 = {}));
  }
});

// node_modules/heap/lib/heap.js
var require_heap = __commonJS({
  "node_modules/heap/lib/heap.js"(exports2, module2) {
    (function() {
      var Heap, defaultCmp, floor, heapify, heappop, heappush, heappushpop, heapreplace, insort, min, nlargest, nsmallest, updateItem, _siftdown, _siftup;
      floor = Math.floor, min = Math.min;
      defaultCmp = function(x, y2) {
        if (x < y2) {
          return -1;
        }
        if (x > y2) {
          return 1;
        }
        return 0;
      };
      insort = function(a2, x, lo, hi, cmp) {
        var mid;
        if (lo == null) {
          lo = 0;
        }
        if (cmp == null) {
          cmp = defaultCmp;
        }
        if (lo < 0) {
          throw new Error("lo must be non-negative");
        }
        if (hi == null) {
          hi = a2.length;
        }
        while (lo < hi) {
          mid = floor((lo + hi) / 2);
          if (cmp(x, a2[mid]) < 0) {
            hi = mid;
          } else {
            lo = mid + 1;
          }
        }
        return [].splice.apply(a2, [lo, lo - lo].concat(x)), x;
      };
      heappush = function(array, item, cmp) {
        if (cmp == null) {
          cmp = defaultCmp;
        }
        array.push(item);
        return _siftdown(array, 0, array.length - 1, cmp);
      };
      heappop = function(array, cmp) {
        var lastelt, returnitem;
        if (cmp == null) {
          cmp = defaultCmp;
        }
        lastelt = array.pop();
        if (array.length) {
          returnitem = array[0];
          array[0] = lastelt;
          _siftup(array, 0, cmp);
        } else {
          returnitem = lastelt;
        }
        return returnitem;
      };
      heapreplace = function(array, item, cmp) {
        var returnitem;
        if (cmp == null) {
          cmp = defaultCmp;
        }
        returnitem = array[0];
        array[0] = item;
        _siftup(array, 0, cmp);
        return returnitem;
      };
      heappushpop = function(array, item, cmp) {
        var _ref;
        if (cmp == null) {
          cmp = defaultCmp;
        }
        if (array.length && cmp(array[0], item) < 0) {
          _ref = [array[0], item], item = _ref[0], array[0] = _ref[1];
          _siftup(array, 0, cmp);
        }
        return item;
      };
      heapify = function(array, cmp) {
        var i3, _i, _j, _len, _ref, _ref1, _results, _results1;
        if (cmp == null) {
          cmp = defaultCmp;
        }
        _ref1 = function() {
          _results1 = [];
          for (var _j2 = 0, _ref2 = floor(array.length / 2); 0 <= _ref2 ? _j2 < _ref2 : _j2 > _ref2; 0 <= _ref2 ? _j2++ : _j2--) {
            _results1.push(_j2);
          }
          return _results1;
        }.apply(this).reverse();
        _results = [];
        for (_i = 0, _len = _ref1.length; _i < _len; _i++) {
          i3 = _ref1[_i];
          _results.push(_siftup(array, i3, cmp));
        }
        return _results;
      };
      updateItem = function(array, item, cmp) {
        var pos;
        if (cmp == null) {
          cmp = defaultCmp;
        }
        pos = array.indexOf(item);
        if (pos === -1) {
          return;
        }
        _siftdown(array, 0, pos, cmp);
        return _siftup(array, pos, cmp);
      };
      nlargest = function(array, n2, cmp) {
        var elem, result2, _i, _len, _ref;
        if (cmp == null) {
          cmp = defaultCmp;
        }
        result2 = array.slice(0, n2);
        if (!result2.length) {
          return result2;
        }
        heapify(result2, cmp);
        _ref = array.slice(n2);
        for (_i = 0, _len = _ref.length; _i < _len; _i++) {
          elem = _ref[_i];
          heappushpop(result2, elem, cmp);
        }
        return result2.sort(cmp).reverse();
      };
      nsmallest = function(array, n2, cmp) {
        var elem, i3, los, result2, _i, _j, _len, _ref, _ref1, _results;
        if (cmp == null) {
          cmp = defaultCmp;
        }
        if (n2 * 10 <= array.length) {
          result2 = array.slice(0, n2).sort(cmp);
          if (!result2.length) {
            return result2;
          }
          los = result2[result2.length - 1];
          _ref = array.slice(n2);
          for (_i = 0, _len = _ref.length; _i < _len; _i++) {
            elem = _ref[_i];
            if (cmp(elem, los) < 0) {
              insort(result2, elem, 0, null, cmp);
              result2.pop();
              los = result2[result2.length - 1];
            }
          }
          return result2;
        }
        heapify(array, cmp);
        _results = [];
        for (i3 = _j = 0, _ref1 = min(n2, array.length); 0 <= _ref1 ? _j < _ref1 : _j > _ref1; i3 = 0 <= _ref1 ? ++_j : --_j) {
          _results.push(heappop(array, cmp));
        }
        return _results;
      };
      _siftdown = function(array, startpos, pos, cmp) {
        var newitem, parent, parentpos;
        if (cmp == null) {
          cmp = defaultCmp;
        }
        newitem = array[pos];
        while (pos > startpos) {
          parentpos = pos - 1 >> 1;
          parent = array[parentpos];
          if (cmp(newitem, parent) < 0) {
            array[pos] = parent;
            pos = parentpos;
            continue;
          }
          break;
        }
        return array[pos] = newitem;
      };
      _siftup = function(array, pos, cmp) {
        var childpos, endpos, newitem, rightpos, startpos;
        if (cmp == null) {
          cmp = defaultCmp;
        }
        endpos = array.length;
        startpos = pos;
        newitem = array[pos];
        childpos = 2 * pos + 1;
        while (childpos < endpos) {
          rightpos = childpos + 1;
          if (rightpos < endpos && !(cmp(array[childpos], array[rightpos]) < 0)) {
            childpos = rightpos;
          }
          array[pos] = array[childpos];
          pos = childpos;
          childpos = 2 * pos + 1;
        }
        array[pos] = newitem;
        return _siftdown(array, startpos, pos, cmp);
      };
      Heap = function() {
        Heap2.push = heappush;
        Heap2.pop = heappop;
        Heap2.replace = heapreplace;
        Heap2.pushpop = heappushpop;
        Heap2.heapify = heapify;
        Heap2.updateItem = updateItem;
        Heap2.nlargest = nlargest;
        Heap2.nsmallest = nsmallest;
        function Heap2(cmp) {
          this.cmp = cmp != null ? cmp : defaultCmp;
          this.nodes = [];
        }
        Heap2.prototype.push = function(x) {
          return heappush(this.nodes, x, this.cmp);
        };
        Heap2.prototype.pop = function() {
          return heappop(this.nodes, this.cmp);
        };
        Heap2.prototype.peek = function() {
          return this.nodes[0];
        };
        Heap2.prototype.contains = function(x) {
          return this.nodes.indexOf(x) !== -1;
        };
        Heap2.prototype.replace = function(x) {
          return heapreplace(this.nodes, x, this.cmp);
        };
        Heap2.prototype.pushpop = function(x) {
          return heappushpop(this.nodes, x, this.cmp);
        };
        Heap2.prototype.heapify = function() {
          return heapify(this.nodes, this.cmp);
        };
        Heap2.prototype.updateItem = function(x) {
          return updateItem(this.nodes, x, this.cmp);
        };
        Heap2.prototype.clear = function() {
          return this.nodes = [];
        };
        Heap2.prototype.empty = function() {
          return this.nodes.length === 0;
        };
        Heap2.prototype.size = function() {
          return this.nodes.length;
        };
        Heap2.prototype.clone = function() {
          var heap;
          heap = new Heap2();
          heap.nodes = this.nodes.slice(0);
          return heap;
        };
        Heap2.prototype.toArray = function() {
          return this.nodes.slice(0);
        };
        Heap2.prototype.insert = Heap2.prototype.push;
        Heap2.prototype.top = Heap2.prototype.peek;
        Heap2.prototype.front = Heap2.prototype.peek;
        Heap2.prototype.has = Heap2.prototype.contains;
        Heap2.prototype.copy = Heap2.prototype.clone;
        return Heap2;
      }();
      (function(root, factory) {
        if (typeof define === "function" && define.amd) {
          return define([], factory);
        } else if (typeof exports2 === "object") {
          return module2.exports = factory();
        } else {
          return root.Heap = factory();
        }
      })(this, function() {
        return Heap;
      });
    }).call(exports2);
  }
});

// node_modules/heap/index.js
var require_heap2 = __commonJS({
  "node_modules/heap/index.js"(exports2, module2) {
    module2.exports = require_heap();
  }
});

// node_modules/difflib/lib/difflib.js
var require_difflib = __commonJS({
  "node_modules/difflib/lib/difflib.js"(exports2) {
    (function() {
      var Differ, Heap, IS_CHARACTER_JUNK, IS_LINE_JUNK, SequenceMatcher, assert2, contextDiff, floor, getCloseMatches, max, min, ndiff, restore, unifiedDiff, _any, _arrayCmp, _calculateRatio, _countLeading, _formatRangeContext, _formatRangeUnified, _has, __indexOf = [].indexOf || function(item) {
        for (var i3 = 0, l2 = this.length; i3 < l2; i3++) {
          if (i3 in this && this[i3] === item)
            return i3;
        }
        return -1;
      };
      floor = Math.floor, max = Math.max, min = Math.min;
      Heap = require_heap2();
      assert2 = require("assert");
      _calculateRatio = function(matches, length) {
        if (length) {
          return 2 * matches / length;
        } else {
          return 1;
        }
      };
      _arrayCmp = function(a2, b2) {
        var i3, la, lb, _i, _ref, _ref1;
        _ref = [a2.length, b2.length], la = _ref[0], lb = _ref[1];
        for (i3 = _i = 0, _ref1 = min(la, lb); 0 <= _ref1 ? _i < _ref1 : _i > _ref1; i3 = 0 <= _ref1 ? ++_i : --_i) {
          if (a2[i3] < b2[i3]) {
            return -1;
          }
          if (a2[i3] > b2[i3]) {
            return 1;
          }
        }
        return la - lb;
      };
      _has = function(obj, key2) {
        return Object.prototype.hasOwnProperty.call(obj, key2);
      };
      _any = function(items) {
        var item, _i, _len;
        for (_i = 0, _len = items.length; _i < _len; _i++) {
          item = items[_i];
          if (item) {
            return true;
          }
        }
        return false;
      };
      SequenceMatcher = function() {
        SequenceMatcher2.name = "SequenceMatcher";
        function SequenceMatcher2(isjunk, a2, b2, autojunk) {
          this.isjunk = isjunk;
          if (a2 == null) {
            a2 = "";
          }
          if (b2 == null) {
            b2 = "";
          }
          this.autojunk = autojunk != null ? autojunk : true;
          this.a = this.b = null;
          this.setSeqs(a2, b2);
        }
        SequenceMatcher2.prototype.setSeqs = function(a2, b2) {
          this.setSeq1(a2);
          return this.setSeq2(b2);
        };
        SequenceMatcher2.prototype.setSeq1 = function(a2) {
          if (a2 === this.a) {
            return;
          }
          this.a = a2;
          return this.matchingBlocks = this.opcodes = null;
        };
        SequenceMatcher2.prototype.setSeq2 = function(b2) {
          if (b2 === this.b) {
            return;
          }
          this.b = b2;
          this.matchingBlocks = this.opcodes = null;
          this.fullbcount = null;
          return this._chainB();
        };
        SequenceMatcher2.prototype._chainB = function() {
          var b2, b2j, elt, i3, idxs, indices, isjunk, junk, n2, ntest, popular, _i, _j, _len, _len1, _ref;
          b2 = this.b;
          this.b2j = b2j = {};
          for (i3 = _i = 0, _len = b2.length; _i < _len; i3 = ++_i) {
            elt = b2[i3];
            indices = _has(b2j, elt) ? b2j[elt] : b2j[elt] = [];
            indices.push(i3);
          }
          junk = {};
          isjunk = this.isjunk;
          if (isjunk) {
            _ref = Object.keys(b2j);
            for (_j = 0, _len1 = _ref.length; _j < _len1; _j++) {
              elt = _ref[_j];
              if (isjunk(elt)) {
                junk[elt] = true;
                delete b2j[elt];
              }
            }
          }
          popular = {};
          n2 = b2.length;
          if (this.autojunk && n2 >= 200) {
            ntest = floor(n2 / 100) + 1;
            for (elt in b2j) {
              idxs = b2j[elt];
              if (idxs.length > ntest) {
                popular[elt] = true;
                delete b2j[elt];
              }
            }
          }
          this.isbjunk = function(b3) {
            return _has(junk, b3);
          };
          return this.isbpopular = function(b3) {
            return _has(popular, b3);
          };
        };
        SequenceMatcher2.prototype.findLongestMatch = function(alo, ahi, blo, bhi) {
          var a2, b2, b2j, besti, bestj, bestsize, i3, isbjunk, j, j2len, k, newj2len, _i, _j, _len, _ref, _ref1, _ref2, _ref3, _ref4, _ref5;
          _ref = [this.a, this.b, this.b2j, this.isbjunk], a2 = _ref[0], b2 = _ref[1], b2j = _ref[2], isbjunk = _ref[3];
          _ref1 = [alo, blo, 0], besti = _ref1[0], bestj = _ref1[1], bestsize = _ref1[2];
          j2len = {};
          for (i3 = _i = alo; alo <= ahi ? _i < ahi : _i > ahi; i3 = alo <= ahi ? ++_i : --_i) {
            newj2len = {};
            _ref2 = _has(b2j, a2[i3]) ? b2j[a2[i3]] : [];
            for (_j = 0, _len = _ref2.length; _j < _len; _j++) {
              j = _ref2[_j];
              if (j < blo) {
                continue;
              }
              if (j >= bhi) {
                break;
              }
              k = newj2len[j] = (j2len[j - 1] || 0) + 1;
              if (k > bestsize) {
                _ref3 = [i3 - k + 1, j - k + 1, k], besti = _ref3[0], bestj = _ref3[1], bestsize = _ref3[2];
              }
            }
            j2len = newj2len;
          }
          while (besti > alo && bestj > blo && !isbjunk(b2[bestj - 1]) && a2[besti - 1] === b2[bestj - 1]) {
            _ref4 = [besti - 1, bestj - 1, bestsize + 1], besti = _ref4[0], bestj = _ref4[1], bestsize = _ref4[2];
          }
          while (besti + bestsize < ahi && bestj + bestsize < bhi && !isbjunk(b2[bestj + bestsize]) && a2[besti + bestsize] === b2[bestj + bestsize]) {
            bestsize++;
          }
          while (besti > alo && bestj > blo && isbjunk(b2[bestj - 1]) && a2[besti - 1] === b2[bestj - 1]) {
            _ref5 = [besti - 1, bestj - 1, bestsize + 1], besti = _ref5[0], bestj = _ref5[1], bestsize = _ref5[2];
          }
          while (besti + bestsize < ahi && bestj + bestsize < bhi && isbjunk(b2[bestj + bestsize]) && a2[besti + bestsize] === b2[bestj + bestsize]) {
            bestsize++;
          }
          return [besti, bestj, bestsize];
        };
        SequenceMatcher2.prototype.getMatchingBlocks = function() {
          var ahi, alo, bhi, blo, i3, i1, i22, j, j1, j2, k, k1, k2, la, lb, matchingBlocks, nonAdjacent, queue, x, _i, _len, _ref, _ref1, _ref2, _ref3, _ref4;
          if (this.matchingBlocks) {
            return this.matchingBlocks;
          }
          _ref = [this.a.length, this.b.length], la = _ref[0], lb = _ref[1];
          queue = [[0, la, 0, lb]];
          matchingBlocks = [];
          while (queue.length) {
            _ref1 = queue.pop(), alo = _ref1[0], ahi = _ref1[1], blo = _ref1[2], bhi = _ref1[3];
            _ref2 = x = this.findLongestMatch(alo, ahi, blo, bhi), i3 = _ref2[0], j = _ref2[1], k = _ref2[2];
            if (k) {
              matchingBlocks.push(x);
              if (alo < i3 && blo < j) {
                queue.push([alo, i3, blo, j]);
              }
              if (i3 + k < ahi && j + k < bhi) {
                queue.push([i3 + k, ahi, j + k, bhi]);
              }
            }
          }
          matchingBlocks.sort(_arrayCmp);
          i1 = j1 = k1 = 0;
          nonAdjacent = [];
          for (_i = 0, _len = matchingBlocks.length; _i < _len; _i++) {
            _ref3 = matchingBlocks[_i], i22 = _ref3[0], j2 = _ref3[1], k2 = _ref3[2];
            if (i1 + k1 === i22 && j1 + k1 === j2) {
              k1 += k2;
            } else {
              if (k1) {
                nonAdjacent.push([i1, j1, k1]);
              }
              _ref4 = [i22, j2, k2], i1 = _ref4[0], j1 = _ref4[1], k1 = _ref4[2];
            }
          }
          if (k1) {
            nonAdjacent.push([i1, j1, k1]);
          }
          nonAdjacent.push([la, lb, 0]);
          return this.matchingBlocks = nonAdjacent;
        };
        SequenceMatcher2.prototype.getOpcodes = function() {
          var ai, answer, bj, i3, j, size, tag, _i, _len, _ref, _ref1, _ref2;
          if (this.opcodes) {
            return this.opcodes;
          }
          i3 = j = 0;
          this.opcodes = answer = [];
          _ref = this.getMatchingBlocks();
          for (_i = 0, _len = _ref.length; _i < _len; _i++) {
            _ref1 = _ref[_i], ai = _ref1[0], bj = _ref1[1], size = _ref1[2];
            tag = "";
            if (i3 < ai && j < bj) {
              tag = "replace";
            } else if (i3 < ai) {
              tag = "delete";
            } else if (j < bj) {
              tag = "insert";
            }
            if (tag) {
              answer.push([tag, i3, ai, j, bj]);
            }
            _ref2 = [ai + size, bj + size], i3 = _ref2[0], j = _ref2[1];
            if (size) {
              answer.push(["equal", ai, i3, bj, j]);
            }
          }
          return answer;
        };
        SequenceMatcher2.prototype.getGroupedOpcodes = function(n2) {
          var codes, group, groups, i1, i22, j1, j2, nn, tag, _i, _len, _ref, _ref1, _ref2, _ref3;
          if (n2 == null) {
            n2 = 3;
          }
          codes = this.getOpcodes();
          if (!codes.length) {
            codes = [["equal", 0, 1, 0, 1]];
          }
          if (codes[0][0] === "equal") {
            _ref = codes[0], tag = _ref[0], i1 = _ref[1], i22 = _ref[2], j1 = _ref[3], j2 = _ref[4];
            codes[0] = [tag, max(i1, i22 - n2), i22, max(j1, j2 - n2), j2];
          }
          if (codes[codes.length - 1][0] === "equal") {
            _ref1 = codes[codes.length - 1], tag = _ref1[0], i1 = _ref1[1], i22 = _ref1[2], j1 = _ref1[3], j2 = _ref1[4];
            codes[codes.length - 1] = [tag, i1, min(i22, i1 + n2), j1, min(j2, j1 + n2)];
          }
          nn = n2 + n2;
          groups = [];
          group = [];
          for (_i = 0, _len = codes.length; _i < _len; _i++) {
            _ref2 = codes[_i], tag = _ref2[0], i1 = _ref2[1], i22 = _ref2[2], j1 = _ref2[3], j2 = _ref2[4];
            if (tag === "equal" && i22 - i1 > nn) {
              group.push([tag, i1, min(i22, i1 + n2), j1, min(j2, j1 + n2)]);
              groups.push(group);
              group = [];
              _ref3 = [max(i1, i22 - n2), max(j1, j2 - n2)], i1 = _ref3[0], j1 = _ref3[1];
            }
            group.push([tag, i1, i22, j1, j2]);
          }
          if (group.length && !(group.length === 1 && group[0][0] === "equal")) {
            groups.push(group);
          }
          return groups;
        };
        SequenceMatcher2.prototype.ratio = function() {
          var match, matches, _i, _len, _ref;
          matches = 0;
          _ref = this.getMatchingBlocks();
          for (_i = 0, _len = _ref.length; _i < _len; _i++) {
            match = _ref[_i];
            matches += match[2];
          }
          return _calculateRatio(matches, this.a.length + this.b.length);
        };
        SequenceMatcher2.prototype.quickRatio = function() {
          var avail, elt, fullbcount, matches, numb, _i, _j, _len, _len1, _ref, _ref1;
          if (!this.fullbcount) {
            this.fullbcount = fullbcount = {};
            _ref = this.b;
            for (_i = 0, _len = _ref.length; _i < _len; _i++) {
              elt = _ref[_i];
              fullbcount[elt] = (fullbcount[elt] || 0) + 1;
            }
          }
          fullbcount = this.fullbcount;
          avail = {};
          matches = 0;
          _ref1 = this.a;
          for (_j = 0, _len1 = _ref1.length; _j < _len1; _j++) {
            elt = _ref1[_j];
            if (_has(avail, elt)) {
              numb = avail[elt];
            } else {
              numb = fullbcount[elt] || 0;
            }
            avail[elt] = numb - 1;
            if (numb > 0) {
              matches++;
            }
          }
          return _calculateRatio(matches, this.a.length + this.b.length);
        };
        SequenceMatcher2.prototype.realQuickRatio = function() {
          var la, lb, _ref;
          _ref = [this.a.length, this.b.length], la = _ref[0], lb = _ref[1];
          return _calculateRatio(min(la, lb), la + lb);
        };
        return SequenceMatcher2;
      }();
      getCloseMatches = function(word, possibilities, n2, cutoff) {
        var result2, s2, score, x, _i, _j, _len, _len1, _ref, _results;
        if (n2 == null) {
          n2 = 3;
        }
        if (cutoff == null) {
          cutoff = 0.6;
        }
        if (!(n2 > 0)) {
          throw new Error("n must be > 0: (" + n2 + ")");
        }
        if (!(0 <= cutoff && cutoff <= 1)) {
          throw new Error("cutoff must be in [0.0, 1.0]: (" + cutoff + ")");
        }
        result2 = [];
        s2 = new SequenceMatcher();
        s2.setSeq2(word);
        for (_i = 0, _len = possibilities.length; _i < _len; _i++) {
          x = possibilities[_i];
          s2.setSeq1(x);
          if (s2.realQuickRatio() >= cutoff && s2.quickRatio() >= cutoff && s2.ratio() >= cutoff) {
            result2.push([s2.ratio(), x]);
          }
        }
        result2 = Heap.nlargest(result2, n2, _arrayCmp);
        _results = [];
        for (_j = 0, _len1 = result2.length; _j < _len1; _j++) {
          _ref = result2[_j], score = _ref[0], x = _ref[1];
          _results.push(x);
        }
        return _results;
      };
      _countLeading = function(line, ch) {
        var i3, n2, _ref;
        _ref = [0, line.length], i3 = _ref[0], n2 = _ref[1];
        while (i3 < n2 && line[i3] === ch) {
          i3++;
        }
        return i3;
      };
      Differ = function() {
        Differ2.name = "Differ";
        function Differ2(linejunk, charjunk) {
          this.linejunk = linejunk;
          this.charjunk = charjunk;
        }
        Differ2.prototype.compare = function(a2, b2) {
          var ahi, alo, bhi, blo, cruncher, g2, line, lines, tag, _i, _j, _len, _len1, _ref, _ref1;
          cruncher = new SequenceMatcher(this.linejunk, a2, b2);
          lines = [];
          _ref = cruncher.getOpcodes();
          for (_i = 0, _len = _ref.length; _i < _len; _i++) {
            _ref1 = _ref[_i], tag = _ref1[0], alo = _ref1[1], ahi = _ref1[2], blo = _ref1[3], bhi = _ref1[4];
            switch (tag) {
              case "replace":
                g2 = this._fancyReplace(a2, alo, ahi, b2, blo, bhi);
                break;
              case "delete":
                g2 = this._dump("-", a2, alo, ahi);
                break;
              case "insert":
                g2 = this._dump("+", b2, blo, bhi);
                break;
              case "equal":
                g2 = this._dump(" ", a2, alo, ahi);
                break;
              default:
                throw new Error("unknow tag (" + tag + ")");
            }
            for (_j = 0, _len1 = g2.length; _j < _len1; _j++) {
              line = g2[_j];
              lines.push(line);
            }
          }
          return lines;
        };
        Differ2.prototype._dump = function(tag, x, lo, hi) {
          var i3, _i, _results;
          _results = [];
          for (i3 = _i = lo; lo <= hi ? _i < hi : _i > hi; i3 = lo <= hi ? ++_i : --_i) {
            _results.push("" + tag + " " + x[i3]);
          }
          return _results;
        };
        Differ2.prototype._plainReplace = function(a2, alo, ahi, b2, blo, bhi) {
          var first, g2, line, lines, second, _i, _j, _len, _len1, _ref;
          assert2(alo < ahi && blo < bhi);
          if (bhi - blo < ahi - alo) {
            first = this._dump("+", b2, blo, bhi);
            second = this._dump("-", a2, alo, ahi);
          } else {
            first = this._dump("-", a2, alo, ahi);
            second = this._dump("+", b2, blo, bhi);
          }
          lines = [];
          _ref = [first, second];
          for (_i = 0, _len = _ref.length; _i < _len; _i++) {
            g2 = _ref[_i];
            for (_j = 0, _len1 = g2.length; _j < _len1; _j++) {
              line = g2[_j];
              lines.push(line);
            }
          }
          return lines;
        };
        Differ2.prototype._fancyReplace = function(a2, alo, ahi, b2, blo, bhi) {
          var aelt, ai, ai1, ai2, atags, belt, bestRatio, besti, bestj, bj, bj1, bj2, btags, cruncher, cutoff, eqi, eqj, i3, j, la, lb, line, lines, tag, _i, _j, _k, _l, _len, _len1, _len2, _len3, _len4, _m, _n, _o, _ref, _ref1, _ref10, _ref11, _ref12, _ref2, _ref3, _ref4, _ref5, _ref6, _ref7, _ref8, _ref9;
          _ref = [0.74, 0.75], bestRatio = _ref[0], cutoff = _ref[1];
          cruncher = new SequenceMatcher(this.charjunk);
          _ref1 = [null, null], eqi = _ref1[0], eqj = _ref1[1];
          lines = [];
          for (j = _i = blo; blo <= bhi ? _i < bhi : _i > bhi; j = blo <= bhi ? ++_i : --_i) {
            bj = b2[j];
            cruncher.setSeq2(bj);
            for (i3 = _j = alo; alo <= ahi ? _j < ahi : _j > ahi; i3 = alo <= ahi ? ++_j : --_j) {
              ai = a2[i3];
              if (ai === bj) {
                if (eqi === null) {
                  _ref2 = [i3, j], eqi = _ref2[0], eqj = _ref2[1];
                }
                continue;
              }
              cruncher.setSeq1(ai);
              if (cruncher.realQuickRatio() > bestRatio && cruncher.quickRatio() > bestRatio && cruncher.ratio() > bestRatio) {
                _ref3 = [cruncher.ratio(), i3, j], bestRatio = _ref3[0], besti = _ref3[1], bestj = _ref3[2];
              }
            }
          }
          if (bestRatio < cutoff) {
            if (eqi === null) {
              _ref4 = this._plainReplace(a2, alo, ahi, b2, blo, bhi);
              for (_k = 0, _len = _ref4.length; _k < _len; _k++) {
                line = _ref4[_k];
                lines.push(line);
              }
              return lines;
            }
            _ref5 = [eqi, eqj, 1], besti = _ref5[0], bestj = _ref5[1], bestRatio = _ref5[2];
          } else {
            eqi = null;
          }
          _ref6 = this._fancyHelper(a2, alo, besti, b2, blo, bestj);
          for (_l = 0, _len1 = _ref6.length; _l < _len1; _l++) {
            line = _ref6[_l];
            lines.push(line);
          }
          _ref7 = [a2[besti], b2[bestj]], aelt = _ref7[0], belt = _ref7[1];
          if (eqi === null) {
            atags = btags = "";
            cruncher.setSeqs(aelt, belt);
            _ref8 = cruncher.getOpcodes();
            for (_m = 0, _len2 = _ref8.length; _m < _len2; _m++) {
              _ref9 = _ref8[_m], tag = _ref9[0], ai1 = _ref9[1], ai2 = _ref9[2], bj1 = _ref9[3], bj2 = _ref9[4];
              _ref10 = [ai2 - ai1, bj2 - bj1], la = _ref10[0], lb = _ref10[1];
              switch (tag) {
                case "replace":
                  atags += Array(la + 1).join("^");
                  btags += Array(lb + 1).join("^");
                  break;
                case "delete":
                  atags += Array(la + 1).join("-");
                  break;
                case "insert":
                  btags += Array(lb + 1).join("+");
                  break;
                case "equal":
                  atags += Array(la + 1).join(" ");
                  btags += Array(lb + 1).join(" ");
                  break;
                default:
                  throw new Error("unknow tag (" + tag + ")");
              }
            }
            _ref11 = this._qformat(aelt, belt, atags, btags);
            for (_n = 0, _len3 = _ref11.length; _n < _len3; _n++) {
              line = _ref11[_n];
              lines.push(line);
            }
          } else {
            lines.push("  " + aelt);
          }
          _ref12 = this._fancyHelper(a2, besti + 1, ahi, b2, bestj + 1, bhi);
          for (_o = 0, _len4 = _ref12.length; _o < _len4; _o++) {
            line = _ref12[_o];
            lines.push(line);
          }
          return lines;
        };
        Differ2.prototype._fancyHelper = function(a2, alo, ahi, b2, blo, bhi) {
          var g2;
          g2 = [];
          if (alo < ahi) {
            if (blo < bhi) {
              g2 = this._fancyReplace(a2, alo, ahi, b2, blo, bhi);
            } else {
              g2 = this._dump("-", a2, alo, ahi);
            }
          } else if (blo < bhi) {
            g2 = this._dump("+", b2, blo, bhi);
          }
          return g2;
        };
        Differ2.prototype._qformat = function(aline, bline, atags, btags) {
          var common2, lines;
          lines = [];
          common2 = min(_countLeading(aline, "	"), _countLeading(bline, "	"));
          common2 = min(common2, _countLeading(atags.slice(0, common2), " "));
          common2 = min(common2, _countLeading(btags.slice(0, common2), " "));
          atags = atags.slice(common2).replace(/\s+$/, "");
          btags = btags.slice(common2).replace(/\s+$/, "");
          lines.push("- " + aline);
          if (atags.length) {
            lines.push("? " + Array(common2 + 1).join("	") + atags + "\n");
          }
          lines.push("+ " + bline);
          if (btags.length) {
            lines.push("? " + Array(common2 + 1).join("	") + btags + "\n");
          }
          return lines;
        };
        return Differ2;
      }();
      IS_LINE_JUNK = function(line, pat) {
        if (pat == null) {
          pat = /^\s*#?\s*$/;
        }
        return pat.test(line);
      };
      IS_CHARACTER_JUNK = function(ch, ws) {
        if (ws == null) {
          ws = " 	";
        }
        return __indexOf.call(ws, ch) >= 0;
      };
      _formatRangeUnified = function(start, stop) {
        var beginning, length;
        beginning = start + 1;
        length = stop - start;
        if (length === 1) {
          return "" + beginning;
        }
        if (!length) {
          beginning--;
        }
        return "" + beginning + "," + length;
      };
      unifiedDiff = function(a2, b2, _arg) {
        var file1Range, file2Range, first, fromdate, fromfile, fromfiledate, group, i1, i22, j1, j2, last, line, lines, lineterm, n2, started, tag, todate, tofile, tofiledate, _i, _j, _k, _l, _len, _len1, _len2, _len3, _len4, _m, _ref, _ref1, _ref2, _ref3, _ref4, _ref5, _ref6;
        _ref = _arg != null ? _arg : {}, fromfile = _ref.fromfile, tofile = _ref.tofile, fromfiledate = _ref.fromfiledate, tofiledate = _ref.tofiledate, n2 = _ref.n, lineterm = _ref.lineterm;
        if (fromfile == null) {
          fromfile = "";
        }
        if (tofile == null) {
          tofile = "";
        }
        if (fromfiledate == null) {
          fromfiledate = "";
        }
        if (tofiledate == null) {
          tofiledate = "";
        }
        if (n2 == null) {
          n2 = 3;
        }
        if (lineterm == null) {
          lineterm = "\n";
        }
        lines = [];
        started = false;
        _ref1 = new SequenceMatcher(null, a2, b2).getGroupedOpcodes();
        for (_i = 0, _len = _ref1.length; _i < _len; _i++) {
          group = _ref1[_i];
          if (!started) {
            started = true;
            fromdate = fromfiledate ? "	" + fromfiledate : "";
            todate = tofiledate ? "	" + tofiledate : "";
            lines.push("--- " + fromfile + fromdate + lineterm);
            lines.push("+++ " + tofile + todate + lineterm);
          }
          _ref2 = [group[0], group[group.length - 1]], first = _ref2[0], last = _ref2[1];
          file1Range = _formatRangeUnified(first[1], last[2]);
          file2Range = _formatRangeUnified(first[3], last[4]);
          lines.push("@@ -" + file1Range + " +" + file2Range + " @@" + lineterm);
          for (_j = 0, _len1 = group.length; _j < _len1; _j++) {
            _ref3 = group[_j], tag = _ref3[0], i1 = _ref3[1], i22 = _ref3[2], j1 = _ref3[3], j2 = _ref3[4];
            if (tag === "equal") {
              _ref4 = a2.slice(i1, i22);
              for (_k = 0, _len2 = _ref4.length; _k < _len2; _k++) {
                line = _ref4[_k];
                lines.push(" " + line);
              }
              continue;
            }
            if (tag === "replace" || tag === "delete") {
              _ref5 = a2.slice(i1, i22);
              for (_l = 0, _len3 = _ref5.length; _l < _len3; _l++) {
                line = _ref5[_l];
                lines.push("-" + line);
              }
            }
            if (tag === "replace" || tag === "insert") {
              _ref6 = b2.slice(j1, j2);
              for (_m = 0, _len4 = _ref6.length; _m < _len4; _m++) {
                line = _ref6[_m];
                lines.push("+" + line);
              }
            }
          }
        }
        return lines;
      };
      _formatRangeContext = function(start, stop) {
        var beginning, length;
        beginning = start + 1;
        length = stop - start;
        if (!length) {
          beginning--;
        }
        if (length <= 1) {
          return "" + beginning;
        }
        return "" + beginning + "," + (beginning + length - 1);
      };
      contextDiff = function(a2, b2, _arg) {
        var file1Range, file2Range, first, fromdate, fromfile, fromfiledate, group, i1, i22, j1, j2, last, line, lines, lineterm, n2, prefix2, started, tag, todate, tofile, tofiledate, _, _i, _j, _k, _l, _len, _len1, _len2, _len3, _len4, _m, _ref, _ref1, _ref2, _ref3, _ref4, _ref5, _ref6;
        _ref = _arg != null ? _arg : {}, fromfile = _ref.fromfile, tofile = _ref.tofile, fromfiledate = _ref.fromfiledate, tofiledate = _ref.tofiledate, n2 = _ref.n, lineterm = _ref.lineterm;
        if (fromfile == null) {
          fromfile = "";
        }
        if (tofile == null) {
          tofile = "";
        }
        if (fromfiledate == null) {
          fromfiledate = "";
        }
        if (tofiledate == null) {
          tofiledate = "";
        }
        if (n2 == null) {
          n2 = 3;
        }
        if (lineterm == null) {
          lineterm = "\n";
        }
        prefix2 = {
          insert: "+ ",
          "delete": "- ",
          replace: "! ",
          equal: "  "
        };
        started = false;
        lines = [];
        _ref1 = new SequenceMatcher(null, a2, b2).getGroupedOpcodes();
        for (_i = 0, _len = _ref1.length; _i < _len; _i++) {
          group = _ref1[_i];
          if (!started) {
            started = true;
            fromdate = fromfiledate ? "	" + fromfiledate : "";
            todate = tofiledate ? "	" + tofiledate : "";
            lines.push("*** " + fromfile + fromdate + lineterm);
            lines.push("--- " + tofile + todate + lineterm);
            _ref2 = [group[0], group[group.length - 1]], first = _ref2[0], last = _ref2[1];
            lines.push("***************" + lineterm);
            file1Range = _formatRangeContext(first[1], last[2]);
            lines.push("*** " + file1Range + " ****" + lineterm);
            if (_any(function() {
              var _j2, _len12, _ref32, _results;
              _results = [];
              for (_j2 = 0, _len12 = group.length; _j2 < _len12; _j2++) {
                _ref32 = group[_j2], tag = _ref32[0], _ = _ref32[1], _ = _ref32[2], _ = _ref32[3], _ = _ref32[4];
                _results.push(tag === "replace" || tag === "delete");
              }
              return _results;
            }())) {
              for (_j = 0, _len1 = group.length; _j < _len1; _j++) {
                _ref3 = group[_j], tag = _ref3[0], i1 = _ref3[1], i22 = _ref3[2], _ = _ref3[3], _ = _ref3[4];
                if (tag !== "insert") {
                  _ref4 = a2.slice(i1, i22);
                  for (_k = 0, _len2 = _ref4.length; _k < _len2; _k++) {
                    line = _ref4[_k];
                    lines.push(prefix2[tag] + line);
                  }
                }
              }
            }
            file2Range = _formatRangeContext(first[3], last[4]);
            lines.push("--- " + file2Range + " ----" + lineterm);
            if (_any(function() {
              var _l2, _len32, _ref52, _results;
              _results = [];
              for (_l2 = 0, _len32 = group.length; _l2 < _len32; _l2++) {
                _ref52 = group[_l2], tag = _ref52[0], _ = _ref52[1], _ = _ref52[2], _ = _ref52[3], _ = _ref52[4];
                _results.push(tag === "replace" || tag === "insert");
              }
              return _results;
            }())) {
              for (_l = 0, _len3 = group.length; _l < _len3; _l++) {
                _ref5 = group[_l], tag = _ref5[0], _ = _ref5[1], _ = _ref5[2], j1 = _ref5[3], j2 = _ref5[4];
                if (tag !== "delete") {
                  _ref6 = b2.slice(j1, j2);
                  for (_m = 0, _len4 = _ref6.length; _m < _len4; _m++) {
                    line = _ref6[_m];
                    lines.push(prefix2[tag] + line);
                  }
                }
              }
            }
          }
        }
        return lines;
      };
      ndiff = function(a2, b2, linejunk, charjunk) {
        if (charjunk == null) {
          charjunk = IS_CHARACTER_JUNK;
        }
        return new Differ(linejunk, charjunk).compare(a2, b2);
      };
      restore = function(delta, which) {
        var line, lines, prefixes, tag, _i, _len, _ref;
        tag = {
          1: "- ",
          2: "+ "
        }[which];
        if (!tag) {
          throw new Error("unknow delta choice (must be 1 or 2): " + which);
        }
        prefixes = ["  ", tag];
        lines = [];
        for (_i = 0, _len = delta.length; _i < _len; _i++) {
          line = delta[_i];
          if (_ref = line.slice(0, 2), __indexOf.call(prefixes, _ref) >= 0) {
            lines.push(line.slice(2));
          }
        }
        return lines;
      };
      exports2._arrayCmp = _arrayCmp;
      exports2.SequenceMatcher = SequenceMatcher;
      exports2.getCloseMatches = getCloseMatches;
      exports2._countLeading = _countLeading;
      exports2.Differ = Differ;
      exports2.IS_LINE_JUNK = IS_LINE_JUNK;
      exports2.IS_CHARACTER_JUNK = IS_CHARACTER_JUNK;
      exports2._formatRangeUnified = _formatRangeUnified;
      exports2.unifiedDiff = unifiedDiff;
      exports2._formatRangeContext = _formatRangeContext;
      exports2.contextDiff = contextDiff;
      exports2.ndiff = ndiff;
      exports2.restore = restore;
    }).call(exports2);
  }
});

// node_modules/difflib/index.js
var require_difflib2 = __commonJS({
  "node_modules/difflib/index.js"(exports2, module2) {
    module2.exports = require_difflib();
  }
});

// node_modules/json-diff/lib/util.js
var require_util3 = __commonJS({
  "node_modules/json-diff/lib/util.js"(exports2, module2) {
    (function() {
      var extendedTypeOf;
      extendedTypeOf = function(obj) {
        var result2;
        result2 = typeof obj;
        if (obj == null) {
          return "null";
        } else if (result2 === "object" && obj.constructor === Array) {
          return "array";
        } else {
          return result2;
        }
      };
      module2.exports = {
        extendedTypeOf
      };
    }).call(exports2);
  }
});

// node_modules/es5-ext/lib/Object/is-callable.js
var require_is_callable = __commonJS({
  "node_modules/es5-ext/lib/Object/is-callable.js"(exports2, module2) {
    "use strict";
    var forEach = Array.prototype.forEach.bind([]);
    module2.exports = function(obj) {
      var type3;
      if (!obj) {
        return false;
      }
      type3 = typeof obj;
      if (type3 === "function") {
        return true;
      }
      if (type3 !== "object") {
        return false;
      }
      try {
        forEach(obj);
        return true;
      } catch (e2) {
        if (e2 instanceof TypeError) {
          return false;
        }
        throw e2;
      }
    };
  }
});

// node_modules/es5-ext/lib/Object/valid-callable.js
var require_valid_callable = __commonJS({
  "node_modules/es5-ext/lib/Object/valid-callable.js"(exports2, module2) {
    "use strict";
    var isCallable = require_is_callable();
    module2.exports = function(fn) {
      if (!isCallable(fn)) {
        throw new TypeError(fn + " is not a function");
      }
      return fn;
    };
  }
});

// node_modules/es5-ext/lib/Object/valid-value.js
var require_valid_value = __commonJS({
  "node_modules/es5-ext/lib/Object/valid-value.js"(exports2, module2) {
    "use strict";
    module2.exports = function(value) {
      if (value == null) {
        throw new TypeError("Cannot use null or undefined");
      }
      return value;
    };
  }
});

// node_modules/es5-ext/lib/Object/_iterate.js
var require_iterate = __commonJS({
  "node_modules/es5-ext/lib/Object/_iterate.js"(exports2, module2) {
    "use strict";
    var call = Function.prototype.call;
    var keys = Object.keys;
    var isCallable = require_is_callable();
    var callable = require_valid_callable();
    var value = require_valid_value();
    module2.exports = function(method) {
      return function(obj, cb2) {
        var list, thisArg = arguments[2], compareFn = arguments[3];
        value(obj);
        callable(cb2);
        list = keys(obj);
        if (compareFn) {
          list.sort(isCallable(compareFn) ? compareFn : void 0);
        }
        return list[method](function(key2, index) {
          return call.call(cb2, thisArg, obj[key2], key2, obj, index);
        });
      };
    };
  }
});

// node_modules/es5-ext/lib/Object/for-each.js
var require_for_each = __commonJS({
  "node_modules/es5-ext/lib/Object/for-each.js"(exports2, module2) {
    "use strict";
    module2.exports = require_iterate()("forEach");
  }
});

// node_modules/es5-ext/lib/Object/map.js
var require_map = __commonJS({
  "node_modules/es5-ext/lib/Object/map.js"(exports2, module2) {
    "use strict";
    var forEach = require_for_each();
    module2.exports = function(obj, cb2) {
      var o2 = {};
      forEach(obj, function(value, key2) {
        o2[key2] = cb2.call(this, value, key2, obj);
      }, arguments[2]);
      return o2;
    };
  }
});

// node_modules/cli-color/lib/index.js
var require_lib3 = __commonJS({
  "node_modules/cli-color/lib/index.js"(exports2, module2) {
    "use strict";
    var defineProperties = Object.defineProperties;
    var map2 = require_map();
    var toString2;
    var codes;
    var properties;
    var init;
    toString2 = function(code, str2) {
      return "[" + code[0] + "m" + (str2 || "") + "[" + code[1] + "m";
    };
    codes = {
      bold: [1, 22],
      italic: [3, 23],
      underline: [4, 24],
      inverse: [7, 27],
      strike: [9, 29]
    };
    ["black", "red", "green", "yellow", "blue", "magenta", "cyan", "white"].forEach(function(color, index) {
      codes[color] = [30 + index, 39];
      codes["bg" + color[0].toUpperCase() + color.slice(1)] = [40 + index, 49];
    });
    codes.gray = [90, 39];
    properties = map2(codes, function(code) {
      return {
        get: function() {
          this.style.push(code);
          return this;
        },
        enumerable: true
      };
    });
    properties.bright = {
      get: function() {
        this._bright = true;
        return this;
      },
      enumerable: true
    };
    properties.bgBright = {
      get: function() {
        this._bgBright = true;
        return this;
      },
      enumerable: true
    };
    init = function() {
      var o2 = defineProperties(function self2(msg) {
        return self2.style.reduce(function(msg2, code) {
          if (self2._bright && code[0] >= 30 && code[0] < 38 || self2._bgBright && code[0] >= 40 && code[0] < 48) {
            code = [code[0] + 60, code[1]];
          }
          return toString2(code, msg2);
        }, msg);
      }, properties);
      o2.style = [];
      return o2[this];
    };
    module2.exports = defineProperties(function(msg) {
      return msg;
    }, map2(properties, function(code, name) {
      return {
        get: init.bind(name),
        enumerable: true
      };
    }));
  }
});

// node_modules/json-diff/lib/colorize.js
var require_colorize2 = __commonJS({
  "node_modules/json-diff/lib/colorize.js"(exports2, module2) {
    (function() {
      var Theme, color, colorize, colorizeToArray, colorizeToCallback, extendedTypeOf, subcolorizeToCallback, hasProp = {}.hasOwnProperty;
      color = require_lib3();
      extendedTypeOf = require_util3().extendedTypeOf;
      Theme = {
        " ": function(s2) {
          return s2;
        },
        "+": color.green,
        "-": color.red
      };
      subcolorizeToCallback = function(key2, diff2, output, color2, indent) {
        var i3, item, j, k, len, len1, len2, looksLikeDiff, m, op, prefix2, ref2, ref1, subindent, subkey, subvalue;
        prefix2 = key2 ? key2 + ": " : "";
        subindent = indent + "  ";
        switch (extendedTypeOf(diff2)) {
          case "object":
            if ("__old" in diff2 && "__new" in diff2 && Object.keys(diff2).length === 2) {
              subcolorizeToCallback(key2, diff2.__old, output, "-", indent);
              return subcolorizeToCallback(key2, diff2.__new, output, "+", indent);
            } else {
              output(color2, "" + indent + prefix2 + "{");
              for (subkey in diff2) {
                if (!hasProp.call(diff2, subkey))
                  continue;
                subvalue = diff2[subkey];
                if (m = subkey.match(/^(.*)__deleted$/)) {
                  subcolorizeToCallback(m[1], subvalue, output, "-", subindent);
                } else if (m = subkey.match(/^(.*)__added$/)) {
                  subcolorizeToCallback(m[1], subvalue, output, "+", subindent);
                } else {
                  subcolorizeToCallback(subkey, subvalue, output, color2, subindent);
                }
              }
              return output(color2, indent + "}");
            }
            break;
          case "array":
            output(color2, "" + indent + prefix2 + "[");
            looksLikeDiff = true;
            for (i3 = 0, len = diff2.length; i3 < len; i3++) {
              item = diff2[i3];
              if (extendedTypeOf(item) !== "array" || !(item.length === 2 || item.length === 1 && item[0] === " ") || !(typeof item[0] === "string") || item[0].length !== 1 || !((ref2 = item[0]) === " " || ref2 === "-" || ref2 === "+" || ref2 === "~")) {
                looksLikeDiff = false;
              }
            }
            if (looksLikeDiff) {
              for (j = 0, len1 = diff2.length; j < len1; j++) {
                ref1 = diff2[j], op = ref1[0], subvalue = ref1[1];
                if (op === " " && subvalue == null) {
                  output(" ", subindent + "...");
                } else {
                  if (op !== " " && op !== "~" && op !== "+" && op !== "-") {
                    throw new Error("Unexpected op '" + op + "' in " + JSON.stringify(diff2, null, 2));
                  }
                  if (op === "~") {
                    op = " ";
                  }
                  subcolorizeToCallback("", subvalue, output, op, subindent);
                }
              }
            } else {
              for (k = 0, len2 = diff2.length; k < len2; k++) {
                subvalue = diff2[k];
                subcolorizeToCallback("", subvalue, output, color2, subindent);
              }
            }
            return output(color2, indent + "]");
          default:
            if (diff2 === 0 || diff2 === null || diff2 === false || diff2) {
              return output(color2, indent + prefix2 + JSON.stringify(diff2));
            }
        }
      };
      colorizeToCallback = function(diff2, output) {
        return subcolorizeToCallback("", diff2, output, " ", "");
      };
      colorizeToArray = function(diff2) {
        var output;
        output = [];
        colorizeToCallback(diff2, function(color2, line) {
          return output.push("" + color2 + line);
        });
        return output;
      };
      colorize = function(diff2, options) {
        var output;
        if (options == null) {
          options = {};
        }
        output = [];
        colorizeToCallback(diff2, function(color2, line) {
          var ref2, ref1, ref22;
          if ((ref2 = options.color) != null ? ref2 : true) {
            return output.push(((ref1 = (ref22 = options.theme) != null ? ref22[color2] : void 0) != null ? ref1 : Theme[color2])("" + color2 + line) + "\n");
          } else {
            return output.push("" + color2 + line + "\n");
          }
        });
        return output.join("");
      };
      module2.exports = {
        colorize,
        colorizeToArray,
        colorizeToCallback
      };
    }).call(exports2);
  }
});

// node_modules/json-diff/lib/index.js
var require_lib4 = __commonJS({
  "node_modules/json-diff/lib/index.js"(exports2, module2) {
    (function() {
      var SequenceMatcher, arrayDiff, colorize, descalarize, diff2, diffScore, diffString, diffWithScore, extendedTypeOf, findMatchingObject, isScalar, isScalarized, objectDiff, scalarize, hasProp = {}.hasOwnProperty;
      SequenceMatcher = require_difflib2().SequenceMatcher;
      extendedTypeOf = require_util3().extendedTypeOf;
      colorize = require_colorize2().colorize;
      isScalar = function(obj) {
        return typeof obj !== "object" || obj === null;
      };
      objectDiff = function(obj1, obj2, options) {
        var change, key2, ref2, ref1, result2, score, subscore, value1, value2;
        if (options == null) {
          options = {};
        }
        result2 = {};
        score = 0;
        for (key2 in obj1) {
          if (!hasProp.call(obj1, key2))
            continue;
          value1 = obj1[key2];
          if (!!(key2 in obj2)) {
            continue;
          }
          result2[key2 + "__deleted"] = value1;
          score -= 30;
        }
        for (key2 in obj2) {
          if (!hasProp.call(obj2, key2))
            continue;
          value2 = obj2[key2];
          if (!!(key2 in obj1)) {
            continue;
          }
          result2[key2 + "__added"] = value2;
          score -= 30;
        }
        for (key2 in obj1) {
          if (!hasProp.call(obj1, key2))
            continue;
          value1 = obj1[key2];
          if (!(key2 in obj2)) {
            continue;
          }
          score += 20;
          value2 = obj2[key2];
          ref2 = diffWithScore(value1, value2, options), subscore = ref2[0], change = ref2[1];
          if (change) {
            result2[key2] = change;
          }
          score += Math.min(20, Math.max(-10, subscore / 5));
        }
        if (Object.keys(result2).length === 0) {
          ref1 = [100 * Math.max(Object.keys(obj1).length, 0.5), void 0], score = ref1[0], result2 = ref1[1];
        } else {
          score = Math.max(0, score);
        }
        return [score, result2];
      };
      findMatchingObject = function(item, index, fuzzyOriginals) {
        var bestMatch, candidate, indexDistance, key2, matchIndex, score;
        bestMatch = null;
        matchIndex = 0;
        for (key2 in fuzzyOriginals) {
          if (!hasProp.call(fuzzyOriginals, key2))
            continue;
          candidate = fuzzyOriginals[key2];
          if (!(key2 !== "__next")) {
            continue;
          }
          indexDistance = Math.abs(matchIndex - index);
          if (extendedTypeOf(item) === extendedTypeOf(candidate)) {
            score = diffScore(item, candidate);
            if (!bestMatch || score > bestMatch.score || score === bestMatch.score && indexDistance < bestMatch.indexDistance) {
              bestMatch = {
                score,
                key: key2,
                indexDistance
              };
            }
          }
          matchIndex++;
        }
        return bestMatch;
      };
      scalarize = function(array, originals, fuzzyOriginals) {
        var bestMatch, index, item, k, len, proxy2, results;
        results = [];
        for (index = k = 0, len = array.length; k < len; index = ++k) {
          item = array[index];
          if (isScalar(item)) {
            results.push(item);
          } else if (fuzzyOriginals && (bestMatch = findMatchingObject(item, index, fuzzyOriginals)) && bestMatch.score > 40 && originals[bestMatch.key] == null) {
            originals[bestMatch.key] = item;
            results.push(bestMatch.key);
          } else {
            proxy2 = "__$!SCALAR" + originals.__next++;
            originals[proxy2] = item;
            results.push(proxy2);
          }
        }
        return results;
      };
      isScalarized = function(item, originals) {
        return typeof item === "string" && item in originals;
      };
      descalarize = function(item, originals) {
        if (isScalarized(item, originals)) {
          return originals[item];
        } else {
          return item;
        }
      };
      arrayDiff = function(obj1, obj2, options) {
        var allEqual, change, i3, i1, i22, item, item1, item2, j, j1, j2, k, l2, len, m, n2, o2, op, opcodes, originals1, originals2, p, q, ref2, ref1, ref10, ref11, ref12, ref22, ref3, ref4, ref5, ref6, ref7, ref8, ref9, result2, score, seq1, seq2;
        if (options == null) {
          options = {};
        }
        originals1 = {
          __next: 1
        };
        seq1 = scalarize(obj1, originals1);
        originals2 = {
          __next: originals1.__next
        };
        seq2 = scalarize(obj2, originals2, originals1);
        opcodes = new SequenceMatcher(null, seq1, seq2).getOpcodes();
        result2 = [];
        score = 0;
        allEqual = true;
        for (k = 0, len = opcodes.length; k < len; k++) {
          ref2 = opcodes[k], op = ref2[0], i1 = ref2[1], i22 = ref2[2], j1 = ref2[3], j2 = ref2[4];
          if (!(op === "equal" || options.keysOnly && op === "replace")) {
            allEqual = false;
          }
          switch (op) {
            case "equal":
              for (i3 = l2 = ref1 = i1, ref22 = i22; ref1 <= ref22 ? l2 < ref22 : l2 > ref22; i3 = ref1 <= ref22 ? ++l2 : --l2) {
                item = seq1[i3];
                if (isScalarized(item, originals1)) {
                  if (!isScalarized(item, originals2)) {
                    throw new AssertionError("internal bug: isScalarized(item, originals1) != isScalarized(item, originals2) for item " + JSON.stringify(item));
                  }
                  item1 = descalarize(item, originals1);
                  item2 = descalarize(item, originals2);
                  change = diff2(item1, item2, options);
                  if (change) {
                    result2.push(["~", change]);
                    allEqual = false;
                  } else {
                    result2.push([" "]);
                  }
                } else {
                  result2.push([" ", item]);
                }
                score += 10;
              }
              break;
            case "delete":
              for (i3 = m = ref3 = i1, ref4 = i22; ref3 <= ref4 ? m < ref4 : m > ref4; i3 = ref3 <= ref4 ? ++m : --m) {
                result2.push(["-", descalarize(seq1[i3], originals1)]);
                score -= 5;
              }
              break;
            case "insert":
              for (j = n2 = ref5 = j1, ref6 = j2; ref5 <= ref6 ? n2 < ref6 : n2 > ref6; j = ref5 <= ref6 ? ++n2 : --n2) {
                result2.push(["+", descalarize(seq2[j], originals2)]);
                score -= 5;
              }
              break;
            case "replace":
              if (!options.keysOnly) {
                for (i3 = o2 = ref7 = i1, ref8 = i22; ref7 <= ref8 ? o2 < ref8 : o2 > ref8; i3 = ref7 <= ref8 ? ++o2 : --o2) {
                  result2.push(["-", descalarize(seq1[i3], originals1)]);
                  score -= 5;
                }
                for (j = p = ref9 = j1, ref10 = j2; ref9 <= ref10 ? p < ref10 : p > ref10; j = ref9 <= ref10 ? ++p : --p) {
                  result2.push(["+", descalarize(seq2[j], originals2)]);
                  score -= 5;
                }
              } else {
                for (i3 = q = ref11 = i1, ref12 = i22; ref11 <= ref12 ? q < ref12 : q > ref12; i3 = ref11 <= ref12 ? ++q : --q) {
                  change = diff2(descalarize(seq1[i3], originals1), descalarize(seq2[i3 - i1 + j1], originals2), options);
                  if (change) {
                    result2.push(["~", change]);
                    allEqual = false;
                  } else {
                    result2.push([" "]);
                  }
                }
              }
          }
        }
        if (allEqual || opcodes.length === 0) {
          result2 = void 0;
          score = 100;
        } else {
          score = Math.max(0, score);
        }
        return [score, result2];
      };
      diffWithScore = function(obj1, obj2, options) {
        var type1, type22;
        if (options == null) {
          options = {};
        }
        type1 = extendedTypeOf(obj1);
        type22 = extendedTypeOf(obj2);
        if (type1 === type22) {
          switch (type1) {
            case "object":
              return objectDiff(obj1, obj2, options);
            case "array":
              return arrayDiff(obj1, obj2, options);
          }
        }
        if (!options.keysOnly) {
          if (obj1 !== obj2) {
            return [
              0,
              {
                __old: obj1,
                __new: obj2
              }
            ];
          } else {
            return [100, void 0];
          }
        } else {
          return [100, void 0];
        }
      };
      diff2 = function(obj1, obj2, options) {
        var change, ref2, score;
        if (options == null) {
          options = {};
        }
        ref2 = diffWithScore(obj1, obj2, options), score = ref2[0], change = ref2[1];
        return change;
      };
      diffScore = function(obj1, obj2, options) {
        var change, ref2, score;
        if (options == null) {
          options = {};
        }
        ref2 = diffWithScore(obj1, obj2, options), score = ref2[0], change = ref2[1];
        return score;
      };
      diffString = function(obj1, obj2, colorizeOptions, diffOptions) {
        if (diffOptions == null) {
          diffOptions = {};
        }
        return colorize(diff2(obj1, obj2, diffOptions), colorizeOptions);
      };
      module2.exports = {
        diff: diff2,
        diffString
      };
    }).call(exports2);
  }
});

// node_modules/lodash/_freeGlobal.js
var require_freeGlobal = __commonJS({
  "node_modules/lodash/_freeGlobal.js"(exports2, module2) {
    var freeGlobal = typeof global == "object" && global && global.Object === Object && global;
    module2.exports = freeGlobal;
  }
});

// node_modules/lodash/_root.js
var require_root = __commonJS({
  "node_modules/lodash/_root.js"(exports2, module2) {
    var freeGlobal = require_freeGlobal();
    var freeSelf = typeof self == "object" && self && self.Object === Object && self;
    var root = freeGlobal || freeSelf || Function("return this")();
    module2.exports = root;
  }
});

// node_modules/lodash/_Symbol.js
var require_Symbol = __commonJS({
  "node_modules/lodash/_Symbol.js"(exports2, module2) {
    var root = require_root();
    var Symbol2 = root.Symbol;
    module2.exports = Symbol2;
  }
});

// node_modules/lodash/_getRawTag.js
var require_getRawTag = __commonJS({
  "node_modules/lodash/_getRawTag.js"(exports2, module2) {
    var Symbol2 = require_Symbol();
    var objectProto = Object.prototype;
    var hasOwnProperty2 = objectProto.hasOwnProperty;
    var nativeObjectToString = objectProto.toString;
    var symToStringTag = Symbol2 ? Symbol2.toStringTag : void 0;
    function getRawTag(value) {
      var isOwn = hasOwnProperty2.call(value, symToStringTag), tag = value[symToStringTag];
      try {
        value[symToStringTag] = void 0;
        var unmasked = true;
      } catch (e2) {
      }
      var result2 = nativeObjectToString.call(value);
      if (unmasked) {
        if (isOwn) {
          value[symToStringTag] = tag;
        } else {
          delete value[symToStringTag];
        }
      }
      return result2;
    }
    module2.exports = getRawTag;
  }
});

// node_modules/lodash/_objectToString.js
var require_objectToString = __commonJS({
  "node_modules/lodash/_objectToString.js"(exports2, module2) {
    var objectProto = Object.prototype;
    var nativeObjectToString = objectProto.toString;
    function objectToString(value) {
      return nativeObjectToString.call(value);
    }
    module2.exports = objectToString;
  }
});

// node_modules/lodash/_baseGetTag.js
var require_baseGetTag = __commonJS({
  "node_modules/lodash/_baseGetTag.js"(exports2, module2) {
    var Symbol2 = require_Symbol();
    var getRawTag = require_getRawTag();
    var objectToString = require_objectToString();
    var nullTag = "[object Null]";
    var undefinedTag = "[object Undefined]";
    var symToStringTag = Symbol2 ? Symbol2.toStringTag : void 0;
    function baseGetTag(value) {
      if (value == null) {
        return value === void 0 ? undefinedTag : nullTag;
      }
      return symToStringTag && symToStringTag in Object(value) ? getRawTag(value) : objectToString(value);
    }
    module2.exports = baseGetTag;
  }
});

// node_modules/lodash/_overArg.js
var require_overArg = __commonJS({
  "node_modules/lodash/_overArg.js"(exports2, module2) {
    function overArg(func2, transform) {
      return function(arg2) {
        return func2(transform(arg2));
      };
    }
    module2.exports = overArg;
  }
});

// node_modules/lodash/_getPrototype.js
var require_getPrototype = __commonJS({
  "node_modules/lodash/_getPrototype.js"(exports2, module2) {
    var overArg = require_overArg();
    var getPrototype = overArg(Object.getPrototypeOf, Object);
    module2.exports = getPrototype;
  }
});

// node_modules/lodash/isObjectLike.js
var require_isObjectLike = __commonJS({
  "node_modules/lodash/isObjectLike.js"(exports2, module2) {
    function isObjectLike(value) {
      return value != null && typeof value == "object";
    }
    module2.exports = isObjectLike;
  }
});

// node_modules/lodash/isPlainObject.js
var require_isPlainObject = __commonJS({
  "node_modules/lodash/isPlainObject.js"(exports2, module2) {
    var baseGetTag = require_baseGetTag();
    var getPrototype = require_getPrototype();
    var isObjectLike = require_isObjectLike();
    var objectTag = "[object Object]";
    var funcProto = Function.prototype;
    var objectProto = Object.prototype;
    var funcToString = funcProto.toString;
    var hasOwnProperty2 = objectProto.hasOwnProperty;
    var objectCtorString = funcToString.call(Object);
    function isPlainObject(value) {
      if (!isObjectLike(value) || baseGetTag(value) != objectTag) {
        return false;
      }
      var proto = getPrototype(value);
      if (proto === null) {
        return true;
      }
      var Ctor = hasOwnProperty2.call(proto, "constructor") && proto.constructor;
      return typeof Ctor == "function" && Ctor instanceof Ctor && funcToString.call(Ctor) == objectCtorString;
    }
    module2.exports = isPlainObject;
  }
});

// node_modules/pretty-error/lib/defaultStyle.js
var require_defaultStyle = __commonJS({
  "node_modules/pretty-error/lib/defaultStyle.js"(exports2, module2) {
    module2.exports = function() {
      return {
        "pretty-error": {
          display: "block",
          marginLeft: "2"
        },
        "pretty-error > header": {
          display: "block"
        },
        "pretty-error > header > title > kind": {
          background: "red",
          color: "bright-white"
        },
        "pretty-error > header > title > wrapper": {
          marginRight: "1",
          color: "grey"
        },
        "pretty-error > header > colon": {
          color: "grey",
          marginRight: 1
        },
        "pretty-error > header > message": {
          color: "bright-white"
        },
        "pretty-error > trace": {
          display: "block",
          marginTop: 1
        },
        "pretty-error > trace > item": {
          display: "block",
          marginBottom: 1,
          marginLeft: 2,
          bullet: '"<grey>-</grey>"'
        },
        "pretty-error > trace > item > header": {
          display: "block"
        },
        "pretty-error > trace > item > header > pointer > file": {
          color: "bright-yellow"
        },
        "pretty-error > trace > item > header > pointer > colon": {
          color: "grey"
        },
        "pretty-error > trace > item > header > pointer > line": {
          color: "bright-yellow",
          marginRight: 1
        },
        "pretty-error > trace > item > header > what": {
          color: "white"
        },
        "pretty-error > trace > item > footer": {
          display: "block"
        },
        "pretty-error > trace > item > footer > addr": {
          display: "block",
          color: "grey"
        },
        "pretty-error > trace > item > footer > extra": {
          display: "block",
          color: "grey"
        }
      };
    };
  }
});

// node_modules/pretty-error/lib/ParsedError.js
var require_ParsedError = __commonJS({
  "node_modules/pretty-error/lib/ParsedError.js"(exports2, module2) {
    var ParsedError;
    var fn;
    var i3;
    var len;
    var prop;
    var ref2;
    var sysPath;
    sysPath = require("path");
    module2.exports = ParsedError = function() {
      function ParsedError2(error) {
        this.error = error;
        this._parse();
      }
      ParsedError2.prototype._parse = function() {
        var m;
        this._trace = [];
        this._kind = "Error";
        this._wrapper = "";
        if (this.error.wrapper != null) {
          this._wrapper = String(this.error.wrapper);
        }
        if (typeof this.error !== "object") {
          this._message = String(this.error);
        } else {
          this._stack = this.error.stack;
          if (this.error.kind != null) {
            this._kind = String(this.error.kind);
          } else if (typeof this._stack === "string") {
            if (m = this._stack.match(/^([a-zA-Z0-9\_\$]+):\ /)) {
              this._kind = m[1];
            }
          }
          this._message = this.error.message != null && String(this.error.message) || "";
          if (typeof this._stack === "string") {
            this._parseStack();
          }
        }
      };
      ParsedError2.prototype._parseStack = function() {
        var i4, len2, line, message, messageLines, reachedTrace, ref3;
        messageLines = [];
        reachedTrace = false;
        ref3 = this._stack.split("\n");
        for (i4 = 0, len2 = ref3.length; i4 < len2; i4++) {
          line = ref3[i4];
          if (line.trim() === "") {
            continue;
          }
          if (reachedTrace) {
            this._trace.push(this._parseTraceItem(line));
          } else {
            if (line.match(/^\s*at\s.+/)) {
              reachedTrace = true;
              this._trace.push(this._parseTraceItem(line));
            } else if (!this._message.split("\n".indexOf(line))) {
              messageLines.push(line);
            }
          }
        }
        message = messageLines.join("\n");
        if (message.substr(0, this._kind.length) === this._kind) {
          message = message.substr(this._kind.length, message.length).replace(/^\:\s+/, "");
        }
        if (message.length) {
          this._message = this._message.length ? [this._message, message].join("\n") : message;
        }
      };
      ParsedError2.prototype._parseTraceItem = function(text) {
        var addr, col, d, dir, file, jsCol, jsLine, line, m, original, packageName, packages, path2, r2, remaining, shortenedAddr, shortenedPath, what;
        text = text.trim();
        if (text === "") {
          return;
        }
        if (!text.match(/^at\ /)) {
          return text;
        }
        text = text.replace(/^at /, "");
        if (text === "Error (<anonymous>)" || text === "Error (<anonymous>:null:null)") {
          return;
        }
        original = text;
        what = null;
        addr = null;
        path2 = null;
        dir = null;
        file = null;
        line = null;
        col = null;
        jsLine = null;
        jsCol = null;
        shortenedPath = null;
        shortenedAddr = null;
        packageName = "[current]";
        if (m = text.match(/\(([^\)]+)\)$/)) {
          addr = m[1].trim();
        }
        if (addr != null) {
          what = text.substr(0, text.length - addr.length - 2);
          what = what.trim();
        }
        if (addr == null) {
          addr = text.trim();
        }
        addr = this._fixPath(addr);
        remaining = addr;
        if (m = remaining.match(/\,\ <js>:(\d+):(\d+)$/)) {
          jsLine = m[1];
          jsCol = m[2];
          remaining = remaining.substr(0, remaining.length - m[0].length);
        }
        if (m = remaining.match(/:(\d+):(\d+)$/)) {
          line = m[1];
          col = m[2];
          remaining = remaining.substr(0, remaining.length - m[0].length);
          path2 = remaining;
        }
        if (path2 != null) {
          file = sysPath.basename(path2);
          dir = sysPath.dirname(path2);
          if (dir === ".") {
            dir = "";
          }
          path2 = this._fixPath(path2);
          file = this._fixPath(file);
          dir = this._fixPath(dir);
        }
        if (dir != null) {
          d = dir.replace(/[\\]{1,2}/g, "/");
          if (m = d.match(/node_modules\/([^\/]+)(?!.*node_modules.*)/)) {
            packageName = m[1];
          }
        }
        if (jsLine == null) {
          jsLine = line;
          jsCol = col;
        }
        if (path2 != null) {
          r2 = this._rectifyPath(path2);
          shortenedPath = r2.path;
          shortenedAddr = shortenedPath + addr.substr(path2.length, addr.length);
          packages = r2.packages;
        }
        return {
          original,
          what,
          addr,
          path: path2,
          dir,
          file,
          line: parseInt(line),
          col: parseInt(col),
          jsLine: parseInt(jsLine),
          jsCol: parseInt(jsCol),
          packageName,
          shortenedPath,
          shortenedAddr,
          packages: packages || []
        };
      };
      ParsedError2.prototype._getMessage = function() {
        return this._message;
      };
      ParsedError2.prototype._getKind = function() {
        return this._kind;
      };
      ParsedError2.prototype._getWrapper = function() {
        return this._wrapper;
      };
      ParsedError2.prototype._getStack = function() {
        return this._stack;
      };
      ParsedError2.prototype._getArguments = function() {
        return this.error["arguments"];
      };
      ParsedError2.prototype._getType = function() {
        return this.error.type;
      };
      ParsedError2.prototype._getTrace = function() {
        return this._trace;
      };
      ParsedError2.prototype._fixPath = function(path2) {
        return path2.replace(/[\\]{1,2}/g, "/");
      };
      ParsedError2.prototype._rectifyPath = function(path2, nameForCurrentPackage) {
        var m, packages, parts, remaining, rest;
        path2 = String(path2);
        remaining = path2;
        if (!(m = path2.match(/^(.+?)\/node_modules\/(.+)$/))) {
          return {
            path: path2,
            packages: []
          };
        }
        parts = [];
        packages = [];
        if (typeof nameForCurrentPackage === "string") {
          parts.push("[" + nameForCurrentPackage + "]");
          packages.push("[" + nameForCurrentPackage + "]");
        } else {
          parts.push("[" + m[1].match(/([^\/]+)$/)[1] + "]");
          packages.push(m[1].match(/([^\/]+)$/)[1]);
        }
        rest = m[2];
        while (m = rest.match(/([^\/]+)\/node_modules\/(.+)$/)) {
          parts.push("[" + m[1] + "]");
          packages.push(m[1]);
          rest = m[2];
        }
        if (m = rest.match(/([^\/]+)\/(.+)$/)) {
          parts.push("[" + m[1] + "]");
          packages.push(m[1]);
          rest = m[2];
        }
        parts.push(rest);
        return {
          path: parts.join("/"),
          packages
        };
      };
      return ParsedError2;
    }();
    ref2 = ["message", "kind", "arguments", "type", "stack", "trace", "wrapper"];
    fn = function() {
      var methodName;
      methodName = "_get" + prop[0].toUpperCase() + prop.substr(1, prop.length);
      return Object.defineProperty(ParsedError.prototype, prop, {
        get: function() {
          return this[methodName]();
        }
      });
    };
    for (i3 = 0, len = ref2.length; i3 < len; i3++) {
      prop = ref2[i3];
      fn();
    }
  }
});

// node_modules/pretty-error/lib/nodePaths.js
var require_nodePaths = __commonJS({
  "node_modules/pretty-error/lib/nodePaths.js"(exports2, module2) {
    module2.exports = ["_debugger.js", "_http_agent.js", "_http_client.js", "_http_common.js", "_http_incoming.js", "_http_outgoing.js", "_http_server.js", "_linklist.js", "_stream_duplex.js", "_stream_passthrough.js", "_stream_readable.js", "_stream_transform.js", "_stream_writable.js", "_tls_legacy.js", "_tls_wrap.js", "assert.js", "buffer.js", "child_process.js", "cluster.js", "console.js", "constants.js", "crypto.js", "dgram.js", "dns.js", "domain.js", "events.js", "freelist.js", "fs.js", "http.js", "https.js", "module.js", "net.js", "os.js", "path.js", "punycode.js", "querystring.js", "readline.js", "repl.js", "smalloc.js", "stream.js", "string_decoder.js", "sys.js", "timers.js", "tls.js", "tty.js", "url.js", "util.js", "vm.js", "zlib.js", "node.js"];
  }
});

// node_modules/entities/lib/maps/decode.json
var require_decode = __commonJS({
  "node_modules/entities/lib/maps/decode.json"(exports2, module2) {
    module2.exports = { "0": 65533, "128": 8364, "130": 8218, "131": 402, "132": 8222, "133": 8230, "134": 8224, "135": 8225, "136": 710, "137": 8240, "138": 352, "139": 8249, "140": 338, "142": 381, "145": 8216, "146": 8217, "147": 8220, "148": 8221, "149": 8226, "150": 8211, "151": 8212, "152": 732, "153": 8482, "154": 353, "155": 8250, "156": 339, "158": 382, "159": 376 };
  }
});

// node_modules/entities/lib/decode_codepoint.js
var require_decode_codepoint = __commonJS({
  "node_modules/entities/lib/decode_codepoint.js"(exports2) {
    "use strict";
    var __importDefault = exports2 && exports2.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { "default": mod };
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    var decode_json_1 = __importDefault(require_decode());
    var fromCodePoint = String.fromCodePoint || function(codePoint) {
      var output = "";
      if (codePoint > 65535) {
        codePoint -= 65536;
        output += String.fromCharCode(codePoint >>> 10 & 1023 | 55296);
        codePoint = 56320 | codePoint & 1023;
      }
      output += String.fromCharCode(codePoint);
      return output;
    };
    function decodeCodePoint(codePoint) {
      if (codePoint >= 55296 && codePoint <= 57343 || codePoint > 1114111) {
        return "\uFFFD";
      }
      if (codePoint in decode_json_1.default) {
        codePoint = decode_json_1.default[codePoint];
      }
      return fromCodePoint(codePoint);
    }
    exports2.default = decodeCodePoint;
  }
});

// node_modules/entities/lib/maps/entities.json
var require_entities = __commonJS({
  "node_modules/entities/lib/maps/entities.json"(exports2, module2) {
    module2.exports = { Aacute: "\xC1", aacute: "\xE1", Abreve: "\u0102", abreve: "\u0103", ac: "\u223E", acd: "\u223F", acE: "\u223E\u0333", Acirc: "\xC2", acirc: "\xE2", acute: "\xB4", Acy: "\u0410", acy: "\u0430", AElig: "\xC6", aelig: "\xE6", af: "\u2061", Afr: "\u{1D504}", afr: "\u{1D51E}", Agrave: "\xC0", agrave: "\xE0", alefsym: "\u2135", aleph: "\u2135", Alpha: "\u0391", alpha: "\u03B1", Amacr: "\u0100", amacr: "\u0101", amalg: "\u2A3F", amp: "&", AMP: "&", andand: "\u2A55", And: "\u2A53", and: "\u2227", andd: "\u2A5C", andslope: "\u2A58", andv: "\u2A5A", ang: "\u2220", ange: "\u29A4", angle: "\u2220", angmsdaa: "\u29A8", angmsdab: "\u29A9", angmsdac: "\u29AA", angmsdad: "\u29AB", angmsdae: "\u29AC", angmsdaf: "\u29AD", angmsdag: "\u29AE", angmsdah: "\u29AF", angmsd: "\u2221", angrt: "\u221F", angrtvb: "\u22BE", angrtvbd: "\u299D", angsph: "\u2222", angst: "\xC5", angzarr: "\u237C", Aogon: "\u0104", aogon: "\u0105", Aopf: "\u{1D538}", aopf: "\u{1D552}", apacir: "\u2A6F", ap: "\u2248", apE: "\u2A70", ape: "\u224A", apid: "\u224B", apos: "'", ApplyFunction: "\u2061", approx: "\u2248", approxeq: "\u224A", Aring: "\xC5", aring: "\xE5", Ascr: "\u{1D49C}", ascr: "\u{1D4B6}", Assign: "\u2254", ast: "*", asymp: "\u2248", asympeq: "\u224D", Atilde: "\xC3", atilde: "\xE3", Auml: "\xC4", auml: "\xE4", awconint: "\u2233", awint: "\u2A11", backcong: "\u224C", backepsilon: "\u03F6", backprime: "\u2035", backsim: "\u223D", backsimeq: "\u22CD", Backslash: "\u2216", Barv: "\u2AE7", barvee: "\u22BD", barwed: "\u2305", Barwed: "\u2306", barwedge: "\u2305", bbrk: "\u23B5", bbrktbrk: "\u23B6", bcong: "\u224C", Bcy: "\u0411", bcy: "\u0431", bdquo: "\u201E", becaus: "\u2235", because: "\u2235", Because: "\u2235", bemptyv: "\u29B0", bepsi: "\u03F6", bernou: "\u212C", Bernoullis: "\u212C", Beta: "\u0392", beta: "\u03B2", beth: "\u2136", between: "\u226C", Bfr: "\u{1D505}", bfr: "\u{1D51F}", bigcap: "\u22C2", bigcirc: "\u25EF", bigcup: "\u22C3", bigodot: "\u2A00", bigoplus: "\u2A01", bigotimes: "\u2A02", bigsqcup: "\u2A06", bigstar: "\u2605", bigtriangledown: "\u25BD", bigtriangleup: "\u25B3", biguplus: "\u2A04", bigvee: "\u22C1", bigwedge: "\u22C0", bkarow: "\u290D", blacklozenge: "\u29EB", blacksquare: "\u25AA", blacktriangle: "\u25B4", blacktriangledown: "\u25BE", blacktriangleleft: "\u25C2", blacktriangleright: "\u25B8", blank: "\u2423", blk12: "\u2592", blk14: "\u2591", blk34: "\u2593", block: "\u2588", bne: "=\u20E5", bnequiv: "\u2261\u20E5", bNot: "\u2AED", bnot: "\u2310", Bopf: "\u{1D539}", bopf: "\u{1D553}", bot: "\u22A5", bottom: "\u22A5", bowtie: "\u22C8", boxbox: "\u29C9", boxdl: "\u2510", boxdL: "\u2555", boxDl: "\u2556", boxDL: "\u2557", boxdr: "\u250C", boxdR: "\u2552", boxDr: "\u2553", boxDR: "\u2554", boxh: "\u2500", boxH: "\u2550", boxhd: "\u252C", boxHd: "\u2564", boxhD: "\u2565", boxHD: "\u2566", boxhu: "\u2534", boxHu: "\u2567", boxhU: "\u2568", boxHU: "\u2569", boxminus: "\u229F", boxplus: "\u229E", boxtimes: "\u22A0", boxul: "\u2518", boxuL: "\u255B", boxUl: "\u255C", boxUL: "\u255D", boxur: "\u2514", boxuR: "\u2558", boxUr: "\u2559", boxUR: "\u255A", boxv: "\u2502", boxV: "\u2551", boxvh: "\u253C", boxvH: "\u256A", boxVh: "\u256B", boxVH: "\u256C", boxvl: "\u2524", boxvL: "\u2561", boxVl: "\u2562", boxVL: "\u2563", boxvr: "\u251C", boxvR: "\u255E", boxVr: "\u255F", boxVR: "\u2560", bprime: "\u2035", breve: "\u02D8", Breve: "\u02D8", brvbar: "\xA6", bscr: "\u{1D4B7}", Bscr: "\u212C", bsemi: "\u204F", bsim: "\u223D", bsime: "\u22CD", bsolb: "\u29C5", bsol: "\\", bsolhsub: "\u27C8", bull: "\u2022", bullet: "\u2022", bump: "\u224E", bumpE: "\u2AAE", bumpe: "\u224F", Bumpeq: "\u224E", bumpeq: "\u224F", Cacute: "\u0106", cacute: "\u0107", capand: "\u2A44", capbrcup: "\u2A49", capcap: "\u2A4B", cap: "\u2229", Cap: "\u22D2", capcup: "\u2A47", capdot: "\u2A40", CapitalDifferentialD: "\u2145", caps: "\u2229\uFE00", caret: "\u2041", caron: "\u02C7", Cayleys: "\u212D", ccaps: "\u2A4D", Ccaron: "\u010C", ccaron: "\u010D", Ccedil: "\xC7", ccedil: "\xE7", Ccirc: "\u0108", ccirc: "\u0109", Cconint: "\u2230", ccups: "\u2A4C", ccupssm: "\u2A50", Cdot: "\u010A", cdot: "\u010B", cedil: "\xB8", Cedilla: "\xB8", cemptyv: "\u29B2", cent: "\xA2", centerdot: "\xB7", CenterDot: "\xB7", cfr: "\u{1D520}", Cfr: "\u212D", CHcy: "\u0427", chcy: "\u0447", check: "\u2713", checkmark: "\u2713", Chi: "\u03A7", chi: "\u03C7", circ: "\u02C6", circeq: "\u2257", circlearrowleft: "\u21BA", circlearrowright: "\u21BB", circledast: "\u229B", circledcirc: "\u229A", circleddash: "\u229D", CircleDot: "\u2299", circledR: "\xAE", circledS: "\u24C8", CircleMinus: "\u2296", CirclePlus: "\u2295", CircleTimes: "\u2297", cir: "\u25CB", cirE: "\u29C3", cire: "\u2257", cirfnint: "\u2A10", cirmid: "\u2AEF", cirscir: "\u29C2", ClockwiseContourIntegral: "\u2232", CloseCurlyDoubleQuote: "\u201D", CloseCurlyQuote: "\u2019", clubs: "\u2663", clubsuit: "\u2663", colon: ":", Colon: "\u2237", Colone: "\u2A74", colone: "\u2254", coloneq: "\u2254", comma: ",", commat: "@", comp: "\u2201", compfn: "\u2218", complement: "\u2201", complexes: "\u2102", cong: "\u2245", congdot: "\u2A6D", Congruent: "\u2261", conint: "\u222E", Conint: "\u222F", ContourIntegral: "\u222E", copf: "\u{1D554}", Copf: "\u2102", coprod: "\u2210", Coproduct: "\u2210", copy: "\xA9", COPY: "\xA9", copysr: "\u2117", CounterClockwiseContourIntegral: "\u2233", crarr: "\u21B5", cross: "\u2717", Cross: "\u2A2F", Cscr: "\u{1D49E}", cscr: "\u{1D4B8}", csub: "\u2ACF", csube: "\u2AD1", csup: "\u2AD0", csupe: "\u2AD2", ctdot: "\u22EF", cudarrl: "\u2938", cudarrr: "\u2935", cuepr: "\u22DE", cuesc: "\u22DF", cularr: "\u21B6", cularrp: "\u293D", cupbrcap: "\u2A48", cupcap: "\u2A46", CupCap: "\u224D", cup: "\u222A", Cup: "\u22D3", cupcup: "\u2A4A", cupdot: "\u228D", cupor: "\u2A45", cups: "\u222A\uFE00", curarr: "\u21B7", curarrm: "\u293C", curlyeqprec: "\u22DE", curlyeqsucc: "\u22DF", curlyvee: "\u22CE", curlywedge: "\u22CF", curren: "\xA4", curvearrowleft: "\u21B6", curvearrowright: "\u21B7", cuvee: "\u22CE", cuwed: "\u22CF", cwconint: "\u2232", cwint: "\u2231", cylcty: "\u232D", dagger: "\u2020", Dagger: "\u2021", daleth: "\u2138", darr: "\u2193", Darr: "\u21A1", dArr: "\u21D3", dash: "\u2010", Dashv: "\u2AE4", dashv: "\u22A3", dbkarow: "\u290F", dblac: "\u02DD", Dcaron: "\u010E", dcaron: "\u010F", Dcy: "\u0414", dcy: "\u0434", ddagger: "\u2021", ddarr: "\u21CA", DD: "\u2145", dd: "\u2146", DDotrahd: "\u2911", ddotseq: "\u2A77", deg: "\xB0", Del: "\u2207", Delta: "\u0394", delta: "\u03B4", demptyv: "\u29B1", dfisht: "\u297F", Dfr: "\u{1D507}", dfr: "\u{1D521}", dHar: "\u2965", dharl: "\u21C3", dharr: "\u21C2", DiacriticalAcute: "\xB4", DiacriticalDot: "\u02D9", DiacriticalDoubleAcute: "\u02DD", DiacriticalGrave: "`", DiacriticalTilde: "\u02DC", diam: "\u22C4", diamond: "\u22C4", Diamond: "\u22C4", diamondsuit: "\u2666", diams: "\u2666", die: "\xA8", DifferentialD: "\u2146", digamma: "\u03DD", disin: "\u22F2", div: "\xF7", divide: "\xF7", divideontimes: "\u22C7", divonx: "\u22C7", DJcy: "\u0402", djcy: "\u0452", dlcorn: "\u231E", dlcrop: "\u230D", dollar: "$", Dopf: "\u{1D53B}", dopf: "\u{1D555}", Dot: "\xA8", dot: "\u02D9", DotDot: "\u20DC", doteq: "\u2250", doteqdot: "\u2251", DotEqual: "\u2250", dotminus: "\u2238", dotplus: "\u2214", dotsquare: "\u22A1", doublebarwedge: "\u2306", DoubleContourIntegral: "\u222F", DoubleDot: "\xA8", DoubleDownArrow: "\u21D3", DoubleLeftArrow: "\u21D0", DoubleLeftRightArrow: "\u21D4", DoubleLeftTee: "\u2AE4", DoubleLongLeftArrow: "\u27F8", DoubleLongLeftRightArrow: "\u27FA", DoubleLongRightArrow: "\u27F9", DoubleRightArrow: "\u21D2", DoubleRightTee: "\u22A8", DoubleUpArrow: "\u21D1", DoubleUpDownArrow: "\u21D5", DoubleVerticalBar: "\u2225", DownArrowBar: "\u2913", downarrow: "\u2193", DownArrow: "\u2193", Downarrow: "\u21D3", DownArrowUpArrow: "\u21F5", DownBreve: "\u0311", downdownarrows: "\u21CA", downharpoonleft: "\u21C3", downharpoonright: "\u21C2", DownLeftRightVector: "\u2950", DownLeftTeeVector: "\u295E", DownLeftVectorBar: "\u2956", DownLeftVector: "\u21BD", DownRightTeeVector: "\u295F", DownRightVectorBar: "\u2957", DownRightVector: "\u21C1", DownTeeArrow: "\u21A7", DownTee: "\u22A4", drbkarow: "\u2910", drcorn: "\u231F", drcrop: "\u230C", Dscr: "\u{1D49F}", dscr: "\u{1D4B9}", DScy: "\u0405", dscy: "\u0455", dsol: "\u29F6", Dstrok: "\u0110", dstrok: "\u0111", dtdot: "\u22F1", dtri: "\u25BF", dtrif: "\u25BE", duarr: "\u21F5", duhar: "\u296F", dwangle: "\u29A6", DZcy: "\u040F", dzcy: "\u045F", dzigrarr: "\u27FF", Eacute: "\xC9", eacute: "\xE9", easter: "\u2A6E", Ecaron: "\u011A", ecaron: "\u011B", Ecirc: "\xCA", ecirc: "\xEA", ecir: "\u2256", ecolon: "\u2255", Ecy: "\u042D", ecy: "\u044D", eDDot: "\u2A77", Edot: "\u0116", edot: "\u0117", eDot: "\u2251", ee: "\u2147", efDot: "\u2252", Efr: "\u{1D508}", efr: "\u{1D522}", eg: "\u2A9A", Egrave: "\xC8", egrave: "\xE8", egs: "\u2A96", egsdot: "\u2A98", el: "\u2A99", Element: "\u2208", elinters: "\u23E7", ell: "\u2113", els: "\u2A95", elsdot: "\u2A97", Emacr: "\u0112", emacr: "\u0113", empty: "\u2205", emptyset: "\u2205", EmptySmallSquare: "\u25FB", emptyv: "\u2205", EmptyVerySmallSquare: "\u25AB", emsp13: "\u2004", emsp14: "\u2005", emsp: "\u2003", ENG: "\u014A", eng: "\u014B", ensp: "\u2002", Eogon: "\u0118", eogon: "\u0119", Eopf: "\u{1D53C}", eopf: "\u{1D556}", epar: "\u22D5", eparsl: "\u29E3", eplus: "\u2A71", epsi: "\u03B5", Epsilon: "\u0395", epsilon: "\u03B5", epsiv: "\u03F5", eqcirc: "\u2256", eqcolon: "\u2255", eqsim: "\u2242", eqslantgtr: "\u2A96", eqslantless: "\u2A95", Equal: "\u2A75", equals: "=", EqualTilde: "\u2242", equest: "\u225F", Equilibrium: "\u21CC", equiv: "\u2261", equivDD: "\u2A78", eqvparsl: "\u29E5", erarr: "\u2971", erDot: "\u2253", escr: "\u212F", Escr: "\u2130", esdot: "\u2250", Esim: "\u2A73", esim: "\u2242", Eta: "\u0397", eta: "\u03B7", ETH: "\xD0", eth: "\xF0", Euml: "\xCB", euml: "\xEB", euro: "\u20AC", excl: "!", exist: "\u2203", Exists: "\u2203", expectation: "\u2130", exponentiale: "\u2147", ExponentialE: "\u2147", fallingdotseq: "\u2252", Fcy: "\u0424", fcy: "\u0444", female: "\u2640", ffilig: "\uFB03", fflig: "\uFB00", ffllig: "\uFB04", Ffr: "\u{1D509}", ffr: "\u{1D523}", filig: "\uFB01", FilledSmallSquare: "\u25FC", FilledVerySmallSquare: "\u25AA", fjlig: "fj", flat: "\u266D", fllig: "\uFB02", fltns: "\u25B1", fnof: "\u0192", Fopf: "\u{1D53D}", fopf: "\u{1D557}", forall: "\u2200", ForAll: "\u2200", fork: "\u22D4", forkv: "\u2AD9", Fouriertrf: "\u2131", fpartint: "\u2A0D", frac12: "\xBD", frac13: "\u2153", frac14: "\xBC", frac15: "\u2155", frac16: "\u2159", frac18: "\u215B", frac23: "\u2154", frac25: "\u2156", frac34: "\xBE", frac35: "\u2157", frac38: "\u215C", frac45: "\u2158", frac56: "\u215A", frac58: "\u215D", frac78: "\u215E", frasl: "\u2044", frown: "\u2322", fscr: "\u{1D4BB}", Fscr: "\u2131", gacute: "\u01F5", Gamma: "\u0393", gamma: "\u03B3", Gammad: "\u03DC", gammad: "\u03DD", gap: "\u2A86", Gbreve: "\u011E", gbreve: "\u011F", Gcedil: "\u0122", Gcirc: "\u011C", gcirc: "\u011D", Gcy: "\u0413", gcy: "\u0433", Gdot: "\u0120", gdot: "\u0121", ge: "\u2265", gE: "\u2267", gEl: "\u2A8C", gel: "\u22DB", geq: "\u2265", geqq: "\u2267", geqslant: "\u2A7E", gescc: "\u2AA9", ges: "\u2A7E", gesdot: "\u2A80", gesdoto: "\u2A82", gesdotol: "\u2A84", gesl: "\u22DB\uFE00", gesles: "\u2A94", Gfr: "\u{1D50A}", gfr: "\u{1D524}", gg: "\u226B", Gg: "\u22D9", ggg: "\u22D9", gimel: "\u2137", GJcy: "\u0403", gjcy: "\u0453", gla: "\u2AA5", gl: "\u2277", glE: "\u2A92", glj: "\u2AA4", gnap: "\u2A8A", gnapprox: "\u2A8A", gne: "\u2A88", gnE: "\u2269", gneq: "\u2A88", gneqq: "\u2269", gnsim: "\u22E7", Gopf: "\u{1D53E}", gopf: "\u{1D558}", grave: "`", GreaterEqual: "\u2265", GreaterEqualLess: "\u22DB", GreaterFullEqual: "\u2267", GreaterGreater: "\u2AA2", GreaterLess: "\u2277", GreaterSlantEqual: "\u2A7E", GreaterTilde: "\u2273", Gscr: "\u{1D4A2}", gscr: "\u210A", gsim: "\u2273", gsime: "\u2A8E", gsiml: "\u2A90", gtcc: "\u2AA7", gtcir: "\u2A7A", gt: ">", GT: ">", Gt: "\u226B", gtdot: "\u22D7", gtlPar: "\u2995", gtquest: "\u2A7C", gtrapprox: "\u2A86", gtrarr: "\u2978", gtrdot: "\u22D7", gtreqless: "\u22DB", gtreqqless: "\u2A8C", gtrless: "\u2277", gtrsim: "\u2273", gvertneqq: "\u2269\uFE00", gvnE: "\u2269\uFE00", Hacek: "\u02C7", hairsp: "\u200A", half: "\xBD", hamilt: "\u210B", HARDcy: "\u042A", hardcy: "\u044A", harrcir: "\u2948", harr: "\u2194", hArr: "\u21D4", harrw: "\u21AD", Hat: "^", hbar: "\u210F", Hcirc: "\u0124", hcirc: "\u0125", hearts: "\u2665", heartsuit: "\u2665", hellip: "\u2026", hercon: "\u22B9", hfr: "\u{1D525}", Hfr: "\u210C", HilbertSpace: "\u210B", hksearow: "\u2925", hkswarow: "\u2926", hoarr: "\u21FF", homtht: "\u223B", hookleftarrow: "\u21A9", hookrightarrow: "\u21AA", hopf: "\u{1D559}", Hopf: "\u210D", horbar: "\u2015", HorizontalLine: "\u2500", hscr: "\u{1D4BD}", Hscr: "\u210B", hslash: "\u210F", Hstrok: "\u0126", hstrok: "\u0127", HumpDownHump: "\u224E", HumpEqual: "\u224F", hybull: "\u2043", hyphen: "\u2010", Iacute: "\xCD", iacute: "\xED", ic: "\u2063", Icirc: "\xCE", icirc: "\xEE", Icy: "\u0418", icy: "\u0438", Idot: "\u0130", IEcy: "\u0415", iecy: "\u0435", iexcl: "\xA1", iff: "\u21D4", ifr: "\u{1D526}", Ifr: "\u2111", Igrave: "\xCC", igrave: "\xEC", ii: "\u2148", iiiint: "\u2A0C", iiint: "\u222D", iinfin: "\u29DC", iiota: "\u2129", IJlig: "\u0132", ijlig: "\u0133", Imacr: "\u012A", imacr: "\u012B", image: "\u2111", ImaginaryI: "\u2148", imagline: "\u2110", imagpart: "\u2111", imath: "\u0131", Im: "\u2111", imof: "\u22B7", imped: "\u01B5", Implies: "\u21D2", incare: "\u2105", in: "\u2208", infin: "\u221E", infintie: "\u29DD", inodot: "\u0131", intcal: "\u22BA", int: "\u222B", Int: "\u222C", integers: "\u2124", Integral: "\u222B", intercal: "\u22BA", Intersection: "\u22C2", intlarhk: "\u2A17", intprod: "\u2A3C", InvisibleComma: "\u2063", InvisibleTimes: "\u2062", IOcy: "\u0401", iocy: "\u0451", Iogon: "\u012E", iogon: "\u012F", Iopf: "\u{1D540}", iopf: "\u{1D55A}", Iota: "\u0399", iota: "\u03B9", iprod: "\u2A3C", iquest: "\xBF", iscr: "\u{1D4BE}", Iscr: "\u2110", isin: "\u2208", isindot: "\u22F5", isinE: "\u22F9", isins: "\u22F4", isinsv: "\u22F3", isinv: "\u2208", it: "\u2062", Itilde: "\u0128", itilde: "\u0129", Iukcy: "\u0406", iukcy: "\u0456", Iuml: "\xCF", iuml: "\xEF", Jcirc: "\u0134", jcirc: "\u0135", Jcy: "\u0419", jcy: "\u0439", Jfr: "\u{1D50D}", jfr: "\u{1D527}", jmath: "\u0237", Jopf: "\u{1D541}", jopf: "\u{1D55B}", Jscr: "\u{1D4A5}", jscr: "\u{1D4BF}", Jsercy: "\u0408", jsercy: "\u0458", Jukcy: "\u0404", jukcy: "\u0454", Kappa: "\u039A", kappa: "\u03BA", kappav: "\u03F0", Kcedil: "\u0136", kcedil: "\u0137", Kcy: "\u041A", kcy: "\u043A", Kfr: "\u{1D50E}", kfr: "\u{1D528}", kgreen: "\u0138", KHcy: "\u0425", khcy: "\u0445", KJcy: "\u040C", kjcy: "\u045C", Kopf: "\u{1D542}", kopf: "\u{1D55C}", Kscr: "\u{1D4A6}", kscr: "\u{1D4C0}", lAarr: "\u21DA", Lacute: "\u0139", lacute: "\u013A", laemptyv: "\u29B4", lagran: "\u2112", Lambda: "\u039B", lambda: "\u03BB", lang: "\u27E8", Lang: "\u27EA", langd: "\u2991", langle: "\u27E8", lap: "\u2A85", Laplacetrf: "\u2112", laquo: "\xAB", larrb: "\u21E4", larrbfs: "\u291F", larr: "\u2190", Larr: "\u219E", lArr: "\u21D0", larrfs: "\u291D", larrhk: "\u21A9", larrlp: "\u21AB", larrpl: "\u2939", larrsim: "\u2973", larrtl: "\u21A2", latail: "\u2919", lAtail: "\u291B", lat: "\u2AAB", late: "\u2AAD", lates: "\u2AAD\uFE00", lbarr: "\u290C", lBarr: "\u290E", lbbrk: "\u2772", lbrace: "{", lbrack: "[", lbrke: "\u298B", lbrksld: "\u298F", lbrkslu: "\u298D", Lcaron: "\u013D", lcaron: "\u013E", Lcedil: "\u013B", lcedil: "\u013C", lceil: "\u2308", lcub: "{", Lcy: "\u041B", lcy: "\u043B", ldca: "\u2936", ldquo: "\u201C", ldquor: "\u201E", ldrdhar: "\u2967", ldrushar: "\u294B", ldsh: "\u21B2", le: "\u2264", lE: "\u2266", LeftAngleBracket: "\u27E8", LeftArrowBar: "\u21E4", leftarrow: "\u2190", LeftArrow: "\u2190", Leftarrow: "\u21D0", LeftArrowRightArrow: "\u21C6", leftarrowtail: "\u21A2", LeftCeiling: "\u2308", LeftDoubleBracket: "\u27E6", LeftDownTeeVector: "\u2961", LeftDownVectorBar: "\u2959", LeftDownVector: "\u21C3", LeftFloor: "\u230A", leftharpoondown: "\u21BD", leftharpoonup: "\u21BC", leftleftarrows: "\u21C7", leftrightarrow: "\u2194", LeftRightArrow: "\u2194", Leftrightarrow: "\u21D4", leftrightarrows: "\u21C6", leftrightharpoons: "\u21CB", leftrightsquigarrow: "\u21AD", LeftRightVector: "\u294E", LeftTeeArrow: "\u21A4", LeftTee: "\u22A3", LeftTeeVector: "\u295A", leftthreetimes: "\u22CB", LeftTriangleBar: "\u29CF", LeftTriangle: "\u22B2", LeftTriangleEqual: "\u22B4", LeftUpDownVector: "\u2951", LeftUpTeeVector: "\u2960", LeftUpVectorBar: "\u2958", LeftUpVector: "\u21BF", LeftVectorBar: "\u2952", LeftVector: "\u21BC", lEg: "\u2A8B", leg: "\u22DA", leq: "\u2264", leqq: "\u2266", leqslant: "\u2A7D", lescc: "\u2AA8", les: "\u2A7D", lesdot: "\u2A7F", lesdoto: "\u2A81", lesdotor: "\u2A83", lesg: "\u22DA\uFE00", lesges: "\u2A93", lessapprox: "\u2A85", lessdot: "\u22D6", lesseqgtr: "\u22DA", lesseqqgtr: "\u2A8B", LessEqualGreater: "\u22DA", LessFullEqual: "\u2266", LessGreater: "\u2276", lessgtr: "\u2276", LessLess: "\u2AA1", lesssim: "\u2272", LessSlantEqual: "\u2A7D", LessTilde: "\u2272", lfisht: "\u297C", lfloor: "\u230A", Lfr: "\u{1D50F}", lfr: "\u{1D529}", lg: "\u2276", lgE: "\u2A91", lHar: "\u2962", lhard: "\u21BD", lharu: "\u21BC", lharul: "\u296A", lhblk: "\u2584", LJcy: "\u0409", ljcy: "\u0459", llarr: "\u21C7", ll: "\u226A", Ll: "\u22D8", llcorner: "\u231E", Lleftarrow: "\u21DA", llhard: "\u296B", lltri: "\u25FA", Lmidot: "\u013F", lmidot: "\u0140", lmoustache: "\u23B0", lmoust: "\u23B0", lnap: "\u2A89", lnapprox: "\u2A89", lne: "\u2A87", lnE: "\u2268", lneq: "\u2A87", lneqq: "\u2268", lnsim: "\u22E6", loang: "\u27EC", loarr: "\u21FD", lobrk: "\u27E6", longleftarrow: "\u27F5", LongLeftArrow: "\u27F5", Longleftarrow: "\u27F8", longleftrightarrow: "\u27F7", LongLeftRightArrow: "\u27F7", Longleftrightarrow: "\u27FA", longmapsto: "\u27FC", longrightarrow: "\u27F6", LongRightArrow: "\u27F6", Longrightarrow: "\u27F9", looparrowleft: "\u21AB", looparrowright: "\u21AC", lopar: "\u2985", Lopf: "\u{1D543}", lopf: "\u{1D55D}", loplus: "\u2A2D", lotimes: "\u2A34", lowast: "\u2217", lowbar: "_", LowerLeftArrow: "\u2199", LowerRightArrow: "\u2198", loz: "\u25CA", lozenge: "\u25CA", lozf: "\u29EB", lpar: "(", lparlt: "\u2993", lrarr: "\u21C6", lrcorner: "\u231F", lrhar: "\u21CB", lrhard: "\u296D", lrm: "\u200E", lrtri: "\u22BF", lsaquo: "\u2039", lscr: "\u{1D4C1}", Lscr: "\u2112", lsh: "\u21B0", Lsh: "\u21B0", lsim: "\u2272", lsime: "\u2A8D", lsimg: "\u2A8F", lsqb: "[", lsquo: "\u2018", lsquor: "\u201A", Lstrok: "\u0141", lstrok: "\u0142", ltcc: "\u2AA6", ltcir: "\u2A79", lt: "<", LT: "<", Lt: "\u226A", ltdot: "\u22D6", lthree: "\u22CB", ltimes: "\u22C9", ltlarr: "\u2976", ltquest: "\u2A7B", ltri: "\u25C3", ltrie: "\u22B4", ltrif: "\u25C2", ltrPar: "\u2996", lurdshar: "\u294A", luruhar: "\u2966", lvertneqq: "\u2268\uFE00", lvnE: "\u2268\uFE00", macr: "\xAF", male: "\u2642", malt: "\u2720", maltese: "\u2720", Map: "\u2905", map: "\u21A6", mapsto: "\u21A6", mapstodown: "\u21A7", mapstoleft: "\u21A4", mapstoup: "\u21A5", marker: "\u25AE", mcomma: "\u2A29", Mcy: "\u041C", mcy: "\u043C", mdash: "\u2014", mDDot: "\u223A", measuredangle: "\u2221", MediumSpace: "\u205F", Mellintrf: "\u2133", Mfr: "\u{1D510}", mfr: "\u{1D52A}", mho: "\u2127", micro: "\xB5", midast: "*", midcir: "\u2AF0", mid: "\u2223", middot: "\xB7", minusb: "\u229F", minus: "\u2212", minusd: "\u2238", minusdu: "\u2A2A", MinusPlus: "\u2213", mlcp: "\u2ADB", mldr: "\u2026", mnplus: "\u2213", models: "\u22A7", Mopf: "\u{1D544}", mopf: "\u{1D55E}", mp: "\u2213", mscr: "\u{1D4C2}", Mscr: "\u2133", mstpos: "\u223E", Mu: "\u039C", mu: "\u03BC", multimap: "\u22B8", mumap: "\u22B8", nabla: "\u2207", Nacute: "\u0143", nacute: "\u0144", nang: "\u2220\u20D2", nap: "\u2249", napE: "\u2A70\u0338", napid: "\u224B\u0338", napos: "\u0149", napprox: "\u2249", natural: "\u266E", naturals: "\u2115", natur: "\u266E", nbsp: "\xA0", nbump: "\u224E\u0338", nbumpe: "\u224F\u0338", ncap: "\u2A43", Ncaron: "\u0147", ncaron: "\u0148", Ncedil: "\u0145", ncedil: "\u0146", ncong: "\u2247", ncongdot: "\u2A6D\u0338", ncup: "\u2A42", Ncy: "\u041D", ncy: "\u043D", ndash: "\u2013", nearhk: "\u2924", nearr: "\u2197", neArr: "\u21D7", nearrow: "\u2197", ne: "\u2260", nedot: "\u2250\u0338", NegativeMediumSpace: "\u200B", NegativeThickSpace: "\u200B", NegativeThinSpace: "\u200B", NegativeVeryThinSpace: "\u200B", nequiv: "\u2262", nesear: "\u2928", nesim: "\u2242\u0338", NestedGreaterGreater: "\u226B", NestedLessLess: "\u226A", NewLine: "\n", nexist: "\u2204", nexists: "\u2204", Nfr: "\u{1D511}", nfr: "\u{1D52B}", ngE: "\u2267\u0338", nge: "\u2271", ngeq: "\u2271", ngeqq: "\u2267\u0338", ngeqslant: "\u2A7E\u0338", nges: "\u2A7E\u0338", nGg: "\u22D9\u0338", ngsim: "\u2275", nGt: "\u226B\u20D2", ngt: "\u226F", ngtr: "\u226F", nGtv: "\u226B\u0338", nharr: "\u21AE", nhArr: "\u21CE", nhpar: "\u2AF2", ni: "\u220B", nis: "\u22FC", nisd: "\u22FA", niv: "\u220B", NJcy: "\u040A", njcy: "\u045A", nlarr: "\u219A", nlArr: "\u21CD", nldr: "\u2025", nlE: "\u2266\u0338", nle: "\u2270", nleftarrow: "\u219A", nLeftarrow: "\u21CD", nleftrightarrow: "\u21AE", nLeftrightarrow: "\u21CE", nleq: "\u2270", nleqq: "\u2266\u0338", nleqslant: "\u2A7D\u0338", nles: "\u2A7D\u0338", nless: "\u226E", nLl: "\u22D8\u0338", nlsim: "\u2274", nLt: "\u226A\u20D2", nlt: "\u226E", nltri: "\u22EA", nltrie: "\u22EC", nLtv: "\u226A\u0338", nmid: "\u2224", NoBreak: "\u2060", NonBreakingSpace: "\xA0", nopf: "\u{1D55F}", Nopf: "\u2115", Not: "\u2AEC", not: "\xAC", NotCongruent: "\u2262", NotCupCap: "\u226D", NotDoubleVerticalBar: "\u2226", NotElement: "\u2209", NotEqual: "\u2260", NotEqualTilde: "\u2242\u0338", NotExists: "\u2204", NotGreater: "\u226F", NotGreaterEqual: "\u2271", NotGreaterFullEqual: "\u2267\u0338", NotGreaterGreater: "\u226B\u0338", NotGreaterLess: "\u2279", NotGreaterSlantEqual: "\u2A7E\u0338", NotGreaterTilde: "\u2275", NotHumpDownHump: "\u224E\u0338", NotHumpEqual: "\u224F\u0338", notin: "\u2209", notindot: "\u22F5\u0338", notinE: "\u22F9\u0338", notinva: "\u2209", notinvb: "\u22F7", notinvc: "\u22F6", NotLeftTriangleBar: "\u29CF\u0338", NotLeftTriangle: "\u22EA", NotLeftTriangleEqual: "\u22EC", NotLess: "\u226E", NotLessEqual: "\u2270", NotLessGreater: "\u2278", NotLessLess: "\u226A\u0338", NotLessSlantEqual: "\u2A7D\u0338", NotLessTilde: "\u2274", NotNestedGreaterGreater: "\u2AA2\u0338", NotNestedLessLess: "\u2AA1\u0338", notni: "\u220C", notniva: "\u220C", notnivb: "\u22FE", notnivc: "\u22FD", NotPrecedes: "\u2280", NotPrecedesEqual: "\u2AAF\u0338", NotPrecedesSlantEqual: "\u22E0", NotReverseElement: "\u220C", NotRightTriangleBar: "\u29D0\u0338", NotRightTriangle: "\u22EB", NotRightTriangleEqual: "\u22ED", NotSquareSubset: "\u228F\u0338", NotSquareSubsetEqual: "\u22E2", NotSquareSuperset: "\u2290\u0338", NotSquareSupersetEqual: "\u22E3", NotSubset: "\u2282\u20D2", NotSubsetEqual: "\u2288", NotSucceeds: "\u2281", NotSucceedsEqual: "\u2AB0\u0338", NotSucceedsSlantEqual: "\u22E1", NotSucceedsTilde: "\u227F\u0338", NotSuperset: "\u2283\u20D2", NotSupersetEqual: "\u2289", NotTilde: "\u2241", NotTildeEqual: "\u2244", NotTildeFullEqual: "\u2247", NotTildeTilde: "\u2249", NotVerticalBar: "\u2224", nparallel: "\u2226", npar: "\u2226", nparsl: "\u2AFD\u20E5", npart: "\u2202\u0338", npolint: "\u2A14", npr: "\u2280", nprcue: "\u22E0", nprec: "\u2280", npreceq: "\u2AAF\u0338", npre: "\u2AAF\u0338", nrarrc: "\u2933\u0338", nrarr: "\u219B", nrArr: "\u21CF", nrarrw: "\u219D\u0338", nrightarrow: "\u219B", nRightarrow: "\u21CF", nrtri: "\u22EB", nrtrie: "\u22ED", nsc: "\u2281", nsccue: "\u22E1", nsce: "\u2AB0\u0338", Nscr: "\u{1D4A9}", nscr: "\u{1D4C3}", nshortmid: "\u2224", nshortparallel: "\u2226", nsim: "\u2241", nsime: "\u2244", nsimeq: "\u2244", nsmid: "\u2224", nspar: "\u2226", nsqsube: "\u22E2", nsqsupe: "\u22E3", nsub: "\u2284", nsubE: "\u2AC5\u0338", nsube: "\u2288", nsubset: "\u2282\u20D2", nsubseteq: "\u2288", nsubseteqq: "\u2AC5\u0338", nsucc: "\u2281", nsucceq: "\u2AB0\u0338", nsup: "\u2285", nsupE: "\u2AC6\u0338", nsupe: "\u2289", nsupset: "\u2283\u20D2", nsupseteq: "\u2289", nsupseteqq: "\u2AC6\u0338", ntgl: "\u2279", Ntilde: "\xD1", ntilde: "\xF1", ntlg: "\u2278", ntriangleleft: "\u22EA", ntrianglelefteq: "\u22EC", ntriangleright: "\u22EB", ntrianglerighteq: "\u22ED", Nu: "\u039D", nu: "\u03BD", num: "#", numero: "\u2116", numsp: "\u2007", nvap: "\u224D\u20D2", nvdash: "\u22AC", nvDash: "\u22AD", nVdash: "\u22AE", nVDash: "\u22AF", nvge: "\u2265\u20D2", nvgt: ">\u20D2", nvHarr: "\u2904", nvinfin: "\u29DE", nvlArr: "\u2902", nvle: "\u2264\u20D2", nvlt: "<\u20D2", nvltrie: "\u22B4\u20D2", nvrArr: "\u2903", nvrtrie: "\u22B5\u20D2", nvsim: "\u223C\u20D2", nwarhk: "\u2923", nwarr: "\u2196", nwArr: "\u21D6", nwarrow: "\u2196", nwnear: "\u2927", Oacute: "\xD3", oacute: "\xF3", oast: "\u229B", Ocirc: "\xD4", ocirc: "\xF4", ocir: "\u229A", Ocy: "\u041E", ocy: "\u043E", odash: "\u229D", Odblac: "\u0150", odblac: "\u0151", odiv: "\u2A38", odot: "\u2299", odsold: "\u29BC", OElig: "\u0152", oelig: "\u0153", ofcir: "\u29BF", Ofr: "\u{1D512}", ofr: "\u{1D52C}", ogon: "\u02DB", Ograve: "\xD2", ograve: "\xF2", ogt: "\u29C1", ohbar: "\u29B5", ohm: "\u03A9", oint: "\u222E", olarr: "\u21BA", olcir: "\u29BE", olcross: "\u29BB", oline: "\u203E", olt: "\u29C0", Omacr: "\u014C", omacr: "\u014D", Omega: "\u03A9", omega: "\u03C9", Omicron: "\u039F", omicron: "\u03BF", omid: "\u29B6", ominus: "\u2296", Oopf: "\u{1D546}", oopf: "\u{1D560}", opar: "\u29B7", OpenCurlyDoubleQuote: "\u201C", OpenCurlyQuote: "\u2018", operp: "\u29B9", oplus: "\u2295", orarr: "\u21BB", Or: "\u2A54", or: "\u2228", ord: "\u2A5D", order: "\u2134", orderof: "\u2134", ordf: "\xAA", ordm: "\xBA", origof: "\u22B6", oror: "\u2A56", orslope: "\u2A57", orv: "\u2A5B", oS: "\u24C8", Oscr: "\u{1D4AA}", oscr: "\u2134", Oslash: "\xD8", oslash: "\xF8", osol: "\u2298", Otilde: "\xD5", otilde: "\xF5", otimesas: "\u2A36", Otimes: "\u2A37", otimes: "\u2297", Ouml: "\xD6", ouml: "\xF6", ovbar: "\u233D", OverBar: "\u203E", OverBrace: "\u23DE", OverBracket: "\u23B4", OverParenthesis: "\u23DC", para: "\xB6", parallel: "\u2225", par: "\u2225", parsim: "\u2AF3", parsl: "\u2AFD", part: "\u2202", PartialD: "\u2202", Pcy: "\u041F", pcy: "\u043F", percnt: "%", period: ".", permil: "\u2030", perp: "\u22A5", pertenk: "\u2031", Pfr: "\u{1D513}", pfr: "\u{1D52D}", Phi: "\u03A6", phi: "\u03C6", phiv: "\u03D5", phmmat: "\u2133", phone: "\u260E", Pi: "\u03A0", pi: "\u03C0", pitchfork: "\u22D4", piv: "\u03D6", planck: "\u210F", planckh: "\u210E", plankv: "\u210F", plusacir: "\u2A23", plusb: "\u229E", pluscir: "\u2A22", plus: "+", plusdo: "\u2214", plusdu: "\u2A25", pluse: "\u2A72", PlusMinus: "\xB1", plusmn: "\xB1", plussim: "\u2A26", plustwo: "\u2A27", pm: "\xB1", Poincareplane: "\u210C", pointint: "\u2A15", popf: "\u{1D561}", Popf: "\u2119", pound: "\xA3", prap: "\u2AB7", Pr: "\u2ABB", pr: "\u227A", prcue: "\u227C", precapprox: "\u2AB7", prec: "\u227A", preccurlyeq: "\u227C", Precedes: "\u227A", PrecedesEqual: "\u2AAF", PrecedesSlantEqual: "\u227C", PrecedesTilde: "\u227E", preceq: "\u2AAF", precnapprox: "\u2AB9", precneqq: "\u2AB5", precnsim: "\u22E8", pre: "\u2AAF", prE: "\u2AB3", precsim: "\u227E", prime: "\u2032", Prime: "\u2033", primes: "\u2119", prnap: "\u2AB9", prnE: "\u2AB5", prnsim: "\u22E8", prod: "\u220F", Product: "\u220F", profalar: "\u232E", profline: "\u2312", profsurf: "\u2313", prop: "\u221D", Proportional: "\u221D", Proportion: "\u2237", propto: "\u221D", prsim: "\u227E", prurel: "\u22B0", Pscr: "\u{1D4AB}", pscr: "\u{1D4C5}", Psi: "\u03A8", psi: "\u03C8", puncsp: "\u2008", Qfr: "\u{1D514}", qfr: "\u{1D52E}", qint: "\u2A0C", qopf: "\u{1D562}", Qopf: "\u211A", qprime: "\u2057", Qscr: "\u{1D4AC}", qscr: "\u{1D4C6}", quaternions: "\u210D", quatint: "\u2A16", quest: "?", questeq: "\u225F", quot: '"', QUOT: '"', rAarr: "\u21DB", race: "\u223D\u0331", Racute: "\u0154", racute: "\u0155", radic: "\u221A", raemptyv: "\u29B3", rang: "\u27E9", Rang: "\u27EB", rangd: "\u2992", range: "\u29A5", rangle: "\u27E9", raquo: "\xBB", rarrap: "\u2975", rarrb: "\u21E5", rarrbfs: "\u2920", rarrc: "\u2933", rarr: "\u2192", Rarr: "\u21A0", rArr: "\u21D2", rarrfs: "\u291E", rarrhk: "\u21AA", rarrlp: "\u21AC", rarrpl: "\u2945", rarrsim: "\u2974", Rarrtl: "\u2916", rarrtl: "\u21A3", rarrw: "\u219D", ratail: "\u291A", rAtail: "\u291C", ratio: "\u2236", rationals: "\u211A", rbarr: "\u290D", rBarr: "\u290F", RBarr: "\u2910", rbbrk: "\u2773", rbrace: "}", rbrack: "]", rbrke: "\u298C", rbrksld: "\u298E", rbrkslu: "\u2990", Rcaron: "\u0158", rcaron: "\u0159", Rcedil: "\u0156", rcedil: "\u0157", rceil: "\u2309", rcub: "}", Rcy: "\u0420", rcy: "\u0440", rdca: "\u2937", rdldhar: "\u2969", rdquo: "\u201D", rdquor: "\u201D", rdsh: "\u21B3", real: "\u211C", realine: "\u211B", realpart: "\u211C", reals: "\u211D", Re: "\u211C", rect: "\u25AD", reg: "\xAE", REG: "\xAE", ReverseElement: "\u220B", ReverseEquilibrium: "\u21CB", ReverseUpEquilibrium: "\u296F", rfisht: "\u297D", rfloor: "\u230B", rfr: "\u{1D52F}", Rfr: "\u211C", rHar: "\u2964", rhard: "\u21C1", rharu: "\u21C0", rharul: "\u296C", Rho: "\u03A1", rho: "\u03C1", rhov: "\u03F1", RightAngleBracket: "\u27E9", RightArrowBar: "\u21E5", rightarrow: "\u2192", RightArrow: "\u2192", Rightarrow: "\u21D2", RightArrowLeftArrow: "\u21C4", rightarrowtail: "\u21A3", RightCeiling: "\u2309", RightDoubleBracket: "\u27E7", RightDownTeeVector: "\u295D", RightDownVectorBar: "\u2955", RightDownVector: "\u21C2", RightFloor: "\u230B", rightharpoondown: "\u21C1", rightharpoonup: "\u21C0", rightleftarrows: "\u21C4", rightleftharpoons: "\u21CC", rightrightarrows: "\u21C9", rightsquigarrow: "\u219D", RightTeeArrow: "\u21A6", RightTee: "\u22A2", RightTeeVector: "\u295B", rightthreetimes: "\u22CC", RightTriangleBar: "\u29D0", RightTriangle: "\u22B3", RightTriangleEqual: "\u22B5", RightUpDownVector: "\u294F", RightUpTeeVector: "\u295C", RightUpVectorBar: "\u2954", RightUpVector: "\u21BE", RightVectorBar: "\u2953", RightVector: "\u21C0", ring: "\u02DA", risingdotseq: "\u2253", rlarr: "\u21C4", rlhar: "\u21CC", rlm: "\u200F", rmoustache: "\u23B1", rmoust: "\u23B1", rnmid: "\u2AEE", roang: "\u27ED", roarr: "\u21FE", robrk: "\u27E7", ropar: "\u2986", ropf: "\u{1D563}", Ropf: "\u211D", roplus: "\u2A2E", rotimes: "\u2A35", RoundImplies: "\u2970", rpar: ")", rpargt: "\u2994", rppolint: "\u2A12", rrarr: "\u21C9", Rrightarrow: "\u21DB", rsaquo: "\u203A", rscr: "\u{1D4C7}", Rscr: "\u211B", rsh: "\u21B1", Rsh: "\u21B1", rsqb: "]", rsquo: "\u2019", rsquor: "\u2019", rthree: "\u22CC", rtimes: "\u22CA", rtri: "\u25B9", rtrie: "\u22B5", rtrif: "\u25B8", rtriltri: "\u29CE", RuleDelayed: "\u29F4", ruluhar: "\u2968", rx: "\u211E", Sacute: "\u015A", sacute: "\u015B", sbquo: "\u201A", scap: "\u2AB8", Scaron: "\u0160", scaron: "\u0161", Sc: "\u2ABC", sc: "\u227B", sccue: "\u227D", sce: "\u2AB0", scE: "\u2AB4", Scedil: "\u015E", scedil: "\u015F", Scirc: "\u015C", scirc: "\u015D", scnap: "\u2ABA", scnE: "\u2AB6", scnsim: "\u22E9", scpolint: "\u2A13", scsim: "\u227F", Scy: "\u0421", scy: "\u0441", sdotb: "\u22A1", sdot: "\u22C5", sdote: "\u2A66", searhk: "\u2925", searr: "\u2198", seArr: "\u21D8", searrow: "\u2198", sect: "\xA7", semi: ";", seswar: "\u2929", setminus: "\u2216", setmn: "\u2216", sext: "\u2736", Sfr: "\u{1D516}", sfr: "\u{1D530}", sfrown: "\u2322", sharp: "\u266F", SHCHcy: "\u0429", shchcy: "\u0449", SHcy: "\u0428", shcy: "\u0448", ShortDownArrow: "\u2193", ShortLeftArrow: "\u2190", shortmid: "\u2223", shortparallel: "\u2225", ShortRightArrow: "\u2192", ShortUpArrow: "\u2191", shy: "\xAD", Sigma: "\u03A3", sigma: "\u03C3", sigmaf: "\u03C2", sigmav: "\u03C2", sim: "\u223C", simdot: "\u2A6A", sime: "\u2243", simeq: "\u2243", simg: "\u2A9E", simgE: "\u2AA0", siml: "\u2A9D", simlE: "\u2A9F", simne: "\u2246", simplus: "\u2A24", simrarr: "\u2972", slarr: "\u2190", SmallCircle: "\u2218", smallsetminus: "\u2216", smashp: "\u2A33", smeparsl: "\u29E4", smid: "\u2223", smile: "\u2323", smt: "\u2AAA", smte: "\u2AAC", smtes: "\u2AAC\uFE00", SOFTcy: "\u042C", softcy: "\u044C", solbar: "\u233F", solb: "\u29C4", sol: "/", Sopf: "\u{1D54A}", sopf: "\u{1D564}", spades: "\u2660", spadesuit: "\u2660", spar: "\u2225", sqcap: "\u2293", sqcaps: "\u2293\uFE00", sqcup: "\u2294", sqcups: "\u2294\uFE00", Sqrt: "\u221A", sqsub: "\u228F", sqsube: "\u2291", sqsubset: "\u228F", sqsubseteq: "\u2291", sqsup: "\u2290", sqsupe: "\u2292", sqsupset: "\u2290", sqsupseteq: "\u2292", square: "\u25A1", Square: "\u25A1", SquareIntersection: "\u2293", SquareSubset: "\u228F", SquareSubsetEqual: "\u2291", SquareSuperset: "\u2290", SquareSupersetEqual: "\u2292", SquareUnion: "\u2294", squarf: "\u25AA", squ: "\u25A1", squf: "\u25AA", srarr: "\u2192", Sscr: "\u{1D4AE}", sscr: "\u{1D4C8}", ssetmn: "\u2216", ssmile: "\u2323", sstarf: "\u22C6", Star: "\u22C6", star: "\u2606", starf: "\u2605", straightepsilon: "\u03F5", straightphi: "\u03D5", strns: "\xAF", sub: "\u2282", Sub: "\u22D0", subdot: "\u2ABD", subE: "\u2AC5", sube: "\u2286", subedot: "\u2AC3", submult: "\u2AC1", subnE: "\u2ACB", subne: "\u228A", subplus: "\u2ABF", subrarr: "\u2979", subset: "\u2282", Subset: "\u22D0", subseteq: "\u2286", subseteqq: "\u2AC5", SubsetEqual: "\u2286", subsetneq: "\u228A", subsetneqq: "\u2ACB", subsim: "\u2AC7", subsub: "\u2AD5", subsup: "\u2AD3", succapprox: "\u2AB8", succ: "\u227B", succcurlyeq: "\u227D", Succeeds: "\u227B", SucceedsEqual: "\u2AB0", SucceedsSlantEqual: "\u227D", SucceedsTilde: "\u227F", succeq: "\u2AB0", succnapprox: "\u2ABA", succneqq: "\u2AB6", succnsim: "\u22E9", succsim: "\u227F", SuchThat: "\u220B", sum: "\u2211", Sum: "\u2211", sung: "\u266A", sup1: "\xB9", sup2: "\xB2", sup3: "\xB3", sup: "\u2283", Sup: "\u22D1", supdot: "\u2ABE", supdsub: "\u2AD8", supE: "\u2AC6", supe: "\u2287", supedot: "\u2AC4", Superset: "\u2283", SupersetEqual: "\u2287", suphsol: "\u27C9", suphsub: "\u2AD7", suplarr: "\u297B", supmult: "\u2AC2", supnE: "\u2ACC", supne: "\u228B", supplus: "\u2AC0", supset: "\u2283", Supset: "\u22D1", supseteq: "\u2287", supseteqq: "\u2AC6", supsetneq: "\u228B", supsetneqq: "\u2ACC", supsim: "\u2AC8", supsub: "\u2AD4", supsup: "\u2AD6", swarhk: "\u2926", swarr: "\u2199", swArr: "\u21D9", swarrow: "\u2199", swnwar: "\u292A", szlig: "\xDF", Tab: "	", target: "\u2316", Tau: "\u03A4", tau: "\u03C4", tbrk: "\u23B4", Tcaron: "\u0164", tcaron: "\u0165", Tcedil: "\u0162", tcedil: "\u0163", Tcy: "\u0422", tcy: "\u0442", tdot: "\u20DB", telrec: "\u2315", Tfr: "\u{1D517}", tfr: "\u{1D531}", there4: "\u2234", therefore: "\u2234", Therefore: "\u2234", Theta: "\u0398", theta: "\u03B8", thetasym: "\u03D1", thetav: "\u03D1", thickapprox: "\u2248", thicksim: "\u223C", ThickSpace: "\u205F\u200A", ThinSpace: "\u2009", thinsp: "\u2009", thkap: "\u2248", thksim: "\u223C", THORN: "\xDE", thorn: "\xFE", tilde: "\u02DC", Tilde: "\u223C", TildeEqual: "\u2243", TildeFullEqual: "\u2245", TildeTilde: "\u2248", timesbar: "\u2A31", timesb: "\u22A0", times: "\xD7", timesd: "\u2A30", tint: "\u222D", toea: "\u2928", topbot: "\u2336", topcir: "\u2AF1", top: "\u22A4", Topf: "\u{1D54B}", topf: "\u{1D565}", topfork: "\u2ADA", tosa: "\u2929", tprime: "\u2034", trade: "\u2122", TRADE: "\u2122", triangle: "\u25B5", triangledown: "\u25BF", triangleleft: "\u25C3", trianglelefteq: "\u22B4", triangleq: "\u225C", triangleright: "\u25B9", trianglerighteq: "\u22B5", tridot: "\u25EC", trie: "\u225C", triminus: "\u2A3A", TripleDot: "\u20DB", triplus: "\u2A39", trisb: "\u29CD", tritime: "\u2A3B", trpezium: "\u23E2", Tscr: "\u{1D4AF}", tscr: "\u{1D4C9}", TScy: "\u0426", tscy: "\u0446", TSHcy: "\u040B", tshcy: "\u045B", Tstrok: "\u0166", tstrok: "\u0167", twixt: "\u226C", twoheadleftarrow: "\u219E", twoheadrightarrow: "\u21A0", Uacute: "\xDA", uacute: "\xFA", uarr: "\u2191", Uarr: "\u219F", uArr: "\u21D1", Uarrocir: "\u2949", Ubrcy: "\u040E", ubrcy: "\u045E", Ubreve: "\u016C", ubreve: "\u016D", Ucirc: "\xDB", ucirc: "\xFB", Ucy: "\u0423", ucy: "\u0443", udarr: "\u21C5", Udblac: "\u0170", udblac: "\u0171", udhar: "\u296E", ufisht: "\u297E", Ufr: "\u{1D518}", ufr: "\u{1D532}", Ugrave: "\xD9", ugrave: "\xF9", uHar: "\u2963", uharl: "\u21BF", uharr: "\u21BE", uhblk: "\u2580", ulcorn: "\u231C", ulcorner: "\u231C", ulcrop: "\u230F", ultri: "\u25F8", Umacr: "\u016A", umacr: "\u016B", uml: "\xA8", UnderBar: "_", UnderBrace: "\u23DF", UnderBracket: "\u23B5", UnderParenthesis: "\u23DD", Union: "\u22C3", UnionPlus: "\u228E", Uogon: "\u0172", uogon: "\u0173", Uopf: "\u{1D54C}", uopf: "\u{1D566}", UpArrowBar: "\u2912", uparrow: "\u2191", UpArrow: "\u2191", Uparrow: "\u21D1", UpArrowDownArrow: "\u21C5", updownarrow: "\u2195", UpDownArrow: "\u2195", Updownarrow: "\u21D5", UpEquilibrium: "\u296E", upharpoonleft: "\u21BF", upharpoonright: "\u21BE", uplus: "\u228E", UpperLeftArrow: "\u2196", UpperRightArrow: "\u2197", upsi: "\u03C5", Upsi: "\u03D2", upsih: "\u03D2", Upsilon: "\u03A5", upsilon: "\u03C5", UpTeeArrow: "\u21A5", UpTee: "\u22A5", upuparrows: "\u21C8", urcorn: "\u231D", urcorner: "\u231D", urcrop: "\u230E", Uring: "\u016E", uring: "\u016F", urtri: "\u25F9", Uscr: "\u{1D4B0}", uscr: "\u{1D4CA}", utdot: "\u22F0", Utilde: "\u0168", utilde: "\u0169", utri: "\u25B5", utrif: "\u25B4", uuarr: "\u21C8", Uuml: "\xDC", uuml: "\xFC", uwangle: "\u29A7", vangrt: "\u299C", varepsilon: "\u03F5", varkappa: "\u03F0", varnothing: "\u2205", varphi: "\u03D5", varpi: "\u03D6", varpropto: "\u221D", varr: "\u2195", vArr: "\u21D5", varrho: "\u03F1", varsigma: "\u03C2", varsubsetneq: "\u228A\uFE00", varsubsetneqq: "\u2ACB\uFE00", varsupsetneq: "\u228B\uFE00", varsupsetneqq: "\u2ACC\uFE00", vartheta: "\u03D1", vartriangleleft: "\u22B2", vartriangleright: "\u22B3", vBar: "\u2AE8", Vbar: "\u2AEB", vBarv: "\u2AE9", Vcy: "\u0412", vcy: "\u0432", vdash: "\u22A2", vDash: "\u22A8", Vdash: "\u22A9", VDash: "\u22AB", Vdashl: "\u2AE6", veebar: "\u22BB", vee: "\u2228", Vee: "\u22C1", veeeq: "\u225A", vellip: "\u22EE", verbar: "|", Verbar: "\u2016", vert: "|", Vert: "\u2016", VerticalBar: "\u2223", VerticalLine: "|", VerticalSeparator: "\u2758", VerticalTilde: "\u2240", VeryThinSpace: "\u200A", Vfr: "\u{1D519}", vfr: "\u{1D533}", vltri: "\u22B2", vnsub: "\u2282\u20D2", vnsup: "\u2283\u20D2", Vopf: "\u{1D54D}", vopf: "\u{1D567}", vprop: "\u221D", vrtri: "\u22B3", Vscr: "\u{1D4B1}", vscr: "\u{1D4CB}", vsubnE: "\u2ACB\uFE00", vsubne: "\u228A\uFE00", vsupnE: "\u2ACC\uFE00", vsupne: "\u228B\uFE00", Vvdash: "\u22AA", vzigzag: "\u299A", Wcirc: "\u0174", wcirc: "\u0175", wedbar: "\u2A5F", wedge: "\u2227", Wedge: "\u22C0", wedgeq: "\u2259", weierp: "\u2118", Wfr: "\u{1D51A}", wfr: "\u{1D534}", Wopf: "\u{1D54E}", wopf: "\u{1D568}", wp: "\u2118", wr: "\u2240", wreath: "\u2240", Wscr: "\u{1D4B2}", wscr: "\u{1D4CC}", xcap: "\u22C2", xcirc: "\u25EF", xcup: "\u22C3", xdtri: "\u25BD", Xfr: "\u{1D51B}", xfr: "\u{1D535}", xharr: "\u27F7", xhArr: "\u27FA", Xi: "\u039E", xi: "\u03BE", xlarr: "\u27F5", xlArr: "\u27F8", xmap: "\u27FC", xnis: "\u22FB", xodot: "\u2A00", Xopf: "\u{1D54F}", xopf: "\u{1D569}", xoplus: "\u2A01", xotime: "\u2A02", xrarr: "\u27F6", xrArr: "\u27F9", Xscr: "\u{1D4B3}", xscr: "\u{1D4CD}", xsqcup: "\u2A06", xuplus: "\u2A04", xutri: "\u25B3", xvee: "\u22C1", xwedge: "\u22C0", Yacute: "\xDD", yacute: "\xFD", YAcy: "\u042F", yacy: "\u044F", Ycirc: "\u0176", ycirc: "\u0177", Ycy: "\u042B", ycy: "\u044B", yen: "\xA5", Yfr: "\u{1D51C}", yfr: "\u{1D536}", YIcy: "\u0407", yicy: "\u0457", Yopf: "\u{1D550}", yopf: "\u{1D56A}", Yscr: "\u{1D4B4}", yscr: "\u{1D4CE}", YUcy: "\u042E", yucy: "\u044E", yuml: "\xFF", Yuml: "\u0178", Zacute: "\u0179", zacute: "\u017A", Zcaron: "\u017D", zcaron: "\u017E", Zcy: "\u0417", zcy: "\u0437", Zdot: "\u017B", zdot: "\u017C", zeetrf: "\u2128", ZeroWidthSpace: "\u200B", Zeta: "\u0396", zeta: "\u03B6", zfr: "\u{1D537}", Zfr: "\u2128", ZHcy: "\u0416", zhcy: "\u0436", zigrarr: "\u21DD", zopf: "\u{1D56B}", Zopf: "\u2124", Zscr: "\u{1D4B5}", zscr: "\u{1D4CF}", zwj: "\u200D", zwnj: "\u200C" };
  }
});

// node_modules/entities/lib/maps/legacy.json
var require_legacy = __commonJS({
  "node_modules/entities/lib/maps/legacy.json"(exports2, module2) {
    module2.exports = { Aacute: "\xC1", aacute: "\xE1", Acirc: "\xC2", acirc: "\xE2", acute: "\xB4", AElig: "\xC6", aelig: "\xE6", Agrave: "\xC0", agrave: "\xE0", amp: "&", AMP: "&", Aring: "\xC5", aring: "\xE5", Atilde: "\xC3", atilde: "\xE3", Auml: "\xC4", auml: "\xE4", brvbar: "\xA6", Ccedil: "\xC7", ccedil: "\xE7", cedil: "\xB8", cent: "\xA2", copy: "\xA9", COPY: "\xA9", curren: "\xA4", deg: "\xB0", divide: "\xF7", Eacute: "\xC9", eacute: "\xE9", Ecirc: "\xCA", ecirc: "\xEA", Egrave: "\xC8", egrave: "\xE8", ETH: "\xD0", eth: "\xF0", Euml: "\xCB", euml: "\xEB", frac12: "\xBD", frac14: "\xBC", frac34: "\xBE", gt: ">", GT: ">", Iacute: "\xCD", iacute: "\xED", Icirc: "\xCE", icirc: "\xEE", iexcl: "\xA1", Igrave: "\xCC", igrave: "\xEC", iquest: "\xBF", Iuml: "\xCF", iuml: "\xEF", laquo: "\xAB", lt: "<", LT: "<", macr: "\xAF", micro: "\xB5", middot: "\xB7", nbsp: "\xA0", not: "\xAC", Ntilde: "\xD1", ntilde: "\xF1", Oacute: "\xD3", oacute: "\xF3", Ocirc: "\xD4", ocirc: "\xF4", Ograve: "\xD2", ograve: "\xF2", ordf: "\xAA", ordm: "\xBA", Oslash: "\xD8", oslash: "\xF8", Otilde: "\xD5", otilde: "\xF5", Ouml: "\xD6", ouml: "\xF6", para: "\xB6", plusmn: "\xB1", pound: "\xA3", quot: '"', QUOT: '"', raquo: "\xBB", reg: "\xAE", REG: "\xAE", sect: "\xA7", shy: "\xAD", sup1: "\xB9", sup2: "\xB2", sup3: "\xB3", szlig: "\xDF", THORN: "\xDE", thorn: "\xFE", times: "\xD7", Uacute: "\xDA", uacute: "\xFA", Ucirc: "\xDB", ucirc: "\xFB", Ugrave: "\xD9", ugrave: "\xF9", uml: "\xA8", Uuml: "\xDC", uuml: "\xFC", Yacute: "\xDD", yacute: "\xFD", yen: "\xA5", yuml: "\xFF" };
  }
});

// node_modules/entities/lib/maps/xml.json
var require_xml = __commonJS({
  "node_modules/entities/lib/maps/xml.json"(exports2, module2) {
    module2.exports = { amp: "&", apos: "'", gt: ">", lt: "<", quot: '"' };
  }
});

// node_modules/htmlparser2/lib/Tokenizer.js
var require_Tokenizer = __commonJS({
  "node_modules/htmlparser2/lib/Tokenizer.js"(exports2) {
    "use strict";
    var __importDefault = exports2 && exports2.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { "default": mod };
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    var decode_codepoint_1 = __importDefault(require_decode_codepoint());
    var entities_json_1 = __importDefault(require_entities());
    var legacy_json_1 = __importDefault(require_legacy());
    var xml_json_1 = __importDefault(require_xml());
    function whitespace(c2) {
      return c2 === " " || c2 === "\n" || c2 === "	" || c2 === "\f" || c2 === "\r";
    }
    function isASCIIAlpha(c2) {
      return c2 >= "a" && c2 <= "z" || c2 >= "A" && c2 <= "Z";
    }
    function ifElseState(upper, SUCCESS, FAILURE) {
      var lower = upper.toLowerCase();
      if (upper === lower) {
        return function(t2, c2) {
          if (c2 === lower) {
            t2._state = SUCCESS;
          } else {
            t2._state = FAILURE;
            t2._index--;
          }
        };
      }
      return function(t2, c2) {
        if (c2 === lower || c2 === upper) {
          t2._state = SUCCESS;
        } else {
          t2._state = FAILURE;
          t2._index--;
        }
      };
    }
    function consumeSpecialNameChar(upper, NEXT_STATE) {
      var lower = upper.toLowerCase();
      return function(t2, c2) {
        if (c2 === lower || c2 === upper) {
          t2._state = NEXT_STATE;
        } else {
          t2._state = 3;
          t2._index--;
        }
      };
    }
    var stateBeforeCdata1 = ifElseState("C", 24, 16);
    var stateBeforeCdata2 = ifElseState("D", 25, 16);
    var stateBeforeCdata3 = ifElseState("A", 26, 16);
    var stateBeforeCdata4 = ifElseState("T", 27, 16);
    var stateBeforeCdata5 = ifElseState("A", 28, 16);
    var stateBeforeScript1 = consumeSpecialNameChar("R", 35);
    var stateBeforeScript2 = consumeSpecialNameChar("I", 36);
    var stateBeforeScript3 = consumeSpecialNameChar("P", 37);
    var stateBeforeScript4 = consumeSpecialNameChar("T", 38);
    var stateAfterScript1 = ifElseState("R", 40, 1);
    var stateAfterScript2 = ifElseState("I", 41, 1);
    var stateAfterScript3 = ifElseState("P", 42, 1);
    var stateAfterScript4 = ifElseState("T", 43, 1);
    var stateBeforeStyle1 = consumeSpecialNameChar("Y", 45);
    var stateBeforeStyle2 = consumeSpecialNameChar("L", 46);
    var stateBeforeStyle3 = consumeSpecialNameChar("E", 47);
    var stateAfterStyle1 = ifElseState("Y", 49, 1);
    var stateAfterStyle2 = ifElseState("L", 50, 1);
    var stateAfterStyle3 = ifElseState("E", 51, 1);
    var stateBeforeSpecialT = consumeSpecialNameChar("I", 54);
    var stateBeforeTitle1 = consumeSpecialNameChar("T", 55);
    var stateBeforeTitle2 = consumeSpecialNameChar("L", 56);
    var stateBeforeTitle3 = consumeSpecialNameChar("E", 57);
    var stateAfterSpecialTEnd = ifElseState("I", 58, 1);
    var stateAfterTitle1 = ifElseState("T", 59, 1);
    var stateAfterTitle2 = ifElseState("L", 60, 1);
    var stateAfterTitle3 = ifElseState("E", 61, 1);
    var stateBeforeEntity = ifElseState("#", 63, 64);
    var stateBeforeNumericEntity = ifElseState("X", 66, 65);
    var Tokenizer = function() {
      function Tokenizer2(options, cbs) {
        var _a2;
        this._state = 1;
        this.buffer = "";
        this.sectionStart = 0;
        this._index = 0;
        this.bufferOffset = 0;
        this.baseState = 1;
        this.special = 1;
        this.running = true;
        this.ended = false;
        this.cbs = cbs;
        this.xmlMode = !!(options === null || options === void 0 ? void 0 : options.xmlMode);
        this.decodeEntities = (_a2 = options === null || options === void 0 ? void 0 : options.decodeEntities) !== null && _a2 !== void 0 ? _a2 : true;
      }
      Tokenizer2.prototype.reset = function() {
        this._state = 1;
        this.buffer = "";
        this.sectionStart = 0;
        this._index = 0;
        this.bufferOffset = 0;
        this.baseState = 1;
        this.special = 1;
        this.running = true;
        this.ended = false;
      };
      Tokenizer2.prototype.write = function(chunk) {
        if (this.ended)
          this.cbs.onerror(Error(".write() after done!"));
        this.buffer += chunk;
        this.parse();
      };
      Tokenizer2.prototype.end = function(chunk) {
        if (this.ended)
          this.cbs.onerror(Error(".end() after done!"));
        if (chunk)
          this.write(chunk);
        this.ended = true;
        if (this.running)
          this.finish();
      };
      Tokenizer2.prototype.pause = function() {
        this.running = false;
      };
      Tokenizer2.prototype.resume = function() {
        this.running = true;
        if (this._index < this.buffer.length) {
          this.parse();
        }
        if (this.ended) {
          this.finish();
        }
      };
      Tokenizer2.prototype.getAbsoluteIndex = function() {
        return this.bufferOffset + this._index;
      };
      Tokenizer2.prototype.stateText = function(c2) {
        if (c2 === "<") {
          if (this._index > this.sectionStart) {
            this.cbs.ontext(this.getSection());
          }
          this._state = 2;
          this.sectionStart = this._index;
        } else if (this.decodeEntities && c2 === "&" && (this.special === 1 || this.special === 4)) {
          if (this._index > this.sectionStart) {
            this.cbs.ontext(this.getSection());
          }
          this.baseState = 1;
          this._state = 62;
          this.sectionStart = this._index;
        }
      };
      Tokenizer2.prototype.isTagStartChar = function(c2) {
        return isASCIIAlpha(c2) || this.xmlMode && !whitespace(c2) && c2 !== "/" && c2 !== ">";
      };
      Tokenizer2.prototype.stateBeforeTagName = function(c2) {
        if (c2 === "/") {
          this._state = 5;
        } else if (c2 === "<") {
          this.cbs.ontext(this.getSection());
          this.sectionStart = this._index;
        } else if (c2 === ">" || this.special !== 1 || whitespace(c2)) {
          this._state = 1;
        } else if (c2 === "!") {
          this._state = 15;
          this.sectionStart = this._index + 1;
        } else if (c2 === "?") {
          this._state = 17;
          this.sectionStart = this._index + 1;
        } else if (!this.isTagStartChar(c2)) {
          this._state = 1;
        } else {
          this._state = !this.xmlMode && (c2 === "s" || c2 === "S") ? 32 : !this.xmlMode && (c2 === "t" || c2 === "T") ? 52 : 3;
          this.sectionStart = this._index;
        }
      };
      Tokenizer2.prototype.stateInTagName = function(c2) {
        if (c2 === "/" || c2 === ">" || whitespace(c2)) {
          this.emitToken("onopentagname");
          this._state = 8;
          this._index--;
        }
      };
      Tokenizer2.prototype.stateBeforeClosingTagName = function(c2) {
        if (whitespace(c2)) {
        } else if (c2 === ">") {
          this._state = 1;
        } else if (this.special !== 1) {
          if (this.special !== 4 && (c2 === "s" || c2 === "S")) {
            this._state = 33;
          } else if (this.special === 4 && (c2 === "t" || c2 === "T")) {
            this._state = 53;
          } else {
            this._state = 1;
            this._index--;
          }
        } else if (!this.isTagStartChar(c2)) {
          this._state = 20;
          this.sectionStart = this._index;
        } else {
          this._state = 6;
          this.sectionStart = this._index;
        }
      };
      Tokenizer2.prototype.stateInClosingTagName = function(c2) {
        if (c2 === ">" || whitespace(c2)) {
          this.emitToken("onclosetag");
          this._state = 7;
          this._index--;
        }
      };
      Tokenizer2.prototype.stateAfterClosingTagName = function(c2) {
        if (c2 === ">") {
          this._state = 1;
          this.sectionStart = this._index + 1;
        }
      };
      Tokenizer2.prototype.stateBeforeAttributeName = function(c2) {
        if (c2 === ">") {
          this.cbs.onopentagend();
          this._state = 1;
          this.sectionStart = this._index + 1;
        } else if (c2 === "/") {
          this._state = 4;
        } else if (!whitespace(c2)) {
          this._state = 9;
          this.sectionStart = this._index;
        }
      };
      Tokenizer2.prototype.stateInSelfClosingTag = function(c2) {
        if (c2 === ">") {
          this.cbs.onselfclosingtag();
          this._state = 1;
          this.sectionStart = this._index + 1;
          this.special = 1;
        } else if (!whitespace(c2)) {
          this._state = 8;
          this._index--;
        }
      };
      Tokenizer2.prototype.stateInAttributeName = function(c2) {
        if (c2 === "=" || c2 === "/" || c2 === ">" || whitespace(c2)) {
          this.cbs.onattribname(this.getSection());
          this.sectionStart = -1;
          this._state = 10;
          this._index--;
        }
      };
      Tokenizer2.prototype.stateAfterAttributeName = function(c2) {
        if (c2 === "=") {
          this._state = 11;
        } else if (c2 === "/" || c2 === ">") {
          this.cbs.onattribend(void 0);
          this._state = 8;
          this._index--;
        } else if (!whitespace(c2)) {
          this.cbs.onattribend(void 0);
          this._state = 9;
          this.sectionStart = this._index;
        }
      };
      Tokenizer2.prototype.stateBeforeAttributeValue = function(c2) {
        if (c2 === '"') {
          this._state = 12;
          this.sectionStart = this._index + 1;
        } else if (c2 === "'") {
          this._state = 13;
          this.sectionStart = this._index + 1;
        } else if (!whitespace(c2)) {
          this._state = 14;
          this.sectionStart = this._index;
          this._index--;
        }
      };
      Tokenizer2.prototype.handleInAttributeValue = function(c2, quote) {
        if (c2 === quote) {
          this.emitToken("onattribdata");
          this.cbs.onattribend(quote);
          this._state = 8;
        } else if (this.decodeEntities && c2 === "&") {
          this.emitToken("onattribdata");
          this.baseState = this._state;
          this._state = 62;
          this.sectionStart = this._index;
        }
      };
      Tokenizer2.prototype.stateInAttributeValueDoubleQuotes = function(c2) {
        this.handleInAttributeValue(c2, '"');
      };
      Tokenizer2.prototype.stateInAttributeValueSingleQuotes = function(c2) {
        this.handleInAttributeValue(c2, "'");
      };
      Tokenizer2.prototype.stateInAttributeValueNoQuotes = function(c2) {
        if (whitespace(c2) || c2 === ">") {
          this.emitToken("onattribdata");
          this.cbs.onattribend(null);
          this._state = 8;
          this._index--;
        } else if (this.decodeEntities && c2 === "&") {
          this.emitToken("onattribdata");
          this.baseState = this._state;
          this._state = 62;
          this.sectionStart = this._index;
        }
      };
      Tokenizer2.prototype.stateBeforeDeclaration = function(c2) {
        this._state = c2 === "[" ? 23 : c2 === "-" ? 18 : 16;
      };
      Tokenizer2.prototype.stateInDeclaration = function(c2) {
        if (c2 === ">") {
          this.cbs.ondeclaration(this.getSection());
          this._state = 1;
          this.sectionStart = this._index + 1;
        }
      };
      Tokenizer2.prototype.stateInProcessingInstruction = function(c2) {
        if (c2 === ">") {
          this.cbs.onprocessinginstruction(this.getSection());
          this._state = 1;
          this.sectionStart = this._index + 1;
        }
      };
      Tokenizer2.prototype.stateBeforeComment = function(c2) {
        if (c2 === "-") {
          this._state = 19;
          this.sectionStart = this._index + 1;
        } else {
          this._state = 16;
        }
      };
      Tokenizer2.prototype.stateInComment = function(c2) {
        if (c2 === "-")
          this._state = 21;
      };
      Tokenizer2.prototype.stateInSpecialComment = function(c2) {
        if (c2 === ">") {
          this.cbs.oncomment(this.buffer.substring(this.sectionStart, this._index));
          this._state = 1;
          this.sectionStart = this._index + 1;
        }
      };
      Tokenizer2.prototype.stateAfterComment1 = function(c2) {
        if (c2 === "-") {
          this._state = 22;
        } else {
          this._state = 19;
        }
      };
      Tokenizer2.prototype.stateAfterComment2 = function(c2) {
        if (c2 === ">") {
          this.cbs.oncomment(this.buffer.substring(this.sectionStart, this._index - 2));
          this._state = 1;
          this.sectionStart = this._index + 1;
        } else if (c2 !== "-") {
          this._state = 19;
        }
      };
      Tokenizer2.prototype.stateBeforeCdata6 = function(c2) {
        if (c2 === "[") {
          this._state = 29;
          this.sectionStart = this._index + 1;
        } else {
          this._state = 16;
          this._index--;
        }
      };
      Tokenizer2.prototype.stateInCdata = function(c2) {
        if (c2 === "]")
          this._state = 30;
      };
      Tokenizer2.prototype.stateAfterCdata1 = function(c2) {
        if (c2 === "]")
          this._state = 31;
        else
          this._state = 29;
      };
      Tokenizer2.prototype.stateAfterCdata2 = function(c2) {
        if (c2 === ">") {
          this.cbs.oncdata(this.buffer.substring(this.sectionStart, this._index - 2));
          this._state = 1;
          this.sectionStart = this._index + 1;
        } else if (c2 !== "]") {
          this._state = 29;
        }
      };
      Tokenizer2.prototype.stateBeforeSpecialS = function(c2) {
        if (c2 === "c" || c2 === "C") {
          this._state = 34;
        } else if (c2 === "t" || c2 === "T") {
          this._state = 44;
        } else {
          this._state = 3;
          this._index--;
        }
      };
      Tokenizer2.prototype.stateBeforeSpecialSEnd = function(c2) {
        if (this.special === 2 && (c2 === "c" || c2 === "C")) {
          this._state = 39;
        } else if (this.special === 3 && (c2 === "t" || c2 === "T")) {
          this._state = 48;
        } else
          this._state = 1;
      };
      Tokenizer2.prototype.stateBeforeSpecialLast = function(c2, special) {
        if (c2 === "/" || c2 === ">" || whitespace(c2)) {
          this.special = special;
        }
        this._state = 3;
        this._index--;
      };
      Tokenizer2.prototype.stateAfterSpecialLast = function(c2, sectionStartOffset) {
        if (c2 === ">" || whitespace(c2)) {
          this.special = 1;
          this._state = 6;
          this.sectionStart = this._index - sectionStartOffset;
          this._index--;
        } else
          this._state = 1;
      };
      Tokenizer2.prototype.parseFixedEntity = function(map2) {
        if (map2 === void 0) {
          map2 = this.xmlMode ? xml_json_1.default : entities_json_1.default;
        }
        if (this.sectionStart + 1 < this._index) {
          var entity = this.buffer.substring(this.sectionStart + 1, this._index);
          if (Object.prototype.hasOwnProperty.call(map2, entity)) {
            this.emitPartial(map2[entity]);
            this.sectionStart = this._index + 1;
          }
        }
      };
      Tokenizer2.prototype.parseLegacyEntity = function() {
        var start = this.sectionStart + 1;
        var limit = Math.min(this._index - start, 6);
        while (limit >= 2) {
          var entity = this.buffer.substr(start, limit);
          if (Object.prototype.hasOwnProperty.call(legacy_json_1.default, entity)) {
            this.emitPartial(legacy_json_1.default[entity]);
            this.sectionStart += limit + 1;
            return;
          }
          limit--;
        }
      };
      Tokenizer2.prototype.stateInNamedEntity = function(c2) {
        if (c2 === ";") {
          this.parseFixedEntity();
          if (this.baseState === 1 && this.sectionStart + 1 < this._index && !this.xmlMode) {
            this.parseLegacyEntity();
          }
          this._state = this.baseState;
        } else if ((c2 < "0" || c2 > "9") && !isASCIIAlpha(c2)) {
          if (this.xmlMode || this.sectionStart + 1 === this._index) {
          } else if (this.baseState !== 1) {
            if (c2 !== "=") {
              this.parseFixedEntity(legacy_json_1.default);
            }
          } else {
            this.parseLegacyEntity();
          }
          this._state = this.baseState;
          this._index--;
        }
      };
      Tokenizer2.prototype.decodeNumericEntity = function(offset, base, strict) {
        var sectionStart = this.sectionStart + offset;
        if (sectionStart !== this._index) {
          var entity = this.buffer.substring(sectionStart, this._index);
          var parsed = parseInt(entity, base);
          this.emitPartial(decode_codepoint_1.default(parsed));
          this.sectionStart = strict ? this._index + 1 : this._index;
        }
        this._state = this.baseState;
      };
      Tokenizer2.prototype.stateInNumericEntity = function(c2) {
        if (c2 === ";") {
          this.decodeNumericEntity(2, 10, true);
        } else if (c2 < "0" || c2 > "9") {
          if (!this.xmlMode) {
            this.decodeNumericEntity(2, 10, false);
          } else {
            this._state = this.baseState;
          }
          this._index--;
        }
      };
      Tokenizer2.prototype.stateInHexEntity = function(c2) {
        if (c2 === ";") {
          this.decodeNumericEntity(3, 16, true);
        } else if ((c2 < "a" || c2 > "f") && (c2 < "A" || c2 > "F") && (c2 < "0" || c2 > "9")) {
          if (!this.xmlMode) {
            this.decodeNumericEntity(3, 16, false);
          } else {
            this._state = this.baseState;
          }
          this._index--;
        }
      };
      Tokenizer2.prototype.cleanup = function() {
        if (this.sectionStart < 0) {
          this.buffer = "";
          this.bufferOffset += this._index;
          this._index = 0;
        } else if (this.running) {
          if (this._state === 1) {
            if (this.sectionStart !== this._index) {
              this.cbs.ontext(this.buffer.substr(this.sectionStart));
            }
            this.buffer = "";
            this.bufferOffset += this._index;
            this._index = 0;
          } else if (this.sectionStart === this._index) {
            this.buffer = "";
            this.bufferOffset += this._index;
            this._index = 0;
          } else {
            this.buffer = this.buffer.substr(this.sectionStart);
            this._index -= this.sectionStart;
            this.bufferOffset += this.sectionStart;
          }
          this.sectionStart = 0;
        }
      };
      Tokenizer2.prototype.parse = function() {
        while (this._index < this.buffer.length && this.running) {
          var c2 = this.buffer.charAt(this._index);
          if (this._state === 1) {
            this.stateText(c2);
          } else if (this._state === 12) {
            this.stateInAttributeValueDoubleQuotes(c2);
          } else if (this._state === 9) {
            this.stateInAttributeName(c2);
          } else if (this._state === 19) {
            this.stateInComment(c2);
          } else if (this._state === 20) {
            this.stateInSpecialComment(c2);
          } else if (this._state === 8) {
            this.stateBeforeAttributeName(c2);
          } else if (this._state === 3) {
            this.stateInTagName(c2);
          } else if (this._state === 6) {
            this.stateInClosingTagName(c2);
          } else if (this._state === 2) {
            this.stateBeforeTagName(c2);
          } else if (this._state === 10) {
            this.stateAfterAttributeName(c2);
          } else if (this._state === 13) {
            this.stateInAttributeValueSingleQuotes(c2);
          } else if (this._state === 11) {
            this.stateBeforeAttributeValue(c2);
          } else if (this._state === 5) {
            this.stateBeforeClosingTagName(c2);
          } else if (this._state === 7) {
            this.stateAfterClosingTagName(c2);
          } else if (this._state === 32) {
            this.stateBeforeSpecialS(c2);
          } else if (this._state === 21) {
            this.stateAfterComment1(c2);
          } else if (this._state === 14) {
            this.stateInAttributeValueNoQuotes(c2);
          } else if (this._state === 4) {
            this.stateInSelfClosingTag(c2);
          } else if (this._state === 16) {
            this.stateInDeclaration(c2);
          } else if (this._state === 15) {
            this.stateBeforeDeclaration(c2);
          } else if (this._state === 22) {
            this.stateAfterComment2(c2);
          } else if (this._state === 18) {
            this.stateBeforeComment(c2);
          } else if (this._state === 33) {
            this.stateBeforeSpecialSEnd(c2);
          } else if (this._state === 53) {
            stateAfterSpecialTEnd(this, c2);
          } else if (this._state === 39) {
            stateAfterScript1(this, c2);
          } else if (this._state === 40) {
            stateAfterScript2(this, c2);
          } else if (this._state === 41) {
            stateAfterScript3(this, c2);
          } else if (this._state === 34) {
            stateBeforeScript1(this, c2);
          } else if (this._state === 35) {
            stateBeforeScript2(this, c2);
          } else if (this._state === 36) {
            stateBeforeScript3(this, c2);
          } else if (this._state === 37) {
            stateBeforeScript4(this, c2);
          } else if (this._state === 38) {
            this.stateBeforeSpecialLast(c2, 2);
          } else if (this._state === 42) {
            stateAfterScript4(this, c2);
          } else if (this._state === 43) {
            this.stateAfterSpecialLast(c2, 6);
          } else if (this._state === 44) {
            stateBeforeStyle1(this, c2);
          } else if (this._state === 29) {
            this.stateInCdata(c2);
          } else if (this._state === 45) {
            stateBeforeStyle2(this, c2);
          } else if (this._state === 46) {
            stateBeforeStyle3(this, c2);
          } else if (this._state === 47) {
            this.stateBeforeSpecialLast(c2, 3);
          } else if (this._state === 48) {
            stateAfterStyle1(this, c2);
          } else if (this._state === 49) {
            stateAfterStyle2(this, c2);
          } else if (this._state === 50) {
            stateAfterStyle3(this, c2);
          } else if (this._state === 51) {
            this.stateAfterSpecialLast(c2, 5);
          } else if (this._state === 52) {
            stateBeforeSpecialT(this, c2);
          } else if (this._state === 54) {
            stateBeforeTitle1(this, c2);
          } else if (this._state === 55) {
            stateBeforeTitle2(this, c2);
          } else if (this._state === 56) {
            stateBeforeTitle3(this, c2);
          } else if (this._state === 57) {
            this.stateBeforeSpecialLast(c2, 4);
          } else if (this._state === 58) {
            stateAfterTitle1(this, c2);
          } else if (this._state === 59) {
            stateAfterTitle2(this, c2);
          } else if (this._state === 60) {
            stateAfterTitle3(this, c2);
          } else if (this._state === 61) {
            this.stateAfterSpecialLast(c2, 5);
          } else if (this._state === 17) {
            this.stateInProcessingInstruction(c2);
          } else if (this._state === 64) {
            this.stateInNamedEntity(c2);
          } else if (this._state === 23) {
            stateBeforeCdata1(this, c2);
          } else if (this._state === 62) {
            stateBeforeEntity(this, c2);
          } else if (this._state === 24) {
            stateBeforeCdata2(this, c2);
          } else if (this._state === 25) {
            stateBeforeCdata3(this, c2);
          } else if (this._state === 30) {
            this.stateAfterCdata1(c2);
          } else if (this._state === 31) {
            this.stateAfterCdata2(c2);
          } else if (this._state === 26) {
            stateBeforeCdata4(this, c2);
          } else if (this._state === 27) {
            stateBeforeCdata5(this, c2);
          } else if (this._state === 28) {
            this.stateBeforeCdata6(c2);
          } else if (this._state === 66) {
            this.stateInHexEntity(c2);
          } else if (this._state === 65) {
            this.stateInNumericEntity(c2);
          } else if (this._state === 63) {
            stateBeforeNumericEntity(this, c2);
          } else {
            this.cbs.onerror(Error("unknown _state"), this._state);
          }
          this._index++;
        }
        this.cleanup();
      };
      Tokenizer2.prototype.finish = function() {
        if (this.sectionStart < this._index) {
          this.handleTrailingData();
        }
        this.cbs.onend();
      };
      Tokenizer2.prototype.handleTrailingData = function() {
        var data = this.buffer.substr(this.sectionStart);
        if (this._state === 29 || this._state === 30 || this._state === 31) {
          this.cbs.oncdata(data);
        } else if (this._state === 19 || this._state === 21 || this._state === 22) {
          this.cbs.oncomment(data);
        } else if (this._state === 64 && !this.xmlMode) {
          this.parseLegacyEntity();
          if (this.sectionStart < this._index) {
            this._state = this.baseState;
            this.handleTrailingData();
          }
        } else if (this._state === 65 && !this.xmlMode) {
          this.decodeNumericEntity(2, 10, false);
          if (this.sectionStart < this._index) {
            this._state = this.baseState;
            this.handleTrailingData();
          }
        } else if (this._state === 66 && !this.xmlMode) {
          this.decodeNumericEntity(3, 16, false);
          if (this.sectionStart < this._index) {
            this._state = this.baseState;
            this.handleTrailingData();
          }
        } else if (this._state !== 3 && this._state !== 8 && this._state !== 11 && this._state !== 10 && this._state !== 9 && this._state !== 13 && this._state !== 12 && this._state !== 14 && this._state !== 6) {
          this.cbs.ontext(data);
        }
      };
      Tokenizer2.prototype.getSection = function() {
        return this.buffer.substring(this.sectionStart, this._index);
      };
      Tokenizer2.prototype.emitToken = function(name) {
        this.cbs[name](this.getSection());
        this.sectionStart = -1;
      };
      Tokenizer2.prototype.emitPartial = function(value) {
        if (this.baseState !== 1) {
          this.cbs.onattribdata(value);
        } else {
          this.cbs.ontext(value);
        }
      };
      return Tokenizer2;
    }();
    exports2.default = Tokenizer;
  }
});

// node_modules/htmlparser2/lib/Parser.js
var require_Parser = __commonJS({
  "node_modules/htmlparser2/lib/Parser.js"(exports2) {
    "use strict";
    var __importDefault = exports2 && exports2.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { "default": mod };
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.Parser = void 0;
    var Tokenizer_1 = __importDefault(require_Tokenizer());
    var formTags = /* @__PURE__ */ new Set([
      "input",
      "option",
      "optgroup",
      "select",
      "button",
      "datalist",
      "textarea"
    ]);
    var pTag = /* @__PURE__ */ new Set(["p"]);
    var openImpliesClose = {
      tr: /* @__PURE__ */ new Set(["tr", "th", "td"]),
      th: /* @__PURE__ */ new Set(["th"]),
      td: /* @__PURE__ */ new Set(["thead", "th", "td"]),
      body: /* @__PURE__ */ new Set(["head", "link", "script"]),
      li: /* @__PURE__ */ new Set(["li"]),
      p: pTag,
      h1: pTag,
      h2: pTag,
      h3: pTag,
      h4: pTag,
      h5: pTag,
      h6: pTag,
      select: formTags,
      input: formTags,
      output: formTags,
      button: formTags,
      datalist: formTags,
      textarea: formTags,
      option: /* @__PURE__ */ new Set(["option"]),
      optgroup: /* @__PURE__ */ new Set(["optgroup", "option"]),
      dd: /* @__PURE__ */ new Set(["dt", "dd"]),
      dt: /* @__PURE__ */ new Set(["dt", "dd"]),
      address: pTag,
      article: pTag,
      aside: pTag,
      blockquote: pTag,
      details: pTag,
      div: pTag,
      dl: pTag,
      fieldset: pTag,
      figcaption: pTag,
      figure: pTag,
      footer: pTag,
      form: pTag,
      header: pTag,
      hr: pTag,
      main: pTag,
      nav: pTag,
      ol: pTag,
      pre: pTag,
      section: pTag,
      table: pTag,
      ul: pTag,
      rt: /* @__PURE__ */ new Set(["rt", "rp"]),
      rp: /* @__PURE__ */ new Set(["rt", "rp"]),
      tbody: /* @__PURE__ */ new Set(["thead", "tbody"]),
      tfoot: /* @__PURE__ */ new Set(["thead", "tbody"])
    };
    var voidElements = /* @__PURE__ */ new Set([
      "area",
      "base",
      "basefont",
      "br",
      "col",
      "command",
      "embed",
      "frame",
      "hr",
      "img",
      "input",
      "isindex",
      "keygen",
      "link",
      "meta",
      "param",
      "source",
      "track",
      "wbr"
    ]);
    var foreignContextElements = /* @__PURE__ */ new Set(["math", "svg"]);
    var htmlIntegrationElements = /* @__PURE__ */ new Set([
      "mi",
      "mo",
      "mn",
      "ms",
      "mtext",
      "annotation-xml",
      "foreignObject",
      "desc",
      "title"
    ]);
    var reNameEnd = /\s|\//;
    var Parser = function() {
      function Parser2(cbs, options) {
        if (options === void 0) {
          options = {};
        }
        var _a2, _b, _c, _d, _e;
        this.startIndex = 0;
        this.endIndex = null;
        this.tagname = "";
        this.attribname = "";
        this.attribvalue = "";
        this.attribs = null;
        this.stack = [];
        this.foreignContext = [];
        this.options = options;
        this.cbs = cbs !== null && cbs !== void 0 ? cbs : {};
        this.lowerCaseTagNames = (_a2 = options.lowerCaseTags) !== null && _a2 !== void 0 ? _a2 : !options.xmlMode;
        this.lowerCaseAttributeNames = (_b = options.lowerCaseAttributeNames) !== null && _b !== void 0 ? _b : !options.xmlMode;
        this.tokenizer = new ((_c = options.Tokenizer) !== null && _c !== void 0 ? _c : Tokenizer_1.default)(this.options, this);
        (_e = (_d = this.cbs).onparserinit) === null || _e === void 0 ? void 0 : _e.call(_d, this);
      }
      Parser2.prototype.updatePosition = function(initialOffset) {
        if (this.endIndex === null) {
          if (this.tokenizer.sectionStart <= initialOffset) {
            this.startIndex = 0;
          } else {
            this.startIndex = this.tokenizer.sectionStart - initialOffset;
          }
        } else {
          this.startIndex = this.endIndex + 1;
        }
        this.endIndex = this.tokenizer.getAbsoluteIndex();
      };
      Parser2.prototype.ontext = function(data) {
        var _a2, _b;
        this.updatePosition(1);
        this.endIndex--;
        (_b = (_a2 = this.cbs).ontext) === null || _b === void 0 ? void 0 : _b.call(_a2, data);
      };
      Parser2.prototype.onopentagname = function(name) {
        var _a2, _b;
        if (this.lowerCaseTagNames) {
          name = name.toLowerCase();
        }
        this.tagname = name;
        if (!this.options.xmlMode && Object.prototype.hasOwnProperty.call(openImpliesClose, name)) {
          var el = void 0;
          while (this.stack.length > 0 && openImpliesClose[name].has(el = this.stack[this.stack.length - 1])) {
            this.onclosetag(el);
          }
        }
        if (this.options.xmlMode || !voidElements.has(name)) {
          this.stack.push(name);
          if (foreignContextElements.has(name)) {
            this.foreignContext.push(true);
          } else if (htmlIntegrationElements.has(name)) {
            this.foreignContext.push(false);
          }
        }
        (_b = (_a2 = this.cbs).onopentagname) === null || _b === void 0 ? void 0 : _b.call(_a2, name);
        if (this.cbs.onopentag)
          this.attribs = {};
      };
      Parser2.prototype.onopentagend = function() {
        var _a2, _b;
        this.updatePosition(1);
        if (this.attribs) {
          (_b = (_a2 = this.cbs).onopentag) === null || _b === void 0 ? void 0 : _b.call(_a2, this.tagname, this.attribs);
          this.attribs = null;
        }
        if (!this.options.xmlMode && this.cbs.onclosetag && voidElements.has(this.tagname)) {
          this.cbs.onclosetag(this.tagname);
        }
        this.tagname = "";
      };
      Parser2.prototype.onclosetag = function(name) {
        this.updatePosition(1);
        if (this.lowerCaseTagNames) {
          name = name.toLowerCase();
        }
        if (foreignContextElements.has(name) || htmlIntegrationElements.has(name)) {
          this.foreignContext.pop();
        }
        if (this.stack.length && (this.options.xmlMode || !voidElements.has(name))) {
          var pos = this.stack.lastIndexOf(name);
          if (pos !== -1) {
            if (this.cbs.onclosetag) {
              pos = this.stack.length - pos;
              while (pos--) {
                this.cbs.onclosetag(this.stack.pop());
              }
            } else
              this.stack.length = pos;
          } else if (name === "p" && !this.options.xmlMode) {
            this.onopentagname(name);
            this.closeCurrentTag();
          }
        } else if (!this.options.xmlMode && (name === "br" || name === "p")) {
          this.onopentagname(name);
          this.closeCurrentTag();
        }
      };
      Parser2.prototype.onselfclosingtag = function() {
        if (this.options.xmlMode || this.options.recognizeSelfClosing || this.foreignContext[this.foreignContext.length - 1]) {
          this.closeCurrentTag();
        } else {
          this.onopentagend();
        }
      };
      Parser2.prototype.closeCurrentTag = function() {
        var _a2, _b;
        var name = this.tagname;
        this.onopentagend();
        if (this.stack[this.stack.length - 1] === name) {
          (_b = (_a2 = this.cbs).onclosetag) === null || _b === void 0 ? void 0 : _b.call(_a2, name);
          this.stack.pop();
        }
      };
      Parser2.prototype.onattribname = function(name) {
        if (this.lowerCaseAttributeNames) {
          name = name.toLowerCase();
        }
        this.attribname = name;
      };
      Parser2.prototype.onattribdata = function(value) {
        this.attribvalue += value;
      };
      Parser2.prototype.onattribend = function(quote) {
        var _a2, _b;
        (_b = (_a2 = this.cbs).onattribute) === null || _b === void 0 ? void 0 : _b.call(_a2, this.attribname, this.attribvalue, quote);
        if (this.attribs && !Object.prototype.hasOwnProperty.call(this.attribs, this.attribname)) {
          this.attribs[this.attribname] = this.attribvalue;
        }
        this.attribname = "";
        this.attribvalue = "";
      };
      Parser2.prototype.getInstructionName = function(value) {
        var idx = value.search(reNameEnd);
        var name = idx < 0 ? value : value.substr(0, idx);
        if (this.lowerCaseTagNames) {
          name = name.toLowerCase();
        }
        return name;
      };
      Parser2.prototype.ondeclaration = function(value) {
        if (this.cbs.onprocessinginstruction) {
          var name_1 = this.getInstructionName(value);
          this.cbs.onprocessinginstruction("!" + name_1, "!" + value);
        }
      };
      Parser2.prototype.onprocessinginstruction = function(value) {
        if (this.cbs.onprocessinginstruction) {
          var name_2 = this.getInstructionName(value);
          this.cbs.onprocessinginstruction("?" + name_2, "?" + value);
        }
      };
      Parser2.prototype.oncomment = function(value) {
        var _a2, _b, _c, _d;
        this.updatePosition(4);
        (_b = (_a2 = this.cbs).oncomment) === null || _b === void 0 ? void 0 : _b.call(_a2, value);
        (_d = (_c = this.cbs).oncommentend) === null || _d === void 0 ? void 0 : _d.call(_c);
      };
      Parser2.prototype.oncdata = function(value) {
        var _a2, _b, _c, _d, _e, _f;
        this.updatePosition(1);
        if (this.options.xmlMode || this.options.recognizeCDATA) {
          (_b = (_a2 = this.cbs).oncdatastart) === null || _b === void 0 ? void 0 : _b.call(_a2);
          (_d = (_c = this.cbs).ontext) === null || _d === void 0 ? void 0 : _d.call(_c, value);
          (_f = (_e = this.cbs).oncdataend) === null || _f === void 0 ? void 0 : _f.call(_e);
        } else {
          this.oncomment("[CDATA[" + value + "]]");
        }
      };
      Parser2.prototype.onerror = function(err2) {
        var _a2, _b;
        (_b = (_a2 = this.cbs).onerror) === null || _b === void 0 ? void 0 : _b.call(_a2, err2);
      };
      Parser2.prototype.onend = function() {
        var _a2, _b;
        if (this.cbs.onclosetag) {
          for (var i3 = this.stack.length; i3 > 0; this.cbs.onclosetag(this.stack[--i3]))
            ;
        }
        (_b = (_a2 = this.cbs).onend) === null || _b === void 0 ? void 0 : _b.call(_a2);
      };
      Parser2.prototype.reset = function() {
        var _a2, _b, _c, _d;
        (_b = (_a2 = this.cbs).onreset) === null || _b === void 0 ? void 0 : _b.call(_a2);
        this.tokenizer.reset();
        this.tagname = "";
        this.attribname = "";
        this.attribs = null;
        this.stack = [];
        (_d = (_c = this.cbs).onparserinit) === null || _d === void 0 ? void 0 : _d.call(_c, this);
      };
      Parser2.prototype.parseComplete = function(data) {
        this.reset();
        this.end(data);
      };
      Parser2.prototype.write = function(chunk) {
        this.tokenizer.write(chunk);
      };
      Parser2.prototype.end = function(chunk) {
        this.tokenizer.end(chunk);
      };
      Parser2.prototype.pause = function() {
        this.tokenizer.pause();
      };
      Parser2.prototype.resume = function() {
        this.tokenizer.resume();
      };
      Parser2.prototype.parseChunk = function(chunk) {
        this.write(chunk);
      };
      Parser2.prototype.done = function(chunk) {
        this.end(chunk);
      };
      return Parser2;
    }();
    exports2.Parser = Parser;
  }
});

// node_modules/domelementtype/lib/index.js
var require_lib5 = __commonJS({
  "node_modules/domelementtype/lib/index.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.Doctype = exports2.CDATA = exports2.Tag = exports2.Style = exports2.Script = exports2.Comment = exports2.Directive = exports2.Text = exports2.Root = exports2.isTag = exports2.ElementType = void 0;
    var ElementType;
    (function(ElementType2) {
      ElementType2["Root"] = "root";
      ElementType2["Text"] = "text";
      ElementType2["Directive"] = "directive";
      ElementType2["Comment"] = "comment";
      ElementType2["Script"] = "script";
      ElementType2["Style"] = "style";
      ElementType2["Tag"] = "tag";
      ElementType2["CDATA"] = "cdata";
      ElementType2["Doctype"] = "doctype";
    })(ElementType = exports2.ElementType || (exports2.ElementType = {}));
    function isTag(elem) {
      return elem.type === ElementType.Tag || elem.type === ElementType.Script || elem.type === ElementType.Style;
    }
    exports2.isTag = isTag;
    exports2.Root = ElementType.Root;
    exports2.Text = ElementType.Text;
    exports2.Directive = ElementType.Directive;
    exports2.Comment = ElementType.Comment;
    exports2.Script = ElementType.Script;
    exports2.Style = ElementType.Style;
    exports2.Tag = ElementType.Tag;
    exports2.CDATA = ElementType.CDATA;
    exports2.Doctype = ElementType.Doctype;
  }
});

// node_modules/domhandler/lib/node.js
var require_node = __commonJS({
  "node_modules/domhandler/lib/node.js"(exports2) {
    "use strict";
    var __extends2 = exports2 && exports2.__extends || function() {
      var extendStatics = function(d, b2) {
        extendStatics = Object.setPrototypeOf || { __proto__: [] } instanceof Array && function(d2, b3) {
          d2.__proto__ = b3;
        } || function(d2, b3) {
          for (var p in b3)
            if (Object.prototype.hasOwnProperty.call(b3, p))
              d2[p] = b3[p];
        };
        return extendStatics(d, b2);
      };
      return function(d, b2) {
        if (typeof b2 !== "function" && b2 !== null)
          throw new TypeError("Class extends value " + String(b2) + " is not a constructor or null");
        extendStatics(d, b2);
        function __() {
          this.constructor = d;
        }
        d.prototype = b2 === null ? Object.create(b2) : (__.prototype = b2.prototype, new __());
      };
    }();
    var __assign = exports2 && exports2.__assign || function() {
      __assign = Object.assign || function(t2) {
        for (var s2, i3 = 1, n2 = arguments.length; i3 < n2; i3++) {
          s2 = arguments[i3];
          for (var p in s2)
            if (Object.prototype.hasOwnProperty.call(s2, p))
              t2[p] = s2[p];
        }
        return t2;
      };
      return __assign.apply(this, arguments);
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.cloneNode = exports2.hasChildren = exports2.isDocument = exports2.isDirective = exports2.isComment = exports2.isText = exports2.isCDATA = exports2.isTag = exports2.Element = exports2.Document = exports2.NodeWithChildren = exports2.ProcessingInstruction = exports2.Comment = exports2.Text = exports2.DataNode = exports2.Node = void 0;
    var domelementtype_1 = require_lib5();
    var nodeTypes = /* @__PURE__ */ new Map([
      [domelementtype_1.ElementType.Tag, 1],
      [domelementtype_1.ElementType.Script, 1],
      [domelementtype_1.ElementType.Style, 1],
      [domelementtype_1.ElementType.Directive, 1],
      [domelementtype_1.ElementType.Text, 3],
      [domelementtype_1.ElementType.CDATA, 4],
      [domelementtype_1.ElementType.Comment, 8],
      [domelementtype_1.ElementType.Root, 9]
    ]);
    var Node2 = function() {
      function Node3(type3) {
        this.type = type3;
        this.parent = null;
        this.prev = null;
        this.next = null;
        this.startIndex = null;
        this.endIndex = null;
      }
      Object.defineProperty(Node3.prototype, "nodeType", {
        get: function() {
          var _a2;
          return (_a2 = nodeTypes.get(this.type)) !== null && _a2 !== void 0 ? _a2 : 1;
        },
        enumerable: false,
        configurable: true
      });
      Object.defineProperty(Node3.prototype, "parentNode", {
        get: function() {
          return this.parent;
        },
        set: function(parent) {
          this.parent = parent;
        },
        enumerable: false,
        configurable: true
      });
      Object.defineProperty(Node3.prototype, "previousSibling", {
        get: function() {
          return this.prev;
        },
        set: function(prev) {
          this.prev = prev;
        },
        enumerable: false,
        configurable: true
      });
      Object.defineProperty(Node3.prototype, "nextSibling", {
        get: function() {
          return this.next;
        },
        set: function(next) {
          this.next = next;
        },
        enumerable: false,
        configurable: true
      });
      Node3.prototype.cloneNode = function(recursive) {
        if (recursive === void 0) {
          recursive = false;
        }
        return cloneNode(this, recursive);
      };
      return Node3;
    }();
    exports2.Node = Node2;
    var DataNode = function(_super) {
      __extends2(DataNode2, _super);
      function DataNode2(type3, data) {
        var _this = _super.call(this, type3) || this;
        _this.data = data;
        return _this;
      }
      Object.defineProperty(DataNode2.prototype, "nodeValue", {
        get: function() {
          return this.data;
        },
        set: function(data) {
          this.data = data;
        },
        enumerable: false,
        configurable: true
      });
      return DataNode2;
    }(Node2);
    exports2.DataNode = DataNode;
    var Text4 = function(_super) {
      __extends2(Text5, _super);
      function Text5(data) {
        return _super.call(this, domelementtype_1.ElementType.Text, data) || this;
      }
      return Text5;
    }(DataNode);
    exports2.Text = Text4;
    var Comment = function(_super) {
      __extends2(Comment2, _super);
      function Comment2(data) {
        return _super.call(this, domelementtype_1.ElementType.Comment, data) || this;
      }
      return Comment2;
    }(DataNode);
    exports2.Comment = Comment;
    var ProcessingInstruction = function(_super) {
      __extends2(ProcessingInstruction2, _super);
      function ProcessingInstruction2(name, data) {
        var _this = _super.call(this, domelementtype_1.ElementType.Directive, data) || this;
        _this.name = name;
        return _this;
      }
      return ProcessingInstruction2;
    }(DataNode);
    exports2.ProcessingInstruction = ProcessingInstruction;
    var NodeWithChildren = function(_super) {
      __extends2(NodeWithChildren2, _super);
      function NodeWithChildren2(type3, children) {
        var _this = _super.call(this, type3) || this;
        _this.children = children;
        return _this;
      }
      Object.defineProperty(NodeWithChildren2.prototype, "firstChild", {
        get: function() {
          var _a2;
          return (_a2 = this.children[0]) !== null && _a2 !== void 0 ? _a2 : null;
        },
        enumerable: false,
        configurable: true
      });
      Object.defineProperty(NodeWithChildren2.prototype, "lastChild", {
        get: function() {
          return this.children.length > 0 ? this.children[this.children.length - 1] : null;
        },
        enumerable: false,
        configurable: true
      });
      Object.defineProperty(NodeWithChildren2.prototype, "childNodes", {
        get: function() {
          return this.children;
        },
        set: function(children) {
          this.children = children;
        },
        enumerable: false,
        configurable: true
      });
      return NodeWithChildren2;
    }(Node2);
    exports2.NodeWithChildren = NodeWithChildren;
    var Document = function(_super) {
      __extends2(Document2, _super);
      function Document2(children) {
        return _super.call(this, domelementtype_1.ElementType.Root, children) || this;
      }
      return Document2;
    }(NodeWithChildren);
    exports2.Document = Document;
    var Element2 = function(_super) {
      __extends2(Element3, _super);
      function Element3(name, attribs, children, type3) {
        if (children === void 0) {
          children = [];
        }
        if (type3 === void 0) {
          type3 = name === "script" ? domelementtype_1.ElementType.Script : name === "style" ? domelementtype_1.ElementType.Style : domelementtype_1.ElementType.Tag;
        }
        var _this = _super.call(this, type3, children) || this;
        _this.name = name;
        _this.attribs = attribs;
        return _this;
      }
      Object.defineProperty(Element3.prototype, "tagName", {
        get: function() {
          return this.name;
        },
        set: function(name) {
          this.name = name;
        },
        enumerable: false,
        configurable: true
      });
      Object.defineProperty(Element3.prototype, "attributes", {
        get: function() {
          var _this = this;
          return Object.keys(this.attribs).map(function(name) {
            var _a2, _b;
            return {
              name,
              value: _this.attribs[name],
              namespace: (_a2 = _this["x-attribsNamespace"]) === null || _a2 === void 0 ? void 0 : _a2[name],
              prefix: (_b = _this["x-attribsPrefix"]) === null || _b === void 0 ? void 0 : _b[name]
            };
          });
        },
        enumerable: false,
        configurable: true
      });
      return Element3;
    }(NodeWithChildren);
    exports2.Element = Element2;
    function isTag(node) {
      return (0, domelementtype_1.isTag)(node);
    }
    exports2.isTag = isTag;
    function isCDATA(node) {
      return node.type === domelementtype_1.ElementType.CDATA;
    }
    exports2.isCDATA = isCDATA;
    function isText(node) {
      return node.type === domelementtype_1.ElementType.Text;
    }
    exports2.isText = isText;
    function isComment(node) {
      return node.type === domelementtype_1.ElementType.Comment;
    }
    exports2.isComment = isComment;
    function isDirective(node) {
      return node.type === domelementtype_1.ElementType.Directive;
    }
    exports2.isDirective = isDirective;
    function isDocument(node) {
      return node.type === domelementtype_1.ElementType.Root;
    }
    exports2.isDocument = isDocument;
    function hasChildren(node) {
      return Object.prototype.hasOwnProperty.call(node, "children");
    }
    exports2.hasChildren = hasChildren;
    function cloneNode(node, recursive) {
      if (recursive === void 0) {
        recursive = false;
      }
      var result2;
      if (isText(node)) {
        result2 = new Text4(node.data);
      } else if (isComment(node)) {
        result2 = new Comment(node.data);
      } else if (isTag(node)) {
        var children = recursive ? cloneChildren(node.children) : [];
        var clone_1 = new Element2(node.name, __assign({}, node.attribs), children);
        children.forEach(function(child) {
          return child.parent = clone_1;
        });
        if (node["x-attribsNamespace"]) {
          clone_1["x-attribsNamespace"] = __assign({}, node["x-attribsNamespace"]);
        }
        if (node["x-attribsPrefix"]) {
          clone_1["x-attribsPrefix"] = __assign({}, node["x-attribsPrefix"]);
        }
        result2 = clone_1;
      } else if (isCDATA(node)) {
        var children = recursive ? cloneChildren(node.children) : [];
        var clone_2 = new NodeWithChildren(domelementtype_1.ElementType.CDATA, children);
        children.forEach(function(child) {
          return child.parent = clone_2;
        });
        result2 = clone_2;
      } else if (isDocument(node)) {
        var children = recursive ? cloneChildren(node.children) : [];
        var clone_3 = new Document(children);
        children.forEach(function(child) {
          return child.parent = clone_3;
        });
        if (node["x-mode"]) {
          clone_3["x-mode"] = node["x-mode"];
        }
        result2 = clone_3;
      } else if (isDirective(node)) {
        var instruction = new ProcessingInstruction(node.name, node.data);
        if (node["x-name"] != null) {
          instruction["x-name"] = node["x-name"];
          instruction["x-publicId"] = node["x-publicId"];
          instruction["x-systemId"] = node["x-systemId"];
        }
        result2 = instruction;
      } else {
        throw new Error("Not implemented yet: " + node.type);
      }
      result2.startIndex = node.startIndex;
      result2.endIndex = node.endIndex;
      return result2;
    }
    exports2.cloneNode = cloneNode;
    function cloneChildren(childs) {
      var children = childs.map(function(child) {
        return cloneNode(child, true);
      });
      for (var i3 = 1; i3 < children.length; i3++) {
        children[i3].prev = children[i3 - 1];
        children[i3 - 1].next = children[i3];
      }
      return children;
    }
  }
});

// node_modules/domhandler/lib/index.js
var require_lib6 = __commonJS({
  "node_modules/domhandler/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o2, m, k, k2) {
      if (k2 === void 0)
        k2 = k;
      Object.defineProperty(o2, k2, { enumerable: true, get: function() {
        return m[k];
      } });
    } : function(o2, m, k, k2) {
      if (k2 === void 0)
        k2 = k;
      o2[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports3) {
      for (var p in m)
        if (p !== "default" && !Object.prototype.hasOwnProperty.call(exports3, p))
          __createBinding(exports3, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.DomHandler = void 0;
    var domelementtype_1 = require_lib5();
    var node_1 = require_node();
    __exportStar(require_node(), exports2);
    var reWhitespace = /\s+/g;
    var defaultOpts = {
      normalizeWhitespace: false,
      withStartIndices: false,
      withEndIndices: false,
      xmlMode: false
    };
    var DomHandler = function() {
      function DomHandler2(callback, options, elementCB) {
        this.dom = [];
        this.root = new node_1.Document(this.dom);
        this.done = false;
        this.tagStack = [this.root];
        this.lastNode = null;
        this.parser = null;
        if (typeof options === "function") {
          elementCB = options;
          options = defaultOpts;
        }
        if (typeof callback === "object") {
          options = callback;
          callback = void 0;
        }
        this.callback = callback !== null && callback !== void 0 ? callback : null;
        this.options = options !== null && options !== void 0 ? options : defaultOpts;
        this.elementCB = elementCB !== null && elementCB !== void 0 ? elementCB : null;
      }
      DomHandler2.prototype.onparserinit = function(parser) {
        this.parser = parser;
      };
      DomHandler2.prototype.onreset = function() {
        this.dom = [];
        this.root = new node_1.Document(this.dom);
        this.done = false;
        this.tagStack = [this.root];
        this.lastNode = null;
        this.parser = null;
      };
      DomHandler2.prototype.onend = function() {
        if (this.done)
          return;
        this.done = true;
        this.parser = null;
        this.handleCallback(null);
      };
      DomHandler2.prototype.onerror = function(error) {
        this.handleCallback(error);
      };
      DomHandler2.prototype.onclosetag = function() {
        this.lastNode = null;
        var elem = this.tagStack.pop();
        if (this.options.withEndIndices) {
          elem.endIndex = this.parser.endIndex;
        }
        if (this.elementCB)
          this.elementCB(elem);
      };
      DomHandler2.prototype.onopentag = function(name, attribs) {
        var type3 = this.options.xmlMode ? domelementtype_1.ElementType.Tag : void 0;
        var element = new node_1.Element(name, attribs, void 0, type3);
        this.addNode(element);
        this.tagStack.push(element);
      };
      DomHandler2.prototype.ontext = function(data) {
        var normalizeWhitespace = this.options.normalizeWhitespace;
        var lastNode = this.lastNode;
        if (lastNode && lastNode.type === domelementtype_1.ElementType.Text) {
          if (normalizeWhitespace) {
            lastNode.data = (lastNode.data + data).replace(reWhitespace, " ");
          } else {
            lastNode.data += data;
          }
          if (this.options.withEndIndices) {
            lastNode.endIndex = this.parser.endIndex;
          }
        } else {
          if (normalizeWhitespace) {
            data = data.replace(reWhitespace, " ");
          }
          var node = new node_1.Text(data);
          this.addNode(node);
          this.lastNode = node;
        }
      };
      DomHandler2.prototype.oncomment = function(data) {
        if (this.lastNode && this.lastNode.type === domelementtype_1.ElementType.Comment) {
          this.lastNode.data += data;
          return;
        }
        var node = new node_1.Comment(data);
        this.addNode(node);
        this.lastNode = node;
      };
      DomHandler2.prototype.oncommentend = function() {
        this.lastNode = null;
      };
      DomHandler2.prototype.oncdatastart = function() {
        var text = new node_1.Text("");
        var node = new node_1.NodeWithChildren(domelementtype_1.ElementType.CDATA, [text]);
        this.addNode(node);
        text.parent = node;
        this.lastNode = text;
      };
      DomHandler2.prototype.oncdataend = function() {
        this.lastNode = null;
      };
      DomHandler2.prototype.onprocessinginstruction = function(name, data) {
        var node = new node_1.ProcessingInstruction(name, data);
        this.addNode(node);
      };
      DomHandler2.prototype.handleCallback = function(error) {
        if (typeof this.callback === "function") {
          this.callback(error, this.dom);
        } else if (error) {
          throw error;
        }
      };
      DomHandler2.prototype.addNode = function(node) {
        var parent = this.tagStack[this.tagStack.length - 1];
        var previousSibling = parent.children[parent.children.length - 1];
        if (this.options.withStartIndices) {
          node.startIndex = this.parser.startIndex;
        }
        if (this.options.withEndIndices) {
          node.endIndex = this.parser.endIndex;
        }
        parent.children.push(node);
        if (previousSibling) {
          node.prev = previousSibling;
          previousSibling.next = node;
        }
        node.parent = parent;
        this.lastNode = null;
      };
      return DomHandler2;
    }();
    exports2.DomHandler = DomHandler;
    exports2.default = DomHandler;
  }
});

// node_modules/entities/lib/decode.js
var require_decode2 = __commonJS({
  "node_modules/entities/lib/decode.js"(exports2) {
    "use strict";
    var __importDefault = exports2 && exports2.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { "default": mod };
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.decodeHTML = exports2.decodeHTMLStrict = exports2.decodeXML = void 0;
    var entities_json_1 = __importDefault(require_entities());
    var legacy_json_1 = __importDefault(require_legacy());
    var xml_json_1 = __importDefault(require_xml());
    var decode_codepoint_1 = __importDefault(require_decode_codepoint());
    var strictEntityRe = /&(?:[a-zA-Z0-9]+|#[xX][\da-fA-F]+|#\d+);/g;
    exports2.decodeXML = getStrictDecoder(xml_json_1.default);
    exports2.decodeHTMLStrict = getStrictDecoder(entities_json_1.default);
    function getStrictDecoder(map2) {
      var replace = getReplacer(map2);
      return function(str2) {
        return String(str2).replace(strictEntityRe, replace);
      };
    }
    var sorter = function(a2, b2) {
      return a2 < b2 ? 1 : -1;
    };
    exports2.decodeHTML = function() {
      var legacy = Object.keys(legacy_json_1.default).sort(sorter);
      var keys = Object.keys(entities_json_1.default).sort(sorter);
      for (var i3 = 0, j = 0; i3 < keys.length; i3++) {
        if (legacy[j] === keys[i3]) {
          keys[i3] += ";?";
          j++;
        } else {
          keys[i3] += ";";
        }
      }
      var re = new RegExp("&(?:" + keys.join("|") + "|#[xX][\\da-fA-F]+;?|#\\d+;?)", "g");
      var replace = getReplacer(entities_json_1.default);
      function replacer(str2) {
        if (str2.substr(-1) !== ";")
          str2 += ";";
        return replace(str2);
      }
      return function(str2) {
        return String(str2).replace(re, replacer);
      };
    }();
    function getReplacer(map2) {
      return function replace(str2) {
        if (str2.charAt(1) === "#") {
          var secondChar = str2.charAt(2);
          if (secondChar === "X" || secondChar === "x") {
            return decode_codepoint_1.default(parseInt(str2.substr(3), 16));
          }
          return decode_codepoint_1.default(parseInt(str2.substr(2), 10));
        }
        return map2[str2.slice(1, -1)] || str2;
      };
    }
  }
});

// node_modules/entities/lib/encode.js
var require_encode = __commonJS({
  "node_modules/entities/lib/encode.js"(exports2) {
    "use strict";
    var __importDefault = exports2 && exports2.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { "default": mod };
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.escapeUTF8 = exports2.escape = exports2.encodeNonAsciiHTML = exports2.encodeHTML = exports2.encodeXML = void 0;
    var xml_json_1 = __importDefault(require_xml());
    var inverseXML = getInverseObj(xml_json_1.default);
    var xmlReplacer = getInverseReplacer(inverseXML);
    exports2.encodeXML = getASCIIEncoder(inverseXML);
    var entities_json_1 = __importDefault(require_entities());
    var inverseHTML = getInverseObj(entities_json_1.default);
    var htmlReplacer = getInverseReplacer(inverseHTML);
    exports2.encodeHTML = getInverse(inverseHTML, htmlReplacer);
    exports2.encodeNonAsciiHTML = getASCIIEncoder(inverseHTML);
    function getInverseObj(obj) {
      return Object.keys(obj).sort().reduce(function(inverse, name) {
        inverse[obj[name]] = "&" + name + ";";
        return inverse;
      }, {});
    }
    function getInverseReplacer(inverse) {
      var single = [];
      var multiple = [];
      for (var _i = 0, _a2 = Object.keys(inverse); _i < _a2.length; _i++) {
        var k = _a2[_i];
        if (k.length === 1) {
          single.push("\\" + k);
        } else {
          multiple.push(k);
        }
      }
      single.sort();
      for (var start = 0; start < single.length - 1; start++) {
        var end = start;
        while (end < single.length - 1 && single[end].charCodeAt(1) + 1 === single[end + 1].charCodeAt(1)) {
          end += 1;
        }
        var count = 1 + end - start;
        if (count < 3)
          continue;
        single.splice(start, count, single[start] + "-" + single[end]);
      }
      multiple.unshift("[" + single.join("") + "]");
      return new RegExp(multiple.join("|"), "g");
    }
    var reNonASCII = /(?:[\x80-\uD7FF\uE000-\uFFFF]|[\uD800-\uDBFF][\uDC00-\uDFFF]|[\uD800-\uDBFF](?![\uDC00-\uDFFF])|(?:[^\uD800-\uDBFF]|^)[\uDC00-\uDFFF])/g;
    var getCodePoint = String.prototype.codePointAt != null ? function(str2) {
      return str2.codePointAt(0);
    } : function(c2) {
      return (c2.charCodeAt(0) - 55296) * 1024 + c2.charCodeAt(1) - 56320 + 65536;
    };
    function singleCharReplacer(c2) {
      return "&#x" + (c2.length > 1 ? getCodePoint(c2) : c2.charCodeAt(0)).toString(16).toUpperCase() + ";";
    }
    function getInverse(inverse, re) {
      return function(data) {
        return data.replace(re, function(name) {
          return inverse[name];
        }).replace(reNonASCII, singleCharReplacer);
      };
    }
    var reEscapeChars = new RegExp(xmlReplacer.source + "|" + reNonASCII.source, "g");
    function escape(data) {
      return data.replace(reEscapeChars, singleCharReplacer);
    }
    exports2.escape = escape;
    function escapeUTF8(data) {
      return data.replace(xmlReplacer, singleCharReplacer);
    }
    exports2.escapeUTF8 = escapeUTF8;
    function getASCIIEncoder(obj) {
      return function(data) {
        return data.replace(reEscapeChars, function(c2) {
          return obj[c2] || singleCharReplacer(c2);
        });
      };
    }
  }
});

// node_modules/entities/lib/index.js
var require_lib7 = __commonJS({
  "node_modules/entities/lib/index.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.decodeXMLStrict = exports2.decodeHTML5Strict = exports2.decodeHTML4Strict = exports2.decodeHTML5 = exports2.decodeHTML4 = exports2.decodeHTMLStrict = exports2.decodeHTML = exports2.decodeXML = exports2.encodeHTML5 = exports2.encodeHTML4 = exports2.escapeUTF8 = exports2.escape = exports2.encodeNonAsciiHTML = exports2.encodeHTML = exports2.encodeXML = exports2.encode = exports2.decodeStrict = exports2.decode = void 0;
    var decode_1 = require_decode2();
    var encode_1 = require_encode();
    function decode(data, level) {
      return (!level || level <= 0 ? decode_1.decodeXML : decode_1.decodeHTML)(data);
    }
    exports2.decode = decode;
    function decodeStrict(data, level) {
      return (!level || level <= 0 ? decode_1.decodeXML : decode_1.decodeHTMLStrict)(data);
    }
    exports2.decodeStrict = decodeStrict;
    function encode(data, level) {
      return (!level || level <= 0 ? encode_1.encodeXML : encode_1.encodeHTML)(data);
    }
    exports2.encode = encode;
    var encode_2 = require_encode();
    Object.defineProperty(exports2, "encodeXML", { enumerable: true, get: function() {
      return encode_2.encodeXML;
    } });
    Object.defineProperty(exports2, "encodeHTML", { enumerable: true, get: function() {
      return encode_2.encodeHTML;
    } });
    Object.defineProperty(exports2, "encodeNonAsciiHTML", { enumerable: true, get: function() {
      return encode_2.encodeNonAsciiHTML;
    } });
    Object.defineProperty(exports2, "escape", { enumerable: true, get: function() {
      return encode_2.escape;
    } });
    Object.defineProperty(exports2, "escapeUTF8", { enumerable: true, get: function() {
      return encode_2.escapeUTF8;
    } });
    Object.defineProperty(exports2, "encodeHTML4", { enumerable: true, get: function() {
      return encode_2.encodeHTML;
    } });
    Object.defineProperty(exports2, "encodeHTML5", { enumerable: true, get: function() {
      return encode_2.encodeHTML;
    } });
    var decode_2 = require_decode2();
    Object.defineProperty(exports2, "decodeXML", { enumerable: true, get: function() {
      return decode_2.decodeXML;
    } });
    Object.defineProperty(exports2, "decodeHTML", { enumerable: true, get: function() {
      return decode_2.decodeHTML;
    } });
    Object.defineProperty(exports2, "decodeHTMLStrict", { enumerable: true, get: function() {
      return decode_2.decodeHTMLStrict;
    } });
    Object.defineProperty(exports2, "decodeHTML4", { enumerable: true, get: function() {
      return decode_2.decodeHTML;
    } });
    Object.defineProperty(exports2, "decodeHTML5", { enumerable: true, get: function() {
      return decode_2.decodeHTML;
    } });
    Object.defineProperty(exports2, "decodeHTML4Strict", { enumerable: true, get: function() {
      return decode_2.decodeHTMLStrict;
    } });
    Object.defineProperty(exports2, "decodeHTML5Strict", { enumerable: true, get: function() {
      return decode_2.decodeHTMLStrict;
    } });
    Object.defineProperty(exports2, "decodeXMLStrict", { enumerable: true, get: function() {
      return decode_2.decodeXML;
    } });
  }
});

// node_modules/dom-serializer/lib/foreignNames.js
var require_foreignNames = __commonJS({
  "node_modules/dom-serializer/lib/foreignNames.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.attributeNames = exports2.elementNames = void 0;
    exports2.elementNames = /* @__PURE__ */ new Map([
      ["altglyph", "altGlyph"],
      ["altglyphdef", "altGlyphDef"],
      ["altglyphitem", "altGlyphItem"],
      ["animatecolor", "animateColor"],
      ["animatemotion", "animateMotion"],
      ["animatetransform", "animateTransform"],
      ["clippath", "clipPath"],
      ["feblend", "feBlend"],
      ["fecolormatrix", "feColorMatrix"],
      ["fecomponenttransfer", "feComponentTransfer"],
      ["fecomposite", "feComposite"],
      ["feconvolvematrix", "feConvolveMatrix"],
      ["fediffuselighting", "feDiffuseLighting"],
      ["fedisplacementmap", "feDisplacementMap"],
      ["fedistantlight", "feDistantLight"],
      ["fedropshadow", "feDropShadow"],
      ["feflood", "feFlood"],
      ["fefunca", "feFuncA"],
      ["fefuncb", "feFuncB"],
      ["fefuncg", "feFuncG"],
      ["fefuncr", "feFuncR"],
      ["fegaussianblur", "feGaussianBlur"],
      ["feimage", "feImage"],
      ["femerge", "feMerge"],
      ["femergenode", "feMergeNode"],
      ["femorphology", "feMorphology"],
      ["feoffset", "feOffset"],
      ["fepointlight", "fePointLight"],
      ["fespecularlighting", "feSpecularLighting"],
      ["fespotlight", "feSpotLight"],
      ["fetile", "feTile"],
      ["feturbulence", "feTurbulence"],
      ["foreignobject", "foreignObject"],
      ["glyphref", "glyphRef"],
      ["lineargradient", "linearGradient"],
      ["radialgradient", "radialGradient"],
      ["textpath", "textPath"]
    ]);
    exports2.attributeNames = /* @__PURE__ */ new Map([
      ["definitionurl", "definitionURL"],
      ["attributename", "attributeName"],
      ["attributetype", "attributeType"],
      ["basefrequency", "baseFrequency"],
      ["baseprofile", "baseProfile"],
      ["calcmode", "calcMode"],
      ["clippathunits", "clipPathUnits"],
      ["diffuseconstant", "diffuseConstant"],
      ["edgemode", "edgeMode"],
      ["filterunits", "filterUnits"],
      ["glyphref", "glyphRef"],
      ["gradienttransform", "gradientTransform"],
      ["gradientunits", "gradientUnits"],
      ["kernelmatrix", "kernelMatrix"],
      ["kernelunitlength", "kernelUnitLength"],
      ["keypoints", "keyPoints"],
      ["keysplines", "keySplines"],
      ["keytimes", "keyTimes"],
      ["lengthadjust", "lengthAdjust"],
      ["limitingconeangle", "limitingConeAngle"],
      ["markerheight", "markerHeight"],
      ["markerunits", "markerUnits"],
      ["markerwidth", "markerWidth"],
      ["maskcontentunits", "maskContentUnits"],
      ["maskunits", "maskUnits"],
      ["numoctaves", "numOctaves"],
      ["pathlength", "pathLength"],
      ["patterncontentunits", "patternContentUnits"],
      ["patterntransform", "patternTransform"],
      ["patternunits", "patternUnits"],
      ["pointsatx", "pointsAtX"],
      ["pointsaty", "pointsAtY"],
      ["pointsatz", "pointsAtZ"],
      ["preservealpha", "preserveAlpha"],
      ["preserveaspectratio", "preserveAspectRatio"],
      ["primitiveunits", "primitiveUnits"],
      ["refx", "refX"],
      ["refy", "refY"],
      ["repeatcount", "repeatCount"],
      ["repeatdur", "repeatDur"],
      ["requiredextensions", "requiredExtensions"],
      ["requiredfeatures", "requiredFeatures"],
      ["specularconstant", "specularConstant"],
      ["specularexponent", "specularExponent"],
      ["spreadmethod", "spreadMethod"],
      ["startoffset", "startOffset"],
      ["stddeviation", "stdDeviation"],
      ["stitchtiles", "stitchTiles"],
      ["surfacescale", "surfaceScale"],
      ["systemlanguage", "systemLanguage"],
      ["tablevalues", "tableValues"],
      ["targetx", "targetX"],
      ["targety", "targetY"],
      ["textlength", "textLength"],
      ["viewbox", "viewBox"],
      ["viewtarget", "viewTarget"],
      ["xchannelselector", "xChannelSelector"],
      ["ychannelselector", "yChannelSelector"],
      ["zoomandpan", "zoomAndPan"]
    ]);
  }
});

// node_modules/dom-serializer/lib/index.js
var require_lib8 = __commonJS({
  "node_modules/dom-serializer/lib/index.js"(exports2) {
    "use strict";
    var __assign = exports2 && exports2.__assign || function() {
      __assign = Object.assign || function(t2) {
        for (var s2, i3 = 1, n2 = arguments.length; i3 < n2; i3++) {
          s2 = arguments[i3];
          for (var p in s2)
            if (Object.prototype.hasOwnProperty.call(s2, p))
              t2[p] = s2[p];
        }
        return t2;
      };
      return __assign.apply(this, arguments);
    };
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o2, m, k, k2) {
      if (k2 === void 0)
        k2 = k;
      Object.defineProperty(o2, k2, { enumerable: true, get: function() {
        return m[k];
      } });
    } : function(o2, m, k, k2) {
      if (k2 === void 0)
        k2 = k;
      o2[k2] = m[k];
    });
    var __setModuleDefault = exports2 && exports2.__setModuleDefault || (Object.create ? function(o2, v) {
      Object.defineProperty(o2, "default", { enumerable: true, value: v });
    } : function(o2, v) {
      o2["default"] = v;
    });
    var __importStar = exports2 && exports2.__importStar || function(mod) {
      if (mod && mod.__esModule)
        return mod;
      var result2 = {};
      if (mod != null) {
        for (var k in mod)
          if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k))
            __createBinding(result2, mod, k);
      }
      __setModuleDefault(result2, mod);
      return result2;
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    var ElementType = __importStar(require_lib5());
    var entities_1 = require_lib7();
    var foreignNames_1 = require_foreignNames();
    var unencodedElements = /* @__PURE__ */ new Set([
      "style",
      "script",
      "xmp",
      "iframe",
      "noembed",
      "noframes",
      "plaintext",
      "noscript"
    ]);
    function formatAttributes(attributes, opts) {
      if (!attributes)
        return;
      return Object.keys(attributes).map(function(key2) {
        var _a2, _b;
        var value = (_a2 = attributes[key2]) !== null && _a2 !== void 0 ? _a2 : "";
        if (opts.xmlMode === "foreign") {
          key2 = (_b = foreignNames_1.attributeNames.get(key2)) !== null && _b !== void 0 ? _b : key2;
        }
        if (!opts.emptyAttrs && !opts.xmlMode && value === "") {
          return key2;
        }
        return key2 + '="' + (opts.decodeEntities !== false ? entities_1.encodeXML(value) : value.replace(/"/g, "&quot;")) + '"';
      }).join(" ");
    }
    var singleTag = /* @__PURE__ */ new Set([
      "area",
      "base",
      "basefont",
      "br",
      "col",
      "command",
      "embed",
      "frame",
      "hr",
      "img",
      "input",
      "isindex",
      "keygen",
      "link",
      "meta",
      "param",
      "source",
      "track",
      "wbr"
    ]);
    function render2(node, options) {
      if (options === void 0) {
        options = {};
      }
      var nodes = "length" in node ? node : [node];
      var output = "";
      for (var i3 = 0; i3 < nodes.length; i3++) {
        output += renderNode(nodes[i3], options);
      }
      return output;
    }
    exports2.default = render2;
    function renderNode(node, options) {
      switch (node.type) {
        case ElementType.Root:
          return render2(node.children, options);
        case ElementType.Directive:
        case ElementType.Doctype:
          return renderDirective(node);
        case ElementType.Comment:
          return renderComment(node);
        case ElementType.CDATA:
          return renderCdata(node);
        case ElementType.Script:
        case ElementType.Style:
        case ElementType.Tag:
          return renderTag(node, options);
        case ElementType.Text:
          return renderText(node, options);
      }
    }
    var foreignModeIntegrationPoints = /* @__PURE__ */ new Set([
      "mi",
      "mo",
      "mn",
      "ms",
      "mtext",
      "annotation-xml",
      "foreignObject",
      "desc",
      "title"
    ]);
    var foreignElements = /* @__PURE__ */ new Set(["svg", "math"]);
    function renderTag(elem, opts) {
      var _a2;
      if (opts.xmlMode === "foreign") {
        elem.name = (_a2 = foreignNames_1.elementNames.get(elem.name)) !== null && _a2 !== void 0 ? _a2 : elem.name;
        if (elem.parent && foreignModeIntegrationPoints.has(elem.parent.name)) {
          opts = __assign(__assign({}, opts), { xmlMode: false });
        }
      }
      if (!opts.xmlMode && foreignElements.has(elem.name)) {
        opts = __assign(__assign({}, opts), { xmlMode: "foreign" });
      }
      var tag = "<" + elem.name;
      var attribs = formatAttributes(elem.attribs, opts);
      if (attribs) {
        tag += " " + attribs;
      }
      if (elem.children.length === 0 && (opts.xmlMode ? opts.selfClosingTags !== false : opts.selfClosingTags && singleTag.has(elem.name))) {
        if (!opts.xmlMode)
          tag += " ";
        tag += "/>";
      } else {
        tag += ">";
        if (elem.children.length > 0) {
          tag += render2(elem.children, opts);
        }
        if (opts.xmlMode || !singleTag.has(elem.name)) {
          tag += "</" + elem.name + ">";
        }
      }
      return tag;
    }
    function renderDirective(elem) {
      return "<" + elem.data + ">";
    }
    function renderText(elem, opts) {
      var data = elem.data || "";
      if (opts.decodeEntities !== false && !(!opts.xmlMode && elem.parent && unencodedElements.has(elem.parent.name))) {
        data = entities_1.encodeXML(data);
      }
      return data;
    }
    function renderCdata(elem) {
      return "<![CDATA[" + elem.children[0].data + "]]>";
    }
    function renderComment(elem) {
      return "<!--" + elem.data + "-->";
    }
  }
});

// node_modules/domutils/lib/stringify.js
var require_stringify = __commonJS({
  "node_modules/domutils/lib/stringify.js"(exports2) {
    "use strict";
    var __importDefault = exports2 && exports2.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { "default": mod };
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.innerText = exports2.textContent = exports2.getText = exports2.getInnerHTML = exports2.getOuterHTML = void 0;
    var domhandler_1 = require_lib6();
    var dom_serializer_1 = __importDefault(require_lib8());
    var domelementtype_1 = require_lib5();
    function getOuterHTML(node, options) {
      return (0, dom_serializer_1.default)(node, options);
    }
    exports2.getOuterHTML = getOuterHTML;
    function getInnerHTML(node, options) {
      return (0, domhandler_1.hasChildren)(node) ? node.children.map(function(node2) {
        return getOuterHTML(node2, options);
      }).join("") : "";
    }
    exports2.getInnerHTML = getInnerHTML;
    function getText(node) {
      if (Array.isArray(node))
        return node.map(getText).join("");
      if ((0, domhandler_1.isTag)(node))
        return node.name === "br" ? "\n" : getText(node.children);
      if ((0, domhandler_1.isCDATA)(node))
        return getText(node.children);
      if ((0, domhandler_1.isText)(node))
        return node.data;
      return "";
    }
    exports2.getText = getText;
    function textContent(node) {
      if (Array.isArray(node))
        return node.map(textContent).join("");
      if ((0, domhandler_1.hasChildren)(node) && !(0, domhandler_1.isComment)(node)) {
        return textContent(node.children);
      }
      if ((0, domhandler_1.isText)(node))
        return node.data;
      return "";
    }
    exports2.textContent = textContent;
    function innerText(node) {
      if (Array.isArray(node))
        return node.map(innerText).join("");
      if ((0, domhandler_1.hasChildren)(node) && (node.type === domelementtype_1.ElementType.Tag || (0, domhandler_1.isCDATA)(node))) {
        return innerText(node.children);
      }
      if ((0, domhandler_1.isText)(node))
        return node.data;
      return "";
    }
    exports2.innerText = innerText;
  }
});

// node_modules/domutils/lib/traversal.js
var require_traversal = __commonJS({
  "node_modules/domutils/lib/traversal.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.prevElementSibling = exports2.nextElementSibling = exports2.getName = exports2.hasAttrib = exports2.getAttributeValue = exports2.getSiblings = exports2.getParent = exports2.getChildren = void 0;
    var domhandler_1 = require_lib6();
    var emptyArray = [];
    function getChildren(elem) {
      var _a2;
      return (_a2 = elem.children) !== null && _a2 !== void 0 ? _a2 : emptyArray;
    }
    exports2.getChildren = getChildren;
    function getParent(elem) {
      return elem.parent || null;
    }
    exports2.getParent = getParent;
    function getSiblings(elem) {
      var _a2, _b;
      var parent = getParent(elem);
      if (parent != null)
        return getChildren(parent);
      var siblings = [elem];
      var prev = elem.prev, next = elem.next;
      while (prev != null) {
        siblings.unshift(prev);
        _a2 = prev, prev = _a2.prev;
      }
      while (next != null) {
        siblings.push(next);
        _b = next, next = _b.next;
      }
      return siblings;
    }
    exports2.getSiblings = getSiblings;
    function getAttributeValue(elem, name) {
      var _a2;
      return (_a2 = elem.attribs) === null || _a2 === void 0 ? void 0 : _a2[name];
    }
    exports2.getAttributeValue = getAttributeValue;
    function hasAttrib(elem, name) {
      return elem.attribs != null && Object.prototype.hasOwnProperty.call(elem.attribs, name) && elem.attribs[name] != null;
    }
    exports2.hasAttrib = hasAttrib;
    function getName(elem) {
      return elem.name;
    }
    exports2.getName = getName;
    function nextElementSibling(elem) {
      var _a2;
      var next = elem.next;
      while (next !== null && !(0, domhandler_1.isTag)(next))
        _a2 = next, next = _a2.next;
      return next;
    }
    exports2.nextElementSibling = nextElementSibling;
    function prevElementSibling(elem) {
      var _a2;
      var prev = elem.prev;
      while (prev !== null && !(0, domhandler_1.isTag)(prev))
        _a2 = prev, prev = _a2.prev;
      return prev;
    }
    exports2.prevElementSibling = prevElementSibling;
  }
});

// node_modules/domutils/lib/manipulation.js
var require_manipulation = __commonJS({
  "node_modules/domutils/lib/manipulation.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.prepend = exports2.prependChild = exports2.append = exports2.appendChild = exports2.replaceElement = exports2.removeElement = void 0;
    function removeElement(elem) {
      if (elem.prev)
        elem.prev.next = elem.next;
      if (elem.next)
        elem.next.prev = elem.prev;
      if (elem.parent) {
        var childs = elem.parent.children;
        childs.splice(childs.lastIndexOf(elem), 1);
      }
    }
    exports2.removeElement = removeElement;
    function replaceElement(elem, replacement) {
      var prev = replacement.prev = elem.prev;
      if (prev) {
        prev.next = replacement;
      }
      var next = replacement.next = elem.next;
      if (next) {
        next.prev = replacement;
      }
      var parent = replacement.parent = elem.parent;
      if (parent) {
        var childs = parent.children;
        childs[childs.lastIndexOf(elem)] = replacement;
      }
    }
    exports2.replaceElement = replaceElement;
    function appendChild(elem, child) {
      removeElement(child);
      child.next = null;
      child.parent = elem;
      if (elem.children.push(child) > 1) {
        var sibling = elem.children[elem.children.length - 2];
        sibling.next = child;
        child.prev = sibling;
      } else {
        child.prev = null;
      }
    }
    exports2.appendChild = appendChild;
    function append(elem, next) {
      removeElement(next);
      var parent = elem.parent;
      var currNext = elem.next;
      next.next = currNext;
      next.prev = elem;
      elem.next = next;
      next.parent = parent;
      if (currNext) {
        currNext.prev = next;
        if (parent) {
          var childs = parent.children;
          childs.splice(childs.lastIndexOf(currNext), 0, next);
        }
      } else if (parent) {
        parent.children.push(next);
      }
    }
    exports2.append = append;
    function prependChild(elem, child) {
      removeElement(child);
      child.parent = elem;
      child.prev = null;
      if (elem.children.unshift(child) !== 1) {
        var sibling = elem.children[1];
        sibling.prev = child;
        child.next = sibling;
      } else {
        child.next = null;
      }
    }
    exports2.prependChild = prependChild;
    function prepend(elem, prev) {
      removeElement(prev);
      var parent = elem.parent;
      if (parent) {
        var childs = parent.children;
        childs.splice(childs.indexOf(elem), 0, prev);
      }
      if (elem.prev) {
        elem.prev.next = prev;
      }
      prev.parent = parent;
      prev.prev = elem.prev;
      prev.next = elem;
      elem.prev = prev;
    }
    exports2.prepend = prepend;
  }
});

// node_modules/domutils/lib/querying.js
var require_querying = __commonJS({
  "node_modules/domutils/lib/querying.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.findAll = exports2.existsOne = exports2.findOne = exports2.findOneChild = exports2.find = exports2.filter = void 0;
    var domhandler_1 = require_lib6();
    function filter(test, node, recurse, limit) {
      if (recurse === void 0) {
        recurse = true;
      }
      if (limit === void 0) {
        limit = Infinity;
      }
      if (!Array.isArray(node))
        node = [node];
      return find(test, node, recurse, limit);
    }
    exports2.filter = filter;
    function find(test, nodes, recurse, limit) {
      var result2 = [];
      for (var _i = 0, nodes_1 = nodes; _i < nodes_1.length; _i++) {
        var elem = nodes_1[_i];
        if (test(elem)) {
          result2.push(elem);
          if (--limit <= 0)
            break;
        }
        if (recurse && (0, domhandler_1.hasChildren)(elem) && elem.children.length > 0) {
          var children = find(test, elem.children, recurse, limit);
          result2.push.apply(result2, children);
          limit -= children.length;
          if (limit <= 0)
            break;
        }
      }
      return result2;
    }
    exports2.find = find;
    function findOneChild(test, nodes) {
      return nodes.find(test);
    }
    exports2.findOneChild = findOneChild;
    function findOne(test, nodes, recurse) {
      if (recurse === void 0) {
        recurse = true;
      }
      var elem = null;
      for (var i3 = 0; i3 < nodes.length && !elem; i3++) {
        var checked = nodes[i3];
        if (!(0, domhandler_1.isTag)(checked)) {
          continue;
        } else if (test(checked)) {
          elem = checked;
        } else if (recurse && checked.children.length > 0) {
          elem = findOne(test, checked.children);
        }
      }
      return elem;
    }
    exports2.findOne = findOne;
    function existsOne(test, nodes) {
      return nodes.some(function(checked) {
        return (0, domhandler_1.isTag)(checked) && (test(checked) || checked.children.length > 0 && existsOne(test, checked.children));
      });
    }
    exports2.existsOne = existsOne;
    function findAll(test, nodes) {
      var _a2;
      var result2 = [];
      var stack = nodes.filter(domhandler_1.isTag);
      var elem;
      while (elem = stack.shift()) {
        var children = (_a2 = elem.children) === null || _a2 === void 0 ? void 0 : _a2.filter(domhandler_1.isTag);
        if (children && children.length > 0) {
          stack.unshift.apply(stack, children);
        }
        if (test(elem))
          result2.push(elem);
      }
      return result2;
    }
    exports2.findAll = findAll;
  }
});

// node_modules/domutils/lib/legacy.js
var require_legacy2 = __commonJS({
  "node_modules/domutils/lib/legacy.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.getElementsByTagType = exports2.getElementsByTagName = exports2.getElementById = exports2.getElements = exports2.testElement = void 0;
    var domhandler_1 = require_lib6();
    var querying_1 = require_querying();
    var Checks = {
      tag_name: function(name) {
        if (typeof name === "function") {
          return function(elem) {
            return (0, domhandler_1.isTag)(elem) && name(elem.name);
          };
        } else if (name === "*") {
          return domhandler_1.isTag;
        }
        return function(elem) {
          return (0, domhandler_1.isTag)(elem) && elem.name === name;
        };
      },
      tag_type: function(type3) {
        if (typeof type3 === "function") {
          return function(elem) {
            return type3(elem.type);
          };
        }
        return function(elem) {
          return elem.type === type3;
        };
      },
      tag_contains: function(data) {
        if (typeof data === "function") {
          return function(elem) {
            return (0, domhandler_1.isText)(elem) && data(elem.data);
          };
        }
        return function(elem) {
          return (0, domhandler_1.isText)(elem) && elem.data === data;
        };
      }
    };
    function getAttribCheck(attrib, value) {
      if (typeof value === "function") {
        return function(elem) {
          return (0, domhandler_1.isTag)(elem) && value(elem.attribs[attrib]);
        };
      }
      return function(elem) {
        return (0, domhandler_1.isTag)(elem) && elem.attribs[attrib] === value;
      };
    }
    function combineFuncs(a2, b2) {
      return function(elem) {
        return a2(elem) || b2(elem);
      };
    }
    function compileTest(options) {
      var funcs = Object.keys(options).map(function(key2) {
        var value = options[key2];
        return Object.prototype.hasOwnProperty.call(Checks, key2) ? Checks[key2](value) : getAttribCheck(key2, value);
      });
      return funcs.length === 0 ? null : funcs.reduce(combineFuncs);
    }
    function testElement(options, node) {
      var test = compileTest(options);
      return test ? test(node) : true;
    }
    exports2.testElement = testElement;
    function getElements(options, nodes, recurse, limit) {
      if (limit === void 0) {
        limit = Infinity;
      }
      var test = compileTest(options);
      return test ? (0, querying_1.filter)(test, nodes, recurse, limit) : [];
    }
    exports2.getElements = getElements;
    function getElementById(id, nodes, recurse) {
      if (recurse === void 0) {
        recurse = true;
      }
      if (!Array.isArray(nodes))
        nodes = [nodes];
      return (0, querying_1.findOne)(getAttribCheck("id", id), nodes, recurse);
    }
    exports2.getElementById = getElementById;
    function getElementsByTagName(tagName, nodes, recurse, limit) {
      if (recurse === void 0) {
        recurse = true;
      }
      if (limit === void 0) {
        limit = Infinity;
      }
      return (0, querying_1.filter)(Checks.tag_name(tagName), nodes, recurse, limit);
    }
    exports2.getElementsByTagName = getElementsByTagName;
    function getElementsByTagType(type3, nodes, recurse, limit) {
      if (recurse === void 0) {
        recurse = true;
      }
      if (limit === void 0) {
        limit = Infinity;
      }
      return (0, querying_1.filter)(Checks.tag_type(type3), nodes, recurse, limit);
    }
    exports2.getElementsByTagType = getElementsByTagType;
  }
});

// node_modules/domutils/lib/helpers.js
var require_helpers = __commonJS({
  "node_modules/domutils/lib/helpers.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.uniqueSort = exports2.compareDocumentPosition = exports2.removeSubsets = void 0;
    var domhandler_1 = require_lib6();
    function removeSubsets(nodes) {
      var idx = nodes.length;
      while (--idx >= 0) {
        var node = nodes[idx];
        if (idx > 0 && nodes.lastIndexOf(node, idx - 1) >= 0) {
          nodes.splice(idx, 1);
          continue;
        }
        for (var ancestor = node.parent; ancestor; ancestor = ancestor.parent) {
          if (nodes.includes(ancestor)) {
            nodes.splice(idx, 1);
            break;
          }
        }
      }
      return nodes;
    }
    exports2.removeSubsets = removeSubsets;
    function compareDocumentPosition(nodeA, nodeB) {
      var aParents = [];
      var bParents = [];
      if (nodeA === nodeB) {
        return 0;
      }
      var current = (0, domhandler_1.hasChildren)(nodeA) ? nodeA : nodeA.parent;
      while (current) {
        aParents.unshift(current);
        current = current.parent;
      }
      current = (0, domhandler_1.hasChildren)(nodeB) ? nodeB : nodeB.parent;
      while (current) {
        bParents.unshift(current);
        current = current.parent;
      }
      var maxIdx = Math.min(aParents.length, bParents.length);
      var idx = 0;
      while (idx < maxIdx && aParents[idx] === bParents[idx]) {
        idx++;
      }
      if (idx === 0) {
        return 1;
      }
      var sharedParent = aParents[idx - 1];
      var siblings = sharedParent.children;
      var aSibling = aParents[idx];
      var bSibling = bParents[idx];
      if (siblings.indexOf(aSibling) > siblings.indexOf(bSibling)) {
        if (sharedParent === nodeB) {
          return 4 | 16;
        }
        return 4;
      }
      if (sharedParent === nodeA) {
        return 2 | 8;
      }
      return 2;
    }
    exports2.compareDocumentPosition = compareDocumentPosition;
    function uniqueSort(nodes) {
      nodes = nodes.filter(function(node, i3, arr) {
        return !arr.includes(node, i3 + 1);
      });
      nodes.sort(function(a2, b2) {
        var relative = compareDocumentPosition(a2, b2);
        if (relative & 2) {
          return -1;
        } else if (relative & 4) {
          return 1;
        }
        return 0;
      });
      return nodes;
    }
    exports2.uniqueSort = uniqueSort;
  }
});

// node_modules/domutils/lib/feeds.js
var require_feeds = __commonJS({
  "node_modules/domutils/lib/feeds.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.getFeed = void 0;
    var stringify_1 = require_stringify();
    var legacy_1 = require_legacy2();
    function getFeed(doc) {
      var feedRoot = getOneElement(isValidFeed, doc);
      return !feedRoot ? null : feedRoot.name === "feed" ? getAtomFeed(feedRoot) : getRssFeed(feedRoot);
    }
    exports2.getFeed = getFeed;
    function getAtomFeed(feedRoot) {
      var _a2;
      var childs = feedRoot.children;
      var feed = {
        type: "atom",
        items: (0, legacy_1.getElementsByTagName)("entry", childs).map(function(item) {
          var _a3;
          var children = item.children;
          var entry = { media: getMediaElements(children) };
          addConditionally(entry, "id", "id", children);
          addConditionally(entry, "title", "title", children);
          var href2 = (_a3 = getOneElement("link", children)) === null || _a3 === void 0 ? void 0 : _a3.attribs.href;
          if (href2) {
            entry.link = href2;
          }
          var description = fetch("summary", children) || fetch("content", children);
          if (description) {
            entry.description = description;
          }
          var pubDate = fetch("updated", children);
          if (pubDate) {
            entry.pubDate = new Date(pubDate);
          }
          return entry;
        })
      };
      addConditionally(feed, "id", "id", childs);
      addConditionally(feed, "title", "title", childs);
      var href = (_a2 = getOneElement("link", childs)) === null || _a2 === void 0 ? void 0 : _a2.attribs.href;
      if (href) {
        feed.link = href;
      }
      addConditionally(feed, "description", "subtitle", childs);
      var updated = fetch("updated", childs);
      if (updated) {
        feed.updated = new Date(updated);
      }
      addConditionally(feed, "author", "email", childs, true);
      return feed;
    }
    function getRssFeed(feedRoot) {
      var _a2, _b;
      var childs = (_b = (_a2 = getOneElement("channel", feedRoot.children)) === null || _a2 === void 0 ? void 0 : _a2.children) !== null && _b !== void 0 ? _b : [];
      var feed = {
        type: feedRoot.name.substr(0, 3),
        id: "",
        items: (0, legacy_1.getElementsByTagName)("item", feedRoot.children).map(function(item) {
          var children = item.children;
          var entry = { media: getMediaElements(children) };
          addConditionally(entry, "id", "guid", children);
          addConditionally(entry, "title", "title", children);
          addConditionally(entry, "link", "link", children);
          addConditionally(entry, "description", "description", children);
          var pubDate = fetch("pubDate", children);
          if (pubDate)
            entry.pubDate = new Date(pubDate);
          return entry;
        })
      };
      addConditionally(feed, "title", "title", childs);
      addConditionally(feed, "link", "link", childs);
      addConditionally(feed, "description", "description", childs);
      var updated = fetch("lastBuildDate", childs);
      if (updated) {
        feed.updated = new Date(updated);
      }
      addConditionally(feed, "author", "managingEditor", childs, true);
      return feed;
    }
    var MEDIA_KEYS_STRING = ["url", "type", "lang"];
    var MEDIA_KEYS_INT = [
      "fileSize",
      "bitrate",
      "framerate",
      "samplingrate",
      "channels",
      "duration",
      "height",
      "width"
    ];
    function getMediaElements(where) {
      return (0, legacy_1.getElementsByTagName)("media:content", where).map(function(elem) {
        var attribs = elem.attribs;
        var media = {
          medium: attribs.medium,
          isDefault: !!attribs.isDefault
        };
        for (var _i = 0, MEDIA_KEYS_STRING_1 = MEDIA_KEYS_STRING; _i < MEDIA_KEYS_STRING_1.length; _i++) {
          var attrib = MEDIA_KEYS_STRING_1[_i];
          if (attribs[attrib]) {
            media[attrib] = attribs[attrib];
          }
        }
        for (var _a2 = 0, MEDIA_KEYS_INT_1 = MEDIA_KEYS_INT; _a2 < MEDIA_KEYS_INT_1.length; _a2++) {
          var attrib = MEDIA_KEYS_INT_1[_a2];
          if (attribs[attrib]) {
            media[attrib] = parseInt(attribs[attrib], 10);
          }
        }
        if (attribs.expression) {
          media.expression = attribs.expression;
        }
        return media;
      });
    }
    function getOneElement(tagName, node) {
      return (0, legacy_1.getElementsByTagName)(tagName, node, true, 1)[0];
    }
    function fetch(tagName, where, recurse) {
      if (recurse === void 0) {
        recurse = false;
      }
      return (0, stringify_1.textContent)((0, legacy_1.getElementsByTagName)(tagName, where, recurse, 1)).trim();
    }
    function addConditionally(obj, prop, tagName, where, recurse) {
      if (recurse === void 0) {
        recurse = false;
      }
      var val = fetch(tagName, where, recurse);
      if (val)
        obj[prop] = val;
    }
    function isValidFeed(value) {
      return value === "rss" || value === "feed" || value === "rdf:RDF";
    }
  }
});

// node_modules/domutils/lib/index.js
var require_lib9 = __commonJS({
  "node_modules/domutils/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o2, m, k, k2) {
      if (k2 === void 0)
        k2 = k;
      Object.defineProperty(o2, k2, { enumerable: true, get: function() {
        return m[k];
      } });
    } : function(o2, m, k, k2) {
      if (k2 === void 0)
        k2 = k;
      o2[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports3) {
      for (var p in m)
        if (p !== "default" && !Object.prototype.hasOwnProperty.call(exports3, p))
          __createBinding(exports3, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.hasChildren = exports2.isDocument = exports2.isComment = exports2.isText = exports2.isCDATA = exports2.isTag = void 0;
    __exportStar(require_stringify(), exports2);
    __exportStar(require_traversal(), exports2);
    __exportStar(require_manipulation(), exports2);
    __exportStar(require_querying(), exports2);
    __exportStar(require_legacy2(), exports2);
    __exportStar(require_helpers(), exports2);
    __exportStar(require_feeds(), exports2);
    var domhandler_1 = require_lib6();
    Object.defineProperty(exports2, "isTag", { enumerable: true, get: function() {
      return domhandler_1.isTag;
    } });
    Object.defineProperty(exports2, "isCDATA", { enumerable: true, get: function() {
      return domhandler_1.isCDATA;
    } });
    Object.defineProperty(exports2, "isText", { enumerable: true, get: function() {
      return domhandler_1.isText;
    } });
    Object.defineProperty(exports2, "isComment", { enumerable: true, get: function() {
      return domhandler_1.isComment;
    } });
    Object.defineProperty(exports2, "isDocument", { enumerable: true, get: function() {
      return domhandler_1.isDocument;
    } });
    Object.defineProperty(exports2, "hasChildren", { enumerable: true, get: function() {
      return domhandler_1.hasChildren;
    } });
  }
});

// node_modules/htmlparser2/lib/FeedHandler.js
var require_FeedHandler = __commonJS({
  "node_modules/htmlparser2/lib/FeedHandler.js"(exports2) {
    "use strict";
    var __extends2 = exports2 && exports2.__extends || function() {
      var extendStatics = function(d, b2) {
        extendStatics = Object.setPrototypeOf || { __proto__: [] } instanceof Array && function(d2, b3) {
          d2.__proto__ = b3;
        } || function(d2, b3) {
          for (var p in b3)
            if (Object.prototype.hasOwnProperty.call(b3, p))
              d2[p] = b3[p];
        };
        return extendStatics(d, b2);
      };
      return function(d, b2) {
        if (typeof b2 !== "function" && b2 !== null)
          throw new TypeError("Class extends value " + String(b2) + " is not a constructor or null");
        extendStatics(d, b2);
        function __() {
          this.constructor = d;
        }
        d.prototype = b2 === null ? Object.create(b2) : (__.prototype = b2.prototype, new __());
      };
    }();
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o2, m, k, k2) {
      if (k2 === void 0)
        k2 = k;
      Object.defineProperty(o2, k2, { enumerable: true, get: function() {
        return m[k];
      } });
    } : function(o2, m, k, k2) {
      if (k2 === void 0)
        k2 = k;
      o2[k2] = m[k];
    });
    var __setModuleDefault = exports2 && exports2.__setModuleDefault || (Object.create ? function(o2, v) {
      Object.defineProperty(o2, "default", { enumerable: true, value: v });
    } : function(o2, v) {
      o2["default"] = v;
    });
    var __importStar = exports2 && exports2.__importStar || function(mod) {
      if (mod && mod.__esModule)
        return mod;
      var result2 = {};
      if (mod != null) {
        for (var k in mod)
          if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k))
            __createBinding(result2, mod, k);
      }
      __setModuleDefault(result2, mod);
      return result2;
    };
    var __importDefault = exports2 && exports2.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { "default": mod };
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.parseFeed = exports2.FeedHandler = void 0;
    var domhandler_1 = __importDefault(require_lib6());
    var DomUtils = __importStar(require_lib9());
    var Parser_1 = require_Parser();
    var FeedItemMediaMedium;
    (function(FeedItemMediaMedium2) {
      FeedItemMediaMedium2[FeedItemMediaMedium2["image"] = 0] = "image";
      FeedItemMediaMedium2[FeedItemMediaMedium2["audio"] = 1] = "audio";
      FeedItemMediaMedium2[FeedItemMediaMedium2["video"] = 2] = "video";
      FeedItemMediaMedium2[FeedItemMediaMedium2["document"] = 3] = "document";
      FeedItemMediaMedium2[FeedItemMediaMedium2["executable"] = 4] = "executable";
    })(FeedItemMediaMedium || (FeedItemMediaMedium = {}));
    var FeedItemMediaExpression;
    (function(FeedItemMediaExpression2) {
      FeedItemMediaExpression2[FeedItemMediaExpression2["sample"] = 0] = "sample";
      FeedItemMediaExpression2[FeedItemMediaExpression2["full"] = 1] = "full";
      FeedItemMediaExpression2[FeedItemMediaExpression2["nonstop"] = 2] = "nonstop";
    })(FeedItemMediaExpression || (FeedItemMediaExpression = {}));
    var FeedHandler = function(_super) {
      __extends2(FeedHandler2, _super);
      function FeedHandler2(callback, options) {
        var _this = this;
        if (typeof callback === "object") {
          callback = void 0;
          options = callback;
        }
        _this = _super.call(this, callback, options) || this;
        return _this;
      }
      FeedHandler2.prototype.onend = function() {
        var _a2, _b;
        var feedRoot = getOneElement(isValidFeed, this.dom);
        if (!feedRoot) {
          this.handleCallback(new Error("couldn't find root of feed"));
          return;
        }
        var feed = {};
        if (feedRoot.name === "feed") {
          var childs = feedRoot.children;
          feed.type = "atom";
          addConditionally(feed, "id", "id", childs);
          addConditionally(feed, "title", "title", childs);
          var href = getAttribute("href", getOneElement("link", childs));
          if (href) {
            feed.link = href;
          }
          addConditionally(feed, "description", "subtitle", childs);
          var updated = fetch("updated", childs);
          if (updated) {
            feed.updated = new Date(updated);
          }
          addConditionally(feed, "author", "email", childs, true);
          feed.items = getElements("entry", childs).map(function(item) {
            var entry = {};
            var children = item.children;
            addConditionally(entry, "id", "id", children);
            addConditionally(entry, "title", "title", children);
            var href2 = getAttribute("href", getOneElement("link", children));
            if (href2) {
              entry.link = href2;
            }
            var description = fetch("summary", children) || fetch("content", children);
            if (description) {
              entry.description = description;
            }
            var pubDate = fetch("updated", children);
            if (pubDate) {
              entry.pubDate = new Date(pubDate);
            }
            entry.media = getMediaElements(children);
            return entry;
          });
        } else {
          var childs = (_b = (_a2 = getOneElement("channel", feedRoot.children)) === null || _a2 === void 0 ? void 0 : _a2.children) !== null && _b !== void 0 ? _b : [];
          feed.type = feedRoot.name.substr(0, 3);
          feed.id = "";
          addConditionally(feed, "title", "title", childs);
          addConditionally(feed, "link", "link", childs);
          addConditionally(feed, "description", "description", childs);
          var updated = fetch("lastBuildDate", childs);
          if (updated) {
            feed.updated = new Date(updated);
          }
          addConditionally(feed, "author", "managingEditor", childs, true);
          feed.items = getElements("item", feedRoot.children).map(function(item) {
            var entry = {};
            var children = item.children;
            addConditionally(entry, "id", "guid", children);
            addConditionally(entry, "title", "title", children);
            addConditionally(entry, "link", "link", children);
            addConditionally(entry, "description", "description", children);
            var pubDate = fetch("pubDate", children);
            if (pubDate)
              entry.pubDate = new Date(pubDate);
            entry.media = getMediaElements(children);
            return entry;
          });
        }
        this.feed = feed;
        this.handleCallback(null);
      };
      return FeedHandler2;
    }(domhandler_1.default);
    exports2.FeedHandler = FeedHandler;
    function getMediaElements(where) {
      return getElements("media:content", where).map(function(elem) {
        var media = {
          medium: elem.attribs.medium,
          isDefault: !!elem.attribs.isDefault
        };
        if (elem.attribs.url) {
          media.url = elem.attribs.url;
        }
        if (elem.attribs.fileSize) {
          media.fileSize = parseInt(elem.attribs.fileSize, 10);
        }
        if (elem.attribs.type) {
          media.type = elem.attribs.type;
        }
        if (elem.attribs.expression) {
          media.expression = elem.attribs.expression;
        }
        if (elem.attribs.bitrate) {
          media.bitrate = parseInt(elem.attribs.bitrate, 10);
        }
        if (elem.attribs.framerate) {
          media.framerate = parseInt(elem.attribs.framerate, 10);
        }
        if (elem.attribs.samplingrate) {
          media.samplingrate = parseInt(elem.attribs.samplingrate, 10);
        }
        if (elem.attribs.channels) {
          media.channels = parseInt(elem.attribs.channels, 10);
        }
        if (elem.attribs.duration) {
          media.duration = parseInt(elem.attribs.duration, 10);
        }
        if (elem.attribs.height) {
          media.height = parseInt(elem.attribs.height, 10);
        }
        if (elem.attribs.width) {
          media.width = parseInt(elem.attribs.width, 10);
        }
        if (elem.attribs.lang) {
          media.lang = elem.attribs.lang;
        }
        return media;
      });
    }
    function getElements(tagName, where) {
      return DomUtils.getElementsByTagName(tagName, where, true);
    }
    function getOneElement(tagName, node) {
      return DomUtils.getElementsByTagName(tagName, node, true, 1)[0];
    }
    function fetch(tagName, where, recurse) {
      if (recurse === void 0) {
        recurse = false;
      }
      return DomUtils.getText(DomUtils.getElementsByTagName(tagName, where, recurse, 1)).trim();
    }
    function getAttribute(name, elem) {
      if (!elem) {
        return null;
      }
      var attribs = elem.attribs;
      return attribs[name];
    }
    function addConditionally(obj, prop, what, where, recurse) {
      if (recurse === void 0) {
        recurse = false;
      }
      var tmp = fetch(what, where, recurse);
      if (tmp)
        obj[prop] = tmp;
    }
    function isValidFeed(value) {
      return value === "rss" || value === "feed" || value === "rdf:RDF";
    }
    function parseFeed(feed, options) {
      if (options === void 0) {
        options = { xmlMode: true };
      }
      var handler = new FeedHandler(options);
      new Parser_1.Parser(handler, options).end(feed);
      return handler.feed;
    }
    exports2.parseFeed = parseFeed;
  }
});

// node_modules/htmlparser2/lib/index.js
var require_lib10 = __commonJS({
  "node_modules/htmlparser2/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o2, m, k, k2) {
      if (k2 === void 0)
        k2 = k;
      Object.defineProperty(o2, k2, { enumerable: true, get: function() {
        return m[k];
      } });
    } : function(o2, m, k, k2) {
      if (k2 === void 0)
        k2 = k;
      o2[k2] = m[k];
    });
    var __setModuleDefault = exports2 && exports2.__setModuleDefault || (Object.create ? function(o2, v) {
      Object.defineProperty(o2, "default", { enumerable: true, value: v });
    } : function(o2, v) {
      o2["default"] = v;
    });
    var __importStar = exports2 && exports2.__importStar || function(mod) {
      if (mod && mod.__esModule)
        return mod;
      var result2 = {};
      if (mod != null) {
        for (var k in mod)
          if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k))
            __createBinding(result2, mod, k);
      }
      __setModuleDefault(result2, mod);
      return result2;
    };
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports3) {
      for (var p in m)
        if (p !== "default" && !Object.prototype.hasOwnProperty.call(exports3, p))
          __createBinding(exports3, m, p);
    };
    var __importDefault = exports2 && exports2.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { "default": mod };
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.RssHandler = exports2.DefaultHandler = exports2.DomUtils = exports2.ElementType = exports2.Tokenizer = exports2.createDomStream = exports2.parseDOM = exports2.parseDocument = exports2.DomHandler = exports2.Parser = void 0;
    var Parser_1 = require_Parser();
    Object.defineProperty(exports2, "Parser", { enumerable: true, get: function() {
      return Parser_1.Parser;
    } });
    var domhandler_1 = require_lib6();
    Object.defineProperty(exports2, "DomHandler", { enumerable: true, get: function() {
      return domhandler_1.DomHandler;
    } });
    Object.defineProperty(exports2, "DefaultHandler", { enumerable: true, get: function() {
      return domhandler_1.DomHandler;
    } });
    function parseDocument(data, options) {
      var handler = new domhandler_1.DomHandler(void 0, options);
      new Parser_1.Parser(handler, options).end(data);
      return handler.root;
    }
    exports2.parseDocument = parseDocument;
    function parseDOM(data, options) {
      return parseDocument(data, options).children;
    }
    exports2.parseDOM = parseDOM;
    function createDomStream(cb2, options, elementCb) {
      var handler = new domhandler_1.DomHandler(cb2, options, elementCb);
      return new Parser_1.Parser(handler, options);
    }
    exports2.createDomStream = createDomStream;
    var Tokenizer_1 = require_Tokenizer();
    Object.defineProperty(exports2, "Tokenizer", { enumerable: true, get: function() {
      return __importDefault(Tokenizer_1).default;
    } });
    var ElementType = __importStar(require_lib5());
    exports2.ElementType = ElementType;
    __exportStar(require_FeedHandler(), exports2);
    exports2.DomUtils = __importStar(require_lib9());
    var FeedHandler_1 = require_FeedHandler();
    Object.defineProperty(exports2, "RssHandler", { enumerable: true, get: function() {
      return FeedHandler_1.FeedHandler;
    } });
  }
});

// node_modules/utila/lib/array.js
var require_array = __commonJS({
  "node_modules/utila/lib/array.js"(exports2, module2) {
    var array;
    module2.exports = array = {
      from: function(r2) {
        return Array.prototype.slice.call(r2);
      },
      simpleClone: function(a2) {
        return a2.slice(0);
      },
      shallowEqual: function(a1, a2) {
        var i3, val, _i, _len;
        if (!(Array.isArray(a1) && Array.isArray(a2) && a1.length === a2.length)) {
          return false;
        }
        for (i3 = _i = 0, _len = a1.length; _i < _len; i3 = ++_i) {
          val = a1[i3];
          if (a2[i3] !== val) {
            return false;
          }
        }
        return true;
      },
      pluck: function(a2, i3) {
        var index, value, _i, _len;
        if (a2.length < 1) {
          return a2;
        }
        for (index = _i = 0, _len = a2.length; _i < _len; index = ++_i) {
          value = a2[index];
          if (index > i3) {
            a2[index - 1] = a2[index];
          }
        }
        a2.length = a2.length - 1;
        return a2;
      },
      pluckItem: function(a2, item) {
        var index, removed, value, _i, _len;
        if (a2.length < 1) {
          return a2;
        }
        removed = 0;
        for (index = _i = 0, _len = a2.length; _i < _len; index = ++_i) {
          value = a2[index];
          if (value === item) {
            removed++;
            continue;
          }
          if (removed !== 0) {
            a2[index - removed] = a2[index];
          }
        }
        if (removed > 0) {
          a2.length = a2.length - removed;
        }
        return a2;
      },
      pluckOneItem: function(a2, item) {
        var index, reached, value, _i, _len;
        if (a2.length < 1) {
          return a2;
        }
        reached = false;
        for (index = _i = 0, _len = a2.length; _i < _len; index = ++_i) {
          value = a2[index];
          if (!reached) {
            if (value === item) {
              reached = true;
              continue;
            }
          } else {
            a2[index - 1] = a2[index];
          }
        }
        if (reached) {
          a2.length = a2.length - 1;
        }
        return a2;
      },
      pluckByCallback: function(a2, cb2) {
        var index, removed, value, _i, _len;
        if (a2.length < 1) {
          return a2;
        }
        removed = 0;
        for (index = _i = 0, _len = a2.length; _i < _len; index = ++_i) {
          value = a2[index];
          if (cb2(value, index)) {
            removed++;
            continue;
          }
          if (removed !== 0) {
            a2[index - removed] = a2[index];
          }
        }
        if (removed > 0) {
          a2.length = a2.length - removed;
        }
        return a2;
      },
      pluckMultiple: function(array2, indexesToRemove) {
        var i3, removedSoFar, _i, _len;
        if (array2.length < 1) {
          return array2;
        }
        removedSoFar = 0;
        indexesToRemove.sort();
        for (_i = 0, _len = indexesToRemove.length; _i < _len; _i++) {
          i3 = indexesToRemove[_i];
          this.pluck(array2, i3 - removedSoFar);
          removedSoFar++;
        }
        return array2;
      },
      injectByCallback: function(a2, toInject, shouldInject) {
        var i3, len, val, valA, valB, _i, _len;
        valA = null;
        valB = null;
        len = a2.length;
        if (len < 1) {
          a2.push(toInject);
          return a2;
        }
        for (i3 = _i = 0, _len = a2.length; _i < _len; i3 = ++_i) {
          val = a2[i3];
          valA = valB;
          valB = val;
          if (shouldInject(valA, valB, toInject)) {
            return a2.splice(i3, 0, toInject);
          }
        }
        a2.push(toInject);
        return a2;
      },
      injectInIndex: function(a2, index, toInject) {
        var i3, len, toPut, toPutNext;
        len = a2.length;
        i3 = index;
        if (len < 1) {
          a2.push(toInject);
          return a2;
        }
        toPut = toInject;
        toPutNext = null;
        for (; i3 <= len; i3++) {
          toPutNext = a2[i3];
          a2[i3] = toPut;
          toPut = toPutNext;
        }
        ;
        return null;
      }
    };
  }
});

// node_modules/utila/lib/classic.js
var require_classic = __commonJS({
  "node_modules/utila/lib/classic.js"(exports2, module2) {
    var classic;
    var __slice = [].slice;
    module2.exports = classic = {};
    classic.implement = function() {
      var classProto, classReference, desc, member, mixin, mixins, _i, _j, _len;
      mixins = 2 <= arguments.length ? __slice.call(arguments, 0, _i = arguments.length - 1) : (_i = 0, []), classReference = arguments[_i++];
      for (_j = 0, _len = mixins.length; _j < _len; _j++) {
        mixin = mixins[_j];
        classProto = classReference.prototype;
        for (member in mixin.prototype) {
          if (!Object.getOwnPropertyDescriptor(classProto, member)) {
            desc = Object.getOwnPropertyDescriptor(mixin.prototype, member);
            Object.defineProperty(classProto, member, desc);
          }
        }
      }
      return classReference;
    };
    classic.mix = function() {
      var classProto, classReference, desc, member, mixin, mixins, _i, _j, _len;
      mixins = 2 <= arguments.length ? __slice.call(arguments, 0, _i = arguments.length - 1) : (_i = 0, []), classReference = arguments[_i++];
      classProto = classReference.prototype;
      classReference.__mixinCloners = [];
      classReference.__applyClonersFor = function(instance, args) {
        var cloner, _j2, _len2, _ref;
        if (args == null) {
          args = null;
        }
        _ref = classReference.__mixinCloners;
        for (_j2 = 0, _len2 = _ref.length; _j2 < _len2; _j2++) {
          cloner = _ref[_j2];
          cloner.apply(instance, args);
        }
      };
      classReference.__mixinInitializers = [];
      classReference.__initMixinsFor = function(instance, args) {
        var initializer, _j2, _len2, _ref;
        if (args == null) {
          args = null;
        }
        _ref = classReference.__mixinInitializers;
        for (_j2 = 0, _len2 = _ref.length; _j2 < _len2; _j2++) {
          initializer = _ref[_j2];
          initializer.apply(instance, args);
        }
      };
      classReference.__mixinQuitters = [];
      classReference.__applyQuittersFor = function(instance, args) {
        var quitter, _j2, _len2, _ref;
        if (args == null) {
          args = null;
        }
        _ref = classReference.__mixinQuitters;
        for (_j2 = 0, _len2 = _ref.length; _j2 < _len2; _j2++) {
          quitter = _ref[_j2];
          quitter.apply(instance, args);
        }
      };
      for (_j = 0, _len = mixins.length; _j < _len; _j++) {
        mixin = mixins[_j];
        if (!(mixin.constructor instanceof Function)) {
          throw Error("Mixin should be a function");
        }
        for (member in mixin.prototype) {
          if (member.substr(0, 11) === "__initMixin") {
            classReference.__mixinInitializers.push(mixin.prototype[member]);
            continue;
          } else if (member.substr(0, 11) === "__clonerFor") {
            classReference.__mixinCloners.push(mixin.prototype[member]);
            continue;
          } else if (member.substr(0, 12) === "__quitterFor") {
            classReference.__mixinQuitters.push(mixin.prototype[member]);
            continue;
          }
          if (!Object.getOwnPropertyDescriptor(classProto, member)) {
            desc = Object.getOwnPropertyDescriptor(mixin.prototype, member);
            Object.defineProperty(classProto, member, desc);
          }
        }
      }
      return classReference;
    };
  }
});

// node_modules/utila/lib/_common.js
var require_common = __commonJS({
  "node_modules/utila/lib/_common.js"(exports2, module2) {
    var common2;
    module2.exports = common2 = {
      isBareObject: function(o2) {
        if (o2 != null && o2.constructor === Object) {
          return true;
        }
        return false;
      },
      typeOf: function(item) {
        var _ref;
        if (item === null) {
          return "null";
        }
        if (typeof item !== "object") {
          return typeof item;
        }
        if (Array.isArray(item)) {
          return "array";
        }
        if (item.nodeName) {
          if (item.nodeType === 1) {
            return "element";
          }
          if (item.nodeType === 3) {
            return (_ref = /\S/.test(item.nodeValue)) != null ? _ref : {
              "textnode": "whitespace"
            };
          }
        } else if (typeof item.length === "number") {
          if (item.callee) {
            return "arguments";
          }
        }
        return typeof item;
      },
      clone: function(item, includePrototype) {
        if (includePrototype == null) {
          includePrototype = false;
        }
        switch (common2.typeOf(item)) {
          case "array":
            return common2._cloneArray(item, includePrototype);
          case "object":
            return common2._cloneObject(item, includePrototype);
          default:
            return item;
        }
      },
      _cloneObject: function(o2, includePrototype) {
        var clone, key2;
        if (includePrototype == null) {
          includePrototype = false;
        }
        if (common2.isBareObject(o2)) {
          clone = {};
          for (key2 in o2) {
            clone[key2] = common2.clone(o2[key2], includePrototype);
          }
          return clone;
        } else {
          if (!includePrototype) {
            return o2;
          }
          if (o2 instanceof Function) {
            return o2;
          }
          clone = Object.create(o2.constructor.prototype);
          for (key2 in o2) {
            if (o2.hasOwnProperty(key2)) {
              clone[key2] = common2.clone(o2[key2], includePrototype);
            }
          }
          return clone;
        }
      },
      _cloneArray: function(a2, includePrototype) {
        var clone, i3;
        if (includePrototype == null) {
          includePrototype = false;
        }
        i3 = a2.length;
        clone = new Array(i3);
        while (i3--) {
          clone[i3] = common2.clone(a2[i3], includePrototype);
        }
        return clone;
      }
    };
  }
});

// node_modules/utila/lib/object.js
var require_object = __commonJS({
  "node_modules/utila/lib/object.js"(exports2, module2) {
    var object;
    var _common;
    var __hasProp = {}.hasOwnProperty;
    _common = require_common();
    module2.exports = object = {
      isBareObject: _common.isBareObject.bind(_common),
      isInstance: function(what) {
        return !this.isBareObject(what);
      },
      typeOf: _common.typeOf.bind(_common),
      clone: _common.clone.bind(_common),
      empty: function(o2) {
        var prop;
        for (prop in o2) {
          if (o2.hasOwnProperty(prop)) {
            delete o2[prop];
          }
        }
        return o2;
      },
      fastEmpty: function(o2) {
        var property;
        for (property in o2) {
          delete o2[property];
        }
        return o2;
      },
      overrideOnto: function(base, newValues) {
        var key2, newVal, oldVal;
        if (!this.isBareObject(newValues) || !this.isBareObject(base)) {
          return base;
        }
        for (key2 in base) {
          oldVal = base[key2];
          newVal = newValues[key2];
          if (newVal === void 0) {
            continue;
          }
          if (typeof newVal !== "object" || this.isInstance(newVal)) {
            base[key2] = this.clone(newVal);
          } else {
            if (typeof oldVal !== "object" || this.isInstance(oldVal)) {
              base[key2] = this.clone(newVal);
            } else {
              this.overrideOnto(oldVal, newVal);
            }
          }
        }
        return base;
      },
      override: function(base, newValues) {
        return this.overrideOnto(this.clone(base), newValues);
      },
      append: function(base, toAppend) {
        return this.appendOnto(this.clone(base), toAppend);
      },
      appendOnto: function(base, toAppend) {
        var key2, newVal, oldVal;
        if (!this.isBareObject(toAppend) || !this.isBareObject(base)) {
          return base;
        }
        for (key2 in toAppend) {
          if (!__hasProp.call(toAppend, key2))
            continue;
          newVal = toAppend[key2];
          if (newVal === void 0) {
            continue;
          }
          if (typeof newVal !== "object" || this.isInstance(newVal)) {
            base[key2] = newVal;
          } else {
            oldVal = base[key2];
            if (typeof oldVal !== "object" || this.isInstance(oldVal)) {
              base[key2] = this.clone(newVal);
            } else {
              this.appendOnto(oldVal, newVal);
            }
          }
        }
        return base;
      },
      groupProps: function(obj, groups) {
        var def, defs, grouped, key2, name, shouldAdd, val, _i, _len;
        grouped = {};
        for (name in groups) {
          defs = groups[name];
          grouped[name] = {};
        }
        grouped["rest"] = {};
        top:
          for (key2 in obj) {
            val = obj[key2];
            shouldAdd = false;
            for (name in groups) {
              defs = groups[name];
              if (!Array.isArray(defs)) {
                defs = [defs];
              }
              for (_i = 0, _len = defs.length; _i < _len; _i++) {
                def = defs[_i];
                if (typeof def === "string") {
                  if (key2 === def) {
                    shouldAdd = true;
                  }
                } else if (def instanceof RegExp) {
                  if (def.test(key2)) {
                    shouldAdd = true;
                  }
                } else if (def instanceof Function) {
                  if (def(key2)) {
                    shouldAdd = true;
                  }
                } else {
                  throw Error("Group definitions must either						be strings, regexes, or functions.");
                }
                if (shouldAdd) {
                  grouped[name][key2] = val;
                  continue top;
                }
              }
            }
            grouped["rest"][key2] = val;
          }
        return grouped;
      }
    };
  }
});

// node_modules/utila/lib/string.js
var require_string = __commonJS({
  "node_modules/utila/lib/string.js"(exports2, module2) {
    module2.exports = {
      pad: function(n2, width, z) {
        if (z == null) {
          z = "0";
        }
        n2 = n2 + "";
        if (n2.length >= width) {
          return n2;
        } else {
          return new Array(width - n2.length + 1).join(z) + n2;
        }
      }
    };
  }
});

// node_modules/utila/lib/Emitter.js
var require_Emitter = __commonJS({
  "node_modules/utila/lib/Emitter.js"(exports2, module2) {
    var Emitter;
    var array;
    array = require_array();
    module2.exports = Emitter = function() {
      function Emitter2() {
        this._listeners = {};
        this._listenersForAnyEvent = [];
        this._disabledEmitters = {};
      }
      Emitter2.prototype.on = function(eventName, listener) {
        if (this._listeners[eventName] == null) {
          this._listeners[eventName] = [];
        }
        this._listeners[eventName].push(listener);
        return this;
      };
      Emitter2.prototype.once = function(eventName, listener) {
        var cb2, ran, _this = this;
        ran = false;
        cb2 = function() {
          if (ran) {
            return;
          }
          ran = true;
          listener();
          return setTimeout(function() {
            return _this.removeEvent(eventName, cb2);
          }, 0);
        };
        this.on(eventName, cb2);
        return this;
      };
      Emitter2.prototype.onAnyEvent = function(listener) {
        this._listenersForAnyEvent.push(listener);
        return this;
      };
      Emitter2.prototype.removeEvent = function(eventName, listener) {
        if (this._listeners[eventName] == null) {
          return this;
        }
        array.pluckOneItem(this._listeners[eventName], listener);
        return this;
      };
      Emitter2.prototype.removeListeners = function(eventName) {
        if (this._listeners[eventName] == null) {
          return this;
        }
        this._listeners[eventName].length = 0;
        return this;
      };
      Emitter2.prototype.removeAllListeners = function() {
        var listeners, name, _ref;
        _ref = this._listeners;
        for (name in _ref) {
          listeners = _ref[name];
          listeners.length = 0;
        }
        return this;
      };
      Emitter2.prototype._emit = function(eventName, data) {
        var listener, _i, _j, _len, _len1, _ref, _ref1;
        _ref = this._listenersForAnyEvent;
        for (_i = 0, _len = _ref.length; _i < _len; _i++) {
          listener = _ref[_i];
          listener.call(this, data, eventName);
        }
        if (this._listeners[eventName] == null) {
          return;
        }
        _ref1 = this._listeners[eventName];
        for (_j = 0, _len1 = _ref1.length; _j < _len1; _j++) {
          listener = _ref1[_j];
          listener.call(this, data);
        }
      };
      Emitter2.prototype._throttleEmitterMethod = function(fnName, time) {
        var lastCallArgs, originalFn, pend, pending, runIt, timer, _this = this;
        if (time == null) {
          time = 1e3;
        }
        originalFn = this[fnName];
        if (typeof originalFn !== "function") {
          throw Error("this class does not have a method called '" + fnName + "'");
        }
        lastCallArgs = null;
        pending = false;
        timer = null;
        this[fnName] = function() {
          lastCallArgs = arguments;
          return pend();
        };
        pend = function() {
          if (pending) {
            clearTimeout(timer);
          }
          timer = setTimeout(runIt, time);
          return pending = true;
        };
        return runIt = function() {
          pending = false;
          return originalFn.apply(_this, lastCallArgs);
        };
      };
      Emitter2.prototype._disableEmitter = function(fnName) {
        if (this._disabledEmitters[fnName] != null) {
          throw Error("" + fnName + " is already a disabled emitter");
        }
        this._disabledEmitters[fnName] = this[fnName];
        return this[fnName] = function() {
        };
      };
      Emitter2.prototype._enableEmitter = function(fnName) {
        var fn;
        fn = this._disabledEmitters[fnName];
        if (fn == null) {
          throw Error("" + fnName + " is not a disabled emitter");
        }
        this[fnName] = fn;
        return delete this._disabledEmitters[fnName];
      };
      return Emitter2;
    }();
  }
});

// node_modules/utila/lib/utila.js
var require_utila = __commonJS({
  "node_modules/utila/lib/utila.js"(exports2, module2) {
    var utila;
    module2.exports = utila = {
      array: require_array(),
      classic: require_classic(),
      object: require_object(),
      string: require_string(),
      Emitter: require_Emitter()
    };
  }
});

// node_modules/dom-converter/lib/objectToSaneObject.js
var require_objectToSaneObject = __commonJS({
  "node_modules/dom-converter/lib/objectToSaneObject.js"(exports2, module2) {
    var object;
    var self2;
    var hasProp = {}.hasOwnProperty;
    object = require_utila().object;
    module2.exports = self2 = {
      sanitize: function(val) {
        return self2._toChildren(val);
      },
      _toChildren: function(val) {
        var ref2;
        if (object.isBareObject(val)) {
          return self2._objectToChildren(val);
        } else if (Array.isArray(val)) {
          return self2._arrayToChildren(val);
        } else if (val === null || typeof val === "undefined") {
          return [];
        } else if ((ref2 = typeof val) === "string" || ref2 === "number") {
          return [String(val)];
        } else {
          throw Error("not a valid child node: `" + val);
        }
      },
      _objectToChildren: function(o2) {
        var a2, cur, key2, val;
        a2 = [];
        for (key2 in o2) {
          if (!hasProp.call(o2, key2))
            continue;
          val = o2[key2];
          cur = {};
          cur[key2] = self2.sanitize(val);
          a2.push(cur);
        }
        return a2;
      },
      _arrayToChildren: function(a2) {
        var i3, len, ret, v;
        ret = [];
        for (i3 = 0, len = a2.length; i3 < len; i3++) {
          v = a2[i3];
          ret.push(self2._toNode(v));
        }
        return ret;
      },
      _toNode: function(o2) {
        var key2, keys, obj, ref2;
        if ((ref2 = typeof o2) === "string" || ref2 === "number") {
          return String(o2);
        } else if (object.isBareObject(o2)) {
          keys = Object.keys(o2);
          if (keys.length !== 1) {
            throw Error("a node must only have one key as tag name");
          }
          key2 = keys[0];
          obj = {};
          obj[key2] = self2._toChildren(o2[key2]);
          return obj;
        } else {
          throw Error("not a valid node: `" + o2 + "`");
        }
      }
    };
  }
});

// node_modules/dom-converter/lib/saneObjectToDom.js
var require_saneObjectToDom = __commonJS({
  "node_modules/dom-converter/lib/saneObjectToDom.js"(exports2, module2) {
    var self2;
    var hasProp = {}.hasOwnProperty;
    module2.exports = self2 = {
      convert: function(obj) {
        return self2._arrayToChildren(obj);
      },
      _arrayToChildren: function(a2, parent) {
        var children, j, len, node, prev, v;
        if (parent == null) {
          parent = null;
        }
        children = [];
        prev = null;
        for (j = 0, len = a2.length; j < len; j++) {
          v = a2[j];
          if (typeof v === "string") {
            node = self2._getTextNodeFor(v);
          } else {
            node = self2._objectToNode(v, parent);
            node.prev = null;
            node.next = null;
            node.parent = parent;
            if (prev != null) {
              node.prev = prev;
              prev.next = node;
            }
            prev = node;
          }
          children.push(node);
        }
        return children;
      },
      _objectToNode: function(o2) {
        var attribs, children, i3, k, key2, name, node, ref2, v, val;
        i3 = 0;
        for (k in o2) {
          if (!hasProp.call(o2, k))
            continue;
          v = o2[k];
          if (i3 > 0) {
            throw Error("_objectToNode() only accepts an object with one key/value");
          }
          key2 = k;
          val = v;
          i3++;
        }
        node = {};
        if (typeof key2 !== "string") {
          throw Error("_objectToNode()'s key must be a string of tag name and classes");
        }
        if (typeof val === "string") {
          children = [self2._getTextNodeFor(val)];
        } else if (Array.isArray(val)) {
          children = self2._arrayToChildren(val, node);
        } else {
          inspect(o2);
          throw Error("_objectToNode()'s key's value must only be a string or an array");
        }
        node.type = "tag";
        ref2 = self2._parseTag(key2), name = ref2.name, attribs = ref2.attribs;
        node.name = name;
        node.attribs = attribs;
        node.children = children;
        return node;
      },
      _getTextNodeFor: function(s2) {
        return {
          type: "text",
          data: s2
        };
      },
      _nameRx: /^[a-zA-Z\-\_]{1}[a-zA-Z0-9\-\_]*$/,
      _parseTag: function(k) {
        var attribs, classes, cls, id, m, name, parts;
        if (!k.match(/^[a-zA-Z0-9\#\-\_\.\[\]\"\'\=\,\s]+$/) || k.match(/^[0-9]+/)) {
          throw Error("cannot parse tag `" + k + "`");
        }
        attribs = {};
        parts = {
          name: "",
          attribs
        };
        if (m = k.match(/^([^\.#]+)/)) {
          name = m[1];
          if (!name.match(self2._nameRx)) {
            throw Error("tag name `" + name + "` is not valid");
          }
          parts.name = name;
          k = k.substr(name.length, k.length);
        }
        if (m = k.match(/^#([a-zA-Z0-9\-]+)/)) {
          id = m[1];
          if (!id.match(self2._nameRx)) {
            throw Error("tag id `" + id + "` is not valid");
          }
          attribs.id = id;
          k = k.substr(id.length + 1, k.length);
        }
        classes = [];
        while (m = k.match(/\.([a-zA-Z0-9\-\_]+)/)) {
          cls = m[1];
          if (!cls.match(self2._nameRx)) {
            throw Error("tag class `" + cls + "` is not valid");
          }
          classes.push(cls);
          k = k.replace("." + cls, "");
        }
        if (classes.length) {
          attribs["class"] = classes.join(" ");
        }
        return parts;
      }
    };
  }
});

// node_modules/dom-converter/lib/domToMarkup.js
var require_domToMarkup = __commonJS({
  "node_modules/dom-converter/lib/domToMarkup.js"() {
  }
});

// node_modules/dom-converter/lib/domConverter.js
var require_domConverter = __commonJS({
  "node_modules/dom-converter/lib/domConverter.js"(exports2, module2) {
    var domToMarkup;
    var object;
    var objectToSaneObject;
    var saneObjectToDom;
    var self2;
    objectToSaneObject = require_objectToSaneObject();
    saneObjectToDom = require_saneObjectToDom();
    domToMarkup = require_domToMarkup();
    object = require_utila().object;
    module2.exports = self2 = {
      objectToDom: function(o2) {
        o2 = self2._object2SaneObject(o2);
        return saneObjectToDom.convert(o2);
      },
      object2markup: function(o2) {
        var dom;
        dom = self2.objectToDom(o2);
        return domToMarkup.convert(dom);
      },
      domToMarkup: function(dom) {
        return domToMarkup.convert(dom);
      },
      _object2SaneObject: function(o2) {
        if (!Array.isArray(o2)) {
          if (!object.isBareObject(o2)) {
            throw Error("toDom() only accepts arrays and bare objects as input");
          }
        }
        return objectToSaneObject.sanitize(o2);
      }
    };
  }
});

// node_modules/lodash/_listCacheClear.js
var require_listCacheClear = __commonJS({
  "node_modules/lodash/_listCacheClear.js"(exports2, module2) {
    function listCacheClear() {
      this.__data__ = [];
      this.size = 0;
    }
    module2.exports = listCacheClear;
  }
});

// node_modules/lodash/eq.js
var require_eq = __commonJS({
  "node_modules/lodash/eq.js"(exports2, module2) {
    function eq(value, other) {
      return value === other || value !== value && other !== other;
    }
    module2.exports = eq;
  }
});

// node_modules/lodash/_assocIndexOf.js
var require_assocIndexOf = __commonJS({
  "node_modules/lodash/_assocIndexOf.js"(exports2, module2) {
    var eq = require_eq();
    function assocIndexOf(array, key2) {
      var length = array.length;
      while (length--) {
        if (eq(array[length][0], key2)) {
          return length;
        }
      }
      return -1;
    }
    module2.exports = assocIndexOf;
  }
});

// node_modules/lodash/_listCacheDelete.js
var require_listCacheDelete = __commonJS({
  "node_modules/lodash/_listCacheDelete.js"(exports2, module2) {
    var assocIndexOf = require_assocIndexOf();
    var arrayProto = Array.prototype;
    var splice = arrayProto.splice;
    function listCacheDelete(key2) {
      var data = this.__data__, index = assocIndexOf(data, key2);
      if (index < 0) {
        return false;
      }
      var lastIndex = data.length - 1;
      if (index == lastIndex) {
        data.pop();
      } else {
        splice.call(data, index, 1);
      }
      --this.size;
      return true;
    }
    module2.exports = listCacheDelete;
  }
});

// node_modules/lodash/_listCacheGet.js
var require_listCacheGet = __commonJS({
  "node_modules/lodash/_listCacheGet.js"(exports2, module2) {
    var assocIndexOf = require_assocIndexOf();
    function listCacheGet(key2) {
      var data = this.__data__, index = assocIndexOf(data, key2);
      return index < 0 ? void 0 : data[index][1];
    }
    module2.exports = listCacheGet;
  }
});

// node_modules/lodash/_listCacheHas.js
var require_listCacheHas = __commonJS({
  "node_modules/lodash/_listCacheHas.js"(exports2, module2) {
    var assocIndexOf = require_assocIndexOf();
    function listCacheHas(key2) {
      return assocIndexOf(this.__data__, key2) > -1;
    }
    module2.exports = listCacheHas;
  }
});

// node_modules/lodash/_listCacheSet.js
var require_listCacheSet = __commonJS({
  "node_modules/lodash/_listCacheSet.js"(exports2, module2) {
    var assocIndexOf = require_assocIndexOf();
    function listCacheSet(key2, value) {
      var data = this.__data__, index = assocIndexOf(data, key2);
      if (index < 0) {
        ++this.size;
        data.push([key2, value]);
      } else {
        data[index][1] = value;
      }
      return this;
    }
    module2.exports = listCacheSet;
  }
});

// node_modules/lodash/_ListCache.js
var require_ListCache = __commonJS({
  "node_modules/lodash/_ListCache.js"(exports2, module2) {
    var listCacheClear = require_listCacheClear();
    var listCacheDelete = require_listCacheDelete();
    var listCacheGet = require_listCacheGet();
    var listCacheHas = require_listCacheHas();
    var listCacheSet = require_listCacheSet();
    function ListCache(entries) {
      var index = -1, length = entries == null ? 0 : entries.length;
      this.clear();
      while (++index < length) {
        var entry = entries[index];
        this.set(entry[0], entry[1]);
      }
    }
    ListCache.prototype.clear = listCacheClear;
    ListCache.prototype["delete"] = listCacheDelete;
    ListCache.prototype.get = listCacheGet;
    ListCache.prototype.has = listCacheHas;
    ListCache.prototype.set = listCacheSet;
    module2.exports = ListCache;
  }
});

// node_modules/lodash/_stackClear.js
var require_stackClear = __commonJS({
  "node_modules/lodash/_stackClear.js"(exports2, module2) {
    var ListCache = require_ListCache();
    function stackClear() {
      this.__data__ = new ListCache();
      this.size = 0;
    }
    module2.exports = stackClear;
  }
});

// node_modules/lodash/_stackDelete.js
var require_stackDelete = __commonJS({
  "node_modules/lodash/_stackDelete.js"(exports2, module2) {
    function stackDelete(key2) {
      var data = this.__data__, result2 = data["delete"](key2);
      this.size = data.size;
      return result2;
    }
    module2.exports = stackDelete;
  }
});

// node_modules/lodash/_stackGet.js
var require_stackGet = __commonJS({
  "node_modules/lodash/_stackGet.js"(exports2, module2) {
    function stackGet(key2) {
      return this.__data__.get(key2);
    }
    module2.exports = stackGet;
  }
});

// node_modules/lodash/_stackHas.js
var require_stackHas = __commonJS({
  "node_modules/lodash/_stackHas.js"(exports2, module2) {
    function stackHas(key2) {
      return this.__data__.has(key2);
    }
    module2.exports = stackHas;
  }
});

// node_modules/lodash/isObject.js
var require_isObject = __commonJS({
  "node_modules/lodash/isObject.js"(exports2, module2) {
    function isObject2(value) {
      var type3 = typeof value;
      return value != null && (type3 == "object" || type3 == "function");
    }
    module2.exports = isObject2;
  }
});

// node_modules/lodash/isFunction.js
var require_isFunction = __commonJS({
  "node_modules/lodash/isFunction.js"(exports2, module2) {
    var baseGetTag = require_baseGetTag();
    var isObject2 = require_isObject();
    var asyncTag = "[object AsyncFunction]";
    var funcTag = "[object Function]";
    var genTag = "[object GeneratorFunction]";
    var proxyTag = "[object Proxy]";
    function isFunction(value) {
      if (!isObject2(value)) {
        return false;
      }
      var tag = baseGetTag(value);
      return tag == funcTag || tag == genTag || tag == asyncTag || tag == proxyTag;
    }
    module2.exports = isFunction;
  }
});

// node_modules/lodash/_coreJsData.js
var require_coreJsData = __commonJS({
  "node_modules/lodash/_coreJsData.js"(exports2, module2) {
    var root = require_root();
    var coreJsData = root["__core-js_shared__"];
    module2.exports = coreJsData;
  }
});

// node_modules/lodash/_isMasked.js
var require_isMasked = __commonJS({
  "node_modules/lodash/_isMasked.js"(exports2, module2) {
    var coreJsData = require_coreJsData();
    var maskSrcKey = function() {
      var uid = /[^.]+$/.exec(coreJsData && coreJsData.keys && coreJsData.keys.IE_PROTO || "");
      return uid ? "Symbol(src)_1." + uid : "";
    }();
    function isMasked(func2) {
      return !!maskSrcKey && maskSrcKey in func2;
    }
    module2.exports = isMasked;
  }
});

// node_modules/lodash/_toSource.js
var require_toSource = __commonJS({
  "node_modules/lodash/_toSource.js"(exports2, module2) {
    var funcProto = Function.prototype;
    var funcToString = funcProto.toString;
    function toSource(func2) {
      if (func2 != null) {
        try {
          return funcToString.call(func2);
        } catch (e2) {
        }
        try {
          return func2 + "";
        } catch (e2) {
        }
      }
      return "";
    }
    module2.exports = toSource;
  }
});

// node_modules/lodash/_baseIsNative.js
var require_baseIsNative = __commonJS({
  "node_modules/lodash/_baseIsNative.js"(exports2, module2) {
    var isFunction = require_isFunction();
    var isMasked = require_isMasked();
    var isObject2 = require_isObject();
    var toSource = require_toSource();
    var reRegExpChar = /[\\^$.*+?()[\]{}|]/g;
    var reIsHostCtor = /^\[object .+?Constructor\]$/;
    var funcProto = Function.prototype;
    var objectProto = Object.prototype;
    var funcToString = funcProto.toString;
    var hasOwnProperty2 = objectProto.hasOwnProperty;
    var reIsNative = RegExp("^" + funcToString.call(hasOwnProperty2).replace(reRegExpChar, "\\$&").replace(/hasOwnProperty|(function).*?(?=\\\()| for .+?(?=\\\])/g, "$1.*?") + "$");
    function baseIsNative(value) {
      if (!isObject2(value) || isMasked(value)) {
        return false;
      }
      var pattern = isFunction(value) ? reIsNative : reIsHostCtor;
      return pattern.test(toSource(value));
    }
    module2.exports = baseIsNative;
  }
});

// node_modules/lodash/_getValue.js
var require_getValue = __commonJS({
  "node_modules/lodash/_getValue.js"(exports2, module2) {
    function getValue2(object, key2) {
      return object == null ? void 0 : object[key2];
    }
    module2.exports = getValue2;
  }
});

// node_modules/lodash/_getNative.js
var require_getNative = __commonJS({
  "node_modules/lodash/_getNative.js"(exports2, module2) {
    var baseIsNative = require_baseIsNative();
    var getValue2 = require_getValue();
    function getNative(object, key2) {
      var value = getValue2(object, key2);
      return baseIsNative(value) ? value : void 0;
    }
    module2.exports = getNative;
  }
});

// node_modules/lodash/_Map.js
var require_Map = __commonJS({
  "node_modules/lodash/_Map.js"(exports2, module2) {
    var getNative = require_getNative();
    var root = require_root();
    var Map2 = getNative(root, "Map");
    module2.exports = Map2;
  }
});

// node_modules/lodash/_nativeCreate.js
var require_nativeCreate = __commonJS({
  "node_modules/lodash/_nativeCreate.js"(exports2, module2) {
    var getNative = require_getNative();
    var nativeCreate = getNative(Object, "create");
    module2.exports = nativeCreate;
  }
});

// node_modules/lodash/_hashClear.js
var require_hashClear = __commonJS({
  "node_modules/lodash/_hashClear.js"(exports2, module2) {
    var nativeCreate = require_nativeCreate();
    function hashClear() {
      this.__data__ = nativeCreate ? nativeCreate(null) : {};
      this.size = 0;
    }
    module2.exports = hashClear;
  }
});

// node_modules/lodash/_hashDelete.js
var require_hashDelete = __commonJS({
  "node_modules/lodash/_hashDelete.js"(exports2, module2) {
    function hashDelete(key2) {
      var result2 = this.has(key2) && delete this.__data__[key2];
      this.size -= result2 ? 1 : 0;
      return result2;
    }
    module2.exports = hashDelete;
  }
});

// node_modules/lodash/_hashGet.js
var require_hashGet = __commonJS({
  "node_modules/lodash/_hashGet.js"(exports2, module2) {
    var nativeCreate = require_nativeCreate();
    var HASH_UNDEFINED = "__lodash_hash_undefined__";
    var objectProto = Object.prototype;
    var hasOwnProperty2 = objectProto.hasOwnProperty;
    function hashGet(key2) {
      var data = this.__data__;
      if (nativeCreate) {
        var result2 = data[key2];
        return result2 === HASH_UNDEFINED ? void 0 : result2;
      }
      return hasOwnProperty2.call(data, key2) ? data[key2] : void 0;
    }
    module2.exports = hashGet;
  }
});

// node_modules/lodash/_hashHas.js
var require_hashHas = __commonJS({
  "node_modules/lodash/_hashHas.js"(exports2, module2) {
    var nativeCreate = require_nativeCreate();
    var objectProto = Object.prototype;
    var hasOwnProperty2 = objectProto.hasOwnProperty;
    function hashHas(key2) {
      var data = this.__data__;
      return nativeCreate ? data[key2] !== void 0 : hasOwnProperty2.call(data, key2);
    }
    module2.exports = hashHas;
  }
});

// node_modules/lodash/_hashSet.js
var require_hashSet = __commonJS({
  "node_modules/lodash/_hashSet.js"(exports2, module2) {
    var nativeCreate = require_nativeCreate();
    var HASH_UNDEFINED = "__lodash_hash_undefined__";
    function hashSet(key2, value) {
      var data = this.__data__;
      this.size += this.has(key2) ? 0 : 1;
      data[key2] = nativeCreate && value === void 0 ? HASH_UNDEFINED : value;
      return this;
    }
    module2.exports = hashSet;
  }
});

// node_modules/lodash/_Hash.js
var require_Hash = __commonJS({
  "node_modules/lodash/_Hash.js"(exports2, module2) {
    var hashClear = require_hashClear();
    var hashDelete = require_hashDelete();
    var hashGet = require_hashGet();
    var hashHas = require_hashHas();
    var hashSet = require_hashSet();
    function Hash(entries) {
      var index = -1, length = entries == null ? 0 : entries.length;
      this.clear();
      while (++index < length) {
        var entry = entries[index];
        this.set(entry[0], entry[1]);
      }
    }
    Hash.prototype.clear = hashClear;
    Hash.prototype["delete"] = hashDelete;
    Hash.prototype.get = hashGet;
    Hash.prototype.has = hashHas;
    Hash.prototype.set = hashSet;
    module2.exports = Hash;
  }
});

// node_modules/lodash/_mapCacheClear.js
var require_mapCacheClear = __commonJS({
  "node_modules/lodash/_mapCacheClear.js"(exports2, module2) {
    var Hash = require_Hash();
    var ListCache = require_ListCache();
    var Map2 = require_Map();
    function mapCacheClear() {
      this.size = 0;
      this.__data__ = {
        "hash": new Hash(),
        "map": new (Map2 || ListCache)(),
        "string": new Hash()
      };
    }
    module2.exports = mapCacheClear;
  }
});

// node_modules/lodash/_isKeyable.js
var require_isKeyable = __commonJS({
  "node_modules/lodash/_isKeyable.js"(exports2, module2) {
    function isKeyable(value) {
      var type3 = typeof value;
      return type3 == "string" || type3 == "number" || type3 == "symbol" || type3 == "boolean" ? value !== "__proto__" : value === null;
    }
    module2.exports = isKeyable;
  }
});

// node_modules/lodash/_getMapData.js
var require_getMapData = __commonJS({
  "node_modules/lodash/_getMapData.js"(exports2, module2) {
    var isKeyable = require_isKeyable();
    function getMapData(map2, key2) {
      var data = map2.__data__;
      return isKeyable(key2) ? data[typeof key2 == "string" ? "string" : "hash"] : data.map;
    }
    module2.exports = getMapData;
  }
});

// node_modules/lodash/_mapCacheDelete.js
var require_mapCacheDelete = __commonJS({
  "node_modules/lodash/_mapCacheDelete.js"(exports2, module2) {
    var getMapData = require_getMapData();
    function mapCacheDelete(key2) {
      var result2 = getMapData(this, key2)["delete"](key2);
      this.size -= result2 ? 1 : 0;
      return result2;
    }
    module2.exports = mapCacheDelete;
  }
});

// node_modules/lodash/_mapCacheGet.js
var require_mapCacheGet = __commonJS({
  "node_modules/lodash/_mapCacheGet.js"(exports2, module2) {
    var getMapData = require_getMapData();
    function mapCacheGet(key2) {
      return getMapData(this, key2).get(key2);
    }
    module2.exports = mapCacheGet;
  }
});

// node_modules/lodash/_mapCacheHas.js
var require_mapCacheHas = __commonJS({
  "node_modules/lodash/_mapCacheHas.js"(exports2, module2) {
    var getMapData = require_getMapData();
    function mapCacheHas(key2) {
      return getMapData(this, key2).has(key2);
    }
    module2.exports = mapCacheHas;
  }
});

// node_modules/lodash/_mapCacheSet.js
var require_mapCacheSet = __commonJS({
  "node_modules/lodash/_mapCacheSet.js"(exports2, module2) {
    var getMapData = require_getMapData();
    function mapCacheSet(key2, value) {
      var data = getMapData(this, key2), size = data.size;
      data.set(key2, value);
      this.size += data.size == size ? 0 : 1;
      return this;
    }
    module2.exports = mapCacheSet;
  }
});

// node_modules/lodash/_MapCache.js
var require_MapCache = __commonJS({
  "node_modules/lodash/_MapCache.js"(exports2, module2) {
    var mapCacheClear = require_mapCacheClear();
    var mapCacheDelete = require_mapCacheDelete();
    var mapCacheGet = require_mapCacheGet();
    var mapCacheHas = require_mapCacheHas();
    var mapCacheSet = require_mapCacheSet();
    function MapCache(entries) {
      var index = -1, length = entries == null ? 0 : entries.length;
      this.clear();
      while (++index < length) {
        var entry = entries[index];
        this.set(entry[0], entry[1]);
      }
    }
    MapCache.prototype.clear = mapCacheClear;
    MapCache.prototype["delete"] = mapCacheDelete;
    MapCache.prototype.get = mapCacheGet;
    MapCache.prototype.has = mapCacheHas;
    MapCache.prototype.set = mapCacheSet;
    module2.exports = MapCache;
  }
});

// node_modules/lodash/_stackSet.js
var require_stackSet = __commonJS({
  "node_modules/lodash/_stackSet.js"(exports2, module2) {
    var ListCache = require_ListCache();
    var Map2 = require_Map();
    var MapCache = require_MapCache();
    var LARGE_ARRAY_SIZE = 200;
    function stackSet(key2, value) {
      var data = this.__data__;
      if (data instanceof ListCache) {
        var pairs2 = data.__data__;
        if (!Map2 || pairs2.length < LARGE_ARRAY_SIZE - 1) {
          pairs2.push([key2, value]);
          this.size = ++data.size;
          return this;
        }
        data = this.__data__ = new MapCache(pairs2);
      }
      data.set(key2, value);
      this.size = data.size;
      return this;
    }
    module2.exports = stackSet;
  }
});

// node_modules/lodash/_Stack.js
var require_Stack = __commonJS({
  "node_modules/lodash/_Stack.js"(exports2, module2) {
    var ListCache = require_ListCache();
    var stackClear = require_stackClear();
    var stackDelete = require_stackDelete();
    var stackGet = require_stackGet();
    var stackHas = require_stackHas();
    var stackSet = require_stackSet();
    function Stack(entries) {
      var data = this.__data__ = new ListCache(entries);
      this.size = data.size;
    }
    Stack.prototype.clear = stackClear;
    Stack.prototype["delete"] = stackDelete;
    Stack.prototype.get = stackGet;
    Stack.prototype.has = stackHas;
    Stack.prototype.set = stackSet;
    module2.exports = Stack;
  }
});

// node_modules/lodash/_defineProperty.js
var require_defineProperty = __commonJS({
  "node_modules/lodash/_defineProperty.js"(exports2, module2) {
    var getNative = require_getNative();
    var defineProperty = function() {
      try {
        var func2 = getNative(Object, "defineProperty");
        func2({}, "", {});
        return func2;
      } catch (e2) {
      }
    }();
    module2.exports = defineProperty;
  }
});

// node_modules/lodash/_baseAssignValue.js
var require_baseAssignValue = __commonJS({
  "node_modules/lodash/_baseAssignValue.js"(exports2, module2) {
    var defineProperty = require_defineProperty();
    function baseAssignValue(object, key2, value) {
      if (key2 == "__proto__" && defineProperty) {
        defineProperty(object, key2, {
          "configurable": true,
          "enumerable": true,
          "value": value,
          "writable": true
        });
      } else {
        object[key2] = value;
      }
    }
    module2.exports = baseAssignValue;
  }
});

// node_modules/lodash/_assignMergeValue.js
var require_assignMergeValue = __commonJS({
  "node_modules/lodash/_assignMergeValue.js"(exports2, module2) {
    var baseAssignValue = require_baseAssignValue();
    var eq = require_eq();
    function assignMergeValue(object, key2, value) {
      if (value !== void 0 && !eq(object[key2], value) || value === void 0 && !(key2 in object)) {
        baseAssignValue(object, key2, value);
      }
    }
    module2.exports = assignMergeValue;
  }
});

// node_modules/lodash/_createBaseFor.js
var require_createBaseFor = __commonJS({
  "node_modules/lodash/_createBaseFor.js"(exports2, module2) {
    function createBaseFor(fromRight) {
      return function(object, iteratee, keysFunc) {
        var index = -1, iterable = Object(object), props = keysFunc(object), length = props.length;
        while (length--) {
          var key2 = props[fromRight ? length : ++index];
          if (iteratee(iterable[key2], key2, iterable) === false) {
            break;
          }
        }
        return object;
      };
    }
    module2.exports = createBaseFor;
  }
});

// node_modules/lodash/_baseFor.js
var require_baseFor = __commonJS({
  "node_modules/lodash/_baseFor.js"(exports2, module2) {
    var createBaseFor = require_createBaseFor();
    var baseFor = createBaseFor();
    module2.exports = baseFor;
  }
});

// node_modules/lodash/_cloneBuffer.js
var require_cloneBuffer = __commonJS({
  "node_modules/lodash/_cloneBuffer.js"(exports2, module2) {
    var root = require_root();
    var freeExports = typeof exports2 == "object" && exports2 && !exports2.nodeType && exports2;
    var freeModule = freeExports && typeof module2 == "object" && module2 && !module2.nodeType && module2;
    var moduleExports = freeModule && freeModule.exports === freeExports;
    var Buffer2 = moduleExports ? root.Buffer : void 0;
    var allocUnsafe = Buffer2 ? Buffer2.allocUnsafe : void 0;
    function cloneBuffer(buffer2, isDeep) {
      if (isDeep) {
        return buffer2.slice();
      }
      var length = buffer2.length, result2 = allocUnsafe ? allocUnsafe(length) : new buffer2.constructor(length);
      buffer2.copy(result2);
      return result2;
    }
    module2.exports = cloneBuffer;
  }
});

// node_modules/lodash/_Uint8Array.js
var require_Uint8Array = __commonJS({
  "node_modules/lodash/_Uint8Array.js"(exports2, module2) {
    var root = require_root();
    var Uint8Array2 = root.Uint8Array;
    module2.exports = Uint8Array2;
  }
});

// node_modules/lodash/_cloneArrayBuffer.js
var require_cloneArrayBuffer = __commonJS({
  "node_modules/lodash/_cloneArrayBuffer.js"(exports2, module2) {
    var Uint8Array2 = require_Uint8Array();
    function cloneArrayBuffer(arrayBuffer) {
      var result2 = new arrayBuffer.constructor(arrayBuffer.byteLength);
      new Uint8Array2(result2).set(new Uint8Array2(arrayBuffer));
      return result2;
    }
    module2.exports = cloneArrayBuffer;
  }
});

// node_modules/lodash/_cloneTypedArray.js
var require_cloneTypedArray = __commonJS({
  "node_modules/lodash/_cloneTypedArray.js"(exports2, module2) {
    var cloneArrayBuffer = require_cloneArrayBuffer();
    function cloneTypedArray(typedArray, isDeep) {
      var buffer2 = isDeep ? cloneArrayBuffer(typedArray.buffer) : typedArray.buffer;
      return new typedArray.constructor(buffer2, typedArray.byteOffset, typedArray.length);
    }
    module2.exports = cloneTypedArray;
  }
});

// node_modules/lodash/_copyArray.js
var require_copyArray = __commonJS({
  "node_modules/lodash/_copyArray.js"(exports2, module2) {
    function copyArray(source, array) {
      var index = -1, length = source.length;
      array || (array = Array(length));
      while (++index < length) {
        array[index] = source[index];
      }
      return array;
    }
    module2.exports = copyArray;
  }
});

// node_modules/lodash/_baseCreate.js
var require_baseCreate = __commonJS({
  "node_modules/lodash/_baseCreate.js"(exports2, module2) {
    var isObject2 = require_isObject();
    var objectCreate = Object.create;
    var baseCreate = function() {
      function object() {
      }
      return function(proto) {
        if (!isObject2(proto)) {
          return {};
        }
        if (objectCreate) {
          return objectCreate(proto);
        }
        object.prototype = proto;
        var result2 = new object();
        object.prototype = void 0;
        return result2;
      };
    }();
    module2.exports = baseCreate;
  }
});

// node_modules/lodash/_isPrototype.js
var require_isPrototype = __commonJS({
  "node_modules/lodash/_isPrototype.js"(exports2, module2) {
    var objectProto = Object.prototype;
    function isPrototype(value) {
      var Ctor = value && value.constructor, proto = typeof Ctor == "function" && Ctor.prototype || objectProto;
      return value === proto;
    }
    module2.exports = isPrototype;
  }
});

// node_modules/lodash/_initCloneObject.js
var require_initCloneObject = __commonJS({
  "node_modules/lodash/_initCloneObject.js"(exports2, module2) {
    var baseCreate = require_baseCreate();
    var getPrototype = require_getPrototype();
    var isPrototype = require_isPrototype();
    function initCloneObject(object) {
      return typeof object.constructor == "function" && !isPrototype(object) ? baseCreate(getPrototype(object)) : {};
    }
    module2.exports = initCloneObject;
  }
});

// node_modules/lodash/_baseIsArguments.js
var require_baseIsArguments = __commonJS({
  "node_modules/lodash/_baseIsArguments.js"(exports2, module2) {
    var baseGetTag = require_baseGetTag();
    var isObjectLike = require_isObjectLike();
    var argsTag = "[object Arguments]";
    function baseIsArguments(value) {
      return isObjectLike(value) && baseGetTag(value) == argsTag;
    }
    module2.exports = baseIsArguments;
  }
});

// node_modules/lodash/isArguments.js
var require_isArguments = __commonJS({
  "node_modules/lodash/isArguments.js"(exports2, module2) {
    var baseIsArguments = require_baseIsArguments();
    var isObjectLike = require_isObjectLike();
    var objectProto = Object.prototype;
    var hasOwnProperty2 = objectProto.hasOwnProperty;
    var propertyIsEnumerable = objectProto.propertyIsEnumerable;
    var isArguments = baseIsArguments(function() {
      return arguments;
    }()) ? baseIsArguments : function(value) {
      return isObjectLike(value) && hasOwnProperty2.call(value, "callee") && !propertyIsEnumerable.call(value, "callee");
    };
    module2.exports = isArguments;
  }
});

// node_modules/lodash/isArray.js
var require_isArray = __commonJS({
  "node_modules/lodash/isArray.js"(exports2, module2) {
    var isArray = Array.isArray;
    module2.exports = isArray;
  }
});

// node_modules/lodash/isLength.js
var require_isLength = __commonJS({
  "node_modules/lodash/isLength.js"(exports2, module2) {
    var MAX_SAFE_INTEGER = 9007199254740991;
    function isLength(value) {
      return typeof value == "number" && value > -1 && value % 1 == 0 && value <= MAX_SAFE_INTEGER;
    }
    module2.exports = isLength;
  }
});

// node_modules/lodash/isArrayLike.js
var require_isArrayLike = __commonJS({
  "node_modules/lodash/isArrayLike.js"(exports2, module2) {
    var isFunction = require_isFunction();
    var isLength = require_isLength();
    function isArrayLike(value) {
      return value != null && isLength(value.length) && !isFunction(value);
    }
    module2.exports = isArrayLike;
  }
});

// node_modules/lodash/isArrayLikeObject.js
var require_isArrayLikeObject = __commonJS({
  "node_modules/lodash/isArrayLikeObject.js"(exports2, module2) {
    var isArrayLike = require_isArrayLike();
    var isObjectLike = require_isObjectLike();
    function isArrayLikeObject(value) {
      return isObjectLike(value) && isArrayLike(value);
    }
    module2.exports = isArrayLikeObject;
  }
});

// node_modules/lodash/stubFalse.js
var require_stubFalse = __commonJS({
  "node_modules/lodash/stubFalse.js"(exports2, module2) {
    function stubFalse() {
      return false;
    }
    module2.exports = stubFalse;
  }
});

// node_modules/lodash/isBuffer.js
var require_isBuffer = __commonJS({
  "node_modules/lodash/isBuffer.js"(exports2, module2) {
    var root = require_root();
    var stubFalse = require_stubFalse();
    var freeExports = typeof exports2 == "object" && exports2 && !exports2.nodeType && exports2;
    var freeModule = freeExports && typeof module2 == "object" && module2 && !module2.nodeType && module2;
    var moduleExports = freeModule && freeModule.exports === freeExports;
    var Buffer2 = moduleExports ? root.Buffer : void 0;
    var nativeIsBuffer = Buffer2 ? Buffer2.isBuffer : void 0;
    var isBuffer = nativeIsBuffer || stubFalse;
    module2.exports = isBuffer;
  }
});

// node_modules/lodash/_baseIsTypedArray.js
var require_baseIsTypedArray = __commonJS({
  "node_modules/lodash/_baseIsTypedArray.js"(exports2, module2) {
    var baseGetTag = require_baseGetTag();
    var isLength = require_isLength();
    var isObjectLike = require_isObjectLike();
    var argsTag = "[object Arguments]";
    var arrayTag = "[object Array]";
    var boolTag = "[object Boolean]";
    var dateTag = "[object Date]";
    var errorTag = "[object Error]";
    var funcTag = "[object Function]";
    var mapTag = "[object Map]";
    var numberTag = "[object Number]";
    var objectTag = "[object Object]";
    var regexpTag = "[object RegExp]";
    var setTag = "[object Set]";
    var stringTag = "[object String]";
    var weakMapTag = "[object WeakMap]";
    var arrayBufferTag = "[object ArrayBuffer]";
    var dataViewTag = "[object DataView]";
    var float32Tag = "[object Float32Array]";
    var float64Tag = "[object Float64Array]";
    var int8Tag = "[object Int8Array]";
    var int16Tag = "[object Int16Array]";
    var int32Tag = "[object Int32Array]";
    var uint8Tag = "[object Uint8Array]";
    var uint8ClampedTag = "[object Uint8ClampedArray]";
    var uint16Tag = "[object Uint16Array]";
    var uint32Tag = "[object Uint32Array]";
    var typedArrayTags = {};
    typedArrayTags[float32Tag] = typedArrayTags[float64Tag] = typedArrayTags[int8Tag] = typedArrayTags[int16Tag] = typedArrayTags[int32Tag] = typedArrayTags[uint8Tag] = typedArrayTags[uint8ClampedTag] = typedArrayTags[uint16Tag] = typedArrayTags[uint32Tag] = true;
    typedArrayTags[argsTag] = typedArrayTags[arrayTag] = typedArrayTags[arrayBufferTag] = typedArrayTags[boolTag] = typedArrayTags[dataViewTag] = typedArrayTags[dateTag] = typedArrayTags[errorTag] = typedArrayTags[funcTag] = typedArrayTags[mapTag] = typedArrayTags[numberTag] = typedArrayTags[objectTag] = typedArrayTags[regexpTag] = typedArrayTags[setTag] = typedArrayTags[stringTag] = typedArrayTags[weakMapTag] = false;
    function baseIsTypedArray(value) {
      return isObjectLike(value) && isLength(value.length) && !!typedArrayTags[baseGetTag(value)];
    }
    module2.exports = baseIsTypedArray;
  }
});

// node_modules/lodash/_baseUnary.js
var require_baseUnary = __commonJS({
  "node_modules/lodash/_baseUnary.js"(exports2, module2) {
    function baseUnary(func2) {
      return function(value) {
        return func2(value);
      };
    }
    module2.exports = baseUnary;
  }
});

// node_modules/lodash/_nodeUtil.js
var require_nodeUtil = __commonJS({
  "node_modules/lodash/_nodeUtil.js"(exports2, module2) {
    var freeGlobal = require_freeGlobal();
    var freeExports = typeof exports2 == "object" && exports2 && !exports2.nodeType && exports2;
    var freeModule = freeExports && typeof module2 == "object" && module2 && !module2.nodeType && module2;
    var moduleExports = freeModule && freeModule.exports === freeExports;
    var freeProcess = moduleExports && freeGlobal.process;
    var nodeUtil = function() {
      try {
        var types2 = freeModule && freeModule.require && freeModule.require("util").types;
        if (types2) {
          return types2;
        }
        return freeProcess && freeProcess.binding && freeProcess.binding("util");
      } catch (e2) {
      }
    }();
    module2.exports = nodeUtil;
  }
});

// node_modules/lodash/isTypedArray.js
var require_isTypedArray = __commonJS({
  "node_modules/lodash/isTypedArray.js"(exports2, module2) {
    var baseIsTypedArray = require_baseIsTypedArray();
    var baseUnary = require_baseUnary();
    var nodeUtil = require_nodeUtil();
    var nodeIsTypedArray = nodeUtil && nodeUtil.isTypedArray;
    var isTypedArray = nodeIsTypedArray ? baseUnary(nodeIsTypedArray) : baseIsTypedArray;
    module2.exports = isTypedArray;
  }
});

// node_modules/lodash/_safeGet.js
var require_safeGet = __commonJS({
  "node_modules/lodash/_safeGet.js"(exports2, module2) {
    function safeGet(object, key2) {
      if (key2 === "constructor" && typeof object[key2] === "function") {
        return;
      }
      if (key2 == "__proto__") {
        return;
      }
      return object[key2];
    }
    module2.exports = safeGet;
  }
});

// node_modules/lodash/_assignValue.js
var require_assignValue = __commonJS({
  "node_modules/lodash/_assignValue.js"(exports2, module2) {
    var baseAssignValue = require_baseAssignValue();
    var eq = require_eq();
    var objectProto = Object.prototype;
    var hasOwnProperty2 = objectProto.hasOwnProperty;
    function assignValue(object, key2, value) {
      var objValue = object[key2];
      if (!(hasOwnProperty2.call(object, key2) && eq(objValue, value)) || value === void 0 && !(key2 in object)) {
        baseAssignValue(object, key2, value);
      }
    }
    module2.exports = assignValue;
  }
});

// node_modules/lodash/_copyObject.js
var require_copyObject = __commonJS({
  "node_modules/lodash/_copyObject.js"(exports2, module2) {
    var assignValue = require_assignValue();
    var baseAssignValue = require_baseAssignValue();
    function copyObject(source, props, object, customizer) {
      var isNew = !object;
      object || (object = {});
      var index = -1, length = props.length;
      while (++index < length) {
        var key2 = props[index];
        var newValue = customizer ? customizer(object[key2], source[key2], key2, object, source) : void 0;
        if (newValue === void 0) {
          newValue = source[key2];
        }
        if (isNew) {
          baseAssignValue(object, key2, newValue);
        } else {
          assignValue(object, key2, newValue);
        }
      }
      return object;
    }
    module2.exports = copyObject;
  }
});

// node_modules/lodash/_baseTimes.js
var require_baseTimes = __commonJS({
  "node_modules/lodash/_baseTimes.js"(exports2, module2) {
    function baseTimes(n2, iteratee) {
      var index = -1, result2 = Array(n2);
      while (++index < n2) {
        result2[index] = iteratee(index);
      }
      return result2;
    }
    module2.exports = baseTimes;
  }
});

// node_modules/lodash/_isIndex.js
var require_isIndex = __commonJS({
  "node_modules/lodash/_isIndex.js"(exports2, module2) {
    var MAX_SAFE_INTEGER = 9007199254740991;
    var reIsUint = /^(?:0|[1-9]\d*)$/;
    function isIndex(value, length) {
      var type3 = typeof value;
      length = length == null ? MAX_SAFE_INTEGER : length;
      return !!length && (type3 == "number" || type3 != "symbol" && reIsUint.test(value)) && (value > -1 && value % 1 == 0 && value < length);
    }
    module2.exports = isIndex;
  }
});

// node_modules/lodash/_arrayLikeKeys.js
var require_arrayLikeKeys = __commonJS({
  "node_modules/lodash/_arrayLikeKeys.js"(exports2, module2) {
    var baseTimes = require_baseTimes();
    var isArguments = require_isArguments();
    var isArray = require_isArray();
    var isBuffer = require_isBuffer();
    var isIndex = require_isIndex();
    var isTypedArray = require_isTypedArray();
    var objectProto = Object.prototype;
    var hasOwnProperty2 = objectProto.hasOwnProperty;
    function arrayLikeKeys(value, inherited) {
      var isArr = isArray(value), isArg = !isArr && isArguments(value), isBuff = !isArr && !isArg && isBuffer(value), isType = !isArr && !isArg && !isBuff && isTypedArray(value), skipIndexes = isArr || isArg || isBuff || isType, result2 = skipIndexes ? baseTimes(value.length, String) : [], length = result2.length;
      for (var key2 in value) {
        if ((inherited || hasOwnProperty2.call(value, key2)) && !(skipIndexes && (key2 == "length" || isBuff && (key2 == "offset" || key2 == "parent") || isType && (key2 == "buffer" || key2 == "byteLength" || key2 == "byteOffset") || isIndex(key2, length)))) {
          result2.push(key2);
        }
      }
      return result2;
    }
    module2.exports = arrayLikeKeys;
  }
});

// node_modules/lodash/_nativeKeysIn.js
var require_nativeKeysIn = __commonJS({
  "node_modules/lodash/_nativeKeysIn.js"(exports2, module2) {
    function nativeKeysIn(object) {
      var result2 = [];
      if (object != null) {
        for (var key2 in Object(object)) {
          result2.push(key2);
        }
      }
      return result2;
    }
    module2.exports = nativeKeysIn;
  }
});

// node_modules/lodash/_baseKeysIn.js
var require_baseKeysIn = __commonJS({
  "node_modules/lodash/_baseKeysIn.js"(exports2, module2) {
    var isObject2 = require_isObject();
    var isPrototype = require_isPrototype();
    var nativeKeysIn = require_nativeKeysIn();
    var objectProto = Object.prototype;
    var hasOwnProperty2 = objectProto.hasOwnProperty;
    function baseKeysIn(object) {
      if (!isObject2(object)) {
        return nativeKeysIn(object);
      }
      var isProto = isPrototype(object), result2 = [];
      for (var key2 in object) {
        if (!(key2 == "constructor" && (isProto || !hasOwnProperty2.call(object, key2)))) {
          result2.push(key2);
        }
      }
      return result2;
    }
    module2.exports = baseKeysIn;
  }
});

// node_modules/lodash/keysIn.js
var require_keysIn = __commonJS({
  "node_modules/lodash/keysIn.js"(exports2, module2) {
    var arrayLikeKeys = require_arrayLikeKeys();
    var baseKeysIn = require_baseKeysIn();
    var isArrayLike = require_isArrayLike();
    function keysIn(object) {
      return isArrayLike(object) ? arrayLikeKeys(object, true) : baseKeysIn(object);
    }
    module2.exports = keysIn;
  }
});

// node_modules/lodash/toPlainObject.js
var require_toPlainObject = __commonJS({
  "node_modules/lodash/toPlainObject.js"(exports2, module2) {
    var copyObject = require_copyObject();
    var keysIn = require_keysIn();
    function toPlainObject(value) {
      return copyObject(value, keysIn(value));
    }
    module2.exports = toPlainObject;
  }
});

// node_modules/lodash/_baseMergeDeep.js
var require_baseMergeDeep = __commonJS({
  "node_modules/lodash/_baseMergeDeep.js"(exports2, module2) {
    var assignMergeValue = require_assignMergeValue();
    var cloneBuffer = require_cloneBuffer();
    var cloneTypedArray = require_cloneTypedArray();
    var copyArray = require_copyArray();
    var initCloneObject = require_initCloneObject();
    var isArguments = require_isArguments();
    var isArray = require_isArray();
    var isArrayLikeObject = require_isArrayLikeObject();
    var isBuffer = require_isBuffer();
    var isFunction = require_isFunction();
    var isObject2 = require_isObject();
    var isPlainObject = require_isPlainObject();
    var isTypedArray = require_isTypedArray();
    var safeGet = require_safeGet();
    var toPlainObject = require_toPlainObject();
    function baseMergeDeep(object, source, key2, srcIndex, mergeFunc, customizer, stack) {
      var objValue = safeGet(object, key2), srcValue = safeGet(source, key2), stacked = stack.get(srcValue);
      if (stacked) {
        assignMergeValue(object, key2, stacked);
        return;
      }
      var newValue = customizer ? customizer(objValue, srcValue, key2 + "", object, source, stack) : void 0;
      var isCommon = newValue === void 0;
      if (isCommon) {
        var isArr = isArray(srcValue), isBuff = !isArr && isBuffer(srcValue), isTyped = !isArr && !isBuff && isTypedArray(srcValue);
        newValue = srcValue;
        if (isArr || isBuff || isTyped) {
          if (isArray(objValue)) {
            newValue = objValue;
          } else if (isArrayLikeObject(objValue)) {
            newValue = copyArray(objValue);
          } else if (isBuff) {
            isCommon = false;
            newValue = cloneBuffer(srcValue, true);
          } else if (isTyped) {
            isCommon = false;
            newValue = cloneTypedArray(srcValue, true);
          } else {
            newValue = [];
          }
        } else if (isPlainObject(srcValue) || isArguments(srcValue)) {
          newValue = objValue;
          if (isArguments(objValue)) {
            newValue = toPlainObject(objValue);
          } else if (!isObject2(objValue) || isFunction(objValue)) {
            newValue = initCloneObject(srcValue);
          }
        } else {
          isCommon = false;
        }
      }
      if (isCommon) {
        stack.set(srcValue, newValue);
        mergeFunc(newValue, srcValue, srcIndex, customizer, stack);
        stack["delete"](srcValue);
      }
      assignMergeValue(object, key2, newValue);
    }
    module2.exports = baseMergeDeep;
  }
});

// node_modules/lodash/_baseMerge.js
var require_baseMerge = __commonJS({
  "node_modules/lodash/_baseMerge.js"(exports2, module2) {
    var Stack = require_Stack();
    var assignMergeValue = require_assignMergeValue();
    var baseFor = require_baseFor();
    var baseMergeDeep = require_baseMergeDeep();
    var isObject2 = require_isObject();
    var keysIn = require_keysIn();
    var safeGet = require_safeGet();
    function baseMerge(object, source, srcIndex, customizer, stack) {
      if (object === source) {
        return;
      }
      baseFor(source, function(srcValue, key2) {
        stack || (stack = new Stack());
        if (isObject2(srcValue)) {
          baseMergeDeep(object, source, key2, srcIndex, baseMerge, customizer, stack);
        } else {
          var newValue = customizer ? customizer(safeGet(object, key2), srcValue, key2 + "", object, source, stack) : void 0;
          if (newValue === void 0) {
            newValue = srcValue;
          }
          assignMergeValue(object, key2, newValue);
        }
      }, keysIn);
    }
    module2.exports = baseMerge;
  }
});

// node_modules/lodash/identity.js
var require_identity = __commonJS({
  "node_modules/lodash/identity.js"(exports2, module2) {
    function identity(value) {
      return value;
    }
    module2.exports = identity;
  }
});

// node_modules/lodash/_apply.js
var require_apply = __commonJS({
  "node_modules/lodash/_apply.js"(exports2, module2) {
    function apply(func2, thisArg, args) {
      switch (args.length) {
        case 0:
          return func2.call(thisArg);
        case 1:
          return func2.call(thisArg, args[0]);
        case 2:
          return func2.call(thisArg, args[0], args[1]);
        case 3:
          return func2.call(thisArg, args[0], args[1], args[2]);
      }
      return func2.apply(thisArg, args);
    }
    module2.exports = apply;
  }
});

// node_modules/lodash/_overRest.js
var require_overRest = __commonJS({
  "node_modules/lodash/_overRest.js"(exports2, module2) {
    var apply = require_apply();
    var nativeMax = Math.max;
    function overRest(func2, start, transform) {
      start = nativeMax(start === void 0 ? func2.length - 1 : start, 0);
      return function() {
        var args = arguments, index = -1, length = nativeMax(args.length - start, 0), array = Array(length);
        while (++index < length) {
          array[index] = args[start + index];
        }
        index = -1;
        var otherArgs = Array(start + 1);
        while (++index < start) {
          otherArgs[index] = args[index];
        }
        otherArgs[start] = transform(array);
        return apply(func2, this, otherArgs);
      };
    }
    module2.exports = overRest;
  }
});

// node_modules/lodash/constant.js
var require_constant = __commonJS({
  "node_modules/lodash/constant.js"(exports2, module2) {
    function constant(value) {
      return function() {
        return value;
      };
    }
    module2.exports = constant;
  }
});

// node_modules/lodash/_baseSetToString.js
var require_baseSetToString = __commonJS({
  "node_modules/lodash/_baseSetToString.js"(exports2, module2) {
    var constant = require_constant();
    var defineProperty = require_defineProperty();
    var identity = require_identity();
    var baseSetToString = !defineProperty ? identity : function(func2, string) {
      return defineProperty(func2, "toString", {
        "configurable": true,
        "enumerable": false,
        "value": constant(string),
        "writable": true
      });
    };
    module2.exports = baseSetToString;
  }
});

// node_modules/lodash/_shortOut.js
var require_shortOut = __commonJS({
  "node_modules/lodash/_shortOut.js"(exports2, module2) {
    var HOT_COUNT = 800;
    var HOT_SPAN = 16;
    var nativeNow = Date.now;
    function shortOut(func2) {
      var count = 0, lastCalled = 0;
      return function() {
        var stamp = nativeNow(), remaining = HOT_SPAN - (stamp - lastCalled);
        lastCalled = stamp;
        if (remaining > 0) {
          if (++count >= HOT_COUNT) {
            return arguments[0];
          }
        } else {
          count = 0;
        }
        return func2.apply(void 0, arguments);
      };
    }
    module2.exports = shortOut;
  }
});

// node_modules/lodash/_setToString.js
var require_setToString = __commonJS({
  "node_modules/lodash/_setToString.js"(exports2, module2) {
    var baseSetToString = require_baseSetToString();
    var shortOut = require_shortOut();
    var setToString = shortOut(baseSetToString);
    module2.exports = setToString;
  }
});

// node_modules/lodash/_baseRest.js
var require_baseRest = __commonJS({
  "node_modules/lodash/_baseRest.js"(exports2, module2) {
    var identity = require_identity();
    var overRest = require_overRest();
    var setToString = require_setToString();
    function baseRest(func2, start) {
      return setToString(overRest(func2, start, identity), func2 + "");
    }
    module2.exports = baseRest;
  }
});

// node_modules/lodash/_isIterateeCall.js
var require_isIterateeCall = __commonJS({
  "node_modules/lodash/_isIterateeCall.js"(exports2, module2) {
    var eq = require_eq();
    var isArrayLike = require_isArrayLike();
    var isIndex = require_isIndex();
    var isObject2 = require_isObject();
    function isIterateeCall(value, index, object) {
      if (!isObject2(object)) {
        return false;
      }
      var type3 = typeof index;
      if (type3 == "number" ? isArrayLike(object) && isIndex(index, object.length) : type3 == "string" && index in object) {
        return eq(object[index], value);
      }
      return false;
    }
    module2.exports = isIterateeCall;
  }
});

// node_modules/lodash/_createAssigner.js
var require_createAssigner = __commonJS({
  "node_modules/lodash/_createAssigner.js"(exports2, module2) {
    var baseRest = require_baseRest();
    var isIterateeCall = require_isIterateeCall();
    function createAssigner(assigner) {
      return baseRest(function(object, sources) {
        var index = -1, length = sources.length, customizer = length > 1 ? sources[length - 1] : void 0, guard = length > 2 ? sources[2] : void 0;
        customizer = assigner.length > 3 && typeof customizer == "function" ? (length--, customizer) : void 0;
        if (guard && isIterateeCall(sources[0], sources[1], guard)) {
          customizer = length < 3 ? void 0 : customizer;
          length = 1;
        }
        object = Object(object);
        while (++index < length) {
          var source = sources[index];
          if (source) {
            assigner(object, source, index, customizer);
          }
        }
        return object;
      });
    }
    module2.exports = createAssigner;
  }
});

// node_modules/lodash/merge.js
var require_merge = __commonJS({
  "node_modules/lodash/merge.js"(exports2, module2) {
    var baseMerge = require_baseMerge();
    var createAssigner = require_createAssigner();
    var merge2 = createAssigner(function(object, source, srcIndex) {
      baseMerge(object, source, srcIndex);
    });
    module2.exports = merge2;
  }
});

// node_modules/lodash/_arrayEach.js
var require_arrayEach = __commonJS({
  "node_modules/lodash/_arrayEach.js"(exports2, module2) {
    function arrayEach(array, iteratee) {
      var index = -1, length = array == null ? 0 : array.length;
      while (++index < length) {
        if (iteratee(array[index], index, array) === false) {
          break;
        }
      }
      return array;
    }
    module2.exports = arrayEach;
  }
});

// node_modules/lodash/_nativeKeys.js
var require_nativeKeys = __commonJS({
  "node_modules/lodash/_nativeKeys.js"(exports2, module2) {
    var overArg = require_overArg();
    var nativeKeys = overArg(Object.keys, Object);
    module2.exports = nativeKeys;
  }
});

// node_modules/lodash/_baseKeys.js
var require_baseKeys = __commonJS({
  "node_modules/lodash/_baseKeys.js"(exports2, module2) {
    var isPrototype = require_isPrototype();
    var nativeKeys = require_nativeKeys();
    var objectProto = Object.prototype;
    var hasOwnProperty2 = objectProto.hasOwnProperty;
    function baseKeys(object) {
      if (!isPrototype(object)) {
        return nativeKeys(object);
      }
      var result2 = [];
      for (var key2 in Object(object)) {
        if (hasOwnProperty2.call(object, key2) && key2 != "constructor") {
          result2.push(key2);
        }
      }
      return result2;
    }
    module2.exports = baseKeys;
  }
});

// node_modules/lodash/keys.js
var require_keys = __commonJS({
  "node_modules/lodash/keys.js"(exports2, module2) {
    var arrayLikeKeys = require_arrayLikeKeys();
    var baseKeys = require_baseKeys();
    var isArrayLike = require_isArrayLike();
    function keys(object) {
      return isArrayLike(object) ? arrayLikeKeys(object) : baseKeys(object);
    }
    module2.exports = keys;
  }
});

// node_modules/lodash/_baseAssign.js
var require_baseAssign = __commonJS({
  "node_modules/lodash/_baseAssign.js"(exports2, module2) {
    var copyObject = require_copyObject();
    var keys = require_keys();
    function baseAssign(object, source) {
      return object && copyObject(source, keys(source), object);
    }
    module2.exports = baseAssign;
  }
});

// node_modules/lodash/_baseAssignIn.js
var require_baseAssignIn = __commonJS({
  "node_modules/lodash/_baseAssignIn.js"(exports2, module2) {
    var copyObject = require_copyObject();
    var keysIn = require_keysIn();
    function baseAssignIn(object, source) {
      return object && copyObject(source, keysIn(source), object);
    }
    module2.exports = baseAssignIn;
  }
});

// node_modules/lodash/_arrayFilter.js
var require_arrayFilter = __commonJS({
  "node_modules/lodash/_arrayFilter.js"(exports2, module2) {
    function arrayFilter(array, predicate) {
      var index = -1, length = array == null ? 0 : array.length, resIndex = 0, result2 = [];
      while (++index < length) {
        var value = array[index];
        if (predicate(value, index, array)) {
          result2[resIndex++] = value;
        }
      }
      return result2;
    }
    module2.exports = arrayFilter;
  }
});

// node_modules/lodash/stubArray.js
var require_stubArray = __commonJS({
  "node_modules/lodash/stubArray.js"(exports2, module2) {
    function stubArray() {
      return [];
    }
    module2.exports = stubArray;
  }
});

// node_modules/lodash/_getSymbols.js
var require_getSymbols = __commonJS({
  "node_modules/lodash/_getSymbols.js"(exports2, module2) {
    var arrayFilter = require_arrayFilter();
    var stubArray = require_stubArray();
    var objectProto = Object.prototype;
    var propertyIsEnumerable = objectProto.propertyIsEnumerable;
    var nativeGetSymbols = Object.getOwnPropertySymbols;
    var getSymbols = !nativeGetSymbols ? stubArray : function(object) {
      if (object == null) {
        return [];
      }
      object = Object(object);
      return arrayFilter(nativeGetSymbols(object), function(symbol) {
        return propertyIsEnumerable.call(object, symbol);
      });
    };
    module2.exports = getSymbols;
  }
});

// node_modules/lodash/_copySymbols.js
var require_copySymbols = __commonJS({
  "node_modules/lodash/_copySymbols.js"(exports2, module2) {
    var copyObject = require_copyObject();
    var getSymbols = require_getSymbols();
    function copySymbols(source, object) {
      return copyObject(source, getSymbols(source), object);
    }
    module2.exports = copySymbols;
  }
});

// node_modules/lodash/_arrayPush.js
var require_arrayPush = __commonJS({
  "node_modules/lodash/_arrayPush.js"(exports2, module2) {
    function arrayPush(array, values) {
      var index = -1, length = values.length, offset = array.length;
      while (++index < length) {
        array[offset + index] = values[index];
      }
      return array;
    }
    module2.exports = arrayPush;
  }
});

// node_modules/lodash/_getSymbolsIn.js
var require_getSymbolsIn = __commonJS({
  "node_modules/lodash/_getSymbolsIn.js"(exports2, module2) {
    var arrayPush = require_arrayPush();
    var getPrototype = require_getPrototype();
    var getSymbols = require_getSymbols();
    var stubArray = require_stubArray();
    var nativeGetSymbols = Object.getOwnPropertySymbols;
    var getSymbolsIn = !nativeGetSymbols ? stubArray : function(object) {
      var result2 = [];
      while (object) {
        arrayPush(result2, getSymbols(object));
        object = getPrototype(object);
      }
      return result2;
    };
    module2.exports = getSymbolsIn;
  }
});

// node_modules/lodash/_copySymbolsIn.js
var require_copySymbolsIn = __commonJS({
  "node_modules/lodash/_copySymbolsIn.js"(exports2, module2) {
    var copyObject = require_copyObject();
    var getSymbolsIn = require_getSymbolsIn();
    function copySymbolsIn(source, object) {
      return copyObject(source, getSymbolsIn(source), object);
    }
    module2.exports = copySymbolsIn;
  }
});

// node_modules/lodash/_baseGetAllKeys.js
var require_baseGetAllKeys = __commonJS({
  "node_modules/lodash/_baseGetAllKeys.js"(exports2, module2) {
    var arrayPush = require_arrayPush();
    var isArray = require_isArray();
    function baseGetAllKeys(object, keysFunc, symbolsFunc) {
      var result2 = keysFunc(object);
      return isArray(object) ? result2 : arrayPush(result2, symbolsFunc(object));
    }
    module2.exports = baseGetAllKeys;
  }
});

// node_modules/lodash/_getAllKeys.js
var require_getAllKeys = __commonJS({
  "node_modules/lodash/_getAllKeys.js"(exports2, module2) {
    var baseGetAllKeys = require_baseGetAllKeys();
    var getSymbols = require_getSymbols();
    var keys = require_keys();
    function getAllKeys(object) {
      return baseGetAllKeys(object, keys, getSymbols);
    }
    module2.exports = getAllKeys;
  }
});

// node_modules/lodash/_getAllKeysIn.js
var require_getAllKeysIn = __commonJS({
  "node_modules/lodash/_getAllKeysIn.js"(exports2, module2) {
    var baseGetAllKeys = require_baseGetAllKeys();
    var getSymbolsIn = require_getSymbolsIn();
    var keysIn = require_keysIn();
    function getAllKeysIn(object) {
      return baseGetAllKeys(object, keysIn, getSymbolsIn);
    }
    module2.exports = getAllKeysIn;
  }
});

// node_modules/lodash/_DataView.js
var require_DataView = __commonJS({
  "node_modules/lodash/_DataView.js"(exports2, module2) {
    var getNative = require_getNative();
    var root = require_root();
    var DataView2 = getNative(root, "DataView");
    module2.exports = DataView2;
  }
});

// node_modules/lodash/_Promise.js
var require_Promise = __commonJS({
  "node_modules/lodash/_Promise.js"(exports2, module2) {
    var getNative = require_getNative();
    var root = require_root();
    var Promise2 = getNative(root, "Promise");
    module2.exports = Promise2;
  }
});

// node_modules/lodash/_Set.js
var require_Set = __commonJS({
  "node_modules/lodash/_Set.js"(exports2, module2) {
    var getNative = require_getNative();
    var root = require_root();
    var Set2 = getNative(root, "Set");
    module2.exports = Set2;
  }
});

// node_modules/lodash/_WeakMap.js
var require_WeakMap = __commonJS({
  "node_modules/lodash/_WeakMap.js"(exports2, module2) {
    var getNative = require_getNative();
    var root = require_root();
    var WeakMap2 = getNative(root, "WeakMap");
    module2.exports = WeakMap2;
  }
});

// node_modules/lodash/_getTag.js
var require_getTag = __commonJS({
  "node_modules/lodash/_getTag.js"(exports2, module2) {
    var DataView2 = require_DataView();
    var Map2 = require_Map();
    var Promise2 = require_Promise();
    var Set2 = require_Set();
    var WeakMap2 = require_WeakMap();
    var baseGetTag = require_baseGetTag();
    var toSource = require_toSource();
    var mapTag = "[object Map]";
    var objectTag = "[object Object]";
    var promiseTag = "[object Promise]";
    var setTag = "[object Set]";
    var weakMapTag = "[object WeakMap]";
    var dataViewTag = "[object DataView]";
    var dataViewCtorString = toSource(DataView2);
    var mapCtorString = toSource(Map2);
    var promiseCtorString = toSource(Promise2);
    var setCtorString = toSource(Set2);
    var weakMapCtorString = toSource(WeakMap2);
    var getTag = baseGetTag;
    if (DataView2 && getTag(new DataView2(new ArrayBuffer(1))) != dataViewTag || Map2 && getTag(new Map2()) != mapTag || Promise2 && getTag(Promise2.resolve()) != promiseTag || Set2 && getTag(new Set2()) != setTag || WeakMap2 && getTag(new WeakMap2()) != weakMapTag) {
      getTag = function(value) {
        var result2 = baseGetTag(value), Ctor = result2 == objectTag ? value.constructor : void 0, ctorString = Ctor ? toSource(Ctor) : "";
        if (ctorString) {
          switch (ctorString) {
            case dataViewCtorString:
              return dataViewTag;
            case mapCtorString:
              return mapTag;
            case promiseCtorString:
              return promiseTag;
            case setCtorString:
              return setTag;
            case weakMapCtorString:
              return weakMapTag;
          }
        }
        return result2;
      };
    }
    module2.exports = getTag;
  }
});

// node_modules/lodash/_initCloneArray.js
var require_initCloneArray = __commonJS({
  "node_modules/lodash/_initCloneArray.js"(exports2, module2) {
    var objectProto = Object.prototype;
    var hasOwnProperty2 = objectProto.hasOwnProperty;
    function initCloneArray(array) {
      var length = array.length, result2 = new array.constructor(length);
      if (length && typeof array[0] == "string" && hasOwnProperty2.call(array, "index")) {
        result2.index = array.index;
        result2.input = array.input;
      }
      return result2;
    }
    module2.exports = initCloneArray;
  }
});

// node_modules/lodash/_cloneDataView.js
var require_cloneDataView = __commonJS({
  "node_modules/lodash/_cloneDataView.js"(exports2, module2) {
    var cloneArrayBuffer = require_cloneArrayBuffer();
    function cloneDataView(dataView, isDeep) {
      var buffer2 = isDeep ? cloneArrayBuffer(dataView.buffer) : dataView.buffer;
      return new dataView.constructor(buffer2, dataView.byteOffset, dataView.byteLength);
    }
    module2.exports = cloneDataView;
  }
});

// node_modules/lodash/_cloneRegExp.js
var require_cloneRegExp = __commonJS({
  "node_modules/lodash/_cloneRegExp.js"(exports2, module2) {
    var reFlags = /\w*$/;
    function cloneRegExp(regexp) {
      var result2 = new regexp.constructor(regexp.source, reFlags.exec(regexp));
      result2.lastIndex = regexp.lastIndex;
      return result2;
    }
    module2.exports = cloneRegExp;
  }
});

// node_modules/lodash/_cloneSymbol.js
var require_cloneSymbol = __commonJS({
  "node_modules/lodash/_cloneSymbol.js"(exports2, module2) {
    var Symbol2 = require_Symbol();
    var symbolProto = Symbol2 ? Symbol2.prototype : void 0;
    var symbolValueOf = symbolProto ? symbolProto.valueOf : void 0;
    function cloneSymbol(symbol) {
      return symbolValueOf ? Object(symbolValueOf.call(symbol)) : {};
    }
    module2.exports = cloneSymbol;
  }
});

// node_modules/lodash/_initCloneByTag.js
var require_initCloneByTag = __commonJS({
  "node_modules/lodash/_initCloneByTag.js"(exports2, module2) {
    var cloneArrayBuffer = require_cloneArrayBuffer();
    var cloneDataView = require_cloneDataView();
    var cloneRegExp = require_cloneRegExp();
    var cloneSymbol = require_cloneSymbol();
    var cloneTypedArray = require_cloneTypedArray();
    var boolTag = "[object Boolean]";
    var dateTag = "[object Date]";
    var mapTag = "[object Map]";
    var numberTag = "[object Number]";
    var regexpTag = "[object RegExp]";
    var setTag = "[object Set]";
    var stringTag = "[object String]";
    var symbolTag = "[object Symbol]";
    var arrayBufferTag = "[object ArrayBuffer]";
    var dataViewTag = "[object DataView]";
    var float32Tag = "[object Float32Array]";
    var float64Tag = "[object Float64Array]";
    var int8Tag = "[object Int8Array]";
    var int16Tag = "[object Int16Array]";
    var int32Tag = "[object Int32Array]";
    var uint8Tag = "[object Uint8Array]";
    var uint8ClampedTag = "[object Uint8ClampedArray]";
    var uint16Tag = "[object Uint16Array]";
    var uint32Tag = "[object Uint32Array]";
    function initCloneByTag(object, tag, isDeep) {
      var Ctor = object.constructor;
      switch (tag) {
        case arrayBufferTag:
          return cloneArrayBuffer(object);
        case boolTag:
        case dateTag:
          return new Ctor(+object);
        case dataViewTag:
          return cloneDataView(object, isDeep);
        case float32Tag:
        case float64Tag:
        case int8Tag:
        case int16Tag:
        case int32Tag:
        case uint8Tag:
        case uint8ClampedTag:
        case uint16Tag:
        case uint32Tag:
          return cloneTypedArray(object, isDeep);
        case mapTag:
          return new Ctor();
        case numberTag:
        case stringTag:
          return new Ctor(object);
        case regexpTag:
          return cloneRegExp(object);
        case setTag:
          return new Ctor();
        case symbolTag:
          return cloneSymbol(object);
      }
    }
    module2.exports = initCloneByTag;
  }
});

// node_modules/lodash/_baseIsMap.js
var require_baseIsMap = __commonJS({
  "node_modules/lodash/_baseIsMap.js"(exports2, module2) {
    var getTag = require_getTag();
    var isObjectLike = require_isObjectLike();
    var mapTag = "[object Map]";
    function baseIsMap(value) {
      return isObjectLike(value) && getTag(value) == mapTag;
    }
    module2.exports = baseIsMap;
  }
});

// node_modules/lodash/isMap.js
var require_isMap = __commonJS({
  "node_modules/lodash/isMap.js"(exports2, module2) {
    var baseIsMap = require_baseIsMap();
    var baseUnary = require_baseUnary();
    var nodeUtil = require_nodeUtil();
    var nodeIsMap = nodeUtil && nodeUtil.isMap;
    var isMap = nodeIsMap ? baseUnary(nodeIsMap) : baseIsMap;
    module2.exports = isMap;
  }
});

// node_modules/lodash/_baseIsSet.js
var require_baseIsSet = __commonJS({
  "node_modules/lodash/_baseIsSet.js"(exports2, module2) {
    var getTag = require_getTag();
    var isObjectLike = require_isObjectLike();
    var setTag = "[object Set]";
    function baseIsSet(value) {
      return isObjectLike(value) && getTag(value) == setTag;
    }
    module2.exports = baseIsSet;
  }
});

// node_modules/lodash/isSet.js
var require_isSet = __commonJS({
  "node_modules/lodash/isSet.js"(exports2, module2) {
    var baseIsSet = require_baseIsSet();
    var baseUnary = require_baseUnary();
    var nodeUtil = require_nodeUtil();
    var nodeIsSet = nodeUtil && nodeUtil.isSet;
    var isSet = nodeIsSet ? baseUnary(nodeIsSet) : baseIsSet;
    module2.exports = isSet;
  }
});

// node_modules/lodash/_baseClone.js
var require_baseClone = __commonJS({
  "node_modules/lodash/_baseClone.js"(exports2, module2) {
    var Stack = require_Stack();
    var arrayEach = require_arrayEach();
    var assignValue = require_assignValue();
    var baseAssign = require_baseAssign();
    var baseAssignIn = require_baseAssignIn();
    var cloneBuffer = require_cloneBuffer();
    var copyArray = require_copyArray();
    var copySymbols = require_copySymbols();
    var copySymbolsIn = require_copySymbolsIn();
    var getAllKeys = require_getAllKeys();
    var getAllKeysIn = require_getAllKeysIn();
    var getTag = require_getTag();
    var initCloneArray = require_initCloneArray();
    var initCloneByTag = require_initCloneByTag();
    var initCloneObject = require_initCloneObject();
    var isArray = require_isArray();
    var isBuffer = require_isBuffer();
    var isMap = require_isMap();
    var isObject2 = require_isObject();
    var isSet = require_isSet();
    var keys = require_keys();
    var keysIn = require_keysIn();
    var CLONE_DEEP_FLAG = 1;
    var CLONE_FLAT_FLAG = 2;
    var CLONE_SYMBOLS_FLAG = 4;
    var argsTag = "[object Arguments]";
    var arrayTag = "[object Array]";
    var boolTag = "[object Boolean]";
    var dateTag = "[object Date]";
    var errorTag = "[object Error]";
    var funcTag = "[object Function]";
    var genTag = "[object GeneratorFunction]";
    var mapTag = "[object Map]";
    var numberTag = "[object Number]";
    var objectTag = "[object Object]";
    var regexpTag = "[object RegExp]";
    var setTag = "[object Set]";
    var stringTag = "[object String]";
    var symbolTag = "[object Symbol]";
    var weakMapTag = "[object WeakMap]";
    var arrayBufferTag = "[object ArrayBuffer]";
    var dataViewTag = "[object DataView]";
    var float32Tag = "[object Float32Array]";
    var float64Tag = "[object Float64Array]";
    var int8Tag = "[object Int8Array]";
    var int16Tag = "[object Int16Array]";
    var int32Tag = "[object Int32Array]";
    var uint8Tag = "[object Uint8Array]";
    var uint8ClampedTag = "[object Uint8ClampedArray]";
    var uint16Tag = "[object Uint16Array]";
    var uint32Tag = "[object Uint32Array]";
    var cloneableTags = {};
    cloneableTags[argsTag] = cloneableTags[arrayTag] = cloneableTags[arrayBufferTag] = cloneableTags[dataViewTag] = cloneableTags[boolTag] = cloneableTags[dateTag] = cloneableTags[float32Tag] = cloneableTags[float64Tag] = cloneableTags[int8Tag] = cloneableTags[int16Tag] = cloneableTags[int32Tag] = cloneableTags[mapTag] = cloneableTags[numberTag] = cloneableTags[objectTag] = cloneableTags[regexpTag] = cloneableTags[setTag] = cloneableTags[stringTag] = cloneableTags[symbolTag] = cloneableTags[uint8Tag] = cloneableTags[uint8ClampedTag] = cloneableTags[uint16Tag] = cloneableTags[uint32Tag] = true;
    cloneableTags[errorTag] = cloneableTags[funcTag] = cloneableTags[weakMapTag] = false;
    function baseClone(value, bitmask, customizer, key2, object, stack) {
      var result2, isDeep = bitmask & CLONE_DEEP_FLAG, isFlat = bitmask & CLONE_FLAT_FLAG, isFull = bitmask & CLONE_SYMBOLS_FLAG;
      if (customizer) {
        result2 = object ? customizer(value, key2, object, stack) : customizer(value);
      }
      if (result2 !== void 0) {
        return result2;
      }
      if (!isObject2(value)) {
        return value;
      }
      var isArr = isArray(value);
      if (isArr) {
        result2 = initCloneArray(value);
        if (!isDeep) {
          return copyArray(value, result2);
        }
      } else {
        var tag = getTag(value), isFunc = tag == funcTag || tag == genTag;
        if (isBuffer(value)) {
          return cloneBuffer(value, isDeep);
        }
        if (tag == objectTag || tag == argsTag || isFunc && !object) {
          result2 = isFlat || isFunc ? {} : initCloneObject(value);
          if (!isDeep) {
            return isFlat ? copySymbolsIn(value, baseAssignIn(result2, value)) : copySymbols(value, baseAssign(result2, value));
          }
        } else {
          if (!cloneableTags[tag]) {
            return object ? value : {};
          }
          result2 = initCloneByTag(value, tag, isDeep);
        }
      }
      stack || (stack = new Stack());
      var stacked = stack.get(value);
      if (stacked) {
        return stacked;
      }
      stack.set(value, result2);
      if (isSet(value)) {
        value.forEach(function(subValue) {
          result2.add(baseClone(subValue, bitmask, customizer, subValue, value, stack));
        });
      } else if (isMap(value)) {
        value.forEach(function(subValue, key3) {
          result2.set(key3, baseClone(subValue, bitmask, customizer, key3, value, stack));
        });
      }
      var keysFunc = isFull ? isFlat ? getAllKeysIn : getAllKeys : isFlat ? keysIn : keys;
      var props = isArr ? void 0 : keysFunc(value);
      arrayEach(props || value, function(subValue, key3) {
        if (props) {
          key3 = subValue;
          subValue = value[key3];
        }
        assignValue(result2, key3, baseClone(subValue, bitmask, customizer, key3, value, stack));
      });
      return result2;
    }
    module2.exports = baseClone;
  }
});

// node_modules/lodash/cloneDeep.js
var require_cloneDeep = __commonJS({
  "node_modules/lodash/cloneDeep.js"(exports2, module2) {
    var baseClone = require_baseClone();
    var CLONE_DEEP_FLAG = 1;
    var CLONE_SYMBOLS_FLAG = 4;
    function cloneDeep(value) {
      return baseClone(value, CLONE_DEEP_FLAG | CLONE_SYMBOLS_FLAG);
    }
    module2.exports = cloneDeep;
  }
});

// node_modules/renderkid/lib/tools.js
var require_tools = __commonJS({
  "node_modules/renderkid/lib/tools.js"(exports2, module2) {
    "use strict";
    var cloneDeep;
    var htmlparser;
    var isPlainObject;
    var merge2;
    var _objectToDom;
    var self2;
    htmlparser = require_lib10();
    var _require = require_domConverter();
    _objectToDom = _require.objectToDom;
    merge2 = require_merge();
    cloneDeep = require_cloneDeep();
    isPlainObject = require_isPlainObject();
    module2.exports = self2 = {
      repeatString: function repeatString(str2, times) {
        var i3, j, output, ref2;
        output = "";
        for (i3 = j = 0, ref2 = times; 0 <= ref2 ? j < ref2 : j > ref2; i3 = 0 <= ref2 ? ++j : --j) {
          output += str2;
        }
        return output;
      },
      cloneAndMergeDeep: function cloneAndMergeDeep(base, toAppend) {
        return merge2(cloneDeep(base), toAppend);
      },
      toDom: function toDom(subject) {
        if (typeof subject === "string") {
          return self2.stringToDom(subject);
        } else if (isPlainObject(subject)) {
          return self2._objectToDom(subject);
        } else {
          throw Error("tools.toDom() only supports strings and objects");
        }
      },
      stringToDom: function stringToDom(string) {
        var handler, parser;
        handler = new htmlparser.DomHandler();
        parser = new htmlparser.Parser(handler);
        parser.write(string);
        parser.end();
        return handler.dom;
      },
      _fixQuotesInDom: function _fixQuotesInDom(input) {
        var j, len, node;
        if (Array.isArray(input)) {
          for (j = 0, len = input.length; j < len; j++) {
            node = input[j];
            self2._fixQuotesInDom(node);
          }
          return input;
        }
        node = input;
        if (node.type === "text") {
          return node.data = self2._quoteNodeText(node.data);
        } else {
          return self2._fixQuotesInDom(node.children);
        }
      },
      objectToDom: function objectToDom(o2) {
        if (!Array.isArray(o2)) {
          if (!isPlainObject(o2)) {
            throw Error("objectToDom() only accepts a bare object or an array");
          }
        }
        return self2._fixQuotesInDom(_objectToDom(o2));
      },
      quote: function quote(str2) {
        return String(str2).replace(/</g, "&lt;").replace(/>/g, "&gt;").replace(/\"/g, "&quot;").replace(/\ /g, "&sp;").replace(/\n/g, "<br />");
      },
      _quoteNodeText: function _quoteNodeText(text) {
        return String(text).replace(/\&/g, "&amp;").replace(/</g, "&lt;").replace(/>/g, "&gt;").replace(/\"/g, "&quot;").replace(/\ /g, "&sp;").replace(/\n/g, "&nl;");
      },
      getCols: function getCols() {
        var cols, tty;
        tty = require("tty");
        cols = function() {
          try {
            if (tty.isatty(1) && tty.isatty(2)) {
              if (process.stdout.getWindowSize) {
                return process.stdout.getWindowSize(1)[0];
              } else if (tty.getWindowSize) {
                return tty.getWindowSize()[1];
              } else if (process.stdout.columns) {
                return process.stdout.columns;
              }
            }
          } catch (error) {
          }
        }();
        if (typeof cols === "number" && cols > 30) {
          return cols;
        } else {
          return 80;
        }
      }
    };
  }
});

// node_modules/renderkid/lib/ansiPainter/tags.js
var require_tags = __commonJS({
  "node_modules/renderkid/lib/ansiPainter/tags.js"(exports2, module2) {
    "use strict";
    var color;
    var colors;
    var i3;
    var len;
    var tags;
    module2.exports = tags = {
      "none": {
        color: "none",
        bg: "none"
      },
      "bg-none": {
        color: "inherit",
        bg: "none"
      },
      "color-none": {
        color: "none",
        bg: "inherit"
      }
    };
    colors = ["black", "red", "green", "yellow", "blue", "magenta", "cyan", "white", "grey", "bright-red", "bright-green", "bright-yellow", "bright-blue", "bright-magenta", "bright-cyan", "bright-white"];
    for (i3 = 0, len = colors.length; i3 < len; i3++) {
      color = colors[i3];
      tags[color] = {
        color,
        bg: "inherit"
      };
      tags["color-".concat(color)] = {
        color,
        bg: "inherit"
      };
      tags["bg-".concat(color)] = {
        color: "inherit",
        bg: color
      };
    }
  }
});

// node_modules/renderkid/lib/ansiPainter/styles.js
var require_styles2 = __commonJS({
  "node_modules/renderkid/lib/ansiPainter/styles.js"(exports2, module2) {
    "use strict";
    var codes;
    var styles;
    module2.exports = styles = {};
    styles.codes = codes = {
      "none": 0,
      "black": 30,
      "red": 31,
      "green": 32,
      "yellow": 33,
      "blue": 34,
      "magenta": 35,
      "cyan": 36,
      "white": 37,
      "grey": 90,
      "bright-red": 91,
      "bright-green": 92,
      "bright-yellow": 93,
      "bright-blue": 94,
      "bright-magenta": 95,
      "bright-cyan": 96,
      "bright-white": 97,
      "bg-black": 40,
      "bg-red": 41,
      "bg-green": 42,
      "bg-yellow": 43,
      "bg-blue": 44,
      "bg-magenta": 45,
      "bg-cyan": 46,
      "bg-white": 47,
      "bg-grey": 100,
      "bg-bright-red": 101,
      "bg-bright-green": 102,
      "bg-bright-yellow": 103,
      "bg-bright-blue": 104,
      "bg-bright-magenta": 105,
      "bg-bright-cyan": 106,
      "bg-bright-white": 107
    };
    styles.color = function(str2) {
      var code;
      if (str2 === "none") {
        return "";
      }
      code = codes[str2];
      if (code == null) {
        throw Error("Unknown color `".concat(str2, "`"));
      }
      return "[" + code + "m";
    };
    styles.bg = function(str2) {
      var code;
      if (str2 === "none") {
        return "";
      }
      code = codes["bg-" + str2];
      if (code == null) {
        throw Error("Unknown bg color `".concat(str2, "`"));
      }
      return "[" + code + "m";
    };
    styles.none = function(str2) {
      return "[" + codes.none + "m";
    };
  }
});

// node_modules/renderkid/lib/AnsiPainter.js
var require_AnsiPainter = __commonJS({
  "node_modules/renderkid/lib/AnsiPainter.js"(exports2, module2) {
    "use strict";
    function _classCallCheck(instance, Constructor) {
      if (!(instance instanceof Constructor)) {
        throw new TypeError("Cannot call a class as a function");
      }
    }
    function _defineProperties(target, props) {
      for (var i3 = 0; i3 < props.length; i3++) {
        var descriptor = props[i3];
        descriptor.enumerable = descriptor.enumerable || false;
        descriptor.configurable = true;
        if ("value" in descriptor)
          descriptor.writable = true;
        Object.defineProperty(target, descriptor.key, descriptor);
      }
    }
    function _createClass(Constructor, protoProps, staticProps) {
      if (protoProps)
        _defineProperties(Constructor.prototype, protoProps);
      if (staticProps)
        _defineProperties(Constructor, staticProps);
      return Constructor;
    }
    var AnsiPainter;
    var styles;
    var tags;
    var tools;
    var hasProp = {}.hasOwnProperty;
    tools = require_tools();
    tags = require_tags();
    styles = require_styles2();
    module2.exports = AnsiPainter = function() {
      var self2;
      var AnsiPainter2 = /* @__PURE__ */ function() {
        function AnsiPainter3() {
          _classCallCheck(this, AnsiPainter3);
        }
        _createClass(AnsiPainter3, [{
          key: "paint",
          value: function paint(s2) {
            return this._replaceSpecialStrings(this._renderDom(this._parse(s2)));
          }
        }, {
          key: "_replaceSpecialStrings",
          value: function _replaceSpecialStrings(str2) {
            return str2.replace(/&sp;/g, " ").replace(/&lt;/g, "<").replace(/&gt;/g, ">").replace(/&quot;/g, '"').replace(/&amp;/g, "&");
          }
        }, {
          key: "_parse",
          value: function _parse(string) {
            var injectFakeRoot = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : true;
            if (injectFakeRoot) {
              string = "<none>" + string + "</none>";
            }
            return tools.toDom(string);
          }
        }, {
          key: "_renderDom",
          value: function _renderDom(dom) {
            var parentStyles;
            parentStyles = {
              bg: "none",
              color: "none"
            };
            return this._renderChildren(dom, parentStyles);
          }
        }, {
          key: "_renderChildren",
          value: function _renderChildren(children, parentStyles) {
            var child, n2, ret;
            ret = "";
            for (n2 in children) {
              if (!hasProp.call(children, n2))
                continue;
              child = children[n2];
              ret += this._renderNode(child, parentStyles);
            }
            return ret;
          }
        }, {
          key: "_renderNode",
          value: function _renderNode(node, parentStyles) {
            if (node.type === "text") {
              return this._renderTextNode(node, parentStyles);
            } else {
              return this._renderTag(node, parentStyles);
            }
          }
        }, {
          key: "_renderTextNode",
          value: function _renderTextNode(node, parentStyles) {
            return this._wrapInStyle(node.data, parentStyles);
          }
        }, {
          key: "_wrapInStyle",
          value: function _wrapInStyle(str2, style) {
            return styles.color(style.color) + styles.bg(style.bg) + str2 + styles.none();
          }
        }, {
          key: "_renderTag",
          value: function _renderTag(node, parentStyles) {
            var currentStyles, tagStyles;
            tagStyles = this._getStylesForTagName(node.name);
            currentStyles = this._mixStyles(parentStyles, tagStyles);
            return this._renderChildren(node.children, currentStyles);
          }
        }, {
          key: "_mixStyles",
          value: function _mixStyles() {
            var final, i3, key2, len, style, val;
            final = {};
            for (var _len = arguments.length, styles2 = new Array(_len), _key = 0; _key < _len; _key++) {
              styles2[_key] = arguments[_key];
            }
            for (i3 = 0, len = styles2.length; i3 < len; i3++) {
              style = styles2[i3];
              for (key2 in style) {
                if (!hasProp.call(style, key2))
                  continue;
                val = style[key2];
                if (final[key2] == null || val !== "inherit") {
                  final[key2] = val;
                }
              }
            }
            return final;
          }
        }, {
          key: "_getStylesForTagName",
          value: function _getStylesForTagName(name) {
            if (tags[name] == null) {
              throw Error("Unknown tag name `".concat(name, "`"));
            }
            return tags[name];
          }
        }], [{
          key: "getInstance",
          value: function getInstance() {
            if (self2._instance == null) {
              self2._instance = new self2();
            }
            return self2._instance;
          }
        }, {
          key: "paint",
          value: function paint(str2) {
            return self2.getInstance().paint(str2);
          }
        }, {
          key: "strip",
          value: function strip(s2) {
            return s2.replace(/\x1b\[[0-9]+m/g, "");
          }
        }]);
        return AnsiPainter3;
      }();
      ;
      AnsiPainter2.tags = tags;
      self2 = AnsiPainter2;
      return AnsiPainter2;
    }.call(void 0);
  }
});

// node_modules/renderkid/lib/renderKid/styleApplier/_common.js
var require_common2 = __commonJS({
  "node_modules/renderkid/lib/renderKid/styleApplier/_common.js"(exports2, module2) {
    "use strict";
    var AnsiPainter;
    var _common;
    AnsiPainter = require_AnsiPainter();
    module2.exports = _common = {
      getStyleTagsFor: function getStyleTagsFor(style) {
        var i3, len, ret, tag, tagName, tagsToAdd;
        tagsToAdd = [];
        if (style.color != null) {
          tagName = "color-" + style.color;
          if (AnsiPainter.tags[tagName] == null) {
            throw Error("Unknown color `".concat(style.color, "`"));
          }
          tagsToAdd.push(tagName);
        }
        if (style.background != null) {
          tagName = "bg-" + style.background;
          if (AnsiPainter.tags[tagName] == null) {
            throw Error("Unknown background `".concat(style.background, "`"));
          }
          tagsToAdd.push(tagName);
        }
        ret = {
          before: "",
          after: ""
        };
        for (i3 = 0, len = tagsToAdd.length; i3 < len; i3++) {
          tag = tagsToAdd[i3];
          ret.before = "<".concat(tag, ">") + ret.before;
          ret.after = ret.after + "</".concat(tag, ">");
        }
        return ret;
      }
    };
  }
});

// node_modules/renderkid/lib/renderKid/styleApplier/inline.js
var require_inline = __commonJS({
  "node_modules/renderkid/lib/renderKid/styleApplier/inline.js"(exports2, module2) {
    "use strict";
    var _common;
    var inlineStyleApplier;
    var self2;
    var tools;
    tools = require_tools();
    _common = require_common2();
    module2.exports = inlineStyleApplier = self2 = {
      applyTo: function applyTo(el, style) {
        var ret;
        ret = _common.getStyleTagsFor(style);
        if (style.marginLeft != null) {
          ret.before = tools.repeatString("&sp;", parseInt(style.marginLeft)) + ret.before;
        }
        if (style.marginRight != null) {
          ret.after += tools.repeatString("&sp;", parseInt(style.marginRight));
        }
        if (style.paddingLeft != null) {
          ret.before += tools.repeatString("&sp;", parseInt(style.paddingLeft));
        }
        if (style.paddingRight != null) {
          ret.after = tools.repeatString("&sp;", parseInt(style.paddingRight)) + ret.after;
        }
        return ret;
      }
    };
  }
});

// node_modules/renderkid/lib/renderKid/styleApplier/block.js
var require_block = __commonJS({
  "node_modules/renderkid/lib/renderKid/styleApplier/block.js"(exports2, module2) {
    "use strict";
    var _common;
    var blockStyleApplier;
    var merge2;
    var self2;
    _common = require_common2();
    merge2 = require_merge();
    module2.exports = blockStyleApplier = self2 = {
      applyTo: function applyTo(el, style) {
        var config, ret;
        ret = _common.getStyleTagsFor(style);
        ret.blockConfig = config = {};
        this._margins(style, config);
        this._bullet(style, config);
        this._dims(style, config);
        return ret;
      },
      _margins: function _margins(style, config) {
        if (style.marginLeft != null) {
          merge2(config, {
            linePrependor: {
              options: {
                amount: parseInt(style.marginLeft)
              }
            }
          });
        }
        if (style.marginRight != null) {
          merge2(config, {
            lineAppendor: {
              options: {
                amount: parseInt(style.marginRight)
              }
            }
          });
        }
        if (style.marginTop != null) {
          merge2(config, {
            blockPrependor: {
              options: {
                amount: parseInt(style.marginTop)
              }
            }
          });
        }
        if (style.marginBottom != null) {
          merge2(config, {
            blockAppendor: {
              options: {
                amount: parseInt(style.marginBottom)
              }
            }
          });
        }
      },
      _bullet: function _bullet(style, config) {
        var after, before, bullet, conf;
        if (style.bullet != null && style.bullet.enabled) {
          bullet = style.bullet;
          conf = {};
          conf.alignment = style.bullet.alignment;
          var _common$getStyleTagsF = _common.getStyleTagsFor({
            color: bullet.color,
            background: bullet.background
          });
          before = _common$getStyleTagsF.before;
          after = _common$getStyleTagsF.after;
          conf.char = before + bullet.char + after;
          merge2(config, {
            linePrependor: {
              options: {
                bullet: conf
              }
            }
          });
        }
      },
      _dims: function _dims(style, config) {
        var w;
        if (style.width != null) {
          w = parseInt(style.width);
          config.width = w;
        }
      }
    };
  }
});

// node_modules/boolbase/index.js
var require_boolbase = __commonJS({
  "node_modules/boolbase/index.js"(exports2, module2) {
    module2.exports = {
      trueFunc: function trueFunc() {
        return true;
      },
      falseFunc: function falseFunc() {
        return false;
      }
    };
  }
});

// node_modules/css-what/lib/parse.js
var require_parse = __commonJS({
  "node_modules/css-what/lib/parse.js"(exports2) {
    "use strict";
    var __spreadArray = exports2 && exports2.__spreadArray || function(to, from) {
      for (var i3 = 0, il = from.length, j = to.length; i3 < il; i3++, j++)
        to[j] = from[i3];
      return to;
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.isTraversal = void 0;
    var reName = /^[^\\#]?(?:\\(?:[\da-f]{1,6}\s?|.)|[\w\-\u00b0-\uFFFF])+/;
    var reEscape = /\\([\da-f]{1,6}\s?|(\s)|.)/gi;
    var actionTypes = /* @__PURE__ */ new Map([
      ["~", "element"],
      ["^", "start"],
      ["$", "end"],
      ["*", "any"],
      ["!", "not"],
      ["|", "hyphen"]
    ]);
    var Traversals = {
      ">": "child",
      "<": "parent",
      "~": "sibling",
      "+": "adjacent"
    };
    var attribSelectors = {
      "#": ["id", "equals"],
      ".": ["class", "element"]
    };
    var unpackPseudos = /* @__PURE__ */ new Set([
      "has",
      "not",
      "matches",
      "is",
      "host",
      "host-context"
    ]);
    var traversalNames = new Set(__spreadArray([
      "descendant"
    ], Object.keys(Traversals).map(function(k) {
      return Traversals[k];
    })));
    var caseInsensitiveAttributes = /* @__PURE__ */ new Set([
      "accept",
      "accept-charset",
      "align",
      "alink",
      "axis",
      "bgcolor",
      "charset",
      "checked",
      "clear",
      "codetype",
      "color",
      "compact",
      "declare",
      "defer",
      "dir",
      "direction",
      "disabled",
      "enctype",
      "face",
      "frame",
      "hreflang",
      "http-equiv",
      "lang",
      "language",
      "link",
      "media",
      "method",
      "multiple",
      "nohref",
      "noresize",
      "noshade",
      "nowrap",
      "readonly",
      "rel",
      "rev",
      "rules",
      "scope",
      "scrolling",
      "selected",
      "shape",
      "target",
      "text",
      "type",
      "valign",
      "valuetype",
      "vlink"
    ]);
    function isTraversal(selector) {
      return traversalNames.has(selector.type);
    }
    exports2.isTraversal = isTraversal;
    var stripQuotesFromPseudos = /* @__PURE__ */ new Set(["contains", "icontains"]);
    var quotes = /* @__PURE__ */ new Set(['"', "'"]);
    function funescape(_, escaped, escapedWhitespace) {
      var high = parseInt(escaped, 16) - 65536;
      return high !== high || escapedWhitespace ? escaped : high < 0 ? String.fromCharCode(high + 65536) : String.fromCharCode(high >> 10 | 55296, high & 1023 | 56320);
    }
    function unescapeCSS(str2) {
      return str2.replace(reEscape, funescape);
    }
    function isWhitespace2(c2) {
      return c2 === " " || c2 === "\n" || c2 === "	" || c2 === "\f" || c2 === "\r";
    }
    function parse(selector, options) {
      var subselects = [];
      var endIndex = parseSelector(subselects, "" + selector, options, 0);
      if (endIndex < selector.length) {
        throw new Error("Unmatched selector: " + selector.slice(endIndex));
      }
      return subselects;
    }
    exports2.default = parse;
    function parseSelector(subselects, selector, options, selectorIndex) {
      var _a2, _b;
      if (options === void 0) {
        options = {};
      }
      var tokens = [];
      var sawWS = false;
      function getName(offset) {
        var match = selector.slice(selectorIndex + offset).match(reName);
        if (!match) {
          throw new Error("Expected name, found " + selector.slice(selectorIndex));
        }
        var name = match[0];
        selectorIndex += offset + name.length;
        return unescapeCSS(name);
      }
      function stripWhitespace(offset) {
        while (isWhitespace2(selector.charAt(selectorIndex + offset)))
          offset++;
        selectorIndex += offset;
      }
      function isEscaped(pos) {
        var slashCount = 0;
        while (selector.charAt(--pos) === "\\")
          slashCount++;
        return (slashCount & 1) === 1;
      }
      function ensureNotTraversal() {
        if (tokens.length > 0 && isTraversal(tokens[tokens.length - 1])) {
          throw new Error("Did not expect successive traversals.");
        }
      }
      stripWhitespace(0);
      while (selector !== "") {
        var firstChar = selector.charAt(selectorIndex);
        if (isWhitespace2(firstChar)) {
          sawWS = true;
          stripWhitespace(1);
        } else if (firstChar in Traversals) {
          ensureNotTraversal();
          tokens.push({ type: Traversals[firstChar] });
          sawWS = false;
          stripWhitespace(1);
        } else if (firstChar === ",") {
          if (tokens.length === 0) {
            throw new Error("Empty sub-selector");
          }
          subselects.push(tokens);
          tokens = [];
          sawWS = false;
          stripWhitespace(1);
        } else if (selector.startsWith("/*", selectorIndex)) {
          var endIndex = selector.indexOf("*/", selectorIndex + 2);
          if (endIndex < 0) {
            throw new Error("Comment was not terminated");
          }
          selectorIndex = endIndex + 2;
        } else {
          if (sawWS) {
            ensureNotTraversal();
            tokens.push({ type: "descendant" });
            sawWS = false;
          }
          if (firstChar in attribSelectors) {
            var _c = attribSelectors[firstChar], name_1 = _c[0], action = _c[1];
            tokens.push({
              type: "attribute",
              name: name_1,
              action,
              value: getName(1),
              namespace: null,
              ignoreCase: options.xmlMode ? null : false
            });
          } else if (firstChar === "[") {
            stripWhitespace(1);
            var name_2 = void 0;
            var namespace = null;
            if (selector.charAt(selectorIndex) === "|") {
              namespace = "";
              selectorIndex += 1;
            }
            if (selector.startsWith("*|", selectorIndex)) {
              namespace = "*";
              selectorIndex += 2;
            }
            name_2 = getName(0);
            if (namespace === null && selector.charAt(selectorIndex) === "|" && selector.charAt(selectorIndex + 1) !== "=") {
              namespace = name_2;
              name_2 = getName(1);
            }
            if ((_a2 = options.lowerCaseAttributeNames) !== null && _a2 !== void 0 ? _a2 : !options.xmlMode) {
              name_2 = name_2.toLowerCase();
            }
            stripWhitespace(0);
            var action = "exists";
            var possibleAction = actionTypes.get(selector.charAt(selectorIndex));
            if (possibleAction) {
              action = possibleAction;
              if (selector.charAt(selectorIndex + 1) !== "=") {
                throw new Error("Expected `=`");
              }
              stripWhitespace(2);
            } else if (selector.charAt(selectorIndex) === "=") {
              action = "equals";
              stripWhitespace(1);
            }
            var value = "";
            var ignoreCase = null;
            if (action !== "exists") {
              if (quotes.has(selector.charAt(selectorIndex))) {
                var quote = selector.charAt(selectorIndex);
                var sectionEnd = selectorIndex + 1;
                while (sectionEnd < selector.length && (selector.charAt(sectionEnd) !== quote || isEscaped(sectionEnd))) {
                  sectionEnd += 1;
                }
                if (selector.charAt(sectionEnd) !== quote) {
                  throw new Error("Attribute value didn't end");
                }
                value = unescapeCSS(selector.slice(selectorIndex + 1, sectionEnd));
                selectorIndex = sectionEnd + 1;
              } else {
                var valueStart = selectorIndex;
                while (selectorIndex < selector.length && (!isWhitespace2(selector.charAt(selectorIndex)) && selector.charAt(selectorIndex) !== "]" || isEscaped(selectorIndex))) {
                  selectorIndex += 1;
                }
                value = unescapeCSS(selector.slice(valueStart, selectorIndex));
              }
              stripWhitespace(0);
              var forceIgnore = selector.charAt(selectorIndex);
              if (forceIgnore === "s" || forceIgnore === "S") {
                ignoreCase = false;
                stripWhitespace(1);
              } else if (forceIgnore === "i" || forceIgnore === "I") {
                ignoreCase = true;
                stripWhitespace(1);
              }
            }
            if (!options.xmlMode) {
              ignoreCase !== null && ignoreCase !== void 0 ? ignoreCase : ignoreCase = caseInsensitiveAttributes.has(name_2);
            }
            if (selector.charAt(selectorIndex) !== "]") {
              throw new Error("Attribute selector didn't terminate");
            }
            selectorIndex += 1;
            var attributeSelector = {
              type: "attribute",
              name: name_2,
              action,
              value,
              namespace,
              ignoreCase
            };
            tokens.push(attributeSelector);
          } else if (firstChar === ":") {
            if (selector.charAt(selectorIndex + 1) === ":") {
              tokens.push({
                type: "pseudo-element",
                name: getName(2).toLowerCase()
              });
              continue;
            }
            var name_3 = getName(1).toLowerCase();
            var data = null;
            if (selector.charAt(selectorIndex) === "(") {
              if (unpackPseudos.has(name_3)) {
                if (quotes.has(selector.charAt(selectorIndex + 1))) {
                  throw new Error("Pseudo-selector " + name_3 + " cannot be quoted");
                }
                data = [];
                selectorIndex = parseSelector(data, selector, options, selectorIndex + 1);
                if (selector.charAt(selectorIndex) !== ")") {
                  throw new Error("Missing closing parenthesis in :" + name_3 + " (" + selector + ")");
                }
                selectorIndex += 1;
              } else {
                selectorIndex += 1;
                var start = selectorIndex;
                var counter = 1;
                for (; counter > 0 && selectorIndex < selector.length; selectorIndex++) {
                  if (selector.charAt(selectorIndex) === "(" && !isEscaped(selectorIndex)) {
                    counter++;
                  } else if (selector.charAt(selectorIndex) === ")" && !isEscaped(selectorIndex)) {
                    counter--;
                  }
                }
                if (counter) {
                  throw new Error("Parenthesis not matched");
                }
                data = selector.slice(start, selectorIndex - 1);
                if (stripQuotesFromPseudos.has(name_3)) {
                  var quot = data.charAt(0);
                  if (quot === data.slice(-1) && quotes.has(quot)) {
                    data = data.slice(1, -1);
                  }
                  data = unescapeCSS(data);
                }
              }
            }
            tokens.push({ type: "pseudo", name: name_3, data });
          } else {
            var namespace = null;
            var name_4 = void 0;
            if (firstChar === "*") {
              selectorIndex += 1;
              name_4 = "*";
            } else if (reName.test(selector.slice(selectorIndex))) {
              if (selector.charAt(selectorIndex) === "|") {
                namespace = "";
                selectorIndex += 1;
              }
              name_4 = getName(0);
            } else {
              if (tokens.length && tokens[tokens.length - 1].type === "descendant") {
                tokens.pop();
              }
              addToken(subselects, tokens);
              return selectorIndex;
            }
            if (selector.charAt(selectorIndex) === "|") {
              namespace = name_4;
              if (selector.charAt(selectorIndex + 1) === "*") {
                name_4 = "*";
                selectorIndex += 2;
              } else {
                name_4 = getName(1);
              }
            }
            if (name_4 === "*") {
              tokens.push({ type: "universal", namespace });
            } else {
              if ((_b = options.lowerCaseTags) !== null && _b !== void 0 ? _b : !options.xmlMode) {
                name_4 = name_4.toLowerCase();
              }
              tokens.push({ type: "tag", name: name_4, namespace });
            }
          }
        }
      }
      addToken(subselects, tokens);
      return selectorIndex;
    }
    function addToken(subselects, tokens) {
      if (subselects.length > 0 && tokens.length === 0) {
        throw new Error("Empty sub-selector");
      }
      subselects.push(tokens);
    }
  }
});

// node_modules/css-what/lib/stringify.js
var require_stringify2 = __commonJS({
  "node_modules/css-what/lib/stringify.js"(exports2) {
    "use strict";
    var __spreadArray = exports2 && exports2.__spreadArray || function(to, from) {
      for (var i3 = 0, il = from.length, j = to.length; i3 < il; i3++, j++)
        to[j] = from[i3];
      return to;
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    var actionTypes = {
      equals: "",
      element: "~",
      start: "^",
      end: "$",
      any: "*",
      not: "!",
      hyphen: "|"
    };
    var charsToEscape = new Set(__spreadArray(__spreadArray([], Object.keys(actionTypes).map(function(typeKey) {
      return actionTypes[typeKey];
    }).filter(Boolean)), [
      ":",
      "[",
      "]",
      " ",
      "\\",
      "(",
      ")",
      "'"
    ]));
    function stringify(selector) {
      return selector.map(stringifySubselector).join(", ");
    }
    exports2.default = stringify;
    function stringifySubselector(token) {
      return token.map(stringifyToken).join("");
    }
    function stringifyToken(token) {
      switch (token.type) {
        case "child":
          return " > ";
        case "parent":
          return " < ";
        case "sibling":
          return " ~ ";
        case "adjacent":
          return " + ";
        case "descendant":
          return " ";
        case "universal":
          return getNamespace(token.namespace) + "*";
        case "tag":
          return getNamespacedName(token);
        case "pseudo-element":
          return "::" + escapeName(token.name);
        case "pseudo":
          if (token.data === null)
            return ":" + escapeName(token.name);
          if (typeof token.data === "string") {
            return ":" + escapeName(token.name) + "(" + escapeName(token.data) + ")";
          }
          return ":" + escapeName(token.name) + "(" + stringify(token.data) + ")";
        case "attribute": {
          if (token.name === "id" && token.action === "equals" && !token.ignoreCase && !token.namespace) {
            return "#" + escapeName(token.value);
          }
          if (token.name === "class" && token.action === "element" && !token.ignoreCase && !token.namespace) {
            return "." + escapeName(token.value);
          }
          var name_1 = getNamespacedName(token);
          if (token.action === "exists") {
            return "[" + name_1 + "]";
          }
          return "[" + name_1 + actionTypes[token.action] + "='" + escapeName(token.value) + "'" + (token.ignoreCase ? "i" : token.ignoreCase === false ? "s" : "") + "]";
        }
      }
    }
    function getNamespacedName(token) {
      return "" + getNamespace(token.namespace) + escapeName(token.name);
    }
    function getNamespace(namespace) {
      return namespace !== null ? (namespace === "*" ? "*" : escapeName(namespace)) + "|" : "";
    }
    function escapeName(str2) {
      return str2.split("").map(function(c2) {
        return charsToEscape.has(c2) ? "\\" + c2 : c2;
      }).join("");
    }
  }
});

// node_modules/css-what/lib/index.js
var require_lib11 = __commonJS({
  "node_modules/css-what/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o2, m, k, k2) {
      if (k2 === void 0)
        k2 = k;
      Object.defineProperty(o2, k2, { enumerable: true, get: function() {
        return m[k];
      } });
    } : function(o2, m, k, k2) {
      if (k2 === void 0)
        k2 = k;
      o2[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports3) {
      for (var p in m)
        if (p !== "default" && !Object.prototype.hasOwnProperty.call(exports3, p))
          __createBinding(exports3, m, p);
    };
    var __importDefault = exports2 && exports2.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { "default": mod };
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.stringify = exports2.parse = void 0;
    __exportStar(require_parse(), exports2);
    var parse_1 = require_parse();
    Object.defineProperty(exports2, "parse", { enumerable: true, get: function() {
      return __importDefault(parse_1).default;
    } });
    var stringify_1 = require_stringify2();
    Object.defineProperty(exports2, "stringify", { enumerable: true, get: function() {
      return __importDefault(stringify_1).default;
    } });
  }
});

// node_modules/css-select/lib/procedure.js
var require_procedure = __commonJS({
  "node_modules/css-select/lib/procedure.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.isTraversal = exports2.procedure = void 0;
    exports2.procedure = {
      universal: 50,
      tag: 30,
      attribute: 1,
      pseudo: 0,
      "pseudo-element": 0,
      descendant: -1,
      child: -1,
      parent: -1,
      sibling: -1,
      adjacent: -1,
      _flexibleDescendant: -1
    };
    function isTraversal(t2) {
      return exports2.procedure[t2.type] < 0;
    }
    exports2.isTraversal = isTraversal;
  }
});

// node_modules/css-select/lib/sort.js
var require_sort = __commonJS({
  "node_modules/css-select/lib/sort.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var procedure_1 = require_procedure();
    var attributes = {
      exists: 10,
      equals: 8,
      not: 7,
      start: 6,
      end: 6,
      any: 5,
      hyphen: 4,
      element: 4
    };
    function sortByProcedure(arr) {
      var procs = arr.map(getProcedure);
      for (var i3 = 1; i3 < arr.length; i3++) {
        var procNew = procs[i3];
        if (procNew < 0)
          continue;
        for (var j = i3 - 1; j >= 0 && procNew < procs[j]; j--) {
          var token = arr[j + 1];
          arr[j + 1] = arr[j];
          arr[j] = token;
          procs[j + 1] = procs[j];
          procs[j] = procNew;
        }
      }
    }
    exports2.default = sortByProcedure;
    function getProcedure(token) {
      var proc = procedure_1.procedure[token.type];
      if (token.type === "attribute") {
        proc = attributes[token.action];
        if (proc === attributes.equals && token.name === "id") {
          proc = 9;
        }
        if (token.ignoreCase) {
          proc >>= 1;
        }
      } else if (token.type === "pseudo") {
        if (!token.data) {
          proc = 3;
        } else if (token.name === "has" || token.name === "contains") {
          proc = 0;
        } else if (Array.isArray(token.data)) {
          proc = 0;
          for (var i3 = 0; i3 < token.data.length; i3++) {
            if (token.data[i3].length !== 1)
              continue;
            var cur = getProcedure(token.data[i3][0]);
            if (cur === 0) {
              proc = 0;
              break;
            }
            if (cur > proc)
              proc = cur;
          }
          if (token.data.length > 1 && proc > 0)
            proc -= 1;
        } else {
          proc = 1;
        }
      }
      return proc;
    }
  }
});

// node_modules/css-select/lib/attributes.js
var require_attributes = __commonJS({
  "node_modules/css-select/lib/attributes.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.attributeRules = void 0;
    var boolbase_1 = require_boolbase();
    var reChars = /[-[\]{}()*+?.,\\^$|#\s]/g;
    function escapeRegex(value) {
      return value.replace(reChars, "\\$&");
    }
    exports2.attributeRules = {
      equals: function(next, data, _a2) {
        var adapter = _a2.adapter;
        var name = data.name;
        var value = data.value;
        if (data.ignoreCase) {
          value = value.toLowerCase();
          return function(elem) {
            var attr = adapter.getAttributeValue(elem, name);
            return attr != null && attr.length === value.length && attr.toLowerCase() === value && next(elem);
          };
        }
        return function(elem) {
          return adapter.getAttributeValue(elem, name) === value && next(elem);
        };
      },
      hyphen: function(next, data, _a2) {
        var adapter = _a2.adapter;
        var name = data.name;
        var value = data.value;
        var len = value.length;
        if (data.ignoreCase) {
          value = value.toLowerCase();
          return function hyphenIC(elem) {
            var attr = adapter.getAttributeValue(elem, name);
            return attr != null && (attr.length === len || attr.charAt(len) === "-") && attr.substr(0, len).toLowerCase() === value && next(elem);
          };
        }
        return function hyphen(elem) {
          var attr = adapter.getAttributeValue(elem, name);
          return attr != null && (attr.length === len || attr.charAt(len) === "-") && attr.substr(0, len) === value && next(elem);
        };
      },
      element: function(next, _a2, _b) {
        var name = _a2.name, value = _a2.value, ignoreCase = _a2.ignoreCase;
        var adapter = _b.adapter;
        if (/\s/.test(value)) {
          return boolbase_1.falseFunc;
        }
        var regex = new RegExp("(?:^|\\s)" + escapeRegex(value) + "(?:$|\\s)", ignoreCase ? "i" : "");
        return function element(elem) {
          var attr = adapter.getAttributeValue(elem, name);
          return attr != null && attr.length >= value.length && regex.test(attr) && next(elem);
        };
      },
      exists: function(next, _a2, _b) {
        var name = _a2.name;
        var adapter = _b.adapter;
        return function(elem) {
          return adapter.hasAttrib(elem, name) && next(elem);
        };
      },
      start: function(next, data, _a2) {
        var adapter = _a2.adapter;
        var name = data.name;
        var value = data.value;
        var len = value.length;
        if (len === 0) {
          return boolbase_1.falseFunc;
        }
        if (data.ignoreCase) {
          value = value.toLowerCase();
          return function(elem) {
            var attr = adapter.getAttributeValue(elem, name);
            return attr != null && attr.length >= len && attr.substr(0, len).toLowerCase() === value && next(elem);
          };
        }
        return function(elem) {
          var _a3;
          return !!((_a3 = adapter.getAttributeValue(elem, name)) === null || _a3 === void 0 ? void 0 : _a3.startsWith(value)) && next(elem);
        };
      },
      end: function(next, data, _a2) {
        var adapter = _a2.adapter;
        var name = data.name;
        var value = data.value;
        var len = -value.length;
        if (len === 0) {
          return boolbase_1.falseFunc;
        }
        if (data.ignoreCase) {
          value = value.toLowerCase();
          return function(elem) {
            var _a3;
            return ((_a3 = adapter.getAttributeValue(elem, name)) === null || _a3 === void 0 ? void 0 : _a3.substr(len).toLowerCase()) === value && next(elem);
          };
        }
        return function(elem) {
          var _a3;
          return !!((_a3 = adapter.getAttributeValue(elem, name)) === null || _a3 === void 0 ? void 0 : _a3.endsWith(value)) && next(elem);
        };
      },
      any: function(next, data, _a2) {
        var adapter = _a2.adapter;
        var name = data.name, value = data.value;
        if (value === "") {
          return boolbase_1.falseFunc;
        }
        if (data.ignoreCase) {
          var regex_1 = new RegExp(escapeRegex(value), "i");
          return function anyIC(elem) {
            var attr = adapter.getAttributeValue(elem, name);
            return attr != null && attr.length >= value.length && regex_1.test(attr) && next(elem);
          };
        }
        return function(elem) {
          var _a3;
          return !!((_a3 = adapter.getAttributeValue(elem, name)) === null || _a3 === void 0 ? void 0 : _a3.includes(value)) && next(elem);
        };
      },
      not: function(next, data, _a2) {
        var adapter = _a2.adapter;
        var name = data.name;
        var value = data.value;
        if (value === "") {
          return function(elem) {
            return !!adapter.getAttributeValue(elem, name) && next(elem);
          };
        } else if (data.ignoreCase) {
          value = value.toLowerCase();
          return function(elem) {
            var attr = adapter.getAttributeValue(elem, name);
            return (attr == null || attr.length !== value.length || attr.toLowerCase() !== value) && next(elem);
          };
        }
        return function(elem) {
          return adapter.getAttributeValue(elem, name) !== value && next(elem);
        };
      }
    };
  }
});

// node_modules/nth-check/lib/parse.js
var require_parse2 = __commonJS({
  "node_modules/nth-check/lib/parse.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.parse = void 0;
    var whitespace = /* @__PURE__ */ new Set([9, 10, 12, 13, 32]);
    var ZERO = "0".charCodeAt(0);
    var NINE = "9".charCodeAt(0);
    function parse(formula) {
      formula = formula.trim().toLowerCase();
      if (formula === "even") {
        return [2, 0];
      } else if (formula === "odd") {
        return [2, 1];
      }
      var idx = 0;
      var a2 = 0;
      var sign = readSign();
      var number = readNumber();
      if (idx < formula.length && formula.charAt(idx) === "n") {
        idx++;
        a2 = sign * (number !== null && number !== void 0 ? number : 1);
        skipWhitespace();
        if (idx < formula.length) {
          sign = readSign();
          skipWhitespace();
          number = readNumber();
        } else {
          sign = number = 0;
        }
      }
      if (number === null || idx < formula.length) {
        throw new Error("n-th rule couldn't be parsed ('" + formula + "')");
      }
      return [a2, sign * number];
      function readSign() {
        if (formula.charAt(idx) === "-") {
          idx++;
          return -1;
        }
        if (formula.charAt(idx) === "+") {
          idx++;
        }
        return 1;
      }
      function readNumber() {
        var start = idx;
        var value = 0;
        while (idx < formula.length && formula.charCodeAt(idx) >= ZERO && formula.charCodeAt(idx) <= NINE) {
          value = value * 10 + (formula.charCodeAt(idx) - ZERO);
          idx++;
        }
        return idx === start ? null : value;
      }
      function skipWhitespace() {
        while (idx < formula.length && whitespace.has(formula.charCodeAt(idx))) {
          idx++;
        }
      }
    }
    exports2.parse = parse;
  }
});

// node_modules/nth-check/lib/compile.js
var require_compile = __commonJS({
  "node_modules/nth-check/lib/compile.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.compile = void 0;
    var boolbase_1 = require_boolbase();
    function compile(parsed) {
      var a2 = parsed[0];
      var b2 = parsed[1] - 1;
      if (b2 < 0 && a2 <= 0)
        return boolbase_1.falseFunc;
      if (a2 === -1)
        return function(index) {
          return index <= b2;
        };
      if (a2 === 0)
        return function(index) {
          return index === b2;
        };
      if (a2 === 1)
        return b2 < 0 ? boolbase_1.trueFunc : function(index) {
          return index >= b2;
        };
      var absA = Math.abs(a2);
      var bMod = (b2 % absA + absA) % absA;
      return a2 > 1 ? function(index) {
        return index >= b2 && index % absA === bMod;
      } : function(index) {
        return index <= b2 && index % absA === bMod;
      };
    }
    exports2.compile = compile;
  }
});

// node_modules/nth-check/lib/index.js
var require_lib12 = __commonJS({
  "node_modules/nth-check/lib/index.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.compile = exports2.parse = void 0;
    var parse_1 = require_parse2();
    Object.defineProperty(exports2, "parse", { enumerable: true, get: function() {
      return parse_1.parse;
    } });
    var compile_1 = require_compile();
    Object.defineProperty(exports2, "compile", { enumerable: true, get: function() {
      return compile_1.compile;
    } });
    function nthCheck(formula) {
      return (0, compile_1.compile)((0, parse_1.parse)(formula));
    }
    exports2.default = nthCheck;
  }
});

// node_modules/css-select/lib/pseudo-selectors/filters.js
var require_filters = __commonJS({
  "node_modules/css-select/lib/pseudo-selectors/filters.js"(exports2) {
    "use strict";
    var __importDefault = exports2 && exports2.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { "default": mod };
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.filters = void 0;
    var nth_check_1 = __importDefault(require_lib12());
    var boolbase_1 = require_boolbase();
    function getChildFunc(next, adapter) {
      return function(elem) {
        var parent = adapter.getParent(elem);
        return parent != null && adapter.isTag(parent) && next(elem);
      };
    }
    exports2.filters = {
      contains: function(next, text, _a2) {
        var adapter = _a2.adapter;
        return function contains(elem) {
          return next(elem) && adapter.getText(elem).includes(text);
        };
      },
      icontains: function(next, text, _a2) {
        var adapter = _a2.adapter;
        var itext = text.toLowerCase();
        return function icontains(elem) {
          return next(elem) && adapter.getText(elem).toLowerCase().includes(itext);
        };
      },
      "nth-child": function(next, rule, _a2) {
        var adapter = _a2.adapter, equals = _a2.equals;
        var func2 = nth_check_1.default(rule);
        if (func2 === boolbase_1.falseFunc)
          return boolbase_1.falseFunc;
        if (func2 === boolbase_1.trueFunc)
          return getChildFunc(next, adapter);
        return function nthChild(elem) {
          var siblings = adapter.getSiblings(elem);
          var pos = 0;
          for (var i3 = 0; i3 < siblings.length; i3++) {
            if (equals(elem, siblings[i3]))
              break;
            if (adapter.isTag(siblings[i3])) {
              pos++;
            }
          }
          return func2(pos) && next(elem);
        };
      },
      "nth-last-child": function(next, rule, _a2) {
        var adapter = _a2.adapter, equals = _a2.equals;
        var func2 = nth_check_1.default(rule);
        if (func2 === boolbase_1.falseFunc)
          return boolbase_1.falseFunc;
        if (func2 === boolbase_1.trueFunc)
          return getChildFunc(next, adapter);
        return function nthLastChild(elem) {
          var siblings = adapter.getSiblings(elem);
          var pos = 0;
          for (var i3 = siblings.length - 1; i3 >= 0; i3--) {
            if (equals(elem, siblings[i3]))
              break;
            if (adapter.isTag(siblings[i3])) {
              pos++;
            }
          }
          return func2(pos) && next(elem);
        };
      },
      "nth-of-type": function(next, rule, _a2) {
        var adapter = _a2.adapter, equals = _a2.equals;
        var func2 = nth_check_1.default(rule);
        if (func2 === boolbase_1.falseFunc)
          return boolbase_1.falseFunc;
        if (func2 === boolbase_1.trueFunc)
          return getChildFunc(next, adapter);
        return function nthOfType(elem) {
          var siblings = adapter.getSiblings(elem);
          var pos = 0;
          for (var i3 = 0; i3 < siblings.length; i3++) {
            var currentSibling = siblings[i3];
            if (equals(elem, currentSibling))
              break;
            if (adapter.isTag(currentSibling) && adapter.getName(currentSibling) === adapter.getName(elem)) {
              pos++;
            }
          }
          return func2(pos) && next(elem);
        };
      },
      "nth-last-of-type": function(next, rule, _a2) {
        var adapter = _a2.adapter, equals = _a2.equals;
        var func2 = nth_check_1.default(rule);
        if (func2 === boolbase_1.falseFunc)
          return boolbase_1.falseFunc;
        if (func2 === boolbase_1.trueFunc)
          return getChildFunc(next, adapter);
        return function nthLastOfType(elem) {
          var siblings = adapter.getSiblings(elem);
          var pos = 0;
          for (var i3 = siblings.length - 1; i3 >= 0; i3--) {
            var currentSibling = siblings[i3];
            if (equals(elem, currentSibling))
              break;
            if (adapter.isTag(currentSibling) && adapter.getName(currentSibling) === adapter.getName(elem)) {
              pos++;
            }
          }
          return func2(pos) && next(elem);
        };
      },
      root: function(next, _rule, _a2) {
        var adapter = _a2.adapter;
        return function(elem) {
          var parent = adapter.getParent(elem);
          return (parent == null || !adapter.isTag(parent)) && next(elem);
        };
      },
      scope: function(next, rule, options, context) {
        var equals = options.equals;
        if (!context || context.length === 0) {
          return exports2.filters.root(next, rule, options);
        }
        if (context.length === 1) {
          return function(elem) {
            return equals(context[0], elem) && next(elem);
          };
        }
        return function(elem) {
          return context.includes(elem) && next(elem);
        };
      },
      hover: dynamicStatePseudo("isHovered"),
      visited: dynamicStatePseudo("isVisited"),
      active: dynamicStatePseudo("isActive")
    };
    function dynamicStatePseudo(name) {
      return function dynamicPseudo(next, _rule, _a2) {
        var adapter = _a2.adapter;
        var func2 = adapter[name];
        if (typeof func2 !== "function") {
          return boolbase_1.falseFunc;
        }
        return function active(elem) {
          return func2(elem) && next(elem);
        };
      };
    }
  }
});

// node_modules/css-select/lib/pseudo-selectors/pseudos.js
var require_pseudos = __commonJS({
  "node_modules/css-select/lib/pseudo-selectors/pseudos.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.verifyPseudoArgs = exports2.pseudos = void 0;
    exports2.pseudos = {
      empty: function(elem, _a2) {
        var adapter = _a2.adapter;
        return !adapter.getChildren(elem).some(function(elem2) {
          return adapter.isTag(elem2) || adapter.getText(elem2) !== "";
        });
      },
      "first-child": function(elem, _a2) {
        var adapter = _a2.adapter, equals = _a2.equals;
        var firstChild = adapter.getSiblings(elem).find(function(elem2) {
          return adapter.isTag(elem2);
        });
        return firstChild != null && equals(elem, firstChild);
      },
      "last-child": function(elem, _a2) {
        var adapter = _a2.adapter, equals = _a2.equals;
        var siblings = adapter.getSiblings(elem);
        for (var i3 = siblings.length - 1; i3 >= 0; i3--) {
          if (equals(elem, siblings[i3]))
            return true;
          if (adapter.isTag(siblings[i3]))
            break;
        }
        return false;
      },
      "first-of-type": function(elem, _a2) {
        var adapter = _a2.adapter, equals = _a2.equals;
        var siblings = adapter.getSiblings(elem);
        var elemName = adapter.getName(elem);
        for (var i3 = 0; i3 < siblings.length; i3++) {
          var currentSibling = siblings[i3];
          if (equals(elem, currentSibling))
            return true;
          if (adapter.isTag(currentSibling) && adapter.getName(currentSibling) === elemName) {
            break;
          }
        }
        return false;
      },
      "last-of-type": function(elem, _a2) {
        var adapter = _a2.adapter, equals = _a2.equals;
        var siblings = adapter.getSiblings(elem);
        var elemName = adapter.getName(elem);
        for (var i3 = siblings.length - 1; i3 >= 0; i3--) {
          var currentSibling = siblings[i3];
          if (equals(elem, currentSibling))
            return true;
          if (adapter.isTag(currentSibling) && adapter.getName(currentSibling) === elemName) {
            break;
          }
        }
        return false;
      },
      "only-of-type": function(elem, _a2) {
        var adapter = _a2.adapter, equals = _a2.equals;
        var elemName = adapter.getName(elem);
        return adapter.getSiblings(elem).every(function(sibling) {
          return equals(elem, sibling) || !adapter.isTag(sibling) || adapter.getName(sibling) !== elemName;
        });
      },
      "only-child": function(elem, _a2) {
        var adapter = _a2.adapter, equals = _a2.equals;
        return adapter.getSiblings(elem).every(function(sibling) {
          return equals(elem, sibling) || !adapter.isTag(sibling);
        });
      }
    };
    function verifyPseudoArgs(func2, name, subselect) {
      if (subselect === null) {
        if (func2.length > 2) {
          throw new Error("pseudo-selector :" + name + " requires an argument");
        }
      } else if (func2.length === 2) {
        throw new Error("pseudo-selector :" + name + " doesn't have any arguments");
      }
    }
    exports2.verifyPseudoArgs = verifyPseudoArgs;
  }
});

// node_modules/css-select/lib/pseudo-selectors/aliases.js
var require_aliases = __commonJS({
  "node_modules/css-select/lib/pseudo-selectors/aliases.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.aliases = void 0;
    exports2.aliases = {
      "any-link": ":is(a, area, link)[href]",
      link: ":any-link:not(:visited)",
      disabled: ":is(\n        :is(button, input, select, textarea, optgroup, option)[disabled],\n        optgroup[disabled] > option,\n        fieldset[disabled]:not(fieldset[disabled] legend:first-of-type *)\n    )",
      enabled: ":not(:disabled)",
      checked: ":is(:is(input[type=radio], input[type=checkbox])[checked], option:selected)",
      required: ":is(input, select, textarea)[required]",
      optional: ":is(input, select, textarea):not([required])",
      selected: "option:is([selected], select:not([multiple]):not(:has(> option[selected])) > :first-of-type)",
      checkbox: "[type=checkbox]",
      file: "[type=file]",
      password: "[type=password]",
      radio: "[type=radio]",
      reset: "[type=reset]",
      image: "[type=image]",
      submit: "[type=submit]",
      parent: ":not(:empty)",
      header: ":is(h1, h2, h3, h4, h5, h6)",
      button: ":is(button, input[type=button])",
      input: ":is(input, textarea, select, button)",
      text: "input:is(:not([type!='']), [type=text])"
    };
  }
});

// node_modules/css-select/lib/pseudo-selectors/subselects.js
var require_subselects = __commonJS({
  "node_modules/css-select/lib/pseudo-selectors/subselects.js"(exports2) {
    "use strict";
    var __spreadArray = exports2 && exports2.__spreadArray || function(to, from) {
      for (var i3 = 0, il = from.length, j = to.length; i3 < il; i3++, j++)
        to[j] = from[i3];
      return to;
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.subselects = exports2.getNextSiblings = exports2.ensureIsTag = exports2.PLACEHOLDER_ELEMENT = void 0;
    var boolbase_1 = require_boolbase();
    var procedure_1 = require_procedure();
    exports2.PLACEHOLDER_ELEMENT = {};
    function ensureIsTag(next, adapter) {
      if (next === boolbase_1.falseFunc)
        return boolbase_1.falseFunc;
      return function(elem) {
        return adapter.isTag(elem) && next(elem);
      };
    }
    exports2.ensureIsTag = ensureIsTag;
    function getNextSiblings(elem, adapter) {
      var siblings = adapter.getSiblings(elem);
      if (siblings.length <= 1)
        return [];
      var elemIndex = siblings.indexOf(elem);
      if (elemIndex < 0 || elemIndex === siblings.length - 1)
        return [];
      return siblings.slice(elemIndex + 1).filter(adapter.isTag);
    }
    exports2.getNextSiblings = getNextSiblings;
    var is = function(next, token, options, context, compileToken) {
      var opts = {
        xmlMode: !!options.xmlMode,
        adapter: options.adapter,
        equals: options.equals
      };
      var func2 = compileToken(token, opts, context);
      return function(elem) {
        return func2(elem) && next(elem);
      };
    };
    exports2.subselects = {
      is,
      matches: is,
      not: function(next, token, options, context, compileToken) {
        var opts = {
          xmlMode: !!options.xmlMode,
          adapter: options.adapter,
          equals: options.equals
        };
        var func2 = compileToken(token, opts, context);
        if (func2 === boolbase_1.falseFunc)
          return next;
        if (func2 === boolbase_1.trueFunc)
          return boolbase_1.falseFunc;
        return function not(elem) {
          return !func2(elem) && next(elem);
        };
      },
      has: function(next, subselect, options, _context, compileToken) {
        var adapter = options.adapter;
        var opts = {
          xmlMode: !!options.xmlMode,
          adapter,
          equals: options.equals
        };
        var context = subselect.some(function(s2) {
          return s2.some(procedure_1.isTraversal);
        }) ? [exports2.PLACEHOLDER_ELEMENT] : void 0;
        var compiled = compileToken(subselect, opts, context);
        if (compiled === boolbase_1.falseFunc)
          return boolbase_1.falseFunc;
        if (compiled === boolbase_1.trueFunc) {
          return function(elem) {
            return adapter.getChildren(elem).some(adapter.isTag) && next(elem);
          };
        }
        var hasElement = ensureIsTag(compiled, adapter);
        var _a2 = compiled.shouldTestNextSiblings, shouldTestNextSiblings = _a2 === void 0 ? false : _a2;
        if (context) {
          return function(elem) {
            context[0] = elem;
            var childs = adapter.getChildren(elem);
            var nextElements = shouldTestNextSiblings ? __spreadArray(__spreadArray([], childs), getNextSiblings(elem, adapter)) : childs;
            return next(elem) && adapter.existsOne(hasElement, nextElements);
          };
        }
        return function(elem) {
          return next(elem) && adapter.existsOne(hasElement, adapter.getChildren(elem));
        };
      }
    };
  }
});

// node_modules/css-select/lib/pseudo-selectors/index.js
var require_pseudo_selectors = __commonJS({
  "node_modules/css-select/lib/pseudo-selectors/index.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.compilePseudoSelector = exports2.aliases = exports2.pseudos = exports2.filters = void 0;
    var boolbase_1 = require_boolbase();
    var css_what_1 = require_lib11();
    var filters_1 = require_filters();
    Object.defineProperty(exports2, "filters", { enumerable: true, get: function() {
      return filters_1.filters;
    } });
    var pseudos_1 = require_pseudos();
    Object.defineProperty(exports2, "pseudos", { enumerable: true, get: function() {
      return pseudos_1.pseudos;
    } });
    var aliases_1 = require_aliases();
    Object.defineProperty(exports2, "aliases", { enumerable: true, get: function() {
      return aliases_1.aliases;
    } });
    var subselects_1 = require_subselects();
    function compilePseudoSelector(next, selector, options, context, compileToken) {
      var name = selector.name, data = selector.data;
      if (Array.isArray(data)) {
        return subselects_1.subselects[name](next, data, options, context, compileToken);
      }
      if (name in aliases_1.aliases) {
        if (data != null) {
          throw new Error("Pseudo " + name + " doesn't have any arguments");
        }
        var alias = css_what_1.parse(aliases_1.aliases[name], options);
        return subselects_1.subselects.is(next, alias, options, context, compileToken);
      }
      if (name in filters_1.filters) {
        return filters_1.filters[name](next, data, options, context);
      }
      if (name in pseudos_1.pseudos) {
        var pseudo_1 = pseudos_1.pseudos[name];
        pseudos_1.verifyPseudoArgs(pseudo_1, name, data);
        return pseudo_1 === boolbase_1.falseFunc ? boolbase_1.falseFunc : next === boolbase_1.trueFunc ? function(elem) {
          return pseudo_1(elem, options, data);
        } : function(elem) {
          return pseudo_1(elem, options, data) && next(elem);
        };
      }
      throw new Error("unmatched pseudo-class :" + name);
    }
    exports2.compilePseudoSelector = compilePseudoSelector;
  }
});

// node_modules/css-select/lib/general.js
var require_general = __commonJS({
  "node_modules/css-select/lib/general.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.compileGeneralSelector = void 0;
    var attributes_1 = require_attributes();
    var pseudo_selectors_1 = require_pseudo_selectors();
    function compileGeneralSelector(next, selector, options, context, compileToken) {
      var adapter = options.adapter, equals = options.equals;
      switch (selector.type) {
        case "pseudo-element":
          throw new Error("Pseudo-elements are not supported by css-select");
        case "attribute":
          return attributes_1.attributeRules[selector.action](next, selector, options);
        case "pseudo":
          return pseudo_selectors_1.compilePseudoSelector(next, selector, options, context, compileToken);
        case "tag":
          return function tag(elem) {
            return adapter.getName(elem) === selector.name && next(elem);
          };
        case "descendant":
          if (options.cacheResults === false || typeof WeakSet === "undefined") {
            return function descendant(elem) {
              var current = elem;
              while (current = adapter.getParent(current)) {
                if (adapter.isTag(current) && next(current)) {
                  return true;
                }
              }
              return false;
            };
          }
          var isFalseCache_1 = new WeakSet();
          return function cachedDescendant(elem) {
            var current = elem;
            while (current = adapter.getParent(current)) {
              if (!isFalseCache_1.has(current)) {
                if (adapter.isTag(current) && next(current)) {
                  return true;
                }
                isFalseCache_1.add(current);
              }
            }
            return false;
          };
        case "_flexibleDescendant":
          return function flexibleDescendant(elem) {
            var current = elem;
            do {
              if (adapter.isTag(current) && next(current))
                return true;
            } while (current = adapter.getParent(current));
            return false;
          };
        case "parent":
          return function parent(elem) {
            return adapter.getChildren(elem).some(function(elem2) {
              return adapter.isTag(elem2) && next(elem2);
            });
          };
        case "child":
          return function child(elem) {
            var parent = adapter.getParent(elem);
            return parent != null && adapter.isTag(parent) && next(parent);
          };
        case "sibling":
          return function sibling(elem) {
            var siblings = adapter.getSiblings(elem);
            for (var i3 = 0; i3 < siblings.length; i3++) {
              var currentSibling = siblings[i3];
              if (equals(elem, currentSibling))
                break;
              if (adapter.isTag(currentSibling) && next(currentSibling)) {
                return true;
              }
            }
            return false;
          };
        case "adjacent":
          return function adjacent(elem) {
            var siblings = adapter.getSiblings(elem);
            var lastElement;
            for (var i3 = 0; i3 < siblings.length; i3++) {
              var currentSibling = siblings[i3];
              if (equals(elem, currentSibling))
                break;
              if (adapter.isTag(currentSibling)) {
                lastElement = currentSibling;
              }
            }
            return !!lastElement && next(lastElement);
          };
        case "universal":
          return next;
      }
    }
    exports2.compileGeneralSelector = compileGeneralSelector;
  }
});

// node_modules/css-select/lib/compile.js
var require_compile2 = __commonJS({
  "node_modules/css-select/lib/compile.js"(exports2) {
    "use strict";
    var __importDefault = exports2 && exports2.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { "default": mod };
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.compileToken = exports2.compileUnsafe = exports2.compile = void 0;
    var css_what_1 = require_lib11();
    var boolbase_1 = require_boolbase();
    var sort_1 = __importDefault(require_sort());
    var procedure_1 = require_procedure();
    var general_1 = require_general();
    var subselects_1 = require_subselects();
    function compile(selector, options, context) {
      var next = compileUnsafe(selector, options, context);
      return subselects_1.ensureIsTag(next, options.adapter);
    }
    exports2.compile = compile;
    function compileUnsafe(selector, options, context) {
      var token = typeof selector === "string" ? css_what_1.parse(selector, options) : selector;
      return compileToken(token, options, context);
    }
    exports2.compileUnsafe = compileUnsafe;
    function includesScopePseudo(t2) {
      return t2.type === "pseudo" && (t2.name === "scope" || Array.isArray(t2.data) && t2.data.some(function(data) {
        return data.some(includesScopePseudo);
      }));
    }
    var DESCENDANT_TOKEN = { type: "descendant" };
    var FLEXIBLE_DESCENDANT_TOKEN = {
      type: "_flexibleDescendant"
    };
    var SCOPE_TOKEN = { type: "pseudo", name: "scope", data: null };
    function absolutize(token, _a2, context) {
      var adapter = _a2.adapter;
      var hasContext = !!(context === null || context === void 0 ? void 0 : context.every(function(e2) {
        var parent = adapter.isTag(e2) && adapter.getParent(e2);
        return e2 === subselects_1.PLACEHOLDER_ELEMENT || parent && adapter.isTag(parent);
      }));
      for (var _i = 0, token_1 = token; _i < token_1.length; _i++) {
        var t2 = token_1[_i];
        if (t2.length > 0 && procedure_1.isTraversal(t2[0]) && t2[0].type !== "descendant") {
        } else if (hasContext && !t2.some(includesScopePseudo)) {
          t2.unshift(DESCENDANT_TOKEN);
        } else {
          continue;
        }
        t2.unshift(SCOPE_TOKEN);
      }
    }
    function compileToken(token, options, context) {
      var _a2;
      token = token.filter(function(t2) {
        return t2.length > 0;
      });
      token.forEach(sort_1.default);
      context = (_a2 = options.context) !== null && _a2 !== void 0 ? _a2 : context;
      var isArrayContext = Array.isArray(context);
      var finalContext = context && (Array.isArray(context) ? context : [context]);
      absolutize(token, options, finalContext);
      var shouldTestNextSiblings = false;
      var query = token.map(function(rules) {
        if (rules.length >= 2) {
          var first = rules[0], second = rules[1];
          if (first.type !== "pseudo" || first.name !== "scope") {
          } else if (isArrayContext && second.type === "descendant") {
            rules[1] = FLEXIBLE_DESCENDANT_TOKEN;
          } else if (second.type === "adjacent" || second.type === "sibling") {
            shouldTestNextSiblings = true;
          }
        }
        return compileRules(rules, options, finalContext);
      }).reduce(reduceRules, boolbase_1.falseFunc);
      query.shouldTestNextSiblings = shouldTestNextSiblings;
      return query;
    }
    exports2.compileToken = compileToken;
    function compileRules(rules, options, context) {
      var _a2;
      return rules.reduce(function(previous, rule) {
        return previous === boolbase_1.falseFunc ? boolbase_1.falseFunc : general_1.compileGeneralSelector(previous, rule, options, context, compileToken);
      }, (_a2 = options.rootFunc) !== null && _a2 !== void 0 ? _a2 : boolbase_1.trueFunc);
    }
    function reduceRules(a2, b2) {
      if (b2 === boolbase_1.falseFunc || a2 === boolbase_1.trueFunc) {
        return a2;
      }
      if (a2 === boolbase_1.falseFunc || b2 === boolbase_1.trueFunc) {
        return b2;
      }
      return function combine(elem) {
        return a2(elem) || b2(elem);
      };
    }
  }
});

// node_modules/css-select/lib/index.js
var require_lib13 = __commonJS({
  "node_modules/css-select/lib/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o2, m, k, k2) {
      if (k2 === void 0)
        k2 = k;
      Object.defineProperty(o2, k2, { enumerable: true, get: function() {
        return m[k];
      } });
    } : function(o2, m, k, k2) {
      if (k2 === void 0)
        k2 = k;
      o2[k2] = m[k];
    });
    var __setModuleDefault = exports2 && exports2.__setModuleDefault || (Object.create ? function(o2, v) {
      Object.defineProperty(o2, "default", { enumerable: true, value: v });
    } : function(o2, v) {
      o2["default"] = v;
    });
    var __importStar = exports2 && exports2.__importStar || function(mod) {
      if (mod && mod.__esModule)
        return mod;
      var result2 = {};
      if (mod != null) {
        for (var k in mod)
          if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k))
            __createBinding(result2, mod, k);
      }
      __setModuleDefault(result2, mod);
      return result2;
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.aliases = exports2.pseudos = exports2.filters = exports2.is = exports2.selectOne = exports2.selectAll = exports2.prepareContext = exports2._compileToken = exports2._compileUnsafe = exports2.compile = void 0;
    var DomUtils = __importStar(require_lib9());
    var boolbase_1 = require_boolbase();
    var compile_1 = require_compile2();
    var subselects_1 = require_subselects();
    var defaultEquals = function(a2, b2) {
      return a2 === b2;
    };
    var defaultOptions = {
      adapter: DomUtils,
      equals: defaultEquals
    };
    function convertOptionFormats(options) {
      var _a2, _b, _c, _d;
      var opts = options !== null && options !== void 0 ? options : defaultOptions;
      (_a2 = opts.adapter) !== null && _a2 !== void 0 ? _a2 : opts.adapter = DomUtils;
      (_b = opts.equals) !== null && _b !== void 0 ? _b : opts.equals = (_d = (_c = opts.adapter) === null || _c === void 0 ? void 0 : _c.equals) !== null && _d !== void 0 ? _d : defaultEquals;
      return opts;
    }
    function wrapCompile(func2) {
      return function addAdapter(selector, options, context) {
        var opts = convertOptionFormats(options);
        return func2(selector, opts, context);
      };
    }
    exports2.compile = wrapCompile(compile_1.compile);
    exports2._compileUnsafe = wrapCompile(compile_1.compileUnsafe);
    exports2._compileToken = wrapCompile(compile_1.compileToken);
    function getSelectorFunc(searchFunc) {
      return function select(query, elements, options) {
        var opts = convertOptionFormats(options);
        if (typeof query !== "function") {
          query = compile_1.compileUnsafe(query, opts, elements);
        }
        var filteredElements = prepareContext(elements, opts.adapter, query.shouldTestNextSiblings);
        return searchFunc(query, filteredElements, opts);
      };
    }
    function prepareContext(elems, adapter, shouldTestNextSiblings) {
      if (shouldTestNextSiblings === void 0) {
        shouldTestNextSiblings = false;
      }
      if (shouldTestNextSiblings) {
        elems = appendNextSiblings(elems, adapter);
      }
      return Array.isArray(elems) ? adapter.removeSubsets(elems) : adapter.getChildren(elems);
    }
    exports2.prepareContext = prepareContext;
    function appendNextSiblings(elem, adapter) {
      var elems = Array.isArray(elem) ? elem.slice(0) : [elem];
      for (var i3 = 0; i3 < elems.length; i3++) {
        var nextSiblings = subselects_1.getNextSiblings(elems[i3], adapter);
        elems.push.apply(elems, nextSiblings);
      }
      return elems;
    }
    exports2.selectAll = getSelectorFunc(function(query, elems, options) {
      return query === boolbase_1.falseFunc || !elems || elems.length === 0 ? [] : options.adapter.findAll(query, elems);
    });
    exports2.selectOne = getSelectorFunc(function(query, elems, options) {
      return query === boolbase_1.falseFunc || !elems || elems.length === 0 ? null : options.adapter.findOne(query, elems);
    });
    function is(elem, query, options) {
      var opts = convertOptionFormats(options);
      return (typeof query === "function" ? query : compile_1.compile(query, opts))(elem);
    }
    exports2.is = is;
    exports2.default = exports2.selectAll;
    var pseudo_selectors_1 = require_pseudo_selectors();
    Object.defineProperty(exports2, "filters", { enumerable: true, get: function() {
      return pseudo_selectors_1.filters;
    } });
    Object.defineProperty(exports2, "pseudos", { enumerable: true, get: function() {
      return pseudo_selectors_1.pseudos;
    } });
    Object.defineProperty(exports2, "aliases", { enumerable: true, get: function() {
      return pseudo_selectors_1.aliases;
    } });
  }
});

// node_modules/renderkid/lib/renderKid/styles/rule/Selector.js
var require_Selector = __commonJS({
  "node_modules/renderkid/lib/renderKid/styles/rule/Selector.js"(exports2, module2) {
    "use strict";
    function _classCallCheck(instance, Constructor) {
      if (!(instance instanceof Constructor)) {
        throw new TypeError("Cannot call a class as a function");
      }
    }
    function _defineProperties(target, props) {
      for (var i3 = 0; i3 < props.length; i3++) {
        var descriptor = props[i3];
        descriptor.enumerable = descriptor.enumerable || false;
        descriptor.configurable = true;
        if ("value" in descriptor)
          descriptor.writable = true;
        Object.defineProperty(target, descriptor.key, descriptor);
      }
    }
    function _createClass(Constructor, protoProps, staticProps) {
      if (protoProps)
        _defineProperties(Constructor.prototype, protoProps);
      if (staticProps)
        _defineProperties(Constructor, staticProps);
      return Constructor;
    }
    var CSSSelect;
    var Selector;
    CSSSelect = require_lib13();
    module2.exports = Selector = function() {
      var self2;
      var Selector2 = /* @__PURE__ */ function() {
        function Selector3(text1) {
          _classCallCheck(this, Selector3);
          this.text = text1;
          this._fn = CSSSelect.compile(this.text);
          this.priority = self2.calculatePriority(this.text);
        }
        _createClass(Selector3, [{
          key: "matches",
          value: function matches(elem) {
            return CSSSelect.is(elem, this._fn);
          }
        }], [{
          key: "calculatePriority",
          value: function calculatePriority(text) {
            var n2, priotrity;
            priotrity = 0;
            if (n2 = text.match(/[\#]{1}/g)) {
              priotrity += 100 * n2.length;
            }
            if (n2 = text.match(/[a-zA-Z]+/g)) {
              priotrity += 2 * n2.length;
            }
            if (n2 = text.match(/\*/g)) {
              priotrity += 1 * n2.length;
            }
            return priotrity;
          }
        }]);
        return Selector3;
      }();
      ;
      self2 = Selector2;
      return Selector2;
    }.call(void 0);
  }
});

// node_modules/renderkid/lib/renderKid/styles/rule/declarationBlock/_Declaration.js
var require_Declaration = __commonJS({
  "node_modules/renderkid/lib/renderKid/styles/rule/declarationBlock/_Declaration.js"(exports2, module2) {
    "use strict";
    function _classCallCheck(instance, Constructor) {
      if (!(instance instanceof Constructor)) {
        throw new TypeError("Cannot call a class as a function");
      }
    }
    function _defineProperties(target, props) {
      for (var i3 = 0; i3 < props.length; i3++) {
        var descriptor = props[i3];
        descriptor.enumerable = descriptor.enumerable || false;
        descriptor.configurable = true;
        if ("value" in descriptor)
          descriptor.writable = true;
        Object.defineProperty(target, descriptor.key, descriptor);
      }
    }
    function _createClass(Constructor, protoProps, staticProps) {
      if (protoProps)
        _defineProperties(Constructor.prototype, protoProps);
      if (staticProps)
        _defineProperties(Constructor, staticProps);
      return Constructor;
    }
    var _Declaration;
    module2.exports = _Declaration = function() {
      var self2;
      var _Declaration2 = /* @__PURE__ */ function() {
        function _Declaration3(prop1, val) {
          _classCallCheck(this, _Declaration3);
          this.prop = prop1;
          this.important = false;
          this.set(val);
        }
        _createClass(_Declaration3, [{
          key: "get",
          value: function get() {
            return this._get();
          }
        }, {
          key: "_get",
          value: function _get() {
            return this.val;
          }
        }, {
          key: "_pickImportantClause",
          value: function _pickImportantClause(val) {
            if (self2.importantClauseRx.test(String(val))) {
              this.important = true;
              return val.replace(self2.importantClauseRx, "");
            } else {
              this.important = false;
              return val;
            }
          }
        }, {
          key: "set",
          value: function set2(val) {
            val = self2.sanitizeValue(val);
            val = this._pickImportantClause(val);
            val = val.trim();
            if (this._handleNullOrInherit(val)) {
              return this;
            }
            this._set(val);
            return this;
          }
        }, {
          key: "_set",
          value: function _set(val) {
            return this.val = val;
          }
        }, {
          key: "_handleNullOrInherit",
          value: function _handleNullOrInherit(val) {
            if (val === "") {
              this.val = "";
              return true;
            }
            if (val === "inherit") {
              if (this.constructor.inheritAllowed) {
                this.val = "inherit";
              } else {
                throw Error("Inherit is not allowed for `".concat(this.prop, "`"));
              }
              return true;
            } else {
              return false;
            }
          }
        }], [{
          key: "setOnto",
          value: function setOnto(declarations, prop, val) {
            var dec;
            if (!(dec = declarations[prop])) {
              return declarations[prop] = new this(prop, val);
            } else {
              return dec.set(val);
            }
          }
        }, {
          key: "sanitizeValue",
          value: function sanitizeValue(val) {
            return String(val).trim().replace(/[\s]+/g, " ");
          }
        }]);
        return _Declaration3;
      }();
      ;
      self2 = _Declaration2;
      _Declaration2.importantClauseRx = /(\s\!important)$/;
      _Declaration2.inheritAllowed = false;
      return _Declaration2;
    }.call(void 0);
  }
});

// node_modules/renderkid/lib/renderKid/styles/rule/declarationBlock/Arbitrary.js
var require_Arbitrary = __commonJS({
  "node_modules/renderkid/lib/renderKid/styles/rule/declarationBlock/Arbitrary.js"(exports2, module2) {
    "use strict";
    function _typeof(obj) {
      "@babel/helpers - typeof";
      if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
        _typeof = function _typeof2(obj2) {
          return typeof obj2;
        };
      } else {
        _typeof = function _typeof2(obj2) {
          return obj2 && typeof Symbol === "function" && obj2.constructor === Symbol && obj2 !== Symbol.prototype ? "symbol" : typeof obj2;
        };
      }
      return _typeof(obj);
    }
    function _classCallCheck(instance, Constructor) {
      if (!(instance instanceof Constructor)) {
        throw new TypeError("Cannot call a class as a function");
      }
    }
    function _inherits(subClass, superClass) {
      if (typeof superClass !== "function" && superClass !== null) {
        throw new TypeError("Super expression must either be null or a function");
      }
      subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } });
      if (superClass)
        _setPrototypeOf(subClass, superClass);
    }
    function _setPrototypeOf(o2, p) {
      _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf2(o3, p2) {
        o3.__proto__ = p2;
        return o3;
      };
      return _setPrototypeOf(o2, p);
    }
    function _createSuper(Derived) {
      var hasNativeReflectConstruct = _isNativeReflectConstruct();
      return function _createSuperInternal() {
        var Super = _getPrototypeOf(Derived), result2;
        if (hasNativeReflectConstruct) {
          var NewTarget = _getPrototypeOf(this).constructor;
          result2 = Reflect.construct(Super, arguments, NewTarget);
        } else {
          result2 = Super.apply(this, arguments);
        }
        return _possibleConstructorReturn(this, result2);
      };
    }
    function _possibleConstructorReturn(self2, call) {
      if (call && (_typeof(call) === "object" || typeof call === "function")) {
        return call;
      }
      return _assertThisInitialized(self2);
    }
    function _assertThisInitialized(self2) {
      if (self2 === void 0) {
        throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
      }
      return self2;
    }
    function _isNativeReflectConstruct() {
      if (typeof Reflect === "undefined" || !Reflect.construct)
        return false;
      if (Reflect.construct.sham)
        return false;
      if (typeof Proxy === "function")
        return true;
      try {
        Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
        }));
        return true;
      } catch (e2) {
        return false;
      }
    }
    function _getPrototypeOf(o2) {
      _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf2(o3) {
        return o3.__proto__ || Object.getPrototypeOf(o3);
      };
      return _getPrototypeOf(o2);
    }
    var Arbitrary;
    var _Declaration;
    _Declaration = require_Declaration();
    module2.exports = Arbitrary = /* @__PURE__ */ function(_Declaration2) {
      _inherits(Arbitrary2, _Declaration2);
      var _super = _createSuper(Arbitrary2);
      function Arbitrary2() {
        _classCallCheck(this, Arbitrary2);
        return _super.apply(this, arguments);
      }
      return Arbitrary2;
    }(_Declaration);
  }
});

// node_modules/renderkid/lib/renderKid/styles/rule/declarationBlock/Color.js
var require_Color = __commonJS({
  "node_modules/renderkid/lib/renderKid/styles/rule/declarationBlock/Color.js"(exports2, module2) {
    "use strict";
    function _typeof(obj) {
      "@babel/helpers - typeof";
      if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
        _typeof = function _typeof2(obj2) {
          return typeof obj2;
        };
      } else {
        _typeof = function _typeof2(obj2) {
          return obj2 && typeof Symbol === "function" && obj2.constructor === Symbol && obj2 !== Symbol.prototype ? "symbol" : typeof obj2;
        };
      }
      return _typeof(obj);
    }
    function _classCallCheck(instance, Constructor) {
      if (!(instance instanceof Constructor)) {
        throw new TypeError("Cannot call a class as a function");
      }
    }
    function _inherits(subClass, superClass) {
      if (typeof superClass !== "function" && superClass !== null) {
        throw new TypeError("Super expression must either be null or a function");
      }
      subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } });
      if (superClass)
        _setPrototypeOf(subClass, superClass);
    }
    function _setPrototypeOf(o2, p) {
      _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf2(o3, p2) {
        o3.__proto__ = p2;
        return o3;
      };
      return _setPrototypeOf(o2, p);
    }
    function _createSuper(Derived) {
      var hasNativeReflectConstruct = _isNativeReflectConstruct();
      return function _createSuperInternal() {
        var Super = _getPrototypeOf(Derived), result2;
        if (hasNativeReflectConstruct) {
          var NewTarget = _getPrototypeOf(this).constructor;
          result2 = Reflect.construct(Super, arguments, NewTarget);
        } else {
          result2 = Super.apply(this, arguments);
        }
        return _possibleConstructorReturn(this, result2);
      };
    }
    function _possibleConstructorReturn(self2, call) {
      if (call && (_typeof(call) === "object" || typeof call === "function")) {
        return call;
      }
      return _assertThisInitialized(self2);
    }
    function _assertThisInitialized(self2) {
      if (self2 === void 0) {
        throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
      }
      return self2;
    }
    function _isNativeReflectConstruct() {
      if (typeof Reflect === "undefined" || !Reflect.construct)
        return false;
      if (Reflect.construct.sham)
        return false;
      if (typeof Proxy === "function")
        return true;
      try {
        Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
        }));
        return true;
      } catch (e2) {
        return false;
      }
    }
    function _getPrototypeOf(o2) {
      _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf2(o3) {
        return o3.__proto__ || Object.getPrototypeOf(o3);
      };
      return _getPrototypeOf(o2);
    }
    var Color;
    var _Declaration;
    _Declaration = require_Declaration();
    module2.exports = Color = /* @__PURE__ */ function(_Declaration2) {
      _inherits(Color2, _Declaration2);
      var _super = _createSuper(Color2);
      function Color2() {
        _classCallCheck(this, Color2);
        return _super.apply(this, arguments);
      }
      return Color2;
    }(_Declaration);
  }
});

// node_modules/renderkid/lib/renderKid/styles/rule/declarationBlock/Background.js
var require_Background = __commonJS({
  "node_modules/renderkid/lib/renderKid/styles/rule/declarationBlock/Background.js"(exports2, module2) {
    "use strict";
    function _typeof(obj) {
      "@babel/helpers - typeof";
      if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
        _typeof = function _typeof2(obj2) {
          return typeof obj2;
        };
      } else {
        _typeof = function _typeof2(obj2) {
          return obj2 && typeof Symbol === "function" && obj2.constructor === Symbol && obj2 !== Symbol.prototype ? "symbol" : typeof obj2;
        };
      }
      return _typeof(obj);
    }
    function _classCallCheck(instance, Constructor) {
      if (!(instance instanceof Constructor)) {
        throw new TypeError("Cannot call a class as a function");
      }
    }
    function _inherits(subClass, superClass) {
      if (typeof superClass !== "function" && superClass !== null) {
        throw new TypeError("Super expression must either be null or a function");
      }
      subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } });
      if (superClass)
        _setPrototypeOf(subClass, superClass);
    }
    function _setPrototypeOf(o2, p) {
      _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf2(o3, p2) {
        o3.__proto__ = p2;
        return o3;
      };
      return _setPrototypeOf(o2, p);
    }
    function _createSuper(Derived) {
      var hasNativeReflectConstruct = _isNativeReflectConstruct();
      return function _createSuperInternal() {
        var Super = _getPrototypeOf(Derived), result2;
        if (hasNativeReflectConstruct) {
          var NewTarget = _getPrototypeOf(this).constructor;
          result2 = Reflect.construct(Super, arguments, NewTarget);
        } else {
          result2 = Super.apply(this, arguments);
        }
        return _possibleConstructorReturn(this, result2);
      };
    }
    function _possibleConstructorReturn(self2, call) {
      if (call && (_typeof(call) === "object" || typeof call === "function")) {
        return call;
      }
      return _assertThisInitialized(self2);
    }
    function _assertThisInitialized(self2) {
      if (self2 === void 0) {
        throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
      }
      return self2;
    }
    function _isNativeReflectConstruct() {
      if (typeof Reflect === "undefined" || !Reflect.construct)
        return false;
      if (Reflect.construct.sham)
        return false;
      if (typeof Proxy === "function")
        return true;
      try {
        Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
        }));
        return true;
      } catch (e2) {
        return false;
      }
    }
    function _getPrototypeOf(o2) {
      _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf2(o3) {
        return o3.__proto__ || Object.getPrototypeOf(o3);
      };
      return _getPrototypeOf(o2);
    }
    var Background;
    var _Declaration;
    _Declaration = require_Declaration();
    module2.exports = Background = /* @__PURE__ */ function(_Declaration2) {
      _inherits(Background2, _Declaration2);
      var _super = _createSuper(Background2);
      function Background2() {
        _classCallCheck(this, Background2);
        return _super.apply(this, arguments);
      }
      return Background2;
    }(_Declaration);
  }
});

// node_modules/renderkid/lib/renderKid/styles/rule/declarationBlock/_Length.js
var require_Length = __commonJS({
  "node_modules/renderkid/lib/renderKid/styles/rule/declarationBlock/_Length.js"(exports2, module2) {
    "use strict";
    function _typeof(obj) {
      "@babel/helpers - typeof";
      if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
        _typeof = function _typeof2(obj2) {
          return typeof obj2;
        };
      } else {
        _typeof = function _typeof2(obj2) {
          return obj2 && typeof Symbol === "function" && obj2.constructor === Symbol && obj2 !== Symbol.prototype ? "symbol" : typeof obj2;
        };
      }
      return _typeof(obj);
    }
    function _classCallCheck(instance, Constructor) {
      if (!(instance instanceof Constructor)) {
        throw new TypeError("Cannot call a class as a function");
      }
    }
    function _defineProperties(target, props) {
      for (var i3 = 0; i3 < props.length; i3++) {
        var descriptor = props[i3];
        descriptor.enumerable = descriptor.enumerable || false;
        descriptor.configurable = true;
        if ("value" in descriptor)
          descriptor.writable = true;
        Object.defineProperty(target, descriptor.key, descriptor);
      }
    }
    function _createClass(Constructor, protoProps, staticProps) {
      if (protoProps)
        _defineProperties(Constructor.prototype, protoProps);
      if (staticProps)
        _defineProperties(Constructor, staticProps);
      return Constructor;
    }
    function _inherits(subClass, superClass) {
      if (typeof superClass !== "function" && superClass !== null) {
        throw new TypeError("Super expression must either be null or a function");
      }
      subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } });
      if (superClass)
        _setPrototypeOf(subClass, superClass);
    }
    function _setPrototypeOf(o2, p) {
      _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf2(o3, p2) {
        o3.__proto__ = p2;
        return o3;
      };
      return _setPrototypeOf(o2, p);
    }
    function _createSuper(Derived) {
      var hasNativeReflectConstruct = _isNativeReflectConstruct();
      return function _createSuperInternal() {
        var Super = _getPrototypeOf(Derived), result2;
        if (hasNativeReflectConstruct) {
          var NewTarget = _getPrototypeOf(this).constructor;
          result2 = Reflect.construct(Super, arguments, NewTarget);
        } else {
          result2 = Super.apply(this, arguments);
        }
        return _possibleConstructorReturn(this, result2);
      };
    }
    function _possibleConstructorReturn(self2, call) {
      if (call && (_typeof(call) === "object" || typeof call === "function")) {
        return call;
      }
      return _assertThisInitialized(self2);
    }
    function _assertThisInitialized(self2) {
      if (self2 === void 0) {
        throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
      }
      return self2;
    }
    function _isNativeReflectConstruct() {
      if (typeof Reflect === "undefined" || !Reflect.construct)
        return false;
      if (Reflect.construct.sham)
        return false;
      if (typeof Proxy === "function")
        return true;
      try {
        Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
        }));
        return true;
      } catch (e2) {
        return false;
      }
    }
    function _getPrototypeOf(o2) {
      _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf2(o3) {
        return o3.__proto__ || Object.getPrototypeOf(o3);
      };
      return _getPrototypeOf(o2);
    }
    var _Declaration;
    var _Length;
    _Declaration = require_Declaration();
    module2.exports = _Length = /* @__PURE__ */ function(_Declaration2) {
      _inherits(_Length2, _Declaration2);
      var _super = _createSuper(_Length2);
      function _Length2() {
        _classCallCheck(this, _Length2);
        return _super.apply(this, arguments);
      }
      _createClass(_Length2, [{
        key: "_set",
        value: function _set(val) {
          if (!/^[0-9]+$/.test(String(val))) {
            throw Error("`".concat(this.prop, "` only takes an integer for value"));
          }
          return this.val = parseInt(val);
        }
      }]);
      return _Length2;
    }(_Declaration);
  }
});

// node_modules/renderkid/lib/renderKid/styles/rule/declarationBlock/Width.js
var require_Width = __commonJS({
  "node_modules/renderkid/lib/renderKid/styles/rule/declarationBlock/Width.js"(exports2, module2) {
    "use strict";
    function _typeof(obj) {
      "@babel/helpers - typeof";
      if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
        _typeof = function _typeof2(obj2) {
          return typeof obj2;
        };
      } else {
        _typeof = function _typeof2(obj2) {
          return obj2 && typeof Symbol === "function" && obj2.constructor === Symbol && obj2 !== Symbol.prototype ? "symbol" : typeof obj2;
        };
      }
      return _typeof(obj);
    }
    function _classCallCheck(instance, Constructor) {
      if (!(instance instanceof Constructor)) {
        throw new TypeError("Cannot call a class as a function");
      }
    }
    function _inherits(subClass, superClass) {
      if (typeof superClass !== "function" && superClass !== null) {
        throw new TypeError("Super expression must either be null or a function");
      }
      subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } });
      if (superClass)
        _setPrototypeOf(subClass, superClass);
    }
    function _setPrototypeOf(o2, p) {
      _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf2(o3, p2) {
        o3.__proto__ = p2;
        return o3;
      };
      return _setPrototypeOf(o2, p);
    }
    function _createSuper(Derived) {
      var hasNativeReflectConstruct = _isNativeReflectConstruct();
      return function _createSuperInternal() {
        var Super = _getPrototypeOf(Derived), result2;
        if (hasNativeReflectConstruct) {
          var NewTarget = _getPrototypeOf(this).constructor;
          result2 = Reflect.construct(Super, arguments, NewTarget);
        } else {
          result2 = Super.apply(this, arguments);
        }
        return _possibleConstructorReturn(this, result2);
      };
    }
    function _possibleConstructorReturn(self2, call) {
      if (call && (_typeof(call) === "object" || typeof call === "function")) {
        return call;
      }
      return _assertThisInitialized(self2);
    }
    function _assertThisInitialized(self2) {
      if (self2 === void 0) {
        throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
      }
      return self2;
    }
    function _isNativeReflectConstruct() {
      if (typeof Reflect === "undefined" || !Reflect.construct)
        return false;
      if (Reflect.construct.sham)
        return false;
      if (typeof Proxy === "function")
        return true;
      try {
        Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
        }));
        return true;
      } catch (e2) {
        return false;
      }
    }
    function _getPrototypeOf(o2) {
      _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf2(o3) {
        return o3.__proto__ || Object.getPrototypeOf(o3);
      };
      return _getPrototypeOf(o2);
    }
    var Width;
    var _Length;
    _Length = require_Length();
    module2.exports = Width = /* @__PURE__ */ function(_Length2) {
      _inherits(Width2, _Length2);
      var _super = _createSuper(Width2);
      function Width2() {
        _classCallCheck(this, Width2);
        return _super.apply(this, arguments);
      }
      return Width2;
    }(_Length);
  }
});

// node_modules/renderkid/lib/renderKid/styles/rule/declarationBlock/Height.js
var require_Height = __commonJS({
  "node_modules/renderkid/lib/renderKid/styles/rule/declarationBlock/Height.js"(exports2, module2) {
    "use strict";
    function _typeof(obj) {
      "@babel/helpers - typeof";
      if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
        _typeof = function _typeof2(obj2) {
          return typeof obj2;
        };
      } else {
        _typeof = function _typeof2(obj2) {
          return obj2 && typeof Symbol === "function" && obj2.constructor === Symbol && obj2 !== Symbol.prototype ? "symbol" : typeof obj2;
        };
      }
      return _typeof(obj);
    }
    function _classCallCheck(instance, Constructor) {
      if (!(instance instanceof Constructor)) {
        throw new TypeError("Cannot call a class as a function");
      }
    }
    function _inherits(subClass, superClass) {
      if (typeof superClass !== "function" && superClass !== null) {
        throw new TypeError("Super expression must either be null or a function");
      }
      subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } });
      if (superClass)
        _setPrototypeOf(subClass, superClass);
    }
    function _setPrototypeOf(o2, p) {
      _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf2(o3, p2) {
        o3.__proto__ = p2;
        return o3;
      };
      return _setPrototypeOf(o2, p);
    }
    function _createSuper(Derived) {
      var hasNativeReflectConstruct = _isNativeReflectConstruct();
      return function _createSuperInternal() {
        var Super = _getPrototypeOf(Derived), result2;
        if (hasNativeReflectConstruct) {
          var NewTarget = _getPrototypeOf(this).constructor;
          result2 = Reflect.construct(Super, arguments, NewTarget);
        } else {
          result2 = Super.apply(this, arguments);
        }
        return _possibleConstructorReturn(this, result2);
      };
    }
    function _possibleConstructorReturn(self2, call) {
      if (call && (_typeof(call) === "object" || typeof call === "function")) {
        return call;
      }
      return _assertThisInitialized(self2);
    }
    function _assertThisInitialized(self2) {
      if (self2 === void 0) {
        throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
      }
      return self2;
    }
    function _isNativeReflectConstruct() {
      if (typeof Reflect === "undefined" || !Reflect.construct)
        return false;
      if (Reflect.construct.sham)
        return false;
      if (typeof Proxy === "function")
        return true;
      try {
        Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
        }));
        return true;
      } catch (e2) {
        return false;
      }
    }
    function _getPrototypeOf(o2) {
      _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf2(o3) {
        return o3.__proto__ || Object.getPrototypeOf(o3);
      };
      return _getPrototypeOf(o2);
    }
    var Height;
    var _Length;
    _Length = require_Length();
    module2.exports = Height = /* @__PURE__ */ function(_Length2) {
      _inherits(Height2, _Length2);
      var _super = _createSuper(Height2);
      function Height2() {
        _classCallCheck(this, Height2);
        return _super.apply(this, arguments);
      }
      return Height2;
    }(_Length);
  }
});

// node_modules/renderkid/lib/renderKid/styles/rule/declarationBlock/Bullet.js
var require_Bullet = __commonJS({
  "node_modules/renderkid/lib/renderKid/styles/rule/declarationBlock/Bullet.js"(exports2, module2) {
    "use strict";
    function _typeof(obj) {
      "@babel/helpers - typeof";
      if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
        _typeof = function _typeof2(obj2) {
          return typeof obj2;
        };
      } else {
        _typeof = function _typeof2(obj2) {
          return obj2 && typeof Symbol === "function" && obj2.constructor === Symbol && obj2 !== Symbol.prototype ? "symbol" : typeof obj2;
        };
      }
      return _typeof(obj);
    }
    function _classCallCheck(instance, Constructor) {
      if (!(instance instanceof Constructor)) {
        throw new TypeError("Cannot call a class as a function");
      }
    }
    function _defineProperties(target, props) {
      for (var i3 = 0; i3 < props.length; i3++) {
        var descriptor = props[i3];
        descriptor.enumerable = descriptor.enumerable || false;
        descriptor.configurable = true;
        if ("value" in descriptor)
          descriptor.writable = true;
        Object.defineProperty(target, descriptor.key, descriptor);
      }
    }
    function _createClass(Constructor, protoProps, staticProps) {
      if (protoProps)
        _defineProperties(Constructor.prototype, protoProps);
      if (staticProps)
        _defineProperties(Constructor, staticProps);
      return Constructor;
    }
    function _inherits(subClass, superClass) {
      if (typeof superClass !== "function" && superClass !== null) {
        throw new TypeError("Super expression must either be null or a function");
      }
      subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } });
      if (superClass)
        _setPrototypeOf(subClass, superClass);
    }
    function _setPrototypeOf(o2, p) {
      _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf2(o3, p2) {
        o3.__proto__ = p2;
        return o3;
      };
      return _setPrototypeOf(o2, p);
    }
    function _createSuper(Derived) {
      var hasNativeReflectConstruct = _isNativeReflectConstruct();
      return function _createSuperInternal() {
        var Super = _getPrototypeOf(Derived), result2;
        if (hasNativeReflectConstruct) {
          var NewTarget = _getPrototypeOf(this).constructor;
          result2 = Reflect.construct(Super, arguments, NewTarget);
        } else {
          result2 = Super.apply(this, arguments);
        }
        return _possibleConstructorReturn(this, result2);
      };
    }
    function _possibleConstructorReturn(self2, call) {
      if (call && (_typeof(call) === "object" || typeof call === "function")) {
        return call;
      }
      return _assertThisInitialized(self2);
    }
    function _assertThisInitialized(self2) {
      if (self2 === void 0) {
        throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
      }
      return self2;
    }
    function _isNativeReflectConstruct() {
      if (typeof Reflect === "undefined" || !Reflect.construct)
        return false;
      if (Reflect.construct.sham)
        return false;
      if (typeof Proxy === "function")
        return true;
      try {
        Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
        }));
        return true;
      } catch (e2) {
        return false;
      }
    }
    function _getPrototypeOf(o2) {
      _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf2(o3) {
        return o3.__proto__ || Object.getPrototypeOf(o3);
      };
      return _getPrototypeOf(o2);
    }
    var Bullet;
    var _Declaration;
    _Declaration = require_Declaration();
    module2.exports = Bullet = function() {
      var self2;
      var Bullet2 = /* @__PURE__ */ function(_Declaration2) {
        _inherits(Bullet3, _Declaration2);
        var _super = _createSuper(Bullet3);
        function Bullet3() {
          _classCallCheck(this, Bullet3);
          return _super.apply(this, arguments);
        }
        _createClass(Bullet3, [{
          key: "_set",
          value: function _set(val) {
            var alignment, bg, char, color, enabled, m, original;
            val = String(val);
            original = val;
            char = null;
            enabled = false;
            color = "none";
            bg = "none";
            if (m = val.match(/\"([^"]+)\"/) || (m = val.match(/\'([^']+)\'/))) {
              char = m[1];
              val = val.replace(m[0], "");
              enabled = true;
            }
            if (m = val.match(/(none|left|right|center)/)) {
              alignment = m[1];
              val = val.replace(m[0], "");
            } else {
              alignment = "left";
            }
            if (alignment === "none") {
              enabled = false;
            }
            if (m = val.match(/color\:([\w\-]+)/)) {
              color = m[1];
              val = val.replace(m[0], "");
            }
            if (m = val.match(/bg\:([\w\-]+)/)) {
              bg = m[1];
              val = val.replace(m[0], "");
            }
            if (val.trim() !== "") {
              throw Error("Unrecognizable value `".concat(original, "` for `").concat(this.prop, "`"));
            }
            return this.val = {
              enabled,
              char,
              alignment,
              background: bg,
              color
            };
          }
        }]);
        return Bullet3;
      }(_Declaration);
      ;
      self2 = Bullet2;
      return Bullet2;
    }.call(void 0);
  }
});

// node_modules/renderkid/lib/renderKid/styles/rule/declarationBlock/Display.js
var require_Display = __commonJS({
  "node_modules/renderkid/lib/renderKid/styles/rule/declarationBlock/Display.js"(exports2, module2) {
    "use strict";
    function _typeof(obj) {
      "@babel/helpers - typeof";
      if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
        _typeof = function _typeof2(obj2) {
          return typeof obj2;
        };
      } else {
        _typeof = function _typeof2(obj2) {
          return obj2 && typeof Symbol === "function" && obj2.constructor === Symbol && obj2 !== Symbol.prototype ? "symbol" : typeof obj2;
        };
      }
      return _typeof(obj);
    }
    function _classCallCheck(instance, Constructor) {
      if (!(instance instanceof Constructor)) {
        throw new TypeError("Cannot call a class as a function");
      }
    }
    function _defineProperties(target, props) {
      for (var i3 = 0; i3 < props.length; i3++) {
        var descriptor = props[i3];
        descriptor.enumerable = descriptor.enumerable || false;
        descriptor.configurable = true;
        if ("value" in descriptor)
          descriptor.writable = true;
        Object.defineProperty(target, descriptor.key, descriptor);
      }
    }
    function _createClass(Constructor, protoProps, staticProps) {
      if (protoProps)
        _defineProperties(Constructor.prototype, protoProps);
      if (staticProps)
        _defineProperties(Constructor, staticProps);
      return Constructor;
    }
    function _inherits(subClass, superClass) {
      if (typeof superClass !== "function" && superClass !== null) {
        throw new TypeError("Super expression must either be null or a function");
      }
      subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } });
      if (superClass)
        _setPrototypeOf(subClass, superClass);
    }
    function _setPrototypeOf(o2, p) {
      _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf2(o3, p2) {
        o3.__proto__ = p2;
        return o3;
      };
      return _setPrototypeOf(o2, p);
    }
    function _createSuper(Derived) {
      var hasNativeReflectConstruct = _isNativeReflectConstruct();
      return function _createSuperInternal() {
        var Super = _getPrototypeOf(Derived), result2;
        if (hasNativeReflectConstruct) {
          var NewTarget = _getPrototypeOf(this).constructor;
          result2 = Reflect.construct(Super, arguments, NewTarget);
        } else {
          result2 = Super.apply(this, arguments);
        }
        return _possibleConstructorReturn(this, result2);
      };
    }
    function _possibleConstructorReturn(self2, call) {
      if (call && (_typeof(call) === "object" || typeof call === "function")) {
        return call;
      }
      return _assertThisInitialized(self2);
    }
    function _assertThisInitialized(self2) {
      if (self2 === void 0) {
        throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
      }
      return self2;
    }
    function _isNativeReflectConstruct() {
      if (typeof Reflect === "undefined" || !Reflect.construct)
        return false;
      if (Reflect.construct.sham)
        return false;
      if (typeof Proxy === "function")
        return true;
      try {
        Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
        }));
        return true;
      } catch (e2) {
        return false;
      }
    }
    function _getPrototypeOf(o2) {
      _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf2(o3) {
        return o3.__proto__ || Object.getPrototypeOf(o3);
      };
      return _getPrototypeOf(o2);
    }
    var Display;
    var _Declaration;
    var indexOf = [].indexOf;
    _Declaration = require_Declaration();
    module2.exports = Display = function() {
      var self2;
      var Display2 = /* @__PURE__ */ function(_Declaration2) {
        _inherits(Display3, _Declaration2);
        var _super = _createSuper(Display3);
        function Display3() {
          _classCallCheck(this, Display3);
          return _super.apply(this, arguments);
        }
        _createClass(Display3, [{
          key: "_set",
          value: function _set(val) {
            val = String(val).toLowerCase();
            if (indexOf.call(self2._allowed, val) < 0) {
              throw Error("Unrecognizable value `".concat(val, "` for `").concat(this.prop, "`"));
            }
            return this.val = val;
          }
        }]);
        return Display3;
      }(_Declaration);
      ;
      self2 = Display2;
      Display2._allowed = ["inline", "block", "none"];
      return Display2;
    }.call(void 0);
  }
});

// node_modules/renderkid/lib/renderKid/styles/rule/declarationBlock/MarginTop.js
var require_MarginTop = __commonJS({
  "node_modules/renderkid/lib/renderKid/styles/rule/declarationBlock/MarginTop.js"(exports2, module2) {
    "use strict";
    function _typeof(obj) {
      "@babel/helpers - typeof";
      if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
        _typeof = function _typeof2(obj2) {
          return typeof obj2;
        };
      } else {
        _typeof = function _typeof2(obj2) {
          return obj2 && typeof Symbol === "function" && obj2.constructor === Symbol && obj2 !== Symbol.prototype ? "symbol" : typeof obj2;
        };
      }
      return _typeof(obj);
    }
    function _classCallCheck(instance, Constructor) {
      if (!(instance instanceof Constructor)) {
        throw new TypeError("Cannot call a class as a function");
      }
    }
    function _inherits(subClass, superClass) {
      if (typeof superClass !== "function" && superClass !== null) {
        throw new TypeError("Super expression must either be null or a function");
      }
      subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } });
      if (superClass)
        _setPrototypeOf(subClass, superClass);
    }
    function _setPrototypeOf(o2, p) {
      _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf2(o3, p2) {
        o3.__proto__ = p2;
        return o3;
      };
      return _setPrototypeOf(o2, p);
    }
    function _createSuper(Derived) {
      var hasNativeReflectConstruct = _isNativeReflectConstruct();
      return function _createSuperInternal() {
        var Super = _getPrototypeOf(Derived), result2;
        if (hasNativeReflectConstruct) {
          var NewTarget = _getPrototypeOf(this).constructor;
          result2 = Reflect.construct(Super, arguments, NewTarget);
        } else {
          result2 = Super.apply(this, arguments);
        }
        return _possibleConstructorReturn(this, result2);
      };
    }
    function _possibleConstructorReturn(self2, call) {
      if (call && (_typeof(call) === "object" || typeof call === "function")) {
        return call;
      }
      return _assertThisInitialized(self2);
    }
    function _assertThisInitialized(self2) {
      if (self2 === void 0) {
        throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
      }
      return self2;
    }
    function _isNativeReflectConstruct() {
      if (typeof Reflect === "undefined" || !Reflect.construct)
        return false;
      if (Reflect.construct.sham)
        return false;
      if (typeof Proxy === "function")
        return true;
      try {
        Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
        }));
        return true;
      } catch (e2) {
        return false;
      }
    }
    function _getPrototypeOf(o2) {
      _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf2(o3) {
        return o3.__proto__ || Object.getPrototypeOf(o3);
      };
      return _getPrototypeOf(o2);
    }
    var MarginTop;
    var _Length;
    _Length = require_Length();
    module2.exports = MarginTop = /* @__PURE__ */ function(_Length2) {
      _inherits(MarginTop2, _Length2);
      var _super = _createSuper(MarginTop2);
      function MarginTop2() {
        _classCallCheck(this, MarginTop2);
        return _super.apply(this, arguments);
      }
      return MarginTop2;
    }(_Length);
  }
});

// node_modules/renderkid/lib/renderKid/styles/rule/declarationBlock/MarginLeft.js
var require_MarginLeft = __commonJS({
  "node_modules/renderkid/lib/renderKid/styles/rule/declarationBlock/MarginLeft.js"(exports2, module2) {
    "use strict";
    function _typeof(obj) {
      "@babel/helpers - typeof";
      if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
        _typeof = function _typeof2(obj2) {
          return typeof obj2;
        };
      } else {
        _typeof = function _typeof2(obj2) {
          return obj2 && typeof Symbol === "function" && obj2.constructor === Symbol && obj2 !== Symbol.prototype ? "symbol" : typeof obj2;
        };
      }
      return _typeof(obj);
    }
    function _classCallCheck(instance, Constructor) {
      if (!(instance instanceof Constructor)) {
        throw new TypeError("Cannot call a class as a function");
      }
    }
    function _inherits(subClass, superClass) {
      if (typeof superClass !== "function" && superClass !== null) {
        throw new TypeError("Super expression must either be null or a function");
      }
      subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } });
      if (superClass)
        _setPrototypeOf(subClass, superClass);
    }
    function _setPrototypeOf(o2, p) {
      _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf2(o3, p2) {
        o3.__proto__ = p2;
        return o3;
      };
      return _setPrototypeOf(o2, p);
    }
    function _createSuper(Derived) {
      var hasNativeReflectConstruct = _isNativeReflectConstruct();
      return function _createSuperInternal() {
        var Super = _getPrototypeOf(Derived), result2;
        if (hasNativeReflectConstruct) {
          var NewTarget = _getPrototypeOf(this).constructor;
          result2 = Reflect.construct(Super, arguments, NewTarget);
        } else {
          result2 = Super.apply(this, arguments);
        }
        return _possibleConstructorReturn(this, result2);
      };
    }
    function _possibleConstructorReturn(self2, call) {
      if (call && (_typeof(call) === "object" || typeof call === "function")) {
        return call;
      }
      return _assertThisInitialized(self2);
    }
    function _assertThisInitialized(self2) {
      if (self2 === void 0) {
        throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
      }
      return self2;
    }
    function _isNativeReflectConstruct() {
      if (typeof Reflect === "undefined" || !Reflect.construct)
        return false;
      if (Reflect.construct.sham)
        return false;
      if (typeof Proxy === "function")
        return true;
      try {
        Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
        }));
        return true;
      } catch (e2) {
        return false;
      }
    }
    function _getPrototypeOf(o2) {
      _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf2(o3) {
        return o3.__proto__ || Object.getPrototypeOf(o3);
      };
      return _getPrototypeOf(o2);
    }
    var MarginLeft;
    var _Length;
    _Length = require_Length();
    module2.exports = MarginLeft = /* @__PURE__ */ function(_Length2) {
      _inherits(MarginLeft2, _Length2);
      var _super = _createSuper(MarginLeft2);
      function MarginLeft2() {
        _classCallCheck(this, MarginLeft2);
        return _super.apply(this, arguments);
      }
      return MarginLeft2;
    }(_Length);
  }
});

// node_modules/renderkid/lib/renderKid/styles/rule/declarationBlock/MarginRight.js
var require_MarginRight = __commonJS({
  "node_modules/renderkid/lib/renderKid/styles/rule/declarationBlock/MarginRight.js"(exports2, module2) {
    "use strict";
    function _typeof(obj) {
      "@babel/helpers - typeof";
      if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
        _typeof = function _typeof2(obj2) {
          return typeof obj2;
        };
      } else {
        _typeof = function _typeof2(obj2) {
          return obj2 && typeof Symbol === "function" && obj2.constructor === Symbol && obj2 !== Symbol.prototype ? "symbol" : typeof obj2;
        };
      }
      return _typeof(obj);
    }
    function _classCallCheck(instance, Constructor) {
      if (!(instance instanceof Constructor)) {
        throw new TypeError("Cannot call a class as a function");
      }
    }
    function _inherits(subClass, superClass) {
      if (typeof superClass !== "function" && superClass !== null) {
        throw new TypeError("Super expression must either be null or a function");
      }
      subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } });
      if (superClass)
        _setPrototypeOf(subClass, superClass);
    }
    function _setPrototypeOf(o2, p) {
      _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf2(o3, p2) {
        o3.__proto__ = p2;
        return o3;
      };
      return _setPrototypeOf(o2, p);
    }
    function _createSuper(Derived) {
      var hasNativeReflectConstruct = _isNativeReflectConstruct();
      return function _createSuperInternal() {
        var Super = _getPrototypeOf(Derived), result2;
        if (hasNativeReflectConstruct) {
          var NewTarget = _getPrototypeOf(this).constructor;
          result2 = Reflect.construct(Super, arguments, NewTarget);
        } else {
          result2 = Super.apply(this, arguments);
        }
        return _possibleConstructorReturn(this, result2);
      };
    }
    function _possibleConstructorReturn(self2, call) {
      if (call && (_typeof(call) === "object" || typeof call === "function")) {
        return call;
      }
      return _assertThisInitialized(self2);
    }
    function _assertThisInitialized(self2) {
      if (self2 === void 0) {
        throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
      }
      return self2;
    }
    function _isNativeReflectConstruct() {
      if (typeof Reflect === "undefined" || !Reflect.construct)
        return false;
      if (Reflect.construct.sham)
        return false;
      if (typeof Proxy === "function")
        return true;
      try {
        Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
        }));
        return true;
      } catch (e2) {
        return false;
      }
    }
    function _getPrototypeOf(o2) {
      _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf2(o3) {
        return o3.__proto__ || Object.getPrototypeOf(o3);
      };
      return _getPrototypeOf(o2);
    }
    var MarginRight;
    var _Length;
    _Length = require_Length();
    module2.exports = MarginRight = /* @__PURE__ */ function(_Length2) {
      _inherits(MarginRight2, _Length2);
      var _super = _createSuper(MarginRight2);
      function MarginRight2() {
        _classCallCheck(this, MarginRight2);
        return _super.apply(this, arguments);
      }
      return MarginRight2;
    }(_Length);
  }
});

// node_modules/renderkid/lib/renderKid/styles/rule/declarationBlock/MarginBottom.js
var require_MarginBottom = __commonJS({
  "node_modules/renderkid/lib/renderKid/styles/rule/declarationBlock/MarginBottom.js"(exports2, module2) {
    "use strict";
    function _typeof(obj) {
      "@babel/helpers - typeof";
      if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
        _typeof = function _typeof2(obj2) {
          return typeof obj2;
        };
      } else {
        _typeof = function _typeof2(obj2) {
          return obj2 && typeof Symbol === "function" && obj2.constructor === Symbol && obj2 !== Symbol.prototype ? "symbol" : typeof obj2;
        };
      }
      return _typeof(obj);
    }
    function _classCallCheck(instance, Constructor) {
      if (!(instance instanceof Constructor)) {
        throw new TypeError("Cannot call a class as a function");
      }
    }
    function _inherits(subClass, superClass) {
      if (typeof superClass !== "function" && superClass !== null) {
        throw new TypeError("Super expression must either be null or a function");
      }
      subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } });
      if (superClass)
        _setPrototypeOf(subClass, superClass);
    }
    function _setPrototypeOf(o2, p) {
      _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf2(o3, p2) {
        o3.__proto__ = p2;
        return o3;
      };
      return _setPrototypeOf(o2, p);
    }
    function _createSuper(Derived) {
      var hasNativeReflectConstruct = _isNativeReflectConstruct();
      return function _createSuperInternal() {
        var Super = _getPrototypeOf(Derived), result2;
        if (hasNativeReflectConstruct) {
          var NewTarget = _getPrototypeOf(this).constructor;
          result2 = Reflect.construct(Super, arguments, NewTarget);
        } else {
          result2 = Super.apply(this, arguments);
        }
        return _possibleConstructorReturn(this, result2);
      };
    }
    function _possibleConstructorReturn(self2, call) {
      if (call && (_typeof(call) === "object" || typeof call === "function")) {
        return call;
      }
      return _assertThisInitialized(self2);
    }
    function _assertThisInitialized(self2) {
      if (self2 === void 0) {
        throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
      }
      return self2;
    }
    function _isNativeReflectConstruct() {
      if (typeof Reflect === "undefined" || !Reflect.construct)
        return false;
      if (Reflect.construct.sham)
        return false;
      if (typeof Proxy === "function")
        return true;
      try {
        Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
        }));
        return true;
      } catch (e2) {
        return false;
      }
    }
    function _getPrototypeOf(o2) {
      _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf2(o3) {
        return o3.__proto__ || Object.getPrototypeOf(o3);
      };
      return _getPrototypeOf(o2);
    }
    var MarginBottom;
    var _Length;
    _Length = require_Length();
    module2.exports = MarginBottom = /* @__PURE__ */ function(_Length2) {
      _inherits(MarginBottom2, _Length2);
      var _super = _createSuper(MarginBottom2);
      function MarginBottom2() {
        _classCallCheck(this, MarginBottom2);
        return _super.apply(this, arguments);
      }
      return MarginBottom2;
    }(_Length);
  }
});

// node_modules/renderkid/lib/renderKid/styles/rule/declarationBlock/Margin.js
var require_Margin = __commonJS({
  "node_modules/renderkid/lib/renderKid/styles/rule/declarationBlock/Margin.js"(exports2, module2) {
    "use strict";
    function _typeof(obj) {
      "@babel/helpers - typeof";
      if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
        _typeof = function _typeof2(obj2) {
          return typeof obj2;
        };
      } else {
        _typeof = function _typeof2(obj2) {
          return obj2 && typeof Symbol === "function" && obj2.constructor === Symbol && obj2 !== Symbol.prototype ? "symbol" : typeof obj2;
        };
      }
      return _typeof(obj);
    }
    function _classCallCheck(instance, Constructor) {
      if (!(instance instanceof Constructor)) {
        throw new TypeError("Cannot call a class as a function");
      }
    }
    function _defineProperties(target, props) {
      for (var i3 = 0; i3 < props.length; i3++) {
        var descriptor = props[i3];
        descriptor.enumerable = descriptor.enumerable || false;
        descriptor.configurable = true;
        if ("value" in descriptor)
          descriptor.writable = true;
        Object.defineProperty(target, descriptor.key, descriptor);
      }
    }
    function _createClass(Constructor, protoProps, staticProps) {
      if (protoProps)
        _defineProperties(Constructor.prototype, protoProps);
      if (staticProps)
        _defineProperties(Constructor, staticProps);
      return Constructor;
    }
    function _inherits(subClass, superClass) {
      if (typeof superClass !== "function" && superClass !== null) {
        throw new TypeError("Super expression must either be null or a function");
      }
      subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } });
      if (superClass)
        _setPrototypeOf(subClass, superClass);
    }
    function _setPrototypeOf(o2, p) {
      _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf2(o3, p2) {
        o3.__proto__ = p2;
        return o3;
      };
      return _setPrototypeOf(o2, p);
    }
    function _createSuper(Derived) {
      var hasNativeReflectConstruct = _isNativeReflectConstruct();
      return function _createSuperInternal() {
        var Super = _getPrototypeOf(Derived), result2;
        if (hasNativeReflectConstruct) {
          var NewTarget = _getPrototypeOf(this).constructor;
          result2 = Reflect.construct(Super, arguments, NewTarget);
        } else {
          result2 = Super.apply(this, arguments);
        }
        return _possibleConstructorReturn(this, result2);
      };
    }
    function _possibleConstructorReturn(self2, call) {
      if (call && (_typeof(call) === "object" || typeof call === "function")) {
        return call;
      }
      return _assertThisInitialized(self2);
    }
    function _assertThisInitialized(self2) {
      if (self2 === void 0) {
        throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
      }
      return self2;
    }
    function _isNativeReflectConstruct() {
      if (typeof Reflect === "undefined" || !Reflect.construct)
        return false;
      if (Reflect.construct.sham)
        return false;
      if (typeof Proxy === "function")
        return true;
      try {
        Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
        }));
        return true;
      } catch (e2) {
        return false;
      }
    }
    function _getPrototypeOf(o2) {
      _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf2(o3) {
        return o3.__proto__ || Object.getPrototypeOf(o3);
      };
      return _getPrototypeOf(o2);
    }
    var Margin;
    var MarginBottom;
    var MarginLeft;
    var MarginRight;
    var MarginTop;
    var _Declaration;
    _Declaration = require_Declaration();
    MarginTop = require_MarginTop();
    MarginLeft = require_MarginLeft();
    MarginRight = require_MarginRight();
    MarginBottom = require_MarginBottom();
    module2.exports = Margin = function() {
      var self2;
      var Margin2 = /* @__PURE__ */ function(_Declaration2) {
        _inherits(Margin3, _Declaration2);
        var _super = _createSuper(Margin3);
        function Margin3() {
          _classCallCheck(this, Margin3);
          return _super.apply(this, arguments);
        }
        _createClass(Margin3, null, [{
          key: "setOnto",
          value: function setOnto(declarations, prop, originalValue) {
            var append, val, vals;
            append = "";
            val = _Declaration.sanitizeValue(originalValue);
            if (_Declaration.importantClauseRx.test(String(val))) {
              append = " !important";
              val = val.replace(_Declaration.importantClauseRx, "");
            }
            val = val.trim();
            if (val.length === 0) {
              return self2._setAllDirections(declarations, append, append, append, append);
            }
            vals = val.split(" ").map(function(val2) {
              return val2 + append;
            });
            if (vals.length === 1) {
              return self2._setAllDirections(declarations, vals[0], vals[0], vals[0], vals[0]);
            } else if (vals.length === 2) {
              return self2._setAllDirections(declarations, vals[0], vals[1], vals[0], vals[1]);
            } else if (vals.length === 3) {
              return self2._setAllDirections(declarations, vals[0], vals[1], vals[2], vals[1]);
            } else if (vals.length === 4) {
              return self2._setAllDirections(declarations, vals[0], vals[1], vals[2], vals[3]);
            } else {
              throw Error("Can't understand value for margin: `".concat(originalValue, "`"));
            }
          }
        }, {
          key: "_setAllDirections",
          value: function _setAllDirections(declarations, top, right, bottom, left) {
            MarginTop.setOnto(declarations, "marginTop", top);
            MarginTop.setOnto(declarations, "marginRight", right);
            MarginTop.setOnto(declarations, "marginBottom", bottom);
            MarginTop.setOnto(declarations, "marginLeft", left);
          }
        }]);
        return Margin3;
      }(_Declaration);
      ;
      self2 = Margin2;
      return Margin2;
    }.call(void 0);
  }
});

// node_modules/renderkid/lib/renderKid/styles/rule/declarationBlock/PaddingTop.js
var require_PaddingTop = __commonJS({
  "node_modules/renderkid/lib/renderKid/styles/rule/declarationBlock/PaddingTop.js"(exports2, module2) {
    "use strict";
    function _typeof(obj) {
      "@babel/helpers - typeof";
      if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
        _typeof = function _typeof2(obj2) {
          return typeof obj2;
        };
      } else {
        _typeof = function _typeof2(obj2) {
          return obj2 && typeof Symbol === "function" && obj2.constructor === Symbol && obj2 !== Symbol.prototype ? "symbol" : typeof obj2;
        };
      }
      return _typeof(obj);
    }
    function _classCallCheck(instance, Constructor) {
      if (!(instance instanceof Constructor)) {
        throw new TypeError("Cannot call a class as a function");
      }
    }
    function _inherits(subClass, superClass) {
      if (typeof superClass !== "function" && superClass !== null) {
        throw new TypeError("Super expression must either be null or a function");
      }
      subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } });
      if (superClass)
        _setPrototypeOf(subClass, superClass);
    }
    function _setPrototypeOf(o2, p) {
      _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf2(o3, p2) {
        o3.__proto__ = p2;
        return o3;
      };
      return _setPrototypeOf(o2, p);
    }
    function _createSuper(Derived) {
      var hasNativeReflectConstruct = _isNativeReflectConstruct();
      return function _createSuperInternal() {
        var Super = _getPrototypeOf(Derived), result2;
        if (hasNativeReflectConstruct) {
          var NewTarget = _getPrototypeOf(this).constructor;
          result2 = Reflect.construct(Super, arguments, NewTarget);
        } else {
          result2 = Super.apply(this, arguments);
        }
        return _possibleConstructorReturn(this, result2);
      };
    }
    function _possibleConstructorReturn(self2, call) {
      if (call && (_typeof(call) === "object" || typeof call === "function")) {
        return call;
      }
      return _assertThisInitialized(self2);
    }
    function _assertThisInitialized(self2) {
      if (self2 === void 0) {
        throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
      }
      return self2;
    }
    function _isNativeReflectConstruct() {
      if (typeof Reflect === "undefined" || !Reflect.construct)
        return false;
      if (Reflect.construct.sham)
        return false;
      if (typeof Proxy === "function")
        return true;
      try {
        Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
        }));
        return true;
      } catch (e2) {
        return false;
      }
    }
    function _getPrototypeOf(o2) {
      _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf2(o3) {
        return o3.__proto__ || Object.getPrototypeOf(o3);
      };
      return _getPrototypeOf(o2);
    }
    var PaddingTop;
    var _Length;
    _Length = require_Length();
    module2.exports = PaddingTop = /* @__PURE__ */ function(_Length2) {
      _inherits(PaddingTop2, _Length2);
      var _super = _createSuper(PaddingTop2);
      function PaddingTop2() {
        _classCallCheck(this, PaddingTop2);
        return _super.apply(this, arguments);
      }
      return PaddingTop2;
    }(_Length);
  }
});

// node_modules/renderkid/lib/renderKid/styles/rule/declarationBlock/PaddingLeft.js
var require_PaddingLeft = __commonJS({
  "node_modules/renderkid/lib/renderKid/styles/rule/declarationBlock/PaddingLeft.js"(exports2, module2) {
    "use strict";
    function _typeof(obj) {
      "@babel/helpers - typeof";
      if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
        _typeof = function _typeof2(obj2) {
          return typeof obj2;
        };
      } else {
        _typeof = function _typeof2(obj2) {
          return obj2 && typeof Symbol === "function" && obj2.constructor === Symbol && obj2 !== Symbol.prototype ? "symbol" : typeof obj2;
        };
      }
      return _typeof(obj);
    }
    function _classCallCheck(instance, Constructor) {
      if (!(instance instanceof Constructor)) {
        throw new TypeError("Cannot call a class as a function");
      }
    }
    function _inherits(subClass, superClass) {
      if (typeof superClass !== "function" && superClass !== null) {
        throw new TypeError("Super expression must either be null or a function");
      }
      subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } });
      if (superClass)
        _setPrototypeOf(subClass, superClass);
    }
    function _setPrototypeOf(o2, p) {
      _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf2(o3, p2) {
        o3.__proto__ = p2;
        return o3;
      };
      return _setPrototypeOf(o2, p);
    }
    function _createSuper(Derived) {
      var hasNativeReflectConstruct = _isNativeReflectConstruct();
      return function _createSuperInternal() {
        var Super = _getPrototypeOf(Derived), result2;
        if (hasNativeReflectConstruct) {
          var NewTarget = _getPrototypeOf(this).constructor;
          result2 = Reflect.construct(Super, arguments, NewTarget);
        } else {
          result2 = Super.apply(this, arguments);
        }
        return _possibleConstructorReturn(this, result2);
      };
    }
    function _possibleConstructorReturn(self2, call) {
      if (call && (_typeof(call) === "object" || typeof call === "function")) {
        return call;
      }
      return _assertThisInitialized(self2);
    }
    function _assertThisInitialized(self2) {
      if (self2 === void 0) {
        throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
      }
      return self2;
    }
    function _isNativeReflectConstruct() {
      if (typeof Reflect === "undefined" || !Reflect.construct)
        return false;
      if (Reflect.construct.sham)
        return false;
      if (typeof Proxy === "function")
        return true;
      try {
        Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
        }));
        return true;
      } catch (e2) {
        return false;
      }
    }
    function _getPrototypeOf(o2) {
      _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf2(o3) {
        return o3.__proto__ || Object.getPrototypeOf(o3);
      };
      return _getPrototypeOf(o2);
    }
    var PaddingLeft;
    var _Length;
    _Length = require_Length();
    module2.exports = PaddingLeft = /* @__PURE__ */ function(_Length2) {
      _inherits(PaddingLeft2, _Length2);
      var _super = _createSuper(PaddingLeft2);
      function PaddingLeft2() {
        _classCallCheck(this, PaddingLeft2);
        return _super.apply(this, arguments);
      }
      return PaddingLeft2;
    }(_Length);
  }
});

// node_modules/renderkid/lib/renderKid/styles/rule/declarationBlock/PaddingRight.js
var require_PaddingRight = __commonJS({
  "node_modules/renderkid/lib/renderKid/styles/rule/declarationBlock/PaddingRight.js"(exports2, module2) {
    "use strict";
    function _typeof(obj) {
      "@babel/helpers - typeof";
      if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
        _typeof = function _typeof2(obj2) {
          return typeof obj2;
        };
      } else {
        _typeof = function _typeof2(obj2) {
          return obj2 && typeof Symbol === "function" && obj2.constructor === Symbol && obj2 !== Symbol.prototype ? "symbol" : typeof obj2;
        };
      }
      return _typeof(obj);
    }
    function _classCallCheck(instance, Constructor) {
      if (!(instance instanceof Constructor)) {
        throw new TypeError("Cannot call a class as a function");
      }
    }
    function _inherits(subClass, superClass) {
      if (typeof superClass !== "function" && superClass !== null) {
        throw new TypeError("Super expression must either be null or a function");
      }
      subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } });
      if (superClass)
        _setPrototypeOf(subClass, superClass);
    }
    function _setPrototypeOf(o2, p) {
      _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf2(o3, p2) {
        o3.__proto__ = p2;
        return o3;
      };
      return _setPrototypeOf(o2, p);
    }
    function _createSuper(Derived) {
      var hasNativeReflectConstruct = _isNativeReflectConstruct();
      return function _createSuperInternal() {
        var Super = _getPrototypeOf(Derived), result2;
        if (hasNativeReflectConstruct) {
          var NewTarget = _getPrototypeOf(this).constructor;
          result2 = Reflect.construct(Super, arguments, NewTarget);
        } else {
          result2 = Super.apply(this, arguments);
        }
        return _possibleConstructorReturn(this, result2);
      };
    }
    function _possibleConstructorReturn(self2, call) {
      if (call && (_typeof(call) === "object" || typeof call === "function")) {
        return call;
      }
      return _assertThisInitialized(self2);
    }
    function _assertThisInitialized(self2) {
      if (self2 === void 0) {
        throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
      }
      return self2;
    }
    function _isNativeReflectConstruct() {
      if (typeof Reflect === "undefined" || !Reflect.construct)
        return false;
      if (Reflect.construct.sham)
        return false;
      if (typeof Proxy === "function")
        return true;
      try {
        Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
        }));
        return true;
      } catch (e2) {
        return false;
      }
    }
    function _getPrototypeOf(o2) {
      _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf2(o3) {
        return o3.__proto__ || Object.getPrototypeOf(o3);
      };
      return _getPrototypeOf(o2);
    }
    var PaddingRight;
    var _Length;
    _Length = require_Length();
    module2.exports = PaddingRight = /* @__PURE__ */ function(_Length2) {
      _inherits(PaddingRight2, _Length2);
      var _super = _createSuper(PaddingRight2);
      function PaddingRight2() {
        _classCallCheck(this, PaddingRight2);
        return _super.apply(this, arguments);
      }
      return PaddingRight2;
    }(_Length);
  }
});

// node_modules/renderkid/lib/renderKid/styles/rule/declarationBlock/PaddingBottom.js
var require_PaddingBottom = __commonJS({
  "node_modules/renderkid/lib/renderKid/styles/rule/declarationBlock/PaddingBottom.js"(exports2, module2) {
    "use strict";
    function _typeof(obj) {
      "@babel/helpers - typeof";
      if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
        _typeof = function _typeof2(obj2) {
          return typeof obj2;
        };
      } else {
        _typeof = function _typeof2(obj2) {
          return obj2 && typeof Symbol === "function" && obj2.constructor === Symbol && obj2 !== Symbol.prototype ? "symbol" : typeof obj2;
        };
      }
      return _typeof(obj);
    }
    function _classCallCheck(instance, Constructor) {
      if (!(instance instanceof Constructor)) {
        throw new TypeError("Cannot call a class as a function");
      }
    }
    function _inherits(subClass, superClass) {
      if (typeof superClass !== "function" && superClass !== null) {
        throw new TypeError("Super expression must either be null or a function");
      }
      subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } });
      if (superClass)
        _setPrototypeOf(subClass, superClass);
    }
    function _setPrototypeOf(o2, p) {
      _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf2(o3, p2) {
        o3.__proto__ = p2;
        return o3;
      };
      return _setPrototypeOf(o2, p);
    }
    function _createSuper(Derived) {
      var hasNativeReflectConstruct = _isNativeReflectConstruct();
      return function _createSuperInternal() {
        var Super = _getPrototypeOf(Derived), result2;
        if (hasNativeReflectConstruct) {
          var NewTarget = _getPrototypeOf(this).constructor;
          result2 = Reflect.construct(Super, arguments, NewTarget);
        } else {
          result2 = Super.apply(this, arguments);
        }
        return _possibleConstructorReturn(this, result2);
      };
    }
    function _possibleConstructorReturn(self2, call) {
      if (call && (_typeof(call) === "object" || typeof call === "function")) {
        return call;
      }
      return _assertThisInitialized(self2);
    }
    function _assertThisInitialized(self2) {
      if (self2 === void 0) {
        throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
      }
      return self2;
    }
    function _isNativeReflectConstruct() {
      if (typeof Reflect === "undefined" || !Reflect.construct)
        return false;
      if (Reflect.construct.sham)
        return false;
      if (typeof Proxy === "function")
        return true;
      try {
        Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
        }));
        return true;
      } catch (e2) {
        return false;
      }
    }
    function _getPrototypeOf(o2) {
      _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf2(o3) {
        return o3.__proto__ || Object.getPrototypeOf(o3);
      };
      return _getPrototypeOf(o2);
    }
    var PaddingBottom;
    var _Length;
    _Length = require_Length();
    module2.exports = PaddingBottom = /* @__PURE__ */ function(_Length2) {
      _inherits(PaddingBottom2, _Length2);
      var _super = _createSuper(PaddingBottom2);
      function PaddingBottom2() {
        _classCallCheck(this, PaddingBottom2);
        return _super.apply(this, arguments);
      }
      return PaddingBottom2;
    }(_Length);
  }
});

// node_modules/renderkid/lib/renderKid/styles/rule/declarationBlock/Padding.js
var require_Padding = __commonJS({
  "node_modules/renderkid/lib/renderKid/styles/rule/declarationBlock/Padding.js"(exports2, module2) {
    "use strict";
    function _typeof(obj) {
      "@babel/helpers - typeof";
      if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
        _typeof = function _typeof2(obj2) {
          return typeof obj2;
        };
      } else {
        _typeof = function _typeof2(obj2) {
          return obj2 && typeof Symbol === "function" && obj2.constructor === Symbol && obj2 !== Symbol.prototype ? "symbol" : typeof obj2;
        };
      }
      return _typeof(obj);
    }
    function _classCallCheck(instance, Constructor) {
      if (!(instance instanceof Constructor)) {
        throw new TypeError("Cannot call a class as a function");
      }
    }
    function _defineProperties(target, props) {
      for (var i3 = 0; i3 < props.length; i3++) {
        var descriptor = props[i3];
        descriptor.enumerable = descriptor.enumerable || false;
        descriptor.configurable = true;
        if ("value" in descriptor)
          descriptor.writable = true;
        Object.defineProperty(target, descriptor.key, descriptor);
      }
    }
    function _createClass(Constructor, protoProps, staticProps) {
      if (protoProps)
        _defineProperties(Constructor.prototype, protoProps);
      if (staticProps)
        _defineProperties(Constructor, staticProps);
      return Constructor;
    }
    function _inherits(subClass, superClass) {
      if (typeof superClass !== "function" && superClass !== null) {
        throw new TypeError("Super expression must either be null or a function");
      }
      subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } });
      if (superClass)
        _setPrototypeOf(subClass, superClass);
    }
    function _setPrototypeOf(o2, p) {
      _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf2(o3, p2) {
        o3.__proto__ = p2;
        return o3;
      };
      return _setPrototypeOf(o2, p);
    }
    function _createSuper(Derived) {
      var hasNativeReflectConstruct = _isNativeReflectConstruct();
      return function _createSuperInternal() {
        var Super = _getPrototypeOf(Derived), result2;
        if (hasNativeReflectConstruct) {
          var NewTarget = _getPrototypeOf(this).constructor;
          result2 = Reflect.construct(Super, arguments, NewTarget);
        } else {
          result2 = Super.apply(this, arguments);
        }
        return _possibleConstructorReturn(this, result2);
      };
    }
    function _possibleConstructorReturn(self2, call) {
      if (call && (_typeof(call) === "object" || typeof call === "function")) {
        return call;
      }
      return _assertThisInitialized(self2);
    }
    function _assertThisInitialized(self2) {
      if (self2 === void 0) {
        throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
      }
      return self2;
    }
    function _isNativeReflectConstruct() {
      if (typeof Reflect === "undefined" || !Reflect.construct)
        return false;
      if (Reflect.construct.sham)
        return false;
      if (typeof Proxy === "function")
        return true;
      try {
        Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
        }));
        return true;
      } catch (e2) {
        return false;
      }
    }
    function _getPrototypeOf(o2) {
      _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf2(o3) {
        return o3.__proto__ || Object.getPrototypeOf(o3);
      };
      return _getPrototypeOf(o2);
    }
    var Padding;
    var PaddingBottom;
    var PaddingLeft;
    var PaddingRight;
    var PaddingTop;
    var _Declaration;
    _Declaration = require_Declaration();
    PaddingTop = require_PaddingTop();
    PaddingLeft = require_PaddingLeft();
    PaddingRight = require_PaddingRight();
    PaddingBottom = require_PaddingBottom();
    module2.exports = Padding = function() {
      var self2;
      var Padding2 = /* @__PURE__ */ function(_Declaration2) {
        _inherits(Padding3, _Declaration2);
        var _super = _createSuper(Padding3);
        function Padding3() {
          _classCallCheck(this, Padding3);
          return _super.apply(this, arguments);
        }
        _createClass(Padding3, null, [{
          key: "setOnto",
          value: function setOnto(declarations, prop, originalValue) {
            var append, val, vals;
            append = "";
            val = _Declaration.sanitizeValue(originalValue);
            if (_Declaration.importantClauseRx.test(String(val))) {
              append = " !important";
              val = val.replace(_Declaration.importantClauseRx, "");
            }
            val = val.trim();
            if (val.length === 0) {
              return self2._setAllDirections(declarations, append, append, append, append);
            }
            vals = val.split(" ").map(function(val2) {
              return val2 + append;
            });
            if (vals.length === 1) {
              return self2._setAllDirections(declarations, vals[0], vals[0], vals[0], vals[0]);
            } else if (vals.length === 2) {
              return self2._setAllDirections(declarations, vals[0], vals[1], vals[0], vals[1]);
            } else if (vals.length === 3) {
              return self2._setAllDirections(declarations, vals[0], vals[1], vals[2], vals[1]);
            } else if (vals.length === 4) {
              return self2._setAllDirections(declarations, vals[0], vals[1], vals[2], vals[3]);
            } else {
              throw Error("Can't understand value for padding: `".concat(originalValue, "`"));
            }
          }
        }, {
          key: "_setAllDirections",
          value: function _setAllDirections(declarations, top, right, bottom, left) {
            PaddingTop.setOnto(declarations, "paddingTop", top);
            PaddingTop.setOnto(declarations, "paddingRight", right);
            PaddingTop.setOnto(declarations, "paddingBottom", bottom);
            PaddingTop.setOnto(declarations, "paddingLeft", left);
          }
        }]);
        return Padding3;
      }(_Declaration);
      ;
      self2 = Padding2;
      return Padding2;
    }.call(void 0);
  }
});

// node_modules/renderkid/lib/renderKid/styles/rule/DeclarationBlock.js
var require_DeclarationBlock = __commonJS({
  "node_modules/renderkid/lib/renderKid/styles/rule/DeclarationBlock.js"(exports2, module2) {
    "use strict";
    function _typeof(obj) {
      "@babel/helpers - typeof";
      if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
        _typeof = function _typeof2(obj2) {
          return typeof obj2;
        };
      } else {
        _typeof = function _typeof2(obj2) {
          return obj2 && typeof Symbol === "function" && obj2.constructor === Symbol && obj2 !== Symbol.prototype ? "symbol" : typeof obj2;
        };
      }
      return _typeof(obj);
    }
    function _classCallCheck(instance, Constructor) {
      if (!(instance instanceof Constructor)) {
        throw new TypeError("Cannot call a class as a function");
      }
    }
    function _defineProperties(target, props) {
      for (var i3 = 0; i3 < props.length; i3++) {
        var descriptor = props[i3];
        descriptor.enumerable = descriptor.enumerable || false;
        descriptor.configurable = true;
        if ("value" in descriptor)
          descriptor.writable = true;
        Object.defineProperty(target, descriptor.key, descriptor);
      }
    }
    function _createClass(Constructor, protoProps, staticProps) {
      if (protoProps)
        _defineProperties(Constructor.prototype, protoProps);
      if (staticProps)
        _defineProperties(Constructor, staticProps);
      return Constructor;
    }
    var Arbitrary;
    var DeclarationBlock;
    var declarationClasses;
    module2.exports = DeclarationBlock = function() {
      var self2;
      var DeclarationBlock2 = /* @__PURE__ */ function() {
        function DeclarationBlock3() {
          _classCallCheck(this, DeclarationBlock3);
          this._declarations = {};
        }
        _createClass(DeclarationBlock3, [{
          key: "set",
          value: function set2(prop, value) {
            var key2, val;
            if (_typeof(prop) === "object") {
              for (key2 in prop) {
                val = prop[key2];
                this.set(key2, val);
              }
              return this;
            }
            prop = self2.sanitizeProp(prop);
            this._getDeclarationClass(prop).setOnto(this._declarations, prop, value);
            return this;
          }
        }, {
          key: "_getDeclarationClass",
          value: function _getDeclarationClass(prop) {
            var cls;
            if (prop[0] === "_") {
              return Arbitrary;
            }
            if (!(cls = declarationClasses[prop])) {
              throw Error("Unknown property `".concat(prop, "`. Write it as `_").concat(prop, "` if you're defining a custom property"));
            }
            return cls;
          }
        }], [{
          key: "sanitizeProp",
          value: function sanitizeProp(prop) {
            return String(prop).trim();
          }
        }]);
        return DeclarationBlock3;
      }();
      ;
      self2 = DeclarationBlock2;
      return DeclarationBlock2;
    }.call(void 0);
    Arbitrary = require_Arbitrary();
    declarationClasses = {
      color: require_Color(),
      background: require_Background(),
      width: require_Width(),
      height: require_Height(),
      bullet: require_Bullet(),
      display: require_Display(),
      margin: require_Margin(),
      marginTop: require_MarginTop(),
      marginLeft: require_MarginLeft(),
      marginRight: require_MarginRight(),
      marginBottom: require_MarginBottom(),
      padding: require_Padding(),
      paddingTop: require_PaddingTop(),
      paddingLeft: require_PaddingLeft(),
      paddingRight: require_PaddingRight(),
      paddingBottom: require_PaddingBottom()
    };
  }
});

// node_modules/renderkid/lib/renderKid/styles/Rule.js
var require_Rule = __commonJS({
  "node_modules/renderkid/lib/renderKid/styles/Rule.js"(exports2, module2) {
    "use strict";
    function _classCallCheck(instance, Constructor) {
      if (!(instance instanceof Constructor)) {
        throw new TypeError("Cannot call a class as a function");
      }
    }
    function _defineProperties(target, props) {
      for (var i3 = 0; i3 < props.length; i3++) {
        var descriptor = props[i3];
        descriptor.enumerable = descriptor.enumerable || false;
        descriptor.configurable = true;
        if ("value" in descriptor)
          descriptor.writable = true;
        Object.defineProperty(target, descriptor.key, descriptor);
      }
    }
    function _createClass(Constructor, protoProps, staticProps) {
      if (protoProps)
        _defineProperties(Constructor.prototype, protoProps);
      if (staticProps)
        _defineProperties(Constructor, staticProps);
      return Constructor;
    }
    var DeclarationBlock;
    var Rule;
    var Selector;
    Selector = require_Selector();
    DeclarationBlock = require_DeclarationBlock();
    module2.exports = Rule = /* @__PURE__ */ function() {
      function Rule2(selector) {
        _classCallCheck(this, Rule2);
        this.selector = new Selector(selector);
        this.styles = new DeclarationBlock();
      }
      _createClass(Rule2, [{
        key: "setStyles",
        value: function setStyles(styles) {
          this.styles.set(styles);
          return this;
        }
      }]);
      return Rule2;
    }();
  }
});

// node_modules/renderkid/lib/renderKid/styles/StyleSheet.js
var require_StyleSheet = __commonJS({
  "node_modules/renderkid/lib/renderKid/styles/StyleSheet.js"(exports2, module2) {
    "use strict";
    function _typeof(obj) {
      "@babel/helpers - typeof";
      if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
        _typeof = function _typeof2(obj2) {
          return typeof obj2;
        };
      } else {
        _typeof = function _typeof2(obj2) {
          return obj2 && typeof Symbol === "function" && obj2.constructor === Symbol && obj2 !== Symbol.prototype ? "symbol" : typeof obj2;
        };
      }
      return _typeof(obj);
    }
    function _classCallCheck(instance, Constructor) {
      if (!(instance instanceof Constructor)) {
        throw new TypeError("Cannot call a class as a function");
      }
    }
    function _defineProperties(target, props) {
      for (var i3 = 0; i3 < props.length; i3++) {
        var descriptor = props[i3];
        descriptor.enumerable = descriptor.enumerable || false;
        descriptor.configurable = true;
        if ("value" in descriptor)
          descriptor.writable = true;
        Object.defineProperty(target, descriptor.key, descriptor);
      }
    }
    function _createClass(Constructor, protoProps, staticProps) {
      if (protoProps)
        _defineProperties(Constructor.prototype, protoProps);
      if (staticProps)
        _defineProperties(Constructor, staticProps);
      return Constructor;
    }
    var Rule;
    var StyleSheet;
    Rule = require_Rule();
    module2.exports = StyleSheet = function() {
      var self2;
      var StyleSheet2 = /* @__PURE__ */ function() {
        function StyleSheet3() {
          _classCallCheck(this, StyleSheet3);
          this._rulesBySelector = {};
        }
        _createClass(StyleSheet3, [{
          key: "setRule",
          value: function setRule(selector, styles) {
            var key2, val;
            if (typeof selector === "string") {
              this._setRule(selector, styles);
            } else if (_typeof(selector) === "object") {
              for (key2 in selector) {
                val = selector[key2];
                this._setRule(key2, val);
              }
            }
            return this;
          }
        }, {
          key: "_setRule",
          value: function _setRule(s2, styles) {
            var i3, len, ref2, selector;
            ref2 = self2.splitSelectors(s2);
            for (i3 = 0, len = ref2.length; i3 < len; i3++) {
              selector = ref2[i3];
              this._setSingleRule(selector, styles);
            }
            return this;
          }
        }, {
          key: "_setSingleRule",
          value: function _setSingleRule(s2, styles) {
            var rule, selector;
            selector = self2.normalizeSelector(s2);
            if (!(rule = this._rulesBySelector[selector])) {
              rule = new Rule(selector);
              this._rulesBySelector[selector] = rule;
            }
            rule.setStyles(styles);
            return this;
          }
        }, {
          key: "getRulesFor",
          value: function getRulesFor(el) {
            var ref2, rule, rules, selector;
            rules = [];
            ref2 = this._rulesBySelector;
            for (selector in ref2) {
              rule = ref2[selector];
              if (rule.selector.matches(el)) {
                rules.push(rule);
              }
            }
            return rules;
          }
        }], [{
          key: "normalizeSelector",
          value: function normalizeSelector(selector) {
            return selector.replace(/[\s]+/g, " ").replace(/[\s]*([>\,\+]{1})[\s]*/g, "$1").trim();
          }
        }, {
          key: "splitSelectors",
          value: function splitSelectors(s2) {
            return s2.trim().split(",");
          }
        }]);
        return StyleSheet3;
      }();
      ;
      self2 = StyleSheet2;
      return StyleSheet2;
    }.call(void 0);
  }
});

// node_modules/renderkid/lib/renderKid/styles/rule/MixedDeclarationSet.js
var require_MixedDeclarationSet = __commonJS({
  "node_modules/renderkid/lib/renderKid/styles/rule/MixedDeclarationSet.js"(exports2, module2) {
    "use strict";
    function _classCallCheck(instance, Constructor) {
      if (!(instance instanceof Constructor)) {
        throw new TypeError("Cannot call a class as a function");
      }
    }
    function _defineProperties(target, props) {
      for (var i3 = 0; i3 < props.length; i3++) {
        var descriptor = props[i3];
        descriptor.enumerable = descriptor.enumerable || false;
        descriptor.configurable = true;
        if ("value" in descriptor)
          descriptor.writable = true;
        Object.defineProperty(target, descriptor.key, descriptor);
      }
    }
    function _createClass(Constructor, protoProps, staticProps) {
      if (protoProps)
        _defineProperties(Constructor.prototype, protoProps);
      if (staticProps)
        _defineProperties(Constructor, staticProps);
      return Constructor;
    }
    var MixedDeclarationSet;
    module2.exports = MixedDeclarationSet = function() {
      var self2;
      var MixedDeclarationSet2 = /* @__PURE__ */ function() {
        function MixedDeclarationSet3() {
          _classCallCheck(this, MixedDeclarationSet3);
          this._declarations = {};
        }
        _createClass(MixedDeclarationSet3, [{
          key: "mixWithList",
          value: function mixWithList(rules) {
            var i3, len, rule;
            rules.sort(function(a2, b2) {
              return a2.selector.priority > b2.selector.priority;
            });
            for (i3 = 0, len = rules.length; i3 < len; i3++) {
              rule = rules[i3];
              this._mixWithRule(rule);
            }
            return this;
          }
        }, {
          key: "_mixWithRule",
          value: function _mixWithRule(rule) {
            var dec, prop, ref2;
            ref2 = rule.styles._declarations;
            for (prop in ref2) {
              dec = ref2[prop];
              this._mixWithDeclaration(dec);
            }
          }
        }, {
          key: "_mixWithDeclaration",
          value: function _mixWithDeclaration(dec) {
            var cur;
            cur = this._declarations[dec.prop];
            if (cur != null && cur.important && !dec.important) {
              return;
            }
            this._declarations[dec.prop] = dec;
          }
        }, {
          key: "get",
          value: function get(prop) {
            if (prop == null) {
              return this._declarations;
            }
            if (this._declarations[prop] == null) {
              return null;
            }
            return this._declarations[prop].val;
          }
        }, {
          key: "toObject",
          value: function toObject() {
            var dec, obj, prop, ref2;
            obj = {};
            ref2 = this._declarations;
            for (prop in ref2) {
              dec = ref2[prop];
              obj[prop] = dec.val;
            }
            return obj;
          }
        }], [{
          key: "mix",
          value: function mix() {
            var i3, len, mixed, rules;
            mixed = new self2();
            for (var _len = arguments.length, ruleSets = new Array(_len), _key = 0; _key < _len; _key++) {
              ruleSets[_key] = arguments[_key];
            }
            for (i3 = 0, len = ruleSets.length; i3 < len; i3++) {
              rules = ruleSets[i3];
              mixed.mixWithList(rules);
            }
            return mixed;
          }
        }]);
        return MixedDeclarationSet3;
      }();
      ;
      self2 = MixedDeclarationSet2;
      return MixedDeclarationSet2;
    }.call(void 0);
  }
});

// node_modules/renderkid/lib/renderKid/Styles.js
var require_Styles = __commonJS({
  "node_modules/renderkid/lib/renderKid/Styles.js"(exports2, module2) {
    "use strict";
    function _classCallCheck(instance, Constructor) {
      if (!(instance instanceof Constructor)) {
        throw new TypeError("Cannot call a class as a function");
      }
    }
    function _defineProperties(target, props) {
      for (var i3 = 0; i3 < props.length; i3++) {
        var descriptor = props[i3];
        descriptor.enumerable = descriptor.enumerable || false;
        descriptor.configurable = true;
        if ("value" in descriptor)
          descriptor.writable = true;
        Object.defineProperty(target, descriptor.key, descriptor);
      }
    }
    function _createClass(Constructor, protoProps, staticProps) {
      if (protoProps)
        _defineProperties(Constructor.prototype, protoProps);
      if (staticProps)
        _defineProperties(Constructor, staticProps);
      return Constructor;
    }
    var MixedDeclarationSet;
    var StyleSheet;
    var Styles;
    var terminalWidth;
    StyleSheet = require_StyleSheet();
    MixedDeclarationSet = require_MixedDeclarationSet();
    terminalWidth = require_tools().getCols();
    module2.exports = Styles = function() {
      var self2;
      var Styles2 = /* @__PURE__ */ function() {
        function Styles3() {
          _classCallCheck(this, Styles3);
          this._defaultStyles = new StyleSheet();
          this._userStyles = new StyleSheet();
          this._setDefaultStyles();
        }
        _createClass(Styles3, [{
          key: "_setDefaultStyles",
          value: function _setDefaultStyles() {
            this._defaultStyles.setRule(self2.defaultRules);
          }
        }, {
          key: "setRule",
          value: function setRule(selector, rules) {
            this._userStyles.setRule.apply(this._userStyles, arguments);
            return this;
          }
        }, {
          key: "getStyleFor",
          value: function getStyleFor(el) {
            var styles;
            styles = el.styles;
            if (styles == null) {
              el.styles = styles = this._getComputedStyleFor(el);
            }
            return styles;
          }
        }, {
          key: "_getRawStyleFor",
          value: function _getRawStyleFor(el) {
            var def, user;
            def = this._defaultStyles.getRulesFor(el);
            user = this._userStyles.getRulesFor(el);
            return MixedDeclarationSet.mix(def, user).toObject();
          }
        }, {
          key: "_getComputedStyleFor",
          value: function _getComputedStyleFor(el) {
            var decs, parent, prop, ref2, val;
            decs = {};
            parent = el.parent;
            ref2 = this._getRawStyleFor(el);
            for (prop in ref2) {
              val = ref2[prop];
              if (val !== "inherit") {
                decs[prop] = val;
              } else {
                throw Error("Inherited styles are not supported yet.");
              }
            }
            return decs;
          }
        }]);
        return Styles3;
      }();
      ;
      self2 = Styles2;
      Styles2.defaultRules = {
        "*": {
          display: "inline"
        },
        "body": {
          background: "none",
          color: "white",
          display: "block",
          width: terminalWidth + " !important"
        }
      };
      return Styles2;
    }.call(void 0);
  }
});

// node_modules/renderkid/lib/layout/SpecialString.js
var require_SpecialString = __commonJS({
  "node_modules/renderkid/lib/layout/SpecialString.js"(exports2, module2) {
    "use strict";
    function _classCallCheck(instance, Constructor) {
      if (!(instance instanceof Constructor)) {
        throw new TypeError("Cannot call a class as a function");
      }
    }
    function _defineProperties(target, props) {
      for (var i4 = 0; i4 < props.length; i4++) {
        var descriptor = props[i4];
        descriptor.enumerable = descriptor.enumerable || false;
        descriptor.configurable = true;
        if ("value" in descriptor)
          descriptor.writable = true;
        Object.defineProperty(target, descriptor.key, descriptor);
      }
    }
    function _createClass(Constructor, protoProps, staticProps) {
      if (protoProps)
        _defineProperties(Constructor.prototype, protoProps);
      if (staticProps)
        _defineProperties(Constructor, staticProps);
      return Constructor;
    }
    var SpecialString;
    var i3;
    var len;
    var prop;
    var ref2;
    module2.exports = SpecialString = function() {
      var self2;
      var SpecialString2 = /* @__PURE__ */ function() {
        function SpecialString3(str2) {
          _classCallCheck(this, SpecialString3);
          if (!(this instanceof self2)) {
            return new self2(str2);
          }
          this._str = String(str2);
          this._len = 0;
        }
        _createClass(SpecialString3, [{
          key: "_getStr",
          value: function _getStr() {
            return this._str;
          }
        }, {
          key: "set",
          value: function set2(str2) {
            this._str = String(str2);
            return this;
          }
        }, {
          key: "clone",
          value: function clone() {
            return new SpecialString3(this._str);
          }
        }, {
          key: "isEmpty",
          value: function isEmpty() {
            return this._str === "";
          }
        }, {
          key: "isOnlySpecialChars",
          value: function isOnlySpecialChars() {
            return !this.isEmpty() && this.length === 0;
          }
        }, {
          key: "_reset",
          value: function _reset() {
            return this._len = 0;
          }
        }, {
          key: "splitIn",
          value: function splitIn(limit) {
            var trimLeftEachLine = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : false;
            var buffer2, bufferLength, justSkippedSkipChar, lines;
            buffer2 = "";
            bufferLength = 0;
            lines = [];
            justSkippedSkipChar = false;
            self2._countChars(this._str, function(char, charLength) {
              if (bufferLength > limit || bufferLength + charLength > limit) {
                lines.push(buffer2);
                buffer2 = "";
                bufferLength = 0;
              }
              if (bufferLength === 0 && char === " " && !justSkippedSkipChar && trimLeftEachLine) {
                return justSkippedSkipChar = true;
              } else {
                buffer2 += char;
                bufferLength += charLength;
                return justSkippedSkipChar = false;
              }
            });
            if (buffer2.length > 0) {
              lines.push(buffer2);
            }
            return lines;
          }
        }, {
          key: "trim",
          value: function trim() {
            return new SpecialString3(this.str.trim());
          }
        }, {
          key: "trimLeft",
          value: function trimLeft() {
            return new SpecialString3(this.str.replace(/^\s+/, ""));
          }
        }, {
          key: "trimRight",
          value: function trimRight() {
            return new SpecialString3(this.str.replace(/\s+$/, ""));
          }
        }, {
          key: "_getLength",
          value: function _getLength() {
            var sum;
            sum = 0;
            self2._countChars(this._str, function(char, charLength) {
              sum += charLength;
            });
            return sum;
          }
        }, {
          key: "cut",
          value: function cut(from, to) {
            var _this = this;
            var trimLeft = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : false;
            var after, before, cur, cut2;
            if (to == null) {
              to = this.length;
            }
            from = parseInt(from);
            if (from >= to) {
              throw Error("`from` shouldn't be larger than `to`");
            }
            before = "";
            after = "";
            cut2 = "";
            cur = 0;
            self2._countChars(this._str, function(char, charLength) {
              if (_this.str === "ab<tag>") {
                console.log(charLength, char);
              }
              if (cur === from && char.match(/^\s+$/) && trimLeft) {
                return;
              }
              if (cur < from) {
                before += char;
              } else if (cur < to || cur + charLength <= to) {
                cut2 += char;
              } else {
                after += char;
              }
              cur += charLength;
            });
            this._str = before + after;
            this._reset();
            return new SpecialString3(cut2);
          }
        }], [{
          key: "_countChars",
          value: function _countChars(text, cb2) {
            var char, charLength, m;
            while (text.length !== 0) {
              if (m = text.match(self2._tagRx)) {
                char = m[0];
                charLength = 0;
                text = text.substr(char.length, text.length);
              } else if (m = text.match(self2._quotedHtmlRx)) {
                char = m[0];
                charLength = 1;
                text = text.substr(char.length, text.length);
              } else if (text.match(self2._tabRx)) {
                char = "	";
                charLength = 8;
                text = text.substr(1, text.length);
              } else {
                char = text[0];
                charLength = 1;
                text = text.substr(1, text.length);
              }
              cb2.call(null, char, charLength);
            }
          }
        }]);
        return SpecialString3;
      }();
      ;
      self2 = SpecialString2;
      SpecialString2._tabRx = /^\t/;
      SpecialString2._tagRx = /^<[^>]+>/;
      SpecialString2._quotedHtmlRx = /^&(gt|lt|quot|amp|apos|sp);/;
      return SpecialString2;
    }.call(void 0);
    ref2 = ["str", "length"];
    for (i3 = 0, len = ref2.length; i3 < len; i3++) {
      prop = ref2[i3];
      (function() {
        var methodName;
        methodName = "_get" + prop[0].toUpperCase() + prop.substr(1, prop.length);
        return SpecialString.prototype.__defineGetter__(prop, function() {
          return this[methodName]();
        });
      })();
    }
  }
});

// node_modules/renderkid/lib/layout/block/blockPrependor/_BlockPrependor.js
var require_BlockPrependor = __commonJS({
  "node_modules/renderkid/lib/layout/block/blockPrependor/_BlockPrependor.js"(exports2, module2) {
    "use strict";
    function _classCallCheck(instance, Constructor) {
      if (!(instance instanceof Constructor)) {
        throw new TypeError("Cannot call a class as a function");
      }
    }
    function _defineProperties(target, props) {
      for (var i3 = 0; i3 < props.length; i3++) {
        var descriptor = props[i3];
        descriptor.enumerable = descriptor.enumerable || false;
        descriptor.configurable = true;
        if ("value" in descriptor)
          descriptor.writable = true;
        Object.defineProperty(target, descriptor.key, descriptor);
      }
    }
    function _createClass(Constructor, protoProps, staticProps) {
      if (protoProps)
        _defineProperties(Constructor.prototype, protoProps);
      if (staticProps)
        _defineProperties(Constructor, staticProps);
      return Constructor;
    }
    var _BlockPrependor;
    module2.exports = _BlockPrependor = /* @__PURE__ */ function() {
      function _BlockPrependor2(_config) {
        _classCallCheck(this, _BlockPrependor2);
        this._config = _config;
      }
      _createClass(_BlockPrependor2, [{
        key: "render",
        value: function render2(options) {
          return this._render(options);
        }
      }]);
      return _BlockPrependor2;
    }();
  }
});

// node_modules/renderkid/lib/layout/block/blockPrependor/Default.js
var require_Default = __commonJS({
  "node_modules/renderkid/lib/layout/block/blockPrependor/Default.js"(exports2, module2) {
    "use strict";
    function _typeof(obj) {
      "@babel/helpers - typeof";
      if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
        _typeof = function _typeof2(obj2) {
          return typeof obj2;
        };
      } else {
        _typeof = function _typeof2(obj2) {
          return obj2 && typeof Symbol === "function" && obj2.constructor === Symbol && obj2 !== Symbol.prototype ? "symbol" : typeof obj2;
        };
      }
      return _typeof(obj);
    }
    function _classCallCheck(instance, Constructor) {
      if (!(instance instanceof Constructor)) {
        throw new TypeError("Cannot call a class as a function");
      }
    }
    function _defineProperties(target, props) {
      for (var i3 = 0; i3 < props.length; i3++) {
        var descriptor = props[i3];
        descriptor.enumerable = descriptor.enumerable || false;
        descriptor.configurable = true;
        if ("value" in descriptor)
          descriptor.writable = true;
        Object.defineProperty(target, descriptor.key, descriptor);
      }
    }
    function _createClass(Constructor, protoProps, staticProps) {
      if (protoProps)
        _defineProperties(Constructor.prototype, protoProps);
      if (staticProps)
        _defineProperties(Constructor, staticProps);
      return Constructor;
    }
    function _inherits(subClass, superClass) {
      if (typeof superClass !== "function" && superClass !== null) {
        throw new TypeError("Super expression must either be null or a function");
      }
      subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } });
      if (superClass)
        _setPrototypeOf(subClass, superClass);
    }
    function _setPrototypeOf(o2, p) {
      _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf2(o3, p2) {
        o3.__proto__ = p2;
        return o3;
      };
      return _setPrototypeOf(o2, p);
    }
    function _createSuper(Derived) {
      var hasNativeReflectConstruct = _isNativeReflectConstruct();
      return function _createSuperInternal() {
        var Super = _getPrototypeOf(Derived), result2;
        if (hasNativeReflectConstruct) {
          var NewTarget = _getPrototypeOf(this).constructor;
          result2 = Reflect.construct(Super, arguments, NewTarget);
        } else {
          result2 = Super.apply(this, arguments);
        }
        return _possibleConstructorReturn(this, result2);
      };
    }
    function _possibleConstructorReturn(self2, call) {
      if (call && (_typeof(call) === "object" || typeof call === "function")) {
        return call;
      }
      return _assertThisInitialized(self2);
    }
    function _assertThisInitialized(self2) {
      if (self2 === void 0) {
        throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
      }
      return self2;
    }
    function _isNativeReflectConstruct() {
      if (typeof Reflect === "undefined" || !Reflect.construct)
        return false;
      if (Reflect.construct.sham)
        return false;
      if (typeof Proxy === "function")
        return true;
      try {
        Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
        }));
        return true;
      } catch (e2) {
        return false;
      }
    }
    function _getPrototypeOf(o2) {
      _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf2(o3) {
        return o3.__proto__ || Object.getPrototypeOf(o3);
      };
      return _getPrototypeOf(o2);
    }
    var DefaultBlockPrependor;
    var tools;
    tools = require_tools();
    module2.exports = DefaultBlockPrependor = /* @__PURE__ */ function(_require) {
      _inherits(DefaultBlockPrependor2, _require);
      var _super = _createSuper(DefaultBlockPrependor2);
      function DefaultBlockPrependor2() {
        _classCallCheck(this, DefaultBlockPrependor2);
        return _super.apply(this, arguments);
      }
      _createClass(DefaultBlockPrependor2, [{
        key: "_render",
        value: function _render(options) {
          return tools.repeatString("\n", this._config.amount);
        }
      }]);
      return DefaultBlockPrependor2;
    }(require_BlockPrependor());
  }
});

// node_modules/renderkid/lib/layout/block/blockAppendor/_BlockAppendor.js
var require_BlockAppendor = __commonJS({
  "node_modules/renderkid/lib/layout/block/blockAppendor/_BlockAppendor.js"(exports2, module2) {
    "use strict";
    function _classCallCheck(instance, Constructor) {
      if (!(instance instanceof Constructor)) {
        throw new TypeError("Cannot call a class as a function");
      }
    }
    function _defineProperties(target, props) {
      for (var i3 = 0; i3 < props.length; i3++) {
        var descriptor = props[i3];
        descriptor.enumerable = descriptor.enumerable || false;
        descriptor.configurable = true;
        if ("value" in descriptor)
          descriptor.writable = true;
        Object.defineProperty(target, descriptor.key, descriptor);
      }
    }
    function _createClass(Constructor, protoProps, staticProps) {
      if (protoProps)
        _defineProperties(Constructor.prototype, protoProps);
      if (staticProps)
        _defineProperties(Constructor, staticProps);
      return Constructor;
    }
    var _BlockAppendor;
    module2.exports = _BlockAppendor = /* @__PURE__ */ function() {
      function _BlockAppendor2(_config) {
        _classCallCheck(this, _BlockAppendor2);
        this._config = _config;
      }
      _createClass(_BlockAppendor2, [{
        key: "render",
        value: function render2(options) {
          return this._render(options);
        }
      }]);
      return _BlockAppendor2;
    }();
  }
});

// node_modules/renderkid/lib/layout/block/blockAppendor/Default.js
var require_Default2 = __commonJS({
  "node_modules/renderkid/lib/layout/block/blockAppendor/Default.js"(exports2, module2) {
    "use strict";
    function _typeof(obj) {
      "@babel/helpers - typeof";
      if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
        _typeof = function _typeof2(obj2) {
          return typeof obj2;
        };
      } else {
        _typeof = function _typeof2(obj2) {
          return obj2 && typeof Symbol === "function" && obj2.constructor === Symbol && obj2 !== Symbol.prototype ? "symbol" : typeof obj2;
        };
      }
      return _typeof(obj);
    }
    function _classCallCheck(instance, Constructor) {
      if (!(instance instanceof Constructor)) {
        throw new TypeError("Cannot call a class as a function");
      }
    }
    function _defineProperties(target, props) {
      for (var i3 = 0; i3 < props.length; i3++) {
        var descriptor = props[i3];
        descriptor.enumerable = descriptor.enumerable || false;
        descriptor.configurable = true;
        if ("value" in descriptor)
          descriptor.writable = true;
        Object.defineProperty(target, descriptor.key, descriptor);
      }
    }
    function _createClass(Constructor, protoProps, staticProps) {
      if (protoProps)
        _defineProperties(Constructor.prototype, protoProps);
      if (staticProps)
        _defineProperties(Constructor, staticProps);
      return Constructor;
    }
    function _inherits(subClass, superClass) {
      if (typeof superClass !== "function" && superClass !== null) {
        throw new TypeError("Super expression must either be null or a function");
      }
      subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } });
      if (superClass)
        _setPrototypeOf(subClass, superClass);
    }
    function _setPrototypeOf(o2, p) {
      _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf2(o3, p2) {
        o3.__proto__ = p2;
        return o3;
      };
      return _setPrototypeOf(o2, p);
    }
    function _createSuper(Derived) {
      var hasNativeReflectConstruct = _isNativeReflectConstruct();
      return function _createSuperInternal() {
        var Super = _getPrototypeOf(Derived), result2;
        if (hasNativeReflectConstruct) {
          var NewTarget = _getPrototypeOf(this).constructor;
          result2 = Reflect.construct(Super, arguments, NewTarget);
        } else {
          result2 = Super.apply(this, arguments);
        }
        return _possibleConstructorReturn(this, result2);
      };
    }
    function _possibleConstructorReturn(self2, call) {
      if (call && (_typeof(call) === "object" || typeof call === "function")) {
        return call;
      }
      return _assertThisInitialized(self2);
    }
    function _assertThisInitialized(self2) {
      if (self2 === void 0) {
        throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
      }
      return self2;
    }
    function _isNativeReflectConstruct() {
      if (typeof Reflect === "undefined" || !Reflect.construct)
        return false;
      if (Reflect.construct.sham)
        return false;
      if (typeof Proxy === "function")
        return true;
      try {
        Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
        }));
        return true;
      } catch (e2) {
        return false;
      }
    }
    function _getPrototypeOf(o2) {
      _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf2(o3) {
        return o3.__proto__ || Object.getPrototypeOf(o3);
      };
      return _getPrototypeOf(o2);
    }
    var DefaultBlockAppendor;
    var tools;
    tools = require_tools();
    module2.exports = DefaultBlockAppendor = /* @__PURE__ */ function(_require) {
      _inherits(DefaultBlockAppendor2, _require);
      var _super = _createSuper(DefaultBlockAppendor2);
      function DefaultBlockAppendor2() {
        _classCallCheck(this, DefaultBlockAppendor2);
        return _super.apply(this, arguments);
      }
      _createClass(DefaultBlockAppendor2, [{
        key: "_render",
        value: function _render(options) {
          return tools.repeatString("\n", this._config.amount);
        }
      }]);
      return DefaultBlockAppendor2;
    }(require_BlockAppendor());
  }
});

// node_modules/renderkid/lib/layout/block/linePrependor/_LinePrependor.js
var require_LinePrependor = __commonJS({
  "node_modules/renderkid/lib/layout/block/linePrependor/_LinePrependor.js"(exports2, module2) {
    "use strict";
    function _classCallCheck(instance, Constructor) {
      if (!(instance instanceof Constructor)) {
        throw new TypeError("Cannot call a class as a function");
      }
    }
    function _defineProperties(target, props) {
      for (var i3 = 0; i3 < props.length; i3++) {
        var descriptor = props[i3];
        descriptor.enumerable = descriptor.enumerable || false;
        descriptor.configurable = true;
        if ("value" in descriptor)
          descriptor.writable = true;
        Object.defineProperty(target, descriptor.key, descriptor);
      }
    }
    function _createClass(Constructor, protoProps, staticProps) {
      if (protoProps)
        _defineProperties(Constructor.prototype, protoProps);
      if (staticProps)
        _defineProperties(Constructor, staticProps);
      return Constructor;
    }
    var _LinePrependor;
    module2.exports = _LinePrependor = /* @__PURE__ */ function() {
      function _LinePrependor2(_config) {
        _classCallCheck(this, _LinePrependor2);
        this._config = _config;
        this._lineNo = -1;
      }
      _createClass(_LinePrependor2, [{
        key: "render",
        value: function render2(inherited, options) {
          this._lineNo++;
          return "<none>" + this._render(inherited, options) + "</none>";
        }
      }]);
      return _LinePrependor2;
    }();
  }
});

// node_modules/renderkid/lib/layout/block/linePrependor/Default.js
var require_Default3 = __commonJS({
  "node_modules/renderkid/lib/layout/block/linePrependor/Default.js"(exports2, module2) {
    "use strict";
    function _typeof(obj) {
      "@babel/helpers - typeof";
      if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
        _typeof = function _typeof2(obj2) {
          return typeof obj2;
        };
      } else {
        _typeof = function _typeof2(obj2) {
          return obj2 && typeof Symbol === "function" && obj2.constructor === Symbol && obj2 !== Symbol.prototype ? "symbol" : typeof obj2;
        };
      }
      return _typeof(obj);
    }
    function _classCallCheck(instance, Constructor) {
      if (!(instance instanceof Constructor)) {
        throw new TypeError("Cannot call a class as a function");
      }
    }
    function _defineProperties(target, props) {
      for (var i3 = 0; i3 < props.length; i3++) {
        var descriptor = props[i3];
        descriptor.enumerable = descriptor.enumerable || false;
        descriptor.configurable = true;
        if ("value" in descriptor)
          descriptor.writable = true;
        Object.defineProperty(target, descriptor.key, descriptor);
      }
    }
    function _createClass(Constructor, protoProps, staticProps) {
      if (protoProps)
        _defineProperties(Constructor.prototype, protoProps);
      if (staticProps)
        _defineProperties(Constructor, staticProps);
      return Constructor;
    }
    function _inherits(subClass, superClass) {
      if (typeof superClass !== "function" && superClass !== null) {
        throw new TypeError("Super expression must either be null or a function");
      }
      subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } });
      if (superClass)
        _setPrototypeOf(subClass, superClass);
    }
    function _setPrototypeOf(o2, p) {
      _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf2(o3, p2) {
        o3.__proto__ = p2;
        return o3;
      };
      return _setPrototypeOf(o2, p);
    }
    function _createSuper(Derived) {
      var hasNativeReflectConstruct = _isNativeReflectConstruct();
      return function _createSuperInternal() {
        var Super = _getPrototypeOf(Derived), result2;
        if (hasNativeReflectConstruct) {
          var NewTarget = _getPrototypeOf(this).constructor;
          result2 = Reflect.construct(Super, arguments, NewTarget);
        } else {
          result2 = Super.apply(this, arguments);
        }
        return _possibleConstructorReturn(this, result2);
      };
    }
    function _possibleConstructorReturn(self2, call) {
      if (call && (_typeof(call) === "object" || typeof call === "function")) {
        return call;
      }
      return _assertThisInitialized(self2);
    }
    function _assertThisInitialized(self2) {
      if (self2 === void 0) {
        throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
      }
      return self2;
    }
    function _isNativeReflectConstruct() {
      if (typeof Reflect === "undefined" || !Reflect.construct)
        return false;
      if (Reflect.construct.sham)
        return false;
      if (typeof Proxy === "function")
        return true;
      try {
        Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
        }));
        return true;
      } catch (e2) {
        return false;
      }
    }
    function _getPrototypeOf(o2) {
      _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf2(o3) {
        return o3.__proto__ || Object.getPrototypeOf(o3);
      };
      return _getPrototypeOf(o2);
    }
    var DefaultLinePrependor;
    var SpecialString;
    var tools;
    tools = require_tools();
    SpecialString = require_SpecialString();
    module2.exports = DefaultLinePrependor = function() {
      var self2;
      var DefaultLinePrependor2 = /* @__PURE__ */ function(_require) {
        _inherits(DefaultLinePrependor3, _require);
        var _super = _createSuper(DefaultLinePrependor3);
        function DefaultLinePrependor3() {
          _classCallCheck(this, DefaultLinePrependor3);
          return _super.apply(this, arguments);
        }
        _createClass(DefaultLinePrependor3, [{
          key: "_render",
          value: function _render(inherited, options) {
            var addToLeft, addToRight, alignment, bullet, char, charLen, diff2, left, output, space, toWrite;
            if (this._lineNo === 0 && (bullet = this._config.bullet)) {
              char = bullet.char;
              charLen = new SpecialString(char).length;
              alignment = bullet.alignment;
              space = this._config.amount;
              toWrite = char;
              addToLeft = "";
              addToRight = "";
              if (space > charLen) {
                diff2 = space - charLen;
                if (alignment === "right") {
                  addToLeft = self2.pad(diff2);
                } else if (alignment === "left") {
                  addToRight = self2.pad(diff2);
                } else if (alignment === "center") {
                  left = Math.round(diff2 / 2);
                  addToLeft = self2.pad(left);
                  addToRight = self2.pad(diff2 - left);
                } else {
                  throw Error("Unknown alignment `".concat(alignment, "`"));
                }
              }
              output = addToLeft + char + addToRight;
            } else {
              output = self2.pad(this._config.amount);
            }
            return inherited + output;
          }
        }], [{
          key: "pad",
          value: function pad(howMuch) {
            return tools.repeatString(" ", howMuch);
          }
        }]);
        return DefaultLinePrependor3;
      }(require_LinePrependor());
      ;
      self2 = DefaultLinePrependor2;
      return DefaultLinePrependor2;
    }.call(void 0);
  }
});

// node_modules/renderkid/lib/layout/block/lineAppendor/_LineAppendor.js
var require_LineAppendor = __commonJS({
  "node_modules/renderkid/lib/layout/block/lineAppendor/_LineAppendor.js"(exports2, module2) {
    "use strict";
    function _classCallCheck(instance, Constructor) {
      if (!(instance instanceof Constructor)) {
        throw new TypeError("Cannot call a class as a function");
      }
    }
    function _defineProperties(target, props) {
      for (var i3 = 0; i3 < props.length; i3++) {
        var descriptor = props[i3];
        descriptor.enumerable = descriptor.enumerable || false;
        descriptor.configurable = true;
        if ("value" in descriptor)
          descriptor.writable = true;
        Object.defineProperty(target, descriptor.key, descriptor);
      }
    }
    function _createClass(Constructor, protoProps, staticProps) {
      if (protoProps)
        _defineProperties(Constructor.prototype, protoProps);
      if (staticProps)
        _defineProperties(Constructor, staticProps);
      return Constructor;
    }
    var _LineAppendor;
    module2.exports = _LineAppendor = /* @__PURE__ */ function() {
      function _LineAppendor2(_config) {
        _classCallCheck(this, _LineAppendor2);
        this._config = _config;
        this._lineNo = 0;
      }
      _createClass(_LineAppendor2, [{
        key: "render",
        value: function render2(inherited, options) {
          this._lineNo++;
          return "<none>" + this._render(inherited, options) + "</none>";
        }
      }]);
      return _LineAppendor2;
    }();
  }
});

// node_modules/renderkid/lib/layout/block/lineAppendor/Default.js
var require_Default4 = __commonJS({
  "node_modules/renderkid/lib/layout/block/lineAppendor/Default.js"(exports2, module2) {
    "use strict";
    function _typeof(obj) {
      "@babel/helpers - typeof";
      if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
        _typeof = function _typeof2(obj2) {
          return typeof obj2;
        };
      } else {
        _typeof = function _typeof2(obj2) {
          return obj2 && typeof Symbol === "function" && obj2.constructor === Symbol && obj2 !== Symbol.prototype ? "symbol" : typeof obj2;
        };
      }
      return _typeof(obj);
    }
    function _classCallCheck(instance, Constructor) {
      if (!(instance instanceof Constructor)) {
        throw new TypeError("Cannot call a class as a function");
      }
    }
    function _defineProperties(target, props) {
      for (var i3 = 0; i3 < props.length; i3++) {
        var descriptor = props[i3];
        descriptor.enumerable = descriptor.enumerable || false;
        descriptor.configurable = true;
        if ("value" in descriptor)
          descriptor.writable = true;
        Object.defineProperty(target, descriptor.key, descriptor);
      }
    }
    function _createClass(Constructor, protoProps, staticProps) {
      if (protoProps)
        _defineProperties(Constructor.prototype, protoProps);
      if (staticProps)
        _defineProperties(Constructor, staticProps);
      return Constructor;
    }
    function _inherits(subClass, superClass) {
      if (typeof superClass !== "function" && superClass !== null) {
        throw new TypeError("Super expression must either be null or a function");
      }
      subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } });
      if (superClass)
        _setPrototypeOf(subClass, superClass);
    }
    function _setPrototypeOf(o2, p) {
      _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf2(o3, p2) {
        o3.__proto__ = p2;
        return o3;
      };
      return _setPrototypeOf(o2, p);
    }
    function _createSuper(Derived) {
      var hasNativeReflectConstruct = _isNativeReflectConstruct();
      return function _createSuperInternal() {
        var Super = _getPrototypeOf(Derived), result2;
        if (hasNativeReflectConstruct) {
          var NewTarget = _getPrototypeOf(this).constructor;
          result2 = Reflect.construct(Super, arguments, NewTarget);
        } else {
          result2 = Super.apply(this, arguments);
        }
        return _possibleConstructorReturn(this, result2);
      };
    }
    function _possibleConstructorReturn(self2, call) {
      if (call && (_typeof(call) === "object" || typeof call === "function")) {
        return call;
      }
      return _assertThisInitialized(self2);
    }
    function _assertThisInitialized(self2) {
      if (self2 === void 0) {
        throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
      }
      return self2;
    }
    function _isNativeReflectConstruct() {
      if (typeof Reflect === "undefined" || !Reflect.construct)
        return false;
      if (Reflect.construct.sham)
        return false;
      if (typeof Proxy === "function")
        return true;
      try {
        Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
        }));
        return true;
      } catch (e2) {
        return false;
      }
    }
    function _getPrototypeOf(o2) {
      _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf2(o3) {
        return o3.__proto__ || Object.getPrototypeOf(o3);
      };
      return _getPrototypeOf(o2);
    }
    var DefaultLineAppendor;
    var tools;
    tools = require_tools();
    module2.exports = DefaultLineAppendor = /* @__PURE__ */ function(_require) {
      _inherits(DefaultLineAppendor2, _require);
      var _super = _createSuper(DefaultLineAppendor2);
      function DefaultLineAppendor2() {
        _classCallCheck(this, DefaultLineAppendor2);
        return _super.apply(this, arguments);
      }
      _createClass(DefaultLineAppendor2, [{
        key: "_render",
        value: function _render(inherited, options) {
          return inherited + tools.repeatString(" ", this._config.amount);
        }
      }]);
      return DefaultLineAppendor2;
    }(require_LineAppendor());
  }
});

// node_modules/renderkid/lib/layout/block/lineWrapper/_LineWrapper.js
var require_LineWrapper = __commonJS({
  "node_modules/renderkid/lib/layout/block/lineWrapper/_LineWrapper.js"(exports2, module2) {
    "use strict";
    function _classCallCheck(instance, Constructor) {
      if (!(instance instanceof Constructor)) {
        throw new TypeError("Cannot call a class as a function");
      }
    }
    function _defineProperties(target, props) {
      for (var i3 = 0; i3 < props.length; i3++) {
        var descriptor = props[i3];
        descriptor.enumerable = descriptor.enumerable || false;
        descriptor.configurable = true;
        if ("value" in descriptor)
          descriptor.writable = true;
        Object.defineProperty(target, descriptor.key, descriptor);
      }
    }
    function _createClass(Constructor, protoProps, staticProps) {
      if (protoProps)
        _defineProperties(Constructor.prototype, protoProps);
      if (staticProps)
        _defineProperties(Constructor, staticProps);
      return Constructor;
    }
    var _LineWrapper;
    module2.exports = _LineWrapper = /* @__PURE__ */ function() {
      function _LineWrapper2() {
        _classCallCheck(this, _LineWrapper2);
      }
      _createClass(_LineWrapper2, [{
        key: "render",
        value: function render2(str2, options) {
          return this._render(str2, options);
        }
      }]);
      return _LineWrapper2;
    }();
  }
});

// node_modules/renderkid/lib/layout/block/lineWrapper/Default.js
var require_Default5 = __commonJS({
  "node_modules/renderkid/lib/layout/block/lineWrapper/Default.js"(exports2, module2) {
    "use strict";
    function _typeof(obj) {
      "@babel/helpers - typeof";
      if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
        _typeof = function _typeof2(obj2) {
          return typeof obj2;
        };
      } else {
        _typeof = function _typeof2(obj2) {
          return obj2 && typeof Symbol === "function" && obj2.constructor === Symbol && obj2 !== Symbol.prototype ? "symbol" : typeof obj2;
        };
      }
      return _typeof(obj);
    }
    function _classCallCheck(instance, Constructor) {
      if (!(instance instanceof Constructor)) {
        throw new TypeError("Cannot call a class as a function");
      }
    }
    function _defineProperties(target, props) {
      for (var i3 = 0; i3 < props.length; i3++) {
        var descriptor = props[i3];
        descriptor.enumerable = descriptor.enumerable || false;
        descriptor.configurable = true;
        if ("value" in descriptor)
          descriptor.writable = true;
        Object.defineProperty(target, descriptor.key, descriptor);
      }
    }
    function _createClass(Constructor, protoProps, staticProps) {
      if (protoProps)
        _defineProperties(Constructor.prototype, protoProps);
      if (staticProps)
        _defineProperties(Constructor, staticProps);
      return Constructor;
    }
    function _inherits(subClass, superClass) {
      if (typeof superClass !== "function" && superClass !== null) {
        throw new TypeError("Super expression must either be null or a function");
      }
      subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } });
      if (superClass)
        _setPrototypeOf(subClass, superClass);
    }
    function _setPrototypeOf(o2, p) {
      _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf2(o3, p2) {
        o3.__proto__ = p2;
        return o3;
      };
      return _setPrototypeOf(o2, p);
    }
    function _createSuper(Derived) {
      var hasNativeReflectConstruct = _isNativeReflectConstruct();
      return function _createSuperInternal() {
        var Super = _getPrototypeOf(Derived), result2;
        if (hasNativeReflectConstruct) {
          var NewTarget = _getPrototypeOf(this).constructor;
          result2 = Reflect.construct(Super, arguments, NewTarget);
        } else {
          result2 = Super.apply(this, arguments);
        }
        return _possibleConstructorReturn(this, result2);
      };
    }
    function _possibleConstructorReturn(self2, call) {
      if (call && (_typeof(call) === "object" || typeof call === "function")) {
        return call;
      }
      return _assertThisInitialized(self2);
    }
    function _assertThisInitialized(self2) {
      if (self2 === void 0) {
        throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
      }
      return self2;
    }
    function _isNativeReflectConstruct() {
      if (typeof Reflect === "undefined" || !Reflect.construct)
        return false;
      if (Reflect.construct.sham)
        return false;
      if (typeof Proxy === "function")
        return true;
      try {
        Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
        }));
        return true;
      } catch (e2) {
        return false;
      }
    }
    function _getPrototypeOf(o2) {
      _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf2(o3) {
        return o3.__proto__ || Object.getPrototypeOf(o3);
      };
      return _getPrototypeOf(o2);
    }
    var DefaultLineWrapper;
    module2.exports = DefaultLineWrapper = /* @__PURE__ */ function(_require) {
      _inherits(DefaultLineWrapper2, _require);
      var _super = _createSuper(DefaultLineWrapper2);
      function DefaultLineWrapper2() {
        _classCallCheck(this, DefaultLineWrapper2);
        return _super.apply(this, arguments);
      }
      _createClass(DefaultLineWrapper2, [{
        key: "_render",
        value: function _render() {
        }
      }]);
      return DefaultLineWrapper2;
    }(require_LineWrapper());
  }
});

// node_modules/renderkid/lib/layout/Block.js
var require_Block = __commonJS({
  "node_modules/renderkid/lib/layout/Block.js"(exports2, module2) {
    "use strict";
    function _classCallCheck(instance, Constructor) {
      if (!(instance instanceof Constructor)) {
        throw new TypeError("Cannot call a class as a function");
      }
    }
    function _defineProperties(target, props) {
      for (var i3 = 0; i3 < props.length; i3++) {
        var descriptor = props[i3];
        descriptor.enumerable = descriptor.enumerable || false;
        descriptor.configurable = true;
        if ("value" in descriptor)
          descriptor.writable = true;
        Object.defineProperty(target, descriptor.key, descriptor);
      }
    }
    function _createClass(Constructor, protoProps, staticProps) {
      if (protoProps)
        _defineProperties(Constructor.prototype, protoProps);
      if (staticProps)
        _defineProperties(Constructor, staticProps);
      return Constructor;
    }
    var Block;
    var SpecialString;
    var cloneAndMergeDeep;
    var terminalWidth;
    SpecialString = require_SpecialString();
    terminalWidth = require_tools().getCols();
    var _require = require_tools();
    cloneAndMergeDeep = _require.cloneAndMergeDeep;
    module2.exports = Block = function() {
      var self2;
      var Block2 = /* @__PURE__ */ function() {
        function Block3(_layout, _parent) {
          var config = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : {};
          var _name = arguments.length > 3 && arguments[3] !== void 0 ? arguments[3] : "";
          _classCallCheck(this, Block3);
          this._layout = _layout;
          this._parent = _parent;
          this._name = _name;
          this._config = cloneAndMergeDeep(self2.defaultConfig, config);
          this._closed = false;
          this._wasOpenOnce = false;
          this._active = false;
          this._buffer = "";
          this._didSeparateBlock = false;
          this._linePrependor = new this._config.linePrependor.fn(this._config.linePrependor.options);
          this._lineAppendor = new this._config.lineAppendor.fn(this._config.lineAppendor.options);
          this._blockPrependor = new this._config.blockPrependor.fn(this._config.blockPrependor.options);
          this._blockAppendor = new this._config.blockAppendor.fn(this._config.blockAppendor.options);
        }
        _createClass(Block3, [{
          key: "_activate",
          value: function _activate() {
            var deactivateParent = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : true;
            if (this._active) {
              throw Error("This block is already active. This is probably a bug in RenderKid itself");
            }
            if (this._closed) {
              throw Error("This block is closed and cannot be activated. This is probably a bug in RenderKid itself");
            }
            this._active = true;
            this._layout._activeBlock = this;
            if (deactivateParent) {
              if (this._parent != null) {
                this._parent._deactivate(false);
              }
            }
            return this;
          }
        }, {
          key: "_deactivate",
          value: function _deactivate() {
            var activateParent = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : true;
            this._ensureActive();
            this._flushBuffer();
            if (activateParent) {
              if (this._parent != null) {
                this._parent._activate(false);
              }
            }
            this._active = false;
            return this;
          }
        }, {
          key: "_ensureActive",
          value: function _ensureActive() {
            if (!this._wasOpenOnce) {
              throw Error("This block has never been open before. This is probably a bug in RenderKid itself.");
            }
            if (!this._active) {
              throw Error("This block is not active. This is probably a bug in RenderKid itself.");
            }
            if (this._closed) {
              throw Error("This block is already closed. This is probably a bug in RenderKid itself.");
            }
          }
        }, {
          key: "_open",
          value: function _open() {
            if (this._wasOpenOnce) {
              throw Error("Block._open() has been called twice. This is probably a RenderKid bug.");
            }
            this._wasOpenOnce = true;
            if (this._parent != null) {
              this._parent.write(this._whatToPrependToBlock());
            }
            this._activate();
            return this;
          }
        }, {
          key: "close",
          value: function close() {
            this._deactivate();
            this._closed = true;
            if (this._parent != null) {
              this._parent.write(this._whatToAppendToBlock());
            }
            return this;
          }
        }, {
          key: "isOpen",
          value: function isOpen() {
            return this._wasOpenOnce && !this._closed;
          }
        }, {
          key: "write",
          value: function write(str2) {
            this._ensureActive();
            if (str2 === "") {
              return;
            }
            str2 = String(str2);
            this._buffer += str2;
            return this;
          }
        }, {
          key: "openBlock",
          value: function openBlock(config, name) {
            var block;
            this._ensureActive();
            block = new Block3(this._layout, this, config, name);
            block._open();
            return block;
          }
        }, {
          key: "_flushBuffer",
          value: function _flushBuffer() {
            var str2;
            if (this._buffer === "") {
              return;
            }
            str2 = this._buffer;
            this._buffer = "";
            this._writeInline(str2);
          }
        }, {
          key: "_toPrependToLine",
          value: function _toPrependToLine() {
            var fromParent;
            fromParent = "";
            if (this._parent != null) {
              fromParent = this._parent._toPrependToLine();
            }
            return this._linePrependor.render(fromParent);
          }
        }, {
          key: "_toAppendToLine",
          value: function _toAppendToLine() {
            var fromParent;
            fromParent = "";
            if (this._parent != null) {
              fromParent = this._parent._toAppendToLine();
            }
            return this._lineAppendor.render(fromParent);
          }
        }, {
          key: "_whatToPrependToBlock",
          value: function _whatToPrependToBlock() {
            return this._blockPrependor.render();
          }
        }, {
          key: "_whatToAppendToBlock",
          value: function _whatToAppendToBlock() {
            return this._blockAppendor.render();
          }
        }, {
          key: "_writeInline",
          value: function _writeInline(str2) {
            var i3, j, k, l2, lineBreaksToAppend, m, ref2, ref1, ref22, remaining;
            if (new SpecialString(str2).isOnlySpecialChars()) {
              this._layout._append(str2);
              return;
            }
            remaining = str2;
            lineBreaksToAppend = 0;
            if (m = remaining.match(/^\n+/)) {
              for (i3 = j = 1, ref2 = m[0].length; 1 <= ref2 ? j <= ref2 : j >= ref2; i3 = 1 <= ref2 ? ++j : --j) {
                this._writeLine("");
              }
              remaining = remaining.substr(m[0].length, remaining.length);
            }
            if (m = remaining.match(/\n+$/)) {
              lineBreaksToAppend = m[0].length;
              remaining = remaining.substr(0, remaining.length - m[0].length);
            }
            while (remaining.length > 0) {
              if (m = remaining.match(/^[^\n]+/)) {
                this._writeLine(m[0]);
                remaining = remaining.substr(m[0].length, remaining.length);
              } else if (m = remaining.match(/^\n+/)) {
                for (i3 = k = 1, ref1 = m[0].length; 1 <= ref1 ? k < ref1 : k > ref1; i3 = 1 <= ref1 ? ++k : --k) {
                  this._writeLine("");
                }
                remaining = remaining.substr(m[0].length, remaining.length);
              }
            }
            if (lineBreaksToAppend > 0) {
              for (i3 = l2 = 1, ref22 = lineBreaksToAppend; 1 <= ref22 ? l2 <= ref22 : l2 >= ref22; i3 = 1 <= ref22 ? ++l2 : --l2) {
                this._writeLine("");
              }
            }
          }
        }, {
          key: "_writeLine",
          value: function _writeLine(str2) {
            var line, lineContent, lineContentLength, remaining, roomLeft, toAppend, toAppendLength, toPrepend, toPrependLength;
            remaining = new SpecialString(str2);
            while (true) {
              toPrepend = this._toPrependToLine();
              toPrependLength = new SpecialString(toPrepend).length;
              toAppend = this._toAppendToLine();
              toAppendLength = new SpecialString(toAppend).length;
              roomLeft = this._layout._config.terminalWidth - (toPrependLength + toAppendLength);
              lineContentLength = Math.min(this._config.width, roomLeft);
              lineContent = remaining.cut(0, lineContentLength, true);
              line = toPrepend + lineContent.str + toAppend;
              this._layout._appendLine(line);
              if (remaining.isEmpty()) {
                break;
              }
            }
          }
        }]);
        return Block3;
      }();
      ;
      self2 = Block2;
      Block2.defaultConfig = {
        blockPrependor: {
          fn: require_Default(),
          options: {
            amount: 0
          }
        },
        blockAppendor: {
          fn: require_Default2(),
          options: {
            amount: 0
          }
        },
        linePrependor: {
          fn: require_Default3(),
          options: {
            amount: 0
          }
        },
        lineAppendor: {
          fn: require_Default4(),
          options: {
            amount: 0
          }
        },
        lineWrapper: {
          fn: require_Default5(),
          options: {
            lineWidth: null
          }
        },
        width: terminalWidth,
        prefixRaw: "",
        suffixRaw: ""
      };
      return Block2;
    }.call(void 0);
  }
});

// node_modules/renderkid/lib/Layout.js
var require_Layout = __commonJS({
  "node_modules/renderkid/lib/Layout.js"(exports2, module2) {
    "use strict";
    function _classCallCheck(instance, Constructor) {
      if (!(instance instanceof Constructor)) {
        throw new TypeError("Cannot call a class as a function");
      }
    }
    function _defineProperties(target, props) {
      for (var i4 = 0; i4 < props.length; i4++) {
        var descriptor = props[i4];
        descriptor.enumerable = descriptor.enumerable || false;
        descriptor.configurable = true;
        if ("value" in descriptor)
          descriptor.writable = true;
        Object.defineProperty(target, descriptor.key, descriptor);
      }
    }
    function _createClass(Constructor, protoProps, staticProps) {
      if (protoProps)
        _defineProperties(Constructor.prototype, protoProps);
      if (staticProps)
        _defineProperties(Constructor, staticProps);
      return Constructor;
    }
    var Block;
    var Layout;
    var SpecialString;
    var cloneAndMergeDeep;
    var i3;
    var len;
    var prop;
    var ref2;
    var terminalWidth;
    Block = require_Block();
    var _require = require_tools();
    cloneAndMergeDeep = _require.cloneAndMergeDeep;
    SpecialString = require_SpecialString();
    terminalWidth = require_tools().getCols();
    module2.exports = Layout = function() {
      var self2;
      var Layout2 = /* @__PURE__ */ function() {
        function Layout3() {
          var config = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {};
          var rootBlockConfig = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {};
          _classCallCheck(this, Layout3);
          var rootConfig;
          this._written = [];
          this._activeBlock = null;
          this._config = cloneAndMergeDeep(self2._defaultConfig, config);
          rootConfig = cloneAndMergeDeep(self2._rootBlockDefaultConfig, rootBlockConfig);
          this._root = new Block(this, null, rootConfig, "__root");
          this._root._open();
        }
        _createClass(Layout3, [{
          key: "getRootBlock",
          value: function getRootBlock() {
            return this._root;
          }
        }, {
          key: "_append",
          value: function _append(text) {
            return this._written.push(text);
          }
        }, {
          key: "_appendLine",
          value: function _appendLine(text) {
            var s2;
            this._append(text);
            s2 = new SpecialString(text);
            if (s2.length < this._config.terminalWidth) {
              this._append("<none>\n</none>");
            }
            return this;
          }
        }, {
          key: "get",
          value: function get() {
            this._ensureClosed();
            if (this._written[this._written.length - 1] === "<none>\n</none>") {
              this._written.pop();
            }
            return this._written.join("");
          }
        }, {
          key: "_ensureClosed",
          value: function _ensureClosed() {
            if (this._activeBlock !== this._root) {
              throw Error("Not all the blocks have been closed. Please call block.close() on all open blocks.");
            }
            if (this._root.isOpen()) {
              this._root.close();
            }
          }
        }]);
        return Layout3;
      }();
      ;
      self2 = Layout2;
      Layout2._rootBlockDefaultConfig = {
        linePrependor: {
          options: {
            amount: 0
          }
        },
        lineAppendor: {
          options: {
            amount: 0
          }
        },
        blockPrependor: {
          options: {
            amount: 0
          }
        },
        blockAppendor: {
          options: {
            amount: 0
          }
        }
      };
      Layout2._defaultConfig = {
        terminalWidth
      };
      return Layout2;
    }.call(void 0);
    ref2 = ["openBlock", "write"];
    for (i3 = 0, len = ref2.length; i3 < len; i3++) {
      prop = ref2[i3];
      (function() {
        var method;
        method = prop;
        return Layout.prototype[method] = function() {
          return this._root[method].apply(this._root, arguments);
        };
      })();
    }
  }
});

// node_modules/renderkid/node_modules/ansi-regex/index.js
var require_ansi_regex2 = __commonJS({
  "node_modules/renderkid/node_modules/ansi-regex/index.js"(exports2, module2) {
    "use strict";
    module2.exports = function() {
      return /[\u001b\u009b][[()#;?]*(?:[0-9]{1,4}(?:;[0-9]{0,4})*)?[0-9A-PRZcf-nqry=><]/g;
    };
  }
});

// node_modules/renderkid/node_modules/strip-ansi/index.js
var require_strip_ansi2 = __commonJS({
  "node_modules/renderkid/node_modules/strip-ansi/index.js"(exports2, module2) {
    "use strict";
    var ansiRegex = require_ansi_regex2()();
    module2.exports = function(str2) {
      return typeof str2 === "string" ? str2.replace(ansiRegex, "") : str2;
    };
  }
});

// node_modules/renderkid/lib/RenderKid.js
var require_RenderKid = __commonJS({
  "node_modules/renderkid/lib/RenderKid.js"(exports2, module2) {
    "use strict";
    function _classCallCheck(instance, Constructor) {
      if (!(instance instanceof Constructor)) {
        throw new TypeError("Cannot call a class as a function");
      }
    }
    function _defineProperties(target, props) {
      for (var i3 = 0; i3 < props.length; i3++) {
        var descriptor = props[i3];
        descriptor.enumerable = descriptor.enumerable || false;
        descriptor.configurable = true;
        if ("value" in descriptor)
          descriptor.writable = true;
        Object.defineProperty(target, descriptor.key, descriptor);
      }
    }
    function _createClass(Constructor, protoProps, staticProps) {
      if (protoProps)
        _defineProperties(Constructor.prototype, protoProps);
      if (staticProps)
        _defineProperties(Constructor, staticProps);
      return Constructor;
    }
    var AnsiPainter;
    var Layout;
    var RenderKid;
    var Styles;
    var blockStyleApplier;
    var cloneAndMergeDeep;
    var inlineStyleApplier;
    var isPlainObject;
    var stripAnsi;
    var terminalWidth;
    var tools;
    inlineStyleApplier = require_inline();
    blockStyleApplier = require_block();
    isPlainObject = require_isPlainObject();
    var _require = require_tools();
    cloneAndMergeDeep = _require.cloneAndMergeDeep;
    AnsiPainter = require_AnsiPainter();
    Styles = require_Styles();
    Layout = require_Layout();
    tools = require_tools();
    stripAnsi = require_strip_ansi2();
    terminalWidth = require_tools().getCols();
    module2.exports = RenderKid = function() {
      var self2;
      var RenderKid2 = /* @__PURE__ */ function() {
        function RenderKid3() {
          var config = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {};
          _classCallCheck(this, RenderKid3);
          this.tools = self2.tools;
          this._config = cloneAndMergeDeep(self2._defaultConfig, config);
          this._initStyles();
        }
        _createClass(RenderKid3, [{
          key: "_initStyles",
          value: function _initStyles() {
            return this._styles = new Styles();
          }
        }, {
          key: "style",
          value: function style() {
            return this._styles.setRule.apply(this._styles, arguments);
          }
        }, {
          key: "_getStyleFor",
          value: function _getStyleFor(el) {
            return this._styles.getStyleFor(el);
          }
        }, {
          key: "render",
          value: function render2(input) {
            var withColors = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : true;
            return this._paint(this._renderDom(this._toDom(input)), withColors);
          }
        }, {
          key: "_toDom",
          value: function _toDom(input) {
            if (typeof input === "string") {
              return this._parse(input);
            } else if (isPlainObject(input) || Array.isArray(input)) {
              return this._objToDom(input);
            } else {
              throw Error("Invalid input type. Only strings, arrays and objects are accepted");
            }
          }
        }, {
          key: "_objToDom",
          value: function _objToDom(o2) {
            var injectFakeRoot = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : true;
            if (injectFakeRoot) {
              o2 = {
                body: o2
              };
            }
            return tools.objectToDom(o2);
          }
        }, {
          key: "_paint",
          value: function _paint(text, withColors) {
            var painted;
            painted = AnsiPainter.paint(text);
            if (withColors) {
              return painted;
            } else {
              return stripAnsi(painted);
            }
          }
        }, {
          key: "_parse",
          value: function _parse(string) {
            var injectFakeRoot = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : true;
            if (injectFakeRoot) {
              string = "<body>" + string + "</body>";
            }
            return tools.stringToDom(string);
          }
        }, {
          key: "_renderDom",
          value: function _renderDom(dom) {
            var bodyTag, layout, rootBlock;
            bodyTag = dom[0];
            layout = new Layout(this._config.layout);
            rootBlock = layout.getRootBlock();
            this._renderBlockNode(bodyTag, null, rootBlock);
            return layout.get();
          }
        }, {
          key: "_renderChildrenOf",
          value: function _renderChildrenOf(parentNode, parentBlock) {
            var i3, len, node, nodes;
            nodes = parentNode.children;
            for (i3 = 0, len = nodes.length; i3 < len; i3++) {
              node = nodes[i3];
              this._renderNode(node, parentNode, parentBlock);
            }
          }
        }, {
          key: "_renderNode",
          value: function _renderNode(node, parentNode, parentBlock) {
            if (node.type === "text") {
              this._renderText(node, parentNode, parentBlock);
            } else if (node.name === "br") {
              this._renderBr(node, parentNode, parentBlock);
            } else if (this._isBlock(node)) {
              this._renderBlockNode(node, parentNode, parentBlock);
            } else if (this._isNone(node)) {
              return;
            } else {
              this._renderInlineNode(node, parentNode, parentBlock);
            }
          }
        }, {
          key: "_renderText",
          value: function _renderText(node, parentNode, parentBlock) {
            var ref2, text;
            text = node.data;
            text = text.replace(/\s+/g, " ");
            if ((parentNode != null ? (ref2 = parentNode.styles) != null ? ref2.display : void 0 : void 0) !== "inline") {
              text = text.trim();
            }
            if (text.length === 0) {
              return;
            }
            text = text.replace(/&nl;/g, "\n");
            return parentBlock.write(text);
          }
        }, {
          key: "_renderBlockNode",
          value: function _renderBlockNode(node, parentNode, parentBlock) {
            var after, before, block, blockConfig;
            var _blockStyleApplier$ap = blockStyleApplier.applyTo(node, this._getStyleFor(node));
            before = _blockStyleApplier$ap.before;
            after = _blockStyleApplier$ap.after;
            blockConfig = _blockStyleApplier$ap.blockConfig;
            block = parentBlock.openBlock(blockConfig);
            if (before !== "") {
              block.write(before);
            }
            this._renderChildrenOf(node, block);
            if (after !== "") {
              block.write(after);
            }
            return block.close();
          }
        }, {
          key: "_renderInlineNode",
          value: function _renderInlineNode(node, parentNode, parentBlock) {
            var after, before;
            var _inlineStyleApplier$a = inlineStyleApplier.applyTo(node, this._getStyleFor(node));
            before = _inlineStyleApplier$a.before;
            after = _inlineStyleApplier$a.after;
            if (before !== "") {
              parentBlock.write(before);
            }
            this._renderChildrenOf(node, parentBlock);
            if (after !== "") {
              return parentBlock.write(after);
            }
          }
        }, {
          key: "_renderBr",
          value: function _renderBr(node, parentNode, parentBlock) {
            return parentBlock.write("\n");
          }
        }, {
          key: "_isBlock",
          value: function _isBlock(node) {
            return !(node.type === "text" || node.name === "br" || this._getStyleFor(node).display !== "block");
          }
        }, {
          key: "_isNone",
          value: function _isNone(node) {
            return !(node.type === "text" || node.name === "br" || this._getStyleFor(node).display !== "none");
          }
        }]);
        return RenderKid3;
      }();
      ;
      self2 = RenderKid2;
      RenderKid2.AnsiPainter = AnsiPainter;
      RenderKid2.Layout = Layout;
      RenderKid2.quote = tools.quote;
      RenderKid2.tools = tools;
      RenderKid2._defaultConfig = {
        layout: {
          terminalWidth
        }
      };
      return RenderKid2;
    }.call(void 0);
  }
});

// node_modules/pretty-error/lib/PrettyError.js
var require_PrettyError = __commonJS({
  "node_modules/pretty-error/lib/PrettyError.js"(exports2, module2) {
    var ParsedError;
    var PrettyError;
    var RenderKid;
    var arrayUtils;
    var defaultStyle;
    var fn;
    var instance;
    var isPlainObject;
    var j;
    var len;
    var merge2;
    var nodePaths;
    var prop;
    var ref2;
    var slice = [].slice;
    var indexOf = [].indexOf || function(item) {
      for (var i3 = 0, l2 = this.length; i3 < l2; i3++) {
        if (i3 in this && this[i3] === item)
          return i3;
      }
      return -1;
    };
    isPlainObject = require_isPlainObject();
    defaultStyle = require_defaultStyle();
    ParsedError = require_ParsedError();
    nodePaths = require_nodePaths();
    RenderKid = require_RenderKid();
    merge2 = require_merge();
    arrayUtils = {
      pluckByCallback: function(a2, cb2) {
        var index, j2, len2, removed, value;
        if (a2.length < 1) {
          return a2;
        }
        removed = 0;
        for (index = j2 = 0, len2 = a2.length; j2 < len2; index = ++j2) {
          value = a2[index];
          if (cb2(value, index)) {
            removed++;
            continue;
          }
          if (removed !== 0) {
            a2[index - removed] = a2[index];
          }
        }
        if (removed > 0) {
          a2.length = a2.length - removed;
        }
        return a2;
      },
      pluckOneItem: function(a2, item) {
        var index, j2, len2, reached, value;
        if (a2.length < 1) {
          return a2;
        }
        reached = false;
        for (index = j2 = 0, len2 = a2.length; j2 < len2; index = ++j2) {
          value = a2[index];
          if (!reached) {
            if (value === item) {
              reached = true;
              continue;
            }
          } else {
            a2[index - 1] = a2[index];
          }
        }
        if (reached) {
          a2.length = a2.length - 1;
        }
        return a2;
      }
    };
    instance = null;
    module2.exports = PrettyError = function() {
      var self2;
      self2 = PrettyError2;
      PrettyError2._filters = {
        "module.exports": function(item) {
          if (item.what == null) {
            return;
          }
          item.what = item.what.replace(/\.module\.exports\./g, " - ");
        }
      };
      PrettyError2._getDefaultStyle = function() {
        return defaultStyle();
      };
      PrettyError2.start = function() {
        if (instance == null) {
          instance = new self2();
          instance.start();
        }
        return instance;
      };
      PrettyError2.stop = function() {
        return instance != null ? instance.stop() : void 0;
      };
      function PrettyError2() {
        this._useColors = true;
        this._maxItems = 50;
        this._packagesToSkip = [];
        this._pathsToSkip = [];
        this._skipCallbacks = [];
        this._filterCallbacks = [];
        this._parsedErrorFilters = [];
        this._aliases = [];
        this._renderer = new RenderKid();
        this._style = self2._getDefaultStyle();
        this._renderer.style(this._style);
      }
      PrettyError2.prototype.start = function() {
        var prepeare;
        this._oldPrepareStackTrace = Error.prepareStackTrace;
        prepeare = this._oldPrepareStackTrace || function(exc, frames) {
          var result2;
          result2 = exc.toString();
          frames = frames.map(function(frame) {
            return "  at " + frame.toString();
          });
          return result2 + "\n" + frames.join("\n");
        };
        Error.prepareStackTrace = function(_this) {
          return function(exc, trace) {
            var stack;
            stack = prepeare.apply(null, arguments);
            return _this.render({
              stack,
              message: exc.toString().replace(/^.*: /, "")
            }, false);
          };
        }(this);
        return this;
      };
      PrettyError2.prototype.stop = function() {
        Error.prepareStackTrace = this._oldPrepareStackTrace;
        return this._oldPrepareStackTrace = null;
      };
      PrettyError2.prototype.config = function(c2) {
        var alias, path2, ref3;
        if (c2.skipPackages != null) {
          if (c2.skipPackages === false) {
            this.unskipAllPackages();
          } else {
            this.skipPackage.apply(this, c2.skipPackages);
          }
        }
        if (c2.skipPaths != null) {
          if (c2.skipPaths === false) {
            this.unskipAllPaths();
          } else {
            this.skipPath.apply(this, c2.skipPaths);
          }
        }
        if (c2.skip != null) {
          if (c2.skip === false) {
            this.unskipAll();
          } else {
            this.skip.apply(this, c2.skip);
          }
        }
        if (c2.maxItems != null) {
          this.setMaxItems(c2.maxItems);
        }
        if (c2.skipNodeFiles === true) {
          this.skipNodeFiles();
        } else if (c2.skipNodeFiles === false) {
          this.unskipNodeFiles();
        }
        if (c2.filters != null) {
          if (c2.filters === false) {
            this.removeAllFilters();
          } else {
            this.filter.apply(this, c2.filters);
          }
        }
        if (c2.parsedErrorFilters != null) {
          if (c2.parsedErrorFilters === false) {
            this.removeAllParsedErrorFilters();
          } else {
            this.filterParsedError.apply(this, c2.parsedErrorFilters);
          }
        }
        if (c2.aliases != null) {
          if (isPlainObject(c2.aliases)) {
            ref3 = c2.aliases;
            for (path2 in ref3) {
              alias = ref3[path2];
              this.alias(path2, alias);
            }
          } else if (c2.aliases === false) {
            this.removeAllAliases();
          }
        }
        return this;
      };
      PrettyError2.prototype.withoutColors = function() {
        this._useColors = false;
        return this;
      };
      PrettyError2.prototype.withColors = function() {
        this._useColors = true;
        return this;
      };
      PrettyError2.prototype.skipPackage = function() {
        var j2, len2, packages, pkg;
        packages = 1 <= arguments.length ? slice.call(arguments, 0) : [];
        for (j2 = 0, len2 = packages.length; j2 < len2; j2++) {
          pkg = packages[j2];
          this._packagesToSkip.push(String(pkg));
        }
        return this;
      };
      PrettyError2.prototype.unskipPackage = function() {
        var j2, len2, packages, pkg;
        packages = 1 <= arguments.length ? slice.call(arguments, 0) : [];
        for (j2 = 0, len2 = packages.length; j2 < len2; j2++) {
          pkg = packages[j2];
          arrayUtils.pluckOneItem(this._packagesToSkip, pkg);
        }
        return this;
      };
      PrettyError2.prototype.unskipAllPackages = function() {
        this._packagesToSkip.length = 0;
        return this;
      };
      PrettyError2.prototype.skipPath = function() {
        var j2, len2, path2, paths;
        paths = 1 <= arguments.length ? slice.call(arguments, 0) : [];
        for (j2 = 0, len2 = paths.length; j2 < len2; j2++) {
          path2 = paths[j2];
          this._pathsToSkip.push(path2);
        }
        return this;
      };
      PrettyError2.prototype.unskipPath = function() {
        var j2, len2, path2, paths;
        paths = 1 <= arguments.length ? slice.call(arguments, 0) : [];
        for (j2 = 0, len2 = paths.length; j2 < len2; j2++) {
          path2 = paths[j2];
          arrayUtils.pluckOneItem(this._pathsToSkip, path2);
        }
        return this;
      };
      PrettyError2.prototype.unskipAllPaths = function() {
        this._pathsToSkip.length = 0;
        return this;
      };
      PrettyError2.prototype.skip = function() {
        var callbacks, cb2, j2, len2;
        callbacks = 1 <= arguments.length ? slice.call(arguments, 0) : [];
        for (j2 = 0, len2 = callbacks.length; j2 < len2; j2++) {
          cb2 = callbacks[j2];
          this._skipCallbacks.push(cb2);
        }
        return this;
      };
      PrettyError2.prototype.unskip = function() {
        var callbacks, cb2, j2, len2;
        callbacks = 1 <= arguments.length ? slice.call(arguments, 0) : [];
        for (j2 = 0, len2 = callbacks.length; j2 < len2; j2++) {
          cb2 = callbacks[j2];
          arrayUtils.pluckOneItem(this._skipCallbacks, cb2);
        }
        return this;
      };
      PrettyError2.prototype.unskipAll = function() {
        this._skipCallbacks.length = 0;
        return this;
      };
      PrettyError2.prototype.skipNodeFiles = function() {
        return this.skipPath.apply(this, nodePaths);
      };
      PrettyError2.prototype.unskipNodeFiles = function() {
        return this.unskipPath.apply(this, nodePaths);
      };
      PrettyError2.prototype.filter = function() {
        var callbacks, cb2, j2, len2;
        callbacks = 1 <= arguments.length ? slice.call(arguments, 0) : [];
        for (j2 = 0, len2 = callbacks.length; j2 < len2; j2++) {
          cb2 = callbacks[j2];
          this._filterCallbacks.push(cb2);
        }
        return this;
      };
      PrettyError2.prototype.removeFilter = function() {
        var callbacks, cb2, j2, len2;
        callbacks = 1 <= arguments.length ? slice.call(arguments, 0) : [];
        for (j2 = 0, len2 = callbacks.length; j2 < len2; j2++) {
          cb2 = callbacks[j2];
          arrayUtils.pluckOneItem(this._filterCallbacks, cb2);
        }
        return this;
      };
      PrettyError2.prototype.removeAllFilters = function() {
        this._filterCallbacks.length = 0;
        return this;
      };
      PrettyError2.prototype.filterParsedError = function() {
        var callbacks, cb2, j2, len2;
        callbacks = 1 <= arguments.length ? slice.call(arguments, 0) : [];
        for (j2 = 0, len2 = callbacks.length; j2 < len2; j2++) {
          cb2 = callbacks[j2];
          this._parsedErrorFilters.push(cb2);
        }
        return this;
      };
      PrettyError2.prototype.removeParsedErrorFilter = function() {
        var callbacks, cb2, j2, len2;
        callbacks = 1 <= arguments.length ? slice.call(arguments, 0) : [];
        for (j2 = 0, len2 = callbacks.length; j2 < len2; j2++) {
          cb2 = callbacks[j2];
          arrayUtils.pluckOneItem(this._parsedErrorFilters, cb2);
        }
        return this;
      };
      PrettyError2.prototype.removeAllParsedErrorFilters = function() {
        this._parsedErrorFilters.length = 0;
        return this;
      };
      PrettyError2.prototype.setMaxItems = function(maxItems) {
        if (maxItems == null) {
          maxItems = 50;
        }
        if (maxItems === 0) {
          maxItems = 50;
        }
        this._maxItems = maxItems | 0;
        return this;
      };
      PrettyError2.prototype.alias = function(stringOrRx, alias) {
        this._aliases.push({
          stringOrRx,
          alias
        });
        return this;
      };
      PrettyError2.prototype.removeAlias = function(stringOrRx) {
        arrayUtils.pluckByCallback(this._aliases, function(pair) {
          return pair.stringOrRx === stringOrRx;
        });
        return this;
      };
      PrettyError2.prototype.removeAllAliases = function() {
        this._aliases.length = 0;
        return this;
      };
      PrettyError2.prototype._getStyle = function() {
        return this._style;
      };
      PrettyError2.prototype.appendStyle = function(toAppend) {
        merge2(this._style, toAppend);
        this._renderer.style(toAppend);
        return this;
      };
      PrettyError2.prototype._getRenderer = function() {
        return this._renderer;
      };
      PrettyError2.prototype.render = function(e2, logIt, useColors) {
        var obj, rendered;
        if (logIt == null) {
          logIt = false;
        }
        if (useColors == null) {
          useColors = this._useColors;
        }
        obj = this.getObject(e2);
        rendered = this._renderer.render(obj, useColors);
        if (logIt === true) {
          console.error(rendered);
        }
        return rendered;
      };
      PrettyError2.prototype.getObject = function(e2) {
        var count, header, i3, item, j2, len2, obj, ref3, traceItems;
        if (!(e2 instanceof ParsedError)) {
          e2 = new ParsedError(e2);
        }
        this._applyParsedErrorFiltersOn(e2);
        header = {
          title: function() {
            var ret;
            ret = {};
            if (e2.wrapper !== "") {
              ret.wrapper = "" + e2.wrapper;
            }
            ret.kind = e2.kind;
            return ret;
          }(),
          colon: ":",
          message: String(e2.message).trim()
        };
        traceItems = [];
        count = -1;
        ref3 = e2.trace;
        for (i3 = j2 = 0, len2 = ref3.length; j2 < len2; i3 = ++j2) {
          item = ref3[i3];
          if (item == null) {
            continue;
          }
          if (this._skipOrFilter(item, i3) === true) {
            continue;
          }
          count++;
          if (count > this._maxItems) {
            break;
          }
          if (typeof item === "string") {
            traceItems.push({
              item: {
                custom: item
              }
            });
            continue;
          }
          traceItems.push(function() {
            var markupItem;
            markupItem = {
              item: {
                header: {
                  pointer: function() {
                    if (item.file == null) {
                      return "";
                    }
                    return {
                      file: item.file,
                      colon: ":",
                      line: item.line
                    };
                  }()
                },
                footer: function() {
                  var foooter;
                  foooter = {
                    addr: item.shortenedAddr
                  };
                  if (item.extra != null) {
                    foooter.extra = item.extra;
                  }
                  return foooter;
                }()
              }
            };
            if (typeof item.what === "string" && item.what.trim().length > 0) {
              markupItem.item.header.what = item.what;
            }
            return markupItem;
          }());
        }
        obj = {
          "pretty-error": {
            header
          }
        };
        if (traceItems.length > 0) {
          obj["pretty-error"].trace = traceItems;
        }
        return obj;
      };
      PrettyError2.prototype._skipOrFilter = function(item, itemNumber) {
        var cb2, j2, k, l2, len2, len1, len22, len3, m, modName, pair, ref3, ref1, ref22, ref32, ref4, ref5;
        if (typeof item === "object") {
          if (ref3 = item.modName, indexOf.call(this._packagesToSkip, ref3) >= 0) {
            return true;
          }
          if (ref1 = item.path, indexOf.call(this._pathsToSkip, ref1) >= 0) {
            return true;
          }
          ref22 = item.packages;
          for (j2 = 0, len2 = ref22.length; j2 < len2; j2++) {
            modName = ref22[j2];
            if (indexOf.call(this._packagesToSkip, modName) >= 0) {
              return true;
            }
          }
          if (typeof item.shortenedAddr === "string") {
            ref32 = this._aliases;
            for (k = 0, len1 = ref32.length; k < len1; k++) {
              pair = ref32[k];
              item.shortenedAddr = item.shortenedAddr.replace(pair.stringOrRx, pair.alias);
            }
          }
        }
        ref4 = this._skipCallbacks;
        for (l2 = 0, len22 = ref4.length; l2 < len22; l2++) {
          cb2 = ref4[l2];
          if (cb2(item, itemNumber) === true) {
            return true;
          }
        }
        ref5 = this._filterCallbacks;
        for (m = 0, len3 = ref5.length; m < len3; m++) {
          cb2 = ref5[m];
          cb2(item, itemNumber);
        }
        return false;
      };
      PrettyError2.prototype._applyParsedErrorFiltersOn = function(error) {
        var cb2, j2, len2, ref3;
        ref3 = this._parsedErrorFilters;
        for (j2 = 0, len2 = ref3.length; j2 < len2; j2++) {
          cb2 = ref3[j2];
          cb2(error);
        }
      };
      return PrettyError2;
    }();
    ref2 = ["renderer", "style"];
    fn = function() {
      var methodName;
      methodName = "_get" + prop[0].toUpperCase() + prop.substr(1, prop.length);
      return PrettyError.prototype.__defineGetter__(prop, function() {
        return this[methodName]();
      });
    };
    for (j = 0, len = ref2.length; j < len; j++) {
      prop = ref2[j];
      fn();
    }
  }
});

// src/cli/index.tsx
var import_commander = __toModule(require_commander());

// src/cli/components-api/index.tsx
var import_react9 = __toModule(require_react());

// node_modules/valtio/esm/index.mjs
var import_react = __toModule(require_react());

// node_modules/proxy-compare/dist/index.modern.mjs
var e = Symbol();
var t = Symbol();
var r = Symbol();
var n = Object.getPrototypeOf;
var o = new WeakMap();
var s = (e2) => e2 && (o.has(e2) ? o.get(e2) : n(e2) === Object.prototype || n(e2) === Array.prototype);
var c = (e2) => typeof e2 == "object" && e2 !== null;
var l = (n2, o2) => {
  let s2 = false;
  const c2 = (e2, t2) => {
    if (!s2) {
      let r2 = e2.a.get(n2);
      r2 || (r2 = /* @__PURE__ */ new Set(), e2.a.set(n2, r2)), r2.add(t2);
    }
  }, l2 = { f: o2, get(e2, t2) {
    return t2 === r ? n2 : (c2(this, t2), i2(e2[t2], this.a, this.c));
  }, has(e2, r2) {
    return r2 === t ? (s2 = true, this.a.delete(n2), true) : (c2(this, r2), r2 in e2);
  }, ownKeys(t2) {
    return c2(this, e), Reflect.ownKeys(t2);
  } };
  return o2 && (l2.set = l2.deleteProperty = () => false), l2;
};
var i2 = (e2, t2, o2) => {
  if (!s(e2))
    return e2;
  const c2 = e2[r] || e2, i3 = ((e3) => Object.isFrozen(e3) || Object.values(Object.getOwnPropertyDescriptors(e3)).some((e4) => !e4.writable))(c2);
  let u2 = o2 && o2.get(c2);
  return u2 && u2.f === i3 || (u2 = l(c2, i3), u2.p = new Proxy(i3 ? ((e3) => {
    if (Array.isArray(e3))
      return Array.from(e3);
    const t3 = Object.getOwnPropertyDescriptors(e3);
    return Object.values(t3).forEach((e4) => {
      e4.configurable = true;
    }), Object.create(n(e3), t3);
  })(c2) : c2, u2), o2 && o2.set(c2, u2)), u2.a = t2, u2.c = o2, u2.p;
};
var u = (e2, t2) => {
  const r2 = Reflect.ownKeys(e2), n2 = Reflect.ownKeys(t2);
  return r2.length !== n2.length || r2.some((e3, t3) => e3 !== n2[t3]);
};
var a = (t2, r2, n2, o2) => {
  if (Object.is(t2, r2))
    return false;
  if (!c(t2) || !c(r2))
    return true;
  const s2 = n2.get(t2);
  if (!s2)
    return true;
  if (o2) {
    const e2 = o2.get(t2);
    if (e2 && e2.n === r2)
      return e2.g;
    o2.set(t2, { n: r2, g: false });
  }
  let l2 = null;
  for (const c2 of s2) {
    const s3 = c2 === e ? u(t2, r2) : a(t2[c2], r2[c2], n2, o2);
    if (s3 !== true && s3 !== false || (l2 = s3), l2)
      break;
  }
  return l2 === null && (l2 = true), o2 && o2.set(t2, { n: r2, g: l2 }), l2;
};
var y = (e2) => s(e2) && e2[r] || null;
var b = (e2, t2 = true) => {
  o.set(e2, t2);
};
var g = (e2, t2) => {
  const r2 = [], n2 = (e3, o2) => {
    const s2 = t2.get(e3);
    s2 ? s2.forEach((t3) => {
      n2(e3[t3], o2 ? [...o2, t3] : [t3]);
    }) : o2 && r2.push(o2);
  };
  return n2(e2), r2;
};

// node_modules/valtio/esm/vanilla.mjs
var VERSION = Symbol();
var LISTENERS = Symbol();
var SNAPSHOT = Symbol();
var PROMISE_RESULT = Symbol();
var PROMISE_ERROR = Symbol();
var refSet = new WeakSet();
var isSupportedObject = (x) => typeof x === "object" && x !== null && (Array.isArray(x) || !x[Symbol.iterator]) && !(x instanceof WeakMap) && !(x instanceof WeakSet) && !(x instanceof Error) && !(x instanceof Number) && !(x instanceof Date) && !(x instanceof String) && !(x instanceof RegExp) && !(x instanceof ArrayBuffer);
var proxyCache = new WeakMap();
var globalVersion = 1;
var snapshotCache = new WeakMap();
var proxy = (initialObject = {}) => {
  if (!isSupportedObject(initialObject)) {
    throw new Error("unsupported object type");
  }
  const found = proxyCache.get(initialObject);
  if (found) {
    return found;
  }
  let version = globalVersion;
  const listeners = /* @__PURE__ */ new Set();
  const notifyUpdate = (op, nextVersion) => {
    if (!nextVersion) {
      nextVersion = ++globalVersion;
    }
    if (version !== nextVersion) {
      version = nextVersion;
      listeners.forEach((listener) => listener(op, nextVersion));
    }
  };
  const propListeners = /* @__PURE__ */ new Map();
  const getPropListener = (prop) => {
    let propListener = propListeners.get(prop);
    if (!propListener) {
      propListener = (op, nextVersion) => {
        const newOp = [...op];
        newOp[1] = [prop, ...newOp[1]];
        notifyUpdate(newOp, nextVersion);
      };
      propListeners.set(prop, propListener);
    }
    return propListener;
  };
  const popPropListener = (prop) => {
    const propListener = propListeners.get(prop);
    propListeners.delete(prop);
    return propListener;
  };
  const createSnapshot = (target, receiver) => {
    const cache = snapshotCache.get(receiver);
    if ((cache == null ? void 0 : cache[0]) === version) {
      return cache[1];
    }
    const snapshot2 = Array.isArray(target) ? [] : Object.create(Object.getPrototypeOf(target));
    b(snapshot2, true);
    snapshotCache.set(receiver, [version, snapshot2]);
    Reflect.ownKeys(target).forEach((key2) => {
      const value = target[key2];
      if (refSet.has(value)) {
        b(value, false);
        snapshot2[key2] = value;
      } else if (!isSupportedObject(value)) {
        snapshot2[key2] = value;
      } else if (value instanceof Promise) {
        if (PROMISE_RESULT in value) {
          snapshot2[key2] = value[PROMISE_RESULT];
        } else {
          const errorOrPromise = value[PROMISE_ERROR] || value;
          Object.defineProperty(snapshot2, key2, {
            get() {
              if (PROMISE_RESULT in value) {
                return value[PROMISE_RESULT];
              }
              throw errorOrPromise;
            }
          });
        }
      } else if (value[VERSION]) {
        snapshot2[key2] = value[SNAPSHOT];
      } else {
        snapshot2[key2] = value;
      }
    });
    Object.freeze(snapshot2);
    return snapshot2;
  };
  const baseObject = Array.isArray(initialObject) ? [] : Object.create(Object.getPrototypeOf(initialObject));
  const proxyObject = new Proxy(baseObject, {
    get(target, prop, receiver) {
      if (prop === VERSION) {
        return version;
      }
      if (prop === LISTENERS) {
        return listeners;
      }
      if (prop === SNAPSHOT) {
        return createSnapshot(target, receiver);
      }
      return target[prop];
    },
    deleteProperty(target, prop) {
      const prevValue = target[prop];
      const childListeners = prevValue == null ? void 0 : prevValue[LISTENERS];
      if (childListeners) {
        childListeners.delete(popPropListener(prop));
      }
      const deleted = Reflect.deleteProperty(target, prop);
      if (deleted) {
        notifyUpdate(["delete", [prop], prevValue]);
      }
      return deleted;
    },
    set(target, prop, value) {
      var _a2;
      const prevValue = target[prop];
      if (Object.is(prevValue, value)) {
        return true;
      }
      const childListeners = prevValue == null ? void 0 : prevValue[LISTENERS];
      if (childListeners) {
        childListeners.delete(popPropListener(prop));
      }
      if (refSet.has(value) || !isSupportedObject(value) || ((_a2 = Object.getOwnPropertyDescriptor(target, prop)) == null ? void 0 : _a2.set)) {
        target[prop] = value;
      } else if (value instanceof Promise) {
        target[prop] = value.then((v) => {
          target[prop][PROMISE_RESULT] = v;
          notifyUpdate(["resolve", [prop], v]);
          return v;
        }).catch((e2) => {
          target[prop][PROMISE_ERROR] = e2;
          notifyUpdate(["reject", [prop], e2]);
        });
      } else {
        value = y(value) || value;
        if (value[LISTENERS]) {
          target[prop] = value;
        } else {
          target[prop] = proxy(value);
        }
        target[prop][LISTENERS].add(getPropListener(prop));
      }
      notifyUpdate(["set", [prop], value, prevValue]);
      return true;
    }
  });
  proxyCache.set(initialObject, proxyObject);
  Reflect.ownKeys(initialObject).forEach((key2) => {
    const desc = Object.getOwnPropertyDescriptor(initialObject, key2);
    if (desc.get || desc.set) {
      Object.defineProperty(baseObject, key2, desc);
    } else {
      proxyObject[key2] = initialObject[key2];
    }
  });
  return proxyObject;
};
var getVersion = (proxyObject) => proxyObject[VERSION];
var subscribe = (proxyObject, callback, notifyInSync) => {
  if (typeof process === "object" && process.env.NODE_ENV !== "production" && !(proxyObject == null ? void 0 : proxyObject[LISTENERS])) {
    console.warn("Please use proxy object");
  }
  let pendingVersion = 0;
  const ops = [];
  const listener = (op, nextVersion) => {
    ops.push(op);
    if (notifyInSync) {
      callback(ops.splice(0));
      return;
    }
    pendingVersion = nextVersion;
    Promise.resolve().then(() => {
      if (nextVersion === pendingVersion) {
        callback(ops.splice(0));
      }
    });
  };
  proxyObject[LISTENERS].add(listener);
  return () => {
    proxyObject[LISTENERS].delete(listener);
  };
};
var snapshot = (proxyObject) => {
  if (typeof process === "object" && process.env.NODE_ENV !== "production" && !(proxyObject == null ? void 0 : proxyObject[SNAPSHOT])) {
    console.warn("Please use proxy object");
  }
  return proxyObject[SNAPSHOT];
};

// node_modules/valtio/esm/index.mjs
var TARGET = "_uMS_T";
var GET_VERSION = "_uMS_V";
var createMutableSource = (target, getVersion2) => ({
  [TARGET]: target,
  [GET_VERSION]: getVersion2
});
var useMutableSource = (source, getSnapshot, subscribe2) => {
  const lastVersion = (0, import_react.useRef)();
  const currentVersion = source[GET_VERSION](source[TARGET]);
  const [state, setState] = (0, import_react.useState)(() => [
    source,
    getSnapshot,
    subscribe2,
    currentVersion,
    getSnapshot(source[TARGET])
  ]);
  let currentSnapshot = state[4];
  if (state[0] !== source || state[1] !== getSnapshot || state[2] !== subscribe2) {
    currentSnapshot = getSnapshot(source[TARGET]);
    setState([
      source,
      getSnapshot,
      subscribe2,
      currentVersion,
      currentSnapshot
    ]);
  } else if (currentVersion !== state[3] && currentVersion !== lastVersion.current) {
    currentSnapshot = getSnapshot(source[TARGET]);
    if (!Object.is(currentSnapshot, state[4])) {
      setState([
        source,
        getSnapshot,
        subscribe2,
        currentVersion,
        currentSnapshot
      ]);
    }
  }
  (0, import_react.useEffect)(() => {
    let didUnsubscribe = false;
    const checkForUpdates = () => {
      if (didUnsubscribe) {
        return;
      }
      try {
        const nextSnapshot = getSnapshot(source[TARGET]);
        const nextVersion = source[GET_VERSION](source[TARGET]);
        lastVersion.current = nextVersion;
        setState((prev) => {
          if (prev[0] !== source || prev[1] !== getSnapshot || prev[2] !== subscribe2) {
            return prev;
          }
          if (Object.is(prev[4], nextSnapshot)) {
            return prev;
          }
          return [
            prev[0],
            prev[1],
            prev[2],
            nextVersion,
            nextSnapshot
          ];
        });
      } catch (e2) {
        setState((prev) => [...prev]);
      }
    };
    const unsubscribe = subscribe2(source[TARGET], checkForUpdates);
    checkForUpdates();
    return () => {
      didUnsubscribe = true;
      unsubscribe();
    };
  }, [source, getSnapshot, subscribe2]);
  return currentSnapshot;
};
var isSSR = typeof window === "undefined" || !window.navigator || /ServerSideRendering|^Deno\//.test(window.navigator.userAgent);
var useIsomorphicLayoutEffect = isSSR ? import_react.useEffect : import_react.useLayoutEffect;
var useAffectedDebugValue = (state, affected) => {
  const pathList = (0, import_react.useRef)();
  (0, import_react.useEffect)(() => {
    pathList.current = g(state, affected);
  });
  (0, import_react.useDebugValue)(pathList.current);
};
var mutableSourceCache = new WeakMap();
var getMutableSource = (proxyObject) => {
  if (!mutableSourceCache.has(proxyObject)) {
    mutableSourceCache.set(proxyObject, createMutableSource(proxyObject, getVersion));
  }
  return mutableSourceCache.get(proxyObject);
};
var useSnapshot = (proxyObject, options) => {
  const forceUpdate = (0, import_react.useReducer)((c2) => c2 + 1, 0)[1];
  const affected = new WeakMap();
  const lastAffected = (0, import_react.useRef)();
  const prevSnapshot = (0, import_react.useRef)();
  const lastSnapshot = (0, import_react.useRef)();
  useIsomorphicLayoutEffect(() => {
    lastSnapshot.current = prevSnapshot.current = snapshot(proxyObject);
  }, [proxyObject]);
  useIsomorphicLayoutEffect(() => {
    lastAffected.current = affected;
    if (prevSnapshot.current !== lastSnapshot.current && a(prevSnapshot.current, lastSnapshot.current, affected, new WeakMap())) {
      prevSnapshot.current = lastSnapshot.current;
      forceUpdate();
    }
  });
  const notifyInSync = options == null ? void 0 : options.sync;
  const sub = (0, import_react.useCallback)((proxyObject2, cb2) => subscribe(proxyObject2, () => {
    const nextSnapshot = snapshot(proxyObject2);
    lastSnapshot.current = nextSnapshot;
    try {
      if (lastAffected.current && !a(prevSnapshot.current, nextSnapshot, lastAffected.current, new WeakMap())) {
        return;
      }
    } catch (e2) {
    }
    prevSnapshot.current = nextSnapshot;
    cb2();
  }, notifyInSync), [notifyInSync]);
  const currSnapshot = useMutableSource(getMutableSource(proxyObject), snapshot, sub);
  if (typeof process === "object" && process.env.NODE_ENV !== "production") {
    useAffectedDebugValue(currSnapshot, affected);
  }
  const proxyCache2 = (0, import_react.useMemo)(() => new WeakMap(), []);
  return i2(currSnapshot, affected, proxyCache2);
};

// src/cli/components-api/components/Task.tsx
var import_react2 = __toModule(require_react());
var import_ink = __toModule(require_build2());
var import_ink_spinner = __toModule(require_build3());
var Task = (props) => {
  const {
    func: func2,
    onDone,
    titleStr
  } = props;
  const [title, setTitle] = (0, import_react2.useState)(titleStr);
  const [state, setState] = (0, import_react2.useState)(0 /* IN_PROGRESS */);
  const [error, setError] = (0, import_react2.useState)(null);
  (0, import_react2.useEffect)(() => {
    (async () => {
      try {
        const result2 = await func2({ setTitle, setError });
        setState(1 /* SUCCESS */);
        onDone(result2);
      } catch (e2) {
        console.error(e2);
      }
    })();
  }, []);
  return /* @__PURE__ */ import_react2.default.createElement(import_ink.Box, {
    flexDirection: "row"
  }, /* @__PURE__ */ import_react2.default.createElement(import_ink.Box, {
    marginRight: 1
  }, state === 0 /* IN_PROGRESS */ ? /* @__PURE__ */ import_react2.default.createElement(import_ink.Text, null, "[", /* @__PURE__ */ import_react2.default.createElement(import_ink_spinner.default, {
    type: "dots"
  }), "]") : state === 1 /* SUCCESS */ ? /* @__PURE__ */ import_react2.default.createElement(import_ink.Text, null, "[", /* @__PURE__ */ import_react2.default.createElement(import_ink.Text, {
    color: "green"
  }, "\u2713"), "]") : /* @__PURE__ */ import_react2.default.createElement(import_ink.Text, null, "[", /* @__PURE__ */ import_react2.default.createElement(import_ink.Text, {
    color: "red"
  }, "\xD7"), "]"), state === 2 /* FAIL */ ? /* @__PURE__ */ import_react2.default.createElement(import_ink.Text, null, title, /* @__PURE__ */ import_react2.default.createElement(import_ink.Newline, null), /* @__PURE__ */ import_react2.default.createElement(import_ink.Text, {
    color: "red"
  }, error.message)) : /* @__PURE__ */ import_react2.default.createElement(import_react2.default.Fragment, null, /* @__PURE__ */ import_react2.default.createElement(import_ink.Text, null, title))));
};
var Task_default = Task;

// src/cli/components-api/CreateApp.tsx
var import_ink2 = __toModule(require_build2());
var import_react4 = __toModule(require_react());

// src/cli/components-api/ComponentsList.tsx
var import_react3 = __toModule(require_react());
var ComponentsList = ({
  componentsList: componentsList2
}) => {
  useSnapshot(componentsList2);
  return /* @__PURE__ */ import_react3.default.createElement(import_react3.default.Fragment, null, componentsList2.map((component, i3) => __spreadProps(__spreadValues({}, component), { key: i3 })));
};
var ComponentsList_default = ComponentsList;

// src/cli/components-api/CreateApp.tsx
var createApp = (componentsList2) => {
  const inkApp = (0, import_ink2.render)(/* @__PURE__ */ import_react4.default.createElement(ComponentsList_default, {
    componentsList: componentsList2
  }));
  return {
    remove() {
      inkApp.rerender(null);
      inkApp.unmount();
      inkApp.clear();
      inkApp.cleanup();
    }
  };
};
var CreateApp_default = createApp;

// src/cli/components-api/components/PromptTablesConflicts.tsx
var import_react5 = __toModule(require_react());
var import_ink3 = __toModule(require_build2());
var import_ink_select_input = __toModule(require_build4());
var import_ink_table = __toModule(require_dist());
var import_react6 = __toModule(require_lib2());

// src/cli/machines/resolveTablesMachine.ts
var import_xstate = __toModule(require_lib());
var createResolveTablesMachine = (props) => (0, import_xstate.createMachine)({
  id: "resolveTables",
  initial: "table",
  context: __spreadProps(__spreadValues({}, props), {
    missingItemIndex: 0,
    newItemIndex: 0,
    createdTables: [],
    renamedTables: [],
    deletedTables: []
  }),
  states: {
    table: {
      entry: (0, import_xstate.send)({ type: "NEXT" }),
      on: {
        NEXT: [
          {
            target: "done",
            cond: "isMissingTablesResolved",
            actions: ["resolveRemaining"]
          },
          {
            target: "done",
            cond: "isNewTablesResolved",
            actions: ["resolveMissing"]
          }
        ],
        CHOICE_ITEM: { target: "action", actions: ["choseItem"] }
      }
    },
    action: {
      initial: "actionChoice",
      states: {
        actionChoice: {
          on: { DELETE: "#resolveTables.confirmationDelete", RENAME: "rename" }
        },
        rename: {
          on: {
            CHOICE_NEW_ITEM: { target: "#resolveTables.confirmationRename", actions: ["choseNewItem"] }
          }
        }
      }
    },
    confirmationDelete: {
      on: {
        CANCEL: "action.actionChoice",
        CONFIRM: [
          { target: "final", actions: ["delete"] }
        ]
      }
    },
    confirmationRename: {
      on: {
        CANCEL: "action.actionChoice",
        CONFIRM: [
          { target: "final", actions: ["rename"] }
        ]
      }
    },
    final: {
      entry: (0, import_xstate.send)({ type: "NEXT" }),
      on: {
        NEXT: [
          {
            target: "done",
            cond: "isMissingTablesResolved",
            actions: ["resolveRemaining"]
          },
          {
            target: "table"
          }
        ]
      }
    },
    done: {}
  }
}, {
  guards: {
    isMissingTablesResolved: ({ missingTables }) => !missingTables.length,
    isNewTablesResolved: ({ newTables }) => !newTables.length
  },
  actions: {
    choseItem: (0, import_xstate.assign)({
      missingItemIndex: (context, event2) => event2.type === "CHOICE_ITEM" ? event2.itemIndex : 0
    }),
    choseNewItem: (0, import_xstate.assign)({
      newItemIndex: (context, event2) => event2.type === "CHOICE_NEW_ITEM" ? event2.itemIndex : 0
    }),
    delete: (0, import_xstate.assign)({
      deletedTables: ({
        missingItemIndex,
        deletedTables,
        missingTables
      }) => [...deletedTables, missingTables[missingItemIndex]],
      missingTables: ({
        missingItemIndex,
        missingTables
      }) => missingTables.filter((_, index) => index !== missingItemIndex)
    }),
    rename: (0, import_xstate.assign)({
      renamedTables: ({
        missingItemIndex,
        newItemIndex,
        renamedTables,
        newTables,
        missingTables
      }) => [
        ...renamedTables,
        { old: missingTables[missingItemIndex], new: newTables[newItemIndex] }
      ],
      missingTables: ({
        missingItemIndex,
        missingTables
      }) => missingTables.filter((_, index) => index !== missingItemIndex),
      newTables: ({
        newItemIndex,
        newTables
      }) => newTables.filter((_, index) => index !== newItemIndex)
    }),
    resolveRemaining: (0, import_xstate.assign)({
      createdTables: ({
        newTables,
        createdTables
      }) => [...createdTables, ...newTables],
      newTables: (context) => []
    }),
    resolveMissing: (0, import_xstate.assign)({
      deletedTables: ({
        missingTables,
        deletedTables
      }) => [...deletedTables, ...missingTables],
      missingTables: (context) => []
    })
  }
});
var resolveTablesMachine_default = createResolveTablesMachine;

// src/cli/utils/formatDataForTable.ts
var formatDataForTable_default = (data) => {
  const array = [];
  array.length = data.reduce((acc, { values }) => {
    if (acc < values.length) {
      return values.length;
    }
    return acc;
  }, 0);
  array.fill({ "": "" });
  return array.map((_, i3) => {
    const temp = {};
    data.forEach((item, ind) => {
      var _a2, _b, _c, _d, _e, _f, _g;
      temp[data[ind].title] = ((_b = (_a2 = item.values[i3]) == null ? void 0 : _a2.old) == null ? void 0 : _b.name) ? `${(_d = (_c = item.values[i3]) == null ? void 0 : _c.old) == null ? void 0 : _d.name} -> ${(_f = (_e = item.values[i3]) == null ? void 0 : _e.new) == null ? void 0 : _f.name}` : ((_g = item.values[i3]) == null ? void 0 : _g.name) || "";
    });
    return temp;
  });
};

// src/cli/utils/valuesForPrompts.ts
var Action = /* @__PURE__ */ ((Action2) => {
  Action2["RENAME"] = "RENAME";
  Action2["DELETE"] = "DELETE";
  return Action2;
})(Action || {});
var actions = [
  {
    key: "RENAME" /* RENAME */,
    label: "Renamed",
    value: "RENAME" /* RENAME */
  },
  {
    key: "DELETE" /* DELETE */,
    label: "Deleted",
    value: "DELETE" /* DELETE */
  }
];
var confirmations = [
  {
    key: "CONFIRM" /* CONFIRM */,
    label: "Yes",
    value: "CONFIRM" /* CONFIRM */
  },
  {
    key: "CANCEL" /* CANCEL */,
    label: "No",
    value: "CANCEL" /* CANCEL */
  }
];

// src/cli/components-api/components/PromptTablesConflicts.tsx
var PromptTablesConflicts = ({
  onDone,
  newTables: newProps,
  missingTables: missingProps
}) => {
  const [current, send3] = (0, import_react6.useMachine)(resolveTablesMachine_default({
    missingTables: missingProps,
    newTables: newProps
  }));
  const {
    missingItemIndex,
    newTables,
    missingTables,
    createdTables,
    renamedTables,
    deletedTables
  } = current.context;
  const selectItemIndex = (item) => {
    send3({ type: "CHOICE_ITEM", itemIndex: item.value });
  };
  const selectNewItemIndex = (item) => {
    send3({ type: "CHOICE_NEW_ITEM", itemIndex: item.value });
  };
  const selectAction = (action) => {
    send3({ type: action.value });
  };
  const confirm = (confirmationItem) => {
    send3({ type: confirmationItem.value });
  };
  const renderDOM = () => {
    var _a2, _b;
    if (current.matches("table")) {
      return /* @__PURE__ */ import_react5.default.createElement(import_react5.default.Fragment, null, /* @__PURE__ */ import_react5.default.createElement(import_ink3.Box, {
        display: "flex",
        flexDirection: "column"
      }, /* @__PURE__ */ import_react5.default.createElement(import_ink3.Box, {
        display: "flex"
      }, /* @__PURE__ */ import_react5.default.createElement(import_ink3.Box, {
        flexDirection: "column"
      }, /* @__PURE__ */ import_react5.default.createElement(import_ink_table.Header, null, "Missing tables:"), /* @__PURE__ */ import_react5.default.createElement(import_ink_select_input.default, {
        items: missingTables.map((table, i3) => ({
          key: String(i3),
          label: table.name,
          value: i3
        })),
        onSelect: selectItemIndex
      })), !!(newTables == null ? void 0 : newTables.length) && /* @__PURE__ */ import_react5.default.createElement(import_ink3.Box, {
        flexDirection: "column",
        paddingLeft: 5
      }, /* @__PURE__ */ import_react5.default.createElement(import_ink_table.Header, null, "New tables:"), /* @__PURE__ */ import_react5.default.createElement(import_ink3.Box, {
        display: "flex",
        flexDirection: "column"
      }, newTables.map(({ name }, i3) => /* @__PURE__ */ import_react5.default.createElement(import_ink3.Text, {
        key: name + i3
      }, name)))))));
    }
    if (current.matches("action.actionChoice")) {
      const tempActions = !newTables.length ? actions.filter(({ value }) => value !== Action.RENAME) : actions;
      return /* @__PURE__ */ import_react5.default.createElement(import_react5.default.Fragment, null, /* @__PURE__ */ import_react5.default.createElement(import_ink_table.Header, null, `${(_a2 = missingTables[missingItemIndex]) == null ? void 0 : _a2.name} is:`), /* @__PURE__ */ import_react5.default.createElement(import_ink_select_input.default, {
        items: tempActions,
        onSelect: selectAction
      }));
    }
    if (current.matches("confirmationDelete")) {
      return /* @__PURE__ */ import_react5.default.createElement(import_react5.default.Fragment, null, /* @__PURE__ */ import_react5.default.createElement(import_ink_table.Header, null, "!!! Data in table will be lost !!!"), /* @__PURE__ */ import_react5.default.createElement(import_ink3.Text, null, "Are you sure?"), /* @__PURE__ */ import_react5.default.createElement(import_ink_select_input.default, {
        items: confirmations,
        onSelect: confirm
      }));
    }
    if (current.matches("confirmationRename")) {
      return /* @__PURE__ */ import_react5.default.createElement(import_react5.default.Fragment, null, /* @__PURE__ */ import_react5.default.createElement(import_ink_table.Header, null, "Are you sure?"), /* @__PURE__ */ import_react5.default.createElement(import_ink_select_input.default, {
        items: confirmations,
        onSelect: confirm
      }));
    }
    if (current.matches("action.rename")) {
      return /* @__PURE__ */ import_react5.default.createElement(import_react5.default.Fragment, null, /* @__PURE__ */ import_react5.default.createElement(import_ink_table.Header, null, `${(_b = missingTables[missingItemIndex]) == null ? void 0 : _b.name} was renamed to:`), /* @__PURE__ */ import_react5.default.createElement(import_ink_select_input.default, {
        items: newTables.map((table, i3) => ({
          key: String(i3),
          label: table.name,
          value: i3
        })),
        onSelect: selectNewItemIndex
      }));
    }
    if (current.matches("done")) {
      onDone({
        created: createdTables,
        renamed: renamedTables,
        deleted: deletedTables
      });
    }
    return /* @__PURE__ */ import_react5.default.createElement(import_react5.default.Fragment, null);
  };
  return !!deletedTables.length || !!renamedTables.length || !!createdTables.length ? /* @__PURE__ */ import_react5.default.createElement(import_ink3.Box, {
    flexDirection: "column",
    margin: 1
  }, /* @__PURE__ */ import_react5.default.createElement(import_ink3.Box, {
    flexDirection: "column",
    marginBottom: 0
  }, /* @__PURE__ */ import_react5.default.createElement(import_ink_table.Header, null, "Tables: "), /* @__PURE__ */ import_react5.default.createElement(import_ink_table.default, {
    data: formatDataForTable_default([
      {
        title: "Deleted",
        values: deletedTables
      },
      {
        title: "Renamed",
        values: renamedTables
      },
      {
        title: "Created",
        values: createdTables
      }
    ])
  })), renderDOM()) : renderDOM();
};
var PromptTablesConflicts_default = PromptTablesConflicts;

// src/cli/components-api/components/PromptColumnsConflicts.tsx
var import_react7 = __toModule(require_react());
var import_ink4 = __toModule(require_build2());
var import_ink_select_input2 = __toModule(require_build4());
var import_ink_table2 = __toModule(require_dist());
var import_react8 = __toModule(require_lib2());

// src/cli/machines/resolveColumnsMachine.ts
var import_xstate2 = __toModule(require_lib());
var createResolveColumnsMachine = (props) => (0, import_xstate2.createMachine)({
  id: "resolveColumns",
  initial: "table",
  context: {
    tableName: props.tableWithColumns.name,
    addedColumns: props.tableWithColumns.added,
    deletedColumns: props.tableWithColumns.deleted,
    missingItemIndex: 0,
    newItemIndex: 0,
    created: [],
    renamed: [],
    deleted: []
  },
  states: {
    table: {
      entry: (0, import_xstate2.send)({ type: "NEXT" }),
      on: {
        NEXT: [
          {
            target: "done",
            cond: "isMissingColumnsResolved",
            actions: ["resolveRemaining"]
          },
          {
            target: "done",
            cond: "isNewColumnsResolved",
            actions: ["resolveMissing"]
          }
        ],
        CHOICE_ITEM: { target: "action", actions: ["choseItem"] }
      }
    },
    action: {
      initial: "actionChoice",
      states: {
        actionChoice: {
          on: { DELETE: "#resolveColumns.confirmationDelete", RENAME: "rename" }
        },
        rename: {
          on: {
            CHOICE_NEW_ITEM: { target: "#resolveColumns.confirmationRename", actions: ["choseNewItem"] }
          }
        }
      }
    },
    confirmationDelete: {
      on: {
        CANCEL: "action.actionChoice",
        CONFIRM: [
          { target: "final", actions: ["delete"] }
        ]
      }
    },
    confirmationRename: {
      on: {
        CANCEL: "action.actionChoice",
        CONFIRM: [
          { target: "final", actions: ["rename"] }
        ]
      }
    },
    final: {
      entry: (0, import_xstate2.send)({ type: "NEXT" }),
      on: {
        NEXT: [
          {
            target: "done",
            cond: "isMissingColumnsResolved",
            actions: ["resolveRemaining"]
          },
          {
            target: "table"
          }
        ]
      }
    },
    done: {}
  }
}, {
  guards: {
    isMissingColumnsResolved: ({ deletedColumns }) => !deletedColumns.length,
    isNewColumnsResolved: ({ addedColumns }) => !addedColumns.length
  },
  actions: {
    choseItem: (0, import_xstate2.assign)({
      missingItemIndex: (context, event2) => event2.type === "CHOICE_ITEM" ? event2.itemIndex : 0
    }),
    choseNewItem: (0, import_xstate2.assign)({
      newItemIndex: (context, event2) => event2.type === "CHOICE_NEW_ITEM" ? event2.itemIndex : 0
    }),
    delete: (0, import_xstate2.assign)({
      deleted: ({
        missingItemIndex,
        deleted,
        deletedColumns
      }) => [...deleted, deletedColumns[missingItemIndex]],
      deletedColumns: ({
        missingItemIndex,
        deletedColumns
      }) => deletedColumns.filter((_, index) => index !== missingItemIndex)
    }),
    rename: (0, import_xstate2.assign)({
      renamed: ({
        missingItemIndex,
        newItemIndex,
        renamed: renamed2,
        addedColumns,
        deletedColumns
      }) => [
        ...renamed2,
        { old: deletedColumns[missingItemIndex], new: addedColumns[newItemIndex] }
      ],
      deletedColumns: ({
        missingItemIndex,
        deletedColumns
      }) => deletedColumns.filter((_, index) => index !== missingItemIndex),
      addedColumns: ({
        newItemIndex,
        addedColumns
      }) => addedColumns.filter((_, index) => index !== newItemIndex)
    }),
    resolveRemaining: (0, import_xstate2.assign)({
      created: ({
        addedColumns,
        created
      }) => [...created, ...addedColumns],
      addedColumns: (context) => []
    }),
    resolveMissing: (0, import_xstate2.assign)({
      deleted: ({
        deletedColumns,
        deleted
      }) => [...deleted, ...deletedColumns],
      deletedColumns: (context) => []
    })
  }
});
var resolveColumnsMachine_default = createResolveColumnsMachine;

// src/cli/components-api/components/PromptColumnsConflicts.tsx
var PromptColumnsConflicts = ({
  onDone,
  tableWithColumns: props
}) => {
  const [current, send3] = (0, import_react8.useMachine)(resolveColumnsMachine_default({ tableWithColumns: props }));
  const {
    tableName,
    addedColumns,
    deletedColumns,
    missingItemIndex,
    created,
    renamed: renamed2,
    deleted
  } = current.context;
  const selectItemIndex = (item) => {
    send3({ type: "CHOICE_ITEM", itemIndex: item.value });
  };
  const selectNewItemIndex = (item) => {
    send3({ type: "CHOICE_NEW_ITEM", itemIndex: item.value });
  };
  const selectAction = (action) => {
    send3({ type: action.value });
  };
  const confirm = (confirmationItem) => {
    send3({ type: confirmationItem.value });
  };
  const renderDOM = () => {
    var _a2, _b;
    if (current.matches("table")) {
      return /* @__PURE__ */ import_react7.default.createElement(import_react7.default.Fragment, null, /* @__PURE__ */ import_react7.default.createElement(import_ink4.Box, {
        display: "flex",
        flexDirection: "column"
      }, /* @__PURE__ */ import_react7.default.createElement(import_ink4.Box, {
        display: "flex"
      }, /* @__PURE__ */ import_react7.default.createElement(import_ink4.Box, {
        flexDirection: "column"
      }, /* @__PURE__ */ import_react7.default.createElement(import_ink_table2.Header, null, `Table "${tableName}" missing columns:`), /* @__PURE__ */ import_react7.default.createElement(import_ink_select_input2.default, {
        items: deletedColumns.map((column, i3) => ({
          key: String(i3),
          label: column.name,
          value: i3
        })),
        onSelect: selectItemIndex
      })), !!(addedColumns == null ? void 0 : addedColumns.length) && /* @__PURE__ */ import_react7.default.createElement(import_ink4.Box, {
        flexDirection: "column",
        paddingLeft: 5
      }, /* @__PURE__ */ import_react7.default.createElement(import_ink_table2.Header, null, "New tables:"), /* @__PURE__ */ import_react7.default.createElement(import_ink4.Box, {
        display: "flex",
        flexDirection: "column"
      }, addedColumns.map(({ name }, i3) => /* @__PURE__ */ import_react7.default.createElement(import_ink4.Text, {
        key: name + i3
      }, name)))))));
    }
    if (current.matches("action.actionChoice")) {
      const tempActions = !addedColumns.length ? actions.filter(({ value }) => value !== Action.RENAME) : actions;
      return /* @__PURE__ */ import_react7.default.createElement(import_react7.default.Fragment, null, /* @__PURE__ */ import_react7.default.createElement(import_ink_table2.Header, null, `${(_a2 = deletedColumns[missingItemIndex]) == null ? void 0 : _a2.name} is:`), /* @__PURE__ */ import_react7.default.createElement(import_ink_select_input2.default, {
        items: tempActions,
        onSelect: selectAction
      }));
    }
    if (current.matches("confirmationDelete")) {
      return /* @__PURE__ */ import_react7.default.createElement(import_react7.default.Fragment, null, /* @__PURE__ */ import_react7.default.createElement(import_ink_table2.Header, null, "!!! Data in table will be lost !!!"), /* @__PURE__ */ import_react7.default.createElement(import_ink4.Text, null, "Are you sure?"), /* @__PURE__ */ import_react7.default.createElement(import_ink_select_input2.default, {
        items: confirmations,
        onSelect: confirm
      }));
    }
    if (current.matches("confirmationRename")) {
      return /* @__PURE__ */ import_react7.default.createElement(import_react7.default.Fragment, null, /* @__PURE__ */ import_react7.default.createElement(import_ink_table2.Header, null, "Are you sure?"), /* @__PURE__ */ import_react7.default.createElement(import_ink_select_input2.default, {
        items: confirmations,
        onSelect: confirm
      }));
    }
    if (current.matches("action.rename")) {
      return /* @__PURE__ */ import_react7.default.createElement(import_react7.default.Fragment, null, /* @__PURE__ */ import_react7.default.createElement(import_ink_table2.Header, null, `${(_b = deletedColumns[missingItemIndex]) == null ? void 0 : _b.name} was renamed to:`), /* @__PURE__ */ import_react7.default.createElement(import_ink_select_input2.default, {
        items: addedColumns.map((table, i3) => ({
          key: String(i3),
          label: table.name,
          value: i3
        })),
        onSelect: selectNewItemIndex
      }));
    }
    if (current.matches("done")) {
      onDone({ created, renamed: renamed2, deleted });
    }
    return /* @__PURE__ */ import_react7.default.createElement(import_react7.default.Fragment, null);
  };
  return !!deleted.length || !!renamed2.length || !!created.length ? /* @__PURE__ */ import_react7.default.createElement(import_ink4.Box, {
    flexDirection: "column",
    margin: 1
  }, /* @__PURE__ */ import_react7.default.createElement(import_ink4.Box, {
    flexDirection: "column",
    marginBottom: 0
  }, /* @__PURE__ */ import_react7.default.createElement(import_ink_table2.Header, null, `${tableName} columns:`), /* @__PURE__ */ import_react7.default.createElement(import_ink_table2.default, {
    data: formatDataForTable_default([
      {
        title: "Deleted",
        values: deleted
      },
      {
        title: "Renamed",
        values: renamed2
      },
      {
        title: "Created",
        values: created
      }
    ])
  })), renderDOM()) : renderDOM();
};
var PromptColumnsConflicts_default = PromptColumnsConflicts;

// src/cli/components-api/index.tsx
var componentsList = proxy([]);
var app;
var prepareApp = () => {
  if (!app) {
    app = CreateApp_default(componentsList);
    componentsList.length = 0;
  }
};
var task = (titleStr, func2) => new Promise((resolve) => {
  prepareApp();
  componentsList.push(/* @__PURE__ */ import_react9.default.createElement(Task_default, {
    titleStr,
    func: func2,
    onDone: (val) => resolve(val)
  }));
});
var promptTablesConflicts = ({ missingTables, newTables }) => new Promise((resolve) => {
  prepareApp();
  componentsList.push(/* @__PURE__ */ import_react9.default.createElement(PromptTablesConflicts_default, {
    onDone: (val) => resolve(val),
    missingTables,
    newTables
  }));
});
var promptColumnsConflicts = (tableWithColumns) => new Promise((resolve) => {
  prepareApp();
  componentsList.push(/* @__PURE__ */ import_react9.default.createElement(PromptColumnsConflicts_default, {
    onDone: (val) => resolve(val),
    tableWithColumns
  }));
});

// src/cli/commands/migrate.tsx
var import_fs4 = __toModule(require("fs"));

// node_modules/js-yaml/dist/js-yaml.mjs
function isNothing(subject) {
  return typeof subject === "undefined" || subject === null;
}
function isObject(subject) {
  return typeof subject === "object" && subject !== null;
}
function toArray(sequence) {
  if (Array.isArray(sequence))
    return sequence;
  else if (isNothing(sequence))
    return [];
  return [sequence];
}
function extend(target, source) {
  var index, length, key2, sourceKeys;
  if (source) {
    sourceKeys = Object.keys(source);
    for (index = 0, length = sourceKeys.length; index < length; index += 1) {
      key2 = sourceKeys[index];
      target[key2] = source[key2];
    }
  }
  return target;
}
function repeat(string, count) {
  var result2 = "", cycle;
  for (cycle = 0; cycle < count; cycle += 1) {
    result2 += string;
  }
  return result2;
}
function isNegativeZero(number) {
  return number === 0 && Number.NEGATIVE_INFINITY === 1 / number;
}
var isNothing_1 = isNothing;
var isObject_1 = isObject;
var toArray_1 = toArray;
var repeat_1 = repeat;
var isNegativeZero_1 = isNegativeZero;
var extend_1 = extend;
var common = {
  isNothing: isNothing_1,
  isObject: isObject_1,
  toArray: toArray_1,
  repeat: repeat_1,
  isNegativeZero: isNegativeZero_1,
  extend: extend_1
};
function formatError(exception2, compact) {
  var where = "", message = exception2.reason || "(unknown reason)";
  if (!exception2.mark)
    return message;
  if (exception2.mark.name) {
    where += 'in "' + exception2.mark.name + '" ';
  }
  where += "(" + (exception2.mark.line + 1) + ":" + (exception2.mark.column + 1) + ")";
  if (!compact && exception2.mark.snippet) {
    where += "\n\n" + exception2.mark.snippet;
  }
  return message + " " + where;
}
function YAMLException$1(reason, mark) {
  Error.call(this);
  this.name = "YAMLException";
  this.reason = reason;
  this.mark = mark;
  this.message = formatError(this, false);
  if (Error.captureStackTrace) {
    Error.captureStackTrace(this, this.constructor);
  } else {
    this.stack = new Error().stack || "";
  }
}
YAMLException$1.prototype = Object.create(Error.prototype);
YAMLException$1.prototype.constructor = YAMLException$1;
YAMLException$1.prototype.toString = function toString(compact) {
  return this.name + ": " + formatError(this, compact);
};
var exception = YAMLException$1;
function getLine(buffer2, lineStart, lineEnd, position, maxLineLength) {
  var head = "";
  var tail = "";
  var maxHalfLength = Math.floor(maxLineLength / 2) - 1;
  if (position - lineStart > maxHalfLength) {
    head = " ... ";
    lineStart = position - maxHalfLength + head.length;
  }
  if (lineEnd - position > maxHalfLength) {
    tail = " ...";
    lineEnd = position + maxHalfLength - tail.length;
  }
  return {
    str: head + buffer2.slice(lineStart, lineEnd).replace(/\t/g, "\u2192") + tail,
    pos: position - lineStart + head.length
  };
}
function padStart(string, max) {
  return common.repeat(" ", max - string.length) + string;
}
function makeSnippet(mark, options) {
  options = Object.create(options || null);
  if (!mark.buffer)
    return null;
  if (!options.maxLength)
    options.maxLength = 79;
  if (typeof options.indent !== "number")
    options.indent = 1;
  if (typeof options.linesBefore !== "number")
    options.linesBefore = 3;
  if (typeof options.linesAfter !== "number")
    options.linesAfter = 2;
  var re = /\r?\n|\r|\0/g;
  var lineStarts = [0];
  var lineEnds = [];
  var match;
  var foundLineNo = -1;
  while (match = re.exec(mark.buffer)) {
    lineEnds.push(match.index);
    lineStarts.push(match.index + match[0].length);
    if (mark.position <= match.index && foundLineNo < 0) {
      foundLineNo = lineStarts.length - 2;
    }
  }
  if (foundLineNo < 0)
    foundLineNo = lineStarts.length - 1;
  var result2 = "", i3, line;
  var lineNoLength = Math.min(mark.line + options.linesAfter, lineEnds.length).toString().length;
  var maxLineLength = options.maxLength - (options.indent + lineNoLength + 3);
  for (i3 = 1; i3 <= options.linesBefore; i3++) {
    if (foundLineNo - i3 < 0)
      break;
    line = getLine(mark.buffer, lineStarts[foundLineNo - i3], lineEnds[foundLineNo - i3], mark.position - (lineStarts[foundLineNo] - lineStarts[foundLineNo - i3]), maxLineLength);
    result2 = common.repeat(" ", options.indent) + padStart((mark.line - i3 + 1).toString(), lineNoLength) + " | " + line.str + "\n" + result2;
  }
  line = getLine(mark.buffer, lineStarts[foundLineNo], lineEnds[foundLineNo], mark.position, maxLineLength);
  result2 += common.repeat(" ", options.indent) + padStart((mark.line + 1).toString(), lineNoLength) + " | " + line.str + "\n";
  result2 += common.repeat("-", options.indent + lineNoLength + 3 + line.pos) + "^\n";
  for (i3 = 1; i3 <= options.linesAfter; i3++) {
    if (foundLineNo + i3 >= lineEnds.length)
      break;
    line = getLine(mark.buffer, lineStarts[foundLineNo + i3], lineEnds[foundLineNo + i3], mark.position - (lineStarts[foundLineNo] - lineStarts[foundLineNo + i3]), maxLineLength);
    result2 += common.repeat(" ", options.indent) + padStart((mark.line + i3 + 1).toString(), lineNoLength) + " | " + line.str + "\n";
  }
  return result2.replace(/\n$/, "");
}
var snippet = makeSnippet;
var TYPE_CONSTRUCTOR_OPTIONS = [
  "kind",
  "multi",
  "resolve",
  "construct",
  "instanceOf",
  "predicate",
  "represent",
  "representName",
  "defaultStyle",
  "styleAliases"
];
var YAML_NODE_KINDS = [
  "scalar",
  "sequence",
  "mapping"
];
function compileStyleAliases(map2) {
  var result2 = {};
  if (map2 !== null) {
    Object.keys(map2).forEach(function(style) {
      map2[style].forEach(function(alias) {
        result2[String(alias)] = style;
      });
    });
  }
  return result2;
}
function Type$1(tag, options) {
  options = options || {};
  Object.keys(options).forEach(function(name) {
    if (TYPE_CONSTRUCTOR_OPTIONS.indexOf(name) === -1) {
      throw new exception('Unknown option "' + name + '" is met in definition of "' + tag + '" YAML type.');
    }
  });
  this.options = options;
  this.tag = tag;
  this.kind = options["kind"] || null;
  this.resolve = options["resolve"] || function() {
    return true;
  };
  this.construct = options["construct"] || function(data) {
    return data;
  };
  this.instanceOf = options["instanceOf"] || null;
  this.predicate = options["predicate"] || null;
  this.represent = options["represent"] || null;
  this.representName = options["representName"] || null;
  this.defaultStyle = options["defaultStyle"] || null;
  this.multi = options["multi"] || false;
  this.styleAliases = compileStyleAliases(options["styleAliases"] || null);
  if (YAML_NODE_KINDS.indexOf(this.kind) === -1) {
    throw new exception('Unknown kind "' + this.kind + '" is specified for "' + tag + '" YAML type.');
  }
}
var type2 = Type$1;
function compileList(schema2, name) {
  var result2 = [];
  schema2[name].forEach(function(currentType) {
    var newIndex = result2.length;
    result2.forEach(function(previousType, previousIndex) {
      if (previousType.tag === currentType.tag && previousType.kind === currentType.kind && previousType.multi === currentType.multi) {
        newIndex = previousIndex;
      }
    });
    result2[newIndex] = currentType;
  });
  return result2;
}
function compileMap() {
  var result2 = {
    scalar: {},
    sequence: {},
    mapping: {},
    fallback: {},
    multi: {
      scalar: [],
      sequence: [],
      mapping: [],
      fallback: []
    }
  }, index, length;
  function collectType(type3) {
    if (type3.multi) {
      result2.multi[type3.kind].push(type3);
      result2.multi["fallback"].push(type3);
    } else {
      result2[type3.kind][type3.tag] = result2["fallback"][type3.tag] = type3;
    }
  }
  for (index = 0, length = arguments.length; index < length; index += 1) {
    arguments[index].forEach(collectType);
  }
  return result2;
}
function Schema$1(definition) {
  return this.extend(definition);
}
Schema$1.prototype.extend = function extend2(definition) {
  var implicit = [];
  var explicit = [];
  if (definition instanceof type2) {
    explicit.push(definition);
  } else if (Array.isArray(definition)) {
    explicit = explicit.concat(definition);
  } else if (definition && (Array.isArray(definition.implicit) || Array.isArray(definition.explicit))) {
    if (definition.implicit)
      implicit = implicit.concat(definition.implicit);
    if (definition.explicit)
      explicit = explicit.concat(definition.explicit);
  } else {
    throw new exception("Schema.extend argument should be a Type, [ Type ], or a schema definition ({ implicit: [...], explicit: [...] })");
  }
  implicit.forEach(function(type$1) {
    if (!(type$1 instanceof type2)) {
      throw new exception("Specified list of YAML types (or a single Type object) contains a non-Type object.");
    }
    if (type$1.loadKind && type$1.loadKind !== "scalar") {
      throw new exception("There is a non-scalar type in the implicit list of a schema. Implicit resolving of such types is not supported.");
    }
    if (type$1.multi) {
      throw new exception("There is a multi type in the implicit list of a schema. Multi tags can only be listed as explicit.");
    }
  });
  explicit.forEach(function(type$1) {
    if (!(type$1 instanceof type2)) {
      throw new exception("Specified list of YAML types (or a single Type object) contains a non-Type object.");
    }
  });
  var result2 = Object.create(Schema$1.prototype);
  result2.implicit = (this.implicit || []).concat(implicit);
  result2.explicit = (this.explicit || []).concat(explicit);
  result2.compiledImplicit = compileList(result2, "implicit");
  result2.compiledExplicit = compileList(result2, "explicit");
  result2.compiledTypeMap = compileMap(result2.compiledImplicit, result2.compiledExplicit);
  return result2;
};
var schema = Schema$1;
var str = new type2("tag:yaml.org,2002:str", {
  kind: "scalar",
  construct: function(data) {
    return data !== null ? data : "";
  }
});
var seq = new type2("tag:yaml.org,2002:seq", {
  kind: "sequence",
  construct: function(data) {
    return data !== null ? data : [];
  }
});
var map = new type2("tag:yaml.org,2002:map", {
  kind: "mapping",
  construct: function(data) {
    return data !== null ? data : {};
  }
});
var failsafe = new schema({
  explicit: [
    str,
    seq,
    map
  ]
});
function resolveYamlNull(data) {
  if (data === null)
    return true;
  var max = data.length;
  return max === 1 && data === "~" || max === 4 && (data === "null" || data === "Null" || data === "NULL");
}
function constructYamlNull() {
  return null;
}
function isNull(object) {
  return object === null;
}
var _null = new type2("tag:yaml.org,2002:null", {
  kind: "scalar",
  resolve: resolveYamlNull,
  construct: constructYamlNull,
  predicate: isNull,
  represent: {
    canonical: function() {
      return "~";
    },
    lowercase: function() {
      return "null";
    },
    uppercase: function() {
      return "NULL";
    },
    camelcase: function() {
      return "Null";
    },
    empty: function() {
      return "";
    }
  },
  defaultStyle: "lowercase"
});
function resolveYamlBoolean(data) {
  if (data === null)
    return false;
  var max = data.length;
  return max === 4 && (data === "true" || data === "True" || data === "TRUE") || max === 5 && (data === "false" || data === "False" || data === "FALSE");
}
function constructYamlBoolean(data) {
  return data === "true" || data === "True" || data === "TRUE";
}
function isBoolean(object) {
  return Object.prototype.toString.call(object) === "[object Boolean]";
}
var bool = new type2("tag:yaml.org,2002:bool", {
  kind: "scalar",
  resolve: resolveYamlBoolean,
  construct: constructYamlBoolean,
  predicate: isBoolean,
  represent: {
    lowercase: function(object) {
      return object ? "true" : "false";
    },
    uppercase: function(object) {
      return object ? "TRUE" : "FALSE";
    },
    camelcase: function(object) {
      return object ? "True" : "False";
    }
  },
  defaultStyle: "lowercase"
});
function isHexCode(c2) {
  return 48 <= c2 && c2 <= 57 || 65 <= c2 && c2 <= 70 || 97 <= c2 && c2 <= 102;
}
function isOctCode(c2) {
  return 48 <= c2 && c2 <= 55;
}
function isDecCode(c2) {
  return 48 <= c2 && c2 <= 57;
}
function resolveYamlInteger(data) {
  if (data === null)
    return false;
  var max = data.length, index = 0, hasDigits = false, ch;
  if (!max)
    return false;
  ch = data[index];
  if (ch === "-" || ch === "+") {
    ch = data[++index];
  }
  if (ch === "0") {
    if (index + 1 === max)
      return true;
    ch = data[++index];
    if (ch === "b") {
      index++;
      for (; index < max; index++) {
        ch = data[index];
        if (ch === "_")
          continue;
        if (ch !== "0" && ch !== "1")
          return false;
        hasDigits = true;
      }
      return hasDigits && ch !== "_";
    }
    if (ch === "x") {
      index++;
      for (; index < max; index++) {
        ch = data[index];
        if (ch === "_")
          continue;
        if (!isHexCode(data.charCodeAt(index)))
          return false;
        hasDigits = true;
      }
      return hasDigits && ch !== "_";
    }
    if (ch === "o") {
      index++;
      for (; index < max; index++) {
        ch = data[index];
        if (ch === "_")
          continue;
        if (!isOctCode(data.charCodeAt(index)))
          return false;
        hasDigits = true;
      }
      return hasDigits && ch !== "_";
    }
  }
  if (ch === "_")
    return false;
  for (; index < max; index++) {
    ch = data[index];
    if (ch === "_")
      continue;
    if (!isDecCode(data.charCodeAt(index))) {
      return false;
    }
    hasDigits = true;
  }
  if (!hasDigits || ch === "_")
    return false;
  return true;
}
function constructYamlInteger(data) {
  var value = data, sign = 1, ch;
  if (value.indexOf("_") !== -1) {
    value = value.replace(/_/g, "");
  }
  ch = value[0];
  if (ch === "-" || ch === "+") {
    if (ch === "-")
      sign = -1;
    value = value.slice(1);
    ch = value[0];
  }
  if (value === "0")
    return 0;
  if (ch === "0") {
    if (value[1] === "b")
      return sign * parseInt(value.slice(2), 2);
    if (value[1] === "x")
      return sign * parseInt(value.slice(2), 16);
    if (value[1] === "o")
      return sign * parseInt(value.slice(2), 8);
  }
  return sign * parseInt(value, 10);
}
function isInteger(object) {
  return Object.prototype.toString.call(object) === "[object Number]" && (object % 1 === 0 && !common.isNegativeZero(object));
}
var int = new type2("tag:yaml.org,2002:int", {
  kind: "scalar",
  resolve: resolveYamlInteger,
  construct: constructYamlInteger,
  predicate: isInteger,
  represent: {
    binary: function(obj) {
      return obj >= 0 ? "0b" + obj.toString(2) : "-0b" + obj.toString(2).slice(1);
    },
    octal: function(obj) {
      return obj >= 0 ? "0o" + obj.toString(8) : "-0o" + obj.toString(8).slice(1);
    },
    decimal: function(obj) {
      return obj.toString(10);
    },
    hexadecimal: function(obj) {
      return obj >= 0 ? "0x" + obj.toString(16).toUpperCase() : "-0x" + obj.toString(16).toUpperCase().slice(1);
    }
  },
  defaultStyle: "decimal",
  styleAliases: {
    binary: [2, "bin"],
    octal: [8, "oct"],
    decimal: [10, "dec"],
    hexadecimal: [16, "hex"]
  }
});
var YAML_FLOAT_PATTERN = new RegExp("^(?:[-+]?(?:[0-9][0-9_]*)(?:\\.[0-9_]*)?(?:[eE][-+]?[0-9]+)?|\\.[0-9_]+(?:[eE][-+]?[0-9]+)?|[-+]?\\.(?:inf|Inf|INF)|\\.(?:nan|NaN|NAN))$");
function resolveYamlFloat(data) {
  if (data === null)
    return false;
  if (!YAML_FLOAT_PATTERN.test(data) || data[data.length - 1] === "_") {
    return false;
  }
  return true;
}
function constructYamlFloat(data) {
  var value, sign;
  value = data.replace(/_/g, "").toLowerCase();
  sign = value[0] === "-" ? -1 : 1;
  if ("+-".indexOf(value[0]) >= 0) {
    value = value.slice(1);
  }
  if (value === ".inf") {
    return sign === 1 ? Number.POSITIVE_INFINITY : Number.NEGATIVE_INFINITY;
  } else if (value === ".nan") {
    return NaN;
  }
  return sign * parseFloat(value, 10);
}
var SCIENTIFIC_WITHOUT_DOT = /^[-+]?[0-9]+e/;
function representYamlFloat(object, style) {
  var res;
  if (isNaN(object)) {
    switch (style) {
      case "lowercase":
        return ".nan";
      case "uppercase":
        return ".NAN";
      case "camelcase":
        return ".NaN";
    }
  } else if (Number.POSITIVE_INFINITY === object) {
    switch (style) {
      case "lowercase":
        return ".inf";
      case "uppercase":
        return ".INF";
      case "camelcase":
        return ".Inf";
    }
  } else if (Number.NEGATIVE_INFINITY === object) {
    switch (style) {
      case "lowercase":
        return "-.inf";
      case "uppercase":
        return "-.INF";
      case "camelcase":
        return "-.Inf";
    }
  } else if (common.isNegativeZero(object)) {
    return "-0.0";
  }
  res = object.toString(10);
  return SCIENTIFIC_WITHOUT_DOT.test(res) ? res.replace("e", ".e") : res;
}
function isFloat(object) {
  return Object.prototype.toString.call(object) === "[object Number]" && (object % 1 !== 0 || common.isNegativeZero(object));
}
var float = new type2("tag:yaml.org,2002:float", {
  kind: "scalar",
  resolve: resolveYamlFloat,
  construct: constructYamlFloat,
  predicate: isFloat,
  represent: representYamlFloat,
  defaultStyle: "lowercase"
});
var json = failsafe.extend({
  implicit: [
    _null,
    bool,
    int,
    float
  ]
});
var core = json;
var YAML_DATE_REGEXP = new RegExp("^([0-9][0-9][0-9][0-9])-([0-9][0-9])-([0-9][0-9])$");
var YAML_TIMESTAMP_REGEXP = new RegExp("^([0-9][0-9][0-9][0-9])-([0-9][0-9]?)-([0-9][0-9]?)(?:[Tt]|[ \\t]+)([0-9][0-9]?):([0-9][0-9]):([0-9][0-9])(?:\\.([0-9]*))?(?:[ \\t]*(Z|([-+])([0-9][0-9]?)(?::([0-9][0-9]))?))?$");
function resolveYamlTimestamp(data) {
  if (data === null)
    return false;
  if (YAML_DATE_REGEXP.exec(data) !== null)
    return true;
  if (YAML_TIMESTAMP_REGEXP.exec(data) !== null)
    return true;
  return false;
}
function constructYamlTimestamp(data) {
  var match, year, month, day, hour, minute, second, fraction = 0, delta = null, tz_hour, tz_minute, date;
  match = YAML_DATE_REGEXP.exec(data);
  if (match === null)
    match = YAML_TIMESTAMP_REGEXP.exec(data);
  if (match === null)
    throw new Error("Date resolve error");
  year = +match[1];
  month = +match[2] - 1;
  day = +match[3];
  if (!match[4]) {
    return new Date(Date.UTC(year, month, day));
  }
  hour = +match[4];
  minute = +match[5];
  second = +match[6];
  if (match[7]) {
    fraction = match[7].slice(0, 3);
    while (fraction.length < 3) {
      fraction += "0";
    }
    fraction = +fraction;
  }
  if (match[9]) {
    tz_hour = +match[10];
    tz_minute = +(match[11] || 0);
    delta = (tz_hour * 60 + tz_minute) * 6e4;
    if (match[9] === "-")
      delta = -delta;
  }
  date = new Date(Date.UTC(year, month, day, hour, minute, second, fraction));
  if (delta)
    date.setTime(date.getTime() - delta);
  return date;
}
function representYamlTimestamp(object) {
  return object.toISOString();
}
var timestamp = new type2("tag:yaml.org,2002:timestamp", {
  kind: "scalar",
  resolve: resolveYamlTimestamp,
  construct: constructYamlTimestamp,
  instanceOf: Date,
  represent: representYamlTimestamp
});
function resolveYamlMerge(data) {
  return data === "<<" || data === null;
}
var merge = new type2("tag:yaml.org,2002:merge", {
  kind: "scalar",
  resolve: resolveYamlMerge
});
var BASE64_MAP = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=\n\r";
function resolveYamlBinary(data) {
  if (data === null)
    return false;
  var code, idx, bitlen = 0, max = data.length, map2 = BASE64_MAP;
  for (idx = 0; idx < max; idx++) {
    code = map2.indexOf(data.charAt(idx));
    if (code > 64)
      continue;
    if (code < 0)
      return false;
    bitlen += 6;
  }
  return bitlen % 8 === 0;
}
function constructYamlBinary(data) {
  var idx, tailbits, input = data.replace(/[\r\n=]/g, ""), max = input.length, map2 = BASE64_MAP, bits = 0, result2 = [];
  for (idx = 0; idx < max; idx++) {
    if (idx % 4 === 0 && idx) {
      result2.push(bits >> 16 & 255);
      result2.push(bits >> 8 & 255);
      result2.push(bits & 255);
    }
    bits = bits << 6 | map2.indexOf(input.charAt(idx));
  }
  tailbits = max % 4 * 6;
  if (tailbits === 0) {
    result2.push(bits >> 16 & 255);
    result2.push(bits >> 8 & 255);
    result2.push(bits & 255);
  } else if (tailbits === 18) {
    result2.push(bits >> 10 & 255);
    result2.push(bits >> 2 & 255);
  } else if (tailbits === 12) {
    result2.push(bits >> 4 & 255);
  }
  return new Uint8Array(result2);
}
function representYamlBinary(object) {
  var result2 = "", bits = 0, idx, tail, max = object.length, map2 = BASE64_MAP;
  for (idx = 0; idx < max; idx++) {
    if (idx % 3 === 0 && idx) {
      result2 += map2[bits >> 18 & 63];
      result2 += map2[bits >> 12 & 63];
      result2 += map2[bits >> 6 & 63];
      result2 += map2[bits & 63];
    }
    bits = (bits << 8) + object[idx];
  }
  tail = max % 3;
  if (tail === 0) {
    result2 += map2[bits >> 18 & 63];
    result2 += map2[bits >> 12 & 63];
    result2 += map2[bits >> 6 & 63];
    result2 += map2[bits & 63];
  } else if (tail === 2) {
    result2 += map2[bits >> 10 & 63];
    result2 += map2[bits >> 4 & 63];
    result2 += map2[bits << 2 & 63];
    result2 += map2[64];
  } else if (tail === 1) {
    result2 += map2[bits >> 2 & 63];
    result2 += map2[bits << 4 & 63];
    result2 += map2[64];
    result2 += map2[64];
  }
  return result2;
}
function isBinary(obj) {
  return Object.prototype.toString.call(obj) === "[object Uint8Array]";
}
var binary = new type2("tag:yaml.org,2002:binary", {
  kind: "scalar",
  resolve: resolveYamlBinary,
  construct: constructYamlBinary,
  predicate: isBinary,
  represent: representYamlBinary
});
var _hasOwnProperty$3 = Object.prototype.hasOwnProperty;
var _toString$2 = Object.prototype.toString;
function resolveYamlOmap(data) {
  if (data === null)
    return true;
  var objectKeys = [], index, length, pair, pairKey, pairHasKey, object = data;
  for (index = 0, length = object.length; index < length; index += 1) {
    pair = object[index];
    pairHasKey = false;
    if (_toString$2.call(pair) !== "[object Object]")
      return false;
    for (pairKey in pair) {
      if (_hasOwnProperty$3.call(pair, pairKey)) {
        if (!pairHasKey)
          pairHasKey = true;
        else
          return false;
      }
    }
    if (!pairHasKey)
      return false;
    if (objectKeys.indexOf(pairKey) === -1)
      objectKeys.push(pairKey);
    else
      return false;
  }
  return true;
}
function constructYamlOmap(data) {
  return data !== null ? data : [];
}
var omap = new type2("tag:yaml.org,2002:omap", {
  kind: "sequence",
  resolve: resolveYamlOmap,
  construct: constructYamlOmap
});
var _toString$1 = Object.prototype.toString;
function resolveYamlPairs(data) {
  if (data === null)
    return true;
  var index, length, pair, keys, result2, object = data;
  result2 = new Array(object.length);
  for (index = 0, length = object.length; index < length; index += 1) {
    pair = object[index];
    if (_toString$1.call(pair) !== "[object Object]")
      return false;
    keys = Object.keys(pair);
    if (keys.length !== 1)
      return false;
    result2[index] = [keys[0], pair[keys[0]]];
  }
  return true;
}
function constructYamlPairs(data) {
  if (data === null)
    return [];
  var index, length, pair, keys, result2, object = data;
  result2 = new Array(object.length);
  for (index = 0, length = object.length; index < length; index += 1) {
    pair = object[index];
    keys = Object.keys(pair);
    result2[index] = [keys[0], pair[keys[0]]];
  }
  return result2;
}
var pairs = new type2("tag:yaml.org,2002:pairs", {
  kind: "sequence",
  resolve: resolveYamlPairs,
  construct: constructYamlPairs
});
var _hasOwnProperty$2 = Object.prototype.hasOwnProperty;
function resolveYamlSet(data) {
  if (data === null)
    return true;
  var key2, object = data;
  for (key2 in object) {
    if (_hasOwnProperty$2.call(object, key2)) {
      if (object[key2] !== null)
        return false;
    }
  }
  return true;
}
function constructYamlSet(data) {
  return data !== null ? data : {};
}
var set = new type2("tag:yaml.org,2002:set", {
  kind: "mapping",
  resolve: resolveYamlSet,
  construct: constructYamlSet
});
var _default = core.extend({
  implicit: [
    timestamp,
    merge
  ],
  explicit: [
    binary,
    omap,
    pairs,
    set
  ]
});
var _hasOwnProperty$1 = Object.prototype.hasOwnProperty;
var CONTEXT_FLOW_IN = 1;
var CONTEXT_FLOW_OUT = 2;
var CONTEXT_BLOCK_IN = 3;
var CONTEXT_BLOCK_OUT = 4;
var CHOMPING_CLIP = 1;
var CHOMPING_STRIP = 2;
var CHOMPING_KEEP = 3;
var PATTERN_NON_PRINTABLE = /[\x00-\x08\x0B\x0C\x0E-\x1F\x7F-\x84\x86-\x9F\uFFFE\uFFFF]|[\uD800-\uDBFF](?![\uDC00-\uDFFF])|(?:[^\uD800-\uDBFF]|^)[\uDC00-\uDFFF]/;
var PATTERN_NON_ASCII_LINE_BREAKS = /[\x85\u2028\u2029]/;
var PATTERN_FLOW_INDICATORS = /[,\[\]\{\}]/;
var PATTERN_TAG_HANDLE = /^(?:!|!!|![a-z\-]+!)$/i;
var PATTERN_TAG_URI = /^(?:!|[^,\[\]\{\}])(?:%[0-9a-f]{2}|[0-9a-z\-#;\/\?:@&=\+\$,_\.!~\*'\(\)\[\]])*$/i;
function _class(obj) {
  return Object.prototype.toString.call(obj);
}
function is_EOL(c2) {
  return c2 === 10 || c2 === 13;
}
function is_WHITE_SPACE(c2) {
  return c2 === 9 || c2 === 32;
}
function is_WS_OR_EOL(c2) {
  return c2 === 9 || c2 === 32 || c2 === 10 || c2 === 13;
}
function is_FLOW_INDICATOR(c2) {
  return c2 === 44 || c2 === 91 || c2 === 93 || c2 === 123 || c2 === 125;
}
function fromHexCode(c2) {
  var lc;
  if (48 <= c2 && c2 <= 57) {
    return c2 - 48;
  }
  lc = c2 | 32;
  if (97 <= lc && lc <= 102) {
    return lc - 97 + 10;
  }
  return -1;
}
function escapedHexLen(c2) {
  if (c2 === 120) {
    return 2;
  }
  if (c2 === 117) {
    return 4;
  }
  if (c2 === 85) {
    return 8;
  }
  return 0;
}
function fromDecimalCode(c2) {
  if (48 <= c2 && c2 <= 57) {
    return c2 - 48;
  }
  return -1;
}
function simpleEscapeSequence(c2) {
  return c2 === 48 ? "\0" : c2 === 97 ? "\x07" : c2 === 98 ? "\b" : c2 === 116 ? "	" : c2 === 9 ? "	" : c2 === 110 ? "\n" : c2 === 118 ? "\v" : c2 === 102 ? "\f" : c2 === 114 ? "\r" : c2 === 101 ? "" : c2 === 32 ? " " : c2 === 34 ? '"' : c2 === 47 ? "/" : c2 === 92 ? "\\" : c2 === 78 ? "\x85" : c2 === 95 ? "\xA0" : c2 === 76 ? "\u2028" : c2 === 80 ? "\u2029" : "";
}
function charFromCodepoint(c2) {
  if (c2 <= 65535) {
    return String.fromCharCode(c2);
  }
  return String.fromCharCode((c2 - 65536 >> 10) + 55296, (c2 - 65536 & 1023) + 56320);
}
var simpleEscapeCheck = new Array(256);
var simpleEscapeMap = new Array(256);
for (i3 = 0; i3 < 256; i3++) {
  simpleEscapeCheck[i3] = simpleEscapeSequence(i3) ? 1 : 0;
  simpleEscapeMap[i3] = simpleEscapeSequence(i3);
}
var i3;
function State$1(input, options) {
  this.input = input;
  this.filename = options["filename"] || null;
  this.schema = options["schema"] || _default;
  this.onWarning = options["onWarning"] || null;
  this.legacy = options["legacy"] || false;
  this.json = options["json"] || false;
  this.listener = options["listener"] || null;
  this.implicitTypes = this.schema.compiledImplicit;
  this.typeMap = this.schema.compiledTypeMap;
  this.length = input.length;
  this.position = 0;
  this.line = 0;
  this.lineStart = 0;
  this.lineIndent = 0;
  this.firstTabInLine = -1;
  this.documents = [];
}
function generateError(state, message) {
  var mark = {
    name: state.filename,
    buffer: state.input.slice(0, -1),
    position: state.position,
    line: state.line,
    column: state.position - state.lineStart
  };
  mark.snippet = snippet(mark);
  return new exception(message, mark);
}
function throwError2(state, message) {
  throw generateError(state, message);
}
function throwWarning(state, message) {
  if (state.onWarning) {
    state.onWarning.call(null, generateError(state, message));
  }
}
var directiveHandlers = {
  YAML: function handleYamlDirective(state, name, args) {
    var match, major, minor;
    if (state.version !== null) {
      throwError2(state, "duplication of %YAML directive");
    }
    if (args.length !== 1) {
      throwError2(state, "YAML directive accepts exactly one argument");
    }
    match = /^([0-9]+)\.([0-9]+)$/.exec(args[0]);
    if (match === null) {
      throwError2(state, "ill-formed argument of the YAML directive");
    }
    major = parseInt(match[1], 10);
    minor = parseInt(match[2], 10);
    if (major !== 1) {
      throwError2(state, "unacceptable YAML version of the document");
    }
    state.version = args[0];
    state.checkLineBreaks = minor < 2;
    if (minor !== 1 && minor !== 2) {
      throwWarning(state, "unsupported YAML version of the document");
    }
  },
  TAG: function handleTagDirective(state, name, args) {
    var handle, prefix2;
    if (args.length !== 2) {
      throwError2(state, "TAG directive accepts exactly two arguments");
    }
    handle = args[0];
    prefix2 = args[1];
    if (!PATTERN_TAG_HANDLE.test(handle)) {
      throwError2(state, "ill-formed tag handle (first argument) of the TAG directive");
    }
    if (_hasOwnProperty$1.call(state.tagMap, handle)) {
      throwError2(state, 'there is a previously declared suffix for "' + handle + '" tag handle');
    }
    if (!PATTERN_TAG_URI.test(prefix2)) {
      throwError2(state, "ill-formed tag prefix (second argument) of the TAG directive");
    }
    try {
      prefix2 = decodeURIComponent(prefix2);
    } catch (err2) {
      throwError2(state, "tag prefix is malformed: " + prefix2);
    }
    state.tagMap[handle] = prefix2;
  }
};
function captureSegment(state, start, end, checkJson) {
  var _position, _length, _character, _result;
  if (start < end) {
    _result = state.input.slice(start, end);
    if (checkJson) {
      for (_position = 0, _length = _result.length; _position < _length; _position += 1) {
        _character = _result.charCodeAt(_position);
        if (!(_character === 9 || 32 <= _character && _character <= 1114111)) {
          throwError2(state, "expected valid JSON character");
        }
      }
    } else if (PATTERN_NON_PRINTABLE.test(_result)) {
      throwError2(state, "the stream contains non-printable characters");
    }
    state.result += _result;
  }
}
function mergeMappings(state, destination, source, overridableKeys) {
  var sourceKeys, key2, index, quantity;
  if (!common.isObject(source)) {
    throwError2(state, "cannot merge mappings; the provided source object is unacceptable");
  }
  sourceKeys = Object.keys(source);
  for (index = 0, quantity = sourceKeys.length; index < quantity; index += 1) {
    key2 = sourceKeys[index];
    if (!_hasOwnProperty$1.call(destination, key2)) {
      destination[key2] = source[key2];
      overridableKeys[key2] = true;
    }
  }
}
function storeMappingPair(state, _result, overridableKeys, keyTag, keyNode, valueNode, startLine, startLineStart, startPos) {
  var index, quantity;
  if (Array.isArray(keyNode)) {
    keyNode = Array.prototype.slice.call(keyNode);
    for (index = 0, quantity = keyNode.length; index < quantity; index += 1) {
      if (Array.isArray(keyNode[index])) {
        throwError2(state, "nested arrays are not supported inside keys");
      }
      if (typeof keyNode === "object" && _class(keyNode[index]) === "[object Object]") {
        keyNode[index] = "[object Object]";
      }
    }
  }
  if (typeof keyNode === "object" && _class(keyNode) === "[object Object]") {
    keyNode = "[object Object]";
  }
  keyNode = String(keyNode);
  if (_result === null) {
    _result = {};
  }
  if (keyTag === "tag:yaml.org,2002:merge") {
    if (Array.isArray(valueNode)) {
      for (index = 0, quantity = valueNode.length; index < quantity; index += 1) {
        mergeMappings(state, _result, valueNode[index], overridableKeys);
      }
    } else {
      mergeMappings(state, _result, valueNode, overridableKeys);
    }
  } else {
    if (!state.json && !_hasOwnProperty$1.call(overridableKeys, keyNode) && _hasOwnProperty$1.call(_result, keyNode)) {
      state.line = startLine || state.line;
      state.lineStart = startLineStart || state.lineStart;
      state.position = startPos || state.position;
      throwError2(state, "duplicated mapping key");
    }
    if (keyNode === "__proto__") {
      Object.defineProperty(_result, keyNode, {
        configurable: true,
        enumerable: true,
        writable: true,
        value: valueNode
      });
    } else {
      _result[keyNode] = valueNode;
    }
    delete overridableKeys[keyNode];
  }
  return _result;
}
function readLineBreak(state) {
  var ch;
  ch = state.input.charCodeAt(state.position);
  if (ch === 10) {
    state.position++;
  } else if (ch === 13) {
    state.position++;
    if (state.input.charCodeAt(state.position) === 10) {
      state.position++;
    }
  } else {
    throwError2(state, "a line break is expected");
  }
  state.line += 1;
  state.lineStart = state.position;
  state.firstTabInLine = -1;
}
function skipSeparationSpace(state, allowComments, checkIndent) {
  var lineBreaks = 0, ch = state.input.charCodeAt(state.position);
  while (ch !== 0) {
    while (is_WHITE_SPACE(ch)) {
      if (ch === 9 && state.firstTabInLine === -1) {
        state.firstTabInLine = state.position;
      }
      ch = state.input.charCodeAt(++state.position);
    }
    if (allowComments && ch === 35) {
      do {
        ch = state.input.charCodeAt(++state.position);
      } while (ch !== 10 && ch !== 13 && ch !== 0);
    }
    if (is_EOL(ch)) {
      readLineBreak(state);
      ch = state.input.charCodeAt(state.position);
      lineBreaks++;
      state.lineIndent = 0;
      while (ch === 32) {
        state.lineIndent++;
        ch = state.input.charCodeAt(++state.position);
      }
    } else {
      break;
    }
  }
  if (checkIndent !== -1 && lineBreaks !== 0 && state.lineIndent < checkIndent) {
    throwWarning(state, "deficient indentation");
  }
  return lineBreaks;
}
function testDocumentSeparator(state) {
  var _position = state.position, ch;
  ch = state.input.charCodeAt(_position);
  if ((ch === 45 || ch === 46) && ch === state.input.charCodeAt(_position + 1) && ch === state.input.charCodeAt(_position + 2)) {
    _position += 3;
    ch = state.input.charCodeAt(_position);
    if (ch === 0 || is_WS_OR_EOL(ch)) {
      return true;
    }
  }
  return false;
}
function writeFoldedLines(state, count) {
  if (count === 1) {
    state.result += " ";
  } else if (count > 1) {
    state.result += common.repeat("\n", count - 1);
  }
}
function readPlainScalar(state, nodeIndent, withinFlowCollection) {
  var preceding, following, captureStart, captureEnd, hasPendingContent, _line, _lineStart, _lineIndent, _kind = state.kind, _result = state.result, ch;
  ch = state.input.charCodeAt(state.position);
  if (is_WS_OR_EOL(ch) || is_FLOW_INDICATOR(ch) || ch === 35 || ch === 38 || ch === 42 || ch === 33 || ch === 124 || ch === 62 || ch === 39 || ch === 34 || ch === 37 || ch === 64 || ch === 96) {
    return false;
  }
  if (ch === 63 || ch === 45) {
    following = state.input.charCodeAt(state.position + 1);
    if (is_WS_OR_EOL(following) || withinFlowCollection && is_FLOW_INDICATOR(following)) {
      return false;
    }
  }
  state.kind = "scalar";
  state.result = "";
  captureStart = captureEnd = state.position;
  hasPendingContent = false;
  while (ch !== 0) {
    if (ch === 58) {
      following = state.input.charCodeAt(state.position + 1);
      if (is_WS_OR_EOL(following) || withinFlowCollection && is_FLOW_INDICATOR(following)) {
        break;
      }
    } else if (ch === 35) {
      preceding = state.input.charCodeAt(state.position - 1);
      if (is_WS_OR_EOL(preceding)) {
        break;
      }
    } else if (state.position === state.lineStart && testDocumentSeparator(state) || withinFlowCollection && is_FLOW_INDICATOR(ch)) {
      break;
    } else if (is_EOL(ch)) {
      _line = state.line;
      _lineStart = state.lineStart;
      _lineIndent = state.lineIndent;
      skipSeparationSpace(state, false, -1);
      if (state.lineIndent >= nodeIndent) {
        hasPendingContent = true;
        ch = state.input.charCodeAt(state.position);
        continue;
      } else {
        state.position = captureEnd;
        state.line = _line;
        state.lineStart = _lineStart;
        state.lineIndent = _lineIndent;
        break;
      }
    }
    if (hasPendingContent) {
      captureSegment(state, captureStart, captureEnd, false);
      writeFoldedLines(state, state.line - _line);
      captureStart = captureEnd = state.position;
      hasPendingContent = false;
    }
    if (!is_WHITE_SPACE(ch)) {
      captureEnd = state.position + 1;
    }
    ch = state.input.charCodeAt(++state.position);
  }
  captureSegment(state, captureStart, captureEnd, false);
  if (state.result) {
    return true;
  }
  state.kind = _kind;
  state.result = _result;
  return false;
}
function readSingleQuotedScalar(state, nodeIndent) {
  var ch, captureStart, captureEnd;
  ch = state.input.charCodeAt(state.position);
  if (ch !== 39) {
    return false;
  }
  state.kind = "scalar";
  state.result = "";
  state.position++;
  captureStart = captureEnd = state.position;
  while ((ch = state.input.charCodeAt(state.position)) !== 0) {
    if (ch === 39) {
      captureSegment(state, captureStart, state.position, true);
      ch = state.input.charCodeAt(++state.position);
      if (ch === 39) {
        captureStart = state.position;
        state.position++;
        captureEnd = state.position;
      } else {
        return true;
      }
    } else if (is_EOL(ch)) {
      captureSegment(state, captureStart, captureEnd, true);
      writeFoldedLines(state, skipSeparationSpace(state, false, nodeIndent));
      captureStart = captureEnd = state.position;
    } else if (state.position === state.lineStart && testDocumentSeparator(state)) {
      throwError2(state, "unexpected end of the document within a single quoted scalar");
    } else {
      state.position++;
      captureEnd = state.position;
    }
  }
  throwError2(state, "unexpected end of the stream within a single quoted scalar");
}
function readDoubleQuotedScalar(state, nodeIndent) {
  var captureStart, captureEnd, hexLength, hexResult, tmp, ch;
  ch = state.input.charCodeAt(state.position);
  if (ch !== 34) {
    return false;
  }
  state.kind = "scalar";
  state.result = "";
  state.position++;
  captureStart = captureEnd = state.position;
  while ((ch = state.input.charCodeAt(state.position)) !== 0) {
    if (ch === 34) {
      captureSegment(state, captureStart, state.position, true);
      state.position++;
      return true;
    } else if (ch === 92) {
      captureSegment(state, captureStart, state.position, true);
      ch = state.input.charCodeAt(++state.position);
      if (is_EOL(ch)) {
        skipSeparationSpace(state, false, nodeIndent);
      } else if (ch < 256 && simpleEscapeCheck[ch]) {
        state.result += simpleEscapeMap[ch];
        state.position++;
      } else if ((tmp = escapedHexLen(ch)) > 0) {
        hexLength = tmp;
        hexResult = 0;
        for (; hexLength > 0; hexLength--) {
          ch = state.input.charCodeAt(++state.position);
          if ((tmp = fromHexCode(ch)) >= 0) {
            hexResult = (hexResult << 4) + tmp;
          } else {
            throwError2(state, "expected hexadecimal character");
          }
        }
        state.result += charFromCodepoint(hexResult);
        state.position++;
      } else {
        throwError2(state, "unknown escape sequence");
      }
      captureStart = captureEnd = state.position;
    } else if (is_EOL(ch)) {
      captureSegment(state, captureStart, captureEnd, true);
      writeFoldedLines(state, skipSeparationSpace(state, false, nodeIndent));
      captureStart = captureEnd = state.position;
    } else if (state.position === state.lineStart && testDocumentSeparator(state)) {
      throwError2(state, "unexpected end of the document within a double quoted scalar");
    } else {
      state.position++;
      captureEnd = state.position;
    }
  }
  throwError2(state, "unexpected end of the stream within a double quoted scalar");
}
function readFlowCollection(state, nodeIndent) {
  var readNext = true, _line, _lineStart, _pos, _tag = state.tag, _result, _anchor = state.anchor, following, terminator, isPair, isExplicitPair, isMapping, overridableKeys = Object.create(null), keyNode, keyTag, valueNode, ch;
  ch = state.input.charCodeAt(state.position);
  if (ch === 91) {
    terminator = 93;
    isMapping = false;
    _result = [];
  } else if (ch === 123) {
    terminator = 125;
    isMapping = true;
    _result = {};
  } else {
    return false;
  }
  if (state.anchor !== null) {
    state.anchorMap[state.anchor] = _result;
  }
  ch = state.input.charCodeAt(++state.position);
  while (ch !== 0) {
    skipSeparationSpace(state, true, nodeIndent);
    ch = state.input.charCodeAt(state.position);
    if (ch === terminator) {
      state.position++;
      state.tag = _tag;
      state.anchor = _anchor;
      state.kind = isMapping ? "mapping" : "sequence";
      state.result = _result;
      return true;
    } else if (!readNext) {
      throwError2(state, "missed comma between flow collection entries");
    } else if (ch === 44) {
      throwError2(state, "expected the node content, but found ','");
    }
    keyTag = keyNode = valueNode = null;
    isPair = isExplicitPair = false;
    if (ch === 63) {
      following = state.input.charCodeAt(state.position + 1);
      if (is_WS_OR_EOL(following)) {
        isPair = isExplicitPair = true;
        state.position++;
        skipSeparationSpace(state, true, nodeIndent);
      }
    }
    _line = state.line;
    _lineStart = state.lineStart;
    _pos = state.position;
    composeNode(state, nodeIndent, CONTEXT_FLOW_IN, false, true);
    keyTag = state.tag;
    keyNode = state.result;
    skipSeparationSpace(state, true, nodeIndent);
    ch = state.input.charCodeAt(state.position);
    if ((isExplicitPair || state.line === _line) && ch === 58) {
      isPair = true;
      ch = state.input.charCodeAt(++state.position);
      skipSeparationSpace(state, true, nodeIndent);
      composeNode(state, nodeIndent, CONTEXT_FLOW_IN, false, true);
      valueNode = state.result;
    }
    if (isMapping) {
      storeMappingPair(state, _result, overridableKeys, keyTag, keyNode, valueNode, _line, _lineStart, _pos);
    } else if (isPair) {
      _result.push(storeMappingPair(state, null, overridableKeys, keyTag, keyNode, valueNode, _line, _lineStart, _pos));
    } else {
      _result.push(keyNode);
    }
    skipSeparationSpace(state, true, nodeIndent);
    ch = state.input.charCodeAt(state.position);
    if (ch === 44) {
      readNext = true;
      ch = state.input.charCodeAt(++state.position);
    } else {
      readNext = false;
    }
  }
  throwError2(state, "unexpected end of the stream within a flow collection");
}
function readBlockScalar(state, nodeIndent) {
  var captureStart, folding, chomping = CHOMPING_CLIP, didReadContent = false, detectedIndent = false, textIndent = nodeIndent, emptyLines = 0, atMoreIndented = false, tmp, ch;
  ch = state.input.charCodeAt(state.position);
  if (ch === 124) {
    folding = false;
  } else if (ch === 62) {
    folding = true;
  } else {
    return false;
  }
  state.kind = "scalar";
  state.result = "";
  while (ch !== 0) {
    ch = state.input.charCodeAt(++state.position);
    if (ch === 43 || ch === 45) {
      if (CHOMPING_CLIP === chomping) {
        chomping = ch === 43 ? CHOMPING_KEEP : CHOMPING_STRIP;
      } else {
        throwError2(state, "repeat of a chomping mode identifier");
      }
    } else if ((tmp = fromDecimalCode(ch)) >= 0) {
      if (tmp === 0) {
        throwError2(state, "bad explicit indentation width of a block scalar; it cannot be less than one");
      } else if (!detectedIndent) {
        textIndent = nodeIndent + tmp - 1;
        detectedIndent = true;
      } else {
        throwError2(state, "repeat of an indentation width identifier");
      }
    } else {
      break;
    }
  }
  if (is_WHITE_SPACE(ch)) {
    do {
      ch = state.input.charCodeAt(++state.position);
    } while (is_WHITE_SPACE(ch));
    if (ch === 35) {
      do {
        ch = state.input.charCodeAt(++state.position);
      } while (!is_EOL(ch) && ch !== 0);
    }
  }
  while (ch !== 0) {
    readLineBreak(state);
    state.lineIndent = 0;
    ch = state.input.charCodeAt(state.position);
    while ((!detectedIndent || state.lineIndent < textIndent) && ch === 32) {
      state.lineIndent++;
      ch = state.input.charCodeAt(++state.position);
    }
    if (!detectedIndent && state.lineIndent > textIndent) {
      textIndent = state.lineIndent;
    }
    if (is_EOL(ch)) {
      emptyLines++;
      continue;
    }
    if (state.lineIndent < textIndent) {
      if (chomping === CHOMPING_KEEP) {
        state.result += common.repeat("\n", didReadContent ? 1 + emptyLines : emptyLines);
      } else if (chomping === CHOMPING_CLIP) {
        if (didReadContent) {
          state.result += "\n";
        }
      }
      break;
    }
    if (folding) {
      if (is_WHITE_SPACE(ch)) {
        atMoreIndented = true;
        state.result += common.repeat("\n", didReadContent ? 1 + emptyLines : emptyLines);
      } else if (atMoreIndented) {
        atMoreIndented = false;
        state.result += common.repeat("\n", emptyLines + 1);
      } else if (emptyLines === 0) {
        if (didReadContent) {
          state.result += " ";
        }
      } else {
        state.result += common.repeat("\n", emptyLines);
      }
    } else {
      state.result += common.repeat("\n", didReadContent ? 1 + emptyLines : emptyLines);
    }
    didReadContent = true;
    detectedIndent = true;
    emptyLines = 0;
    captureStart = state.position;
    while (!is_EOL(ch) && ch !== 0) {
      ch = state.input.charCodeAt(++state.position);
    }
    captureSegment(state, captureStart, state.position, false);
  }
  return true;
}
function readBlockSequence(state, nodeIndent) {
  var _line, _tag = state.tag, _anchor = state.anchor, _result = [], following, detected = false, ch;
  if (state.firstTabInLine !== -1)
    return false;
  if (state.anchor !== null) {
    state.anchorMap[state.anchor] = _result;
  }
  ch = state.input.charCodeAt(state.position);
  while (ch !== 0) {
    if (state.firstTabInLine !== -1) {
      state.position = state.firstTabInLine;
      throwError2(state, "tab characters must not be used in indentation");
    }
    if (ch !== 45) {
      break;
    }
    following = state.input.charCodeAt(state.position + 1);
    if (!is_WS_OR_EOL(following)) {
      break;
    }
    detected = true;
    state.position++;
    if (skipSeparationSpace(state, true, -1)) {
      if (state.lineIndent <= nodeIndent) {
        _result.push(null);
        ch = state.input.charCodeAt(state.position);
        continue;
      }
    }
    _line = state.line;
    composeNode(state, nodeIndent, CONTEXT_BLOCK_IN, false, true);
    _result.push(state.result);
    skipSeparationSpace(state, true, -1);
    ch = state.input.charCodeAt(state.position);
    if ((state.line === _line || state.lineIndent > nodeIndent) && ch !== 0) {
      throwError2(state, "bad indentation of a sequence entry");
    } else if (state.lineIndent < nodeIndent) {
      break;
    }
  }
  if (detected) {
    state.tag = _tag;
    state.anchor = _anchor;
    state.kind = "sequence";
    state.result = _result;
    return true;
  }
  return false;
}
function readBlockMapping(state, nodeIndent, flowIndent) {
  var following, allowCompact, _line, _keyLine, _keyLineStart, _keyPos, _tag = state.tag, _anchor = state.anchor, _result = {}, overridableKeys = Object.create(null), keyTag = null, keyNode = null, valueNode = null, atExplicitKey = false, detected = false, ch;
  if (state.firstTabInLine !== -1)
    return false;
  if (state.anchor !== null) {
    state.anchorMap[state.anchor] = _result;
  }
  ch = state.input.charCodeAt(state.position);
  while (ch !== 0) {
    if (!atExplicitKey && state.firstTabInLine !== -1) {
      state.position = state.firstTabInLine;
      throwError2(state, "tab characters must not be used in indentation");
    }
    following = state.input.charCodeAt(state.position + 1);
    _line = state.line;
    if ((ch === 63 || ch === 58) && is_WS_OR_EOL(following)) {
      if (ch === 63) {
        if (atExplicitKey) {
          storeMappingPair(state, _result, overridableKeys, keyTag, keyNode, null, _keyLine, _keyLineStart, _keyPos);
          keyTag = keyNode = valueNode = null;
        }
        detected = true;
        atExplicitKey = true;
        allowCompact = true;
      } else if (atExplicitKey) {
        atExplicitKey = false;
        allowCompact = true;
      } else {
        throwError2(state, "incomplete explicit mapping pair; a key node is missed; or followed by a non-tabulated empty line");
      }
      state.position += 1;
      ch = following;
    } else {
      _keyLine = state.line;
      _keyLineStart = state.lineStart;
      _keyPos = state.position;
      if (!composeNode(state, flowIndent, CONTEXT_FLOW_OUT, false, true)) {
        break;
      }
      if (state.line === _line) {
        ch = state.input.charCodeAt(state.position);
        while (is_WHITE_SPACE(ch)) {
          ch = state.input.charCodeAt(++state.position);
        }
        if (ch === 58) {
          ch = state.input.charCodeAt(++state.position);
          if (!is_WS_OR_EOL(ch)) {
            throwError2(state, "a whitespace character is expected after the key-value separator within a block mapping");
          }
          if (atExplicitKey) {
            storeMappingPair(state, _result, overridableKeys, keyTag, keyNode, null, _keyLine, _keyLineStart, _keyPos);
            keyTag = keyNode = valueNode = null;
          }
          detected = true;
          atExplicitKey = false;
          allowCompact = false;
          keyTag = state.tag;
          keyNode = state.result;
        } else if (detected) {
          throwError2(state, "can not read an implicit mapping pair; a colon is missed");
        } else {
          state.tag = _tag;
          state.anchor = _anchor;
          return true;
        }
      } else if (detected) {
        throwError2(state, "can not read a block mapping entry; a multiline key may not be an implicit key");
      } else {
        state.tag = _tag;
        state.anchor = _anchor;
        return true;
      }
    }
    if (state.line === _line || state.lineIndent > nodeIndent) {
      if (atExplicitKey) {
        _keyLine = state.line;
        _keyLineStart = state.lineStart;
        _keyPos = state.position;
      }
      if (composeNode(state, nodeIndent, CONTEXT_BLOCK_OUT, true, allowCompact)) {
        if (atExplicitKey) {
          keyNode = state.result;
        } else {
          valueNode = state.result;
        }
      }
      if (!atExplicitKey) {
        storeMappingPair(state, _result, overridableKeys, keyTag, keyNode, valueNode, _keyLine, _keyLineStart, _keyPos);
        keyTag = keyNode = valueNode = null;
      }
      skipSeparationSpace(state, true, -1);
      ch = state.input.charCodeAt(state.position);
    }
    if ((state.line === _line || state.lineIndent > nodeIndent) && ch !== 0) {
      throwError2(state, "bad indentation of a mapping entry");
    } else if (state.lineIndent < nodeIndent) {
      break;
    }
  }
  if (atExplicitKey) {
    storeMappingPair(state, _result, overridableKeys, keyTag, keyNode, null, _keyLine, _keyLineStart, _keyPos);
  }
  if (detected) {
    state.tag = _tag;
    state.anchor = _anchor;
    state.kind = "mapping";
    state.result = _result;
  }
  return detected;
}
function readTagProperty(state) {
  var _position, isVerbatim = false, isNamed = false, tagHandle, tagName, ch;
  ch = state.input.charCodeAt(state.position);
  if (ch !== 33)
    return false;
  if (state.tag !== null) {
    throwError2(state, "duplication of a tag property");
  }
  ch = state.input.charCodeAt(++state.position);
  if (ch === 60) {
    isVerbatim = true;
    ch = state.input.charCodeAt(++state.position);
  } else if (ch === 33) {
    isNamed = true;
    tagHandle = "!!";
    ch = state.input.charCodeAt(++state.position);
  } else {
    tagHandle = "!";
  }
  _position = state.position;
  if (isVerbatim) {
    do {
      ch = state.input.charCodeAt(++state.position);
    } while (ch !== 0 && ch !== 62);
    if (state.position < state.length) {
      tagName = state.input.slice(_position, state.position);
      ch = state.input.charCodeAt(++state.position);
    } else {
      throwError2(state, "unexpected end of the stream within a verbatim tag");
    }
  } else {
    while (ch !== 0 && !is_WS_OR_EOL(ch)) {
      if (ch === 33) {
        if (!isNamed) {
          tagHandle = state.input.slice(_position - 1, state.position + 1);
          if (!PATTERN_TAG_HANDLE.test(tagHandle)) {
            throwError2(state, "named tag handle cannot contain such characters");
          }
          isNamed = true;
          _position = state.position + 1;
        } else {
          throwError2(state, "tag suffix cannot contain exclamation marks");
        }
      }
      ch = state.input.charCodeAt(++state.position);
    }
    tagName = state.input.slice(_position, state.position);
    if (PATTERN_FLOW_INDICATORS.test(tagName)) {
      throwError2(state, "tag suffix cannot contain flow indicator characters");
    }
  }
  if (tagName && !PATTERN_TAG_URI.test(tagName)) {
    throwError2(state, "tag name cannot contain such characters: " + tagName);
  }
  try {
    tagName = decodeURIComponent(tagName);
  } catch (err2) {
    throwError2(state, "tag name is malformed: " + tagName);
  }
  if (isVerbatim) {
    state.tag = tagName;
  } else if (_hasOwnProperty$1.call(state.tagMap, tagHandle)) {
    state.tag = state.tagMap[tagHandle] + tagName;
  } else if (tagHandle === "!") {
    state.tag = "!" + tagName;
  } else if (tagHandle === "!!") {
    state.tag = "tag:yaml.org,2002:" + tagName;
  } else {
    throwError2(state, 'undeclared tag handle "' + tagHandle + '"');
  }
  return true;
}
function readAnchorProperty(state) {
  var _position, ch;
  ch = state.input.charCodeAt(state.position);
  if (ch !== 38)
    return false;
  if (state.anchor !== null) {
    throwError2(state, "duplication of an anchor property");
  }
  ch = state.input.charCodeAt(++state.position);
  _position = state.position;
  while (ch !== 0 && !is_WS_OR_EOL(ch) && !is_FLOW_INDICATOR(ch)) {
    ch = state.input.charCodeAt(++state.position);
  }
  if (state.position === _position) {
    throwError2(state, "name of an anchor node must contain at least one character");
  }
  state.anchor = state.input.slice(_position, state.position);
  return true;
}
function readAlias(state) {
  var _position, alias, ch;
  ch = state.input.charCodeAt(state.position);
  if (ch !== 42)
    return false;
  ch = state.input.charCodeAt(++state.position);
  _position = state.position;
  while (ch !== 0 && !is_WS_OR_EOL(ch) && !is_FLOW_INDICATOR(ch)) {
    ch = state.input.charCodeAt(++state.position);
  }
  if (state.position === _position) {
    throwError2(state, "name of an alias node must contain at least one character");
  }
  alias = state.input.slice(_position, state.position);
  if (!_hasOwnProperty$1.call(state.anchorMap, alias)) {
    throwError2(state, 'unidentified alias "' + alias + '"');
  }
  state.result = state.anchorMap[alias];
  skipSeparationSpace(state, true, -1);
  return true;
}
function composeNode(state, parentIndent, nodeContext, allowToSeek, allowCompact) {
  var allowBlockStyles, allowBlockScalars, allowBlockCollections, indentStatus = 1, atNewLine = false, hasContent = false, typeIndex, typeQuantity, typeList, type3, flowIndent, blockIndent;
  if (state.listener !== null) {
    state.listener("open", state);
  }
  state.tag = null;
  state.anchor = null;
  state.kind = null;
  state.result = null;
  allowBlockStyles = allowBlockScalars = allowBlockCollections = CONTEXT_BLOCK_OUT === nodeContext || CONTEXT_BLOCK_IN === nodeContext;
  if (allowToSeek) {
    if (skipSeparationSpace(state, true, -1)) {
      atNewLine = true;
      if (state.lineIndent > parentIndent) {
        indentStatus = 1;
      } else if (state.lineIndent === parentIndent) {
        indentStatus = 0;
      } else if (state.lineIndent < parentIndent) {
        indentStatus = -1;
      }
    }
  }
  if (indentStatus === 1) {
    while (readTagProperty(state) || readAnchorProperty(state)) {
      if (skipSeparationSpace(state, true, -1)) {
        atNewLine = true;
        allowBlockCollections = allowBlockStyles;
        if (state.lineIndent > parentIndent) {
          indentStatus = 1;
        } else if (state.lineIndent === parentIndent) {
          indentStatus = 0;
        } else if (state.lineIndent < parentIndent) {
          indentStatus = -1;
        }
      } else {
        allowBlockCollections = false;
      }
    }
  }
  if (allowBlockCollections) {
    allowBlockCollections = atNewLine || allowCompact;
  }
  if (indentStatus === 1 || CONTEXT_BLOCK_OUT === nodeContext) {
    if (CONTEXT_FLOW_IN === nodeContext || CONTEXT_FLOW_OUT === nodeContext) {
      flowIndent = parentIndent;
    } else {
      flowIndent = parentIndent + 1;
    }
    blockIndent = state.position - state.lineStart;
    if (indentStatus === 1) {
      if (allowBlockCollections && (readBlockSequence(state, blockIndent) || readBlockMapping(state, blockIndent, flowIndent)) || readFlowCollection(state, flowIndent)) {
        hasContent = true;
      } else {
        if (allowBlockScalars && readBlockScalar(state, flowIndent) || readSingleQuotedScalar(state, flowIndent) || readDoubleQuotedScalar(state, flowIndent)) {
          hasContent = true;
        } else if (readAlias(state)) {
          hasContent = true;
          if (state.tag !== null || state.anchor !== null) {
            throwError2(state, "alias node should not have any properties");
          }
        } else if (readPlainScalar(state, flowIndent, CONTEXT_FLOW_IN === nodeContext)) {
          hasContent = true;
          if (state.tag === null) {
            state.tag = "?";
          }
        }
        if (state.anchor !== null) {
          state.anchorMap[state.anchor] = state.result;
        }
      }
    } else if (indentStatus === 0) {
      hasContent = allowBlockCollections && readBlockSequence(state, blockIndent);
    }
  }
  if (state.tag === null) {
    if (state.anchor !== null) {
      state.anchorMap[state.anchor] = state.result;
    }
  } else if (state.tag === "?") {
    if (state.result !== null && state.kind !== "scalar") {
      throwError2(state, 'unacceptable node kind for !<?> tag; it should be "scalar", not "' + state.kind + '"');
    }
    for (typeIndex = 0, typeQuantity = state.implicitTypes.length; typeIndex < typeQuantity; typeIndex += 1) {
      type3 = state.implicitTypes[typeIndex];
      if (type3.resolve(state.result)) {
        state.result = type3.construct(state.result);
        state.tag = type3.tag;
        if (state.anchor !== null) {
          state.anchorMap[state.anchor] = state.result;
        }
        break;
      }
    }
  } else if (state.tag !== "!") {
    if (_hasOwnProperty$1.call(state.typeMap[state.kind || "fallback"], state.tag)) {
      type3 = state.typeMap[state.kind || "fallback"][state.tag];
    } else {
      type3 = null;
      typeList = state.typeMap.multi[state.kind || "fallback"];
      for (typeIndex = 0, typeQuantity = typeList.length; typeIndex < typeQuantity; typeIndex += 1) {
        if (state.tag.slice(0, typeList[typeIndex].tag.length) === typeList[typeIndex].tag) {
          type3 = typeList[typeIndex];
          break;
        }
      }
    }
    if (!type3) {
      throwError2(state, "unknown tag !<" + state.tag + ">");
    }
    if (state.result !== null && type3.kind !== state.kind) {
      throwError2(state, "unacceptable node kind for !<" + state.tag + '> tag; it should be "' + type3.kind + '", not "' + state.kind + '"');
    }
    if (!type3.resolve(state.result, state.tag)) {
      throwError2(state, "cannot resolve a node with !<" + state.tag + "> explicit tag");
    } else {
      state.result = type3.construct(state.result, state.tag);
      if (state.anchor !== null) {
        state.anchorMap[state.anchor] = state.result;
      }
    }
  }
  if (state.listener !== null) {
    state.listener("close", state);
  }
  return state.tag !== null || state.anchor !== null || hasContent;
}
function readDocument(state) {
  var documentStart = state.position, _position, directiveName, directiveArgs, hasDirectives = false, ch;
  state.version = null;
  state.checkLineBreaks = state.legacy;
  state.tagMap = Object.create(null);
  state.anchorMap = Object.create(null);
  while ((ch = state.input.charCodeAt(state.position)) !== 0) {
    skipSeparationSpace(state, true, -1);
    ch = state.input.charCodeAt(state.position);
    if (state.lineIndent > 0 || ch !== 37) {
      break;
    }
    hasDirectives = true;
    ch = state.input.charCodeAt(++state.position);
    _position = state.position;
    while (ch !== 0 && !is_WS_OR_EOL(ch)) {
      ch = state.input.charCodeAt(++state.position);
    }
    directiveName = state.input.slice(_position, state.position);
    directiveArgs = [];
    if (directiveName.length < 1) {
      throwError2(state, "directive name must not be less than one character in length");
    }
    while (ch !== 0) {
      while (is_WHITE_SPACE(ch)) {
        ch = state.input.charCodeAt(++state.position);
      }
      if (ch === 35) {
        do {
          ch = state.input.charCodeAt(++state.position);
        } while (ch !== 0 && !is_EOL(ch));
        break;
      }
      if (is_EOL(ch))
        break;
      _position = state.position;
      while (ch !== 0 && !is_WS_OR_EOL(ch)) {
        ch = state.input.charCodeAt(++state.position);
      }
      directiveArgs.push(state.input.slice(_position, state.position));
    }
    if (ch !== 0)
      readLineBreak(state);
    if (_hasOwnProperty$1.call(directiveHandlers, directiveName)) {
      directiveHandlers[directiveName](state, directiveName, directiveArgs);
    } else {
      throwWarning(state, 'unknown document directive "' + directiveName + '"');
    }
  }
  skipSeparationSpace(state, true, -1);
  if (state.lineIndent === 0 && state.input.charCodeAt(state.position) === 45 && state.input.charCodeAt(state.position + 1) === 45 && state.input.charCodeAt(state.position + 2) === 45) {
    state.position += 3;
    skipSeparationSpace(state, true, -1);
  } else if (hasDirectives) {
    throwError2(state, "directives end mark is expected");
  }
  composeNode(state, state.lineIndent - 1, CONTEXT_BLOCK_OUT, false, true);
  skipSeparationSpace(state, true, -1);
  if (state.checkLineBreaks && PATTERN_NON_ASCII_LINE_BREAKS.test(state.input.slice(documentStart, state.position))) {
    throwWarning(state, "non-ASCII line breaks are interpreted as content");
  }
  state.documents.push(state.result);
  if (state.position === state.lineStart && testDocumentSeparator(state)) {
    if (state.input.charCodeAt(state.position) === 46) {
      state.position += 3;
      skipSeparationSpace(state, true, -1);
    }
    return;
  }
  if (state.position < state.length - 1) {
    throwError2(state, "end of the stream or a document separator is expected");
  } else {
    return;
  }
}
function loadDocuments(input, options) {
  input = String(input);
  options = options || {};
  if (input.length !== 0) {
    if (input.charCodeAt(input.length - 1) !== 10 && input.charCodeAt(input.length - 1) !== 13) {
      input += "\n";
    }
    if (input.charCodeAt(0) === 65279) {
      input = input.slice(1);
    }
  }
  var state = new State$1(input, options);
  var nullpos = input.indexOf("\0");
  if (nullpos !== -1) {
    state.position = nullpos;
    throwError2(state, "null byte is not allowed in input");
  }
  state.input += "\0";
  while (state.input.charCodeAt(state.position) === 32) {
    state.lineIndent += 1;
    state.position += 1;
  }
  while (state.position < state.length - 1) {
    readDocument(state);
  }
  return state.documents;
}
function loadAll$1(input, iterator, options) {
  if (iterator !== null && typeof iterator === "object" && typeof options === "undefined") {
    options = iterator;
    iterator = null;
  }
  var documents = loadDocuments(input, options);
  if (typeof iterator !== "function") {
    return documents;
  }
  for (var index = 0, length = documents.length; index < length; index += 1) {
    iterator(documents[index]);
  }
}
function load$1(input, options) {
  var documents = loadDocuments(input, options);
  if (documents.length === 0) {
    return void 0;
  } else if (documents.length === 1) {
    return documents[0];
  }
  throw new exception("expected a single document in the stream, but found more");
}
var loadAll_1 = loadAll$1;
var load_1 = load$1;
var loader = {
  loadAll: loadAll_1,
  load: load_1
};
var _toString = Object.prototype.toString;
var _hasOwnProperty = Object.prototype.hasOwnProperty;
var CHAR_BOM = 65279;
var CHAR_TAB = 9;
var CHAR_LINE_FEED = 10;
var CHAR_CARRIAGE_RETURN = 13;
var CHAR_SPACE = 32;
var CHAR_EXCLAMATION = 33;
var CHAR_DOUBLE_QUOTE = 34;
var CHAR_SHARP = 35;
var CHAR_PERCENT = 37;
var CHAR_AMPERSAND = 38;
var CHAR_SINGLE_QUOTE = 39;
var CHAR_ASTERISK = 42;
var CHAR_COMMA = 44;
var CHAR_MINUS = 45;
var CHAR_COLON = 58;
var CHAR_EQUALS = 61;
var CHAR_GREATER_THAN = 62;
var CHAR_QUESTION = 63;
var CHAR_COMMERCIAL_AT = 64;
var CHAR_LEFT_SQUARE_BRACKET = 91;
var CHAR_RIGHT_SQUARE_BRACKET = 93;
var CHAR_GRAVE_ACCENT = 96;
var CHAR_LEFT_CURLY_BRACKET = 123;
var CHAR_VERTICAL_LINE = 124;
var CHAR_RIGHT_CURLY_BRACKET = 125;
var ESCAPE_SEQUENCES = {};
ESCAPE_SEQUENCES[0] = "\\0";
ESCAPE_SEQUENCES[7] = "\\a";
ESCAPE_SEQUENCES[8] = "\\b";
ESCAPE_SEQUENCES[9] = "\\t";
ESCAPE_SEQUENCES[10] = "\\n";
ESCAPE_SEQUENCES[11] = "\\v";
ESCAPE_SEQUENCES[12] = "\\f";
ESCAPE_SEQUENCES[13] = "\\r";
ESCAPE_SEQUENCES[27] = "\\e";
ESCAPE_SEQUENCES[34] = '\\"';
ESCAPE_SEQUENCES[92] = "\\\\";
ESCAPE_SEQUENCES[133] = "\\N";
ESCAPE_SEQUENCES[160] = "\\_";
ESCAPE_SEQUENCES[8232] = "\\L";
ESCAPE_SEQUENCES[8233] = "\\P";
var DEPRECATED_BOOLEANS_SYNTAX = [
  "y",
  "Y",
  "yes",
  "Yes",
  "YES",
  "on",
  "On",
  "ON",
  "n",
  "N",
  "no",
  "No",
  "NO",
  "off",
  "Off",
  "OFF"
];
var DEPRECATED_BASE60_SYNTAX = /^[-+]?[0-9_]+(?::[0-9_]+)+(?:\.[0-9_]*)?$/;
function compileStyleMap(schema2, map2) {
  var result2, keys, index, length, tag, style, type3;
  if (map2 === null)
    return {};
  result2 = {};
  keys = Object.keys(map2);
  for (index = 0, length = keys.length; index < length; index += 1) {
    tag = keys[index];
    style = String(map2[tag]);
    if (tag.slice(0, 2) === "!!") {
      tag = "tag:yaml.org,2002:" + tag.slice(2);
    }
    type3 = schema2.compiledTypeMap["fallback"][tag];
    if (type3 && _hasOwnProperty.call(type3.styleAliases, style)) {
      style = type3.styleAliases[style];
    }
    result2[tag] = style;
  }
  return result2;
}
function encodeHex(character) {
  var string, handle, length;
  string = character.toString(16).toUpperCase();
  if (character <= 255) {
    handle = "x";
    length = 2;
  } else if (character <= 65535) {
    handle = "u";
    length = 4;
  } else if (character <= 4294967295) {
    handle = "U";
    length = 8;
  } else {
    throw new exception("code point within a string may not be greater than 0xFFFFFFFF");
  }
  return "\\" + handle + common.repeat("0", length - string.length) + string;
}
var QUOTING_TYPE_SINGLE = 1;
var QUOTING_TYPE_DOUBLE = 2;
function State(options) {
  this.schema = options["schema"] || _default;
  this.indent = Math.max(1, options["indent"] || 2);
  this.noArrayIndent = options["noArrayIndent"] || false;
  this.skipInvalid = options["skipInvalid"] || false;
  this.flowLevel = common.isNothing(options["flowLevel"]) ? -1 : options["flowLevel"];
  this.styleMap = compileStyleMap(this.schema, options["styles"] || null);
  this.sortKeys = options["sortKeys"] || false;
  this.lineWidth = options["lineWidth"] || 80;
  this.noRefs = options["noRefs"] || false;
  this.noCompatMode = options["noCompatMode"] || false;
  this.condenseFlow = options["condenseFlow"] || false;
  this.quotingType = options["quotingType"] === '"' ? QUOTING_TYPE_DOUBLE : QUOTING_TYPE_SINGLE;
  this.forceQuotes = options["forceQuotes"] || false;
  this.replacer = typeof options["replacer"] === "function" ? options["replacer"] : null;
  this.implicitTypes = this.schema.compiledImplicit;
  this.explicitTypes = this.schema.compiledExplicit;
  this.tag = null;
  this.result = "";
  this.duplicates = [];
  this.usedDuplicates = null;
}
function indentString(string, spaces) {
  var ind = common.repeat(" ", spaces), position = 0, next = -1, result2 = "", line, length = string.length;
  while (position < length) {
    next = string.indexOf("\n", position);
    if (next === -1) {
      line = string.slice(position);
      position = length;
    } else {
      line = string.slice(position, next + 1);
      position = next + 1;
    }
    if (line.length && line !== "\n")
      result2 += ind;
    result2 += line;
  }
  return result2;
}
function generateNextLine(state, level) {
  return "\n" + common.repeat(" ", state.indent * level);
}
function testImplicitResolving(state, str2) {
  var index, length, type3;
  for (index = 0, length = state.implicitTypes.length; index < length; index += 1) {
    type3 = state.implicitTypes[index];
    if (type3.resolve(str2)) {
      return true;
    }
  }
  return false;
}
function isWhitespace(c2) {
  return c2 === CHAR_SPACE || c2 === CHAR_TAB;
}
function isPrintable(c2) {
  return 32 <= c2 && c2 <= 126 || 161 <= c2 && c2 <= 55295 && c2 !== 8232 && c2 !== 8233 || 57344 <= c2 && c2 <= 65533 && c2 !== CHAR_BOM || 65536 <= c2 && c2 <= 1114111;
}
function isNsCharOrWhitespace(c2) {
  return isPrintable(c2) && c2 !== CHAR_BOM && c2 !== CHAR_CARRIAGE_RETURN && c2 !== CHAR_LINE_FEED;
}
function isPlainSafe(c2, prev, inblock) {
  var cIsNsCharOrWhitespace = isNsCharOrWhitespace(c2);
  var cIsNsChar = cIsNsCharOrWhitespace && !isWhitespace(c2);
  return (inblock ? cIsNsCharOrWhitespace : cIsNsCharOrWhitespace && c2 !== CHAR_COMMA && c2 !== CHAR_LEFT_SQUARE_BRACKET && c2 !== CHAR_RIGHT_SQUARE_BRACKET && c2 !== CHAR_LEFT_CURLY_BRACKET && c2 !== CHAR_RIGHT_CURLY_BRACKET) && c2 !== CHAR_SHARP && !(prev === CHAR_COLON && !cIsNsChar) || isNsCharOrWhitespace(prev) && !isWhitespace(prev) && c2 === CHAR_SHARP || prev === CHAR_COLON && cIsNsChar;
}
function isPlainSafeFirst(c2) {
  return isPrintable(c2) && c2 !== CHAR_BOM && !isWhitespace(c2) && c2 !== CHAR_MINUS && c2 !== CHAR_QUESTION && c2 !== CHAR_COLON && c2 !== CHAR_COMMA && c2 !== CHAR_LEFT_SQUARE_BRACKET && c2 !== CHAR_RIGHT_SQUARE_BRACKET && c2 !== CHAR_LEFT_CURLY_BRACKET && c2 !== CHAR_RIGHT_CURLY_BRACKET && c2 !== CHAR_SHARP && c2 !== CHAR_AMPERSAND && c2 !== CHAR_ASTERISK && c2 !== CHAR_EXCLAMATION && c2 !== CHAR_VERTICAL_LINE && c2 !== CHAR_EQUALS && c2 !== CHAR_GREATER_THAN && c2 !== CHAR_SINGLE_QUOTE && c2 !== CHAR_DOUBLE_QUOTE && c2 !== CHAR_PERCENT && c2 !== CHAR_COMMERCIAL_AT && c2 !== CHAR_GRAVE_ACCENT;
}
function isPlainSafeLast(c2) {
  return !isWhitespace(c2) && c2 !== CHAR_COLON;
}
function codePointAt(string, pos) {
  var first = string.charCodeAt(pos), second;
  if (first >= 55296 && first <= 56319 && pos + 1 < string.length) {
    second = string.charCodeAt(pos + 1);
    if (second >= 56320 && second <= 57343) {
      return (first - 55296) * 1024 + second - 56320 + 65536;
    }
  }
  return first;
}
function needIndentIndicator(string) {
  var leadingSpaceRe = /^\n* /;
  return leadingSpaceRe.test(string);
}
var STYLE_PLAIN = 1;
var STYLE_SINGLE = 2;
var STYLE_LITERAL = 3;
var STYLE_FOLDED = 4;
var STYLE_DOUBLE = 5;
function chooseScalarStyle(string, singleLineOnly, indentPerLevel, lineWidth, testAmbiguousType, quotingType, forceQuotes, inblock) {
  var i3;
  var char = 0;
  var prevChar = null;
  var hasLineBreak = false;
  var hasFoldableLine = false;
  var shouldTrackWidth = lineWidth !== -1;
  var previousLineBreak = -1;
  var plain = isPlainSafeFirst(codePointAt(string, 0)) && isPlainSafeLast(codePointAt(string, string.length - 1));
  if (singleLineOnly || forceQuotes) {
    for (i3 = 0; i3 < string.length; char >= 65536 ? i3 += 2 : i3++) {
      char = codePointAt(string, i3);
      if (!isPrintable(char)) {
        return STYLE_DOUBLE;
      }
      plain = plain && isPlainSafe(char, prevChar, inblock);
      prevChar = char;
    }
  } else {
    for (i3 = 0; i3 < string.length; char >= 65536 ? i3 += 2 : i3++) {
      char = codePointAt(string, i3);
      if (char === CHAR_LINE_FEED) {
        hasLineBreak = true;
        if (shouldTrackWidth) {
          hasFoldableLine = hasFoldableLine || i3 - previousLineBreak - 1 > lineWidth && string[previousLineBreak + 1] !== " ";
          previousLineBreak = i3;
        }
      } else if (!isPrintable(char)) {
        return STYLE_DOUBLE;
      }
      plain = plain && isPlainSafe(char, prevChar, inblock);
      prevChar = char;
    }
    hasFoldableLine = hasFoldableLine || shouldTrackWidth && (i3 - previousLineBreak - 1 > lineWidth && string[previousLineBreak + 1] !== " ");
  }
  if (!hasLineBreak && !hasFoldableLine) {
    if (plain && !forceQuotes && !testAmbiguousType(string)) {
      return STYLE_PLAIN;
    }
    return quotingType === QUOTING_TYPE_DOUBLE ? STYLE_DOUBLE : STYLE_SINGLE;
  }
  if (indentPerLevel > 9 && needIndentIndicator(string)) {
    return STYLE_DOUBLE;
  }
  if (!forceQuotes) {
    return hasFoldableLine ? STYLE_FOLDED : STYLE_LITERAL;
  }
  return quotingType === QUOTING_TYPE_DOUBLE ? STYLE_DOUBLE : STYLE_SINGLE;
}
function writeScalar(state, string, level, iskey, inblock) {
  state.dump = function() {
    if (string.length === 0) {
      return state.quotingType === QUOTING_TYPE_DOUBLE ? '""' : "''";
    }
    if (!state.noCompatMode) {
      if (DEPRECATED_BOOLEANS_SYNTAX.indexOf(string) !== -1 || DEPRECATED_BASE60_SYNTAX.test(string)) {
        return state.quotingType === QUOTING_TYPE_DOUBLE ? '"' + string + '"' : "'" + string + "'";
      }
    }
    var indent = state.indent * Math.max(1, level);
    var lineWidth = state.lineWidth === -1 ? -1 : Math.max(Math.min(state.lineWidth, 40), state.lineWidth - indent);
    var singleLineOnly = iskey || state.flowLevel > -1 && level >= state.flowLevel;
    function testAmbiguity(string2) {
      return testImplicitResolving(state, string2);
    }
    switch (chooseScalarStyle(string, singleLineOnly, state.indent, lineWidth, testAmbiguity, state.quotingType, state.forceQuotes && !iskey, inblock)) {
      case STYLE_PLAIN:
        return string;
      case STYLE_SINGLE:
        return "'" + string.replace(/'/g, "''") + "'";
      case STYLE_LITERAL:
        return "|" + blockHeader(string, state.indent) + dropEndingNewline(indentString(string, indent));
      case STYLE_FOLDED:
        return ">" + blockHeader(string, state.indent) + dropEndingNewline(indentString(foldString(string, lineWidth), indent));
      case STYLE_DOUBLE:
        return '"' + escapeString(string) + '"';
      default:
        throw new exception("impossible error: invalid scalar style");
    }
  }();
}
function blockHeader(string, indentPerLevel) {
  var indentIndicator = needIndentIndicator(string) ? String(indentPerLevel) : "";
  var clip = string[string.length - 1] === "\n";
  var keep = clip && (string[string.length - 2] === "\n" || string === "\n");
  var chomp = keep ? "+" : clip ? "" : "-";
  return indentIndicator + chomp + "\n";
}
function dropEndingNewline(string) {
  return string[string.length - 1] === "\n" ? string.slice(0, -1) : string;
}
function foldString(string, width) {
  var lineRe = /(\n+)([^\n]*)/g;
  var result2 = function() {
    var nextLF = string.indexOf("\n");
    nextLF = nextLF !== -1 ? nextLF : string.length;
    lineRe.lastIndex = nextLF;
    return foldLine(string.slice(0, nextLF), width);
  }();
  var prevMoreIndented = string[0] === "\n" || string[0] === " ";
  var moreIndented;
  var match;
  while (match = lineRe.exec(string)) {
    var prefix2 = match[1], line = match[2];
    moreIndented = line[0] === " ";
    result2 += prefix2 + (!prevMoreIndented && !moreIndented && line !== "" ? "\n" : "") + foldLine(line, width);
    prevMoreIndented = moreIndented;
  }
  return result2;
}
function foldLine(line, width) {
  if (line === "" || line[0] === " ")
    return line;
  var breakRe = / [^ ]/g;
  var match;
  var start = 0, end, curr = 0, next = 0;
  var result2 = "";
  while (match = breakRe.exec(line)) {
    next = match.index;
    if (next - start > width) {
      end = curr > start ? curr : next;
      result2 += "\n" + line.slice(start, end);
      start = end + 1;
    }
    curr = next;
  }
  result2 += "\n";
  if (line.length - start > width && curr > start) {
    result2 += line.slice(start, curr) + "\n" + line.slice(curr + 1);
  } else {
    result2 += line.slice(start);
  }
  return result2.slice(1);
}
function escapeString(string) {
  var result2 = "";
  var char = 0;
  var escapeSeq;
  for (var i3 = 0; i3 < string.length; char >= 65536 ? i3 += 2 : i3++) {
    char = codePointAt(string, i3);
    escapeSeq = ESCAPE_SEQUENCES[char];
    if (!escapeSeq && isPrintable(char)) {
      result2 += string[i3];
      if (char >= 65536)
        result2 += string[i3 + 1];
    } else {
      result2 += escapeSeq || encodeHex(char);
    }
  }
  return result2;
}
function writeFlowSequence(state, level, object) {
  var _result = "", _tag = state.tag, index, length, value;
  for (index = 0, length = object.length; index < length; index += 1) {
    value = object[index];
    if (state.replacer) {
      value = state.replacer.call(object, String(index), value);
    }
    if (writeNode(state, level, value, false, false) || typeof value === "undefined" && writeNode(state, level, null, false, false)) {
      if (_result !== "")
        _result += "," + (!state.condenseFlow ? " " : "");
      _result += state.dump;
    }
  }
  state.tag = _tag;
  state.dump = "[" + _result + "]";
}
function writeBlockSequence(state, level, object, compact) {
  var _result = "", _tag = state.tag, index, length, value;
  for (index = 0, length = object.length; index < length; index += 1) {
    value = object[index];
    if (state.replacer) {
      value = state.replacer.call(object, String(index), value);
    }
    if (writeNode(state, level + 1, value, true, true, false, true) || typeof value === "undefined" && writeNode(state, level + 1, null, true, true, false, true)) {
      if (!compact || _result !== "") {
        _result += generateNextLine(state, level);
      }
      if (state.dump && CHAR_LINE_FEED === state.dump.charCodeAt(0)) {
        _result += "-";
      } else {
        _result += "- ";
      }
      _result += state.dump;
    }
  }
  state.tag = _tag;
  state.dump = _result || "[]";
}
function writeFlowMapping(state, level, object) {
  var _result = "", _tag = state.tag, objectKeyList = Object.keys(object), index, length, objectKey, objectValue, pairBuffer;
  for (index = 0, length = objectKeyList.length; index < length; index += 1) {
    pairBuffer = "";
    if (_result !== "")
      pairBuffer += ", ";
    if (state.condenseFlow)
      pairBuffer += '"';
    objectKey = objectKeyList[index];
    objectValue = object[objectKey];
    if (state.replacer) {
      objectValue = state.replacer.call(object, objectKey, objectValue);
    }
    if (!writeNode(state, level, objectKey, false, false)) {
      continue;
    }
    if (state.dump.length > 1024)
      pairBuffer += "? ";
    pairBuffer += state.dump + (state.condenseFlow ? '"' : "") + ":" + (state.condenseFlow ? "" : " ");
    if (!writeNode(state, level, objectValue, false, false)) {
      continue;
    }
    pairBuffer += state.dump;
    _result += pairBuffer;
  }
  state.tag = _tag;
  state.dump = "{" + _result + "}";
}
function writeBlockMapping(state, level, object, compact) {
  var _result = "", _tag = state.tag, objectKeyList = Object.keys(object), index, length, objectKey, objectValue, explicitPair, pairBuffer;
  if (state.sortKeys === true) {
    objectKeyList.sort();
  } else if (typeof state.sortKeys === "function") {
    objectKeyList.sort(state.sortKeys);
  } else if (state.sortKeys) {
    throw new exception("sortKeys must be a boolean or a function");
  }
  for (index = 0, length = objectKeyList.length; index < length; index += 1) {
    pairBuffer = "";
    if (!compact || _result !== "") {
      pairBuffer += generateNextLine(state, level);
    }
    objectKey = objectKeyList[index];
    objectValue = object[objectKey];
    if (state.replacer) {
      objectValue = state.replacer.call(object, objectKey, objectValue);
    }
    if (!writeNode(state, level + 1, objectKey, true, true, true)) {
      continue;
    }
    explicitPair = state.tag !== null && state.tag !== "?" || state.dump && state.dump.length > 1024;
    if (explicitPair) {
      if (state.dump && CHAR_LINE_FEED === state.dump.charCodeAt(0)) {
        pairBuffer += "?";
      } else {
        pairBuffer += "? ";
      }
    }
    pairBuffer += state.dump;
    if (explicitPair) {
      pairBuffer += generateNextLine(state, level);
    }
    if (!writeNode(state, level + 1, objectValue, true, explicitPair)) {
      continue;
    }
    if (state.dump && CHAR_LINE_FEED === state.dump.charCodeAt(0)) {
      pairBuffer += ":";
    } else {
      pairBuffer += ": ";
    }
    pairBuffer += state.dump;
    _result += pairBuffer;
  }
  state.tag = _tag;
  state.dump = _result || "{}";
}
function detectType(state, object, explicit) {
  var _result, typeList, index, length, type3, style;
  typeList = explicit ? state.explicitTypes : state.implicitTypes;
  for (index = 0, length = typeList.length; index < length; index += 1) {
    type3 = typeList[index];
    if ((type3.instanceOf || type3.predicate) && (!type3.instanceOf || typeof object === "object" && object instanceof type3.instanceOf) && (!type3.predicate || type3.predicate(object))) {
      if (explicit) {
        if (type3.multi && type3.representName) {
          state.tag = type3.representName(object);
        } else {
          state.tag = type3.tag;
        }
      } else {
        state.tag = "?";
      }
      if (type3.represent) {
        style = state.styleMap[type3.tag] || type3.defaultStyle;
        if (_toString.call(type3.represent) === "[object Function]") {
          _result = type3.represent(object, style);
        } else if (_hasOwnProperty.call(type3.represent, style)) {
          _result = type3.represent[style](object, style);
        } else {
          throw new exception("!<" + type3.tag + '> tag resolver accepts not "' + style + '" style');
        }
        state.dump = _result;
      }
      return true;
    }
  }
  return false;
}
function writeNode(state, level, object, block, compact, iskey, isblockseq) {
  state.tag = null;
  state.dump = object;
  if (!detectType(state, object, false)) {
    detectType(state, object, true);
  }
  var type3 = _toString.call(state.dump);
  var inblock = block;
  var tagStr;
  if (block) {
    block = state.flowLevel < 0 || state.flowLevel > level;
  }
  var objectOrArray = type3 === "[object Object]" || type3 === "[object Array]", duplicateIndex, duplicate;
  if (objectOrArray) {
    duplicateIndex = state.duplicates.indexOf(object);
    duplicate = duplicateIndex !== -1;
  }
  if (state.tag !== null && state.tag !== "?" || duplicate || state.indent !== 2 && level > 0) {
    compact = false;
  }
  if (duplicate && state.usedDuplicates[duplicateIndex]) {
    state.dump = "*ref_" + duplicateIndex;
  } else {
    if (objectOrArray && duplicate && !state.usedDuplicates[duplicateIndex]) {
      state.usedDuplicates[duplicateIndex] = true;
    }
    if (type3 === "[object Object]") {
      if (block && Object.keys(state.dump).length !== 0) {
        writeBlockMapping(state, level, state.dump, compact);
        if (duplicate) {
          state.dump = "&ref_" + duplicateIndex + state.dump;
        }
      } else {
        writeFlowMapping(state, level, state.dump);
        if (duplicate) {
          state.dump = "&ref_" + duplicateIndex + " " + state.dump;
        }
      }
    } else if (type3 === "[object Array]") {
      if (block && state.dump.length !== 0) {
        if (state.noArrayIndent && !isblockseq && level > 0) {
          writeBlockSequence(state, level - 1, state.dump, compact);
        } else {
          writeBlockSequence(state, level, state.dump, compact);
        }
        if (duplicate) {
          state.dump = "&ref_" + duplicateIndex + state.dump;
        }
      } else {
        writeFlowSequence(state, level, state.dump);
        if (duplicate) {
          state.dump = "&ref_" + duplicateIndex + " " + state.dump;
        }
      }
    } else if (type3 === "[object String]") {
      if (state.tag !== "?") {
        writeScalar(state, state.dump, level, iskey, inblock);
      }
    } else if (type3 === "[object Undefined]") {
      return false;
    } else {
      if (state.skipInvalid)
        return false;
      throw new exception("unacceptable kind of an object to dump " + type3);
    }
    if (state.tag !== null && state.tag !== "?") {
      tagStr = encodeURI(state.tag[0] === "!" ? state.tag.slice(1) : state.tag).replace(/!/g, "%21");
      if (state.tag[0] === "!") {
        tagStr = "!" + tagStr;
      } else if (tagStr.slice(0, 18) === "tag:yaml.org,2002:") {
        tagStr = "!!" + tagStr.slice(18);
      } else {
        tagStr = "!<" + tagStr + ">";
      }
      state.dump = tagStr + " " + state.dump;
    }
  }
  return true;
}
function getDuplicateReferences(object, state) {
  var objects = [], duplicatesIndexes = [], index, length;
  inspectNode(object, objects, duplicatesIndexes);
  for (index = 0, length = duplicatesIndexes.length; index < length; index += 1) {
    state.duplicates.push(objects[duplicatesIndexes[index]]);
  }
  state.usedDuplicates = new Array(length);
}
function inspectNode(object, objects, duplicatesIndexes) {
  var objectKeyList, index, length;
  if (object !== null && typeof object === "object") {
    index = objects.indexOf(object);
    if (index !== -1) {
      if (duplicatesIndexes.indexOf(index) === -1) {
        duplicatesIndexes.push(index);
      }
    } else {
      objects.push(object);
      if (Array.isArray(object)) {
        for (index = 0, length = object.length; index < length; index += 1) {
          inspectNode(object[index], objects, duplicatesIndexes);
        }
      } else {
        objectKeyList = Object.keys(object);
        for (index = 0, length = objectKeyList.length; index < length; index += 1) {
          inspectNode(object[objectKeyList[index]], objects, duplicatesIndexes);
        }
      }
    }
  }
}
function dump$1(input, options) {
  options = options || {};
  var state = new State(options);
  if (!state.noRefs)
    getDuplicateReferences(input, state);
  var value = input;
  if (state.replacer) {
    value = state.replacer.call({ "": value }, "", value);
  }
  if (writeNode(state, 0, value, true, true))
    return state.dump + "\n";
  return "";
}
var dump_1 = dump$1;
var dumper = {
  dump: dump_1
};
function renamed(from, to) {
  return function() {
    throw new Error("Function yaml." + from + " is removed in js-yaml 4. Use yaml." + to + " instead, which is now safe by default.");
  };
}
var Type = type2;
var Schema = schema;
var FAILSAFE_SCHEMA = failsafe;
var JSON_SCHEMA = json;
var CORE_SCHEMA = core;
var DEFAULT_SCHEMA = _default;
var load = loader.load;
var loadAll = loader.loadAll;
var dump2 = dumper.dump;
var YAMLException = exception;
var types = {
  binary,
  float,
  map,
  null: _null,
  pairs,
  set,
  timestamp,
  bool,
  int,
  merge,
  omap,
  seq,
  str
};
var safeLoad = renamed("safeLoad", "load");
var safeLoadAll = renamed("safeLoadAll", "loadAll");
var safeDump = renamed("safeDump", "dump");
var jsYaml = {
  Type,
  Schema,
  FAILSAFE_SCHEMA,
  JSON_SCHEMA,
  CORE_SCHEMA,
  DEFAULT_SCHEMA,
  load,
  loadAll,
  dump: dump2,
  YAMLException,
  types,
  safeLoad,
  safeLoadAll,
  safeDump
};
var js_yaml_default = jsYaml;

// src/migrationPreparator.ts
var import_fs3 = __toModule(require("fs"));

// src/serializer/index.ts
var import_fs2 = __toModule(require("fs"));
var import_string_decoder = __toModule(require("string_decoder"));

// src/serializer/factory.ts
var import_typescript = __toModule(require_typescript());
var import_fs = __toModule(require("fs"));
var printer = import_typescript.default.createPrinter();
var prepareFabricFile = (folder) => {
  const staticImports = [
    import_typescript.default.createImportDeclaration(void 0, void 0, import_typescript.default.createImportClause(void 0, import_typescript.default.createNamespaceImport(import_typescript.default.createIdentifier("drizzle"))), import_typescript.default.createStringLiteral("drizzle-orm")),
    import_typescript.default.createImportDeclaration(void 0, void 0, import_typescript.default.createImportClause(import_typescript.default.createIdentifier("MigrationSerializer"), void 0), import_typescript.default.createStringLiteral("drizzle-orm/serializer/serializer")),
    import_typescript.default.createImportDeclaration(void 0, void 0, import_typescript.default.createImportClause(import_typescript.default.createIdentifier("Enum"), void 0), import_typescript.default.createStringLiteral("drizzle-orm/types/type")),
    import_typescript.default.createImportDeclaration(void 0, void 0, import_typescript.default.createImportClause(void 0, import_typescript.default.createNamespaceImport(import_typescript.default.createIdentifier("pg"))), import_typescript.default.createStringLiteral("pg"))
  ];
  const dynamicImports = [];
  const filenames = import_fs.default.readdirSync(folder);
  for (let i3 = 0; i3 < filenames.length; i3++) {
    const filename = filenames[i3];
    const importPath = `${folder}/${filename.split(".")[0]}`;
    dynamicImports.push(import_typescript.default.createImportDeclaration(void 0, void 0, import_typescript.default.createImportClause(void 0, import_typescript.default.createNamespaceImport(import_typescript.default.createIdentifier(`i${i3}`))), import_typescript.default.createStringLiteral(importPath)));
  }
  const variablesStatements = [
    import_typescript.default.createVariableStatement(void 0, import_typescript.default.createVariableDeclarationList([
      import_typescript.default.createVariableDeclaration(import_typescript.default.createIdentifier("db"), void 0, import_typescript.default.createNew(import_typescript.default.createIdentifier("drizzle.DB"), void 0, [
        import_typescript.default.createNew(import_typescript.default.createPropertyAccess(import_typescript.default.createIdentifier("pg"), import_typescript.default.createIdentifier("Pool")), void 0, [])
      ]))
    ], import_typescript.default.NodeFlags.Const)),
    import_typescript.default.createVariableStatement(void 0, import_typescript.default.createVariableDeclarationList([
      import_typescript.default.createVariableDeclaration(import_typescript.default.createIdentifier("serializer"), void 0, import_typescript.default.createNew(import_typescript.default.createIdentifier("MigrationSerializer"), void 0, []))
    ], import_typescript.default.NodeFlags.Const))
  ];
  const blockStatements = [];
  blockStatements.push(import_typescript.default.createVariableStatement(void 0, import_typescript.default.createVariableDeclarationList([
    import_typescript.default.createVariableDeclaration(import_typescript.default.createIdentifier("tables"), import_typescript.default.createArrayTypeNode(import_typescript.default.createTypeReferenceNode(import_typescript.default.createQualifiedName(import_typescript.default.createIdentifier("drizzle"), import_typescript.default.createIdentifier("AbstractTable")), [import_typescript.default.createKeywordTypeNode(import_typescript.default.SyntaxKind.AnyKeyword)])), import_typescript.default.createArrayLiteral([], false))
  ], import_typescript.default.NodeFlags.Const)));
  blockStatements.push(import_typescript.default.createVariableStatement(void 0, import_typescript.default.createVariableDeclarationList([
    import_typescript.default.createVariableDeclaration(import_typescript.default.createIdentifier("enums"), import_typescript.default.createArrayTypeNode(import_typescript.default.createTypeReferenceNode(import_typescript.default.createIdentifier("Enum"), [import_typescript.default.createKeywordTypeNode(import_typescript.default.SyntaxKind.AnyKeyword)])), import_typescript.default.createArrayLiteral([], false))
  ], import_typescript.default.NodeFlags.Const)));
  for (let i3 = 0; i3 < filenames.length; i3++) {
    const valuesDeclaration = import_typescript.default.createVariableStatement(void 0, import_typescript.default.createVariableDeclarationList([
      import_typescript.default.createVariableDeclaration(import_typescript.default.createIdentifier(`i${i3}values`), void 0, import_typescript.default.createCall(import_typescript.default.createPropertyAccess(import_typescript.default.createIdentifier("Object"), import_typescript.default.createIdentifier("values")), void 0, [import_typescript.default.createIdentifier("i" + i3)]))
    ], import_typescript.default.NodeFlags.Const));
    blockStatements.push(valuesDeclaration);
    const iterationWithTypeChecks = import_typescript.default.createExpressionStatement(import_typescript.default.createCall(import_typescript.default.createPropertyAccess(import_typescript.default.createIdentifier(`i${i3}values`), import_typescript.default.createIdentifier("forEach")), void 0, [
      import_typescript.default.createArrowFunction(void 0, void 0, [
        import_typescript.default.createParameter(void 0, void 0, void 0, import_typescript.default.createIdentifier("t"), void 0, void 0, void 0)
      ], void 0, import_typescript.default.createToken(import_typescript.default.SyntaxKind.EqualsGreaterThanToken), import_typescript.default.createBlock([
        import_typescript.default.createIf(import_typescript.default.createBinary(import_typescript.default.createIdentifier("t"), import_typescript.default.SyntaxKind.InstanceOfKeyword, import_typescript.default.createIdentifier("Enum")), import_typescript.default.createBlock([
          import_typescript.default.createExpressionStatement(import_typescript.default.createCall(import_typescript.default.createPropertyAccess(import_typescript.default.createIdentifier("enums"), import_typescript.default.createIdentifier("push")), void 0, [import_typescript.default.createIdentifier("t")])),
          import_typescript.default.createReturn(void 0)
        ], true), void 0),
        import_typescript.default.createIf(import_typescript.default.createBinary(import_typescript.default.createBinary(import_typescript.default.createBinary(import_typescript.default.createTypeOf(import_typescript.default.createIdentifier("t")), import_typescript.default.createToken(import_typescript.default.SyntaxKind.EqualsEqualsEqualsToken), import_typescript.default.createStringLiteral("function")), import_typescript.default.createToken(import_typescript.default.SyntaxKind.AmpersandAmpersandToken), import_typescript.default.createPropertyAccess(import_typescript.default.createIdentifier("t"), import_typescript.default.createIdentifier("prototype"))), import_typescript.default.createToken(import_typescript.default.SyntaxKind.AmpersandAmpersandToken), import_typescript.default.createPropertyAccess(import_typescript.default.createPropertyAccess(import_typescript.default.createIdentifier("t"), import_typescript.default.createIdentifier("prototype")), import_typescript.default.createIdentifier("constructor"))), import_typescript.default.createBlock([
          import_typescript.default.createVariableStatement(void 0, import_typescript.default.createVariableDeclarationList([
            import_typescript.default.createVariableDeclaration(import_typescript.default.createIdentifier("instance"), void 0, import_typescript.default.createNew(import_typescript.default.createIdentifier("t"), void 0, [import_typescript.default.createIdentifier("db")]))
          ], import_typescript.default.NodeFlags.Const)),
          import_typescript.default.createIf(import_typescript.default.createBinary(import_typescript.default.createIdentifier("instance"), import_typescript.default.SyntaxKind.InstanceOfKeyword, import_typescript.default.createIdentifier("drizzle.AbstractTable")), import_typescript.default.createBlock([
            import_typescript.default.createExpressionStatement(import_typescript.default.createCall(import_typescript.default.createPropertyAccess(import_typescript.default.createIdentifier("tables"), import_typescript.default.createIdentifier("push")), void 0, [
              import_typescript.default.createAsExpression(import_typescript.default.createAsExpression(import_typescript.default.createIdentifier("instance"), import_typescript.default.createKeywordTypeNode(import_typescript.default.SyntaxKind.UnknownKeyword)), import_typescript.default.createTypeReferenceNode(import_typescript.default.createQualifiedName(import_typescript.default.createIdentifier("drizzle"), import_typescript.default.createIdentifier("AbstractTable")), [
                import_typescript.default.createKeywordTypeNode(import_typescript.default.SyntaxKind.AnyKeyword)
              ]))
            ]))
          ], true), void 0)
        ], true), void 0)
      ], true))
    ]));
    blockStatements.push(iterationWithTypeChecks);
  }
  blockStatements.push(import_typescript.default.createReturn(import_typescript.default.createCall(import_typescript.default.createPropertyAccess(import_typescript.default.createIdentifier("serializer"), import_typescript.default.createIdentifier("generate")), void 0, [
    import_typescript.default.createIdentifier("tables"),
    import_typescript.default.createIdentifier("enums")
  ])));
  const funcStatement = [
    import_typescript.default.createVariableStatement(void 0, import_typescript.default.createVariableDeclarationList([
      import_typescript.default.createVariableDeclaration(import_typescript.default.createIdentifier("testFun"), void 0, import_typescript.default.createArrowFunction(void 0, void 0, [], void 0, import_typescript.default.createToken(import_typescript.default.SyntaxKind.EqualsGreaterThanToken), import_typescript.default.createBlock(blockStatements, true)))
    ], import_typescript.default.NodeFlags.Const))
  ];
  const invocationStatement = [
    import_typescript.default.createExpressionStatement(import_typescript.default.createCall(import_typescript.default.createIdentifier("testFun"), void 0, []))
  ];
  const outFile = import_typescript.default.createSourceFile("outfile.ts", "", import_typescript.default.ScriptTarget.ES2015, true, import_typescript.default.ScriptKind.TS);
  const source = [];
  source.push(...staticImports);
  source.push(...dynamicImports);
  source.push(...variablesStatements);
  source.push(...funcStatement);
  source.push(...invocationStatement);
  const newFile = import_typescript.default.factory.updateSourceFile(outFile, source);
  return printer.printFile(newFile);
};
var factory_default = prepareFabricFile;

// src/serializer/index.ts
var esbuild = require("esbuild");
var serialize = (path) => {
  const decoder = new import_string_decoder.StringDecoder();
  const preparedFarbic = factory_default(path);
  import_fs2.default.writeFileSync("__out.ts", preparedFarbic, "utf-8");
  const result = esbuild.buildSync({
    entryPoints: ["__out.ts"],
    bundle: true,
    platform: "node",
    write: false,
    external: ["pg-native"]
  });
  import_fs2.default.unlinkSync("__out.ts");
  return eval(decoder.write(result.outputFiles[0].contents));
};
var serializer_default = serialize;

// src/migrationPreparator.ts
var dry = {
  version: "1",
  tables: {},
  enums: {}
};
var prepareMigration = (migrationRootFolderName = "drizzle", dataFolderPath) => {
  const root = migrationRootFolderName;
  const files = import_fs3.default.readdirSync("./");
  const drizzleFolder = files.find((it) => {
    return it === root;
  });
  if (!drizzleFolder) {
    import_fs3.default.mkdirSync(root);
  }
  const migrationFolders = import_fs3.default.readdirSync(`./${root}`);
  let prevSnapshot;
  if (migrationFolders.length === 0) {
    prevSnapshot = dry;
  } else {
    migrationFolders.sort();
    const lastSnapshotFolder = migrationFolders[migrationFolders.length - 1];
    console.log(lastSnapshotFolder);
    prevSnapshot = JSON.parse(import_fs3.default.readFileSync(`./${root}/${lastSnapshotFolder}/snapshot.json`).toString());
  }
  const result2 = serializer_default(dataFolderPath);
  return { prev: prevSnapshot, cur: result2 };
};
var migrationPreparator_default = prepareMigration;

// src/sqlgenerator.ts
var Convertor = class {
};
var CreateTableConvertor = class extends Convertor {
  can(statement) {
    return statement.type === "create_table";
  }
  convert(st) {
    const { tableName, columns } = st;
    let statement = "";
    console.log(columns.length);
    console.log(columns);
    statement += `CREATE TABLE IF NOT EXISTS ${tableName} (
`;
    for (let i3 = 0; i3 < columns.length; i3++) {
      const column = columns[i3];
      const primaryKeyStatement = column.primaryKey ? "PRIMARY KEY" : "";
      const notNullStatement = column.notNull ? "NOT NULL" : "";
      const defaultStatement = column.default ? `DEFAULT '${column.default}'` : "";
      statement += "	" + `${column.name} ${column.type} ${primaryKeyStatement} ${defaultStatement} ${notNullStatement}`.replace(/  +/g, " ").trim();
      statement += (i3 === columns.length - 1 ? "" : ",") + "\n";
    }
    statement += `);`;
    statement += `
`;
    return statement;
  }
};
var CreateTypeEnumConvertor = class extends Convertor {
  can(statement) {
    return statement.type === "create_type_enum";
  }
  convert(st) {
    const { name, values } = st;
    let valuesStatement = "(";
    valuesStatement += values.map((it) => `'${it}'`).join(", ");
    valuesStatement += ")";
    let statement = "DO $$ BEGIN";
    statement += "\n";
    statement += ` CREATE TYPE ${name} AS ENUM${valuesStatement};`;
    statement += "\n";
    statement += "EXCEPTION";
    statement += "\n";
    statement += " WHEN duplicate_object THEN null;";
    statement += "\n";
    statement += "END $$;";
    statement += "\n";
    return statement;
  }
};
var AlterTypeAddValueConvertor = class extends Convertor {
  can(statement) {
    return statement.type === "alter_type_add_value";
  }
  convert(st) {
    const { name, value } = st;
    return `ALTER TYPE ${name} ADD VALUE ${value};`;
  }
};
var DropTableConvertor = class extends Convertor {
  can(statement) {
    return statement.type === "drop_table";
  }
  convert(statement) {
    const { tableName } = statement;
    return `DROP TABLE ${tableName};`;
  }
};
var RenameTableConvertor = class extends Convertor {
  can(statement) {
    return statement.type === "rename_table";
  }
  convert(statement) {
    const { tableNameFrom, tableNameTo } = statement;
    return `ALTER TABLE ${tableNameFrom} RENAME TO ${tableNameTo};`;
  }
};
var AlterTableDropColumnConvertor = class extends Convertor {
  can(statement) {
    return statement.type === "alter_table_drop_column";
  }
  convert(statement) {
    const { tableName, columnName } = statement;
    return `ALTER TABLE ${tableName} DROP COLUMN IF EXISTS ${columnName};`;
  }
};
var AlterTableAddColumnConvertor = class extends Convertor {
  can(statement) {
    return statement.type === "alter_table_add_column";
  }
  convert(statement) {
    const { tableName, column } = statement;
    const { name, type: type3, notNull } = column;
    const defaultValue = column.default;
    const defaultStatement = `${defaultValue ? `DEFAULT ${defaultValue}` : ""}`;
    const notNullStatement = `${notNull ? "NOT NULL" : ""}`;
    return `ALTER TABLE ${tableName} ADD COLUMN ${name} ${type3} ${defaultStatement} ${notNullStatement}`.replace(/  +/g, " ").trim() + ";";
  }
};
var AlterTableAlterColumnSetTypeConvertor = class extends Convertor {
  can(statement) {
    return statement.type === "alter_table_alter_column_set_type";
  }
  convert(statement) {
    const { tableName, columnName, newDataType } = statement;
    return `ALTER TABLE ${tableName} ALTER COLUMN ${columnName} SET DATA TYPE ${newDataType};`;
  }
};
var AlterTableAlterColumnSetNotNullConvertor = class extends Convertor {
  can(statement) {
    return statement.type === "alter_table_alter_column_set_notnull";
  }
  convert(statement) {
    const { tableName, columnName } = statement;
    return `ALTER TABLE ${tableName} ALTER COLUMN ${columnName} SET NOT NULL;`;
  }
};
var AlterTableAlterColumnDropNotNullConvertor = class extends Convertor {
  can(statement) {
    return statement.type === "alter_table_alter_column_drop_notnull";
  }
  convert(statement) {
    const { tableName, columnName } = statement;
    return `ALTER TABLE ${tableName} ALTER COLUMN ${columnName} DROP NOT NULL;`;
  }
};
var CreateForeignKeyConvertor = class extends Convertor {
  can(statement) {
    return statement.type === "create_reference";
  }
  convert(statement) {
    const { fromTable, toTable, fromColumn, toColumn, foreignKeyName, onDelete, onUpdate } = statement;
    const onDeleteStatement = onDelete || "";
    const onUpdateStatement = onUpdate || "";
    return `ALTER TABLE ${fromTable} ADD CONSTRAINT ${foreignKeyName} FOREIGN KEY (${fromColumn}) REFERENCES ${toTable}(${toColumn}) ${onDeleteStatement} ${onUpdateStatement}`.replace(/  +/g, " ").trim() + ";";
  }
};
var CreateIndexConvertor = class extends Convertor {
  can(statement) {
    return statement.type === "create_index";
  }
  convert(statement) {
    const { tableName, indexName, value } = statement;
    return `CREATE INDEX IF NOT EXISTS ${indexName} ON ${tableName} (${value});`;
  }
};
var DropIndexConvertor = class extends Convertor {
  can(statement) {
    return statement.type === "drop_index";
  }
  convert(statement) {
    const { indexName } = statement;
    return `DROP INDEX IF EXISTS ${indexName};`;
  }
};
var convertors = [];
convertors.push(new CreateTableConvertor());
convertors.push(new CreateTypeEnumConvertor());
convertors.push(new DropTableConvertor());
convertors.push(new RenameTableConvertor());
convertors.push(new AlterTableDropColumnConvertor());
convertors.push(new AlterTableAddColumnConvertor());
convertors.push(new AlterTableAlterColumnSetTypeConvertor());
convertors.push(new CreateIndexConvertor());
convertors.push(new DropIndexConvertor());
convertors.push(new AlterTypeAddValueConvertor());
convertors.push(new AlterTableAlterColumnSetNotNullConvertor());
convertors.push(new AlterTableAlterColumnDropNotNullConvertor());
convertors.push(new CreateForeignKeyConvertor());
var fromJson = (statements) => {
  return statements.map((statement) => {
    const filtered = convertors.filter((it) => {
      return it.can(statement);
    });
    const convertor = filtered.length === 1 ? filtered[0] : void 0;
    if (!convertor) {
      console.log("no convertor:", statement.type);
      return "dry run";
    }
    return convertor.convert(statement);
  });
};
https:
  `
create table users (
	id int,
    name character varying(128)
);

create type venum as enum('one', 'two', 'three');
alter table users add column typed venum;

insert into users(id, name, typed) values (1, 'name1', 'one');
insert into users(id, name, typed) values (2, 'name2', 'two');
insert into users(id, name, typed) values (3, 'name3', 'three');

alter type venum rename to __venum;
create type venum as enum ('one', 'two', 'three', 'four', 'five');

ALTER TABLE users ALTER COLUMN typed TYPE venum USING typed::text::venum;

insert into users(id, name, typed) values (4, 'name4', 'four');
insert into users(id, name, typed) values (5, 'name5', 'five');

drop type __venum;
`;

// src/jsonDiffer.js
var import_json_diff = __toModule(require_lib4());
"use-strict";
function diffForRenamed(pairs2) {
  const renamed2 = pairs2.map((it) => {
    const from = it.from || it.old;
    const to = it.to || it.new;
    const newFrom = __spreadProps(__spreadValues({}, from), { name: to.name });
    return [newFrom, to];
  });
  const altered = renamed2.map((pair) => {
    const diffed = (0, import_json_diff.diff)(pair[0], pair[1]);
    diffed.name = pair[0].name;
    return findAlternationsInTable(diffed);
  });
  return altered;
}
function applyJsonDiff(json1, json2) {
  const difference = (0, import_json_diff.diff)(json1, json2);
  difference.tables = difference.tables ? difference.tables : {};
  difference.enums = difference.enums ? difference.enums : {};
  const tableEntries = Object.entries(difference.tables);
  const addedTables = tableEntries.filter((it) => it[0].includes("__added")).map((it) => it[1]).map((it) => {
    return __spreadProps(__spreadValues({}, it), { columns: Object.values(it.columns) });
  }).map((it) => {
    return __spreadProps(__spreadValues({}, it), {
      indexes: Object.entries(it.indexes).map((indexEntry) => {
        const idx = indexEntry[1];
        const name = idx["name"];
        const columns = Object.values(idx["columns"]).map((it2) => it2["name"]);
        return { name, columns };
      })
    });
  });
  const deletedTables = tableEntries.filter((it) => it[0].includes("__deleted")).map((it) => it[1]).map((it) => {
    return __spreadProps(__spreadValues({}, it), { columns: Object.values(it.columns) });
  });
  const enumsEntries = Object.entries(difference.enums);
  const addedEnums = enumsEntries.filter((it) => it[0].includes("__added")).map((it) => it[1]).map((it) => {
    const values = Object.entries(it.values).map((ve) => ve[1]);
    return { name: it.name, values };
  });
  const deletedEnums = enumsEntries.filter((it) => it[0].includes("__deleted")).map((it) => it[1]).map((it) => {
    const values = Object.entries(it.values).map((ve) => ve[1]);
    return { name: it.name, values };
  });
  const alteredEnums = enumsEntries.filter((it) => !(it[0].includes("__added") || it[0].includes("__deleted"))).map((it) => {
    const vals = it[1].values;
    const addedValues = Object.entries(vals).filter((val) => val[0].includes("__added")).map((val) => val[1]);
    const deletedValues = Object.entries(vals).filter((val) => val[0].includes("__deleted")).map((val) => val[1]);
    return { name: it[0], addedValues, deletedValues };
  });
  const alteredTables = Object.keys(difference.tables).filter((it) => !(it.includes("__added") || it.includes("__deleted"))).map((it) => {
    return __spreadValues({ name: it }, difference.tables[it]);
  });
  const alteredTablesWithColumns = alteredTables.map((table) => findAlternationsInTable(table));
  return {
    addedTables,
    deletedTables,
    alteredTablesWithColumns,
    addedEnums,
    deletedEnums,
    alteredEnums
  };
}
var findAlternationsInTable = (table) => {
  const columns = table.columns;
  const added = Object.keys(columns).filter((it) => it.includes("__added")).map((it) => {
    return __spreadValues({}, columns[it]);
  });
  const deleted = Object.keys(columns).filter((it) => it.includes("__deleted")).map((it) => {
    return __spreadValues({}, columns[it]);
  });
  const altered = Object.keys(columns).filter((it) => !(it.includes("__deleted") || it.includes("__added"))).map((it) => {
    return __spreadValues({ name: it }, columns[it]);
  });
  const deletedIndexes = Object.values(table.indexes__deleted || {}).map((it) => {
    const name = it["name"];
    const columns2 = Object.values(it["columns"]).map((it2) => it2["name"]);
    return { name, columns: columns2 };
  }).concat(Object.keys(table.indexes || {}).filter((it) => it.includes("__deleted")).map((it) => {
    const idx = table.indexes[it];
    const name = idx["name"];
    const columns2 = Object.values(idx["columns"]).map((it2) => it2["name"]);
    return { name, columns: columns2 };
  }));
  const addedIndexes = Object.values(table.indexes__added || {}).map((it) => {
    const name = it["name"];
    const columns2 = Object.values(it["columns"]).map((it2) => it2["name"]);
    return { name, columns: columns2 };
  }).concat(Object.keys(table.indexes || {}).filter((it) => it.includes("__added")).map((it) => {
    const idx = table.indexes[it];
    const name = idx["name"];
    const columns2 = Object.values(idx["columns"]).map((it2) => it2["name"]);
    return { name, columns: columns2 };
  }));
  const mappedAltered = altered.map((it) => {
    if (typeof it.name !== "string" && "__old" in it.name) {
      return __spreadProps(__spreadValues({}, it), { name: { type: "changed", old: it.name.__old, new: it.name.__new } });
    }
    return it;
  }).map((it) => {
    if ("type" in it) {
      return __spreadProps(__spreadValues({}, it), { type: { type: "changed", old: it.type.__old, new: it.type.__new } });
    }
    return it;
  }).map((it) => {
    if ("defaultValue" in it) {
      return __spreadProps(__spreadValues({}, it), { defaultValue: { type: "changed", old: it.defaultValue.__old, new: it.defaultValue.__new } });
    }
    if ("defaultValue__added" in it) {
      const _a2 = it, { defaultValue__added } = _a2, others = __objRest(_a2, ["defaultValue__added"]);
      return __spreadProps(__spreadValues({}, others), { defaultValue: { type: "added", value: it.defaultValue__added } });
    }
    if ("defaultValue__deleted" in it) {
      const _b = it, { defaultValue__deleted } = _b, others = __objRest(_b, ["defaultValue__deleted"]);
      return __spreadProps(__spreadValues({}, others), { defaultValue: { type: "deleted", value: it.defaultValue__deleted } });
    }
    return it;
  }).map((it) => {
    if ("notNull" in it) {
      return __spreadProps(__spreadValues({}, it), { notNull: { type: "changed", old: it.notNull.__old, new: it.notNull.__new } });
    }
    if ("notNull__added" in it) {
      const _a2 = it, { notNull__added } = _a2, others = __objRest(_a2, ["notNull__added"]);
      return __spreadProps(__spreadValues({}, others), { notNull: { type: "added", value: it.notNull__added } });
    }
    if ("notNull__deleted" in it) {
      const _b = it, { notNull__deleted } = _b, others = __objRest(_b, ["notNull__deleted"]);
      return __spreadProps(__spreadValues({}, others), { notNull: { type: "deleted", value: it.notNull__deleted } });
    }
    return it;
  });
  return { name: table.name, deleted, added, altered: mappedAltered, addedIndexes, deletedIndexes };
};

// src/jsonStatements.ts
var prepareCreateTableJson = (table) => {
  const { name, columns } = table;
  return {
    type: "create_table",
    tableName: name,
    columns
  };
};
var prepareDropTableJson = (table) => {
  return {
    type: "drop_table",
    tableName: table.name
  };
};
var prepareRenameTableJson = (tableFrom, tableTo) => {
  return {
    type: "rename_table",
    tableNameFrom: tableFrom.name,
    tableNameTo: tableTo.name
  };
};
var prepareCreateEnumJson = (name, values) => {
  return {
    type: "create_type_enum",
    name,
    values
  };
};
var prepareAddValuesToEnumJson = (name, values) => {
  return values.map((it) => {
    return {
      type: "alter_type_add_value",
      name,
      value: it
    };
  });
};
var prepareAlterTableColumnsJson = (tableName, deleted, added, altered) => {
  const statements = [];
  const dropColumns = _prepareDropColumns(tableName, deleted);
  const addColumns = _prepareAddColumns(tableName, added);
  const alterColumns = _prepareAlterColumns(tableName, altered);
  statements.push(...dropColumns);
  statements.push(...addColumns);
  statements.push(...alterColumns);
  return statements;
};
var _prepareDropColumns = (taleName, columns) => {
  return columns.map((it) => {
    return {
      type: "alter_table_drop_column",
      tableName: taleName,
      columnName: it.name
    };
  });
};
var _prepareAddColumns = (tableName, columns) => {
  return columns.map((it) => {
    return {
      type: "alter_table_add_column",
      tableName,
      column: it
    };
  });
};
var _prepareAlterColumns = (tableName, columns) => {
  var _a2, _b, _c, _d, _e, _f, _g;
  let statements = [];
  for (const column of columns) {
    const columnName = typeof column.name !== "string" ? column.name.new : column.name;
    if (typeof column.name !== "string") {
      statements.push({
        type: "alter_table_rename_column",
        tableName,
        oldColumnName: column.name.old,
        newColumnName: column.name.new
      });
      column.name.old;
    }
    if (((_a2 = column.type) == null ? void 0 : _a2.type) === "changed") {
      statements.push({
        type: "alter_table_alter_column_set_type",
        tableName,
        columnName,
        newDataType: column.type.new
      });
    }
    if (((_b = column.defaultValue) == null ? void 0 : _b.type) === "added") {
      statements.push({
        type: "alter_table_alter_column_set_default",
        tableName,
        columnName,
        newDefaultValue: column.defaultValue.value
      });
    }
    if (((_c = column.defaultValue) == null ? void 0 : _c.type) === "changed") {
      statements.push({
        type: "alter_table_alter_column_set_default",
        tableName,
        columnName,
        newDefaultValue: column.defaultValue.new
      });
    }
    if (((_d = column.defaultValue) == null ? void 0 : _d.type) === "deleted") {
      statements.push({
        type: "alter_table_alter_column_drop_default",
        tableName,
        columnName
      });
    }
    if (((_e = column.notNull) == null ? void 0 : _e.type) === "added") {
      statements.push({
        type: "alter_table_alter_column_set_notnull",
        tableName,
        columnName
      });
    }
    if (((_f = column.notNull) == null ? void 0 : _f.type) === "changed") {
      const type3 = column.notNull.new ? "alter_table_alter_column_set_notnull" : "alter_table_alter_column_drop_notnull";
      statements.push({
        type: type3,
        tableName,
        columnName
      });
    }
    if (((_g = column.notNull) == null ? void 0 : _g.type) === "deleted") {
      statements.push({
        type: "alter_table_alter_column_drop_notnull",
        tableName,
        columnName
      });
    }
  }
  return statements;
};
var prepareCreateIndexesJson = (tableName, indexes) => {
  return indexes.map((index) => {
    return {
      type: "create_index",
      tableName,
      indexName: index.name,
      value: index.columns.join(", ")
    };
  });
};
var prepareCreateReferencesJson = (tableName, columns) => {
  return columns.filter((it) => {
    return it.references !== void 0;
  }).map((entry) => {
    const column = entry;
    const references = column.references;
    return {
      type: "create_reference",
      fromTable: tableName,
      toTable: references.table,
      fromColumn: column.name,
      toColumn: references.column,
      foreignKeyName: references.foreignKeyName,
      onDelete: references.onDelete,
      onUpdate: references.onUpdate
    };
  });
};
var prepareDropIndexesJson = (tableName, indexes) => {
  return indexes.map((index) => {
    return {
      type: "drop_index",
      tableName,
      indexName: index.name
    };
  });
};

// src/snapshotsDiffer.ts
var applySnapshotsDiff = async (json1, json2, tablesResolver, columnsResolver) => {
  const diffResult = applyJsonDiff(json1, json2);
  const typedResult = diffResult;
  const { created, deleted, renamed: renamed2 } = await tablesResolver({ created: typedResult.addedTables, deleted: typedResult.deletedTables });
  const jsonStatements = [];
  const jsonCreateTables = created.map((it) => {
    return prepareCreateTableJson(it);
  });
  const jsonCreateIndexesForCreatedTables = created.map((it) => {
    return prepareCreateIndexesJson(it.name, it.indexes);
  }).flat();
  const jsonDropTables = deleted.map((it) => {
    return prepareDropTableJson(it);
  });
  const jsonRenameTables = renamed2.map((it) => {
    return prepareRenameTableJson(it.from, it.to);
  });
  const renamedWithAlternations = diffForRenamed(renamed2);
  const allAltered = typedResult.alteredTablesWithColumns.concat(renamedWithAlternations);
  const allAlteredResolved = [];
  for (const table of allAltered) {
    const result2 = await columnsResolver({ tableName: table.name, created: table.added, deleted: table.deleted });
    const _a2 = table, { deleted: deleted2, added } = _a2, ini = __objRest(_a2, ["deleted", "added"]);
    const resolved = __spreadValues(__spreadValues({}, ini), result2);
    allAlteredResolved.push(resolved);
  }
  const jsonAlterTables = allAlteredResolved.map((it) => {
    return prepareAlterTableColumnsJson(it.name, it.deleted, it.created, it.altered);
  }).flat();
  const jsonCreateIndexesForAllAlteredTables = allAltered.map((it) => {
    return prepareCreateIndexesJson(it.name, it.addedIndexes || {});
  }).flat();
  const jsonDropIndexesForAllAlteredTables = allAltered.map((it) => {
    return prepareDropIndexesJson(it.name, it.deletedIndexes || {});
  }).flat();
  const jsonCreateReferencesForCreatedTables = created.map((it) => {
    return prepareCreateReferencesJson(it.name, Object.values(it.columns));
  }).flat();
  const jsonCreateReferencesForAllAlteredTables = allAltered.map((it) => {
    return prepareCreateReferencesJson(it.name, it.added);
  }).flat();
  const jsonCreateReferences = jsonCreateReferencesForCreatedTables.concat(jsonCreateReferencesForAllAlteredTables);
  const createEnums = diffResult.addedEnums.map((it) => {
    return prepareCreateEnumJson(it.name, it.values);
  });
  const jsonAlterEnumsWithAddedValues = diffResult.alteredEnums.map((it) => {
    return prepareAddValuesToEnumJson(it.name, it.addedValues);
  }).flat();
  jsonStatements.push(...createEnums);
  jsonStatements.push(...jsonAlterEnumsWithAddedValues);
  jsonStatements.push(...jsonCreateTables);
  jsonStatements.push(...jsonDropTables);
  jsonStatements.push(...jsonRenameTables);
  jsonStatements.push(...jsonAlterTables);
  jsonStatements.push(...jsonCreateReferences);
  jsonStatements.push(...jsonCreateIndexesForCreatedTables);
  jsonStatements.push(...jsonCreateIndexesForAllAlteredTables);
  jsonStatements.push(...jsonDropIndexesForAllAlteredTables);
  const sqlStatements = fromJson(jsonStatements);
  return sqlStatements.join("\n");
};

// src/cli/commands/migrate.tsx
var migrate = async () => {
  const drizzleConfig = js_yaml_default.load(import_fs4.default.readFileSync("drizzle.config.yml", { encoding: "utf-8" }));
  const migrationRootFolder = drizzleConfig.migrationRootFolder || "drizzle";
  const dataFolder = drizzleConfig.dataFolder;
  const { prev, cur } = await task("preparing data schema json snapshot", async ({ setTitle }) => {
    return migrationPreparator_default(migrationRootFolder, dataFolder);
  });
  const tablesResolver = async (input) => {
    const { created, deleted, renamed: renamed2 } = await promptTablesConflicts({
      newTables: input.created,
      missingTables: input.deleted
    });
    const renamedMapped = renamed2.map((it) => {
      return { from: it.old, to: it.new };
    });
    return { created, deleted, renamed: renamedMapped };
  };
  const columnsResolver = async (input) => {
    const result2 = await promptColumnsConflicts({ name: input.tableName, added: input.created, deleted: input.deleted });
    const renamedMapped = result2.renamed.map((it) => {
      return { from: it.old, to: it.new };
    });
    return { tableName: input.tableName, created: result2.created, deleted: input.deleted, renamed: renamedMapped };
  };
  const sql = await task("preparing schemas diff", async () => {
    return applySnapshotsDiff(prev, cur, tablesResolver, columnsResolver);
  });
  const date = new Date();
  const folderName = date.toISOString();
  const migrationFolderPath = `./${migrationRootFolder}/${folderName}`;
  import_fs4.default.mkdirSync(migrationFolderPath);
  import_fs4.default.writeFileSync(`${migrationFolderPath}/snapshot.json`, JSON.stringify(cur, null, 2));
  import_fs4.default.writeFileSync(`${migrationFolderPath}/migration.sql`, sql);
};
var migrate_default = migrate;

// node_modules/source-map-support/register.js
require_source_map_support().install();

// node_modules/pretty-error/start.js
require_PrettyError().start();

// src/cli/commands/prepare-snapshot.ts
function prepareSnapshot(path2) {
  const result2 = serializer_default(path2);
  return result2;
}

// src/cli/index.tsx
var migrationCommand = new import_commander.Command("migrate").alias("mg").description("Migration").action(migrate_default);
var prepareSnapshotCommand = new import_commander.Command("prepare").argument("<path>").action((path2) => {
  console.log(JSON.stringify(prepareSnapshot(path2), null, 2));
});
import_commander.program.addCommand(migrationCommand);
import_commander.program.addCommand(prepareSnapshotCommand);
import_commander.program.parse();
/*
object-assign
(c) Sindre Sorhus
@license MIT
*/
/*! *****************************************************************************
Copyright (c) Microsoft Corporation.

Permission to use, copy, modify, and/or distribute this software for any
purpose with or without fee is hereby granted.

THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
PERFORMANCE OF THIS SOFTWARE.
***************************************************************************** */
/*! *****************************************************************************
Copyright (c) Microsoft Corporation. All rights reserved.
Licensed under the Apache License, Version 2.0 (the "License"); you may not use
this file except in compliance with the License. You may obtain a copy of the
License at http://www.apache.org/licenses/LICENSE-2.0

THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
MERCHANTABLITY OR NON-INFRINGEMENT.

See the Apache Version 2.0 License for specific language governing permissions
and limitations under the License.
***************************************************************************** */
/*! js-yaml 4.1.0 https://github.com/nodeca/js-yaml @license MIT */
/*! promise-polyfill 2.0.1 */
/**
 * @license
 * Lodash <https://lodash.com/>
 * Copyright OpenJS Foundation and other contributors <https://openjsf.org/>
 * Released under MIT license <https://lodash.com/license>
 * Based on Underscore.js 1.8.3 <http://underscorejs.org/LICENSE>
 * Copyright Jeremy Ashkenas, DocumentCloud and Investigative Reporters & Editors
 */
/** @license React v0.18.0
 * scheduler-tracing.development.js
 *
 * Copyright (c) Facebook, Inc. and its affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */
/** @license React v0.18.0
 * scheduler-tracing.production.min.js
 *
 * Copyright (c) Facebook, Inc. and its affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */
/** @license React v0.18.0
 * scheduler.development.js
 *
 * Copyright (c) Facebook, Inc. and its affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */
/** @license React v0.18.0
 * scheduler.production.min.js
 *
 * Copyright (c) Facebook, Inc. and its affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */
/** @license React v0.24.0
 * react-reconciler.development.js
 *
 * Copyright (c) Facebook, Inc. and its affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */
/** @license React v0.24.0
 * react-reconciler.production.min.js
 *
 * Copyright (c) Facebook, Inc. and its affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */
/** @license React v16.14.0
 * react.development.js
 *
 * Copyright (c) Facebook, Inc. and its affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */
/** @license React v16.14.0
 * react.production.min.js
 *
 * Copyright (c) Facebook, Inc. and its affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */
/** @license React vundefined
 * react-debug-tools.production.min.js
 *
 * Copyright (c) Facebook, Inc. and its affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */
/** @license React vundefined
 * react-is.production.min.js
 *
 * Copyright (c) Facebook, Inc. and its affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */
/** @license React vundefined
 * react.production.min.js
 *
 * Copyright (c) Facebook, Inc. and its affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */
/** @license React vundefined
 * use-subscription.development.js
 *
 * Copyright (c) Facebook, Inc. and its affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */
/** @license React vundefined
 * use-subscription.production.min.js
 *
 * Copyright (c) Facebook, Inc. and its affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */
